/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the RISCV target                           *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 99;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(4),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s32,
  GILLT_p0s64,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_nxv1s1,
  GILLT_nxv1s8,
  GILLT_nxv1s16,
  GILLT_nxv1s32,
  GILLT_nxv1s64,
  GILLT_nxv2s1,
  GILLT_nxv2s8,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s8,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv4s64,
  GILLT_nxv8s1,
  GILLT_nxv8s8,
  GILLT_nxv8s16,
  GILLT_nxv8s32,
  GILLT_nxv8s64,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
  GILLT_nxv16s16,
  GILLT_nxv16s32,
  GILLT_nxv32s1,
  GILLT_nxv32s8,
  GILLT_nxv32s16,
  GILLT_nxv64s1,
  GILLT_nxv64s8,
};
const static size_t NumTypeObjects = 34;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 32),
  LLT::pointer(0, 64),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(1), 8),
  LLT::vector(ElementCount::getScalable(1), 16),
  LLT::vector(ElementCount::getScalable(1), 32),
  LLT::vector(ElementCount::getScalable(1), 64),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 8),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 8),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(4), 64),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 8),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(8), 32),
  LLT::vector(ElementCount::getScalable(8), 64),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
  LLT::vector(ElementCount::getScalable(16), 16),
  LLT::vector(ElementCount::getScalable(16), 32),
  LLT::vector(ElementCount::getScalable(32), 1),
  LLT::vector(ElementCount::getScalable(32), 8),
  LLT::vector(ElementCount::getScalable(32), 16),
  LLT::vector(ElementCount::getScalable(64), 1),
  LLT::vector(ElementCount::getScalable(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasStdExtZicbopBit = 34,
  Feature_HasStdExtZicondBit = 35,
  Feature_HasStdExtZihintpauseBit = 22,
  Feature_HasStdExtZimopBit = 33,
  Feature_HasStdExtZicfilpBit = 2,
  Feature_NoStdExtZicfilpBit = 1,
  Feature_HasStdExtZilsdBit = 36,
  Feature_HasStdExtZmmulBit = 23,
  Feature_HasStdExtMBit = 24,
  Feature_HasStdExtABit = 26,
  Feature_HasStdExtZtsoBit = 28,
  Feature_NotHasStdExtZtsoBit = 27,
  Feature_HasStdExtZabhaBit = 31,
  Feature_HasStdExtZacasBit = 30,
  Feature_NoStdExtZacasBit = 29,
  Feature_HasStdExtZalasrBit = 32,
  Feature_HasStdExtFBit = 5,
  Feature_HasStdExtDBit = 7,
  Feature_HasStdExtZfhminBit = 12,
  Feature_HasStdExtZfhBit = 10,
  Feature_HasStdExtZfaBit = 37,
  Feature_NoStdExtZfaBit = 8,
  Feature_HasStdExtZfinxBit = 6,
  Feature_HasStdExtZdinxBit = 9,
  Feature_HasStdExtZhinxminBit = 13,
  Feature_HasStdExtZhinxBit = 11,
  Feature_HasStdExtCBit = 18,
  Feature_HasStdExtCOrZcaBit = 20,
  Feature_HasStdExtZbaBit = 43,
  Feature_NotHasStdExtZbaBit = 21,
  Feature_HasStdExtZbbBit = 40,
  Feature_NoStdExtZbbBit = 42,
  Feature_HasStdExtZbcBit = 45,
  Feature_HasStdExtZbsBit = 39,
  Feature_HasStdExtZbkbBit = 41,
  Feature_NoStdExtZbkbBit = 96,
  Feature_HasStdExtZbkxBit = 46,
  Feature_HasStdExtZbbOrZbkbBit = 38,
  Feature_HasStdExtZbcOrZbkcBit = 44,
  Feature_HasStdExtZkndBit = 47,
  Feature_HasStdExtZkneBit = 49,
  Feature_HasStdExtZkndOrZkneBit = 48,
  Feature_HasStdExtZknhBit = 50,
  Feature_HasStdExtZksedBit = 51,
  Feature_HasStdExtZkshBit = 52,
  Feature_HasStdExtZvkbBit = 60,
  Feature_HasStdExtZvbbBit = 59,
  Feature_HasStdExtZvbcBit = 64,
  Feature_HasStdExtZvkgBit = 61,
  Feature_HasStdExtZvknedBit = 62,
  Feature_HasStdExtZvknhaBit = 65,
  Feature_HasStdExtZvknhbBit = 66,
  Feature_HasStdExtZvksedBit = 67,
  Feature_HasStdExtZvkshBit = 63,
  Feature_HasVInstructionsBit = 14,
  Feature_HasVInstructionsI64Bit = 55,
  Feature_HasVInstructionsAnyFBit = 54,
  Feature_HasVInstructionsF16MinimalBit = 57,
  Feature_HasVInstructionsF16Bit = 53,
  Feature_HasVInstructionsF64Bit = 58,
  Feature_HasVInstructionsFullMultiplyBit = 56,
  Feature_HasVendorXVentanaCondOpsBit = 68,
  Feature_HasVendorXTHeadBaBit = 69,
  Feature_HasVendorXTHeadBbBit = 70,
  Feature_HasVendorXTHeadBsBit = 71,
  Feature_HasVendorXTHeadCondMovBit = 72,
  Feature_HasVendorXTHeadFMemIdxBit = 77,
  Feature_HasVendorXTHeadMacBit = 73,
  Feature_HasVendorXTHeadMemIdxBit = 76,
  Feature_HasVendorXTHeadMemPairBit = 75,
  Feature_HasVendorXTHeadVdotBit = 74,
  Feature_HasVendorXSfvcpBit = 78,
  Feature_HasVendorXSfvqmaccdodBit = 79,
  Feature_HasVendorXSfvqmaccqoqBit = 80,
  Feature_HasVendorXSfvfnrclipxfqfBit = 81,
  Feature_HasVendorXCVbitmanipBit = 83,
  Feature_HasVendorXCVmacBit = 86,
  Feature_HasVendorXCVmemBit = 82,
  Feature_HasVendorXCValuBit = 84,
  Feature_HasVendorXCVbiBit = 85,
  Feature_UseCCMovInsnBit = 94,
  Feature_HasVendorXqciaBit = 90,
  Feature_HasVendorXqcibiBit = 91,
  Feature_HasVendorXqcibmBit = 92,
  Feature_HasVendorXqciintBit = 93,
  Feature_HasVendorXqciliaBit = 87,
  Feature_HasVendorXqciloBit = 88,
  Feature_HasVendorXqcislsBit = 89,
  Feature_HasVendorXAndesPerfBit = 95,
  Feature_IsRV64Bit = 4,
  Feature_IsRV32Bit = 3,
  Feature_HasShortForwardBranchOptBit = 15,
  Feature_NoShortForwardBranchOptBit = 17,
  Feature_HasConditionalMoveFusionBit = 16,
  Feature_NoConditionalMoveFusionBit = 0,
  Feature_HasAtomicLdStBit = 25,
  Feature_OptForMinSizeBit = 19,
  Feature_HwMode1Bit = 98,
  Feature_HwMode0Bit = 97,
};

PredicateBitset RISCVInstructionSelector::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasStdExtZicbop())
    Features.set(Feature_HasStdExtZicbopBit);
  if (Subtarget->hasStdExtZicond())
    Features.set(Feature_HasStdExtZicondBit);
  if (Subtarget->hasStdExtZihintpause())
    Features.set(Feature_HasStdExtZihintpauseBit);
  if (Subtarget->hasStdExtZimop())
    Features.set(Feature_HasStdExtZimopBit);
  if (Subtarget->hasStdExtZicfilp())
    Features.set(Feature_HasStdExtZicfilpBit);
  if (!Subtarget->hasStdExtZicfilp())
    Features.set(Feature_NoStdExtZicfilpBit);
  if (Subtarget->hasStdExtZilsd())
    Features.set(Feature_HasStdExtZilsdBit);
  if (Subtarget->hasStdExtZmmul())
    Features.set(Feature_HasStdExtZmmulBit);
  if (Subtarget->hasStdExtM())
    Features.set(Feature_HasStdExtMBit);
  if (Subtarget->hasStdExtA())
    Features.set(Feature_HasStdExtABit);
  if (Subtarget->hasStdExtZtso())
    Features.set(Feature_HasStdExtZtsoBit);
  if (!Subtarget->hasStdExtZtso())
    Features.set(Feature_NotHasStdExtZtsoBit);
  if (Subtarget->hasStdExtZabha())
    Features.set(Feature_HasStdExtZabhaBit);
  if (Subtarget->hasStdExtZacas())
    Features.set(Feature_HasStdExtZacasBit);
  if (!Subtarget->hasStdExtZacas())
    Features.set(Feature_NoStdExtZacasBit);
  if (Subtarget->hasStdExtZalasr())
    Features.set(Feature_HasStdExtZalasrBit);
  if (Subtarget->hasStdExtF())
    Features.set(Feature_HasStdExtFBit);
  if (Subtarget->hasStdExtD())
    Features.set(Feature_HasStdExtDBit);
  if (Subtarget->hasStdExtZfhmin())
    Features.set(Feature_HasStdExtZfhminBit);
  if (Subtarget->hasStdExtZfh())
    Features.set(Feature_HasStdExtZfhBit);
  if (Subtarget->hasStdExtZfa())
    Features.set(Feature_HasStdExtZfaBit);
  if (!Subtarget->hasStdExtZfa())
    Features.set(Feature_NoStdExtZfaBit);
  if (Subtarget->hasStdExtZfinx())
    Features.set(Feature_HasStdExtZfinxBit);
  if (Subtarget->hasStdExtZdinx())
    Features.set(Feature_HasStdExtZdinxBit);
  if (Subtarget->hasStdExtZhinxmin())
    Features.set(Feature_HasStdExtZhinxminBit);
  if (Subtarget->hasStdExtZhinx())
    Features.set(Feature_HasStdExtZhinxBit);
  if (Subtarget->hasStdExtC())
    Features.set(Feature_HasStdExtCBit);
  if (Subtarget->hasStdExtCOrZca())
    Features.set(Feature_HasStdExtCOrZcaBit);
  if (Subtarget->hasStdExtZba())
    Features.set(Feature_HasStdExtZbaBit);
  if (!Subtarget->hasStdExtZba())
    Features.set(Feature_NotHasStdExtZbaBit);
  if (Subtarget->hasStdExtZbb())
    Features.set(Feature_HasStdExtZbbBit);
  if (!Subtarget->hasStdExtZbb())
    Features.set(Feature_NoStdExtZbbBit);
  if (Subtarget->hasStdExtZbc())
    Features.set(Feature_HasStdExtZbcBit);
  if (Subtarget->hasStdExtZbs())
    Features.set(Feature_HasStdExtZbsBit);
  if (Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbkbBit);
  if (!Subtarget->hasStdExtZbkb())
    Features.set(Feature_NoStdExtZbkbBit);
  if (Subtarget->hasStdExtZbkx())
    Features.set(Feature_HasStdExtZbkxBit);
  if (Subtarget->hasStdExtZbb() || Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbbOrZbkbBit);
  if (Subtarget->hasStdExtZbc() || Subtarget->hasStdExtZbkc())
    Features.set(Feature_HasStdExtZbcOrZbkcBit);
  if (Subtarget->hasStdExtZknd())
    Features.set(Feature_HasStdExtZkndBit);
  if (Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkneBit);
  if (Subtarget->hasStdExtZknd() || Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkndOrZkneBit);
  if (Subtarget->hasStdExtZknh())
    Features.set(Feature_HasStdExtZknhBit);
  if (Subtarget->hasStdExtZksed())
    Features.set(Feature_HasStdExtZksedBit);
  if (Subtarget->hasStdExtZksh())
    Features.set(Feature_HasStdExtZkshBit);
  if (Subtarget->hasStdExtZvkb())
    Features.set(Feature_HasStdExtZvkbBit);
  if (Subtarget->hasStdExtZvbb())
    Features.set(Feature_HasStdExtZvbbBit);
  if (Subtarget->hasStdExtZvbc())
    Features.set(Feature_HasStdExtZvbcBit);
  if (Subtarget->hasStdExtZvkg())
    Features.set(Feature_HasStdExtZvkgBit);
  if (Subtarget->hasStdExtZvkned())
    Features.set(Feature_HasStdExtZvknedBit);
  if (Subtarget->hasStdExtZvknha())
    Features.set(Feature_HasStdExtZvknhaBit);
  if (Subtarget->hasStdExtZvknhb())
    Features.set(Feature_HasStdExtZvknhbBit);
  if (Subtarget->hasStdExtZvksed())
    Features.set(Feature_HasStdExtZvksedBit);
  if (Subtarget->hasStdExtZvksh())
    Features.set(Feature_HasStdExtZvkshBit);
  if (Subtarget->hasVInstructions())
    Features.set(Feature_HasVInstructionsBit);
  if (Subtarget->hasVInstructionsI64())
    Features.set(Feature_HasVInstructionsI64Bit);
  if (Subtarget->hasVInstructionsAnyF())
    Features.set(Feature_HasVInstructionsAnyFBit);
  if (Subtarget->hasVInstructionsF16Minimal())
    Features.set(Feature_HasVInstructionsF16MinimalBit);
  if (Subtarget->hasVInstructionsF16())
    Features.set(Feature_HasVInstructionsF16Bit);
  if (Subtarget->hasVInstructionsF64())
    Features.set(Feature_HasVInstructionsF64Bit);
  if (Subtarget->hasVInstructionsFullMultiply())
    Features.set(Feature_HasVInstructionsFullMultiplyBit);
  if (Subtarget->hasVendorXVentanaCondOps())
    Features.set(Feature_HasVendorXVentanaCondOpsBit);
  if (Subtarget->hasVendorXTHeadBa())
    Features.set(Feature_HasVendorXTHeadBaBit);
  if (Subtarget->hasVendorXTHeadBb())
    Features.set(Feature_HasVendorXTHeadBbBit);
  if (Subtarget->hasVendorXTHeadBs())
    Features.set(Feature_HasVendorXTHeadBsBit);
  if (Subtarget->hasVendorXTHeadCondMov())
    Features.set(Feature_HasVendorXTHeadCondMovBit);
  if (Subtarget->hasVendorXTHeadFMemIdx())
    Features.set(Feature_HasVendorXTHeadFMemIdxBit);
  if (Subtarget->hasVendorXTHeadMac())
    Features.set(Feature_HasVendorXTHeadMacBit);
  if (Subtarget->hasVendorXTHeadMemIdx())
    Features.set(Feature_HasVendorXTHeadMemIdxBit);
  if (Subtarget->hasVendorXTHeadMemPair())
    Features.set(Feature_HasVendorXTHeadMemPairBit);
  if (Subtarget->hasVendorXTHeadVdot())
    Features.set(Feature_HasVendorXTHeadVdotBit);
  if (Subtarget->hasVendorXSfvcp())
    Features.set(Feature_HasVendorXSfvcpBit);
  if (Subtarget->hasVendorXSfvqmaccdod())
    Features.set(Feature_HasVendorXSfvqmaccdodBit);
  if (Subtarget->hasVendorXSfvqmaccqoq())
    Features.set(Feature_HasVendorXSfvqmaccqoqBit);
  if (Subtarget->hasVendorXSfvfnrclipxfqf())
    Features.set(Feature_HasVendorXSfvfnrclipxfqfBit);
  if (Subtarget->hasVendorXCVbitmanip())
    Features.set(Feature_HasVendorXCVbitmanipBit);
  if (Subtarget->hasVendorXCVmac())
    Features.set(Feature_HasVendorXCVmacBit);
  if (Subtarget->hasVendorXCVmem())
    Features.set(Feature_HasVendorXCVmemBit);
  if (Subtarget->hasVendorXCValu())
    Features.set(Feature_HasVendorXCValuBit);
  if (Subtarget->hasVendorXCVbi())
    Features.set(Feature_HasVendorXCVbiBit);
  if (Subtarget->useCCMovInsn())
    Features.set(Feature_UseCCMovInsnBit);
  if (Subtarget->hasVendorXqcia())
    Features.set(Feature_HasVendorXqciaBit);
  if (Subtarget->hasVendorXqcibi())
    Features.set(Feature_HasVendorXqcibiBit);
  if (Subtarget->hasVendorXqcibm())
    Features.set(Feature_HasVendorXqcibmBit);
  if (Subtarget->hasVendorXqciint())
    Features.set(Feature_HasVendorXqciintBit);
  if (Subtarget->hasVendorXqcilia())
    Features.set(Feature_HasVendorXqciliaBit);
  if (Subtarget->hasVendorXqcilo())
    Features.set(Feature_HasVendorXqciloBit);
  if (Subtarget->hasVendorXqcisls())
    Features.set(Feature_HasVendorXqcislsBit);
  if (Subtarget->hasVendorXAndesPerf())
    Features.set(Feature_HasVendorXAndesPerfBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_IsRV64Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_IsRV32Bit);
  if (Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_HasShortForwardBranchOptBit);
  if (!Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_NoShortForwardBranchOptBit);
  if (Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_HasConditionalMoveFusionBit);
  if (!Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_NoConditionalMoveFusionBit);
  if (Subtarget->hasStdExtA() || Subtarget->hasForcedAtomics())
    Features.set(Feature_HasAtomicLdStBit);
  if (MF ? MF->getFunction().hasMinSize() : false)
    Features.set(Feature_OptForMinSizeBit);
  if (!((Subtarget->is64Bit())))
    Features.set(Feature_HwMode1Bit);
  if ((Subtarget->is64Bit()))
    Features.set(Feature_HwMode0Bit);
  return Features;
}

void RISCVInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVInstructionSelector::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HwMode0,
  GIFBS_HwMode1,
  GIFBS_HasAtomicLdSt_HwMode0,
  GIFBS_HasAtomicLdSt_HwMode1,
  GIFBS_HasShortForwardBranchOpt_HwMode0,
  GIFBS_HasShortForwardBranchOpt_HwMode1,
  GIFBS_HasStdExtA_HwMode0,
  GIFBS_HasStdExtA_HwMode1,
  GIFBS_HasStdExtD,
  GIFBS_HasStdExtD_HwMode0,
  GIFBS_HasStdExtD_HwMode1,
  GIFBS_HasStdExtF,
  GIFBS_HasStdExtF_HwMode0,
  GIFBS_HasStdExtF_HwMode1,
  GIFBS_HasStdExtM_HwMode0,
  GIFBS_HasStdExtM_HwMode1,
  GIFBS_HasStdExtZalasr_HwMode0,
  GIFBS_HasStdExtZalasr_HwMode1,
  GIFBS_HasStdExtZba_HwMode0,
  GIFBS_HasStdExtZba_HwMode1,
  GIFBS_HasStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_HwMode1,
  GIFBS_HasStdExtZbkb_HwMode0,
  GIFBS_HasStdExtZbkb_HwMode1,
  GIFBS_HasStdExtZbkx_HwMode0,
  GIFBS_HasStdExtZbkx_HwMode1,
  GIFBS_HasStdExtZbs_HwMode0,
  GIFBS_HasStdExtZbs_HwMode1,
  GIFBS_HasStdExtZfa,
  GIFBS_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtZfh,
  GIFBS_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtZfinx,
  GIFBS_HasStdExtZfinx_HwMode0,
  GIFBS_HasStdExtZfinx_HwMode1,
  GIFBS_HasStdExtZhinx,
  GIFBS_HasStdExtZhinx_HwMode0,
  GIFBS_HasStdExtZhinx_HwMode1,
  GIFBS_HasStdExtZhinxmin_HwMode0,
  GIFBS_HasStdExtZhinxmin_HwMode1,
  GIFBS_HasStdExtZihintpause_HwMode0,
  GIFBS_HasStdExtZihintpause_HwMode1,
  GIFBS_HasStdExtZmmul_HwMode0,
  GIFBS_HasStdExtZmmul_HwMode1,
  GIFBS_HasStdExtZvbb_HwMode0,
  GIFBS_HasStdExtZvbb_HwMode1,
  GIFBS_HasStdExtZvbc_HwMode0,
  GIFBS_HasStdExtZvbc_HwMode1,
  GIFBS_HasStdExtZvkb_HwMode0,
  GIFBS_HasStdExtZvkb_HwMode1,
  GIFBS_HasStdExtZvkg_HwMode0,
  GIFBS_HasStdExtZvkg_HwMode1,
  GIFBS_HasStdExtZvkned_HwMode0,
  GIFBS_HasStdExtZvkned_HwMode1,
  GIFBS_HasStdExtZvknha_HwMode0,
  GIFBS_HasStdExtZvknha_HwMode1,
  GIFBS_HasStdExtZvknhb_HwMode0,
  GIFBS_HasStdExtZvknhb_HwMode1,
  GIFBS_HasStdExtZvksed_HwMode0,
  GIFBS_HasStdExtZvksed_HwMode1,
  GIFBS_HasStdExtZvksh_HwMode0,
  GIFBS_HasStdExtZvksh_HwMode1,
  GIFBS_HasVInstructions_HwMode0,
  GIFBS_HasVInstructions_HwMode1,
  GIFBS_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsFullMultiply_HwMode0,
  GIFBS_HasVInstructionsFullMultiply_HwMode1,
  GIFBS_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXAndesPerf_HwMode0,
  GIFBS_HasVendorXAndesPerf_HwMode1,
  GIFBS_HasVendorXCVmac_HwMode0,
  GIFBS_HasVendorXCVmac_HwMode1,
  GIFBS_HasVendorXSfvcp_HwMode0,
  GIFBS_HasVendorXSfvcp_HwMode1,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1,
  GIFBS_HasVendorXSfvqmaccdod_HwMode0,
  GIFBS_HasVendorXSfvqmaccdod_HwMode1,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode0,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode1,
  GIFBS_HasVendorXTHeadBa_HwMode0,
  GIFBS_HasVendorXTHeadBa_HwMode1,
  GIFBS_HasVendorXTHeadBb_HwMode0,
  GIFBS_HasVendorXTHeadBb_HwMode1,
  GIFBS_HasVendorXTHeadBs_HwMode0,
  GIFBS_HasVendorXTHeadBs_HwMode1,
  GIFBS_HasVendorXTHeadCondMov_HwMode0,
  GIFBS_HasVendorXTHeadCondMov_HwMode1,
  GIFBS_HasVendorXTHeadMac_HwMode0,
  GIFBS_HasVendorXTHeadMac_HwMode1,
  GIFBS_HasVendorXTHeadVdot_HwMode0,
  GIFBS_HasVendorXTHeadVdot_HwMode1,
  GIFBS_IsRV32_HwMode0,
  GIFBS_IsRV32_HwMode1,
  GIFBS_IsRV64_HwMode0,
  GIFBS_IsRV64_HwMode1,
  GIFBS_UseCCMovInsn_HwMode0,
  GIFBS_UseCCMovInsn_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_IsRV64_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode1,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfa,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtD_IsRV32_HwMode0,
  GIFBS_HasStdExtD_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV64_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode1,
  GIFBS_HasStdExtF_IsRV64_HwMode0,
  GIFBS_HasStdExtM_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode1,
  GIFBS_HasStdExtZba_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV64_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfh_IsRV32_HwMode0,
  GIFBS_HasStdExtZfh_IsRV32_HwMode1,
  GIFBS_HasStdExtZfh_IsRV64_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZfinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZhinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZknd_IsRV32_HwMode1,
  GIFBS_HasStdExtZknd_IsRV64_HwMode0,
  GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZkne_IsRV32_HwMode1,
  GIFBS_HasStdExtZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZknh_IsRV32_HwMode1,
  GIFBS_HasStdExtZknh_IsRV64_HwMode0,
  GIFBS_HasStdExtZmmul_IsRV64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode1,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1,
  GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0,
  GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode1,
  GIFBS_HasVendorXqcibm_IsRV32_HwMode0,
  GIFBS_HasVendorXqcibm_IsRV32_HwMode1,
  GIFBS_HasVendorXqcilia_IsRV32_HwMode1,
  GIFBS_HasVendorXqcisls_IsRV32_HwMode0,
  GIFBS_HasVendorXqcisls_IsRV32_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1,
  GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HwMode0Bit, },
  {Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode1Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode0Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, },
  {Feature_HasStdExtDBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, },
  {Feature_HasStdExtFBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZihintpauseBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZihintpauseBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode0Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndOrZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqciliaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcislsBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcislsBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZilsdBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZilsdBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_GIAddrRegImm,
  GICP_GIShiftMask32,
  GICP_GIShiftMaskXLen,
  GICP_GIVLOp,
  GICP_gi_sexti32,
  GICP_gi_sh1add_op,
  GICP_gi_sh1add_uw_op,
  GICP_gi_sh2add_op,
  GICP_gi_sh2add_uw_op,
  GICP_gi_sh3add_op,
  GICP_gi_sh3add_uw_op,
  GICP_gi_zexti16,
  GICP_gi_zexti32,
  GICP_gi_zexti8,
};
// See constructor for table contents

RISCVInstructionSelector::ComplexMatcherMemFn
RISCVInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &RISCVInstructionSelector::selectAddrRegImm, // GIAddrRegImm
  &RISCVInstructionSelector::selectShiftMask32, // GIShiftMask32
  &RISCVInstructionSelector::selectShiftMaskXLen, // GIShiftMaskXLen
  &RISCVInstructionSelector::renderVLOp, // GIVLOp
  &RISCVInstructionSelector::selectSExtBits<32>, // gi_sexti32
  &RISCVInstructionSelector::selectSHXADDOp<1>, // gi_sh1add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<1>, // gi_sh1add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<2>, // gi_sh2add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<2>, // gi_sh2add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<3>, // gi_sh3add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<3>, // gi_sh3add_uw_op
  &RISCVInstructionSelector::selectZExtBits<16>, // gi_zexti16
  &RISCVInstructionSelector::selectZExtBits<32>, // gi_zexti32
  &RISCVInstructionSelector::selectZExtBits<8>, // gi_zexti8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_like_non_imm12 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_add_non_imm12,
  GICXXPred_MI_Predicate_anonymous_9913,
  GICXXPred_MI_Predicate_anonymous_9915,
  GICXXPred_MI_Predicate_anonymous_10003,
  GICXXPred_MI_Predicate_anonymous_10017,
  GICXXPred_MI_Predicate_anonymous_10021,
  GICXXPred_MI_Predicate_anonymous_10023,
  GICXXPred_MI_Predicate_anonymous_10025,
  GICXXPred_MI_Predicate_anonymous_10027,
  GICXXPred_MI_Predicate_anonymous_10030,
  GICXXPred_MI_Predicate_anonymous_10032,
  GICXXPred_MI_Predicate_anonymous_10045,
  GICXXPred_MI_Predicate_anonymous_10058,
  GICXXPred_MI_Predicate_anonymous_11254,
};
bool RISCVInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_like_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_like_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_add_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_9913: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9915: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10003: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10017: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10021: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10023: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10025: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10027: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10030: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10032: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10045: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10058: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_11254: {
     return hasAllHUsers(MI); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AddiPair = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BCLRMask,
  GICXXPred_I64_Predicate_LeadingOnesMask,
  GICXXPred_I64_Predicate_LeadingOnesWMask,
  GICXXPred_I64_Predicate_SingleBitSetMask,
  GICXXPred_I64_Predicate_allonessew8,
  GICXXPred_I64_Predicate_allonessew16,
  GICXXPred_I64_Predicate_allonessew32,
  GICXXPred_I64_Predicate_allonessew64,
  GICXXPred_I64_Predicate_bare_simm9_lsb0,
  GICXXPred_I64_Predicate_bare_simm12_lsb0,
  GICXXPred_I64_Predicate_bare_simm13_lsb0,
  GICXXPred_I64_Predicate_byteselect,
  GICXXPred_I64_Predicate_c_lui_imm,
  GICXXPred_I64_Predicate_csr_sysreg,
  GICXXPred_I64_Predicate_cv_tuimm2,
  GICXXPred_I64_Predicate_cv_tuimm5,
  GICXXPred_I64_Predicate_cv_uimm10,
  GICXXPred_I64_Predicate_immzero,
  GICXXPred_I64_Predicate_payload1,
  GICXXPred_I64_Predicate_payload2,
  GICXXPred_I64_Predicate_payload5,
  GICXXPred_I64_Predicate_powerOf2Minus1,
  GICXXPred_I64_Predicate_rnum,
  GICXXPred_I64_Predicate_simm5,
  GICXXPred_I64_Predicate_simm5_plus1,
  GICXXPred_I64_Predicate_simm5_plus1_nonzero,
  GICXXPred_I64_Predicate_simm5nonzero,
  GICXXPred_I64_Predicate_simm6,
  GICXXPred_I64_Predicate_simm6nonzero,
  GICXXPred_I64_Predicate_simm10_lsb0000nonzero,
  GICXXPred_I64_Predicate_simm11,
  GICXXPred_I64_Predicate_simm12,
  GICXXPred_I64_Predicate_simm12Minus1Nonzero,
  GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1,
  GICXXPred_I64_Predicate_simm12Plus1,
  GICXXPred_I64_Predicate_simm12Plus1i32,
  GICXXPred_I64_Predicate_simm12_lsb00000,
  GICXXPred_I64_Predicate_simm12_no6,
  GICXXPred_I64_Predicate_simm12_plus1,
  GICXXPred_I64_Predicate_simm16nonzero,
  GICXXPred_I64_Predicate_simm20_li,
  GICXXPred_I64_Predicate_simm21_lsb0_jal,
  GICXXPred_I64_Predicate_simm26,
  GICXXPred_I64_Predicate_simm26_nosimm12,
  GICXXPred_I64_Predicate_simm32_nosimm26,
  GICXXPred_I64_Predicate_tsimm5,
  GICXXPred_I64_Predicate_tuimm5,
  GICXXPred_I64_Predicate_u32simm12,
  GICXXPred_I64_Predicate_uimm1,
  GICXXPred_I64_Predicate_uimm2,
  GICXXPred_I64_Predicate_uimm2_3,
  GICXXPred_I64_Predicate_uimm2_4,
  GICXXPred_I64_Predicate_uimm2_lsb0,
  GICXXPred_I64_Predicate_uimm3,
  GICXXPred_I64_Predicate_uimm4,
  GICXXPred_I64_Predicate_uimm5,
  GICXXPred_I64_Predicate_uimm5_lsb0,
  GICXXPred_I64_Predicate_uimm5_plus1,
  GICXXPred_I64_Predicate_uimm5ge6_plus1,
  GICXXPred_I64_Predicate_uimm5gt3,
  GICXXPred_I64_Predicate_uimm5i32,
  GICXXPred_I64_Predicate_uimm5nonzero,
  GICXXPred_I64_Predicate_uimm5slist,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_lsb0,
  GICXXPred_I64_Predicate_uimm6gt32,
  GICXXPred_I64_Predicate_uimm7_lsb00,
  GICXXPred_I64_Predicate_uimm7_lsb000,
  GICXXPred_I64_Predicate_uimm8_lsb00,
  GICXXPred_I64_Predicate_uimm8_lsb000,
  GICXXPred_I64_Predicate_uimm9_lsb000,
  GICXXPred_I64_Predicate_uimm10,
  GICXXPred_I64_Predicate_uimm10_lsb00nonzero,
  GICXXPred_I64_Predicate_uimm11,
  GICXXPred_I64_Predicate_uimm14lsb00,
  GICXXPred_I64_Predicate_uimm16nonzero,
  GICXXPred_I64_Predicate_uimmlog2xlen,
  GICXXPred_I64_Predicate_uimmlog2xlennonzero,
};
bool RISCVInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AddiPair: {
    
      // The immediate operand must be in range [-4096,-2049] or [2048,4094].
      return (-4096 <= Imm && Imm <= -2049) || (2048 <= Imm && Imm <= 4094);
    
    llvm_unreachable("AddiPair should have returned");
  }
  case GICXXPred_I64_Predicate_BCLRMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(~Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(~Imm);
    
    llvm_unreachable("BCLRMask should have returned");
  }
  case GICXXPred_I64_Predicate_LeadingOnesMask: {
    
      return !isInt<32>(Imm) && isMask_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_LeadingOnesWMask: {
    
      // If the value is a uint32 but not an int32, it must have bit 31 set and
      // bits 63:32 cleared. After that we're looking for a shifted mask but not
      // an all ones mask.
      return !isInt<32>(Imm) && isUInt<32>(Imm) && isShiftedMask_64(Imm) &&
             Imm != UINT64_C(0xffffffff);
    
    llvm_unreachable("LeadingOnesWMask should have returned");
  }
  case GICXXPred_I64_Predicate_SingleBitSetMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(Imm);
    
    llvm_unreachable("SingleBitSetMask should have returned");
  }
  case GICXXPred_I64_Predicate_allonessew8: {
    return SignExtend64<8>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew16: {
    return SignExtend64<16>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew32: {
    return SignExtend64<32>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew64: {
    return Imm == -1LL;
  }
  case GICXXPred_I64_Predicate_bare_simm9_lsb0: {
    return isShiftedInt<8, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_bare_simm12_lsb0: {
    return isShiftedInt<11, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_bare_simm13_lsb0: {
    return isShiftedInt<12, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_byteselect: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_c_lui_imm: {
    return (Imm != 0) &&
                                     (isUInt<5>(Imm) ||
                                      (Imm >= 0xfffe0 && Imm <= 0xfffff));
  }
  case GICXXPred_I64_Predicate_csr_sysreg: {
    return isUInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immzero: {
    return (Imm == 0);
  }
  case GICXXPred_I64_Predicate_payload1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_payload2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_payload5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_powerOf2Minus1: {
     return isPowerOf2_32(Imm+1); 
  }
  case GICXXPred_I64_Predicate_rnum: {
    return (Imm >= 0 && Imm <= 10);
  }
  case GICXXPred_I64_Predicate_simm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm5_plus1: {
    return (isInt<5>(Imm) && Imm != -16) || Imm == 16;
  }
  case GICXXPred_I64_Predicate_simm5_plus1_nonzero: {
    return Imm != 0 && ((isInt<5>(Imm) && Imm != -16) || Imm == 16);
  }
  case GICXXPred_I64_Predicate_simm5nonzero: {
    return (Imm != 0) && isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6nonzero: {
    return (Imm != 0) && isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm10_lsb0000nonzero: {
    return (Imm != 0) && isShiftedInt<6, 4>(Imm);
  }
  case GICXXPred_I64_Predicate_simm11: {
    return isInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12: {
    return isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12Minus1Nonzero: {
    
      return (Imm >= -2049 && Imm < 0) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1: {
    
      return (Imm >= -2049 && Imm < -1) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Plus1: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12Plus1i32: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12_lsb00000: {
    return isShiftedInt<7, 5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12_no6: {
    
      return isInt<12>(Imm) && !isInt<6>(Imm) && isInt<12>(-Imm);
  }
  case GICXXPred_I64_Predicate_simm12_plus1: {
    return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm16nonzero: {
    return (Imm != 0) && isInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_simm20_li: {
    return isInt<20>(Imm);
  }
  case GICXXPred_I64_Predicate_simm21_lsb0_jal: {
    return isShiftedInt<20, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26: {
    return isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26_nosimm12: {
    
      return isInt<26>(Imm) && !isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm32_nosimm26: {
    
      return isInt<32>(Imm) && !isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_tsimm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_u32simm12: {
    
      return isUInt<32>(Imm) && isInt<12>(SignExtend64<32>(Imm));
    
  }
  case GICXXPred_I64_Predicate_uimm1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2_3: {
    
      return isShiftedUInt<2, 3>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_4: {
    
      return isShiftedUInt<2, 4>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_lsb0: {
    return isShiftedUInt<1, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_lsb0: {
    return isShiftedUInt<4, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_plus1: {
    return (isUInt<5>(Imm) && (Imm != 0)) || (Imm == 32);
  }
  case GICXXPred_I64_Predicate_uimm5ge6_plus1: {
    return (Imm >= 6) && (isUInt<5>(Imm) || (Imm == 32));
  }
  case GICXXPred_I64_Predicate_uimm5gt3: {
    return (Imm > 3) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5i32: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5nonzero: {
    return (Imm != 0) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5slist: {
    return ((Imm == 0)  ||
                (Imm == 1)  ||
                (Imm == 2)  ||
                (Imm == 4)  ||
                (Imm == 8)  ||
                (Imm == 16) ||
                (Imm == 15) ||
                (Imm == 31));
  }
  case GICXXPred_I64_Predicate_uimm6: {
    return isUInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6_lsb0: {
    return isShiftedUInt<5, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6gt32: {
    
      return isUInt<6>(Imm) && Imm > 32;
    
  }
  case GICXXPred_I64_Predicate_uimm7_lsb00: {
    return isShiftedUInt<5, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm7_lsb000: {
    return isShiftedUInt<4, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb00: {
    return isShiftedUInt<6, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb000: {
    return isShiftedUInt<5, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm9_lsb000: {
    return isShiftedUInt<6, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10_lsb00nonzero: {
    return isShiftedUInt<8, 2>(Imm) && (Imm != 0);
  }
  case GICXXPred_I64_Predicate_uimm11: {
    return isUInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm14lsb00: {
    return isShiftedUInt<12, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm16nonzero: {
    return (Imm != 0) && isUInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_uimmlog2xlen: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm);
      return isUInt<5>(Imm);
    
    llvm_unreachable("uimmlog2xlen should have returned");
  }
  case GICXXPred_I64_Predicate_uimmlog2xlennonzero: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm) && (Imm != 0);
      return isUInt<5>(Imm) && (Imm != 0);
    
    llvm_unreachable("uimmlog2xlennonzero should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_Shifted32OnesMask = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_TrailingOnesMask,
};
bool RISCVInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_Shifted32OnesMask: {
    
      if (!Imm.isShiftedMask())
        return false;
    
      unsigned TrailingZeros = Imm.countr_zero();
      return TrailingZeros > 0 && TrailingZeros < 32 &&
             Imm == UINT64_C(0xFFFFFFFF) << TrailingZeros;
    
    llvm_unreachable("Shifted32OnesMask should have returned");
  }
  case GICXXPred_APInt_Predicate_TrailingOnesMask: {
    
      return !isInt<12>(Imm.getSExtValue()) && isMask_64(Imm.getZExtValue());
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("RISCVInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderAddiPairImmLarge,
  GICR_renderAddiPairImmSmall,
  GICR_renderFrameIndex,
  GICR_renderImmPlus1,
  GICR_renderImmSubFrom32,
  GICR_renderImmSubFromXLen,
  GICR_renderNegImm,
  GICR_renderTrailingZeros,
  GICR_renderXLenSubTrailingOnes,
};
RISCVInstructionSelector::CustomRendererFn
RISCVInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &RISCVInstructionSelector::renderAddiPairImmLarge,
  &RISCVInstructionSelector::renderAddiPairImmSmall,
  &RISCVInstructionSelector::renderFrameIndex,
  &RISCVInstructionSelector::renderImmPlus1,
  &RISCVInstructionSelector::renderImmSubFrom32,
  &RISCVInstructionSelector::renderImmSubFromXLen,
  &RISCVInstructionSelector::renderNegImm,
  &RISCVInstructionSelector::renderTrailingZeros,
  &RISCVInstructionSelector::renderXLenSubTrailingOnes,
};

bool RISCVInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool RISCVInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("RISCVInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*       0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(333), /*)*//*default:*//*Label 125*/ GIMT_Encode4(2453243),
     /*      10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1130),
     /*      14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(61071),
     /*      18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(80304),
     /*      22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(107358),
     /*      26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(110092),
     /*      30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(112826),
     /*      34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(115605), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(118339),
     /*      50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(127821),
     /*      54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(140442), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      74 */ /*TargetOpcode::G_FRAME_INDEX*//*Label 10*/ GIMT_Encode4(155349), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      94 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 11*/ GIMT_Encode4(155410), GIMT_Encode4(0),
     /*     102 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 12*/ GIMT_Encode4(155471), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     126 */ /*TargetOpcode::G_BITCAST*//*Label 13*/ GIMT_Encode4(155562), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 14*/ GIMT_Encode4(155929),
     /*     146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 15*/ GIMT_Encode4(156127),
     /*     150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 16*/ GIMT_Encode4(156325),
     /*     154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 17*/ GIMT_Encode4(156905),
     /*     158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 18*/ GIMT_Encode4(157115),
     /*     162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 19*/ GIMT_Encode4(157313),
     /*     166 */ /*TargetOpcode::G_READSTEADYCOUNTER*//*Label 20*/ GIMT_Encode4(157352),
     /*     170 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(157391),
     /*     174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(167673),
     /*     178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(169643), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     194 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(171133), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 25*/ GIMT_Encode4(179337),
     /*     210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 26*/ GIMT_Encode4(184223),
     /*     214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 27*/ GIMT_Encode4(187133), GIMT_Encode4(0),
     /*     222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 28*/ GIMT_Encode4(190043),
     /*     226 */ /*TargetOpcode::G_ATOMICRMW_NAND*//*Label 29*/ GIMT_Encode4(192953),
     /*     230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 30*/ GIMT_Encode4(193865),
     /*     234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 31*/ GIMT_Encode4(196775),
     /*     238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 32*/ GIMT_Encode4(199685),
     /*     242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 33*/ GIMT_Encode4(202595),
     /*     246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 34*/ GIMT_Encode4(205505),
     /*     250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 35*/ GIMT_Encode4(208415), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(211325), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(211543),
     /*     318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(2209836), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(2211404), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     354 */ /*TargetOpcode::G_SEXT*//*Label 40*/ GIMT_Encode4(2214525),
     /*     358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 41*/ GIMT_Encode4(2218000),
     /*     362 */ /*TargetOpcode::G_ZEXT*//*Label 42*/ GIMT_Encode4(2219043),
     /*     366 */ /*TargetOpcode::G_SHL*//*Label 43*/ GIMT_Encode4(2222730),
     /*     370 */ /*TargetOpcode::G_LSHR*//*Label 44*/ GIMT_Encode4(2231326),
     /*     374 */ /*TargetOpcode::G_ASHR*//*Label 45*/ GIMT_Encode4(2234357), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     386 */ /*TargetOpcode::G_ROTR*//*Label 46*/ GIMT_Encode4(2237296),
     /*     390 */ /*TargetOpcode::G_ROTL*//*Label 47*/ GIMT_Encode4(2240236),
     /*     394 */ /*TargetOpcode::G_ICMP*//*Label 48*/ GIMT_Encode4(2243146),
     /*     398 */ /*TargetOpcode::G_FCMP*//*Label 49*/ GIMT_Encode4(2269809), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     410 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(2277271), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     454 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(2281663),
     /*     458 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(2284397),
     /*     462 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(2287131),
     /*     466 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(2289984),
     /*     470 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(2292837),
     /*     474 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(2295690),
     /*     478 */ /*TargetOpcode::G_USHLSAT*//*Label 57*/ GIMT_Encode4(2298543),
     /*     482 */ /*TargetOpcode::G_SSHLSAT*//*Label 58*/ GIMT_Encode4(2298601), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     518 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(2298659),
     /*     522 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(2301087),
     /*     526 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(2303515),
     /*     530 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(2305943), GIMT_Encode4(0),
     /*     538 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(2322588), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     586 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(2325016),
     /*     590 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(2326987),
     /*     594 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(2327440),
     /*     598 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(2328976),
     /*     602 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(2333862),
     /*     606 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(2338748),
     /*     610 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(2344034), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     622 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(2349320),
     /*     626 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 72*/ GIMT_Encode4(2351291), GIMT_Encode4(0),
     /*     634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 73*/ GIMT_Encode4(2357353),
     /*     638 */ /*TargetOpcode::G_FMINNUM*//*Label 74*/ GIMT_Encode4(2357543),
     /*     642 */ /*TargetOpcode::G_FMAXNUM*//*Label 75*/ GIMT_Encode4(2359628), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     654 */ /*TargetOpcode::G_FMINIMUM*//*Label 76*/ GIMT_Encode4(2361713),
     /*     658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 77*/ GIMT_Encode4(2361839),
     /*     662 */ /*TargetOpcode::G_FMINIMUMNUM*//*Label 78*/ GIMT_Encode4(2361965),
     /*     666 */ /*TargetOpcode::G_FMAXIMUMNUM*//*Label 79*/ GIMT_Encode4(2364050), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     702 */ /*TargetOpcode::G_SMIN*//*Label 80*/ GIMT_Encode4(2366135),
     /*     706 */ /*TargetOpcode::G_SMAX*//*Label 81*/ GIMT_Encode4(2368911),
     /*     710 */ /*TargetOpcode::G_UMIN*//*Label 82*/ GIMT_Encode4(2371687),
     /*     714 */ /*TargetOpcode::G_UMAX*//*Label 83*/ GIMT_Encode4(2374463),
     /*     718 */ /*TargetOpcode::G_ABS*//*Label 84*/ GIMT_Encode4(2377239),
     /*     722 */ /*TargetOpcode::G_LROUND*//*Label 85*/ GIMT_Encode4(2377397),
     /*     726 */ /*TargetOpcode::G_LLROUND*//*Label 86*/ GIMT_Encode4(2377977),
     /*     730 */ /*TargetOpcode::G_BR*//*Label 87*/ GIMT_Encode4(2378187), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     774 */ /*TargetOpcode::G_CTTZ*//*Label 88*/ GIMT_Encode4(2378203), GIMT_Encode4(0),
     /*     782 */ /*TargetOpcode::G_CTLZ*//*Label 89*/ GIMT_Encode4(2380723), GIMT_Encode4(0),
     /*     790 */ /*TargetOpcode::G_CTPOP*//*Label 90*/ GIMT_Encode4(2383381),
     /*     794 */ /*TargetOpcode::G_BSWAP*//*Label 91*/ GIMT_Encode4(2385932),
     /*     798 */ /*TargetOpcode::G_BITREVERSE*//*Label 92*/ GIMT_Encode4(2388467),
     /*     802 */ /*TargetOpcode::G_FCEIL*//*Label 93*/ GIMT_Encode4(2390961), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     850 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(2391159),
     /*     854 */ /*TargetOpcode::G_FFLOOR*//*Label 95*/ GIMT_Encode4(2393335),
     /*     858 */ /*TargetOpcode::G_FRINT*//*Label 96*/ GIMT_Encode4(2393533),
     /*     862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 97*/ GIMT_Encode4(2393731), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 98*/ GIMT_Encode4(2393929),
     /*     894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 99*/ GIMT_Encode4(2396357),
     /*     898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 100*/ GIMT_Encode4(2398785),
     /*     902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 101*/ GIMT_Encode4(2401213), GIMT_Encode4(0),
     /*     910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 102*/ GIMT_Encode4(2403641),
     /*     914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 103*/ GIMT_Encode4(2420286), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     950 */ /*TargetOpcode::G_TRAP*//*Label 104*/ GIMT_Encode4(2422462),
     /*     954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 105*/ GIMT_Encode4(2422475), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    1050 */ /*RISCV::G_CLZW*//*Label 106*/ GIMT_Encode4(2422488),
     /*    1054 */ /*RISCV::G_CTZW*//*Label 107*/ GIMT_Encode4(2422583),
     /*    1058 */ /*RISCV::G_DIVUW*//*Label 108*/ GIMT_Encode4(2422613),
     /*    1062 */ /*RISCV::G_DIVW*//*Label 109*/ GIMT_Encode4(2422650),
     /*    1066 */ /*RISCV::G_FCLASS*//*Label 110*/ GIMT_Encode4(2422687),
     /*    1070 */ /*RISCV::G_FCVT_WU_RV64*//*Label 111*/ GIMT_Encode4(2423047),
     /*    1074 */ /*RISCV::G_FCVT_W_RV64*//*Label 112*/ GIMT_Encode4(2423245),
     /*    1078 */ /*RISCV::G_READ_VLENB*//*Label 113*/ GIMT_Encode4(2423443),
     /*    1082 */ /*RISCV::G_REMUW*//*Label 114*/ GIMT_Encode4(2423503),
     /*    1086 */ /*RISCV::G_ROLW*//*Label 115*/ GIMT_Encode4(2423540),
     /*    1090 */ /*RISCV::G_RORW*//*Label 116*/ GIMT_Encode4(2423665),
     /*    1094 */ /*RISCV::G_SLLW*//*Label 117*/ GIMT_Encode4(2423786), GIMT_Encode4(0),
     /*    1102 */ /*RISCV::G_SRAW*//*Label 118*/ GIMT_Encode4(2423833),
     /*    1106 */ /*RISCV::G_SRLW*//*Label 119*/ GIMT_Encode4(2423880),
     /*    1110 */ /*RISCV::G_VMCLR_VL*//*Label 120*/ GIMT_Encode4(2423927),
     /*    1114 */ /*RISCV::G_VMSET_VL*//*Label 121*/ GIMT_Encode4(2424576),
     /*    1118 */ /*RISCV::G_VMV_V_V_VL*//*Label 122*/ GIMT_Encode4(2425225),
     /*    1122 */ /*RISCV::G_VSLIDEDOWN_VL*//*Label 123*/ GIMT_Encode4(2429483),
     /*    1126 */ /*RISCV::G_VSLIDEUP_VL*//*Label 124*/ GIMT_Encode4(2441363),
     /*    1130 */ // Label 0: @1130
     /*    1130 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 150*/ GIMT_Encode4(61070),
     /*    1141 */ /*GILLT_s32*//*Label 126*/ GIMT_Encode4(1265),
     /*    1145 */ /*GILLT_s64*//*Label 127*/ GIMT_Encode4(3530), GIMT_Encode4(0),
     /*    1153 */ /*GILLT_nxv1s8*//*Label 128*/ GIMT_Encode4(11430),
     /*    1157 */ /*GILLT_nxv1s16*//*Label 129*/ GIMT_Encode4(11825),
     /*    1161 */ /*GILLT_nxv1s32*//*Label 130*/ GIMT_Encode4(14950),
     /*    1165 */ /*GILLT_nxv1s64*//*Label 131*/ GIMT_Encode4(18075), GIMT_Encode4(0),
     /*    1173 */ /*GILLT_nxv2s8*//*Label 132*/ GIMT_Encode4(21200),
     /*    1177 */ /*GILLT_nxv2s16*//*Label 133*/ GIMT_Encode4(21595),
     /*    1181 */ /*GILLT_nxv2s32*//*Label 134*/ GIMT_Encode4(24720),
     /*    1185 */ /*GILLT_nxv2s64*//*Label 135*/ GIMT_Encode4(27845), GIMT_Encode4(0),
     /*    1193 */ /*GILLT_nxv4s8*//*Label 136*/ GIMT_Encode4(30970),
     /*    1197 */ /*GILLT_nxv4s16*//*Label 137*/ GIMT_Encode4(31365),
     /*    1201 */ /*GILLT_nxv4s32*//*Label 138*/ GIMT_Encode4(34490),
     /*    1205 */ /*GILLT_nxv4s64*//*Label 139*/ GIMT_Encode4(37615), GIMT_Encode4(0),
     /*    1213 */ /*GILLT_nxv8s8*//*Label 140*/ GIMT_Encode4(40740),
     /*    1217 */ /*GILLT_nxv8s16*//*Label 141*/ GIMT_Encode4(41135),
     /*    1221 */ /*GILLT_nxv8s32*//*Label 142*/ GIMT_Encode4(44260),
     /*    1225 */ /*GILLT_nxv8s64*//*Label 143*/ GIMT_Encode4(47385), GIMT_Encode4(0),
     /*    1233 */ /*GILLT_nxv16s8*//*Label 144*/ GIMT_Encode4(50510),
     /*    1237 */ /*GILLT_nxv16s16*//*Label 145*/ GIMT_Encode4(50905),
     /*    1241 */ /*GILLT_nxv16s32*//*Label 146*/ GIMT_Encode4(54030), GIMT_Encode4(0),
     /*    1249 */ /*GILLT_nxv32s8*//*Label 147*/ GIMT_Encode4(57155),
     /*    1253 */ /*GILLT_nxv32s16*//*Label 148*/ GIMT_Encode4(57550), GIMT_Encode4(0),
     /*    1261 */ /*GILLT_nxv64s8*//*Label 149*/ GIMT_Encode4(60675),
     /*    1265 */ // Label 126: @1265
     /*    1265 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(3529),
     /*    1270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*    1273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*    1276 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(1324), // Rule ID 2560 //
     /*    1281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1288 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    1292 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    1296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1300 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1311 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:2:x, GPR:{ *:[i32] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1316 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1322 */     GIR_RootConstrainSelectedInstOperands,
     /*    1323 */     // GIR_Coverage, 2560,
     /*    1323 */     GIR_EraseRootFromParent_Done,
     /*    1324 */   // Label 152: @1324
     /*    1324 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(1372), // Rule ID 2570 //
     /*    1329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1336 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    1340 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    1344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1359 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:4:x, GPR:{ *:[i32] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1370 */     GIR_RootConstrainSelectedInstOperands,
     /*    1371 */     // GIR_Coverage, 2570,
     /*    1371 */     GIR_EraseRootFromParent_Done,
     /*    1372 */   // Label 153: @1372
     /*    1372 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(1420), // Rule ID 2580 //
     /*    1377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1384 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    1388 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    1392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1407 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:6:x, GPR:{ *:[i32] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1418 */     GIR_RootConstrainSelectedInstOperands,
     /*    1419 */     // GIR_Coverage, 2580,
     /*    1419 */     GIR_EraseRootFromParent_Done,
     /*    1420 */   // Label 154: @1420
     /*    1420 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(1471), // Rule ID 62526 //
     /*    1425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1432 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    1436 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    1440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1455 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs2:$pred:24:x, GPR:{ *:[i32] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1469 */     GIR_RootConstrainSelectedInstOperands,
     /*    1470 */     // GIR_Coverage, 62526,
     /*    1470 */     GIR_EraseRootFromParent_Done,
     /*    1471 */   // Label 155: @1471
     /*    1471 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(1522), // Rule ID 62530 //
     /*    1476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1483 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    1487 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    1491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1506 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs2:$pred:25:x, GPR:{ *:[i32] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1520 */     GIR_RootConstrainSelectedInstOperands,
     /*    1521 */     // GIR_Coverage, 62530,
     /*    1521 */     GIR_EraseRootFromParent_Done,
     /*    1522 */   // Label 156: @1522
     /*    1522 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(1573), // Rule ID 62534 //
     /*    1527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1534 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    1538 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    1542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1557 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs2:$pred:26:x, GPR:{ *:[i32] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    1557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1564 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    1571 */     GIR_RootConstrainSelectedInstOperands,
     /*    1572 */     // GIR_Coverage, 62534,
     /*    1572 */     GIR_EraseRootFromParent_Done,
     /*    1573 */   // Label 157: @1573
     /*    1573 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(1621), // Rule ID 64994 //
     /*    1578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1585 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:28:x
     /*    1589 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:28:y
     /*    1593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1608 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:28:x, GPR:{ *:[i32] }:$rs2:$pred:28:y)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    1611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1619 */     GIR_RootConstrainSelectedInstOperands,
     /*    1620 */     // GIR_Coverage, 64994,
     /*    1620 */     GIR_EraseRootFromParent_Done,
     /*    1621 */   // Label 158: @1621
     /*    1621 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(1669), // Rule ID 65004 //
     /*    1626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1633 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:30:x
     /*    1637 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:30:y
     /*    1641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1656 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:30:x, GPR:{ *:[i32] }:$rs2:$pred:30:y)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    1659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1667 */     GIR_RootConstrainSelectedInstOperands,
     /*    1668 */     // GIR_Coverage, 65004,
     /*    1668 */     GIR_EraseRootFromParent_Done,
     /*    1669 */   // Label 159: @1669
     /*    1669 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(1717), // Rule ID 65014 //
     /*    1674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1681 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:32:x
     /*    1685 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:32:y
     /*    1689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1693 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1704 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:32:x, GPR:{ *:[i32] }:$rs2:$pred:32:y)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    1707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1715 */     GIR_RootConstrainSelectedInstOperands,
     /*    1716 */     // GIR_Coverage, 65014,
     /*    1716 */     GIR_EraseRootFromParent_Done,
     /*    1717 */   // Label 160: @1717
     /*    1717 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(1765), // Rule ID 65473 //
     /*    1722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1729 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    1733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1737 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    1741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1752 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:2:y, sh1add_op:{ *:[i32] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1763 */     GIR_RootConstrainSelectedInstOperands,
     /*    1764 */     // GIR_Coverage, 65473,
     /*    1764 */     GIR_EraseRootFromParent_Done,
     /*    1765 */   // Label 161: @1765
     /*    1765 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(1813), // Rule ID 65481 //
     /*    1770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1777 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    1781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1785 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    1789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1800 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:4:y, sh2add_op:{ *:[i32] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1805 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1811 */     GIR_RootConstrainSelectedInstOperands,
     /*    1812 */     // GIR_Coverage, 65481,
     /*    1812 */     GIR_EraseRootFromParent_Done,
     /*    1813 */   // Label 162: @1813
     /*    1813 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(1861), // Rule ID 65489 //
     /*    1818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1825 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    1829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1833 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    1837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1848 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:6:y, sh3add_op:{ *:[i32] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1859 */     GIR_RootConstrainSelectedInstOperands,
     /*    1860 */     // GIR_Coverage, 65489,
     /*    1860 */     GIR_EraseRootFromParent_Done,
     /*    1861 */   // Label 163: @1861
     /*    1861 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(1912), // Rule ID 74307 //
     /*    1866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1873 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    1877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1881 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    1885 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1896 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:24:y, sh1add_op:{ *:[i32] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1910 */     GIR_RootConstrainSelectedInstOperands,
     /*    1911 */     // GIR_Coverage, 74307,
     /*    1911 */     GIR_EraseRootFromParent_Done,
     /*    1912 */   // Label 164: @1912
     /*    1912 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(1963), // Rule ID 74311 //
     /*    1917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1924 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    1928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1932 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    1936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1947 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:25:y, sh2add_op:{ *:[i32] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1961 */     GIR_RootConstrainSelectedInstOperands,
     /*    1962 */     // GIR_Coverage, 74311,
     /*    1962 */     GIR_EraseRootFromParent_Done,
     /*    1963 */   // Label 165: @1963
     /*    1963 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2014), // Rule ID 74315 //
     /*    1968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1975 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    1979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1983 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    1987 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1998 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:26:y, sh3add_op:{ *:[i32] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    1998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    2001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    2005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    2009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    2012 */     GIR_RootConstrainSelectedInstOperands,
     /*    2013 */     // GIR_Coverage, 74315,
     /*    2013 */     GIR_EraseRootFromParent_Done,
     /*    2014 */   // Label 166: @2014
     /*    2014 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2062), // Rule ID 74348 //
     /*    2019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2026 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:28:y
     /*    2030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2034 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:28:x
     /*    2038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    2049 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:28:y, sh1add_op:{ *:[i32] }:$rs1:$pred:28:x)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2054 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2060 */     GIR_RootConstrainSelectedInstOperands,
     /*    2061 */     // GIR_Coverage, 74348,
     /*    2061 */     GIR_EraseRootFromParent_Done,
     /*    2062 */   // Label 167: @2062
     /*    2062 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2110), // Rule ID 74356 //
     /*    2067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2074 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:30:y
     /*    2078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2082 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:30:x
     /*    2086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    2097 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:30:y, sh2add_op:{ *:[i32] }:$rs1:$pred:30:x)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2108 */     GIR_RootConstrainSelectedInstOperands,
     /*    2109 */     // GIR_Coverage, 74356,
     /*    2109 */     GIR_EraseRootFromParent_Done,
     /*    2110 */   // Label 168: @2110
     /*    2110 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2158), // Rule ID 74364 //
     /*    2115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2122 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:32:y
     /*    2126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2130 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:32:x
     /*    2134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    2145 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:32:y, sh3add_op:{ *:[i32] }:$rs1:$pred:32:x)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2150 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2156 */     GIR_RootConstrainSelectedInstOperands,
     /*    2157 */     // GIR_Coverage, 74364,
     /*    2157 */     GIR_EraseRootFromParent_Done,
     /*    2158 */   // Label 169: @2158
     /*    2158 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2226), // Rule ID 2554 //
     /*    2163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2170 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    2174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2195 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2199 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    2203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2207 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2213 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x, GPR:{ *:[i32] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2224 */     GIR_RootConstrainSelectedInstOperands,
     /*    2225 */     // GIR_Coverage, 2554,
     /*    2225 */     GIR_EraseRootFromParent_Done,
     /*    2226 */   // Label 170: @2226
     /*    2226 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2294), // Rule ID 2564 //
     /*    2231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2238 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    2242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2263 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2267 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    2271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2275 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2281 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x, GPR:{ *:[i32] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2292 */     GIR_RootConstrainSelectedInstOperands,
     /*    2293 */     // GIR_Coverage, 2564,
     /*    2293 */     GIR_EraseRootFromParent_Done,
     /*    2294 */   // Label 171: @2294
     /*    2294 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2362), // Rule ID 2574 //
     /*    2299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2306 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    2310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2331 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2335 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    2339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2343 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2349 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x, GPR:{ *:[i32] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2360 */     GIR_RootConstrainSelectedInstOperands,
     /*    2361 */     // GIR_Coverage, 2574,
     /*    2361 */     GIR_EraseRootFromParent_Done,
     /*    2362 */   // Label 172: @2362
     /*    2362 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2430), // Rule ID 64988 //
     /*    2367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2374 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:27:x
     /*    2378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2399 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2403 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:27:y
     /*    2407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2411 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2417 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:27:x, GPR:{ *:[i32] }:$rs2:$pred:27:y)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2428 */     GIR_RootConstrainSelectedInstOperands,
     /*    2429 */     // GIR_Coverage, 64988,
     /*    2429 */     GIR_EraseRootFromParent_Done,
     /*    2430 */   // Label 173: @2430
     /*    2430 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2498), // Rule ID 64998 //
     /*    2435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2442 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:29:x
     /*    2446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2467 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2471 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:29:y
     /*    2475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2485 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:29:x, GPR:{ *:[i32] }:$rs2:$pred:29:y)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2496 */     GIR_RootConstrainSelectedInstOperands,
     /*    2497 */     // GIR_Coverage, 64998,
     /*    2497 */     GIR_EraseRootFromParent_Done,
     /*    2498 */   // Label 174: @2498
     /*    2498 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2566), // Rule ID 65008 //
     /*    2503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2510 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:31:x
     /*    2514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2535 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2539 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:31:y
     /*    2543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2553 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:31:x, GPR:{ *:[i32] }:$rs2:$pred:31:y)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2564 */     GIR_RootConstrainSelectedInstOperands,
     /*    2565 */     // GIR_Coverage, 65008,
     /*    2565 */     GIR_EraseRootFromParent_Done,
     /*    2566 */   // Label 175: @2566
     /*    2566 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2634), // Rule ID 65469 //
     /*    2571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2578 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*    2582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2586 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*    2590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2611 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2621 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:1:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2632 */     GIR_RootConstrainSelectedInstOperands,
     /*    2633 */     // GIR_Coverage, 65469,
     /*    2633 */     GIR_EraseRootFromParent_Done,
     /*    2634 */   // Label 176: @2634
     /*    2634 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2702), // Rule ID 65477 //
     /*    2639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2646 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*    2650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2654 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*    2658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2679 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2689 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:3:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2700 */     GIR_RootConstrainSelectedInstOperands,
     /*    2701 */     // GIR_Coverage, 65477,
     /*    2701 */     GIR_EraseRootFromParent_Done,
     /*    2702 */   // Label 177: @2702
     /*    2702 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2770), // Rule ID 65485 //
     /*    2707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2714 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*    2718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2722 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*    2726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2747 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2757 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:5:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2768 */     GIR_RootConstrainSelectedInstOperands,
     /*    2769 */     // GIR_Coverage, 65485,
     /*    2769 */     GIR_EraseRootFromParent_Done,
     /*    2770 */   // Label 178: @2770
     /*    2770 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2838), // Rule ID 74344 //
     /*    2775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2782 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:27:y
     /*    2786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2790 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:27:x
     /*    2794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2815 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2825 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:27:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:27:x)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2836 */     GIR_RootConstrainSelectedInstOperands,
     /*    2837 */     // GIR_Coverage, 74344,
     /*    2837 */     GIR_EraseRootFromParent_Done,
     /*    2838 */   // Label 179: @2838
     /*    2838 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2906), // Rule ID 74352 //
     /*    2843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2850 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:29:y
     /*    2854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2858 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:29:x
     /*    2862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2883 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2893 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:29:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:29:x)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2904 */     GIR_RootConstrainSelectedInstOperands,
     /*    2905 */     // GIR_Coverage, 74352,
     /*    2905 */     GIR_EraseRootFromParent_Done,
     /*    2906 */   // Label 180: @2906
     /*    2906 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2974), // Rule ID 74360 //
     /*    2911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2918 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:31:y
     /*    2922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2926 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:31:x
     /*    2930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2951 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2961 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:31:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:31:x)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2972 */     GIR_RootConstrainSelectedInstOperands,
     /*    2973 */     // GIR_Coverage, 74360,
     /*    2973 */     GIR_EraseRootFromParent_Done,
     /*    2974 */   // Label 181: @2974
     /*    2974 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(3053), // Rule ID 62520 //
     /*    2979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    2982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2986 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*    2990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3019 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    3023 */     // MIs[2] Operand 1
     /*    3023 */     // No operand predicates
     /*    3023 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*    3027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3037 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i32] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    3037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    3040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    3044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    3048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    3051 */     GIR_RootConstrainSelectedInstOperands,
     /*    3052 */     // GIR_Coverage, 62520,
     /*    3052 */     GIR_EraseRootFromParent_Done,
     /*    3053 */   // Label 182: @3053
     /*    3053 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(3132), // Rule ID 74303 //
     /*    3058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    3061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3065 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*    3069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3073 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*    3077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3106 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    3110 */     // MIs[2] Operand 1
     /*    3110 */     // No operand predicates
     /*    3110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3116 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:23:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    3116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    3119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    3127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    3130 */     GIR_RootConstrainSelectedInstOperands,
     /*    3131 */     // GIR_Coverage, 74303,
     /*    3131 */     GIR_EraseRootFromParent_Done,
     /*    3132 */   // Label 183: @3132
     /*    3132 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(3181), // Rule ID 115 //
     /*    3137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*    3152 */     // MIs[1] Operand 1
     /*    3152 */     // No operand predicates
     /*    3152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    3156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3160 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3164 */     // MIs[2] Operand 1
     /*    3164 */     // No operand predicates
     /*    3164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3166 */     // (add:{ *:[i32] } (frameindex:{ *:[i32] }):$fi, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i32] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i32] }:$fi), (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)
     /*    3166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3171 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*    3176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*    3179 */     GIR_RootConstrainSelectedInstOperands,
     /*    3180 */     // GIR_Coverage, 115,
     /*    3180 */     GIR_EraseRootFromParent_Done,
     /*    3181 */   // Label 184: @3181
     /*    3181 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3223), // Rule ID 75 //
     /*    3186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3209 */     // MIs[1] Operand 1
     /*    3209 */     // No operand predicates
     /*    3209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3211 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*    3211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3221 */     GIR_RootConstrainSelectedInstOperands,
     /*    3222 */     // GIR_Coverage, 75,
     /*    3222 */     GIR_EraseRootFromParent_Done,
     /*    3223 */   // Label 185: @3223
     /*    3223 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3295), // Rule ID 286 //
     /*    3228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*    3251 */     // MIs[1] Operand 1
     /*    3251 */     // No operand predicates
     /*    3251 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10045),
     /*    3255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3257 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10045>>:$rs2)  =>  (ADDI:{ *:[i32] } (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (AddiPairImmLarge:{ *:[i32] } (imm:{ *:[i32] }):$rs2)), (AddiPairImmSmall:{ *:[i32] } (imm:{ *:[i32] }):$rs2))
     /*    3257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*    3260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    3269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*    3273 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*    3278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    3280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    3288 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*    3293 */     GIR_RootConstrainSelectedInstOperands,
     /*    3294 */     // GIR_Coverage, 286,
     /*    3294 */     GIR_EraseRootFromParent_Done,
     /*    3295 */   // Label 186: @3295
     /*    3295 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3337), // Rule ID 64518 //
     /*    3300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    3303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*    3323 */     // MIs[1] Operand 1
     /*    3323 */     // No operand predicates
     /*    3323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3325 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ADDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*    3325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDAI),
     /*    3328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3335 */     GIR_RootConstrainSelectedInstOperands,
     /*    3336 */     // GIR_Coverage, 64518,
     /*    3336 */     GIR_EraseRootFromParent_Done,
     /*    3337 */   // Label 187: @3337
     /*    3337 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(3379), // Rule ID 64522 //
     /*    3342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    3345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*    3365 */     // MIs[1] Operand 1
     /*    3365 */     // No operand predicates
     /*    3365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3367 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ADDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*    3367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDI),
     /*    3370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3377 */     GIR_RootConstrainSelectedInstOperands,
     /*    3378 */     // GIR_Coverage, 64522,
     /*    3378 */     GIR_EraseRootFromParent_Done,
     /*    3379 */   // Label 188: @3379
     /*    3379 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(3440), // Rule ID 74317 //
     /*    3384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    3387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3423 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rd)  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    3426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    3430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    3438 */     GIR_RootConstrainSelectedInstOperands,
     /*    3439 */     // GIR_Coverage, 74317,
     /*    3439 */     GIR_EraseRootFromParent_Done,
     /*    3440 */   // Label 189: @3440
     /*    3440 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(3501), // Rule ID 62587 //
     /*    3445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    3448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3484 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    3487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    3491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    3499 */     GIR_RootConstrainSelectedInstOperands,
     /*    3500 */     // GIR_Coverage, 62587,
     /*    3500 */     GIR_EraseRootFromParent_Done,
     /*    3501 */   // Label 190: @3501
     /*    3501 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(3528), // Rule ID 73 //
     /*    3506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3521 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*    3526 */     GIR_RootConstrainSelectedInstOperands,
     /*    3527 */     // GIR_Coverage, 73,
     /*    3527 */     GIR_Done,
     /*    3528 */   // Label 191: @3528
     /*    3528 */   GIM_Reject,
     /*    3529 */ // Label 151: @3529
     /*    3529 */ GIM_Reject,
     /*    3530 */ // Label 127: @3530
     /*    3530 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(11429),
     /*    3535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*    3538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*    3541 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3636), // Rule ID 2600 //
     /*    3546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3553 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*    3557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3594 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    3598 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    3609 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*    3613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3623 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:10:x, GPR:{ *:[i64] }:$rs2:$pred:10:y)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    3626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3634 */     GIR_RootConstrainSelectedInstOperands,
     /*    3635 */     // GIR_Coverage, 2600,
     /*    3635 */     GIR_EraseRootFromParent_Done,
     /*    3636 */   // Label 193: @3636
     /*    3636 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3731), // Rule ID 2604 //
     /*    3641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3648 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:12:x
     /*    3652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3689 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    3693 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    3704 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:12:y
     /*    3708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3712 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3718 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x, GPR:{ *:[i64] }:$rs2:$pred:12:y)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    3721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3729 */     GIR_RootConstrainSelectedInstOperands,
     /*    3730 */     // GIR_Coverage, 2604,
     /*    3730 */     GIR_EraseRootFromParent_Done,
     /*    3731 */   // Label 194: @3731
     /*    3731 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3826), // Rule ID 65044 //
     /*    3736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    3739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3743 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:40:x
     /*    3747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3784 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    3788 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    3799 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:40:y
     /*    3803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3807 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3813 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:40:x, GPR:{ *:[i64] }:$rs2:$pred:40:y)<<P:40:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    3816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3824 */     GIR_RootConstrainSelectedInstOperands,
     /*    3825 */     // GIR_Coverage, 65044,
     /*    3825 */     GIR_EraseRootFromParent_Done,
     /*    3826 */   // Label 195: @3826
     /*    3826 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3921), // Rule ID 65048 //
     /*    3831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    3834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3838 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:42:x
     /*    3842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3879 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    3883 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    3894 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:42:y
     /*    3898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3902 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3908 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:42:x, GPR:{ *:[i64] }:$rs2:$pred:42:y)<<P:42:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    3911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3919 */     GIR_RootConstrainSelectedInstOperands,
     /*    3920 */     // GIR_Coverage, 65048,
     /*    3920 */     GIR_EraseRootFromParent_Done,
     /*    3921 */   // Label 196: @3921
     /*    3921 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(4016), // Rule ID 2595 //
     /*    3926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3933 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*    3937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3974 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3985 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    3989 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*    3993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4003 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x, GPR:{ *:[i64] }:$rs2:$pred:8:y)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4014 */     GIR_RootConstrainSelectedInstOperands,
     /*    4015 */     // GIR_Coverage, 2595,
     /*    4015 */     GIR_EraseRootFromParent_Done,
     /*    4016 */   // Label 197: @4016
     /*    4016 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(4111), // Rule ID 2614 //
     /*    4021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4028 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*    4032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4069 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4080 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    4084 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*    4088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4092 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4098 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:16:x, GPR:{ *:[i64] }:$rs2:$pred:16:y)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4109 */     GIR_RootConstrainSelectedInstOperands,
     /*    4110 */     // GIR_Coverage, 2614,
     /*    4110 */     GIR_EraseRootFromParent_Done,
     /*    4111 */   // Label 198: @4111
     /*    4111 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(4206), // Rule ID 2619 //
     /*    4116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4123 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:18:x
     /*    4127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4164 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4175 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    4179 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:18:y
     /*    4183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4193 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:18:x, GPR:{ *:[i64] }:$rs2:$pred:18:y)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    4196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4204 */     GIR_RootConstrainSelectedInstOperands,
     /*    4205 */     // GIR_Coverage, 2619,
     /*    4205 */     GIR_EraseRootFromParent_Done,
     /*    4206 */   // Label 199: @4206
     /*    4206 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(4301), // Rule ID 65029 //
     /*    4211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4218 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:34:x
     /*    4222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4259 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4270 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    4274 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:34:y
     /*    4278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4282 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4288 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:34:x, GPR:{ *:[i64] }:$rs2:$pred:34:y)<<P:34:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    4291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4299 */     GIR_RootConstrainSelectedInstOperands,
     /*    4300 */     // GIR_Coverage, 65029,
     /*    4300 */     GIR_EraseRootFromParent_Done,
     /*    4301 */   // Label 200: @4301
     /*    4301 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(4396), // Rule ID 65034 //
     /*    4306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4313 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:36:x
     /*    4317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4354 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4365 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    4369 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:36:y
     /*    4373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4377 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4383 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:36:x, GPR:{ *:[i64] }:$rs2:$pred:36:y)<<P:36:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    4386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4394 */     GIR_RootConstrainSelectedInstOperands,
     /*    4395 */     // GIR_Coverage, 65034,
     /*    4395 */     GIR_EraseRootFromParent_Done,
     /*    4396 */   // Label 201: @4396
     /*    4396 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(4491), // Rule ID 65039 //
     /*    4401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4408 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:38:x
     /*    4412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4449 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4460 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    4464 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:38:y
     /*    4468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4478 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:38:x, GPR:{ *:[i64] }:$rs2:$pred:38:y)<<P:38:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    4481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4489 */     GIR_RootConstrainSelectedInstOperands,
     /*    4490 */     // GIR_Coverage, 65039,
     /*    4490 */     GIR_EraseRootFromParent_Done,
     /*    4491 */   // Label 202: @4491
     /*    4491 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(4586), // Rule ID 65499 //
     /*    4496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4503 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:10:y
     /*    4507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4511 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:10:x
     /*    4515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4552 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    4556 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    4567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4573 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:10:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:10:x)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4584 */     GIR_RootConstrainSelectedInstOperands,
     /*    4585 */     // GIR_Coverage, 65499,
     /*    4585 */     GIR_EraseRootFromParent_Done,
     /*    4586 */   // Label 203: @4586
     /*    4586 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(4681), // Rule ID 65503 //
     /*    4591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4598 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:12:y
     /*    4602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4606 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:12:x
     /*    4610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4647 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    4651 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    4662 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4668 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:12:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4679 */     GIR_RootConstrainSelectedInstOperands,
     /*    4680 */     // GIR_Coverage, 65503,
     /*    4680 */     GIR_EraseRootFromParent_Done,
     /*    4681 */   // Label 204: @4681
     /*    4681 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(4776), // Rule ID 74382 //
     /*    4686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4693 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:40:y
     /*    4697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4701 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:40:x
     /*    4705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4742 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    4746 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    4757 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4763 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:40:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:40:x)<<P:40:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    4766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4774 */     GIR_RootConstrainSelectedInstOperands,
     /*    4775 */     // GIR_Coverage, 74382,
     /*    4775 */     GIR_EraseRootFromParent_Done,
     /*    4776 */   // Label 205: @4776
     /*    4776 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(4871), // Rule ID 74386 //
     /*    4781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4788 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:42:y
     /*    4792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4796 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:42:x
     /*    4800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4837 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    4841 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    4852 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4858 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:42:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:42:x)<<P:42:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    4861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4869 */     GIR_RootConstrainSelectedInstOperands,
     /*    4870 */     // GIR_Coverage, 74386,
     /*    4870 */     GIR_EraseRootFromParent_Done,
     /*    4871 */   // Label 206: @4871
     /*    4871 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(4966), // Rule ID 65495 //
     /*    4876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4883 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:8:y
     /*    4887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4891 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:8:x
     /*    4895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4932 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    4947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4953 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:8:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4964 */     GIR_RootConstrainSelectedInstOperands,
     /*    4965 */     // GIR_Coverage, 65495,
     /*    4965 */     GIR_EraseRootFromParent_Done,
     /*    4966 */   // Label 207: @4966
     /*    4966 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(5061), // Rule ID 65511 //
     /*    4971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4978 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:16:y
     /*    4982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4986 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:16:x
     /*    4990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5027 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5038 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5048 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:16:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:16:x)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5059 */     GIR_RootConstrainSelectedInstOperands,
     /*    5060 */     // GIR_Coverage, 65511,
     /*    5060 */     GIR_EraseRootFromParent_Done,
     /*    5061 */   // Label 208: @5061
     /*    5061 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(5156), // Rule ID 65515 //
     /*    5066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5073 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:18:y
     /*    5077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5081 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:18:x
     /*    5085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5122 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5133 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5143 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:18:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:18:x)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    5146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5154 */     GIR_RootConstrainSelectedInstOperands,
     /*    5155 */     // GIR_Coverage, 65515,
     /*    5155 */     GIR_EraseRootFromParent_Done,
     /*    5156 */   // Label 209: @5156
     /*    5156 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(5251), // Rule ID 74370 //
     /*    5161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5168 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:34:y
     /*    5172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5176 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:34:x
     /*    5180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5217 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5228 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    5232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5238 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:34:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:34:x)<<P:34:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    5241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5249 */     GIR_RootConstrainSelectedInstOperands,
     /*    5250 */     // GIR_Coverage, 74370,
     /*    5250 */     GIR_EraseRootFromParent_Done,
     /*    5251 */   // Label 210: @5251
     /*    5251 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(5346), // Rule ID 74374 //
     /*    5256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5263 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:36:y
     /*    5267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5271 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:36:x
     /*    5275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5312 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5323 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5333 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:36:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:36:x)<<P:36:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    5336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5344 */     GIR_RootConstrainSelectedInstOperands,
     /*    5345 */     // GIR_Coverage, 74374,
     /*    5345 */     GIR_EraseRootFromParent_Done,
     /*    5346 */   // Label 211: @5346
     /*    5346 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(5441), // Rule ID 74378 //
     /*    5351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5358 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:38:y
     /*    5362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5366 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:38:x
     /*    5370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5407 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5418 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5422 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5428 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:38:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:38:x)<<P:38:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    5431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5439 */     GIR_RootConstrainSelectedInstOperands,
     /*    5440 */     // GIR_Coverage, 74378,
     /*    5440 */     GIR_EraseRootFromParent_Done,
     /*    5441 */   // Label 212: @5441
     /*    5441 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5489), // Rule ID 2559 //
     /*    5446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5453 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    5457 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    5461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5476 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:2:x, GPR:{ *:[i64] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    5479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5481 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5487 */     GIR_RootConstrainSelectedInstOperands,
     /*    5488 */     // GIR_Coverage, 2559,
     /*    5488 */     GIR_EraseRootFromParent_Done,
     /*    5489 */   // Label 213: @5489
     /*    5489 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(5537), // Rule ID 2569 //
     /*    5494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5501 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    5505 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    5509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5524 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:4:x, GPR:{ *:[i64] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    5527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5529 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5535 */     GIR_RootConstrainSelectedInstOperands,
     /*    5536 */     // GIR_Coverage, 2569,
     /*    5536 */     GIR_EraseRootFromParent_Done,
     /*    5537 */   // Label 214: @5537
     /*    5537 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(5585), // Rule ID 2579 //
     /*    5542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5549 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    5553 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    5557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    5572 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:6:x, GPR:{ *:[i64] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    5575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5583 */     GIR_RootConstrainSelectedInstOperands,
     /*    5584 */     // GIR_Coverage, 2579,
     /*    5584 */     GIR_EraseRootFromParent_Done,
     /*    5585 */   // Label 215: @5585
     /*    5585 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(5633), // Rule ID 2598 //
     /*    5590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5597 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*    5601 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*    5605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    5620 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:9:x, GPR:{ *:[i64] }:$rs2:$pred:9:y)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    5623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5631 */     GIR_RootConstrainSelectedInstOperands,
     /*    5632 */     // GIR_Coverage, 2598,
     /*    5632 */     GIR_EraseRootFromParent_Done,
     /*    5633 */   // Label 216: @5633
     /*    5633 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(5681), // Rule ID 2617 //
     /*    5638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5645 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:17:x
     /*    5649 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:17:y
     /*    5653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    5668 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:17:x, GPR:{ *:[i64] }:$rs2:$pred:17:y)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5679 */     GIR_RootConstrainSelectedInstOperands,
     /*    5680 */     // GIR_Coverage, 2617,
     /*    5680 */     GIR_EraseRootFromParent_Done,
     /*    5681 */   // Label 217: @5681
     /*    5681 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(5729), // Rule ID 2622 //
     /*    5686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5693 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:19:x
     /*    5697 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:19:y
     /*    5701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    5716 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:19:x, GPR:{ *:[i64] }:$rs2:$pred:19:y)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    5719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5727 */     GIR_RootConstrainSelectedInstOperands,
     /*    5728 */     // GIR_Coverage, 2622,
     /*    5728 */     GIR_EraseRootFromParent_Done,
     /*    5729 */   // Label 218: @5729
     /*    5729 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(5780), // Rule ID 62525 //
     /*    5734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    5737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5741 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    5745 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    5749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5764 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs2:$pred:24:x, GPR:{ *:[i64] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    5764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    5767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    5771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    5775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    5778 */     GIR_RootConstrainSelectedInstOperands,
     /*    5779 */     // GIR_Coverage, 62525,
     /*    5779 */     GIR_EraseRootFromParent_Done,
     /*    5780 */   // Label 219: @5780
     /*    5780 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(5831), // Rule ID 62529 //
     /*    5785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    5788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5792 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    5796 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    5800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5815 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs2:$pred:25:x, GPR:{ *:[i64] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    5815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    5818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    5822 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    5826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    5829 */     GIR_RootConstrainSelectedInstOperands,
     /*    5830 */     // GIR_Coverage, 62529,
     /*    5830 */     GIR_EraseRootFromParent_Done,
     /*    5831 */   // Label 220: @5831
     /*    5831 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(5882), // Rule ID 62533 //
     /*    5836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    5839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5843 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    5847 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    5851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    5866 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs2:$pred:26:x, GPR:{ *:[i64] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    5866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    5869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    5873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    5877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    5880 */     GIR_RootConstrainSelectedInstOperands,
     /*    5881 */     // GIR_Coverage, 62533,
     /*    5881 */     GIR_EraseRootFromParent_Done,
     /*    5882 */   // Label 221: @5882
     /*    5882 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(5930), // Rule ID 64993 //
     /*    5887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    5890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5894 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:28:x
     /*    5898 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:28:y
     /*    5902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5917 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:28:x, GPR:{ *:[i64] }:$rs2:$pred:28:y)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    5920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5928 */     GIR_RootConstrainSelectedInstOperands,
     /*    5929 */     // GIR_Coverage, 64993,
     /*    5929 */     GIR_EraseRootFromParent_Done,
     /*    5930 */   // Label 222: @5930
     /*    5930 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(5978), // Rule ID 65003 //
     /*    5935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    5938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5942 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:30:x
     /*    5946 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:30:y
     /*    5950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5965 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:30:x, GPR:{ *:[i64] }:$rs2:$pred:30:y)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    5968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5970 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5976 */     GIR_RootConstrainSelectedInstOperands,
     /*    5977 */     // GIR_Coverage, 65003,
     /*    5977 */     GIR_EraseRootFromParent_Done,
     /*    5978 */   // Label 223: @5978
     /*    5978 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6026), // Rule ID 65013 //
     /*    5983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    5986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5990 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:32:x
     /*    5994 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:32:y
     /*    5998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6002 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6013 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:32:x, GPR:{ *:[i64] }:$rs2:$pred:32:y)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    6016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6024 */     GIR_RootConstrainSelectedInstOperands,
     /*    6025 */     // GIR_Coverage, 65013,
     /*    6025 */     GIR_EraseRootFromParent_Done,
     /*    6026 */   // Label 224: @6026
     /*    6026 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6074), // Rule ID 65032 //
     /*    6031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6038 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:35:x
     /*    6042 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:35:y
     /*    6046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6061 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:35:x, GPR:{ *:[i64] }:$rs2:$pred:35:y)<<P:35:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    6064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6066 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6072 */     GIR_RootConstrainSelectedInstOperands,
     /*    6073 */     // GIR_Coverage, 65032,
     /*    6073 */     GIR_EraseRootFromParent_Done,
     /*    6074 */   // Label 225: @6074
     /*    6074 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(6122), // Rule ID 65037 //
     /*    6079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6086 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:37:x
     /*    6090 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:37:y
     /*    6094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6109 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:37:x, GPR:{ *:[i64] }:$rs2:$pred:37:y)<<P:37:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    6112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6120 */     GIR_RootConstrainSelectedInstOperands,
     /*    6121 */     // GIR_Coverage, 65037,
     /*    6121 */     GIR_EraseRootFromParent_Done,
     /*    6122 */   // Label 226: @6122
     /*    6122 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6170), // Rule ID 65042 //
     /*    6127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6134 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:39:x
     /*    6138 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:39:y
     /*    6142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6157 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:39:x, GPR:{ *:[i64] }:$rs2:$pred:39:y)<<P:39:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    6160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6168 */     GIR_RootConstrainSelectedInstOperands,
     /*    6169 */     // GIR_Coverage, 65042,
     /*    6169 */     GIR_EraseRootFromParent_Done,
     /*    6170 */   // Label 227: @6170
     /*    6170 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6218), // Rule ID 65472 //
     /*    6175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6182 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    6186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6190 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    6194 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6205 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:2:y, sh1add_op:{ *:[i64] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    6208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6216 */     GIR_RootConstrainSelectedInstOperands,
     /*    6217 */     // GIR_Coverage, 65472,
     /*    6217 */     GIR_EraseRootFromParent_Done,
     /*    6218 */   // Label 228: @6218
     /*    6218 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6266), // Rule ID 65480 //
     /*    6223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6230 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    6234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6238 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    6242 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6253 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:4:y, sh2add_op:{ *:[i64] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    6256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6258 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6264 */     GIR_RootConstrainSelectedInstOperands,
     /*    6265 */     // GIR_Coverage, 65480,
     /*    6265 */     GIR_EraseRootFromParent_Done,
     /*    6266 */   // Label 229: @6266
     /*    6266 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(6314), // Rule ID 65488 //
     /*    6271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6278 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    6282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6286 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    6290 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6301 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:6:y, sh3add_op:{ *:[i64] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    6304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6312 */     GIR_RootConstrainSelectedInstOperands,
     /*    6313 */     // GIR_Coverage, 65488,
     /*    6313 */     GIR_EraseRootFromParent_Done,
     /*    6314 */   // Label 230: @6314
     /*    6314 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(6362), // Rule ID 65497 //
     /*    6319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6326 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:9:y
     /*    6330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6334 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:9:x
     /*    6338 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6349 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:9:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:9:x)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    6352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6354 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6360 */     GIR_RootConstrainSelectedInstOperands,
     /*    6361 */     // GIR_Coverage, 65497,
     /*    6361 */     GIR_EraseRootFromParent_Done,
     /*    6362 */   // Label 231: @6362
     /*    6362 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(6410), // Rule ID 65513 //
     /*    6367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6374 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:17:y
     /*    6378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6382 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:17:x
     /*    6386 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6397 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:17:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:17:x)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    6400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6408 */     GIR_RootConstrainSelectedInstOperands,
     /*    6409 */     // GIR_Coverage, 65513,
     /*    6409 */     GIR_EraseRootFromParent_Done,
     /*    6410 */   // Label 232: @6410
     /*    6410 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(6458), // Rule ID 65517 //
     /*    6415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6422 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:19:y
     /*    6426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6430 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:19:x
     /*    6434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6445 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:19:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:19:x)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    6448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6450 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6456 */     GIR_RootConstrainSelectedInstOperands,
     /*    6457 */     // GIR_Coverage, 65517,
     /*    6457 */     GIR_EraseRootFromParent_Done,
     /*    6458 */   // Label 233: @6458
     /*    6458 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(6509), // Rule ID 74306 //
     /*    6463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6470 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    6474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6478 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    6482 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6493 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:24:y, sh1add_op:{ *:[i64] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    6493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    6507 */     GIR_RootConstrainSelectedInstOperands,
     /*    6508 */     // GIR_Coverage, 74306,
     /*    6508 */     GIR_EraseRootFromParent_Done,
     /*    6509 */   // Label 234: @6509
     /*    6509 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(6560), // Rule ID 74310 //
     /*    6514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6521 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    6525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6529 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    6533 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6544 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:25:y, sh2add_op:{ *:[i64] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    6544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    6558 */     GIR_RootConstrainSelectedInstOperands,
     /*    6559 */     // GIR_Coverage, 74310,
     /*    6559 */     GIR_EraseRootFromParent_Done,
     /*    6560 */   // Label 235: @6560
     /*    6560 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(6611), // Rule ID 74314 //
     /*    6565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6572 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    6576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6580 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    6584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6595 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:26:y, sh3add_op:{ *:[i64] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    6595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6602 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    6609 */     GIR_RootConstrainSelectedInstOperands,
     /*    6610 */     // GIR_Coverage, 74314,
     /*    6610 */     GIR_EraseRootFromParent_Done,
     /*    6611 */   // Label 236: @6611
     /*    6611 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(6659), // Rule ID 74347 //
     /*    6616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6623 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:28:y
     /*    6627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6631 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:28:x
     /*    6635 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6646 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:28:y, sh1add_op:{ *:[i64] }:$rs1:$pred:28:x)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    6649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6657 */     GIR_RootConstrainSelectedInstOperands,
     /*    6658 */     // GIR_Coverage, 74347,
     /*    6658 */     GIR_EraseRootFromParent_Done,
     /*    6659 */   // Label 237: @6659
     /*    6659 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(6707), // Rule ID 74355 //
     /*    6664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6671 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:30:y
     /*    6675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6679 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:30:x
     /*    6683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6694 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:30:y, sh2add_op:{ *:[i64] }:$rs1:$pred:30:x)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    6697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6699 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6705 */     GIR_RootConstrainSelectedInstOperands,
     /*    6706 */     // GIR_Coverage, 74355,
     /*    6706 */     GIR_EraseRootFromParent_Done,
     /*    6707 */   // Label 238: @6707
     /*    6707 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(6755), // Rule ID 74363 //
     /*    6712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6719 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:32:y
     /*    6723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6727 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:32:x
     /*    6731 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6742 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:32:y, sh3add_op:{ *:[i64] }:$rs1:$pred:32:x)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    6745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6753 */     GIR_RootConstrainSelectedInstOperands,
     /*    6754 */     // GIR_Coverage, 74363,
     /*    6754 */     GIR_EraseRootFromParent_Done,
     /*    6755 */   // Label 239: @6755
     /*    6755 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(6803), // Rule ID 74372 //
     /*    6760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6767 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:35:y
     /*    6771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6775 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:35:x
     /*    6779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6790 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:35:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:35:x)<<P:35:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    6793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6795 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6801 */     GIR_RootConstrainSelectedInstOperands,
     /*    6802 */     // GIR_Coverage, 74372,
     /*    6802 */     GIR_EraseRootFromParent_Done,
     /*    6803 */   // Label 240: @6803
     /*    6803 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(6851), // Rule ID 74376 //
     /*    6808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6815 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:37:y
     /*    6819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6823 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:37:x
     /*    6827 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6838 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:37:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:37:x)<<P:37:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    6841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6843 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6849 */     GIR_RootConstrainSelectedInstOperands,
     /*    6850 */     // GIR_Coverage, 74376,
     /*    6850 */     GIR_EraseRootFromParent_Done,
     /*    6851 */   // Label 241: @6851
     /*    6851 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(6899), // Rule ID 74380 //
     /*    6856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6863 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:39:y
     /*    6867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6871 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:39:x
     /*    6875 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6886 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:39:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:39:x)<<P:39:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    6889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6891 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6897 */     GIR_RootConstrainSelectedInstOperands,
     /*    6898 */     // GIR_Coverage, 74380,
     /*    6898 */     GIR_EraseRootFromParent_Done,
     /*    6899 */   // Label 242: @6899
     /*    6899 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(6974), // Rule ID 2590 //
     /*    6904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6911 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*    6915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    6919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6936 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    6947 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*    6951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6961 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x, GPR:{ *:[i64] }:$rs2:$pred:7:y)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    6964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6972 */     GIR_RootConstrainSelectedInstOperands,
     /*    6973 */     // GIR_Coverage, 2590,
     /*    6973 */     GIR_EraseRootFromParent_Done,
     /*    6974 */   // Label 243: @6974
     /*    6974 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(7069), // Rule ID 2602 //
     /*    6979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6986 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*    6990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    6994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7011 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    7022 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*    7026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7036 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:11:x, GPR:{ *:[i64] }:$rs2:$pred:11:y)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7052 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    7060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7067 */     GIR_RootConstrainSelectedInstOperands,
     /*    7068 */     // GIR_Coverage, 2602,
     /*    7068 */     GIR_EraseRootFromParent_Done,
     /*    7069 */   // Label 244: @7069
     /*    7069 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(7164), // Rule ID 2606 //
     /*    7074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7081 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*    7085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7106 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    7117 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*    7121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7125 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7131 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:13:x, GPR:{ *:[i64] }:$rs2:$pred:13:y)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7147 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    7155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7162 */     GIR_RootConstrainSelectedInstOperands,
     /*    7163 */     // GIR_Coverage, 2606,
     /*    7163 */     GIR_EraseRootFromParent_Done,
     /*    7164 */   // Label 245: @7164
     /*    7164 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(7259), // Rule ID 2608 //
     /*    7169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7176 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*    7180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7201 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7212 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*    7216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7226 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:14:x, GPR:{ *:[i64] }:$rs2:$pred:14:y)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7242 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    7250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7257 */     GIR_RootConstrainSelectedInstOperands,
     /*    7258 */     // GIR_Coverage, 2608,
     /*    7258 */     GIR_EraseRootFromParent_Done,
     /*    7259 */   // Label 246: @7259
     /*    7259 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(7354), // Rule ID 2610 //
     /*    7264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7271 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:15:x
     /*    7275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7296 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    7307 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:15:y
     /*    7311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7321 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:15:x, GPR:{ *:[i64] }:$rs2:$pred:15:y)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7337 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    7345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7352 */     GIR_RootConstrainSelectedInstOperands,
     /*    7353 */     // GIR_Coverage, 2610,
     /*    7353 */     GIR_EraseRootFromParent_Done,
     /*    7354 */   // Label 247: @7354
     /*    7354 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(7449), // Rule ID 2624 //
     /*    7359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7366 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:20:x
     /*    7370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7391 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    7402 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:20:y
     /*    7406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7410 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7416 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:20:x, GPR:{ *:[i64] }:$rs2:$pred:20:y)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7432 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    7440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7447 */     GIR_RootConstrainSelectedInstOperands,
     /*    7448 */     // GIR_Coverage, 2624,
     /*    7448 */     GIR_EraseRootFromParent_Done,
     /*    7449 */   // Label 248: @7449
     /*    7449 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(7544), // Rule ID 2626 //
     /*    7454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7461 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:21:x
     /*    7465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7486 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    7497 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:21:y
     /*    7501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7511 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:21:x, GPR:{ *:[i64] }:$rs2:$pred:21:y)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7527 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    7535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7542 */     GIR_RootConstrainSelectedInstOperands,
     /*    7543 */     // GIR_Coverage, 2626,
     /*    7543 */     GIR_EraseRootFromParent_Done,
     /*    7544 */   // Label 249: @7544
     /*    7544 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(7639), // Rule ID 2628 //
     /*    7549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7556 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:22:x
     /*    7560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7581 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7592 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:22:y
     /*    7596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7606 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:22:x, GPR:{ *:[i64] }:$rs2:$pred:22:y)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    7630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7637 */     GIR_RootConstrainSelectedInstOperands,
     /*    7638 */     // GIR_Coverage, 2628,
     /*    7638 */     GIR_EraseRootFromParent_Done,
     /*    7639 */   // Label 250: @7639
     /*    7639 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(7714), // Rule ID 65024 //
     /*    7644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7651 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:33:x
     /*    7655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7676 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    7687 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:33:y
     /*    7691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7701 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:33:x, GPR:{ *:[i64] }:$rs2:$pred:33:y)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*    7704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7712 */     GIR_RootConstrainSelectedInstOperands,
     /*    7713 */     // GIR_Coverage, 65024,
     /*    7713 */     GIR_EraseRootFromParent_Done,
     /*    7714 */   // Label 251: @7714
     /*    7714 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(7809), // Rule ID 65046 //
     /*    7719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7726 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:41:x
     /*    7730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7751 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    7762 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:41:y
     /*    7766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7776 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:41:x, GPR:{ *:[i64] }:$rs2:$pred:41:y)<<P:41:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7788 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7792 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    7800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7807 */     GIR_RootConstrainSelectedInstOperands,
     /*    7808 */     // GIR_Coverage, 65046,
     /*    7808 */     GIR_EraseRootFromParent_Done,
     /*    7809 */   // Label 252: @7809
     /*    7809 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(7904), // Rule ID 65050 //
     /*    7814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7821 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:43:x
     /*    7825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7846 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    7857 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:43:y
     /*    7861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7865 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7871 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:43:x, GPR:{ *:[i64] }:$rs2:$pred:43:y)<<P:43:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    7895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7902 */     GIR_RootConstrainSelectedInstOperands,
     /*    7903 */     // GIR_Coverage, 65050,
     /*    7903 */     GIR_EraseRootFromParent_Done,
     /*    7904 */   // Label 253: @7904
     /*    7904 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(7999), // Rule ID 65052 //
     /*    7909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7916 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:44:x
     /*    7920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7941 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7952 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:44:y
     /*    7956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7966 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:44:x, GPR:{ *:[i64] }:$rs2:$pred:44:y)<<P:44:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7982 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    7990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7997 */     GIR_RootConstrainSelectedInstOperands,
     /*    7998 */     // GIR_Coverage, 65052,
     /*    7998 */     GIR_EraseRootFromParent_Done,
     /*    7999 */   // Label 254: @7999
     /*    7999 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(8094), // Rule ID 65054 //
     /*    8004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8011 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:45:x
     /*    8015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8036 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    8047 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:45:y
     /*    8051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8055 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8061 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:45:x, GPR:{ *:[i64] }:$rs2:$pred:45:y)<<P:45:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8077 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8092 */     GIR_RootConstrainSelectedInstOperands,
     /*    8093 */     // GIR_Coverage, 65054,
     /*    8093 */     GIR_EraseRootFromParent_Done,
     /*    8094 */   // Label 255: @8094
     /*    8094 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(8189), // Rule ID 65056 //
     /*    8099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8106 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:46:x
     /*    8110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8131 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    8142 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:46:y
     /*    8146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8150 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8156 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:46:x, GPR:{ *:[i64] }:$rs2:$pred:46:y)<<P:46:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8168 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8172 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    8175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    8180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8187 */     GIR_RootConstrainSelectedInstOperands,
     /*    8188 */     // GIR_Coverage, 65056,
     /*    8188 */     GIR_EraseRootFromParent_Done,
     /*    8189 */   // Label 256: @8189
     /*    8189 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(8284), // Rule ID 65058 //
     /*    8194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8201 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:47:x
     /*    8205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8226 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    8237 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:47:y
     /*    8241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8245 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8251 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:47:x, GPR:{ *:[i64] }:$rs2:$pred:47:y)<<P:47:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8263 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8267 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    8270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    8275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8282 */     GIR_RootConstrainSelectedInstOperands,
     /*    8283 */     // GIR_Coverage, 65058,
     /*    8283 */     GIR_EraseRootFromParent_Done,
     /*    8284 */   // Label 257: @8284
     /*    8284 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(8379), // Rule ID 65060 //
     /*    8289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8296 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:48:x
     /*    8300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8321 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    8332 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:48:y
     /*    8336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8340 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8346 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:48:x, GPR:{ *:[i64] }:$rs2:$pred:48:y)<<P:48:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8362 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8377 */     GIR_RootConstrainSelectedInstOperands,
     /*    8378 */     // GIR_Coverage, 65060,
     /*    8378 */     GIR_EraseRootFromParent_Done,
     /*    8379 */   // Label 258: @8379
     /*    8379 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(8447), // Rule ID 2553 //
     /*    8384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8391 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    8395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8416 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    8420 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    8424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8434 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x, GPR:{ *:[i64] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    8437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8445 */     GIR_RootConstrainSelectedInstOperands,
     /*    8446 */     // GIR_Coverage, 2553,
     /*    8446 */     GIR_EraseRootFromParent_Done,
     /*    8447 */   // Label 259: @8447
     /*    8447 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(8515), // Rule ID 2563 //
     /*    8452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8459 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    8463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8484 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    8488 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    8492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8502 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x, GPR:{ *:[i64] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    8505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8513 */     GIR_RootConstrainSelectedInstOperands,
     /*    8514 */     // GIR_Coverage, 2563,
     /*    8514 */     GIR_EraseRootFromParent_Done,
     /*    8515 */   // Label 260: @8515
     /*    8515 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(8583), // Rule ID 2573 //
     /*    8520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8527 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    8531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8552 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    8556 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    8560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8570 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x, GPR:{ *:[i64] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    8573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8581 */     GIR_RootConstrainSelectedInstOperands,
     /*    8582 */     // GIR_Coverage, 2573,
     /*    8582 */     GIR_EraseRootFromParent_Done,
     /*    8583 */   // Label 261: @8583
     /*    8583 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(8651), // Rule ID 64987 //
     /*    8588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    8591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8595 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:27:x
     /*    8599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8620 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    8624 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:27:y
     /*    8628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8632 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8638 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:27:x, GPR:{ *:[i64] }:$rs2:$pred:27:y)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    8641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8649 */     GIR_RootConstrainSelectedInstOperands,
     /*    8650 */     // GIR_Coverage, 64987,
     /*    8650 */     GIR_EraseRootFromParent_Done,
     /*    8651 */   // Label 262: @8651
     /*    8651 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(8719), // Rule ID 64997 //
     /*    8656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    8659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8663 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:29:x
     /*    8667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8688 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    8692 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:29:y
     /*    8696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8700 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8706 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:29:x, GPR:{ *:[i64] }:$rs2:$pred:29:y)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    8709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8717 */     GIR_RootConstrainSelectedInstOperands,
     /*    8718 */     // GIR_Coverage, 64997,
     /*    8718 */     GIR_EraseRootFromParent_Done,
     /*    8719 */   // Label 263: @8719
     /*    8719 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(8787), // Rule ID 65007 //
     /*    8724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    8727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8731 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:31:x
     /*    8735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8756 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    8760 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:31:y
     /*    8764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8774 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:31:x, GPR:{ *:[i64] }:$rs2:$pred:31:y)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    8777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8785 */     GIR_RootConstrainSelectedInstOperands,
     /*    8786 */     // GIR_Coverage, 65007,
     /*    8786 */     GIR_EraseRootFromParent_Done,
     /*    8787 */   // Label 264: @8787
     /*    8787 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(8862), // Rule ID 65491 //
     /*    8792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8799 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:7:y
     /*    8803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8807 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:7:x
     /*    8811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8832 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    8843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8849 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:7:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    8852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    8860 */     GIR_RootConstrainSelectedInstOperands,
     /*    8861 */     // GIR_Coverage, 65491,
     /*    8861 */     GIR_EraseRootFromParent_Done,
     /*    8862 */   // Label 265: @8862
     /*    8862 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(8957), // Rule ID 65501 //
     /*    8867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8874 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:11:y
     /*    8878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8882 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:11:x
     /*    8886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8907 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    8918 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8924 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:11:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:11:x)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8936 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8940 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    8943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    8948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    8955 */     GIR_RootConstrainSelectedInstOperands,
     /*    8956 */     // GIR_Coverage, 65501,
     /*    8956 */     GIR_EraseRootFromParent_Done,
     /*    8957 */   // Label 266: @8957
     /*    8957 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(9052), // Rule ID 65505 //
     /*    8962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8969 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:13:y
     /*    8973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8977 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:13:x
     /*    8981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9002 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    9013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9019 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:13:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:13:x)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    9043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9050 */     GIR_RootConstrainSelectedInstOperands,
     /*    9051 */     // GIR_Coverage, 65505,
     /*    9051 */     GIR_EraseRootFromParent_Done,
     /*    9052 */   // Label 267: @9052
     /*    9052 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(9147), // Rule ID 65507 //
     /*    9057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9064 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:14:y
     /*    9068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9072 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:14:x
     /*    9076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9097 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9114 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:14:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:14:x)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9130 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    9138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9145 */     GIR_RootConstrainSelectedInstOperands,
     /*    9146 */     // GIR_Coverage, 65507,
     /*    9146 */     GIR_EraseRootFromParent_Done,
     /*    9147 */   // Label 268: @9147
     /*    9147 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(9242), // Rule ID 65509 //
     /*    9152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9159 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:15:y
     /*    9163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9167 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:15:x
     /*    9171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9192 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    9203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9209 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:15:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:15:x)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9221 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9225 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    9233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9240 */     GIR_RootConstrainSelectedInstOperands,
     /*    9241 */     // GIR_Coverage, 65509,
     /*    9241 */     GIR_EraseRootFromParent_Done,
     /*    9242 */   // Label 269: @9242
     /*    9242 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(9337), // Rule ID 65519 //
     /*    9247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9254 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:20:y
     /*    9258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9262 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:20:x
     /*    9266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9287 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    9298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9304 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:20:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:20:x)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9320 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    9323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    9328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9335 */     GIR_RootConstrainSelectedInstOperands,
     /*    9336 */     // GIR_Coverage, 65519,
     /*    9336 */     GIR_EraseRootFromParent_Done,
     /*    9337 */   // Label 270: @9337
     /*    9337 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(9432), // Rule ID 65521 //
     /*    9342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9349 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:21:y
     /*    9353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9357 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:21:x
     /*    9361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9382 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    9393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9399 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:21:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:21:x)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9415 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    9423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9430 */     GIR_RootConstrainSelectedInstOperands,
     /*    9431 */     // GIR_Coverage, 65521,
     /*    9431 */     GIR_EraseRootFromParent_Done,
     /*    9432 */   // Label 271: @9432
     /*    9432 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(9527), // Rule ID 65523 //
     /*    9437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9444 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:22:y
     /*    9448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9452 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:22:x
     /*    9456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9477 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9488 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9494 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:22:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:22:x)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    9518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9525 */     GIR_RootConstrainSelectedInstOperands,
     /*    9526 */     // GIR_Coverage, 65523,
     /*    9526 */     GIR_EraseRootFromParent_Done,
     /*    9527 */   // Label 272: @9527
     /*    9527 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(9602), // Rule ID 74366 //
     /*    9532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9539 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:33:y
     /*    9543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9547 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:33:x
     /*    9551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9572 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    9583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9589 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:33:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:33:x)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*    9592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9600 */     GIR_RootConstrainSelectedInstOperands,
     /*    9601 */     // GIR_Coverage, 74366,
     /*    9601 */     GIR_EraseRootFromParent_Done,
     /*    9602 */   // Label 273: @9602
     /*    9602 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(9697), // Rule ID 74384 //
     /*    9607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9614 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:41:y
     /*    9618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9622 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:41:x
     /*    9626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9647 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    9658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9664 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:41:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:41:x)<<P:41:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9680 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    9683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    9688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9695 */     GIR_RootConstrainSelectedInstOperands,
     /*    9696 */     // GIR_Coverage, 74384,
     /*    9696 */     GIR_EraseRootFromParent_Done,
     /*    9697 */   // Label 274: @9697
     /*    9697 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(9792), // Rule ID 74388 //
     /*    9702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9709 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:43:y
     /*    9713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9717 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:43:x
     /*    9721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9742 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    9753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9759 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:43:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:43:x)<<P:43:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9771 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    9783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9790 */     GIR_RootConstrainSelectedInstOperands,
     /*    9791 */     // GIR_Coverage, 74388,
     /*    9791 */     GIR_EraseRootFromParent_Done,
     /*    9792 */   // Label 275: @9792
     /*    9792 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(9887), // Rule ID 74390 //
     /*    9797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9804 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:44:y
     /*    9808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9812 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:44:x
     /*    9816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9837 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9854 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:44:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:44:x)<<P:44:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9870 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    9878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9885 */     GIR_RootConstrainSelectedInstOperands,
     /*    9886 */     // GIR_Coverage, 74390,
     /*    9886 */     GIR_EraseRootFromParent_Done,
     /*    9887 */   // Label 276: @9887
     /*    9887 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(9982), // Rule ID 74392 //
     /*    9892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9899 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:45:y
     /*    9903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9907 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:45:x
     /*    9911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9932 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    9943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9949 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:45:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:45:x)<<P:45:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    9973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9980 */     GIR_RootConstrainSelectedInstOperands,
     /*    9981 */     // GIR_Coverage, 74392,
     /*    9981 */     GIR_EraseRootFromParent_Done,
     /*    9982 */   // Label 277: @9982
     /*    9982 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(10077), // Rule ID 74394 //
     /*    9987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9994 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:46:y
     /*    9998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10002 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:46:x
     /*   10006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10027 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*   10038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10044 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:46:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:46:x)<<P:46:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   10063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*   10068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10075 */     GIR_RootConstrainSelectedInstOperands,
     /*   10076 */     // GIR_Coverage, 74394,
     /*   10076 */     GIR_EraseRootFromParent_Done,
     /*   10077 */   // Label 278: @10077
     /*   10077 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(10172), // Rule ID 74396 //
     /*   10082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10089 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:47:y
     /*   10093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10097 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:47:x
     /*   10101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10122 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*   10133 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10139 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:47:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:47:x)<<P:47:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10155 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*   10158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*   10163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10170 */     GIR_RootConstrainSelectedInstOperands,
     /*   10171 */     // GIR_Coverage, 74396,
     /*   10171 */     GIR_EraseRootFromParent_Done,
     /*   10172 */   // Label 279: @10172
     /*   10172 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(10267), // Rule ID 74398 //
     /*   10177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10184 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:48:y
     /*   10188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10192 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:48:x
     /*   10196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10217 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*   10228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10234 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:48:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:48:x)<<P:48:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10250 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*   10253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*   10258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10265 */     GIR_RootConstrainSelectedInstOperands,
     /*   10266 */     // GIR_Coverage, 74398,
     /*   10266 */     GIR_EraseRootFromParent_Done,
     /*   10267 */   // Label 280: @10267
     /*   10267 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(10335), // Rule ID 65468 //
     /*   10272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10279 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*   10283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10287 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*   10291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10312 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   10316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10322 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:1:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*   10325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10333 */     GIR_RootConstrainSelectedInstOperands,
     /*   10334 */     // GIR_Coverage, 65468,
     /*   10334 */     GIR_EraseRootFromParent_Done,
     /*   10335 */   // Label 281: @10335
     /*   10335 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(10403), // Rule ID 65476 //
     /*   10340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10347 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*   10351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10355 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*   10359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10380 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*   10384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10390 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:3:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*   10393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10401 */     GIR_RootConstrainSelectedInstOperands,
     /*   10402 */     // GIR_Coverage, 65476,
     /*   10402 */     GIR_EraseRootFromParent_Done,
     /*   10403 */   // Label 282: @10403
     /*   10403 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(10471), // Rule ID 65484 //
     /*   10408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10415 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*   10419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10423 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*   10427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10448 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*   10452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10458 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:5:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*   10461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10469 */     GIR_RootConstrainSelectedInstOperands,
     /*   10470 */     // GIR_Coverage, 65484,
     /*   10470 */     GIR_EraseRootFromParent_Done,
     /*   10471 */   // Label 283: @10471
     /*   10471 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(10539), // Rule ID 74343 //
     /*   10476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10483 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:27:y
     /*   10487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10491 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:27:x
     /*   10495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10516 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   10520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10526 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:27:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:27:x)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*   10529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10537 */     GIR_RootConstrainSelectedInstOperands,
     /*   10538 */     // GIR_Coverage, 74343,
     /*   10538 */     GIR_EraseRootFromParent_Done,
     /*   10539 */   // Label 284: @10539
     /*   10539 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(10607), // Rule ID 74351 //
     /*   10544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10551 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:29:y
     /*   10555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10559 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:29:x
     /*   10563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10584 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*   10588 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10594 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:29:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:29:x)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*   10597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10605 */     GIR_RootConstrainSelectedInstOperands,
     /*   10606 */     // GIR_Coverage, 74351,
     /*   10606 */     GIR_EraseRootFromParent_Done,
     /*   10607 */   // Label 285: @10607
     /*   10607 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(10675), // Rule ID 74359 //
     /*   10612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10619 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:31:y
     /*   10623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10627 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:31:x
     /*   10631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10652 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*   10656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10662 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:31:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:31:x)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*   10665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10673 */     GIR_RootConstrainSelectedInstOperands,
     /*   10674 */     // GIR_Coverage, 74359,
     /*   10674 */     GIR_EraseRootFromParent_Done,
     /*   10675 */   // Label 286: @10675
     /*   10675 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(10754), // Rule ID 62519 //
     /*   10680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*   10683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10687 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*   10691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   10716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10720 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*   10724 */     // MIs[2] Operand 1
     /*   10724 */     // No operand predicates
     /*   10724 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*   10728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   10738 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i64] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*   10738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*   10741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   10745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   10749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*   10752 */     GIR_RootConstrainSelectedInstOperands,
     /*   10753 */     // GIR_Coverage, 62519,
     /*   10753 */     GIR_EraseRootFromParent_Done,
     /*   10754 */   // Label 287: @10754
     /*   10754 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(10833), // Rule ID 74302 //
     /*   10759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*   10762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10766 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*   10770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10774 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*   10778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   10803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10807 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*   10811 */     // MIs[2] Operand 1
     /*   10811 */     // No operand predicates
     /*   10811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   10817 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:23:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*   10817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*   10820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   10828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*   10831 */     GIR_RootConstrainSelectedInstOperands,
     /*   10832 */     // GIR_Coverage, 74302,
     /*   10832 */     GIR_EraseRootFromParent_Done,
     /*   10833 */   // Label 288: @10833
     /*   10833 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(10882), // Rule ID 114 //
     /*   10838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   10841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*   10853 */     // MIs[1] Operand 1
     /*   10853 */     // No operand predicates
     /*   10853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   10857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10861 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   10865 */     // MIs[2] Operand 1
     /*   10865 */     // No operand predicates
     /*   10865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   10867 */     // (add:{ *:[i64] } (frameindex:{ *:[i64] }):$fi, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i64] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i64] }:$fi), (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)
     /*   10867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   10870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10872 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*   10877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*   10880 */     GIR_RootConstrainSelectedInstOperands,
     /*   10881 */     // GIR_Coverage, 114,
     /*   10881 */     GIR_EraseRootFromParent_Done,
     /*   10882 */   // Label 289: @10882
     /*   10882 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(10928), // Rule ID 265 //
     /*   10887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   10890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   10910 */     // MIs[1] Operand 1
     /*   10910 */     // No operand predicates
     /*   10910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10017),
     /*   10914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10916 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)<<P:Predicate_anonymous_10017>>  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   10916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   10919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   10926 */     GIR_RootConstrainSelectedInstOperands,
     /*   10927 */     // GIR_Coverage, 265,
     /*   10927 */     GIR_EraseRootFromParent_Done,
     /*   10928 */   // Label 290: @10928
     /*   10928 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(11004), // Rule ID 287 //
     /*   10933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   10936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*   10956 */     // MIs[1] Operand 1
     /*   10956 */     // No operand predicates
     /*   10956 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10045),
     /*   10960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10017),
     /*   10964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10966 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10045>>:$rs2)<<P:Predicate_anonymous_10017>>  =>  (ADDIW:{ *:[i64] } (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*   10966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   10973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   10982 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*   10987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   10992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10997 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*   11002 */     GIR_RootConstrainSelectedInstOperands,
     /*   11003 */     // GIR_Coverage, 287,
     /*   11003 */     GIR_EraseRootFromParent_Done,
     /*   11004 */   // Label 291: @11004
     /*   11004 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(11069), // Rule ID 74318 //
     /*   11009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   11012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11046 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10017),
     /*   11050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11052 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)<<P:Predicate_anonymous_10017>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*   11055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11067 */     GIR_RootConstrainSelectedInstOperands,
     /*   11068 */     // GIR_Coverage, 74318,
     /*   11068 */     GIR_EraseRootFromParent_Done,
     /*   11069 */   // Label 292: @11069
     /*   11069 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(11134), // Rule ID 62590 //
     /*   11074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   11077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10017),
     /*   11115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11117 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10017>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*   11120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11132 */     GIR_RootConstrainSelectedInstOperands,
     /*   11133 */     // GIR_Coverage, 62590,
     /*   11133 */     GIR_EraseRootFromParent_Done,
     /*   11134 */   // Label 293: @11134
     /*   11134 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(11176), // Rule ID 74 //
     /*   11139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   11162 */     // MIs[1] Operand 1
     /*   11162 */     // No operand predicates
     /*   11162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11164 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   11164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   11174 */     GIR_RootConstrainSelectedInstOperands,
     /*   11175 */     // GIR_Coverage, 74,
     /*   11175 */     GIR_EraseRootFromParent_Done,
     /*   11176 */   // Label 294: @11176
     /*   11176 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(11248), // Rule ID 285 //
     /*   11181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*   11204 */     // MIs[1] Operand 1
     /*   11204 */     // No operand predicates
     /*   11204 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10045),
     /*   11208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11210 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10045>>:$rs2)  =>  (ADDI:{ *:[i64] } (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*   11210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   11213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   11226 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*   11231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11241 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*   11246 */     GIR_RootConstrainSelectedInstOperands,
     /*   11247 */     // GIR_Coverage, 285,
     /*   11247 */     GIR_EraseRootFromParent_Done,
     /*   11248 */   // Label 295: @11248
     /*   11248 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(11309), // Rule ID 74316 //
     /*   11253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   11256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11292 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*   11295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11307 */     GIR_RootConstrainSelectedInstOperands,
     /*   11308 */     // GIR_Coverage, 74316,
     /*   11308 */     GIR_EraseRootFromParent_Done,
     /*   11309 */   // Label 296: @11309
     /*   11309 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(11370), // Rule ID 62586 //
     /*   11314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   11317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11353 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*   11356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11368 */     GIR_RootConstrainSelectedInstOperands,
     /*   11369 */     // GIR_Coverage, 62586,
     /*   11369 */     GIR_EraseRootFromParent_Done,
     /*   11370 */   // Label 297: @11370
     /*   11370 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(11401), // Rule ID 264 //
     /*   11375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   11378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11390 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10017),
     /*   11394 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10017>>  =>  (ADDW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADDW),
     /*   11399 */     GIR_RootConstrainSelectedInstOperands,
     /*   11400 */     // GIR_Coverage, 264,
     /*   11400 */     GIR_Done,
     /*   11401 */   // Label 298: @11401
     /*   11401 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(11428), // Rule ID 72 //
     /*   11406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11421 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*   11426 */     GIR_RootConstrainSelectedInstOperands,
     /*   11427 */     // GIR_Coverage, 72,
     /*   11427 */     GIR_Done,
     /*   11428 */   // Label 299: @11428
     /*   11428 */   GIM_Reject,
     /*   11429 */ // Label 192: @11429
     /*   11429 */ GIM_Reject,
     /*   11430 */ // Label 128: @11430
     /*   11430 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(11824),
     /*   11435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11445 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(11513), // Rule ID 69266 //
     /*   11450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11487 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11511 */     GIR_RootConstrainSelectedInstOperands,
     /*   11512 */     // GIR_Coverage, 69266,
     /*   11512 */     GIR_EraseRootFromParent_Done,
     /*   11513 */   // Label 301: @11513
     /*   11513 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(11581), // Rule ID 69267 //
     /*   11518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11537 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11555 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   11555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11579 */     GIR_RootConstrainSelectedInstOperands,
     /*   11580 */     // GIR_Coverage, 69267,
     /*   11580 */     GIR_EraseRootFromParent_Done,
     /*   11581 */   // Label 302: @11581
     /*   11581 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(11649), // Rule ID 45910 //
     /*   11586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11609 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11623 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11647 */     GIR_RootConstrainSelectedInstOperands,
     /*   11648 */     // GIR_Coverage, 45910,
     /*   11648 */     GIR_EraseRootFromParent_Done,
     /*   11649 */   // Label 303: @11649
     /*   11649 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(11717), // Rule ID 45911 //
     /*   11654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11677 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11691 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   11691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11715 */     GIR_RootConstrainSelectedInstOperands,
     /*   11716 */     // GIR_Coverage, 45911,
     /*   11716 */     GIR_EraseRootFromParent_Done,
     /*   11717 */   // Label 304: @11717
     /*   11717 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(11770), // Rule ID 45738 //
     /*   11722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11733 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   11733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   11736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*   11750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11768 */     GIR_RootConstrainSelectedInstOperands,
     /*   11769 */     // GIR_Coverage, 45738,
     /*   11769 */     GIR_EraseRootFromParent_Done,
     /*   11770 */   // Label 305: @11770
     /*   11770 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(11823), // Rule ID 45739 //
     /*   11775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11786 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   11786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   11789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*   11803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11821 */     GIR_RootConstrainSelectedInstOperands,
     /*   11822 */     // GIR_Coverage, 45739,
     /*   11822 */     GIR_EraseRootFromParent_Done,
     /*   11823 */   // Label 306: @11823
     /*   11823 */   GIM_Reject,
     /*   11824 */ // Label 300: @11824
     /*   11824 */ GIM_Reject,
     /*   11825 */ // Label 129: @11825
     /*   11825 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14949),
     /*   11830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   11836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11840 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(11936), // Rule ID 69180 //
     /*   11845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   11864 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11878 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11893 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11897 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11899 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11910 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   11913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   11921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   11925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11934 */     GIR_RootConstrainSelectedInstOperands,
     /*   11935 */     // GIR_Coverage, 69180,
     /*   11935 */     GIR_EraseRootFromParent_Done,
     /*   11936 */   // Label 308: @11936
     /*   11936 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(12032), // Rule ID 69181 //
     /*   11941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   11960 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11974 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11989 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11993 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11995 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12006 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12030 */     GIR_RootConstrainSelectedInstOperands,
     /*   12031 */     // GIR_Coverage, 69181,
     /*   12031 */     GIR_EraseRootFromParent_Done,
     /*   12032 */   // Label 309: @12032
     /*   12032 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(12128), // Rule ID 71006 //
     /*   12037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12056 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12070 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12085 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12089 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12091 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12102 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12126 */     GIR_RootConstrainSelectedInstOperands,
     /*   12127 */     // GIR_Coverage, 71006,
     /*   12127 */     GIR_EraseRootFromParent_Done,
     /*   12128 */   // Label 310: @12128
     /*   12128 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(12224), // Rule ID 71007 //
     /*   12133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12152 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12166 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12181 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12185 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12187 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12198 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12222 */     GIR_RootConstrainSelectedInstOperands,
     /*   12223 */     // GIR_Coverage, 71007,
     /*   12223 */     GIR_EraseRootFromParent_Done,
     /*   12224 */   // Label 311: @12224
     /*   12224 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(12320), // Rule ID 71008 //
     /*   12229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12248 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12262 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12281 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12283 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12294 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12318 */     GIR_RootConstrainSelectedInstOperands,
     /*   12319 */     // GIR_Coverage, 71008,
     /*   12319 */     GIR_EraseRootFromParent_Done,
     /*   12320 */   // Label 312: @12320
     /*   12320 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(12416), // Rule ID 71009 //
     /*   12325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12344 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12358 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12373 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12377 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12379 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12390 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12414 */     GIR_RootConstrainSelectedInstOperands,
     /*   12415 */     // GIR_Coverage, 71009,
     /*   12415 */     GIR_EraseRootFromParent_Done,
     /*   12416 */   // Label 313: @12416
     /*   12416 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(12512), // Rule ID 70884 //
     /*   12421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12440 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12454 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12469 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12473 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12475 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12486 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   12489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12510 */     GIR_RootConstrainSelectedInstOperands,
     /*   12511 */     // GIR_Coverage, 70884,
     /*   12511 */     GIR_EraseRootFromParent_Done,
     /*   12512 */   // Label 314: @12512
     /*   12512 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(12608), // Rule ID 70885 //
     /*   12517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12565 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12569 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12571 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12582 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   12585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12606 */     GIR_RootConstrainSelectedInstOperands,
     /*   12607 */     // GIR_Coverage, 70885,
     /*   12607 */     GIR_EraseRootFromParent_Done,
     /*   12608 */   // Label 315: @12608
     /*   12608 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(12704), // Rule ID 45822 //
     /*   12613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12636 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12650 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12669 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12671 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12678 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12702 */     GIR_RootConstrainSelectedInstOperands,
     /*   12703 */     // GIR_Coverage, 45822,
     /*   12703 */     GIR_EraseRootFromParent_Done,
     /*   12704 */   // Label 316: @12704
     /*   12704 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(12800), // Rule ID 45823 //
     /*   12709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12732 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12746 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12761 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12765 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12767 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12774 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12798 */     GIR_RootConstrainSelectedInstOperands,
     /*   12799 */     // GIR_Coverage, 45823,
     /*   12799 */     GIR_EraseRootFromParent_Done,
     /*   12800 */   // Label 317: @12800
     /*   12800 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(12896), // Rule ID 52142 //
     /*   12805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12828 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12842 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12857 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12861 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12863 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12870 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12894 */     GIR_RootConstrainSelectedInstOperands,
     /*   12895 */     // GIR_Coverage, 52142,
     /*   12895 */     GIR_EraseRootFromParent_Done,
     /*   12896 */   // Label 318: @12896
     /*   12896 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(12992), // Rule ID 52143 //
     /*   12901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12924 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12938 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12953 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12957 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12959 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12966 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12990 */     GIR_RootConstrainSelectedInstOperands,
     /*   12991 */     // GIR_Coverage, 52143,
     /*   12991 */     GIR_EraseRootFromParent_Done,
     /*   12992 */   // Label 319: @12992
     /*   12992 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(13088), // Rule ID 71004 //
     /*   12997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13020 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13034 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13049 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13053 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13055 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13062 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   13073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   13077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13086 */     GIR_RootConstrainSelectedInstOperands,
     /*   13087 */     // GIR_Coverage, 71004,
     /*   13087 */     GIR_EraseRootFromParent_Done,
     /*   13088 */   // Label 320: @13088
     /*   13088 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(13184), // Rule ID 71005 //
     /*   13093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13116 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13130 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13145 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13149 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13151 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13158 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   13169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   13173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13182 */     GIR_RootConstrainSelectedInstOperands,
     /*   13183 */     // GIR_Coverage, 71005,
     /*   13183 */     GIR_EraseRootFromParent_Done,
     /*   13184 */   // Label 321: @13184
     /*   13184 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(13280), // Rule ID 52082 //
     /*   13189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13212 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13226 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13241 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13245 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13247 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13254 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13278 */     GIR_RootConstrainSelectedInstOperands,
     /*   13279 */     // GIR_Coverage, 52082,
     /*   13279 */     GIR_EraseRootFromParent_Done,
     /*   13280 */   // Label 322: @13280
     /*   13280 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(13376), // Rule ID 52083 //
     /*   13285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13308 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13322 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13337 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13341 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13343 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13350 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13374 */     GIR_RootConstrainSelectedInstOperands,
     /*   13375 */     // GIR_Coverage, 52083,
     /*   13375 */     GIR_EraseRootFromParent_Done,
     /*   13376 */   // Label 323: @13376
     /*   13376 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(13465), // Rule ID 46668 //
     /*   13381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13396 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13415 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13424 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13463 */     GIR_RootConstrainSelectedInstOperands,
     /*   13464 */     // GIR_Coverage, 46668,
     /*   13464 */     GIR_EraseRootFromParent_Done,
     /*   13465 */   // Label 324: @13465
     /*   13465 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(13554), // Rule ID 46669 //
     /*   13470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13485 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13504 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13513 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13552 */     GIR_RootConstrainSelectedInstOperands,
     /*   13553 */     // GIR_Coverage, 46669,
     /*   13553 */     GIR_EraseRootFromParent_Done,
     /*   13554 */   // Label 325: @13554
     /*   13554 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(13643), // Rule ID 45814 //
     /*   13559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13574 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13593 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13602 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*   13619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13641 */     GIR_RootConstrainSelectedInstOperands,
     /*   13642 */     // GIR_Coverage, 45814,
     /*   13642 */     GIR_EraseRootFromParent_Done,
     /*   13643 */   // Label 326: @13643
     /*   13643 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(13732), // Rule ID 45815 //
     /*   13648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13663 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13682 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13691 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*   13708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13730 */     GIR_RootConstrainSelectedInstOperands,
     /*   13731 */     // GIR_Coverage, 45815,
     /*   13731 */     GIR_EraseRootFromParent_Done,
     /*   13732 */   // Label 327: @13732
     /*   13732 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(13821), // Rule ID 46548 //
     /*   13737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13771 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13780 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13819 */     GIR_RootConstrainSelectedInstOperands,
     /*   13820 */     // GIR_Coverage, 46548,
     /*   13820 */     GIR_EraseRootFromParent_Done,
     /*   13821 */   // Label 328: @13821
     /*   13821 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(13910), // Rule ID 46549 //
     /*   13826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13860 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13869 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13908 */     GIR_RootConstrainSelectedInstOperands,
     /*   13909 */     // GIR_Coverage, 46549,
     /*   13909 */     GIR_EraseRootFromParent_Done,
     /*   13910 */   // Label 329: @13910
     /*   13910 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(13978), // Rule ID 70576 //
     /*   13915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13934 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13952 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   13952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   13955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   13961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13976 */     GIR_RootConstrainSelectedInstOperands,
     /*   13977 */     // GIR_Coverage, 70576,
     /*   13977 */     GIR_EraseRootFromParent_Done,
     /*   13978 */   // Label 330: @13978
     /*   13978 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(14046), // Rule ID 70577 //
     /*   13983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14020 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   14020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14044 */     GIR_RootConstrainSelectedInstOperands,
     /*   14045 */     // GIR_Coverage, 70577,
     /*   14045 */     GIR_EraseRootFromParent_Done,
     /*   14046 */   // Label 331: @14046
     /*   14046 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(14101), // Rule ID 69568 //
     /*   14051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14079 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14099 */     GIR_RootConstrainSelectedInstOperands,
     /*   14100 */     // GIR_Coverage, 69568,
     /*   14100 */     GIR_EraseRootFromParent_Done,
     /*   14101 */   // Label 332: @14101
     /*   14101 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(14156), // Rule ID 69569 //
     /*   14106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14134 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14154 */     GIR_RootConstrainSelectedInstOperands,
     /*   14155 */     // GIR_Coverage, 69569,
     /*   14155 */     GIR_EraseRootFromParent_Done,
     /*   14156 */   // Label 333: @14156
     /*   14156 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(14211), // Rule ID 69176 //
     /*   14161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14176 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14189 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14209 */     GIR_RootConstrainSelectedInstOperands,
     /*   14210 */     // GIR_Coverage, 69176,
     /*   14210 */     GIR_EraseRootFromParent_Done,
     /*   14211 */   // Label 334: @14211
     /*   14211 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(14266), // Rule ID 69177 //
     /*   14216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14231 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14244 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14264 */     GIR_RootConstrainSelectedInstOperands,
     /*   14265 */     // GIR_Coverage, 69177,
     /*   14265 */     GIR_EraseRootFromParent_Done,
     /*   14266 */   // Label 335: @14266
     /*   14266 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(14321), // Rule ID 69478 //
     /*   14271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14286 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14299 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14319 */     GIR_RootConstrainSelectedInstOperands,
     /*   14320 */     // GIR_Coverage, 69478,
     /*   14320 */     GIR_EraseRootFromParent_Done,
     /*   14321 */   // Label 336: @14321
     /*   14321 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(14376), // Rule ID 69479 //
     /*   14326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14341 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14354 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14374 */     GIR_RootConstrainSelectedInstOperands,
     /*   14375 */     // GIR_Coverage, 69479,
     /*   14375 */     GIR_EraseRootFromParent_Done,
     /*   14376 */   // Label 337: @14376
     /*   14376 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(14444), // Rule ID 51862 //
     /*   14381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14404 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14418 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   14418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14442 */     GIR_RootConstrainSelectedInstOperands,
     /*   14443 */     // GIR_Coverage, 51862,
     /*   14443 */     GIR_EraseRootFromParent_Done,
     /*   14444 */   // Label 338: @14444
     /*   14444 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(14512), // Rule ID 51863 //
     /*   14449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14472 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14486 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   14486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14510 */     GIR_RootConstrainSelectedInstOperands,
     /*   14511 */     // GIR_Coverage, 51863,
     /*   14511 */     GIR_EraseRootFromParent_Done,
     /*   14512 */   // Label 339: @14512
     /*   14512 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(14567), // Rule ID 46728 //
     /*   14517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14545 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14565 */     GIR_RootConstrainSelectedInstOperands,
     /*   14566 */     // GIR_Coverage, 46728,
     /*   14566 */     GIR_EraseRootFromParent_Done,
     /*   14567 */   // Label 340: @14567
     /*   14567 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(14622), // Rule ID 46729 //
     /*   14572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14591 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14600 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14620 */     GIR_RootConstrainSelectedInstOperands,
     /*   14621 */     // GIR_Coverage, 46729,
     /*   14621 */     GIR_EraseRootFromParent_Done,
     /*   14622 */   // Label 341: @14622
     /*   14622 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(14677), // Rule ID 45818 //
     /*   14627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14646 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14655 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14675 */     GIR_RootConstrainSelectedInstOperands,
     /*   14676 */     // GIR_Coverage, 45818,
     /*   14676 */     GIR_EraseRootFromParent_Done,
     /*   14677 */   // Label 342: @14677
     /*   14677 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(14732), // Rule ID 45819 //
     /*   14682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14701 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14710 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14730 */     GIR_RootConstrainSelectedInstOperands,
     /*   14731 */     // GIR_Coverage, 45819,
     /*   14731 */     GIR_EraseRootFromParent_Done,
     /*   14732 */   // Label 343: @14732
     /*   14732 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(14787), // Rule ID 46608 //
     /*   14737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14756 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14765 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14785 */     GIR_RootConstrainSelectedInstOperands,
     /*   14786 */     // GIR_Coverage, 46608,
     /*   14786 */     GIR_EraseRootFromParent_Done,
     /*   14787 */   // Label 344: @14787
     /*   14787 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(14842), // Rule ID 46609 //
     /*   14792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14811 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14820 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14840 */     GIR_RootConstrainSelectedInstOperands,
     /*   14841 */     // GIR_Coverage, 46609,
     /*   14841 */     GIR_EraseRootFromParent_Done,
     /*   14842 */   // Label 345: @14842
     /*   14842 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(14895), // Rule ID 46094 //
     /*   14847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14858 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   14858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   14875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14893 */     GIR_RootConstrainSelectedInstOperands,
     /*   14894 */     // GIR_Coverage, 46094,
     /*   14894 */     GIR_EraseRootFromParent_Done,
     /*   14895 */   // Label 346: @14895
     /*   14895 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(14948), // Rule ID 46095 //
     /*   14900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14911 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   14911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   14928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14946 */     GIR_RootConstrainSelectedInstOperands,
     /*   14947 */     // GIR_Coverage, 46095,
     /*   14947 */     GIR_EraseRootFromParent_Done,
     /*   14948 */   // Label 347: @14948
     /*   14948 */   GIM_Reject,
     /*   14949 */ // Label 307: @14949
     /*   14949 */ GIM_Reject,
     /*   14950 */ // Label 130: @14950
     /*   14950 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(18074),
     /*   14955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   14961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14965 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15061), // Rule ID 70782 //
     /*   14970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   14989 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15018 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15022 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15024 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15035 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15059 */     GIR_RootConstrainSelectedInstOperands,
     /*   15060 */     // GIR_Coverage, 70782,
     /*   15060 */     GIR_EraseRootFromParent_Done,
     /*   15061 */   // Label 349: @15061
     /*   15061 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15157), // Rule ID 70783 //
     /*   15066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15085 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15099 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15114 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15118 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15120 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15131 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15155 */     GIR_RootConstrainSelectedInstOperands,
     /*   15156 */     // GIR_Coverage, 70783,
     /*   15156 */     GIR_EraseRootFromParent_Done,
     /*   15157 */   // Label 350: @15157
     /*   15157 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15253), // Rule ID 71042 //
     /*   15162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15181 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15195 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15210 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15214 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15216 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15227 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15251 */     GIR_RootConstrainSelectedInstOperands,
     /*   15252 */     // GIR_Coverage, 71042,
     /*   15252 */     GIR_EraseRootFromParent_Done,
     /*   15253 */   // Label 351: @15253
     /*   15253 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15349), // Rule ID 71043 //
     /*   15258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15277 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15291 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15306 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15310 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15312 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15323 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15347 */     GIR_RootConstrainSelectedInstOperands,
     /*   15348 */     // GIR_Coverage, 71043,
     /*   15348 */     GIR_EraseRootFromParent_Done,
     /*   15349 */   // Label 352: @15349
     /*   15349 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15445), // Rule ID 71044 //
     /*   15354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15373 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15387 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15402 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15406 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15408 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15419 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   15430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   15434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15443 */     GIR_RootConstrainSelectedInstOperands,
     /*   15444 */     // GIR_Coverage, 71044,
     /*   15444 */     GIR_EraseRootFromParent_Done,
     /*   15445 */   // Label 353: @15445
     /*   15445 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15541), // Rule ID 71045 //
     /*   15450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15483 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15498 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15502 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15504 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15513 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15515 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   15526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   15530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15539 */     GIR_RootConstrainSelectedInstOperands,
     /*   15540 */     // GIR_Coverage, 71045,
     /*   15540 */     GIR_EraseRootFromParent_Done,
     /*   15541 */   // Label 354: @15541
     /*   15541 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15637), // Rule ID 70896 //
     /*   15546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15565 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15579 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15594 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15598 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15600 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15609 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15611 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   15614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15635 */     GIR_RootConstrainSelectedInstOperands,
     /*   15636 */     // GIR_Coverage, 70896,
     /*   15636 */     GIR_EraseRootFromParent_Done,
     /*   15637 */   // Label 355: @15637
     /*   15637 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(15733), // Rule ID 70897 //
     /*   15642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15675 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15690 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15694 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15696 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15707 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   15710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15731 */     GIR_RootConstrainSelectedInstOperands,
     /*   15732 */     // GIR_Coverage, 70897,
     /*   15732 */     GIR_EraseRootFromParent_Done,
     /*   15733 */   // Label 356: @15733
     /*   15733 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(15829), // Rule ID 52036 //
     /*   15738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15761 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15775 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15794 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15796 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15801 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15803 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15827 */     GIR_RootConstrainSelectedInstOperands,
     /*   15828 */     // GIR_Coverage, 52036,
     /*   15828 */     GIR_EraseRootFromParent_Done,
     /*   15829 */   // Label 357: @15829
     /*   15829 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(15925), // Rule ID 52037 //
     /*   15834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15857 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15871 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15886 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15890 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15892 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15897 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15899 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15923 */     GIR_RootConstrainSelectedInstOperands,
     /*   15924 */     // GIR_Coverage, 52037,
     /*   15924 */     GIR_EraseRootFromParent_Done,
     /*   15925 */   // Label 358: @15925
     /*   15925 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16021), // Rule ID 52154 //
     /*   15930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15953 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15967 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15982 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15986 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15988 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15995 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16019 */     GIR_RootConstrainSelectedInstOperands,
     /*   16020 */     // GIR_Coverage, 52154,
     /*   16020 */     GIR_EraseRootFromParent_Done,
     /*   16021 */   // Label 359: @16021
     /*   16021 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16117), // Rule ID 52155 //
     /*   16026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16049 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16063 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16082 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16084 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16091 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16115 */     GIR_RootConstrainSelectedInstOperands,
     /*   16116 */     // GIR_Coverage, 52155,
     /*   16116 */     GIR_EraseRootFromParent_Done,
     /*   16117 */   // Label 360: @16117
     /*   16117 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16213), // Rule ID 71040 //
     /*   16122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16145 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16159 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16174 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16178 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16180 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16185 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16187 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   16198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   16202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16211 */     GIR_RootConstrainSelectedInstOperands,
     /*   16212 */     // GIR_Coverage, 71040,
     /*   16212 */     GIR_EraseRootFromParent_Done,
     /*   16213 */   // Label 361: @16213
     /*   16213 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16309), // Rule ID 71041 //
     /*   16218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16241 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16255 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16270 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16274 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16276 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16283 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   16294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   16298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16307 */     GIR_RootConstrainSelectedInstOperands,
     /*   16308 */     // GIR_Coverage, 71041,
     /*   16308 */     GIR_EraseRootFromParent_Done,
     /*   16309 */   // Label 362: @16309
     /*   16309 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16405), // Rule ID 52094 //
     /*   16314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16337 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16351 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16366 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16370 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16372 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16379 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16403 */     GIR_RootConstrainSelectedInstOperands,
     /*   16404 */     // GIR_Coverage, 52094,
     /*   16404 */     GIR_EraseRootFromParent_Done,
     /*   16405 */   // Label 363: @16405
     /*   16405 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16501), // Rule ID 52095 //
     /*   16410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16433 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16447 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16462 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16466 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16468 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16475 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16499 */     GIR_RootConstrainSelectedInstOperands,
     /*   16500 */     // GIR_Coverage, 52095,
     /*   16500 */     GIR_EraseRootFromParent_Done,
     /*   16501 */   // Label 364: @16501
     /*   16501 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16590), // Rule ID 46692 //
     /*   16506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16540 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16549 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   16566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16588 */     GIR_RootConstrainSelectedInstOperands,
     /*   16589 */     // GIR_Coverage, 46692,
     /*   16589 */     GIR_EraseRootFromParent_Done,
     /*   16590 */   // Label 365: @16590
     /*   16590 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16679), // Rule ID 46693 //
     /*   16595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16610 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16629 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16638 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   16655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16677 */     GIR_RootConstrainSelectedInstOperands,
     /*   16678 */     // GIR_Coverage, 46693,
     /*   16678 */     GIR_EraseRootFromParent_Done,
     /*   16679 */   // Label 366: @16679
     /*   16679 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16768), // Rule ID 46456 //
     /*   16684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16699 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16718 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16727 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   16744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16766 */     GIR_RootConstrainSelectedInstOperands,
     /*   16767 */     // GIR_Coverage, 46456,
     /*   16767 */     GIR_EraseRootFromParent_Done,
     /*   16768 */   // Label 367: @16768
     /*   16768 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16857), // Rule ID 46457 //
     /*   16773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16807 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16816 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   16833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16855 */     GIR_RootConstrainSelectedInstOperands,
     /*   16856 */     // GIR_Coverage, 46457,
     /*   16856 */     GIR_EraseRootFromParent_Done,
     /*   16857 */   // Label 368: @16857
     /*   16857 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16946), // Rule ID 46572 //
     /*   16862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16896 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16905 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   16922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16944 */     GIR_RootConstrainSelectedInstOperands,
     /*   16945 */     // GIR_Coverage, 46572,
     /*   16945 */     GIR_EraseRootFromParent_Done,
     /*   16946 */   // Label 369: @16946
     /*   16946 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17035), // Rule ID 46573 //
     /*   16951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16985 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16994 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   17011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17033 */     GIR_RootConstrainSelectedInstOperands,
     /*   17034 */     // GIR_Coverage, 46573,
     /*   17034 */     GIR_EraseRootFromParent_Done,
     /*   17035 */   // Label 370: @17035
     /*   17035 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17103), // Rule ID 70592 //
     /*   17040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17059 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17077 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   17077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17101 */     GIR_RootConstrainSelectedInstOperands,
     /*   17102 */     // GIR_Coverage, 70592,
     /*   17102 */     GIR_EraseRootFromParent_Done,
     /*   17103 */   // Label 371: @17103
     /*   17103 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17171), // Rule ID 70593 //
     /*   17108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17127 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17145 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   17145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17169 */     GIR_RootConstrainSelectedInstOperands,
     /*   17170 */     // GIR_Coverage, 70593,
     /*   17170 */     GIR_EraseRootFromParent_Done,
     /*   17171 */   // Label 372: @17171
     /*   17171 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17226), // Rule ID 69592 //
     /*   17176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17191 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17204 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17224 */     GIR_RootConstrainSelectedInstOperands,
     /*   17225 */     // GIR_Coverage, 69592,
     /*   17225 */     GIR_EraseRootFromParent_Done,
     /*   17226 */   // Label 373: @17226
     /*   17226 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17281), // Rule ID 69593 //
     /*   17231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17259 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17279 */     GIR_RootConstrainSelectedInstOperands,
     /*   17280 */     // GIR_Coverage, 69593,
     /*   17280 */     GIR_EraseRootFromParent_Done,
     /*   17281 */   // Label 374: @17281
     /*   17281 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17336), // Rule ID 69412 //
     /*   17286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17314 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17334 */     GIR_RootConstrainSelectedInstOperands,
     /*   17335 */     // GIR_Coverage, 69412,
     /*   17335 */     GIR_EraseRootFromParent_Done,
     /*   17336 */   // Label 375: @17336
     /*   17336 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17391), // Rule ID 69413 //
     /*   17341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17356 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17369 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17389 */     GIR_RootConstrainSelectedInstOperands,
     /*   17390 */     // GIR_Coverage, 69413,
     /*   17390 */     GIR_EraseRootFromParent_Done,
     /*   17391 */   // Label 376: @17391
     /*   17391 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17446), // Rule ID 69502 //
     /*   17396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17424 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17444 */     GIR_RootConstrainSelectedInstOperands,
     /*   17445 */     // GIR_Coverage, 69502,
     /*   17445 */     GIR_EraseRootFromParent_Done,
     /*   17446 */   // Label 377: @17446
     /*   17446 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17501), // Rule ID 69503 //
     /*   17451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17466 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17479 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17499 */     GIR_RootConstrainSelectedInstOperands,
     /*   17500 */     // GIR_Coverage, 69503,
     /*   17500 */     GIR_EraseRootFromParent_Done,
     /*   17501 */   // Label 378: @17501
     /*   17501 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17569), // Rule ID 51870 //
     /*   17506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17529 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17543 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   17543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17567 */     GIR_RootConstrainSelectedInstOperands,
     /*   17568 */     // GIR_Coverage, 51870,
     /*   17568 */     GIR_EraseRootFromParent_Done,
     /*   17569 */   // Label 379: @17569
     /*   17569 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17637), // Rule ID 51871 //
     /*   17574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17597 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17611 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   17611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17635 */     GIR_RootConstrainSelectedInstOperands,
     /*   17636 */     // GIR_Coverage, 51871,
     /*   17636 */     GIR_EraseRootFromParent_Done,
     /*   17637 */   // Label 380: @17637
     /*   17637 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17692), // Rule ID 46752 //
     /*   17642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17670 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17690 */     GIR_RootConstrainSelectedInstOperands,
     /*   17691 */     // GIR_Coverage, 46752,
     /*   17691 */     GIR_EraseRootFromParent_Done,
     /*   17692 */   // Label 381: @17692
     /*   17692 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17747), // Rule ID 46753 //
     /*   17697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17725 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17745 */     GIR_RootConstrainSelectedInstOperands,
     /*   17746 */     // GIR_Coverage, 46753,
     /*   17746 */     GIR_EraseRootFromParent_Done,
     /*   17747 */   // Label 382: @17747
     /*   17747 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17802), // Rule ID 46512 //
     /*   17752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17771 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17780 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17800 */     GIR_RootConstrainSelectedInstOperands,
     /*   17801 */     // GIR_Coverage, 46512,
     /*   17801 */     GIR_EraseRootFromParent_Done,
     /*   17802 */   // Label 383: @17802
     /*   17802 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17857), // Rule ID 46513 //
     /*   17807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17826 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17835 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17855 */     GIR_RootConstrainSelectedInstOperands,
     /*   17856 */     // GIR_Coverage, 46513,
     /*   17856 */     GIR_EraseRootFromParent_Done,
     /*   17857 */   // Label 384: @17857
     /*   17857 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17912), // Rule ID 46632 //
     /*   17862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17881 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17890 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17910 */     GIR_RootConstrainSelectedInstOperands,
     /*   17911 */     // GIR_Coverage, 46632,
     /*   17911 */     GIR_EraseRootFromParent_Done,
     /*   17912 */   // Label 385: @17912
     /*   17912 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17967), // Rule ID 46633 //
     /*   17917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17936 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17945 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17965 */     GIR_RootConstrainSelectedInstOperands,
     /*   17966 */     // GIR_Coverage, 46633,
     /*   17966 */     GIR_EraseRootFromParent_Done,
     /*   17967 */   // Label 386: @17967
     /*   17967 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18020), // Rule ID 46102 //
     /*   17972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17983 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   17983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   18000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18018 */     GIR_RootConstrainSelectedInstOperands,
     /*   18019 */     // GIR_Coverage, 46102,
     /*   18019 */     GIR_EraseRootFromParent_Done,
     /*   18020 */   // Label 387: @18020
     /*   18020 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18073), // Rule ID 46103 //
     /*   18025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18036 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   18036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   18039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   18053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18071 */     GIR_RootConstrainSelectedInstOperands,
     /*   18072 */     // GIR_Coverage, 46103,
     /*   18072 */     GIR_EraseRootFromParent_Done,
     /*   18073 */   // Label 388: @18073
     /*   18073 */   GIM_Reject,
     /*   18074 */ // Label 348: @18074
     /*   18074 */ GIM_Reject,
     /*   18075 */ // Label 131: @18075
     /*   18075 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(21199),
     /*   18080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18090 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18186), // Rule ID 70792 //
     /*   18095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18114 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18128 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18147 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18149 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18160 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18184 */     GIR_RootConstrainSelectedInstOperands,
     /*   18185 */     // GIR_Coverage, 70792,
     /*   18185 */     GIR_EraseRootFromParent_Done,
     /*   18186 */   // Label 390: @18186
     /*   18186 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18282), // Rule ID 70793 //
     /*   18191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18224 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18239 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18243 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18245 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18256 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18280 */     GIR_RootConstrainSelectedInstOperands,
     /*   18281 */     // GIR_Coverage, 70793,
     /*   18281 */     GIR_EraseRootFromParent_Done,
     /*   18282 */   // Label 391: @18282
     /*   18282 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18378), // Rule ID 71072 //
     /*   18287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18320 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18335 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18339 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18341 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18352 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18376 */     GIR_RootConstrainSelectedInstOperands,
     /*   18377 */     // GIR_Coverage, 71072,
     /*   18377 */     GIR_EraseRootFromParent_Done,
     /*   18378 */   // Label 392: @18378
     /*   18378 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18474), // Rule ID 71073 //
     /*   18383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18402 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18416 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18431 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18435 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18437 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18448 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18472 */     GIR_RootConstrainSelectedInstOperands,
     /*   18473 */     // GIR_Coverage, 71073,
     /*   18473 */     GIR_EraseRootFromParent_Done,
     /*   18474 */   // Label 393: @18474
     /*   18474 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18570), // Rule ID 71074 //
     /*   18479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18498 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18512 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18527 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18531 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18533 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18544 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   18555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   18559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18568 */     GIR_RootConstrainSelectedInstOperands,
     /*   18569 */     // GIR_Coverage, 71074,
     /*   18569 */     GIR_EraseRootFromParent_Done,
     /*   18570 */   // Label 394: @18570
     /*   18570 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18666), // Rule ID 71075 //
     /*   18575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18594 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18608 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18623 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18627 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18629 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18640 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   18651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   18655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18664 */     GIR_RootConstrainSelectedInstOperands,
     /*   18665 */     // GIR_Coverage, 71075,
     /*   18665 */     GIR_EraseRootFromParent_Done,
     /*   18666 */   // Label 395: @18666
     /*   18666 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18762), // Rule ID 70906 //
     /*   18671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18690 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18704 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18719 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18723 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18725 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18736 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   18739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18760 */     GIR_RootConstrainSelectedInstOperands,
     /*   18761 */     // GIR_Coverage, 70906,
     /*   18761 */     GIR_EraseRootFromParent_Done,
     /*   18762 */   // Label 396: @18762
     /*   18762 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18858), // Rule ID 70907 //
     /*   18767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18800 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18815 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18819 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18821 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18832 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   18835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18856 */     GIR_RootConstrainSelectedInstOperands,
     /*   18857 */     // GIR_Coverage, 70907,
     /*   18857 */     GIR_EraseRootFromParent_Done,
     /*   18858 */   // Label 397: @18858
     /*   18858 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18954), // Rule ID 52046 //
     /*   18863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18886 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18900 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18915 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18919 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18921 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18928 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   18935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18952 */     GIR_RootConstrainSelectedInstOperands,
     /*   18953 */     // GIR_Coverage, 52046,
     /*   18953 */     GIR_EraseRootFromParent_Done,
     /*   18954 */   // Label 398: @18954
     /*   18954 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(19050), // Rule ID 52047 //
     /*   18959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18982 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18996 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19011 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19015 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19017 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19024 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   19027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19048 */     GIR_RootConstrainSelectedInstOperands,
     /*   19049 */     // GIR_Coverage, 52047,
     /*   19049 */     GIR_EraseRootFromParent_Done,
     /*   19050 */   // Label 399: @19050
     /*   19050 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(19146), // Rule ID 52164 //
     /*   19055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19078 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19092 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19107 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19111 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19113 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19120 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19144 */     GIR_RootConstrainSelectedInstOperands,
     /*   19145 */     // GIR_Coverage, 52164,
     /*   19145 */     GIR_EraseRootFromParent_Done,
     /*   19146 */   // Label 400: @19146
     /*   19146 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(19242), // Rule ID 52165 //
     /*   19151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19174 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19188 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19203 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19207 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19209 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19216 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19240 */     GIR_RootConstrainSelectedInstOperands,
     /*   19241 */     // GIR_Coverage, 52165,
     /*   19241 */     GIR_EraseRootFromParent_Done,
     /*   19242 */   // Label 401: @19242
     /*   19242 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(19338), // Rule ID 71070 //
     /*   19247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19270 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19284 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19299 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19303 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19305 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19312 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19336 */     GIR_RootConstrainSelectedInstOperands,
     /*   19337 */     // GIR_Coverage, 71070,
     /*   19337 */     GIR_EraseRootFromParent_Done,
     /*   19338 */   // Label 402: @19338
     /*   19338 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(19434), // Rule ID 71071 //
     /*   19343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19380 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19399 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19401 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19408 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19432 */     GIR_RootConstrainSelectedInstOperands,
     /*   19433 */     // GIR_Coverage, 71071,
     /*   19433 */     GIR_EraseRootFromParent_Done,
     /*   19434 */   // Label 403: @19434
     /*   19434 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(19530), // Rule ID 52104 //
     /*   19439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19462 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19476 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19491 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19495 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19497 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19504 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19528 */     GIR_RootConstrainSelectedInstOperands,
     /*   19529 */     // GIR_Coverage, 52104,
     /*   19529 */     GIR_EraseRootFromParent_Done,
     /*   19530 */   // Label 404: @19530
     /*   19530 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(19626), // Rule ID 52105 //
     /*   19535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19572 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19591 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19593 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19600 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19624 */     GIR_RootConstrainSelectedInstOperands,
     /*   19625 */     // GIR_Coverage, 52105,
     /*   19625 */     GIR_EraseRootFromParent_Done,
     /*   19626 */   // Label 405: @19626
     /*   19626 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(19715), // Rule ID 46712 //
     /*   19631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19646 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19665 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19674 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   19674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   19691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19713 */     GIR_RootConstrainSelectedInstOperands,
     /*   19714 */     // GIR_Coverage, 46712,
     /*   19714 */     GIR_EraseRootFromParent_Done,
     /*   19715 */   // Label 406: @19715
     /*   19715 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(19804), // Rule ID 46713 //
     /*   19720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19735 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19754 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19763 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   19763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   19780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19802 */     GIR_RootConstrainSelectedInstOperands,
     /*   19803 */     // GIR_Coverage, 46713,
     /*   19803 */     GIR_EraseRootFromParent_Done,
     /*   19804 */   // Label 407: @19804
     /*   19804 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(19893), // Rule ID 46476 //
     /*   19809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19824 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19843 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19852 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   19852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   19869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19891 */     GIR_RootConstrainSelectedInstOperands,
     /*   19892 */     // GIR_Coverage, 46476,
     /*   19892 */     GIR_EraseRootFromParent_Done,
     /*   19893 */   // Label 408: @19893
     /*   19893 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(19982), // Rule ID 46477 //
     /*   19898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19913 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19932 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19941 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   19941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   19958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19980 */     GIR_RootConstrainSelectedInstOperands,
     /*   19981 */     // GIR_Coverage, 46477,
     /*   19981 */     GIR_EraseRootFromParent_Done,
     /*   19982 */   // Label 409: @19982
     /*   19982 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(20071), // Rule ID 46592 //
     /*   19987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20021 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20030 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   20030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20069 */     GIR_RootConstrainSelectedInstOperands,
     /*   20070 */     // GIR_Coverage, 46592,
     /*   20070 */     GIR_EraseRootFromParent_Done,
     /*   20071 */   // Label 410: @20071
     /*   20071 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(20160), // Rule ID 46593 //
     /*   20076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20091 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20110 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20119 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   20119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20158 */     GIR_RootConstrainSelectedInstOperands,
     /*   20159 */     // GIR_Coverage, 46593,
     /*   20159 */     GIR_EraseRootFromParent_Done,
     /*   20160 */   // Label 411: @20160
     /*   20160 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(20228), // Rule ID 70624 //
     /*   20165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   20168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20184 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20202 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   20202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20226 */     GIR_RootConstrainSelectedInstOperands,
     /*   20227 */     // GIR_Coverage, 70624,
     /*   20227 */     GIR_EraseRootFromParent_Done,
     /*   20228 */   // Label 412: @20228
     /*   20228 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(20296), // Rule ID 70625 //
     /*   20233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   20236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20252 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20270 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   20270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20294 */     GIR_RootConstrainSelectedInstOperands,
     /*   20295 */     // GIR_Coverage, 70625,
     /*   20295 */     GIR_EraseRootFromParent_Done,
     /*   20296 */   // Label 413: @20296
     /*   20296 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(20351), // Rule ID 69612 //
     /*   20301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20329 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20349 */     GIR_RootConstrainSelectedInstOperands,
     /*   20350 */     // GIR_Coverage, 69612,
     /*   20350 */     GIR_EraseRootFromParent_Done,
     /*   20351 */   // Label 414: @20351
     /*   20351 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(20406), // Rule ID 69613 //
     /*   20356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20384 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20404 */     GIR_RootConstrainSelectedInstOperands,
     /*   20405 */     // GIR_Coverage, 69613,
     /*   20405 */     GIR_EraseRootFromParent_Done,
     /*   20406 */   // Label 415: @20406
     /*   20406 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(20461), // Rule ID 69432 //
     /*   20411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20439 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20459 */     GIR_RootConstrainSelectedInstOperands,
     /*   20460 */     // GIR_Coverage, 69432,
     /*   20460 */     GIR_EraseRootFromParent_Done,
     /*   20461 */   // Label 416: @20461
     /*   20461 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(20516), // Rule ID 69433 //
     /*   20466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20481 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20494 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20514 */     GIR_RootConstrainSelectedInstOperands,
     /*   20515 */     // GIR_Coverage, 69433,
     /*   20515 */     GIR_EraseRootFromParent_Done,
     /*   20516 */   // Label 417: @20516
     /*   20516 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(20571), // Rule ID 69522 //
     /*   20521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20549 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20569 */     GIR_RootConstrainSelectedInstOperands,
     /*   20570 */     // GIR_Coverage, 69522,
     /*   20570 */     GIR_EraseRootFromParent_Done,
     /*   20571 */   // Label 418: @20571
     /*   20571 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(20626), // Rule ID 69523 //
     /*   20576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20591 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20604 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20624 */     GIR_RootConstrainSelectedInstOperands,
     /*   20625 */     // GIR_Coverage, 69523,
     /*   20625 */     GIR_EraseRootFromParent_Done,
     /*   20626 */   // Label 419: @20626
     /*   20626 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(20694), // Rule ID 51886 //
     /*   20631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   20634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20654 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20668 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   20668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20692 */     GIR_RootConstrainSelectedInstOperands,
     /*   20693 */     // GIR_Coverage, 51886,
     /*   20693 */     GIR_EraseRootFromParent_Done,
     /*   20694 */   // Label 420: @20694
     /*   20694 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(20762), // Rule ID 51887 //
     /*   20699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   20702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20736 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   20736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20760 */     GIR_RootConstrainSelectedInstOperands,
     /*   20761 */     // GIR_Coverage, 51887,
     /*   20761 */     GIR_EraseRootFromParent_Done,
     /*   20762 */   // Label 421: @20762
     /*   20762 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(20817), // Rule ID 46772 //
     /*   20767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20795 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20815 */     GIR_RootConstrainSelectedInstOperands,
     /*   20816 */     // GIR_Coverage, 46772,
     /*   20816 */     GIR_EraseRootFromParent_Done,
     /*   20817 */   // Label 422: @20817
     /*   20817 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(20872), // Rule ID 46773 //
     /*   20822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20850 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20870 */     GIR_RootConstrainSelectedInstOperands,
     /*   20871 */     // GIR_Coverage, 46773,
     /*   20871 */     GIR_EraseRootFromParent_Done,
     /*   20872 */   // Label 423: @20872
     /*   20872 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(20927), // Rule ID 46532 //
     /*   20877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20905 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20925 */     GIR_RootConstrainSelectedInstOperands,
     /*   20926 */     // GIR_Coverage, 46532,
     /*   20926 */     GIR_EraseRootFromParent_Done,
     /*   20927 */   // Label 424: @20927
     /*   20927 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20982), // Rule ID 46533 //
     /*   20932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20951 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20960 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20980 */     GIR_RootConstrainSelectedInstOperands,
     /*   20981 */     // GIR_Coverage, 46533,
     /*   20981 */     GIR_EraseRootFromParent_Done,
     /*   20982 */   // Label 425: @20982
     /*   20982 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(21037), // Rule ID 46652 //
     /*   20987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21006 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21015 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   21015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21035 */     GIR_RootConstrainSelectedInstOperands,
     /*   21036 */     // GIR_Coverage, 46652,
     /*   21036 */     GIR_EraseRootFromParent_Done,
     /*   21037 */   // Label 426: @21037
     /*   21037 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(21092), // Rule ID 46653 //
     /*   21042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   21045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21061 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21070 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   21070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21090 */     GIR_RootConstrainSelectedInstOperands,
     /*   21091 */     // GIR_Coverage, 46653,
     /*   21091 */     GIR_EraseRootFromParent_Done,
     /*   21092 */   // Label 427: @21092
     /*   21092 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(21145), // Rule ID 46118 //
     /*   21097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   21100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21108 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   21108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   21125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21143 */     GIR_RootConstrainSelectedInstOperands,
     /*   21144 */     // GIR_Coverage, 46118,
     /*   21144 */     GIR_EraseRootFromParent_Done,
     /*   21145 */   // Label 428: @21145
     /*   21145 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(21198), // Rule ID 46119 //
     /*   21150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   21153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21161 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   21161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   21178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21196 */     GIR_RootConstrainSelectedInstOperands,
     /*   21197 */     // GIR_Coverage, 46119,
     /*   21197 */     GIR_EraseRootFromParent_Done,
     /*   21198 */   // Label 429: @21198
     /*   21198 */   GIM_Reject,
     /*   21199 */ // Label 389: @21199
     /*   21199 */ GIM_Reject,
     /*   21200 */ // Label 132: @21200
     /*   21200 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(21594),
     /*   21205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21215 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(21283), // Rule ID 70560 //
     /*   21220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21239 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21257 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21281 */     GIR_RootConstrainSelectedInstOperands,
     /*   21282 */     // GIR_Coverage, 70560,
     /*   21282 */     GIR_EraseRootFromParent_Done,
     /*   21283 */   // Label 431: @21283
     /*   21283 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(21351), // Rule ID 70561 //
     /*   21288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21307 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21325 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21349 */     GIR_RootConstrainSelectedInstOperands,
     /*   21350 */     // GIR_Coverage, 70561,
     /*   21350 */     GIR_EraseRootFromParent_Done,
     /*   21351 */   // Label 432: @21351
     /*   21351 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21419), // Rule ID 51854 //
     /*   21356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21379 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21393 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21417 */     GIR_RootConstrainSelectedInstOperands,
     /*   21418 */     // GIR_Coverage, 51854,
     /*   21418 */     GIR_EraseRootFromParent_Done,
     /*   21419 */   // Label 433: @21419
     /*   21419 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21487), // Rule ID 51855 //
     /*   21424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21447 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21461 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21485 */     GIR_RootConstrainSelectedInstOperands,
     /*   21486 */     // GIR_Coverage, 51855,
     /*   21486 */     GIR_EraseRootFromParent_Done,
     /*   21487 */   // Label 434: @21487
     /*   21487 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21540), // Rule ID 46086 //
     /*   21492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21503 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   21503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   21506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   21520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21538 */     GIR_RootConstrainSelectedInstOperands,
     /*   21539 */     // GIR_Coverage, 46086,
     /*   21539 */     GIR_EraseRootFromParent_Done,
     /*   21540 */   // Label 435: @21540
     /*   21540 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21593), // Rule ID 46087 //
     /*   21545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21556 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   21556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   21559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   21573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21591 */     GIR_RootConstrainSelectedInstOperands,
     /*   21592 */     // GIR_Coverage, 46087,
     /*   21592 */     GIR_EraseRootFromParent_Done,
     /*   21593 */   // Label 436: @21593
     /*   21593 */   GIM_Reject,
     /*   21594 */ // Label 430: @21594
     /*   21594 */ GIM_Reject,
     /*   21595 */ // Label 133: @21595
     /*   21595 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(24719),
     /*   21600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21610 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21706), // Rule ID 70772 //
     /*   21615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21634 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21648 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21663 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21667 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21669 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21680 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   21683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21704 */     GIR_RootConstrainSelectedInstOperands,
     /*   21705 */     // GIR_Coverage, 70772,
     /*   21705 */     GIR_EraseRootFromParent_Done,
     /*   21706 */   // Label 438: @21706
     /*   21706 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21802), // Rule ID 70773 //
     /*   21711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21744 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21763 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21765 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21776 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   21779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21800 */     GIR_RootConstrainSelectedInstOperands,
     /*   21801 */     // GIR_Coverage, 70773,
     /*   21801 */     GIR_EraseRootFromParent_Done,
     /*   21802 */   // Label 439: @21802
     /*   21802 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21898), // Rule ID 71012 //
     /*   21807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21826 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21840 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21855 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21859 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21861 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21872 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   21875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21896 */     GIR_RootConstrainSelectedInstOperands,
     /*   21897 */     // GIR_Coverage, 71012,
     /*   21897 */     GIR_EraseRootFromParent_Done,
     /*   21898 */   // Label 440: @21898
     /*   21898 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(21994), // Rule ID 71013 //
     /*   21903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21922 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21936 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21951 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21955 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21957 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21968 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   21971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21992 */     GIR_RootConstrainSelectedInstOperands,
     /*   21993 */     // GIR_Coverage, 71013,
     /*   21993 */     GIR_EraseRootFromParent_Done,
     /*   21994 */   // Label 441: @21994
     /*   21994 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22090), // Rule ID 71014 //
     /*   21999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22018 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22032 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22047 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22051 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22053 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22064 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22088 */     GIR_RootConstrainSelectedInstOperands,
     /*   22089 */     // GIR_Coverage, 71014,
     /*   22089 */     GIR_EraseRootFromParent_Done,
     /*   22090 */   // Label 442: @22090
     /*   22090 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22186), // Rule ID 71015 //
     /*   22095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22114 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22128 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22147 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22149 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22160 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22184 */     GIR_RootConstrainSelectedInstOperands,
     /*   22185 */     // GIR_Coverage, 71015,
     /*   22185 */     GIR_EraseRootFromParent_Done,
     /*   22186 */   // Label 443: @22186
     /*   22186 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22282), // Rule ID 70886 //
     /*   22191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22224 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22239 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22243 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22245 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22256 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   22259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22280 */     GIR_RootConstrainSelectedInstOperands,
     /*   22281 */     // GIR_Coverage, 70886,
     /*   22281 */     GIR_EraseRootFromParent_Done,
     /*   22282 */   // Label 444: @22282
     /*   22282 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22378), // Rule ID 70887 //
     /*   22287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22320 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22335 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22339 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22341 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22352 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   22355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22376 */     GIR_RootConstrainSelectedInstOperands,
     /*   22377 */     // GIR_Coverage, 70887,
     /*   22377 */     GIR_EraseRootFromParent_Done,
     /*   22378 */   // Label 445: @22378
     /*   22378 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22474), // Rule ID 52026 //
     /*   22383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22406 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22435 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22439 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22441 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22448 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22472 */     GIR_RootConstrainSelectedInstOperands,
     /*   22473 */     // GIR_Coverage, 52026,
     /*   22473 */     GIR_EraseRootFromParent_Done,
     /*   22474 */   // Label 446: @22474
     /*   22474 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22570), // Rule ID 52027 //
     /*   22479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22502 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22516 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22531 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22535 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22537 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22544 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22568 */     GIR_RootConstrainSelectedInstOperands,
     /*   22569 */     // GIR_Coverage, 52027,
     /*   22569 */     GIR_EraseRootFromParent_Done,
     /*   22570 */   // Label 447: @22570
     /*   22570 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22666), // Rule ID 52144 //
     /*   22575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22598 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22612 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22627 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22631 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22633 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22640 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22664 */     GIR_RootConstrainSelectedInstOperands,
     /*   22665 */     // GIR_Coverage, 52144,
     /*   22665 */     GIR_EraseRootFromParent_Done,
     /*   22666 */   // Label 448: @22666
     /*   22666 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22762), // Rule ID 52145 //
     /*   22671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22694 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22708 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22723 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22727 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22729 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22736 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22760 */     GIR_RootConstrainSelectedInstOperands,
     /*   22761 */     // GIR_Coverage, 52145,
     /*   22761 */     GIR_EraseRootFromParent_Done,
     /*   22762 */   // Label 449: @22762
     /*   22762 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22858), // Rule ID 71010 //
     /*   22767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22790 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22804 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22819 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22823 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22825 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22832 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22856 */     GIR_RootConstrainSelectedInstOperands,
     /*   22857 */     // GIR_Coverage, 71010,
     /*   22857 */     GIR_EraseRootFromParent_Done,
     /*   22858 */   // Label 450: @22858
     /*   22858 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22954), // Rule ID 71011 //
     /*   22863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22886 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22900 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22915 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22919 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22921 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22928 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22952 */     GIR_RootConstrainSelectedInstOperands,
     /*   22953 */     // GIR_Coverage, 71011,
     /*   22953 */     GIR_EraseRootFromParent_Done,
     /*   22954 */   // Label 451: @22954
     /*   22954 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(23050), // Rule ID 52084 //
     /*   22959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22982 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22996 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23011 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23015 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23017 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23024 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   23027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23048 */     GIR_RootConstrainSelectedInstOperands,
     /*   23049 */     // GIR_Coverage, 52084,
     /*   23049 */     GIR_EraseRootFromParent_Done,
     /*   23050 */   // Label 452: @23050
     /*   23050 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23146), // Rule ID 52085 //
     /*   23055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23078 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23092 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23107 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23111 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23113 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23120 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   23123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23144 */     GIR_RootConstrainSelectedInstOperands,
     /*   23145 */     // GIR_Coverage, 52085,
     /*   23145 */     GIR_EraseRootFromParent_Done,
     /*   23146 */   // Label 453: @23146
     /*   23146 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23235), // Rule ID 46672 //
     /*   23151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23166 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23185 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23194 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23233 */     GIR_RootConstrainSelectedInstOperands,
     /*   23234 */     // GIR_Coverage, 46672,
     /*   23234 */     GIR_EraseRootFromParent_Done,
     /*   23235 */   // Label 454: @23235
     /*   23235 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23324), // Rule ID 46673 //
     /*   23240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23255 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23274 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23283 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23322 */     GIR_RootConstrainSelectedInstOperands,
     /*   23323 */     // GIR_Coverage, 46673,
     /*   23323 */     GIR_EraseRootFromParent_Done,
     /*   23324 */   // Label 455: @23324
     /*   23324 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23413), // Rule ID 46436 //
     /*   23329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23344 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23363 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23372 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   23389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23411 */     GIR_RootConstrainSelectedInstOperands,
     /*   23412 */     // GIR_Coverage, 46436,
     /*   23412 */     GIR_EraseRootFromParent_Done,
     /*   23413 */   // Label 456: @23413
     /*   23413 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23502), // Rule ID 46437 //
     /*   23418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23433 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23452 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23461 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   23478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23500 */     GIR_RootConstrainSelectedInstOperands,
     /*   23501 */     // GIR_Coverage, 46437,
     /*   23501 */     GIR_EraseRootFromParent_Done,
     /*   23502 */   // Label 457: @23502
     /*   23502 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23591), // Rule ID 46552 //
     /*   23507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23522 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23541 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23550 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23589 */     GIR_RootConstrainSelectedInstOperands,
     /*   23590 */     // GIR_Coverage, 46552,
     /*   23590 */     GIR_EraseRootFromParent_Done,
     /*   23591 */   // Label 458: @23591
     /*   23591 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23680), // Rule ID 46553 //
     /*   23596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23630 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23639 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23678 */     GIR_RootConstrainSelectedInstOperands,
     /*   23679 */     // GIR_Coverage, 46553,
     /*   23679 */     GIR_EraseRootFromParent_Done,
     /*   23680 */   // Label 459: @23680
     /*   23680 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23748), // Rule ID 70584 //
     /*   23685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23704 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23722 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   23722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   23725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   23731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23746 */     GIR_RootConstrainSelectedInstOperands,
     /*   23747 */     // GIR_Coverage, 70584,
     /*   23747 */     GIR_EraseRootFromParent_Done,
     /*   23748 */   // Label 460: @23748
     /*   23748 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23816), // Rule ID 70585 //
     /*   23753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23790 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   23790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   23793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   23799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23814 */     GIR_RootConstrainSelectedInstOperands,
     /*   23815 */     // GIR_Coverage, 70585,
     /*   23815 */     GIR_EraseRootFromParent_Done,
     /*   23816 */   // Label 461: @23816
     /*   23816 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23871), // Rule ID 69572 //
     /*   23821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23849 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   23852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23869 */     GIR_RootConstrainSelectedInstOperands,
     /*   23870 */     // GIR_Coverage, 69572,
     /*   23870 */     GIR_EraseRootFromParent_Done,
     /*   23871 */   // Label 462: @23871
     /*   23871 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23926), // Rule ID 69573 //
     /*   23876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23891 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23904 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   23907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23924 */     GIR_RootConstrainSelectedInstOperands,
     /*   23925 */     // GIR_Coverage, 69573,
     /*   23925 */     GIR_EraseRootFromParent_Done,
     /*   23926 */   // Label 463: @23926
     /*   23926 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23981), // Rule ID 69392 //
     /*   23931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23959 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   23962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23979 */     GIR_RootConstrainSelectedInstOperands,
     /*   23980 */     // GIR_Coverage, 69392,
     /*   23980 */     GIR_EraseRootFromParent_Done,
     /*   23981 */   // Label 464: @23981
     /*   23981 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(24036), // Rule ID 69393 //
     /*   23986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24001 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24014 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24034 */     GIR_RootConstrainSelectedInstOperands,
     /*   24035 */     // GIR_Coverage, 69393,
     /*   24035 */     GIR_EraseRootFromParent_Done,
     /*   24036 */   // Label 465: @24036
     /*   24036 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(24091), // Rule ID 69482 //
     /*   24041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24056 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24069 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24089 */     GIR_RootConstrainSelectedInstOperands,
     /*   24090 */     // GIR_Coverage, 69482,
     /*   24090 */     GIR_EraseRootFromParent_Done,
     /*   24091 */   // Label 466: @24091
     /*   24091 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(24146), // Rule ID 69483 //
     /*   24096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24111 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24124 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24144 */     GIR_RootConstrainSelectedInstOperands,
     /*   24145 */     // GIR_Coverage, 69483,
     /*   24145 */     GIR_EraseRootFromParent_Done,
     /*   24146 */   // Label 467: @24146
     /*   24146 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(24214), // Rule ID 51866 //
     /*   24151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24174 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24188 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24212 */     GIR_RootConstrainSelectedInstOperands,
     /*   24213 */     // GIR_Coverage, 51866,
     /*   24213 */     GIR_EraseRootFromParent_Done,
     /*   24214 */   // Label 468: @24214
     /*   24214 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(24282), // Rule ID 51867 //
     /*   24219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24242 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24256 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   24256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24280 */     GIR_RootConstrainSelectedInstOperands,
     /*   24281 */     // GIR_Coverage, 51867,
     /*   24281 */     GIR_EraseRootFromParent_Done,
     /*   24282 */   // Label 469: @24282
     /*   24282 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(24337), // Rule ID 46732 //
     /*   24287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24315 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24335 */     GIR_RootConstrainSelectedInstOperands,
     /*   24336 */     // GIR_Coverage, 46732,
     /*   24336 */     GIR_EraseRootFromParent_Done,
     /*   24337 */   // Label 470: @24337
     /*   24337 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(24392), // Rule ID 46733 //
     /*   24342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24370 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24390 */     GIR_RootConstrainSelectedInstOperands,
     /*   24391 */     // GIR_Coverage, 46733,
     /*   24391 */     GIR_EraseRootFromParent_Done,
     /*   24392 */   // Label 471: @24392
     /*   24392 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24447), // Rule ID 46492 //
     /*   24397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24416 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24425 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24445 */     GIR_RootConstrainSelectedInstOperands,
     /*   24446 */     // GIR_Coverage, 46492,
     /*   24446 */     GIR_EraseRootFromParent_Done,
     /*   24447 */   // Label 472: @24447
     /*   24447 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24502), // Rule ID 46493 //
     /*   24452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24471 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24480 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24500 */     GIR_RootConstrainSelectedInstOperands,
     /*   24501 */     // GIR_Coverage, 46493,
     /*   24501 */     GIR_EraseRootFromParent_Done,
     /*   24502 */   // Label 473: @24502
     /*   24502 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24557), // Rule ID 46612 //
     /*   24507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24526 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24535 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24555 */     GIR_RootConstrainSelectedInstOperands,
     /*   24556 */     // GIR_Coverage, 46612,
     /*   24556 */     GIR_EraseRootFromParent_Done,
     /*   24557 */   // Label 474: @24557
     /*   24557 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24612), // Rule ID 46613 //
     /*   24562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24581 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24590 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24610 */     GIR_RootConstrainSelectedInstOperands,
     /*   24611 */     // GIR_Coverage, 46613,
     /*   24611 */     GIR_EraseRootFromParent_Done,
     /*   24612 */   // Label 475: @24612
     /*   24612 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24665), // Rule ID 46098 //
     /*   24617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24628 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   24628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   24645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24663 */     GIR_RootConstrainSelectedInstOperands,
     /*   24664 */     // GIR_Coverage, 46098,
     /*   24664 */     GIR_EraseRootFromParent_Done,
     /*   24665 */   // Label 476: @24665
     /*   24665 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24718), // Rule ID 46099 //
     /*   24670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24681 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   24681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   24698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24716 */     GIR_RootConstrainSelectedInstOperands,
     /*   24717 */     // GIR_Coverage, 46099,
     /*   24717 */     GIR_EraseRootFromParent_Done,
     /*   24718 */   // Label 477: @24718
     /*   24718 */   GIM_Reject,
     /*   24719 */ // Label 437: @24719
     /*   24719 */ GIM_Reject,
     /*   24720 */ // Label 134: @24720
     /*   24720 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(27844),
     /*   24725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24735 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24831), // Rule ID 70784 //
     /*   24740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24759 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24773 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24788 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24792 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24794 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24805 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   24808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24829 */     GIR_RootConstrainSelectedInstOperands,
     /*   24830 */     // GIR_Coverage, 70784,
     /*   24830 */     GIR_EraseRootFromParent_Done,
     /*   24831 */   // Label 479: @24831
     /*   24831 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(24927), // Rule ID 70785 //
     /*   24836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24855 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24869 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24884 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24888 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24890 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24901 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   24901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   24904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24925 */     GIR_RootConstrainSelectedInstOperands,
     /*   24926 */     // GIR_Coverage, 70785,
     /*   24926 */     GIR_EraseRootFromParent_Done,
     /*   24927 */   // Label 480: @24927
     /*   24927 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(25023), // Rule ID 71048 //
     /*   24932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24951 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24965 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24980 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24984 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24986 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24997 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25021 */     GIR_RootConstrainSelectedInstOperands,
     /*   25022 */     // GIR_Coverage, 71048,
     /*   25022 */     GIR_EraseRootFromParent_Done,
     /*   25023 */   // Label 481: @25023
     /*   25023 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(25119), // Rule ID 71049 //
     /*   25028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25047 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25061 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25076 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25080 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25082 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25093 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25117 */     GIR_RootConstrainSelectedInstOperands,
     /*   25118 */     // GIR_Coverage, 71049,
     /*   25118 */     GIR_EraseRootFromParent_Done,
     /*   25119 */   // Label 482: @25119
     /*   25119 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(25215), // Rule ID 71050 //
     /*   25124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25143 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25157 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25172 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25176 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25178 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25189 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25213 */     GIR_RootConstrainSelectedInstOperands,
     /*   25214 */     // GIR_Coverage, 71050,
     /*   25214 */     GIR_EraseRootFromParent_Done,
     /*   25215 */   // Label 483: @25215
     /*   25215 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(25311), // Rule ID 71051 //
     /*   25220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25239 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25253 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25268 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25272 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25285 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25309 */     GIR_RootConstrainSelectedInstOperands,
     /*   25310 */     // GIR_Coverage, 71051,
     /*   25310 */     GIR_EraseRootFromParent_Done,
     /*   25311 */   // Label 484: @25311
     /*   25311 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(25407), // Rule ID 70898 //
     /*   25316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25335 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25349 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25364 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25368 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25370 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25381 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   25384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25405 */     GIR_RootConstrainSelectedInstOperands,
     /*   25406 */     // GIR_Coverage, 70898,
     /*   25406 */     GIR_EraseRootFromParent_Done,
     /*   25407 */   // Label 485: @25407
     /*   25407 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(25503), // Rule ID 70899 //
     /*   25412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25445 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25460 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25464 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25466 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25477 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   25480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25501 */     GIR_RootConstrainSelectedInstOperands,
     /*   25502 */     // GIR_Coverage, 70899,
     /*   25502 */     GIR_EraseRootFromParent_Done,
     /*   25503 */   // Label 486: @25503
     /*   25503 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(25599), // Rule ID 52038 //
     /*   25508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25545 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25560 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25564 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25566 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25571 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25573 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   25576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25597 */     GIR_RootConstrainSelectedInstOperands,
     /*   25598 */     // GIR_Coverage, 52038,
     /*   25598 */     GIR_EraseRootFromParent_Done,
     /*   25599 */   // Label 487: @25599
     /*   25599 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(25695), // Rule ID 52039 //
     /*   25604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25627 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25641 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25656 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25660 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25662 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25669 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   25672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25693 */     GIR_RootConstrainSelectedInstOperands,
     /*   25694 */     // GIR_Coverage, 52039,
     /*   25694 */     GIR_EraseRootFromParent_Done,
     /*   25695 */   // Label 488: @25695
     /*   25695 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(25791), // Rule ID 52156 //
     /*   25700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25723 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25737 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25739 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25752 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25756 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25758 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25765 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25789 */     GIR_RootConstrainSelectedInstOperands,
     /*   25790 */     // GIR_Coverage, 52156,
     /*   25790 */     GIR_EraseRootFromParent_Done,
     /*   25791 */   // Label 489: @25791
     /*   25791 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(25887), // Rule ID 52157 //
     /*   25796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25819 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25833 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25852 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25854 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25861 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25885 */     GIR_RootConstrainSelectedInstOperands,
     /*   25886 */     // GIR_Coverage, 52157,
     /*   25886 */     GIR_EraseRootFromParent_Done,
     /*   25887 */   // Label 490: @25887
     /*   25887 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(25983), // Rule ID 71046 //
     /*   25892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25915 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25929 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25944 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25948 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25950 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25957 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25981 */     GIR_RootConstrainSelectedInstOperands,
     /*   25982 */     // GIR_Coverage, 71046,
     /*   25982 */     GIR_EraseRootFromParent_Done,
     /*   25983 */   // Label 491: @25983
     /*   25983 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(26079), // Rule ID 71047 //
     /*   25988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26025 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26040 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26044 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26046 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26053 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   26056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   26064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   26068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26077 */     GIR_RootConstrainSelectedInstOperands,
     /*   26078 */     // GIR_Coverage, 71047,
     /*   26078 */     GIR_EraseRootFromParent_Done,
     /*   26079 */   // Label 492: @26079
     /*   26079 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(26175), // Rule ID 52096 //
     /*   26084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26121 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26136 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26140 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26142 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26149 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   26152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26173 */     GIR_RootConstrainSelectedInstOperands,
     /*   26174 */     // GIR_Coverage, 52096,
     /*   26174 */     GIR_EraseRootFromParent_Done,
     /*   26175 */   // Label 493: @26175
     /*   26175 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(26271), // Rule ID 52097 //
     /*   26180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26203 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26217 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26232 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26236 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26238 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26245 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   26248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26269 */     GIR_RootConstrainSelectedInstOperands,
     /*   26270 */     // GIR_Coverage, 52097,
     /*   26270 */     GIR_EraseRootFromParent_Done,
     /*   26271 */   // Label 494: @26271
     /*   26271 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(26360), // Rule ID 46696 //
     /*   26276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26291 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26310 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26319 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26358 */     GIR_RootConstrainSelectedInstOperands,
     /*   26359 */     // GIR_Coverage, 46696,
     /*   26359 */     GIR_EraseRootFromParent_Done,
     /*   26360 */   // Label 495: @26360
     /*   26360 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(26449), // Rule ID 46697 //
     /*   26365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26380 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26399 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26408 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26447 */     GIR_RootConstrainSelectedInstOperands,
     /*   26448 */     // GIR_Coverage, 46697,
     /*   26448 */     GIR_EraseRootFromParent_Done,
     /*   26449 */   // Label 496: @26449
     /*   26449 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(26538), // Rule ID 46460 //
     /*   26454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26488 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26497 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   26514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26536 */     GIR_RootConstrainSelectedInstOperands,
     /*   26537 */     // GIR_Coverage, 46460,
     /*   26537 */     GIR_EraseRootFromParent_Done,
     /*   26538 */   // Label 497: @26538
     /*   26538 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(26627), // Rule ID 46461 //
     /*   26543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26577 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26586 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   26603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26625 */     GIR_RootConstrainSelectedInstOperands,
     /*   26626 */     // GIR_Coverage, 46461,
     /*   26626 */     GIR_EraseRootFromParent_Done,
     /*   26627 */   // Label 498: @26627
     /*   26627 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(26716), // Rule ID 46576 //
     /*   26632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26666 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26675 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26714 */     GIR_RootConstrainSelectedInstOperands,
     /*   26715 */     // GIR_Coverage, 46576,
     /*   26715 */     GIR_EraseRootFromParent_Done,
     /*   26716 */   // Label 499: @26716
     /*   26716 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(26805), // Rule ID 46577 //
     /*   26721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26755 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26764 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26803 */     GIR_RootConstrainSelectedInstOperands,
     /*   26804 */     // GIR_Coverage, 46577,
     /*   26804 */     GIR_EraseRootFromParent_Done,
     /*   26805 */   // Label 500: @26805
     /*   26805 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(26873), // Rule ID 70616 //
     /*   26810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26829 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26847 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   26847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   26850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   26856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26871 */     GIR_RootConstrainSelectedInstOperands,
     /*   26872 */     // GIR_Coverage, 70616,
     /*   26872 */     GIR_EraseRootFromParent_Done,
     /*   26873 */   // Label 501: @26873
     /*   26873 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(26941), // Rule ID 70617 //
     /*   26878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26897 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26915 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   26915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   26918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   26924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26939 */     GIR_RootConstrainSelectedInstOperands,
     /*   26940 */     // GIR_Coverage, 70617,
     /*   26940 */     GIR_EraseRootFromParent_Done,
     /*   26941 */   // Label 502: @26941
     /*   26941 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(26996), // Rule ID 69596 //
     /*   26946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26961 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26974 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   26977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26994 */     GIR_RootConstrainSelectedInstOperands,
     /*   26995 */     // GIR_Coverage, 69596,
     /*   26995 */     GIR_EraseRootFromParent_Done,
     /*   26996 */   // Label 503: @26996
     /*   26996 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(27051), // Rule ID 69597 //
     /*   27001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27029 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27049 */     GIR_RootConstrainSelectedInstOperands,
     /*   27050 */     // GIR_Coverage, 69597,
     /*   27050 */     GIR_EraseRootFromParent_Done,
     /*   27051 */   // Label 504: @27051
     /*   27051 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(27106), // Rule ID 69416 //
     /*   27056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27071 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27084 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27104 */     GIR_RootConstrainSelectedInstOperands,
     /*   27105 */     // GIR_Coverage, 69416,
     /*   27105 */     GIR_EraseRootFromParent_Done,
     /*   27106 */   // Label 505: @27106
     /*   27106 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(27161), // Rule ID 69417 //
     /*   27111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27139 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27159 */     GIR_RootConstrainSelectedInstOperands,
     /*   27160 */     // GIR_Coverage, 69417,
     /*   27160 */     GIR_EraseRootFromParent_Done,
     /*   27161 */   // Label 506: @27161
     /*   27161 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(27216), // Rule ID 69506 //
     /*   27166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27181 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27194 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27214 */     GIR_RootConstrainSelectedInstOperands,
     /*   27215 */     // GIR_Coverage, 69506,
     /*   27215 */     GIR_EraseRootFromParent_Done,
     /*   27216 */   // Label 507: @27216
     /*   27216 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(27271), // Rule ID 69507 //
     /*   27221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27236 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27249 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27269 */     GIR_RootConstrainSelectedInstOperands,
     /*   27270 */     // GIR_Coverage, 69507,
     /*   27270 */     GIR_EraseRootFromParent_Done,
     /*   27271 */   // Label 508: @27271
     /*   27271 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(27339), // Rule ID 51882 //
     /*   27276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27299 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27313 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   27313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27337 */     GIR_RootConstrainSelectedInstOperands,
     /*   27338 */     // GIR_Coverage, 51882,
     /*   27338 */     GIR_EraseRootFromParent_Done,
     /*   27339 */   // Label 509: @27339
     /*   27339 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(27407), // Rule ID 51883 //
     /*   27344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27367 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27381 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   27381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27405 */     GIR_RootConstrainSelectedInstOperands,
     /*   27406 */     // GIR_Coverage, 51883,
     /*   27406 */     GIR_EraseRootFromParent_Done,
     /*   27407 */   // Label 510: @27407
     /*   27407 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(27462), // Rule ID 46756 //
     /*   27412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27440 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27460 */     GIR_RootConstrainSelectedInstOperands,
     /*   27461 */     // GIR_Coverage, 46756,
     /*   27461 */     GIR_EraseRootFromParent_Done,
     /*   27462 */   // Label 511: @27462
     /*   27462 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(27517), // Rule ID 46757 //
     /*   27467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27495 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27515 */     GIR_RootConstrainSelectedInstOperands,
     /*   27516 */     // GIR_Coverage, 46757,
     /*   27516 */     GIR_EraseRootFromParent_Done,
     /*   27517 */   // Label 512: @27517
     /*   27517 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(27572), // Rule ID 46516 //
     /*   27522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27550 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27570 */     GIR_RootConstrainSelectedInstOperands,
     /*   27571 */     // GIR_Coverage, 46516,
     /*   27571 */     GIR_EraseRootFromParent_Done,
     /*   27572 */   // Label 513: @27572
     /*   27572 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(27627), // Rule ID 46517 //
     /*   27577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27596 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27605 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27625 */     GIR_RootConstrainSelectedInstOperands,
     /*   27626 */     // GIR_Coverage, 46517,
     /*   27626 */     GIR_EraseRootFromParent_Done,
     /*   27627 */   // Label 514: @27627
     /*   27627 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(27682), // Rule ID 46636 //
     /*   27632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27651 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27660 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27680 */     GIR_RootConstrainSelectedInstOperands,
     /*   27681 */     // GIR_Coverage, 46636,
     /*   27681 */     GIR_EraseRootFromParent_Done,
     /*   27682 */   // Label 515: @27682
     /*   27682 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(27737), // Rule ID 46637 //
     /*   27687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27706 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27715 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27735 */     GIR_RootConstrainSelectedInstOperands,
     /*   27736 */     // GIR_Coverage, 46637,
     /*   27736 */     GIR_EraseRootFromParent_Done,
     /*   27737 */   // Label 516: @27737
     /*   27737 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(27790), // Rule ID 46114 //
     /*   27742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27753 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   27753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   27770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27788 */     GIR_RootConstrainSelectedInstOperands,
     /*   27789 */     // GIR_Coverage, 46114,
     /*   27789 */     GIR_EraseRootFromParent_Done,
     /*   27790 */   // Label 517: @27790
     /*   27790 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(27843), // Rule ID 46115 //
     /*   27795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27806 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   27806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   27823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27841 */     GIR_RootConstrainSelectedInstOperands,
     /*   27842 */     // GIR_Coverage, 46115,
     /*   27842 */     GIR_EraseRootFromParent_Done,
     /*   27843 */   // Label 518: @27843
     /*   27843 */   GIM_Reject,
     /*   27844 */ // Label 478: @27844
     /*   27844 */ GIM_Reject,
     /*   27845 */ // Label 135: @27845
     /*   27845 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(30969),
     /*   27850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   27853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   27856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   27860 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(27956), // Rule ID 70794 //
     /*   27865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   27868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   27880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   27884 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27898 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   27909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27913 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27917 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   27919 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   27928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   27930 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   27930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   27933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   27937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   27945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27954 */     GIR_RootConstrainSelectedInstOperands,
     /*   27955 */     // GIR_Coverage, 70794,
     /*   27955 */     GIR_EraseRootFromParent_Done,
     /*   27956 */   // Label 520: @27956
     /*   27956 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(28052), // Rule ID 70795 //
     /*   27961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   27964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   27976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   27980 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27994 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28013 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28015 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28026 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28050 */     GIR_RootConstrainSelectedInstOperands,
     /*   28051 */     // GIR_Coverage, 70795,
     /*   28051 */     GIR_EraseRootFromParent_Done,
     /*   28052 */   // Label 521: @28052
     /*   28052 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(28148), // Rule ID 71078 //
     /*   28057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28090 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28105 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28109 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28111 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28122 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28146 */     GIR_RootConstrainSelectedInstOperands,
     /*   28147 */     // GIR_Coverage, 71078,
     /*   28147 */     GIR_EraseRootFromParent_Done,
     /*   28148 */   // Label 522: @28148
     /*   28148 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(28244), // Rule ID 71079 //
     /*   28153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28172 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28186 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28201 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28205 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28207 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28218 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28242 */     GIR_RootConstrainSelectedInstOperands,
     /*   28243 */     // GIR_Coverage, 71079,
     /*   28243 */     GIR_EraseRootFromParent_Done,
     /*   28244 */   // Label 523: @28244
     /*   28244 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(28340), // Rule ID 71080 //
     /*   28249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28268 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28282 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28297 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28301 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28303 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28314 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28338 */     GIR_RootConstrainSelectedInstOperands,
     /*   28339 */     // GIR_Coverage, 71080,
     /*   28339 */     GIR_EraseRootFromParent_Done,
     /*   28340 */   // Label 524: @28340
     /*   28340 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(28436), // Rule ID 71081 //
     /*   28345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28364 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28378 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28393 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28397 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28399 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28410 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28434 */     GIR_RootConstrainSelectedInstOperands,
     /*   28435 */     // GIR_Coverage, 71081,
     /*   28435 */     GIR_EraseRootFromParent_Done,
     /*   28436 */   // Label 525: @28436
     /*   28436 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(28532), // Rule ID 70908 //
     /*   28441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28460 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28474 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28489 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28493 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28495 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28506 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   28509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28530 */     GIR_RootConstrainSelectedInstOperands,
     /*   28531 */     // GIR_Coverage, 70908,
     /*   28531 */     GIR_EraseRootFromParent_Done,
     /*   28532 */   // Label 526: @28532
     /*   28532 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(28628), // Rule ID 70909 //
     /*   28537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28570 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28585 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28589 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28591 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28602 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   28605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28626 */     GIR_RootConstrainSelectedInstOperands,
     /*   28627 */     // GIR_Coverage, 70909,
     /*   28627 */     GIR_EraseRootFromParent_Done,
     /*   28628 */   // Label 527: @28628
     /*   28628 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(28724), // Rule ID 52048 //
     /*   28633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28670 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28685 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28689 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28691 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28698 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28722 */     GIR_RootConstrainSelectedInstOperands,
     /*   28723 */     // GIR_Coverage, 52048,
     /*   28723 */     GIR_EraseRootFromParent_Done,
     /*   28724 */   // Label 528: @28724
     /*   28724 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(28820), // Rule ID 52049 //
     /*   28729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28766 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28781 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28785 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28787 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28794 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28818 */     GIR_RootConstrainSelectedInstOperands,
     /*   28819 */     // GIR_Coverage, 52049,
     /*   28819 */     GIR_EraseRootFromParent_Done,
     /*   28820 */   // Label 529: @28820
     /*   28820 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(28916), // Rule ID 52166 //
     /*   28825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28848 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28862 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28881 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28883 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28890 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28914 */     GIR_RootConstrainSelectedInstOperands,
     /*   28915 */     // GIR_Coverage, 52166,
     /*   28915 */     GIR_EraseRootFromParent_Done,
     /*   28916 */   // Label 530: @28916
     /*   28916 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(29012), // Rule ID 52167 //
     /*   28921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28958 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28977 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28986 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29010 */     GIR_RootConstrainSelectedInstOperands,
     /*   29011 */     // GIR_Coverage, 52167,
     /*   29011 */     GIR_EraseRootFromParent_Done,
     /*   29012 */   // Label 531: @29012
     /*   29012 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(29108), // Rule ID 71076 //
     /*   29017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29054 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29069 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29073 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29082 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   29093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   29097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29106 */     GIR_RootConstrainSelectedInstOperands,
     /*   29107 */     // GIR_Coverage, 71076,
     /*   29107 */     GIR_EraseRootFromParent_Done,
     /*   29108 */   // Label 532: @29108
     /*   29108 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(29204), // Rule ID 71077 //
     /*   29113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29150 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29169 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29171 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29178 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   29189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   29193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29202 */     GIR_RootConstrainSelectedInstOperands,
     /*   29203 */     // GIR_Coverage, 71077,
     /*   29203 */     GIR_EraseRootFromParent_Done,
     /*   29204 */   // Label 533: @29204
     /*   29204 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(29300), // Rule ID 52106 //
     /*   29209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29232 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29246 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29261 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29265 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29267 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29274 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29298 */     GIR_RootConstrainSelectedInstOperands,
     /*   29299 */     // GIR_Coverage, 52106,
     /*   29299 */     GIR_EraseRootFromParent_Done,
     /*   29300 */   // Label 534: @29300
     /*   29300 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(29396), // Rule ID 52107 //
     /*   29305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29342 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29361 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29363 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29370 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29394 */     GIR_RootConstrainSelectedInstOperands,
     /*   29395 */     // GIR_Coverage, 52107,
     /*   29395 */     GIR_EraseRootFromParent_Done,
     /*   29396 */   // Label 535: @29396
     /*   29396 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(29485), // Rule ID 46716 //
     /*   29401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29416 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29435 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29444 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29483 */     GIR_RootConstrainSelectedInstOperands,
     /*   29484 */     // GIR_Coverage, 46716,
     /*   29484 */     GIR_EraseRootFromParent_Done,
     /*   29485 */   // Label 536: @29485
     /*   29485 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(29574), // Rule ID 46717 //
     /*   29490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29505 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29524 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29533 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29572 */     GIR_RootConstrainSelectedInstOperands,
     /*   29573 */     // GIR_Coverage, 46717,
     /*   29573 */     GIR_EraseRootFromParent_Done,
     /*   29574 */   // Label 537: @29574
     /*   29574 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(29663), // Rule ID 46480 //
     /*   29579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29594 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29613 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29622 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   29639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29661 */     GIR_RootConstrainSelectedInstOperands,
     /*   29662 */     // GIR_Coverage, 46480,
     /*   29662 */     GIR_EraseRootFromParent_Done,
     /*   29663 */   // Label 538: @29663
     /*   29663 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(29752), // Rule ID 46481 //
     /*   29668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29683 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29702 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29711 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   29728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29750 */     GIR_RootConstrainSelectedInstOperands,
     /*   29751 */     // GIR_Coverage, 46481,
     /*   29751 */     GIR_EraseRootFromParent_Done,
     /*   29752 */   // Label 539: @29752
     /*   29752 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(29841), // Rule ID 46596 //
     /*   29757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29791 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29793 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29800 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29839 */     GIR_RootConstrainSelectedInstOperands,
     /*   29840 */     // GIR_Coverage, 46596,
     /*   29840 */     GIR_EraseRootFromParent_Done,
     /*   29841 */   // Label 540: @29841
     /*   29841 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(29930), // Rule ID 46597 //
     /*   29846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29861 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29880 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29889 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29928 */     GIR_RootConstrainSelectedInstOperands,
     /*   29929 */     // GIR_Coverage, 46597,
     /*   29929 */     GIR_EraseRootFromParent_Done,
     /*   29930 */   // Label 541: @29930
     /*   29930 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(29998), // Rule ID 70704 //
     /*   29935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   29938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29954 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29972 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   29972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   29975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   29981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   29993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29996 */     GIR_RootConstrainSelectedInstOperands,
     /*   29997 */     // GIR_Coverage, 70704,
     /*   29997 */     GIR_EraseRootFromParent_Done,
     /*   29998 */   // Label 542: @29998
     /*   29998 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(30066), // Rule ID 70705 //
     /*   30003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30022 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30040 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   30040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30064 */     GIR_RootConstrainSelectedInstOperands,
     /*   30065 */     // GIR_Coverage, 70705,
     /*   30065 */     GIR_EraseRootFromParent_Done,
     /*   30066 */   // Label 543: @30066
     /*   30066 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(30121), // Rule ID 69616 //
     /*   30071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30099 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30119 */     GIR_RootConstrainSelectedInstOperands,
     /*   30120 */     // GIR_Coverage, 69616,
     /*   30120 */     GIR_EraseRootFromParent_Done,
     /*   30121 */   // Label 544: @30121
     /*   30121 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(30176), // Rule ID 69617 //
     /*   30126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30141 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30154 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30174 */     GIR_RootConstrainSelectedInstOperands,
     /*   30175 */     // GIR_Coverage, 69617,
     /*   30175 */     GIR_EraseRootFromParent_Done,
     /*   30176 */   // Label 545: @30176
     /*   30176 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(30231), // Rule ID 69436 //
     /*   30181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30209 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30229 */     GIR_RootConstrainSelectedInstOperands,
     /*   30230 */     // GIR_Coverage, 69436,
     /*   30230 */     GIR_EraseRootFromParent_Done,
     /*   30231 */   // Label 546: @30231
     /*   30231 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(30286), // Rule ID 69437 //
     /*   30236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30264 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30284 */     GIR_RootConstrainSelectedInstOperands,
     /*   30285 */     // GIR_Coverage, 69437,
     /*   30285 */     GIR_EraseRootFromParent_Done,
     /*   30286 */   // Label 547: @30286
     /*   30286 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(30341), // Rule ID 69526 //
     /*   30291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30319 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30339 */     GIR_RootConstrainSelectedInstOperands,
     /*   30340 */     // GIR_Coverage, 69526,
     /*   30340 */     GIR_EraseRootFromParent_Done,
     /*   30341 */   // Label 548: @30341
     /*   30341 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(30396), // Rule ID 69527 //
     /*   30346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30374 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30394 */     GIR_RootConstrainSelectedInstOperands,
     /*   30395 */     // GIR_Coverage, 69527,
     /*   30395 */     GIR_EraseRootFromParent_Done,
     /*   30396 */   // Label 549: @30396
     /*   30396 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(30464), // Rule ID 51926 //
     /*   30401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   30404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30438 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   30438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30462 */     GIR_RootConstrainSelectedInstOperands,
     /*   30463 */     // GIR_Coverage, 51926,
     /*   30463 */     GIR_EraseRootFromParent_Done,
     /*   30464 */   // Label 550: @30464
     /*   30464 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(30532), // Rule ID 51927 //
     /*   30469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30506 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   30506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30530 */     GIR_RootConstrainSelectedInstOperands,
     /*   30531 */     // GIR_Coverage, 51927,
     /*   30531 */     GIR_EraseRootFromParent_Done,
     /*   30532 */   // Label 551: @30532
     /*   30532 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(30587), // Rule ID 46776 //
     /*   30537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30565 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30585 */     GIR_RootConstrainSelectedInstOperands,
     /*   30586 */     // GIR_Coverage, 46776,
     /*   30586 */     GIR_EraseRootFromParent_Done,
     /*   30587 */   // Label 552: @30587
     /*   30587 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(30642), // Rule ID 46777 //
     /*   30592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30620 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30640 */     GIR_RootConstrainSelectedInstOperands,
     /*   30641 */     // GIR_Coverage, 46777,
     /*   30641 */     GIR_EraseRootFromParent_Done,
     /*   30642 */   // Label 553: @30642
     /*   30642 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(30697), // Rule ID 46536 //
     /*   30647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30675 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30695 */     GIR_RootConstrainSelectedInstOperands,
     /*   30696 */     // GIR_Coverage, 46536,
     /*   30696 */     GIR_EraseRootFromParent_Done,
     /*   30697 */   // Label 554: @30697
     /*   30697 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(30752), // Rule ID 46537 //
     /*   30702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30730 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30750 */     GIR_RootConstrainSelectedInstOperands,
     /*   30751 */     // GIR_Coverage, 46537,
     /*   30751 */     GIR_EraseRootFromParent_Done,
     /*   30752 */   // Label 555: @30752
     /*   30752 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(30807), // Rule ID 46656 //
     /*   30757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30785 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30805 */     GIR_RootConstrainSelectedInstOperands,
     /*   30806 */     // GIR_Coverage, 46656,
     /*   30806 */     GIR_EraseRootFromParent_Done,
     /*   30807 */   // Label 556: @30807
     /*   30807 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(30862), // Rule ID 46657 //
     /*   30812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30840 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30860 */     GIR_RootConstrainSelectedInstOperands,
     /*   30861 */     // GIR_Coverage, 46657,
     /*   30861 */     GIR_EraseRootFromParent_Done,
     /*   30862 */   // Label 557: @30862
     /*   30862 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(30915), // Rule ID 46158 //
     /*   30867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   30870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30878 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   30878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   30895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30913 */     GIR_RootConstrainSelectedInstOperands,
     /*   30914 */     // GIR_Coverage, 46158,
     /*   30914 */     GIR_EraseRootFromParent_Done,
     /*   30915 */   // Label 558: @30915
     /*   30915 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(30968), // Rule ID 46159 //
     /*   30920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30931 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   30931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   30948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30966 */     GIR_RootConstrainSelectedInstOperands,
     /*   30967 */     // GIR_Coverage, 46159,
     /*   30967 */     GIR_EraseRootFromParent_Done,
     /*   30968 */   // Label 559: @30968
     /*   30968 */   GIM_Reject,
     /*   30969 */ // Label 519: @30969
     /*   30969 */ GIM_Reject,
     /*   30970 */ // Label 136: @30970
     /*   30970 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(31364),
     /*   30975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   30978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   30981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30985 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(31053), // Rule ID 70568 //
     /*   30990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31009 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31027 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31051 */     GIR_RootConstrainSelectedInstOperands,
     /*   31052 */     // GIR_Coverage, 70568,
     /*   31052 */     GIR_EraseRootFromParent_Done,
     /*   31053 */   // Label 561: @31053
     /*   31053 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(31121), // Rule ID 70569 //
     /*   31058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31077 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31095 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31119 */     GIR_RootConstrainSelectedInstOperands,
     /*   31120 */     // GIR_Coverage, 70569,
     /*   31120 */     GIR_EraseRootFromParent_Done,
     /*   31121 */   // Label 562: @31121
     /*   31121 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(31189), // Rule ID 51858 //
     /*   31126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31163 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31187 */     GIR_RootConstrainSelectedInstOperands,
     /*   31188 */     // GIR_Coverage, 51858,
     /*   31188 */     GIR_EraseRootFromParent_Done,
     /*   31189 */   // Label 563: @31189
     /*   31189 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(31257), // Rule ID 51859 //
     /*   31194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31217 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31231 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31255 */     GIR_RootConstrainSelectedInstOperands,
     /*   31256 */     // GIR_Coverage, 51859,
     /*   31256 */     GIR_EraseRootFromParent_Done,
     /*   31257 */   // Label 564: @31257
     /*   31257 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(31310), // Rule ID 46090 //
     /*   31262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31273 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   31273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   31290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31308 */     GIR_RootConstrainSelectedInstOperands,
     /*   31309 */     // GIR_Coverage, 46090,
     /*   31309 */     GIR_EraseRootFromParent_Done,
     /*   31310 */   // Label 565: @31310
     /*   31310 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(31363), // Rule ID 46091 //
     /*   31315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31326 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   31326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   31343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31361 */     GIR_RootConstrainSelectedInstOperands,
     /*   31362 */     // GIR_Coverage, 46091,
     /*   31362 */     GIR_EraseRootFromParent_Done,
     /*   31363 */   // Label 566: @31363
     /*   31363 */   GIM_Reject,
     /*   31364 */ // Label 560: @31364
     /*   31364 */ GIM_Reject,
     /*   31365 */ // Label 137: @31365
     /*   31365 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(34489),
     /*   31370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31380 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(31476), // Rule ID 70774 //
     /*   31385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31404 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31418 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31433 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31437 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31439 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31450 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   31453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31474 */     GIR_RootConstrainSelectedInstOperands,
     /*   31475 */     // GIR_Coverage, 70774,
     /*   31475 */     GIR_EraseRootFromParent_Done,
     /*   31476 */   // Label 568: @31476
     /*   31476 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(31572), // Rule ID 70775 //
     /*   31481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31514 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31529 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31533 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31535 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31546 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   31549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31570 */     GIR_RootConstrainSelectedInstOperands,
     /*   31571 */     // GIR_Coverage, 70775,
     /*   31571 */     GIR_EraseRootFromParent_Done,
     /*   31572 */   // Label 569: @31572
     /*   31572 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(31668), // Rule ID 71018 //
     /*   31577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31596 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31610 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31625 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31629 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31631 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31642 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31666 */     GIR_RootConstrainSelectedInstOperands,
     /*   31667 */     // GIR_Coverage, 71018,
     /*   31667 */     GIR_EraseRootFromParent_Done,
     /*   31668 */   // Label 570: @31668
     /*   31668 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(31764), // Rule ID 71019 //
     /*   31673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31692 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31706 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31721 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31725 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31727 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31738 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31762 */     GIR_RootConstrainSelectedInstOperands,
     /*   31763 */     // GIR_Coverage, 71019,
     /*   31763 */     GIR_EraseRootFromParent_Done,
     /*   31764 */   // Label 571: @31764
     /*   31764 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(31860), // Rule ID 71020 //
     /*   31769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31802 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31821 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31823 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31834 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   31845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   31849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31858 */     GIR_RootConstrainSelectedInstOperands,
     /*   31859 */     // GIR_Coverage, 71020,
     /*   31859 */     GIR_EraseRootFromParent_Done,
     /*   31860 */   // Label 572: @31860
     /*   31860 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(31956), // Rule ID 71021 //
     /*   31865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31884 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31898 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31913 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31917 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31919 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31930 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   31941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   31945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31954 */     GIR_RootConstrainSelectedInstOperands,
     /*   31955 */     // GIR_Coverage, 71021,
     /*   31955 */     GIR_EraseRootFromParent_Done,
     /*   31956 */   // Label 573: @31956
     /*   31956 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(32052), // Rule ID 70888 //
     /*   31961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31980 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31994 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32013 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32015 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32026 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32050 */     GIR_RootConstrainSelectedInstOperands,
     /*   32051 */     // GIR_Coverage, 70888,
     /*   32051 */     GIR_EraseRootFromParent_Done,
     /*   32052 */   // Label 574: @32052
     /*   32052 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(32148), // Rule ID 70889 //
     /*   32057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32090 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32105 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32109 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32111 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32122 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32146 */     GIR_RootConstrainSelectedInstOperands,
     /*   32147 */     // GIR_Coverage, 70889,
     /*   32147 */     GIR_EraseRootFromParent_Done,
     /*   32148 */   // Label 575: @32148
     /*   32148 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(32244), // Rule ID 52028 //
     /*   32153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32176 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32190 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32209 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32211 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32218 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32242 */     GIR_RootConstrainSelectedInstOperands,
     /*   32243 */     // GIR_Coverage, 52028,
     /*   32243 */     GIR_EraseRootFromParent_Done,
     /*   32244 */   // Label 576: @32244
     /*   32244 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(32340), // Rule ID 52029 //
     /*   32249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32286 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32301 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32305 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32307 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32314 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32338 */     GIR_RootConstrainSelectedInstOperands,
     /*   32339 */     // GIR_Coverage, 52029,
     /*   32339 */     GIR_EraseRootFromParent_Done,
     /*   32340 */   // Label 577: @32340
     /*   32340 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(32436), // Rule ID 52146 //
     /*   32345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32368 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32382 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32397 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32401 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32410 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32434 */     GIR_RootConstrainSelectedInstOperands,
     /*   32435 */     // GIR_Coverage, 52146,
     /*   32435 */     GIR_EraseRootFromParent_Done,
     /*   32436 */   // Label 578: @32436
     /*   32436 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(32532), // Rule ID 52147 //
     /*   32441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32464 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32478 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32493 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32497 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32499 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32506 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32530 */     GIR_RootConstrainSelectedInstOperands,
     /*   32531 */     // GIR_Coverage, 52147,
     /*   32531 */     GIR_EraseRootFromParent_Done,
     /*   32532 */   // Label 579: @32532
     /*   32532 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(32628), // Rule ID 71016 //
     /*   32537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32560 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32574 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32589 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32593 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32595 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32602 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   32613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   32617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32626 */     GIR_RootConstrainSelectedInstOperands,
     /*   32627 */     // GIR_Coverage, 71016,
     /*   32627 */     GIR_EraseRootFromParent_Done,
     /*   32628 */   // Label 580: @32628
     /*   32628 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(32724), // Rule ID 71017 //
     /*   32633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32670 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32685 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32689 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32691 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32698 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   32709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   32713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32722 */     GIR_RootConstrainSelectedInstOperands,
     /*   32723 */     // GIR_Coverage, 71017,
     /*   32723 */     GIR_EraseRootFromParent_Done,
     /*   32724 */   // Label 581: @32724
     /*   32724 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(32820), // Rule ID 52086 //
     /*   32729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32766 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32781 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32785 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32787 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32794 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32818 */     GIR_RootConstrainSelectedInstOperands,
     /*   32819 */     // GIR_Coverage, 52086,
     /*   32819 */     GIR_EraseRootFromParent_Done,
     /*   32820 */   // Label 582: @32820
     /*   32820 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(32916), // Rule ID 52087 //
     /*   32825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32848 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32862 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32881 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32883 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32890 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32914 */     GIR_RootConstrainSelectedInstOperands,
     /*   32915 */     // GIR_Coverage, 52087,
     /*   32915 */     GIR_EraseRootFromParent_Done,
     /*   32916 */   // Label 583: @32916
     /*   32916 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(33005), // Rule ID 46676 //
     /*   32921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   32932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32936 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   32947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   32951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32955 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32964 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   32964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   32967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   32981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   32990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33003 */     GIR_RootConstrainSelectedInstOperands,
     /*   33004 */     // GIR_Coverage, 46676,
     /*   33004 */     GIR_EraseRootFromParent_Done,
     /*   33005 */   // Label 584: @33005
     /*   33005 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(33094), // Rule ID 46677 //
     /*   33010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33025 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33044 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33053 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33092 */     GIR_RootConstrainSelectedInstOperands,
     /*   33093 */     // GIR_Coverage, 46677,
     /*   33093 */     GIR_EraseRootFromParent_Done,
     /*   33094 */   // Label 585: @33094
     /*   33094 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(33183), // Rule ID 46440 //
     /*   33099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33114 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33133 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33142 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   33159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33181 */     GIR_RootConstrainSelectedInstOperands,
     /*   33182 */     // GIR_Coverage, 46440,
     /*   33182 */     GIR_EraseRootFromParent_Done,
     /*   33183 */   // Label 586: @33183
     /*   33183 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(33272), // Rule ID 46441 //
     /*   33188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33203 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33222 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33231 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   33248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33270 */     GIR_RootConstrainSelectedInstOperands,
     /*   33271 */     // GIR_Coverage, 46441,
     /*   33271 */     GIR_EraseRootFromParent_Done,
     /*   33272 */   // Label 587: @33272
     /*   33272 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(33361), // Rule ID 46556 //
     /*   33277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33311 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33320 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33359 */     GIR_RootConstrainSelectedInstOperands,
     /*   33360 */     // GIR_Coverage, 46556,
     /*   33360 */     GIR_EraseRootFromParent_Done,
     /*   33361 */   // Label 588: @33361
     /*   33361 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(33450), // Rule ID 46557 //
     /*   33366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33400 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33409 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33448 */     GIR_RootConstrainSelectedInstOperands,
     /*   33449 */     // GIR_Coverage, 46557,
     /*   33449 */     GIR_EraseRootFromParent_Done,
     /*   33450 */   // Label 589: @33450
     /*   33450 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(33518), // Rule ID 70608 //
     /*   33455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33474 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33492 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   33492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33516 */     GIR_RootConstrainSelectedInstOperands,
     /*   33517 */     // GIR_Coverage, 70608,
     /*   33517 */     GIR_EraseRootFromParent_Done,
     /*   33518 */   // Label 590: @33518
     /*   33518 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(33586), // Rule ID 70609 //
     /*   33523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33542 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33560 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   33560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33584 */     GIR_RootConstrainSelectedInstOperands,
     /*   33585 */     // GIR_Coverage, 70609,
     /*   33585 */     GIR_EraseRootFromParent_Done,
     /*   33586 */   // Label 591: @33586
     /*   33586 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(33641), // Rule ID 69576 //
     /*   33591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33606 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33619 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33639 */     GIR_RootConstrainSelectedInstOperands,
     /*   33640 */     // GIR_Coverage, 69576,
     /*   33640 */     GIR_EraseRootFromParent_Done,
     /*   33641 */   // Label 592: @33641
     /*   33641 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(33696), // Rule ID 69577 //
     /*   33646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33674 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33694 */     GIR_RootConstrainSelectedInstOperands,
     /*   33695 */     // GIR_Coverage, 69577,
     /*   33695 */     GIR_EraseRootFromParent_Done,
     /*   33696 */   // Label 593: @33696
     /*   33696 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(33751), // Rule ID 69396 //
     /*   33701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33729 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   33732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33749 */     GIR_RootConstrainSelectedInstOperands,
     /*   33750 */     // GIR_Coverage, 69396,
     /*   33750 */     GIR_EraseRootFromParent_Done,
     /*   33751 */   // Label 594: @33751
     /*   33751 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(33806), // Rule ID 69397 //
     /*   33756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33771 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33784 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   33787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33804 */     GIR_RootConstrainSelectedInstOperands,
     /*   33805 */     // GIR_Coverage, 69397,
     /*   33805 */     GIR_EraseRootFromParent_Done,
     /*   33806 */   // Label 595: @33806
     /*   33806 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(33861), // Rule ID 69486 //
     /*   33811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33826 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33839 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33859 */     GIR_RootConstrainSelectedInstOperands,
     /*   33860 */     // GIR_Coverage, 69486,
     /*   33860 */     GIR_EraseRootFromParent_Done,
     /*   33861 */   // Label 596: @33861
     /*   33861 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(33916), // Rule ID 69487 //
     /*   33866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33881 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33894 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33914 */     GIR_RootConstrainSelectedInstOperands,
     /*   33915 */     // GIR_Coverage, 69487,
     /*   33915 */     GIR_EraseRootFromParent_Done,
     /*   33916 */   // Label 597: @33916
     /*   33916 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(33984), // Rule ID 51878 //
     /*   33921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33958 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   33958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   33973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33982 */     GIR_RootConstrainSelectedInstOperands,
     /*   33983 */     // GIR_Coverage, 51878,
     /*   33983 */     GIR_EraseRootFromParent_Done,
     /*   33984 */   // Label 598: @33984
     /*   33984 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(34052), // Rule ID 51879 //
     /*   33989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   34012 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34026 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   34029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   34035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34050 */     GIR_RootConstrainSelectedInstOperands,
     /*   34051 */     // GIR_Coverage, 51879,
     /*   34051 */     GIR_EraseRootFromParent_Done,
     /*   34052 */   // Label 599: @34052
     /*   34052 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(34107), // Rule ID 46736 //
     /*   34057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34085 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34105 */     GIR_RootConstrainSelectedInstOperands,
     /*   34106 */     // GIR_Coverage, 46736,
     /*   34106 */     GIR_EraseRootFromParent_Done,
     /*   34107 */   // Label 600: @34107
     /*   34107 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(34162), // Rule ID 46737 //
     /*   34112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34131 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34140 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34160 */     GIR_RootConstrainSelectedInstOperands,
     /*   34161 */     // GIR_Coverage, 46737,
     /*   34161 */     GIR_EraseRootFromParent_Done,
     /*   34162 */   // Label 601: @34162
     /*   34162 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(34217), // Rule ID 46496 //
     /*   34167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34186 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34195 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34215 */     GIR_RootConstrainSelectedInstOperands,
     /*   34216 */     // GIR_Coverage, 46496,
     /*   34216 */     GIR_EraseRootFromParent_Done,
     /*   34217 */   // Label 602: @34217
     /*   34217 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(34272), // Rule ID 46497 //
     /*   34222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34241 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34250 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34270 */     GIR_RootConstrainSelectedInstOperands,
     /*   34271 */     // GIR_Coverage, 46497,
     /*   34271 */     GIR_EraseRootFromParent_Done,
     /*   34272 */   // Label 603: @34272
     /*   34272 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(34327), // Rule ID 46616 //
     /*   34277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34296 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34305 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34325 */     GIR_RootConstrainSelectedInstOperands,
     /*   34326 */     // GIR_Coverage, 46616,
     /*   34326 */     GIR_EraseRootFromParent_Done,
     /*   34327 */   // Label 604: @34327
     /*   34327 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(34382), // Rule ID 46617 //
     /*   34332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34351 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34360 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34380 */     GIR_RootConstrainSelectedInstOperands,
     /*   34381 */     // GIR_Coverage, 46617,
     /*   34381 */     GIR_EraseRootFromParent_Done,
     /*   34382 */   // Label 605: @34382
     /*   34382 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(34435), // Rule ID 46110 //
     /*   34387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34398 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   34398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   34401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   34415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34433 */     GIR_RootConstrainSelectedInstOperands,
     /*   34434 */     // GIR_Coverage, 46110,
     /*   34434 */     GIR_EraseRootFromParent_Done,
     /*   34435 */   // Label 606: @34435
     /*   34435 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(34488), // Rule ID 46111 //
     /*   34440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34451 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   34451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   34454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   34468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34486 */     GIR_RootConstrainSelectedInstOperands,
     /*   34487 */     // GIR_Coverage, 46111,
     /*   34487 */     GIR_EraseRootFromParent_Done,
     /*   34488 */   // Label 607: @34488
     /*   34488 */   GIM_Reject,
     /*   34489 */ // Label 567: @34489
     /*   34489 */ GIM_Reject,
     /*   34490 */ // Label 138: @34490
     /*   34490 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37614),
     /*   34495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34505 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(34601), // Rule ID 70786 //
     /*   34510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34529 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34543 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34558 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34562 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34564 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34575 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   34578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34599 */     GIR_RootConstrainSelectedInstOperands,
     /*   34600 */     // GIR_Coverage, 70786,
     /*   34600 */     GIR_EraseRootFromParent_Done,
     /*   34601 */   // Label 609: @34601
     /*   34601 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(34697), // Rule ID 70787 //
     /*   34606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34625 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34639 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34654 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34658 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34660 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34669 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34671 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   34674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34695 */     GIR_RootConstrainSelectedInstOperands,
     /*   34696 */     // GIR_Coverage, 70787,
     /*   34696 */     GIR_EraseRootFromParent_Done,
     /*   34697 */   // Label 610: @34697
     /*   34697 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(34793), // Rule ID 71054 //
     /*   34702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34735 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34750 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34754 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34756 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34765 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34767 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   34770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34791 */     GIR_RootConstrainSelectedInstOperands,
     /*   34792 */     // GIR_Coverage, 71054,
     /*   34792 */     GIR_EraseRootFromParent_Done,
     /*   34793 */   // Label 611: @34793
     /*   34793 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(34889), // Rule ID 71055 //
     /*   34798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34817 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34831 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34846 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34850 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34852 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34863 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   34866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34887 */     GIR_RootConstrainSelectedInstOperands,
     /*   34888 */     // GIR_Coverage, 71055,
     /*   34888 */     GIR_EraseRootFromParent_Done,
     /*   34889 */   // Label 612: @34889
     /*   34889 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(34985), // Rule ID 71056 //
     /*   34894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34913 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34927 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34942 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34946 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34948 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34957 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34959 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   34962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   34970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   34974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34983 */     GIR_RootConstrainSelectedInstOperands,
     /*   34984 */     // GIR_Coverage, 71056,
     /*   34984 */     GIR_EraseRootFromParent_Done,
     /*   34985 */   // Label 613: @34985
     /*   34985 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(35081), // Rule ID 71057 //
     /*   34990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35009 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35023 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35042 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35044 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35055 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35079 */     GIR_RootConstrainSelectedInstOperands,
     /*   35080 */     // GIR_Coverage, 71057,
     /*   35080 */     GIR_EraseRootFromParent_Done,
     /*   35081 */   // Label 614: @35081
     /*   35081 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(35177), // Rule ID 70900 //
     /*   35086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35105 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35119 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35134 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35138 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35140 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35151 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35175 */     GIR_RootConstrainSelectedInstOperands,
     /*   35176 */     // GIR_Coverage, 70900,
     /*   35176 */     GIR_EraseRootFromParent_Done,
     /*   35177 */   // Label 615: @35177
     /*   35177 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(35273), // Rule ID 70901 //
     /*   35182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35215 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35230 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35234 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35236 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35247 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35271 */     GIR_RootConstrainSelectedInstOperands,
     /*   35272 */     // GIR_Coverage, 70901,
     /*   35272 */     GIR_EraseRootFromParent_Done,
     /*   35273 */   // Label 616: @35273
     /*   35273 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(35369), // Rule ID 52040 //
     /*   35278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35315 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35317 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35334 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35336 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35343 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35367 */     GIR_RootConstrainSelectedInstOperands,
     /*   35368 */     // GIR_Coverage, 52040,
     /*   35368 */     GIR_EraseRootFromParent_Done,
     /*   35369 */   // Label 617: @35369
     /*   35369 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(35465), // Rule ID 52041 //
     /*   35374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35397 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35411 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35426 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35430 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35432 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35437 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35439 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35463 */     GIR_RootConstrainSelectedInstOperands,
     /*   35464 */     // GIR_Coverage, 52041,
     /*   35464 */     GIR_EraseRootFromParent_Done,
     /*   35465 */   // Label 618: @35465
     /*   35465 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(35561), // Rule ID 52158 //
     /*   35470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35493 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35507 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35522 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35526 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35528 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35535 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35559 */     GIR_RootConstrainSelectedInstOperands,
     /*   35560 */     // GIR_Coverage, 52158,
     /*   35560 */     GIR_EraseRootFromParent_Done,
     /*   35561 */   // Label 619: @35561
     /*   35561 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(35657), // Rule ID 52159 //
     /*   35566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35589 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35603 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35605 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35618 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35622 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35624 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35629 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35631 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35655 */     GIR_RootConstrainSelectedInstOperands,
     /*   35656 */     // GIR_Coverage, 52159,
     /*   35656 */     GIR_EraseRootFromParent_Done,
     /*   35657 */   // Label 620: @35657
     /*   35657 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(35753), // Rule ID 71052 //
     /*   35662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35685 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35699 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35718 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35720 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35727 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35751 */     GIR_RootConstrainSelectedInstOperands,
     /*   35752 */     // GIR_Coverage, 71052,
     /*   35752 */     GIR_EraseRootFromParent_Done,
     /*   35753 */   // Label 621: @35753
     /*   35753 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(35849), // Rule ID 71053 //
     /*   35758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35795 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35814 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35816 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35823 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35847 */     GIR_RootConstrainSelectedInstOperands,
     /*   35848 */     // GIR_Coverage, 71053,
     /*   35848 */     GIR_EraseRootFromParent_Done,
     /*   35849 */   // Label 622: @35849
     /*   35849 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(35945), // Rule ID 52098 //
     /*   35854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35891 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35906 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35910 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35912 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35919 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35943 */     GIR_RootConstrainSelectedInstOperands,
     /*   35944 */     // GIR_Coverage, 52098,
     /*   35944 */     GIR_EraseRootFromParent_Done,
     /*   35945 */   // Label 623: @35945
     /*   35945 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(36041), // Rule ID 52099 //
     /*   35950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36002 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36006 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36008 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36015 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   36018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   36030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36039 */     GIR_RootConstrainSelectedInstOperands,
     /*   36040 */     // GIR_Coverage, 52099,
     /*   36040 */     GIR_EraseRootFromParent_Done,
     /*   36041 */   // Label 624: @36041
     /*   36041 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(36130), // Rule ID 46700 //
     /*   36046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36061 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36080 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36089 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36128 */     GIR_RootConstrainSelectedInstOperands,
     /*   36129 */     // GIR_Coverage, 46700,
     /*   36129 */     GIR_EraseRootFromParent_Done,
     /*   36130 */   // Label 625: @36130
     /*   36130 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(36219), // Rule ID 46701 //
     /*   36135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36169 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36178 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36217 */     GIR_RootConstrainSelectedInstOperands,
     /*   36218 */     // GIR_Coverage, 46701,
     /*   36218 */     GIR_EraseRootFromParent_Done,
     /*   36219 */   // Label 626: @36219
     /*   36219 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(36308), // Rule ID 46464 //
     /*   36224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36239 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36258 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36267 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   36284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36306 */     GIR_RootConstrainSelectedInstOperands,
     /*   36307 */     // GIR_Coverage, 46464,
     /*   36307 */     GIR_EraseRootFromParent_Done,
     /*   36308 */   // Label 627: @36308
     /*   36308 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(36397), // Rule ID 46465 //
     /*   36313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36347 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36356 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   36373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36395 */     GIR_RootConstrainSelectedInstOperands,
     /*   36396 */     // GIR_Coverage, 46465,
     /*   36396 */     GIR_EraseRootFromParent_Done,
     /*   36397 */   // Label 628: @36397
     /*   36397 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(36486), // Rule ID 46580 //
     /*   36402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36417 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36436 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36445 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36484 */     GIR_RootConstrainSelectedInstOperands,
     /*   36485 */     // GIR_Coverage, 46580,
     /*   36485 */     GIR_EraseRootFromParent_Done,
     /*   36486 */   // Label 629: @36486
     /*   36486 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(36575), // Rule ID 46581 //
     /*   36491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36506 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36525 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36534 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36573 */     GIR_RootConstrainSelectedInstOperands,
     /*   36574 */     // GIR_Coverage, 46581,
     /*   36574 */     GIR_EraseRootFromParent_Done,
     /*   36575 */   // Label 630: @36575
     /*   36575 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(36643), // Rule ID 70680 //
     /*   36580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36599 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36617 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   36617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   36620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36641 */     GIR_RootConstrainSelectedInstOperands,
     /*   36642 */     // GIR_Coverage, 70680,
     /*   36642 */     GIR_EraseRootFromParent_Done,
     /*   36643 */   // Label 631: @36643
     /*   36643 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(36711), // Rule ID 70681 //
     /*   36648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36667 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36685 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   36685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   36688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36709 */     GIR_RootConstrainSelectedInstOperands,
     /*   36710 */     // GIR_Coverage, 70681,
     /*   36710 */     GIR_EraseRootFromParent_Done,
     /*   36711 */   // Label 632: @36711
     /*   36711 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(36766), // Rule ID 69600 //
     /*   36716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36731 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36744 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   36747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36764 */     GIR_RootConstrainSelectedInstOperands,
     /*   36765 */     // GIR_Coverage, 69600,
     /*   36765 */     GIR_EraseRootFromParent_Done,
     /*   36766 */   // Label 633: @36766
     /*   36766 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(36821), // Rule ID 69601 //
     /*   36771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36799 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   36802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36819 */     GIR_RootConstrainSelectedInstOperands,
     /*   36820 */     // GIR_Coverage, 69601,
     /*   36820 */     GIR_EraseRootFromParent_Done,
     /*   36821 */   // Label 634: @36821
     /*   36821 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(36876), // Rule ID 69420 //
     /*   36826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36854 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   36857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36874 */     GIR_RootConstrainSelectedInstOperands,
     /*   36875 */     // GIR_Coverage, 69420,
     /*   36875 */     GIR_EraseRootFromParent_Done,
     /*   36876 */   // Label 635: @36876
     /*   36876 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(36931), // Rule ID 69421 //
     /*   36881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36909 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   36912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36929 */     GIR_RootConstrainSelectedInstOperands,
     /*   36930 */     // GIR_Coverage, 69421,
     /*   36930 */     GIR_EraseRootFromParent_Done,
     /*   36931 */   // Label 636: @36931
     /*   36931 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(36986), // Rule ID 69510 //
     /*   36936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36951 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36964 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   36967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36984 */     GIR_RootConstrainSelectedInstOperands,
     /*   36985 */     // GIR_Coverage, 69510,
     /*   36985 */     GIR_EraseRootFromParent_Done,
     /*   36986 */   // Label 637: @36986
     /*   36986 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(37041), // Rule ID 69511 //
     /*   36991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37006 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37019 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37039 */     GIR_RootConstrainSelectedInstOperands,
     /*   37040 */     // GIR_Coverage, 69511,
     /*   37040 */     GIR_EraseRootFromParent_Done,
     /*   37041 */   // Label 638: @37041
     /*   37041 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(37109), // Rule ID 51914 //
     /*   37046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37069 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37083 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37107 */     GIR_RootConstrainSelectedInstOperands,
     /*   37108 */     // GIR_Coverage, 51914,
     /*   37108 */     GIR_EraseRootFromParent_Done,
     /*   37109 */   // Label 639: @37109
     /*   37109 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(37177), // Rule ID 51915 //
     /*   37114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37137 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37151 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37175 */     GIR_RootConstrainSelectedInstOperands,
     /*   37176 */     // GIR_Coverage, 51915,
     /*   37176 */     GIR_EraseRootFromParent_Done,
     /*   37177 */   // Label 640: @37177
     /*   37177 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(37232), // Rule ID 46760 //
     /*   37182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37210 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37230 */     GIR_RootConstrainSelectedInstOperands,
     /*   37231 */     // GIR_Coverage, 46760,
     /*   37231 */     GIR_EraseRootFromParent_Done,
     /*   37232 */   // Label 641: @37232
     /*   37232 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(37287), // Rule ID 46761 //
     /*   37237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37265 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37285 */     GIR_RootConstrainSelectedInstOperands,
     /*   37286 */     // GIR_Coverage, 46761,
     /*   37286 */     GIR_EraseRootFromParent_Done,
     /*   37287 */   // Label 642: @37287
     /*   37287 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(37342), // Rule ID 46520 //
     /*   37292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37311 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37320 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37340 */     GIR_RootConstrainSelectedInstOperands,
     /*   37341 */     // GIR_Coverage, 46520,
     /*   37341 */     GIR_EraseRootFromParent_Done,
     /*   37342 */   // Label 643: @37342
     /*   37342 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(37397), // Rule ID 46521 //
     /*   37347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37375 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37395 */     GIR_RootConstrainSelectedInstOperands,
     /*   37396 */     // GIR_Coverage, 46521,
     /*   37396 */     GIR_EraseRootFromParent_Done,
     /*   37397 */   // Label 644: @37397
     /*   37397 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(37452), // Rule ID 46640 //
     /*   37402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37430 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37450 */     GIR_RootConstrainSelectedInstOperands,
     /*   37451 */     // GIR_Coverage, 46640,
     /*   37451 */     GIR_EraseRootFromParent_Done,
     /*   37452 */   // Label 645: @37452
     /*   37452 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(37507), // Rule ID 46641 //
     /*   37457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37476 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37485 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37505 */     GIR_RootConstrainSelectedInstOperands,
     /*   37506 */     // GIR_Coverage, 46641,
     /*   37506 */     GIR_EraseRootFromParent_Done,
     /*   37507 */   // Label 646: @37507
     /*   37507 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(37560), // Rule ID 46146 //
     /*   37512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37523 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   37523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   37526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   37530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   37540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   37547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37558 */     GIR_RootConstrainSelectedInstOperands,
     /*   37559 */     // GIR_Coverage, 46146,
     /*   37559 */     GIR_EraseRootFromParent_Done,
     /*   37560 */   // Label 647: @37560
     /*   37560 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(37613), // Rule ID 46147 //
     /*   37565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37576 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   37576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   37579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   37583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   37593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   37600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37611 */     GIR_RootConstrainSelectedInstOperands,
     /*   37612 */     // GIR_Coverage, 46147,
     /*   37612 */     GIR_EraseRootFromParent_Done,
     /*   37613 */   // Label 648: @37613
     /*   37613 */   GIM_Reject,
     /*   37614 */ // Label 608: @37614
     /*   37614 */ GIM_Reject,
     /*   37615 */ // Label 139: @37615
     /*   37615 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(40739),
     /*   37620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37630 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(37726), // Rule ID 70796 //
     /*   37635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   37638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37654 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37668 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37687 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37689 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37700 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   37703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37724 */     GIR_RootConstrainSelectedInstOperands,
     /*   37725 */     // GIR_Coverage, 70796,
     /*   37725 */     GIR_EraseRootFromParent_Done,
     /*   37726 */   // Label 650: @37726
     /*   37726 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(37822), // Rule ID 70797 //
     /*   37731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   37734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37750 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37764 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37779 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37783 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37785 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37796 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   37799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37820 */     GIR_RootConstrainSelectedInstOperands,
     /*   37821 */     // GIR_Coverage, 70797,
     /*   37821 */     GIR_EraseRootFromParent_Done,
     /*   37822 */   // Label 651: @37822
     /*   37822 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(37918), // Rule ID 71084 //
     /*   37827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   37830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37860 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37875 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37879 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37892 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   37895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37916 */     GIR_RootConstrainSelectedInstOperands,
     /*   37917 */     // GIR_Coverage, 71084,
     /*   37917 */     GIR_EraseRootFromParent_Done,
     /*   37918 */   // Label 652: @37918
     /*   37918 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(38014), // Rule ID 71085 //
     /*   37923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   37926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37942 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37956 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37958 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37971 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37975 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37977 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37988 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   37991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38012 */     GIR_RootConstrainSelectedInstOperands,
     /*   38013 */     // GIR_Coverage, 71085,
     /*   38013 */     GIR_EraseRootFromParent_Done,
     /*   38014 */   // Label 653: @38014
     /*   38014 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(38110), // Rule ID 71086 //
     /*   38019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38038 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38052 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38071 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38073 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38084 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38108 */     GIR_RootConstrainSelectedInstOperands,
     /*   38109 */     // GIR_Coverage, 71086,
     /*   38109 */     GIR_EraseRootFromParent_Done,
     /*   38110 */   // Label 654: @38110
     /*   38110 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(38206), // Rule ID 71087 //
     /*   38115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38148 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38163 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38167 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38169 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38180 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38204 */     GIR_RootConstrainSelectedInstOperands,
     /*   38205 */     // GIR_Coverage, 71087,
     /*   38205 */     GIR_EraseRootFromParent_Done,
     /*   38206 */   // Label 655: @38206
     /*   38206 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(38302), // Rule ID 70910 //
     /*   38211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38230 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38244 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38259 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38263 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38265 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38276 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   38279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38300 */     GIR_RootConstrainSelectedInstOperands,
     /*   38301 */     // GIR_Coverage, 70910,
     /*   38301 */     GIR_EraseRootFromParent_Done,
     /*   38302 */   // Label 656: @38302
     /*   38302 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(38398), // Rule ID 70911 //
     /*   38307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38340 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38355 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38359 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38361 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38372 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   38375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38396 */     GIR_RootConstrainSelectedInstOperands,
     /*   38397 */     // GIR_Coverage, 70911,
     /*   38397 */     GIR_EraseRootFromParent_Done,
     /*   38398 */   // Label 657: @38398
     /*   38398 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(38494), // Rule ID 52050 //
     /*   38403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38459 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38461 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38468 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38492 */     GIR_RootConstrainSelectedInstOperands,
     /*   38493 */     // GIR_Coverage, 52050,
     /*   38493 */     GIR_EraseRootFromParent_Done,
     /*   38494 */   // Label 658: @38494
     /*   38494 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(38590), // Rule ID 52051 //
     /*   38499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38522 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38536 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38555 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38557 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38564 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38588 */     GIR_RootConstrainSelectedInstOperands,
     /*   38589 */     // GIR_Coverage, 52051,
     /*   38589 */     GIR_EraseRootFromParent_Done,
     /*   38590 */   // Label 659: @38590
     /*   38590 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(38686), // Rule ID 52168 //
     /*   38595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38618 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38632 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38647 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38651 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38653 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38660 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38684 */     GIR_RootConstrainSelectedInstOperands,
     /*   38685 */     // GIR_Coverage, 52168,
     /*   38685 */     GIR_EraseRootFromParent_Done,
     /*   38686 */   // Label 660: @38686
     /*   38686 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(38782), // Rule ID 52169 //
     /*   38691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38714 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38743 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38747 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38749 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38756 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38780 */     GIR_RootConstrainSelectedInstOperands,
     /*   38781 */     // GIR_Coverage, 52169,
     /*   38781 */     GIR_EraseRootFromParent_Done,
     /*   38782 */   // Label 661: @38782
     /*   38782 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(38878), // Rule ID 71082 //
     /*   38787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38810 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38824 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38839 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38843 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38845 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38852 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38876 */     GIR_RootConstrainSelectedInstOperands,
     /*   38877 */     // GIR_Coverage, 71082,
     /*   38877 */     GIR_EraseRootFromParent_Done,
     /*   38878 */   // Label 662: @38878
     /*   38878 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(38974), // Rule ID 71083 //
     /*   38883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38906 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38920 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38935 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38939 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38941 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38948 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38972 */     GIR_RootConstrainSelectedInstOperands,
     /*   38973 */     // GIR_Coverage, 71083,
     /*   38973 */     GIR_EraseRootFromParent_Done,
     /*   38974 */   // Label 663: @38974
     /*   38974 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(39070), // Rule ID 52108 //
     /*   38979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39016 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39031 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39035 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39037 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39044 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   39047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39068 */     GIR_RootConstrainSelectedInstOperands,
     /*   39069 */     // GIR_Coverage, 52108,
     /*   39069 */     GIR_EraseRootFromParent_Done,
     /*   39070 */   // Label 664: @39070
     /*   39070 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(39166), // Rule ID 52109 //
     /*   39075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39098 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39112 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39131 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39133 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39140 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   39143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39164 */     GIR_RootConstrainSelectedInstOperands,
     /*   39165 */     // GIR_Coverage, 52109,
     /*   39165 */     GIR_EraseRootFromParent_Done,
     /*   39166 */   // Label 665: @39166
     /*   39166 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(39255), // Rule ID 46720 //
     /*   39171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39186 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39205 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39214 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39253 */     GIR_RootConstrainSelectedInstOperands,
     /*   39254 */     // GIR_Coverage, 46720,
     /*   39254 */     GIR_EraseRootFromParent_Done,
     /*   39255 */   // Label 666: @39255
     /*   39255 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(39344), // Rule ID 46721 //
     /*   39260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39275 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39294 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39303 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39342 */     GIR_RootConstrainSelectedInstOperands,
     /*   39343 */     // GIR_Coverage, 46721,
     /*   39343 */     GIR_EraseRootFromParent_Done,
     /*   39344 */   // Label 667: @39344
     /*   39344 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(39433), // Rule ID 46484 //
     /*   39349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39364 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39383 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39392 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   39409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39431 */     GIR_RootConstrainSelectedInstOperands,
     /*   39432 */     // GIR_Coverage, 46484,
     /*   39432 */     GIR_EraseRootFromParent_Done,
     /*   39433 */   // Label 668: @39433
     /*   39433 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(39522), // Rule ID 46485 //
     /*   39438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39453 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39472 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39481 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   39498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39520 */     GIR_RootConstrainSelectedInstOperands,
     /*   39521 */     // GIR_Coverage, 46485,
     /*   39521 */     GIR_EraseRootFromParent_Done,
     /*   39522 */   // Label 669: @39522
     /*   39522 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(39611), // Rule ID 46600 //
     /*   39527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39542 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39561 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39570 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39609 */     GIR_RootConstrainSelectedInstOperands,
     /*   39610 */     // GIR_Coverage, 46600,
     /*   39610 */     GIR_EraseRootFromParent_Done,
     /*   39611 */   // Label 670: @39611
     /*   39611 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(39700), // Rule ID 46601 //
     /*   39616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39631 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39650 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39659 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39698 */     GIR_RootConstrainSelectedInstOperands,
     /*   39699 */     // GIR_Coverage, 46601,
     /*   39699 */     GIR_EraseRootFromParent_Done,
     /*   39700 */   // Label 671: @39700
     /*   39700 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(39768), // Rule ID 70712 //
     /*   39705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   39708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39724 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39742 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   39742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   39745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   39751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   39763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39766 */     GIR_RootConstrainSelectedInstOperands,
     /*   39767 */     // GIR_Coverage, 70712,
     /*   39767 */     GIR_EraseRootFromParent_Done,
     /*   39768 */   // Label 672: @39768
     /*   39768 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(39836), // Rule ID 70713 //
     /*   39773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   39776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39792 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39810 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   39810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   39813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   39819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   39831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39834 */     GIR_RootConstrainSelectedInstOperands,
     /*   39835 */     // GIR_Coverage, 70713,
     /*   39835 */     GIR_EraseRootFromParent_Done,
     /*   39836 */   // Label 673: @39836
     /*   39836 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(39891), // Rule ID 69620 //
     /*   39841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39856 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39869 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   39872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39889 */     GIR_RootConstrainSelectedInstOperands,
     /*   39890 */     // GIR_Coverage, 69620,
     /*   39890 */     GIR_EraseRootFromParent_Done,
     /*   39891 */   // Label 674: @39891
     /*   39891 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(39946), // Rule ID 69621 //
     /*   39896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39911 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39924 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   39927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39944 */     GIR_RootConstrainSelectedInstOperands,
     /*   39945 */     // GIR_Coverage, 69621,
     /*   39945 */     GIR_EraseRootFromParent_Done,
     /*   39946 */   // Label 675: @39946
     /*   39946 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(40001), // Rule ID 69440 //
     /*   39951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39979 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   39982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39999 */     GIR_RootConstrainSelectedInstOperands,
     /*   40000 */     // GIR_Coverage, 69440,
     /*   40000 */     GIR_EraseRootFromParent_Done,
     /*   40001 */   // Label 676: @40001
     /*   40001 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(40056), // Rule ID 69441 //
     /*   40006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40021 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40034 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40054 */     GIR_RootConstrainSelectedInstOperands,
     /*   40055 */     // GIR_Coverage, 69441,
     /*   40055 */     GIR_EraseRootFromParent_Done,
     /*   40056 */   // Label 677: @40056
     /*   40056 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(40111), // Rule ID 69530 //
     /*   40061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40089 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40109 */     GIR_RootConstrainSelectedInstOperands,
     /*   40110 */     // GIR_Coverage, 69530,
     /*   40110 */     GIR_EraseRootFromParent_Done,
     /*   40111 */   // Label 678: @40111
     /*   40111 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(40166), // Rule ID 69531 //
     /*   40116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40131 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40144 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40164 */     GIR_RootConstrainSelectedInstOperands,
     /*   40165 */     // GIR_Coverage, 69531,
     /*   40165 */     GIR_EraseRootFromParent_Done,
     /*   40166 */   // Label 679: @40166
     /*   40166 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(40234), // Rule ID 51930 //
     /*   40171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   40174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40194 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40208 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   40208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40232 */     GIR_RootConstrainSelectedInstOperands,
     /*   40233 */     // GIR_Coverage, 51930,
     /*   40233 */     GIR_EraseRootFromParent_Done,
     /*   40234 */   // Label 680: @40234
     /*   40234 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(40302), // Rule ID 51931 //
     /*   40239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   40242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40262 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40276 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   40276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40300 */     GIR_RootConstrainSelectedInstOperands,
     /*   40301 */     // GIR_Coverage, 51931,
     /*   40301 */     GIR_EraseRootFromParent_Done,
     /*   40302 */   // Label 681: @40302
     /*   40302 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(40357), // Rule ID 46780 //
     /*   40307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40335 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40355 */     GIR_RootConstrainSelectedInstOperands,
     /*   40356 */     // GIR_Coverage, 46780,
     /*   40356 */     GIR_EraseRootFromParent_Done,
     /*   40357 */   // Label 682: @40357
     /*   40357 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(40412), // Rule ID 46781 //
     /*   40362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40390 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40410 */     GIR_RootConstrainSelectedInstOperands,
     /*   40411 */     // GIR_Coverage, 46781,
     /*   40411 */     GIR_EraseRootFromParent_Done,
     /*   40412 */   // Label 683: @40412
     /*   40412 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(40467), // Rule ID 46540 //
     /*   40417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40445 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40465 */     GIR_RootConstrainSelectedInstOperands,
     /*   40466 */     // GIR_Coverage, 46540,
     /*   40466 */     GIR_EraseRootFromParent_Done,
     /*   40467 */   // Label 684: @40467
     /*   40467 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(40522), // Rule ID 46541 //
     /*   40472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40500 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40520 */     GIR_RootConstrainSelectedInstOperands,
     /*   40521 */     // GIR_Coverage, 46541,
     /*   40521 */     GIR_EraseRootFromParent_Done,
     /*   40522 */   // Label 685: @40522
     /*   40522 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(40577), // Rule ID 46660 //
     /*   40527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40555 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40575 */     GIR_RootConstrainSelectedInstOperands,
     /*   40576 */     // GIR_Coverage, 46660,
     /*   40576 */     GIR_EraseRootFromParent_Done,
     /*   40577 */   // Label 686: @40577
     /*   40577 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(40632), // Rule ID 46661 //
     /*   40582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40601 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40610 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40630 */     GIR_RootConstrainSelectedInstOperands,
     /*   40631 */     // GIR_Coverage, 46661,
     /*   40631 */     GIR_EraseRootFromParent_Done,
     /*   40632 */   // Label 687: @40632
     /*   40632 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(40685), // Rule ID 46162 //
     /*   40637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   40640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40648 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   40648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   40651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   40665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   40672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40683 */     GIR_RootConstrainSelectedInstOperands,
     /*   40684 */     // GIR_Coverage, 46162,
     /*   40684 */     GIR_EraseRootFromParent_Done,
     /*   40685 */   // Label 688: @40685
     /*   40685 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(40738), // Rule ID 46163 //
     /*   40690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   40693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40701 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   40701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   40704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   40718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   40725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40736 */     GIR_RootConstrainSelectedInstOperands,
     /*   40737 */     // GIR_Coverage, 46163,
     /*   40737 */     GIR_EraseRootFromParent_Done,
     /*   40738 */   // Label 689: @40738
     /*   40738 */   GIM_Reject,
     /*   40739 */ // Label 649: @40739
     /*   40739 */ GIM_Reject,
     /*   40740 */ // Label 140: @40740
     /*   40740 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(41134),
     /*   40745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40755 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(40823), // Rule ID 70600 //
     /*   40760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40797 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   40797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   40800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40821 */     GIR_RootConstrainSelectedInstOperands,
     /*   40822 */     // GIR_Coverage, 70600,
     /*   40822 */     GIR_EraseRootFromParent_Done,
     /*   40823 */   // Label 691: @40823
     /*   40823 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(40891), // Rule ID 70601 //
     /*   40828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   40831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40847 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40865 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   40865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   40868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40889 */     GIR_RootConstrainSelectedInstOperands,
     /*   40890 */     // GIR_Coverage, 70601,
     /*   40890 */     GIR_EraseRootFromParent_Done,
     /*   40891 */   // Label 692: @40891
     /*   40891 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(40959), // Rule ID 51874 //
     /*   40896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40919 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40933 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   40933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   40936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40957 */     GIR_RootConstrainSelectedInstOperands,
     /*   40958 */     // GIR_Coverage, 51874,
     /*   40958 */     GIR_EraseRootFromParent_Done,
     /*   40959 */   // Label 693: @40959
     /*   40959 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(41027), // Rule ID 51875 //
     /*   40964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   40967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40987 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41001 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   41004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   41010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   41016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41025 */     GIR_RootConstrainSelectedInstOperands,
     /*   41026 */     // GIR_Coverage, 51875,
     /*   41026 */     GIR_EraseRootFromParent_Done,
     /*   41027 */   // Label 694: @41027
     /*   41027 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(41080), // Rule ID 46106 //
     /*   41032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41043 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   41043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   41046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   41060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41078 */     GIR_RootConstrainSelectedInstOperands,
     /*   41079 */     // GIR_Coverage, 46106,
     /*   41079 */     GIR_EraseRootFromParent_Done,
     /*   41080 */   // Label 695: @41080
     /*   41080 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(41133), // Rule ID 46107 //
     /*   41085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41096 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   41096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   41099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   41113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41131 */     GIR_RootConstrainSelectedInstOperands,
     /*   41132 */     // GIR_Coverage, 46107,
     /*   41132 */     GIR_EraseRootFromParent_Done,
     /*   41133 */   // Label 696: @41133
     /*   41133 */   GIM_Reject,
     /*   41134 */ // Label 690: @41134
     /*   41134 */ GIM_Reject,
     /*   41135 */ // Label 141: @41135
     /*   41135 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(44259),
     /*   41140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41150 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(41246), // Rule ID 70776 //
     /*   41155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41174 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41188 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41203 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41207 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41209 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41220 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41244 */     GIR_RootConstrainSelectedInstOperands,
     /*   41245 */     // GIR_Coverage, 70776,
     /*   41245 */     GIR_EraseRootFromParent_Done,
     /*   41246 */   // Label 698: @41246
     /*   41246 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(41342), // Rule ID 70777 //
     /*   41251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41270 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41284 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41299 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41303 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41305 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41316 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41340 */     GIR_RootConstrainSelectedInstOperands,
     /*   41341 */     // GIR_Coverage, 70777,
     /*   41341 */     GIR_EraseRootFromParent_Done,
     /*   41342 */   // Label 699: @41342
     /*   41342 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(41438), // Rule ID 71024 //
     /*   41347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41380 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41399 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41401 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41412 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41436 */     GIR_RootConstrainSelectedInstOperands,
     /*   41437 */     // GIR_Coverage, 71024,
     /*   41437 */     GIR_EraseRootFromParent_Done,
     /*   41438 */   // Label 700: @41438
     /*   41438 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(41534), // Rule ID 71025 //
     /*   41443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41462 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41476 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41491 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41495 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41497 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41508 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41532 */     GIR_RootConstrainSelectedInstOperands,
     /*   41533 */     // GIR_Coverage, 71025,
     /*   41533 */     GIR_EraseRootFromParent_Done,
     /*   41534 */   // Label 701: @41534
     /*   41534 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(41630), // Rule ID 71026 //
     /*   41539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41572 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41591 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41593 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41602 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41604 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   41615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   41619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41628 */     GIR_RootConstrainSelectedInstOperands,
     /*   41629 */     // GIR_Coverage, 71026,
     /*   41629 */     GIR_EraseRootFromParent_Done,
     /*   41630 */   // Label 702: @41630
     /*   41630 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(41726), // Rule ID 71027 //
     /*   41635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41654 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41668 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41687 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41689 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41700 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   41711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   41715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41724 */     GIR_RootConstrainSelectedInstOperands,
     /*   41725 */     // GIR_Coverage, 71027,
     /*   41725 */     GIR_EraseRootFromParent_Done,
     /*   41726 */   // Label 703: @41726
     /*   41726 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(41822), // Rule ID 70890 //
     /*   41731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41750 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41764 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41779 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41783 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41785 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41796 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   41799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41820 */     GIR_RootConstrainSelectedInstOperands,
     /*   41821 */     // GIR_Coverage, 70890,
     /*   41821 */     GIR_EraseRootFromParent_Done,
     /*   41822 */   // Label 704: @41822
     /*   41822 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(41918), // Rule ID 70891 //
     /*   41827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41860 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41875 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41879 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41892 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   41895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41916 */     GIR_RootConstrainSelectedInstOperands,
     /*   41917 */     // GIR_Coverage, 70891,
     /*   41917 */     GIR_EraseRootFromParent_Done,
     /*   41918 */   // Label 705: @41918
     /*   41918 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(42014), // Rule ID 52030 //
     /*   41923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41960 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41979 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41981 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41988 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   41995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42012 */     GIR_RootConstrainSelectedInstOperands,
     /*   42013 */     // GIR_Coverage, 52030,
     /*   42013 */     GIR_EraseRootFromParent_Done,
     /*   42014 */   // Label 706: @42014
     /*   42014 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(42110), // Rule ID 52031 //
     /*   42019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42042 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42056 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42071 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42075 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42077 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42084 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   42087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42108 */     GIR_RootConstrainSelectedInstOperands,
     /*   42109 */     // GIR_Coverage, 52031,
     /*   42109 */     GIR_EraseRootFromParent_Done,
     /*   42110 */   // Label 707: @42110
     /*   42110 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(42206), // Rule ID 52148 //
     /*   42115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42138 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42152 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42167 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42171 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42173 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42180 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42204 */     GIR_RootConstrainSelectedInstOperands,
     /*   42205 */     // GIR_Coverage, 52148,
     /*   42205 */     GIR_EraseRootFromParent_Done,
     /*   42206 */   // Label 708: @42206
     /*   42206 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(42302), // Rule ID 52149 //
     /*   42211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42234 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42248 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42263 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42267 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42269 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42276 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42300 */     GIR_RootConstrainSelectedInstOperands,
     /*   42301 */     // GIR_Coverage, 52149,
     /*   42301 */     GIR_EraseRootFromParent_Done,
     /*   42302 */   // Label 709: @42302
     /*   42302 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(42398), // Rule ID 71022 //
     /*   42307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42330 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42344 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42359 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42363 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42365 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42372 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42396 */     GIR_RootConstrainSelectedInstOperands,
     /*   42397 */     // GIR_Coverage, 71022,
     /*   42397 */     GIR_EraseRootFromParent_Done,
     /*   42398 */   // Label 710: @42398
     /*   42398 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(42494), // Rule ID 71023 //
     /*   42403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42459 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42461 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42468 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42492 */     GIR_RootConstrainSelectedInstOperands,
     /*   42493 */     // GIR_Coverage, 71023,
     /*   42493 */     GIR_EraseRootFromParent_Done,
     /*   42494 */   // Label 711: @42494
     /*   42494 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(42590), // Rule ID 52088 //
     /*   42499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42522 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42536 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42555 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42557 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42564 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   42567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42588 */     GIR_RootConstrainSelectedInstOperands,
     /*   42589 */     // GIR_Coverage, 52088,
     /*   42589 */     GIR_EraseRootFromParent_Done,
     /*   42590 */   // Label 712: @42590
     /*   42590 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(42686), // Rule ID 52089 //
     /*   42595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42618 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42632 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42647 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42651 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42653 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42660 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   42663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42684 */     GIR_RootConstrainSelectedInstOperands,
     /*   42685 */     // GIR_Coverage, 52089,
     /*   42685 */     GIR_EraseRootFromParent_Done,
     /*   42686 */   // Label 713: @42686
     /*   42686 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(42775), // Rule ID 46680 //
     /*   42691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42706 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42725 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42734 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   42734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   42737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   42751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42773 */     GIR_RootConstrainSelectedInstOperands,
     /*   42774 */     // GIR_Coverage, 46680,
     /*   42774 */     GIR_EraseRootFromParent_Done,
     /*   42775 */   // Label 714: @42775
     /*   42775 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(42864), // Rule ID 46681 //
     /*   42780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42795 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42814 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42823 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   42823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   42826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   42840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42862 */     GIR_RootConstrainSelectedInstOperands,
     /*   42863 */     // GIR_Coverage, 46681,
     /*   42863 */     GIR_EraseRootFromParent_Done,
     /*   42864 */   // Label 715: @42864
     /*   42864 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(42953), // Rule ID 46444 //
     /*   42869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42884 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42903 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42912 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   42912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   42915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   42929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42951 */     GIR_RootConstrainSelectedInstOperands,
     /*   42952 */     // GIR_Coverage, 46444,
     /*   42952 */     GIR_EraseRootFromParent_Done,
     /*   42953 */   // Label 716: @42953
     /*   42953 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(43042), // Rule ID 46445 //
     /*   42958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42992 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42994 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43001 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   43018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43040 */     GIR_RootConstrainSelectedInstOperands,
     /*   43041 */     // GIR_Coverage, 46445,
     /*   43041 */     GIR_EraseRootFromParent_Done,
     /*   43042 */   // Label 717: @43042
     /*   43042 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(43131), // Rule ID 46560 //
     /*   43047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43062 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43081 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43090 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   43090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43129 */     GIR_RootConstrainSelectedInstOperands,
     /*   43130 */     // GIR_Coverage, 46560,
     /*   43130 */     GIR_EraseRootFromParent_Done,
     /*   43131 */   // Label 718: @43131
     /*   43131 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(43220), // Rule ID 46561 //
     /*   43136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43170 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43179 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43218 */     GIR_RootConstrainSelectedInstOperands,
     /*   43219 */     // GIR_Coverage, 46561,
     /*   43219 */     GIR_EraseRootFromParent_Done,
     /*   43220 */   // Label 719: @43220
     /*   43220 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(43288), // Rule ID 70656 //
     /*   43225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43244 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43262 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   43262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43286 */     GIR_RootConstrainSelectedInstOperands,
     /*   43287 */     // GIR_Coverage, 70656,
     /*   43287 */     GIR_EraseRootFromParent_Done,
     /*   43288 */   // Label 720: @43288
     /*   43288 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(43356), // Rule ID 70657 //
     /*   43293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43330 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   43330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43354 */     GIR_RootConstrainSelectedInstOperands,
     /*   43355 */     // GIR_Coverage, 70657,
     /*   43355 */     GIR_EraseRootFromParent_Done,
     /*   43356 */   // Label 721: @43356
     /*   43356 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(43411), // Rule ID 69580 //
     /*   43361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43376 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43389 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43409 */     GIR_RootConstrainSelectedInstOperands,
     /*   43410 */     // GIR_Coverage, 69580,
     /*   43410 */     GIR_EraseRootFromParent_Done,
     /*   43411 */   // Label 722: @43411
     /*   43411 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(43466), // Rule ID 69581 //
     /*   43416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43444 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43464 */     GIR_RootConstrainSelectedInstOperands,
     /*   43465 */     // GIR_Coverage, 69581,
     /*   43465 */     GIR_EraseRootFromParent_Done,
     /*   43466 */   // Label 723: @43466
     /*   43466 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(43521), // Rule ID 69400 //
     /*   43471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43499 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43519 */     GIR_RootConstrainSelectedInstOperands,
     /*   43520 */     // GIR_Coverage, 69400,
     /*   43520 */     GIR_EraseRootFromParent_Done,
     /*   43521 */   // Label 724: @43521
     /*   43521 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(43576), // Rule ID 69401 //
     /*   43526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43554 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43574 */     GIR_RootConstrainSelectedInstOperands,
     /*   43575 */     // GIR_Coverage, 69401,
     /*   43575 */     GIR_EraseRootFromParent_Done,
     /*   43576 */   // Label 725: @43576
     /*   43576 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(43631), // Rule ID 69490 //
     /*   43581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43596 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43609 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43629 */     GIR_RootConstrainSelectedInstOperands,
     /*   43630 */     // GIR_Coverage, 69490,
     /*   43630 */     GIR_EraseRootFromParent_Done,
     /*   43631 */   // Label 726: @43631
     /*   43631 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(43686), // Rule ID 69491 //
     /*   43636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43651 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43664 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43684 */     GIR_RootConstrainSelectedInstOperands,
     /*   43685 */     // GIR_Coverage, 69491,
     /*   43685 */     GIR_EraseRootFromParent_Done,
     /*   43686 */   // Label 727: @43686
     /*   43686 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(43754), // Rule ID 51902 //
     /*   43691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43714 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43728 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   43728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43752 */     GIR_RootConstrainSelectedInstOperands,
     /*   43753 */     // GIR_Coverage, 51902,
     /*   43753 */     GIR_EraseRootFromParent_Done,
     /*   43754 */   // Label 728: @43754
     /*   43754 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(43822), // Rule ID 51903 //
     /*   43759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43782 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43796 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   43796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43820 */     GIR_RootConstrainSelectedInstOperands,
     /*   43821 */     // GIR_Coverage, 51903,
     /*   43821 */     GIR_EraseRootFromParent_Done,
     /*   43822 */   // Label 729: @43822
     /*   43822 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(43877), // Rule ID 46740 //
     /*   43827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43855 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43875 */     GIR_RootConstrainSelectedInstOperands,
     /*   43876 */     // GIR_Coverage, 46740,
     /*   43876 */     GIR_EraseRootFromParent_Done,
     /*   43877 */   // Label 730: @43877
     /*   43877 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(43932), // Rule ID 46741 //
     /*   43882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43910 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43930 */     GIR_RootConstrainSelectedInstOperands,
     /*   43931 */     // GIR_Coverage, 46741,
     /*   43931 */     GIR_EraseRootFromParent_Done,
     /*   43932 */   // Label 731: @43932
     /*   43932 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(43987), // Rule ID 46500 //
     /*   43937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43965 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43985 */     GIR_RootConstrainSelectedInstOperands,
     /*   43986 */     // GIR_Coverage, 46500,
     /*   43986 */     GIR_EraseRootFromParent_Done,
     /*   43987 */   // Label 732: @43987
     /*   43987 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(44042), // Rule ID 46501 //
     /*   43992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44020 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   44023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44040 */     GIR_RootConstrainSelectedInstOperands,
     /*   44041 */     // GIR_Coverage, 46501,
     /*   44041 */     GIR_EraseRootFromParent_Done,
     /*   44042 */   // Label 733: @44042
     /*   44042 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(44097), // Rule ID 46620 //
     /*   44047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44075 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   44075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44095 */     GIR_RootConstrainSelectedInstOperands,
     /*   44096 */     // GIR_Coverage, 46620,
     /*   44096 */     GIR_EraseRootFromParent_Done,
     /*   44097 */   // Label 734: @44097
     /*   44097 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(44152), // Rule ID 46621 //
     /*   44102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44130 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44150 */     GIR_RootConstrainSelectedInstOperands,
     /*   44151 */     // GIR_Coverage, 46621,
     /*   44151 */     GIR_EraseRootFromParent_Done,
     /*   44152 */   // Label 735: @44152
     /*   44152 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(44205), // Rule ID 46134 //
     /*   44157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44168 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   44168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   44171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   44185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44203 */     GIR_RootConstrainSelectedInstOperands,
     /*   44204 */     // GIR_Coverage, 46134,
     /*   44204 */     GIR_EraseRootFromParent_Done,
     /*   44205 */   // Label 736: @44205
     /*   44205 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(44258), // Rule ID 46135 //
     /*   44210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44221 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   44221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   44224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   44238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44256 */     GIR_RootConstrainSelectedInstOperands,
     /*   44257 */     // GIR_Coverage, 46135,
     /*   44257 */     GIR_EraseRootFromParent_Done,
     /*   44258 */   // Label 737: @44258
     /*   44258 */   GIM_Reject,
     /*   44259 */ // Label 697: @44259
     /*   44259 */ GIM_Reject,
     /*   44260 */ // Label 142: @44260
     /*   44260 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(47384),
     /*   44265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44275 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(44371), // Rule ID 70788 //
     /*   44280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44299 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44313 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44328 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44332 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44334 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44345 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   44348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44369 */     GIR_RootConstrainSelectedInstOperands,
     /*   44370 */     // GIR_Coverage, 70788,
     /*   44370 */     GIR_EraseRootFromParent_Done,
     /*   44371 */   // Label 739: @44371
     /*   44371 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(44467), // Rule ID 70789 //
     /*   44376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44395 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44409 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44424 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44428 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44430 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44441 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   44444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44465 */     GIR_RootConstrainSelectedInstOperands,
     /*   44466 */     // GIR_Coverage, 70789,
     /*   44466 */     GIR_EraseRootFromParent_Done,
     /*   44467 */   // Label 740: @44467
     /*   44467 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(44563), // Rule ID 71060 //
     /*   44472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44505 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44520 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44524 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44526 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44537 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44561 */     GIR_RootConstrainSelectedInstOperands,
     /*   44562 */     // GIR_Coverage, 71060,
     /*   44562 */     GIR_EraseRootFromParent_Done,
     /*   44563 */   // Label 741: @44563
     /*   44563 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(44659), // Rule ID 71061 //
     /*   44568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44587 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44601 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44616 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44620 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44622 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44631 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44633 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44657 */     GIR_RootConstrainSelectedInstOperands,
     /*   44658 */     // GIR_Coverage, 71061,
     /*   44658 */     GIR_EraseRootFromParent_Done,
     /*   44659 */   // Label 742: @44659
     /*   44659 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(44755), // Rule ID 71062 //
     /*   44664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44683 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44697 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44712 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44716 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44718 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44727 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44729 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   44740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   44744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44753 */     GIR_RootConstrainSelectedInstOperands,
     /*   44754 */     // GIR_Coverage, 71062,
     /*   44754 */     GIR_EraseRootFromParent_Done,
     /*   44755 */   // Label 743: @44755
     /*   44755 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(44851), // Rule ID 71063 //
     /*   44760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44793 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44795 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44808 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44812 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44814 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44825 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   44836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   44840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44849 */     GIR_RootConstrainSelectedInstOperands,
     /*   44850 */     // GIR_Coverage, 71063,
     /*   44850 */     GIR_EraseRootFromParent_Done,
     /*   44851 */   // Label 744: @44851
     /*   44851 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(44947), // Rule ID 70902 //
     /*   44856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44875 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44889 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44904 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44908 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44910 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44921 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   44924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44945 */     GIR_RootConstrainSelectedInstOperands,
     /*   44946 */     // GIR_Coverage, 70902,
     /*   44946 */     GIR_EraseRootFromParent_Done,
     /*   44947 */   // Label 745: @44947
     /*   44947 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(45043), // Rule ID 70903 //
     /*   44952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44971 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44985 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45000 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45004 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45006 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45017 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45041 */     GIR_RootConstrainSelectedInstOperands,
     /*   45042 */     // GIR_Coverage, 70903,
     /*   45042 */     GIR_EraseRootFromParent_Done,
     /*   45043 */   // Label 746: @45043
     /*   45043 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(45139), // Rule ID 52042 //
     /*   45048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45071 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45085 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45104 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45106 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45113 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   45116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45137 */     GIR_RootConstrainSelectedInstOperands,
     /*   45138 */     // GIR_Coverage, 52042,
     /*   45138 */     GIR_EraseRootFromParent_Done,
     /*   45139 */   // Label 747: @45139
     /*   45139 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(45235), // Rule ID 52043 //
     /*   45144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45167 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45181 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45200 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45202 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45209 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   45212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45233 */     GIR_RootConstrainSelectedInstOperands,
     /*   45234 */     // GIR_Coverage, 52043,
     /*   45234 */     GIR_EraseRootFromParent_Done,
     /*   45235 */   // Label 748: @45235
     /*   45235 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(45331), // Rule ID 52160 //
     /*   45240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45263 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45277 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45292 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45296 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45305 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45329 */     GIR_RootConstrainSelectedInstOperands,
     /*   45330 */     // GIR_Coverage, 52160,
     /*   45330 */     GIR_EraseRootFromParent_Done,
     /*   45331 */   // Label 749: @45331
     /*   45331 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(45427), // Rule ID 52161 //
     /*   45336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45359 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45373 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45388 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45392 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45394 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45401 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45425 */     GIR_RootConstrainSelectedInstOperands,
     /*   45426 */     // GIR_Coverage, 52161,
     /*   45426 */     GIR_EraseRootFromParent_Done,
     /*   45427 */   // Label 750: @45427
     /*   45427 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(45523), // Rule ID 71058 //
     /*   45432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45455 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45469 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45484 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45488 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45490 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45497 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45521 */     GIR_RootConstrainSelectedInstOperands,
     /*   45522 */     // GIR_Coverage, 71058,
     /*   45522 */     GIR_EraseRootFromParent_Done,
     /*   45523 */   // Label 751: @45523
     /*   45523 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(45619), // Rule ID 71059 //
     /*   45528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45551 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45565 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45580 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45584 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45586 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45593 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45617 */     GIR_RootConstrainSelectedInstOperands,
     /*   45618 */     // GIR_Coverage, 71059,
     /*   45618 */     GIR_EraseRootFromParent_Done,
     /*   45619 */   // Label 752: @45619
     /*   45619 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(45715), // Rule ID 52100 //
     /*   45624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45661 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45676 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45680 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45682 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45689 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45713 */     GIR_RootConstrainSelectedInstOperands,
     /*   45714 */     // GIR_Coverage, 52100,
     /*   45714 */     GIR_EraseRootFromParent_Done,
     /*   45715 */   // Label 753: @45715
     /*   45715 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(45811), // Rule ID 52101 //
     /*   45720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45743 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45757 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45772 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45776 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45778 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45785 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45809 */     GIR_RootConstrainSelectedInstOperands,
     /*   45810 */     // GIR_Coverage, 52101,
     /*   45810 */     GIR_EraseRootFromParent_Done,
     /*   45811 */   // Label 754: @45811
     /*   45811 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(45900), // Rule ID 46704 //
     /*   45816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   45842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45850 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45859 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   45859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   45862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   45876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45898 */     GIR_RootConstrainSelectedInstOperands,
     /*   45899 */     // GIR_Coverage, 46704,
     /*   45899 */     GIR_EraseRootFromParent_Done,
     /*   45900 */   // Label 755: @45900
     /*   45900 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(45989), // Rule ID 46705 //
     /*   45905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   45931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45939 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45948 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   45948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   45951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   45965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45987 */     GIR_RootConstrainSelectedInstOperands,
     /*   45988 */     // GIR_Coverage, 46705,
     /*   45988 */     GIR_EraseRootFromParent_Done,
     /*   45989 */   // Label 756: @45989
     /*   45989 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(46078), // Rule ID 46468 //
     /*   45994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46009 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46028 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46037 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   46054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46076 */     GIR_RootConstrainSelectedInstOperands,
     /*   46077 */     // GIR_Coverage, 46468,
     /*   46077 */     GIR_EraseRootFromParent_Done,
     /*   46078 */   // Label 757: @46078
     /*   46078 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(46167), // Rule ID 46469 //
     /*   46083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46098 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46117 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46126 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   46143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46165 */     GIR_RootConstrainSelectedInstOperands,
     /*   46166 */     // GIR_Coverage, 46469,
     /*   46166 */     GIR_EraseRootFromParent_Done,
     /*   46167 */   // Label 758: @46167
     /*   46167 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(46256), // Rule ID 46584 //
     /*   46172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46187 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46206 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46215 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46254 */     GIR_RootConstrainSelectedInstOperands,
     /*   46255 */     // GIR_Coverage, 46584,
     /*   46255 */     GIR_EraseRootFromParent_Done,
     /*   46256 */   // Label 759: @46256
     /*   46256 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(46345), // Rule ID 46585 //
     /*   46261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46276 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46295 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46304 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46343 */     GIR_RootConstrainSelectedInstOperands,
     /*   46344 */     // GIR_Coverage, 46585,
     /*   46344 */     GIR_EraseRootFromParent_Done,
     /*   46345 */   // Label 760: @46345
     /*   46345 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(46413), // Rule ID 70688 //
     /*   46350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46369 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46387 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   46387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46411 */     GIR_RootConstrainSelectedInstOperands,
     /*   46412 */     // GIR_Coverage, 70688,
     /*   46412 */     GIR_EraseRootFromParent_Done,
     /*   46413 */   // Label 761: @46413
     /*   46413 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(46481), // Rule ID 70689 //
     /*   46418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46455 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   46455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46479 */     GIR_RootConstrainSelectedInstOperands,
     /*   46480 */     // GIR_Coverage, 70689,
     /*   46480 */     GIR_EraseRootFromParent_Done,
     /*   46481 */   // Label 762: @46481
     /*   46481 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(46536), // Rule ID 69604 //
     /*   46486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46501 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46514 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46534 */     GIR_RootConstrainSelectedInstOperands,
     /*   46535 */     // GIR_Coverage, 69604,
     /*   46535 */     GIR_EraseRootFromParent_Done,
     /*   46536 */   // Label 763: @46536
     /*   46536 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(46591), // Rule ID 69605 //
     /*   46541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46569 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46589 */     GIR_RootConstrainSelectedInstOperands,
     /*   46590 */     // GIR_Coverage, 69605,
     /*   46590 */     GIR_EraseRootFromParent_Done,
     /*   46591 */   // Label 764: @46591
     /*   46591 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(46646), // Rule ID 69424 //
     /*   46596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46624 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   46627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46644 */     GIR_RootConstrainSelectedInstOperands,
     /*   46645 */     // GIR_Coverage, 69424,
     /*   46645 */     GIR_EraseRootFromParent_Done,
     /*   46646 */   // Label 765: @46646
     /*   46646 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(46701), // Rule ID 69425 //
     /*   46651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46679 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   46682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46699 */     GIR_RootConstrainSelectedInstOperands,
     /*   46700 */     // GIR_Coverage, 69425,
     /*   46700 */     GIR_EraseRootFromParent_Done,
     /*   46701 */   // Label 766: @46701
     /*   46701 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(46756), // Rule ID 69514 //
     /*   46706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46734 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46754 */     GIR_RootConstrainSelectedInstOperands,
     /*   46755 */     // GIR_Coverage, 69514,
     /*   46755 */     GIR_EraseRootFromParent_Done,
     /*   46756 */   // Label 767: @46756
     /*   46756 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(46811), // Rule ID 69515 //
     /*   46761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46789 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46809 */     GIR_RootConstrainSelectedInstOperands,
     /*   46810 */     // GIR_Coverage, 69515,
     /*   46810 */     GIR_EraseRootFromParent_Done,
     /*   46811 */   // Label 768: @46811
     /*   46811 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(46879), // Rule ID 51918 //
     /*   46816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46839 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46853 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   46853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46877 */     GIR_RootConstrainSelectedInstOperands,
     /*   46878 */     // GIR_Coverage, 51918,
     /*   46878 */     GIR_EraseRootFromParent_Done,
     /*   46879 */   // Label 769: @46879
     /*   46879 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(46947), // Rule ID 51919 //
     /*   46884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46907 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46921 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   46921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46945 */     GIR_RootConstrainSelectedInstOperands,
     /*   46946 */     // GIR_Coverage, 51919,
     /*   46946 */     GIR_EraseRootFromParent_Done,
     /*   46947 */   // Label 770: @46947
     /*   46947 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(47002), // Rule ID 46764 //
     /*   46952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46971 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46980 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47000 */     GIR_RootConstrainSelectedInstOperands,
     /*   47001 */     // GIR_Coverage, 46764,
     /*   47001 */     GIR_EraseRootFromParent_Done,
     /*   47002 */   // Label 771: @47002
     /*   47002 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(47057), // Rule ID 46765 //
     /*   47007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   47022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47035 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47055 */     GIR_RootConstrainSelectedInstOperands,
     /*   47056 */     // GIR_Coverage, 46765,
     /*   47056 */     GIR_EraseRootFromParent_Done,
     /*   47057 */   // Label 772: @47057
     /*   47057 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(47112), // Rule ID 46524 //
     /*   47062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47081 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47090 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47110 */     GIR_RootConstrainSelectedInstOperands,
     /*   47111 */     // GIR_Coverage, 46524,
     /*   47111 */     GIR_EraseRootFromParent_Done,
     /*   47112 */   // Label 773: @47112
     /*   47112 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(47167), // Rule ID 46525 //
     /*   47117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47145 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47165 */     GIR_RootConstrainSelectedInstOperands,
     /*   47166 */     // GIR_Coverage, 46525,
     /*   47166 */     GIR_EraseRootFromParent_Done,
     /*   47167 */   // Label 774: @47167
     /*   47167 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(47222), // Rule ID 46644 //
     /*   47172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47191 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47200 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47220 */     GIR_RootConstrainSelectedInstOperands,
     /*   47221 */     // GIR_Coverage, 46644,
     /*   47221 */     GIR_EraseRootFromParent_Done,
     /*   47222 */   // Label 775: @47222
     /*   47222 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(47277), // Rule ID 46645 //
     /*   47227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47255 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47275 */     GIR_RootConstrainSelectedInstOperands,
     /*   47276 */     // GIR_Coverage, 46645,
     /*   47276 */     GIR_EraseRootFromParent_Done,
     /*   47277 */   // Label 776: @47277
     /*   47277 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(47330), // Rule ID 46150 //
     /*   47282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47293 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   47293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   47296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   47310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47328 */     GIR_RootConstrainSelectedInstOperands,
     /*   47329 */     // GIR_Coverage, 46150,
     /*   47329 */     GIR_EraseRootFromParent_Done,
     /*   47330 */   // Label 777: @47330
     /*   47330 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(47383), // Rule ID 46151 //
     /*   47335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47346 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   47346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   47349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   47363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47381 */     GIR_RootConstrainSelectedInstOperands,
     /*   47382 */     // GIR_Coverage, 46151,
     /*   47382 */     GIR_EraseRootFromParent_Done,
     /*   47383 */   // Label 778: @47383
     /*   47383 */   GIM_Reject,
     /*   47384 */ // Label 738: @47384
     /*   47384 */ GIM_Reject,
     /*   47385 */ // Label 143: @47385
     /*   47385 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50509),
     /*   47390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47400 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(47496), // Rule ID 70798 //
     /*   47405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47438 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47453 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47457 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47459 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47470 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   47473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47494 */     GIR_RootConstrainSelectedInstOperands,
     /*   47495 */     // GIR_Coverage, 70798,
     /*   47495 */     GIR_EraseRootFromParent_Done,
     /*   47496 */   // Label 780: @47496
     /*   47496 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(47592), // Rule ID 70799 //
     /*   47501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47520 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47534 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47553 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47555 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47566 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   47569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47590 */     GIR_RootConstrainSelectedInstOperands,
     /*   47591 */     // GIR_Coverage, 70799,
     /*   47591 */     GIR_EraseRootFromParent_Done,
     /*   47592 */   // Label 781: @47592
     /*   47592 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(47688), // Rule ID 71090 //
     /*   47597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47616 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47630 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47645 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47649 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47651 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47662 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47686 */     GIR_RootConstrainSelectedInstOperands,
     /*   47687 */     // GIR_Coverage, 71090,
     /*   47687 */     GIR_EraseRootFromParent_Done,
     /*   47688 */   // Label 782: @47688
     /*   47688 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(47784), // Rule ID 71091 //
     /*   47693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47712 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47726 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47728 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47741 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47745 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47747 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47758 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47782 */     GIR_RootConstrainSelectedInstOperands,
     /*   47783 */     // GIR_Coverage, 71091,
     /*   47783 */     GIR_EraseRootFromParent_Done,
     /*   47784 */   // Label 783: @47784
     /*   47784 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(47880), // Rule ID 71092 //
     /*   47789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47808 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47822 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47837 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47841 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47843 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47854 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   47865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   47869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47878 */     GIR_RootConstrainSelectedInstOperands,
     /*   47879 */     // GIR_Coverage, 71092,
     /*   47879 */     GIR_EraseRootFromParent_Done,
     /*   47880 */   // Label 784: @47880
     /*   47880 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(47976), // Rule ID 71093 //
     /*   47885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47904 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47918 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47933 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47937 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47939 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47950 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   47961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   47965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47974 */     GIR_RootConstrainSelectedInstOperands,
     /*   47975 */     // GIR_Coverage, 71093,
     /*   47975 */     GIR_EraseRootFromParent_Done,
     /*   47976 */   // Label 785: @47976
     /*   47976 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(48072), // Rule ID 70912 //
     /*   47981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48000 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48014 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48029 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48033 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48035 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48046 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48070 */     GIR_RootConstrainSelectedInstOperands,
     /*   48071 */     // GIR_Coverage, 70912,
     /*   48071 */     GIR_EraseRootFromParent_Done,
     /*   48072 */   // Label 786: @48072
     /*   48072 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(48168), // Rule ID 70913 //
     /*   48077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48110 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48125 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48129 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48142 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48166 */     GIR_RootConstrainSelectedInstOperands,
     /*   48167 */     // GIR_Coverage, 70913,
     /*   48167 */     GIR_EraseRootFromParent_Done,
     /*   48168 */   // Label 787: @48168
     /*   48168 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(48264), // Rule ID 52052 //
     /*   48173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48210 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48225 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48229 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48231 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48238 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48262 */     GIR_RootConstrainSelectedInstOperands,
     /*   48263 */     // GIR_Coverage, 52052,
     /*   48263 */     GIR_EraseRootFromParent_Done,
     /*   48264 */   // Label 788: @48264
     /*   48264 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(48360), // Rule ID 52053 //
     /*   48269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48325 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48327 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48334 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48358 */     GIR_RootConstrainSelectedInstOperands,
     /*   48359 */     // GIR_Coverage, 52053,
     /*   48359 */     GIR_EraseRootFromParent_Done,
     /*   48360 */   // Label 789: @48360
     /*   48360 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(48456), // Rule ID 52170 //
     /*   48365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48402 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48417 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48421 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48423 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48430 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48454 */     GIR_RootConstrainSelectedInstOperands,
     /*   48455 */     // GIR_Coverage, 52170,
     /*   48455 */     GIR_EraseRootFromParent_Done,
     /*   48456 */   // Label 790: @48456
     /*   48456 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(48552), // Rule ID 52171 //
     /*   48461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48484 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48498 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48513 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48517 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48519 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48526 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48550 */     GIR_RootConstrainSelectedInstOperands,
     /*   48551 */     // GIR_Coverage, 52171,
     /*   48551 */     GIR_EraseRootFromParent_Done,
     /*   48552 */   // Label 791: @48552
     /*   48552 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(48648), // Rule ID 71088 //
     /*   48557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48580 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48594 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48609 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48613 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48615 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48622 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48646 */     GIR_RootConstrainSelectedInstOperands,
     /*   48647 */     // GIR_Coverage, 71088,
     /*   48647 */     GIR_EraseRootFromParent_Done,
     /*   48648 */   // Label 792: @48648
     /*   48648 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(48744), // Rule ID 71089 //
     /*   48653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48690 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48705 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48709 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48711 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48718 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48742 */     GIR_RootConstrainSelectedInstOperands,
     /*   48743 */     // GIR_Coverage, 71089,
     /*   48743 */     GIR_EraseRootFromParent_Done,
     /*   48744 */   // Label 793: @48744
     /*   48744 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(48840), // Rule ID 52110 //
     /*   48749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48786 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48801 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48805 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48807 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48814 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48838 */     GIR_RootConstrainSelectedInstOperands,
     /*   48839 */     // GIR_Coverage, 52110,
     /*   48839 */     GIR_EraseRootFromParent_Done,
     /*   48840 */   // Label 794: @48840
     /*   48840 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(48936), // Rule ID 52111 //
     /*   48845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48868 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48882 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48897 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48901 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48903 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48910 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48934 */     GIR_RootConstrainSelectedInstOperands,
     /*   48935 */     // GIR_Coverage, 52111,
     /*   48935 */     GIR_EraseRootFromParent_Done,
     /*   48936 */   // Label 795: @48936
     /*   48936 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(49025), // Rule ID 46724 //
     /*   48941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   48952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   48967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   48971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48975 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48984 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   48984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   48987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   48991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   48996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   48998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49023 */     GIR_RootConstrainSelectedInstOperands,
     /*   49024 */     // GIR_Coverage, 46724,
     /*   49024 */     GIR_EraseRootFromParent_Done,
     /*   49025 */   // Label 796: @49025
     /*   49025 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(49114), // Rule ID 46725 //
     /*   49030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49045 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49064 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49073 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49112 */     GIR_RootConstrainSelectedInstOperands,
     /*   49113 */     // GIR_Coverage, 46725,
     /*   49113 */     GIR_EraseRootFromParent_Done,
     /*   49114 */   // Label 797: @49114
     /*   49114 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(49203), // Rule ID 46488 //
     /*   49119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49153 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49162 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   49179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49201 */     GIR_RootConstrainSelectedInstOperands,
     /*   49202 */     // GIR_Coverage, 46488,
     /*   49202 */     GIR_EraseRootFromParent_Done,
     /*   49203 */   // Label 798: @49203
     /*   49203 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(49292), // Rule ID 46489 //
     /*   49208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49223 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49242 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49251 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   49268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49290 */     GIR_RootConstrainSelectedInstOperands,
     /*   49291 */     // GIR_Coverage, 46489,
     /*   49291 */     GIR_EraseRootFromParent_Done,
     /*   49292 */   // Label 799: @49292
     /*   49292 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(49381), // Rule ID 46604 //
     /*   49297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49331 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49340 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49379 */     GIR_RootConstrainSelectedInstOperands,
     /*   49380 */     // GIR_Coverage, 46604,
     /*   49380 */     GIR_EraseRootFromParent_Done,
     /*   49381 */   // Label 800: @49381
     /*   49381 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(49470), // Rule ID 46605 //
     /*   49386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49429 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49468 */     GIR_RootConstrainSelectedInstOperands,
     /*   49469 */     // GIR_Coverage, 46605,
     /*   49469 */     GIR_EraseRootFromParent_Done,
     /*   49470 */   // Label 801: @49470
     /*   49470 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(49538), // Rule ID 70720 //
     /*   49475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   49478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49494 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49512 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   49512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   49533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49536 */     GIR_RootConstrainSelectedInstOperands,
     /*   49537 */     // GIR_Coverage, 70720,
     /*   49537 */     GIR_EraseRootFromParent_Done,
     /*   49538 */   // Label 802: @49538
     /*   49538 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(49606), // Rule ID 70721 //
     /*   49543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   49546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49562 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49580 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   49580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   49601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49604 */     GIR_RootConstrainSelectedInstOperands,
     /*   49605 */     // GIR_Coverage, 70721,
     /*   49605 */     GIR_EraseRootFromParent_Done,
     /*   49606 */   // Label 803: @49606
     /*   49606 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(49661), // Rule ID 69624 //
     /*   49611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49626 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49639 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49659 */     GIR_RootConstrainSelectedInstOperands,
     /*   49660 */     // GIR_Coverage, 69624,
     /*   49660 */     GIR_EraseRootFromParent_Done,
     /*   49661 */   // Label 804: @49661
     /*   49661 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(49716), // Rule ID 69625 //
     /*   49666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49681 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49694 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49714 */     GIR_RootConstrainSelectedInstOperands,
     /*   49715 */     // GIR_Coverage, 69625,
     /*   49715 */     GIR_EraseRootFromParent_Done,
     /*   49716 */   // Label 805: @49716
     /*   49716 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(49771), // Rule ID 69444 //
     /*   49721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49749 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   49752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49769 */     GIR_RootConstrainSelectedInstOperands,
     /*   49770 */     // GIR_Coverage, 69444,
     /*   49770 */     GIR_EraseRootFromParent_Done,
     /*   49771 */   // Label 806: @49771
     /*   49771 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(49826), // Rule ID 69445 //
     /*   49776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49804 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   49807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49824 */     GIR_RootConstrainSelectedInstOperands,
     /*   49825 */     // GIR_Coverage, 69445,
     /*   49825 */     GIR_EraseRootFromParent_Done,
     /*   49826 */   // Label 807: @49826
     /*   49826 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(49881), // Rule ID 69534 //
     /*   49831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49859 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49879 */     GIR_RootConstrainSelectedInstOperands,
     /*   49880 */     // GIR_Coverage, 69534,
     /*   49880 */     GIR_EraseRootFromParent_Done,
     /*   49881 */   // Label 808: @49881
     /*   49881 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(49936), // Rule ID 69535 //
     /*   49886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49914 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49934 */     GIR_RootConstrainSelectedInstOperands,
     /*   49935 */     // GIR_Coverage, 69535,
     /*   49935 */     GIR_EraseRootFromParent_Done,
     /*   49936 */   // Label 809: @49936
     /*   49936 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(50004), // Rule ID 51934 //
     /*   49941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   49944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49964 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49978 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   49978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   49993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   49999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50002 */     GIR_RootConstrainSelectedInstOperands,
     /*   50003 */     // GIR_Coverage, 51934,
     /*   50003 */     GIR_EraseRootFromParent_Done,
     /*   50004 */   // Label 810: @50004
     /*   50004 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(50072), // Rule ID 51935 //
     /*   50009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   50028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   50032 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50046 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   50046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   50049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50070 */     GIR_RootConstrainSelectedInstOperands,
     /*   50071 */     // GIR_Coverage, 51935,
     /*   50071 */     GIR_EraseRootFromParent_Done,
     /*   50072 */   // Label 811: @50072
     /*   50072 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(50127), // Rule ID 46784 //
     /*   50077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50105 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50125 */     GIR_RootConstrainSelectedInstOperands,
     /*   50126 */     // GIR_Coverage, 46784,
     /*   50126 */     GIR_EraseRootFromParent_Done,
     /*   50127 */   // Label 812: @50127
     /*   50127 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(50182), // Rule ID 46785 //
     /*   50132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50160 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50180 */     GIR_RootConstrainSelectedInstOperands,
     /*   50181 */     // GIR_Coverage, 46785,
     /*   50181 */     GIR_EraseRootFromParent_Done,
     /*   50182 */   // Label 813: @50182
     /*   50182 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(50237), // Rule ID 46544 //
     /*   50187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50215 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50235 */     GIR_RootConstrainSelectedInstOperands,
     /*   50236 */     // GIR_Coverage, 46544,
     /*   50236 */     GIR_EraseRootFromParent_Done,
     /*   50237 */   // Label 814: @50237
     /*   50237 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(50292), // Rule ID 46545 //
     /*   50242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50270 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50290 */     GIR_RootConstrainSelectedInstOperands,
     /*   50291 */     // GIR_Coverage, 46545,
     /*   50291 */     GIR_EraseRootFromParent_Done,
     /*   50292 */   // Label 815: @50292
     /*   50292 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(50347), // Rule ID 46664 //
     /*   50297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50325 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50345 */     GIR_RootConstrainSelectedInstOperands,
     /*   50346 */     // GIR_Coverage, 46664,
     /*   50346 */     GIR_EraseRootFromParent_Done,
     /*   50347 */   // Label 816: @50347
     /*   50347 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(50402), // Rule ID 46665 //
     /*   50352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50380 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50400 */     GIR_RootConstrainSelectedInstOperands,
     /*   50401 */     // GIR_Coverage, 46665,
     /*   50401 */     GIR_EraseRootFromParent_Done,
     /*   50402 */   // Label 817: @50402
     /*   50402 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(50455), // Rule ID 46166 //
     /*   50407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   50410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50418 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   50418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   50421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   50435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50453 */     GIR_RootConstrainSelectedInstOperands,
     /*   50454 */     // GIR_Coverage, 46166,
     /*   50454 */     GIR_EraseRootFromParent_Done,
     /*   50455 */   // Label 818: @50455
     /*   50455 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(50508), // Rule ID 46167 //
     /*   50460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50471 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   50471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   50474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   50488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50506 */     GIR_RootConstrainSelectedInstOperands,
     /*   50507 */     // GIR_Coverage, 46167,
     /*   50507 */     GIR_EraseRootFromParent_Done,
     /*   50508 */   // Label 819: @50508
     /*   50508 */   GIM_Reject,
     /*   50509 */ // Label 779: @50509
     /*   50509 */ GIM_Reject,
     /*   50510 */ // Label 144: @50510
     /*   50510 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(50904),
     /*   50515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50525 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(50593), // Rule ID 70632 //
     /*   50530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50549 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50567 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   50567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50591 */     GIR_RootConstrainSelectedInstOperands,
     /*   50592 */     // GIR_Coverage, 70632,
     /*   50592 */     GIR_EraseRootFromParent_Done,
     /*   50593 */   // Label 821: @50593
     /*   50593 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(50661), // Rule ID 70633 //
     /*   50598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50617 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50635 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   50635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50659 */     GIR_RootConstrainSelectedInstOperands,
     /*   50660 */     // GIR_Coverage, 70633,
     /*   50660 */     GIR_EraseRootFromParent_Done,
     /*   50661 */   // Label 822: @50661
     /*   50661 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(50729), // Rule ID 51890 //
     /*   50666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50703 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   50703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50727 */     GIR_RootConstrainSelectedInstOperands,
     /*   50728 */     // GIR_Coverage, 51890,
     /*   50728 */     GIR_EraseRootFromParent_Done,
     /*   50729 */   // Label 823: @50729
     /*   50729 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(50797), // Rule ID 51891 //
     /*   50734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50757 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50771 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   50771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50795 */     GIR_RootConstrainSelectedInstOperands,
     /*   50796 */     // GIR_Coverage, 51891,
     /*   50796 */     GIR_EraseRootFromParent_Done,
     /*   50797 */   // Label 824: @50797
     /*   50797 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(50850), // Rule ID 46122 //
     /*   50802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50813 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   50813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   50816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   50830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50848 */     GIR_RootConstrainSelectedInstOperands,
     /*   50849 */     // GIR_Coverage, 46122,
     /*   50849 */     GIR_EraseRootFromParent_Done,
     /*   50850 */   // Label 825: @50850
     /*   50850 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(50903), // Rule ID 46123 //
     /*   50855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50866 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   50866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   50869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   50883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50901 */     GIR_RootConstrainSelectedInstOperands,
     /*   50902 */     // GIR_Coverage, 46123,
     /*   50902 */     GIR_EraseRootFromParent_Done,
     /*   50903 */   // Label 826: @50903
     /*   50903 */   GIM_Reject,
     /*   50904 */ // Label 820: @50904
     /*   50904 */ GIM_Reject,
     /*   50905 */ // Label 145: @50905
     /*   50905 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(54029),
     /*   50910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   50916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50920 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(51016), // Rule ID 70778 //
     /*   50925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   50944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50958 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50977 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50990 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   50990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   50993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   50997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51014 */     GIR_RootConstrainSelectedInstOperands,
     /*   51015 */     // GIR_Coverage, 70778,
     /*   51015 */     GIR_EraseRootFromParent_Done,
     /*   51016 */   // Label 828: @51016
     /*   51016 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(51112), // Rule ID 70779 //
     /*   51021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51054 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51069 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51073 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51086 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51110 */     GIR_RootConstrainSelectedInstOperands,
     /*   51111 */     // GIR_Coverage, 70779,
     /*   51111 */     GIR_EraseRootFromParent_Done,
     /*   51112 */   // Label 829: @51112
     /*   51112 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(51208), // Rule ID 71030 //
     /*   51117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51150 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51169 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51171 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51182 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51206 */     GIR_RootConstrainSelectedInstOperands,
     /*   51207 */     // GIR_Coverage, 71030,
     /*   51207 */     GIR_EraseRootFromParent_Done,
     /*   51208 */   // Label 830: @51208
     /*   51208 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(51304), // Rule ID 71031 //
     /*   51213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51232 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51246 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51261 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51265 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51267 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51278 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51302 */     GIR_RootConstrainSelectedInstOperands,
     /*   51303 */     // GIR_Coverage, 71031,
     /*   51303 */     GIR_EraseRootFromParent_Done,
     /*   51304 */   // Label 831: @51304
     /*   51304 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(51400), // Rule ID 71032 //
     /*   51309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51342 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51361 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51363 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51374 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51398 */     GIR_RootConstrainSelectedInstOperands,
     /*   51399 */     // GIR_Coverage, 71032,
     /*   51399 */     GIR_EraseRootFromParent_Done,
     /*   51400 */   // Label 832: @51400
     /*   51400 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(51496), // Rule ID 71033 //
     /*   51405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51438 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51453 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51457 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51459 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51470 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51494 */     GIR_RootConstrainSelectedInstOperands,
     /*   51495 */     // GIR_Coverage, 71033,
     /*   51495 */     GIR_EraseRootFromParent_Done,
     /*   51496 */   // Label 833: @51496
     /*   51496 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(51592), // Rule ID 70892 //
     /*   51501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51520 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51534 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51553 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51555 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51566 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   51569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51590 */     GIR_RootConstrainSelectedInstOperands,
     /*   51591 */     // GIR_Coverage, 70892,
     /*   51591 */     GIR_EraseRootFromParent_Done,
     /*   51592 */   // Label 834: @51592
     /*   51592 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(51688), // Rule ID 70893 //
     /*   51597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51616 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51630 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51645 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51649 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51651 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51662 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   51665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51686 */     GIR_RootConstrainSelectedInstOperands,
     /*   51687 */     // GIR_Coverage, 70893,
     /*   51687 */     GIR_EraseRootFromParent_Done,
     /*   51688 */   // Label 835: @51688
     /*   51688 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(51784), // Rule ID 52032 //
     /*   51693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51730 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51745 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51749 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51751 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51758 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51782 */     GIR_RootConstrainSelectedInstOperands,
     /*   51783 */     // GIR_Coverage, 52032,
     /*   51783 */     GIR_EraseRootFromParent_Done,
     /*   51784 */   // Label 836: @51784
     /*   51784 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(51880), // Rule ID 52033 //
     /*   51789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51812 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51826 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51841 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51845 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51847 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51854 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51878 */     GIR_RootConstrainSelectedInstOperands,
     /*   51879 */     // GIR_Coverage, 52033,
     /*   51879 */     GIR_EraseRootFromParent_Done,
     /*   51880 */   // Label 837: @51880
     /*   51880 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(51976), // Rule ID 52150 //
     /*   51885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51922 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51937 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51941 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51943 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51950 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51974 */     GIR_RootConstrainSelectedInstOperands,
     /*   51975 */     // GIR_Coverage, 52150,
     /*   51975 */     GIR_EraseRootFromParent_Done,
     /*   51976 */   // Label 838: @51976
     /*   51976 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(52072), // Rule ID 52151 //
     /*   51981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52004 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52018 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52033 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52037 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52039 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52046 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52070 */     GIR_RootConstrainSelectedInstOperands,
     /*   52071 */     // GIR_Coverage, 52151,
     /*   52071 */     GIR_EraseRootFromParent_Done,
     /*   52072 */   // Label 839: @52072
     /*   52072 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(52168), // Rule ID 71028 //
     /*   52077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52100 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52114 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52129 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52133 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52135 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52142 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   52153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   52157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52166 */     GIR_RootConstrainSelectedInstOperands,
     /*   52167 */     // GIR_Coverage, 71028,
     /*   52167 */     GIR_EraseRootFromParent_Done,
     /*   52168 */   // Label 840: @52168
     /*   52168 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(52264), // Rule ID 71029 //
     /*   52173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52210 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52225 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52229 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52231 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52238 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   52249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   52253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52262 */     GIR_RootConstrainSelectedInstOperands,
     /*   52263 */     // GIR_Coverage, 71029,
     /*   52263 */     GIR_EraseRootFromParent_Done,
     /*   52264 */   // Label 841: @52264
     /*   52264 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(52360), // Rule ID 52090 //
     /*   52269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52325 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52327 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52334 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52358 */     GIR_RootConstrainSelectedInstOperands,
     /*   52359 */     // GIR_Coverage, 52090,
     /*   52359 */     GIR_EraseRootFromParent_Done,
     /*   52360 */   // Label 842: @52360
     /*   52360 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(52456), // Rule ID 52091 //
     /*   52365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52402 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52417 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52421 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52423 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52430 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52454 */     GIR_RootConstrainSelectedInstOperands,
     /*   52455 */     // GIR_Coverage, 52091,
     /*   52455 */     GIR_EraseRootFromParent_Done,
     /*   52456 */   // Label 843: @52456
     /*   52456 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(52545), // Rule ID 46684 //
     /*   52461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52476 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52495 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52504 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52543 */     GIR_RootConstrainSelectedInstOperands,
     /*   52544 */     // GIR_Coverage, 46684,
     /*   52544 */     GIR_EraseRootFromParent_Done,
     /*   52545 */   // Label 844: @52545
     /*   52545 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(52634), // Rule ID 46685 //
     /*   52550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52565 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52584 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52593 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   52593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52632 */     GIR_RootConstrainSelectedInstOperands,
     /*   52633 */     // GIR_Coverage, 46685,
     /*   52633 */     GIR_EraseRootFromParent_Done,
     /*   52634 */   // Label 845: @52634
     /*   52634 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(52723), // Rule ID 46448 //
     /*   52639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52654 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52673 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52682 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   52699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52721 */     GIR_RootConstrainSelectedInstOperands,
     /*   52722 */     // GIR_Coverage, 46448,
     /*   52722 */     GIR_EraseRootFromParent_Done,
     /*   52723 */   // Label 846: @52723
     /*   52723 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(52812), // Rule ID 46449 //
     /*   52728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52743 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52762 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52771 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   52771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   52788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52810 */     GIR_RootConstrainSelectedInstOperands,
     /*   52811 */     // GIR_Coverage, 46449,
     /*   52811 */     GIR_EraseRootFromParent_Done,
     /*   52812 */   // Label 847: @52812
     /*   52812 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(52901), // Rule ID 46564 //
     /*   52817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52832 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52851 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52860 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52899 */     GIR_RootConstrainSelectedInstOperands,
     /*   52900 */     // GIR_Coverage, 46564,
     /*   52900 */     GIR_EraseRootFromParent_Done,
     /*   52901 */   // Label 848: @52901
     /*   52901 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(52990), // Rule ID 46565 //
     /*   52906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52921 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52940 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52949 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   52949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52988 */     GIR_RootConstrainSelectedInstOperands,
     /*   52989 */     // GIR_Coverage, 46565,
     /*   52989 */     GIR_EraseRootFromParent_Done,
     /*   52990 */   // Label 849: @52990
     /*   52990 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(53058), // Rule ID 70664 //
     /*   52995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53014 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53032 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   53032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53056 */     GIR_RootConstrainSelectedInstOperands,
     /*   53057 */     // GIR_Coverage, 70664,
     /*   53057 */     GIR_EraseRootFromParent_Done,
     /*   53058 */   // Label 850: @53058
     /*   53058 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(53126), // Rule ID 70665 //
     /*   53063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53082 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53100 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   53100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53124 */     GIR_RootConstrainSelectedInstOperands,
     /*   53125 */     // GIR_Coverage, 70665,
     /*   53125 */     GIR_EraseRootFromParent_Done,
     /*   53126 */   // Label 851: @53126
     /*   53126 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(53181), // Rule ID 69584 //
     /*   53131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53146 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53159 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53179 */     GIR_RootConstrainSelectedInstOperands,
     /*   53180 */     // GIR_Coverage, 69584,
     /*   53180 */     GIR_EraseRootFromParent_Done,
     /*   53181 */   // Label 852: @53181
     /*   53181 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(53236), // Rule ID 69585 //
     /*   53186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53214 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53234 */     GIR_RootConstrainSelectedInstOperands,
     /*   53235 */     // GIR_Coverage, 69585,
     /*   53235 */     GIR_EraseRootFromParent_Done,
     /*   53236 */   // Label 853: @53236
     /*   53236 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(53291), // Rule ID 69404 //
     /*   53241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53269 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53289 */     GIR_RootConstrainSelectedInstOperands,
     /*   53290 */     // GIR_Coverage, 69404,
     /*   53290 */     GIR_EraseRootFromParent_Done,
     /*   53291 */   // Label 854: @53291
     /*   53291 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(53346), // Rule ID 69405 //
     /*   53296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53311 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53324 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53344 */     GIR_RootConstrainSelectedInstOperands,
     /*   53345 */     // GIR_Coverage, 69405,
     /*   53345 */     GIR_EraseRootFromParent_Done,
     /*   53346 */   // Label 855: @53346
     /*   53346 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(53401), // Rule ID 69494 //
     /*   53351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53379 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53399 */     GIR_RootConstrainSelectedInstOperands,
     /*   53400 */     // GIR_Coverage, 69494,
     /*   53400 */     GIR_EraseRootFromParent_Done,
     /*   53401 */   // Label 856: @53401
     /*   53401 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(53456), // Rule ID 69495 //
     /*   53406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53434 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53454 */     GIR_RootConstrainSelectedInstOperands,
     /*   53455 */     // GIR_Coverage, 69495,
     /*   53455 */     GIR_EraseRootFromParent_Done,
     /*   53456 */   // Label 857: @53456
     /*   53456 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(53524), // Rule ID 51906 //
     /*   53461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53484 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53498 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   53498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53522 */     GIR_RootConstrainSelectedInstOperands,
     /*   53523 */     // GIR_Coverage, 51906,
     /*   53523 */     GIR_EraseRootFromParent_Done,
     /*   53524 */   // Label 858: @53524
     /*   53524 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53592), // Rule ID 51907 //
     /*   53529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53566 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   53566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53590 */     GIR_RootConstrainSelectedInstOperands,
     /*   53591 */     // GIR_Coverage, 51907,
     /*   53591 */     GIR_EraseRootFromParent_Done,
     /*   53592 */   // Label 859: @53592
     /*   53592 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53647), // Rule ID 46744 //
     /*   53597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53616 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53625 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53645 */     GIR_RootConstrainSelectedInstOperands,
     /*   53646 */     // GIR_Coverage, 46744,
     /*   53646 */     GIR_EraseRootFromParent_Done,
     /*   53647 */   // Label 860: @53647
     /*   53647 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53702), // Rule ID 46745 //
     /*   53652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53671 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53680 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53700 */     GIR_RootConstrainSelectedInstOperands,
     /*   53701 */     // GIR_Coverage, 46745,
     /*   53701 */     GIR_EraseRootFromParent_Done,
     /*   53702 */   // Label 861: @53702
     /*   53702 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53757), // Rule ID 46504 //
     /*   53707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53735 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53755 */     GIR_RootConstrainSelectedInstOperands,
     /*   53756 */     // GIR_Coverage, 46504,
     /*   53756 */     GIR_EraseRootFromParent_Done,
     /*   53757 */   // Label 862: @53757
     /*   53757 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53812), // Rule ID 46505 //
     /*   53762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53790 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53810 */     GIR_RootConstrainSelectedInstOperands,
     /*   53811 */     // GIR_Coverage, 46505,
     /*   53811 */     GIR_EraseRootFromParent_Done,
     /*   53812 */   // Label 863: @53812
     /*   53812 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53867), // Rule ID 46624 //
     /*   53817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53845 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53865 */     GIR_RootConstrainSelectedInstOperands,
     /*   53866 */     // GIR_Coverage, 46624,
     /*   53866 */     GIR_EraseRootFromParent_Done,
     /*   53867 */   // Label 864: @53867
     /*   53867 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53922), // Rule ID 46625 //
     /*   53872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53891 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53900 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53920 */     GIR_RootConstrainSelectedInstOperands,
     /*   53921 */     // GIR_Coverage, 46625,
     /*   53921 */     GIR_EraseRootFromParent_Done,
     /*   53922 */   // Label 865: @53922
     /*   53922 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53975), // Rule ID 46138 //
     /*   53927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53938 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   53938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   53955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53973 */     GIR_RootConstrainSelectedInstOperands,
     /*   53974 */     // GIR_Coverage, 46138,
     /*   53974 */     GIR_EraseRootFromParent_Done,
     /*   53975 */   // Label 866: @53975
     /*   53975 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(54028), // Rule ID 46139 //
     /*   53980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53991 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   53991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   54003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   54005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   54008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   54013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   54015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   54017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54026 */     GIR_RootConstrainSelectedInstOperands,
     /*   54027 */     // GIR_Coverage, 46139,
     /*   54027 */     GIR_EraseRootFromParent_Done,
     /*   54028 */   // Label 867: @54028
     /*   54028 */   GIM_Reject,
     /*   54029 */ // Label 827: @54029
     /*   54029 */ GIM_Reject,
     /*   54030 */ // Label 146: @54030
     /*   54030 */ GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(57154),
     /*   54035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54045 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(54141), // Rule ID 70790 //
     /*   54050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54069 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54083 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54098 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54102 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54104 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54115 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54139 */     GIR_RootConstrainSelectedInstOperands,
     /*   54140 */     // GIR_Coverage, 70790,
     /*   54140 */     GIR_EraseRootFromParent_Done,
     /*   54141 */   // Label 869: @54141
     /*   54141 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(54237), // Rule ID 70791 //
     /*   54146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54179 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54198 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54200 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54211 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54235 */     GIR_RootConstrainSelectedInstOperands,
     /*   54236 */     // GIR_Coverage, 70791,
     /*   54236 */     GIR_EraseRootFromParent_Done,
     /*   54237 */   // Label 870: @54237
     /*   54237 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(54333), // Rule ID 71066 //
     /*   54242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54275 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54294 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54296 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54307 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54331 */     GIR_RootConstrainSelectedInstOperands,
     /*   54332 */     // GIR_Coverage, 71066,
     /*   54332 */     GIR_EraseRootFromParent_Done,
     /*   54333 */   // Label 871: @54333
     /*   54333 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54429), // Rule ID 71067 //
     /*   54338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54357 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54371 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54386 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54390 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54392 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54403 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54427 */     GIR_RootConstrainSelectedInstOperands,
     /*   54428 */     // GIR_Coverage, 71067,
     /*   54428 */     GIR_EraseRootFromParent_Done,
     /*   54429 */   // Label 872: @54429
     /*   54429 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54525), // Rule ID 71068 //
     /*   54434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54453 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54467 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54482 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54486 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54488 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54499 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   54510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   54514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54523 */     GIR_RootConstrainSelectedInstOperands,
     /*   54524 */     // GIR_Coverage, 71068,
     /*   54524 */     GIR_EraseRootFromParent_Done,
     /*   54525 */   // Label 873: @54525
     /*   54525 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(54621), // Rule ID 71069 //
     /*   54530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54549 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54563 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54578 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54582 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54584 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54595 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   54606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   54610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54619 */     GIR_RootConstrainSelectedInstOperands,
     /*   54620 */     // GIR_Coverage, 71069,
     /*   54620 */     GIR_EraseRootFromParent_Done,
     /*   54621 */   // Label 874: @54621
     /*   54621 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54717), // Rule ID 70904 //
     /*   54626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54645 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54659 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54674 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54678 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54680 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54691 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   54694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54715 */     GIR_RootConstrainSelectedInstOperands,
     /*   54716 */     // GIR_Coverage, 70904,
     /*   54716 */     GIR_EraseRootFromParent_Done,
     /*   54717 */   // Label 875: @54717
     /*   54717 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54813), // Rule ID 70905 //
     /*   54722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54741 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54755 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54770 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54774 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54776 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54787 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   54790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54811 */     GIR_RootConstrainSelectedInstOperands,
     /*   54812 */     // GIR_Coverage, 70905,
     /*   54812 */     GIR_EraseRootFromParent_Done,
     /*   54813 */   // Label 876: @54813
     /*   54813 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54909), // Rule ID 52044 //
     /*   54818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54855 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54870 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54874 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54876 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54883 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54907 */     GIR_RootConstrainSelectedInstOperands,
     /*   54908 */     // GIR_Coverage, 52044,
     /*   54908 */     GIR_EraseRootFromParent_Done,
     /*   54909 */   // Label 877: @54909
     /*   54909 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(55005), // Rule ID 52045 //
     /*   54914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54937 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54951 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54970 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54972 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54979 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55003 */     GIR_RootConstrainSelectedInstOperands,
     /*   55004 */     // GIR_Coverage, 52045,
     /*   55004 */     GIR_EraseRootFromParent_Done,
     /*   55005 */   // Label 878: @55005
     /*   55005 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(55101), // Rule ID 52162 //
     /*   55010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55033 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55047 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55066 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55068 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55075 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55099 */     GIR_RootConstrainSelectedInstOperands,
     /*   55100 */     // GIR_Coverage, 52162,
     /*   55100 */     GIR_EraseRootFromParent_Done,
     /*   55101 */   // Label 879: @55101
     /*   55101 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(55197), // Rule ID 52163 //
     /*   55106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55129 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55143 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55158 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55162 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55164 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55171 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55195 */     GIR_RootConstrainSelectedInstOperands,
     /*   55196 */     // GIR_Coverage, 52163,
     /*   55196 */     GIR_EraseRootFromParent_Done,
     /*   55197 */   // Label 880: @55197
     /*   55197 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(55293), // Rule ID 71064 //
     /*   55202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55225 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55239 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55254 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55258 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55260 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55267 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55291 */     GIR_RootConstrainSelectedInstOperands,
     /*   55292 */     // GIR_Coverage, 71064,
     /*   55292 */     GIR_EraseRootFromParent_Done,
     /*   55293 */   // Label 881: @55293
     /*   55293 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(55389), // Rule ID 71065 //
     /*   55298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55321 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55335 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55350 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55354 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55356 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55363 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55387 */     GIR_RootConstrainSelectedInstOperands,
     /*   55388 */     // GIR_Coverage, 71065,
     /*   55388 */     GIR_EraseRootFromParent_Done,
     /*   55389 */   // Label 882: @55389
     /*   55389 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55485), // Rule ID 52102 //
     /*   55394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55417 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55431 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55446 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55450 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55452 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55459 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55483 */     GIR_RootConstrainSelectedInstOperands,
     /*   55484 */     // GIR_Coverage, 52102,
     /*   55484 */     GIR_EraseRootFromParent_Done,
     /*   55485 */   // Label 883: @55485
     /*   55485 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55581), // Rule ID 52103 //
     /*   55490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55513 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55527 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55542 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55546 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55548 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55555 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55579 */     GIR_RootConstrainSelectedInstOperands,
     /*   55580 */     // GIR_Coverage, 52103,
     /*   55580 */     GIR_EraseRootFromParent_Done,
     /*   55581 */   // Label 884: @55581
     /*   55581 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55670), // Rule ID 46708 //
     /*   55586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55601 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55620 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55629 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   55629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   55646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55668 */     GIR_RootConstrainSelectedInstOperands,
     /*   55669 */     // GIR_Coverage, 46708,
     /*   55669 */     GIR_EraseRootFromParent_Done,
     /*   55670 */   // Label 885: @55670
     /*   55670 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55759), // Rule ID 46709 //
     /*   55675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55690 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55709 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55718 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   55718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   55735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55757 */     GIR_RootConstrainSelectedInstOperands,
     /*   55758 */     // GIR_Coverage, 46709,
     /*   55758 */     GIR_EraseRootFromParent_Done,
     /*   55759 */   // Label 886: @55759
     /*   55759 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55848), // Rule ID 46472 //
     /*   55764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55798 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55807 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   55807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   55824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55846 */     GIR_RootConstrainSelectedInstOperands,
     /*   55847 */     // GIR_Coverage, 46472,
     /*   55847 */     GIR_EraseRootFromParent_Done,
     /*   55848 */   // Label 887: @55848
     /*   55848 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55937), // Rule ID 46473 //
     /*   55853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55868 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55887 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55896 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   55896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   55913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55935 */     GIR_RootConstrainSelectedInstOperands,
     /*   55936 */     // GIR_Coverage, 46473,
     /*   55936 */     GIR_EraseRootFromParent_Done,
     /*   55937 */   // Label 888: @55937
     /*   55937 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(56026), // Rule ID 46588 //
     /*   55942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55957 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55976 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55985 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   55985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56024 */     GIR_RootConstrainSelectedInstOperands,
     /*   56025 */     // GIR_Coverage, 46588,
     /*   56025 */     GIR_EraseRootFromParent_Done,
     /*   56026 */   // Label 889: @56026
     /*   56026 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(56115), // Rule ID 46589 //
     /*   56031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56046 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56065 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56074 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   56074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56113 */     GIR_RootConstrainSelectedInstOperands,
     /*   56114 */     // GIR_Coverage, 46589,
     /*   56114 */     GIR_EraseRootFromParent_Done,
     /*   56115 */   // Label 890: @56115
     /*   56115 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(56183), // Rule ID 70696 //
     /*   56120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56139 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56157 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   56157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56181 */     GIR_RootConstrainSelectedInstOperands,
     /*   56182 */     // GIR_Coverage, 70696,
     /*   56182 */     GIR_EraseRootFromParent_Done,
     /*   56183 */   // Label 891: @56183
     /*   56183 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(56251), // Rule ID 70697 //
     /*   56188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56207 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56225 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   56225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56249 */     GIR_RootConstrainSelectedInstOperands,
     /*   56250 */     // GIR_Coverage, 70697,
     /*   56250 */     GIR_EraseRootFromParent_Done,
     /*   56251 */   // Label 892: @56251
     /*   56251 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(56306), // Rule ID 69608 //
     /*   56256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56271 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56284 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56304 */     GIR_RootConstrainSelectedInstOperands,
     /*   56305 */     // GIR_Coverage, 69608,
     /*   56305 */     GIR_EraseRootFromParent_Done,
     /*   56306 */   // Label 893: @56306
     /*   56306 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(56361), // Rule ID 69609 //
     /*   56311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56339 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56359 */     GIR_RootConstrainSelectedInstOperands,
     /*   56360 */     // GIR_Coverage, 69609,
     /*   56360 */     GIR_EraseRootFromParent_Done,
     /*   56361 */   // Label 894: @56361
     /*   56361 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(56416), // Rule ID 69428 //
     /*   56366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56394 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56414 */     GIR_RootConstrainSelectedInstOperands,
     /*   56415 */     // GIR_Coverage, 69428,
     /*   56415 */     GIR_EraseRootFromParent_Done,
     /*   56416 */   // Label 895: @56416
     /*   56416 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(56471), // Rule ID 69429 //
     /*   56421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56449 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56469 */     GIR_RootConstrainSelectedInstOperands,
     /*   56470 */     // GIR_Coverage, 69429,
     /*   56470 */     GIR_EraseRootFromParent_Done,
     /*   56471 */   // Label 896: @56471
     /*   56471 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(56526), // Rule ID 69518 //
     /*   56476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56504 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56524 */     GIR_RootConstrainSelectedInstOperands,
     /*   56525 */     // GIR_Coverage, 69518,
     /*   56525 */     GIR_EraseRootFromParent_Done,
     /*   56526 */   // Label 897: @56526
     /*   56526 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(56581), // Rule ID 69519 //
     /*   56531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56559 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56579 */     GIR_RootConstrainSelectedInstOperands,
     /*   56580 */     // GIR_Coverage, 69519,
     /*   56580 */     GIR_EraseRootFromParent_Done,
     /*   56581 */   // Label 898: @56581
     /*   56581 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(56649), // Rule ID 51922 //
     /*   56586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56609 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56623 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   56623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56647 */     GIR_RootConstrainSelectedInstOperands,
     /*   56648 */     // GIR_Coverage, 51922,
     /*   56648 */     GIR_EraseRootFromParent_Done,
     /*   56649 */   // Label 899: @56649
     /*   56649 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(56717), // Rule ID 51923 //
     /*   56654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56677 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56691 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   56691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56715 */     GIR_RootConstrainSelectedInstOperands,
     /*   56716 */     // GIR_Coverage, 51923,
     /*   56716 */     GIR_EraseRootFromParent_Done,
     /*   56717 */   // Label 900: @56717
     /*   56717 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(56772), // Rule ID 46768 //
     /*   56722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56741 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56750 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56770 */     GIR_RootConstrainSelectedInstOperands,
     /*   56771 */     // GIR_Coverage, 46768,
     /*   56771 */     GIR_EraseRootFromParent_Done,
     /*   56772 */   // Label 901: @56772
     /*   56772 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(56827), // Rule ID 46769 //
     /*   56777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56796 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56805 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56825 */     GIR_RootConstrainSelectedInstOperands,
     /*   56826 */     // GIR_Coverage, 46769,
     /*   56826 */     GIR_EraseRootFromParent_Done,
     /*   56827 */   // Label 902: @56827
     /*   56827 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(56882), // Rule ID 46528 //
     /*   56832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56851 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56860 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56880 */     GIR_RootConstrainSelectedInstOperands,
     /*   56881 */     // GIR_Coverage, 46528,
     /*   56881 */     GIR_EraseRootFromParent_Done,
     /*   56882 */   // Label 903: @56882
     /*   56882 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(56937), // Rule ID 46529 //
     /*   56887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56906 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56915 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56935 */     GIR_RootConstrainSelectedInstOperands,
     /*   56936 */     // GIR_Coverage, 46529,
     /*   56936 */     GIR_EraseRootFromParent_Done,
     /*   56937 */   // Label 904: @56937
     /*   56937 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(56992), // Rule ID 46648 //
     /*   56942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56961 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56970 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56990 */     GIR_RootConstrainSelectedInstOperands,
     /*   56991 */     // GIR_Coverage, 46648,
     /*   56991 */     GIR_EraseRootFromParent_Done,
     /*   56992 */   // Label 905: @56992
     /*   56992 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(57047), // Rule ID 46649 //
     /*   56997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57025 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   57025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57045 */     GIR_RootConstrainSelectedInstOperands,
     /*   57046 */     // GIR_Coverage, 46649,
     /*   57046 */     GIR_EraseRootFromParent_Done,
     /*   57047 */   // Label 906: @57047
     /*   57047 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(57100), // Rule ID 46154 //
     /*   57052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57063 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   57063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   57066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   57080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57098 */     GIR_RootConstrainSelectedInstOperands,
     /*   57099 */     // GIR_Coverage, 46154,
     /*   57099 */     GIR_EraseRootFromParent_Done,
     /*   57100 */   // Label 907: @57100
     /*   57100 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(57153), // Rule ID 46155 //
     /*   57105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57116 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   57116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   57119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   57133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57151 */     GIR_RootConstrainSelectedInstOperands,
     /*   57152 */     // GIR_Coverage, 46155,
     /*   57152 */     GIR_EraseRootFromParent_Done,
     /*   57153 */   // Label 908: @57153
     /*   57153 */   GIM_Reject,
     /*   57154 */ // Label 868: @57154
     /*   57154 */ GIM_Reject,
     /*   57155 */ // Label 147: @57155
     /*   57155 */ GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(57549),
     /*   57160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57170 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(57238), // Rule ID 70640 //
     /*   57175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57194 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57212 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57236 */     GIR_RootConstrainSelectedInstOperands,
     /*   57237 */     // GIR_Coverage, 70640,
     /*   57237 */     GIR_EraseRootFromParent_Done,
     /*   57238 */   // Label 910: @57238
     /*   57238 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(57306), // Rule ID 70641 //
     /*   57243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57262 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57280 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57304 */     GIR_RootConstrainSelectedInstOperands,
     /*   57305 */     // GIR_Coverage, 70641,
     /*   57305 */     GIR_EraseRootFromParent_Done,
     /*   57306 */   // Label 911: @57306
     /*   57306 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(57374), // Rule ID 51894 //
     /*   57311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57334 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57348 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57372 */     GIR_RootConstrainSelectedInstOperands,
     /*   57373 */     // GIR_Coverage, 51894,
     /*   57373 */     GIR_EraseRootFromParent_Done,
     /*   57374 */   // Label 912: @57374
     /*   57374 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(57442), // Rule ID 51895 //
     /*   57379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57402 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57416 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57440 */     GIR_RootConstrainSelectedInstOperands,
     /*   57441 */     // GIR_Coverage, 51895,
     /*   57441 */     GIR_EraseRootFromParent_Done,
     /*   57442 */   // Label 913: @57442
     /*   57442 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(57495), // Rule ID 46126 //
     /*   57447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57458 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   57458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   57461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   57475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57493 */     GIR_RootConstrainSelectedInstOperands,
     /*   57494 */     // GIR_Coverage, 46126,
     /*   57494 */     GIR_EraseRootFromParent_Done,
     /*   57495 */   // Label 914: @57495
     /*   57495 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(57548), // Rule ID 46127 //
     /*   57500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57511 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   57511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   57514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   57528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57546 */     GIR_RootConstrainSelectedInstOperands,
     /*   57547 */     // GIR_Coverage, 46127,
     /*   57547 */     GIR_EraseRootFromParent_Done,
     /*   57548 */   // Label 915: @57548
     /*   57548 */   GIM_Reject,
     /*   57549 */ // Label 909: @57549
     /*   57549 */ GIM_Reject,
     /*   57550 */ // Label 148: @57550
     /*   57550 */ GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(60674),
     /*   57555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57565 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(57661), // Rule ID 70780 //
     /*   57570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57589 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57603 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57605 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57618 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57622 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57624 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57635 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   57638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57659 */     GIR_RootConstrainSelectedInstOperands,
     /*   57660 */     // GIR_Coverage, 70780,
     /*   57660 */     GIR_EraseRootFromParent_Done,
     /*   57661 */   // Label 917: @57661
     /*   57661 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(57757), // Rule ID 70781 //
     /*   57666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57685 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57699 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57718 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57720 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57729 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57731 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   57734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57755 */     GIR_RootConstrainSelectedInstOperands,
     /*   57756 */     // GIR_Coverage, 70781,
     /*   57756 */     GIR_EraseRootFromParent_Done,
     /*   57757 */   // Label 918: @57757
     /*   57757 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57853), // Rule ID 71036 //
     /*   57762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57795 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57814 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57816 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57827 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   57830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57851 */     GIR_RootConstrainSelectedInstOperands,
     /*   57852 */     // GIR_Coverage, 71036,
     /*   57852 */     GIR_EraseRootFromParent_Done,
     /*   57853 */   // Label 919: @57853
     /*   57853 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(57949), // Rule ID 71037 //
     /*   57858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57891 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57906 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57910 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57912 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57923 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   57926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57947 */     GIR_RootConstrainSelectedInstOperands,
     /*   57948 */     // GIR_Coverage, 71037,
     /*   57948 */     GIR_EraseRootFromParent_Done,
     /*   57949 */   // Label 920: @57949
     /*   57949 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(58045), // Rule ID 71038 //
     /*   57954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58002 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58006 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58008 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58019 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58043 */     GIR_RootConstrainSelectedInstOperands,
     /*   58044 */     // GIR_Coverage, 71038,
     /*   58044 */     GIR_EraseRootFromParent_Done,
     /*   58045 */   // Label 921: @58045
     /*   58045 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(58141), // Rule ID 71039 //
     /*   58050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58069 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58083 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58098 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58102 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58104 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58115 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58139 */     GIR_RootConstrainSelectedInstOperands,
     /*   58140 */     // GIR_Coverage, 71039,
     /*   58140 */     GIR_EraseRootFromParent_Done,
     /*   58141 */   // Label 922: @58141
     /*   58141 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(58237), // Rule ID 70894 //
     /*   58146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58179 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58198 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58200 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58211 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58235 */     GIR_RootConstrainSelectedInstOperands,
     /*   58236 */     // GIR_Coverage, 70894,
     /*   58236 */     GIR_EraseRootFromParent_Done,
     /*   58237 */   // Label 923: @58237
     /*   58237 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(58333), // Rule ID 70895 //
     /*   58242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58275 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58294 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58296 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58307 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58331 */     GIR_RootConstrainSelectedInstOperands,
     /*   58332 */     // GIR_Coverage, 70895,
     /*   58332 */     GIR_EraseRootFromParent_Done,
     /*   58333 */   // Label 924: @58333
     /*   58333 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(58429), // Rule ID 52034 //
     /*   58338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58375 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58390 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58394 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58396 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58403 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58427 */     GIR_RootConstrainSelectedInstOperands,
     /*   58428 */     // GIR_Coverage, 52034,
     /*   58428 */     GIR_EraseRootFromParent_Done,
     /*   58429 */   // Label 925: @58429
     /*   58429 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(58525), // Rule ID 52035 //
     /*   58434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58457 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58471 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58473 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58490 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58492 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58499 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58523 */     GIR_RootConstrainSelectedInstOperands,
     /*   58524 */     // GIR_Coverage, 52035,
     /*   58524 */     GIR_EraseRootFromParent_Done,
     /*   58525 */   // Label 926: @58525
     /*   58525 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(58621), // Rule ID 52152 //
     /*   58530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58553 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58567 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58582 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58586 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58588 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58595 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58619 */     GIR_RootConstrainSelectedInstOperands,
     /*   58620 */     // GIR_Coverage, 52152,
     /*   58620 */     GIR_EraseRootFromParent_Done,
     /*   58621 */   // Label 927: @58621
     /*   58621 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(58717), // Rule ID 52153 //
     /*   58626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58649 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58663 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58682 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58684 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58691 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58715 */     GIR_RootConstrainSelectedInstOperands,
     /*   58716 */     // GIR_Coverage, 52153,
     /*   58716 */     GIR_EraseRootFromParent_Done,
     /*   58717 */   // Label 928: @58717
     /*   58717 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(58813), // Rule ID 71034 //
     /*   58722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58745 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58759 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58774 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58778 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58780 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58787 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58811 */     GIR_RootConstrainSelectedInstOperands,
     /*   58812 */     // GIR_Coverage, 71034,
     /*   58812 */     GIR_EraseRootFromParent_Done,
     /*   58813 */   // Label 929: @58813
     /*   58813 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(58909), // Rule ID 71035 //
     /*   58818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58855 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58870 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58874 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58876 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58883 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58907 */     GIR_RootConstrainSelectedInstOperands,
     /*   58908 */     // GIR_Coverage, 71035,
     /*   58908 */     GIR_EraseRootFromParent_Done,
     /*   58909 */   // Label 930: @58909
     /*   58909 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(59005), // Rule ID 52092 //
     /*   58914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58937 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58951 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58970 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58972 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58979 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59003 */     GIR_RootConstrainSelectedInstOperands,
     /*   59004 */     // GIR_Coverage, 52092,
     /*   59004 */     GIR_EraseRootFromParent_Done,
     /*   59005 */   // Label 931: @59005
     /*   59005 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(59101), // Rule ID 52093 //
     /*   59010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59033 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59047 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59066 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59068 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59075 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   59078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   59090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59099 */     GIR_RootConstrainSelectedInstOperands,
     /*   59100 */     // GIR_Coverage, 52093,
     /*   59100 */     GIR_EraseRootFromParent_Done,
     /*   59101 */   // Label 932: @59101
     /*   59101 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(59190), // Rule ID 46688 //
     /*   59106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59140 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59149 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59188 */     GIR_RootConstrainSelectedInstOperands,
     /*   59189 */     // GIR_Coverage, 46688,
     /*   59189 */     GIR_EraseRootFromParent_Done,
     /*   59190 */   // Label 933: @59190
     /*   59190 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(59279), // Rule ID 46689 //
     /*   59195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59229 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59238 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59277 */     GIR_RootConstrainSelectedInstOperands,
     /*   59278 */     // GIR_Coverage, 46689,
     /*   59278 */     GIR_EraseRootFromParent_Done,
     /*   59279 */   // Label 934: @59279
     /*   59279 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(59368), // Rule ID 46452 //
     /*   59284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59299 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59318 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59327 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   59344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59366 */     GIR_RootConstrainSelectedInstOperands,
     /*   59367 */     // GIR_Coverage, 46452,
     /*   59367 */     GIR_EraseRootFromParent_Done,
     /*   59368 */   // Label 935: @59368
     /*   59368 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(59457), // Rule ID 46453 //
     /*   59373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59407 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59416 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   59433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59455 */     GIR_RootConstrainSelectedInstOperands,
     /*   59456 */     // GIR_Coverage, 46453,
     /*   59456 */     GIR_EraseRootFromParent_Done,
     /*   59457 */   // Label 936: @59457
     /*   59457 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(59546), // Rule ID 46568 //
     /*   59462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59477 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59496 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59505 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59544 */     GIR_RootConstrainSelectedInstOperands,
     /*   59545 */     // GIR_Coverage, 46568,
     /*   59545 */     GIR_EraseRootFromParent_Done,
     /*   59546 */   // Label 937: @59546
     /*   59546 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(59635), // Rule ID 46569 //
     /*   59551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59566 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59585 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59594 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59633 */     GIR_RootConstrainSelectedInstOperands,
     /*   59634 */     // GIR_Coverage, 46569,
     /*   59634 */     GIR_EraseRootFromParent_Done,
     /*   59635 */   // Label 938: @59635
     /*   59635 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(59703), // Rule ID 70672 //
     /*   59640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59659 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59677 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   59677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   59680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   59686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59701 */     GIR_RootConstrainSelectedInstOperands,
     /*   59702 */     // GIR_Coverage, 70672,
     /*   59702 */     GIR_EraseRootFromParent_Done,
     /*   59703 */   // Label 939: @59703
     /*   59703 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(59771), // Rule ID 70673 //
     /*   59708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59727 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59745 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   59745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   59748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   59754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59769 */     GIR_RootConstrainSelectedInstOperands,
     /*   59770 */     // GIR_Coverage, 70673,
     /*   59770 */     GIR_EraseRootFromParent_Done,
     /*   59771 */   // Label 940: @59771
     /*   59771 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(59826), // Rule ID 69588 //
     /*   59776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59804 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   59807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59824 */     GIR_RootConstrainSelectedInstOperands,
     /*   59825 */     // GIR_Coverage, 69588,
     /*   59825 */     GIR_EraseRootFromParent_Done,
     /*   59826 */   // Label 941: @59826
     /*   59826 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(59881), // Rule ID 69589 //
     /*   59831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59859 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   59862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59879 */     GIR_RootConstrainSelectedInstOperands,
     /*   59880 */     // GIR_Coverage, 69589,
     /*   59880 */     GIR_EraseRootFromParent_Done,
     /*   59881 */   // Label 942: @59881
     /*   59881 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(59936), // Rule ID 69408 //
     /*   59886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59914 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   59917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59934 */     GIR_RootConstrainSelectedInstOperands,
     /*   59935 */     // GIR_Coverage, 69408,
     /*   59935 */     GIR_EraseRootFromParent_Done,
     /*   59936 */   // Label 943: @59936
     /*   59936 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(59991), // Rule ID 69409 //
     /*   59941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59969 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   59972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59989 */     GIR_RootConstrainSelectedInstOperands,
     /*   59990 */     // GIR_Coverage, 69409,
     /*   59990 */     GIR_EraseRootFromParent_Done,
     /*   59991 */   // Label 944: @59991
     /*   59991 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(60046), // Rule ID 69498 //
     /*   59996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60024 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60044 */     GIR_RootConstrainSelectedInstOperands,
     /*   60045 */     // GIR_Coverage, 69498,
     /*   60045 */     GIR_EraseRootFromParent_Done,
     /*   60046 */   // Label 945: @60046
     /*   60046 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(60101), // Rule ID 69499 //
     /*   60051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60079 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60099 */     GIR_RootConstrainSelectedInstOperands,
     /*   60100 */     // GIR_Coverage, 69499,
     /*   60100 */     GIR_EraseRootFromParent_Done,
     /*   60101 */   // Label 946: @60101
     /*   60101 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(60169), // Rule ID 51910 //
     /*   60106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60129 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60143 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   60143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60167 */     GIR_RootConstrainSelectedInstOperands,
     /*   60168 */     // GIR_Coverage, 51910,
     /*   60168 */     GIR_EraseRootFromParent_Done,
     /*   60169 */   // Label 947: @60169
     /*   60169 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(60237), // Rule ID 51911 //
     /*   60174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60197 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60211 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   60211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60235 */     GIR_RootConstrainSelectedInstOperands,
     /*   60236 */     // GIR_Coverage, 51911,
     /*   60236 */     GIR_EraseRootFromParent_Done,
     /*   60237 */   // Label 948: @60237
     /*   60237 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(60292), // Rule ID 46748 //
     /*   60242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60270 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60290 */     GIR_RootConstrainSelectedInstOperands,
     /*   60291 */     // GIR_Coverage, 46748,
     /*   60291 */     GIR_EraseRootFromParent_Done,
     /*   60292 */   // Label 949: @60292
     /*   60292 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(60347), // Rule ID 46749 //
     /*   60297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60325 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60345 */     GIR_RootConstrainSelectedInstOperands,
     /*   60346 */     // GIR_Coverage, 46749,
     /*   60346 */     GIR_EraseRootFromParent_Done,
     /*   60347 */   // Label 950: @60347
     /*   60347 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(60402), // Rule ID 46508 //
     /*   60352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60380 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60400 */     GIR_RootConstrainSelectedInstOperands,
     /*   60401 */     // GIR_Coverage, 46508,
     /*   60401 */     GIR_EraseRootFromParent_Done,
     /*   60402 */   // Label 951: @60402
     /*   60402 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(60457), // Rule ID 46509 //
     /*   60407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60435 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60455 */     GIR_RootConstrainSelectedInstOperands,
     /*   60456 */     // GIR_Coverage, 46509,
     /*   60456 */     GIR_EraseRootFromParent_Done,
     /*   60457 */   // Label 952: @60457
     /*   60457 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(60512), // Rule ID 46628 //
     /*   60462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60481 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60490 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60510 */     GIR_RootConstrainSelectedInstOperands,
     /*   60511 */     // GIR_Coverage, 46628,
     /*   60511 */     GIR_EraseRootFromParent_Done,
     /*   60512 */   // Label 953: @60512
     /*   60512 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(60567), // Rule ID 46629 //
     /*   60517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60545 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60565 */     GIR_RootConstrainSelectedInstOperands,
     /*   60566 */     // GIR_Coverage, 46629,
     /*   60566 */     GIR_EraseRootFromParent_Done,
     /*   60567 */   // Label 954: @60567
     /*   60567 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(60620), // Rule ID 46142 //
     /*   60572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60583 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   60583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   60586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   60600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   60607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60618 */     GIR_RootConstrainSelectedInstOperands,
     /*   60619 */     // GIR_Coverage, 46142,
     /*   60619 */     GIR_EraseRootFromParent_Done,
     /*   60620 */   // Label 955: @60620
     /*   60620 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(60673), // Rule ID 46143 //
     /*   60625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60636 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   60636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   60639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   60653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   60660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60671 */     GIR_RootConstrainSelectedInstOperands,
     /*   60672 */     // GIR_Coverage, 46143,
     /*   60672 */     GIR_EraseRootFromParent_Done,
     /*   60673 */   // Label 956: @60673
     /*   60673 */   GIM_Reject,
     /*   60674 */ // Label 916: @60674
     /*   60674 */ GIM_Reject,
     /*   60675 */ // Label 149: @60675
     /*   60675 */ GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(61069),
     /*   60680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60690 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(60758), // Rule ID 70648 //
     /*   60695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60714 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60732 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60756 */     GIR_RootConstrainSelectedInstOperands,
     /*   60757 */     // GIR_Coverage, 70648,
     /*   60757 */     GIR_EraseRootFromParent_Done,
     /*   60758 */   // Label 958: @60758
     /*   60758 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(60826), // Rule ID 70649 //
     /*   60763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60782 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60800 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60824 */     GIR_RootConstrainSelectedInstOperands,
     /*   60825 */     // GIR_Coverage, 70649,
     /*   60825 */     GIR_EraseRootFromParent_Done,
     /*   60826 */   // Label 959: @60826
     /*   60826 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(60894), // Rule ID 51898 //
     /*   60831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60868 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60892 */     GIR_RootConstrainSelectedInstOperands,
     /*   60893 */     // GIR_Coverage, 51898,
     /*   60893 */     GIR_EraseRootFromParent_Done,
     /*   60894 */   // Label 960: @60894
     /*   60894 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(60962), // Rule ID 51899 //
     /*   60899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60922 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60936 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60960 */     GIR_RootConstrainSelectedInstOperands,
     /*   60961 */     // GIR_Coverage, 51899,
     /*   60961 */     GIR_EraseRootFromParent_Done,
     /*   60962 */   // Label 961: @60962
     /*   60962 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(61015), // Rule ID 46130 //
     /*   60967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60978 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   60978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   60981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   60995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61013 */     GIR_RootConstrainSelectedInstOperands,
     /*   61014 */     // GIR_Coverage, 46130,
     /*   61014 */     GIR_EraseRootFromParent_Done,
     /*   61015 */   // Label 962: @61015
     /*   61015 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(61068), // Rule ID 46131 //
     /*   61020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61031 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   61034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   61048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61066 */     GIR_RootConstrainSelectedInstOperands,
     /*   61067 */     // GIR_Coverage, 46131,
     /*   61067 */     GIR_EraseRootFromParent_Done,
     /*   61068 */   // Label 963: @61068
     /*   61068 */   GIM_Reject,
     /*   61069 */ // Label 957: @61069
     /*   61069 */ GIM_Reject,
     /*   61070 */ // Label 150: @61070
     /*   61070 */ GIM_Reject,
     /*   61071 */ // Label 1: @61071
     /*   61071 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 988*/ GIMT_Encode4(80303),
     /*   61082 */ /*GILLT_s32*//*Label 964*/ GIMT_Encode4(61206),
     /*   61086 */ /*GILLT_s64*//*Label 965*/ GIMT_Encode4(61453), GIMT_Encode4(0),
     /*   61094 */ /*GILLT_nxv1s8*//*Label 966*/ GIMT_Encode4(61729),
     /*   61098 */ /*GILLT_nxv1s16*//*Label 967*/ GIMT_Encode4(61976),
     /*   61102 */ /*GILLT_nxv1s32*//*Label 968*/ GIMT_Encode4(63099),
     /*   61106 */ /*GILLT_nxv1s64*//*Label 969*/ GIMT_Encode4(64222), GIMT_Encode4(0),
     /*   61114 */ /*GILLT_nxv2s8*//*Label 970*/ GIMT_Encode4(65345),
     /*   61118 */ /*GILLT_nxv2s16*//*Label 971*/ GIMT_Encode4(65592),
     /*   61122 */ /*GILLT_nxv2s32*//*Label 972*/ GIMT_Encode4(66715),
     /*   61126 */ /*GILLT_nxv2s64*//*Label 973*/ GIMT_Encode4(67838), GIMT_Encode4(0),
     /*   61134 */ /*GILLT_nxv4s8*//*Label 974*/ GIMT_Encode4(68961),
     /*   61138 */ /*GILLT_nxv4s16*//*Label 975*/ GIMT_Encode4(69208),
     /*   61142 */ /*GILLT_nxv4s32*//*Label 976*/ GIMT_Encode4(70331),
     /*   61146 */ /*GILLT_nxv4s64*//*Label 977*/ GIMT_Encode4(71454), GIMT_Encode4(0),
     /*   61154 */ /*GILLT_nxv8s8*//*Label 978*/ GIMT_Encode4(72577),
     /*   61158 */ /*GILLT_nxv8s16*//*Label 979*/ GIMT_Encode4(72824),
     /*   61162 */ /*GILLT_nxv8s32*//*Label 980*/ GIMT_Encode4(73947),
     /*   61166 */ /*GILLT_nxv8s64*//*Label 981*/ GIMT_Encode4(75070), GIMT_Encode4(0),
     /*   61174 */ /*GILLT_nxv16s8*//*Label 982*/ GIMT_Encode4(76193),
     /*   61178 */ /*GILLT_nxv16s16*//*Label 983*/ GIMT_Encode4(76440),
     /*   61182 */ /*GILLT_nxv16s32*//*Label 984*/ GIMT_Encode4(77563), GIMT_Encode4(0),
     /*   61190 */ /*GILLT_nxv32s8*//*Label 985*/ GIMT_Encode4(78686),
     /*   61194 */ /*GILLT_nxv32s16*//*Label 986*/ GIMT_Encode4(78933), GIMT_Encode4(0),
     /*   61202 */ /*GILLT_nxv64s8*//*Label 987*/ GIMT_Encode4(80056),
     /*   61206 */ // Label 964: @61206
     /*   61206 */ GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(61452),
     /*   61211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   61214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   61217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61221 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(61296), // Rule ID 98 //
     /*   61226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*   61229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61249 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61256 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61262 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i64] }), 31:{ *:[i64] })
     /*   61262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   61265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61278 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   61281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   61294 */     GIR_RootConstrainSelectedInstOperands,
     /*   61295 */     // GIR_Coverage, 98,
     /*   61295 */     GIR_EraseRootFromParent_Done,
     /*   61296 */   // Label 990: @61296
     /*   61296 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(61371), // Rule ID 99 //
     /*   61301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*   61304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61324 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61331 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61337 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i32] }), 31:{ *:[i32] })
     /*   61337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   61340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   61356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   61369 */     GIR_RootConstrainSelectedInstOperands,
     /*   61370 */     // GIR_Coverage, 99,
     /*   61370 */     GIR_EraseRootFromParent_Done,
     /*   61371 */   // Label 991: @61371
     /*   61371 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(61428), // Rule ID 62589 //
     /*   61376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*   61379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61411 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULS:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   61411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   61414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61426 */     GIR_RootConstrainSelectedInstOperands,
     /*   61427 */     // GIR_Coverage, 62589,
     /*   61427 */     GIR_EraseRootFromParent_Done,
     /*   61428 */   // Label 992: @61428
     /*   61428 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(61451), // Rule ID 77 //
     /*   61433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   61436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61444 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   61444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   61449 */     GIR_RootConstrainSelectedInstOperands,
     /*   61450 */     // GIR_Coverage, 77,
     /*   61450 */     GIR_Done,
     /*   61451 */   // Label 993: @61451
     /*   61451 */   GIM_Reject,
     /*   61452 */ // Label 989: @61452
     /*   61452 */ GIM_Reject,
     /*   61453 */ // Label 965: @61453
     /*   61453 */ GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(61728),
     /*   61458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   61461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   61464 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(61543), // Rule ID 100 //
     /*   61469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   61472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61496 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61503 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61509 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 1:{ *:[i64] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, 63:{ *:[i64] }), 63:{ *:[i64] })
     /*   61509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   61512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61521 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61525 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*   61528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /*   61541 */     GIR_RootConstrainSelectedInstOperands,
     /*   61542 */     // GIR_Coverage, 100,
     /*   61542 */     GIR_EraseRootFromParent_Done,
     /*   61543 */   // Label 995: @61543
     /*   61543 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(61608), // Rule ID 62591 //
     /*   61548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   61551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10021),
     /*   61589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61591 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10021>>  =>  (TH_MULSW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULSW),
     /*   61594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61606 */     GIR_RootConstrainSelectedInstOperands,
     /*   61607 */     // GIR_Coverage, 62591,
     /*   61607 */     GIR_EraseRootFromParent_Done,
     /*   61608 */   // Label 996: @61608
     /*   61608 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(61669), // Rule ID 62588 //
     /*   61613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   61616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61652 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULS:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   61655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61667 */     GIR_RootConstrainSelectedInstOperands,
     /*   61668 */     // GIR_Coverage, 62588,
     /*   61668 */     GIR_EraseRootFromParent_Done,
     /*   61669 */   // Label 997: @61669
     /*   61669 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(61700), // Rule ID 267 //
     /*   61674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   61677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10021),
     /*   61693 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10021>>  =>  (SUBW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUBW),
     /*   61698 */     GIR_RootConstrainSelectedInstOperands,
     /*   61699 */     // GIR_Coverage, 267,
     /*   61699 */     GIR_Done,
     /*   61700 */   // Label 998: @61700
     /*   61700 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(61727), // Rule ID 76 //
     /*   61705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   61708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61720 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (SUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   61725 */     GIR_RootConstrainSelectedInstOperands,
     /*   61726 */     // GIR_Coverage, 76,
     /*   61726 */     GIR_Done,
     /*   61727 */   // Label 999: @61727
     /*   61727 */   GIM_Reject,
     /*   61728 */ // Label 994: @61728
     /*   61728 */ GIM_Reject,
     /*   61729 */ // Label 966: @61729
     /*   61729 */ GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(61975),
     /*   61734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   61737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   61740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61748 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(61812), // Rule ID 51938 //
     /*   61753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   61768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   61772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61786 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   61786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   61789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61810 */     GIR_RootConstrainSelectedInstOperands,
     /*   61811 */     // GIR_Coverage, 51938,
     /*   61811 */     GIR_EraseRootFromParent_Done,
     /*   61812 */   // Label 1001: @61812
     /*   61812 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(61876), // Rule ID 51939 //
     /*   61817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   61832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   61836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61850 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   61850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   61853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61874 */     GIR_RootConstrainSelectedInstOperands,
     /*   61875 */     // GIR_Coverage, 51939,
     /*   61875 */     GIR_EraseRootFromParent_Done,
     /*   61876 */   // Label 1002: @61876
     /*   61876 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(61925), // Rule ID 46212 //
     /*   61881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61888 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   61888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   61891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   61905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61923 */     GIR_RootConstrainSelectedInstOperands,
     /*   61924 */     // GIR_Coverage, 46212,
     /*   61924 */     GIR_EraseRootFromParent_Done,
     /*   61925 */   // Label 1003: @61925
     /*   61925 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61974), // Rule ID 46213 //
     /*   61930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61937 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   61940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   61954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61972 */     GIR_RootConstrainSelectedInstOperands,
     /*   61973 */     // GIR_Coverage, 46213,
     /*   61973 */     GIR_EraseRootFromParent_Done,
     /*   61974 */   // Label 1004: @61974
     /*   61974 */   GIM_Reject,
     /*   61975 */ // Label 1000: @61975
     /*   61975 */ GIM_Reject,
     /*   61976 */ // Label 967: @61976
     /*   61976 */ GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(63098),
     /*   61981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   61984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   61987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61991 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(62080), // Rule ID 47208 //
     /*   61996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62030 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62039 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62078 */     GIR_RootConstrainSelectedInstOperands,
     /*   62079 */     // GIR_Coverage, 47208,
     /*   62079 */     GIR_EraseRootFromParent_Done,
     /*   62080 */   // Label 1006: @62080
     /*   62080 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(62169), // Rule ID 47209 //
     /*   62085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62100 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62119 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62128 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62167 */     GIR_RootConstrainSelectedInstOperands,
     /*   62168 */     // GIR_Coverage, 47209,
     /*   62168 */     GIR_EraseRootFromParent_Done,
     /*   62169 */   // Label 1007: @62169
     /*   62169 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(62258), // Rule ID 46968 //
     /*   62174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62189 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62208 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62217 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   62234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62256 */     GIR_RootConstrainSelectedInstOperands,
     /*   62257 */     // GIR_Coverage, 46968,
     /*   62257 */     GIR_EraseRootFromParent_Done,
     /*   62258 */   // Label 1008: @62258
     /*   62258 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(62347), // Rule ID 46969 //
     /*   62263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62278 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62297 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62299 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62306 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   62323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62345 */     GIR_RootConstrainSelectedInstOperands,
     /*   62346 */     // GIR_Coverage, 46969,
     /*   62346 */     GIR_EraseRootFromParent_Done,
     /*   62347 */   // Label 1009: @62347
     /*   62347 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(62436), // Rule ID 47088 //
     /*   62352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62367 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62386 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62395 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62434 */     GIR_RootConstrainSelectedInstOperands,
     /*   62435 */     // GIR_Coverage, 47088,
     /*   62435 */     GIR_EraseRootFromParent_Done,
     /*   62436 */   // Label 1010: @62436
     /*   62436 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(62525), // Rule ID 47089 //
     /*   62441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62456 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62475 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62484 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62523 */     GIR_RootConstrainSelectedInstOperands,
     /*   62524 */     // GIR_Coverage, 47089,
     /*   62524 */     GIR_EraseRootFromParent_Done,
     /*   62525 */   // Label 1011: @62525
     /*   62525 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(62593), // Rule ID 51950 //
     /*   62530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   62549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   62553 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62567 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   62567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   62570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62591 */     GIR_RootConstrainSelectedInstOperands,
     /*   62592 */     // GIR_Coverage, 51950,
     /*   62592 */     GIR_EraseRootFromParent_Done,
     /*   62593 */   // Label 1012: @62593
     /*   62593 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(62661), // Rule ID 51951 //
     /*   62598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   62617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   62621 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62635 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   62635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   62638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62659 */     GIR_RootConstrainSelectedInstOperands,
     /*   62660 */     // GIR_Coverage, 51951,
     /*   62660 */     GIR_EraseRootFromParent_Done,
     /*   62661 */   // Label 1013: @62661
     /*   62661 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(62716), // Rule ID 47268 //
     /*   62666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62685 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62694 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62714 */     GIR_RootConstrainSelectedInstOperands,
     /*   62715 */     // GIR_Coverage, 47268,
     /*   62715 */     GIR_EraseRootFromParent_Done,
     /*   62716 */   // Label 1014: @62716
     /*   62716 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(62771), // Rule ID 47269 //
     /*   62721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62740 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62749 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62769 */     GIR_RootConstrainSelectedInstOperands,
     /*   62770 */     // GIR_Coverage, 47269,
     /*   62770 */     GIR_EraseRootFromParent_Done,
     /*   62771 */   // Label 1015: @62771
     /*   62771 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(62826), // Rule ID 47028 //
     /*   62776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62795 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62804 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   62807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62824 */     GIR_RootConstrainSelectedInstOperands,
     /*   62825 */     // GIR_Coverage, 47028,
     /*   62825 */     GIR_EraseRootFromParent_Done,
     /*   62826 */   // Label 1016: @62826
     /*   62826 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(62881), // Rule ID 47029 //
     /*   62831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62850 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62859 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   62862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62879 */     GIR_RootConstrainSelectedInstOperands,
     /*   62880 */     // GIR_Coverage, 47029,
     /*   62880 */     GIR_EraseRootFromParent_Done,
     /*   62881 */   // Label 1017: @62881
     /*   62881 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(62936), // Rule ID 47148 //
     /*   62886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62905 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62914 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62934 */     GIR_RootConstrainSelectedInstOperands,
     /*   62935 */     // GIR_Coverage, 47148,
     /*   62935 */     GIR_EraseRootFromParent_Done,
     /*   62936 */   // Label 1018: @62936
     /*   62936 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(62991), // Rule ID 47149 //
     /*   62941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62960 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62969 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62989 */     GIR_RootConstrainSelectedInstOperands,
     /*   62990 */     // GIR_Coverage, 47149,
     /*   62990 */     GIR_EraseRootFromParent_Done,
     /*   62991 */   // Label 1019: @62991
     /*   62991 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(63044), // Rule ID 46224 //
     /*   62996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63007 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   63010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   63024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63042 */     GIR_RootConstrainSelectedInstOperands,
     /*   63043 */     // GIR_Coverage, 46224,
     /*   63043 */     GIR_EraseRootFromParent_Done,
     /*   63044 */   // Label 1020: @63044
     /*   63044 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(63097), // Rule ID 46225 //
     /*   63049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63060 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   63063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   63077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63095 */     GIR_RootConstrainSelectedInstOperands,
     /*   63096 */     // GIR_Coverage, 46225,
     /*   63096 */     GIR_EraseRootFromParent_Done,
     /*   63097 */   // Label 1021: @63097
     /*   63097 */   GIM_Reject,
     /*   63098 */ // Label 1005: @63098
     /*   63098 */ GIM_Reject,
     /*   63099 */ // Label 968: @63099
     /*   63099 */ GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(64221),
     /*   63104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63114 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(63203), // Rule ID 47232 //
     /*   63119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63153 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63162 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63201 */     GIR_RootConstrainSelectedInstOperands,
     /*   63202 */     // GIR_Coverage, 47232,
     /*   63202 */     GIR_EraseRootFromParent_Done,
     /*   63203 */   // Label 1023: @63203
     /*   63203 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(63292), // Rule ID 47233 //
     /*   63208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63223 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63242 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63251 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63290 */     GIR_RootConstrainSelectedInstOperands,
     /*   63291 */     // GIR_Coverage, 47233,
     /*   63291 */     GIR_EraseRootFromParent_Done,
     /*   63292 */   // Label 1024: @63292
     /*   63292 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(63381), // Rule ID 46992 //
     /*   63297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63331 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63340 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   63357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63379 */     GIR_RootConstrainSelectedInstOperands,
     /*   63380 */     // GIR_Coverage, 46992,
     /*   63380 */     GIR_EraseRootFromParent_Done,
     /*   63381 */   // Label 1025: @63381
     /*   63381 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(63470), // Rule ID 46993 //
     /*   63386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63429 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   63446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63468 */     GIR_RootConstrainSelectedInstOperands,
     /*   63469 */     // GIR_Coverage, 46993,
     /*   63469 */     GIR_EraseRootFromParent_Done,
     /*   63470 */   // Label 1026: @63470
     /*   63470 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(63559), // Rule ID 47112 //
     /*   63475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63490 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63509 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63518 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63557 */     GIR_RootConstrainSelectedInstOperands,
     /*   63558 */     // GIR_Coverage, 47112,
     /*   63558 */     GIR_EraseRootFromParent_Done,
     /*   63559 */   // Label 1027: @63559
     /*   63559 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(63648), // Rule ID 47113 //
     /*   63564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63579 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63598 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63607 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63646 */     GIR_RootConstrainSelectedInstOperands,
     /*   63647 */     // GIR_Coverage, 47113,
     /*   63647 */     GIR_EraseRootFromParent_Done,
     /*   63648 */   // Label 1028: @63648
     /*   63648 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(63716), // Rule ID 51958 //
     /*   63653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63690 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   63690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   63693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63714 */     GIR_RootConstrainSelectedInstOperands,
     /*   63715 */     // GIR_Coverage, 51958,
     /*   63715 */     GIR_EraseRootFromParent_Done,
     /*   63716 */   // Label 1029: @63716
     /*   63716 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(63784), // Rule ID 51959 //
     /*   63721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63744 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63758 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   63758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   63761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63782 */     GIR_RootConstrainSelectedInstOperands,
     /*   63783 */     // GIR_Coverage, 51959,
     /*   63783 */     GIR_EraseRootFromParent_Done,
     /*   63784 */   // Label 1030: @63784
     /*   63784 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(63839), // Rule ID 47292 //
     /*   63789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63808 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63817 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   63817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   63820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63837 */     GIR_RootConstrainSelectedInstOperands,
     /*   63838 */     // GIR_Coverage, 47292,
     /*   63838 */     GIR_EraseRootFromParent_Done,
     /*   63839 */   // Label 1031: @63839
     /*   63839 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(63894), // Rule ID 47293 //
     /*   63844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63863 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63872 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   63872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   63875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63892 */     GIR_RootConstrainSelectedInstOperands,
     /*   63893 */     // GIR_Coverage, 47293,
     /*   63893 */     GIR_EraseRootFromParent_Done,
     /*   63894 */   // Label 1032: @63894
     /*   63894 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(63949), // Rule ID 47052 //
     /*   63899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63927 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   63927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   63930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63947 */     GIR_RootConstrainSelectedInstOperands,
     /*   63948 */     // GIR_Coverage, 47052,
     /*   63948 */     GIR_EraseRootFromParent_Done,
     /*   63949 */   // Label 1033: @63949
     /*   63949 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(64004), // Rule ID 47053 //
     /*   63954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63982 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   63982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   63985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64002 */     GIR_RootConstrainSelectedInstOperands,
     /*   64003 */     // GIR_Coverage, 47053,
     /*   64003 */     GIR_EraseRootFromParent_Done,
     /*   64004 */   // Label 1034: @64004
     /*   64004 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(64059), // Rule ID 47172 //
     /*   64009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64028 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64037 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   64037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64057 */     GIR_RootConstrainSelectedInstOperands,
     /*   64058 */     // GIR_Coverage, 47172,
     /*   64058 */     GIR_EraseRootFromParent_Done,
     /*   64059 */   // Label 1035: @64059
     /*   64059 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(64114), // Rule ID 47173 //
     /*   64064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64083 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64092 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   64092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64112 */     GIR_RootConstrainSelectedInstOperands,
     /*   64113 */     // GIR_Coverage, 47173,
     /*   64113 */     GIR_EraseRootFromParent_Done,
     /*   64114 */   // Label 1036: @64114
     /*   64114 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(64167), // Rule ID 46232 //
     /*   64119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64130 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   64147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64165 */     GIR_RootConstrainSelectedInstOperands,
     /*   64166 */     // GIR_Coverage, 46232,
     /*   64166 */     GIR_EraseRootFromParent_Done,
     /*   64167 */   // Label 1037: @64167
     /*   64167 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(64220), // Rule ID 46233 //
     /*   64172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64183 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   64200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64218 */     GIR_RootConstrainSelectedInstOperands,
     /*   64219 */     // GIR_Coverage, 46233,
     /*   64219 */     GIR_EraseRootFromParent_Done,
     /*   64220 */   // Label 1038: @64220
     /*   64220 */   GIM_Reject,
     /*   64221 */ // Label 1022: @64221
     /*   64221 */ GIM_Reject,
     /*   64222 */ // Label 969: @64222
     /*   64222 */ GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(65344),
     /*   64227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64237 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(64326), // Rule ID 47252 //
     /*   64242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64257 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64276 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64285 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64324 */     GIR_RootConstrainSelectedInstOperands,
     /*   64325 */     // GIR_Coverage, 47252,
     /*   64325 */     GIR_EraseRootFromParent_Done,
     /*   64326 */   // Label 1040: @64326
     /*   64326 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(64415), // Rule ID 47253 //
     /*   64331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64346 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64365 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64374 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64413 */     GIR_RootConstrainSelectedInstOperands,
     /*   64414 */     // GIR_Coverage, 47253,
     /*   64414 */     GIR_EraseRootFromParent_Done,
     /*   64415 */   // Label 1041: @64415
     /*   64415 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(64504), // Rule ID 47012 //
     /*   64420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64435 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64454 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64463 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   64480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64502 */     GIR_RootConstrainSelectedInstOperands,
     /*   64503 */     // GIR_Coverage, 47012,
     /*   64503 */     GIR_EraseRootFromParent_Done,
     /*   64504 */   // Label 1042: @64504
     /*   64504 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(64593), // Rule ID 47013 //
     /*   64509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64524 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64543 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64552 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   64569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64591 */     GIR_RootConstrainSelectedInstOperands,
     /*   64592 */     // GIR_Coverage, 47013,
     /*   64592 */     GIR_EraseRootFromParent_Done,
     /*   64593 */   // Label 1043: @64593
     /*   64593 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(64682), // Rule ID 47132 //
     /*   64598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64613 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64632 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64641 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64680 */     GIR_RootConstrainSelectedInstOperands,
     /*   64681 */     // GIR_Coverage, 47132,
     /*   64681 */     GIR_EraseRootFromParent_Done,
     /*   64682 */   // Label 1044: @64682
     /*   64682 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(64771), // Rule ID 47133 //
     /*   64687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64702 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64721 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64730 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64769 */     GIR_RootConstrainSelectedInstOperands,
     /*   64770 */     // GIR_Coverage, 47133,
     /*   64770 */     GIR_EraseRootFromParent_Done,
     /*   64771 */   // Label 1045: @64771
     /*   64771 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(64839), // Rule ID 51974 //
     /*   64776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   64779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64799 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64813 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   64813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   64816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   64834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64837 */     GIR_RootConstrainSelectedInstOperands,
     /*   64838 */     // GIR_Coverage, 51974,
     /*   64838 */     GIR_EraseRootFromParent_Done,
     /*   64839 */   // Label 1046: @64839
     /*   64839 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(64907), // Rule ID 51975 //
     /*   64844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   64847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64867 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64881 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   64881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   64884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   64902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64905 */     GIR_RootConstrainSelectedInstOperands,
     /*   64906 */     // GIR_Coverage, 51975,
     /*   64906 */     GIR_EraseRootFromParent_Done,
     /*   64907 */   // Label 1047: @64907
     /*   64907 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(64962), // Rule ID 47312 //
     /*   64912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64940 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   64940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   64943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64960 */     GIR_RootConstrainSelectedInstOperands,
     /*   64961 */     // GIR_Coverage, 47312,
     /*   64961 */     GIR_EraseRootFromParent_Done,
     /*   64962 */   // Label 1048: @64962
     /*   64962 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(65017), // Rule ID 47313 //
     /*   64967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64986 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64995 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   64995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   64998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65015 */     GIR_RootConstrainSelectedInstOperands,
     /*   65016 */     // GIR_Coverage, 47313,
     /*   65016 */     GIR_EraseRootFromParent_Done,
     /*   65017 */   // Label 1049: @65017
     /*   65017 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(65072), // Rule ID 47072 //
     /*   65022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65041 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65050 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65070 */     GIR_RootConstrainSelectedInstOperands,
     /*   65071 */     // GIR_Coverage, 47072,
     /*   65071 */     GIR_EraseRootFromParent_Done,
     /*   65072 */   // Label 1050: @65072
     /*   65072 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(65127), // Rule ID 47073 //
     /*   65077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65105 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65125 */     GIR_RootConstrainSelectedInstOperands,
     /*   65126 */     // GIR_Coverage, 47073,
     /*   65126 */     GIR_EraseRootFromParent_Done,
     /*   65127 */   // Label 1051: @65127
     /*   65127 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(65182), // Rule ID 47192 //
     /*   65132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65160 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65180 */     GIR_RootConstrainSelectedInstOperands,
     /*   65181 */     // GIR_Coverage, 47192,
     /*   65181 */     GIR_EraseRootFromParent_Done,
     /*   65182 */   // Label 1052: @65182
     /*   65182 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(65237), // Rule ID 47193 //
     /*   65187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65215 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65235 */     GIR_RootConstrainSelectedInstOperands,
     /*   65236 */     // GIR_Coverage, 47193,
     /*   65236 */     GIR_EraseRootFromParent_Done,
     /*   65237 */   // Label 1053: @65237
     /*   65237 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(65290), // Rule ID 46248 //
     /*   65242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   65245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65253 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   65253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   65270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65288 */     GIR_RootConstrainSelectedInstOperands,
     /*   65289 */     // GIR_Coverage, 46248,
     /*   65289 */     GIR_EraseRootFromParent_Done,
     /*   65290 */   // Label 1054: @65290
     /*   65290 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(65343), // Rule ID 46249 //
     /*   65295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   65298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65306 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   65306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   65323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65341 */     GIR_RootConstrainSelectedInstOperands,
     /*   65342 */     // GIR_Coverage, 46249,
     /*   65342 */     GIR_EraseRootFromParent_Done,
     /*   65343 */   // Label 1055: @65343
     /*   65343 */   GIM_Reject,
     /*   65344 */ // Label 1039: @65344
     /*   65344 */ GIM_Reject,
     /*   65345 */ // Label 970: @65345
     /*   65345 */ GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(65591),
     /*   65350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65364 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(65428), // Rule ID 51942 //
     /*   65369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65402 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   65402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   65405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65426 */     GIR_RootConstrainSelectedInstOperands,
     /*   65427 */     // GIR_Coverage, 51942,
     /*   65427 */     GIR_EraseRootFromParent_Done,
     /*   65428 */   // Label 1057: @65428
     /*   65428 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(65492), // Rule ID 51943 //
     /*   65433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65452 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65466 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   65466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   65469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65490 */     GIR_RootConstrainSelectedInstOperands,
     /*   65491 */     // GIR_Coverage, 51943,
     /*   65491 */     GIR_EraseRootFromParent_Done,
     /*   65492 */   // Label 1058: @65492
     /*   65492 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(65541), // Rule ID 46216 //
     /*   65497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65504 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   65507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   65521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65539 */     GIR_RootConstrainSelectedInstOperands,
     /*   65540 */     // GIR_Coverage, 46216,
     /*   65540 */     GIR_EraseRootFromParent_Done,
     /*   65541 */   // Label 1059: @65541
     /*   65541 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(65590), // Rule ID 46217 //
     /*   65546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65553 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   65556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   65570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65588 */     GIR_RootConstrainSelectedInstOperands,
     /*   65589 */     // GIR_Coverage, 46217,
     /*   65589 */     GIR_EraseRootFromParent_Done,
     /*   65590 */   // Label 1060: @65590
     /*   65590 */   GIM_Reject,
     /*   65591 */ // Label 1056: @65591
     /*   65591 */ GIM_Reject,
     /*   65592 */ // Label 971: @65592
     /*   65592 */ GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(66714),
     /*   65597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   65600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   65603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65607 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(65696), // Rule ID 47212 //
     /*   65612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65627 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65646 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65655 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   65672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65694 */     GIR_RootConstrainSelectedInstOperands,
     /*   65695 */     // GIR_Coverage, 47212,
     /*   65695 */     GIR_EraseRootFromParent_Done,
     /*   65696 */   // Label 1062: @65696
     /*   65696 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(65785), // Rule ID 47213 //
     /*   65701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65735 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65744 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   65761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65783 */     GIR_RootConstrainSelectedInstOperands,
     /*   65784 */     // GIR_Coverage, 47213,
     /*   65784 */     GIR_EraseRootFromParent_Done,
     /*   65785 */   // Label 1063: @65785
     /*   65785 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(65874), // Rule ID 46972 //
     /*   65790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65805 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65824 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65833 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   65850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65872 */     GIR_RootConstrainSelectedInstOperands,
     /*   65873 */     // GIR_Coverage, 46972,
     /*   65873 */     GIR_EraseRootFromParent_Done,
     /*   65874 */   // Label 1064: @65874
     /*   65874 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(65963), // Rule ID 46973 //
     /*   65879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65894 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65913 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65922 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   65939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65961 */     GIR_RootConstrainSelectedInstOperands,
     /*   65962 */     // GIR_Coverage, 46973,
     /*   65962 */     GIR_EraseRootFromParent_Done,
     /*   65963 */   // Label 1065: @65963
     /*   65963 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(66052), // Rule ID 47092 //
     /*   65968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65983 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66002 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66011 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   66011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66050 */     GIR_RootConstrainSelectedInstOperands,
     /*   66051 */     // GIR_Coverage, 47092,
     /*   66051 */     GIR_EraseRootFromParent_Done,
     /*   66052 */   // Label 1066: @66052
     /*   66052 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(66141), // Rule ID 47093 //
     /*   66057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66072 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66091 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66100 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   66100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66139 */     GIR_RootConstrainSelectedInstOperands,
     /*   66140 */     // GIR_Coverage, 47093,
     /*   66140 */     GIR_EraseRootFromParent_Done,
     /*   66141 */   // Label 1067: @66141
     /*   66141 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(66209), // Rule ID 51954 //
     /*   66146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66169 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66183 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   66183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   66186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66207 */     GIR_RootConstrainSelectedInstOperands,
     /*   66208 */     // GIR_Coverage, 51954,
     /*   66208 */     GIR_EraseRootFromParent_Done,
     /*   66209 */   // Label 1068: @66209
     /*   66209 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(66277), // Rule ID 51955 //
     /*   66214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66237 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66251 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   66251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   66254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66275 */     GIR_RootConstrainSelectedInstOperands,
     /*   66276 */     // GIR_Coverage, 51955,
     /*   66276 */     GIR_EraseRootFromParent_Done,
     /*   66277 */   // Label 1069: @66277
     /*   66277 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(66332), // Rule ID 47272 //
     /*   66282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66310 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66330 */     GIR_RootConstrainSelectedInstOperands,
     /*   66331 */     // GIR_Coverage, 47272,
     /*   66331 */     GIR_EraseRootFromParent_Done,
     /*   66332 */   // Label 1070: @66332
     /*   66332 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(66387), // Rule ID 47273 //
     /*   66337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66356 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66365 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66385 */     GIR_RootConstrainSelectedInstOperands,
     /*   66386 */     // GIR_Coverage, 47273,
     /*   66386 */     GIR_EraseRootFromParent_Done,
     /*   66387 */   // Label 1071: @66387
     /*   66387 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(66442), // Rule ID 47032 //
     /*   66392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66420 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   66423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66440 */     GIR_RootConstrainSelectedInstOperands,
     /*   66441 */     // GIR_Coverage, 47032,
     /*   66441 */     GIR_EraseRootFromParent_Done,
     /*   66442 */   // Label 1072: @66442
     /*   66442 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(66497), // Rule ID 47033 //
     /*   66447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66466 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66475 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   66478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66495 */     GIR_RootConstrainSelectedInstOperands,
     /*   66496 */     // GIR_Coverage, 47033,
     /*   66496 */     GIR_EraseRootFromParent_Done,
     /*   66497 */   // Label 1073: @66497
     /*   66497 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(66552), // Rule ID 47152 //
     /*   66502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66530 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66550 */     GIR_RootConstrainSelectedInstOperands,
     /*   66551 */     // GIR_Coverage, 47152,
     /*   66551 */     GIR_EraseRootFromParent_Done,
     /*   66552 */   // Label 1074: @66552
     /*   66552 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(66607), // Rule ID 47153 //
     /*   66557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66576 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66585 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66605 */     GIR_RootConstrainSelectedInstOperands,
     /*   66606 */     // GIR_Coverage, 47153,
     /*   66606 */     GIR_EraseRootFromParent_Done,
     /*   66607 */   // Label 1075: @66607
     /*   66607 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(66660), // Rule ID 46228 //
     /*   66612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66623 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   66640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   66647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   66649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66658 */     GIR_RootConstrainSelectedInstOperands,
     /*   66659 */     // GIR_Coverage, 46228,
     /*   66659 */     GIR_EraseRootFromParent_Done,
     /*   66660 */   // Label 1076: @66660
     /*   66660 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(66713), // Rule ID 46229 //
     /*   66665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66676 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   66676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   66693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   66700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   66702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66711 */     GIR_RootConstrainSelectedInstOperands,
     /*   66712 */     // GIR_Coverage, 46229,
     /*   66712 */     GIR_EraseRootFromParent_Done,
     /*   66713 */   // Label 1077: @66713
     /*   66713 */   GIM_Reject,
     /*   66714 */ // Label 1061: @66714
     /*   66714 */ GIM_Reject,
     /*   66715 */ // Label 972: @66715
     /*   66715 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(67837),
     /*   66720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   66723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   66726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66730 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(66819), // Rule ID 47236 //
     /*   66735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66750 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66769 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66778 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   66781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   66795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66817 */     GIR_RootConstrainSelectedInstOperands,
     /*   66818 */     // GIR_Coverage, 47236,
     /*   66818 */     GIR_EraseRootFromParent_Done,
     /*   66819 */   // Label 1079: @66819
     /*   66819 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(66908), // Rule ID 47237 //
     /*   66824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66839 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66858 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66867 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   66867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   66870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   66884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66906 */     GIR_RootConstrainSelectedInstOperands,
     /*   66907 */     // GIR_Coverage, 47237,
     /*   66907 */     GIR_EraseRootFromParent_Done,
     /*   66908 */   // Label 1080: @66908
     /*   66908 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(66997), // Rule ID 46996 //
     /*   66913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66928 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66947 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66956 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   66959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   66973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66995 */     GIR_RootConstrainSelectedInstOperands,
     /*   66996 */     // GIR_Coverage, 46996,
     /*   66996 */     GIR_EraseRootFromParent_Done,
     /*   66997 */   // Label 1081: @66997
     /*   66997 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(67086), // Rule ID 46997 //
     /*   67002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67017 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67036 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67045 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   67062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67084 */     GIR_RootConstrainSelectedInstOperands,
     /*   67085 */     // GIR_Coverage, 46997,
     /*   67085 */     GIR_EraseRootFromParent_Done,
     /*   67086 */   // Label 1082: @67086
     /*   67086 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(67175), // Rule ID 47116 //
     /*   67091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67106 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67125 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67134 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   67134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67173 */     GIR_RootConstrainSelectedInstOperands,
     /*   67174 */     // GIR_Coverage, 47116,
     /*   67174 */     GIR_EraseRootFromParent_Done,
     /*   67175 */   // Label 1083: @67175
     /*   67175 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(67264), // Rule ID 47117 //
     /*   67180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67195 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67214 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67223 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67262 */     GIR_RootConstrainSelectedInstOperands,
     /*   67263 */     // GIR_Coverage, 47117,
     /*   67263 */     GIR_EraseRootFromParent_Done,
     /*   67264 */   // Label 1084: @67264
     /*   67264 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(67332), // Rule ID 51970 //
     /*   67269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67306 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   67306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   67309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   67315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67330 */     GIR_RootConstrainSelectedInstOperands,
     /*   67331 */     // GIR_Coverage, 51970,
     /*   67331 */     GIR_EraseRootFromParent_Done,
     /*   67332 */   // Label 1085: @67332
     /*   67332 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(67400), // Rule ID 51971 //
     /*   67337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67360 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67374 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   67374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   67377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   67383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67398 */     GIR_RootConstrainSelectedInstOperands,
     /*   67399 */     // GIR_Coverage, 51971,
     /*   67399 */     GIR_EraseRootFromParent_Done,
     /*   67400 */   // Label 1086: @67400
     /*   67400 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(67455), // Rule ID 47296 //
     /*   67405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67433 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67453 */     GIR_RootConstrainSelectedInstOperands,
     /*   67454 */     // GIR_Coverage, 47296,
     /*   67454 */     GIR_EraseRootFromParent_Done,
     /*   67455 */   // Label 1087: @67455
     /*   67455 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(67510), // Rule ID 47297 //
     /*   67460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67479 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67488 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67508 */     GIR_RootConstrainSelectedInstOperands,
     /*   67509 */     // GIR_Coverage, 47297,
     /*   67509 */     GIR_EraseRootFromParent_Done,
     /*   67510 */   // Label 1088: @67510
     /*   67510 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(67565), // Rule ID 47056 //
     /*   67515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67534 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67543 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   67546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67563 */     GIR_RootConstrainSelectedInstOperands,
     /*   67564 */     // GIR_Coverage, 47056,
     /*   67564 */     GIR_EraseRootFromParent_Done,
     /*   67565 */   // Label 1089: @67565
     /*   67565 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(67620), // Rule ID 47057 //
     /*   67570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67589 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67598 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   67601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67618 */     GIR_RootConstrainSelectedInstOperands,
     /*   67619 */     // GIR_Coverage, 47057,
     /*   67619 */     GIR_EraseRootFromParent_Done,
     /*   67620 */   // Label 1090: @67620
     /*   67620 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(67675), // Rule ID 47176 //
     /*   67625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67644 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67653 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67673 */     GIR_RootConstrainSelectedInstOperands,
     /*   67674 */     // GIR_Coverage, 47176,
     /*   67674 */     GIR_EraseRootFromParent_Done,
     /*   67675 */   // Label 1091: @67675
     /*   67675 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(67730), // Rule ID 47177 //
     /*   67680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67699 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67708 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67728 */     GIR_RootConstrainSelectedInstOperands,
     /*   67729 */     // GIR_Coverage, 47177,
     /*   67729 */     GIR_EraseRootFromParent_Done,
     /*   67730 */   // Label 1092: @67730
     /*   67730 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(67783), // Rule ID 46244 //
     /*   67735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67746 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   67746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   67763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67781 */     GIR_RootConstrainSelectedInstOperands,
     /*   67782 */     // GIR_Coverage, 46244,
     /*   67782 */     GIR_EraseRootFromParent_Done,
     /*   67783 */   // Label 1093: @67783
     /*   67783 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(67836), // Rule ID 46245 //
     /*   67788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67799 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   67799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   67816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67834 */     GIR_RootConstrainSelectedInstOperands,
     /*   67835 */     // GIR_Coverage, 46245,
     /*   67835 */     GIR_EraseRootFromParent_Done,
     /*   67836 */   // Label 1094: @67836
     /*   67836 */   GIM_Reject,
     /*   67837 */ // Label 1078: @67837
     /*   67837 */ GIM_Reject,
     /*   67838 */ // Label 973: @67838
     /*   67838 */ GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(68960),
     /*   67843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   67846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   67849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67853 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(67942), // Rule ID 47256 //
     /*   67858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   67861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67873 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67892 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67901 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   67901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   67904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   67918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67940 */     GIR_RootConstrainSelectedInstOperands,
     /*   67941 */     // GIR_Coverage, 47256,
     /*   67941 */     GIR_EraseRootFromParent_Done,
     /*   67942 */   // Label 1096: @67942
     /*   67942 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(68031), // Rule ID 47257 //
     /*   67947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   67950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67962 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67981 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67990 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   67990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   67993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68029 */     GIR_RootConstrainSelectedInstOperands,
     /*   68030 */     // GIR_Coverage, 47257,
     /*   68030 */     GIR_EraseRootFromParent_Done,
     /*   68031 */   // Label 1097: @68031
     /*   68031 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(68120), // Rule ID 47016 //
     /*   68036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68051 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68070 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68079 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   68096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68118 */     GIR_RootConstrainSelectedInstOperands,
     /*   68119 */     // GIR_Coverage, 47016,
     /*   68119 */     GIR_EraseRootFromParent_Done,
     /*   68120 */   // Label 1098: @68120
     /*   68120 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(68209), // Rule ID 47017 //
     /*   68125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68140 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68159 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68168 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   68185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68207 */     GIR_RootConstrainSelectedInstOperands,
     /*   68208 */     // GIR_Coverage, 47017,
     /*   68208 */     GIR_EraseRootFromParent_Done,
     /*   68209 */   // Label 1099: @68209
     /*   68209 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(68298), // Rule ID 47136 //
     /*   68214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68229 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68248 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68257 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68296 */     GIR_RootConstrainSelectedInstOperands,
     /*   68297 */     // GIR_Coverage, 47136,
     /*   68297 */     GIR_EraseRootFromParent_Done,
     /*   68298 */   // Label 1100: @68298
     /*   68298 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(68387), // Rule ID 47137 //
     /*   68303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68318 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68337 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68346 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68385 */     GIR_RootConstrainSelectedInstOperands,
     /*   68386 */     // GIR_Coverage, 47137,
     /*   68386 */     GIR_EraseRootFromParent_Done,
     /*   68387 */   // Label 1101: @68387
     /*   68387 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(68455), // Rule ID 52014 //
     /*   68392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   68395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68415 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68429 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   68429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   68432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68453 */     GIR_RootConstrainSelectedInstOperands,
     /*   68454 */     // GIR_Coverage, 52014,
     /*   68454 */     GIR_EraseRootFromParent_Done,
     /*   68455 */   // Label 1102: @68455
     /*   68455 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(68523), // Rule ID 52015 //
     /*   68460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   68463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68483 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68497 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   68497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   68500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68521 */     GIR_RootConstrainSelectedInstOperands,
     /*   68522 */     // GIR_Coverage, 52015,
     /*   68522 */     GIR_EraseRootFromParent_Done,
     /*   68523 */   // Label 1103: @68523
     /*   68523 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(68578), // Rule ID 47316 //
     /*   68528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68547 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68556 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68576 */     GIR_RootConstrainSelectedInstOperands,
     /*   68577 */     // GIR_Coverage, 47316,
     /*   68577 */     GIR_EraseRootFromParent_Done,
     /*   68578 */   // Label 1104: @68578
     /*   68578 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(68633), // Rule ID 47317 //
     /*   68583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68611 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68631 */     GIR_RootConstrainSelectedInstOperands,
     /*   68632 */     // GIR_Coverage, 47317,
     /*   68632 */     GIR_EraseRootFromParent_Done,
     /*   68633 */   // Label 1105: @68633
     /*   68633 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(68688), // Rule ID 47076 //
     /*   68638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68657 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68666 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   68669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68686 */     GIR_RootConstrainSelectedInstOperands,
     /*   68687 */     // GIR_Coverage, 47076,
     /*   68687 */     GIR_EraseRootFromParent_Done,
     /*   68688 */   // Label 1106: @68688
     /*   68688 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(68743), // Rule ID 47077 //
     /*   68693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68712 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68721 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   68724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68741 */     GIR_RootConstrainSelectedInstOperands,
     /*   68742 */     // GIR_Coverage, 47077,
     /*   68742 */     GIR_EraseRootFromParent_Done,
     /*   68743 */   // Label 1107: @68743
     /*   68743 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(68798), // Rule ID 47196 //
     /*   68748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68767 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68776 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68796 */     GIR_RootConstrainSelectedInstOperands,
     /*   68797 */     // GIR_Coverage, 47196,
     /*   68797 */     GIR_EraseRootFromParent_Done,
     /*   68798 */   // Label 1108: @68798
     /*   68798 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(68853), // Rule ID 47197 //
     /*   68803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68822 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68831 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68851 */     GIR_RootConstrainSelectedInstOperands,
     /*   68852 */     // GIR_Coverage, 47197,
     /*   68852 */     GIR_EraseRootFromParent_Done,
     /*   68853 */   // Label 1109: @68853
     /*   68853 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(68906), // Rule ID 46288 //
     /*   68858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   68861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68869 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   68869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   68886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68904 */     GIR_RootConstrainSelectedInstOperands,
     /*   68905 */     // GIR_Coverage, 46288,
     /*   68905 */     GIR_EraseRootFromParent_Done,
     /*   68906 */   // Label 1110: @68906
     /*   68906 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(68959), // Rule ID 46289 //
     /*   68911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   68914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68922 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   68922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   68939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68957 */     GIR_RootConstrainSelectedInstOperands,
     /*   68958 */     // GIR_Coverage, 46289,
     /*   68958 */     GIR_EraseRootFromParent_Done,
     /*   68959 */   // Label 1111: @68959
     /*   68959 */   GIM_Reject,
     /*   68960 */ // Label 1095: @68960
     /*   68960 */ GIM_Reject,
     /*   68961 */ // Label 974: @68961
     /*   68961 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(69207),
     /*   68966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   68969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   68972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68980 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(69044), // Rule ID 51946 //
     /*   68985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69004 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69018 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   69018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   69021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69042 */     GIR_RootConstrainSelectedInstOperands,
     /*   69043 */     // GIR_Coverage, 51946,
     /*   69043 */     GIR_EraseRootFromParent_Done,
     /*   69044 */   // Label 1113: @69044
     /*   69044 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(69108), // Rule ID 51947 //
     /*   69049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69068 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69082 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   69082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   69085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69106 */     GIR_RootConstrainSelectedInstOperands,
     /*   69107 */     // GIR_Coverage, 51947,
     /*   69107 */     GIR_EraseRootFromParent_Done,
     /*   69108 */   // Label 1114: @69108
     /*   69108 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(69157), // Rule ID 46220 //
     /*   69113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69120 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   69123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   69137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69155 */     GIR_RootConstrainSelectedInstOperands,
     /*   69156 */     // GIR_Coverage, 46220,
     /*   69156 */     GIR_EraseRootFromParent_Done,
     /*   69157 */   // Label 1115: @69157
     /*   69157 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(69206), // Rule ID 46221 //
     /*   69162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69169 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   69172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   69186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69204 */     GIR_RootConstrainSelectedInstOperands,
     /*   69205 */     // GIR_Coverage, 46221,
     /*   69205 */     GIR_EraseRootFromParent_Done,
     /*   69206 */   // Label 1116: @69206
     /*   69206 */   GIM_Reject,
     /*   69207 */ // Label 1112: @69207
     /*   69207 */ GIM_Reject,
     /*   69208 */ // Label 975: @69208
     /*   69208 */ GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(70330),
     /*   69213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69223 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(69312), // Rule ID 47216 //
     /*   69228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69243 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69262 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69271 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69310 */     GIR_RootConstrainSelectedInstOperands,
     /*   69311 */     // GIR_Coverage, 47216,
     /*   69311 */     GIR_EraseRootFromParent_Done,
     /*   69312 */   // Label 1118: @69312
     /*   69312 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(69401), // Rule ID 47217 //
     /*   69317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69332 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69351 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69360 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69399 */     GIR_RootConstrainSelectedInstOperands,
     /*   69400 */     // GIR_Coverage, 47217,
     /*   69400 */     GIR_EraseRootFromParent_Done,
     /*   69401 */   // Label 1119: @69401
     /*   69401 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(69490), // Rule ID 46976 //
     /*   69406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69449 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   69466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69488 */     GIR_RootConstrainSelectedInstOperands,
     /*   69489 */     // GIR_Coverage, 46976,
     /*   69489 */     GIR_EraseRootFromParent_Done,
     /*   69490 */   // Label 1120: @69490
     /*   69490 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(69579), // Rule ID 46977 //
     /*   69495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69510 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69529 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69538 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   69555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69577 */     GIR_RootConstrainSelectedInstOperands,
     /*   69578 */     // GIR_Coverage, 46977,
     /*   69578 */     GIR_EraseRootFromParent_Done,
     /*   69579 */   // Label 1121: @69579
     /*   69579 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(69668), // Rule ID 47096 //
     /*   69584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69599 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69618 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69627 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69666 */     GIR_RootConstrainSelectedInstOperands,
     /*   69667 */     // GIR_Coverage, 47096,
     /*   69667 */     GIR_EraseRootFromParent_Done,
     /*   69668 */   // Label 1122: @69668
     /*   69668 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(69757), // Rule ID 47097 //
     /*   69673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69688 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69707 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69716 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69755 */     GIR_RootConstrainSelectedInstOperands,
     /*   69756 */     // GIR_Coverage, 47097,
     /*   69756 */     GIR_EraseRootFromParent_Done,
     /*   69757 */   // Label 1123: @69757
     /*   69757 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(69825), // Rule ID 51966 //
     /*   69762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69785 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69799 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   69799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   69802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69823 */     GIR_RootConstrainSelectedInstOperands,
     /*   69824 */     // GIR_Coverage, 51966,
     /*   69824 */     GIR_EraseRootFromParent_Done,
     /*   69825 */   // Label 1124: @69825
     /*   69825 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(69893), // Rule ID 51967 //
     /*   69830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69853 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69867 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   69867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   69870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69891 */     GIR_RootConstrainSelectedInstOperands,
     /*   69892 */     // GIR_Coverage, 51967,
     /*   69892 */     GIR_EraseRootFromParent_Done,
     /*   69893 */   // Label 1125: @69893
     /*   69893 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(69948), // Rule ID 47276 //
     /*   69898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69917 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69926 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   69926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   69929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69946 */     GIR_RootConstrainSelectedInstOperands,
     /*   69947 */     // GIR_Coverage, 47276,
     /*   69947 */     GIR_EraseRootFromParent_Done,
     /*   69948 */   // Label 1126: @69948
     /*   69948 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(70003), // Rule ID 47277 //
     /*   69953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69972 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69981 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   69981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   69984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70001 */     GIR_RootConstrainSelectedInstOperands,
     /*   70002 */     // GIR_Coverage, 47277,
     /*   70002 */     GIR_EraseRootFromParent_Done,
     /*   70003 */   // Label 1127: @70003
     /*   70003 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(70058), // Rule ID 47036 //
     /*   70008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70027 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70036 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   70039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70056 */     GIR_RootConstrainSelectedInstOperands,
     /*   70057 */     // GIR_Coverage, 47036,
     /*   70057 */     GIR_EraseRootFromParent_Done,
     /*   70058 */   // Label 1128: @70058
     /*   70058 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(70113), // Rule ID 47037 //
     /*   70063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70082 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70091 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   70094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70111 */     GIR_RootConstrainSelectedInstOperands,
     /*   70112 */     // GIR_Coverage, 47037,
     /*   70112 */     GIR_EraseRootFromParent_Done,
     /*   70113 */   // Label 1129: @70113
     /*   70113 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(70168), // Rule ID 47156 //
     /*   70118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70137 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70146 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70166 */     GIR_RootConstrainSelectedInstOperands,
     /*   70167 */     // GIR_Coverage, 47156,
     /*   70167 */     GIR_EraseRootFromParent_Done,
     /*   70168 */   // Label 1130: @70168
     /*   70168 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(70223), // Rule ID 47157 //
     /*   70173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70192 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70201 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70221 */     GIR_RootConstrainSelectedInstOperands,
     /*   70222 */     // GIR_Coverage, 47157,
     /*   70222 */     GIR_EraseRootFromParent_Done,
     /*   70223 */   // Label 1131: @70223
     /*   70223 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(70276), // Rule ID 46240 //
     /*   70228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70239 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   70256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70274 */     GIR_RootConstrainSelectedInstOperands,
     /*   70275 */     // GIR_Coverage, 46240,
     /*   70275 */     GIR_EraseRootFromParent_Done,
     /*   70276 */   // Label 1132: @70276
     /*   70276 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(70329), // Rule ID 46241 //
     /*   70281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70292 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   70309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70327 */     GIR_RootConstrainSelectedInstOperands,
     /*   70328 */     // GIR_Coverage, 46241,
     /*   70328 */     GIR_EraseRootFromParent_Done,
     /*   70329 */   // Label 1133: @70329
     /*   70329 */   GIM_Reject,
     /*   70330 */ // Label 1117: @70330
     /*   70330 */ GIM_Reject,
     /*   70331 */ // Label 976: @70331
     /*   70331 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(71453),
     /*   70336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70346 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(70435), // Rule ID 47240 //
     /*   70351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70385 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70394 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70433 */     GIR_RootConstrainSelectedInstOperands,
     /*   70434 */     // GIR_Coverage, 47240,
     /*   70434 */     GIR_EraseRootFromParent_Done,
     /*   70435 */   // Label 1135: @70435
     /*   70435 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(70524), // Rule ID 47241 //
     /*   70440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70455 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70474 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70483 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70522 */     GIR_RootConstrainSelectedInstOperands,
     /*   70523 */     // GIR_Coverage, 47241,
     /*   70523 */     GIR_EraseRootFromParent_Done,
     /*   70524 */   // Label 1136: @70524
     /*   70524 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(70613), // Rule ID 47000 //
     /*   70529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70544 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70563 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70572 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   70589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70611 */     GIR_RootConstrainSelectedInstOperands,
     /*   70612 */     // GIR_Coverage, 47000,
     /*   70612 */     GIR_EraseRootFromParent_Done,
     /*   70613 */   // Label 1137: @70613
     /*   70613 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(70702), // Rule ID 47001 //
     /*   70618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70633 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70652 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70661 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   70678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70700 */     GIR_RootConstrainSelectedInstOperands,
     /*   70701 */     // GIR_Coverage, 47001,
     /*   70701 */     GIR_EraseRootFromParent_Done,
     /*   70702 */   // Label 1138: @70702
     /*   70702 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(70791), // Rule ID 47120 //
     /*   70707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70741 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70750 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70789 */     GIR_RootConstrainSelectedInstOperands,
     /*   70790 */     // GIR_Coverage, 47120,
     /*   70790 */     GIR_EraseRootFromParent_Done,
     /*   70791 */   // Label 1139: @70791
     /*   70791 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(70880), // Rule ID 47121 //
     /*   70796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70811 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70830 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70839 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70878 */     GIR_RootConstrainSelectedInstOperands,
     /*   70879 */     // GIR_Coverage, 47121,
     /*   70879 */     GIR_EraseRootFromParent_Done,
     /*   70880 */   // Label 1140: @70880
     /*   70880 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(70948), // Rule ID 52002 //
     /*   70885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70922 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   70922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   70925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   70931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   70943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70946 */     GIR_RootConstrainSelectedInstOperands,
     /*   70947 */     // GIR_Coverage, 52002,
     /*   70947 */     GIR_EraseRootFromParent_Done,
     /*   70948 */   // Label 1141: @70948
     /*   70948 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(71016), // Rule ID 52003 //
     /*   70953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70990 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   70990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   70993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   70999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71014 */     GIR_RootConstrainSelectedInstOperands,
     /*   71015 */     // GIR_Coverage, 52003,
     /*   71015 */     GIR_EraseRootFromParent_Done,
     /*   71016 */   // Label 1142: @71016
     /*   71016 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(71071), // Rule ID 47300 //
     /*   71021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71049 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71069 */     GIR_RootConstrainSelectedInstOperands,
     /*   71070 */     // GIR_Coverage, 47300,
     /*   71070 */     GIR_EraseRootFromParent_Done,
     /*   71071 */   // Label 1143: @71071
     /*   71071 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(71126), // Rule ID 47301 //
     /*   71076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71095 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71104 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71124 */     GIR_RootConstrainSelectedInstOperands,
     /*   71125 */     // GIR_Coverage, 47301,
     /*   71125 */     GIR_EraseRootFromParent_Done,
     /*   71126 */   // Label 1144: @71126
     /*   71126 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(71181), // Rule ID 47060 //
     /*   71131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71159 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   71162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71179 */     GIR_RootConstrainSelectedInstOperands,
     /*   71180 */     // GIR_Coverage, 47060,
     /*   71180 */     GIR_EraseRootFromParent_Done,
     /*   71181 */   // Label 1145: @71181
     /*   71181 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(71236), // Rule ID 47061 //
     /*   71186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71205 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71214 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   71217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71234 */     GIR_RootConstrainSelectedInstOperands,
     /*   71235 */     // GIR_Coverage, 47061,
     /*   71235 */     GIR_EraseRootFromParent_Done,
     /*   71236 */   // Label 1146: @71236
     /*   71236 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(71291), // Rule ID 47180 //
     /*   71241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71260 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71269 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71289 */     GIR_RootConstrainSelectedInstOperands,
     /*   71290 */     // GIR_Coverage, 47180,
     /*   71290 */     GIR_EraseRootFromParent_Done,
     /*   71291 */   // Label 1147: @71291
     /*   71291 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71346), // Rule ID 47181 //
     /*   71296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71315 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71324 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71344 */     GIR_RootConstrainSelectedInstOperands,
     /*   71345 */     // GIR_Coverage, 47181,
     /*   71345 */     GIR_EraseRootFromParent_Done,
     /*   71346 */   // Label 1148: @71346
     /*   71346 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(71399), // Rule ID 46276 //
     /*   71351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71362 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   71379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   71388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71397 */     GIR_RootConstrainSelectedInstOperands,
     /*   71398 */     // GIR_Coverage, 46276,
     /*   71398 */     GIR_EraseRootFromParent_Done,
     /*   71399 */   // Label 1149: @71399
     /*   71399 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(71452), // Rule ID 46277 //
     /*   71404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71415 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   71432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   71441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71450 */     GIR_RootConstrainSelectedInstOperands,
     /*   71451 */     // GIR_Coverage, 46277,
     /*   71451 */     GIR_EraseRootFromParent_Done,
     /*   71452 */   // Label 1150: @71452
     /*   71452 */   GIM_Reject,
     /*   71453 */ // Label 1134: @71453
     /*   71453 */ GIM_Reject,
     /*   71454 */ // Label 977: @71454
     /*   71454 */ GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(72576),
     /*   71459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   71462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   71465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71469 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(71558), // Rule ID 47260 //
     /*   71474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71489 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71508 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71517 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71556 */     GIR_RootConstrainSelectedInstOperands,
     /*   71557 */     // GIR_Coverage, 47260,
     /*   71557 */     GIR_EraseRootFromParent_Done,
     /*   71558 */   // Label 1152: @71558
     /*   71558 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71647), // Rule ID 47261 //
     /*   71563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71578 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71597 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71606 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71645 */     GIR_RootConstrainSelectedInstOperands,
     /*   71646 */     // GIR_Coverage, 47261,
     /*   71646 */     GIR_EraseRootFromParent_Done,
     /*   71647 */   // Label 1153: @71647
     /*   71647 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(71736), // Rule ID 47020 //
     /*   71652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71667 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71686 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71695 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   71712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71734 */     GIR_RootConstrainSelectedInstOperands,
     /*   71735 */     // GIR_Coverage, 47020,
     /*   71735 */     GIR_EraseRootFromParent_Done,
     /*   71736 */   // Label 1154: @71736
     /*   71736 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(71825), // Rule ID 47021 //
     /*   71741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71756 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71775 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71784 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   71801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71823 */     GIR_RootConstrainSelectedInstOperands,
     /*   71824 */     // GIR_Coverage, 47021,
     /*   71824 */     GIR_EraseRootFromParent_Done,
     /*   71825 */   // Label 1155: @71825
     /*   71825 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(71914), // Rule ID 47140 //
     /*   71830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71845 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71864 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71873 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71912 */     GIR_RootConstrainSelectedInstOperands,
     /*   71913 */     // GIR_Coverage, 47140,
     /*   71913 */     GIR_EraseRootFromParent_Done,
     /*   71914 */   // Label 1156: @71914
     /*   71914 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(72003), // Rule ID 47141 //
     /*   71919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71934 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71953 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71962 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72001 */     GIR_RootConstrainSelectedInstOperands,
     /*   72002 */     // GIR_Coverage, 47141,
     /*   72002 */     GIR_EraseRootFromParent_Done,
     /*   72003 */   // Label 1157: @72003
     /*   72003 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(72071), // Rule ID 52018 //
     /*   72008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   72011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   72027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   72031 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72045 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   72045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72069 */     GIR_RootConstrainSelectedInstOperands,
     /*   72070 */     // GIR_Coverage, 52018,
     /*   72070 */     GIR_EraseRootFromParent_Done,
     /*   72071 */   // Label 1158: @72071
     /*   72071 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(72139), // Rule ID 52019 //
     /*   72076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   72079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   72095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   72099 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72113 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   72113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72137 */     GIR_RootConstrainSelectedInstOperands,
     /*   72138 */     // GIR_Coverage, 52019,
     /*   72138 */     GIR_EraseRootFromParent_Done,
     /*   72139 */   // Label 1159: @72139
     /*   72139 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(72194), // Rule ID 47320 //
     /*   72144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72172 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72192 */     GIR_RootConstrainSelectedInstOperands,
     /*   72193 */     // GIR_Coverage, 47320,
     /*   72193 */     GIR_EraseRootFromParent_Done,
     /*   72194 */   // Label 1160: @72194
     /*   72194 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(72249), // Rule ID 47321 //
     /*   72199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72227 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72247 */     GIR_RootConstrainSelectedInstOperands,
     /*   72248 */     // GIR_Coverage, 47321,
     /*   72248 */     GIR_EraseRootFromParent_Done,
     /*   72249 */   // Label 1161: @72249
     /*   72249 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(72304), // Rule ID 47080 //
     /*   72254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72273 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72282 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   72285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72302 */     GIR_RootConstrainSelectedInstOperands,
     /*   72303 */     // GIR_Coverage, 47080,
     /*   72303 */     GIR_EraseRootFromParent_Done,
     /*   72304 */   // Label 1162: @72304
     /*   72304 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(72359), // Rule ID 47081 //
     /*   72309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72337 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   72340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72357 */     GIR_RootConstrainSelectedInstOperands,
     /*   72358 */     // GIR_Coverage, 47081,
     /*   72358 */     GIR_EraseRootFromParent_Done,
     /*   72359 */   // Label 1163: @72359
     /*   72359 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72414), // Rule ID 47200 //
     /*   72364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72383 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72392 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72412 */     GIR_RootConstrainSelectedInstOperands,
     /*   72413 */     // GIR_Coverage, 47200,
     /*   72413 */     GIR_EraseRootFromParent_Done,
     /*   72414 */   // Label 1164: @72414
     /*   72414 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(72469), // Rule ID 47201 //
     /*   72419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72438 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72447 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72467 */     GIR_RootConstrainSelectedInstOperands,
     /*   72468 */     // GIR_Coverage, 47201,
     /*   72468 */     GIR_EraseRootFromParent_Done,
     /*   72469 */   // Label 1165: @72469
     /*   72469 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(72522), // Rule ID 46292 //
     /*   72474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   72477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72485 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   72485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   72502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72520 */     GIR_RootConstrainSelectedInstOperands,
     /*   72521 */     // GIR_Coverage, 46292,
     /*   72521 */     GIR_EraseRootFromParent_Done,
     /*   72522 */   // Label 1166: @72522
     /*   72522 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(72575), // Rule ID 46293 //
     /*   72527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   72530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72538 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   72538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   72555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72573 */     GIR_RootConstrainSelectedInstOperands,
     /*   72574 */     // GIR_Coverage, 46293,
     /*   72574 */     GIR_EraseRootFromParent_Done,
     /*   72575 */   // Label 1167: @72575
     /*   72575 */   GIM_Reject,
     /*   72576 */ // Label 1151: @72576
     /*   72576 */ GIM_Reject,
     /*   72577 */ // Label 978: @72577
     /*   72577 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(72823),
     /*   72582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   72588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72596 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72660), // Rule ID 51962 //
     /*   72601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   72620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72634 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   72634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   72637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72658 */     GIR_RootConstrainSelectedInstOperands,
     /*   72659 */     // GIR_Coverage, 51962,
     /*   72659 */     GIR_EraseRootFromParent_Done,
     /*   72660 */   // Label 1169: @72660
     /*   72660 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72724), // Rule ID 51963 //
     /*   72665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   72684 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72698 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   72698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   72701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72722 */     GIR_RootConstrainSelectedInstOperands,
     /*   72723 */     // GIR_Coverage, 51963,
     /*   72723 */     GIR_EraseRootFromParent_Done,
     /*   72724 */   // Label 1170: @72724
     /*   72724 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72773), // Rule ID 46236 //
     /*   72729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72736 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   72736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   72739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   72753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72771 */     GIR_RootConstrainSelectedInstOperands,
     /*   72772 */     // GIR_Coverage, 46236,
     /*   72772 */     GIR_EraseRootFromParent_Done,
     /*   72773 */   // Label 1171: @72773
     /*   72773 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72822), // Rule ID 46237 //
     /*   72778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72785 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   72785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   72788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   72802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72820 */     GIR_RootConstrainSelectedInstOperands,
     /*   72821 */     // GIR_Coverage, 46237,
     /*   72821 */     GIR_EraseRootFromParent_Done,
     /*   72822 */   // Label 1172: @72822
     /*   72822 */   GIM_Reject,
     /*   72823 */ // Label 1168: @72823
     /*   72823 */ GIM_Reject,
     /*   72824 */ // Label 979: @72824
     /*   72824 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(73946),
     /*   72829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   72832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   72835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72839 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72928), // Rule ID 47220 //
     /*   72844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72859 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72878 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72887 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   72887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   72890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   72904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72926 */     GIR_RootConstrainSelectedInstOperands,
     /*   72927 */     // GIR_Coverage, 47220,
     /*   72927 */     GIR_EraseRootFromParent_Done,
     /*   72928 */   // Label 1174: @72928
     /*   72928 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(73017), // Rule ID 47221 //
     /*   72933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72948 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72967 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72976 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   72976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   72979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   72993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73015 */     GIR_RootConstrainSelectedInstOperands,
     /*   73016 */     // GIR_Coverage, 47221,
     /*   73016 */     GIR_EraseRootFromParent_Done,
     /*   73017 */   // Label 1175: @73017
     /*   73017 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(73106), // Rule ID 46980 //
     /*   73022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73037 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73056 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73065 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   73082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73104 */     GIR_RootConstrainSelectedInstOperands,
     /*   73105 */     // GIR_Coverage, 46980,
     /*   73105 */     GIR_EraseRootFromParent_Done,
     /*   73106 */   // Label 1176: @73106
     /*   73106 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(73195), // Rule ID 46981 //
     /*   73111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73145 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73154 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   73171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73193 */     GIR_RootConstrainSelectedInstOperands,
     /*   73194 */     // GIR_Coverage, 46981,
     /*   73194 */     GIR_EraseRootFromParent_Done,
     /*   73195 */   // Label 1177: @73195
     /*   73195 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(73284), // Rule ID 47100 //
     /*   73200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73215 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73234 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73243 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73282 */     GIR_RootConstrainSelectedInstOperands,
     /*   73283 */     // GIR_Coverage, 47100,
     /*   73283 */     GIR_EraseRootFromParent_Done,
     /*   73284 */   // Label 1178: @73284
     /*   73284 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(73373), // Rule ID 47101 //
     /*   73289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73304 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73323 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73332 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73371 */     GIR_RootConstrainSelectedInstOperands,
     /*   73372 */     // GIR_Coverage, 47101,
     /*   73372 */     GIR_EraseRootFromParent_Done,
     /*   73373 */   // Label 1179: @73373
     /*   73373 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(73441), // Rule ID 51990 //
     /*   73378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73415 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   73415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   73418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73439 */     GIR_RootConstrainSelectedInstOperands,
     /*   73440 */     // GIR_Coverage, 51990,
     /*   73440 */     GIR_EraseRootFromParent_Done,
     /*   73441 */   // Label 1180: @73441
     /*   73441 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(73509), // Rule ID 51991 //
     /*   73446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73483 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   73483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   73486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73507 */     GIR_RootConstrainSelectedInstOperands,
     /*   73508 */     // GIR_Coverage, 51991,
     /*   73508 */     GIR_EraseRootFromParent_Done,
     /*   73509 */   // Label 1181: @73509
     /*   73509 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73564), // Rule ID 47280 //
     /*   73514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73533 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73542 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73562 */     GIR_RootConstrainSelectedInstOperands,
     /*   73563 */     // GIR_Coverage, 47280,
     /*   73563 */     GIR_EraseRootFromParent_Done,
     /*   73564 */   // Label 1182: @73564
     /*   73564 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73619), // Rule ID 47281 //
     /*   73569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73588 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73597 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73617 */     GIR_RootConstrainSelectedInstOperands,
     /*   73618 */     // GIR_Coverage, 47281,
     /*   73618 */     GIR_EraseRootFromParent_Done,
     /*   73619 */   // Label 1183: @73619
     /*   73619 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73674), // Rule ID 47040 //
     /*   73624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73643 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73652 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   73655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73672 */     GIR_RootConstrainSelectedInstOperands,
     /*   73673 */     // GIR_Coverage, 47040,
     /*   73673 */     GIR_EraseRootFromParent_Done,
     /*   73674 */   // Label 1184: @73674
     /*   73674 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73729), // Rule ID 47041 //
     /*   73679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73698 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73707 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   73710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73727 */     GIR_RootConstrainSelectedInstOperands,
     /*   73728 */     // GIR_Coverage, 47041,
     /*   73728 */     GIR_EraseRootFromParent_Done,
     /*   73729 */   // Label 1185: @73729
     /*   73729 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73784), // Rule ID 47160 //
     /*   73734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73753 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73762 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73782 */     GIR_RootConstrainSelectedInstOperands,
     /*   73783 */     // GIR_Coverage, 47160,
     /*   73783 */     GIR_EraseRootFromParent_Done,
     /*   73784 */   // Label 1186: @73784
     /*   73784 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73839), // Rule ID 47161 //
     /*   73789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73808 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73817 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73837 */     GIR_RootConstrainSelectedInstOperands,
     /*   73838 */     // GIR_Coverage, 47161,
     /*   73838 */     GIR_EraseRootFromParent_Done,
     /*   73839 */   // Label 1187: @73839
     /*   73839 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73892), // Rule ID 46264 //
     /*   73844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73855 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   73855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   73872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73890 */     GIR_RootConstrainSelectedInstOperands,
     /*   73891 */     // GIR_Coverage, 46264,
     /*   73891 */     GIR_EraseRootFromParent_Done,
     /*   73892 */   // Label 1188: @73892
     /*   73892 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73945), // Rule ID 46265 //
     /*   73897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73908 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   73908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   73925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73943 */     GIR_RootConstrainSelectedInstOperands,
     /*   73944 */     // GIR_Coverage, 46265,
     /*   73944 */     GIR_EraseRootFromParent_Done,
     /*   73945 */   // Label 1189: @73945
     /*   73945 */   GIM_Reject,
     /*   73946 */ // Label 1173: @73946
     /*   73946 */ GIM_Reject,
     /*   73947 */ // Label 980: @73947
     /*   73947 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(75069),
     /*   73952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   73955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   73958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73962 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(74051), // Rule ID 47244 //
     /*   73967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73982 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74001 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74010 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74049 */     GIR_RootConstrainSelectedInstOperands,
     /*   74050 */     // GIR_Coverage, 47244,
     /*   74050 */     GIR_EraseRootFromParent_Done,
     /*   74051 */   // Label 1191: @74051
     /*   74051 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(74140), // Rule ID 47245 //
     /*   74056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74071 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74090 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74099 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74138 */     GIR_RootConstrainSelectedInstOperands,
     /*   74139 */     // GIR_Coverage, 47245,
     /*   74139 */     GIR_EraseRootFromParent_Done,
     /*   74140 */   // Label 1192: @74140
     /*   74140 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(74229), // Rule ID 47004 //
     /*   74145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74160 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74179 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74188 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   74205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74227 */     GIR_RootConstrainSelectedInstOperands,
     /*   74228 */     // GIR_Coverage, 47004,
     /*   74228 */     GIR_EraseRootFromParent_Done,
     /*   74229 */   // Label 1193: @74229
     /*   74229 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74318), // Rule ID 47005 //
     /*   74234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74249 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74268 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74277 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   74294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74316 */     GIR_RootConstrainSelectedInstOperands,
     /*   74317 */     // GIR_Coverage, 47005,
     /*   74317 */     GIR_EraseRootFromParent_Done,
     /*   74318 */   // Label 1194: @74318
     /*   74318 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74407), // Rule ID 47124 //
     /*   74323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74338 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74357 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74366 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74405 */     GIR_RootConstrainSelectedInstOperands,
     /*   74406 */     // GIR_Coverage, 47124,
     /*   74406 */     GIR_EraseRootFromParent_Done,
     /*   74407 */   // Label 1195: @74407
     /*   74407 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74496), // Rule ID 47125 //
     /*   74412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74427 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74446 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74455 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74494 */     GIR_RootConstrainSelectedInstOperands,
     /*   74495 */     // GIR_Coverage, 47125,
     /*   74495 */     GIR_EraseRootFromParent_Done,
     /*   74496 */   // Label 1196: @74496
     /*   74496 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74564), // Rule ID 52006 //
     /*   74501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   74520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   74524 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74538 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   74538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   74541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   74547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   74559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74562 */     GIR_RootConstrainSelectedInstOperands,
     /*   74563 */     // GIR_Coverage, 52006,
     /*   74563 */     GIR_EraseRootFromParent_Done,
     /*   74564 */   // Label 1197: @74564
     /*   74564 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74632), // Rule ID 52007 //
     /*   74569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   74588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   74592 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74606 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   74606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   74609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   74615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   74627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74630 */     GIR_RootConstrainSelectedInstOperands,
     /*   74631 */     // GIR_Coverage, 52007,
     /*   74631 */     GIR_EraseRootFromParent_Done,
     /*   74632 */   // Label 1198: @74632
     /*   74632 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74687), // Rule ID 47304 //
     /*   74637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74665 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74685 */     GIR_RootConstrainSelectedInstOperands,
     /*   74686 */     // GIR_Coverage, 47304,
     /*   74686 */     GIR_EraseRootFromParent_Done,
     /*   74687 */   // Label 1199: @74687
     /*   74687 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74742), // Rule ID 47305 //
     /*   74692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74711 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74720 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74740 */     GIR_RootConstrainSelectedInstOperands,
     /*   74741 */     // GIR_Coverage, 47305,
     /*   74741 */     GIR_EraseRootFromParent_Done,
     /*   74742 */   // Label 1200: @74742
     /*   74742 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74797), // Rule ID 47064 //
     /*   74747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74766 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74775 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   74778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74795 */     GIR_RootConstrainSelectedInstOperands,
     /*   74796 */     // GIR_Coverage, 47064,
     /*   74796 */     GIR_EraseRootFromParent_Done,
     /*   74797 */   // Label 1201: @74797
     /*   74797 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74852), // Rule ID 47065 //
     /*   74802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74821 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74830 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   74833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74850 */     GIR_RootConstrainSelectedInstOperands,
     /*   74851 */     // GIR_Coverage, 47065,
     /*   74851 */     GIR_EraseRootFromParent_Done,
     /*   74852 */   // Label 1202: @74852
     /*   74852 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74907), // Rule ID 47184 //
     /*   74857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74876 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74885 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74905 */     GIR_RootConstrainSelectedInstOperands,
     /*   74906 */     // GIR_Coverage, 47184,
     /*   74906 */     GIR_EraseRootFromParent_Done,
     /*   74907 */   // Label 1203: @74907
     /*   74907 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74962), // Rule ID 47185 //
     /*   74912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74940 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74960 */     GIR_RootConstrainSelectedInstOperands,
     /*   74961 */     // GIR_Coverage, 47185,
     /*   74961 */     GIR_EraseRootFromParent_Done,
     /*   74962 */   // Label 1204: @74962
     /*   74962 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(75015), // Rule ID 46280 //
     /*   74967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74978 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   74978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   74995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75013 */     GIR_RootConstrainSelectedInstOperands,
     /*   75014 */     // GIR_Coverage, 46280,
     /*   75014 */     GIR_EraseRootFromParent_Done,
     /*   75015 */   // Label 1205: @75015
     /*   75015 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75068), // Rule ID 46281 //
     /*   75020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75031 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   75034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   75048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75066 */     GIR_RootConstrainSelectedInstOperands,
     /*   75067 */     // GIR_Coverage, 46281,
     /*   75067 */     GIR_EraseRootFromParent_Done,
     /*   75068 */   // Label 1206: @75068
     /*   75068 */   GIM_Reject,
     /*   75069 */ // Label 1190: @75069
     /*   75069 */ GIM_Reject,
     /*   75070 */ // Label 981: @75070
     /*   75070 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(76192),
     /*   75075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75085 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75174), // Rule ID 47264 //
     /*   75090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75105 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75124 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75133 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75172 */     GIR_RootConstrainSelectedInstOperands,
     /*   75173 */     // GIR_Coverage, 47264,
     /*   75173 */     GIR_EraseRootFromParent_Done,
     /*   75174 */   // Label 1208: @75174
     /*   75174 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75263), // Rule ID 47265 //
     /*   75179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75194 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75213 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75222 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75261 */     GIR_RootConstrainSelectedInstOperands,
     /*   75262 */     // GIR_Coverage, 47265,
     /*   75262 */     GIR_EraseRootFromParent_Done,
     /*   75263 */   // Label 1209: @75263
     /*   75263 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75352), // Rule ID 47024 //
     /*   75268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75283 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75302 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75311 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75350 */     GIR_RootConstrainSelectedInstOperands,
     /*   75351 */     // GIR_Coverage, 47024,
     /*   75351 */     GIR_EraseRootFromParent_Done,
     /*   75352 */   // Label 1210: @75352
     /*   75352 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75441), // Rule ID 47025 //
     /*   75357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75372 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75391 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75400 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75439 */     GIR_RootConstrainSelectedInstOperands,
     /*   75440 */     // GIR_Coverage, 47025,
     /*   75440 */     GIR_EraseRootFromParent_Done,
     /*   75441 */   // Label 1211: @75441
     /*   75441 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75530), // Rule ID 47144 //
     /*   75446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75461 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75480 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75489 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75528 */     GIR_RootConstrainSelectedInstOperands,
     /*   75529 */     // GIR_Coverage, 47144,
     /*   75529 */     GIR_EraseRootFromParent_Done,
     /*   75530 */   // Label 1212: @75530
     /*   75530 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75619), // Rule ID 47145 //
     /*   75535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75550 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75569 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75578 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75617 */     GIR_RootConstrainSelectedInstOperands,
     /*   75618 */     // GIR_Coverage, 47145,
     /*   75618 */     GIR_EraseRootFromParent_Done,
     /*   75619 */   // Label 1213: @75619
     /*   75619 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75687), // Rule ID 52022 //
     /*   75624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   75627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   75639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75661 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   75661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   75664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   75682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75685 */     GIR_RootConstrainSelectedInstOperands,
     /*   75686 */     // GIR_Coverage, 52022,
     /*   75686 */     GIR_EraseRootFromParent_Done,
     /*   75687 */   // Label 1214: @75687
     /*   75687 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(75755), // Rule ID 52023 //
     /*   75692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   75695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   75707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75715 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75729 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   75729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   75732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   75750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75753 */     GIR_RootConstrainSelectedInstOperands,
     /*   75754 */     // GIR_Coverage, 52023,
     /*   75754 */     GIR_EraseRootFromParent_Done,
     /*   75755 */   // Label 1215: @75755
     /*   75755 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(75810), // Rule ID 47324 //
     /*   75760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75788 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   75788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   75791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75808 */     GIR_RootConstrainSelectedInstOperands,
     /*   75809 */     // GIR_Coverage, 47324,
     /*   75809 */     GIR_EraseRootFromParent_Done,
     /*   75810 */   // Label 1216: @75810
     /*   75810 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(75865), // Rule ID 47325 //
     /*   75815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75843 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   75843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   75846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75863 */     GIR_RootConstrainSelectedInstOperands,
     /*   75864 */     // GIR_Coverage, 47325,
     /*   75864 */     GIR_EraseRootFromParent_Done,
     /*   75865 */   // Label 1217: @75865
     /*   75865 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(75920), // Rule ID 47084 //
     /*   75870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75889 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75898 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   75898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   75901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75918 */     GIR_RootConstrainSelectedInstOperands,
     /*   75919 */     // GIR_Coverage, 47084,
     /*   75919 */     GIR_EraseRootFromParent_Done,
     /*   75920 */   // Label 1218: @75920
     /*   75920 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(75975), // Rule ID 47085 //
     /*   75925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75953 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   75953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   75956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75973 */     GIR_RootConstrainSelectedInstOperands,
     /*   75974 */     // GIR_Coverage, 47085,
     /*   75974 */     GIR_EraseRootFromParent_Done,
     /*   75975 */   // Label 1219: @75975
     /*   75975 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76030), // Rule ID 47204 //
     /*   75980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75999 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76008 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   76008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76028 */     GIR_RootConstrainSelectedInstOperands,
     /*   76029 */     // GIR_Coverage, 47204,
     /*   76029 */     GIR_EraseRootFromParent_Done,
     /*   76030 */   // Label 1220: @76030
     /*   76030 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76085), // Rule ID 47205 //
     /*   76035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   76038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76054 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76063 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   76063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76083 */     GIR_RootConstrainSelectedInstOperands,
     /*   76084 */     // GIR_Coverage, 47205,
     /*   76084 */     GIR_EraseRootFromParent_Done,
     /*   76085 */   // Label 1221: @76085
     /*   76085 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76138), // Rule ID 46296 //
     /*   76090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   76093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76101 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   76101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76136 */     GIR_RootConstrainSelectedInstOperands,
     /*   76137 */     // GIR_Coverage, 46296,
     /*   76137 */     GIR_EraseRootFromParent_Done,
     /*   76138 */   // Label 1222: @76138
     /*   76138 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76191), // Rule ID 46297 //
     /*   76143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   76146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76154 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   76154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76189 */     GIR_RootConstrainSelectedInstOperands,
     /*   76190 */     // GIR_Coverage, 46297,
     /*   76190 */     GIR_EraseRootFromParent_Done,
     /*   76191 */   // Label 1223: @76191
     /*   76191 */   GIM_Reject,
     /*   76192 */ // Label 1207: @76192
     /*   76192 */ GIM_Reject,
     /*   76193 */ // Label 982: @76193
     /*   76193 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(76439),
     /*   76198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76212 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(76276), // Rule ID 51978 //
     /*   76217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76236 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76250 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   76250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   76253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76274 */     GIR_RootConstrainSelectedInstOperands,
     /*   76275 */     // GIR_Coverage, 51978,
     /*   76275 */     GIR_EraseRootFromParent_Done,
     /*   76276 */   // Label 1225: @76276
     /*   76276 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(76340), // Rule ID 51979 //
     /*   76281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76300 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76314 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   76314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   76317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76338 */     GIR_RootConstrainSelectedInstOperands,
     /*   76339 */     // GIR_Coverage, 51979,
     /*   76339 */     GIR_EraseRootFromParent_Done,
     /*   76340 */   // Label 1226: @76340
     /*   76340 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(76389), // Rule ID 46252 //
     /*   76345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76352 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   76355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   76369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76387 */     GIR_RootConstrainSelectedInstOperands,
     /*   76388 */     // GIR_Coverage, 46252,
     /*   76388 */     GIR_EraseRootFromParent_Done,
     /*   76389 */   // Label 1227: @76389
     /*   76389 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(76438), // Rule ID 46253 //
     /*   76394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76401 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   76404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   76418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76436 */     GIR_RootConstrainSelectedInstOperands,
     /*   76437 */     // GIR_Coverage, 46253,
     /*   76437 */     GIR_EraseRootFromParent_Done,
     /*   76438 */   // Label 1228: @76438
     /*   76438 */   GIM_Reject,
     /*   76439 */ // Label 1224: @76439
     /*   76439 */ GIM_Reject,
     /*   76440 */ // Label 983: @76440
     /*   76440 */ GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(77562),
     /*   76445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   76448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   76451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76455 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(76544), // Rule ID 47224 //
     /*   76460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76475 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76494 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76503 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76542 */     GIR_RootConstrainSelectedInstOperands,
     /*   76543 */     // GIR_Coverage, 47224,
     /*   76543 */     GIR_EraseRootFromParent_Done,
     /*   76544 */   // Label 1230: @76544
     /*   76544 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(76633), // Rule ID 47225 //
     /*   76549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76564 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76583 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76592 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76631 */     GIR_RootConstrainSelectedInstOperands,
     /*   76632 */     // GIR_Coverage, 47225,
     /*   76632 */     GIR_EraseRootFromParent_Done,
     /*   76633 */   // Label 1231: @76633
     /*   76633 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(76722), // Rule ID 46984 //
     /*   76638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76653 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76672 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76681 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   76698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76720 */     GIR_RootConstrainSelectedInstOperands,
     /*   76721 */     // GIR_Coverage, 46984,
     /*   76721 */     GIR_EraseRootFromParent_Done,
     /*   76722 */   // Label 1232: @76722
     /*   76722 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(76811), // Rule ID 46985 //
     /*   76727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76742 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76761 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76770 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   76787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76809 */     GIR_RootConstrainSelectedInstOperands,
     /*   76810 */     // GIR_Coverage, 46985,
     /*   76810 */     GIR_EraseRootFromParent_Done,
     /*   76811 */   // Label 1233: @76811
     /*   76811 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(76900), // Rule ID 47104 //
     /*   76816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76850 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76859 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76898 */     GIR_RootConstrainSelectedInstOperands,
     /*   76899 */     // GIR_Coverage, 47104,
     /*   76899 */     GIR_EraseRootFromParent_Done,
     /*   76900 */   // Label 1234: @76900
     /*   76900 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(76989), // Rule ID 47105 //
     /*   76905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76939 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76948 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76987 */     GIR_RootConstrainSelectedInstOperands,
     /*   76988 */     // GIR_Coverage, 47105,
     /*   76988 */     GIR_EraseRootFromParent_Done,
     /*   76989 */   // Label 1235: @76989
     /*   76989 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(77057), // Rule ID 51994 //
     /*   76994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   77009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   77017 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77031 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   77031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   77034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   77040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77055 */     GIR_RootConstrainSelectedInstOperands,
     /*   77056 */     // GIR_Coverage, 51994,
     /*   77056 */     GIR_EraseRootFromParent_Done,
     /*   77057 */   // Label 1236: @77057
     /*   77057 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(77125), // Rule ID 51995 //
     /*   77062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   77077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   77085 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77099 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   77099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   77102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   77108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77123 */     GIR_RootConstrainSelectedInstOperands,
     /*   77124 */     // GIR_Coverage, 51995,
     /*   77124 */     GIR_EraseRootFromParent_Done,
     /*   77125 */   // Label 1237: @77125
     /*   77125 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(77180), // Rule ID 47284 //
     /*   77130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77158 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77178 */     GIR_RootConstrainSelectedInstOperands,
     /*   77179 */     // GIR_Coverage, 47284,
     /*   77179 */     GIR_EraseRootFromParent_Done,
     /*   77180 */   // Label 1238: @77180
     /*   77180 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(77235), // Rule ID 47285 //
     /*   77185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77204 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77213 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77233 */     GIR_RootConstrainSelectedInstOperands,
     /*   77234 */     // GIR_Coverage, 47285,
     /*   77234 */     GIR_EraseRootFromParent_Done,
     /*   77235 */   // Label 1239: @77235
     /*   77235 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(77290), // Rule ID 47044 //
     /*   77240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77259 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77268 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   77271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77288 */     GIR_RootConstrainSelectedInstOperands,
     /*   77289 */     // GIR_Coverage, 47044,
     /*   77289 */     GIR_EraseRootFromParent_Done,
     /*   77290 */   // Label 1240: @77290
     /*   77290 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(77345), // Rule ID 47045 //
     /*   77295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77314 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77323 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   77326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77343 */     GIR_RootConstrainSelectedInstOperands,
     /*   77344 */     // GIR_Coverage, 47045,
     /*   77344 */     GIR_EraseRootFromParent_Done,
     /*   77345 */   // Label 1241: @77345
     /*   77345 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(77400), // Rule ID 47164 //
     /*   77350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77369 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77378 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77398 */     GIR_RootConstrainSelectedInstOperands,
     /*   77399 */     // GIR_Coverage, 47164,
     /*   77399 */     GIR_EraseRootFromParent_Done,
     /*   77400 */   // Label 1242: @77400
     /*   77400 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(77455), // Rule ID 47165 //
     /*   77405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77433 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77453 */     GIR_RootConstrainSelectedInstOperands,
     /*   77454 */     // GIR_Coverage, 47165,
     /*   77454 */     GIR_EraseRootFromParent_Done,
     /*   77455 */   // Label 1243: @77455
     /*   77455 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(77508), // Rule ID 46268 //
     /*   77460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77471 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   77488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   77497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77506 */     GIR_RootConstrainSelectedInstOperands,
     /*   77507 */     // GIR_Coverage, 46268,
     /*   77507 */     GIR_EraseRootFromParent_Done,
     /*   77508 */   // Label 1244: @77508
     /*   77508 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(77561), // Rule ID 46269 //
     /*   77513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77524 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   77541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   77550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77559 */     GIR_RootConstrainSelectedInstOperands,
     /*   77560 */     // GIR_Coverage, 46269,
     /*   77560 */     GIR_EraseRootFromParent_Done,
     /*   77561 */   // Label 1245: @77561
     /*   77561 */   GIM_Reject,
     /*   77562 */ // Label 1229: @77562
     /*   77562 */ GIM_Reject,
     /*   77563 */ // Label 984: @77563
     /*   77563 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(78685),
     /*   77568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   77571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   77574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   77578 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(77667), // Rule ID 47248 //
     /*   77583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77598 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77617 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77626 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   77643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77665 */     GIR_RootConstrainSelectedInstOperands,
     /*   77666 */     // GIR_Coverage, 47248,
     /*   77666 */     GIR_EraseRootFromParent_Done,
     /*   77667 */   // Label 1247: @77667
     /*   77667 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(77756), // Rule ID 47249 //
     /*   77672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77687 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77706 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77715 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   77732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77754 */     GIR_RootConstrainSelectedInstOperands,
     /*   77755 */     // GIR_Coverage, 47249,
     /*   77755 */     GIR_EraseRootFromParent_Done,
     /*   77756 */   // Label 1248: @77756
     /*   77756 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(77845), // Rule ID 47008 //
     /*   77761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77795 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77804 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   77821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77843 */     GIR_RootConstrainSelectedInstOperands,
     /*   77844 */     // GIR_Coverage, 47008,
     /*   77844 */     GIR_EraseRootFromParent_Done,
     /*   77845 */   // Label 1249: @77845
     /*   77845 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(77934), // Rule ID 47009 //
     /*   77850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77865 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77884 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77893 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   77910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77932 */     GIR_RootConstrainSelectedInstOperands,
     /*   77933 */     // GIR_Coverage, 47009,
     /*   77933 */     GIR_EraseRootFromParent_Done,
     /*   77934 */   // Label 1250: @77934
     /*   77934 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(78023), // Rule ID 47128 //
     /*   77939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77954 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77973 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77982 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   77999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78021 */     GIR_RootConstrainSelectedInstOperands,
     /*   78022 */     // GIR_Coverage, 47128,
     /*   78022 */     GIR_EraseRootFromParent_Done,
     /*   78023 */   // Label 1251: @78023
     /*   78023 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(78112), // Rule ID 47129 //
     /*   78028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78043 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78062 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78071 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   78088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78110 */     GIR_RootConstrainSelectedInstOperands,
     /*   78111 */     // GIR_Coverage, 47129,
     /*   78111 */     GIR_EraseRootFromParent_Done,
     /*   78112 */   // Label 1252: @78112
     /*   78112 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(78180), // Rule ID 52010 //
     /*   78117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78140 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78154 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   78154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   78157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78178 */     GIR_RootConstrainSelectedInstOperands,
     /*   78179 */     // GIR_Coverage, 52010,
     /*   78179 */     GIR_EraseRootFromParent_Done,
     /*   78180 */   // Label 1253: @78180
     /*   78180 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(78248), // Rule ID 52011 //
     /*   78185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78222 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   78222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   78225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78246 */     GIR_RootConstrainSelectedInstOperands,
     /*   78247 */     // GIR_Coverage, 52011,
     /*   78247 */     GIR_EraseRootFromParent_Done,
     /*   78248 */   // Label 1254: @78248
     /*   78248 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(78303), // Rule ID 47308 //
     /*   78253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78281 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78301 */     GIR_RootConstrainSelectedInstOperands,
     /*   78302 */     // GIR_Coverage, 47308,
     /*   78302 */     GIR_EraseRootFromParent_Done,
     /*   78303 */   // Label 1255: @78303
     /*   78303 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(78358), // Rule ID 47309 //
     /*   78308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78327 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78336 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78356 */     GIR_RootConstrainSelectedInstOperands,
     /*   78357 */     // GIR_Coverage, 47309,
     /*   78357 */     GIR_EraseRootFromParent_Done,
     /*   78358 */   // Label 1256: @78358
     /*   78358 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(78413), // Rule ID 47068 //
     /*   78363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78382 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78391 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   78394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78411 */     GIR_RootConstrainSelectedInstOperands,
     /*   78412 */     // GIR_Coverage, 47068,
     /*   78412 */     GIR_EraseRootFromParent_Done,
     /*   78413 */   // Label 1257: @78413
     /*   78413 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(78468), // Rule ID 47069 //
     /*   78418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78446 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   78449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78466 */     GIR_RootConstrainSelectedInstOperands,
     /*   78467 */     // GIR_Coverage, 47069,
     /*   78467 */     GIR_EraseRootFromParent_Done,
     /*   78468 */   // Label 1258: @78468
     /*   78468 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(78523), // Rule ID 47188 //
     /*   78473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78501 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78521 */     GIR_RootConstrainSelectedInstOperands,
     /*   78522 */     // GIR_Coverage, 47188,
     /*   78522 */     GIR_EraseRootFromParent_Done,
     /*   78523 */   // Label 1259: @78523
     /*   78523 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(78578), // Rule ID 47189 //
     /*   78528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78547 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78556 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78576 */     GIR_RootConstrainSelectedInstOperands,
     /*   78577 */     // GIR_Coverage, 47189,
     /*   78577 */     GIR_EraseRootFromParent_Done,
     /*   78578 */   // Label 1260: @78578
     /*   78578 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(78631), // Rule ID 46284 //
     /*   78583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78594 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   78594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   78611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78629 */     GIR_RootConstrainSelectedInstOperands,
     /*   78630 */     // GIR_Coverage, 46284,
     /*   78630 */     GIR_EraseRootFromParent_Done,
     /*   78631 */   // Label 1261: @78631
     /*   78631 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(78684), // Rule ID 46285 //
     /*   78636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78647 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   78647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   78664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78682 */     GIR_RootConstrainSelectedInstOperands,
     /*   78683 */     // GIR_Coverage, 46285,
     /*   78683 */     GIR_EraseRootFromParent_Done,
     /*   78684 */   // Label 1262: @78684
     /*   78684 */   GIM_Reject,
     /*   78685 */ // Label 1246: @78685
     /*   78685 */ GIM_Reject,
     /*   78686 */ // Label 985: @78686
     /*   78686 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(78932),
     /*   78691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   78697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78705 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(78769), // Rule ID 51982 //
     /*   78710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   78729 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78743 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   78743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   78746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78767 */     GIR_RootConstrainSelectedInstOperands,
     /*   78768 */     // GIR_Coverage, 51982,
     /*   78768 */     GIR_EraseRootFromParent_Done,
     /*   78769 */   // Label 1264: @78769
     /*   78769 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(78833), // Rule ID 51983 //
     /*   78774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   78793 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78807 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   78807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   78810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78831 */     GIR_RootConstrainSelectedInstOperands,
     /*   78832 */     // GIR_Coverage, 51983,
     /*   78832 */     GIR_EraseRootFromParent_Done,
     /*   78833 */   // Label 1265: @78833
     /*   78833 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(78882), // Rule ID 46256 //
     /*   78838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78845 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   78845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   78848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   78862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78880 */     GIR_RootConstrainSelectedInstOperands,
     /*   78881 */     // GIR_Coverage, 46256,
     /*   78881 */     GIR_EraseRootFromParent_Done,
     /*   78882 */   // Label 1266: @78882
     /*   78882 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(78931), // Rule ID 46257 //
     /*   78887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78894 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   78894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   78897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   78911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78929 */     GIR_RootConstrainSelectedInstOperands,
     /*   78930 */     // GIR_Coverage, 46257,
     /*   78930 */     GIR_EraseRootFromParent_Done,
     /*   78931 */   // Label 1267: @78931
     /*   78931 */   GIM_Reject,
     /*   78932 */ // Label 1263: @78932
     /*   78932 */ GIM_Reject,
     /*   78933 */ // Label 986: @78933
     /*   78933 */ GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(80055),
     /*   78938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   78941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   78944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78948 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(79037), // Rule ID 47228 //
     /*   78953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78996 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   78996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   78999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79035 */     GIR_RootConstrainSelectedInstOperands,
     /*   79036 */     // GIR_Coverage, 47228,
     /*   79036 */     GIR_EraseRootFromParent_Done,
     /*   79037 */   // Label 1269: @79037
     /*   79037 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(79126), // Rule ID 47229 //
     /*   79042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79057 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79076 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79085 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79124 */     GIR_RootConstrainSelectedInstOperands,
     /*   79125 */     // GIR_Coverage, 47229,
     /*   79125 */     GIR_EraseRootFromParent_Done,
     /*   79126 */   // Label 1270: @79126
     /*   79126 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(79215), // Rule ID 46988 //
     /*   79131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79146 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79165 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79174 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   79191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79213 */     GIR_RootConstrainSelectedInstOperands,
     /*   79214 */     // GIR_Coverage, 46988,
     /*   79214 */     GIR_EraseRootFromParent_Done,
     /*   79215 */   // Label 1271: @79215
     /*   79215 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(79304), // Rule ID 46989 //
     /*   79220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79235 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79254 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79263 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   79280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79302 */     GIR_RootConstrainSelectedInstOperands,
     /*   79303 */     // GIR_Coverage, 46989,
     /*   79303 */     GIR_EraseRootFromParent_Done,
     /*   79304 */   // Label 1272: @79304
     /*   79304 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(79393), // Rule ID 47108 //
     /*   79309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79324 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79343 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79352 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79391 */     GIR_RootConstrainSelectedInstOperands,
     /*   79392 */     // GIR_Coverage, 47108,
     /*   79392 */     GIR_EraseRootFromParent_Done,
     /*   79393 */   // Label 1273: @79393
     /*   79393 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(79482), // Rule ID 47109 //
     /*   79398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79413 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79432 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79441 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79480 */     GIR_RootConstrainSelectedInstOperands,
     /*   79481 */     // GIR_Coverage, 47109,
     /*   79481 */     GIR_EraseRootFromParent_Done,
     /*   79482 */   // Label 1274: @79482
     /*   79482 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(79550), // Rule ID 51998 //
     /*   79487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   79506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   79510 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79524 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   79524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   79527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   79533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79548 */     GIR_RootConstrainSelectedInstOperands,
     /*   79549 */     // GIR_Coverage, 51998,
     /*   79549 */     GIR_EraseRootFromParent_Done,
     /*   79550 */   // Label 1275: @79550
     /*   79550 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(79618), // Rule ID 51999 //
     /*   79555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   79574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   79578 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79592 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   79592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   79595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   79601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79616 */     GIR_RootConstrainSelectedInstOperands,
     /*   79617 */     // GIR_Coverage, 51999,
     /*   79617 */     GIR_EraseRootFromParent_Done,
     /*   79618 */   // Label 1276: @79618
     /*   79618 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(79673), // Rule ID 47288 //
     /*   79623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79642 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79651 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79671 */     GIR_RootConstrainSelectedInstOperands,
     /*   79672 */     // GIR_Coverage, 47288,
     /*   79672 */     GIR_EraseRootFromParent_Done,
     /*   79673 */   // Label 1277: @79673
     /*   79673 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(79728), // Rule ID 47289 //
     /*   79678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79706 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79726 */     GIR_RootConstrainSelectedInstOperands,
     /*   79727 */     // GIR_Coverage, 47289,
     /*   79727 */     GIR_EraseRootFromParent_Done,
     /*   79728 */   // Label 1278: @79728
     /*   79728 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(79783), // Rule ID 47048 //
     /*   79733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79761 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   79764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79781 */     GIR_RootConstrainSelectedInstOperands,
     /*   79782 */     // GIR_Coverage, 47048,
     /*   79782 */     GIR_EraseRootFromParent_Done,
     /*   79783 */   // Label 1279: @79783
     /*   79783 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(79838), // Rule ID 47049 //
     /*   79788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79807 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79816 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   79819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79836 */     GIR_RootConstrainSelectedInstOperands,
     /*   79837 */     // GIR_Coverage, 47049,
     /*   79837 */     GIR_EraseRootFromParent_Done,
     /*   79838 */   // Label 1280: @79838
     /*   79838 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(79893), // Rule ID 47168 //
     /*   79843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79862 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79871 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79891 */     GIR_RootConstrainSelectedInstOperands,
     /*   79892 */     // GIR_Coverage, 47168,
     /*   79892 */     GIR_EraseRootFromParent_Done,
     /*   79893 */   // Label 1281: @79893
     /*   79893 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(79948), // Rule ID 47169 //
     /*   79898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79917 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79926 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79946 */     GIR_RootConstrainSelectedInstOperands,
     /*   79947 */     // GIR_Coverage, 47169,
     /*   79947 */     GIR_EraseRootFromParent_Done,
     /*   79948 */   // Label 1282: @79948
     /*   79948 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(80001), // Rule ID 46272 //
     /*   79953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79964 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   79964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   79981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   79990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79999 */     GIR_RootConstrainSelectedInstOperands,
     /*   80000 */     // GIR_Coverage, 46272,
     /*   80000 */     GIR_EraseRootFromParent_Done,
     /*   80001 */   // Label 1283: @80001
     /*   80001 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(80054), // Rule ID 46273 //
     /*   80006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80017 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   80017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   80020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80052 */     GIR_RootConstrainSelectedInstOperands,
     /*   80053 */     // GIR_Coverage, 46273,
     /*   80053 */     GIR_EraseRootFromParent_Done,
     /*   80054 */   // Label 1284: @80054
     /*   80054 */   GIM_Reject,
     /*   80055 */ // Label 1268: @80055
     /*   80055 */ GIM_Reject,
     /*   80056 */ // Label 987: @80056
     /*   80056 */ GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(80302),
     /*   80061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80075 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(80139), // Rule ID 51986 //
     /*   80080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80099 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80113 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   80113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80137 */     GIR_RootConstrainSelectedInstOperands,
     /*   80138 */     // GIR_Coverage, 51986,
     /*   80138 */     GIR_EraseRootFromParent_Done,
     /*   80139 */   // Label 1286: @80139
     /*   80139 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(80203), // Rule ID 51987 //
     /*   80144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80177 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   80177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80201 */     GIR_RootConstrainSelectedInstOperands,
     /*   80202 */     // GIR_Coverage, 51987,
     /*   80202 */     GIR_EraseRootFromParent_Done,
     /*   80203 */   // Label 1287: @80203
     /*   80203 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(80252), // Rule ID 46260 //
     /*   80208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80215 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   80218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80250 */     GIR_RootConstrainSelectedInstOperands,
     /*   80251 */     // GIR_Coverage, 46260,
     /*   80251 */     GIR_EraseRootFromParent_Done,
     /*   80252 */   // Label 1288: @80252
     /*   80252 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(80301), // Rule ID 46261 //
     /*   80257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80264 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   80267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80299 */     GIR_RootConstrainSelectedInstOperands,
     /*   80300 */     // GIR_Coverage, 46261,
     /*   80300 */     GIR_EraseRootFromParent_Done,
     /*   80301 */   // Label 1289: @80301
     /*   80301 */   GIM_Reject,
     /*   80302 */ // Label 1285: @80302
     /*   80302 */ GIM_Reject,
     /*   80303 */ // Label 988: @80303
     /*   80303 */ GIM_Reject,
     /*   80304 */ // Label 2: @80304
     /*   80304 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1314*/ GIMT_Encode4(107357),
     /*   80315 */ /*GILLT_s32*//*Label 1290*/ GIMT_Encode4(80439),
     /*   80319 */ /*GILLT_s64*//*Label 1291*/ GIMT_Encode4(80473), GIMT_Encode4(0),
     /*   80327 */ /*GILLT_nxv1s8*//*Label 1292*/ GIMT_Encode4(80677),
     /*   80331 */ /*GILLT_nxv1s16*//*Label 1293*/ GIMT_Encode4(80792),
     /*   80335 */ /*GILLT_nxv1s32*//*Label 1294*/ GIMT_Encode4(82517),
     /*   80339 */ /*GILLT_nxv1s64*//*Label 1295*/ GIMT_Encode4(84242), GIMT_Encode4(0),
     /*   80347 */ /*GILLT_nxv2s8*//*Label 1296*/ GIMT_Encode4(85967),
     /*   80351 */ /*GILLT_nxv2s16*//*Label 1297*/ GIMT_Encode4(86082),
     /*   80355 */ /*GILLT_nxv2s32*//*Label 1298*/ GIMT_Encode4(87807),
     /*   80359 */ /*GILLT_nxv2s64*//*Label 1299*/ GIMT_Encode4(89532), GIMT_Encode4(0),
     /*   80367 */ /*GILLT_nxv4s8*//*Label 1300*/ GIMT_Encode4(91257),
     /*   80371 */ /*GILLT_nxv4s16*//*Label 1301*/ GIMT_Encode4(91372),
     /*   80375 */ /*GILLT_nxv4s32*//*Label 1302*/ GIMT_Encode4(93097),
     /*   80379 */ /*GILLT_nxv4s64*//*Label 1303*/ GIMT_Encode4(94822), GIMT_Encode4(0),
     /*   80387 */ /*GILLT_nxv8s8*//*Label 1304*/ GIMT_Encode4(96547),
     /*   80391 */ /*GILLT_nxv8s16*//*Label 1305*/ GIMT_Encode4(96662),
     /*   80395 */ /*GILLT_nxv8s32*//*Label 1306*/ GIMT_Encode4(98387),
     /*   80399 */ /*GILLT_nxv8s64*//*Label 1307*/ GIMT_Encode4(100112), GIMT_Encode4(0),
     /*   80407 */ /*GILLT_nxv16s8*//*Label 1308*/ GIMT_Encode4(101837),
     /*   80411 */ /*GILLT_nxv16s16*//*Label 1309*/ GIMT_Encode4(101952),
     /*   80415 */ /*GILLT_nxv16s32*//*Label 1310*/ GIMT_Encode4(103677), GIMT_Encode4(0),
     /*   80423 */ /*GILLT_nxv32s8*//*Label 1311*/ GIMT_Encode4(105402),
     /*   80427 */ /*GILLT_nxv32s16*//*Label 1312*/ GIMT_Encode4(105517), GIMT_Encode4(0),
     /*   80435 */ /*GILLT_nxv64s8*//*Label 1313*/ GIMT_Encode4(107242),
     /*   80439 */ // Label 1290: @80439
     /*   80439 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(80472), // Rule ID 292 //
     /*   80444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /*   80447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   80450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   80453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80465 */   // (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MUL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   80465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   80470 */   GIR_RootConstrainSelectedInstOperands,
     /*   80471 */   // GIR_Coverage, 292,
     /*   80471 */   GIR_Done,
     /*   80472 */ // Label 1315: @80472
     /*   80472 */ GIM_Reject,
     /*   80473 */ // Label 1291: @80473
     /*   80473 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(80676),
     /*   80478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   80481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   80484 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(80617), // Rule ID 314 //
     /*   80489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0),
     /*   80492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   80504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   80508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   80512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80517 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*   80528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   80536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   80540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   80544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80549 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*   80560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80562 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 4294967295:{ *:[i64] }))  =>  (MULHU:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))
     /*   80562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   80565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   80569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   80578 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*   80581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   80583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   80586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   80590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80599 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*   80602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /*   80607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   80615 */     GIR_RootConstrainSelectedInstOperands,
     /*   80616 */     // GIR_Coverage, 314,
     /*   80616 */     GIR_EraseRootFromParent_Done,
     /*   80617 */   // Label 1317: @80617
     /*   80617 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(80648), // Rule ID 307 //
     /*   80622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_HwMode0),
     /*   80625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80637 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10058),
     /*   80641 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10058>>  =>  (MULW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   80641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULW),
     /*   80646 */     GIR_RootConstrainSelectedInstOperands,
     /*   80647 */     // GIR_Coverage, 307,
     /*   80647 */     GIR_Done,
     /*   80648 */   // Label 1318: @80648
     /*   80648 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(80675), // Rule ID 291 //
     /*   80653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /*   80656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80668 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MUL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   80668 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   80673 */     GIR_RootConstrainSelectedInstOperands,
     /*   80674 */     // GIR_Coverage, 291,
     /*   80674 */     GIR_Done,
     /*   80675 */   // Label 1319: @80675
     /*   80675 */   GIM_Reject,
     /*   80676 */ // Label 1316: @80676
     /*   80676 */ GIM_Reject,
     /*   80677 */ // Label 1292: @80677
     /*   80677 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(80791),
     /*   80682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   80688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80700 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(80745), // Rule ID 50848 //
     /*   80705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80708 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   80711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   80725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80743 */     GIR_RootConstrainSelectedInstOperands,
     /*   80744 */     // GIR_Coverage, 50848,
     /*   80744 */     GIR_EraseRootFromParent_Done,
     /*   80745 */   // Label 1321: @80745
     /*   80745 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(80790), // Rule ID 50849 //
     /*   80750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80753 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   80756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   80770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80788 */     GIR_RootConstrainSelectedInstOperands,
     /*   80789 */     // GIR_Coverage, 50849,
     /*   80789 */     GIR_EraseRootFromParent_Done,
     /*   80790 */   // Label 1322: @80790
     /*   80790 */   GIM_Reject,
     /*   80791 */ // Label 1320: @80791
     /*   80791 */ GIM_Reject,
     /*   80792 */ // Label 1293: @80792
     /*   80792 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(82516),
     /*   80797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   80800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   80803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80807 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(80896), // Rule ID 51614 //
     /*   80812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80827 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80855 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   80858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   80872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80894 */     GIR_RootConstrainSelectedInstOperands,
     /*   80895 */     // GIR_Coverage, 51614,
     /*   80895 */     GIR_EraseRootFromParent_Done,
     /*   80896 */   // Label 1324: @80896
     /*   80896 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(80985), // Rule ID 51615 //
     /*   80901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80916 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80935 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80944 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   80947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   80961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80983 */     GIR_RootConstrainSelectedInstOperands,
     /*   80984 */     // GIR_Coverage, 51615,
     /*   80984 */     GIR_EraseRootFromParent_Done,
     /*   80985 */   // Label 1325: @80985
     /*   80985 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(81074), // Rule ID 70500 //
     /*   80990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81005 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81024 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81033 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81072 */     GIR_RootConstrainSelectedInstOperands,
     /*   81073 */     // GIR_Coverage, 70500,
     /*   81073 */     GIR_EraseRootFromParent_Done,
     /*   81074 */   // Label 1326: @81074
     /*   81074 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(81163), // Rule ID 70501 //
     /*   81079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81094 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81113 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81122 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81161 */     GIR_RootConstrainSelectedInstOperands,
     /*   81162 */     // GIR_Coverage, 70501,
     /*   81162 */     GIR_EraseRootFromParent_Done,
     /*   81163 */   // Label 1327: @81163
     /*   81163 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(81252), // Rule ID 70380 //
     /*   81168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81183 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81202 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81211 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81250 */     GIR_RootConstrainSelectedInstOperands,
     /*   81251 */     // GIR_Coverage, 70380,
     /*   81251 */     GIR_EraseRootFromParent_Done,
     /*   81252 */   // Label 1328: @81252
     /*   81252 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(81341), // Rule ID 70381 //
     /*   81257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81291 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81300 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81339 */     GIR_RootConstrainSelectedInstOperands,
     /*   81340 */     // GIR_Coverage, 70381,
     /*   81340 */     GIR_EraseRootFromParent_Done,
     /*   81341 */   // Label 1329: @81341
     /*   81341 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(81430), // Rule ID 51794 //
     /*   81346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81380 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81389 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81428 */     GIR_RootConstrainSelectedInstOperands,
     /*   81429 */     // GIR_Coverage, 51794,
     /*   81429 */     GIR_EraseRootFromParent_Done,
     /*   81430 */   // Label 1330: @81430
     /*   81430 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(81519), // Rule ID 51795 //
     /*   81435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81450 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81469 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81478 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81517 */     GIR_RootConstrainSelectedInstOperands,
     /*   81518 */     // GIR_Coverage, 51795,
     /*   81518 */     GIR_EraseRootFromParent_Done,
     /*   81519 */   // Label 1331: @81519
     /*   81519 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(81608), // Rule ID 51494 //
     /*   81524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81539 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81558 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81567 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   81584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81606 */     GIR_RootConstrainSelectedInstOperands,
     /*   81607 */     // GIR_Coverage, 51494,
     /*   81607 */     GIR_EraseRootFromParent_Done,
     /*   81608 */   // Label 1332: @81608
     /*   81608 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(81697), // Rule ID 51495 //
     /*   81613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81628 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81647 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81656 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   81673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81695 */     GIR_RootConstrainSelectedInstOperands,
     /*   81696 */     // GIR_Coverage, 51495,
     /*   81696 */     GIR_EraseRootFromParent_Done,
     /*   81697 */   // Label 1333: @81697
     /*   81697 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(81786), // Rule ID 51734 //
     /*   81702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81717 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81736 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81745 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81784 */     GIR_RootConstrainSelectedInstOperands,
     /*   81785 */     // GIR_Coverage, 51734,
     /*   81785 */     GIR_EraseRootFromParent_Done,
     /*   81786 */   // Label 1334: @81786
     /*   81786 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(81875), // Rule ID 51735 //
     /*   81791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81806 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81825 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81834 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81873 */     GIR_RootConstrainSelectedInstOperands,
     /*   81874 */     // GIR_Coverage, 51735,
     /*   81874 */     GIR_EraseRootFromParent_Done,
     /*   81875 */   // Label 1335: @81875
     /*   81875 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(81964), // Rule ID 51674 //
     /*   81880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81895 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81914 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81923 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81962 */     GIR_RootConstrainSelectedInstOperands,
     /*   81963 */     // GIR_Coverage, 51674,
     /*   81963 */     GIR_EraseRootFromParent_Done,
     /*   81964 */   // Label 1336: @81964
     /*   81964 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(82053), // Rule ID 51675 //
     /*   81969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81984 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82012 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82051 */     GIR_RootConstrainSelectedInstOperands,
     /*   82052 */     // GIR_Coverage, 51675,
     /*   82052 */     GIR_EraseRootFromParent_Done,
     /*   82053 */   // Label 1337: @82053
     /*   82053 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(82142), // Rule ID 70440 //
     /*   82058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82073 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82092 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82101 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82140 */     GIR_RootConstrainSelectedInstOperands,
     /*   82141 */     // GIR_Coverage, 70440,
     /*   82141 */     GIR_EraseRootFromParent_Done,
     /*   82142 */   // Label 1338: @82142
     /*   82142 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(82231), // Rule ID 70441 //
     /*   82147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82162 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82181 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82190 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82229 */     GIR_RootConstrainSelectedInstOperands,
     /*   82230 */     // GIR_Coverage, 70441,
     /*   82230 */     GIR_EraseRootFromParent_Done,
     /*   82231 */   // Label 1339: @82231
     /*   82231 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(82320), // Rule ID 51554 //
     /*   82236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82270 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82279 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82318 */     GIR_RootConstrainSelectedInstOperands,
     /*   82319 */     // GIR_Coverage, 51554,
     /*   82319 */     GIR_EraseRootFromParent_Done,
     /*   82320 */   // Label 1340: @82320
     /*   82320 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(82409), // Rule ID 51555 //
     /*   82325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82340 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82359 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82368 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82407 */     GIR_RootConstrainSelectedInstOperands,
     /*   82408 */     // GIR_Coverage, 51555,
     /*   82408 */     GIR_EraseRootFromParent_Done,
     /*   82409 */   // Label 1341: @82409
     /*   82409 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(82462), // Rule ID 50860 //
     /*   82414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82425 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   82442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   82449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   82451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82460 */     GIR_RootConstrainSelectedInstOperands,
     /*   82461 */     // GIR_Coverage, 50860,
     /*   82461 */     GIR_EraseRootFromParent_Done,
     /*   82462 */   // Label 1342: @82462
     /*   82462 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(82515), // Rule ID 50861 //
     /*   82467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82478 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   82495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   82502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   82504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82513 */     GIR_RootConstrainSelectedInstOperands,
     /*   82514 */     // GIR_Coverage, 50861,
     /*   82514 */     GIR_EraseRootFromParent_Done,
     /*   82515 */   // Label 1343: @82515
     /*   82515 */   GIM_Reject,
     /*   82516 */ // Label 1323: @82516
     /*   82516 */ GIM_Reject,
     /*   82517 */ // Label 1294: @82517
     /*   82517 */ GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(84241),
     /*   82522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   82525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   82528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82532 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(82621), // Rule ID 51638 //
     /*   82537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82571 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82580 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82619 */     GIR_RootConstrainSelectedInstOperands,
     /*   82620 */     // GIR_Coverage, 51638,
     /*   82620 */     GIR_EraseRootFromParent_Done,
     /*   82621 */   // Label 1345: @82621
     /*   82621 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(82710), // Rule ID 51639 //
     /*   82626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82641 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82660 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82669 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82708 */     GIR_RootConstrainSelectedInstOperands,
     /*   82709 */     // GIR_Coverage, 51639,
     /*   82709 */     GIR_EraseRootFromParent_Done,
     /*   82710 */   // Label 1346: @82710
     /*   82710 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(82799), // Rule ID 70524 //
     /*   82715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82749 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82758 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   82775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82797 */     GIR_RootConstrainSelectedInstOperands,
     /*   82798 */     // GIR_Coverage, 70524,
     /*   82798 */     GIR_EraseRootFromParent_Done,
     /*   82799 */   // Label 1347: @82799
     /*   82799 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(82888), // Rule ID 70525 //
     /*   82804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82819 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82838 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82847 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   82864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82886 */     GIR_RootConstrainSelectedInstOperands,
     /*   82887 */     // GIR_Coverage, 70525,
     /*   82887 */     GIR_EraseRootFromParent_Done,
     /*   82888 */   // Label 1348: @82888
     /*   82888 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(82977), // Rule ID 70404 //
     /*   82893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82927 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82936 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82975 */     GIR_RootConstrainSelectedInstOperands,
     /*   82976 */     // GIR_Coverage, 70404,
     /*   82976 */     GIR_EraseRootFromParent_Done,
     /*   82977 */   // Label 1349: @82977
     /*   82977 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(83066), // Rule ID 70405 //
     /*   82982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82997 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83016 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83025 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83064 */     GIR_RootConstrainSelectedInstOperands,
     /*   83065 */     // GIR_Coverage, 70405,
     /*   83065 */     GIR_EraseRootFromParent_Done,
     /*   83066 */   // Label 1350: @83066
     /*   83066 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(83155), // Rule ID 51818 //
     /*   83071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83105 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83114 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83153 */     GIR_RootConstrainSelectedInstOperands,
     /*   83154 */     // GIR_Coverage, 51818,
     /*   83154 */     GIR_EraseRootFromParent_Done,
     /*   83155 */   // Label 1351: @83155
     /*   83155 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(83244), // Rule ID 51819 //
     /*   83160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83194 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83203 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83242 */     GIR_RootConstrainSelectedInstOperands,
     /*   83243 */     // GIR_Coverage, 51819,
     /*   83243 */     GIR_EraseRootFromParent_Done,
     /*   83244 */   // Label 1352: @83244
     /*   83244 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(83333), // Rule ID 51518 //
     /*   83249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83264 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83283 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83292 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   83309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83331 */     GIR_RootConstrainSelectedInstOperands,
     /*   83332 */     // GIR_Coverage, 51518,
     /*   83332 */     GIR_EraseRootFromParent_Done,
     /*   83333 */   // Label 1353: @83333
     /*   83333 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(83422), // Rule ID 51519 //
     /*   83338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83353 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83372 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83381 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   83398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83420 */     GIR_RootConstrainSelectedInstOperands,
     /*   83421 */     // GIR_Coverage, 51519,
     /*   83421 */     GIR_EraseRootFromParent_Done,
     /*   83422 */   // Label 1354: @83422
     /*   83422 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(83511), // Rule ID 51758 //
     /*   83427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83442 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83461 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83470 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83509 */     GIR_RootConstrainSelectedInstOperands,
     /*   83510 */     // GIR_Coverage, 51758,
     /*   83510 */     GIR_EraseRootFromParent_Done,
     /*   83511 */   // Label 1355: @83511
     /*   83511 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(83600), // Rule ID 51759 //
     /*   83516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83559 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83598 */     GIR_RootConstrainSelectedInstOperands,
     /*   83599 */     // GIR_Coverage, 51759,
     /*   83599 */     GIR_EraseRootFromParent_Done,
     /*   83600 */   // Label 1356: @83600
     /*   83600 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(83689), // Rule ID 51698 //
     /*   83605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83639 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83648 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83687 */     GIR_RootConstrainSelectedInstOperands,
     /*   83688 */     // GIR_Coverage, 51698,
     /*   83688 */     GIR_EraseRootFromParent_Done,
     /*   83689 */   // Label 1357: @83689
     /*   83689 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(83778), // Rule ID 51699 //
     /*   83694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83737 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83776 */     GIR_RootConstrainSelectedInstOperands,
     /*   83777 */     // GIR_Coverage, 51699,
     /*   83777 */     GIR_EraseRootFromParent_Done,
     /*   83778 */   // Label 1358: @83778
     /*   83778 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(83867), // Rule ID 70464 //
     /*   83783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83817 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83826 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83865 */     GIR_RootConstrainSelectedInstOperands,
     /*   83866 */     // GIR_Coverage, 70464,
     /*   83866 */     GIR_EraseRootFromParent_Done,
     /*   83867 */   // Label 1359: @83867
     /*   83867 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(83956), // Rule ID 70465 //
     /*   83872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83915 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83954 */     GIR_RootConstrainSelectedInstOperands,
     /*   83955 */     // GIR_Coverage, 70465,
     /*   83955 */     GIR_EraseRootFromParent_Done,
     /*   83956 */   // Label 1360: @83956
     /*   83956 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(84045), // Rule ID 51578 //
     /*   83961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83995 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84004 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84043 */     GIR_RootConstrainSelectedInstOperands,
     /*   84044 */     // GIR_Coverage, 51578,
     /*   84044 */     GIR_EraseRootFromParent_Done,
     /*   84045 */   // Label 1361: @84045
     /*   84045 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(84134), // Rule ID 51579 //
     /*   84050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84084 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84093 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84132 */     GIR_RootConstrainSelectedInstOperands,
     /*   84133 */     // GIR_Coverage, 51579,
     /*   84133 */     GIR_EraseRootFromParent_Done,
     /*   84134 */   // Label 1362: @84134
     /*   84134 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(84187), // Rule ID 50868 //
     /*   84139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84150 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   84167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   84174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   84176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84185 */     GIR_RootConstrainSelectedInstOperands,
     /*   84186 */     // GIR_Coverage, 50868,
     /*   84186 */     GIR_EraseRootFromParent_Done,
     /*   84187 */   // Label 1363: @84187
     /*   84187 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(84240), // Rule ID 50869 //
     /*   84192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84203 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   84220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   84227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   84229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84238 */     GIR_RootConstrainSelectedInstOperands,
     /*   84239 */     // GIR_Coverage, 50869,
     /*   84239 */     GIR_EraseRootFromParent_Done,
     /*   84240 */   // Label 1364: @84240
     /*   84240 */   GIM_Reject,
     /*   84241 */ // Label 1344: @84241
     /*   84241 */ GIM_Reject,
     /*   84242 */ // Label 1295: @84242
     /*   84242 */ GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(85966),
     /*   84247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   84250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   84253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84257 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(84346), // Rule ID 51658 //
     /*   84262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84277 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84296 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84305 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84344 */     GIR_RootConstrainSelectedInstOperands,
     /*   84345 */     // GIR_Coverage, 51658,
     /*   84345 */     GIR_EraseRootFromParent_Done,
     /*   84346 */   // Label 1366: @84346
     /*   84346 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(84435), // Rule ID 51659 //
     /*   84351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84385 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84394 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84433 */     GIR_RootConstrainSelectedInstOperands,
     /*   84434 */     // GIR_Coverage, 51659,
     /*   84434 */     GIR_EraseRootFromParent_Done,
     /*   84435 */   // Label 1367: @84435
     /*   84435 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(84524), // Rule ID 70544 //
     /*   84440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84455 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84474 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84483 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84522 */     GIR_RootConstrainSelectedInstOperands,
     /*   84523 */     // GIR_Coverage, 70544,
     /*   84523 */     GIR_EraseRootFromParent_Done,
     /*   84524 */   // Label 1368: @84524
     /*   84524 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(84613), // Rule ID 70545 //
     /*   84529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84544 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84563 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84572 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84611 */     GIR_RootConstrainSelectedInstOperands,
     /*   84612 */     // GIR_Coverage, 70545,
     /*   84612 */     GIR_EraseRootFromParent_Done,
     /*   84613 */   // Label 1369: @84613
     /*   84613 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(84702), // Rule ID 70424 //
     /*   84618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84633 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84652 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84661 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84700 */     GIR_RootConstrainSelectedInstOperands,
     /*   84701 */     // GIR_Coverage, 70424,
     /*   84701 */     GIR_EraseRootFromParent_Done,
     /*   84702 */   // Label 1370: @84702
     /*   84702 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(84791), // Rule ID 70425 //
     /*   84707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84741 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84750 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84789 */     GIR_RootConstrainSelectedInstOperands,
     /*   84790 */     // GIR_Coverage, 70425,
     /*   84790 */     GIR_EraseRootFromParent_Done,
     /*   84791 */   // Label 1371: @84791
     /*   84791 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(84880), // Rule ID 51838 //
     /*   84796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84811 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84830 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84839 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84878 */     GIR_RootConstrainSelectedInstOperands,
     /*   84879 */     // GIR_Coverage, 51838,
     /*   84879 */     GIR_EraseRootFromParent_Done,
     /*   84880 */   // Label 1372: @84880
     /*   84880 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(84969), // Rule ID 51839 //
     /*   84885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84900 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84919 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84928 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84967 */     GIR_RootConstrainSelectedInstOperands,
     /*   84968 */     // GIR_Coverage, 51839,
     /*   84968 */     GIR_EraseRootFromParent_Done,
     /*   84969 */   // Label 1373: @84969
     /*   84969 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(85058), // Rule ID 51538 //
     /*   84974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84989 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85008 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85017 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   85034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85056 */     GIR_RootConstrainSelectedInstOperands,
     /*   85057 */     // GIR_Coverage, 51538,
     /*   85057 */     GIR_EraseRootFromParent_Done,
     /*   85058 */   // Label 1374: @85058
     /*   85058 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(85147), // Rule ID 51539 //
     /*   85063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85078 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85097 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85106 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   85123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85145 */     GIR_RootConstrainSelectedInstOperands,
     /*   85146 */     // GIR_Coverage, 51539,
     /*   85146 */     GIR_EraseRootFromParent_Done,
     /*   85147 */   // Label 1375: @85147
     /*   85147 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(85236), // Rule ID 51778 //
     /*   85152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85167 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85186 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85195 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85234 */     GIR_RootConstrainSelectedInstOperands,
     /*   85235 */     // GIR_Coverage, 51778,
     /*   85235 */     GIR_EraseRootFromParent_Done,
     /*   85236 */   // Label 1376: @85236
     /*   85236 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(85325), // Rule ID 51779 //
     /*   85241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85275 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85284 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85323 */     GIR_RootConstrainSelectedInstOperands,
     /*   85324 */     // GIR_Coverage, 51779,
     /*   85324 */     GIR_EraseRootFromParent_Done,
     /*   85325 */   // Label 1377: @85325
     /*   85325 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(85414), // Rule ID 51718 //
     /*   85330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85345 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85364 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85373 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85412 */     GIR_RootConstrainSelectedInstOperands,
     /*   85413 */     // GIR_Coverage, 51718,
     /*   85413 */     GIR_EraseRootFromParent_Done,
     /*   85414 */   // Label 1378: @85414
     /*   85414 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(85503), // Rule ID 51719 //
     /*   85419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85434 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85453 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85462 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85501 */     GIR_RootConstrainSelectedInstOperands,
     /*   85502 */     // GIR_Coverage, 51719,
     /*   85502 */     GIR_EraseRootFromParent_Done,
     /*   85503 */   // Label 1379: @85503
     /*   85503 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(85592), // Rule ID 70484 //
     /*   85508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85523 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85542 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85551 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85590 */     GIR_RootConstrainSelectedInstOperands,
     /*   85591 */     // GIR_Coverage, 70484,
     /*   85591 */     GIR_EraseRootFromParent_Done,
     /*   85592 */   // Label 1380: @85592
     /*   85592 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(85681), // Rule ID 70485 //
     /*   85597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85612 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85631 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85640 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85679 */     GIR_RootConstrainSelectedInstOperands,
     /*   85680 */     // GIR_Coverage, 70485,
     /*   85680 */     GIR_EraseRootFromParent_Done,
     /*   85681 */   // Label 1381: @85681
     /*   85681 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(85770), // Rule ID 51598 //
     /*   85686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85701 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85720 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85729 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85768 */     GIR_RootConstrainSelectedInstOperands,
     /*   85769 */     // GIR_Coverage, 51598,
     /*   85769 */     GIR_EraseRootFromParent_Done,
     /*   85770 */   // Label 1382: @85770
     /*   85770 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(85859), // Rule ID 51599 //
     /*   85775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85790 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85809 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85811 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85818 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85857 */     GIR_RootConstrainSelectedInstOperands,
     /*   85858 */     // GIR_Coverage, 51599,
     /*   85858 */     GIR_EraseRootFromParent_Done,
     /*   85859 */   // Label 1383: @85859
     /*   85859 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(85912), // Rule ID 50884 //
     /*   85864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   85867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85875 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   85875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   85892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   85899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   85901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   85907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85910 */     GIR_RootConstrainSelectedInstOperands,
     /*   85911 */     // GIR_Coverage, 50884,
     /*   85911 */     GIR_EraseRootFromParent_Done,
     /*   85912 */   // Label 1384: @85912
     /*   85912 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(85965), // Rule ID 50885 //
     /*   85917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   85920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85928 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   85928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   85945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   85952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   85954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   85960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85963 */     GIR_RootConstrainSelectedInstOperands,
     /*   85964 */     // GIR_Coverage, 50885,
     /*   85964 */     GIR_EraseRootFromParent_Done,
     /*   85965 */   // Label 1385: @85965
     /*   85965 */   GIM_Reject,
     /*   85966 */ // Label 1365: @85966
     /*   85966 */ GIM_Reject,
     /*   85967 */ // Label 1296: @85967
     /*   85967 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(86081),
     /*   85972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   85975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   85978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85990 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(86035), // Rule ID 50852 //
     /*   85995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   85998 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   85998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   86001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   86015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86033 */     GIR_RootConstrainSelectedInstOperands,
     /*   86034 */     // GIR_Coverage, 50852,
     /*   86034 */     GIR_EraseRootFromParent_Done,
     /*   86035 */   // Label 1387: @86035
     /*   86035 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(86080), // Rule ID 50853 //
     /*   86040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86043 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   86046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   86060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86078 */     GIR_RootConstrainSelectedInstOperands,
     /*   86079 */     // GIR_Coverage, 50853,
     /*   86079 */     GIR_EraseRootFromParent_Done,
     /*   86080 */   // Label 1388: @86080
     /*   86080 */   GIM_Reject,
     /*   86081 */ // Label 1386: @86081
     /*   86081 */ GIM_Reject,
     /*   86082 */ // Label 1297: @86082
     /*   86082 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(87806),
     /*   86087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   86090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   86093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86097 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(86186), // Rule ID 51618 //
     /*   86102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86117 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86136 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86145 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86184 */     GIR_RootConstrainSelectedInstOperands,
     /*   86185 */     // GIR_Coverage, 51618,
     /*   86185 */     GIR_EraseRootFromParent_Done,
     /*   86186 */   // Label 1390: @86186
     /*   86186 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(86275), // Rule ID 51619 //
     /*   86191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86225 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86234 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86273 */     GIR_RootConstrainSelectedInstOperands,
     /*   86274 */     // GIR_Coverage, 51619,
     /*   86274 */     GIR_EraseRootFromParent_Done,
     /*   86275 */   // Label 1391: @86275
     /*   86275 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(86364), // Rule ID 70504 //
     /*   86280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86295 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86314 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86323 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86362 */     GIR_RootConstrainSelectedInstOperands,
     /*   86363 */     // GIR_Coverage, 70504,
     /*   86363 */     GIR_EraseRootFromParent_Done,
     /*   86364 */   // Label 1392: @86364
     /*   86364 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(86453), // Rule ID 70505 //
     /*   86369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86384 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86403 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86412 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86451 */     GIR_RootConstrainSelectedInstOperands,
     /*   86452 */     // GIR_Coverage, 70505,
     /*   86452 */     GIR_EraseRootFromParent_Done,
     /*   86453 */   // Label 1393: @86453
     /*   86453 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(86542), // Rule ID 70384 //
     /*   86458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86473 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86492 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86501 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86540 */     GIR_RootConstrainSelectedInstOperands,
     /*   86541 */     // GIR_Coverage, 70384,
     /*   86541 */     GIR_EraseRootFromParent_Done,
     /*   86542 */   // Label 1394: @86542
     /*   86542 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(86631), // Rule ID 70385 //
     /*   86547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86562 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86581 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86590 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86629 */     GIR_RootConstrainSelectedInstOperands,
     /*   86630 */     // GIR_Coverage, 70385,
     /*   86630 */     GIR_EraseRootFromParent_Done,
     /*   86631 */   // Label 1395: @86631
     /*   86631 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(86720), // Rule ID 51798 //
     /*   86636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86651 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86670 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86679 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86718 */     GIR_RootConstrainSelectedInstOperands,
     /*   86719 */     // GIR_Coverage, 51798,
     /*   86719 */     GIR_EraseRootFromParent_Done,
     /*   86720 */   // Label 1396: @86720
     /*   86720 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(86809), // Rule ID 51799 //
     /*   86725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86740 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86759 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86768 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86807 */     GIR_RootConstrainSelectedInstOperands,
     /*   86808 */     // GIR_Coverage, 51799,
     /*   86808 */     GIR_EraseRootFromParent_Done,
     /*   86809 */   // Label 1397: @86809
     /*   86809 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(86898), // Rule ID 51498 //
     /*   86814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86829 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86848 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86857 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   86874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86896 */     GIR_RootConstrainSelectedInstOperands,
     /*   86897 */     // GIR_Coverage, 51498,
     /*   86897 */     GIR_EraseRootFromParent_Done,
     /*   86898 */   // Label 1398: @86898
     /*   86898 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(86987), // Rule ID 51499 //
     /*   86903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86937 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86946 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   86963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86985 */     GIR_RootConstrainSelectedInstOperands,
     /*   86986 */     // GIR_Coverage, 51499,
     /*   86986 */     GIR_EraseRootFromParent_Done,
     /*   86987 */   // Label 1399: @86987
     /*   86987 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(87076), // Rule ID 51738 //
     /*   86992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87007 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87026 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87035 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87074 */     GIR_RootConstrainSelectedInstOperands,
     /*   87075 */     // GIR_Coverage, 51738,
     /*   87075 */     GIR_EraseRootFromParent_Done,
     /*   87076 */   // Label 1400: @87076
     /*   87076 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(87165), // Rule ID 51739 //
     /*   87081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87115 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87124 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87163 */     GIR_RootConstrainSelectedInstOperands,
     /*   87164 */     // GIR_Coverage, 51739,
     /*   87164 */     GIR_EraseRootFromParent_Done,
     /*   87165 */   // Label 1401: @87165
     /*   87165 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(87254), // Rule ID 51678 //
     /*   87170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87185 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87204 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87213 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87252 */     GIR_RootConstrainSelectedInstOperands,
     /*   87253 */     // GIR_Coverage, 51678,
     /*   87253 */     GIR_EraseRootFromParent_Done,
     /*   87254 */   // Label 1402: @87254
     /*   87254 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(87343), // Rule ID 51679 //
     /*   87259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87274 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87293 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87302 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87341 */     GIR_RootConstrainSelectedInstOperands,
     /*   87342 */     // GIR_Coverage, 51679,
     /*   87342 */     GIR_EraseRootFromParent_Done,
     /*   87343 */   // Label 1403: @87343
     /*   87343 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(87432), // Rule ID 70444 //
     /*   87348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87363 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87382 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87391 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87430 */     GIR_RootConstrainSelectedInstOperands,
     /*   87431 */     // GIR_Coverage, 70444,
     /*   87431 */     GIR_EraseRootFromParent_Done,
     /*   87432 */   // Label 1404: @87432
     /*   87432 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(87521), // Rule ID 70445 //
     /*   87437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87452 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87471 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87473 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87480 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87519 */     GIR_RootConstrainSelectedInstOperands,
     /*   87520 */     // GIR_Coverage, 70445,
     /*   87520 */     GIR_EraseRootFromParent_Done,
     /*   87521 */   // Label 1405: @87521
     /*   87521 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(87610), // Rule ID 51558 //
     /*   87526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87560 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87569 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87608 */     GIR_RootConstrainSelectedInstOperands,
     /*   87609 */     // GIR_Coverage, 51558,
     /*   87609 */     GIR_EraseRootFromParent_Done,
     /*   87610 */   // Label 1406: @87610
     /*   87610 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(87699), // Rule ID 51559 //
     /*   87615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87630 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87649 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87658 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87697 */     GIR_RootConstrainSelectedInstOperands,
     /*   87698 */     // GIR_Coverage, 51559,
     /*   87698 */     GIR_EraseRootFromParent_Done,
     /*   87699 */   // Label 1407: @87699
     /*   87699 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(87752), // Rule ID 50864 //
     /*   87704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87715 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   87715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   87732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   87739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   87741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87750 */     GIR_RootConstrainSelectedInstOperands,
     /*   87751 */     // GIR_Coverage, 50864,
     /*   87751 */     GIR_EraseRootFromParent_Done,
     /*   87752 */   // Label 1408: @87752
     /*   87752 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(87805), // Rule ID 50865 //
     /*   87757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87768 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   87768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   87785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   87792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   87794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87803 */     GIR_RootConstrainSelectedInstOperands,
     /*   87804 */     // GIR_Coverage, 50865,
     /*   87804 */     GIR_EraseRootFromParent_Done,
     /*   87805 */   // Label 1409: @87805
     /*   87805 */   GIM_Reject,
     /*   87806 */ // Label 1389: @87806
     /*   87806 */ GIM_Reject,
     /*   87807 */ // Label 1298: @87807
     /*   87807 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(89531),
     /*   87812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   87815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   87818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87822 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(87911), // Rule ID 51642 //
     /*   87827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87842 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87861 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87870 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   87870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   87873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   87887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87909 */     GIR_RootConstrainSelectedInstOperands,
     /*   87910 */     // GIR_Coverage, 51642,
     /*   87910 */     GIR_EraseRootFromParent_Done,
     /*   87911 */   // Label 1411: @87911
     /*   87911 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(88000), // Rule ID 51643 //
     /*   87916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87950 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87959 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   87959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   87962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   87976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87998 */     GIR_RootConstrainSelectedInstOperands,
     /*   87999 */     // GIR_Coverage, 51643,
     /*   87999 */     GIR_EraseRootFromParent_Done,
     /*   88000 */   // Label 1412: @88000
     /*   88000 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(88089), // Rule ID 70528 //
     /*   88005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88020 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88039 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88048 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88087 */     GIR_RootConstrainSelectedInstOperands,
     /*   88088 */     // GIR_Coverage, 70528,
     /*   88088 */     GIR_EraseRootFromParent_Done,
     /*   88089 */   // Label 1413: @88089
     /*   88089 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(88178), // Rule ID 70529 //
     /*   88094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88109 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88128 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88137 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88176 */     GIR_RootConstrainSelectedInstOperands,
     /*   88177 */     // GIR_Coverage, 70529,
     /*   88177 */     GIR_EraseRootFromParent_Done,
     /*   88178 */   // Label 1414: @88178
     /*   88178 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(88267), // Rule ID 70408 //
     /*   88183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88198 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88217 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88226 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88265 */     GIR_RootConstrainSelectedInstOperands,
     /*   88266 */     // GIR_Coverage, 70408,
     /*   88266 */     GIR_EraseRootFromParent_Done,
     /*   88267 */   // Label 1415: @88267
     /*   88267 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(88356), // Rule ID 70409 //
     /*   88272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88287 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88315 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88354 */     GIR_RootConstrainSelectedInstOperands,
     /*   88355 */     // GIR_Coverage, 70409,
     /*   88355 */     GIR_EraseRootFromParent_Done,
     /*   88356 */   // Label 1416: @88356
     /*   88356 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(88445), // Rule ID 51822 //
     /*   88361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88376 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88395 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88404 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88443 */     GIR_RootConstrainSelectedInstOperands,
     /*   88444 */     // GIR_Coverage, 51822,
     /*   88444 */     GIR_EraseRootFromParent_Done,
     /*   88445 */   // Label 1417: @88445
     /*   88445 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(88534), // Rule ID 51823 //
     /*   88450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88465 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88484 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88493 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88532 */     GIR_RootConstrainSelectedInstOperands,
     /*   88533 */     // GIR_Coverage, 51823,
     /*   88533 */     GIR_EraseRootFromParent_Done,
     /*   88534 */   // Label 1418: @88534
     /*   88534 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(88623), // Rule ID 51522 //
     /*   88539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88554 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88573 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88582 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   88599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88621 */     GIR_RootConstrainSelectedInstOperands,
     /*   88622 */     // GIR_Coverage, 51522,
     /*   88622 */     GIR_EraseRootFromParent_Done,
     /*   88623 */   // Label 1419: @88623
     /*   88623 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(88712), // Rule ID 51523 //
     /*   88628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88643 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88662 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88671 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   88688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88710 */     GIR_RootConstrainSelectedInstOperands,
     /*   88711 */     // GIR_Coverage, 51523,
     /*   88711 */     GIR_EraseRootFromParent_Done,
     /*   88712 */   // Label 1420: @88712
     /*   88712 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(88801), // Rule ID 51762 //
     /*   88717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88732 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88751 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88760 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88799 */     GIR_RootConstrainSelectedInstOperands,
     /*   88800 */     // GIR_Coverage, 51762,
     /*   88800 */     GIR_EraseRootFromParent_Done,
     /*   88801 */   // Label 1421: @88801
     /*   88801 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(88890), // Rule ID 51763 //
     /*   88806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88821 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88840 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88849 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88888 */     GIR_RootConstrainSelectedInstOperands,
     /*   88889 */     // GIR_Coverage, 51763,
     /*   88889 */     GIR_EraseRootFromParent_Done,
     /*   88890 */   // Label 1422: @88890
     /*   88890 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(88979), // Rule ID 51702 //
     /*   88895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88910 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88929 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88938 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88977 */     GIR_RootConstrainSelectedInstOperands,
     /*   88978 */     // GIR_Coverage, 51702,
     /*   88978 */     GIR_EraseRootFromParent_Done,
     /*   88979 */   // Label 1423: @88979
     /*   88979 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(89068), // Rule ID 51703 //
     /*   88984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88999 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89018 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89027 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89066 */     GIR_RootConstrainSelectedInstOperands,
     /*   89067 */     // GIR_Coverage, 51703,
     /*   89067 */     GIR_EraseRootFromParent_Done,
     /*   89068 */   // Label 1424: @89068
     /*   89068 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(89157), // Rule ID 70468 //
     /*   89073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89088 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89107 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89116 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89155 */     GIR_RootConstrainSelectedInstOperands,
     /*   89156 */     // GIR_Coverage, 70468,
     /*   89156 */     GIR_EraseRootFromParent_Done,
     /*   89157 */   // Label 1425: @89157
     /*   89157 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(89246), // Rule ID 70469 //
     /*   89162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89177 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89196 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89205 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89244 */     GIR_RootConstrainSelectedInstOperands,
     /*   89245 */     // GIR_Coverage, 70469,
     /*   89245 */     GIR_EraseRootFromParent_Done,
     /*   89246 */   // Label 1426: @89246
     /*   89246 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(89335), // Rule ID 51582 //
     /*   89251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89266 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89285 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89294 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89333 */     GIR_RootConstrainSelectedInstOperands,
     /*   89334 */     // GIR_Coverage, 51582,
     /*   89334 */     GIR_EraseRootFromParent_Done,
     /*   89335 */   // Label 1427: @89335
     /*   89335 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(89424), // Rule ID 51583 //
     /*   89340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89355 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89374 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89383 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89422 */     GIR_RootConstrainSelectedInstOperands,
     /*   89423 */     // GIR_Coverage, 51583,
     /*   89423 */     GIR_EraseRootFromParent_Done,
     /*   89424 */   // Label 1428: @89424
     /*   89424 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(89477), // Rule ID 50880 //
     /*   89429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89440 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   89457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   89464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   89466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89475 */     GIR_RootConstrainSelectedInstOperands,
     /*   89476 */     // GIR_Coverage, 50880,
     /*   89476 */     GIR_EraseRootFromParent_Done,
     /*   89477 */   // Label 1429: @89477
     /*   89477 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(89530), // Rule ID 50881 //
     /*   89482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89493 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   89510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   89517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   89519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89528 */     GIR_RootConstrainSelectedInstOperands,
     /*   89529 */     // GIR_Coverage, 50881,
     /*   89529 */     GIR_EraseRootFromParent_Done,
     /*   89530 */   // Label 1430: @89530
     /*   89530 */   GIM_Reject,
     /*   89531 */ // Label 1410: @89531
     /*   89531 */ GIM_Reject,
     /*   89532 */ // Label 1299: @89532
     /*   89532 */ GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91256),
     /*   89537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   89540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   89543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   89547 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(89636), // Rule ID 51662 //
     /*   89552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   89555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89567 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89586 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89595 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89634 */     GIR_RootConstrainSelectedInstOperands,
     /*   89635 */     // GIR_Coverage, 51662,
     /*   89635 */     GIR_EraseRootFromParent_Done,
     /*   89636 */   // Label 1432: @89636
     /*   89636 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(89725), // Rule ID 51663 //
     /*   89641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   89644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89675 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89684 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89723 */     GIR_RootConstrainSelectedInstOperands,
     /*   89724 */     // GIR_Coverage, 51663,
     /*   89724 */     GIR_EraseRootFromParent_Done,
     /*   89725 */   // Label 1433: @89725
     /*   89725 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(89814), // Rule ID 70548 //
     /*   89730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   89733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89745 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89764 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89773 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   89790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89812 */     GIR_RootConstrainSelectedInstOperands,
     /*   89813 */     // GIR_Coverage, 70548,
     /*   89813 */     GIR_EraseRootFromParent_Done,
     /*   89814 */   // Label 1434: @89814
     /*   89814 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(89903), // Rule ID 70549 //
     /*   89819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   89822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89853 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89862 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   89879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89901 */     GIR_RootConstrainSelectedInstOperands,
     /*   89902 */     // GIR_Coverage, 70549,
     /*   89902 */     GIR_EraseRootFromParent_Done,
     /*   89903 */   // Label 1435: @89903
     /*   89903 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(89992), // Rule ID 70428 //
     /*   89908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   89911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89923 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89942 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89951 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89990 */     GIR_RootConstrainSelectedInstOperands,
     /*   89991 */     // GIR_Coverage, 70428,
     /*   89991 */     GIR_EraseRootFromParent_Done,
     /*   89992 */   // Label 1436: @89992
     /*   89992 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(90081), // Rule ID 70429 //
     /*   89997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90012 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90031 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90040 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90079 */     GIR_RootConstrainSelectedInstOperands,
     /*   90080 */     // GIR_Coverage, 70429,
     /*   90080 */     GIR_EraseRootFromParent_Done,
     /*   90081 */   // Label 1437: @90081
     /*   90081 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(90170), // Rule ID 51842 //
     /*   90086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90101 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90120 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90129 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90168 */     GIR_RootConstrainSelectedInstOperands,
     /*   90169 */     // GIR_Coverage, 51842,
     /*   90169 */     GIR_EraseRootFromParent_Done,
     /*   90170 */   // Label 1438: @90170
     /*   90170 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(90259), // Rule ID 51843 //
     /*   90175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90190 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90209 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90218 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90257 */     GIR_RootConstrainSelectedInstOperands,
     /*   90258 */     // GIR_Coverage, 51843,
     /*   90258 */     GIR_EraseRootFromParent_Done,
     /*   90259 */   // Label 1439: @90259
     /*   90259 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(90348), // Rule ID 51542 //
     /*   90264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90279 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90298 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90307 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   90324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90346 */     GIR_RootConstrainSelectedInstOperands,
     /*   90347 */     // GIR_Coverage, 51542,
     /*   90347 */     GIR_EraseRootFromParent_Done,
     /*   90348 */   // Label 1440: @90348
     /*   90348 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(90437), // Rule ID 51543 //
     /*   90353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90368 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90387 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90396 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   90413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90435 */     GIR_RootConstrainSelectedInstOperands,
     /*   90436 */     // GIR_Coverage, 51543,
     /*   90436 */     GIR_EraseRootFromParent_Done,
     /*   90437 */   // Label 1441: @90437
     /*   90437 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(90526), // Rule ID 51782 //
     /*   90442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90457 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90476 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90485 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90524 */     GIR_RootConstrainSelectedInstOperands,
     /*   90525 */     // GIR_Coverage, 51782,
     /*   90525 */     GIR_EraseRootFromParent_Done,
     /*   90526 */   // Label 1442: @90526
     /*   90526 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(90615), // Rule ID 51783 //
     /*   90531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90565 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90574 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90613 */     GIR_RootConstrainSelectedInstOperands,
     /*   90614 */     // GIR_Coverage, 51783,
     /*   90614 */     GIR_EraseRootFromParent_Done,
     /*   90615 */   // Label 1443: @90615
     /*   90615 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(90704), // Rule ID 51722 //
     /*   90620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90635 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90654 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90663 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90702 */     GIR_RootConstrainSelectedInstOperands,
     /*   90703 */     // GIR_Coverage, 51722,
     /*   90703 */     GIR_EraseRootFromParent_Done,
     /*   90704 */   // Label 1444: @90704
     /*   90704 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(90793), // Rule ID 51723 //
     /*   90709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90724 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90743 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90752 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90791 */     GIR_RootConstrainSelectedInstOperands,
     /*   90792 */     // GIR_Coverage, 51723,
     /*   90792 */     GIR_EraseRootFromParent_Done,
     /*   90793 */   // Label 1445: @90793
     /*   90793 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(90882), // Rule ID 70488 //
     /*   90798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90813 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90832 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90841 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90880 */     GIR_RootConstrainSelectedInstOperands,
     /*   90881 */     // GIR_Coverage, 70488,
     /*   90881 */     GIR_EraseRootFromParent_Done,
     /*   90882 */   // Label 1446: @90882
     /*   90882 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(90971), // Rule ID 70489 //
     /*   90887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90902 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90921 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90930 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90969 */     GIR_RootConstrainSelectedInstOperands,
     /*   90970 */     // GIR_Coverage, 70489,
     /*   90970 */     GIR_EraseRootFromParent_Done,
     /*   90971 */   // Label 1447: @90971
     /*   90971 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(91060), // Rule ID 51602 //
     /*   90976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90991 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91010 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91019 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91058 */     GIR_RootConstrainSelectedInstOperands,
     /*   91059 */     // GIR_Coverage, 51602,
     /*   91059 */     GIR_EraseRootFromParent_Done,
     /*   91060 */   // Label 1448: @91060
     /*   91060 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(91149), // Rule ID 51603 //
     /*   91065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91080 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91099 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91108 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91147 */     GIR_RootConstrainSelectedInstOperands,
     /*   91148 */     // GIR_Coverage, 51603,
     /*   91148 */     GIR_EraseRootFromParent_Done,
     /*   91149 */   // Label 1449: @91149
     /*   91149 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(91202), // Rule ID 50924 //
     /*   91154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   91157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91165 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   91165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   91182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   91197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91200 */     GIR_RootConstrainSelectedInstOperands,
     /*   91201 */     // GIR_Coverage, 50924,
     /*   91201 */     GIR_EraseRootFromParent_Done,
     /*   91202 */   // Label 1450: @91202
     /*   91202 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(91255), // Rule ID 50925 //
     /*   91207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   91210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91218 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   91218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   91235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   91250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91253 */     GIR_RootConstrainSelectedInstOperands,
     /*   91254 */     // GIR_Coverage, 50925,
     /*   91254 */     GIR_EraseRootFromParent_Done,
     /*   91255 */   // Label 1451: @91255
     /*   91255 */   GIM_Reject,
     /*   91256 */ // Label 1431: @91256
     /*   91256 */ GIM_Reject,
     /*   91257 */ // Label 1300: @91257
     /*   91257 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(91371),
     /*   91262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   91268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91280 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(91325), // Rule ID 50856 //
     /*   91285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91288 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   91291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   91305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91323 */     GIR_RootConstrainSelectedInstOperands,
     /*   91324 */     // GIR_Coverage, 50856,
     /*   91324 */     GIR_EraseRootFromParent_Done,
     /*   91325 */   // Label 1453: @91325
     /*   91325 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(91370), // Rule ID 50857 //
     /*   91330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91333 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   91336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   91350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91368 */     GIR_RootConstrainSelectedInstOperands,
     /*   91369 */     // GIR_Coverage, 50857,
     /*   91369 */     GIR_EraseRootFromParent_Done,
     /*   91370 */   // Label 1454: @91370
     /*   91370 */   GIM_Reject,
     /*   91371 */ // Label 1452: @91371
     /*   91371 */ GIM_Reject,
     /*   91372 */ // Label 1301: @91372
     /*   91372 */ GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(93096),
     /*   91377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   91380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   91383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91387 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(91476), // Rule ID 51622 //
     /*   91392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91407 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91426 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91435 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91474 */     GIR_RootConstrainSelectedInstOperands,
     /*   91475 */     // GIR_Coverage, 51622,
     /*   91475 */     GIR_EraseRootFromParent_Done,
     /*   91476 */   // Label 1456: @91476
     /*   91476 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(91565), // Rule ID 51623 //
     /*   91481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91496 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91515 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91524 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91563 */     GIR_RootConstrainSelectedInstOperands,
     /*   91564 */     // GIR_Coverage, 51623,
     /*   91564 */     GIR_EraseRootFromParent_Done,
     /*   91565 */   // Label 1457: @91565
     /*   91565 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(91654), // Rule ID 70508 //
     /*   91570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91585 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91604 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91613 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   91630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91652 */     GIR_RootConstrainSelectedInstOperands,
     /*   91653 */     // GIR_Coverage, 70508,
     /*   91653 */     GIR_EraseRootFromParent_Done,
     /*   91654 */   // Label 1458: @91654
     /*   91654 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(91743), // Rule ID 70509 //
     /*   91659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91674 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91693 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91702 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   91719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91741 */     GIR_RootConstrainSelectedInstOperands,
     /*   91742 */     // GIR_Coverage, 70509,
     /*   91742 */     GIR_EraseRootFromParent_Done,
     /*   91743 */   // Label 1459: @91743
     /*   91743 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(91832), // Rule ID 70388 //
     /*   91748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91763 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91782 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91791 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91830 */     GIR_RootConstrainSelectedInstOperands,
     /*   91831 */     // GIR_Coverage, 70388,
     /*   91831 */     GIR_EraseRootFromParent_Done,
     /*   91832 */   // Label 1460: @91832
     /*   91832 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(91921), // Rule ID 70389 //
     /*   91837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91852 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91871 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91880 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91919 */     GIR_RootConstrainSelectedInstOperands,
     /*   91920 */     // GIR_Coverage, 70389,
     /*   91920 */     GIR_EraseRootFromParent_Done,
     /*   91921 */   // Label 1461: @91921
     /*   91921 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(92010), // Rule ID 51802 //
     /*   91926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91941 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91960 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91969 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   91986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92008 */     GIR_RootConstrainSelectedInstOperands,
     /*   92009 */     // GIR_Coverage, 51802,
     /*   92009 */     GIR_EraseRootFromParent_Done,
     /*   92010 */   // Label 1462: @92010
     /*   92010 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(92099), // Rule ID 51803 //
     /*   92015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92030 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92049 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92058 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92097 */     GIR_RootConstrainSelectedInstOperands,
     /*   92098 */     // GIR_Coverage, 51803,
     /*   92098 */     GIR_EraseRootFromParent_Done,
     /*   92099 */   // Label 1463: @92099
     /*   92099 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(92188), // Rule ID 51502 //
     /*   92104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92119 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92138 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92147 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   92164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92186 */     GIR_RootConstrainSelectedInstOperands,
     /*   92187 */     // GIR_Coverage, 51502,
     /*   92187 */     GIR_EraseRootFromParent_Done,
     /*   92188 */   // Label 1464: @92188
     /*   92188 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(92277), // Rule ID 51503 //
     /*   92193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92227 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92236 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   92253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92275 */     GIR_RootConstrainSelectedInstOperands,
     /*   92276 */     // GIR_Coverage, 51503,
     /*   92276 */     GIR_EraseRootFromParent_Done,
     /*   92277 */   // Label 1465: @92277
     /*   92277 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(92366), // Rule ID 51742 //
     /*   92282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92297 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92316 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92325 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92364 */     GIR_RootConstrainSelectedInstOperands,
     /*   92365 */     // GIR_Coverage, 51742,
     /*   92365 */     GIR_EraseRootFromParent_Done,
     /*   92366 */   // Label 1466: @92366
     /*   92366 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(92455), // Rule ID 51743 //
     /*   92371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92386 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92405 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92414 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92453 */     GIR_RootConstrainSelectedInstOperands,
     /*   92454 */     // GIR_Coverage, 51743,
     /*   92454 */     GIR_EraseRootFromParent_Done,
     /*   92455 */   // Label 1467: @92455
     /*   92455 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(92544), // Rule ID 51682 //
     /*   92460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92475 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92494 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92503 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92542 */     GIR_RootConstrainSelectedInstOperands,
     /*   92543 */     // GIR_Coverage, 51682,
     /*   92543 */     GIR_EraseRootFromParent_Done,
     /*   92544 */   // Label 1468: @92544
     /*   92544 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(92633), // Rule ID 51683 //
     /*   92549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92564 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92583 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92592 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92631 */     GIR_RootConstrainSelectedInstOperands,
     /*   92632 */     // GIR_Coverage, 51683,
     /*   92632 */     GIR_EraseRootFromParent_Done,
     /*   92633 */   // Label 1469: @92633
     /*   92633 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(92722), // Rule ID 70448 //
     /*   92638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92653 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92672 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92681 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92720 */     GIR_RootConstrainSelectedInstOperands,
     /*   92721 */     // GIR_Coverage, 70448,
     /*   92721 */     GIR_EraseRootFromParent_Done,
     /*   92722 */   // Label 1470: @92722
     /*   92722 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(92811), // Rule ID 70449 //
     /*   92727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92742 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92761 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92770 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92809 */     GIR_RootConstrainSelectedInstOperands,
     /*   92810 */     // GIR_Coverage, 70449,
     /*   92810 */     GIR_EraseRootFromParent_Done,
     /*   92811 */   // Label 1471: @92811
     /*   92811 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(92900), // Rule ID 51562 //
     /*   92816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92850 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92859 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92898 */     GIR_RootConstrainSelectedInstOperands,
     /*   92899 */     // GIR_Coverage, 51562,
     /*   92899 */     GIR_EraseRootFromParent_Done,
     /*   92900 */   // Label 1472: @92900
     /*   92900 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(92989), // Rule ID 51563 //
     /*   92905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92939 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92948 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92987 */     GIR_RootConstrainSelectedInstOperands,
     /*   92988 */     // GIR_Coverage, 51563,
     /*   92988 */     GIR_EraseRootFromParent_Done,
     /*   92989 */   // Label 1473: @92989
     /*   92989 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(93042), // Rule ID 50876 //
     /*   92994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93005 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   93022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   93029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   93031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93040 */     GIR_RootConstrainSelectedInstOperands,
     /*   93041 */     // GIR_Coverage, 50876,
     /*   93041 */     GIR_EraseRootFromParent_Done,
     /*   93042 */   // Label 1474: @93042
     /*   93042 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(93095), // Rule ID 50877 //
     /*   93047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93058 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   93075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   93082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   93084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93093 */     GIR_RootConstrainSelectedInstOperands,
     /*   93094 */     // GIR_Coverage, 50877,
     /*   93094 */     GIR_EraseRootFromParent_Done,
     /*   93095 */   // Label 1475: @93095
     /*   93095 */   GIM_Reject,
     /*   93096 */ // Label 1455: @93096
     /*   93096 */ GIM_Reject,
     /*   93097 */ // Label 1302: @93097
     /*   93097 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(94821),
     /*   93102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   93105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   93108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   93112 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(93201), // Rule ID 51646 //
     /*   93117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93132 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93151 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93160 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93199 */     GIR_RootConstrainSelectedInstOperands,
     /*   93200 */     // GIR_Coverage, 51646,
     /*   93200 */     GIR_EraseRootFromParent_Done,
     /*   93201 */   // Label 1477: @93201
     /*   93201 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(93290), // Rule ID 51647 //
     /*   93206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93221 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93240 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93249 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93288 */     GIR_RootConstrainSelectedInstOperands,
     /*   93289 */     // GIR_Coverage, 51647,
     /*   93289 */     GIR_EraseRootFromParent_Done,
     /*   93290 */   // Label 1478: @93290
     /*   93290 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(93379), // Rule ID 70532 //
     /*   93295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93310 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93329 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93338 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93377 */     GIR_RootConstrainSelectedInstOperands,
     /*   93378 */     // GIR_Coverage, 70532,
     /*   93378 */     GIR_EraseRootFromParent_Done,
     /*   93379 */   // Label 1479: @93379
     /*   93379 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(93468), // Rule ID 70533 //
     /*   93384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93399 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93418 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93427 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93466 */     GIR_RootConstrainSelectedInstOperands,
     /*   93467 */     // GIR_Coverage, 70533,
     /*   93467 */     GIR_EraseRootFromParent_Done,
     /*   93468 */   // Label 1480: @93468
     /*   93468 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(93557), // Rule ID 70412 //
     /*   93473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93488 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93507 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93516 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93555 */     GIR_RootConstrainSelectedInstOperands,
     /*   93556 */     // GIR_Coverage, 70412,
     /*   93556 */     GIR_EraseRootFromParent_Done,
     /*   93557 */   // Label 1481: @93557
     /*   93557 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(93646), // Rule ID 70413 //
     /*   93562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93577 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93596 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93605 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93644 */     GIR_RootConstrainSelectedInstOperands,
     /*   93645 */     // GIR_Coverage, 70413,
     /*   93645 */     GIR_EraseRootFromParent_Done,
     /*   93646 */   // Label 1482: @93646
     /*   93646 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(93735), // Rule ID 51826 //
     /*   93651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93685 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93694 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93733 */     GIR_RootConstrainSelectedInstOperands,
     /*   93734 */     // GIR_Coverage, 51826,
     /*   93734 */     GIR_EraseRootFromParent_Done,
     /*   93735 */   // Label 1483: @93735
     /*   93735 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(93824), // Rule ID 51827 //
     /*   93740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93755 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93774 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93783 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93822 */     GIR_RootConstrainSelectedInstOperands,
     /*   93823 */     // GIR_Coverage, 51827,
     /*   93823 */     GIR_EraseRootFromParent_Done,
     /*   93824 */   // Label 1484: @93824
     /*   93824 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(93913), // Rule ID 51526 //
     /*   93829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93844 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93863 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93872 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   93889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93911 */     GIR_RootConstrainSelectedInstOperands,
     /*   93912 */     // GIR_Coverage, 51526,
     /*   93912 */     GIR_EraseRootFromParent_Done,
     /*   93913 */   // Label 1485: @93913
     /*   93913 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(94002), // Rule ID 51527 //
     /*   93918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93933 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93952 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93961 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   93978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94000 */     GIR_RootConstrainSelectedInstOperands,
     /*   94001 */     // GIR_Coverage, 51527,
     /*   94001 */     GIR_EraseRootFromParent_Done,
     /*   94002 */   // Label 1486: @94002
     /*   94002 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(94091), // Rule ID 51766 //
     /*   94007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94022 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94041 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94050 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94089 */     GIR_RootConstrainSelectedInstOperands,
     /*   94090 */     // GIR_Coverage, 51766,
     /*   94090 */     GIR_EraseRootFromParent_Done,
     /*   94091 */   // Label 1487: @94091
     /*   94091 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(94180), // Rule ID 51767 //
     /*   94096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94111 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94130 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94139 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94178 */     GIR_RootConstrainSelectedInstOperands,
     /*   94179 */     // GIR_Coverage, 51767,
     /*   94179 */     GIR_EraseRootFromParent_Done,
     /*   94180 */   // Label 1488: @94180
     /*   94180 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(94269), // Rule ID 51706 //
     /*   94185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94200 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94219 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94228 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94267 */     GIR_RootConstrainSelectedInstOperands,
     /*   94268 */     // GIR_Coverage, 51706,
     /*   94268 */     GIR_EraseRootFromParent_Done,
     /*   94269 */   // Label 1489: @94269
     /*   94269 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(94358), // Rule ID 51707 //
     /*   94274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94289 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94308 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94317 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94356 */     GIR_RootConstrainSelectedInstOperands,
     /*   94357 */     // GIR_Coverage, 51707,
     /*   94357 */     GIR_EraseRootFromParent_Done,
     /*   94358 */   // Label 1490: @94358
     /*   94358 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(94447), // Rule ID 70472 //
     /*   94363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94378 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94397 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94406 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94445 */     GIR_RootConstrainSelectedInstOperands,
     /*   94446 */     // GIR_Coverage, 70472,
     /*   94446 */     GIR_EraseRootFromParent_Done,
     /*   94447 */   // Label 1491: @94447
     /*   94447 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(94536), // Rule ID 70473 //
     /*   94452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94467 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94486 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94495 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94534 */     GIR_RootConstrainSelectedInstOperands,
     /*   94535 */     // GIR_Coverage, 70473,
     /*   94535 */     GIR_EraseRootFromParent_Done,
     /*   94536 */   // Label 1492: @94536
     /*   94536 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(94625), // Rule ID 51586 //
     /*   94541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94575 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94584 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94623 */     GIR_RootConstrainSelectedInstOperands,
     /*   94624 */     // GIR_Coverage, 51586,
     /*   94624 */     GIR_EraseRootFromParent_Done,
     /*   94625 */   // Label 1493: @94625
     /*   94625 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(94714), // Rule ID 51587 //
     /*   94630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94645 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94664 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94673 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94712 */     GIR_RootConstrainSelectedInstOperands,
     /*   94713 */     // GIR_Coverage, 51587,
     /*   94713 */     GIR_EraseRootFromParent_Done,
     /*   94714 */   // Label 1494: @94714
     /*   94714 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(94767), // Rule ID 50912 //
     /*   94719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94730 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   94730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   94747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   94754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   94756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   94762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94765 */     GIR_RootConstrainSelectedInstOperands,
     /*   94766 */     // GIR_Coverage, 50912,
     /*   94766 */     GIR_EraseRootFromParent_Done,
     /*   94767 */   // Label 1495: @94767
     /*   94767 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(94820), // Rule ID 50913 //
     /*   94772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94783 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   94783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   94800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   94807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   94809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   94815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94818 */     GIR_RootConstrainSelectedInstOperands,
     /*   94819 */     // GIR_Coverage, 50913,
     /*   94819 */     GIR_EraseRootFromParent_Done,
     /*   94820 */   // Label 1496: @94820
     /*   94820 */   GIM_Reject,
     /*   94821 */ // Label 1476: @94821
     /*   94821 */ GIM_Reject,
     /*   94822 */ // Label 1303: @94822
     /*   94822 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(96546),
     /*   94827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   94830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   94833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   94837 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(94926), // Rule ID 51666 //
     /*   94842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   94845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94857 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94876 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94885 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   94885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   94888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   94902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   94921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94924 */     GIR_RootConstrainSelectedInstOperands,
     /*   94925 */     // GIR_Coverage, 51666,
     /*   94925 */     GIR_EraseRootFromParent_Done,
     /*   94926 */   // Label 1498: @94926
     /*   94926 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(95015), // Rule ID 51667 //
     /*   94931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   94934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94965 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94974 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   94974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   94977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   94991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95013 */     GIR_RootConstrainSelectedInstOperands,
     /*   95014 */     // GIR_Coverage, 51667,
     /*   95014 */     GIR_EraseRootFromParent_Done,
     /*   95015 */   // Label 1499: @95015
     /*   95015 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(95104), // Rule ID 70552 //
     /*   95020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95035 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95054 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95063 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95102 */     GIR_RootConstrainSelectedInstOperands,
     /*   95103 */     // GIR_Coverage, 70552,
     /*   95103 */     GIR_EraseRootFromParent_Done,
     /*   95104 */   // Label 1500: @95104
     /*   95104 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(95193), // Rule ID 70553 //
     /*   95109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95124 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95143 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95152 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95191 */     GIR_RootConstrainSelectedInstOperands,
     /*   95192 */     // GIR_Coverage, 70553,
     /*   95192 */     GIR_EraseRootFromParent_Done,
     /*   95193 */   // Label 1501: @95193
     /*   95193 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(95282), // Rule ID 70432 //
     /*   95198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95213 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95232 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95241 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95280 */     GIR_RootConstrainSelectedInstOperands,
     /*   95281 */     // GIR_Coverage, 70432,
     /*   95281 */     GIR_EraseRootFromParent_Done,
     /*   95282 */   // Label 1502: @95282
     /*   95282 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(95371), // Rule ID 70433 //
     /*   95287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95302 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95321 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95330 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95369 */     GIR_RootConstrainSelectedInstOperands,
     /*   95370 */     // GIR_Coverage, 70433,
     /*   95370 */     GIR_EraseRootFromParent_Done,
     /*   95371 */   // Label 1503: @95371
     /*   95371 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(95460), // Rule ID 51846 //
     /*   95376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95391 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95410 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95419 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95458 */     GIR_RootConstrainSelectedInstOperands,
     /*   95459 */     // GIR_Coverage, 51846,
     /*   95459 */     GIR_EraseRootFromParent_Done,
     /*   95460 */   // Label 1504: @95460
     /*   95460 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(95549), // Rule ID 51847 //
     /*   95465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95480 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95499 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95508 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95547 */     GIR_RootConstrainSelectedInstOperands,
     /*   95548 */     // GIR_Coverage, 51847,
     /*   95548 */     GIR_EraseRootFromParent_Done,
     /*   95549 */   // Label 1505: @95549
     /*   95549 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(95638), // Rule ID 51546 //
     /*   95554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95569 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95588 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95597 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   95614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95636 */     GIR_RootConstrainSelectedInstOperands,
     /*   95637 */     // GIR_Coverage, 51546,
     /*   95637 */     GIR_EraseRootFromParent_Done,
     /*   95638 */   // Label 1506: @95638
     /*   95638 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(95727), // Rule ID 51547 //
     /*   95643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95658 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95677 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95686 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   95703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95725 */     GIR_RootConstrainSelectedInstOperands,
     /*   95726 */     // GIR_Coverage, 51547,
     /*   95726 */     GIR_EraseRootFromParent_Done,
     /*   95727 */   // Label 1507: @95727
     /*   95727 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(95816), // Rule ID 51786 //
     /*   95732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95747 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95766 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95775 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95814 */     GIR_RootConstrainSelectedInstOperands,
     /*   95815 */     // GIR_Coverage, 51786,
     /*   95815 */     GIR_EraseRootFromParent_Done,
     /*   95816 */   // Label 1508: @95816
     /*   95816 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(95905), // Rule ID 51787 //
     /*   95821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95855 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95864 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95903 */     GIR_RootConstrainSelectedInstOperands,
     /*   95904 */     // GIR_Coverage, 51787,
     /*   95904 */     GIR_EraseRootFromParent_Done,
     /*   95905 */   // Label 1509: @95905
     /*   95905 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(95994), // Rule ID 51726 //
     /*   95910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95925 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95944 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95953 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95992 */     GIR_RootConstrainSelectedInstOperands,
     /*   95993 */     // GIR_Coverage, 51726,
     /*   95993 */     GIR_EraseRootFromParent_Done,
     /*   95994 */   // Label 1510: @95994
     /*   95994 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(96083), // Rule ID 51727 //
     /*   95999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96014 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96033 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96042 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96081 */     GIR_RootConstrainSelectedInstOperands,
     /*   96082 */     // GIR_Coverage, 51727,
     /*   96082 */     GIR_EraseRootFromParent_Done,
     /*   96083 */   // Label 1511: @96083
     /*   96083 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(96172), // Rule ID 70492 //
     /*   96088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96103 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96122 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96131 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96170 */     GIR_RootConstrainSelectedInstOperands,
     /*   96171 */     // GIR_Coverage, 70492,
     /*   96171 */     GIR_EraseRootFromParent_Done,
     /*   96172 */   // Label 1512: @96172
     /*   96172 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(96261), // Rule ID 70493 //
     /*   96177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96192 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96211 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96220 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96259 */     GIR_RootConstrainSelectedInstOperands,
     /*   96260 */     // GIR_Coverage, 70493,
     /*   96260 */     GIR_EraseRootFromParent_Done,
     /*   96261 */   // Label 1513: @96261
     /*   96261 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(96350), // Rule ID 51606 //
     /*   96266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96281 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96300 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96309 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96348 */     GIR_RootConstrainSelectedInstOperands,
     /*   96349 */     // GIR_Coverage, 51606,
     /*   96349 */     GIR_EraseRootFromParent_Done,
     /*   96350 */   // Label 1514: @96350
     /*   96350 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(96439), // Rule ID 51607 //
     /*   96355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96370 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96389 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96398 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96437 */     GIR_RootConstrainSelectedInstOperands,
     /*   96438 */     // GIR_Coverage, 51607,
     /*   96438 */     GIR_EraseRootFromParent_Done,
     /*   96439 */   // Label 1515: @96439
     /*   96439 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(96492), // Rule ID 50928 //
     /*   96444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   96447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96455 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   96455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   96472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   96487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96490 */     GIR_RootConstrainSelectedInstOperands,
     /*   96491 */     // GIR_Coverage, 50928,
     /*   96491 */     GIR_EraseRootFromParent_Done,
     /*   96492 */   // Label 1516: @96492
     /*   96492 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(96545), // Rule ID 50929 //
     /*   96497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   96500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96508 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   96508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   96525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   96540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96543 */     GIR_RootConstrainSelectedInstOperands,
     /*   96544 */     // GIR_Coverage, 50929,
     /*   96544 */     GIR_EraseRootFromParent_Done,
     /*   96545 */   // Label 1517: @96545
     /*   96545 */   GIM_Reject,
     /*   96546 */ // Label 1497: @96546
     /*   96546 */ GIM_Reject,
     /*   96547 */ // Label 1304: @96547
     /*   96547 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(96661),
     /*   96552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   96558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96570 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(96615), // Rule ID 50872 //
     /*   96575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   96578 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   96578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   96581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   96595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96613 */     GIR_RootConstrainSelectedInstOperands,
     /*   96614 */     // GIR_Coverage, 50872,
     /*   96614 */     GIR_EraseRootFromParent_Done,
     /*   96615 */   // Label 1519: @96615
     /*   96615 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(96660), // Rule ID 50873 //
     /*   96620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   96623 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   96623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   96626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   96640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96658 */     GIR_RootConstrainSelectedInstOperands,
     /*   96659 */     // GIR_Coverage, 50873,
     /*   96659 */     GIR_EraseRootFromParent_Done,
     /*   96660 */   // Label 1520: @96660
     /*   96660 */   GIM_Reject,
     /*   96661 */ // Label 1518: @96661
     /*   96661 */ GIM_Reject,
     /*   96662 */ // Label 1305: @96662
     /*   96662 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(98386),
     /*   96667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   96670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   96673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96677 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(96766), // Rule ID 51626 //
     /*   96682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   96685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96716 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96725 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   96725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   96742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96764 */     GIR_RootConstrainSelectedInstOperands,
     /*   96765 */     // GIR_Coverage, 51626,
     /*   96765 */     GIR_EraseRootFromParent_Done,
     /*   96766 */   // Label 1522: @96766
     /*   96766 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(96855), // Rule ID 51627 //
     /*   96771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   96774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96805 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96814 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   96814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   96831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96853 */     GIR_RootConstrainSelectedInstOperands,
     /*   96854 */     // GIR_Coverage, 51627,
     /*   96854 */     GIR_EraseRootFromParent_Done,
     /*   96855 */   // Label 1523: @96855
     /*   96855 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(96944), // Rule ID 70512 //
     /*   96860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   96863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96875 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96894 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96903 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   96903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   96920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96942 */     GIR_RootConstrainSelectedInstOperands,
     /*   96943 */     // GIR_Coverage, 70512,
     /*   96943 */     GIR_EraseRootFromParent_Done,
     /*   96944 */   // Label 1524: @96944
     /*   96944 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(97033), // Rule ID 70513 //
     /*   96949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   96952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96964 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96983 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96992 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   96992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97031 */     GIR_RootConstrainSelectedInstOperands,
     /*   97032 */     // GIR_Coverage, 70513,
     /*   97032 */     GIR_EraseRootFromParent_Done,
     /*   97033 */   // Label 1525: @97033
     /*   97033 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(97122), // Rule ID 70392 //
     /*   97038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97053 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97072 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97081 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97120 */     GIR_RootConstrainSelectedInstOperands,
     /*   97121 */     // GIR_Coverage, 70392,
     /*   97121 */     GIR_EraseRootFromParent_Done,
     /*   97122 */   // Label 1526: @97122
     /*   97122 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(97211), // Rule ID 70393 //
     /*   97127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97142 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97161 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97170 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97209 */     GIR_RootConstrainSelectedInstOperands,
     /*   97210 */     // GIR_Coverage, 70393,
     /*   97210 */     GIR_EraseRootFromParent_Done,
     /*   97211 */   // Label 1527: @97211
     /*   97211 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(97300), // Rule ID 51806 //
     /*   97216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97231 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97250 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97259 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97298 */     GIR_RootConstrainSelectedInstOperands,
     /*   97299 */     // GIR_Coverage, 51806,
     /*   97299 */     GIR_EraseRootFromParent_Done,
     /*   97300 */   // Label 1528: @97300
     /*   97300 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(97389), // Rule ID 51807 //
     /*   97305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97320 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97339 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97348 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97387 */     GIR_RootConstrainSelectedInstOperands,
     /*   97388 */     // GIR_Coverage, 51807,
     /*   97388 */     GIR_EraseRootFromParent_Done,
     /*   97389 */   // Label 1529: @97389
     /*   97389 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(97478), // Rule ID 51506 //
     /*   97394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97409 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97428 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97437 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   97454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97476 */     GIR_RootConstrainSelectedInstOperands,
     /*   97477 */     // GIR_Coverage, 51506,
     /*   97477 */     GIR_EraseRootFromParent_Done,
     /*   97478 */   // Label 1530: @97478
     /*   97478 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(97567), // Rule ID 51507 //
     /*   97483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97498 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97517 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97526 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   97543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97565 */     GIR_RootConstrainSelectedInstOperands,
     /*   97566 */     // GIR_Coverage, 51507,
     /*   97566 */     GIR_EraseRootFromParent_Done,
     /*   97567 */   // Label 1531: @97567
     /*   97567 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(97656), // Rule ID 51746 //
     /*   97572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97587 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97606 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97615 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97654 */     GIR_RootConstrainSelectedInstOperands,
     /*   97655 */     // GIR_Coverage, 51746,
     /*   97655 */     GIR_EraseRootFromParent_Done,
     /*   97656 */   // Label 1532: @97656
     /*   97656 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(97745), // Rule ID 51747 //
     /*   97661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97695 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97704 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97743 */     GIR_RootConstrainSelectedInstOperands,
     /*   97744 */     // GIR_Coverage, 51747,
     /*   97744 */     GIR_EraseRootFromParent_Done,
     /*   97745 */   // Label 1533: @97745
     /*   97745 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(97834), // Rule ID 51686 //
     /*   97750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97765 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97784 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97793 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97832 */     GIR_RootConstrainSelectedInstOperands,
     /*   97833 */     // GIR_Coverage, 51686,
     /*   97833 */     GIR_EraseRootFromParent_Done,
     /*   97834 */   // Label 1534: @97834
     /*   97834 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(97923), // Rule ID 51687 //
     /*   97839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97873 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97882 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97921 */     GIR_RootConstrainSelectedInstOperands,
     /*   97922 */     // GIR_Coverage, 51687,
     /*   97922 */     GIR_EraseRootFromParent_Done,
     /*   97923 */   // Label 1535: @97923
     /*   97923 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(98012), // Rule ID 70452 //
     /*   97928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97943 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97962 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97971 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98010 */     GIR_RootConstrainSelectedInstOperands,
     /*   98011 */     // GIR_Coverage, 70452,
     /*   98011 */     GIR_EraseRootFromParent_Done,
     /*   98012 */   // Label 1536: @98012
     /*   98012 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(98101), // Rule ID 70453 //
     /*   98017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98032 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98051 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98060 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   98077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98099 */     GIR_RootConstrainSelectedInstOperands,
     /*   98100 */     // GIR_Coverage, 70453,
     /*   98100 */     GIR_EraseRootFromParent_Done,
     /*   98101 */   // Label 1537: @98101
     /*   98101 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(98190), // Rule ID 51566 //
     /*   98106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98140 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98149 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98188 */     GIR_RootConstrainSelectedInstOperands,
     /*   98189 */     // GIR_Coverage, 51566,
     /*   98189 */     GIR_EraseRootFromParent_Done,
     /*   98190 */   // Label 1538: @98190
     /*   98190 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(98279), // Rule ID 51567 //
     /*   98195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98229 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98238 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98277 */     GIR_RootConstrainSelectedInstOperands,
     /*   98278 */     // GIR_Coverage, 51567,
     /*   98278 */     GIR_EraseRootFromParent_Done,
     /*   98279 */   // Label 1539: @98279
     /*   98279 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(98332), // Rule ID 50900 //
     /*   98284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98295 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   98312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   98319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   98321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98330 */     GIR_RootConstrainSelectedInstOperands,
     /*   98331 */     // GIR_Coverage, 50900,
     /*   98331 */     GIR_EraseRootFromParent_Done,
     /*   98332 */   // Label 1540: @98332
     /*   98332 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(98385), // Rule ID 50901 //
     /*   98337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98348 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   98365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   98372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   98374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98383 */     GIR_RootConstrainSelectedInstOperands,
     /*   98384 */     // GIR_Coverage, 50901,
     /*   98384 */     GIR_EraseRootFromParent_Done,
     /*   98385 */   // Label 1541: @98385
     /*   98385 */   GIM_Reject,
     /*   98386 */ // Label 1521: @98386
     /*   98386 */ GIM_Reject,
     /*   98387 */ // Label 1306: @98387
     /*   98387 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(100111),
     /*   98392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   98395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   98398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   98402 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(98491), // Rule ID 51650 //
     /*   98407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98422 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98441 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98450 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98489 */     GIR_RootConstrainSelectedInstOperands,
     /*   98490 */     // GIR_Coverage, 51650,
     /*   98490 */     GIR_EraseRootFromParent_Done,
     /*   98491 */   // Label 1543: @98491
     /*   98491 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(98580), // Rule ID 51651 //
     /*   98496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98511 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98530 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98539 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98578 */     GIR_RootConstrainSelectedInstOperands,
     /*   98579 */     // GIR_Coverage, 51651,
     /*   98579 */     GIR_EraseRootFromParent_Done,
     /*   98580 */   // Label 1544: @98580
     /*   98580 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(98669), // Rule ID 70536 //
     /*   98585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98600 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98619 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98628 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98667 */     GIR_RootConstrainSelectedInstOperands,
     /*   98668 */     // GIR_Coverage, 70536,
     /*   98668 */     GIR_EraseRootFromParent_Done,
     /*   98669 */   // Label 1545: @98669
     /*   98669 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(98758), // Rule ID 70537 //
     /*   98674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98708 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98717 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98756 */     GIR_RootConstrainSelectedInstOperands,
     /*   98757 */     // GIR_Coverage, 70537,
     /*   98757 */     GIR_EraseRootFromParent_Done,
     /*   98758 */   // Label 1546: @98758
     /*   98758 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(98847), // Rule ID 70416 //
     /*   98763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98778 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98797 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98799 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98806 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98845 */     GIR_RootConstrainSelectedInstOperands,
     /*   98846 */     // GIR_Coverage, 70416,
     /*   98846 */     GIR_EraseRootFromParent_Done,
     /*   98847 */   // Label 1547: @98847
     /*   98847 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(98936), // Rule ID 70417 //
     /*   98852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98867 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98886 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98895 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98934 */     GIR_RootConstrainSelectedInstOperands,
     /*   98935 */     // GIR_Coverage, 70417,
     /*   98935 */     GIR_EraseRootFromParent_Done,
     /*   98936 */   // Label 1548: @98936
     /*   98936 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(99025), // Rule ID 51830 //
     /*   98941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98975 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98984 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99023 */     GIR_RootConstrainSelectedInstOperands,
     /*   99024 */     // GIR_Coverage, 51830,
     /*   99024 */     GIR_EraseRootFromParent_Done,
     /*   99025 */   // Label 1549: @99025
     /*   99025 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(99114), // Rule ID 51831 //
     /*   99030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99045 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99064 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99073 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99112 */     GIR_RootConstrainSelectedInstOperands,
     /*   99113 */     // GIR_Coverage, 51831,
     /*   99113 */     GIR_EraseRootFromParent_Done,
     /*   99114 */   // Label 1550: @99114
     /*   99114 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(99203), // Rule ID 51530 //
     /*   99119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99153 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99162 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   99179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99201 */     GIR_RootConstrainSelectedInstOperands,
     /*   99202 */     // GIR_Coverage, 51530,
     /*   99202 */     GIR_EraseRootFromParent_Done,
     /*   99203 */   // Label 1551: @99203
     /*   99203 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(99292), // Rule ID 51531 //
     /*   99208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99223 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99242 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99251 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   99268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99290 */     GIR_RootConstrainSelectedInstOperands,
     /*   99291 */     // GIR_Coverage, 51531,
     /*   99291 */     GIR_EraseRootFromParent_Done,
     /*   99292 */   // Label 1552: @99292
     /*   99292 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(99381), // Rule ID 51770 //
     /*   99297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99331 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99340 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99379 */     GIR_RootConstrainSelectedInstOperands,
     /*   99380 */     // GIR_Coverage, 51770,
     /*   99380 */     GIR_EraseRootFromParent_Done,
     /*   99381 */   // Label 1553: @99381
     /*   99381 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(99470), // Rule ID 51771 //
     /*   99386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99429 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99468 */     GIR_RootConstrainSelectedInstOperands,
     /*   99469 */     // GIR_Coverage, 51771,
     /*   99469 */     GIR_EraseRootFromParent_Done,
     /*   99470 */   // Label 1554: @99470
     /*   99470 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(99559), // Rule ID 51710 //
     /*   99475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99490 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99509 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99518 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99557 */     GIR_RootConstrainSelectedInstOperands,
     /*   99558 */     // GIR_Coverage, 51710,
     /*   99558 */     GIR_EraseRootFromParent_Done,
     /*   99559 */   // Label 1555: @99559
     /*   99559 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(99648), // Rule ID 51711 //
     /*   99564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99579 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99598 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99607 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99646 */     GIR_RootConstrainSelectedInstOperands,
     /*   99647 */     // GIR_Coverage, 51711,
     /*   99647 */     GIR_EraseRootFromParent_Done,
     /*   99648 */   // Label 1556: @99648
     /*   99648 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(99737), // Rule ID 70476 //
     /*   99653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99668 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99687 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99696 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99735 */     GIR_RootConstrainSelectedInstOperands,
     /*   99736 */     // GIR_Coverage, 70476,
     /*   99736 */     GIR_EraseRootFromParent_Done,
     /*   99737 */   // Label 1557: @99737
     /*   99737 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(99826), // Rule ID 70477 //
     /*   99742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99757 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99776 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99785 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99824 */     GIR_RootConstrainSelectedInstOperands,
     /*   99825 */     // GIR_Coverage, 70477,
     /*   99825 */     GIR_EraseRootFromParent_Done,
     /*   99826 */   // Label 1558: @99826
     /*   99826 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(99915), // Rule ID 51590 //
     /*   99831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99865 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99874 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99913 */     GIR_RootConstrainSelectedInstOperands,
     /*   99914 */     // GIR_Coverage, 51590,
     /*   99914 */     GIR_EraseRootFromParent_Done,
     /*   99915 */   // Label 1559: @99915
     /*   99915 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(100004), // Rule ID 51591 //
     /*   99920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99935 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99954 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99963 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100002 */     GIR_RootConstrainSelectedInstOperands,
     /*  100003 */     // GIR_Coverage, 51591,
     /*  100003 */     GIR_EraseRootFromParent_Done,
     /*  100004 */   // Label 1560: @100004
     /*  100004 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(100057), // Rule ID 50916 //
     /*  100009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100020 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  100037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  100044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  100046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100055 */     GIR_RootConstrainSelectedInstOperands,
     /*  100056 */     // GIR_Coverage, 50916,
     /*  100056 */     GIR_EraseRootFromParent_Done,
     /*  100057 */   // Label 1561: @100057
     /*  100057 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(100110), // Rule ID 50917 //
     /*  100062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100073 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  100090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  100097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  100099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100108 */     GIR_RootConstrainSelectedInstOperands,
     /*  100109 */     // GIR_Coverage, 50917,
     /*  100109 */     GIR_EraseRootFromParent_Done,
     /*  100110 */   // Label 1562: @100110
     /*  100110 */   GIM_Reject,
     /*  100111 */ // Label 1542: @100111
     /*  100111 */ GIM_Reject,
     /*  100112 */ // Label 1307: @100112
     /*  100112 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(101836),
     /*  100117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  100120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  100123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  100127 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(100216), // Rule ID 51670 //
     /*  100132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100147 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100166 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100175 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100214 */     GIR_RootConstrainSelectedInstOperands,
     /*  100215 */     // GIR_Coverage, 51670,
     /*  100215 */     GIR_EraseRootFromParent_Done,
     /*  100216 */   // Label 1564: @100216
     /*  100216 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(100305), // Rule ID 51671 //
     /*  100221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100236 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100255 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100264 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100303 */     GIR_RootConstrainSelectedInstOperands,
     /*  100304 */     // GIR_Coverage, 51671,
     /*  100304 */     GIR_EraseRootFromParent_Done,
     /*  100305 */   // Label 1565: @100305
     /*  100305 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(100394), // Rule ID 70556 //
     /*  100310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100325 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100344 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100353 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100392 */     GIR_RootConstrainSelectedInstOperands,
     /*  100393 */     // GIR_Coverage, 70556,
     /*  100393 */     GIR_EraseRootFromParent_Done,
     /*  100394 */   // Label 1566: @100394
     /*  100394 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(100483), // Rule ID 70557 //
     /*  100399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100414 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100433 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100442 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100481 */     GIR_RootConstrainSelectedInstOperands,
     /*  100482 */     // GIR_Coverage, 70557,
     /*  100482 */     GIR_EraseRootFromParent_Done,
     /*  100483 */   // Label 1567: @100483
     /*  100483 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(100572), // Rule ID 70436 //
     /*  100488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100503 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100522 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100531 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100570 */     GIR_RootConstrainSelectedInstOperands,
     /*  100571 */     // GIR_Coverage, 70436,
     /*  100571 */     GIR_EraseRootFromParent_Done,
     /*  100572 */   // Label 1568: @100572
     /*  100572 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(100661), // Rule ID 70437 //
     /*  100577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100592 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100611 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100620 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100659 */     GIR_RootConstrainSelectedInstOperands,
     /*  100660 */     // GIR_Coverage, 70437,
     /*  100660 */     GIR_EraseRootFromParent_Done,
     /*  100661 */   // Label 1569: @100661
     /*  100661 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(100750), // Rule ID 51850 //
     /*  100666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100681 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100700 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100709 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100748 */     GIR_RootConstrainSelectedInstOperands,
     /*  100749 */     // GIR_Coverage, 51850,
     /*  100749 */     GIR_EraseRootFromParent_Done,
     /*  100750 */   // Label 1570: @100750
     /*  100750 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(100839), // Rule ID 51851 //
     /*  100755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100770 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100789 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100798 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100837 */     GIR_RootConstrainSelectedInstOperands,
     /*  100838 */     // GIR_Coverage, 51851,
     /*  100838 */     GIR_EraseRootFromParent_Done,
     /*  100839 */   // Label 1571: @100839
     /*  100839 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(100928), // Rule ID 51550 //
     /*  100844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100859 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100878 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100887 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  100904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100926 */     GIR_RootConstrainSelectedInstOperands,
     /*  100927 */     // GIR_Coverage, 51550,
     /*  100927 */     GIR_EraseRootFromParent_Done,
     /*  100928 */   // Label 1572: @100928
     /*  100928 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(101017), // Rule ID 51551 //
     /*  100933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100948 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100967 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100976 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  100993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101015 */     GIR_RootConstrainSelectedInstOperands,
     /*  101016 */     // GIR_Coverage, 51551,
     /*  101016 */     GIR_EraseRootFromParent_Done,
     /*  101017 */   // Label 1573: @101017
     /*  101017 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(101106), // Rule ID 51790 //
     /*  101022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101037 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101056 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101065 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101104 */     GIR_RootConstrainSelectedInstOperands,
     /*  101105 */     // GIR_Coverage, 51790,
     /*  101105 */     GIR_EraseRootFromParent_Done,
     /*  101106 */   // Label 1574: @101106
     /*  101106 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(101195), // Rule ID 51791 //
     /*  101111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101145 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101154 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101193 */     GIR_RootConstrainSelectedInstOperands,
     /*  101194 */     // GIR_Coverage, 51791,
     /*  101194 */     GIR_EraseRootFromParent_Done,
     /*  101195 */   // Label 1575: @101195
     /*  101195 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(101284), // Rule ID 51730 //
     /*  101200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101215 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101234 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101243 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101282 */     GIR_RootConstrainSelectedInstOperands,
     /*  101283 */     // GIR_Coverage, 51730,
     /*  101283 */     GIR_EraseRootFromParent_Done,
     /*  101284 */   // Label 1576: @101284
     /*  101284 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(101373), // Rule ID 51731 //
     /*  101289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101304 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101323 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101332 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101371 */     GIR_RootConstrainSelectedInstOperands,
     /*  101372 */     // GIR_Coverage, 51731,
     /*  101372 */     GIR_EraseRootFromParent_Done,
     /*  101373 */   // Label 1577: @101373
     /*  101373 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(101462), // Rule ID 70496 //
     /*  101378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101393 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101412 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101421 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101460 */     GIR_RootConstrainSelectedInstOperands,
     /*  101461 */     // GIR_Coverage, 70496,
     /*  101461 */     GIR_EraseRootFromParent_Done,
     /*  101462 */   // Label 1578: @101462
     /*  101462 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(101551), // Rule ID 70497 //
     /*  101467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101482 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101501 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101503 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101510 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101549 */     GIR_RootConstrainSelectedInstOperands,
     /*  101550 */     // GIR_Coverage, 70497,
     /*  101550 */     GIR_EraseRootFromParent_Done,
     /*  101551 */   // Label 1579: @101551
     /*  101551 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(101640), // Rule ID 51610 //
     /*  101556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101571 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101590 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101599 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101638 */     GIR_RootConstrainSelectedInstOperands,
     /*  101639 */     // GIR_Coverage, 51610,
     /*  101639 */     GIR_EraseRootFromParent_Done,
     /*  101640 */   // Label 1580: @101640
     /*  101640 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(101729), // Rule ID 51611 //
     /*  101645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101660 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101679 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101688 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101727 */     GIR_RootConstrainSelectedInstOperands,
     /*  101728 */     // GIR_Coverage, 51611,
     /*  101728 */     GIR_EraseRootFromParent_Done,
     /*  101729 */   // Label 1581: @101729
     /*  101729 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(101782), // Rule ID 50932 //
     /*  101734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  101737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101745 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  101745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  101762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  101777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101780 */     GIR_RootConstrainSelectedInstOperands,
     /*  101781 */     // GIR_Coverage, 50932,
     /*  101781 */     GIR_EraseRootFromParent_Done,
     /*  101782 */   // Label 1582: @101782
     /*  101782 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(101835), // Rule ID 50933 //
     /*  101787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  101790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101798 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  101798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  101815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  101830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101833 */     GIR_RootConstrainSelectedInstOperands,
     /*  101834 */     // GIR_Coverage, 50933,
     /*  101834 */     GIR_EraseRootFromParent_Done,
     /*  101835 */   // Label 1583: @101835
     /*  101835 */   GIM_Reject,
     /*  101836 */ // Label 1563: @101836
     /*  101836 */ GIM_Reject,
     /*  101837 */ // Label 1308: @101837
     /*  101837 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(101951),
     /*  101842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  101845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  101848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101860 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(101905), // Rule ID 50888 //
     /*  101865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101868 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  101868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  101871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  101885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101903 */     GIR_RootConstrainSelectedInstOperands,
     /*  101904 */     // GIR_Coverage, 50888,
     /*  101904 */     GIR_EraseRootFromParent_Done,
     /*  101905 */   // Label 1585: @101905
     /*  101905 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(101950), // Rule ID 50889 //
     /*  101910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  101913 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  101913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  101916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  101930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101948 */     GIR_RootConstrainSelectedInstOperands,
     /*  101949 */     // GIR_Coverage, 50889,
     /*  101949 */     GIR_EraseRootFromParent_Done,
     /*  101950 */   // Label 1586: @101950
     /*  101950 */   GIM_Reject,
     /*  101951 */ // Label 1584: @101951
     /*  101951 */ GIM_Reject,
     /*  101952 */ // Label 1309: @101952
     /*  101952 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(103676),
     /*  101957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  101960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  101963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101967 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(102056), // Rule ID 51630 //
     /*  101972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  101987 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102006 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102015 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102054 */     GIR_RootConstrainSelectedInstOperands,
     /*  102055 */     // GIR_Coverage, 51630,
     /*  102055 */     GIR_EraseRootFromParent_Done,
     /*  102056 */   // Label 1588: @102056
     /*  102056 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(102145), // Rule ID 51631 //
     /*  102061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102095 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102104 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102143 */     GIR_RootConstrainSelectedInstOperands,
     /*  102144 */     // GIR_Coverage, 51631,
     /*  102144 */     GIR_EraseRootFromParent_Done,
     /*  102145 */   // Label 1589: @102145
     /*  102145 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(102234), // Rule ID 70516 //
     /*  102150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102184 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102193 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102232 */     GIR_RootConstrainSelectedInstOperands,
     /*  102233 */     // GIR_Coverage, 70516,
     /*  102233 */     GIR_EraseRootFromParent_Done,
     /*  102234 */   // Label 1590: @102234
     /*  102234 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(102323), // Rule ID 70517 //
     /*  102239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102254 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102273 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102282 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102321 */     GIR_RootConstrainSelectedInstOperands,
     /*  102322 */     // GIR_Coverage, 70517,
     /*  102322 */     GIR_EraseRootFromParent_Done,
     /*  102323 */   // Label 1591: @102323
     /*  102323 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(102412), // Rule ID 70396 //
     /*  102328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102343 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102362 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102371 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102410 */     GIR_RootConstrainSelectedInstOperands,
     /*  102411 */     // GIR_Coverage, 70396,
     /*  102411 */     GIR_EraseRootFromParent_Done,
     /*  102412 */   // Label 1592: @102412
     /*  102412 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(102501), // Rule ID 70397 //
     /*  102417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102432 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102451 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102460 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102499 */     GIR_RootConstrainSelectedInstOperands,
     /*  102500 */     // GIR_Coverage, 70397,
     /*  102500 */     GIR_EraseRootFromParent_Done,
     /*  102501 */   // Label 1593: @102501
     /*  102501 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(102590), // Rule ID 51810 //
     /*  102506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102540 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102549 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102588 */     GIR_RootConstrainSelectedInstOperands,
     /*  102589 */     // GIR_Coverage, 51810,
     /*  102589 */     GIR_EraseRootFromParent_Done,
     /*  102590 */   // Label 1594: @102590
     /*  102590 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(102679), // Rule ID 51811 //
     /*  102595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102610 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102629 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102638 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102677 */     GIR_RootConstrainSelectedInstOperands,
     /*  102678 */     // GIR_Coverage, 51811,
     /*  102678 */     GIR_EraseRootFromParent_Done,
     /*  102679 */   // Label 1595: @102679
     /*  102679 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(102768), // Rule ID 51510 //
     /*  102684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102699 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102718 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102727 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  102744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102766 */     GIR_RootConstrainSelectedInstOperands,
     /*  102767 */     // GIR_Coverage, 51510,
     /*  102767 */     GIR_EraseRootFromParent_Done,
     /*  102768 */   // Label 1596: @102768
     /*  102768 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(102857), // Rule ID 51511 //
     /*  102773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102807 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102816 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  102833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102855 */     GIR_RootConstrainSelectedInstOperands,
     /*  102856 */     // GIR_Coverage, 51511,
     /*  102856 */     GIR_EraseRootFromParent_Done,
     /*  102857 */   // Label 1597: @102857
     /*  102857 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(102946), // Rule ID 51750 //
     /*  102862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102896 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102905 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102944 */     GIR_RootConstrainSelectedInstOperands,
     /*  102945 */     // GIR_Coverage, 51750,
     /*  102945 */     GIR_EraseRootFromParent_Done,
     /*  102946 */   // Label 1598: @102946
     /*  102946 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(103035), // Rule ID 51751 //
     /*  102951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102985 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102994 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103033 */     GIR_RootConstrainSelectedInstOperands,
     /*  103034 */     // GIR_Coverage, 51751,
     /*  103034 */     GIR_EraseRootFromParent_Done,
     /*  103035 */   // Label 1599: @103035
     /*  103035 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(103124), // Rule ID 51690 //
     /*  103040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103055 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103074 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103083 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103122 */     GIR_RootConstrainSelectedInstOperands,
     /*  103123 */     // GIR_Coverage, 51690,
     /*  103123 */     GIR_EraseRootFromParent_Done,
     /*  103124 */   // Label 1600: @103124
     /*  103124 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(103213), // Rule ID 51691 //
     /*  103129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103144 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103163 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103172 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103211 */     GIR_RootConstrainSelectedInstOperands,
     /*  103212 */     // GIR_Coverage, 51691,
     /*  103212 */     GIR_EraseRootFromParent_Done,
     /*  103213 */   // Label 1601: @103213
     /*  103213 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(103302), // Rule ID 70456 //
     /*  103218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103233 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103252 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103261 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103300 */     GIR_RootConstrainSelectedInstOperands,
     /*  103301 */     // GIR_Coverage, 70456,
     /*  103301 */     GIR_EraseRootFromParent_Done,
     /*  103302 */   // Label 1602: @103302
     /*  103302 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(103391), // Rule ID 70457 //
     /*  103307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103322 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103341 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103350 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103389 */     GIR_RootConstrainSelectedInstOperands,
     /*  103390 */     // GIR_Coverage, 70457,
     /*  103390 */     GIR_EraseRootFromParent_Done,
     /*  103391 */   // Label 1603: @103391
     /*  103391 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(103480), // Rule ID 51570 //
     /*  103396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103430 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103439 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103478 */     GIR_RootConstrainSelectedInstOperands,
     /*  103479 */     // GIR_Coverage, 51570,
     /*  103479 */     GIR_EraseRootFromParent_Done,
     /*  103480 */   // Label 1604: @103480
     /*  103480 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(103569), // Rule ID 51571 //
     /*  103485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103519 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103528 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103567 */     GIR_RootConstrainSelectedInstOperands,
     /*  103568 */     // GIR_Coverage, 51571,
     /*  103568 */     GIR_EraseRootFromParent_Done,
     /*  103569 */   // Label 1605: @103569
     /*  103569 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(103622), // Rule ID 50904 //
     /*  103574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103585 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  103602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103620 */     GIR_RootConstrainSelectedInstOperands,
     /*  103621 */     // GIR_Coverage, 50904,
     /*  103621 */     GIR_EraseRootFromParent_Done,
     /*  103622 */   // Label 1606: @103622
     /*  103622 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(103675), // Rule ID 50905 //
     /*  103627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103638 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  103638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  103655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103673 */     GIR_RootConstrainSelectedInstOperands,
     /*  103674 */     // GIR_Coverage, 50905,
     /*  103674 */     GIR_EraseRootFromParent_Done,
     /*  103675 */   // Label 1607: @103675
     /*  103675 */   GIM_Reject,
     /*  103676 */ // Label 1587: @103676
     /*  103676 */ GIM_Reject,
     /*  103677 */ // Label 1310: @103677
     /*  103677 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(105401),
     /*  103682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  103685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  103688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  103692 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(103781), // Rule ID 51654 //
     /*  103697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103712 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103731 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103740 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  103743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  103757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103779 */     GIR_RootConstrainSelectedInstOperands,
     /*  103780 */     // GIR_Coverage, 51654,
     /*  103780 */     GIR_EraseRootFromParent_Done,
     /*  103781 */   // Label 1609: @103781
     /*  103781 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(103870), // Rule ID 51655 //
     /*  103786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103801 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103820 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103829 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  103829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  103832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  103846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103868 */     GIR_RootConstrainSelectedInstOperands,
     /*  103869 */     // GIR_Coverage, 51655,
     /*  103869 */     GIR_EraseRootFromParent_Done,
     /*  103870 */   // Label 1610: @103870
     /*  103870 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(103959), // Rule ID 70540 //
     /*  103875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103890 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103909 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103918 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  103921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  103935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103957 */     GIR_RootConstrainSelectedInstOperands,
     /*  103958 */     // GIR_Coverage, 70540,
     /*  103958 */     GIR_EraseRootFromParent_Done,
     /*  103959 */   // Label 1611: @103959
     /*  103959 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(104048), // Rule ID 70541 //
     /*  103964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103979 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103998 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104007 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104046 */     GIR_RootConstrainSelectedInstOperands,
     /*  104047 */     // GIR_Coverage, 70541,
     /*  104047 */     GIR_EraseRootFromParent_Done,
     /*  104048 */   // Label 1612: @104048
     /*  104048 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(104137), // Rule ID 70420 //
     /*  104053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104068 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104087 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104096 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104135 */     GIR_RootConstrainSelectedInstOperands,
     /*  104136 */     // GIR_Coverage, 70420,
     /*  104136 */     GIR_EraseRootFromParent_Done,
     /*  104137 */   // Label 1613: @104137
     /*  104137 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(104226), // Rule ID 70421 //
     /*  104142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104157 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104176 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104185 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104224 */     GIR_RootConstrainSelectedInstOperands,
     /*  104225 */     // GIR_Coverage, 70421,
     /*  104225 */     GIR_EraseRootFromParent_Done,
     /*  104226 */   // Label 1614: @104226
     /*  104226 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(104315), // Rule ID 51834 //
     /*  104231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104265 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104274 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104313 */     GIR_RootConstrainSelectedInstOperands,
     /*  104314 */     // GIR_Coverage, 51834,
     /*  104314 */     GIR_EraseRootFromParent_Done,
     /*  104315 */   // Label 1615: @104315
     /*  104315 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(104404), // Rule ID 51835 //
     /*  104320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104335 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104354 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104363 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104402 */     GIR_RootConstrainSelectedInstOperands,
     /*  104403 */     // GIR_Coverage, 51835,
     /*  104403 */     GIR_EraseRootFromParent_Done,
     /*  104404 */   // Label 1616: @104404
     /*  104404 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(104493), // Rule ID 51534 //
     /*  104409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104443 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104452 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  104469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104491 */     GIR_RootConstrainSelectedInstOperands,
     /*  104492 */     // GIR_Coverage, 51534,
     /*  104492 */     GIR_EraseRootFromParent_Done,
     /*  104493 */   // Label 1617: @104493
     /*  104493 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(104582), // Rule ID 51535 //
     /*  104498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104513 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104532 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104541 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  104558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104580 */     GIR_RootConstrainSelectedInstOperands,
     /*  104581 */     // GIR_Coverage, 51535,
     /*  104581 */     GIR_EraseRootFromParent_Done,
     /*  104582 */   // Label 1618: @104582
     /*  104582 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(104671), // Rule ID 51774 //
     /*  104587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104621 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104630 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104669 */     GIR_RootConstrainSelectedInstOperands,
     /*  104670 */     // GIR_Coverage, 51774,
     /*  104670 */     GIR_EraseRootFromParent_Done,
     /*  104671 */   // Label 1619: @104671
     /*  104671 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(104760), // Rule ID 51775 //
     /*  104676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104691 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104710 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104719 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104758 */     GIR_RootConstrainSelectedInstOperands,
     /*  104759 */     // GIR_Coverage, 51775,
     /*  104759 */     GIR_EraseRootFromParent_Done,
     /*  104760 */   // Label 1620: @104760
     /*  104760 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(104849), // Rule ID 51714 //
     /*  104765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104780 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104799 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104808 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104847 */     GIR_RootConstrainSelectedInstOperands,
     /*  104848 */     // GIR_Coverage, 51714,
     /*  104848 */     GIR_EraseRootFromParent_Done,
     /*  104849 */   // Label 1621: @104849
     /*  104849 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(104938), // Rule ID 51715 //
     /*  104854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104869 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104888 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104897 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104936 */     GIR_RootConstrainSelectedInstOperands,
     /*  104937 */     // GIR_Coverage, 51715,
     /*  104937 */     GIR_EraseRootFromParent_Done,
     /*  104938 */   // Label 1622: @104938
     /*  104938 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(105027), // Rule ID 70480 //
     /*  104943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104958 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104977 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104986 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105025 */     GIR_RootConstrainSelectedInstOperands,
     /*  105026 */     // GIR_Coverage, 70480,
     /*  105026 */     GIR_EraseRootFromParent_Done,
     /*  105027 */   // Label 1623: @105027
     /*  105027 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(105116), // Rule ID 70481 //
     /*  105032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105047 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105066 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105075 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105114 */     GIR_RootConstrainSelectedInstOperands,
     /*  105115 */     // GIR_Coverage, 70481,
     /*  105115 */     GIR_EraseRootFromParent_Done,
     /*  105116 */   // Label 1624: @105116
     /*  105116 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(105205), // Rule ID 51594 //
     /*  105121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105155 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105164 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105203 */     GIR_RootConstrainSelectedInstOperands,
     /*  105204 */     // GIR_Coverage, 51594,
     /*  105204 */     GIR_EraseRootFromParent_Done,
     /*  105205 */   // Label 1625: @105205
     /*  105205 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(105294), // Rule ID 51595 //
     /*  105210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105225 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105244 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105253 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105292 */     GIR_RootConstrainSelectedInstOperands,
     /*  105293 */     // GIR_Coverage, 51595,
     /*  105293 */     GIR_EraseRootFromParent_Done,
     /*  105294 */   // Label 1626: @105294
     /*  105294 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(105347), // Rule ID 50920 //
     /*  105299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105310 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  105310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  105327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105345 */     GIR_RootConstrainSelectedInstOperands,
     /*  105346 */     // GIR_Coverage, 50920,
     /*  105346 */     GIR_EraseRootFromParent_Done,
     /*  105347 */   // Label 1627: @105347
     /*  105347 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(105400), // Rule ID 50921 //
     /*  105352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105363 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  105363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  105380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105398 */     GIR_RootConstrainSelectedInstOperands,
     /*  105399 */     // GIR_Coverage, 50921,
     /*  105399 */     GIR_EraseRootFromParent_Done,
     /*  105400 */   // Label 1628: @105400
     /*  105400 */   GIM_Reject,
     /*  105401 */ // Label 1608: @105401
     /*  105401 */ GIM_Reject,
     /*  105402 */ // Label 1311: @105402
     /*  105402 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(105516),
     /*  105407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  105413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105425 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(105470), // Rule ID 50892 //
     /*  105430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105433 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  105450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105468 */     GIR_RootConstrainSelectedInstOperands,
     /*  105469 */     // GIR_Coverage, 50892,
     /*  105469 */     GIR_EraseRootFromParent_Done,
     /*  105470 */   // Label 1630: @105470
     /*  105470 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(105515), // Rule ID 50893 //
     /*  105475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105478 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  105495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105513 */     GIR_RootConstrainSelectedInstOperands,
     /*  105514 */     // GIR_Coverage, 50893,
     /*  105514 */     GIR_EraseRootFromParent_Done,
     /*  105515 */   // Label 1631: @105515
     /*  105515 */   GIM_Reject,
     /*  105516 */ // Label 1629: @105516
     /*  105516 */ GIM_Reject,
     /*  105517 */ // Label 1312: @105517
     /*  105517 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(107241),
     /*  105522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  105525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  105528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105532 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(105621), // Rule ID 51634 //
     /*  105537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105571 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105580 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105619 */     GIR_RootConstrainSelectedInstOperands,
     /*  105620 */     // GIR_Coverage, 51634,
     /*  105620 */     GIR_EraseRootFromParent_Done,
     /*  105621 */   // Label 1633: @105621
     /*  105621 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(105710), // Rule ID 51635 //
     /*  105626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105641 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105660 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105669 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105708 */     GIR_RootConstrainSelectedInstOperands,
     /*  105709 */     // GIR_Coverage, 51635,
     /*  105709 */     GIR_EraseRootFromParent_Done,
     /*  105710 */   // Label 1634: @105710
     /*  105710 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(105799), // Rule ID 70520 //
     /*  105715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105749 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105758 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105797 */     GIR_RootConstrainSelectedInstOperands,
     /*  105798 */     // GIR_Coverage, 70520,
     /*  105798 */     GIR_EraseRootFromParent_Done,
     /*  105799 */   // Label 1635: @105799
     /*  105799 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(105888), // Rule ID 70521 //
     /*  105804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105819 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105838 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105847 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105886 */     GIR_RootConstrainSelectedInstOperands,
     /*  105887 */     // GIR_Coverage, 70521,
     /*  105887 */     GIR_EraseRootFromParent_Done,
     /*  105888 */   // Label 1636: @105888
     /*  105888 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(105977), // Rule ID 70400 //
     /*  105893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105927 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105936 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105975 */     GIR_RootConstrainSelectedInstOperands,
     /*  105976 */     // GIR_Coverage, 70400,
     /*  105976 */     GIR_EraseRootFromParent_Done,
     /*  105977 */   // Label 1637: @105977
     /*  105977 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(106066), // Rule ID 70401 //
     /*  105982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105997 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106016 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106025 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106064 */     GIR_RootConstrainSelectedInstOperands,
     /*  106065 */     // GIR_Coverage, 70401,
     /*  106065 */     GIR_EraseRootFromParent_Done,
     /*  106066 */   // Label 1638: @106066
     /*  106066 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(106155), // Rule ID 51814 //
     /*  106071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106105 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106114 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106153 */     GIR_RootConstrainSelectedInstOperands,
     /*  106154 */     // GIR_Coverage, 51814,
     /*  106154 */     GIR_EraseRootFromParent_Done,
     /*  106155 */   // Label 1639: @106155
     /*  106155 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(106244), // Rule ID 51815 //
     /*  106160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106194 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106203 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106242 */     GIR_RootConstrainSelectedInstOperands,
     /*  106243 */     // GIR_Coverage, 51815,
     /*  106243 */     GIR_EraseRootFromParent_Done,
     /*  106244 */   // Label 1640: @106244
     /*  106244 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106333), // Rule ID 51514 //
     /*  106249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106264 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106283 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106292 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  106309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106331 */     GIR_RootConstrainSelectedInstOperands,
     /*  106332 */     // GIR_Coverage, 51514,
     /*  106332 */     GIR_EraseRootFromParent_Done,
     /*  106333 */   // Label 1641: @106333
     /*  106333 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106422), // Rule ID 51515 //
     /*  106338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106353 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106372 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106381 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  106398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106420 */     GIR_RootConstrainSelectedInstOperands,
     /*  106421 */     // GIR_Coverage, 51515,
     /*  106421 */     GIR_EraseRootFromParent_Done,
     /*  106422 */   // Label 1642: @106422
     /*  106422 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106511), // Rule ID 51754 //
     /*  106427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106442 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106461 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106470 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106509 */     GIR_RootConstrainSelectedInstOperands,
     /*  106510 */     // GIR_Coverage, 51754,
     /*  106510 */     GIR_EraseRootFromParent_Done,
     /*  106511 */   // Label 1643: @106511
     /*  106511 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(106600), // Rule ID 51755 //
     /*  106516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106559 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106598 */     GIR_RootConstrainSelectedInstOperands,
     /*  106599 */     // GIR_Coverage, 51755,
     /*  106599 */     GIR_EraseRootFromParent_Done,
     /*  106600 */   // Label 1644: @106600
     /*  106600 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(106689), // Rule ID 51694 //
     /*  106605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106639 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106648 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106687 */     GIR_RootConstrainSelectedInstOperands,
     /*  106688 */     // GIR_Coverage, 51694,
     /*  106688 */     GIR_EraseRootFromParent_Done,
     /*  106689 */   // Label 1645: @106689
     /*  106689 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(106778), // Rule ID 51695 //
     /*  106694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106737 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106776 */     GIR_RootConstrainSelectedInstOperands,
     /*  106777 */     // GIR_Coverage, 51695,
     /*  106777 */     GIR_EraseRootFromParent_Done,
     /*  106778 */   // Label 1646: @106778
     /*  106778 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(106867), // Rule ID 70460 //
     /*  106783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106817 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106826 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106865 */     GIR_RootConstrainSelectedInstOperands,
     /*  106866 */     // GIR_Coverage, 70460,
     /*  106866 */     GIR_EraseRootFromParent_Done,
     /*  106867 */   // Label 1647: @106867
     /*  106867 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(106956), // Rule ID 70461 //
     /*  106872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106915 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106954 */     GIR_RootConstrainSelectedInstOperands,
     /*  106955 */     // GIR_Coverage, 70461,
     /*  106955 */     GIR_EraseRootFromParent_Done,
     /*  106956 */   // Label 1648: @106956
     /*  106956 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(107045), // Rule ID 51574 //
     /*  106961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106995 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107004 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107043 */     GIR_RootConstrainSelectedInstOperands,
     /*  107044 */     // GIR_Coverage, 51574,
     /*  107044 */     GIR_EraseRootFromParent_Done,
     /*  107045 */   // Label 1649: @107045
     /*  107045 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(107134), // Rule ID 51575 //
     /*  107050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107084 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107093 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107132 */     GIR_RootConstrainSelectedInstOperands,
     /*  107133 */     // GIR_Coverage, 51575,
     /*  107133 */     GIR_EraseRootFromParent_Done,
     /*  107134 */   // Label 1650: @107134
     /*  107134 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(107187), // Rule ID 50908 //
     /*  107139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107150 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  107150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107185 */     GIR_RootConstrainSelectedInstOperands,
     /*  107186 */     // GIR_Coverage, 50908,
     /*  107186 */     GIR_EraseRootFromParent_Done,
     /*  107187 */   // Label 1651: @107187
     /*  107187 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(107240), // Rule ID 50909 //
     /*  107192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107203 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  107203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107238 */     GIR_RootConstrainSelectedInstOperands,
     /*  107239 */     // GIR_Coverage, 50909,
     /*  107239 */     GIR_EraseRootFromParent_Done,
     /*  107240 */   // Label 1652: @107240
     /*  107240 */   GIM_Reject,
     /*  107241 */ // Label 1632: @107241
     /*  107241 */ GIM_Reject,
     /*  107242 */ // Label 1313: @107242
     /*  107242 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(107356),
     /*  107247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  107250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  107253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107265 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(107310), // Rule ID 50896 //
     /*  107270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107273 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  107276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107308 */     GIR_RootConstrainSelectedInstOperands,
     /*  107309 */     // GIR_Coverage, 50896,
     /*  107309 */     GIR_EraseRootFromParent_Done,
     /*  107310 */   // Label 1654: @107310
     /*  107310 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(107355), // Rule ID 50897 //
     /*  107315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107318 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  107321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107353 */     GIR_RootConstrainSelectedInstOperands,
     /*  107354 */     // GIR_Coverage, 50897,
     /*  107354 */     GIR_EraseRootFromParent_Done,
     /*  107355 */   // Label 1655: @107355
     /*  107355 */   GIM_Reject,
     /*  107356 */ // Label 1653: @107356
     /*  107356 */ GIM_Reject,
     /*  107357 */ // Label 1314: @107357
     /*  107357 */ GIM_Reject,
     /*  107358 */ // Label 3: @107358
     /*  107358 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1680*/ GIMT_Encode4(110091),
     /*  107369 */ /*GILLT_s32*//*Label 1656*/ GIMT_Encode4(107493),
     /*  107373 */ /*GILLT_s64*//*Label 1657*/ GIMT_Encode4(107527), GIMT_Encode4(0),
     /*  107381 */ /*GILLT_nxv1s8*//*Label 1658*/ GIMT_Encode4(107561),
     /*  107385 */ /*GILLT_nxv1s16*//*Label 1659*/ GIMT_Encode4(107676),
     /*  107389 */ /*GILLT_nxv1s32*//*Label 1660*/ GIMT_Encode4(107791),
     /*  107393 */ /*GILLT_nxv1s64*//*Label 1661*/ GIMT_Encode4(107906), GIMT_Encode4(0),
     /*  107401 */ /*GILLT_nxv2s8*//*Label 1662*/ GIMT_Encode4(108021),
     /*  107405 */ /*GILLT_nxv2s16*//*Label 1663*/ GIMT_Encode4(108136),
     /*  107409 */ /*GILLT_nxv2s32*//*Label 1664*/ GIMT_Encode4(108251),
     /*  107413 */ /*GILLT_nxv2s64*//*Label 1665*/ GIMT_Encode4(108366), GIMT_Encode4(0),
     /*  107421 */ /*GILLT_nxv4s8*//*Label 1666*/ GIMT_Encode4(108481),
     /*  107425 */ /*GILLT_nxv4s16*//*Label 1667*/ GIMT_Encode4(108596),
     /*  107429 */ /*GILLT_nxv4s32*//*Label 1668*/ GIMT_Encode4(108711),
     /*  107433 */ /*GILLT_nxv4s64*//*Label 1669*/ GIMT_Encode4(108826), GIMT_Encode4(0),
     /*  107441 */ /*GILLT_nxv8s8*//*Label 1670*/ GIMT_Encode4(108941),
     /*  107445 */ /*GILLT_nxv8s16*//*Label 1671*/ GIMT_Encode4(109056),
     /*  107449 */ /*GILLT_nxv8s32*//*Label 1672*/ GIMT_Encode4(109171),
     /*  107453 */ /*GILLT_nxv8s64*//*Label 1673*/ GIMT_Encode4(109286), GIMT_Encode4(0),
     /*  107461 */ /*GILLT_nxv16s8*//*Label 1674*/ GIMT_Encode4(109401),
     /*  107465 */ /*GILLT_nxv16s16*//*Label 1675*/ GIMT_Encode4(109516),
     /*  107469 */ /*GILLT_nxv16s32*//*Label 1676*/ GIMT_Encode4(109631), GIMT_Encode4(0),
     /*  107477 */ /*GILLT_nxv32s8*//*Label 1677*/ GIMT_Encode4(109746),
     /*  107481 */ /*GILLT_nxv32s16*//*Label 1678*/ GIMT_Encode4(109861), GIMT_Encode4(0),
     /*  107489 */ /*GILLT_nxv64s8*//*Label 1679*/ GIMT_Encode4(109976),
     /*  107493 */ // Label 1656: @107493
     /*  107493 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(107526), // Rule ID 300 //
     /*  107498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  107501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  107504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  107507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107519 */   // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  107524 */   GIR_RootConstrainSelectedInstOperands,
     /*  107525 */   // GIR_Coverage, 300,
     /*  107525 */   GIR_Done,
     /*  107526 */ // Label 1681: @107526
     /*  107526 */ GIM_Reject,
     /*  107527 */ // Label 1657: @107527
     /*  107527 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(107560), // Rule ID 299 //
     /*  107532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  107535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  107538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  107541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107553 */   // (sdiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  107553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  107558 */   GIR_RootConstrainSelectedInstOperands,
     /*  107559 */   // GIR_Coverage, 299,
     /*  107559 */   GIR_Done,
     /*  107560 */ // Label 1682: @107560
     /*  107560 */ GIM_Reject,
     /*  107561 */ // Label 1658: @107561
     /*  107561 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(107675),
     /*  107566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  107569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  107572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107584 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(107629), // Rule ID 51200 //
     /*  107589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107592 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  107595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  107609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107627 */     GIR_RootConstrainSelectedInstOperands,
     /*  107628 */     // GIR_Coverage, 51200,
     /*  107628 */     GIR_EraseRootFromParent_Done,
     /*  107629 */   // Label 1684: @107629
     /*  107629 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(107674), // Rule ID 51201 //
     /*  107634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107637 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  107640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  107654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107672 */     GIR_RootConstrainSelectedInstOperands,
     /*  107673 */     // GIR_Coverage, 51201,
     /*  107673 */     GIR_EraseRootFromParent_Done,
     /*  107674 */   // Label 1685: @107674
     /*  107674 */   GIM_Reject,
     /*  107675 */ // Label 1683: @107675
     /*  107675 */ GIM_Reject,
     /*  107676 */ // Label 1659: @107676
     /*  107676 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(107790),
     /*  107681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  107684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  107687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107699 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(107744), // Rule ID 51212 //
     /*  107704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107707 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  107707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  107710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  107724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107742 */     GIR_RootConstrainSelectedInstOperands,
     /*  107743 */     // GIR_Coverage, 51212,
     /*  107743 */     GIR_EraseRootFromParent_Done,
     /*  107744 */   // Label 1687: @107744
     /*  107744 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(107789), // Rule ID 51213 //
     /*  107749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107752 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  107752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  107755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  107769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107787 */     GIR_RootConstrainSelectedInstOperands,
     /*  107788 */     // GIR_Coverage, 51213,
     /*  107788 */     GIR_EraseRootFromParent_Done,
     /*  107789 */   // Label 1688: @107789
     /*  107789 */   GIM_Reject,
     /*  107790 */ // Label 1686: @107790
     /*  107790 */ GIM_Reject,
     /*  107791 */ // Label 1660: @107791
     /*  107791 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(107905),
     /*  107796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  107799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  107802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107814 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(107859), // Rule ID 51220 //
     /*  107819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107822 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  107822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  107825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  107839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  107854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107857 */     GIR_RootConstrainSelectedInstOperands,
     /*  107858 */     // GIR_Coverage, 51220,
     /*  107858 */     GIR_EraseRootFromParent_Done,
     /*  107859 */   // Label 1690: @107859
     /*  107859 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(107904), // Rule ID 51221 //
     /*  107864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107867 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  107867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  107870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  107884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  107899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107902 */     GIR_RootConstrainSelectedInstOperands,
     /*  107903 */     // GIR_Coverage, 51221,
     /*  107903 */     GIR_EraseRootFromParent_Done,
     /*  107904 */   // Label 1691: @107904
     /*  107904 */   GIM_Reject,
     /*  107905 */ // Label 1689: @107905
     /*  107905 */ GIM_Reject,
     /*  107906 */ // Label 1661: @107906
     /*  107906 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(108020),
     /*  107911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  107914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  107917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107929 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(107974), // Rule ID 51236 //
     /*  107934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  107937 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  107937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  107940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  107954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  107969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107972 */     GIR_RootConstrainSelectedInstOperands,
     /*  107973 */     // GIR_Coverage, 51236,
     /*  107973 */     GIR_EraseRootFromParent_Done,
     /*  107974 */   // Label 1693: @107974
     /*  107974 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(108019), // Rule ID 51237 //
     /*  107979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  107982 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  107982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  107985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  107999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108017 */     GIR_RootConstrainSelectedInstOperands,
     /*  108018 */     // GIR_Coverage, 51237,
     /*  108018 */     GIR_EraseRootFromParent_Done,
     /*  108019 */   // Label 1694: @108019
     /*  108019 */   GIM_Reject,
     /*  108020 */ // Label 1692: @108020
     /*  108020 */ GIM_Reject,
     /*  108021 */ // Label 1662: @108021
     /*  108021 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(108135),
     /*  108026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  108029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  108032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108044 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(108089), // Rule ID 51204 //
     /*  108049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108052 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  108055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  108069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108087 */     GIR_RootConstrainSelectedInstOperands,
     /*  108088 */     // GIR_Coverage, 51204,
     /*  108088 */     GIR_EraseRootFromParent_Done,
     /*  108089 */   // Label 1696: @108089
     /*  108089 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(108134), // Rule ID 51205 //
     /*  108094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108097 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  108100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  108114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108132 */     GIR_RootConstrainSelectedInstOperands,
     /*  108133 */     // GIR_Coverage, 51205,
     /*  108133 */     GIR_EraseRootFromParent_Done,
     /*  108134 */   // Label 1697: @108134
     /*  108134 */   GIM_Reject,
     /*  108135 */ // Label 1695: @108135
     /*  108135 */ GIM_Reject,
     /*  108136 */ // Label 1663: @108136
     /*  108136 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(108250),
     /*  108141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  108144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  108147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108159 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(108204), // Rule ID 51216 //
     /*  108164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108167 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  108170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  108184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108202 */     GIR_RootConstrainSelectedInstOperands,
     /*  108203 */     // GIR_Coverage, 51216,
     /*  108203 */     GIR_EraseRootFromParent_Done,
     /*  108204 */   // Label 1699: @108204
     /*  108204 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(108249), // Rule ID 51217 //
     /*  108209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108212 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  108215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  108229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108247 */     GIR_RootConstrainSelectedInstOperands,
     /*  108248 */     // GIR_Coverage, 51217,
     /*  108248 */     GIR_EraseRootFromParent_Done,
     /*  108249 */   // Label 1700: @108249
     /*  108249 */   GIM_Reject,
     /*  108250 */ // Label 1698: @108250
     /*  108250 */ GIM_Reject,
     /*  108251 */ // Label 1664: @108251
     /*  108251 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(108365),
     /*  108256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  108259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  108262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108274 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(108319), // Rule ID 51232 //
     /*  108279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108282 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  108282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  108285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  108299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108317 */     GIR_RootConstrainSelectedInstOperands,
     /*  108318 */     // GIR_Coverage, 51232,
     /*  108318 */     GIR_EraseRootFromParent_Done,
     /*  108319 */   // Label 1702: @108319
     /*  108319 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(108364), // Rule ID 51233 //
     /*  108324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108327 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  108327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  108330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  108344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108362 */     GIR_RootConstrainSelectedInstOperands,
     /*  108363 */     // GIR_Coverage, 51233,
     /*  108363 */     GIR_EraseRootFromParent_Done,
     /*  108364 */   // Label 1703: @108364
     /*  108364 */   GIM_Reject,
     /*  108365 */ // Label 1701: @108365
     /*  108365 */ GIM_Reject,
     /*  108366 */ // Label 1665: @108366
     /*  108366 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(108480),
     /*  108371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  108374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  108377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108389 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(108434), // Rule ID 51276 //
     /*  108394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  108397 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  108397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  108400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  108414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108432 */     GIR_RootConstrainSelectedInstOperands,
     /*  108433 */     // GIR_Coverage, 51276,
     /*  108433 */     GIR_EraseRootFromParent_Done,
     /*  108434 */   // Label 1705: @108434
     /*  108434 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(108479), // Rule ID 51277 //
     /*  108439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  108442 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  108442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  108445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  108459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108477 */     GIR_RootConstrainSelectedInstOperands,
     /*  108478 */     // GIR_Coverage, 51277,
     /*  108478 */     GIR_EraseRootFromParent_Done,
     /*  108479 */   // Label 1706: @108479
     /*  108479 */   GIM_Reject,
     /*  108480 */ // Label 1704: @108480
     /*  108480 */ GIM_Reject,
     /*  108481 */ // Label 1666: @108481
     /*  108481 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(108595),
     /*  108486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  108489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  108492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108504 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(108549), // Rule ID 51208 //
     /*  108509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108512 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  108515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  108529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108547 */     GIR_RootConstrainSelectedInstOperands,
     /*  108548 */     // GIR_Coverage, 51208,
     /*  108548 */     GIR_EraseRootFromParent_Done,
     /*  108549 */   // Label 1708: @108549
     /*  108549 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(108594), // Rule ID 51209 //
     /*  108554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108557 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  108560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  108574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108592 */     GIR_RootConstrainSelectedInstOperands,
     /*  108593 */     // GIR_Coverage, 51209,
     /*  108593 */     GIR_EraseRootFromParent_Done,
     /*  108594 */   // Label 1709: @108594
     /*  108594 */   GIM_Reject,
     /*  108595 */ // Label 1707: @108595
     /*  108595 */ GIM_Reject,
     /*  108596 */ // Label 1667: @108596
     /*  108596 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(108710),
     /*  108601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  108604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  108607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108619 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(108664), // Rule ID 51228 //
     /*  108624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108627 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  108630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  108644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108662 */     GIR_RootConstrainSelectedInstOperands,
     /*  108663 */     // GIR_Coverage, 51228,
     /*  108663 */     GIR_EraseRootFromParent_Done,
     /*  108664 */   // Label 1711: @108664
     /*  108664 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(108709), // Rule ID 51229 //
     /*  108669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108672 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  108675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  108689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108707 */     GIR_RootConstrainSelectedInstOperands,
     /*  108708 */     // GIR_Coverage, 51229,
     /*  108708 */     GIR_EraseRootFromParent_Done,
     /*  108709 */   // Label 1712: @108709
     /*  108709 */   GIM_Reject,
     /*  108710 */ // Label 1710: @108710
     /*  108710 */ GIM_Reject,
     /*  108711 */ // Label 1668: @108711
     /*  108711 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(108825),
     /*  108716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  108719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  108722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108734 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(108779), // Rule ID 51264 //
     /*  108739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108742 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  108742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  108745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  108759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108777 */     GIR_RootConstrainSelectedInstOperands,
     /*  108778 */     // GIR_Coverage, 51264,
     /*  108778 */     GIR_EraseRootFromParent_Done,
     /*  108779 */   // Label 1714: @108779
     /*  108779 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(108824), // Rule ID 51265 //
     /*  108784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108787 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  108787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  108790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  108804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108822 */     GIR_RootConstrainSelectedInstOperands,
     /*  108823 */     // GIR_Coverage, 51265,
     /*  108823 */     GIR_EraseRootFromParent_Done,
     /*  108824 */   // Label 1715: @108824
     /*  108824 */   GIM_Reject,
     /*  108825 */ // Label 1713: @108825
     /*  108825 */ GIM_Reject,
     /*  108826 */ // Label 1669: @108826
     /*  108826 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(108940),
     /*  108831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  108834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  108837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108849 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(108894), // Rule ID 51280 //
     /*  108854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  108857 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  108857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  108860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  108874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108892 */     GIR_RootConstrainSelectedInstOperands,
     /*  108893 */     // GIR_Coverage, 51280,
     /*  108893 */     GIR_EraseRootFromParent_Done,
     /*  108894 */   // Label 1717: @108894
     /*  108894 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(108939), // Rule ID 51281 //
     /*  108899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  108902 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  108902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  108905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  108919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108937 */     GIR_RootConstrainSelectedInstOperands,
     /*  108938 */     // GIR_Coverage, 51281,
     /*  108938 */     GIR_EraseRootFromParent_Done,
     /*  108939 */   // Label 1718: @108939
     /*  108939 */   GIM_Reject,
     /*  108940 */ // Label 1716: @108940
     /*  108940 */ GIM_Reject,
     /*  108941 */ // Label 1670: @108941
     /*  108941 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(109055),
     /*  108946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  108949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  108952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108964 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(109009), // Rule ID 51224 //
     /*  108969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108972 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  108975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  108989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109007 */     GIR_RootConstrainSelectedInstOperands,
     /*  109008 */     // GIR_Coverage, 51224,
     /*  109008 */     GIR_EraseRootFromParent_Done,
     /*  109009 */   // Label 1720: @109009
     /*  109009 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(109054), // Rule ID 51225 //
     /*  109014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109017 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  109020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  109034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109052 */     GIR_RootConstrainSelectedInstOperands,
     /*  109053 */     // GIR_Coverage, 51225,
     /*  109053 */     GIR_EraseRootFromParent_Done,
     /*  109054 */   // Label 1721: @109054
     /*  109054 */   GIM_Reject,
     /*  109055 */ // Label 1719: @109055
     /*  109055 */ GIM_Reject,
     /*  109056 */ // Label 1671: @109056
     /*  109056 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(109170),
     /*  109061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  109064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  109067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109079 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(109124), // Rule ID 51252 //
     /*  109084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109087 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  109090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  109104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109122 */     GIR_RootConstrainSelectedInstOperands,
     /*  109123 */     // GIR_Coverage, 51252,
     /*  109123 */     GIR_EraseRootFromParent_Done,
     /*  109124 */   // Label 1723: @109124
     /*  109124 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(109169), // Rule ID 51253 //
     /*  109129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109132 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  109135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  109149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109167 */     GIR_RootConstrainSelectedInstOperands,
     /*  109168 */     // GIR_Coverage, 51253,
     /*  109168 */     GIR_EraseRootFromParent_Done,
     /*  109169 */   // Label 1724: @109169
     /*  109169 */   GIM_Reject,
     /*  109170 */ // Label 1722: @109170
     /*  109170 */ GIM_Reject,
     /*  109171 */ // Label 1672: @109171
     /*  109171 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(109285),
     /*  109176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  109179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  109182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109194 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(109239), // Rule ID 51268 //
     /*  109199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109202 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  109205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  109219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109237 */     GIR_RootConstrainSelectedInstOperands,
     /*  109238 */     // GIR_Coverage, 51268,
     /*  109238 */     GIR_EraseRootFromParent_Done,
     /*  109239 */   // Label 1726: @109239
     /*  109239 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(109284), // Rule ID 51269 //
     /*  109244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109247 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  109250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  109264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109282 */     GIR_RootConstrainSelectedInstOperands,
     /*  109283 */     // GIR_Coverage, 51269,
     /*  109283 */     GIR_EraseRootFromParent_Done,
     /*  109284 */   // Label 1727: @109284
     /*  109284 */   GIM_Reject,
     /*  109285 */ // Label 1725: @109285
     /*  109285 */ GIM_Reject,
     /*  109286 */ // Label 1673: @109286
     /*  109286 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(109400),
     /*  109291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  109294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  109297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109309 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(109354), // Rule ID 51284 //
     /*  109314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  109317 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  109317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  109320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  109334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109352 */     GIR_RootConstrainSelectedInstOperands,
     /*  109353 */     // GIR_Coverage, 51284,
     /*  109353 */     GIR_EraseRootFromParent_Done,
     /*  109354 */   // Label 1729: @109354
     /*  109354 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(109399), // Rule ID 51285 //
     /*  109359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  109362 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  109362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  109365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  109379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109397 */     GIR_RootConstrainSelectedInstOperands,
     /*  109398 */     // GIR_Coverage, 51285,
     /*  109398 */     GIR_EraseRootFromParent_Done,
     /*  109399 */   // Label 1730: @109399
     /*  109399 */   GIM_Reject,
     /*  109400 */ // Label 1728: @109400
     /*  109400 */ GIM_Reject,
     /*  109401 */ // Label 1674: @109401
     /*  109401 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(109515),
     /*  109406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  109409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  109412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109424 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(109469), // Rule ID 51240 //
     /*  109429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109432 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  109435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  109449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109467 */     GIR_RootConstrainSelectedInstOperands,
     /*  109468 */     // GIR_Coverage, 51240,
     /*  109468 */     GIR_EraseRootFromParent_Done,
     /*  109469 */   // Label 1732: @109469
     /*  109469 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(109514), // Rule ID 51241 //
     /*  109474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109477 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  109480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  109494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109512 */     GIR_RootConstrainSelectedInstOperands,
     /*  109513 */     // GIR_Coverage, 51241,
     /*  109513 */     GIR_EraseRootFromParent_Done,
     /*  109514 */   // Label 1733: @109514
     /*  109514 */   GIM_Reject,
     /*  109515 */ // Label 1731: @109515
     /*  109515 */ GIM_Reject,
     /*  109516 */ // Label 1675: @109516
     /*  109516 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(109630),
     /*  109521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  109524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  109527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109539 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(109584), // Rule ID 51256 //
     /*  109544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109547 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  109550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  109564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109582 */     GIR_RootConstrainSelectedInstOperands,
     /*  109583 */     // GIR_Coverage, 51256,
     /*  109583 */     GIR_EraseRootFromParent_Done,
     /*  109584 */   // Label 1735: @109584
     /*  109584 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(109629), // Rule ID 51257 //
     /*  109589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109592 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  109595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  109609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109627 */     GIR_RootConstrainSelectedInstOperands,
     /*  109628 */     // GIR_Coverage, 51257,
     /*  109628 */     GIR_EraseRootFromParent_Done,
     /*  109629 */   // Label 1736: @109629
     /*  109629 */   GIM_Reject,
     /*  109630 */ // Label 1734: @109630
     /*  109630 */ GIM_Reject,
     /*  109631 */ // Label 1676: @109631
     /*  109631 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(109745),
     /*  109636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  109639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  109642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109650 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109654 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(109699), // Rule ID 51272 //
     /*  109659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109662 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  109665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  109679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109697 */     GIR_RootConstrainSelectedInstOperands,
     /*  109698 */     // GIR_Coverage, 51272,
     /*  109698 */     GIR_EraseRootFromParent_Done,
     /*  109699 */   // Label 1738: @109699
     /*  109699 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(109744), // Rule ID 51273 //
     /*  109704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109707 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  109710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  109724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109742 */     GIR_RootConstrainSelectedInstOperands,
     /*  109743 */     // GIR_Coverage, 51273,
     /*  109743 */     GIR_EraseRootFromParent_Done,
     /*  109744 */   // Label 1739: @109744
     /*  109744 */   GIM_Reject,
     /*  109745 */ // Label 1737: @109745
     /*  109745 */ GIM_Reject,
     /*  109746 */ // Label 1677: @109746
     /*  109746 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(109860),
     /*  109751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  109754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  109757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109769 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(109814), // Rule ID 51244 //
     /*  109774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109777 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  109780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  109794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109812 */     GIR_RootConstrainSelectedInstOperands,
     /*  109813 */     // GIR_Coverage, 51244,
     /*  109813 */     GIR_EraseRootFromParent_Done,
     /*  109814 */   // Label 1741: @109814
     /*  109814 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(109859), // Rule ID 51245 //
     /*  109819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109822 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  109825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  109839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109857 */     GIR_RootConstrainSelectedInstOperands,
     /*  109858 */     // GIR_Coverage, 51245,
     /*  109858 */     GIR_EraseRootFromParent_Done,
     /*  109859 */   // Label 1742: @109859
     /*  109859 */   GIM_Reject,
     /*  109860 */ // Label 1740: @109860
     /*  109860 */ GIM_Reject,
     /*  109861 */ // Label 1678: @109861
     /*  109861 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(109975),
     /*  109866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  109869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  109872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109884 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(109929), // Rule ID 51260 //
     /*  109889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109892 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  109895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  109909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109927 */     GIR_RootConstrainSelectedInstOperands,
     /*  109928 */     // GIR_Coverage, 51260,
     /*  109928 */     GIR_EraseRootFromParent_Done,
     /*  109929 */   // Label 1744: @109929
     /*  109929 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(109974), // Rule ID 51261 //
     /*  109934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109937 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  109940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  109954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109972 */     GIR_RootConstrainSelectedInstOperands,
     /*  109973 */     // GIR_Coverage, 51261,
     /*  109973 */     GIR_EraseRootFromParent_Done,
     /*  109974 */   // Label 1745: @109974
     /*  109974 */   GIM_Reject,
     /*  109975 */ // Label 1743: @109975
     /*  109975 */ GIM_Reject,
     /*  109976 */ // Label 1679: @109976
     /*  109976 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(110090),
     /*  109981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  109984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  109987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109999 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(110044), // Rule ID 51248 //
     /*  110004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110007 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  110010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  110024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110042 */     GIR_RootConstrainSelectedInstOperands,
     /*  110043 */     // GIR_Coverage, 51248,
     /*  110043 */     GIR_EraseRootFromParent_Done,
     /*  110044 */   // Label 1747: @110044
     /*  110044 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(110089), // Rule ID 51249 //
     /*  110049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110052 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  110055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  110069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110087 */     GIR_RootConstrainSelectedInstOperands,
     /*  110088 */     // GIR_Coverage, 51249,
     /*  110088 */     GIR_EraseRootFromParent_Done,
     /*  110089 */   // Label 1748: @110089
     /*  110089 */   GIM_Reject,
     /*  110090 */ // Label 1746: @110090
     /*  110090 */ GIM_Reject,
     /*  110091 */ // Label 1680: @110091
     /*  110091 */ GIM_Reject,
     /*  110092 */ // Label 4: @110092
     /*  110092 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1773*/ GIMT_Encode4(112825),
     /*  110103 */ /*GILLT_s32*//*Label 1749*/ GIMT_Encode4(110227),
     /*  110107 */ /*GILLT_s64*//*Label 1750*/ GIMT_Encode4(110261), GIMT_Encode4(0),
     /*  110115 */ /*GILLT_nxv1s8*//*Label 1751*/ GIMT_Encode4(110295),
     /*  110119 */ /*GILLT_nxv1s16*//*Label 1752*/ GIMT_Encode4(110410),
     /*  110123 */ /*GILLT_nxv1s32*//*Label 1753*/ GIMT_Encode4(110525),
     /*  110127 */ /*GILLT_nxv1s64*//*Label 1754*/ GIMT_Encode4(110640), GIMT_Encode4(0),
     /*  110135 */ /*GILLT_nxv2s8*//*Label 1755*/ GIMT_Encode4(110755),
     /*  110139 */ /*GILLT_nxv2s16*//*Label 1756*/ GIMT_Encode4(110870),
     /*  110143 */ /*GILLT_nxv2s32*//*Label 1757*/ GIMT_Encode4(110985),
     /*  110147 */ /*GILLT_nxv2s64*//*Label 1758*/ GIMT_Encode4(111100), GIMT_Encode4(0),
     /*  110155 */ /*GILLT_nxv4s8*//*Label 1759*/ GIMT_Encode4(111215),
     /*  110159 */ /*GILLT_nxv4s16*//*Label 1760*/ GIMT_Encode4(111330),
     /*  110163 */ /*GILLT_nxv4s32*//*Label 1761*/ GIMT_Encode4(111445),
     /*  110167 */ /*GILLT_nxv4s64*//*Label 1762*/ GIMT_Encode4(111560), GIMT_Encode4(0),
     /*  110175 */ /*GILLT_nxv8s8*//*Label 1763*/ GIMT_Encode4(111675),
     /*  110179 */ /*GILLT_nxv8s16*//*Label 1764*/ GIMT_Encode4(111790),
     /*  110183 */ /*GILLT_nxv8s32*//*Label 1765*/ GIMT_Encode4(111905),
     /*  110187 */ /*GILLT_nxv8s64*//*Label 1766*/ GIMT_Encode4(112020), GIMT_Encode4(0),
     /*  110195 */ /*GILLT_nxv16s8*//*Label 1767*/ GIMT_Encode4(112135),
     /*  110199 */ /*GILLT_nxv16s16*//*Label 1768*/ GIMT_Encode4(112250),
     /*  110203 */ /*GILLT_nxv16s32*//*Label 1769*/ GIMT_Encode4(112365), GIMT_Encode4(0),
     /*  110211 */ /*GILLT_nxv32s8*//*Label 1770*/ GIMT_Encode4(112480),
     /*  110215 */ /*GILLT_nxv32s16*//*Label 1771*/ GIMT_Encode4(112595), GIMT_Encode4(0),
     /*  110223 */ /*GILLT_nxv64s8*//*Label 1772*/ GIMT_Encode4(112710),
     /*  110227 */ // Label 1749: @110227
     /*  110227 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(110260), // Rule ID 302 //
     /*  110232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  110235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  110238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  110241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110253 */   // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIVU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  110258 */   GIR_RootConstrainSelectedInstOperands,
     /*  110259 */   // GIR_Coverage, 302,
     /*  110259 */   GIR_Done,
     /*  110260 */ // Label 1774: @110260
     /*  110260 */ GIM_Reject,
     /*  110261 */ // Label 1750: @110261
     /*  110261 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(110294), // Rule ID 301 //
     /*  110266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  110269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  110272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  110275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110287 */   // (udiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  110287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  110292 */   GIR_RootConstrainSelectedInstOperands,
     /*  110293 */   // GIR_Coverage, 301,
     /*  110293 */   GIR_Done,
     /*  110294 */ // Label 1775: @110294
     /*  110294 */ GIM_Reject,
     /*  110295 */ // Label 1751: @110295
     /*  110295 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(110409),
     /*  110300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  110303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  110306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110318 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(110363), // Rule ID 51112 //
     /*  110323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110326 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  110329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  110343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110361 */     GIR_RootConstrainSelectedInstOperands,
     /*  110362 */     // GIR_Coverage, 51112,
     /*  110362 */     GIR_EraseRootFromParent_Done,
     /*  110363 */   // Label 1777: @110363
     /*  110363 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(110408), // Rule ID 51113 //
     /*  110368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110371 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  110374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  110388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110406 */     GIR_RootConstrainSelectedInstOperands,
     /*  110407 */     // GIR_Coverage, 51113,
     /*  110407 */     GIR_EraseRootFromParent_Done,
     /*  110408 */   // Label 1778: @110408
     /*  110408 */   GIM_Reject,
     /*  110409 */ // Label 1776: @110409
     /*  110409 */ GIM_Reject,
     /*  110410 */ // Label 1752: @110410
     /*  110410 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(110524),
     /*  110415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  110418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  110421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110433 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(110478), // Rule ID 51124 //
     /*  110438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110441 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  110444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  110458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110476 */     GIR_RootConstrainSelectedInstOperands,
     /*  110477 */     // GIR_Coverage, 51124,
     /*  110477 */     GIR_EraseRootFromParent_Done,
     /*  110478 */   // Label 1780: @110478
     /*  110478 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(110523), // Rule ID 51125 //
     /*  110483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110486 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  110489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  110503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110521 */     GIR_RootConstrainSelectedInstOperands,
     /*  110522 */     // GIR_Coverage, 51125,
     /*  110522 */     GIR_EraseRootFromParent_Done,
     /*  110523 */   // Label 1781: @110523
     /*  110523 */   GIM_Reject,
     /*  110524 */ // Label 1779: @110524
     /*  110524 */ GIM_Reject,
     /*  110525 */ // Label 1753: @110525
     /*  110525 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(110639),
     /*  110530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  110533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  110536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110548 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(110593), // Rule ID 51132 //
     /*  110553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110556 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  110556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  110559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  110573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110591 */     GIR_RootConstrainSelectedInstOperands,
     /*  110592 */     // GIR_Coverage, 51132,
     /*  110592 */     GIR_EraseRootFromParent_Done,
     /*  110593 */   // Label 1783: @110593
     /*  110593 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(110638), // Rule ID 51133 //
     /*  110598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110601 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  110601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  110604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  110618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110636 */     GIR_RootConstrainSelectedInstOperands,
     /*  110637 */     // GIR_Coverage, 51133,
     /*  110637 */     GIR_EraseRootFromParent_Done,
     /*  110638 */   // Label 1784: @110638
     /*  110638 */   GIM_Reject,
     /*  110639 */ // Label 1782: @110639
     /*  110639 */ GIM_Reject,
     /*  110640 */ // Label 1754: @110640
     /*  110640 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(110754),
     /*  110645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  110648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  110651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110663 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(110708), // Rule ID 51148 //
     /*  110668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  110671 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  110671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  110674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  110688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  110703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110706 */     GIR_RootConstrainSelectedInstOperands,
     /*  110707 */     // GIR_Coverage, 51148,
     /*  110707 */     GIR_EraseRootFromParent_Done,
     /*  110708 */   // Label 1786: @110708
     /*  110708 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(110753), // Rule ID 51149 //
     /*  110713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  110716 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  110716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  110719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  110733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  110748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110751 */     GIR_RootConstrainSelectedInstOperands,
     /*  110752 */     // GIR_Coverage, 51149,
     /*  110752 */     GIR_EraseRootFromParent_Done,
     /*  110753 */   // Label 1787: @110753
     /*  110753 */   GIM_Reject,
     /*  110754 */ // Label 1785: @110754
     /*  110754 */ GIM_Reject,
     /*  110755 */ // Label 1755: @110755
     /*  110755 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(110869),
     /*  110760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  110763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  110766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110778 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(110823), // Rule ID 51116 //
     /*  110783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110786 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  110789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  110803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110821 */     GIR_RootConstrainSelectedInstOperands,
     /*  110822 */     // GIR_Coverage, 51116,
     /*  110822 */     GIR_EraseRootFromParent_Done,
     /*  110823 */   // Label 1789: @110823
     /*  110823 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(110868), // Rule ID 51117 //
     /*  110828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110831 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  110834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  110848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110866 */     GIR_RootConstrainSelectedInstOperands,
     /*  110867 */     // GIR_Coverage, 51117,
     /*  110867 */     GIR_EraseRootFromParent_Done,
     /*  110868 */   // Label 1790: @110868
     /*  110868 */   GIM_Reject,
     /*  110869 */ // Label 1788: @110869
     /*  110869 */ GIM_Reject,
     /*  110870 */ // Label 1756: @110870
     /*  110870 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(110984),
     /*  110875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  110878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  110881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110893 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(110938), // Rule ID 51128 //
     /*  110898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110901 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  110904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  110918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110936 */     GIR_RootConstrainSelectedInstOperands,
     /*  110937 */     // GIR_Coverage, 51128,
     /*  110937 */     GIR_EraseRootFromParent_Done,
     /*  110938 */   // Label 1792: @110938
     /*  110938 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(110983), // Rule ID 51129 //
     /*  110943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110946 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  110949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  110963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110981 */     GIR_RootConstrainSelectedInstOperands,
     /*  110982 */     // GIR_Coverage, 51129,
     /*  110982 */     GIR_EraseRootFromParent_Done,
     /*  110983 */   // Label 1793: @110983
     /*  110983 */   GIM_Reject,
     /*  110984 */ // Label 1791: @110984
     /*  110984 */ GIM_Reject,
     /*  110985 */ // Label 1757: @110985
     /*  110985 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(111099),
     /*  110990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  110993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  110996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111008 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(111053), // Rule ID 51144 //
     /*  111013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111016 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  111019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  111033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111051 */     GIR_RootConstrainSelectedInstOperands,
     /*  111052 */     // GIR_Coverage, 51144,
     /*  111052 */     GIR_EraseRootFromParent_Done,
     /*  111053 */   // Label 1795: @111053
     /*  111053 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(111098), // Rule ID 51145 //
     /*  111058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111061 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  111064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  111078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111096 */     GIR_RootConstrainSelectedInstOperands,
     /*  111097 */     // GIR_Coverage, 51145,
     /*  111097 */     GIR_EraseRootFromParent_Done,
     /*  111098 */   // Label 1796: @111098
     /*  111098 */   GIM_Reject,
     /*  111099 */ // Label 1794: @111099
     /*  111099 */ GIM_Reject,
     /*  111100 */ // Label 1758: @111100
     /*  111100 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(111214),
     /*  111105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  111108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  111111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111123 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(111168), // Rule ID 51188 //
     /*  111128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  111131 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  111131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  111134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  111148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111166 */     GIR_RootConstrainSelectedInstOperands,
     /*  111167 */     // GIR_Coverage, 51188,
     /*  111167 */     GIR_EraseRootFromParent_Done,
     /*  111168 */   // Label 1798: @111168
     /*  111168 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(111213), // Rule ID 51189 //
     /*  111173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  111176 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  111176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  111179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  111193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111211 */     GIR_RootConstrainSelectedInstOperands,
     /*  111212 */     // GIR_Coverage, 51189,
     /*  111212 */     GIR_EraseRootFromParent_Done,
     /*  111213 */   // Label 1799: @111213
     /*  111213 */   GIM_Reject,
     /*  111214 */ // Label 1797: @111214
     /*  111214 */ GIM_Reject,
     /*  111215 */ // Label 1759: @111215
     /*  111215 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(111329),
     /*  111220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  111223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  111226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111238 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(111283), // Rule ID 51120 //
     /*  111243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111246 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  111249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  111263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111281 */     GIR_RootConstrainSelectedInstOperands,
     /*  111282 */     // GIR_Coverage, 51120,
     /*  111282 */     GIR_EraseRootFromParent_Done,
     /*  111283 */   // Label 1801: @111283
     /*  111283 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(111328), // Rule ID 51121 //
     /*  111288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111291 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  111294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  111308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111326 */     GIR_RootConstrainSelectedInstOperands,
     /*  111327 */     // GIR_Coverage, 51121,
     /*  111327 */     GIR_EraseRootFromParent_Done,
     /*  111328 */   // Label 1802: @111328
     /*  111328 */   GIM_Reject,
     /*  111329 */ // Label 1800: @111329
     /*  111329 */ GIM_Reject,
     /*  111330 */ // Label 1760: @111330
     /*  111330 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(111444),
     /*  111335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  111338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  111341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111353 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(111398), // Rule ID 51140 //
     /*  111358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111361 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  111364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  111378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111396 */     GIR_RootConstrainSelectedInstOperands,
     /*  111397 */     // GIR_Coverage, 51140,
     /*  111397 */     GIR_EraseRootFromParent_Done,
     /*  111398 */   // Label 1804: @111398
     /*  111398 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(111443), // Rule ID 51141 //
     /*  111403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111406 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  111409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  111423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111441 */     GIR_RootConstrainSelectedInstOperands,
     /*  111442 */     // GIR_Coverage, 51141,
     /*  111442 */     GIR_EraseRootFromParent_Done,
     /*  111443 */   // Label 1805: @111443
     /*  111443 */   GIM_Reject,
     /*  111444 */ // Label 1803: @111444
     /*  111444 */ GIM_Reject,
     /*  111445 */ // Label 1761: @111445
     /*  111445 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(111559),
     /*  111450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  111453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  111456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111468 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(111513), // Rule ID 51176 //
     /*  111473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111476 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  111479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  111493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111511 */     GIR_RootConstrainSelectedInstOperands,
     /*  111512 */     // GIR_Coverage, 51176,
     /*  111512 */     GIR_EraseRootFromParent_Done,
     /*  111513 */   // Label 1807: @111513
     /*  111513 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(111558), // Rule ID 51177 //
     /*  111518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111521 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  111524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  111538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111556 */     GIR_RootConstrainSelectedInstOperands,
     /*  111557 */     // GIR_Coverage, 51177,
     /*  111557 */     GIR_EraseRootFromParent_Done,
     /*  111558 */   // Label 1808: @111558
     /*  111558 */   GIM_Reject,
     /*  111559 */ // Label 1806: @111559
     /*  111559 */ GIM_Reject,
     /*  111560 */ // Label 1762: @111560
     /*  111560 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(111674),
     /*  111565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  111568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  111571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111583 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(111628), // Rule ID 51192 //
     /*  111588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  111591 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  111591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  111594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  111608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111626 */     GIR_RootConstrainSelectedInstOperands,
     /*  111627 */     // GIR_Coverage, 51192,
     /*  111627 */     GIR_EraseRootFromParent_Done,
     /*  111628 */   // Label 1810: @111628
     /*  111628 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(111673), // Rule ID 51193 //
     /*  111633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  111636 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  111636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  111639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  111653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111671 */     GIR_RootConstrainSelectedInstOperands,
     /*  111672 */     // GIR_Coverage, 51193,
     /*  111672 */     GIR_EraseRootFromParent_Done,
     /*  111673 */   // Label 1811: @111673
     /*  111673 */   GIM_Reject,
     /*  111674 */ // Label 1809: @111674
     /*  111674 */ GIM_Reject,
     /*  111675 */ // Label 1763: @111675
     /*  111675 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(111789),
     /*  111680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  111683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  111686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111698 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(111743), // Rule ID 51136 //
     /*  111703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111706 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  111709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  111723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111741 */     GIR_RootConstrainSelectedInstOperands,
     /*  111742 */     // GIR_Coverage, 51136,
     /*  111742 */     GIR_EraseRootFromParent_Done,
     /*  111743 */   // Label 1813: @111743
     /*  111743 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(111788), // Rule ID 51137 //
     /*  111748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111751 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  111754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  111768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111786 */     GIR_RootConstrainSelectedInstOperands,
     /*  111787 */     // GIR_Coverage, 51137,
     /*  111787 */     GIR_EraseRootFromParent_Done,
     /*  111788 */   // Label 1814: @111788
     /*  111788 */   GIM_Reject,
     /*  111789 */ // Label 1812: @111789
     /*  111789 */ GIM_Reject,
     /*  111790 */ // Label 1764: @111790
     /*  111790 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(111904),
     /*  111795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  111798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  111801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111813 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(111858), // Rule ID 51164 //
     /*  111818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111821 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  111824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  111838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111856 */     GIR_RootConstrainSelectedInstOperands,
     /*  111857 */     // GIR_Coverage, 51164,
     /*  111857 */     GIR_EraseRootFromParent_Done,
     /*  111858 */   // Label 1816: @111858
     /*  111858 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(111903), // Rule ID 51165 //
     /*  111863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111866 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  111869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  111883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111901 */     GIR_RootConstrainSelectedInstOperands,
     /*  111902 */     // GIR_Coverage, 51165,
     /*  111902 */     GIR_EraseRootFromParent_Done,
     /*  111903 */   // Label 1817: @111903
     /*  111903 */   GIM_Reject,
     /*  111904 */ // Label 1815: @111904
     /*  111904 */ GIM_Reject,
     /*  111905 */ // Label 1765: @111905
     /*  111905 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(112019),
     /*  111910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  111913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  111916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111928 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(111973), // Rule ID 51180 //
     /*  111933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111936 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  111939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  111953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111971 */     GIR_RootConstrainSelectedInstOperands,
     /*  111972 */     // GIR_Coverage, 51180,
     /*  111972 */     GIR_EraseRootFromParent_Done,
     /*  111973 */   // Label 1819: @111973
     /*  111973 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(112018), // Rule ID 51181 //
     /*  111978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111981 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  111984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  111998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112016 */     GIR_RootConstrainSelectedInstOperands,
     /*  112017 */     // GIR_Coverage, 51181,
     /*  112017 */     GIR_EraseRootFromParent_Done,
     /*  112018 */   // Label 1820: @112018
     /*  112018 */   GIM_Reject,
     /*  112019 */ // Label 1818: @112019
     /*  112019 */ GIM_Reject,
     /*  112020 */ // Label 1766: @112020
     /*  112020 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(112134),
     /*  112025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  112028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  112031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112043 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(112088), // Rule ID 51196 //
     /*  112048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  112051 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  112051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  112054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  112068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112086 */     GIR_RootConstrainSelectedInstOperands,
     /*  112087 */     // GIR_Coverage, 51196,
     /*  112087 */     GIR_EraseRootFromParent_Done,
     /*  112088 */   // Label 1822: @112088
     /*  112088 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(112133), // Rule ID 51197 //
     /*  112093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  112096 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  112096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  112099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  112113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112131 */     GIR_RootConstrainSelectedInstOperands,
     /*  112132 */     // GIR_Coverage, 51197,
     /*  112132 */     GIR_EraseRootFromParent_Done,
     /*  112133 */   // Label 1823: @112133
     /*  112133 */   GIM_Reject,
     /*  112134 */ // Label 1821: @112134
     /*  112134 */ GIM_Reject,
     /*  112135 */ // Label 1767: @112135
     /*  112135 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(112249),
     /*  112140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  112143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  112146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112158 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(112203), // Rule ID 51152 //
     /*  112163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112166 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  112169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  112183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112201 */     GIR_RootConstrainSelectedInstOperands,
     /*  112202 */     // GIR_Coverage, 51152,
     /*  112202 */     GIR_EraseRootFromParent_Done,
     /*  112203 */   // Label 1825: @112203
     /*  112203 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(112248), // Rule ID 51153 //
     /*  112208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112211 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  112214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  112228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112246 */     GIR_RootConstrainSelectedInstOperands,
     /*  112247 */     // GIR_Coverage, 51153,
     /*  112247 */     GIR_EraseRootFromParent_Done,
     /*  112248 */   // Label 1826: @112248
     /*  112248 */   GIM_Reject,
     /*  112249 */ // Label 1824: @112249
     /*  112249 */ GIM_Reject,
     /*  112250 */ // Label 1768: @112250
     /*  112250 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(112364),
     /*  112255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  112258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  112261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112273 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(112318), // Rule ID 51168 //
     /*  112278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112281 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  112284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  112298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112316 */     GIR_RootConstrainSelectedInstOperands,
     /*  112317 */     // GIR_Coverage, 51168,
     /*  112317 */     GIR_EraseRootFromParent_Done,
     /*  112318 */   // Label 1828: @112318
     /*  112318 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(112363), // Rule ID 51169 //
     /*  112323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112326 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  112329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  112343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112361 */     GIR_RootConstrainSelectedInstOperands,
     /*  112362 */     // GIR_Coverage, 51169,
     /*  112362 */     GIR_EraseRootFromParent_Done,
     /*  112363 */   // Label 1829: @112363
     /*  112363 */   GIM_Reject,
     /*  112364 */ // Label 1827: @112364
     /*  112364 */ GIM_Reject,
     /*  112365 */ // Label 1769: @112365
     /*  112365 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(112479),
     /*  112370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  112373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  112376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112384 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112388 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(112433), // Rule ID 51184 //
     /*  112393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112396 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  112396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  112399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  112413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112431 */     GIR_RootConstrainSelectedInstOperands,
     /*  112432 */     // GIR_Coverage, 51184,
     /*  112432 */     GIR_EraseRootFromParent_Done,
     /*  112433 */   // Label 1831: @112433
     /*  112433 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(112478), // Rule ID 51185 //
     /*  112438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112441 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  112441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  112444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  112458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112476 */     GIR_RootConstrainSelectedInstOperands,
     /*  112477 */     // GIR_Coverage, 51185,
     /*  112477 */     GIR_EraseRootFromParent_Done,
     /*  112478 */   // Label 1832: @112478
     /*  112478 */   GIM_Reject,
     /*  112479 */ // Label 1830: @112479
     /*  112479 */ GIM_Reject,
     /*  112480 */ // Label 1770: @112480
     /*  112480 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(112594),
     /*  112485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  112488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  112491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112503 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(112548), // Rule ID 51156 //
     /*  112508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112511 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  112514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  112528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112546 */     GIR_RootConstrainSelectedInstOperands,
     /*  112547 */     // GIR_Coverage, 51156,
     /*  112547 */     GIR_EraseRootFromParent_Done,
     /*  112548 */   // Label 1834: @112548
     /*  112548 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(112593), // Rule ID 51157 //
     /*  112553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112556 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  112559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  112573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112591 */     GIR_RootConstrainSelectedInstOperands,
     /*  112592 */     // GIR_Coverage, 51157,
     /*  112592 */     GIR_EraseRootFromParent_Done,
     /*  112593 */   // Label 1835: @112593
     /*  112593 */   GIM_Reject,
     /*  112594 */ // Label 1833: @112594
     /*  112594 */ GIM_Reject,
     /*  112595 */ // Label 1771: @112595
     /*  112595 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(112709),
     /*  112600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  112603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  112606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112618 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(112663), // Rule ID 51172 //
     /*  112623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112626 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  112629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  112643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112661 */     GIR_RootConstrainSelectedInstOperands,
     /*  112662 */     // GIR_Coverage, 51172,
     /*  112662 */     GIR_EraseRootFromParent_Done,
     /*  112663 */   // Label 1837: @112663
     /*  112663 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(112708), // Rule ID 51173 //
     /*  112668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112671 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  112674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  112688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112706 */     GIR_RootConstrainSelectedInstOperands,
     /*  112707 */     // GIR_Coverage, 51173,
     /*  112707 */     GIR_EraseRootFromParent_Done,
     /*  112708 */   // Label 1838: @112708
     /*  112708 */   GIM_Reject,
     /*  112709 */ // Label 1836: @112709
     /*  112709 */ GIM_Reject,
     /*  112710 */ // Label 1772: @112710
     /*  112710 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(112824),
     /*  112715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  112718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  112721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112733 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(112778), // Rule ID 51160 //
     /*  112738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112741 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  112744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  112758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112776 */     GIR_RootConstrainSelectedInstOperands,
     /*  112777 */     // GIR_Coverage, 51160,
     /*  112777 */     GIR_EraseRootFromParent_Done,
     /*  112778 */   // Label 1840: @112778
     /*  112778 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(112823), // Rule ID 51161 //
     /*  112783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112786 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  112789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  112803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112821 */     GIR_RootConstrainSelectedInstOperands,
     /*  112822 */     // GIR_Coverage, 51161,
     /*  112822 */     GIR_EraseRootFromParent_Done,
     /*  112823 */   // Label 1841: @112823
     /*  112823 */   GIM_Reject,
     /*  112824 */ // Label 1839: @112824
     /*  112824 */ GIM_Reject,
     /*  112825 */ // Label 1773: @112825
     /*  112825 */ GIM_Reject,
     /*  112826 */ // Label 5: @112826
     /*  112826 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1866*/ GIMT_Encode4(115604),
     /*  112837 */ /*GILLT_s32*//*Label 1842*/ GIMT_Encode4(112961),
     /*  112841 */ /*GILLT_s64*//*Label 1843*/ GIMT_Encode4(112995), GIMT_Encode4(0),
     /*  112849 */ /*GILLT_nxv1s8*//*Label 1844*/ GIMT_Encode4(113074),
     /*  112853 */ /*GILLT_nxv1s16*//*Label 1845*/ GIMT_Encode4(113189),
     /*  112857 */ /*GILLT_nxv1s32*//*Label 1846*/ GIMT_Encode4(113304),
     /*  112861 */ /*GILLT_nxv1s64*//*Label 1847*/ GIMT_Encode4(113419), GIMT_Encode4(0),
     /*  112869 */ /*GILLT_nxv2s8*//*Label 1848*/ GIMT_Encode4(113534),
     /*  112873 */ /*GILLT_nxv2s16*//*Label 1849*/ GIMT_Encode4(113649),
     /*  112877 */ /*GILLT_nxv2s32*//*Label 1850*/ GIMT_Encode4(113764),
     /*  112881 */ /*GILLT_nxv2s64*//*Label 1851*/ GIMT_Encode4(113879), GIMT_Encode4(0),
     /*  112889 */ /*GILLT_nxv4s8*//*Label 1852*/ GIMT_Encode4(113994),
     /*  112893 */ /*GILLT_nxv4s16*//*Label 1853*/ GIMT_Encode4(114109),
     /*  112897 */ /*GILLT_nxv4s32*//*Label 1854*/ GIMT_Encode4(114224),
     /*  112901 */ /*GILLT_nxv4s64*//*Label 1855*/ GIMT_Encode4(114339), GIMT_Encode4(0),
     /*  112909 */ /*GILLT_nxv8s8*//*Label 1856*/ GIMT_Encode4(114454),
     /*  112913 */ /*GILLT_nxv8s16*//*Label 1857*/ GIMT_Encode4(114569),
     /*  112917 */ /*GILLT_nxv8s32*//*Label 1858*/ GIMT_Encode4(114684),
     /*  112921 */ /*GILLT_nxv8s64*//*Label 1859*/ GIMT_Encode4(114799), GIMT_Encode4(0),
     /*  112929 */ /*GILLT_nxv16s8*//*Label 1860*/ GIMT_Encode4(114914),
     /*  112933 */ /*GILLT_nxv16s16*//*Label 1861*/ GIMT_Encode4(115029),
     /*  112937 */ /*GILLT_nxv16s32*//*Label 1862*/ GIMT_Encode4(115144), GIMT_Encode4(0),
     /*  112945 */ /*GILLT_nxv32s8*//*Label 1863*/ GIMT_Encode4(115259),
     /*  112949 */ /*GILLT_nxv32s16*//*Label 1864*/ GIMT_Encode4(115374), GIMT_Encode4(0),
     /*  112957 */ /*GILLT_nxv64s8*//*Label 1865*/ GIMT_Encode4(115489),
     /*  112961 */ // Label 1842: @112961
     /*  112961 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(112994), // Rule ID 304 //
     /*  112966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  112969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  112972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  112975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112987 */   // (srem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REM:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  112987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  112992 */   GIR_RootConstrainSelectedInstOperands,
     /*  112993 */   // GIR_Coverage, 304,
     /*  112993 */   GIR_Done,
     /*  112994 */ // Label 1867: @112994
     /*  112994 */ GIM_Reject,
     /*  112995 */ // Label 1843: @112995
     /*  112995 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(113073),
     /*  113000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  113003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113010 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(113049), // Rule ID 313 //
     /*  113015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /*  113018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /*  113025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_sexti32),
     /*  113032 */     // (srem:{ *:[i64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (REMW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::REMW),
     /*  113035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  113042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  113047 */     GIR_RootConstrainSelectedInstOperands,
     /*  113048 */     // GIR_Coverage, 313,
     /*  113048 */     GIR_EraseRootFromParent_Done,
     /*  113049 */   // Label 1869: @113049
     /*  113049 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(113072), // Rule ID 303 //
     /*  113054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  113057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113065 */     // (srem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  113070 */     GIR_RootConstrainSelectedInstOperands,
     /*  113071 */     // GIR_Coverage, 303,
     /*  113071 */     GIR_Done,
     /*  113072 */   // Label 1870: @113072
     /*  113072 */   GIM_Reject,
     /*  113073 */ // Label 1868: @113073
     /*  113073 */ GIM_Reject,
     /*  113074 */ // Label 1844: @113074
     /*  113074 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(113188),
     /*  113079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  113082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  113085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113097 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(113142), // Rule ID 51376 //
     /*  113102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113105 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  113108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  113122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113140 */     GIR_RootConstrainSelectedInstOperands,
     /*  113141 */     // GIR_Coverage, 51376,
     /*  113141 */     GIR_EraseRootFromParent_Done,
     /*  113142 */   // Label 1872: @113142
     /*  113142 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(113187), // Rule ID 51377 //
     /*  113147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113150 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  113153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  113167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113185 */     GIR_RootConstrainSelectedInstOperands,
     /*  113186 */     // GIR_Coverage, 51377,
     /*  113186 */     GIR_EraseRootFromParent_Done,
     /*  113187 */   // Label 1873: @113187
     /*  113187 */   GIM_Reject,
     /*  113188 */ // Label 1871: @113188
     /*  113188 */ GIM_Reject,
     /*  113189 */ // Label 1845: @113189
     /*  113189 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(113303),
     /*  113194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  113197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  113200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113212 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(113257), // Rule ID 51388 //
     /*  113217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113220 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  113223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  113237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113255 */     GIR_RootConstrainSelectedInstOperands,
     /*  113256 */     // GIR_Coverage, 51388,
     /*  113256 */     GIR_EraseRootFromParent_Done,
     /*  113257 */   // Label 1875: @113257
     /*  113257 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(113302), // Rule ID 51389 //
     /*  113262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113265 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  113268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  113282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113300 */     GIR_RootConstrainSelectedInstOperands,
     /*  113301 */     // GIR_Coverage, 51389,
     /*  113301 */     GIR_EraseRootFromParent_Done,
     /*  113302 */   // Label 1876: @113302
     /*  113302 */   GIM_Reject,
     /*  113303 */ // Label 1874: @113303
     /*  113303 */ GIM_Reject,
     /*  113304 */ // Label 1846: @113304
     /*  113304 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(113418),
     /*  113309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  113312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  113315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113327 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(113372), // Rule ID 51396 //
     /*  113332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113335 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  113335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  113338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  113352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113370 */     GIR_RootConstrainSelectedInstOperands,
     /*  113371 */     // GIR_Coverage, 51396,
     /*  113371 */     GIR_EraseRootFromParent_Done,
     /*  113372 */   // Label 1878: @113372
     /*  113372 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(113417), // Rule ID 51397 //
     /*  113377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113380 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  113380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  113383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  113397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113415 */     GIR_RootConstrainSelectedInstOperands,
     /*  113416 */     // GIR_Coverage, 51397,
     /*  113416 */     GIR_EraseRootFromParent_Done,
     /*  113417 */   // Label 1879: @113417
     /*  113417 */   GIM_Reject,
     /*  113418 */ // Label 1877: @113418
     /*  113418 */ GIM_Reject,
     /*  113419 */ // Label 1847: @113419
     /*  113419 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(113533),
     /*  113424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  113427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  113430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113442 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(113487), // Rule ID 51412 //
     /*  113447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  113450 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  113450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  113453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  113467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113485 */     GIR_RootConstrainSelectedInstOperands,
     /*  113486 */     // GIR_Coverage, 51412,
     /*  113486 */     GIR_EraseRootFromParent_Done,
     /*  113487 */   // Label 1881: @113487
     /*  113487 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(113532), // Rule ID 51413 //
     /*  113492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  113495 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  113495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  113498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  113512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113530 */     GIR_RootConstrainSelectedInstOperands,
     /*  113531 */     // GIR_Coverage, 51413,
     /*  113531 */     GIR_EraseRootFromParent_Done,
     /*  113532 */   // Label 1882: @113532
     /*  113532 */   GIM_Reject,
     /*  113533 */ // Label 1880: @113533
     /*  113533 */ GIM_Reject,
     /*  113534 */ // Label 1848: @113534
     /*  113534 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(113648),
     /*  113539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  113542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  113545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113553 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113557 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(113602), // Rule ID 51380 //
     /*  113562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113565 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  113568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  113582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113600 */     GIR_RootConstrainSelectedInstOperands,
     /*  113601 */     // GIR_Coverage, 51380,
     /*  113601 */     GIR_EraseRootFromParent_Done,
     /*  113602 */   // Label 1884: @113602
     /*  113602 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(113647), // Rule ID 51381 //
     /*  113607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113610 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  113613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  113627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113645 */     GIR_RootConstrainSelectedInstOperands,
     /*  113646 */     // GIR_Coverage, 51381,
     /*  113646 */     GIR_EraseRootFromParent_Done,
     /*  113647 */   // Label 1885: @113647
     /*  113647 */   GIM_Reject,
     /*  113648 */ // Label 1883: @113648
     /*  113648 */ GIM_Reject,
     /*  113649 */ // Label 1849: @113649
     /*  113649 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(113763),
     /*  113654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  113657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  113660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113672 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(113717), // Rule ID 51392 //
     /*  113677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113680 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  113683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  113697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113715 */     GIR_RootConstrainSelectedInstOperands,
     /*  113716 */     // GIR_Coverage, 51392,
     /*  113716 */     GIR_EraseRootFromParent_Done,
     /*  113717 */   // Label 1887: @113717
     /*  113717 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(113762), // Rule ID 51393 //
     /*  113722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113725 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  113728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  113742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113760 */     GIR_RootConstrainSelectedInstOperands,
     /*  113761 */     // GIR_Coverage, 51393,
     /*  113761 */     GIR_EraseRootFromParent_Done,
     /*  113762 */   // Label 1888: @113762
     /*  113762 */   GIM_Reject,
     /*  113763 */ // Label 1886: @113763
     /*  113763 */ GIM_Reject,
     /*  113764 */ // Label 1850: @113764
     /*  113764 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(113878),
     /*  113769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  113772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  113775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113787 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(113832), // Rule ID 51408 //
     /*  113792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113795 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  113795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  113798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  113812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113830 */     GIR_RootConstrainSelectedInstOperands,
     /*  113831 */     // GIR_Coverage, 51408,
     /*  113831 */     GIR_EraseRootFromParent_Done,
     /*  113832 */   // Label 1890: @113832
     /*  113832 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(113877), // Rule ID 51409 //
     /*  113837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113840 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  113840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  113843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  113857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113875 */     GIR_RootConstrainSelectedInstOperands,
     /*  113876 */     // GIR_Coverage, 51409,
     /*  113876 */     GIR_EraseRootFromParent_Done,
     /*  113877 */   // Label 1891: @113877
     /*  113877 */   GIM_Reject,
     /*  113878 */ // Label 1889: @113878
     /*  113878 */ GIM_Reject,
     /*  113879 */ // Label 1851: @113879
     /*  113879 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(113993),
     /*  113884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  113887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  113890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113902 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(113947), // Rule ID 51452 //
     /*  113907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  113910 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  113910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  113913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  113927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113945 */     GIR_RootConstrainSelectedInstOperands,
     /*  113946 */     // GIR_Coverage, 51452,
     /*  113946 */     GIR_EraseRootFromParent_Done,
     /*  113947 */   // Label 1893: @113947
     /*  113947 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(113992), // Rule ID 51453 //
     /*  113952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  113955 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  113955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  113958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  113972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113990 */     GIR_RootConstrainSelectedInstOperands,
     /*  113991 */     // GIR_Coverage, 51453,
     /*  113991 */     GIR_EraseRootFromParent_Done,
     /*  113992 */   // Label 1894: @113992
     /*  113992 */   GIM_Reject,
     /*  113993 */ // Label 1892: @113993
     /*  113993 */ GIM_Reject,
     /*  113994 */ // Label 1852: @113994
     /*  113994 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(114108),
     /*  113999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  114002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  114005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114017 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(114062), // Rule ID 51384 //
     /*  114022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114025 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  114028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  114042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114060 */     GIR_RootConstrainSelectedInstOperands,
     /*  114061 */     // GIR_Coverage, 51384,
     /*  114061 */     GIR_EraseRootFromParent_Done,
     /*  114062 */   // Label 1896: @114062
     /*  114062 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(114107), // Rule ID 51385 //
     /*  114067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114070 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  114073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  114087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114105 */     GIR_RootConstrainSelectedInstOperands,
     /*  114106 */     // GIR_Coverage, 51385,
     /*  114106 */     GIR_EraseRootFromParent_Done,
     /*  114107 */   // Label 1897: @114107
     /*  114107 */   GIM_Reject,
     /*  114108 */ // Label 1895: @114108
     /*  114108 */ GIM_Reject,
     /*  114109 */ // Label 1853: @114109
     /*  114109 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(114223),
     /*  114114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  114117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  114120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114132 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(114177), // Rule ID 51404 //
     /*  114137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114140 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  114140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  114143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  114157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114175 */     GIR_RootConstrainSelectedInstOperands,
     /*  114176 */     // GIR_Coverage, 51404,
     /*  114176 */     GIR_EraseRootFromParent_Done,
     /*  114177 */   // Label 1899: @114177
     /*  114177 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(114222), // Rule ID 51405 //
     /*  114182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114185 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  114185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  114188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  114202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114220 */     GIR_RootConstrainSelectedInstOperands,
     /*  114221 */     // GIR_Coverage, 51405,
     /*  114221 */     GIR_EraseRootFromParent_Done,
     /*  114222 */   // Label 1900: @114222
     /*  114222 */   GIM_Reject,
     /*  114223 */ // Label 1898: @114223
     /*  114223 */ GIM_Reject,
     /*  114224 */ // Label 1854: @114224
     /*  114224 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(114338),
     /*  114229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  114232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  114235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114247 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(114292), // Rule ID 51440 //
     /*  114252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114255 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  114255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  114258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  114272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114290 */     GIR_RootConstrainSelectedInstOperands,
     /*  114291 */     // GIR_Coverage, 51440,
     /*  114291 */     GIR_EraseRootFromParent_Done,
     /*  114292 */   // Label 1902: @114292
     /*  114292 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(114337), // Rule ID 51441 //
     /*  114297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114300 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  114300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  114303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  114317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114335 */     GIR_RootConstrainSelectedInstOperands,
     /*  114336 */     // GIR_Coverage, 51441,
     /*  114336 */     GIR_EraseRootFromParent_Done,
     /*  114337 */   // Label 1903: @114337
     /*  114337 */   GIM_Reject,
     /*  114338 */ // Label 1901: @114338
     /*  114338 */ GIM_Reject,
     /*  114339 */ // Label 1855: @114339
     /*  114339 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(114453),
     /*  114344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  114347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  114350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114362 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(114407), // Rule ID 51456 //
     /*  114367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  114370 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  114370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  114373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  114387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114405 */     GIR_RootConstrainSelectedInstOperands,
     /*  114406 */     // GIR_Coverage, 51456,
     /*  114406 */     GIR_EraseRootFromParent_Done,
     /*  114407 */   // Label 1905: @114407
     /*  114407 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(114452), // Rule ID 51457 //
     /*  114412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  114415 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  114415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  114418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  114432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114450 */     GIR_RootConstrainSelectedInstOperands,
     /*  114451 */     // GIR_Coverage, 51457,
     /*  114451 */     GIR_EraseRootFromParent_Done,
     /*  114452 */   // Label 1906: @114452
     /*  114452 */   GIM_Reject,
     /*  114453 */ // Label 1904: @114453
     /*  114453 */ GIM_Reject,
     /*  114454 */ // Label 1856: @114454
     /*  114454 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(114568),
     /*  114459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  114462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  114465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114477 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(114522), // Rule ID 51400 //
     /*  114482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114485 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  114488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  114502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114520 */     GIR_RootConstrainSelectedInstOperands,
     /*  114521 */     // GIR_Coverage, 51400,
     /*  114521 */     GIR_EraseRootFromParent_Done,
     /*  114522 */   // Label 1908: @114522
     /*  114522 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(114567), // Rule ID 51401 //
     /*  114527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114530 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  114533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  114547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114565 */     GIR_RootConstrainSelectedInstOperands,
     /*  114566 */     // GIR_Coverage, 51401,
     /*  114566 */     GIR_EraseRootFromParent_Done,
     /*  114567 */   // Label 1909: @114567
     /*  114567 */   GIM_Reject,
     /*  114568 */ // Label 1907: @114568
     /*  114568 */ GIM_Reject,
     /*  114569 */ // Label 1857: @114569
     /*  114569 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(114683),
     /*  114574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  114577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  114580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114592 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(114637), // Rule ID 51428 //
     /*  114597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114600 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  114600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  114603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  114617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114635 */     GIR_RootConstrainSelectedInstOperands,
     /*  114636 */     // GIR_Coverage, 51428,
     /*  114636 */     GIR_EraseRootFromParent_Done,
     /*  114637 */   // Label 1911: @114637
     /*  114637 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(114682), // Rule ID 51429 //
     /*  114642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114645 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  114645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  114648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  114662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114680 */     GIR_RootConstrainSelectedInstOperands,
     /*  114681 */     // GIR_Coverage, 51429,
     /*  114681 */     GIR_EraseRootFromParent_Done,
     /*  114682 */   // Label 1912: @114682
     /*  114682 */   GIM_Reject,
     /*  114683 */ // Label 1910: @114683
     /*  114683 */ GIM_Reject,
     /*  114684 */ // Label 1858: @114684
     /*  114684 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(114798),
     /*  114689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  114692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  114695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114707 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(114752), // Rule ID 51444 //
     /*  114712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114715 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  114715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  114718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  114732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114750 */     GIR_RootConstrainSelectedInstOperands,
     /*  114751 */     // GIR_Coverage, 51444,
     /*  114751 */     GIR_EraseRootFromParent_Done,
     /*  114752 */   // Label 1914: @114752
     /*  114752 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(114797), // Rule ID 51445 //
     /*  114757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114760 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  114760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  114763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  114777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114795 */     GIR_RootConstrainSelectedInstOperands,
     /*  114796 */     // GIR_Coverage, 51445,
     /*  114796 */     GIR_EraseRootFromParent_Done,
     /*  114797 */   // Label 1915: @114797
     /*  114797 */   GIM_Reject,
     /*  114798 */ // Label 1913: @114798
     /*  114798 */ GIM_Reject,
     /*  114799 */ // Label 1859: @114799
     /*  114799 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(114913),
     /*  114804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  114807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  114810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114822 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(114867), // Rule ID 51460 //
     /*  114827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  114830 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  114830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  114833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  114847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114865 */     GIR_RootConstrainSelectedInstOperands,
     /*  114866 */     // GIR_Coverage, 51460,
     /*  114866 */     GIR_EraseRootFromParent_Done,
     /*  114867 */   // Label 1917: @114867
     /*  114867 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(114912), // Rule ID 51461 //
     /*  114872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  114875 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  114875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  114878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  114892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114910 */     GIR_RootConstrainSelectedInstOperands,
     /*  114911 */     // GIR_Coverage, 51461,
     /*  114911 */     GIR_EraseRootFromParent_Done,
     /*  114912 */   // Label 1918: @114912
     /*  114912 */   GIM_Reject,
     /*  114913 */ // Label 1916: @114913
     /*  114913 */ GIM_Reject,
     /*  114914 */ // Label 1860: @114914
     /*  114914 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(115028),
     /*  114919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  114922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  114925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114937 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(114982), // Rule ID 51416 //
     /*  114942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114945 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  114948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  114962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114980 */     GIR_RootConstrainSelectedInstOperands,
     /*  114981 */     // GIR_Coverage, 51416,
     /*  114981 */     GIR_EraseRootFromParent_Done,
     /*  114982 */   // Label 1920: @114982
     /*  114982 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(115027), // Rule ID 51417 //
     /*  114987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114990 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  114993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  115007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115025 */     GIR_RootConstrainSelectedInstOperands,
     /*  115026 */     // GIR_Coverage, 51417,
     /*  115026 */     GIR_EraseRootFromParent_Done,
     /*  115027 */   // Label 1921: @115027
     /*  115027 */   GIM_Reject,
     /*  115028 */ // Label 1919: @115028
     /*  115028 */ GIM_Reject,
     /*  115029 */ // Label 1861: @115029
     /*  115029 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(115143),
     /*  115034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  115037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  115040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115052 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(115097), // Rule ID 51432 //
     /*  115057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115060 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  115063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  115077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115095 */     GIR_RootConstrainSelectedInstOperands,
     /*  115096 */     // GIR_Coverage, 51432,
     /*  115096 */     GIR_EraseRootFromParent_Done,
     /*  115097 */   // Label 1923: @115097
     /*  115097 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(115142), // Rule ID 51433 //
     /*  115102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115105 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  115108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  115122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115140 */     GIR_RootConstrainSelectedInstOperands,
     /*  115141 */     // GIR_Coverage, 51433,
     /*  115141 */     GIR_EraseRootFromParent_Done,
     /*  115142 */   // Label 1924: @115142
     /*  115142 */   GIM_Reject,
     /*  115143 */ // Label 1922: @115143
     /*  115143 */ GIM_Reject,
     /*  115144 */ // Label 1862: @115144
     /*  115144 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(115258),
     /*  115149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  115152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  115155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115167 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(115212), // Rule ID 51448 //
     /*  115172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115175 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  115175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  115178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  115192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115210 */     GIR_RootConstrainSelectedInstOperands,
     /*  115211 */     // GIR_Coverage, 51448,
     /*  115211 */     GIR_EraseRootFromParent_Done,
     /*  115212 */   // Label 1926: @115212
     /*  115212 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(115257), // Rule ID 51449 //
     /*  115217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115220 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  115220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  115223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  115237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115255 */     GIR_RootConstrainSelectedInstOperands,
     /*  115256 */     // GIR_Coverage, 51449,
     /*  115256 */     GIR_EraseRootFromParent_Done,
     /*  115257 */   // Label 1927: @115257
     /*  115257 */   GIM_Reject,
     /*  115258 */ // Label 1925: @115258
     /*  115258 */ GIM_Reject,
     /*  115259 */ // Label 1863: @115259
     /*  115259 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(115373),
     /*  115264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  115267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  115270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115282 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(115327), // Rule ID 51420 //
     /*  115287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115290 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  115293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  115307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115325 */     GIR_RootConstrainSelectedInstOperands,
     /*  115326 */     // GIR_Coverage, 51420,
     /*  115326 */     GIR_EraseRootFromParent_Done,
     /*  115327 */   // Label 1929: @115327
     /*  115327 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(115372), // Rule ID 51421 //
     /*  115332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115335 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  115338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  115352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115370 */     GIR_RootConstrainSelectedInstOperands,
     /*  115371 */     // GIR_Coverage, 51421,
     /*  115371 */     GIR_EraseRootFromParent_Done,
     /*  115372 */   // Label 1930: @115372
     /*  115372 */   GIM_Reject,
     /*  115373 */ // Label 1928: @115373
     /*  115373 */ GIM_Reject,
     /*  115374 */ // Label 1864: @115374
     /*  115374 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(115488),
     /*  115379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  115382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  115385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115397 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(115442), // Rule ID 51436 //
     /*  115402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115405 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  115408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  115422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115440 */     GIR_RootConstrainSelectedInstOperands,
     /*  115441 */     // GIR_Coverage, 51436,
     /*  115441 */     GIR_EraseRootFromParent_Done,
     /*  115442 */   // Label 1932: @115442
     /*  115442 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(115487), // Rule ID 51437 //
     /*  115447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115450 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  115453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  115467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115485 */     GIR_RootConstrainSelectedInstOperands,
     /*  115486 */     // GIR_Coverage, 51437,
     /*  115486 */     GIR_EraseRootFromParent_Done,
     /*  115487 */   // Label 1933: @115487
     /*  115487 */   GIM_Reject,
     /*  115488 */ // Label 1931: @115488
     /*  115488 */ GIM_Reject,
     /*  115489 */ // Label 1865: @115489
     /*  115489 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(115603),
     /*  115494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  115497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  115500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115512 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(115557), // Rule ID 51424 //
     /*  115517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115520 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  115523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  115537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115555 */     GIR_RootConstrainSelectedInstOperands,
     /*  115556 */     // GIR_Coverage, 51424,
     /*  115556 */     GIR_EraseRootFromParent_Done,
     /*  115557 */   // Label 1935: @115557
     /*  115557 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(115602), // Rule ID 51425 //
     /*  115562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115565 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  115568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  115582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115600 */     GIR_RootConstrainSelectedInstOperands,
     /*  115601 */     // GIR_Coverage, 51425,
     /*  115601 */     GIR_EraseRootFromParent_Done,
     /*  115602 */   // Label 1936: @115602
     /*  115602 */   GIM_Reject,
     /*  115603 */ // Label 1934: @115603
     /*  115603 */ GIM_Reject,
     /*  115604 */ // Label 1866: @115604
     /*  115604 */ GIM_Reject,
     /*  115605 */ // Label 6: @115605
     /*  115605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1961*/ GIMT_Encode4(118338),
     /*  115616 */ /*GILLT_s32*//*Label 1937*/ GIMT_Encode4(115740),
     /*  115620 */ /*GILLT_s64*//*Label 1938*/ GIMT_Encode4(115774), GIMT_Encode4(0),
     /*  115628 */ /*GILLT_nxv1s8*//*Label 1939*/ GIMT_Encode4(115808),
     /*  115632 */ /*GILLT_nxv1s16*//*Label 1940*/ GIMT_Encode4(115923),
     /*  115636 */ /*GILLT_nxv1s32*//*Label 1941*/ GIMT_Encode4(116038),
     /*  115640 */ /*GILLT_nxv1s64*//*Label 1942*/ GIMT_Encode4(116153), GIMT_Encode4(0),
     /*  115648 */ /*GILLT_nxv2s8*//*Label 1943*/ GIMT_Encode4(116268),
     /*  115652 */ /*GILLT_nxv2s16*//*Label 1944*/ GIMT_Encode4(116383),
     /*  115656 */ /*GILLT_nxv2s32*//*Label 1945*/ GIMT_Encode4(116498),
     /*  115660 */ /*GILLT_nxv2s64*//*Label 1946*/ GIMT_Encode4(116613), GIMT_Encode4(0),
     /*  115668 */ /*GILLT_nxv4s8*//*Label 1947*/ GIMT_Encode4(116728),
     /*  115672 */ /*GILLT_nxv4s16*//*Label 1948*/ GIMT_Encode4(116843),
     /*  115676 */ /*GILLT_nxv4s32*//*Label 1949*/ GIMT_Encode4(116958),
     /*  115680 */ /*GILLT_nxv4s64*//*Label 1950*/ GIMT_Encode4(117073), GIMT_Encode4(0),
     /*  115688 */ /*GILLT_nxv8s8*//*Label 1951*/ GIMT_Encode4(117188),
     /*  115692 */ /*GILLT_nxv8s16*//*Label 1952*/ GIMT_Encode4(117303),
     /*  115696 */ /*GILLT_nxv8s32*//*Label 1953*/ GIMT_Encode4(117418),
     /*  115700 */ /*GILLT_nxv8s64*//*Label 1954*/ GIMT_Encode4(117533), GIMT_Encode4(0),
     /*  115708 */ /*GILLT_nxv16s8*//*Label 1955*/ GIMT_Encode4(117648),
     /*  115712 */ /*GILLT_nxv16s16*//*Label 1956*/ GIMT_Encode4(117763),
     /*  115716 */ /*GILLT_nxv16s32*//*Label 1957*/ GIMT_Encode4(117878), GIMT_Encode4(0),
     /*  115724 */ /*GILLT_nxv32s8*//*Label 1958*/ GIMT_Encode4(117993),
     /*  115728 */ /*GILLT_nxv32s16*//*Label 1959*/ GIMT_Encode4(118108), GIMT_Encode4(0),
     /*  115736 */ /*GILLT_nxv64s8*//*Label 1960*/ GIMT_Encode4(118223),
     /*  115740 */ // Label 1937: @115740
     /*  115740 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(115773), // Rule ID 306 //
     /*  115745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  115748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  115751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  115754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115766 */   // (urem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REMU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  115766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  115771 */   GIR_RootConstrainSelectedInstOperands,
     /*  115772 */   // GIR_Coverage, 306,
     /*  115772 */   GIR_Done,
     /*  115773 */ // Label 1962: @115773
     /*  115773 */ GIM_Reject,
     /*  115774 */ // Label 1938: @115774
     /*  115774 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(115807), // Rule ID 305 //
     /*  115779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  115782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  115785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  115788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115800 */   // (urem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  115800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  115805 */   GIR_RootConstrainSelectedInstOperands,
     /*  115806 */   // GIR_Coverage, 305,
     /*  115806 */   GIR_Done,
     /*  115807 */ // Label 1963: @115807
     /*  115807 */ GIM_Reject,
     /*  115808 */ // Label 1939: @115808
     /*  115808 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(115922),
     /*  115813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  115816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  115819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115831 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(115876), // Rule ID 51288 //
     /*  115836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115839 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  115842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  115856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115874 */     GIR_RootConstrainSelectedInstOperands,
     /*  115875 */     // GIR_Coverage, 51288,
     /*  115875 */     GIR_EraseRootFromParent_Done,
     /*  115876 */   // Label 1965: @115876
     /*  115876 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(115921), // Rule ID 51289 //
     /*  115881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115884 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  115887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  115901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115919 */     GIR_RootConstrainSelectedInstOperands,
     /*  115920 */     // GIR_Coverage, 51289,
     /*  115920 */     GIR_EraseRootFromParent_Done,
     /*  115921 */   // Label 1966: @115921
     /*  115921 */   GIM_Reject,
     /*  115922 */ // Label 1964: @115922
     /*  115922 */ GIM_Reject,
     /*  115923 */ // Label 1940: @115923
     /*  115923 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(116037),
     /*  115928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  115931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  115934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115942 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115946 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(115991), // Rule ID 51300 //
     /*  115951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115954 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  115957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  115971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115989 */     GIR_RootConstrainSelectedInstOperands,
     /*  115990 */     // GIR_Coverage, 51300,
     /*  115990 */     GIR_EraseRootFromParent_Done,
     /*  115991 */   // Label 1968: @115991
     /*  115991 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(116036), // Rule ID 51301 //
     /*  115996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115999 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  116002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  116016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116034 */     GIR_RootConstrainSelectedInstOperands,
     /*  116035 */     // GIR_Coverage, 51301,
     /*  116035 */     GIR_EraseRootFromParent_Done,
     /*  116036 */   // Label 1969: @116036
     /*  116036 */   GIM_Reject,
     /*  116037 */ // Label 1967: @116037
     /*  116037 */ GIM_Reject,
     /*  116038 */ // Label 1941: @116038
     /*  116038 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(116152),
     /*  116043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  116046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  116049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116061 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(116106), // Rule ID 51308 //
     /*  116066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116069 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  116072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  116086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116104 */     GIR_RootConstrainSelectedInstOperands,
     /*  116105 */     // GIR_Coverage, 51308,
     /*  116105 */     GIR_EraseRootFromParent_Done,
     /*  116106 */   // Label 1971: @116106
     /*  116106 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(116151), // Rule ID 51309 //
     /*  116111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116114 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  116114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  116117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  116131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116149 */     GIR_RootConstrainSelectedInstOperands,
     /*  116150 */     // GIR_Coverage, 51309,
     /*  116150 */     GIR_EraseRootFromParent_Done,
     /*  116151 */   // Label 1972: @116151
     /*  116151 */   GIM_Reject,
     /*  116152 */ // Label 1970: @116152
     /*  116152 */ GIM_Reject,
     /*  116153 */ // Label 1942: @116153
     /*  116153 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(116267),
     /*  116158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  116161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  116164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116176 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(116221), // Rule ID 51324 //
     /*  116181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  116184 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  116184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  116187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  116201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116219 */     GIR_RootConstrainSelectedInstOperands,
     /*  116220 */     // GIR_Coverage, 51324,
     /*  116220 */     GIR_EraseRootFromParent_Done,
     /*  116221 */   // Label 1974: @116221
     /*  116221 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(116266), // Rule ID 51325 //
     /*  116226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  116229 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  116229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  116232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  116246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116264 */     GIR_RootConstrainSelectedInstOperands,
     /*  116265 */     // GIR_Coverage, 51325,
     /*  116265 */     GIR_EraseRootFromParent_Done,
     /*  116266 */   // Label 1975: @116266
     /*  116266 */   GIM_Reject,
     /*  116267 */ // Label 1973: @116267
     /*  116267 */ GIM_Reject,
     /*  116268 */ // Label 1943: @116268
     /*  116268 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(116382),
     /*  116273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  116276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  116279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116291 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(116336), // Rule ID 51292 //
     /*  116296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116299 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  116299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  116302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  116316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116334 */     GIR_RootConstrainSelectedInstOperands,
     /*  116335 */     // GIR_Coverage, 51292,
     /*  116335 */     GIR_EraseRootFromParent_Done,
     /*  116336 */   // Label 1977: @116336
     /*  116336 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(116381), // Rule ID 51293 //
     /*  116341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116344 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  116347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  116361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116379 */     GIR_RootConstrainSelectedInstOperands,
     /*  116380 */     // GIR_Coverage, 51293,
     /*  116380 */     GIR_EraseRootFromParent_Done,
     /*  116381 */   // Label 1978: @116381
     /*  116381 */   GIM_Reject,
     /*  116382 */ // Label 1976: @116382
     /*  116382 */ GIM_Reject,
     /*  116383 */ // Label 1944: @116383
     /*  116383 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(116497),
     /*  116388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  116391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  116394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116406 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(116451), // Rule ID 51304 //
     /*  116411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116414 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  116414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  116417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  116431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116449 */     GIR_RootConstrainSelectedInstOperands,
     /*  116450 */     // GIR_Coverage, 51304,
     /*  116450 */     GIR_EraseRootFromParent_Done,
     /*  116451 */   // Label 1980: @116451
     /*  116451 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(116496), // Rule ID 51305 //
     /*  116456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116459 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  116459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  116462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  116476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116494 */     GIR_RootConstrainSelectedInstOperands,
     /*  116495 */     // GIR_Coverage, 51305,
     /*  116495 */     GIR_EraseRootFromParent_Done,
     /*  116496 */   // Label 1981: @116496
     /*  116496 */   GIM_Reject,
     /*  116497 */ // Label 1979: @116497
     /*  116497 */ GIM_Reject,
     /*  116498 */ // Label 1945: @116498
     /*  116498 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(116612),
     /*  116503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  116506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  116509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116521 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(116566), // Rule ID 51320 //
     /*  116526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116529 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  116532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  116546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116564 */     GIR_RootConstrainSelectedInstOperands,
     /*  116565 */     // GIR_Coverage, 51320,
     /*  116565 */     GIR_EraseRootFromParent_Done,
     /*  116566 */   // Label 1983: @116566
     /*  116566 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(116611), // Rule ID 51321 //
     /*  116571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116574 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  116574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  116577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  116591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116609 */     GIR_RootConstrainSelectedInstOperands,
     /*  116610 */     // GIR_Coverage, 51321,
     /*  116610 */     GIR_EraseRootFromParent_Done,
     /*  116611 */   // Label 1984: @116611
     /*  116611 */   GIM_Reject,
     /*  116612 */ // Label 1982: @116612
     /*  116612 */ GIM_Reject,
     /*  116613 */ // Label 1946: @116613
     /*  116613 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(116727),
     /*  116618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  116621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  116624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116636 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(116681), // Rule ID 51364 //
     /*  116641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  116644 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  116644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  116647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  116661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116679 */     GIR_RootConstrainSelectedInstOperands,
     /*  116680 */     // GIR_Coverage, 51364,
     /*  116680 */     GIR_EraseRootFromParent_Done,
     /*  116681 */   // Label 1986: @116681
     /*  116681 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(116726), // Rule ID 51365 //
     /*  116686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  116689 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  116689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  116692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  116706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116724 */     GIR_RootConstrainSelectedInstOperands,
     /*  116725 */     // GIR_Coverage, 51365,
     /*  116725 */     GIR_EraseRootFromParent_Done,
     /*  116726 */   // Label 1987: @116726
     /*  116726 */   GIM_Reject,
     /*  116727 */ // Label 1985: @116727
     /*  116727 */ GIM_Reject,
     /*  116728 */ // Label 1947: @116728
     /*  116728 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(116842),
     /*  116733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  116736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  116739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116751 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(116796), // Rule ID 51296 //
     /*  116756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116759 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  116759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  116762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  116776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116794 */     GIR_RootConstrainSelectedInstOperands,
     /*  116795 */     // GIR_Coverage, 51296,
     /*  116795 */     GIR_EraseRootFromParent_Done,
     /*  116796 */   // Label 1989: @116796
     /*  116796 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(116841), // Rule ID 51297 //
     /*  116801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116804 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  116807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  116821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116839 */     GIR_RootConstrainSelectedInstOperands,
     /*  116840 */     // GIR_Coverage, 51297,
     /*  116840 */     GIR_EraseRootFromParent_Done,
     /*  116841 */   // Label 1990: @116841
     /*  116841 */   GIM_Reject,
     /*  116842 */ // Label 1988: @116842
     /*  116842 */ GIM_Reject,
     /*  116843 */ // Label 1948: @116843
     /*  116843 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(116957),
     /*  116848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  116851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  116854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116866 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(116911), // Rule ID 51316 //
     /*  116871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116874 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  116874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  116877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  116891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116909 */     GIR_RootConstrainSelectedInstOperands,
     /*  116910 */     // GIR_Coverage, 51316,
     /*  116910 */     GIR_EraseRootFromParent_Done,
     /*  116911 */   // Label 1992: @116911
     /*  116911 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(116956), // Rule ID 51317 //
     /*  116916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116919 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  116919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  116922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  116936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116954 */     GIR_RootConstrainSelectedInstOperands,
     /*  116955 */     // GIR_Coverage, 51317,
     /*  116955 */     GIR_EraseRootFromParent_Done,
     /*  116956 */   // Label 1993: @116956
     /*  116956 */   GIM_Reject,
     /*  116957 */ // Label 1991: @116957
     /*  116957 */ GIM_Reject,
     /*  116958 */ // Label 1949: @116958
     /*  116958 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(117072),
     /*  116963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  116966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  116969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116981 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(117026), // Rule ID 51352 //
     /*  116986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116989 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  116992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  117006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117024 */     GIR_RootConstrainSelectedInstOperands,
     /*  117025 */     // GIR_Coverage, 51352,
     /*  117025 */     GIR_EraseRootFromParent_Done,
     /*  117026 */   // Label 1995: @117026
     /*  117026 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(117071), // Rule ID 51353 //
     /*  117031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117034 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  117037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  117051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117069 */     GIR_RootConstrainSelectedInstOperands,
     /*  117070 */     // GIR_Coverage, 51353,
     /*  117070 */     GIR_EraseRootFromParent_Done,
     /*  117071 */   // Label 1996: @117071
     /*  117071 */   GIM_Reject,
     /*  117072 */ // Label 1994: @117072
     /*  117072 */ GIM_Reject,
     /*  117073 */ // Label 1950: @117073
     /*  117073 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(117187),
     /*  117078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  117081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  117084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117096 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(117141), // Rule ID 51368 //
     /*  117101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  117104 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  117104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  117107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  117121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117139 */     GIR_RootConstrainSelectedInstOperands,
     /*  117140 */     // GIR_Coverage, 51368,
     /*  117140 */     GIR_EraseRootFromParent_Done,
     /*  117141 */   // Label 1998: @117141
     /*  117141 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(117186), // Rule ID 51369 //
     /*  117146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  117149 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  117149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  117152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  117166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117184 */     GIR_RootConstrainSelectedInstOperands,
     /*  117185 */     // GIR_Coverage, 51369,
     /*  117185 */     GIR_EraseRootFromParent_Done,
     /*  117186 */   // Label 1999: @117186
     /*  117186 */   GIM_Reject,
     /*  117187 */ // Label 1997: @117187
     /*  117187 */ GIM_Reject,
     /*  117188 */ // Label 1951: @117188
     /*  117188 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(117302),
     /*  117193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  117196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  117199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117207 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117211 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(117256), // Rule ID 51312 //
     /*  117216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117219 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  117219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  117222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  117236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117254 */     GIR_RootConstrainSelectedInstOperands,
     /*  117255 */     // GIR_Coverage, 51312,
     /*  117255 */     GIR_EraseRootFromParent_Done,
     /*  117256 */   // Label 2001: @117256
     /*  117256 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(117301), // Rule ID 51313 //
     /*  117261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117264 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  117264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  117267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  117281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117299 */     GIR_RootConstrainSelectedInstOperands,
     /*  117300 */     // GIR_Coverage, 51313,
     /*  117300 */     GIR_EraseRootFromParent_Done,
     /*  117301 */   // Label 2002: @117301
     /*  117301 */   GIM_Reject,
     /*  117302 */ // Label 2000: @117302
     /*  117302 */ GIM_Reject,
     /*  117303 */ // Label 1952: @117303
     /*  117303 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(117417),
     /*  117308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  117311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  117314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117326 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(117371), // Rule ID 51340 //
     /*  117331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117334 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  117334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  117337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  117351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117369 */     GIR_RootConstrainSelectedInstOperands,
     /*  117370 */     // GIR_Coverage, 51340,
     /*  117370 */     GIR_EraseRootFromParent_Done,
     /*  117371 */   // Label 2004: @117371
     /*  117371 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(117416), // Rule ID 51341 //
     /*  117376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117379 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  117379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  117382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  117396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117414 */     GIR_RootConstrainSelectedInstOperands,
     /*  117415 */     // GIR_Coverage, 51341,
     /*  117415 */     GIR_EraseRootFromParent_Done,
     /*  117416 */   // Label 2005: @117416
     /*  117416 */   GIM_Reject,
     /*  117417 */ // Label 2003: @117417
     /*  117417 */ GIM_Reject,
     /*  117418 */ // Label 1953: @117418
     /*  117418 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(117532),
     /*  117423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  117426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  117429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117441 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(117486), // Rule ID 51356 //
     /*  117446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117449 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  117452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  117466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117484 */     GIR_RootConstrainSelectedInstOperands,
     /*  117485 */     // GIR_Coverage, 51356,
     /*  117485 */     GIR_EraseRootFromParent_Done,
     /*  117486 */   // Label 2007: @117486
     /*  117486 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(117531), // Rule ID 51357 //
     /*  117491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117494 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  117497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  117511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117529 */     GIR_RootConstrainSelectedInstOperands,
     /*  117530 */     // GIR_Coverage, 51357,
     /*  117530 */     GIR_EraseRootFromParent_Done,
     /*  117531 */   // Label 2008: @117531
     /*  117531 */   GIM_Reject,
     /*  117532 */ // Label 2006: @117532
     /*  117532 */ GIM_Reject,
     /*  117533 */ // Label 1954: @117533
     /*  117533 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(117647),
     /*  117538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  117541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  117544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117556 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(117601), // Rule ID 51372 //
     /*  117561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  117564 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  117564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  117567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  117581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117599 */     GIR_RootConstrainSelectedInstOperands,
     /*  117600 */     // GIR_Coverage, 51372,
     /*  117600 */     GIR_EraseRootFromParent_Done,
     /*  117601 */   // Label 2010: @117601
     /*  117601 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(117646), // Rule ID 51373 //
     /*  117606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  117609 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  117609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  117612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  117626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117644 */     GIR_RootConstrainSelectedInstOperands,
     /*  117645 */     // GIR_Coverage, 51373,
     /*  117645 */     GIR_EraseRootFromParent_Done,
     /*  117646 */   // Label 2011: @117646
     /*  117646 */   GIM_Reject,
     /*  117647 */ // Label 2009: @117647
     /*  117647 */ GIM_Reject,
     /*  117648 */ // Label 1955: @117648
     /*  117648 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(117762),
     /*  117653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  117656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  117659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117667 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117671 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(117716), // Rule ID 51328 //
     /*  117676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117679 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  117679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  117682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  117696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117714 */     GIR_RootConstrainSelectedInstOperands,
     /*  117715 */     // GIR_Coverage, 51328,
     /*  117715 */     GIR_EraseRootFromParent_Done,
     /*  117716 */   // Label 2013: @117716
     /*  117716 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(117761), // Rule ID 51329 //
     /*  117721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117724 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  117724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  117727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  117741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117759 */     GIR_RootConstrainSelectedInstOperands,
     /*  117760 */     // GIR_Coverage, 51329,
     /*  117760 */     GIR_EraseRootFromParent_Done,
     /*  117761 */   // Label 2014: @117761
     /*  117761 */   GIM_Reject,
     /*  117762 */ // Label 2012: @117762
     /*  117762 */ GIM_Reject,
     /*  117763 */ // Label 1956: @117763
     /*  117763 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(117877),
     /*  117768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  117771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  117774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117786 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(117831), // Rule ID 51344 //
     /*  117791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117794 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  117794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  117797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  117811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117829 */     GIR_RootConstrainSelectedInstOperands,
     /*  117830 */     // GIR_Coverage, 51344,
     /*  117830 */     GIR_EraseRootFromParent_Done,
     /*  117831 */   // Label 2016: @117831
     /*  117831 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(117876), // Rule ID 51345 //
     /*  117836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117839 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  117839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  117842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  117856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117874 */     GIR_RootConstrainSelectedInstOperands,
     /*  117875 */     // GIR_Coverage, 51345,
     /*  117875 */     GIR_EraseRootFromParent_Done,
     /*  117876 */   // Label 2017: @117876
     /*  117876 */   GIM_Reject,
     /*  117877 */ // Label 2015: @117877
     /*  117877 */ GIM_Reject,
     /*  117878 */ // Label 1957: @117878
     /*  117878 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(117992),
     /*  117883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  117886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  117889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117901 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(117946), // Rule ID 51360 //
     /*  117906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117909 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  117912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  117926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117944 */     GIR_RootConstrainSelectedInstOperands,
     /*  117945 */     // GIR_Coverage, 51360,
     /*  117945 */     GIR_EraseRootFromParent_Done,
     /*  117946 */   // Label 2019: @117946
     /*  117946 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(117991), // Rule ID 51361 //
     /*  117951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117954 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  117957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  117971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117989 */     GIR_RootConstrainSelectedInstOperands,
     /*  117990 */     // GIR_Coverage, 51361,
     /*  117990 */     GIR_EraseRootFromParent_Done,
     /*  117991 */   // Label 2020: @117991
     /*  117991 */   GIM_Reject,
     /*  117992 */ // Label 2018: @117992
     /*  117992 */ GIM_Reject,
     /*  117993 */ // Label 1958: @117993
     /*  117993 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(118107),
     /*  117998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  118001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  118004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118016 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(118061), // Rule ID 51332 //
     /*  118021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118024 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  118027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  118041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118059 */     GIR_RootConstrainSelectedInstOperands,
     /*  118060 */     // GIR_Coverage, 51332,
     /*  118060 */     GIR_EraseRootFromParent_Done,
     /*  118061 */   // Label 2022: @118061
     /*  118061 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(118106), // Rule ID 51333 //
     /*  118066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118069 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  118072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  118086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118104 */     GIR_RootConstrainSelectedInstOperands,
     /*  118105 */     // GIR_Coverage, 51333,
     /*  118105 */     GIR_EraseRootFromParent_Done,
     /*  118106 */   // Label 2023: @118106
     /*  118106 */   GIM_Reject,
     /*  118107 */ // Label 2021: @118107
     /*  118107 */ GIM_Reject,
     /*  118108 */ // Label 1959: @118108
     /*  118108 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(118222),
     /*  118113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  118116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  118119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118131 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(118176), // Rule ID 51348 //
     /*  118136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118139 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  118139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  118142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  118156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118174 */     GIR_RootConstrainSelectedInstOperands,
     /*  118175 */     // GIR_Coverage, 51348,
     /*  118175 */     GIR_EraseRootFromParent_Done,
     /*  118176 */   // Label 2025: @118176
     /*  118176 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(118221), // Rule ID 51349 //
     /*  118181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118184 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  118184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  118187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  118201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118219 */     GIR_RootConstrainSelectedInstOperands,
     /*  118220 */     // GIR_Coverage, 51349,
     /*  118220 */     GIR_EraseRootFromParent_Done,
     /*  118221 */   // Label 2026: @118221
     /*  118221 */   GIM_Reject,
     /*  118222 */ // Label 2024: @118222
     /*  118222 */ GIM_Reject,
     /*  118223 */ // Label 1960: @118223
     /*  118223 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(118337),
     /*  118228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  118231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  118234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118246 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(118291), // Rule ID 51336 //
     /*  118251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118254 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  118257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  118271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118289 */     GIR_RootConstrainSelectedInstOperands,
     /*  118290 */     // GIR_Coverage, 51336,
     /*  118290 */     GIR_EraseRootFromParent_Done,
     /*  118291 */   // Label 2028: @118291
     /*  118291 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(118336), // Rule ID 51337 //
     /*  118296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118299 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  118302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  118316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118334 */     GIR_RootConstrainSelectedInstOperands,
     /*  118335 */     // GIR_Coverage, 51337,
     /*  118335 */     GIR_EraseRootFromParent_Done,
     /*  118336 */   // Label 2029: @118336
     /*  118336 */   GIM_Reject,
     /*  118337 */ // Label 2027: @118337
     /*  118337 */ GIM_Reject,
     /*  118338 */ // Label 1961: @118338
     /*  118338 */ GIM_Reject,
     /*  118339 */ // Label 7: @118339
     /*  118339 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2061*/ GIMT_Encode4(127820),
     /*  118350 */ /*GILLT_s32*//*Label 2030*/ GIMT_Encode4(118474),
     /*  118354 */ /*GILLT_s64*//*Label 2031*/ GIMT_Encode4(119692),
     /*  118358 */ /*GILLT_nxv1s1*//*Label 2032*/ GIMT_Encode4(121013),
     /*  118362 */ /*GILLT_nxv1s8*//*Label 2033*/ GIMT_Encode4(121624),
     /*  118366 */ /*GILLT_nxv1s16*//*Label 2034*/ GIMT_Encode4(121739),
     /*  118370 */ /*GILLT_nxv1s32*//*Label 2035*/ GIMT_Encode4(121854),
     /*  118374 */ /*GILLT_nxv1s64*//*Label 2036*/ GIMT_Encode4(121969),
     /*  118378 */ /*GILLT_nxv2s1*//*Label 2037*/ GIMT_Encode4(122084),
     /*  118382 */ /*GILLT_nxv2s8*//*Label 2038*/ GIMT_Encode4(122695),
     /*  118386 */ /*GILLT_nxv2s16*//*Label 2039*/ GIMT_Encode4(122810),
     /*  118390 */ /*GILLT_nxv2s32*//*Label 2040*/ GIMT_Encode4(122925),
     /*  118394 */ /*GILLT_nxv2s64*//*Label 2041*/ GIMT_Encode4(123040),
     /*  118398 */ /*GILLT_nxv4s1*//*Label 2042*/ GIMT_Encode4(123155),
     /*  118402 */ /*GILLT_nxv4s8*//*Label 2043*/ GIMT_Encode4(123766),
     /*  118406 */ /*GILLT_nxv4s16*//*Label 2044*/ GIMT_Encode4(123881),
     /*  118410 */ /*GILLT_nxv4s32*//*Label 2045*/ GIMT_Encode4(123996),
     /*  118414 */ /*GILLT_nxv4s64*//*Label 2046*/ GIMT_Encode4(124111),
     /*  118418 */ /*GILLT_nxv8s1*//*Label 2047*/ GIMT_Encode4(124226),
     /*  118422 */ /*GILLT_nxv8s8*//*Label 2048*/ GIMT_Encode4(124837),
     /*  118426 */ /*GILLT_nxv8s16*//*Label 2049*/ GIMT_Encode4(124952),
     /*  118430 */ /*GILLT_nxv8s32*//*Label 2050*/ GIMT_Encode4(125067),
     /*  118434 */ /*GILLT_nxv8s64*//*Label 2051*/ GIMT_Encode4(125182),
     /*  118438 */ /*GILLT_nxv16s1*//*Label 2052*/ GIMT_Encode4(125297),
     /*  118442 */ /*GILLT_nxv16s8*//*Label 2053*/ GIMT_Encode4(125908),
     /*  118446 */ /*GILLT_nxv16s16*//*Label 2054*/ GIMT_Encode4(126023),
     /*  118450 */ /*GILLT_nxv16s32*//*Label 2055*/ GIMT_Encode4(126138),
     /*  118454 */ /*GILLT_nxv32s1*//*Label 2056*/ GIMT_Encode4(126253),
     /*  118458 */ /*GILLT_nxv32s8*//*Label 2057*/ GIMT_Encode4(126864),
     /*  118462 */ /*GILLT_nxv32s16*//*Label 2058*/ GIMT_Encode4(126979),
     /*  118466 */ /*GILLT_nxv64s1*//*Label 2059*/ GIMT_Encode4(127094),
     /*  118470 */ /*GILLT_nxv64s8*//*Label 2060*/ GIMT_Encode4(127705),
     /*  118474 */ // Label 2030: @118474
     /*  118474 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(119691),
     /*  118479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  118482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  118485 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(118574), // Rule ID 65443 //
     /*  118490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  118493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  118505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118534 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  118538 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  118549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  118558 */     // (and:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] })), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  118561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  118568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  118572 */     GIR_RootConstrainSelectedInstOperands,
     /*  118573 */     // GIR_Coverage, 65443,
     /*  118573 */     GIR_EraseRootFromParent_Done,
     /*  118574 */   // Label 2063: @118574
     /*  118574 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(118663), // Rule ID 2534 //
     /*  118579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  118582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  118594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118623 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  118627 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  118638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  118647 */     // (and:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1)), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  118650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  118657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  118661 */     GIR_RootConstrainSelectedInstOperands,
     /*  118662 */     // GIR_Coverage, 2534,
     /*  118662 */     GIR_EraseRootFromParent_Done,
     /*  118663 */   // Label 2064: @118663
     /*  118663 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(118742), // Rule ID 2461 //
     /*  118668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118707 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  118711 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  118715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  118728 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  118731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  118735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  118740 */     GIR_RootConstrainSelectedInstOperands,
     /*  118741 */     // GIR_Coverage, 2461,
     /*  118741 */     GIR_EraseRootFromParent_Done,
     /*  118742 */   // Label 2065: @118742
     /*  118742 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(118821), // Rule ID 65431 //
     /*  118747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  118762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118790 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  118794 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  118798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  118807 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  118810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  118819 */     GIR_RootConstrainSelectedInstOperands,
     /*  118820 */     // GIR_Coverage, 65431,
     /*  118820 */     GIR_EraseRootFromParent_Done,
     /*  118821 */   // Label 2066: @118821
     /*  118821 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(118886), // Rule ID 2481 //
     /*  118826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  118841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  118862 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  118866 */     // MIs[2] Operand 1
     /*  118866 */     // No operand predicates
     /*  118866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  118870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118872 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (BEXTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  118872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  118875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  118881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  118884 */     GIR_RootConstrainSelectedInstOperands,
     /*  118885 */     // GIR_Coverage, 2481,
     /*  118885 */     GIR_EraseRootFromParent_Done,
     /*  118886 */   // Label 2067: @118886
     /*  118886 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(118951), // Rule ID 62565 //
     /*  118891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode1),
     /*  118894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  118906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  118927 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  118931 */     // MIs[2] Operand 1
     /*  118931 */     // No operand predicates
     /*  118931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  118935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118937 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (TH_TST:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  118937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  118940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  118946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  118949 */     GIR_RootConstrainSelectedInstOperands,
     /*  118950 */     // GIR_Coverage, 62565,
     /*  118950 */     GIR_EraseRootFromParent_Done,
     /*  118951 */   // Label 2068: @118951
     /*  118951 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(119013), // Rule ID 2469 //
     /*  118956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  118971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  118988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  118990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  118997 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), 1:{ *:[i32] })  =>  (BEXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  119000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  119006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  119011 */     GIR_RootConstrainSelectedInstOperands,
     /*  119012 */     // GIR_Coverage, 2469,
     /*  119012 */     GIR_EraseRootFromParent_Done,
     /*  119013 */   // Label 2069: @119013
     /*  119013 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(119069), // Rule ID 2463 //
     /*  119018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  119033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  119045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119056 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119067 */     GIR_RootConstrainSelectedInstOperands,
     /*  119068 */     // GIR_Coverage, 2463,
     /*  119068 */     GIR_EraseRootFromParent_Done,
     /*  119069 */   // Label 2070: @119069
     /*  119069 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(119125), // Rule ID 65417 //
     /*  119074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  119077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119102 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119112 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  119115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119123 */     GIR_RootConstrainSelectedInstOperands,
     /*  119124 */     // GIR_Coverage, 65417,
     /*  119124 */     GIR_EraseRootFromParent_Done,
     /*  119125 */   // Label 2071: @119125
     /*  119125 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(119181), // Rule ID 65433 //
     /*  119130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  119149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119157 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  119161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119168 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119179 */     GIR_RootConstrainSelectedInstOperands,
     /*  119180 */     // GIR_Coverage, 65433,
     /*  119180 */     GIR_EraseRootFromParent_Done,
     /*  119181 */   // Label 2072: @119181
     /*  119181 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(119237), // Rule ID 2437 //
     /*  119186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  119189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119218 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119224 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  119227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119235 */     GIR_RootConstrainSelectedInstOperands,
     /*  119236 */     // GIR_Coverage, 2437,
     /*  119236 */     GIR_EraseRootFromParent_Done,
     /*  119237 */   // Label 2073: @119237
     /*  119237 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(119273), // Rule ID 64466 //
     /*  119242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  119245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119253 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119264 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 65535:{ *:[i32] })  =>  (CV_EXTHZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  119264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  119267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119271 */     GIR_RootConstrainSelectedInstOperands,
     /*  119272 */     // GIR_Coverage, 64466,
     /*  119272 */     GIR_EraseRootFromParent_Done,
     /*  119273 */   // Label 2074: @119273
     /*  119273 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(119309), // Rule ID 64468 //
     /*  119278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  119281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119289 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  119300 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 255:{ *:[i32] })  =>  (CV_EXTBZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  119300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  119303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119307 */     GIR_RootConstrainSelectedInstOperands,
     /*  119308 */     // GIR_Coverage, 64468,
     /*  119308 */     GIR_EraseRootFromParent_Done,
     /*  119309 */   // Label 2075: @119309
     /*  119309 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(119345), // Rule ID 2545 //
     /*  119314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /*  119317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119325 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119336 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  119336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  119339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119343 */     GIR_RootConstrainSelectedInstOperands,
     /*  119344 */     // GIR_Coverage, 2545,
     /*  119344 */     GIR_EraseRootFromParent_Done,
     /*  119345 */   // Label 2076: @119345
     /*  119345 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(119381), // Rule ID 2546 //
     /*  119350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /*  119353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119361 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119372 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  119372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  119375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119379 */     GIR_RootConstrainSelectedInstOperands,
     /*  119380 */     // GIR_Coverage, 2546,
     /*  119380 */     GIR_EraseRootFromParent_Done,
     /*  119381 */   // Label 2077: @119381
     /*  119381 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(119423), // Rule ID 2548 //
     /*  119386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /*  119389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119397 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119408 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i64] })
     /*  119408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  119411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  119421 */     GIR_RootConstrainSelectedInstOperands,
     /*  119422 */     // GIR_Coverage, 2548,
     /*  119422 */     GIR_EraseRootFromParent_Done,
     /*  119423 */   // Label 2078: @119423
     /*  119423 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(119465), // Rule ID 2549 //
     /*  119428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /*  119431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119439 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119450 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i32] })
     /*  119450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  119453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  119463 */     GIR_RootConstrainSelectedInstOperands,
     /*  119464 */     // GIR_Coverage, 2549,
     /*  119464 */     GIR_EraseRootFromParent_Done,
     /*  119465 */   // Label 2079: @119465
     /*  119465 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(119507), // Rule ID 85 //
     /*  119470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  119473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  119493 */     // MIs[1] Operand 1
     /*  119493 */     // No operand predicates
     /*  119493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119495 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  119495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  119498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  119505 */     GIR_RootConstrainSelectedInstOperands,
     /*  119506 */     // GIR_Coverage, 85,
     /*  119506 */     GIR_EraseRootFromParent_Done,
     /*  119507 */   // Label 2080: @119507
     /*  119507 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(119579), // Rule ID 103 //
     /*  119512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  119515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119531 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  119535 */     // MIs[1] Operand 1
     /*  119535 */     // No operand predicates
     /*  119535 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9915),
     /*  119539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119541 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9915>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)), (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask))
     /*  119541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  119544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  119548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  119553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  119557 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  119562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  119564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  119567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  119572 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  119577 */     GIR_RootConstrainSelectedInstOperands,
     /*  119578 */     // GIR_Coverage, 103,
     /*  119578 */     GIR_EraseRootFromParent_Done,
     /*  119579 */   // Label 2081: @119579
     /*  119579 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(119621), // Rule ID 64519 //
     /*  119584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  119587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  119607 */     // MIs[1] Operand 1
     /*  119607 */     // No operand predicates
     /*  119607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119609 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ANDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  119609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDAI),
     /*  119612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  119614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  119619 */     GIR_RootConstrainSelectedInstOperands,
     /*  119620 */     // GIR_Coverage, 64519,
     /*  119620 */     GIR_EraseRootFromParent_Done,
     /*  119621 */   // Label 2082: @119621
     /*  119621 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(119663), // Rule ID 64523 //
     /*  119626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  119629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  119649 */     // MIs[1] Operand 1
     /*  119649 */     // No operand predicates
     /*  119649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119651 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ANDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  119651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDI),
     /*  119654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  119661 */     GIR_RootConstrainSelectedInstOperands,
     /*  119662 */     // GIR_Coverage, 64523,
     /*  119662 */     GIR_EraseRootFromParent_Done,
     /*  119663 */   // Label 2083: @119663
     /*  119663 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(119690), // Rule ID 83 //
     /*  119668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  119671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119683 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (AND:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  119688 */     GIR_RootConstrainSelectedInstOperands,
     /*  119689 */     // GIR_Coverage, 83,
     /*  119689 */     GIR_Done,
     /*  119690 */   // Label 2084: @119690
     /*  119690 */   GIM_Reject,
     /*  119691 */ // Label 2062: @119691
     /*  119691 */ GIM_Reject,
     /*  119692 */ // Label 2031: @119692
     /*  119692 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(121012),
     /*  119697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  119700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  119703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119707 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(119792), // Rule ID 65442 //
     /*  119712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  119715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  119723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  119727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  119731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  119735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  119743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  119747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  119756 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  119776 */     // (and:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] })), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  119776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  119779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  119786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  119790 */     GIR_RootConstrainSelectedInstOperands,
     /*  119791 */     // GIR_Coverage, 65442,
     /*  119791 */     GIR_EraseRootFromParent_Done,
     /*  119792 */   // Label 2086: @119792
     /*  119792 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(119877), // Rule ID 2533 //
     /*  119797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  119800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  119808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  119812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  119816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  119828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  119832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119837 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  119841 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  119861 */     // (and:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1)), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  119861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  119864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  119871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  119875 */     GIR_RootConstrainSelectedInstOperands,
     /*  119876 */     // GIR_Coverage, 2533,
     /*  119876 */     GIR_EraseRootFromParent_Done,
     /*  119877 */   // Label 2087: @119877
     /*  119877 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(119952), // Rule ID 2460 //
     /*  119882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  119885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  119897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  119901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  119913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  119917 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  119921 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  119938 */     // (and:{ *:[i64] } (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  119938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  119950 */     GIR_RootConstrainSelectedInstOperands,
     /*  119951 */     // GIR_Coverage, 2460,
     /*  119951 */     GIR_EraseRootFromParent_Done,
     /*  119952 */   // Label 2088: @119952
     /*  119952 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(120027), // Rule ID 65430 //
     /*  119957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  119960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  119976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  119980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  119992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  119996 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  120000 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120006 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120013 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120025 */     GIR_RootConstrainSelectedInstOperands,
     /*  120026 */     // GIR_Coverage, 65430,
     /*  120026 */     GIR_EraseRootFromParent_Done,
     /*  120027 */   // Label 2089: @120027
     /*  120027 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(120088), // Rule ID 2480 //
     /*  120032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120064 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  120068 */     // MIs[2] Operand 1
     /*  120068 */     // No operand predicates
     /*  120068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  120072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120074 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (BEXTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  120074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  120077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  120083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  120086 */     GIR_RootConstrainSelectedInstOperands,
     /*  120087 */     // GIR_Coverage, 2480,
     /*  120087 */     GIR_EraseRootFromParent_Done,
     /*  120088 */   // Label 2090: @120088
     /*  120088 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(120149), // Rule ID 62564 //
     /*  120093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode0),
     /*  120096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120125 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  120129 */     // MIs[2] Operand 1
     /*  120129 */     // No operand predicates
     /*  120129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  120133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120135 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (TH_TST:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  120135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  120138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  120144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  120147 */     GIR_RootConstrainSelectedInstOperands,
     /*  120148 */     // GIR_Coverage, 62564,
     /*  120148 */     GIR_EraseRootFromParent_Done,
     /*  120149 */   // Label 2091: @120149
     /*  120149 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(120207), // Rule ID 2468 //
     /*  120154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  120182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120191 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), 1:{ *:[i64] })  =>  (BEXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  120194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  120200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120205 */     GIR_RootConstrainSelectedInstOperands,
     /*  120206 */     // GIR_Coverage, 2468,
     /*  120206 */     GIR_EraseRootFromParent_Done,
     /*  120207 */   // Label 2092: @120207
     /*  120207 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(120259), // Rule ID 2462 //
     /*  120212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  120223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120231 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  120235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120246 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  120257 */     GIR_RootConstrainSelectedInstOperands,
     /*  120258 */     // GIR_Coverage, 2462,
     /*  120258 */     GIR_EraseRootFromParent_Done,
     /*  120259 */   // Label 2093: @120259
     /*  120259 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(120311), // Rule ID 65416 //
     /*  120264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  120267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120288 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120298 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  120301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  120309 */     GIR_RootConstrainSelectedInstOperands,
     /*  120310 */     // GIR_Coverage, 65416,
     /*  120310 */     GIR_EraseRootFromParent_Done,
     /*  120311 */   // Label 2094: @120311
     /*  120311 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(120363), // Rule ID 65432 //
     /*  120316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  120331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120339 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  120343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120350 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  120361 */     GIR_RootConstrainSelectedInstOperands,
     /*  120362 */     // GIR_Coverage, 65432,
     /*  120362 */     GIR_EraseRootFromParent_Done,
     /*  120363 */   // Label 2095: @120363
     /*  120363 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(120415), // Rule ID 2436 //
     /*  120368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  120371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120396 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120402 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  120405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  120413 */     GIR_RootConstrainSelectedInstOperands,
     /*  120414 */     // GIR_Coverage, 2436,
     /*  120414 */     GIR_EraseRootFromParent_Done,
     /*  120415 */   // Label 2096: @120415
     /*  120415 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(120447), // Rule ID 64465 //
     /*  120420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  120423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120427 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120438 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 65535:{ *:[i64] })  =>  (CV_EXTHZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  120438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  120441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120445 */     GIR_RootConstrainSelectedInstOperands,
     /*  120446 */     // GIR_Coverage, 64465,
     /*  120446 */     GIR_EraseRootFromParent_Done,
     /*  120447 */   // Label 2097: @120447
     /*  120447 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(120479), // Rule ID 64467 //
     /*  120452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  120455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120459 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  120470 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 255:{ *:[i64] })  =>  (CV_EXTBZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  120470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  120473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120477 */     GIR_RootConstrainSelectedInstOperands,
     /*  120478 */     // GIR_Coverage, 64467,
     /*  120478 */     GIR_EraseRootFromParent_Done,
     /*  120479 */   // Label 2098: @120479
     /*  120479 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(120536), // Rule ID 252 //
     /*  120484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /*  120487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120491 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  120502 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] })  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), 32:{ *:[i64] })
     /*  120502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  120505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  120518 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  120521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  120526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /*  120534 */     GIR_RootConstrainSelectedInstOperands,
     /*  120535 */     // GIR_Coverage, 252,
     /*  120535 */     GIR_EraseRootFromParent_Done,
     /*  120536 */   // Label 2099: @120536
     /*  120536 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(120568), // Rule ID 2547 //
     /*  120541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /*  120544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120548 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120559 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs)
     /*  120559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /*  120562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120566 */     GIR_RootConstrainSelectedInstOperands,
     /*  120567 */     // GIR_Coverage, 2547,
     /*  120567 */     GIR_EraseRootFromParent_Done,
     /*  120568 */   // Label 2100: @120568
     /*  120568 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(120606), // Rule ID 2550 //
     /*  120573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /*  120576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120580 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120591 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  120591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  120594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  120604 */     GIR_RootConstrainSelectedInstOperands,
     /*  120605 */     // GIR_Coverage, 2550,
     /*  120605 */     GIR_EraseRootFromParent_Done,
     /*  120606 */   // Label 2101: @120606
     /*  120606 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(120644), // Rule ID 2593 //
     /*  120611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  120614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120618 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  120629 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  120629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*  120632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  120642 */     GIR_RootConstrainSelectedInstOperands,
     /*  120643 */     // GIR_Coverage, 2593,
     /*  120643 */     GIR_EraseRootFromParent_Done,
     /*  120644 */   // Label 2102: @120644
     /*  120644 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(120682), // Rule ID 65027 //
     /*  120649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*  120652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120656 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  120667 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  120667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*  120670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  120680 */     GIR_RootConstrainSelectedInstOperands,
     /*  120681 */     // GIR_Coverage, 65027,
     /*  120681 */     GIR_EraseRootFromParent_Done,
     /*  120682 */   // Label 2103: @120682
     /*  120682 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(120720), // Rule ID 84 //
     /*  120687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  120690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  120706 */     // MIs[1] Operand 1
     /*  120706 */     // No operand predicates
     /*  120706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120708 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  120708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  120711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  120718 */     GIR_RootConstrainSelectedInstOperands,
     /*  120719 */     // GIR_Coverage, 84,
     /*  120719 */     GIR_EraseRootFromParent_Done,
     /*  120720 */   // Label 2104: @120720
     /*  120720 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(120788), // Rule ID 101 //
     /*  120725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  120728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesMask),
     /*  120744 */     // MIs[1] Operand 1
     /*  120744 */     // No operand predicates
     /*  120744 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9913),
     /*  120748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120750 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesMask>><<P:Predicate_anonymous_9913>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  120750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  120753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  120757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  120766 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  120771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120781 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  120786 */     GIR_RootConstrainSelectedInstOperands,
     /*  120787 */     // GIR_Coverage, 101,
     /*  120787 */     GIR_EraseRootFromParent_Done,
     /*  120788 */   // Label 2105: @120788
     /*  120788 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(120856), // Rule ID 102 //
     /*  120793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  120796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120808 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  120812 */     // MIs[1] Operand 1
     /*  120812 */     // No operand predicates
     /*  120812 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9915),
     /*  120816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120818 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9915>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  120818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  120821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  120834 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  120839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  120844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120849 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  120854 */     GIR_RootConstrainSelectedInstOperands,
     /*  120855 */     // GIR_Coverage, 102,
     /*  120855 */     GIR_EraseRootFromParent_Done,
     /*  120856 */   // Label 2106: @120856
     /*  120856 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(120924), // Rule ID 254 //
     /*  120861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  120864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesWMask),
     /*  120880 */     // MIs[1] Operand 1
     /*  120880 */     // No operand predicates
     /*  120880 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10003),
     /*  120884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120886 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesWMask>><<P:Predicate_anonymous_10003>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLIW:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  120886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  120889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*  120893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  120902 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  120907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120917 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  120922 */     GIR_RootConstrainSelectedInstOperands,
     /*  120923 */     // GIR_Coverage, 254,
     /*  120923 */     GIR_EraseRootFromParent_Done,
     /*  120924 */   // Label 2107: @120924
     /*  120924 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(120988), // Rule ID 2612 //
     /*  120929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  120932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120944 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_Shifted32OnesMask),
     /*  120948 */     // MIs[1] Operand 1
     /*  120948 */     // No operand predicates
     /*  120948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120950 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>><<X:TrailingZeros>>:$mask)  =>  (SLLI_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask))
     /*  120950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  120953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  120957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  120966 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  120971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /*  120976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120981 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  120986 */     GIR_RootConstrainSelectedInstOperands,
     /*  120987 */     // GIR_Coverage, 2612,
     /*  120987 */     GIR_EraseRootFromParent_Done,
     /*  120988 */   // Label 2108: @120988
     /*  120988 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(121011), // Rule ID 82 //
     /*  120993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  120996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121004 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AND:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  121009 */     GIR_RootConstrainSelectedInstOperands,
     /*  121010 */     // GIR_Coverage, 82,
     /*  121010 */     GIR_Done,
     /*  121011 */   // Label 2109: @121011
     /*  121011 */   GIM_Reject,
     /*  121012 */ // Label 2085: @121012
     /*  121012 */ GIM_Reject,
     /*  121013 */ // Label 2032: @121013
     /*  121013 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(121623),
     /*  121018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121028 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(121094), // Rule ID 71642 //
     /*  121033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121075 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121092 */     GIR_RootConstrainSelectedInstOperands,
     /*  121093 */     // GIR_Coverage, 71642,
     /*  121093 */     GIR_EraseRootFromParent_Done,
     /*  121094 */   // Label 2111: @121094
     /*  121094 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(121160), // Rule ID 71643 //
     /*  121099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121141 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121158 */     GIR_RootConstrainSelectedInstOperands,
     /*  121159 */     // GIR_Coverage, 71643,
     /*  121159 */     GIR_EraseRootFromParent_Done,
     /*  121160 */   // Label 2112: @121160
     /*  121160 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(121226), // Rule ID 71640 //
     /*  121165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121207 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121224 */     GIR_RootConstrainSelectedInstOperands,
     /*  121225 */     // GIR_Coverage, 71640,
     /*  121225 */     GIR_EraseRootFromParent_Done,
     /*  121226 */   // Label 2113: @121226
     /*  121226 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(121292), // Rule ID 71641 //
     /*  121231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121273 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121290 */     GIR_RootConstrainSelectedInstOperands,
     /*  121291 */     // GIR_Coverage, 71641,
     /*  121291 */     GIR_EraseRootFromParent_Done,
     /*  121292 */   // Label 2114: @121292
     /*  121292 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(121358), // Rule ID 71638 //
     /*  121297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121339 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121356 */     GIR_RootConstrainSelectedInstOperands,
     /*  121357 */     // GIR_Coverage, 71638,
     /*  121357 */     GIR_EraseRootFromParent_Done,
     /*  121358 */   // Label 2115: @121358
     /*  121358 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(121424), // Rule ID 71639 //
     /*  121363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121405 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121422 */     GIR_RootConstrainSelectedInstOperands,
     /*  121423 */     // GIR_Coverage, 71639,
     /*  121423 */     GIR_EraseRootFromParent_Done,
     /*  121424 */   // Label 2116: @121424
     /*  121424 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(121490), // Rule ID 53164 //
     /*  121429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121471 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121488 */     GIR_RootConstrainSelectedInstOperands,
     /*  121489 */     // GIR_Coverage, 53164,
     /*  121489 */     GIR_EraseRootFromParent_Done,
     /*  121490 */   // Label 2117: @121490
     /*  121490 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(121556), // Rule ID 53165 //
     /*  121495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121537 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121554 */     GIR_RootConstrainSelectedInstOperands,
     /*  121555 */     // GIR_Coverage, 53165,
     /*  121555 */     GIR_EraseRootFromParent_Done,
     /*  121556 */   // Label 2118: @121556
     /*  121556 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(121589), // Rule ID 53152 //
     /*  121561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121572 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  121575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121587 */     GIR_RootConstrainSelectedInstOperands,
     /*  121588 */     // GIR_Coverage, 53152,
     /*  121588 */     GIR_EraseRootFromParent_Done,
     /*  121589 */   // Label 2119: @121589
     /*  121589 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(121622), // Rule ID 53153 //
     /*  121594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121605 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  121608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121620 */     GIR_RootConstrainSelectedInstOperands,
     /*  121621 */     // GIR_Coverage, 53153,
     /*  121621 */     GIR_EraseRootFromParent_Done,
     /*  121622 */   // Label 2120: @121622
     /*  121622 */   GIM_Reject,
     /*  121623 */ // Label 2110: @121623
     /*  121623 */ GIM_Reject,
     /*  121624 */ // Label 2033: @121624
     /*  121624 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(121738),
     /*  121629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  121632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  121635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121647 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(121692), // Rule ID 47644 //
     /*  121652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121655 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  121655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  121658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  121672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121690 */     GIR_RootConstrainSelectedInstOperands,
     /*  121691 */     // GIR_Coverage, 47644,
     /*  121691 */     GIR_EraseRootFromParent_Done,
     /*  121692 */   // Label 2122: @121692
     /*  121692 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(121737), // Rule ID 47645 //
     /*  121697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121700 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  121700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  121703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  121717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121735 */     GIR_RootConstrainSelectedInstOperands,
     /*  121736 */     // GIR_Coverage, 47645,
     /*  121736 */     GIR_EraseRootFromParent_Done,
     /*  121737 */   // Label 2123: @121737
     /*  121737 */   GIM_Reject,
     /*  121738 */ // Label 2121: @121738
     /*  121738 */ GIM_Reject,
     /*  121739 */ // Label 2034: @121739
     /*  121739 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(121853),
     /*  121744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  121747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  121750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121762 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(121807), // Rule ID 47656 //
     /*  121767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121770 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  121770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  121773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  121787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  121802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121805 */     GIR_RootConstrainSelectedInstOperands,
     /*  121806 */     // GIR_Coverage, 47656,
     /*  121806 */     GIR_EraseRootFromParent_Done,
     /*  121807 */   // Label 2125: @121807
     /*  121807 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(121852), // Rule ID 47657 //
     /*  121812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121815 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  121815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  121818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  121832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  121847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121850 */     GIR_RootConstrainSelectedInstOperands,
     /*  121851 */     // GIR_Coverage, 47657,
     /*  121851 */     GIR_EraseRootFromParent_Done,
     /*  121852 */   // Label 2126: @121852
     /*  121852 */   GIM_Reject,
     /*  121853 */ // Label 2124: @121853
     /*  121853 */ GIM_Reject,
     /*  121854 */ // Label 2035: @121854
     /*  121854 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(121968),
     /*  121859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  121862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  121865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121877 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(121922), // Rule ID 47664 //
     /*  121882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121885 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  121885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  121888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  121902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  121917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121920 */     GIR_RootConstrainSelectedInstOperands,
     /*  121921 */     // GIR_Coverage, 47664,
     /*  121921 */     GIR_EraseRootFromParent_Done,
     /*  121922 */   // Label 2128: @121922
     /*  121922 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(121967), // Rule ID 47665 //
     /*  121927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121930 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  121930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  121933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  121947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  121962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121965 */     GIR_RootConstrainSelectedInstOperands,
     /*  121966 */     // GIR_Coverage, 47665,
     /*  121966 */     GIR_EraseRootFromParent_Done,
     /*  121967 */   // Label 2129: @121967
     /*  121967 */   GIM_Reject,
     /*  121968 */ // Label 2127: @121968
     /*  121968 */ GIM_Reject,
     /*  121969 */ // Label 2036: @121969
     /*  121969 */ GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(122083),
     /*  121974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  121977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  121980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121992 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(122037), // Rule ID 47680 //
     /*  121997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  122000 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  122000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  122003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  122017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  122032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122035 */     GIR_RootConstrainSelectedInstOperands,
     /*  122036 */     // GIR_Coverage, 47680,
     /*  122036 */     GIR_EraseRootFromParent_Done,
     /*  122037 */   // Label 2131: @122037
     /*  122037 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(122082), // Rule ID 47681 //
     /*  122042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  122045 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  122045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  122048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  122062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  122077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122080 */     GIR_RootConstrainSelectedInstOperands,
     /*  122081 */     // GIR_Coverage, 47681,
     /*  122081 */     GIR_EraseRootFromParent_Done,
     /*  122082 */   // Label 2132: @122082
     /*  122082 */   GIM_Reject,
     /*  122083 */ // Label 2130: @122083
     /*  122083 */ GIM_Reject,
     /*  122084 */ // Label 2037: @122084
     /*  122084 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(122694),
     /*  122089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122099 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(122165), // Rule ID 71670 //
     /*  122104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122146 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122163 */     GIR_RootConstrainSelectedInstOperands,
     /*  122164 */     // GIR_Coverage, 71670,
     /*  122164 */     GIR_EraseRootFromParent_Done,
     /*  122165 */   // Label 2134: @122165
     /*  122165 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(122231), // Rule ID 71671 //
     /*  122170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122212 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122229 */     GIR_RootConstrainSelectedInstOperands,
     /*  122230 */     // GIR_Coverage, 71671,
     /*  122230 */     GIR_EraseRootFromParent_Done,
     /*  122231 */   // Label 2135: @122231
     /*  122231 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(122297), // Rule ID 71668 //
     /*  122236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122278 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122295 */     GIR_RootConstrainSelectedInstOperands,
     /*  122296 */     // GIR_Coverage, 71668,
     /*  122296 */     GIR_EraseRootFromParent_Done,
     /*  122297 */   // Label 2136: @122297
     /*  122297 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(122363), // Rule ID 71669 //
     /*  122302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122344 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122361 */     GIR_RootConstrainSelectedInstOperands,
     /*  122362 */     // GIR_Coverage, 71669,
     /*  122362 */     GIR_EraseRootFromParent_Done,
     /*  122363 */   // Label 2137: @122363
     /*  122363 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(122429), // Rule ID 71666 //
     /*  122368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122410 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122427 */     GIR_RootConstrainSelectedInstOperands,
     /*  122428 */     // GIR_Coverage, 71666,
     /*  122428 */     GIR_EraseRootFromParent_Done,
     /*  122429 */   // Label 2138: @122429
     /*  122429 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(122495), // Rule ID 71667 //
     /*  122434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122476 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122493 */     GIR_RootConstrainSelectedInstOperands,
     /*  122494 */     // GIR_Coverage, 71667,
     /*  122494 */     GIR_EraseRootFromParent_Done,
     /*  122495 */   // Label 2139: @122495
     /*  122495 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(122561), // Rule ID 53182 //
     /*  122500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122542 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122559 */     GIR_RootConstrainSelectedInstOperands,
     /*  122560 */     // GIR_Coverage, 53182,
     /*  122560 */     GIR_EraseRootFromParent_Done,
     /*  122561 */   // Label 2140: @122561
     /*  122561 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(122627), // Rule ID 53183 //
     /*  122566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122608 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122625 */     GIR_RootConstrainSelectedInstOperands,
     /*  122626 */     // GIR_Coverage, 53183,
     /*  122626 */     GIR_EraseRootFromParent_Done,
     /*  122627 */   // Label 2141: @122627
     /*  122627 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(122660), // Rule ID 53170 //
     /*  122632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122643 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  122646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122658 */     GIR_RootConstrainSelectedInstOperands,
     /*  122659 */     // GIR_Coverage, 53170,
     /*  122659 */     GIR_EraseRootFromParent_Done,
     /*  122660 */   // Label 2142: @122660
     /*  122660 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(122693), // Rule ID 53171 //
     /*  122665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122676 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  122679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122691 */     GIR_RootConstrainSelectedInstOperands,
     /*  122692 */     // GIR_Coverage, 53171,
     /*  122692 */     GIR_EraseRootFromParent_Done,
     /*  122693 */   // Label 2143: @122693
     /*  122693 */   GIM_Reject,
     /*  122694 */ // Label 2133: @122694
     /*  122694 */ GIM_Reject,
     /*  122695 */ // Label 2038: @122695
     /*  122695 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(122809),
     /*  122700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  122703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  122706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122718 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(122763), // Rule ID 47648 //
     /*  122723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122726 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  122726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  122729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  122743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122761 */     GIR_RootConstrainSelectedInstOperands,
     /*  122762 */     // GIR_Coverage, 47648,
     /*  122762 */     GIR_EraseRootFromParent_Done,
     /*  122763 */   // Label 2145: @122763
     /*  122763 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(122808), // Rule ID 47649 //
     /*  122768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122771 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  122771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  122774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  122788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122806 */     GIR_RootConstrainSelectedInstOperands,
     /*  122807 */     // GIR_Coverage, 47649,
     /*  122807 */     GIR_EraseRootFromParent_Done,
     /*  122808 */   // Label 2146: @122808
     /*  122808 */   GIM_Reject,
     /*  122809 */ // Label 2144: @122809
     /*  122809 */ GIM_Reject,
     /*  122810 */ // Label 2039: @122810
     /*  122810 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(122924),
     /*  122815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  122818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  122821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122833 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(122878), // Rule ID 47660 //
     /*  122838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122841 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  122841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  122844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  122858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122876 */     GIR_RootConstrainSelectedInstOperands,
     /*  122877 */     // GIR_Coverage, 47660,
     /*  122877 */     GIR_EraseRootFromParent_Done,
     /*  122878 */   // Label 2148: @122878
     /*  122878 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(122923), // Rule ID 47661 //
     /*  122883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122886 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  122886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  122889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  122903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122921 */     GIR_RootConstrainSelectedInstOperands,
     /*  122922 */     // GIR_Coverage, 47661,
     /*  122922 */     GIR_EraseRootFromParent_Done,
     /*  122923 */   // Label 2149: @122923
     /*  122923 */   GIM_Reject,
     /*  122924 */ // Label 2147: @122924
     /*  122924 */ GIM_Reject,
     /*  122925 */ // Label 2040: @122925
     /*  122925 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(123039),
     /*  122930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  122933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  122936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122948 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(122993), // Rule ID 47676 //
     /*  122953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122956 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  122956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  122959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  122973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122991 */     GIR_RootConstrainSelectedInstOperands,
     /*  122992 */     // GIR_Coverage, 47676,
     /*  122992 */     GIR_EraseRootFromParent_Done,
     /*  122993 */   // Label 2151: @122993
     /*  122993 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(123038), // Rule ID 47677 //
     /*  122998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123001 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  123001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  123004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  123033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123036 */     GIR_RootConstrainSelectedInstOperands,
     /*  123037 */     // GIR_Coverage, 47677,
     /*  123037 */     GIR_EraseRootFromParent_Done,
     /*  123038 */   // Label 2152: @123038
     /*  123038 */   GIM_Reject,
     /*  123039 */ // Label 2150: @123039
     /*  123039 */ GIM_Reject,
     /*  123040 */ // Label 2041: @123040
     /*  123040 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(123154),
     /*  123045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  123048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  123051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123059 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123063 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(123108), // Rule ID 47720 //
     /*  123068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  123071 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  123071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  123074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  123088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  123103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123106 */     GIR_RootConstrainSelectedInstOperands,
     /*  123107 */     // GIR_Coverage, 47720,
     /*  123107 */     GIR_EraseRootFromParent_Done,
     /*  123108 */   // Label 2154: @123108
     /*  123108 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(123153), // Rule ID 47721 //
     /*  123113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  123116 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  123116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  123119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  123133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  123148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123151 */     GIR_RootConstrainSelectedInstOperands,
     /*  123152 */     // GIR_Coverage, 47721,
     /*  123152 */     GIR_EraseRootFromParent_Done,
     /*  123153 */   // Label 2155: @123153
     /*  123153 */   GIM_Reject,
     /*  123154 */ // Label 2153: @123154
     /*  123154 */ GIM_Reject,
     /*  123155 */ // Label 2042: @123155
     /*  123155 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(123765),
     /*  123160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123170 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(123236), // Rule ID 71698 //
     /*  123175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123217 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123234 */     GIR_RootConstrainSelectedInstOperands,
     /*  123235 */     // GIR_Coverage, 71698,
     /*  123235 */     GIR_EraseRootFromParent_Done,
     /*  123236 */   // Label 2157: @123236
     /*  123236 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(123302), // Rule ID 71699 //
     /*  123241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123283 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123300 */     GIR_RootConstrainSelectedInstOperands,
     /*  123301 */     // GIR_Coverage, 71699,
     /*  123301 */     GIR_EraseRootFromParent_Done,
     /*  123302 */   // Label 2158: @123302
     /*  123302 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(123368), // Rule ID 71696 //
     /*  123307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123349 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123366 */     GIR_RootConstrainSelectedInstOperands,
     /*  123367 */     // GIR_Coverage, 71696,
     /*  123367 */     GIR_EraseRootFromParent_Done,
     /*  123368 */   // Label 2159: @123368
     /*  123368 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(123434), // Rule ID 71697 //
     /*  123373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123415 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123432 */     GIR_RootConstrainSelectedInstOperands,
     /*  123433 */     // GIR_Coverage, 71697,
     /*  123433 */     GIR_EraseRootFromParent_Done,
     /*  123434 */   // Label 2160: @123434
     /*  123434 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(123500), // Rule ID 71694 //
     /*  123439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123481 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123498 */     GIR_RootConstrainSelectedInstOperands,
     /*  123499 */     // GIR_Coverage, 71694,
     /*  123499 */     GIR_EraseRootFromParent_Done,
     /*  123500 */   // Label 2161: @123500
     /*  123500 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(123566), // Rule ID 71695 //
     /*  123505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123547 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123564 */     GIR_RootConstrainSelectedInstOperands,
     /*  123565 */     // GIR_Coverage, 71695,
     /*  123565 */     GIR_EraseRootFromParent_Done,
     /*  123566 */   // Label 2162: @123566
     /*  123566 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(123632), // Rule ID 53200 //
     /*  123571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123613 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123630 */     GIR_RootConstrainSelectedInstOperands,
     /*  123631 */     // GIR_Coverage, 53200,
     /*  123631 */     GIR_EraseRootFromParent_Done,
     /*  123632 */   // Label 2163: @123632
     /*  123632 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(123698), // Rule ID 53201 //
     /*  123637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123679 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123696 */     GIR_RootConstrainSelectedInstOperands,
     /*  123697 */     // GIR_Coverage, 53201,
     /*  123697 */     GIR_EraseRootFromParent_Done,
     /*  123698 */   // Label 2164: @123698
     /*  123698 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(123731), // Rule ID 53188 //
     /*  123703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123714 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  123717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123729 */     GIR_RootConstrainSelectedInstOperands,
     /*  123730 */     // GIR_Coverage, 53188,
     /*  123730 */     GIR_EraseRootFromParent_Done,
     /*  123731 */   // Label 2165: @123731
     /*  123731 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(123764), // Rule ID 53189 //
     /*  123736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123747 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  123750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123762 */     GIR_RootConstrainSelectedInstOperands,
     /*  123763 */     // GIR_Coverage, 53189,
     /*  123763 */     GIR_EraseRootFromParent_Done,
     /*  123764 */   // Label 2166: @123764
     /*  123764 */   GIM_Reject,
     /*  123765 */ // Label 2156: @123765
     /*  123765 */ GIM_Reject,
     /*  123766 */ // Label 2043: @123766
     /*  123766 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(123880),
     /*  123771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  123774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  123777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123789 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(123834), // Rule ID 47652 //
     /*  123794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123797 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  123797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  123800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  123814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123832 */     GIR_RootConstrainSelectedInstOperands,
     /*  123833 */     // GIR_Coverage, 47652,
     /*  123833 */     GIR_EraseRootFromParent_Done,
     /*  123834 */   // Label 2168: @123834
     /*  123834 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(123879), // Rule ID 47653 //
     /*  123839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123842 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  123842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  123845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  123859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123877 */     GIR_RootConstrainSelectedInstOperands,
     /*  123878 */     // GIR_Coverage, 47653,
     /*  123878 */     GIR_EraseRootFromParent_Done,
     /*  123879 */   // Label 2169: @123879
     /*  123879 */   GIM_Reject,
     /*  123880 */ // Label 2167: @123880
     /*  123880 */ GIM_Reject,
     /*  123881 */ // Label 2044: @123881
     /*  123881 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(123995),
     /*  123886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  123889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  123892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123904 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(123949), // Rule ID 47672 //
     /*  123909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123912 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  123912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  123915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123947 */     GIR_RootConstrainSelectedInstOperands,
     /*  123948 */     // GIR_Coverage, 47672,
     /*  123948 */     GIR_EraseRootFromParent_Done,
     /*  123949 */   // Label 2171: @123949
     /*  123949 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(123994), // Rule ID 47673 //
     /*  123954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123957 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  123957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  123960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123992 */     GIR_RootConstrainSelectedInstOperands,
     /*  123993 */     // GIR_Coverage, 47673,
     /*  123993 */     GIR_EraseRootFromParent_Done,
     /*  123994 */   // Label 2172: @123994
     /*  123994 */   GIM_Reject,
     /*  123995 */ // Label 2170: @123995
     /*  123995 */ GIM_Reject,
     /*  123996 */ // Label 2045: @123996
     /*  123996 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(124110),
     /*  124001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  124004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  124007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124019 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(124064), // Rule ID 47708 //
     /*  124024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124027 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  124027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  124030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124062 */     GIR_RootConstrainSelectedInstOperands,
     /*  124063 */     // GIR_Coverage, 47708,
     /*  124063 */     GIR_EraseRootFromParent_Done,
     /*  124064 */   // Label 2174: @124064
     /*  124064 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(124109), // Rule ID 47709 //
     /*  124069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124072 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  124072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  124075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124107 */     GIR_RootConstrainSelectedInstOperands,
     /*  124108 */     // GIR_Coverage, 47709,
     /*  124108 */     GIR_EraseRootFromParent_Done,
     /*  124109 */   // Label 2175: @124109
     /*  124109 */   GIM_Reject,
     /*  124110 */ // Label 2173: @124110
     /*  124110 */ GIM_Reject,
     /*  124111 */ // Label 2046: @124111
     /*  124111 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(124225),
     /*  124116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  124119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  124122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124134 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(124179), // Rule ID 47724 //
     /*  124139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  124142 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  124142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  124145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  124159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  124174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124177 */     GIR_RootConstrainSelectedInstOperands,
     /*  124178 */     // GIR_Coverage, 47724,
     /*  124178 */     GIR_EraseRootFromParent_Done,
     /*  124179 */   // Label 2177: @124179
     /*  124179 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(124224), // Rule ID 47725 //
     /*  124184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  124187 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  124187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  124190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  124204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  124219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124222 */     GIR_RootConstrainSelectedInstOperands,
     /*  124223 */     // GIR_Coverage, 47725,
     /*  124223 */     GIR_EraseRootFromParent_Done,
     /*  124224 */   // Label 2178: @124224
     /*  124224 */   GIM_Reject,
     /*  124225 */ // Label 2176: @124225
     /*  124225 */ GIM_Reject,
     /*  124226 */ // Label 2047: @124226
     /*  124226 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(124836),
     /*  124231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124241 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(124307), // Rule ID 71726 //
     /*  124246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124288 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124305 */     GIR_RootConstrainSelectedInstOperands,
     /*  124306 */     // GIR_Coverage, 71726,
     /*  124306 */     GIR_EraseRootFromParent_Done,
     /*  124307 */   // Label 2180: @124307
     /*  124307 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(124373), // Rule ID 71727 //
     /*  124312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124354 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124371 */     GIR_RootConstrainSelectedInstOperands,
     /*  124372 */     // GIR_Coverage, 71727,
     /*  124372 */     GIR_EraseRootFromParent_Done,
     /*  124373 */   // Label 2181: @124373
     /*  124373 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(124439), // Rule ID 71724 //
     /*  124378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124420 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124437 */     GIR_RootConstrainSelectedInstOperands,
     /*  124438 */     // GIR_Coverage, 71724,
     /*  124438 */     GIR_EraseRootFromParent_Done,
     /*  124439 */   // Label 2182: @124439
     /*  124439 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(124505), // Rule ID 71725 //
     /*  124444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124486 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124503 */     GIR_RootConstrainSelectedInstOperands,
     /*  124504 */     // GIR_Coverage, 71725,
     /*  124504 */     GIR_EraseRootFromParent_Done,
     /*  124505 */   // Label 2183: @124505
     /*  124505 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(124571), // Rule ID 71722 //
     /*  124510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124552 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124569 */     GIR_RootConstrainSelectedInstOperands,
     /*  124570 */     // GIR_Coverage, 71722,
     /*  124570 */     GIR_EraseRootFromParent_Done,
     /*  124571 */   // Label 2184: @124571
     /*  124571 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(124637), // Rule ID 71723 //
     /*  124576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124618 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124635 */     GIR_RootConstrainSelectedInstOperands,
     /*  124636 */     // GIR_Coverage, 71723,
     /*  124636 */     GIR_EraseRootFromParent_Done,
     /*  124637 */   // Label 2185: @124637
     /*  124637 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(124703), // Rule ID 53218 //
     /*  124642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124684 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124701 */     GIR_RootConstrainSelectedInstOperands,
     /*  124702 */     // GIR_Coverage, 53218,
     /*  124702 */     GIR_EraseRootFromParent_Done,
     /*  124703 */   // Label 2186: @124703
     /*  124703 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(124769), // Rule ID 53219 //
     /*  124708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124750 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124767 */     GIR_RootConstrainSelectedInstOperands,
     /*  124768 */     // GIR_Coverage, 53219,
     /*  124768 */     GIR_EraseRootFromParent_Done,
     /*  124769 */   // Label 2187: @124769
     /*  124769 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(124802), // Rule ID 53206 //
     /*  124774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124785 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  124788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124800 */     GIR_RootConstrainSelectedInstOperands,
     /*  124801 */     // GIR_Coverage, 53206,
     /*  124801 */     GIR_EraseRootFromParent_Done,
     /*  124802 */   // Label 2188: @124802
     /*  124802 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(124835), // Rule ID 53207 //
     /*  124807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124818 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  124821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124833 */     GIR_RootConstrainSelectedInstOperands,
     /*  124834 */     // GIR_Coverage, 53207,
     /*  124834 */     GIR_EraseRootFromParent_Done,
     /*  124835 */   // Label 2189: @124835
     /*  124835 */   GIM_Reject,
     /*  124836 */ // Label 2179: @124836
     /*  124836 */ GIM_Reject,
     /*  124837 */ // Label 2048: @124837
     /*  124837 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(124951),
     /*  124842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  124845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  124848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124860 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(124905), // Rule ID 47668 //
     /*  124865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124868 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  124868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  124871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  124885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124903 */     GIR_RootConstrainSelectedInstOperands,
     /*  124904 */     // GIR_Coverage, 47668,
     /*  124904 */     GIR_EraseRootFromParent_Done,
     /*  124905 */   // Label 2191: @124905
     /*  124905 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(124950), // Rule ID 47669 //
     /*  124910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124913 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  124913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  124916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  124930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124948 */     GIR_RootConstrainSelectedInstOperands,
     /*  124949 */     // GIR_Coverage, 47669,
     /*  124949 */     GIR_EraseRootFromParent_Done,
     /*  124950 */   // Label 2192: @124950
     /*  124950 */   GIM_Reject,
     /*  124951 */ // Label 2190: @124951
     /*  124951 */ GIM_Reject,
     /*  124952 */ // Label 2049: @124952
     /*  124952 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(125066),
     /*  124957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  124960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  124963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124971 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124975 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(125020), // Rule ID 47696 //
     /*  124980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124983 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  124983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  124986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  125015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125018 */     GIR_RootConstrainSelectedInstOperands,
     /*  125019 */     // GIR_Coverage, 47696,
     /*  125019 */     GIR_EraseRootFromParent_Done,
     /*  125020 */   // Label 2194: @125020
     /*  125020 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(125065), // Rule ID 47697 //
     /*  125025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125028 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  125028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  125031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  125060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125063 */     GIR_RootConstrainSelectedInstOperands,
     /*  125064 */     // GIR_Coverage, 47697,
     /*  125064 */     GIR_EraseRootFromParent_Done,
     /*  125065 */   // Label 2195: @125065
     /*  125065 */   GIM_Reject,
     /*  125066 */ // Label 2193: @125066
     /*  125066 */ GIM_Reject,
     /*  125067 */ // Label 2050: @125067
     /*  125067 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(125181),
     /*  125072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  125075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  125078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125090 */   GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(125135), // Rule ID 47712 //
     /*  125095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125098 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  125098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  125101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  125115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  125130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125133 */     GIR_RootConstrainSelectedInstOperands,
     /*  125134 */     // GIR_Coverage, 47712,
     /*  125134 */     GIR_EraseRootFromParent_Done,
     /*  125135 */   // Label 2197: @125135
     /*  125135 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(125180), // Rule ID 47713 //
     /*  125140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125143 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  125143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  125146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  125160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  125175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125178 */     GIR_RootConstrainSelectedInstOperands,
     /*  125179 */     // GIR_Coverage, 47713,
     /*  125179 */     GIR_EraseRootFromParent_Done,
     /*  125180 */   // Label 2198: @125180
     /*  125180 */   GIM_Reject,
     /*  125181 */ // Label 2196: @125181
     /*  125181 */ GIM_Reject,
     /*  125182 */ // Label 2051: @125182
     /*  125182 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(125296),
     /*  125187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  125190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  125193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125205 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(125250), // Rule ID 47728 //
     /*  125210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  125213 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  125213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  125216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  125230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125248 */     GIR_RootConstrainSelectedInstOperands,
     /*  125249 */     // GIR_Coverage, 47728,
     /*  125249 */     GIR_EraseRootFromParent_Done,
     /*  125250 */   // Label 2200: @125250
     /*  125250 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(125295), // Rule ID 47729 //
     /*  125255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  125258 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  125258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  125261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  125275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125293 */     GIR_RootConstrainSelectedInstOperands,
     /*  125294 */     // GIR_Coverage, 47729,
     /*  125294 */     GIR_EraseRootFromParent_Done,
     /*  125295 */   // Label 2201: @125295
     /*  125295 */   GIM_Reject,
     /*  125296 */ // Label 2199: @125296
     /*  125296 */ GIM_Reject,
     /*  125297 */ // Label 2052: @125297
     /*  125297 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(125907),
     /*  125302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125312 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(125378), // Rule ID 71754 //
     /*  125317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125359 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125376 */     GIR_RootConstrainSelectedInstOperands,
     /*  125377 */     // GIR_Coverage, 71754,
     /*  125377 */     GIR_EraseRootFromParent_Done,
     /*  125378 */   // Label 2203: @125378
     /*  125378 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(125444), // Rule ID 71755 //
     /*  125383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125425 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125442 */     GIR_RootConstrainSelectedInstOperands,
     /*  125443 */     // GIR_Coverage, 71755,
     /*  125443 */     GIR_EraseRootFromParent_Done,
     /*  125444 */   // Label 2204: @125444
     /*  125444 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(125510), // Rule ID 71752 //
     /*  125449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125491 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125508 */     GIR_RootConstrainSelectedInstOperands,
     /*  125509 */     // GIR_Coverage, 71752,
     /*  125509 */     GIR_EraseRootFromParent_Done,
     /*  125510 */   // Label 2205: @125510
     /*  125510 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(125576), // Rule ID 71753 //
     /*  125515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125557 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125574 */     GIR_RootConstrainSelectedInstOperands,
     /*  125575 */     // GIR_Coverage, 71753,
     /*  125575 */     GIR_EraseRootFromParent_Done,
     /*  125576 */   // Label 2206: @125576
     /*  125576 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(125642), // Rule ID 71750 //
     /*  125581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125623 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125640 */     GIR_RootConstrainSelectedInstOperands,
     /*  125641 */     // GIR_Coverage, 71750,
     /*  125641 */     GIR_EraseRootFromParent_Done,
     /*  125642 */   // Label 2207: @125642
     /*  125642 */   GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(125708), // Rule ID 71751 //
     /*  125647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125689 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125706 */     GIR_RootConstrainSelectedInstOperands,
     /*  125707 */     // GIR_Coverage, 71751,
     /*  125707 */     GIR_EraseRootFromParent_Done,
     /*  125708 */   // Label 2208: @125708
     /*  125708 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(125774), // Rule ID 53236 //
     /*  125713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125755 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125772 */     GIR_RootConstrainSelectedInstOperands,
     /*  125773 */     // GIR_Coverage, 53236,
     /*  125773 */     GIR_EraseRootFromParent_Done,
     /*  125774 */   // Label 2209: @125774
     /*  125774 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(125840), // Rule ID 53237 //
     /*  125779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125821 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125838 */     GIR_RootConstrainSelectedInstOperands,
     /*  125839 */     // GIR_Coverage, 53237,
     /*  125839 */     GIR_EraseRootFromParent_Done,
     /*  125840 */   // Label 2210: @125840
     /*  125840 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(125873), // Rule ID 53224 //
     /*  125845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125856 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  125859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125871 */     GIR_RootConstrainSelectedInstOperands,
     /*  125872 */     // GIR_Coverage, 53224,
     /*  125872 */     GIR_EraseRootFromParent_Done,
     /*  125873 */   // Label 2211: @125873
     /*  125873 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(125906), // Rule ID 53225 //
     /*  125878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125889 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  125892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125904 */     GIR_RootConstrainSelectedInstOperands,
     /*  125905 */     // GIR_Coverage, 53225,
     /*  125905 */     GIR_EraseRootFromParent_Done,
     /*  125906 */   // Label 2212: @125906
     /*  125906 */   GIM_Reject,
     /*  125907 */ // Label 2202: @125907
     /*  125907 */ GIM_Reject,
     /*  125908 */ // Label 2053: @125908
     /*  125908 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(126022),
     /*  125913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  125916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  125919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125931 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(125976), // Rule ID 47684 //
     /*  125936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125939 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  125939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  125942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125974 */     GIR_RootConstrainSelectedInstOperands,
     /*  125975 */     // GIR_Coverage, 47684,
     /*  125975 */     GIR_EraseRootFromParent_Done,
     /*  125976 */   // Label 2214: @125976
     /*  125976 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(126021), // Rule ID 47685 //
     /*  125981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125984 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  125984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  125987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  126001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126019 */     GIR_RootConstrainSelectedInstOperands,
     /*  126020 */     // GIR_Coverage, 47685,
     /*  126020 */     GIR_EraseRootFromParent_Done,
     /*  126021 */   // Label 2215: @126021
     /*  126021 */   GIM_Reject,
     /*  126022 */ // Label 2213: @126022
     /*  126022 */ GIM_Reject,
     /*  126023 */ // Label 2054: @126023
     /*  126023 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(126137),
     /*  126028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  126031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  126034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126046 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(126091), // Rule ID 47700 //
     /*  126051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126054 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  126054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  126057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126089 */     GIR_RootConstrainSelectedInstOperands,
     /*  126090 */     // GIR_Coverage, 47700,
     /*  126090 */     GIR_EraseRootFromParent_Done,
     /*  126091 */   // Label 2217: @126091
     /*  126091 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(126136), // Rule ID 47701 //
     /*  126096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126099 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  126099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  126102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126134 */     GIR_RootConstrainSelectedInstOperands,
     /*  126135 */     // GIR_Coverage, 47701,
     /*  126135 */     GIR_EraseRootFromParent_Done,
     /*  126136 */   // Label 2218: @126136
     /*  126136 */   GIM_Reject,
     /*  126137 */ // Label 2216: @126137
     /*  126137 */ GIM_Reject,
     /*  126138 */ // Label 2055: @126138
     /*  126138 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(126252),
     /*  126143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  126146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  126149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126161 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(126206), // Rule ID 47716 //
     /*  126166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126169 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  126169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  126172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  126186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126204 */     GIR_RootConstrainSelectedInstOperands,
     /*  126205 */     // GIR_Coverage, 47716,
     /*  126205 */     GIR_EraseRootFromParent_Done,
     /*  126206 */   // Label 2220: @126206
     /*  126206 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(126251), // Rule ID 47717 //
     /*  126211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126214 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  126214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  126217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  126231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126249 */     GIR_RootConstrainSelectedInstOperands,
     /*  126250 */     // GIR_Coverage, 47717,
     /*  126250 */     GIR_EraseRootFromParent_Done,
     /*  126251 */   // Label 2221: @126251
     /*  126251 */   GIM_Reject,
     /*  126252 */ // Label 2219: @126252
     /*  126252 */ GIM_Reject,
     /*  126253 */ // Label 2056: @126253
     /*  126253 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(126863),
     /*  126258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126268 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(126334), // Rule ID 71782 //
     /*  126273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126315 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126332 */     GIR_RootConstrainSelectedInstOperands,
     /*  126333 */     // GIR_Coverage, 71782,
     /*  126333 */     GIR_EraseRootFromParent_Done,
     /*  126334 */   // Label 2223: @126334
     /*  126334 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(126400), // Rule ID 71783 //
     /*  126339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126381 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126398 */     GIR_RootConstrainSelectedInstOperands,
     /*  126399 */     // GIR_Coverage, 71783,
     /*  126399 */     GIR_EraseRootFromParent_Done,
     /*  126400 */   // Label 2224: @126400
     /*  126400 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(126466), // Rule ID 71780 //
     /*  126405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126447 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126464 */     GIR_RootConstrainSelectedInstOperands,
     /*  126465 */     // GIR_Coverage, 71780,
     /*  126465 */     GIR_EraseRootFromParent_Done,
     /*  126466 */   // Label 2225: @126466
     /*  126466 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(126532), // Rule ID 71781 //
     /*  126471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126513 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126530 */     GIR_RootConstrainSelectedInstOperands,
     /*  126531 */     // GIR_Coverage, 71781,
     /*  126531 */     GIR_EraseRootFromParent_Done,
     /*  126532 */   // Label 2226: @126532
     /*  126532 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(126598), // Rule ID 71778 //
     /*  126537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126579 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126596 */     GIR_RootConstrainSelectedInstOperands,
     /*  126597 */     // GIR_Coverage, 71778,
     /*  126597 */     GIR_EraseRootFromParent_Done,
     /*  126598 */   // Label 2227: @126598
     /*  126598 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(126664), // Rule ID 71779 //
     /*  126603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126645 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126662 */     GIR_RootConstrainSelectedInstOperands,
     /*  126663 */     // GIR_Coverage, 71779,
     /*  126663 */     GIR_EraseRootFromParent_Done,
     /*  126664 */   // Label 2228: @126664
     /*  126664 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(126730), // Rule ID 53254 //
     /*  126669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126711 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126728 */     GIR_RootConstrainSelectedInstOperands,
     /*  126729 */     // GIR_Coverage, 53254,
     /*  126729 */     GIR_EraseRootFromParent_Done,
     /*  126730 */   // Label 2229: @126730
     /*  126730 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(126796), // Rule ID 53255 //
     /*  126735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126777 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126794 */     GIR_RootConstrainSelectedInstOperands,
     /*  126795 */     // GIR_Coverage, 53255,
     /*  126795 */     GIR_EraseRootFromParent_Done,
     /*  126796 */   // Label 2230: @126796
     /*  126796 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(126829), // Rule ID 53242 //
     /*  126801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126812 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  126815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126827 */     GIR_RootConstrainSelectedInstOperands,
     /*  126828 */     // GIR_Coverage, 53242,
     /*  126828 */     GIR_EraseRootFromParent_Done,
     /*  126829 */   // Label 2231: @126829
     /*  126829 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(126862), // Rule ID 53243 //
     /*  126834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126845 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  126848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126860 */     GIR_RootConstrainSelectedInstOperands,
     /*  126861 */     // GIR_Coverage, 53243,
     /*  126861 */     GIR_EraseRootFromParent_Done,
     /*  126862 */   // Label 2232: @126862
     /*  126862 */   GIM_Reject,
     /*  126863 */ // Label 2222: @126863
     /*  126863 */ GIM_Reject,
     /*  126864 */ // Label 2057: @126864
     /*  126864 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(126978),
     /*  126869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  126872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  126875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126883 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126887 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(126932), // Rule ID 47688 //
     /*  126892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126895 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  126895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  126898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126930 */     GIR_RootConstrainSelectedInstOperands,
     /*  126931 */     // GIR_Coverage, 47688,
     /*  126931 */     GIR_EraseRootFromParent_Done,
     /*  126932 */   // Label 2234: @126932
     /*  126932 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(126977), // Rule ID 47689 //
     /*  126937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126940 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  126940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  126943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126975 */     GIR_RootConstrainSelectedInstOperands,
     /*  126976 */     // GIR_Coverage, 47689,
     /*  126976 */     GIR_EraseRootFromParent_Done,
     /*  126977 */   // Label 2235: @126977
     /*  126977 */   GIM_Reject,
     /*  126978 */ // Label 2233: @126978
     /*  126978 */ GIM_Reject,
     /*  126979 */ // Label 2058: @126979
     /*  126979 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(127093),
     /*  126984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  126987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  126990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127002 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(127047), // Rule ID 47704 //
     /*  127007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127010 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  127010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  127013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127045 */     GIR_RootConstrainSelectedInstOperands,
     /*  127046 */     // GIR_Coverage, 47704,
     /*  127046 */     GIR_EraseRootFromParent_Done,
     /*  127047 */   // Label 2237: @127047
     /*  127047 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(127092), // Rule ID 47705 //
     /*  127052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127055 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  127055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  127058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127090 */     GIR_RootConstrainSelectedInstOperands,
     /*  127091 */     // GIR_Coverage, 47705,
     /*  127091 */     GIR_EraseRootFromParent_Done,
     /*  127092 */   // Label 2238: @127092
     /*  127092 */   GIM_Reject,
     /*  127093 */ // Label 2236: @127093
     /*  127093 */ GIM_Reject,
     /*  127094 */ // Label 2059: @127094
     /*  127094 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(127704),
     /*  127099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127109 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(127175), // Rule ID 71810 //
     /*  127114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127156 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127173 */     GIR_RootConstrainSelectedInstOperands,
     /*  127174 */     // GIR_Coverage, 71810,
     /*  127174 */     GIR_EraseRootFromParent_Done,
     /*  127175 */   // Label 2240: @127175
     /*  127175 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(127241), // Rule ID 71811 //
     /*  127180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127222 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127239 */     GIR_RootConstrainSelectedInstOperands,
     /*  127240 */     // GIR_Coverage, 71811,
     /*  127240 */     GIR_EraseRootFromParent_Done,
     /*  127241 */   // Label 2241: @127241
     /*  127241 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(127307), // Rule ID 71808 //
     /*  127246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127288 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127305 */     GIR_RootConstrainSelectedInstOperands,
     /*  127306 */     // GIR_Coverage, 71808,
     /*  127306 */     GIR_EraseRootFromParent_Done,
     /*  127307 */   // Label 2242: @127307
     /*  127307 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(127373), // Rule ID 71809 //
     /*  127312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127354 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127371 */     GIR_RootConstrainSelectedInstOperands,
     /*  127372 */     // GIR_Coverage, 71809,
     /*  127372 */     GIR_EraseRootFromParent_Done,
     /*  127373 */   // Label 2243: @127373
     /*  127373 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(127439), // Rule ID 71806 //
     /*  127378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127420 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127437 */     GIR_RootConstrainSelectedInstOperands,
     /*  127438 */     // GIR_Coverage, 71806,
     /*  127438 */     GIR_EraseRootFromParent_Done,
     /*  127439 */   // Label 2244: @127439
     /*  127439 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(127505), // Rule ID 71807 //
     /*  127444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127486 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127503 */     GIR_RootConstrainSelectedInstOperands,
     /*  127504 */     // GIR_Coverage, 71807,
     /*  127504 */     GIR_EraseRootFromParent_Done,
     /*  127505 */   // Label 2245: @127505
     /*  127505 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(127571), // Rule ID 53272 //
     /*  127510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127552 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127569 */     GIR_RootConstrainSelectedInstOperands,
     /*  127570 */     // GIR_Coverage, 53272,
     /*  127570 */     GIR_EraseRootFromParent_Done,
     /*  127571 */   // Label 2246: @127571
     /*  127571 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(127637), // Rule ID 53273 //
     /*  127576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127618 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127635 */     GIR_RootConstrainSelectedInstOperands,
     /*  127636 */     // GIR_Coverage, 53273,
     /*  127636 */     GIR_EraseRootFromParent_Done,
     /*  127637 */   // Label 2247: @127637
     /*  127637 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(127670), // Rule ID 53260 //
     /*  127642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127653 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  127656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127668 */     GIR_RootConstrainSelectedInstOperands,
     /*  127669 */     // GIR_Coverage, 53260,
     /*  127669 */     GIR_EraseRootFromParent_Done,
     /*  127670 */   // Label 2248: @127670
     /*  127670 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(127703), // Rule ID 53261 //
     /*  127675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127686 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  127689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127701 */     GIR_RootConstrainSelectedInstOperands,
     /*  127702 */     // GIR_Coverage, 53261,
     /*  127702 */     GIR_EraseRootFromParent_Done,
     /*  127703 */   // Label 2249: @127703
     /*  127703 */   GIM_Reject,
     /*  127704 */ // Label 2239: @127704
     /*  127704 */ GIM_Reject,
     /*  127705 */ // Label 2060: @127705
     /*  127705 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(127819),
     /*  127710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  127713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  127716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127728 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(127773), // Rule ID 47692 //
     /*  127733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127736 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  127736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  127739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127771 */     GIR_RootConstrainSelectedInstOperands,
     /*  127772 */     // GIR_Coverage, 47692,
     /*  127772 */     GIR_EraseRootFromParent_Done,
     /*  127773 */   // Label 2251: @127773
     /*  127773 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(127818), // Rule ID 47693 //
     /*  127778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127781 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  127781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  127784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127816 */     GIR_RootConstrainSelectedInstOperands,
     /*  127817 */     // GIR_Coverage, 47693,
     /*  127817 */     GIR_EraseRootFromParent_Done,
     /*  127818 */   // Label 2252: @127818
     /*  127818 */   GIM_Reject,
     /*  127819 */ // Label 2250: @127819
     /*  127819 */ GIM_Reject,
     /*  127820 */ // Label 2061: @127820
     /*  127820 */ GIM_Reject,
     /*  127821 */ // Label 8: @127821
     /*  127821 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2284*/ GIMT_Encode4(140441),
     /*  127832 */ /*GILLT_s32*//*Label 2253*/ GIMT_Encode4(127956),
     /*  127836 */ /*GILLT_s64*//*Label 2254*/ GIMT_Encode4(130686),
     /*  127840 */ /*GILLT_nxv1s1*//*Label 2255*/ GIMT_Encode4(133634),
     /*  127844 */ /*GILLT_nxv1s8*//*Label 2256*/ GIMT_Encode4(134245),
     /*  127848 */ /*GILLT_nxv1s16*//*Label 2257*/ GIMT_Encode4(134360),
     /*  127852 */ /*GILLT_nxv1s32*//*Label 2258*/ GIMT_Encode4(134475),
     /*  127856 */ /*GILLT_nxv1s64*//*Label 2259*/ GIMT_Encode4(134590),
     /*  127860 */ /*GILLT_nxv2s1*//*Label 2260*/ GIMT_Encode4(134705),
     /*  127864 */ /*GILLT_nxv2s8*//*Label 2261*/ GIMT_Encode4(135316),
     /*  127868 */ /*GILLT_nxv2s16*//*Label 2262*/ GIMT_Encode4(135431),
     /*  127872 */ /*GILLT_nxv2s32*//*Label 2263*/ GIMT_Encode4(135546),
     /*  127876 */ /*GILLT_nxv2s64*//*Label 2264*/ GIMT_Encode4(135661),
     /*  127880 */ /*GILLT_nxv4s1*//*Label 2265*/ GIMT_Encode4(135776),
     /*  127884 */ /*GILLT_nxv4s8*//*Label 2266*/ GIMT_Encode4(136387),
     /*  127888 */ /*GILLT_nxv4s16*//*Label 2267*/ GIMT_Encode4(136502),
     /*  127892 */ /*GILLT_nxv4s32*//*Label 2268*/ GIMT_Encode4(136617),
     /*  127896 */ /*GILLT_nxv4s64*//*Label 2269*/ GIMT_Encode4(136732),
     /*  127900 */ /*GILLT_nxv8s1*//*Label 2270*/ GIMT_Encode4(136847),
     /*  127904 */ /*GILLT_nxv8s8*//*Label 2271*/ GIMT_Encode4(137458),
     /*  127908 */ /*GILLT_nxv8s16*//*Label 2272*/ GIMT_Encode4(137573),
     /*  127912 */ /*GILLT_nxv8s32*//*Label 2273*/ GIMT_Encode4(137688),
     /*  127916 */ /*GILLT_nxv8s64*//*Label 2274*/ GIMT_Encode4(137803),
     /*  127920 */ /*GILLT_nxv16s1*//*Label 2275*/ GIMT_Encode4(137918),
     /*  127924 */ /*GILLT_nxv16s8*//*Label 2276*/ GIMT_Encode4(138529),
     /*  127928 */ /*GILLT_nxv16s16*//*Label 2277*/ GIMT_Encode4(138644),
     /*  127932 */ /*GILLT_nxv16s32*//*Label 2278*/ GIMT_Encode4(138759),
     /*  127936 */ /*GILLT_nxv32s1*//*Label 2279*/ GIMT_Encode4(138874),
     /*  127940 */ /*GILLT_nxv32s8*//*Label 2280*/ GIMT_Encode4(139485),
     /*  127944 */ /*GILLT_nxv32s16*//*Label 2281*/ GIMT_Encode4(139600),
     /*  127948 */ /*GILLT_nxv64s1*//*Label 2282*/ GIMT_Encode4(139715),
     /*  127952 */ /*GILLT_nxv64s8*//*Label 2283*/ GIMT_Encode4(140326),
     /*  127956 */ // Label 2253: @127956
     /*  127956 */ GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(130685),
     /*  127961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  127964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  127967 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(128162), // Rule ID 65460 //
     /*  127972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  127975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  127979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  127987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  127991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  127995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128011 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128023 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128027 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128031 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128035 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128039 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128043 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128047 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  128051 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128055 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128059 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128063 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128067 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  128071 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128080 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128087 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128094 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128101 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  128118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  128123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  128142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  128147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128160 */     GIR_RootConstrainSelectedInstOperands,
     /*  128161 */     // GIR_Coverage, 65460,
     /*  128161 */     GIR_EraseRootFromParent_Done,
     /*  128162 */   // Label 2286: @128162
     /*  128162 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(128357), // Rule ID 65462 //
     /*  128167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128206 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128218 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128222 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128226 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128230 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128234 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128238 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128242 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  128246 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128250 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128254 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128258 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128262 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  128266 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128282 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128289 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128296 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128296 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128299 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128303 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  128313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  128318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  128337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  128342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128355 */     GIR_RootConstrainSelectedInstOperands,
     /*  128356 */     // GIR_Coverage, 65462,
     /*  128356 */     GIR_EraseRootFromParent_Done,
     /*  128357 */   // Label 2287: @128357
     /*  128357 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(128552), // Rule ID 65456 //
     /*  128362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128401 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128413 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128417 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128421 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128425 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128429 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128433 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128437 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  128441 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128445 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128449 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128453 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128457 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  128461 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128477 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128484 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128491 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128491 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128494 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128498 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  128508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  128513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  128532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  128537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128550 */     GIR_RootConstrainSelectedInstOperands,
     /*  128551 */     // GIR_Coverage, 65456,
     /*  128551 */     GIR_EraseRootFromParent_Done,
     /*  128552 */   // Label 2288: @128552
     /*  128552 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(128747), // Rule ID 65458 //
     /*  128557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128596 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128608 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128612 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128620 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128624 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128628 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128632 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  128636 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128640 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128644 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128648 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128652 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  128656 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128672 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128679 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128686 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128686 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128689 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128693 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  128703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  128708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  128727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  128732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128745 */     GIR_RootConstrainSelectedInstOperands,
     /*  128746 */     // GIR_Coverage, 65458,
     /*  128746 */     GIR_EraseRootFromParent_Done,
     /*  128747 */   // Label 2289: @128747
     /*  128747 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(128942), // Rule ID 65450 //
     /*  128752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128791 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  128795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  128799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128803 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128807 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128811 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  128815 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  128819 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128823 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128827 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128831 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  128835 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128839 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128843 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128847 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  128851 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128853 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128860 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128867 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128874 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128881 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128881 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128888 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  128898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  128903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  128922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  128927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128940 */     GIR_RootConstrainSelectedInstOperands,
     /*  128941 */     // GIR_Coverage, 65450,
     /*  128941 */     GIR_EraseRootFromParent_Done,
     /*  128942 */   // Label 2290: @128942
     /*  128942 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(129137), // Rule ID 65454 //
     /*  128947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128986 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  128990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  128994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128998 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129002 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129006 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  129010 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129014 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129018 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129022 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129026 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  129030 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129034 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129038 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129042 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129046 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129055 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129062 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129069 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129076 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129076 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129079 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129083 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  129093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  129098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  129117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  129122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129135 */     GIR_RootConstrainSelectedInstOperands,
     /*  129136 */     // GIR_Coverage, 65454,
     /*  129136 */     GIR_EraseRootFromParent_Done,
     /*  129137 */   // Label 2291: @129137
     /*  129137 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(129332), // Rule ID 2541 //
     /*  129142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129181 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  129185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129193 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129197 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129201 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  129205 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129209 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129213 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129217 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129221 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  129225 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129229 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129233 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129237 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129241 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129250 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129257 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129264 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129271 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129271 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129274 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129278 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  129288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  129293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  129312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  129317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129330 */     GIR_RootConstrainSelectedInstOperands,
     /*  129331 */     // GIR_Coverage, 2541,
     /*  129331 */     GIR_EraseRootFromParent_Done,
     /*  129332 */   // Label 2292: @129332
     /*  129332 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(129527), // Rule ID 65452 //
     /*  129337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129376 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  129380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129388 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129392 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129396 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  129400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129408 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129412 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129416 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  129420 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129424 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129428 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129432 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129436 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129445 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129452 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129459 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129466 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  129483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  129488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  129507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  129512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129525 */     GIR_RootConstrainSelectedInstOperands,
     /*  129526 */     // GIR_Coverage, 65452,
     /*  129526 */     GIR_EraseRootFromParent_Done,
     /*  129527 */   // Label 2293: @129527
     /*  129527 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(129632), // Rule ID 2536 //
     /*  129532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  129535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129555 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  129559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  129563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129575 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  129579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129595 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  129595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  129612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  129617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  129622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  129630 */     GIR_RootConstrainSelectedInstOperands,
     /*  129631 */     // GIR_Coverage, 2536,
     /*  129631 */     GIR_EraseRootFromParent_Done,
     /*  129632 */   // Label 2294: @129632
     /*  129632 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(129737), // Rule ID 65445 //
     /*  129637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  129640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129660 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  129664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  129668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129680 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  129684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129700 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  129700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  129717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  129722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  129727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  129735 */     GIR_RootConstrainSelectedInstOperands,
     /*  129736 */     // GIR_Coverage, 65445,
     /*  129736 */     GIR_EraseRootFromParent_Done,
     /*  129737 */   // Label 2295: @129737
     /*  129737 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(129826), // Rule ID 65439 //
     /*  129742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  129745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  129753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  129757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129786 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  129790 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  129801 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129810 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  129810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  129820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  129824 */     GIR_RootConstrainSelectedInstOperands,
     /*  129825 */     // GIR_Coverage, 65439,
     /*  129825 */     GIR_EraseRootFromParent_Done,
     /*  129826 */   // Label 2296: @129826
     /*  129826 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(129915), // Rule ID 2530 //
     /*  129831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  129834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  129846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129866 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129870 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129875 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  129879 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  129890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129899 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  129899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  129909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  129913 */     GIR_RootConstrainSelectedInstOperands,
     /*  129914 */     // GIR_Coverage, 2530,
     /*  129914 */     GIR_EraseRootFromParent_Done,
     /*  129915 */   // Label 2297: @129915
     /*  129915 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(129980), // Rule ID 65441 //
     /*  129920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  129923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  129931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  129947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129963 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  129963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  129973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  129978 */     GIR_RootConstrainSelectedInstOperands,
     /*  129979 */     // GIR_Coverage, 65441,
     /*  129979 */     GIR_EraseRootFromParent_Done,
     /*  129980 */   // Label 2298: @129980
     /*  129980 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(130045), // Rule ID 2532 //
     /*  129985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  129988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130008 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130028 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  130038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130043 */     GIR_RootConstrainSelectedInstOperands,
     /*  130044 */     // GIR_Coverage, 2532,
     /*  130044 */     GIR_EraseRootFromParent_Done,
     /*  130045 */   // Label 2299: @130045
     /*  130045 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(130111), // Rule ID 65447 //
     /*  130050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130078 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130082 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11254),
     /*  130086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130095 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }))<<P:Predicate_anonymous_11254>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130109 */     GIR_RootConstrainSelectedInstOperands,
     /*  130110 */     // GIR_Coverage, 65447,
     /*  130110 */     GIR_EraseRootFromParent_Done,
     /*  130111 */   // Label 2300: @130111
     /*  130111 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(130177), // Rule ID 2538 //
     /*  130116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130144 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130148 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11254),
     /*  130152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130161 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))<<P:Predicate_anonymous_11254>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130175 */     GIR_RootConstrainSelectedInstOperands,
     /*  130176 */     // GIR_Coverage, 2538,
     /*  130176 */     GIR_EraseRootFromParent_Done,
     /*  130177 */   // Label 2301: @130177
     /*  130177 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(130239), // Rule ID 2539 //
     /*  130182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  130185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130210 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  130214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  130223 */     // (or:{ *:[i32] } (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130237 */     GIR_RootConstrainSelectedInstOperands,
     /*  130238 */     // GIR_Coverage, 2539,
     /*  130238 */     GIR_EraseRootFromParent_Done,
     /*  130239 */   // Label 2302: @130239
     /*  130239 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(130301), // Rule ID 65448 //
     /*  130244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  130247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130272 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  130276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  130285 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }), (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130299 */     GIR_RootConstrainSelectedInstOperands,
     /*  130300 */     // GIR_Coverage, 65448,
     /*  130300 */     GIR_EraseRootFromParent_Done,
     /*  130301 */   // Label 2303: @130301
     /*  130301 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(130360), // Rule ID 2465 //
     /*  130306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  130309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130329 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  130333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  130346 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  130349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130358 */     GIR_RootConstrainSelectedInstOperands,
     /*  130359 */     // GIR_Coverage, 2465,
     /*  130359 */     GIR_EraseRootFromParent_Done,
     /*  130360 */   // Label 2304: @130360
     /*  130360 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(130419), // Rule ID 65435 //
     /*  130365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  130368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130392 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  130396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  130405 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  130408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130417 */     GIR_RootConstrainSelectedInstOperands,
     /*  130418 */     // GIR_Coverage, 65435,
     /*  130418 */     GIR_EraseRootFromParent_Done,
     /*  130419 */   // Label 2305: @130419
     /*  130419 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(130475), // Rule ID 65419 //
     /*  130424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  130427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130452 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  130456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130462 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  130465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130473 */     GIR_RootConstrainSelectedInstOperands,
     /*  130474 */     // GIR_Coverage, 65419,
     /*  130474 */     GIR_EraseRootFromParent_Done,
     /*  130475 */   // Label 2306: @130475
     /*  130475 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(130531), // Rule ID 2439 //
     /*  130480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  130483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130512 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  130516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130518 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  130521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130529 */     GIR_RootConstrainSelectedInstOperands,
     /*  130530 */     // GIR_Coverage, 2439,
     /*  130530 */     GIR_EraseRootFromParent_Done,
     /*  130531 */   // Label 2307: @130531
     /*  130531 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(130573), // Rule ID 81 //
     /*  130536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  130539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  130559 */     // MIs[1] Operand 1
     /*  130559 */     // No operand predicates
     /*  130559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130561 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  130561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  130564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  130571 */     GIR_RootConstrainSelectedInstOperands,
     /*  130572 */     // GIR_Coverage, 81,
     /*  130572 */     GIR_EraseRootFromParent_Done,
     /*  130573 */   // Label 2308: @130573
     /*  130573 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(130615), // Rule ID 64520 //
     /*  130578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  130581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  130585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  130589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  130601 */     // MIs[1] Operand 1
     /*  130601 */     // No operand predicates
     /*  130601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130603 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  130603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORAI),
     /*  130606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  130608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  130613 */     GIR_RootConstrainSelectedInstOperands,
     /*  130614 */     // GIR_Coverage, 64520,
     /*  130614 */     GIR_EraseRootFromParent_Done,
     /*  130615 */   // Label 2309: @130615
     /*  130615 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(130657), // Rule ID 64524 //
     /*  130620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  130623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  130627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  130631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  130643 */     // MIs[1] Operand 1
     /*  130643 */     // No operand predicates
     /*  130643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130645 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  130645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORI),
     /*  130648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  130655 */     GIR_RootConstrainSelectedInstOperands,
     /*  130656 */     // GIR_Coverage, 64524,
     /*  130656 */     GIR_EraseRootFromParent_Done,
     /*  130657 */   // Label 2310: @130657
     /*  130657 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(130684), // Rule ID 79 //
     /*  130662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  130665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130677 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (OR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  130682 */     GIR_RootConstrainSelectedInstOperands,
     /*  130683 */     // GIR_Coverage, 79,
     /*  130683 */     GIR_Done,
     /*  130684 */   // Label 2311: @130684
     /*  130684 */   GIM_Reject,
     /*  130685 */ // Label 2285: @130685
     /*  130685 */ GIM_Reject,
     /*  130686 */ // Label 2254: @130686
     /*  130686 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(133633),
     /*  130691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  130694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  130697 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(130892), // Rule ID 65459 //
     /*  130702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  130705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  130721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  130725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  130729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  130737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  130741 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  130745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  130749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130753 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  130757 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  130761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  130765 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130769 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  130773 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  130777 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  130781 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  130785 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130789 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  130793 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  130797 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  130801 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  130803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130810 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130817 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  130824 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  130831 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  130831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  130834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  130848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  130853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  130855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  130858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  130872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  130877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  130890 */     GIR_RootConstrainSelectedInstOperands,
     /*  130891 */     // GIR_Coverage, 65459,
     /*  130891 */     GIR_EraseRootFromParent_Done,
     /*  130892 */   // Label 2313: @130892
     /*  130892 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(131087), // Rule ID 65461 //
     /*  130897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  130900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  130916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  130920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  130924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  130932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  130936 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  130940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  130944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130948 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  130952 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  130956 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  130960 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130964 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  130968 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  130972 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  130976 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  130980 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130984 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  130988 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  130992 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  130996 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  130998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131005 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131012 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131019 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131026 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131026 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131029 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131033 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  131043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  131048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  131067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  131072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131085 */     GIR_RootConstrainSelectedInstOperands,
     /*  131086 */     // GIR_Coverage, 65461,
     /*  131086 */     GIR_EraseRootFromParent_Done,
     /*  131087 */   // Label 2314: @131087
     /*  131087 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(131282), // Rule ID 65455 //
     /*  131092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131131 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131147 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131151 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131155 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131159 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131163 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131167 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  131171 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131175 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131179 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131183 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131187 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  131191 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131207 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131214 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131221 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131221 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131224 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131228 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  131238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  131243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  131262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  131267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131280 */     GIR_RootConstrainSelectedInstOperands,
     /*  131281 */     // GIR_Coverage, 65455,
     /*  131281 */     GIR_EraseRootFromParent_Done,
     /*  131282 */   // Label 2315: @131282
     /*  131282 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(131477), // Rule ID 65457 //
     /*  131287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131326 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131338 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131342 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131346 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131350 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131354 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131358 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131362 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  131366 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131370 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131374 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131378 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131382 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  131386 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131395 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131402 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131409 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131416 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131416 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131419 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131423 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  131433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  131438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  131457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  131462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131475 */     GIR_RootConstrainSelectedInstOperands,
     /*  131476 */     // GIR_Coverage, 65457,
     /*  131476 */     GIR_EraseRootFromParent_Done,
     /*  131477 */   // Label 2316: @131477
     /*  131477 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(131672), // Rule ID 65449 //
     /*  131482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131521 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  131525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  131529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131537 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131541 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  131545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  131549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131553 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131557 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131561 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  131565 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131569 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131573 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131577 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  131581 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131583 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131590 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131597 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131604 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131611 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131611 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131614 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131618 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  131628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  131633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  131652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  131657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131670 */     GIR_RootConstrainSelectedInstOperands,
     /*  131671 */     // GIR_Coverage, 65449,
     /*  131671 */     GIR_EraseRootFromParent_Done,
     /*  131672 */   // Label 2317: @131672
     /*  131672 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(131867), // Rule ID 65453 //
     /*  131677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131716 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  131720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  131724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131728 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131732 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131736 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  131740 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  131744 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131748 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131752 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131756 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  131760 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131764 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131768 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131772 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  131776 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131778 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131785 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131792 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131799 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131806 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131806 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131809 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131813 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  131823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  131828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  131847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  131852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131865 */     GIR_RootConstrainSelectedInstOperands,
     /*  131866 */     // GIR_Coverage, 65453,
     /*  131866 */     GIR_EraseRootFromParent_Done,
     /*  131867 */   // Label 2318: @131867
     /*  131867 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(132062), // Rule ID 2540 //
     /*  131872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131911 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  131915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  131919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131923 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131927 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131931 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  131935 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  131939 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131943 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131947 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131951 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  131955 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131959 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131963 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131967 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  131971 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131980 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131987 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131994 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132001 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132001 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132004 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132008 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  132018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  132023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  132042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  132047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132060 */     GIR_RootConstrainSelectedInstOperands,
     /*  132061 */     // GIR_Coverage, 2540,
     /*  132061 */     GIR_EraseRootFromParent_Done,
     /*  132062 */   // Label 2319: @132062
     /*  132062 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(132257), // Rule ID 65451 //
     /*  132067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132106 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132118 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132122 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132126 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  132130 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132134 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132138 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132142 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132146 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  132150 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132154 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132158 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132162 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132166 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132168 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132175 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132182 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132189 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132196 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132196 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132199 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132203 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  132213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  132218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  132237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  132242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132255 */     GIR_RootConstrainSelectedInstOperands,
     /*  132256 */     // GIR_Coverage, 65451,
     /*  132256 */     GIR_EraseRootFromParent_Done,
     /*  132257 */   // Label 2320: @132257
     /*  132257 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(132362), // Rule ID 2535 //
     /*  132262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132285 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  132289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  132293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132305 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132325 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  132325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  132342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  132347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  132352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  132360 */     GIR_RootConstrainSelectedInstOperands,
     /*  132361 */     // GIR_Coverage, 2535,
     /*  132361 */     GIR_EraseRootFromParent_Done,
     /*  132362 */   // Label 2321: @132362
     /*  132362 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(132467), // Rule ID 65444 //
     /*  132367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132390 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  132394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  132398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132410 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  132414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132423 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132430 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  132430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  132452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  132457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  132465 */     GIR_RootConstrainSelectedInstOperands,
     /*  132466 */     // GIR_Coverage, 65444,
     /*  132466 */     GIR_EraseRootFromParent_Done,
     /*  132467 */   // Label 2322: @132467
     /*  132467 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(132556), // Rule ID 65438 //
     /*  132472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  132483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  132487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132516 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  132520 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  132531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132540 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  132554 */     GIR_RootConstrainSelectedInstOperands,
     /*  132555 */     // GIR_Coverage, 65438,
     /*  132555 */     GIR_EraseRootFromParent_Done,
     /*  132556 */   // Label 2323: @132556
     /*  132556 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(132645), // Rule ID 2529 //
     /*  132561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  132576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132605 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  132609 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  132620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132629 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  132643 */     GIR_RootConstrainSelectedInstOperands,
     /*  132644 */     // GIR_Coverage, 2529,
     /*  132644 */     GIR_EraseRootFromParent_Done,
     /*  132645 */   // Label 2324: @132645
     /*  132645 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(132710), // Rule ID 65440 //
     /*  132650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  132661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132673 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  132677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132693 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  132708 */     GIR_RootConstrainSelectedInstOperands,
     /*  132709 */     // GIR_Coverage, 65440,
     /*  132709 */     GIR_EraseRootFromParent_Done,
     /*  132710 */   // Label 2325: @132710
     /*  132710 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(132775), // Rule ID 2531 //
     /*  132715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132738 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  132742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132758 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  132768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  132773 */     GIR_RootConstrainSelectedInstOperands,
     /*  132774 */     // GIR_Coverage, 2531,
     /*  132774 */     GIR_EraseRootFromParent_Done,
     /*  132775 */   // Label 2326: @132775
     /*  132775 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(132860), // Rule ID 65465 //
     /*  132780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  132783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  132791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  132795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132820 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132824 */     // MIs[1] Operand 2
     /*  132824 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  132835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  132844 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  132847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  132858 */     GIR_RootConstrainSelectedInstOperands,
     /*  132859 */     // GIR_Coverage, 65465,
     /*  132859 */     GIR_EraseRootFromParent_Done,
     /*  132860 */   // Label 2327: @132860
     /*  132860 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(132945), // Rule ID 2544 //
     /*  132865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  132868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  132880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132905 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132909 */     // MIs[1] Operand 2
     /*  132909 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  132920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  132929 */     // (or:{ *:[i64] } (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  132932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  132943 */     GIR_RootConstrainSelectedInstOperands,
     /*  132944 */     // GIR_Coverage, 2544,
     /*  132944 */     GIR_EraseRootFromParent_Done,
     /*  132945 */   // Label 2328: @132945
     /*  132945 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(133011), // Rule ID 65446 //
     /*  132950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  132961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132978 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  132982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11254),
     /*  132986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132995 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }))<<P:Predicate_anonymous_11254>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133009 */     GIR_RootConstrainSelectedInstOperands,
     /*  133010 */     // GIR_Coverage, 65446,
     /*  133010 */     GIR_EraseRootFromParent_Done,
     /*  133011 */   // Label 2329: @133011
     /*  133011 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(133077), // Rule ID 65464 //
     /*  133016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133044 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  133048 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10030),
     /*  133052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133061 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }))<<P:Predicate_anonymous_10030>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133075 */     GIR_RootConstrainSelectedInstOperands,
     /*  133076 */     // GIR_Coverage, 65464,
     /*  133076 */     GIR_EraseRootFromParent_Done,
     /*  133077 */   // Label 2330: @133077
     /*  133077 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(133143), // Rule ID 2537 //
     /*  133082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133110 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133114 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11254),
     /*  133118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133127 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_11254>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133141 */     GIR_RootConstrainSelectedInstOperands,
     /*  133142 */     // GIR_Coverage, 2537,
     /*  133142 */     GIR_EraseRootFromParent_Done,
     /*  133143 */   // Label 2331: @133143
     /*  133143 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(133209), // Rule ID 2543 //
     /*  133148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133176 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  133180 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10030),
     /*  133184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133193 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_10030>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133207 */     GIR_RootConstrainSelectedInstOperands,
     /*  133208 */     // GIR_Coverage, 2543,
     /*  133208 */     GIR_EraseRootFromParent_Done,
     /*  133209 */   // Label 2332: @133209
     /*  133209 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(133271), // Rule ID 2542 //
     /*  133214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133242 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  133246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  133255 */     // (or:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  133258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133269 */     GIR_RootConstrainSelectedInstOperands,
     /*  133270 */     // GIR_Coverage, 2542,
     /*  133270 */     GIR_EraseRootFromParent_Done,
     /*  133271 */   // Label 2333: @133271
     /*  133271 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(133333), // Rule ID 65463 //
     /*  133276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133304 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  133308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  133317 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }), (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  133320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133331 */     GIR_RootConstrainSelectedInstOperands,
     /*  133332 */     // GIR_Coverage, 65463,
     /*  133332 */     GIR_EraseRootFromParent_Done,
     /*  133333 */   // Label 2334: @133333
     /*  133333 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(133392), // Rule ID 2464 //
     /*  133338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  133341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133361 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  133365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  133378 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  133381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133390 */     GIR_RootConstrainSelectedInstOperands,
     /*  133391 */     // GIR_Coverage, 2464,
     /*  133391 */     GIR_EraseRootFromParent_Done,
     /*  133392 */   // Label 2335: @133392
     /*  133392 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(133451), // Rule ID 65434 //
     /*  133397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  133400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  133428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  133437 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  133440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133449 */     GIR_RootConstrainSelectedInstOperands,
     /*  133450 */     // GIR_Coverage, 65434,
     /*  133450 */     GIR_EraseRootFromParent_Done,
     /*  133451 */   // Label 2336: @133451
     /*  133451 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133507), // Rule ID 65418 //
     /*  133456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  133459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133484 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  133488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133494 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  133497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133505 */     GIR_RootConstrainSelectedInstOperands,
     /*  133506 */     // GIR_Coverage, 65418,
     /*  133506 */     GIR_EraseRootFromParent_Done,
     /*  133507 */   // Label 2337: @133507
     /*  133507 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133563), // Rule ID 2438 //
     /*  133512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  133515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133544 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  133548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133550 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  133553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133561 */     GIR_RootConstrainSelectedInstOperands,
     /*  133562 */     // GIR_Coverage, 2438,
     /*  133562 */     GIR_EraseRootFromParent_Done,
     /*  133563 */   // Label 2338: @133563
     /*  133563 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133605), // Rule ID 80 //
     /*  133568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  133571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  133591 */     // MIs[1] Operand 1
     /*  133591 */     // No operand predicates
     /*  133591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133593 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  133593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  133596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  133603 */     GIR_RootConstrainSelectedInstOperands,
     /*  133604 */     // GIR_Coverage, 80,
     /*  133604 */     GIR_EraseRootFromParent_Done,
     /*  133605 */   // Label 2339: @133605
     /*  133605 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133632), // Rule ID 78 //
     /*  133610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  133613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133625 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (OR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  133630 */     GIR_RootConstrainSelectedInstOperands,
     /*  133631 */     // GIR_Coverage, 78,
     /*  133631 */     GIR_Done,
     /*  133632 */   // Label 2340: @133632
     /*  133632 */   GIM_Reject,
     /*  133633 */ // Label 2312: @133633
     /*  133633 */ GIM_Reject,
     /*  133634 */ // Label 2255: @133634
     /*  133634 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(134244),
     /*  133639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  133642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  133645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133649 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(133715), // Rule ID 71648 //
     /*  133654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  133669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  133673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133696 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  133696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  133699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  133707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133713 */     GIR_RootConstrainSelectedInstOperands,
     /*  133714 */     // GIR_Coverage, 71648,
     /*  133714 */     GIR_EraseRootFromParent_Done,
     /*  133715 */   // Label 2342: @133715
     /*  133715 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(133781), // Rule ID 71649 //
     /*  133720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  133735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  133739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  133751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133762 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  133762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  133765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  133773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133779 */     GIR_RootConstrainSelectedInstOperands,
     /*  133780 */     // GIR_Coverage, 71649,
     /*  133780 */     GIR_EraseRootFromParent_Done,
     /*  133781 */   // Label 2343: @133781
     /*  133781 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(133847), // Rule ID 71646 //
     /*  133786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  133801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  133805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  133814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133828 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  133828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  133831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133845 */     GIR_RootConstrainSelectedInstOperands,
     /*  133846 */     // GIR_Coverage, 71646,
     /*  133846 */     GIR_EraseRootFromParent_Done,
     /*  133847 */   // Label 2344: @133847
     /*  133847 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(133913), // Rule ID 71647 //
     /*  133852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  133867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  133871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  133880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  133888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133894 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  133894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  133897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133911 */     GIR_RootConstrainSelectedInstOperands,
     /*  133912 */     // GIR_Coverage, 71647,
     /*  133912 */     GIR_EraseRootFromParent_Done,
     /*  133913 */   // Label 2345: @133913
     /*  133913 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(133979), // Rule ID 71644 //
     /*  133918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  133937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  133941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133960 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  133960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  133963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  133971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133977 */     GIR_RootConstrainSelectedInstOperands,
     /*  133978 */     // GIR_Coverage, 71644,
     /*  133978 */     GIR_EraseRootFromParent_Done,
     /*  133979 */   // Label 2346: @133979
     /*  133979 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(134045), // Rule ID 71645 //
     /*  133984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134026 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134043 */     GIR_RootConstrainSelectedInstOperands,
     /*  134044 */     // GIR_Coverage, 71645,
     /*  134044 */     GIR_EraseRootFromParent_Done,
     /*  134045 */   // Label 2347: @134045
     /*  134045 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(134111), // Rule ID 53166 //
     /*  134050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134092 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134109 */     GIR_RootConstrainSelectedInstOperands,
     /*  134110 */     // GIR_Coverage, 53166,
     /*  134110 */     GIR_EraseRootFromParent_Done,
     /*  134111 */   // Label 2348: @134111
     /*  134111 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(134177), // Rule ID 53167 //
     /*  134116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134158 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134175 */     GIR_RootConstrainSelectedInstOperands,
     /*  134176 */     // GIR_Coverage, 53167,
     /*  134176 */     GIR_EraseRootFromParent_Done,
     /*  134177 */   // Label 2349: @134177
     /*  134177 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134210), // Rule ID 53154 //
     /*  134182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134193 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  134196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134208 */     GIR_RootConstrainSelectedInstOperands,
     /*  134209 */     // GIR_Coverage, 53154,
     /*  134209 */     GIR_EraseRootFromParent_Done,
     /*  134210 */   // Label 2350: @134210
     /*  134210 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134243), // Rule ID 53155 //
     /*  134215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134226 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  134229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134241 */     GIR_RootConstrainSelectedInstOperands,
     /*  134242 */     // GIR_Coverage, 53155,
     /*  134242 */     GIR_EraseRootFromParent_Done,
     /*  134243 */   // Label 2351: @134243
     /*  134243 */   GIM_Reject,
     /*  134244 */ // Label 2341: @134244
     /*  134244 */ GIM_Reject,
     /*  134245 */ // Label 2256: @134245
     /*  134245 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(134359),
     /*  134250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  134253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  134256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134268 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(134313), // Rule ID 47776 //
     /*  134273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134276 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  134276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  134279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  134293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134311 */     GIR_RootConstrainSelectedInstOperands,
     /*  134312 */     // GIR_Coverage, 47776,
     /*  134312 */     GIR_EraseRootFromParent_Done,
     /*  134313 */   // Label 2353: @134313
     /*  134313 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(134358), // Rule ID 47777 //
     /*  134318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134321 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  134321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  134324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  134338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134356 */     GIR_RootConstrainSelectedInstOperands,
     /*  134357 */     // GIR_Coverage, 47777,
     /*  134357 */     GIR_EraseRootFromParent_Done,
     /*  134358 */   // Label 2354: @134358
     /*  134358 */   GIM_Reject,
     /*  134359 */ // Label 2352: @134359
     /*  134359 */ GIM_Reject,
     /*  134360 */ // Label 2257: @134360
     /*  134360 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(134474),
     /*  134365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  134368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  134371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134383 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(134428), // Rule ID 47788 //
     /*  134388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134391 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  134391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  134394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  134408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  134423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134426 */     GIR_RootConstrainSelectedInstOperands,
     /*  134427 */     // GIR_Coverage, 47788,
     /*  134427 */     GIR_EraseRootFromParent_Done,
     /*  134428 */   // Label 2356: @134428
     /*  134428 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(134473), // Rule ID 47789 //
     /*  134433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134436 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  134436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  134439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  134453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  134468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134471 */     GIR_RootConstrainSelectedInstOperands,
     /*  134472 */     // GIR_Coverage, 47789,
     /*  134472 */     GIR_EraseRootFromParent_Done,
     /*  134473 */   // Label 2357: @134473
     /*  134473 */   GIM_Reject,
     /*  134474 */ // Label 2355: @134474
     /*  134474 */ GIM_Reject,
     /*  134475 */ // Label 2258: @134475
     /*  134475 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(134589),
     /*  134480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  134483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  134486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134498 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(134543), // Rule ID 47796 //
     /*  134503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134506 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  134506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  134509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  134523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  134538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134541 */     GIR_RootConstrainSelectedInstOperands,
     /*  134542 */     // GIR_Coverage, 47796,
     /*  134542 */     GIR_EraseRootFromParent_Done,
     /*  134543 */   // Label 2359: @134543
     /*  134543 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(134588), // Rule ID 47797 //
     /*  134548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134551 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  134551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  134554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  134568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  134583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134586 */     GIR_RootConstrainSelectedInstOperands,
     /*  134587 */     // GIR_Coverage, 47797,
     /*  134587 */     GIR_EraseRootFromParent_Done,
     /*  134588 */   // Label 2360: @134588
     /*  134588 */   GIM_Reject,
     /*  134589 */ // Label 2358: @134589
     /*  134589 */ GIM_Reject,
     /*  134590 */ // Label 2259: @134590
     /*  134590 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(134704),
     /*  134595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  134598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  134601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134613 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(134658), // Rule ID 47812 //
     /*  134618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  134621 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  134621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  134624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  134638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  134653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134656 */     GIR_RootConstrainSelectedInstOperands,
     /*  134657 */     // GIR_Coverage, 47812,
     /*  134657 */     GIR_EraseRootFromParent_Done,
     /*  134658 */   // Label 2362: @134658
     /*  134658 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(134703), // Rule ID 47813 //
     /*  134663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  134666 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  134666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  134669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  134683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  134698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134701 */     GIR_RootConstrainSelectedInstOperands,
     /*  134702 */     // GIR_Coverage, 47813,
     /*  134702 */     GIR_EraseRootFromParent_Done,
     /*  134703 */   // Label 2363: @134703
     /*  134703 */   GIM_Reject,
     /*  134704 */ // Label 2361: @134704
     /*  134704 */ GIM_Reject,
     /*  134705 */ // Label 2260: @134705
     /*  134705 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(135315),
     /*  134710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  134713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  134716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134720 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(134786), // Rule ID 71676 //
     /*  134725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  134740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  134744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134767 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  134770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134784 */     GIR_RootConstrainSelectedInstOperands,
     /*  134785 */     // GIR_Coverage, 71676,
     /*  134785 */     GIR_EraseRootFromParent_Done,
     /*  134786 */   // Label 2365: @134786
     /*  134786 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(134852), // Rule ID 71677 //
     /*  134791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  134806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  134810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134833 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  134836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134850 */     GIR_RootConstrainSelectedInstOperands,
     /*  134851 */     // GIR_Coverage, 71677,
     /*  134851 */     GIR_EraseRootFromParent_Done,
     /*  134852 */   // Label 2366: @134852
     /*  134852 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(134918), // Rule ID 71674 //
     /*  134857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  134872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  134876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134899 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  134902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134916 */     GIR_RootConstrainSelectedInstOperands,
     /*  134917 */     // GIR_Coverage, 71674,
     /*  134917 */     GIR_EraseRootFromParent_Done,
     /*  134918 */   // Label 2367: @134918
     /*  134918 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(134984), // Rule ID 71675 //
     /*  134923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  134938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  134942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134965 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  134968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134982 */     GIR_RootConstrainSelectedInstOperands,
     /*  134983 */     // GIR_Coverage, 71675,
     /*  134983 */     GIR_EraseRootFromParent_Done,
     /*  134984 */   // Label 2368: @134984
     /*  134984 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(135050), // Rule ID 71672 //
     /*  134989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135031 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135048 */     GIR_RootConstrainSelectedInstOperands,
     /*  135049 */     // GIR_Coverage, 71672,
     /*  135049 */     GIR_EraseRootFromParent_Done,
     /*  135050 */   // Label 2369: @135050
     /*  135050 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(135116), // Rule ID 71673 //
     /*  135055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135097 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135114 */     GIR_RootConstrainSelectedInstOperands,
     /*  135115 */     // GIR_Coverage, 71673,
     /*  135115 */     GIR_EraseRootFromParent_Done,
     /*  135116 */   // Label 2370: @135116
     /*  135116 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(135182), // Rule ID 53184 //
     /*  135121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135163 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135180 */     GIR_RootConstrainSelectedInstOperands,
     /*  135181 */     // GIR_Coverage, 53184,
     /*  135181 */     GIR_EraseRootFromParent_Done,
     /*  135182 */   // Label 2371: @135182
     /*  135182 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(135248), // Rule ID 53185 //
     /*  135187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135229 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135246 */     GIR_RootConstrainSelectedInstOperands,
     /*  135247 */     // GIR_Coverage, 53185,
     /*  135247 */     GIR_EraseRootFromParent_Done,
     /*  135248 */   // Label 2372: @135248
     /*  135248 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(135281), // Rule ID 53172 //
     /*  135253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135264 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  135267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135279 */     GIR_RootConstrainSelectedInstOperands,
     /*  135280 */     // GIR_Coverage, 53172,
     /*  135280 */     GIR_EraseRootFromParent_Done,
     /*  135281 */   // Label 2373: @135281
     /*  135281 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(135314), // Rule ID 53173 //
     /*  135286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135297 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  135300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135312 */     GIR_RootConstrainSelectedInstOperands,
     /*  135313 */     // GIR_Coverage, 53173,
     /*  135313 */     GIR_EraseRootFromParent_Done,
     /*  135314 */   // Label 2374: @135314
     /*  135314 */   GIM_Reject,
     /*  135315 */ // Label 2364: @135315
     /*  135315 */ GIM_Reject,
     /*  135316 */ // Label 2261: @135316
     /*  135316 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(135430),
     /*  135321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  135324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  135327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135339 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(135384), // Rule ID 47780 //
     /*  135344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135347 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  135347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  135350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  135364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135382 */     GIR_RootConstrainSelectedInstOperands,
     /*  135383 */     // GIR_Coverage, 47780,
     /*  135383 */     GIR_EraseRootFromParent_Done,
     /*  135384 */   // Label 2376: @135384
     /*  135384 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(135429), // Rule ID 47781 //
     /*  135389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135392 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  135392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  135395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  135409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135427 */     GIR_RootConstrainSelectedInstOperands,
     /*  135428 */     // GIR_Coverage, 47781,
     /*  135428 */     GIR_EraseRootFromParent_Done,
     /*  135429 */   // Label 2377: @135429
     /*  135429 */   GIM_Reject,
     /*  135430 */ // Label 2375: @135430
     /*  135430 */ GIM_Reject,
     /*  135431 */ // Label 2262: @135431
     /*  135431 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(135545),
     /*  135436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  135439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  135442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135454 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(135499), // Rule ID 47792 //
     /*  135459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135462 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  135462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  135465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  135479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135497 */     GIR_RootConstrainSelectedInstOperands,
     /*  135498 */     // GIR_Coverage, 47792,
     /*  135498 */     GIR_EraseRootFromParent_Done,
     /*  135499 */   // Label 2379: @135499
     /*  135499 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(135544), // Rule ID 47793 //
     /*  135504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135507 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  135507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  135510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  135524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135542 */     GIR_RootConstrainSelectedInstOperands,
     /*  135543 */     // GIR_Coverage, 47793,
     /*  135543 */     GIR_EraseRootFromParent_Done,
     /*  135544 */   // Label 2380: @135544
     /*  135544 */   GIM_Reject,
     /*  135545 */ // Label 2378: @135545
     /*  135545 */ GIM_Reject,
     /*  135546 */ // Label 2263: @135546
     /*  135546 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(135660),
     /*  135551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  135554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  135557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135569 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(135614), // Rule ID 47808 //
     /*  135574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135577 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  135577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  135580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  135594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135612 */     GIR_RootConstrainSelectedInstOperands,
     /*  135613 */     // GIR_Coverage, 47808,
     /*  135613 */     GIR_EraseRootFromParent_Done,
     /*  135614 */   // Label 2382: @135614
     /*  135614 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(135659), // Rule ID 47809 //
     /*  135619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135622 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  135622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  135625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  135639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135657 */     GIR_RootConstrainSelectedInstOperands,
     /*  135658 */     // GIR_Coverage, 47809,
     /*  135658 */     GIR_EraseRootFromParent_Done,
     /*  135659 */   // Label 2383: @135659
     /*  135659 */   GIM_Reject,
     /*  135660 */ // Label 2381: @135660
     /*  135660 */ GIM_Reject,
     /*  135661 */ // Label 2264: @135661
     /*  135661 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(135775),
     /*  135666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  135669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  135672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  135676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  135680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  135684 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(135729), // Rule ID 47852 //
     /*  135689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  135692 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  135692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  135695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  135709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135727 */     GIR_RootConstrainSelectedInstOperands,
     /*  135728 */     // GIR_Coverage, 47852,
     /*  135728 */     GIR_EraseRootFromParent_Done,
     /*  135729 */   // Label 2385: @135729
     /*  135729 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(135774), // Rule ID 47853 //
     /*  135734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  135737 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  135737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  135740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  135754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135772 */     GIR_RootConstrainSelectedInstOperands,
     /*  135773 */     // GIR_Coverage, 47853,
     /*  135773 */     GIR_EraseRootFromParent_Done,
     /*  135774 */   // Label 2386: @135774
     /*  135774 */   GIM_Reject,
     /*  135775 */ // Label 2384: @135775
     /*  135775 */ GIM_Reject,
     /*  135776 */ // Label 2265: @135776
     /*  135776 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(136386),
     /*  135781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  135784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  135787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135791 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(135857), // Rule ID 71704 //
     /*  135796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  135811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  135815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135838 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  135841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135855 */     GIR_RootConstrainSelectedInstOperands,
     /*  135856 */     // GIR_Coverage, 71704,
     /*  135856 */     GIR_EraseRootFromParent_Done,
     /*  135857 */   // Label 2388: @135857
     /*  135857 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(135923), // Rule ID 71705 //
     /*  135862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  135877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  135881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135904 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  135907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135921 */     GIR_RootConstrainSelectedInstOperands,
     /*  135922 */     // GIR_Coverage, 71705,
     /*  135922 */     GIR_EraseRootFromParent_Done,
     /*  135923 */   // Label 2389: @135923
     /*  135923 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(135989), // Rule ID 71702 //
     /*  135928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  135943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  135947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135970 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  135973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135987 */     GIR_RootConstrainSelectedInstOperands,
     /*  135988 */     // GIR_Coverage, 71702,
     /*  135988 */     GIR_EraseRootFromParent_Done,
     /*  135989 */   // Label 2390: @135989
     /*  135989 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(136055), // Rule ID 71703 //
     /*  135994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136036 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136053 */     GIR_RootConstrainSelectedInstOperands,
     /*  136054 */     // GIR_Coverage, 71703,
     /*  136054 */     GIR_EraseRootFromParent_Done,
     /*  136055 */   // Label 2391: @136055
     /*  136055 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(136121), // Rule ID 71700 //
     /*  136060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136102 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136119 */     GIR_RootConstrainSelectedInstOperands,
     /*  136120 */     // GIR_Coverage, 71700,
     /*  136120 */     GIR_EraseRootFromParent_Done,
     /*  136121 */   // Label 2392: @136121
     /*  136121 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(136187), // Rule ID 71701 //
     /*  136126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136168 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136185 */     GIR_RootConstrainSelectedInstOperands,
     /*  136186 */     // GIR_Coverage, 71701,
     /*  136186 */     GIR_EraseRootFromParent_Done,
     /*  136187 */   // Label 2393: @136187
     /*  136187 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(136253), // Rule ID 53202 //
     /*  136192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136234 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136251 */     GIR_RootConstrainSelectedInstOperands,
     /*  136252 */     // GIR_Coverage, 53202,
     /*  136252 */     GIR_EraseRootFromParent_Done,
     /*  136253 */   // Label 2394: @136253
     /*  136253 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(136319), // Rule ID 53203 //
     /*  136258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136300 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136317 */     GIR_RootConstrainSelectedInstOperands,
     /*  136318 */     // GIR_Coverage, 53203,
     /*  136318 */     GIR_EraseRootFromParent_Done,
     /*  136319 */   // Label 2395: @136319
     /*  136319 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(136352), // Rule ID 53190 //
     /*  136324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136335 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  136338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136350 */     GIR_RootConstrainSelectedInstOperands,
     /*  136351 */     // GIR_Coverage, 53190,
     /*  136351 */     GIR_EraseRootFromParent_Done,
     /*  136352 */   // Label 2396: @136352
     /*  136352 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(136385), // Rule ID 53191 //
     /*  136357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136368 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  136371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136383 */     GIR_RootConstrainSelectedInstOperands,
     /*  136384 */     // GIR_Coverage, 53191,
     /*  136384 */     GIR_EraseRootFromParent_Done,
     /*  136385 */   // Label 2397: @136385
     /*  136385 */   GIM_Reject,
     /*  136386 */ // Label 2387: @136386
     /*  136386 */ GIM_Reject,
     /*  136387 */ // Label 2266: @136387
     /*  136387 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(136501),
     /*  136392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  136395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  136398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136410 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(136455), // Rule ID 47784 //
     /*  136415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136418 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  136418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  136421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136453 */     GIR_RootConstrainSelectedInstOperands,
     /*  136454 */     // GIR_Coverage, 47784,
     /*  136454 */     GIR_EraseRootFromParent_Done,
     /*  136455 */   // Label 2399: @136455
     /*  136455 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(136500), // Rule ID 47785 //
     /*  136460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136463 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  136463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  136466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136498 */     GIR_RootConstrainSelectedInstOperands,
     /*  136499 */     // GIR_Coverage, 47785,
     /*  136499 */     GIR_EraseRootFromParent_Done,
     /*  136500 */   // Label 2400: @136500
     /*  136500 */   GIM_Reject,
     /*  136501 */ // Label 2398: @136501
     /*  136501 */ GIM_Reject,
     /*  136502 */ // Label 2267: @136502
     /*  136502 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(136616),
     /*  136507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  136510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  136513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136525 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(136570), // Rule ID 47804 //
     /*  136530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136533 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  136533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  136536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  136550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  136565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136568 */     GIR_RootConstrainSelectedInstOperands,
     /*  136569 */     // GIR_Coverage, 47804,
     /*  136569 */     GIR_EraseRootFromParent_Done,
     /*  136570 */   // Label 2402: @136570
     /*  136570 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(136615), // Rule ID 47805 //
     /*  136575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136578 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  136578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  136581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  136595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  136610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136613 */     GIR_RootConstrainSelectedInstOperands,
     /*  136614 */     // GIR_Coverage, 47805,
     /*  136614 */     GIR_EraseRootFromParent_Done,
     /*  136615 */   // Label 2403: @136615
     /*  136615 */   GIM_Reject,
     /*  136616 */ // Label 2401: @136616
     /*  136616 */ GIM_Reject,
     /*  136617 */ // Label 2268: @136617
     /*  136617 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(136731),
     /*  136622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  136625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  136628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136640 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(136685), // Rule ID 47840 //
     /*  136645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136648 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  136648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  136651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  136665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136683 */     GIR_RootConstrainSelectedInstOperands,
     /*  136684 */     // GIR_Coverage, 47840,
     /*  136684 */     GIR_EraseRootFromParent_Done,
     /*  136685 */   // Label 2405: @136685
     /*  136685 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(136730), // Rule ID 47841 //
     /*  136690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136693 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  136693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  136696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  136710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136728 */     GIR_RootConstrainSelectedInstOperands,
     /*  136729 */     // GIR_Coverage, 47841,
     /*  136729 */     GIR_EraseRootFromParent_Done,
     /*  136730 */   // Label 2406: @136730
     /*  136730 */   GIM_Reject,
     /*  136731 */ // Label 2404: @136731
     /*  136731 */ GIM_Reject,
     /*  136732 */ // Label 2269: @136732
     /*  136732 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(136846),
     /*  136737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  136740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  136743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  136747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  136751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  136755 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(136800), // Rule ID 47856 //
     /*  136760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  136763 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  136763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  136766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  136780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136798 */     GIR_RootConstrainSelectedInstOperands,
     /*  136799 */     // GIR_Coverage, 47856,
     /*  136799 */     GIR_EraseRootFromParent_Done,
     /*  136800 */   // Label 2408: @136800
     /*  136800 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(136845), // Rule ID 47857 //
     /*  136805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  136808 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  136808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  136811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  136825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136843 */     GIR_RootConstrainSelectedInstOperands,
     /*  136844 */     // GIR_Coverage, 47857,
     /*  136844 */     GIR_EraseRootFromParent_Done,
     /*  136845 */   // Label 2409: @136845
     /*  136845 */   GIM_Reject,
     /*  136846 */ // Label 2407: @136846
     /*  136846 */ GIM_Reject,
     /*  136847 */ // Label 2270: @136847
     /*  136847 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(137457),
     /*  136852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  136855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  136858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136862 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(136928), // Rule ID 71732 //
     /*  136867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  136882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  136886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136909 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  136912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136926 */     GIR_RootConstrainSelectedInstOperands,
     /*  136927 */     // GIR_Coverage, 71732,
     /*  136927 */     GIR_EraseRootFromParent_Done,
     /*  136928 */   // Label 2411: @136928
     /*  136928 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(136994), // Rule ID 71733 //
     /*  136933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  136948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  136952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136975 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  136978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136992 */     GIR_RootConstrainSelectedInstOperands,
     /*  136993 */     // GIR_Coverage, 71733,
     /*  136993 */     GIR_EraseRootFromParent_Done,
     /*  136994 */   // Label 2412: @136994
     /*  136994 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(137060), // Rule ID 71730 //
     /*  136999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137041 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137058 */     GIR_RootConstrainSelectedInstOperands,
     /*  137059 */     // GIR_Coverage, 71730,
     /*  137059 */     GIR_EraseRootFromParent_Done,
     /*  137060 */   // Label 2413: @137060
     /*  137060 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(137126), // Rule ID 71731 //
     /*  137065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137107 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137124 */     GIR_RootConstrainSelectedInstOperands,
     /*  137125 */     // GIR_Coverage, 71731,
     /*  137125 */     GIR_EraseRootFromParent_Done,
     /*  137126 */   // Label 2414: @137126
     /*  137126 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(137192), // Rule ID 71728 //
     /*  137131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137173 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137190 */     GIR_RootConstrainSelectedInstOperands,
     /*  137191 */     // GIR_Coverage, 71728,
     /*  137191 */     GIR_EraseRootFromParent_Done,
     /*  137192 */   // Label 2415: @137192
     /*  137192 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(137258), // Rule ID 71729 //
     /*  137197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137239 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137256 */     GIR_RootConstrainSelectedInstOperands,
     /*  137257 */     // GIR_Coverage, 71729,
     /*  137257 */     GIR_EraseRootFromParent_Done,
     /*  137258 */   // Label 2416: @137258
     /*  137258 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(137324), // Rule ID 53220 //
     /*  137263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137305 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137322 */     GIR_RootConstrainSelectedInstOperands,
     /*  137323 */     // GIR_Coverage, 53220,
     /*  137323 */     GIR_EraseRootFromParent_Done,
     /*  137324 */   // Label 2417: @137324
     /*  137324 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(137390), // Rule ID 53221 //
     /*  137329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137371 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137388 */     GIR_RootConstrainSelectedInstOperands,
     /*  137389 */     // GIR_Coverage, 53221,
     /*  137389 */     GIR_EraseRootFromParent_Done,
     /*  137390 */   // Label 2418: @137390
     /*  137390 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(137423), // Rule ID 53208 //
     /*  137395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137406 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  137409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137421 */     GIR_RootConstrainSelectedInstOperands,
     /*  137422 */     // GIR_Coverage, 53208,
     /*  137422 */     GIR_EraseRootFromParent_Done,
     /*  137423 */   // Label 2419: @137423
     /*  137423 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(137456), // Rule ID 53209 //
     /*  137428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137439 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  137442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137454 */     GIR_RootConstrainSelectedInstOperands,
     /*  137455 */     // GIR_Coverage, 53209,
     /*  137455 */     GIR_EraseRootFromParent_Done,
     /*  137456 */   // Label 2420: @137456
     /*  137456 */   GIM_Reject,
     /*  137457 */ // Label 2410: @137457
     /*  137457 */ GIM_Reject,
     /*  137458 */ // Label 2271: @137458
     /*  137458 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(137572),
     /*  137463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  137466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  137469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137481 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(137526), // Rule ID 47800 //
     /*  137486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137489 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  137489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  137492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137524 */     GIR_RootConstrainSelectedInstOperands,
     /*  137525 */     // GIR_Coverage, 47800,
     /*  137525 */     GIR_EraseRootFromParent_Done,
     /*  137526 */   // Label 2422: @137526
     /*  137526 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(137571), // Rule ID 47801 //
     /*  137531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137534 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  137534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  137537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137569 */     GIR_RootConstrainSelectedInstOperands,
     /*  137570 */     // GIR_Coverage, 47801,
     /*  137570 */     GIR_EraseRootFromParent_Done,
     /*  137571 */   // Label 2423: @137571
     /*  137571 */   GIM_Reject,
     /*  137572 */ // Label 2421: @137572
     /*  137572 */ GIM_Reject,
     /*  137573 */ // Label 2272: @137573
     /*  137573 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(137687),
     /*  137578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  137581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  137584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137596 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(137641), // Rule ID 47828 //
     /*  137601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137604 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  137604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  137607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  137621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137639 */     GIR_RootConstrainSelectedInstOperands,
     /*  137640 */     // GIR_Coverage, 47828,
     /*  137640 */     GIR_EraseRootFromParent_Done,
     /*  137641 */   // Label 2425: @137641
     /*  137641 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(137686), // Rule ID 47829 //
     /*  137646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137649 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  137649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  137652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  137666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137684 */     GIR_RootConstrainSelectedInstOperands,
     /*  137685 */     // GIR_Coverage, 47829,
     /*  137685 */     GIR_EraseRootFromParent_Done,
     /*  137686 */   // Label 2426: @137686
     /*  137686 */   GIM_Reject,
     /*  137687 */ // Label 2424: @137687
     /*  137687 */ GIM_Reject,
     /*  137688 */ // Label 2273: @137688
     /*  137688 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(137802),
     /*  137693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  137696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  137699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137711 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(137756), // Rule ID 47844 //
     /*  137716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137719 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  137719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  137722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  137736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137754 */     GIR_RootConstrainSelectedInstOperands,
     /*  137755 */     // GIR_Coverage, 47844,
     /*  137755 */     GIR_EraseRootFromParent_Done,
     /*  137756 */   // Label 2428: @137756
     /*  137756 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(137801), // Rule ID 47845 //
     /*  137761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137764 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  137764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  137767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  137781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137799 */     GIR_RootConstrainSelectedInstOperands,
     /*  137800 */     // GIR_Coverage, 47845,
     /*  137800 */     GIR_EraseRootFromParent_Done,
     /*  137801 */   // Label 2429: @137801
     /*  137801 */   GIM_Reject,
     /*  137802 */ // Label 2427: @137802
     /*  137802 */ GIM_Reject,
     /*  137803 */ // Label 2274: @137803
     /*  137803 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(137917),
     /*  137808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  137811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  137814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  137818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  137822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  137826 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(137871), // Rule ID 47860 //
     /*  137831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  137834 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  137834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  137837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  137851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  137866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137869 */     GIR_RootConstrainSelectedInstOperands,
     /*  137870 */     // GIR_Coverage, 47860,
     /*  137870 */     GIR_EraseRootFromParent_Done,
     /*  137871 */   // Label 2431: @137871
     /*  137871 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(137916), // Rule ID 47861 //
     /*  137876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  137879 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  137879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  137882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  137896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  137911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137914 */     GIR_RootConstrainSelectedInstOperands,
     /*  137915 */     // GIR_Coverage, 47861,
     /*  137915 */     GIR_EraseRootFromParent_Done,
     /*  137916 */   // Label 2432: @137916
     /*  137916 */   GIM_Reject,
     /*  137917 */ // Label 2430: @137917
     /*  137917 */ GIM_Reject,
     /*  137918 */ // Label 2275: @137918
     /*  137918 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(138528),
     /*  137923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  137926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  137929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137933 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(137999), // Rule ID 71760 //
     /*  137938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  137953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  137957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137980 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  137983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137997 */     GIR_RootConstrainSelectedInstOperands,
     /*  137998 */     // GIR_Coverage, 71760,
     /*  137998 */     GIR_EraseRootFromParent_Done,
     /*  137999 */   // Label 2434: @137999
     /*  137999 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(138065), // Rule ID 71761 //
     /*  138004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138046 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138063 */     GIR_RootConstrainSelectedInstOperands,
     /*  138064 */     // GIR_Coverage, 71761,
     /*  138064 */     GIR_EraseRootFromParent_Done,
     /*  138065 */   // Label 2435: @138065
     /*  138065 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(138131), // Rule ID 71758 //
     /*  138070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138112 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138129 */     GIR_RootConstrainSelectedInstOperands,
     /*  138130 */     // GIR_Coverage, 71758,
     /*  138130 */     GIR_EraseRootFromParent_Done,
     /*  138131 */   // Label 2436: @138131
     /*  138131 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(138197), // Rule ID 71759 //
     /*  138136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138178 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138195 */     GIR_RootConstrainSelectedInstOperands,
     /*  138196 */     // GIR_Coverage, 71759,
     /*  138196 */     GIR_EraseRootFromParent_Done,
     /*  138197 */   // Label 2437: @138197
     /*  138197 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(138263), // Rule ID 71756 //
     /*  138202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138244 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138261 */     GIR_RootConstrainSelectedInstOperands,
     /*  138262 */     // GIR_Coverage, 71756,
     /*  138262 */     GIR_EraseRootFromParent_Done,
     /*  138263 */   // Label 2438: @138263
     /*  138263 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(138329), // Rule ID 71757 //
     /*  138268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138310 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138327 */     GIR_RootConstrainSelectedInstOperands,
     /*  138328 */     // GIR_Coverage, 71757,
     /*  138328 */     GIR_EraseRootFromParent_Done,
     /*  138329 */   // Label 2439: @138329
     /*  138329 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(138395), // Rule ID 53238 //
     /*  138334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138376 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138393 */     GIR_RootConstrainSelectedInstOperands,
     /*  138394 */     // GIR_Coverage, 53238,
     /*  138394 */     GIR_EraseRootFromParent_Done,
     /*  138395 */   // Label 2440: @138395
     /*  138395 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(138461), // Rule ID 53239 //
     /*  138400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138442 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138459 */     GIR_RootConstrainSelectedInstOperands,
     /*  138460 */     // GIR_Coverage, 53239,
     /*  138460 */     GIR_EraseRootFromParent_Done,
     /*  138461 */   // Label 2441: @138461
     /*  138461 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(138494), // Rule ID 53226 //
     /*  138466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138477 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  138480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138492 */     GIR_RootConstrainSelectedInstOperands,
     /*  138493 */     // GIR_Coverage, 53226,
     /*  138493 */     GIR_EraseRootFromParent_Done,
     /*  138494 */   // Label 2442: @138494
     /*  138494 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(138527), // Rule ID 53227 //
     /*  138499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138510 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  138513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138525 */     GIR_RootConstrainSelectedInstOperands,
     /*  138526 */     // GIR_Coverage, 53227,
     /*  138526 */     GIR_EraseRootFromParent_Done,
     /*  138527 */   // Label 2443: @138527
     /*  138527 */   GIM_Reject,
     /*  138528 */ // Label 2433: @138528
     /*  138528 */ GIM_Reject,
     /*  138529 */ // Label 2276: @138529
     /*  138529 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(138643),
     /*  138534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  138537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  138540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138552 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(138597), // Rule ID 47816 //
     /*  138557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138560 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  138560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  138563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  138577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138595 */     GIR_RootConstrainSelectedInstOperands,
     /*  138596 */     // GIR_Coverage, 47816,
     /*  138596 */     GIR_EraseRootFromParent_Done,
     /*  138597 */   // Label 2445: @138597
     /*  138597 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(138642), // Rule ID 47817 //
     /*  138602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138605 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  138605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  138608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  138622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138640 */     GIR_RootConstrainSelectedInstOperands,
     /*  138641 */     // GIR_Coverage, 47817,
     /*  138641 */     GIR_EraseRootFromParent_Done,
     /*  138642 */   // Label 2446: @138642
     /*  138642 */   GIM_Reject,
     /*  138643 */ // Label 2444: @138643
     /*  138643 */ GIM_Reject,
     /*  138644 */ // Label 2277: @138644
     /*  138644 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(138758),
     /*  138649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  138652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  138655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138667 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(138712), // Rule ID 47832 //
     /*  138672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138675 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  138675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  138678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  138692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138710 */     GIR_RootConstrainSelectedInstOperands,
     /*  138711 */     // GIR_Coverage, 47832,
     /*  138711 */     GIR_EraseRootFromParent_Done,
     /*  138712 */   // Label 2448: @138712
     /*  138712 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(138757), // Rule ID 47833 //
     /*  138717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138720 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  138720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  138723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  138737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138755 */     GIR_RootConstrainSelectedInstOperands,
     /*  138756 */     // GIR_Coverage, 47833,
     /*  138756 */     GIR_EraseRootFromParent_Done,
     /*  138757 */   // Label 2449: @138757
     /*  138757 */   GIM_Reject,
     /*  138758 */ // Label 2447: @138758
     /*  138758 */ GIM_Reject,
     /*  138759 */ // Label 2278: @138759
     /*  138759 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(138873),
     /*  138764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  138767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  138770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138778 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138782 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(138827), // Rule ID 47848 //
     /*  138787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138790 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  138790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  138793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  138807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  138822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138825 */     GIR_RootConstrainSelectedInstOperands,
     /*  138826 */     // GIR_Coverage, 47848,
     /*  138826 */     GIR_EraseRootFromParent_Done,
     /*  138827 */   // Label 2451: @138827
     /*  138827 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(138872), // Rule ID 47849 //
     /*  138832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138835 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  138835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  138838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  138852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  138867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138870 */     GIR_RootConstrainSelectedInstOperands,
     /*  138871 */     // GIR_Coverage, 47849,
     /*  138871 */     GIR_EraseRootFromParent_Done,
     /*  138872 */   // Label 2452: @138872
     /*  138872 */   GIM_Reject,
     /*  138873 */ // Label 2450: @138873
     /*  138873 */ GIM_Reject,
     /*  138874 */ // Label 2279: @138874
     /*  138874 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(139484),
     /*  138879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  138882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  138885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138889 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(138955), // Rule ID 71788 //
     /*  138894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  138909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  138913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138936 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  138939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138953 */     GIR_RootConstrainSelectedInstOperands,
     /*  138954 */     // GIR_Coverage, 71788,
     /*  138954 */     GIR_EraseRootFromParent_Done,
     /*  138955 */   // Label 2454: @138955
     /*  138955 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(139021), // Rule ID 71789 //
     /*  138960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  138975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  138979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139002 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139019 */     GIR_RootConstrainSelectedInstOperands,
     /*  139020 */     // GIR_Coverage, 71789,
     /*  139020 */     GIR_EraseRootFromParent_Done,
     /*  139021 */   // Label 2455: @139021
     /*  139021 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(139087), // Rule ID 71786 //
     /*  139026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139068 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139085 */     GIR_RootConstrainSelectedInstOperands,
     /*  139086 */     // GIR_Coverage, 71786,
     /*  139086 */     GIR_EraseRootFromParent_Done,
     /*  139087 */   // Label 2456: @139087
     /*  139087 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(139153), // Rule ID 71787 //
     /*  139092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139134 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139151 */     GIR_RootConstrainSelectedInstOperands,
     /*  139152 */     // GIR_Coverage, 71787,
     /*  139152 */     GIR_EraseRootFromParent_Done,
     /*  139153 */   // Label 2457: @139153
     /*  139153 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(139219), // Rule ID 71784 //
     /*  139158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139200 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139217 */     GIR_RootConstrainSelectedInstOperands,
     /*  139218 */     // GIR_Coverage, 71784,
     /*  139218 */     GIR_EraseRootFromParent_Done,
     /*  139219 */   // Label 2458: @139219
     /*  139219 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(139285), // Rule ID 71785 //
     /*  139224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139266 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139283 */     GIR_RootConstrainSelectedInstOperands,
     /*  139284 */     // GIR_Coverage, 71785,
     /*  139284 */     GIR_EraseRootFromParent_Done,
     /*  139285 */   // Label 2459: @139285
     /*  139285 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(139351), // Rule ID 53256 //
     /*  139290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139332 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139349 */     GIR_RootConstrainSelectedInstOperands,
     /*  139350 */     // GIR_Coverage, 53256,
     /*  139350 */     GIR_EraseRootFromParent_Done,
     /*  139351 */   // Label 2460: @139351
     /*  139351 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(139417), // Rule ID 53257 //
     /*  139356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139398 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139415 */     GIR_RootConstrainSelectedInstOperands,
     /*  139416 */     // GIR_Coverage, 53257,
     /*  139416 */     GIR_EraseRootFromParent_Done,
     /*  139417 */   // Label 2461: @139417
     /*  139417 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(139450), // Rule ID 53244 //
     /*  139422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139433 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  139436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139448 */     GIR_RootConstrainSelectedInstOperands,
     /*  139449 */     // GIR_Coverage, 53244,
     /*  139449 */     GIR_EraseRootFromParent_Done,
     /*  139450 */   // Label 2462: @139450
     /*  139450 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(139483), // Rule ID 53245 //
     /*  139455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139466 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  139469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139481 */     GIR_RootConstrainSelectedInstOperands,
     /*  139482 */     // GIR_Coverage, 53245,
     /*  139482 */     GIR_EraseRootFromParent_Done,
     /*  139483 */   // Label 2463: @139483
     /*  139483 */   GIM_Reject,
     /*  139484 */ // Label 2453: @139484
     /*  139484 */ GIM_Reject,
     /*  139485 */ // Label 2280: @139485
     /*  139485 */ GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(139599),
     /*  139490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  139493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  139496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139508 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(139553), // Rule ID 47820 //
     /*  139513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139516 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  139516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  139519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  139533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139551 */     GIR_RootConstrainSelectedInstOperands,
     /*  139552 */     // GIR_Coverage, 47820,
     /*  139552 */     GIR_EraseRootFromParent_Done,
     /*  139553 */   // Label 2465: @139553
     /*  139553 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(139598), // Rule ID 47821 //
     /*  139558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139561 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  139561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  139564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  139578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139596 */     GIR_RootConstrainSelectedInstOperands,
     /*  139597 */     // GIR_Coverage, 47821,
     /*  139597 */     GIR_EraseRootFromParent_Done,
     /*  139598 */   // Label 2466: @139598
     /*  139598 */   GIM_Reject,
     /*  139599 */ // Label 2464: @139599
     /*  139599 */ GIM_Reject,
     /*  139600 */ // Label 2281: @139600
     /*  139600 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(139714),
     /*  139605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  139608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  139611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139623 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(139668), // Rule ID 47836 //
     /*  139628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139631 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  139631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  139634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  139648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139666 */     GIR_RootConstrainSelectedInstOperands,
     /*  139667 */     // GIR_Coverage, 47836,
     /*  139667 */     GIR_EraseRootFromParent_Done,
     /*  139668 */   // Label 2468: @139668
     /*  139668 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(139713), // Rule ID 47837 //
     /*  139673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139676 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  139676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  139679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  139693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139711 */     GIR_RootConstrainSelectedInstOperands,
     /*  139712 */     // GIR_Coverage, 47837,
     /*  139712 */     GIR_EraseRootFromParent_Done,
     /*  139713 */   // Label 2469: @139713
     /*  139713 */   GIM_Reject,
     /*  139714 */ // Label 2467: @139714
     /*  139714 */ GIM_Reject,
     /*  139715 */ // Label 2282: @139715
     /*  139715 */ GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(140325),
     /*  139720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  139723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  139726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139730 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(139796), // Rule ID 71816 //
     /*  139735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  139750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  139754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139777 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  139780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139794 */     GIR_RootConstrainSelectedInstOperands,
     /*  139795 */     // GIR_Coverage, 71816,
     /*  139795 */     GIR_EraseRootFromParent_Done,
     /*  139796 */   // Label 2471: @139796
     /*  139796 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(139862), // Rule ID 71817 //
     /*  139801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  139816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  139820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139843 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  139846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139860 */     GIR_RootConstrainSelectedInstOperands,
     /*  139861 */     // GIR_Coverage, 71817,
     /*  139861 */     GIR_EraseRootFromParent_Done,
     /*  139862 */   // Label 2472: @139862
     /*  139862 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(139928), // Rule ID 71814 //
     /*  139867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  139882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  139886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139909 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  139912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139926 */     GIR_RootConstrainSelectedInstOperands,
     /*  139927 */     // GIR_Coverage, 71814,
     /*  139927 */     GIR_EraseRootFromParent_Done,
     /*  139928 */   // Label 2473: @139928
     /*  139928 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(139994), // Rule ID 71815 //
     /*  139933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  139948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  139952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139975 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  139978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139992 */     GIR_RootConstrainSelectedInstOperands,
     /*  139993 */     // GIR_Coverage, 71815,
     /*  139993 */     GIR_EraseRootFromParent_Done,
     /*  139994 */   // Label 2474: @139994
     /*  139994 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(140060), // Rule ID 71812 //
     /*  139999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140041 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140058 */     GIR_RootConstrainSelectedInstOperands,
     /*  140059 */     // GIR_Coverage, 71812,
     /*  140059 */     GIR_EraseRootFromParent_Done,
     /*  140060 */   // Label 2475: @140060
     /*  140060 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(140126), // Rule ID 71813 //
     /*  140065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140107 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140124 */     GIR_RootConstrainSelectedInstOperands,
     /*  140125 */     // GIR_Coverage, 71813,
     /*  140125 */     GIR_EraseRootFromParent_Done,
     /*  140126 */   // Label 2476: @140126
     /*  140126 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(140192), // Rule ID 53274 //
     /*  140131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140173 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140190 */     GIR_RootConstrainSelectedInstOperands,
     /*  140191 */     // GIR_Coverage, 53274,
     /*  140191 */     GIR_EraseRootFromParent_Done,
     /*  140192 */   // Label 2477: @140192
     /*  140192 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(140258), // Rule ID 53275 //
     /*  140197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140239 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140256 */     GIR_RootConstrainSelectedInstOperands,
     /*  140257 */     // GIR_Coverage, 53275,
     /*  140257 */     GIR_EraseRootFromParent_Done,
     /*  140258 */   // Label 2478: @140258
     /*  140258 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(140291), // Rule ID 53262 //
     /*  140263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140274 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  140277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140289 */     GIR_RootConstrainSelectedInstOperands,
     /*  140290 */     // GIR_Coverage, 53262,
     /*  140290 */     GIR_EraseRootFromParent_Done,
     /*  140291 */   // Label 2479: @140291
     /*  140291 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(140324), // Rule ID 53263 //
     /*  140296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140307 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  140310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140322 */     GIR_RootConstrainSelectedInstOperands,
     /*  140323 */     // GIR_Coverage, 53263,
     /*  140323 */     GIR_EraseRootFromParent_Done,
     /*  140324 */   // Label 2480: @140324
     /*  140324 */   GIM_Reject,
     /*  140325 */ // Label 2470: @140325
     /*  140325 */ GIM_Reject,
     /*  140326 */ // Label 2283: @140326
     /*  140326 */ GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(140440),
     /*  140331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  140334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  140337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140349 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(140394), // Rule ID 47824 //
     /*  140354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140357 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  140357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  140360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140392 */     GIR_RootConstrainSelectedInstOperands,
     /*  140393 */     // GIR_Coverage, 47824,
     /*  140393 */     GIR_EraseRootFromParent_Done,
     /*  140394 */   // Label 2482: @140394
     /*  140394 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(140439), // Rule ID 47825 //
     /*  140399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140402 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  140402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  140405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140437 */     GIR_RootConstrainSelectedInstOperands,
     /*  140438 */     // GIR_Coverage, 47825,
     /*  140438 */     GIR_EraseRootFromParent_Done,
     /*  140439 */   // Label 2483: @140439
     /*  140439 */   GIM_Reject,
     /*  140440 */ // Label 2481: @140440
     /*  140440 */ GIM_Reject,
     /*  140441 */ // Label 2284: @140441
     /*  140441 */ GIM_Reject,
     /*  140442 */ // Label 9: @140442
     /*  140442 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2515*/ GIMT_Encode4(155348),
     /*  140453 */ /*GILLT_s32*//*Label 2484*/ GIMT_Encode4(140577),
     /*  140457 */ /*GILLT_s64*//*Label 2485*/ GIMT_Encode4(141115),
     /*  140461 */ /*GILLT_nxv1s1*//*Label 2486*/ GIMT_Encode4(141541),
     /*  140465 */ /*GILLT_nxv1s8*//*Label 2487*/ GIMT_Encode4(143152),
     /*  140469 */ /*GILLT_nxv1s16*//*Label 2488*/ GIMT_Encode4(143267),
     /*  140473 */ /*GILLT_nxv1s32*//*Label 2489*/ GIMT_Encode4(143382),
     /*  140477 */ /*GILLT_nxv1s64*//*Label 2490*/ GIMT_Encode4(143497),
     /*  140481 */ /*GILLT_nxv2s1*//*Label 2491*/ GIMT_Encode4(143612),
     /*  140485 */ /*GILLT_nxv2s8*//*Label 2492*/ GIMT_Encode4(145223),
     /*  140489 */ /*GILLT_nxv2s16*//*Label 2493*/ GIMT_Encode4(145338),
     /*  140493 */ /*GILLT_nxv2s32*//*Label 2494*/ GIMT_Encode4(145453),
     /*  140497 */ /*GILLT_nxv2s64*//*Label 2495*/ GIMT_Encode4(145568),
     /*  140501 */ /*GILLT_nxv4s1*//*Label 2496*/ GIMT_Encode4(145683),
     /*  140505 */ /*GILLT_nxv4s8*//*Label 2497*/ GIMT_Encode4(147294),
     /*  140509 */ /*GILLT_nxv4s16*//*Label 2498*/ GIMT_Encode4(147409),
     /*  140513 */ /*GILLT_nxv4s32*//*Label 2499*/ GIMT_Encode4(147524),
     /*  140517 */ /*GILLT_nxv4s64*//*Label 2500*/ GIMT_Encode4(147639),
     /*  140521 */ /*GILLT_nxv8s1*//*Label 2501*/ GIMT_Encode4(147754),
     /*  140525 */ /*GILLT_nxv8s8*//*Label 2502*/ GIMT_Encode4(149365),
     /*  140529 */ /*GILLT_nxv8s16*//*Label 2503*/ GIMT_Encode4(149480),
     /*  140533 */ /*GILLT_nxv8s32*//*Label 2504*/ GIMT_Encode4(149595),
     /*  140537 */ /*GILLT_nxv8s64*//*Label 2505*/ GIMT_Encode4(149710),
     /*  140541 */ /*GILLT_nxv16s1*//*Label 2506*/ GIMT_Encode4(149825),
     /*  140545 */ /*GILLT_nxv16s8*//*Label 2507*/ GIMT_Encode4(151436),
     /*  140549 */ /*GILLT_nxv16s16*//*Label 2508*/ GIMT_Encode4(151551),
     /*  140553 */ /*GILLT_nxv16s32*//*Label 2509*/ GIMT_Encode4(151666),
     /*  140557 */ /*GILLT_nxv32s1*//*Label 2510*/ GIMT_Encode4(151781),
     /*  140561 */ /*GILLT_nxv32s8*//*Label 2511*/ GIMT_Encode4(153392),
     /*  140565 */ /*GILLT_nxv32s16*//*Label 2512*/ GIMT_Encode4(153507),
     /*  140569 */ /*GILLT_nxv64s1*//*Label 2513*/ GIMT_Encode4(153622),
     /*  140573 */ /*GILLT_nxv64s8*//*Label 2514*/ GIMT_Encode4(155233),
     /*  140577 */ // Label 2484: @140577
     /*  140577 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(141114),
     /*  140582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  140585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  140588 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(140671), // Rule ID 2473 //
     /*  140593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  140596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  140608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  140616 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  140620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  140624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  140633 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] })  =>  (ADDI:{ *:[i32] } (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })
     /*  140633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  140636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  140640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140645 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  140651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  140656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  140661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140669 */     GIR_RootConstrainSelectedInstOperands,
     /*  140670 */     // GIR_Coverage, 2473,
     /*  140670 */     GIR_EraseRootFromParent_Done,
     /*  140671 */   // Label 2517: @140671
     /*  140671 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(140730), // Rule ID 2467 //
     /*  140676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  140679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  140691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  140699 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  140703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  140716 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  140716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  140719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  140728 */     GIR_RootConstrainSelectedInstOperands,
     /*  140729 */     // GIR_Coverage, 2467,
     /*  140729 */     GIR_EraseRootFromParent_Done,
     /*  140730 */   // Label 2518: @140730
     /*  140730 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(140789), // Rule ID 65437 //
     /*  140735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  140738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  140754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  140762 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  140766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  140775 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  140775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  140778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  140787 */     GIR_RootConstrainSelectedInstOperands,
     /*  140788 */     // GIR_Coverage, 65437,
     /*  140788 */     GIR_EraseRootFromParent_Done,
     /*  140789 */   // Label 2519: @140789
     /*  140789 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(140845), // Rule ID 65423 //
     /*  140794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  140797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  140817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140822 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  140826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140832 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs2)  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  140832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  140835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  140841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140843 */     GIR_RootConstrainSelectedInstOperands,
     /*  140844 */     // GIR_Coverage, 65423,
     /*  140844 */     GIR_EraseRootFromParent_Done,
     /*  140845 */   // Label 2520: @140845
     /*  140845 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(140904), // Rule ID 65421 //
     /*  140850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  140853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  140873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  140887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140889 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  140889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  140892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  140898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140902 */     GIR_RootConstrainSelectedInstOperands,
     /*  140903 */     // GIR_Coverage, 65421,
     /*  140903 */     GIR_EraseRootFromParent_Done,
     /*  140904 */   // Label 2521: @140904
     /*  140904 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(140960), // Rule ID 2441 //
     /*  140909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  140912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  140936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140941 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  140945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140947 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  140947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  140950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140958 */     GIR_RootConstrainSelectedInstOperands,
     /*  140959 */     // GIR_Coverage, 2441,
     /*  140959 */     GIR_EraseRootFromParent_Done,
     /*  140960 */   // Label 2522: @140960
     /*  140960 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(141002), // Rule ID 89 //
     /*  140965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  140968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  140988 */     // MIs[1] Operand 1
     /*  140988 */     // No operand predicates
     /*  140988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140990 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  140990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  140993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141000 */     GIR_RootConstrainSelectedInstOperands,
     /*  141001 */     // GIR_Coverage, 89,
     /*  141001 */     GIR_EraseRootFromParent_Done,
     /*  141002 */   // Label 2523: @141002
     /*  141002 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(141044), // Rule ID 64521 //
     /*  141007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  141010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  141030 */     // MIs[1] Operand 1
     /*  141030 */     // No operand predicates
     /*  141030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141032 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_XORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  141032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORAI),
     /*  141035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  141037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141042 */     GIR_RootConstrainSelectedInstOperands,
     /*  141043 */     // GIR_Coverage, 64521,
     /*  141043 */     GIR_EraseRootFromParent_Done,
     /*  141044 */   // Label 2524: @141044
     /*  141044 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(141086), // Rule ID 64525 //
     /*  141049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  141052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  141072 */     // MIs[1] Operand 1
     /*  141072 */     // No operand predicates
     /*  141072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141074 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_XORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  141074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORI),
     /*  141077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141084 */     GIR_RootConstrainSelectedInstOperands,
     /*  141085 */     // GIR_Coverage, 64525,
     /*  141085 */     GIR_EraseRootFromParent_Done,
     /*  141086 */   // Label 2525: @141086
     /*  141086 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(141113), // Rule ID 87 //
     /*  141091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  141094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141106 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  141111 */     GIR_RootConstrainSelectedInstOperands,
     /*  141112 */     // GIR_Coverage, 87,
     /*  141112 */     GIR_Done,
     /*  141113 */   // Label 2526: @141113
     /*  141113 */   GIM_Reject,
     /*  141114 */ // Label 2516: @141114
     /*  141114 */ GIM_Reject,
     /*  141115 */ // Label 2485: @141115
     /*  141115 */ GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(141540),
     /*  141120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  141123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  141126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141130 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(141209), // Rule ID 2472 //
     /*  141135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  141138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141154 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  141158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141171 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } -1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] })  =>  (ADDI:{ *:[i64] } (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })
     /*  141171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  141174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  141178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141183 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  141189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  141199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141207 */     GIR_RootConstrainSelectedInstOperands,
     /*  141208 */     // GIR_Coverage, 2472,
     /*  141208 */     GIR_EraseRootFromParent_Done,
     /*  141209 */   // Label 2528: @141209
     /*  141209 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(141264), // Rule ID 2466 //
     /*  141214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  141217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141233 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141250 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141262 */     GIR_RootConstrainSelectedInstOperands,
     /*  141263 */     // GIR_Coverage, 2466,
     /*  141263 */     GIR_EraseRootFromParent_Done,
     /*  141264 */   // Label 2529: @141264
     /*  141264 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(141319), // Rule ID 65436 //
     /*  141269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  141272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141292 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141305 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141317 */     GIR_RootConstrainSelectedInstOperands,
     /*  141318 */     // GIR_Coverage, 65436,
     /*  141318 */     GIR_EraseRootFromParent_Done,
     /*  141319 */   // Label 2530: @141319
     /*  141319 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(141371), // Rule ID 65422 //
     /*  141324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  141327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141348 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141358 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141369 */     GIR_RootConstrainSelectedInstOperands,
     /*  141370 */     // GIR_Coverage, 65422,
     /*  141370 */     GIR_EraseRootFromParent_Done,
     /*  141371 */   // Label 2531: @141371
     /*  141371 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(141426), // Rule ID 65420 //
     /*  141376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  141379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141411 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141424 */     GIR_RootConstrainSelectedInstOperands,
     /*  141425 */     // GIR_Coverage, 65420,
     /*  141425 */     GIR_EraseRootFromParent_Done,
     /*  141426 */   // Label 2532: @141426
     /*  141426 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(141478), // Rule ID 2440 //
     /*  141431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  141434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141459 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141465 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  141476 */     GIR_RootConstrainSelectedInstOperands,
     /*  141477 */     // GIR_Coverage, 2440,
     /*  141477 */     GIR_EraseRootFromParent_Done,
     /*  141478 */   // Label 2533: @141478
     /*  141478 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(141516), // Rule ID 88 //
     /*  141483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  141486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  141502 */     // MIs[1] Operand 1
     /*  141502 */     // No operand predicates
     /*  141502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141504 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  141504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  141507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141514 */     GIR_RootConstrainSelectedInstOperands,
     /*  141515 */     // GIR_Coverage, 88,
     /*  141515 */     GIR_EraseRootFromParent_Done,
     /*  141516 */   // Label 2534: @141516
     /*  141516 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(141539), // Rule ID 86 //
     /*  141521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  141524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141532 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  141537 */     GIR_RootConstrainSelectedInstOperands,
     /*  141538 */     // GIR_Coverage, 86,
     /*  141538 */     GIR_Done,
     /*  141539 */   // Label 2535: @141539
     /*  141539 */   GIM_Reject,
     /*  141540 */ // Label 2527: @141540
     /*  141540 */ GIM_Reject,
     /*  141541 */ // Label 2486: @141541
     /*  141541 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(143151),
     /*  141546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141556 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(141625), // Rule ID 53158 //
     /*  141561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  141572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  141594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  141602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141604 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  141607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141623 */     GIR_RootConstrainSelectedInstOperands,
     /*  141624 */     // GIR_Coverage, 53158,
     /*  141624 */     GIR_EraseRootFromParent_Done,
     /*  141625 */   // Label 2537: @141625
     /*  141625 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(141694), // Rule ID 53159 //
     /*  141630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  141641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  141663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  141671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141673 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  141676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141692 */     GIR_RootConstrainSelectedInstOperands,
     /*  141693 */     // GIR_Coverage, 53159,
     /*  141693 */     GIR_EraseRootFromParent_Done,
     /*  141694 */   // Label 2538: @141694
     /*  141694 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(141763), // Rule ID 53160 //
     /*  141699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  141710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  141732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  141740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141742 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  141745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141761 */     GIR_RootConstrainSelectedInstOperands,
     /*  141762 */     // GIR_Coverage, 53160,
     /*  141762 */     GIR_EraseRootFromParent_Done,
     /*  141763 */   // Label 2539: @141763
     /*  141763 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(141832), // Rule ID 53161 //
     /*  141768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  141779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  141801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  141809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141811 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  141814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141830 */     GIR_RootConstrainSelectedInstOperands,
     /*  141831 */     // GIR_Coverage, 53161,
     /*  141831 */     GIR_EraseRootFromParent_Done,
     /*  141832 */   // Label 2540: @141832
     /*  141832 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(141898), // Rule ID 71630 //
     /*  141837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  141860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  141868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141877 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141879 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  141882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  141888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141896 */     GIR_RootConstrainSelectedInstOperands,
     /*  141897 */     // GIR_Coverage, 71630,
     /*  141897 */     GIR_EraseRootFromParent_Done,
     /*  141898 */   // Label 2541: @141898
     /*  141898 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(141964), // Rule ID 71631 //
     /*  141903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  141926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  141934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141945 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  141948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  141954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141962 */     GIR_RootConstrainSelectedInstOperands,
     /*  141963 */     // GIR_Coverage, 71631,
     /*  141963 */     GIR_EraseRootFromParent_Done,
     /*  141964 */   // Label 2542: @141964
     /*  141964 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(142030), // Rule ID 71628 //
     /*  141969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  141997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142011 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142028 */     GIR_RootConstrainSelectedInstOperands,
     /*  142029 */     // GIR_Coverage, 71628,
     /*  142029 */     GIR_EraseRootFromParent_Done,
     /*  142030 */   // Label 2543: @142030
     /*  142030 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(142096), // Rule ID 71629 //
     /*  142035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142077 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142094 */     GIR_RootConstrainSelectedInstOperands,
     /*  142095 */     // GIR_Coverage, 71629,
     /*  142095 */     GIR_EraseRootFromParent_Done,
     /*  142096 */   // Label 2544: @142096
     /*  142096 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(142165), // Rule ID 53162 //
     /*  142101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142144 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142163 */     GIR_RootConstrainSelectedInstOperands,
     /*  142164 */     // GIR_Coverage, 53162,
     /*  142164 */     GIR_EraseRootFromParent_Done,
     /*  142165 */   // Label 2545: @142165
     /*  142165 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(142234), // Rule ID 53163 //
     /*  142170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142213 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142232 */     GIR_RootConstrainSelectedInstOperands,
     /*  142233 */     // GIR_Coverage, 53163,
     /*  142233 */     GIR_EraseRootFromParent_Done,
     /*  142234 */   // Label 2546: @142234
     /*  142234 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(142303), // Rule ID 71624 //
     /*  142239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142282 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142301 */     GIR_RootConstrainSelectedInstOperands,
     /*  142302 */     // GIR_Coverage, 71624,
     /*  142302 */     GIR_EraseRootFromParent_Done,
     /*  142303 */   // Label 2547: @142303
     /*  142303 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(142372), // Rule ID 71625 //
     /*  142308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142351 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142370 */     GIR_RootConstrainSelectedInstOperands,
     /*  142371 */     // GIR_Coverage, 71625,
     /*  142371 */     GIR_EraseRootFromParent_Done,
     /*  142372 */   // Label 2548: @142372
     /*  142372 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(142441), // Rule ID 71626 //
     /*  142377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142408 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142420 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142439 */     GIR_RootConstrainSelectedInstOperands,
     /*  142440 */     // GIR_Coverage, 71626,
     /*  142440 */     GIR_EraseRootFromParent_Done,
     /*  142441 */   // Label 2549: @142441
     /*  142441 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(142510), // Rule ID 71627 //
     /*  142446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142489 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142508 */     GIR_RootConstrainSelectedInstOperands,
     /*  142509 */     // GIR_Coverage, 71627,
     /*  142509 */     GIR_EraseRootFromParent_Done,
     /*  142510 */   // Label 2550: @142510
     /*  142510 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(142579), // Rule ID 71632 //
     /*  142515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142551 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142558 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142577 */     GIR_RootConstrainSelectedInstOperands,
     /*  142578 */     // GIR_Coverage, 71632,
     /*  142578 */     GIR_EraseRootFromParent_Done,
     /*  142579 */   // Label 2551: @142579
     /*  142579 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(142648), // Rule ID 71633 //
     /*  142584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142611 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142627 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142646 */     GIR_RootConstrainSelectedInstOperands,
     /*  142647 */     // GIR_Coverage, 71633,
     /*  142647 */     GIR_EraseRootFromParent_Done,
     /*  142648 */   // Label 2552: @142648
     /*  142648 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(142714), // Rule ID 71636 //
     /*  142653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142695 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142712 */     GIR_RootConstrainSelectedInstOperands,
     /*  142713 */     // GIR_Coverage, 71636,
     /*  142713 */     GIR_EraseRootFromParent_Done,
     /*  142714 */   // Label 2553: @142714
     /*  142714 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(142780), // Rule ID 71637 //
     /*  142719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142761 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142778 */     GIR_RootConstrainSelectedInstOperands,
     /*  142779 */     // GIR_Coverage, 71637,
     /*  142779 */     GIR_EraseRootFromParent_Done,
     /*  142780 */   // Label 2554: @142780
     /*  142780 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(142846), // Rule ID 71634 //
     /*  142785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142827 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142844 */     GIR_RootConstrainSelectedInstOperands,
     /*  142845 */     // GIR_Coverage, 71634,
     /*  142845 */     GIR_EraseRootFromParent_Done,
     /*  142846 */   // Label 2555: @142846
     /*  142846 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(142912), // Rule ID 71635 //
     /*  142851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142893 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142910 */     GIR_RootConstrainSelectedInstOperands,
     /*  142911 */     // GIR_Coverage, 71635,
     /*  142911 */     GIR_EraseRootFromParent_Done,
     /*  142912 */   // Label 2556: @142912
     /*  142912 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(142955), // Rule ID 71650 //
     /*  142917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142938 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  142945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  142947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142953 */     GIR_RootConstrainSelectedInstOperands,
     /*  142954 */     // GIR_Coverage, 71650,
     /*  142954 */     GIR_EraseRootFromParent_Done,
     /*  142955 */   // Label 2557: @142955
     /*  142955 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(142998), // Rule ID 71651 //
     /*  142960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142981 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  142988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  142990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142996 */     GIR_RootConstrainSelectedInstOperands,
     /*  142997 */     // GIR_Coverage, 71651,
     /*  142997 */     GIR_EraseRootFromParent_Done,
     /*  142998 */   // Label 2558: @142998
     /*  142998 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(143041), // Rule ID 53168 //
     /*  143003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143024 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143039 */     GIR_RootConstrainSelectedInstOperands,
     /*  143040 */     // GIR_Coverage, 53168,
     /*  143040 */     GIR_EraseRootFromParent_Done,
     /*  143041 */   // Label 2559: @143041
     /*  143041 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(143084), // Rule ID 53169 //
     /*  143046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143067 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143082 */     GIR_RootConstrainSelectedInstOperands,
     /*  143083 */     // GIR_Coverage, 53169,
     /*  143083 */     GIR_EraseRootFromParent_Done,
     /*  143084 */   // Label 2560: @143084
     /*  143084 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(143117), // Rule ID 53156 //
     /*  143089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143100 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  143103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143115 */     GIR_RootConstrainSelectedInstOperands,
     /*  143116 */     // GIR_Coverage, 53156,
     /*  143116 */     GIR_EraseRootFromParent_Done,
     /*  143117 */   // Label 2561: @143117
     /*  143117 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(143150), // Rule ID 53157 //
     /*  143122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143133 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  143136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143148 */     GIR_RootConstrainSelectedInstOperands,
     /*  143149 */     // GIR_Coverage, 53157,
     /*  143149 */     GIR_EraseRootFromParent_Done,
     /*  143150 */   // Label 2562: @143150
     /*  143150 */   GIM_Reject,
     /*  143151 */ // Label 2536: @143151
     /*  143151 */ GIM_Reject,
     /*  143152 */ // Label 2487: @143152
     /*  143152 */ GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(143266),
     /*  143157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  143160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  143163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143171 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143175 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(143220), // Rule ID 47908 //
     /*  143180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143183 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  143183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  143186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  143200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143218 */     GIR_RootConstrainSelectedInstOperands,
     /*  143219 */     // GIR_Coverage, 47908,
     /*  143219 */     GIR_EraseRootFromParent_Done,
     /*  143220 */   // Label 2564: @143220
     /*  143220 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(143265), // Rule ID 47909 //
     /*  143225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143228 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  143228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  143231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  143245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143263 */     GIR_RootConstrainSelectedInstOperands,
     /*  143264 */     // GIR_Coverage, 47909,
     /*  143264 */     GIR_EraseRootFromParent_Done,
     /*  143265 */   // Label 2565: @143265
     /*  143265 */   GIM_Reject,
     /*  143266 */ // Label 2563: @143266
     /*  143266 */ GIM_Reject,
     /*  143267 */ // Label 2488: @143267
     /*  143267 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(143381),
     /*  143272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  143275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  143278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143290 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(143335), // Rule ID 47920 //
     /*  143295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143298 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  143298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  143301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  143315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143333 */     GIR_RootConstrainSelectedInstOperands,
     /*  143334 */     // GIR_Coverage, 47920,
     /*  143334 */     GIR_EraseRootFromParent_Done,
     /*  143335 */   // Label 2567: @143335
     /*  143335 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(143380), // Rule ID 47921 //
     /*  143340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143343 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  143343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  143346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  143360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143378 */     GIR_RootConstrainSelectedInstOperands,
     /*  143379 */     // GIR_Coverage, 47921,
     /*  143379 */     GIR_EraseRootFromParent_Done,
     /*  143380 */   // Label 2568: @143380
     /*  143380 */   GIM_Reject,
     /*  143381 */ // Label 2566: @143381
     /*  143381 */ GIM_Reject,
     /*  143382 */ // Label 2489: @143382
     /*  143382 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(143496),
     /*  143387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  143390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  143393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143401 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143405 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(143450), // Rule ID 47928 //
     /*  143410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143413 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  143413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  143416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  143430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  143445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143448 */     GIR_RootConstrainSelectedInstOperands,
     /*  143449 */     // GIR_Coverage, 47928,
     /*  143449 */     GIR_EraseRootFromParent_Done,
     /*  143450 */   // Label 2570: @143450
     /*  143450 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(143495), // Rule ID 47929 //
     /*  143455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143458 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  143458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  143461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  143475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  143490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143493 */     GIR_RootConstrainSelectedInstOperands,
     /*  143494 */     // GIR_Coverage, 47929,
     /*  143494 */     GIR_EraseRootFromParent_Done,
     /*  143495 */   // Label 2571: @143495
     /*  143495 */   GIM_Reject,
     /*  143496 */ // Label 2569: @143496
     /*  143496 */ GIM_Reject,
     /*  143497 */ // Label 2490: @143497
     /*  143497 */ GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(143611),
     /*  143502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  143505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  143508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143520 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(143565), // Rule ID 47944 //
     /*  143525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  143528 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  143528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  143531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  143545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  143560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143563 */     GIR_RootConstrainSelectedInstOperands,
     /*  143564 */     // GIR_Coverage, 47944,
     /*  143564 */     GIR_EraseRootFromParent_Done,
     /*  143565 */   // Label 2573: @143565
     /*  143565 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(143610), // Rule ID 47945 //
     /*  143570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  143573 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  143573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  143576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  143590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  143605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143608 */     GIR_RootConstrainSelectedInstOperands,
     /*  143609 */     // GIR_Coverage, 47945,
     /*  143609 */     GIR_EraseRootFromParent_Done,
     /*  143610 */   // Label 2574: @143610
     /*  143610 */   GIM_Reject,
     /*  143611 */ // Label 2572: @143611
     /*  143611 */ GIM_Reject,
     /*  143612 */ // Label 2491: @143612
     /*  143612 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(145222),
     /*  143617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143627 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(143696), // Rule ID 53176 //
     /*  143632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  143643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143675 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  143678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143694 */     GIR_RootConstrainSelectedInstOperands,
     /*  143695 */     // GIR_Coverage, 53176,
     /*  143695 */     GIR_EraseRootFromParent_Done,
     /*  143696 */   // Label 2576: @143696
     /*  143696 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(143765), // Rule ID 53177 //
     /*  143701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  143712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143744 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  143747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143763 */     GIR_RootConstrainSelectedInstOperands,
     /*  143764 */     // GIR_Coverage, 53177,
     /*  143764 */     GIR_EraseRootFromParent_Done,
     /*  143765 */   // Label 2577: @143765
     /*  143765 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(143834), // Rule ID 53178 //
     /*  143770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  143781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143813 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  143816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143832 */     GIR_RootConstrainSelectedInstOperands,
     /*  143833 */     // GIR_Coverage, 53178,
     /*  143833 */     GIR_EraseRootFromParent_Done,
     /*  143834 */   // Label 2578: @143834
     /*  143834 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(143903), // Rule ID 53179 //
     /*  143839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  143850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143882 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  143885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143901 */     GIR_RootConstrainSelectedInstOperands,
     /*  143902 */     // GIR_Coverage, 53179,
     /*  143902 */     GIR_EraseRootFromParent_Done,
     /*  143903 */   // Label 2579: @143903
     /*  143903 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(143969), // Rule ID 71658 //
     /*  143908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143950 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  143953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  143959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143967 */     GIR_RootConstrainSelectedInstOperands,
     /*  143968 */     // GIR_Coverage, 71658,
     /*  143968 */     GIR_EraseRootFromParent_Done,
     /*  143969 */   // Label 2580: @143969
     /*  143969 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(144035), // Rule ID 71659 //
     /*  143974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144016 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144033 */     GIR_RootConstrainSelectedInstOperands,
     /*  144034 */     // GIR_Coverage, 71659,
     /*  144034 */     GIR_EraseRootFromParent_Done,
     /*  144035 */   // Label 2581: @144035
     /*  144035 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(144101), // Rule ID 71656 //
     /*  144040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144082 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144099 */     GIR_RootConstrainSelectedInstOperands,
     /*  144100 */     // GIR_Coverage, 71656,
     /*  144100 */     GIR_EraseRootFromParent_Done,
     /*  144101 */   // Label 2582: @144101
     /*  144101 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(144167), // Rule ID 71657 //
     /*  144106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144148 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144165 */     GIR_RootConstrainSelectedInstOperands,
     /*  144166 */     // GIR_Coverage, 71657,
     /*  144166 */     GIR_EraseRootFromParent_Done,
     /*  144167 */   // Label 2583: @144167
     /*  144167 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(144236), // Rule ID 53180 //
     /*  144172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144215 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144234 */     GIR_RootConstrainSelectedInstOperands,
     /*  144235 */     // GIR_Coverage, 53180,
     /*  144235 */     GIR_EraseRootFromParent_Done,
     /*  144236 */   // Label 2584: @144236
     /*  144236 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(144305), // Rule ID 53181 //
     /*  144241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144284 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144303 */     GIR_RootConstrainSelectedInstOperands,
     /*  144304 */     // GIR_Coverage, 53181,
     /*  144304 */     GIR_EraseRootFromParent_Done,
     /*  144305 */   // Label 2585: @144305
     /*  144305 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(144374), // Rule ID 71652 //
     /*  144310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144353 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144372 */     GIR_RootConstrainSelectedInstOperands,
     /*  144373 */     // GIR_Coverage, 71652,
     /*  144373 */     GIR_EraseRootFromParent_Done,
     /*  144374 */   // Label 2586: @144374
     /*  144374 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(144443), // Rule ID 71653 //
     /*  144379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  144394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144422 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144441 */     GIR_RootConstrainSelectedInstOperands,
     /*  144442 */     // GIR_Coverage, 71653,
     /*  144442 */     GIR_EraseRootFromParent_Done,
     /*  144443 */   // Label 2587: @144443
     /*  144443 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(144512), // Rule ID 71654 //
     /*  144448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144491 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144510 */     GIR_RootConstrainSelectedInstOperands,
     /*  144511 */     // GIR_Coverage, 71654,
     /*  144511 */     GIR_EraseRootFromParent_Done,
     /*  144512 */   // Label 2588: @144512
     /*  144512 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(144581), // Rule ID 71655 //
     /*  144517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  144532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144560 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144579 */     GIR_RootConstrainSelectedInstOperands,
     /*  144580 */     // GIR_Coverage, 71655,
     /*  144580 */     GIR_EraseRootFromParent_Done,
     /*  144581 */   // Label 2589: @144581
     /*  144581 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(144650), // Rule ID 71660 //
     /*  144586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144613 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144617 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144629 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144648 */     GIR_RootConstrainSelectedInstOperands,
     /*  144649 */     // GIR_Coverage, 71660,
     /*  144649 */     GIR_EraseRootFromParent_Done,
     /*  144650 */   // Label 2590: @144650
     /*  144650 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(144719), // Rule ID 71661 //
     /*  144655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  144670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144698 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144717 */     GIR_RootConstrainSelectedInstOperands,
     /*  144718 */     // GIR_Coverage, 71661,
     /*  144718 */     GIR_EraseRootFromParent_Done,
     /*  144719 */   // Label 2591: @144719
     /*  144719 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(144785), // Rule ID 71664 //
     /*  144724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  144735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144766 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  144777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144783 */     GIR_RootConstrainSelectedInstOperands,
     /*  144784 */     // GIR_Coverage, 71664,
     /*  144784 */     GIR_EraseRootFromParent_Done,
     /*  144785 */   // Label 2592: @144785
     /*  144785 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(144851), // Rule ID 71665 //
     /*  144790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  144801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144832 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  144843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144849 */     GIR_RootConstrainSelectedInstOperands,
     /*  144850 */     // GIR_Coverage, 71665,
     /*  144850 */     GIR_EraseRootFromParent_Done,
     /*  144851 */   // Label 2593: @144851
     /*  144851 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(144917), // Rule ID 71662 //
     /*  144856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  144867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144898 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  144909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144915 */     GIR_RootConstrainSelectedInstOperands,
     /*  144916 */     // GIR_Coverage, 71662,
     /*  144916 */     GIR_EraseRootFromParent_Done,
     /*  144917 */   // Label 2594: @144917
     /*  144917 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(144983), // Rule ID 71663 //
     /*  144922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  144933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144964 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  144975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144981 */     GIR_RootConstrainSelectedInstOperands,
     /*  144982 */     // GIR_Coverage, 71663,
     /*  144982 */     GIR_EraseRootFromParent_Done,
     /*  144983 */   // Label 2595: @144983
     /*  144983 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(145026), // Rule ID 71678 //
     /*  144988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145009 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145024 */     GIR_RootConstrainSelectedInstOperands,
     /*  145025 */     // GIR_Coverage, 71678,
     /*  145025 */     GIR_EraseRootFromParent_Done,
     /*  145026 */   // Label 2596: @145026
     /*  145026 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(145069), // Rule ID 71679 //
     /*  145031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145052 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145067 */     GIR_RootConstrainSelectedInstOperands,
     /*  145068 */     // GIR_Coverage, 71679,
     /*  145068 */     GIR_EraseRootFromParent_Done,
     /*  145069 */   // Label 2597: @145069
     /*  145069 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(145112), // Rule ID 53186 //
     /*  145074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145095 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145110 */     GIR_RootConstrainSelectedInstOperands,
     /*  145111 */     // GIR_Coverage, 53186,
     /*  145111 */     GIR_EraseRootFromParent_Done,
     /*  145112 */   // Label 2598: @145112
     /*  145112 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(145155), // Rule ID 53187 //
     /*  145117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145138 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145153 */     GIR_RootConstrainSelectedInstOperands,
     /*  145154 */     // GIR_Coverage, 53187,
     /*  145154 */     GIR_EraseRootFromParent_Done,
     /*  145155 */   // Label 2599: @145155
     /*  145155 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(145188), // Rule ID 53174 //
     /*  145160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145171 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  145174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145186 */     GIR_RootConstrainSelectedInstOperands,
     /*  145187 */     // GIR_Coverage, 53174,
     /*  145187 */     GIR_EraseRootFromParent_Done,
     /*  145188 */   // Label 2600: @145188
     /*  145188 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(145221), // Rule ID 53175 //
     /*  145193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145204 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  145207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145219 */     GIR_RootConstrainSelectedInstOperands,
     /*  145220 */     // GIR_Coverage, 53175,
     /*  145220 */     GIR_EraseRootFromParent_Done,
     /*  145221 */   // Label 2601: @145221
     /*  145221 */   GIM_Reject,
     /*  145222 */ // Label 2575: @145222
     /*  145222 */ GIM_Reject,
     /*  145223 */ // Label 2492: @145223
     /*  145223 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(145337),
     /*  145228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  145231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  145234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145246 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(145291), // Rule ID 47912 //
     /*  145251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145254 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  145254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  145257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  145271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145289 */     GIR_RootConstrainSelectedInstOperands,
     /*  145290 */     // GIR_Coverage, 47912,
     /*  145290 */     GIR_EraseRootFromParent_Done,
     /*  145291 */   // Label 2603: @145291
     /*  145291 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(145336), // Rule ID 47913 //
     /*  145296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145299 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  145299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  145302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  145316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145334 */     GIR_RootConstrainSelectedInstOperands,
     /*  145335 */     // GIR_Coverage, 47913,
     /*  145335 */     GIR_EraseRootFromParent_Done,
     /*  145336 */   // Label 2604: @145336
     /*  145336 */   GIM_Reject,
     /*  145337 */ // Label 2602: @145337
     /*  145337 */ GIM_Reject,
     /*  145338 */ // Label 2493: @145338
     /*  145338 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(145452),
     /*  145343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  145346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  145349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145361 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(145406), // Rule ID 47924 //
     /*  145366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145369 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  145369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  145372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  145386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145404 */     GIR_RootConstrainSelectedInstOperands,
     /*  145405 */     // GIR_Coverage, 47924,
     /*  145405 */     GIR_EraseRootFromParent_Done,
     /*  145406 */   // Label 2606: @145406
     /*  145406 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(145451), // Rule ID 47925 //
     /*  145411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145414 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  145414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  145417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  145431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145449 */     GIR_RootConstrainSelectedInstOperands,
     /*  145450 */     // GIR_Coverage, 47925,
     /*  145450 */     GIR_EraseRootFromParent_Done,
     /*  145451 */   // Label 2607: @145451
     /*  145451 */   GIM_Reject,
     /*  145452 */ // Label 2605: @145452
     /*  145452 */ GIM_Reject,
     /*  145453 */ // Label 2494: @145453
     /*  145453 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(145567),
     /*  145458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  145461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  145464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145476 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(145521), // Rule ID 47940 //
     /*  145481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145484 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  145484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  145487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  145501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  145516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145519 */     GIR_RootConstrainSelectedInstOperands,
     /*  145520 */     // GIR_Coverage, 47940,
     /*  145520 */     GIR_EraseRootFromParent_Done,
     /*  145521 */   // Label 2609: @145521
     /*  145521 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(145566), // Rule ID 47941 //
     /*  145526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145529 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  145529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  145532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  145546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  145561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145564 */     GIR_RootConstrainSelectedInstOperands,
     /*  145565 */     // GIR_Coverage, 47941,
     /*  145565 */     GIR_EraseRootFromParent_Done,
     /*  145566 */   // Label 2610: @145566
     /*  145566 */   GIM_Reject,
     /*  145567 */ // Label 2608: @145567
     /*  145567 */ GIM_Reject,
     /*  145568 */ // Label 2495: @145568
     /*  145568 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(145682),
     /*  145573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  145576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  145579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  145583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  145587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  145591 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(145636), // Rule ID 47984 //
     /*  145596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  145599 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  145599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  145602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  145616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  145631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145634 */     GIR_RootConstrainSelectedInstOperands,
     /*  145635 */     // GIR_Coverage, 47984,
     /*  145635 */     GIR_EraseRootFromParent_Done,
     /*  145636 */   // Label 2612: @145636
     /*  145636 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(145681), // Rule ID 47985 //
     /*  145641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  145644 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  145644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  145647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  145661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  145676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145679 */     GIR_RootConstrainSelectedInstOperands,
     /*  145680 */     // GIR_Coverage, 47985,
     /*  145680 */     GIR_EraseRootFromParent_Done,
     /*  145681 */   // Label 2613: @145681
     /*  145681 */   GIM_Reject,
     /*  145682 */ // Label 2611: @145682
     /*  145682 */ GIM_Reject,
     /*  145683 */ // Label 2496: @145683
     /*  145683 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(147293),
     /*  145688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  145691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  145694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145698 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(145767), // Rule ID 53194 //
     /*  145703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  145714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  145718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  145722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145746 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  145749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145765 */     GIR_RootConstrainSelectedInstOperands,
     /*  145766 */     // GIR_Coverage, 53194,
     /*  145766 */     GIR_EraseRootFromParent_Done,
     /*  145767 */   // Label 2615: @145767
     /*  145767 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(145836), // Rule ID 53195 //
     /*  145772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  145783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  145787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  145791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145815 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  145818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145834 */     GIR_RootConstrainSelectedInstOperands,
     /*  145835 */     // GIR_Coverage, 53195,
     /*  145835 */     GIR_EraseRootFromParent_Done,
     /*  145836 */   // Label 2616: @145836
     /*  145836 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(145905), // Rule ID 53196 //
     /*  145841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  145852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  145856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  145860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145884 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  145887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145903 */     GIR_RootConstrainSelectedInstOperands,
     /*  145904 */     // GIR_Coverage, 53196,
     /*  145904 */     GIR_EraseRootFromParent_Done,
     /*  145905 */   // Label 2617: @145905
     /*  145905 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(145974), // Rule ID 53197 //
     /*  145910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  145921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  145925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  145929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145953 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  145956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145972 */     GIR_RootConstrainSelectedInstOperands,
     /*  145973 */     // GIR_Coverage, 53197,
     /*  145973 */     GIR_EraseRootFromParent_Done,
     /*  145974 */   // Label 2618: @145974
     /*  145974 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(146040), // Rule ID 71686 //
     /*  145979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  145994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  145998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146021 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146038 */     GIR_RootConstrainSelectedInstOperands,
     /*  146039 */     // GIR_Coverage, 71686,
     /*  146039 */     GIR_EraseRootFromParent_Done,
     /*  146040 */   // Label 2619: @146040
     /*  146040 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(146106), // Rule ID 71687 //
     /*  146045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146087 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146104 */     GIR_RootConstrainSelectedInstOperands,
     /*  146105 */     // GIR_Coverage, 71687,
     /*  146105 */     GIR_EraseRootFromParent_Done,
     /*  146106 */   // Label 2620: @146106
     /*  146106 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(146172), // Rule ID 71684 //
     /*  146111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  146139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146153 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146170 */     GIR_RootConstrainSelectedInstOperands,
     /*  146171 */     // GIR_Coverage, 71684,
     /*  146171 */     GIR_EraseRootFromParent_Done,
     /*  146172 */   // Label 2621: @146172
     /*  146172 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(146238), // Rule ID 71685 //
     /*  146177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  146205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146219 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146236 */     GIR_RootConstrainSelectedInstOperands,
     /*  146237 */     // GIR_Coverage, 71685,
     /*  146237 */     GIR_EraseRootFromParent_Done,
     /*  146238 */   // Label 2622: @146238
     /*  146238 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(146307), // Rule ID 53198 //
     /*  146243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146286 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146305 */     GIR_RootConstrainSelectedInstOperands,
     /*  146306 */     // GIR_Coverage, 53198,
     /*  146306 */     GIR_EraseRootFromParent_Done,
     /*  146307 */   // Label 2623: @146307
     /*  146307 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(146376), // Rule ID 53199 //
     /*  146312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146355 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146374 */     GIR_RootConstrainSelectedInstOperands,
     /*  146375 */     // GIR_Coverage, 53199,
     /*  146375 */     GIR_EraseRootFromParent_Done,
     /*  146376 */   // Label 2624: @146376
     /*  146376 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(146445), // Rule ID 71680 //
     /*  146381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  146396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146424 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146443 */     GIR_RootConstrainSelectedInstOperands,
     /*  146444 */     // GIR_Coverage, 71680,
     /*  146444 */     GIR_EraseRootFromParent_Done,
     /*  146445 */   // Label 2625: @146445
     /*  146445 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(146514), // Rule ID 71681 //
     /*  146450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  146465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146493 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146512 */     GIR_RootConstrainSelectedInstOperands,
     /*  146513 */     // GIR_Coverage, 71681,
     /*  146513 */     GIR_EraseRootFromParent_Done,
     /*  146514 */   // Label 2626: @146514
     /*  146514 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(146583), // Rule ID 71682 //
     /*  146519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  146534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146562 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  146565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146581 */     GIR_RootConstrainSelectedInstOperands,
     /*  146582 */     // GIR_Coverage, 71682,
     /*  146582 */     GIR_EraseRootFromParent_Done,
     /*  146583 */   // Label 2627: @146583
     /*  146583 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(146652), // Rule ID 71683 //
     /*  146588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  146603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146631 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  146634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146650 */     GIR_RootConstrainSelectedInstOperands,
     /*  146651 */     // GIR_Coverage, 71683,
     /*  146651 */     GIR_EraseRootFromParent_Done,
     /*  146652 */   // Label 2628: @146652
     /*  146652 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(146721), // Rule ID 71688 //
     /*  146657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  146672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146700 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146719 */     GIR_RootConstrainSelectedInstOperands,
     /*  146720 */     // GIR_Coverage, 71688,
     /*  146720 */     GIR_EraseRootFromParent_Done,
     /*  146721 */   // Label 2629: @146721
     /*  146721 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(146790), // Rule ID 71689 //
     /*  146726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  146741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146769 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146788 */     GIR_RootConstrainSelectedInstOperands,
     /*  146789 */     // GIR_Coverage, 71689,
     /*  146789 */     GIR_EraseRootFromParent_Done,
     /*  146790 */   // Label 2630: @146790
     /*  146790 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(146856), // Rule ID 71692 //
     /*  146795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146837 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  146848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146854 */     GIR_RootConstrainSelectedInstOperands,
     /*  146855 */     // GIR_Coverage, 71692,
     /*  146855 */     GIR_EraseRootFromParent_Done,
     /*  146856 */   // Label 2631: @146856
     /*  146856 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(146922), // Rule ID 71693 //
     /*  146861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146903 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  146914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146920 */     GIR_RootConstrainSelectedInstOperands,
     /*  146921 */     // GIR_Coverage, 71693,
     /*  146921 */     GIR_EraseRootFromParent_Done,
     /*  146922 */   // Label 2632: @146922
     /*  146922 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(146988), // Rule ID 71690 //
     /*  146927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  146959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146969 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  146980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146986 */     GIR_RootConstrainSelectedInstOperands,
     /*  146987 */     // GIR_Coverage, 71690,
     /*  146987 */     GIR_EraseRootFromParent_Done,
     /*  146988 */   // Label 2633: @146988
     /*  146988 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(147054), // Rule ID 71691 //
     /*  146993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147035 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147052 */     GIR_RootConstrainSelectedInstOperands,
     /*  147053 */     // GIR_Coverage, 71691,
     /*  147053 */     GIR_EraseRootFromParent_Done,
     /*  147054 */   // Label 2634: @147054
     /*  147054 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(147097), // Rule ID 71706 //
     /*  147059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147080 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147095 */     GIR_RootConstrainSelectedInstOperands,
     /*  147096 */     // GIR_Coverage, 71706,
     /*  147096 */     GIR_EraseRootFromParent_Done,
     /*  147097 */   // Label 2635: @147097
     /*  147097 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(147140), // Rule ID 71707 //
     /*  147102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147123 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147138 */     GIR_RootConstrainSelectedInstOperands,
     /*  147139 */     // GIR_Coverage, 71707,
     /*  147139 */     GIR_EraseRootFromParent_Done,
     /*  147140 */   // Label 2636: @147140
     /*  147140 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(147183), // Rule ID 53204 //
     /*  147145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147166 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147181 */     GIR_RootConstrainSelectedInstOperands,
     /*  147182 */     // GIR_Coverage, 53204,
     /*  147182 */     GIR_EraseRootFromParent_Done,
     /*  147183 */   // Label 2637: @147183
     /*  147183 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(147226), // Rule ID 53205 //
     /*  147188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147209 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147224 */     GIR_RootConstrainSelectedInstOperands,
     /*  147225 */     // GIR_Coverage, 53205,
     /*  147225 */     GIR_EraseRootFromParent_Done,
     /*  147226 */   // Label 2638: @147226
     /*  147226 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(147259), // Rule ID 53192 //
     /*  147231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147242 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  147245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147257 */     GIR_RootConstrainSelectedInstOperands,
     /*  147258 */     // GIR_Coverage, 53192,
     /*  147258 */     GIR_EraseRootFromParent_Done,
     /*  147259 */   // Label 2639: @147259
     /*  147259 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(147292), // Rule ID 53193 //
     /*  147264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147275 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  147278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147290 */     GIR_RootConstrainSelectedInstOperands,
     /*  147291 */     // GIR_Coverage, 53193,
     /*  147291 */     GIR_EraseRootFromParent_Done,
     /*  147292 */   // Label 2640: @147292
     /*  147292 */   GIM_Reject,
     /*  147293 */ // Label 2614: @147293
     /*  147293 */ GIM_Reject,
     /*  147294 */ // Label 2497: @147294
     /*  147294 */ GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(147408),
     /*  147299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  147302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  147305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147317 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(147362), // Rule ID 47916 //
     /*  147322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147325 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  147325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  147328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  147342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147360 */     GIR_RootConstrainSelectedInstOperands,
     /*  147361 */     // GIR_Coverage, 47916,
     /*  147361 */     GIR_EraseRootFromParent_Done,
     /*  147362 */   // Label 2642: @147362
     /*  147362 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(147407), // Rule ID 47917 //
     /*  147367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147370 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  147370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  147373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  147387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147405 */     GIR_RootConstrainSelectedInstOperands,
     /*  147406 */     // GIR_Coverage, 47917,
     /*  147406 */     GIR_EraseRootFromParent_Done,
     /*  147407 */   // Label 2643: @147407
     /*  147407 */   GIM_Reject,
     /*  147408 */ // Label 2641: @147408
     /*  147408 */ GIM_Reject,
     /*  147409 */ // Label 2498: @147409
     /*  147409 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(147523),
     /*  147414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  147417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  147420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147432 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(147477), // Rule ID 47936 //
     /*  147437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147440 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  147440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  147443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  147457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  147472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147475 */     GIR_RootConstrainSelectedInstOperands,
     /*  147476 */     // GIR_Coverage, 47936,
     /*  147476 */     GIR_EraseRootFromParent_Done,
     /*  147477 */   // Label 2645: @147477
     /*  147477 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(147522), // Rule ID 47937 //
     /*  147482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147485 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  147485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  147488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  147502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  147517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147520 */     GIR_RootConstrainSelectedInstOperands,
     /*  147521 */     // GIR_Coverage, 47937,
     /*  147521 */     GIR_EraseRootFromParent_Done,
     /*  147522 */   // Label 2646: @147522
     /*  147522 */   GIM_Reject,
     /*  147523 */ // Label 2644: @147523
     /*  147523 */ GIM_Reject,
     /*  147524 */ // Label 2499: @147524
     /*  147524 */ GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(147638),
     /*  147529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  147532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  147535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147547 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(147592), // Rule ID 47972 //
     /*  147552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147555 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  147555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  147558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  147572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  147587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147590 */     GIR_RootConstrainSelectedInstOperands,
     /*  147591 */     // GIR_Coverage, 47972,
     /*  147591 */     GIR_EraseRootFromParent_Done,
     /*  147592 */   // Label 2648: @147592
     /*  147592 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(147637), // Rule ID 47973 //
     /*  147597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147600 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  147600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  147603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  147617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  147632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147635 */     GIR_RootConstrainSelectedInstOperands,
     /*  147636 */     // GIR_Coverage, 47973,
     /*  147636 */     GIR_EraseRootFromParent_Done,
     /*  147637 */   // Label 2649: @147637
     /*  147637 */   GIM_Reject,
     /*  147638 */ // Label 2647: @147638
     /*  147638 */ GIM_Reject,
     /*  147639 */ // Label 2500: @147639
     /*  147639 */ GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(147753),
     /*  147644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  147647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  147650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147662 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(147707), // Rule ID 47988 //
     /*  147667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  147670 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  147670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  147673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  147687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  147702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147705 */     GIR_RootConstrainSelectedInstOperands,
     /*  147706 */     // GIR_Coverage, 47988,
     /*  147706 */     GIR_EraseRootFromParent_Done,
     /*  147707 */   // Label 2651: @147707
     /*  147707 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(147752), // Rule ID 47989 //
     /*  147712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  147715 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  147715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  147718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  147732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  147747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147750 */     GIR_RootConstrainSelectedInstOperands,
     /*  147751 */     // GIR_Coverage, 47989,
     /*  147751 */     GIR_EraseRootFromParent_Done,
     /*  147752 */   // Label 2652: @147752
     /*  147752 */   GIM_Reject,
     /*  147753 */ // Label 2650: @147753
     /*  147753 */ GIM_Reject,
     /*  147754 */ // Label 2501: @147754
     /*  147754 */ GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(149364),
     /*  147759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  147762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  147765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147769 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(147838), // Rule ID 53212 //
     /*  147774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  147785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  147789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  147793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147817 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  147820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147836 */     GIR_RootConstrainSelectedInstOperands,
     /*  147837 */     // GIR_Coverage, 53212,
     /*  147837 */     GIR_EraseRootFromParent_Done,
     /*  147838 */   // Label 2654: @147838
     /*  147838 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(147907), // Rule ID 53213 //
     /*  147843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  147854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  147858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  147862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147886 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  147889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147905 */     GIR_RootConstrainSelectedInstOperands,
     /*  147906 */     // GIR_Coverage, 53213,
     /*  147906 */     GIR_EraseRootFromParent_Done,
     /*  147907 */   // Label 2655: @147907
     /*  147907 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(147976), // Rule ID 53214 //
     /*  147912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  147927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  147931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147955 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  147958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147974 */     GIR_RootConstrainSelectedInstOperands,
     /*  147975 */     // GIR_Coverage, 53214,
     /*  147975 */     GIR_EraseRootFromParent_Done,
     /*  147976 */   // Label 2656: @147976
     /*  147976 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(148045), // Rule ID 53215 //
     /*  147981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  147996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148024 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148043 */     GIR_RootConstrainSelectedInstOperands,
     /*  148044 */     // GIR_Coverage, 53215,
     /*  148044 */     GIR_EraseRootFromParent_Done,
     /*  148045 */   // Label 2657: @148045
     /*  148045 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(148111), // Rule ID 71714 //
     /*  148050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148092 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148109 */     GIR_RootConstrainSelectedInstOperands,
     /*  148110 */     // GIR_Coverage, 71714,
     /*  148110 */     GIR_EraseRootFromParent_Done,
     /*  148111 */   // Label 2658: @148111
     /*  148111 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(148177), // Rule ID 71715 //
     /*  148116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148158 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148175 */     GIR_RootConstrainSelectedInstOperands,
     /*  148176 */     // GIR_Coverage, 71715,
     /*  148176 */     GIR_EraseRootFromParent_Done,
     /*  148177 */   // Label 2659: @148177
     /*  148177 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(148243), // Rule ID 71712 //
     /*  148182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  148210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148224 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148241 */     GIR_RootConstrainSelectedInstOperands,
     /*  148242 */     // GIR_Coverage, 71712,
     /*  148242 */     GIR_EraseRootFromParent_Done,
     /*  148243 */   // Label 2660: @148243
     /*  148243 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(148309), // Rule ID 71713 //
     /*  148248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  148276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148290 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148307 */     GIR_RootConstrainSelectedInstOperands,
     /*  148308 */     // GIR_Coverage, 71713,
     /*  148308 */     GIR_EraseRootFromParent_Done,
     /*  148309 */   // Label 2661: @148309
     /*  148309 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(148378), // Rule ID 53216 //
     /*  148314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148357 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148376 */     GIR_RootConstrainSelectedInstOperands,
     /*  148377 */     // GIR_Coverage, 53216,
     /*  148377 */     GIR_EraseRootFromParent_Done,
     /*  148378 */   // Label 2662: @148378
     /*  148378 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(148447), // Rule ID 53217 //
     /*  148383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148426 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148445 */     GIR_RootConstrainSelectedInstOperands,
     /*  148446 */     // GIR_Coverage, 53217,
     /*  148446 */     GIR_EraseRootFromParent_Done,
     /*  148447 */   // Label 2663: @148447
     /*  148447 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(148516), // Rule ID 71708 //
     /*  148452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148495 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148514 */     GIR_RootConstrainSelectedInstOperands,
     /*  148515 */     // GIR_Coverage, 71708,
     /*  148515 */     GIR_EraseRootFromParent_Done,
     /*  148516 */   // Label 2664: @148516
     /*  148516 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(148585), // Rule ID 71709 //
     /*  148521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  148536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148564 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148583 */     GIR_RootConstrainSelectedInstOperands,
     /*  148584 */     // GIR_Coverage, 71709,
     /*  148584 */     GIR_EraseRootFromParent_Done,
     /*  148585 */   // Label 2665: @148585
     /*  148585 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(148654), // Rule ID 71710 //
     /*  148590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148633 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148652 */     GIR_RootConstrainSelectedInstOperands,
     /*  148653 */     // GIR_Coverage, 71710,
     /*  148653 */     GIR_EraseRootFromParent_Done,
     /*  148654 */   // Label 2666: @148654
     /*  148654 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(148723), // Rule ID 71711 //
     /*  148659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  148674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148702 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148721 */     GIR_RootConstrainSelectedInstOperands,
     /*  148722 */     // GIR_Coverage, 71711,
     /*  148722 */     GIR_EraseRootFromParent_Done,
     /*  148723 */   // Label 2667: @148723
     /*  148723 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(148792), // Rule ID 71716 //
     /*  148728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148771 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148790 */     GIR_RootConstrainSelectedInstOperands,
     /*  148791 */     // GIR_Coverage, 71716,
     /*  148791 */     GIR_EraseRootFromParent_Done,
     /*  148792 */   // Label 2668: @148792
     /*  148792 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(148861), // Rule ID 71717 //
     /*  148797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  148812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148840 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148859 */     GIR_RootConstrainSelectedInstOperands,
     /*  148860 */     // GIR_Coverage, 71717,
     /*  148860 */     GIR_EraseRootFromParent_Done,
     /*  148861 */   // Label 2669: @148861
     /*  148861 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(148927), // Rule ID 71720 //
     /*  148866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  148877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148908 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  148919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148925 */     GIR_RootConstrainSelectedInstOperands,
     /*  148926 */     // GIR_Coverage, 71720,
     /*  148926 */     GIR_EraseRootFromParent_Done,
     /*  148927 */   // Label 2670: @148927
     /*  148927 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(148993), // Rule ID 71721 //
     /*  148932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  148943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148974 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  148985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148991 */     GIR_RootConstrainSelectedInstOperands,
     /*  148992 */     // GIR_Coverage, 71721,
     /*  148992 */     GIR_EraseRootFromParent_Done,
     /*  148993 */   // Label 2671: @148993
     /*  148993 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(149059), // Rule ID 71718 //
     /*  148998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149040 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149057 */     GIR_RootConstrainSelectedInstOperands,
     /*  149058 */     // GIR_Coverage, 71718,
     /*  149058 */     GIR_EraseRootFromParent_Done,
     /*  149059 */   // Label 2672: @149059
     /*  149059 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(149125), // Rule ID 71719 //
     /*  149064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149106 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149123 */     GIR_RootConstrainSelectedInstOperands,
     /*  149124 */     // GIR_Coverage, 71719,
     /*  149124 */     GIR_EraseRootFromParent_Done,
     /*  149125 */   // Label 2673: @149125
     /*  149125 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(149168), // Rule ID 71734 //
     /*  149130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149151 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149166 */     GIR_RootConstrainSelectedInstOperands,
     /*  149167 */     // GIR_Coverage, 71734,
     /*  149167 */     GIR_EraseRootFromParent_Done,
     /*  149168 */   // Label 2674: @149168
     /*  149168 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(149211), // Rule ID 71735 //
     /*  149173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149194 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149209 */     GIR_RootConstrainSelectedInstOperands,
     /*  149210 */     // GIR_Coverage, 71735,
     /*  149210 */     GIR_EraseRootFromParent_Done,
     /*  149211 */   // Label 2675: @149211
     /*  149211 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(149254), // Rule ID 53222 //
     /*  149216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149237 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149252 */     GIR_RootConstrainSelectedInstOperands,
     /*  149253 */     // GIR_Coverage, 53222,
     /*  149253 */     GIR_EraseRootFromParent_Done,
     /*  149254 */   // Label 2676: @149254
     /*  149254 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(149297), // Rule ID 53223 //
     /*  149259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149280 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149295 */     GIR_RootConstrainSelectedInstOperands,
     /*  149296 */     // GIR_Coverage, 53223,
     /*  149296 */     GIR_EraseRootFromParent_Done,
     /*  149297 */   // Label 2677: @149297
     /*  149297 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(149330), // Rule ID 53210 //
     /*  149302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149313 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  149316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149328 */     GIR_RootConstrainSelectedInstOperands,
     /*  149329 */     // GIR_Coverage, 53210,
     /*  149329 */     GIR_EraseRootFromParent_Done,
     /*  149330 */   // Label 2678: @149330
     /*  149330 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(149363), // Rule ID 53211 //
     /*  149335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149346 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  149349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149361 */     GIR_RootConstrainSelectedInstOperands,
     /*  149362 */     // GIR_Coverage, 53211,
     /*  149362 */     GIR_EraseRootFromParent_Done,
     /*  149363 */   // Label 2679: @149363
     /*  149363 */   GIM_Reject,
     /*  149364 */ // Label 2653: @149364
     /*  149364 */ GIM_Reject,
     /*  149365 */ // Label 2502: @149365
     /*  149365 */ GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(149479),
     /*  149370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  149373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  149376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149384 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149388 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(149433), // Rule ID 47932 //
     /*  149393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149396 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  149396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  149399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  149413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149431 */     GIR_RootConstrainSelectedInstOperands,
     /*  149432 */     // GIR_Coverage, 47932,
     /*  149432 */     GIR_EraseRootFromParent_Done,
     /*  149433 */   // Label 2681: @149433
     /*  149433 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(149478), // Rule ID 47933 //
     /*  149438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149441 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  149441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  149444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  149458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149476 */     GIR_RootConstrainSelectedInstOperands,
     /*  149477 */     // GIR_Coverage, 47933,
     /*  149477 */     GIR_EraseRootFromParent_Done,
     /*  149478 */   // Label 2682: @149478
     /*  149478 */   GIM_Reject,
     /*  149479 */ // Label 2680: @149479
     /*  149479 */ GIM_Reject,
     /*  149480 */ // Label 2503: @149480
     /*  149480 */ GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(149594),
     /*  149485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  149488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  149491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149503 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(149548), // Rule ID 47960 //
     /*  149508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149511 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  149511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  149514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  149528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  149543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149546 */     GIR_RootConstrainSelectedInstOperands,
     /*  149547 */     // GIR_Coverage, 47960,
     /*  149547 */     GIR_EraseRootFromParent_Done,
     /*  149548 */   // Label 2684: @149548
     /*  149548 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(149593), // Rule ID 47961 //
     /*  149553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149556 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  149556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  149559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  149573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  149588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149591 */     GIR_RootConstrainSelectedInstOperands,
     /*  149592 */     // GIR_Coverage, 47961,
     /*  149592 */     GIR_EraseRootFromParent_Done,
     /*  149593 */   // Label 2685: @149593
     /*  149593 */   GIM_Reject,
     /*  149594 */ // Label 2683: @149594
     /*  149594 */ GIM_Reject,
     /*  149595 */ // Label 2504: @149595
     /*  149595 */ GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(149709),
     /*  149600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  149603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  149606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  149610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  149614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  149618 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(149663), // Rule ID 47976 //
     /*  149623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149626 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  149626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  149629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  149643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  149658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149661 */     GIR_RootConstrainSelectedInstOperands,
     /*  149662 */     // GIR_Coverage, 47976,
     /*  149662 */     GIR_EraseRootFromParent_Done,
     /*  149663 */   // Label 2687: @149663
     /*  149663 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(149708), // Rule ID 47977 //
     /*  149668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149671 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  149671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  149674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  149688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  149703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149706 */     GIR_RootConstrainSelectedInstOperands,
     /*  149707 */     // GIR_Coverage, 47977,
     /*  149707 */     GIR_EraseRootFromParent_Done,
     /*  149708 */   // Label 2688: @149708
     /*  149708 */   GIM_Reject,
     /*  149709 */ // Label 2686: @149709
     /*  149709 */ GIM_Reject,
     /*  149710 */ // Label 2505: @149710
     /*  149710 */ GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(149824),
     /*  149715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  149718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  149721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149733 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(149778), // Rule ID 47992 //
     /*  149738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  149741 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  149741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  149744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  149758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149776 */     GIR_RootConstrainSelectedInstOperands,
     /*  149777 */     // GIR_Coverage, 47992,
     /*  149777 */     GIR_EraseRootFromParent_Done,
     /*  149778 */   // Label 2690: @149778
     /*  149778 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(149823), // Rule ID 47993 //
     /*  149783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  149786 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  149786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  149789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  149803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149821 */     GIR_RootConstrainSelectedInstOperands,
     /*  149822 */     // GIR_Coverage, 47993,
     /*  149822 */     GIR_EraseRootFromParent_Done,
     /*  149823 */   // Label 2691: @149823
     /*  149823 */   GIM_Reject,
     /*  149824 */ // Label 2689: @149824
     /*  149824 */ GIM_Reject,
     /*  149825 */ // Label 2506: @149825
     /*  149825 */ GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(151435),
     /*  149830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  149833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  149836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149840 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(149909), // Rule ID 53230 //
     /*  149845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  149856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  149860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  149864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149888 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  149891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  149901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149907 */     GIR_RootConstrainSelectedInstOperands,
     /*  149908 */     // GIR_Coverage, 53230,
     /*  149908 */     GIR_EraseRootFromParent_Done,
     /*  149909 */   // Label 2693: @149909
     /*  149909 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(149978), // Rule ID 53231 //
     /*  149914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  149925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  149929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  149933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149957 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  149960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  149970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149976 */     GIR_RootConstrainSelectedInstOperands,
     /*  149977 */     // GIR_Coverage, 53231,
     /*  149977 */     GIR_EraseRootFromParent_Done,
     /*  149978 */   // Label 2694: @149978
     /*  149978 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(150047), // Rule ID 53232 //
     /*  149983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  149994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  149998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150026 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150045 */     GIR_RootConstrainSelectedInstOperands,
     /*  150046 */     // GIR_Coverage, 53232,
     /*  150046 */     GIR_EraseRootFromParent_Done,
     /*  150047 */   // Label 2695: @150047
     /*  150047 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(150116), // Rule ID 53233 //
     /*  150052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150095 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150114 */     GIR_RootConstrainSelectedInstOperands,
     /*  150115 */     // GIR_Coverage, 53233,
     /*  150115 */     GIR_EraseRootFromParent_Done,
     /*  150116 */   // Label 2696: @150116
     /*  150116 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(150182), // Rule ID 71742 //
     /*  150121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  150144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150163 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  150172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150180 */     GIR_RootConstrainSelectedInstOperands,
     /*  150181 */     // GIR_Coverage, 71742,
     /*  150181 */     GIR_EraseRootFromParent_Done,
     /*  150182 */   // Label 2697: @150182
     /*  150182 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(150248), // Rule ID 71743 //
     /*  150187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  150210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150229 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  150238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150246 */     GIR_RootConstrainSelectedInstOperands,
     /*  150247 */     // GIR_Coverage, 71743,
     /*  150247 */     GIR_EraseRootFromParent_Done,
     /*  150248 */   // Label 2698: @150248
     /*  150248 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(150314), // Rule ID 71740 //
     /*  150253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  150281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150295 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150312 */     GIR_RootConstrainSelectedInstOperands,
     /*  150313 */     // GIR_Coverage, 71740,
     /*  150313 */     GIR_EraseRootFromParent_Done,
     /*  150314 */   // Label 2699: @150314
     /*  150314 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(150380), // Rule ID 71741 //
     /*  150319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  150347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150361 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150378 */     GIR_RootConstrainSelectedInstOperands,
     /*  150379 */     // GIR_Coverage, 71741,
     /*  150379 */     GIR_EraseRootFromParent_Done,
     /*  150380 */   // Label 2700: @150380
     /*  150380 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(150449), // Rule ID 53234 //
     /*  150385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150428 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150447 */     GIR_RootConstrainSelectedInstOperands,
     /*  150448 */     // GIR_Coverage, 53234,
     /*  150448 */     GIR_EraseRootFromParent_Done,
     /*  150449 */   // Label 2701: @150449
     /*  150449 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(150518), // Rule ID 53235 //
     /*  150454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150497 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150516 */     GIR_RootConstrainSelectedInstOperands,
     /*  150517 */     // GIR_Coverage, 53235,
     /*  150517 */     GIR_EraseRootFromParent_Done,
     /*  150518 */   // Label 2702: @150518
     /*  150518 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(150587), // Rule ID 71736 //
     /*  150523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150566 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  150569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150585 */     GIR_RootConstrainSelectedInstOperands,
     /*  150586 */     // GIR_Coverage, 71736,
     /*  150586 */     GIR_EraseRootFromParent_Done,
     /*  150587 */   // Label 2703: @150587
     /*  150587 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(150656), // Rule ID 71737 //
     /*  150592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150635 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  150638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150654 */     GIR_RootConstrainSelectedInstOperands,
     /*  150655 */     // GIR_Coverage, 71737,
     /*  150655 */     GIR_EraseRootFromParent_Done,
     /*  150656 */   // Label 2704: @150656
     /*  150656 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(150725), // Rule ID 71738 //
     /*  150661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150704 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150723 */     GIR_RootConstrainSelectedInstOperands,
     /*  150724 */     // GIR_Coverage, 71738,
     /*  150724 */     GIR_EraseRootFromParent_Done,
     /*  150725 */   // Label 2705: @150725
     /*  150725 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(150794), // Rule ID 71739 //
     /*  150730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150773 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150792 */     GIR_RootConstrainSelectedInstOperands,
     /*  150793 */     // GIR_Coverage, 71739,
     /*  150793 */     GIR_EraseRootFromParent_Done,
     /*  150794 */   // Label 2706: @150794
     /*  150794 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(150863), // Rule ID 71744 //
     /*  150799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150842 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150861 */     GIR_RootConstrainSelectedInstOperands,
     /*  150862 */     // GIR_Coverage, 71744,
     /*  150862 */     GIR_EraseRootFromParent_Done,
     /*  150863 */   // Label 2707: @150863
     /*  150863 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(150932), // Rule ID 71745 //
     /*  150868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150899 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150911 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150930 */     GIR_RootConstrainSelectedInstOperands,
     /*  150931 */     // GIR_Coverage, 71745,
     /*  150931 */     GIR_EraseRootFromParent_Done,
     /*  150932 */   // Label 2708: @150932
     /*  150932 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(150998), // Rule ID 71748 //
     /*  150937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  150964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150979 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  150988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  150990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150996 */     GIR_RootConstrainSelectedInstOperands,
     /*  150997 */     // GIR_Coverage, 71748,
     /*  150997 */     GIR_EraseRootFromParent_Done,
     /*  150998 */   // Label 2709: @150998
     /*  150998 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(151064), // Rule ID 71749 //
     /*  151003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151045 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  151054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151062 */     GIR_RootConstrainSelectedInstOperands,
     /*  151063 */     // GIR_Coverage, 71749,
     /*  151063 */     GIR_EraseRootFromParent_Done,
     /*  151064 */   // Label 2710: @151064
     /*  151064 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(151130), // Rule ID 71746 //
     /*  151069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  151101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151111 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151128 */     GIR_RootConstrainSelectedInstOperands,
     /*  151129 */     // GIR_Coverage, 71746,
     /*  151129 */     GIR_EraseRootFromParent_Done,
     /*  151130 */   // Label 2711: @151130
     /*  151130 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(151196), // Rule ID 71747 //
     /*  151135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  151167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151177 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151194 */     GIR_RootConstrainSelectedInstOperands,
     /*  151195 */     // GIR_Coverage, 71747,
     /*  151195 */     GIR_EraseRootFromParent_Done,
     /*  151196 */   // Label 2712: @151196
     /*  151196 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(151239), // Rule ID 71762 //
     /*  151201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151222 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151237 */     GIR_RootConstrainSelectedInstOperands,
     /*  151238 */     // GIR_Coverage, 71762,
     /*  151238 */     GIR_EraseRootFromParent_Done,
     /*  151239 */   // Label 2713: @151239
     /*  151239 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(151282), // Rule ID 71763 //
     /*  151244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151265 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151280 */     GIR_RootConstrainSelectedInstOperands,
     /*  151281 */     // GIR_Coverage, 71763,
     /*  151281 */     GIR_EraseRootFromParent_Done,
     /*  151282 */   // Label 2714: @151282
     /*  151282 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(151325), // Rule ID 53240 //
     /*  151287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151308 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151323 */     GIR_RootConstrainSelectedInstOperands,
     /*  151324 */     // GIR_Coverage, 53240,
     /*  151324 */     GIR_EraseRootFromParent_Done,
     /*  151325 */   // Label 2715: @151325
     /*  151325 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(151368), // Rule ID 53241 //
     /*  151330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151351 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151366 */     GIR_RootConstrainSelectedInstOperands,
     /*  151367 */     // GIR_Coverage, 53241,
     /*  151367 */     GIR_EraseRootFromParent_Done,
     /*  151368 */   // Label 2716: @151368
     /*  151368 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(151401), // Rule ID 53228 //
     /*  151373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151384 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  151387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151399 */     GIR_RootConstrainSelectedInstOperands,
     /*  151400 */     // GIR_Coverage, 53228,
     /*  151400 */     GIR_EraseRootFromParent_Done,
     /*  151401 */   // Label 2717: @151401
     /*  151401 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(151434), // Rule ID 53229 //
     /*  151406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151417 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  151420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151432 */     GIR_RootConstrainSelectedInstOperands,
     /*  151433 */     // GIR_Coverage, 53229,
     /*  151433 */     GIR_EraseRootFromParent_Done,
     /*  151434 */   // Label 2718: @151434
     /*  151434 */   GIM_Reject,
     /*  151435 */ // Label 2692: @151435
     /*  151435 */ GIM_Reject,
     /*  151436 */ // Label 2507: @151436
     /*  151436 */ GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(151550),
     /*  151441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  151444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  151447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151459 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(151504), // Rule ID 47948 //
     /*  151464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151467 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  151467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  151470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  151484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151502 */     GIR_RootConstrainSelectedInstOperands,
     /*  151503 */     // GIR_Coverage, 47948,
     /*  151503 */     GIR_EraseRootFromParent_Done,
     /*  151504 */   // Label 2720: @151504
     /*  151504 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(151549), // Rule ID 47949 //
     /*  151509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151512 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  151512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  151515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  151529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151547 */     GIR_RootConstrainSelectedInstOperands,
     /*  151548 */     // GIR_Coverage, 47949,
     /*  151548 */     GIR_EraseRootFromParent_Done,
     /*  151549 */   // Label 2721: @151549
     /*  151549 */   GIM_Reject,
     /*  151550 */ // Label 2719: @151550
     /*  151550 */ GIM_Reject,
     /*  151551 */ // Label 2508: @151551
     /*  151551 */ GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(151665),
     /*  151556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  151559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  151562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151574 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(151619), // Rule ID 47964 //
     /*  151579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151582 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  151582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  151585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  151599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  151614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151617 */     GIR_RootConstrainSelectedInstOperands,
     /*  151618 */     // GIR_Coverage, 47964,
     /*  151618 */     GIR_EraseRootFromParent_Done,
     /*  151619 */   // Label 2723: @151619
     /*  151619 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(151664), // Rule ID 47965 //
     /*  151624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151627 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  151627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  151630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  151644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  151659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151662 */     GIR_RootConstrainSelectedInstOperands,
     /*  151663 */     // GIR_Coverage, 47965,
     /*  151663 */     GIR_EraseRootFromParent_Done,
     /*  151664 */   // Label 2724: @151664
     /*  151664 */   GIM_Reject,
     /*  151665 */ // Label 2722: @151665
     /*  151665 */ GIM_Reject,
     /*  151666 */ // Label 2509: @151666
     /*  151666 */ GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(151780),
     /*  151671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  151674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  151677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151685 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151689 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(151734), // Rule ID 47980 //
     /*  151694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151697 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  151697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  151700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  151714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  151729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151732 */     GIR_RootConstrainSelectedInstOperands,
     /*  151733 */     // GIR_Coverage, 47980,
     /*  151733 */     GIR_EraseRootFromParent_Done,
     /*  151734 */   // Label 2726: @151734
     /*  151734 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(151779), // Rule ID 47981 //
     /*  151739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151742 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  151742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  151745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  151759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  151774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151777 */     GIR_RootConstrainSelectedInstOperands,
     /*  151778 */     // GIR_Coverage, 47981,
     /*  151778 */     GIR_EraseRootFromParent_Done,
     /*  151779 */   // Label 2727: @151779
     /*  151779 */   GIM_Reject,
     /*  151780 */ // Label 2725: @151780
     /*  151780 */ GIM_Reject,
     /*  151781 */ // Label 2510: @151781
     /*  151781 */ GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(153391),
     /*  151786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  151789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  151792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151796 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(151865), // Rule ID 53248 //
     /*  151801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  151812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  151816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  151820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151844 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  151847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  151857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151863 */     GIR_RootConstrainSelectedInstOperands,
     /*  151864 */     // GIR_Coverage, 53248,
     /*  151864 */     GIR_EraseRootFromParent_Done,
     /*  151865 */   // Label 2729: @151865
     /*  151865 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(151934), // Rule ID 53249 //
     /*  151870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  151881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  151885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  151889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151913 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  151916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  151926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151932 */     GIR_RootConstrainSelectedInstOperands,
     /*  151933 */     // GIR_Coverage, 53249,
     /*  151933 */     GIR_EraseRootFromParent_Done,
     /*  151934 */   // Label 2730: @151934
     /*  151934 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(152003), // Rule ID 53250 //
     /*  151939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  151950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  151954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  151958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151982 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  151985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  151995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152001 */     GIR_RootConstrainSelectedInstOperands,
     /*  152002 */     // GIR_Coverage, 53250,
     /*  152002 */     GIR_EraseRootFromParent_Done,
     /*  152003 */   // Label 2731: @152003
     /*  152003 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(152072), // Rule ID 53251 //
     /*  152008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152051 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  152054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152070 */     GIR_RootConstrainSelectedInstOperands,
     /*  152071 */     // GIR_Coverage, 53251,
     /*  152071 */     GIR_EraseRootFromParent_Done,
     /*  152072 */   // Label 2732: @152072
     /*  152072 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(152138), // Rule ID 71770 //
     /*  152077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  152100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152119 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  152128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152136 */     GIR_RootConstrainSelectedInstOperands,
     /*  152137 */     // GIR_Coverage, 71770,
     /*  152137 */     GIR_EraseRootFromParent_Done,
     /*  152138 */   // Label 2733: @152138
     /*  152138 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(152204), // Rule ID 71771 //
     /*  152143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  152166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152185 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  152194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152202 */     GIR_RootConstrainSelectedInstOperands,
     /*  152203 */     // GIR_Coverage, 71771,
     /*  152203 */     GIR_EraseRootFromParent_Done,
     /*  152204 */   // Label 2734: @152204
     /*  152204 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(152270), // Rule ID 71768 //
     /*  152209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  152237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152251 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152268 */     GIR_RootConstrainSelectedInstOperands,
     /*  152269 */     // GIR_Coverage, 71768,
     /*  152269 */     GIR_EraseRootFromParent_Done,
     /*  152270 */   // Label 2735: @152270
     /*  152270 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(152336), // Rule ID 71769 //
     /*  152275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  152303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152317 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152334 */     GIR_RootConstrainSelectedInstOperands,
     /*  152335 */     // GIR_Coverage, 71769,
     /*  152335 */     GIR_EraseRootFromParent_Done,
     /*  152336 */   // Label 2736: @152336
     /*  152336 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(152405), // Rule ID 53252 //
     /*  152341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152384 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152403 */     GIR_RootConstrainSelectedInstOperands,
     /*  152404 */     // GIR_Coverage, 53252,
     /*  152404 */     GIR_EraseRootFromParent_Done,
     /*  152405 */   // Label 2737: @152405
     /*  152405 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(152474), // Rule ID 53253 //
     /*  152410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152453 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152472 */     GIR_RootConstrainSelectedInstOperands,
     /*  152473 */     // GIR_Coverage, 53253,
     /*  152473 */     GIR_EraseRootFromParent_Done,
     /*  152474 */   // Label 2738: @152474
     /*  152474 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(152543), // Rule ID 71764 //
     /*  152479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  152494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152522 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  152525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  152531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  152535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152541 */     GIR_RootConstrainSelectedInstOperands,
     /*  152542 */     // GIR_Coverage, 71764,
     /*  152542 */     GIR_EraseRootFromParent_Done,
     /*  152543 */   // Label 2739: @152543
     /*  152543 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(152612), // Rule ID 71765 //
     /*  152548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  152563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152591 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  152594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  152600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  152604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152610 */     GIR_RootConstrainSelectedInstOperands,
     /*  152611 */     // GIR_Coverage, 71765,
     /*  152611 */     GIR_EraseRootFromParent_Done,
     /*  152612 */   // Label 2740: @152612
     /*  152612 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(152681), // Rule ID 71766 //
     /*  152617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  152632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152660 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  152663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  152669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  152673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152679 */     GIR_RootConstrainSelectedInstOperands,
     /*  152680 */     // GIR_Coverage, 71766,
     /*  152680 */     GIR_EraseRootFromParent_Done,
     /*  152681 */   // Label 2741: @152681
     /*  152681 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(152750), // Rule ID 71767 //
     /*  152686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  152701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152729 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  152732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  152738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  152742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152748 */     GIR_RootConstrainSelectedInstOperands,
     /*  152749 */     // GIR_Coverage, 71767,
     /*  152749 */     GIR_EraseRootFromParent_Done,
     /*  152750 */   // Label 2742: @152750
     /*  152750 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(152819), // Rule ID 71772 //
     /*  152755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  152770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152798 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  152807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  152811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152817 */     GIR_RootConstrainSelectedInstOperands,
     /*  152818 */     // GIR_Coverage, 71772,
     /*  152818 */     GIR_EraseRootFromParent_Done,
     /*  152819 */   // Label 2743: @152819
     /*  152819 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(152888), // Rule ID 71773 //
     /*  152824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  152839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152867 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  152876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  152880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152886 */     GIR_RootConstrainSelectedInstOperands,
     /*  152887 */     // GIR_Coverage, 71773,
     /*  152887 */     GIR_EraseRootFromParent_Done,
     /*  152888 */   // Label 2744: @152888
     /*  152888 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(152954), // Rule ID 71776 //
     /*  152893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  152904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  152920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152935 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  152944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  152946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152952 */     GIR_RootConstrainSelectedInstOperands,
     /*  152953 */     // GIR_Coverage, 71776,
     /*  152953 */     GIR_EraseRootFromParent_Done,
     /*  152954 */   // Label 2745: @152954
     /*  152954 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(153020), // Rule ID 71777 //
     /*  152959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  152970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  152986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153001 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153018 */     GIR_RootConstrainSelectedInstOperands,
     /*  153019 */     // GIR_Coverage, 71777,
     /*  153019 */     GIR_EraseRootFromParent_Done,
     /*  153020 */   // Label 2746: @153020
     /*  153020 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(153086), // Rule ID 71774 //
     /*  153025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  153057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153067 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153084 */     GIR_RootConstrainSelectedInstOperands,
     /*  153085 */     // GIR_Coverage, 71774,
     /*  153085 */     GIR_EraseRootFromParent_Done,
     /*  153086 */   // Label 2747: @153086
     /*  153086 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(153152), // Rule ID 71775 //
     /*  153091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  153123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153133 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153150 */     GIR_RootConstrainSelectedInstOperands,
     /*  153151 */     // GIR_Coverage, 71775,
     /*  153151 */     GIR_EraseRootFromParent_Done,
     /*  153152 */   // Label 2748: @153152
     /*  153152 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(153195), // Rule ID 71790 //
     /*  153157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153178 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153193 */     GIR_RootConstrainSelectedInstOperands,
     /*  153194 */     // GIR_Coverage, 71790,
     /*  153194 */     GIR_EraseRootFromParent_Done,
     /*  153195 */   // Label 2749: @153195
     /*  153195 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(153238), // Rule ID 71791 //
     /*  153200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153221 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153236 */     GIR_RootConstrainSelectedInstOperands,
     /*  153237 */     // GIR_Coverage, 71791,
     /*  153237 */     GIR_EraseRootFromParent_Done,
     /*  153238 */   // Label 2750: @153238
     /*  153238 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(153281), // Rule ID 53258 //
     /*  153243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153264 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153279 */     GIR_RootConstrainSelectedInstOperands,
     /*  153280 */     // GIR_Coverage, 53258,
     /*  153280 */     GIR_EraseRootFromParent_Done,
     /*  153281 */   // Label 2751: @153281
     /*  153281 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(153324), // Rule ID 53259 //
     /*  153286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153307 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153322 */     GIR_RootConstrainSelectedInstOperands,
     /*  153323 */     // GIR_Coverage, 53259,
     /*  153323 */     GIR_EraseRootFromParent_Done,
     /*  153324 */   // Label 2752: @153324
     /*  153324 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(153357), // Rule ID 53246 //
     /*  153329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153340 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  153343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153355 */     GIR_RootConstrainSelectedInstOperands,
     /*  153356 */     // GIR_Coverage, 53246,
     /*  153356 */     GIR_EraseRootFromParent_Done,
     /*  153357 */   // Label 2753: @153357
     /*  153357 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(153390), // Rule ID 53247 //
     /*  153362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153373 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  153376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153388 */     GIR_RootConstrainSelectedInstOperands,
     /*  153389 */     // GIR_Coverage, 53247,
     /*  153389 */     GIR_EraseRootFromParent_Done,
     /*  153390 */   // Label 2754: @153390
     /*  153390 */   GIM_Reject,
     /*  153391 */ // Label 2728: @153391
     /*  153391 */ GIM_Reject,
     /*  153392 */ // Label 2511: @153392
     /*  153392 */ GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(153506),
     /*  153397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  153400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  153403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153415 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(153460), // Rule ID 47952 //
     /*  153420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153423 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  153423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  153426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  153430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  153435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  153437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  153440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  153445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153458 */     GIR_RootConstrainSelectedInstOperands,
     /*  153459 */     // GIR_Coverage, 47952,
     /*  153459 */     GIR_EraseRootFromParent_Done,
     /*  153460 */   // Label 2756: @153460
     /*  153460 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(153505), // Rule ID 47953 //
     /*  153465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153468 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  153468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  153471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  153475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  153480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  153482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  153485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  153490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153503 */     GIR_RootConstrainSelectedInstOperands,
     /*  153504 */     // GIR_Coverage, 47953,
     /*  153504 */     GIR_EraseRootFromParent_Done,
     /*  153505 */   // Label 2757: @153505
     /*  153505 */   GIM_Reject,
     /*  153506 */ // Label 2755: @153506
     /*  153506 */ GIM_Reject,
     /*  153507 */ // Label 2512: @153507
     /*  153507 */ GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(153621),
     /*  153512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  153515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  153518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  153522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  153526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  153530 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(153575), // Rule ID 47968 //
     /*  153535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153538 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  153538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  153541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  153545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  153550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  153552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  153555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  153560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  153570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153573 */     GIR_RootConstrainSelectedInstOperands,
     /*  153574 */     // GIR_Coverage, 47968,
     /*  153574 */     GIR_EraseRootFromParent_Done,
     /*  153575 */   // Label 2759: @153575
     /*  153575 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(153620), // Rule ID 47969 //
     /*  153580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153583 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  153583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  153586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  153590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  153595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  153597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  153600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  153605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  153615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153618 */     GIR_RootConstrainSelectedInstOperands,
     /*  153619 */     // GIR_Coverage, 47969,
     /*  153619 */     GIR_EraseRootFromParent_Done,
     /*  153620 */   // Label 2760: @153620
     /*  153620 */   GIM_Reject,
     /*  153621 */ // Label 2758: @153621
     /*  153621 */ GIM_Reject,
     /*  153622 */ // Label 2513: @153622
     /*  153622 */ GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(155232),
     /*  153627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  153633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153637 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(153706), // Rule ID 53266 //
     /*  153642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  153653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  153661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153685 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  153688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153704 */     GIR_RootConstrainSelectedInstOperands,
     /*  153705 */     // GIR_Coverage, 53266,
     /*  153705 */     GIR_EraseRootFromParent_Done,
     /*  153706 */   // Label 2762: @153706
     /*  153706 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(153775), // Rule ID 53267 //
     /*  153711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  153722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  153730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153754 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  153757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153773 */     GIR_RootConstrainSelectedInstOperands,
     /*  153774 */     // GIR_Coverage, 53267,
     /*  153774 */     GIR_EraseRootFromParent_Done,
     /*  153775 */   // Label 2763: @153775
     /*  153775 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(153844), // Rule ID 53268 //
     /*  153780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  153791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  153799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153823 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  153826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153842 */     GIR_RootConstrainSelectedInstOperands,
     /*  153843 */     // GIR_Coverage, 53268,
     /*  153843 */     GIR_EraseRootFromParent_Done,
     /*  153844 */   // Label 2764: @153844
     /*  153844 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(153913), // Rule ID 53269 //
     /*  153849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  153860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  153868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153892 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  153895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153911 */     GIR_RootConstrainSelectedInstOperands,
     /*  153912 */     // GIR_Coverage, 53269,
     /*  153912 */     GIR_EraseRootFromParent_Done,
     /*  153913 */   // Label 2765: @153913
     /*  153913 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(153979), // Rule ID 71798 //
     /*  153918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  153937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153960 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  153963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153977 */     GIR_RootConstrainSelectedInstOperands,
     /*  153978 */     // GIR_Coverage, 71798,
     /*  153978 */     GIR_EraseRootFromParent_Done,
     /*  153979 */   // Label 2766: @153979
     /*  153979 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(154045), // Rule ID 71799 //
     /*  153984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154026 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154043 */     GIR_RootConstrainSelectedInstOperands,
     /*  154044 */     // GIR_Coverage, 71799,
     /*  154044 */     GIR_EraseRootFromParent_Done,
     /*  154045 */   // Label 2767: @154045
     /*  154045 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(154111), // Rule ID 71796 //
     /*  154050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154092 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154109 */     GIR_RootConstrainSelectedInstOperands,
     /*  154110 */     // GIR_Coverage, 71796,
     /*  154110 */     GIR_EraseRootFromParent_Done,
     /*  154111 */   // Label 2768: @154111
     /*  154111 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(154177), // Rule ID 71797 //
     /*  154116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154158 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154175 */     GIR_RootConstrainSelectedInstOperands,
     /*  154176 */     // GIR_Coverage, 71797,
     /*  154176 */     GIR_EraseRootFromParent_Done,
     /*  154177 */   // Label 2769: @154177
     /*  154177 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(154246), // Rule ID 53270 //
     /*  154182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154225 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154244 */     GIR_RootConstrainSelectedInstOperands,
     /*  154245 */     // GIR_Coverage, 53270,
     /*  154245 */     GIR_EraseRootFromParent_Done,
     /*  154246 */   // Label 2770: @154246
     /*  154246 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(154315), // Rule ID 53271 //
     /*  154251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154294 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154313 */     GIR_RootConstrainSelectedInstOperands,
     /*  154314 */     // GIR_Coverage, 53271,
     /*  154314 */     GIR_EraseRootFromParent_Done,
     /*  154315 */   // Label 2771: @154315
     /*  154315 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(154384), // Rule ID 71792 //
     /*  154320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154363 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154382 */     GIR_RootConstrainSelectedInstOperands,
     /*  154383 */     // GIR_Coverage, 71792,
     /*  154383 */     GIR_EraseRootFromParent_Done,
     /*  154384 */   // Label 2772: @154384
     /*  154384 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(154453), // Rule ID 71793 //
     /*  154389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154432 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154451 */     GIR_RootConstrainSelectedInstOperands,
     /*  154452 */     // GIR_Coverage, 71793,
     /*  154452 */     GIR_EraseRootFromParent_Done,
     /*  154453 */   // Label 2773: @154453
     /*  154453 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(154522), // Rule ID 71794 //
     /*  154458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154501 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154520 */     GIR_RootConstrainSelectedInstOperands,
     /*  154521 */     // GIR_Coverage, 71794,
     /*  154521 */     GIR_EraseRootFromParent_Done,
     /*  154522 */   // Label 2774: @154522
     /*  154522 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(154591), // Rule ID 71795 //
     /*  154527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154570 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154589 */     GIR_RootConstrainSelectedInstOperands,
     /*  154590 */     // GIR_Coverage, 71795,
     /*  154590 */     GIR_EraseRootFromParent_Done,
     /*  154591 */   // Label 2775: @154591
     /*  154591 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(154660), // Rule ID 71800 //
     /*  154596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154639 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154658 */     GIR_RootConstrainSelectedInstOperands,
     /*  154659 */     // GIR_Coverage, 71800,
     /*  154659 */     GIR_EraseRootFromParent_Done,
     /*  154660 */   // Label 2776: @154660
     /*  154660 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(154729), // Rule ID 71801 //
     /*  154665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154708 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154727 */     GIR_RootConstrainSelectedInstOperands,
     /*  154728 */     // GIR_Coverage, 71801,
     /*  154728 */     GIR_EraseRootFromParent_Done,
     /*  154729 */   // Label 2777: @154729
     /*  154729 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(154795), // Rule ID 71804 //
     /*  154734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154776 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  154787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154793 */     GIR_RootConstrainSelectedInstOperands,
     /*  154794 */     // GIR_Coverage, 71804,
     /*  154794 */     GIR_EraseRootFromParent_Done,
     /*  154795 */   // Label 2778: @154795
     /*  154795 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(154861), // Rule ID 71805 //
     /*  154800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154842 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  154853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154859 */     GIR_RootConstrainSelectedInstOperands,
     /*  154860 */     // GIR_Coverage, 71805,
     /*  154860 */     GIR_EraseRootFromParent_Done,
     /*  154861 */   // Label 2779: @154861
     /*  154861 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(154927), // Rule ID 71802 //
     /*  154866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154908 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  154919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154925 */     GIR_RootConstrainSelectedInstOperands,
     /*  154926 */     // GIR_Coverage, 71802,
     /*  154926 */     GIR_EraseRootFromParent_Done,
     /*  154927 */   // Label 2780: @154927
     /*  154927 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(154993), // Rule ID 71803 //
     /*  154932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154974 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  154985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154991 */     GIR_RootConstrainSelectedInstOperands,
     /*  154992 */     // GIR_Coverage, 71803,
     /*  154992 */     GIR_EraseRootFromParent_Done,
     /*  154993 */   // Label 2781: @154993
     /*  154993 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(155036), // Rule ID 71818 //
     /*  154998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155019 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155034 */     GIR_RootConstrainSelectedInstOperands,
     /*  155035 */     // GIR_Coverage, 71818,
     /*  155035 */     GIR_EraseRootFromParent_Done,
     /*  155036 */   // Label 2782: @155036
     /*  155036 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(155079), // Rule ID 71819 //
     /*  155041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155062 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155077 */     GIR_RootConstrainSelectedInstOperands,
     /*  155078 */     // GIR_Coverage, 71819,
     /*  155078 */     GIR_EraseRootFromParent_Done,
     /*  155079 */   // Label 2783: @155079
     /*  155079 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(155122), // Rule ID 53276 //
     /*  155084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155105 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155120 */     GIR_RootConstrainSelectedInstOperands,
     /*  155121 */     // GIR_Coverage, 53276,
     /*  155121 */     GIR_EraseRootFromParent_Done,
     /*  155122 */   // Label 2784: @155122
     /*  155122 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(155165), // Rule ID 53277 //
     /*  155127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155148 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155163 */     GIR_RootConstrainSelectedInstOperands,
     /*  155164 */     // GIR_Coverage, 53277,
     /*  155164 */     GIR_EraseRootFromParent_Done,
     /*  155165 */   // Label 2785: @155165
     /*  155165 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(155198), // Rule ID 53264 //
     /*  155170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155181 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  155184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155196 */     GIR_RootConstrainSelectedInstOperands,
     /*  155197 */     // GIR_Coverage, 53264,
     /*  155197 */     GIR_EraseRootFromParent_Done,
     /*  155198 */   // Label 2786: @155198
     /*  155198 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(155231), // Rule ID 53265 //
     /*  155203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155214 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  155217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155229 */     GIR_RootConstrainSelectedInstOperands,
     /*  155230 */     // GIR_Coverage, 53265,
     /*  155230 */     GIR_EraseRootFromParent_Done,
     /*  155231 */   // Label 2787: @155231
     /*  155231 */   GIM_Reject,
     /*  155232 */ // Label 2761: @155232
     /*  155232 */ GIM_Reject,
     /*  155233 */ // Label 2514: @155233
     /*  155233 */ GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(155347),
     /*  155238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  155241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  155244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155256 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(155301), // Rule ID 47956 //
     /*  155261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155264 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  155264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  155267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  155271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  155276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  155278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  155281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  155286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155299 */     GIR_RootConstrainSelectedInstOperands,
     /*  155300 */     // GIR_Coverage, 47956,
     /*  155300 */     GIR_EraseRootFromParent_Done,
     /*  155301 */   // Label 2789: @155301
     /*  155301 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(155346), // Rule ID 47957 //
     /*  155306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155309 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  155309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  155312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  155316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  155321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  155323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  155326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  155331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155344 */     GIR_RootConstrainSelectedInstOperands,
     /*  155345 */     // GIR_Coverage, 47957,
     /*  155345 */     GIR_EraseRootFromParent_Done,
     /*  155346 */   // Label 2790: @155346
     /*  155346 */   GIM_Reject,
     /*  155347 */ // Label 2788: @155347
     /*  155347 */ GIM_Reject,
     /*  155348 */ // Label 2515: @155348
     /*  155348 */ GIM_Reject,
     /*  155349 */ // Label 10: @155349
     /*  155349 */ GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(155409),
     /*  155354 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  155358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155362 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(155385), // Rule ID 110 //
     /*  155367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  155370 */     // MIs[0] Operand 1
     /*  155370 */     // No operand predicates
     /*  155370 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i64] })
     /*  155370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  155373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155375 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  155380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155383 */     GIR_RootConstrainSelectedInstOperands,
     /*  155384 */     // GIR_Coverage, 110,
     /*  155384 */     GIR_EraseRootFromParent_Done,
     /*  155385 */   // Label 2792: @155385
     /*  155385 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(155408), // Rule ID 111 //
     /*  155390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  155393 */     // MIs[0] Operand 1
     /*  155393 */     // No operand predicates
     /*  155393 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i32] })
     /*  155393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  155396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155398 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  155403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155406 */     GIR_RootConstrainSelectedInstOperands,
     /*  155407 */     // GIR_Coverage, 111,
     /*  155407 */     GIR_EraseRootFromParent_Done,
     /*  155408 */   // Label 2793: @155408
     /*  155408 */   GIM_Reject,
     /*  155409 */ // Label 2791: @155409
     /*  155409 */ GIM_Reject,
     /*  155410 */ // Label 11: @155410
     /*  155410 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(155470),
     /*  155415 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  155418 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  155421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  155424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  155427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  155439 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(155454), // Rule ID 50 //
     /*  155444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  155447 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  155447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  155452 */     GIR_RootConstrainSelectedInstOperands,
     /*  155453 */     // GIR_Coverage, 50,
     /*  155453 */     GIR_Done,
     /*  155454 */   // Label 2795: @155454
     /*  155454 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(155469), // Rule ID 51 //
     /*  155459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  155462 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  155462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  155467 */     GIR_RootConstrainSelectedInstOperands,
     /*  155468 */     // GIR_Coverage, 51,
     /*  155468 */     GIR_Done,
     /*  155469 */   // Label 2796: @155469
     /*  155469 */   GIM_Reject,
     /*  155470 */ // Label 2794: @155470
     /*  155470 */ GIM_Reject,
     /*  155471 */ // Label 12: @155471
     /*  155471 */ GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(155561),
     /*  155476 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  155479 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  155482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  155485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  155488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  155492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155500 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(155515), // Rule ID 48 //
     /*  155505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  155508 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  155508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  155513 */     GIR_RootConstrainSelectedInstOperands,
     /*  155514 */     // GIR_Coverage, 48,
     /*  155514 */     GIR_Done,
     /*  155515 */   // Label 2798: @155515
     /*  155515 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(155530), // Rule ID 49 //
     /*  155520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  155523 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  155523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  155528 */     GIR_RootConstrainSelectedInstOperands,
     /*  155529 */     // GIR_Coverage, 49,
     /*  155529 */     GIR_Done,
     /*  155530 */   // Label 2799: @155530
     /*  155530 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(155545), // Rule ID 2394 //
     /*  155535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0),
     /*  155538 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  155538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  155543 */     GIR_RootConstrainSelectedInstOperands,
     /*  155544 */     // GIR_Coverage, 2394,
     /*  155544 */     GIR_Done,
     /*  155545 */   // Label 2800: @155545
     /*  155545 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(155560), // Rule ID 2395 //
     /*  155550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1),
     /*  155553 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  155553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  155558 */     GIR_RootConstrainSelectedInstOperands,
     /*  155559 */     // GIR_Coverage, 2395,
     /*  155559 */     GIR_Done,
     /*  155560 */   // Label 2801: @155560
     /*  155560 */   GIM_Reject,
     /*  155561 */ // Label 2797: @155561
     /*  155561 */ GIM_Reject,
     /*  155562 */ // Label 13: @155562
     /*  155562 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2804*/ GIMT_Encode4(155928),
     /*  155573 */ /*GILLT_s32*//*Label 2802*/ GIMT_Encode4(155581),
     /*  155577 */ /*GILLT_s64*//*Label 2803*/ GIMT_Encode4(155818),
     /*  155581 */ // Label 2802: @155581
     /*  155581 */ GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(155817),
     /*  155586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  155589 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(155612), // Rule ID 1437 //
     /*  155594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  155597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  155601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155605 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  155605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  155610 */     GIR_RootConstrainSelectedInstOperands,
     /*  155611 */     // GIR_Coverage, 1437,
     /*  155611 */     GIR_Done,
     /*  155612 */   // Label 2806: @155612
     /*  155612 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(155635), // Rule ID 1438 //
     /*  155617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  155620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  155624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155628 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  155628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  155633 */     GIR_RootConstrainSelectedInstOperands,
     /*  155634 */     // GIR_Coverage, 1438,
     /*  155634 */     GIR_Done,
     /*  155635 */   // Label 2807: @155635
     /*  155635 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(155658), // Rule ID 1439 //
     /*  155640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  155643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  155651 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  155651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  155656 */     GIR_RootConstrainSelectedInstOperands,
     /*  155657 */     // GIR_Coverage, 1439,
     /*  155657 */     GIR_Done,
     /*  155658 */   // Label 2808: @155658
     /*  155658 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(155681), // Rule ID 1440 //
     /*  155663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  155666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  155674 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  155674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  155679 */     GIR_RootConstrainSelectedInstOperands,
     /*  155680 */     // GIR_Coverage, 1440,
     /*  155680 */     GIR_Done,
     /*  155681 */   // Label 2809: @155681
     /*  155681 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(155719), // Rule ID 1441 //
     /*  155686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  155689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  155693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155697 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  155697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  155700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  155702 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  155708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  155713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155718 */     // GIR_Coverage, 1441,
     /*  155718 */     GIR_EraseRootFromParent_Done,
     /*  155719 */   // Label 2810: @155719
     /*  155719 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(155757), // Rule ID 1442 //
     /*  155724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  155727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  155731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155735 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  155735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  155738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  155740 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  155746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  155751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155756 */     // GIR_Coverage, 1442,
     /*  155756 */     GIR_EraseRootFromParent_Done,
     /*  155757 */   // Label 2811: @155757
     /*  155757 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(155816), // Rule ID 1443 //
     /*  155762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  155765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  155773 */     // (bitconvert:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), FPR32INX:{ *:[f32] }:$rs1, sub_32:{ *:[i32] })
     /*  155773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  155776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  155780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  155785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  155787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  155790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  155792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  155795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  155800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  155815 */     // GIR_Coverage, 1443,
     /*  155815 */     GIR_EraseRootFromParent_Done,
     /*  155816 */   // Label 2812: @155816
     /*  155816 */   GIM_Reject,
     /*  155817 */ // Label 2805: @155817
     /*  155817 */ GIM_Reject,
     /*  155818 */ // Label 2803: @155818
     /*  155818 */ GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(155927),
     /*  155823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  155826 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(155849), // Rule ID 1890 //
     /*  155831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  155834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  155838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155842 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FMV_D_X:{ *:[f64] } GPR:{ *:[i64] }:$rs1)
     /*  155842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_D_X),
     /*  155847 */     GIR_RootConstrainSelectedInstOperands,
     /*  155848 */     // GIR_Coverage, 1890,
     /*  155848 */     GIR_Done,
     /*  155849 */   // Label 2814: @155849
     /*  155849 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(155872), // Rule ID 1891 //
     /*  155854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  155857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  155865 */     // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMV_X_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)
     /*  155865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_D),
     /*  155870 */     GIR_RootConstrainSelectedInstOperands,
     /*  155871 */     // GIR_Coverage, 1891,
     /*  155871 */     GIR_Done,
     /*  155872 */   // Label 2815: @155872
     /*  155872 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(155899), // Rule ID 1918 //
     /*  155877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  155880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155888 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i32] })
     /*  155888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  155893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155898 */     // GIR_Coverage, 1918,
     /*  155898 */     GIR_Done,
     /*  155899 */   // Label 2816: @155899
     /*  155899 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(155926), // Rule ID 1919 //
     /*  155904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  155907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155915 */     // (bitconvert:{ *:[i64] } GPR:{ *:[f64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[i64] } GPR:{ *:[f64] }:$rs1, GPR:{ *:[i32] })
     /*  155915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  155920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155925 */     // GIR_Coverage, 1919,
     /*  155925 */     GIR_Done,
     /*  155926 */   // Label 2817: @155926
     /*  155926 */   GIM_Reject,
     /*  155927 */ // Label 2813: @155927
     /*  155927 */ GIM_Reject,
     /*  155928 */ // Label 2804: @155928
     /*  155928 */ GIM_Reject,
     /*  155929 */ // Label 14: @155929
     /*  155929 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2821*/ GIMT_Encode4(156126),
     /*  155940 */ /*GILLT_s16*//*Label 2818*/ GIMT_Encode4(155952),
     /*  155944 */ /*GILLT_s32*//*Label 2819*/ GIMT_Encode4(156010),
     /*  155948 */ /*GILLT_s64*//*Label 2820*/ GIMT_Encode4(156068),
     /*  155952 */ // Label 2818: @155952
     /*  155952 */ GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(156009),
     /*  155957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  155960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  155964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  155968 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(155988), // Rule ID 2426 //
     /*  155973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  155976 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /*  155976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  155979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  155986 */     GIR_RootConstrainSelectedInstOperands,
     /*  155987 */     // GIR_Coverage, 2426,
     /*  155987 */     GIR_EraseRootFromParent_Done,
     /*  155988 */   // Label 2823: @155988
     /*  155988 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(156008), // Rule ID 2427 //
     /*  155993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  155996 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /*  155996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  155999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156006 */     GIR_RootConstrainSelectedInstOperands,
     /*  156007 */     // GIR_Coverage, 2427,
     /*  156007 */     GIR_EraseRootFromParent_Done,
     /*  156008 */   // Label 2824: @156008
     /*  156008 */   GIM_Reject,
     /*  156009 */ // Label 2822: @156009
     /*  156009 */ GIM_Reject,
     /*  156010 */ // Label 2819: @156010
     /*  156010 */ GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(156067),
     /*  156015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156026 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(156046), // Rule ID 2344 //
     /*  156031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  156034 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /*  156034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156044 */     GIR_RootConstrainSelectedInstOperands,
     /*  156045 */     // GIR_Coverage, 2344,
     /*  156045 */     GIR_EraseRootFromParent_Done,
     /*  156046 */   // Label 2826: @156046
     /*  156046 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(156066), // Rule ID 2345 //
     /*  156051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  156054 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /*  156054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156064 */     GIR_RootConstrainSelectedInstOperands,
     /*  156065 */     // GIR_Coverage, 2345,
     /*  156065 */     GIR_EraseRootFromParent_Done,
     /*  156066 */   // Label 2827: @156066
     /*  156066 */   GIM_Reject,
     /*  156067 */ // Label 2825: @156067
     /*  156067 */ GIM_Reject,
     /*  156068 */ // Label 2820: @156068
     /*  156068 */ GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(156125),
     /*  156073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156084 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(156104), // Rule ID 2384 //
     /*  156089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  156092 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /*  156092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156102 */     GIR_RootConstrainSelectedInstOperands,
     /*  156103 */     // GIR_Coverage, 2384,
     /*  156103 */     GIR_EraseRootFromParent_Done,
     /*  156104 */   // Label 2829: @156104
     /*  156104 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(156124), // Rule ID 2385 //
     /*  156109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  156112 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /*  156112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156122 */     GIR_RootConstrainSelectedInstOperands,
     /*  156123 */     // GIR_Coverage, 2385,
     /*  156123 */     GIR_EraseRootFromParent_Done,
     /*  156124 */   // Label 2830: @156124
     /*  156124 */   GIM_Reject,
     /*  156125 */ // Label 2828: @156125
     /*  156125 */ GIM_Reject,
     /*  156126 */ // Label 2821: @156126
     /*  156126 */ GIM_Reject,
     /*  156127 */ // Label 15: @156127
     /*  156127 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2834*/ GIMT_Encode4(156324),
     /*  156138 */ /*GILLT_s16*//*Label 2831*/ GIMT_Encode4(156150),
     /*  156142 */ /*GILLT_s32*//*Label 2832*/ GIMT_Encode4(156208),
     /*  156146 */ /*GILLT_s64*//*Label 2833*/ GIMT_Encode4(156266),
     /*  156150 */ // Label 2831: @156150
     /*  156150 */ GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(156207),
     /*  156155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156166 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(156186), // Rule ID 2410 //
     /*  156171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  156174 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /*  156174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156184 */     GIR_RootConstrainSelectedInstOperands,
     /*  156185 */     // GIR_Coverage, 2410,
     /*  156185 */     GIR_EraseRootFromParent_Done,
     /*  156186 */   // Label 2836: @156186
     /*  156186 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(156206), // Rule ID 2411 //
     /*  156191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  156194 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /*  156194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156204 */     GIR_RootConstrainSelectedInstOperands,
     /*  156205 */     // GIR_Coverage, 2411,
     /*  156205 */     GIR_EraseRootFromParent_Done,
     /*  156206 */   // Label 2837: @156206
     /*  156206 */   GIM_Reject,
     /*  156207 */ // Label 2835: @156207
     /*  156207 */ GIM_Reject,
     /*  156208 */ // Label 2832: @156208
     /*  156208 */ GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(156265),
     /*  156213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156224 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(156244), // Rule ID 2328 //
     /*  156229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  156232 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /*  156232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156242 */     GIR_RootConstrainSelectedInstOperands,
     /*  156243 */     // GIR_Coverage, 2328,
     /*  156243 */     GIR_EraseRootFromParent_Done,
     /*  156244 */   // Label 2839: @156244
     /*  156244 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(156264), // Rule ID 2329 //
     /*  156249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  156252 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /*  156252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156262 */     GIR_RootConstrainSelectedInstOperands,
     /*  156263 */     // GIR_Coverage, 2329,
     /*  156263 */     GIR_EraseRootFromParent_Done,
     /*  156264 */   // Label 2840: @156264
     /*  156264 */   GIM_Reject,
     /*  156265 */ // Label 2838: @156265
     /*  156265 */ GIM_Reject,
     /*  156266 */ // Label 2833: @156266
     /*  156266 */ GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(156323),
     /*  156271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156282 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(156302), // Rule ID 2368 //
     /*  156287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  156290 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /*  156290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156300 */     GIR_RootConstrainSelectedInstOperands,
     /*  156301 */     // GIR_Coverage, 2368,
     /*  156301 */     GIR_EraseRootFromParent_Done,
     /*  156302 */   // Label 2842: @156302
     /*  156302 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(156322), // Rule ID 2369 //
     /*  156307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  156310 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /*  156310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156320 */     GIR_RootConstrainSelectedInstOperands,
     /*  156321 */     // GIR_Coverage, 2369,
     /*  156321 */     GIR_EraseRootFromParent_Done,
     /*  156322 */   // Label 2843: @156322
     /*  156322 */   GIM_Reject,
     /*  156323 */ // Label 2841: @156323
     /*  156323 */ GIM_Reject,
     /*  156324 */ // Label 2834: @156324
     /*  156324 */ GIM_Reject,
     /*  156325 */ // Label 16: @156325
     /*  156325 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2846*/ GIMT_Encode4(156904),
     /*  156336 */ /*GILLT_s32*//*Label 2844*/ GIMT_Encode4(156344),
     /*  156340 */ /*GILLT_s64*//*Label 2845*/ GIMT_Encode4(156717),
     /*  156344 */ // Label 2844: @156344
     /*  156344 */ GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(156375), // Rule ID 1456 //
     /*  156349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  156352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156363 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  156363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  156366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156368 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156373 */   GIR_RootConstrainSelectedInstOperands,
     /*  156374 */   // GIR_Coverage, 1456,
     /*  156374 */   GIR_EraseRootFromParent_Done,
     /*  156375 */ // Label 2847: @156375
     /*  156375 */ GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(156406), // Rule ID 1457 //
     /*  156380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  156383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156394 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  156394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  156397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156399 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156404 */   GIR_RootConstrainSelectedInstOperands,
     /*  156405 */   // GIR_Coverage, 1457,
     /*  156405 */   GIR_EraseRootFromParent_Done,
     /*  156406 */ // Label 2848: @156406
     /*  156406 */ GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(156437), // Rule ID 1482 //
     /*  156411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  156414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156425 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  156425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  156428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156430 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156435 */   GIR_RootConstrainSelectedInstOperands,
     /*  156436 */   // GIR_Coverage, 1482,
     /*  156436 */   GIR_EraseRootFromParent_Done,
     /*  156437 */ // Label 2849: @156437
     /*  156437 */ GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(156468), // Rule ID 1483 //
     /*  156442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  156445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156456 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  156456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  156459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156461 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156466 */   GIR_RootConstrainSelectedInstOperands,
     /*  156467 */   // GIR_Coverage, 1483,
     /*  156467 */   GIR_EraseRootFromParent_Done,
     /*  156468 */ // Label 2850: @156468
     /*  156468 */ GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(156499), // Rule ID 1850 //
     /*  156473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /*  156476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156487 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  156487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  156490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156492 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156497 */   GIR_RootConstrainSelectedInstOperands,
     /*  156498 */   // GIR_Coverage, 1850,
     /*  156498 */   GIR_EraseRootFromParent_Done,
     /*  156499 */ // Label 2851: @156499
     /*  156499 */ GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(156530), // Rule ID 1851 //
     /*  156504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /*  156507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156518 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  156518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  156521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156523 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156528 */   GIR_RootConstrainSelectedInstOperands,
     /*  156529 */   // GIR_Coverage, 1851,
     /*  156529 */   GIR_EraseRootFromParent_Done,
     /*  156530 */ // Label 2852: @156530
     /*  156530 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(156561), // Rule ID 1876 //
     /*  156535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /*  156538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  156549 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  156549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  156552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156554 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156559 */   GIR_RootConstrainSelectedInstOperands,
     /*  156560 */   // GIR_Coverage, 1876,
     /*  156560 */   GIR_EraseRootFromParent_Done,
     /*  156561 */ // Label 2853: @156561
     /*  156561 */ GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(156592), // Rule ID 1877 //
     /*  156566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /*  156569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  156580 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  156580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  156583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156585 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156590 */   GIR_RootConstrainSelectedInstOperands,
     /*  156591 */   // GIR_Coverage, 1877,
     /*  156591 */   GIR_EraseRootFromParent_Done,
     /*  156592 */ // Label 2854: @156592
     /*  156592 */ GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(156623), // Rule ID 2192 //
     /*  156597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /*  156600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156611 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  156611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  156614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156616 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156621 */   GIR_RootConstrainSelectedInstOperands,
     /*  156622 */   // GIR_Coverage, 2192,
     /*  156622 */   GIR_EraseRootFromParent_Done,
     /*  156623 */ // Label 2855: @156623
     /*  156623 */ GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(156654), // Rule ID 2193 //
     /*  156628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /*  156631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156642 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  156642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  156645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156647 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156652 */   GIR_RootConstrainSelectedInstOperands,
     /*  156653 */   // GIR_Coverage, 2193,
     /*  156653 */   GIR_EraseRootFromParent_Done,
     /*  156654 */ // Label 2856: @156654
     /*  156654 */ GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(156685), // Rule ID 2218 //
     /*  156659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /*  156662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  156673 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  156673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  156676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156678 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156683 */   GIR_RootConstrainSelectedInstOperands,
     /*  156684 */   // GIR_Coverage, 2218,
     /*  156684 */   GIR_EraseRootFromParent_Done,
     /*  156685 */ // Label 2857: @156685
     /*  156685 */ GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(156716), // Rule ID 2219 //
     /*  156690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /*  156693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  156704 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  156704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  156707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156709 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156714 */   GIR_RootConstrainSelectedInstOperands,
     /*  156715 */   // GIR_Coverage, 2219,
     /*  156715 */   GIR_EraseRootFromParent_Done,
     /*  156716 */ // Label 2858: @156716
     /*  156716 */ GIM_Reject,
     /*  156717 */ // Label 2845: @156717
     /*  156717 */ GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(156748), // Rule ID 1509 //
     /*  156722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  156725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156736 */   // (lrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  156736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  156739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156741 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156746 */   GIR_RootConstrainSelectedInstOperands,
     /*  156747 */   // GIR_Coverage, 1509,
     /*  156747 */   GIR_EraseRootFromParent_Done,
     /*  156748 */ // Label 2859: @156748
     /*  156748 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(156779), // Rule ID 1537 //
     /*  156753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  156756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156767 */   // (lrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  156767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  156770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156772 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156777 */   GIR_RootConstrainSelectedInstOperands,
     /*  156778 */   // GIR_Coverage, 1537,
     /*  156778 */   GIR_EraseRootFromParent_Done,
     /*  156779 */ // Label 2860: @156779
     /*  156779 */ GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(156810), // Rule ID 1907 //
     /*  156784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  156787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156798 */   // (lrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  156798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  156801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156803 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156808 */   GIR_RootConstrainSelectedInstOperands,
     /*  156809 */   // GIR_Coverage, 1907,
     /*  156809 */   GIR_EraseRootFromParent_Done,
     /*  156810 */ // Label 2861: @156810
     /*  156810 */ GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(156841), // Rule ID 1935 //
     /*  156815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  156818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156829 */   // (lrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  156829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  156832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156834 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156839 */   GIR_RootConstrainSelectedInstOperands,
     /*  156840 */   // GIR_Coverage, 1935,
     /*  156840 */   GIR_EraseRootFromParent_Done,
     /*  156841 */ // Label 2862: @156841
     /*  156841 */ GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(156872), // Rule ID 2243 //
     /*  156846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  156849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156860 */   // (lrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  156860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  156863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156865 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156870 */   GIR_RootConstrainSelectedInstOperands,
     /*  156871 */   // GIR_Coverage, 2243,
     /*  156871 */   GIR_EraseRootFromParent_Done,
     /*  156872 */ // Label 2863: @156872
     /*  156872 */ GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(156903), // Rule ID 2269 //
     /*  156877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  156880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  156891 */   // (lrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  156891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  156894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156896 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156901 */   GIR_RootConstrainSelectedInstOperands,
     /*  156902 */   // GIR_Coverage, 2269,
     /*  156902 */   GIR_EraseRootFromParent_Done,
     /*  156903 */ // Label 2864: @156903
     /*  156903 */ GIM_Reject,
     /*  156904 */ // Label 2846: @156904
     /*  156904 */ GIM_Reject,
     /*  156905 */ // Label 17: @156905
     /*  156905 */ GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(157114),
     /*  156910 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  156913 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2869*/ GIMT_Encode4(157113),
     /*  156924 */   /*GILLT_s16*//*Label 2866*/ GIMT_Encode4(156936),
     /*  156928 */   /*GILLT_s32*//*Label 2867*/ GIMT_Encode4(156995),
     /*  156932 */   /*GILLT_s64*//*Label 2868*/ GIMT_Encode4(157054),
     /*  156936 */   // Label 2866: @156936
     /*  156936 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(156994),
     /*  156941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156945 */     GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(156969), // Rule ID 2245 //
     /*  156950 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  156953 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156957 */       // (llrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  156957 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  156960 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156962 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156964 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156967 */       GIR_RootConstrainSelectedInstOperands,
     /*  156968 */       // GIR_Coverage, 2245,
     /*  156968 */       GIR_EraseRootFromParent_Done,
     /*  156969 */     // Label 2871: @156969
     /*  156969 */     GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(156993), // Rule ID 2271 //
     /*  156974 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  156977 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  156981 */       // (llrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  156981 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  156984 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156986 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156988 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156991 */       GIR_RootConstrainSelectedInstOperands,
     /*  156992 */       // GIR_Coverage, 2271,
     /*  156992 */       GIR_EraseRootFromParent_Done,
     /*  156993 */     // Label 2872: @156993
     /*  156993 */     GIM_Reject,
     /*  156994 */   // Label 2870: @156994
     /*  156994 */   GIM_Reject,
     /*  156995 */   // Label 2867: @156995
     /*  156995 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(157053),
     /*  157000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157004 */     GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(157028), // Rule ID 1511 //
     /*  157009 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  157012 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157016 */       // (llrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157016 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  157019 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157021 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157023 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157026 */       GIR_RootConstrainSelectedInstOperands,
     /*  157027 */       // GIR_Coverage, 1511,
     /*  157027 */       GIR_EraseRootFromParent_Done,
     /*  157028 */     // Label 2874: @157028
     /*  157028 */     GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(157052), // Rule ID 1539 //
     /*  157033 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  157036 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157040 */       // (llrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157040 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  157043 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157045 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157047 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157050 */       GIR_RootConstrainSelectedInstOperands,
     /*  157051 */       // GIR_Coverage, 1539,
     /*  157051 */       GIR_EraseRootFromParent_Done,
     /*  157052 */     // Label 2875: @157052
     /*  157052 */     GIM_Reject,
     /*  157053 */   // Label 2873: @157053
     /*  157053 */   GIM_Reject,
     /*  157054 */   // Label 2868: @157054
     /*  157054 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(157112),
     /*  157059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157063 */     GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(157087), // Rule ID 1909 //
     /*  157068 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  157071 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157075 */       // (llrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157075 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  157078 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157080 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157082 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157085 */       GIR_RootConstrainSelectedInstOperands,
     /*  157086 */       // GIR_Coverage, 1909,
     /*  157086 */       GIR_EraseRootFromParent_Done,
     /*  157087 */     // Label 2877: @157087
     /*  157087 */     GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(157111), // Rule ID 1937 //
     /*  157092 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  157095 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157099 */       // (llrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157099 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  157102 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157104 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157106 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157109 */       GIR_RootConstrainSelectedInstOperands,
     /*  157110 */       // GIR_Coverage, 1937,
     /*  157110 */       GIR_EraseRootFromParent_Done,
     /*  157111 */     // Label 2878: @157111
     /*  157111 */     GIM_Reject,
     /*  157112 */   // Label 2876: @157112
     /*  157112 */   GIM_Reject,
     /*  157113 */   // Label 2869: @157113
     /*  157113 */   GIM_Reject,
     /*  157114 */ // Label 2865: @157114
     /*  157114 */ GIM_Reject,
     /*  157115 */ // Label 18: @157115
     /*  157115 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2882*/ GIMT_Encode4(157312),
     /*  157126 */ /*GILLT_s16*//*Label 2879*/ GIMT_Encode4(157138),
     /*  157130 */ /*GILLT_s32*//*Label 2880*/ GIMT_Encode4(157196),
     /*  157134 */ /*GILLT_s64*//*Label 2881*/ GIMT_Encode4(157254),
     /*  157138 */ // Label 2879: @157138
     /*  157138 */ GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(157195),
     /*  157143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157154 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(157174), // Rule ID 2414 //
     /*  157159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  157162 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /*  157162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  157165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157172 */     GIR_RootConstrainSelectedInstOperands,
     /*  157173 */     // GIR_Coverage, 2414,
     /*  157173 */     GIR_EraseRootFromParent_Done,
     /*  157174 */   // Label 2884: @157174
     /*  157174 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(157194), // Rule ID 2415 //
     /*  157179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  157182 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /*  157182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  157185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157192 */     GIR_RootConstrainSelectedInstOperands,
     /*  157193 */     // GIR_Coverage, 2415,
     /*  157193 */     GIR_EraseRootFromParent_Done,
     /*  157194 */   // Label 2885: @157194
     /*  157194 */   GIM_Reject,
     /*  157195 */ // Label 2883: @157195
     /*  157195 */ GIM_Reject,
     /*  157196 */ // Label 2880: @157196
     /*  157196 */ GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(157253),
     /*  157201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157212 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(157232), // Rule ID 2332 //
     /*  157217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  157220 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /*  157220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  157223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157230 */     GIR_RootConstrainSelectedInstOperands,
     /*  157231 */     // GIR_Coverage, 2332,
     /*  157231 */     GIR_EraseRootFromParent_Done,
     /*  157232 */   // Label 2887: @157232
     /*  157232 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(157252), // Rule ID 2333 //
     /*  157237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  157240 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /*  157240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  157243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157250 */     GIR_RootConstrainSelectedInstOperands,
     /*  157251 */     // GIR_Coverage, 2333,
     /*  157251 */     GIR_EraseRootFromParent_Done,
     /*  157252 */   // Label 2888: @157252
     /*  157252 */   GIM_Reject,
     /*  157253 */ // Label 2886: @157253
     /*  157253 */ GIM_Reject,
     /*  157254 */ // Label 2881: @157254
     /*  157254 */ GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(157311),
     /*  157259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157270 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(157290), // Rule ID 2372 //
     /*  157275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  157278 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i64] })
     /*  157278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157288 */     GIR_RootConstrainSelectedInstOperands,
     /*  157289 */     // GIR_Coverage, 2372,
     /*  157289 */     GIR_EraseRootFromParent_Done,
     /*  157290 */   // Label 2890: @157290
     /*  157290 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(157310), // Rule ID 2373 //
     /*  157295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  157298 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i32] })
     /*  157298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157308 */     GIR_RootConstrainSelectedInstOperands,
     /*  157309 */     // GIR_Coverage, 2373,
     /*  157309 */     GIR_EraseRootFromParent_Done,
     /*  157310 */   // Label 2891: @157310
     /*  157310 */   GIM_Reject,
     /*  157311 */ // Label 2889: @157311
     /*  157311 */ GIM_Reject,
     /*  157312 */ // Label 2882: @157312
     /*  157312 */ GIM_Reject,
     /*  157313 */ // Label 19: @157313
     /*  157313 */ GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(157351), // Rule ID 281 //
     /*  157318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  157321 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  157324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157328 */   // (readcyclecounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3072:{ *:[i64] }, X0:{ *:[i64] })
     /*  157328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  157331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157333 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3072),
     /*  157343 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  157349 */   GIR_RootConstrainSelectedInstOperands,
     /*  157350 */   // GIR_Coverage, 281,
     /*  157350 */   GIR_EraseRootFromParent_Done,
     /*  157351 */ // Label 2892: @157351
     /*  157351 */ GIM_Reject,
     /*  157352 */ // Label 20: @157352
     /*  157352 */ GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(157390), // Rule ID 282 //
     /*  157357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  157360 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  157363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157367 */   // (readsteadycounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3073:{ *:[i64] }, X0:{ *:[i64] })
     /*  157367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  157370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157372 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3073),
     /*  157382 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  157388 */   GIR_RootConstrainSelectedInstOperands,
     /*  157389 */   // GIR_Coverage, 282,
     /*  157389 */   GIR_EraseRootFromParent_Done,
     /*  157390 */ // Label 2893: @157390
     /*  157390 */ GIM_Reject,
     /*  157391 */ // Label 21: @157391
     /*  157391 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 2928*/ GIMT_Encode4(167672),
     /*  157402 */ /*GILLT_p0s32*//*Label 2894*/ GIMT_Encode4(157538),
     /*  157406 */ /*GILLT_p0s64*//*Label 2895*/ GIMT_Encode4(157632),
     /*  157410 */ /*GILLT_s16*//*Label 2896*/ GIMT_Encode4(157726),
     /*  157414 */ /*GILLT_s32*//*Label 2897*/ GIMT_Encode4(158381),
     /*  157418 */ /*GILLT_s64*//*Label 2898*/ GIMT_Encode4(161140),
     /*  157422 */ /*GILLT_nxv1s1*//*Label 2899*/ GIMT_Encode4(162366),
     /*  157426 */ /*GILLT_nxv1s8*//*Label 2900*/ GIMT_Encode4(162486),
     /*  157430 */ /*GILLT_nxv1s16*//*Label 2901*/ GIMT_Encode4(162614),
     /*  157434 */ /*GILLT_nxv1s32*//*Label 2902*/ GIMT_Encode4(162852),
     /*  157438 */ /*GILLT_nxv1s64*//*Label 2903*/ GIMT_Encode4(163090),
     /*  157442 */ /*GILLT_nxv2s1*//*Label 2904*/ GIMT_Encode4(163328),
     /*  157446 */ /*GILLT_nxv2s8*//*Label 2905*/ GIMT_Encode4(163448),
     /*  157450 */ /*GILLT_nxv2s16*//*Label 2906*/ GIMT_Encode4(163576),
     /*  157454 */ /*GILLT_nxv2s32*//*Label 2907*/ GIMT_Encode4(163814),
     /*  157458 */ /*GILLT_nxv2s64*//*Label 2908*/ GIMT_Encode4(164052),
     /*  157462 */ /*GILLT_nxv4s1*//*Label 2909*/ GIMT_Encode4(164290),
     /*  157466 */ /*GILLT_nxv4s8*//*Label 2910*/ GIMT_Encode4(164410),
     /*  157470 */ /*GILLT_nxv4s16*//*Label 2911*/ GIMT_Encode4(164538),
     /*  157474 */ /*GILLT_nxv4s32*//*Label 2912*/ GIMT_Encode4(164776),
     /*  157478 */ /*GILLT_nxv4s64*//*Label 2913*/ GIMT_Encode4(165014),
     /*  157482 */ /*GILLT_nxv8s1*//*Label 2914*/ GIMT_Encode4(165252),
     /*  157486 */ /*GILLT_nxv8s8*//*Label 2915*/ GIMT_Encode4(165372),
     /*  157490 */ /*GILLT_nxv8s16*//*Label 2916*/ GIMT_Encode4(165500),
     /*  157494 */ /*GILLT_nxv8s32*//*Label 2917*/ GIMT_Encode4(165738),
     /*  157498 */ /*GILLT_nxv8s64*//*Label 2918*/ GIMT_Encode4(165976),
     /*  157502 */ /*GILLT_nxv16s1*//*Label 2919*/ GIMT_Encode4(166214),
     /*  157506 */ /*GILLT_nxv16s8*//*Label 2920*/ GIMT_Encode4(166334),
     /*  157510 */ /*GILLT_nxv16s16*//*Label 2921*/ GIMT_Encode4(166462),
     /*  157514 */ /*GILLT_nxv16s32*//*Label 2922*/ GIMT_Encode4(166700),
     /*  157518 */ /*GILLT_nxv32s1*//*Label 2923*/ GIMT_Encode4(166938),
     /*  157522 */ /*GILLT_nxv32s8*//*Label 2924*/ GIMT_Encode4(167058),
     /*  157526 */ /*GILLT_nxv32s16*//*Label 2925*/ GIMT_Encode4(167186),
     /*  157530 */ /*GILLT_nxv64s1*//*Label 2926*/ GIMT_Encode4(167424),
     /*  157534 */ /*GILLT_nxv64s8*//*Label 2927*/ GIMT_Encode4(167544),
     /*  157538 */ // Label 2894: @157538
     /*  157538 */ GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(157631),
     /*  157543 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157546 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157558 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(157594), // Rule ID 65298 //
     /*  157563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  157566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157573 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  157573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  157576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157592 */     GIR_RootConstrainSelectedInstOperands,
     /*  157593 */     // GIR_Coverage, 65298,
     /*  157593 */     GIR_EraseRootFromParent_Done,
     /*  157594 */   // Label 2930: @157594
     /*  157594 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(157630), // Rule ID 65302 //
     /*  157599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  157602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157609 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  157609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  157612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157628 */     GIR_RootConstrainSelectedInstOperands,
     /*  157629 */     // GIR_Coverage, 65302,
     /*  157629 */     GIR_EraseRootFromParent_Done,
     /*  157630 */   // Label 2931: @157630
     /*  157630 */   GIM_Reject,
     /*  157631 */ // Label 2929: @157631
     /*  157631 */ GIM_Reject,
     /*  157632 */ // Label 2895: @157632
     /*  157632 */ GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(157725),
     /*  157637 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157648 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157652 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(157688), // Rule ID 65297 //
     /*  157657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  157660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157667 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  157670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157686 */     GIR_RootConstrainSelectedInstOperands,
     /*  157687 */     // GIR_Coverage, 65297,
     /*  157687 */     GIR_EraseRootFromParent_Done,
     /*  157688 */   // Label 2933: @157688
     /*  157688 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(157724), // Rule ID 65301 //
     /*  157693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  157696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157703 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  157706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157722 */     GIR_RootConstrainSelectedInstOperands,
     /*  157723 */     // GIR_Coverage, 65301,
     /*  157723 */     GIR_EraseRootFromParent_Done,
     /*  157724 */   // Label 2934: @157724
     /*  157724 */   GIM_Reject,
     /*  157725 */ // Label 2932: @157725
     /*  157725 */ GIM_Reject,
     /*  157726 */ // Label 2896: @157726
     /*  157726 */ GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(157777), // Rule ID 2140 //
     /*  157731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  157734 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157737 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157745 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157749 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157756 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  157759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157771 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157775 */   GIR_RootConstrainSelectedInstOperands,
     /*  157776 */   // GIR_Coverage, 2140,
     /*  157776 */   GIR_EraseRootFromParent_Done,
     /*  157777 */ // Label 2935: @157777
     /*  157777 */ GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(157828), // Rule ID 2141 //
     /*  157782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  157785 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157788 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157796 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157800 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157807 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  157807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  157810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157822 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157826 */   GIR_RootConstrainSelectedInstOperands,
     /*  157827 */   // GIR_Coverage, 2141,
     /*  157827 */   GIR_EraseRootFromParent_Done,
     /*  157828 */ // Label 2936: @157828
     /*  157828 */ GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(157879), // Rule ID 2146 //
     /*  157833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  157836 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157839 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157851 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157858 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  157861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157873 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157877 */   GIR_RootConstrainSelectedInstOperands,
     /*  157878 */   // GIR_Coverage, 2146,
     /*  157878 */   GIR_EraseRootFromParent_Done,
     /*  157879 */ // Label 2937: @157879
     /*  157879 */ GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(157930), // Rule ID 2147 //
     /*  157884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  157887 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157890 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157898 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157902 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157909 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  157909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  157912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157924 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157928 */   GIR_RootConstrainSelectedInstOperands,
     /*  157929 */   // GIR_Coverage, 2147,
     /*  157929 */   GIR_EraseRootFromParent_Done,
     /*  157930 */ // Label 2938: @157930
     /*  157930 */ GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(157981), // Rule ID 65305 //
     /*  157935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  157938 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157941 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157949 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157953 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157960 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  157963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157965 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157975 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157979 */   GIR_RootConstrainSelectedInstOperands,
     /*  157980 */   // GIR_Coverage, 65305,
     /*  157980 */   GIR_EraseRootFromParent_Done,
     /*  157981 */ // Label 2939: @157981
     /*  157981 */ GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(158032), // Rule ID 65306 //
     /*  157986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  157989 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157992 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158000 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158004 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158011 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158030 */   GIR_RootConstrainSelectedInstOperands,
     /*  158031 */   // GIR_Coverage, 65306,
     /*  158031 */   GIR_EraseRootFromParent_Done,
     /*  158032 */ // Label 2940: @158032
     /*  158032 */ GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(158090), // Rule ID 65309 //
     /*  158037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  158040 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158043 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158047 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158058 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158062 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158069 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  158072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158088 */   GIR_RootConstrainSelectedInstOperands,
     /*  158089 */   // GIR_Coverage, 65309,
     /*  158089 */   GIR_EraseRootFromParent_Done,
     /*  158090 */ // Label 2941: @158090
     /*  158090 */ GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(158148), // Rule ID 65310 //
     /*  158095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  158098 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158101 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158116 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158120 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158127 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  158130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158142 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158146 */   GIR_RootConstrainSelectedInstOperands,
     /*  158147 */   // GIR_Coverage, 65310,
     /*  158147 */   GIR_EraseRootFromParent_Done,
     /*  158148 */ // Label 2942: @158148
     /*  158148 */ GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(158206), // Rule ID 65313 //
     /*  158153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  158156 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158159 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158163 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158185 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  158188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158200 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158204 */   GIR_RootConstrainSelectedInstOperands,
     /*  158205 */   // GIR_Coverage, 65313,
     /*  158205 */   GIR_EraseRootFromParent_Done,
     /*  158206 */ // Label 2943: @158206
     /*  158206 */ GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(158264), // Rule ID 65314 //
     /*  158211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  158214 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158217 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158221 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158232 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158236 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158243 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  158246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158258 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158262 */   GIR_RootConstrainSelectedInstOperands,
     /*  158263 */   // GIR_Coverage, 65314,
     /*  158263 */   GIR_EraseRootFromParent_Done,
     /*  158264 */ // Label 2944: @158264
     /*  158264 */ GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(158322), // Rule ID 65315 //
     /*  158269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  158272 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158275 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158279 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158290 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158294 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158301 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158320 */   GIR_RootConstrainSelectedInstOperands,
     /*  158321 */   // GIR_Coverage, 65315,
     /*  158321 */   GIR_EraseRootFromParent_Done,
     /*  158322 */ // Label 2945: @158322
     /*  158322 */ GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(158380), // Rule ID 65316 //
     /*  158327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  158330 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158333 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158337 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158348 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158352 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158359 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158374 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158378 */   GIR_RootConstrainSelectedInstOperands,
     /*  158379 */   // GIR_Coverage, 65316,
     /*  158379 */   GIR_EraseRootFromParent_Done,
     /*  158380 */ // Label 2946: @158380
     /*  158380 */ GIM_Reject,
     /*  158381 */ // Label 2897: @158381
     /*  158381 */ GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(158492), // Rule ID 74323 //
     /*  158386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  158389 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158392 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158396 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158407 */   // MIs[0] Operand 1
     /*  158407 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158411 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  158415 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  158419 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  158423 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  158427 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  158431 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  158435 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  158439 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  158443 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  158448 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  158452 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  158456 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  158460 */   // MIs[3] Operand 1
     /*  158460 */   // No operand predicates
     /*  158460 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158465 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  158467 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  158467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  158470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158472 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  158476 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  158480 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  158483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  158490 */   GIR_RootConstrainSelectedInstOperands,
     /*  158491 */   // GIR_Coverage, 74323,
     /*  158491 */   GIR_EraseRootFromParent_Done,
     /*  158492 */ // Label 2947: @158492
     /*  158492 */ GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(158603), // Rule ID 74324 //
     /*  158497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  158500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158503 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158507 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158518 */   // MIs[0] Operand 1
     /*  158518 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158522 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  158526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  158530 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  158534 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  158538 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  158542 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  158546 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  158550 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  158554 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  158559 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  158563 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  158567 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  158571 */   // MIs[3] Operand 1
     /*  158571 */   // No operand predicates
     /*  158571 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158576 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  158578 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  158578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  158581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158583 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  158587 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  158591 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  158594 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  158601 */   GIR_RootConstrainSelectedInstOperands,
     /*  158602 */   // GIR_Coverage, 74324,
     /*  158602 */   GIR_EraseRootFromParent_Done,
     /*  158603 */ // Label 2948: @158603
     /*  158603 */ GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(158714), // Rule ID 74327 //
     /*  158608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  158611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158614 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158618 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158629 */   // MIs[0] Operand 1
     /*  158629 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  158637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  158641 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  158645 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  158649 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  158653 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  158657 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  158661 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  158665 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  158670 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  158674 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  158678 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  158682 */   // MIs[3] Operand 1
     /*  158682 */   // No operand predicates
     /*  158682 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158687 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  158689 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  158689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  158692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158694 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  158698 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  158702 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  158705 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  158712 */   GIR_RootConstrainSelectedInstOperands,
     /*  158713 */   // GIR_Coverage, 74327,
     /*  158713 */   GIR_EraseRootFromParent_Done,
     /*  158714 */ // Label 2949: @158714
     /*  158714 */ GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(158825), // Rule ID 74328 //
     /*  158719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  158722 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158725 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158729 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158740 */   // MIs[0] Operand 1
     /*  158740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158744 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  158748 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  158752 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  158756 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  158760 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  158764 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  158768 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  158772 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  158776 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  158781 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  158785 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  158789 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  158793 */   // MIs[3] Operand 1
     /*  158793 */   // No operand predicates
     /*  158793 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158798 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  158800 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  158800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  158803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158805 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  158809 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  158813 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  158816 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  158823 */   GIR_RootConstrainSelectedInstOperands,
     /*  158824 */   // GIR_Coverage, 74328,
     /*  158824 */   GIR_EraseRootFromParent_Done,
     /*  158825 */ // Label 2950: @158825
     /*  158825 */ GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(158929), // Rule ID 74329 //
     /*  158830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  158833 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158836 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158844 */   // MIs[0] Operand 1
     /*  158844 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158848 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  158852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  158856 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  158860 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  158864 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  158868 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  158872 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  158876 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  158880 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  158885 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  158889 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  158893 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  158897 */   // MIs[3] Operand 1
     /*  158897 */   // No operand predicates
     /*  158897 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158902 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  158904 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (QC_LRW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  158904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRW),
     /*  158907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158909 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  158913 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  158917 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  158920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  158927 */   GIR_RootConstrainSelectedInstOperands,
     /*  158928 */   // GIR_Coverage, 74329,
     /*  158928 */   GIR_EraseRootFromParent_Done,
     /*  158929 */ // Label 2951: @158929
     /*  158929 */ GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(159033), // Rule ID 74330 //
     /*  158934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  158937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158940 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158948 */   // MIs[0] Operand 1
     /*  158948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158952 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  158956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  158960 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  158964 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  158968 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  158972 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  158976 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  158980 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  158984 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  158989 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  158993 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  158997 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159001 */   // MIs[3] Operand 1
     /*  159001 */   // No operand predicates
     /*  159001 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159006 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159008 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (QC_LRW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  159008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRW),
     /*  159011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159013 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  159017 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159021 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159024 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159031 */   GIR_RootConstrainSelectedInstOperands,
     /*  159032 */   // GIR_Coverage, 74330,
     /*  159032 */   GIR_EraseRootFromParent_Done,
     /*  159033 */ // Label 2952: @159033
     /*  159033 */ GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(159144), // Rule ID 64548 //
     /*  159038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  159041 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159044 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159048 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159059 */   // MIs[0] Operand 1
     /*  159059 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159063 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  159067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  159071 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  159075 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  159079 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159084 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  159088 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  159092 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  159096 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  159100 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  159105 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  159109 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  159113 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159117 */   // MIs[3] Operand 1
     /*  159117 */   // No operand predicates
     /*  159117 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159119 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  159119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  159122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159124 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  159128 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159132 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159135 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159142 */   GIR_RootConstrainSelectedInstOperands,
     /*  159143 */   // GIR_Coverage, 64548,
     /*  159143 */   GIR_EraseRootFromParent_Done,
     /*  159144 */ // Label 2953: @159144
     /*  159144 */ GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(159255), // Rule ID 64549 //
     /*  159149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  159152 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159155 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159170 */   // MIs[0] Operand 1
     /*  159170 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159174 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  159178 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  159182 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  159186 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  159190 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159195 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  159199 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  159203 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  159207 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  159211 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  159216 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  159220 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  159224 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159228 */   // MIs[3] Operand 1
     /*  159228 */   // No operand predicates
     /*  159228 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159230 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  159230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  159233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159235 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  159239 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159243 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159253 */   GIR_RootConstrainSelectedInstOperands,
     /*  159254 */   // GIR_Coverage, 64549,
     /*  159254 */   GIR_EraseRootFromParent_Done,
     /*  159255 */ // Label 2954: @159255
     /*  159255 */ GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(159366), // Rule ID 64552 //
     /*  159260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  159263 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159266 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159270 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159281 */   // MIs[0] Operand 1
     /*  159281 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  159289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  159293 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  159297 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  159301 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159306 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  159310 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  159314 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  159318 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  159322 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  159327 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  159331 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  159335 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159339 */   // MIs[3] Operand 1
     /*  159339 */   // No operand predicates
     /*  159339 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159341 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  159341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  159344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159346 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  159350 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159354 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159364 */   GIR_RootConstrainSelectedInstOperands,
     /*  159365 */   // GIR_Coverage, 64552,
     /*  159365 */   GIR_EraseRootFromParent_Done,
     /*  159366 */ // Label 2955: @159366
     /*  159366 */ GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(159477), // Rule ID 64553 //
     /*  159371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  159374 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159377 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159381 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159392 */   // MIs[0] Operand 1
     /*  159392 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159396 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  159400 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  159404 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  159408 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  159412 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159417 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  159421 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  159425 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  159429 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  159433 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  159438 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  159442 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  159446 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159450 */   // MIs[3] Operand 1
     /*  159450 */   // No operand predicates
     /*  159450 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159452 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  159452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  159455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159457 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  159461 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159465 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159475 */   GIR_RootConstrainSelectedInstOperands,
     /*  159476 */   // GIR_Coverage, 64553,
     /*  159476 */   GIR_EraseRootFromParent_Done,
     /*  159477 */ // Label 2956: @159477
     /*  159477 */ GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(159581), // Rule ID 64554 //
     /*  159482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  159485 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159488 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159496 */   // MIs[0] Operand 1
     /*  159496 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159500 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  159504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  159508 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  159512 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  159516 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159521 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  159525 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  159529 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  159533 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  159537 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  159542 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  159546 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  159550 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159554 */   // MIs[3] Operand 1
     /*  159554 */   // No operand predicates
     /*  159554 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159556 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (QC_LRW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  159556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRW),
     /*  159559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159561 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  159565 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159569 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159579 */   GIR_RootConstrainSelectedInstOperands,
     /*  159580 */   // GIR_Coverage, 64554,
     /*  159580 */   GIR_EraseRootFromParent_Done,
     /*  159581 */ // Label 2957: @159581
     /*  159581 */ GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(159685), // Rule ID 64555 //
     /*  159586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  159589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159592 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159600 */   // MIs[0] Operand 1
     /*  159600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159604 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  159608 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  159612 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  159616 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  159620 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159625 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  159629 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  159633 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  159637 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  159641 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  159646 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  159650 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  159654 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159658 */   // MIs[3] Operand 1
     /*  159658 */   // No operand predicates
     /*  159658 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159660 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (QC_LRW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  159660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRW),
     /*  159663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159665 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  159669 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159673 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159676 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159683 */   GIR_RootConstrainSelectedInstOperands,
     /*  159684 */   // GIR_Coverage, 64555,
     /*  159684 */   GIR_EraseRootFromParent_Done,
     /*  159685 */ // Label 2958: @159685
     /*  159685 */ GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(159743), // Rule ID 227 //
     /*  159690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159693 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159696 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159711 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159722 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  159725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159737 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159741 */   GIR_RootConstrainSelectedInstOperands,
     /*  159742 */   // GIR_Coverage, 227,
     /*  159742 */   GIR_EraseRootFromParent_Done,
     /*  159743 */ // Label 2959: @159743
     /*  159743 */ GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(159801), // Rule ID 231 //
     /*  159748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159751 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159754 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159758 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159769 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159773 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159780 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159799 */   GIR_RootConstrainSelectedInstOperands,
     /*  159800 */   // GIR_Coverage, 231,
     /*  159800 */   GIR_EraseRootFromParent_Done,
     /*  159801 */ // Label 2960: @159801
     /*  159801 */ GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(159852), // Rule ID 232 //
     /*  159806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  159809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159812 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159824 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159831 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159850 */   GIR_RootConstrainSelectedInstOperands,
     /*  159851 */   // GIR_Coverage, 232,
     /*  159851 */   GIR_EraseRootFromParent_Done,
     /*  159852 */ // Label 2961: @159852
     /*  159852 */ GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(159903), // Rule ID 233 //
     /*  159857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159860 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159863 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159882 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159901 */   GIR_RootConstrainSelectedInstOperands,
     /*  159902 */   // GIR_Coverage, 233,
     /*  159902 */   GIR_EraseRootFromParent_Done,
     /*  159903 */ // Label 2962: @159903
     /*  159903 */ GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(159964), // Rule ID 316 //
     /*  159908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159911 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159914 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159918 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159925 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159932 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159936 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159943 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10067>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  159946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159958 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159962 */   GIR_RootConstrainSelectedInstOperands,
     /*  159963 */   // GIR_Coverage, 316,
     /*  159963 */   GIR_EraseRootFromParent_Done,
     /*  159964 */ // Label 2963: @159964
     /*  159964 */ GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(160025), // Rule ID 320 //
     /*  159969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159972 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159975 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159979 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159986 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159993 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159997 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160004 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10069>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160019 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160023 */   GIR_RootConstrainSelectedInstOperands,
     /*  160024 */   // GIR_Coverage, 320,
     /*  160024 */   GIR_EraseRootFromParent_Done,
     /*  160025 */ // Label 2964: @160025
     /*  160025 */ GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(160086), // Rule ID 334 //
     /*  160030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode1),
     /*  160033 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160036 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160040 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160047 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160054 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160058 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160065 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10081>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160084 */   GIR_RootConstrainSelectedInstOperands,
     /*  160085 */   // GIR_Coverage, 334,
     /*  160085 */   GIR_EraseRootFromParent_Done,
     /*  160086 */ // Label 2965: @160086
     /*  160086 */ GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(160147), // Rule ID 336 //
     /*  160091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  160094 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160097 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160108 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160115 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160119 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160126 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10083>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160145 */   GIR_RootConstrainSelectedInstOperands,
     /*  160146 */   // GIR_Coverage, 336,
     /*  160146 */   GIR_EraseRootFromParent_Done,
     /*  160147 */ // Label 2966: @160147
     /*  160147 */ GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(160198), // Rule ID 1427 //
     /*  160152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  160155 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160158 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  160166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160170 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160177 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  160180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160196 */   GIR_RootConstrainSelectedInstOperands,
     /*  160197 */   // GIR_Coverage, 1427,
     /*  160197 */   GIR_EraseRootFromParent_Done,
     /*  160198 */ // Label 2967: @160198
     /*  160198 */ GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(160249), // Rule ID 1428 //
     /*  160203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  160206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160209 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  160217 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160221 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160228 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  160231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160238 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160243 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160247 */   GIR_RootConstrainSelectedInstOperands,
     /*  160248 */   // GIR_Coverage, 1428,
     /*  160248 */   GIR_EraseRootFromParent_Done,
     /*  160249 */ // Label 2968: @160249
     /*  160249 */ GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(160300), // Rule ID 1433 //
     /*  160254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  160257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160260 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  160268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160272 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160279 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  160282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160294 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160298 */   GIR_RootConstrainSelectedInstOperands,
     /*  160299 */   // GIR_Coverage, 1433,
     /*  160299 */   GIR_EraseRootFromParent_Done,
     /*  160300 */ // Label 2969: @160300
     /*  160300 */ GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(160351), // Rule ID 1434 //
     /*  160305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  160308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160311 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  160319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160330 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  160333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160345 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160349 */   GIR_RootConstrainSelectedInstOperands,
     /*  160350 */   // GIR_Coverage, 1434,
     /*  160350 */   GIR_EraseRootFromParent_Done,
     /*  160351 */ // Label 2970: @160351
     /*  160351 */ GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(160409), // Rule ID 65321 //
     /*  160356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  160359 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160362 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160366 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160381 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160388 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160403 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160407 */   GIR_RootConstrainSelectedInstOperands,
     /*  160408 */   // GIR_Coverage, 65321,
     /*  160408 */   GIR_EraseRootFromParent_Done,
     /*  160409 */ // Label 2971: @160409
     /*  160409 */ GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(160467), // Rule ID 65322 //
     /*  160414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  160417 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160420 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160424 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160435 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160439 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160446 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160451 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160456 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160465 */   GIR_RootConstrainSelectedInstOperands,
     /*  160466 */   // GIR_Coverage, 65322,
     /*  160466 */   GIR_EraseRootFromParent_Done,
     /*  160467 */ // Label 2972: @160467
     /*  160467 */ GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(160525), // Rule ID 65325 //
     /*  160472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160475 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160478 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160482 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160493 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160497 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160504 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  160507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160519 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160523 */   GIR_RootConstrainSelectedInstOperands,
     /*  160524 */   // GIR_Coverage, 65325,
     /*  160524 */   GIR_EraseRootFromParent_Done,
     /*  160525 */ // Label 2973: @160525
     /*  160525 */ GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(160583), // Rule ID 65326 //
     /*  160530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  160533 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160536 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160540 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160551 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160555 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160562 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  160565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160581 */   GIR_RootConstrainSelectedInstOperands,
     /*  160582 */   // GIR_Coverage, 65326,
     /*  160582 */   GIR_EraseRootFromParent_Done,
     /*  160583 */ // Label 2974: @160583
     /*  160583 */ GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(160641), // Rule ID 65327 //
     /*  160588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160591 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160594 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160598 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160613 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160620 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160635 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160639 */   GIR_RootConstrainSelectedInstOperands,
     /*  160640 */   // GIR_Coverage, 65327,
     /*  160640 */   GIR_EraseRootFromParent_Done,
     /*  160641 */ // Label 2975: @160641
     /*  160641 */ GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(160699), // Rule ID 65328 //
     /*  160646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  160649 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160652 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160656 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160667 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160671 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160678 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160683 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160693 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160697 */   GIR_RootConstrainSelectedInstOperands,
     /*  160698 */   // GIR_Coverage, 65328,
     /*  160698 */   GIR_EraseRootFromParent_Done,
     /*  160699 */ // Label 2976: @160699
     /*  160699 */ GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(160743), // Rule ID 1092 //
     /*  160704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160707 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160710 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160714 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160728 */   // MIs[0] rs1
     /*  160728 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160736 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10571>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  160741 */   GIR_RootConstrainSelectedInstOperands,
     /*  160742 */   // GIR_Coverage, 1092,
     /*  160742 */   GIR_Done,
     /*  160743 */ // Label 2977: @160743
     /*  160743 */ GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(160787), // Rule ID 1096 //
     /*  160748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160751 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160754 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160758 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160765 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160772 */   // MIs[0] rs1
     /*  160772 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160780 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10573>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  160785 */   GIR_RootConstrainSelectedInstOperands,
     /*  160786 */   // GIR_Coverage, 1096,
     /*  160786 */   GIR_Done,
     /*  160787 */ // Label 2978: @160787
     /*  160787 */ GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(160831), // Rule ID 1100 //
     /*  160792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160795 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160798 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160802 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160816 */   // MIs[0] rs1
     /*  160816 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160824 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10575>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  160829 */   GIR_RootConstrainSelectedInstOperands,
     /*  160830 */   // GIR_Coverage, 1100,
     /*  160830 */   GIR_Done,
     /*  160831 */ // Label 2979: @160831
     /*  160831 */ GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(160875), // Rule ID 1104 //
     /*  160836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160839 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160842 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160853 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160860 */   // MIs[0] rs1
     /*  160860 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160868 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10577>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  160873 */   GIR_RootConstrainSelectedInstOperands,
     /*  160874 */   // GIR_Coverage, 1104,
     /*  160874 */   GIR_Done,
     /*  160875 */ // Label 2980: @160875
     /*  160875 */ GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(160919), // Rule ID 1120 //
     /*  160880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  160883 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160890 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160897 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160904 */   // MIs[0] rs1
     /*  160904 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160912 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10591>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160917 */   GIR_RootConstrainSelectedInstOperands,
     /*  160918 */   // GIR_Coverage, 1120,
     /*  160918 */   GIR_Done,
     /*  160919 */ // Label 2981: @160919
     /*  160919 */ GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(160963), // Rule ID 1122 //
     /*  160924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  160927 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160934 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160941 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160948 */   // MIs[0] rs1
     /*  160948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160956 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10593>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160961 */   GIR_RootConstrainSelectedInstOperands,
     /*  160962 */   // GIR_Coverage, 1122,
     /*  160962 */   GIR_Done,
     /*  160963 */ // Label 2982: @160963
     /*  160963 */ GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(161007), // Rule ID 1124 //
     /*  160968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160971 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160974 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160978 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160985 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160992 */   // MIs[0] rs1
     /*  160992 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161000 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10595>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  161000 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161005 */   GIR_RootConstrainSelectedInstOperands,
     /*  161006 */   // GIR_Coverage, 1124,
     /*  161006 */   GIR_Done,
     /*  161007 */ // Label 2983: @161007
     /*  161007 */ GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(161051), // Rule ID 1128 //
     /*  161012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  161015 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161018 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161022 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161029 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161036 */   // MIs[0] rs1
     /*  161036 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161044 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10597>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  161044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161049 */   GIR_RootConstrainSelectedInstOperands,
     /*  161050 */   // GIR_Coverage, 1128,
     /*  161050 */   GIR_Done,
     /*  161051 */ // Label 2984: @161051
     /*  161051 */ GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(161095), // Rule ID 1132 //
     /*  161056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  161059 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161062 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161066 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161080 */   // MIs[0] rs1
     /*  161080 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161088 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10599>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  161088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  161093 */   GIR_RootConstrainSelectedInstOperands,
     /*  161094 */   // GIR_Coverage, 1132,
     /*  161094 */   GIR_Done,
     /*  161095 */ // Label 2985: @161095
     /*  161095 */ GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(161139), // Rule ID 1134 //
     /*  161100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  161103 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161106 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161110 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161117 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161124 */   // MIs[0] rs1
     /*  161124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161132 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10601>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  161132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  161137 */   GIR_RootConstrainSelectedInstOperands,
     /*  161138 */   // GIR_Coverage, 1134,
     /*  161138 */   GIR_Done,
     /*  161139 */ // Label 2986: @161139
     /*  161139 */ GIM_Reject,
     /*  161140 */ // Label 2898: @161140
     /*  161140 */ GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(161198), // Rule ID 226 //
     /*  161145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  161148 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161151 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161155 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161170 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161177 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  161180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161196 */   GIR_RootConstrainSelectedInstOperands,
     /*  161197 */   // GIR_Coverage, 226,
     /*  161197 */   GIR_EraseRootFromParent_Done,
     /*  161198 */ // Label 2987: @161198
     /*  161198 */ GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(161256), // Rule ID 230 //
     /*  161203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  161206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161209 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161213 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161224 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161228 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161235 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  161238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161250 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161254 */   GIR_RootConstrainSelectedInstOperands,
     /*  161255 */   // GIR_Coverage, 230,
     /*  161255 */   GIR_EraseRootFromParent_Done,
     /*  161256 */ // Label 2988: @161256
     /*  161256 */ GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(161314), // Rule ID 276 //
     /*  161261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  161264 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161267 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161271 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161282 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161286 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161293 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  161296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161308 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161312 */   GIR_RootConstrainSelectedInstOperands,
     /*  161313 */   // GIR_Coverage, 276,
     /*  161313 */   GIR_EraseRootFromParent_Done,
     /*  161314 */ // Label 2989: @161314
     /*  161314 */ GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(161365), // Rule ID 278 //
     /*  161319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  161322 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161325 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161333 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161337 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161344 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  161347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161363 */   GIR_RootConstrainSelectedInstOperands,
     /*  161364 */   // GIR_Coverage, 278,
     /*  161364 */   GIR_EraseRootFromParent_Done,
     /*  161365 */ // Label 2990: @161365
     /*  161365 */ GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(161426), // Rule ID 315 //
     /*  161370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  161373 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161376 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161380 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161387 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161394 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161398 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161405 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10067>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  161408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161420 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161424 */   GIR_RootConstrainSelectedInstOperands,
     /*  161425 */   // GIR_Coverage, 315,
     /*  161425 */   GIR_EraseRootFromParent_Done,
     /*  161426 */ // Label 2991: @161426
     /*  161426 */ GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(161487), // Rule ID 319 //
     /*  161431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  161434 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161437 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161441 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161448 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161455 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161459 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161466 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10069>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  161469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161481 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161485 */   GIR_RootConstrainSelectedInstOperands,
     /*  161486 */   // GIR_Coverage, 319,
     /*  161486 */   GIR_EraseRootFromParent_Done,
     /*  161487 */ // Label 2992: @161487
     /*  161487 */ GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(161548), // Rule ID 333 //
     /*  161492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode0),
     /*  161495 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161498 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161502 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161509 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161520 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161527 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10081>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  161530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161542 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161546 */   GIR_RootConstrainSelectedInstOperands,
     /*  161547 */   // GIR_Coverage, 333,
     /*  161547 */   GIR_EraseRootFromParent_Done,
     /*  161548 */ // Label 2993: @161548
     /*  161548 */ GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(161609), // Rule ID 335 //
     /*  161553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  161556 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161559 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161563 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161570 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161577 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161581 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161588 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10083>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  161591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161603 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161607 */   GIR_RootConstrainSelectedInstOperands,
     /*  161608 */   // GIR_Coverage, 335,
     /*  161608 */   GIR_EraseRootFromParent_Done,
     /*  161609 */ // Label 2994: @161609
     /*  161609 */ GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(161670), // Rule ID 341 //
     /*  161614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  161617 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161620 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161624 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161631 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161638 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161642 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161649 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10087>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  161652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161664 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161668 */   GIR_RootConstrainSelectedInstOperands,
     /*  161669 */   // GIR_Coverage, 341,
     /*  161669 */   GIR_EraseRootFromParent_Done,
     /*  161670 */ // Label 2995: @161670
     /*  161670 */ GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(161721), // Rule ID 1825 //
     /*  161675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  161678 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161681 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  161689 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161693 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161700 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  161703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161715 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161719 */   GIR_RootConstrainSelectedInstOperands,
     /*  161720 */   // GIR_Coverage, 1825,
     /*  161720 */   GIR_EraseRootFromParent_Done,
     /*  161721 */ // Label 2996: @161721
     /*  161721 */ GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(161772), // Rule ID 1826 //
     /*  161726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  161729 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161732 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  161740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161751 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  161751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  161754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161770 */   GIR_RootConstrainSelectedInstOperands,
     /*  161771 */   // GIR_Coverage, 1826,
     /*  161771 */   GIR_EraseRootFromParent_Done,
     /*  161772 */ // Label 2997: @161772
     /*  161772 */ GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(161823), // Rule ID 1830 //
     /*  161777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  161780 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161783 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161791 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161795 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161802 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  161805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161821 */   GIR_RootConstrainSelectedInstOperands,
     /*  161822 */   // GIR_Coverage, 1830,
     /*  161822 */   GIR_EraseRootFromParent_Done,
     /*  161823 */ // Label 2998: @161823
     /*  161823 */ GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(161874), // Rule ID 1834 //
     /*  161828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0),
     /*  161831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  161842 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161846 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161853 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_RV32:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD_RV32),
     /*  161856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161868 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161872 */   GIR_RootConstrainSelectedInstOperands,
     /*  161873 */   // GIR_Coverage, 1834,
     /*  161873 */   GIR_EraseRootFromParent_Done,
     /*  161874 */ // Label 2999: @161874
     /*  161874 */ GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(161925), // Rule ID 1835 //
     /*  161879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1),
     /*  161882 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161885 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  161893 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161897 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161904 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_RV32:{ *:[f64] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  161904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD_RV32),
     /*  161907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161909 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161919 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161923 */   GIR_RootConstrainSelectedInstOperands,
     /*  161924 */   // GIR_Coverage, 1835,
     /*  161924 */   GIR_EraseRootFromParent_Done,
     /*  161925 */ // Label 3000: @161925
     /*  161925 */ GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(161969), // Rule ID 1091 //
     /*  161930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161933 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161936 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161940 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161947 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161954 */   // MIs[0] rs1
     /*  161954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161962 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10571>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  161967 */   GIR_RootConstrainSelectedInstOperands,
     /*  161968 */   // GIR_Coverage, 1091,
     /*  161968 */   GIR_Done,
     /*  161969 */ // Label 3001: @161969
     /*  161969 */ GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(162013), // Rule ID 1095 //
     /*  161974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161977 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161980 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161984 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161998 */   // MIs[0] rs1
     /*  161998 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162006 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10573>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162006 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  162011 */   GIR_RootConstrainSelectedInstOperands,
     /*  162012 */   // GIR_Coverage, 1095,
     /*  162012 */   GIR_Done,
     /*  162013 */ // Label 3002: @162013
     /*  162013 */ GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(162057), // Rule ID 1099 //
     /*  162018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  162021 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162024 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162028 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  162035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  162038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162042 */   // MIs[0] rs1
     /*  162042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162050 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10575>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  162055 */   GIR_RootConstrainSelectedInstOperands,
     /*  162056 */   // GIR_Coverage, 1099,
     /*  162056 */   GIR_Done,
     /*  162057 */ // Label 3003: @162057
     /*  162057 */ GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(162101), // Rule ID 1103 //
     /*  162062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  162065 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162068 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162072 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  162079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  162082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162086 */   // MIs[0] rs1
     /*  162086 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162094 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10577>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  162099 */   GIR_RootConstrainSelectedInstOperands,
     /*  162100 */   // GIR_Coverage, 1103,
     /*  162100 */   GIR_Done,
     /*  162101 */ // Label 3004: @162101
     /*  162101 */ GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(162145), // Rule ID 1119 //
     /*  162106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  162109 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162116 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  162123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  162126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162130 */   // MIs[0] rs1
     /*  162130 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162138 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10591>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162138 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  162143 */   GIR_RootConstrainSelectedInstOperands,
     /*  162144 */   // GIR_Coverage, 1119,
     /*  162144 */   GIR_Done,
     /*  162145 */ // Label 3005: @162145
     /*  162145 */ GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(162189), // Rule ID 1121 //
     /*  162150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  162153 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162156 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162160 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  162167 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  162170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162174 */   // MIs[0] rs1
     /*  162174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162182 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10593>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  162187 */   GIR_RootConstrainSelectedInstOperands,
     /*  162188 */   // GIR_Coverage, 1121,
     /*  162188 */   GIR_Done,
     /*  162189 */ // Label 3006: @162189
     /*  162189 */ GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(162233), // Rule ID 1123 //
     /*  162194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  162197 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162200 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162204 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  162211 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  162214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162218 */   // MIs[0] rs1
     /*  162218 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162226 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10595>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  162231 */   GIR_RootConstrainSelectedInstOperands,
     /*  162232 */   // GIR_Coverage, 1123,
     /*  162232 */   GIR_Done,
     /*  162233 */ // Label 3007: @162233
     /*  162233 */ GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(162277), // Rule ID 1127 //
     /*  162238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  162241 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162244 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  162255 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  162258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162262 */   // MIs[0] rs1
     /*  162262 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162270 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10597>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  162275 */   GIR_RootConstrainSelectedInstOperands,
     /*  162276 */   // GIR_Coverage, 1127,
     /*  162276 */   GIR_Done,
     /*  162277 */ // Label 3008: @162277
     /*  162277 */ GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(162321), // Rule ID 1131 //
     /*  162282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  162285 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162288 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162292 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  162299 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  162302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162306 */   // MIs[0] rs1
     /*  162306 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162314 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10599>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  162319 */   GIR_RootConstrainSelectedInstOperands,
     /*  162320 */   // GIR_Coverage, 1131,
     /*  162320 */   GIR_Done,
     /*  162321 */ // Label 3009: @162321
     /*  162321 */ GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(162365), // Rule ID 1133 //
     /*  162326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  162329 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162332 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  162343 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  162346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162350 */   // MIs[0] rs1
     /*  162350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162358 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10601>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  162363 */   GIR_RootConstrainSelectedInstOperands,
     /*  162364 */   // GIR_Coverage, 1133,
     /*  162364 */   GIR_Done,
     /*  162365 */ // Label 3010: @162365
     /*  162365 */ GIM_Reject,
     /*  162366 */ // Label 2899: @162366
     /*  162366 */ GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(162485),
     /*  162371 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162374 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162382 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  162386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162390 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(162437), // Rule ID 45734 //
     /*  162395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162398 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  162398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  162401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  162415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162435 */     GIR_RootConstrainSelectedInstOperands,
     /*  162436 */     // GIR_Coverage, 45734,
     /*  162436 */     GIR_EraseRootFromParent_Done,
     /*  162437 */   // Label 3012: @162437
     /*  162437 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(162484), // Rule ID 45735 //
     /*  162442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162445 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  162445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  162448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  162462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162482 */     GIR_RootConstrainSelectedInstOperands,
     /*  162483 */     // GIR_Coverage, 45735,
     /*  162483 */     GIR_EraseRootFromParent_Done,
     /*  162484 */   // Label 3013: @162484
     /*  162484 */   GIM_Reject,
     /*  162485 */ // Label 3011: @162485
     /*  162485 */ GIM_Reject,
     /*  162486 */ // Label 2900: @162486
     /*  162486 */ GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(162613),
     /*  162491 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162494 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162502 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(162557), // Rule ID 45730 //
     /*  162507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162510 */     // MIs[0] rs1
     /*  162510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162518 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  162518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  162521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  162535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162555 */     GIR_RootConstrainSelectedInstOperands,
     /*  162556 */     // GIR_Coverage, 45730,
     /*  162556 */     GIR_EraseRootFromParent_Done,
     /*  162557 */   // Label 3015: @162557
     /*  162557 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(162612), // Rule ID 45731 //
     /*  162562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162565 */     // MIs[0] rs1
     /*  162565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162573 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  162573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  162576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  162590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162610 */     GIR_RootConstrainSelectedInstOperands,
     /*  162611 */     // GIR_Coverage, 45731,
     /*  162611 */     GIR_EraseRootFromParent_Done,
     /*  162612 */   // Label 3016: @162612
     /*  162612 */   GIM_Reject,
     /*  162613 */ // Label 3014: @162613
     /*  162613 */ GIM_Reject,
     /*  162614 */ // Label 2901: @162614
     /*  162614 */ GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(162851),
     /*  162619 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162622 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162630 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(162685), // Rule ID 45926 //
     /*  162635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162638 */     // MIs[0] rs1
     /*  162638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162646 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162683 */     GIR_RootConstrainSelectedInstOperands,
     /*  162684 */     // GIR_Coverage, 45926,
     /*  162684 */     GIR_EraseRootFromParent_Done,
     /*  162685 */   // Label 3018: @162685
     /*  162685 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(162740), // Rule ID 45927 //
     /*  162690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162693 */     // MIs[0] rs1
     /*  162693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162701 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162738 */     GIR_RootConstrainSelectedInstOperands,
     /*  162739 */     // GIR_Coverage, 45927,
     /*  162739 */     GIR_EraseRootFromParent_Done,
     /*  162740 */   // Label 3019: @162740
     /*  162740 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(162795), // Rule ID 46002 //
     /*  162745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  162748 */     // MIs[0] rs1
     /*  162748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162756 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162793 */     GIR_RootConstrainSelectedInstOperands,
     /*  162794 */     // GIR_Coverage, 46002,
     /*  162794 */     GIR_EraseRootFromParent_Done,
     /*  162795 */   // Label 3020: @162795
     /*  162795 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(162850), // Rule ID 46003 //
     /*  162800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  162803 */     // MIs[0] rs1
     /*  162803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162811 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162848 */     GIR_RootConstrainSelectedInstOperands,
     /*  162849 */     // GIR_Coverage, 46003,
     /*  162849 */     GIR_EraseRootFromParent_Done,
     /*  162850 */   // Label 3021: @162850
     /*  162850 */   GIM_Reject,
     /*  162851 */ // Label 3017: @162851
     /*  162851 */ GIM_Reject,
     /*  162852 */ // Label 2902: @162852
     /*  162852 */ GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(163089),
     /*  162857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162868 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(162923), // Rule ID 45934 //
     /*  162873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162876 */     // MIs[0] rs1
     /*  162876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162884 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162921 */     GIR_RootConstrainSelectedInstOperands,
     /*  162922 */     // GIR_Coverage, 45934,
     /*  162922 */     GIR_EraseRootFromParent_Done,
     /*  162923 */   // Label 3023: @162923
     /*  162923 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(162978), // Rule ID 45935 //
     /*  162928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162931 */     // MIs[0] rs1
     /*  162931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162939 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  162939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162976 */     GIR_RootConstrainSelectedInstOperands,
     /*  162977 */     // GIR_Coverage, 45935,
     /*  162977 */     GIR_EraseRootFromParent_Done,
     /*  162978 */   // Label 3024: @162978
     /*  162978 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(163033), // Rule ID 46010 //
     /*  162983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  162986 */     // MIs[0] rs1
     /*  162986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162994 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  163011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163031 */     GIR_RootConstrainSelectedInstOperands,
     /*  163032 */     // GIR_Coverage, 46010,
     /*  163032 */     GIR_EraseRootFromParent_Done,
     /*  163033 */   // Label 3025: @163033
     /*  163033 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(163088), // Rule ID 46011 //
     /*  163038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  163041 */     // MIs[0] rs1
     /*  163041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163049 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  163049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  163052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  163066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163086 */     GIR_RootConstrainSelectedInstOperands,
     /*  163087 */     // GIR_Coverage, 46011,
     /*  163087 */     GIR_EraseRootFromParent_Done,
     /*  163088 */   // Label 3026: @163088
     /*  163088 */   GIM_Reject,
     /*  163089 */ // Label 3022: @163089
     /*  163089 */ GIM_Reject,
     /*  163090 */ // Label 2903: @163090
     /*  163090 */ GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(163327),
     /*  163095 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163098 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163106 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(163161), // Rule ID 45950 //
     /*  163111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  163114 */     // MIs[0] rs1
     /*  163114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163122 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  163122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  163125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  163139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163159 */     GIR_RootConstrainSelectedInstOperands,
     /*  163160 */     // GIR_Coverage, 45950,
     /*  163160 */     GIR_EraseRootFromParent_Done,
     /*  163161 */   // Label 3028: @163161
     /*  163161 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(163216), // Rule ID 45951 //
     /*  163166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  163169 */     // MIs[0] rs1
     /*  163169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163177 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  163177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  163180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  163194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163214 */     GIR_RootConstrainSelectedInstOperands,
     /*  163215 */     // GIR_Coverage, 45951,
     /*  163215 */     GIR_EraseRootFromParent_Done,
     /*  163216 */   // Label 3029: @163216
     /*  163216 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(163271), // Rule ID 46022 //
     /*  163221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  163224 */     // MIs[0] rs1
     /*  163224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163232 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  163232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  163235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  163249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163269 */     GIR_RootConstrainSelectedInstOperands,
     /*  163270 */     // GIR_Coverage, 46022,
     /*  163270 */     GIR_EraseRootFromParent_Done,
     /*  163271 */   // Label 3030: @163271
     /*  163271 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(163326), // Rule ID 46023 //
     /*  163276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  163279 */     // MIs[0] rs1
     /*  163279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163287 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  163287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  163290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  163304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163324 */     GIR_RootConstrainSelectedInstOperands,
     /*  163325 */     // GIR_Coverage, 46023,
     /*  163325 */     GIR_EraseRootFromParent_Done,
     /*  163326 */   // Label 3031: @163326
     /*  163326 */   GIM_Reject,
     /*  163327 */ // Label 3027: @163327
     /*  163327 */ GIM_Reject,
     /*  163328 */ // Label 2904: @163328
     /*  163328 */ GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(163447),
     /*  163333 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163336 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  163348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163352 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(163399), // Rule ID 46062 //
     /*  163357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163360 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  163360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  163363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  163377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163397 */     GIR_RootConstrainSelectedInstOperands,
     /*  163398 */     // GIR_Coverage, 46062,
     /*  163398 */     GIR_EraseRootFromParent_Done,
     /*  163399 */   // Label 3033: @163399
     /*  163399 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(163446), // Rule ID 46063 //
     /*  163404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163407 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  163407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  163410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  163424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163444 */     GIR_RootConstrainSelectedInstOperands,
     /*  163445 */     // GIR_Coverage, 46063,
     /*  163445 */     GIR_EraseRootFromParent_Done,
     /*  163446 */   // Label 3034: @163446
     /*  163446 */   GIM_Reject,
     /*  163447 */ // Label 3032: @163447
     /*  163447 */ GIM_Reject,
     /*  163448 */ // Label 2905: @163448
     /*  163448 */ GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(163575),
     /*  163453 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163456 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163464 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(163519), // Rule ID 45918 //
     /*  163469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163472 */     // MIs[0] rs1
     /*  163472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163480 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  163480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  163483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  163497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163517 */     GIR_RootConstrainSelectedInstOperands,
     /*  163518 */     // GIR_Coverage, 45918,
     /*  163518 */     GIR_EraseRootFromParent_Done,
     /*  163519 */   // Label 3036: @163519
     /*  163519 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(163574), // Rule ID 45919 //
     /*  163524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163527 */     // MIs[0] rs1
     /*  163527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163535 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  163535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  163538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  163552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163572 */     GIR_RootConstrainSelectedInstOperands,
     /*  163573 */     // GIR_Coverage, 45919,
     /*  163573 */     GIR_EraseRootFromParent_Done,
     /*  163574 */   // Label 3037: @163574
     /*  163574 */   GIM_Reject,
     /*  163575 */ // Label 3035: @163575
     /*  163575 */ GIM_Reject,
     /*  163576 */ // Label 2906: @163576
     /*  163576 */ GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(163813),
     /*  163581 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163584 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163592 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(163647), // Rule ID 45930 //
     /*  163597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163600 */     // MIs[0] rs1
     /*  163600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163608 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  163608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163645 */     GIR_RootConstrainSelectedInstOperands,
     /*  163646 */     // GIR_Coverage, 45930,
     /*  163646 */     GIR_EraseRootFromParent_Done,
     /*  163647 */   // Label 3039: @163647
     /*  163647 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(163702), // Rule ID 45931 //
     /*  163652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163655 */     // MIs[0] rs1
     /*  163655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163663 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163700 */     GIR_RootConstrainSelectedInstOperands,
     /*  163701 */     // GIR_Coverage, 45931,
     /*  163701 */     GIR_EraseRootFromParent_Done,
     /*  163702 */   // Label 3040: @163702
     /*  163702 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(163757), // Rule ID 46006 //
     /*  163707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  163710 */     // MIs[0] rs1
     /*  163710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163718 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  163718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163755 */     GIR_RootConstrainSelectedInstOperands,
     /*  163756 */     // GIR_Coverage, 46006,
     /*  163756 */     GIR_EraseRootFromParent_Done,
     /*  163757 */   // Label 3041: @163757
     /*  163757 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(163812), // Rule ID 46007 //
     /*  163762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  163765 */     // MIs[0] rs1
     /*  163765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163773 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163810 */     GIR_RootConstrainSelectedInstOperands,
     /*  163811 */     // GIR_Coverage, 46007,
     /*  163811 */     GIR_EraseRootFromParent_Done,
     /*  163812 */   // Label 3042: @163812
     /*  163812 */   GIM_Reject,
     /*  163813 */ // Label 3038: @163813
     /*  163813 */ GIM_Reject,
     /*  163814 */ // Label 2907: @163814
     /*  163814 */ GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(164051),
     /*  163819 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163822 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163830 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(163885), // Rule ID 45946 //
     /*  163835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163838 */     // MIs[0] rs1
     /*  163838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163846 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163883 */     GIR_RootConstrainSelectedInstOperands,
     /*  163884 */     // GIR_Coverage, 45946,
     /*  163884 */     GIR_EraseRootFromParent_Done,
     /*  163885 */   // Label 3044: @163885
     /*  163885 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(163940), // Rule ID 45947 //
     /*  163890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163893 */     // MIs[0] rs1
     /*  163893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163901 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  163901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163938 */     GIR_RootConstrainSelectedInstOperands,
     /*  163939 */     // GIR_Coverage, 45947,
     /*  163939 */     GIR_EraseRootFromParent_Done,
     /*  163940 */   // Label 3045: @163940
     /*  163940 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(163995), // Rule ID 46018 //
     /*  163945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  163948 */     // MIs[0] rs1
     /*  163948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163956 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163993 */     GIR_RootConstrainSelectedInstOperands,
     /*  163994 */     // GIR_Coverage, 46018,
     /*  163994 */     GIR_EraseRootFromParent_Done,
     /*  163995 */   // Label 3046: @163995
     /*  163995 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(164050), // Rule ID 46019 //
     /*  164000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  164003 */     // MIs[0] rs1
     /*  164003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164011 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  164014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  164028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164048 */     GIR_RootConstrainSelectedInstOperands,
     /*  164049 */     // GIR_Coverage, 46019,
     /*  164049 */     GIR_EraseRootFromParent_Done,
     /*  164050 */   // Label 3047: @164050
     /*  164050 */   GIM_Reject,
     /*  164051 */ // Label 3043: @164051
     /*  164051 */ GIM_Reject,
     /*  164052 */ // Label 2908: @164052
     /*  164052 */ GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(164289),
     /*  164057 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164060 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  164068 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(164123), // Rule ID 45990 //
     /*  164073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  164076 */     // MIs[0] rs1
     /*  164076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164084 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  164084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  164087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  164101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164121 */     GIR_RootConstrainSelectedInstOperands,
     /*  164122 */     // GIR_Coverage, 45990,
     /*  164122 */     GIR_EraseRootFromParent_Done,
     /*  164123 */   // Label 3049: @164123
     /*  164123 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(164178), // Rule ID 45991 //
     /*  164128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  164131 */     // MIs[0] rs1
     /*  164131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164139 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  164139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  164142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  164156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164176 */     GIR_RootConstrainSelectedInstOperands,
     /*  164177 */     // GIR_Coverage, 45991,
     /*  164177 */     GIR_EraseRootFromParent_Done,
     /*  164178 */   // Label 3050: @164178
     /*  164178 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(164233), // Rule ID 46050 //
     /*  164183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  164186 */     // MIs[0] rs1
     /*  164186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164194 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  164194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  164197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  164211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164231 */     GIR_RootConstrainSelectedInstOperands,
     /*  164232 */     // GIR_Coverage, 46050,
     /*  164232 */     GIR_EraseRootFromParent_Done,
     /*  164233 */   // Label 3051: @164233
     /*  164233 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(164288), // Rule ID 46051 //
     /*  164238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  164241 */     // MIs[0] rs1
     /*  164241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164249 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  164249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  164252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  164266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164286 */     GIR_RootConstrainSelectedInstOperands,
     /*  164287 */     // GIR_Coverage, 46051,
     /*  164287 */     GIR_EraseRootFromParent_Done,
     /*  164288 */   // Label 3052: @164288
     /*  164288 */   GIM_Reject,
     /*  164289 */ // Label 3048: @164289
     /*  164289 */ GIM_Reject,
     /*  164290 */ // Label 2909: @164290
     /*  164290 */ GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(164409),
     /*  164295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164298 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164306 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164314 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(164361), // Rule ID 46066 //
     /*  164319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164322 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  164322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  164325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  164339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  164352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164359 */     GIR_RootConstrainSelectedInstOperands,
     /*  164360 */     // GIR_Coverage, 46066,
     /*  164360 */     GIR_EraseRootFromParent_Done,
     /*  164361 */   // Label 3054: @164361
     /*  164361 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(164408), // Rule ID 46067 //
     /*  164366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164369 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  164369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  164372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  164386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  164399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164406 */     GIR_RootConstrainSelectedInstOperands,
     /*  164407 */     // GIR_Coverage, 46067,
     /*  164407 */     GIR_EraseRootFromParent_Done,
     /*  164408 */   // Label 3055: @164408
     /*  164408 */   GIM_Reject,
     /*  164409 */ // Label 3053: @164409
     /*  164409 */ GIM_Reject,
     /*  164410 */ // Label 2910: @164410
     /*  164410 */ GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(164537),
     /*  164415 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164418 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164426 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(164481), // Rule ID 45922 //
     /*  164431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164434 */     // MIs[0] rs1
     /*  164434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164442 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  164442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  164445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  164459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164479 */     GIR_RootConstrainSelectedInstOperands,
     /*  164480 */     // GIR_Coverage, 45922,
     /*  164480 */     GIR_EraseRootFromParent_Done,
     /*  164481 */   // Label 3057: @164481
     /*  164481 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(164536), // Rule ID 45923 //
     /*  164486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164489 */     // MIs[0] rs1
     /*  164489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164497 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  164497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  164500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  164514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164534 */     GIR_RootConstrainSelectedInstOperands,
     /*  164535 */     // GIR_Coverage, 45923,
     /*  164535 */     GIR_EraseRootFromParent_Done,
     /*  164536 */   // Label 3058: @164536
     /*  164536 */   GIM_Reject,
     /*  164537 */ // Label 3056: @164537
     /*  164537 */ GIM_Reject,
     /*  164538 */ // Label 2911: @164538
     /*  164538 */ GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(164775),
     /*  164543 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164546 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164554 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(164609), // Rule ID 45942 //
     /*  164559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164562 */     // MIs[0] rs1
     /*  164562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164570 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  164570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164607 */     GIR_RootConstrainSelectedInstOperands,
     /*  164608 */     // GIR_Coverage, 45942,
     /*  164608 */     GIR_EraseRootFromParent_Done,
     /*  164609 */   // Label 3060: @164609
     /*  164609 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(164664), // Rule ID 45943 //
     /*  164614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164617 */     // MIs[0] rs1
     /*  164617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164625 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  164625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164662 */     GIR_RootConstrainSelectedInstOperands,
     /*  164663 */     // GIR_Coverage, 45943,
     /*  164663 */     GIR_EraseRootFromParent_Done,
     /*  164664 */   // Label 3061: @164664
     /*  164664 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(164719), // Rule ID 46014 //
     /*  164669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  164672 */     // MIs[0] rs1
     /*  164672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164680 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  164680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164717 */     GIR_RootConstrainSelectedInstOperands,
     /*  164718 */     // GIR_Coverage, 46014,
     /*  164718 */     GIR_EraseRootFromParent_Done,
     /*  164719 */   // Label 3062: @164719
     /*  164719 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(164774), // Rule ID 46015 //
     /*  164724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  164727 */     // MIs[0] rs1
     /*  164727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164735 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  164735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164772 */     GIR_RootConstrainSelectedInstOperands,
     /*  164773 */     // GIR_Coverage, 46015,
     /*  164773 */     GIR_EraseRootFromParent_Done,
     /*  164774 */   // Label 3063: @164774
     /*  164774 */   GIM_Reject,
     /*  164775 */ // Label 3059: @164775
     /*  164775 */ GIM_Reject,
     /*  164776 */ // Label 2912: @164776
     /*  164776 */ GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(165013),
     /*  164781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164784 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  164792 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(164847), // Rule ID 45978 //
     /*  164797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164800 */     // MIs[0] rs1
     /*  164800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164808 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  164808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164845 */     GIR_RootConstrainSelectedInstOperands,
     /*  164846 */     // GIR_Coverage, 45978,
     /*  164846 */     GIR_EraseRootFromParent_Done,
     /*  164847 */   // Label 3065: @164847
     /*  164847 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(164902), // Rule ID 45979 //
     /*  164852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164855 */     // MIs[0] rs1
     /*  164855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164863 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164900 */     GIR_RootConstrainSelectedInstOperands,
     /*  164901 */     // GIR_Coverage, 45979,
     /*  164901 */     GIR_EraseRootFromParent_Done,
     /*  164902 */   // Label 3066: @164902
     /*  164902 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(164957), // Rule ID 46038 //
     /*  164907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  164910 */     // MIs[0] rs1
     /*  164910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164918 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  164918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164955 */     GIR_RootConstrainSelectedInstOperands,
     /*  164956 */     // GIR_Coverage, 46038,
     /*  164956 */     GIR_EraseRootFromParent_Done,
     /*  164957 */   // Label 3067: @164957
     /*  164957 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(165012), // Rule ID 46039 //
     /*  164962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  164965 */     // MIs[0] rs1
     /*  164965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164973 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165010 */     GIR_RootConstrainSelectedInstOperands,
     /*  165011 */     // GIR_Coverage, 46039,
     /*  165011 */     GIR_EraseRootFromParent_Done,
     /*  165012 */   // Label 3068: @165012
     /*  165012 */   GIM_Reject,
     /*  165013 */ // Label 3064: @165013
     /*  165013 */ GIM_Reject,
     /*  165014 */ // Label 2913: @165014
     /*  165014 */ GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(165251),
     /*  165019 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165022 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165030 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(165085), // Rule ID 45994 //
     /*  165035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  165038 */     // MIs[0] rs1
     /*  165038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165046 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  165046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  165049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  165063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165083 */     GIR_RootConstrainSelectedInstOperands,
     /*  165084 */     // GIR_Coverage, 45994,
     /*  165084 */     GIR_EraseRootFromParent_Done,
     /*  165085 */   // Label 3070: @165085
     /*  165085 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(165140), // Rule ID 45995 //
     /*  165090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  165093 */     // MIs[0] rs1
     /*  165093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165101 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  165101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  165104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  165118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165138 */     GIR_RootConstrainSelectedInstOperands,
     /*  165139 */     // GIR_Coverage, 45995,
     /*  165139 */     GIR_EraseRootFromParent_Done,
     /*  165140 */   // Label 3071: @165140
     /*  165140 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(165195), // Rule ID 46054 //
     /*  165145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  165148 */     // MIs[0] rs1
     /*  165148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165156 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  165156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  165159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  165173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165193 */     GIR_RootConstrainSelectedInstOperands,
     /*  165194 */     // GIR_Coverage, 46054,
     /*  165194 */     GIR_EraseRootFromParent_Done,
     /*  165195 */   // Label 3072: @165195
     /*  165195 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(165250), // Rule ID 46055 //
     /*  165200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  165203 */     // MIs[0] rs1
     /*  165203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165211 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  165211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  165214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  165228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165248 */     GIR_RootConstrainSelectedInstOperands,
     /*  165249 */     // GIR_Coverage, 46055,
     /*  165249 */     GIR_EraseRootFromParent_Done,
     /*  165250 */   // Label 3073: @165250
     /*  165250 */   GIM_Reject,
     /*  165251 */ // Label 3069: @165251
     /*  165251 */ GIM_Reject,
     /*  165252 */ // Label 2914: @165252
     /*  165252 */ GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(165371),
     /*  165257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165260 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  165272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165276 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(165323), // Rule ID 46070 //
     /*  165281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165284 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  165284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  165287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  165301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  165314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165321 */     GIR_RootConstrainSelectedInstOperands,
     /*  165322 */     // GIR_Coverage, 46070,
     /*  165322 */     GIR_EraseRootFromParent_Done,
     /*  165323 */   // Label 3075: @165323
     /*  165323 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(165370), // Rule ID 46071 //
     /*  165328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165331 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  165331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  165334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  165348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  165361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165368 */     GIR_RootConstrainSelectedInstOperands,
     /*  165369 */     // GIR_Coverage, 46071,
     /*  165369 */     GIR_EraseRootFromParent_Done,
     /*  165370 */   // Label 3076: @165370
     /*  165370 */   GIM_Reject,
     /*  165371 */ // Label 3074: @165371
     /*  165371 */ GIM_Reject,
     /*  165372 */ // Label 2915: @165372
     /*  165372 */ GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(165499),
     /*  165377 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165380 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165388 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(165443), // Rule ID 45938 //
     /*  165393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165396 */     // MIs[0] rs1
     /*  165396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165404 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  165404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  165407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  165421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165441 */     GIR_RootConstrainSelectedInstOperands,
     /*  165442 */     // GIR_Coverage, 45938,
     /*  165442 */     GIR_EraseRootFromParent_Done,
     /*  165443 */   // Label 3078: @165443
     /*  165443 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(165498), // Rule ID 45939 //
     /*  165448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165451 */     // MIs[0] rs1
     /*  165451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165459 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  165459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  165462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  165476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165496 */     GIR_RootConstrainSelectedInstOperands,
     /*  165497 */     // GIR_Coverage, 45939,
     /*  165497 */     GIR_EraseRootFromParent_Done,
     /*  165498 */   // Label 3079: @165498
     /*  165498 */   GIM_Reject,
     /*  165499 */ // Label 3077: @165499
     /*  165499 */ GIM_Reject,
     /*  165500 */ // Label 2916: @165500
     /*  165500 */ GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(165737),
     /*  165505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165516 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(165571), // Rule ID 45966 //
     /*  165521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165524 */     // MIs[0] rs1
     /*  165524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165532 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  165532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165569 */     GIR_RootConstrainSelectedInstOperands,
     /*  165570 */     // GIR_Coverage, 45966,
     /*  165570 */     GIR_EraseRootFromParent_Done,
     /*  165571 */   // Label 3081: @165571
     /*  165571 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(165626), // Rule ID 45967 //
     /*  165576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165579 */     // MIs[0] rs1
     /*  165579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165587 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  165587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165624 */     GIR_RootConstrainSelectedInstOperands,
     /*  165625 */     // GIR_Coverage, 45967,
     /*  165625 */     GIR_EraseRootFromParent_Done,
     /*  165626 */   // Label 3082: @165626
     /*  165626 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(165681), // Rule ID 46026 //
     /*  165631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  165634 */     // MIs[0] rs1
     /*  165634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165642 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  165642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165679 */     GIR_RootConstrainSelectedInstOperands,
     /*  165680 */     // GIR_Coverage, 46026,
     /*  165680 */     GIR_EraseRootFromParent_Done,
     /*  165681 */   // Label 3083: @165681
     /*  165681 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(165736), // Rule ID 46027 //
     /*  165686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  165689 */     // MIs[0] rs1
     /*  165689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165697 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  165697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165734 */     GIR_RootConstrainSelectedInstOperands,
     /*  165735 */     // GIR_Coverage, 46027,
     /*  165735 */     GIR_EraseRootFromParent_Done,
     /*  165736 */   // Label 3084: @165736
     /*  165736 */   GIM_Reject,
     /*  165737 */ // Label 3080: @165737
     /*  165737 */ GIM_Reject,
     /*  165738 */ // Label 2917: @165738
     /*  165738 */ GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(165975),
     /*  165743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165746 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165754 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(165809), // Rule ID 45982 //
     /*  165759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165762 */     // MIs[0] rs1
     /*  165762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165770 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  165770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165807 */     GIR_RootConstrainSelectedInstOperands,
     /*  165808 */     // GIR_Coverage, 45982,
     /*  165808 */     GIR_EraseRootFromParent_Done,
     /*  165809 */   // Label 3086: @165809
     /*  165809 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(165864), // Rule ID 45983 //
     /*  165814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165817 */     // MIs[0] rs1
     /*  165817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165825 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  165825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165862 */     GIR_RootConstrainSelectedInstOperands,
     /*  165863 */     // GIR_Coverage, 45983,
     /*  165863 */     GIR_EraseRootFromParent_Done,
     /*  165864 */   // Label 3087: @165864
     /*  165864 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(165919), // Rule ID 46042 //
     /*  165869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  165872 */     // MIs[0] rs1
     /*  165872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165880 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  165880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165917 */     GIR_RootConstrainSelectedInstOperands,
     /*  165918 */     // GIR_Coverage, 46042,
     /*  165918 */     GIR_EraseRootFromParent_Done,
     /*  165919 */   // Label 3088: @165919
     /*  165919 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(165974), // Rule ID 46043 //
     /*  165924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  165927 */     // MIs[0] rs1
     /*  165927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165935 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  165935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165972 */     GIR_RootConstrainSelectedInstOperands,
     /*  165973 */     // GIR_Coverage, 46043,
     /*  165973 */     GIR_EraseRootFromParent_Done,
     /*  165974 */   // Label 3089: @165974
     /*  165974 */   GIM_Reject,
     /*  165975 */ // Label 3085: @165975
     /*  165975 */ GIM_Reject,
     /*  165976 */ // Label 2918: @165976
     /*  165976 */ GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(166213),
     /*  165981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165984 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  165992 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(166047), // Rule ID 45998 //
     /*  165997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  166000 */     // MIs[0] rs1
     /*  166000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166008 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  166008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  166011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  166025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166045 */     GIR_RootConstrainSelectedInstOperands,
     /*  166046 */     // GIR_Coverage, 45998,
     /*  166046 */     GIR_EraseRootFromParent_Done,
     /*  166047 */   // Label 3091: @166047
     /*  166047 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(166102), // Rule ID 45999 //
     /*  166052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  166055 */     // MIs[0] rs1
     /*  166055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166063 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  166063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  166066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  166080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166100 */     GIR_RootConstrainSelectedInstOperands,
     /*  166101 */     // GIR_Coverage, 45999,
     /*  166101 */     GIR_EraseRootFromParent_Done,
     /*  166102 */   // Label 3092: @166102
     /*  166102 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(166157), // Rule ID 46058 //
     /*  166107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  166110 */     // MIs[0] rs1
     /*  166110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166118 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  166118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  166121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  166135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166155 */     GIR_RootConstrainSelectedInstOperands,
     /*  166156 */     // GIR_Coverage, 46058,
     /*  166156 */     GIR_EraseRootFromParent_Done,
     /*  166157 */   // Label 3093: @166157
     /*  166157 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(166212), // Rule ID 46059 //
     /*  166162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  166165 */     // MIs[0] rs1
     /*  166165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166173 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  166173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  166176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  166190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166210 */     GIR_RootConstrainSelectedInstOperands,
     /*  166211 */     // GIR_Coverage, 46059,
     /*  166211 */     GIR_EraseRootFromParent_Done,
     /*  166212 */   // Label 3094: @166212
     /*  166212 */   GIM_Reject,
     /*  166213 */ // Label 3090: @166213
     /*  166213 */ GIM_Reject,
     /*  166214 */ // Label 2919: @166214
     /*  166214 */ GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(166333),
     /*  166219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166222 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166238 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(166285), // Rule ID 46074 //
     /*  166243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166246 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  166246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  166249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  166263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166283 */     GIR_RootConstrainSelectedInstOperands,
     /*  166284 */     // GIR_Coverage, 46074,
     /*  166284 */     GIR_EraseRootFromParent_Done,
     /*  166285 */   // Label 3096: @166285
     /*  166285 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(166332), // Rule ID 46075 //
     /*  166290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166293 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  166293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  166296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  166310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166330 */     GIR_RootConstrainSelectedInstOperands,
     /*  166331 */     // GIR_Coverage, 46075,
     /*  166331 */     GIR_EraseRootFromParent_Done,
     /*  166332 */   // Label 3097: @166332
     /*  166332 */   GIM_Reject,
     /*  166333 */ // Label 3095: @166333
     /*  166333 */ GIM_Reject,
     /*  166334 */ // Label 2920: @166334
     /*  166334 */ GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(166461),
     /*  166339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166342 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  166350 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(166405), // Rule ID 45954 //
     /*  166355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166358 */     // MIs[0] rs1
     /*  166358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166366 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  166366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  166369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  166383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166403 */     GIR_RootConstrainSelectedInstOperands,
     /*  166404 */     // GIR_Coverage, 45954,
     /*  166404 */     GIR_EraseRootFromParent_Done,
     /*  166405 */   // Label 3099: @166405
     /*  166405 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(166460), // Rule ID 45955 //
     /*  166410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166413 */     // MIs[0] rs1
     /*  166413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166421 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  166421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  166424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  166438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166458 */     GIR_RootConstrainSelectedInstOperands,
     /*  166459 */     // GIR_Coverage, 45955,
     /*  166459 */     GIR_EraseRootFromParent_Done,
     /*  166460 */   // Label 3100: @166460
     /*  166460 */   GIM_Reject,
     /*  166461 */ // Label 3098: @166461
     /*  166461 */ GIM_Reject,
     /*  166462 */ // Label 2921: @166462
     /*  166462 */ GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(166699),
     /*  166467 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166470 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166478 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(166533), // Rule ID 45970 //
     /*  166483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166486 */     // MIs[0] rs1
     /*  166486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166494 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166531 */     GIR_RootConstrainSelectedInstOperands,
     /*  166532 */     // GIR_Coverage, 45970,
     /*  166532 */     GIR_EraseRootFromParent_Done,
     /*  166533 */   // Label 3102: @166533
     /*  166533 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(166588), // Rule ID 45971 //
     /*  166538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166541 */     // MIs[0] rs1
     /*  166541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166549 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166586 */     GIR_RootConstrainSelectedInstOperands,
     /*  166587 */     // GIR_Coverage, 45971,
     /*  166587 */     GIR_EraseRootFromParent_Done,
     /*  166588 */   // Label 3103: @166588
     /*  166588 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(166643), // Rule ID 46030 //
     /*  166593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  166596 */     // MIs[0] rs1
     /*  166596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166604 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166641 */     GIR_RootConstrainSelectedInstOperands,
     /*  166642 */     // GIR_Coverage, 46030,
     /*  166642 */     GIR_EraseRootFromParent_Done,
     /*  166643 */   // Label 3104: @166643
     /*  166643 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(166698), // Rule ID 46031 //
     /*  166648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  166651 */     // MIs[0] rs1
     /*  166651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166659 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166696 */     GIR_RootConstrainSelectedInstOperands,
     /*  166697 */     // GIR_Coverage, 46031,
     /*  166697 */     GIR_EraseRootFromParent_Done,
     /*  166698 */   // Label 3105: @166698
     /*  166698 */   GIM_Reject,
     /*  166699 */ // Label 3101: @166699
     /*  166699 */ GIM_Reject,
     /*  166700 */ // Label 2922: @166700
     /*  166700 */ GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(166937),
     /*  166705 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166708 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166716 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(166771), // Rule ID 45986 //
     /*  166721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166724 */     // MIs[0] rs1
     /*  166724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166732 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  166732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166769 */     GIR_RootConstrainSelectedInstOperands,
     /*  166770 */     // GIR_Coverage, 45986,
     /*  166770 */     GIR_EraseRootFromParent_Done,
     /*  166771 */   // Label 3107: @166771
     /*  166771 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(166826), // Rule ID 45987 //
     /*  166776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166779 */     // MIs[0] rs1
     /*  166779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166787 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  166787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166824 */     GIR_RootConstrainSelectedInstOperands,
     /*  166825 */     // GIR_Coverage, 45987,
     /*  166825 */     GIR_EraseRootFromParent_Done,
     /*  166826 */   // Label 3108: @166826
     /*  166826 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(166881), // Rule ID 46046 //
     /*  166831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  166834 */     // MIs[0] rs1
     /*  166834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166842 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  166842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166879 */     GIR_RootConstrainSelectedInstOperands,
     /*  166880 */     // GIR_Coverage, 46046,
     /*  166880 */     GIR_EraseRootFromParent_Done,
     /*  166881 */   // Label 3109: @166881
     /*  166881 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(166936), // Rule ID 46047 //
     /*  166886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  166889 */     // MIs[0] rs1
     /*  166889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166897 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  166897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166934 */     GIR_RootConstrainSelectedInstOperands,
     /*  166935 */     // GIR_Coverage, 46047,
     /*  166935 */     GIR_EraseRootFromParent_Done,
     /*  166936 */   // Label 3110: @166936
     /*  166936 */   GIM_Reject,
     /*  166937 */ // Label 3106: @166937
     /*  166937 */ GIM_Reject,
     /*  166938 */ // Label 2923: @166938
     /*  166938 */ GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(167057),
     /*  166943 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166946 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166962 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(167009), // Rule ID 46078 //
     /*  166967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166970 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  166970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  166973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  166987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  167000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167007 */     GIR_RootConstrainSelectedInstOperands,
     /*  167008 */     // GIR_Coverage, 46078,
     /*  167008 */     GIR_EraseRootFromParent_Done,
     /*  167009 */   // Label 3112: @167009
     /*  167009 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(167056), // Rule ID 46079 //
     /*  167014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167017 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  167017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  167020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  167034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  167047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167054 */     GIR_RootConstrainSelectedInstOperands,
     /*  167055 */     // GIR_Coverage, 46079,
     /*  167055 */     GIR_EraseRootFromParent_Done,
     /*  167056 */   // Label 3113: @167056
     /*  167056 */   GIM_Reject,
     /*  167057 */ // Label 3111: @167057
     /*  167057 */ GIM_Reject,
     /*  167058 */ // Label 2924: @167058
     /*  167058 */ GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(167185),
     /*  167063 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167066 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  167074 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(167129), // Rule ID 45958 //
     /*  167079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167082 */     // MIs[0] rs1
     /*  167082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167090 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  167090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  167093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  167107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167127 */     GIR_RootConstrainSelectedInstOperands,
     /*  167128 */     // GIR_Coverage, 45958,
     /*  167128 */     GIR_EraseRootFromParent_Done,
     /*  167129 */   // Label 3115: @167129
     /*  167129 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(167184), // Rule ID 45959 //
     /*  167134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167137 */     // MIs[0] rs1
     /*  167137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167145 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  167145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  167148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  167162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167182 */     GIR_RootConstrainSelectedInstOperands,
     /*  167183 */     // GIR_Coverage, 45959,
     /*  167183 */     GIR_EraseRootFromParent_Done,
     /*  167184 */   // Label 3116: @167184
     /*  167184 */   GIM_Reject,
     /*  167185 */ // Label 3114: @167185
     /*  167185 */ GIM_Reject,
     /*  167186 */ // Label 2925: @167186
     /*  167186 */ GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(167423),
     /*  167191 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167194 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  167202 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(167257), // Rule ID 45974 //
     /*  167207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167210 */     // MIs[0] rs1
     /*  167210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167218 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  167218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  167221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  167235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167255 */     GIR_RootConstrainSelectedInstOperands,
     /*  167256 */     // GIR_Coverage, 45974,
     /*  167256 */     GIR_EraseRootFromParent_Done,
     /*  167257 */   // Label 3118: @167257
     /*  167257 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(167312), // Rule ID 45975 //
     /*  167262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167265 */     // MIs[0] rs1
     /*  167265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167273 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  167273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  167276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  167290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167310 */     GIR_RootConstrainSelectedInstOperands,
     /*  167311 */     // GIR_Coverage, 45975,
     /*  167311 */     GIR_EraseRootFromParent_Done,
     /*  167312 */   // Label 3119: @167312
     /*  167312 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(167367), // Rule ID 46034 //
     /*  167317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  167320 */     // MIs[0] rs1
     /*  167320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167328 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  167328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  167331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  167345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167365 */     GIR_RootConstrainSelectedInstOperands,
     /*  167366 */     // GIR_Coverage, 46034,
     /*  167366 */     GIR_EraseRootFromParent_Done,
     /*  167367 */   // Label 3120: @167367
     /*  167367 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(167422), // Rule ID 46035 //
     /*  167372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  167375 */     // MIs[0] rs1
     /*  167375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167383 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  167383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  167386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  167400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167420 */     GIR_RootConstrainSelectedInstOperands,
     /*  167421 */     // GIR_Coverage, 46035,
     /*  167421 */     GIR_EraseRootFromParent_Done,
     /*  167422 */   // Label 3121: @167422
     /*  167422 */   GIM_Reject,
     /*  167423 */ // Label 3117: @167423
     /*  167423 */ GIM_Reject,
     /*  167424 */ // Label 2926: @167424
     /*  167424 */ GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(167543),
     /*  167429 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167432 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167440 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167448 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(167495), // Rule ID 46082 //
     /*  167453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167456 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  167456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  167459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  167473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  167486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167493 */     GIR_RootConstrainSelectedInstOperands,
     /*  167494 */     // GIR_Coverage, 46082,
     /*  167494 */     GIR_EraseRootFromParent_Done,
     /*  167495 */   // Label 3123: @167495
     /*  167495 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(167542), // Rule ID 46083 //
     /*  167500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167503 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  167503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  167506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  167520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  167533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167540 */     GIR_RootConstrainSelectedInstOperands,
     /*  167541 */     // GIR_Coverage, 46083,
     /*  167541 */     GIR_EraseRootFromParent_Done,
     /*  167542 */   // Label 3124: @167542
     /*  167542 */   GIM_Reject,
     /*  167543 */ // Label 3122: @167543
     /*  167543 */ GIM_Reject,
     /*  167544 */ // Label 2927: @167544
     /*  167544 */ GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(167671),
     /*  167549 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167552 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  167560 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(167615), // Rule ID 45962 //
     /*  167565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167568 */     // MIs[0] rs1
     /*  167568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167576 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  167576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  167579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  167593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167613 */     GIR_RootConstrainSelectedInstOperands,
     /*  167614 */     // GIR_Coverage, 45962,
     /*  167614 */     GIR_EraseRootFromParent_Done,
     /*  167615 */   // Label 3126: @167615
     /*  167615 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(167670), // Rule ID 45963 //
     /*  167620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167623 */     // MIs[0] rs1
     /*  167623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167631 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  167631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  167634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  167648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167668 */     GIR_RootConstrainSelectedInstOperands,
     /*  167669 */     // GIR_Coverage, 45963,
     /*  167669 */     GIR_EraseRootFromParent_Done,
     /*  167670 */   // Label 3127: @167670
     /*  167670 */   GIM_Reject,
     /*  167671 */ // Label 3125: @167671
     /*  167671 */ GIM_Reject,
     /*  167672 */ // Label 2928: @167672
     /*  167672 */ GIM_Reject,
     /*  167673 */ // Label 22: @167673
     /*  167673 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3130*/ GIMT_Encode4(169642),
     /*  167684 */ /*GILLT_s32*//*Label 3128*/ GIMT_Encode4(167692),
     /*  167688 */ /*GILLT_s64*//*Label 3129*/ GIMT_Encode4(169068),
     /*  167692 */ // Label 3128: @167692
     /*  167692 */ GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(167799), // Rule ID 74321 //
     /*  167697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  167700 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167703 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167714 */   // MIs[0] Operand 1
     /*  167714 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167718 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  167722 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  167726 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  167730 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  167734 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  167738 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  167742 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  167746 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  167750 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  167755 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  167759 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  167763 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  167767 */   // MIs[3] Operand 1
     /*  167767 */   // No operand predicates
     /*  167767 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167772 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  167774 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (QC_LRB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  167774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRB),
     /*  167777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167779 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  167783 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  167787 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  167790 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  167797 */   GIR_RootConstrainSelectedInstOperands,
     /*  167798 */   // GIR_Coverage, 74321,
     /*  167798 */   GIR_EraseRootFromParent_Done,
     /*  167799 */ // Label 3131: @167799
     /*  167799 */ GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(167906), // Rule ID 74322 //
     /*  167804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  167807 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167810 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167821 */   // MIs[0] Operand 1
     /*  167821 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167825 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  167829 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  167833 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  167837 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  167841 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  167845 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  167849 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  167853 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  167857 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  167862 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  167866 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  167870 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  167874 */   // MIs[3] Operand 1
     /*  167874 */   // No operand predicates
     /*  167874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167879 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  167881 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (QC_LRB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  167881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRB),
     /*  167884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167886 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  167890 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  167894 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  167897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  167904 */   GIR_RootConstrainSelectedInstOperands,
     /*  167905 */   // GIR_Coverage, 74322,
     /*  167905 */   GIR_EraseRootFromParent_Done,
     /*  167906 */ // Label 3132: @167906
     /*  167906 */ GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(168013), // Rule ID 74325 //
     /*  167911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  167914 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167917 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167928 */   // MIs[0] Operand 1
     /*  167928 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167932 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  167936 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  167940 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  167944 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  167948 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  167952 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  167956 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  167960 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  167964 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  167969 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  167973 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  167977 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  167981 */   // MIs[3] Operand 1
     /*  167981 */   // No operand predicates
     /*  167981 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167986 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  167988 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  167988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  167991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167993 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  167997 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168001 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168011 */   GIR_RootConstrainSelectedInstOperands,
     /*  168012 */   // GIR_Coverage, 74325,
     /*  168012 */   GIR_EraseRootFromParent_Done,
     /*  168013 */ // Label 3133: @168013
     /*  168013 */ GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(168120), // Rule ID 74326 //
     /*  168018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  168021 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168024 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168035 */   // MIs[0] Operand 1
     /*  168035 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168039 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168043 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168047 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168051 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168055 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  168059 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168063 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168067 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  168071 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168076 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168080 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168084 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168088 */   // MIs[3] Operand 1
     /*  168088 */   // No operand predicates
     /*  168088 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168093 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168095 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  168095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  168098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168100 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  168104 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168108 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168111 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168118 */   GIR_RootConstrainSelectedInstOperands,
     /*  168119 */   // GIR_Coverage, 74326,
     /*  168119 */   GIR_EraseRootFromParent_Done,
     /*  168120 */ // Label 3134: @168120
     /*  168120 */ GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(168227), // Rule ID 64546 //
     /*  168125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  168128 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168131 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168142 */   // MIs[0] Operand 1
     /*  168142 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168146 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168150 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168154 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168158 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168162 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168167 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  168171 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168175 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168179 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  168183 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168188 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168192 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168196 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168200 */   // MIs[3] Operand 1
     /*  168200 */   // No operand predicates
     /*  168200 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168202 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (QC_LRB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  168202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRB),
     /*  168205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168207 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  168211 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168215 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168218 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168225 */   GIR_RootConstrainSelectedInstOperands,
     /*  168226 */   // GIR_Coverage, 64546,
     /*  168226 */   GIR_EraseRootFromParent_Done,
     /*  168227 */ // Label 3135: @168227
     /*  168227 */ GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(168334), // Rule ID 64547 //
     /*  168232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  168235 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168238 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168249 */   // MIs[0] Operand 1
     /*  168249 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168261 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168265 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168269 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168274 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  168278 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168282 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168286 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  168290 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168295 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168299 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168303 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168307 */   // MIs[3] Operand 1
     /*  168307 */   // No operand predicates
     /*  168307 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168309 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (QC_LRB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  168309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRB),
     /*  168312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168314 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  168318 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168322 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168325 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168332 */   GIR_RootConstrainSelectedInstOperands,
     /*  168333 */   // GIR_Coverage, 64547,
     /*  168333 */   GIR_EraseRootFromParent_Done,
     /*  168334 */ // Label 3136: @168334
     /*  168334 */ GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(168441), // Rule ID 64550 //
     /*  168339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  168342 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168345 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168356 */   // MIs[0] Operand 1
     /*  168356 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168360 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168364 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168368 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168372 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168376 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168381 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  168385 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168389 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168393 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  168397 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168402 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168406 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168410 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168414 */   // MIs[3] Operand 1
     /*  168414 */   // No operand predicates
     /*  168414 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168416 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  168416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  168419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168421 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  168425 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168429 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168432 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168439 */   GIR_RootConstrainSelectedInstOperands,
     /*  168440 */   // GIR_Coverage, 64550,
     /*  168440 */   GIR_EraseRootFromParent_Done,
     /*  168441 */ // Label 3137: @168441
     /*  168441 */ GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(168548), // Rule ID 64551 //
     /*  168446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  168449 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168463 */   // MIs[0] Operand 1
     /*  168463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168475 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168479 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168483 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168488 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  168492 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168496 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168500 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  168504 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168509 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168513 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168517 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168521 */   // MIs[3] Operand 1
     /*  168521 */   // No operand predicates
     /*  168521 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168523 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  168523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  168526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168528 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  168532 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168536 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168539 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168546 */   GIR_RootConstrainSelectedInstOperands,
     /*  168547 */   // GIR_Coverage, 64551,
     /*  168547 */   GIR_EraseRootFromParent_Done,
     /*  168548 */ // Label 3138: @168548
     /*  168548 */ GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(168602), // Rule ID 225 //
     /*  168553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  168556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168559 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168574 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168581 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  168584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168600 */   GIR_RootConstrainSelectedInstOperands,
     /*  168601 */   // GIR_Coverage, 225,
     /*  168601 */   GIR_EraseRootFromParent_Done,
     /*  168602 */ // Label 3139: @168602
     /*  168602 */ GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(168656), // Rule ID 229 //
     /*  168607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  168610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168613 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168635 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  168638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168650 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168654 */   GIR_RootConstrainSelectedInstOperands,
     /*  168655 */   // GIR_Coverage, 229,
     /*  168655 */   GIR_EraseRootFromParent_Done,
     /*  168656 */ // Label 3140: @168656
     /*  168656 */ GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(168713), // Rule ID 318 //
     /*  168661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  168664 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168667 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168674 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168681 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168685 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168692 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10067>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  168695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168711 */   GIR_RootConstrainSelectedInstOperands,
     /*  168712 */   // GIR_Coverage, 318,
     /*  168712 */   GIR_EraseRootFromParent_Done,
     /*  168713 */ // Label 3141: @168713
     /*  168713 */ GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(168770), // Rule ID 322 //
     /*  168718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  168721 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168724 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168731 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168749 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10069>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  168752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168768 */   GIR_RootConstrainSelectedInstOperands,
     /*  168769 */   // GIR_Coverage, 322,
     /*  168769 */   GIR_EraseRootFromParent_Done,
     /*  168770 */ // Label 3142: @168770
     /*  168770 */ GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(168827), // Rule ID 338 //
     /*  168775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  168778 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168781 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168788 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168806 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10083>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  168809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168821 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168825 */   GIR_RootConstrainSelectedInstOperands,
     /*  168826 */   // GIR_Coverage, 338,
     /*  168826 */   GIR_EraseRootFromParent_Done,
     /*  168827 */ // Label 3143: @168827
     /*  168827 */ GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(168867), // Rule ID 1094 //
     /*  168832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  168835 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168838 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168852 */   // MIs[0] rs1
     /*  168852 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168860 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10571>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  168860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  168865 */   GIR_RootConstrainSelectedInstOperands,
     /*  168866 */   // GIR_Coverage, 1094,
     /*  168866 */   GIR_Done,
     /*  168867 */ // Label 3144: @168867
     /*  168867 */ GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(168907), // Rule ID 1098 //
     /*  168872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  168875 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168878 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168885 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  168888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168892 */   // MIs[0] rs1
     /*  168892 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168900 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10573>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  168900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  168905 */   GIR_RootConstrainSelectedInstOperands,
     /*  168906 */   // GIR_Coverage, 1098,
     /*  168906 */   GIR_Done,
     /*  168907 */ // Label 3145: @168907
     /*  168907 */ GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(168947), // Rule ID 1102 //
     /*  168912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  168915 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168918 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168925 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168932 */   // MIs[0] rs1
     /*  168932 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168940 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10575>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  168940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  168945 */   GIR_RootConstrainSelectedInstOperands,
     /*  168946 */   // GIR_Coverage, 1102,
     /*  168946 */   GIR_Done,
     /*  168947 */ // Label 3146: @168947
     /*  168947 */ GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(168987), // Rule ID 1106 //
     /*  168952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  168955 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168958 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  168968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168972 */   // MIs[0] rs1
     /*  168972 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168980 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10577>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  168980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  168985 */   GIR_RootConstrainSelectedInstOperands,
     /*  168986 */   // GIR_Coverage, 1106,
     /*  168986 */   GIR_Done,
     /*  168987 */ // Label 3147: @168987
     /*  168987 */ GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(169027), // Rule ID 1126 //
     /*  168992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  168995 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168998 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169005 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169012 */   // MIs[0] rs1
     /*  169012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  169016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169020 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10595>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  169020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  169025 */   GIR_RootConstrainSelectedInstOperands,
     /*  169026 */   // GIR_Coverage, 1126,
     /*  169026 */   GIR_Done,
     /*  169027 */ // Label 3148: @169027
     /*  169027 */ GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(169067), // Rule ID 1130 //
     /*  169032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  169035 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169038 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169045 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  169048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169052 */   // MIs[0] rs1
     /*  169052 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  169056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169060 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10597>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  169060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  169065 */   GIR_RootConstrainSelectedInstOperands,
     /*  169066 */   // GIR_Coverage, 1130,
     /*  169066 */   GIR_Done,
     /*  169067 */ // Label 3149: @169067
     /*  169067 */ GIM_Reject,
     /*  169068 */ // Label 3129: @169068
     /*  169068 */ GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(169122), // Rule ID 224 //
     /*  169073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169079 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169090 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169094 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169101 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  169104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169116 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169120 */   GIR_RootConstrainSelectedInstOperands,
     /*  169121 */   // GIR_Coverage, 224,
     /*  169121 */   GIR_EraseRootFromParent_Done,
     /*  169122 */ // Label 3150: @169122
     /*  169122 */ GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(169176), // Rule ID 228 //
     /*  169127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169130 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169133 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169155 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  169158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169170 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169174 */   GIR_RootConstrainSelectedInstOperands,
     /*  169175 */   // GIR_Coverage, 228,
     /*  169175 */   GIR_EraseRootFromParent_Done,
     /*  169176 */ // Label 3151: @169176
     /*  169176 */ GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(169230), // Rule ID 275 //
     /*  169181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  169184 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169187 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169198 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169202 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169209 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  169212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169219 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169224 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169228 */   GIR_RootConstrainSelectedInstOperands,
     /*  169229 */   // GIR_Coverage, 275,
     /*  169229 */   GIR_EraseRootFromParent_Done,
     /*  169230 */ // Label 3152: @169230
     /*  169230 */ GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(169287), // Rule ID 317 //
     /*  169235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  169238 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169241 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169248 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169255 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169259 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169266 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10067>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  169269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169281 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169285 */   GIR_RootConstrainSelectedInstOperands,
     /*  169286 */   // GIR_Coverage, 317,
     /*  169286 */   GIR_EraseRootFromParent_Done,
     /*  169287 */ // Label 3153: @169287
     /*  169287 */ GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(169344), // Rule ID 321 //
     /*  169292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  169295 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169298 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169305 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169316 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169323 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10069>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  169326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169338 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169342 */   GIR_RootConstrainSelectedInstOperands,
     /*  169343 */   // GIR_Coverage, 321,
     /*  169343 */   GIR_EraseRootFromParent_Done,
     /*  169344 */ // Label 3154: @169344
     /*  169344 */ GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(169401), // Rule ID 337 //
     /*  169349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  169352 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169355 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169362 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169369 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169373 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169380 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10083>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  169383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169395 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169399 */   GIR_RootConstrainSelectedInstOperands,
     /*  169400 */   // GIR_Coverage, 337,
     /*  169400 */   GIR_EraseRootFromParent_Done,
     /*  169401 */ // Label 3155: @169401
     /*  169401 */ GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(169441), // Rule ID 1093 //
     /*  169406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  169409 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169412 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169426 */   // MIs[0] rs1
     /*  169426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  169430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169434 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10571>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  169434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  169439 */   GIR_RootConstrainSelectedInstOperands,
     /*  169440 */   // GIR_Coverage, 1093,
     /*  169440 */   GIR_Done,
     /*  169441 */ // Label 3156: @169441
     /*  169441 */ GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(169481), // Rule ID 1097 //
     /*  169446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  169449 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169459 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  169462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169466 */   // MIs[0] rs1
     /*  169466 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  169470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169474 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10573>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  169474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  169479 */   GIR_RootConstrainSelectedInstOperands,
     /*  169480 */   // GIR_Coverage, 1097,
     /*  169480 */   GIR_Done,
     /*  169481 */ // Label 3157: @169481
     /*  169481 */ GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(169521), // Rule ID 1101 //
     /*  169486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  169489 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169492 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169499 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169506 */   // MIs[0] rs1
     /*  169506 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  169510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169514 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10575>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  169514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  169519 */   GIR_RootConstrainSelectedInstOperands,
     /*  169520 */   // GIR_Coverage, 1101,
     /*  169520 */   GIR_Done,
     /*  169521 */ // Label 3158: @169521
     /*  169521 */ GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(169561), // Rule ID 1105 //
     /*  169526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  169529 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169532 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169539 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  169542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169546 */   // MIs[0] rs1
     /*  169546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  169550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169554 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10577>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  169554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  169559 */   GIR_RootConstrainSelectedInstOperands,
     /*  169560 */   // GIR_Coverage, 1105,
     /*  169560 */   GIR_Done,
     /*  169561 */ // Label 3159: @169561
     /*  169561 */ GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(169601), // Rule ID 1125 //
     /*  169566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  169569 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169572 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169579 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169586 */   // MIs[0] rs1
     /*  169586 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  169590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169594 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10595>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  169594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  169599 */   GIR_RootConstrainSelectedInstOperands,
     /*  169600 */   // GIR_Coverage, 1125,
     /*  169600 */   GIR_Done,
     /*  169601 */ // Label 3160: @169601
     /*  169601 */ GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(169641), // Rule ID 1129 //
     /*  169606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  169609 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169612 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169619 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  169622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169626 */   // MIs[0] rs1
     /*  169626 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  169630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169634 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10597>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  169634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  169639 */   GIR_RootConstrainSelectedInstOperands,
     /*  169640 */   // GIR_Coverage, 1129,
     /*  169640 */   GIR_Done,
     /*  169641 */ // Label 3161: @169641
     /*  169641 */ GIM_Reject,
     /*  169642 */ // Label 3130: @169642
     /*  169642 */ GIM_Reject,
     /*  169643 */ // Label 23: @169643
     /*  169643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3164*/ GIMT_Encode4(171132),
     /*  169654 */ /*GILLT_s32*//*Label 3162*/ GIMT_Encode4(169662),
     /*  169658 */ /*GILLT_s64*//*Label 3163*/ GIMT_Encode4(170798),
     /*  169662 */ // Label 3162: @169662
     /*  169662 */ GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(169769), // Rule ID 74331 //
     /*  169667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  169670 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169673 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169684 */   // MIs[0] Operand 1
     /*  169684 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  169688 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  169692 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  169696 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  169700 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  169704 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  169708 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  169712 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  169716 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  169720 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  169725 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  169729 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  169733 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  169737 */   // MIs[3] Operand 1
     /*  169737 */   // No operand predicates
     /*  169737 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169742 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  169744 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  169744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  169747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169749 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  169753 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  169757 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  169760 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  169767 */   GIR_RootConstrainSelectedInstOperands,
     /*  169768 */   // GIR_Coverage, 74331,
     /*  169768 */   GIR_EraseRootFromParent_Done,
     /*  169769 */ // Label 3165: @169769
     /*  169769 */ GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(169876), // Rule ID 74332 //
     /*  169774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  169777 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169780 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169791 */   // MIs[0] Operand 1
     /*  169791 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  169795 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  169799 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  169803 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  169807 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  169811 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  169815 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  169819 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  169823 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  169827 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  169832 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  169836 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  169840 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  169844 */   // MIs[3] Operand 1
     /*  169844 */   // No operand predicates
     /*  169844 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169849 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  169851 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  169851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  169854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169856 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  169860 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  169864 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  169867 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  169874 */   GIR_RootConstrainSelectedInstOperands,
     /*  169875 */   // GIR_Coverage, 74332,
     /*  169875 */   GIR_EraseRootFromParent_Done,
     /*  169876 */ // Label 3166: @169876
     /*  169876 */ GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(169983), // Rule ID 74333 //
     /*  169881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  169884 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169887 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169898 */   // MIs[0] Operand 1
     /*  169898 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  169902 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  169906 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  169910 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  169914 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  169918 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  169922 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  169926 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  169930 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  169934 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  169939 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  169943 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  169947 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  169951 */   // MIs[3] Operand 1
     /*  169951 */   // No operand predicates
     /*  169951 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169956 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  169958 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (QC_LRHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  169958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRHU),
     /*  169961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169963 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  169967 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  169971 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  169974 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  169981 */   GIR_RootConstrainSelectedInstOperands,
     /*  169982 */   // GIR_Coverage, 74333,
     /*  169982 */   GIR_EraseRootFromParent_Done,
     /*  169983 */ // Label 3167: @169983
     /*  169983 */ GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(170090), // Rule ID 74334 //
     /*  169988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  169991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169994 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170005 */   // MIs[0] Operand 1
     /*  170005 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170009 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  170013 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  170017 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  170021 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  170025 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  170029 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  170033 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  170037 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  170041 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  170046 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  170050 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  170054 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  170058 */   // MIs[3] Operand 1
     /*  170058 */   // No operand predicates
     /*  170058 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170063 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  170065 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (QC_LRHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  170065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRHU),
     /*  170068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170070 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  170074 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  170078 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  170081 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  170088 */   GIR_RootConstrainSelectedInstOperands,
     /*  170089 */   // GIR_Coverage, 74334,
     /*  170089 */   GIR_EraseRootFromParent_Done,
     /*  170090 */ // Label 3168: @170090
     /*  170090 */ GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(170197), // Rule ID 64556 //
     /*  170095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  170098 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170112 */   // MIs[0] Operand 1
     /*  170112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170116 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  170120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  170124 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  170128 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  170132 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170137 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  170141 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  170145 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  170149 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  170153 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  170158 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  170162 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  170166 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  170170 */   // MIs[3] Operand 1
     /*  170170 */   // No operand predicates
     /*  170170 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  170172 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  170172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  170175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170177 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  170181 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  170185 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  170188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  170195 */   GIR_RootConstrainSelectedInstOperands,
     /*  170196 */   // GIR_Coverage, 64556,
     /*  170196 */   GIR_EraseRootFromParent_Done,
     /*  170197 */ // Label 3169: @170197
     /*  170197 */ GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(170304), // Rule ID 64557 //
     /*  170202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  170205 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170208 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170219 */   // MIs[0] Operand 1
     /*  170219 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  170227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  170231 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  170235 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  170239 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170244 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  170248 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  170252 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  170256 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  170260 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  170265 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  170269 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  170273 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  170277 */   // MIs[3] Operand 1
     /*  170277 */   // No operand predicates
     /*  170277 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  170279 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  170279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  170282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170284 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  170288 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  170292 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  170295 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  170302 */   GIR_RootConstrainSelectedInstOperands,
     /*  170303 */   // GIR_Coverage, 64557,
     /*  170303 */   GIR_EraseRootFromParent_Done,
     /*  170304 */ // Label 3170: @170304
     /*  170304 */ GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(170411), // Rule ID 64558 //
     /*  170309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  170312 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170315 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170326 */   // MIs[0] Operand 1
     /*  170326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  170334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  170338 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  170342 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  170346 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170351 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  170355 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  170359 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  170363 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  170367 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  170372 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  170376 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  170380 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  170384 */   // MIs[3] Operand 1
     /*  170384 */   // No operand predicates
     /*  170384 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  170386 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (QC_LRHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  170386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRHU),
     /*  170389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170391 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  170395 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  170399 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  170402 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  170409 */   GIR_RootConstrainSelectedInstOperands,
     /*  170410 */   // GIR_Coverage, 64558,
     /*  170410 */   GIR_EraseRootFromParent_Done,
     /*  170411 */ // Label 3171: @170411
     /*  170411 */ GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(170518), // Rule ID 64559 //
     /*  170416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  170419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170422 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170433 */   // MIs[0] Operand 1
     /*  170433 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170437 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  170441 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  170445 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  170449 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  170453 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170458 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  170462 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  170466 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  170470 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  170474 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  170479 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  170483 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  170487 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  170491 */   // MIs[3] Operand 1
     /*  170491 */   // No operand predicates
     /*  170491 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  170493 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (QC_LRHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  170493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRHU),
     /*  170496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170498 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  170502 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  170506 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  170509 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  170516 */   GIR_RootConstrainSelectedInstOperands,
     /*  170517 */   // GIR_Coverage, 64559,
     /*  170517 */   GIR_EraseRootFromParent_Done,
     /*  170518 */ // Label 3172: @170518
     /*  170518 */ GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(170572), // Rule ID 235 //
     /*  170523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  170526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170529 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170540 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170544 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170551 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  170554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170566 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170570 */   GIR_RootConstrainSelectedInstOperands,
     /*  170571 */   // GIR_Coverage, 235,
     /*  170571 */   GIR_EraseRootFromParent_Done,
     /*  170572 */ // Label 3173: @170572
     /*  170572 */ GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(170626), // Rule ID 237 //
     /*  170577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  170580 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170583 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170594 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170598 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170605 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  170608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170624 */   GIR_RootConstrainSelectedInstOperands,
     /*  170625 */   // GIR_Coverage, 237,
     /*  170625 */   GIR_EraseRootFromParent_Done,
     /*  170626 */ // Label 3174: @170626
     /*  170626 */ GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(170683), // Rule ID 324 //
     /*  170631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  170634 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170637 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170644 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  170647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170651 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170655 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170662 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10071>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  170665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170681 */   GIR_RootConstrainSelectedInstOperands,
     /*  170682 */   // GIR_Coverage, 324,
     /*  170682 */   GIR_EraseRootFromParent_Done,
     /*  170683 */ // Label 3175: @170683
     /*  170683 */ GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(170740), // Rule ID 326 //
     /*  170688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  170691 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170694 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170701 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  170704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170708 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170712 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170719 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10073>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  170722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170738 */   GIR_RootConstrainSelectedInstOperands,
     /*  170739 */   // GIR_Coverage, 326,
     /*  170739 */   GIR_EraseRootFromParent_Done,
     /*  170740 */ // Label 3176: @170740
     /*  170740 */ GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(170797), // Rule ID 340 //
     /*  170745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  170748 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170751 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170758 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  170761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170765 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170769 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170776 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10085>>  =>  (LWU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  170779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170791 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170795 */   GIR_RootConstrainSelectedInstOperands,
     /*  170796 */   // GIR_Coverage, 340,
     /*  170796 */   GIR_EraseRootFromParent_Done,
     /*  170797 */ // Label 3177: @170797
     /*  170797 */ GIM_Reject,
     /*  170798 */ // Label 3163: @170798
     /*  170798 */ GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(170852), // Rule ID 234 //
     /*  170803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  170806 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170809 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170824 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170831 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  170834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170850 */   GIR_RootConstrainSelectedInstOperands,
     /*  170851 */   // GIR_Coverage, 234,
     /*  170851 */   GIR_EraseRootFromParent_Done,
     /*  170852 */ // Label 3178: @170852
     /*  170852 */ GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(170906), // Rule ID 236 //
     /*  170857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  170860 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170863 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170874 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170878 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170885 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  170888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170904 */   GIR_RootConstrainSelectedInstOperands,
     /*  170905 */   // GIR_Coverage, 236,
     /*  170905 */   GIR_EraseRootFromParent_Done,
     /*  170906 */ // Label 3179: @170906
     /*  170906 */ GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(170960), // Rule ID 277 //
     /*  170911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  170914 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170917 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170928 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170932 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170939 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  170942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170954 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170958 */   GIR_RootConstrainSelectedInstOperands,
     /*  170959 */   // GIR_Coverage, 277,
     /*  170959 */   GIR_EraseRootFromParent_Done,
     /*  170960 */ // Label 3180: @170960
     /*  170960 */ GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(171017), // Rule ID 323 //
     /*  170965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  170968 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170971 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170978 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  170981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170985 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170989 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170996 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10071>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  170999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171011 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171015 */   GIR_RootConstrainSelectedInstOperands,
     /*  171016 */   // GIR_Coverage, 323,
     /*  171016 */   GIR_EraseRootFromParent_Done,
     /*  171017 */ // Label 3181: @171017
     /*  171017 */ GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(171074), // Rule ID 325 //
     /*  171022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  171025 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171028 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171035 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  171038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171046 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171053 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10073>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  171056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171068 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171072 */   GIR_RootConstrainSelectedInstOperands,
     /*  171073 */   // GIR_Coverage, 325,
     /*  171073 */   GIR_EraseRootFromParent_Done,
     /*  171074 */ // Label 3182: @171074
     /*  171074 */ GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(171131), // Rule ID 339 //
     /*  171079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  171082 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171085 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171092 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  171095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171103 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171110 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10085>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  171113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171125 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171129 */   GIR_RootConstrainSelectedInstOperands,
     /*  171130 */   // GIR_Coverage, 339,
     /*  171130 */   GIR_EraseRootFromParent_Done,
     /*  171131 */ // Label 3183: @171131
     /*  171131 */ GIM_Reject,
     /*  171132 */ // Label 3164: @171132
     /*  171132 */ GIM_Reject,
     /*  171133 */ // Label 24: @171133
     /*  171133 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 3218*/ GIMT_Encode4(179336),
     /*  171144 */ /*GILLT_p0s32*//*Label 3184*/ GIMT_Encode4(171280),
     /*  171148 */ /*GILLT_p0s64*//*Label 3185*/ GIMT_Encode4(171374),
     /*  171152 */ /*GILLT_s16*//*Label 3186*/ GIMT_Encode4(171468),
     /*  171156 */ /*GILLT_s32*//*Label 3187*/ GIMT_Encode4(172107),
     /*  171160 */ /*GILLT_s64*//*Label 3188*/ GIMT_Encode4(174713),
     /*  171164 */ /*GILLT_nxv1s1*//*Label 3189*/ GIMT_Encode4(175790),
     /*  171168 */ /*GILLT_nxv1s8*//*Label 3190*/ GIMT_Encode4(175870),
     /*  171172 */ /*GILLT_nxv1s16*//*Label 3191*/ GIMT_Encode4(175958),
     /*  171176 */ /*GILLT_nxv1s32*//*Label 3192*/ GIMT_Encode4(176116),
     /*  171180 */ /*GILLT_nxv1s64*//*Label 3193*/ GIMT_Encode4(176274),
     /*  171184 */ /*GILLT_nxv2s1*//*Label 3194*/ GIMT_Encode4(176432),
     /*  171188 */ /*GILLT_nxv2s8*//*Label 3195*/ GIMT_Encode4(176512),
     /*  171192 */ /*GILLT_nxv2s16*//*Label 3196*/ GIMT_Encode4(176600),
     /*  171196 */ /*GILLT_nxv2s32*//*Label 3197*/ GIMT_Encode4(176758),
     /*  171200 */ /*GILLT_nxv2s64*//*Label 3198*/ GIMT_Encode4(176916),
     /*  171204 */ /*GILLT_nxv4s1*//*Label 3199*/ GIMT_Encode4(177074),
     /*  171208 */ /*GILLT_nxv4s8*//*Label 3200*/ GIMT_Encode4(177154),
     /*  171212 */ /*GILLT_nxv4s16*//*Label 3201*/ GIMT_Encode4(177242),
     /*  171216 */ /*GILLT_nxv4s32*//*Label 3202*/ GIMT_Encode4(177400),
     /*  171220 */ /*GILLT_nxv4s64*//*Label 3203*/ GIMT_Encode4(177558),
     /*  171224 */ /*GILLT_nxv8s1*//*Label 3204*/ GIMT_Encode4(177716),
     /*  171228 */ /*GILLT_nxv8s8*//*Label 3205*/ GIMT_Encode4(177796),
     /*  171232 */ /*GILLT_nxv8s16*//*Label 3206*/ GIMT_Encode4(177884),
     /*  171236 */ /*GILLT_nxv8s32*//*Label 3207*/ GIMT_Encode4(178042),
     /*  171240 */ /*GILLT_nxv8s64*//*Label 3208*/ GIMT_Encode4(178200),
     /*  171244 */ /*GILLT_nxv16s1*//*Label 3209*/ GIMT_Encode4(178358),
     /*  171248 */ /*GILLT_nxv16s8*//*Label 3210*/ GIMT_Encode4(178438),
     /*  171252 */ /*GILLT_nxv16s16*//*Label 3211*/ GIMT_Encode4(178526),
     /*  171256 */ /*GILLT_nxv16s32*//*Label 3212*/ GIMT_Encode4(178684),
     /*  171260 */ /*GILLT_nxv32s1*//*Label 3213*/ GIMT_Encode4(178842),
     /*  171264 */ /*GILLT_nxv32s8*//*Label 3214*/ GIMT_Encode4(178922),
     /*  171268 */ /*GILLT_nxv32s16*//*Label 3215*/ GIMT_Encode4(179010),
     /*  171272 */ /*GILLT_nxv64s1*//*Label 3216*/ GIMT_Encode4(179168),
     /*  171276 */ /*GILLT_nxv64s8*//*Label 3217*/ GIMT_Encode4(179248),
     /*  171280 */ // Label 3184: @171280
     /*  171280 */ GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(171373),
     /*  171285 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171288 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171296 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171300 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(171336), // Rule ID 65300 //
     /*  171305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  171308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171315 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  171318 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171334 */     GIR_RootConstrainSelectedInstOperands,
     /*  171335 */     // GIR_Coverage, 65300,
     /*  171335 */     GIR_EraseRootFromParent_Done,
     /*  171336 */   // Label 3220: @171336
     /*  171336 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(171372), // Rule ID 65304 //
     /*  171341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  171344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171351 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171354 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171370 */     GIR_RootConstrainSelectedInstOperands,
     /*  171371 */     // GIR_Coverage, 65304,
     /*  171371 */     GIR_EraseRootFromParent_Done,
     /*  171372 */   // Label 3221: @171372
     /*  171372 */   GIM_Reject,
     /*  171373 */ // Label 3219: @171373
     /*  171373 */ GIM_Reject,
     /*  171374 */ // Label 3185: @171374
     /*  171374 */ GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(171467),
     /*  171379 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171382 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171390 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171394 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(171430), // Rule ID 65299 //
     /*  171399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  171402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171409 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  171412 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171428 */     GIR_RootConstrainSelectedInstOperands,
     /*  171429 */     // GIR_Coverage, 65299,
     /*  171429 */     GIR_EraseRootFromParent_Done,
     /*  171430 */   // Label 3223: @171430
     /*  171430 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(171466), // Rule ID 65303 //
     /*  171435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  171438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171445 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171448 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171464 */     GIR_RootConstrainSelectedInstOperands,
     /*  171465 */     // GIR_Coverage, 65303,
     /*  171465 */     GIR_EraseRootFromParent_Done,
     /*  171466 */   // Label 3224: @171466
     /*  171466 */   GIM_Reject,
     /*  171467 */ // Label 3222: @171467
     /*  171467 */ GIM_Reject,
     /*  171468 */ // Label 3186: @171468
     /*  171468 */ GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(171522), // Rule ID 65317 //
     /*  171473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  171476 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171479 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171494 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171501 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  171504 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171516 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171520 */   GIR_RootConstrainSelectedInstOperands,
     /*  171521 */   // GIR_Coverage, 65317,
     /*  171521 */   GIR_EraseRootFromParent_Done,
     /*  171522 */ // Label 3225: @171522
     /*  171522 */ GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(171576), // Rule ID 65318 //
     /*  171527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  171530 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171533 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171544 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171548 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171555 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  171558 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171570 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171574 */   GIR_RootConstrainSelectedInstOperands,
     /*  171575 */   // GIR_Coverage, 65318,
     /*  171575 */   GIR_EraseRootFromParent_Done,
     /*  171576 */ // Label 3226: @171576
     /*  171576 */ GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(171630), // Rule ID 65319 //
     /*  171581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  171584 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171587 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171598 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171602 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171609 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171612 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171628 */   GIR_RootConstrainSelectedInstOperands,
     /*  171629 */   // GIR_Coverage, 65319,
     /*  171629 */   GIR_EraseRootFromParent_Done,
     /*  171630 */ // Label 3227: @171630
     /*  171630 */ GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(171684), // Rule ID 65320 //
     /*  171635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  171638 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171641 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171652 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171656 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171663 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171666 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171682 */   GIR_RootConstrainSelectedInstOperands,
     /*  171683 */   // GIR_Coverage, 65320,
     /*  171683 */   GIR_EraseRootFromParent_Done,
     /*  171684 */ // Label 3228: @171684
     /*  171684 */ GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(171735), // Rule ID 2142 //
     /*  171689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  171692 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171695 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  171703 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171707 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171714 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  171717 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171733 */   GIR_RootConstrainSelectedInstOperands,
     /*  171734 */   // GIR_Coverage, 2142,
     /*  171734 */   GIR_EraseRootFromParent_Done,
     /*  171735 */ // Label 3229: @171735
     /*  171735 */ GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(171786), // Rule ID 2143 //
     /*  171740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  171743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171746 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  171754 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171758 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171765 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  171768 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171780 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171784 */   GIR_RootConstrainSelectedInstOperands,
     /*  171785 */   // GIR_Coverage, 2143,
     /*  171785 */   GIR_EraseRootFromParent_Done,
     /*  171786 */ // Label 3230: @171786
     /*  171786 */ GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(171837), // Rule ID 2148 //
     /*  171791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  171794 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171797 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  171805 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171809 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171816 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  171819 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171835 */   GIR_RootConstrainSelectedInstOperands,
     /*  171836 */   // GIR_Coverage, 2148,
     /*  171836 */   GIR_EraseRootFromParent_Done,
     /*  171837 */ // Label 3231: @171837
     /*  171837 */ GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(171888), // Rule ID 2149 //
     /*  171842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  171845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171848 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  171856 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171860 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171867 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  171870 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171882 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171886 */   GIR_RootConstrainSelectedInstOperands,
     /*  171887 */   // GIR_Coverage, 2149,
     /*  171887 */   GIR_EraseRootFromParent_Done,
     /*  171888 */ // Label 3232: @171888
     /*  171888 */ GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(171939), // Rule ID 65307 //
     /*  171893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  171896 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171899 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171907 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171911 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171918 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171921 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171933 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171937 */   GIR_RootConstrainSelectedInstOperands,
     /*  171938 */   // GIR_Coverage, 65307,
     /*  171938 */   GIR_EraseRootFromParent_Done,
     /*  171939 */ // Label 3233: @171939
     /*  171939 */ GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(171990), // Rule ID 65308 //
     /*  171944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  171947 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171950 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171958 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171962 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171969 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171972 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171984 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171988 */   GIR_RootConstrainSelectedInstOperands,
     /*  171989 */   // GIR_Coverage, 65308,
     /*  171989 */   GIR_EraseRootFromParent_Done,
     /*  171990 */ // Label 3234: @171990
     /*  171990 */ GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(172048), // Rule ID 65311 //
     /*  171995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  171998 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172001 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172005 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172016 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  172020 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  172027 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  172027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  172030 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  172037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  172042 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172046 */   GIR_RootConstrainSelectedInstOperands,
     /*  172047 */   // GIR_Coverage, 65311,
     /*  172047 */   GIR_EraseRootFromParent_Done,
     /*  172048 */ // Label 3235: @172048
     /*  172048 */ GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(172106), // Rule ID 65312 //
     /*  172053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  172056 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172059 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172063 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172074 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  172078 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  172085 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  172085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  172088 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  172095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  172100 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172104 */   GIR_RootConstrainSelectedInstOperands,
     /*  172105 */   // GIR_Coverage, 65312,
     /*  172105 */   GIR_EraseRootFromParent_Done,
     /*  172106 */ // Label 3236: @172106
     /*  172106 */ GIM_Reject,
     /*  172107 */ // Label 3187: @172107
     /*  172107 */ GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(172218), // Rule ID 74335 //
     /*  172112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  172115 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172118 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172122 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172133 */   // MIs[0] Operand 1
     /*  172133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172137 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172141 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172145 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172149 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172153 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  172157 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172161 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172165 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  172169 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172174 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172178 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172182 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172186 */   // MIs[3] Operand 1
     /*  172186 */   // No operand predicates
     /*  172186 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172191 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172193 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (QC_SRB GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  172193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRB),
     /*  172196 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172198 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  172202 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172206 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172216 */   GIR_RootConstrainSelectedInstOperands,
     /*  172217 */   // GIR_Coverage, 74335,
     /*  172217 */   GIR_EraseRootFromParent_Done,
     /*  172218 */ // Label 3237: @172218
     /*  172218 */ GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(172329), // Rule ID 74336 //
     /*  172223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  172226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172229 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172233 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172244 */   // MIs[0] Operand 1
     /*  172244 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172248 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172256 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172260 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172264 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  172268 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172272 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172276 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  172280 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172285 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172289 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172293 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172297 */   // MIs[3] Operand 1
     /*  172297 */   // No operand predicates
     /*  172297 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172302 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172304 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (QC_SRB GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  172304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRB),
     /*  172307 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172309 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  172313 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172317 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172320 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172327 */   GIR_RootConstrainSelectedInstOperands,
     /*  172328 */   // GIR_Coverage, 74336,
     /*  172328 */   GIR_EraseRootFromParent_Done,
     /*  172329 */ // Label 3238: @172329
     /*  172329 */ GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(172440), // Rule ID 74337 //
     /*  172334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  172337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172340 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172344 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  172351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172355 */   // MIs[0] Operand 1
     /*  172355 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172367 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172371 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172375 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  172379 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172383 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172387 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  172391 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172396 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172400 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172404 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172408 */   // MIs[3] Operand 1
     /*  172408 */   // No operand predicates
     /*  172408 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172413 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172415 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (QC_SRH GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  172415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRH),
     /*  172418 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172420 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  172424 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172428 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172431 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172438 */   GIR_RootConstrainSelectedInstOperands,
     /*  172439 */   // GIR_Coverage, 74337,
     /*  172439 */   GIR_EraseRootFromParent_Done,
     /*  172440 */ // Label 3239: @172440
     /*  172440 */ GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(172551), // Rule ID 74338 //
     /*  172445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  172448 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172451 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  172462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172466 */   // MIs[0] Operand 1
     /*  172466 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172470 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172474 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172478 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172482 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172486 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  172490 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172494 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172498 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  172502 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172507 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172511 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172515 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172519 */   // MIs[3] Operand 1
     /*  172519 */   // No operand predicates
     /*  172519 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172524 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172526 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (QC_SRH GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  172526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRH),
     /*  172529 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172531 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  172535 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172539 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172542 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172549 */   GIR_RootConstrainSelectedInstOperands,
     /*  172550 */   // GIR_Coverage, 74338,
     /*  172550 */   GIR_EraseRootFromParent_Done,
     /*  172551 */ // Label 3240: @172551
     /*  172551 */ GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(172655), // Rule ID 74339 //
     /*  172556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  172559 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172562 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172570 */   // MIs[0] Operand 1
     /*  172570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172582 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172586 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172590 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  172594 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172598 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172602 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  172606 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172611 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172615 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172619 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172623 */   // MIs[3] Operand 1
     /*  172623 */   // No operand predicates
     /*  172623 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172628 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172630 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (QC_SRW GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  172630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRW),
     /*  172633 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172635 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  172639 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172643 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172646 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172653 */   GIR_RootConstrainSelectedInstOperands,
     /*  172654 */   // GIR_Coverage, 74339,
     /*  172654 */   GIR_EraseRootFromParent_Done,
     /*  172655 */ // Label 3241: @172655
     /*  172655 */ GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(172759), // Rule ID 74340 //
     /*  172660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  172663 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172666 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172674 */   // MIs[0] Operand 1
     /*  172674 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172678 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172682 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172686 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172690 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172694 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  172698 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172702 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172706 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  172710 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172715 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172719 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172723 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172727 */   // MIs[3] Operand 1
     /*  172727 */   // No operand predicates
     /*  172727 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172732 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172734 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (QC_SRW GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  172734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRW),
     /*  172737 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172739 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  172743 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172747 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172750 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172757 */   GIR_RootConstrainSelectedInstOperands,
     /*  172758 */   // GIR_Coverage, 74340,
     /*  172758 */   GIR_EraseRootFromParent_Done,
     /*  172759 */ // Label 3242: @172759
     /*  172759 */ GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(172870), // Rule ID 64560 //
     /*  172764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  172767 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172770 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172774 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172785 */   // MIs[0] Operand 1
     /*  172785 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172797 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172801 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172805 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172810 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  172814 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172818 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172822 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  172826 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172831 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172835 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172839 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172843 */   // MIs[3] Operand 1
     /*  172843 */   // No operand predicates
     /*  172843 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172845 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (QC_SRB GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  172845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRB),
     /*  172848 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172850 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  172854 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172858 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172868 */   GIR_RootConstrainSelectedInstOperands,
     /*  172869 */   // GIR_Coverage, 64560,
     /*  172869 */   GIR_EraseRootFromParent_Done,
     /*  172870 */ // Label 3243: @172870
     /*  172870 */ GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(172981), // Rule ID 64561 //
     /*  172875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  172878 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172881 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172885 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172896 */   // MIs[0] Operand 1
     /*  172896 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172908 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172912 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172916 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172921 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  172925 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172929 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172933 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  172937 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172942 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172946 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172950 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172954 */   // MIs[3] Operand 1
     /*  172954 */   // No operand predicates
     /*  172954 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172956 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (QC_SRB GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  172956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRB),
     /*  172959 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172961 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  172965 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172969 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172979 */   GIR_RootConstrainSelectedInstOperands,
     /*  172980 */   // GIR_Coverage, 64561,
     /*  172980 */   GIR_EraseRootFromParent_Done,
     /*  172981 */ // Label 3244: @172981
     /*  172981 */ GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(173092), // Rule ID 64562 //
     /*  172986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  172989 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172992 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172996 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  173003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173007 */   // MIs[0] Operand 1
     /*  173007 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173011 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  173015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  173019 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  173023 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  173027 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173032 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  173036 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  173040 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  173044 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  173048 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  173053 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  173057 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  173061 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  173065 */   // MIs[3] Operand 1
     /*  173065 */   // No operand predicates
     /*  173065 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  173067 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (QC_SRH GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  173067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRH),
     /*  173070 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  173072 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  173076 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  173080 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  173083 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  173090 */   GIR_RootConstrainSelectedInstOperands,
     /*  173091 */   // GIR_Coverage, 64562,
     /*  173091 */   GIR_EraseRootFromParent_Done,
     /*  173092 */ // Label 3245: @173092
     /*  173092 */ GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(173203), // Rule ID 64563 //
     /*  173097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  173100 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173103 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173107 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  173114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173118 */   // MIs[0] Operand 1
     /*  173118 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173122 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  173126 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  173130 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  173134 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  173138 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173143 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  173147 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  173151 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  173155 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  173159 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  173164 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  173168 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  173172 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  173176 */   // MIs[3] Operand 1
     /*  173176 */   // No operand predicates
     /*  173176 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  173178 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (QC_SRH GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  173178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRH),
     /*  173181 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  173183 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  173187 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  173191 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  173194 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  173201 */   GIR_RootConstrainSelectedInstOperands,
     /*  173202 */   // GIR_Coverage, 64563,
     /*  173202 */   GIR_EraseRootFromParent_Done,
     /*  173203 */ // Label 3246: @173203
     /*  173203 */ GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(173307), // Rule ID 64564 //
     /*  173208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  173211 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173214 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173222 */   // MIs[0] Operand 1
     /*  173222 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173226 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  173230 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  173234 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  173238 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  173242 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173247 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  173251 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  173255 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  173259 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  173263 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  173268 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  173272 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  173276 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  173280 */   // MIs[3] Operand 1
     /*  173280 */   // No operand predicates
     /*  173280 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  173282 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (QC_SRW GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  173282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRW),
     /*  173285 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  173287 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  173291 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  173295 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  173298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  173305 */   GIR_RootConstrainSelectedInstOperands,
     /*  173306 */   // GIR_Coverage, 64564,
     /*  173306 */   GIR_EraseRootFromParent_Done,
     /*  173307 */ // Label 3247: @173307
     /*  173307 */ GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(173411), // Rule ID 64565 //
     /*  173312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  173315 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173318 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173326 */   // MIs[0] Operand 1
     /*  173326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  173334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  173338 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  173342 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  173346 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173351 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  173355 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  173359 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  173363 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  173367 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  173372 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  173376 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  173380 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  173384 */   // MIs[3] Operand 1
     /*  173384 */   // No operand predicates
     /*  173384 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  173386 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (QC_SRW GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  173386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRW),
     /*  173389 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  173391 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  173395 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  173399 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  173402 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  173409 */   GIR_RootConstrainSelectedInstOperands,
     /*  173410 */   // GIR_Coverage, 64565,
     /*  173410 */   GIR_EraseRootFromParent_Done,
     /*  173411 */ // Label 3248: @173411
     /*  173411 */ GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(173468), // Rule ID 328 //
     /*  173416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  173419 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  173422 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  173429 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  173432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173436 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173440 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173447 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10075>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  173450 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173462 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173466 */   GIR_RootConstrainSelectedInstOperands,
     /*  173467 */   // GIR_Coverage, 328,
     /*  173467 */   GIR_EraseRootFromParent_Done,
     /*  173468 */ // Label 3249: @173468
     /*  173468 */ GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(173525), // Rule ID 330 //
     /*  173473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  173476 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  173479 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  173486 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  173489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173493 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173497 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173504 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10077>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  173507 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173519 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173523 */   GIR_RootConstrainSelectedInstOperands,
     /*  173524 */   // GIR_Coverage, 330,
     /*  173524 */   GIR_EraseRootFromParent_Done,
     /*  173525 */ // Label 3250: @173525
     /*  173525 */ GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(173582), // Rule ID 332 //
     /*  173530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  173533 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  173536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  173543 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  173546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173561 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10079>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  173564 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173576 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173580 */   GIR_RootConstrainSelectedInstOperands,
     /*  173581 */   // GIR_Coverage, 332,
     /*  173581 */   GIR_EraseRootFromParent_Done,
     /*  173582 */ // Label 3251: @173582
     /*  173582 */ GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(173636), // Rule ID 65323 //
     /*  173587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  173590 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  173593 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  173600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173604 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173608 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173615 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  173615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  173618 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173634 */   GIR_RootConstrainSelectedInstOperands,
     /*  173635 */   // GIR_Coverage, 65323,
     /*  173635 */   GIR_EraseRootFromParent_Done,
     /*  173636 */ // Label 3252: @173636
     /*  173636 */ GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(173690), // Rule ID 65324 //
     /*  173641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  173644 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  173647 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  173654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173669 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  173672 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173688 */   GIR_RootConstrainSelectedInstOperands,
     /*  173689 */   // GIR_Coverage, 65324,
     /*  173689 */   GIR_EraseRootFromParent_Done,
     /*  173690 */ // Label 3253: @173690
     /*  173690 */ GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(173748), // Rule ID 239 //
     /*  173695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  173698 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173701 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173705 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  173712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173716 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173720 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173727 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  173730 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173742 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173746 */   GIR_RootConstrainSelectedInstOperands,
     /*  173747 */   // GIR_Coverage, 239,
     /*  173747 */   GIR_EraseRootFromParent_Done,
     /*  173748 */ // Label 3254: @173748
     /*  173748 */ GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(173806), // Rule ID 241 //
     /*  173753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  173756 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173759 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173763 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  173770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173774 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173778 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173785 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  173788 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173800 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173804 */   GIR_RootConstrainSelectedInstOperands,
     /*  173805 */   // GIR_Coverage, 241,
     /*  173805 */   GIR_EraseRootFromParent_Done,
     /*  173806 */ // Label 3255: @173806
     /*  173806 */ GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(173857), // Rule ID 242 //
     /*  173811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  173814 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173817 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173825 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173829 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173836 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  173836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  173839 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173851 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173855 */   GIR_RootConstrainSelectedInstOperands,
     /*  173856 */   // GIR_Coverage, 242,
     /*  173856 */   GIR_EraseRootFromParent_Done,
     /*  173857 */ // Label 3256: @173857
     /*  173857 */ GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(173908), // Rule ID 243 //
     /*  173862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  173865 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173868 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173876 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173880 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173887 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  173890 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173902 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173906 */   GIR_RootConstrainSelectedInstOperands,
     /*  173907 */   // GIR_Coverage, 243,
     /*  173907 */   GIR_EraseRootFromParent_Done,
     /*  173908 */ // Label 3257: @173908
     /*  173908 */ GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(173959), // Rule ID 1429 //
     /*  173913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  173916 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173919 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  173927 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173931 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173938 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  173938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  173941 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173953 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173957 */   GIR_RootConstrainSelectedInstOperands,
     /*  173958 */   // GIR_Coverage, 1429,
     /*  173958 */   GIR_EraseRootFromParent_Done,
     /*  173959 */ // Label 3258: @173959
     /*  173959 */ GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(174010), // Rule ID 1430 //
     /*  173964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  173967 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173970 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  173978 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173982 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173989 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  173992 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174008 */   GIR_RootConstrainSelectedInstOperands,
     /*  174009 */   // GIR_Coverage, 1430,
     /*  174009 */   GIR_EraseRootFromParent_Done,
     /*  174010 */ // Label 3259: @174010
     /*  174010 */ GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(174061), // Rule ID 1435 //
     /*  174015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  174018 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174021 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  174029 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174033 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174040 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  174043 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174055 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174059 */   GIR_RootConstrainSelectedInstOperands,
     /*  174060 */   // GIR_Coverage, 1435,
     /*  174060 */   GIR_EraseRootFromParent_Done,
     /*  174061 */ // Label 3260: @174061
     /*  174061 */ GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(174112), // Rule ID 1436 //
     /*  174066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  174069 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174072 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  174080 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174084 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174091 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  174091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  174094 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174106 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174110 */   GIR_RootConstrainSelectedInstOperands,
     /*  174111 */   // GIR_Coverage, 1436,
     /*  174111 */   GIR_EraseRootFromParent_Done,
     /*  174112 */ // Label 3261: @174112
     /*  174112 */ GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(174170), // Rule ID 65329 //
     /*  174117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  174120 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174123 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174127 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  174134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174138 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174142 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174149 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  174152 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174159 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174164 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174168 */   GIR_RootConstrainSelectedInstOperands,
     /*  174169 */   // GIR_Coverage, 65329,
     /*  174169 */   GIR_EraseRootFromParent_Done,
     /*  174170 */ // Label 3262: @174170
     /*  174170 */ GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(174228), // Rule ID 65330 //
     /*  174175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  174178 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174181 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174185 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  174192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174196 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174200 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174207 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  174207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  174210 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174226 */   GIR_RootConstrainSelectedInstOperands,
     /*  174227 */   // GIR_Coverage, 65330,
     /*  174227 */   GIR_EraseRootFromParent_Done,
     /*  174228 */ // Label 3263: @174228
     /*  174228 */ GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(174286), // Rule ID 65331 //
     /*  174233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  174236 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174239 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174243 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  174250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174254 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174258 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174265 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  174268 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174280 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174284 */   GIR_RootConstrainSelectedInstOperands,
     /*  174285 */   // GIR_Coverage, 65331,
     /*  174285 */   GIR_EraseRootFromParent_Done,
     /*  174286 */ // Label 3264: @174286
     /*  174286 */ GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(174344), // Rule ID 65332 //
     /*  174291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  174294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174297 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174301 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  174308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174316 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174323 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  174323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  174326 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174338 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174342 */   GIR_RootConstrainSelectedInstOperands,
     /*  174343 */   // GIR_Coverage, 65332,
     /*  174343 */   GIR_EraseRootFromParent_Done,
     /*  174344 */ // Label 3265: @174344
     /*  174344 */ GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(174390), // Rule ID 1108 //
     /*  174349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  174352 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174355 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  174362 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174369 */   // MIs[0] rs1
     /*  174369 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174377 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10579>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  174380 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174382 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174384 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174388 */   GIR_RootConstrainSelectedInstOperands,
     /*  174389 */   // GIR_Coverage, 1108,
     /*  174389 */   GIR_EraseRootFromParent_Done,
     /*  174390 */ // Label 3266: @174390
     /*  174390 */ GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(174436), // Rule ID 1110 //
     /*  174395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  174398 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174401 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  174408 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  174411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174415 */   // MIs[0] rs1
     /*  174415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174423 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10581>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  174426 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174428 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174434 */   GIR_RootConstrainSelectedInstOperands,
     /*  174435 */   // GIR_Coverage, 1110,
     /*  174435 */   GIR_EraseRootFromParent_Done,
     /*  174436 */ // Label 3267: @174436
     /*  174436 */ GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(174482), // Rule ID 1112 //
     /*  174441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  174444 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174447 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  174454 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174461 */   // MIs[0] rs1
     /*  174461 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174469 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10583>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  174472 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174474 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174476 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174480 */   GIR_RootConstrainSelectedInstOperands,
     /*  174481 */   // GIR_Coverage, 1112,
     /*  174481 */   GIR_EraseRootFromParent_Done,
     /*  174482 */ // Label 3268: @174482
     /*  174482 */ GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(174528), // Rule ID 1114 //
     /*  174487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  174490 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174493 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  174500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  174503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174507 */   // MIs[0] rs1
     /*  174507 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174515 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10585>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  174518 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174520 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174522 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174526 */   GIR_RootConstrainSelectedInstOperands,
     /*  174527 */   // GIR_Coverage, 1114,
     /*  174527 */   GIR_EraseRootFromParent_Done,
     /*  174528 */ // Label 3269: @174528
     /*  174528 */ GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(174574), // Rule ID 1116 //
     /*  174533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  174536 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174539 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  174546 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174553 */   // MIs[0] rs1
     /*  174553 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174561 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10587>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  174564 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174566 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174568 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174572 */   GIR_RootConstrainSelectedInstOperands,
     /*  174573 */   // GIR_Coverage, 1116,
     /*  174573 */   GIR_EraseRootFromParent_Done,
     /*  174574 */ // Label 3270: @174574
     /*  174574 */ GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(174620), // Rule ID 1118 //
     /*  174579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  174582 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174585 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  174592 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  174595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174599 */   // MIs[0] rs1
     /*  174599 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174607 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10589>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  174610 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174612 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174618 */   GIR_RootConstrainSelectedInstOperands,
     /*  174619 */   // GIR_Coverage, 1118,
     /*  174619 */   GIR_EraseRootFromParent_Done,
     /*  174620 */ // Label 3271: @174620
     /*  174620 */ GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(174666), // Rule ID 1136 //
     /*  174625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  174628 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174631 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  174638 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174645 */   // MIs[0] rs1
     /*  174645 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174653 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10603>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  174656 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174658 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174664 */   GIR_RootConstrainSelectedInstOperands,
     /*  174665 */   // GIR_Coverage, 1136,
     /*  174665 */   GIR_EraseRootFromParent_Done,
     /*  174666 */ // Label 3272: @174666
     /*  174666 */ GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(174712), // Rule ID 1138 //
     /*  174671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  174674 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174677 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  174684 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  174687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174691 */   // MIs[0] rs1
     /*  174691 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174699 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10605>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  174702 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174704 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174706 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174710 */   GIR_RootConstrainSelectedInstOperands,
     /*  174711 */   // GIR_Coverage, 1138,
     /*  174711 */   GIR_EraseRootFromParent_Done,
     /*  174712 */ // Label 3273: @174712
     /*  174712 */ GIM_Reject,
     /*  174713 */ // Label 3188: @174713
     /*  174713 */ GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(174770), // Rule ID 327 //
     /*  174718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  174721 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174724 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  174731 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174749 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10075>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  174752 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174768 */   GIR_RootConstrainSelectedInstOperands,
     /*  174769 */   // GIR_Coverage, 327,
     /*  174769 */   GIR_EraseRootFromParent_Done,
     /*  174770 */ // Label 3274: @174770
     /*  174770 */ GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(174827), // Rule ID 329 //
     /*  174775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  174778 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174781 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  174788 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174806 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10077>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  174809 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174821 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174825 */   GIR_RootConstrainSelectedInstOperands,
     /*  174826 */   // GIR_Coverage, 329,
     /*  174826 */   GIR_EraseRootFromParent_Done,
     /*  174827 */ // Label 3275: @174827
     /*  174827 */ GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(174884), // Rule ID 331 //
     /*  174832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  174835 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174838 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  174845 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174852 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174856 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174863 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10079>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  174866 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174878 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174882 */   GIR_RootConstrainSelectedInstOperands,
     /*  174883 */   // GIR_Coverage, 331,
     /*  174883 */   GIR_EraseRootFromParent_Done,
     /*  174884 */ // Label 3276: @174884
     /*  174884 */ GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(174941), // Rule ID 342 //
     /*  174889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  174892 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174895 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  174902 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174909 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174913 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174920 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10089>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  174923 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174935 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174939 */   GIR_RootConstrainSelectedInstOperands,
     /*  174940 */   // GIR_Coverage, 342,
     /*  174940 */   GIR_EraseRootFromParent_Done,
     /*  174941 */ // Label 3277: @174941
     /*  174941 */ GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(174999), // Rule ID 238 //
     /*  174946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  174949 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174952 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174956 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  174963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174967 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174971 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174978 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  174981 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174993 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174997 */   GIR_RootConstrainSelectedInstOperands,
     /*  174998 */   // GIR_Coverage, 238,
     /*  174998 */   GIR_EraseRootFromParent_Done,
     /*  174999 */ // Label 3278: @174999
     /*  174999 */ GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(175057), // Rule ID 240 //
     /*  175004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  175007 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175010 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175014 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  175021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175025 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175036 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  175036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  175039 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175051 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175055 */   GIR_RootConstrainSelectedInstOperands,
     /*  175056 */   // GIR_Coverage, 240,
     /*  175056 */   GIR_EraseRootFromParent_Done,
     /*  175057 */ // Label 3279: @175057
     /*  175057 */ GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(175115), // Rule ID 279 //
     /*  175062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  175065 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175068 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175072 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175083 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175087 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175094 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  175094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  175097 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175113 */   GIR_RootConstrainSelectedInstOperands,
     /*  175114 */   // GIR_Coverage, 279,
     /*  175114 */   GIR_EraseRootFromParent_Done,
     /*  175115 */ // Label 3280: @175115
     /*  175115 */ GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(175166), // Rule ID 280 //
     /*  175120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  175123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175126 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175134 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175138 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175145 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  175145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  175148 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175160 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175164 */   GIR_RootConstrainSelectedInstOperands,
     /*  175165 */   // GIR_Coverage, 280,
     /*  175165 */   GIR_EraseRootFromParent_Done,
     /*  175166 */ // Label 3281: @175166
     /*  175166 */ GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(175217), // Rule ID 1827 //
     /*  175171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  175174 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175177 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  175185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175196 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  175196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  175199 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175215 */   GIR_RootConstrainSelectedInstOperands,
     /*  175216 */   // GIR_Coverage, 1827,
     /*  175216 */   GIR_EraseRootFromParent_Done,
     /*  175217 */ // Label 3282: @175217
     /*  175217 */ GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(175268), // Rule ID 1828 //
     /*  175222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  175225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175228 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  175236 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175240 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175247 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  175247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  175250 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175262 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175266 */   GIR_RootConstrainSelectedInstOperands,
     /*  175267 */   // GIR_Coverage, 1828,
     /*  175267 */   GIR_EraseRootFromParent_Done,
     /*  175268 */ // Label 3283: @175268
     /*  175268 */ GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(175319), // Rule ID 1831 //
     /*  175273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  175276 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175279 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175287 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175291 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175298 */   // (st GPR:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  175298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  175301 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175313 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175317 */   GIR_RootConstrainSelectedInstOperands,
     /*  175318 */   // GIR_Coverage, 1831,
     /*  175318 */   GIR_EraseRootFromParent_Done,
     /*  175319 */ // Label 3284: @175319
     /*  175319 */ GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(175370), // Rule ID 1836 //
     /*  175324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0),
     /*  175327 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175330 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  175338 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175342 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175349 */   // (st GPRPair:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD_RV32 GPRPair:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  175349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RV32),
     /*  175352 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175364 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175368 */   GIR_RootConstrainSelectedInstOperands,
     /*  175369 */   // GIR_Coverage, 1836,
     /*  175369 */   GIR_EraseRootFromParent_Done,
     /*  175370 */ // Label 3285: @175370
     /*  175370 */ GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(175421), // Rule ID 1837 //
     /*  175375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1),
     /*  175378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175381 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  175389 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175393 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175400 */   // (st GPRPair:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD_RV32 GPRPair:{ *:[f64] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  175400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RV32),
     /*  175403 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175415 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175419 */   GIR_RootConstrainSelectedInstOperands,
     /*  175420 */   // GIR_Coverage, 1837,
     /*  175420 */   GIR_EraseRootFromParent_Done,
     /*  175421 */ // Label 3286: @175421
     /*  175421 */ GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(175467), // Rule ID 1107 //
     /*  175426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  175429 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175432 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  175439 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175446 */   // MIs[0] rs1
     /*  175446 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175454 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10579>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  175457 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175459 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175465 */   GIR_RootConstrainSelectedInstOperands,
     /*  175466 */   // GIR_Coverage, 1107,
     /*  175466 */   GIR_EraseRootFromParent_Done,
     /*  175467 */ // Label 3287: @175467
     /*  175467 */ GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(175513), // Rule ID 1109 //
     /*  175472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  175475 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175478 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  175485 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  175488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175492 */   // MIs[0] rs1
     /*  175492 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175500 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10581>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  175503 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175505 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175507 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175511 */   GIR_RootConstrainSelectedInstOperands,
     /*  175512 */   // GIR_Coverage, 1109,
     /*  175512 */   GIR_EraseRootFromParent_Done,
     /*  175513 */ // Label 3288: @175513
     /*  175513 */ GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(175559), // Rule ID 1111 //
     /*  175518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  175521 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175524 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  175531 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175538 */   // MIs[0] rs1
     /*  175538 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175546 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10583>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  175549 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175551 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175553 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175557 */   GIR_RootConstrainSelectedInstOperands,
     /*  175558 */   // GIR_Coverage, 1111,
     /*  175558 */   GIR_EraseRootFromParent_Done,
     /*  175559 */ // Label 3289: @175559
     /*  175559 */ GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(175605), // Rule ID 1113 //
     /*  175564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  175567 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175570 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  175577 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  175580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175584 */   // MIs[0] rs1
     /*  175584 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175592 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10585>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  175595 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175597 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175599 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175603 */   GIR_RootConstrainSelectedInstOperands,
     /*  175604 */   // GIR_Coverage, 1113,
     /*  175604 */   GIR_EraseRootFromParent_Done,
     /*  175605 */ // Label 3290: @175605
     /*  175605 */ GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(175651), // Rule ID 1115 //
     /*  175610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  175613 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175616 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175623 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175630 */   // MIs[0] rs1
     /*  175630 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175638 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10587>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  175641 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175643 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175645 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175649 */   GIR_RootConstrainSelectedInstOperands,
     /*  175650 */   // GIR_Coverage, 1115,
     /*  175650 */   GIR_EraseRootFromParent_Done,
     /*  175651 */ // Label 3291: @175651
     /*  175651 */ GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(175697), // Rule ID 1117 //
     /*  175656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  175659 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175662 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  175672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175676 */   // MIs[0] rs1
     /*  175676 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175684 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10589>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  175687 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175689 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175691 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175695 */   GIR_RootConstrainSelectedInstOperands,
     /*  175696 */   // GIR_Coverage, 1117,
     /*  175696 */   GIR_EraseRootFromParent_Done,
     /*  175697 */ // Label 3292: @175697
     /*  175697 */ GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(175743), // Rule ID 1135 //
     /*  175702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  175705 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175708 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  175715 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175722 */   // MIs[0] rs1
     /*  175722 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175730 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10603>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  175733 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175735 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175737 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175741 */   GIR_RootConstrainSelectedInstOperands,
     /*  175742 */   // GIR_Coverage, 1135,
     /*  175742 */   GIR_EraseRootFromParent_Done,
     /*  175743 */ // Label 3293: @175743
     /*  175743 */ GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(175789), // Rule ID 1137 //
     /*  175748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  175751 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175754 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  175761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  175764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175768 */   // MIs[0] rs1
     /*  175768 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175776 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10605>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  175779 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175781 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175783 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175787 */   GIR_RootConstrainSelectedInstOperands,
     /*  175788 */   // GIR_Coverage, 1137,
     /*  175788 */   GIR_EraseRootFromParent_Done,
     /*  175789 */ // Label 3294: @175789
     /*  175789 */ GIM_Reject,
     /*  175790 */ // Label 3189: @175790
     /*  175790 */ GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(175869),
     /*  175795 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175798 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175806 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175814 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(175841), // Rule ID 45736 //
     /*  175819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175822 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  175822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  175825 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175839 */     GIR_RootConstrainSelectedInstOperands,
     /*  175840 */     // GIR_Coverage, 45736,
     /*  175840 */     GIR_EraseRootFromParent_Done,
     /*  175841 */   // Label 3296: @175841
     /*  175841 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(175868), // Rule ID 45737 //
     /*  175846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175849 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  175849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  175852 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175866 */     GIR_RootConstrainSelectedInstOperands,
     /*  175867 */     // GIR_Coverage, 45737,
     /*  175867 */     GIR_EraseRootFromParent_Done,
     /*  175868 */   // Label 3297: @175868
     /*  175868 */   GIM_Reject,
     /*  175869 */ // Label 3295: @175869
     /*  175869 */ GIM_Reject,
     /*  175870 */ // Label 3190: @175870
     /*  175870 */ GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(175957),
     /*  175875 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175878 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175886 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(175921), // Rule ID 45732 //
     /*  175891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175894 */     // MIs[0] rs1
     /*  175894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175902 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  175902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  175905 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175919 */     GIR_RootConstrainSelectedInstOperands,
     /*  175920 */     // GIR_Coverage, 45732,
     /*  175920 */     GIR_EraseRootFromParent_Done,
     /*  175921 */   // Label 3299: @175921
     /*  175921 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(175956), // Rule ID 45733 //
     /*  175926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175929 */     // MIs[0] rs1
     /*  175929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175937 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  175937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  175940 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175954 */     GIR_RootConstrainSelectedInstOperands,
     /*  175955 */     // GIR_Coverage, 45733,
     /*  175955 */     GIR_EraseRootFromParent_Done,
     /*  175956 */   // Label 3300: @175956
     /*  175956 */   GIM_Reject,
     /*  175957 */ // Label 3298: @175957
     /*  175957 */ GIM_Reject,
     /*  175958 */ // Label 3191: @175958
     /*  175958 */ GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(176115),
     /*  175963 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175966 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175974 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(176009), // Rule ID 45928 //
     /*  175979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175982 */     // MIs[0] rs1
     /*  175982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175990 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  175993 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176007 */     GIR_RootConstrainSelectedInstOperands,
     /*  176008 */     // GIR_Coverage, 45928,
     /*  176008 */     GIR_EraseRootFromParent_Done,
     /*  176009 */   // Label 3302: @176009
     /*  176009 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(176044), // Rule ID 45929 //
     /*  176014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176017 */     // MIs[0] rs1
     /*  176017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176025 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  176025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  176028 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176042 */     GIR_RootConstrainSelectedInstOperands,
     /*  176043 */     // GIR_Coverage, 45929,
     /*  176043 */     GIR_EraseRootFromParent_Done,
     /*  176044 */   // Label 3303: @176044
     /*  176044 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(176079), // Rule ID 46004 //
     /*  176049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  176052 */     // MIs[0] rs1
     /*  176052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176060 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  176060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  176063 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176077 */     GIR_RootConstrainSelectedInstOperands,
     /*  176078 */     // GIR_Coverage, 46004,
     /*  176078 */     GIR_EraseRootFromParent_Done,
     /*  176079 */   // Label 3304: @176079
     /*  176079 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(176114), // Rule ID 46005 //
     /*  176084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  176087 */     // MIs[0] rs1
     /*  176087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176095 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  176095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  176098 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176112 */     GIR_RootConstrainSelectedInstOperands,
     /*  176113 */     // GIR_Coverage, 46005,
     /*  176113 */     GIR_EraseRootFromParent_Done,
     /*  176114 */   // Label 3305: @176114
     /*  176114 */   GIM_Reject,
     /*  176115 */ // Label 3301: @176115
     /*  176115 */ GIM_Reject,
     /*  176116 */ // Label 3192: @176116
     /*  176116 */ GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(176273),
     /*  176121 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176124 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176132 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(176167), // Rule ID 45936 //
     /*  176137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176140 */     // MIs[0] rs1
     /*  176140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176148 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  176148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  176151 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176165 */     GIR_RootConstrainSelectedInstOperands,
     /*  176166 */     // GIR_Coverage, 45936,
     /*  176166 */     GIR_EraseRootFromParent_Done,
     /*  176167 */   // Label 3307: @176167
     /*  176167 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(176202), // Rule ID 45937 //
     /*  176172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176175 */     // MIs[0] rs1
     /*  176175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176183 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  176183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  176186 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176200 */     GIR_RootConstrainSelectedInstOperands,
     /*  176201 */     // GIR_Coverage, 45937,
     /*  176201 */     GIR_EraseRootFromParent_Done,
     /*  176202 */   // Label 3308: @176202
     /*  176202 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(176237), // Rule ID 46012 //
     /*  176207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  176210 */     // MIs[0] rs1
     /*  176210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176218 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  176218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  176221 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176235 */     GIR_RootConstrainSelectedInstOperands,
     /*  176236 */     // GIR_Coverage, 46012,
     /*  176236 */     GIR_EraseRootFromParent_Done,
     /*  176237 */   // Label 3309: @176237
     /*  176237 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(176272), // Rule ID 46013 //
     /*  176242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  176245 */     // MIs[0] rs1
     /*  176245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176253 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  176253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  176256 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176270 */     GIR_RootConstrainSelectedInstOperands,
     /*  176271 */     // GIR_Coverage, 46013,
     /*  176271 */     GIR_EraseRootFromParent_Done,
     /*  176272 */   // Label 3310: @176272
     /*  176272 */   GIM_Reject,
     /*  176273 */ // Label 3306: @176273
     /*  176273 */ GIM_Reject,
     /*  176274 */ // Label 3193: @176274
     /*  176274 */ GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(176431),
     /*  176279 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176282 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176290 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(176325), // Rule ID 45952 //
     /*  176295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  176298 */     // MIs[0] rs1
     /*  176298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176306 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  176306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  176309 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176323 */     GIR_RootConstrainSelectedInstOperands,
     /*  176324 */     // GIR_Coverage, 45952,
     /*  176324 */     GIR_EraseRootFromParent_Done,
     /*  176325 */   // Label 3312: @176325
     /*  176325 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(176360), // Rule ID 45953 //
     /*  176330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  176333 */     // MIs[0] rs1
     /*  176333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176341 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  176341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  176344 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176358 */     GIR_RootConstrainSelectedInstOperands,
     /*  176359 */     // GIR_Coverage, 45953,
     /*  176359 */     GIR_EraseRootFromParent_Done,
     /*  176360 */   // Label 3313: @176360
     /*  176360 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(176395), // Rule ID 46024 //
     /*  176365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  176368 */     // MIs[0] rs1
     /*  176368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176376 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  176376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  176379 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176393 */     GIR_RootConstrainSelectedInstOperands,
     /*  176394 */     // GIR_Coverage, 46024,
     /*  176394 */     GIR_EraseRootFromParent_Done,
     /*  176395 */   // Label 3314: @176395
     /*  176395 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(176430), // Rule ID 46025 //
     /*  176400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  176403 */     // MIs[0] rs1
     /*  176403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176411 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  176411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  176414 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176428 */     GIR_RootConstrainSelectedInstOperands,
     /*  176429 */     // GIR_Coverage, 46025,
     /*  176429 */     GIR_EraseRootFromParent_Done,
     /*  176430 */   // Label 3315: @176430
     /*  176430 */   GIM_Reject,
     /*  176431 */ // Label 3311: @176431
     /*  176431 */ GIM_Reject,
     /*  176432 */ // Label 3194: @176432
     /*  176432 */ GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(176511),
     /*  176437 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176440 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176448 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  176452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176456 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(176483), // Rule ID 46064 //
     /*  176461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176464 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  176464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  176467 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  176477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176481 */     GIR_RootConstrainSelectedInstOperands,
     /*  176482 */     // GIR_Coverage, 46064,
     /*  176482 */     GIR_EraseRootFromParent_Done,
     /*  176483 */   // Label 3317: @176483
     /*  176483 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(176510), // Rule ID 46065 //
     /*  176488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176491 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  176491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  176494 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  176504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176508 */     GIR_RootConstrainSelectedInstOperands,
     /*  176509 */     // GIR_Coverage, 46065,
     /*  176509 */     GIR_EraseRootFromParent_Done,
     /*  176510 */   // Label 3318: @176510
     /*  176510 */   GIM_Reject,
     /*  176511 */ // Label 3316: @176511
     /*  176511 */ GIM_Reject,
     /*  176512 */ // Label 3195: @176512
     /*  176512 */ GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(176599),
     /*  176517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176520 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176528 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(176563), // Rule ID 45920 //
     /*  176533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176536 */     // MIs[0] rs1
     /*  176536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176544 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  176544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  176547 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  176557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176561 */     GIR_RootConstrainSelectedInstOperands,
     /*  176562 */     // GIR_Coverage, 45920,
     /*  176562 */     GIR_EraseRootFromParent_Done,
     /*  176563 */   // Label 3320: @176563
     /*  176563 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(176598), // Rule ID 45921 //
     /*  176568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176571 */     // MIs[0] rs1
     /*  176571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176579 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  176579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  176582 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  176592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176596 */     GIR_RootConstrainSelectedInstOperands,
     /*  176597 */     // GIR_Coverage, 45921,
     /*  176597 */     GIR_EraseRootFromParent_Done,
     /*  176598 */   // Label 3321: @176598
     /*  176598 */   GIM_Reject,
     /*  176599 */ // Label 3319: @176599
     /*  176599 */ GIM_Reject,
     /*  176600 */ // Label 3196: @176600
     /*  176600 */ GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(176757),
     /*  176605 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176608 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176616 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(176651), // Rule ID 45932 //
     /*  176621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176624 */     // MIs[0] rs1
     /*  176624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176632 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  176632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  176635 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176649 */     GIR_RootConstrainSelectedInstOperands,
     /*  176650 */     // GIR_Coverage, 45932,
     /*  176650 */     GIR_EraseRootFromParent_Done,
     /*  176651 */   // Label 3323: @176651
     /*  176651 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(176686), // Rule ID 45933 //
     /*  176656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176659 */     // MIs[0] rs1
     /*  176659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176667 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  176667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  176670 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176684 */     GIR_RootConstrainSelectedInstOperands,
     /*  176685 */     // GIR_Coverage, 45933,
     /*  176685 */     GIR_EraseRootFromParent_Done,
     /*  176686 */   // Label 3324: @176686
     /*  176686 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(176721), // Rule ID 46008 //
     /*  176691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  176694 */     // MIs[0] rs1
     /*  176694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176702 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  176702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  176705 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176719 */     GIR_RootConstrainSelectedInstOperands,
     /*  176720 */     // GIR_Coverage, 46008,
     /*  176720 */     GIR_EraseRootFromParent_Done,
     /*  176721 */   // Label 3325: @176721
     /*  176721 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(176756), // Rule ID 46009 //
     /*  176726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  176729 */     // MIs[0] rs1
     /*  176729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176737 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  176737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  176740 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176754 */     GIR_RootConstrainSelectedInstOperands,
     /*  176755 */     // GIR_Coverage, 46009,
     /*  176755 */     GIR_EraseRootFromParent_Done,
     /*  176756 */   // Label 3326: @176756
     /*  176756 */   GIM_Reject,
     /*  176757 */ // Label 3322: @176757
     /*  176757 */ GIM_Reject,
     /*  176758 */ // Label 3197: @176758
     /*  176758 */ GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(176915),
     /*  176763 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176766 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176774 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(176809), // Rule ID 45948 //
     /*  176779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176782 */     // MIs[0] rs1
     /*  176782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176790 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  176790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  176793 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176807 */     GIR_RootConstrainSelectedInstOperands,
     /*  176808 */     // GIR_Coverage, 45948,
     /*  176808 */     GIR_EraseRootFromParent_Done,
     /*  176809 */   // Label 3328: @176809
     /*  176809 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(176844), // Rule ID 45949 //
     /*  176814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176817 */     // MIs[0] rs1
     /*  176817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176825 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  176825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  176828 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176842 */     GIR_RootConstrainSelectedInstOperands,
     /*  176843 */     // GIR_Coverage, 45949,
     /*  176843 */     GIR_EraseRootFromParent_Done,
     /*  176844 */   // Label 3329: @176844
     /*  176844 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(176879), // Rule ID 46020 //
     /*  176849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  176852 */     // MIs[0] rs1
     /*  176852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176860 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  176860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  176863 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176877 */     GIR_RootConstrainSelectedInstOperands,
     /*  176878 */     // GIR_Coverage, 46020,
     /*  176878 */     GIR_EraseRootFromParent_Done,
     /*  176879 */   // Label 3330: @176879
     /*  176879 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(176914), // Rule ID 46021 //
     /*  176884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  176887 */     // MIs[0] rs1
     /*  176887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176895 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  176895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  176898 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176912 */     GIR_RootConstrainSelectedInstOperands,
     /*  176913 */     // GIR_Coverage, 46021,
     /*  176913 */     GIR_EraseRootFromParent_Done,
     /*  176914 */   // Label 3331: @176914
     /*  176914 */   GIM_Reject,
     /*  176915 */ // Label 3327: @176915
     /*  176915 */ GIM_Reject,
     /*  176916 */ // Label 3198: @176916
     /*  176916 */ GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(177073),
     /*  176921 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176924 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  176932 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(176967), // Rule ID 45992 //
     /*  176937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  176940 */     // MIs[0] rs1
     /*  176940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176948 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  176948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  176951 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176965 */     GIR_RootConstrainSelectedInstOperands,
     /*  176966 */     // GIR_Coverage, 45992,
     /*  176966 */     GIR_EraseRootFromParent_Done,
     /*  176967 */   // Label 3333: @176967
     /*  176967 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(177002), // Rule ID 45993 //
     /*  176972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  176975 */     // MIs[0] rs1
     /*  176975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176983 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  176983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  176986 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177000 */     GIR_RootConstrainSelectedInstOperands,
     /*  177001 */     // GIR_Coverage, 45993,
     /*  177001 */     GIR_EraseRootFromParent_Done,
     /*  177002 */   // Label 3334: @177002
     /*  177002 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(177037), // Rule ID 46052 //
     /*  177007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  177010 */     // MIs[0] rs1
     /*  177010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177018 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  177018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  177021 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177035 */     GIR_RootConstrainSelectedInstOperands,
     /*  177036 */     // GIR_Coverage, 46052,
     /*  177036 */     GIR_EraseRootFromParent_Done,
     /*  177037 */   // Label 3335: @177037
     /*  177037 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(177072), // Rule ID 46053 //
     /*  177042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  177045 */     // MIs[0] rs1
     /*  177045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177053 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  177053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  177056 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177070 */     GIR_RootConstrainSelectedInstOperands,
     /*  177071 */     // GIR_Coverage, 46053,
     /*  177071 */     GIR_EraseRootFromParent_Done,
     /*  177072 */   // Label 3336: @177072
     /*  177072 */   GIM_Reject,
     /*  177073 */ // Label 3332: @177073
     /*  177073 */ GIM_Reject,
     /*  177074 */ // Label 3199: @177074
     /*  177074 */ GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(177153),
     /*  177079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177082 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177090 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177098 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(177125), // Rule ID 46068 //
     /*  177103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177106 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  177106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  177109 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  177119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177123 */     GIR_RootConstrainSelectedInstOperands,
     /*  177124 */     // GIR_Coverage, 46068,
     /*  177124 */     GIR_EraseRootFromParent_Done,
     /*  177125 */   // Label 3338: @177125
     /*  177125 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(177152), // Rule ID 46069 //
     /*  177130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177133 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  177133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  177136 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  177146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177150 */     GIR_RootConstrainSelectedInstOperands,
     /*  177151 */     // GIR_Coverage, 46069,
     /*  177151 */     GIR_EraseRootFromParent_Done,
     /*  177152 */   // Label 3339: @177152
     /*  177152 */   GIM_Reject,
     /*  177153 */ // Label 3337: @177153
     /*  177153 */ GIM_Reject,
     /*  177154 */ // Label 3200: @177154
     /*  177154 */ GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(177241),
     /*  177159 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177162 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177170 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(177205), // Rule ID 45924 //
     /*  177175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177178 */     // MIs[0] rs1
     /*  177178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177186 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  177186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  177189 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  177199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177203 */     GIR_RootConstrainSelectedInstOperands,
     /*  177204 */     // GIR_Coverage, 45924,
     /*  177204 */     GIR_EraseRootFromParent_Done,
     /*  177205 */   // Label 3341: @177205
     /*  177205 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(177240), // Rule ID 45925 //
     /*  177210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177213 */     // MIs[0] rs1
     /*  177213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177221 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  177221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  177224 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  177234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177238 */     GIR_RootConstrainSelectedInstOperands,
     /*  177239 */     // GIR_Coverage, 45925,
     /*  177239 */     GIR_EraseRootFromParent_Done,
     /*  177240 */   // Label 3342: @177240
     /*  177240 */   GIM_Reject,
     /*  177241 */ // Label 3340: @177241
     /*  177241 */ GIM_Reject,
     /*  177242 */ // Label 3201: @177242
     /*  177242 */ GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(177399),
     /*  177247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177258 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(177293), // Rule ID 45944 //
     /*  177263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177266 */     // MIs[0] rs1
     /*  177266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177274 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  177274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  177277 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177291 */     GIR_RootConstrainSelectedInstOperands,
     /*  177292 */     // GIR_Coverage, 45944,
     /*  177292 */     GIR_EraseRootFromParent_Done,
     /*  177293 */   // Label 3344: @177293
     /*  177293 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(177328), // Rule ID 45945 //
     /*  177298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177301 */     // MIs[0] rs1
     /*  177301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177309 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  177309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  177312 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177326 */     GIR_RootConstrainSelectedInstOperands,
     /*  177327 */     // GIR_Coverage, 45945,
     /*  177327 */     GIR_EraseRootFromParent_Done,
     /*  177328 */   // Label 3345: @177328
     /*  177328 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(177363), // Rule ID 46016 //
     /*  177333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  177336 */     // MIs[0] rs1
     /*  177336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177344 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  177344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  177347 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177361 */     GIR_RootConstrainSelectedInstOperands,
     /*  177362 */     // GIR_Coverage, 46016,
     /*  177362 */     GIR_EraseRootFromParent_Done,
     /*  177363 */   // Label 3346: @177363
     /*  177363 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(177398), // Rule ID 46017 //
     /*  177368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  177371 */     // MIs[0] rs1
     /*  177371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177379 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  177379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  177382 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177396 */     GIR_RootConstrainSelectedInstOperands,
     /*  177397 */     // GIR_Coverage, 46017,
     /*  177397 */     GIR_EraseRootFromParent_Done,
     /*  177398 */   // Label 3347: @177398
     /*  177398 */   GIM_Reject,
     /*  177399 */ // Label 3343: @177399
     /*  177399 */ GIM_Reject,
     /*  177400 */ // Label 3202: @177400
     /*  177400 */ GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(177557),
     /*  177405 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177408 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177416 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(177451), // Rule ID 45980 //
     /*  177421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177424 */     // MIs[0] rs1
     /*  177424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177432 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  177432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  177435 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177449 */     GIR_RootConstrainSelectedInstOperands,
     /*  177450 */     // GIR_Coverage, 45980,
     /*  177450 */     GIR_EraseRootFromParent_Done,
     /*  177451 */   // Label 3349: @177451
     /*  177451 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(177486), // Rule ID 45981 //
     /*  177456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177459 */     // MIs[0] rs1
     /*  177459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177467 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  177467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  177470 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177484 */     GIR_RootConstrainSelectedInstOperands,
     /*  177485 */     // GIR_Coverage, 45981,
     /*  177485 */     GIR_EraseRootFromParent_Done,
     /*  177486 */   // Label 3350: @177486
     /*  177486 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(177521), // Rule ID 46040 //
     /*  177491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  177494 */     // MIs[0] rs1
     /*  177494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177502 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  177502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  177505 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177519 */     GIR_RootConstrainSelectedInstOperands,
     /*  177520 */     // GIR_Coverage, 46040,
     /*  177520 */     GIR_EraseRootFromParent_Done,
     /*  177521 */   // Label 3351: @177521
     /*  177521 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(177556), // Rule ID 46041 //
     /*  177526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  177529 */     // MIs[0] rs1
     /*  177529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177537 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  177537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  177540 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177554 */     GIR_RootConstrainSelectedInstOperands,
     /*  177555 */     // GIR_Coverage, 46041,
     /*  177555 */     GIR_EraseRootFromParent_Done,
     /*  177556 */   // Label 3352: @177556
     /*  177556 */   GIM_Reject,
     /*  177557 */ // Label 3348: @177557
     /*  177557 */ GIM_Reject,
     /*  177558 */ // Label 3203: @177558
     /*  177558 */ GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(177715),
     /*  177563 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177566 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177574 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(177609), // Rule ID 45996 //
     /*  177579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  177582 */     // MIs[0] rs1
     /*  177582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177590 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  177590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  177593 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177607 */     GIR_RootConstrainSelectedInstOperands,
     /*  177608 */     // GIR_Coverage, 45996,
     /*  177608 */     GIR_EraseRootFromParent_Done,
     /*  177609 */   // Label 3354: @177609
     /*  177609 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(177644), // Rule ID 45997 //
     /*  177614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  177617 */     // MIs[0] rs1
     /*  177617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177625 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  177625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  177628 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177642 */     GIR_RootConstrainSelectedInstOperands,
     /*  177643 */     // GIR_Coverage, 45997,
     /*  177643 */     GIR_EraseRootFromParent_Done,
     /*  177644 */   // Label 3355: @177644
     /*  177644 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(177679), // Rule ID 46056 //
     /*  177649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  177652 */     // MIs[0] rs1
     /*  177652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177660 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  177660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  177663 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177677 */     GIR_RootConstrainSelectedInstOperands,
     /*  177678 */     // GIR_Coverage, 46056,
     /*  177678 */     GIR_EraseRootFromParent_Done,
     /*  177679 */   // Label 3356: @177679
     /*  177679 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(177714), // Rule ID 46057 //
     /*  177684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  177687 */     // MIs[0] rs1
     /*  177687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177695 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  177695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  177698 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177712 */     GIR_RootConstrainSelectedInstOperands,
     /*  177713 */     // GIR_Coverage, 46057,
     /*  177713 */     GIR_EraseRootFromParent_Done,
     /*  177714 */   // Label 3357: @177714
     /*  177714 */   GIM_Reject,
     /*  177715 */ // Label 3353: @177715
     /*  177715 */ GIM_Reject,
     /*  177716 */ // Label 3204: @177716
     /*  177716 */ GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(177795),
     /*  177721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177724 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177732 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177740 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(177767), // Rule ID 46072 //
     /*  177745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177748 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  177748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  177751 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  177761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177765 */     GIR_RootConstrainSelectedInstOperands,
     /*  177766 */     // GIR_Coverage, 46072,
     /*  177766 */     GIR_EraseRootFromParent_Done,
     /*  177767 */   // Label 3359: @177767
     /*  177767 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(177794), // Rule ID 46073 //
     /*  177772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177775 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  177775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  177778 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  177788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177792 */     GIR_RootConstrainSelectedInstOperands,
     /*  177793 */     // GIR_Coverage, 46073,
     /*  177793 */     GIR_EraseRootFromParent_Done,
     /*  177794 */   // Label 3360: @177794
     /*  177794 */   GIM_Reject,
     /*  177795 */ // Label 3358: @177795
     /*  177795 */ GIM_Reject,
     /*  177796 */ // Label 3205: @177796
     /*  177796 */ GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(177883),
     /*  177801 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177804 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177812 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(177847), // Rule ID 45940 //
     /*  177817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177820 */     // MIs[0] rs1
     /*  177820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177828 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  177828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  177831 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  177841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177845 */     GIR_RootConstrainSelectedInstOperands,
     /*  177846 */     // GIR_Coverage, 45940,
     /*  177846 */     GIR_EraseRootFromParent_Done,
     /*  177847 */   // Label 3362: @177847
     /*  177847 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(177882), // Rule ID 45941 //
     /*  177852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177855 */     // MIs[0] rs1
     /*  177855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177863 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  177863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  177866 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  177876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177880 */     GIR_RootConstrainSelectedInstOperands,
     /*  177881 */     // GIR_Coverage, 45941,
     /*  177881 */     GIR_EraseRootFromParent_Done,
     /*  177882 */   // Label 3363: @177882
     /*  177882 */   GIM_Reject,
     /*  177883 */ // Label 3361: @177883
     /*  177883 */ GIM_Reject,
     /*  177884 */ // Label 3206: @177884
     /*  177884 */ GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(178041),
     /*  177889 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177892 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177900 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(177935), // Rule ID 45968 //
     /*  177905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177908 */     // MIs[0] rs1
     /*  177908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177916 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  177916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  177919 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177933 */     GIR_RootConstrainSelectedInstOperands,
     /*  177934 */     // GIR_Coverage, 45968,
     /*  177934 */     GIR_EraseRootFromParent_Done,
     /*  177935 */   // Label 3365: @177935
     /*  177935 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(177970), // Rule ID 45969 //
     /*  177940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177943 */     // MIs[0] rs1
     /*  177943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177951 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  177951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  177954 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177968 */     GIR_RootConstrainSelectedInstOperands,
     /*  177969 */     // GIR_Coverage, 45969,
     /*  177969 */     GIR_EraseRootFromParent_Done,
     /*  177970 */   // Label 3366: @177970
     /*  177970 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(178005), // Rule ID 46028 //
     /*  177975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  177978 */     // MIs[0] rs1
     /*  177978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177986 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  177986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  177989 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178003 */     GIR_RootConstrainSelectedInstOperands,
     /*  178004 */     // GIR_Coverage, 46028,
     /*  178004 */     GIR_EraseRootFromParent_Done,
     /*  178005 */   // Label 3367: @178005
     /*  178005 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(178040), // Rule ID 46029 //
     /*  178010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  178013 */     // MIs[0] rs1
     /*  178013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178021 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  178021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  178024 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178038 */     GIR_RootConstrainSelectedInstOperands,
     /*  178039 */     // GIR_Coverage, 46029,
     /*  178039 */     GIR_EraseRootFromParent_Done,
     /*  178040 */   // Label 3368: @178040
     /*  178040 */   GIM_Reject,
     /*  178041 */ // Label 3364: @178041
     /*  178041 */ GIM_Reject,
     /*  178042 */ // Label 3207: @178042
     /*  178042 */ GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(178199),
     /*  178047 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178050 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  178058 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(178093), // Rule ID 45984 //
     /*  178063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178066 */     // MIs[0] rs1
     /*  178066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178074 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  178074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  178077 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178091 */     GIR_RootConstrainSelectedInstOperands,
     /*  178092 */     // GIR_Coverage, 45984,
     /*  178092 */     GIR_EraseRootFromParent_Done,
     /*  178093 */   // Label 3370: @178093
     /*  178093 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(178128), // Rule ID 45985 //
     /*  178098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178101 */     // MIs[0] rs1
     /*  178101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178109 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  178109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  178112 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178126 */     GIR_RootConstrainSelectedInstOperands,
     /*  178127 */     // GIR_Coverage, 45985,
     /*  178127 */     GIR_EraseRootFromParent_Done,
     /*  178128 */   // Label 3371: @178128
     /*  178128 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(178163), // Rule ID 46044 //
     /*  178133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  178136 */     // MIs[0] rs1
     /*  178136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178144 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  178144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  178147 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178161 */     GIR_RootConstrainSelectedInstOperands,
     /*  178162 */     // GIR_Coverage, 46044,
     /*  178162 */     GIR_EraseRootFromParent_Done,
     /*  178163 */   // Label 3372: @178163
     /*  178163 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(178198), // Rule ID 46045 //
     /*  178168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  178171 */     // MIs[0] rs1
     /*  178171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178179 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  178179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  178182 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178196 */     GIR_RootConstrainSelectedInstOperands,
     /*  178197 */     // GIR_Coverage, 46045,
     /*  178197 */     GIR_EraseRootFromParent_Done,
     /*  178198 */   // Label 3373: @178198
     /*  178198 */   GIM_Reject,
     /*  178199 */ // Label 3369: @178199
     /*  178199 */ GIM_Reject,
     /*  178200 */ // Label 3208: @178200
     /*  178200 */ GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(178357),
     /*  178205 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178208 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  178216 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(178251), // Rule ID 46000 //
     /*  178221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  178224 */     // MIs[0] rs1
     /*  178224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178232 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  178232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  178235 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178249 */     GIR_RootConstrainSelectedInstOperands,
     /*  178250 */     // GIR_Coverage, 46000,
     /*  178250 */     GIR_EraseRootFromParent_Done,
     /*  178251 */   // Label 3375: @178251
     /*  178251 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(178286), // Rule ID 46001 //
     /*  178256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  178259 */     // MIs[0] rs1
     /*  178259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178267 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  178267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  178270 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178284 */     GIR_RootConstrainSelectedInstOperands,
     /*  178285 */     // GIR_Coverage, 46001,
     /*  178285 */     GIR_EraseRootFromParent_Done,
     /*  178286 */   // Label 3376: @178286
     /*  178286 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(178321), // Rule ID 46060 //
     /*  178291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  178294 */     // MIs[0] rs1
     /*  178294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178302 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  178302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  178305 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178319 */     GIR_RootConstrainSelectedInstOperands,
     /*  178320 */     // GIR_Coverage, 46060,
     /*  178320 */     GIR_EraseRootFromParent_Done,
     /*  178321 */   // Label 3377: @178321
     /*  178321 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(178356), // Rule ID 46061 //
     /*  178326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  178329 */     // MIs[0] rs1
     /*  178329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178337 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  178337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  178340 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178354 */     GIR_RootConstrainSelectedInstOperands,
     /*  178355 */     // GIR_Coverage, 46061,
     /*  178355 */     GIR_EraseRootFromParent_Done,
     /*  178356 */   // Label 3378: @178356
     /*  178356 */   GIM_Reject,
     /*  178357 */ // Label 3374: @178357
     /*  178357 */ GIM_Reject,
     /*  178358 */ // Label 3209: @178358
     /*  178358 */ GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(178437),
     /*  178363 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178366 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178374 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178382 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(178409), // Rule ID 46076 //
     /*  178387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178390 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  178390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  178393 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  178403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178407 */     GIR_RootConstrainSelectedInstOperands,
     /*  178408 */     // GIR_Coverage, 46076,
     /*  178408 */     GIR_EraseRootFromParent_Done,
     /*  178409 */   // Label 3380: @178409
     /*  178409 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(178436), // Rule ID 46077 //
     /*  178414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178417 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  178417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  178420 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  178430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178434 */     GIR_RootConstrainSelectedInstOperands,
     /*  178435 */     // GIR_Coverage, 46077,
     /*  178435 */     GIR_EraseRootFromParent_Done,
     /*  178436 */   // Label 3381: @178436
     /*  178436 */   GIM_Reject,
     /*  178437 */ // Label 3379: @178437
     /*  178437 */ GIM_Reject,
     /*  178438 */ // Label 3210: @178438
     /*  178438 */ GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(178525),
     /*  178443 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178446 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  178454 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(178489), // Rule ID 45956 //
     /*  178459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178462 */     // MIs[0] rs1
     /*  178462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178470 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  178470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  178473 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178487 */     GIR_RootConstrainSelectedInstOperands,
     /*  178488 */     // GIR_Coverage, 45956,
     /*  178488 */     GIR_EraseRootFromParent_Done,
     /*  178489 */   // Label 3383: @178489
     /*  178489 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(178524), // Rule ID 45957 //
     /*  178494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178497 */     // MIs[0] rs1
     /*  178497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178505 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  178505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  178508 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178522 */     GIR_RootConstrainSelectedInstOperands,
     /*  178523 */     // GIR_Coverage, 45957,
     /*  178523 */     GIR_EraseRootFromParent_Done,
     /*  178524 */   // Label 3384: @178524
     /*  178524 */   GIM_Reject,
     /*  178525 */ // Label 3382: @178525
     /*  178525 */ GIM_Reject,
     /*  178526 */ // Label 3211: @178526
     /*  178526 */ GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(178683),
     /*  178531 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178534 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  178542 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(178577), // Rule ID 45972 //
     /*  178547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178550 */     // MIs[0] rs1
     /*  178550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178558 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  178558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  178561 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178575 */     GIR_RootConstrainSelectedInstOperands,
     /*  178576 */     // GIR_Coverage, 45972,
     /*  178576 */     GIR_EraseRootFromParent_Done,
     /*  178577 */   // Label 3386: @178577
     /*  178577 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(178612), // Rule ID 45973 //
     /*  178582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178585 */     // MIs[0] rs1
     /*  178585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178593 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  178593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  178596 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178610 */     GIR_RootConstrainSelectedInstOperands,
     /*  178611 */     // GIR_Coverage, 45973,
     /*  178611 */     GIR_EraseRootFromParent_Done,
     /*  178612 */   // Label 3387: @178612
     /*  178612 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(178647), // Rule ID 46032 //
     /*  178617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  178620 */     // MIs[0] rs1
     /*  178620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178628 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  178628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  178631 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178645 */     GIR_RootConstrainSelectedInstOperands,
     /*  178646 */     // GIR_Coverage, 46032,
     /*  178646 */     GIR_EraseRootFromParent_Done,
     /*  178647 */   // Label 3388: @178647
     /*  178647 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(178682), // Rule ID 46033 //
     /*  178652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  178655 */     // MIs[0] rs1
     /*  178655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178663 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  178663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  178666 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178680 */     GIR_RootConstrainSelectedInstOperands,
     /*  178681 */     // GIR_Coverage, 46033,
     /*  178681 */     GIR_EraseRootFromParent_Done,
     /*  178682 */   // Label 3389: @178682
     /*  178682 */   GIM_Reject,
     /*  178683 */ // Label 3385: @178683
     /*  178683 */ GIM_Reject,
     /*  178684 */ // Label 3212: @178684
     /*  178684 */ GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(178841),
     /*  178689 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178692 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  178700 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(178735), // Rule ID 45988 //
     /*  178705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178708 */     // MIs[0] rs1
     /*  178708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178716 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  178716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  178719 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178733 */     GIR_RootConstrainSelectedInstOperands,
     /*  178734 */     // GIR_Coverage, 45988,
     /*  178734 */     GIR_EraseRootFromParent_Done,
     /*  178735 */   // Label 3391: @178735
     /*  178735 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(178770), // Rule ID 45989 //
     /*  178740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178743 */     // MIs[0] rs1
     /*  178743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178751 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  178751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  178754 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178768 */     GIR_RootConstrainSelectedInstOperands,
     /*  178769 */     // GIR_Coverage, 45989,
     /*  178769 */     GIR_EraseRootFromParent_Done,
     /*  178770 */   // Label 3392: @178770
     /*  178770 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(178805), // Rule ID 46048 //
     /*  178775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  178778 */     // MIs[0] rs1
     /*  178778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178786 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  178786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  178789 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178803 */     GIR_RootConstrainSelectedInstOperands,
     /*  178804 */     // GIR_Coverage, 46048,
     /*  178804 */     GIR_EraseRootFromParent_Done,
     /*  178805 */   // Label 3393: @178805
     /*  178805 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(178840), // Rule ID 46049 //
     /*  178810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  178813 */     // MIs[0] rs1
     /*  178813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178821 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  178821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  178824 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178838 */     GIR_RootConstrainSelectedInstOperands,
     /*  178839 */     // GIR_Coverage, 46049,
     /*  178839 */     GIR_EraseRootFromParent_Done,
     /*  178840 */   // Label 3394: @178840
     /*  178840 */   GIM_Reject,
     /*  178841 */ // Label 3390: @178841
     /*  178841 */ GIM_Reject,
     /*  178842 */ // Label 3213: @178842
     /*  178842 */ GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(178921),
     /*  178847 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178850 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178858 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178866 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(178893), // Rule ID 46080 //
     /*  178871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178874 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  178874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  178877 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  178887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178891 */     GIR_RootConstrainSelectedInstOperands,
     /*  178892 */     // GIR_Coverage, 46080,
     /*  178892 */     GIR_EraseRootFromParent_Done,
     /*  178893 */   // Label 3396: @178893
     /*  178893 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(178920), // Rule ID 46081 //
     /*  178898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178901 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  178901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  178904 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  178914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178918 */     GIR_RootConstrainSelectedInstOperands,
     /*  178919 */     // GIR_Coverage, 46081,
     /*  178919 */     GIR_EraseRootFromParent_Done,
     /*  178920 */   // Label 3397: @178920
     /*  178920 */   GIM_Reject,
     /*  178921 */ // Label 3395: @178921
     /*  178921 */ GIM_Reject,
     /*  178922 */ // Label 3214: @178922
     /*  178922 */ GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(179009),
     /*  178927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  178938 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(178973), // Rule ID 45960 //
     /*  178943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178946 */     // MIs[0] rs1
     /*  178946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178954 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  178954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  178957 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178971 */     GIR_RootConstrainSelectedInstOperands,
     /*  178972 */     // GIR_Coverage, 45960,
     /*  178972 */     GIR_EraseRootFromParent_Done,
     /*  178973 */   // Label 3399: @178973
     /*  178973 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(179008), // Rule ID 45961 //
     /*  178978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178981 */     // MIs[0] rs1
     /*  178981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178989 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  178989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  178992 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  179002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179006 */     GIR_RootConstrainSelectedInstOperands,
     /*  179007 */     // GIR_Coverage, 45961,
     /*  179007 */     GIR_EraseRootFromParent_Done,
     /*  179008 */   // Label 3400: @179008
     /*  179008 */   GIM_Reject,
     /*  179009 */ // Label 3398: @179009
     /*  179009 */ GIM_Reject,
     /*  179010 */ // Label 3215: @179010
     /*  179010 */ GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(179167),
     /*  179015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  179018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  179022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  179026 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(179061), // Rule ID 45976 //
     /*  179031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  179034 */     // MIs[0] rs1
     /*  179034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179042 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  179042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  179045 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179059 */     GIR_RootConstrainSelectedInstOperands,
     /*  179060 */     // GIR_Coverage, 45976,
     /*  179060 */     GIR_EraseRootFromParent_Done,
     /*  179061 */   // Label 3402: @179061
     /*  179061 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(179096), // Rule ID 45977 //
     /*  179066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  179069 */     // MIs[0] rs1
     /*  179069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179077 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  179077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  179080 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179094 */     GIR_RootConstrainSelectedInstOperands,
     /*  179095 */     // GIR_Coverage, 45977,
     /*  179095 */     GIR_EraseRootFromParent_Done,
     /*  179096 */   // Label 3403: @179096
     /*  179096 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(179131), // Rule ID 46036 //
     /*  179101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  179104 */     // MIs[0] rs1
     /*  179104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179112 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  179112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  179115 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179129 */     GIR_RootConstrainSelectedInstOperands,
     /*  179130 */     // GIR_Coverage, 46036,
     /*  179130 */     GIR_EraseRootFromParent_Done,
     /*  179131 */   // Label 3404: @179131
     /*  179131 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(179166), // Rule ID 46037 //
     /*  179136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  179139 */     // MIs[0] rs1
     /*  179139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179147 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  179147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  179150 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179164 */     GIR_RootConstrainSelectedInstOperands,
     /*  179165 */     // GIR_Coverage, 46037,
     /*  179165 */     GIR_EraseRootFromParent_Done,
     /*  179166 */   // Label 3405: @179166
     /*  179166 */   GIM_Reject,
     /*  179167 */ // Label 3401: @179167
     /*  179167 */ GIM_Reject,
     /*  179168 */ // Label 3216: @179168
     /*  179168 */ GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(179247),
     /*  179173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  179176 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  179180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  179188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179192 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(179219), // Rule ID 46084 //
     /*  179197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  179200 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  179200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  179203 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  179213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179217 */     GIR_RootConstrainSelectedInstOperands,
     /*  179218 */     // GIR_Coverage, 46084,
     /*  179218 */     GIR_EraseRootFromParent_Done,
     /*  179219 */   // Label 3407: @179219
     /*  179219 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(179246), // Rule ID 46085 //
     /*  179224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  179227 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  179227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  179230 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  179240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179244 */     GIR_RootConstrainSelectedInstOperands,
     /*  179245 */     // GIR_Coverage, 46085,
     /*  179245 */     GIR_EraseRootFromParent_Done,
     /*  179246 */   // Label 3408: @179246
     /*  179246 */   GIM_Reject,
     /*  179247 */ // Label 3406: @179247
     /*  179247 */ GIM_Reject,
     /*  179248 */ // Label 3217: @179248
     /*  179248 */ GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(179335),
     /*  179253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  179256 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  179260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  179264 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(179299), // Rule ID 45964 //
     /*  179269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  179272 */     // MIs[0] rs1
     /*  179272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179280 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  179280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  179283 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  179293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179297 */     GIR_RootConstrainSelectedInstOperands,
     /*  179298 */     // GIR_Coverage, 45964,
     /*  179298 */     GIR_EraseRootFromParent_Done,
     /*  179299 */   // Label 3410: @179299
     /*  179299 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(179334), // Rule ID 45965 //
     /*  179304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  179307 */     // MIs[0] rs1
     /*  179307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179315 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  179315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  179318 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  179328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179332 */     GIR_RootConstrainSelectedInstOperands,
     /*  179333 */     // GIR_Coverage, 45965,
     /*  179333 */     GIR_EraseRootFromParent_Done,
     /*  179334 */   // Label 3411: @179334
     /*  179334 */   GIM_Reject,
     /*  179335 */ // Label 3409: @179335
     /*  179335 */ GIM_Reject,
     /*  179336 */ // Label 3218: @179336
     /*  179336 */ GIM_Reject,
     /*  179337 */ // Label 25: @179337
     /*  179337 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3414*/ GIMT_Encode4(184222),
     /*  179348 */ /*GILLT_s32*//*Label 3412*/ GIMT_Encode4(179356),
     /*  179352 */ /*GILLT_s64*//*Label 3413*/ GIMT_Encode4(181349),
     /*  179356 */ // Label 3412: @179356
     /*  179356 */ GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(181348),
     /*  179361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  179364 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  179367 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(179433), // Rule ID 645 //
     /*  179372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  179375 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179382 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179389 */     // MIs[0] addr
     /*  179389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  179393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179405 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 2:{ *:[i32] })
     /*  179405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  179408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  179411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  179413 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  179418 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179420 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179422 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  179427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179431 */     GIR_RootConstrainSelectedInstOperands,
     /*  179432 */     // GIR_Coverage, 645,
     /*  179432 */     GIR_EraseRootFromParent_Done,
     /*  179433 */   // Label 3416: @179433
     /*  179433 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(179499), // Rule ID 647 //
     /*  179438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  179441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179455 */     // MIs[0] addr
     /*  179455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  179459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179471 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 4:{ *:[i32] })
     /*  179471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  179474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  179477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  179479 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  179484 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179486 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179488 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179497 */     GIR_RootConstrainSelectedInstOperands,
     /*  179498 */     // GIR_Coverage, 647,
     /*  179498 */     GIR_EraseRootFromParent_Done,
     /*  179499 */   // Label 3417: @179499
     /*  179499 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(179565), // Rule ID 649 //
     /*  179504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  179507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179521 */     // MIs[0] addr
     /*  179521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  179525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179537 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 5:{ *:[i32] })
     /*  179537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  179540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  179543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  179545 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  179550 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179552 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179554 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  179559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179563 */     GIR_RootConstrainSelectedInstOperands,
     /*  179564 */     // GIR_Coverage, 649,
     /*  179564 */     GIR_EraseRootFromParent_Done,
     /*  179565 */   // Label 3418: @179565
     /*  179565 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(179631), // Rule ID 651 //
     /*  179570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  179573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179587 */     // MIs[0] addr
     /*  179587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  179591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179603 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 6:{ *:[i32] })
     /*  179603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  179606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  179609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  179611 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  179616 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179618 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179620 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  179625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179629 */     GIR_RootConstrainSelectedInstOperands,
     /*  179630 */     // GIR_Coverage, 651,
     /*  179630 */     GIR_EraseRootFromParent_Done,
     /*  179631 */   // Label 3419: @179631
     /*  179631 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(179697), // Rule ID 653 //
     /*  179636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  179639 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179653 */     // MIs[0] addr
     /*  179653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  179657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179669 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 7:{ *:[i32] })
     /*  179669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  179672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  179675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  179677 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  179682 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179684 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179686 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  179691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179695 */     GIR_RootConstrainSelectedInstOperands,
     /*  179696 */     // GIR_Coverage, 653,
     /*  179696 */     GIR_EraseRootFromParent_Done,
     /*  179697 */   // Label 3420: @179697
     /*  179697 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(179752), // Rule ID 662 //
     /*  179702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  179705 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179719 */     // MIs[0] addr
     /*  179719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179735 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  179735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  179738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179740 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179742 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179744 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179750 */     GIR_RootConstrainSelectedInstOperands,
     /*  179751 */     // GIR_Coverage, 662,
     /*  179751 */     GIR_EraseRootFromParent_Done,
     /*  179752 */   // Label 3421: @179752
     /*  179752 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(179807), // Rule ID 664 //
     /*  179757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  179760 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179774 */     // MIs[0] addr
     /*  179774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179790 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  179790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  179793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179795 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179797 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179799 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179805 */     GIR_RootConstrainSelectedInstOperands,
     /*  179806 */     // GIR_Coverage, 664,
     /*  179806 */     GIR_EraseRootFromParent_Done,
     /*  179807 */   // Label 3422: @179807
     /*  179807 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(179862), // Rule ID 666 //
     /*  179812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  179815 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179829 */     // MIs[0] addr
     /*  179829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179845 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  179845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  179848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179850 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179852 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179854 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179860 */     GIR_RootConstrainSelectedInstOperands,
     /*  179861 */     // GIR_Coverage, 666,
     /*  179861 */     GIR_EraseRootFromParent_Done,
     /*  179862 */   // Label 3423: @179862
     /*  179862 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(179917), // Rule ID 668 //
     /*  179867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  179870 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179884 */     // MIs[0] addr
     /*  179884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179900 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  179900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  179903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179905 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179907 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179909 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179915 */     GIR_RootConstrainSelectedInstOperands,
     /*  179916 */     // GIR_Coverage, 668,
     /*  179916 */     GIR_EraseRootFromParent_Done,
     /*  179917 */   // Label 3424: @179917
     /*  179917 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(179972), // Rule ID 670 //
     /*  179922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  179925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179939 */     // MIs[0] addr
     /*  179939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179955 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  179955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  179958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179960 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179962 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179964 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179970 */     GIR_RootConstrainSelectedInstOperands,
     /*  179971 */     // GIR_Coverage, 670,
     /*  179971 */     GIR_EraseRootFromParent_Done,
     /*  179972 */   // Label 3425: @179972
     /*  179972 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(180027), // Rule ID 672 //
     /*  179977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  179980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179994 */     // MIs[0] addr
     /*  179994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180010 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  180013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180015 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180017 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180019 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180025 */     GIR_RootConstrainSelectedInstOperands,
     /*  180026 */     // GIR_Coverage, 672,
     /*  180026 */     GIR_EraseRootFromParent_Done,
     /*  180027 */   // Label 3426: @180027
     /*  180027 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(180082), // Rule ID 674 //
     /*  180032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180049 */     // MIs[0] addr
     /*  180049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180065 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  180068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180070 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180072 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180074 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180080 */     GIR_RootConstrainSelectedInstOperands,
     /*  180081 */     // GIR_Coverage, 674,
     /*  180081 */     GIR_EraseRootFromParent_Done,
     /*  180082 */   // Label 3427: @180082
     /*  180082 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(180137), // Rule ID 676 //
     /*  180087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180090 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180097 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180104 */     // MIs[0] addr
     /*  180104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180120 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  180123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180125 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180127 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180129 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180135 */     GIR_RootConstrainSelectedInstOperands,
     /*  180136 */     // GIR_Coverage, 676,
     /*  180136 */     GIR_EraseRootFromParent_Done,
     /*  180137 */   // Label 3428: @180137
     /*  180137 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(180192), // Rule ID 678 //
     /*  180142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180145 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180159 */     // MIs[0] addr
     /*  180159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180175 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  180178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180180 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180182 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180184 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180190 */     GIR_RootConstrainSelectedInstOperands,
     /*  180191 */     // GIR_Coverage, 678,
     /*  180191 */     GIR_EraseRootFromParent_Done,
     /*  180192 */   // Label 3429: @180192
     /*  180192 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(180247), // Rule ID 680 //
     /*  180197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180200 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180207 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180214 */     // MIs[0] addr
     /*  180214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180230 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  180233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180235 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180237 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180239 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180245 */     GIR_RootConstrainSelectedInstOperands,
     /*  180246 */     // GIR_Coverage, 680,
     /*  180246 */     GIR_EraseRootFromParent_Done,
     /*  180247 */   // Label 3430: @180247
     /*  180247 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(180302), // Rule ID 1052 //
     /*  180252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180255 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180269 */     // MIs[0] addr
     /*  180269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180285 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180290 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180292 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180294 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180300 */     GIR_RootConstrainSelectedInstOperands,
     /*  180301 */     // GIR_Coverage, 1052,
     /*  180301 */     GIR_EraseRootFromParent_Done,
     /*  180302 */   // Label 3431: @180302
     /*  180302 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(180357), // Rule ID 1054 //
     /*  180307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180310 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180317 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180324 */     // MIs[0] addr
     /*  180324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180340 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  180343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180345 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180347 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180349 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180355 */     GIR_RootConstrainSelectedInstOperands,
     /*  180356 */     // GIR_Coverage, 1054,
     /*  180356 */     GIR_EraseRootFromParent_Done,
     /*  180357 */   // Label 3432: @180357
     /*  180357 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(180412), // Rule ID 1056 //
     /*  180362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180365 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180372 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180379 */     // MIs[0] addr
     /*  180379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180395 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  180398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180400 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180402 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180404 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180410 */     GIR_RootConstrainSelectedInstOperands,
     /*  180411 */     // GIR_Coverage, 1056,
     /*  180411 */     GIR_EraseRootFromParent_Done,
     /*  180412 */   // Label 3433: @180412
     /*  180412 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(180467), // Rule ID 1058 //
     /*  180417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180434 */     // MIs[0] addr
     /*  180434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180450 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  180453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180455 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180457 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180459 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180465 */     GIR_RootConstrainSelectedInstOperands,
     /*  180466 */     // GIR_Coverage, 1058,
     /*  180466 */     GIR_EraseRootFromParent_Done,
     /*  180467 */   // Label 3434: @180467
     /*  180467 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(180522), // Rule ID 1060 //
     /*  180472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180489 */     // MIs[0] addr
     /*  180489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180505 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  180508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180510 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180512 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180514 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180520 */     GIR_RootConstrainSelectedInstOperands,
     /*  180521 */     // GIR_Coverage, 1060,
     /*  180521 */     GIR_EraseRootFromParent_Done,
     /*  180522 */   // Label 3435: @180522
     /*  180522 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(180577), // Rule ID 1062 //
     /*  180527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180530 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180537 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180544 */     // MIs[0] addr
     /*  180544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180560 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180565 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180567 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180569 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180575 */     GIR_RootConstrainSelectedInstOperands,
     /*  180576 */     // GIR_Coverage, 1062,
     /*  180576 */     GIR_EraseRootFromParent_Done,
     /*  180577 */   // Label 3436: @180577
     /*  180577 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(180632), // Rule ID 1064 //
     /*  180582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180585 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180592 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180599 */     // MIs[0] addr
     /*  180599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180615 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180620 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180622 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180624 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180630 */     GIR_RootConstrainSelectedInstOperands,
     /*  180631 */     // GIR_Coverage, 1064,
     /*  180631 */     GIR_EraseRootFromParent_Done,
     /*  180632 */   // Label 3437: @180632
     /*  180632 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(180687), // Rule ID 1066 //
     /*  180637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180640 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180647 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180654 */     // MIs[0] addr
     /*  180654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180670 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180675 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180677 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180679 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180685 */     GIR_RootConstrainSelectedInstOperands,
     /*  180686 */     // GIR_Coverage, 1066,
     /*  180686 */     GIR_EraseRootFromParent_Done,
     /*  180687 */   // Label 3438: @180687
     /*  180687 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(180742), // Rule ID 1068 //
     /*  180692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180709 */     // MIs[0] addr
     /*  180709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180725 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180730 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180732 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180734 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180740 */     GIR_RootConstrainSelectedInstOperands,
     /*  180741 */     // GIR_Coverage, 1068,
     /*  180741 */     GIR_EraseRootFromParent_Done,
     /*  180742 */   // Label 3439: @180742
     /*  180742 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(180797), // Rule ID 1070 //
     /*  180747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180750 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180757 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180764 */     // MIs[0] addr
     /*  180764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180780 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180785 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180787 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180789 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180795 */     GIR_RootConstrainSelectedInstOperands,
     /*  180796 */     // GIR_Coverage, 1070,
     /*  180796 */     GIR_EraseRootFromParent_Done,
     /*  180797 */   // Label 3440: @180797
     /*  180797 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(180852), // Rule ID 1072 //
     /*  180802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180805 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180812 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180819 */     // MIs[0] addr
     /*  180819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180835 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180840 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180842 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180844 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180850 */     GIR_RootConstrainSelectedInstOperands,
     /*  180851 */     // GIR_Coverage, 1072,
     /*  180851 */     GIR_EraseRootFromParent_Done,
     /*  180852 */   // Label 3441: @180852
     /*  180852 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(180907), // Rule ID 1074 //
     /*  180857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180860 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180867 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180874 */     // MIs[0] addr
     /*  180874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180890 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  180893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180895 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180897 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180899 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180905 */     GIR_RootConstrainSelectedInstOperands,
     /*  180906 */     // GIR_Coverage, 1074,
     /*  180906 */     GIR_EraseRootFromParent_Done,
     /*  180907 */   // Label 3442: @180907
     /*  180907 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(180962), // Rule ID 1076 //
     /*  180912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180915 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180922 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180929 */     // MIs[0] addr
     /*  180929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180945 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  180948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180950 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180952 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180954 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180960 */     GIR_RootConstrainSelectedInstOperands,
     /*  180961 */     // GIR_Coverage, 1076,
     /*  180961 */     GIR_EraseRootFromParent_Done,
     /*  180962 */   // Label 3443: @180962
     /*  180962 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(181017), // Rule ID 1078 //
     /*  180967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180984 */     // MIs[0] addr
     /*  180984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181000 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  181003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181005 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181007 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181009 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181015 */     GIR_RootConstrainSelectedInstOperands,
     /*  181016 */     // GIR_Coverage, 1078,
     /*  181016 */     GIR_EraseRootFromParent_Done,
     /*  181017 */   // Label 3444: @181017
     /*  181017 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(181072), // Rule ID 1080 //
     /*  181022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  181025 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181032 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181039 */     // MIs[0] addr
     /*  181039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181055 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  181058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181060 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181062 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181064 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181070 */     GIR_RootConstrainSelectedInstOperands,
     /*  181071 */     // GIR_Coverage, 1080,
     /*  181071 */     GIR_EraseRootFromParent_Done,
     /*  181072 */   // Label 3445: @181072
     /*  181072 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(181127), // Rule ID 1082 //
     /*  181077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  181080 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181087 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181094 */     // MIs[0] addr
     /*  181094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181110 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  181113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181115 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181117 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181119 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181125 */     GIR_RootConstrainSelectedInstOperands,
     /*  181126 */     // GIR_Coverage, 1082,
     /*  181126 */     GIR_EraseRootFromParent_Done,
     /*  181127 */   // Label 3446: @181127
     /*  181127 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(181182), // Rule ID 1084 //
     /*  181132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  181135 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181142 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181149 */     // MIs[0] addr
     /*  181149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181165 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  181168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181170 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181172 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181174 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181180 */     GIR_RootConstrainSelectedInstOperands,
     /*  181181 */     // GIR_Coverage, 1084,
     /*  181181 */     GIR_EraseRootFromParent_Done,
     /*  181182 */   // Label 3447: @181182
     /*  181182 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(181237), // Rule ID 1086 //
     /*  181187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  181190 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181204 */     // MIs[0] addr
     /*  181204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181220 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  181223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181225 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181227 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181229 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181235 */     GIR_RootConstrainSelectedInstOperands,
     /*  181236 */     // GIR_Coverage, 1086,
     /*  181236 */     GIR_EraseRootFromParent_Done,
     /*  181237 */   // Label 3448: @181237
     /*  181237 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(181292), // Rule ID 1088 //
     /*  181242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  181245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181259 */     // MIs[0] addr
     /*  181259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181275 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  181278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181280 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181282 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181284 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181290 */     GIR_RootConstrainSelectedInstOperands,
     /*  181291 */     // GIR_Coverage, 1088,
     /*  181291 */     GIR_EraseRootFromParent_Done,
     /*  181292 */   // Label 3449: @181292
     /*  181292 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(181347), // Rule ID 1090 //
     /*  181297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  181300 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181307 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181314 */     // MIs[0] addr
     /*  181314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181330 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  181333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181335 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181337 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181339 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181345 */     GIR_RootConstrainSelectedInstOperands,
     /*  181346 */     // GIR_Coverage, 1090,
     /*  181346 */     GIR_EraseRootFromParent_Done,
     /*  181347 */   // Label 3450: @181347
     /*  181347 */   GIM_Reject,
     /*  181348 */ // Label 3415: @181348
     /*  181348 */ GIM_Reject,
     /*  181349 */ // Label 3413: @181349
     /*  181349 */ GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(184221),
     /*  181354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  181357 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  181360 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(181426), // Rule ID 644 //
     /*  181365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  181368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181382 */     // MIs[0] addr
     /*  181382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181398 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  181398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  181404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181406 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181411 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181413 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181415 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  181420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181424 */     GIR_RootConstrainSelectedInstOperands,
     /*  181425 */     // GIR_Coverage, 644,
     /*  181425 */     GIR_EraseRootFromParent_Done,
     /*  181426 */   // Label 3452: @181426
     /*  181426 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(181492), // Rule ID 646 //
     /*  181431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  181434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181448 */     // MIs[0] addr
     /*  181448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181464 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  181464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  181470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181472 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181477 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181479 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181481 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  181486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181490 */     GIR_RootConstrainSelectedInstOperands,
     /*  181491 */     // GIR_Coverage, 646,
     /*  181491 */     GIR_EraseRootFromParent_Done,
     /*  181492 */   // Label 3453: @181492
     /*  181492 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(181558), // Rule ID 648 //
     /*  181497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  181500 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181514 */     // MIs[0] addr
     /*  181514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181530 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  181530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  181536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181538 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181543 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181545 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181547 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  181552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181556 */     GIR_RootConstrainSelectedInstOperands,
     /*  181557 */     // GIR_Coverage, 648,
     /*  181557 */     GIR_EraseRootFromParent_Done,
     /*  181558 */   // Label 3454: @181558
     /*  181558 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(181624), // Rule ID 650 //
     /*  181563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  181566 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181580 */     // MIs[0] addr
     /*  181580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181596 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  181596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  181602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181604 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181609 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181611 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181613 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  181618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181622 */     GIR_RootConstrainSelectedInstOperands,
     /*  181623 */     // GIR_Coverage, 650,
     /*  181623 */     GIR_EraseRootFromParent_Done,
     /*  181624 */   // Label 3455: @181624
     /*  181624 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(181690), // Rule ID 652 //
     /*  181629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  181632 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181639 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181646 */     // MIs[0] addr
     /*  181646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181662 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  181662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  181668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181670 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181675 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181677 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181679 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  181684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181688 */     GIR_RootConstrainSelectedInstOperands,
     /*  181689 */     // GIR_Coverage, 652,
     /*  181689 */     GIR_EraseRootFromParent_Done,
     /*  181690 */   // Label 3456: @181690
     /*  181690 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(181756), // Rule ID 654 //
     /*  181695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  181698 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181705 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181712 */     // MIs[0] addr
     /*  181712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181728 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  181728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  181734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181736 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181741 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181743 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181745 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  181750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181754 */     GIR_RootConstrainSelectedInstOperands,
     /*  181755 */     // GIR_Coverage, 654,
     /*  181755 */     GIR_EraseRootFromParent_Done,
     /*  181756 */   // Label 3457: @181756
     /*  181756 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(181822), // Rule ID 655 //
     /*  181761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  181764 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181771 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181778 */     // MIs[0] addr
     /*  181778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181794 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  181794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  181800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181802 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181807 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181809 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181811 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  181816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181820 */     GIR_RootConstrainSelectedInstOperands,
     /*  181821 */     // GIR_Coverage, 655,
     /*  181821 */     GIR_EraseRootFromParent_Done,
     /*  181822 */   // Label 3458: @181822
     /*  181822 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(181888), // Rule ID 656 //
     /*  181827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  181830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181844 */     // MIs[0] addr
     /*  181844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181860 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  181860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  181866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181868 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181873 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181875 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181877 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  181882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181886 */     GIR_RootConstrainSelectedInstOperands,
     /*  181887 */     // GIR_Coverage, 656,
     /*  181887 */     GIR_EraseRootFromParent_Done,
     /*  181888 */   // Label 3459: @181888
     /*  181888 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(181954), // Rule ID 657 //
     /*  181893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  181896 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181903 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181910 */     // MIs[0] addr
     /*  181910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181926 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  181926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  181932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181934 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181939 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181941 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181943 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  181948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181952 */     GIR_RootConstrainSelectedInstOperands,
     /*  181953 */     // GIR_Coverage, 657,
     /*  181953 */     GIR_EraseRootFromParent_Done,
     /*  181954 */   // Label 3460: @181954
     /*  181954 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(182020), // Rule ID 658 //
     /*  181959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  181962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181976 */     // MIs[0] addr
     /*  181976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181992 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  181992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  181998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  182000 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  182005 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182007 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182009 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  182014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182018 */     GIR_RootConstrainSelectedInstOperands,
     /*  182019 */     // GIR_Coverage, 658,
     /*  182019 */     GIR_EraseRootFromParent_Done,
     /*  182020 */   // Label 3461: @182020
     /*  182020 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(182075), // Rule ID 661 //
     /*  182025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  182028 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182035 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182042 */     // MIs[0] addr
     /*  182042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182058 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  182061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182063 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182065 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182067 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182073 */     GIR_RootConstrainSelectedInstOperands,
     /*  182074 */     // GIR_Coverage, 661,
     /*  182074 */     GIR_EraseRootFromParent_Done,
     /*  182075 */   // Label 3462: @182075
     /*  182075 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(182130), // Rule ID 663 //
     /*  182080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  182083 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182090 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182097 */     // MIs[0] addr
     /*  182097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182113 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  182116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182118 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182120 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182122 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182128 */     GIR_RootConstrainSelectedInstOperands,
     /*  182129 */     // GIR_Coverage, 663,
     /*  182129 */     GIR_EraseRootFromParent_Done,
     /*  182130 */   // Label 3463: @182130
     /*  182130 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(182185), // Rule ID 665 //
     /*  182135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  182138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182152 */     // MIs[0] addr
     /*  182152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182168 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  182171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182173 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182175 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182177 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182183 */     GIR_RootConstrainSelectedInstOperands,
     /*  182184 */     // GIR_Coverage, 665,
     /*  182184 */     GIR_EraseRootFromParent_Done,
     /*  182185 */   // Label 3464: @182185
     /*  182185 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(182240), // Rule ID 667 //
     /*  182190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  182193 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182200 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182207 */     // MIs[0] addr
     /*  182207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182223 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  182226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182228 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182230 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182232 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182238 */     GIR_RootConstrainSelectedInstOperands,
     /*  182239 */     // GIR_Coverage, 667,
     /*  182239 */     GIR_EraseRootFromParent_Done,
     /*  182240 */   // Label 3465: @182240
     /*  182240 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(182295), // Rule ID 669 //
     /*  182245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  182248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182262 */     // MIs[0] addr
     /*  182262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182278 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  182281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182283 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182285 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182287 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182293 */     GIR_RootConstrainSelectedInstOperands,
     /*  182294 */     // GIR_Coverage, 669,
     /*  182294 */     GIR_EraseRootFromParent_Done,
     /*  182295 */   // Label 3466: @182295
     /*  182295 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(182350), // Rule ID 671 //
     /*  182300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  182303 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182310 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182317 */     // MIs[0] addr
     /*  182317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182333 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  182336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182338 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182340 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182342 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182348 */     GIR_RootConstrainSelectedInstOperands,
     /*  182349 */     // GIR_Coverage, 671,
     /*  182349 */     GIR_EraseRootFromParent_Done,
     /*  182350 */   // Label 3467: @182350
     /*  182350 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(182405), // Rule ID 673 //
     /*  182355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  182358 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182365 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182372 */     // MIs[0] addr
     /*  182372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182388 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  182391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182393 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182395 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182397 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182403 */     GIR_RootConstrainSelectedInstOperands,
     /*  182404 */     // GIR_Coverage, 673,
     /*  182404 */     GIR_EraseRootFromParent_Done,
     /*  182405 */   // Label 3468: @182405
     /*  182405 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(182460), // Rule ID 675 //
     /*  182410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  182413 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182420 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182427 */     // MIs[0] addr
     /*  182427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182443 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  182446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182448 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182450 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182452 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182458 */     GIR_RootConstrainSelectedInstOperands,
     /*  182459 */     // GIR_Coverage, 675,
     /*  182459 */     GIR_EraseRootFromParent_Done,
     /*  182460 */   // Label 3469: @182460
     /*  182460 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(182515), // Rule ID 677 //
     /*  182465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  182468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182482 */     // MIs[0] addr
     /*  182482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182498 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  182501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182503 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182505 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182507 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182513 */     GIR_RootConstrainSelectedInstOperands,
     /*  182514 */     // GIR_Coverage, 677,
     /*  182514 */     GIR_EraseRootFromParent_Done,
     /*  182515 */   // Label 3470: @182515
     /*  182515 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(182570), // Rule ID 679 //
     /*  182520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  182523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182530 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182537 */     // MIs[0] addr
     /*  182537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182553 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  182556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182558 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182560 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182562 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182568 */     GIR_RootConstrainSelectedInstOperands,
     /*  182569 */     // GIR_Coverage, 679,
     /*  182569 */     GIR_EraseRootFromParent_Done,
     /*  182570 */   // Label 3471: @182570
     /*  182570 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(182625), // Rule ID 681 //
     /*  182575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182592 */     // MIs[0] addr
     /*  182592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182608 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  182611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182613 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182615 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182617 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182623 */     GIR_RootConstrainSelectedInstOperands,
     /*  182624 */     // GIR_Coverage, 681,
     /*  182624 */     GIR_EraseRootFromParent_Done,
     /*  182625 */   // Label 3472: @182625
     /*  182625 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(182680), // Rule ID 682 //
     /*  182630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182647 */     // MIs[0] addr
     /*  182647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182663 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ),
     /*  182666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182668 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182670 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182672 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182678 */     GIR_RootConstrainSelectedInstOperands,
     /*  182679 */     // GIR_Coverage, 682,
     /*  182679 */     GIR_EraseRootFromParent_Done,
     /*  182680 */   // Label 3473: @182680
     /*  182680 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(182735), // Rule ID 683 //
     /*  182685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182702 */     // MIs[0] addr
     /*  182702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182718 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_RL),
     /*  182721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182723 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182725 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182727 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182733 */     GIR_RootConstrainSelectedInstOperands,
     /*  182734 */     // GIR_Coverage, 683,
     /*  182734 */     GIR_EraseRootFromParent_Done,
     /*  182735 */   // Label 3474: @182735
     /*  182735 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(182790), // Rule ID 684 //
     /*  182740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182757 */     // MIs[0] addr
     /*  182757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182773 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  182776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182778 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182780 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182782 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182788 */     GIR_RootConstrainSelectedInstOperands,
     /*  182789 */     // GIR_Coverage, 684,
     /*  182789 */     GIR_EraseRootFromParent_Done,
     /*  182790 */   // Label 3475: @182790
     /*  182790 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(182845), // Rule ID 685 //
     /*  182795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182798 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182812 */     // MIs[0] addr
     /*  182812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182828 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  182831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182833 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182835 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182837 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182843 */     GIR_RootConstrainSelectedInstOperands,
     /*  182844 */     // GIR_Coverage, 685,
     /*  182844 */     GIR_EraseRootFromParent_Done,
     /*  182845 */   // Label 3476: @182845
     /*  182845 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(182900), // Rule ID 686 //
     /*  182850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  182853 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182867 */     // MIs[0] addr
     /*  182867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182883 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  182886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182888 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182890 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182892 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182898 */     GIR_RootConstrainSelectedInstOperands,
     /*  182899 */     // GIR_Coverage, 686,
     /*  182899 */     GIR_EraseRootFromParent_Done,
     /*  182900 */   // Label 3477: @182900
     /*  182900 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(182955), // Rule ID 687 //
     /*  182905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  182908 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182922 */     // MIs[0] addr
     /*  182922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182938 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  182941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182943 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182945 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182947 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182953 */     GIR_RootConstrainSelectedInstOperands,
     /*  182954 */     // GIR_Coverage, 687,
     /*  182954 */     GIR_EraseRootFromParent_Done,
     /*  182955 */   // Label 3478: @182955
     /*  182955 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(183010), // Rule ID 688 //
     /*  182960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  182963 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182970 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182977 */     // MIs[0] addr
     /*  182977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182993 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  182996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182998 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183000 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183002 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183008 */     GIR_RootConstrainSelectedInstOperands,
     /*  183009 */     // GIR_Coverage, 688,
     /*  183009 */     GIR_EraseRootFromParent_Done,
     /*  183010 */   // Label 3479: @183010
     /*  183010 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(183065), // Rule ID 689 //
     /*  183015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  183018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  183025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183032 */     // MIs[0] addr
     /*  183032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183048 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  183051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183053 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183055 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183057 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183063 */     GIR_RootConstrainSelectedInstOperands,
     /*  183064 */     // GIR_Coverage, 689,
     /*  183064 */     GIR_EraseRootFromParent_Done,
     /*  183065 */   // Label 3480: @183065
     /*  183065 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(183120), // Rule ID 690 //
     /*  183070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  183073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  183080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183087 */     // MIs[0] addr
     /*  183087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183103 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  183106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183108 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183110 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183112 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183118 */     GIR_RootConstrainSelectedInstOperands,
     /*  183119 */     // GIR_Coverage, 690,
     /*  183119 */     GIR_EraseRootFromParent_Done,
     /*  183120 */   // Label 3481: @183120
     /*  183120 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(183175), // Rule ID 1051 //
     /*  183125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183142 */     // MIs[0] addr
     /*  183142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183158 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  183161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183163 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183165 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183167 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183173 */     GIR_RootConstrainSelectedInstOperands,
     /*  183174 */     // GIR_Coverage, 1051,
     /*  183174 */     GIR_EraseRootFromParent_Done,
     /*  183175 */   // Label 3482: @183175
     /*  183175 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(183230), // Rule ID 1053 //
     /*  183180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183183 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183190 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183197 */     // MIs[0] addr
     /*  183197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183213 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  183216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183218 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183220 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183222 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183228 */     GIR_RootConstrainSelectedInstOperands,
     /*  183229 */     // GIR_Coverage, 1053,
     /*  183229 */     GIR_EraseRootFromParent_Done,
     /*  183230 */   // Label 3483: @183230
     /*  183230 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(183285), // Rule ID 1055 //
     /*  183235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183252 */     // MIs[0] addr
     /*  183252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183268 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  183271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183273 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183275 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183277 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183283 */     GIR_RootConstrainSelectedInstOperands,
     /*  183284 */     // GIR_Coverage, 1055,
     /*  183284 */     GIR_EraseRootFromParent_Done,
     /*  183285 */   // Label 3484: @183285
     /*  183285 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(183340), // Rule ID 1057 //
     /*  183290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183293 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183300 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183307 */     // MIs[0] addr
     /*  183307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183323 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  183326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183328 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183330 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183332 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183338 */     GIR_RootConstrainSelectedInstOperands,
     /*  183339 */     // GIR_Coverage, 1057,
     /*  183339 */     GIR_EraseRootFromParent_Done,
     /*  183340 */   // Label 3485: @183340
     /*  183340 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(183395), // Rule ID 1059 //
     /*  183345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183348 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183355 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183362 */     // MIs[0] addr
     /*  183362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183378 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  183381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183383 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183385 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183387 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183393 */     GIR_RootConstrainSelectedInstOperands,
     /*  183394 */     // GIR_Coverage, 1059,
     /*  183394 */     GIR_EraseRootFromParent_Done,
     /*  183395 */   // Label 3486: @183395
     /*  183395 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(183450), // Rule ID 1061 //
     /*  183400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  183403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183417 */     // MIs[0] addr
     /*  183417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183433 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  183436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183438 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183440 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183442 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183448 */     GIR_RootConstrainSelectedInstOperands,
     /*  183449 */     // GIR_Coverage, 1061,
     /*  183449 */     GIR_EraseRootFromParent_Done,
     /*  183450 */   // Label 3487: @183450
     /*  183450 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(183505), // Rule ID 1063 //
     /*  183455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  183458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183472 */     // MIs[0] addr
     /*  183472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183488 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  183491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183493 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183495 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183497 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183503 */     GIR_RootConstrainSelectedInstOperands,
     /*  183504 */     // GIR_Coverage, 1063,
     /*  183504 */     GIR_EraseRootFromParent_Done,
     /*  183505 */   // Label 3488: @183505
     /*  183505 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(183560), // Rule ID 1065 //
     /*  183510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  183513 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183520 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183527 */     // MIs[0] addr
     /*  183527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183543 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  183546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183548 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183550 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183552 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183558 */     GIR_RootConstrainSelectedInstOperands,
     /*  183559 */     // GIR_Coverage, 1065,
     /*  183559 */     GIR_EraseRootFromParent_Done,
     /*  183560 */   // Label 3489: @183560
     /*  183560 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(183615), // Rule ID 1067 //
     /*  183565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  183568 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183582 */     // MIs[0] addr
     /*  183582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183598 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  183601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183603 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183605 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183607 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183613 */     GIR_RootConstrainSelectedInstOperands,
     /*  183614 */     // GIR_Coverage, 1067,
     /*  183614 */     GIR_EraseRootFromParent_Done,
     /*  183615 */   // Label 3490: @183615
     /*  183615 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(183670), // Rule ID 1069 //
     /*  183620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  183623 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183630 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183637 */     // MIs[0] addr
     /*  183637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183653 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  183656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183658 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183660 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183662 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183668 */     GIR_RootConstrainSelectedInstOperands,
     /*  183669 */     // GIR_Coverage, 1069,
     /*  183669 */     GIR_EraseRootFromParent_Done,
     /*  183670 */   // Label 3491: @183670
     /*  183670 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(183725), // Rule ID 1071 //
     /*  183675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183678 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183692 */     // MIs[0] addr
     /*  183692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183708 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  183711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183713 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183715 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183717 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183723 */     GIR_RootConstrainSelectedInstOperands,
     /*  183724 */     // GIR_Coverage, 1071,
     /*  183724 */     GIR_EraseRootFromParent_Done,
     /*  183725 */   // Label 3492: @183725
     /*  183725 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(183780), // Rule ID 1073 //
     /*  183730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183733 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183740 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183747 */     // MIs[0] addr
     /*  183747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183763 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  183766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183768 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183770 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183772 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183778 */     GIR_RootConstrainSelectedInstOperands,
     /*  183779 */     // GIR_Coverage, 1073,
     /*  183779 */     GIR_EraseRootFromParent_Done,
     /*  183780 */   // Label 3493: @183780
     /*  183780 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(183835), // Rule ID 1075 //
     /*  183785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183788 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183795 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183802 */     // MIs[0] addr
     /*  183802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183818 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  183821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183823 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183825 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183827 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183833 */     GIR_RootConstrainSelectedInstOperands,
     /*  183834 */     // GIR_Coverage, 1075,
     /*  183834 */     GIR_EraseRootFromParent_Done,
     /*  183835 */   // Label 3494: @183835
     /*  183835 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(183890), // Rule ID 1077 //
     /*  183840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183857 */     // MIs[0] addr
     /*  183857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183873 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  183876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183878 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183880 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183882 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183888 */     GIR_RootConstrainSelectedInstOperands,
     /*  183889 */     // GIR_Coverage, 1077,
     /*  183889 */     GIR_EraseRootFromParent_Done,
     /*  183890 */   // Label 3495: @183890
     /*  183890 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(183945), // Rule ID 1079 //
     /*  183895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183898 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183905 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183912 */     // MIs[0] addr
     /*  183912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183928 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  183931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183933 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183935 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183937 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183943 */     GIR_RootConstrainSelectedInstOperands,
     /*  183944 */     // GIR_Coverage, 1079,
     /*  183944 */     GIR_EraseRootFromParent_Done,
     /*  183945 */   // Label 3496: @183945
     /*  183945 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(184000), // Rule ID 1081 //
     /*  183950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  183953 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183960 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183967 */     // MIs[0] addr
     /*  183967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183983 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  183986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183988 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183990 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183992 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183998 */     GIR_RootConstrainSelectedInstOperands,
     /*  183999 */     // GIR_Coverage, 1081,
     /*  183999 */     GIR_EraseRootFromParent_Done,
     /*  184000 */   // Label 3497: @184000
     /*  184000 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(184055), // Rule ID 1083 //
     /*  184005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  184008 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184015 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184022 */     // MIs[0] addr
     /*  184022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184038 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  184038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  184041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  184043 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  184045 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  184047 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  184049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  184053 */     GIR_RootConstrainSelectedInstOperands,
     /*  184054 */     // GIR_Coverage, 1083,
     /*  184054 */     GIR_EraseRootFromParent_Done,
     /*  184055 */   // Label 3498: @184055
     /*  184055 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(184110), // Rule ID 1085 //
     /*  184060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  184063 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184077 */     // MIs[0] addr
     /*  184077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184093 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  184093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  184096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  184098 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  184100 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  184102 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  184104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  184108 */     GIR_RootConstrainSelectedInstOperands,
     /*  184109 */     // GIR_Coverage, 1085,
     /*  184109 */     GIR_EraseRootFromParent_Done,
     /*  184110 */   // Label 3499: @184110
     /*  184110 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(184165), // Rule ID 1087 //
     /*  184115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  184118 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184125 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184132 */     // MIs[0] addr
     /*  184132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184148 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  184148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  184151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  184153 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  184155 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  184157 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  184159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  184163 */     GIR_RootConstrainSelectedInstOperands,
     /*  184164 */     // GIR_Coverage, 1087,
     /*  184164 */     GIR_EraseRootFromParent_Done,
     /*  184165 */   // Label 3500: @184165
     /*  184165 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(184220), // Rule ID 1089 //
     /*  184170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  184173 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184180 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184187 */     // MIs[0] addr
     /*  184187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184203 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  184203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  184206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  184208 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  184210 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  184212 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  184214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  184218 */     GIR_RootConstrainSelectedInstOperands,
     /*  184219 */     // GIR_Coverage, 1089,
     /*  184219 */     GIR_EraseRootFromParent_Done,
     /*  184220 */   // Label 3501: @184220
     /*  184220 */   GIM_Reject,
     /*  184221 */ // Label 3451: @184221
     /*  184221 */ GIM_Reject,
     /*  184222 */ // Label 3414: @184222
     /*  184222 */ GIM_Reject,
     /*  184223 */ // Label 26: @184223
     /*  184223 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3504*/ GIMT_Encode4(187132),
     /*  184234 */ /*GILLT_s32*//*Label 3502*/ GIMT_Encode4(184242),
     /*  184238 */ /*GILLT_s64*//*Label 3503*/ GIMT_Encode4(185482),
     /*  184242 */ // Label 3502: @184242
     /*  184242 */ GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(185481),
     /*  184247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  184250 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(184291), // Rule ID 344 //
     /*  184255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  184258 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184265 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184272 */     // MIs[0] rs1
     /*  184272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184284 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  184289 */     GIR_RootConstrainSelectedInstOperands,
     /*  184290 */     // GIR_Coverage, 344,
     /*  184290 */     GIR_Done,
     /*  184291 */   // Label 3506: @184291
     /*  184291 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(184332), // Rule ID 346 //
     /*  184296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  184299 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184313 */     // MIs[0] rs1
     /*  184313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184325 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184325 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  184330 */     GIR_RootConstrainSelectedInstOperands,
     /*  184331 */     // GIR_Coverage, 346,
     /*  184331 */     GIR_Done,
     /*  184332 */   // Label 3507: @184332
     /*  184332 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(184373), // Rule ID 348 //
     /*  184337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  184340 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184347 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184354 */     // MIs[0] rs1
     /*  184354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184366 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  184371 */     GIR_RootConstrainSelectedInstOperands,
     /*  184372 */     // GIR_Coverage, 348,
     /*  184372 */     GIR_Done,
     /*  184373 */   // Label 3508: @184373
     /*  184373 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(184414), // Rule ID 350 //
     /*  184378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  184381 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184388 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184395 */     // MIs[0] rs1
     /*  184395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184407 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184407 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  184412 */     GIR_RootConstrainSelectedInstOperands,
     /*  184413 */     // GIR_Coverage, 350,
     /*  184413 */     GIR_Done,
     /*  184414 */   // Label 3509: @184414
     /*  184414 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(184455), // Rule ID 352 //
     /*  184419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  184422 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184429 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184436 */     // MIs[0] rs1
     /*  184436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184448 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  184453 */     GIR_RootConstrainSelectedInstOperands,
     /*  184454 */     // GIR_Coverage, 352,
     /*  184454 */     GIR_Done,
     /*  184455 */   // Label 3510: @184455
     /*  184455 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(184496), // Rule ID 354 //
     /*  184460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184463 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184470 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184477 */     // MIs[0] rs1
     /*  184477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184489 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  184494 */     GIR_RootConstrainSelectedInstOperands,
     /*  184495 */     // GIR_Coverage, 354,
     /*  184495 */     GIR_Done,
     /*  184496 */   // Label 3511: @184496
     /*  184496 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(184537), // Rule ID 356 //
     /*  184501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184504 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184511 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184518 */     // MIs[0] rs1
     /*  184518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184530 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  184535 */     GIR_RootConstrainSelectedInstOperands,
     /*  184536 */     // GIR_Coverage, 356,
     /*  184536 */     GIR_Done,
     /*  184537 */   // Label 3512: @184537
     /*  184537 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(184578), // Rule ID 358 //
     /*  184542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184545 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184552 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184559 */     // MIs[0] rs1
     /*  184559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184571 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  184576 */     GIR_RootConstrainSelectedInstOperands,
     /*  184577 */     // GIR_Coverage, 358,
     /*  184577 */     GIR_Done,
     /*  184578 */   // Label 3513: @184578
     /*  184578 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(184619), // Rule ID 360 //
     /*  184583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184586 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184593 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184600 */     // MIs[0] rs1
     /*  184600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184612 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  184617 */     GIR_RootConstrainSelectedInstOperands,
     /*  184618 */     // GIR_Coverage, 360,
     /*  184618 */     GIR_Done,
     /*  184619 */   // Label 3514: @184619
     /*  184619 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(184660), // Rule ID 362 //
     /*  184624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184627 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184634 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184641 */     // MIs[0] rs1
     /*  184641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184653 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  184658 */     GIR_RootConstrainSelectedInstOperands,
     /*  184659 */     // GIR_Coverage, 362,
     /*  184659 */     GIR_Done,
     /*  184660 */   // Label 3515: @184660
     /*  184660 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(184701), // Rule ID 692 //
     /*  184665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184668 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184675 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184682 */     // MIs[0] rs1
     /*  184682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184694 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  184699 */     GIR_RootConstrainSelectedInstOperands,
     /*  184700 */     // GIR_Coverage, 692,
     /*  184700 */     GIR_Done,
     /*  184701 */   // Label 3516: @184701
     /*  184701 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(184742), // Rule ID 694 //
     /*  184706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184709 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184716 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184723 */     // MIs[0] rs1
     /*  184723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184735 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  184740 */     GIR_RootConstrainSelectedInstOperands,
     /*  184741 */     // GIR_Coverage, 694,
     /*  184741 */     GIR_Done,
     /*  184742 */   // Label 3517: @184742
     /*  184742 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(184783), // Rule ID 696 //
     /*  184747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184750 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184757 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184764 */     // MIs[0] rs1
     /*  184764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184776 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  184781 */     GIR_RootConstrainSelectedInstOperands,
     /*  184782 */     // GIR_Coverage, 696,
     /*  184782 */     GIR_Done,
     /*  184783 */   // Label 3518: @184783
     /*  184783 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(184824), // Rule ID 698 //
     /*  184788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184791 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184798 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184805 */     // MIs[0] rs1
     /*  184805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184817 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  184822 */     GIR_RootConstrainSelectedInstOperands,
     /*  184823 */     // GIR_Coverage, 698,
     /*  184823 */     GIR_Done,
     /*  184824 */   // Label 3519: @184824
     /*  184824 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(184865), // Rule ID 700 //
     /*  184829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184832 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184839 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184846 */     // MIs[0] rs1
     /*  184846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184858 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  184863 */     GIR_RootConstrainSelectedInstOperands,
     /*  184864 */     // GIR_Coverage, 700,
     /*  184864 */     GIR_Done,
     /*  184865 */   // Label 3520: @184865
     /*  184865 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(184906), // Rule ID 702 //
     /*  184870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184873 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184880 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184887 */     // MIs[0] rs1
     /*  184887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184899 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  184904 */     GIR_RootConstrainSelectedInstOperands,
     /*  184905 */     // GIR_Coverage, 702,
     /*  184905 */     GIR_Done,
     /*  184906 */   // Label 3521: @184906
     /*  184906 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(184947), // Rule ID 704 //
     /*  184911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184914 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184921 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184928 */     // MIs[0] rs1
     /*  184928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184940 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  184945 */     GIR_RootConstrainSelectedInstOperands,
     /*  184946 */     // GIR_Coverage, 704,
     /*  184946 */     GIR_Done,
     /*  184947 */   // Label 3522: @184947
     /*  184947 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(184988), // Rule ID 706 //
     /*  184952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184955 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184962 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184969 */     // MIs[0] rs1
     /*  184969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184981 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  184986 */     GIR_RootConstrainSelectedInstOperands,
     /*  184987 */     // GIR_Coverage, 706,
     /*  184987 */     GIR_Done,
     /*  184988 */   // Label 3523: @184988
     /*  184988 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(185029), // Rule ID 708 //
     /*  184993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184996 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185003 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185010 */     // MIs[0] rs1
     /*  185010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185022 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  185027 */     GIR_RootConstrainSelectedInstOperands,
     /*  185028 */     // GIR_Coverage, 708,
     /*  185028 */     GIR_Done,
     /*  185029 */   // Label 3524: @185029
     /*  185029 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(185070), // Rule ID 710 //
     /*  185034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  185037 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185044 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185051 */     // MIs[0] rs1
     /*  185051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185063 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  185068 */     GIR_RootConstrainSelectedInstOperands,
     /*  185069 */     // GIR_Coverage, 710,
     /*  185069 */     GIR_Done,
     /*  185070 */   // Label 3525: @185070
     /*  185070 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(185111), // Rule ID 872 //
     /*  185075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  185078 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185085 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185092 */     // MIs[0] rs1
     /*  185092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185104 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  185109 */     GIR_RootConstrainSelectedInstOperands,
     /*  185110 */     // GIR_Coverage, 872,
     /*  185110 */     GIR_Done,
     /*  185111 */   // Label 3526: @185111
     /*  185111 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(185152), // Rule ID 874 //
     /*  185116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  185119 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185133 */     // MIs[0] rs1
     /*  185133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185145 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  185150 */     GIR_RootConstrainSelectedInstOperands,
     /*  185151 */     // GIR_Coverage, 874,
     /*  185151 */     GIR_Done,
     /*  185152 */   // Label 3527: @185152
     /*  185152 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(185193), // Rule ID 876 //
     /*  185157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  185160 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185167 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185174 */     // MIs[0] rs1
     /*  185174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185186 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  185191 */     GIR_RootConstrainSelectedInstOperands,
     /*  185192 */     // GIR_Coverage, 876,
     /*  185192 */     GIR_Done,
     /*  185193 */   // Label 3528: @185193
     /*  185193 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(185234), // Rule ID 878 //
     /*  185198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  185201 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185208 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185215 */     // MIs[0] rs1
     /*  185215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185227 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  185232 */     GIR_RootConstrainSelectedInstOperands,
     /*  185233 */     // GIR_Coverage, 878,
     /*  185233 */     GIR_Done,
     /*  185234 */   // Label 3529: @185234
     /*  185234 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(185275), // Rule ID 880 //
     /*  185239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  185242 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185249 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185256 */     // MIs[0] rs1
     /*  185256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185268 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  185273 */     GIR_RootConstrainSelectedInstOperands,
     /*  185274 */     // GIR_Coverage, 880,
     /*  185274 */     GIR_Done,
     /*  185275 */   // Label 3530: @185275
     /*  185275 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(185316), // Rule ID 882 //
     /*  185280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  185283 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185290 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185297 */     // MIs[0] rs1
     /*  185297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185309 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185309 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  185314 */     GIR_RootConstrainSelectedInstOperands,
     /*  185315 */     // GIR_Coverage, 882,
     /*  185315 */     GIR_Done,
     /*  185316 */   // Label 3531: @185316
     /*  185316 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(185357), // Rule ID 884 //
     /*  185321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  185324 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185331 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185338 */     // MIs[0] rs1
     /*  185338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185350 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  185355 */     GIR_RootConstrainSelectedInstOperands,
     /*  185356 */     // GIR_Coverage, 884,
     /*  185356 */     GIR_Done,
     /*  185357 */   // Label 3532: @185357
     /*  185357 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(185398), // Rule ID 886 //
     /*  185362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  185365 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185372 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185379 */     // MIs[0] rs1
     /*  185379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185391 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  185396 */     GIR_RootConstrainSelectedInstOperands,
     /*  185397 */     // GIR_Coverage, 886,
     /*  185397 */     GIR_Done,
     /*  185398 */   // Label 3533: @185398
     /*  185398 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(185439), // Rule ID 888 //
     /*  185403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  185406 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185413 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185420 */     // MIs[0] rs1
     /*  185420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185432 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  185437 */     GIR_RootConstrainSelectedInstOperands,
     /*  185438 */     // GIR_Coverage, 888,
     /*  185438 */     GIR_Done,
     /*  185439 */   // Label 3534: @185439
     /*  185439 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(185480), // Rule ID 890 //
     /*  185444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  185447 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185461 */     // MIs[0] rs1
     /*  185461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185473 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  185478 */     GIR_RootConstrainSelectedInstOperands,
     /*  185479 */     // GIR_Coverage, 890,
     /*  185479 */     GIR_Done,
     /*  185480 */   // Label 3535: @185480
     /*  185480 */   GIM_Reject,
     /*  185481 */ // Label 3505: @185481
     /*  185481 */ GIM_Reject,
     /*  185482 */ // Label 3503: @185482
     /*  185482 */ GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(187131),
     /*  185487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  185490 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(185531), // Rule ID 343 //
     /*  185495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185512 */     // MIs[0] rs1
     /*  185512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185524 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  185529 */     GIR_RootConstrainSelectedInstOperands,
     /*  185530 */     // GIR_Coverage, 343,
     /*  185530 */     GIR_Done,
     /*  185531 */   // Label 3537: @185531
     /*  185531 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(185572), // Rule ID 345 //
     /*  185536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185553 */     // MIs[0] rs1
     /*  185553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185565 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  185570 */     GIR_RootConstrainSelectedInstOperands,
     /*  185571 */     // GIR_Coverage, 345,
     /*  185571 */     GIR_Done,
     /*  185572 */   // Label 3538: @185572
     /*  185572 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(185613), // Rule ID 347 //
     /*  185577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185580 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185587 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185594 */     // MIs[0] rs1
     /*  185594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185606 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  185611 */     GIR_RootConstrainSelectedInstOperands,
     /*  185612 */     // GIR_Coverage, 347,
     /*  185612 */     GIR_Done,
     /*  185613 */   // Label 3539: @185613
     /*  185613 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(185654), // Rule ID 349 //
     /*  185618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185621 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185628 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185635 */     // MIs[0] rs1
     /*  185635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185647 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  185652 */     GIR_RootConstrainSelectedInstOperands,
     /*  185653 */     // GIR_Coverage, 349,
     /*  185653 */     GIR_Done,
     /*  185654 */   // Label 3540: @185654
     /*  185654 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(185695), // Rule ID 351 //
     /*  185659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185662 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185669 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185676 */     // MIs[0] rs1
     /*  185676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185688 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  185693 */     GIR_RootConstrainSelectedInstOperands,
     /*  185694 */     // GIR_Coverage, 351,
     /*  185694 */     GIR_Done,
     /*  185695 */   // Label 3541: @185695
     /*  185695 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(185736), // Rule ID 353 //
     /*  185700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185710 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185717 */     // MIs[0] rs1
     /*  185717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185729 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  185734 */     GIR_RootConstrainSelectedInstOperands,
     /*  185735 */     // GIR_Coverage, 353,
     /*  185735 */     GIR_Done,
     /*  185736 */   // Label 3542: @185736
     /*  185736 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(185777), // Rule ID 355 //
     /*  185741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185744 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185758 */     // MIs[0] rs1
     /*  185758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185770 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  185775 */     GIR_RootConstrainSelectedInstOperands,
     /*  185776 */     // GIR_Coverage, 355,
     /*  185776 */     GIR_Done,
     /*  185777 */   // Label 3543: @185777
     /*  185777 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(185818), // Rule ID 357 //
     /*  185782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185785 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185792 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185799 */     // MIs[0] rs1
     /*  185799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185811 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  185816 */     GIR_RootConstrainSelectedInstOperands,
     /*  185817 */     // GIR_Coverage, 357,
     /*  185817 */     GIR_Done,
     /*  185818 */   // Label 3544: @185818
     /*  185818 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(185859), // Rule ID 359 //
     /*  185823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185826 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185833 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185840 */     // MIs[0] rs1
     /*  185840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185852 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  185857 */     GIR_RootConstrainSelectedInstOperands,
     /*  185858 */     // GIR_Coverage, 359,
     /*  185858 */     GIR_Done,
     /*  185859 */   // Label 3545: @185859
     /*  185859 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(185900), // Rule ID 361 //
     /*  185864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185867 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185874 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185881 */     // MIs[0] rs1
     /*  185881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185893 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  185898 */     GIR_RootConstrainSelectedInstOperands,
     /*  185899 */     // GIR_Coverage, 361,
     /*  185899 */     GIR_Done,
     /*  185900 */   // Label 3546: @185900
     /*  185900 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(185941), // Rule ID 523 //
     /*  185905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185908 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185922 */     // MIs[0] rs1
     /*  185922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185934 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  185939 */     GIR_RootConstrainSelectedInstOperands,
     /*  185940 */     // GIR_Coverage, 523,
     /*  185940 */     GIR_Done,
     /*  185941 */   // Label 3547: @185941
     /*  185941 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(185982), // Rule ID 524 //
     /*  185946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185949 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185956 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185963 */     // MIs[0] rs1
     /*  185963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185975 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ),
     /*  185980 */     GIR_RootConstrainSelectedInstOperands,
     /*  185981 */     // GIR_Coverage, 524,
     /*  185981 */     GIR_Done,
     /*  185982 */   // Label 3548: @185982
     /*  185982 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(186023), // Rule ID 525 //
     /*  185987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185990 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185997 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186004 */     // MIs[0] rs1
     /*  186004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186016 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_RL),
     /*  186021 */     GIR_RootConstrainSelectedInstOperands,
     /*  186022 */     // GIR_Coverage, 525,
     /*  186022 */     GIR_Done,
     /*  186023 */   // Label 3549: @186023
     /*  186023 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(186064), // Rule ID 526 //
     /*  186028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  186031 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186038 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186045 */     // MIs[0] rs1
     /*  186045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186057 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  186062 */     GIR_RootConstrainSelectedInstOperands,
     /*  186063 */     // GIR_Coverage, 526,
     /*  186063 */     GIR_Done,
     /*  186064 */   // Label 3550: @186064
     /*  186064 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(186105), // Rule ID 527 //
     /*  186069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  186072 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186079 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186086 */     // MIs[0] rs1
     /*  186086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186098 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  186103 */     GIR_RootConstrainSelectedInstOperands,
     /*  186104 */     // GIR_Coverage, 527,
     /*  186104 */     GIR_Done,
     /*  186105 */   // Label 3551: @186105
     /*  186105 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(186146), // Rule ID 528 //
     /*  186110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  186113 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186120 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186127 */     // MIs[0] rs1
     /*  186127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186139 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  186144 */     GIR_RootConstrainSelectedInstOperands,
     /*  186145 */     // GIR_Coverage, 528,
     /*  186145 */     GIR_Done,
     /*  186146 */   // Label 3552: @186146
     /*  186146 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(186187), // Rule ID 529 //
     /*  186151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  186154 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186161 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186168 */     // MIs[0] rs1
     /*  186168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186180 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  186185 */     GIR_RootConstrainSelectedInstOperands,
     /*  186186 */     // GIR_Coverage, 529,
     /*  186186 */     GIR_Done,
     /*  186187 */   // Label 3553: @186187
     /*  186187 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(186228), // Rule ID 530 //
     /*  186192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  186195 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186202 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186209 */     // MIs[0] rs1
     /*  186209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186221 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  186226 */     GIR_RootConstrainSelectedInstOperands,
     /*  186227 */     // GIR_Coverage, 530,
     /*  186227 */     GIR_Done,
     /*  186228 */   // Label 3554: @186228
     /*  186228 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(186269), // Rule ID 531 //
     /*  186233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  186236 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186243 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186250 */     // MIs[0] rs1
     /*  186250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186262 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  186267 */     GIR_RootConstrainSelectedInstOperands,
     /*  186268 */     // GIR_Coverage, 531,
     /*  186268 */     GIR_Done,
     /*  186269 */   // Label 3555: @186269
     /*  186269 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(186310), // Rule ID 532 //
     /*  186274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  186277 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186284 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186291 */     // MIs[0] rs1
     /*  186291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186303 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  186308 */     GIR_RootConstrainSelectedInstOperands,
     /*  186309 */     // GIR_Coverage, 532,
     /*  186309 */     GIR_Done,
     /*  186310 */   // Label 3556: @186310
     /*  186310 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(186351), // Rule ID 691 //
     /*  186315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186318 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186325 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186332 */     // MIs[0] rs1
     /*  186332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186344 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  186349 */     GIR_RootConstrainSelectedInstOperands,
     /*  186350 */     // GIR_Coverage, 691,
     /*  186350 */     GIR_Done,
     /*  186351 */   // Label 3557: @186351
     /*  186351 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(186392), // Rule ID 693 //
     /*  186356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186359 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186366 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186373 */     // MIs[0] rs1
     /*  186373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186385 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  186390 */     GIR_RootConstrainSelectedInstOperands,
     /*  186391 */     // GIR_Coverage, 693,
     /*  186391 */     GIR_Done,
     /*  186392 */   // Label 3558: @186392
     /*  186392 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(186433), // Rule ID 695 //
     /*  186397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186400 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186414 */     // MIs[0] rs1
     /*  186414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186426 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  186431 */     GIR_RootConstrainSelectedInstOperands,
     /*  186432 */     // GIR_Coverage, 695,
     /*  186432 */     GIR_Done,
     /*  186433 */   // Label 3559: @186433
     /*  186433 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(186474), // Rule ID 697 //
     /*  186438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186455 */     // MIs[0] rs1
     /*  186455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186467 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  186472 */     GIR_RootConstrainSelectedInstOperands,
     /*  186473 */     // GIR_Coverage, 697,
     /*  186473 */     GIR_Done,
     /*  186474 */   // Label 3560: @186474
     /*  186474 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(186515), // Rule ID 699 //
     /*  186479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186482 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186496 */     // MIs[0] rs1
     /*  186496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186508 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  186513 */     GIR_RootConstrainSelectedInstOperands,
     /*  186514 */     // GIR_Coverage, 699,
     /*  186514 */     GIR_Done,
     /*  186515 */   // Label 3561: @186515
     /*  186515 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(186556), // Rule ID 701 //
     /*  186520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186530 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186537 */     // MIs[0] rs1
     /*  186537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186549 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  186554 */     GIR_RootConstrainSelectedInstOperands,
     /*  186555 */     // GIR_Coverage, 701,
     /*  186555 */     GIR_Done,
     /*  186556 */   // Label 3562: @186556
     /*  186556 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(186597), // Rule ID 703 //
     /*  186561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186564 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186571 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186578 */     // MIs[0] rs1
     /*  186578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186590 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  186595 */     GIR_RootConstrainSelectedInstOperands,
     /*  186596 */     // GIR_Coverage, 703,
     /*  186596 */     GIR_Done,
     /*  186597 */   // Label 3563: @186597
     /*  186597 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(186638), // Rule ID 705 //
     /*  186602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186612 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186619 */     // MIs[0] rs1
     /*  186619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186631 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  186636 */     GIR_RootConstrainSelectedInstOperands,
     /*  186637 */     // GIR_Coverage, 705,
     /*  186637 */     GIR_Done,
     /*  186638 */   // Label 3564: @186638
     /*  186638 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(186679), // Rule ID 707 //
     /*  186643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186660 */     // MIs[0] rs1
     /*  186660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186672 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  186677 */     GIR_RootConstrainSelectedInstOperands,
     /*  186678 */     // GIR_Coverage, 707,
     /*  186678 */     GIR_Done,
     /*  186679 */   // Label 3565: @186679
     /*  186679 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(186720), // Rule ID 709 //
     /*  186684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186701 */     // MIs[0] rs1
     /*  186701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186713 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  186718 */     GIR_RootConstrainSelectedInstOperands,
     /*  186719 */     // GIR_Coverage, 709,
     /*  186719 */     GIR_Done,
     /*  186720 */   // Label 3566: @186720
     /*  186720 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(186761), // Rule ID 871 //
     /*  186725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186742 */     // MIs[0] rs1
     /*  186742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186754 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  186759 */     GIR_RootConstrainSelectedInstOperands,
     /*  186760 */     // GIR_Coverage, 871,
     /*  186760 */     GIR_Done,
     /*  186761 */   // Label 3567: @186761
     /*  186761 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(186802), // Rule ID 873 //
     /*  186766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186769 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186783 */     // MIs[0] rs1
     /*  186783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186795 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  186800 */     GIR_RootConstrainSelectedInstOperands,
     /*  186801 */     // GIR_Coverage, 873,
     /*  186801 */     GIR_Done,
     /*  186802 */   // Label 3568: @186802
     /*  186802 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(186843), // Rule ID 875 //
     /*  186807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186824 */     // MIs[0] rs1
     /*  186824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186836 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  186841 */     GIR_RootConstrainSelectedInstOperands,
     /*  186842 */     // GIR_Coverage, 875,
     /*  186842 */     GIR_Done,
     /*  186843 */   // Label 3569: @186843
     /*  186843 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(186884), // Rule ID 877 //
     /*  186848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186851 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186858 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186865 */     // MIs[0] rs1
     /*  186865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186877 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  186882 */     GIR_RootConstrainSelectedInstOperands,
     /*  186883 */     // GIR_Coverage, 877,
     /*  186883 */     GIR_Done,
     /*  186884 */   // Label 3570: @186884
     /*  186884 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(186925), // Rule ID 879 //
     /*  186889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186892 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186906 */     // MIs[0] rs1
     /*  186906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186918 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  186923 */     GIR_RootConstrainSelectedInstOperands,
     /*  186924 */     // GIR_Coverage, 879,
     /*  186924 */     GIR_Done,
     /*  186925 */   // Label 3571: @186925
     /*  186925 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(186966), // Rule ID 881 //
     /*  186930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186940 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186947 */     // MIs[0] rs1
     /*  186947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186959 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  186964 */     GIR_RootConstrainSelectedInstOperands,
     /*  186965 */     // GIR_Coverage, 881,
     /*  186965 */     GIR_Done,
     /*  186966 */   // Label 3572: @186966
     /*  186966 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(187007), // Rule ID 883 //
     /*  186971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186974 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186981 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186988 */     // MIs[0] rs1
     /*  186988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187000 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  187005 */     GIR_RootConstrainSelectedInstOperands,
     /*  187006 */     // GIR_Coverage, 883,
     /*  187006 */     GIR_Done,
     /*  187007 */   // Label 3573: @187007
     /*  187007 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(187048), // Rule ID 885 //
     /*  187012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  187015 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187022 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187029 */     // MIs[0] rs1
     /*  187029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187041 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  187046 */     GIR_RootConstrainSelectedInstOperands,
     /*  187047 */     // GIR_Coverage, 885,
     /*  187047 */     GIR_Done,
     /*  187048 */   // Label 3574: @187048
     /*  187048 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(187089), // Rule ID 887 //
     /*  187053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  187056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187070 */     // MIs[0] rs1
     /*  187070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187082 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  187087 */     GIR_RootConstrainSelectedInstOperands,
     /*  187088 */     // GIR_Coverage, 887,
     /*  187088 */     GIR_Done,
     /*  187089 */   // Label 3575: @187089
     /*  187089 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(187130), // Rule ID 889 //
     /*  187094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  187097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187111 */     // MIs[0] rs1
     /*  187111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187123 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  187128 */     GIR_RootConstrainSelectedInstOperands,
     /*  187129 */     // GIR_Coverage, 889,
     /*  187129 */     GIR_Done,
     /*  187130 */   // Label 3576: @187130
     /*  187130 */   GIM_Reject,
     /*  187131 */ // Label 3536: @187131
     /*  187131 */ GIM_Reject,
     /*  187132 */ // Label 3504: @187132
     /*  187132 */ GIM_Reject,
     /*  187133 */ // Label 27: @187133
     /*  187133 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3579*/ GIMT_Encode4(190042),
     /*  187144 */ /*GILLT_s32*//*Label 3577*/ GIMT_Encode4(187152),
     /*  187148 */ /*GILLT_s64*//*Label 3578*/ GIMT_Encode4(188392),
     /*  187152 */ // Label 3577: @187152
     /*  187152 */ GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(188391),
     /*  187157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  187160 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(187201), // Rule ID 364 //
     /*  187165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  187168 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187175 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187182 */     // MIs[0] rs1
     /*  187182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187194 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  187199 */     GIR_RootConstrainSelectedInstOperands,
     /*  187200 */     // GIR_Coverage, 364,
     /*  187200 */     GIR_Done,
     /*  187201 */   // Label 3581: @187201
     /*  187201 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(187242), // Rule ID 366 //
     /*  187206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  187209 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187216 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187223 */     // MIs[0] rs1
     /*  187223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187235 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  187240 */     GIR_RootConstrainSelectedInstOperands,
     /*  187241 */     // GIR_Coverage, 366,
     /*  187241 */     GIR_Done,
     /*  187242 */   // Label 3582: @187242
     /*  187242 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(187283), // Rule ID 368 //
     /*  187247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  187250 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187257 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187264 */     // MIs[0] rs1
     /*  187264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187276 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  187281 */     GIR_RootConstrainSelectedInstOperands,
     /*  187282 */     // GIR_Coverage, 368,
     /*  187282 */     GIR_Done,
     /*  187283 */   // Label 3583: @187283
     /*  187283 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(187324), // Rule ID 370 //
     /*  187288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  187291 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187298 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187305 */     // MIs[0] rs1
     /*  187305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187317 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  187322 */     GIR_RootConstrainSelectedInstOperands,
     /*  187323 */     // GIR_Coverage, 370,
     /*  187323 */     GIR_Done,
     /*  187324 */   // Label 3584: @187324
     /*  187324 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(187365), // Rule ID 372 //
     /*  187329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  187332 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187339 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187346 */     // MIs[0] rs1
     /*  187346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187358 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  187363 */     GIR_RootConstrainSelectedInstOperands,
     /*  187364 */     // GIR_Coverage, 372,
     /*  187364 */     GIR_Done,
     /*  187365 */   // Label 3585: @187365
     /*  187365 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(187406), // Rule ID 374 //
     /*  187370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187373 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187380 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187387 */     // MIs[0] rs1
     /*  187387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187399 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  187404 */     GIR_RootConstrainSelectedInstOperands,
     /*  187405 */     // GIR_Coverage, 374,
     /*  187405 */     GIR_Done,
     /*  187406 */   // Label 3586: @187406
     /*  187406 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(187447), // Rule ID 376 //
     /*  187411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187414 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187421 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187428 */     // MIs[0] rs1
     /*  187428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187440 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  187445 */     GIR_RootConstrainSelectedInstOperands,
     /*  187446 */     // GIR_Coverage, 376,
     /*  187446 */     GIR_Done,
     /*  187447 */   // Label 3587: @187447
     /*  187447 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(187488), // Rule ID 378 //
     /*  187452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187455 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187462 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187469 */     // MIs[0] rs1
     /*  187469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187481 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  187486 */     GIR_RootConstrainSelectedInstOperands,
     /*  187487 */     // GIR_Coverage, 378,
     /*  187487 */     GIR_Done,
     /*  187488 */   // Label 3588: @187488
     /*  187488 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(187529), // Rule ID 380 //
     /*  187493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187496 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187503 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187510 */     // MIs[0] rs1
     /*  187510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187522 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  187527 */     GIR_RootConstrainSelectedInstOperands,
     /*  187528 */     // GIR_Coverage, 380,
     /*  187528 */     GIR_Done,
     /*  187529 */   // Label 3589: @187529
     /*  187529 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(187570), // Rule ID 382 //
     /*  187534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187537 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187544 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187551 */     // MIs[0] rs1
     /*  187551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187563 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187563 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  187568 */     GIR_RootConstrainSelectedInstOperands,
     /*  187569 */     // GIR_Coverage, 382,
     /*  187569 */     GIR_Done,
     /*  187570 */   // Label 3590: @187570
     /*  187570 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(187611), // Rule ID 712 //
     /*  187575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187592 */     // MIs[0] rs1
     /*  187592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187604 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  187609 */     GIR_RootConstrainSelectedInstOperands,
     /*  187610 */     // GIR_Coverage, 712,
     /*  187610 */     GIR_Done,
     /*  187611 */   // Label 3591: @187611
     /*  187611 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(187652), // Rule ID 714 //
     /*  187616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187619 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187626 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187633 */     // MIs[0] rs1
     /*  187633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187645 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  187650 */     GIR_RootConstrainSelectedInstOperands,
     /*  187651 */     // GIR_Coverage, 714,
     /*  187651 */     GIR_Done,
     /*  187652 */   // Label 3592: @187652
     /*  187652 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(187693), // Rule ID 716 //
     /*  187657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187660 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187667 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187674 */     // MIs[0] rs1
     /*  187674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187686 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  187691 */     GIR_RootConstrainSelectedInstOperands,
     /*  187692 */     // GIR_Coverage, 716,
     /*  187692 */     GIR_Done,
     /*  187693 */   // Label 3593: @187693
     /*  187693 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(187734), // Rule ID 718 //
     /*  187698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187701 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187708 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187715 */     // MIs[0] rs1
     /*  187715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187727 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  187732 */     GIR_RootConstrainSelectedInstOperands,
     /*  187733 */     // GIR_Coverage, 718,
     /*  187733 */     GIR_Done,
     /*  187734 */   // Label 3594: @187734
     /*  187734 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(187775), // Rule ID 720 //
     /*  187739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187742 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187749 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187756 */     // MIs[0] rs1
     /*  187756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187768 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  187773 */     GIR_RootConstrainSelectedInstOperands,
     /*  187774 */     // GIR_Coverage, 720,
     /*  187774 */     GIR_Done,
     /*  187775 */   // Label 3595: @187775
     /*  187775 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(187816), // Rule ID 722 //
     /*  187780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187783 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187790 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187797 */     // MIs[0] rs1
     /*  187797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187809 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  187814 */     GIR_RootConstrainSelectedInstOperands,
     /*  187815 */     // GIR_Coverage, 722,
     /*  187815 */     GIR_Done,
     /*  187816 */   // Label 3596: @187816
     /*  187816 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(187857), // Rule ID 724 //
     /*  187821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187824 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187831 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187838 */     // MIs[0] rs1
     /*  187838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187850 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  187855 */     GIR_RootConstrainSelectedInstOperands,
     /*  187856 */     // GIR_Coverage, 724,
     /*  187856 */     GIR_Done,
     /*  187857 */   // Label 3597: @187857
     /*  187857 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(187898), // Rule ID 726 //
     /*  187862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187865 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187872 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187879 */     // MIs[0] rs1
     /*  187879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187891 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  187896 */     GIR_RootConstrainSelectedInstOperands,
     /*  187897 */     // GIR_Coverage, 726,
     /*  187897 */     GIR_Done,
     /*  187898 */   // Label 3598: @187898
     /*  187898 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(187939), // Rule ID 728 //
     /*  187903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187913 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187920 */     // MIs[0] rs1
     /*  187920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187932 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  187937 */     GIR_RootConstrainSelectedInstOperands,
     /*  187938 */     // GIR_Coverage, 728,
     /*  187938 */     GIR_Done,
     /*  187939 */   // Label 3599: @187939
     /*  187939 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(187980), // Rule ID 730 //
     /*  187944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187947 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187954 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187961 */     // MIs[0] rs1
     /*  187961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187973 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  187978 */     GIR_RootConstrainSelectedInstOperands,
     /*  187979 */     // GIR_Coverage, 730,
     /*  187979 */     GIR_Done,
     /*  187980 */   // Label 3600: @187980
     /*  187980 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(188021), // Rule ID 892 //
     /*  187985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187988 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187995 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188002 */     // MIs[0] rs1
     /*  188002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188014 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  188019 */     GIR_RootConstrainSelectedInstOperands,
     /*  188020 */     // GIR_Coverage, 892,
     /*  188020 */     GIR_Done,
     /*  188021 */   // Label 3601: @188021
     /*  188021 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(188062), // Rule ID 894 //
     /*  188026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  188029 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188036 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188043 */     // MIs[0] rs1
     /*  188043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188055 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  188060 */     GIR_RootConstrainSelectedInstOperands,
     /*  188061 */     // GIR_Coverage, 894,
     /*  188061 */     GIR_Done,
     /*  188062 */   // Label 3602: @188062
     /*  188062 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(188103), // Rule ID 896 //
     /*  188067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  188070 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188077 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188084 */     // MIs[0] rs1
     /*  188084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188096 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  188101 */     GIR_RootConstrainSelectedInstOperands,
     /*  188102 */     // GIR_Coverage, 896,
     /*  188102 */     GIR_Done,
     /*  188103 */   // Label 3603: @188103
     /*  188103 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(188144), // Rule ID 898 //
     /*  188108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  188111 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188118 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188125 */     // MIs[0] rs1
     /*  188125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188137 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  188142 */     GIR_RootConstrainSelectedInstOperands,
     /*  188143 */     // GIR_Coverage, 898,
     /*  188143 */     GIR_Done,
     /*  188144 */   // Label 3604: @188144
     /*  188144 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(188185), // Rule ID 900 //
     /*  188149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  188152 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188159 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188166 */     // MIs[0] rs1
     /*  188166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188178 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  188183 */     GIR_RootConstrainSelectedInstOperands,
     /*  188184 */     // GIR_Coverage, 900,
     /*  188184 */     GIR_Done,
     /*  188185 */   // Label 3605: @188185
     /*  188185 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(188226), // Rule ID 902 //
     /*  188190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  188193 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188200 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188207 */     // MIs[0] rs1
     /*  188207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188219 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  188224 */     GIR_RootConstrainSelectedInstOperands,
     /*  188225 */     // GIR_Coverage, 902,
     /*  188225 */     GIR_Done,
     /*  188226 */   // Label 3606: @188226
     /*  188226 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(188267), // Rule ID 904 //
     /*  188231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  188234 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188241 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188248 */     // MIs[0] rs1
     /*  188248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188260 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  188265 */     GIR_RootConstrainSelectedInstOperands,
     /*  188266 */     // GIR_Coverage, 904,
     /*  188266 */     GIR_Done,
     /*  188267 */   // Label 3607: @188267
     /*  188267 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(188308), // Rule ID 906 //
     /*  188272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  188275 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188282 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188289 */     // MIs[0] rs1
     /*  188289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188301 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  188306 */     GIR_RootConstrainSelectedInstOperands,
     /*  188307 */     // GIR_Coverage, 906,
     /*  188307 */     GIR_Done,
     /*  188308 */   // Label 3608: @188308
     /*  188308 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(188349), // Rule ID 908 //
     /*  188313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  188316 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188323 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188330 */     // MIs[0] rs1
     /*  188330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188342 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  188347 */     GIR_RootConstrainSelectedInstOperands,
     /*  188348 */     // GIR_Coverage, 908,
     /*  188348 */     GIR_Done,
     /*  188349 */   // Label 3609: @188349
     /*  188349 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(188390), // Rule ID 910 //
     /*  188354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  188357 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188364 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188371 */     // MIs[0] rs1
     /*  188371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188383 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188383 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  188388 */     GIR_RootConstrainSelectedInstOperands,
     /*  188389 */     // GIR_Coverage, 910,
     /*  188389 */     GIR_Done,
     /*  188390 */   // Label 3610: @188390
     /*  188390 */   GIM_Reject,
     /*  188391 */ // Label 3580: @188391
     /*  188391 */ GIM_Reject,
     /*  188392 */ // Label 3578: @188392
     /*  188392 */ GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(190041),
     /*  188397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  188400 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(188441), // Rule ID 363 //
     /*  188405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188408 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188415 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188422 */     // MIs[0] rs1
     /*  188422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188434 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  188439 */     GIR_RootConstrainSelectedInstOperands,
     /*  188440 */     // GIR_Coverage, 363,
     /*  188440 */     GIR_Done,
     /*  188441 */   // Label 3612: @188441
     /*  188441 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(188482), // Rule ID 365 //
     /*  188446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188449 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188463 */     // MIs[0] rs1
     /*  188463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188475 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  188480 */     GIR_RootConstrainSelectedInstOperands,
     /*  188481 */     // GIR_Coverage, 365,
     /*  188481 */     GIR_Done,
     /*  188482 */   // Label 3613: @188482
     /*  188482 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(188523), // Rule ID 367 //
     /*  188487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188490 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188504 */     // MIs[0] rs1
     /*  188504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188516 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  188521 */     GIR_RootConstrainSelectedInstOperands,
     /*  188522 */     // GIR_Coverage, 367,
     /*  188522 */     GIR_Done,
     /*  188523 */   // Label 3614: @188523
     /*  188523 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(188564), // Rule ID 369 //
     /*  188528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188531 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188545 */     // MIs[0] rs1
     /*  188545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188557 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188557 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  188562 */     GIR_RootConstrainSelectedInstOperands,
     /*  188563 */     // GIR_Coverage, 369,
     /*  188563 */     GIR_Done,
     /*  188564 */   // Label 3615: @188564
     /*  188564 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(188605), // Rule ID 371 //
     /*  188569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188572 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188579 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188586 */     // MIs[0] rs1
     /*  188586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188598 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  188603 */     GIR_RootConstrainSelectedInstOperands,
     /*  188604 */     // GIR_Coverage, 371,
     /*  188604 */     GIR_Done,
     /*  188605 */   // Label 3616: @188605
     /*  188605 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(188646), // Rule ID 373 //
     /*  188610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188613 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188620 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188627 */     // MIs[0] rs1
     /*  188627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188639 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188639 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  188644 */     GIR_RootConstrainSelectedInstOperands,
     /*  188645 */     // GIR_Coverage, 373,
     /*  188645 */     GIR_Done,
     /*  188646 */   // Label 3617: @188646
     /*  188646 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(188687), // Rule ID 375 //
     /*  188651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188654 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188661 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188668 */     // MIs[0] rs1
     /*  188668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188680 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  188685 */     GIR_RootConstrainSelectedInstOperands,
     /*  188686 */     // GIR_Coverage, 375,
     /*  188686 */     GIR_Done,
     /*  188687 */   // Label 3618: @188687
     /*  188687 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(188728), // Rule ID 377 //
     /*  188692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188709 */     // MIs[0] rs1
     /*  188709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188721 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  188726 */     GIR_RootConstrainSelectedInstOperands,
     /*  188727 */     // GIR_Coverage, 377,
     /*  188727 */     GIR_Done,
     /*  188728 */   // Label 3619: @188728
     /*  188728 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(188769), // Rule ID 379 //
     /*  188733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188750 */     // MIs[0] rs1
     /*  188750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188762 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  188767 */     GIR_RootConstrainSelectedInstOperands,
     /*  188768 */     // GIR_Coverage, 379,
     /*  188768 */     GIR_Done,
     /*  188769 */   // Label 3620: @188769
     /*  188769 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(188810), // Rule ID 381 //
     /*  188774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188777 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188791 */     // MIs[0] rs1
     /*  188791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188803 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  188808 */     GIR_RootConstrainSelectedInstOperands,
     /*  188809 */     // GIR_Coverage, 381,
     /*  188809 */     GIR_Done,
     /*  188810 */   // Label 3621: @188810
     /*  188810 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(188851), // Rule ID 533 //
     /*  188815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188818 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188825 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188832 */     // MIs[0] rs1
     /*  188832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188844 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  188849 */     GIR_RootConstrainSelectedInstOperands,
     /*  188850 */     // GIR_Coverage, 533,
     /*  188850 */     GIR_Done,
     /*  188851 */   // Label 3622: @188851
     /*  188851 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(188892), // Rule ID 534 //
     /*  188856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188866 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188873 */     // MIs[0] rs1
     /*  188873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188885 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ),
     /*  188890 */     GIR_RootConstrainSelectedInstOperands,
     /*  188891 */     // GIR_Coverage, 534,
     /*  188891 */     GIR_Done,
     /*  188892 */   // Label 3623: @188892
     /*  188892 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(188933), // Rule ID 535 //
     /*  188897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188900 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188907 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188914 */     // MIs[0] rs1
     /*  188914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188926 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_RL),
     /*  188931 */     GIR_RootConstrainSelectedInstOperands,
     /*  188932 */     // GIR_Coverage, 535,
     /*  188932 */     GIR_Done,
     /*  188933 */   // Label 3624: @188933
     /*  188933 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(188974), // Rule ID 536 //
     /*  188938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188941 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188948 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188955 */     // MIs[0] rs1
     /*  188955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188967 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  188972 */     GIR_RootConstrainSelectedInstOperands,
     /*  188973 */     // GIR_Coverage, 536,
     /*  188973 */     GIR_Done,
     /*  188974 */   // Label 3625: @188974
     /*  188974 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(189015), // Rule ID 537 //
     /*  188979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188982 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188989 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188996 */     // MIs[0] rs1
     /*  188996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189008 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  189013 */     GIR_RootConstrainSelectedInstOperands,
     /*  189014 */     // GIR_Coverage, 537,
     /*  189014 */     GIR_Done,
     /*  189015 */   // Label 3626: @189015
     /*  189015 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(189056), // Rule ID 538 //
     /*  189020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  189023 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189030 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189037 */     // MIs[0] rs1
     /*  189037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189049 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  189054 */     GIR_RootConstrainSelectedInstOperands,
     /*  189055 */     // GIR_Coverage, 538,
     /*  189055 */     GIR_Done,
     /*  189056 */   // Label 3627: @189056
     /*  189056 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(189097), // Rule ID 539 //
     /*  189061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  189064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189078 */     // MIs[0] rs1
     /*  189078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189090 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  189095 */     GIR_RootConstrainSelectedInstOperands,
     /*  189096 */     // GIR_Coverage, 539,
     /*  189096 */     GIR_Done,
     /*  189097 */   // Label 3628: @189097
     /*  189097 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(189138), // Rule ID 540 //
     /*  189102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  189105 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189112 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189119 */     // MIs[0] rs1
     /*  189119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189131 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  189136 */     GIR_RootConstrainSelectedInstOperands,
     /*  189137 */     // GIR_Coverage, 540,
     /*  189137 */     GIR_Done,
     /*  189138 */   // Label 3629: @189138
     /*  189138 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(189179), // Rule ID 541 //
     /*  189143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  189146 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189153 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189160 */     // MIs[0] rs1
     /*  189160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189172 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  189177 */     GIR_RootConstrainSelectedInstOperands,
     /*  189178 */     // GIR_Coverage, 541,
     /*  189178 */     GIR_Done,
     /*  189179 */   // Label 3630: @189179
     /*  189179 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(189220), // Rule ID 542 //
     /*  189184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  189187 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189201 */     // MIs[0] rs1
     /*  189201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189213 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  189218 */     GIR_RootConstrainSelectedInstOperands,
     /*  189219 */     // GIR_Coverage, 542,
     /*  189219 */     GIR_Done,
     /*  189220 */   // Label 3631: @189220
     /*  189220 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(189261), // Rule ID 711 //
     /*  189225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189228 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189235 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189242 */     // MIs[0] rs1
     /*  189242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189254 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  189259 */     GIR_RootConstrainSelectedInstOperands,
     /*  189260 */     // GIR_Coverage, 711,
     /*  189260 */     GIR_Done,
     /*  189261 */   // Label 3632: @189261
     /*  189261 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(189302), // Rule ID 713 //
     /*  189266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189269 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189276 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189283 */     // MIs[0] rs1
     /*  189283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189295 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  189300 */     GIR_RootConstrainSelectedInstOperands,
     /*  189301 */     // GIR_Coverage, 713,
     /*  189301 */     GIR_Done,
     /*  189302 */   // Label 3633: @189302
     /*  189302 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(189343), // Rule ID 715 //
     /*  189307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189310 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189317 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189324 */     // MIs[0] rs1
     /*  189324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189336 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  189341 */     GIR_RootConstrainSelectedInstOperands,
     /*  189342 */     // GIR_Coverage, 715,
     /*  189342 */     GIR_Done,
     /*  189343 */   // Label 3634: @189343
     /*  189343 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(189384), // Rule ID 717 //
     /*  189348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189351 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189358 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189365 */     // MIs[0] rs1
     /*  189365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189377 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  189382 */     GIR_RootConstrainSelectedInstOperands,
     /*  189383 */     // GIR_Coverage, 717,
     /*  189383 */     GIR_Done,
     /*  189384 */   // Label 3635: @189384
     /*  189384 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(189425), // Rule ID 719 //
     /*  189389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189406 */     // MIs[0] rs1
     /*  189406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189418 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  189423 */     GIR_RootConstrainSelectedInstOperands,
     /*  189424 */     // GIR_Coverage, 719,
     /*  189424 */     GIR_Done,
     /*  189425 */   // Label 3636: @189425
     /*  189425 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(189466), // Rule ID 721 //
     /*  189430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189433 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189440 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189447 */     // MIs[0] rs1
     /*  189447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189459 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  189464 */     GIR_RootConstrainSelectedInstOperands,
     /*  189465 */     // GIR_Coverage, 721,
     /*  189465 */     GIR_Done,
     /*  189466 */   // Label 3637: @189466
     /*  189466 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(189507), // Rule ID 723 //
     /*  189471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189474 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189481 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189488 */     // MIs[0] rs1
     /*  189488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189500 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  189505 */     GIR_RootConstrainSelectedInstOperands,
     /*  189506 */     // GIR_Coverage, 723,
     /*  189506 */     GIR_Done,
     /*  189507 */   // Label 3638: @189507
     /*  189507 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(189548), // Rule ID 725 //
     /*  189512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189515 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189522 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189529 */     // MIs[0] rs1
     /*  189529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189541 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  189546 */     GIR_RootConstrainSelectedInstOperands,
     /*  189547 */     // GIR_Coverage, 725,
     /*  189547 */     GIR_Done,
     /*  189548 */   // Label 3639: @189548
     /*  189548 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(189589), // Rule ID 727 //
     /*  189553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189570 */     // MIs[0] rs1
     /*  189570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189582 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  189587 */     GIR_RootConstrainSelectedInstOperands,
     /*  189588 */     // GIR_Coverage, 727,
     /*  189588 */     GIR_Done,
     /*  189589 */   // Label 3640: @189589
     /*  189589 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(189630), // Rule ID 729 //
     /*  189594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189611 */     // MIs[0] rs1
     /*  189611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189623 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  189628 */     GIR_RootConstrainSelectedInstOperands,
     /*  189629 */     // GIR_Coverage, 729,
     /*  189629 */     GIR_Done,
     /*  189630 */   // Label 3641: @189630
     /*  189630 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(189671), // Rule ID 891 //
     /*  189635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189652 */     // MIs[0] rs1
     /*  189652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189664 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  189669 */     GIR_RootConstrainSelectedInstOperands,
     /*  189670 */     // GIR_Coverage, 891,
     /*  189670 */     GIR_Done,
     /*  189671 */   // Label 3642: @189671
     /*  189671 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(189712), // Rule ID 893 //
     /*  189676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189693 */     // MIs[0] rs1
     /*  189693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189705 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  189710 */     GIR_RootConstrainSelectedInstOperands,
     /*  189711 */     // GIR_Coverage, 893,
     /*  189711 */     GIR_Done,
     /*  189712 */   // Label 3643: @189712
     /*  189712 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(189753), // Rule ID 895 //
     /*  189717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189734 */     // MIs[0] rs1
     /*  189734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189746 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  189751 */     GIR_RootConstrainSelectedInstOperands,
     /*  189752 */     // GIR_Coverage, 895,
     /*  189752 */     GIR_Done,
     /*  189753 */   // Label 3644: @189753
     /*  189753 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(189794), // Rule ID 897 //
     /*  189758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189768 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189775 */     // MIs[0] rs1
     /*  189775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189787 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  189792 */     GIR_RootConstrainSelectedInstOperands,
     /*  189793 */     // GIR_Coverage, 897,
     /*  189793 */     GIR_Done,
     /*  189794 */   // Label 3645: @189794
     /*  189794 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(189835), // Rule ID 899 //
     /*  189799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189802 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189816 */     // MIs[0] rs1
     /*  189816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189828 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  189833 */     GIR_RootConstrainSelectedInstOperands,
     /*  189834 */     // GIR_Coverage, 899,
     /*  189834 */     GIR_Done,
     /*  189835 */   // Label 3646: @189835
     /*  189835 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(189876), // Rule ID 901 //
     /*  189840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189857 */     // MIs[0] rs1
     /*  189857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189869 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  189874 */     GIR_RootConstrainSelectedInstOperands,
     /*  189875 */     // GIR_Coverage, 901,
     /*  189875 */     GIR_Done,
     /*  189876 */   // Label 3647: @189876
     /*  189876 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(189917), // Rule ID 903 //
     /*  189881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189898 */     // MIs[0] rs1
     /*  189898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189910 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  189915 */     GIR_RootConstrainSelectedInstOperands,
     /*  189916 */     // GIR_Coverage, 903,
     /*  189916 */     GIR_Done,
     /*  189917 */   // Label 3648: @189917
     /*  189917 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(189958), // Rule ID 905 //
     /*  189922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189939 */     // MIs[0] rs1
     /*  189939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189951 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  189956 */     GIR_RootConstrainSelectedInstOperands,
     /*  189957 */     // GIR_Coverage, 905,
     /*  189957 */     GIR_Done,
     /*  189958 */   // Label 3649: @189958
     /*  189958 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(189999), // Rule ID 907 //
     /*  189963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189980 */     // MIs[0] rs1
     /*  189980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189992 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  189997 */     GIR_RootConstrainSelectedInstOperands,
     /*  189998 */     // GIR_Coverage, 907,
     /*  189998 */     GIR_Done,
     /*  189999 */   // Label 3650: @189999
     /*  189999 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(190040), // Rule ID 909 //
     /*  190004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  190007 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190014 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190021 */     // MIs[0] rs1
     /*  190021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  190025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190033 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  190033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  190038 */     GIR_RootConstrainSelectedInstOperands,
     /*  190039 */     // GIR_Coverage, 909,
     /*  190039 */     GIR_Done,
     /*  190040 */   // Label 3651: @190040
     /*  190040 */   GIM_Reject,
     /*  190041 */ // Label 3611: @190041
     /*  190041 */ GIM_Reject,
     /*  190042 */ // Label 3579: @190042
     /*  190042 */ GIM_Reject,
     /*  190043 */ // Label 28: @190043
     /*  190043 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3654*/ GIMT_Encode4(192952),
     /*  190054 */ /*GILLT_s32*//*Label 3652*/ GIMT_Encode4(190062),
     /*  190058 */ /*GILLT_s64*//*Label 3653*/ GIMT_Encode4(191302),
     /*  190062 */ // Label 3652: @190062
     /*  190062 */ GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(191301),
     /*  190067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  190070 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(190111), // Rule ID 384 //
     /*  190075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190078 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190085 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190092 */     // MIs[0] rs1
     /*  190092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190104 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  190109 */     GIR_RootConstrainSelectedInstOperands,
     /*  190110 */     // GIR_Coverage, 384,
     /*  190110 */     GIR_Done,
     /*  190111 */   // Label 3656: @190111
     /*  190111 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(190152), // Rule ID 386 //
     /*  190116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190119 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190133 */     // MIs[0] rs1
     /*  190133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190145 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  190150 */     GIR_RootConstrainSelectedInstOperands,
     /*  190151 */     // GIR_Coverage, 386,
     /*  190151 */     GIR_Done,
     /*  190152 */   // Label 3657: @190152
     /*  190152 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(190193), // Rule ID 388 //
     /*  190157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190160 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190167 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190174 */     // MIs[0] rs1
     /*  190174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190186 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  190191 */     GIR_RootConstrainSelectedInstOperands,
     /*  190192 */     // GIR_Coverage, 388,
     /*  190192 */     GIR_Done,
     /*  190193 */   // Label 3658: @190193
     /*  190193 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(190234), // Rule ID 390 //
     /*  190198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190201 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190208 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190215 */     // MIs[0] rs1
     /*  190215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190227 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  190232 */     GIR_RootConstrainSelectedInstOperands,
     /*  190233 */     // GIR_Coverage, 390,
     /*  190233 */     GIR_Done,
     /*  190234 */   // Label 3659: @190234
     /*  190234 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(190275), // Rule ID 392 //
     /*  190239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190242 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190249 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190256 */     // MIs[0] rs1
     /*  190256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190268 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  190273 */     GIR_RootConstrainSelectedInstOperands,
     /*  190274 */     // GIR_Coverage, 392,
     /*  190274 */     GIR_Done,
     /*  190275 */   // Label 3660: @190275
     /*  190275 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(190316), // Rule ID 394 //
     /*  190280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190283 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190290 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190297 */     // MIs[0] rs1
     /*  190297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190309 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190309 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  190314 */     GIR_RootConstrainSelectedInstOperands,
     /*  190315 */     // GIR_Coverage, 394,
     /*  190315 */     GIR_Done,
     /*  190316 */   // Label 3661: @190316
     /*  190316 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(190357), // Rule ID 396 //
     /*  190321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190324 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190331 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190338 */     // MIs[0] rs1
     /*  190338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190350 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  190355 */     GIR_RootConstrainSelectedInstOperands,
     /*  190356 */     // GIR_Coverage, 396,
     /*  190356 */     GIR_Done,
     /*  190357 */   // Label 3662: @190357
     /*  190357 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(190398), // Rule ID 398 //
     /*  190362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190365 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190372 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190379 */     // MIs[0] rs1
     /*  190379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190391 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  190396 */     GIR_RootConstrainSelectedInstOperands,
     /*  190397 */     // GIR_Coverage, 398,
     /*  190397 */     GIR_Done,
     /*  190398 */   // Label 3663: @190398
     /*  190398 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(190439), // Rule ID 400 //
     /*  190403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190406 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190413 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190420 */     // MIs[0] rs1
     /*  190420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190432 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  190437 */     GIR_RootConstrainSelectedInstOperands,
     /*  190438 */     // GIR_Coverage, 400,
     /*  190438 */     GIR_Done,
     /*  190439 */   // Label 3664: @190439
     /*  190439 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(190480), // Rule ID 402 //
     /*  190444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190447 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190461 */     // MIs[0] rs1
     /*  190461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190473 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  190478 */     GIR_RootConstrainSelectedInstOperands,
     /*  190479 */     // GIR_Coverage, 402,
     /*  190479 */     GIR_Done,
     /*  190480 */   // Label 3665: @190480
     /*  190480 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(190521), // Rule ID 732 //
     /*  190485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190488 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190495 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190502 */     // MIs[0] rs1
     /*  190502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190514 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  190519 */     GIR_RootConstrainSelectedInstOperands,
     /*  190520 */     // GIR_Coverage, 732,
     /*  190520 */     GIR_Done,
     /*  190521 */   // Label 3666: @190521
     /*  190521 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(190562), // Rule ID 734 //
     /*  190526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190529 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190536 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190543 */     // MIs[0] rs1
     /*  190543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190555 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  190560 */     GIR_RootConstrainSelectedInstOperands,
     /*  190561 */     // GIR_Coverage, 734,
     /*  190561 */     GIR_Done,
     /*  190562 */   // Label 3667: @190562
     /*  190562 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(190603), // Rule ID 736 //
     /*  190567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190570 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190577 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190584 */     // MIs[0] rs1
     /*  190584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190596 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  190601 */     GIR_RootConstrainSelectedInstOperands,
     /*  190602 */     // GIR_Coverage, 736,
     /*  190602 */     GIR_Done,
     /*  190603 */   // Label 3668: @190603
     /*  190603 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(190644), // Rule ID 738 //
     /*  190608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190611 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190618 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190625 */     // MIs[0] rs1
     /*  190625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190637 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  190642 */     GIR_RootConstrainSelectedInstOperands,
     /*  190643 */     // GIR_Coverage, 738,
     /*  190643 */     GIR_Done,
     /*  190644 */   // Label 3669: @190644
     /*  190644 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(190685), // Rule ID 740 //
     /*  190649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190652 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190659 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190666 */     // MIs[0] rs1
     /*  190666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190678 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  190683 */     GIR_RootConstrainSelectedInstOperands,
     /*  190684 */     // GIR_Coverage, 740,
     /*  190684 */     GIR_Done,
     /*  190685 */   // Label 3670: @190685
     /*  190685 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(190726), // Rule ID 742 //
     /*  190690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190693 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190700 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190707 */     // MIs[0] rs1
     /*  190707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190719 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  190724 */     GIR_RootConstrainSelectedInstOperands,
     /*  190725 */     // GIR_Coverage, 742,
     /*  190725 */     GIR_Done,
     /*  190726 */   // Label 3671: @190726
     /*  190726 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(190767), // Rule ID 744 //
     /*  190731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190734 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190741 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190748 */     // MIs[0] rs1
     /*  190748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190760 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190760 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  190765 */     GIR_RootConstrainSelectedInstOperands,
     /*  190766 */     // GIR_Coverage, 744,
     /*  190766 */     GIR_Done,
     /*  190767 */   // Label 3672: @190767
     /*  190767 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(190808), // Rule ID 746 //
     /*  190772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190775 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190782 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190789 */     // MIs[0] rs1
     /*  190789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190801 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  190806 */     GIR_RootConstrainSelectedInstOperands,
     /*  190807 */     // GIR_Coverage, 746,
     /*  190807 */     GIR_Done,
     /*  190808 */   // Label 3673: @190808
     /*  190808 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(190849), // Rule ID 748 //
     /*  190813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190816 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190823 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190830 */     // MIs[0] rs1
     /*  190830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190842 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  190847 */     GIR_RootConstrainSelectedInstOperands,
     /*  190848 */     // GIR_Coverage, 748,
     /*  190848 */     GIR_Done,
     /*  190849 */   // Label 3674: @190849
     /*  190849 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(190890), // Rule ID 750 //
     /*  190854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190857 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190864 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190871 */     // MIs[0] rs1
     /*  190871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190883 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  190888 */     GIR_RootConstrainSelectedInstOperands,
     /*  190889 */     // GIR_Coverage, 750,
     /*  190889 */     GIR_Done,
     /*  190890 */   // Label 3675: @190890
     /*  190890 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(190931), // Rule ID 912 //
     /*  190895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190898 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190905 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190912 */     // MIs[0] rs1
     /*  190912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190924 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  190929 */     GIR_RootConstrainSelectedInstOperands,
     /*  190930 */     // GIR_Coverage, 912,
     /*  190930 */     GIR_Done,
     /*  190931 */   // Label 3676: @190931
     /*  190931 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(190972), // Rule ID 914 //
     /*  190936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190939 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190946 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190953 */     // MIs[0] rs1
     /*  190953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190965 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  190970 */     GIR_RootConstrainSelectedInstOperands,
     /*  190971 */     // GIR_Coverage, 914,
     /*  190971 */     GIR_Done,
     /*  190972 */   // Label 3677: @190972
     /*  190972 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(191013), // Rule ID 916 //
     /*  190977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190994 */     // MIs[0] rs1
     /*  190994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191006 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  191011 */     GIR_RootConstrainSelectedInstOperands,
     /*  191012 */     // GIR_Coverage, 916,
     /*  191012 */     GIR_Done,
     /*  191013 */   // Label 3678: @191013
     /*  191013 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(191054), // Rule ID 918 //
     /*  191018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191021 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191028 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191035 */     // MIs[0] rs1
     /*  191035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191047 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  191052 */     GIR_RootConstrainSelectedInstOperands,
     /*  191053 */     // GIR_Coverage, 918,
     /*  191053 */     GIR_Done,
     /*  191054 */   // Label 3679: @191054
     /*  191054 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(191095), // Rule ID 920 //
     /*  191059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191062 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191069 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191076 */     // MIs[0] rs1
     /*  191076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191088 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  191093 */     GIR_RootConstrainSelectedInstOperands,
     /*  191094 */     // GIR_Coverage, 920,
     /*  191094 */     GIR_Done,
     /*  191095 */   // Label 3680: @191095
     /*  191095 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(191136), // Rule ID 922 //
     /*  191100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191103 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191110 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191117 */     // MIs[0] rs1
     /*  191117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191129 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  191134 */     GIR_RootConstrainSelectedInstOperands,
     /*  191135 */     // GIR_Coverage, 922,
     /*  191135 */     GIR_Done,
     /*  191136 */   // Label 3681: @191136
     /*  191136 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(191177), // Rule ID 924 //
     /*  191141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191144 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191151 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191158 */     // MIs[0] rs1
     /*  191158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191170 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191170 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  191175 */     GIR_RootConstrainSelectedInstOperands,
     /*  191176 */     // GIR_Coverage, 924,
     /*  191176 */     GIR_Done,
     /*  191177 */   // Label 3682: @191177
     /*  191177 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(191218), // Rule ID 926 //
     /*  191182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191185 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191192 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191199 */     // MIs[0] rs1
     /*  191199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191211 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  191216 */     GIR_RootConstrainSelectedInstOperands,
     /*  191217 */     // GIR_Coverage, 926,
     /*  191217 */     GIR_Done,
     /*  191218 */   // Label 3683: @191218
     /*  191218 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(191259), // Rule ID 928 //
     /*  191223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191226 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191233 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191240 */     // MIs[0] rs1
     /*  191240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191252 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  191257 */     GIR_RootConstrainSelectedInstOperands,
     /*  191258 */     // GIR_Coverage, 928,
     /*  191258 */     GIR_Done,
     /*  191259 */   // Label 3684: @191259
     /*  191259 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(191300), // Rule ID 930 //
     /*  191264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191267 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191274 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191281 */     // MIs[0] rs1
     /*  191281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191293 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  191298 */     GIR_RootConstrainSelectedInstOperands,
     /*  191299 */     // GIR_Coverage, 930,
     /*  191299 */     GIR_Done,
     /*  191300 */   // Label 3685: @191300
     /*  191300 */   GIM_Reject,
     /*  191301 */ // Label 3655: @191301
     /*  191301 */ GIM_Reject,
     /*  191302 */ // Label 3653: @191302
     /*  191302 */ GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(192951),
     /*  191307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  191310 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(191351), // Rule ID 383 //
     /*  191315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191318 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191325 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191332 */     // MIs[0] rs1
     /*  191332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191344 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  191349 */     GIR_RootConstrainSelectedInstOperands,
     /*  191350 */     // GIR_Coverage, 383,
     /*  191350 */     GIR_Done,
     /*  191351 */   // Label 3687: @191351
     /*  191351 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(191392), // Rule ID 385 //
     /*  191356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191359 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191366 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191373 */     // MIs[0] rs1
     /*  191373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191385 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  191390 */     GIR_RootConstrainSelectedInstOperands,
     /*  191391 */     // GIR_Coverage, 385,
     /*  191391 */     GIR_Done,
     /*  191392 */   // Label 3688: @191392
     /*  191392 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(191433), // Rule ID 387 //
     /*  191397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191400 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191414 */     // MIs[0] rs1
     /*  191414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191426 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  191431 */     GIR_RootConstrainSelectedInstOperands,
     /*  191432 */     // GIR_Coverage, 387,
     /*  191432 */     GIR_Done,
     /*  191433 */   // Label 3689: @191433
     /*  191433 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(191474), // Rule ID 389 //
     /*  191438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191455 */     // MIs[0] rs1
     /*  191455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191467 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  191472 */     GIR_RootConstrainSelectedInstOperands,
     /*  191473 */     // GIR_Coverage, 389,
     /*  191473 */     GIR_Done,
     /*  191474 */   // Label 3690: @191474
     /*  191474 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(191515), // Rule ID 391 //
     /*  191479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191482 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191496 */     // MIs[0] rs1
     /*  191496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191508 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  191513 */     GIR_RootConstrainSelectedInstOperands,
     /*  191514 */     // GIR_Coverage, 391,
     /*  191514 */     GIR_Done,
     /*  191515 */   // Label 3691: @191515
     /*  191515 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(191556), // Rule ID 393 //
     /*  191520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191530 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191537 */     // MIs[0] rs1
     /*  191537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191549 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  191554 */     GIR_RootConstrainSelectedInstOperands,
     /*  191555 */     // GIR_Coverage, 393,
     /*  191555 */     GIR_Done,
     /*  191556 */   // Label 3692: @191556
     /*  191556 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(191597), // Rule ID 395 //
     /*  191561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191564 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191571 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191578 */     // MIs[0] rs1
     /*  191578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191590 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  191595 */     GIR_RootConstrainSelectedInstOperands,
     /*  191596 */     // GIR_Coverage, 395,
     /*  191596 */     GIR_Done,
     /*  191597 */   // Label 3693: @191597
     /*  191597 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(191638), // Rule ID 397 //
     /*  191602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191612 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191619 */     // MIs[0] rs1
     /*  191619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191631 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  191636 */     GIR_RootConstrainSelectedInstOperands,
     /*  191637 */     // GIR_Coverage, 397,
     /*  191637 */     GIR_Done,
     /*  191638 */   // Label 3694: @191638
     /*  191638 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(191679), // Rule ID 399 //
     /*  191643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191660 */     // MIs[0] rs1
     /*  191660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191672 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  191677 */     GIR_RootConstrainSelectedInstOperands,
     /*  191678 */     // GIR_Coverage, 399,
     /*  191678 */     GIR_Done,
     /*  191679 */   // Label 3695: @191679
     /*  191679 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(191720), // Rule ID 401 //
     /*  191684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191701 */     // MIs[0] rs1
     /*  191701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191713 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  191718 */     GIR_RootConstrainSelectedInstOperands,
     /*  191719 */     // GIR_Coverage, 401,
     /*  191719 */     GIR_Done,
     /*  191720 */   // Label 3696: @191720
     /*  191720 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(191761), // Rule ID 543 //
     /*  191725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191742 */     // MIs[0] rs1
     /*  191742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191754 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  191759 */     GIR_RootConstrainSelectedInstOperands,
     /*  191760 */     // GIR_Coverage, 543,
     /*  191760 */     GIR_Done,
     /*  191761 */   // Label 3697: @191761
     /*  191761 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(191802), // Rule ID 544 //
     /*  191766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191769 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191783 */     // MIs[0] rs1
     /*  191783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191795 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ),
     /*  191800 */     GIR_RootConstrainSelectedInstOperands,
     /*  191801 */     // GIR_Coverage, 544,
     /*  191801 */     GIR_Done,
     /*  191802 */   // Label 3698: @191802
     /*  191802 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(191843), // Rule ID 545 //
     /*  191807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191824 */     // MIs[0] rs1
     /*  191824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191836 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_RL),
     /*  191841 */     GIR_RootConstrainSelectedInstOperands,
     /*  191842 */     // GIR_Coverage, 545,
     /*  191842 */     GIR_Done,
     /*  191843 */   // Label 3699: @191843
     /*  191843 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(191884), // Rule ID 546 //
     /*  191848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191851 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191858 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191865 */     // MIs[0] rs1
     /*  191865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191877 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  191882 */     GIR_RootConstrainSelectedInstOperands,
     /*  191883 */     // GIR_Coverage, 546,
     /*  191883 */     GIR_Done,
     /*  191884 */   // Label 3700: @191884
     /*  191884 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(191925), // Rule ID 547 //
     /*  191889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191892 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191906 */     // MIs[0] rs1
     /*  191906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191918 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  191923 */     GIR_RootConstrainSelectedInstOperands,
     /*  191924 */     // GIR_Coverage, 547,
     /*  191924 */     GIR_Done,
     /*  191925 */   // Label 3701: @191925
     /*  191925 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(191966), // Rule ID 548 //
     /*  191930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191940 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191947 */     // MIs[0] rs1
     /*  191947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191959 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  191964 */     GIR_RootConstrainSelectedInstOperands,
     /*  191965 */     // GIR_Coverage, 548,
     /*  191965 */     GIR_Done,
     /*  191966 */   // Label 3702: @191966
     /*  191966 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(192007), // Rule ID 549 //
     /*  191971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191974 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191981 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191988 */     // MIs[0] rs1
     /*  191988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192000 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  192005 */     GIR_RootConstrainSelectedInstOperands,
     /*  192006 */     // GIR_Coverage, 549,
     /*  192006 */     GIR_Done,
     /*  192007 */   // Label 3703: @192007
     /*  192007 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(192048), // Rule ID 550 //
     /*  192012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192015 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192022 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192029 */     // MIs[0] rs1
     /*  192029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192041 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  192046 */     GIR_RootConstrainSelectedInstOperands,
     /*  192047 */     // GIR_Coverage, 550,
     /*  192047 */     GIR_Done,
     /*  192048 */   // Label 3704: @192048
     /*  192048 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(192089), // Rule ID 551 //
     /*  192053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192070 */     // MIs[0] rs1
     /*  192070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192082 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  192087 */     GIR_RootConstrainSelectedInstOperands,
     /*  192088 */     // GIR_Coverage, 551,
     /*  192088 */     GIR_Done,
     /*  192089 */   // Label 3705: @192089
     /*  192089 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(192130), // Rule ID 552 //
     /*  192094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192111 */     // MIs[0] rs1
     /*  192111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192123 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  192128 */     GIR_RootConstrainSelectedInstOperands,
     /*  192129 */     // GIR_Coverage, 552,
     /*  192129 */     GIR_Done,
     /*  192130 */   // Label 3706: @192130
     /*  192130 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(192171), // Rule ID 731 //
     /*  192135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192152 */     // MIs[0] rs1
     /*  192152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192164 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  192169 */     GIR_RootConstrainSelectedInstOperands,
     /*  192170 */     // GIR_Coverage, 731,
     /*  192170 */     GIR_Done,
     /*  192171 */   // Label 3707: @192171
     /*  192171 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(192212), // Rule ID 733 //
     /*  192176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192179 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192186 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192193 */     // MIs[0] rs1
     /*  192193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192205 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  192210 */     GIR_RootConstrainSelectedInstOperands,
     /*  192211 */     // GIR_Coverage, 733,
     /*  192211 */     GIR_Done,
     /*  192212 */   // Label 3708: @192212
     /*  192212 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(192253), // Rule ID 735 //
     /*  192217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192220 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192227 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192234 */     // MIs[0] rs1
     /*  192234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192246 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  192251 */     GIR_RootConstrainSelectedInstOperands,
     /*  192252 */     // GIR_Coverage, 735,
     /*  192252 */     GIR_Done,
     /*  192253 */   // Label 3709: @192253
     /*  192253 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(192294), // Rule ID 737 //
     /*  192258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192261 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192268 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192275 */     // MIs[0] rs1
     /*  192275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192287 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  192292 */     GIR_RootConstrainSelectedInstOperands,
     /*  192293 */     // GIR_Coverage, 737,
     /*  192293 */     GIR_Done,
     /*  192294 */   // Label 3710: @192294
     /*  192294 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(192335), // Rule ID 739 //
     /*  192299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192302 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192309 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192316 */     // MIs[0] rs1
     /*  192316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192328 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  192333 */     GIR_RootConstrainSelectedInstOperands,
     /*  192334 */     // GIR_Coverage, 739,
     /*  192334 */     GIR_Done,
     /*  192335 */   // Label 3711: @192335
     /*  192335 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(192376), // Rule ID 741 //
     /*  192340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192343 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192350 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192357 */     // MIs[0] rs1
     /*  192357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192369 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  192374 */     GIR_RootConstrainSelectedInstOperands,
     /*  192375 */     // GIR_Coverage, 741,
     /*  192375 */     GIR_Done,
     /*  192376 */   // Label 3712: @192376
     /*  192376 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(192417), // Rule ID 743 //
     /*  192381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192398 */     // MIs[0] rs1
     /*  192398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192410 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  192415 */     GIR_RootConstrainSelectedInstOperands,
     /*  192416 */     // GIR_Coverage, 743,
     /*  192416 */     GIR_Done,
     /*  192417 */   // Label 3713: @192417
     /*  192417 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(192458), // Rule ID 745 //
     /*  192422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192425 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192439 */     // MIs[0] rs1
     /*  192439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192451 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  192456 */     GIR_RootConstrainSelectedInstOperands,
     /*  192457 */     // GIR_Coverage, 745,
     /*  192457 */     GIR_Done,
     /*  192458 */   // Label 3714: @192458
     /*  192458 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(192499), // Rule ID 747 //
     /*  192463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192480 */     // MIs[0] rs1
     /*  192480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192492 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  192497 */     GIR_RootConstrainSelectedInstOperands,
     /*  192498 */     // GIR_Coverage, 747,
     /*  192498 */     GIR_Done,
     /*  192499 */   // Label 3715: @192499
     /*  192499 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(192540), // Rule ID 749 //
     /*  192504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192521 */     // MIs[0] rs1
     /*  192521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192533 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  192538 */     GIR_RootConstrainSelectedInstOperands,
     /*  192539 */     // GIR_Coverage, 749,
     /*  192539 */     GIR_Done,
     /*  192540 */   // Label 3716: @192540
     /*  192540 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(192581), // Rule ID 911 //
     /*  192545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192562 */     // MIs[0] rs1
     /*  192562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192574 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  192579 */     GIR_RootConstrainSelectedInstOperands,
     /*  192580 */     // GIR_Coverage, 911,
     /*  192580 */     GIR_Done,
     /*  192581 */   // Label 3717: @192581
     /*  192581 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(192622), // Rule ID 913 //
     /*  192586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192603 */     // MIs[0] rs1
     /*  192603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192615 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  192620 */     GIR_RootConstrainSelectedInstOperands,
     /*  192621 */     // GIR_Coverage, 913,
     /*  192621 */     GIR_Done,
     /*  192622 */   // Label 3718: @192622
     /*  192622 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(192663), // Rule ID 915 //
     /*  192627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192644 */     // MIs[0] rs1
     /*  192644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192656 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  192661 */     GIR_RootConstrainSelectedInstOperands,
     /*  192662 */     // GIR_Coverage, 915,
     /*  192662 */     GIR_Done,
     /*  192663 */   // Label 3719: @192663
     /*  192663 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(192704), // Rule ID 917 //
     /*  192668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192685 */     // MIs[0] rs1
     /*  192685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192697 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  192702 */     GIR_RootConstrainSelectedInstOperands,
     /*  192703 */     // GIR_Coverage, 917,
     /*  192703 */     GIR_Done,
     /*  192704 */   // Label 3720: @192704
     /*  192704 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(192745), // Rule ID 919 //
     /*  192709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192726 */     // MIs[0] rs1
     /*  192726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192738 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  192743 */     GIR_RootConstrainSelectedInstOperands,
     /*  192744 */     // GIR_Coverage, 919,
     /*  192744 */     GIR_Done,
     /*  192745 */   // Label 3721: @192745
     /*  192745 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(192786), // Rule ID 921 //
     /*  192750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192767 */     // MIs[0] rs1
     /*  192767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192779 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  192784 */     GIR_RootConstrainSelectedInstOperands,
     /*  192785 */     // GIR_Coverage, 921,
     /*  192785 */     GIR_Done,
     /*  192786 */   // Label 3722: @192786
     /*  192786 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(192827), // Rule ID 923 //
     /*  192791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192794 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192808 */     // MIs[0] rs1
     /*  192808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192820 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  192825 */     GIR_RootConstrainSelectedInstOperands,
     /*  192826 */     // GIR_Coverage, 923,
     /*  192826 */     GIR_Done,
     /*  192827 */   // Label 3723: @192827
     /*  192827 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(192868), // Rule ID 925 //
     /*  192832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192849 */     // MIs[0] rs1
     /*  192849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192861 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  192866 */     GIR_RootConstrainSelectedInstOperands,
     /*  192867 */     // GIR_Coverage, 925,
     /*  192867 */     GIR_Done,
     /*  192868 */   // Label 3724: @192868
     /*  192868 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(192909), // Rule ID 927 //
     /*  192873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192890 */     // MIs[0] rs1
     /*  192890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192902 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  192907 */     GIR_RootConstrainSelectedInstOperands,
     /*  192908 */     // GIR_Coverage, 927,
     /*  192908 */     GIR_Done,
     /*  192909 */   // Label 3725: @192909
     /*  192909 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(192950), // Rule ID 929 //
     /*  192914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192924 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192931 */     // MIs[0] rs1
     /*  192931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192943 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  192948 */     GIR_RootConstrainSelectedInstOperands,
     /*  192949 */     // GIR_Coverage, 929,
     /*  192949 */     GIR_Done,
     /*  192950 */   // Label 3726: @192950
     /*  192950 */   GIM_Reject,
     /*  192951 */ // Label 3686: @192951
     /*  192951 */ GIM_Reject,
     /*  192952 */ // Label 3654: @192952
     /*  192952 */ GIM_Reject,
     /*  192953 */ // Label 29: @192953
     /*  192953 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3729*/ GIMT_Encode4(193864),
     /*  192964 */ /*GILLT_s32*//*Label 3727*/ GIMT_Encode4(192972),
     /*  192968 */ /*GILLT_s64*//*Label 3728*/ GIMT_Encode4(193254),
     /*  192972 */ // Label 3727: @192972
     /*  192972 */ GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(193253),
     /*  192977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  192980 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192987 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(193040), // Rule ID 614 //
     /*  192992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  192995 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193002 */     // MIs[0] addr
     /*  193002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193014 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 2:{ *:[i32] })
     /*  193014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193022 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193027 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193029 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  193034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193038 */     GIR_RootConstrainSelectedInstOperands,
     /*  193039 */     // GIR_Coverage, 614,
     /*  193039 */     GIR_EraseRootFromParent_Done,
     /*  193040 */   // Label 3731: @193040
     /*  193040 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(193093), // Rule ID 616 //
     /*  193045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  193048 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193055 */     // MIs[0] addr
     /*  193055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193067 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 4:{ *:[i32] })
     /*  193067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193075 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193080 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193082 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  193087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193091 */     GIR_RootConstrainSelectedInstOperands,
     /*  193092 */     // GIR_Coverage, 616,
     /*  193092 */     GIR_EraseRootFromParent_Done,
     /*  193093 */   // Label 3732: @193093
     /*  193093 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(193146), // Rule ID 618 //
     /*  193098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  193101 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193108 */     // MIs[0] addr
     /*  193108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193120 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 5:{ *:[i32] })
     /*  193120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193128 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193133 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193135 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  193140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193144 */     GIR_RootConstrainSelectedInstOperands,
     /*  193145 */     // GIR_Coverage, 618,
     /*  193145 */     GIR_EraseRootFromParent_Done,
     /*  193146 */   // Label 3733: @193146
     /*  193146 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(193199), // Rule ID 620 //
     /*  193151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  193154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193161 */     // MIs[0] addr
     /*  193161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193173 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 6:{ *:[i32] })
     /*  193173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193181 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193186 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193188 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  193193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193197 */     GIR_RootConstrainSelectedInstOperands,
     /*  193198 */     // GIR_Coverage, 620,
     /*  193198 */     GIR_EraseRootFromParent_Done,
     /*  193199 */   // Label 3734: @193199
     /*  193199 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(193252), // Rule ID 622 //
     /*  193204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  193207 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193214 */     // MIs[0] addr
     /*  193214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193226 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 7:{ *:[i32] })
     /*  193226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193234 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193239 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193241 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  193246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193250 */     GIR_RootConstrainSelectedInstOperands,
     /*  193251 */     // GIR_Coverage, 622,
     /*  193251 */     GIR_EraseRootFromParent_Done,
     /*  193252 */   // Label 3735: @193252
     /*  193252 */   GIM_Reject,
     /*  193253 */ // Label 3730: @193253
     /*  193253 */ GIM_Reject,
     /*  193254 */ // Label 3728: @193254
     /*  193254 */ GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(193863),
     /*  193259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  193262 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(193322), // Rule ID 613 //
     /*  193267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  193270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193284 */     // MIs[0] addr
     /*  193284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193296 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  193296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193304 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193309 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193311 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  193316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193320 */     GIR_RootConstrainSelectedInstOperands,
     /*  193321 */     // GIR_Coverage, 613,
     /*  193321 */     GIR_EraseRootFromParent_Done,
     /*  193322 */   // Label 3737: @193322
     /*  193322 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(193382), // Rule ID 615 //
     /*  193327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  193330 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193337 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193344 */     // MIs[0] addr
     /*  193344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193356 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  193356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193364 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193369 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193371 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  193376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193380 */     GIR_RootConstrainSelectedInstOperands,
     /*  193381 */     // GIR_Coverage, 615,
     /*  193381 */     GIR_EraseRootFromParent_Done,
     /*  193382 */   // Label 3738: @193382
     /*  193382 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(193442), // Rule ID 617 //
     /*  193387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  193390 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193397 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193404 */     // MIs[0] addr
     /*  193404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193416 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  193416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193424 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193429 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193431 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  193436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193440 */     GIR_RootConstrainSelectedInstOperands,
     /*  193441 */     // GIR_Coverage, 617,
     /*  193441 */     GIR_EraseRootFromParent_Done,
     /*  193442 */   // Label 3739: @193442
     /*  193442 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(193502), // Rule ID 619 //
     /*  193447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  193450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193464 */     // MIs[0] addr
     /*  193464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193476 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  193476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193484 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193489 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193491 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  193496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193500 */     GIR_RootConstrainSelectedInstOperands,
     /*  193501 */     // GIR_Coverage, 619,
     /*  193501 */     GIR_EraseRootFromParent_Done,
     /*  193502 */   // Label 3740: @193502
     /*  193502 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(193562), // Rule ID 621 //
     /*  193507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  193510 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193524 */     // MIs[0] addr
     /*  193524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193536 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  193536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193544 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193549 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193551 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  193556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193560 */     GIR_RootConstrainSelectedInstOperands,
     /*  193561 */     // GIR_Coverage, 621,
     /*  193561 */     GIR_EraseRootFromParent_Done,
     /*  193562 */   // Label 3741: @193562
     /*  193562 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(193622), // Rule ID 631 //
     /*  193567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  193570 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  193577 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193584 */     // MIs[0] addr
     /*  193584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193596 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_monotonic>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  193596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  193602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193604 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193609 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193611 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  193616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193620 */     GIR_RootConstrainSelectedInstOperands,
     /*  193621 */     // GIR_Coverage, 631,
     /*  193621 */     GIR_EraseRootFromParent_Done,
     /*  193622 */   // Label 3742: @193622
     /*  193622 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(193682), // Rule ID 632 //
     /*  193627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  193630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  193637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193644 */     // MIs[0] addr
     /*  193644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193656 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acquire>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  193656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  193662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193664 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193669 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193671 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  193676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193680 */     GIR_RootConstrainSelectedInstOperands,
     /*  193681 */     // GIR_Coverage, 632,
     /*  193681 */     GIR_EraseRootFromParent_Done,
     /*  193682 */   // Label 3743: @193682
     /*  193682 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(193742), // Rule ID 633 //
     /*  193687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  193690 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  193697 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193704 */     // MIs[0] addr
     /*  193704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193716 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_release>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  193716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  193722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193724 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193729 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193731 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  193736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193740 */     GIR_RootConstrainSelectedInstOperands,
     /*  193741 */     // GIR_Coverage, 633,
     /*  193741 */     GIR_EraseRootFromParent_Done,
     /*  193742 */   // Label 3744: @193742
     /*  193742 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(193802), // Rule ID 634 //
     /*  193747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  193750 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  193757 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193764 */     // MIs[0] addr
     /*  193764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193776 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acq_rel>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  193776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  193782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193784 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193789 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193791 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  193796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193800 */     GIR_RootConstrainSelectedInstOperands,
     /*  193801 */     // GIR_Coverage, 634,
     /*  193801 */     GIR_EraseRootFromParent_Done,
     /*  193802 */   // Label 3745: @193802
     /*  193802 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(193862), // Rule ID 635 //
     /*  193807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  193810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  193817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193824 */     // MIs[0] addr
     /*  193824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193836 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_seq_cst>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  193836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  193842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193844 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193849 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193851 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  193856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193860 */     GIR_RootConstrainSelectedInstOperands,
     /*  193861 */     // GIR_Coverage, 635,
     /*  193861 */     GIR_EraseRootFromParent_Done,
     /*  193862 */   // Label 3746: @193862
     /*  193862 */   GIM_Reject,
     /*  193863 */ // Label 3736: @193863
     /*  193863 */ GIM_Reject,
     /*  193864 */ // Label 3729: @193864
     /*  193864 */ GIM_Reject,
     /*  193865 */ // Label 30: @193865
     /*  193865 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3749*/ GIMT_Encode4(196774),
     /*  193876 */ /*GILLT_s32*//*Label 3747*/ GIMT_Encode4(193884),
     /*  193880 */ /*GILLT_s64*//*Label 3748*/ GIMT_Encode4(195124),
     /*  193884 */ // Label 3747: @193884
     /*  193884 */ GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(195123),
     /*  193889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  193892 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(193933), // Rule ID 404 //
     /*  193897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193900 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193907 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193914 */     // MIs[0] rs1
     /*  193914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193926 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  193931 */     GIR_RootConstrainSelectedInstOperands,
     /*  193932 */     // GIR_Coverage, 404,
     /*  193932 */     GIR_Done,
     /*  193933 */   // Label 3751: @193933
     /*  193933 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(193974), // Rule ID 406 //
     /*  193938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193941 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193948 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193955 */     // MIs[0] rs1
     /*  193955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193967 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  193972 */     GIR_RootConstrainSelectedInstOperands,
     /*  193973 */     // GIR_Coverage, 406,
     /*  193973 */     GIR_Done,
     /*  193974 */   // Label 3752: @193974
     /*  193974 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(194015), // Rule ID 408 //
     /*  193979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193982 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193989 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193996 */     // MIs[0] rs1
     /*  193996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194008 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  194013 */     GIR_RootConstrainSelectedInstOperands,
     /*  194014 */     // GIR_Coverage, 408,
     /*  194014 */     GIR_Done,
     /*  194015 */   // Label 3753: @194015
     /*  194015 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(194056), // Rule ID 410 //
     /*  194020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  194023 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194030 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194037 */     // MIs[0] rs1
     /*  194037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194049 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  194054 */     GIR_RootConstrainSelectedInstOperands,
     /*  194055 */     // GIR_Coverage, 410,
     /*  194055 */     GIR_Done,
     /*  194056 */   // Label 3754: @194056
     /*  194056 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(194097), // Rule ID 412 //
     /*  194061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  194064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194078 */     // MIs[0] rs1
     /*  194078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194090 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  194095 */     GIR_RootConstrainSelectedInstOperands,
     /*  194096 */     // GIR_Coverage, 412,
     /*  194096 */     GIR_Done,
     /*  194097 */   // Label 3755: @194097
     /*  194097 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(194138), // Rule ID 414 //
     /*  194102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  194105 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194112 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194119 */     // MIs[0] rs1
     /*  194119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194131 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  194136 */     GIR_RootConstrainSelectedInstOperands,
     /*  194137 */     // GIR_Coverage, 414,
     /*  194137 */     GIR_Done,
     /*  194138 */   // Label 3756: @194138
     /*  194138 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(194179), // Rule ID 416 //
     /*  194143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  194146 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194153 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194160 */     // MIs[0] rs1
     /*  194160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194172 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  194177 */     GIR_RootConstrainSelectedInstOperands,
     /*  194178 */     // GIR_Coverage, 416,
     /*  194178 */     GIR_Done,
     /*  194179 */   // Label 3757: @194179
     /*  194179 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(194220), // Rule ID 418 //
     /*  194184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  194187 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194201 */     // MIs[0] rs1
     /*  194201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194213 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  194218 */     GIR_RootConstrainSelectedInstOperands,
     /*  194219 */     // GIR_Coverage, 418,
     /*  194219 */     GIR_Done,
     /*  194220 */   // Label 3758: @194220
     /*  194220 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(194261), // Rule ID 420 //
     /*  194225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  194228 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194235 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194242 */     // MIs[0] rs1
     /*  194242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194254 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  194259 */     GIR_RootConstrainSelectedInstOperands,
     /*  194260 */     // GIR_Coverage, 420,
     /*  194260 */     GIR_Done,
     /*  194261 */   // Label 3759: @194261
     /*  194261 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(194302), // Rule ID 422 //
     /*  194266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  194269 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194276 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194283 */     // MIs[0] rs1
     /*  194283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194295 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  194300 */     GIR_RootConstrainSelectedInstOperands,
     /*  194301 */     // GIR_Coverage, 422,
     /*  194301 */     GIR_Done,
     /*  194302 */   // Label 3760: @194302
     /*  194302 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(194343), // Rule ID 752 //
     /*  194307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194310 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194317 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194324 */     // MIs[0] rs1
     /*  194324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194336 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  194341 */     GIR_RootConstrainSelectedInstOperands,
     /*  194342 */     // GIR_Coverage, 752,
     /*  194342 */     GIR_Done,
     /*  194343 */   // Label 3761: @194343
     /*  194343 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(194384), // Rule ID 754 //
     /*  194348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194351 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194358 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194365 */     // MIs[0] rs1
     /*  194365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194377 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  194382 */     GIR_RootConstrainSelectedInstOperands,
     /*  194383 */     // GIR_Coverage, 754,
     /*  194383 */     GIR_Done,
     /*  194384 */   // Label 3762: @194384
     /*  194384 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(194425), // Rule ID 756 //
     /*  194389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194406 */     // MIs[0] rs1
     /*  194406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194418 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  194423 */     GIR_RootConstrainSelectedInstOperands,
     /*  194424 */     // GIR_Coverage, 756,
     /*  194424 */     GIR_Done,
     /*  194425 */   // Label 3763: @194425
     /*  194425 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(194466), // Rule ID 758 //
     /*  194430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194433 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194440 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194447 */     // MIs[0] rs1
     /*  194447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194459 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  194464 */     GIR_RootConstrainSelectedInstOperands,
     /*  194465 */     // GIR_Coverage, 758,
     /*  194465 */     GIR_Done,
     /*  194466 */   // Label 3764: @194466
     /*  194466 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(194507), // Rule ID 760 //
     /*  194471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194474 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194481 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194488 */     // MIs[0] rs1
     /*  194488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194500 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  194505 */     GIR_RootConstrainSelectedInstOperands,
     /*  194506 */     // GIR_Coverage, 760,
     /*  194506 */     GIR_Done,
     /*  194507 */   // Label 3765: @194507
     /*  194507 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(194548), // Rule ID 762 //
     /*  194512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194515 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194522 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194529 */     // MIs[0] rs1
     /*  194529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194541 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  194546 */     GIR_RootConstrainSelectedInstOperands,
     /*  194547 */     // GIR_Coverage, 762,
     /*  194547 */     GIR_Done,
     /*  194548 */   // Label 3766: @194548
     /*  194548 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(194589), // Rule ID 764 //
     /*  194553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194570 */     // MIs[0] rs1
     /*  194570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194582 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  194587 */     GIR_RootConstrainSelectedInstOperands,
     /*  194588 */     // GIR_Coverage, 764,
     /*  194588 */     GIR_Done,
     /*  194589 */   // Label 3767: @194589
     /*  194589 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(194630), // Rule ID 766 //
     /*  194594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194611 */     // MIs[0] rs1
     /*  194611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194623 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  194628 */     GIR_RootConstrainSelectedInstOperands,
     /*  194629 */     // GIR_Coverage, 766,
     /*  194629 */     GIR_Done,
     /*  194630 */   // Label 3768: @194630
     /*  194630 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(194671), // Rule ID 768 //
     /*  194635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194652 */     // MIs[0] rs1
     /*  194652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194664 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  194669 */     GIR_RootConstrainSelectedInstOperands,
     /*  194670 */     // GIR_Coverage, 768,
     /*  194670 */     GIR_Done,
     /*  194671 */   // Label 3769: @194671
     /*  194671 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(194712), // Rule ID 770 //
     /*  194676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194693 */     // MIs[0] rs1
     /*  194693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194705 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  194710 */     GIR_RootConstrainSelectedInstOperands,
     /*  194711 */     // GIR_Coverage, 770,
     /*  194711 */     GIR_Done,
     /*  194712 */   // Label 3770: @194712
     /*  194712 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(194753), // Rule ID 932 //
     /*  194717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194734 */     // MIs[0] rs1
     /*  194734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194746 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  194751 */     GIR_RootConstrainSelectedInstOperands,
     /*  194752 */     // GIR_Coverage, 932,
     /*  194752 */     GIR_Done,
     /*  194753 */   // Label 3771: @194753
     /*  194753 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(194794), // Rule ID 934 //
     /*  194758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194768 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194775 */     // MIs[0] rs1
     /*  194775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194787 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  194792 */     GIR_RootConstrainSelectedInstOperands,
     /*  194793 */     // GIR_Coverage, 934,
     /*  194793 */     GIR_Done,
     /*  194794 */   // Label 3772: @194794
     /*  194794 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(194835), // Rule ID 936 //
     /*  194799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194802 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194816 */     // MIs[0] rs1
     /*  194816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194828 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  194833 */     GIR_RootConstrainSelectedInstOperands,
     /*  194834 */     // GIR_Coverage, 936,
     /*  194834 */     GIR_Done,
     /*  194835 */   // Label 3773: @194835
     /*  194835 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(194876), // Rule ID 938 //
     /*  194840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194857 */     // MIs[0] rs1
     /*  194857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194869 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  194874 */     GIR_RootConstrainSelectedInstOperands,
     /*  194875 */     // GIR_Coverage, 938,
     /*  194875 */     GIR_Done,
     /*  194876 */   // Label 3774: @194876
     /*  194876 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(194917), // Rule ID 940 //
     /*  194881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194898 */     // MIs[0] rs1
     /*  194898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194910 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  194915 */     GIR_RootConstrainSelectedInstOperands,
     /*  194916 */     // GIR_Coverage, 940,
     /*  194916 */     GIR_Done,
     /*  194917 */   // Label 3775: @194917
     /*  194917 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(194958), // Rule ID 942 //
     /*  194922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194939 */     // MIs[0] rs1
     /*  194939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194951 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  194956 */     GIR_RootConstrainSelectedInstOperands,
     /*  194957 */     // GIR_Coverage, 942,
     /*  194957 */     GIR_Done,
     /*  194958 */   // Label 3776: @194958
     /*  194958 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(194999), // Rule ID 944 //
     /*  194963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194980 */     // MIs[0] rs1
     /*  194980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194992 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  194997 */     GIR_RootConstrainSelectedInstOperands,
     /*  194998 */     // GIR_Coverage, 944,
     /*  194998 */     GIR_Done,
     /*  194999 */   // Label 3777: @194999
     /*  194999 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(195040), // Rule ID 946 //
     /*  195004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  195007 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195014 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195021 */     // MIs[0] rs1
     /*  195021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195033 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  195038 */     GIR_RootConstrainSelectedInstOperands,
     /*  195039 */     // GIR_Coverage, 946,
     /*  195039 */     GIR_Done,
     /*  195040 */   // Label 3778: @195040
     /*  195040 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(195081), // Rule ID 948 //
     /*  195045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  195048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195062 */     // MIs[0] rs1
     /*  195062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195074 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  195079 */     GIR_RootConstrainSelectedInstOperands,
     /*  195080 */     // GIR_Coverage, 948,
     /*  195080 */     GIR_Done,
     /*  195081 */   // Label 3779: @195081
     /*  195081 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(195122), // Rule ID 950 //
     /*  195086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  195089 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195103 */     // MIs[0] rs1
     /*  195103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195115 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  195120 */     GIR_RootConstrainSelectedInstOperands,
     /*  195121 */     // GIR_Coverage, 950,
     /*  195121 */     GIR_Done,
     /*  195122 */   // Label 3780: @195122
     /*  195122 */   GIM_Reject,
     /*  195123 */ // Label 3750: @195123
     /*  195123 */ GIM_Reject,
     /*  195124 */ // Label 3748: @195124
     /*  195124 */ GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(196773),
     /*  195129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  195132 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(195173), // Rule ID 403 //
     /*  195137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  195140 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195147 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195154 */     // MIs[0] rs1
     /*  195154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195166 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  195171 */     GIR_RootConstrainSelectedInstOperands,
     /*  195172 */     // GIR_Coverage, 403,
     /*  195172 */     GIR_Done,
     /*  195173 */   // Label 3782: @195173
     /*  195173 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(195214), // Rule ID 405 //
     /*  195178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  195181 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195188 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195195 */     // MIs[0] rs1
     /*  195195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195207 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  195212 */     GIR_RootConstrainSelectedInstOperands,
     /*  195213 */     // GIR_Coverage, 405,
     /*  195213 */     GIR_Done,
     /*  195214 */   // Label 3783: @195214
     /*  195214 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(195255), // Rule ID 407 //
     /*  195219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  195222 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195229 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195236 */     // MIs[0] rs1
     /*  195236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195248 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  195253 */     GIR_RootConstrainSelectedInstOperands,
     /*  195254 */     // GIR_Coverage, 407,
     /*  195254 */     GIR_Done,
     /*  195255 */   // Label 3784: @195255
     /*  195255 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(195296), // Rule ID 409 //
     /*  195260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  195263 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195277 */     // MIs[0] rs1
     /*  195277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195289 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195289 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  195294 */     GIR_RootConstrainSelectedInstOperands,
     /*  195295 */     // GIR_Coverage, 409,
     /*  195295 */     GIR_Done,
     /*  195296 */   // Label 3785: @195296
     /*  195296 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(195337), // Rule ID 411 //
     /*  195301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  195304 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195318 */     // MIs[0] rs1
     /*  195318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195330 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  195335 */     GIR_RootConstrainSelectedInstOperands,
     /*  195336 */     // GIR_Coverage, 411,
     /*  195336 */     GIR_Done,
     /*  195337 */   // Label 3786: @195337
     /*  195337 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(195378), // Rule ID 413 //
     /*  195342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195345 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195352 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195359 */     // MIs[0] rs1
     /*  195359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195371 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  195376 */     GIR_RootConstrainSelectedInstOperands,
     /*  195377 */     // GIR_Coverage, 413,
     /*  195377 */     GIR_Done,
     /*  195378 */   // Label 3787: @195378
     /*  195378 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(195419), // Rule ID 415 //
     /*  195383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195386 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195393 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195400 */     // MIs[0] rs1
     /*  195400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195412 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  195417 */     GIR_RootConstrainSelectedInstOperands,
     /*  195418 */     // GIR_Coverage, 415,
     /*  195418 */     GIR_Done,
     /*  195419 */   // Label 3788: @195419
     /*  195419 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(195460), // Rule ID 417 //
     /*  195424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195434 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195441 */     // MIs[0] rs1
     /*  195441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195453 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195453 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  195458 */     GIR_RootConstrainSelectedInstOperands,
     /*  195459 */     // GIR_Coverage, 417,
     /*  195459 */     GIR_Done,
     /*  195460 */   // Label 3789: @195460
     /*  195460 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(195501), // Rule ID 419 //
     /*  195465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195482 */     // MIs[0] rs1
     /*  195482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195494 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  195499 */     GIR_RootConstrainSelectedInstOperands,
     /*  195500 */     // GIR_Coverage, 419,
     /*  195500 */     GIR_Done,
     /*  195501 */   // Label 3790: @195501
     /*  195501 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(195542), // Rule ID 421 //
     /*  195506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195509 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195516 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195523 */     // MIs[0] rs1
     /*  195523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195535 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  195540 */     GIR_RootConstrainSelectedInstOperands,
     /*  195541 */     // GIR_Coverage, 421,
     /*  195541 */     GIR_Done,
     /*  195542 */   // Label 3791: @195542
     /*  195542 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(195583), // Rule ID 553 //
     /*  195547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195550 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195557 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195564 */     // MIs[0] rs1
     /*  195564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195576 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  195581 */     GIR_RootConstrainSelectedInstOperands,
     /*  195582 */     // GIR_Coverage, 553,
     /*  195582 */     GIR_Done,
     /*  195583 */   // Label 3792: @195583
     /*  195583 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(195624), // Rule ID 554 //
     /*  195588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195591 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195598 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195605 */     // MIs[0] rs1
     /*  195605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195617 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ),
     /*  195622 */     GIR_RootConstrainSelectedInstOperands,
     /*  195623 */     // GIR_Coverage, 554,
     /*  195623 */     GIR_Done,
     /*  195624 */   // Label 3793: @195624
     /*  195624 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(195665), // Rule ID 555 //
     /*  195629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195632 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195639 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195646 */     // MIs[0] rs1
     /*  195646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195658 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_RL),
     /*  195663 */     GIR_RootConstrainSelectedInstOperands,
     /*  195664 */     // GIR_Coverage, 555,
     /*  195664 */     GIR_Done,
     /*  195665 */   // Label 3794: @195665
     /*  195665 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(195706), // Rule ID 556 //
     /*  195670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195673 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195680 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195687 */     // MIs[0] rs1
     /*  195687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195699 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  195704 */     GIR_RootConstrainSelectedInstOperands,
     /*  195705 */     // GIR_Coverage, 556,
     /*  195705 */     GIR_Done,
     /*  195706 */   // Label 3795: @195706
     /*  195706 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(195747), // Rule ID 557 //
     /*  195711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195714 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195721 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195728 */     // MIs[0] rs1
     /*  195728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195740 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  195745 */     GIR_RootConstrainSelectedInstOperands,
     /*  195746 */     // GIR_Coverage, 557,
     /*  195746 */     GIR_Done,
     /*  195747 */   // Label 3796: @195747
     /*  195747 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(195788), // Rule ID 558 //
     /*  195752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195755 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195762 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195769 */     // MIs[0] rs1
     /*  195769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195781 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  195786 */     GIR_RootConstrainSelectedInstOperands,
     /*  195787 */     // GIR_Coverage, 558,
     /*  195787 */     GIR_Done,
     /*  195788 */   // Label 3797: @195788
     /*  195788 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(195829), // Rule ID 559 //
     /*  195793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195796 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195803 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195810 */     // MIs[0] rs1
     /*  195810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195822 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  195827 */     GIR_RootConstrainSelectedInstOperands,
     /*  195828 */     // GIR_Coverage, 559,
     /*  195828 */     GIR_Done,
     /*  195829 */   // Label 3798: @195829
     /*  195829 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(195870), // Rule ID 560 //
     /*  195834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195837 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195844 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195851 */     // MIs[0] rs1
     /*  195851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195863 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  195868 */     GIR_RootConstrainSelectedInstOperands,
     /*  195869 */     // GIR_Coverage, 560,
     /*  195869 */     GIR_Done,
     /*  195870 */   // Label 3799: @195870
     /*  195870 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(195911), // Rule ID 561 //
     /*  195875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195878 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195885 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195892 */     // MIs[0] rs1
     /*  195892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195904 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  195909 */     GIR_RootConstrainSelectedInstOperands,
     /*  195910 */     // GIR_Coverage, 561,
     /*  195910 */     GIR_Done,
     /*  195911 */   // Label 3800: @195911
     /*  195911 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(195952), // Rule ID 562 //
     /*  195916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195919 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195926 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195933 */     // MIs[0] rs1
     /*  195933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195945 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  195950 */     GIR_RootConstrainSelectedInstOperands,
     /*  195951 */     // GIR_Coverage, 562,
     /*  195951 */     GIR_Done,
     /*  195952 */   // Label 3801: @195952
     /*  195952 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(195993), // Rule ID 751 //
     /*  195957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195960 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195967 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195974 */     // MIs[0] rs1
     /*  195974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195986 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  195991 */     GIR_RootConstrainSelectedInstOperands,
     /*  195992 */     // GIR_Coverage, 751,
     /*  195992 */     GIR_Done,
     /*  195993 */   // Label 3802: @195993
     /*  195993 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(196034), // Rule ID 753 //
     /*  195998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196001 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196008 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196015 */     // MIs[0] rs1
     /*  196015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196027 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  196032 */     GIR_RootConstrainSelectedInstOperands,
     /*  196033 */     // GIR_Coverage, 753,
     /*  196033 */     GIR_Done,
     /*  196034 */   // Label 3803: @196034
     /*  196034 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(196075), // Rule ID 755 //
     /*  196039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196042 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196049 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196056 */     // MIs[0] rs1
     /*  196056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196068 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  196073 */     GIR_RootConstrainSelectedInstOperands,
     /*  196074 */     // GIR_Coverage, 755,
     /*  196074 */     GIR_Done,
     /*  196075 */   // Label 3804: @196075
     /*  196075 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(196116), // Rule ID 757 //
     /*  196080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196083 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196090 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196097 */     // MIs[0] rs1
     /*  196097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196109 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196109 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  196114 */     GIR_RootConstrainSelectedInstOperands,
     /*  196115 */     // GIR_Coverage, 757,
     /*  196115 */     GIR_Done,
     /*  196116 */   // Label 3805: @196116
     /*  196116 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(196157), // Rule ID 759 //
     /*  196121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196124 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196131 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196138 */     // MIs[0] rs1
     /*  196138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196150 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  196155 */     GIR_RootConstrainSelectedInstOperands,
     /*  196156 */     // GIR_Coverage, 759,
     /*  196156 */     GIR_Done,
     /*  196157 */   // Label 3806: @196157
     /*  196157 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(196198), // Rule ID 761 //
     /*  196162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196165 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196179 */     // MIs[0] rs1
     /*  196179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196191 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  196196 */     GIR_RootConstrainSelectedInstOperands,
     /*  196197 */     // GIR_Coverage, 761,
     /*  196197 */     GIR_Done,
     /*  196198 */   // Label 3807: @196198
     /*  196198 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(196239), // Rule ID 763 //
     /*  196203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196206 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196213 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196220 */     // MIs[0] rs1
     /*  196220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196232 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  196237 */     GIR_RootConstrainSelectedInstOperands,
     /*  196238 */     // GIR_Coverage, 763,
     /*  196238 */     GIR_Done,
     /*  196239 */   // Label 3808: @196239
     /*  196239 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(196280), // Rule ID 765 //
     /*  196244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196247 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196254 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196261 */     // MIs[0] rs1
     /*  196261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196273 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  196278 */     GIR_RootConstrainSelectedInstOperands,
     /*  196279 */     // GIR_Coverage, 765,
     /*  196279 */     GIR_Done,
     /*  196280 */   // Label 3809: @196280
     /*  196280 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(196321), // Rule ID 767 //
     /*  196285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196288 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196295 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196302 */     // MIs[0] rs1
     /*  196302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196314 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  196319 */     GIR_RootConstrainSelectedInstOperands,
     /*  196320 */     // GIR_Coverage, 767,
     /*  196320 */     GIR_Done,
     /*  196321 */   // Label 3810: @196321
     /*  196321 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(196362), // Rule ID 769 //
     /*  196326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196329 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196336 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196343 */     // MIs[0] rs1
     /*  196343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196355 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  196360 */     GIR_RootConstrainSelectedInstOperands,
     /*  196361 */     // GIR_Coverage, 769,
     /*  196361 */     GIR_Done,
     /*  196362 */   // Label 3811: @196362
     /*  196362 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(196403), // Rule ID 931 //
     /*  196367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196370 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196377 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196384 */     // MIs[0] rs1
     /*  196384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196396 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  196401 */     GIR_RootConstrainSelectedInstOperands,
     /*  196402 */     // GIR_Coverage, 931,
     /*  196402 */     GIR_Done,
     /*  196403 */   // Label 3812: @196403
     /*  196403 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(196444), // Rule ID 933 //
     /*  196408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196411 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196425 */     // MIs[0] rs1
     /*  196425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196437 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  196442 */     GIR_RootConstrainSelectedInstOperands,
     /*  196443 */     // GIR_Coverage, 933,
     /*  196443 */     GIR_Done,
     /*  196444 */   // Label 3813: @196444
     /*  196444 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(196485), // Rule ID 935 //
     /*  196449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196452 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196459 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196466 */     // MIs[0] rs1
     /*  196466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196478 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  196483 */     GIR_RootConstrainSelectedInstOperands,
     /*  196484 */     // GIR_Coverage, 935,
     /*  196484 */     GIR_Done,
     /*  196485 */   // Label 3814: @196485
     /*  196485 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(196526), // Rule ID 937 //
     /*  196490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196493 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196500 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196507 */     // MIs[0] rs1
     /*  196507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196519 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  196524 */     GIR_RootConstrainSelectedInstOperands,
     /*  196525 */     // GIR_Coverage, 937,
     /*  196525 */     GIR_Done,
     /*  196526 */   // Label 3815: @196526
     /*  196526 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(196567), // Rule ID 939 //
     /*  196531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196534 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196548 */     // MIs[0] rs1
     /*  196548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196560 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  196565 */     GIR_RootConstrainSelectedInstOperands,
     /*  196566 */     // GIR_Coverage, 939,
     /*  196566 */     GIR_Done,
     /*  196567 */   // Label 3816: @196567
     /*  196567 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(196608), // Rule ID 941 //
     /*  196572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196589 */     // MIs[0] rs1
     /*  196589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196601 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  196606 */     GIR_RootConstrainSelectedInstOperands,
     /*  196607 */     // GIR_Coverage, 941,
     /*  196607 */     GIR_Done,
     /*  196608 */   // Label 3817: @196608
     /*  196608 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(196649), // Rule ID 943 //
     /*  196613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196616 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196630 */     // MIs[0] rs1
     /*  196630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196642 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  196647 */     GIR_RootConstrainSelectedInstOperands,
     /*  196648 */     // GIR_Coverage, 943,
     /*  196648 */     GIR_Done,
     /*  196649 */   // Label 3818: @196649
     /*  196649 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(196690), // Rule ID 945 //
     /*  196654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196657 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196664 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196671 */     // MIs[0] rs1
     /*  196671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196683 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  196688 */     GIR_RootConstrainSelectedInstOperands,
     /*  196689 */     // GIR_Coverage, 945,
     /*  196689 */     GIR_Done,
     /*  196690 */   // Label 3819: @196690
     /*  196690 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(196731), // Rule ID 947 //
     /*  196695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196698 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196705 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196712 */     // MIs[0] rs1
     /*  196712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196724 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  196729 */     GIR_RootConstrainSelectedInstOperands,
     /*  196730 */     // GIR_Coverage, 947,
     /*  196730 */     GIR_Done,
     /*  196731 */   // Label 3820: @196731
     /*  196731 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(196772), // Rule ID 949 //
     /*  196736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196739 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196746 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196753 */     // MIs[0] rs1
     /*  196753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196765 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  196770 */     GIR_RootConstrainSelectedInstOperands,
     /*  196771 */     // GIR_Coverage, 949,
     /*  196771 */     GIR_Done,
     /*  196772 */   // Label 3821: @196772
     /*  196772 */   GIM_Reject,
     /*  196773 */ // Label 3781: @196773
     /*  196773 */ GIM_Reject,
     /*  196774 */ // Label 3749: @196774
     /*  196774 */ GIM_Reject,
     /*  196775 */ // Label 31: @196775
     /*  196775 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3824*/ GIMT_Encode4(199684),
     /*  196786 */ /*GILLT_s32*//*Label 3822*/ GIMT_Encode4(196794),
     /*  196790 */ /*GILLT_s64*//*Label 3823*/ GIMT_Encode4(198034),
     /*  196794 */ // Label 3822: @196794
     /*  196794 */ GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(198033),
     /*  196799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  196802 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(196843), // Rule ID 424 //
     /*  196807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196824 */     // MIs[0] rs1
     /*  196824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196836 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  196841 */     GIR_RootConstrainSelectedInstOperands,
     /*  196842 */     // GIR_Coverage, 424,
     /*  196842 */     GIR_Done,
     /*  196843 */   // Label 3826: @196843
     /*  196843 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(196884), // Rule ID 426 //
     /*  196848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196851 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196858 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196865 */     // MIs[0] rs1
     /*  196865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196877 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  196882 */     GIR_RootConstrainSelectedInstOperands,
     /*  196883 */     // GIR_Coverage, 426,
     /*  196883 */     GIR_Done,
     /*  196884 */   // Label 3827: @196884
     /*  196884 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(196925), // Rule ID 428 //
     /*  196889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196892 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196906 */     // MIs[0] rs1
     /*  196906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196918 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  196923 */     GIR_RootConstrainSelectedInstOperands,
     /*  196924 */     // GIR_Coverage, 428,
     /*  196924 */     GIR_Done,
     /*  196925 */   // Label 3828: @196925
     /*  196925 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(196966), // Rule ID 430 //
     /*  196930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196940 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196947 */     // MIs[0] rs1
     /*  196947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196959 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  196964 */     GIR_RootConstrainSelectedInstOperands,
     /*  196965 */     // GIR_Coverage, 430,
     /*  196965 */     GIR_Done,
     /*  196966 */   // Label 3829: @196966
     /*  196966 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(197007), // Rule ID 432 //
     /*  196971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196974 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196981 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196988 */     // MIs[0] rs1
     /*  196988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197000 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  197005 */     GIR_RootConstrainSelectedInstOperands,
     /*  197006 */     // GIR_Coverage, 432,
     /*  197006 */     GIR_Done,
     /*  197007 */   // Label 3830: @197007
     /*  197007 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(197048), // Rule ID 434 //
     /*  197012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  197015 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197022 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197029 */     // MIs[0] rs1
     /*  197029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197041 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  197046 */     GIR_RootConstrainSelectedInstOperands,
     /*  197047 */     // GIR_Coverage, 434,
     /*  197047 */     GIR_Done,
     /*  197048 */   // Label 3831: @197048
     /*  197048 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(197089), // Rule ID 436 //
     /*  197053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  197056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197070 */     // MIs[0] rs1
     /*  197070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197082 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  197087 */     GIR_RootConstrainSelectedInstOperands,
     /*  197088 */     // GIR_Coverage, 436,
     /*  197088 */     GIR_Done,
     /*  197089 */   // Label 3832: @197089
     /*  197089 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(197130), // Rule ID 438 //
     /*  197094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  197097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197111 */     // MIs[0] rs1
     /*  197111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197123 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  197128 */     GIR_RootConstrainSelectedInstOperands,
     /*  197129 */     // GIR_Coverage, 438,
     /*  197129 */     GIR_Done,
     /*  197130 */   // Label 3833: @197130
     /*  197130 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(197171), // Rule ID 440 //
     /*  197135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  197138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197152 */     // MIs[0] rs1
     /*  197152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197164 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  197169 */     GIR_RootConstrainSelectedInstOperands,
     /*  197170 */     // GIR_Coverage, 440,
     /*  197170 */     GIR_Done,
     /*  197171 */   // Label 3834: @197171
     /*  197171 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(197212), // Rule ID 442 //
     /*  197176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  197179 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197186 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197193 */     // MIs[0] rs1
     /*  197193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197205 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  197210 */     GIR_RootConstrainSelectedInstOperands,
     /*  197211 */     // GIR_Coverage, 442,
     /*  197211 */     GIR_Done,
     /*  197212 */   // Label 3835: @197212
     /*  197212 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(197253), // Rule ID 772 //
     /*  197217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197220 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197227 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197234 */     // MIs[0] rs1
     /*  197234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197246 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  197251 */     GIR_RootConstrainSelectedInstOperands,
     /*  197252 */     // GIR_Coverage, 772,
     /*  197252 */     GIR_Done,
     /*  197253 */   // Label 3836: @197253
     /*  197253 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(197294), // Rule ID 774 //
     /*  197258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197261 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197268 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197275 */     // MIs[0] rs1
     /*  197275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197287 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  197292 */     GIR_RootConstrainSelectedInstOperands,
     /*  197293 */     // GIR_Coverage, 774,
     /*  197293 */     GIR_Done,
     /*  197294 */   // Label 3837: @197294
     /*  197294 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(197335), // Rule ID 776 //
     /*  197299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197302 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197309 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197316 */     // MIs[0] rs1
     /*  197316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197328 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  197333 */     GIR_RootConstrainSelectedInstOperands,
     /*  197334 */     // GIR_Coverage, 776,
     /*  197334 */     GIR_Done,
     /*  197335 */   // Label 3838: @197335
     /*  197335 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(197376), // Rule ID 778 //
     /*  197340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197343 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197350 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197357 */     // MIs[0] rs1
     /*  197357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197369 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  197374 */     GIR_RootConstrainSelectedInstOperands,
     /*  197375 */     // GIR_Coverage, 778,
     /*  197375 */     GIR_Done,
     /*  197376 */   // Label 3839: @197376
     /*  197376 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(197417), // Rule ID 780 //
     /*  197381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197398 */     // MIs[0] rs1
     /*  197398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197410 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  197415 */     GIR_RootConstrainSelectedInstOperands,
     /*  197416 */     // GIR_Coverage, 780,
     /*  197416 */     GIR_Done,
     /*  197417 */   // Label 3840: @197417
     /*  197417 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(197458), // Rule ID 782 //
     /*  197422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197425 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197439 */     // MIs[0] rs1
     /*  197439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197451 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  197456 */     GIR_RootConstrainSelectedInstOperands,
     /*  197457 */     // GIR_Coverage, 782,
     /*  197457 */     GIR_Done,
     /*  197458 */   // Label 3841: @197458
     /*  197458 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(197499), // Rule ID 784 //
     /*  197463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197480 */     // MIs[0] rs1
     /*  197480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197492 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  197497 */     GIR_RootConstrainSelectedInstOperands,
     /*  197498 */     // GIR_Coverage, 784,
     /*  197498 */     GIR_Done,
     /*  197499 */   // Label 3842: @197499
     /*  197499 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(197540), // Rule ID 786 //
     /*  197504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197521 */     // MIs[0] rs1
     /*  197521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197533 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  197538 */     GIR_RootConstrainSelectedInstOperands,
     /*  197539 */     // GIR_Coverage, 786,
     /*  197539 */     GIR_Done,
     /*  197540 */   // Label 3843: @197540
     /*  197540 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(197581), // Rule ID 788 //
     /*  197545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197562 */     // MIs[0] rs1
     /*  197562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197574 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  197579 */     GIR_RootConstrainSelectedInstOperands,
     /*  197580 */     // GIR_Coverage, 788,
     /*  197580 */     GIR_Done,
     /*  197581 */   // Label 3844: @197581
     /*  197581 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(197622), // Rule ID 790 //
     /*  197586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197603 */     // MIs[0] rs1
     /*  197603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197615 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  197620 */     GIR_RootConstrainSelectedInstOperands,
     /*  197621 */     // GIR_Coverage, 790,
     /*  197621 */     GIR_Done,
     /*  197622 */   // Label 3845: @197622
     /*  197622 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(197663), // Rule ID 952 //
     /*  197627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197644 */     // MIs[0] rs1
     /*  197644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197656 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  197661 */     GIR_RootConstrainSelectedInstOperands,
     /*  197662 */     // GIR_Coverage, 952,
     /*  197662 */     GIR_Done,
     /*  197663 */   // Label 3846: @197663
     /*  197663 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(197704), // Rule ID 954 //
     /*  197668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197685 */     // MIs[0] rs1
     /*  197685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197697 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  197702 */     GIR_RootConstrainSelectedInstOperands,
     /*  197703 */     // GIR_Coverage, 954,
     /*  197703 */     GIR_Done,
     /*  197704 */   // Label 3847: @197704
     /*  197704 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(197745), // Rule ID 956 //
     /*  197709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197726 */     // MIs[0] rs1
     /*  197726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197738 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  197743 */     GIR_RootConstrainSelectedInstOperands,
     /*  197744 */     // GIR_Coverage, 956,
     /*  197744 */     GIR_Done,
     /*  197745 */   // Label 3848: @197745
     /*  197745 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(197786), // Rule ID 958 //
     /*  197750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197767 */     // MIs[0] rs1
     /*  197767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197779 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  197784 */     GIR_RootConstrainSelectedInstOperands,
     /*  197785 */     // GIR_Coverage, 958,
     /*  197785 */     GIR_Done,
     /*  197786 */   // Label 3849: @197786
     /*  197786 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(197827), // Rule ID 960 //
     /*  197791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197794 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197808 */     // MIs[0] rs1
     /*  197808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197820 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  197825 */     GIR_RootConstrainSelectedInstOperands,
     /*  197826 */     // GIR_Coverage, 960,
     /*  197826 */     GIR_Done,
     /*  197827 */   // Label 3850: @197827
     /*  197827 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(197868), // Rule ID 962 //
     /*  197832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197849 */     // MIs[0] rs1
     /*  197849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197861 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  197866 */     GIR_RootConstrainSelectedInstOperands,
     /*  197867 */     // GIR_Coverage, 962,
     /*  197867 */     GIR_Done,
     /*  197868 */   // Label 3851: @197868
     /*  197868 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(197909), // Rule ID 964 //
     /*  197873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197890 */     // MIs[0] rs1
     /*  197890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197902 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  197907 */     GIR_RootConstrainSelectedInstOperands,
     /*  197908 */     // GIR_Coverage, 964,
     /*  197908 */     GIR_Done,
     /*  197909 */   // Label 3852: @197909
     /*  197909 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(197950), // Rule ID 966 //
     /*  197914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197924 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197931 */     // MIs[0] rs1
     /*  197931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197943 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  197948 */     GIR_RootConstrainSelectedInstOperands,
     /*  197949 */     // GIR_Coverage, 966,
     /*  197949 */     GIR_Done,
     /*  197950 */   // Label 3853: @197950
     /*  197950 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(197991), // Rule ID 968 //
     /*  197955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197972 */     // MIs[0] rs1
     /*  197972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197984 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  197989 */     GIR_RootConstrainSelectedInstOperands,
     /*  197990 */     // GIR_Coverage, 968,
     /*  197990 */     GIR_Done,
     /*  197991 */   // Label 3854: @197991
     /*  197991 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(198032), // Rule ID 970 //
     /*  197996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198006 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198013 */     // MIs[0] rs1
     /*  198013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198025 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  198030 */     GIR_RootConstrainSelectedInstOperands,
     /*  198031 */     // GIR_Coverage, 970,
     /*  198031 */     GIR_Done,
     /*  198032 */   // Label 3855: @198032
     /*  198032 */   GIM_Reject,
     /*  198033 */ // Label 3825: @198033
     /*  198033 */ GIM_Reject,
     /*  198034 */ // Label 3823: @198034
     /*  198034 */ GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(199683),
     /*  198039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  198042 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(198083), // Rule ID 423 //
     /*  198047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  198050 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198057 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198064 */     // MIs[0] rs1
     /*  198064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198076 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  198081 */     GIR_RootConstrainSelectedInstOperands,
     /*  198082 */     // GIR_Coverage, 423,
     /*  198082 */     GIR_Done,
     /*  198083 */   // Label 3857: @198083
     /*  198083 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(198124), // Rule ID 425 //
     /*  198088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  198091 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198098 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198105 */     // MIs[0] rs1
     /*  198105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198117 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  198122 */     GIR_RootConstrainSelectedInstOperands,
     /*  198123 */     // GIR_Coverage, 425,
     /*  198123 */     GIR_Done,
     /*  198124 */   // Label 3858: @198124
     /*  198124 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(198165), // Rule ID 427 //
     /*  198129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  198132 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198139 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198146 */     // MIs[0] rs1
     /*  198146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198158 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  198163 */     GIR_RootConstrainSelectedInstOperands,
     /*  198164 */     // GIR_Coverage, 427,
     /*  198164 */     GIR_Done,
     /*  198165 */   // Label 3859: @198165
     /*  198165 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(198206), // Rule ID 429 //
     /*  198170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  198173 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198180 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198187 */     // MIs[0] rs1
     /*  198187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198199 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  198204 */     GIR_RootConstrainSelectedInstOperands,
     /*  198205 */     // GIR_Coverage, 429,
     /*  198205 */     GIR_Done,
     /*  198206 */   // Label 3860: @198206
     /*  198206 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(198247), // Rule ID 431 //
     /*  198211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  198214 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198221 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198228 */     // MIs[0] rs1
     /*  198228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198240 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  198245 */     GIR_RootConstrainSelectedInstOperands,
     /*  198246 */     // GIR_Coverage, 431,
     /*  198246 */     GIR_Done,
     /*  198247 */   // Label 3861: @198247
     /*  198247 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(198288), // Rule ID 433 //
     /*  198252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  198255 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198269 */     // MIs[0] rs1
     /*  198269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198281 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  198286 */     GIR_RootConstrainSelectedInstOperands,
     /*  198287 */     // GIR_Coverage, 433,
     /*  198287 */     GIR_Done,
     /*  198288 */   // Label 3862: @198288
     /*  198288 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(198329), // Rule ID 435 //
     /*  198293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  198296 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198303 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198310 */     // MIs[0] rs1
     /*  198310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198322 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  198327 */     GIR_RootConstrainSelectedInstOperands,
     /*  198328 */     // GIR_Coverage, 435,
     /*  198328 */     GIR_Done,
     /*  198329 */   // Label 3863: @198329
     /*  198329 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(198370), // Rule ID 437 //
     /*  198334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  198337 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198344 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198351 */     // MIs[0] rs1
     /*  198351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198363 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  198368 */     GIR_RootConstrainSelectedInstOperands,
     /*  198369 */     // GIR_Coverage, 437,
     /*  198369 */     GIR_Done,
     /*  198370 */   // Label 3864: @198370
     /*  198370 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(198411), // Rule ID 439 //
     /*  198375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  198378 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198385 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198392 */     // MIs[0] rs1
     /*  198392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198404 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  198409 */     GIR_RootConstrainSelectedInstOperands,
     /*  198410 */     // GIR_Coverage, 439,
     /*  198410 */     GIR_Done,
     /*  198411 */   // Label 3865: @198411
     /*  198411 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(198452), // Rule ID 441 //
     /*  198416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  198419 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198426 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198433 */     // MIs[0] rs1
     /*  198433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198445 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  198450 */     GIR_RootConstrainSelectedInstOperands,
     /*  198451 */     // GIR_Coverage, 441,
     /*  198451 */     GIR_Done,
     /*  198452 */   // Label 3866: @198452
     /*  198452 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(198493), // Rule ID 563 //
     /*  198457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198460 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198474 */     // MIs[0] rs1
     /*  198474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198486 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  198491 */     GIR_RootConstrainSelectedInstOperands,
     /*  198492 */     // GIR_Coverage, 563,
     /*  198492 */     GIR_Done,
     /*  198493 */   // Label 3867: @198493
     /*  198493 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(198534), // Rule ID 564 //
     /*  198498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198501 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198508 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198515 */     // MIs[0] rs1
     /*  198515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198527 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ),
     /*  198532 */     GIR_RootConstrainSelectedInstOperands,
     /*  198533 */     // GIR_Coverage, 564,
     /*  198533 */     GIR_Done,
     /*  198534 */   // Label 3868: @198534
     /*  198534 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(198575), // Rule ID 565 //
     /*  198539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198542 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198549 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198556 */     // MIs[0] rs1
     /*  198556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198568 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_RL),
     /*  198573 */     GIR_RootConstrainSelectedInstOperands,
     /*  198574 */     // GIR_Coverage, 565,
     /*  198574 */     GIR_Done,
     /*  198575 */   // Label 3869: @198575
     /*  198575 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(198616), // Rule ID 566 //
     /*  198580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198583 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198590 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198597 */     // MIs[0] rs1
     /*  198597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198609 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  198614 */     GIR_RootConstrainSelectedInstOperands,
     /*  198615 */     // GIR_Coverage, 566,
     /*  198615 */     GIR_Done,
     /*  198616 */   // Label 3870: @198616
     /*  198616 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(198657), // Rule ID 567 //
     /*  198621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198624 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198631 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198638 */     // MIs[0] rs1
     /*  198638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198650 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198650 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  198655 */     GIR_RootConstrainSelectedInstOperands,
     /*  198656 */     // GIR_Coverage, 567,
     /*  198656 */     GIR_Done,
     /*  198657 */   // Label 3871: @198657
     /*  198657 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(198698), // Rule ID 568 //
     /*  198662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198665 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198679 */     // MIs[0] rs1
     /*  198679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198691 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  198696 */     GIR_RootConstrainSelectedInstOperands,
     /*  198697 */     // GIR_Coverage, 568,
     /*  198697 */     GIR_Done,
     /*  198698 */   // Label 3872: @198698
     /*  198698 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(198739), // Rule ID 569 //
     /*  198703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198706 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198713 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198720 */     // MIs[0] rs1
     /*  198720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198732 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  198737 */     GIR_RootConstrainSelectedInstOperands,
     /*  198738 */     // GIR_Coverage, 569,
     /*  198738 */     GIR_Done,
     /*  198739 */   // Label 3873: @198739
     /*  198739 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(198780), // Rule ID 570 //
     /*  198744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198747 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198754 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198761 */     // MIs[0] rs1
     /*  198761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198773 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  198778 */     GIR_RootConstrainSelectedInstOperands,
     /*  198779 */     // GIR_Coverage, 570,
     /*  198779 */     GIR_Done,
     /*  198780 */   // Label 3874: @198780
     /*  198780 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(198821), // Rule ID 571 //
     /*  198785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198788 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198795 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198802 */     // MIs[0] rs1
     /*  198802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198814 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  198819 */     GIR_RootConstrainSelectedInstOperands,
     /*  198820 */     // GIR_Coverage, 571,
     /*  198820 */     GIR_Done,
     /*  198821 */   // Label 3875: @198821
     /*  198821 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(198862), // Rule ID 572 //
     /*  198826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198829 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198836 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198843 */     // MIs[0] rs1
     /*  198843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198855 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  198860 */     GIR_RootConstrainSelectedInstOperands,
     /*  198861 */     // GIR_Coverage, 572,
     /*  198861 */     GIR_Done,
     /*  198862 */   // Label 3876: @198862
     /*  198862 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(198903), // Rule ID 771 //
     /*  198867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198870 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198884 */     // MIs[0] rs1
     /*  198884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198896 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  198901 */     GIR_RootConstrainSelectedInstOperands,
     /*  198902 */     // GIR_Coverage, 771,
     /*  198902 */     GIR_Done,
     /*  198903 */   // Label 3877: @198903
     /*  198903 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(198944), // Rule ID 773 //
     /*  198908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198911 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198918 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198925 */     // MIs[0] rs1
     /*  198925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198937 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  198942 */     GIR_RootConstrainSelectedInstOperands,
     /*  198943 */     // GIR_Coverage, 773,
     /*  198943 */     GIR_Done,
     /*  198944 */   // Label 3878: @198944
     /*  198944 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(198985), // Rule ID 775 //
     /*  198949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198952 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198959 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198966 */     // MIs[0] rs1
     /*  198966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198978 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  198983 */     GIR_RootConstrainSelectedInstOperands,
     /*  198984 */     // GIR_Coverage, 775,
     /*  198984 */     GIR_Done,
     /*  198985 */   // Label 3879: @198985
     /*  198985 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(199026), // Rule ID 777 //
     /*  198990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199007 */     // MIs[0] rs1
     /*  199007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199019 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  199024 */     GIR_RootConstrainSelectedInstOperands,
     /*  199025 */     // GIR_Coverage, 777,
     /*  199025 */     GIR_Done,
     /*  199026 */   // Label 3880: @199026
     /*  199026 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(199067), // Rule ID 779 //
     /*  199031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  199034 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199041 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199048 */     // MIs[0] rs1
     /*  199048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199060 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  199065 */     GIR_RootConstrainSelectedInstOperands,
     /*  199066 */     // GIR_Coverage, 779,
     /*  199066 */     GIR_Done,
     /*  199067 */   // Label 3881: @199067
     /*  199067 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(199108), // Rule ID 781 //
     /*  199072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199075 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199082 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199089 */     // MIs[0] rs1
     /*  199089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199101 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  199106 */     GIR_RootConstrainSelectedInstOperands,
     /*  199107 */     // GIR_Coverage, 781,
     /*  199107 */     GIR_Done,
     /*  199108 */   // Label 3882: @199108
     /*  199108 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(199149), // Rule ID 783 //
     /*  199113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199130 */     // MIs[0] rs1
     /*  199130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199142 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  199147 */     GIR_RootConstrainSelectedInstOperands,
     /*  199148 */     // GIR_Coverage, 783,
     /*  199148 */     GIR_Done,
     /*  199149 */   // Label 3883: @199149
     /*  199149 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(199190), // Rule ID 785 //
     /*  199154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199157 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199171 */     // MIs[0] rs1
     /*  199171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199183 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  199188 */     GIR_RootConstrainSelectedInstOperands,
     /*  199189 */     // GIR_Coverage, 785,
     /*  199189 */     GIR_Done,
     /*  199190 */   // Label 3884: @199190
     /*  199190 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(199231), // Rule ID 787 //
     /*  199195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199212 */     // MIs[0] rs1
     /*  199212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199224 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  199229 */     GIR_RootConstrainSelectedInstOperands,
     /*  199230 */     // GIR_Coverage, 787,
     /*  199230 */     GIR_Done,
     /*  199231 */   // Label 3885: @199231
     /*  199231 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(199272), // Rule ID 789 //
     /*  199236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199239 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199246 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199253 */     // MIs[0] rs1
     /*  199253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199265 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  199270 */     GIR_RootConstrainSelectedInstOperands,
     /*  199271 */     // GIR_Coverage, 789,
     /*  199271 */     GIR_Done,
     /*  199272 */   // Label 3886: @199272
     /*  199272 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(199313), // Rule ID 951 //
     /*  199277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  199280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199294 */     // MIs[0] rs1
     /*  199294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199306 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  199311 */     GIR_RootConstrainSelectedInstOperands,
     /*  199312 */     // GIR_Coverage, 951,
     /*  199312 */     GIR_Done,
     /*  199313 */   // Label 3887: @199313
     /*  199313 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(199354), // Rule ID 953 //
     /*  199318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  199321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199328 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199335 */     // MIs[0] rs1
     /*  199335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199347 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  199352 */     GIR_RootConstrainSelectedInstOperands,
     /*  199353 */     // GIR_Coverage, 953,
     /*  199353 */     GIR_Done,
     /*  199354 */   // Label 3888: @199354
     /*  199354 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(199395), // Rule ID 955 //
     /*  199359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  199362 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199376 */     // MIs[0] rs1
     /*  199376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199388 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  199393 */     GIR_RootConstrainSelectedInstOperands,
     /*  199394 */     // GIR_Coverage, 955,
     /*  199394 */     GIR_Done,
     /*  199395 */   // Label 3889: @199395
     /*  199395 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(199436), // Rule ID 957 //
     /*  199400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  199403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199417 */     // MIs[0] rs1
     /*  199417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199429 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  199434 */     GIR_RootConstrainSelectedInstOperands,
     /*  199435 */     // GIR_Coverage, 957,
     /*  199435 */     GIR_Done,
     /*  199436 */   // Label 3890: @199436
     /*  199436 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(199477), // Rule ID 959 //
     /*  199441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  199444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199458 */     // MIs[0] rs1
     /*  199458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199470 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  199475 */     GIR_RootConstrainSelectedInstOperands,
     /*  199476 */     // GIR_Coverage, 959,
     /*  199476 */     GIR_Done,
     /*  199477 */   // Label 3891: @199477
     /*  199477 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(199518), // Rule ID 961 //
     /*  199482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199499 */     // MIs[0] rs1
     /*  199499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199511 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  199516 */     GIR_RootConstrainSelectedInstOperands,
     /*  199517 */     // GIR_Coverage, 961,
     /*  199517 */     GIR_Done,
     /*  199518 */   // Label 3892: @199518
     /*  199518 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(199559), // Rule ID 963 //
     /*  199523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199526 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199540 */     // MIs[0] rs1
     /*  199540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199552 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  199557 */     GIR_RootConstrainSelectedInstOperands,
     /*  199558 */     // GIR_Coverage, 963,
     /*  199558 */     GIR_Done,
     /*  199559 */   // Label 3893: @199559
     /*  199559 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(199600), // Rule ID 965 //
     /*  199564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199567 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199581 */     // MIs[0] rs1
     /*  199581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199593 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  199598 */     GIR_RootConstrainSelectedInstOperands,
     /*  199599 */     // GIR_Coverage, 965,
     /*  199599 */     GIR_Done,
     /*  199600 */   // Label 3894: @199600
     /*  199600 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(199641), // Rule ID 967 //
     /*  199605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199622 */     // MIs[0] rs1
     /*  199622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199634 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  199639 */     GIR_RootConstrainSelectedInstOperands,
     /*  199640 */     // GIR_Coverage, 967,
     /*  199640 */     GIR_Done,
     /*  199641 */   // Label 3895: @199641
     /*  199641 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(199682), // Rule ID 969 //
     /*  199646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199649 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199656 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199663 */     // MIs[0] rs1
     /*  199663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199675 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  199680 */     GIR_RootConstrainSelectedInstOperands,
     /*  199681 */     // GIR_Coverage, 969,
     /*  199681 */     GIR_Done,
     /*  199682 */   // Label 3896: @199682
     /*  199682 */   GIM_Reject,
     /*  199683 */ // Label 3856: @199683
     /*  199683 */ GIM_Reject,
     /*  199684 */ // Label 3824: @199684
     /*  199684 */ GIM_Reject,
     /*  199685 */ // Label 32: @199685
     /*  199685 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3899*/ GIMT_Encode4(202594),
     /*  199696 */ /*GILLT_s32*//*Label 3897*/ GIMT_Encode4(199704),
     /*  199700 */ /*GILLT_s64*//*Label 3898*/ GIMT_Encode4(200944),
     /*  199704 */ // Label 3897: @199704
     /*  199704 */ GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(200943),
     /*  199709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  199712 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(199753), // Rule ID 444 //
     /*  199717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199734 */     // MIs[0] rs1
     /*  199734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199746 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  199751 */     GIR_RootConstrainSelectedInstOperands,
     /*  199752 */     // GIR_Coverage, 444,
     /*  199752 */     GIR_Done,
     /*  199753 */   // Label 3901: @199753
     /*  199753 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(199794), // Rule ID 446 //
     /*  199758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199768 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199775 */     // MIs[0] rs1
     /*  199775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199787 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  199792 */     GIR_RootConstrainSelectedInstOperands,
     /*  199793 */     // GIR_Coverage, 446,
     /*  199793 */     GIR_Done,
     /*  199794 */   // Label 3902: @199794
     /*  199794 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(199835), // Rule ID 448 //
     /*  199799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199802 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199816 */     // MIs[0] rs1
     /*  199816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199828 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  199833 */     GIR_RootConstrainSelectedInstOperands,
     /*  199834 */     // GIR_Coverage, 448,
     /*  199834 */     GIR_Done,
     /*  199835 */   // Label 3903: @199835
     /*  199835 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(199876), // Rule ID 450 //
     /*  199840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199857 */     // MIs[0] rs1
     /*  199857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199869 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  199874 */     GIR_RootConstrainSelectedInstOperands,
     /*  199875 */     // GIR_Coverage, 450,
     /*  199875 */     GIR_Done,
     /*  199876 */   // Label 3904: @199876
     /*  199876 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(199917), // Rule ID 452 //
     /*  199881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199898 */     // MIs[0] rs1
     /*  199898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199910 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  199915 */     GIR_RootConstrainSelectedInstOperands,
     /*  199916 */     // GIR_Coverage, 452,
     /*  199916 */     GIR_Done,
     /*  199917 */   // Label 3905: @199917
     /*  199917 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(199958), // Rule ID 454 //
     /*  199922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199939 */     // MIs[0] rs1
     /*  199939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199951 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  199956 */     GIR_RootConstrainSelectedInstOperands,
     /*  199957 */     // GIR_Coverage, 454,
     /*  199957 */     GIR_Done,
     /*  199958 */   // Label 3906: @199958
     /*  199958 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(199999), // Rule ID 456 //
     /*  199963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199980 */     // MIs[0] rs1
     /*  199980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199992 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  199997 */     GIR_RootConstrainSelectedInstOperands,
     /*  199998 */     // GIR_Coverage, 456,
     /*  199998 */     GIR_Done,
     /*  199999 */   // Label 3907: @199999
     /*  199999 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(200040), // Rule ID 458 //
     /*  200004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  200007 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200014 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200021 */     // MIs[0] rs1
     /*  200021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200033 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  200038 */     GIR_RootConstrainSelectedInstOperands,
     /*  200039 */     // GIR_Coverage, 458,
     /*  200039 */     GIR_Done,
     /*  200040 */   // Label 3908: @200040
     /*  200040 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(200081), // Rule ID 460 //
     /*  200045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  200048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200062 */     // MIs[0] rs1
     /*  200062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200074 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  200079 */     GIR_RootConstrainSelectedInstOperands,
     /*  200080 */     // GIR_Coverage, 460,
     /*  200080 */     GIR_Done,
     /*  200081 */   // Label 3909: @200081
     /*  200081 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(200122), // Rule ID 462 //
     /*  200086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  200089 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200103 */     // MIs[0] rs1
     /*  200103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200115 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  200120 */     GIR_RootConstrainSelectedInstOperands,
     /*  200121 */     // GIR_Coverage, 462,
     /*  200121 */     GIR_Done,
     /*  200122 */   // Label 3910: @200122
     /*  200122 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(200163), // Rule ID 792 //
     /*  200127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200130 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200144 */     // MIs[0] rs1
     /*  200144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200156 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  200161 */     GIR_RootConstrainSelectedInstOperands,
     /*  200162 */     // GIR_Coverage, 792,
     /*  200162 */     GIR_Done,
     /*  200163 */   // Label 3911: @200163
     /*  200163 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(200204), // Rule ID 794 //
     /*  200168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200171 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200178 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200185 */     // MIs[0] rs1
     /*  200185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200197 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  200202 */     GIR_RootConstrainSelectedInstOperands,
     /*  200203 */     // GIR_Coverage, 794,
     /*  200203 */     GIR_Done,
     /*  200204 */   // Label 3912: @200204
     /*  200204 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(200245), // Rule ID 796 //
     /*  200209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200212 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200219 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200226 */     // MIs[0] rs1
     /*  200226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200238 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  200243 */     GIR_RootConstrainSelectedInstOperands,
     /*  200244 */     // GIR_Coverage, 796,
     /*  200244 */     GIR_Done,
     /*  200245 */   // Label 3913: @200245
     /*  200245 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(200286), // Rule ID 798 //
     /*  200250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200267 */     // MIs[0] rs1
     /*  200267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200279 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  200284 */     GIR_RootConstrainSelectedInstOperands,
     /*  200285 */     // GIR_Coverage, 798,
     /*  200285 */     GIR_Done,
     /*  200286 */   // Label 3914: @200286
     /*  200286 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(200327), // Rule ID 800 //
     /*  200291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200294 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200301 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200308 */     // MIs[0] rs1
     /*  200308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200320 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  200325 */     GIR_RootConstrainSelectedInstOperands,
     /*  200326 */     // GIR_Coverage, 800,
     /*  200326 */     GIR_Done,
     /*  200327 */   // Label 3915: @200327
     /*  200327 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(200368), // Rule ID 802 //
     /*  200332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200335 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200342 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200349 */     // MIs[0] rs1
     /*  200349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200361 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  200366 */     GIR_RootConstrainSelectedInstOperands,
     /*  200367 */     // GIR_Coverage, 802,
     /*  200367 */     GIR_Done,
     /*  200368 */   // Label 3916: @200368
     /*  200368 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(200409), // Rule ID 804 //
     /*  200373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200376 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200383 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200390 */     // MIs[0] rs1
     /*  200390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200402 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  200407 */     GIR_RootConstrainSelectedInstOperands,
     /*  200408 */     // GIR_Coverage, 804,
     /*  200408 */     GIR_Done,
     /*  200409 */   // Label 3917: @200409
     /*  200409 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(200450), // Rule ID 806 //
     /*  200414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200431 */     // MIs[0] rs1
     /*  200431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200443 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  200448 */     GIR_RootConstrainSelectedInstOperands,
     /*  200449 */     // GIR_Coverage, 806,
     /*  200449 */     GIR_Done,
     /*  200450 */   // Label 3918: @200450
     /*  200450 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(200491), // Rule ID 808 //
     /*  200455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200472 */     // MIs[0] rs1
     /*  200472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200484 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  200489 */     GIR_RootConstrainSelectedInstOperands,
     /*  200490 */     // GIR_Coverage, 808,
     /*  200490 */     GIR_Done,
     /*  200491 */   // Label 3919: @200491
     /*  200491 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(200532), // Rule ID 810 //
     /*  200496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200513 */     // MIs[0] rs1
     /*  200513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200525 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  200530 */     GIR_RootConstrainSelectedInstOperands,
     /*  200531 */     // GIR_Coverage, 810,
     /*  200531 */     GIR_Done,
     /*  200532 */   // Label 3920: @200532
     /*  200532 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(200573), // Rule ID 972 //
     /*  200537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200554 */     // MIs[0] rs1
     /*  200554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200566 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  200571 */     GIR_RootConstrainSelectedInstOperands,
     /*  200572 */     // GIR_Coverage, 972,
     /*  200572 */     GIR_Done,
     /*  200573 */   // Label 3921: @200573
     /*  200573 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(200614), // Rule ID 974 //
     /*  200578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200595 */     // MIs[0] rs1
     /*  200595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200607 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  200612 */     GIR_RootConstrainSelectedInstOperands,
     /*  200613 */     // GIR_Coverage, 974,
     /*  200613 */     GIR_Done,
     /*  200614 */   // Label 3922: @200614
     /*  200614 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(200655), // Rule ID 976 //
     /*  200619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200636 */     // MIs[0] rs1
     /*  200636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200648 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  200653 */     GIR_RootConstrainSelectedInstOperands,
     /*  200654 */     // GIR_Coverage, 976,
     /*  200654 */     GIR_Done,
     /*  200655 */   // Label 3923: @200655
     /*  200655 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(200696), // Rule ID 978 //
     /*  200660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200677 */     // MIs[0] rs1
     /*  200677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200689 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  200694 */     GIR_RootConstrainSelectedInstOperands,
     /*  200695 */     // GIR_Coverage, 978,
     /*  200695 */     GIR_Done,
     /*  200696 */   // Label 3924: @200696
     /*  200696 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(200737), // Rule ID 980 //
     /*  200701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200711 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200718 */     // MIs[0] rs1
     /*  200718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200730 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  200735 */     GIR_RootConstrainSelectedInstOperands,
     /*  200736 */     // GIR_Coverage, 980,
     /*  200736 */     GIR_Done,
     /*  200737 */   // Label 3925: @200737
     /*  200737 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(200778), // Rule ID 982 //
     /*  200742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200745 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200752 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200759 */     // MIs[0] rs1
     /*  200759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200771 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  200776 */     GIR_RootConstrainSelectedInstOperands,
     /*  200777 */     // GIR_Coverage, 982,
     /*  200777 */     GIR_Done,
     /*  200778 */   // Label 3926: @200778
     /*  200778 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(200819), // Rule ID 984 //
     /*  200783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200800 */     // MIs[0] rs1
     /*  200800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200812 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  200817 */     GIR_RootConstrainSelectedInstOperands,
     /*  200818 */     // GIR_Coverage, 984,
     /*  200818 */     GIR_Done,
     /*  200819 */   // Label 3927: @200819
     /*  200819 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(200860), // Rule ID 986 //
     /*  200824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200841 */     // MIs[0] rs1
     /*  200841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200853 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  200858 */     GIR_RootConstrainSelectedInstOperands,
     /*  200859 */     // GIR_Coverage, 986,
     /*  200859 */     GIR_Done,
     /*  200860 */   // Label 3928: @200860
     /*  200860 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(200901), // Rule ID 988 //
     /*  200865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200882 */     // MIs[0] rs1
     /*  200882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200894 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  200899 */     GIR_RootConstrainSelectedInstOperands,
     /*  200900 */     // GIR_Coverage, 988,
     /*  200900 */     GIR_Done,
     /*  200901 */   // Label 3929: @200901
     /*  200901 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(200942), // Rule ID 990 //
     /*  200906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200909 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200916 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200923 */     // MIs[0] rs1
     /*  200923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200935 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  200940 */     GIR_RootConstrainSelectedInstOperands,
     /*  200941 */     // GIR_Coverage, 990,
     /*  200941 */     GIR_Done,
     /*  200942 */   // Label 3930: @200942
     /*  200942 */   GIM_Reject,
     /*  200943 */ // Label 3900: @200943
     /*  200943 */ GIM_Reject,
     /*  200944 */ // Label 3898: @200944
     /*  200944 */ GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(202593),
     /*  200949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  200952 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(200993), // Rule ID 443 //
     /*  200957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200960 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200967 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200974 */     // MIs[0] rs1
     /*  200974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200986 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  200991 */     GIR_RootConstrainSelectedInstOperands,
     /*  200992 */     // GIR_Coverage, 443,
     /*  200992 */     GIR_Done,
     /*  200993 */   // Label 3932: @200993
     /*  200993 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(201034), // Rule ID 445 //
     /*  200998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  201001 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201008 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201015 */     // MIs[0] rs1
     /*  201015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201027 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  201032 */     GIR_RootConstrainSelectedInstOperands,
     /*  201033 */     // GIR_Coverage, 445,
     /*  201033 */     GIR_Done,
     /*  201034 */   // Label 3933: @201034
     /*  201034 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(201075), // Rule ID 447 //
     /*  201039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  201042 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201049 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201056 */     // MIs[0] rs1
     /*  201056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201068 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  201073 */     GIR_RootConstrainSelectedInstOperands,
     /*  201074 */     // GIR_Coverage, 447,
     /*  201074 */     GIR_Done,
     /*  201075 */   // Label 3934: @201075
     /*  201075 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(201116), // Rule ID 449 //
     /*  201080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  201083 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201090 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201097 */     // MIs[0] rs1
     /*  201097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201109 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201109 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  201114 */     GIR_RootConstrainSelectedInstOperands,
     /*  201115 */     // GIR_Coverage, 449,
     /*  201115 */     GIR_Done,
     /*  201116 */   // Label 3935: @201116
     /*  201116 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(201157), // Rule ID 451 //
     /*  201121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  201124 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201131 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201138 */     // MIs[0] rs1
     /*  201138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201150 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  201155 */     GIR_RootConstrainSelectedInstOperands,
     /*  201156 */     // GIR_Coverage, 451,
     /*  201156 */     GIR_Done,
     /*  201157 */   // Label 3936: @201157
     /*  201157 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(201198), // Rule ID 453 //
     /*  201162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  201165 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201179 */     // MIs[0] rs1
     /*  201179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201191 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  201196 */     GIR_RootConstrainSelectedInstOperands,
     /*  201197 */     // GIR_Coverage, 453,
     /*  201197 */     GIR_Done,
     /*  201198 */   // Label 3937: @201198
     /*  201198 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(201239), // Rule ID 455 //
     /*  201203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  201206 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201213 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201220 */     // MIs[0] rs1
     /*  201220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201232 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  201237 */     GIR_RootConstrainSelectedInstOperands,
     /*  201238 */     // GIR_Coverage, 455,
     /*  201238 */     GIR_Done,
     /*  201239 */   // Label 3938: @201239
     /*  201239 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(201280), // Rule ID 457 //
     /*  201244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  201247 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201254 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201261 */     // MIs[0] rs1
     /*  201261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201273 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  201278 */     GIR_RootConstrainSelectedInstOperands,
     /*  201279 */     // GIR_Coverage, 457,
     /*  201279 */     GIR_Done,
     /*  201280 */   // Label 3939: @201280
     /*  201280 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(201321), // Rule ID 459 //
     /*  201285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  201288 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201295 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201302 */     // MIs[0] rs1
     /*  201302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201314 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  201319 */     GIR_RootConstrainSelectedInstOperands,
     /*  201320 */     // GIR_Coverage, 459,
     /*  201320 */     GIR_Done,
     /*  201321 */   // Label 3940: @201321
     /*  201321 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(201362), // Rule ID 461 //
     /*  201326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  201329 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201336 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201343 */     // MIs[0] rs1
     /*  201343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201355 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  201360 */     GIR_RootConstrainSelectedInstOperands,
     /*  201361 */     // GIR_Coverage, 461,
     /*  201361 */     GIR_Done,
     /*  201362 */   // Label 3941: @201362
     /*  201362 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(201403), // Rule ID 573 //
     /*  201367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201370 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201377 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201384 */     // MIs[0] rs1
     /*  201384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201396 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  201401 */     GIR_RootConstrainSelectedInstOperands,
     /*  201402 */     // GIR_Coverage, 573,
     /*  201402 */     GIR_Done,
     /*  201403 */   // Label 3942: @201403
     /*  201403 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(201444), // Rule ID 574 //
     /*  201408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201411 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201425 */     // MIs[0] rs1
     /*  201425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201437 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ),
     /*  201442 */     GIR_RootConstrainSelectedInstOperands,
     /*  201443 */     // GIR_Coverage, 574,
     /*  201443 */     GIR_Done,
     /*  201444 */   // Label 3943: @201444
     /*  201444 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(201485), // Rule ID 575 //
     /*  201449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201452 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201459 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201466 */     // MIs[0] rs1
     /*  201466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201478 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_RL),
     /*  201483 */     GIR_RootConstrainSelectedInstOperands,
     /*  201484 */     // GIR_Coverage, 575,
     /*  201484 */     GIR_Done,
     /*  201485 */   // Label 3944: @201485
     /*  201485 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(201526), // Rule ID 576 //
     /*  201490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201493 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201500 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201507 */     // MIs[0] rs1
     /*  201507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201519 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  201524 */     GIR_RootConstrainSelectedInstOperands,
     /*  201525 */     // GIR_Coverage, 576,
     /*  201525 */     GIR_Done,
     /*  201526 */   // Label 3945: @201526
     /*  201526 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(201567), // Rule ID 577 //
     /*  201531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201534 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201548 */     // MIs[0] rs1
     /*  201548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201560 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  201565 */     GIR_RootConstrainSelectedInstOperands,
     /*  201566 */     // GIR_Coverage, 577,
     /*  201566 */     GIR_Done,
     /*  201567 */   // Label 3946: @201567
     /*  201567 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(201608), // Rule ID 578 //
     /*  201572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201589 */     // MIs[0] rs1
     /*  201589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201601 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  201606 */     GIR_RootConstrainSelectedInstOperands,
     /*  201607 */     // GIR_Coverage, 578,
     /*  201607 */     GIR_Done,
     /*  201608 */   // Label 3947: @201608
     /*  201608 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(201649), // Rule ID 579 //
     /*  201613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201616 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201630 */     // MIs[0] rs1
     /*  201630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201642 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  201647 */     GIR_RootConstrainSelectedInstOperands,
     /*  201648 */     // GIR_Coverage, 579,
     /*  201648 */     GIR_Done,
     /*  201649 */   // Label 3948: @201649
     /*  201649 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(201690), // Rule ID 580 //
     /*  201654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201657 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201664 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201671 */     // MIs[0] rs1
     /*  201671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201683 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  201688 */     GIR_RootConstrainSelectedInstOperands,
     /*  201689 */     // GIR_Coverage, 580,
     /*  201689 */     GIR_Done,
     /*  201690 */   // Label 3949: @201690
     /*  201690 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(201731), // Rule ID 581 //
     /*  201695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201698 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201705 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201712 */     // MIs[0] rs1
     /*  201712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201724 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  201729 */     GIR_RootConstrainSelectedInstOperands,
     /*  201730 */     // GIR_Coverage, 581,
     /*  201730 */     GIR_Done,
     /*  201731 */   // Label 3950: @201731
     /*  201731 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(201772), // Rule ID 582 //
     /*  201736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201739 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201746 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201753 */     // MIs[0] rs1
     /*  201753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201765 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  201770 */     GIR_RootConstrainSelectedInstOperands,
     /*  201771 */     // GIR_Coverage, 582,
     /*  201771 */     GIR_Done,
     /*  201772 */   // Label 3951: @201772
     /*  201772 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(201813), // Rule ID 791 //
     /*  201777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201780 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201787 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201794 */     // MIs[0] rs1
     /*  201794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201806 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  201811 */     GIR_RootConstrainSelectedInstOperands,
     /*  201812 */     // GIR_Coverage, 791,
     /*  201812 */     GIR_Done,
     /*  201813 */   // Label 3952: @201813
     /*  201813 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(201854), // Rule ID 793 //
     /*  201818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201821 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201828 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201835 */     // MIs[0] rs1
     /*  201835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201847 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  201852 */     GIR_RootConstrainSelectedInstOperands,
     /*  201853 */     // GIR_Coverage, 793,
     /*  201853 */     GIR_Done,
     /*  201854 */   // Label 3953: @201854
     /*  201854 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(201895), // Rule ID 795 //
     /*  201859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201862 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201869 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201876 */     // MIs[0] rs1
     /*  201876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201888 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  201893 */     GIR_RootConstrainSelectedInstOperands,
     /*  201894 */     // GIR_Coverage, 795,
     /*  201894 */     GIR_Done,
     /*  201895 */   // Label 3954: @201895
     /*  201895 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(201936), // Rule ID 797 //
     /*  201900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201903 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201917 */     // MIs[0] rs1
     /*  201917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201929 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  201934 */     GIR_RootConstrainSelectedInstOperands,
     /*  201935 */     // GIR_Coverage, 797,
     /*  201935 */     GIR_Done,
     /*  201936 */   // Label 3955: @201936
     /*  201936 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(201977), // Rule ID 799 //
     /*  201941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201944 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201951 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201958 */     // MIs[0] rs1
     /*  201958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201970 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  201975 */     GIR_RootConstrainSelectedInstOperands,
     /*  201976 */     // GIR_Coverage, 799,
     /*  201976 */     GIR_Done,
     /*  201977 */   // Label 3956: @201977
     /*  201977 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(202018), // Rule ID 801 //
     /*  201982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201985 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201992 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201999 */     // MIs[0] rs1
     /*  201999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202011 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  202016 */     GIR_RootConstrainSelectedInstOperands,
     /*  202017 */     // GIR_Coverage, 801,
     /*  202017 */     GIR_Done,
     /*  202018 */   // Label 3957: @202018
     /*  202018 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(202059), // Rule ID 803 //
     /*  202023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202026 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202033 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202040 */     // MIs[0] rs1
     /*  202040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202052 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  202057 */     GIR_RootConstrainSelectedInstOperands,
     /*  202058 */     // GIR_Coverage, 803,
     /*  202058 */     GIR_Done,
     /*  202059 */   // Label 3958: @202059
     /*  202059 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(202100), // Rule ID 805 //
     /*  202064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202081 */     // MIs[0] rs1
     /*  202081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202093 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  202098 */     GIR_RootConstrainSelectedInstOperands,
     /*  202099 */     // GIR_Coverage, 805,
     /*  202099 */     GIR_Done,
     /*  202100 */   // Label 3959: @202100
     /*  202100 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(202141), // Rule ID 807 //
     /*  202105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202122 */     // MIs[0] rs1
     /*  202122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202134 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  202139 */     GIR_RootConstrainSelectedInstOperands,
     /*  202140 */     // GIR_Coverage, 807,
     /*  202140 */     GIR_Done,
     /*  202141 */   // Label 3960: @202141
     /*  202141 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(202182), // Rule ID 809 //
     /*  202146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202149 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202156 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202163 */     // MIs[0] rs1
     /*  202163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202175 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  202180 */     GIR_RootConstrainSelectedInstOperands,
     /*  202181 */     // GIR_Coverage, 809,
     /*  202181 */     GIR_Done,
     /*  202182 */   // Label 3961: @202182
     /*  202182 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(202223), // Rule ID 971 //
     /*  202187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  202190 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202204 */     // MIs[0] rs1
     /*  202204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202216 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  202221 */     GIR_RootConstrainSelectedInstOperands,
     /*  202222 */     // GIR_Coverage, 971,
     /*  202222 */     GIR_Done,
     /*  202223 */   // Label 3962: @202223
     /*  202223 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(202264), // Rule ID 973 //
     /*  202228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  202231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202245 */     // MIs[0] rs1
     /*  202245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202257 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  202262 */     GIR_RootConstrainSelectedInstOperands,
     /*  202263 */     // GIR_Coverage, 973,
     /*  202263 */     GIR_Done,
     /*  202264 */   // Label 3963: @202264
     /*  202264 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(202305), // Rule ID 975 //
     /*  202269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  202272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202286 */     // MIs[0] rs1
     /*  202286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202298 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  202303 */     GIR_RootConstrainSelectedInstOperands,
     /*  202304 */     // GIR_Coverage, 975,
     /*  202304 */     GIR_Done,
     /*  202305 */   // Label 3964: @202305
     /*  202305 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(202346), // Rule ID 977 //
     /*  202310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  202313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202327 */     // MIs[0] rs1
     /*  202327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202339 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  202344 */     GIR_RootConstrainSelectedInstOperands,
     /*  202345 */     // GIR_Coverage, 977,
     /*  202345 */     GIR_Done,
     /*  202346 */   // Label 3965: @202346
     /*  202346 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(202387), // Rule ID 979 //
     /*  202351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  202354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202368 */     // MIs[0] rs1
     /*  202368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202380 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  202385 */     GIR_RootConstrainSelectedInstOperands,
     /*  202386 */     // GIR_Coverage, 979,
     /*  202386 */     GIR_Done,
     /*  202387 */   // Label 3966: @202387
     /*  202387 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(202428), // Rule ID 981 //
     /*  202392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202409 */     // MIs[0] rs1
     /*  202409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202421 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  202426 */     GIR_RootConstrainSelectedInstOperands,
     /*  202427 */     // GIR_Coverage, 981,
     /*  202427 */     GIR_Done,
     /*  202428 */   // Label 3967: @202428
     /*  202428 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(202469), // Rule ID 983 //
     /*  202433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202450 */     // MIs[0] rs1
     /*  202450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202462 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  202467 */     GIR_RootConstrainSelectedInstOperands,
     /*  202468 */     // GIR_Coverage, 983,
     /*  202468 */     GIR_Done,
     /*  202469 */   // Label 3968: @202469
     /*  202469 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(202510), // Rule ID 985 //
     /*  202474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202477 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202484 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202491 */     // MIs[0] rs1
     /*  202491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202503 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  202508 */     GIR_RootConstrainSelectedInstOperands,
     /*  202509 */     // GIR_Coverage, 985,
     /*  202509 */     GIR_Done,
     /*  202510 */   // Label 3969: @202510
     /*  202510 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(202551), // Rule ID 987 //
     /*  202515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202532 */     // MIs[0] rs1
     /*  202532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202544 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  202549 */     GIR_RootConstrainSelectedInstOperands,
     /*  202550 */     // GIR_Coverage, 987,
     /*  202550 */     GIR_Done,
     /*  202551 */   // Label 3970: @202551
     /*  202551 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(202592), // Rule ID 989 //
     /*  202556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202573 */     // MIs[0] rs1
     /*  202573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202585 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  202590 */     GIR_RootConstrainSelectedInstOperands,
     /*  202591 */     // GIR_Coverage, 989,
     /*  202591 */     GIR_Done,
     /*  202592 */   // Label 3971: @202592
     /*  202592 */   GIM_Reject,
     /*  202593 */ // Label 3931: @202593
     /*  202593 */ GIM_Reject,
     /*  202594 */ // Label 3899: @202594
     /*  202594 */ GIM_Reject,
     /*  202595 */ // Label 33: @202595
     /*  202595 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3974*/ GIMT_Encode4(205504),
     /*  202606 */ /*GILLT_s32*//*Label 3972*/ GIMT_Encode4(202614),
     /*  202610 */ /*GILLT_s64*//*Label 3973*/ GIMT_Encode4(203854),
     /*  202614 */ // Label 3972: @202614
     /*  202614 */ GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(203853),
     /*  202619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  202622 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(202663), // Rule ID 464 //
     /*  202627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202644 */     // MIs[0] rs1
     /*  202644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202656 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  202661 */     GIR_RootConstrainSelectedInstOperands,
     /*  202662 */     // GIR_Coverage, 464,
     /*  202662 */     GIR_Done,
     /*  202663 */   // Label 3976: @202663
     /*  202663 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(202704), // Rule ID 466 //
     /*  202668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202685 */     // MIs[0] rs1
     /*  202685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202697 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  202702 */     GIR_RootConstrainSelectedInstOperands,
     /*  202703 */     // GIR_Coverage, 466,
     /*  202703 */     GIR_Done,
     /*  202704 */   // Label 3977: @202704
     /*  202704 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(202745), // Rule ID 468 //
     /*  202709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202726 */     // MIs[0] rs1
     /*  202726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202738 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  202743 */     GIR_RootConstrainSelectedInstOperands,
     /*  202744 */     // GIR_Coverage, 468,
     /*  202744 */     GIR_Done,
     /*  202745 */   // Label 3978: @202745
     /*  202745 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(202786), // Rule ID 470 //
     /*  202750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202767 */     // MIs[0] rs1
     /*  202767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202779 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  202784 */     GIR_RootConstrainSelectedInstOperands,
     /*  202785 */     // GIR_Coverage, 470,
     /*  202785 */     GIR_Done,
     /*  202786 */   // Label 3979: @202786
     /*  202786 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(202827), // Rule ID 472 //
     /*  202791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202794 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202808 */     // MIs[0] rs1
     /*  202808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202820 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  202825 */     GIR_RootConstrainSelectedInstOperands,
     /*  202826 */     // GIR_Coverage, 472,
     /*  202826 */     GIR_Done,
     /*  202827 */   // Label 3980: @202827
     /*  202827 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(202868), // Rule ID 474 //
     /*  202832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202849 */     // MIs[0] rs1
     /*  202849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202861 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  202866 */     GIR_RootConstrainSelectedInstOperands,
     /*  202867 */     // GIR_Coverage, 474,
     /*  202867 */     GIR_Done,
     /*  202868 */   // Label 3981: @202868
     /*  202868 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(202909), // Rule ID 476 //
     /*  202873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202890 */     // MIs[0] rs1
     /*  202890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202902 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  202907 */     GIR_RootConstrainSelectedInstOperands,
     /*  202908 */     // GIR_Coverage, 476,
     /*  202908 */     GIR_Done,
     /*  202909 */   // Label 3982: @202909
     /*  202909 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(202950), // Rule ID 478 //
     /*  202914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202924 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202931 */     // MIs[0] rs1
     /*  202931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202943 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  202948 */     GIR_RootConstrainSelectedInstOperands,
     /*  202949 */     // GIR_Coverage, 478,
     /*  202949 */     GIR_Done,
     /*  202950 */   // Label 3983: @202950
     /*  202950 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(202991), // Rule ID 480 //
     /*  202955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202972 */     // MIs[0] rs1
     /*  202972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202984 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  202989 */     GIR_RootConstrainSelectedInstOperands,
     /*  202990 */     // GIR_Coverage, 480,
     /*  202990 */     GIR_Done,
     /*  202991 */   // Label 3984: @202991
     /*  202991 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(203032), // Rule ID 482 //
     /*  202996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203006 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203013 */     // MIs[0] rs1
     /*  203013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203025 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  203030 */     GIR_RootConstrainSelectedInstOperands,
     /*  203031 */     // GIR_Coverage, 482,
     /*  203031 */     GIR_Done,
     /*  203032 */   // Label 3985: @203032
     /*  203032 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(203073), // Rule ID 812 //
     /*  203037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203040 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203047 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203054 */     // MIs[0] rs1
     /*  203054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203066 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  203071 */     GIR_RootConstrainSelectedInstOperands,
     /*  203072 */     // GIR_Coverage, 812,
     /*  203072 */     GIR_Done,
     /*  203073 */   // Label 3986: @203073
     /*  203073 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(203114), // Rule ID 814 //
     /*  203078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203095 */     // MIs[0] rs1
     /*  203095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203107 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  203112 */     GIR_RootConstrainSelectedInstOperands,
     /*  203113 */     // GIR_Coverage, 814,
     /*  203113 */     GIR_Done,
     /*  203114 */   // Label 3987: @203114
     /*  203114 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(203155), // Rule ID 816 //
     /*  203119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203122 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203129 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203136 */     // MIs[0] rs1
     /*  203136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203148 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  203153 */     GIR_RootConstrainSelectedInstOperands,
     /*  203154 */     // GIR_Coverage, 816,
     /*  203154 */     GIR_Done,
     /*  203155 */   // Label 3988: @203155
     /*  203155 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(203196), // Rule ID 818 //
     /*  203160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203163 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203177 */     // MIs[0] rs1
     /*  203177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203189 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  203194 */     GIR_RootConstrainSelectedInstOperands,
     /*  203195 */     // GIR_Coverage, 818,
     /*  203195 */     GIR_Done,
     /*  203196 */   // Label 3989: @203196
     /*  203196 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(203237), // Rule ID 820 //
     /*  203201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203204 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203211 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203218 */     // MIs[0] rs1
     /*  203218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203230 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  203235 */     GIR_RootConstrainSelectedInstOperands,
     /*  203236 */     // GIR_Coverage, 820,
     /*  203236 */     GIR_Done,
     /*  203237 */   // Label 3990: @203237
     /*  203237 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(203278), // Rule ID 822 //
     /*  203242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203259 */     // MIs[0] rs1
     /*  203259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203271 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  203276 */     GIR_RootConstrainSelectedInstOperands,
     /*  203277 */     // GIR_Coverage, 822,
     /*  203277 */     GIR_Done,
     /*  203278 */   // Label 3991: @203278
     /*  203278 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(203319), // Rule ID 824 //
     /*  203283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203286 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203293 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203300 */     // MIs[0] rs1
     /*  203300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203312 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  203317 */     GIR_RootConstrainSelectedInstOperands,
     /*  203318 */     // GIR_Coverage, 824,
     /*  203318 */     GIR_Done,
     /*  203319 */   // Label 3992: @203319
     /*  203319 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(203360), // Rule ID 826 //
     /*  203324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203327 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203334 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203341 */     // MIs[0] rs1
     /*  203341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203353 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  203358 */     GIR_RootConstrainSelectedInstOperands,
     /*  203359 */     // GIR_Coverage, 826,
     /*  203359 */     GIR_Done,
     /*  203360 */   // Label 3993: @203360
     /*  203360 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(203401), // Rule ID 828 //
     /*  203365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203382 */     // MIs[0] rs1
     /*  203382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203394 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  203399 */     GIR_RootConstrainSelectedInstOperands,
     /*  203400 */     // GIR_Coverage, 828,
     /*  203400 */     GIR_Done,
     /*  203401 */   // Label 3994: @203401
     /*  203401 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(203442), // Rule ID 830 //
     /*  203406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203423 */     // MIs[0] rs1
     /*  203423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203435 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  203440 */     GIR_RootConstrainSelectedInstOperands,
     /*  203441 */     // GIR_Coverage, 830,
     /*  203441 */     GIR_Done,
     /*  203442 */   // Label 3995: @203442
     /*  203442 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(203483), // Rule ID 992 //
     /*  203447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203464 */     // MIs[0] rs1
     /*  203464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203476 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  203481 */     GIR_RootConstrainSelectedInstOperands,
     /*  203482 */     // GIR_Coverage, 992,
     /*  203482 */     GIR_Done,
     /*  203483 */   // Label 3996: @203483
     /*  203483 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(203524), // Rule ID 994 //
     /*  203488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203505 */     // MIs[0] rs1
     /*  203505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203517 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  203522 */     GIR_RootConstrainSelectedInstOperands,
     /*  203523 */     // GIR_Coverage, 994,
     /*  203523 */     GIR_Done,
     /*  203524 */   // Label 3997: @203524
     /*  203524 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(203565), // Rule ID 996 //
     /*  203529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203546 */     // MIs[0] rs1
     /*  203546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203558 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  203563 */     GIR_RootConstrainSelectedInstOperands,
     /*  203564 */     // GIR_Coverage, 996,
     /*  203564 */     GIR_Done,
     /*  203565 */   // Label 3998: @203565
     /*  203565 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(203606), // Rule ID 998 //
     /*  203570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203587 */     // MIs[0] rs1
     /*  203587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203599 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  203604 */     GIR_RootConstrainSelectedInstOperands,
     /*  203605 */     // GIR_Coverage, 998,
     /*  203605 */     GIR_Done,
     /*  203606 */   // Label 3999: @203606
     /*  203606 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(203647), // Rule ID 1000 //
     /*  203611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203628 */     // MIs[0] rs1
     /*  203628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203640 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  203645 */     GIR_RootConstrainSelectedInstOperands,
     /*  203646 */     // GIR_Coverage, 1000,
     /*  203646 */     GIR_Done,
     /*  203647 */   // Label 4000: @203647
     /*  203647 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(203688), // Rule ID 1002 //
     /*  203652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203669 */     // MIs[0] rs1
     /*  203669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203681 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  203686 */     GIR_RootConstrainSelectedInstOperands,
     /*  203687 */     // GIR_Coverage, 1002,
     /*  203687 */     GIR_Done,
     /*  203688 */   // Label 4001: @203688
     /*  203688 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(203729), // Rule ID 1004 //
     /*  203693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203703 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203710 */     // MIs[0] rs1
     /*  203710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203722 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  203727 */     GIR_RootConstrainSelectedInstOperands,
     /*  203728 */     // GIR_Coverage, 1004,
     /*  203728 */     GIR_Done,
     /*  203729 */   // Label 4002: @203729
     /*  203729 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(203770), // Rule ID 1006 //
     /*  203734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203751 */     // MIs[0] rs1
     /*  203751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203763 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  203768 */     GIR_RootConstrainSelectedInstOperands,
     /*  203769 */     // GIR_Coverage, 1006,
     /*  203769 */     GIR_Done,
     /*  203770 */   // Label 4003: @203770
     /*  203770 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(203811), // Rule ID 1008 //
     /*  203775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203792 */     // MIs[0] rs1
     /*  203792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203804 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  203809 */     GIR_RootConstrainSelectedInstOperands,
     /*  203810 */     // GIR_Coverage, 1008,
     /*  203810 */     GIR_Done,
     /*  203811 */   // Label 4004: @203811
     /*  203811 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(203852), // Rule ID 1010 //
     /*  203816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203819 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203833 */     // MIs[0] rs1
     /*  203833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203845 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  203850 */     GIR_RootConstrainSelectedInstOperands,
     /*  203851 */     // GIR_Coverage, 1010,
     /*  203851 */     GIR_Done,
     /*  203852 */   // Label 4005: @203852
     /*  203852 */   GIM_Reject,
     /*  203853 */ // Label 3975: @203853
     /*  203853 */ GIM_Reject,
     /*  203854 */ // Label 3973: @203854
     /*  203854 */ GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(205503),
     /*  203859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  203862 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(203903), // Rule ID 463 //
     /*  203867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203870 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203884 */     // MIs[0] rs1
     /*  203884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203896 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  203901 */     GIR_RootConstrainSelectedInstOperands,
     /*  203902 */     // GIR_Coverage, 463,
     /*  203902 */     GIR_Done,
     /*  203903 */   // Label 4007: @203903
     /*  203903 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(203944), // Rule ID 465 //
     /*  203908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203911 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203918 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203925 */     // MIs[0] rs1
     /*  203925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203937 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  203942 */     GIR_RootConstrainSelectedInstOperands,
     /*  203943 */     // GIR_Coverage, 465,
     /*  203943 */     GIR_Done,
     /*  203944 */   // Label 4008: @203944
     /*  203944 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(203985), // Rule ID 467 //
     /*  203949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203952 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203959 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203966 */     // MIs[0] rs1
     /*  203966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203978 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  203983 */     GIR_RootConstrainSelectedInstOperands,
     /*  203984 */     // GIR_Coverage, 467,
     /*  203984 */     GIR_Done,
     /*  203985 */   // Label 4009: @203985
     /*  203985 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(204026), // Rule ID 469 //
     /*  203990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204007 */     // MIs[0] rs1
     /*  204007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204019 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  204024 */     GIR_RootConstrainSelectedInstOperands,
     /*  204025 */     // GIR_Coverage, 469,
     /*  204025 */     GIR_Done,
     /*  204026 */   // Label 4010: @204026
     /*  204026 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(204067), // Rule ID 471 //
     /*  204031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  204034 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204041 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204048 */     // MIs[0] rs1
     /*  204048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204060 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  204065 */     GIR_RootConstrainSelectedInstOperands,
     /*  204066 */     // GIR_Coverage, 471,
     /*  204066 */     GIR_Done,
     /*  204067 */   // Label 4011: @204067
     /*  204067 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(204108), // Rule ID 473 //
     /*  204072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  204075 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204082 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204089 */     // MIs[0] rs1
     /*  204089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204101 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  204106 */     GIR_RootConstrainSelectedInstOperands,
     /*  204107 */     // GIR_Coverage, 473,
     /*  204107 */     GIR_Done,
     /*  204108 */   // Label 4012: @204108
     /*  204108 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(204149), // Rule ID 475 //
     /*  204113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  204116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204130 */     // MIs[0] rs1
     /*  204130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204142 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  204147 */     GIR_RootConstrainSelectedInstOperands,
     /*  204148 */     // GIR_Coverage, 475,
     /*  204148 */     GIR_Done,
     /*  204149 */   // Label 4013: @204149
     /*  204149 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(204190), // Rule ID 477 //
     /*  204154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  204157 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204171 */     // MIs[0] rs1
     /*  204171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204183 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  204188 */     GIR_RootConstrainSelectedInstOperands,
     /*  204189 */     // GIR_Coverage, 477,
     /*  204189 */     GIR_Done,
     /*  204190 */   // Label 4014: @204190
     /*  204190 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(204231), // Rule ID 479 //
     /*  204195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  204198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204212 */     // MIs[0] rs1
     /*  204212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204224 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  204229 */     GIR_RootConstrainSelectedInstOperands,
     /*  204230 */     // GIR_Coverage, 479,
     /*  204230 */     GIR_Done,
     /*  204231 */   // Label 4015: @204231
     /*  204231 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(204272), // Rule ID 481 //
     /*  204236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  204239 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204246 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204253 */     // MIs[0] rs1
     /*  204253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204265 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  204270 */     GIR_RootConstrainSelectedInstOperands,
     /*  204271 */     // GIR_Coverage, 481,
     /*  204271 */     GIR_Done,
     /*  204272 */   // Label 4016: @204272
     /*  204272 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(204313), // Rule ID 583 //
     /*  204277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  204280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204294 */     // MIs[0] rs1
     /*  204294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204306 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  204311 */     GIR_RootConstrainSelectedInstOperands,
     /*  204312 */     // GIR_Coverage, 583,
     /*  204312 */     GIR_Done,
     /*  204313 */   // Label 4017: @204313
     /*  204313 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(204354), // Rule ID 584 //
     /*  204318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  204321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204328 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204335 */     // MIs[0] rs1
     /*  204335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204347 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ),
     /*  204352 */     GIR_RootConstrainSelectedInstOperands,
     /*  204353 */     // GIR_Coverage, 584,
     /*  204353 */     GIR_Done,
     /*  204354 */   // Label 4018: @204354
     /*  204354 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(204395), // Rule ID 585 //
     /*  204359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  204362 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204376 */     // MIs[0] rs1
     /*  204376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204388 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_RL),
     /*  204393 */     GIR_RootConstrainSelectedInstOperands,
     /*  204394 */     // GIR_Coverage, 585,
     /*  204394 */     GIR_Done,
     /*  204395 */   // Label 4019: @204395
     /*  204395 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(204436), // Rule ID 586 //
     /*  204400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  204403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204417 */     // MIs[0] rs1
     /*  204417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204429 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  204434 */     GIR_RootConstrainSelectedInstOperands,
     /*  204435 */     // GIR_Coverage, 586,
     /*  204435 */     GIR_Done,
     /*  204436 */   // Label 4020: @204436
     /*  204436 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(204477), // Rule ID 587 //
     /*  204441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  204444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204458 */     // MIs[0] rs1
     /*  204458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204470 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  204475 */     GIR_RootConstrainSelectedInstOperands,
     /*  204476 */     // GIR_Coverage, 587,
     /*  204476 */     GIR_Done,
     /*  204477 */   // Label 4021: @204477
     /*  204477 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(204518), // Rule ID 588 //
     /*  204482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204499 */     // MIs[0] rs1
     /*  204499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204511 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  204516 */     GIR_RootConstrainSelectedInstOperands,
     /*  204517 */     // GIR_Coverage, 588,
     /*  204517 */     GIR_Done,
     /*  204518 */   // Label 4022: @204518
     /*  204518 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(204559), // Rule ID 589 //
     /*  204523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204526 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204540 */     // MIs[0] rs1
     /*  204540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204552 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  204557 */     GIR_RootConstrainSelectedInstOperands,
     /*  204558 */     // GIR_Coverage, 589,
     /*  204558 */     GIR_Done,
     /*  204559 */   // Label 4023: @204559
     /*  204559 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(204600), // Rule ID 590 //
     /*  204564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204567 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204581 */     // MIs[0] rs1
     /*  204581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204593 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  204598 */     GIR_RootConstrainSelectedInstOperands,
     /*  204599 */     // GIR_Coverage, 590,
     /*  204599 */     GIR_Done,
     /*  204600 */   // Label 4024: @204600
     /*  204600 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(204641), // Rule ID 591 //
     /*  204605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204622 */     // MIs[0] rs1
     /*  204622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204634 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  204639 */     GIR_RootConstrainSelectedInstOperands,
     /*  204640 */     // GIR_Coverage, 591,
     /*  204640 */     GIR_Done,
     /*  204641 */   // Label 4025: @204641
     /*  204641 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(204682), // Rule ID 592 //
     /*  204646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204649 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204656 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204663 */     // MIs[0] rs1
     /*  204663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204675 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  204680 */     GIR_RootConstrainSelectedInstOperands,
     /*  204681 */     // GIR_Coverage, 592,
     /*  204681 */     GIR_Done,
     /*  204682 */   // Label 4026: @204682
     /*  204682 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(204723), // Rule ID 811 //
     /*  204687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204690 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204697 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204704 */     // MIs[0] rs1
     /*  204704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204716 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  204721 */     GIR_RootConstrainSelectedInstOperands,
     /*  204722 */     // GIR_Coverage, 811,
     /*  204722 */     GIR_Done,
     /*  204723 */   // Label 4027: @204723
     /*  204723 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(204764), // Rule ID 813 //
     /*  204728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204731 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204738 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204745 */     // MIs[0] rs1
     /*  204745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204757 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  204762 */     GIR_RootConstrainSelectedInstOperands,
     /*  204763 */     // GIR_Coverage, 813,
     /*  204763 */     GIR_Done,
     /*  204764 */   // Label 4028: @204764
     /*  204764 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(204805), // Rule ID 815 //
     /*  204769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204772 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204786 */     // MIs[0] rs1
     /*  204786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204798 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  204803 */     GIR_RootConstrainSelectedInstOperands,
     /*  204804 */     // GIR_Coverage, 815,
     /*  204804 */     GIR_Done,
     /*  204805 */   // Label 4029: @204805
     /*  204805 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(204846), // Rule ID 817 //
     /*  204810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204827 */     // MIs[0] rs1
     /*  204827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204839 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  204844 */     GIR_RootConstrainSelectedInstOperands,
     /*  204845 */     // GIR_Coverage, 817,
     /*  204845 */     GIR_Done,
     /*  204846 */   // Label 4030: @204846
     /*  204846 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(204887), // Rule ID 819 //
     /*  204851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204854 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204868 */     // MIs[0] rs1
     /*  204868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204880 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  204885 */     GIR_RootConstrainSelectedInstOperands,
     /*  204886 */     // GIR_Coverage, 819,
     /*  204886 */     GIR_Done,
     /*  204887 */   // Label 4031: @204887
     /*  204887 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(204928), // Rule ID 821 //
     /*  204892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204895 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204909 */     // MIs[0] rs1
     /*  204909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204921 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  204926 */     GIR_RootConstrainSelectedInstOperands,
     /*  204927 */     // GIR_Coverage, 821,
     /*  204927 */     GIR_Done,
     /*  204928 */   // Label 4032: @204928
     /*  204928 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(204969), // Rule ID 823 //
     /*  204933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204936 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204950 */     // MIs[0] rs1
     /*  204950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204962 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  204967 */     GIR_RootConstrainSelectedInstOperands,
     /*  204968 */     // GIR_Coverage, 823,
     /*  204968 */     GIR_Done,
     /*  204969 */   // Label 4033: @204969
     /*  204969 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(205010), // Rule ID 825 //
     /*  204974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204977 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204991 */     // MIs[0] rs1
     /*  204991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205003 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  205008 */     GIR_RootConstrainSelectedInstOperands,
     /*  205009 */     // GIR_Coverage, 825,
     /*  205009 */     GIR_Done,
     /*  205010 */   // Label 4034: @205010
     /*  205010 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(205051), // Rule ID 827 //
     /*  205015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205032 */     // MIs[0] rs1
     /*  205032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205044 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  205049 */     GIR_RootConstrainSelectedInstOperands,
     /*  205050 */     // GIR_Coverage, 827,
     /*  205050 */     GIR_Done,
     /*  205051 */   // Label 4035: @205051
     /*  205051 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(205092), // Rule ID 829 //
     /*  205056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205073 */     // MIs[0] rs1
     /*  205073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205085 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  205090 */     GIR_RootConstrainSelectedInstOperands,
     /*  205091 */     // GIR_Coverage, 829,
     /*  205091 */     GIR_Done,
     /*  205092 */   // Label 4036: @205092
     /*  205092 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(205133), // Rule ID 991 //
     /*  205097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  205100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205114 */     // MIs[0] rs1
     /*  205114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205126 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  205131 */     GIR_RootConstrainSelectedInstOperands,
     /*  205132 */     // GIR_Coverage, 991,
     /*  205132 */     GIR_Done,
     /*  205133 */   // Label 4037: @205133
     /*  205133 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(205174), // Rule ID 993 //
     /*  205138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  205141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205148 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205155 */     // MIs[0] rs1
     /*  205155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205167 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  205172 */     GIR_RootConstrainSelectedInstOperands,
     /*  205173 */     // GIR_Coverage, 993,
     /*  205173 */     GIR_Done,
     /*  205174 */   // Label 4038: @205174
     /*  205174 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(205215), // Rule ID 995 //
     /*  205179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  205182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205196 */     // MIs[0] rs1
     /*  205196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205208 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  205213 */     GIR_RootConstrainSelectedInstOperands,
     /*  205214 */     // GIR_Coverage, 995,
     /*  205214 */     GIR_Done,
     /*  205215 */   // Label 4039: @205215
     /*  205215 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(205256), // Rule ID 997 //
     /*  205220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  205223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205237 */     // MIs[0] rs1
     /*  205237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205249 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  205254 */     GIR_RootConstrainSelectedInstOperands,
     /*  205255 */     // GIR_Coverage, 997,
     /*  205255 */     GIR_Done,
     /*  205256 */   // Label 4040: @205256
     /*  205256 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(205297), // Rule ID 999 //
     /*  205261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  205264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205278 */     // MIs[0] rs1
     /*  205278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205290 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  205295 */     GIR_RootConstrainSelectedInstOperands,
     /*  205296 */     // GIR_Coverage, 999,
     /*  205296 */     GIR_Done,
     /*  205297 */   // Label 4041: @205297
     /*  205297 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(205338), // Rule ID 1001 //
     /*  205302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205305 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205319 */     // MIs[0] rs1
     /*  205319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205331 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  205336 */     GIR_RootConstrainSelectedInstOperands,
     /*  205337 */     // GIR_Coverage, 1001,
     /*  205337 */     GIR_Done,
     /*  205338 */   // Label 4042: @205338
     /*  205338 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(205379), // Rule ID 1003 //
     /*  205343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205360 */     // MIs[0] rs1
     /*  205360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205372 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  205377 */     GIR_RootConstrainSelectedInstOperands,
     /*  205378 */     // GIR_Coverage, 1003,
     /*  205378 */     GIR_Done,
     /*  205379 */   // Label 4043: @205379
     /*  205379 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(205420), // Rule ID 1005 //
     /*  205384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205401 */     // MIs[0] rs1
     /*  205401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205413 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  205418 */     GIR_RootConstrainSelectedInstOperands,
     /*  205419 */     // GIR_Coverage, 1005,
     /*  205419 */     GIR_Done,
     /*  205420 */   // Label 4044: @205420
     /*  205420 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(205461), // Rule ID 1007 //
     /*  205425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205442 */     // MIs[0] rs1
     /*  205442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205454 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  205459 */     GIR_RootConstrainSelectedInstOperands,
     /*  205460 */     // GIR_Coverage, 1007,
     /*  205460 */     GIR_Done,
     /*  205461 */   // Label 4045: @205461
     /*  205461 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(205502), // Rule ID 1009 //
     /*  205466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205483 */     // MIs[0] rs1
     /*  205483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205495 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  205500 */     GIR_RootConstrainSelectedInstOperands,
     /*  205501 */     // GIR_Coverage, 1009,
     /*  205501 */     GIR_Done,
     /*  205502 */   // Label 4046: @205502
     /*  205502 */   GIM_Reject,
     /*  205503 */ // Label 4006: @205503
     /*  205503 */ GIM_Reject,
     /*  205504 */ // Label 3974: @205504
     /*  205504 */ GIM_Reject,
     /*  205505 */ // Label 34: @205505
     /*  205505 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4049*/ GIMT_Encode4(208414),
     /*  205516 */ /*GILLT_s32*//*Label 4047*/ GIMT_Encode4(205524),
     /*  205520 */ /*GILLT_s64*//*Label 4048*/ GIMT_Encode4(206764),
     /*  205524 */ // Label 4047: @205524
     /*  205524 */ GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(206763),
     /*  205529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  205532 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(205573), // Rule ID 484 //
     /*  205537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205554 */     // MIs[0] rs1
     /*  205554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205566 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  205571 */     GIR_RootConstrainSelectedInstOperands,
     /*  205572 */     // GIR_Coverage, 484,
     /*  205572 */     GIR_Done,
     /*  205573 */   // Label 4051: @205573
     /*  205573 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(205614), // Rule ID 486 //
     /*  205578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205595 */     // MIs[0] rs1
     /*  205595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205607 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  205612 */     GIR_RootConstrainSelectedInstOperands,
     /*  205613 */     // GIR_Coverage, 486,
     /*  205613 */     GIR_Done,
     /*  205614 */   // Label 4052: @205614
     /*  205614 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(205655), // Rule ID 488 //
     /*  205619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205636 */     // MIs[0] rs1
     /*  205636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205648 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  205653 */     GIR_RootConstrainSelectedInstOperands,
     /*  205654 */     // GIR_Coverage, 488,
     /*  205654 */     GIR_Done,
     /*  205655 */   // Label 4053: @205655
     /*  205655 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(205696), // Rule ID 490 //
     /*  205660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205677 */     // MIs[0] rs1
     /*  205677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205689 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  205694 */     GIR_RootConstrainSelectedInstOperands,
     /*  205695 */     // GIR_Coverage, 490,
     /*  205695 */     GIR_Done,
     /*  205696 */   // Label 4054: @205696
     /*  205696 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(205737), // Rule ID 492 //
     /*  205701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205711 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205718 */     // MIs[0] rs1
     /*  205718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205730 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  205735 */     GIR_RootConstrainSelectedInstOperands,
     /*  205736 */     // GIR_Coverage, 492,
     /*  205736 */     GIR_Done,
     /*  205737 */   // Label 4055: @205737
     /*  205737 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(205778), // Rule ID 494 //
     /*  205742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205745 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205752 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205759 */     // MIs[0] rs1
     /*  205759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205771 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  205776 */     GIR_RootConstrainSelectedInstOperands,
     /*  205777 */     // GIR_Coverage, 494,
     /*  205777 */     GIR_Done,
     /*  205778 */   // Label 4056: @205778
     /*  205778 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(205819), // Rule ID 496 //
     /*  205783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205800 */     // MIs[0] rs1
     /*  205800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205812 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  205817 */     GIR_RootConstrainSelectedInstOperands,
     /*  205818 */     // GIR_Coverage, 496,
     /*  205818 */     GIR_Done,
     /*  205819 */   // Label 4057: @205819
     /*  205819 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(205860), // Rule ID 498 //
     /*  205824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205841 */     // MIs[0] rs1
     /*  205841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205853 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  205858 */     GIR_RootConstrainSelectedInstOperands,
     /*  205859 */     // GIR_Coverage, 498,
     /*  205859 */     GIR_Done,
     /*  205860 */   // Label 4058: @205860
     /*  205860 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(205901), // Rule ID 500 //
     /*  205865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205882 */     // MIs[0] rs1
     /*  205882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205894 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  205899 */     GIR_RootConstrainSelectedInstOperands,
     /*  205900 */     // GIR_Coverage, 500,
     /*  205900 */     GIR_Done,
     /*  205901 */   // Label 4059: @205901
     /*  205901 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(205942), // Rule ID 502 //
     /*  205906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205909 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205916 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205923 */     // MIs[0] rs1
     /*  205923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205935 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  205940 */     GIR_RootConstrainSelectedInstOperands,
     /*  205941 */     // GIR_Coverage, 502,
     /*  205941 */     GIR_Done,
     /*  205942 */   // Label 4060: @205942
     /*  205942 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(205983), // Rule ID 832 //
     /*  205947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205964 */     // MIs[0] rs1
     /*  205964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205976 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  205981 */     GIR_RootConstrainSelectedInstOperands,
     /*  205982 */     // GIR_Coverage, 832,
     /*  205982 */     GIR_Done,
     /*  205983 */   // Label 4061: @205983
     /*  205983 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(206024), // Rule ID 834 //
     /*  205988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205998 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206005 */     // MIs[0] rs1
     /*  206005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206017 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  206022 */     GIR_RootConstrainSelectedInstOperands,
     /*  206023 */     // GIR_Coverage, 834,
     /*  206023 */     GIR_Done,
     /*  206024 */   // Label 4062: @206024
     /*  206024 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(206065), // Rule ID 836 //
     /*  206029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206032 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206039 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206046 */     // MIs[0] rs1
     /*  206046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206058 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  206063 */     GIR_RootConstrainSelectedInstOperands,
     /*  206064 */     // GIR_Coverage, 836,
     /*  206064 */     GIR_Done,
     /*  206065 */   // Label 4063: @206065
     /*  206065 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(206106), // Rule ID 838 //
     /*  206070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206087 */     // MIs[0] rs1
     /*  206087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206099 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  206104 */     GIR_RootConstrainSelectedInstOperands,
     /*  206105 */     // GIR_Coverage, 838,
     /*  206105 */     GIR_Done,
     /*  206106 */   // Label 4064: @206106
     /*  206106 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(206147), // Rule ID 840 //
     /*  206111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206121 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206128 */     // MIs[0] rs1
     /*  206128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206140 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  206145 */     GIR_RootConstrainSelectedInstOperands,
     /*  206146 */     // GIR_Coverage, 840,
     /*  206146 */     GIR_Done,
     /*  206147 */   // Label 4065: @206147
     /*  206147 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(206188), // Rule ID 842 //
     /*  206152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206169 */     // MIs[0] rs1
     /*  206169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206181 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  206186 */     GIR_RootConstrainSelectedInstOperands,
     /*  206187 */     // GIR_Coverage, 842,
     /*  206187 */     GIR_Done,
     /*  206188 */   // Label 4066: @206188
     /*  206188 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(206229), // Rule ID 844 //
     /*  206193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206196 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206203 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206210 */     // MIs[0] rs1
     /*  206210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206222 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  206227 */     GIR_RootConstrainSelectedInstOperands,
     /*  206228 */     // GIR_Coverage, 844,
     /*  206228 */     GIR_Done,
     /*  206229 */   // Label 4067: @206229
     /*  206229 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(206270), // Rule ID 846 //
     /*  206234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206237 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206244 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206251 */     // MIs[0] rs1
     /*  206251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206263 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  206268 */     GIR_RootConstrainSelectedInstOperands,
     /*  206269 */     // GIR_Coverage, 846,
     /*  206269 */     GIR_Done,
     /*  206270 */   // Label 4068: @206270
     /*  206270 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(206311), // Rule ID 848 //
     /*  206275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206292 */     // MIs[0] rs1
     /*  206292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206304 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  206309 */     GIR_RootConstrainSelectedInstOperands,
     /*  206310 */     // GIR_Coverage, 848,
     /*  206310 */     GIR_Done,
     /*  206311 */   // Label 4069: @206311
     /*  206311 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(206352), // Rule ID 850 //
     /*  206316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206319 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206333 */     // MIs[0] rs1
     /*  206333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206345 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  206350 */     GIR_RootConstrainSelectedInstOperands,
     /*  206351 */     // GIR_Coverage, 850,
     /*  206351 */     GIR_Done,
     /*  206352 */   // Label 4070: @206352
     /*  206352 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(206393), // Rule ID 1012 //
     /*  206357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206360 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206374 */     // MIs[0] rs1
     /*  206374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206386 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  206391 */     GIR_RootConstrainSelectedInstOperands,
     /*  206392 */     // GIR_Coverage, 1012,
     /*  206392 */     GIR_Done,
     /*  206393 */   // Label 4071: @206393
     /*  206393 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(206434), // Rule ID 1014 //
     /*  206398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206415 */     // MIs[0] rs1
     /*  206415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206427 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  206432 */     GIR_RootConstrainSelectedInstOperands,
     /*  206433 */     // GIR_Coverage, 1014,
     /*  206433 */     GIR_Done,
     /*  206434 */   // Label 4072: @206434
     /*  206434 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(206475), // Rule ID 1016 //
     /*  206439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206456 */     // MIs[0] rs1
     /*  206456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206468 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  206473 */     GIR_RootConstrainSelectedInstOperands,
     /*  206474 */     // GIR_Coverage, 1016,
     /*  206474 */     GIR_Done,
     /*  206475 */   // Label 4073: @206475
     /*  206475 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(206516), // Rule ID 1018 //
     /*  206480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206497 */     // MIs[0] rs1
     /*  206497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206509 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  206514 */     GIR_RootConstrainSelectedInstOperands,
     /*  206515 */     // GIR_Coverage, 1018,
     /*  206515 */     GIR_Done,
     /*  206516 */   // Label 4074: @206516
     /*  206516 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(206557), // Rule ID 1020 //
     /*  206521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206538 */     // MIs[0] rs1
     /*  206538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206550 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  206555 */     GIR_RootConstrainSelectedInstOperands,
     /*  206556 */     // GIR_Coverage, 1020,
     /*  206556 */     GIR_Done,
     /*  206557 */   // Label 4075: @206557
     /*  206557 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(206598), // Rule ID 1022 //
     /*  206562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206565 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206572 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206579 */     // MIs[0] rs1
     /*  206579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206591 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  206596 */     GIR_RootConstrainSelectedInstOperands,
     /*  206597 */     // GIR_Coverage, 1022,
     /*  206597 */     GIR_Done,
     /*  206598 */   // Label 4076: @206598
     /*  206598 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(206639), // Rule ID 1024 //
     /*  206603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206606 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206620 */     // MIs[0] rs1
     /*  206620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206632 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  206637 */     GIR_RootConstrainSelectedInstOperands,
     /*  206638 */     // GIR_Coverage, 1024,
     /*  206638 */     GIR_Done,
     /*  206639 */   // Label 4077: @206639
     /*  206639 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(206680), // Rule ID 1026 //
     /*  206644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206654 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206661 */     // MIs[0] rs1
     /*  206661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206673 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  206678 */     GIR_RootConstrainSelectedInstOperands,
     /*  206679 */     // GIR_Coverage, 1026,
     /*  206679 */     GIR_Done,
     /*  206680 */   // Label 4078: @206680
     /*  206680 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(206721), // Rule ID 1028 //
     /*  206685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206702 */     // MIs[0] rs1
     /*  206702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206714 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  206719 */     GIR_RootConstrainSelectedInstOperands,
     /*  206720 */     // GIR_Coverage, 1028,
     /*  206720 */     GIR_Done,
     /*  206721 */   // Label 4079: @206721
     /*  206721 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(206762), // Rule ID 1030 //
     /*  206726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206743 */     // MIs[0] rs1
     /*  206743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206755 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  206760 */     GIR_RootConstrainSelectedInstOperands,
     /*  206761 */     // GIR_Coverage, 1030,
     /*  206761 */     GIR_Done,
     /*  206762 */   // Label 4080: @206762
     /*  206762 */   GIM_Reject,
     /*  206763 */ // Label 4050: @206763
     /*  206763 */ GIM_Reject,
     /*  206764 */ // Label 4048: @206764
     /*  206764 */ GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(208413),
     /*  206769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  206772 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(206813), // Rule ID 483 //
     /*  206777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206780 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206787 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206794 */     // MIs[0] rs1
     /*  206794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206806 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  206811 */     GIR_RootConstrainSelectedInstOperands,
     /*  206812 */     // GIR_Coverage, 483,
     /*  206812 */     GIR_Done,
     /*  206813 */   // Label 4082: @206813
     /*  206813 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(206854), // Rule ID 485 //
     /*  206818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206821 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206828 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206835 */     // MIs[0] rs1
     /*  206835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206847 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  206852 */     GIR_RootConstrainSelectedInstOperands,
     /*  206853 */     // GIR_Coverage, 485,
     /*  206853 */     GIR_Done,
     /*  206854 */   // Label 4083: @206854
     /*  206854 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(206895), // Rule ID 487 //
     /*  206859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206862 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206869 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206876 */     // MIs[0] rs1
     /*  206876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206888 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  206893 */     GIR_RootConstrainSelectedInstOperands,
     /*  206894 */     // GIR_Coverage, 487,
     /*  206894 */     GIR_Done,
     /*  206895 */   // Label 4084: @206895
     /*  206895 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(206936), // Rule ID 489 //
     /*  206900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206903 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206917 */     // MIs[0] rs1
     /*  206917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206929 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  206934 */     GIR_RootConstrainSelectedInstOperands,
     /*  206935 */     // GIR_Coverage, 489,
     /*  206935 */     GIR_Done,
     /*  206936 */   // Label 4085: @206936
     /*  206936 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(206977), // Rule ID 491 //
     /*  206941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206944 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206951 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206958 */     // MIs[0] rs1
     /*  206958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206970 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  206975 */     GIR_RootConstrainSelectedInstOperands,
     /*  206976 */     // GIR_Coverage, 491,
     /*  206976 */     GIR_Done,
     /*  206977 */   // Label 4086: @206977
     /*  206977 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(207018), // Rule ID 493 //
     /*  206982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206985 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206992 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206999 */     // MIs[0] rs1
     /*  206999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207011 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  207016 */     GIR_RootConstrainSelectedInstOperands,
     /*  207017 */     // GIR_Coverage, 493,
     /*  207017 */     GIR_Done,
     /*  207018 */   // Label 4087: @207018
     /*  207018 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(207059), // Rule ID 495 //
     /*  207023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  207026 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  207033 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207040 */     // MIs[0] rs1
     /*  207040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207052 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  207057 */     GIR_RootConstrainSelectedInstOperands,
     /*  207058 */     // GIR_Coverage, 495,
     /*  207058 */     GIR_Done,
     /*  207059 */   // Label 4088: @207059
     /*  207059 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(207100), // Rule ID 497 //
     /*  207064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  207067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  207074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207081 */     // MIs[0] rs1
     /*  207081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207093 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  207098 */     GIR_RootConstrainSelectedInstOperands,
     /*  207099 */     // GIR_Coverage, 497,
     /*  207099 */     GIR_Done,
     /*  207100 */   // Label 4089: @207100
     /*  207100 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(207141), // Rule ID 499 //
     /*  207105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  207108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  207115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207122 */     // MIs[0] rs1
     /*  207122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207134 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  207139 */     GIR_RootConstrainSelectedInstOperands,
     /*  207140 */     // GIR_Coverage, 499,
     /*  207140 */     GIR_Done,
     /*  207141 */   // Label 4090: @207141
     /*  207141 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(207182), // Rule ID 501 //
     /*  207146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  207149 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  207156 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207163 */     // MIs[0] rs1
     /*  207163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207175 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  207180 */     GIR_RootConstrainSelectedInstOperands,
     /*  207181 */     // GIR_Coverage, 501,
     /*  207181 */     GIR_Done,
     /*  207182 */   // Label 4091: @207182
     /*  207182 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(207223), // Rule ID 593 //
     /*  207187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  207190 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207204 */     // MIs[0] rs1
     /*  207204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207216 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  207221 */     GIR_RootConstrainSelectedInstOperands,
     /*  207222 */     // GIR_Coverage, 593,
     /*  207222 */     GIR_Done,
     /*  207223 */   // Label 4092: @207223
     /*  207223 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(207264), // Rule ID 594 //
     /*  207228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  207231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207245 */     // MIs[0] rs1
     /*  207245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207257 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ),
     /*  207262 */     GIR_RootConstrainSelectedInstOperands,
     /*  207263 */     // GIR_Coverage, 594,
     /*  207263 */     GIR_Done,
     /*  207264 */   // Label 4093: @207264
     /*  207264 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(207305), // Rule ID 595 //
     /*  207269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  207272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207286 */     // MIs[0] rs1
     /*  207286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207298 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_RL),
     /*  207303 */     GIR_RootConstrainSelectedInstOperands,
     /*  207304 */     // GIR_Coverage, 595,
     /*  207304 */     GIR_Done,
     /*  207305 */   // Label 4094: @207305
     /*  207305 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(207346), // Rule ID 596 //
     /*  207310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  207313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207327 */     // MIs[0] rs1
     /*  207327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207339 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  207344 */     GIR_RootConstrainSelectedInstOperands,
     /*  207345 */     // GIR_Coverage, 596,
     /*  207345 */     GIR_Done,
     /*  207346 */   // Label 4095: @207346
     /*  207346 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(207387), // Rule ID 597 //
     /*  207351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  207354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207368 */     // MIs[0] rs1
     /*  207368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207380 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  207385 */     GIR_RootConstrainSelectedInstOperands,
     /*  207386 */     // GIR_Coverage, 597,
     /*  207386 */     GIR_Done,
     /*  207387 */   // Label 4096: @207387
     /*  207387 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(207428), // Rule ID 598 //
     /*  207392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207409 */     // MIs[0] rs1
     /*  207409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207421 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  207426 */     GIR_RootConstrainSelectedInstOperands,
     /*  207427 */     // GIR_Coverage, 598,
     /*  207427 */     GIR_Done,
     /*  207428 */   // Label 4097: @207428
     /*  207428 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(207469), // Rule ID 599 //
     /*  207433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207450 */     // MIs[0] rs1
     /*  207450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207462 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  207467 */     GIR_RootConstrainSelectedInstOperands,
     /*  207468 */     // GIR_Coverage, 599,
     /*  207468 */     GIR_Done,
     /*  207469 */   // Label 4098: @207469
     /*  207469 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(207510), // Rule ID 600 //
     /*  207474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207477 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207484 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207491 */     // MIs[0] rs1
     /*  207491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207503 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  207508 */     GIR_RootConstrainSelectedInstOperands,
     /*  207509 */     // GIR_Coverage, 600,
     /*  207509 */     GIR_Done,
     /*  207510 */   // Label 4099: @207510
     /*  207510 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(207551), // Rule ID 601 //
     /*  207515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207532 */     // MIs[0] rs1
     /*  207532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207544 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  207549 */     GIR_RootConstrainSelectedInstOperands,
     /*  207550 */     // GIR_Coverage, 601,
     /*  207550 */     GIR_Done,
     /*  207551 */   // Label 4100: @207551
     /*  207551 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(207592), // Rule ID 602 //
     /*  207556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207573 */     // MIs[0] rs1
     /*  207573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207585 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  207590 */     GIR_RootConstrainSelectedInstOperands,
     /*  207591 */     // GIR_Coverage, 602,
     /*  207591 */     GIR_Done,
     /*  207592 */   // Label 4101: @207592
     /*  207592 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(207633), // Rule ID 831 //
     /*  207597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207600 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207607 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207614 */     // MIs[0] rs1
     /*  207614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207626 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  207631 */     GIR_RootConstrainSelectedInstOperands,
     /*  207632 */     // GIR_Coverage, 831,
     /*  207632 */     GIR_Done,
     /*  207633 */   // Label 4102: @207633
     /*  207633 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(207674), // Rule ID 833 //
     /*  207638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207641 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207648 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207655 */     // MIs[0] rs1
     /*  207655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207667 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  207672 */     GIR_RootConstrainSelectedInstOperands,
     /*  207673 */     // GIR_Coverage, 833,
     /*  207673 */     GIR_Done,
     /*  207674 */   // Label 4103: @207674
     /*  207674 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(207715), // Rule ID 835 //
     /*  207679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207682 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207689 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207696 */     // MIs[0] rs1
     /*  207696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207708 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  207713 */     GIR_RootConstrainSelectedInstOperands,
     /*  207714 */     // GIR_Coverage, 835,
     /*  207714 */     GIR_Done,
     /*  207715 */   // Label 4104: @207715
     /*  207715 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(207756), // Rule ID 837 //
     /*  207720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207723 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207737 */     // MIs[0] rs1
     /*  207737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207749 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  207754 */     GIR_RootConstrainSelectedInstOperands,
     /*  207755 */     // GIR_Coverage, 837,
     /*  207755 */     GIR_Done,
     /*  207756 */   // Label 4105: @207756
     /*  207756 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(207797), // Rule ID 839 //
     /*  207761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207764 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207771 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207778 */     // MIs[0] rs1
     /*  207778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207790 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  207795 */     GIR_RootConstrainSelectedInstOperands,
     /*  207796 */     // GIR_Coverage, 839,
     /*  207796 */     GIR_Done,
     /*  207797 */   // Label 4106: @207797
     /*  207797 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(207838), // Rule ID 841 //
     /*  207802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207805 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207812 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207819 */     // MIs[0] rs1
     /*  207819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207831 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  207836 */     GIR_RootConstrainSelectedInstOperands,
     /*  207837 */     // GIR_Coverage, 841,
     /*  207837 */     GIR_Done,
     /*  207838 */   // Label 4107: @207838
     /*  207838 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(207879), // Rule ID 843 //
     /*  207843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207860 */     // MIs[0] rs1
     /*  207860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207872 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  207877 */     GIR_RootConstrainSelectedInstOperands,
     /*  207878 */     // GIR_Coverage, 843,
     /*  207878 */     GIR_Done,
     /*  207879 */   // Label 4108: @207879
     /*  207879 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(207920), // Rule ID 845 //
     /*  207884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207887 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207894 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207901 */     // MIs[0] rs1
     /*  207901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207913 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  207918 */     GIR_RootConstrainSelectedInstOperands,
     /*  207919 */     // GIR_Coverage, 845,
     /*  207919 */     GIR_Done,
     /*  207920 */   // Label 4109: @207920
     /*  207920 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(207961), // Rule ID 847 //
     /*  207925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207928 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207935 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207942 */     // MIs[0] rs1
     /*  207942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207954 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  207959 */     GIR_RootConstrainSelectedInstOperands,
     /*  207960 */     // GIR_Coverage, 847,
     /*  207960 */     GIR_Done,
     /*  207961 */   // Label 4110: @207961
     /*  207961 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(208002), // Rule ID 849 //
     /*  207966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207969 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207983 */     // MIs[0] rs1
     /*  207983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207995 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  208000 */     GIR_RootConstrainSelectedInstOperands,
     /*  208001 */     // GIR_Coverage, 849,
     /*  208001 */     GIR_Done,
     /*  208002 */   // Label 4111: @208002
     /*  208002 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(208043), // Rule ID 1011 //
     /*  208007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  208010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  208020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208024 */     // MIs[0] rs1
     /*  208024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208036 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  208041 */     GIR_RootConstrainSelectedInstOperands,
     /*  208042 */     // GIR_Coverage, 1011,
     /*  208042 */     GIR_Done,
     /*  208043 */   // Label 4112: @208043
     /*  208043 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(208084), // Rule ID 1013 //
     /*  208048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  208051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  208061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208065 */     // MIs[0] rs1
     /*  208065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208077 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  208082 */     GIR_RootConstrainSelectedInstOperands,
     /*  208083 */     // GIR_Coverage, 1013,
     /*  208083 */     GIR_Done,
     /*  208084 */   // Label 4113: @208084
     /*  208084 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(208125), // Rule ID 1015 //
     /*  208089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  208092 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208099 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  208102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208106 */     // MIs[0] rs1
     /*  208106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208118 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  208123 */     GIR_RootConstrainSelectedInstOperands,
     /*  208124 */     // GIR_Coverage, 1015,
     /*  208124 */     GIR_Done,
     /*  208125 */   // Label 4114: @208125
     /*  208125 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(208166), // Rule ID 1017 //
     /*  208130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  208133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  208143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208147 */     // MIs[0] rs1
     /*  208147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208159 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  208164 */     GIR_RootConstrainSelectedInstOperands,
     /*  208165 */     // GIR_Coverage, 1017,
     /*  208165 */     GIR_Done,
     /*  208166 */   // Label 4115: @208166
     /*  208166 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(208207), // Rule ID 1019 //
     /*  208171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  208174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  208184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208188 */     // MIs[0] rs1
     /*  208188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208200 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  208205 */     GIR_RootConstrainSelectedInstOperands,
     /*  208206 */     // GIR_Coverage, 1019,
     /*  208206 */     GIR_Done,
     /*  208207 */   // Label 4116: @208207
     /*  208207 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(208248), // Rule ID 1021 //
     /*  208212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  208215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  208225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208229 */     // MIs[0] rs1
     /*  208229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208241 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  208246 */     GIR_RootConstrainSelectedInstOperands,
     /*  208247 */     // GIR_Coverage, 1021,
     /*  208247 */     GIR_Done,
     /*  208248 */   // Label 4117: @208248
     /*  208248 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(208289), // Rule ID 1023 //
     /*  208253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  208256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  208266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208270 */     // MIs[0] rs1
     /*  208270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208282 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  208287 */     GIR_RootConstrainSelectedInstOperands,
     /*  208288 */     // GIR_Coverage, 1023,
     /*  208288 */     GIR_Done,
     /*  208289 */   // Label 4118: @208289
     /*  208289 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(208330), // Rule ID 1025 //
     /*  208294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  208297 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  208307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208311 */     // MIs[0] rs1
     /*  208311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208323 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  208328 */     GIR_RootConstrainSelectedInstOperands,
     /*  208329 */     // GIR_Coverage, 1025,
     /*  208329 */     GIR_Done,
     /*  208330 */   // Label 4119: @208330
     /*  208330 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(208371), // Rule ID 1027 //
     /*  208335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  208338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208345 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  208348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208352 */     // MIs[0] rs1
     /*  208352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208364 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  208369 */     GIR_RootConstrainSelectedInstOperands,
     /*  208370 */     // GIR_Coverage, 1027,
     /*  208370 */     GIR_Done,
     /*  208371 */   // Label 4120: @208371
     /*  208371 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(208412), // Rule ID 1029 //
     /*  208376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  208379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208386 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  208389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208393 */     // MIs[0] rs1
     /*  208393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208405 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  208410 */     GIR_RootConstrainSelectedInstOperands,
     /*  208411 */     // GIR_Coverage, 1029,
     /*  208411 */     GIR_Done,
     /*  208412 */   // Label 4121: @208412
     /*  208412 */   GIM_Reject,
     /*  208413 */ // Label 4081: @208413
     /*  208413 */ GIM_Reject,
     /*  208414 */ // Label 4049: @208414
     /*  208414 */ GIM_Reject,
     /*  208415 */ // Label 35: @208415
     /*  208415 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4124*/ GIMT_Encode4(211324),
     /*  208426 */ /*GILLT_s32*//*Label 4122*/ GIMT_Encode4(208434),
     /*  208430 */ /*GILLT_s64*//*Label 4123*/ GIMT_Encode4(209674),
     /*  208434 */ // Label 4122: @208434
     /*  208434 */ GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(209673),
     /*  208439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208442 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(208483), // Rule ID 504 //
     /*  208447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  208450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  208460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208464 */     // MIs[0] rs1
     /*  208464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208476 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  208481 */     GIR_RootConstrainSelectedInstOperands,
     /*  208482 */     // GIR_Coverage, 504,
     /*  208482 */     GIR_Done,
     /*  208483 */   // Label 4126: @208483
     /*  208483 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(208524), // Rule ID 506 //
     /*  208488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  208491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  208501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208505 */     // MIs[0] rs1
     /*  208505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208517 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  208522 */     GIR_RootConstrainSelectedInstOperands,
     /*  208523 */     // GIR_Coverage, 506,
     /*  208523 */     GIR_Done,
     /*  208524 */   // Label 4127: @208524
     /*  208524 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(208565), // Rule ID 508 //
     /*  208529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  208532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  208542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208546 */     // MIs[0] rs1
     /*  208546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208558 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  208563 */     GIR_RootConstrainSelectedInstOperands,
     /*  208564 */     // GIR_Coverage, 508,
     /*  208564 */     GIR_Done,
     /*  208565 */   // Label 4128: @208565
     /*  208565 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(208606), // Rule ID 510 //
     /*  208570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  208573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  208583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208587 */     // MIs[0] rs1
     /*  208587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208599 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  208604 */     GIR_RootConstrainSelectedInstOperands,
     /*  208605 */     // GIR_Coverage, 510,
     /*  208605 */     GIR_Done,
     /*  208606 */   // Label 4129: @208606
     /*  208606 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(208647), // Rule ID 512 //
     /*  208611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  208614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  208624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208628 */     // MIs[0] rs1
     /*  208628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208640 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  208645 */     GIR_RootConstrainSelectedInstOperands,
     /*  208646 */     // GIR_Coverage, 512,
     /*  208646 */     GIR_Done,
     /*  208647 */   // Label 4130: @208647
     /*  208647 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(208688), // Rule ID 514 //
     /*  208652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  208655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  208665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208669 */     // MIs[0] rs1
     /*  208669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208681 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  208686 */     GIR_RootConstrainSelectedInstOperands,
     /*  208687 */     // GIR_Coverage, 514,
     /*  208687 */     GIR_Done,
     /*  208688 */   // Label 4131: @208688
     /*  208688 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(208729), // Rule ID 516 //
     /*  208693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  208696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208703 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  208706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208710 */     // MIs[0] rs1
     /*  208710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208722 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  208727 */     GIR_RootConstrainSelectedInstOperands,
     /*  208728 */     // GIR_Coverage, 516,
     /*  208728 */     GIR_Done,
     /*  208729 */   // Label 4132: @208729
     /*  208729 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(208770), // Rule ID 518 //
     /*  208734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  208737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  208747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208751 */     // MIs[0] rs1
     /*  208751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208763 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  208768 */     GIR_RootConstrainSelectedInstOperands,
     /*  208769 */     // GIR_Coverage, 518,
     /*  208769 */     GIR_Done,
     /*  208770 */   // Label 4133: @208770
     /*  208770 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(208811), // Rule ID 520 //
     /*  208775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  208778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  208788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208792 */     // MIs[0] rs1
     /*  208792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208804 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  208809 */     GIR_RootConstrainSelectedInstOperands,
     /*  208810 */     // GIR_Coverage, 520,
     /*  208810 */     GIR_Done,
     /*  208811 */   // Label 4134: @208811
     /*  208811 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(208852), // Rule ID 522 //
     /*  208816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  208819 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  208829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208833 */     // MIs[0] rs1
     /*  208833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208845 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  208850 */     GIR_RootConstrainSelectedInstOperands,
     /*  208851 */     // GIR_Coverage, 522,
     /*  208851 */     GIR_Done,
     /*  208852 */   // Label 4135: @208852
     /*  208852 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(208893), // Rule ID 852 //
     /*  208857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  208860 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  208867 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  208870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208874 */     // MIs[0] rs1
     /*  208874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208886 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  208891 */     GIR_RootConstrainSelectedInstOperands,
     /*  208892 */     // GIR_Coverage, 852,
     /*  208892 */     GIR_Done,
     /*  208893 */   // Label 4136: @208893
     /*  208893 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(208934), // Rule ID 854 //
     /*  208898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  208901 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  208908 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  208911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208915 */     // MIs[0] rs1
     /*  208915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208927 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  208932 */     GIR_RootConstrainSelectedInstOperands,
     /*  208933 */     // GIR_Coverage, 854,
     /*  208933 */     GIR_Done,
     /*  208934 */   // Label 4137: @208934
     /*  208934 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(208975), // Rule ID 856 //
     /*  208939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  208942 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  208949 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  208952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208956 */     // MIs[0] rs1
     /*  208956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208968 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  208973 */     GIR_RootConstrainSelectedInstOperands,
     /*  208974 */     // GIR_Coverage, 856,
     /*  208974 */     GIR_Done,
     /*  208975 */   // Label 4138: @208975
     /*  208975 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(209016), // Rule ID 858 //
     /*  208980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  208983 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  208990 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  208993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208997 */     // MIs[0] rs1
     /*  208997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209009 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  209014 */     GIR_RootConstrainSelectedInstOperands,
     /*  209015 */     // GIR_Coverage, 858,
     /*  209015 */     GIR_Done,
     /*  209016 */   // Label 4139: @209016
     /*  209016 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(209057), // Rule ID 860 //
     /*  209021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  209024 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  209031 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  209034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209038 */     // MIs[0] rs1
     /*  209038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209050 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  209055 */     GIR_RootConstrainSelectedInstOperands,
     /*  209056 */     // GIR_Coverage, 860,
     /*  209056 */     GIR_Done,
     /*  209057 */   // Label 4140: @209057
     /*  209057 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(209098), // Rule ID 862 //
     /*  209062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209065 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  209072 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  209075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209079 */     // MIs[0] rs1
     /*  209079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209091 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  209096 */     GIR_RootConstrainSelectedInstOperands,
     /*  209097 */     // GIR_Coverage, 862,
     /*  209097 */     GIR_Done,
     /*  209098 */   // Label 4141: @209098
     /*  209098 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(209139), // Rule ID 864 //
     /*  209103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  209113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  209116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209120 */     // MIs[0] rs1
     /*  209120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209132 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  209137 */     GIR_RootConstrainSelectedInstOperands,
     /*  209138 */     // GIR_Coverage, 864,
     /*  209138 */     GIR_Done,
     /*  209139 */   // Label 4142: @209139
     /*  209139 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(209180), // Rule ID 866 //
     /*  209144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209147 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  209154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  209157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209161 */     // MIs[0] rs1
     /*  209161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209173 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  209178 */     GIR_RootConstrainSelectedInstOperands,
     /*  209179 */     // GIR_Coverage, 866,
     /*  209179 */     GIR_Done,
     /*  209180 */   // Label 4143: @209180
     /*  209180 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(209221), // Rule ID 868 //
     /*  209185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209188 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  209195 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  209198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209202 */     // MIs[0] rs1
     /*  209202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209214 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  209219 */     GIR_RootConstrainSelectedInstOperands,
     /*  209220 */     // GIR_Coverage, 868,
     /*  209220 */     GIR_Done,
     /*  209221 */   // Label 4144: @209221
     /*  209221 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(209262), // Rule ID 870 //
     /*  209226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209229 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  209236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  209239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209243 */     // MIs[0] rs1
     /*  209243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209255 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  209260 */     GIR_RootConstrainSelectedInstOperands,
     /*  209261 */     // GIR_Coverage, 870,
     /*  209261 */     GIR_Done,
     /*  209262 */   // Label 4145: @209262
     /*  209262 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(209303), // Rule ID 1032 //
     /*  209267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  209270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  209280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209284 */     // MIs[0] rs1
     /*  209284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209296 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  209301 */     GIR_RootConstrainSelectedInstOperands,
     /*  209302 */     // GIR_Coverage, 1032,
     /*  209302 */     GIR_Done,
     /*  209303 */   // Label 4146: @209303
     /*  209303 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(209344), // Rule ID 1034 //
     /*  209308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  209311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209318 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  209321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209325 */     // MIs[0] rs1
     /*  209325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209337 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  209342 */     GIR_RootConstrainSelectedInstOperands,
     /*  209343 */     // GIR_Coverage, 1034,
     /*  209343 */     GIR_Done,
     /*  209344 */   // Label 4147: @209344
     /*  209344 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(209385), // Rule ID 1036 //
     /*  209349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  209352 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209359 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  209362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209366 */     // MIs[0] rs1
     /*  209366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209378 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  209383 */     GIR_RootConstrainSelectedInstOperands,
     /*  209384 */     // GIR_Coverage, 1036,
     /*  209384 */     GIR_Done,
     /*  209385 */   // Label 4148: @209385
     /*  209385 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(209426), // Rule ID 1038 //
     /*  209390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  209393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  209403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209407 */     // MIs[0] rs1
     /*  209407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209419 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  209424 */     GIR_RootConstrainSelectedInstOperands,
     /*  209425 */     // GIR_Coverage, 1038,
     /*  209425 */     GIR_Done,
     /*  209426 */   // Label 4149: @209426
     /*  209426 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(209467), // Rule ID 1040 //
     /*  209431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  209434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  209444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209448 */     // MIs[0] rs1
     /*  209448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209460 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  209465 */     GIR_RootConstrainSelectedInstOperands,
     /*  209466 */     // GIR_Coverage, 1040,
     /*  209466 */     GIR_Done,
     /*  209467 */   // Label 4150: @209467
     /*  209467 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(209508), // Rule ID 1042 //
     /*  209472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  209485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209489 */     // MIs[0] rs1
     /*  209489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209501 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  209506 */     GIR_RootConstrainSelectedInstOperands,
     /*  209507 */     // GIR_Coverage, 1042,
     /*  209507 */     GIR_Done,
     /*  209508 */   // Label 4151: @209508
     /*  209508 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(209549), // Rule ID 1044 //
     /*  209513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209516 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209523 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  209526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209530 */     // MIs[0] rs1
     /*  209530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209542 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  209547 */     GIR_RootConstrainSelectedInstOperands,
     /*  209548 */     // GIR_Coverage, 1044,
     /*  209548 */     GIR_Done,
     /*  209549 */   // Label 4152: @209549
     /*  209549 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(209590), // Rule ID 1046 //
     /*  209554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209557 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209564 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  209567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209571 */     // MIs[0] rs1
     /*  209571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209583 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  209588 */     GIR_RootConstrainSelectedInstOperands,
     /*  209589 */     // GIR_Coverage, 1046,
     /*  209589 */     GIR_Done,
     /*  209590 */   // Label 4153: @209590
     /*  209590 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(209631), // Rule ID 1048 //
     /*  209595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209598 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209605 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  209608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209612 */     // MIs[0] rs1
     /*  209612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209624 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  209629 */     GIR_RootConstrainSelectedInstOperands,
     /*  209630 */     // GIR_Coverage, 1048,
     /*  209630 */     GIR_Done,
     /*  209631 */   // Label 4154: @209631
     /*  209631 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(209672), // Rule ID 1050 //
     /*  209636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209639 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  209649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209653 */     // MIs[0] rs1
     /*  209653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209665 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  209670 */     GIR_RootConstrainSelectedInstOperands,
     /*  209671 */     // GIR_Coverage, 1050,
     /*  209671 */     GIR_Done,
     /*  209672 */   // Label 4155: @209672
     /*  209672 */   GIM_Reject,
     /*  209673 */ // Label 4125: @209673
     /*  209673 */ GIM_Reject,
     /*  209674 */ // Label 4123: @209674
     /*  209674 */ GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(211323),
     /*  209679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209682 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(209723), // Rule ID 503 //
     /*  209687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  209690 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209697 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  209700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209704 */     // MIs[0] rs1
     /*  209704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209716 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  209721 */     GIR_RootConstrainSelectedInstOperands,
     /*  209722 */     // GIR_Coverage, 503,
     /*  209722 */     GIR_Done,
     /*  209723 */   // Label 4157: @209723
     /*  209723 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(209764), // Rule ID 505 //
     /*  209728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  209731 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209738 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  209741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209745 */     // MIs[0] rs1
     /*  209745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209757 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  209762 */     GIR_RootConstrainSelectedInstOperands,
     /*  209763 */     // GIR_Coverage, 505,
     /*  209763 */     GIR_Done,
     /*  209764 */   // Label 4158: @209764
     /*  209764 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(209805), // Rule ID 507 //
     /*  209769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  209772 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  209782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209786 */     // MIs[0] rs1
     /*  209786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209798 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  209803 */     GIR_RootConstrainSelectedInstOperands,
     /*  209804 */     // GIR_Coverage, 507,
     /*  209804 */     GIR_Done,
     /*  209805 */   // Label 4159: @209805
     /*  209805 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(209846), // Rule ID 509 //
     /*  209810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  209813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  209823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209827 */     // MIs[0] rs1
     /*  209827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209839 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  209844 */     GIR_RootConstrainSelectedInstOperands,
     /*  209845 */     // GIR_Coverage, 509,
     /*  209845 */     GIR_Done,
     /*  209846 */   // Label 4160: @209846
     /*  209846 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(209887), // Rule ID 511 //
     /*  209851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  209854 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  209864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209868 */     // MIs[0] rs1
     /*  209868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209880 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  209885 */     GIR_RootConstrainSelectedInstOperands,
     /*  209886 */     // GIR_Coverage, 511,
     /*  209886 */     GIR_Done,
     /*  209887 */   // Label 4161: @209887
     /*  209887 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(209928), // Rule ID 513 //
     /*  209892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  209895 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  209905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209909 */     // MIs[0] rs1
     /*  209909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209921 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  209926 */     GIR_RootConstrainSelectedInstOperands,
     /*  209927 */     // GIR_Coverage, 513,
     /*  209927 */     GIR_Done,
     /*  209928 */   // Label 4162: @209928
     /*  209928 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(209969), // Rule ID 515 //
     /*  209933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  209936 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  209946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209950 */     // MIs[0] rs1
     /*  209950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209962 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  209967 */     GIR_RootConstrainSelectedInstOperands,
     /*  209968 */     // GIR_Coverage, 515,
     /*  209968 */     GIR_Done,
     /*  209969 */   // Label 4163: @209969
     /*  209969 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(210010), // Rule ID 517 //
     /*  209974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  209977 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  209987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209991 */     // MIs[0] rs1
     /*  209991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210003 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  210008 */     GIR_RootConstrainSelectedInstOperands,
     /*  210009 */     // GIR_Coverage, 517,
     /*  210009 */     GIR_Done,
     /*  210010 */   // Label 4164: @210010
     /*  210010 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(210051), // Rule ID 519 //
     /*  210015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  210018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  210025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  210028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210032 */     // MIs[0] rs1
     /*  210032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210044 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  210049 */     GIR_RootConstrainSelectedInstOperands,
     /*  210050 */     // GIR_Coverage, 519,
     /*  210050 */     GIR_Done,
     /*  210051 */   // Label 4165: @210051
     /*  210051 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(210092), // Rule ID 521 //
     /*  210056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  210059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  210066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  210069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210073 */     // MIs[0] rs1
     /*  210073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210085 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  210090 */     GIR_RootConstrainSelectedInstOperands,
     /*  210091 */     // GIR_Coverage, 521,
     /*  210091 */     GIR_Done,
     /*  210092 */   // Label 4166: @210092
     /*  210092 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(210133), // Rule ID 603 //
     /*  210097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  210100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  210110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210114 */     // MIs[0] rs1
     /*  210114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210126 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  210131 */     GIR_RootConstrainSelectedInstOperands,
     /*  210132 */     // GIR_Coverage, 603,
     /*  210132 */     GIR_Done,
     /*  210133 */   // Label 4167: @210133
     /*  210133 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(210174), // Rule ID 604 //
     /*  210138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  210141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210148 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  210151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210155 */     // MIs[0] rs1
     /*  210155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210167 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ),
     /*  210172 */     GIR_RootConstrainSelectedInstOperands,
     /*  210173 */     // GIR_Coverage, 604,
     /*  210173 */     GIR_Done,
     /*  210174 */   // Label 4168: @210174
     /*  210174 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(210215), // Rule ID 605 //
     /*  210179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  210182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  210192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210196 */     // MIs[0] rs1
     /*  210196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210208 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_RL),
     /*  210213 */     GIR_RootConstrainSelectedInstOperands,
     /*  210214 */     // GIR_Coverage, 605,
     /*  210214 */     GIR_Done,
     /*  210215 */   // Label 4169: @210215
     /*  210215 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(210256), // Rule ID 606 //
     /*  210220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  210223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  210233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210237 */     // MIs[0] rs1
     /*  210237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210249 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  210254 */     GIR_RootConstrainSelectedInstOperands,
     /*  210255 */     // GIR_Coverage, 606,
     /*  210255 */     GIR_Done,
     /*  210256 */   // Label 4170: @210256
     /*  210256 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(210297), // Rule ID 607 //
     /*  210261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  210264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  210274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210278 */     // MIs[0] rs1
     /*  210278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210290 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  210295 */     GIR_RootConstrainSelectedInstOperands,
     /*  210296 */     // GIR_Coverage, 607,
     /*  210296 */     GIR_Done,
     /*  210297 */   // Label 4171: @210297
     /*  210297 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(210338), // Rule ID 608 //
     /*  210302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  210305 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  210315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210319 */     // MIs[0] rs1
     /*  210319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210331 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  210336 */     GIR_RootConstrainSelectedInstOperands,
     /*  210337 */     // GIR_Coverage, 608,
     /*  210337 */     GIR_Done,
     /*  210338 */   // Label 4172: @210338
     /*  210338 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(210379), // Rule ID 609 //
     /*  210343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  210346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  210356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210360 */     // MIs[0] rs1
     /*  210360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210372 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  210377 */     GIR_RootConstrainSelectedInstOperands,
     /*  210378 */     // GIR_Coverage, 609,
     /*  210378 */     GIR_Done,
     /*  210379 */   // Label 4173: @210379
     /*  210379 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(210420), // Rule ID 610 //
     /*  210384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  210387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  210397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210401 */     // MIs[0] rs1
     /*  210401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210413 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  210418 */     GIR_RootConstrainSelectedInstOperands,
     /*  210419 */     // GIR_Coverage, 610,
     /*  210419 */     GIR_Done,
     /*  210420 */   // Label 4174: @210420
     /*  210420 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(210461), // Rule ID 611 //
     /*  210425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  210428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  210438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210442 */     // MIs[0] rs1
     /*  210442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210454 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  210459 */     GIR_RootConstrainSelectedInstOperands,
     /*  210460 */     // GIR_Coverage, 611,
     /*  210460 */     GIR_Done,
     /*  210461 */   // Label 4175: @210461
     /*  210461 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(210502), // Rule ID 612 //
     /*  210466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  210469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  210479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210483 */     // MIs[0] rs1
     /*  210483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210495 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  210500 */     GIR_RootConstrainSelectedInstOperands,
     /*  210501 */     // GIR_Coverage, 612,
     /*  210501 */     GIR_Done,
     /*  210502 */   // Label 4176: @210502
     /*  210502 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(210543), // Rule ID 851 //
     /*  210507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210510 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  210520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210524 */     // MIs[0] rs1
     /*  210524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210536 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  210541 */     GIR_RootConstrainSelectedInstOperands,
     /*  210542 */     // GIR_Coverage, 851,
     /*  210542 */     GIR_Done,
     /*  210543 */   // Label 4177: @210543
     /*  210543 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(210584), // Rule ID 853 //
     /*  210548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210551 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210558 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  210561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210565 */     // MIs[0] rs1
     /*  210565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210577 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  210582 */     GIR_RootConstrainSelectedInstOperands,
     /*  210583 */     // GIR_Coverage, 853,
     /*  210583 */     GIR_Done,
     /*  210584 */   // Label 4178: @210584
     /*  210584 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(210625), // Rule ID 855 //
     /*  210589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210592 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  210602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210606 */     // MIs[0] rs1
     /*  210606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210618 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  210623 */     GIR_RootConstrainSelectedInstOperands,
     /*  210624 */     // GIR_Coverage, 855,
     /*  210624 */     GIR_Done,
     /*  210625 */   // Label 4179: @210625
     /*  210625 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(210666), // Rule ID 857 //
     /*  210630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  210643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210647 */     // MIs[0] rs1
     /*  210647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210659 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  210664 */     GIR_RootConstrainSelectedInstOperands,
     /*  210665 */     // GIR_Coverage, 857,
     /*  210665 */     GIR_Done,
     /*  210666 */   // Label 4180: @210666
     /*  210666 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(210707), // Rule ID 859 //
     /*  210671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210674 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210681 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  210684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210688 */     // MIs[0] rs1
     /*  210688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210700 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  210705 */     GIR_RootConstrainSelectedInstOperands,
     /*  210706 */     // GIR_Coverage, 859,
     /*  210706 */     GIR_Done,
     /*  210707 */   // Label 4181: @210707
     /*  210707 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(210748), // Rule ID 861 //
     /*  210712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  210715 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210722 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  210725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210729 */     // MIs[0] rs1
     /*  210729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210741 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  210746 */     GIR_RootConstrainSelectedInstOperands,
     /*  210747 */     // GIR_Coverage, 861,
     /*  210747 */     GIR_Done,
     /*  210748 */   // Label 4182: @210748
     /*  210748 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(210789), // Rule ID 863 //
     /*  210753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  210756 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210763 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  210766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210770 */     // MIs[0] rs1
     /*  210770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210782 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  210787 */     GIR_RootConstrainSelectedInstOperands,
     /*  210788 */     // GIR_Coverage, 863,
     /*  210788 */     GIR_Done,
     /*  210789 */   // Label 4183: @210789
     /*  210789 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(210830), // Rule ID 865 //
     /*  210794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  210797 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  210807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210811 */     // MIs[0] rs1
     /*  210811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210823 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  210828 */     GIR_RootConstrainSelectedInstOperands,
     /*  210829 */     // GIR_Coverage, 865,
     /*  210829 */     GIR_Done,
     /*  210830 */   // Label 4184: @210830
     /*  210830 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(210871), // Rule ID 867 //
     /*  210835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  210838 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210845 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  210848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210852 */     // MIs[0] rs1
     /*  210852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210864 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  210869 */     GIR_RootConstrainSelectedInstOperands,
     /*  210870 */     // GIR_Coverage, 867,
     /*  210870 */     GIR_Done,
     /*  210871 */   // Label 4185: @210871
     /*  210871 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(210912), // Rule ID 869 //
     /*  210876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  210879 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210886 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  210889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210893 */     // MIs[0] rs1
     /*  210893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210905 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  210910 */     GIR_RootConstrainSelectedInstOperands,
     /*  210911 */     // GIR_Coverage, 869,
     /*  210911 */     GIR_Done,
     /*  210912 */   // Label 4186: @210912
     /*  210912 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(210953), // Rule ID 1031 //
     /*  210917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  210927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  210930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210934 */     // MIs[0] rs1
     /*  210934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210946 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  210951 */     GIR_RootConstrainSelectedInstOperands,
     /*  210952 */     // GIR_Coverage, 1031,
     /*  210952 */     GIR_Done,
     /*  210953 */   // Label 4187: @210953
     /*  210953 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(210994), // Rule ID 1033 //
     /*  210958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  210968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  210971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210975 */     // MIs[0] rs1
     /*  210975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210987 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  210992 */     GIR_RootConstrainSelectedInstOperands,
     /*  210993 */     // GIR_Coverage, 1033,
     /*  210993 */     GIR_Done,
     /*  210994 */   // Label 4188: @210994
     /*  210994 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(211035), // Rule ID 1035 //
     /*  210999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  211002 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211009 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  211012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211016 */     // MIs[0] rs1
     /*  211016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211028 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  211033 */     GIR_RootConstrainSelectedInstOperands,
     /*  211034 */     // GIR_Coverage, 1035,
     /*  211034 */     GIR_Done,
     /*  211035 */   // Label 4189: @211035
     /*  211035 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(211076), // Rule ID 1037 //
     /*  211040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  211043 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211050 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  211053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211057 */     // MIs[0] rs1
     /*  211057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211069 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  211074 */     GIR_RootConstrainSelectedInstOperands,
     /*  211075 */     // GIR_Coverage, 1037,
     /*  211075 */     GIR_Done,
     /*  211076 */   // Label 4190: @211076
     /*  211076 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(211117), // Rule ID 1039 //
     /*  211081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  211084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  211094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211098 */     // MIs[0] rs1
     /*  211098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211110 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  211115 */     GIR_RootConstrainSelectedInstOperands,
     /*  211116 */     // GIR_Coverage, 1039,
     /*  211116 */     GIR_Done,
     /*  211117 */   // Label 4191: @211117
     /*  211117 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(211158), // Rule ID 1041 //
     /*  211122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  211125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  211135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211139 */     // MIs[0] rs1
     /*  211139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211151 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  211156 */     GIR_RootConstrainSelectedInstOperands,
     /*  211157 */     // GIR_Coverage, 1041,
     /*  211157 */     GIR_Done,
     /*  211158 */   // Label 4192: @211158
     /*  211158 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(211199), // Rule ID 1043 //
     /*  211163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  211166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  211176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211180 */     // MIs[0] rs1
     /*  211180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211192 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  211197 */     GIR_RootConstrainSelectedInstOperands,
     /*  211198 */     // GIR_Coverage, 1043,
     /*  211198 */     GIR_Done,
     /*  211199 */   // Label 4193: @211199
     /*  211199 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(211240), // Rule ID 1045 //
     /*  211204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  211207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  211217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211221 */     // MIs[0] rs1
     /*  211221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211233 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  211238 */     GIR_RootConstrainSelectedInstOperands,
     /*  211239 */     // GIR_Coverage, 1045,
     /*  211239 */     GIR_Done,
     /*  211240 */   // Label 4194: @211240
     /*  211240 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(211281), // Rule ID 1047 //
     /*  211245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  211248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  211258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211262 */     // MIs[0] rs1
     /*  211262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211274 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  211279 */     GIR_RootConstrainSelectedInstOperands,
     /*  211280 */     // GIR_Coverage, 1047,
     /*  211280 */     GIR_Done,
     /*  211281 */   // Label 4195: @211281
     /*  211281 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(211322), // Rule ID 1049 //
     /*  211286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  211289 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  211299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211303 */     // MIs[0] rs1
     /*  211303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211315 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  211320 */     GIR_RootConstrainSelectedInstOperands,
     /*  211321 */     // GIR_Coverage, 1049,
     /*  211321 */     GIR_Done,
     /*  211322 */   // Label 4196: @211322
     /*  211322 */   GIM_Reject,
     /*  211323 */ // Label 4156: @211323
     /*  211323 */ GIM_Reject,
     /*  211324 */ // Label 4124: @211324
     /*  211324 */ GIM_Reject,
     /*  211325 */ // Label 36: @211325
     /*  211325 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4199*/ GIMT_Encode4(211542),
     /*  211336 */ /*GILLT_s32*//*Label 4197*/ GIMT_Encode4(211344),
     /*  211340 */ /*GILLT_s64*//*Label 4198*/ GIMT_Encode4(211443),
     /*  211344 */ // Label 4197: @211344
     /*  211344 */ GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(211370), // Rule ID 245 //
     /*  211349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211352 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  211356 */   // MIs[0] Operand 1
     /*  211356 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211359 */   // (atomic_fence 4:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 2:{ *:[i32] }, 3:{ *:[i32] })
     /*  211359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  211362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  211365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211368 */   GIR_RootConstrainSelectedInstOperands,
     /*  211369 */   // GIR_Coverage, 245,
     /*  211369 */   GIR_EraseRootFromParent_Done,
     /*  211370 */ // Label 4200: @211370
     /*  211370 */ GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(211396), // Rule ID 247 //
     /*  211375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211378 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  211382 */   // MIs[0] Operand 1
     /*  211382 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211385 */   // (atomic_fence 5:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  211385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  211388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  211394 */   GIR_RootConstrainSelectedInstOperands,
     /*  211395 */   // GIR_Coverage, 247,
     /*  211395 */   GIR_EraseRootFromParent_Done,
     /*  211396 */ // Label 4201: @211396
     /*  211396 */ GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(211416), // Rule ID 249 //
     /*  211401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211404 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  211408 */   // MIs[0] Operand 1
     /*  211408 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211411 */   // (atomic_fence 6:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE_TSO)
     /*  211411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  211414 */   GIR_RootConstrainSelectedInstOperands,
     /*  211415 */   // GIR_Coverage, 249,
     /*  211415 */   GIR_EraseRootFromParent_Done,
     /*  211416 */ // Label 4202: @211416
     /*  211416 */ GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(211442), // Rule ID 251 //
     /*  211421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211424 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  211428 */   // MIs[0] Operand 1
     /*  211428 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211431 */   // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  211431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  211434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211440 */   GIR_RootConstrainSelectedInstOperands,
     /*  211441 */   // GIR_Coverage, 251,
     /*  211441 */   GIR_EraseRootFromParent_Done,
     /*  211442 */ // Label 4203: @211442
     /*  211442 */ GIM_Reject,
     /*  211443 */ // Label 4198: @211443
     /*  211443 */ GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(211469), // Rule ID 244 //
     /*  211448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211451 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  211455 */   // MIs[0] Operand 1
     /*  211455 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211458 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 2:{ *:[i64] }, 3:{ *:[i64] })
     /*  211458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  211461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  211464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211467 */   GIR_RootConstrainSelectedInstOperands,
     /*  211468 */   // GIR_Coverage, 244,
     /*  211468 */   GIR_EraseRootFromParent_Done,
     /*  211469 */ // Label 4204: @211469
     /*  211469 */ GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(211495), // Rule ID 246 //
     /*  211474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211477 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  211481 */   // MIs[0] Operand 1
     /*  211481 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211484 */   // (atomic_fence 5:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  211484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  211487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  211493 */   GIR_RootConstrainSelectedInstOperands,
     /*  211494 */   // GIR_Coverage, 246,
     /*  211494 */   GIR_EraseRootFromParent_Done,
     /*  211495 */ // Label 4205: @211495
     /*  211495 */ GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(211515), // Rule ID 248 //
     /*  211500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211503 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  211507 */   // MIs[0] Operand 1
     /*  211507 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211510 */   // (atomic_fence 6:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE_TSO)
     /*  211510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  211513 */   GIR_RootConstrainSelectedInstOperands,
     /*  211514 */   // GIR_Coverage, 248,
     /*  211514 */   GIR_EraseRootFromParent_Done,
     /*  211515 */ // Label 4206: @211515
     /*  211515 */ GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(211541), // Rule ID 250 //
     /*  211520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211523 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  211527 */   // MIs[0] Operand 1
     /*  211527 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211530 */   // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  211530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  211533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211539 */   GIR_RootConstrainSelectedInstOperands,
     /*  211540 */   // GIR_Coverage, 250,
     /*  211540 */   GIR_EraseRootFromParent_Done,
     /*  211541 */ // Label 4207: @211541
     /*  211541 */ GIM_Reject,
     /*  211542 */ // Label 4199: @211542
     /*  211542 */ GIM_Reject,
     /*  211543 */ // Label 37: @211543
     /*  211543 */ GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(213028),
     /*  211548 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  211551 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(211596), // Rule ID 2706 //
     /*  211556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  211570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211581 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  211584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211594 */     GIR_RootConstrainSelectedInstOperands,
     /*  211595 */     // GIR_Coverage, 2706,
     /*  211595 */     GIR_EraseRootFromParent_Done,
     /*  211596 */   // Label 4209: @211596
     /*  211596 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(211641), // Rule ID 2707 //
     /*  211601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  211615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211626 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  211629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211639 */     GIR_RootConstrainSelectedInstOperands,
     /*  211640 */     // GIR_Coverage, 2707,
     /*  211640 */     GIR_EraseRootFromParent_Done,
     /*  211641 */   // Label 4210: @211641
     /*  211641 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(211686), // Rule ID 23256 //
     /*  211646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  211660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211671 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  211674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211684 */     GIR_RootConstrainSelectedInstOperands,
     /*  211685 */     // GIR_Coverage, 23256,
     /*  211685 */     GIR_EraseRootFromParent_Done,
     /*  211686 */   // Label 4211: @211686
     /*  211686 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(211731), // Rule ID 23257 //
     /*  211691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  211705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211716 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  211719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211729 */     GIR_RootConstrainSelectedInstOperands,
     /*  211730 */     // GIR_Coverage, 23257,
     /*  211730 */     GIR_EraseRootFromParent_Done,
     /*  211731 */   // Label 4212: @211731
     /*  211731 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(211776), // Rule ID 23258 //
     /*  211736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  211750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211761 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  211764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211774 */     GIR_RootConstrainSelectedInstOperands,
     /*  211775 */     // GIR_Coverage, 23258,
     /*  211775 */     GIR_EraseRootFromParent_Done,
     /*  211776 */   // Label 4213: @211776
     /*  211776 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(211821), // Rule ID 23259 //
     /*  211781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  211795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211806 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  211809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211819 */     GIR_RootConstrainSelectedInstOperands,
     /*  211820 */     // GIR_Coverage, 23259,
     /*  211820 */     GIR_EraseRootFromParent_Done,
     /*  211821 */   // Label 4214: @211821
     /*  211821 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(211866), // Rule ID 23260 //
     /*  211826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  211840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211851 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  211854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211864 */     GIR_RootConstrainSelectedInstOperands,
     /*  211865 */     // GIR_Coverage, 23260,
     /*  211865 */     GIR_EraseRootFromParent_Done,
     /*  211866 */   // Label 4215: @211866
     /*  211866 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(211911), // Rule ID 23261 //
     /*  211871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  211885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  211899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211909 */     GIR_RootConstrainSelectedInstOperands,
     /*  211910 */     // GIR_Coverage, 23261,
     /*  211910 */     GIR_EraseRootFromParent_Done,
     /*  211911 */   // Label 4216: @211911
     /*  211911 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(211956), // Rule ID 23262 //
     /*  211916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  211930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211941 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  211944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211954 */     GIR_RootConstrainSelectedInstOperands,
     /*  211955 */     // GIR_Coverage, 23262,
     /*  211955 */     GIR_EraseRootFromParent_Done,
     /*  211956 */   // Label 4217: @211956
     /*  211956 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(212001), // Rule ID 23263 //
     /*  211961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  211975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211986 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  211989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211999 */     GIR_RootConstrainSelectedInstOperands,
     /*  212000 */     // GIR_Coverage, 23263,
     /*  212000 */     GIR_EraseRootFromParent_Done,
     /*  212001 */   // Label 4218: @212001
     /*  212001 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(212046), // Rule ID 23264 //
     /*  212006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  212014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212031 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  212034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212044 */     GIR_RootConstrainSelectedInstOperands,
     /*  212045 */     // GIR_Coverage, 23264,
     /*  212045 */     GIR_EraseRootFromParent_Done,
     /*  212046 */   // Label 4219: @212046
     /*  212046 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(212091), // Rule ID 23265 //
     /*  212051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  212059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212076 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  212079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212089 */     GIR_RootConstrainSelectedInstOperands,
     /*  212090 */     // GIR_Coverage, 23265,
     /*  212090 */     GIR_EraseRootFromParent_Done,
     /*  212091 */   // Label 4220: @212091
     /*  212091 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(212136), // Rule ID 23266 //
     /*  212096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  212104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212121 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  212124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212134 */     GIR_RootConstrainSelectedInstOperands,
     /*  212135 */     // GIR_Coverage, 23266,
     /*  212135 */     GIR_EraseRootFromParent_Done,
     /*  212136 */   // Label 4221: @212136
     /*  212136 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(212181), // Rule ID 23267 //
     /*  212141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  212149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212166 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11395:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  212169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212179 */     GIR_RootConstrainSelectedInstOperands,
     /*  212180 */     // GIR_Coverage, 23267,
     /*  212180 */     GIR_EraseRootFromParent_Done,
     /*  212181 */   // Label 4222: @212181
     /*  212181 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(212226), // Rule ID 23268 //
     /*  212186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212211 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  212214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212224 */     GIR_RootConstrainSelectedInstOperands,
     /*  212225 */     // GIR_Coverage, 23268,
     /*  212225 */     GIR_EraseRootFromParent_Done,
     /*  212226 */   // Label 4223: @212226
     /*  212226 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(212271), // Rule ID 23269 //
     /*  212231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212256 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  212259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212269 */     GIR_RootConstrainSelectedInstOperands,
     /*  212270 */     // GIR_Coverage, 23269,
     /*  212270 */     GIR_EraseRootFromParent_Done,
     /*  212271 */   // Label 4224: @212271
     /*  212271 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(212316), // Rule ID 23270 //
     /*  212276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212301 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  212304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212314 */     GIR_RootConstrainSelectedInstOperands,
     /*  212315 */     // GIR_Coverage, 23270,
     /*  212315 */     GIR_EraseRootFromParent_Done,
     /*  212316 */   // Label 4225: @212316
     /*  212316 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(212361), // Rule ID 23271 //
     /*  212321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212346 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  212349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212359 */     GIR_RootConstrainSelectedInstOperands,
     /*  212360 */     // GIR_Coverage, 23271,
     /*  212360 */     GIR_EraseRootFromParent_Done,
     /*  212361 */   // Label 4226: @212361
     /*  212361 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(212406), // Rule ID 23272 //
     /*  212366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212391 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  212394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212404 */     GIR_RootConstrainSelectedInstOperands,
     /*  212405 */     // GIR_Coverage, 23272,
     /*  212405 */     GIR_EraseRootFromParent_Done,
     /*  212406 */   // Label 4227: @212406
     /*  212406 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(212451), // Rule ID 23273 //
     /*  212411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212436 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  212439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212449 */     GIR_RootConstrainSelectedInstOperands,
     /*  212450 */     // GIR_Coverage, 23273,
     /*  212450 */     GIR_EraseRootFromParent_Done,
     /*  212451 */   // Label 4228: @212451
     /*  212451 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(212496), // Rule ID 23274 //
     /*  212456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212481 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  212484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212494 */     GIR_RootConstrainSelectedInstOperands,
     /*  212495 */     // GIR_Coverage, 23274,
     /*  212495 */     GIR_EraseRootFromParent_Done,
     /*  212496 */   // Label 4229: @212496
     /*  212496 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(212541), // Rule ID 23275 //
     /*  212501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212526 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  212529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212539 */     GIR_RootConstrainSelectedInstOperands,
     /*  212540 */     // GIR_Coverage, 23275,
     /*  212540 */     GIR_EraseRootFromParent_Done,
     /*  212541 */   // Label 4230: @212541
     /*  212541 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(212586), // Rule ID 23276 //
     /*  212546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212571 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  212574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212584 */     GIR_RootConstrainSelectedInstOperands,
     /*  212585 */     // GIR_Coverage, 23276,
     /*  212585 */     GIR_EraseRootFromParent_Done,
     /*  212586 */   // Label 4231: @212586
     /*  212586 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(212631), // Rule ID 23277 //
     /*  212591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212616 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  212619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212629 */     GIR_RootConstrainSelectedInstOperands,
     /*  212630 */     // GIR_Coverage, 23277,
     /*  212630 */     GIR_EraseRootFromParent_Done,
     /*  212631 */   // Label 4232: @212631
     /*  212631 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(212676), // Rule ID 23278 //
     /*  212636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212661 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  212664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212674 */     GIR_RootConstrainSelectedInstOperands,
     /*  212675 */     // GIR_Coverage, 23278,
     /*  212675 */     GIR_EraseRootFromParent_Done,
     /*  212676 */   // Label 4233: @212676
     /*  212676 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(212721), // Rule ID 23279 //
     /*  212681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212706 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  212709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212719 */     GIR_RootConstrainSelectedInstOperands,
     /*  212720 */     // GIR_Coverage, 23279,
     /*  212720 */     GIR_EraseRootFromParent_Done,
     /*  212721 */   // Label 4234: @212721
     /*  212721 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(212766), // Rule ID 23280 //
     /*  212726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212751 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  212754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212764 */     GIR_RootConstrainSelectedInstOperands,
     /*  212765 */     // GIR_Coverage, 23280,
     /*  212765 */     GIR_EraseRootFromParent_Done,
     /*  212766 */   // Label 4235: @212766
     /*  212766 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(212811), // Rule ID 23281 //
     /*  212771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212796 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11423:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  212799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212809 */     GIR_RootConstrainSelectedInstOperands,
     /*  212810 */     // GIR_Coverage, 23281,
     /*  212810 */     GIR_EraseRootFromParent_Done,
     /*  212811 */   // Label 4236: @212811
     /*  212811 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(212847), // Rule ID 2643 //
     /*  212816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  212819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64im),
     /*  212824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  212827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212838 */     // (intrinsic_wo_chain:{ *:[i64] } 10943:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (AES64IM:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  212838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64IM),
     /*  212841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  212845 */     GIR_RootConstrainSelectedInstOperands,
     /*  212846 */     // GIR_Coverage, 2643,
     /*  212846 */     GIR_EraseRootFromParent_Done,
     /*  212847 */   // Label 4237: @212847
     /*  212847 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(212883), // Rule ID 2664 //
     /*  212852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  212855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0),
     /*  212860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  212863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212874 */     // (intrinsic_wo_chain:{ *:[i64] } 11090:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  212874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0),
     /*  212877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  212881 */     GIR_RootConstrainSelectedInstOperands,
     /*  212882 */     // GIR_Coverage, 2664,
     /*  212882 */     GIR_EraseRootFromParent_Done,
     /*  212883 */   // Label 4238: @212883
     /*  212883 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(212919), // Rule ID 2665 //
     /*  212888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  212891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1),
     /*  212896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  212899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212910 */     // (intrinsic_wo_chain:{ *:[i64] } 11093:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  212910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1),
     /*  212913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  212917 */     GIR_RootConstrainSelectedInstOperands,
     /*  212918 */     // GIR_Coverage, 2665,
     /*  212918 */     GIR_EraseRootFromParent_Done,
     /*  212919 */   // Label 4239: @212919
     /*  212919 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(212955), // Rule ID 2666 //
     /*  212924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  212927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0),
     /*  212932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  212935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212946 */     // (intrinsic_wo_chain:{ *:[i64] } 11096:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  212946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0),
     /*  212949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  212953 */     GIR_RootConstrainSelectedInstOperands,
     /*  212954 */     // GIR_Coverage, 2666,
     /*  212954 */     GIR_EraseRootFromParent_Done,
     /*  212955 */   // Label 4240: @212955
     /*  212955 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(212991), // Rule ID 2667 //
     /*  212960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  212963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1),
     /*  212968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  212971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212982 */     // (intrinsic_wo_chain:{ *:[i64] } 11098:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  212982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1),
     /*  212985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  212989 */     GIR_RootConstrainSelectedInstOperands,
     /*  212990 */     // GIR_Coverage, 2667,
     /*  212990 */     GIR_EraseRootFromParent_Done,
     /*  212991 */   // Label 4241: @212991
     /*  212991 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(213027), // Rule ID 64434 //
     /*  212996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  212999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_clb),
     /*  213004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  213010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213018 */     // (intrinsic_wo_chain:{ *:[i32] } 10963:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1)  =>  (CV_CLB:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  213018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLB),
     /*  213021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213025 */     GIR_RootConstrainSelectedInstOperands,
     /*  213026 */     // GIR_Coverage, 64434,
     /*  213026 */     GIR_EraseRootFromParent_Done,
     /*  213027 */   // Label 4242: @213027
     /*  213027 */   GIM_Reject,
     /*  213028 */ // Label 4208: @213028
     /*  213028 */ GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(220316),
     /*  213033 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  213036 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(213090), // Rule ID 2676 //
     /*  213041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  213055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213073 */     // (intrinsic_wo_chain:{ *:[i64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  213076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213088 */     GIR_RootConstrainSelectedInstOperands,
     /*  213089 */     // GIR_Coverage, 2676,
     /*  213089 */     GIR_EraseRootFromParent_Done,
     /*  213090 */   // Label 4244: @213090
     /*  213090 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(213144), // Rule ID 2677 //
     /*  213095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  213109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213127 */     // (intrinsic_wo_chain:{ *:[i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  213130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213142 */     GIR_RootConstrainSelectedInstOperands,
     /*  213143 */     // GIR_Coverage, 2677,
     /*  213143 */     GIR_EraseRootFromParent_Done,
     /*  213144 */   // Label 4245: @213144
     /*  213144 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(213198), // Rule ID 2682 //
     /*  213149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  213157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  213160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  213163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213181 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  213184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213196 */     GIR_RootConstrainSelectedInstOperands,
     /*  213197 */     // GIR_Coverage, 2682,
     /*  213197 */     GIR_EraseRootFromParent_Done,
     /*  213198 */   // Label 4246: @213198
     /*  213198 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(213252), // Rule ID 2683 //
     /*  213203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  213211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  213214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  213217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213235 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  213238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213250 */     GIR_RootConstrainSelectedInstOperands,
     /*  213251 */     // GIR_Coverage, 2683,
     /*  213251 */     GIR_EraseRootFromParent_Done,
     /*  213252 */   // Label 4247: @213252
     /*  213252 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(213309), // Rule ID 2702 //
     /*  213257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  213268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  213271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213289 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  213292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213307 */     GIR_RootConstrainSelectedInstOperands,
     /*  213308 */     // GIR_Coverage, 2702,
     /*  213308 */     GIR_EraseRootFromParent_Done,
     /*  213309 */   // Label 4248: @213309
     /*  213309 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(213366), // Rule ID 2703 //
     /*  213314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  213325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  213328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213346 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  213349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213364 */     GIR_RootConstrainSelectedInstOperands,
     /*  213365 */     // GIR_Coverage, 2703,
     /*  213365 */     GIR_EraseRootFromParent_Done,
     /*  213366 */   // Label 4249: @213366
     /*  213366 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(213420), // Rule ID 23282 //
     /*  213371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  213385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213403 */     // (intrinsic_wo_chain:{ *:[i64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  213406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213418 */     GIR_RootConstrainSelectedInstOperands,
     /*  213419 */     // GIR_Coverage, 23282,
     /*  213419 */     GIR_EraseRootFromParent_Done,
     /*  213420 */   // Label 4250: @213420
     /*  213420 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(213474), // Rule ID 23283 //
     /*  213425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  213439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213457 */     // (intrinsic_wo_chain:{ *:[i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  213460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213472 */     GIR_RootConstrainSelectedInstOperands,
     /*  213473 */     // GIR_Coverage, 23283,
     /*  213473 */     GIR_EraseRootFromParent_Done,
     /*  213474 */   // Label 4251: @213474
     /*  213474 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(213528), // Rule ID 23286 //
     /*  213479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  213493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213511 */     // (intrinsic_wo_chain:{ *:[i64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  213514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213526 */     GIR_RootConstrainSelectedInstOperands,
     /*  213527 */     // GIR_Coverage, 23286,
     /*  213527 */     GIR_EraseRootFromParent_Done,
     /*  213528 */   // Label 4252: @213528
     /*  213528 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(213582), // Rule ID 23287 //
     /*  213533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  213547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213565 */     // (intrinsic_wo_chain:{ *:[i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  213568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213580 */     GIR_RootConstrainSelectedInstOperands,
     /*  213581 */     // GIR_Coverage, 23287,
     /*  213581 */     GIR_EraseRootFromParent_Done,
     /*  213582 */   // Label 4253: @213582
     /*  213582 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(213636), // Rule ID 23290 //
     /*  213587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  213601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213619 */     // (intrinsic_wo_chain:{ *:[i64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  213622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213634 */     GIR_RootConstrainSelectedInstOperands,
     /*  213635 */     // GIR_Coverage, 23290,
     /*  213635 */     GIR_EraseRootFromParent_Done,
     /*  213636 */   // Label 4254: @213636
     /*  213636 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(213690), // Rule ID 23291 //
     /*  213641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  213655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213673 */     // (intrinsic_wo_chain:{ *:[i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  213676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213688 */     GIR_RootConstrainSelectedInstOperands,
     /*  213689 */     // GIR_Coverage, 23291,
     /*  213689 */     GIR_EraseRootFromParent_Done,
     /*  213690 */   // Label 4255: @213690
     /*  213690 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(213744), // Rule ID 23294 //
     /*  213695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  213709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213727 */     // (intrinsic_wo_chain:{ *:[i64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  213730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213742 */     GIR_RootConstrainSelectedInstOperands,
     /*  213743 */     // GIR_Coverage, 23294,
     /*  213743 */     GIR_EraseRootFromParent_Done,
     /*  213744 */   // Label 4256: @213744
     /*  213744 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(213798), // Rule ID 23295 //
     /*  213749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  213763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213781 */     // (intrinsic_wo_chain:{ *:[i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  213784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213796 */     GIR_RootConstrainSelectedInstOperands,
     /*  213797 */     // GIR_Coverage, 23295,
     /*  213797 */     GIR_EraseRootFromParent_Done,
     /*  213798 */   // Label 4257: @213798
     /*  213798 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(213852), // Rule ID 23298 //
     /*  213803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  213817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213835 */     // (intrinsic_wo_chain:{ *:[i64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  213838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213850 */     GIR_RootConstrainSelectedInstOperands,
     /*  213851 */     // GIR_Coverage, 23298,
     /*  213851 */     GIR_EraseRootFromParent_Done,
     /*  213852 */   // Label 4258: @213852
     /*  213852 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(213906), // Rule ID 23299 //
     /*  213857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  213871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213889 */     // (intrinsic_wo_chain:{ *:[i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  213892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213904 */     GIR_RootConstrainSelectedInstOperands,
     /*  213905 */     // GIR_Coverage, 23299,
     /*  213905 */     GIR_EraseRootFromParent_Done,
     /*  213906 */   // Label 4259: @213906
     /*  213906 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(213960), // Rule ID 23302 //
     /*  213911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  213925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213943 */     // (intrinsic_wo_chain:{ *:[i64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  213946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213958 */     GIR_RootConstrainSelectedInstOperands,
     /*  213959 */     // GIR_Coverage, 23302,
     /*  213959 */     GIR_EraseRootFromParent_Done,
     /*  213960 */   // Label 4260: @213960
     /*  213960 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(214014), // Rule ID 23303 //
     /*  213965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  213979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213997 */     // (intrinsic_wo_chain:{ *:[i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  214000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214012 */     GIR_RootConstrainSelectedInstOperands,
     /*  214013 */     // GIR_Coverage, 23303,
     /*  214013 */     GIR_EraseRootFromParent_Done,
     /*  214014 */   // Label 4261: @214014
     /*  214014 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(214068), // Rule ID 23306 //
     /*  214019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  214033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214051 */     // (intrinsic_wo_chain:{ *:[i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  214054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214066 */     GIR_RootConstrainSelectedInstOperands,
     /*  214067 */     // GIR_Coverage, 23306,
     /*  214067 */     GIR_EraseRootFromParent_Done,
     /*  214068 */   // Label 4262: @214068
     /*  214068 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(214122), // Rule ID 23307 //
     /*  214073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  214087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214105 */     // (intrinsic_wo_chain:{ *:[i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  214108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214120 */     GIR_RootConstrainSelectedInstOperands,
     /*  214121 */     // GIR_Coverage, 23307,
     /*  214121 */     GIR_EraseRootFromParent_Done,
     /*  214122 */   // Label 4263: @214122
     /*  214122 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(214176), // Rule ID 23310 //
     /*  214127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  214141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214159 */     // (intrinsic_wo_chain:{ *:[i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  214162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214174 */     GIR_RootConstrainSelectedInstOperands,
     /*  214175 */     // GIR_Coverage, 23310,
     /*  214175 */     GIR_EraseRootFromParent_Done,
     /*  214176 */   // Label 4264: @214176
     /*  214176 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(214230), // Rule ID 23311 //
     /*  214181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  214195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214213 */     // (intrinsic_wo_chain:{ *:[i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  214216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214228 */     GIR_RootConstrainSelectedInstOperands,
     /*  214229 */     // GIR_Coverage, 23311,
     /*  214229 */     GIR_EraseRootFromParent_Done,
     /*  214230 */   // Label 4265: @214230
     /*  214230 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(214284), // Rule ID 23314 //
     /*  214235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  214249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214267 */     // (intrinsic_wo_chain:{ *:[i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  214270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214282 */     GIR_RootConstrainSelectedInstOperands,
     /*  214283 */     // GIR_Coverage, 23314,
     /*  214283 */     GIR_EraseRootFromParent_Done,
     /*  214284 */   // Label 4266: @214284
     /*  214284 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(214338), // Rule ID 23315 //
     /*  214289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  214303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214321 */     // (intrinsic_wo_chain:{ *:[i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  214324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214336 */     GIR_RootConstrainSelectedInstOperands,
     /*  214337 */     // GIR_Coverage, 23315,
     /*  214337 */     GIR_EraseRootFromParent_Done,
     /*  214338 */   // Label 4267: @214338
     /*  214338 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(214392), // Rule ID 23318 //
     /*  214343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  214357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214375 */     // (intrinsic_wo_chain:{ *:[i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  214378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214390 */     GIR_RootConstrainSelectedInstOperands,
     /*  214391 */     // GIR_Coverage, 23318,
     /*  214391 */     GIR_EraseRootFromParent_Done,
     /*  214392 */   // Label 4268: @214392
     /*  214392 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(214446), // Rule ID 23319 //
     /*  214397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  214411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214429 */     // (intrinsic_wo_chain:{ *:[i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  214432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214444 */     GIR_RootConstrainSelectedInstOperands,
     /*  214445 */     // GIR_Coverage, 23319,
     /*  214445 */     GIR_EraseRootFromParent_Done,
     /*  214446 */   // Label 4269: @214446
     /*  214446 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(214500), // Rule ID 23322 //
     /*  214451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  214465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214483 */     // (intrinsic_wo_chain:{ *:[i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  214486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214498 */     GIR_RootConstrainSelectedInstOperands,
     /*  214499 */     // GIR_Coverage, 23322,
     /*  214499 */     GIR_EraseRootFromParent_Done,
     /*  214500 */   // Label 4270: @214500
     /*  214500 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(214554), // Rule ID 23323 //
     /*  214505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  214519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214537 */     // (intrinsic_wo_chain:{ *:[i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  214540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214552 */     GIR_RootConstrainSelectedInstOperands,
     /*  214553 */     // GIR_Coverage, 23323,
     /*  214553 */     GIR_EraseRootFromParent_Done,
     /*  214554 */   // Label 4271: @214554
     /*  214554 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(214608), // Rule ID 23326 //
     /*  214559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  214573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214591 */     // (intrinsic_wo_chain:{ *:[i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  214594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214606 */     GIR_RootConstrainSelectedInstOperands,
     /*  214607 */     // GIR_Coverage, 23326,
     /*  214607 */     GIR_EraseRootFromParent_Done,
     /*  214608 */   // Label 4272: @214608
     /*  214608 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(214662), // Rule ID 23327 //
     /*  214613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  214627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214645 */     // (intrinsic_wo_chain:{ *:[i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  214648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214660 */     GIR_RootConstrainSelectedInstOperands,
     /*  214661 */     // GIR_Coverage, 23327,
     /*  214661 */     GIR_EraseRootFromParent_Done,
     /*  214662 */   // Label 4273: @214662
     /*  214662 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(214716), // Rule ID 23330 //
     /*  214667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  214681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214699 */     // (intrinsic_wo_chain:{ *:[i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  214702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214714 */     GIR_RootConstrainSelectedInstOperands,
     /*  214715 */     // GIR_Coverage, 23330,
     /*  214715 */     GIR_EraseRootFromParent_Done,
     /*  214716 */   // Label 4274: @214716
     /*  214716 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(214770), // Rule ID 23331 //
     /*  214721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  214735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214753 */     // (intrinsic_wo_chain:{ *:[i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  214756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214768 */     GIR_RootConstrainSelectedInstOperands,
     /*  214769 */     // GIR_Coverage, 23331,
     /*  214769 */     GIR_EraseRootFromParent_Done,
     /*  214770 */   // Label 4275: @214770
     /*  214770 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(214824), // Rule ID 23334 //
     /*  214775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  214783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  214786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  214789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214807 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  214810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  214814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214822 */     GIR_RootConstrainSelectedInstOperands,
     /*  214823 */     // GIR_Coverage, 23334,
     /*  214823 */     GIR_EraseRootFromParent_Done,
     /*  214824 */   // Label 4276: @214824
     /*  214824 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(214878), // Rule ID 23335 //
     /*  214829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  214837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  214840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  214843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214861 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  214864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  214868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214876 */     GIR_RootConstrainSelectedInstOperands,
     /*  214877 */     // GIR_Coverage, 23335,
     /*  214877 */     GIR_EraseRootFromParent_Done,
     /*  214878 */   // Label 4277: @214878
     /*  214878 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(214932), // Rule ID 23338 //
     /*  214883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  214891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  214894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  214897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214915 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  214918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  214922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214930 */     GIR_RootConstrainSelectedInstOperands,
     /*  214931 */     // GIR_Coverage, 23338,
     /*  214931 */     GIR_EraseRootFromParent_Done,
     /*  214932 */   // Label 4278: @214932
     /*  214932 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(214986), // Rule ID 23339 //
     /*  214937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  214945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  214948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  214951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214969 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  214972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  214976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214984 */     GIR_RootConstrainSelectedInstOperands,
     /*  214985 */     // GIR_Coverage, 23339,
     /*  214985 */     GIR_EraseRootFromParent_Done,
     /*  214986 */   // Label 4279: @214986
     /*  214986 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(215040), // Rule ID 23342 //
     /*  214991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  214999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  215002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  215005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215023 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  215026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215038 */     GIR_RootConstrainSelectedInstOperands,
     /*  215039 */     // GIR_Coverage, 23342,
     /*  215039 */     GIR_EraseRootFromParent_Done,
     /*  215040 */   // Label 4280: @215040
     /*  215040 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(215094), // Rule ID 23343 //
     /*  215045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  215056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  215059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215077 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  215080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215092 */     GIR_RootConstrainSelectedInstOperands,
     /*  215093 */     // GIR_Coverage, 23343,
     /*  215093 */     GIR_EraseRootFromParent_Done,
     /*  215094 */   // Label 4281: @215094
     /*  215094 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(215148), // Rule ID 23346 //
     /*  215099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  215110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  215113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215131 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  215134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215146 */     GIR_RootConstrainSelectedInstOperands,
     /*  215147 */     // GIR_Coverage, 23346,
     /*  215147 */     GIR_EraseRootFromParent_Done,
     /*  215148 */   // Label 4282: @215148
     /*  215148 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(215202), // Rule ID 23347 //
     /*  215153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  215164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  215167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215185 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  215188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215200 */     GIR_RootConstrainSelectedInstOperands,
     /*  215201 */     // GIR_Coverage, 23347,
     /*  215201 */     GIR_EraseRootFromParent_Done,
     /*  215202 */   // Label 4283: @215202
     /*  215202 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(215256), // Rule ID 23350 //
     /*  215207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  215218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  215221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215239 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  215242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215254 */     GIR_RootConstrainSelectedInstOperands,
     /*  215255 */     // GIR_Coverage, 23350,
     /*  215255 */     GIR_EraseRootFromParent_Done,
     /*  215256 */   // Label 4284: @215256
     /*  215256 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(215310), // Rule ID 23351 //
     /*  215261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  215272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  215275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215293 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  215296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215308 */     GIR_RootConstrainSelectedInstOperands,
     /*  215309 */     // GIR_Coverage, 23351,
     /*  215309 */     GIR_EraseRootFromParent_Done,
     /*  215310 */   // Label 4285: @215310
     /*  215310 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(215364), // Rule ID 23354 //
     /*  215315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  215326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  215329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215347 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  215350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215362 */     GIR_RootConstrainSelectedInstOperands,
     /*  215363 */     // GIR_Coverage, 23354,
     /*  215363 */     GIR_EraseRootFromParent_Done,
     /*  215364 */   // Label 4286: @215364
     /*  215364 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(215418), // Rule ID 23355 //
     /*  215369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  215380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  215383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215401 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11419:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  215404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215416 */     GIR_RootConstrainSelectedInstOperands,
     /*  215417 */     // GIR_Coverage, 23355,
     /*  215417 */     GIR_EraseRootFromParent_Done,
     /*  215418 */   // Label 4287: @215418
     /*  215418 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(215472), // Rule ID 23358 //
     /*  215423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  215434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  215437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215455 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  215458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215470 */     GIR_RootConstrainSelectedInstOperands,
     /*  215471 */     // GIR_Coverage, 23358,
     /*  215471 */     GIR_EraseRootFromParent_Done,
     /*  215472 */   // Label 4288: @215472
     /*  215472 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(215526), // Rule ID 23359 //
     /*  215477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  215488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  215491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215509 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  215512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215524 */     GIR_RootConstrainSelectedInstOperands,
     /*  215525 */     // GIR_Coverage, 23359,
     /*  215525 */     GIR_EraseRootFromParent_Done,
     /*  215526 */   // Label 4289: @215526
     /*  215526 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(215580), // Rule ID 23362 //
     /*  215531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  215542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  215545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215563 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  215566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215578 */     GIR_RootConstrainSelectedInstOperands,
     /*  215579 */     // GIR_Coverage, 23362,
     /*  215579 */     GIR_EraseRootFromParent_Done,
     /*  215580 */   // Label 4290: @215580
     /*  215580 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(215634), // Rule ID 23363 //
     /*  215585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  215596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  215599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215617 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  215620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215632 */     GIR_RootConstrainSelectedInstOperands,
     /*  215633 */     // GIR_Coverage, 23363,
     /*  215633 */     GIR_EraseRootFromParent_Done,
     /*  215634 */   // Label 4291: @215634
     /*  215634 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(215688), // Rule ID 23366 //
     /*  215639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  215650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  215653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215671 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  215674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215686 */     GIR_RootConstrainSelectedInstOperands,
     /*  215687 */     // GIR_Coverage, 23366,
     /*  215687 */     GIR_EraseRootFromParent_Done,
     /*  215688 */   // Label 4292: @215688
     /*  215688 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(215742), // Rule ID 23367 //
     /*  215693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  215704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  215707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215725 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  215728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215740 */     GIR_RootConstrainSelectedInstOperands,
     /*  215741 */     // GIR_Coverage, 23367,
     /*  215741 */     GIR_EraseRootFromParent_Done,
     /*  215742 */   // Label 4293: @215742
     /*  215742 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(215796), // Rule ID 23370 //
     /*  215747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  215758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  215761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215779 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  215782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215794 */     GIR_RootConstrainSelectedInstOperands,
     /*  215795 */     // GIR_Coverage, 23370,
     /*  215795 */     GIR_EraseRootFromParent_Done,
     /*  215796 */   // Label 4294: @215796
     /*  215796 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(215850), // Rule ID 23371 //
     /*  215801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  215812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  215815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215833 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  215836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215848 */     GIR_RootConstrainSelectedInstOperands,
     /*  215849 */     // GIR_Coverage, 23371,
     /*  215849 */     GIR_EraseRootFromParent_Done,
     /*  215850 */   // Label 4295: @215850
     /*  215850 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(215904), // Rule ID 23374 //
     /*  215855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  215866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  215869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215887 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  215890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215902 */     GIR_RootConstrainSelectedInstOperands,
     /*  215903 */     // GIR_Coverage, 23374,
     /*  215903 */     GIR_EraseRootFromParent_Done,
     /*  215904 */   // Label 4296: @215904
     /*  215904 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(215958), // Rule ID 23375 //
     /*  215909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  215920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  215923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215941 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  215944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215956 */     GIR_RootConstrainSelectedInstOperands,
     /*  215957 */     // GIR_Coverage, 23375,
     /*  215957 */     GIR_EraseRootFromParent_Done,
     /*  215958 */   // Label 4297: @215958
     /*  215958 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(216012), // Rule ID 23378 //
     /*  215963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  215974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  215977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215995 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  215998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216010 */     GIR_RootConstrainSelectedInstOperands,
     /*  216011 */     // GIR_Coverage, 23378,
     /*  216011 */     GIR_EraseRootFromParent_Done,
     /*  216012 */   // Label 4298: @216012
     /*  216012 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(216066), // Rule ID 23379 //
     /*  216017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  216025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  216028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  216031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216049 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  216052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216064 */     GIR_RootConstrainSelectedInstOperands,
     /*  216065 */     // GIR_Coverage, 23379,
     /*  216065 */     GIR_EraseRootFromParent_Done,
     /*  216066 */   // Label 4299: @216066
     /*  216066 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(216120), // Rule ID 23382 //
     /*  216071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  216079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  216082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  216085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216103 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  216106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216118 */     GIR_RootConstrainSelectedInstOperands,
     /*  216119 */     // GIR_Coverage, 23382,
     /*  216119 */     GIR_EraseRootFromParent_Done,
     /*  216120 */   // Label 4300: @216120
     /*  216120 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(216174), // Rule ID 23383 //
     /*  216125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  216133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  216136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  216139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216157 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11432:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  216160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216172 */     GIR_RootConstrainSelectedInstOperands,
     /*  216173 */     // GIR_Coverage, 23383,
     /*  216173 */     GIR_EraseRootFromParent_Done,
     /*  216174 */   // Label 4301: @216174
     /*  216174 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(216228), // Rule ID 23386 //
     /*  216179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  216193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216211 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  216214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216226 */     GIR_RootConstrainSelectedInstOperands,
     /*  216227 */     // GIR_Coverage, 23386,
     /*  216227 */     GIR_EraseRootFromParent_Done,
     /*  216228 */   // Label 4302: @216228
     /*  216228 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(216282), // Rule ID 23387 //
     /*  216233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  216247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216265 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  216268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216280 */     GIR_RootConstrainSelectedInstOperands,
     /*  216281 */     // GIR_Coverage, 23387,
     /*  216281 */     GIR_EraseRootFromParent_Done,
     /*  216282 */   // Label 4303: @216282
     /*  216282 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(216336), // Rule ID 23390 //
     /*  216287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  216298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  216301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216319 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  216322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216334 */     GIR_RootConstrainSelectedInstOperands,
     /*  216335 */     // GIR_Coverage, 23390,
     /*  216335 */     GIR_EraseRootFromParent_Done,
     /*  216336 */   // Label 4304: @216336
     /*  216336 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(216390), // Rule ID 23391 //
     /*  216341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  216352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  216355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216373 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  216376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216388 */     GIR_RootConstrainSelectedInstOperands,
     /*  216389 */     // GIR_Coverage, 23391,
     /*  216389 */     GIR_EraseRootFromParent_Done,
     /*  216390 */   // Label 4305: @216390
     /*  216390 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(216444), // Rule ID 23394 //
     /*  216395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  216406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  216409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216427 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  216430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216442 */     GIR_RootConstrainSelectedInstOperands,
     /*  216443 */     // GIR_Coverage, 23394,
     /*  216443 */     GIR_EraseRootFromParent_Done,
     /*  216444 */   // Label 4306: @216444
     /*  216444 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(216498), // Rule ID 23395 //
     /*  216449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  216460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  216463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216481 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  216484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216496 */     GIR_RootConstrainSelectedInstOperands,
     /*  216497 */     // GIR_Coverage, 23395,
     /*  216497 */     GIR_EraseRootFromParent_Done,
     /*  216498 */   // Label 4307: @216498
     /*  216498 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(216552), // Rule ID 23398 //
     /*  216503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  216514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  216517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216535 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  216538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216550 */     GIR_RootConstrainSelectedInstOperands,
     /*  216551 */     // GIR_Coverage, 23398,
     /*  216551 */     GIR_EraseRootFromParent_Done,
     /*  216552 */   // Label 4308: @216552
     /*  216552 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(216606), // Rule ID 23399 //
     /*  216557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  216568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  216571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216589 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  216592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216604 */     GIR_RootConstrainSelectedInstOperands,
     /*  216605 */     // GIR_Coverage, 23399,
     /*  216605 */     GIR_EraseRootFromParent_Done,
     /*  216606 */   // Label 4309: @216606
     /*  216606 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(216660), // Rule ID 23402 //
     /*  216611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  216622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  216625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216643 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  216646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216658 */     GIR_RootConstrainSelectedInstOperands,
     /*  216659 */     // GIR_Coverage, 23402,
     /*  216659 */     GIR_EraseRootFromParent_Done,
     /*  216660 */   // Label 4310: @216660
     /*  216660 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(216714), // Rule ID 23403 //
     /*  216665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  216676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  216679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216697 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  216700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216712 */     GIR_RootConstrainSelectedInstOperands,
     /*  216713 */     // GIR_Coverage, 23403,
     /*  216713 */     GIR_EraseRootFromParent_Done,
     /*  216714 */   // Label 4311: @216714
     /*  216714 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(216768), // Rule ID 23406 //
     /*  216719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  216730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  216733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216751 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  216754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216766 */     GIR_RootConstrainSelectedInstOperands,
     /*  216767 */     // GIR_Coverage, 23406,
     /*  216767 */     GIR_EraseRootFromParent_Done,
     /*  216768 */   // Label 4312: @216768
     /*  216768 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(216822), // Rule ID 23407 //
     /*  216773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  216784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  216787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216805 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  216808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216820 */     GIR_RootConstrainSelectedInstOperands,
     /*  216821 */     // GIR_Coverage, 23407,
     /*  216821 */     GIR_EraseRootFromParent_Done,
     /*  216822 */   // Label 4313: @216822
     /*  216822 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(216876), // Rule ID 23410 //
     /*  216827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  216838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  216841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216859 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  216862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216874 */     GIR_RootConstrainSelectedInstOperands,
     /*  216875 */     // GIR_Coverage, 23410,
     /*  216875 */     GIR_EraseRootFromParent_Done,
     /*  216876 */   // Label 4314: @216876
     /*  216876 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(216930), // Rule ID 23411 //
     /*  216881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  216892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  216895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216913 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  216916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216928 */     GIR_RootConstrainSelectedInstOperands,
     /*  216929 */     // GIR_Coverage, 23411,
     /*  216929 */     GIR_EraseRootFromParent_Done,
     /*  216930 */   // Label 4315: @216930
     /*  216930 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(216987), // Rule ID 23498 //
     /*  216935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  216943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  216946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  216949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216967 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  216967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  216970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216985 */     GIR_RootConstrainSelectedInstOperands,
     /*  216986 */     // GIR_Coverage, 23498,
     /*  216986 */     GIR_EraseRootFromParent_Done,
     /*  216987 */   // Label 4316: @216987
     /*  216987 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(217044), // Rule ID 23499 //
     /*  216992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  217003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  217006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217024 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  217024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  217027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217042 */     GIR_RootConstrainSelectedInstOperands,
     /*  217043 */     // GIR_Coverage, 23499,
     /*  217043 */     GIR_EraseRootFromParent_Done,
     /*  217044 */   // Label 4317: @217044
     /*  217044 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(217101), // Rule ID 23502 //
     /*  217049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  217060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  217063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217081 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11298:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  217081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  217084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217099 */     GIR_RootConstrainSelectedInstOperands,
     /*  217100 */     // GIR_Coverage, 23502,
     /*  217100 */     GIR_EraseRootFromParent_Done,
     /*  217101 */   // Label 4318: @217101
     /*  217101 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(217158), // Rule ID 23503 //
     /*  217106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  217117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  217120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217138 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11298:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  217138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  217141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217156 */     GIR_RootConstrainSelectedInstOperands,
     /*  217157 */     // GIR_Coverage, 23503,
     /*  217157 */     GIR_EraseRootFromParent_Done,
     /*  217158 */   // Label 4319: @217158
     /*  217158 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(217215), // Rule ID 23506 //
     /*  217163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  217174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  217177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217195 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  217195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  217198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217213 */     GIR_RootConstrainSelectedInstOperands,
     /*  217214 */     // GIR_Coverage, 23506,
     /*  217214 */     GIR_EraseRootFromParent_Done,
     /*  217215 */   // Label 4320: @217215
     /*  217215 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(217272), // Rule ID 23507 //
     /*  217220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  217231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  217234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217252 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  217252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  217255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217270 */     GIR_RootConstrainSelectedInstOperands,
     /*  217271 */     // GIR_Coverage, 23507,
     /*  217271 */     GIR_EraseRootFromParent_Done,
     /*  217272 */   // Label 4321: @217272
     /*  217272 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(217329), // Rule ID 23510 //
     /*  217277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  217288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217309 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  217309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  217312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217327 */     GIR_RootConstrainSelectedInstOperands,
     /*  217328 */     // GIR_Coverage, 23510,
     /*  217328 */     GIR_EraseRootFromParent_Done,
     /*  217329 */   // Label 4322: @217329
     /*  217329 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(217386), // Rule ID 23511 //
     /*  217334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  217345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  217366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  217369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217384 */     GIR_RootConstrainSelectedInstOperands,
     /*  217385 */     // GIR_Coverage, 23511,
     /*  217385 */     GIR_EraseRootFromParent_Done,
     /*  217386 */   // Label 4323: @217386
     /*  217386 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(217443), // Rule ID 23514 //
     /*  217391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  217402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217423 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  217423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  217426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217441 */     GIR_RootConstrainSelectedInstOperands,
     /*  217442 */     // GIR_Coverage, 23514,
     /*  217442 */     GIR_EraseRootFromParent_Done,
     /*  217443 */   // Label 4324: @217443
     /*  217443 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(217500), // Rule ID 23515 //
     /*  217448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  217459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217480 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  217480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  217483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217498 */     GIR_RootConstrainSelectedInstOperands,
     /*  217499 */     // GIR_Coverage, 23515,
     /*  217499 */     GIR_EraseRootFromParent_Done,
     /*  217500 */   // Label 4325: @217500
     /*  217500 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(217557), // Rule ID 23518 //
     /*  217505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  217516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  217519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217537 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11298:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  217537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217555 */     GIR_RootConstrainSelectedInstOperands,
     /*  217556 */     // GIR_Coverage, 23518,
     /*  217556 */     GIR_EraseRootFromParent_Done,
     /*  217557 */   // Label 4326: @217557
     /*  217557 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(217614), // Rule ID 23519 //
     /*  217562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  217573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  217576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217594 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11298:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  217594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217612 */     GIR_RootConstrainSelectedInstOperands,
     /*  217613 */     // GIR_Coverage, 23519,
     /*  217613 */     GIR_EraseRootFromParent_Done,
     /*  217614 */   // Label 4327: @217614
     /*  217614 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(217671), // Rule ID 23522 //
     /*  217619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  217630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  217633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217651 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  217651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217669 */     GIR_RootConstrainSelectedInstOperands,
     /*  217670 */     // GIR_Coverage, 23522,
     /*  217670 */     GIR_EraseRootFromParent_Done,
     /*  217671 */   // Label 4328: @217671
     /*  217671 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(217728), // Rule ID 23523 //
     /*  217676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  217687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  217690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  217708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217726 */     GIR_RootConstrainSelectedInstOperands,
     /*  217727 */     // GIR_Coverage, 23523,
     /*  217727 */     GIR_EraseRootFromParent_Done,
     /*  217728 */   // Label 4329: @217728
     /*  217728 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(217785), // Rule ID 23526 //
     /*  217733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  217744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  217747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  217765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217783 */     GIR_RootConstrainSelectedInstOperands,
     /*  217784 */     // GIR_Coverage, 23526,
     /*  217784 */     GIR_EraseRootFromParent_Done,
     /*  217785 */   // Label 4330: @217785
     /*  217785 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(217842), // Rule ID 23527 //
     /*  217790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  217801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  217804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217822 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  217822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217840 */     GIR_RootConstrainSelectedInstOperands,
     /*  217841 */     // GIR_Coverage, 23527,
     /*  217841 */     GIR_EraseRootFromParent_Done,
     /*  217842 */   // Label 4331: @217842
     /*  217842 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(217899), // Rule ID 23530 //
     /*  217847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  217850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  217858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  217861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217879 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  217879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  217894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217897 */     GIR_RootConstrainSelectedInstOperands,
     /*  217898 */     // GIR_Coverage, 23530,
     /*  217898 */     GIR_EraseRootFromParent_Done,
     /*  217899 */   // Label 4332: @217899
     /*  217899 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(217956), // Rule ID 23531 //
     /*  217904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  217907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  217915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  217918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217936 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  217936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  217951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217954 */     GIR_RootConstrainSelectedInstOperands,
     /*  217955 */     // GIR_Coverage, 23531,
     /*  217955 */     GIR_EraseRootFromParent_Done,
     /*  217956 */   // Label 4333: @217956
     /*  217956 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(218013), // Rule ID 23534 //
     /*  217961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  217972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  217975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217993 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  217993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  217996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218011 */     GIR_RootConstrainSelectedInstOperands,
     /*  218012 */     // GIR_Coverage, 23534,
     /*  218012 */     GIR_EraseRootFromParent_Done,
     /*  218013 */   // Label 4334: @218013
     /*  218013 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(218070), // Rule ID 23535 //
     /*  218018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  218029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  218032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218050 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  218050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  218053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218068 */     GIR_RootConstrainSelectedInstOperands,
     /*  218069 */     // GIR_Coverage, 23535,
     /*  218069 */     GIR_EraseRootFromParent_Done,
     /*  218070 */   // Label 4335: @218070
     /*  218070 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(218127), // Rule ID 23538 //
     /*  218075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  218086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  218089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218107 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  218107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  218110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218125 */     GIR_RootConstrainSelectedInstOperands,
     /*  218126 */     // GIR_Coverage, 23538,
     /*  218126 */     GIR_EraseRootFromParent_Done,
     /*  218127 */   // Label 4336: @218127
     /*  218127 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(218184), // Rule ID 23539 //
     /*  218132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  218143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  218146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218164 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  218164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  218167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218182 */     GIR_RootConstrainSelectedInstOperands,
     /*  218183 */     // GIR_Coverage, 23539,
     /*  218183 */     GIR_EraseRootFromParent_Done,
     /*  218184 */   // Label 4337: @218184
     /*  218184 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(218241), // Rule ID 23542 //
     /*  218189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  218200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  218203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218221 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  218221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  218224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218239 */     GIR_RootConstrainSelectedInstOperands,
     /*  218240 */     // GIR_Coverage, 23542,
     /*  218240 */     GIR_EraseRootFromParent_Done,
     /*  218241 */   // Label 4338: @218241
     /*  218241 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(218298), // Rule ID 23543 //
     /*  218246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  218257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  218260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218278 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  218278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  218281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218296 */     GIR_RootConstrainSelectedInstOperands,
     /*  218297 */     // GIR_Coverage, 23543,
     /*  218297 */     GIR_EraseRootFromParent_Done,
     /*  218298 */   // Label 4339: @218298
     /*  218298 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(218355), // Rule ID 23546 //
     /*  218303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  218314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  218317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218335 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  218335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  218338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218353 */     GIR_RootConstrainSelectedInstOperands,
     /*  218354 */     // GIR_Coverage, 23546,
     /*  218354 */     GIR_EraseRootFromParent_Done,
     /*  218355 */   // Label 4340: @218355
     /*  218355 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(218412), // Rule ID 23547 //
     /*  218360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  218371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  218374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  218392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  218395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218410 */     GIR_RootConstrainSelectedInstOperands,
     /*  218411 */     // GIR_Coverage, 23547,
     /*  218411 */     GIR_EraseRootFromParent_Done,
     /*  218412 */   // Label 4341: @218412
     /*  218412 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(218469), // Rule ID 23550 //
     /*  218417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  218428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  218431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218449 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  218449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  218452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218467 */     GIR_RootConstrainSelectedInstOperands,
     /*  218468 */     // GIR_Coverage, 23550,
     /*  218468 */     GIR_EraseRootFromParent_Done,
     /*  218469 */   // Label 4342: @218469
     /*  218469 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(218526), // Rule ID 23551 //
     /*  218474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  218485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  218488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218506 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  218506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  218509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218524 */     GIR_RootConstrainSelectedInstOperands,
     /*  218525 */     // GIR_Coverage, 23551,
     /*  218525 */     GIR_EraseRootFromParent_Done,
     /*  218526 */   // Label 4343: @218526
     /*  218526 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(218583), // Rule ID 23554 //
     /*  218531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  218542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  218545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218563 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  218563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  218566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218581 */     GIR_RootConstrainSelectedInstOperands,
     /*  218582 */     // GIR_Coverage, 23554,
     /*  218582 */     GIR_EraseRootFromParent_Done,
     /*  218583 */   // Label 4344: @218583
     /*  218583 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(218640), // Rule ID 23555 //
     /*  218588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  218599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  218602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218620 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  218620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  218623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218638 */     GIR_RootConstrainSelectedInstOperands,
     /*  218639 */     // GIR_Coverage, 23555,
     /*  218639 */     GIR_EraseRootFromParent_Done,
     /*  218640 */   // Label 4345: @218640
     /*  218640 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(218697), // Rule ID 23558 //
     /*  218645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  218656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  218659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218677 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  218677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  218680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218695 */     GIR_RootConstrainSelectedInstOperands,
     /*  218696 */     // GIR_Coverage, 23558,
     /*  218696 */     GIR_EraseRootFromParent_Done,
     /*  218697 */   // Label 4346: @218697
     /*  218697 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(218754), // Rule ID 23559 //
     /*  218702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  218713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  218716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  218734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  218737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218752 */     GIR_RootConstrainSelectedInstOperands,
     /*  218753 */     // GIR_Coverage, 23559,
     /*  218753 */     GIR_EraseRootFromParent_Done,
     /*  218754 */   // Label 4347: @218754
     /*  218754 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(218811), // Rule ID 23562 //
     /*  218759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  218770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  218773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218791 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  218791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  218794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218809 */     GIR_RootConstrainSelectedInstOperands,
     /*  218810 */     // GIR_Coverage, 23562,
     /*  218810 */     GIR_EraseRootFromParent_Done,
     /*  218811 */   // Label 4348: @218811
     /*  218811 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(218868), // Rule ID 23563 //
     /*  218816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  218827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  218830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218848 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  218848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  218851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218866 */     GIR_RootConstrainSelectedInstOperands,
     /*  218867 */     // GIR_Coverage, 23563,
     /*  218867 */     GIR_EraseRootFromParent_Done,
     /*  218868 */   // Label 4349: @218868
     /*  218868 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(218925), // Rule ID 23566 //
     /*  218873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  218884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  218887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218905 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  218905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  218908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218923 */     GIR_RootConstrainSelectedInstOperands,
     /*  218924 */     // GIR_Coverage, 23566,
     /*  218924 */     GIR_EraseRootFromParent_Done,
     /*  218925 */   // Label 4350: @218925
     /*  218925 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(218982), // Rule ID 23567 //
     /*  218930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  218941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  218944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218962 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  218962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  218965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218980 */     GIR_RootConstrainSelectedInstOperands,
     /*  218981 */     // GIR_Coverage, 23567,
     /*  218981 */     GIR_EraseRootFromParent_Done,
     /*  218982 */   // Label 4351: @218982
     /*  218982 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(219039), // Rule ID 23570 //
     /*  218987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  218990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  218998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  219001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219019 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  219019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  219022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219037 */     GIR_RootConstrainSelectedInstOperands,
     /*  219038 */     // GIR_Coverage, 23570,
     /*  219038 */     GIR_EraseRootFromParent_Done,
     /*  219039 */   // Label 4352: @219039
     /*  219039 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(219096), // Rule ID 23571 //
     /*  219044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  219052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  219055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  219058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  219076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  219079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219094 */     GIR_RootConstrainSelectedInstOperands,
     /*  219095 */     // GIR_Coverage, 23571,
     /*  219095 */     GIR_EraseRootFromParent_Done,
     /*  219096 */   // Label 4353: @219096
     /*  219096 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(219153), // Rule ID 23574 //
     /*  219101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  219109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  219112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  219115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219133 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  219133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  219136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219151 */     GIR_RootConstrainSelectedInstOperands,
     /*  219152 */     // GIR_Coverage, 23574,
     /*  219152 */     GIR_EraseRootFromParent_Done,
     /*  219153 */   // Label 4354: @219153
     /*  219153 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(219210), // Rule ID 23575 //
     /*  219158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  219166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  219169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  219172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219190 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  219190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  219193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219208 */     GIR_RootConstrainSelectedInstOperands,
     /*  219209 */     // GIR_Coverage, 23575,
     /*  219209 */     GIR_EraseRootFromParent_Done,
     /*  219210 */   // Label 4355: @219210
     /*  219210 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(219267), // Rule ID 23578 //
     /*  219215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  219223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  219226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  219229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219247 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  219247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  219250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219265 */     GIR_RootConstrainSelectedInstOperands,
     /*  219266 */     // GIR_Coverage, 23578,
     /*  219266 */     GIR_EraseRootFromParent_Done,
     /*  219267 */   // Label 4356: @219267
     /*  219267 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(219324), // Rule ID 23579 //
     /*  219272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  219280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  219283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  219286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219304 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  219304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  219307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219322 */     GIR_RootConstrainSelectedInstOperands,
     /*  219323 */     // GIR_Coverage, 23579,
     /*  219323 */     GIR_EraseRootFromParent_Done,
     /*  219324 */   // Label 4357: @219324
     /*  219324 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(219370), // Rule ID 2645 //
     /*  219329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  219332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks1i),
     /*  219337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219351 */     // MIs[0] rnum
     /*  219351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  219354 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_rnum),
     /*  219359 */     // (intrinsic_wo_chain:{ *:[i64] } 10944:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)  =>  (AES64KS1I:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)
     /*  219359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS1I),
     /*  219362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rnum
     /*  219368 */     GIR_RootConstrainSelectedInstOperands,
     /*  219369 */     // GIR_Coverage, 2645,
     /*  219369 */     GIR_EraseRootFromParent_Done,
     /*  219370 */   // Label 4358: @219370
     /*  219370 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(219415), // Rule ID 64442 //
     /*  219375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  219378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clip),
     /*  219383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219404 */     // (intrinsic_wo_chain:{ *:[i32] } 10954:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPR),
     /*  219407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219413 */     GIR_RootConstrainSelectedInstOperands,
     /*  219414 */     // GIR_Coverage, 64442,
     /*  219414 */     GIR_EraseRootFromParent_Done,
     /*  219415 */   // Label 4359: @219415
     /*  219415 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(219460), // Rule ID 64469 //
     /*  219420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  219423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clipu),
     /*  219428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219449 */     // (intrinsic_wo_chain:{ *:[i32] } 10955:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPUR),
     /*  219452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219458 */     GIR_RootConstrainSelectedInstOperands,
     /*  219459 */     // GIR_Coverage, 64469,
     /*  219459 */     GIR_EraseRootFromParent_Done,
     /*  219460 */   // Label 4360: @219460
     /*  219460 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(219505), // Rule ID 2635 //
     /*  219465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  219468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  219473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219494 */     // (intrinsic_wo_chain:{ *:[i64] } 11656:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM4:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  219497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219503 */     GIR_RootConstrainSelectedInstOperands,
     /*  219504 */     // GIR_Coverage, 2635,
     /*  219504 */     GIR_EraseRootFromParent_Done,
     /*  219505 */   // Label 4361: @219505
     /*  219505 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(219550), // Rule ID 2636 //
     /*  219510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  219513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  219518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219539 */     // (intrinsic_wo_chain:{ *:[i32] } 11656:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM4:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  219542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219548 */     GIR_RootConstrainSelectedInstOperands,
     /*  219549 */     // GIR_Coverage, 2636,
     /*  219549 */     GIR_EraseRootFromParent_Done,
     /*  219550 */   // Label 4362: @219550
     /*  219550 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(219595), // Rule ID 2637 //
     /*  219555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  219558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  219563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219584 */     // (intrinsic_wo_chain:{ *:[i64] } 11657:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM8:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  219587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219593 */     GIR_RootConstrainSelectedInstOperands,
     /*  219594 */     // GIR_Coverage, 2637,
     /*  219594 */     GIR_EraseRootFromParent_Done,
     /*  219595 */   // Label 4363: @219595
     /*  219595 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(219640), // Rule ID 2638 //
     /*  219600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  219603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  219608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219629 */     // (intrinsic_wo_chain:{ *:[i32] } 11657:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM8:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  219632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219638 */     GIR_RootConstrainSelectedInstOperands,
     /*  219639 */     // GIR_Coverage, 2638,
     /*  219639 */     GIR_EraseRootFromParent_Done,
     /*  219640 */   // Label 4364: @219640
     /*  219640 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(219685), // Rule ID 2641 //
     /*  219645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  219648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ds),
     /*  219653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219674 */     // (intrinsic_wo_chain:{ *:[i64] } 10939:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DS),
     /*  219677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219683 */     GIR_RootConstrainSelectedInstOperands,
     /*  219684 */     // GIR_Coverage, 2641,
     /*  219684 */     GIR_EraseRootFromParent_Done,
     /*  219685 */   // Label 4365: @219685
     /*  219685 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(219730), // Rule ID 2642 //
     /*  219690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  219693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64dsm),
     /*  219698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219719 */     // (intrinsic_wo_chain:{ *:[i64] } 10940:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DSM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DSM),
     /*  219722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219728 */     GIR_RootConstrainSelectedInstOperands,
     /*  219729 */     // GIR_Coverage, 2642,
     /*  219729 */     GIR_EraseRootFromParent_Done,
     /*  219730 */   // Label 4366: @219730
     /*  219730 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(219775), // Rule ID 2644 //
     /*  219735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  219738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks2),
     /*  219743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219764 */     // (intrinsic_wo_chain:{ *:[i64] } 10945:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64KS2:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS2),
     /*  219767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219773 */     GIR_RootConstrainSelectedInstOperands,
     /*  219774 */     // GIR_Coverage, 2644,
     /*  219774 */     GIR_EraseRootFromParent_Done,
     /*  219775 */   // Label 4367: @219775
     /*  219775 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(219820), // Rule ID 2648 //
     /*  219780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  219783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64es),
     /*  219788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219809 */     // (intrinsic_wo_chain:{ *:[i64] } 10941:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ES:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ES),
     /*  219812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219818 */     GIR_RootConstrainSelectedInstOperands,
     /*  219819 */     // GIR_Coverage, 2648,
     /*  219819 */     GIR_EraseRootFromParent_Done,
     /*  219820 */   // Label 4368: @219820
     /*  219820 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(219865), // Rule ID 2649 //
     /*  219825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  219828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64esm),
     /*  219833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219854 */     // (intrinsic_wo_chain:{ *:[i64] } 10942:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ESM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ESM),
     /*  219857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219863 */     GIR_RootConstrainSelectedInstOperands,
     /*  219864 */     // GIR_Coverage, 2649,
     /*  219864 */     GIR_EraseRootFromParent_Done,
     /*  219865 */   // Label 4369: @219865
     /*  219865 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(219910), // Rule ID 2658 //
     /*  219870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  219873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0l),
     /*  219878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219899 */     // (intrinsic_wo_chain:{ *:[i32] } 11092:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0L),
     /*  219902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219908 */     GIR_RootConstrainSelectedInstOperands,
     /*  219909 */     // GIR_Coverage, 2658,
     /*  219909 */     GIR_EraseRootFromParent_Done,
     /*  219910 */   // Label 4370: @219910
     /*  219910 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(219955), // Rule ID 2659 //
     /*  219915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  219918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0h),
     /*  219923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219944 */     // (intrinsic_wo_chain:{ *:[i32] } 11091:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0H),
     /*  219947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219953 */     GIR_RootConstrainSelectedInstOperands,
     /*  219954 */     // GIR_Coverage, 2659,
     /*  219954 */     GIR_EraseRootFromParent_Done,
     /*  219955 */   // Label 4371: @219955
     /*  219955 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(220000), // Rule ID 2660 //
     /*  219960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  219963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1l),
     /*  219968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219989 */     // (intrinsic_wo_chain:{ *:[i32] } 11095:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1L),
     /*  219992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219998 */     GIR_RootConstrainSelectedInstOperands,
     /*  219999 */     // GIR_Coverage, 2660,
     /*  219999 */     GIR_EraseRootFromParent_Done,
     /*  220000 */   // Label 4372: @220000
     /*  220000 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(220045), // Rule ID 2661 //
     /*  220005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  220008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1h),
     /*  220013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220034 */     // (intrinsic_wo_chain:{ *:[i32] } 11094:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1H),
     /*  220037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220043 */     GIR_RootConstrainSelectedInstOperands,
     /*  220044 */     // GIR_Coverage, 2661,
     /*  220044 */     GIR_EraseRootFromParent_Done,
     /*  220045 */   // Label 4373: @220045
     /*  220045 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(220090), // Rule ID 2662 //
     /*  220050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  220053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0r),
     /*  220058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220079 */     // (intrinsic_wo_chain:{ *:[i32] } 11097:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM0R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0R),
     /*  220082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220088 */     GIR_RootConstrainSelectedInstOperands,
     /*  220089 */     // GIR_Coverage, 2662,
     /*  220089 */     GIR_EraseRootFromParent_Done,
     /*  220090 */   // Label 4374: @220090
     /*  220090 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(220135), // Rule ID 2663 //
     /*  220095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  220098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1r),
     /*  220103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220124 */     // (intrinsic_wo_chain:{ *:[i32] } 11099:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM1R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1R),
     /*  220127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220133 */     GIR_RootConstrainSelectedInstOperands,
     /*  220134 */     // GIR_Coverage, 2663,
     /*  220134 */     GIR_EraseRootFromParent_Done,
     /*  220135 */   // Label 4375: @220135
     /*  220135 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(220180), // Rule ID 64419 //
     /*  220140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  220143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extract),
     /*  220148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220169 */     // (intrinsic_wo_chain:{ *:[i32] } 10964:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTR),
     /*  220172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220178 */     GIR_RootConstrainSelectedInstOperands,
     /*  220179 */     // GIR_Coverage, 64419,
     /*  220179 */     GIR_EraseRootFromParent_Done,
     /*  220180 */   // Label 4376: @220180
     /*  220180 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(220225), // Rule ID 64421 //
     /*  220185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  220188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extractu),
     /*  220193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220214 */     // (intrinsic_wo_chain:{ *:[i32] } 10965:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTUR),
     /*  220217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220223 */     GIR_RootConstrainSelectedInstOperands,
     /*  220224 */     // GIR_Coverage, 64421,
     /*  220224 */     GIR_EraseRootFromParent_Done,
     /*  220225 */   // Label 4377: @220225
     /*  220225 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(220270), // Rule ID 64423 //
     /*  220230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  220233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bclr),
     /*  220238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220259 */     // (intrinsic_wo_chain:{ *:[i32] } 10960:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BCLRR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BCLRR),
     /*  220262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220268 */     GIR_RootConstrainSelectedInstOperands,
     /*  220269 */     // GIR_Coverage, 64423,
     /*  220269 */     GIR_EraseRootFromParent_Done,
     /*  220270 */   // Label 4378: @220270
     /*  220270 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(220315), // Rule ID 64425 //
     /*  220275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  220278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bset),
     /*  220283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220304 */     // (intrinsic_wo_chain:{ *:[i32] } 10962:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BSETR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BSETR),
     /*  220307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220313 */     GIR_RootConstrainSelectedInstOperands,
     /*  220314 */     // GIR_Coverage, 64425,
     /*  220314 */     GIR_EraseRootFromParent_Done,
     /*  220315 */   // Label 4379: @220315
     /*  220315 */   GIM_Reject,
     /*  220316 */ // Label 4243: @220316
     /*  220316 */ GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(391221),
     /*  220321 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  220324 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(220398), // Rule ID 5456 //
     /*  220329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  220343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220369 */     // MIs[1] Operand 1
     /*  220369 */     // No operand predicates
     /*  220369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220378 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  220381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220396 */     GIR_RootConstrainSelectedInstOperands,
     /*  220397 */     // GIR_Coverage, 5456,
     /*  220397 */     GIR_EraseRootFromParent_Done,
     /*  220398 */   // Label 4381: @220398
     /*  220398 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(220472), // Rule ID 5457 //
     /*  220403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  220417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220443 */     // MIs[1] Operand 1
     /*  220443 */     // No operand predicates
     /*  220443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220452 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  220455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220470 */     GIR_RootConstrainSelectedInstOperands,
     /*  220471 */     // GIR_Coverage, 5457,
     /*  220471 */     GIR_EraseRootFromParent_Done,
     /*  220472 */   // Label 4382: @220472
     /*  220472 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(220546), // Rule ID 5458 //
     /*  220477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  220491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220517 */     // MIs[1] Operand 1
     /*  220517 */     // No operand predicates
     /*  220517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220526 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  220529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220544 */     GIR_RootConstrainSelectedInstOperands,
     /*  220545 */     // GIR_Coverage, 5458,
     /*  220545 */     GIR_EraseRootFromParent_Done,
     /*  220546 */   // Label 4383: @220546
     /*  220546 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(220620), // Rule ID 5459 //
     /*  220551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  220565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220591 */     // MIs[1] Operand 1
     /*  220591 */     // No operand predicates
     /*  220591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220600 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  220603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220618 */     GIR_RootConstrainSelectedInstOperands,
     /*  220619 */     // GIR_Coverage, 5459,
     /*  220619 */     GIR_EraseRootFromParent_Done,
     /*  220620 */   // Label 4384: @220620
     /*  220620 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(220694), // Rule ID 5460 //
     /*  220625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  220639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220665 */     // MIs[1] Operand 1
     /*  220665 */     // No operand predicates
     /*  220665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220674 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  220677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220692 */     GIR_RootConstrainSelectedInstOperands,
     /*  220693 */     // GIR_Coverage, 5460,
     /*  220693 */     GIR_EraseRootFromParent_Done,
     /*  220694 */   // Label 4385: @220694
     /*  220694 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(220768), // Rule ID 5461 //
     /*  220699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  220713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220739 */     // MIs[1] Operand 1
     /*  220739 */     // No operand predicates
     /*  220739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220748 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  220751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220766 */     GIR_RootConstrainSelectedInstOperands,
     /*  220767 */     // GIR_Coverage, 5461,
     /*  220767 */     GIR_EraseRootFromParent_Done,
     /*  220768 */   // Label 4386: @220768
     /*  220768 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(220842), // Rule ID 5462 //
     /*  220773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220813 */     // MIs[1] Operand 1
     /*  220813 */     // No operand predicates
     /*  220813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220822 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  220825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220840 */     GIR_RootConstrainSelectedInstOperands,
     /*  220841 */     // GIR_Coverage, 5462,
     /*  220841 */     GIR_EraseRootFromParent_Done,
     /*  220842 */   // Label 4387: @220842
     /*  220842 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(220916), // Rule ID 5463 //
     /*  220847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220887 */     // MIs[1] Operand 1
     /*  220887 */     // No operand predicates
     /*  220887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220896 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  220899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220914 */     GIR_RootConstrainSelectedInstOperands,
     /*  220915 */     // GIR_Coverage, 5463,
     /*  220915 */     GIR_EraseRootFromParent_Done,
     /*  220916 */   // Label 4388: @220916
     /*  220916 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(220990), // Rule ID 5464 //
     /*  220921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  220935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220961 */     // MIs[1] Operand 1
     /*  220961 */     // No operand predicates
     /*  220961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220970 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  220973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220988 */     GIR_RootConstrainSelectedInstOperands,
     /*  220989 */     // GIR_Coverage, 5464,
     /*  220989 */     GIR_EraseRootFromParent_Done,
     /*  220990 */   // Label 4389: @220990
     /*  220990 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(221064), // Rule ID 5465 //
     /*  220995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  221009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221035 */     // MIs[1] Operand 1
     /*  221035 */     // No operand predicates
     /*  221035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221044 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  221047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221062 */     GIR_RootConstrainSelectedInstOperands,
     /*  221063 */     // GIR_Coverage, 5465,
     /*  221063 */     GIR_EraseRootFromParent_Done,
     /*  221064 */   // Label 4390: @221064
     /*  221064 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(221138), // Rule ID 5466 //
     /*  221069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  221083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221109 */     // MIs[1] Operand 1
     /*  221109 */     // No operand predicates
     /*  221109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221118 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  221118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  221121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221136 */     GIR_RootConstrainSelectedInstOperands,
     /*  221137 */     // GIR_Coverage, 5466,
     /*  221137 */     GIR_EraseRootFromParent_Done,
     /*  221138 */   // Label 4391: @221138
     /*  221138 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(221212), // Rule ID 5467 //
     /*  221143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  221157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221183 */     // MIs[1] Operand 1
     /*  221183 */     // No operand predicates
     /*  221183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221192 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  221195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221210 */     GIR_RootConstrainSelectedInstOperands,
     /*  221211 */     // GIR_Coverage, 5467,
     /*  221211 */     GIR_EraseRootFromParent_Done,
     /*  221212 */   // Label 4392: @221212
     /*  221212 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(221286), // Rule ID 5468 //
     /*  221217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  221231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221257 */     // MIs[1] Operand 1
     /*  221257 */     // No operand predicates
     /*  221257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221266 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221284 */     GIR_RootConstrainSelectedInstOperands,
     /*  221285 */     // GIR_Coverage, 5468,
     /*  221285 */     GIR_EraseRootFromParent_Done,
     /*  221286 */   // Label 4393: @221286
     /*  221286 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(221360), // Rule ID 5469 //
     /*  221291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  221305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221331 */     // MIs[1] Operand 1
     /*  221331 */     // No operand predicates
     /*  221331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221340 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221358 */     GIR_RootConstrainSelectedInstOperands,
     /*  221359 */     // GIR_Coverage, 5469,
     /*  221359 */     GIR_EraseRootFromParent_Done,
     /*  221360 */   // Label 4394: @221360
     /*  221360 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(221434), // Rule ID 5470 //
     /*  221365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  221379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221405 */     // MIs[1] Operand 1
     /*  221405 */     // No operand predicates
     /*  221405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221414 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221432 */     GIR_RootConstrainSelectedInstOperands,
     /*  221433 */     // GIR_Coverage, 5470,
     /*  221433 */     GIR_EraseRootFromParent_Done,
     /*  221434 */   // Label 4395: @221434
     /*  221434 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(221508), // Rule ID 5471 //
     /*  221439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  221453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221479 */     // MIs[1] Operand 1
     /*  221479 */     // No operand predicates
     /*  221479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221488 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221506 */     GIR_RootConstrainSelectedInstOperands,
     /*  221507 */     // GIR_Coverage, 5471,
     /*  221507 */     GIR_EraseRootFromParent_Done,
     /*  221508 */   // Label 4396: @221508
     /*  221508 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(221582), // Rule ID 5472 //
     /*  221513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  221527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221553 */     // MIs[1] Operand 1
     /*  221553 */     // No operand predicates
     /*  221553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221562 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  221562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221580 */     GIR_RootConstrainSelectedInstOperands,
     /*  221581 */     // GIR_Coverage, 5472,
     /*  221581 */     GIR_EraseRootFromParent_Done,
     /*  221582 */   // Label 4397: @221582
     /*  221582 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(221656), // Rule ID 5473 //
     /*  221587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  221601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221627 */     // MIs[1] Operand 1
     /*  221627 */     // No operand predicates
     /*  221627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221636 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221654 */     GIR_RootConstrainSelectedInstOperands,
     /*  221655 */     // GIR_Coverage, 5473,
     /*  221655 */     GIR_EraseRootFromParent_Done,
     /*  221656 */   // Label 4398: @221656
     /*  221656 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(221730), // Rule ID 5474 //
     /*  221661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  221664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221701 */     // MIs[1] Operand 1
     /*  221701 */     // No operand predicates
     /*  221701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221710 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  221710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221728 */     GIR_RootConstrainSelectedInstOperands,
     /*  221729 */     // GIR_Coverage, 5474,
     /*  221729 */     GIR_EraseRootFromParent_Done,
     /*  221730 */   // Label 4399: @221730
     /*  221730 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(221804), // Rule ID 5475 //
     /*  221735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  221738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221775 */     // MIs[1] Operand 1
     /*  221775 */     // No operand predicates
     /*  221775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221784 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  221784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221802 */     GIR_RootConstrainSelectedInstOperands,
     /*  221803 */     // GIR_Coverage, 5475,
     /*  221803 */     GIR_EraseRootFromParent_Done,
     /*  221804 */   // Label 4400: @221804
     /*  221804 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(221878), // Rule ID 5476 //
     /*  221809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  221823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221849 */     // MIs[1] Operand 1
     /*  221849 */     // No operand predicates
     /*  221849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221858 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  221861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221876 */     GIR_RootConstrainSelectedInstOperands,
     /*  221877 */     // GIR_Coverage, 5476,
     /*  221877 */     GIR_EraseRootFromParent_Done,
     /*  221878 */   // Label 4401: @221878
     /*  221878 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(221952), // Rule ID 5477 //
     /*  221883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  221897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221923 */     // MIs[1] Operand 1
     /*  221923 */     // No operand predicates
     /*  221923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221932 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  221935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221950 */     GIR_RootConstrainSelectedInstOperands,
     /*  221951 */     // GIR_Coverage, 5477,
     /*  221951 */     GIR_EraseRootFromParent_Done,
     /*  221952 */   // Label 4402: @221952
     /*  221952 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(222026), // Rule ID 5478 //
     /*  221957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  221971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221997 */     // MIs[1] Operand 1
     /*  221997 */     // No operand predicates
     /*  221997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222006 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  222006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  222009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222024 */     GIR_RootConstrainSelectedInstOperands,
     /*  222025 */     // GIR_Coverage, 5478,
     /*  222025 */     GIR_EraseRootFromParent_Done,
     /*  222026 */   // Label 4403: @222026
     /*  222026 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(222100), // Rule ID 5479 //
     /*  222031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  222042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  222045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222071 */     // MIs[1] Operand 1
     /*  222071 */     // No operand predicates
     /*  222071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222080 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  222080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  222083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222098 */     GIR_RootConstrainSelectedInstOperands,
     /*  222099 */     // GIR_Coverage, 5479,
     /*  222099 */     GIR_EraseRootFromParent_Done,
     /*  222100 */   // Label 4404: @222100
     /*  222100 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(222174), // Rule ID 5480 //
     /*  222105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  222116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  222119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222145 */     // MIs[1] Operand 1
     /*  222145 */     // No operand predicates
     /*  222145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222154 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  222154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  222157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222172 */     GIR_RootConstrainSelectedInstOperands,
     /*  222173 */     // GIR_Coverage, 5480,
     /*  222173 */     GIR_EraseRootFromParent_Done,
     /*  222174 */   // Label 4405: @222174
     /*  222174 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(222248), // Rule ID 5481 //
     /*  222179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  222190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  222193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222219 */     // MIs[1] Operand 1
     /*  222219 */     // No operand predicates
     /*  222219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222228 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  222228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  222231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222246 */     GIR_RootConstrainSelectedInstOperands,
     /*  222247 */     // GIR_Coverage, 5481,
     /*  222247 */     GIR_EraseRootFromParent_Done,
     /*  222248 */   // Label 4406: @222248
     /*  222248 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(222322), // Rule ID 5482 //
     /*  222253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  222267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222293 */     // MIs[1] Operand 1
     /*  222293 */     // No operand predicates
     /*  222293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222302 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  222305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222320 */     GIR_RootConstrainSelectedInstOperands,
     /*  222321 */     // GIR_Coverage, 5482,
     /*  222321 */     GIR_EraseRootFromParent_Done,
     /*  222322 */   // Label 4407: @222322
     /*  222322 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(222396), // Rule ID 5483 //
     /*  222327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  222341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222367 */     // MIs[1] Operand 1
     /*  222367 */     // No operand predicates
     /*  222367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222376 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  222379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222394 */     GIR_RootConstrainSelectedInstOperands,
     /*  222395 */     // GIR_Coverage, 5483,
     /*  222395 */     GIR_EraseRootFromParent_Done,
     /*  222396 */   // Label 4408: @222396
     /*  222396 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(222470), // Rule ID 5484 //
     /*  222401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  222415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222441 */     // MIs[1] Operand 1
     /*  222441 */     // No operand predicates
     /*  222441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222450 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  222453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222468 */     GIR_RootConstrainSelectedInstOperands,
     /*  222469 */     // GIR_Coverage, 5484,
     /*  222469 */     GIR_EraseRootFromParent_Done,
     /*  222470 */   // Label 4409: @222470
     /*  222470 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(222544), // Rule ID 5485 //
     /*  222475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  222489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222515 */     // MIs[1] Operand 1
     /*  222515 */     // No operand predicates
     /*  222515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222524 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  222527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222542 */     GIR_RootConstrainSelectedInstOperands,
     /*  222543 */     // GIR_Coverage, 5485,
     /*  222543 */     GIR_EraseRootFromParent_Done,
     /*  222544 */   // Label 4410: @222544
     /*  222544 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(222618), // Rule ID 5486 //
     /*  222549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  222560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  222563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222589 */     // MIs[1] Operand 1
     /*  222589 */     // No operand predicates
     /*  222589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222598 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  222601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222616 */     GIR_RootConstrainSelectedInstOperands,
     /*  222617 */     // GIR_Coverage, 5486,
     /*  222617 */     GIR_EraseRootFromParent_Done,
     /*  222618 */   // Label 4411: @222618
     /*  222618 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(222692), // Rule ID 5487 //
     /*  222623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  222634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  222637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222663 */     // MIs[1] Operand 1
     /*  222663 */     // No operand predicates
     /*  222663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222672 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  222675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222690 */     GIR_RootConstrainSelectedInstOperands,
     /*  222691 */     // GIR_Coverage, 5487,
     /*  222691 */     GIR_EraseRootFromParent_Done,
     /*  222692 */   // Label 4412: @222692
     /*  222692 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(222766), // Rule ID 5488 //
     /*  222697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  222711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222737 */     // MIs[1] Operand 1
     /*  222737 */     // No operand predicates
     /*  222737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222746 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  222749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222764 */     GIR_RootConstrainSelectedInstOperands,
     /*  222765 */     // GIR_Coverage, 5488,
     /*  222765 */     GIR_EraseRootFromParent_Done,
     /*  222766 */   // Label 4413: @222766
     /*  222766 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(222840), // Rule ID 5489 //
     /*  222771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  222785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222811 */     // MIs[1] Operand 1
     /*  222811 */     // No operand predicates
     /*  222811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222820 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  222823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222838 */     GIR_RootConstrainSelectedInstOperands,
     /*  222839 */     // GIR_Coverage, 5489,
     /*  222839 */     GIR_EraseRootFromParent_Done,
     /*  222840 */   // Label 4414: @222840
     /*  222840 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(222914), // Rule ID 5490 //
     /*  222845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  222859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222885 */     // MIs[1] Operand 1
     /*  222885 */     // No operand predicates
     /*  222885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222894 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  222897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222912 */     GIR_RootConstrainSelectedInstOperands,
     /*  222913 */     // GIR_Coverage, 5490,
     /*  222913 */     GIR_EraseRootFromParent_Done,
     /*  222914 */   // Label 4415: @222914
     /*  222914 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(222988), // Rule ID 5491 //
     /*  222919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  222933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222959 */     // MIs[1] Operand 1
     /*  222959 */     // No operand predicates
     /*  222959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222968 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  222971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222986 */     GIR_RootConstrainSelectedInstOperands,
     /*  222987 */     // GIR_Coverage, 5491,
     /*  222987 */     GIR_EraseRootFromParent_Done,
     /*  222988 */   // Label 4416: @222988
     /*  222988 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(223062), // Rule ID 5492 //
     /*  222993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  223004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  223007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223033 */     // MIs[1] Operand 1
     /*  223033 */     // No operand predicates
     /*  223033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223042 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  223042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  223045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223060 */     GIR_RootConstrainSelectedInstOperands,
     /*  223061 */     // GIR_Coverage, 5492,
     /*  223061 */     GIR_EraseRootFromParent_Done,
     /*  223062 */   // Label 4417: @223062
     /*  223062 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(223136), // Rule ID 5493 //
     /*  223067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  223078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  223081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223107 */     // MIs[1] Operand 1
     /*  223107 */     // No operand predicates
     /*  223107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223116 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  223116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  223119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223134 */     GIR_RootConstrainSelectedInstOperands,
     /*  223135 */     // GIR_Coverage, 5493,
     /*  223135 */     GIR_EraseRootFromParent_Done,
     /*  223136 */   // Label 4418: @223136
     /*  223136 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(223210), // Rule ID 5494 //
     /*  223141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  223144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  223155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  223169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223181 */     // MIs[1] Operand 1
     /*  223181 */     // No operand predicates
     /*  223181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223190 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  223193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223208 */     GIR_RootConstrainSelectedInstOperands,
     /*  223209 */     // GIR_Coverage, 5494,
     /*  223209 */     GIR_EraseRootFromParent_Done,
     /*  223210 */   // Label 4419: @223210
     /*  223210 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(223284), // Rule ID 5495 //
     /*  223215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  223218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  223229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  223243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223255 */     // MIs[1] Operand 1
     /*  223255 */     // No operand predicates
     /*  223255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223264 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  223267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223282 */     GIR_RootConstrainSelectedInstOperands,
     /*  223283 */     // GIR_Coverage, 5495,
     /*  223283 */     GIR_EraseRootFromParent_Done,
     /*  223284 */   // Label 4420: @223284
     /*  223284 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(223358), // Rule ID 5496 //
     /*  223289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  223292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  223303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  223317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223329 */     // MIs[1] Operand 1
     /*  223329 */     // No operand predicates
     /*  223329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223338 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  223341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223356 */     GIR_RootConstrainSelectedInstOperands,
     /*  223357 */     // GIR_Coverage, 5496,
     /*  223357 */     GIR_EraseRootFromParent_Done,
     /*  223358 */   // Label 4421: @223358
     /*  223358 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(223432), // Rule ID 5497 //
     /*  223363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  223366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  223377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  223391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223403 */     // MIs[1] Operand 1
     /*  223403 */     // No operand predicates
     /*  223403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223412 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  223415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223430 */     GIR_RootConstrainSelectedInstOperands,
     /*  223431 */     // GIR_Coverage, 5497,
     /*  223431 */     GIR_EraseRootFromParent_Done,
     /*  223432 */   // Label 4422: @223432
     /*  223432 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(223506), // Rule ID 5498 //
     /*  223437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  223440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  223451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223477 */     // MIs[1] Operand 1
     /*  223477 */     // No operand predicates
     /*  223477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223486 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  223489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223504 */     GIR_RootConstrainSelectedInstOperands,
     /*  223505 */     // GIR_Coverage, 5498,
     /*  223505 */     GIR_EraseRootFromParent_Done,
     /*  223506 */   // Label 4423: @223506
     /*  223506 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(223580), // Rule ID 5499 //
     /*  223511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  223514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  223525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223551 */     // MIs[1] Operand 1
     /*  223551 */     // No operand predicates
     /*  223551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223560 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  223563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223578 */     GIR_RootConstrainSelectedInstOperands,
     /*  223579 */     // GIR_Coverage, 5499,
     /*  223579 */     GIR_EraseRootFromParent_Done,
     /*  223580 */   // Label 4424: @223580
     /*  223580 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(223654), // Rule ID 7968 //
     /*  223585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  223599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223625 */     // MIs[1] Operand 1
     /*  223625 */     // No operand predicates
     /*  223625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223634 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  223637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223652 */     GIR_RootConstrainSelectedInstOperands,
     /*  223653 */     // GIR_Coverage, 7968,
     /*  223653 */     GIR_EraseRootFromParent_Done,
     /*  223654 */   // Label 4425: @223654
     /*  223654 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(223728), // Rule ID 7969 //
     /*  223659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  223673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223699 */     // MIs[1] Operand 1
     /*  223699 */     // No operand predicates
     /*  223699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223708 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  223711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223726 */     GIR_RootConstrainSelectedInstOperands,
     /*  223727 */     // GIR_Coverage, 7969,
     /*  223727 */     GIR_EraseRootFromParent_Done,
     /*  223728 */   // Label 4426: @223728
     /*  223728 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(223802), // Rule ID 7972 //
     /*  223733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  223747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223773 */     // MIs[1] Operand 1
     /*  223773 */     // No operand predicates
     /*  223773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223782 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  223785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223800 */     GIR_RootConstrainSelectedInstOperands,
     /*  223801 */     // GIR_Coverage, 7972,
     /*  223801 */     GIR_EraseRootFromParent_Done,
     /*  223802 */   // Label 4427: @223802
     /*  223802 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(223876), // Rule ID 7973 //
     /*  223807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  223821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223847 */     // MIs[1] Operand 1
     /*  223847 */     // No operand predicates
     /*  223847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223856 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  223859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223874 */     GIR_RootConstrainSelectedInstOperands,
     /*  223875 */     // GIR_Coverage, 7973,
     /*  223875 */     GIR_EraseRootFromParent_Done,
     /*  223876 */   // Label 4428: @223876
     /*  223876 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(223950), // Rule ID 7976 //
     /*  223881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  223895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223921 */     // MIs[1] Operand 1
     /*  223921 */     // No operand predicates
     /*  223921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223930 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  223933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223948 */     GIR_RootConstrainSelectedInstOperands,
     /*  223949 */     // GIR_Coverage, 7976,
     /*  223949 */     GIR_EraseRootFromParent_Done,
     /*  223950 */   // Label 4429: @223950
     /*  223950 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(224024), // Rule ID 7977 //
     /*  223955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  223969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223995 */     // MIs[1] Operand 1
     /*  223995 */     // No operand predicates
     /*  223995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224004 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  224007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224022 */     GIR_RootConstrainSelectedInstOperands,
     /*  224023 */     // GIR_Coverage, 7977,
     /*  224023 */     GIR_EraseRootFromParent_Done,
     /*  224024 */   // Label 4430: @224024
     /*  224024 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(224098), // Rule ID 7980 //
     /*  224029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  224043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224069 */     // MIs[1] Operand 1
     /*  224069 */     // No operand predicates
     /*  224069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224078 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  224081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224096 */     GIR_RootConstrainSelectedInstOperands,
     /*  224097 */     // GIR_Coverage, 7980,
     /*  224097 */     GIR_EraseRootFromParent_Done,
     /*  224098 */   // Label 4431: @224098
     /*  224098 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(224172), // Rule ID 7981 //
     /*  224103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  224117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224143 */     // MIs[1] Operand 1
     /*  224143 */     // No operand predicates
     /*  224143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224152 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  224155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224170 */     GIR_RootConstrainSelectedInstOperands,
     /*  224171 */     // GIR_Coverage, 7981,
     /*  224171 */     GIR_EraseRootFromParent_Done,
     /*  224172 */   // Label 4432: @224172
     /*  224172 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(224246), // Rule ID 7984 //
     /*  224177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  224191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224217 */     // MIs[1] Operand 1
     /*  224217 */     // No operand predicates
     /*  224217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224226 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  224229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224244 */     GIR_RootConstrainSelectedInstOperands,
     /*  224245 */     // GIR_Coverage, 7984,
     /*  224245 */     GIR_EraseRootFromParent_Done,
     /*  224246 */   // Label 4433: @224246
     /*  224246 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(224320), // Rule ID 7985 //
     /*  224251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  224265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224291 */     // MIs[1] Operand 1
     /*  224291 */     // No operand predicates
     /*  224291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224300 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  224303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224318 */     GIR_RootConstrainSelectedInstOperands,
     /*  224319 */     // GIR_Coverage, 7985,
     /*  224319 */     GIR_EraseRootFromParent_Done,
     /*  224320 */   // Label 4434: @224320
     /*  224320 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(224394), // Rule ID 7988 //
     /*  224325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  224339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224365 */     // MIs[1] Operand 1
     /*  224365 */     // No operand predicates
     /*  224365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224374 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  224374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  224377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224392 */     GIR_RootConstrainSelectedInstOperands,
     /*  224393 */     // GIR_Coverage, 7988,
     /*  224393 */     GIR_EraseRootFromParent_Done,
     /*  224394 */   // Label 4435: @224394
     /*  224394 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(224468), // Rule ID 7989 //
     /*  224399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  224413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224439 */     // MIs[1] Operand 1
     /*  224439 */     // No operand predicates
     /*  224439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224448 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  224448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  224451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224466 */     GIR_RootConstrainSelectedInstOperands,
     /*  224467 */     // GIR_Coverage, 7989,
     /*  224467 */     GIR_EraseRootFromParent_Done,
     /*  224468 */   // Label 4436: @224468
     /*  224468 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(224542), // Rule ID 7992 //
     /*  224473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  224487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224513 */     // MIs[1] Operand 1
     /*  224513 */     // No operand predicates
     /*  224513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224522 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224540 */     GIR_RootConstrainSelectedInstOperands,
     /*  224541 */     // GIR_Coverage, 7992,
     /*  224541 */     GIR_EraseRootFromParent_Done,
     /*  224542 */   // Label 4437: @224542
     /*  224542 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(224616), // Rule ID 7993 //
     /*  224547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  224561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224587 */     // MIs[1] Operand 1
     /*  224587 */     // No operand predicates
     /*  224587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224596 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224614 */     GIR_RootConstrainSelectedInstOperands,
     /*  224615 */     // GIR_Coverage, 7993,
     /*  224615 */     GIR_EraseRootFromParent_Done,
     /*  224616 */   // Label 4438: @224616
     /*  224616 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(224690), // Rule ID 7996 //
     /*  224621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224661 */     // MIs[1] Operand 1
     /*  224661 */     // No operand predicates
     /*  224661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224670 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224688 */     GIR_RootConstrainSelectedInstOperands,
     /*  224689 */     // GIR_Coverage, 7996,
     /*  224689 */     GIR_EraseRootFromParent_Done,
     /*  224690 */   // Label 4439: @224690
     /*  224690 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(224764), // Rule ID 7997 //
     /*  224695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224735 */     // MIs[1] Operand 1
     /*  224735 */     // No operand predicates
     /*  224735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224744 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224762 */     GIR_RootConstrainSelectedInstOperands,
     /*  224763 */     // GIR_Coverage, 7997,
     /*  224763 */     GIR_EraseRootFromParent_Done,
     /*  224764 */   // Label 4440: @224764
     /*  224764 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(224838), // Rule ID 8000 //
     /*  224769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  224783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224809 */     // MIs[1] Operand 1
     /*  224809 */     // No operand predicates
     /*  224809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224818 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  224818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224836 */     GIR_RootConstrainSelectedInstOperands,
     /*  224837 */     // GIR_Coverage, 8000,
     /*  224837 */     GIR_EraseRootFromParent_Done,
     /*  224838 */   // Label 4441: @224838
     /*  224838 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(224912), // Rule ID 8001 //
     /*  224843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  224857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224883 */     // MIs[1] Operand 1
     /*  224883 */     // No operand predicates
     /*  224883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224892 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  224892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224910 */     GIR_RootConstrainSelectedInstOperands,
     /*  224911 */     // GIR_Coverage, 8001,
     /*  224911 */     GIR_EraseRootFromParent_Done,
     /*  224912 */   // Label 4442: @224912
     /*  224912 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(224986), // Rule ID 8004 //
     /*  224917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  224920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  224931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224957 */     // MIs[1] Operand 1
     /*  224957 */     // No operand predicates
     /*  224957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224966 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  224966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224984 */     GIR_RootConstrainSelectedInstOperands,
     /*  224985 */     // GIR_Coverage, 8004,
     /*  224985 */     GIR_EraseRootFromParent_Done,
     /*  224986 */   // Label 4443: @224986
     /*  224986 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(225060), // Rule ID 8005 //
     /*  224991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  224994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  225002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  225005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225031 */     // MIs[1] Operand 1
     /*  225031 */     // No operand predicates
     /*  225031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  225040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  225043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225058 */     GIR_RootConstrainSelectedInstOperands,
     /*  225059 */     // GIR_Coverage, 8005,
     /*  225059 */     GIR_EraseRootFromParent_Done,
     /*  225060 */   // Label 4444: @225060
     /*  225060 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(225134), // Rule ID 8008 //
     /*  225065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  225079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225105 */     // MIs[1] Operand 1
     /*  225105 */     // No operand predicates
     /*  225105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225114 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  225114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  225117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225132 */     GIR_RootConstrainSelectedInstOperands,
     /*  225133 */     // GIR_Coverage, 8008,
     /*  225133 */     GIR_EraseRootFromParent_Done,
     /*  225134 */   // Label 4445: @225134
     /*  225134 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(225208), // Rule ID 8009 //
     /*  225139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  225153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225179 */     // MIs[1] Operand 1
     /*  225179 */     // No operand predicates
     /*  225179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225188 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  225188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  225191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225206 */     GIR_RootConstrainSelectedInstOperands,
     /*  225207 */     // GIR_Coverage, 8009,
     /*  225207 */     GIR_EraseRootFromParent_Done,
     /*  225208 */   // Label 4446: @225208
     /*  225208 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(225282), // Rule ID 8012 //
     /*  225213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  225227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225253 */     // MIs[1] Operand 1
     /*  225253 */     // No operand predicates
     /*  225253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225262 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  225262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  225265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225280 */     GIR_RootConstrainSelectedInstOperands,
     /*  225281 */     // GIR_Coverage, 8012,
     /*  225281 */     GIR_EraseRootFromParent_Done,
     /*  225282 */   // Label 4447: @225282
     /*  225282 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(225356), // Rule ID 8013 //
     /*  225287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  225301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225327 */     // MIs[1] Operand 1
     /*  225327 */     // No operand predicates
     /*  225327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225336 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  225336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  225339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225354 */     GIR_RootConstrainSelectedInstOperands,
     /*  225355 */     // GIR_Coverage, 8013,
     /*  225355 */     GIR_EraseRootFromParent_Done,
     /*  225356 */   // Label 4448: @225356
     /*  225356 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(225430), // Rule ID 8016 //
     /*  225361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  225372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  225375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225401 */     // MIs[1] Operand 1
     /*  225401 */     // No operand predicates
     /*  225401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225410 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  225410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  225413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225428 */     GIR_RootConstrainSelectedInstOperands,
     /*  225429 */     // GIR_Coverage, 8016,
     /*  225429 */     GIR_EraseRootFromParent_Done,
     /*  225430 */   // Label 4449: @225430
     /*  225430 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(225504), // Rule ID 8017 //
     /*  225435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  225446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  225449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225475 */     // MIs[1] Operand 1
     /*  225475 */     // No operand predicates
     /*  225475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225484 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  225484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  225487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225502 */     GIR_RootConstrainSelectedInstOperands,
     /*  225503 */     // GIR_Coverage, 8017,
     /*  225503 */     GIR_EraseRootFromParent_Done,
     /*  225504 */   // Label 4450: @225504
     /*  225504 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(225578), // Rule ID 8020 //
     /*  225509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  225523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225549 */     // MIs[1] Operand 1
     /*  225549 */     // No operand predicates
     /*  225549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225558 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  225561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225576 */     GIR_RootConstrainSelectedInstOperands,
     /*  225577 */     // GIR_Coverage, 8020,
     /*  225577 */     GIR_EraseRootFromParent_Done,
     /*  225578 */   // Label 4451: @225578
     /*  225578 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(225652), // Rule ID 8021 //
     /*  225583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  225597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225623 */     // MIs[1] Operand 1
     /*  225623 */     // No operand predicates
     /*  225623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225632 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  225635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225650 */     GIR_RootConstrainSelectedInstOperands,
     /*  225651 */     // GIR_Coverage, 8021,
     /*  225651 */     GIR_EraseRootFromParent_Done,
     /*  225652 */   // Label 4452: @225652
     /*  225652 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(225726), // Rule ID 8024 //
     /*  225657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225697 */     // MIs[1] Operand 1
     /*  225697 */     // No operand predicates
     /*  225697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225706 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  225709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225724 */     GIR_RootConstrainSelectedInstOperands,
     /*  225725 */     // GIR_Coverage, 8024,
     /*  225725 */     GIR_EraseRootFromParent_Done,
     /*  225726 */   // Label 4453: @225726
     /*  225726 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(225800), // Rule ID 8025 //
     /*  225731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225771 */     // MIs[1] Operand 1
     /*  225771 */     // No operand predicates
     /*  225771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225780 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  225783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225798 */     GIR_RootConstrainSelectedInstOperands,
     /*  225799 */     // GIR_Coverage, 8025,
     /*  225799 */     GIR_EraseRootFromParent_Done,
     /*  225800 */   // Label 4454: @225800
     /*  225800 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(225874), // Rule ID 8028 //
     /*  225805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225845 */     // MIs[1] Operand 1
     /*  225845 */     // No operand predicates
     /*  225845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225854 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  225857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225872 */     GIR_RootConstrainSelectedInstOperands,
     /*  225873 */     // GIR_Coverage, 8028,
     /*  225873 */     GIR_EraseRootFromParent_Done,
     /*  225874 */   // Label 4455: @225874
     /*  225874 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(225948), // Rule ID 8029 //
     /*  225879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225919 */     // MIs[1] Operand 1
     /*  225919 */     // No operand predicates
     /*  225919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225928 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  225931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225946 */     GIR_RootConstrainSelectedInstOperands,
     /*  225947 */     // GIR_Coverage, 8029,
     /*  225947 */     GIR_EraseRootFromParent_Done,
     /*  225948 */   // Label 4456: @225948
     /*  225948 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(226022), // Rule ID 8032 //
     /*  225953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  225967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225993 */     // MIs[1] Operand 1
     /*  225993 */     // No operand predicates
     /*  225993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226002 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  226005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226020 */     GIR_RootConstrainSelectedInstOperands,
     /*  226021 */     // GIR_Coverage, 8032,
     /*  226021 */     GIR_EraseRootFromParent_Done,
     /*  226022 */   // Label 4457: @226022
     /*  226022 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(226096), // Rule ID 8033 //
     /*  226027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  226041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226067 */     // MIs[1] Operand 1
     /*  226067 */     // No operand predicates
     /*  226067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226076 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  226076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  226079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226094 */     GIR_RootConstrainSelectedInstOperands,
     /*  226095 */     // GIR_Coverage, 8033,
     /*  226095 */     GIR_EraseRootFromParent_Done,
     /*  226096 */   // Label 4458: @226096
     /*  226096 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(226170), // Rule ID 8036 //
     /*  226101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  226115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226141 */     // MIs[1] Operand 1
     /*  226141 */     // No operand predicates
     /*  226141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226150 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  226153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226168 */     GIR_RootConstrainSelectedInstOperands,
     /*  226169 */     // GIR_Coverage, 8036,
     /*  226169 */     GIR_EraseRootFromParent_Done,
     /*  226170 */   // Label 4459: @226170
     /*  226170 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(226244), // Rule ID 8037 //
     /*  226175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  226189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226215 */     // MIs[1] Operand 1
     /*  226215 */     // No operand predicates
     /*  226215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226224 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  226224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  226227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226242 */     GIR_RootConstrainSelectedInstOperands,
     /*  226243 */     // GIR_Coverage, 8037,
     /*  226243 */     GIR_EraseRootFromParent_Done,
     /*  226244 */   // Label 4460: @226244
     /*  226244 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(226318), // Rule ID 8040 //
     /*  226249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  226260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  226263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226289 */     // MIs[1] Operand 1
     /*  226289 */     // No operand predicates
     /*  226289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226298 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  226301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226316 */     GIR_RootConstrainSelectedInstOperands,
     /*  226317 */     // GIR_Coverage, 8040,
     /*  226317 */     GIR_EraseRootFromParent_Done,
     /*  226318 */   // Label 4461: @226318
     /*  226318 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(226392), // Rule ID 8041 //
     /*  226323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  226334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  226337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226363 */     // MIs[1] Operand 1
     /*  226363 */     // No operand predicates
     /*  226363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226372 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  226372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  226375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226390 */     GIR_RootConstrainSelectedInstOperands,
     /*  226391 */     // GIR_Coverage, 8041,
     /*  226391 */     GIR_EraseRootFromParent_Done,
     /*  226392 */   // Label 4462: @226392
     /*  226392 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(226466), // Rule ID 8044 //
     /*  226397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  226411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226437 */     // MIs[1] Operand 1
     /*  226437 */     // No operand predicates
     /*  226437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  226449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226464 */     GIR_RootConstrainSelectedInstOperands,
     /*  226465 */     // GIR_Coverage, 8044,
     /*  226465 */     GIR_EraseRootFromParent_Done,
     /*  226466 */   // Label 4463: @226466
     /*  226466 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(226540), // Rule ID 8045 //
     /*  226471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  226485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226511 */     // MIs[1] Operand 1
     /*  226511 */     // No operand predicates
     /*  226511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226520 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  226523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226538 */     GIR_RootConstrainSelectedInstOperands,
     /*  226539 */     // GIR_Coverage, 8045,
     /*  226539 */     GIR_EraseRootFromParent_Done,
     /*  226540 */   // Label 4464: @226540
     /*  226540 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(226614), // Rule ID 8048 //
     /*  226545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  226559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226585 */     // MIs[1] Operand 1
     /*  226585 */     // No operand predicates
     /*  226585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226594 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  226597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226612 */     GIR_RootConstrainSelectedInstOperands,
     /*  226613 */     // GIR_Coverage, 8048,
     /*  226613 */     GIR_EraseRootFromParent_Done,
     /*  226614 */   // Label 4465: @226614
     /*  226614 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(226688), // Rule ID 8049 //
     /*  226619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  226633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226659 */     // MIs[1] Operand 1
     /*  226659 */     // No operand predicates
     /*  226659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  226671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226686 */     GIR_RootConstrainSelectedInstOperands,
     /*  226687 */     // GIR_Coverage, 8049,
     /*  226687 */     GIR_EraseRootFromParent_Done,
     /*  226688 */   // Label 4466: @226688
     /*  226688 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(226762), // Rule ID 8052 //
     /*  226693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226733 */     // MIs[1] Operand 1
     /*  226733 */     // No operand predicates
     /*  226733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226742 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  226745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226760 */     GIR_RootConstrainSelectedInstOperands,
     /*  226761 */     // GIR_Coverage, 8052,
     /*  226761 */     GIR_EraseRootFromParent_Done,
     /*  226762 */   // Label 4467: @226762
     /*  226762 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(226836), // Rule ID 8053 //
     /*  226767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226807 */     // MIs[1] Operand 1
     /*  226807 */     // No operand predicates
     /*  226807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226816 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  226819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226834 */     GIR_RootConstrainSelectedInstOperands,
     /*  226835 */     // GIR_Coverage, 8053,
     /*  226835 */     GIR_EraseRootFromParent_Done,
     /*  226836 */   // Label 4468: @226836
     /*  226836 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(226910), // Rule ID 8232 //
     /*  226841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  226855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226881 */     // MIs[1] Operand 1
     /*  226881 */     // No operand predicates
     /*  226881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226890 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  226893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226908 */     GIR_RootConstrainSelectedInstOperands,
     /*  226909 */     // GIR_Coverage, 8232,
     /*  226909 */     GIR_EraseRootFromParent_Done,
     /*  226910 */   // Label 4469: @226910
     /*  226910 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(226984), // Rule ID 8233 //
     /*  226915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  226929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226955 */     // MIs[1] Operand 1
     /*  226955 */     // No operand predicates
     /*  226955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226964 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  226967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226982 */     GIR_RootConstrainSelectedInstOperands,
     /*  226983 */     // GIR_Coverage, 8233,
     /*  226983 */     GIR_EraseRootFromParent_Done,
     /*  226984 */   // Label 4470: @226984
     /*  226984 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(227058), // Rule ID 8236 //
     /*  226989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  227003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227029 */     // MIs[1] Operand 1
     /*  227029 */     // No operand predicates
     /*  227029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227038 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  227041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227056 */     GIR_RootConstrainSelectedInstOperands,
     /*  227057 */     // GIR_Coverage, 8236,
     /*  227057 */     GIR_EraseRootFromParent_Done,
     /*  227058 */   // Label 4471: @227058
     /*  227058 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(227132), // Rule ID 8237 //
     /*  227063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  227077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227103 */     // MIs[1] Operand 1
     /*  227103 */     // No operand predicates
     /*  227103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227112 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  227115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227130 */     GIR_RootConstrainSelectedInstOperands,
     /*  227131 */     // GIR_Coverage, 8237,
     /*  227131 */     GIR_EraseRootFromParent_Done,
     /*  227132 */   // Label 4472: @227132
     /*  227132 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(227206), // Rule ID 8240 //
     /*  227137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  227151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227177 */     // MIs[1] Operand 1
     /*  227177 */     // No operand predicates
     /*  227177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227186 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  227189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227204 */     GIR_RootConstrainSelectedInstOperands,
     /*  227205 */     // GIR_Coverage, 8240,
     /*  227205 */     GIR_EraseRootFromParent_Done,
     /*  227206 */   // Label 4473: @227206
     /*  227206 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(227280), // Rule ID 8241 //
     /*  227211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  227225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227251 */     // MIs[1] Operand 1
     /*  227251 */     // No operand predicates
     /*  227251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227260 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  227263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227278 */     GIR_RootConstrainSelectedInstOperands,
     /*  227279 */     // GIR_Coverage, 8241,
     /*  227279 */     GIR_EraseRootFromParent_Done,
     /*  227280 */   // Label 4474: @227280
     /*  227280 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(227354), // Rule ID 8244 //
     /*  227285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  227299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227325 */     // MIs[1] Operand 1
     /*  227325 */     // No operand predicates
     /*  227325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227334 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  227337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227352 */     GIR_RootConstrainSelectedInstOperands,
     /*  227353 */     // GIR_Coverage, 8244,
     /*  227353 */     GIR_EraseRootFromParent_Done,
     /*  227354 */   // Label 4475: @227354
     /*  227354 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(227428), // Rule ID 8245 //
     /*  227359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  227373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227399 */     // MIs[1] Operand 1
     /*  227399 */     // No operand predicates
     /*  227399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227408 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  227411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227426 */     GIR_RootConstrainSelectedInstOperands,
     /*  227427 */     // GIR_Coverage, 8245,
     /*  227427 */     GIR_EraseRootFromParent_Done,
     /*  227428 */   // Label 4476: @227428
     /*  227428 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(227502), // Rule ID 8248 //
     /*  227433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  227447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227473 */     // MIs[1] Operand 1
     /*  227473 */     // No operand predicates
     /*  227473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227482 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  227485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227500 */     GIR_RootConstrainSelectedInstOperands,
     /*  227501 */     // GIR_Coverage, 8248,
     /*  227501 */     GIR_EraseRootFromParent_Done,
     /*  227502 */   // Label 4477: @227502
     /*  227502 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(227576), // Rule ID 8249 //
     /*  227507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  227521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227547 */     // MIs[1] Operand 1
     /*  227547 */     // No operand predicates
     /*  227547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227556 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  227559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227574 */     GIR_RootConstrainSelectedInstOperands,
     /*  227575 */     // GIR_Coverage, 8249,
     /*  227575 */     GIR_EraseRootFromParent_Done,
     /*  227576 */   // Label 4478: @227576
     /*  227576 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(227650), // Rule ID 8252 //
     /*  227581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  227595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227621 */     // MIs[1] Operand 1
     /*  227621 */     // No operand predicates
     /*  227621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227630 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  227630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  227633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227648 */     GIR_RootConstrainSelectedInstOperands,
     /*  227649 */     // GIR_Coverage, 8252,
     /*  227649 */     GIR_EraseRootFromParent_Done,
     /*  227650 */   // Label 4479: @227650
     /*  227650 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(227724), // Rule ID 8253 //
     /*  227655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  227669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227695 */     // MIs[1] Operand 1
     /*  227695 */     // No operand predicates
     /*  227695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227704 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  227704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  227707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227722 */     GIR_RootConstrainSelectedInstOperands,
     /*  227723 */     // GIR_Coverage, 8253,
     /*  227723 */     GIR_EraseRootFromParent_Done,
     /*  227724 */   // Label 4480: @227724
     /*  227724 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(227798), // Rule ID 8256 //
     /*  227729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  227743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227769 */     // MIs[1] Operand 1
     /*  227769 */     // No operand predicates
     /*  227769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227778 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  227781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227796 */     GIR_RootConstrainSelectedInstOperands,
     /*  227797 */     // GIR_Coverage, 8256,
     /*  227797 */     GIR_EraseRootFromParent_Done,
     /*  227798 */   // Label 4481: @227798
     /*  227798 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(227872), // Rule ID 8257 //
     /*  227803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  227817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227843 */     // MIs[1] Operand 1
     /*  227843 */     // No operand predicates
     /*  227843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227852 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  227855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227870 */     GIR_RootConstrainSelectedInstOperands,
     /*  227871 */     // GIR_Coverage, 8257,
     /*  227871 */     GIR_EraseRootFromParent_Done,
     /*  227872 */   // Label 4482: @227872
     /*  227872 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(227946), // Rule ID 8260 //
     /*  227877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  227891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227917 */     // MIs[1] Operand 1
     /*  227917 */     // No operand predicates
     /*  227917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227926 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  227929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227944 */     GIR_RootConstrainSelectedInstOperands,
     /*  227945 */     // GIR_Coverage, 8260,
     /*  227945 */     GIR_EraseRootFromParent_Done,
     /*  227946 */   // Label 4483: @227946
     /*  227946 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(228020), // Rule ID 8261 //
     /*  227951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  227965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227991 */     // MIs[1] Operand 1
     /*  227991 */     // No operand predicates
     /*  227991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228000 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  228003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228018 */     GIR_RootConstrainSelectedInstOperands,
     /*  228019 */     // GIR_Coverage, 8261,
     /*  228019 */     GIR_EraseRootFromParent_Done,
     /*  228020 */   // Label 4484: @228020
     /*  228020 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(228094), // Rule ID 8264 //
     /*  228025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  228036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  228039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228065 */     // MIs[1] Operand 1
     /*  228065 */     // No operand predicates
     /*  228065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228074 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  228074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  228077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228092 */     GIR_RootConstrainSelectedInstOperands,
     /*  228093 */     // GIR_Coverage, 8264,
     /*  228093 */     GIR_EraseRootFromParent_Done,
     /*  228094 */   // Label 4485: @228094
     /*  228094 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(228168), // Rule ID 8265 //
     /*  228099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  228110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  228113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228139 */     // MIs[1] Operand 1
     /*  228139 */     // No operand predicates
     /*  228139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228148 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  228148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  228151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228166 */     GIR_RootConstrainSelectedInstOperands,
     /*  228167 */     // GIR_Coverage, 8265,
     /*  228167 */     GIR_EraseRootFromParent_Done,
     /*  228168 */   // Label 4486: @228168
     /*  228168 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(228242), // Rule ID 8268 //
     /*  228173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  228176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  228187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228213 */     // MIs[1] Operand 1
     /*  228213 */     // No operand predicates
     /*  228213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228222 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  228222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  228225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228240 */     GIR_RootConstrainSelectedInstOperands,
     /*  228241 */     // GIR_Coverage, 8268,
     /*  228241 */     GIR_EraseRootFromParent_Done,
     /*  228242 */   // Label 4487: @228242
     /*  228242 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(228316), // Rule ID 8269 //
     /*  228247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  228250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  228261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228287 */     // MIs[1] Operand 1
     /*  228287 */     // No operand predicates
     /*  228287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228296 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  228296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  228299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228314 */     GIR_RootConstrainSelectedInstOperands,
     /*  228315 */     // GIR_Coverage, 8269,
     /*  228315 */     GIR_EraseRootFromParent_Done,
     /*  228316 */   // Label 4488: @228316
     /*  228316 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(228390), // Rule ID 8272 //
     /*  228321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  228335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228361 */     // MIs[1] Operand 1
     /*  228361 */     // No operand predicates
     /*  228361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228370 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  228373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228388 */     GIR_RootConstrainSelectedInstOperands,
     /*  228389 */     // GIR_Coverage, 8272,
     /*  228389 */     GIR_EraseRootFromParent_Done,
     /*  228390 */   // Label 4489: @228390
     /*  228390 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(228464), // Rule ID 8273 //
     /*  228395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  228409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228435 */     // MIs[1] Operand 1
     /*  228435 */     // No operand predicates
     /*  228435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228444 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  228447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228462 */     GIR_RootConstrainSelectedInstOperands,
     /*  228463 */     // GIR_Coverage, 8273,
     /*  228463 */     GIR_EraseRootFromParent_Done,
     /*  228464 */   // Label 4490: @228464
     /*  228464 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(228538), // Rule ID 8276 //
     /*  228469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  228483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228509 */     // MIs[1] Operand 1
     /*  228509 */     // No operand predicates
     /*  228509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228518 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  228521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228536 */     GIR_RootConstrainSelectedInstOperands,
     /*  228537 */     // GIR_Coverage, 8276,
     /*  228537 */     GIR_EraseRootFromParent_Done,
     /*  228538 */   // Label 4491: @228538
     /*  228538 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(228612), // Rule ID 8277 //
     /*  228543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  228557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228583 */     // MIs[1] Operand 1
     /*  228583 */     // No operand predicates
     /*  228583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228592 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  228595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228610 */     GIR_RootConstrainSelectedInstOperands,
     /*  228611 */     // GIR_Coverage, 8277,
     /*  228611 */     GIR_EraseRootFromParent_Done,
     /*  228612 */   // Label 4492: @228612
     /*  228612 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(228686), // Rule ID 8280 //
     /*  228617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  228628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  228631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228657 */     // MIs[1] Operand 1
     /*  228657 */     // No operand predicates
     /*  228657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228666 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  228669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228684 */     GIR_RootConstrainSelectedInstOperands,
     /*  228685 */     // GIR_Coverage, 8280,
     /*  228685 */     GIR_EraseRootFromParent_Done,
     /*  228686 */   // Label 4493: @228686
     /*  228686 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(228760), // Rule ID 8281 //
     /*  228691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  228702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  228705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228731 */     // MIs[1] Operand 1
     /*  228731 */     // No operand predicates
     /*  228731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228740 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  228743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228758 */     GIR_RootConstrainSelectedInstOperands,
     /*  228759 */     // GIR_Coverage, 8281,
     /*  228759 */     GIR_EraseRootFromParent_Done,
     /*  228760 */   // Label 4494: @228760
     /*  228760 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(228834), // Rule ID 8284 //
     /*  228765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  228779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228805 */     // MIs[1] Operand 1
     /*  228805 */     // No operand predicates
     /*  228805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228814 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  228817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228832 */     GIR_RootConstrainSelectedInstOperands,
     /*  228833 */     // GIR_Coverage, 8284,
     /*  228833 */     GIR_EraseRootFromParent_Done,
     /*  228834 */   // Label 4495: @228834
     /*  228834 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(228908), // Rule ID 8285 //
     /*  228839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  228853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228879 */     // MIs[1] Operand 1
     /*  228879 */     // No operand predicates
     /*  228879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  228891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228906 */     GIR_RootConstrainSelectedInstOperands,
     /*  228907 */     // GIR_Coverage, 8285,
     /*  228907 */     GIR_EraseRootFromParent_Done,
     /*  228908 */   // Label 4496: @228908
     /*  228908 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(228982), // Rule ID 8288 //
     /*  228913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  228927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228953 */     // MIs[1] Operand 1
     /*  228953 */     // No operand predicates
     /*  228953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228962 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  228965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228980 */     GIR_RootConstrainSelectedInstOperands,
     /*  228981 */     // GIR_Coverage, 8288,
     /*  228981 */     GIR_EraseRootFromParent_Done,
     /*  228982 */   // Label 4497: @228982
     /*  228982 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(229056), // Rule ID 8289 //
     /*  228987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  229001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229027 */     // MIs[1] Operand 1
     /*  229027 */     // No operand predicates
     /*  229027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229036 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  229036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  229039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229054 */     GIR_RootConstrainSelectedInstOperands,
     /*  229055 */     // GIR_Coverage, 8289,
     /*  229055 */     GIR_EraseRootFromParent_Done,
     /*  229056 */   // Label 4498: @229056
     /*  229056 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(229130), // Rule ID 8292 //
     /*  229061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  229072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  229075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229101 */     // MIs[1] Operand 1
     /*  229101 */     // No operand predicates
     /*  229101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229110 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  229110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  229113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229128 */     GIR_RootConstrainSelectedInstOperands,
     /*  229129 */     // GIR_Coverage, 8292,
     /*  229129 */     GIR_EraseRootFromParent_Done,
     /*  229130 */   // Label 4499: @229130
     /*  229130 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(229204), // Rule ID 8293 //
     /*  229135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  229146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  229149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229175 */     // MIs[1] Operand 1
     /*  229175 */     // No operand predicates
     /*  229175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229184 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  229184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  229187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229202 */     GIR_RootConstrainSelectedInstOperands,
     /*  229203 */     // GIR_Coverage, 8293,
     /*  229203 */     GIR_EraseRootFromParent_Done,
     /*  229204 */   // Label 4500: @229204
     /*  229204 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(229278), // Rule ID 8296 //
     /*  229209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  229223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229249 */     // MIs[1] Operand 1
     /*  229249 */     // No operand predicates
     /*  229249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229258 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  229261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229276 */     GIR_RootConstrainSelectedInstOperands,
     /*  229277 */     // GIR_Coverage, 8296,
     /*  229277 */     GIR_EraseRootFromParent_Done,
     /*  229278 */   // Label 4501: @229278
     /*  229278 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(229352), // Rule ID 8297 //
     /*  229283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  229297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229323 */     // MIs[1] Operand 1
     /*  229323 */     // No operand predicates
     /*  229323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229332 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  229335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229350 */     GIR_RootConstrainSelectedInstOperands,
     /*  229351 */     // GIR_Coverage, 8297,
     /*  229351 */     GIR_EraseRootFromParent_Done,
     /*  229352 */   // Label 4502: @229352
     /*  229352 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(229426), // Rule ID 8300 //
     /*  229357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  229371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229397 */     // MIs[1] Operand 1
     /*  229397 */     // No operand predicates
     /*  229397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229406 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  229409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229424 */     GIR_RootConstrainSelectedInstOperands,
     /*  229425 */     // GIR_Coverage, 8300,
     /*  229425 */     GIR_EraseRootFromParent_Done,
     /*  229426 */   // Label 4503: @229426
     /*  229426 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(229500), // Rule ID 8301 //
     /*  229431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  229445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229471 */     // MIs[1] Operand 1
     /*  229471 */     // No operand predicates
     /*  229471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229480 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  229483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229498 */     GIR_RootConstrainSelectedInstOperands,
     /*  229499 */     // GIR_Coverage, 8301,
     /*  229499 */     GIR_EraseRootFromParent_Done,
     /*  229500 */   // Label 4504: @229500
     /*  229500 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(229574), // Rule ID 8304 //
     /*  229505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  229519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229545 */     // MIs[1] Operand 1
     /*  229545 */     // No operand predicates
     /*  229545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229554 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  229557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229572 */     GIR_RootConstrainSelectedInstOperands,
     /*  229573 */     // GIR_Coverage, 8304,
     /*  229573 */     GIR_EraseRootFromParent_Done,
     /*  229574 */   // Label 4505: @229574
     /*  229574 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(229648), // Rule ID 8305 //
     /*  229579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  229593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229619 */     // MIs[1] Operand 1
     /*  229619 */     // No operand predicates
     /*  229619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229628 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  229631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229646 */     GIR_RootConstrainSelectedInstOperands,
     /*  229647 */     // GIR_Coverage, 8305,
     /*  229647 */     GIR_EraseRootFromParent_Done,
     /*  229648 */   // Label 4506: @229648
     /*  229648 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(229722), // Rule ID 8308 //
     /*  229653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229693 */     // MIs[1] Operand 1
     /*  229693 */     // No operand predicates
     /*  229693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229702 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  229705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229720 */     GIR_RootConstrainSelectedInstOperands,
     /*  229721 */     // GIR_Coverage, 8308,
     /*  229721 */     GIR_EraseRootFromParent_Done,
     /*  229722 */   // Label 4507: @229722
     /*  229722 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(229796), // Rule ID 8309 //
     /*  229727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229767 */     // MIs[1] Operand 1
     /*  229767 */     // No operand predicates
     /*  229767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  229779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229794 */     GIR_RootConstrainSelectedInstOperands,
     /*  229795 */     // GIR_Coverage, 8309,
     /*  229795 */     GIR_EraseRootFromParent_Done,
     /*  229796 */   // Label 4508: @229796
     /*  229796 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(229870), // Rule ID 8312 //
     /*  229801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229841 */     // MIs[1] Operand 1
     /*  229841 */     // No operand predicates
     /*  229841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229850 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  229853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229868 */     GIR_RootConstrainSelectedInstOperands,
     /*  229869 */     // GIR_Coverage, 8312,
     /*  229869 */     GIR_EraseRootFromParent_Done,
     /*  229870 */   // Label 4509: @229870
     /*  229870 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(229944), // Rule ID 8313 //
     /*  229875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229915 */     // MIs[1] Operand 1
     /*  229915 */     // No operand predicates
     /*  229915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229924 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  229927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229942 */     GIR_RootConstrainSelectedInstOperands,
     /*  229943 */     // GIR_Coverage, 8313,
     /*  229943 */     GIR_EraseRootFromParent_Done,
     /*  229944 */   // Label 4510: @229944
     /*  229944 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(230018), // Rule ID 8316 //
     /*  229949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  229963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229989 */     // MIs[1] Operand 1
     /*  229989 */     // No operand predicates
     /*  229989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229998 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  230001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230016 */     GIR_RootConstrainSelectedInstOperands,
     /*  230017 */     // GIR_Coverage, 8316,
     /*  230017 */     GIR_EraseRootFromParent_Done,
     /*  230018 */   // Label 4511: @230018
     /*  230018 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(230092), // Rule ID 8317 //
     /*  230023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  230026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  230031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  230037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  230051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230063 */     // MIs[1] Operand 1
     /*  230063 */     // No operand predicates
     /*  230063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230072 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  230072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  230075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230090 */     GIR_RootConstrainSelectedInstOperands,
     /*  230091 */     // GIR_Coverage, 8317,
     /*  230091 */     GIR_EraseRootFromParent_Done,
     /*  230092 */   // Label 4512: @230092
     /*  230092 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(230166), // Rule ID 8848 //
     /*  230097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  230111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230137 */     // MIs[1] Operand 1
     /*  230137 */     // No operand predicates
     /*  230137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230146 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  230149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230164 */     GIR_RootConstrainSelectedInstOperands,
     /*  230165 */     // GIR_Coverage, 8848,
     /*  230165 */     GIR_EraseRootFromParent_Done,
     /*  230166 */   // Label 4513: @230166
     /*  230166 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(230240), // Rule ID 8849 //
     /*  230171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  230185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230211 */     // MIs[1] Operand 1
     /*  230211 */     // No operand predicates
     /*  230211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230220 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  230223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230238 */     GIR_RootConstrainSelectedInstOperands,
     /*  230239 */     // GIR_Coverage, 8849,
     /*  230239 */     GIR_EraseRootFromParent_Done,
     /*  230240 */   // Label 4514: @230240
     /*  230240 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(230314), // Rule ID 8852 //
     /*  230245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  230259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230285 */     // MIs[1] Operand 1
     /*  230285 */     // No operand predicates
     /*  230285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230294 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  230297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230312 */     GIR_RootConstrainSelectedInstOperands,
     /*  230313 */     // GIR_Coverage, 8852,
     /*  230313 */     GIR_EraseRootFromParent_Done,
     /*  230314 */   // Label 4515: @230314
     /*  230314 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(230388), // Rule ID 8853 //
     /*  230319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  230333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230359 */     // MIs[1] Operand 1
     /*  230359 */     // No operand predicates
     /*  230359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  230371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230386 */     GIR_RootConstrainSelectedInstOperands,
     /*  230387 */     // GIR_Coverage, 8853,
     /*  230387 */     GIR_EraseRootFromParent_Done,
     /*  230388 */   // Label 4516: @230388
     /*  230388 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(230462), // Rule ID 8856 //
     /*  230393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  230407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230433 */     // MIs[1] Operand 1
     /*  230433 */     // No operand predicates
     /*  230433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230442 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  230445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230460 */     GIR_RootConstrainSelectedInstOperands,
     /*  230461 */     // GIR_Coverage, 8856,
     /*  230461 */     GIR_EraseRootFromParent_Done,
     /*  230462 */   // Label 4517: @230462
     /*  230462 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(230536), // Rule ID 8857 //
     /*  230467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  230481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230507 */     // MIs[1] Operand 1
     /*  230507 */     // No operand predicates
     /*  230507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230516 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  230519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230534 */     GIR_RootConstrainSelectedInstOperands,
     /*  230535 */     // GIR_Coverage, 8857,
     /*  230535 */     GIR_EraseRootFromParent_Done,
     /*  230536 */   // Label 4518: @230536
     /*  230536 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(230610), // Rule ID 8860 //
     /*  230541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  230555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230581 */     // MIs[1] Operand 1
     /*  230581 */     // No operand predicates
     /*  230581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230590 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  230593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230608 */     GIR_RootConstrainSelectedInstOperands,
     /*  230609 */     // GIR_Coverage, 8860,
     /*  230609 */     GIR_EraseRootFromParent_Done,
     /*  230610 */   // Label 4519: @230610
     /*  230610 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(230684), // Rule ID 8861 //
     /*  230615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  230629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230655 */     // MIs[1] Operand 1
     /*  230655 */     // No operand predicates
     /*  230655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230664 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  230667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230682 */     GIR_RootConstrainSelectedInstOperands,
     /*  230683 */     // GIR_Coverage, 8861,
     /*  230683 */     GIR_EraseRootFromParent_Done,
     /*  230684 */   // Label 4520: @230684
     /*  230684 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(230758), // Rule ID 8864 //
     /*  230689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230729 */     // MIs[1] Operand 1
     /*  230729 */     // No operand predicates
     /*  230729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230738 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  230741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230756 */     GIR_RootConstrainSelectedInstOperands,
     /*  230757 */     // GIR_Coverage, 8864,
     /*  230757 */     GIR_EraseRootFromParent_Done,
     /*  230758 */   // Label 4521: @230758
     /*  230758 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(230832), // Rule ID 8865 //
     /*  230763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230803 */     // MIs[1] Operand 1
     /*  230803 */     // No operand predicates
     /*  230803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230812 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  230815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230830 */     GIR_RootConstrainSelectedInstOperands,
     /*  230831 */     // GIR_Coverage, 8865,
     /*  230831 */     GIR_EraseRootFromParent_Done,
     /*  230832 */   // Label 4522: @230832
     /*  230832 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(230906), // Rule ID 8868 //
     /*  230837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230877 */     // MIs[1] Operand 1
     /*  230877 */     // No operand predicates
     /*  230877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230886 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  230886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  230889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230904 */     GIR_RootConstrainSelectedInstOperands,
     /*  230905 */     // GIR_Coverage, 8868,
     /*  230905 */     GIR_EraseRootFromParent_Done,
     /*  230906 */   // Label 4523: @230906
     /*  230906 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(230980), // Rule ID 8869 //
     /*  230911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230951 */     // MIs[1] Operand 1
     /*  230951 */     // No operand predicates
     /*  230951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230960 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  230960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  230963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230978 */     GIR_RootConstrainSelectedInstOperands,
     /*  230979 */     // GIR_Coverage, 8869,
     /*  230979 */     GIR_EraseRootFromParent_Done,
     /*  230980 */   // Label 4524: @230980
     /*  230980 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(231054), // Rule ID 8872 //
     /*  230985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  230999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231025 */     // MIs[1] Operand 1
     /*  231025 */     // No operand predicates
     /*  231025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231034 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231052 */     GIR_RootConstrainSelectedInstOperands,
     /*  231053 */     // GIR_Coverage, 8872,
     /*  231053 */     GIR_EraseRootFromParent_Done,
     /*  231054 */   // Label 4525: @231054
     /*  231054 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(231128), // Rule ID 8873 //
     /*  231059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  231073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231099 */     // MIs[1] Operand 1
     /*  231099 */     // No operand predicates
     /*  231099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231108 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231126 */     GIR_RootConstrainSelectedInstOperands,
     /*  231127 */     // GIR_Coverage, 8873,
     /*  231127 */     GIR_EraseRootFromParent_Done,
     /*  231128 */   // Label 4526: @231128
     /*  231128 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(231202), // Rule ID 8876 //
     /*  231133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  231147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231173 */     // MIs[1] Operand 1
     /*  231173 */     // No operand predicates
     /*  231173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231182 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231200 */     GIR_RootConstrainSelectedInstOperands,
     /*  231201 */     // GIR_Coverage, 8876,
     /*  231201 */     GIR_EraseRootFromParent_Done,
     /*  231202 */   // Label 4527: @231202
     /*  231202 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(231276), // Rule ID 8877 //
     /*  231207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  231221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231247 */     // MIs[1] Operand 1
     /*  231247 */     // No operand predicates
     /*  231247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231256 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231274 */     GIR_RootConstrainSelectedInstOperands,
     /*  231275 */     // GIR_Coverage, 8877,
     /*  231275 */     GIR_EraseRootFromParent_Done,
     /*  231276 */   // Label 4528: @231276
     /*  231276 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(231350), // Rule ID 8880 //
     /*  231281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  231292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  231295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231321 */     // MIs[1] Operand 1
     /*  231321 */     // No operand predicates
     /*  231321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231330 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  231330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231348 */     GIR_RootConstrainSelectedInstOperands,
     /*  231349 */     // GIR_Coverage, 8880,
     /*  231349 */     GIR_EraseRootFromParent_Done,
     /*  231350 */   // Label 4529: @231350
     /*  231350 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(231424), // Rule ID 8881 //
     /*  231355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  231366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  231369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231395 */     // MIs[1] Operand 1
     /*  231395 */     // No operand predicates
     /*  231395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231404 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  231404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231422 */     GIR_RootConstrainSelectedInstOperands,
     /*  231423 */     // GIR_Coverage, 8881,
     /*  231423 */     GIR_EraseRootFromParent_Done,
     /*  231424 */   // Label 4530: @231424
     /*  231424 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(231498), // Rule ID 8884 //
     /*  231429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  231432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  231440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  231443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231469 */     // MIs[1] Operand 1
     /*  231469 */     // No operand predicates
     /*  231469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231478 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  231478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231496 */     GIR_RootConstrainSelectedInstOperands,
     /*  231497 */     // GIR_Coverage, 8884,
     /*  231497 */     GIR_EraseRootFromParent_Done,
     /*  231498 */   // Label 4531: @231498
     /*  231498 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(231572), // Rule ID 8885 //
     /*  231503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  231506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  231514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  231517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231543 */     // MIs[1] Operand 1
     /*  231543 */     // No operand predicates
     /*  231543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231552 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  231552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231570 */     GIR_RootConstrainSelectedInstOperands,
     /*  231571 */     // GIR_Coverage, 8885,
     /*  231571 */     GIR_EraseRootFromParent_Done,
     /*  231572 */   // Label 4532: @231572
     /*  231572 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(231646), // Rule ID 8888 //
     /*  231577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  231591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231617 */     // MIs[1] Operand 1
     /*  231617 */     // No operand predicates
     /*  231617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231626 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  231629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231644 */     GIR_RootConstrainSelectedInstOperands,
     /*  231645 */     // GIR_Coverage, 8888,
     /*  231645 */     GIR_EraseRootFromParent_Done,
     /*  231646 */   // Label 4533: @231646
     /*  231646 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(231720), // Rule ID 8889 //
     /*  231651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  231665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231691 */     // MIs[1] Operand 1
     /*  231691 */     // No operand predicates
     /*  231691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231700 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  231703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231718 */     GIR_RootConstrainSelectedInstOperands,
     /*  231719 */     // GIR_Coverage, 8889,
     /*  231719 */     GIR_EraseRootFromParent_Done,
     /*  231720 */   // Label 4534: @231720
     /*  231720 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(231794), // Rule ID 8892 //
     /*  231725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  231739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231765 */     // MIs[1] Operand 1
     /*  231765 */     // No operand predicates
     /*  231765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231774 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  231777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231792 */     GIR_RootConstrainSelectedInstOperands,
     /*  231793 */     // GIR_Coverage, 8892,
     /*  231793 */     GIR_EraseRootFromParent_Done,
     /*  231794 */   // Label 4535: @231794
     /*  231794 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(231868), // Rule ID 8893 //
     /*  231799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  231813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231839 */     // MIs[1] Operand 1
     /*  231839 */     // No operand predicates
     /*  231839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231848 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  231851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231866 */     GIR_RootConstrainSelectedInstOperands,
     /*  231867 */     // GIR_Coverage, 8893,
     /*  231867 */     GIR_EraseRootFromParent_Done,
     /*  231868 */   // Label 4536: @231868
     /*  231868 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(231942), // Rule ID 8896 //
     /*  231873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  231884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  231887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231913 */     // MIs[1] Operand 1
     /*  231913 */     // No operand predicates
     /*  231913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231922 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  231925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231940 */     GIR_RootConstrainSelectedInstOperands,
     /*  231941 */     // GIR_Coverage, 8896,
     /*  231941 */     GIR_EraseRootFromParent_Done,
     /*  231942 */   // Label 4537: @231942
     /*  231942 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(232016), // Rule ID 8897 //
     /*  231947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  231958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  231961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231987 */     // MIs[1] Operand 1
     /*  231987 */     // No operand predicates
     /*  231987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231996 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  231999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232014 */     GIR_RootConstrainSelectedInstOperands,
     /*  232015 */     // GIR_Coverage, 8897,
     /*  232015 */     GIR_EraseRootFromParent_Done,
     /*  232016 */   // Label 4538: @232016
     /*  232016 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(232090), // Rule ID 8900 //
     /*  232021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  232035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232061 */     // MIs[1] Operand 1
     /*  232061 */     // No operand predicates
     /*  232061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232070 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  232073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232088 */     GIR_RootConstrainSelectedInstOperands,
     /*  232089 */     // GIR_Coverage, 8900,
     /*  232089 */     GIR_EraseRootFromParent_Done,
     /*  232090 */   // Label 4539: @232090
     /*  232090 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(232164), // Rule ID 8901 //
     /*  232095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  232109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232135 */     // MIs[1] Operand 1
     /*  232135 */     // No operand predicates
     /*  232135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232144 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  232147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232162 */     GIR_RootConstrainSelectedInstOperands,
     /*  232163 */     // GIR_Coverage, 8901,
     /*  232163 */     GIR_EraseRootFromParent_Done,
     /*  232164 */   // Label 4540: @232164
     /*  232164 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(232238), // Rule ID 8904 //
     /*  232169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  232183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232209 */     // MIs[1] Operand 1
     /*  232209 */     // No operand predicates
     /*  232209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232218 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  232221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232236 */     GIR_RootConstrainSelectedInstOperands,
     /*  232237 */     // GIR_Coverage, 8904,
     /*  232237 */     GIR_EraseRootFromParent_Done,
     /*  232238 */   // Label 4541: @232238
     /*  232238 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(232312), // Rule ID 8905 //
     /*  232243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  232257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232283 */     // MIs[1] Operand 1
     /*  232283 */     // No operand predicates
     /*  232283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232292 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  232295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232310 */     GIR_RootConstrainSelectedInstOperands,
     /*  232311 */     // GIR_Coverage, 8905,
     /*  232311 */     GIR_EraseRootFromParent_Done,
     /*  232312 */   // Label 4542: @232312
     /*  232312 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(232386), // Rule ID 8908 //
     /*  232317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  232328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  232331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232357 */     // MIs[1] Operand 1
     /*  232357 */     // No operand predicates
     /*  232357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232366 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  232369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232384 */     GIR_RootConstrainSelectedInstOperands,
     /*  232385 */     // GIR_Coverage, 8908,
     /*  232385 */     GIR_EraseRootFromParent_Done,
     /*  232386 */   // Label 4543: @232386
     /*  232386 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(232460), // Rule ID 8909 //
     /*  232391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  232402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  232405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232431 */     // MIs[1] Operand 1
     /*  232431 */     // No operand predicates
     /*  232431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232440 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  232443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232458 */     GIR_RootConstrainSelectedInstOperands,
     /*  232459 */     // GIR_Coverage, 8909,
     /*  232459 */     GIR_EraseRootFromParent_Done,
     /*  232460 */   // Label 4544: @232460
     /*  232460 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(232534), // Rule ID 8912 //
     /*  232465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  232479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232505 */     // MIs[1] Operand 1
     /*  232505 */     // No operand predicates
     /*  232505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232514 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  232517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232532 */     GIR_RootConstrainSelectedInstOperands,
     /*  232533 */     // GIR_Coverage, 8912,
     /*  232533 */     GIR_EraseRootFromParent_Done,
     /*  232534 */   // Label 4545: @232534
     /*  232534 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(232608), // Rule ID 8913 //
     /*  232539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  232553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232579 */     // MIs[1] Operand 1
     /*  232579 */     // No operand predicates
     /*  232579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232588 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  232591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232606 */     GIR_RootConstrainSelectedInstOperands,
     /*  232607 */     // GIR_Coverage, 8913,
     /*  232607 */     GIR_EraseRootFromParent_Done,
     /*  232608 */   // Label 4546: @232608
     /*  232608 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(232682), // Rule ID 8916 //
     /*  232613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  232627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232653 */     // MIs[1] Operand 1
     /*  232653 */     // No operand predicates
     /*  232653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232662 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  232665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232680 */     GIR_RootConstrainSelectedInstOperands,
     /*  232681 */     // GIR_Coverage, 8916,
     /*  232681 */     GIR_EraseRootFromParent_Done,
     /*  232682 */   // Label 4547: @232682
     /*  232682 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(232756), // Rule ID 8917 //
     /*  232687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  232701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232727 */     // MIs[1] Operand 1
     /*  232727 */     // No operand predicates
     /*  232727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  232739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232754 */     GIR_RootConstrainSelectedInstOperands,
     /*  232755 */     // GIR_Coverage, 8917,
     /*  232755 */     GIR_EraseRootFromParent_Done,
     /*  232756 */   // Label 4548: @232756
     /*  232756 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(232830), // Rule ID 8920 //
     /*  232761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  232775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232801 */     // MIs[1] Operand 1
     /*  232801 */     // No operand predicates
     /*  232801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232810 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  232813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232828 */     GIR_RootConstrainSelectedInstOperands,
     /*  232829 */     // GIR_Coverage, 8920,
     /*  232829 */     GIR_EraseRootFromParent_Done,
     /*  232830 */   // Label 4549: @232830
     /*  232830 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(232904), // Rule ID 8921 //
     /*  232835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  232849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232875 */     // MIs[1] Operand 1
     /*  232875 */     // No operand predicates
     /*  232875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232884 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  232887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232902 */     GIR_RootConstrainSelectedInstOperands,
     /*  232903 */     // GIR_Coverage, 8921,
     /*  232903 */     GIR_EraseRootFromParent_Done,
     /*  232904 */   // Label 4550: @232904
     /*  232904 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(232978), // Rule ID 8924 //
     /*  232909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  232912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  232923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232949 */     // MIs[1] Operand 1
     /*  232949 */     // No operand predicates
     /*  232949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232958 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  232961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232976 */     GIR_RootConstrainSelectedInstOperands,
     /*  232977 */     // GIR_Coverage, 8924,
     /*  232977 */     GIR_EraseRootFromParent_Done,
     /*  232978 */   // Label 4551: @232978
     /*  232978 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(233052), // Rule ID 8925 //
     /*  232983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  232986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  232997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  233011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233023 */     // MIs[1] Operand 1
     /*  233023 */     // No operand predicates
     /*  233023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233032 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  233035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233050 */     GIR_RootConstrainSelectedInstOperands,
     /*  233051 */     // GIR_Coverage, 8925,
     /*  233051 */     GIR_EraseRootFromParent_Done,
     /*  233052 */   // Label 4552: @233052
     /*  233052 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(233126), // Rule ID 8928 //
     /*  233057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  233060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  233065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  233071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233097 */     // MIs[1] Operand 1
     /*  233097 */     // No operand predicates
     /*  233097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233106 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  233106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  233109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233124 */     GIR_RootConstrainSelectedInstOperands,
     /*  233125 */     // GIR_Coverage, 8928,
     /*  233125 */     GIR_EraseRootFromParent_Done,
     /*  233126 */   // Label 4553: @233126
     /*  233126 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(233200), // Rule ID 8929 //
     /*  233131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  233134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  233139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  233145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233171 */     // MIs[1] Operand 1
     /*  233171 */     // No operand predicates
     /*  233171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  233183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233198 */     GIR_RootConstrainSelectedInstOperands,
     /*  233199 */     // GIR_Coverage, 8929,
     /*  233199 */     GIR_EraseRootFromParent_Done,
     /*  233200 */   // Label 4554: @233200
     /*  233200 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(233274), // Rule ID 8932 //
     /*  233205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  233208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  233213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  233219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233245 */     // MIs[1] Operand 1
     /*  233245 */     // No operand predicates
     /*  233245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233254 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  233254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  233257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233272 */     GIR_RootConstrainSelectedInstOperands,
     /*  233273 */     // GIR_Coverage, 8932,
     /*  233273 */     GIR_EraseRootFromParent_Done,
     /*  233274 */   // Label 4555: @233274
     /*  233274 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(233348), // Rule ID 8933 //
     /*  233279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  233282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  233287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  233293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233319 */     // MIs[1] Operand 1
     /*  233319 */     // No operand predicates
     /*  233319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233328 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  233331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233346 */     GIR_RootConstrainSelectedInstOperands,
     /*  233347 */     // GIR_Coverage, 8933,
     /*  233347 */     GIR_EraseRootFromParent_Done,
     /*  233348 */   // Label 4556: @233348
     /*  233348 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(233422), // Rule ID 9112 //
     /*  233353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  233367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233393 */     // MIs[1] Operand 1
     /*  233393 */     // No operand predicates
     /*  233393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233402 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  233405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233420 */     GIR_RootConstrainSelectedInstOperands,
     /*  233421 */     // GIR_Coverage, 9112,
     /*  233421 */     GIR_EraseRootFromParent_Done,
     /*  233422 */   // Label 4557: @233422
     /*  233422 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(233496), // Rule ID 9113 //
     /*  233427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  233441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233467 */     // MIs[1] Operand 1
     /*  233467 */     // No operand predicates
     /*  233467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233476 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  233479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233494 */     GIR_RootConstrainSelectedInstOperands,
     /*  233495 */     // GIR_Coverage, 9113,
     /*  233495 */     GIR_EraseRootFromParent_Done,
     /*  233496 */   // Label 4558: @233496
     /*  233496 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(233570), // Rule ID 9116 //
     /*  233501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  233515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233541 */     // MIs[1] Operand 1
     /*  233541 */     // No operand predicates
     /*  233541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233550 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  233553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233568 */     GIR_RootConstrainSelectedInstOperands,
     /*  233569 */     // GIR_Coverage, 9116,
     /*  233569 */     GIR_EraseRootFromParent_Done,
     /*  233570 */   // Label 4559: @233570
     /*  233570 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(233644), // Rule ID 9117 //
     /*  233575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  233589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233615 */     // MIs[1] Operand 1
     /*  233615 */     // No operand predicates
     /*  233615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233624 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  233627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233642 */     GIR_RootConstrainSelectedInstOperands,
     /*  233643 */     // GIR_Coverage, 9117,
     /*  233643 */     GIR_EraseRootFromParent_Done,
     /*  233644 */   // Label 4560: @233644
     /*  233644 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(233718), // Rule ID 9120 //
     /*  233649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  233663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233689 */     // MIs[1] Operand 1
     /*  233689 */     // No operand predicates
     /*  233689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233698 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  233701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233716 */     GIR_RootConstrainSelectedInstOperands,
     /*  233717 */     // GIR_Coverage, 9120,
     /*  233717 */     GIR_EraseRootFromParent_Done,
     /*  233718 */   // Label 4561: @233718
     /*  233718 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(233792), // Rule ID 9121 //
     /*  233723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  233737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233763 */     // MIs[1] Operand 1
     /*  233763 */     // No operand predicates
     /*  233763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233772 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  233775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233790 */     GIR_RootConstrainSelectedInstOperands,
     /*  233791 */     // GIR_Coverage, 9121,
     /*  233791 */     GIR_EraseRootFromParent_Done,
     /*  233792 */   // Label 4562: @233792
     /*  233792 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(233866), // Rule ID 9124 //
     /*  233797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  233811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233837 */     // MIs[1] Operand 1
     /*  233837 */     // No operand predicates
     /*  233837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233846 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  233849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233864 */     GIR_RootConstrainSelectedInstOperands,
     /*  233865 */     // GIR_Coverage, 9124,
     /*  233865 */     GIR_EraseRootFromParent_Done,
     /*  233866 */   // Label 4563: @233866
     /*  233866 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(233940), // Rule ID 9125 //
     /*  233871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  233885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233911 */     // MIs[1] Operand 1
     /*  233911 */     // No operand predicates
     /*  233911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233920 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  233923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233938 */     GIR_RootConstrainSelectedInstOperands,
     /*  233939 */     // GIR_Coverage, 9125,
     /*  233939 */     GIR_EraseRootFromParent_Done,
     /*  233940 */   // Label 4564: @233940
     /*  233940 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(234014), // Rule ID 9128 //
     /*  233945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  233959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233985 */     // MIs[1] Operand 1
     /*  233985 */     // No operand predicates
     /*  233985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233994 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  233997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234012 */     GIR_RootConstrainSelectedInstOperands,
     /*  234013 */     // GIR_Coverage, 9128,
     /*  234013 */     GIR_EraseRootFromParent_Done,
     /*  234014 */   // Label 4565: @234014
     /*  234014 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(234088), // Rule ID 9129 //
     /*  234019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  234033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234059 */     // MIs[1] Operand 1
     /*  234059 */     // No operand predicates
     /*  234059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234068 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  234071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234086 */     GIR_RootConstrainSelectedInstOperands,
     /*  234087 */     // GIR_Coverage, 9129,
     /*  234087 */     GIR_EraseRootFromParent_Done,
     /*  234088 */   // Label 4566: @234088
     /*  234088 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(234162), // Rule ID 9132 //
     /*  234093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  234107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234133 */     // MIs[1] Operand 1
     /*  234133 */     // No operand predicates
     /*  234133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234142 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  234145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234160 */     GIR_RootConstrainSelectedInstOperands,
     /*  234161 */     // GIR_Coverage, 9132,
     /*  234161 */     GIR_EraseRootFromParent_Done,
     /*  234162 */   // Label 4567: @234162
     /*  234162 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(234236), // Rule ID 9133 //
     /*  234167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  234181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234207 */     // MIs[1] Operand 1
     /*  234207 */     // No operand predicates
     /*  234207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234216 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  234219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234234 */     GIR_RootConstrainSelectedInstOperands,
     /*  234235 */     // GIR_Coverage, 9133,
     /*  234235 */     GIR_EraseRootFromParent_Done,
     /*  234236 */   // Label 4568: @234236
     /*  234236 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(234310), // Rule ID 9136 //
     /*  234241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  234255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234281 */     // MIs[1] Operand 1
     /*  234281 */     // No operand predicates
     /*  234281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234290 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234308 */     GIR_RootConstrainSelectedInstOperands,
     /*  234309 */     // GIR_Coverage, 9136,
     /*  234309 */     GIR_EraseRootFromParent_Done,
     /*  234310 */   // Label 4569: @234310
     /*  234310 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(234384), // Rule ID 9137 //
     /*  234315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  234329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234355 */     // MIs[1] Operand 1
     /*  234355 */     // No operand predicates
     /*  234355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234364 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234382 */     GIR_RootConstrainSelectedInstOperands,
     /*  234383 */     // GIR_Coverage, 9137,
     /*  234383 */     GIR_EraseRootFromParent_Done,
     /*  234384 */   // Label 4570: @234384
     /*  234384 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(234458), // Rule ID 9140 //
     /*  234389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  234400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  234403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234429 */     // MIs[1] Operand 1
     /*  234429 */     // No operand predicates
     /*  234429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234438 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234456 */     GIR_RootConstrainSelectedInstOperands,
     /*  234457 */     // GIR_Coverage, 9140,
     /*  234457 */     GIR_EraseRootFromParent_Done,
     /*  234458 */   // Label 4571: @234458
     /*  234458 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(234532), // Rule ID 9141 //
     /*  234463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  234474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  234477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234503 */     // MIs[1] Operand 1
     /*  234503 */     // No operand predicates
     /*  234503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234530 */     GIR_RootConstrainSelectedInstOperands,
     /*  234531 */     // GIR_Coverage, 9141,
     /*  234531 */     GIR_EraseRootFromParent_Done,
     /*  234532 */   // Label 4572: @234532
     /*  234532 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(234606), // Rule ID 9144 //
     /*  234537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  234551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234577 */     // MIs[1] Operand 1
     /*  234577 */     // No operand predicates
     /*  234577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234586 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234604 */     GIR_RootConstrainSelectedInstOperands,
     /*  234605 */     // GIR_Coverage, 9144,
     /*  234605 */     GIR_EraseRootFromParent_Done,
     /*  234606 */   // Label 4573: @234606
     /*  234606 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(234680), // Rule ID 9145 //
     /*  234611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  234625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234651 */     // MIs[1] Operand 1
     /*  234651 */     // No operand predicates
     /*  234651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234660 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234678 */     GIR_RootConstrainSelectedInstOperands,
     /*  234679 */     // GIR_Coverage, 9145,
     /*  234679 */     GIR_EraseRootFromParent_Done,
     /*  234680 */   // Label 4574: @234680
     /*  234680 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(234754), // Rule ID 9148 //
     /*  234685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  234688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234725 */     // MIs[1] Operand 1
     /*  234725 */     // No operand predicates
     /*  234725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234734 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  234734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234752 */     GIR_RootConstrainSelectedInstOperands,
     /*  234753 */     // GIR_Coverage, 9148,
     /*  234753 */     GIR_EraseRootFromParent_Done,
     /*  234754 */   // Label 4575: @234754
     /*  234754 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(234828), // Rule ID 9149 //
     /*  234759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  234762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234799 */     // MIs[1] Operand 1
     /*  234799 */     // No operand predicates
     /*  234799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234808 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  234808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234826 */     GIR_RootConstrainSelectedInstOperands,
     /*  234827 */     // GIR_Coverage, 9149,
     /*  234827 */     GIR_EraseRootFromParent_Done,
     /*  234828 */   // Label 4576: @234828
     /*  234828 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(234902), // Rule ID 9152 //
     /*  234833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  234847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234873 */     // MIs[1] Operand 1
     /*  234873 */     // No operand predicates
     /*  234873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234882 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  234885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234900 */     GIR_RootConstrainSelectedInstOperands,
     /*  234901 */     // GIR_Coverage, 9152,
     /*  234901 */     GIR_EraseRootFromParent_Done,
     /*  234902 */   // Label 4577: @234902
     /*  234902 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(234976), // Rule ID 9153 //
     /*  234907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  234921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234947 */     // MIs[1] Operand 1
     /*  234947 */     // No operand predicates
     /*  234947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234956 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  234959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234974 */     GIR_RootConstrainSelectedInstOperands,
     /*  234975 */     // GIR_Coverage, 9153,
     /*  234975 */     GIR_EraseRootFromParent_Done,
     /*  234976 */   // Label 4578: @234976
     /*  234976 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(235050), // Rule ID 9156 //
     /*  234981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  234995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235021 */     // MIs[1] Operand 1
     /*  235021 */     // No operand predicates
     /*  235021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235030 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  235030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  235033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235048 */     GIR_RootConstrainSelectedInstOperands,
     /*  235049 */     // GIR_Coverage, 9156,
     /*  235049 */     GIR_EraseRootFromParent_Done,
     /*  235050 */   // Label 4579: @235050
     /*  235050 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(235124), // Rule ID 9157 //
     /*  235055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  235069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235095 */     // MIs[1] Operand 1
     /*  235095 */     // No operand predicates
     /*  235095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235104 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  235104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  235107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235122 */     GIR_RootConstrainSelectedInstOperands,
     /*  235123 */     // GIR_Coverage, 9157,
     /*  235123 */     GIR_EraseRootFromParent_Done,
     /*  235124 */   // Label 4580: @235124
     /*  235124 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(235198), // Rule ID 9160 //
     /*  235129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  235140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  235143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235169 */     // MIs[1] Operand 1
     /*  235169 */     // No operand predicates
     /*  235169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235178 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  235178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  235181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235196 */     GIR_RootConstrainSelectedInstOperands,
     /*  235197 */     // GIR_Coverage, 9160,
     /*  235197 */     GIR_EraseRootFromParent_Done,
     /*  235198 */   // Label 4581: @235198
     /*  235198 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(235272), // Rule ID 9161 //
     /*  235203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  235214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  235217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235243 */     // MIs[1] Operand 1
     /*  235243 */     // No operand predicates
     /*  235243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235252 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  235252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  235255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235270 */     GIR_RootConstrainSelectedInstOperands,
     /*  235271 */     // GIR_Coverage, 9161,
     /*  235271 */     GIR_EraseRootFromParent_Done,
     /*  235272 */   // Label 4582: @235272
     /*  235272 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(235346), // Rule ID 9164 //
     /*  235277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  235291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235317 */     // MIs[1] Operand 1
     /*  235317 */     // No operand predicates
     /*  235317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235326 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  235329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235344 */     GIR_RootConstrainSelectedInstOperands,
     /*  235345 */     // GIR_Coverage, 9164,
     /*  235345 */     GIR_EraseRootFromParent_Done,
     /*  235346 */   // Label 4583: @235346
     /*  235346 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(235420), // Rule ID 9165 //
     /*  235351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  235365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235391 */     // MIs[1] Operand 1
     /*  235391 */     // No operand predicates
     /*  235391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235400 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  235403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235418 */     GIR_RootConstrainSelectedInstOperands,
     /*  235419 */     // GIR_Coverage, 9165,
     /*  235419 */     GIR_EraseRootFromParent_Done,
     /*  235420 */   // Label 4584: @235420
     /*  235420 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(235494), // Rule ID 9168 //
     /*  235425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  235439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235465 */     // MIs[1] Operand 1
     /*  235465 */     // No operand predicates
     /*  235465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235474 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  235477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235492 */     GIR_RootConstrainSelectedInstOperands,
     /*  235493 */     // GIR_Coverage, 9168,
     /*  235493 */     GIR_EraseRootFromParent_Done,
     /*  235494 */   // Label 4585: @235494
     /*  235494 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(235568), // Rule ID 9169 //
     /*  235499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  235513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235539 */     // MIs[1] Operand 1
     /*  235539 */     // No operand predicates
     /*  235539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235548 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  235551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235566 */     GIR_RootConstrainSelectedInstOperands,
     /*  235567 */     // GIR_Coverage, 9169,
     /*  235567 */     GIR_EraseRootFromParent_Done,
     /*  235568 */   // Label 4586: @235568
     /*  235568 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(235642), // Rule ID 9172 //
     /*  235573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  235587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235613 */     // MIs[1] Operand 1
     /*  235613 */     // No operand predicates
     /*  235613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235622 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  235625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235640 */     GIR_RootConstrainSelectedInstOperands,
     /*  235641 */     // GIR_Coverage, 9172,
     /*  235641 */     GIR_EraseRootFromParent_Done,
     /*  235642 */   // Label 4587: @235642
     /*  235642 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(235716), // Rule ID 9173 //
     /*  235647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  235661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235687 */     // MIs[1] Operand 1
     /*  235687 */     // No operand predicates
     /*  235687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235696 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  235699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235714 */     GIR_RootConstrainSelectedInstOperands,
     /*  235715 */     // GIR_Coverage, 9173,
     /*  235715 */     GIR_EraseRootFromParent_Done,
     /*  235716 */   // Label 4588: @235716
     /*  235716 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(235790), // Rule ID 9176 //
     /*  235721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235761 */     // MIs[1] Operand 1
     /*  235761 */     // No operand predicates
     /*  235761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235770 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  235773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235788 */     GIR_RootConstrainSelectedInstOperands,
     /*  235789 */     // GIR_Coverage, 9176,
     /*  235789 */     GIR_EraseRootFromParent_Done,
     /*  235790 */   // Label 4589: @235790
     /*  235790 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(235864), // Rule ID 9177 //
     /*  235795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235835 */     // MIs[1] Operand 1
     /*  235835 */     // No operand predicates
     /*  235835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235844 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  235847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235862 */     GIR_RootConstrainSelectedInstOperands,
     /*  235863 */     // GIR_Coverage, 9177,
     /*  235863 */     GIR_EraseRootFromParent_Done,
     /*  235864 */   // Label 4590: @235864
     /*  235864 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(235938), // Rule ID 9180 //
     /*  235869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235909 */     // MIs[1] Operand 1
     /*  235909 */     // No operand predicates
     /*  235909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235918 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  235921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235936 */     GIR_RootConstrainSelectedInstOperands,
     /*  235937 */     // GIR_Coverage, 9180,
     /*  235937 */     GIR_EraseRootFromParent_Done,
     /*  235938 */   // Label 4591: @235938
     /*  235938 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(236012), // Rule ID 9181 //
     /*  235943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235983 */     // MIs[1] Operand 1
     /*  235983 */     // No operand predicates
     /*  235983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235992 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  235995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236010 */     GIR_RootConstrainSelectedInstOperands,
     /*  236011 */     // GIR_Coverage, 9181,
     /*  236011 */     GIR_EraseRootFromParent_Done,
     /*  236012 */   // Label 4592: @236012
     /*  236012 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(236086), // Rule ID 9184 //
     /*  236017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  236028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  236031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236057 */     // MIs[1] Operand 1
     /*  236057 */     // No operand predicates
     /*  236057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236066 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  236066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  236069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236084 */     GIR_RootConstrainSelectedInstOperands,
     /*  236085 */     // GIR_Coverage, 9184,
     /*  236085 */     GIR_EraseRootFromParent_Done,
     /*  236086 */   // Label 4593: @236086
     /*  236086 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(236160), // Rule ID 9185 //
     /*  236091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  236102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  236105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236131 */     // MIs[1] Operand 1
     /*  236131 */     // No operand predicates
     /*  236131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236140 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  236140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  236143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236158 */     GIR_RootConstrainSelectedInstOperands,
     /*  236159 */     // GIR_Coverage, 9185,
     /*  236159 */     GIR_EraseRootFromParent_Done,
     /*  236160 */   // Label 4594: @236160
     /*  236160 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(236234), // Rule ID 9188 //
     /*  236165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  236168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  236179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  236193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236205 */     // MIs[1] Operand 1
     /*  236205 */     // No operand predicates
     /*  236205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236214 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  236217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236232 */     GIR_RootConstrainSelectedInstOperands,
     /*  236233 */     // GIR_Coverage, 9188,
     /*  236233 */     GIR_EraseRootFromParent_Done,
     /*  236234 */   // Label 4595: @236234
     /*  236234 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(236308), // Rule ID 9189 //
     /*  236239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  236242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  236253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  236267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236279 */     // MIs[1] Operand 1
     /*  236279 */     // No operand predicates
     /*  236279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236288 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  236291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236306 */     GIR_RootConstrainSelectedInstOperands,
     /*  236307 */     // GIR_Coverage, 9189,
     /*  236307 */     GIR_EraseRootFromParent_Done,
     /*  236308 */   // Label 4596: @236308
     /*  236308 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(236382), // Rule ID 9192 //
     /*  236313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  236316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  236327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  236341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236353 */     // MIs[1] Operand 1
     /*  236353 */     // No operand predicates
     /*  236353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236362 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  236365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236380 */     GIR_RootConstrainSelectedInstOperands,
     /*  236381 */     // GIR_Coverage, 9192,
     /*  236381 */     GIR_EraseRootFromParent_Done,
     /*  236382 */   // Label 4597: @236382
     /*  236382 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(236456), // Rule ID 9193 //
     /*  236387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  236390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  236401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  236415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236427 */     // MIs[1] Operand 1
     /*  236427 */     // No operand predicates
     /*  236427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236436 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  236439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236454 */     GIR_RootConstrainSelectedInstOperands,
     /*  236455 */     // GIR_Coverage, 9193,
     /*  236455 */     GIR_EraseRootFromParent_Done,
     /*  236456 */   // Label 4598: @236456
     /*  236456 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(236530), // Rule ID 9196 //
     /*  236461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  236464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  236475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236501 */     // MIs[1] Operand 1
     /*  236501 */     // No operand predicates
     /*  236501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236510 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  236513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236528 */     GIR_RootConstrainSelectedInstOperands,
     /*  236529 */     // GIR_Coverage, 9196,
     /*  236529 */     GIR_EraseRootFromParent_Done,
     /*  236530 */   // Label 4599: @236530
     /*  236530 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(236604), // Rule ID 9197 //
     /*  236535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  236538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  236549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236575 */     // MIs[1] Operand 1
     /*  236575 */     // No operand predicates
     /*  236575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236584 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  236587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236602 */     GIR_RootConstrainSelectedInstOperands,
     /*  236603 */     // GIR_Coverage, 9197,
     /*  236603 */     GIR_EraseRootFromParent_Done,
     /*  236604 */   // Label 4600: @236604
     /*  236604 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(236678), // Rule ID 9288 //
     /*  236609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  236623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236649 */     // MIs[1] Operand 1
     /*  236649 */     // No operand predicates
     /*  236649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236658 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  236661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236676 */     GIR_RootConstrainSelectedInstOperands,
     /*  236677 */     // GIR_Coverage, 9288,
     /*  236677 */     GIR_EraseRootFromParent_Done,
     /*  236678 */   // Label 4601: @236678
     /*  236678 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(236752), // Rule ID 9289 //
     /*  236683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  236697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236723 */     // MIs[1] Operand 1
     /*  236723 */     // No operand predicates
     /*  236723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236732 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  236735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236750 */     GIR_RootConstrainSelectedInstOperands,
     /*  236751 */     // GIR_Coverage, 9289,
     /*  236751 */     GIR_EraseRootFromParent_Done,
     /*  236752 */   // Label 4602: @236752
     /*  236752 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(236826), // Rule ID 9292 //
     /*  236757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  236771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236797 */     // MIs[1] Operand 1
     /*  236797 */     // No operand predicates
     /*  236797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236806 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  236809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236824 */     GIR_RootConstrainSelectedInstOperands,
     /*  236825 */     // GIR_Coverage, 9292,
     /*  236825 */     GIR_EraseRootFromParent_Done,
     /*  236826 */   // Label 4603: @236826
     /*  236826 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(236900), // Rule ID 9293 //
     /*  236831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  236845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236871 */     // MIs[1] Operand 1
     /*  236871 */     // No operand predicates
     /*  236871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  236883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236898 */     GIR_RootConstrainSelectedInstOperands,
     /*  236899 */     // GIR_Coverage, 9293,
     /*  236899 */     GIR_EraseRootFromParent_Done,
     /*  236900 */   // Label 4604: @236900
     /*  236900 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(236974), // Rule ID 9296 //
     /*  236905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  236919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236945 */     // MIs[1] Operand 1
     /*  236945 */     // No operand predicates
     /*  236945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236954 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  236957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236972 */     GIR_RootConstrainSelectedInstOperands,
     /*  236973 */     // GIR_Coverage, 9296,
     /*  236973 */     GIR_EraseRootFromParent_Done,
     /*  236974 */   // Label 4605: @236974
     /*  236974 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(237048), // Rule ID 9297 //
     /*  236979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  236993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237019 */     // MIs[1] Operand 1
     /*  237019 */     // No operand predicates
     /*  237019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237028 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  237031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237046 */     GIR_RootConstrainSelectedInstOperands,
     /*  237047 */     // GIR_Coverage, 9297,
     /*  237047 */     GIR_EraseRootFromParent_Done,
     /*  237048 */   // Label 4606: @237048
     /*  237048 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(237122), // Rule ID 9300 //
     /*  237053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  237067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237093 */     // MIs[1] Operand 1
     /*  237093 */     // No operand predicates
     /*  237093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237102 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  237105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237120 */     GIR_RootConstrainSelectedInstOperands,
     /*  237121 */     // GIR_Coverage, 9300,
     /*  237121 */     GIR_EraseRootFromParent_Done,
     /*  237122 */   // Label 4607: @237122
     /*  237122 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(237196), // Rule ID 9301 //
     /*  237127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  237141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237167 */     // MIs[1] Operand 1
     /*  237167 */     // No operand predicates
     /*  237167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237176 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  237179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237194 */     GIR_RootConstrainSelectedInstOperands,
     /*  237195 */     // GIR_Coverage, 9301,
     /*  237195 */     GIR_EraseRootFromParent_Done,
     /*  237196 */   // Label 4608: @237196
     /*  237196 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(237270), // Rule ID 9304 //
     /*  237201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  237215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237241 */     // MIs[1] Operand 1
     /*  237241 */     // No operand predicates
     /*  237241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237250 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  237253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237268 */     GIR_RootConstrainSelectedInstOperands,
     /*  237269 */     // GIR_Coverage, 9304,
     /*  237269 */     GIR_EraseRootFromParent_Done,
     /*  237270 */   // Label 4609: @237270
     /*  237270 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(237344), // Rule ID 9305 //
     /*  237275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  237289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237315 */     // MIs[1] Operand 1
     /*  237315 */     // No operand predicates
     /*  237315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237324 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  237327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237342 */     GIR_RootConstrainSelectedInstOperands,
     /*  237343 */     // GIR_Coverage, 9305,
     /*  237343 */     GIR_EraseRootFromParent_Done,
     /*  237344 */   // Label 4610: @237344
     /*  237344 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(237418), // Rule ID 9308 //
     /*  237349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  237363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237389 */     // MIs[1] Operand 1
     /*  237389 */     // No operand predicates
     /*  237389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237398 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  237401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237416 */     GIR_RootConstrainSelectedInstOperands,
     /*  237417 */     // GIR_Coverage, 9308,
     /*  237417 */     GIR_EraseRootFromParent_Done,
     /*  237418 */   // Label 4611: @237418
     /*  237418 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(237492), // Rule ID 9309 //
     /*  237423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  237437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237463 */     // MIs[1] Operand 1
     /*  237463 */     // No operand predicates
     /*  237463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237472 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  237472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  237475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237490 */     GIR_RootConstrainSelectedInstOperands,
     /*  237491 */     // GIR_Coverage, 9309,
     /*  237491 */     GIR_EraseRootFromParent_Done,
     /*  237492 */   // Label 4612: @237492
     /*  237492 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(237566), // Rule ID 9312 //
     /*  237497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  237511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237537 */     // MIs[1] Operand 1
     /*  237537 */     // No operand predicates
     /*  237537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237546 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  237546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237564 */     GIR_RootConstrainSelectedInstOperands,
     /*  237565 */     // GIR_Coverage, 9312,
     /*  237565 */     GIR_EraseRootFromParent_Done,
     /*  237566 */   // Label 4613: @237566
     /*  237566 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(237640), // Rule ID 9313 //
     /*  237571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  237585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237611 */     // MIs[1] Operand 1
     /*  237611 */     // No operand predicates
     /*  237611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237638 */     GIR_RootConstrainSelectedInstOperands,
     /*  237639 */     // GIR_Coverage, 9313,
     /*  237639 */     GIR_EraseRootFromParent_Done,
     /*  237640 */   // Label 4614: @237640
     /*  237640 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(237714), // Rule ID 9316 //
     /*  237645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  237659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237685 */     // MIs[1] Operand 1
     /*  237685 */     // No operand predicates
     /*  237685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237694 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237712 */     GIR_RootConstrainSelectedInstOperands,
     /*  237713 */     // GIR_Coverage, 9316,
     /*  237713 */     GIR_EraseRootFromParent_Done,
     /*  237714 */   // Label 4615: @237714
     /*  237714 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(237788), // Rule ID 9317 //
     /*  237719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  237733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237759 */     // MIs[1] Operand 1
     /*  237759 */     // No operand predicates
     /*  237759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237768 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237786 */     GIR_RootConstrainSelectedInstOperands,
     /*  237787 */     // GIR_Coverage, 9317,
     /*  237787 */     GIR_EraseRootFromParent_Done,
     /*  237788 */   // Label 4616: @237788
     /*  237788 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(237862), // Rule ID 9320 //
     /*  237793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  237807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237833 */     // MIs[1] Operand 1
     /*  237833 */     // No operand predicates
     /*  237833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237842 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237860 */     GIR_RootConstrainSelectedInstOperands,
     /*  237861 */     // GIR_Coverage, 9320,
     /*  237861 */     GIR_EraseRootFromParent_Done,
     /*  237862 */   // Label 4617: @237862
     /*  237862 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(237936), // Rule ID 9321 //
     /*  237867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  237881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237907 */     // MIs[1] Operand 1
     /*  237907 */     // No operand predicates
     /*  237907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237916 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  237916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237934 */     GIR_RootConstrainSelectedInstOperands,
     /*  237935 */     // GIR_Coverage, 9321,
     /*  237935 */     GIR_EraseRootFromParent_Done,
     /*  237936 */   // Label 4618: @237936
     /*  237936 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(238010), // Rule ID 9324 //
     /*  237941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  237944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  237955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237981 */     // MIs[1] Operand 1
     /*  237981 */     // No operand predicates
     /*  237981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237990 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  237990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238008 */     GIR_RootConstrainSelectedInstOperands,
     /*  238009 */     // GIR_Coverage, 9324,
     /*  238009 */     GIR_EraseRootFromParent_Done,
     /*  238010 */   // Label 4619: @238010
     /*  238010 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(238084), // Rule ID 9325 //
     /*  238015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  238018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  238026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  238029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238055 */     // MIs[1] Operand 1
     /*  238055 */     // No operand predicates
     /*  238055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238064 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  238064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  238067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238082 */     GIR_RootConstrainSelectedInstOperands,
     /*  238083 */     // GIR_Coverage, 9325,
     /*  238083 */     GIR_EraseRootFromParent_Done,
     /*  238084 */   // Label 4620: @238084
     /*  238084 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(238158), // Rule ID 9328 //
     /*  238089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  238103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238129 */     // MIs[1] Operand 1
     /*  238129 */     // No operand predicates
     /*  238129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238138 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  238138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  238141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238156 */     GIR_RootConstrainSelectedInstOperands,
     /*  238157 */     // GIR_Coverage, 9328,
     /*  238157 */     GIR_EraseRootFromParent_Done,
     /*  238158 */   // Label 4621: @238158
     /*  238158 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(238232), // Rule ID 9329 //
     /*  238163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  238177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238203 */     // MIs[1] Operand 1
     /*  238203 */     // No operand predicates
     /*  238203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238212 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  238212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  238215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238230 */     GIR_RootConstrainSelectedInstOperands,
     /*  238231 */     // GIR_Coverage, 9329,
     /*  238231 */     GIR_EraseRootFromParent_Done,
     /*  238232 */   // Label 4622: @238232
     /*  238232 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(238306), // Rule ID 9332 //
     /*  238237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  238251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238277 */     // MIs[1] Operand 1
     /*  238277 */     // No operand predicates
     /*  238277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238286 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  238286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  238289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238304 */     GIR_RootConstrainSelectedInstOperands,
     /*  238305 */     // GIR_Coverage, 9332,
     /*  238305 */     GIR_EraseRootFromParent_Done,
     /*  238306 */   // Label 4623: @238306
     /*  238306 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(238380), // Rule ID 9333 //
     /*  238311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  238325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238351 */     // MIs[1] Operand 1
     /*  238351 */     // No operand predicates
     /*  238351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238360 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  238360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  238363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238378 */     GIR_RootConstrainSelectedInstOperands,
     /*  238379 */     // GIR_Coverage, 9333,
     /*  238379 */     GIR_EraseRootFromParent_Done,
     /*  238380 */   // Label 4624: @238380
     /*  238380 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(238454), // Rule ID 9336 //
     /*  238385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  238396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  238399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238425 */     // MIs[1] Operand 1
     /*  238425 */     // No operand predicates
     /*  238425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238434 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  238434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  238437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238452 */     GIR_RootConstrainSelectedInstOperands,
     /*  238453 */     // GIR_Coverage, 9336,
     /*  238453 */     GIR_EraseRootFromParent_Done,
     /*  238454 */   // Label 4625: @238454
     /*  238454 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(238528), // Rule ID 9337 //
     /*  238459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  238470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  238473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238499 */     // MIs[1] Operand 1
     /*  238499 */     // No operand predicates
     /*  238499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238508 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  238508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  238511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238526 */     GIR_RootConstrainSelectedInstOperands,
     /*  238527 */     // GIR_Coverage, 9337,
     /*  238527 */     GIR_EraseRootFromParent_Done,
     /*  238528 */   // Label 4626: @238528
     /*  238528 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(238602), // Rule ID 9340 //
     /*  238533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  238547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238573 */     // MIs[1] Operand 1
     /*  238573 */     // No operand predicates
     /*  238573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238582 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  238585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238600 */     GIR_RootConstrainSelectedInstOperands,
     /*  238601 */     // GIR_Coverage, 9340,
     /*  238601 */     GIR_EraseRootFromParent_Done,
     /*  238602 */   // Label 4627: @238602
     /*  238602 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(238676), // Rule ID 9341 //
     /*  238607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  238621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238647 */     // MIs[1] Operand 1
     /*  238647 */     // No operand predicates
     /*  238647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238656 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  238659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238674 */     GIR_RootConstrainSelectedInstOperands,
     /*  238675 */     // GIR_Coverage, 9341,
     /*  238675 */     GIR_EraseRootFromParent_Done,
     /*  238676 */   // Label 4628: @238676
     /*  238676 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(238750), // Rule ID 9344 //
     /*  238681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238721 */     // MIs[1] Operand 1
     /*  238721 */     // No operand predicates
     /*  238721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238730 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  238733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238748 */     GIR_RootConstrainSelectedInstOperands,
     /*  238749 */     // GIR_Coverage, 9344,
     /*  238749 */     GIR_EraseRootFromParent_Done,
     /*  238750 */   // Label 4629: @238750
     /*  238750 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(238824), // Rule ID 9345 //
     /*  238755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238795 */     // MIs[1] Operand 1
     /*  238795 */     // No operand predicates
     /*  238795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238804 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  238807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238822 */     GIR_RootConstrainSelectedInstOperands,
     /*  238823 */     // GIR_Coverage, 9345,
     /*  238823 */     GIR_EraseRootFromParent_Done,
     /*  238824 */   // Label 4630: @238824
     /*  238824 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(238898), // Rule ID 9348 //
     /*  238829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238869 */     // MIs[1] Operand 1
     /*  238869 */     // No operand predicates
     /*  238869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238878 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  238881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238896 */     GIR_RootConstrainSelectedInstOperands,
     /*  238897 */     // GIR_Coverage, 9348,
     /*  238897 */     GIR_EraseRootFromParent_Done,
     /*  238898 */   // Label 4631: @238898
     /*  238898 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(238972), // Rule ID 9349 //
     /*  238903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238943 */     // MIs[1] Operand 1
     /*  238943 */     // No operand predicates
     /*  238943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238952 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  238955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238970 */     GIR_RootConstrainSelectedInstOperands,
     /*  238971 */     // GIR_Coverage, 9349,
     /*  238971 */     GIR_EraseRootFromParent_Done,
     /*  238972 */   // Label 4632: @238972
     /*  238972 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(239046), // Rule ID 9352 //
     /*  238977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  238991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239017 */     // MIs[1] Operand 1
     /*  239017 */     // No operand predicates
     /*  239017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239026 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  239026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  239029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239044 */     GIR_RootConstrainSelectedInstOperands,
     /*  239045 */     // GIR_Coverage, 9352,
     /*  239045 */     GIR_EraseRootFromParent_Done,
     /*  239046 */   // Label 4633: @239046
     /*  239046 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(239120), // Rule ID 9353 //
     /*  239051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  239065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239091 */     // MIs[1] Operand 1
     /*  239091 */     // No operand predicates
     /*  239091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239100 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  239100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  239103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239118 */     GIR_RootConstrainSelectedInstOperands,
     /*  239119 */     // GIR_Coverage, 9353,
     /*  239119 */     GIR_EraseRootFromParent_Done,
     /*  239120 */   // Label 4634: @239120
     /*  239120 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(239194), // Rule ID 9356 //
     /*  239125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  239139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239165 */     // MIs[1] Operand 1
     /*  239165 */     // No operand predicates
     /*  239165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239174 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  239174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  239177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239192 */     GIR_RootConstrainSelectedInstOperands,
     /*  239193 */     // GIR_Coverage, 9356,
     /*  239193 */     GIR_EraseRootFromParent_Done,
     /*  239194 */   // Label 4635: @239194
     /*  239194 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(239268), // Rule ID 9357 //
     /*  239199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  239213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239239 */     // MIs[1] Operand 1
     /*  239239 */     // No operand predicates
     /*  239239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  239248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  239251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239266 */     GIR_RootConstrainSelectedInstOperands,
     /*  239267 */     // GIR_Coverage, 9357,
     /*  239267 */     GIR_EraseRootFromParent_Done,
     /*  239268 */   // Label 4636: @239268
     /*  239268 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(239342), // Rule ID 9360 //
     /*  239273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  239284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  239287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239313 */     // MIs[1] Operand 1
     /*  239313 */     // No operand predicates
     /*  239313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239322 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  239322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  239325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239340 */     GIR_RootConstrainSelectedInstOperands,
     /*  239341 */     // GIR_Coverage, 9360,
     /*  239341 */     GIR_EraseRootFromParent_Done,
     /*  239342 */   // Label 4637: @239342
     /*  239342 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(239416), // Rule ID 9361 //
     /*  239347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  239358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  239361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239387 */     // MIs[1] Operand 1
     /*  239387 */     // No operand predicates
     /*  239387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239396 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  239396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  239399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239414 */     GIR_RootConstrainSelectedInstOperands,
     /*  239415 */     // GIR_Coverage, 9361,
     /*  239415 */     GIR_EraseRootFromParent_Done,
     /*  239416 */   // Label 4638: @239416
     /*  239416 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(239490), // Rule ID 9364 //
     /*  239421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  239432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  239435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239461 */     // MIs[1] Operand 1
     /*  239461 */     // No operand predicates
     /*  239461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239470 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  239473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239488 */     GIR_RootConstrainSelectedInstOperands,
     /*  239489 */     // GIR_Coverage, 9364,
     /*  239489 */     GIR_EraseRootFromParent_Done,
     /*  239490 */   // Label 4639: @239490
     /*  239490 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(239564), // Rule ID 9365 //
     /*  239495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  239506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  239509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239535 */     // MIs[1] Operand 1
     /*  239535 */     // No operand predicates
     /*  239535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  239547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239562 */     GIR_RootConstrainSelectedInstOperands,
     /*  239563 */     // GIR_Coverage, 9365,
     /*  239563 */     GIR_EraseRootFromParent_Done,
     /*  239564 */   // Label 4640: @239564
     /*  239564 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(239638), // Rule ID 9368 //
     /*  239569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  239583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239609 */     // MIs[1] Operand 1
     /*  239609 */     // No operand predicates
     /*  239609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239618 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  239621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239636 */     GIR_RootConstrainSelectedInstOperands,
     /*  239637 */     // GIR_Coverage, 9368,
     /*  239637 */     GIR_EraseRootFromParent_Done,
     /*  239638 */   // Label 4641: @239638
     /*  239638 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(239712), // Rule ID 9369 //
     /*  239643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  239657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239683 */     // MIs[1] Operand 1
     /*  239683 */     // No operand predicates
     /*  239683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239692 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  239695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239710 */     GIR_RootConstrainSelectedInstOperands,
     /*  239711 */     // GIR_Coverage, 9369,
     /*  239711 */     GIR_EraseRootFromParent_Done,
     /*  239712 */   // Label 4642: @239712
     /*  239712 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(239786), // Rule ID 9372 //
     /*  239717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239757 */     // MIs[1] Operand 1
     /*  239757 */     // No operand predicates
     /*  239757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239766 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  239769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239784 */     GIR_RootConstrainSelectedInstOperands,
     /*  239785 */     // GIR_Coverage, 9372,
     /*  239785 */     GIR_EraseRootFromParent_Done,
     /*  239786 */   // Label 4643: @239786
     /*  239786 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(239860), // Rule ID 9373 //
     /*  239791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239831 */     // MIs[1] Operand 1
     /*  239831 */     // No operand predicates
     /*  239831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239840 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  239843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239858 */     GIR_RootConstrainSelectedInstOperands,
     /*  239859 */     // GIR_Coverage, 9373,
     /*  239859 */     GIR_EraseRootFromParent_Done,
     /*  239860 */   // Label 4644: @239860
     /*  239860 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(239934), // Rule ID 9464 //
     /*  239865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239905 */     // MIs[1] Operand 1
     /*  239905 */     // No operand predicates
     /*  239905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239914 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  239914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  239917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239932 */     GIR_RootConstrainSelectedInstOperands,
     /*  239933 */     // GIR_Coverage, 9464,
     /*  239933 */     GIR_EraseRootFromParent_Done,
     /*  239934 */   // Label 4645: @239934
     /*  239934 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(240008), // Rule ID 9465 //
     /*  239939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239979 */     // MIs[1] Operand 1
     /*  239979 */     // No operand predicates
     /*  239979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239988 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  239988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  239991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240006 */     GIR_RootConstrainSelectedInstOperands,
     /*  240007 */     // GIR_Coverage, 9465,
     /*  240007 */     GIR_EraseRootFromParent_Done,
     /*  240008 */   // Label 4646: @240008
     /*  240008 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(240082), // Rule ID 9468 //
     /*  240013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  240024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  240027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240053 */     // MIs[1] Operand 1
     /*  240053 */     // No operand predicates
     /*  240053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240062 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  240065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240080 */     GIR_RootConstrainSelectedInstOperands,
     /*  240081 */     // GIR_Coverage, 9468,
     /*  240081 */     GIR_EraseRootFromParent_Done,
     /*  240082 */   // Label 4647: @240082
     /*  240082 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(240156), // Rule ID 9469 //
     /*  240087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  240098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  240101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240127 */     // MIs[1] Operand 1
     /*  240127 */     // No operand predicates
     /*  240127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240136 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  240139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240154 */     GIR_RootConstrainSelectedInstOperands,
     /*  240155 */     // GIR_Coverage, 9469,
     /*  240155 */     GIR_EraseRootFromParent_Done,
     /*  240156 */   // Label 4648: @240156
     /*  240156 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(240230), // Rule ID 9472 //
     /*  240161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  240172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  240175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240201 */     // MIs[1] Operand 1
     /*  240201 */     // No operand predicates
     /*  240201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240210 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  240213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240228 */     GIR_RootConstrainSelectedInstOperands,
     /*  240229 */     // GIR_Coverage, 9472,
     /*  240229 */     GIR_EraseRootFromParent_Done,
     /*  240230 */   // Label 4649: @240230
     /*  240230 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(240304), // Rule ID 9473 //
     /*  240235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  240246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  240249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240275 */     // MIs[1] Operand 1
     /*  240275 */     // No operand predicates
     /*  240275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240284 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  240287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240302 */     GIR_RootConstrainSelectedInstOperands,
     /*  240303 */     // GIR_Coverage, 9473,
     /*  240303 */     GIR_EraseRootFromParent_Done,
     /*  240304 */   // Label 4650: @240304
     /*  240304 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(240378), // Rule ID 9476 //
     /*  240309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240349 */     // MIs[1] Operand 1
     /*  240349 */     // No operand predicates
     /*  240349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240358 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  240358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  240361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240376 */     GIR_RootConstrainSelectedInstOperands,
     /*  240377 */     // GIR_Coverage, 9476,
     /*  240377 */     GIR_EraseRootFromParent_Done,
     /*  240378 */   // Label 4651: @240378
     /*  240378 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(240452), // Rule ID 9477 //
     /*  240383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240423 */     // MIs[1] Operand 1
     /*  240423 */     // No operand predicates
     /*  240423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240432 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  240432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  240435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240450 */     GIR_RootConstrainSelectedInstOperands,
     /*  240451 */     // GIR_Coverage, 9477,
     /*  240451 */     GIR_EraseRootFromParent_Done,
     /*  240452 */   // Label 4652: @240452
     /*  240452 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(240526), // Rule ID 9480 //
     /*  240457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  240468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  240471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240497 */     // MIs[1] Operand 1
     /*  240497 */     // No operand predicates
     /*  240497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240506 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  240506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  240509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240524 */     GIR_RootConstrainSelectedInstOperands,
     /*  240525 */     // GIR_Coverage, 9480,
     /*  240525 */     GIR_EraseRootFromParent_Done,
     /*  240526 */   // Label 4653: @240526
     /*  240526 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(240600), // Rule ID 9481 //
     /*  240531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  240542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  240545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240571 */     // MIs[1] Operand 1
     /*  240571 */     // No operand predicates
     /*  240571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240580 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  240580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  240583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240598 */     GIR_RootConstrainSelectedInstOperands,
     /*  240599 */     // GIR_Coverage, 9481,
     /*  240599 */     GIR_EraseRootFromParent_Done,
     /*  240600 */   // Label 4654: @240600
     /*  240600 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(240674), // Rule ID 9484 //
     /*  240605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  240619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240645 */     // MIs[1] Operand 1
     /*  240645 */     // No operand predicates
     /*  240645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240654 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  240654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  240657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240672 */     GIR_RootConstrainSelectedInstOperands,
     /*  240673 */     // GIR_Coverage, 9484,
     /*  240673 */     GIR_EraseRootFromParent_Done,
     /*  240674 */   // Label 4655: @240674
     /*  240674 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(240748), // Rule ID 9485 //
     /*  240679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  240693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240719 */     // MIs[1] Operand 1
     /*  240719 */     // No operand predicates
     /*  240719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240728 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  240728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  240731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240746 */     GIR_RootConstrainSelectedInstOperands,
     /*  240747 */     // GIR_Coverage, 9485,
     /*  240747 */     GIR_EraseRootFromParent_Done,
     /*  240748 */   // Label 4656: @240748
     /*  240748 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(240822), // Rule ID 9488 //
     /*  240753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  240764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  240767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240793 */     // MIs[1] Operand 1
     /*  240793 */     // No operand predicates
     /*  240793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240802 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  240805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240820 */     GIR_RootConstrainSelectedInstOperands,
     /*  240821 */     // GIR_Coverage, 9488,
     /*  240821 */     GIR_EraseRootFromParent_Done,
     /*  240822 */   // Label 4657: @240822
     /*  240822 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(240896), // Rule ID 9489 //
     /*  240827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  240838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  240841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240867 */     // MIs[1] Operand 1
     /*  240867 */     // No operand predicates
     /*  240867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240876 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  240879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240894 */     GIR_RootConstrainSelectedInstOperands,
     /*  240895 */     // GIR_Coverage, 9489,
     /*  240895 */     GIR_EraseRootFromParent_Done,
     /*  240896 */   // Label 4658: @240896
     /*  240896 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(240970), // Rule ID 9492 //
     /*  240901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  240912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  240915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240941 */     // MIs[1] Operand 1
     /*  240941 */     // No operand predicates
     /*  240941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240950 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  240950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  240953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240968 */     GIR_RootConstrainSelectedInstOperands,
     /*  240969 */     // GIR_Coverage, 9492,
     /*  240969 */     GIR_EraseRootFromParent_Done,
     /*  240970 */   // Label 4659: @240970
     /*  240970 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(241044), // Rule ID 9493 //
     /*  240975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  240986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  240989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241015 */     // MIs[1] Operand 1
     /*  241015 */     // No operand predicates
     /*  241015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241024 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  241024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  241027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241042 */     GIR_RootConstrainSelectedInstOperands,
     /*  241043 */     // GIR_Coverage, 9493,
     /*  241043 */     GIR_EraseRootFromParent_Done,
     /*  241044 */   // Label 4660: @241044
     /*  241044 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(241118), // Rule ID 9496 //
     /*  241049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  241060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  241063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241089 */     // MIs[1] Operand 1
     /*  241089 */     // No operand predicates
     /*  241089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241098 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  241098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  241101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241116 */     GIR_RootConstrainSelectedInstOperands,
     /*  241117 */     // GIR_Coverage, 9496,
     /*  241117 */     GIR_EraseRootFromParent_Done,
     /*  241118 */   // Label 4661: @241118
     /*  241118 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(241192), // Rule ID 9497 //
     /*  241123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  241134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  241137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  241140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241163 */     // MIs[1] Operand 1
     /*  241163 */     // No operand predicates
     /*  241163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241172 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  241172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  241175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241190 */     GIR_RootConstrainSelectedInstOperands,
     /*  241191 */     // GIR_Coverage, 9497,
     /*  241191 */     GIR_EraseRootFromParent_Done,
     /*  241192 */   // Label 4662: @241192
     /*  241192 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(241266), // Rule ID 9500 //
     /*  241197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  241200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  241208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  241211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241237 */     // MIs[1] Operand 1
     /*  241237 */     // No operand predicates
     /*  241237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241246 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  241246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  241249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241264 */     GIR_RootConstrainSelectedInstOperands,
     /*  241265 */     // GIR_Coverage, 9500,
     /*  241265 */     GIR_EraseRootFromParent_Done,
     /*  241266 */   // Label 4663: @241266
     /*  241266 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(241340), // Rule ID 9501 //
     /*  241271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  241274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  241282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  241285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  241288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241311 */     // MIs[1] Operand 1
     /*  241311 */     // No operand predicates
     /*  241311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241320 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  241320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  241323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241338 */     GIR_RootConstrainSelectedInstOperands,
     /*  241339 */     // GIR_Coverage, 9501,
     /*  241339 */     GIR_EraseRootFromParent_Done,
     /*  241340 */   // Label 4664: @241340
     /*  241340 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(241414), // Rule ID 9504 //
     /*  241345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  241356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  241359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241385 */     // MIs[1] Operand 1
     /*  241385 */     // No operand predicates
     /*  241385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241394 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  241394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  241397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  241412 */     GIR_RootConstrainSelectedInstOperands,
     /*  241413 */     // GIR_Coverage, 9504,
     /*  241413 */     GIR_EraseRootFromParent_Done,
     /*  241414 */   // Label 4665: @241414
     /*  241414 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(241488), // Rule ID 9505 //
     /*  241419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  241430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  241433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  241436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241459 */     // MIs[1] Operand 1
     /*  241459 */     // No operand predicates
     /*  241459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241468 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  241468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  241471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  241486 */     GIR_RootConstrainSelectedInstOperands,
     /*  241487 */     // GIR_Coverage, 9505,
     /*  241487 */     GIR_EraseRootFromParent_Done,
     /*  241488 */   // Label 4666: @241488
     /*  241488 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(241562), // Rule ID 9508 //
     /*  241493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  241504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  241507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241533 */     // MIs[1] Operand 1
     /*  241533 */     // No operand predicates
     /*  241533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241542 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  241542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  241545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  241560 */     GIR_RootConstrainSelectedInstOperands,
     /*  241561 */     // GIR_Coverage, 9508,
     /*  241561 */     GIR_EraseRootFromParent_Done,
     /*  241562 */   // Label 4667: @241562
     /*  241562 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(241636), // Rule ID 9509 //
     /*  241567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  241578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  241581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  241584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241607 */     // MIs[1] Operand 1
     /*  241607 */     // No operand predicates
     /*  241607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241616 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  241616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  241619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  241634 */     GIR_RootConstrainSelectedInstOperands,
     /*  241635 */     // GIR_Coverage, 9509,
     /*  241635 */     GIR_EraseRootFromParent_Done,
     /*  241636 */   // Label 4668: @241636
     /*  241636 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(241710), // Rule ID 9512 //
     /*  241641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  241652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  241655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241681 */     // MIs[1] Operand 1
     /*  241681 */     // No operand predicates
     /*  241681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241690 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  241690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  241693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  241708 */     GIR_RootConstrainSelectedInstOperands,
     /*  241709 */     // GIR_Coverage, 9512,
     /*  241709 */     GIR_EraseRootFromParent_Done,
     /*  241710 */   // Label 4669: @241710
     /*  241710 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(241784), // Rule ID 9513 //
     /*  241715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  241726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  241729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  241732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241755 */     // MIs[1] Operand 1
     /*  241755 */     // No operand predicates
     /*  241755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241764 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  241764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  241767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  241782 */     GIR_RootConstrainSelectedInstOperands,
     /*  241783 */     // GIR_Coverage, 9513,
     /*  241783 */     GIR_EraseRootFromParent_Done,
     /*  241784 */   // Label 4670: @241784
     /*  241784 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(241858), // Rule ID 9516 //
     /*  241789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  241800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  241803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241829 */     // MIs[1] Operand 1
     /*  241829 */     // No operand predicates
     /*  241829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241838 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  241838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  241841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241856 */     GIR_RootConstrainSelectedInstOperands,
     /*  241857 */     // GIR_Coverage, 9516,
     /*  241857 */     GIR_EraseRootFromParent_Done,
     /*  241858 */   // Label 4671: @241858
     /*  241858 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(241932), // Rule ID 9517 //
     /*  241863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  241874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  241877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  241880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241903 */     // MIs[1] Operand 1
     /*  241903 */     // No operand predicates
     /*  241903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  241912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  241915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241930 */     GIR_RootConstrainSelectedInstOperands,
     /*  241931 */     // GIR_Coverage, 9517,
     /*  241931 */     GIR_EraseRootFromParent_Done,
     /*  241932 */   // Label 4672: @241932
     /*  241932 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(242006), // Rule ID 9520 //
     /*  241937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  241948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  241951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241977 */     // MIs[1] Operand 1
     /*  241977 */     // No operand predicates
     /*  241977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241986 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  241986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  241989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242004 */     GIR_RootConstrainSelectedInstOperands,
     /*  242005 */     // GIR_Coverage, 9520,
     /*  242005 */     GIR_EraseRootFromParent_Done,
     /*  242006 */   // Label 4673: @242006
     /*  242006 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(242080), // Rule ID 9521 //
     /*  242011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  242022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  242025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242051 */     // MIs[1] Operand 1
     /*  242051 */     // No operand predicates
     /*  242051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242060 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  242060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  242063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242078 */     GIR_RootConstrainSelectedInstOperands,
     /*  242079 */     // GIR_Coverage, 9521,
     /*  242079 */     GIR_EraseRootFromParent_Done,
     /*  242080 */   // Label 4674: @242080
     /*  242080 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(242154), // Rule ID 9524 //
     /*  242085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  242096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  242099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242125 */     // MIs[1] Operand 1
     /*  242125 */     // No operand predicates
     /*  242125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242134 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  242134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  242137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242152 */     GIR_RootConstrainSelectedInstOperands,
     /*  242153 */     // GIR_Coverage, 9524,
     /*  242153 */     GIR_EraseRootFromParent_Done,
     /*  242154 */   // Label 4675: @242154
     /*  242154 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(242228), // Rule ID 9525 //
     /*  242159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  242170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  242173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242199 */     // MIs[1] Operand 1
     /*  242199 */     // No operand predicates
     /*  242199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242208 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  242208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  242211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242226 */     GIR_RootConstrainSelectedInstOperands,
     /*  242227 */     // GIR_Coverage, 9525,
     /*  242227 */     GIR_EraseRootFromParent_Done,
     /*  242228 */   // Label 4676: @242228
     /*  242228 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(242302), // Rule ID 9528 //
     /*  242233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  242244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  242247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242273 */     // MIs[1] Operand 1
     /*  242273 */     // No operand predicates
     /*  242273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242282 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  242282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  242285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242300 */     GIR_RootConstrainSelectedInstOperands,
     /*  242301 */     // GIR_Coverage, 9528,
     /*  242301 */     GIR_EraseRootFromParent_Done,
     /*  242302 */   // Label 4677: @242302
     /*  242302 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(242376), // Rule ID 9529 //
     /*  242307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  242318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  242321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242347 */     // MIs[1] Operand 1
     /*  242347 */     // No operand predicates
     /*  242347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242356 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  242356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  242359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242374 */     GIR_RootConstrainSelectedInstOperands,
     /*  242375 */     // GIR_Coverage, 9529,
     /*  242375 */     GIR_EraseRootFromParent_Done,
     /*  242376 */   // Label 4678: @242376
     /*  242376 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(242450), // Rule ID 9532 //
     /*  242381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  242392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242421 */     // MIs[1] Operand 1
     /*  242421 */     // No operand predicates
     /*  242421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242430 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  242430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  242433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242448 */     GIR_RootConstrainSelectedInstOperands,
     /*  242449 */     // GIR_Coverage, 9532,
     /*  242449 */     GIR_EraseRootFromParent_Done,
     /*  242450 */   // Label 4679: @242450
     /*  242450 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(242524), // Rule ID 9533 //
     /*  242455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  242466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242495 */     // MIs[1] Operand 1
     /*  242495 */     // No operand predicates
     /*  242495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242504 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  242504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  242507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242522 */     GIR_RootConstrainSelectedInstOperands,
     /*  242523 */     // GIR_Coverage, 9533,
     /*  242523 */     GIR_EraseRootFromParent_Done,
     /*  242524 */   // Label 4680: @242524
     /*  242524 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(242598), // Rule ID 9536 //
     /*  242529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  242540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242569 */     // MIs[1] Operand 1
     /*  242569 */     // No operand predicates
     /*  242569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242578 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  242578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  242581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242596 */     GIR_RootConstrainSelectedInstOperands,
     /*  242597 */     // GIR_Coverage, 9536,
     /*  242597 */     GIR_EraseRootFromParent_Done,
     /*  242598 */   // Label 4681: @242598
     /*  242598 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(242672), // Rule ID 9537 //
     /*  242603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  242614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242643 */     // MIs[1] Operand 1
     /*  242643 */     // No operand predicates
     /*  242643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242652 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  242652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  242655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242670 */     GIR_RootConstrainSelectedInstOperands,
     /*  242671 */     // GIR_Coverage, 9537,
     /*  242671 */     GIR_EraseRootFromParent_Done,
     /*  242672 */   // Label 4682: @242672
     /*  242672 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(242746), // Rule ID 9540 //
     /*  242677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  242680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  242688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  242691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242717 */     // MIs[1] Operand 1
     /*  242717 */     // No operand predicates
     /*  242717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242726 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  242726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  242729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242744 */     GIR_RootConstrainSelectedInstOperands,
     /*  242745 */     // GIR_Coverage, 9540,
     /*  242745 */     GIR_EraseRootFromParent_Done,
     /*  242746 */   // Label 4683: @242746
     /*  242746 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(242820), // Rule ID 9541 //
     /*  242751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  242754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  242762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  242765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242791 */     // MIs[1] Operand 1
     /*  242791 */     // No operand predicates
     /*  242791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242800 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  242800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  242803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242818 */     GIR_RootConstrainSelectedInstOperands,
     /*  242819 */     // GIR_Coverage, 9541,
     /*  242819 */     GIR_EraseRootFromParent_Done,
     /*  242820 */   // Label 4684: @242820
     /*  242820 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(242894), // Rule ID 9544 //
     /*  242825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  242828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  242836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242865 */     // MIs[1] Operand 1
     /*  242865 */     // No operand predicates
     /*  242865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242874 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  242874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  242877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242892 */     GIR_RootConstrainSelectedInstOperands,
     /*  242893 */     // GIR_Coverage, 9544,
     /*  242893 */     GIR_EraseRootFromParent_Done,
     /*  242894 */   // Label 4685: @242894
     /*  242894 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(242968), // Rule ID 9545 //
     /*  242899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  242902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  242910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242939 */     // MIs[1] Operand 1
     /*  242939 */     // No operand predicates
     /*  242939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242948 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  242948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  242951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242966 */     GIR_RootConstrainSelectedInstOperands,
     /*  242967 */     // GIR_Coverage, 9545,
     /*  242967 */     GIR_EraseRootFromParent_Done,
     /*  242968 */   // Label 4686: @242968
     /*  242968 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(243042), // Rule ID 9548 //
     /*  242973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  242976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  242984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  242987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  243005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  243009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  243013 */     // MIs[1] Operand 1
     /*  243013 */     // No operand predicates
     /*  243013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  243015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243022 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  243022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  243025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  243032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243040 */     GIR_RootConstrainSelectedInstOperands,
     /*  243041 */     // GIR_Coverage, 9548,
     /*  243041 */     GIR_EraseRootFromParent_Done,
     /*  243042 */   // Label 4687: @243042
     /*  243042 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(243116), // Rule ID 9549 //
     /*  243047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  243050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  243055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  243058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  243064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  243079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  243083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  243087 */     // MIs[1] Operand 1
     /*  243087 */     // No operand predicates
     /*  243087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  243089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243096 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  243096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  243099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  243106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243114 */     GIR_RootConstrainSelectedInstOperands,
     /*  243115 */     // GIR_Coverage, 9549,
     /*  243115 */     GIR_EraseRootFromParent_Done,
     /*  243116 */   // Label 4688: @243116
     /*  243116 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(243172), // Rule ID 64439 //
     /*  243121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  243124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bitrev),
     /*  243129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  243132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  243135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  243139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  243143 */     // MIs[0] pts
     /*  243143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  243146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  243151 */     // MIs[0] radix
     /*  243151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  243154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm2),
     /*  243159 */     // (intrinsic_wo_chain:{ *:[i32] } 10961:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts)
     /*  243159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /*  243162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243166 */     GIR_RootToRootCopy, /*OpIdx*/4, // radix
     /*  243168 */     GIR_RootToRootCopy, /*OpIdx*/3, // pts
     /*  243170 */     GIR_RootConstrainSelectedInstOperands,
     /*  243171 */     // GIR_Coverage, 64439,
     /*  243171 */     GIR_EraseRootFromParent_Done,
     /*  243172 */   // Label 4689: @243172
     /*  243172 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(243235), // Rule ID 2678 //
     /*  243177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  243180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  243185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  243188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  243191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  243194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  243201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  243209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243216 */     // (intrinsic_wo_chain:{ *:[i64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  243216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  243219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243223 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  243225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243233 */     GIR_RootConstrainSelectedInstOperands,
     /*  243234 */     // GIR_Coverage, 2678,
     /*  243234 */     GIR_EraseRootFromParent_Done,
     /*  243235 */   // Label 4690: @243235
     /*  243235 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(243298), // Rule ID 2679 //
     /*  243240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  243243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  243248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  243251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  243254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  243257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  243264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  243272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243279 */     // (intrinsic_wo_chain:{ *:[i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  243279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  243282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243286 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  243288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243296 */     GIR_RootConstrainSelectedInstOperands,
     /*  243297 */     // GIR_Coverage, 2679,
     /*  243297 */     GIR_EraseRootFromParent_Done,
     /*  243298 */   // Label 4691: @243298
     /*  243298 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(243364), // Rule ID 2686 //
     /*  243303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  243311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  243314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  243320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243342 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  243342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  243345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  243359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243362 */     GIR_RootConstrainSelectedInstOperands,
     /*  243363 */     // GIR_Coverage, 2686,
     /*  243363 */     GIR_EraseRootFromParent_Done,
     /*  243364 */   // Label 4692: @243364
     /*  243364 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(243430), // Rule ID 2687 //
     /*  243369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  243377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  243380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  243386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243408 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  243408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  243411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  243425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243428 */     GIR_RootConstrainSelectedInstOperands,
     /*  243429 */     // GIR_Coverage, 2687,
     /*  243429 */     GIR_EraseRootFromParent_Done,
     /*  243430 */   // Label 4693: @243430
     /*  243430 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(243496), // Rule ID 2690 //
     /*  243435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  243446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  243449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  243474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  243477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243494 */     GIR_RootConstrainSelectedInstOperands,
     /*  243495 */     // GIR_Coverage, 2690,
     /*  243495 */     GIR_EraseRootFromParent_Done,
     /*  243496 */   // Label 4694: @243496
     /*  243496 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(243562), // Rule ID 2691 //
     /*  243501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  243512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  243515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243540 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  243540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  243543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243560 */     GIR_RootConstrainSelectedInstOperands,
     /*  243561 */     // GIR_Coverage, 2691,
     /*  243561 */     GIR_EraseRootFromParent_Done,
     /*  243562 */   // Label 4695: @243562
     /*  243562 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(243628), // Rule ID 2694 //
     /*  243567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  243570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  243575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  243578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  243581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  243584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243606 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  243606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  243609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243626 */     GIR_RootConstrainSelectedInstOperands,
     /*  243627 */     // GIR_Coverage, 2694,
     /*  243627 */     GIR_EraseRootFromParent_Done,
     /*  243628 */   // Label 4696: @243628
     /*  243628 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(243694), // Rule ID 2695 //
     /*  243633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  243636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  243641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  243644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  243647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  243650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243672 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  243672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  243675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243692 */     GIR_RootConstrainSelectedInstOperands,
     /*  243693 */     // GIR_Coverage, 2695,
     /*  243693 */     GIR_EraseRootFromParent_Done,
     /*  243694 */   // Label 4697: @243694
     /*  243694 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(243757), // Rule ID 2708 //
     /*  243699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  243707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  243710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243738 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  243738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  243741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  243755 */     GIR_RootConstrainSelectedInstOperands,
     /*  243756 */     // GIR_Coverage, 2708,
     /*  243756 */     GIR_EraseRootFromParent_Done,
     /*  243757 */   // Label 4698: @243757
     /*  243757 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(243820), // Rule ID 2709 //
     /*  243762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  243770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  243773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243801 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  243801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  243804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  243818 */     GIR_RootConstrainSelectedInstOperands,
     /*  243819 */     // GIR_Coverage, 2709,
     /*  243819 */     GIR_EraseRootFromParent_Done,
     /*  243820 */   // Label 4699: @243820
     /*  243820 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(243883), // Rule ID 2720 //
     /*  243825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  243833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  243836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243864 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  243864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  243867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  243871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  243873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  243881 */     GIR_RootConstrainSelectedInstOperands,
     /*  243882 */     // GIR_Coverage, 2720,
     /*  243882 */     GIR_EraseRootFromParent_Done,
     /*  243883 */   // Label 4700: @243883
     /*  243883 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(243946), // Rule ID 2721 //
     /*  243888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  243896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  243899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243927 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  243927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  243930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  243934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  243936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  243944 */     GIR_RootConstrainSelectedInstOperands,
     /*  243945 */     // GIR_Coverage, 2721,
     /*  243945 */     GIR_EraseRootFromParent_Done,
     /*  243946 */   // Label 4701: @243946
     /*  243946 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(244009), // Rule ID 2728 //
     /*  243951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  243959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  243962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243990 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  243990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  243993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  244007 */     GIR_RootConstrainSelectedInstOperands,
     /*  244008 */     // GIR_Coverage, 2728,
     /*  244008 */     GIR_EraseRootFromParent_Done,
     /*  244009 */   // Label 4702: @244009
     /*  244009 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(244072), // Rule ID 2729 //
     /*  244014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  244022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  244025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  244028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244053 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  244053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  244056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  244060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  244070 */     GIR_RootConstrainSelectedInstOperands,
     /*  244071 */     // GIR_Coverage, 2729,
     /*  244071 */     GIR_EraseRootFromParent_Done,
     /*  244072 */   // Label 4703: @244072
     /*  244072 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(244138), // Rule ID 2730 //
     /*  244077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  244080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  244088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  244091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  244094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244116 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  244119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244136 */     GIR_RootConstrainSelectedInstOperands,
     /*  244137 */     // GIR_Coverage, 2730,
     /*  244137 */     GIR_EraseRootFromParent_Done,
     /*  244138 */   // Label 4704: @244138
     /*  244138 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(244204), // Rule ID 2731 //
     /*  244143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  244146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  244154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  244157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  244160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244182 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  244185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244202 */     GIR_RootConstrainSelectedInstOperands,
     /*  244203 */     // GIR_Coverage, 2731,
     /*  244203 */     GIR_EraseRootFromParent_Done,
     /*  244204 */   // Label 4705: @244204
     /*  244204 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(244267), // Rule ID 2742 //
     /*  244209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  244217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  244220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  244223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  244226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244248 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  244248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  244251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  244255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244265 */     GIR_RootConstrainSelectedInstOperands,
     /*  244266 */     // GIR_Coverage, 2742,
     /*  244266 */     GIR_EraseRootFromParent_Done,
     /*  244267 */   // Label 4706: @244267
     /*  244267 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(244330), // Rule ID 2743 //
     /*  244272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  244280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  244283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  244286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  244289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244311 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  244311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  244314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  244318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244328 */     GIR_RootConstrainSelectedInstOperands,
     /*  244329 */     // GIR_Coverage, 2743,
     /*  244329 */     GIR_EraseRootFromParent_Done,
     /*  244330 */   // Label 4707: @244330
     /*  244330 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(244396), // Rule ID 4890 //
     /*  244335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  244346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  244349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244374 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  244377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244394 */     GIR_RootConstrainSelectedInstOperands,
     /*  244395 */     // GIR_Coverage, 4890,
     /*  244395 */     GIR_EraseRootFromParent_Done,
     /*  244396 */   // Label 4708: @244396
     /*  244396 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(244462), // Rule ID 4891 //
     /*  244401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  244412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  244415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244440 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  244443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244460 */     GIR_RootConstrainSelectedInstOperands,
     /*  244461 */     // GIR_Coverage, 4891,
     /*  244461 */     GIR_EraseRootFromParent_Done,
     /*  244462 */   // Label 4709: @244462
     /*  244462 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(244528), // Rule ID 4894 //
     /*  244467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  244478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  244481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  244509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244526 */     GIR_RootConstrainSelectedInstOperands,
     /*  244527 */     // GIR_Coverage, 4894,
     /*  244527 */     GIR_EraseRootFromParent_Done,
     /*  244528 */   // Label 4710: @244528
     /*  244528 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(244594), // Rule ID 4895 //
     /*  244533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  244544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  244547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244572 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  244575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244592 */     GIR_RootConstrainSelectedInstOperands,
     /*  244593 */     // GIR_Coverage, 4895,
     /*  244593 */     GIR_EraseRootFromParent_Done,
     /*  244594 */   // Label 4711: @244594
     /*  244594 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(244660), // Rule ID 4898 //
     /*  244599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244638 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  244641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244658 */     GIR_RootConstrainSelectedInstOperands,
     /*  244659 */     // GIR_Coverage, 4898,
     /*  244659 */     GIR_EraseRootFromParent_Done,
     /*  244660 */   // Label 4712: @244660
     /*  244660 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(244726), // Rule ID 4899 //
     /*  244665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  244707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244724 */     GIR_RootConstrainSelectedInstOperands,
     /*  244725 */     // GIR_Coverage, 4899,
     /*  244725 */     GIR_EraseRootFromParent_Done,
     /*  244726 */   // Label 4713: @244726
     /*  244726 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(244792), // Rule ID 4902 //
     /*  244731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  244742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  244745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  244748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244770 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  244773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244790 */     GIR_RootConstrainSelectedInstOperands,
     /*  244791 */     // GIR_Coverage, 4902,
     /*  244791 */     GIR_EraseRootFromParent_Done,
     /*  244792 */   // Label 4714: @244792
     /*  244792 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(244858), // Rule ID 4903 //
     /*  244797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  244808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  244811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  244814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244836 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  244839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244856 */     GIR_RootConstrainSelectedInstOperands,
     /*  244857 */     // GIR_Coverage, 4903,
     /*  244857 */     GIR_EraseRootFromParent_Done,
     /*  244858 */   // Label 4715: @244858
     /*  244858 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(244924), // Rule ID 4906 //
     /*  244863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  244874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  244877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  244880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244902 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  244905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244922 */     GIR_RootConstrainSelectedInstOperands,
     /*  244923 */     // GIR_Coverage, 4906,
     /*  244923 */     GIR_EraseRootFromParent_Done,
     /*  244924 */   // Label 4716: @244924
     /*  244924 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(244990), // Rule ID 4907 //
     /*  244929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  244940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  244943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  244946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244968 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  244971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244988 */     GIR_RootConstrainSelectedInstOperands,
     /*  244989 */     // GIR_Coverage, 4907,
     /*  244989 */     GIR_EraseRootFromParent_Done,
     /*  244990 */   // Label 4717: @244990
     /*  244990 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(245056), // Rule ID 4910 //
     /*  244995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  245006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  245009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  245012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  245037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245054 */     GIR_RootConstrainSelectedInstOperands,
     /*  245055 */     // GIR_Coverage, 4910,
     /*  245055 */     GIR_EraseRootFromParent_Done,
     /*  245056 */   // Label 4718: @245056
     /*  245056 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(245122), // Rule ID 4911 //
     /*  245061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  245072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  245075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  245078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245100 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  245103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245120 */     GIR_RootConstrainSelectedInstOperands,
     /*  245121 */     // GIR_Coverage, 4911,
     /*  245121 */     GIR_EraseRootFromParent_Done,
     /*  245122 */   // Label 4719: @245122
     /*  245122 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(245188), // Rule ID 4914 //
     /*  245127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  245144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  245169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245186 */     GIR_RootConstrainSelectedInstOperands,
     /*  245187 */     // GIR_Coverage, 4914,
     /*  245187 */     GIR_EraseRootFromParent_Done,
     /*  245188 */   // Label 4720: @245188
     /*  245188 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(245254), // Rule ID 4915 //
     /*  245193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  245210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  245235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245252 */     GIR_RootConstrainSelectedInstOperands,
     /*  245253 */     // GIR_Coverage, 4915,
     /*  245253 */     GIR_EraseRootFromParent_Done,
     /*  245254 */   // Label 4721: @245254
     /*  245254 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(245320), // Rule ID 4918 //
     /*  245259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  245301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245318 */     GIR_RootConstrainSelectedInstOperands,
     /*  245319 */     // GIR_Coverage, 4918,
     /*  245319 */     GIR_EraseRootFromParent_Done,
     /*  245320 */   // Label 4722: @245320
     /*  245320 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(245386), // Rule ID 4919 //
     /*  245325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  245367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245384 */     GIR_RootConstrainSelectedInstOperands,
     /*  245385 */     // GIR_Coverage, 4919,
     /*  245385 */     GIR_EraseRootFromParent_Done,
     /*  245386 */   // Label 4723: @245386
     /*  245386 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(245452), // Rule ID 4922 //
     /*  245391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  245402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  245405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  245408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  245433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245450 */     GIR_RootConstrainSelectedInstOperands,
     /*  245451 */     // GIR_Coverage, 4922,
     /*  245451 */     GIR_EraseRootFromParent_Done,
     /*  245452 */   // Label 4724: @245452
     /*  245452 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(245518), // Rule ID 4923 //
     /*  245457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  245468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  245471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  245474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  245499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245516 */     GIR_RootConstrainSelectedInstOperands,
     /*  245517 */     // GIR_Coverage, 4923,
     /*  245517 */     GIR_EraseRootFromParent_Done,
     /*  245518 */   // Label 4725: @245518
     /*  245518 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(245584), // Rule ID 4926 //
     /*  245523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  245534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  245537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  245540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  245565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245582 */     GIR_RootConstrainSelectedInstOperands,
     /*  245583 */     // GIR_Coverage, 4926,
     /*  245583 */     GIR_EraseRootFromParent_Done,
     /*  245584 */   // Label 4726: @245584
     /*  245584 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(245650), // Rule ID 4927 //
     /*  245589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  245600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  245603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  245606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245628 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  245631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245648 */     GIR_RootConstrainSelectedInstOperands,
     /*  245649 */     // GIR_Coverage, 4927,
     /*  245649 */     GIR_EraseRootFromParent_Done,
     /*  245650 */   // Label 4727: @245650
     /*  245650 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(245716), // Rule ID 4930 //
     /*  245655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245694 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  245697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245714 */     GIR_RootConstrainSelectedInstOperands,
     /*  245715 */     // GIR_Coverage, 4930,
     /*  245715 */     GIR_EraseRootFromParent_Done,
     /*  245716 */   // Label 4728: @245716
     /*  245716 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(245782), // Rule ID 4931 //
     /*  245721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  245763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245780 */     GIR_RootConstrainSelectedInstOperands,
     /*  245781 */     // GIR_Coverage, 4931,
     /*  245781 */     GIR_EraseRootFromParent_Done,
     /*  245782 */   // Label 4729: @245782
     /*  245782 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(245848), // Rule ID 4934 //
     /*  245787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  245798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  245801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  245804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245826 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  245829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245846 */     GIR_RootConstrainSelectedInstOperands,
     /*  245847 */     // GIR_Coverage, 4934,
     /*  245847 */     GIR_EraseRootFromParent_Done,
     /*  245848 */   // Label 4730: @245848
     /*  245848 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(245914), // Rule ID 4935 //
     /*  245853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  245864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  245867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  245870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  245895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245912 */     GIR_RootConstrainSelectedInstOperands,
     /*  245913 */     // GIR_Coverage, 4935,
     /*  245913 */     GIR_EraseRootFromParent_Done,
     /*  245914 */   // Label 4731: @245914
     /*  245914 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(245980), // Rule ID 4938 //
     /*  245919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  245930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  245933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  245936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245958 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  245961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245978 */     GIR_RootConstrainSelectedInstOperands,
     /*  245979 */     // GIR_Coverage, 4938,
     /*  245979 */     GIR_EraseRootFromParent_Done,
     /*  245980 */   // Label 4732: @245980
     /*  245980 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(246046), // Rule ID 4939 //
     /*  245985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  245996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  245999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  246002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246024 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  246027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246044 */     GIR_RootConstrainSelectedInstOperands,
     /*  246045 */     // GIR_Coverage, 4939,
     /*  246045 */     GIR_EraseRootFromParent_Done,
     /*  246046 */   // Label 4733: @246046
     /*  246046 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(246112), // Rule ID 4942 //
     /*  246051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  246062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  246065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  246068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  246093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246110 */     GIR_RootConstrainSelectedInstOperands,
     /*  246111 */     // GIR_Coverage, 4942,
     /*  246111 */     GIR_EraseRootFromParent_Done,
     /*  246112 */   // Label 4734: @246112
     /*  246112 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(246178), // Rule ID 4943 //
     /*  246117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  246128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  246131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  246134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246156 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  246159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246176 */     GIR_RootConstrainSelectedInstOperands,
     /*  246177 */     // GIR_Coverage, 4943,
     /*  246177 */     GIR_EraseRootFromParent_Done,
     /*  246178 */   // Label 4735: @246178
     /*  246178 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(246244), // Rule ID 4946 //
     /*  246183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  246194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  246197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246222 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  246225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246242 */     GIR_RootConstrainSelectedInstOperands,
     /*  246243 */     // GIR_Coverage, 4946,
     /*  246243 */     GIR_EraseRootFromParent_Done,
     /*  246244 */   // Label 4736: @246244
     /*  246244 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(246310), // Rule ID 4947 //
     /*  246249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  246260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  246263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246288 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  246291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246308 */     GIR_RootConstrainSelectedInstOperands,
     /*  246309 */     // GIR_Coverage, 4947,
     /*  246309 */     GIR_EraseRootFromParent_Done,
     /*  246310 */   // Label 4737: @246310
     /*  246310 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(246376), // Rule ID 4950 //
     /*  246315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  246326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  246329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  246357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246374 */     GIR_RootConstrainSelectedInstOperands,
     /*  246375 */     // GIR_Coverage, 4950,
     /*  246375 */     GIR_EraseRootFromParent_Done,
     /*  246376 */   // Label 4738: @246376
     /*  246376 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(246442), // Rule ID 4951 //
     /*  246381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  246392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  246395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246420 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  246423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246440 */     GIR_RootConstrainSelectedInstOperands,
     /*  246441 */     // GIR_Coverage, 4951,
     /*  246441 */     GIR_EraseRootFromParent_Done,
     /*  246442 */   // Label 4739: @246442
     /*  246442 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(246508), // Rule ID 4954 //
     /*  246447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  246464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  246489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246506 */     GIR_RootConstrainSelectedInstOperands,
     /*  246507 */     // GIR_Coverage, 4954,
     /*  246507 */     GIR_EraseRootFromParent_Done,
     /*  246508 */   // Label 4740: @246508
     /*  246508 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(246574), // Rule ID 4955 //
     /*  246513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  246530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  246555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246572 */     GIR_RootConstrainSelectedInstOperands,
     /*  246573 */     // GIR_Coverage, 4955,
     /*  246573 */     GIR_EraseRootFromParent_Done,
     /*  246574 */   // Label 4741: @246574
     /*  246574 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(246640), // Rule ID 4958 //
     /*  246579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  246596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  246621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246638 */     GIR_RootConstrainSelectedInstOperands,
     /*  246639 */     // GIR_Coverage, 4958,
     /*  246639 */     GIR_EraseRootFromParent_Done,
     /*  246640 */   // Label 4742: @246640
     /*  246640 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(246706), // Rule ID 4959 //
     /*  246645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  246662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246684 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  246687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246704 */     GIR_RootConstrainSelectedInstOperands,
     /*  246705 */     // GIR_Coverage, 4959,
     /*  246705 */     GIR_EraseRootFromParent_Done,
     /*  246706 */   // Label 4743: @246706
     /*  246706 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(246772), // Rule ID 4962 //
     /*  246711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  246722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  246725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  246728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  246753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246770 */     GIR_RootConstrainSelectedInstOperands,
     /*  246771 */     // GIR_Coverage, 4962,
     /*  246771 */     GIR_EraseRootFromParent_Done,
     /*  246772 */   // Label 4744: @246772
     /*  246772 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(246838), // Rule ID 4963 //
     /*  246777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  246788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  246791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  246794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246816 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  246819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246836 */     GIR_RootConstrainSelectedInstOperands,
     /*  246837 */     // GIR_Coverage, 4963,
     /*  246837 */     GIR_EraseRootFromParent_Done,
     /*  246838 */   // Label 4745: @246838
     /*  246838 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(246904), // Rule ID 4966 //
     /*  246843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  246860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246882 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  246885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246902 */     GIR_RootConstrainSelectedInstOperands,
     /*  246903 */     // GIR_Coverage, 4966,
     /*  246903 */     GIR_EraseRootFromParent_Done,
     /*  246904 */   // Label 4746: @246904
     /*  246904 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(246970), // Rule ID 4967 //
     /*  246909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  246926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246948 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  246951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246968 */     GIR_RootConstrainSelectedInstOperands,
     /*  246969 */     // GIR_Coverage, 4967,
     /*  246969 */     GIR_EraseRootFromParent_Done,
     /*  246970 */   // Label 4747: @246970
     /*  246970 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(247036), // Rule ID 4970 //
     /*  246975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  246992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  247017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247034 */     GIR_RootConstrainSelectedInstOperands,
     /*  247035 */     // GIR_Coverage, 4970,
     /*  247035 */     GIR_EraseRootFromParent_Done,
     /*  247036 */   // Label 4748: @247036
     /*  247036 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(247102), // Rule ID 4971 //
     /*  247041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  247058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  247083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247100 */     GIR_RootConstrainSelectedInstOperands,
     /*  247101 */     // GIR_Coverage, 4971,
     /*  247101 */     GIR_EraseRootFromParent_Done,
     /*  247102 */   // Label 4749: @247102
     /*  247102 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(247168), // Rule ID 4974 //
     /*  247107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  247124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247146 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  247149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247166 */     GIR_RootConstrainSelectedInstOperands,
     /*  247167 */     // GIR_Coverage, 4974,
     /*  247167 */     GIR_EraseRootFromParent_Done,
     /*  247168 */   // Label 4750: @247168
     /*  247168 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(247234), // Rule ID 4975 //
     /*  247173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  247190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247212 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  247215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247232 */     GIR_RootConstrainSelectedInstOperands,
     /*  247233 */     // GIR_Coverage, 4975,
     /*  247233 */     GIR_EraseRootFromParent_Done,
     /*  247234 */   // Label 4751: @247234
     /*  247234 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(247300), // Rule ID 4978 //
     /*  247239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  247256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247278 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  247281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247298 */     GIR_RootConstrainSelectedInstOperands,
     /*  247299 */     // GIR_Coverage, 4978,
     /*  247299 */     GIR_EraseRootFromParent_Done,
     /*  247300 */   // Label 4752: @247300
     /*  247300 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(247366), // Rule ID 4979 //
     /*  247305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  247322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247344 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  247347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247364 */     GIR_RootConstrainSelectedInstOperands,
     /*  247365 */     // GIR_Coverage, 4979,
     /*  247365 */     GIR_EraseRootFromParent_Done,
     /*  247366 */   // Label 4753: @247366
     /*  247366 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(247432), // Rule ID 4982 //
     /*  247371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247410 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  247413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247430 */     GIR_RootConstrainSelectedInstOperands,
     /*  247431 */     // GIR_Coverage, 4982,
     /*  247431 */     GIR_EraseRootFromParent_Done,
     /*  247432 */   // Label 4754: @247432
     /*  247432 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(247498), // Rule ID 4983 //
     /*  247437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  247479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247496 */     GIR_RootConstrainSelectedInstOperands,
     /*  247497 */     // GIR_Coverage, 4983,
     /*  247497 */     GIR_EraseRootFromParent_Done,
     /*  247498 */   // Label 4755: @247498
     /*  247498 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(247564), // Rule ID 4986 //
     /*  247503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  247545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247562 */     GIR_RootConstrainSelectedInstOperands,
     /*  247563 */     // GIR_Coverage, 4986,
     /*  247563 */     GIR_EraseRootFromParent_Done,
     /*  247564 */   // Label 4756: @247564
     /*  247564 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(247630), // Rule ID 4987 //
     /*  247569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  247611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247628 */     GIR_RootConstrainSelectedInstOperands,
     /*  247629 */     // GIR_Coverage, 4987,
     /*  247629 */     GIR_EraseRootFromParent_Done,
     /*  247630 */   // Label 4757: @247630
     /*  247630 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(247696), // Rule ID 4990 //
     /*  247635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247674 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  247677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247694 */     GIR_RootConstrainSelectedInstOperands,
     /*  247695 */     // GIR_Coverage, 4990,
     /*  247695 */     GIR_EraseRootFromParent_Done,
     /*  247696 */   // Label 4758: @247696
     /*  247696 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(247762), // Rule ID 4991 //
     /*  247701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247740 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  247743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247760 */     GIR_RootConstrainSelectedInstOperands,
     /*  247761 */     // GIR_Coverage, 4991,
     /*  247761 */     GIR_EraseRootFromParent_Done,
     /*  247762 */   // Label 4759: @247762
     /*  247762 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(247828), // Rule ID 4994 //
     /*  247767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  247784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  247809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247826 */     GIR_RootConstrainSelectedInstOperands,
     /*  247827 */     // GIR_Coverage, 4994,
     /*  247827 */     GIR_EraseRootFromParent_Done,
     /*  247828 */   // Label 4760: @247828
     /*  247828 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(247894), // Rule ID 4995 //
     /*  247833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  247850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247872 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  247875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247892 */     GIR_RootConstrainSelectedInstOperands,
     /*  247893 */     // GIR_Coverage, 4995,
     /*  247893 */     GIR_EraseRootFromParent_Done,
     /*  247894 */   // Label 4761: @247894
     /*  247894 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(247960), // Rule ID 4998 //
     /*  247899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  247910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  247913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247938 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  247938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  247941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  247955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247958 */     GIR_RootConstrainSelectedInstOperands,
     /*  247959 */     // GIR_Coverage, 4998,
     /*  247959 */     GIR_EraseRootFromParent_Done,
     /*  247960 */   // Label 4762: @247960
     /*  247960 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(248026), // Rule ID 4999 //
     /*  247965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  247976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  247979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248004 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  248007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248024 */     GIR_RootConstrainSelectedInstOperands,
     /*  248025 */     // GIR_Coverage, 4999,
     /*  248025 */     GIR_EraseRootFromParent_Done,
     /*  248026 */   // Label 4763: @248026
     /*  248026 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(248092), // Rule ID 5002 //
     /*  248031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  248042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  248045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  248048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248070 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  248070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  248073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248090 */     GIR_RootConstrainSelectedInstOperands,
     /*  248091 */     // GIR_Coverage, 5002,
     /*  248091 */     GIR_EraseRootFromParent_Done,
     /*  248092 */   // Label 4764: @248092
     /*  248092 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(248158), // Rule ID 5003 //
     /*  248097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  248108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  248111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  248114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248136 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  248139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248156 */     GIR_RootConstrainSelectedInstOperands,
     /*  248157 */     // GIR_Coverage, 5003,
     /*  248157 */     GIR_EraseRootFromParent_Done,
     /*  248158 */   // Label 4765: @248158
     /*  248158 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(248224), // Rule ID 5006 //
     /*  248163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  248174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  248177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  248180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  248202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  248205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248222 */     GIR_RootConstrainSelectedInstOperands,
     /*  248223 */     // GIR_Coverage, 5006,
     /*  248223 */     GIR_EraseRootFromParent_Done,
     /*  248224 */   // Label 4766: @248224
     /*  248224 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(248290), // Rule ID 5007 //
     /*  248229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  248240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  248243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  248246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  248271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248288 */     GIR_RootConstrainSelectedInstOperands,
     /*  248289 */     // GIR_Coverage, 5007,
     /*  248289 */     GIR_EraseRootFromParent_Done,
     /*  248290 */   // Label 4767: @248290
     /*  248290 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(248356), // Rule ID 5010 //
     /*  248295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  248306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  248309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  248334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  248337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248354 */     GIR_RootConstrainSelectedInstOperands,
     /*  248355 */     // GIR_Coverage, 5010,
     /*  248355 */     GIR_EraseRootFromParent_Done,
     /*  248356 */   // Label 4768: @248356
     /*  248356 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(248422), // Rule ID 5011 //
     /*  248361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  248372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  248375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  248403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248420 */     GIR_RootConstrainSelectedInstOperands,
     /*  248421 */     // GIR_Coverage, 5011,
     /*  248421 */     GIR_EraseRootFromParent_Done,
     /*  248422 */   // Label 4769: @248422
     /*  248422 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(248488), // Rule ID 5014 //
     /*  248427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  248438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  248441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  248444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248466 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  248466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  248469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248486 */     GIR_RootConstrainSelectedInstOperands,
     /*  248487 */     // GIR_Coverage, 5014,
     /*  248487 */     GIR_EraseRootFromParent_Done,
     /*  248488 */   // Label 4770: @248488
     /*  248488 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(248554), // Rule ID 5015 //
     /*  248493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  248504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  248507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  248510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248532 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  248535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248552 */     GIR_RootConstrainSelectedInstOperands,
     /*  248553 */     // GIR_Coverage, 5015,
     /*  248553 */     GIR_EraseRootFromParent_Done,
     /*  248554 */   // Label 4771: @248554
     /*  248554 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(248620), // Rule ID 5018 //
     /*  248559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  248570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  248573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  248576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248598 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  248598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  248601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248618 */     GIR_RootConstrainSelectedInstOperands,
     /*  248619 */     // GIR_Coverage, 5018,
     /*  248619 */     GIR_EraseRootFromParent_Done,
     /*  248620 */   // Label 4772: @248620
     /*  248620 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(248686), // Rule ID 5019 //
     /*  248625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  248636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  248639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  248642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248664 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  248667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248684 */     GIR_RootConstrainSelectedInstOperands,
     /*  248685 */     // GIR_Coverage, 5019,
     /*  248685 */     GIR_EraseRootFromParent_Done,
     /*  248686 */   // Label 4773: @248686
     /*  248686 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(248752), // Rule ID 5022 //
     /*  248691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  248702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  248705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  248708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248730 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  248730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  248733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248750 */     GIR_RootConstrainSelectedInstOperands,
     /*  248751 */     // GIR_Coverage, 5022,
     /*  248751 */     GIR_EraseRootFromParent_Done,
     /*  248752 */   // Label 4774: @248752
     /*  248752 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(248818), // Rule ID 5023 //
     /*  248757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  248768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  248771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  248774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248796 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  248796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  248799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248816 */     GIR_RootConstrainSelectedInstOperands,
     /*  248817 */     // GIR_Coverage, 5023,
     /*  248817 */     GIR_EraseRootFromParent_Done,
     /*  248818 */   // Label 4775: @248818
     /*  248818 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(248884), // Rule ID 5026 //
     /*  248823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  248834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  248837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  248840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248862 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  248862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  248865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248882 */     GIR_RootConstrainSelectedInstOperands,
     /*  248883 */     // GIR_Coverage, 5026,
     /*  248883 */     GIR_EraseRootFromParent_Done,
     /*  248884 */   // Label 4776: @248884
     /*  248884 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(248950), // Rule ID 5027 //
     /*  248889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  248900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  248903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  248906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248928 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  248928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  248931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248948 */     GIR_RootConstrainSelectedInstOperands,
     /*  248949 */     // GIR_Coverage, 5027,
     /*  248949 */     GIR_EraseRootFromParent_Done,
     /*  248950 */   // Label 4777: @248950
     /*  248950 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(249016), // Rule ID 5030 //
     /*  248955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  248966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  248969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  248972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248994 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  248994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  248997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249014 */     GIR_RootConstrainSelectedInstOperands,
     /*  249015 */     // GIR_Coverage, 5030,
     /*  249015 */     GIR_EraseRootFromParent_Done,
     /*  249016 */   // Label 4778: @249016
     /*  249016 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(249082), // Rule ID 5031 //
     /*  249021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  249032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  249035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  249038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249060 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  249060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  249063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249080 */     GIR_RootConstrainSelectedInstOperands,
     /*  249081 */     // GIR_Coverage, 5031,
     /*  249081 */     GIR_EraseRootFromParent_Done,
     /*  249082 */   // Label 4779: @249082
     /*  249082 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(249148), // Rule ID 5034 //
     /*  249087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  249098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  249101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249126 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  249126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  249129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249146 */     GIR_RootConstrainSelectedInstOperands,
     /*  249147 */     // GIR_Coverage, 5034,
     /*  249147 */     GIR_EraseRootFromParent_Done,
     /*  249148 */   // Label 4780: @249148
     /*  249148 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(249214), // Rule ID 5035 //
     /*  249153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  249164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  249167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249192 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  249192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  249195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249212 */     GIR_RootConstrainSelectedInstOperands,
     /*  249213 */     // GIR_Coverage, 5035,
     /*  249213 */     GIR_EraseRootFromParent_Done,
     /*  249214 */   // Label 4781: @249214
     /*  249214 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(249280), // Rule ID 5038 //
     /*  249219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  249230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  249233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249258 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  249258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  249261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249278 */     GIR_RootConstrainSelectedInstOperands,
     /*  249279 */     // GIR_Coverage, 5038,
     /*  249279 */     GIR_EraseRootFromParent_Done,
     /*  249280 */   // Label 4782: @249280
     /*  249280 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(249346), // Rule ID 5039 //
     /*  249285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  249296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  249299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249324 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  249324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  249327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249344 */     GIR_RootConstrainSelectedInstOperands,
     /*  249345 */     // GIR_Coverage, 5039,
     /*  249345 */     GIR_EraseRootFromParent_Done,
     /*  249346 */   // Label 4783: @249346
     /*  249346 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(249412), // Rule ID 5042 //
     /*  249351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  249354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  249362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  249365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  249368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  249390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  249393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249410 */     GIR_RootConstrainSelectedInstOperands,
     /*  249411 */     // GIR_Coverage, 5042,
     /*  249411 */     GIR_EraseRootFromParent_Done,
     /*  249412 */   // Label 4784: @249412
     /*  249412 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(249478), // Rule ID 5043 //
     /*  249417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  249420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  249428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  249431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  249434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249456 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  249456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  249459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249476 */     GIR_RootConstrainSelectedInstOperands,
     /*  249477 */     // GIR_Coverage, 5043,
     /*  249477 */     GIR_EraseRootFromParent_Done,
     /*  249478 */   // Label 4785: @249478
     /*  249478 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(249544), // Rule ID 5046 //
     /*  249483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  249486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  249494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  249497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  249500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249522 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  249522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  249525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249542 */     GIR_RootConstrainSelectedInstOperands,
     /*  249543 */     // GIR_Coverage, 5046,
     /*  249543 */     GIR_EraseRootFromParent_Done,
     /*  249544 */   // Label 4786: @249544
     /*  249544 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(249610), // Rule ID 5047 //
     /*  249549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  249552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  249560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  249563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  249566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249588 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  249588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  249591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249608 */     GIR_RootConstrainSelectedInstOperands,
     /*  249609 */     // GIR_Coverage, 5047,
     /*  249609 */     GIR_EraseRootFromParent_Done,
     /*  249610 */   // Label 4787: @249610
     /*  249610 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(249676), // Rule ID 5050 //
     /*  249615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  249618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  249626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  249629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  249632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249654 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  249654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  249657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249674 */     GIR_RootConstrainSelectedInstOperands,
     /*  249675 */     // GIR_Coverage, 5050,
     /*  249675 */     GIR_EraseRootFromParent_Done,
     /*  249676 */   // Label 4788: @249676
     /*  249676 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(249742), // Rule ID 5051 //
     /*  249681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  249684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  249692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  249695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  249698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  249720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  249723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249740 */     GIR_RootConstrainSelectedInstOperands,
     /*  249741 */     // GIR_Coverage, 5051,
     /*  249741 */     GIR_EraseRootFromParent_Done,
     /*  249742 */   // Label 4789: @249742
     /*  249742 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(249808), // Rule ID 5054 //
     /*  249747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  249750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  249758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  249761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  249764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  249786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  249789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249806 */     GIR_RootConstrainSelectedInstOperands,
     /*  249807 */     // GIR_Coverage, 5054,
     /*  249807 */     GIR_EraseRootFromParent_Done,
     /*  249808 */   // Label 4790: @249808
     /*  249808 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(249874), // Rule ID 5055 //
     /*  249813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  249816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  249824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  249827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  249830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249852 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  249852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  249855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249872 */     GIR_RootConstrainSelectedInstOperands,
     /*  249873 */     // GIR_Coverage, 5055,
     /*  249873 */     GIR_EraseRootFromParent_Done,
     /*  249874 */   // Label 4791: @249874
     /*  249874 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(249940), // Rule ID 5058 //
     /*  249879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  249890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  249893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  249896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  249918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  249921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249938 */     GIR_RootConstrainSelectedInstOperands,
     /*  249939 */     // GIR_Coverage, 5058,
     /*  249939 */     GIR_EraseRootFromParent_Done,
     /*  249940 */   // Label 4792: @249940
     /*  249940 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(250006), // Rule ID 5059 //
     /*  249945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  249956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  249959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  249962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249984 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  249984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  249987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250004 */     GIR_RootConstrainSelectedInstOperands,
     /*  250005 */     // GIR_Coverage, 5059,
     /*  250005 */     GIR_EraseRootFromParent_Done,
     /*  250006 */   // Label 4793: @250006
     /*  250006 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(250072), // Rule ID 5062 //
     /*  250011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  250022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  250025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  250028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  250050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  250053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250070 */     GIR_RootConstrainSelectedInstOperands,
     /*  250071 */     // GIR_Coverage, 5062,
     /*  250071 */     GIR_EraseRootFromParent_Done,
     /*  250072 */   // Label 4794: @250072
     /*  250072 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(250138), // Rule ID 5063 //
     /*  250077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  250088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  250091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  250094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250116 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  250116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  250119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250136 */     GIR_RootConstrainSelectedInstOperands,
     /*  250137 */     // GIR_Coverage, 5063,
     /*  250137 */     GIR_EraseRootFromParent_Done,
     /*  250138 */   // Label 4795: @250138
     /*  250138 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(250204), // Rule ID 5066 //
     /*  250143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  250154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  250157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  250160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250182 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  250182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  250185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250202 */     GIR_RootConstrainSelectedInstOperands,
     /*  250203 */     // GIR_Coverage, 5066,
     /*  250203 */     GIR_EraseRootFromParent_Done,
     /*  250204 */   // Label 4796: @250204
     /*  250204 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(250270), // Rule ID 5067 //
     /*  250209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  250220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  250223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  250226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  250248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  250251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250268 */     GIR_RootConstrainSelectedInstOperands,
     /*  250269 */     // GIR_Coverage, 5067,
     /*  250269 */     GIR_EraseRootFromParent_Done,
     /*  250270 */   // Label 4797: @250270
     /*  250270 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(250336), // Rule ID 5070 //
     /*  250275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  250286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  250289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  250292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  250314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  250317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250334 */     GIR_RootConstrainSelectedInstOperands,
     /*  250335 */     // GIR_Coverage, 5070,
     /*  250335 */     GIR_EraseRootFromParent_Done,
     /*  250336 */   // Label 4798: @250336
     /*  250336 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(250402), // Rule ID 5071 //
     /*  250341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  250352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  250355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  250358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250380 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  250380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  250383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250400 */     GIR_RootConstrainSelectedInstOperands,
     /*  250401 */     // GIR_Coverage, 5071,
     /*  250401 */     GIR_EraseRootFromParent_Done,
     /*  250402 */   // Label 4799: @250402
     /*  250402 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(250468), // Rule ID 5074 //
     /*  250407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  250418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  250421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  250424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  250446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  250449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250466 */     GIR_RootConstrainSelectedInstOperands,
     /*  250467 */     // GIR_Coverage, 5074,
     /*  250467 */     GIR_EraseRootFromParent_Done,
     /*  250468 */   // Label 4800: @250468
     /*  250468 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(250534), // Rule ID 5075 //
     /*  250473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  250484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  250487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  250490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250512 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  250512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  250515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250532 */     GIR_RootConstrainSelectedInstOperands,
     /*  250533 */     // GIR_Coverage, 5075,
     /*  250533 */     GIR_EraseRootFromParent_Done,
     /*  250534 */   // Label 4801: @250534
     /*  250534 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(250600), // Rule ID 5078 //
     /*  250539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  250542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  250550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  250553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  250556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250578 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  250578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  250581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250598 */     GIR_RootConstrainSelectedInstOperands,
     /*  250599 */     // GIR_Coverage, 5078,
     /*  250599 */     GIR_EraseRootFromParent_Done,
     /*  250600 */   // Label 4802: @250600
     /*  250600 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(250666), // Rule ID 5079 //
     /*  250605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  250608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  250616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  250619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  250622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  250644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  250647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250664 */     GIR_RootConstrainSelectedInstOperands,
     /*  250665 */     // GIR_Coverage, 5079,
     /*  250665 */     GIR_EraseRootFromParent_Done,
     /*  250666 */   // Label 4803: @250666
     /*  250666 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(250732), // Rule ID 5082 //
     /*  250671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  250674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  250682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  250685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  250688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  250710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  250713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250730 */     GIR_RootConstrainSelectedInstOperands,
     /*  250731 */     // GIR_Coverage, 5082,
     /*  250731 */     GIR_EraseRootFromParent_Done,
     /*  250732 */   // Label 4804: @250732
     /*  250732 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(250798), // Rule ID 5083 //
     /*  250737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  250740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  250748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  250751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  250754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  250776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  250779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250796 */     GIR_RootConstrainSelectedInstOperands,
     /*  250797 */     // GIR_Coverage, 5083,
     /*  250797 */     GIR_EraseRootFromParent_Done,
     /*  250798 */   // Label 4805: @250798
     /*  250798 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(250864), // Rule ID 5086 //
     /*  250803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  250806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  250814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  250820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250842 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  250842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  250845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250862 */     GIR_RootConstrainSelectedInstOperands,
     /*  250863 */     // GIR_Coverage, 5086,
     /*  250863 */     GIR_EraseRootFromParent_Done,
     /*  250864 */   // Label 4806: @250864
     /*  250864 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(250930), // Rule ID 5087 //
     /*  250869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  250872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  250880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  250886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250908 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  250908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  250911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250928 */     GIR_RootConstrainSelectedInstOperands,
     /*  250929 */     // GIR_Coverage, 5087,
     /*  250929 */     GIR_EraseRootFromParent_Done,
     /*  250930 */   // Label 4807: @250930
     /*  250930 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(250996), // Rule ID 5090 //
     /*  250935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  250938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  250946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  250949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  250952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250974 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  250974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  250977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250994 */     GIR_RootConstrainSelectedInstOperands,
     /*  250995 */     // GIR_Coverage, 5090,
     /*  250995 */     GIR_EraseRootFromParent_Done,
     /*  250996 */   // Label 4808: @250996
     /*  250996 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(251062), // Rule ID 5091 //
     /*  251001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  251004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  251012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  251015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  251018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251040 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  251040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  251043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251060 */     GIR_RootConstrainSelectedInstOperands,
     /*  251061 */     // GIR_Coverage, 5091,
     /*  251061 */     GIR_EraseRootFromParent_Done,
     /*  251062 */   // Label 4809: @251062
     /*  251062 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(251128), // Rule ID 5094 //
     /*  251067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  251070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  251078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  251081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  251084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  251106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  251109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251126 */     GIR_RootConstrainSelectedInstOperands,
     /*  251127 */     // GIR_Coverage, 5094,
     /*  251127 */     GIR_EraseRootFromParent_Done,
     /*  251128 */   // Label 4810: @251128
     /*  251128 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(251194), // Rule ID 5095 //
     /*  251133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  251136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  251144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  251147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  251150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251172 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  251172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  251175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251192 */     GIR_RootConstrainSelectedInstOperands,
     /*  251193 */     // GIR_Coverage, 5095,
     /*  251193 */     GIR_EraseRootFromParent_Done,
     /*  251194 */   // Label 4811: @251194
     /*  251194 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(251260), // Rule ID 5098 //
     /*  251199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  251202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  251210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  251213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  251216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  251238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  251241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251258 */     GIR_RootConstrainSelectedInstOperands,
     /*  251259 */     // GIR_Coverage, 5098,
     /*  251259 */     GIR_EraseRootFromParent_Done,
     /*  251260 */   // Label 4812: @251260
     /*  251260 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(251326), // Rule ID 5099 //
     /*  251265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  251268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  251276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  251279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  251282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251304 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  251304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  251307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251324 */     GIR_RootConstrainSelectedInstOperands,
     /*  251325 */     // GIR_Coverage, 5099,
     /*  251325 */     GIR_EraseRootFromParent_Done,
     /*  251326 */   // Label 4813: @251326
     /*  251326 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(251392), // Rule ID 5102 //
     /*  251331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  251334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  251342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  251345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  251348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251370 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  251370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  251373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251390 */     GIR_RootConstrainSelectedInstOperands,
     /*  251391 */     // GIR_Coverage, 5102,
     /*  251391 */     GIR_EraseRootFromParent_Done,
     /*  251392 */   // Label 4814: @251392
     /*  251392 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(251458), // Rule ID 5103 //
     /*  251397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  251400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  251408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  251411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  251414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  251436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  251439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251456 */     GIR_RootConstrainSelectedInstOperands,
     /*  251457 */     // GIR_Coverage, 5103,
     /*  251457 */     GIR_EraseRootFromParent_Done,
     /*  251458 */   // Label 4815: @251458
     /*  251458 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(251524), // Rule ID 5106 //
     /*  251463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  251466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  251474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  251477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  251480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  251502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  251505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251522 */     GIR_RootConstrainSelectedInstOperands,
     /*  251523 */     // GIR_Coverage, 5106,
     /*  251523 */     GIR_EraseRootFromParent_Done,
     /*  251524 */   // Label 4816: @251524
     /*  251524 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(251590), // Rule ID 5107 //
     /*  251529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  251532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  251540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  251543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  251546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251568 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  251568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  251571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251588 */     GIR_RootConstrainSelectedInstOperands,
     /*  251589 */     // GIR_Coverage, 5107,
     /*  251589 */     GIR_EraseRootFromParent_Done,
     /*  251590 */   // Label 4817: @251590
     /*  251590 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(251653), // Rule ID 5370 //
     /*  251595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  251609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  251612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251634 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  251637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251651 */     GIR_RootConstrainSelectedInstOperands,
     /*  251652 */     // GIR_Coverage, 5370,
     /*  251652 */     GIR_EraseRootFromParent_Done,
     /*  251653 */   // Label 4818: @251653
     /*  251653 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(251716), // Rule ID 5371 //
     /*  251658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  251672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  251675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251697 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  251700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251714 */     GIR_RootConstrainSelectedInstOperands,
     /*  251715 */     // GIR_Coverage, 5371,
     /*  251715 */     GIR_EraseRootFromParent_Done,
     /*  251716 */   // Label 4819: @251716
     /*  251716 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(251779), // Rule ID 5372 //
     /*  251721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  251735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  251738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251760 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  251763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251777 */     GIR_RootConstrainSelectedInstOperands,
     /*  251778 */     // GIR_Coverage, 5372,
     /*  251778 */     GIR_EraseRootFromParent_Done,
     /*  251779 */   // Label 4820: @251779
     /*  251779 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(251842), // Rule ID 5373 //
     /*  251784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  251798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  251801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251823 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  251826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251840 */     GIR_RootConstrainSelectedInstOperands,
     /*  251841 */     // GIR_Coverage, 5373,
     /*  251841 */     GIR_EraseRootFromParent_Done,
     /*  251842 */   // Label 4821: @251842
     /*  251842 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(251905), // Rule ID 5374 //
     /*  251847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  251861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  251864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251886 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  251886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  251889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251903 */     GIR_RootConstrainSelectedInstOperands,
     /*  251904 */     // GIR_Coverage, 5374,
     /*  251904 */     GIR_EraseRootFromParent_Done,
     /*  251905 */   // Label 4822: @251905
     /*  251905 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(251968), // Rule ID 5375 //
     /*  251910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  251924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  251927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251949 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  251952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251966 */     GIR_RootConstrainSelectedInstOperands,
     /*  251967 */     // GIR_Coverage, 5375,
     /*  251967 */     GIR_EraseRootFromParent_Done,
     /*  251968 */   // Label 4823: @251968
     /*  251968 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(252031), // Rule ID 5376 //
     /*  251973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  251987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  251990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252012 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  252015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252029 */     GIR_RootConstrainSelectedInstOperands,
     /*  252030 */     // GIR_Coverage, 5376,
     /*  252030 */     GIR_EraseRootFromParent_Done,
     /*  252031 */   // Label 4824: @252031
     /*  252031 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(252094), // Rule ID 5377 //
     /*  252036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  252050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  252053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252075 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  252078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252092 */     GIR_RootConstrainSelectedInstOperands,
     /*  252093 */     // GIR_Coverage, 5377,
     /*  252093 */     GIR_EraseRootFromParent_Done,
     /*  252094 */   // Label 4825: @252094
     /*  252094 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(252157), // Rule ID 5378 //
     /*  252099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  252113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  252116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252138 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  252141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252155 */     GIR_RootConstrainSelectedInstOperands,
     /*  252156 */     // GIR_Coverage, 5378,
     /*  252156 */     GIR_EraseRootFromParent_Done,
     /*  252157 */   // Label 4826: @252157
     /*  252157 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(252220), // Rule ID 5379 //
     /*  252162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  252176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  252179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252201 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  252204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252218 */     GIR_RootConstrainSelectedInstOperands,
     /*  252219 */     // GIR_Coverage, 5379,
     /*  252219 */     GIR_EraseRootFromParent_Done,
     /*  252220 */   // Label 4827: @252220
     /*  252220 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(252283), // Rule ID 5380 //
     /*  252225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  252239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  252242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252281 */     GIR_RootConstrainSelectedInstOperands,
     /*  252282 */     // GIR_Coverage, 5380,
     /*  252282 */     GIR_EraseRootFromParent_Done,
     /*  252283 */   // Label 4828: @252283
     /*  252283 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(252346), // Rule ID 5381 //
     /*  252288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  252302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  252305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252327 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252344 */     GIR_RootConstrainSelectedInstOperands,
     /*  252345 */     // GIR_Coverage, 5381,
     /*  252345 */     GIR_EraseRootFromParent_Done,
     /*  252346 */   // Label 4829: @252346
     /*  252346 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(252409), // Rule ID 5382 //
     /*  252351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  252365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  252368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252390 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252407 */     GIR_RootConstrainSelectedInstOperands,
     /*  252408 */     // GIR_Coverage, 5382,
     /*  252408 */     GIR_EraseRootFromParent_Done,
     /*  252409 */   // Label 4830: @252409
     /*  252409 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(252472), // Rule ID 5383 //
     /*  252414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  252428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  252431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252453 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252470 */     GIR_RootConstrainSelectedInstOperands,
     /*  252471 */     // GIR_Coverage, 5383,
     /*  252471 */     GIR_EraseRootFromParent_Done,
     /*  252472 */   // Label 4831: @252472
     /*  252472 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(252535), // Rule ID 5384 //
     /*  252477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  252491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  252494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252516 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252533 */     GIR_RootConstrainSelectedInstOperands,
     /*  252534 */     // GIR_Coverage, 5384,
     /*  252534 */     GIR_EraseRootFromParent_Done,
     /*  252535 */   // Label 4832: @252535
     /*  252535 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(252598), // Rule ID 5385 //
     /*  252540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  252554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  252557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252579 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252596 */     GIR_RootConstrainSelectedInstOperands,
     /*  252597 */     // GIR_Coverage, 5385,
     /*  252597 */     GIR_EraseRootFromParent_Done,
     /*  252598 */   // Label 4833: @252598
     /*  252598 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(252661), // Rule ID 5386 //
     /*  252603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  252606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  252617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  252620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252642 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  252642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252659 */     GIR_RootConstrainSelectedInstOperands,
     /*  252660 */     // GIR_Coverage, 5386,
     /*  252660 */     GIR_EraseRootFromParent_Done,
     /*  252661 */   // Label 4834: @252661
     /*  252661 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(252724), // Rule ID 5387 //
     /*  252666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  252669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  252680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  252683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252705 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  252705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252722 */     GIR_RootConstrainSelectedInstOperands,
     /*  252723 */     // GIR_Coverage, 5387,
     /*  252723 */     GIR_EraseRootFromParent_Done,
     /*  252724 */   // Label 4835: @252724
     /*  252724 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(252787), // Rule ID 5388 //
     /*  252729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  252743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  252746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252768 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  252771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252785 */     GIR_RootConstrainSelectedInstOperands,
     /*  252786 */     // GIR_Coverage, 5388,
     /*  252786 */     GIR_EraseRootFromParent_Done,
     /*  252787 */   // Label 4836: @252787
     /*  252787 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(252850), // Rule ID 5389 //
     /*  252792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  252806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  252809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252831 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  252834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252848 */     GIR_RootConstrainSelectedInstOperands,
     /*  252849 */     // GIR_Coverage, 5389,
     /*  252849 */     GIR_EraseRootFromParent_Done,
     /*  252850 */   // Label 4837: @252850
     /*  252850 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(252913), // Rule ID 5390 //
     /*  252855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  252869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  252872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252894 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  252897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252911 */     GIR_RootConstrainSelectedInstOperands,
     /*  252912 */     // GIR_Coverage, 5390,
     /*  252912 */     GIR_EraseRootFromParent_Done,
     /*  252913 */   // Label 4838: @252913
     /*  252913 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(252976), // Rule ID 5391 //
     /*  252918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  252932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  252935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252957 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  252960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252974 */     GIR_RootConstrainSelectedInstOperands,
     /*  252975 */     // GIR_Coverage, 5391,
     /*  252975 */     GIR_EraseRootFromParent_Done,
     /*  252976 */   // Label 4839: @252976
     /*  252976 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(253039), // Rule ID 5392 //
     /*  252981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  252992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  252995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  252998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253020 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  253023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253037 */     GIR_RootConstrainSelectedInstOperands,
     /*  253038 */     // GIR_Coverage, 5392,
     /*  253038 */     GIR_EraseRootFromParent_Done,
     /*  253039 */   // Label 4840: @253039
     /*  253039 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(253102), // Rule ID 5393 //
     /*  253044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  253055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  253058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  253061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253083 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  253086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253100 */     GIR_RootConstrainSelectedInstOperands,
     /*  253101 */     // GIR_Coverage, 5393,
     /*  253101 */     GIR_EraseRootFromParent_Done,
     /*  253102 */   // Label 4841: @253102
     /*  253102 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(253165), // Rule ID 5394 //
     /*  253107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  253121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  253124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253146 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  253146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  253149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253163 */     GIR_RootConstrainSelectedInstOperands,
     /*  253164 */     // GIR_Coverage, 5394,
     /*  253164 */     GIR_EraseRootFromParent_Done,
     /*  253165 */   // Label 4842: @253165
     /*  253165 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(253228), // Rule ID 5395 //
     /*  253170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  253184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  253187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253209 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  253209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  253212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253226 */     GIR_RootConstrainSelectedInstOperands,
     /*  253227 */     // GIR_Coverage, 5395,
     /*  253227 */     GIR_EraseRootFromParent_Done,
     /*  253228 */   // Label 4843: @253228
     /*  253228 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(253291), // Rule ID 5396 //
     /*  253233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  253247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  253250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253272 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  253272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  253275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253289 */     GIR_RootConstrainSelectedInstOperands,
     /*  253290 */     // GIR_Coverage, 5396,
     /*  253290 */     GIR_EraseRootFromParent_Done,
     /*  253291 */   // Label 4844: @253291
     /*  253291 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(253354), // Rule ID 5397 //
     /*  253296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  253310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  253313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253335 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  253335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  253338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253352 */     GIR_RootConstrainSelectedInstOperands,
     /*  253353 */     // GIR_Coverage, 5397,
     /*  253353 */     GIR_EraseRootFromParent_Done,
     /*  253354 */   // Label 4845: @253354
     /*  253354 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(253417), // Rule ID 5398 //
     /*  253359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  253370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  253373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  253376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253398 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  253398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  253401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253415 */     GIR_RootConstrainSelectedInstOperands,
     /*  253416 */     // GIR_Coverage, 5398,
     /*  253416 */     GIR_EraseRootFromParent_Done,
     /*  253417 */   // Label 4846: @253417
     /*  253417 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(253480), // Rule ID 5399 //
     /*  253422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  253433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  253436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  253439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253461 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  253461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  253464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253478 */     GIR_RootConstrainSelectedInstOperands,
     /*  253479 */     // GIR_Coverage, 5399,
     /*  253479 */     GIR_EraseRootFromParent_Done,
     /*  253480 */   // Label 4847: @253480
     /*  253480 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(253543), // Rule ID 5400 //
     /*  253485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  253499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  253502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253524 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  253527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253541 */     GIR_RootConstrainSelectedInstOperands,
     /*  253542 */     // GIR_Coverage, 5400,
     /*  253542 */     GIR_EraseRootFromParent_Done,
     /*  253543 */   // Label 4848: @253543
     /*  253543 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(253606), // Rule ID 5401 //
     /*  253548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  253562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  253565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253587 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  253590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253604 */     GIR_RootConstrainSelectedInstOperands,
     /*  253605 */     // GIR_Coverage, 5401,
     /*  253605 */     GIR_EraseRootFromParent_Done,
     /*  253606 */   // Label 4849: @253606
     /*  253606 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(253669), // Rule ID 5402 //
     /*  253611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  253625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  253628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253650 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  253653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253667 */     GIR_RootConstrainSelectedInstOperands,
     /*  253668 */     // GIR_Coverage, 5402,
     /*  253668 */     GIR_EraseRootFromParent_Done,
     /*  253669 */   // Label 4850: @253669
     /*  253669 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(253732), // Rule ID 5403 //
     /*  253674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  253688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  253691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253713 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  253716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253730 */     GIR_RootConstrainSelectedInstOperands,
     /*  253731 */     // GIR_Coverage, 5403,
     /*  253731 */     GIR_EraseRootFromParent_Done,
     /*  253732 */   // Label 4851: @253732
     /*  253732 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(253795), // Rule ID 5404 //
     /*  253737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  253751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  253754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253776 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  253779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253793 */     GIR_RootConstrainSelectedInstOperands,
     /*  253794 */     // GIR_Coverage, 5404,
     /*  253794 */     GIR_EraseRootFromParent_Done,
     /*  253795 */   // Label 4852: @253795
     /*  253795 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(253858), // Rule ID 5405 //
     /*  253800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  253814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  253817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253839 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  253842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253856 */     GIR_RootConstrainSelectedInstOperands,
     /*  253857 */     // GIR_Coverage, 5405,
     /*  253857 */     GIR_EraseRootFromParent_Done,
     /*  253858 */   // Label 4853: @253858
     /*  253858 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(253921), // Rule ID 5406 //
     /*  253863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  253866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  253877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  253880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253902 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  253902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  253905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253919 */     GIR_RootConstrainSelectedInstOperands,
     /*  253920 */     // GIR_Coverage, 5406,
     /*  253920 */     GIR_EraseRootFromParent_Done,
     /*  253921 */   // Label 4854: @253921
     /*  253921 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(253984), // Rule ID 5407 //
     /*  253926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  253929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  253940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  253943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253965 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  253965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  253968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253982 */     GIR_RootConstrainSelectedInstOperands,
     /*  253983 */     // GIR_Coverage, 5407,
     /*  253983 */     GIR_EraseRootFromParent_Done,
     /*  253984 */   // Label 4855: @253984
     /*  253984 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(254047), // Rule ID 5408 //
     /*  253989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  253992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  254003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  254006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254028 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  254028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  254031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254045 */     GIR_RootConstrainSelectedInstOperands,
     /*  254046 */     // GIR_Coverage, 5408,
     /*  254046 */     GIR_EraseRootFromParent_Done,
     /*  254047 */   // Label 4856: @254047
     /*  254047 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(254110), // Rule ID 5409 //
     /*  254052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  254055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  254066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  254069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254091 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  254091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  254094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254108 */     GIR_RootConstrainSelectedInstOperands,
     /*  254109 */     // GIR_Coverage, 5409,
     /*  254109 */     GIR_EraseRootFromParent_Done,
     /*  254110 */   // Label 4857: @254110
     /*  254110 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(254173), // Rule ID 5410 //
     /*  254115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  254118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  254129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  254132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254154 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  254154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  254157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254171 */     GIR_RootConstrainSelectedInstOperands,
     /*  254172 */     // GIR_Coverage, 5410,
     /*  254172 */     GIR_EraseRootFromParent_Done,
     /*  254173 */   // Label 4858: @254173
     /*  254173 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(254236), // Rule ID 5411 //
     /*  254178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  254181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  254192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  254195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254217 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  254217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  254220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254234 */     GIR_RootConstrainSelectedInstOperands,
     /*  254235 */     // GIR_Coverage, 5411,
     /*  254235 */     GIR_EraseRootFromParent_Done,
     /*  254236 */   // Label 4859: @254236
     /*  254236 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(254299), // Rule ID 5412 //
     /*  254241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  254255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  254258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  254283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254297 */     GIR_RootConstrainSelectedInstOperands,
     /*  254298 */     // GIR_Coverage, 5412,
     /*  254298 */     GIR_EraseRootFromParent_Done,
     /*  254299 */   // Label 4860: @254299
     /*  254299 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(254362), // Rule ID 5413 //
     /*  254304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  254318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  254321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254343 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  254346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254360 */     GIR_RootConstrainSelectedInstOperands,
     /*  254361 */     // GIR_Coverage, 5413,
     /*  254361 */     GIR_EraseRootFromParent_Done,
     /*  254362 */   // Label 4861: @254362
     /*  254362 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(254425), // Rule ID 5414 //
     /*  254367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  254381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  254384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254406 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  254409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254423 */     GIR_RootConstrainSelectedInstOperands,
     /*  254424 */     // GIR_Coverage, 5414,
     /*  254424 */     GIR_EraseRootFromParent_Done,
     /*  254425 */   // Label 4862: @254425
     /*  254425 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(254488), // Rule ID 5415 //
     /*  254430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  254444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  254447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254469 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  254472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254486 */     GIR_RootConstrainSelectedInstOperands,
     /*  254487 */     // GIR_Coverage, 5415,
     /*  254487 */     GIR_EraseRootFromParent_Done,
     /*  254488 */   // Label 4863: @254488
     /*  254488 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(254551), // Rule ID 5416 //
     /*  254493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  254507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  254510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254532 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  254535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254549 */     GIR_RootConstrainSelectedInstOperands,
     /*  254550 */     // GIR_Coverage, 5416,
     /*  254550 */     GIR_EraseRootFromParent_Done,
     /*  254551 */   // Label 4864: @254551
     /*  254551 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(254614), // Rule ID 5417 //
     /*  254556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  254570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  254573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254595 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  254598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254612 */     GIR_RootConstrainSelectedInstOperands,
     /*  254613 */     // GIR_Coverage, 5417,
     /*  254613 */     GIR_EraseRootFromParent_Done,
     /*  254614 */   // Label 4865: @254614
     /*  254614 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(254677), // Rule ID 5418 //
     /*  254619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  254633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  254636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254658 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  254661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254675 */     GIR_RootConstrainSelectedInstOperands,
     /*  254676 */     // GIR_Coverage, 5418,
     /*  254676 */     GIR_EraseRootFromParent_Done,
     /*  254677 */   // Label 4866: @254677
     /*  254677 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(254740), // Rule ID 5419 //
     /*  254682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  254696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  254699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254721 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  254724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254738 */     GIR_RootConstrainSelectedInstOperands,
     /*  254739 */     // GIR_Coverage, 5419,
     /*  254739 */     GIR_EraseRootFromParent_Done,
     /*  254740 */   // Label 4867: @254740
     /*  254740 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(254803), // Rule ID 5420 //
     /*  254745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  254759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  254762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254784 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  254787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254801 */     GIR_RootConstrainSelectedInstOperands,
     /*  254802 */     // GIR_Coverage, 5420,
     /*  254802 */     GIR_EraseRootFromParent_Done,
     /*  254803 */   // Label 4868: @254803
     /*  254803 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(254866), // Rule ID 5421 //
     /*  254808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  254822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  254825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254847 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  254850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254864 */     GIR_RootConstrainSelectedInstOperands,
     /*  254865 */     // GIR_Coverage, 5421,
     /*  254865 */     GIR_EraseRootFromParent_Done,
     /*  254866 */   // Label 4869: @254866
     /*  254866 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(254929), // Rule ID 5422 //
     /*  254871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  254885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  254888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254910 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  254910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  254913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254927 */     GIR_RootConstrainSelectedInstOperands,
     /*  254928 */     // GIR_Coverage, 5422,
     /*  254928 */     GIR_EraseRootFromParent_Done,
     /*  254929 */   // Label 4870: @254929
     /*  254929 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(254992), // Rule ID 5423 //
     /*  254934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  254948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  254951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254973 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  254973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  254976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254990 */     GIR_RootConstrainSelectedInstOperands,
     /*  254991 */     // GIR_Coverage, 5423,
     /*  254991 */     GIR_EraseRootFromParent_Done,
     /*  254992 */   // Label 4871: @254992
     /*  254992 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(255055), // Rule ID 5424 //
     /*  254997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  255011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255036 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255053 */     GIR_RootConstrainSelectedInstOperands,
     /*  255054 */     // GIR_Coverage, 5424,
     /*  255054 */     GIR_EraseRootFromParent_Done,
     /*  255055 */   // Label 4872: @255055
     /*  255055 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(255118), // Rule ID 5425 //
     /*  255060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  255074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255099 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255116 */     GIR_RootConstrainSelectedInstOperands,
     /*  255117 */     // GIR_Coverage, 5425,
     /*  255117 */     GIR_EraseRootFromParent_Done,
     /*  255118 */   // Label 4873: @255118
     /*  255118 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(255181), // Rule ID 5426 //
     /*  255123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  255137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255162 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255179 */     GIR_RootConstrainSelectedInstOperands,
     /*  255180 */     // GIR_Coverage, 5426,
     /*  255180 */     GIR_EraseRootFromParent_Done,
     /*  255181 */   // Label 4874: @255181
     /*  255181 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(255244), // Rule ID 5427 //
     /*  255186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  255200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255225 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255242 */     GIR_RootConstrainSelectedInstOperands,
     /*  255243 */     // GIR_Coverage, 5427,
     /*  255243 */     GIR_EraseRootFromParent_Done,
     /*  255244 */   // Label 4875: @255244
     /*  255244 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(255307), // Rule ID 5428 //
     /*  255249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  255260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  255263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255288 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255305 */     GIR_RootConstrainSelectedInstOperands,
     /*  255306 */     // GIR_Coverage, 5428,
     /*  255306 */     GIR_EraseRootFromParent_Done,
     /*  255307 */   // Label 4876: @255307
     /*  255307 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(255370), // Rule ID 5429 //
     /*  255312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  255323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  255326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255351 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  255351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255368 */     GIR_RootConstrainSelectedInstOperands,
     /*  255369 */     // GIR_Coverage, 5429,
     /*  255369 */     GIR_EraseRootFromParent_Done,
     /*  255370 */   // Label 4877: @255370
     /*  255370 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(255433), // Rule ID 5430 //
     /*  255375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  255378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  255386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  255389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255414 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  255414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255431 */     GIR_RootConstrainSelectedInstOperands,
     /*  255432 */     // GIR_Coverage, 5430,
     /*  255432 */     GIR_EraseRootFromParent_Done,
     /*  255433 */   // Label 4878: @255433
     /*  255433 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(255496), // Rule ID 5431 //
     /*  255438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  255441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  255449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  255452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255477 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  255477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255494 */     GIR_RootConstrainSelectedInstOperands,
     /*  255495 */     // GIR_Coverage, 5431,
     /*  255495 */     GIR_EraseRootFromParent_Done,
     /*  255496 */   // Label 4879: @255496
     /*  255496 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(255559), // Rule ID 5432 //
     /*  255501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  255515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255540 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  255543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255557 */     GIR_RootConstrainSelectedInstOperands,
     /*  255558 */     // GIR_Coverage, 5432,
     /*  255558 */     GIR_EraseRootFromParent_Done,
     /*  255559 */   // Label 4880: @255559
     /*  255559 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(255622), // Rule ID 5433 //
     /*  255564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  255578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255603 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  255606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255620 */     GIR_RootConstrainSelectedInstOperands,
     /*  255621 */     // GIR_Coverage, 5433,
     /*  255621 */     GIR_EraseRootFromParent_Done,
     /*  255622 */   // Label 4881: @255622
     /*  255622 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(255685), // Rule ID 5434 //
     /*  255627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  255641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255666 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  255669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255683 */     GIR_RootConstrainSelectedInstOperands,
     /*  255684 */     // GIR_Coverage, 5434,
     /*  255684 */     GIR_EraseRootFromParent_Done,
     /*  255685 */   // Label 4882: @255685
     /*  255685 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(255748), // Rule ID 5435 //
     /*  255690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  255704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255729 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  255732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255746 */     GIR_RootConstrainSelectedInstOperands,
     /*  255747 */     // GIR_Coverage, 5435,
     /*  255747 */     GIR_EraseRootFromParent_Done,
     /*  255748 */   // Label 4883: @255748
     /*  255748 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(255811), // Rule ID 5436 //
     /*  255753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  255764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  255767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255792 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  255795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255809 */     GIR_RootConstrainSelectedInstOperands,
     /*  255810 */     // GIR_Coverage, 5436,
     /*  255810 */     GIR_EraseRootFromParent_Done,
     /*  255811 */   // Label 4884: @255811
     /*  255811 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(255874), // Rule ID 5437 //
     /*  255816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  255827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  255830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255855 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  255858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255872 */     GIR_RootConstrainSelectedInstOperands,
     /*  255873 */     // GIR_Coverage, 5437,
     /*  255873 */     GIR_EraseRootFromParent_Done,
     /*  255874 */   // Label 4885: @255874
     /*  255874 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(255937), // Rule ID 5438 //
     /*  255879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  255893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255918 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  255921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255935 */     GIR_RootConstrainSelectedInstOperands,
     /*  255936 */     // GIR_Coverage, 5438,
     /*  255936 */     GIR_EraseRootFromParent_Done,
     /*  255937 */   // Label 4886: @255937
     /*  255937 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(256000), // Rule ID 5439 //
     /*  255942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  255956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255981 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  255984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255998 */     GIR_RootConstrainSelectedInstOperands,
     /*  255999 */     // GIR_Coverage, 5439,
     /*  255999 */     GIR_EraseRootFromParent_Done,
     /*  256000 */   // Label 4887: @256000
     /*  256000 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(256063), // Rule ID 5440 //
     /*  256005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  256016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  256019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256044 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  256047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256061 */     GIR_RootConstrainSelectedInstOperands,
     /*  256062 */     // GIR_Coverage, 5440,
     /*  256062 */     GIR_EraseRootFromParent_Done,
     /*  256063 */   // Label 4888: @256063
     /*  256063 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(256126), // Rule ID 5441 //
     /*  256068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  256079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  256082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256107 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  256110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256124 */     GIR_RootConstrainSelectedInstOperands,
     /*  256125 */     // GIR_Coverage, 5441,
     /*  256125 */     GIR_EraseRootFromParent_Done,
     /*  256126 */   // Label 4889: @256126
     /*  256126 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(256189), // Rule ID 5442 //
     /*  256131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  256142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  256145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256170 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  256173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256187 */     GIR_RootConstrainSelectedInstOperands,
     /*  256188 */     // GIR_Coverage, 5442,
     /*  256188 */     GIR_EraseRootFromParent_Done,
     /*  256189 */   // Label 4890: @256189
     /*  256189 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(256252), // Rule ID 5443 //
     /*  256194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  256205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  256208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256233 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  256236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256250 */     GIR_RootConstrainSelectedInstOperands,
     /*  256251 */     // GIR_Coverage, 5443,
     /*  256251 */     GIR_EraseRootFromParent_Done,
     /*  256252 */   // Label 4891: @256252
     /*  256252 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(256315), // Rule ID 5444 //
     /*  256257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  256271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256296 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  256296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  256299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256313 */     GIR_RootConstrainSelectedInstOperands,
     /*  256314 */     // GIR_Coverage, 5444,
     /*  256314 */     GIR_EraseRootFromParent_Done,
     /*  256315 */   // Label 4892: @256315
     /*  256315 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(256378), // Rule ID 5445 //
     /*  256320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  256334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256359 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  256359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  256362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256376 */     GIR_RootConstrainSelectedInstOperands,
     /*  256377 */     // GIR_Coverage, 5445,
     /*  256377 */     GIR_EraseRootFromParent_Done,
     /*  256378 */   // Label 4893: @256378
     /*  256378 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(256441), // Rule ID 5446 //
     /*  256383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  256397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256422 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  256422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  256425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256439 */     GIR_RootConstrainSelectedInstOperands,
     /*  256440 */     // GIR_Coverage, 5446,
     /*  256440 */     GIR_EraseRootFromParent_Done,
     /*  256441 */   // Label 4894: @256441
     /*  256441 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(256504), // Rule ID 5447 //
     /*  256446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  256460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256485 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  256485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  256488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256502 */     GIR_RootConstrainSelectedInstOperands,
     /*  256503 */     // GIR_Coverage, 5447,
     /*  256503 */     GIR_EraseRootFromParent_Done,
     /*  256504 */   // Label 4895: @256504
     /*  256504 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(256567), // Rule ID 5448 //
     /*  256509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  256520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  256523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256548 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  256548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  256551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256565 */     GIR_RootConstrainSelectedInstOperands,
     /*  256566 */     // GIR_Coverage, 5448,
     /*  256566 */     GIR_EraseRootFromParent_Done,
     /*  256567 */   // Label 4896: @256567
     /*  256567 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(256630), // Rule ID 5449 //
     /*  256572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  256583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  256586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256611 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  256611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  256614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256628 */     GIR_RootConstrainSelectedInstOperands,
     /*  256629 */     // GIR_Coverage, 5449,
     /*  256629 */     GIR_EraseRootFromParent_Done,
     /*  256630 */   // Label 4897: @256630
     /*  256630 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(256693), // Rule ID 5450 //
     /*  256635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  256638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  256649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256674 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  256674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  256677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256691 */     GIR_RootConstrainSelectedInstOperands,
     /*  256692 */     // GIR_Coverage, 5450,
     /*  256692 */     GIR_EraseRootFromParent_Done,
     /*  256693 */   // Label 4898: @256693
     /*  256693 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(256756), // Rule ID 5451 //
     /*  256698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  256701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  256712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256737 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  256737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  256740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256754 */     GIR_RootConstrainSelectedInstOperands,
     /*  256755 */     // GIR_Coverage, 5451,
     /*  256755 */     GIR_EraseRootFromParent_Done,
     /*  256756 */   // Label 4899: @256756
     /*  256756 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(256819), // Rule ID 5452 //
     /*  256761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  256764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  256775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256800 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  256800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  256803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256817 */     GIR_RootConstrainSelectedInstOperands,
     /*  256818 */     // GIR_Coverage, 5452,
     /*  256818 */     GIR_EraseRootFromParent_Done,
     /*  256819 */   // Label 4900: @256819
     /*  256819 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(256882), // Rule ID 5453 //
     /*  256824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  256827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  256838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256863 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  256863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  256866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256880 */     GIR_RootConstrainSelectedInstOperands,
     /*  256881 */     // GIR_Coverage, 5453,
     /*  256881 */     GIR_EraseRootFromParent_Done,
     /*  256882 */   // Label 4901: @256882
     /*  256882 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(256945), // Rule ID 5454 //
     /*  256887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  256890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  256901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256926 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  256926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  256929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256943 */     GIR_RootConstrainSelectedInstOperands,
     /*  256944 */     // GIR_Coverage, 5454,
     /*  256944 */     GIR_EraseRootFromParent_Done,
     /*  256945 */   // Label 4902: @256945
     /*  256945 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(257008), // Rule ID 5455 //
     /*  256950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  256953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  256964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256989 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  256989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  256992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  257006 */     GIR_RootConstrainSelectedInstOperands,
     /*  257007 */     // GIR_Coverage, 5455,
     /*  257007 */     GIR_EraseRootFromParent_Done,
     /*  257008 */   // Label 4903: @257008
     /*  257008 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(257071), // Rule ID 5676 //
     /*  257013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  257027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  257030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257052 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  257055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257069 */     GIR_RootConstrainSelectedInstOperands,
     /*  257070 */     // GIR_Coverage, 5676,
     /*  257070 */     GIR_EraseRootFromParent_Done,
     /*  257071 */   // Label 4904: @257071
     /*  257071 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(257134), // Rule ID 5677 //
     /*  257076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  257090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  257093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257115 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  257118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257132 */     GIR_RootConstrainSelectedInstOperands,
     /*  257133 */     // GIR_Coverage, 5677,
     /*  257133 */     GIR_EraseRootFromParent_Done,
     /*  257134 */   // Label 4905: @257134
     /*  257134 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(257197), // Rule ID 5678 //
     /*  257139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  257153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  257156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257178 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  257181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257195 */     GIR_RootConstrainSelectedInstOperands,
     /*  257196 */     // GIR_Coverage, 5678,
     /*  257196 */     GIR_EraseRootFromParent_Done,
     /*  257197 */   // Label 4906: @257197
     /*  257197 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(257260), // Rule ID 5679 //
     /*  257202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  257216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  257219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257241 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  257244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257258 */     GIR_RootConstrainSelectedInstOperands,
     /*  257259 */     // GIR_Coverage, 5679,
     /*  257259 */     GIR_EraseRootFromParent_Done,
     /*  257260 */   // Label 4907: @257260
     /*  257260 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(257323), // Rule ID 5680 //
     /*  257265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  257279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  257282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257304 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  257307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257321 */     GIR_RootConstrainSelectedInstOperands,
     /*  257322 */     // GIR_Coverage, 5680,
     /*  257322 */     GIR_EraseRootFromParent_Done,
     /*  257323 */   // Label 4908: @257323
     /*  257323 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(257386), // Rule ID 5681 //
     /*  257328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  257342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  257345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257367 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  257370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257384 */     GIR_RootConstrainSelectedInstOperands,
     /*  257385 */     // GIR_Coverage, 5681,
     /*  257385 */     GIR_EraseRootFromParent_Done,
     /*  257386 */   // Label 4909: @257386
     /*  257386 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(257449), // Rule ID 5682 //
     /*  257391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  257405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  257408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257430 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  257433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257447 */     GIR_RootConstrainSelectedInstOperands,
     /*  257448 */     // GIR_Coverage, 5682,
     /*  257448 */     GIR_EraseRootFromParent_Done,
     /*  257449 */   // Label 4910: @257449
     /*  257449 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(257512), // Rule ID 5683 //
     /*  257454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  257468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  257471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257493 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  257496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257510 */     GIR_RootConstrainSelectedInstOperands,
     /*  257511 */     // GIR_Coverage, 5683,
     /*  257511 */     GIR_EraseRootFromParent_Done,
     /*  257512 */   // Label 4911: @257512
     /*  257512 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(257575), // Rule ID 5684 //
     /*  257517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  257531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  257534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257556 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  257559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257573 */     GIR_RootConstrainSelectedInstOperands,
     /*  257574 */     // GIR_Coverage, 5684,
     /*  257574 */     GIR_EraseRootFromParent_Done,
     /*  257575 */   // Label 4912: @257575
     /*  257575 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(257638), // Rule ID 5685 //
     /*  257580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  257594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  257597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257619 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  257622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257636 */     GIR_RootConstrainSelectedInstOperands,
     /*  257637 */     // GIR_Coverage, 5685,
     /*  257637 */     GIR_EraseRootFromParent_Done,
     /*  257638 */   // Label 4913: @257638
     /*  257638 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(257701), // Rule ID 5686 //
     /*  257643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  257657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  257660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257682 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  257682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  257685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257699 */     GIR_RootConstrainSelectedInstOperands,
     /*  257700 */     // GIR_Coverage, 5686,
     /*  257700 */     GIR_EraseRootFromParent_Done,
     /*  257701 */   // Label 4914: @257701
     /*  257701 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(257764), // Rule ID 5687 //
     /*  257706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  257720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  257723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257745 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  257745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  257748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257762 */     GIR_RootConstrainSelectedInstOperands,
     /*  257763 */     // GIR_Coverage, 5687,
     /*  257763 */     GIR_EraseRootFromParent_Done,
     /*  257764 */   // Label 4915: @257764
     /*  257764 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(257827), // Rule ID 5688 //
     /*  257769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  257783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  257786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257808 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  257811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257825 */     GIR_RootConstrainSelectedInstOperands,
     /*  257826 */     // GIR_Coverage, 5688,
     /*  257826 */     GIR_EraseRootFromParent_Done,
     /*  257827 */   // Label 4916: @257827
     /*  257827 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(257890), // Rule ID 5689 //
     /*  257832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  257846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  257849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257871 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  257874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257888 */     GIR_RootConstrainSelectedInstOperands,
     /*  257889 */     // GIR_Coverage, 5689,
     /*  257889 */     GIR_EraseRootFromParent_Done,
     /*  257890 */   // Label 4917: @257890
     /*  257890 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(257953), // Rule ID 5690 //
     /*  257895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  257909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  257912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257934 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  257937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257951 */     GIR_RootConstrainSelectedInstOperands,
     /*  257952 */     // GIR_Coverage, 5690,
     /*  257952 */     GIR_EraseRootFromParent_Done,
     /*  257953 */   // Label 4918: @257953
     /*  257953 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(258016), // Rule ID 5691 //
     /*  257958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  257972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  257975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257997 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  258000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258014 */     GIR_RootConstrainSelectedInstOperands,
     /*  258015 */     // GIR_Coverage, 5691,
     /*  258015 */     GIR_EraseRootFromParent_Done,
     /*  258016 */   // Label 4919: @258016
     /*  258016 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(258079), // Rule ID 5692 //
     /*  258021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  258035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  258038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258060 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  258063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258077 */     GIR_RootConstrainSelectedInstOperands,
     /*  258078 */     // GIR_Coverage, 5692,
     /*  258078 */     GIR_EraseRootFromParent_Done,
     /*  258079 */   // Label 4920: @258079
     /*  258079 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(258142), // Rule ID 5693 //
     /*  258084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  258098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  258101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258123 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  258126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258140 */     GIR_RootConstrainSelectedInstOperands,
     /*  258141 */     // GIR_Coverage, 5693,
     /*  258141 */     GIR_EraseRootFromParent_Done,
     /*  258142 */   // Label 4921: @258142
     /*  258142 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(258205), // Rule ID 5694 //
     /*  258147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  258150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  258158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  258161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  258164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258186 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  258186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  258189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258203 */     GIR_RootConstrainSelectedInstOperands,
     /*  258204 */     // GIR_Coverage, 5694,
     /*  258204 */     GIR_EraseRootFromParent_Done,
     /*  258205 */   // Label 4922: @258205
     /*  258205 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(258268), // Rule ID 5695 //
     /*  258210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  258213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  258221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  258224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  258227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258249 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  258249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  258252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258266 */     GIR_RootConstrainSelectedInstOperands,
     /*  258267 */     // GIR_Coverage, 5695,
     /*  258267 */     GIR_EraseRootFromParent_Done,
     /*  258268 */   // Label 4923: @258268
     /*  258268 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(258331), // Rule ID 5696 //
     /*  258273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  258287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  258290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258312 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  258312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  258315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258329 */     GIR_RootConstrainSelectedInstOperands,
     /*  258330 */     // GIR_Coverage, 5696,
     /*  258330 */     GIR_EraseRootFromParent_Done,
     /*  258331 */   // Label 4924: @258331
     /*  258331 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(258394), // Rule ID 5697 //
     /*  258336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  258350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  258353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258375 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  258378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258392 */     GIR_RootConstrainSelectedInstOperands,
     /*  258393 */     // GIR_Coverage, 5697,
     /*  258393 */     GIR_EraseRootFromParent_Done,
     /*  258394 */   // Label 4925: @258394
     /*  258394 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(258457), // Rule ID 5698 //
     /*  258399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  258410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  258413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  258416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258438 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  258438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  258441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258455 */     GIR_RootConstrainSelectedInstOperands,
     /*  258456 */     // GIR_Coverage, 5698,
     /*  258456 */     GIR_EraseRootFromParent_Done,
     /*  258457 */   // Label 4926: @258457
     /*  258457 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(258520), // Rule ID 5699 //
     /*  258462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  258473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  258476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  258479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258501 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  258504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258518 */     GIR_RootConstrainSelectedInstOperands,
     /*  258519 */     // GIR_Coverage, 5699,
     /*  258519 */     GIR_EraseRootFromParent_Done,
     /*  258520 */   // Label 4927: @258520
     /*  258520 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(258583), // Rule ID 5700 //
     /*  258525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  258536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  258539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  258542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258564 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  258564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  258567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258581 */     GIR_RootConstrainSelectedInstOperands,
     /*  258582 */     // GIR_Coverage, 5700,
     /*  258582 */     GIR_EraseRootFromParent_Done,
     /*  258583 */   // Label 4928: @258583
     /*  258583 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(258646), // Rule ID 5701 //
     /*  258588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  258599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  258602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  258605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258627 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  258630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258644 */     GIR_RootConstrainSelectedInstOperands,
     /*  258645 */     // GIR_Coverage, 5701,
     /*  258645 */     GIR_EraseRootFromParent_Done,
     /*  258646 */   // Label 4929: @258646
     /*  258646 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(258709), // Rule ID 5702 //
     /*  258651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  258665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  258668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258690 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  258693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258707 */     GIR_RootConstrainSelectedInstOperands,
     /*  258708 */     // GIR_Coverage, 5702,
     /*  258708 */     GIR_EraseRootFromParent_Done,
     /*  258709 */   // Label 4930: @258709
     /*  258709 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(258772), // Rule ID 5703 //
     /*  258714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  258728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  258731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258753 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  258753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  258756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258770 */     GIR_RootConstrainSelectedInstOperands,
     /*  258771 */     // GIR_Coverage, 5703,
     /*  258771 */     GIR_EraseRootFromParent_Done,
     /*  258772 */   // Label 4931: @258772
     /*  258772 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(258835), // Rule ID 5704 //
     /*  258777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  258791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  258794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258816 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  258819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258833 */     GIR_RootConstrainSelectedInstOperands,
     /*  258834 */     // GIR_Coverage, 5704,
     /*  258834 */     GIR_EraseRootFromParent_Done,
     /*  258835 */   // Label 4932: @258835
     /*  258835 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(258898), // Rule ID 5705 //
     /*  258840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  258854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  258857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258879 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  258879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  258882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258896 */     GIR_RootConstrainSelectedInstOperands,
     /*  258897 */     // GIR_Coverage, 5705,
     /*  258897 */     GIR_EraseRootFromParent_Done,
     /*  258898 */   // Label 4933: @258898
     /*  258898 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(258961), // Rule ID 5706 //
     /*  258903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  258914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  258917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  258920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258942 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  258945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258959 */     GIR_RootConstrainSelectedInstOperands,
     /*  258960 */     // GIR_Coverage, 5706,
     /*  258960 */     GIR_EraseRootFromParent_Done,
     /*  258961 */   // Label 4934: @258961
     /*  258961 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(259024), // Rule ID 5707 //
     /*  258966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  258977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  258980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  258983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259005 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  259008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259022 */     GIR_RootConstrainSelectedInstOperands,
     /*  259023 */     // GIR_Coverage, 5707,
     /*  259023 */     GIR_EraseRootFromParent_Done,
     /*  259024 */   // Label 4935: @259024
     /*  259024 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(259087), // Rule ID 5708 //
     /*  259029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  259043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  259046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259068 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  259068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  259071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259085 */     GIR_RootConstrainSelectedInstOperands,
     /*  259086 */     // GIR_Coverage, 5708,
     /*  259086 */     GIR_EraseRootFromParent_Done,
     /*  259087 */   // Label 4936: @259087
     /*  259087 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(259150), // Rule ID 5709 //
     /*  259092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  259106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  259109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259131 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  259131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  259134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259148 */     GIR_RootConstrainSelectedInstOperands,
     /*  259149 */     // GIR_Coverage, 5709,
     /*  259149 */     GIR_EraseRootFromParent_Done,
     /*  259150 */   // Label 4937: @259150
     /*  259150 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(259213), // Rule ID 5710 //
     /*  259155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  259169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  259172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259194 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  259194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  259197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259211 */     GIR_RootConstrainSelectedInstOperands,
     /*  259212 */     // GIR_Coverage, 5710,
     /*  259212 */     GIR_EraseRootFromParent_Done,
     /*  259213 */   // Label 4938: @259213
     /*  259213 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(259276), // Rule ID 5711 //
     /*  259218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  259232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  259235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259257 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  259257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  259260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259274 */     GIR_RootConstrainSelectedInstOperands,
     /*  259275 */     // GIR_Coverage, 5711,
     /*  259275 */     GIR_EraseRootFromParent_Done,
     /*  259276 */   // Label 4939: @259276
     /*  259276 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(259339), // Rule ID 5712 //
     /*  259281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  259292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  259295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  259298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259320 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  259320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  259323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259337 */     GIR_RootConstrainSelectedInstOperands,
     /*  259338 */     // GIR_Coverage, 5712,
     /*  259338 */     GIR_EraseRootFromParent_Done,
     /*  259339 */   // Label 4940: @259339
     /*  259339 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(259402), // Rule ID 5713 //
     /*  259344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  259355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  259358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  259361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259383 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  259383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  259386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259400 */     GIR_RootConstrainSelectedInstOperands,
     /*  259401 */     // GIR_Coverage, 5713,
     /*  259401 */     GIR_EraseRootFromParent_Done,
     /*  259402 */   // Label 4941: @259402
     /*  259402 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(259465), // Rule ID 5714 //
     /*  259407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  259410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  259421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  259424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  259446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  259449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259463 */     GIR_RootConstrainSelectedInstOperands,
     /*  259464 */     // GIR_Coverage, 5714,
     /*  259464 */     GIR_EraseRootFromParent_Done,
     /*  259465 */   // Label 4942: @259465
     /*  259465 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(259528), // Rule ID 5715 //
     /*  259470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  259473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  259484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  259487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259509 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  259509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  259512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259526 */     GIR_RootConstrainSelectedInstOperands,
     /*  259527 */     // GIR_Coverage, 5715,
     /*  259527 */     GIR_EraseRootFromParent_Done,
     /*  259528 */   // Label 4943: @259528
     /*  259528 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(259591), // Rule ID 5716 //
     /*  259533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  259536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  259547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  259550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  259572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  259575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259589 */     GIR_RootConstrainSelectedInstOperands,
     /*  259590 */     // GIR_Coverage, 5716,
     /*  259590 */     GIR_EraseRootFromParent_Done,
     /*  259591 */   // Label 4944: @259591
     /*  259591 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(259654), // Rule ID 5717 //
     /*  259596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  259599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  259610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  259613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259635 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  259635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  259638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259652 */     GIR_RootConstrainSelectedInstOperands,
     /*  259653 */     // GIR_Coverage, 5717,
     /*  259653 */     GIR_EraseRootFromParent_Done,
     /*  259654 */   // Label 4945: @259654
     /*  259654 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(259717), // Rule ID 5718 //
     /*  259659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  259662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  259673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  259676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259698 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  259698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  259701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259715 */     GIR_RootConstrainSelectedInstOperands,
     /*  259716 */     // GIR_Coverage, 5718,
     /*  259716 */     GIR_EraseRootFromParent_Done,
     /*  259717 */   // Label 4946: @259717
     /*  259717 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(259780), // Rule ID 5719 //
     /*  259722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  259725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  259736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  259739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259761 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  259761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  259764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259778 */     GIR_RootConstrainSelectedInstOperands,
     /*  259779 */     // GIR_Coverage, 5719,
     /*  259779 */     GIR_EraseRootFromParent_Done,
     /*  259780 */   // Label 4947: @259780
     /*  259780 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(259843), // Rule ID 5720 //
     /*  259785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  259799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  259802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  259817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259824 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  259827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259841 */     GIR_RootConstrainSelectedInstOperands,
     /*  259842 */     // GIR_Coverage, 5720,
     /*  259842 */     GIR_EraseRootFromParent_Done,
     /*  259843 */   // Label 4948: @259843
     /*  259843 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(259906), // Rule ID 5721 //
     /*  259848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  259862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  259865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  259880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259887 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  259890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259904 */     GIR_RootConstrainSelectedInstOperands,
     /*  259905 */     // GIR_Coverage, 5721,
     /*  259905 */     GIR_EraseRootFromParent_Done,
     /*  259906 */   // Label 4949: @259906
     /*  259906 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(259969), // Rule ID 5722 //
     /*  259911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  259925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  259928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  259943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259950 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  259953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259967 */     GIR_RootConstrainSelectedInstOperands,
     /*  259968 */     // GIR_Coverage, 5722,
     /*  259968 */     GIR_EraseRootFromParent_Done,
     /*  259969 */   // Label 4950: @259969
     /*  259969 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(260032), // Rule ID 5723 //
     /*  259974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  259988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  259991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260013 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  260016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260030 */     GIR_RootConstrainSelectedInstOperands,
     /*  260031 */     // GIR_Coverage, 5723,
     /*  260031 */     GIR_EraseRootFromParent_Done,
     /*  260032 */   // Label 4951: @260032
     /*  260032 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(260095), // Rule ID 5724 //
     /*  260037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  260051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260076 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  260079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260093 */     GIR_RootConstrainSelectedInstOperands,
     /*  260094 */     // GIR_Coverage, 5724,
     /*  260094 */     GIR_EraseRootFromParent_Done,
     /*  260095 */   // Label 4952: @260095
     /*  260095 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(260158), // Rule ID 5725 //
     /*  260100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  260114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260139 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  260142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260156 */     GIR_RootConstrainSelectedInstOperands,
     /*  260157 */     // GIR_Coverage, 5725,
     /*  260157 */     GIR_EraseRootFromParent_Done,
     /*  260158 */   // Label 4953: @260158
     /*  260158 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(260221), // Rule ID 5726 //
     /*  260163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  260177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260202 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  260205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260219 */     GIR_RootConstrainSelectedInstOperands,
     /*  260220 */     // GIR_Coverage, 5726,
     /*  260220 */     GIR_EraseRootFromParent_Done,
     /*  260221 */   // Label 4954: @260221
     /*  260221 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(260284), // Rule ID 5727 //
     /*  260226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  260240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260265 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  260268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260282 */     GIR_RootConstrainSelectedInstOperands,
     /*  260283 */     // GIR_Coverage, 5727,
     /*  260283 */     GIR_EraseRootFromParent_Done,
     /*  260284 */   // Label 4955: @260284
     /*  260284 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(260347), // Rule ID 5728 //
     /*  260289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  260303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260328 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  260331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260345 */     GIR_RootConstrainSelectedInstOperands,
     /*  260346 */     // GIR_Coverage, 5728,
     /*  260346 */     GIR_EraseRootFromParent_Done,
     /*  260347 */   // Label 4956: @260347
     /*  260347 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(260410), // Rule ID 5729 //
     /*  260352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  260366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260391 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  260394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260408 */     GIR_RootConstrainSelectedInstOperands,
     /*  260409 */     // GIR_Coverage, 5729,
     /*  260409 */     GIR_EraseRootFromParent_Done,
     /*  260410 */   // Label 4957: @260410
     /*  260410 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(260473), // Rule ID 5730 //
     /*  260415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  260429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260454 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  260457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260471 */     GIR_RootConstrainSelectedInstOperands,
     /*  260472 */     // GIR_Coverage, 5730,
     /*  260472 */     GIR_EraseRootFromParent_Done,
     /*  260473 */   // Label 4958: @260473
     /*  260473 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(260536), // Rule ID 5731 //
     /*  260478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  260492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260517 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  260520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260534 */     GIR_RootConstrainSelectedInstOperands,
     /*  260535 */     // GIR_Coverage, 5731,
     /*  260535 */     GIR_EraseRootFromParent_Done,
     /*  260536 */   // Label 4959: @260536
     /*  260536 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(260599), // Rule ID 5732 //
     /*  260541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  260555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260580 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260597 */     GIR_RootConstrainSelectedInstOperands,
     /*  260598 */     // GIR_Coverage, 5732,
     /*  260598 */     GIR_EraseRootFromParent_Done,
     /*  260599 */   // Label 4960: @260599
     /*  260599 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(260662), // Rule ID 5733 //
     /*  260604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  260618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260643 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260660 */     GIR_RootConstrainSelectedInstOperands,
     /*  260661 */     // GIR_Coverage, 5733,
     /*  260661 */     GIR_EraseRootFromParent_Done,
     /*  260662 */   // Label 4961: @260662
     /*  260662 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(260725), // Rule ID 5734 //
     /*  260667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  260681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260706 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260723 */     GIR_RootConstrainSelectedInstOperands,
     /*  260724 */     // GIR_Coverage, 5734,
     /*  260724 */     GIR_EraseRootFromParent_Done,
     /*  260725 */   // Label 4962: @260725
     /*  260725 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(260788), // Rule ID 5735 //
     /*  260730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  260744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260769 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260786 */     GIR_RootConstrainSelectedInstOperands,
     /*  260787 */     // GIR_Coverage, 5735,
     /*  260787 */     GIR_EraseRootFromParent_Done,
     /*  260788 */   // Label 4963: @260788
     /*  260788 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(260851), // Rule ID 5736 //
     /*  260793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  260807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260832 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260849 */     GIR_RootConstrainSelectedInstOperands,
     /*  260850 */     // GIR_Coverage, 5736,
     /*  260850 */     GIR_EraseRootFromParent_Done,
     /*  260851 */   // Label 4964: @260851
     /*  260851 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(260914), // Rule ID 5737 //
     /*  260856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  260870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260895 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260912 */     GIR_RootConstrainSelectedInstOperands,
     /*  260913 */     // GIR_Coverage, 5737,
     /*  260913 */     GIR_EraseRootFromParent_Done,
     /*  260914 */   // Label 4965: @260914
     /*  260914 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(260977), // Rule ID 5738 //
     /*  260919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  260922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  260933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260958 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  260958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  260975 */     GIR_RootConstrainSelectedInstOperands,
     /*  260976 */     // GIR_Coverage, 5738,
     /*  260976 */     GIR_EraseRootFromParent_Done,
     /*  260977 */   // Label 4966: @260977
     /*  260977 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(261040), // Rule ID 5739 //
     /*  260982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  260985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  260996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261021 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  261024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261038 */     GIR_RootConstrainSelectedInstOperands,
     /*  261039 */     // GIR_Coverage, 5739,
     /*  261039 */     GIR_EraseRootFromParent_Done,
     /*  261040 */   // Label 4967: @261040
     /*  261040 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(261103), // Rule ID 5740 //
     /*  261045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  261056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  261059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261084 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  261087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261101 */     GIR_RootConstrainSelectedInstOperands,
     /*  261102 */     // GIR_Coverage, 5740,
     /*  261102 */     GIR_EraseRootFromParent_Done,
     /*  261103 */   // Label 4968: @261103
     /*  261103 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(261166), // Rule ID 5741 //
     /*  261108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  261119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  261122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261147 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  261150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261164 */     GIR_RootConstrainSelectedInstOperands,
     /*  261165 */     // GIR_Coverage, 5741,
     /*  261165 */     GIR_EraseRootFromParent_Done,
     /*  261166 */   // Label 4969: @261166
     /*  261166 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(261229), // Rule ID 5742 //
     /*  261171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  261182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  261185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261210 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  261213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261227 */     GIR_RootConstrainSelectedInstOperands,
     /*  261228 */     // GIR_Coverage, 5742,
     /*  261228 */     GIR_EraseRootFromParent_Done,
     /*  261229 */   // Label 4970: @261229
     /*  261229 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(261292), // Rule ID 5743 //
     /*  261234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  261245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  261248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261273 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  261276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261290 */     GIR_RootConstrainSelectedInstOperands,
     /*  261291 */     // GIR_Coverage, 5743,
     /*  261291 */     GIR_EraseRootFromParent_Done,
     /*  261292 */   // Label 4971: @261292
     /*  261292 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(261355), // Rule ID 5744 //
     /*  261297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  261308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  261311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261336 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  261339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261353 */     GIR_RootConstrainSelectedInstOperands,
     /*  261354 */     // GIR_Coverage, 5744,
     /*  261354 */     GIR_EraseRootFromParent_Done,
     /*  261355 */   // Label 4972: @261355
     /*  261355 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(261418), // Rule ID 5745 //
     /*  261360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  261371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  261374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261399 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  261402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261416 */     GIR_RootConstrainSelectedInstOperands,
     /*  261417 */     // GIR_Coverage, 5745,
     /*  261417 */     GIR_EraseRootFromParent_Done,
     /*  261418 */   // Label 4973: @261418
     /*  261418 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(261481), // Rule ID 5746 //
     /*  261423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  261437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261462 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  261462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  261465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261479 */     GIR_RootConstrainSelectedInstOperands,
     /*  261480 */     // GIR_Coverage, 5746,
     /*  261480 */     GIR_EraseRootFromParent_Done,
     /*  261481 */   // Label 4974: @261481
     /*  261481 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(261544), // Rule ID 5747 //
     /*  261486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  261500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261525 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  261528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261542 */     GIR_RootConstrainSelectedInstOperands,
     /*  261543 */     // GIR_Coverage, 5747,
     /*  261543 */     GIR_EraseRootFromParent_Done,
     /*  261544 */   // Label 4975: @261544
     /*  261544 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(261607), // Rule ID 5748 //
     /*  261549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  261560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  261563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261588 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  261588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  261591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261605 */     GIR_RootConstrainSelectedInstOperands,
     /*  261606 */     // GIR_Coverage, 5748,
     /*  261606 */     GIR_EraseRootFromParent_Done,
     /*  261607 */   // Label 4976: @261607
     /*  261607 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(261670), // Rule ID 5749 //
     /*  261612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  261623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  261626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261651 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  261654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261668 */     GIR_RootConstrainSelectedInstOperands,
     /*  261669 */     // GIR_Coverage, 5749,
     /*  261669 */     GIR_EraseRootFromParent_Done,
     /*  261670 */   // Label 4977: @261670
     /*  261670 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(261733), // Rule ID 5750 //
     /*  261675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  261686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  261689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261714 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  261714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  261717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261731 */     GIR_RootConstrainSelectedInstOperands,
     /*  261732 */     // GIR_Coverage, 5750,
     /*  261732 */     GIR_EraseRootFromParent_Done,
     /*  261733 */   // Label 4978: @261733
     /*  261733 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(261796), // Rule ID 5751 //
     /*  261738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  261749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  261752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261777 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  261780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261794 */     GIR_RootConstrainSelectedInstOperands,
     /*  261795 */     // GIR_Coverage, 5751,
     /*  261795 */     GIR_EraseRootFromParent_Done,
     /*  261796 */   // Label 4979: @261796
     /*  261796 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(261859), // Rule ID 5752 //
     /*  261801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  261815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261840 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  261840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  261843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261857 */     GIR_RootConstrainSelectedInstOperands,
     /*  261858 */     // GIR_Coverage, 5752,
     /*  261858 */     GIR_EraseRootFromParent_Done,
     /*  261859 */   // Label 4980: @261859
     /*  261859 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(261922), // Rule ID 5753 //
     /*  261864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  261878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261903 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  261903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  261906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261920 */     GIR_RootConstrainSelectedInstOperands,
     /*  261921 */     // GIR_Coverage, 5753,
     /*  261921 */     GIR_EraseRootFromParent_Done,
     /*  261922 */   // Label 4981: @261922
     /*  261922 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(261985), // Rule ID 5754 //
     /*  261927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  261941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261966 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  261966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  261969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261983 */     GIR_RootConstrainSelectedInstOperands,
     /*  261984 */     // GIR_Coverage, 5754,
     /*  261984 */     GIR_EraseRootFromParent_Done,
     /*  261985 */   // Label 4982: @261985
     /*  261985 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(262048), // Rule ID 5755 //
     /*  261990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  262004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262029 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  262029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  262032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262046 */     GIR_RootConstrainSelectedInstOperands,
     /*  262047 */     // GIR_Coverage, 5755,
     /*  262047 */     GIR_EraseRootFromParent_Done,
     /*  262048 */   // Label 4983: @262048
     /*  262048 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(262111), // Rule ID 5756 //
     /*  262053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  262067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262092 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  262092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  262095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262109 */     GIR_RootConstrainSelectedInstOperands,
     /*  262110 */     // GIR_Coverage, 5756,
     /*  262110 */     GIR_EraseRootFromParent_Done,
     /*  262111 */   // Label 4984: @262111
     /*  262111 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(262174), // Rule ID 5757 //
     /*  262116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  262130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262155 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  262155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  262158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262172 */     GIR_RootConstrainSelectedInstOperands,
     /*  262173 */     // GIR_Coverage, 5757,
     /*  262173 */     GIR_EraseRootFromParent_Done,
     /*  262174 */   // Label 4985: @262174
     /*  262174 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(262237), // Rule ID 5758 //
     /*  262179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  262182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  262193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262218 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  262218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  262221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262235 */     GIR_RootConstrainSelectedInstOperands,
     /*  262236 */     // GIR_Coverage, 5758,
     /*  262236 */     GIR_EraseRootFromParent_Done,
     /*  262237 */   // Label 4986: @262237
     /*  262237 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(262300), // Rule ID 5759 //
     /*  262242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  262245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  262256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262281 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  262281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  262284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262298 */     GIR_RootConstrainSelectedInstOperands,
     /*  262299 */     // GIR_Coverage, 5759,
     /*  262299 */     GIR_EraseRootFromParent_Done,
     /*  262300 */   // Label 4987: @262300
     /*  262300 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(262363), // Rule ID 5760 //
     /*  262305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  262308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  262319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262344 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  262344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  262347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262361 */     GIR_RootConstrainSelectedInstOperands,
     /*  262362 */     // GIR_Coverage, 5760,
     /*  262362 */     GIR_EraseRootFromParent_Done,
     /*  262363 */   // Label 4988: @262363
     /*  262363 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(262426), // Rule ID 5761 //
     /*  262368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  262371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  262382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262407 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  262407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  262410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262424 */     GIR_RootConstrainSelectedInstOperands,
     /*  262425 */     // GIR_Coverage, 5761,
     /*  262425 */     GIR_EraseRootFromParent_Done,
     /*  262426 */   // Label 4989: @262426
     /*  262426 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(262489), // Rule ID 5762 //
     /*  262431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  262434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  262445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262470 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  262470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  262473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262487 */     GIR_RootConstrainSelectedInstOperands,
     /*  262488 */     // GIR_Coverage, 5762,
     /*  262488 */     GIR_EraseRootFromParent_Done,
     /*  262489 */   // Label 4990: @262489
     /*  262489 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(262552), // Rule ID 5763 //
     /*  262494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  262497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  262508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262533 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  262533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  262536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262550 */     GIR_RootConstrainSelectedInstOperands,
     /*  262551 */     // GIR_Coverage, 5763,
     /*  262551 */     GIR_EraseRootFromParent_Done,
     /*  262552 */   // Label 4991: @262552
     /*  262552 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(262615), // Rule ID 7796 //
     /*  262557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  262571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  262574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262596 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  262599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262613 */     GIR_RootConstrainSelectedInstOperands,
     /*  262614 */     // GIR_Coverage, 7796,
     /*  262614 */     GIR_EraseRootFromParent_Done,
     /*  262615 */   // Label 4992: @262615
     /*  262615 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(262678), // Rule ID 7797 //
     /*  262620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  262634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  262637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262659 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  262662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262676 */     GIR_RootConstrainSelectedInstOperands,
     /*  262677 */     // GIR_Coverage, 7797,
     /*  262677 */     GIR_EraseRootFromParent_Done,
     /*  262678 */   // Label 4993: @262678
     /*  262678 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(262741), // Rule ID 7800 //
     /*  262683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  262697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  262700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262722 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  262725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262739 */     GIR_RootConstrainSelectedInstOperands,
     /*  262740 */     // GIR_Coverage, 7800,
     /*  262740 */     GIR_EraseRootFromParent_Done,
     /*  262741 */   // Label 4994: @262741
     /*  262741 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(262804), // Rule ID 7801 //
     /*  262746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  262760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  262763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262785 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  262788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262802 */     GIR_RootConstrainSelectedInstOperands,
     /*  262803 */     // GIR_Coverage, 7801,
     /*  262803 */     GIR_EraseRootFromParent_Done,
     /*  262804 */   // Label 4995: @262804
     /*  262804 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(262867), // Rule ID 7804 //
     /*  262809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  262823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  262826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262848 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  262851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262865 */     GIR_RootConstrainSelectedInstOperands,
     /*  262866 */     // GIR_Coverage, 7804,
     /*  262866 */     GIR_EraseRootFromParent_Done,
     /*  262867 */   // Label 4996: @262867
     /*  262867 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(262930), // Rule ID 7805 //
     /*  262872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  262886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  262889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262911 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  262911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  262914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262928 */     GIR_RootConstrainSelectedInstOperands,
     /*  262929 */     // GIR_Coverage, 7805,
     /*  262929 */     GIR_EraseRootFromParent_Done,
     /*  262930 */   // Label 4997: @262930
     /*  262930 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(262993), // Rule ID 7808 //
     /*  262935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  262949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  262952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262974 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  262977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262991 */     GIR_RootConstrainSelectedInstOperands,
     /*  262992 */     // GIR_Coverage, 7808,
     /*  262992 */     GIR_EraseRootFromParent_Done,
     /*  262993 */   // Label 4998: @262993
     /*  262993 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(263056), // Rule ID 7809 //
     /*  262998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  263012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  263015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263037 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  263040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263054 */     GIR_RootConstrainSelectedInstOperands,
     /*  263055 */     // GIR_Coverage, 7809,
     /*  263055 */     GIR_EraseRootFromParent_Done,
     /*  263056 */   // Label 4999: @263056
     /*  263056 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(263119), // Rule ID 7812 //
     /*  263061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  263075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  263078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263100 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  263103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263117 */     GIR_RootConstrainSelectedInstOperands,
     /*  263118 */     // GIR_Coverage, 7812,
     /*  263118 */     GIR_EraseRootFromParent_Done,
     /*  263119 */   // Label 5000: @263119
     /*  263119 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(263182), // Rule ID 7813 //
     /*  263124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  263138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  263141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263163 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  263166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263180 */     GIR_RootConstrainSelectedInstOperands,
     /*  263181 */     // GIR_Coverage, 7813,
     /*  263181 */     GIR_EraseRootFromParent_Done,
     /*  263182 */   // Label 5001: @263182
     /*  263182 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(263245), // Rule ID 7816 //
     /*  263187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  263201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  263204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263226 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263243 */     GIR_RootConstrainSelectedInstOperands,
     /*  263244 */     // GIR_Coverage, 7816,
     /*  263244 */     GIR_EraseRootFromParent_Done,
     /*  263245 */   // Label 5002: @263245
     /*  263245 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(263308), // Rule ID 7817 //
     /*  263250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  263264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  263267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263289 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263306 */     GIR_RootConstrainSelectedInstOperands,
     /*  263307 */     // GIR_Coverage, 7817,
     /*  263307 */     GIR_EraseRootFromParent_Done,
     /*  263308 */   // Label 5003: @263308
     /*  263308 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(263371), // Rule ID 7820 //
     /*  263313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  263327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  263330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263352 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263369 */     GIR_RootConstrainSelectedInstOperands,
     /*  263370 */     // GIR_Coverage, 7820,
     /*  263370 */     GIR_EraseRootFromParent_Done,
     /*  263371 */   // Label 5004: @263371
     /*  263371 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(263434), // Rule ID 7821 //
     /*  263376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  263390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  263393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263415 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263432 */     GIR_RootConstrainSelectedInstOperands,
     /*  263433 */     // GIR_Coverage, 7821,
     /*  263433 */     GIR_EraseRootFromParent_Done,
     /*  263434 */   // Label 5005: @263434
     /*  263434 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(263497), // Rule ID 7824 //
     /*  263439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  263453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  263456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263478 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263495 */     GIR_RootConstrainSelectedInstOperands,
     /*  263496 */     // GIR_Coverage, 7824,
     /*  263496 */     GIR_EraseRootFromParent_Done,
     /*  263497 */   // Label 5006: @263497
     /*  263497 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(263560), // Rule ID 7825 //
     /*  263502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  263516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  263519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263541 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263558 */     GIR_RootConstrainSelectedInstOperands,
     /*  263559 */     // GIR_Coverage, 7825,
     /*  263559 */     GIR_EraseRootFromParent_Done,
     /*  263560 */   // Label 5007: @263560
     /*  263560 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(263623), // Rule ID 7828 //
     /*  263565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  263568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  263579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  263582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263604 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  263604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263621 */     GIR_RootConstrainSelectedInstOperands,
     /*  263622 */     // GIR_Coverage, 7828,
     /*  263622 */     GIR_EraseRootFromParent_Done,
     /*  263623 */   // Label 5008: @263623
     /*  263623 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(263686), // Rule ID 7829 //
     /*  263628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  263631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  263642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  263645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263667 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  263667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263684 */     GIR_RootConstrainSelectedInstOperands,
     /*  263685 */     // GIR_Coverage, 7829,
     /*  263685 */     GIR_EraseRootFromParent_Done,
     /*  263686 */   // Label 5009: @263686
     /*  263686 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(263749), // Rule ID 7832 //
     /*  263691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  263705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  263708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263730 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  263733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263747 */     GIR_RootConstrainSelectedInstOperands,
     /*  263748 */     // GIR_Coverage, 7832,
     /*  263748 */     GIR_EraseRootFromParent_Done,
     /*  263749 */   // Label 5010: @263749
     /*  263749 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(263812), // Rule ID 7833 //
     /*  263754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  263768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  263771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263793 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  263796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263810 */     GIR_RootConstrainSelectedInstOperands,
     /*  263811 */     // GIR_Coverage, 7833,
     /*  263811 */     GIR_EraseRootFromParent_Done,
     /*  263812 */   // Label 5011: @263812
     /*  263812 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(263875), // Rule ID 7836 //
     /*  263817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  263831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  263834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263856 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  263859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263873 */     GIR_RootConstrainSelectedInstOperands,
     /*  263874 */     // GIR_Coverage, 7836,
     /*  263874 */     GIR_EraseRootFromParent_Done,
     /*  263875 */   // Label 5012: @263875
     /*  263875 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(263938), // Rule ID 7837 //
     /*  263880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  263894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  263897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263919 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  263922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263936 */     GIR_RootConstrainSelectedInstOperands,
     /*  263937 */     // GIR_Coverage, 7837,
     /*  263937 */     GIR_EraseRootFromParent_Done,
     /*  263938 */   // Label 5013: @263938
     /*  263938 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(264001), // Rule ID 7840 //
     /*  263943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  263954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  263957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  263960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263982 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  263985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263999 */     GIR_RootConstrainSelectedInstOperands,
     /*  264000 */     // GIR_Coverage, 7840,
     /*  264000 */     GIR_EraseRootFromParent_Done,
     /*  264001 */   // Label 5014: @264001
     /*  264001 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(264064), // Rule ID 7841 //
     /*  264006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  264017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  264020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  264023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264045 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  264048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264062 */     GIR_RootConstrainSelectedInstOperands,
     /*  264063 */     // GIR_Coverage, 7841,
     /*  264063 */     GIR_EraseRootFromParent_Done,
     /*  264064 */   // Label 5015: @264064
     /*  264064 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(264127), // Rule ID 7844 //
     /*  264069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  264083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  264086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264108 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  264108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  264111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264125 */     GIR_RootConstrainSelectedInstOperands,
     /*  264126 */     // GIR_Coverage, 7844,
     /*  264126 */     GIR_EraseRootFromParent_Done,
     /*  264127 */   // Label 5016: @264127
     /*  264127 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(264190), // Rule ID 7845 //
     /*  264132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  264146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  264149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264171 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  264171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  264174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264188 */     GIR_RootConstrainSelectedInstOperands,
     /*  264189 */     // GIR_Coverage, 7845,
     /*  264189 */     GIR_EraseRootFromParent_Done,
     /*  264190 */   // Label 5017: @264190
     /*  264190 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(264253), // Rule ID 7848 //
     /*  264195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  264209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  264212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264234 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  264234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  264237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264251 */     GIR_RootConstrainSelectedInstOperands,
     /*  264252 */     // GIR_Coverage, 7848,
     /*  264252 */     GIR_EraseRootFromParent_Done,
     /*  264253 */   // Label 5018: @264253
     /*  264253 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(264316), // Rule ID 7849 //
     /*  264258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  264272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  264275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264297 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  264297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  264300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264314 */     GIR_RootConstrainSelectedInstOperands,
     /*  264315 */     // GIR_Coverage, 7849,
     /*  264315 */     GIR_EraseRootFromParent_Done,
     /*  264316 */   // Label 5019: @264316
     /*  264316 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(264379), // Rule ID 7852 //
     /*  264321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  264332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  264335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  264338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264360 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  264360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  264363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264377 */     GIR_RootConstrainSelectedInstOperands,
     /*  264378 */     // GIR_Coverage, 7852,
     /*  264378 */     GIR_EraseRootFromParent_Done,
     /*  264379 */   // Label 5020: @264379
     /*  264379 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(264442), // Rule ID 7853 //
     /*  264384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  264395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  264398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  264401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264423 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  264423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  264426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264440 */     GIR_RootConstrainSelectedInstOperands,
     /*  264441 */     // GIR_Coverage, 7853,
     /*  264441 */     GIR_EraseRootFromParent_Done,
     /*  264442 */   // Label 5021: @264442
     /*  264442 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(264505), // Rule ID 7856 //
     /*  264447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  264461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  264464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264486 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  264489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264503 */     GIR_RootConstrainSelectedInstOperands,
     /*  264504 */     // GIR_Coverage, 7856,
     /*  264504 */     GIR_EraseRootFromParent_Done,
     /*  264505 */   // Label 5022: @264505
     /*  264505 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(264568), // Rule ID 7857 //
     /*  264510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  264524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  264527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264549 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  264552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264566 */     GIR_RootConstrainSelectedInstOperands,
     /*  264567 */     // GIR_Coverage, 7857,
     /*  264567 */     GIR_EraseRootFromParent_Done,
     /*  264568 */   // Label 5023: @264568
     /*  264568 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(264631), // Rule ID 7860 //
     /*  264573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  264587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  264590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264612 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  264615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264629 */     GIR_RootConstrainSelectedInstOperands,
     /*  264630 */     // GIR_Coverage, 7860,
     /*  264630 */     GIR_EraseRootFromParent_Done,
     /*  264631 */   // Label 5024: @264631
     /*  264631 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(264694), // Rule ID 7861 //
     /*  264636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  264650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  264653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264675 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  264678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264692 */     GIR_RootConstrainSelectedInstOperands,
     /*  264693 */     // GIR_Coverage, 7861,
     /*  264693 */     GIR_EraseRootFromParent_Done,
     /*  264694 */   // Label 5025: @264694
     /*  264694 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(264757), // Rule ID 7864 //
     /*  264699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  264713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  264716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264738 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  264741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264755 */     GIR_RootConstrainSelectedInstOperands,
     /*  264756 */     // GIR_Coverage, 7864,
     /*  264756 */     GIR_EraseRootFromParent_Done,
     /*  264757 */   // Label 5026: @264757
     /*  264757 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(264820), // Rule ID 7865 //
     /*  264762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  264776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  264779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264801 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  264804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264818 */     GIR_RootConstrainSelectedInstOperands,
     /*  264819 */     // GIR_Coverage, 7865,
     /*  264819 */     GIR_EraseRootFromParent_Done,
     /*  264820 */   // Label 5027: @264820
     /*  264820 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(264883), // Rule ID 7868 //
     /*  264825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  264828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  264839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  264842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264864 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  264864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  264867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264881 */     GIR_RootConstrainSelectedInstOperands,
     /*  264882 */     // GIR_Coverage, 7868,
     /*  264882 */     GIR_EraseRootFromParent_Done,
     /*  264883 */   // Label 5028: @264883
     /*  264883 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(264946), // Rule ID 7869 //
     /*  264888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  264891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  264902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  264905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264927 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  264927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  264930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264944 */     GIR_RootConstrainSelectedInstOperands,
     /*  264945 */     // GIR_Coverage, 7869,
     /*  264945 */     GIR_EraseRootFromParent_Done,
     /*  264946 */   // Label 5029: @264946
     /*  264946 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(265009), // Rule ID 7872 //
     /*  264951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  264954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  264965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  264968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264990 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  264990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  264993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265007 */     GIR_RootConstrainSelectedInstOperands,
     /*  265008 */     // GIR_Coverage, 7872,
     /*  265008 */     GIR_EraseRootFromParent_Done,
     /*  265009 */   // Label 5030: @265009
     /*  265009 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(265072), // Rule ID 7873 //
     /*  265014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  265017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  265028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  265031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265053 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  265053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  265056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265070 */     GIR_RootConstrainSelectedInstOperands,
     /*  265071 */     // GIR_Coverage, 7873,
     /*  265071 */     GIR_EraseRootFromParent_Done,
     /*  265072 */   // Label 5031: @265072
     /*  265072 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(265135), // Rule ID 7876 //
     /*  265077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  265080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  265091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  265094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265116 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  265116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  265119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265133 */     GIR_RootConstrainSelectedInstOperands,
     /*  265134 */     // GIR_Coverage, 7876,
     /*  265134 */     GIR_EraseRootFromParent_Done,
     /*  265135 */   // Label 5032: @265135
     /*  265135 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(265198), // Rule ID 7877 //
     /*  265140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  265143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  265154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  265157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265179 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  265179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  265182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265196 */     GIR_RootConstrainSelectedInstOperands,
     /*  265197 */     // GIR_Coverage, 7877,
     /*  265197 */     GIR_EraseRootFromParent_Done,
     /*  265198 */   // Label 5033: @265198
     /*  265198 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(265261), // Rule ID 7880 //
     /*  265203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  265217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265242 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  265245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265259 */     GIR_RootConstrainSelectedInstOperands,
     /*  265260 */     // GIR_Coverage, 7880,
     /*  265260 */     GIR_EraseRootFromParent_Done,
     /*  265261 */   // Label 5034: @265261
     /*  265261 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(265324), // Rule ID 7881 //
     /*  265266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  265280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  265283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265305 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  265308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265322 */     GIR_RootConstrainSelectedInstOperands,
     /*  265323 */     // GIR_Coverage, 7881,
     /*  265323 */     GIR_EraseRootFromParent_Done,
     /*  265324 */   // Label 5035: @265324
     /*  265324 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(265387), // Rule ID 7884 //
     /*  265329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  265343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  265371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265385 */     GIR_RootConstrainSelectedInstOperands,
     /*  265386 */     // GIR_Coverage, 7884,
     /*  265386 */     GIR_EraseRootFromParent_Done,
     /*  265387 */   // Label 5036: @265387
     /*  265387 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(265450), // Rule ID 7885 //
     /*  265392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  265406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  265409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265431 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  265434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265448 */     GIR_RootConstrainSelectedInstOperands,
     /*  265449 */     // GIR_Coverage, 7885,
     /*  265449 */     GIR_EraseRootFromParent_Done,
     /*  265450 */   // Label 5037: @265450
     /*  265450 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(265513), // Rule ID 7888 //
     /*  265455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  265469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265494 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  265497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265511 */     GIR_RootConstrainSelectedInstOperands,
     /*  265512 */     // GIR_Coverage, 7888,
     /*  265512 */     GIR_EraseRootFromParent_Done,
     /*  265513 */   // Label 5038: @265513
     /*  265513 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(265576), // Rule ID 7889 //
     /*  265518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  265532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  265535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265557 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  265560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265574 */     GIR_RootConstrainSelectedInstOperands,
     /*  265575 */     // GIR_Coverage, 7889,
     /*  265575 */     GIR_EraseRootFromParent_Done,
     /*  265576 */   // Label 5039: @265576
     /*  265576 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(265639), // Rule ID 7892 //
     /*  265581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  265595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  265623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265637 */     GIR_RootConstrainSelectedInstOperands,
     /*  265638 */     // GIR_Coverage, 7892,
     /*  265638 */     GIR_EraseRootFromParent_Done,
     /*  265639 */   // Label 5040: @265639
     /*  265639 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(265702), // Rule ID 7893 //
     /*  265644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  265658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  265661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265683 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  265686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265700 */     GIR_RootConstrainSelectedInstOperands,
     /*  265701 */     // GIR_Coverage, 7893,
     /*  265701 */     GIR_EraseRootFromParent_Done,
     /*  265702 */   // Label 5041: @265702
     /*  265702 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(265765), // Rule ID 7896 //
     /*  265707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  265721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265746 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  265749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265763 */     GIR_RootConstrainSelectedInstOperands,
     /*  265764 */     // GIR_Coverage, 7896,
     /*  265764 */     GIR_EraseRootFromParent_Done,
     /*  265765 */   // Label 5042: @265765
     /*  265765 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(265828), // Rule ID 7897 //
     /*  265770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  265784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  265787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265809 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  265812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265826 */     GIR_RootConstrainSelectedInstOperands,
     /*  265827 */     // GIR_Coverage, 7897,
     /*  265827 */     GIR_EraseRootFromParent_Done,
     /*  265828 */   // Label 5043: @265828
     /*  265828 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(265891), // Rule ID 7900 //
     /*  265833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  265847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265872 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  265872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  265875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265889 */     GIR_RootConstrainSelectedInstOperands,
     /*  265890 */     // GIR_Coverage, 7900,
     /*  265890 */     GIR_EraseRootFromParent_Done,
     /*  265891 */   // Label 5044: @265891
     /*  265891 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(265954), // Rule ID 7901 //
     /*  265896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  265910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  265913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265935 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  265935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  265938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265952 */     GIR_RootConstrainSelectedInstOperands,
     /*  265953 */     // GIR_Coverage, 7901,
     /*  265953 */     GIR_EraseRootFromParent_Done,
     /*  265954 */   // Label 5045: @265954
     /*  265954 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(266017), // Rule ID 7904 //
     /*  265959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  265973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265998 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266015 */     GIR_RootConstrainSelectedInstOperands,
     /*  266016 */     // GIR_Coverage, 7904,
     /*  266016 */     GIR_EraseRootFromParent_Done,
     /*  266017 */   // Label 5046: @266017
     /*  266017 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(266080), // Rule ID 7905 //
     /*  266022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  266036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266061 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266078 */     GIR_RootConstrainSelectedInstOperands,
     /*  266079 */     // GIR_Coverage, 7905,
     /*  266079 */     GIR_EraseRootFromParent_Done,
     /*  266080 */   // Label 5047: @266080
     /*  266080 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(266143), // Rule ID 7908 //
     /*  266085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  266099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266124 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266141 */     GIR_RootConstrainSelectedInstOperands,
     /*  266142 */     // GIR_Coverage, 7908,
     /*  266142 */     GIR_EraseRootFromParent_Done,
     /*  266143 */   // Label 5048: @266143
     /*  266143 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(266206), // Rule ID 7909 //
     /*  266148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  266162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266187 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266204 */     GIR_RootConstrainSelectedInstOperands,
     /*  266205 */     // GIR_Coverage, 7909,
     /*  266205 */     GIR_EraseRootFromParent_Done,
     /*  266206 */   // Label 5049: @266206
     /*  266206 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(266269), // Rule ID 7912 //
     /*  266211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  266225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266250 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266267 */     GIR_RootConstrainSelectedInstOperands,
     /*  266268 */     // GIR_Coverage, 7912,
     /*  266268 */     GIR_EraseRootFromParent_Done,
     /*  266269 */   // Label 5050: @266269
     /*  266269 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(266332), // Rule ID 7913 //
     /*  266274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  266288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266313 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266330 */     GIR_RootConstrainSelectedInstOperands,
     /*  266331 */     // GIR_Coverage, 7913,
     /*  266331 */     GIR_EraseRootFromParent_Done,
     /*  266332 */   // Label 5051: @266332
     /*  266332 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(266395), // Rule ID 7916 //
     /*  266337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  266340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  266351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266376 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  266376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266393 */     GIR_RootConstrainSelectedInstOperands,
     /*  266394 */     // GIR_Coverage, 7916,
     /*  266394 */     GIR_EraseRootFromParent_Done,
     /*  266395 */   // Label 5052: @266395
     /*  266395 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(266458), // Rule ID 7917 //
     /*  266400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  266403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  266414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266439 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  266439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266456 */     GIR_RootConstrainSelectedInstOperands,
     /*  266457 */     // GIR_Coverage, 7917,
     /*  266457 */     GIR_EraseRootFromParent_Done,
     /*  266458 */   // Label 5053: @266458
     /*  266458 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(266521), // Rule ID 7920 //
     /*  266463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  266477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266502 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  266505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266519 */     GIR_RootConstrainSelectedInstOperands,
     /*  266520 */     // GIR_Coverage, 7920,
     /*  266520 */     GIR_EraseRootFromParent_Done,
     /*  266521 */   // Label 5054: @266521
     /*  266521 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(266584), // Rule ID 7921 //
     /*  266526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  266540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266565 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  266568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266582 */     GIR_RootConstrainSelectedInstOperands,
     /*  266583 */     // GIR_Coverage, 7921,
     /*  266583 */     GIR_EraseRootFromParent_Done,
     /*  266584 */   // Label 5055: @266584
     /*  266584 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(266647), // Rule ID 7924 //
     /*  266589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  266603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266628 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  266631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266645 */     GIR_RootConstrainSelectedInstOperands,
     /*  266646 */     // GIR_Coverage, 7924,
     /*  266646 */     GIR_EraseRootFromParent_Done,
     /*  266647 */   // Label 5056: @266647
     /*  266647 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(266710), // Rule ID 7925 //
     /*  266652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  266666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266691 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  266694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266708 */     GIR_RootConstrainSelectedInstOperands,
     /*  266709 */     // GIR_Coverage, 7925,
     /*  266709 */     GIR_EraseRootFromParent_Done,
     /*  266710 */   // Label 5057: @266710
     /*  266710 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(266773), // Rule ID 7928 //
     /*  266715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  266726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  266729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266754 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  266757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266771 */     GIR_RootConstrainSelectedInstOperands,
     /*  266772 */     // GIR_Coverage, 7928,
     /*  266772 */     GIR_EraseRootFromParent_Done,
     /*  266773 */   // Label 5058: @266773
     /*  266773 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(266836), // Rule ID 7929 //
     /*  266778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  266789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  266792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266817 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  266820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266834 */     GIR_RootConstrainSelectedInstOperands,
     /*  266835 */     // GIR_Coverage, 7929,
     /*  266835 */     GIR_EraseRootFromParent_Done,
     /*  266836 */   // Label 5059: @266836
     /*  266836 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(266899), // Rule ID 7932 //
     /*  266841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  266855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266880 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  266883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266897 */     GIR_RootConstrainSelectedInstOperands,
     /*  266898 */     // GIR_Coverage, 7932,
     /*  266898 */     GIR_EraseRootFromParent_Done,
     /*  266899 */   // Label 5060: @266899
     /*  266899 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(266962), // Rule ID 7933 //
     /*  266904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  266918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266943 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  266946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266960 */     GIR_RootConstrainSelectedInstOperands,
     /*  266961 */     // GIR_Coverage, 7933,
     /*  266961 */     GIR_EraseRootFromParent_Done,
     /*  266962 */   // Label 5061: @266962
     /*  266962 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(267025), // Rule ID 7936 //
     /*  266967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  266981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267006 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  267009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267023 */     GIR_RootConstrainSelectedInstOperands,
     /*  267024 */     // GIR_Coverage, 7936,
     /*  267024 */     GIR_EraseRootFromParent_Done,
     /*  267025 */   // Label 5062: @267025
     /*  267025 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(267088), // Rule ID 7937 //
     /*  267030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  267041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  267044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267069 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  267072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267086 */     GIR_RootConstrainSelectedInstOperands,
     /*  267087 */     // GIR_Coverage, 7937,
     /*  267087 */     GIR_EraseRootFromParent_Done,
     /*  267088 */   // Label 5063: @267088
     /*  267088 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(267151), // Rule ID 7940 //
     /*  267093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  267104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  267107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267132 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  267135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267149 */     GIR_RootConstrainSelectedInstOperands,
     /*  267150 */     // GIR_Coverage, 7940,
     /*  267150 */     GIR_EraseRootFromParent_Done,
     /*  267151 */   // Label 5064: @267151
     /*  267151 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(267214), // Rule ID 7941 //
     /*  267156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  267167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  267170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267195 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  267198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267212 */     GIR_RootConstrainSelectedInstOperands,
     /*  267213 */     // GIR_Coverage, 7941,
     /*  267213 */     GIR_EraseRootFromParent_Done,
     /*  267214 */   // Label 5065: @267214
     /*  267214 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(267277), // Rule ID 7944 //
     /*  267219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  267233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267258 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  267258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  267261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267275 */     GIR_RootConstrainSelectedInstOperands,
     /*  267276 */     // GIR_Coverage, 7944,
     /*  267276 */     GIR_EraseRootFromParent_Done,
     /*  267277 */   // Label 5066: @267277
     /*  267277 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(267340), // Rule ID 7945 //
     /*  267282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  267296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267321 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  267321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  267324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267338 */     GIR_RootConstrainSelectedInstOperands,
     /*  267339 */     // GIR_Coverage, 7945,
     /*  267339 */     GIR_EraseRootFromParent_Done,
     /*  267340 */   // Label 5067: @267340
     /*  267340 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(267403), // Rule ID 7948 //
     /*  267345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  267359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267384 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  267384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  267387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267401 */     GIR_RootConstrainSelectedInstOperands,
     /*  267402 */     // GIR_Coverage, 7948,
     /*  267402 */     GIR_EraseRootFromParent_Done,
     /*  267403 */   // Label 5068: @267403
     /*  267403 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(267466), // Rule ID 7949 //
     /*  267408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  267422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267447 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  267447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  267450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267464 */     GIR_RootConstrainSelectedInstOperands,
     /*  267465 */     // GIR_Coverage, 7949,
     /*  267465 */     GIR_EraseRootFromParent_Done,
     /*  267466 */   // Label 5069: @267466
     /*  267466 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(267529), // Rule ID 7952 //
     /*  267471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  267482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  267485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267510 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  267510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  267513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267527 */     GIR_RootConstrainSelectedInstOperands,
     /*  267528 */     // GIR_Coverage, 7952,
     /*  267528 */     GIR_EraseRootFromParent_Done,
     /*  267529 */   // Label 5070: @267529
     /*  267529 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(267592), // Rule ID 7953 //
     /*  267534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  267545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  267548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267573 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  267573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  267576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267590 */     GIR_RootConstrainSelectedInstOperands,
     /*  267591 */     // GIR_Coverage, 7953,
     /*  267591 */     GIR_EraseRootFromParent_Done,
     /*  267592 */   // Label 5071: @267592
     /*  267592 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(267655), // Rule ID 7956 //
     /*  267597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  267600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  267611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267636 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  267636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  267639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267653 */     GIR_RootConstrainSelectedInstOperands,
     /*  267654 */     // GIR_Coverage, 7956,
     /*  267654 */     GIR_EraseRootFromParent_Done,
     /*  267655 */   // Label 5072: @267655
     /*  267655 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(267718), // Rule ID 7957 //
     /*  267660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  267663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  267674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267699 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  267699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  267702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267716 */     GIR_RootConstrainSelectedInstOperands,
     /*  267717 */     // GIR_Coverage, 7957,
     /*  267717 */     GIR_EraseRootFromParent_Done,
     /*  267718 */   // Label 5073: @267718
     /*  267718 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(267781), // Rule ID 7960 //
     /*  267723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  267726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  267737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267762 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  267762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  267765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267779 */     GIR_RootConstrainSelectedInstOperands,
     /*  267780 */     // GIR_Coverage, 7960,
     /*  267780 */     GIR_EraseRootFromParent_Done,
     /*  267781 */   // Label 5074: @267781
     /*  267781 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(267844), // Rule ID 7961 //
     /*  267786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  267789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  267800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267825 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  267825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  267828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267842 */     GIR_RootConstrainSelectedInstOperands,
     /*  267843 */     // GIR_Coverage, 7961,
     /*  267843 */     GIR_EraseRootFromParent_Done,
     /*  267844 */   // Label 5075: @267844
     /*  267844 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(267907), // Rule ID 7964 //
     /*  267849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  267852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  267863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  267888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  267891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267905 */     GIR_RootConstrainSelectedInstOperands,
     /*  267906 */     // GIR_Coverage, 7964,
     /*  267906 */     GIR_EraseRootFromParent_Done,
     /*  267907 */   // Label 5076: @267907
     /*  267907 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(267970), // Rule ID 7965 //
     /*  267912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  267915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  267926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267951 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  267951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  267954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267968 */     GIR_RootConstrainSelectedInstOperands,
     /*  267969 */     // GIR_Coverage, 7965,
     /*  267969 */     GIR_EraseRootFromParent_Done,
     /*  267970 */   // Label 5077: @267970
     /*  267970 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(268033), // Rule ID 8056 //
     /*  267975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  267989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  267992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  268017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268031 */     GIR_RootConstrainSelectedInstOperands,
     /*  268032 */     // GIR_Coverage, 8056,
     /*  268032 */     GIR_EraseRootFromParent_Done,
     /*  268033 */   // Label 5078: @268033
     /*  268033 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(268096), // Rule ID 8057 //
     /*  268038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  268052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  268055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268077 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  268080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268094 */     GIR_RootConstrainSelectedInstOperands,
     /*  268095 */     // GIR_Coverage, 8057,
     /*  268095 */     GIR_EraseRootFromParent_Done,
     /*  268096 */   // Label 5079: @268096
     /*  268096 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(268159), // Rule ID 8060 //
     /*  268101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  268115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  268118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268140 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  268143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268157 */     GIR_RootConstrainSelectedInstOperands,
     /*  268158 */     // GIR_Coverage, 8060,
     /*  268158 */     GIR_EraseRootFromParent_Done,
     /*  268159 */   // Label 5080: @268159
     /*  268159 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(268222), // Rule ID 8061 //
     /*  268164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  268178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  268181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268203 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  268206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268220 */     GIR_RootConstrainSelectedInstOperands,
     /*  268221 */     // GIR_Coverage, 8061,
     /*  268221 */     GIR_EraseRootFromParent_Done,
     /*  268222 */   // Label 5081: @268222
     /*  268222 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(268285), // Rule ID 8064 //
     /*  268227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  268241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  268244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268266 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  268269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268283 */     GIR_RootConstrainSelectedInstOperands,
     /*  268284 */     // GIR_Coverage, 8064,
     /*  268284 */     GIR_EraseRootFromParent_Done,
     /*  268285 */   // Label 5082: @268285
     /*  268285 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(268348), // Rule ID 8065 //
     /*  268290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  268304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  268307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268329 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  268332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268346 */     GIR_RootConstrainSelectedInstOperands,
     /*  268347 */     // GIR_Coverage, 8065,
     /*  268347 */     GIR_EraseRootFromParent_Done,
     /*  268348 */   // Label 5083: @268348
     /*  268348 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(268411), // Rule ID 8068 //
     /*  268353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  268367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  268370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  268395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268409 */     GIR_RootConstrainSelectedInstOperands,
     /*  268410 */     // GIR_Coverage, 8068,
     /*  268410 */     GIR_EraseRootFromParent_Done,
     /*  268411 */   // Label 5084: @268411
     /*  268411 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(268474), // Rule ID 8069 //
     /*  268416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  268430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  268433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268455 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  268458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268472 */     GIR_RootConstrainSelectedInstOperands,
     /*  268473 */     // GIR_Coverage, 8069,
     /*  268473 */     GIR_EraseRootFromParent_Done,
     /*  268474 */   // Label 5085: @268474
     /*  268474 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(268537), // Rule ID 8072 //
     /*  268479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  268493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  268496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268518 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  268521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268535 */     GIR_RootConstrainSelectedInstOperands,
     /*  268536 */     // GIR_Coverage, 8072,
     /*  268536 */     GIR_EraseRootFromParent_Done,
     /*  268537 */   // Label 5086: @268537
     /*  268537 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(268600), // Rule ID 8073 //
     /*  268542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  268556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  268559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268581 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  268584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268598 */     GIR_RootConstrainSelectedInstOperands,
     /*  268599 */     // GIR_Coverage, 8073,
     /*  268599 */     GIR_EraseRootFromParent_Done,
     /*  268600 */   // Label 5087: @268600
     /*  268600 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(268663), // Rule ID 8076 //
     /*  268605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  268619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  268622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268644 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  268644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  268647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268661 */     GIR_RootConstrainSelectedInstOperands,
     /*  268662 */     // GIR_Coverage, 8076,
     /*  268662 */     GIR_EraseRootFromParent_Done,
     /*  268663 */   // Label 5088: @268663
     /*  268663 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(268726), // Rule ID 8077 //
     /*  268668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  268682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  268685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268707 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  268707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  268710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268724 */     GIR_RootConstrainSelectedInstOperands,
     /*  268725 */     // GIR_Coverage, 8077,
     /*  268725 */     GIR_EraseRootFromParent_Done,
     /*  268726 */   // Label 5089: @268726
     /*  268726 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(268789), // Rule ID 8080 //
     /*  268731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  268745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  268748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268770 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  268773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268787 */     GIR_RootConstrainSelectedInstOperands,
     /*  268788 */     // GIR_Coverage, 8080,
     /*  268788 */     GIR_EraseRootFromParent_Done,
     /*  268789 */   // Label 5090: @268789
     /*  268789 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(268852), // Rule ID 8081 //
     /*  268794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  268808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  268811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268833 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  268836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268850 */     GIR_RootConstrainSelectedInstOperands,
     /*  268851 */     // GIR_Coverage, 8081,
     /*  268851 */     GIR_EraseRootFromParent_Done,
     /*  268852 */   // Label 5091: @268852
     /*  268852 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(268915), // Rule ID 8084 //
     /*  268857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  268871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  268874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268896 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  268899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268913 */     GIR_RootConstrainSelectedInstOperands,
     /*  268914 */     // GIR_Coverage, 8084,
     /*  268914 */     GIR_EraseRootFromParent_Done,
     /*  268915 */   // Label 5092: @268915
     /*  268915 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(268978), // Rule ID 8085 //
     /*  268920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  268934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  268937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268959 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  268962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268976 */     GIR_RootConstrainSelectedInstOperands,
     /*  268977 */     // GIR_Coverage, 8085,
     /*  268977 */     GIR_EraseRootFromParent_Done,
     /*  268978 */   // Label 5093: @268978
     /*  268978 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(269041), // Rule ID 8088 //
     /*  268983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  268997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  269000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269022 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  269022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  269025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269039 */     GIR_RootConstrainSelectedInstOperands,
     /*  269040 */     // GIR_Coverage, 8088,
     /*  269040 */     GIR_EraseRootFromParent_Done,
     /*  269041 */   // Label 5094: @269041
     /*  269041 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(269104), // Rule ID 8089 //
     /*  269046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  269060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  269063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269085 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  269088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269102 */     GIR_RootConstrainSelectedInstOperands,
     /*  269103 */     // GIR_Coverage, 8089,
     /*  269103 */     GIR_EraseRootFromParent_Done,
     /*  269104 */   // Label 5095: @269104
     /*  269104 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(269167), // Rule ID 8092 //
     /*  269109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  269112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  269123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  269126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269148 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  269148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  269151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269165 */     GIR_RootConstrainSelectedInstOperands,
     /*  269166 */     // GIR_Coverage, 8092,
     /*  269166 */     GIR_EraseRootFromParent_Done,
     /*  269167 */   // Label 5096: @269167
     /*  269167 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(269230), // Rule ID 8093 //
     /*  269172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  269175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  269186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  269189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269211 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  269214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269228 */     GIR_RootConstrainSelectedInstOperands,
     /*  269229 */     // GIR_Coverage, 8093,
     /*  269229 */     GIR_EraseRootFromParent_Done,
     /*  269230 */   // Label 5097: @269230
     /*  269230 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(269293), // Rule ID 8096 //
     /*  269235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  269249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  269252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269274 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  269277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269291 */     GIR_RootConstrainSelectedInstOperands,
     /*  269292 */     // GIR_Coverage, 8096,
     /*  269292 */     GIR_EraseRootFromParent_Done,
     /*  269293 */   // Label 5098: @269293
     /*  269293 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(269356), // Rule ID 8097 //
     /*  269298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  269312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  269315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269337 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  269337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  269340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269354 */     GIR_RootConstrainSelectedInstOperands,
     /*  269355 */     // GIR_Coverage, 8097,
     /*  269355 */     GIR_EraseRootFromParent_Done,
     /*  269356 */   // Label 5099: @269356
     /*  269356 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(269419), // Rule ID 8100 //
     /*  269361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  269372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  269375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  269378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269400 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  269403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269417 */     GIR_RootConstrainSelectedInstOperands,
     /*  269418 */     // GIR_Coverage, 8100,
     /*  269418 */     GIR_EraseRootFromParent_Done,
     /*  269419 */   // Label 5100: @269419
     /*  269419 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(269482), // Rule ID 8101 //
     /*  269424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  269435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  269438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  269441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269463 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  269463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  269466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269480 */     GIR_RootConstrainSelectedInstOperands,
     /*  269481 */     // GIR_Coverage, 8101,
     /*  269481 */     GIR_EraseRootFromParent_Done,
     /*  269482 */   // Label 5101: @269482
     /*  269482 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(269545), // Rule ID 8104 //
     /*  269487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  269498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  269501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  269504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269526 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  269529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269543 */     GIR_RootConstrainSelectedInstOperands,
     /*  269544 */     // GIR_Coverage, 8104,
     /*  269544 */     GIR_EraseRootFromParent_Done,
     /*  269545 */   // Label 5102: @269545
     /*  269545 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(269608), // Rule ID 8105 //
     /*  269550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  269561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  269564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  269567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269589 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  269589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  269592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269606 */     GIR_RootConstrainSelectedInstOperands,
     /*  269607 */     // GIR_Coverage, 8105,
     /*  269607 */     GIR_EraseRootFromParent_Done,
     /*  269608 */   // Label 5103: @269608
     /*  269608 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(269671), // Rule ID 8108 //
     /*  269613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  269627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  269630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269652 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  269655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269669 */     GIR_RootConstrainSelectedInstOperands,
     /*  269670 */     // GIR_Coverage, 8108,
     /*  269670 */     GIR_EraseRootFromParent_Done,
     /*  269671 */   // Label 5104: @269671
     /*  269671 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(269734), // Rule ID 8109 //
     /*  269676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  269690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  269693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269715 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  269718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269732 */     GIR_RootConstrainSelectedInstOperands,
     /*  269733 */     // GIR_Coverage, 8109,
     /*  269733 */     GIR_EraseRootFromParent_Done,
     /*  269734 */   // Label 5105: @269734
     /*  269734 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(269797), // Rule ID 8112 //
     /*  269739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  269753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  269756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269778 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  269781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269795 */     GIR_RootConstrainSelectedInstOperands,
     /*  269796 */     // GIR_Coverage, 8112,
     /*  269796 */     GIR_EraseRootFromParent_Done,
     /*  269797 */   // Label 5106: @269797
     /*  269797 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(269860), // Rule ID 8113 //
     /*  269802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  269816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  269819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269841 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  269844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269858 */     GIR_RootConstrainSelectedInstOperands,
     /*  269859 */     // GIR_Coverage, 8113,
     /*  269859 */     GIR_EraseRootFromParent_Done,
     /*  269860 */   // Label 5107: @269860
     /*  269860 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(269923), // Rule ID 8116 //
     /*  269865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  269876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  269879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  269882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269904 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  269907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269921 */     GIR_RootConstrainSelectedInstOperands,
     /*  269922 */     // GIR_Coverage, 8116,
     /*  269922 */     GIR_EraseRootFromParent_Done,
     /*  269923 */   // Label 5108: @269923
     /*  269923 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(269986), // Rule ID 8117 //
     /*  269928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  269939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  269942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  269945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269967 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  269970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269984 */     GIR_RootConstrainSelectedInstOperands,
     /*  269985 */     // GIR_Coverage, 8117,
     /*  269985 */     GIR_EraseRootFromParent_Done,
     /*  269986 */   // Label 5109: @269986
     /*  269986 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(270049), // Rule ID 8120 //
     /*  269991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  270005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  270008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270030 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  270030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  270033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270047 */     GIR_RootConstrainSelectedInstOperands,
     /*  270048 */     // GIR_Coverage, 8120,
     /*  270048 */     GIR_EraseRootFromParent_Done,
     /*  270049 */   // Label 5110: @270049
     /*  270049 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(270112), // Rule ID 8121 //
     /*  270054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  270068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  270071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270093 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  270093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  270096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270110 */     GIR_RootConstrainSelectedInstOperands,
     /*  270111 */     // GIR_Coverage, 8121,
     /*  270111 */     GIR_EraseRootFromParent_Done,
     /*  270112 */   // Label 5111: @270112
     /*  270112 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(270175), // Rule ID 8124 //
     /*  270117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  270131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  270134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270156 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  270156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  270159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270173 */     GIR_RootConstrainSelectedInstOperands,
     /*  270174 */     // GIR_Coverage, 8124,
     /*  270174 */     GIR_EraseRootFromParent_Done,
     /*  270175 */   // Label 5112: @270175
     /*  270175 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(270238), // Rule ID 8125 //
     /*  270180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  270194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  270197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270219 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  270219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  270222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270236 */     GIR_RootConstrainSelectedInstOperands,
     /*  270237 */     // GIR_Coverage, 8125,
     /*  270237 */     GIR_EraseRootFromParent_Done,
     /*  270238 */   // Label 5113: @270238
     /*  270238 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(270301), // Rule ID 8128 //
     /*  270243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  270254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  270257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  270260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270282 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  270282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  270285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270299 */     GIR_RootConstrainSelectedInstOperands,
     /*  270300 */     // GIR_Coverage, 8128,
     /*  270300 */     GIR_EraseRootFromParent_Done,
     /*  270301 */   // Label 5114: @270301
     /*  270301 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(270364), // Rule ID 8129 //
     /*  270306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  270317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  270320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  270323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270345 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  270345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  270348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270362 */     GIR_RootConstrainSelectedInstOperands,
     /*  270363 */     // GIR_Coverage, 8129,
     /*  270363 */     GIR_EraseRootFromParent_Done,
     /*  270364 */   // Label 5115: @270364
     /*  270364 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(270427), // Rule ID 8132 //
     /*  270369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  270372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  270383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  270386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270408 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  270408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  270411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270425 */     GIR_RootConstrainSelectedInstOperands,
     /*  270426 */     // GIR_Coverage, 8132,
     /*  270426 */     GIR_EraseRootFromParent_Done,
     /*  270427 */   // Label 5116: @270427
     /*  270427 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(270490), // Rule ID 8133 //
     /*  270432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  270435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  270446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  270449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270471 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  270471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  270474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270488 */     GIR_RootConstrainSelectedInstOperands,
     /*  270489 */     // GIR_Coverage, 8133,
     /*  270489 */     GIR_EraseRootFromParent_Done,
     /*  270490 */   // Label 5117: @270490
     /*  270490 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(270553), // Rule ID 8136 //
     /*  270495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  270498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  270509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  270512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270534 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  270534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  270537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270551 */     GIR_RootConstrainSelectedInstOperands,
     /*  270552 */     // GIR_Coverage, 8136,
     /*  270552 */     GIR_EraseRootFromParent_Done,
     /*  270553 */   // Label 5118: @270553
     /*  270553 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(270616), // Rule ID 8137 //
     /*  270558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  270561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  270572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  270575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270597 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  270597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  270600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270614 */     GIR_RootConstrainSelectedInstOperands,
     /*  270615 */     // GIR_Coverage, 8137,
     /*  270615 */     GIR_EraseRootFromParent_Done,
     /*  270616 */   // Label 5119: @270616
     /*  270616 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(270679), // Rule ID 8140 //
     /*  270621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  270624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  270635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  270638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270660 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  270660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  270663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270677 */     GIR_RootConstrainSelectedInstOperands,
     /*  270678 */     // GIR_Coverage, 8140,
     /*  270678 */     GIR_EraseRootFromParent_Done,
     /*  270679 */   // Label 5120: @270679
     /*  270679 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(270742), // Rule ID 8141 //
     /*  270684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  270687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  270698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  270701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270723 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  270723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  270726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270740 */     GIR_RootConstrainSelectedInstOperands,
     /*  270741 */     // GIR_Coverage, 8141,
     /*  270741 */     GIR_EraseRootFromParent_Done,
     /*  270742 */   // Label 5121: @270742
     /*  270742 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(270805), // Rule ID 8144 //
     /*  270747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  270761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  270764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270786 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  270789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270803 */     GIR_RootConstrainSelectedInstOperands,
     /*  270804 */     // GIR_Coverage, 8144,
     /*  270804 */     GIR_EraseRootFromParent_Done,
     /*  270805 */   // Label 5122: @270805
     /*  270805 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(270868), // Rule ID 8145 //
     /*  270810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  270824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  270827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270849 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  270852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270866 */     GIR_RootConstrainSelectedInstOperands,
     /*  270867 */     // GIR_Coverage, 8145,
     /*  270867 */     GIR_EraseRootFromParent_Done,
     /*  270868 */   // Label 5123: @270868
     /*  270868 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(270931), // Rule ID 8148 //
     /*  270873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  270887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  270890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270912 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  270915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270929 */     GIR_RootConstrainSelectedInstOperands,
     /*  270930 */     // GIR_Coverage, 8148,
     /*  270930 */     GIR_EraseRootFromParent_Done,
     /*  270931 */   // Label 5124: @270931
     /*  270931 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(270994), // Rule ID 8149 //
     /*  270936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  270950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  270953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270975 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  270978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270992 */     GIR_RootConstrainSelectedInstOperands,
     /*  270993 */     // GIR_Coverage, 8149,
     /*  270993 */     GIR_EraseRootFromParent_Done,
     /*  270994 */   // Label 5125: @270994
     /*  270994 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(271057), // Rule ID 8152 //
     /*  270999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  271013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271038 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  271041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271055 */     GIR_RootConstrainSelectedInstOperands,
     /*  271056 */     // GIR_Coverage, 8152,
     /*  271056 */     GIR_EraseRootFromParent_Done,
     /*  271057 */   // Label 5126: @271057
     /*  271057 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(271120), // Rule ID 8153 //
     /*  271062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  271076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271101 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  271104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271118 */     GIR_RootConstrainSelectedInstOperands,
     /*  271119 */     // GIR_Coverage, 8153,
     /*  271119 */     GIR_EraseRootFromParent_Done,
     /*  271120 */   // Label 5127: @271120
     /*  271120 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(271183), // Rule ID 8156 //
     /*  271125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  271139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271164 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  271167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271181 */     GIR_RootConstrainSelectedInstOperands,
     /*  271182 */     // GIR_Coverage, 8156,
     /*  271182 */     GIR_EraseRootFromParent_Done,
     /*  271183 */   // Label 5128: @271183
     /*  271183 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(271246), // Rule ID 8157 //
     /*  271188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  271202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271227 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  271230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271244 */     GIR_RootConstrainSelectedInstOperands,
     /*  271245 */     // GIR_Coverage, 8157,
     /*  271245 */     GIR_EraseRootFromParent_Done,
     /*  271246 */   // Label 5129: @271246
     /*  271246 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(271309), // Rule ID 8160 //
     /*  271251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  271265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271290 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  271293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271307 */     GIR_RootConstrainSelectedInstOperands,
     /*  271308 */     // GIR_Coverage, 8160,
     /*  271308 */     GIR_EraseRootFromParent_Done,
     /*  271309 */   // Label 5130: @271309
     /*  271309 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(271372), // Rule ID 8161 //
     /*  271314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  271328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271353 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  271356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271370 */     GIR_RootConstrainSelectedInstOperands,
     /*  271371 */     // GIR_Coverage, 8161,
     /*  271371 */     GIR_EraseRootFromParent_Done,
     /*  271372 */   // Label 5131: @271372
     /*  271372 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(271435), // Rule ID 8164 //
     /*  271377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  271391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271416 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  271419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271433 */     GIR_RootConstrainSelectedInstOperands,
     /*  271434 */     // GIR_Coverage, 8164,
     /*  271434 */     GIR_EraseRootFromParent_Done,
     /*  271435 */   // Label 5132: @271435
     /*  271435 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(271498), // Rule ID 8165 //
     /*  271440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  271454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271479 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  271479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  271482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271496 */     GIR_RootConstrainSelectedInstOperands,
     /*  271497 */     // GIR_Coverage, 8165,
     /*  271497 */     GIR_EraseRootFromParent_Done,
     /*  271498 */   // Label 5133: @271498
     /*  271498 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(271561), // Rule ID 8168 //
     /*  271503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  271517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271542 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271559 */     GIR_RootConstrainSelectedInstOperands,
     /*  271560 */     // GIR_Coverage, 8168,
     /*  271560 */     GIR_EraseRootFromParent_Done,
     /*  271561 */   // Label 5134: @271561
     /*  271561 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(271624), // Rule ID 8169 //
     /*  271566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  271580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271605 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271622 */     GIR_RootConstrainSelectedInstOperands,
     /*  271623 */     // GIR_Coverage, 8169,
     /*  271623 */     GIR_EraseRootFromParent_Done,
     /*  271624 */   // Label 5135: @271624
     /*  271624 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(271687), // Rule ID 8172 //
     /*  271629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  271643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271685 */     GIR_RootConstrainSelectedInstOperands,
     /*  271686 */     // GIR_Coverage, 8172,
     /*  271686 */     GIR_EraseRootFromParent_Done,
     /*  271687 */   // Label 5136: @271687
     /*  271687 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(271750), // Rule ID 8173 //
     /*  271692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  271706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271731 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271748 */     GIR_RootConstrainSelectedInstOperands,
     /*  271749 */     // GIR_Coverage, 8173,
     /*  271749 */     GIR_EraseRootFromParent_Done,
     /*  271750 */   // Label 5137: @271750
     /*  271750 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(271813), // Rule ID 8176 //
     /*  271755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  271769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271794 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271811 */     GIR_RootConstrainSelectedInstOperands,
     /*  271812 */     // GIR_Coverage, 8176,
     /*  271812 */     GIR_EraseRootFromParent_Done,
     /*  271813 */   // Label 5138: @271813
     /*  271813 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(271876), // Rule ID 8177 //
     /*  271818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  271832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271857 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  271857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271874 */     GIR_RootConstrainSelectedInstOperands,
     /*  271875 */     // GIR_Coverage, 8177,
     /*  271875 */     GIR_EraseRootFromParent_Done,
     /*  271876 */   // Label 5139: @271876
     /*  271876 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(271939), // Rule ID 8180 //
     /*  271881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  271884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  271895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271920 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  271920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271937 */     GIR_RootConstrainSelectedInstOperands,
     /*  271938 */     // GIR_Coverage, 8180,
     /*  271938 */     GIR_EraseRootFromParent_Done,
     /*  271939 */   // Label 5140: @271939
     /*  271939 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(272002), // Rule ID 8181 //
     /*  271944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  271947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  271958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271983 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  271983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272000 */     GIR_RootConstrainSelectedInstOperands,
     /*  272001 */     // GIR_Coverage, 8181,
     /*  272001 */     GIR_EraseRootFromParent_Done,
     /*  272002 */   // Label 5141: @272002
     /*  272002 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(272065), // Rule ID 8184 //
     /*  272007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  272021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272046 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  272049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272063 */     GIR_RootConstrainSelectedInstOperands,
     /*  272064 */     // GIR_Coverage, 8184,
     /*  272064 */     GIR_EraseRootFromParent_Done,
     /*  272065 */   // Label 5142: @272065
     /*  272065 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(272128), // Rule ID 8185 //
     /*  272070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  272084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272109 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  272112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272126 */     GIR_RootConstrainSelectedInstOperands,
     /*  272127 */     // GIR_Coverage, 8185,
     /*  272127 */     GIR_EraseRootFromParent_Done,
     /*  272128 */   // Label 5143: @272128
     /*  272128 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(272191), // Rule ID 8188 //
     /*  272133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  272144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  272147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272172 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  272175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272189 */     GIR_RootConstrainSelectedInstOperands,
     /*  272190 */     // GIR_Coverage, 8188,
     /*  272190 */     GIR_EraseRootFromParent_Done,
     /*  272191 */   // Label 5144: @272191
     /*  272191 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(272254), // Rule ID 8189 //
     /*  272196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  272207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  272210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272235 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  272238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272252 */     GIR_RootConstrainSelectedInstOperands,
     /*  272253 */     // GIR_Coverage, 8189,
     /*  272253 */     GIR_EraseRootFromParent_Done,
     /*  272254 */   // Label 5145: @272254
     /*  272254 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(272317), // Rule ID 8192 //
     /*  272259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  272270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  272273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272298 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  272301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272315 */     GIR_RootConstrainSelectedInstOperands,
     /*  272316 */     // GIR_Coverage, 8192,
     /*  272316 */     GIR_EraseRootFromParent_Done,
     /*  272317 */   // Label 5146: @272317
     /*  272317 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(272380), // Rule ID 8193 //
     /*  272322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  272333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  272336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272361 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  272364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272378 */     GIR_RootConstrainSelectedInstOperands,
     /*  272379 */     // GIR_Coverage, 8193,
     /*  272379 */     GIR_EraseRootFromParent_Done,
     /*  272380 */   // Label 5147: @272380
     /*  272380 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(272443), // Rule ID 8196 //
     /*  272385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  272399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272424 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  272427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272441 */     GIR_RootConstrainSelectedInstOperands,
     /*  272442 */     // GIR_Coverage, 8196,
     /*  272442 */     GIR_EraseRootFromParent_Done,
     /*  272443 */   // Label 5148: @272443
     /*  272443 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(272506), // Rule ID 8197 //
     /*  272448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  272462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272487 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  272490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272504 */     GIR_RootConstrainSelectedInstOperands,
     /*  272505 */     // GIR_Coverage, 8197,
     /*  272505 */     GIR_EraseRootFromParent_Done,
     /*  272506 */   // Label 5149: @272506
     /*  272506 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(272569), // Rule ID 8200 //
     /*  272511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  272525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272550 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  272553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272567 */     GIR_RootConstrainSelectedInstOperands,
     /*  272568 */     // GIR_Coverage, 8200,
     /*  272568 */     GIR_EraseRootFromParent_Done,
     /*  272569 */   // Label 5150: @272569
     /*  272569 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(272632), // Rule ID 8201 //
     /*  272574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  272588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272613 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  272616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272630 */     GIR_RootConstrainSelectedInstOperands,
     /*  272631 */     // GIR_Coverage, 8201,
     /*  272631 */     GIR_EraseRootFromParent_Done,
     /*  272632 */   // Label 5151: @272632
     /*  272632 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(272695), // Rule ID 8204 //
     /*  272637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  272648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  272651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272676 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  272679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272693 */     GIR_RootConstrainSelectedInstOperands,
     /*  272694 */     // GIR_Coverage, 8204,
     /*  272694 */     GIR_EraseRootFromParent_Done,
     /*  272695 */   // Label 5152: @272695
     /*  272695 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(272758), // Rule ID 8205 //
     /*  272700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  272711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  272714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272739 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  272742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272756 */     GIR_RootConstrainSelectedInstOperands,
     /*  272757 */     // GIR_Coverage, 8205,
     /*  272757 */     GIR_EraseRootFromParent_Done,
     /*  272758 */   // Label 5153: @272758
     /*  272758 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(272821), // Rule ID 8208 //
     /*  272763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  272777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272802 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  272802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  272805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272819 */     GIR_RootConstrainSelectedInstOperands,
     /*  272820 */     // GIR_Coverage, 8208,
     /*  272820 */     GIR_EraseRootFromParent_Done,
     /*  272821 */   // Label 5154: @272821
     /*  272821 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(272884), // Rule ID 8209 //
     /*  272826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  272840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272865 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  272865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  272868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272882 */     GIR_RootConstrainSelectedInstOperands,
     /*  272883 */     // GIR_Coverage, 8209,
     /*  272883 */     GIR_EraseRootFromParent_Done,
     /*  272884 */   // Label 5155: @272884
     /*  272884 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(272947), // Rule ID 8212 //
     /*  272889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  272903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272928 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  272928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  272931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272945 */     GIR_RootConstrainSelectedInstOperands,
     /*  272946 */     // GIR_Coverage, 8212,
     /*  272946 */     GIR_EraseRootFromParent_Done,
     /*  272947 */   // Label 5156: @272947
     /*  272947 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(273010), // Rule ID 8213 //
     /*  272952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  272966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272991 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  272991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  272994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273008 */     GIR_RootConstrainSelectedInstOperands,
     /*  273009 */     // GIR_Coverage, 8213,
     /*  273009 */     GIR_EraseRootFromParent_Done,
     /*  273010 */   // Label 5157: @273010
     /*  273010 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(273073), // Rule ID 8216 //
     /*  273015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  273026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  273029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273054 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  273054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  273057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273071 */     GIR_RootConstrainSelectedInstOperands,
     /*  273072 */     // GIR_Coverage, 8216,
     /*  273072 */     GIR_EraseRootFromParent_Done,
     /*  273073 */   // Label 5158: @273073
     /*  273073 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(273136), // Rule ID 8217 //
     /*  273078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  273089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  273092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273117 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  273117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  273120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273134 */     GIR_RootConstrainSelectedInstOperands,
     /*  273135 */     // GIR_Coverage, 8217,
     /*  273135 */     GIR_EraseRootFromParent_Done,
     /*  273136 */   // Label 5159: @273136
     /*  273136 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(273199), // Rule ID 8220 //
     /*  273141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  273144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  273155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  273169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273180 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  273180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  273183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273197 */     GIR_RootConstrainSelectedInstOperands,
     /*  273198 */     // GIR_Coverage, 8220,
     /*  273198 */     GIR_EraseRootFromParent_Done,
     /*  273199 */   // Label 5160: @273199
     /*  273199 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(273262), // Rule ID 8221 //
     /*  273204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  273207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  273218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  273232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273243 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  273243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  273246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273260 */     GIR_RootConstrainSelectedInstOperands,
     /*  273261 */     // GIR_Coverage, 8221,
     /*  273261 */     GIR_EraseRootFromParent_Done,
     /*  273262 */   // Label 5161: @273262
     /*  273262 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(273325), // Rule ID 8224 //
     /*  273267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  273270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  273281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273306 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  273306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  273309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273323 */     GIR_RootConstrainSelectedInstOperands,
     /*  273324 */     // GIR_Coverage, 8224,
     /*  273324 */     GIR_EraseRootFromParent_Done,
     /*  273325 */   // Label 5162: @273325
     /*  273325 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(273388), // Rule ID 8225 //
     /*  273330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  273333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  273344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273369 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  273369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  273372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273386 */     GIR_RootConstrainSelectedInstOperands,
     /*  273387 */     // GIR_Coverage, 8225,
     /*  273387 */     GIR_EraseRootFromParent_Done,
     /*  273388 */   // Label 5163: @273388
     /*  273388 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(273451), // Rule ID 8228 //
     /*  273393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  273396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  273407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  273432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  273435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273449 */     GIR_RootConstrainSelectedInstOperands,
     /*  273450 */     // GIR_Coverage, 8228,
     /*  273450 */     GIR_EraseRootFromParent_Done,
     /*  273451 */   // Label 5164: @273451
     /*  273451 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(273514), // Rule ID 8229 //
     /*  273456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  273459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  273470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273495 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  273495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  273498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273512 */     GIR_RootConstrainSelectedInstOperands,
     /*  273513 */     // GIR_Coverage, 8229,
     /*  273513 */     GIR_EraseRootFromParent_Done,
     /*  273514 */   // Label 5165: @273514
     /*  273514 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(273577), // Rule ID 8320 //
     /*  273519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  273533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  273536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273558 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  273561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273575 */     GIR_RootConstrainSelectedInstOperands,
     /*  273576 */     // GIR_Coverage, 8320,
     /*  273576 */     GIR_EraseRootFromParent_Done,
     /*  273577 */   // Label 5166: @273577
     /*  273577 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(273640), // Rule ID 8321 //
     /*  273582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  273596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  273599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273621 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  273624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273638 */     GIR_RootConstrainSelectedInstOperands,
     /*  273639 */     // GIR_Coverage, 8321,
     /*  273639 */     GIR_EraseRootFromParent_Done,
     /*  273640 */   // Label 5167: @273640
     /*  273640 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(273703), // Rule ID 8324 //
     /*  273645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  273659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  273662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273684 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  273687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273701 */     GIR_RootConstrainSelectedInstOperands,
     /*  273702 */     // GIR_Coverage, 8324,
     /*  273702 */     GIR_EraseRootFromParent_Done,
     /*  273703 */   // Label 5168: @273703
     /*  273703 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(273766), // Rule ID 8325 //
     /*  273708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  273722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  273725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273747 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  273750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273764 */     GIR_RootConstrainSelectedInstOperands,
     /*  273765 */     // GIR_Coverage, 8325,
     /*  273765 */     GIR_EraseRootFromParent_Done,
     /*  273766 */   // Label 5169: @273766
     /*  273766 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(273829), // Rule ID 8328 //
     /*  273771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  273785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  273788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273810 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  273813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273827 */     GIR_RootConstrainSelectedInstOperands,
     /*  273828 */     // GIR_Coverage, 8328,
     /*  273828 */     GIR_EraseRootFromParent_Done,
     /*  273829 */   // Label 5170: @273829
     /*  273829 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(273892), // Rule ID 8329 //
     /*  273834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  273848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  273851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273873 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  273876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273890 */     GIR_RootConstrainSelectedInstOperands,
     /*  273891 */     // GIR_Coverage, 8329,
     /*  273891 */     GIR_EraseRootFromParent_Done,
     /*  273892 */   // Label 5171: @273892
     /*  273892 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(273955), // Rule ID 8332 //
     /*  273897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  273911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  273914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273936 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  273939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273953 */     GIR_RootConstrainSelectedInstOperands,
     /*  273954 */     // GIR_Coverage, 8332,
     /*  273954 */     GIR_EraseRootFromParent_Done,
     /*  273955 */   // Label 5172: @273955
     /*  273955 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(274018), // Rule ID 8333 //
     /*  273960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  273974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  273977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273999 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  274002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274016 */     GIR_RootConstrainSelectedInstOperands,
     /*  274017 */     // GIR_Coverage, 8333,
     /*  274017 */     GIR_EraseRootFromParent_Done,
     /*  274018 */   // Label 5173: @274018
     /*  274018 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(274081), // Rule ID 8336 //
     /*  274023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  274037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  274040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274062 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  274065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274079 */     GIR_RootConstrainSelectedInstOperands,
     /*  274080 */     // GIR_Coverage, 8336,
     /*  274080 */     GIR_EraseRootFromParent_Done,
     /*  274081 */   // Label 5174: @274081
     /*  274081 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(274144), // Rule ID 8337 //
     /*  274086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  274100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  274103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274125 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  274128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274142 */     GIR_RootConstrainSelectedInstOperands,
     /*  274143 */     // GIR_Coverage, 8337,
     /*  274143 */     GIR_EraseRootFromParent_Done,
     /*  274144 */   // Label 5175: @274144
     /*  274144 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(274207), // Rule ID 8340 //
     /*  274149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  274163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  274166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274188 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  274191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274205 */     GIR_RootConstrainSelectedInstOperands,
     /*  274206 */     // GIR_Coverage, 8340,
     /*  274206 */     GIR_EraseRootFromParent_Done,
     /*  274207 */   // Label 5176: @274207
     /*  274207 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(274270), // Rule ID 8341 //
     /*  274212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  274226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  274229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274251 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  274254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274268 */     GIR_RootConstrainSelectedInstOperands,
     /*  274269 */     // GIR_Coverage, 8341,
     /*  274269 */     GIR_EraseRootFromParent_Done,
     /*  274270 */   // Label 5177: @274270
     /*  274270 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(274333), // Rule ID 8344 //
     /*  274275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  274289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  274292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274314 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274331 */     GIR_RootConstrainSelectedInstOperands,
     /*  274332 */     // GIR_Coverage, 8344,
     /*  274332 */     GIR_EraseRootFromParent_Done,
     /*  274333 */   // Label 5178: @274333
     /*  274333 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(274396), // Rule ID 8345 //
     /*  274338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  274352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  274355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274377 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274394 */     GIR_RootConstrainSelectedInstOperands,
     /*  274395 */     // GIR_Coverage, 8345,
     /*  274395 */     GIR_EraseRootFromParent_Done,
     /*  274396 */   // Label 5179: @274396
     /*  274396 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(274459), // Rule ID 8348 //
     /*  274401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  274415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  274418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274440 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274457 */     GIR_RootConstrainSelectedInstOperands,
     /*  274458 */     // GIR_Coverage, 8348,
     /*  274458 */     GIR_EraseRootFromParent_Done,
     /*  274459 */   // Label 5180: @274459
     /*  274459 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(274522), // Rule ID 8349 //
     /*  274464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  274478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  274481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274503 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274520 */     GIR_RootConstrainSelectedInstOperands,
     /*  274521 */     // GIR_Coverage, 8349,
     /*  274521 */     GIR_EraseRootFromParent_Done,
     /*  274522 */   // Label 5181: @274522
     /*  274522 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(274585), // Rule ID 8352 //
     /*  274527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  274541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  274544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274566 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274583 */     GIR_RootConstrainSelectedInstOperands,
     /*  274584 */     // GIR_Coverage, 8352,
     /*  274584 */     GIR_EraseRootFromParent_Done,
     /*  274585 */   // Label 5182: @274585
     /*  274585 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(274648), // Rule ID 8353 //
     /*  274590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  274604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  274607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274629 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274646 */     GIR_RootConstrainSelectedInstOperands,
     /*  274647 */     // GIR_Coverage, 8353,
     /*  274647 */     GIR_EraseRootFromParent_Done,
     /*  274648 */   // Label 5183: @274648
     /*  274648 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(274711), // Rule ID 8356 //
     /*  274653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  274656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  274667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  274670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274692 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  274692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274709 */     GIR_RootConstrainSelectedInstOperands,
     /*  274710 */     // GIR_Coverage, 8356,
     /*  274710 */     GIR_EraseRootFromParent_Done,
     /*  274711 */   // Label 5184: @274711
     /*  274711 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(274774), // Rule ID 8357 //
     /*  274716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  274719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  274730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  274733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274755 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  274755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274772 */     GIR_RootConstrainSelectedInstOperands,
     /*  274773 */     // GIR_Coverage, 8357,
     /*  274773 */     GIR_EraseRootFromParent_Done,
     /*  274774 */   // Label 5185: @274774
     /*  274774 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(274837), // Rule ID 8360 //
     /*  274779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  274793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  274796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274818 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  274821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274835 */     GIR_RootConstrainSelectedInstOperands,
     /*  274836 */     // GIR_Coverage, 8360,
     /*  274836 */     GIR_EraseRootFromParent_Done,
     /*  274837 */   // Label 5186: @274837
     /*  274837 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(274900), // Rule ID 8361 //
     /*  274842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  274856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  274859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274881 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  274884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274898 */     GIR_RootConstrainSelectedInstOperands,
     /*  274899 */     // GIR_Coverage, 8361,
     /*  274899 */     GIR_EraseRootFromParent_Done,
     /*  274900 */   // Label 5187: @274900
     /*  274900 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(274963), // Rule ID 8364 //
     /*  274905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  274919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  274922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274944 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  274947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274961 */     GIR_RootConstrainSelectedInstOperands,
     /*  274962 */     // GIR_Coverage, 8364,
     /*  274962 */     GIR_EraseRootFromParent_Done,
     /*  274963 */   // Label 5188: @274963
     /*  274963 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(275026), // Rule ID 8365 //
     /*  274968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  274982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  274985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275007 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  275010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275024 */     GIR_RootConstrainSelectedInstOperands,
     /*  275025 */     // GIR_Coverage, 8365,
     /*  275025 */     GIR_EraseRootFromParent_Done,
     /*  275026 */   // Label 5189: @275026
     /*  275026 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(275089), // Rule ID 8368 //
     /*  275031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  275042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  275045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  275048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275070 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  275073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275087 */     GIR_RootConstrainSelectedInstOperands,
     /*  275088 */     // GIR_Coverage, 8368,
     /*  275088 */     GIR_EraseRootFromParent_Done,
     /*  275089 */   // Label 5190: @275089
     /*  275089 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(275152), // Rule ID 8369 //
     /*  275094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  275105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  275108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  275111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275133 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  275136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275150 */     GIR_RootConstrainSelectedInstOperands,
     /*  275151 */     // GIR_Coverage, 8369,
     /*  275151 */     GIR_EraseRootFromParent_Done,
     /*  275152 */   // Label 5191: @275152
     /*  275152 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(275215), // Rule ID 8372 //
     /*  275157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  275171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  275174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275196 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  275196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  275199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275213 */     GIR_RootConstrainSelectedInstOperands,
     /*  275214 */     // GIR_Coverage, 8372,
     /*  275214 */     GIR_EraseRootFromParent_Done,
     /*  275215 */   // Label 5192: @275215
     /*  275215 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(275278), // Rule ID 8373 //
     /*  275220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  275234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  275237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275259 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  275259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  275262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275276 */     GIR_RootConstrainSelectedInstOperands,
     /*  275277 */     // GIR_Coverage, 8373,
     /*  275277 */     GIR_EraseRootFromParent_Done,
     /*  275278 */   // Label 5193: @275278
     /*  275278 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(275341), // Rule ID 8376 //
     /*  275283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  275294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  275297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  275300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275322 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  275322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  275325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275339 */     GIR_RootConstrainSelectedInstOperands,
     /*  275340 */     // GIR_Coverage, 8376,
     /*  275340 */     GIR_EraseRootFromParent_Done,
     /*  275341 */   // Label 5194: @275341
     /*  275341 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(275404), // Rule ID 8377 //
     /*  275346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  275357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  275360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  275363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275385 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  275385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  275388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275402 */     GIR_RootConstrainSelectedInstOperands,
     /*  275403 */     // GIR_Coverage, 8377,
     /*  275403 */     GIR_EraseRootFromParent_Done,
     /*  275404 */   // Label 5195: @275404
     /*  275404 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(275467), // Rule ID 8380 //
     /*  275409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  275420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  275423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  275426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275448 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  275448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  275451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275465 */     GIR_RootConstrainSelectedInstOperands,
     /*  275466 */     // GIR_Coverage, 8380,
     /*  275466 */     GIR_EraseRootFromParent_Done,
     /*  275467 */   // Label 5196: @275467
     /*  275467 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(275530), // Rule ID 8381 //
     /*  275472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  275483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  275486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  275489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275511 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  275511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  275514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275528 */     GIR_RootConstrainSelectedInstOperands,
     /*  275529 */     // GIR_Coverage, 8381,
     /*  275529 */     GIR_EraseRootFromParent_Done,
     /*  275530 */   // Label 5197: @275530
     /*  275530 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(275593), // Rule ID 8384 //
     /*  275535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  275549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  275552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275574 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  275577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275591 */     GIR_RootConstrainSelectedInstOperands,
     /*  275592 */     // GIR_Coverage, 8384,
     /*  275592 */     GIR_EraseRootFromParent_Done,
     /*  275593 */   // Label 5198: @275593
     /*  275593 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(275656), // Rule ID 8385 //
     /*  275598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  275612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  275615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275637 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  275640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275654 */     GIR_RootConstrainSelectedInstOperands,
     /*  275655 */     // GIR_Coverage, 8385,
     /*  275655 */     GIR_EraseRootFromParent_Done,
     /*  275656 */   // Label 5199: @275656
     /*  275656 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(275719), // Rule ID 8388 //
     /*  275661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  275675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  275678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275700 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  275703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275717 */     GIR_RootConstrainSelectedInstOperands,
     /*  275718 */     // GIR_Coverage, 8388,
     /*  275718 */     GIR_EraseRootFromParent_Done,
     /*  275719 */   // Label 5200: @275719
     /*  275719 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(275782), // Rule ID 8389 //
     /*  275724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  275738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  275741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275763 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  275766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275780 */     GIR_RootConstrainSelectedInstOperands,
     /*  275781 */     // GIR_Coverage, 8389,
     /*  275781 */     GIR_EraseRootFromParent_Done,
     /*  275782 */   // Label 5201: @275782
     /*  275782 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(275845), // Rule ID 8392 //
     /*  275787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  275798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  275801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  275804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275826 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  275829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275843 */     GIR_RootConstrainSelectedInstOperands,
     /*  275844 */     // GIR_Coverage, 8392,
     /*  275844 */     GIR_EraseRootFromParent_Done,
     /*  275845 */   // Label 5202: @275845
     /*  275845 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(275908), // Rule ID 8393 //
     /*  275850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  275861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  275864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  275867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275889 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  275892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275906 */     GIR_RootConstrainSelectedInstOperands,
     /*  275907 */     // GIR_Coverage, 8393,
     /*  275907 */     GIR_EraseRootFromParent_Done,
     /*  275908 */   // Label 5203: @275908
     /*  275908 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(275971), // Rule ID 8396 //
     /*  275913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  275916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  275927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  275930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275952 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  275952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  275955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275969 */     GIR_RootConstrainSelectedInstOperands,
     /*  275970 */     // GIR_Coverage, 8396,
     /*  275970 */     GIR_EraseRootFromParent_Done,
     /*  275971 */   // Label 5204: @275971
     /*  275971 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(276034), // Rule ID 8397 //
     /*  275976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  275979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  275990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  275993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276015 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  276015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  276018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276032 */     GIR_RootConstrainSelectedInstOperands,
     /*  276033 */     // GIR_Coverage, 8397,
     /*  276033 */     GIR_EraseRootFromParent_Done,
     /*  276034 */   // Label 5205: @276034
     /*  276034 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(276097), // Rule ID 8400 //
     /*  276039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  276042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  276053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  276056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276078 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  276078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  276081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276095 */     GIR_RootConstrainSelectedInstOperands,
     /*  276096 */     // GIR_Coverage, 8400,
     /*  276096 */     GIR_EraseRootFromParent_Done,
     /*  276097 */   // Label 5206: @276097
     /*  276097 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(276160), // Rule ID 8401 //
     /*  276102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  276105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  276116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  276119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276141 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  276141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  276144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276158 */     GIR_RootConstrainSelectedInstOperands,
     /*  276159 */     // GIR_Coverage, 8401,
     /*  276159 */     GIR_EraseRootFromParent_Done,
     /*  276160 */   // Label 5207: @276160
     /*  276160 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(276223), // Rule ID 8404 //
     /*  276165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  276168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  276179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  276182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276204 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  276204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  276207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276221 */     GIR_RootConstrainSelectedInstOperands,
     /*  276222 */     // GIR_Coverage, 8404,
     /*  276222 */     GIR_EraseRootFromParent_Done,
     /*  276223 */   // Label 5208: @276223
     /*  276223 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(276286), // Rule ID 8405 //
     /*  276228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  276231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  276242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  276245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276267 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  276267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  276270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276284 */     GIR_RootConstrainSelectedInstOperands,
     /*  276285 */     // GIR_Coverage, 8405,
     /*  276285 */     GIR_EraseRootFromParent_Done,
     /*  276286 */   // Label 5209: @276286
     /*  276286 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(276349), // Rule ID 8408 //
     /*  276291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  276305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  276308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276330 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  276333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276347 */     GIR_RootConstrainSelectedInstOperands,
     /*  276348 */     // GIR_Coverage, 8408,
     /*  276348 */     GIR_EraseRootFromParent_Done,
     /*  276349 */   // Label 5210: @276349
     /*  276349 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(276412), // Rule ID 8409 //
     /*  276354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  276368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  276371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276393 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  276396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276410 */     GIR_RootConstrainSelectedInstOperands,
     /*  276411 */     // GIR_Coverage, 8409,
     /*  276411 */     GIR_EraseRootFromParent_Done,
     /*  276412 */   // Label 5211: @276412
     /*  276412 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(276475), // Rule ID 8412 //
     /*  276417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  276431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  276434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276456 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  276459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276473 */     GIR_RootConstrainSelectedInstOperands,
     /*  276474 */     // GIR_Coverage, 8412,
     /*  276474 */     GIR_EraseRootFromParent_Done,
     /*  276475 */   // Label 5212: @276475
     /*  276475 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(276538), // Rule ID 8413 //
     /*  276480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  276494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  276497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276519 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  276522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276536 */     GIR_RootConstrainSelectedInstOperands,
     /*  276537 */     // GIR_Coverage, 8413,
     /*  276537 */     GIR_EraseRootFromParent_Done,
     /*  276538 */   // Label 5213: @276538
     /*  276538 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(276601), // Rule ID 8416 //
     /*  276543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  276557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  276560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276582 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  276585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276599 */     GIR_RootConstrainSelectedInstOperands,
     /*  276600 */     // GIR_Coverage, 8416,
     /*  276600 */     GIR_EraseRootFromParent_Done,
     /*  276601 */   // Label 5214: @276601
     /*  276601 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(276664), // Rule ID 8417 //
     /*  276606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  276620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  276623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276645 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  276648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276662 */     GIR_RootConstrainSelectedInstOperands,
     /*  276663 */     // GIR_Coverage, 8417,
     /*  276663 */     GIR_EraseRootFromParent_Done,
     /*  276664 */   // Label 5215: @276664
     /*  276664 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(276727), // Rule ID 8420 //
     /*  276669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  276683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  276686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276708 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  276711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276725 */     GIR_RootConstrainSelectedInstOperands,
     /*  276726 */     // GIR_Coverage, 8420,
     /*  276726 */     GIR_EraseRootFromParent_Done,
     /*  276727 */   // Label 5216: @276727
     /*  276727 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(276790), // Rule ID 8421 //
     /*  276732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  276746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  276749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276771 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  276774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276788 */     GIR_RootConstrainSelectedInstOperands,
     /*  276789 */     // GIR_Coverage, 8421,
     /*  276789 */     GIR_EraseRootFromParent_Done,
     /*  276790 */   // Label 5217: @276790
     /*  276790 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(276853), // Rule ID 8424 //
     /*  276795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  276809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  276812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276834 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  276837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276851 */     GIR_RootConstrainSelectedInstOperands,
     /*  276852 */     // GIR_Coverage, 8424,
     /*  276852 */     GIR_EraseRootFromParent_Done,
     /*  276853 */   // Label 5218: @276853
     /*  276853 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(276916), // Rule ID 8425 //
     /*  276858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  276872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  276875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276897 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  276900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276914 */     GIR_RootConstrainSelectedInstOperands,
     /*  276915 */     // GIR_Coverage, 8425,
     /*  276915 */     GIR_EraseRootFromParent_Done,
     /*  276916 */   // Label 5219: @276916
     /*  276916 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(276979), // Rule ID 8428 //
     /*  276921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  276935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  276938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276960 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  276960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  276963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276977 */     GIR_RootConstrainSelectedInstOperands,
     /*  276978 */     // GIR_Coverage, 8428,
     /*  276978 */     GIR_EraseRootFromParent_Done,
     /*  276979 */   // Label 5220: @276979
     /*  276979 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(277042), // Rule ID 8429 //
     /*  276984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  276998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277023 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  277026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277040 */     GIR_RootConstrainSelectedInstOperands,
     /*  277041 */     // GIR_Coverage, 8429,
     /*  277041 */     GIR_EraseRootFromParent_Done,
     /*  277042 */   // Label 5221: @277042
     /*  277042 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(277105), // Rule ID 8432 //
     /*  277047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  277061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277086 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277103 */     GIR_RootConstrainSelectedInstOperands,
     /*  277104 */     // GIR_Coverage, 8432,
     /*  277104 */     GIR_EraseRootFromParent_Done,
     /*  277105 */   // Label 5222: @277105
     /*  277105 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(277168), // Rule ID 8433 //
     /*  277110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  277124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277149 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277166 */     GIR_RootConstrainSelectedInstOperands,
     /*  277167 */     // GIR_Coverage, 8433,
     /*  277167 */     GIR_EraseRootFromParent_Done,
     /*  277168 */   // Label 5223: @277168
     /*  277168 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(277231), // Rule ID 8436 //
     /*  277173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  277187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277212 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277229 */     GIR_RootConstrainSelectedInstOperands,
     /*  277230 */     // GIR_Coverage, 8436,
     /*  277230 */     GIR_EraseRootFromParent_Done,
     /*  277231 */   // Label 5224: @277231
     /*  277231 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(277294), // Rule ID 8437 //
     /*  277236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  277250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277275 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  277275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277292 */     GIR_RootConstrainSelectedInstOperands,
     /*  277293 */     // GIR_Coverage, 8437,
     /*  277293 */     GIR_EraseRootFromParent_Done,
     /*  277294 */   // Label 5225: @277294
     /*  277294 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(277357), // Rule ID 8440 //
     /*  277299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  277310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  277313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277338 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277355 */     GIR_RootConstrainSelectedInstOperands,
     /*  277356 */     // GIR_Coverage, 8440,
     /*  277356 */     GIR_EraseRootFromParent_Done,
     /*  277357 */   // Label 5226: @277357
     /*  277357 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(277420), // Rule ID 8441 //
     /*  277362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  277373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  277376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277401 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277418 */     GIR_RootConstrainSelectedInstOperands,
     /*  277419 */     // GIR_Coverage, 8441,
     /*  277419 */     GIR_EraseRootFromParent_Done,
     /*  277420 */   // Label 5227: @277420
     /*  277420 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(277483), // Rule ID 8444 //
     /*  277425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  277428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  277436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  277439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277464 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  277464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277481 */     GIR_RootConstrainSelectedInstOperands,
     /*  277482 */     // GIR_Coverage, 8444,
     /*  277482 */     GIR_EraseRootFromParent_Done,
     /*  277483 */   // Label 5228: @277483
     /*  277483 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(277546), // Rule ID 8445 //
     /*  277488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  277491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  277499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  277502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277527 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  277527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277544 */     GIR_RootConstrainSelectedInstOperands,
     /*  277545 */     // GIR_Coverage, 8445,
     /*  277545 */     GIR_EraseRootFromParent_Done,
     /*  277546 */   // Label 5229: @277546
     /*  277546 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(277609), // Rule ID 8448 //
     /*  277551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  277565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277590 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  277593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277607 */     GIR_RootConstrainSelectedInstOperands,
     /*  277608 */     // GIR_Coverage, 8448,
     /*  277608 */     GIR_EraseRootFromParent_Done,
     /*  277609 */   // Label 5230: @277609
     /*  277609 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(277672), // Rule ID 8449 //
     /*  277614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  277628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277653 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  277656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277670 */     GIR_RootConstrainSelectedInstOperands,
     /*  277671 */     // GIR_Coverage, 8449,
     /*  277671 */     GIR_EraseRootFromParent_Done,
     /*  277672 */   // Label 5231: @277672
     /*  277672 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(277735), // Rule ID 8452 //
     /*  277677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  277691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277716 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  277719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277733 */     GIR_RootConstrainSelectedInstOperands,
     /*  277734 */     // GIR_Coverage, 8452,
     /*  277734 */     GIR_EraseRootFromParent_Done,
     /*  277735 */   // Label 5232: @277735
     /*  277735 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(277798), // Rule ID 8453 //
     /*  277740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  277754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277779 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  277782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277796 */     GIR_RootConstrainSelectedInstOperands,
     /*  277797 */     // GIR_Coverage, 8453,
     /*  277797 */     GIR_EraseRootFromParent_Done,
     /*  277798 */   // Label 5233: @277798
     /*  277798 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(277861), // Rule ID 8456 //
     /*  277803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  277814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  277817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277842 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  277845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277859 */     GIR_RootConstrainSelectedInstOperands,
     /*  277860 */     // GIR_Coverage, 8456,
     /*  277860 */     GIR_EraseRootFromParent_Done,
     /*  277861 */   // Label 5234: @277861
     /*  277861 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(277924), // Rule ID 8457 //
     /*  277866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  277877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  277880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277905 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  277908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277922 */     GIR_RootConstrainSelectedInstOperands,
     /*  277923 */     // GIR_Coverage, 8457,
     /*  277923 */     GIR_EraseRootFromParent_Done,
     /*  277924 */   // Label 5235: @277924
     /*  277924 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(277987), // Rule ID 8460 //
     /*  277929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  277943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277968 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  277971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277985 */     GIR_RootConstrainSelectedInstOperands,
     /*  277986 */     // GIR_Coverage, 8460,
     /*  277986 */     GIR_EraseRootFromParent_Done,
     /*  277987 */   // Label 5236: @277987
     /*  277987 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(278050), // Rule ID 8461 //
     /*  277992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  278006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278031 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  278034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278048 */     GIR_RootConstrainSelectedInstOperands,
     /*  278049 */     // GIR_Coverage, 8461,
     /*  278049 */     GIR_EraseRootFromParent_Done,
     /*  278050 */   // Label 5237: @278050
     /*  278050 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(278113), // Rule ID 8464 //
     /*  278055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  278066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  278069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278094 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  278097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278111 */     GIR_RootConstrainSelectedInstOperands,
     /*  278112 */     // GIR_Coverage, 8464,
     /*  278112 */     GIR_EraseRootFromParent_Done,
     /*  278113 */   // Label 5238: @278113
     /*  278113 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(278176), // Rule ID 8465 //
     /*  278118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  278129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  278132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278157 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  278160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278174 */     GIR_RootConstrainSelectedInstOperands,
     /*  278175 */     // GIR_Coverage, 8465,
     /*  278175 */     GIR_EraseRootFromParent_Done,
     /*  278176 */   // Label 5239: @278176
     /*  278176 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(278239), // Rule ID 8468 //
     /*  278181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  278192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  278195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278220 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  278223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278237 */     GIR_RootConstrainSelectedInstOperands,
     /*  278238 */     // GIR_Coverage, 8468,
     /*  278238 */     GIR_EraseRootFromParent_Done,
     /*  278239 */   // Label 5240: @278239
     /*  278239 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(278302), // Rule ID 8469 //
     /*  278244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  278255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  278258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278283 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  278286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278300 */     GIR_RootConstrainSelectedInstOperands,
     /*  278301 */     // GIR_Coverage, 8469,
     /*  278301 */     GIR_EraseRootFromParent_Done,
     /*  278302 */   // Label 5241: @278302
     /*  278302 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(278365), // Rule ID 8472 //
     /*  278307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  278321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278346 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  278346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  278349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278363 */     GIR_RootConstrainSelectedInstOperands,
     /*  278364 */     // GIR_Coverage, 8472,
     /*  278364 */     GIR_EraseRootFromParent_Done,
     /*  278365 */   // Label 5242: @278365
     /*  278365 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(278428), // Rule ID 8473 //
     /*  278370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  278384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278409 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  278409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  278412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278426 */     GIR_RootConstrainSelectedInstOperands,
     /*  278427 */     // GIR_Coverage, 8473,
     /*  278427 */     GIR_EraseRootFromParent_Done,
     /*  278428 */   // Label 5243: @278428
     /*  278428 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(278491), // Rule ID 8476 //
     /*  278433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  278447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278472 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  278472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  278475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278489 */     GIR_RootConstrainSelectedInstOperands,
     /*  278490 */     // GIR_Coverage, 8476,
     /*  278490 */     GIR_EraseRootFromParent_Done,
     /*  278491 */   // Label 5244: @278491
     /*  278491 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(278554), // Rule ID 8477 //
     /*  278496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  278510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278535 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  278535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  278538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278552 */     GIR_RootConstrainSelectedInstOperands,
     /*  278553 */     // GIR_Coverage, 8477,
     /*  278553 */     GIR_EraseRootFromParent_Done,
     /*  278554 */   // Label 5245: @278554
     /*  278554 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(278617), // Rule ID 8480 //
     /*  278559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  278570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  278573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278598 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  278598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  278601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278615 */     GIR_RootConstrainSelectedInstOperands,
     /*  278616 */     // GIR_Coverage, 8480,
     /*  278616 */     GIR_EraseRootFromParent_Done,
     /*  278617 */   // Label 5246: @278617
     /*  278617 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(278680), // Rule ID 8481 //
     /*  278622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  278633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  278636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278661 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  278661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  278664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278678 */     GIR_RootConstrainSelectedInstOperands,
     /*  278679 */     // GIR_Coverage, 8481,
     /*  278679 */     GIR_EraseRootFromParent_Done,
     /*  278680 */   // Label 5247: @278680
     /*  278680 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(278743), // Rule ID 8484 //
     /*  278685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  278688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  278699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278724 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  278724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  278727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278741 */     GIR_RootConstrainSelectedInstOperands,
     /*  278742 */     // GIR_Coverage, 8484,
     /*  278742 */     GIR_EraseRootFromParent_Done,
     /*  278743 */   // Label 5248: @278743
     /*  278743 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(278806), // Rule ID 8485 //
     /*  278748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  278751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  278762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278787 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  278787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  278790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278804 */     GIR_RootConstrainSelectedInstOperands,
     /*  278805 */     // GIR_Coverage, 8485,
     /*  278805 */     GIR_EraseRootFromParent_Done,
     /*  278806 */   // Label 5249: @278806
     /*  278806 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(278869), // Rule ID 8488 //
     /*  278811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  278814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  278825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278850 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  278850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  278853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278867 */     GIR_RootConstrainSelectedInstOperands,
     /*  278868 */     // GIR_Coverage, 8488,
     /*  278868 */     GIR_EraseRootFromParent_Done,
     /*  278869 */   // Label 5250: @278869
     /*  278869 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(278932), // Rule ID 8489 //
     /*  278874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  278877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  278888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278913 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  278913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  278916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278930 */     GIR_RootConstrainSelectedInstOperands,
     /*  278931 */     // GIR_Coverage, 8489,
     /*  278931 */     GIR_EraseRootFromParent_Done,
     /*  278932 */   // Label 5251: @278932
     /*  278932 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(278995), // Rule ID 8492 //
     /*  278937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  278940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  278951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278976 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  278976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  278979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278993 */     GIR_RootConstrainSelectedInstOperands,
     /*  278994 */     // GIR_Coverage, 8492,
     /*  278994 */     GIR_EraseRootFromParent_Done,
     /*  278995 */   // Label 5252: @278995
     /*  278995 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(279058), // Rule ID 8493 //
     /*  279000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  279003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  279008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  279014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279039 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  279039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  279042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  279056 */     GIR_RootConstrainSelectedInstOperands,
     /*  279057 */     // GIR_Coverage, 8493,
     /*  279057 */     GIR_EraseRootFromParent_Done,
     /*  279058 */   // Label 5253: @279058
     /*  279058 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(279121), // Rule ID 8496 //
     /*  279063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  279077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  279080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279102 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  279105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279119 */     GIR_RootConstrainSelectedInstOperands,
     /*  279120 */     // GIR_Coverage, 8496,
     /*  279120 */     GIR_EraseRootFromParent_Done,
     /*  279121 */   // Label 5254: @279121
     /*  279121 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(279184), // Rule ID 8497 //
     /*  279126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  279140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  279143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279165 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  279168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279182 */     GIR_RootConstrainSelectedInstOperands,
     /*  279183 */     // GIR_Coverage, 8497,
     /*  279183 */     GIR_EraseRootFromParent_Done,
     /*  279184 */   // Label 5255: @279184
     /*  279184 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(279247), // Rule ID 8500 //
     /*  279189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  279203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  279206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279228 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  279231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279245 */     GIR_RootConstrainSelectedInstOperands,
     /*  279246 */     // GIR_Coverage, 8500,
     /*  279246 */     GIR_EraseRootFromParent_Done,
     /*  279247 */   // Label 5256: @279247
     /*  279247 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(279310), // Rule ID 8501 //
     /*  279252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  279266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  279269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279291 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  279294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279308 */     GIR_RootConstrainSelectedInstOperands,
     /*  279309 */     // GIR_Coverage, 8501,
     /*  279309 */     GIR_EraseRootFromParent_Done,
     /*  279310 */   // Label 5257: @279310
     /*  279310 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(279373), // Rule ID 8504 //
     /*  279315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  279326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  279329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  279332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279354 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  279357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279371 */     GIR_RootConstrainSelectedInstOperands,
     /*  279372 */     // GIR_Coverage, 8504,
     /*  279372 */     GIR_EraseRootFromParent_Done,
     /*  279373 */   // Label 5258: @279373
     /*  279373 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(279436), // Rule ID 8505 //
     /*  279378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  279389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  279392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  279395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279417 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  279420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279434 */     GIR_RootConstrainSelectedInstOperands,
     /*  279435 */     // GIR_Coverage, 8505,
     /*  279435 */     GIR_EraseRootFromParent_Done,
     /*  279436 */   // Label 5259: @279436
     /*  279436 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(279499), // Rule ID 8508 //
     /*  279441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  279455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  279458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279480 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  279483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279497 */     GIR_RootConstrainSelectedInstOperands,
     /*  279498 */     // GIR_Coverage, 8508,
     /*  279498 */     GIR_EraseRootFromParent_Done,
     /*  279499 */   // Label 5260: @279499
     /*  279499 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(279562), // Rule ID 8509 //
     /*  279504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  279518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  279521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279543 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  279546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279560 */     GIR_RootConstrainSelectedInstOperands,
     /*  279561 */     // GIR_Coverage, 8509,
     /*  279561 */     GIR_EraseRootFromParent_Done,
     /*  279562 */   // Label 5261: @279562
     /*  279562 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(279625), // Rule ID 8512 //
     /*  279567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  279581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  279584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279606 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  279609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279623 */     GIR_RootConstrainSelectedInstOperands,
     /*  279624 */     // GIR_Coverage, 8512,
     /*  279624 */     GIR_EraseRootFromParent_Done,
     /*  279625 */   // Label 5262: @279625
     /*  279625 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(279688), // Rule ID 8513 //
     /*  279630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  279644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  279647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279669 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  279672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279686 */     GIR_RootConstrainSelectedInstOperands,
     /*  279687 */     // GIR_Coverage, 8513,
     /*  279687 */     GIR_EraseRootFromParent_Done,
     /*  279688 */   // Label 5263: @279688
     /*  279688 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(279751), // Rule ID 8516 //
     /*  279693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  279707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  279710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279732 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  279732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  279735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279749 */     GIR_RootConstrainSelectedInstOperands,
     /*  279750 */     // GIR_Coverage, 8516,
     /*  279750 */     GIR_EraseRootFromParent_Done,
     /*  279751 */   // Label 5264: @279751
     /*  279751 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(279814), // Rule ID 8517 //
     /*  279756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  279770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  279773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279795 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  279795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  279798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279812 */     GIR_RootConstrainSelectedInstOperands,
     /*  279813 */     // GIR_Coverage, 8517,
     /*  279813 */     GIR_EraseRootFromParent_Done,
     /*  279814 */   // Label 5265: @279814
     /*  279814 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(279877), // Rule ID 8520 //
     /*  279819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  279833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  279836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279858 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  279861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279875 */     GIR_RootConstrainSelectedInstOperands,
     /*  279876 */     // GIR_Coverage, 8520,
     /*  279876 */     GIR_EraseRootFromParent_Done,
     /*  279877 */   // Label 5266: @279877
     /*  279877 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(279940), // Rule ID 8521 //
     /*  279882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  279896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  279899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279921 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  279924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279938 */     GIR_RootConstrainSelectedInstOperands,
     /*  279939 */     // GIR_Coverage, 8521,
     /*  279939 */     GIR_EraseRootFromParent_Done,
     /*  279940 */   // Label 5267: @279940
     /*  279940 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(280003), // Rule ID 8524 //
     /*  279945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  279956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  279959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  279962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279984 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  279987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280001 */     GIR_RootConstrainSelectedInstOperands,
     /*  280002 */     // GIR_Coverage, 8524,
     /*  280002 */     GIR_EraseRootFromParent_Done,
     /*  280003 */   // Label 5268: @280003
     /*  280003 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(280066), // Rule ID 8525 //
     /*  280008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  280022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  280025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280047 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  280050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280064 */     GIR_RootConstrainSelectedInstOperands,
     /*  280065 */     // GIR_Coverage, 8525,
     /*  280065 */     GIR_EraseRootFromParent_Done,
     /*  280066 */   // Label 5269: @280066
     /*  280066 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(280129), // Rule ID 8528 //
     /*  280071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  280085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  280088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280110 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  280113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280127 */     GIR_RootConstrainSelectedInstOperands,
     /*  280128 */     // GIR_Coverage, 8528,
     /*  280128 */     GIR_EraseRootFromParent_Done,
     /*  280129 */   // Label 5270: @280129
     /*  280129 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(280192), // Rule ID 8529 //
     /*  280134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  280148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  280151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280173 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  280176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280190 */     GIR_RootConstrainSelectedInstOperands,
     /*  280191 */     // GIR_Coverage, 8529,
     /*  280191 */     GIR_EraseRootFromParent_Done,
     /*  280192 */   // Label 5271: @280192
     /*  280192 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(280255), // Rule ID 8532 //
     /*  280197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  280211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  280214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280236 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  280236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  280239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280253 */     GIR_RootConstrainSelectedInstOperands,
     /*  280254 */     // GIR_Coverage, 8532,
     /*  280254 */     GIR_EraseRootFromParent_Done,
     /*  280255 */   // Label 5272: @280255
     /*  280255 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(280318), // Rule ID 8533 //
     /*  280260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  280263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  280274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  280277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280299 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  280299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  280302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280316 */     GIR_RootConstrainSelectedInstOperands,
     /*  280317 */     // GIR_Coverage, 8533,
     /*  280317 */     GIR_EraseRootFromParent_Done,
     /*  280318 */   // Label 5273: @280318
     /*  280318 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(280381), // Rule ID 8536 //
     /*  280323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  280337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  280340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280362 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  280365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280379 */     GIR_RootConstrainSelectedInstOperands,
     /*  280380 */     // GIR_Coverage, 8536,
     /*  280380 */     GIR_EraseRootFromParent_Done,
     /*  280381 */   // Label 5274: @280381
     /*  280381 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(280444), // Rule ID 8537 //
     /*  280386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  280400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  280403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280425 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  280428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280442 */     GIR_RootConstrainSelectedInstOperands,
     /*  280443 */     // GIR_Coverage, 8537,
     /*  280443 */     GIR_EraseRootFromParent_Done,
     /*  280444 */   // Label 5275: @280444
     /*  280444 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(280507), // Rule ID 8540 //
     /*  280449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  280460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  280463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  280466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280488 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  280491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280505 */     GIR_RootConstrainSelectedInstOperands,
     /*  280506 */     // GIR_Coverage, 8540,
     /*  280506 */     GIR_EraseRootFromParent_Done,
     /*  280507 */   // Label 5276: @280507
     /*  280507 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(280570), // Rule ID 8541 //
     /*  280512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  280523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  280526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  280529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280551 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  280554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280568 */     GIR_RootConstrainSelectedInstOperands,
     /*  280569 */     // GIR_Coverage, 8541,
     /*  280569 */     GIR_EraseRootFromParent_Done,
     /*  280570 */   // Label 5277: @280570
     /*  280570 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(280633), // Rule ID 8544 //
     /*  280575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  280586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  280589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  280592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280614 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  280617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280631 */     GIR_RootConstrainSelectedInstOperands,
     /*  280632 */     // GIR_Coverage, 8544,
     /*  280632 */     GIR_EraseRootFromParent_Done,
     /*  280633 */   // Label 5278: @280633
     /*  280633 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(280696), // Rule ID 8545 //
     /*  280638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  280649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  280652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  280655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280677 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  280680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280694 */     GIR_RootConstrainSelectedInstOperands,
     /*  280695 */     // GIR_Coverage, 8545,
     /*  280695 */     GIR_EraseRootFromParent_Done,
     /*  280696 */   // Label 5279: @280696
     /*  280696 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(280759), // Rule ID 8548 //
     /*  280701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  280715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  280718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  280743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280757 */     GIR_RootConstrainSelectedInstOperands,
     /*  280758 */     // GIR_Coverage, 8548,
     /*  280758 */     GIR_EraseRootFromParent_Done,
     /*  280759 */   // Label 5280: @280759
     /*  280759 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(280822), // Rule ID 8549 //
     /*  280764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  280778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  280781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280803 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  280806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280820 */     GIR_RootConstrainSelectedInstOperands,
     /*  280821 */     // GIR_Coverage, 8549,
     /*  280821 */     GIR_EraseRootFromParent_Done,
     /*  280822 */   // Label 5281: @280822
     /*  280822 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(280885), // Rule ID 8552 //
     /*  280827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  280841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  280844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280866 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  280869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280883 */     GIR_RootConstrainSelectedInstOperands,
     /*  280884 */     // GIR_Coverage, 8552,
     /*  280884 */     GIR_EraseRootFromParent_Done,
     /*  280885 */   // Label 5282: @280885
     /*  280885 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(280948), // Rule ID 8553 //
     /*  280890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  280904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  280907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280929 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  280932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280946 */     GIR_RootConstrainSelectedInstOperands,
     /*  280947 */     // GIR_Coverage, 8553,
     /*  280947 */     GIR_EraseRootFromParent_Done,
     /*  280948 */   // Label 5283: @280948
     /*  280948 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(281011), // Rule ID 8556 //
     /*  280953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  280964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  280967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  280970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280992 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  280995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281009 */     GIR_RootConstrainSelectedInstOperands,
     /*  281010 */     // GIR_Coverage, 8556,
     /*  281010 */     GIR_EraseRootFromParent_Done,
     /*  281011 */   // Label 5284: @281011
     /*  281011 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(281074), // Rule ID 8557 //
     /*  281016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  281027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  281030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  281033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281055 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  281058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281072 */     GIR_RootConstrainSelectedInstOperands,
     /*  281073 */     // GIR_Coverage, 8557,
     /*  281073 */     GIR_EraseRootFromParent_Done,
     /*  281074 */   // Label 5285: @281074
     /*  281074 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(281137), // Rule ID 8560 //
     /*  281079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  281093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  281096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281118 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  281118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  281121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281135 */     GIR_RootConstrainSelectedInstOperands,
     /*  281136 */     // GIR_Coverage, 8560,
     /*  281136 */     GIR_EraseRootFromParent_Done,
     /*  281137 */   // Label 5286: @281137
     /*  281137 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(281200), // Rule ID 8561 //
     /*  281142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  281156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  281159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281181 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  281181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  281184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281198 */     GIR_RootConstrainSelectedInstOperands,
     /*  281199 */     // GIR_Coverage, 8561,
     /*  281199 */     GIR_EraseRootFromParent_Done,
     /*  281200 */   // Label 5287: @281200
     /*  281200 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(281263), // Rule ID 8564 //
     /*  281205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  281219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  281222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281244 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  281244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  281247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281261 */     GIR_RootConstrainSelectedInstOperands,
     /*  281262 */     // GIR_Coverage, 8564,
     /*  281262 */     GIR_EraseRootFromParent_Done,
     /*  281263 */   // Label 5288: @281263
     /*  281263 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(281326), // Rule ID 8565 //
     /*  281268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  281282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  281285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281307 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  281307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  281310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281324 */     GIR_RootConstrainSelectedInstOperands,
     /*  281325 */     // GIR_Coverage, 8565,
     /*  281325 */     GIR_EraseRootFromParent_Done,
     /*  281326 */   // Label 5289: @281326
     /*  281326 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(281389), // Rule ID 8568 //
     /*  281331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  281342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  281345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  281348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281370 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  281370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  281373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281387 */     GIR_RootConstrainSelectedInstOperands,
     /*  281388 */     // GIR_Coverage, 8568,
     /*  281388 */     GIR_EraseRootFromParent_Done,
     /*  281389 */   // Label 5290: @281389
     /*  281389 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(281452), // Rule ID 8569 //
     /*  281394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  281405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  281408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  281411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281433 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  281433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  281436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281450 */     GIR_RootConstrainSelectedInstOperands,
     /*  281451 */     // GIR_Coverage, 8569,
     /*  281451 */     GIR_EraseRootFromParent_Done,
     /*  281452 */   // Label 5291: @281452
     /*  281452 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(281515), // Rule ID 8572 //
     /*  281457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  281460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  281471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  281474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281496 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  281496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  281499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281513 */     GIR_RootConstrainSelectedInstOperands,
     /*  281514 */     // GIR_Coverage, 8572,
     /*  281514 */     GIR_EraseRootFromParent_Done,
     /*  281515 */   // Label 5292: @281515
     /*  281515 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(281578), // Rule ID 8573 //
     /*  281520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  281523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  281534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  281537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281559 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  281559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  281562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281576 */     GIR_RootConstrainSelectedInstOperands,
     /*  281577 */     // GIR_Coverage, 8573,
     /*  281577 */     GIR_EraseRootFromParent_Done,
     /*  281578 */   // Label 5293: @281578
     /*  281578 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(281641), // Rule ID 8576 //
     /*  281583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  281586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  281597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  281600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281622 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  281622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  281625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281639 */     GIR_RootConstrainSelectedInstOperands,
     /*  281640 */     // GIR_Coverage, 8576,
     /*  281640 */     GIR_EraseRootFromParent_Done,
     /*  281641 */   // Label 5294: @281641
     /*  281641 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(281704), // Rule ID 8577 //
     /*  281646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  281649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  281660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  281663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281685 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  281685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  281688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281702 */     GIR_RootConstrainSelectedInstOperands,
     /*  281703 */     // GIR_Coverage, 8577,
     /*  281703 */     GIR_EraseRootFromParent_Done,
     /*  281704 */   // Label 5295: @281704
     /*  281704 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(281767), // Rule ID 8580 //
     /*  281709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  281712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  281723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  281726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281748 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  281748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  281751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281765 */     GIR_RootConstrainSelectedInstOperands,
     /*  281766 */     // GIR_Coverage, 8580,
     /*  281766 */     GIR_EraseRootFromParent_Done,
     /*  281767 */   // Label 5296: @281767
     /*  281767 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(281830), // Rule ID 8581 //
     /*  281772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  281775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  281786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  281789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281811 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  281811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  281814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281828 */     GIR_RootConstrainSelectedInstOperands,
     /*  281829 */     // GIR_Coverage, 8581,
     /*  281829 */     GIR_EraseRootFromParent_Done,
     /*  281830 */   // Label 5297: @281830
     /*  281830 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(281893), // Rule ID 8584 //
     /*  281835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  281849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  281852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281874 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  281877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281891 */     GIR_RootConstrainSelectedInstOperands,
     /*  281892 */     // GIR_Coverage, 8584,
     /*  281892 */     GIR_EraseRootFromParent_Done,
     /*  281893 */   // Label 5298: @281893
     /*  281893 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(281956), // Rule ID 8585 //
     /*  281898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  281912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  281915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281937 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  281940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281954 */     GIR_RootConstrainSelectedInstOperands,
     /*  281955 */     // GIR_Coverage, 8585,
     /*  281955 */     GIR_EraseRootFromParent_Done,
     /*  281956 */   // Label 5299: @281956
     /*  281956 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(282019), // Rule ID 8588 //
     /*  281961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  281975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  281978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282000 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  282003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282017 */     GIR_RootConstrainSelectedInstOperands,
     /*  282018 */     // GIR_Coverage, 8588,
     /*  282018 */     GIR_EraseRootFromParent_Done,
     /*  282019 */   // Label 5300: @282019
     /*  282019 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(282082), // Rule ID 8589 //
     /*  282024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  282038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282063 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  282066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282080 */     GIR_RootConstrainSelectedInstOperands,
     /*  282081 */     // GIR_Coverage, 8589,
     /*  282081 */     GIR_EraseRootFromParent_Done,
     /*  282082 */   // Label 5301: @282082
     /*  282082 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(282145), // Rule ID 8592 //
     /*  282087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  282101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282126 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  282129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282143 */     GIR_RootConstrainSelectedInstOperands,
     /*  282144 */     // GIR_Coverage, 8592,
     /*  282144 */     GIR_EraseRootFromParent_Done,
     /*  282145 */   // Label 5302: @282145
     /*  282145 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(282208), // Rule ID 8593 //
     /*  282150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  282164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282189 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  282192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282206 */     GIR_RootConstrainSelectedInstOperands,
     /*  282207 */     // GIR_Coverage, 8593,
     /*  282207 */     GIR_EraseRootFromParent_Done,
     /*  282208 */   // Label 5303: @282208
     /*  282208 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(282271), // Rule ID 8596 //
     /*  282213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  282227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282252 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  282255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282269 */     GIR_RootConstrainSelectedInstOperands,
     /*  282270 */     // GIR_Coverage, 8596,
     /*  282270 */     GIR_EraseRootFromParent_Done,
     /*  282271 */   // Label 5304: @282271
     /*  282271 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(282334), // Rule ID 8597 //
     /*  282276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  282290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282315 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  282318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282332 */     GIR_RootConstrainSelectedInstOperands,
     /*  282333 */     // GIR_Coverage, 8597,
     /*  282333 */     GIR_EraseRootFromParent_Done,
     /*  282334 */   // Label 5305: @282334
     /*  282334 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(282397), // Rule ID 8600 //
     /*  282339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  282353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282378 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  282381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282395 */     GIR_RootConstrainSelectedInstOperands,
     /*  282396 */     // GIR_Coverage, 8600,
     /*  282396 */     GIR_EraseRootFromParent_Done,
     /*  282397 */   // Label 5306: @282397
     /*  282397 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(282460), // Rule ID 8601 //
     /*  282402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  282416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282441 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  282444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282458 */     GIR_RootConstrainSelectedInstOperands,
     /*  282459 */     // GIR_Coverage, 8601,
     /*  282459 */     GIR_EraseRootFromParent_Done,
     /*  282460 */   // Label 5307: @282460
     /*  282460 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(282523), // Rule ID 8604 //
     /*  282465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  282479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282504 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  282504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  282507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282521 */     GIR_RootConstrainSelectedInstOperands,
     /*  282522 */     // GIR_Coverage, 8604,
     /*  282522 */     GIR_EraseRootFromParent_Done,
     /*  282523 */   // Label 5308: @282523
     /*  282523 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(282586), // Rule ID 8605 //
     /*  282528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  282542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282567 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  282567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  282570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282584 */     GIR_RootConstrainSelectedInstOperands,
     /*  282585 */     // GIR_Coverage, 8605,
     /*  282585 */     GIR_EraseRootFromParent_Done,
     /*  282586 */   // Label 5309: @282586
     /*  282586 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(282649), // Rule ID 8608 //
     /*  282591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  282605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282630 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  282633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282647 */     GIR_RootConstrainSelectedInstOperands,
     /*  282648 */     // GIR_Coverage, 8608,
     /*  282648 */     GIR_EraseRootFromParent_Done,
     /*  282649 */   // Label 5310: @282649
     /*  282649 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(282712), // Rule ID 8609 //
     /*  282654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  282668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282693 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  282696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282710 */     GIR_RootConstrainSelectedInstOperands,
     /*  282711 */     // GIR_Coverage, 8609,
     /*  282711 */     GIR_EraseRootFromParent_Done,
     /*  282712 */   // Label 5311: @282712
     /*  282712 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(282775), // Rule ID 8612 //
     /*  282717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  282731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282756 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  282759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282773 */     GIR_RootConstrainSelectedInstOperands,
     /*  282774 */     // GIR_Coverage, 8612,
     /*  282774 */     GIR_EraseRootFromParent_Done,
     /*  282775 */   // Label 5312: @282775
     /*  282775 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(282838), // Rule ID 8613 //
     /*  282780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  282794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282819 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  282822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282836 */     GIR_RootConstrainSelectedInstOperands,
     /*  282837 */     // GIR_Coverage, 8613,
     /*  282837 */     GIR_EraseRootFromParent_Done,
     /*  282838 */   // Label 5313: @282838
     /*  282838 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(282901), // Rule ID 8616 //
     /*  282843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  282857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282882 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  282882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  282885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282899 */     GIR_RootConstrainSelectedInstOperands,
     /*  282900 */     // GIR_Coverage, 8616,
     /*  282900 */     GIR_EraseRootFromParent_Done,
     /*  282901 */   // Label 5314: @282901
     /*  282901 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(282964), // Rule ID 8617 //
     /*  282906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  282920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282945 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  282945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  282948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282962 */     GIR_RootConstrainSelectedInstOperands,
     /*  282963 */     // GIR_Coverage, 8617,
     /*  282963 */     GIR_EraseRootFromParent_Done,
     /*  282964 */   // Label 5315: @282964
     /*  282964 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(283027), // Rule ID 8620 //
     /*  282969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  282972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  282983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283008 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  283011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283025 */     GIR_RootConstrainSelectedInstOperands,
     /*  283026 */     // GIR_Coverage, 8620,
     /*  283026 */     GIR_EraseRootFromParent_Done,
     /*  283027 */   // Label 5316: @283027
     /*  283027 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(283090), // Rule ID 8621 //
     /*  283032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  283046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283071 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  283074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283088 */     GIR_RootConstrainSelectedInstOperands,
     /*  283089 */     // GIR_Coverage, 8621,
     /*  283089 */     GIR_EraseRootFromParent_Done,
     /*  283090 */   // Label 5317: @283090
     /*  283090 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(283153), // Rule ID 8624 //
     /*  283095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  283109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283134 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  283137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283151 */     GIR_RootConstrainSelectedInstOperands,
     /*  283152 */     // GIR_Coverage, 8624,
     /*  283152 */     GIR_EraseRootFromParent_Done,
     /*  283153 */   // Label 5318: @283153
     /*  283153 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(283216), // Rule ID 8625 //
     /*  283158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  283172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283197 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  283200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283214 */     GIR_RootConstrainSelectedInstOperands,
     /*  283215 */     // GIR_Coverage, 8625,
     /*  283215 */     GIR_EraseRootFromParent_Done,
     /*  283216 */   // Label 5319: @283216
     /*  283216 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(283279), // Rule ID 8628 //
     /*  283221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  283232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  283235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283260 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  283263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283277 */     GIR_RootConstrainSelectedInstOperands,
     /*  283278 */     // GIR_Coverage, 8628,
     /*  283278 */     GIR_EraseRootFromParent_Done,
     /*  283279 */   // Label 5320: @283279
     /*  283279 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(283342), // Rule ID 8629 //
     /*  283284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  283295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  283298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283323 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  283326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283340 */     GIR_RootConstrainSelectedInstOperands,
     /*  283341 */     // GIR_Coverage, 8629,
     /*  283341 */     GIR_EraseRootFromParent_Done,
     /*  283342 */   // Label 5321: @283342
     /*  283342 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(283405), // Rule ID 8632 //
     /*  283347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  283358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  283361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283386 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  283389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283403 */     GIR_RootConstrainSelectedInstOperands,
     /*  283404 */     // GIR_Coverage, 8632,
     /*  283404 */     GIR_EraseRootFromParent_Done,
     /*  283405 */   // Label 5322: @283405
     /*  283405 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(283468), // Rule ID 8633 //
     /*  283410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  283421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  283424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283449 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  283452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283466 */     GIR_RootConstrainSelectedInstOperands,
     /*  283467 */     // GIR_Coverage, 8633,
     /*  283467 */     GIR_EraseRootFromParent_Done,
     /*  283468 */   // Label 5323: @283468
     /*  283468 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(283531), // Rule ID 8636 //
     /*  283473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  283487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283512 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  283515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283529 */     GIR_RootConstrainSelectedInstOperands,
     /*  283530 */     // GIR_Coverage, 8636,
     /*  283530 */     GIR_EraseRootFromParent_Done,
     /*  283531 */   // Label 5324: @283531
     /*  283531 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(283594), // Rule ID 8637 //
     /*  283536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  283550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283575 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  283575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  283578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283592 */     GIR_RootConstrainSelectedInstOperands,
     /*  283593 */     // GIR_Coverage, 8637,
     /*  283593 */     GIR_EraseRootFromParent_Done,
     /*  283594 */   // Label 5325: @283594
     /*  283594 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(283657), // Rule ID 8640 //
     /*  283599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  283613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283638 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  283641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283655 */     GIR_RootConstrainSelectedInstOperands,
     /*  283656 */     // GIR_Coverage, 8640,
     /*  283656 */     GIR_EraseRootFromParent_Done,
     /*  283657 */   // Label 5326: @283657
     /*  283657 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(283720), // Rule ID 8641 //
     /*  283662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  283676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283701 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  283701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  283704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283718 */     GIR_RootConstrainSelectedInstOperands,
     /*  283719 */     // GIR_Coverage, 8641,
     /*  283719 */     GIR_EraseRootFromParent_Done,
     /*  283720 */   // Label 5327: @283720
     /*  283720 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(283783), // Rule ID 8644 //
     /*  283725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  283736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  283739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283764 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  283767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283781 */     GIR_RootConstrainSelectedInstOperands,
     /*  283782 */     // GIR_Coverage, 8644,
     /*  283782 */     GIR_EraseRootFromParent_Done,
     /*  283783 */   // Label 5328: @283783
     /*  283783 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(283846), // Rule ID 8645 //
     /*  283788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  283799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  283802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283827 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  283827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  283830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283844 */     GIR_RootConstrainSelectedInstOperands,
     /*  283845 */     // GIR_Coverage, 8645,
     /*  283845 */     GIR_EraseRootFromParent_Done,
     /*  283846 */   // Label 5329: @283846
     /*  283846 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(283909), // Rule ID 8648 //
     /*  283851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  283865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283890 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  283890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  283893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283907 */     GIR_RootConstrainSelectedInstOperands,
     /*  283908 */     // GIR_Coverage, 8648,
     /*  283908 */     GIR_EraseRootFromParent_Done,
     /*  283909 */   // Label 5330: @283909
     /*  283909 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(283972), // Rule ID 8649 //
     /*  283914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  283928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283953 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  283953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  283956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283970 */     GIR_RootConstrainSelectedInstOperands,
     /*  283971 */     // GIR_Coverage, 8649,
     /*  283971 */     GIR_EraseRootFromParent_Done,
     /*  283972 */   // Label 5331: @283972
     /*  283972 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(284035), // Rule ID 8652 //
     /*  283977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  283991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284016 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  284016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  284019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284033 */     GIR_RootConstrainSelectedInstOperands,
     /*  284034 */     // GIR_Coverage, 8652,
     /*  284034 */     GIR_EraseRootFromParent_Done,
     /*  284035 */   // Label 5332: @284035
     /*  284035 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(284098), // Rule ID 8653 //
     /*  284040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  284054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284079 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  284079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  284082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284096 */     GIR_RootConstrainSelectedInstOperands,
     /*  284097 */     // GIR_Coverage, 8653,
     /*  284097 */     GIR_EraseRootFromParent_Done,
     /*  284098 */   // Label 5333: @284098
     /*  284098 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(284161), // Rule ID 8656 //
     /*  284103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  284114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  284117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284142 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  284142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  284145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284159 */     GIR_RootConstrainSelectedInstOperands,
     /*  284160 */     // GIR_Coverage, 8656,
     /*  284160 */     GIR_EraseRootFromParent_Done,
     /*  284161 */   // Label 5334: @284161
     /*  284161 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(284224), // Rule ID 8657 //
     /*  284166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  284177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  284180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284205 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  284205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  284208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284222 */     GIR_RootConstrainSelectedInstOperands,
     /*  284223 */     // GIR_Coverage, 8657,
     /*  284223 */     GIR_EraseRootFromParent_Done,
     /*  284224 */   // Label 5335: @284224
     /*  284224 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(284287), // Rule ID 8660 //
     /*  284229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  284232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  284243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284268 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  284268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  284271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284285 */     GIR_RootConstrainSelectedInstOperands,
     /*  284286 */     // GIR_Coverage, 8660,
     /*  284286 */     GIR_EraseRootFromParent_Done,
     /*  284287 */   // Label 5336: @284287
     /*  284287 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(284350), // Rule ID 8661 //
     /*  284292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  284295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  284306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284331 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  284331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  284334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284348 */     GIR_RootConstrainSelectedInstOperands,
     /*  284349 */     // GIR_Coverage, 8661,
     /*  284349 */     GIR_EraseRootFromParent_Done,
     /*  284350 */   // Label 5337: @284350
     /*  284350 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(284413), // Rule ID 8664 //
     /*  284355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  284358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  284369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284394 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  284394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  284397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284411 */     GIR_RootConstrainSelectedInstOperands,
     /*  284412 */     // GIR_Coverage, 8664,
     /*  284412 */     GIR_EraseRootFromParent_Done,
     /*  284413 */   // Label 5338: @284413
     /*  284413 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(284476), // Rule ID 8665 //
     /*  284418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  284421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  284432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284457 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  284457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  284460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284474 */     GIR_RootConstrainSelectedInstOperands,
     /*  284475 */     // GIR_Coverage, 8665,
     /*  284475 */     GIR_EraseRootFromParent_Done,
     /*  284476 */   // Label 5339: @284476
     /*  284476 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(284539), // Rule ID 8668 //
     /*  284481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  284484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  284495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284520 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  284520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  284523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284537 */     GIR_RootConstrainSelectedInstOperands,
     /*  284538 */     // GIR_Coverage, 8668,
     /*  284538 */     GIR_EraseRootFromParent_Done,
     /*  284539 */   // Label 5340: @284539
     /*  284539 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(284602), // Rule ID 8669 //
     /*  284544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  284547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  284558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284583 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  284583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  284586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284600 */     GIR_RootConstrainSelectedInstOperands,
     /*  284601 */     // GIR_Coverage, 8669,
     /*  284601 */     GIR_EraseRootFromParent_Done,
     /*  284602 */   // Label 5341: @284602
     /*  284602 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(284665), // Rule ID 8672 //
     /*  284607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  284621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  284624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284646 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  284649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284663 */     GIR_RootConstrainSelectedInstOperands,
     /*  284664 */     // GIR_Coverage, 8672,
     /*  284664 */     GIR_EraseRootFromParent_Done,
     /*  284665 */   // Label 5342: @284665
     /*  284665 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(284728), // Rule ID 8673 //
     /*  284670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  284684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  284687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284709 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  284712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284726 */     GIR_RootConstrainSelectedInstOperands,
     /*  284727 */     // GIR_Coverage, 8673,
     /*  284727 */     GIR_EraseRootFromParent_Done,
     /*  284728 */   // Label 5343: @284728
     /*  284728 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(284791), // Rule ID 8676 //
     /*  284733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  284747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  284750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284772 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  284775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284789 */     GIR_RootConstrainSelectedInstOperands,
     /*  284790 */     // GIR_Coverage, 8676,
     /*  284790 */     GIR_EraseRootFromParent_Done,
     /*  284791 */   // Label 5344: @284791
     /*  284791 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(284854), // Rule ID 8677 //
     /*  284796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  284810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  284813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284835 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  284838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284852 */     GIR_RootConstrainSelectedInstOperands,
     /*  284853 */     // GIR_Coverage, 8677,
     /*  284853 */     GIR_EraseRootFromParent_Done,
     /*  284854 */   // Label 5345: @284854
     /*  284854 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(284917), // Rule ID 8680 //
     /*  284859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  284873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  284876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284898 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  284901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284915 */     GIR_RootConstrainSelectedInstOperands,
     /*  284916 */     // GIR_Coverage, 8680,
     /*  284916 */     GIR_EraseRootFromParent_Done,
     /*  284917 */   // Label 5346: @284917
     /*  284917 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(284980), // Rule ID 8681 //
     /*  284922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  284936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  284939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284961 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  284964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284978 */     GIR_RootConstrainSelectedInstOperands,
     /*  284979 */     // GIR_Coverage, 8681,
     /*  284979 */     GIR_EraseRootFromParent_Done,
     /*  284980 */   // Label 5347: @284980
     /*  284980 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(285043), // Rule ID 8684 //
     /*  284985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  284999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  285002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  285027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285041 */     GIR_RootConstrainSelectedInstOperands,
     /*  285042 */     // GIR_Coverage, 8684,
     /*  285042 */     GIR_EraseRootFromParent_Done,
     /*  285043 */   // Label 5348: @285043
     /*  285043 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(285106), // Rule ID 8685 //
     /*  285048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  285062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  285065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285087 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  285090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285104 */     GIR_RootConstrainSelectedInstOperands,
     /*  285105 */     // GIR_Coverage, 8685,
     /*  285105 */     GIR_EraseRootFromParent_Done,
     /*  285106 */   // Label 5349: @285106
     /*  285106 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(285169), // Rule ID 8688 //
     /*  285111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  285125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  285128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285150 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  285153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285167 */     GIR_RootConstrainSelectedInstOperands,
     /*  285168 */     // GIR_Coverage, 8688,
     /*  285168 */     GIR_EraseRootFromParent_Done,
     /*  285169 */   // Label 5350: @285169
     /*  285169 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(285232), // Rule ID 8689 //
     /*  285174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  285188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  285191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285213 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  285216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285230 */     GIR_RootConstrainSelectedInstOperands,
     /*  285231 */     // GIR_Coverage, 8689,
     /*  285231 */     GIR_EraseRootFromParent_Done,
     /*  285232 */   // Label 5351: @285232
     /*  285232 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(285295), // Rule ID 8692 //
     /*  285237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  285251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  285254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285276 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  285279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285293 */     GIR_RootConstrainSelectedInstOperands,
     /*  285294 */     // GIR_Coverage, 8692,
     /*  285294 */     GIR_EraseRootFromParent_Done,
     /*  285295 */   // Label 5352: @285295
     /*  285295 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(285358), // Rule ID 8693 //
     /*  285300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  285314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  285317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285339 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  285342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285356 */     GIR_RootConstrainSelectedInstOperands,
     /*  285357 */     // GIR_Coverage, 8693,
     /*  285357 */     GIR_EraseRootFromParent_Done,
     /*  285358 */   // Label 5353: @285358
     /*  285358 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(285421), // Rule ID 8696 //
     /*  285363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  285377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  285380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285402 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285419 */     GIR_RootConstrainSelectedInstOperands,
     /*  285420 */     // GIR_Coverage, 8696,
     /*  285420 */     GIR_EraseRootFromParent_Done,
     /*  285421 */   // Label 5354: @285421
     /*  285421 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(285484), // Rule ID 8697 //
     /*  285426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  285440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  285443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285465 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285482 */     GIR_RootConstrainSelectedInstOperands,
     /*  285483 */     // GIR_Coverage, 8697,
     /*  285483 */     GIR_EraseRootFromParent_Done,
     /*  285484 */   // Label 5355: @285484
     /*  285484 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(285547), // Rule ID 8700 //
     /*  285489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  285500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  285503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  285506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285528 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285545 */     GIR_RootConstrainSelectedInstOperands,
     /*  285546 */     // GIR_Coverage, 8700,
     /*  285546 */     GIR_EraseRootFromParent_Done,
     /*  285547 */   // Label 5356: @285547
     /*  285547 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(285610), // Rule ID 8701 //
     /*  285552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  285563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  285566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  285569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285591 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285608 */     GIR_RootConstrainSelectedInstOperands,
     /*  285609 */     // GIR_Coverage, 8701,
     /*  285609 */     GIR_EraseRootFromParent_Done,
     /*  285610 */   // Label 5357: @285610
     /*  285610 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(285673), // Rule ID 8704 //
     /*  285615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  285629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  285632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285654 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285671 */     GIR_RootConstrainSelectedInstOperands,
     /*  285672 */     // GIR_Coverage, 8704,
     /*  285672 */     GIR_EraseRootFromParent_Done,
     /*  285673 */   // Label 5358: @285673
     /*  285673 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(285736), // Rule ID 8705 //
     /*  285678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  285692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  285695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285717 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285734 */     GIR_RootConstrainSelectedInstOperands,
     /*  285735 */     // GIR_Coverage, 8705,
     /*  285735 */     GIR_EraseRootFromParent_Done,
     /*  285736 */   // Label 5359: @285736
     /*  285736 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(285799), // Rule ID 8708 //
     /*  285741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  285744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  285755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  285758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285780 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  285780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285797 */     GIR_RootConstrainSelectedInstOperands,
     /*  285798 */     // GIR_Coverage, 8708,
     /*  285798 */     GIR_EraseRootFromParent_Done,
     /*  285799 */   // Label 5360: @285799
     /*  285799 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(285862), // Rule ID 8709 //
     /*  285804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  285807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  285818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  285821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285843 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  285843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285860 */     GIR_RootConstrainSelectedInstOperands,
     /*  285861 */     // GIR_Coverage, 8709,
     /*  285861 */     GIR_EraseRootFromParent_Done,
     /*  285862 */   // Label 5361: @285862
     /*  285862 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(285925), // Rule ID 8712 //
     /*  285867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  285881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  285884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285906 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  285909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285923 */     GIR_RootConstrainSelectedInstOperands,
     /*  285924 */     // GIR_Coverage, 8712,
     /*  285924 */     GIR_EraseRootFromParent_Done,
     /*  285925 */   // Label 5362: @285925
     /*  285925 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(285988), // Rule ID 8713 //
     /*  285930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  285944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  285947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285969 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  285972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285986 */     GIR_RootConstrainSelectedInstOperands,
     /*  285987 */     // GIR_Coverage, 8713,
     /*  285987 */     GIR_EraseRootFromParent_Done,
     /*  285988 */   // Label 5363: @285988
     /*  285988 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(286051), // Rule ID 8716 //
     /*  285993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  286004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  286007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  286010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286032 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  286035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286049 */     GIR_RootConstrainSelectedInstOperands,
     /*  286050 */     // GIR_Coverage, 8716,
     /*  286050 */     GIR_EraseRootFromParent_Done,
     /*  286051 */   // Label 5364: @286051
     /*  286051 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(286114), // Rule ID 8717 //
     /*  286056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  286067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  286070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  286073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286095 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  286098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286112 */     GIR_RootConstrainSelectedInstOperands,
     /*  286113 */     // GIR_Coverage, 8717,
     /*  286113 */     GIR_EraseRootFromParent_Done,
     /*  286114 */   // Label 5365: @286114
     /*  286114 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(286177), // Rule ID 8720 //
     /*  286119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  286130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  286133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  286136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286158 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  286161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286175 */     GIR_RootConstrainSelectedInstOperands,
     /*  286176 */     // GIR_Coverage, 8720,
     /*  286176 */     GIR_EraseRootFromParent_Done,
     /*  286177 */   // Label 5366: @286177
     /*  286177 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(286240), // Rule ID 8721 //
     /*  286182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  286193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  286196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  286199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286221 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  286224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286238 */     GIR_RootConstrainSelectedInstOperands,
     /*  286239 */     // GIR_Coverage, 8721,
     /*  286239 */     GIR_EraseRootFromParent_Done,
     /*  286240 */   // Label 5367: @286240
     /*  286240 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(286303), // Rule ID 8724 //
     /*  286245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  286259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  286262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286284 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  286284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  286287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286301 */     GIR_RootConstrainSelectedInstOperands,
     /*  286302 */     // GIR_Coverage, 8724,
     /*  286302 */     GIR_EraseRootFromParent_Done,
     /*  286303 */   // Label 5368: @286303
     /*  286303 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(286366), // Rule ID 8725 //
     /*  286308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  286322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  286325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286347 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  286350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286364 */     GIR_RootConstrainSelectedInstOperands,
     /*  286365 */     // GIR_Coverage, 8725,
     /*  286365 */     GIR_EraseRootFromParent_Done,
     /*  286366 */   // Label 5369: @286366
     /*  286366 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(286429), // Rule ID 8728 //
     /*  286371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  286382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  286385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  286388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286410 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  286410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  286413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286427 */     GIR_RootConstrainSelectedInstOperands,
     /*  286428 */     // GIR_Coverage, 8728,
     /*  286428 */     GIR_EraseRootFromParent_Done,
     /*  286429 */   // Label 5370: @286429
     /*  286429 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(286492), // Rule ID 8729 //
     /*  286434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  286445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  286448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  286451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286473 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  286476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286490 */     GIR_RootConstrainSelectedInstOperands,
     /*  286491 */     // GIR_Coverage, 8729,
     /*  286491 */     GIR_EraseRootFromParent_Done,
     /*  286492 */   // Label 5371: @286492
     /*  286492 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(286555), // Rule ID 8732 //
     /*  286497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  286508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  286511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  286514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286536 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  286536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  286539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286553 */     GIR_RootConstrainSelectedInstOperands,
     /*  286554 */     // GIR_Coverage, 8732,
     /*  286554 */     GIR_EraseRootFromParent_Done,
     /*  286555 */   // Label 5372: @286555
     /*  286555 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(286618), // Rule ID 8733 //
     /*  286560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  286571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  286574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  286577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286599 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  286602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286616 */     GIR_RootConstrainSelectedInstOperands,
     /*  286617 */     // GIR_Coverage, 8733,
     /*  286617 */     GIR_EraseRootFromParent_Done,
     /*  286618 */   // Label 5373: @286618
     /*  286618 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(286681), // Rule ID 8736 //
     /*  286623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  286637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  286640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286662 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  286665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286679 */     GIR_RootConstrainSelectedInstOperands,
     /*  286680 */     // GIR_Coverage, 8736,
     /*  286680 */     GIR_EraseRootFromParent_Done,
     /*  286681 */   // Label 5374: @286681
     /*  286681 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(286744), // Rule ID 8737 //
     /*  286686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  286700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  286703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286725 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  286728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286742 */     GIR_RootConstrainSelectedInstOperands,
     /*  286743 */     // GIR_Coverage, 8737,
     /*  286743 */     GIR_EraseRootFromParent_Done,
     /*  286744 */   // Label 5375: @286744
     /*  286744 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(286807), // Rule ID 8740 //
     /*  286749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  286763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  286766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286788 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  286791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286805 */     GIR_RootConstrainSelectedInstOperands,
     /*  286806 */     // GIR_Coverage, 8740,
     /*  286806 */     GIR_EraseRootFromParent_Done,
     /*  286807 */   // Label 5376: @286807
     /*  286807 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(286870), // Rule ID 8741 //
     /*  286812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  286826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  286829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286851 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  286854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286868 */     GIR_RootConstrainSelectedInstOperands,
     /*  286869 */     // GIR_Coverage, 8741,
     /*  286869 */     GIR_EraseRootFromParent_Done,
     /*  286870 */   // Label 5377: @286870
     /*  286870 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(286933), // Rule ID 8744 //
     /*  286875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  286886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  286889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  286892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286914 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  286917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286931 */     GIR_RootConstrainSelectedInstOperands,
     /*  286932 */     // GIR_Coverage, 8744,
     /*  286932 */     GIR_EraseRootFromParent_Done,
     /*  286933 */   // Label 5378: @286933
     /*  286933 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(286996), // Rule ID 8745 //
     /*  286938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  286949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  286952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  286955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286977 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  286980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286994 */     GIR_RootConstrainSelectedInstOperands,
     /*  286995 */     // GIR_Coverage, 8745,
     /*  286995 */     GIR_EraseRootFromParent_Done,
     /*  286996 */   // Label 5379: @286996
     /*  286996 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(287059), // Rule ID 8748 //
     /*  287001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  287004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  287015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  287018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287040 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  287040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  287043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287057 */     GIR_RootConstrainSelectedInstOperands,
     /*  287058 */     // GIR_Coverage, 8748,
     /*  287058 */     GIR_EraseRootFromParent_Done,
     /*  287059 */   // Label 5380: @287059
     /*  287059 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(287122), // Rule ID 8749 //
     /*  287064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  287067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  287078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  287081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287103 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  287103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  287106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287120 */     GIR_RootConstrainSelectedInstOperands,
     /*  287121 */     // GIR_Coverage, 8749,
     /*  287121 */     GIR_EraseRootFromParent_Done,
     /*  287122 */   // Label 5381: @287122
     /*  287122 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(287185), // Rule ID 8752 //
     /*  287127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  287130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  287141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  287144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287166 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  287166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  287169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287183 */     GIR_RootConstrainSelectedInstOperands,
     /*  287184 */     // GIR_Coverage, 8752,
     /*  287184 */     GIR_EraseRootFromParent_Done,
     /*  287185 */   // Label 5382: @287185
     /*  287185 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(287248), // Rule ID 8753 //
     /*  287190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  287193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  287204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  287207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287229 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  287229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  287232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287246 */     GIR_RootConstrainSelectedInstOperands,
     /*  287247 */     // GIR_Coverage, 8753,
     /*  287247 */     GIR_EraseRootFromParent_Done,
     /*  287248 */   // Label 5383: @287248
     /*  287248 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(287311), // Rule ID 8756 //
     /*  287253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  287256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  287267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  287270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287292 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  287292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  287295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287309 */     GIR_RootConstrainSelectedInstOperands,
     /*  287310 */     // GIR_Coverage, 8756,
     /*  287310 */     GIR_EraseRootFromParent_Done,
     /*  287311 */   // Label 5384: @287311
     /*  287311 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(287374), // Rule ID 8757 //
     /*  287316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  287319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  287330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  287333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287355 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  287355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  287358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287372 */     GIR_RootConstrainSelectedInstOperands,
     /*  287373 */     // GIR_Coverage, 8757,
     /*  287373 */     GIR_EraseRootFromParent_Done,
     /*  287374 */   // Label 5385: @287374
     /*  287374 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(287437), // Rule ID 8760 //
     /*  287379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  287393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  287396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287418 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  287421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287435 */     GIR_RootConstrainSelectedInstOperands,
     /*  287436 */     // GIR_Coverage, 8760,
     /*  287436 */     GIR_EraseRootFromParent_Done,
     /*  287437 */   // Label 5386: @287437
     /*  287437 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(287500), // Rule ID 8761 //
     /*  287442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  287456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  287459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287481 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  287484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287498 */     GIR_RootConstrainSelectedInstOperands,
     /*  287499 */     // GIR_Coverage, 8761,
     /*  287499 */     GIR_EraseRootFromParent_Done,
     /*  287500 */   // Label 5387: @287500
     /*  287500 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(287563), // Rule ID 8764 //
     /*  287505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  287519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  287522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  287547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287561 */     GIR_RootConstrainSelectedInstOperands,
     /*  287562 */     // GIR_Coverage, 8764,
     /*  287562 */     GIR_EraseRootFromParent_Done,
     /*  287563 */   // Label 5388: @287563
     /*  287563 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(287626), // Rule ID 8765 //
     /*  287568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  287582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  287585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287607 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  287610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287624 */     GIR_RootConstrainSelectedInstOperands,
     /*  287625 */     // GIR_Coverage, 8765,
     /*  287625 */     GIR_EraseRootFromParent_Done,
     /*  287626 */   // Label 5389: @287626
     /*  287626 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(287689), // Rule ID 8768 //
     /*  287631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  287645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  287648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287670 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  287673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287687 */     GIR_RootConstrainSelectedInstOperands,
     /*  287688 */     // GIR_Coverage, 8768,
     /*  287688 */     GIR_EraseRootFromParent_Done,
     /*  287689 */   // Label 5390: @287689
     /*  287689 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(287752), // Rule ID 8769 //
     /*  287694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  287708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  287711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287733 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  287736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287750 */     GIR_RootConstrainSelectedInstOperands,
     /*  287751 */     // GIR_Coverage, 8769,
     /*  287751 */     GIR_EraseRootFromParent_Done,
     /*  287752 */   // Label 5391: @287752
     /*  287752 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(287815), // Rule ID 8772 //
     /*  287757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  287771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  287774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287796 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  287799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287813 */     GIR_RootConstrainSelectedInstOperands,
     /*  287814 */     // GIR_Coverage, 8772,
     /*  287814 */     GIR_EraseRootFromParent_Done,
     /*  287815 */   // Label 5392: @287815
     /*  287815 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(287878), // Rule ID 8773 //
     /*  287820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  287834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  287837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287859 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  287862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287876 */     GIR_RootConstrainSelectedInstOperands,
     /*  287877 */     // GIR_Coverage, 8773,
     /*  287877 */     GIR_EraseRootFromParent_Done,
     /*  287878 */   // Label 5393: @287878
     /*  287878 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(287941), // Rule ID 8776 //
     /*  287883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  287897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  287900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287922 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  287925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287939 */     GIR_RootConstrainSelectedInstOperands,
     /*  287940 */     // GIR_Coverage, 8776,
     /*  287940 */     GIR_EraseRootFromParent_Done,
     /*  287941 */   // Label 5394: @287941
     /*  287941 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(288004), // Rule ID 8777 //
     /*  287946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  287960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  287963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287985 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  287988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288002 */     GIR_RootConstrainSelectedInstOperands,
     /*  288003 */     // GIR_Coverage, 8777,
     /*  288003 */     GIR_EraseRootFromParent_Done,
     /*  288004 */   // Label 5395: @288004
     /*  288004 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(288067), // Rule ID 8780 //
     /*  288009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  288020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  288023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288048 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  288051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288065 */     GIR_RootConstrainSelectedInstOperands,
     /*  288066 */     // GIR_Coverage, 8780,
     /*  288066 */     GIR_EraseRootFromParent_Done,
     /*  288067 */   // Label 5396: @288067
     /*  288067 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(288130), // Rule ID 8781 //
     /*  288072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  288083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  288086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288111 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  288114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288128 */     GIR_RootConstrainSelectedInstOperands,
     /*  288129 */     // GIR_Coverage, 8781,
     /*  288129 */     GIR_EraseRootFromParent_Done,
     /*  288130 */   // Label 5397: @288130
     /*  288130 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(288193), // Rule ID 8784 //
     /*  288135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  288149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288174 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288191 */     GIR_RootConstrainSelectedInstOperands,
     /*  288192 */     // GIR_Coverage, 8784,
     /*  288192 */     GIR_EraseRootFromParent_Done,
     /*  288193 */   // Label 5398: @288193
     /*  288193 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(288256), // Rule ID 8785 //
     /*  288198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  288212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288237 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288254 */     GIR_RootConstrainSelectedInstOperands,
     /*  288255 */     // GIR_Coverage, 8785,
     /*  288255 */     GIR_EraseRootFromParent_Done,
     /*  288256 */   // Label 5399: @288256
     /*  288256 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(288319), // Rule ID 8788 //
     /*  288261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  288275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288300 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  288300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288317 */     GIR_RootConstrainSelectedInstOperands,
     /*  288318 */     // GIR_Coverage, 8788,
     /*  288318 */     GIR_EraseRootFromParent_Done,
     /*  288319 */   // Label 5400: @288319
     /*  288319 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(288382), // Rule ID 8789 //
     /*  288324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  288338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288363 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288380 */     GIR_RootConstrainSelectedInstOperands,
     /*  288381 */     // GIR_Coverage, 8789,
     /*  288381 */     GIR_EraseRootFromParent_Done,
     /*  288382 */   // Label 5401: @288382
     /*  288382 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(288445), // Rule ID 8792 //
     /*  288387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  288398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  288401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288426 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288443 */     GIR_RootConstrainSelectedInstOperands,
     /*  288444 */     // GIR_Coverage, 8792,
     /*  288444 */     GIR_EraseRootFromParent_Done,
     /*  288445 */   // Label 5402: @288445
     /*  288445 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(288508), // Rule ID 8793 //
     /*  288450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  288461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  288464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288489 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288506 */     GIR_RootConstrainSelectedInstOperands,
     /*  288507 */     // GIR_Coverage, 8793,
     /*  288507 */     GIR_EraseRootFromParent_Done,
     /*  288508 */   // Label 5403: @288508
     /*  288508 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(288571), // Rule ID 8796 //
     /*  288513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  288516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  288524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  288527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288552 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  288552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288569 */     GIR_RootConstrainSelectedInstOperands,
     /*  288570 */     // GIR_Coverage, 8796,
     /*  288570 */     GIR_EraseRootFromParent_Done,
     /*  288571 */   // Label 5404: @288571
     /*  288571 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(288634), // Rule ID 8797 //
     /*  288576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  288579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  288587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  288590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288615 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  288615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288632 */     GIR_RootConstrainSelectedInstOperands,
     /*  288633 */     // GIR_Coverage, 8797,
     /*  288633 */     GIR_EraseRootFromParent_Done,
     /*  288634 */   // Label 5405: @288634
     /*  288634 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(288697), // Rule ID 8800 //
     /*  288639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  288653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288678 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  288681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288695 */     GIR_RootConstrainSelectedInstOperands,
     /*  288696 */     // GIR_Coverage, 8800,
     /*  288696 */     GIR_EraseRootFromParent_Done,
     /*  288697 */   // Label 5406: @288697
     /*  288697 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(288760), // Rule ID 8801 //
     /*  288702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  288716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288741 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  288744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288758 */     GIR_RootConstrainSelectedInstOperands,
     /*  288759 */     // GIR_Coverage, 8801,
     /*  288759 */     GIR_EraseRootFromParent_Done,
     /*  288760 */   // Label 5407: @288760
     /*  288760 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(288823), // Rule ID 8804 //
     /*  288765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  288779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288804 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  288807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288821 */     GIR_RootConstrainSelectedInstOperands,
     /*  288822 */     // GIR_Coverage, 8804,
     /*  288822 */     GIR_EraseRootFromParent_Done,
     /*  288823 */   // Label 5408: @288823
     /*  288823 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(288886), // Rule ID 8805 //
     /*  288828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  288842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288867 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  288870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288884 */     GIR_RootConstrainSelectedInstOperands,
     /*  288885 */     // GIR_Coverage, 8805,
     /*  288885 */     GIR_EraseRootFromParent_Done,
     /*  288886 */   // Label 5409: @288886
     /*  288886 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(288949), // Rule ID 8808 //
     /*  288891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  288902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  288905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288930 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  288933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288947 */     GIR_RootConstrainSelectedInstOperands,
     /*  288948 */     // GIR_Coverage, 8808,
     /*  288948 */     GIR_EraseRootFromParent_Done,
     /*  288949 */   // Label 5410: @288949
     /*  288949 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(289012), // Rule ID 8809 //
     /*  288954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  288965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  288968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288993 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  288996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289010 */     GIR_RootConstrainSelectedInstOperands,
     /*  289011 */     // GIR_Coverage, 8809,
     /*  289011 */     GIR_EraseRootFromParent_Done,
     /*  289012 */   // Label 5411: @289012
     /*  289012 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(289075), // Rule ID 8812 //
     /*  289017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  289031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289056 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  289059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289073 */     GIR_RootConstrainSelectedInstOperands,
     /*  289074 */     // GIR_Coverage, 8812,
     /*  289074 */     GIR_EraseRootFromParent_Done,
     /*  289075 */   // Label 5412: @289075
     /*  289075 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(289138), // Rule ID 8813 //
     /*  289080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  289094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289119 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  289119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  289122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289136 */     GIR_RootConstrainSelectedInstOperands,
     /*  289137 */     // GIR_Coverage, 8813,
     /*  289137 */     GIR_EraseRootFromParent_Done,
     /*  289138 */   // Label 5413: @289138
     /*  289138 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(289201), // Rule ID 8816 //
     /*  289143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  289157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289182 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  289185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289199 */     GIR_RootConstrainSelectedInstOperands,
     /*  289200 */     // GIR_Coverage, 8816,
     /*  289200 */     GIR_EraseRootFromParent_Done,
     /*  289201 */   // Label 5414: @289201
     /*  289201 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(289264), // Rule ID 8817 //
     /*  289206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  289220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289245 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  289245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  289248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289262 */     GIR_RootConstrainSelectedInstOperands,
     /*  289263 */     // GIR_Coverage, 8817,
     /*  289263 */     GIR_EraseRootFromParent_Done,
     /*  289264 */   // Label 5415: @289264
     /*  289264 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(289327), // Rule ID 8820 //
     /*  289269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  289280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  289283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289308 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  289311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289325 */     GIR_RootConstrainSelectedInstOperands,
     /*  289326 */     // GIR_Coverage, 8820,
     /*  289326 */     GIR_EraseRootFromParent_Done,
     /*  289327 */   // Label 5416: @289327
     /*  289327 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(289390), // Rule ID 8821 //
     /*  289332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  289343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  289346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289371 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  289371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  289374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289388 */     GIR_RootConstrainSelectedInstOperands,
     /*  289389 */     // GIR_Coverage, 8821,
     /*  289389 */     GIR_EraseRootFromParent_Done,
     /*  289390 */   // Label 5417: @289390
     /*  289390 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(289453), // Rule ID 8824 //
     /*  289395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  289409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289434 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  289434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  289437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289451 */     GIR_RootConstrainSelectedInstOperands,
     /*  289452 */     // GIR_Coverage, 8824,
     /*  289452 */     GIR_EraseRootFromParent_Done,
     /*  289453 */   // Label 5418: @289453
     /*  289453 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(289516), // Rule ID 8825 //
     /*  289458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  289472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289497 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  289500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289514 */     GIR_RootConstrainSelectedInstOperands,
     /*  289515 */     // GIR_Coverage, 8825,
     /*  289515 */     GIR_EraseRootFromParent_Done,
     /*  289516 */   // Label 5419: @289516
     /*  289516 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(289579), // Rule ID 8828 //
     /*  289521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  289535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289560 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  289560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  289563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289577 */     GIR_RootConstrainSelectedInstOperands,
     /*  289578 */     // GIR_Coverage, 8828,
     /*  289578 */     GIR_EraseRootFromParent_Done,
     /*  289579 */   // Label 5420: @289579
     /*  289579 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(289642), // Rule ID 8829 //
     /*  289584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  289598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289623 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  289626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289640 */     GIR_RootConstrainSelectedInstOperands,
     /*  289641 */     // GIR_Coverage, 8829,
     /*  289641 */     GIR_EraseRootFromParent_Done,
     /*  289642 */   // Label 5421: @289642
     /*  289642 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(289705), // Rule ID 8832 //
     /*  289647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  289661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289686 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  289686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  289689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289703 */     GIR_RootConstrainSelectedInstOperands,
     /*  289704 */     // GIR_Coverage, 8832,
     /*  289704 */     GIR_EraseRootFromParent_Done,
     /*  289705 */   // Label 5422: @289705
     /*  289705 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(289768), // Rule ID 8833 //
     /*  289710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  289724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289749 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  289752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289766 */     GIR_RootConstrainSelectedInstOperands,
     /*  289767 */     // GIR_Coverage, 8833,
     /*  289767 */     GIR_EraseRootFromParent_Done,
     /*  289768 */   // Label 5423: @289768
     /*  289768 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(289831), // Rule ID 8836 //
     /*  289773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  289776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  289787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289812 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  289812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  289815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289829 */     GIR_RootConstrainSelectedInstOperands,
     /*  289830 */     // GIR_Coverage, 8836,
     /*  289830 */     GIR_EraseRootFromParent_Done,
     /*  289831 */   // Label 5424: @289831
     /*  289831 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(289894), // Rule ID 8837 //
     /*  289836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  289839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  289850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289875 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  289875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  289878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289892 */     GIR_RootConstrainSelectedInstOperands,
     /*  289893 */     // GIR_Coverage, 8837,
     /*  289893 */     GIR_EraseRootFromParent_Done,
     /*  289894 */   // Label 5425: @289894
     /*  289894 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(289957), // Rule ID 8840 //
     /*  289899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  289902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  289913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289938 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  289938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  289941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289955 */     GIR_RootConstrainSelectedInstOperands,
     /*  289956 */     // GIR_Coverage, 8840,
     /*  289956 */     GIR_EraseRootFromParent_Done,
     /*  289957 */   // Label 5426: @289957
     /*  289957 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(290020), // Rule ID 8841 //
     /*  289962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  289965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  289976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290001 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  290001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  290004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290018 */     GIR_RootConstrainSelectedInstOperands,
     /*  290019 */     // GIR_Coverage, 8841,
     /*  290019 */     GIR_EraseRootFromParent_Done,
     /*  290020 */   // Label 5427: @290020
     /*  290020 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(290083), // Rule ID 8844 //
     /*  290025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  290028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  290033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  290039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290064 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  290064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  290067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290081 */     GIR_RootConstrainSelectedInstOperands,
     /*  290082 */     // GIR_Coverage, 8844,
     /*  290082 */     GIR_EraseRootFromParent_Done,
     /*  290083 */   // Label 5428: @290083
     /*  290083 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(290146), // Rule ID 8845 //
     /*  290088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  290091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  290096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  290102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290127 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  290127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  290130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290144 */     GIR_RootConstrainSelectedInstOperands,
     /*  290145 */     // GIR_Coverage, 8845,
     /*  290145 */     GIR_EraseRootFromParent_Done,
     /*  290146 */   // Label 5429: @290146
     /*  290146 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(290209), // Rule ID 8936 //
     /*  290151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  290165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  290168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  290193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290207 */     GIR_RootConstrainSelectedInstOperands,
     /*  290208 */     // GIR_Coverage, 8936,
     /*  290208 */     GIR_EraseRootFromParent_Done,
     /*  290209 */   // Label 5430: @290209
     /*  290209 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(290272), // Rule ID 8937 //
     /*  290214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  290228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  290231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290253 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  290256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290270 */     GIR_RootConstrainSelectedInstOperands,
     /*  290271 */     // GIR_Coverage, 8937,
     /*  290271 */     GIR_EraseRootFromParent_Done,
     /*  290272 */   // Label 5431: @290272
     /*  290272 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(290335), // Rule ID 8940 //
     /*  290277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  290291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  290294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290316 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  290319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290333 */     GIR_RootConstrainSelectedInstOperands,
     /*  290334 */     // GIR_Coverage, 8940,
     /*  290334 */     GIR_EraseRootFromParent_Done,
     /*  290335 */   // Label 5432: @290335
     /*  290335 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(290398), // Rule ID 8941 //
     /*  290340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  290354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  290357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290379 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  290382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290396 */     GIR_RootConstrainSelectedInstOperands,
     /*  290397 */     // GIR_Coverage, 8941,
     /*  290397 */     GIR_EraseRootFromParent_Done,
     /*  290398 */   // Label 5433: @290398
     /*  290398 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(290461), // Rule ID 8944 //
     /*  290403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  290414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  290417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  290420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290442 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  290445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290459 */     GIR_RootConstrainSelectedInstOperands,
     /*  290460 */     // GIR_Coverage, 8944,
     /*  290460 */     GIR_EraseRootFromParent_Done,
     /*  290461 */   // Label 5434: @290461
     /*  290461 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(290524), // Rule ID 8945 //
     /*  290466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  290477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  290480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  290483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290505 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  290508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290522 */     GIR_RootConstrainSelectedInstOperands,
     /*  290523 */     // GIR_Coverage, 8945,
     /*  290523 */     GIR_EraseRootFromParent_Done,
     /*  290524 */   // Label 5435: @290524
     /*  290524 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(290587), // Rule ID 8948 //
     /*  290529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  290543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  290546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290568 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  290571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290585 */     GIR_RootConstrainSelectedInstOperands,
     /*  290586 */     // GIR_Coverage, 8948,
     /*  290586 */     GIR_EraseRootFromParent_Done,
     /*  290587 */   // Label 5436: @290587
     /*  290587 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(290650), // Rule ID 8949 //
     /*  290592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  290606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  290609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290631 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  290634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290648 */     GIR_RootConstrainSelectedInstOperands,
     /*  290649 */     // GIR_Coverage, 8949,
     /*  290649 */     GIR_EraseRootFromParent_Done,
     /*  290650 */   // Label 5437: @290650
     /*  290650 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(290713), // Rule ID 8952 //
     /*  290655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  290669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  290672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290694 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  290697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290711 */     GIR_RootConstrainSelectedInstOperands,
     /*  290712 */     // GIR_Coverage, 8952,
     /*  290712 */     GIR_EraseRootFromParent_Done,
     /*  290713 */   // Label 5438: @290713
     /*  290713 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(290776), // Rule ID 8953 //
     /*  290718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  290732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  290735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290757 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  290760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290774 */     GIR_RootConstrainSelectedInstOperands,
     /*  290775 */     // GIR_Coverage, 8953,
     /*  290775 */     GIR_EraseRootFromParent_Done,
     /*  290776 */   // Label 5439: @290776
     /*  290776 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(290839), // Rule ID 8956 //
     /*  290781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  290795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  290798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290820 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  290820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  290823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290837 */     GIR_RootConstrainSelectedInstOperands,
     /*  290838 */     // GIR_Coverage, 8956,
     /*  290838 */     GIR_EraseRootFromParent_Done,
     /*  290839 */   // Label 5440: @290839
     /*  290839 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(290902), // Rule ID 8957 //
     /*  290844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  290858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  290861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290883 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  290883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  290886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290900 */     GIR_RootConstrainSelectedInstOperands,
     /*  290901 */     // GIR_Coverage, 8957,
     /*  290901 */     GIR_EraseRootFromParent_Done,
     /*  290902 */   // Label 5441: @290902
     /*  290902 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(290965), // Rule ID 8960 //
     /*  290907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  290921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  290924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290946 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  290949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290963 */     GIR_RootConstrainSelectedInstOperands,
     /*  290964 */     // GIR_Coverage, 8960,
     /*  290964 */     GIR_EraseRootFromParent_Done,
     /*  290965 */   // Label 5442: @290965
     /*  290965 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(291028), // Rule ID 8961 //
     /*  290970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  290984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  290987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291009 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291026 */     GIR_RootConstrainSelectedInstOperands,
     /*  291027 */     // GIR_Coverage, 8961,
     /*  291027 */     GIR_EraseRootFromParent_Done,
     /*  291028 */   // Label 5443: @291028
     /*  291028 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(291091), // Rule ID 8964 //
     /*  291033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  291047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  291050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291072 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291089 */     GIR_RootConstrainSelectedInstOperands,
     /*  291090 */     // GIR_Coverage, 8964,
     /*  291090 */     GIR_EraseRootFromParent_Done,
     /*  291091 */   // Label 5444: @291091
     /*  291091 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(291154), // Rule ID 8965 //
     /*  291096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  291110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  291113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291135 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291152 */     GIR_RootConstrainSelectedInstOperands,
     /*  291153 */     // GIR_Coverage, 8965,
     /*  291153 */     GIR_EraseRootFromParent_Done,
     /*  291154 */   // Label 5445: @291154
     /*  291154 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(291217), // Rule ID 8968 //
     /*  291159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  291173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  291176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291198 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291215 */     GIR_RootConstrainSelectedInstOperands,
     /*  291216 */     // GIR_Coverage, 8968,
     /*  291216 */     GIR_EraseRootFromParent_Done,
     /*  291217 */   // Label 5446: @291217
     /*  291217 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(291280), // Rule ID 8969 //
     /*  291222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  291236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  291239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291261 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291278 */     GIR_RootConstrainSelectedInstOperands,
     /*  291279 */     // GIR_Coverage, 8969,
     /*  291279 */     GIR_EraseRootFromParent_Done,
     /*  291280 */   // Label 5447: @291280
     /*  291280 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(291343), // Rule ID 8972 //
     /*  291285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  291288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  291296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  291299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  291302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291324 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  291324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291341 */     GIR_RootConstrainSelectedInstOperands,
     /*  291342 */     // GIR_Coverage, 8972,
     /*  291342 */     GIR_EraseRootFromParent_Done,
     /*  291343 */   // Label 5448: @291343
     /*  291343 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(291406), // Rule ID 8973 //
     /*  291348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  291351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  291359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  291362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  291365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291387 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  291387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291404 */     GIR_RootConstrainSelectedInstOperands,
     /*  291405 */     // GIR_Coverage, 8973,
     /*  291405 */     GIR_EraseRootFromParent_Done,
     /*  291406 */   // Label 5449: @291406
     /*  291406 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(291469), // Rule ID 8976 //
     /*  291411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  291425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  291428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291450 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  291450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  291453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291467 */     GIR_RootConstrainSelectedInstOperands,
     /*  291468 */     // GIR_Coverage, 8976,
     /*  291468 */     GIR_EraseRootFromParent_Done,
     /*  291469 */   // Label 5450: @291469
     /*  291469 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(291532), // Rule ID 8977 //
     /*  291474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  291488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  291491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291513 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  291516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291530 */     GIR_RootConstrainSelectedInstOperands,
     /*  291531 */     // GIR_Coverage, 8977,
     /*  291531 */     GIR_EraseRootFromParent_Done,
     /*  291532 */   // Label 5451: @291532
     /*  291532 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(291595), // Rule ID 8980 //
     /*  291537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  291548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  291551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  291554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291576 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  291576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  291579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291593 */     GIR_RootConstrainSelectedInstOperands,
     /*  291594 */     // GIR_Coverage, 8980,
     /*  291594 */     GIR_EraseRootFromParent_Done,
     /*  291595 */   // Label 5452: @291595
     /*  291595 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(291658), // Rule ID 8981 //
     /*  291600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  291611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  291614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  291617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291639 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  291642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291656 */     GIR_RootConstrainSelectedInstOperands,
     /*  291657 */     // GIR_Coverage, 8981,
     /*  291657 */     GIR_EraseRootFromParent_Done,
     /*  291658 */   // Label 5453: @291658
     /*  291658 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(291721), // Rule ID 8984 //
     /*  291663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  291674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  291677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  291680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291702 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  291702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  291705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291719 */     GIR_RootConstrainSelectedInstOperands,
     /*  291720 */     // GIR_Coverage, 8984,
     /*  291720 */     GIR_EraseRootFromParent_Done,
     /*  291721 */   // Label 5454: @291721
     /*  291721 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(291784), // Rule ID 8985 //
     /*  291726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  291737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  291740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  291743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291765 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  291768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291782 */     GIR_RootConstrainSelectedInstOperands,
     /*  291783 */     // GIR_Coverage, 8985,
     /*  291783 */     GIR_EraseRootFromParent_Done,
     /*  291784 */   // Label 5455: @291784
     /*  291784 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(291847), // Rule ID 8988 //
     /*  291789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  291803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  291806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291828 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  291831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291845 */     GIR_RootConstrainSelectedInstOperands,
     /*  291846 */     // GIR_Coverage, 8988,
     /*  291846 */     GIR_EraseRootFromParent_Done,
     /*  291847 */   // Label 5456: @291847
     /*  291847 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(291910), // Rule ID 8989 //
     /*  291852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  291866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  291869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291891 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  291894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291908 */     GIR_RootConstrainSelectedInstOperands,
     /*  291909 */     // GIR_Coverage, 8989,
     /*  291909 */     GIR_EraseRootFromParent_Done,
     /*  291910 */   // Label 5457: @291910
     /*  291910 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(291973), // Rule ID 8992 //
     /*  291915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  291929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  291932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291954 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  291957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291971 */     GIR_RootConstrainSelectedInstOperands,
     /*  291972 */     // GIR_Coverage, 8992,
     /*  291972 */     GIR_EraseRootFromParent_Done,
     /*  291973 */   // Label 5458: @291973
     /*  291973 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(292036), // Rule ID 8993 //
     /*  291978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  291992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  291995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292017 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  292020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292034 */     GIR_RootConstrainSelectedInstOperands,
     /*  292035 */     // GIR_Coverage, 8993,
     /*  292035 */     GIR_EraseRootFromParent_Done,
     /*  292036 */   // Label 5459: @292036
     /*  292036 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(292099), // Rule ID 8996 //
     /*  292041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  292052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  292055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  292058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292080 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  292080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  292083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292097 */     GIR_RootConstrainSelectedInstOperands,
     /*  292098 */     // GIR_Coverage, 8996,
     /*  292098 */     GIR_EraseRootFromParent_Done,
     /*  292099 */   // Label 5460: @292099
     /*  292099 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(292162), // Rule ID 8997 //
     /*  292104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  292115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  292118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  292121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292143 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  292146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292160 */     GIR_RootConstrainSelectedInstOperands,
     /*  292161 */     // GIR_Coverage, 8997,
     /*  292161 */     GIR_EraseRootFromParent_Done,
     /*  292162 */   // Label 5461: @292162
     /*  292162 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(292225), // Rule ID 9000 //
     /*  292167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  292181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  292184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292206 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  292209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292223 */     GIR_RootConstrainSelectedInstOperands,
     /*  292224 */     // GIR_Coverage, 9000,
     /*  292224 */     GIR_EraseRootFromParent_Done,
     /*  292225 */   // Label 5462: @292225
     /*  292225 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(292288), // Rule ID 9001 //
     /*  292230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  292244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  292247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292269 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  292269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  292272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292286 */     GIR_RootConstrainSelectedInstOperands,
     /*  292287 */     // GIR_Coverage, 9001,
     /*  292287 */     GIR_EraseRootFromParent_Done,
     /*  292288 */   // Label 5463: @292288
     /*  292288 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(292351), // Rule ID 9004 //
     /*  292293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  292307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  292310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292332 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  292335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292349 */     GIR_RootConstrainSelectedInstOperands,
     /*  292350 */     // GIR_Coverage, 9004,
     /*  292350 */     GIR_EraseRootFromParent_Done,
     /*  292351 */   // Label 5464: @292351
     /*  292351 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(292414), // Rule ID 9005 //
     /*  292356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  292370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  292373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292395 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  292395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  292398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292412 */     GIR_RootConstrainSelectedInstOperands,
     /*  292413 */     // GIR_Coverage, 9005,
     /*  292413 */     GIR_EraseRootFromParent_Done,
     /*  292414 */   // Label 5465: @292414
     /*  292414 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(292477), // Rule ID 9008 //
     /*  292419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  292430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  292433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  292436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292458 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  292461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292475 */     GIR_RootConstrainSelectedInstOperands,
     /*  292476 */     // GIR_Coverage, 9008,
     /*  292476 */     GIR_EraseRootFromParent_Done,
     /*  292477 */   // Label 5466: @292477
     /*  292477 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(292540), // Rule ID 9009 //
     /*  292482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  292493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  292496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  292499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292521 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  292521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  292524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292538 */     GIR_RootConstrainSelectedInstOperands,
     /*  292539 */     // GIR_Coverage, 9009,
     /*  292539 */     GIR_EraseRootFromParent_Done,
     /*  292540 */   // Label 5467: @292540
     /*  292540 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(292603), // Rule ID 9012 //
     /*  292545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  292548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  292559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  292562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292584 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  292584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  292587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292601 */     GIR_RootConstrainSelectedInstOperands,
     /*  292602 */     // GIR_Coverage, 9012,
     /*  292602 */     GIR_EraseRootFromParent_Done,
     /*  292603 */   // Label 5468: @292603
     /*  292603 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(292666), // Rule ID 9013 //
     /*  292608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  292611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  292622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  292625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292647 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  292647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  292650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292664 */     GIR_RootConstrainSelectedInstOperands,
     /*  292665 */     // GIR_Coverage, 9013,
     /*  292665 */     GIR_EraseRootFromParent_Done,
     /*  292666 */   // Label 5469: @292666
     /*  292666 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(292729), // Rule ID 9016 //
     /*  292671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  292674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  292685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  292688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292710 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  292710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  292713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292727 */     GIR_RootConstrainSelectedInstOperands,
     /*  292728 */     // GIR_Coverage, 9016,
     /*  292728 */     GIR_EraseRootFromParent_Done,
     /*  292729 */   // Label 5470: @292729
     /*  292729 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(292792), // Rule ID 9017 //
     /*  292734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  292737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  292748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  292751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292773 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  292773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  292776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292790 */     GIR_RootConstrainSelectedInstOperands,
     /*  292791 */     // GIR_Coverage, 9017,
     /*  292791 */     GIR_EraseRootFromParent_Done,
     /*  292792 */   // Label 5471: @292792
     /*  292792 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(292855), // Rule ID 9020 //
     /*  292797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  292800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  292811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  292814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292836 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  292836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  292839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292853 */     GIR_RootConstrainSelectedInstOperands,
     /*  292854 */     // GIR_Coverage, 9020,
     /*  292854 */     GIR_EraseRootFromParent_Done,
     /*  292855 */   // Label 5472: @292855
     /*  292855 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(292918), // Rule ID 9021 //
     /*  292860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  292863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  292874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  292877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292899 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  292899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  292902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292916 */     GIR_RootConstrainSelectedInstOperands,
     /*  292917 */     // GIR_Coverage, 9021,
     /*  292917 */     GIR_EraseRootFromParent_Done,
     /*  292918 */   // Label 5473: @292918
     /*  292918 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(292981), // Rule ID 9024 //
     /*  292923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  292937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292962 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  292965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292979 */     GIR_RootConstrainSelectedInstOperands,
     /*  292980 */     // GIR_Coverage, 9024,
     /*  292980 */     GIR_EraseRootFromParent_Done,
     /*  292981 */   // Label 5474: @292981
     /*  292981 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(293044), // Rule ID 9025 //
     /*  292986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  293000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293025 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  293028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293042 */     GIR_RootConstrainSelectedInstOperands,
     /*  293043 */     // GIR_Coverage, 9025,
     /*  293043 */     GIR_EraseRootFromParent_Done,
     /*  293044 */   // Label 5475: @293044
     /*  293044 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(293107), // Rule ID 9028 //
     /*  293049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  293063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293088 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  293091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293105 */     GIR_RootConstrainSelectedInstOperands,
     /*  293106 */     // GIR_Coverage, 9028,
     /*  293106 */     GIR_EraseRootFromParent_Done,
     /*  293107 */   // Label 5476: @293107
     /*  293107 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(293170), // Rule ID 9029 //
     /*  293112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  293126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293151 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  293154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293168 */     GIR_RootConstrainSelectedInstOperands,
     /*  293169 */     // GIR_Coverage, 9029,
     /*  293169 */     GIR_EraseRootFromParent_Done,
     /*  293170 */   // Label 5477: @293170
     /*  293170 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(293233), // Rule ID 9032 //
     /*  293175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  293189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293214 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  293217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293231 */     GIR_RootConstrainSelectedInstOperands,
     /*  293232 */     // GIR_Coverage, 9032,
     /*  293232 */     GIR_EraseRootFromParent_Done,
     /*  293233 */   // Label 5478: @293233
     /*  293233 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(293296), // Rule ID 9033 //
     /*  293238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  293252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293277 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  293280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293294 */     GIR_RootConstrainSelectedInstOperands,
     /*  293295 */     // GIR_Coverage, 9033,
     /*  293295 */     GIR_EraseRootFromParent_Done,
     /*  293296 */   // Label 5479: @293296
     /*  293296 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(293359), // Rule ID 9036 //
     /*  293301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  293315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293340 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  293343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293357 */     GIR_RootConstrainSelectedInstOperands,
     /*  293358 */     // GIR_Coverage, 9036,
     /*  293358 */     GIR_EraseRootFromParent_Done,
     /*  293359 */   // Label 5480: @293359
     /*  293359 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(293422), // Rule ID 9037 //
     /*  293364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  293378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293403 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  293406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293420 */     GIR_RootConstrainSelectedInstOperands,
     /*  293421 */     // GIR_Coverage, 9037,
     /*  293421 */     GIR_EraseRootFromParent_Done,
     /*  293422 */   // Label 5481: @293422
     /*  293422 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(293485), // Rule ID 9040 //
     /*  293427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  293441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293466 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  293469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293483 */     GIR_RootConstrainSelectedInstOperands,
     /*  293484 */     // GIR_Coverage, 9040,
     /*  293484 */     GIR_EraseRootFromParent_Done,
     /*  293485 */   // Label 5482: @293485
     /*  293485 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(293548), // Rule ID 9041 //
     /*  293490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  293504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293529 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  293532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293546 */     GIR_RootConstrainSelectedInstOperands,
     /*  293547 */     // GIR_Coverage, 9041,
     /*  293547 */     GIR_EraseRootFromParent_Done,
     /*  293548 */   // Label 5483: @293548
     /*  293548 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(293611), // Rule ID 9044 //
     /*  293553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  293567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293592 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  293592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  293595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293609 */     GIR_RootConstrainSelectedInstOperands,
     /*  293610 */     // GIR_Coverage, 9044,
     /*  293610 */     GIR_EraseRootFromParent_Done,
     /*  293611 */   // Label 5484: @293611
     /*  293611 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(293674), // Rule ID 9045 //
     /*  293616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  293630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293655 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  293655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  293658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293672 */     GIR_RootConstrainSelectedInstOperands,
     /*  293673 */     // GIR_Coverage, 9045,
     /*  293673 */     GIR_EraseRootFromParent_Done,
     /*  293674 */   // Label 5485: @293674
     /*  293674 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(293737), // Rule ID 9048 //
     /*  293679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  293693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293718 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  293721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293735 */     GIR_RootConstrainSelectedInstOperands,
     /*  293736 */     // GIR_Coverage, 9048,
     /*  293736 */     GIR_EraseRootFromParent_Done,
     /*  293737 */   // Label 5486: @293737
     /*  293737 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(293800), // Rule ID 9049 //
     /*  293742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  293756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293781 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  293784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293798 */     GIR_RootConstrainSelectedInstOperands,
     /*  293799 */     // GIR_Coverage, 9049,
     /*  293799 */     GIR_EraseRootFromParent_Done,
     /*  293800 */   // Label 5487: @293800
     /*  293800 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(293863), // Rule ID 9052 //
     /*  293805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  293819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293844 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  293847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293861 */     GIR_RootConstrainSelectedInstOperands,
     /*  293862 */     // GIR_Coverage, 9052,
     /*  293862 */     GIR_EraseRootFromParent_Done,
     /*  293863 */   // Label 5488: @293863
     /*  293863 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(293926), // Rule ID 9053 //
     /*  293868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  293882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293907 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  293910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293924 */     GIR_RootConstrainSelectedInstOperands,
     /*  293925 */     // GIR_Coverage, 9053,
     /*  293925 */     GIR_EraseRootFromParent_Done,
     /*  293926 */   // Label 5489: @293926
     /*  293926 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(293989), // Rule ID 9056 //
     /*  293931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  293945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293970 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  293970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  293973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293987 */     GIR_RootConstrainSelectedInstOperands,
     /*  293988 */     // GIR_Coverage, 9056,
     /*  293988 */     GIR_EraseRootFromParent_Done,
     /*  293989 */   // Label 5490: @293989
     /*  293989 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(294052), // Rule ID 9057 //
     /*  293994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  294008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294033 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  294036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294050 */     GIR_RootConstrainSelectedInstOperands,
     /*  294051 */     // GIR_Coverage, 9057,
     /*  294051 */     GIR_EraseRootFromParent_Done,
     /*  294052 */   // Label 5491: @294052
     /*  294052 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(294115), // Rule ID 9060 //
     /*  294057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  294071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294096 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  294099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294113 */     GIR_RootConstrainSelectedInstOperands,
     /*  294114 */     // GIR_Coverage, 9060,
     /*  294114 */     GIR_EraseRootFromParent_Done,
     /*  294115 */   // Label 5492: @294115
     /*  294115 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(294178), // Rule ID 9061 //
     /*  294120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  294123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  294134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294159 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  294162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294176 */     GIR_RootConstrainSelectedInstOperands,
     /*  294177 */     // GIR_Coverage, 9061,
     /*  294177 */     GIR_EraseRootFromParent_Done,
     /*  294178 */   // Label 5493: @294178
     /*  294178 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(294241), // Rule ID 9064 //
     /*  294183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  294197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294222 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  294225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294239 */     GIR_RootConstrainSelectedInstOperands,
     /*  294240 */     // GIR_Coverage, 9064,
     /*  294240 */     GIR_EraseRootFromParent_Done,
     /*  294241 */   // Label 5494: @294241
     /*  294241 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(294304), // Rule ID 9065 //
     /*  294246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  294260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294285 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  294288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294302 */     GIR_RootConstrainSelectedInstOperands,
     /*  294303 */     // GIR_Coverage, 9065,
     /*  294303 */     GIR_EraseRootFromParent_Done,
     /*  294304 */   // Label 5495: @294304
     /*  294304 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(294367), // Rule ID 9068 //
     /*  294309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  294320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  294323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294348 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  294351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294365 */     GIR_RootConstrainSelectedInstOperands,
     /*  294366 */     // GIR_Coverage, 9068,
     /*  294366 */     GIR_EraseRootFromParent_Done,
     /*  294367 */   // Label 5496: @294367
     /*  294367 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(294430), // Rule ID 9069 //
     /*  294372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  294383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  294386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294411 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  294414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294428 */     GIR_RootConstrainSelectedInstOperands,
     /*  294429 */     // GIR_Coverage, 9069,
     /*  294429 */     GIR_EraseRootFromParent_Done,
     /*  294430 */   // Label 5497: @294430
     /*  294430 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(294493), // Rule ID 9072 //
     /*  294435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  294446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  294449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294474 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  294477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294491 */     GIR_RootConstrainSelectedInstOperands,
     /*  294492 */     // GIR_Coverage, 9072,
     /*  294492 */     GIR_EraseRootFromParent_Done,
     /*  294493 */   // Label 5498: @294493
     /*  294493 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(294556), // Rule ID 9073 //
     /*  294498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  294509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  294512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294537 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  294540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294554 */     GIR_RootConstrainSelectedInstOperands,
     /*  294555 */     // GIR_Coverage, 9073,
     /*  294555 */     GIR_EraseRootFromParent_Done,
     /*  294556 */   // Label 5499: @294556
     /*  294556 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(294619), // Rule ID 9076 //
     /*  294561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  294575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294600 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  294603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294617 */     GIR_RootConstrainSelectedInstOperands,
     /*  294618 */     // GIR_Coverage, 9076,
     /*  294618 */     GIR_EraseRootFromParent_Done,
     /*  294619 */   // Label 5500: @294619
     /*  294619 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(294682), // Rule ID 9077 //
     /*  294624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  294638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294663 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  294666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294680 */     GIR_RootConstrainSelectedInstOperands,
     /*  294681 */     // GIR_Coverage, 9077,
     /*  294681 */     GIR_EraseRootFromParent_Done,
     /*  294682 */   // Label 5501: @294682
     /*  294682 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(294745), // Rule ID 9080 //
     /*  294687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  294701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294726 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  294729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294743 */     GIR_RootConstrainSelectedInstOperands,
     /*  294744 */     // GIR_Coverage, 9080,
     /*  294744 */     GIR_EraseRootFromParent_Done,
     /*  294745 */   // Label 5502: @294745
     /*  294745 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(294808), // Rule ID 9081 //
     /*  294750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  294764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294789 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  294792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294806 */     GIR_RootConstrainSelectedInstOperands,
     /*  294807 */     // GIR_Coverage, 9081,
     /*  294807 */     GIR_EraseRootFromParent_Done,
     /*  294808 */   // Label 5503: @294808
     /*  294808 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(294871), // Rule ID 9084 //
     /*  294813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  294824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  294827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294852 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  294855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294869 */     GIR_RootConstrainSelectedInstOperands,
     /*  294870 */     // GIR_Coverage, 9084,
     /*  294870 */     GIR_EraseRootFromParent_Done,
     /*  294871 */   // Label 5504: @294871
     /*  294871 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(294934), // Rule ID 9085 //
     /*  294876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  294887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  294890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294915 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  294918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294932 */     GIR_RootConstrainSelectedInstOperands,
     /*  294933 */     // GIR_Coverage, 9085,
     /*  294933 */     GIR_EraseRootFromParent_Done,
     /*  294934 */   // Label 5505: @294934
     /*  294934 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(294997), // Rule ID 9088 //
     /*  294939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  294953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294978 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  294981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294995 */     GIR_RootConstrainSelectedInstOperands,
     /*  294996 */     // GIR_Coverage, 9088,
     /*  294996 */     GIR_EraseRootFromParent_Done,
     /*  294997 */   // Label 5506: @294997
     /*  294997 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(295060), // Rule ID 9089 //
     /*  295002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  295016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295041 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  295044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295058 */     GIR_RootConstrainSelectedInstOperands,
     /*  295059 */     // GIR_Coverage, 9089,
     /*  295059 */     GIR_EraseRootFromParent_Done,
     /*  295060 */   // Label 5507: @295060
     /*  295060 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(295123), // Rule ID 9092 //
     /*  295065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  295079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295104 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  295107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295121 */     GIR_RootConstrainSelectedInstOperands,
     /*  295122 */     // GIR_Coverage, 9092,
     /*  295122 */     GIR_EraseRootFromParent_Done,
     /*  295123 */   // Label 5508: @295123
     /*  295123 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(295186), // Rule ID 9093 //
     /*  295128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  295142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295167 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  295170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295184 */     GIR_RootConstrainSelectedInstOperands,
     /*  295185 */     // GIR_Coverage, 9093,
     /*  295185 */     GIR_EraseRootFromParent_Done,
     /*  295186 */   // Label 5509: @295186
     /*  295186 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(295249), // Rule ID 9096 //
     /*  295191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  295202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  295205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295230 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  295233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295247 */     GIR_RootConstrainSelectedInstOperands,
     /*  295248 */     // GIR_Coverage, 9096,
     /*  295248 */     GIR_EraseRootFromParent_Done,
     /*  295249 */   // Label 5510: @295249
     /*  295249 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(295312), // Rule ID 9097 //
     /*  295254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  295265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  295268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295293 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  295296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295310 */     GIR_RootConstrainSelectedInstOperands,
     /*  295311 */     // GIR_Coverage, 9097,
     /*  295311 */     GIR_EraseRootFromParent_Done,
     /*  295312 */   // Label 5511: @295312
     /*  295312 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(295375), // Rule ID 9100 //
     /*  295317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  295320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  295331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295356 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  295356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  295359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295373 */     GIR_RootConstrainSelectedInstOperands,
     /*  295374 */     // GIR_Coverage, 9100,
     /*  295374 */     GIR_EraseRootFromParent_Done,
     /*  295375 */   // Label 5512: @295375
     /*  295375 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(295438), // Rule ID 9101 //
     /*  295380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  295383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  295394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295419 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  295419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  295422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295436 */     GIR_RootConstrainSelectedInstOperands,
     /*  295437 */     // GIR_Coverage, 9101,
     /*  295437 */     GIR_EraseRootFromParent_Done,
     /*  295438 */   // Label 5513: @295438
     /*  295438 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(295501), // Rule ID 9104 //
     /*  295443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  295446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  295457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295482 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  295482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  295485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295499 */     GIR_RootConstrainSelectedInstOperands,
     /*  295500 */     // GIR_Coverage, 9104,
     /*  295500 */     GIR_EraseRootFromParent_Done,
     /*  295501 */   // Label 5514: @295501
     /*  295501 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(295564), // Rule ID 9105 //
     /*  295506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  295509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  295520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295545 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  295545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  295548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295562 */     GIR_RootConstrainSelectedInstOperands,
     /*  295563 */     // GIR_Coverage, 9105,
     /*  295563 */     GIR_EraseRootFromParent_Done,
     /*  295564 */   // Label 5515: @295564
     /*  295564 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(295627), // Rule ID 9108 //
     /*  295569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  295572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  295583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295608 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  295608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  295611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295625 */     GIR_RootConstrainSelectedInstOperands,
     /*  295626 */     // GIR_Coverage, 9108,
     /*  295626 */     GIR_EraseRootFromParent_Done,
     /*  295627 */   // Label 5516: @295627
     /*  295627 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(295690), // Rule ID 9109 //
     /*  295632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  295635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  295646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295671 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  295671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  295674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295688 */     GIR_RootConstrainSelectedInstOperands,
     /*  295689 */     // GIR_Coverage, 9109,
     /*  295689 */     GIR_EraseRootFromParent_Done,
     /*  295690 */   // Label 5517: @295690
     /*  295690 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(295753), // Rule ID 9200 //
     /*  295695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  295703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  295709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295734 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  295737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295751 */     GIR_RootConstrainSelectedInstOperands,
     /*  295752 */     // GIR_Coverage, 9200,
     /*  295752 */     GIR_EraseRootFromParent_Done,
     /*  295753 */   // Label 5518: @295753
     /*  295753 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(295816), // Rule ID 9201 //
     /*  295758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  295766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  295772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295797 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  295800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295814 */     GIR_RootConstrainSelectedInstOperands,
     /*  295815 */     // GIR_Coverage, 9201,
     /*  295815 */     GIR_EraseRootFromParent_Done,
     /*  295816 */   // Label 5519: @295816
     /*  295816 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(295879), // Rule ID 9204 //
     /*  295821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  295829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  295835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  295863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295877 */     GIR_RootConstrainSelectedInstOperands,
     /*  295878 */     // GIR_Coverage, 9204,
     /*  295878 */     GIR_EraseRootFromParent_Done,
     /*  295879 */   // Label 5520: @295879
     /*  295879 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(295942), // Rule ID 9205 //
     /*  295884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  295892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  295898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295923 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  295926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295940 */     GIR_RootConstrainSelectedInstOperands,
     /*  295941 */     // GIR_Coverage, 9205,
     /*  295941 */     GIR_EraseRootFromParent_Done,
     /*  295942 */   // Label 5521: @295942
     /*  295942 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(296005), // Rule ID 9208 //
     /*  295947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  295955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  295961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295986 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  295989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296003 */     GIR_RootConstrainSelectedInstOperands,
     /*  296004 */     // GIR_Coverage, 9208,
     /*  296004 */     GIR_EraseRootFromParent_Done,
     /*  296005 */   // Label 5522: @296005
     /*  296005 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(296068), // Rule ID 9209 //
     /*  296010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  296024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296049 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  296052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296066 */     GIR_RootConstrainSelectedInstOperands,
     /*  296067 */     // GIR_Coverage, 9209,
     /*  296067 */     GIR_EraseRootFromParent_Done,
     /*  296068 */   // Label 5523: @296068
     /*  296068 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(296131), // Rule ID 9212 //
     /*  296073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  296087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296112 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  296115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296129 */     GIR_RootConstrainSelectedInstOperands,
     /*  296130 */     // GIR_Coverage, 9212,
     /*  296130 */     GIR_EraseRootFromParent_Done,
     /*  296131 */   // Label 5524: @296131
     /*  296131 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(296194), // Rule ID 9213 //
     /*  296136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  296150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296175 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  296178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296192 */     GIR_RootConstrainSelectedInstOperands,
     /*  296193 */     // GIR_Coverage, 9213,
     /*  296193 */     GIR_EraseRootFromParent_Done,
     /*  296194 */   // Label 5525: @296194
     /*  296194 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(296257), // Rule ID 9216 //
     /*  296199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  296213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296238 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  296241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296255 */     GIR_RootConstrainSelectedInstOperands,
     /*  296256 */     // GIR_Coverage, 9216,
     /*  296256 */     GIR_EraseRootFromParent_Done,
     /*  296257 */   // Label 5526: @296257
     /*  296257 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(296320), // Rule ID 9217 //
     /*  296262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  296276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296301 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  296304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296318 */     GIR_RootConstrainSelectedInstOperands,
     /*  296319 */     // GIR_Coverage, 9217,
     /*  296319 */     GIR_EraseRootFromParent_Done,
     /*  296320 */   // Label 5527: @296320
     /*  296320 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(296383), // Rule ID 9220 //
     /*  296325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  296339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296364 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  296367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296381 */     GIR_RootConstrainSelectedInstOperands,
     /*  296382 */     // GIR_Coverage, 9220,
     /*  296382 */     GIR_EraseRootFromParent_Done,
     /*  296383 */   // Label 5528: @296383
     /*  296383 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(296446), // Rule ID 9221 //
     /*  296388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  296402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296427 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  296430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296444 */     GIR_RootConstrainSelectedInstOperands,
     /*  296445 */     // GIR_Coverage, 9221,
     /*  296445 */     GIR_EraseRootFromParent_Done,
     /*  296446 */   // Label 5529: @296446
     /*  296446 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(296509), // Rule ID 9224 //
     /*  296451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  296465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296490 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296507 */     GIR_RootConstrainSelectedInstOperands,
     /*  296508 */     // GIR_Coverage, 9224,
     /*  296508 */     GIR_EraseRootFromParent_Done,
     /*  296509 */   // Label 5530: @296509
     /*  296509 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(296572), // Rule ID 9225 //
     /*  296514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  296528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296553 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296570 */     GIR_RootConstrainSelectedInstOperands,
     /*  296571 */     // GIR_Coverage, 9225,
     /*  296571 */     GIR_EraseRootFromParent_Done,
     /*  296572 */   // Label 5531: @296572
     /*  296572 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(296635), // Rule ID 9228 //
     /*  296577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  296591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296616 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296633 */     GIR_RootConstrainSelectedInstOperands,
     /*  296634 */     // GIR_Coverage, 9228,
     /*  296634 */     GIR_EraseRootFromParent_Done,
     /*  296635 */   // Label 5532: @296635
     /*  296635 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(296698), // Rule ID 9229 //
     /*  296640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  296654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296679 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296696 */     GIR_RootConstrainSelectedInstOperands,
     /*  296697 */     // GIR_Coverage, 9229,
     /*  296697 */     GIR_EraseRootFromParent_Done,
     /*  296698 */   // Label 5533: @296698
     /*  296698 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(296761), // Rule ID 9232 //
     /*  296703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  296717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296742 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296759 */     GIR_RootConstrainSelectedInstOperands,
     /*  296760 */     // GIR_Coverage, 9232,
     /*  296760 */     GIR_EraseRootFromParent_Done,
     /*  296761 */   // Label 5534: @296761
     /*  296761 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(296824), // Rule ID 9233 //
     /*  296766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  296780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296805 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296822 */     GIR_RootConstrainSelectedInstOperands,
     /*  296823 */     // GIR_Coverage, 9233,
     /*  296823 */     GIR_EraseRootFromParent_Done,
     /*  296824 */   // Label 5535: @296824
     /*  296824 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(296887), // Rule ID 9236 //
     /*  296829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  296832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  296843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296868 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  296868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296885 */     GIR_RootConstrainSelectedInstOperands,
     /*  296886 */     // GIR_Coverage, 9236,
     /*  296886 */     GIR_EraseRootFromParent_Done,
     /*  296887 */   // Label 5536: @296887
     /*  296887 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(296950), // Rule ID 9237 //
     /*  296892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  296895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  296906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296931 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  296931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296948 */     GIR_RootConstrainSelectedInstOperands,
     /*  296949 */     // GIR_Coverage, 9237,
     /*  296949 */     GIR_EraseRootFromParent_Done,
     /*  296950 */   // Label 5537: @296950
     /*  296950 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(297013), // Rule ID 9240 //
     /*  296955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  296969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296994 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  296997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297011 */     GIR_RootConstrainSelectedInstOperands,
     /*  297012 */     // GIR_Coverage, 9240,
     /*  297012 */     GIR_EraseRootFromParent_Done,
     /*  297013 */   // Label 5538: @297013
     /*  297013 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(297076), // Rule ID 9241 //
     /*  297018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  297029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  297032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297057 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  297060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297074 */     GIR_RootConstrainSelectedInstOperands,
     /*  297075 */     // GIR_Coverage, 9241,
     /*  297075 */     GIR_EraseRootFromParent_Done,
     /*  297076 */   // Label 5539: @297076
     /*  297076 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(297139), // Rule ID 9244 //
     /*  297081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  297092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  297095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297120 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  297123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297137 */     GIR_RootConstrainSelectedInstOperands,
     /*  297138 */     // GIR_Coverage, 9244,
     /*  297138 */     GIR_EraseRootFromParent_Done,
     /*  297139 */   // Label 5540: @297139
     /*  297139 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(297202), // Rule ID 9245 //
     /*  297144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  297155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  297158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297183 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  297186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297200 */     GIR_RootConstrainSelectedInstOperands,
     /*  297201 */     // GIR_Coverage, 9245,
     /*  297201 */     GIR_EraseRootFromParent_Done,
     /*  297202 */   // Label 5541: @297202
     /*  297202 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(297265), // Rule ID 9248 //
     /*  297207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  297218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  297221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297246 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  297249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297263 */     GIR_RootConstrainSelectedInstOperands,
     /*  297264 */     // GIR_Coverage, 9248,
     /*  297264 */     GIR_EraseRootFromParent_Done,
     /*  297265 */   // Label 5542: @297265
     /*  297265 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(297328), // Rule ID 9249 //
     /*  297270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  297281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  297284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297309 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  297312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297326 */     GIR_RootConstrainSelectedInstOperands,
     /*  297327 */     // GIR_Coverage, 9249,
     /*  297327 */     GIR_EraseRootFromParent_Done,
     /*  297328 */   // Label 5543: @297328
     /*  297328 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(297391), // Rule ID 9252 //
     /*  297333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  297347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297372 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  297375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297389 */     GIR_RootConstrainSelectedInstOperands,
     /*  297390 */     // GIR_Coverage, 9252,
     /*  297390 */     GIR_EraseRootFromParent_Done,
     /*  297391 */   // Label 5544: @297391
     /*  297391 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(297454), // Rule ID 9253 //
     /*  297396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  297410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297435 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  297438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297452 */     GIR_RootConstrainSelectedInstOperands,
     /*  297453 */     // GIR_Coverage, 9253,
     /*  297453 */     GIR_EraseRootFromParent_Done,
     /*  297454 */   // Label 5545: @297454
     /*  297454 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(297517), // Rule ID 9256 //
     /*  297459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  297470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  297473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297498 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  297501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297515 */     GIR_RootConstrainSelectedInstOperands,
     /*  297516 */     // GIR_Coverage, 9256,
     /*  297516 */     GIR_EraseRootFromParent_Done,
     /*  297517 */   // Label 5546: @297517
     /*  297517 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(297580), // Rule ID 9257 //
     /*  297522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  297533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  297536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297561 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  297564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297578 */     GIR_RootConstrainSelectedInstOperands,
     /*  297579 */     // GIR_Coverage, 9257,
     /*  297579 */     GIR_EraseRootFromParent_Done,
     /*  297580 */   // Label 5547: @297580
     /*  297580 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(297643), // Rule ID 9260 //
     /*  297585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  297596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  297599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297624 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  297627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297641 */     GIR_RootConstrainSelectedInstOperands,
     /*  297642 */     // GIR_Coverage, 9260,
     /*  297642 */     GIR_EraseRootFromParent_Done,
     /*  297643 */   // Label 5548: @297643
     /*  297643 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(297706), // Rule ID 9261 //
     /*  297648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  297659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  297662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297687 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  297690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297704 */     GIR_RootConstrainSelectedInstOperands,
     /*  297705 */     // GIR_Coverage, 9261,
     /*  297705 */     GIR_EraseRootFromParent_Done,
     /*  297706 */   // Label 5549: @297706
     /*  297706 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(297769), // Rule ID 9264 //
     /*  297711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  297725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297750 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  297753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297767 */     GIR_RootConstrainSelectedInstOperands,
     /*  297768 */     // GIR_Coverage, 9264,
     /*  297768 */     GIR_EraseRootFromParent_Done,
     /*  297769 */   // Label 5550: @297769
     /*  297769 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(297832), // Rule ID 9265 //
     /*  297774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  297788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297813 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  297816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297830 */     GIR_RootConstrainSelectedInstOperands,
     /*  297831 */     // GIR_Coverage, 9265,
     /*  297831 */     GIR_EraseRootFromParent_Done,
     /*  297832 */   // Label 5551: @297832
     /*  297832 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(297895), // Rule ID 9268 //
     /*  297837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  297851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297876 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  297879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297893 */     GIR_RootConstrainSelectedInstOperands,
     /*  297894 */     // GIR_Coverage, 9268,
     /*  297894 */     GIR_EraseRootFromParent_Done,
     /*  297895 */   // Label 5552: @297895
     /*  297895 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(297958), // Rule ID 9269 //
     /*  297900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  297914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297939 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  297942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297956 */     GIR_RootConstrainSelectedInstOperands,
     /*  297957 */     // GIR_Coverage, 9269,
     /*  297957 */     GIR_EraseRootFromParent_Done,
     /*  297958 */   // Label 5553: @297958
     /*  297958 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(298021), // Rule ID 9272 //
     /*  297963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  297974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  297977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298002 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  298002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  298005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298019 */     GIR_RootConstrainSelectedInstOperands,
     /*  298020 */     // GIR_Coverage, 9272,
     /*  298020 */     GIR_EraseRootFromParent_Done,
     /*  298021 */   // Label 5554: @298021
     /*  298021 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(298084), // Rule ID 9273 //
     /*  298026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  298037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  298040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298065 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  298065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  298068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298082 */     GIR_RootConstrainSelectedInstOperands,
     /*  298083 */     // GIR_Coverage, 9273,
     /*  298083 */     GIR_EraseRootFromParent_Done,
     /*  298084 */   // Label 5555: @298084
     /*  298084 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(298147), // Rule ID 9276 //
     /*  298089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  298092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  298103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298128 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  298128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  298131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298145 */     GIR_RootConstrainSelectedInstOperands,
     /*  298146 */     // GIR_Coverage, 9276,
     /*  298146 */     GIR_EraseRootFromParent_Done,
     /*  298147 */   // Label 5556: @298147
     /*  298147 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(298210), // Rule ID 9277 //
     /*  298152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  298155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  298166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298191 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  298191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  298194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298208 */     GIR_RootConstrainSelectedInstOperands,
     /*  298209 */     // GIR_Coverage, 9277,
     /*  298209 */     GIR_EraseRootFromParent_Done,
     /*  298210 */   // Label 5557: @298210
     /*  298210 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(298273), // Rule ID 9280 //
     /*  298215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  298218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  298229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298254 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  298254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  298257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298271 */     GIR_RootConstrainSelectedInstOperands,
     /*  298272 */     // GIR_Coverage, 9280,
     /*  298272 */     GIR_EraseRootFromParent_Done,
     /*  298273 */   // Label 5558: @298273
     /*  298273 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(298336), // Rule ID 9281 //
     /*  298278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  298281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  298292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298317 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  298317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  298320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298334 */     GIR_RootConstrainSelectedInstOperands,
     /*  298335 */     // GIR_Coverage, 9281,
     /*  298335 */     GIR_EraseRootFromParent_Done,
     /*  298336 */   // Label 5559: @298336
     /*  298336 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(298399), // Rule ID 9284 //
     /*  298341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  298344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  298355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298380 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  298380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  298383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298397 */     GIR_RootConstrainSelectedInstOperands,
     /*  298398 */     // GIR_Coverage, 9284,
     /*  298398 */     GIR_EraseRootFromParent_Done,
     /*  298399 */   // Label 5560: @298399
     /*  298399 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(298462), // Rule ID 9285 //
     /*  298404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  298407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  298418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298443 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  298443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  298446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298460 */     GIR_RootConstrainSelectedInstOperands,
     /*  298461 */     // GIR_Coverage, 9285,
     /*  298461 */     GIR_EraseRootFromParent_Done,
     /*  298462 */   // Label 5561: @298462
     /*  298462 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(298525), // Rule ID 9376 //
     /*  298467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  298481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298506 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  298509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298523 */     GIR_RootConstrainSelectedInstOperands,
     /*  298524 */     // GIR_Coverage, 9376,
     /*  298524 */     GIR_EraseRootFromParent_Done,
     /*  298525 */   // Label 5562: @298525
     /*  298525 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(298588), // Rule ID 9377 //
     /*  298530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  298544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298569 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  298572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298586 */     GIR_RootConstrainSelectedInstOperands,
     /*  298587 */     // GIR_Coverage, 9377,
     /*  298587 */     GIR_EraseRootFromParent_Done,
     /*  298588 */   // Label 5563: @298588
     /*  298588 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(298651), // Rule ID 9380 //
     /*  298593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  298607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298632 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  298635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298649 */     GIR_RootConstrainSelectedInstOperands,
     /*  298650 */     // GIR_Coverage, 9380,
     /*  298650 */     GIR_EraseRootFromParent_Done,
     /*  298651 */   // Label 5564: @298651
     /*  298651 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(298714), // Rule ID 9381 //
     /*  298656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  298670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298695 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  298698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298712 */     GIR_RootConstrainSelectedInstOperands,
     /*  298713 */     // GIR_Coverage, 9381,
     /*  298713 */     GIR_EraseRootFromParent_Done,
     /*  298714 */   // Label 5565: @298714
     /*  298714 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(298777), // Rule ID 9384 //
     /*  298719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  298733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298758 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  298761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298775 */     GIR_RootConstrainSelectedInstOperands,
     /*  298776 */     // GIR_Coverage, 9384,
     /*  298776 */     GIR_EraseRootFromParent_Done,
     /*  298777 */   // Label 5566: @298777
     /*  298777 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(298840), // Rule ID 9385 //
     /*  298782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  298796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298821 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  298824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298838 */     GIR_RootConstrainSelectedInstOperands,
     /*  298839 */     // GIR_Coverage, 9385,
     /*  298839 */     GIR_EraseRootFromParent_Done,
     /*  298840 */   // Label 5567: @298840
     /*  298840 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(298903), // Rule ID 9388 //
     /*  298845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  298859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298884 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  298887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298901 */     GIR_RootConstrainSelectedInstOperands,
     /*  298902 */     // GIR_Coverage, 9388,
     /*  298902 */     GIR_EraseRootFromParent_Done,
     /*  298903 */   // Label 5568: @298903
     /*  298903 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(298966), // Rule ID 9389 //
     /*  298908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  298922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298947 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  298950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298964 */     GIR_RootConstrainSelectedInstOperands,
     /*  298965 */     // GIR_Coverage, 9389,
     /*  298965 */     GIR_EraseRootFromParent_Done,
     /*  298966 */   // Label 5569: @298966
     /*  298966 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(299029), // Rule ID 9392 //
     /*  298971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  298985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299010 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  299013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299027 */     GIR_RootConstrainSelectedInstOperands,
     /*  299028 */     // GIR_Coverage, 9392,
     /*  299028 */     GIR_EraseRootFromParent_Done,
     /*  299029 */   // Label 5570: @299029
     /*  299029 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(299092), // Rule ID 9393 //
     /*  299034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  299048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299073 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  299076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299090 */     GIR_RootConstrainSelectedInstOperands,
     /*  299091 */     // GIR_Coverage, 9393,
     /*  299091 */     GIR_EraseRootFromParent_Done,
     /*  299092 */   // Label 5571: @299092
     /*  299092 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(299155), // Rule ID 9396 //
     /*  299097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  299108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  299111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299136 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  299139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299153 */     GIR_RootConstrainSelectedInstOperands,
     /*  299154 */     // GIR_Coverage, 9396,
     /*  299154 */     GIR_EraseRootFromParent_Done,
     /*  299155 */   // Label 5572: @299155
     /*  299155 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(299218), // Rule ID 9397 //
     /*  299160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  299171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  299174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299199 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  299202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299216 */     GIR_RootConstrainSelectedInstOperands,
     /*  299217 */     // GIR_Coverage, 9397,
     /*  299217 */     GIR_EraseRootFromParent_Done,
     /*  299218 */   // Label 5573: @299218
     /*  299218 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(299281), // Rule ID 9400 //
     /*  299223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  299237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299262 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299279 */     GIR_RootConstrainSelectedInstOperands,
     /*  299280 */     // GIR_Coverage, 9400,
     /*  299280 */     GIR_EraseRootFromParent_Done,
     /*  299281 */   // Label 5574: @299281
     /*  299281 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(299344), // Rule ID 9401 //
     /*  299286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  299300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299325 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299342 */     GIR_RootConstrainSelectedInstOperands,
     /*  299343 */     // GIR_Coverage, 9401,
     /*  299343 */     GIR_EraseRootFromParent_Done,
     /*  299344 */   // Label 5575: @299344
     /*  299344 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(299407), // Rule ID 9404 //
     /*  299349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  299363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299388 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299405 */     GIR_RootConstrainSelectedInstOperands,
     /*  299406 */     // GIR_Coverage, 9404,
     /*  299406 */     GIR_EraseRootFromParent_Done,
     /*  299407 */   // Label 5576: @299407
     /*  299407 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(299470), // Rule ID 9405 //
     /*  299412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  299426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299451 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299468 */     GIR_RootConstrainSelectedInstOperands,
     /*  299469 */     // GIR_Coverage, 9405,
     /*  299469 */     GIR_EraseRootFromParent_Done,
     /*  299470 */   // Label 5577: @299470
     /*  299470 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(299533), // Rule ID 9408 //
     /*  299475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  299489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299514 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299531 */     GIR_RootConstrainSelectedInstOperands,
     /*  299532 */     // GIR_Coverage, 9408,
     /*  299532 */     GIR_EraseRootFromParent_Done,
     /*  299533 */   // Label 5578: @299533
     /*  299533 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(299596), // Rule ID 9409 //
     /*  299538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  299552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299577 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299594 */     GIR_RootConstrainSelectedInstOperands,
     /*  299595 */     // GIR_Coverage, 9409,
     /*  299595 */     GIR_EraseRootFromParent_Done,
     /*  299596 */   // Label 5579: @299596
     /*  299596 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(299659), // Rule ID 9412 //
     /*  299601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  299604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  299612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  299615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299640 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299657 */     GIR_RootConstrainSelectedInstOperands,
     /*  299658 */     // GIR_Coverage, 9412,
     /*  299658 */     GIR_EraseRootFromParent_Done,
     /*  299659 */   // Label 5580: @299659
     /*  299659 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(299722), // Rule ID 9413 //
     /*  299664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  299667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  299675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  299678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299703 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  299703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299720 */     GIR_RootConstrainSelectedInstOperands,
     /*  299721 */     // GIR_Coverage, 9413,
     /*  299721 */     GIR_EraseRootFromParent_Done,
     /*  299722 */   // Label 5581: @299722
     /*  299722 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(299785), // Rule ID 9416 //
     /*  299727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  299741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299766 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  299769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299783 */     GIR_RootConstrainSelectedInstOperands,
     /*  299784 */     // GIR_Coverage, 9416,
     /*  299784 */     GIR_EraseRootFromParent_Done,
     /*  299785 */   // Label 5582: @299785
     /*  299785 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(299848), // Rule ID 9417 //
     /*  299790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  299804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299829 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  299832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299846 */     GIR_RootConstrainSelectedInstOperands,
     /*  299847 */     // GIR_Coverage, 9417,
     /*  299847 */     GIR_EraseRootFromParent_Done,
     /*  299848 */   // Label 5583: @299848
     /*  299848 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(299911), // Rule ID 9420 //
     /*  299853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  299867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299892 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  299895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299909 */     GIR_RootConstrainSelectedInstOperands,
     /*  299910 */     // GIR_Coverage, 9420,
     /*  299910 */     GIR_EraseRootFromParent_Done,
     /*  299911 */   // Label 5584: @299911
     /*  299911 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(299974), // Rule ID 9421 //
     /*  299916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  299930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299955 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  299958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299972 */     GIR_RootConstrainSelectedInstOperands,
     /*  299973 */     // GIR_Coverage, 9421,
     /*  299973 */     GIR_EraseRootFromParent_Done,
     /*  299974 */   // Label 5585: @299974
     /*  299974 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(300037), // Rule ID 9424 //
     /*  299979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  299990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  299993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300018 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  300021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300035 */     GIR_RootConstrainSelectedInstOperands,
     /*  300036 */     // GIR_Coverage, 9424,
     /*  300036 */     GIR_EraseRootFromParent_Done,
     /*  300037 */   // Label 5586: @300037
     /*  300037 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(300100), // Rule ID 9425 //
     /*  300042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  300053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  300056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300081 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  300084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300098 */     GIR_RootConstrainSelectedInstOperands,
     /*  300099 */     // GIR_Coverage, 9425,
     /*  300099 */     GIR_EraseRootFromParent_Done,
     /*  300100 */   // Label 5587: @300100
     /*  300100 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(300163), // Rule ID 9428 //
     /*  300105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  300119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300144 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  300147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300161 */     GIR_RootConstrainSelectedInstOperands,
     /*  300162 */     // GIR_Coverage, 9428,
     /*  300162 */     GIR_EraseRootFromParent_Done,
     /*  300163 */   // Label 5588: @300163
     /*  300163 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(300226), // Rule ID 9429 //
     /*  300168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  300182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300207 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  300210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300224 */     GIR_RootConstrainSelectedInstOperands,
     /*  300225 */     // GIR_Coverage, 9429,
     /*  300225 */     GIR_EraseRootFromParent_Done,
     /*  300226 */   // Label 5589: @300226
     /*  300226 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(300289), // Rule ID 9432 //
     /*  300231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  300245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300270 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  300273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300287 */     GIR_RootConstrainSelectedInstOperands,
     /*  300288 */     // GIR_Coverage, 9432,
     /*  300288 */     GIR_EraseRootFromParent_Done,
     /*  300289 */   // Label 5590: @300289
     /*  300289 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(300352), // Rule ID 9433 //
     /*  300294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  300308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300333 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  300336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300350 */     GIR_RootConstrainSelectedInstOperands,
     /*  300351 */     // GIR_Coverage, 9433,
     /*  300351 */     GIR_EraseRootFromParent_Done,
     /*  300352 */   // Label 5591: @300352
     /*  300352 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(300415), // Rule ID 9436 //
     /*  300357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  300368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  300371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300396 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  300399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300413 */     GIR_RootConstrainSelectedInstOperands,
     /*  300414 */     // GIR_Coverage, 9436,
     /*  300414 */     GIR_EraseRootFromParent_Done,
     /*  300415 */   // Label 5592: @300415
     /*  300415 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(300478), // Rule ID 9437 //
     /*  300420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  300431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  300434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300459 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  300462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300476 */     GIR_RootConstrainSelectedInstOperands,
     /*  300477 */     // GIR_Coverage, 9437,
     /*  300477 */     GIR_EraseRootFromParent_Done,
     /*  300478 */   // Label 5593: @300478
     /*  300478 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(300541), // Rule ID 9440 //
     /*  300483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  300497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300522 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  300525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300539 */     GIR_RootConstrainSelectedInstOperands,
     /*  300540 */     // GIR_Coverage, 9440,
     /*  300540 */     GIR_EraseRootFromParent_Done,
     /*  300541 */   // Label 5594: @300541
     /*  300541 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(300604), // Rule ID 9441 //
     /*  300546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  300560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300585 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  300588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300602 */     GIR_RootConstrainSelectedInstOperands,
     /*  300603 */     // GIR_Coverage, 9441,
     /*  300603 */     GIR_EraseRootFromParent_Done,
     /*  300604 */   // Label 5595: @300604
     /*  300604 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(300667), // Rule ID 9444 //
     /*  300609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  300623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300648 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  300651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300665 */     GIR_RootConstrainSelectedInstOperands,
     /*  300666 */     // GIR_Coverage, 9444,
     /*  300666 */     GIR_EraseRootFromParent_Done,
     /*  300667 */   // Label 5596: @300667
     /*  300667 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(300730), // Rule ID 9445 //
     /*  300672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  300686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300711 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  300714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300728 */     GIR_RootConstrainSelectedInstOperands,
     /*  300729 */     // GIR_Coverage, 9445,
     /*  300729 */     GIR_EraseRootFromParent_Done,
     /*  300730 */   // Label 5597: @300730
     /*  300730 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(300793), // Rule ID 9448 //
     /*  300735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  300749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300774 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  300777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300791 */     GIR_RootConstrainSelectedInstOperands,
     /*  300792 */     // GIR_Coverage, 9448,
     /*  300792 */     GIR_EraseRootFromParent_Done,
     /*  300793 */   // Label 5598: @300793
     /*  300793 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(300856), // Rule ID 9449 //
     /*  300798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  300812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300837 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  300840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300854 */     GIR_RootConstrainSelectedInstOperands,
     /*  300855 */     // GIR_Coverage, 9449,
     /*  300855 */     GIR_EraseRootFromParent_Done,
     /*  300856 */   // Label 5599: @300856
     /*  300856 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(300919), // Rule ID 9452 //
     /*  300861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  300864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  300875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300900 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  300900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  300903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300917 */     GIR_RootConstrainSelectedInstOperands,
     /*  300918 */     // GIR_Coverage, 9452,
     /*  300918 */     GIR_EraseRootFromParent_Done,
     /*  300919 */   // Label 5600: @300919
     /*  300919 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(300982), // Rule ID 9453 //
     /*  300924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  300927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  300938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300963 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  300963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  300966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300980 */     GIR_RootConstrainSelectedInstOperands,
     /*  300981 */     // GIR_Coverage, 9453,
     /*  300981 */     GIR_EraseRootFromParent_Done,
     /*  300982 */   // Label 5601: @300982
     /*  300982 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(301045), // Rule ID 9456 //
     /*  300987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  300990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  301001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  301004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  301019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301026 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  301026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  301029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  301033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  301035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301043 */     GIR_RootConstrainSelectedInstOperands,
     /*  301044 */     // GIR_Coverage, 9456,
     /*  301044 */     GIR_EraseRootFromParent_Done,
     /*  301045 */   // Label 5602: @301045
     /*  301045 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(301108), // Rule ID 9457 //
     /*  301050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  301053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  301061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  301064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  301067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  301082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301089 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  301089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  301092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  301096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  301098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301106 */     GIR_RootConstrainSelectedInstOperands,
     /*  301107 */     // GIR_Coverage, 9457,
     /*  301107 */     GIR_EraseRootFromParent_Done,
     /*  301108 */   // Label 5603: @301108
     /*  301108 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(301171), // Rule ID 9460 //
     /*  301113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  301116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  301127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  301130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  301145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301152 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  301152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  301155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  301159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  301161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301169 */     GIR_RootConstrainSelectedInstOperands,
     /*  301170 */     // GIR_Coverage, 9460,
     /*  301170 */     GIR_EraseRootFromParent_Done,
     /*  301171 */   // Label 5604: @301171
     /*  301171 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(301234), // Rule ID 9461 //
     /*  301176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  301179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  301190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  301193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  301208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301215 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  301215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  301218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  301222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  301224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301232 */     GIR_RootConstrainSelectedInstOperands,
     /*  301233 */     // GIR_Coverage, 9461,
     /*  301233 */     GIR_EraseRootFromParent_Done,
     /*  301234 */   // Label 5605: @301234
     /*  301234 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(301297), // Rule ID 9552 //
     /*  301239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  301253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  301256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301278 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  301281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301295 */     GIR_RootConstrainSelectedInstOperands,
     /*  301296 */     // GIR_Coverage, 9552,
     /*  301296 */     GIR_EraseRootFromParent_Done,
     /*  301297 */   // Label 5606: @301297
     /*  301297 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(301360), // Rule ID 9553 //
     /*  301302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  301316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  301319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301341 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  301344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301358 */     GIR_RootConstrainSelectedInstOperands,
     /*  301359 */     // GIR_Coverage, 9553,
     /*  301359 */     GIR_EraseRootFromParent_Done,
     /*  301360 */   // Label 5607: @301360
     /*  301360 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(301423), // Rule ID 9556 //
     /*  301365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  301376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  301379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  301382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301404 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  301407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301421 */     GIR_RootConstrainSelectedInstOperands,
     /*  301422 */     // GIR_Coverage, 9556,
     /*  301422 */     GIR_EraseRootFromParent_Done,
     /*  301423 */   // Label 5608: @301423
     /*  301423 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(301486), // Rule ID 9557 //
     /*  301428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  301439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  301442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  301445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301467 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  301470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301484 */     GIR_RootConstrainSelectedInstOperands,
     /*  301485 */     // GIR_Coverage, 9557,
     /*  301485 */     GIR_EraseRootFromParent_Done,
     /*  301486 */   // Label 5609: @301486
     /*  301486 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(301549), // Rule ID 9560 //
     /*  301491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  301505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  301508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301530 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  301533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301547 */     GIR_RootConstrainSelectedInstOperands,
     /*  301548 */     // GIR_Coverage, 9560,
     /*  301548 */     GIR_EraseRootFromParent_Done,
     /*  301549 */   // Label 5610: @301549
     /*  301549 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(301612), // Rule ID 9561 //
     /*  301554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  301568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  301571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301593 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  301596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301610 */     GIR_RootConstrainSelectedInstOperands,
     /*  301611 */     // GIR_Coverage, 9561,
     /*  301611 */     GIR_EraseRootFromParent_Done,
     /*  301612 */   // Label 5611: @301612
     /*  301612 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(301675), // Rule ID 9564 //
     /*  301617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  301631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  301634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301656 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  301659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301673 */     GIR_RootConstrainSelectedInstOperands,
     /*  301674 */     // GIR_Coverage, 9564,
     /*  301674 */     GIR_EraseRootFromParent_Done,
     /*  301675 */   // Label 5612: @301675
     /*  301675 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(301738), // Rule ID 9565 //
     /*  301680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  301694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  301697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301719 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  301722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301736 */     GIR_RootConstrainSelectedInstOperands,
     /*  301737 */     // GIR_Coverage, 9565,
     /*  301737 */     GIR_EraseRootFromParent_Done,
     /*  301738 */   // Label 5613: @301738
     /*  301738 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(301801), // Rule ID 9568 //
     /*  301743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  301757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  301760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301782 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  301782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  301785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301799 */     GIR_RootConstrainSelectedInstOperands,
     /*  301800 */     // GIR_Coverage, 9568,
     /*  301800 */     GIR_EraseRootFromParent_Done,
     /*  301801 */   // Label 5614: @301801
     /*  301801 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(301864), // Rule ID 9569 //
     /*  301806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  301820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  301823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301845 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  301845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  301848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301862 */     GIR_RootConstrainSelectedInstOperands,
     /*  301863 */     // GIR_Coverage, 9569,
     /*  301863 */     GIR_EraseRootFromParent_Done,
     /*  301864 */   // Label 5615: @301864
     /*  301864 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(301927), // Rule ID 9572 //
     /*  301869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  301883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  301886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301908 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  301911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301925 */     GIR_RootConstrainSelectedInstOperands,
     /*  301926 */     // GIR_Coverage, 9572,
     /*  301926 */     GIR_EraseRootFromParent_Done,
     /*  301927 */   // Label 5616: @301927
     /*  301927 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(301990), // Rule ID 9573 //
     /*  301932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  301946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  301949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301971 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  301974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301988 */     GIR_RootConstrainSelectedInstOperands,
     /*  301989 */     // GIR_Coverage, 9573,
     /*  301989 */     GIR_EraseRootFromParent_Done,
     /*  301990 */   // Label 5617: @301990
     /*  301990 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(302053), // Rule ID 9576 //
     /*  301995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  302009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  302012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302034 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  302037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302051 */     GIR_RootConstrainSelectedInstOperands,
     /*  302052 */     // GIR_Coverage, 9576,
     /*  302052 */     GIR_EraseRootFromParent_Done,
     /*  302053 */   // Label 5618: @302053
     /*  302053 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(302116), // Rule ID 9577 //
     /*  302058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  302072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  302075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302097 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  302100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302114 */     GIR_RootConstrainSelectedInstOperands,
     /*  302115 */     // GIR_Coverage, 9577,
     /*  302115 */     GIR_EraseRootFromParent_Done,
     /*  302116 */   // Label 5619: @302116
     /*  302116 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(302179), // Rule ID 9580 //
     /*  302121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  302135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  302138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302160 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  302163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302177 */     GIR_RootConstrainSelectedInstOperands,
     /*  302178 */     // GIR_Coverage, 9580,
     /*  302178 */     GIR_EraseRootFromParent_Done,
     /*  302179 */   // Label 5620: @302179
     /*  302179 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(302242), // Rule ID 9581 //
     /*  302184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  302198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  302201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302223 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  302226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302240 */     GIR_RootConstrainSelectedInstOperands,
     /*  302241 */     // GIR_Coverage, 9581,
     /*  302241 */     GIR_EraseRootFromParent_Done,
     /*  302242 */   // Label 5621: @302242
     /*  302242 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(302305), // Rule ID 9584 //
     /*  302247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  302250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  302258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  302261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  302264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302286 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  302289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302303 */     GIR_RootConstrainSelectedInstOperands,
     /*  302304 */     // GIR_Coverage, 9584,
     /*  302304 */     GIR_EraseRootFromParent_Done,
     /*  302305 */   // Label 5622: @302305
     /*  302305 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(302368), // Rule ID 9585 //
     /*  302310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  302313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  302321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  302324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  302327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302349 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  302352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302366 */     GIR_RootConstrainSelectedInstOperands,
     /*  302367 */     // GIR_Coverage, 9585,
     /*  302367 */     GIR_EraseRootFromParent_Done,
     /*  302368 */   // Label 5623: @302368
     /*  302368 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(302431), // Rule ID 9588 //
     /*  302373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  302387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  302390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302412 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  302415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302429 */     GIR_RootConstrainSelectedInstOperands,
     /*  302430 */     // GIR_Coverage, 9588,
     /*  302430 */     GIR_EraseRootFromParent_Done,
     /*  302431 */   // Label 5624: @302431
     /*  302431 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(302494), // Rule ID 9589 //
     /*  302436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  302450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  302453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302475 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  302478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302492 */     GIR_RootConstrainSelectedInstOperands,
     /*  302493 */     // GIR_Coverage, 9589,
     /*  302493 */     GIR_EraseRootFromParent_Done,
     /*  302494 */   // Label 5625: @302494
     /*  302494 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(302557), // Rule ID 9592 //
     /*  302499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  302510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  302513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  302516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302538 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  302541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302555 */     GIR_RootConstrainSelectedInstOperands,
     /*  302556 */     // GIR_Coverage, 9592,
     /*  302556 */     GIR_EraseRootFromParent_Done,
     /*  302557 */   // Label 5626: @302557
     /*  302557 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(302620), // Rule ID 9593 //
     /*  302562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  302573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  302576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  302579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302601 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  302604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302618 */     GIR_RootConstrainSelectedInstOperands,
     /*  302619 */     // GIR_Coverage, 9593,
     /*  302619 */     GIR_EraseRootFromParent_Done,
     /*  302620 */   // Label 5627: @302620
     /*  302620 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(302683), // Rule ID 9596 //
     /*  302625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  302636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  302639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  302642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302664 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  302667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302681 */     GIR_RootConstrainSelectedInstOperands,
     /*  302682 */     // GIR_Coverage, 9596,
     /*  302682 */     GIR_EraseRootFromParent_Done,
     /*  302683 */   // Label 5628: @302683
     /*  302683 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(302746), // Rule ID 9597 //
     /*  302688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  302699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  302702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  302705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302727 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  302730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302744 */     GIR_RootConstrainSelectedInstOperands,
     /*  302745 */     // GIR_Coverage, 9597,
     /*  302745 */     GIR_EraseRootFromParent_Done,
     /*  302746 */   // Label 5629: @302746
     /*  302746 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(302809), // Rule ID 9600 //
     /*  302751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  302765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  302768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302790 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  302793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302807 */     GIR_RootConstrainSelectedInstOperands,
     /*  302808 */     // GIR_Coverage, 9600,
     /*  302808 */     GIR_EraseRootFromParent_Done,
     /*  302809 */   // Label 5630: @302809
     /*  302809 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(302872), // Rule ID 9601 //
     /*  302814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  302828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  302831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302853 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  302856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302870 */     GIR_RootConstrainSelectedInstOperands,
     /*  302871 */     // GIR_Coverage, 9601,
     /*  302871 */     GIR_EraseRootFromParent_Done,
     /*  302872 */   // Label 5631: @302872
     /*  302872 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(302935), // Rule ID 9604 //
     /*  302877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  302891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  302894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302916 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  302919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302933 */     GIR_RootConstrainSelectedInstOperands,
     /*  302934 */     // GIR_Coverage, 9604,
     /*  302934 */     GIR_EraseRootFromParent_Done,
     /*  302935 */   // Label 5632: @302935
     /*  302935 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(302998), // Rule ID 9605 //
     /*  302940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  302954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  302957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302979 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  302982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302996 */     GIR_RootConstrainSelectedInstOperands,
     /*  302997 */     // GIR_Coverage, 9605,
     /*  302997 */     GIR_EraseRootFromParent_Done,
     /*  302998 */   // Label 5633: @302998
     /*  302998 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(303061), // Rule ID 9608 //
     /*  303003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  303014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  303017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  303020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303042 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  303045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303059 */     GIR_RootConstrainSelectedInstOperands,
     /*  303060 */     // GIR_Coverage, 9608,
     /*  303060 */     GIR_EraseRootFromParent_Done,
     /*  303061 */   // Label 5634: @303061
     /*  303061 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(303124), // Rule ID 9609 //
     /*  303066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  303077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  303080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  303083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303105 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  303105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  303108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303122 */     GIR_RootConstrainSelectedInstOperands,
     /*  303123 */     // GIR_Coverage, 9609,
     /*  303123 */     GIR_EraseRootFromParent_Done,
     /*  303124 */   // Label 5635: @303124
     /*  303124 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(303187), // Rule ID 9612 //
     /*  303129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  303143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  303146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303168 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  303168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  303171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303185 */     GIR_RootConstrainSelectedInstOperands,
     /*  303186 */     // GIR_Coverage, 9612,
     /*  303186 */     GIR_EraseRootFromParent_Done,
     /*  303187 */   // Label 5636: @303187
     /*  303187 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(303250), // Rule ID 9613 //
     /*  303192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  303206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  303209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303231 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  303231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  303234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303248 */     GIR_RootConstrainSelectedInstOperands,
     /*  303249 */     // GIR_Coverage, 9613,
     /*  303249 */     GIR_EraseRootFromParent_Done,
     /*  303250 */   // Label 5637: @303250
     /*  303250 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(303313), // Rule ID 9616 //
     /*  303255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  303269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  303272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303294 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  303294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  303297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303311 */     GIR_RootConstrainSelectedInstOperands,
     /*  303312 */     // GIR_Coverage, 9616,
     /*  303312 */     GIR_EraseRootFromParent_Done,
     /*  303313 */   // Label 5638: @303313
     /*  303313 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(303376), // Rule ID 9617 //
     /*  303318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  303332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  303335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303357 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  303357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  303360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303374 */     GIR_RootConstrainSelectedInstOperands,
     /*  303375 */     // GIR_Coverage, 9617,
     /*  303375 */     GIR_EraseRootFromParent_Done,
     /*  303376 */   // Label 5639: @303376
     /*  303376 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(303439), // Rule ID 9620 //
     /*  303381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  303392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  303395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  303398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303420 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  303420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  303423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303437 */     GIR_RootConstrainSelectedInstOperands,
     /*  303438 */     // GIR_Coverage, 9620,
     /*  303438 */     GIR_EraseRootFromParent_Done,
     /*  303439 */   // Label 5640: @303439
     /*  303439 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(303502), // Rule ID 9621 //
     /*  303444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  303455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  303458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  303461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303483 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  303483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  303486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303500 */     GIR_RootConstrainSelectedInstOperands,
     /*  303501 */     // GIR_Coverage, 9621,
     /*  303501 */     GIR_EraseRootFromParent_Done,
     /*  303502 */   // Label 5641: @303502
     /*  303502 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(303565), // Rule ID 9624 //
     /*  303507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  303510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  303521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  303524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303546 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  303546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  303549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303563 */     GIR_RootConstrainSelectedInstOperands,
     /*  303564 */     // GIR_Coverage, 9624,
     /*  303564 */     GIR_EraseRootFromParent_Done,
     /*  303565 */   // Label 5642: @303565
     /*  303565 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(303628), // Rule ID 9625 //
     /*  303570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  303573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  303584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  303587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303609 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  303609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  303612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303626 */     GIR_RootConstrainSelectedInstOperands,
     /*  303627 */     // GIR_Coverage, 9625,
     /*  303627 */     GIR_EraseRootFromParent_Done,
     /*  303628 */   // Label 5643: @303628
     /*  303628 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(303691), // Rule ID 9628 //
     /*  303633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  303636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  303647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  303650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303672 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  303672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  303675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303689 */     GIR_RootConstrainSelectedInstOperands,
     /*  303690 */     // GIR_Coverage, 9628,
     /*  303690 */     GIR_EraseRootFromParent_Done,
     /*  303691 */   // Label 5644: @303691
     /*  303691 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(303754), // Rule ID 9629 //
     /*  303696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  303699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  303710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  303713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303735 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  303735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  303738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303752 */     GIR_RootConstrainSelectedInstOperands,
     /*  303753 */     // GIR_Coverage, 9629,
     /*  303753 */     GIR_EraseRootFromParent_Done,
     /*  303754 */   // Label 5645: @303754
     /*  303754 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(303817), // Rule ID 9632 //
     /*  303759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  303762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  303773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  303776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303798 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  303798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  303801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303815 */     GIR_RootConstrainSelectedInstOperands,
     /*  303816 */     // GIR_Coverage, 9632,
     /*  303816 */     GIR_EraseRootFromParent_Done,
     /*  303817 */   // Label 5646: @303817
     /*  303817 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(303880), // Rule ID 9633 //
     /*  303822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  303825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  303836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  303839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303861 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  303861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  303864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303878 */     GIR_RootConstrainSelectedInstOperands,
     /*  303879 */     // GIR_Coverage, 9633,
     /*  303879 */     GIR_EraseRootFromParent_Done,
     /*  303880 */   // Label 5647: @303880
     /*  303880 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(303943), // Rule ID 9636 //
     /*  303885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  303893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  303899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  303902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303924 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  303927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303941 */     GIR_RootConstrainSelectedInstOperands,
     /*  303942 */     // GIR_Coverage, 9636,
     /*  303942 */     GIR_EraseRootFromParent_Done,
     /*  303943 */   // Label 5648: @303943
     /*  303943 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(304006), // Rule ID 9637 //
     /*  303948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  303956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  303962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  303965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303987 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  303990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304004 */     GIR_RootConstrainSelectedInstOperands,
     /*  304005 */     // GIR_Coverage, 9637,
     /*  304005 */     GIR_EraseRootFromParent_Done,
     /*  304006 */   // Label 5649: @304006
     /*  304006 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(304069), // Rule ID 9640 //
     /*  304011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  304025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  304028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304050 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  304053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304067 */     GIR_RootConstrainSelectedInstOperands,
     /*  304068 */     // GIR_Coverage, 9640,
     /*  304068 */     GIR_EraseRootFromParent_Done,
     /*  304069 */   // Label 5650: @304069
     /*  304069 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(304132), // Rule ID 9641 //
     /*  304074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  304088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  304091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304113 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  304116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304130 */     GIR_RootConstrainSelectedInstOperands,
     /*  304131 */     // GIR_Coverage, 9641,
     /*  304131 */     GIR_EraseRootFromParent_Done,
     /*  304132 */   // Label 5651: @304132
     /*  304132 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(304195), // Rule ID 9644 //
     /*  304137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  304151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  304154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  304179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304193 */     GIR_RootConstrainSelectedInstOperands,
     /*  304194 */     // GIR_Coverage, 9644,
     /*  304194 */     GIR_EraseRootFromParent_Done,
     /*  304195 */   // Label 5652: @304195
     /*  304195 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(304258), // Rule ID 9645 //
     /*  304200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  304214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  304217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304239 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  304242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304256 */     GIR_RootConstrainSelectedInstOperands,
     /*  304257 */     // GIR_Coverage, 9645,
     /*  304257 */     GIR_EraseRootFromParent_Done,
     /*  304258 */   // Label 5653: @304258
     /*  304258 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(304321), // Rule ID 9648 //
     /*  304263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  304277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  304280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304302 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  304305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304319 */     GIR_RootConstrainSelectedInstOperands,
     /*  304320 */     // GIR_Coverage, 9648,
     /*  304320 */     GIR_EraseRootFromParent_Done,
     /*  304321 */   // Label 5654: @304321
     /*  304321 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(304384), // Rule ID 9649 //
     /*  304326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  304340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  304343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304365 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  304368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304382 */     GIR_RootConstrainSelectedInstOperands,
     /*  304383 */     // GIR_Coverage, 9649,
     /*  304383 */     GIR_EraseRootFromParent_Done,
     /*  304384 */   // Label 5655: @304384
     /*  304384 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(304447), // Rule ID 9652 //
     /*  304389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  304403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  304406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304428 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  304431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304445 */     GIR_RootConstrainSelectedInstOperands,
     /*  304446 */     // GIR_Coverage, 9652,
     /*  304446 */     GIR_EraseRootFromParent_Done,
     /*  304447 */   // Label 5656: @304447
     /*  304447 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(304510), // Rule ID 9653 //
     /*  304452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  304466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  304469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304491 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  304494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304508 */     GIR_RootConstrainSelectedInstOperands,
     /*  304509 */     // GIR_Coverage, 9653,
     /*  304509 */     GIR_EraseRootFromParent_Done,
     /*  304510 */   // Label 5657: @304510
     /*  304510 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(304573), // Rule ID 9656 //
     /*  304515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  304529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  304532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304554 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  304554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  304557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304571 */     GIR_RootConstrainSelectedInstOperands,
     /*  304572 */     // GIR_Coverage, 9656,
     /*  304572 */     GIR_EraseRootFromParent_Done,
     /*  304573 */   // Label 5658: @304573
     /*  304573 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(304636), // Rule ID 9657 //
     /*  304578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  304592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  304595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304617 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  304617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  304620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304634 */     GIR_RootConstrainSelectedInstOperands,
     /*  304635 */     // GIR_Coverage, 9657,
     /*  304635 */     GIR_EraseRootFromParent_Done,
     /*  304636 */   // Label 5659: @304636
     /*  304636 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(304699), // Rule ID 9660 //
     /*  304641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  304655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  304658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304680 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  304683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304697 */     GIR_RootConstrainSelectedInstOperands,
     /*  304698 */     // GIR_Coverage, 9660,
     /*  304698 */     GIR_EraseRootFromParent_Done,
     /*  304699 */   // Label 5660: @304699
     /*  304699 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(304762), // Rule ID 9661 //
     /*  304704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  304718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  304721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304743 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  304746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304760 */     GIR_RootConstrainSelectedInstOperands,
     /*  304761 */     // GIR_Coverage, 9661,
     /*  304761 */     GIR_EraseRootFromParent_Done,
     /*  304762 */   // Label 5661: @304762
     /*  304762 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(304825), // Rule ID 9664 //
     /*  304767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  304781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  304784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304806 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  304809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304823 */     GIR_RootConstrainSelectedInstOperands,
     /*  304824 */     // GIR_Coverage, 9664,
     /*  304824 */     GIR_EraseRootFromParent_Done,
     /*  304825 */   // Label 5662: @304825
     /*  304825 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(304888), // Rule ID 9665 //
     /*  304830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  304844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  304847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304869 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  304872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304886 */     GIR_RootConstrainSelectedInstOperands,
     /*  304887 */     // GIR_Coverage, 9665,
     /*  304887 */     GIR_EraseRootFromParent_Done,
     /*  304888 */   // Label 5663: @304888
     /*  304888 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(304951), // Rule ID 9668 //
     /*  304893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  304907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  304910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304932 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  304932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  304935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304949 */     GIR_RootConstrainSelectedInstOperands,
     /*  304950 */     // GIR_Coverage, 9668,
     /*  304950 */     GIR_EraseRootFromParent_Done,
     /*  304951 */   // Label 5664: @304951
     /*  304951 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(305014), // Rule ID 9669 //
     /*  304956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  304970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  304973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304995 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  304995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  304998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305012 */     GIR_RootConstrainSelectedInstOperands,
     /*  305013 */     // GIR_Coverage, 9669,
     /*  305013 */     GIR_EraseRootFromParent_Done,
     /*  305014 */   // Label 5665: @305014
     /*  305014 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(305077), // Rule ID 9672 //
     /*  305019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  305033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  305036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305058 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  305061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305075 */     GIR_RootConstrainSelectedInstOperands,
     /*  305076 */     // GIR_Coverage, 9672,
     /*  305076 */     GIR_EraseRootFromParent_Done,
     /*  305077 */   // Label 5666: @305077
     /*  305077 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(305140), // Rule ID 9673 //
     /*  305082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  305096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  305099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305121 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  305121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  305124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305138 */     GIR_RootConstrainSelectedInstOperands,
     /*  305139 */     // GIR_Coverage, 9673,
     /*  305139 */     GIR_EraseRootFromParent_Done,
     /*  305140 */   // Label 5667: @305140
     /*  305140 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(305203), // Rule ID 9676 //
     /*  305145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  305159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  305162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305184 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  305187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305201 */     GIR_RootConstrainSelectedInstOperands,
     /*  305202 */     // GIR_Coverage, 9676,
     /*  305202 */     GIR_EraseRootFromParent_Done,
     /*  305203 */   // Label 5668: @305203
     /*  305203 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(305266), // Rule ID 9677 //
     /*  305208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  305222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  305225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305247 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  305250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305264 */     GIR_RootConstrainSelectedInstOperands,
     /*  305265 */     // GIR_Coverage, 9677,
     /*  305265 */     GIR_EraseRootFromParent_Done,
     /*  305266 */   // Label 5669: @305266
     /*  305266 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(305329), // Rule ID 9680 //
     /*  305271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  305282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  305285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  305288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305310 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  305313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305327 */     GIR_RootConstrainSelectedInstOperands,
     /*  305328 */     // GIR_Coverage, 9680,
     /*  305328 */     GIR_EraseRootFromParent_Done,
     /*  305329 */   // Label 5670: @305329
     /*  305329 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(305392), // Rule ID 9681 //
     /*  305334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  305345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  305348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  305351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305373 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  305376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305390 */     GIR_RootConstrainSelectedInstOperands,
     /*  305391 */     // GIR_Coverage, 9681,
     /*  305391 */     GIR_EraseRootFromParent_Done,
     /*  305392 */   // Label 5671: @305392
     /*  305392 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(305455), // Rule ID 9684 //
     /*  305397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  305408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  305411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  305414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305436 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  305439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305453 */     GIR_RootConstrainSelectedInstOperands,
     /*  305454 */     // GIR_Coverage, 9684,
     /*  305454 */     GIR_EraseRootFromParent_Done,
     /*  305455 */   // Label 5672: @305455
     /*  305455 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(305518), // Rule ID 9685 //
     /*  305460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  305471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  305474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  305477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305499 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  305502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305516 */     GIR_RootConstrainSelectedInstOperands,
     /*  305517 */     // GIR_Coverage, 9685,
     /*  305517 */     GIR_EraseRootFromParent_Done,
     /*  305518 */   // Label 5673: @305518
     /*  305518 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(305581), // Rule ID 9688 //
     /*  305523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  305537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  305540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305562 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  305562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  305565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305579 */     GIR_RootConstrainSelectedInstOperands,
     /*  305580 */     // GIR_Coverage, 9688,
     /*  305580 */     GIR_EraseRootFromParent_Done,
     /*  305581 */   // Label 5674: @305581
     /*  305581 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(305644), // Rule ID 9689 //
     /*  305586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  305600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  305603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305625 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  305628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305642 */     GIR_RootConstrainSelectedInstOperands,
     /*  305643 */     // GIR_Coverage, 9689,
     /*  305643 */     GIR_EraseRootFromParent_Done,
     /*  305644 */   // Label 5675: @305644
     /*  305644 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(305707), // Rule ID 9692 //
     /*  305649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  305663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  305666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305688 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  305688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  305691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305705 */     GIR_RootConstrainSelectedInstOperands,
     /*  305706 */     // GIR_Coverage, 9692,
     /*  305706 */     GIR_EraseRootFromParent_Done,
     /*  305707 */   // Label 5676: @305707
     /*  305707 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(305770), // Rule ID 9693 //
     /*  305712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  305726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  305729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305751 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  305754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305768 */     GIR_RootConstrainSelectedInstOperands,
     /*  305769 */     // GIR_Coverage, 9693,
     /*  305769 */     GIR_EraseRootFromParent_Done,
     /*  305770 */   // Label 5677: @305770
     /*  305770 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(305833), // Rule ID 9696 //
     /*  305775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  305786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  305789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  305792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305814 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  305814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  305817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305831 */     GIR_RootConstrainSelectedInstOperands,
     /*  305832 */     // GIR_Coverage, 9696,
     /*  305832 */     GIR_EraseRootFromParent_Done,
     /*  305833 */   // Label 5678: @305833
     /*  305833 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(305896), // Rule ID 9697 //
     /*  305838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  305849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  305852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  305855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305877 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  305880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305894 */     GIR_RootConstrainSelectedInstOperands,
     /*  305895 */     // GIR_Coverage, 9697,
     /*  305895 */     GIR_EraseRootFromParent_Done,
     /*  305896 */   // Label 5679: @305896
     /*  305896 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(305959), // Rule ID 9700 //
     /*  305901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  305915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  305918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305940 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  305940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  305943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305957 */     GIR_RootConstrainSelectedInstOperands,
     /*  305958 */     // GIR_Coverage, 9700,
     /*  305958 */     GIR_EraseRootFromParent_Done,
     /*  305959 */   // Label 5680: @305959
     /*  305959 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(306022), // Rule ID 9701 //
     /*  305964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  305978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  305981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306003 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  306003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  306006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306020 */     GIR_RootConstrainSelectedInstOperands,
     /*  306021 */     // GIR_Coverage, 9701,
     /*  306021 */     GIR_EraseRootFromParent_Done,
     /*  306022 */   // Label 5681: @306022
     /*  306022 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(306085), // Rule ID 9704 //
     /*  306027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  306041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  306044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306066 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  306066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  306069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306083 */     GIR_RootConstrainSelectedInstOperands,
     /*  306084 */     // GIR_Coverage, 9704,
     /*  306084 */     GIR_EraseRootFromParent_Done,
     /*  306085 */   // Label 5682: @306085
     /*  306085 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(306148), // Rule ID 9705 //
     /*  306090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  306104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  306107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306129 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  306129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  306132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306146 */     GIR_RootConstrainSelectedInstOperands,
     /*  306147 */     // GIR_Coverage, 9705,
     /*  306147 */     GIR_EraseRootFromParent_Done,
     /*  306148 */   // Label 5683: @306148
     /*  306148 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(306211), // Rule ID 9708 //
     /*  306153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  306164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  306167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  306170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306192 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  306192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  306195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306209 */     GIR_RootConstrainSelectedInstOperands,
     /*  306210 */     // GIR_Coverage, 9708,
     /*  306210 */     GIR_EraseRootFromParent_Done,
     /*  306211 */   // Label 5684: @306211
     /*  306211 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(306274), // Rule ID 9709 //
     /*  306216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  306227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  306230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  306233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306255 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  306255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  306258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306272 */     GIR_RootConstrainSelectedInstOperands,
     /*  306273 */     // GIR_Coverage, 9709,
     /*  306273 */     GIR_EraseRootFromParent_Done,
     /*  306274 */   // Label 5685: @306274
     /*  306274 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(306337), // Rule ID 9712 //
     /*  306279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  306282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  306293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  306296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306318 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  306318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  306321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306335 */     GIR_RootConstrainSelectedInstOperands,
     /*  306336 */     // GIR_Coverage, 9712,
     /*  306336 */     GIR_EraseRootFromParent_Done,
     /*  306337 */   // Label 5686: @306337
     /*  306337 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(306400), // Rule ID 9713 //
     /*  306342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  306345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  306356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  306359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306381 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  306381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  306384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306398 */     GIR_RootConstrainSelectedInstOperands,
     /*  306399 */     // GIR_Coverage, 9713,
     /*  306399 */     GIR_EraseRootFromParent_Done,
     /*  306400 */   // Label 5687: @306400
     /*  306400 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(306463), // Rule ID 9716 //
     /*  306405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  306408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  306419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  306422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306444 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  306444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  306447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306461 */     GIR_RootConstrainSelectedInstOperands,
     /*  306462 */     // GIR_Coverage, 9716,
     /*  306462 */     GIR_EraseRootFromParent_Done,
     /*  306463 */   // Label 5688: @306463
     /*  306463 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(306526), // Rule ID 9717 //
     /*  306468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  306471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  306482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  306485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306507 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  306507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  306510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306524 */     GIR_RootConstrainSelectedInstOperands,
     /*  306525 */     // GIR_Coverage, 9717,
     /*  306525 */     GIR_EraseRootFromParent_Done,
     /*  306526 */   // Label 5689: @306526
     /*  306526 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(306589), // Rule ID 9720 //
     /*  306531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  306534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  306545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  306548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306570 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  306570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  306573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306587 */     GIR_RootConstrainSelectedInstOperands,
     /*  306588 */     // GIR_Coverage, 9720,
     /*  306588 */     GIR_EraseRootFromParent_Done,
     /*  306589 */   // Label 5690: @306589
     /*  306589 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(306652), // Rule ID 9721 //
     /*  306594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  306597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  306608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  306611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306633 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  306633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  306636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306650 */     GIR_RootConstrainSelectedInstOperands,
     /*  306651 */     // GIR_Coverage, 9721,
     /*  306651 */     GIR_EraseRootFromParent_Done,
     /*  306652 */   // Label 5691: @306652
     /*  306652 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(306715), // Rule ID 9724 //
     /*  306657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  306665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  306671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  306674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306696 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  306699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306713 */     GIR_RootConstrainSelectedInstOperands,
     /*  306714 */     // GIR_Coverage, 9724,
     /*  306714 */     GIR_EraseRootFromParent_Done,
     /*  306715 */   // Label 5692: @306715
     /*  306715 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(306778), // Rule ID 9725 //
     /*  306720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  306728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  306734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  306737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306759 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  306762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306776 */     GIR_RootConstrainSelectedInstOperands,
     /*  306777 */     // GIR_Coverage, 9725,
     /*  306777 */     GIR_EraseRootFromParent_Done,
     /*  306778 */   // Label 5693: @306778
     /*  306778 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(306841), // Rule ID 9728 //
     /*  306783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  306791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  306797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  306800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306822 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  306825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306839 */     GIR_RootConstrainSelectedInstOperands,
     /*  306840 */     // GIR_Coverage, 9728,
     /*  306840 */     GIR_EraseRootFromParent_Done,
     /*  306841 */   // Label 5694: @306841
     /*  306841 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(306904), // Rule ID 9729 //
     /*  306846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  306854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  306860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  306863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306885 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  306888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306902 */     GIR_RootConstrainSelectedInstOperands,
     /*  306903 */     // GIR_Coverage, 9729,
     /*  306903 */     GIR_EraseRootFromParent_Done,
     /*  306904 */   // Label 5695: @306904
     /*  306904 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(306967), // Rule ID 9732 //
     /*  306909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  306917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  306923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  306926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306948 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  306951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306965 */     GIR_RootConstrainSelectedInstOperands,
     /*  306966 */     // GIR_Coverage, 9732,
     /*  306966 */     GIR_EraseRootFromParent_Done,
     /*  306967 */   // Label 5696: @306967
     /*  306967 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(307030), // Rule ID 9733 //
     /*  306972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  306980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  306986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  306989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307011 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  307014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307028 */     GIR_RootConstrainSelectedInstOperands,
     /*  307029 */     // GIR_Coverage, 9733,
     /*  307029 */     GIR_EraseRootFromParent_Done,
     /*  307030 */   // Label 5697: @307030
     /*  307030 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(307093), // Rule ID 9736 //
     /*  307035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  307049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  307052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307074 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  307077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307091 */     GIR_RootConstrainSelectedInstOperands,
     /*  307092 */     // GIR_Coverage, 9736,
     /*  307092 */     GIR_EraseRootFromParent_Done,
     /*  307093 */   // Label 5698: @307093
     /*  307093 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(307156), // Rule ID 9737 //
     /*  307098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  307112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  307115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307137 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  307140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307154 */     GIR_RootConstrainSelectedInstOperands,
     /*  307155 */     // GIR_Coverage, 9737,
     /*  307155 */     GIR_EraseRootFromParent_Done,
     /*  307156 */   // Label 5699: @307156
     /*  307156 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(307219), // Rule ID 9740 //
     /*  307161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  307175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  307178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307200 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  307203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307217 */     GIR_RootConstrainSelectedInstOperands,
     /*  307218 */     // GIR_Coverage, 9740,
     /*  307218 */     GIR_EraseRootFromParent_Done,
     /*  307219 */   // Label 5700: @307219
     /*  307219 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(307282), // Rule ID 9741 //
     /*  307224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  307238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  307241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307263 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  307266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307280 */     GIR_RootConstrainSelectedInstOperands,
     /*  307281 */     // GIR_Coverage, 9741,
     /*  307281 */     GIR_EraseRootFromParent_Done,
     /*  307282 */   // Label 5701: @307282
     /*  307282 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(307345), // Rule ID 9744 //
     /*  307287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  307301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  307304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307326 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  307329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307343 */     GIR_RootConstrainSelectedInstOperands,
     /*  307344 */     // GIR_Coverage, 9744,
     /*  307344 */     GIR_EraseRootFromParent_Done,
     /*  307345 */   // Label 5702: @307345
     /*  307345 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(307408), // Rule ID 9745 //
     /*  307350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  307364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  307367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307389 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  307392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307406 */     GIR_RootConstrainSelectedInstOperands,
     /*  307407 */     // GIR_Coverage, 9745,
     /*  307407 */     GIR_EraseRootFromParent_Done,
     /*  307408 */   // Label 5703: @307408
     /*  307408 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(307471), // Rule ID 9748 //
     /*  307413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  307427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  307430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307469 */     GIR_RootConstrainSelectedInstOperands,
     /*  307470 */     // GIR_Coverage, 9748,
     /*  307470 */     GIR_EraseRootFromParent_Done,
     /*  307471 */   // Label 5704: @307471
     /*  307471 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(307534), // Rule ID 9749 //
     /*  307476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  307490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  307493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307515 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307532 */     GIR_RootConstrainSelectedInstOperands,
     /*  307533 */     // GIR_Coverage, 9749,
     /*  307533 */     GIR_EraseRootFromParent_Done,
     /*  307534 */   // Label 5705: @307534
     /*  307534 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(307597), // Rule ID 9752 //
     /*  307539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  307553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  307556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307578 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307595 */     GIR_RootConstrainSelectedInstOperands,
     /*  307596 */     // GIR_Coverage, 9752,
     /*  307596 */     GIR_EraseRootFromParent_Done,
     /*  307597 */   // Label 5706: @307597
     /*  307597 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(307660), // Rule ID 9753 //
     /*  307602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  307616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  307619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307641 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307658 */     GIR_RootConstrainSelectedInstOperands,
     /*  307659 */     // GIR_Coverage, 9753,
     /*  307659 */     GIR_EraseRootFromParent_Done,
     /*  307660 */   // Label 5707: @307660
     /*  307660 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(307723), // Rule ID 9756 //
     /*  307665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  307679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  307682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307721 */     GIR_RootConstrainSelectedInstOperands,
     /*  307722 */     // GIR_Coverage, 9756,
     /*  307722 */     GIR_EraseRootFromParent_Done,
     /*  307723 */   // Label 5708: @307723
     /*  307723 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(307786), // Rule ID 9757 //
     /*  307728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  307742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  307745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307767 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307784 */     GIR_RootConstrainSelectedInstOperands,
     /*  307785 */     // GIR_Coverage, 9757,
     /*  307785 */     GIR_EraseRootFromParent_Done,
     /*  307786 */   // Label 5709: @307786
     /*  307786 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(307849), // Rule ID 9760 //
     /*  307791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  307794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  307805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  307808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307830 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  307830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307847 */     GIR_RootConstrainSelectedInstOperands,
     /*  307848 */     // GIR_Coverage, 9760,
     /*  307848 */     GIR_EraseRootFromParent_Done,
     /*  307849 */   // Label 5710: @307849
     /*  307849 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(307912), // Rule ID 9761 //
     /*  307854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  307857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  307868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  307871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307893 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  307893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307910 */     GIR_RootConstrainSelectedInstOperands,
     /*  307911 */     // GIR_Coverage, 9761,
     /*  307911 */     GIR_EraseRootFromParent_Done,
     /*  307912 */   // Label 5711: @307912
     /*  307912 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(307975), // Rule ID 9764 //
     /*  307917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  307931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  307934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307956 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  307959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307973 */     GIR_RootConstrainSelectedInstOperands,
     /*  307974 */     // GIR_Coverage, 9764,
     /*  307974 */     GIR_EraseRootFromParent_Done,
     /*  307975 */   // Label 5712: @307975
     /*  307975 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(308038), // Rule ID 9765 //
     /*  307980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  307994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  307997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308019 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  308019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  308022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308036 */     GIR_RootConstrainSelectedInstOperands,
     /*  308037 */     // GIR_Coverage, 9765,
     /*  308037 */     GIR_EraseRootFromParent_Done,
     /*  308038 */   // Label 5713: @308038
     /*  308038 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(308101), // Rule ID 9768 //
     /*  308043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  308054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  308057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  308060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308082 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  308082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  308085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308099 */     GIR_RootConstrainSelectedInstOperands,
     /*  308100 */     // GIR_Coverage, 9768,
     /*  308100 */     GIR_EraseRootFromParent_Done,
     /*  308101 */   // Label 5714: @308101
     /*  308101 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(308164), // Rule ID 9769 //
     /*  308106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  308117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  308120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  308123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308145 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  308145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  308148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308162 */     GIR_RootConstrainSelectedInstOperands,
     /*  308163 */     // GIR_Coverage, 9769,
     /*  308163 */     GIR_EraseRootFromParent_Done,
     /*  308164 */   // Label 5715: @308164
     /*  308164 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(308227), // Rule ID 9772 //
     /*  308169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  308180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  308183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  308186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308208 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  308208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  308211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308225 */     GIR_RootConstrainSelectedInstOperands,
     /*  308226 */     // GIR_Coverage, 9772,
     /*  308226 */     GIR_EraseRootFromParent_Done,
     /*  308227 */   // Label 5716: @308227
     /*  308227 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(308290), // Rule ID 9773 //
     /*  308232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  308243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  308246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  308249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308271 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  308271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  308274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308288 */     GIR_RootConstrainSelectedInstOperands,
     /*  308289 */     // GIR_Coverage, 9773,
     /*  308289 */     GIR_EraseRootFromParent_Done,
     /*  308290 */   // Label 5717: @308290
     /*  308290 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(308353), // Rule ID 9776 //
     /*  308295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  308309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  308312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308334 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  308334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  308337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308351 */     GIR_RootConstrainSelectedInstOperands,
     /*  308352 */     // GIR_Coverage, 9776,
     /*  308352 */     GIR_EraseRootFromParent_Done,
     /*  308353 */   // Label 5718: @308353
     /*  308353 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(308416), // Rule ID 9777 //
     /*  308358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  308372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  308375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308397 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  308397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  308400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308414 */     GIR_RootConstrainSelectedInstOperands,
     /*  308415 */     // GIR_Coverage, 9777,
     /*  308415 */     GIR_EraseRootFromParent_Done,
     /*  308416 */   // Label 5719: @308416
     /*  308416 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(308479), // Rule ID 9780 //
     /*  308421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  308432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  308435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  308438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308460 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  308460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  308463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308477 */     GIR_RootConstrainSelectedInstOperands,
     /*  308478 */     // GIR_Coverage, 9780,
     /*  308478 */     GIR_EraseRootFromParent_Done,
     /*  308479 */   // Label 5720: @308479
     /*  308479 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(308542), // Rule ID 9781 //
     /*  308484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  308495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  308498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  308501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308523 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  308523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  308526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308540 */     GIR_RootConstrainSelectedInstOperands,
     /*  308541 */     // GIR_Coverage, 9781,
     /*  308541 */     GIR_EraseRootFromParent_Done,
     /*  308542 */   // Label 5721: @308542
     /*  308542 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(308605), // Rule ID 9784 //
     /*  308547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  308558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  308561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  308564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308586 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  308586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  308589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308603 */     GIR_RootConstrainSelectedInstOperands,
     /*  308604 */     // GIR_Coverage, 9784,
     /*  308604 */     GIR_EraseRootFromParent_Done,
     /*  308605 */   // Label 5722: @308605
     /*  308605 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(308668), // Rule ID 9785 //
     /*  308610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  308621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  308624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  308627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308649 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  308649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  308652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308666 */     GIR_RootConstrainSelectedInstOperands,
     /*  308667 */     // GIR_Coverage, 9785,
     /*  308667 */     GIR_EraseRootFromParent_Done,
     /*  308668 */   // Label 5723: @308668
     /*  308668 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(308731), // Rule ID 9788 //
     /*  308673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  308687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  308690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308712 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  308712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  308715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308729 */     GIR_RootConstrainSelectedInstOperands,
     /*  308730 */     // GIR_Coverage, 9788,
     /*  308730 */     GIR_EraseRootFromParent_Done,
     /*  308731 */   // Label 5724: @308731
     /*  308731 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(308794), // Rule ID 9789 //
     /*  308736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  308750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  308753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308775 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  308775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  308778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308792 */     GIR_RootConstrainSelectedInstOperands,
     /*  308793 */     // GIR_Coverage, 9789,
     /*  308793 */     GIR_EraseRootFromParent_Done,
     /*  308794 */   // Label 5725: @308794
     /*  308794 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(308857), // Rule ID 9792 //
     /*  308799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  308813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  308816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308838 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  308838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  308841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308855 */     GIR_RootConstrainSelectedInstOperands,
     /*  308856 */     // GIR_Coverage, 9792,
     /*  308856 */     GIR_EraseRootFromParent_Done,
     /*  308857 */   // Label 5726: @308857
     /*  308857 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(308920), // Rule ID 9793 //
     /*  308862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  308876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  308879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308901 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  308901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  308904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308918 */     GIR_RootConstrainSelectedInstOperands,
     /*  308919 */     // GIR_Coverage, 9793,
     /*  308919 */     GIR_EraseRootFromParent_Done,
     /*  308920 */   // Label 5727: @308920
     /*  308920 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(308983), // Rule ID 9796 //
     /*  308925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  308936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  308939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  308942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308964 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  308964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  308967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308981 */     GIR_RootConstrainSelectedInstOperands,
     /*  308982 */     // GIR_Coverage, 9796,
     /*  308982 */     GIR_EraseRootFromParent_Done,
     /*  308983 */   // Label 5728: @308983
     /*  308983 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(309046), // Rule ID 9797 //
     /*  308988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  308999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  309002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  309005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309027 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  309027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  309030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309044 */     GIR_RootConstrainSelectedInstOperands,
     /*  309045 */     // GIR_Coverage, 9797,
     /*  309045 */     GIR_EraseRootFromParent_Done,
     /*  309046 */   // Label 5729: @309046
     /*  309046 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(309109), // Rule ID 9800 //
     /*  309051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  309054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  309059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  309062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  309065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  309068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309090 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  309090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  309093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309107 */     GIR_RootConstrainSelectedInstOperands,
     /*  309108 */     // GIR_Coverage, 9800,
     /*  309108 */     GIR_EraseRootFromParent_Done,
     /*  309109 */   // Label 5730: @309109
     /*  309109 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(309172), // Rule ID 9801 //
     /*  309114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  309117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  309122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  309125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  309128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  309131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309153 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  309153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  309156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309170 */     GIR_RootConstrainSelectedInstOperands,
     /*  309171 */     // GIR_Coverage, 9801,
     /*  309171 */     GIR_EraseRootFromParent_Done,
     /*  309172 */   // Label 5731: @309172
     /*  309172 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(309235), // Rule ID 9804 //
     /*  309177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  309180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  309185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  309188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  309191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  309194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309216 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  309216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  309219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309233 */     GIR_RootConstrainSelectedInstOperands,
     /*  309234 */     // GIR_Coverage, 9804,
     /*  309234 */     GIR_EraseRootFromParent_Done,
     /*  309235 */   // Label 5732: @309235
     /*  309235 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(309298), // Rule ID 9805 //
     /*  309240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  309243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  309248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  309251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  309254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  309257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309279 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  309279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  309282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309296 */     GIR_RootConstrainSelectedInstOperands,
     /*  309297 */     // GIR_Coverage, 9805,
     /*  309297 */     GIR_EraseRootFromParent_Done,
     /*  309298 */   // Label 5733: @309298
     /*  309298 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(309361), // Rule ID 9808 //
     /*  309303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  309306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  309311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  309314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  309317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  309320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309342 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  309342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  309345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309359 */     GIR_RootConstrainSelectedInstOperands,
     /*  309360 */     // GIR_Coverage, 9808,
     /*  309360 */     GIR_EraseRootFromParent_Done,
     /*  309361 */   // Label 5734: @309361
     /*  309361 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(309424), // Rule ID 9809 //
     /*  309366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  309369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  309374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  309377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  309380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  309383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309405 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  309405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  309408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309422 */     GIR_RootConstrainSelectedInstOperands,
     /*  309423 */     // GIR_Coverage, 9809,
     /*  309423 */     GIR_EraseRootFromParent_Done,
     /*  309424 */   // Label 5735: @309424
     /*  309424 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(309487), // Rule ID 9812 //
     /*  309429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  309440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  309443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  309446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309468 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  309468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  309471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309485 */     GIR_RootConstrainSelectedInstOperands,
     /*  309486 */     // GIR_Coverage, 9812,
     /*  309486 */     GIR_EraseRootFromParent_Done,
     /*  309487 */   // Label 5736: @309487
     /*  309487 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(309550), // Rule ID 9813 //
     /*  309492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  309503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  309506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  309509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309531 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  309531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  309534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309548 */     GIR_RootConstrainSelectedInstOperands,
     /*  309549 */     // GIR_Coverage, 9813,
     /*  309549 */     GIR_EraseRootFromParent_Done,
     /*  309550 */   // Label 5737: @309550
     /*  309550 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(309613), // Rule ID 9816 //
     /*  309555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  309566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  309569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  309572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309594 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  309594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  309597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309611 */     GIR_RootConstrainSelectedInstOperands,
     /*  309612 */     // GIR_Coverage, 9816,
     /*  309612 */     GIR_EraseRootFromParent_Done,
     /*  309613 */   // Label 5738: @309613
     /*  309613 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(309676), // Rule ID 9817 //
     /*  309618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  309629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  309632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  309635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309657 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  309657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  309660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309674 */     GIR_RootConstrainSelectedInstOperands,
     /*  309675 */     // GIR_Coverage, 9817,
     /*  309675 */     GIR_EraseRootFromParent_Done,
     /*  309676 */   // Label 5739: @309676
     /*  309676 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(309739), // Rule ID 9820 //
     /*  309681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  309692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  309695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  309698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309720 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  309720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  309723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309737 */     GIR_RootConstrainSelectedInstOperands,
     /*  309738 */     // GIR_Coverage, 9820,
     /*  309738 */     GIR_EraseRootFromParent_Done,
     /*  309739 */   // Label 5740: @309739
     /*  309739 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(309802), // Rule ID 9821 //
     /*  309744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  309755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  309758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  309761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309783 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  309783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  309786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309800 */     GIR_RootConstrainSelectedInstOperands,
     /*  309801 */     // GIR_Coverage, 9821,
     /*  309801 */     GIR_EraseRootFromParent_Done,
     /*  309802 */   // Label 5741: @309802
     /*  309802 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(309865), // Rule ID 9824 //
     /*  309807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  309818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  309821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  309824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309846 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  309846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  309849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309863 */     GIR_RootConstrainSelectedInstOperands,
     /*  309864 */     // GIR_Coverage, 9824,
     /*  309864 */     GIR_EraseRootFromParent_Done,
     /*  309865 */   // Label 5742: @309865
     /*  309865 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(309928), // Rule ID 9825 //
     /*  309870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  309881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  309884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  309887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309909 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  309909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  309912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309926 */     GIR_RootConstrainSelectedInstOperands,
     /*  309927 */     // GIR_Coverage, 9825,
     /*  309927 */     GIR_EraseRootFromParent_Done,
     /*  309928 */   // Label 5743: @309928
     /*  309928 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(309991), // Rule ID 9828 //
     /*  309933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  309944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  309947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  309950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309972 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  309972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  309975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309989 */     GIR_RootConstrainSelectedInstOperands,
     /*  309990 */     // GIR_Coverage, 9828,
     /*  309990 */     GIR_EraseRootFromParent_Done,
     /*  309991 */   // Label 5744: @309991
     /*  309991 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(310054), // Rule ID 9829 //
     /*  309996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  310007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  310010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  310013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310035 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  310035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  310038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310052 */     GIR_RootConstrainSelectedInstOperands,
     /*  310053 */     // GIR_Coverage, 9829,
     /*  310053 */     GIR_EraseRootFromParent_Done,
     /*  310054 */   // Label 5745: @310054
     /*  310054 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(310117), // Rule ID 9832 //
     /*  310059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  310070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  310073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  310076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310098 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  310098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  310101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310115 */     GIR_RootConstrainSelectedInstOperands,
     /*  310116 */     // GIR_Coverage, 9832,
     /*  310116 */     GIR_EraseRootFromParent_Done,
     /*  310117 */   // Label 5746: @310117
     /*  310117 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(310180), // Rule ID 9833 //
     /*  310122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  310133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  310136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  310139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310161 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  310161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  310164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310178 */     GIR_RootConstrainSelectedInstOperands,
     /*  310179 */     // GIR_Coverage, 9833,
     /*  310179 */     GIR_EraseRootFromParent_Done,
     /*  310180 */   // Label 5747: @310180
     /*  310180 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(310243), // Rule ID 9836 //
     /*  310185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  310196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  310199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  310202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310224 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  310224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310241 */     GIR_RootConstrainSelectedInstOperands,
     /*  310242 */     // GIR_Coverage, 9836,
     /*  310242 */     GIR_EraseRootFromParent_Done,
     /*  310243 */   // Label 5748: @310243
     /*  310243 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(310306), // Rule ID 9837 //
     /*  310248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  310259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  310262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  310265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310287 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  310287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310304 */     GIR_RootConstrainSelectedInstOperands,
     /*  310305 */     // GIR_Coverage, 9837,
     /*  310305 */     GIR_EraseRootFromParent_Done,
     /*  310306 */   // Label 5749: @310306
     /*  310306 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(310369), // Rule ID 9840 //
     /*  310311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  310322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  310325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  310328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310350 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  310350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310367 */     GIR_RootConstrainSelectedInstOperands,
     /*  310368 */     // GIR_Coverage, 9840,
     /*  310368 */     GIR_EraseRootFromParent_Done,
     /*  310369 */   // Label 5750: @310369
     /*  310369 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(310432), // Rule ID 9841 //
     /*  310374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  310385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  310388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  310391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310413 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  310413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310430 */     GIR_RootConstrainSelectedInstOperands,
     /*  310431 */     // GIR_Coverage, 9841,
     /*  310431 */     GIR_EraseRootFromParent_Done,
     /*  310432 */   // Label 5751: @310432
     /*  310432 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(310495), // Rule ID 9844 //
     /*  310437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  310448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  310451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  310454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310476 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  310476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310493 */     GIR_RootConstrainSelectedInstOperands,
     /*  310494 */     // GIR_Coverage, 9844,
     /*  310494 */     GIR_EraseRootFromParent_Done,
     /*  310495 */   // Label 5752: @310495
     /*  310495 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(310558), // Rule ID 9845 //
     /*  310500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  310511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  310514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  310517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310539 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  310539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310556 */     GIR_RootConstrainSelectedInstOperands,
     /*  310557 */     // GIR_Coverage, 9845,
     /*  310557 */     GIR_EraseRootFromParent_Done,
     /*  310558 */   // Label 5753: @310558
     /*  310558 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(310621), // Rule ID 9848 //
     /*  310563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  310566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  310574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  310577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  310580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310602 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  310602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310619 */     GIR_RootConstrainSelectedInstOperands,
     /*  310620 */     // GIR_Coverage, 9848,
     /*  310620 */     GIR_EraseRootFromParent_Done,
     /*  310621 */   // Label 5754: @310621
     /*  310621 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(310684), // Rule ID 9849 //
     /*  310626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  310629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  310637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  310640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  310643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310665 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  310665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310682 */     GIR_RootConstrainSelectedInstOperands,
     /*  310683 */     // GIR_Coverage, 9849,
     /*  310683 */     GIR_EraseRootFromParent_Done,
     /*  310684 */   // Label 5755: @310684
     /*  310684 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(310747), // Rule ID 9852 //
     /*  310689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  310700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  310703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  310706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310728 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  310728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  310731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310745 */     GIR_RootConstrainSelectedInstOperands,
     /*  310746 */     // GIR_Coverage, 9852,
     /*  310746 */     GIR_EraseRootFromParent_Done,
     /*  310747 */   // Label 5756: @310747
     /*  310747 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(310810), // Rule ID 9853 //
     /*  310752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  310763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  310766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  310769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310791 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  310791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  310794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310808 */     GIR_RootConstrainSelectedInstOperands,
     /*  310809 */     // GIR_Coverage, 9853,
     /*  310809 */     GIR_EraseRootFromParent_Done,
     /*  310810 */   // Label 5757: @310810
     /*  310810 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(310873), // Rule ID 9856 //
     /*  310815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  310826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  310829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  310832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310854 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  310854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  310857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310871 */     GIR_RootConstrainSelectedInstOperands,
     /*  310872 */     // GIR_Coverage, 9856,
     /*  310872 */     GIR_EraseRootFromParent_Done,
     /*  310873 */   // Label 5758: @310873
     /*  310873 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(310936), // Rule ID 9857 //
     /*  310878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  310889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  310892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  310895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310917 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  310917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  310920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310934 */     GIR_RootConstrainSelectedInstOperands,
     /*  310935 */     // GIR_Coverage, 9857,
     /*  310935 */     GIR_EraseRootFromParent_Done,
     /*  310936 */   // Label 5759: @310936
     /*  310936 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(310999), // Rule ID 9860 //
     /*  310941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  310952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  310955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  310958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310980 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  310980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  310983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310997 */     GIR_RootConstrainSelectedInstOperands,
     /*  310998 */     // GIR_Coverage, 9860,
     /*  310998 */     GIR_EraseRootFromParent_Done,
     /*  310999 */   // Label 5760: @310999
     /*  310999 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(311062), // Rule ID 9861 //
     /*  311004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  311015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  311018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  311021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311043 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  311043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  311046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  311060 */     GIR_RootConstrainSelectedInstOperands,
     /*  311061 */     // GIR_Coverage, 9861,
     /*  311061 */     GIR_EraseRootFromParent_Done,
     /*  311062 */   // Label 5761: @311062
     /*  311062 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(311125), // Rule ID 9864 //
     /*  311067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  311078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  311081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  311084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311106 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  311106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  311109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311123 */     GIR_RootConstrainSelectedInstOperands,
     /*  311124 */     // GIR_Coverage, 9864,
     /*  311124 */     GIR_EraseRootFromParent_Done,
     /*  311125 */   // Label 5762: @311125
     /*  311125 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(311188), // Rule ID 9865 //
     /*  311130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  311141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  311144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  311147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311169 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  311169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  311172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311186 */     GIR_RootConstrainSelectedInstOperands,
     /*  311187 */     // GIR_Coverage, 9865,
     /*  311187 */     GIR_EraseRootFromParent_Done,
     /*  311188 */   // Label 5763: @311188
     /*  311188 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(311251), // Rule ID 9868 //
     /*  311193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  311204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  311207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  311210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311232 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  311232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  311235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311249 */     GIR_RootConstrainSelectedInstOperands,
     /*  311250 */     // GIR_Coverage, 9868,
     /*  311250 */     GIR_EraseRootFromParent_Done,
     /*  311251 */   // Label 5764: @311251
     /*  311251 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(311314), // Rule ID 9869 //
     /*  311256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  311267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  311270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  311273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311295 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  311295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  311298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311312 */     GIR_RootConstrainSelectedInstOperands,
     /*  311313 */     // GIR_Coverage, 9869,
     /*  311313 */     GIR_EraseRootFromParent_Done,
     /*  311314 */   // Label 5765: @311314
     /*  311314 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(311377), // Rule ID 9872 //
     /*  311319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  311330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  311333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  311336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311358 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  311358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  311361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311375 */     GIR_RootConstrainSelectedInstOperands,
     /*  311376 */     // GIR_Coverage, 9872,
     /*  311376 */     GIR_EraseRootFromParent_Done,
     /*  311377 */   // Label 5766: @311377
     /*  311377 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(311440), // Rule ID 9873 //
     /*  311382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  311393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  311396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  311399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311421 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  311421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  311424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311438 */     GIR_RootConstrainSelectedInstOperands,
     /*  311439 */     // GIR_Coverage, 9873,
     /*  311439 */     GIR_EraseRootFromParent_Done,
     /*  311440 */   // Label 5767: @311440
     /*  311440 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(311503), // Rule ID 9876 //
     /*  311445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  311456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  311459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  311462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311484 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  311484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  311487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311501 */     GIR_RootConstrainSelectedInstOperands,
     /*  311502 */     // GIR_Coverage, 9876,
     /*  311502 */     GIR_EraseRootFromParent_Done,
     /*  311503 */   // Label 5768: @311503
     /*  311503 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(311566), // Rule ID 9877 //
     /*  311508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  311519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  311522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  311525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311547 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  311547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  311550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311564 */     GIR_RootConstrainSelectedInstOperands,
     /*  311565 */     // GIR_Coverage, 9877,
     /*  311565 */     GIR_EraseRootFromParent_Done,
     /*  311566 */   // Label 5769: @311566
     /*  311566 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(311629), // Rule ID 9880 //
     /*  311571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  311582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  311585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  311588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311610 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  311610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  311613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311627 */     GIR_RootConstrainSelectedInstOperands,
     /*  311628 */     // GIR_Coverage, 9880,
     /*  311628 */     GIR_EraseRootFromParent_Done,
     /*  311629 */   // Label 5770: @311629
     /*  311629 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(311692), // Rule ID 9881 //
     /*  311634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  311645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  311648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  311651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311673 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  311673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  311676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311690 */     GIR_RootConstrainSelectedInstOperands,
     /*  311691 */     // GIR_Coverage, 9881,
     /*  311691 */     GIR_EraseRootFromParent_Done,
     /*  311692 */   // Label 5771: @311692
     /*  311692 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(311755), // Rule ID 9884 //
     /*  311697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  311708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  311711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  311714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311736 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  311736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  311739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311753 */     GIR_RootConstrainSelectedInstOperands,
     /*  311754 */     // GIR_Coverage, 9884,
     /*  311754 */     GIR_EraseRootFromParent_Done,
     /*  311755 */   // Label 5772: @311755
     /*  311755 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(311818), // Rule ID 9885 //
     /*  311760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  311771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  311774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  311777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311799 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  311799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  311802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311816 */     GIR_RootConstrainSelectedInstOperands,
     /*  311817 */     // GIR_Coverage, 9885,
     /*  311817 */     GIR_EraseRootFromParent_Done,
     /*  311818 */   // Label 5773: @311818
     /*  311818 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(311881), // Rule ID 9888 //
     /*  311823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  311834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  311837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  311840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311862 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  311862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  311865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311879 */     GIR_RootConstrainSelectedInstOperands,
     /*  311880 */     // GIR_Coverage, 9888,
     /*  311880 */     GIR_EraseRootFromParent_Done,
     /*  311881 */   // Label 5774: @311881
     /*  311881 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(311944), // Rule ID 9889 //
     /*  311886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  311889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  311897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  311900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  311903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311925 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  311925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  311928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311942 */     GIR_RootConstrainSelectedInstOperands,
     /*  311943 */     // GIR_Coverage, 9889,
     /*  311943 */     GIR_EraseRootFromParent_Done,
     /*  311944 */   // Label 5775: @311944
     /*  311944 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(312007), // Rule ID 9892 //
     /*  311949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  311960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  311963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  311966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311988 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  311988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  311991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312005 */     GIR_RootConstrainSelectedInstOperands,
     /*  312006 */     // GIR_Coverage, 9892,
     /*  312006 */     GIR_EraseRootFromParent_Done,
     /*  312007 */   // Label 5776: @312007
     /*  312007 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(312070), // Rule ID 9893 //
     /*  312012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  312015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  312020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  312023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  312026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  312029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312051 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  312051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  312054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  312060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312068 */     GIR_RootConstrainSelectedInstOperands,
     /*  312069 */     // GIR_Coverage, 9893,
     /*  312069 */     GIR_EraseRootFromParent_Done,
     /*  312070 */   // Label 5777: @312070
     /*  312070 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(312133), // Rule ID 9896 //
     /*  312075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  312078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  312083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  312086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  312089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  312092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312114 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  312114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  312117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  312123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312131 */     GIR_RootConstrainSelectedInstOperands,
     /*  312132 */     // GIR_Coverage, 9896,
     /*  312132 */     GIR_EraseRootFromParent_Done,
     /*  312133 */   // Label 5778: @312133
     /*  312133 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(312196), // Rule ID 9897 //
     /*  312138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  312141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  312146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  312149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  312152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  312155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312177 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  312177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  312180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  312186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312194 */     GIR_RootConstrainSelectedInstOperands,
     /*  312195 */     // GIR_Coverage, 9897,
     /*  312195 */     GIR_EraseRootFromParent_Done,
     /*  312196 */   // Label 5779: @312196
     /*  312196 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(312262), // Rule ID 13972 //
     /*  312201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  312212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  312215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  312218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312240 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  312240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  312243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  312257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312260 */     GIR_RootConstrainSelectedInstOperands,
     /*  312261 */     // GIR_Coverage, 13972,
     /*  312261 */     GIR_EraseRootFromParent_Done,
     /*  312262 */   // Label 5780: @312262
     /*  312262 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(312328), // Rule ID 13973 //
     /*  312267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  312270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  312278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  312281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  312284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312306 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  312306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  312309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  312323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312326 */     GIR_RootConstrainSelectedInstOperands,
     /*  312327 */     // GIR_Coverage, 13973,
     /*  312327 */     GIR_EraseRootFromParent_Done,
     /*  312328 */   // Label 5781: @312328
     /*  312328 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(312394), // Rule ID 13974 //
     /*  312333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  312344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  312347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  312350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312372 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  312372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  312375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  312389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312392 */     GIR_RootConstrainSelectedInstOperands,
     /*  312393 */     // GIR_Coverage, 13974,
     /*  312393 */     GIR_EraseRootFromParent_Done,
     /*  312394 */   // Label 5782: @312394
     /*  312394 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(312460), // Rule ID 13975 //
     /*  312399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  312402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  312410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  312413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  312416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312438 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  312438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  312441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  312455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312458 */     GIR_RootConstrainSelectedInstOperands,
     /*  312459 */     // GIR_Coverage, 13975,
     /*  312459 */     GIR_EraseRootFromParent_Done,
     /*  312460 */   // Label 5783: @312460
     /*  312460 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(312526), // Rule ID 13976 //
     /*  312465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  312476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  312479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  312482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312504 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  312504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  312521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312524 */     GIR_RootConstrainSelectedInstOperands,
     /*  312525 */     // GIR_Coverage, 13976,
     /*  312525 */     GIR_EraseRootFromParent_Done,
     /*  312526 */   // Label 5784: @312526
     /*  312526 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(312592), // Rule ID 13977 //
     /*  312531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  312534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  312542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  312545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  312548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312570 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  312570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  312587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312590 */     GIR_RootConstrainSelectedInstOperands,
     /*  312591 */     // GIR_Coverage, 13977,
     /*  312591 */     GIR_EraseRootFromParent_Done,
     /*  312592 */   // Label 5785: @312592
     /*  312592 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(312658), // Rule ID 13978 //
     /*  312597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  312608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  312611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  312614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312636 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  312639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312656 */     GIR_RootConstrainSelectedInstOperands,
     /*  312657 */     // GIR_Coverage, 13978,
     /*  312657 */     GIR_EraseRootFromParent_Done,
     /*  312658 */   // Label 5786: @312658
     /*  312658 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(312724), // Rule ID 13979 //
     /*  312663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  312666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  312674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  312677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  312680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312702 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  312705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312722 */     GIR_RootConstrainSelectedInstOperands,
     /*  312723 */     // GIR_Coverage, 13979,
     /*  312723 */     GIR_EraseRootFromParent_Done,
     /*  312724 */   // Label 5787: @312724
     /*  312724 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(312790), // Rule ID 13980 //
     /*  312729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  312740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  312743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  312746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312788 */     GIR_RootConstrainSelectedInstOperands,
     /*  312789 */     // GIR_Coverage, 13980,
     /*  312789 */     GIR_EraseRootFromParent_Done,
     /*  312790 */   // Label 5788: @312790
     /*  312790 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(312856), // Rule ID 13981 //
     /*  312795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  312798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  312806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  312809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  312812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312834 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312854 */     GIR_RootConstrainSelectedInstOperands,
     /*  312855 */     // GIR_Coverage, 13981,
     /*  312855 */     GIR_EraseRootFromParent_Done,
     /*  312856 */   // Label 5789: @312856
     /*  312856 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(312922), // Rule ID 13982 //
     /*  312861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  312872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  312875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  312878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312900 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312920 */     GIR_RootConstrainSelectedInstOperands,
     /*  312921 */     // GIR_Coverage, 13982,
     /*  312921 */     GIR_EraseRootFromParent_Done,
     /*  312922 */   // Label 5790: @312922
     /*  312922 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(312988), // Rule ID 13983 //
     /*  312927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  312930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  312938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  312941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  312944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312966 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312986 */     GIR_RootConstrainSelectedInstOperands,
     /*  312987 */     // GIR_Coverage, 13983,
     /*  312987 */     GIR_EraseRootFromParent_Done,
     /*  312988 */   // Label 5791: @312988
     /*  312988 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(313054), // Rule ID 13984 //
     /*  312993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  313004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  313007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  313010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  313032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313052 */     GIR_RootConstrainSelectedInstOperands,
     /*  313053 */     // GIR_Coverage, 13984,
     /*  313053 */     GIR_EraseRootFromParent_Done,
     /*  313054 */   // Label 5792: @313054
     /*  313054 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(313120), // Rule ID 13985 //
     /*  313059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  313070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  313073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  313076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313098 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  313098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313118 */     GIR_RootConstrainSelectedInstOperands,
     /*  313119 */     // GIR_Coverage, 13985,
     /*  313119 */     GIR_EraseRootFromParent_Done,
     /*  313120 */   // Label 5793: @313120
     /*  313120 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(313186), // Rule ID 13986 //
     /*  313125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  313128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  313136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  313139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313164 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313184 */     GIR_RootConstrainSelectedInstOperands,
     /*  313185 */     // GIR_Coverage, 13986,
     /*  313185 */     GIR_EraseRootFromParent_Done,
     /*  313186 */   // Label 5794: @313186
     /*  313186 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(313252), // Rule ID 13987 //
     /*  313191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  313202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  313205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313230 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  313230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313250 */     GIR_RootConstrainSelectedInstOperands,
     /*  313251 */     // GIR_Coverage, 13987,
     /*  313251 */     GIR_EraseRootFromParent_Done,
     /*  313252 */   // Label 5795: @313252
     /*  313252 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(313318), // Rule ID 13988 //
     /*  313257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  313260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  313268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  313271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  313274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313316 */     GIR_RootConstrainSelectedInstOperands,
     /*  313317 */     // GIR_Coverage, 13988,
     /*  313317 */     GIR_EraseRootFromParent_Done,
     /*  313318 */   // Label 5796: @313318
     /*  313318 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(313384), // Rule ID 13989 //
     /*  313323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  313334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  313337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  313340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313362 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313382 */     GIR_RootConstrainSelectedInstOperands,
     /*  313383 */     // GIR_Coverage, 13989,
     /*  313383 */     GIR_EraseRootFromParent_Done,
     /*  313384 */   // Label 5797: @313384
     /*  313384 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(313450), // Rule ID 13990 //
     /*  313389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  313392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  313400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  313403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  313406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313428 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313448 */     GIR_RootConstrainSelectedInstOperands,
     /*  313449 */     // GIR_Coverage, 13990,
     /*  313449 */     GIR_EraseRootFromParent_Done,
     /*  313450 */   // Label 5798: @313450
     /*  313450 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(313516), // Rule ID 13991 //
     /*  313455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  313458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  313466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  313469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  313472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313514 */     GIR_RootConstrainSelectedInstOperands,
     /*  313515 */     // GIR_Coverage, 13991,
     /*  313515 */     GIR_EraseRootFromParent_Done,
     /*  313516 */   // Label 5799: @313516
     /*  313516 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(313582), // Rule ID 13992 //
     /*  313521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  313524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  313532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  313535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  313538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313560 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  313560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  313563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313580 */     GIR_RootConstrainSelectedInstOperands,
     /*  313581 */     // GIR_Coverage, 13992,
     /*  313581 */     GIR_EraseRootFromParent_Done,
     /*  313582 */   // Label 5800: @313582
     /*  313582 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(313648), // Rule ID 13993 //
     /*  313587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  313598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  313601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  313604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313626 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  313626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  313629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313646 */     GIR_RootConstrainSelectedInstOperands,
     /*  313647 */     // GIR_Coverage, 13993,
     /*  313647 */     GIR_EraseRootFromParent_Done,
     /*  313648 */   // Label 5801: @313648
     /*  313648 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(313714), // Rule ID 13994 //
     /*  313653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  313656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  313664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  313667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  313670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313692 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  313692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313712 */     GIR_RootConstrainSelectedInstOperands,
     /*  313713 */     // GIR_Coverage, 13994,
     /*  313713 */     GIR_EraseRootFromParent_Done,
     /*  313714 */   // Label 5802: @313714
     /*  313714 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(313780), // Rule ID 13995 //
     /*  313719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  313730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  313733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  313736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313758 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  313758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313778 */     GIR_RootConstrainSelectedInstOperands,
     /*  313779 */     // GIR_Coverage, 13995,
     /*  313779 */     GIR_EraseRootFromParent_Done,
     /*  313780 */   // Label 5803: @313780
     /*  313780 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(313846), // Rule ID 13996 //
     /*  313785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  313788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  313796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  313799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  313802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313824 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  313824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313844 */     GIR_RootConstrainSelectedInstOperands,
     /*  313845 */     // GIR_Coverage, 13996,
     /*  313845 */     GIR_EraseRootFromParent_Done,
     /*  313846 */   // Label 5804: @313846
     /*  313846 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(313912), // Rule ID 13997 //
     /*  313851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  313862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  313865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  313868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313890 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  313890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313910 */     GIR_RootConstrainSelectedInstOperands,
     /*  313911 */     // GIR_Coverage, 13997,
     /*  313911 */     GIR_EraseRootFromParent_Done,
     /*  313912 */   // Label 5805: @313912
     /*  313912 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(313978), // Rule ID 13998 //
     /*  313917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  313920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  313928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  313931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  313934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  313959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313976 */     GIR_RootConstrainSelectedInstOperands,
     /*  313977 */     // GIR_Coverage, 13998,
     /*  313977 */     GIR_EraseRootFromParent_Done,
     /*  313978 */   // Label 5806: @313978
     /*  313978 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(314044), // Rule ID 13999 //
     /*  313983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  313994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  313997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  314000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  314025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314042 */     GIR_RootConstrainSelectedInstOperands,
     /*  314043 */     // GIR_Coverage, 13999,
     /*  314043 */     GIR_EraseRootFromParent_Done,
     /*  314044 */   // Label 5807: @314044
     /*  314044 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(314110), // Rule ID 14000 //
     /*  314049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  314052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  314060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  314063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314088 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  314091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314108 */     GIR_RootConstrainSelectedInstOperands,
     /*  314109 */     // GIR_Coverage, 14000,
     /*  314109 */     GIR_EraseRootFromParent_Done,
     /*  314110 */   // Label 5808: @314110
     /*  314110 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(314176), // Rule ID 14001 //
     /*  314115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  314118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  314126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  314129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314154 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  314157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314174 */     GIR_RootConstrainSelectedInstOperands,
     /*  314175 */     // GIR_Coverage, 14001,
     /*  314175 */     GIR_EraseRootFromParent_Done,
     /*  314176 */   // Label 5809: @314176
     /*  314176 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(314242), // Rule ID 14002 //
     /*  314181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  314184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  314192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  314195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314220 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  314223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314240 */     GIR_RootConstrainSelectedInstOperands,
     /*  314241 */     // GIR_Coverage, 14002,
     /*  314241 */     GIR_EraseRootFromParent_Done,
     /*  314242 */   // Label 5810: @314242
     /*  314242 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(314308), // Rule ID 14003 //
     /*  314247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  314250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  314258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  314261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  314289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314306 */     GIR_RootConstrainSelectedInstOperands,
     /*  314307 */     // GIR_Coverage, 14003,
     /*  314307 */     GIR_EraseRootFromParent_Done,
     /*  314308 */   // Label 5811: @314308
     /*  314308 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(314374), // Rule ID 14004 //
     /*  314313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  314316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  314324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  314327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  314355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314372 */     GIR_RootConstrainSelectedInstOperands,
     /*  314373 */     // GIR_Coverage, 14004,
     /*  314373 */     GIR_EraseRootFromParent_Done,
     /*  314374 */   // Label 5812: @314374
     /*  314374 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(314440), // Rule ID 14005 //
     /*  314379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  314382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  314390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  314393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  314421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314438 */     GIR_RootConstrainSelectedInstOperands,
     /*  314439 */     // GIR_Coverage, 14005,
     /*  314439 */     GIR_EraseRootFromParent_Done,
     /*  314440 */   // Label 5813: @314440
     /*  314440 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(314506), // Rule ID 14006 //
     /*  314445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  314448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  314456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  314459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  314487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314504 */     GIR_RootConstrainSelectedInstOperands,
     /*  314505 */     // GIR_Coverage, 14006,
     /*  314505 */     GIR_EraseRootFromParent_Done,
     /*  314506 */   // Label 5814: @314506
     /*  314506 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(314572), // Rule ID 14007 //
     /*  314511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  314514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  314522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  314525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314550 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  314553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314570 */     GIR_RootConstrainSelectedInstOperands,
     /*  314571 */     // GIR_Coverage, 14007,
     /*  314571 */     GIR_EraseRootFromParent_Done,
     /*  314572 */   // Label 5815: @314572
     /*  314572 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(314638), // Rule ID 14008 //
     /*  314577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  314580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  314588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  314591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  314594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314616 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  314619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314636 */     GIR_RootConstrainSelectedInstOperands,
     /*  314637 */     // GIR_Coverage, 14008,
     /*  314637 */     GIR_EraseRootFromParent_Done,
     /*  314638 */   // Label 5816: @314638
     /*  314638 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(314704), // Rule ID 14009 //
     /*  314643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  314646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  314654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  314657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  314660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314682 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  314685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314702 */     GIR_RootConstrainSelectedInstOperands,
     /*  314703 */     // GIR_Coverage, 14009,
     /*  314703 */     GIR_EraseRootFromParent_Done,
     /*  314704 */   // Label 5817: @314704
     /*  314704 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(314770), // Rule ID 14010 //
     /*  314709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  314712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  314720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  314723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  314726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314748 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  314751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314768 */     GIR_RootConstrainSelectedInstOperands,
     /*  314769 */     // GIR_Coverage, 14010,
     /*  314769 */     GIR_EraseRootFromParent_Done,
     /*  314770 */   // Label 5818: @314770
     /*  314770 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(314836), // Rule ID 14011 //
     /*  314775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  314778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  314786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  314789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  314792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  314814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  314817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314834 */     GIR_RootConstrainSelectedInstOperands,
     /*  314835 */     // GIR_Coverage, 14011,
     /*  314835 */     GIR_EraseRootFromParent_Done,
     /*  314836 */   // Label 5819: @314836
     /*  314836 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(314902), // Rule ID 14012 //
     /*  314841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  314844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  314852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  314855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  314858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314880 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  314883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314900 */     GIR_RootConstrainSelectedInstOperands,
     /*  314901 */     // GIR_Coverage, 14012,
     /*  314901 */     GIR_EraseRootFromParent_Done,
     /*  314902 */   // Label 5820: @314902
     /*  314902 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(314968), // Rule ID 14013 //
     /*  314907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  314910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  314918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  314921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  314924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314946 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  314946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  314949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314966 */     GIR_RootConstrainSelectedInstOperands,
     /*  314967 */     // GIR_Coverage, 14013,
     /*  314967 */     GIR_EraseRootFromParent_Done,
     /*  314968 */   // Label 5821: @314968
     /*  314968 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(315034), // Rule ID 14014 //
     /*  314973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  314976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  314984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  314987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  314990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315012 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  315012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  315015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315032 */     GIR_RootConstrainSelectedInstOperands,
     /*  315033 */     // GIR_Coverage, 14014,
     /*  315033 */     GIR_EraseRootFromParent_Done,
     /*  315034 */   // Label 5822: @315034
     /*  315034 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(315100), // Rule ID 14015 //
     /*  315039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  315042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  315050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  315053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  315056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315078 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  315078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  315081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315098 */     GIR_RootConstrainSelectedInstOperands,
     /*  315099 */     // GIR_Coverage, 14015,
     /*  315099 */     GIR_EraseRootFromParent_Done,
     /*  315100 */   // Label 5823: @315100
     /*  315100 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(315166), // Rule ID 14016 //
     /*  315105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  315108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  315116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  315119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315144 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  315144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  315147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315164 */     GIR_RootConstrainSelectedInstOperands,
     /*  315165 */     // GIR_Coverage, 14016,
     /*  315165 */     GIR_EraseRootFromParent_Done,
     /*  315166 */   // Label 5824: @315166
     /*  315166 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(315232), // Rule ID 14017 //
     /*  315171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  315174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  315182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  315185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315210 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  315210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  315213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315230 */     GIR_RootConstrainSelectedInstOperands,
     /*  315231 */     // GIR_Coverage, 14017,
     /*  315231 */     GIR_EraseRootFromParent_Done,
     /*  315232 */   // Label 5825: @315232
     /*  315232 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(315298), // Rule ID 14018 //
     /*  315237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  315240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  315248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  315251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  315254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315276 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  315276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  315279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315296 */     GIR_RootConstrainSelectedInstOperands,
     /*  315297 */     // GIR_Coverage, 14018,
     /*  315297 */     GIR_EraseRootFromParent_Done,
     /*  315298 */   // Label 5826: @315298
     /*  315298 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(315364), // Rule ID 14019 //
     /*  315303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  315306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  315314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  315317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  315320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315342 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  315342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  315345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315362 */     GIR_RootConstrainSelectedInstOperands,
     /*  315363 */     // GIR_Coverage, 14019,
     /*  315363 */     GIR_EraseRootFromParent_Done,
     /*  315364 */   // Label 5827: @315364
     /*  315364 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(315430), // Rule ID 14020 //
     /*  315369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  315380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  315386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315408 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  315408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  315411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315428 */     GIR_RootConstrainSelectedInstOperands,
     /*  315429 */     // GIR_Coverage, 14020,
     /*  315429 */     GIR_EraseRootFromParent_Done,
     /*  315430 */   // Label 5828: @315430
     /*  315430 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(315496), // Rule ID 14021 //
     /*  315435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  315446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  315452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315474 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  315474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  315477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315494 */     GIR_RootConstrainSelectedInstOperands,
     /*  315495 */     // GIR_Coverage, 14021,
     /*  315495 */     GIR_EraseRootFromParent_Done,
     /*  315496 */   // Label 5829: @315496
     /*  315496 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(315562), // Rule ID 14022 //
     /*  315501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  315504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  315512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  315515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  315518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315540 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  315540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  315543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315560 */     GIR_RootConstrainSelectedInstOperands,
     /*  315561 */     // GIR_Coverage, 14022,
     /*  315561 */     GIR_EraseRootFromParent_Done,
     /*  315562 */   // Label 5830: @315562
     /*  315562 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(315628), // Rule ID 14023 //
     /*  315567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  315570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  315578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  315581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  315584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315606 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  315606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  315609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315626 */     GIR_RootConstrainSelectedInstOperands,
     /*  315627 */     // GIR_Coverage, 14023,
     /*  315627 */     GIR_EraseRootFromParent_Done,
     /*  315628 */   // Label 5831: @315628
     /*  315628 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(315694), // Rule ID 14024 //
     /*  315633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  315644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  315647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  315650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315672 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  315672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  315675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315692 */     GIR_RootConstrainSelectedInstOperands,
     /*  315693 */     // GIR_Coverage, 14024,
     /*  315693 */     GIR_EraseRootFromParent_Done,
     /*  315694 */   // Label 5832: @315694
     /*  315694 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(315760), // Rule ID 14025 //
     /*  315699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  315710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  315713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  315716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315738 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  315738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  315741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315758 */     GIR_RootConstrainSelectedInstOperands,
     /*  315759 */     // GIR_Coverage, 14025,
     /*  315759 */     GIR_EraseRootFromParent_Done,
     /*  315760 */   // Label 5833: @315760
     /*  315760 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(315826), // Rule ID 14026 //
     /*  315765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  315768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  315776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  315779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  315782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315804 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  315804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  315807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315824 */     GIR_RootConstrainSelectedInstOperands,
     /*  315825 */     // GIR_Coverage, 14026,
     /*  315825 */     GIR_EraseRootFromParent_Done,
     /*  315826 */   // Label 5834: @315826
     /*  315826 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(315892), // Rule ID 14027 //
     /*  315831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  315834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  315842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  315845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  315848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315870 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  315870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  315873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315890 */     GIR_RootConstrainSelectedInstOperands,
     /*  315891 */     // GIR_Coverage, 14027,
     /*  315891 */     GIR_EraseRootFromParent_Done,
     /*  315892 */   // Label 5835: @315892
     /*  315892 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(315958), // Rule ID 14028 //
     /*  315897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  315900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  315908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  315911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  315914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315936 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  315936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  315939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315956 */     GIR_RootConstrainSelectedInstOperands,
     /*  315957 */     // GIR_Coverage, 14028,
     /*  315957 */     GIR_EraseRootFromParent_Done,
     /*  315958 */   // Label 5836: @315958
     /*  315958 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(316024), // Rule ID 14029 //
     /*  315963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  315966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  315974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  315977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  315980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316002 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  316002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  316005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316022 */     GIR_RootConstrainSelectedInstOperands,
     /*  316023 */     // GIR_Coverage, 14029,
     /*  316023 */     GIR_EraseRootFromParent_Done,
     /*  316024 */   // Label 5837: @316024
     /*  316024 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(316090), // Rule ID 14030 //
     /*  316029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  316032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  316040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  316043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  316046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316068 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  316068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  316071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316088 */     GIR_RootConstrainSelectedInstOperands,
     /*  316089 */     // GIR_Coverage, 14030,
     /*  316089 */     GIR_EraseRootFromParent_Done,
     /*  316090 */   // Label 5838: @316090
     /*  316090 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(316156), // Rule ID 14031 //
     /*  316095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  316098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  316106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  316109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  316112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316134 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  316134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  316137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316154 */     GIR_RootConstrainSelectedInstOperands,
     /*  316155 */     // GIR_Coverage, 14031,
     /*  316155 */     GIR_EraseRootFromParent_Done,
     /*  316156 */   // Label 5839: @316156
     /*  316156 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(316222), // Rule ID 14032 //
     /*  316161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  316164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  316172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  316175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316200 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  316200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  316203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316220 */     GIR_RootConstrainSelectedInstOperands,
     /*  316221 */     // GIR_Coverage, 14032,
     /*  316221 */     GIR_EraseRootFromParent_Done,
     /*  316222 */   // Label 5840: @316222
     /*  316222 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(316288), // Rule ID 14033 //
     /*  316227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  316230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  316238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  316241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316266 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  316266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  316269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316286 */     GIR_RootConstrainSelectedInstOperands,
     /*  316287 */     // GIR_Coverage, 14033,
     /*  316287 */     GIR_EraseRootFromParent_Done,
     /*  316288 */   // Label 5841: @316288
     /*  316288 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(316354), // Rule ID 14034 //
     /*  316293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  316304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  316307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  316310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316332 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  316332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  316335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316352 */     GIR_RootConstrainSelectedInstOperands,
     /*  316353 */     // GIR_Coverage, 14034,
     /*  316353 */     GIR_EraseRootFromParent_Done,
     /*  316354 */   // Label 5842: @316354
     /*  316354 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(316420), // Rule ID 14035 //
     /*  316359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  316370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  316373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  316376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316398 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  316398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  316401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316418 */     GIR_RootConstrainSelectedInstOperands,
     /*  316419 */     // GIR_Coverage, 14035,
     /*  316419 */     GIR_EraseRootFromParent_Done,
     /*  316420 */   // Label 5843: @316420
     /*  316420 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(316486), // Rule ID 14036 //
     /*  316425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  316436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  316439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  316442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316464 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  316464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  316467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316484 */     GIR_RootConstrainSelectedInstOperands,
     /*  316485 */     // GIR_Coverage, 14036,
     /*  316485 */     GIR_EraseRootFromParent_Done,
     /*  316486 */   // Label 5844: @316486
     /*  316486 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(316552), // Rule ID 14037 //
     /*  316491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  316502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  316505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  316508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316530 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  316530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  316533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316550 */     GIR_RootConstrainSelectedInstOperands,
     /*  316551 */     // GIR_Coverage, 14037,
     /*  316551 */     GIR_EraseRootFromParent_Done,
     /*  316552 */   // Label 5845: @316552
     /*  316552 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(316618), // Rule ID 14038 //
     /*  316557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  316568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  316571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  316574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316596 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  316596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  316599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316616 */     GIR_RootConstrainSelectedInstOperands,
     /*  316617 */     // GIR_Coverage, 14038,
     /*  316617 */     GIR_EraseRootFromParent_Done,
     /*  316618 */   // Label 5846: @316618
     /*  316618 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(316684), // Rule ID 14039 //
     /*  316623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  316634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  316637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  316640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316662 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  316662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  316665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316682 */     GIR_RootConstrainSelectedInstOperands,
     /*  316683 */     // GIR_Coverage, 14039,
     /*  316683 */     GIR_EraseRootFromParent_Done,
     /*  316684 */   // Label 5847: @316684
     /*  316684 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(316750), // Rule ID 14040 //
     /*  316689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  316700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  316703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  316706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316728 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  316728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  316731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316748 */     GIR_RootConstrainSelectedInstOperands,
     /*  316749 */     // GIR_Coverage, 14040,
     /*  316749 */     GIR_EraseRootFromParent_Done,
     /*  316750 */   // Label 5848: @316750
     /*  316750 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(316816), // Rule ID 14041 //
     /*  316755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  316766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  316769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  316772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316794 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  316794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  316797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316814 */     GIR_RootConstrainSelectedInstOperands,
     /*  316815 */     // GIR_Coverage, 14041,
     /*  316815 */     GIR_EraseRootFromParent_Done,
     /*  316816 */   // Label 5849: @316816
     /*  316816 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(316882), // Rule ID 14042 //
     /*  316821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  316832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  316835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  316838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316860 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  316860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  316863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316880 */     GIR_RootConstrainSelectedInstOperands,
     /*  316881 */     // GIR_Coverage, 14042,
     /*  316881 */     GIR_EraseRootFromParent_Done,
     /*  316882 */   // Label 5850: @316882
     /*  316882 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(316948), // Rule ID 14043 //
     /*  316887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  316898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  316901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  316904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316926 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  316926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  316929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316946 */     GIR_RootConstrainSelectedInstOperands,
     /*  316947 */     // GIR_Coverage, 14043,
     /*  316947 */     GIR_EraseRootFromParent_Done,
     /*  316948 */   // Label 5851: @316948
     /*  316948 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(317014), // Rule ID 14044 //
     /*  316953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  316964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  316967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  316970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316992 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  316992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  316995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  317001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317012 */     GIR_RootConstrainSelectedInstOperands,
     /*  317013 */     // GIR_Coverage, 14044,
     /*  317013 */     GIR_EraseRootFromParent_Done,
     /*  317014 */   // Label 5852: @317014
     /*  317014 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(317080), // Rule ID 14045 //
     /*  317019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  317022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  317027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  317030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  317033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  317036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317058 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  317058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  317061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  317067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317078 */     GIR_RootConstrainSelectedInstOperands,
     /*  317079 */     // GIR_Coverage, 14045,
     /*  317079 */     GIR_EraseRootFromParent_Done,
     /*  317080 */   // Label 5853: @317080
     /*  317080 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(317146), // Rule ID 19048 //
     /*  317085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  317096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  317099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  317102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317124 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  317124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  317127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317144 */     GIR_RootConstrainSelectedInstOperands,
     /*  317145 */     // GIR_Coverage, 19048,
     /*  317145 */     GIR_EraseRootFromParent_Done,
     /*  317146 */   // Label 5854: @317146
     /*  317146 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(317212), // Rule ID 19049 //
     /*  317151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  317162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  317165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  317168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317190 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  317190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  317193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317210 */     GIR_RootConstrainSelectedInstOperands,
     /*  317211 */     // GIR_Coverage, 19049,
     /*  317211 */     GIR_EraseRootFromParent_Done,
     /*  317212 */   // Label 5855: @317212
     /*  317212 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(317278), // Rule ID 19052 //
     /*  317217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  317228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  317234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317256 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  317256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  317259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317276 */     GIR_RootConstrainSelectedInstOperands,
     /*  317277 */     // GIR_Coverage, 19052,
     /*  317277 */     GIR_EraseRootFromParent_Done,
     /*  317278 */   // Label 5856: @317278
     /*  317278 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(317344), // Rule ID 19053 //
     /*  317283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  317294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  317300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317322 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  317322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  317325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317342 */     GIR_RootConstrainSelectedInstOperands,
     /*  317343 */     // GIR_Coverage, 19053,
     /*  317343 */     GIR_EraseRootFromParent_Done,
     /*  317344 */   // Label 5857: @317344
     /*  317344 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(317410), // Rule ID 19056 //
     /*  317349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  317360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  317366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317388 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  317388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  317391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317408 */     GIR_RootConstrainSelectedInstOperands,
     /*  317409 */     // GIR_Coverage, 19056,
     /*  317409 */     GIR_EraseRootFromParent_Done,
     /*  317410 */   // Label 5858: @317410
     /*  317410 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(317476), // Rule ID 19057 //
     /*  317415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  317426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  317432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317454 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  317454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  317457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317474 */     GIR_RootConstrainSelectedInstOperands,
     /*  317475 */     // GIR_Coverage, 19057,
     /*  317475 */     GIR_EraseRootFromParent_Done,
     /*  317476 */   // Label 5859: @317476
     /*  317476 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(317542), // Rule ID 19060 //
     /*  317481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  317492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  317495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  317498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317520 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  317520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  317523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317540 */     GIR_RootConstrainSelectedInstOperands,
     /*  317541 */     // GIR_Coverage, 19060,
     /*  317541 */     GIR_EraseRootFromParent_Done,
     /*  317542 */   // Label 5860: @317542
     /*  317542 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(317608), // Rule ID 19061 //
     /*  317547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  317558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  317561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  317564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317586 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  317586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  317589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317606 */     GIR_RootConstrainSelectedInstOperands,
     /*  317607 */     // GIR_Coverage, 19061,
     /*  317607 */     GIR_EraseRootFromParent_Done,
     /*  317608 */   // Label 5861: @317608
     /*  317608 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(317674), // Rule ID 19064 //
     /*  317613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  317616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  317624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  317627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  317630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317652 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  317652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  317655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317672 */     GIR_RootConstrainSelectedInstOperands,
     /*  317673 */     // GIR_Coverage, 19064,
     /*  317673 */     GIR_EraseRootFromParent_Done,
     /*  317674 */   // Label 5862: @317674
     /*  317674 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(317740), // Rule ID 19065 //
     /*  317679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  317682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  317690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  317693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  317696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317718 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  317718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  317721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317738 */     GIR_RootConstrainSelectedInstOperands,
     /*  317739 */     // GIR_Coverage, 19065,
     /*  317739 */     GIR_EraseRootFromParent_Done,
     /*  317740 */   // Label 5863: @317740
     /*  317740 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(317806), // Rule ID 19068 //
     /*  317745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  317756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  317759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  317762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317784 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  317784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  317787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317804 */     GIR_RootConstrainSelectedInstOperands,
     /*  317805 */     // GIR_Coverage, 19068,
     /*  317805 */     GIR_EraseRootFromParent_Done,
     /*  317806 */   // Label 5864: @317806
     /*  317806 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(317872), // Rule ID 19069 //
     /*  317811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  317822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  317825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  317828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317850 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  317850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  317853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317870 */     GIR_RootConstrainSelectedInstOperands,
     /*  317871 */     // GIR_Coverage, 19069,
     /*  317871 */     GIR_EraseRootFromParent_Done,
     /*  317872 */   // Label 5865: @317872
     /*  317872 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(317938), // Rule ID 19072 //
     /*  317877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  317888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  317891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  317894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317916 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  317916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  317919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317936 */     GIR_RootConstrainSelectedInstOperands,
     /*  317937 */     // GIR_Coverage, 19072,
     /*  317937 */     GIR_EraseRootFromParent_Done,
     /*  317938 */   // Label 5866: @317938
     /*  317938 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(318004), // Rule ID 19073 //
     /*  317943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  317954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  317957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  317960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317982 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  317982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  317985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318002 */     GIR_RootConstrainSelectedInstOperands,
     /*  318003 */     // GIR_Coverage, 19073,
     /*  318003 */     GIR_EraseRootFromParent_Done,
     /*  318004 */   // Label 5867: @318004
     /*  318004 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(318070), // Rule ID 19076 //
     /*  318009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  318020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  318023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  318026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318048 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  318048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  318051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318068 */     GIR_RootConstrainSelectedInstOperands,
     /*  318069 */     // GIR_Coverage, 19076,
     /*  318069 */     GIR_EraseRootFromParent_Done,
     /*  318070 */   // Label 5868: @318070
     /*  318070 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(318136), // Rule ID 19077 //
     /*  318075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  318086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  318089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  318092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318114 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  318114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  318117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318134 */     GIR_RootConstrainSelectedInstOperands,
     /*  318135 */     // GIR_Coverage, 19077,
     /*  318135 */     GIR_EraseRootFromParent_Done,
     /*  318136 */   // Label 5869: @318136
     /*  318136 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(318202), // Rule ID 19080 //
     /*  318141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  318152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  318155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  318158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318180 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  318180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  318183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318200 */     GIR_RootConstrainSelectedInstOperands,
     /*  318201 */     // GIR_Coverage, 19080,
     /*  318201 */     GIR_EraseRootFromParent_Done,
     /*  318202 */   // Label 5870: @318202
     /*  318202 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(318268), // Rule ID 19081 //
     /*  318207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  318218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  318221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  318224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318246 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  318246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  318249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318266 */     GIR_RootConstrainSelectedInstOperands,
     /*  318267 */     // GIR_Coverage, 19081,
     /*  318267 */     GIR_EraseRootFromParent_Done,
     /*  318268 */   // Label 5871: @318268
     /*  318268 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(318334), // Rule ID 19084 //
     /*  318273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  318284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  318287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  318290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318312 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  318312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  318315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318332 */     GIR_RootConstrainSelectedInstOperands,
     /*  318333 */     // GIR_Coverage, 19084,
     /*  318333 */     GIR_EraseRootFromParent_Done,
     /*  318334 */   // Label 5872: @318334
     /*  318334 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(318400), // Rule ID 19085 //
     /*  318339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  318350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  318353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  318356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318378 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  318378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  318381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318398 */     GIR_RootConstrainSelectedInstOperands,
     /*  318399 */     // GIR_Coverage, 19085,
     /*  318399 */     GIR_EraseRootFromParent_Done,
     /*  318400 */   // Label 5873: @318400
     /*  318400 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(318466), // Rule ID 19088 //
     /*  318405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  318416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  318419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  318422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318444 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  318444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  318447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318464 */     GIR_RootConstrainSelectedInstOperands,
     /*  318465 */     // GIR_Coverage, 19088,
     /*  318465 */     GIR_EraseRootFromParent_Done,
     /*  318466 */   // Label 5874: @318466
     /*  318466 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(318532), // Rule ID 19089 //
     /*  318471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  318482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  318485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  318488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318510 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  318510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  318513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318530 */     GIR_RootConstrainSelectedInstOperands,
     /*  318531 */     // GIR_Coverage, 19089,
     /*  318531 */     GIR_EraseRootFromParent_Done,
     /*  318532 */   // Label 5875: @318532
     /*  318532 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(318598), // Rule ID 19092 //
     /*  318537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  318548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  318551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  318554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318576 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  318576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  318579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318596 */     GIR_RootConstrainSelectedInstOperands,
     /*  318597 */     // GIR_Coverage, 19092,
     /*  318597 */     GIR_EraseRootFromParent_Done,
     /*  318598 */   // Label 5876: @318598
     /*  318598 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(318664), // Rule ID 19093 //
     /*  318603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  318614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  318617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  318620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318642 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  318642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  318645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318662 */     GIR_RootConstrainSelectedInstOperands,
     /*  318663 */     // GIR_Coverage, 19093,
     /*  318663 */     GIR_EraseRootFromParent_Done,
     /*  318664 */   // Label 5877: @318664
     /*  318664 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(318730), // Rule ID 19096 //
     /*  318669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  318680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  318683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  318686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318708 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  318708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  318711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318728 */     GIR_RootConstrainSelectedInstOperands,
     /*  318729 */     // GIR_Coverage, 19096,
     /*  318729 */     GIR_EraseRootFromParent_Done,
     /*  318730 */   // Label 5878: @318730
     /*  318730 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(318796), // Rule ID 19097 //
     /*  318735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  318746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  318749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  318752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318774 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  318774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  318777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318794 */     GIR_RootConstrainSelectedInstOperands,
     /*  318795 */     // GIR_Coverage, 19097,
     /*  318795 */     GIR_EraseRootFromParent_Done,
     /*  318796 */   // Label 5879: @318796
     /*  318796 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(318862), // Rule ID 19100 //
     /*  318801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  318812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  318815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  318818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318840 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  318840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  318843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318860 */     GIR_RootConstrainSelectedInstOperands,
     /*  318861 */     // GIR_Coverage, 19100,
     /*  318861 */     GIR_EraseRootFromParent_Done,
     /*  318862 */   // Label 5880: @318862
     /*  318862 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(318928), // Rule ID 19101 //
     /*  318867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  318878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  318881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  318884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318906 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  318906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  318909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318926 */     GIR_RootConstrainSelectedInstOperands,
     /*  318927 */     // GIR_Coverage, 19101,
     /*  318927 */     GIR_EraseRootFromParent_Done,
     /*  318928 */   // Label 5881: @318928
     /*  318928 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(318991), // Rule ID 19764 //
     /*  318933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  318947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  318950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318972 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  318975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318989 */     GIR_RootConstrainSelectedInstOperands,
     /*  318990 */     // GIR_Coverage, 19764,
     /*  318990 */     GIR_EraseRootFromParent_Done,
     /*  318991 */   // Label 5882: @318991
     /*  318991 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(319054), // Rule ID 19765 //
     /*  318996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  319010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  319013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319035 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  319038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319052 */     GIR_RootConstrainSelectedInstOperands,
     /*  319053 */     // GIR_Coverage, 19765,
     /*  319053 */     GIR_EraseRootFromParent_Done,
     /*  319054 */   // Label 5883: @319054
     /*  319054 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(319117), // Rule ID 19768 //
     /*  319059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  319073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319098 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  319101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319115 */     GIR_RootConstrainSelectedInstOperands,
     /*  319116 */     // GIR_Coverage, 19768,
     /*  319116 */     GIR_EraseRootFromParent_Done,
     /*  319117 */   // Label 5884: @319117
     /*  319117 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(319180), // Rule ID 19769 //
     /*  319122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  319136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319161 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  319164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319178 */     GIR_RootConstrainSelectedInstOperands,
     /*  319179 */     // GIR_Coverage, 19769,
     /*  319179 */     GIR_EraseRootFromParent_Done,
     /*  319180 */   // Label 5885: @319180
     /*  319180 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(319243), // Rule ID 19772 //
     /*  319185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  319199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319224 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  319227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319241 */     GIR_RootConstrainSelectedInstOperands,
     /*  319242 */     // GIR_Coverage, 19772,
     /*  319242 */     GIR_EraseRootFromParent_Done,
     /*  319243 */   // Label 5886: @319243
     /*  319243 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(319306), // Rule ID 19773 //
     /*  319248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  319262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319287 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  319290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319304 */     GIR_RootConstrainSelectedInstOperands,
     /*  319305 */     // GIR_Coverage, 19773,
     /*  319305 */     GIR_EraseRootFromParent_Done,
     /*  319306 */   // Label 5887: @319306
     /*  319306 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(319369), // Rule ID 19776 //
     /*  319311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  319325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  319328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319350 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  319353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319367 */     GIR_RootConstrainSelectedInstOperands,
     /*  319368 */     // GIR_Coverage, 19776,
     /*  319368 */     GIR_EraseRootFromParent_Done,
     /*  319369 */   // Label 5888: @319369
     /*  319369 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(319432), // Rule ID 19777 //
     /*  319374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  319388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  319391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319413 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  319416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319430 */     GIR_RootConstrainSelectedInstOperands,
     /*  319431 */     // GIR_Coverage, 19777,
     /*  319431 */     GIR_EraseRootFromParent_Done,
     /*  319432 */   // Label 5889: @319432
     /*  319432 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(319495), // Rule ID 19780 //
     /*  319437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  319451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  319454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319476 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  319479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319493 */     GIR_RootConstrainSelectedInstOperands,
     /*  319494 */     // GIR_Coverage, 19780,
     /*  319494 */     GIR_EraseRootFromParent_Done,
     /*  319495 */   // Label 5890: @319495
     /*  319495 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(319558), // Rule ID 19781 //
     /*  319500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  319514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  319517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319539 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  319542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319556 */     GIR_RootConstrainSelectedInstOperands,
     /*  319557 */     // GIR_Coverage, 19781,
     /*  319557 */     GIR_EraseRootFromParent_Done,
     /*  319558 */   // Label 5891: @319558
     /*  319558 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(319621), // Rule ID 19784 //
     /*  319563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  319566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  319577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  319580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319602 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  319602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  319605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319619 */     GIR_RootConstrainSelectedInstOperands,
     /*  319620 */     // GIR_Coverage, 19784,
     /*  319620 */     GIR_EraseRootFromParent_Done,
     /*  319621 */   // Label 5892: @319621
     /*  319621 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(319684), // Rule ID 19785 //
     /*  319626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  319629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  319640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  319643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319665 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  319665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  319668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319682 */     GIR_RootConstrainSelectedInstOperands,
     /*  319683 */     // GIR_Coverage, 19785,
     /*  319683 */     GIR_EraseRootFromParent_Done,
     /*  319684 */   // Label 5893: @319684
     /*  319684 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(319747), // Rule ID 19788 //
     /*  319689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  319703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  319706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  319731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319745 */     GIR_RootConstrainSelectedInstOperands,
     /*  319746 */     // GIR_Coverage, 19788,
     /*  319746 */     GIR_EraseRootFromParent_Done,
     /*  319747 */   // Label 5894: @319747
     /*  319747 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(319810), // Rule ID 19789 //
     /*  319752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  319766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  319769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319791 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  319794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319808 */     GIR_RootConstrainSelectedInstOperands,
     /*  319809 */     // GIR_Coverage, 19789,
     /*  319809 */     GIR_EraseRootFromParent_Done,
     /*  319810 */   // Label 5895: @319810
     /*  319810 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(319873), // Rule ID 19792 //
     /*  319815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  319826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  319829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  319832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319854 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  319857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319871 */     GIR_RootConstrainSelectedInstOperands,
     /*  319872 */     // GIR_Coverage, 19792,
     /*  319872 */     GIR_EraseRootFromParent_Done,
     /*  319873 */   // Label 5896: @319873
     /*  319873 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(319936), // Rule ID 19793 //
     /*  319878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  319889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  319892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  319895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319917 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  319920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319934 */     GIR_RootConstrainSelectedInstOperands,
     /*  319935 */     // GIR_Coverage, 19793,
     /*  319935 */     GIR_EraseRootFromParent_Done,
     /*  319936 */   // Label 5897: @319936
     /*  319936 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(319999), // Rule ID 19796 //
     /*  319941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  319952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  319955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  319958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319980 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  319983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319997 */     GIR_RootConstrainSelectedInstOperands,
     /*  319998 */     // GIR_Coverage, 19796,
     /*  319998 */     GIR_EraseRootFromParent_Done,
     /*  319999 */   // Label 5898: @319999
     /*  319999 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(320062), // Rule ID 19797 //
     /*  320004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  320015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  320018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  320021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320043 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  320046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320060 */     GIR_RootConstrainSelectedInstOperands,
     /*  320061 */     // GIR_Coverage, 19797,
     /*  320061 */     GIR_EraseRootFromParent_Done,
     /*  320062 */   // Label 5899: @320062
     /*  320062 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(320125), // Rule ID 19800 //
     /*  320067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  320081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  320084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320106 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  320109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320123 */     GIR_RootConstrainSelectedInstOperands,
     /*  320124 */     // GIR_Coverage, 19800,
     /*  320124 */     GIR_EraseRootFromParent_Done,
     /*  320125 */   // Label 5900: @320125
     /*  320125 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(320188), // Rule ID 19801 //
     /*  320130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  320144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  320147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320169 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  320172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320186 */     GIR_RootConstrainSelectedInstOperands,
     /*  320187 */     // GIR_Coverage, 19801,
     /*  320187 */     GIR_EraseRootFromParent_Done,
     /*  320188 */   // Label 5901: @320188
     /*  320188 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(320251), // Rule ID 19804 //
     /*  320193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  320207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  320210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320232 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  320235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320249 */     GIR_RootConstrainSelectedInstOperands,
     /*  320250 */     // GIR_Coverage, 19804,
     /*  320250 */     GIR_EraseRootFromParent_Done,
     /*  320251 */   // Label 5902: @320251
     /*  320251 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(320314), // Rule ID 19805 //
     /*  320256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  320270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  320273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320295 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  320298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320312 */     GIR_RootConstrainSelectedInstOperands,
     /*  320313 */     // GIR_Coverage, 19805,
     /*  320313 */     GIR_EraseRootFromParent_Done,
     /*  320314 */   // Label 5903: @320314
     /*  320314 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(320377), // Rule ID 19808 //
     /*  320319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  320333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  320336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320358 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  320361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320375 */     GIR_RootConstrainSelectedInstOperands,
     /*  320376 */     // GIR_Coverage, 19808,
     /*  320376 */     GIR_EraseRootFromParent_Done,
     /*  320377 */   // Label 5904: @320377
     /*  320377 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(320440), // Rule ID 19809 //
     /*  320382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  320396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  320399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320421 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  320424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320438 */     GIR_RootConstrainSelectedInstOperands,
     /*  320439 */     // GIR_Coverage, 19809,
     /*  320439 */     GIR_EraseRootFromParent_Done,
     /*  320440 */   // Label 5905: @320440
     /*  320440 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(320503), // Rule ID 19812 //
     /*  320445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  320459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  320462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320484 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  320487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320501 */     GIR_RootConstrainSelectedInstOperands,
     /*  320502 */     // GIR_Coverage, 19812,
     /*  320502 */     GIR_EraseRootFromParent_Done,
     /*  320503 */   // Label 5906: @320503
     /*  320503 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(320566), // Rule ID 19813 //
     /*  320508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  320522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  320525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320547 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  320550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320564 */     GIR_RootConstrainSelectedInstOperands,
     /*  320565 */     // GIR_Coverage, 19813,
     /*  320565 */     GIR_EraseRootFromParent_Done,
     /*  320566 */   // Label 5907: @320566
     /*  320566 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(320629), // Rule ID 19816 //
     /*  320571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  320585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  320588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  320613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320627 */     GIR_RootConstrainSelectedInstOperands,
     /*  320628 */     // GIR_Coverage, 19816,
     /*  320628 */     GIR_EraseRootFromParent_Done,
     /*  320629 */   // Label 5908: @320629
     /*  320629 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(320692), // Rule ID 19817 //
     /*  320634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  320648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  320651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320673 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  320676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320690 */     GIR_RootConstrainSelectedInstOperands,
     /*  320691 */     // GIR_Coverage, 19817,
     /*  320691 */     GIR_EraseRootFromParent_Done,
     /*  320692 */   // Label 5909: @320692
     /*  320692 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(320755), // Rule ID 19820 //
     /*  320697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  320711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  320714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  320739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320753 */     GIR_RootConstrainSelectedInstOperands,
     /*  320754 */     // GIR_Coverage, 19820,
     /*  320754 */     GIR_EraseRootFromParent_Done,
     /*  320755 */   // Label 5910: @320755
     /*  320755 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(320818), // Rule ID 19821 //
     /*  320760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  320774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  320777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320799 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  320802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320816 */     GIR_RootConstrainSelectedInstOperands,
     /*  320817 */     // GIR_Coverage, 19821,
     /*  320817 */     GIR_EraseRootFromParent_Done,
     /*  320818 */   // Label 5911: @320818
     /*  320818 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(320881), // Rule ID 19824 //
     /*  320823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  320837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320862 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  320865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320879 */     GIR_RootConstrainSelectedInstOperands,
     /*  320880 */     // GIR_Coverage, 19824,
     /*  320880 */     GIR_EraseRootFromParent_Done,
     /*  320881 */   // Label 5912: @320881
     /*  320881 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(320944), // Rule ID 19825 //
     /*  320886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  320900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320925 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  320928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320942 */     GIR_RootConstrainSelectedInstOperands,
     /*  320943 */     // GIR_Coverage, 19825,
     /*  320943 */     GIR_EraseRootFromParent_Done,
     /*  320944 */   // Label 5913: @320944
     /*  320944 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(321007), // Rule ID 19828 //
     /*  320949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  320963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320988 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  320991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321005 */     GIR_RootConstrainSelectedInstOperands,
     /*  321006 */     // GIR_Coverage, 19828,
     /*  321006 */     GIR_EraseRootFromParent_Done,
     /*  321007 */   // Label 5914: @321007
     /*  321007 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(321070), // Rule ID 19829 //
     /*  321012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  321026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321051 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  321054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321068 */     GIR_RootConstrainSelectedInstOperands,
     /*  321069 */     // GIR_Coverage, 19829,
     /*  321069 */     GIR_EraseRootFromParent_Done,
     /*  321070 */   // Label 5915: @321070
     /*  321070 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(321133), // Rule ID 19832 //
     /*  321075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  321089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321114 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  321117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321131 */     GIR_RootConstrainSelectedInstOperands,
     /*  321132 */     // GIR_Coverage, 19832,
     /*  321132 */     GIR_EraseRootFromParent_Done,
     /*  321133 */   // Label 5916: @321133
     /*  321133 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(321196), // Rule ID 19833 //
     /*  321138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  321152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321177 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  321180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321194 */     GIR_RootConstrainSelectedInstOperands,
     /*  321195 */     // GIR_Coverage, 19833,
     /*  321195 */     GIR_EraseRootFromParent_Done,
     /*  321196 */   // Label 5917: @321196
     /*  321196 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(321259), // Rule ID 19836 //
     /*  321201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  321215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321240 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  321243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321257 */     GIR_RootConstrainSelectedInstOperands,
     /*  321258 */     // GIR_Coverage, 19836,
     /*  321258 */     GIR_EraseRootFromParent_Done,
     /*  321259 */   // Label 5918: @321259
     /*  321259 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(321322), // Rule ID 19837 //
     /*  321264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  321278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321303 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  321306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321320 */     GIR_RootConstrainSelectedInstOperands,
     /*  321321 */     // GIR_Coverage, 19837,
     /*  321321 */     GIR_EraseRootFromParent_Done,
     /*  321322 */   // Label 5919: @321322
     /*  321322 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(321385), // Rule ID 19840 //
     /*  321327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  321341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321366 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  321369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321383 */     GIR_RootConstrainSelectedInstOperands,
     /*  321384 */     // GIR_Coverage, 19840,
     /*  321384 */     GIR_EraseRootFromParent_Done,
     /*  321385 */   // Label 5920: @321385
     /*  321385 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(321448), // Rule ID 19841 //
     /*  321390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  321404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321429 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  321432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321446 */     GIR_RootConstrainSelectedInstOperands,
     /*  321447 */     // GIR_Coverage, 19841,
     /*  321447 */     GIR_EraseRootFromParent_Done,
     /*  321448 */   // Label 5921: @321448
     /*  321448 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(321511), // Rule ID 19844 //
     /*  321453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  321456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  321467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321492 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  321495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321509 */     GIR_RootConstrainSelectedInstOperands,
     /*  321510 */     // GIR_Coverage, 19844,
     /*  321510 */     GIR_EraseRootFromParent_Done,
     /*  321511 */   // Label 5922: @321511
     /*  321511 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(321574), // Rule ID 19845 //
     /*  321516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  321519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  321530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321555 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  321558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321572 */     GIR_RootConstrainSelectedInstOperands,
     /*  321573 */     // GIR_Coverage, 19845,
     /*  321573 */     GIR_EraseRootFromParent_Done,
     /*  321574 */   // Label 5923: @321574
     /*  321574 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(321637), // Rule ID 19848 //
     /*  321579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  321593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321618 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  321621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321635 */     GIR_RootConstrainSelectedInstOperands,
     /*  321636 */     // GIR_Coverage, 19848,
     /*  321636 */     GIR_EraseRootFromParent_Done,
     /*  321637 */   // Label 5924: @321637
     /*  321637 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(321700), // Rule ID 19849 //
     /*  321642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  321656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321681 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  321684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321698 */     GIR_RootConstrainSelectedInstOperands,
     /*  321699 */     // GIR_Coverage, 19849,
     /*  321699 */     GIR_EraseRootFromParent_Done,
     /*  321700 */   // Label 5925: @321700
     /*  321700 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(321763), // Rule ID 19852 //
     /*  321705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  321716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  321719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321744 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  321747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321761 */     GIR_RootConstrainSelectedInstOperands,
     /*  321762 */     // GIR_Coverage, 19852,
     /*  321762 */     GIR_EraseRootFromParent_Done,
     /*  321763 */   // Label 5926: @321763
     /*  321763 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(321826), // Rule ID 19853 //
     /*  321768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  321779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  321782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321807 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  321810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321824 */     GIR_RootConstrainSelectedInstOperands,
     /*  321825 */     // GIR_Coverage, 19853,
     /*  321825 */     GIR_EraseRootFromParent_Done,
     /*  321826 */   // Label 5927: @321826
     /*  321826 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(321889), // Rule ID 19856 //
     /*  321831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  321842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  321845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321870 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  321873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321887 */     GIR_RootConstrainSelectedInstOperands,
     /*  321888 */     // GIR_Coverage, 19856,
     /*  321888 */     GIR_EraseRootFromParent_Done,
     /*  321889 */   // Label 5928: @321889
     /*  321889 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(321952), // Rule ID 19857 //
     /*  321894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  321905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  321908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321933 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  321936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321950 */     GIR_RootConstrainSelectedInstOperands,
     /*  321951 */     // GIR_Coverage, 19857,
     /*  321951 */     GIR_EraseRootFromParent_Done,
     /*  321952 */   // Label 5929: @321952
     /*  321952 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(322015), // Rule ID 19860 //
     /*  321957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  321971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321996 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  321999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322013 */     GIR_RootConstrainSelectedInstOperands,
     /*  322014 */     // GIR_Coverage, 19860,
     /*  322014 */     GIR_EraseRootFromParent_Done,
     /*  322015 */   // Label 5930: @322015
     /*  322015 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(322078), // Rule ID 19861 //
     /*  322020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  322034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322059 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  322062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322076 */     GIR_RootConstrainSelectedInstOperands,
     /*  322077 */     // GIR_Coverage, 19861,
     /*  322077 */     GIR_EraseRootFromParent_Done,
     /*  322078 */   // Label 5931: @322078
     /*  322078 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(322141), // Rule ID 19864 //
     /*  322083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  322097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322122 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  322125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322139 */     GIR_RootConstrainSelectedInstOperands,
     /*  322140 */     // GIR_Coverage, 19864,
     /*  322140 */     GIR_EraseRootFromParent_Done,
     /*  322141 */   // Label 5932: @322141
     /*  322141 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(322204), // Rule ID 19865 //
     /*  322146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  322160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322185 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  322188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322202 */     GIR_RootConstrainSelectedInstOperands,
     /*  322203 */     // GIR_Coverage, 19865,
     /*  322203 */     GIR_EraseRootFromParent_Done,
     /*  322204 */   // Label 5933: @322204
     /*  322204 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(322267), // Rule ID 19868 //
     /*  322209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  322223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322248 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  322251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322265 */     GIR_RootConstrainSelectedInstOperands,
     /*  322266 */     // GIR_Coverage, 19868,
     /*  322266 */     GIR_EraseRootFromParent_Done,
     /*  322267 */   // Label 5934: @322267
     /*  322267 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(322330), // Rule ID 19869 //
     /*  322272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  322286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322311 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  322314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322328 */     GIR_RootConstrainSelectedInstOperands,
     /*  322329 */     // GIR_Coverage, 19869,
     /*  322329 */     GIR_EraseRootFromParent_Done,
     /*  322330 */   // Label 5935: @322330
     /*  322330 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(322393), // Rule ID 19872 //
     /*  322335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  322349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322374 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  322377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322391 */     GIR_RootConstrainSelectedInstOperands,
     /*  322392 */     // GIR_Coverage, 19872,
     /*  322392 */     GIR_EraseRootFromParent_Done,
     /*  322393 */   // Label 5936: @322393
     /*  322393 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(322456), // Rule ID 19873 //
     /*  322398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  322412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322437 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  322440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322454 */     GIR_RootConstrainSelectedInstOperands,
     /*  322455 */     // GIR_Coverage, 19873,
     /*  322455 */     GIR_EraseRootFromParent_Done,
     /*  322456 */   // Label 5937: @322456
     /*  322456 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(322519), // Rule ID 19876 //
     /*  322461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  322475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322500 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  322503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322517 */     GIR_RootConstrainSelectedInstOperands,
     /*  322518 */     // GIR_Coverage, 19876,
     /*  322518 */     GIR_EraseRootFromParent_Done,
     /*  322519 */   // Label 5938: @322519
     /*  322519 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(322582), // Rule ID 19877 //
     /*  322524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  322538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322563 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  322566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322580 */     GIR_RootConstrainSelectedInstOperands,
     /*  322581 */     // GIR_Coverage, 19877,
     /*  322581 */     GIR_EraseRootFromParent_Done,
     /*  322582 */   // Label 5939: @322582
     /*  322582 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(322645), // Rule ID 19880 //
     /*  322587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  322601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322626 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  322629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322643 */     GIR_RootConstrainSelectedInstOperands,
     /*  322644 */     // GIR_Coverage, 19880,
     /*  322644 */     GIR_EraseRootFromParent_Done,
     /*  322645 */   // Label 5940: @322645
     /*  322645 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(322708), // Rule ID 19881 //
     /*  322650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  322664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322689 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  322692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322706 */     GIR_RootConstrainSelectedInstOperands,
     /*  322707 */     // GIR_Coverage, 19881,
     /*  322707 */     GIR_EraseRootFromParent_Done,
     /*  322708 */   // Label 5941: @322708
     /*  322708 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(322771), // Rule ID 19884 //
     /*  322713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  322727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  322730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322752 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  322755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322769 */     GIR_RootConstrainSelectedInstOperands,
     /*  322770 */     // GIR_Coverage, 19884,
     /*  322770 */     GIR_EraseRootFromParent_Done,
     /*  322771 */   // Label 5942: @322771
     /*  322771 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(322834), // Rule ID 19885 //
     /*  322776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  322790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  322793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322815 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  322818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322832 */     GIR_RootConstrainSelectedInstOperands,
     /*  322833 */     // GIR_Coverage, 19885,
     /*  322833 */     GIR_EraseRootFromParent_Done,
     /*  322834 */   // Label 5943: @322834
     /*  322834 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(322897), // Rule ID 19888 //
     /*  322839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  322853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  322856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322878 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  322881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322895 */     GIR_RootConstrainSelectedInstOperands,
     /*  322896 */     // GIR_Coverage, 19888,
     /*  322896 */     GIR_EraseRootFromParent_Done,
     /*  322897 */   // Label 5944: @322897
     /*  322897 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(322960), // Rule ID 19889 //
     /*  322902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  322916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  322919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322941 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  322944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322958 */     GIR_RootConstrainSelectedInstOperands,
     /*  322959 */     // GIR_Coverage, 19889,
     /*  322959 */     GIR_EraseRootFromParent_Done,
     /*  322960 */   // Label 5945: @322960
     /*  322960 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(323023), // Rule ID 19892 //
     /*  322965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  322979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  322982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323004 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  323007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323021 */     GIR_RootConstrainSelectedInstOperands,
     /*  323022 */     // GIR_Coverage, 19892,
     /*  323022 */     GIR_EraseRootFromParent_Done,
     /*  323023 */   // Label 5946: @323023
     /*  323023 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(323086), // Rule ID 19893 //
     /*  323028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  323042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  323045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323067 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  323070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323084 */     GIR_RootConstrainSelectedInstOperands,
     /*  323085 */     // GIR_Coverage, 19893,
     /*  323085 */     GIR_EraseRootFromParent_Done,
     /*  323086 */   // Label 5947: @323086
     /*  323086 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(323149), // Rule ID 19896 //
     /*  323091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  323105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  323108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323130 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  323133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323147 */     GIR_RootConstrainSelectedInstOperands,
     /*  323148 */     // GIR_Coverage, 19896,
     /*  323148 */     GIR_EraseRootFromParent_Done,
     /*  323149 */   // Label 5948: @323149
     /*  323149 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(323212), // Rule ID 19897 //
     /*  323154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  323168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  323171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323193 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  323196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323210 */     GIR_RootConstrainSelectedInstOperands,
     /*  323211 */     // GIR_Coverage, 19897,
     /*  323211 */     GIR_EraseRootFromParent_Done,
     /*  323212 */   // Label 5949: @323212
     /*  323212 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(323275), // Rule ID 19900 //
     /*  323217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  323231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  323234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323256 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  323259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323273 */     GIR_RootConstrainSelectedInstOperands,
     /*  323274 */     // GIR_Coverage, 19900,
     /*  323274 */     GIR_EraseRootFromParent_Done,
     /*  323275 */   // Label 5950: @323275
     /*  323275 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(323338), // Rule ID 19901 //
     /*  323280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  323294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  323297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323319 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  323322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323336 */     GIR_RootConstrainSelectedInstOperands,
     /*  323337 */     // GIR_Coverage, 19901,
     /*  323337 */     GIR_EraseRootFromParent_Done,
     /*  323338 */   // Label 5951: @323338
     /*  323338 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(323401), // Rule ID 19904 //
     /*  323343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  323346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  323357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  323360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323382 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  323382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  323385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323399 */     GIR_RootConstrainSelectedInstOperands,
     /*  323400 */     // GIR_Coverage, 19904,
     /*  323400 */     GIR_EraseRootFromParent_Done,
     /*  323401 */   // Label 5952: @323401
     /*  323401 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(323464), // Rule ID 19905 //
     /*  323406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  323409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  323420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  323423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323445 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  323445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  323448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323462 */     GIR_RootConstrainSelectedInstOperands,
     /*  323463 */     // GIR_Coverage, 19905,
     /*  323463 */     GIR_EraseRootFromParent_Done,
     /*  323464 */   // Label 5953: @323464
     /*  323464 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(323527), // Rule ID 19908 //
     /*  323469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  323483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323508 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  323511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323525 */     GIR_RootConstrainSelectedInstOperands,
     /*  323526 */     // GIR_Coverage, 19908,
     /*  323526 */     GIR_EraseRootFromParent_Done,
     /*  323527 */   // Label 5954: @323527
     /*  323527 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(323590), // Rule ID 19909 //
     /*  323532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  323546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323571 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  323574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323588 */     GIR_RootConstrainSelectedInstOperands,
     /*  323589 */     // GIR_Coverage, 19909,
     /*  323589 */     GIR_EraseRootFromParent_Done,
     /*  323590 */   // Label 5955: @323590
     /*  323590 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(323653), // Rule ID 19912 //
     /*  323595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  323606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  323609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323634 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  323637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323651 */     GIR_RootConstrainSelectedInstOperands,
     /*  323652 */     // GIR_Coverage, 19912,
     /*  323652 */     GIR_EraseRootFromParent_Done,
     /*  323653 */   // Label 5956: @323653
     /*  323653 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(323716), // Rule ID 19913 //
     /*  323658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  323669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  323672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323697 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  323700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323714 */     GIR_RootConstrainSelectedInstOperands,
     /*  323715 */     // GIR_Coverage, 19913,
     /*  323715 */     GIR_EraseRootFromParent_Done,
     /*  323716 */   // Label 5957: @323716
     /*  323716 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(323779), // Rule ID 19916 //
     /*  323721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  323732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  323735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323760 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  323763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323777 */     GIR_RootConstrainSelectedInstOperands,
     /*  323778 */     // GIR_Coverage, 19916,
     /*  323778 */     GIR_EraseRootFromParent_Done,
     /*  323779 */   // Label 5958: @323779
     /*  323779 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(323842), // Rule ID 19917 //
     /*  323784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  323795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  323798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323823 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  323826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323840 */     GIR_RootConstrainSelectedInstOperands,
     /*  323841 */     // GIR_Coverage, 19917,
     /*  323841 */     GIR_EraseRootFromParent_Done,
     /*  323842 */   // Label 5959: @323842
     /*  323842 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(323905), // Rule ID 19920 //
     /*  323847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  323861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  323864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323886 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  323889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323903 */     GIR_RootConstrainSelectedInstOperands,
     /*  323904 */     // GIR_Coverage, 19920,
     /*  323904 */     GIR_EraseRootFromParent_Done,
     /*  323905 */   // Label 5960: @323905
     /*  323905 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(323968), // Rule ID 19921 //
     /*  323910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  323924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  323927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323949 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  323952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323966 */     GIR_RootConstrainSelectedInstOperands,
     /*  323967 */     // GIR_Coverage, 19921,
     /*  323967 */     GIR_EraseRootFromParent_Done,
     /*  323968 */   // Label 5961: @323968
     /*  323968 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(324031), // Rule ID 19924 //
     /*  323973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  323987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  323990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324012 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  324015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324029 */     GIR_RootConstrainSelectedInstOperands,
     /*  324030 */     // GIR_Coverage, 19924,
     /*  324030 */     GIR_EraseRootFromParent_Done,
     /*  324031 */   // Label 5962: @324031
     /*  324031 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(324094), // Rule ID 19925 //
     /*  324036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  324050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  324053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324075 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  324078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324092 */     GIR_RootConstrainSelectedInstOperands,
     /*  324093 */     // GIR_Coverage, 19925,
     /*  324093 */     GIR_EraseRootFromParent_Done,
     /*  324094 */   // Label 5963: @324094
     /*  324094 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(324157), // Rule ID 19928 //
     /*  324099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  324113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  324116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324138 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  324141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324155 */     GIR_RootConstrainSelectedInstOperands,
     /*  324156 */     // GIR_Coverage, 19928,
     /*  324156 */     GIR_EraseRootFromParent_Done,
     /*  324157 */   // Label 5964: @324157
     /*  324157 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(324220), // Rule ID 19929 //
     /*  324162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  324176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  324179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324201 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  324204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324218 */     GIR_RootConstrainSelectedInstOperands,
     /*  324219 */     // GIR_Coverage, 19929,
     /*  324219 */     GIR_EraseRootFromParent_Done,
     /*  324220 */   // Label 5965: @324220
     /*  324220 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(324283), // Rule ID 19932 //
     /*  324225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  324239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  324242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324264 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  324267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324281 */     GIR_RootConstrainSelectedInstOperands,
     /*  324282 */     // GIR_Coverage, 19932,
     /*  324282 */     GIR_EraseRootFromParent_Done,
     /*  324283 */   // Label 5966: @324283
     /*  324283 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(324346), // Rule ID 19933 //
     /*  324288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  324302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  324305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324327 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  324330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324344 */     GIR_RootConstrainSelectedInstOperands,
     /*  324345 */     // GIR_Coverage, 19933,
     /*  324345 */     GIR_EraseRootFromParent_Done,
     /*  324346 */   // Label 5967: @324346
     /*  324346 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(324409), // Rule ID 19936 //
     /*  324351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  324365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  324368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324390 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  324393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324407 */     GIR_RootConstrainSelectedInstOperands,
     /*  324408 */     // GIR_Coverage, 19936,
     /*  324408 */     GIR_EraseRootFromParent_Done,
     /*  324409 */   // Label 5968: @324409
     /*  324409 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(324472), // Rule ID 19937 //
     /*  324414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  324428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  324431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324453 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  324456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324470 */     GIR_RootConstrainSelectedInstOperands,
     /*  324471 */     // GIR_Coverage, 19937,
     /*  324471 */     GIR_EraseRootFromParent_Done,
     /*  324472 */   // Label 5969: @324472
     /*  324472 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(324535), // Rule ID 19940 //
     /*  324477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  324491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  324494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324516 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  324519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324533 */     GIR_RootConstrainSelectedInstOperands,
     /*  324534 */     // GIR_Coverage, 19940,
     /*  324534 */     GIR_EraseRootFromParent_Done,
     /*  324535 */   // Label 5970: @324535
     /*  324535 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(324598), // Rule ID 19941 //
     /*  324540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  324554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  324557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324579 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  324582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324596 */     GIR_RootConstrainSelectedInstOperands,
     /*  324597 */     // GIR_Coverage, 19941,
     /*  324597 */     GIR_EraseRootFromParent_Done,
     /*  324598 */   // Label 5971: @324598
     /*  324598 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(324661), // Rule ID 19944 //
     /*  324603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  324617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324642 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  324645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324659 */     GIR_RootConstrainSelectedInstOperands,
     /*  324660 */     // GIR_Coverage, 19944,
     /*  324660 */     GIR_EraseRootFromParent_Done,
     /*  324661 */   // Label 5972: @324661
     /*  324661 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(324724), // Rule ID 19945 //
     /*  324666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  324680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324705 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  324708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324722 */     GIR_RootConstrainSelectedInstOperands,
     /*  324723 */     // GIR_Coverage, 19945,
     /*  324723 */     GIR_EraseRootFromParent_Done,
     /*  324724 */   // Label 5973: @324724
     /*  324724 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(324787), // Rule ID 19948 //
     /*  324729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  324743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324768 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  324771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324785 */     GIR_RootConstrainSelectedInstOperands,
     /*  324786 */     // GIR_Coverage, 19948,
     /*  324786 */     GIR_EraseRootFromParent_Done,
     /*  324787 */   // Label 5974: @324787
     /*  324787 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(324850), // Rule ID 19949 //
     /*  324792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  324806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324831 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  324834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324848 */     GIR_RootConstrainSelectedInstOperands,
     /*  324849 */     // GIR_Coverage, 19949,
     /*  324849 */     GIR_EraseRootFromParent_Done,
     /*  324850 */   // Label 5975: @324850
     /*  324850 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(324913), // Rule ID 19952 //
     /*  324855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  324869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  324872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324894 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  324897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324911 */     GIR_RootConstrainSelectedInstOperands,
     /*  324912 */     // GIR_Coverage, 19952,
     /*  324912 */     GIR_EraseRootFromParent_Done,
     /*  324913 */   // Label 5976: @324913
     /*  324913 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(324976), // Rule ID 19953 //
     /*  324918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  324932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  324935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324957 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  324960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324974 */     GIR_RootConstrainSelectedInstOperands,
     /*  324975 */     // GIR_Coverage, 19953,
     /*  324975 */     GIR_EraseRootFromParent_Done,
     /*  324976 */   // Label 5977: @324976
     /*  324976 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(325039), // Rule ID 19956 //
     /*  324981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  324995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325020 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  325023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325037 */     GIR_RootConstrainSelectedInstOperands,
     /*  325038 */     // GIR_Coverage, 19956,
     /*  325038 */     GIR_EraseRootFromParent_Done,
     /*  325039 */   // Label 5978: @325039
     /*  325039 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(325102), // Rule ID 19957 //
     /*  325044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  325058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325083 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  325086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325100 */     GIR_RootConstrainSelectedInstOperands,
     /*  325101 */     // GIR_Coverage, 19957,
     /*  325101 */     GIR_EraseRootFromParent_Done,
     /*  325102 */   // Label 5979: @325102
     /*  325102 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(325165), // Rule ID 19960 //
     /*  325107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  325121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325146 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  325149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325163 */     GIR_RootConstrainSelectedInstOperands,
     /*  325164 */     // GIR_Coverage, 19960,
     /*  325164 */     GIR_EraseRootFromParent_Done,
     /*  325165 */   // Label 5980: @325165
     /*  325165 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(325228), // Rule ID 19961 //
     /*  325170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  325184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325209 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  325212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325226 */     GIR_RootConstrainSelectedInstOperands,
     /*  325227 */     // GIR_Coverage, 19961,
     /*  325227 */     GIR_EraseRootFromParent_Done,
     /*  325228 */   // Label 5981: @325228
     /*  325228 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(325291), // Rule ID 19964 //
     /*  325233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  325236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  325247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325272 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  325272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  325275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325289 */     GIR_RootConstrainSelectedInstOperands,
     /*  325290 */     // GIR_Coverage, 19964,
     /*  325290 */     GIR_EraseRootFromParent_Done,
     /*  325291 */   // Label 5982: @325291
     /*  325291 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(325354), // Rule ID 19965 //
     /*  325296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  325299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  325310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325335 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  325335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  325338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325352 */     GIR_RootConstrainSelectedInstOperands,
     /*  325353 */     // GIR_Coverage, 19965,
     /*  325353 */     GIR_EraseRootFromParent_Done,
     /*  325354 */   // Label 5983: @325354
     /*  325354 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(325417), // Rule ID 19968 //
     /*  325359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  325373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325398 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  325401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325415 */     GIR_RootConstrainSelectedInstOperands,
     /*  325416 */     // GIR_Coverage, 19968,
     /*  325416 */     GIR_EraseRootFromParent_Done,
     /*  325417 */   // Label 5984: @325417
     /*  325417 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(325480), // Rule ID 19969 //
     /*  325422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  325436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325461 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  325464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325478 */     GIR_RootConstrainSelectedInstOperands,
     /*  325479 */     // GIR_Coverage, 19969,
     /*  325479 */     GIR_EraseRootFromParent_Done,
     /*  325480 */   // Label 5985: @325480
     /*  325480 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(325543), // Rule ID 19972 //
     /*  325485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  325499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325524 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  325527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325541 */     GIR_RootConstrainSelectedInstOperands,
     /*  325542 */     // GIR_Coverage, 19972,
     /*  325542 */     GIR_EraseRootFromParent_Done,
     /*  325543 */   // Label 5986: @325543
     /*  325543 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(325606), // Rule ID 19973 //
     /*  325548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  325562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325587 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  325590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325604 */     GIR_RootConstrainSelectedInstOperands,
     /*  325605 */     // GIR_Coverage, 19973,
     /*  325605 */     GIR_EraseRootFromParent_Done,
     /*  325606 */   // Label 5987: @325606
     /*  325606 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(325669), // Rule ID 19976 //
     /*  325611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  325622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  325625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325650 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  325653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325667 */     GIR_RootConstrainSelectedInstOperands,
     /*  325668 */     // GIR_Coverage, 19976,
     /*  325668 */     GIR_EraseRootFromParent_Done,
     /*  325669 */   // Label 5988: @325669
     /*  325669 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(325732), // Rule ID 19977 //
     /*  325674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  325685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  325688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325713 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  325716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325730 */     GIR_RootConstrainSelectedInstOperands,
     /*  325731 */     // GIR_Coverage, 19977,
     /*  325731 */     GIR_EraseRootFromParent_Done,
     /*  325732 */   // Label 5989: @325732
     /*  325732 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(325795), // Rule ID 19980 //
     /*  325737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  325751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325776 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  325779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325793 */     GIR_RootConstrainSelectedInstOperands,
     /*  325794 */     // GIR_Coverage, 19980,
     /*  325794 */     GIR_EraseRootFromParent_Done,
     /*  325795 */   // Label 5990: @325795
     /*  325795 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(325858), // Rule ID 19981 //
     /*  325800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  325814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325839 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  325842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325856 */     GIR_RootConstrainSelectedInstOperands,
     /*  325857 */     // GIR_Coverage, 19981,
     /*  325857 */     GIR_EraseRootFromParent_Done,
     /*  325858 */   // Label 5991: @325858
     /*  325858 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(325921), // Rule ID 19984 //
     /*  325863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  325877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325902 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  325905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325919 */     GIR_RootConstrainSelectedInstOperands,
     /*  325920 */     // GIR_Coverage, 19984,
     /*  325920 */     GIR_EraseRootFromParent_Done,
     /*  325921 */   // Label 5992: @325921
     /*  325921 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(325984), // Rule ID 19985 //
     /*  325926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  325940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325965 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  325968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325982 */     GIR_RootConstrainSelectedInstOperands,
     /*  325983 */     // GIR_Coverage, 19985,
     /*  325983 */     GIR_EraseRootFromParent_Done,
     /*  325984 */   // Label 5993: @325984
     /*  325984 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(326047), // Rule ID 19988 //
     /*  325989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  326000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  326003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326028 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  326031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326045 */     GIR_RootConstrainSelectedInstOperands,
     /*  326046 */     // GIR_Coverage, 19988,
     /*  326046 */     GIR_EraseRootFromParent_Done,
     /*  326047 */   // Label 5994: @326047
     /*  326047 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(326110), // Rule ID 19989 //
     /*  326052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  326063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  326066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326091 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  326094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326108 */     GIR_RootConstrainSelectedInstOperands,
     /*  326109 */     // GIR_Coverage, 19989,
     /*  326109 */     GIR_EraseRootFromParent_Done,
     /*  326110 */   // Label 5995: @326110
     /*  326110 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(326173), // Rule ID 19992 //
     /*  326115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  326129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326154 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  326157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326171 */     GIR_RootConstrainSelectedInstOperands,
     /*  326172 */     // GIR_Coverage, 19992,
     /*  326172 */     GIR_EraseRootFromParent_Done,
     /*  326173 */   // Label 5996: @326173
     /*  326173 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(326236), // Rule ID 19993 //
     /*  326178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  326192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326217 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  326220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326234 */     GIR_RootConstrainSelectedInstOperands,
     /*  326235 */     // GIR_Coverage, 19993,
     /*  326235 */     GIR_EraseRootFromParent_Done,
     /*  326236 */   // Label 5997: @326236
     /*  326236 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(326299), // Rule ID 19996 //
     /*  326241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  326255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326280 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  326283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326297 */     GIR_RootConstrainSelectedInstOperands,
     /*  326298 */     // GIR_Coverage, 19996,
     /*  326298 */     GIR_EraseRootFromParent_Done,
     /*  326299 */   // Label 5998: @326299
     /*  326299 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(326362), // Rule ID 19997 //
     /*  326304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  326318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326343 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  326346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326360 */     GIR_RootConstrainSelectedInstOperands,
     /*  326361 */     // GIR_Coverage, 19997,
     /*  326361 */     GIR_EraseRootFromParent_Done,
     /*  326362 */   // Label 5999: @326362
     /*  326362 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(326425), // Rule ID 20000 //
     /*  326367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  326381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326406 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  326409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326423 */     GIR_RootConstrainSelectedInstOperands,
     /*  326424 */     // GIR_Coverage, 20000,
     /*  326424 */     GIR_EraseRootFromParent_Done,
     /*  326425 */   // Label 6000: @326425
     /*  326425 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(326488), // Rule ID 20001 //
     /*  326430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  326444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326469 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  326472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326486 */     GIR_RootConstrainSelectedInstOperands,
     /*  326487 */     // GIR_Coverage, 20001,
     /*  326487 */     GIR_EraseRootFromParent_Done,
     /*  326488 */   // Label 6001: @326488
     /*  326488 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(326551), // Rule ID 20004 //
     /*  326493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  326507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  326510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326532 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  326535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326549 */     GIR_RootConstrainSelectedInstOperands,
     /*  326550 */     // GIR_Coverage, 20004,
     /*  326550 */     GIR_EraseRootFromParent_Done,
     /*  326551 */   // Label 6002: @326551
     /*  326551 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(326614), // Rule ID 20005 //
     /*  326556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  326570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  326573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326595 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  326598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326612 */     GIR_RootConstrainSelectedInstOperands,
     /*  326613 */     // GIR_Coverage, 20005,
     /*  326613 */     GIR_EraseRootFromParent_Done,
     /*  326614 */   // Label 6003: @326614
     /*  326614 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(326677), // Rule ID 20008 //
     /*  326619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  326633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  326636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326658 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  326661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326675 */     GIR_RootConstrainSelectedInstOperands,
     /*  326676 */     // GIR_Coverage, 20008,
     /*  326676 */     GIR_EraseRootFromParent_Done,
     /*  326677 */   // Label 6004: @326677
     /*  326677 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(326740), // Rule ID 20009 //
     /*  326682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  326696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  326699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326721 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  326724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326738 */     GIR_RootConstrainSelectedInstOperands,
     /*  326739 */     // GIR_Coverage, 20009,
     /*  326739 */     GIR_EraseRootFromParent_Done,
     /*  326740 */   // Label 6005: @326740
     /*  326740 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(326803), // Rule ID 20012 //
     /*  326745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  326759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  326762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326784 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  326787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326801 */     GIR_RootConstrainSelectedInstOperands,
     /*  326802 */     // GIR_Coverage, 20012,
     /*  326802 */     GIR_EraseRootFromParent_Done,
     /*  326803 */   // Label 6006: @326803
     /*  326803 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(326866), // Rule ID 20013 //
     /*  326808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  326822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  326825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326847 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  326850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326864 */     GIR_RootConstrainSelectedInstOperands,
     /*  326865 */     // GIR_Coverage, 20013,
     /*  326865 */     GIR_EraseRootFromParent_Done,
     /*  326866 */   // Label 6007: @326866
     /*  326866 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(326929), // Rule ID 20016 //
     /*  326871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  326885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  326888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326910 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  326913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326927 */     GIR_RootConstrainSelectedInstOperands,
     /*  326928 */     // GIR_Coverage, 20016,
     /*  326928 */     GIR_EraseRootFromParent_Done,
     /*  326929 */   // Label 6008: @326929
     /*  326929 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(326992), // Rule ID 20017 //
     /*  326934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  326948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  326951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326973 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  326976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326990 */     GIR_RootConstrainSelectedInstOperands,
     /*  326991 */     // GIR_Coverage, 20017,
     /*  326991 */     GIR_EraseRootFromParent_Done,
     /*  326992 */   // Label 6009: @326992
     /*  326992 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(327055), // Rule ID 20020 //
     /*  326997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  327011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  327014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327036 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  327039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327053 */     GIR_RootConstrainSelectedInstOperands,
     /*  327054 */     // GIR_Coverage, 20020,
     /*  327054 */     GIR_EraseRootFromParent_Done,
     /*  327055 */   // Label 6010: @327055
     /*  327055 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(327118), // Rule ID 20021 //
     /*  327060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  327074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  327077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327099 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  327102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327116 */     GIR_RootConstrainSelectedInstOperands,
     /*  327117 */     // GIR_Coverage, 20021,
     /*  327117 */     GIR_EraseRootFromParent_Done,
     /*  327118 */   // Label 6011: @327118
     /*  327118 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(327181), // Rule ID 20024 //
     /*  327123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  327126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  327137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  327140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327162 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  327162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  327165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327179 */     GIR_RootConstrainSelectedInstOperands,
     /*  327180 */     // GIR_Coverage, 20024,
     /*  327180 */     GIR_EraseRootFromParent_Done,
     /*  327181 */   // Label 6012: @327181
     /*  327181 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(327244), // Rule ID 20025 //
     /*  327186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  327189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  327200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  327203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327225 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  327225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  327228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327242 */     GIR_RootConstrainSelectedInstOperands,
     /*  327243 */     // GIR_Coverage, 20025,
     /*  327243 */     GIR_EraseRootFromParent_Done,
     /*  327244 */   // Label 6013: @327244
     /*  327244 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(327307), // Rule ID 20028 //
     /*  327249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  327263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  327266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327288 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  327291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327305 */     GIR_RootConstrainSelectedInstOperands,
     /*  327306 */     // GIR_Coverage, 20028,
     /*  327306 */     GIR_EraseRootFromParent_Done,
     /*  327307 */   // Label 6014: @327307
     /*  327307 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(327370), // Rule ID 20029 //
     /*  327312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  327326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  327329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327351 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  327354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327368 */     GIR_RootConstrainSelectedInstOperands,
     /*  327369 */     // GIR_Coverage, 20029,
     /*  327369 */     GIR_EraseRootFromParent_Done,
     /*  327370 */   // Label 6015: @327370
     /*  327370 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(327433), // Rule ID 20032 //
     /*  327375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  327389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  327392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327414 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  327417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327431 */     GIR_RootConstrainSelectedInstOperands,
     /*  327432 */     // GIR_Coverage, 20032,
     /*  327432 */     GIR_EraseRootFromParent_Done,
     /*  327433 */   // Label 6016: @327433
     /*  327433 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(327496), // Rule ID 20033 //
     /*  327438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  327452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  327455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327477 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  327480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327494 */     GIR_RootConstrainSelectedInstOperands,
     /*  327495 */     // GIR_Coverage, 20033,
     /*  327495 */     GIR_EraseRootFromParent_Done,
     /*  327496 */   // Label 6017: @327496
     /*  327496 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(327559), // Rule ID 20036 //
     /*  327501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  327512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  327515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  327518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327540 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  327543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327557 */     GIR_RootConstrainSelectedInstOperands,
     /*  327558 */     // GIR_Coverage, 20036,
     /*  327558 */     GIR_EraseRootFromParent_Done,
     /*  327559 */   // Label 6018: @327559
     /*  327559 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(327622), // Rule ID 20037 //
     /*  327564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  327575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  327578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  327581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327603 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  327606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327620 */     GIR_RootConstrainSelectedInstOperands,
     /*  327621 */     // GIR_Coverage, 20037,
     /*  327621 */     GIR_EraseRootFromParent_Done,
     /*  327622 */   // Label 6019: @327622
     /*  327622 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(327685), // Rule ID 20040 //
     /*  327627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  327641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  327644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327666 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  327669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327683 */     GIR_RootConstrainSelectedInstOperands,
     /*  327684 */     // GIR_Coverage, 20040,
     /*  327684 */     GIR_EraseRootFromParent_Done,
     /*  327685 */   // Label 6020: @327685
     /*  327685 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(327748), // Rule ID 20041 //
     /*  327690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  327704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  327707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327729 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  327732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327746 */     GIR_RootConstrainSelectedInstOperands,
     /*  327747 */     // GIR_Coverage, 20041,
     /*  327747 */     GIR_EraseRootFromParent_Done,
     /*  327748 */   // Label 6021: @327748
     /*  327748 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(327811), // Rule ID 20044 //
     /*  327753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  327767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  327770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327792 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  327795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327809 */     GIR_RootConstrainSelectedInstOperands,
     /*  327810 */     // GIR_Coverage, 20044,
     /*  327810 */     GIR_EraseRootFromParent_Done,
     /*  327811 */   // Label 6022: @327811
     /*  327811 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(327874), // Rule ID 20045 //
     /*  327816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  327830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  327833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327855 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  327858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327872 */     GIR_RootConstrainSelectedInstOperands,
     /*  327873 */     // GIR_Coverage, 20045,
     /*  327873 */     GIR_EraseRootFromParent_Done,
     /*  327874 */   // Label 6023: @327874
     /*  327874 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(327937), // Rule ID 20048 //
     /*  327879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  327893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  327896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327918 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  327921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327935 */     GIR_RootConstrainSelectedInstOperands,
     /*  327936 */     // GIR_Coverage, 20048,
     /*  327936 */     GIR_EraseRootFromParent_Done,
     /*  327937 */   // Label 6024: @327937
     /*  327937 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(328000), // Rule ID 20049 //
     /*  327942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  327956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  327959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327981 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  327984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327998 */     GIR_RootConstrainSelectedInstOperands,
     /*  327999 */     // GIR_Coverage, 20049,
     /*  327999 */     GIR_EraseRootFromParent_Done,
     /*  328000 */   // Label 6025: @328000
     /*  328000 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(328063), // Rule ID 20052 //
     /*  328005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  328019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  328022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328044 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  328047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328061 */     GIR_RootConstrainSelectedInstOperands,
     /*  328062 */     // GIR_Coverage, 20052,
     /*  328062 */     GIR_EraseRootFromParent_Done,
     /*  328063 */   // Label 6026: @328063
     /*  328063 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(328126), // Rule ID 20053 //
     /*  328068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  328082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  328085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328107 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  328110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328124 */     GIR_RootConstrainSelectedInstOperands,
     /*  328125 */     // GIR_Coverage, 20053,
     /*  328125 */     GIR_EraseRootFromParent_Done,
     /*  328126 */   // Label 6027: @328126
     /*  328126 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(328189), // Rule ID 20056 //
     /*  328131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  328145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  328148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328170 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  328173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328187 */     GIR_RootConstrainSelectedInstOperands,
     /*  328188 */     // GIR_Coverage, 20056,
     /*  328188 */     GIR_EraseRootFromParent_Done,
     /*  328189 */   // Label 6028: @328189
     /*  328189 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(328252), // Rule ID 20057 //
     /*  328194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  328208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  328211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328233 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  328236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328250 */     GIR_RootConstrainSelectedInstOperands,
     /*  328251 */     // GIR_Coverage, 20057,
     /*  328251 */     GIR_EraseRootFromParent_Done,
     /*  328252 */   // Label 6029: @328252
     /*  328252 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(328315), // Rule ID 20060 //
     /*  328257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  328271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  328274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328296 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  328299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328313 */     GIR_RootConstrainSelectedInstOperands,
     /*  328314 */     // GIR_Coverage, 20060,
     /*  328314 */     GIR_EraseRootFromParent_Done,
     /*  328315 */   // Label 6030: @328315
     /*  328315 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(328378), // Rule ID 20061 //
     /*  328320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  328334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  328337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328359 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  328362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328376 */     GIR_RootConstrainSelectedInstOperands,
     /*  328377 */     // GIR_Coverage, 20061,
     /*  328377 */     GIR_EraseRootFromParent_Done,
     /*  328378 */   // Label 6031: @328378
     /*  328378 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(328441), // Rule ID 20064 //
     /*  328383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  328397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328422 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  328425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328439 */     GIR_RootConstrainSelectedInstOperands,
     /*  328440 */     // GIR_Coverage, 20064,
     /*  328440 */     GIR_EraseRootFromParent_Done,
     /*  328441 */   // Label 6032: @328441
     /*  328441 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(328504), // Rule ID 20065 //
     /*  328446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  328460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328485 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  328488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328502 */     GIR_RootConstrainSelectedInstOperands,
     /*  328503 */     // GIR_Coverage, 20065,
     /*  328503 */     GIR_EraseRootFromParent_Done,
     /*  328504 */   // Label 6033: @328504
     /*  328504 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(328567), // Rule ID 20068 //
     /*  328509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  328523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328548 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  328551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328565 */     GIR_RootConstrainSelectedInstOperands,
     /*  328566 */     // GIR_Coverage, 20068,
     /*  328566 */     GIR_EraseRootFromParent_Done,
     /*  328567 */   // Label 6034: @328567
     /*  328567 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(328630), // Rule ID 20069 //
     /*  328572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  328586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328611 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  328614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328628 */     GIR_RootConstrainSelectedInstOperands,
     /*  328629 */     // GIR_Coverage, 20069,
     /*  328629 */     GIR_EraseRootFromParent_Done,
     /*  328630 */   // Label 6035: @328630
     /*  328630 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(328693), // Rule ID 20072 //
     /*  328635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  328649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328674 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  328677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328691 */     GIR_RootConstrainSelectedInstOperands,
     /*  328692 */     // GIR_Coverage, 20072,
     /*  328692 */     GIR_EraseRootFromParent_Done,
     /*  328693 */   // Label 6036: @328693
     /*  328693 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(328756), // Rule ID 20073 //
     /*  328698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  328712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328737 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  328740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328754 */     GIR_RootConstrainSelectedInstOperands,
     /*  328755 */     // GIR_Coverage, 20073,
     /*  328755 */     GIR_EraseRootFromParent_Done,
     /*  328756 */   // Label 6037: @328756
     /*  328756 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(328819), // Rule ID 20076 //
     /*  328761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  328775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328800 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  328803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328817 */     GIR_RootConstrainSelectedInstOperands,
     /*  328818 */     // GIR_Coverage, 20076,
     /*  328818 */     GIR_EraseRootFromParent_Done,
     /*  328819 */   // Label 6038: @328819
     /*  328819 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(328882), // Rule ID 20077 //
     /*  328824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  328838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328863 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  328866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328880 */     GIR_RootConstrainSelectedInstOperands,
     /*  328881 */     // GIR_Coverage, 20077,
     /*  328881 */     GIR_EraseRootFromParent_Done,
     /*  328882 */   // Label 6039: @328882
     /*  328882 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(328945), // Rule ID 20080 //
     /*  328887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  328901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328926 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  328929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328943 */     GIR_RootConstrainSelectedInstOperands,
     /*  328944 */     // GIR_Coverage, 20080,
     /*  328944 */     GIR_EraseRootFromParent_Done,
     /*  328945 */   // Label 6040: @328945
     /*  328945 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(329008), // Rule ID 20081 //
     /*  328950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  328964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328989 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  328992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329006 */     GIR_RootConstrainSelectedInstOperands,
     /*  329007 */     // GIR_Coverage, 20081,
     /*  329007 */     GIR_EraseRootFromParent_Done,
     /*  329008 */   // Label 6041: @329008
     /*  329008 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(329071), // Rule ID 20084 //
     /*  329013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  329016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  329027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329052 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  329055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329069 */     GIR_RootConstrainSelectedInstOperands,
     /*  329070 */     // GIR_Coverage, 20084,
     /*  329070 */     GIR_EraseRootFromParent_Done,
     /*  329071 */   // Label 6042: @329071
     /*  329071 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(329134), // Rule ID 20085 //
     /*  329076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  329079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  329090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329115 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  329115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  329118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329132 */     GIR_RootConstrainSelectedInstOperands,
     /*  329133 */     // GIR_Coverage, 20085,
     /*  329133 */     GIR_EraseRootFromParent_Done,
     /*  329134 */   // Label 6043: @329134
     /*  329134 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(329197), // Rule ID 20088 //
     /*  329139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  329153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329178 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  329181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329195 */     GIR_RootConstrainSelectedInstOperands,
     /*  329196 */     // GIR_Coverage, 20088,
     /*  329196 */     GIR_EraseRootFromParent_Done,
     /*  329197 */   // Label 6044: @329197
     /*  329197 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(329260), // Rule ID 20089 //
     /*  329202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  329216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329241 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  329244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329258 */     GIR_RootConstrainSelectedInstOperands,
     /*  329259 */     // GIR_Coverage, 20089,
     /*  329259 */     GIR_EraseRootFromParent_Done,
     /*  329260 */   // Label 6045: @329260
     /*  329260 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(329323), // Rule ID 20092 //
     /*  329265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329304 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  329307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329321 */     GIR_RootConstrainSelectedInstOperands,
     /*  329322 */     // GIR_Coverage, 20092,
     /*  329322 */     GIR_EraseRootFromParent_Done,
     /*  329323 */   // Label 6046: @329323
     /*  329323 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(329386), // Rule ID 20093 //
     /*  329328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329367 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  329370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329384 */     GIR_RootConstrainSelectedInstOperands,
     /*  329385 */     // GIR_Coverage, 20093,
     /*  329385 */     GIR_EraseRootFromParent_Done,
     /*  329386 */   // Label 6047: @329386
     /*  329386 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(329449), // Rule ID 20096 //
     /*  329391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329430 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  329433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329447 */     GIR_RootConstrainSelectedInstOperands,
     /*  329448 */     // GIR_Coverage, 20096,
     /*  329448 */     GIR_EraseRootFromParent_Done,
     /*  329449 */   // Label 6048: @329449
     /*  329449 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(329512), // Rule ID 20097 //
     /*  329454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329493 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  329496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329510 */     GIR_RootConstrainSelectedInstOperands,
     /*  329511 */     // GIR_Coverage, 20097,
     /*  329511 */     GIR_EraseRootFromParent_Done,
     /*  329512 */   // Label 6049: @329512
     /*  329512 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(329575), // Rule ID 20100 //
     /*  329517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329556 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  329559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329573 */     GIR_RootConstrainSelectedInstOperands,
     /*  329574 */     // GIR_Coverage, 20100,
     /*  329574 */     GIR_EraseRootFromParent_Done,
     /*  329575 */   // Label 6050: @329575
     /*  329575 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(329638), // Rule ID 20101 //
     /*  329580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329619 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  329622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329636 */     GIR_RootConstrainSelectedInstOperands,
     /*  329637 */     // GIR_Coverage, 20101,
     /*  329637 */     GIR_EraseRootFromParent_Done,
     /*  329638 */   // Label 6051: @329638
     /*  329638 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(329701), // Rule ID 20104 //
     /*  329643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  329657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329682 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  329685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329699 */     GIR_RootConstrainSelectedInstOperands,
     /*  329700 */     // GIR_Coverage, 20104,
     /*  329700 */     GIR_EraseRootFromParent_Done,
     /*  329701 */   // Label 6052: @329701
     /*  329701 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(329764), // Rule ID 20105 //
     /*  329706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  329720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329745 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  329748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329762 */     GIR_RootConstrainSelectedInstOperands,
     /*  329763 */     // GIR_Coverage, 20105,
     /*  329763 */     GIR_EraseRootFromParent_Done,
     /*  329764 */   // Label 6053: @329764
     /*  329764 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(329827), // Rule ID 20108 //
     /*  329769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  329783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329808 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  329811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329825 */     GIR_RootConstrainSelectedInstOperands,
     /*  329826 */     // GIR_Coverage, 20108,
     /*  329826 */     GIR_EraseRootFromParent_Done,
     /*  329827 */   // Label 6054: @329827
     /*  329827 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(329890), // Rule ID 20109 //
     /*  329832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  329846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329871 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  329874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329888 */     GIR_RootConstrainSelectedInstOperands,
     /*  329889 */     // GIR_Coverage, 20109,
     /*  329889 */     GIR_EraseRootFromParent_Done,
     /*  329890 */   // Label 6055: @329890
     /*  329890 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(329953), // Rule ID 20112 //
     /*  329895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  329898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  329909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329934 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  329937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329951 */     GIR_RootConstrainSelectedInstOperands,
     /*  329952 */     // GIR_Coverage, 20112,
     /*  329952 */     GIR_EraseRootFromParent_Done,
     /*  329953 */   // Label 6056: @329953
     /*  329953 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(330016), // Rule ID 20113 //
     /*  329958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  329961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  329972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329997 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  329997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  330000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330014 */     GIR_RootConstrainSelectedInstOperands,
     /*  330015 */     // GIR_Coverage, 20113,
     /*  330015 */     GIR_EraseRootFromParent_Done,
     /*  330016 */   // Label 6057: @330016
     /*  330016 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(330079), // Rule ID 20116 //
     /*  330021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  330029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  330035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330060 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  330063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330077 */     GIR_RootConstrainSelectedInstOperands,
     /*  330078 */     // GIR_Coverage, 20116,
     /*  330078 */     GIR_EraseRootFromParent_Done,
     /*  330079 */   // Label 6058: @330079
     /*  330079 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(330142), // Rule ID 20117 //
     /*  330084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  330092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  330098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330123 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  330126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330140 */     GIR_RootConstrainSelectedInstOperands,
     /*  330141 */     // GIR_Coverage, 20117,
     /*  330141 */     GIR_EraseRootFromParent_Done,
     /*  330142 */   // Label 6059: @330142
     /*  330142 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(330205), // Rule ID 20120 //
     /*  330147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  330155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330186 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  330189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330203 */     GIR_RootConstrainSelectedInstOperands,
     /*  330204 */     // GIR_Coverage, 20120,
     /*  330204 */     GIR_EraseRootFromParent_Done,
     /*  330205 */   // Label 6060: @330205
     /*  330205 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(330268), // Rule ID 20121 //
     /*  330210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  330218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330249 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  330252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330266 */     GIR_RootConstrainSelectedInstOperands,
     /*  330267 */     // GIR_Coverage, 20121,
     /*  330267 */     GIR_EraseRootFromParent_Done,
     /*  330268 */   // Label 6061: @330268
     /*  330268 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(330331), // Rule ID 20124 //
     /*  330273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  330287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  330290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330312 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  330315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330329 */     GIR_RootConstrainSelectedInstOperands,
     /*  330330 */     // GIR_Coverage, 20124,
     /*  330330 */     GIR_EraseRootFromParent_Done,
     /*  330331 */   // Label 6062: @330331
     /*  330331 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(330394), // Rule ID 20125 //
     /*  330336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  330350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  330353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330375 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  330378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330392 */     GIR_RootConstrainSelectedInstOperands,
     /*  330393 */     // GIR_Coverage, 20125,
     /*  330393 */     GIR_EraseRootFromParent_Done,
     /*  330394 */   // Label 6063: @330394
     /*  330394 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(330457), // Rule ID 20128 //
     /*  330399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  330413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  330416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330438 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  330441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330455 */     GIR_RootConstrainSelectedInstOperands,
     /*  330456 */     // GIR_Coverage, 20128,
     /*  330456 */     GIR_EraseRootFromParent_Done,
     /*  330457 */   // Label 6064: @330457
     /*  330457 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(330520), // Rule ID 20129 //
     /*  330462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  330476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  330479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330501 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  330504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330518 */     GIR_RootConstrainSelectedInstOperands,
     /*  330519 */     // GIR_Coverage, 20129,
     /*  330519 */     GIR_EraseRootFromParent_Done,
     /*  330520 */   // Label 6065: @330520
     /*  330520 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(330583), // Rule ID 20132 //
     /*  330525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  330539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  330542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330564 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  330567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330581 */     GIR_RootConstrainSelectedInstOperands,
     /*  330582 */     // GIR_Coverage, 20132,
     /*  330582 */     GIR_EraseRootFromParent_Done,
     /*  330583 */   // Label 6066: @330583
     /*  330583 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(330646), // Rule ID 20133 //
     /*  330588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  330602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  330605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330627 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  330630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330644 */     GIR_RootConstrainSelectedInstOperands,
     /*  330645 */     // GIR_Coverage, 20133,
     /*  330645 */     GIR_EraseRootFromParent_Done,
     /*  330646 */   // Label 6067: @330646
     /*  330646 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(330709), // Rule ID 20136 //
     /*  330651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  330665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  330668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330690 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  330693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330707 */     GIR_RootConstrainSelectedInstOperands,
     /*  330708 */     // GIR_Coverage, 20136,
     /*  330708 */     GIR_EraseRootFromParent_Done,
     /*  330709 */   // Label 6068: @330709
     /*  330709 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(330772), // Rule ID 20137 //
     /*  330714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  330728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  330731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330753 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  330756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330770 */     GIR_RootConstrainSelectedInstOperands,
     /*  330771 */     // GIR_Coverage, 20137,
     /*  330771 */     GIR_EraseRootFromParent_Done,
     /*  330772 */   // Label 6069: @330772
     /*  330772 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(330835), // Rule ID 20140 //
     /*  330777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  330791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  330794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330816 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  330819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330833 */     GIR_RootConstrainSelectedInstOperands,
     /*  330834 */     // GIR_Coverage, 20140,
     /*  330834 */     GIR_EraseRootFromParent_Done,
     /*  330835 */   // Label 6070: @330835
     /*  330835 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(330898), // Rule ID 20141 //
     /*  330840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  330854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  330857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330879 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  330882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330896 */     GIR_RootConstrainSelectedInstOperands,
     /*  330897 */     // GIR_Coverage, 20141,
     /*  330897 */     GIR_EraseRootFromParent_Done,
     /*  330898 */   // Label 6071: @330898
     /*  330898 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(330961), // Rule ID 20144 //
     /*  330903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  330917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  330920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330942 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  330945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330959 */     GIR_RootConstrainSelectedInstOperands,
     /*  330960 */     // GIR_Coverage, 20144,
     /*  330960 */     GIR_EraseRootFromParent_Done,
     /*  330961 */   // Label 6072: @330961
     /*  330961 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(331024), // Rule ID 20145 //
     /*  330966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  330980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  330983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331005 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  331005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  331008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331022 */     GIR_RootConstrainSelectedInstOperands,
     /*  331023 */     // GIR_Coverage, 20145,
     /*  331023 */     GIR_EraseRootFromParent_Done,
     /*  331024 */   // Label 6073: @331024
     /*  331024 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(331087), // Rule ID 20148 //
     /*  331029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  331043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  331046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331068 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  331071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331085 */     GIR_RootConstrainSelectedInstOperands,
     /*  331086 */     // GIR_Coverage, 20148,
     /*  331086 */     GIR_EraseRootFromParent_Done,
     /*  331087 */   // Label 6074: @331087
     /*  331087 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(331150), // Rule ID 20149 //
     /*  331092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  331106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  331109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331131 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  331134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331148 */     GIR_RootConstrainSelectedInstOperands,
     /*  331149 */     // GIR_Coverage, 20149,
     /*  331149 */     GIR_EraseRootFromParent_Done,
     /*  331150 */   // Label 6075: @331150
     /*  331150 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(331213), // Rule ID 20152 //
     /*  331155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  331169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  331172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331194 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  331197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331211 */     GIR_RootConstrainSelectedInstOperands,
     /*  331212 */     // GIR_Coverage, 20152,
     /*  331212 */     GIR_EraseRootFromParent_Done,
     /*  331213 */   // Label 6076: @331213
     /*  331213 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(331276), // Rule ID 20153 //
     /*  331218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  331232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  331235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331257 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  331260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331274 */     GIR_RootConstrainSelectedInstOperands,
     /*  331275 */     // GIR_Coverage, 20153,
     /*  331275 */     GIR_EraseRootFromParent_Done,
     /*  331276 */   // Label 6077: @331276
     /*  331276 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(331339), // Rule ID 20156 //
     /*  331281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  331292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  331295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  331298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331320 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  331323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331337 */     GIR_RootConstrainSelectedInstOperands,
     /*  331338 */     // GIR_Coverage, 20156,
     /*  331338 */     GIR_EraseRootFromParent_Done,
     /*  331339 */   // Label 6078: @331339
     /*  331339 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(331402), // Rule ID 20157 //
     /*  331344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  331355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  331358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  331361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331383 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  331386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331400 */     GIR_RootConstrainSelectedInstOperands,
     /*  331401 */     // GIR_Coverage, 20157,
     /*  331401 */     GIR_EraseRootFromParent_Done,
     /*  331402 */   // Label 6079: @331402
     /*  331402 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(331465), // Rule ID 20160 //
     /*  331407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  331424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331446 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  331449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331463 */     GIR_RootConstrainSelectedInstOperands,
     /*  331464 */     // GIR_Coverage, 20160,
     /*  331464 */     GIR_EraseRootFromParent_Done,
     /*  331465 */   // Label 6080: @331465
     /*  331465 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(331528), // Rule ID 20161 //
     /*  331470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  331487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331509 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  331512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331526 */     GIR_RootConstrainSelectedInstOperands,
     /*  331527 */     // GIR_Coverage, 20161,
     /*  331527 */     GIR_EraseRootFromParent_Done,
     /*  331528 */   // Label 6081: @331528
     /*  331528 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(331591), // Rule ID 20164 //
     /*  331533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  331547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  331550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331572 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  331575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331589 */     GIR_RootConstrainSelectedInstOperands,
     /*  331590 */     // GIR_Coverage, 20164,
     /*  331590 */     GIR_EraseRootFromParent_Done,
     /*  331591 */   // Label 6082: @331591
     /*  331591 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(331654), // Rule ID 20165 //
     /*  331596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  331610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  331613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331635 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  331638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331652 */     GIR_RootConstrainSelectedInstOperands,
     /*  331653 */     // GIR_Coverage, 20165,
     /*  331653 */     GIR_EraseRootFromParent_Done,
     /*  331654 */   // Label 6083: @331654
     /*  331654 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(331717), // Rule ID 20168 //
     /*  331659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  331676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331698 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  331701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331715 */     GIR_RootConstrainSelectedInstOperands,
     /*  331716 */     // GIR_Coverage, 20168,
     /*  331716 */     GIR_EraseRootFromParent_Done,
     /*  331717 */   // Label 6084: @331717
     /*  331717 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(331780), // Rule ID 20169 //
     /*  331722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  331739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331761 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  331764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331778 */     GIR_RootConstrainSelectedInstOperands,
     /*  331779 */     // GIR_Coverage, 20169,
     /*  331779 */     GIR_EraseRootFromParent_Done,
     /*  331780 */   // Label 6085: @331780
     /*  331780 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(331843), // Rule ID 20172 //
     /*  331785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  331799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  331802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331824 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  331824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  331827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331841 */     GIR_RootConstrainSelectedInstOperands,
     /*  331842 */     // GIR_Coverage, 20172,
     /*  331842 */     GIR_EraseRootFromParent_Done,
     /*  331843 */   // Label 6086: @331843
     /*  331843 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(331906), // Rule ID 20173 //
     /*  331848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  331851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  331862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  331865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331887 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  331887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  331890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331904 */     GIR_RootConstrainSelectedInstOperands,
     /*  331905 */     // GIR_Coverage, 20173,
     /*  331905 */     GIR_EraseRootFromParent_Done,
     /*  331906 */   // Label 6087: @331906
     /*  331906 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(331969), // Rule ID 20176 //
     /*  331911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  331925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  331928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331950 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  331950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  331953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331967 */     GIR_RootConstrainSelectedInstOperands,
     /*  331968 */     // GIR_Coverage, 20176,
     /*  331968 */     GIR_EraseRootFromParent_Done,
     /*  331969 */   // Label 6088: @331969
     /*  331969 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(332032), // Rule ID 20177 //
     /*  331974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  331977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  331988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  331991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332013 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  332016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332030 */     GIR_RootConstrainSelectedInstOperands,
     /*  332031 */     // GIR_Coverage, 20177,
     /*  332031 */     GIR_EraseRootFromParent_Done,
     /*  332032 */   // Label 6089: @332032
     /*  332032 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(332095), // Rule ID 20180 //
     /*  332037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  332040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  332051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  332054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332076 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  332079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332093 */     GIR_RootConstrainSelectedInstOperands,
     /*  332094 */     // GIR_Coverage, 20180,
     /*  332094 */     GIR_EraseRootFromParent_Done,
     /*  332095 */   // Label 6090: @332095
     /*  332095 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(332158), // Rule ID 20181 //
     /*  332100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  332114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  332117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332139 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  332142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332156 */     GIR_RootConstrainSelectedInstOperands,
     /*  332157 */     // GIR_Coverage, 20181,
     /*  332157 */     GIR_EraseRootFromParent_Done,
     /*  332158 */   // Label 6091: @332158
     /*  332158 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(332221), // Rule ID 20184 //
     /*  332163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332202 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  332205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332219 */     GIR_RootConstrainSelectedInstOperands,
     /*  332220 */     // GIR_Coverage, 20184,
     /*  332220 */     GIR_EraseRootFromParent_Done,
     /*  332221 */   // Label 6092: @332221
     /*  332221 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(332284), // Rule ID 20185 //
     /*  332226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332265 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  332268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332282 */     GIR_RootConstrainSelectedInstOperands,
     /*  332283 */     // GIR_Coverage, 20185,
     /*  332283 */     GIR_EraseRootFromParent_Done,
     /*  332284 */   // Label 6093: @332284
     /*  332284 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(332347), // Rule ID 20188 //
     /*  332289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332328 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  332331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332345 */     GIR_RootConstrainSelectedInstOperands,
     /*  332346 */     // GIR_Coverage, 20188,
     /*  332346 */     GIR_EraseRootFromParent_Done,
     /*  332347 */   // Label 6094: @332347
     /*  332347 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(332410), // Rule ID 20189 //
     /*  332352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332391 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  332394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332408 */     GIR_RootConstrainSelectedInstOperands,
     /*  332409 */     // GIR_Coverage, 20189,
     /*  332409 */     GIR_EraseRootFromParent_Done,
     /*  332410 */   // Label 6095: @332410
     /*  332410 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(332473), // Rule ID 20192 //
     /*  332415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332454 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  332457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332471 */     GIR_RootConstrainSelectedInstOperands,
     /*  332472 */     // GIR_Coverage, 20192,
     /*  332472 */     GIR_EraseRootFromParent_Done,
     /*  332473 */   // Label 6096: @332473
     /*  332473 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(332536), // Rule ID 20193 //
     /*  332478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332517 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  332520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332534 */     GIR_RootConstrainSelectedInstOperands,
     /*  332535 */     // GIR_Coverage, 20193,
     /*  332535 */     GIR_EraseRootFromParent_Done,
     /*  332536 */   // Label 6097: @332536
     /*  332536 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(332599), // Rule ID 20196 //
     /*  332541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  332555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332580 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  332583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332597 */     GIR_RootConstrainSelectedInstOperands,
     /*  332598 */     // GIR_Coverage, 20196,
     /*  332598 */     GIR_EraseRootFromParent_Done,
     /*  332599 */   // Label 6098: @332599
     /*  332599 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(332662), // Rule ID 20197 //
     /*  332604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  332618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332643 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  332646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332660 */     GIR_RootConstrainSelectedInstOperands,
     /*  332661 */     // GIR_Coverage, 20197,
     /*  332661 */     GIR_EraseRootFromParent_Done,
     /*  332662 */   // Label 6099: @332662
     /*  332662 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(332725), // Rule ID 20200 //
     /*  332667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  332681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332706 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  332709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332723 */     GIR_RootConstrainSelectedInstOperands,
     /*  332724 */     // GIR_Coverage, 20200,
     /*  332724 */     GIR_EraseRootFromParent_Done,
     /*  332725 */   // Label 6100: @332725
     /*  332725 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(332788), // Rule ID 20201 //
     /*  332730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  332744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332769 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  332772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332786 */     GIR_RootConstrainSelectedInstOperands,
     /*  332787 */     // GIR_Coverage, 20201,
     /*  332787 */     GIR_EraseRootFromParent_Done,
     /*  332788 */   // Label 6101: @332788
     /*  332788 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(332851), // Rule ID 20204 //
     /*  332793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  332796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  332807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332832 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  332835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332849 */     GIR_RootConstrainSelectedInstOperands,
     /*  332850 */     // GIR_Coverage, 20204,
     /*  332850 */     GIR_EraseRootFromParent_Done,
     /*  332851 */   // Label 6102: @332851
     /*  332851 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(332914), // Rule ID 20205 //
     /*  332856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  332870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332895 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  332898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332912 */     GIR_RootConstrainSelectedInstOperands,
     /*  332913 */     // GIR_Coverage, 20205,
     /*  332913 */     GIR_EraseRootFromParent_Done,
     /*  332914 */   // Label 6103: @332914
     /*  332914 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(332977), // Rule ID 20208 //
     /*  332919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  332933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332958 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  332961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332975 */     GIR_RootConstrainSelectedInstOperands,
     /*  332976 */     // GIR_Coverage, 20208,
     /*  332976 */     GIR_EraseRootFromParent_Done,
     /*  332977 */   // Label 6104: @332977
     /*  332977 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(333040), // Rule ID 20209 //
     /*  332982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  332996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333021 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  333024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333038 */     GIR_RootConstrainSelectedInstOperands,
     /*  333039 */     // GIR_Coverage, 20209,
     /*  333039 */     GIR_EraseRootFromParent_Done,
     /*  333040 */   // Label 6105: @333040
     /*  333040 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(333103), // Rule ID 20212 //
     /*  333045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  333059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333084 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  333087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333101 */     GIR_RootConstrainSelectedInstOperands,
     /*  333102 */     // GIR_Coverage, 20212,
     /*  333102 */     GIR_EraseRootFromParent_Done,
     /*  333103 */   // Label 6106: @333103
     /*  333103 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(333166), // Rule ID 20213 //
     /*  333108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  333122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333147 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  333150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333164 */     GIR_RootConstrainSelectedInstOperands,
     /*  333165 */     // GIR_Coverage, 20213,
     /*  333165 */     GIR_EraseRootFromParent_Done,
     /*  333166 */   // Label 6107: @333166
     /*  333166 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(333229), // Rule ID 20216 //
     /*  333171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  333182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  333185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333210 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  333213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333227 */     GIR_RootConstrainSelectedInstOperands,
     /*  333228 */     // GIR_Coverage, 20216,
     /*  333228 */     GIR_EraseRootFromParent_Done,
     /*  333229 */   // Label 6108: @333229
     /*  333229 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(333292), // Rule ID 20217 //
     /*  333234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  333245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  333248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333273 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  333276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333290 */     GIR_RootConstrainSelectedInstOperands,
     /*  333291 */     // GIR_Coverage, 20217,
     /*  333291 */     GIR_EraseRootFromParent_Done,
     /*  333292 */   // Label 6109: @333292
     /*  333292 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(333355), // Rule ID 20220 //
     /*  333297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  333311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333336 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  333339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333353 */     GIR_RootConstrainSelectedInstOperands,
     /*  333354 */     // GIR_Coverage, 20220,
     /*  333354 */     GIR_EraseRootFromParent_Done,
     /*  333355 */   // Label 6110: @333355
     /*  333355 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(333418), // Rule ID 20221 //
     /*  333360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  333374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333399 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  333402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333416 */     GIR_RootConstrainSelectedInstOperands,
     /*  333417 */     // GIR_Coverage, 20221,
     /*  333417 */     GIR_EraseRootFromParent_Done,
     /*  333418 */   // Label 6111: @333418
     /*  333418 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(333481), // Rule ID 20224 //
     /*  333423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  333437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333462 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  333465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333479 */     GIR_RootConstrainSelectedInstOperands,
     /*  333480 */     // GIR_Coverage, 20224,
     /*  333480 */     GIR_EraseRootFromParent_Done,
     /*  333481 */   // Label 6112: @333481
     /*  333481 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(333544), // Rule ID 20225 //
     /*  333486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  333500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333525 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  333528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333542 */     GIR_RootConstrainSelectedInstOperands,
     /*  333543 */     // GIR_Coverage, 20225,
     /*  333543 */     GIR_EraseRootFromParent_Done,
     /*  333544 */   // Label 6113: @333544
     /*  333544 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(333607), // Rule ID 20228 //
     /*  333549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  333563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333588 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  333591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333605 */     GIR_RootConstrainSelectedInstOperands,
     /*  333606 */     // GIR_Coverage, 20228,
     /*  333606 */     GIR_EraseRootFromParent_Done,
     /*  333607 */   // Label 6114: @333607
     /*  333607 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(333670), // Rule ID 20229 //
     /*  333612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  333626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333651 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  333654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333668 */     GIR_RootConstrainSelectedInstOperands,
     /*  333669 */     // GIR_Coverage, 20229,
     /*  333669 */     GIR_EraseRootFromParent_Done,
     /*  333670 */   // Label 6115: @333670
     /*  333670 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(333733), // Rule ID 20232 //
     /*  333675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  333689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333714 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  333717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333731 */     GIR_RootConstrainSelectedInstOperands,
     /*  333732 */     // GIR_Coverage, 20232,
     /*  333732 */     GIR_EraseRootFromParent_Done,
     /*  333733 */   // Label 6116: @333733
     /*  333733 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(333796), // Rule ID 20233 //
     /*  333738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  333752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333777 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  333780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333794 */     GIR_RootConstrainSelectedInstOperands,
     /*  333795 */     // GIR_Coverage, 20233,
     /*  333795 */     GIR_EraseRootFromParent_Done,
     /*  333796 */   // Label 6117: @333796
     /*  333796 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(333859), // Rule ID 20236 //
     /*  333801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  333815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333840 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  333843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333857 */     GIR_RootConstrainSelectedInstOperands,
     /*  333858 */     // GIR_Coverage, 20236,
     /*  333858 */     GIR_EraseRootFromParent_Done,
     /*  333859 */   // Label 6118: @333859
     /*  333859 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(333922), // Rule ID 20237 //
     /*  333864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  333878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333903 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  333906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333920 */     GIR_RootConstrainSelectedInstOperands,
     /*  333921 */     // GIR_Coverage, 20237,
     /*  333921 */     GIR_EraseRootFromParent_Done,
     /*  333922 */   // Label 6119: @333922
     /*  333922 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(333985), // Rule ID 20240 //
     /*  333927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  333941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333966 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  333969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333983 */     GIR_RootConstrainSelectedInstOperands,
     /*  333984 */     // GIR_Coverage, 20240,
     /*  333984 */     GIR_EraseRootFromParent_Done,
     /*  333985 */   // Label 6120: @333985
     /*  333985 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(334048), // Rule ID 20241 //
     /*  333990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  334004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334029 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  334029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  334032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334046 */     GIR_RootConstrainSelectedInstOperands,
     /*  334047 */     // GIR_Coverage, 20241,
     /*  334047 */     GIR_EraseRootFromParent_Done,
     /*  334048 */   // Label 6121: @334048
     /*  334048 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(334111), // Rule ID 20244 //
     /*  334053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  334067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334092 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  334095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334109 */     GIR_RootConstrainSelectedInstOperands,
     /*  334110 */     // GIR_Coverage, 20244,
     /*  334110 */     GIR_EraseRootFromParent_Done,
     /*  334111 */   // Label 6122: @334111
     /*  334111 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(334174), // Rule ID 20245 //
     /*  334116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  334130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334155 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  334158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334172 */     GIR_RootConstrainSelectedInstOperands,
     /*  334173 */     // GIR_Coverage, 20245,
     /*  334173 */     GIR_EraseRootFromParent_Done,
     /*  334174 */   // Label 6123: @334174
     /*  334174 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(334237), // Rule ID 20248 //
     /*  334179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  334193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334218 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  334221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334235 */     GIR_RootConstrainSelectedInstOperands,
     /*  334236 */     // GIR_Coverage, 20248,
     /*  334236 */     GIR_EraseRootFromParent_Done,
     /*  334237 */   // Label 6124: @334237
     /*  334237 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(334300), // Rule ID 20249 //
     /*  334242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  334256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334281 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  334284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334298 */     GIR_RootConstrainSelectedInstOperands,
     /*  334299 */     // GIR_Coverage, 20249,
     /*  334299 */     GIR_EraseRootFromParent_Done,
     /*  334300 */   // Label 6125: @334300
     /*  334300 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(334363), // Rule ID 20252 //
     /*  334305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  334319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  334322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  334337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334344 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  334347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334361 */     GIR_RootConstrainSelectedInstOperands,
     /*  334362 */     // GIR_Coverage, 20252,
     /*  334362 */     GIR_EraseRootFromParent_Done,
     /*  334363 */   // Label 6126: @334363
     /*  334363 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(334426), // Rule ID 20253 //
     /*  334368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  334382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  334385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  334400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334407 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  334410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334424 */     GIR_RootConstrainSelectedInstOperands,
     /*  334425 */     // GIR_Coverage, 20253,
     /*  334425 */     GIR_EraseRootFromParent_Done,
     /*  334426 */   // Label 6127: @334426
     /*  334426 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(334489), // Rule ID 20256 //
     /*  334431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  334445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334470 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  334473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334487 */     GIR_RootConstrainSelectedInstOperands,
     /*  334488 */     // GIR_Coverage, 20256,
     /*  334488 */     GIR_EraseRootFromParent_Done,
     /*  334489 */   // Label 6128: @334489
     /*  334489 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(334552), // Rule ID 20257 //
     /*  334494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  334508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334533 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  334536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334550 */     GIR_RootConstrainSelectedInstOperands,
     /*  334551 */     // GIR_Coverage, 20257,
     /*  334551 */     GIR_EraseRootFromParent_Done,
     /*  334552 */   // Label 6129: @334552
     /*  334552 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(334615), // Rule ID 20260 //
     /*  334557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  334571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  334574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  334589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334596 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  334599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334613 */     GIR_RootConstrainSelectedInstOperands,
     /*  334614 */     // GIR_Coverage, 20260,
     /*  334614 */     GIR_EraseRootFromParent_Done,
     /*  334615 */   // Label 6130: @334615
     /*  334615 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(334678), // Rule ID 20261 //
     /*  334620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  334634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  334637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  334652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334659 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  334662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334676 */     GIR_RootConstrainSelectedInstOperands,
     /*  334677 */     // GIR_Coverage, 20261,
     /*  334677 */     GIR_EraseRootFromParent_Done,
     /*  334678 */   // Label 6131: @334678
     /*  334678 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(334741), // Rule ID 20264 //
     /*  334683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  334686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  334697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334722 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  334722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  334725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334739 */     GIR_RootConstrainSelectedInstOperands,
     /*  334740 */     // GIR_Coverage, 20264,
     /*  334740 */     GIR_EraseRootFromParent_Done,
     /*  334741 */   // Label 6132: @334741
     /*  334741 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(334804), // Rule ID 20265 //
     /*  334746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  334749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  334760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334785 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  334785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  334788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334802 */     GIR_RootConstrainSelectedInstOperands,
     /*  334803 */     // GIR_Coverage, 20265,
     /*  334803 */     GIR_EraseRootFromParent_Done,
     /*  334804 */   // Label 6133: @334804
     /*  334804 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(334867), // Rule ID 20268 //
     /*  334809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  334823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334848 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  334851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334865 */     GIR_RootConstrainSelectedInstOperands,
     /*  334866 */     // GIR_Coverage, 20268,
     /*  334866 */     GIR_EraseRootFromParent_Done,
     /*  334867 */   // Label 6134: @334867
     /*  334867 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(334930), // Rule ID 20269 //
     /*  334872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  334886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334911 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  334914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334928 */     GIR_RootConstrainSelectedInstOperands,
     /*  334929 */     // GIR_Coverage, 20269,
     /*  334929 */     GIR_EraseRootFromParent_Done,
     /*  334930 */   // Label 6135: @334930
     /*  334930 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(334993), // Rule ID 20272 //
     /*  334935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  334946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  334949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334974 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  334977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334991 */     GIR_RootConstrainSelectedInstOperands,
     /*  334992 */     // GIR_Coverage, 20272,
     /*  334992 */     GIR_EraseRootFromParent_Done,
     /*  334993 */   // Label 6136: @334993
     /*  334993 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(335056), // Rule ID 20273 //
     /*  334998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  335012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  335015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  335030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335037 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  335040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335054 */     GIR_RootConstrainSelectedInstOperands,
     /*  335055 */     // GIR_Coverage, 20273,
     /*  335055 */     GIR_EraseRootFromParent_Done,
     /*  335056 */   // Label 6137: @335056
     /*  335056 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(335119), // Rule ID 20276 //
     /*  335061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  335072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  335075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  335078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  335093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335100 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  335103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335117 */     GIR_RootConstrainSelectedInstOperands,
     /*  335118 */     // GIR_Coverage, 20276,
     /*  335118 */     GIR_EraseRootFromParent_Done,
     /*  335119 */   // Label 6138: @335119
     /*  335119 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(335182), // Rule ID 20277 //
     /*  335124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  335135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  335138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  335141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  335156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335163 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  335166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335180 */     GIR_RootConstrainSelectedInstOperands,
     /*  335181 */     // GIR_Coverage, 20277,
     /*  335181 */     GIR_EraseRootFromParent_Done,
     /*  335182 */   // Label 6139: @335182
     /*  335182 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(335245), // Rule ID 20280 //
     /*  335187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  335201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  335204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  335219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335226 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  335229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335243 */     GIR_RootConstrainSelectedInstOperands,
     /*  335244 */     // GIR_Coverage, 20280,
     /*  335244 */     GIR_EraseRootFromParent_Done,
     /*  335245 */   // Label 6140: @335245
     /*  335245 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(335308), // Rule ID 20281 //
     /*  335250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  335264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  335267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  335282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335289 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  335292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335306 */     GIR_RootConstrainSelectedInstOperands,
     /*  335307 */     // GIR_Coverage, 20281,
     /*  335307 */     GIR_EraseRootFromParent_Done,
     /*  335308 */   // Label 6141: @335308
     /*  335308 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(335371), // Rule ID 20284 //
     /*  335313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  335327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  335330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  335345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335352 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  335355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335369 */     GIR_RootConstrainSelectedInstOperands,
     /*  335370 */     // GIR_Coverage, 20284,
     /*  335370 */     GIR_EraseRootFromParent_Done,
     /*  335371 */   // Label 6142: @335371
     /*  335371 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(335434), // Rule ID 20285 //
     /*  335376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  335390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  335393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  335408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335415 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  335418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335432 */     GIR_RootConstrainSelectedInstOperands,
     /*  335433 */     // GIR_Coverage, 20285,
     /*  335433 */     GIR_EraseRootFromParent_Done,
     /*  335434 */   // Label 6143: @335434
     /*  335434 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(335497), // Rule ID 20288 //
     /*  335439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  335456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  335471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335478 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  335481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335495 */     GIR_RootConstrainSelectedInstOperands,
     /*  335496 */     // GIR_Coverage, 20288,
     /*  335496 */     GIR_EraseRootFromParent_Done,
     /*  335497 */   // Label 6144: @335497
     /*  335497 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(335560), // Rule ID 20289 //
     /*  335502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  335519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  335534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335541 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  335544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335558 */     GIR_RootConstrainSelectedInstOperands,
     /*  335559 */     // GIR_Coverage, 20289,
     /*  335559 */     GIR_EraseRootFromParent_Done,
     /*  335560 */   // Label 6145: @335560
     /*  335560 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(335623), // Rule ID 20292 //
     /*  335565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  335582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  335597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335604 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  335607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335621 */     GIR_RootConstrainSelectedInstOperands,
     /*  335622 */     // GIR_Coverage, 20292,
     /*  335622 */     GIR_EraseRootFromParent_Done,
     /*  335623 */   // Label 6146: @335623
     /*  335623 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(335686), // Rule ID 20293 //
     /*  335628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  335645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  335660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335667 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  335670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335684 */     GIR_RootConstrainSelectedInstOperands,
     /*  335685 */     // GIR_Coverage, 20293,
     /*  335685 */     GIR_EraseRootFromParent_Done,
     /*  335686 */   // Label 6147: @335686
     /*  335686 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(335749), // Rule ID 20296 //
     /*  335691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  335705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  335708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  335723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335730 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  335733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335747 */     GIR_RootConstrainSelectedInstOperands,
     /*  335748 */     // GIR_Coverage, 20296,
     /*  335748 */     GIR_EraseRootFromParent_Done,
     /*  335749 */   // Label 6148: @335749
     /*  335749 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(335812), // Rule ID 20297 //
     /*  335754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  335768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  335771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  335786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335793 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  335796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335810 */     GIR_RootConstrainSelectedInstOperands,
     /*  335811 */     // GIR_Coverage, 20297,
     /*  335811 */     GIR_EraseRootFromParent_Done,
     /*  335812 */   // Label 6149: @335812
     /*  335812 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(335875), // Rule ID 20300 //
     /*  335817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  335831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  335834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  335849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335856 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  335859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335873 */     GIR_RootConstrainSelectedInstOperands,
     /*  335874 */     // GIR_Coverage, 20300,
     /*  335874 */     GIR_EraseRootFromParent_Done,
     /*  335875 */   // Label 6150: @335875
     /*  335875 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(335938), // Rule ID 20301 //
     /*  335880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  335894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  335897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  335912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335919 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  335922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335936 */     GIR_RootConstrainSelectedInstOperands,
     /*  335937 */     // GIR_Coverage, 20301,
     /*  335937 */     GIR_EraseRootFromParent_Done,
     /*  335938 */   // Label 6151: @335938
     /*  335938 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(336001), // Rule ID 20304 //
     /*  335943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  335957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  335960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  335975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335982 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  335985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335999 */     GIR_RootConstrainSelectedInstOperands,
     /*  336000 */     // GIR_Coverage, 20304,
     /*  336000 */     GIR_EraseRootFromParent_Done,
     /*  336001 */   // Label 6152: @336001
     /*  336001 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(336064), // Rule ID 20305 //
     /*  336006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  336020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336045 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  336048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336062 */     GIR_RootConstrainSelectedInstOperands,
     /*  336063 */     // GIR_Coverage, 20305,
     /*  336063 */     GIR_EraseRootFromParent_Done,
     /*  336064 */   // Label 6153: @336064
     /*  336064 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(336127), // Rule ID 20308 //
     /*  336069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336108 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  336111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336125 */     GIR_RootConstrainSelectedInstOperands,
     /*  336126 */     // GIR_Coverage, 20308,
     /*  336126 */     GIR_EraseRootFromParent_Done,
     /*  336127 */   // Label 6154: @336127
     /*  336127 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(336190), // Rule ID 20309 //
     /*  336132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336171 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  336174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336188 */     GIR_RootConstrainSelectedInstOperands,
     /*  336189 */     // GIR_Coverage, 20309,
     /*  336189 */     GIR_EraseRootFromParent_Done,
     /*  336190 */   // Label 6155: @336190
     /*  336190 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(336253), // Rule ID 20312 //
     /*  336195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  336212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  336227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336234 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  336237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336251 */     GIR_RootConstrainSelectedInstOperands,
     /*  336252 */     // GIR_Coverage, 20312,
     /*  336252 */     GIR_EraseRootFromParent_Done,
     /*  336253 */   // Label 6156: @336253
     /*  336253 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(336316), // Rule ID 20313 //
     /*  336258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  336275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  336290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336297 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  336300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336314 */     GIR_RootConstrainSelectedInstOperands,
     /*  336315 */     // GIR_Coverage, 20313,
     /*  336315 */     GIR_EraseRootFromParent_Done,
     /*  336316 */   // Label 6157: @336316
     /*  336316 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(336379), // Rule ID 20316 //
     /*  336321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  336335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336360 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  336363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336377 */     GIR_RootConstrainSelectedInstOperands,
     /*  336378 */     // GIR_Coverage, 20316,
     /*  336378 */     GIR_EraseRootFromParent_Done,
     /*  336379 */   // Label 6158: @336379
     /*  336379 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(336442), // Rule ID 20317 //
     /*  336384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  336398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336423 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  336426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336440 */     GIR_RootConstrainSelectedInstOperands,
     /*  336441 */     // GIR_Coverage, 20317,
     /*  336441 */     GIR_EraseRootFromParent_Done,
     /*  336442 */   // Label 6159: @336442
     /*  336442 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(336505), // Rule ID 20320 //
     /*  336447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  336461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  336464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  336479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336486 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  336489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336503 */     GIR_RootConstrainSelectedInstOperands,
     /*  336504 */     // GIR_Coverage, 20320,
     /*  336504 */     GIR_EraseRootFromParent_Done,
     /*  336505 */   // Label 6160: @336505
     /*  336505 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(336568), // Rule ID 20321 //
     /*  336510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  336524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  336527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  336542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336549 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  336552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336566 */     GIR_RootConstrainSelectedInstOperands,
     /*  336567 */     // GIR_Coverage, 20321,
     /*  336567 */     GIR_EraseRootFromParent_Done,
     /*  336568 */   // Label 6161: @336568
     /*  336568 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(336631), // Rule ID 20324 //
     /*  336573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  336576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  336587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  336590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  336605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336612 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  336612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  336615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336629 */     GIR_RootConstrainSelectedInstOperands,
     /*  336630 */     // GIR_Coverage, 20324,
     /*  336630 */     GIR_EraseRootFromParent_Done,
     /*  336631 */   // Label 6162: @336631
     /*  336631 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(336694), // Rule ID 20325 //
     /*  336636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  336639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  336650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  336653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  336668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336675 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  336675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  336678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336692 */     GIR_RootConstrainSelectedInstOperands,
     /*  336693 */     // GIR_Coverage, 20325,
     /*  336693 */     GIR_EraseRootFromParent_Done,
     /*  336694 */   // Label 6163: @336694
     /*  336694 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(336757), // Rule ID 20328 //
     /*  336699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  336713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  336741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336755 */     GIR_RootConstrainSelectedInstOperands,
     /*  336756 */     // GIR_Coverage, 20328,
     /*  336756 */     GIR_EraseRootFromParent_Done,
     /*  336757 */   // Label 6164: @336757
     /*  336757 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(336820), // Rule ID 20329 //
     /*  336762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  336776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336801 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  336804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336818 */     GIR_RootConstrainSelectedInstOperands,
     /*  336819 */     // GIR_Coverage, 20329,
     /*  336819 */     GIR_EraseRootFromParent_Done,
     /*  336820 */   // Label 6165: @336820
     /*  336820 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(336883), // Rule ID 20332 //
     /*  336825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  336836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  336839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336864 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  336867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336881 */     GIR_RootConstrainSelectedInstOperands,
     /*  336882 */     // GIR_Coverage, 20332,
     /*  336882 */     GIR_EraseRootFromParent_Done,
     /*  336883 */   // Label 6166: @336883
     /*  336883 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(336946), // Rule ID 20333 //
     /*  336888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  336899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  336902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336927 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  336930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336944 */     GIR_RootConstrainSelectedInstOperands,
     /*  336945 */     // GIR_Coverage, 20333,
     /*  336945 */     GIR_EraseRootFromParent_Done,
     /*  336946 */   // Label 6167: @336946
     /*  336946 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(337009), // Rule ID 20336 //
     /*  336951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  336962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  336965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336990 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  336993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337007 */     GIR_RootConstrainSelectedInstOperands,
     /*  337008 */     // GIR_Coverage, 20336,
     /*  337008 */     GIR_EraseRootFromParent_Done,
     /*  337009 */   // Label 6168: @337009
     /*  337009 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(337072), // Rule ID 20337 //
     /*  337014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  337017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  337025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  337028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  337031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  337046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337053 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  337053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  337056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337070 */     GIR_RootConstrainSelectedInstOperands,
     /*  337071 */     // GIR_Coverage, 20337,
     /*  337071 */     GIR_EraseRootFromParent_Done,
     /*  337072 */   // Label 6169: @337072
     /*  337072 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(337135), // Rule ID 20340 //
     /*  337077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  337091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  337094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  337109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337116 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  337119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337133 */     GIR_RootConstrainSelectedInstOperands,
     /*  337134 */     // GIR_Coverage, 20340,
     /*  337134 */     GIR_EraseRootFromParent_Done,
     /*  337135 */   // Label 6170: @337135
     /*  337135 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(337198), // Rule ID 20341 //
     /*  337140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  337154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  337157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  337172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337179 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  337182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337196 */     GIR_RootConstrainSelectedInstOperands,
     /*  337197 */     // GIR_Coverage, 20341,
     /*  337197 */     GIR_EraseRootFromParent_Done,
     /*  337198 */   // Label 6171: @337198
     /*  337198 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(337261), // Rule ID 20344 //
     /*  337203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  337217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  337220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  337235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337242 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  337245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337259 */     GIR_RootConstrainSelectedInstOperands,
     /*  337260 */     // GIR_Coverage, 20344,
     /*  337260 */     GIR_EraseRootFromParent_Done,
     /*  337261 */   // Label 6172: @337261
     /*  337261 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(337324), // Rule ID 20345 //
     /*  337266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  337280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  337283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  337298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337305 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  337308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337322 */     GIR_RootConstrainSelectedInstOperands,
     /*  337323 */     // GIR_Coverage, 20345,
     /*  337323 */     GIR_EraseRootFromParent_Done,
     /*  337324 */   // Label 6173: @337324
     /*  337324 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(337387), // Rule ID 20348 //
     /*  337329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  337343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  337346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  337361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337368 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  337371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337385 */     GIR_RootConstrainSelectedInstOperands,
     /*  337386 */     // GIR_Coverage, 20348,
     /*  337386 */     GIR_EraseRootFromParent_Done,
     /*  337387 */   // Label 6174: @337387
     /*  337387 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(337450), // Rule ID 20349 //
     /*  337392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  337406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  337409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  337424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337431 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  337434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337448 */     GIR_RootConstrainSelectedInstOperands,
     /*  337449 */     // GIR_Coverage, 20349,
     /*  337449 */     GIR_EraseRootFromParent_Done,
     /*  337450 */   // Label 6175: @337450
     /*  337450 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(337513), // Rule ID 20352 //
     /*  337455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  337469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  337472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  337487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337494 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  337497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337511 */     GIR_RootConstrainSelectedInstOperands,
     /*  337512 */     // GIR_Coverage, 20352,
     /*  337512 */     GIR_EraseRootFromParent_Done,
     /*  337513 */   // Label 6176: @337513
     /*  337513 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(337576), // Rule ID 20353 //
     /*  337518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  337532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  337535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  337550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337557 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  337560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337574 */     GIR_RootConstrainSelectedInstOperands,
     /*  337575 */     // GIR_Coverage, 20353,
     /*  337575 */     GIR_EraseRootFromParent_Done,
     /*  337576 */   // Label 6177: @337576
     /*  337576 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(337639), // Rule ID 20356 //
     /*  337581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  337595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  337598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  337613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337620 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  337623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337637 */     GIR_RootConstrainSelectedInstOperands,
     /*  337638 */     // GIR_Coverage, 20356,
     /*  337638 */     GIR_EraseRootFromParent_Done,
     /*  337639 */   // Label 6178: @337639
     /*  337639 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(337702), // Rule ID 20357 //
     /*  337644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  337658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  337661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  337676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337683 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  337686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337700 */     GIR_RootConstrainSelectedInstOperands,
     /*  337701 */     // GIR_Coverage, 20357,
     /*  337701 */     GIR_EraseRootFromParent_Done,
     /*  337702 */   // Label 6179: @337702
     /*  337702 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(337765), // Rule ID 20360 //
     /*  337707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  337721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  337724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  337739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337746 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  337749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337763 */     GIR_RootConstrainSelectedInstOperands,
     /*  337764 */     // GIR_Coverage, 20360,
     /*  337764 */     GIR_EraseRootFromParent_Done,
     /*  337765 */   // Label 6180: @337765
     /*  337765 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(337828), // Rule ID 20361 //
     /*  337770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  337784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  337787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  337802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337809 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  337812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337826 */     GIR_RootConstrainSelectedInstOperands,
     /*  337827 */     // GIR_Coverage, 20361,
     /*  337827 */     GIR_EraseRootFromParent_Done,
     /*  337828 */   // Label 6181: @337828
     /*  337828 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(337891), // Rule ID 20364 //
     /*  337833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  337836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  337841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  337844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  337847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  337850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337872 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  337872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  337875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337889 */     GIR_RootConstrainSelectedInstOperands,
     /*  337890 */     // GIR_Coverage, 20364,
     /*  337890 */     GIR_EraseRootFromParent_Done,
     /*  337891 */   // Label 6182: @337891
     /*  337891 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(337954), // Rule ID 20365 //
     /*  337896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  337899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  337904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  337907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  337910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  337913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337935 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  337935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  337938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337952 */     GIR_RootConstrainSelectedInstOperands,
     /*  337953 */     // GIR_Coverage, 20365,
     /*  337953 */     GIR_EraseRootFromParent_Done,
     /*  337954 */   // Label 6183: @337954
     /*  337954 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(338017), // Rule ID 20368 //
     /*  337959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  337962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  337967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  337973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  337976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  337998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  338001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338015 */     GIR_RootConstrainSelectedInstOperands,
     /*  338016 */     // GIR_Coverage, 20368,
     /*  338016 */     GIR_EraseRootFromParent_Done,
     /*  338017 */   // Label 6184: @338017
     /*  338017 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(338080), // Rule ID 20369 //
     /*  338022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  338025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  338033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  338036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  338039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338061 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  338061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  338064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338078 */     GIR_RootConstrainSelectedInstOperands,
     /*  338079 */     // GIR_Coverage, 20369,
     /*  338079 */     GIR_EraseRootFromParent_Done,
     /*  338080 */   // Label 6185: @338080
     /*  338080 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(338143), // Rule ID 20372 //
     /*  338085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  338088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  338096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  338099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  338102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338124 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  338124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  338127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338141 */     GIR_RootConstrainSelectedInstOperands,
     /*  338142 */     // GIR_Coverage, 20372,
     /*  338142 */     GIR_EraseRootFromParent_Done,
     /*  338143 */   // Label 6186: @338143
     /*  338143 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(338206), // Rule ID 20373 //
     /*  338148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  338151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  338159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  338162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  338165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338187 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  338187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  338190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338204 */     GIR_RootConstrainSelectedInstOperands,
     /*  338205 */     // GIR_Coverage, 20373,
     /*  338205 */     GIR_EraseRootFromParent_Done,
     /*  338206 */   // Label 6187: @338206
     /*  338206 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(338269), // Rule ID 20376 //
     /*  338211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  338214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  338222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  338225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  338228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338250 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  338250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  338253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338267 */     GIR_RootConstrainSelectedInstOperands,
     /*  338268 */     // GIR_Coverage, 20376,
     /*  338268 */     GIR_EraseRootFromParent_Done,
     /*  338269 */   // Label 6188: @338269
     /*  338269 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(338332), // Rule ID 20377 //
     /*  338274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  338277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  338285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  338288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  338291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338313 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  338313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  338316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338330 */     GIR_RootConstrainSelectedInstOperands,
     /*  338331 */     // GIR_Coverage, 20377,
     /*  338331 */     GIR_EraseRootFromParent_Done,
     /*  338332 */   // Label 6189: @338332
     /*  338332 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(338395), // Rule ID 20380 //
     /*  338337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  338340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  338348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  338351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  338354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  338376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  338379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338393 */     GIR_RootConstrainSelectedInstOperands,
     /*  338394 */     // GIR_Coverage, 20380,
     /*  338394 */     GIR_EraseRootFromParent_Done,
     /*  338395 */   // Label 6190: @338395
     /*  338395 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(338458), // Rule ID 20381 //
     /*  338400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  338403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  338411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  338414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  338417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338439 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  338439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  338442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338456 */     GIR_RootConstrainSelectedInstOperands,
     /*  338457 */     // GIR_Coverage, 20381,
     /*  338457 */     GIR_EraseRootFromParent_Done,
     /*  338458 */   // Label 6191: @338458
     /*  338458 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(338521), // Rule ID 20384 //
     /*  338463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  338466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  338474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  338477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  338480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338502 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  338502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  338505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338519 */     GIR_RootConstrainSelectedInstOperands,
     /*  338520 */     // GIR_Coverage, 20384,
     /*  338520 */     GIR_EraseRootFromParent_Done,
     /*  338521 */   // Label 6192: @338521
     /*  338521 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(338584), // Rule ID 20385 //
     /*  338526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  338529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  338537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  338540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  338543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338565 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  338565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  338568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338582 */     GIR_RootConstrainSelectedInstOperands,
     /*  338583 */     // GIR_Coverage, 20385,
     /*  338583 */     GIR_EraseRootFromParent_Done,
     /*  338584 */   // Label 6193: @338584
     /*  338584 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(338647), // Rule ID 20388 //
     /*  338589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  338592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  338600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338628 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  338628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  338631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338645 */     GIR_RootConstrainSelectedInstOperands,
     /*  338646 */     // GIR_Coverage, 20388,
     /*  338646 */     GIR_EraseRootFromParent_Done,
     /*  338647 */   // Label 6194: @338647
     /*  338647 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(338710), // Rule ID 20389 //
     /*  338652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  338655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  338663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338691 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  338691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  338694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338708 */     GIR_RootConstrainSelectedInstOperands,
     /*  338709 */     // GIR_Coverage, 20389,
     /*  338709 */     GIR_EraseRootFromParent_Done,
     /*  338710 */   // Label 6195: @338710
     /*  338710 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(338773), // Rule ID 20392 //
     /*  338715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  338718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  338726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  338729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  338732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338754 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  338754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  338757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338771 */     GIR_RootConstrainSelectedInstOperands,
     /*  338772 */     // GIR_Coverage, 20392,
     /*  338772 */     GIR_EraseRootFromParent_Done,
     /*  338773 */   // Label 6196: @338773
     /*  338773 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(338836), // Rule ID 20393 //
     /*  338778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  338781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  338789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  338792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  338795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338817 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  338817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  338820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338834 */     GIR_RootConstrainSelectedInstOperands,
     /*  338835 */     // GIR_Coverage, 20393,
     /*  338835 */     GIR_EraseRootFromParent_Done,
     /*  338836 */   // Label 6197: @338836
     /*  338836 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(338899), // Rule ID 20396 //
     /*  338841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  338844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  338852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  338855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  338858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338880 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  338880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  338883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338897 */     GIR_RootConstrainSelectedInstOperands,
     /*  338898 */     // GIR_Coverage, 20396,
     /*  338898 */     GIR_EraseRootFromParent_Done,
     /*  338899 */   // Label 6198: @338899
     /*  338899 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(338962), // Rule ID 20397 //
     /*  338904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  338907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  338915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  338918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  338921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338943 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  338943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  338946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338960 */     GIR_RootConstrainSelectedInstOperands,
     /*  338961 */     // GIR_Coverage, 20397,
     /*  338961 */     GIR_EraseRootFromParent_Done,
     /*  338962 */   // Label 6199: @338962
     /*  338962 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(339025), // Rule ID 20400 //
     /*  338967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  338970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  338978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  338981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  338984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339006 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  339006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  339009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339023 */     GIR_RootConstrainSelectedInstOperands,
     /*  339024 */     // GIR_Coverage, 20400,
     /*  339024 */     GIR_EraseRootFromParent_Done,
     /*  339025 */   // Label 6200: @339025
     /*  339025 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(339088), // Rule ID 20401 //
     /*  339030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  339033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  339041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  339044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  339047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339069 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  339069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  339072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339086 */     GIR_RootConstrainSelectedInstOperands,
     /*  339087 */     // GIR_Coverage, 20401,
     /*  339087 */     GIR_EraseRootFromParent_Done,
     /*  339088 */   // Label 6201: @339088
     /*  339088 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(339151), // Rule ID 20404 //
     /*  339093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  339096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  339104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  339107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  339110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339132 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  339132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  339135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339149 */     GIR_RootConstrainSelectedInstOperands,
     /*  339150 */     // GIR_Coverage, 20404,
     /*  339150 */     GIR_EraseRootFromParent_Done,
     /*  339151 */   // Label 6202: @339151
     /*  339151 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(339214), // Rule ID 20405 //
     /*  339156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  339159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  339167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  339170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  339173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339195 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  339195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  339198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339212 */     GIR_RootConstrainSelectedInstOperands,
     /*  339213 */     // GIR_Coverage, 20405,
     /*  339213 */     GIR_EraseRootFromParent_Done,
     /*  339214 */   // Label 6203: @339214
     /*  339214 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(339277), // Rule ID 20408 //
     /*  339219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  339222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  339230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  339233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  339236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339258 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  339258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  339261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339275 */     GIR_RootConstrainSelectedInstOperands,
     /*  339276 */     // GIR_Coverage, 20408,
     /*  339276 */     GIR_EraseRootFromParent_Done,
     /*  339277 */   // Label 6204: @339277
     /*  339277 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(339340), // Rule ID 20409 //
     /*  339282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  339285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  339293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  339296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  339299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339321 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  339321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  339324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339338 */     GIR_RootConstrainSelectedInstOperands,
     /*  339339 */     // GIR_Coverage, 20409,
     /*  339339 */     GIR_EraseRootFromParent_Done,
     /*  339340 */   // Label 6205: @339340
     /*  339340 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(339403), // Rule ID 20412 //
     /*  339345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  339348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  339356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339384 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  339384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  339387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339401 */     GIR_RootConstrainSelectedInstOperands,
     /*  339402 */     // GIR_Coverage, 20412,
     /*  339402 */     GIR_EraseRootFromParent_Done,
     /*  339403 */   // Label 6206: @339403
     /*  339403 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(339466), // Rule ID 20413 //
     /*  339408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  339411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  339419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339447 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  339447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  339450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339464 */     GIR_RootConstrainSelectedInstOperands,
     /*  339465 */     // GIR_Coverage, 20413,
     /*  339465 */     GIR_EraseRootFromParent_Done,
     /*  339466 */   // Label 6207: @339466
     /*  339466 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(339529), // Rule ID 20416 //
     /*  339471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  339474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  339482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339510 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  339510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  339513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339527 */     GIR_RootConstrainSelectedInstOperands,
     /*  339528 */     // GIR_Coverage, 20416,
     /*  339528 */     GIR_EraseRootFromParent_Done,
     /*  339529 */   // Label 6208: @339529
     /*  339529 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(339592), // Rule ID 20417 //
     /*  339534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  339537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  339545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339573 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  339573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  339576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339590 */     GIR_RootConstrainSelectedInstOperands,
     /*  339591 */     // GIR_Coverage, 20417,
     /*  339591 */     GIR_EraseRootFromParent_Done,
     /*  339592 */   // Label 6209: @339592
     /*  339592 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(339655), // Rule ID 20420 //
     /*  339597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  339600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  339608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  339611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  339614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339636 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  339636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  339639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339653 */     GIR_RootConstrainSelectedInstOperands,
     /*  339654 */     // GIR_Coverage, 20420,
     /*  339654 */     GIR_EraseRootFromParent_Done,
     /*  339655 */   // Label 6210: @339655
     /*  339655 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(339718), // Rule ID 20421 //
     /*  339660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  339663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  339671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  339674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  339677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339699 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  339699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  339702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339716 */     GIR_RootConstrainSelectedInstOperands,
     /*  339717 */     // GIR_Coverage, 20421,
     /*  339717 */     GIR_EraseRootFromParent_Done,
     /*  339718 */   // Label 6211: @339718
     /*  339718 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(339781), // Rule ID 20424 //
     /*  339723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  339726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  339731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  339734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  339737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  339740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339762 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  339762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  339765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339779 */     GIR_RootConstrainSelectedInstOperands,
     /*  339780 */     // GIR_Coverage, 20424,
     /*  339780 */     GIR_EraseRootFromParent_Done,
     /*  339781 */   // Label 6212: @339781
     /*  339781 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(339844), // Rule ID 20425 //
     /*  339786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  339789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  339794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  339797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  339800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  339803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339825 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  339825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  339828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339842 */     GIR_RootConstrainSelectedInstOperands,
     /*  339843 */     // GIR_Coverage, 20425,
     /*  339843 */     GIR_EraseRootFromParent_Done,
     /*  339844 */   // Label 6213: @339844
     /*  339844 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(339907), // Rule ID 20428 //
     /*  339849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  339852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  339857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  339860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  339863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  339866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339888 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  339888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  339891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339905 */     GIR_RootConstrainSelectedInstOperands,
     /*  339906 */     // GIR_Coverage, 20428,
     /*  339906 */     GIR_EraseRootFromParent_Done,
     /*  339907 */   // Label 6214: @339907
     /*  339907 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(339970), // Rule ID 20429 //
     /*  339912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  339915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  339920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  339923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  339926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  339929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339951 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  339951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  339954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339968 */     GIR_RootConstrainSelectedInstOperands,
     /*  339969 */     // GIR_Coverage, 20429,
     /*  339969 */     GIR_EraseRootFromParent_Done,
     /*  339970 */   // Label 6215: @339970
     /*  339970 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(340033), // Rule ID 20432 //
     /*  339975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  339978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  339983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  339986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  339989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  339992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  340014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  340017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340031 */     GIR_RootConstrainSelectedInstOperands,
     /*  340032 */     // GIR_Coverage, 20432,
     /*  340032 */     GIR_EraseRootFromParent_Done,
     /*  340033 */   // Label 6216: @340033
     /*  340033 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(340096), // Rule ID 20433 //
     /*  340038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  340041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  340049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  340052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  340055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340077 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  340077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  340080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340094 */     GIR_RootConstrainSelectedInstOperands,
     /*  340095 */     // GIR_Coverage, 20433,
     /*  340095 */     GIR_EraseRootFromParent_Done,
     /*  340096 */   // Label 6217: @340096
     /*  340096 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(340159), // Rule ID 20436 //
     /*  340101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  340104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  340112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  340140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  340143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340157 */     GIR_RootConstrainSelectedInstOperands,
     /*  340158 */     // GIR_Coverage, 20436,
     /*  340158 */     GIR_EraseRootFromParent_Done,
     /*  340159 */   // Label 6218: @340159
     /*  340159 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(340222), // Rule ID 20437 //
     /*  340164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  340167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  340175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340203 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  340203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  340206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340220 */     GIR_RootConstrainSelectedInstOperands,
     /*  340221 */     // GIR_Coverage, 20437,
     /*  340221 */     GIR_EraseRootFromParent_Done,
     /*  340222 */   // Label 6219: @340222
     /*  340222 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(340285), // Rule ID 20440 //
     /*  340227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  340230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  340238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  340241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  340244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340266 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  340266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  340269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340283 */     GIR_RootConstrainSelectedInstOperands,
     /*  340284 */     // GIR_Coverage, 20440,
     /*  340284 */     GIR_EraseRootFromParent_Done,
     /*  340285 */   // Label 6220: @340285
     /*  340285 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(340348), // Rule ID 20441 //
     /*  340290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  340293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  340301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  340304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  340307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340329 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  340329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  340332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340346 */     GIR_RootConstrainSelectedInstOperands,
     /*  340347 */     // GIR_Coverage, 20441,
     /*  340347 */     GIR_EraseRootFromParent_Done,
     /*  340348 */   // Label 6221: @340348
     /*  340348 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(340411), // Rule ID 20444 //
     /*  340353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  340356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  340364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  340367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  340370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  340392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  340395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340409 */     GIR_RootConstrainSelectedInstOperands,
     /*  340410 */     // GIR_Coverage, 20444,
     /*  340410 */     GIR_EraseRootFromParent_Done,
     /*  340411 */   // Label 6222: @340411
     /*  340411 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(340474), // Rule ID 20445 //
     /*  340416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  340419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  340427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  340430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  340433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340455 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  340455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  340458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340472 */     GIR_RootConstrainSelectedInstOperands,
     /*  340473 */     // GIR_Coverage, 20445,
     /*  340473 */     GIR_EraseRootFromParent_Done,
     /*  340474 */   // Label 6223: @340474
     /*  340474 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(340537), // Rule ID 20448 //
     /*  340479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  340482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  340490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  340493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  340496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340518 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  340518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  340521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340535 */     GIR_RootConstrainSelectedInstOperands,
     /*  340536 */     // GIR_Coverage, 20448,
     /*  340536 */     GIR_EraseRootFromParent_Done,
     /*  340537 */   // Label 6224: @340537
     /*  340537 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(340600), // Rule ID 20449 //
     /*  340542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  340545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  340553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  340556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  340559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340581 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  340581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  340584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340598 */     GIR_RootConstrainSelectedInstOperands,
     /*  340599 */     // GIR_Coverage, 20449,
     /*  340599 */     GIR_EraseRootFromParent_Done,
     /*  340600 */   // Label 6225: @340600
     /*  340600 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(340663), // Rule ID 20452 //
     /*  340605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  340608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  340616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  340619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  340622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340644 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  340644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  340647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340661 */     GIR_RootConstrainSelectedInstOperands,
     /*  340662 */     // GIR_Coverage, 20452,
     /*  340662 */     GIR_EraseRootFromParent_Done,
     /*  340663 */   // Label 6226: @340663
     /*  340663 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(340726), // Rule ID 20453 //
     /*  340668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  340671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  340679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  340682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  340685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340707 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  340707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  340710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340724 */     GIR_RootConstrainSelectedInstOperands,
     /*  340725 */     // GIR_Coverage, 20453,
     /*  340725 */     GIR_EraseRootFromParent_Done,
     /*  340726 */   // Label 6227: @340726
     /*  340726 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(340789), // Rule ID 20456 //
     /*  340731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  340734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  340742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  340745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  340748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340770 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  340770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  340773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340787 */     GIR_RootConstrainSelectedInstOperands,
     /*  340788 */     // GIR_Coverage, 20456,
     /*  340788 */     GIR_EraseRootFromParent_Done,
     /*  340789 */   // Label 6228: @340789
     /*  340789 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(340852), // Rule ID 20457 //
     /*  340794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  340797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  340805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  340808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  340811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340833 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  340833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  340836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340850 */     GIR_RootConstrainSelectedInstOperands,
     /*  340851 */     // GIR_Coverage, 20457,
     /*  340851 */     GIR_EraseRootFromParent_Done,
     /*  340852 */   // Label 6229: @340852
     /*  340852 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(340915), // Rule ID 20460 //
     /*  340857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  340860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  340868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  340871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  340874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340896 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  340896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  340899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340913 */     GIR_RootConstrainSelectedInstOperands,
     /*  340914 */     // GIR_Coverage, 20460,
     /*  340914 */     GIR_EraseRootFromParent_Done,
     /*  340915 */   // Label 6230: @340915
     /*  340915 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(340978), // Rule ID 20461 //
     /*  340920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  340923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  340931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  340934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  340937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340959 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  340959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  340962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340976 */     GIR_RootConstrainSelectedInstOperands,
     /*  340977 */     // GIR_Coverage, 20461,
     /*  340977 */     GIR_EraseRootFromParent_Done,
     /*  340978 */   // Label 6231: @340978
     /*  340978 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(341041), // Rule ID 20464 //
     /*  340983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  340986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  340994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  340997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  341000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341022 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  341022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  341025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341039 */     GIR_RootConstrainSelectedInstOperands,
     /*  341040 */     // GIR_Coverage, 20464,
     /*  341040 */     GIR_EraseRootFromParent_Done,
     /*  341041 */   // Label 6232: @341041
     /*  341041 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(341104), // Rule ID 20465 //
     /*  341046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  341049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  341057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  341060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  341063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341085 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  341085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  341088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341102 */     GIR_RootConstrainSelectedInstOperands,
     /*  341103 */     // GIR_Coverage, 20465,
     /*  341103 */     GIR_EraseRootFromParent_Done,
     /*  341104 */   // Label 6233: @341104
     /*  341104 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(341167), // Rule ID 20468 //
     /*  341109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  341112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  341120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  341123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  341126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341148 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  341148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  341151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341165 */     GIR_RootConstrainSelectedInstOperands,
     /*  341166 */     // GIR_Coverage, 20468,
     /*  341166 */     GIR_EraseRootFromParent_Done,
     /*  341167 */   // Label 6234: @341167
     /*  341167 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(341230), // Rule ID 20469 //
     /*  341172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  341175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  341183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  341186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  341189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341211 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  341211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  341214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341228 */     GIR_RootConstrainSelectedInstOperands,
     /*  341229 */     // GIR_Coverage, 20469,
     /*  341229 */     GIR_EraseRootFromParent_Done,
     /*  341230 */   // Label 6235: @341230
     /*  341230 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(341293), // Rule ID 20472 //
     /*  341235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  341238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  341246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  341249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  341252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341274 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  341274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  341277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341291 */     GIR_RootConstrainSelectedInstOperands,
     /*  341292 */     // GIR_Coverage, 20472,
     /*  341292 */     GIR_EraseRootFromParent_Done,
     /*  341293 */   // Label 6236: @341293
     /*  341293 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(341356), // Rule ID 20473 //
     /*  341298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  341301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  341309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  341312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  341315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341337 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  341337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  341340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341354 */     GIR_RootConstrainSelectedInstOperands,
     /*  341355 */     // GIR_Coverage, 20473,
     /*  341355 */     GIR_EraseRootFromParent_Done,
     /*  341356 */   // Label 6237: @341356
     /*  341356 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(341419), // Rule ID 20476 //
     /*  341361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  341364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  341372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  341375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  341378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341400 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  341400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  341403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341417 */     GIR_RootConstrainSelectedInstOperands,
     /*  341418 */     // GIR_Coverage, 20476,
     /*  341418 */     GIR_EraseRootFromParent_Done,
     /*  341419 */   // Label 6238: @341419
     /*  341419 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(341482), // Rule ID 20477 //
     /*  341424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  341427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  341435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  341438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  341441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341463 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  341463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  341466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341480 */     GIR_RootConstrainSelectedInstOperands,
     /*  341481 */     // GIR_Coverage, 20477,
     /*  341481 */     GIR_EraseRootFromParent_Done,
     /*  341482 */   // Label 6239: @341482
     /*  341482 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(341545), // Rule ID 20480 //
     /*  341487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  341490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  341498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  341501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  341504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341526 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  341526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  341529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341543 */     GIR_RootConstrainSelectedInstOperands,
     /*  341544 */     // GIR_Coverage, 20480,
     /*  341544 */     GIR_EraseRootFromParent_Done,
     /*  341545 */   // Label 6240: @341545
     /*  341545 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(341608), // Rule ID 20481 //
     /*  341550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  341553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  341561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  341564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  341567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341589 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  341589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  341592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341606 */     GIR_RootConstrainSelectedInstOperands,
     /*  341607 */     // GIR_Coverage, 20481,
     /*  341607 */     GIR_EraseRootFromParent_Done,
     /*  341608 */   // Label 6241: @341608
     /*  341608 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(341674), // Rule ID 20484 //
     /*  341613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  341621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  341624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  341627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  341630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341652 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  341655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341672 */     GIR_RootConstrainSelectedInstOperands,
     /*  341673 */     // GIR_Coverage, 20484,
     /*  341673 */     GIR_EraseRootFromParent_Done,
     /*  341674 */   // Label 6242: @341674
     /*  341674 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(341740), // Rule ID 20485 //
     /*  341679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  341687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  341690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  341693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  341696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  341721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341738 */     GIR_RootConstrainSelectedInstOperands,
     /*  341739 */     // GIR_Coverage, 20485,
     /*  341739 */     GIR_EraseRootFromParent_Done,
     /*  341740 */   // Label 6243: @341740
     /*  341740 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(341806), // Rule ID 20488 //
     /*  341745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  341753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  341756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  341759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  341762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  341787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341804 */     GIR_RootConstrainSelectedInstOperands,
     /*  341805 */     // GIR_Coverage, 20488,
     /*  341805 */     GIR_EraseRootFromParent_Done,
     /*  341806 */   // Label 6244: @341806
     /*  341806 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(341872), // Rule ID 20489 //
     /*  341811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  341819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  341822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  341825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  341828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341850 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  341853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341870 */     GIR_RootConstrainSelectedInstOperands,
     /*  341871 */     // GIR_Coverage, 20489,
     /*  341871 */     GIR_EraseRootFromParent_Done,
     /*  341872 */   // Label 6245: @341872
     /*  341872 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(341938), // Rule ID 20492 //
     /*  341877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  341885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  341888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  341891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  341894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341916 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  341919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341936 */     GIR_RootConstrainSelectedInstOperands,
     /*  341937 */     // GIR_Coverage, 20492,
     /*  341937 */     GIR_EraseRootFromParent_Done,
     /*  341938 */   // Label 6246: @341938
     /*  341938 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(342004), // Rule ID 20493 //
     /*  341943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  341951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  341954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  341957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  341960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341982 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  341985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342002 */     GIR_RootConstrainSelectedInstOperands,
     /*  342003 */     // GIR_Coverage, 20493,
     /*  342003 */     GIR_EraseRootFromParent_Done,
     /*  342004 */   // Label 6247: @342004
     /*  342004 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(342070), // Rule ID 20496 //
     /*  342009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  342020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  342023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  342026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  342051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342068 */     GIR_RootConstrainSelectedInstOperands,
     /*  342069 */     // GIR_Coverage, 20496,
     /*  342069 */     GIR_EraseRootFromParent_Done,
     /*  342070 */   // Label 6248: @342070
     /*  342070 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(342136), // Rule ID 20497 //
     /*  342075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  342086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  342089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  342092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  342117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342134 */     GIR_RootConstrainSelectedInstOperands,
     /*  342135 */     // GIR_Coverage, 20497,
     /*  342135 */     GIR_EraseRootFromParent_Done,
     /*  342136 */   // Label 6249: @342136
     /*  342136 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(342202), // Rule ID 20500 //
     /*  342141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  342144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  342152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  342155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  342158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342180 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  342180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  342183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342200 */     GIR_RootConstrainSelectedInstOperands,
     /*  342201 */     // GIR_Coverage, 20500,
     /*  342201 */     GIR_EraseRootFromParent_Done,
     /*  342202 */   // Label 6250: @342202
     /*  342202 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(342268), // Rule ID 20501 //
     /*  342207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  342210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  342218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  342221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  342224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  342246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  342249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342266 */     GIR_RootConstrainSelectedInstOperands,
     /*  342267 */     // GIR_Coverage, 20501,
     /*  342267 */     GIR_EraseRootFromParent_Done,
     /*  342268 */   // Label 6251: @342268
     /*  342268 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(342334), // Rule ID 20504 //
     /*  342273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  342284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  342287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  342290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342312 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  342315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342332 */     GIR_RootConstrainSelectedInstOperands,
     /*  342333 */     // GIR_Coverage, 20504,
     /*  342333 */     GIR_EraseRootFromParent_Done,
     /*  342334 */   // Label 6252: @342334
     /*  342334 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(342400), // Rule ID 20505 //
     /*  342339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  342350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  342353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  342356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342378 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  342381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342398 */     GIR_RootConstrainSelectedInstOperands,
     /*  342399 */     // GIR_Coverage, 20505,
     /*  342399 */     GIR_EraseRootFromParent_Done,
     /*  342400 */   // Label 6253: @342400
     /*  342400 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(342466), // Rule ID 20508 //
     /*  342405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  342416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  342419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  342422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342444 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  342447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342464 */     GIR_RootConstrainSelectedInstOperands,
     /*  342465 */     // GIR_Coverage, 20508,
     /*  342465 */     GIR_EraseRootFromParent_Done,
     /*  342466 */   // Label 6254: @342466
     /*  342466 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(342532), // Rule ID 20509 //
     /*  342471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  342482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  342485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  342488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342510 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  342513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342530 */     GIR_RootConstrainSelectedInstOperands,
     /*  342531 */     // GIR_Coverage, 20509,
     /*  342531 */     GIR_EraseRootFromParent_Done,
     /*  342532 */   // Label 6255: @342532
     /*  342532 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(342598), // Rule ID 20512 //
     /*  342537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  342548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  342551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  342554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342576 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  342579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342596 */     GIR_RootConstrainSelectedInstOperands,
     /*  342597 */     // GIR_Coverage, 20512,
     /*  342597 */     GIR_EraseRootFromParent_Done,
     /*  342598 */   // Label 6256: @342598
     /*  342598 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(342664), // Rule ID 20513 //
     /*  342603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  342614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  342617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  342620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342642 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  342645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342662 */     GIR_RootConstrainSelectedInstOperands,
     /*  342663 */     // GIR_Coverage, 20513,
     /*  342663 */     GIR_EraseRootFromParent_Done,
     /*  342664 */   // Label 6257: @342664
     /*  342664 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(342730), // Rule ID 20516 //
     /*  342669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  342680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  342683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  342686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  342711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342728 */     GIR_RootConstrainSelectedInstOperands,
     /*  342729 */     // GIR_Coverage, 20516,
     /*  342729 */     GIR_EraseRootFromParent_Done,
     /*  342730 */   // Label 6258: @342730
     /*  342730 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(342796), // Rule ID 20517 //
     /*  342735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  342746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  342749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  342752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342774 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  342777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342794 */     GIR_RootConstrainSelectedInstOperands,
     /*  342795 */     // GIR_Coverage, 20517,
     /*  342795 */     GIR_EraseRootFromParent_Done,
     /*  342796 */   // Label 6259: @342796
     /*  342796 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(342862), // Rule ID 20520 //
     /*  342801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  342812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  342815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  342818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  342843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342860 */     GIR_RootConstrainSelectedInstOperands,
     /*  342861 */     // GIR_Coverage, 20520,
     /*  342861 */     GIR_EraseRootFromParent_Done,
     /*  342862 */   // Label 6260: @342862
     /*  342862 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(342928), // Rule ID 20521 //
     /*  342867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  342878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  342881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  342884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342906 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  342909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342926 */     GIR_RootConstrainSelectedInstOperands,
     /*  342927 */     // GIR_Coverage, 20521,
     /*  342927 */     GIR_EraseRootFromParent_Done,
     /*  342928 */   // Label 6261: @342928
     /*  342928 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(342994), // Rule ID 20524 //
     /*  342933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  342944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  342947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  342950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342972 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  342975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342992 */     GIR_RootConstrainSelectedInstOperands,
     /*  342993 */     // GIR_Coverage, 20524,
     /*  342993 */     GIR_EraseRootFromParent_Done,
     /*  342994 */   // Label 6262: @342994
     /*  342994 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(343060), // Rule ID 20525 //
     /*  342999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  343002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  343010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  343013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  343016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  343041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343058 */     GIR_RootConstrainSelectedInstOperands,
     /*  343059 */     // GIR_Coverage, 20525,
     /*  343059 */     GIR_EraseRootFromParent_Done,
     /*  343060 */   // Label 6263: @343060
     /*  343060 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(343126), // Rule ID 20528 //
     /*  343065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  343082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  343107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343124 */     GIR_RootConstrainSelectedInstOperands,
     /*  343125 */     // GIR_Coverage, 20528,
     /*  343125 */     GIR_EraseRootFromParent_Done,
     /*  343126 */   // Label 6264: @343126
     /*  343126 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(343192), // Rule ID 20529 //
     /*  343131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  343148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  343173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343190 */     GIR_RootConstrainSelectedInstOperands,
     /*  343191 */     // GIR_Coverage, 20529,
     /*  343191 */     GIR_EraseRootFromParent_Done,
     /*  343192 */   // Label 6265: @343192
     /*  343192 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(343258), // Rule ID 20532 //
     /*  343197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343236 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  343239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343256 */     GIR_RootConstrainSelectedInstOperands,
     /*  343257 */     // GIR_Coverage, 20532,
     /*  343257 */     GIR_EraseRootFromParent_Done,
     /*  343258 */   // Label 6266: @343258
     /*  343258 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(343324), // Rule ID 20533 //
     /*  343263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343302 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  343305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343322 */     GIR_RootConstrainSelectedInstOperands,
     /*  343323 */     // GIR_Coverage, 20533,
     /*  343323 */     GIR_EraseRootFromParent_Done,
     /*  343324 */   // Label 6267: @343324
     /*  343324 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(343390), // Rule ID 20536 //
     /*  343329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  343371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343388 */     GIR_RootConstrainSelectedInstOperands,
     /*  343389 */     // GIR_Coverage, 20536,
     /*  343389 */     GIR_EraseRootFromParent_Done,
     /*  343390 */   // Label 6268: @343390
     /*  343390 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(343456), // Rule ID 20537 //
     /*  343395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  343437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343454 */     GIR_RootConstrainSelectedInstOperands,
     /*  343455 */     // GIR_Coverage, 20537,
     /*  343455 */     GIR_EraseRootFromParent_Done,
     /*  343456 */   // Label 6269: @343456
     /*  343456 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(343522), // Rule ID 20862 //
     /*  343461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  343472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  343475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  343478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343500 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  343503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343520 */     GIR_RootConstrainSelectedInstOperands,
     /*  343521 */     // GIR_Coverage, 20862,
     /*  343521 */     GIR_EraseRootFromParent_Done,
     /*  343522 */   // Label 6270: @343522
     /*  343522 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(343588), // Rule ID 20863 //
     /*  343527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  343538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  343541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  343544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343566 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  343569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343586 */     GIR_RootConstrainSelectedInstOperands,
     /*  343587 */     // GIR_Coverage, 20863,
     /*  343587 */     GIR_EraseRootFromParent_Done,
     /*  343588 */   // Label 6271: @343588
     /*  343588 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(343654), // Rule ID 20866 //
     /*  343593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  343604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  343607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  343610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343632 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  343635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343652 */     GIR_RootConstrainSelectedInstOperands,
     /*  343653 */     // GIR_Coverage, 20866,
     /*  343653 */     GIR_EraseRootFromParent_Done,
     /*  343654 */   // Label 6272: @343654
     /*  343654 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(343720), // Rule ID 20867 //
     /*  343659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  343670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  343673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  343676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343698 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  343701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343718 */     GIR_RootConstrainSelectedInstOperands,
     /*  343719 */     // GIR_Coverage, 20867,
     /*  343719 */     GIR_EraseRootFromParent_Done,
     /*  343720 */   // Label 6273: @343720
     /*  343720 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(343786), // Rule ID 20870 //
     /*  343725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  343728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  343736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  343739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  343742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343764 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  343764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  343767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343784 */     GIR_RootConstrainSelectedInstOperands,
     /*  343785 */     // GIR_Coverage, 20870,
     /*  343785 */     GIR_EraseRootFromParent_Done,
     /*  343786 */   // Label 6274: @343786
     /*  343786 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(343852), // Rule ID 20871 //
     /*  343791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  343794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  343802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  343805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  343808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343830 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  343833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343850 */     GIR_RootConstrainSelectedInstOperands,
     /*  343851 */     // GIR_Coverage, 20871,
     /*  343851 */     GIR_EraseRootFromParent_Done,
     /*  343852 */   // Label 6275: @343852
     /*  343852 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(343918), // Rule ID 20874 //
     /*  343857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  343868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  343871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  343874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343896 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  343899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343916 */     GIR_RootConstrainSelectedInstOperands,
     /*  343917 */     // GIR_Coverage, 20874,
     /*  343917 */     GIR_EraseRootFromParent_Done,
     /*  343918 */   // Label 6276: @343918
     /*  343918 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(343984), // Rule ID 20875 //
     /*  343923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  343934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  343937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  343940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343962 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  343965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343982 */     GIR_RootConstrainSelectedInstOperands,
     /*  343983 */     // GIR_Coverage, 20875,
     /*  343983 */     GIR_EraseRootFromParent_Done,
     /*  343984 */   // Label 6277: @343984
     /*  343984 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(344050), // Rule ID 20878 //
     /*  343989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  343992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344028 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  344031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344048 */     GIR_RootConstrainSelectedInstOperands,
     /*  344049 */     // GIR_Coverage, 20878,
     /*  344049 */     GIR_EraseRootFromParent_Done,
     /*  344050 */   // Label 6278: @344050
     /*  344050 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(344116), // Rule ID 20879 //
     /*  344055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  344058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344094 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  344097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344114 */     GIR_RootConstrainSelectedInstOperands,
     /*  344115 */     // GIR_Coverage, 20879,
     /*  344115 */     GIR_EraseRootFromParent_Done,
     /*  344116 */   // Label 6279: @344116
     /*  344116 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(344182), // Rule ID 20882 //
     /*  344121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  344124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  344138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344160 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  344160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  344163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  344177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344180 */     GIR_RootConstrainSelectedInstOperands,
     /*  344181 */     // GIR_Coverage, 20882,
     /*  344181 */     GIR_EraseRootFromParent_Done,
     /*  344182 */   // Label 6280: @344182
     /*  344182 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(344248), // Rule ID 20883 //
     /*  344187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  344190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  344204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344226 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  344226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  344229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  344243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344246 */     GIR_RootConstrainSelectedInstOperands,
     /*  344247 */     // GIR_Coverage, 20883,
     /*  344247 */     GIR_EraseRootFromParent_Done,
     /*  344248 */   // Label 6281: @344248
     /*  344248 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(344314), // Rule ID 20886 //
     /*  344253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  344264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  344267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  344270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  344295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344312 */     GIR_RootConstrainSelectedInstOperands,
     /*  344313 */     // GIR_Coverage, 20886,
     /*  344313 */     GIR_EraseRootFromParent_Done,
     /*  344314 */   // Label 6282: @344314
     /*  344314 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(344380), // Rule ID 20887 //
     /*  344319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  344330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  344333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  344336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344358 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  344361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344378 */     GIR_RootConstrainSelectedInstOperands,
     /*  344379 */     // GIR_Coverage, 20887,
     /*  344379 */     GIR_EraseRootFromParent_Done,
     /*  344380 */   // Label 6283: @344380
     /*  344380 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(344446), // Rule ID 20890 //
     /*  344385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  344396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  344399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344424 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  344427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344444 */     GIR_RootConstrainSelectedInstOperands,
     /*  344445 */     // GIR_Coverage, 20890,
     /*  344445 */     GIR_EraseRootFromParent_Done,
     /*  344446 */   // Label 6284: @344446
     /*  344446 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(344512), // Rule ID 20891 //
     /*  344451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  344462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  344465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344490 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  344493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344510 */     GIR_RootConstrainSelectedInstOperands,
     /*  344511 */     // GIR_Coverage, 20891,
     /*  344511 */     GIR_EraseRootFromParent_Done,
     /*  344512 */   // Label 6285: @344512
     /*  344512 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(344578), // Rule ID 20894 //
     /*  344517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  344528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  344531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  344534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344556 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  344559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344576 */     GIR_RootConstrainSelectedInstOperands,
     /*  344577 */     // GIR_Coverage, 20894,
     /*  344577 */     GIR_EraseRootFromParent_Done,
     /*  344578 */   // Label 6286: @344578
     /*  344578 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(344644), // Rule ID 20895 //
     /*  344583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  344594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  344597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  344600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344622 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  344625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344642 */     GIR_RootConstrainSelectedInstOperands,
     /*  344643 */     // GIR_Coverage, 20895,
     /*  344643 */     GIR_EraseRootFromParent_Done,
     /*  344644 */   // Label 6287: @344644
     /*  344644 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(344710), // Rule ID 20898 //
     /*  344649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  344652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  344660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  344663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  344666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  344691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344708 */     GIR_RootConstrainSelectedInstOperands,
     /*  344709 */     // GIR_Coverage, 20898,
     /*  344709 */     GIR_EraseRootFromParent_Done,
     /*  344710 */   // Label 6288: @344710
     /*  344710 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(344776), // Rule ID 20899 //
     /*  344715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  344718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  344726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  344729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  344732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  344757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344774 */     GIR_RootConstrainSelectedInstOperands,
     /*  344775 */     // GIR_Coverage, 20899,
     /*  344775 */     GIR_EraseRootFromParent_Done,
     /*  344776 */   // Label 6289: @344776
     /*  344776 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(344842), // Rule ID 20902 //
     /*  344781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  344784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  344792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  344795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  344798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344820 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  344823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344840 */     GIR_RootConstrainSelectedInstOperands,
     /*  344841 */     // GIR_Coverage, 20902,
     /*  344841 */     GIR_EraseRootFromParent_Done,
     /*  344842 */   // Label 6290: @344842
     /*  344842 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(344908), // Rule ID 20903 //
     /*  344847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  344850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  344858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  344861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  344864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344886 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  344889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344906 */     GIR_RootConstrainSelectedInstOperands,
     /*  344907 */     // GIR_Coverage, 20903,
     /*  344907 */     GIR_EraseRootFromParent_Done,
     /*  344908 */   // Label 6291: @344908
     /*  344908 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(344974), // Rule ID 20906 //
     /*  344913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  344916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  344930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  344955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344972 */     GIR_RootConstrainSelectedInstOperands,
     /*  344973 */     // GIR_Coverage, 20906,
     /*  344973 */     GIR_EraseRootFromParent_Done,
     /*  344974 */   // Label 6292: @344974
     /*  344974 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(345040), // Rule ID 20907 //
     /*  344979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  344982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  344996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  345021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345038 */     GIR_RootConstrainSelectedInstOperands,
     /*  345039 */     // GIR_Coverage, 20907,
     /*  345039 */     GIR_EraseRootFromParent_Done,
     /*  345040 */   // Label 6293: @345040
     /*  345040 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(345106), // Rule ID 20910 //
     /*  345045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  345048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  345053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  345056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  345059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  345062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  345084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  345087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  345101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345104 */     GIR_RootConstrainSelectedInstOperands,
     /*  345105 */     // GIR_Coverage, 20910,
     /*  345105 */     GIR_EraseRootFromParent_Done,
     /*  345106 */   // Label 6294: @345106
     /*  345106 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(345172), // Rule ID 20911 //
     /*  345111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  345114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  345119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  345122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  345125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  345128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345150 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  345150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  345153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  345167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345170 */     GIR_RootConstrainSelectedInstOperands,
     /*  345171 */     // GIR_Coverage, 20911,
     /*  345171 */     GIR_EraseRootFromParent_Done,
     /*  345172 */   // Label 6295: @345172
     /*  345172 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(345238), // Rule ID 20914 //
     /*  345177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  345180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  345185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  345188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  345191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  345194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345216 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  345216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  345219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  345233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345236 */     GIR_RootConstrainSelectedInstOperands,
     /*  345237 */     // GIR_Coverage, 20914,
     /*  345237 */     GIR_EraseRootFromParent_Done,
     /*  345238 */   // Label 6296: @345238
     /*  345238 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(345304), // Rule ID 20915 //
     /*  345243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  345246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  345251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  345254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  345257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  345260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345282 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  345282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  345285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  345299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345302 */     GIR_RootConstrainSelectedInstOperands,
     /*  345303 */     // GIR_Coverage, 20915,
     /*  345303 */     GIR_EraseRootFromParent_Done,
     /*  345304 */   // Label 6297: @345304
     /*  345304 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(345370), // Rule ID 20918 //
     /*  345309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  345312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  345317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  345326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345348 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  345348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  345351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  345365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345368 */     GIR_RootConstrainSelectedInstOperands,
     /*  345369 */     // GIR_Coverage, 20918,
     /*  345369 */     GIR_EraseRootFromParent_Done,
     /*  345370 */   // Label 6298: @345370
     /*  345370 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(345436), // Rule ID 20919 //
     /*  345375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  345378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  345383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  345392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345414 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  345414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  345417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  345431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345434 */     GIR_RootConstrainSelectedInstOperands,
     /*  345435 */     // GIR_Coverage, 20919,
     /*  345435 */     GIR_EraseRootFromParent_Done,
     /*  345436 */   // Label 6299: @345436
     /*  345436 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(345502), // Rule ID 20922 //
     /*  345441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  345452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  345455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  345458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345480 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  345483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345500 */     GIR_RootConstrainSelectedInstOperands,
     /*  345501 */     // GIR_Coverage, 20922,
     /*  345501 */     GIR_EraseRootFromParent_Done,
     /*  345502 */   // Label 6300: @345502
     /*  345502 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(345568), // Rule ID 20923 //
     /*  345507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  345518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  345521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  345524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  345549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345566 */     GIR_RootConstrainSelectedInstOperands,
     /*  345567 */     // GIR_Coverage, 20923,
     /*  345567 */     GIR_EraseRootFromParent_Done,
     /*  345568 */   // Label 6301: @345568
     /*  345568 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(345634), // Rule ID 20926 //
     /*  345573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  345584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  345587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  345590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345612 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  345615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345632 */     GIR_RootConstrainSelectedInstOperands,
     /*  345633 */     // GIR_Coverage, 20926,
     /*  345633 */     GIR_EraseRootFromParent_Done,
     /*  345634 */   // Label 6302: @345634
     /*  345634 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(345700), // Rule ID 20927 //
     /*  345639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  345650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  345653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  345656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345678 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  345681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345698 */     GIR_RootConstrainSelectedInstOperands,
     /*  345699 */     // GIR_Coverage, 20927,
     /*  345699 */     GIR_EraseRootFromParent_Done,
     /*  345700 */   // Label 6303: @345700
     /*  345700 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(345766), // Rule ID 20930 //
     /*  345705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  345708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  345716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  345719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  345722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345744 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  345747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345764 */     GIR_RootConstrainSelectedInstOperands,
     /*  345765 */     // GIR_Coverage, 20930,
     /*  345765 */     GIR_EraseRootFromParent_Done,
     /*  345766 */   // Label 6304: @345766
     /*  345766 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(345832), // Rule ID 20931 //
     /*  345771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  345774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  345782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  345785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  345788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345810 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  345813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345830 */     GIR_RootConstrainSelectedInstOperands,
     /*  345831 */     // GIR_Coverage, 20931,
     /*  345831 */     GIR_EraseRootFromParent_Done,
     /*  345832 */   // Label 6305: @345832
     /*  345832 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(345898), // Rule ID 20934 //
     /*  345837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  345848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  345851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  345854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  345879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345896 */     GIR_RootConstrainSelectedInstOperands,
     /*  345897 */     // GIR_Coverage, 20934,
     /*  345897 */     GIR_EraseRootFromParent_Done,
     /*  345898 */   // Label 6306: @345898
     /*  345898 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(345964), // Rule ID 20935 //
     /*  345903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  345914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  345917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  345920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345942 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  345945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345962 */     GIR_RootConstrainSelectedInstOperands,
     /*  345963 */     // GIR_Coverage, 20935,
     /*  345963 */     GIR_EraseRootFromParent_Done,
     /*  345964 */   // Label 6307: @345964
     /*  345964 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(346030), // Rule ID 20938 //
     /*  345969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  345972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  345980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  345983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  345986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  346011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346028 */     GIR_RootConstrainSelectedInstOperands,
     /*  346029 */     // GIR_Coverage, 20938,
     /*  346029 */     GIR_EraseRootFromParent_Done,
     /*  346030 */   // Label 6308: @346030
     /*  346030 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(346096), // Rule ID 20939 //
     /*  346035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  346046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  346049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  346052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  346077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346094 */     GIR_RootConstrainSelectedInstOperands,
     /*  346095 */     // GIR_Coverage, 20939,
     /*  346095 */     GIR_EraseRootFromParent_Done,
     /*  346096 */   // Label 6309: @346096
     /*  346096 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(346162), // Rule ID 20942 //
     /*  346101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  346104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  346112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  346115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  346118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  346140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  346143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  346157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346160 */     GIR_RootConstrainSelectedInstOperands,
     /*  346161 */     // GIR_Coverage, 20942,
     /*  346161 */     GIR_EraseRootFromParent_Done,
     /*  346162 */   // Label 6310: @346162
     /*  346162 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(346228), // Rule ID 20943 //
     /*  346167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  346170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  346178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  346181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  346184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346206 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  346206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  346209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  346223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346226 */     GIR_RootConstrainSelectedInstOperands,
     /*  346227 */     // GIR_Coverage, 20943,
     /*  346227 */     GIR_EraseRootFromParent_Done,
     /*  346228 */   // Label 6311: @346228
     /*  346228 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(346294), // Rule ID 20946 //
     /*  346233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  346244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  346247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  346250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346272 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  346275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346292 */     GIR_RootConstrainSelectedInstOperands,
     /*  346293 */     // GIR_Coverage, 20946,
     /*  346293 */     GIR_EraseRootFromParent_Done,
     /*  346294 */   // Label 6312: @346294
     /*  346294 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(346360), // Rule ID 20947 //
     /*  346299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  346310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  346313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  346316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346338 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  346341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346358 */     GIR_RootConstrainSelectedInstOperands,
     /*  346359 */     // GIR_Coverage, 20947,
     /*  346359 */     GIR_EraseRootFromParent_Done,
     /*  346360 */   // Label 6313: @346360
     /*  346360 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(346426), // Rule ID 20950 //
     /*  346365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  346376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  346379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  346382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  346407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346424 */     GIR_RootConstrainSelectedInstOperands,
     /*  346425 */     // GIR_Coverage, 20950,
     /*  346425 */     GIR_EraseRootFromParent_Done,
     /*  346426 */   // Label 6314: @346426
     /*  346426 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(346492), // Rule ID 20951 //
     /*  346431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  346442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  346445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  346448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346470 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  346473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346490 */     GIR_RootConstrainSelectedInstOperands,
     /*  346491 */     // GIR_Coverage, 20951,
     /*  346491 */     GIR_EraseRootFromParent_Done,
     /*  346492 */   // Label 6315: @346492
     /*  346492 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(346558), // Rule ID 20954 //
     /*  346497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  346508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  346511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  346514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346536 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  346539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346556 */     GIR_RootConstrainSelectedInstOperands,
     /*  346557 */     // GIR_Coverage, 20954,
     /*  346557 */     GIR_EraseRootFromParent_Done,
     /*  346558 */   // Label 6316: @346558
     /*  346558 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(346624), // Rule ID 20955 //
     /*  346563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  346574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  346577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  346580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346602 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  346605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346622 */     GIR_RootConstrainSelectedInstOperands,
     /*  346623 */     // GIR_Coverage, 20955,
     /*  346623 */     GIR_EraseRootFromParent_Done,
     /*  346624 */   // Label 6317: @346624
     /*  346624 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(346690), // Rule ID 20958 //
     /*  346629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  346640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  346643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  346646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  346671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346688 */     GIR_RootConstrainSelectedInstOperands,
     /*  346689 */     // GIR_Coverage, 20958,
     /*  346689 */     GIR_EraseRootFromParent_Done,
     /*  346690 */   // Label 6318: @346690
     /*  346690 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(346756), // Rule ID 20959 //
     /*  346695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  346706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  346709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  346712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  346737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346754 */     GIR_RootConstrainSelectedInstOperands,
     /*  346755 */     // GIR_Coverage, 20959,
     /*  346755 */     GIR_EraseRootFromParent_Done,
     /*  346756 */   // Label 6319: @346756
     /*  346756 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(346822), // Rule ID 20962 //
     /*  346761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  346772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  346775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  346778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346800 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  346803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346820 */     GIR_RootConstrainSelectedInstOperands,
     /*  346821 */     // GIR_Coverage, 20962,
     /*  346821 */     GIR_EraseRootFromParent_Done,
     /*  346822 */   // Label 6320: @346822
     /*  346822 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(346888), // Rule ID 20963 //
     /*  346827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  346838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  346841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  346844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  346869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346886 */     GIR_RootConstrainSelectedInstOperands,
     /*  346887 */     // GIR_Coverage, 20963,
     /*  346887 */     GIR_EraseRootFromParent_Done,
     /*  346888 */   // Label 6321: @346888
     /*  346888 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(346954), // Rule ID 20966 //
     /*  346893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  346904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  346907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  346910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346932 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  346935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346952 */     GIR_RootConstrainSelectedInstOperands,
     /*  346953 */     // GIR_Coverage, 20966,
     /*  346953 */     GIR_EraseRootFromParent_Done,
     /*  346954 */   // Label 6322: @346954
     /*  346954 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(347020), // Rule ID 20967 //
     /*  346959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  346970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  346973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  346976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346998 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  347001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347018 */     GIR_RootConstrainSelectedInstOperands,
     /*  347019 */     // GIR_Coverage, 20967,
     /*  347019 */     GIR_EraseRootFromParent_Done,
     /*  347020 */   // Label 6323: @347020
     /*  347020 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(347086), // Rule ID 20970 //
     /*  347025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  347028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  347033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  347036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  347039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  347042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347064 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  347064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  347067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347084 */     GIR_RootConstrainSelectedInstOperands,
     /*  347085 */     // GIR_Coverage, 20970,
     /*  347085 */     GIR_EraseRootFromParent_Done,
     /*  347086 */   // Label 6324: @347086
     /*  347086 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(347152), // Rule ID 20971 //
     /*  347091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  347094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  347099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  347102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  347105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  347108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  347130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  347133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347150 */     GIR_RootConstrainSelectedInstOperands,
     /*  347151 */     // GIR_Coverage, 20971,
     /*  347151 */     GIR_EraseRootFromParent_Done,
     /*  347152 */   // Label 6325: @347152
     /*  347152 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(347218), // Rule ID 20974 //
     /*  347157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  347160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  347165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  347168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  347171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  347174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  347196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  347199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347216 */     GIR_RootConstrainSelectedInstOperands,
     /*  347217 */     // GIR_Coverage, 20974,
     /*  347217 */     GIR_EraseRootFromParent_Done,
     /*  347218 */   // Label 6326: @347218
     /*  347218 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(347284), // Rule ID 20975 //
     /*  347223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  347226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  347231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  347234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  347237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  347240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347262 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  347262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  347265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347282 */     GIR_RootConstrainSelectedInstOperands,
     /*  347283 */     // GIR_Coverage, 20975,
     /*  347283 */     GIR_EraseRootFromParent_Done,
     /*  347284 */   // Label 6327: @347284
     /*  347284 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(347350), // Rule ID 20978 //
     /*  347289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  347292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  347297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  347300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  347303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  347306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347328 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  347328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  347331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347348 */     GIR_RootConstrainSelectedInstOperands,
     /*  347349 */     // GIR_Coverage, 20978,
     /*  347349 */     GIR_EraseRootFromParent_Done,
     /*  347350 */   // Label 6328: @347350
     /*  347350 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(347416), // Rule ID 20979 //
     /*  347355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  347358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  347363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  347366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  347369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  347372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347394 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  347394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  347397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347414 */     GIR_RootConstrainSelectedInstOperands,
     /*  347415 */     // GIR_Coverage, 20979,
     /*  347415 */     GIR_EraseRootFromParent_Done,
     /*  347416 */   // Label 6329: @347416
     /*  347416 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(347482), // Rule ID 21246 //
     /*  347421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  347432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  347435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  347438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347460 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  347463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347480 */     GIR_RootConstrainSelectedInstOperands,
     /*  347481 */     // GIR_Coverage, 21246,
     /*  347481 */     GIR_EraseRootFromParent_Done,
     /*  347482 */   // Label 6330: @347482
     /*  347482 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(347548), // Rule ID 21247 //
     /*  347487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  347498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  347501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  347504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347526 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  347529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347546 */     GIR_RootConstrainSelectedInstOperands,
     /*  347547 */     // GIR_Coverage, 21247,
     /*  347547 */     GIR_EraseRootFromParent_Done,
     /*  347548 */   // Label 6331: @347548
     /*  347548 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(347614), // Rule ID 21250 //
     /*  347553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  347564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  347567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  347570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347592 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  347595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347612 */     GIR_RootConstrainSelectedInstOperands,
     /*  347613 */     // GIR_Coverage, 21250,
     /*  347613 */     GIR_EraseRootFromParent_Done,
     /*  347614 */   // Label 6332: @347614
     /*  347614 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(347680), // Rule ID 21251 //
     /*  347619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  347630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  347633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  347636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  347661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347678 */     GIR_RootConstrainSelectedInstOperands,
     /*  347679 */     // GIR_Coverage, 21251,
     /*  347679 */     GIR_EraseRootFromParent_Done,
     /*  347680 */   // Label 6333: @347680
     /*  347680 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(347746), // Rule ID 21254 //
     /*  347685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  347696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  347699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  347702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  347727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347744 */     GIR_RootConstrainSelectedInstOperands,
     /*  347745 */     // GIR_Coverage, 21254,
     /*  347745 */     GIR_EraseRootFromParent_Done,
     /*  347746 */   // Label 6334: @347746
     /*  347746 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(347812), // Rule ID 21255 //
     /*  347751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  347762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  347765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  347768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  347793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347810 */     GIR_RootConstrainSelectedInstOperands,
     /*  347811 */     // GIR_Coverage, 21255,
     /*  347811 */     GIR_EraseRootFromParent_Done,
     /*  347812 */   // Label 6335: @347812
     /*  347812 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(347878), // Rule ID 21258 //
     /*  347817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  347828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  347831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  347834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347856 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  347859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347876 */     GIR_RootConstrainSelectedInstOperands,
     /*  347877 */     // GIR_Coverage, 21258,
     /*  347877 */     GIR_EraseRootFromParent_Done,
     /*  347878 */   // Label 6336: @347878
     /*  347878 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(347944), // Rule ID 21259 //
     /*  347883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  347894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  347897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  347900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347922 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  347925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347942 */     GIR_RootConstrainSelectedInstOperands,
     /*  347943 */     // GIR_Coverage, 21259,
     /*  347943 */     GIR_EraseRootFromParent_Done,
     /*  347944 */   // Label 6337: @347944
     /*  347944 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(348010), // Rule ID 21262 //
     /*  347949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  347960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  347963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  347966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347988 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  347991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348008 */     GIR_RootConstrainSelectedInstOperands,
     /*  348009 */     // GIR_Coverage, 21262,
     /*  348009 */     GIR_EraseRootFromParent_Done,
     /*  348010 */   // Label 6338: @348010
     /*  348010 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(348076), // Rule ID 21263 //
     /*  348015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  348026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  348029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  348032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  348057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348074 */     GIR_RootConstrainSelectedInstOperands,
     /*  348075 */     // GIR_Coverage, 21263,
     /*  348075 */     GIR_EraseRootFromParent_Done,
     /*  348076 */   // Label 6339: @348076
     /*  348076 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(348142), // Rule ID 21266 //
     /*  348081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  348084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  348092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  348095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  348098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  348123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348140 */     GIR_RootConstrainSelectedInstOperands,
     /*  348141 */     // GIR_Coverage, 21266,
     /*  348141 */     GIR_EraseRootFromParent_Done,
     /*  348142 */   // Label 6340: @348142
     /*  348142 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(348208), // Rule ID 21267 //
     /*  348147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  348150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  348158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  348161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  348164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  348189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348206 */     GIR_RootConstrainSelectedInstOperands,
     /*  348207 */     // GIR_Coverage, 21267,
     /*  348207 */     GIR_EraseRootFromParent_Done,
     /*  348208 */   // Label 6341: @348208
     /*  348208 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(348274), // Rule ID 21270 //
     /*  348213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  348216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  348224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  348227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  348230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  348255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348272 */     GIR_RootConstrainSelectedInstOperands,
     /*  348273 */     // GIR_Coverage, 21270,
     /*  348273 */     GIR_EraseRootFromParent_Done,
     /*  348274 */   // Label 6342: @348274
     /*  348274 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(348340), // Rule ID 21271 //
     /*  348279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  348282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  348290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  348293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  348296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  348321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348338 */     GIR_RootConstrainSelectedInstOperands,
     /*  348339 */     // GIR_Coverage, 21271,
     /*  348339 */     GIR_EraseRootFromParent_Done,
     /*  348340 */   // Label 6343: @348340
     /*  348340 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(348406), // Rule ID 21274 //
     /*  348345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  348348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  348356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  348359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  348362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348384 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  348387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348404 */     GIR_RootConstrainSelectedInstOperands,
     /*  348405 */     // GIR_Coverage, 21274,
     /*  348405 */     GIR_EraseRootFromParent_Done,
     /*  348406 */   // Label 6344: @348406
     /*  348406 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(348472), // Rule ID 21275 //
     /*  348411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  348414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  348422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  348425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  348428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348450 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  348453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348470 */     GIR_RootConstrainSelectedInstOperands,
     /*  348471 */     // GIR_Coverage, 21275,
     /*  348471 */     GIR_EraseRootFromParent_Done,
     /*  348472 */   // Label 6345: @348472
     /*  348472 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(348538), // Rule ID 21278 //
     /*  348477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  348480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  348488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  348491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  348494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348516 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  348519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348536 */     GIR_RootConstrainSelectedInstOperands,
     /*  348537 */     // GIR_Coverage, 21278,
     /*  348537 */     GIR_EraseRootFromParent_Done,
     /*  348538 */   // Label 6346: @348538
     /*  348538 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(348604), // Rule ID 21279 //
     /*  348543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  348546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  348554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  348557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  348560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348582 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  348585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348602 */     GIR_RootConstrainSelectedInstOperands,
     /*  348603 */     // GIR_Coverage, 21279,
     /*  348603 */     GIR_EraseRootFromParent_Done,
     /*  348604 */   // Label 6347: @348604
     /*  348604 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(348670), // Rule ID 21282 //
     /*  348609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  348617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  348620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  348623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  348626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348648 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  348651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348668 */     GIR_RootConstrainSelectedInstOperands,
     /*  348669 */     // GIR_Coverage, 21282,
     /*  348669 */     GIR_EraseRootFromParent_Done,
     /*  348670 */   // Label 6348: @348670
     /*  348670 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(348736), // Rule ID 21283 //
     /*  348675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  348683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  348686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  348689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  348692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  348717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348734 */     GIR_RootConstrainSelectedInstOperands,
     /*  348735 */     // GIR_Coverage, 21283,
     /*  348735 */     GIR_EraseRootFromParent_Done,
     /*  348736 */   // Label 6349: @348736
     /*  348736 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(348802), // Rule ID 21286 //
     /*  348741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  348749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  348752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  348755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  348758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348780 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  348783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348800 */     GIR_RootConstrainSelectedInstOperands,
     /*  348801 */     // GIR_Coverage, 21286,
     /*  348801 */     GIR_EraseRootFromParent_Done,
     /*  348802 */   // Label 6350: @348802
     /*  348802 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(348868), // Rule ID 21287 //
     /*  348807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  348815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  348818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  348821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  348824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348846 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  348849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348866 */     GIR_RootConstrainSelectedInstOperands,
     /*  348867 */     // GIR_Coverage, 21287,
     /*  348867 */     GIR_EraseRootFromParent_Done,
     /*  348868 */   // Label 6351: @348868
     /*  348868 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(348934), // Rule ID 21290 //
     /*  348873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  348881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  348884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  348887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  348890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  348915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348932 */     GIR_RootConstrainSelectedInstOperands,
     /*  348933 */     // GIR_Coverage, 21290,
     /*  348933 */     GIR_EraseRootFromParent_Done,
     /*  348934 */   // Label 6352: @348934
     /*  348934 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(349000), // Rule ID 21291 //
     /*  348939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  348947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  348950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  348953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  348956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348978 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  348981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348998 */     GIR_RootConstrainSelectedInstOperands,
     /*  348999 */     // GIR_Coverage, 21291,
     /*  348999 */     GIR_EraseRootFromParent_Done,
     /*  349000 */   // Label 6353: @349000
     /*  349000 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(349066), // Rule ID 21294 //
     /*  349005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  349008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349044 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  349047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349064 */     GIR_RootConstrainSelectedInstOperands,
     /*  349065 */     // GIR_Coverage, 21294,
     /*  349065 */     GIR_EraseRootFromParent_Done,
     /*  349066 */   // Label 6354: @349066
     /*  349066 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(349132), // Rule ID 21295 //
     /*  349071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  349074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349110 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  349113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349130 */     GIR_RootConstrainSelectedInstOperands,
     /*  349131 */     // GIR_Coverage, 21295,
     /*  349131 */     GIR_EraseRootFromParent_Done,
     /*  349132 */   // Label 6355: @349132
     /*  349132 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(349198), // Rule ID 21298 //
     /*  349137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  349140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  349148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  349151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349176 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  349179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349196 */     GIR_RootConstrainSelectedInstOperands,
     /*  349197 */     // GIR_Coverage, 21298,
     /*  349197 */     GIR_EraseRootFromParent_Done,
     /*  349198 */   // Label 6356: @349198
     /*  349198 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(349264), // Rule ID 21299 //
     /*  349203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  349206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  349214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  349217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349242 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  349245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349262 */     GIR_RootConstrainSelectedInstOperands,
     /*  349263 */     // GIR_Coverage, 21299,
     /*  349263 */     GIR_EraseRootFromParent_Done,
     /*  349264 */   // Label 6357: @349264
     /*  349264 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(349330), // Rule ID 21302 //
     /*  349269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  349272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  349280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  349283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  349286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  349311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349328 */     GIR_RootConstrainSelectedInstOperands,
     /*  349329 */     // GIR_Coverage, 21302,
     /*  349329 */     GIR_EraseRootFromParent_Done,
     /*  349330 */   // Label 6358: @349330
     /*  349330 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(349396), // Rule ID 21303 //
     /*  349335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  349338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  349346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  349349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  349352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  349377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349394 */     GIR_RootConstrainSelectedInstOperands,
     /*  349395 */     // GIR_Coverage, 21303,
     /*  349395 */     GIR_EraseRootFromParent_Done,
     /*  349396 */   // Label 6359: @349396
     /*  349396 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(349462), // Rule ID 21306 //
     /*  349401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  349404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  349412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  349415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  349418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349440 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  349443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349460 */     GIR_RootConstrainSelectedInstOperands,
     /*  349461 */     // GIR_Coverage, 21306,
     /*  349461 */     GIR_EraseRootFromParent_Done,
     /*  349462 */   // Label 6360: @349462
     /*  349462 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(349528), // Rule ID 21307 //
     /*  349467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  349470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  349478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  349481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  349484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349506 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  349509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349526 */     GIR_RootConstrainSelectedInstOperands,
     /*  349527 */     // GIR_Coverage, 21307,
     /*  349527 */     GIR_EraseRootFromParent_Done,
     /*  349528 */   // Label 6361: @349528
     /*  349528 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(349594), // Rule ID 21310 //
     /*  349533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  349536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  349544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  349547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  349550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349572 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  349575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349592 */     GIR_RootConstrainSelectedInstOperands,
     /*  349593 */     // GIR_Coverage, 21310,
     /*  349593 */     GIR_EraseRootFromParent_Done,
     /*  349594 */   // Label 6362: @349594
     /*  349594 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(349660), // Rule ID 21311 //
     /*  349599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  349602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  349610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  349613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  349616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349638 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  349641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349658 */     GIR_RootConstrainSelectedInstOperands,
     /*  349659 */     // GIR_Coverage, 21311,
     /*  349659 */     GIR_EraseRootFromParent_Done,
     /*  349660 */   // Label 6363: @349660
     /*  349660 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(349726), // Rule ID 21314 //
     /*  349665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  349668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  349676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  349679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  349682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349704 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  349707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349724 */     GIR_RootConstrainSelectedInstOperands,
     /*  349725 */     // GIR_Coverage, 21314,
     /*  349725 */     GIR_EraseRootFromParent_Done,
     /*  349726 */   // Label 6364: @349726
     /*  349726 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(349792), // Rule ID 21315 //
     /*  349731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  349734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  349742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  349745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  349748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349770 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  349773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349790 */     GIR_RootConstrainSelectedInstOperands,
     /*  349791 */     // GIR_Coverage, 21315,
     /*  349791 */     GIR_EraseRootFromParent_Done,
     /*  349792 */   // Label 6365: @349792
     /*  349792 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(349858), // Rule ID 21318 //
     /*  349797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  349800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  349805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  349808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  349811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  349814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349836 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  349836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  349839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349856 */     GIR_RootConstrainSelectedInstOperands,
     /*  349857 */     // GIR_Coverage, 21318,
     /*  349857 */     GIR_EraseRootFromParent_Done,
     /*  349858 */   // Label 6366: @349858
     /*  349858 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(349924), // Rule ID 21319 //
     /*  349863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  349866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  349871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  349874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  349877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  349880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349902 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  349902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  349905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349922 */     GIR_RootConstrainSelectedInstOperands,
     /*  349923 */     // GIR_Coverage, 21319,
     /*  349923 */     GIR_EraseRootFromParent_Done,
     /*  349924 */   // Label 6367: @349924
     /*  349924 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(349990), // Rule ID 21322 //
     /*  349929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  349932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  349937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  349940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  349943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  349946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349968 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  349968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  349971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349988 */     GIR_RootConstrainSelectedInstOperands,
     /*  349989 */     // GIR_Coverage, 21322,
     /*  349989 */     GIR_EraseRootFromParent_Done,
     /*  349990 */   // Label 6368: @349990
     /*  349990 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(350056), // Rule ID 21323 //
     /*  349995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  349998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  350006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  350009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  350012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350034 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  350034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  350037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350054 */     GIR_RootConstrainSelectedInstOperands,
     /*  350055 */     // GIR_Coverage, 21323,
     /*  350055 */     GIR_EraseRootFromParent_Done,
     /*  350056 */   // Label 6369: @350056
     /*  350056 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(350122), // Rule ID 21326 //
     /*  350061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  350064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  350072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  350075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  350078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350100 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  350100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  350103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350120 */     GIR_RootConstrainSelectedInstOperands,
     /*  350121 */     // GIR_Coverage, 21326,
     /*  350121 */     GIR_EraseRootFromParent_Done,
     /*  350122 */   // Label 6370: @350122
     /*  350122 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(350188), // Rule ID 21327 //
     /*  350127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  350130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  350138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  350141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  350144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350166 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  350166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  350169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350186 */     GIR_RootConstrainSelectedInstOperands,
     /*  350187 */     // GIR_Coverage, 21327,
     /*  350187 */     GIR_EraseRootFromParent_Done,
     /*  350188 */   // Label 6371: @350188
     /*  350188 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(350254), // Rule ID 21330 //
     /*  350193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  350196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  350204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  350207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  350210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350232 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  350232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  350235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350252 */     GIR_RootConstrainSelectedInstOperands,
     /*  350253 */     // GIR_Coverage, 21330,
     /*  350253 */     GIR_EraseRootFromParent_Done,
     /*  350254 */   // Label 6372: @350254
     /*  350254 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(350320), // Rule ID 21331 //
     /*  350259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  350262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  350270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  350273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  350276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350298 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  350298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  350301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350318 */     GIR_RootConstrainSelectedInstOperands,
     /*  350319 */     // GIR_Coverage, 21331,
     /*  350319 */     GIR_EraseRootFromParent_Done,
     /*  350320 */   // Label 6373: @350320
     /*  350320 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(350386), // Rule ID 21334 //
     /*  350325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  350328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  350336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  350339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  350342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350364 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  350364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  350367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350384 */     GIR_RootConstrainSelectedInstOperands,
     /*  350385 */     // GIR_Coverage, 21334,
     /*  350385 */     GIR_EraseRootFromParent_Done,
     /*  350386 */   // Label 6374: @350386
     /*  350386 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(350452), // Rule ID 21335 //
     /*  350391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  350394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  350402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  350405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  350408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350430 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  350430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  350433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350450 */     GIR_RootConstrainSelectedInstOperands,
     /*  350451 */     // GIR_Coverage, 21335,
     /*  350451 */     GIR_EraseRootFromParent_Done,
     /*  350452 */   // Label 6375: @350452
     /*  350452 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(350518), // Rule ID 21338 //
     /*  350457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  350460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  350468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  350471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  350474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350496 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  350496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  350499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350516 */     GIR_RootConstrainSelectedInstOperands,
     /*  350517 */     // GIR_Coverage, 21338,
     /*  350517 */     GIR_EraseRootFromParent_Done,
     /*  350518 */   // Label 6376: @350518
     /*  350518 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(350584), // Rule ID 21339 //
     /*  350523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  350526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  350534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  350537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  350540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350562 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  350562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  350565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350582 */     GIR_RootConstrainSelectedInstOperands,
     /*  350583 */     // GIR_Coverage, 21339,
     /*  350583 */     GIR_EraseRootFromParent_Done,
     /*  350584 */   // Label 6377: @350584
     /*  350584 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(350650), // Rule ID 21342 //
     /*  350589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  350592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  350600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  350603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  350606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350628 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  350631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350648 */     GIR_RootConstrainSelectedInstOperands,
     /*  350649 */     // GIR_Coverage, 21342,
     /*  350649 */     GIR_EraseRootFromParent_Done,
     /*  350650 */   // Label 6378: @350650
     /*  350650 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(350716), // Rule ID 21343 //
     /*  350655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  350658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  350666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  350669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  350672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350694 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  350697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350714 */     GIR_RootConstrainSelectedInstOperands,
     /*  350715 */     // GIR_Coverage, 21343,
     /*  350715 */     GIR_EraseRootFromParent_Done,
     /*  350716 */   // Label 6379: @350716
     /*  350716 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(350782), // Rule ID 21346 //
     /*  350721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  350724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  350732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  350735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350760 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  350763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350780 */     GIR_RootConstrainSelectedInstOperands,
     /*  350781 */     // GIR_Coverage, 21346,
     /*  350781 */     GIR_EraseRootFromParent_Done,
     /*  350782 */   // Label 6380: @350782
     /*  350782 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(350848), // Rule ID 21347 //
     /*  350787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  350790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  350798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  350801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350826 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  350829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350846 */     GIR_RootConstrainSelectedInstOperands,
     /*  350847 */     // GIR_Coverage, 21347,
     /*  350847 */     GIR_EraseRootFromParent_Done,
     /*  350848 */   // Label 6381: @350848
     /*  350848 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(350914), // Rule ID 21350 //
     /*  350853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  350856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  350864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  350867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350892 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  350895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350912 */     GIR_RootConstrainSelectedInstOperands,
     /*  350913 */     // GIR_Coverage, 21350,
     /*  350913 */     GIR_EraseRootFromParent_Done,
     /*  350914 */   // Label 6382: @350914
     /*  350914 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(350980), // Rule ID 21351 //
     /*  350919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  350922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  350930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  350933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350958 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  350961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350978 */     GIR_RootConstrainSelectedInstOperands,
     /*  350979 */     // GIR_Coverage, 21351,
     /*  350979 */     GIR_EraseRootFromParent_Done,
     /*  350980 */   // Label 6383: @350980
     /*  350980 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(351046), // Rule ID 21354 //
     /*  350985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  350988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  350996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  350999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  351002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351024 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  351024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  351027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351044 */     GIR_RootConstrainSelectedInstOperands,
     /*  351045 */     // GIR_Coverage, 21354,
     /*  351045 */     GIR_EraseRootFromParent_Done,
     /*  351046 */   // Label 6384: @351046
     /*  351046 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(351112), // Rule ID 21355 //
     /*  351051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  351054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  351062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  351065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  351068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351090 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  351090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  351093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351110 */     GIR_RootConstrainSelectedInstOperands,
     /*  351111 */     // GIR_Coverage, 21355,
     /*  351111 */     GIR_EraseRootFromParent_Done,
     /*  351112 */   // Label 6385: @351112
     /*  351112 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(351178), // Rule ID 21358 //
     /*  351117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  351120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  351128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  351131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  351134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351156 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  351156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  351159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351176 */     GIR_RootConstrainSelectedInstOperands,
     /*  351177 */     // GIR_Coverage, 21358,
     /*  351177 */     GIR_EraseRootFromParent_Done,
     /*  351178 */   // Label 6386: @351178
     /*  351178 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(351244), // Rule ID 21359 //
     /*  351183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  351186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  351194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  351197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  351200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351222 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  351222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  351225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351242 */     GIR_RootConstrainSelectedInstOperands,
     /*  351243 */     // GIR_Coverage, 21359,
     /*  351243 */     GIR_EraseRootFromParent_Done,
     /*  351244 */   // Label 6387: @351244
     /*  351244 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(351310), // Rule ID 21362 //
     /*  351249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  351252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  351260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  351263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351288 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  351291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351308 */     GIR_RootConstrainSelectedInstOperands,
     /*  351309 */     // GIR_Coverage, 21362,
     /*  351309 */     GIR_EraseRootFromParent_Done,
     /*  351310 */   // Label 6388: @351310
     /*  351310 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(351376), // Rule ID 21363 //
     /*  351315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  351318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  351326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  351329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351354 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  351357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351374 */     GIR_RootConstrainSelectedInstOperands,
     /*  351375 */     // GIR_Coverage, 21363,
     /*  351375 */     GIR_EraseRootFromParent_Done,
     /*  351376 */   // Label 6389: @351376
     /*  351376 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(351442), // Rule ID 21366 //
     /*  351381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  351384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  351392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  351395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  351398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351420 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  351423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351440 */     GIR_RootConstrainSelectedInstOperands,
     /*  351441 */     // GIR_Coverage, 21366,
     /*  351441 */     GIR_EraseRootFromParent_Done,
     /*  351442 */   // Label 6390: @351442
     /*  351442 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(351508), // Rule ID 21367 //
     /*  351447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  351450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  351458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  351461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  351464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351486 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  351489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351506 */     GIR_RootConstrainSelectedInstOperands,
     /*  351507 */     // GIR_Coverage, 21367,
     /*  351507 */     GIR_EraseRootFromParent_Done,
     /*  351508 */   // Label 6391: @351508
     /*  351508 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(351574), // Rule ID 21370 //
     /*  351513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  351516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  351524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  351527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  351530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351552 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  351555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351572 */     GIR_RootConstrainSelectedInstOperands,
     /*  351573 */     // GIR_Coverage, 21370,
     /*  351573 */     GIR_EraseRootFromParent_Done,
     /*  351574 */   // Label 6392: @351574
     /*  351574 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(351640), // Rule ID 21371 //
     /*  351579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  351582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  351590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  351593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  351596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351618 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  351621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351638 */     GIR_RootConstrainSelectedInstOperands,
     /*  351639 */     // GIR_Coverage, 21371,
     /*  351639 */     GIR_EraseRootFromParent_Done,
     /*  351640 */   // Label 6393: @351640
     /*  351640 */   GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(351706), // Rule ID 21374 //
     /*  351645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  351648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  351656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  351659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  351662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351684 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  351687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351704 */     GIR_RootConstrainSelectedInstOperands,
     /*  351705 */     // GIR_Coverage, 21374,
     /*  351705 */     GIR_EraseRootFromParent_Done,
     /*  351706 */   // Label 6394: @351706
     /*  351706 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(351772), // Rule ID 21375 //
     /*  351711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  351714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  351722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  351725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  351728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351750 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  351753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351770 */     GIR_RootConstrainSelectedInstOperands,
     /*  351771 */     // GIR_Coverage, 21375,
     /*  351771 */     GIR_EraseRootFromParent_Done,
     /*  351772 */   // Label 6395: @351772
     /*  351772 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(351838), // Rule ID 21378 //
     /*  351777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  351785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  351788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  351791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  351794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351816 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  351819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351836 */     GIR_RootConstrainSelectedInstOperands,
     /*  351837 */     // GIR_Coverage, 21378,
     /*  351837 */     GIR_EraseRootFromParent_Done,
     /*  351838 */   // Label 6396: @351838
     /*  351838 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(351904), // Rule ID 21379 //
     /*  351843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  351851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  351854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  351857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  351860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351882 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  351885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351902 */     GIR_RootConstrainSelectedInstOperands,
     /*  351903 */     // GIR_Coverage, 21379,
     /*  351903 */     GIR_EraseRootFromParent_Done,
     /*  351904 */   // Label 6397: @351904
     /*  351904 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(351970), // Rule ID 21382 //
     /*  351909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  351917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  351920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  351923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  351926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351948 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  351951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351968 */     GIR_RootConstrainSelectedInstOperands,
     /*  351969 */     // GIR_Coverage, 21382,
     /*  351969 */     GIR_EraseRootFromParent_Done,
     /*  351970 */   // Label 6398: @351970
     /*  351970 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(352036), // Rule ID 21383 //
     /*  351975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  351983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  351986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  351989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  351992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352014 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  352017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352034 */     GIR_RootConstrainSelectedInstOperands,
     /*  352035 */     // GIR_Coverage, 21383,
     /*  352035 */     GIR_EraseRootFromParent_Done,
     /*  352036 */   // Label 6399: @352036
     /*  352036 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(352102), // Rule ID 21386 //
     /*  352041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  352058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352080 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  352083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352100 */     GIR_RootConstrainSelectedInstOperands,
     /*  352101 */     // GIR_Coverage, 21386,
     /*  352101 */     GIR_EraseRootFromParent_Done,
     /*  352102 */   // Label 6400: @352102
     /*  352102 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(352168), // Rule ID 21387 //
     /*  352107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  352124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352146 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  352149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352166 */     GIR_RootConstrainSelectedInstOperands,
     /*  352167 */     // GIR_Coverage, 21387,
     /*  352167 */     GIR_EraseRootFromParent_Done,
     /*  352168 */   // Label 6401: @352168
     /*  352168 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(352234), // Rule ID 21390 //
     /*  352173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  352184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  352187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  352190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352212 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  352215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352232 */     GIR_RootConstrainSelectedInstOperands,
     /*  352233 */     // GIR_Coverage, 21390,
     /*  352233 */     GIR_EraseRootFromParent_Done,
     /*  352234 */   // Label 6402: @352234
     /*  352234 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(352300), // Rule ID 21391 //
     /*  352239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  352250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  352253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  352256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352278 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  352281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352298 */     GIR_RootConstrainSelectedInstOperands,
     /*  352299 */     // GIR_Coverage, 21391,
     /*  352299 */     GIR_EraseRootFromParent_Done,
     /*  352300 */   // Label 6403: @352300
     /*  352300 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(352366), // Rule ID 21394 //
     /*  352305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  352316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  352319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  352322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352344 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  352347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352364 */     GIR_RootConstrainSelectedInstOperands,
     /*  352365 */     // GIR_Coverage, 21394,
     /*  352365 */     GIR_EraseRootFromParent_Done,
     /*  352366 */   // Label 6404: @352366
     /*  352366 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(352432), // Rule ID 21395 //
     /*  352371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  352382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  352385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  352388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352410 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  352413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352430 */     GIR_RootConstrainSelectedInstOperands,
     /*  352431 */     // GIR_Coverage, 21395,
     /*  352431 */     GIR_EraseRootFromParent_Done,
     /*  352432 */   // Label 6405: @352432
     /*  352432 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(352498), // Rule ID 21398 //
     /*  352437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  352448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  352451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  352454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352476 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  352479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352496 */     GIR_RootConstrainSelectedInstOperands,
     /*  352497 */     // GIR_Coverage, 21398,
     /*  352497 */     GIR_EraseRootFromParent_Done,
     /*  352498 */   // Label 6406: @352498
     /*  352498 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(352564), // Rule ID 21399 //
     /*  352503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  352514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  352517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  352520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352542 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  352545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352562 */     GIR_RootConstrainSelectedInstOperands,
     /*  352563 */     // GIR_Coverage, 21399,
     /*  352563 */     GIR_EraseRootFromParent_Done,
     /*  352564 */   // Label 6407: @352564
     /*  352564 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(352630), // Rule ID 21402 //
     /*  352569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  352580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  352583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  352586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352608 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  352611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352628 */     GIR_RootConstrainSelectedInstOperands,
     /*  352629 */     // GIR_Coverage, 21402,
     /*  352629 */     GIR_EraseRootFromParent_Done,
     /*  352630 */   // Label 6408: @352630
     /*  352630 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(352696), // Rule ID 21403 //
     /*  352635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  352646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  352649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  352652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352674 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  352677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352694 */     GIR_RootConstrainSelectedInstOperands,
     /*  352695 */     // GIR_Coverage, 21403,
     /*  352695 */     GIR_EraseRootFromParent_Done,
     /*  352696 */   // Label 6409: @352696
     /*  352696 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(352762), // Rule ID 21406 //
     /*  352701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  352712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  352715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  352718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352740 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  352743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352760 */     GIR_RootConstrainSelectedInstOperands,
     /*  352761 */     // GIR_Coverage, 21406,
     /*  352761 */     GIR_EraseRootFromParent_Done,
     /*  352762 */   // Label 6410: @352762
     /*  352762 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(352828), // Rule ID 21407 //
     /*  352767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  352778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  352781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  352784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352806 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  352809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352826 */     GIR_RootConstrainSelectedInstOperands,
     /*  352827 */     // GIR_Coverage, 21407,
     /*  352827 */     GIR_EraseRootFromParent_Done,
     /*  352828 */   // Label 6411: @352828
     /*  352828 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(352894), // Rule ID 21410 //
     /*  352833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  352844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  352847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  352850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352872 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  352875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352892 */     GIR_RootConstrainSelectedInstOperands,
     /*  352893 */     // GIR_Coverage, 21410,
     /*  352893 */     GIR_EraseRootFromParent_Done,
     /*  352894 */   // Label 6412: @352894
     /*  352894 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(352960), // Rule ID 21411 //
     /*  352899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  352910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  352913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  352916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352938 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  352941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352958 */     GIR_RootConstrainSelectedInstOperands,
     /*  352959 */     // GIR_Coverage, 21411,
     /*  352959 */     GIR_EraseRootFromParent_Done,
     /*  352960 */   // Label 6413: @352960
     /*  352960 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(353026), // Rule ID 21414 //
     /*  352965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  352976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  352979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  352982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353004 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  353007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353024 */     GIR_RootConstrainSelectedInstOperands,
     /*  353025 */     // GIR_Coverage, 21414,
     /*  353025 */     GIR_EraseRootFromParent_Done,
     /*  353026 */   // Label 6414: @353026
     /*  353026 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(353092), // Rule ID 21415 //
     /*  353031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  353034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  353042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  353045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  353048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353070 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  353073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353090 */     GIR_RootConstrainSelectedInstOperands,
     /*  353091 */     // GIR_Coverage, 21415,
     /*  353091 */     GIR_EraseRootFromParent_Done,
     /*  353092 */   // Label 6415: @353092
     /*  353092 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(353158), // Rule ID 21418 //
     /*  353097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  353100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  353108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  353111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  353114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353136 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  353139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353156 */     GIR_RootConstrainSelectedInstOperands,
     /*  353157 */     // GIR_Coverage, 21418,
     /*  353157 */     GIR_EraseRootFromParent_Done,
     /*  353158 */   // Label 6416: @353158
     /*  353158 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(353224), // Rule ID 21419 //
     /*  353163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  353166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  353174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  353177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  353180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353202 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  353205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353222 */     GIR_RootConstrainSelectedInstOperands,
     /*  353223 */     // GIR_Coverage, 21419,
     /*  353223 */     GIR_EraseRootFromParent_Done,
     /*  353224 */   // Label 6417: @353224
     /*  353224 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(353290), // Rule ID 21422 //
     /*  353229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  353240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  353243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  353246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353268 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  353271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353288 */     GIR_RootConstrainSelectedInstOperands,
     /*  353289 */     // GIR_Coverage, 21422,
     /*  353289 */     GIR_EraseRootFromParent_Done,
     /*  353290 */   // Label 6418: @353290
     /*  353290 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(353356), // Rule ID 21423 //
     /*  353295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  353306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  353309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  353312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353334 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  353337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353354 */     GIR_RootConstrainSelectedInstOperands,
     /*  353355 */     // GIR_Coverage, 21423,
     /*  353355 */     GIR_EraseRootFromParent_Done,
     /*  353356 */   // Label 6419: @353356
     /*  353356 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(353422), // Rule ID 21426 //
     /*  353361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  353372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  353375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  353378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353400 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  353403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353420 */     GIR_RootConstrainSelectedInstOperands,
     /*  353421 */     // GIR_Coverage, 21426,
     /*  353421 */     GIR_EraseRootFromParent_Done,
     /*  353422 */   // Label 6420: @353422
     /*  353422 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(353488), // Rule ID 21427 //
     /*  353427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  353438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  353441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  353444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353466 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  353469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353486 */     GIR_RootConstrainSelectedInstOperands,
     /*  353487 */     // GIR_Coverage, 21427,
     /*  353487 */     GIR_EraseRootFromParent_Done,
     /*  353488 */   // Label 6421: @353488
     /*  353488 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(353554), // Rule ID 21430 //
     /*  353493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  353504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  353507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  353510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353532 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  353535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353552 */     GIR_RootConstrainSelectedInstOperands,
     /*  353553 */     // GIR_Coverage, 21430,
     /*  353553 */     GIR_EraseRootFromParent_Done,
     /*  353554 */   // Label 6422: @353554
     /*  353554 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(353620), // Rule ID 21431 //
     /*  353559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  353570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  353573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  353576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353598 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  353601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353618 */     GIR_RootConstrainSelectedInstOperands,
     /*  353619 */     // GIR_Coverage, 21431,
     /*  353619 */     GIR_EraseRootFromParent_Done,
     /*  353620 */   // Label 6423: @353620
     /*  353620 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(353686), // Rule ID 21434 //
     /*  353625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  353636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  353639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  353642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353664 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  353667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353684 */     GIR_RootConstrainSelectedInstOperands,
     /*  353685 */     // GIR_Coverage, 21434,
     /*  353685 */     GIR_EraseRootFromParent_Done,
     /*  353686 */   // Label 6424: @353686
     /*  353686 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(353752), // Rule ID 21435 //
     /*  353691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  353702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  353705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  353708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353730 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  353733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353750 */     GIR_RootConstrainSelectedInstOperands,
     /*  353751 */     // GIR_Coverage, 21435,
     /*  353751 */     GIR_EraseRootFromParent_Done,
     /*  353752 */   // Label 6425: @353752
     /*  353752 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(353818), // Rule ID 21438 //
     /*  353757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  353760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  353765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  353768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  353771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  353774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353796 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  353799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353816 */     GIR_RootConstrainSelectedInstOperands,
     /*  353817 */     // GIR_Coverage, 21438,
     /*  353817 */     GIR_EraseRootFromParent_Done,
     /*  353818 */   // Label 6426: @353818
     /*  353818 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(353884), // Rule ID 21439 //
     /*  353823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  353826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  353831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  353834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  353837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  353840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353862 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  353865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353882 */     GIR_RootConstrainSelectedInstOperands,
     /*  353883 */     // GIR_Coverage, 21439,
     /*  353883 */     GIR_EraseRootFromParent_Done,
     /*  353884 */   // Label 6427: @353884
     /*  353884 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(353950), // Rule ID 21442 //
     /*  353889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  353892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  353897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  353900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  353903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  353906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353928 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  353931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353948 */     GIR_RootConstrainSelectedInstOperands,
     /*  353949 */     // GIR_Coverage, 21442,
     /*  353949 */     GIR_EraseRootFromParent_Done,
     /*  353950 */   // Label 6428: @353950
     /*  353950 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(354016), // Rule ID 21443 //
     /*  353955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  353958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  353963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  353966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  353969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  353972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353994 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  353997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354014 */     GIR_RootConstrainSelectedInstOperands,
     /*  354015 */     // GIR_Coverage, 21443,
     /*  354015 */     GIR_EraseRootFromParent_Done,
     /*  354016 */   // Label 6429: @354016
     /*  354016 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(354082), // Rule ID 21446 //
     /*  354021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  354024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  354032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  354035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  354038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354060 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  354063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354080 */     GIR_RootConstrainSelectedInstOperands,
     /*  354081 */     // GIR_Coverage, 21446,
     /*  354081 */     GIR_EraseRootFromParent_Done,
     /*  354082 */   // Label 6430: @354082
     /*  354082 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(354148), // Rule ID 21447 //
     /*  354087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  354090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  354098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  354101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  354104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354126 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  354129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354146 */     GIR_RootConstrainSelectedInstOperands,
     /*  354147 */     // GIR_Coverage, 21447,
     /*  354147 */     GIR_EraseRootFromParent_Done,
     /*  354148 */   // Label 6431: @354148
     /*  354148 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(354214), // Rule ID 21450 //
     /*  354153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  354156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  354164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  354167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  354170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354192 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  354195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354212 */     GIR_RootConstrainSelectedInstOperands,
     /*  354213 */     // GIR_Coverage, 21450,
     /*  354213 */     GIR_EraseRootFromParent_Done,
     /*  354214 */   // Label 6432: @354214
     /*  354214 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(354280), // Rule ID 21451 //
     /*  354219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  354222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  354230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  354233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  354236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354258 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  354261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354278 */     GIR_RootConstrainSelectedInstOperands,
     /*  354279 */     // GIR_Coverage, 21451,
     /*  354279 */     GIR_EraseRootFromParent_Done,
     /*  354280 */   // Label 6433: @354280
     /*  354280 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(354346), // Rule ID 21454 //
     /*  354285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  354288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  354296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  354299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  354302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354324 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  354327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354344 */     GIR_RootConstrainSelectedInstOperands,
     /*  354345 */     // GIR_Coverage, 21454,
     /*  354345 */     GIR_EraseRootFromParent_Done,
     /*  354346 */   // Label 6434: @354346
     /*  354346 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(354412), // Rule ID 21455 //
     /*  354351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  354354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  354362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  354365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  354368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354390 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  354393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354410 */     GIR_RootConstrainSelectedInstOperands,
     /*  354411 */     // GIR_Coverage, 21455,
     /*  354411 */     GIR_EraseRootFromParent_Done,
     /*  354412 */   // Label 6435: @354412
     /*  354412 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(354478), // Rule ID 21458 //
     /*  354417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  354420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  354428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  354431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  354434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354456 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  354459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354476 */     GIR_RootConstrainSelectedInstOperands,
     /*  354477 */     // GIR_Coverage, 21458,
     /*  354477 */     GIR_EraseRootFromParent_Done,
     /*  354478 */   // Label 6436: @354478
     /*  354478 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(354544), // Rule ID 21459 //
     /*  354483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  354486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  354494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  354497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  354500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354522 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  354525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354542 */     GIR_RootConstrainSelectedInstOperands,
     /*  354543 */     // GIR_Coverage, 21459,
     /*  354543 */     GIR_EraseRootFromParent_Done,
     /*  354544 */   // Label 6437: @354544
     /*  354544 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(354610), // Rule ID 21462 //
     /*  354549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  354552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  354560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  354563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354588 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  354591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354608 */     GIR_RootConstrainSelectedInstOperands,
     /*  354609 */     // GIR_Coverage, 21462,
     /*  354609 */     GIR_EraseRootFromParent_Done,
     /*  354610 */   // Label 6438: @354610
     /*  354610 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(354676), // Rule ID 21463 //
     /*  354615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  354618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  354626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  354629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354654 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  354657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354674 */     GIR_RootConstrainSelectedInstOperands,
     /*  354675 */     // GIR_Coverage, 21463,
     /*  354675 */     GIR_EraseRootFromParent_Done,
     /*  354676 */   // Label 6439: @354676
     /*  354676 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(354742), // Rule ID 21466 //
     /*  354681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  354684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  354692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  354695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354720 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  354723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354740 */     GIR_RootConstrainSelectedInstOperands,
     /*  354741 */     // GIR_Coverage, 21466,
     /*  354741 */     GIR_EraseRootFromParent_Done,
     /*  354742 */   // Label 6440: @354742
     /*  354742 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(354808), // Rule ID 21467 //
     /*  354747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  354750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  354758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  354761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354786 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  354789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354806 */     GIR_RootConstrainSelectedInstOperands,
     /*  354807 */     // GIR_Coverage, 21467,
     /*  354807 */     GIR_EraseRootFromParent_Done,
     /*  354808 */   // Label 6441: @354808
     /*  354808 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(354874), // Rule ID 21470 //
     /*  354813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  354816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  354824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  354827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  354830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354852 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  354855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354872 */     GIR_RootConstrainSelectedInstOperands,
     /*  354873 */     // GIR_Coverage, 21470,
     /*  354873 */     GIR_EraseRootFromParent_Done,
     /*  354874 */   // Label 6442: @354874
     /*  354874 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(354940), // Rule ID 21471 //
     /*  354879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  354882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  354890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  354893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  354896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354918 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  354921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354938 */     GIR_RootConstrainSelectedInstOperands,
     /*  354939 */     // GIR_Coverage, 21471,
     /*  354939 */     GIR_EraseRootFromParent_Done,
     /*  354940 */   // Label 6443: @354940
     /*  354940 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(355006), // Rule ID 21714 //
     /*  354945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  354948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  354953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  354956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  354959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  354962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354984 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  354984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  354987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355004 */     GIR_RootConstrainSelectedInstOperands,
     /*  355005 */     // GIR_Coverage, 21714,
     /*  355005 */     GIR_EraseRootFromParent_Done,
     /*  355006 */   // Label 6444: @355006
     /*  355006 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(355072), // Rule ID 21715 //
     /*  355011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  355014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  355022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  355025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  355028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355050 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  355053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355070 */     GIR_RootConstrainSelectedInstOperands,
     /*  355071 */     // GIR_Coverage, 21715,
     /*  355071 */     GIR_EraseRootFromParent_Done,
     /*  355072 */   // Label 6445: @355072
     /*  355072 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(355138), // Rule ID 21718 //
     /*  355077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  355080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  355088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  355091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  355094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355116 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  355116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  355119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355136 */     GIR_RootConstrainSelectedInstOperands,
     /*  355137 */     // GIR_Coverage, 21718,
     /*  355137 */     GIR_EraseRootFromParent_Done,
     /*  355138 */   // Label 6446: @355138
     /*  355138 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(355204), // Rule ID 21719 //
     /*  355143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  355146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  355154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  355157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  355160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355182 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  355185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355202 */     GIR_RootConstrainSelectedInstOperands,
     /*  355203 */     // GIR_Coverage, 21719,
     /*  355203 */     GIR_EraseRootFromParent_Done,
     /*  355204 */   // Label 6447: @355204
     /*  355204 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(355270), // Rule ID 21722 //
     /*  355209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  355212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  355220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  355223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  355226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355248 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  355248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  355251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355268 */     GIR_RootConstrainSelectedInstOperands,
     /*  355269 */     // GIR_Coverage, 21722,
     /*  355269 */     GIR_EraseRootFromParent_Done,
     /*  355270 */   // Label 6448: @355270
     /*  355270 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(355336), // Rule ID 21723 //
     /*  355275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  355278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  355286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  355289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  355292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355314 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  355317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355334 */     GIR_RootConstrainSelectedInstOperands,
     /*  355335 */     // GIR_Coverage, 21723,
     /*  355335 */     GIR_EraseRootFromParent_Done,
     /*  355336 */   // Label 6449: @355336
     /*  355336 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(355402), // Rule ID 21726 //
     /*  355341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  355344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  355352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  355355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  355358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355380 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  355380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  355383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355400 */     GIR_RootConstrainSelectedInstOperands,
     /*  355401 */     // GIR_Coverage, 21726,
     /*  355401 */     GIR_EraseRootFromParent_Done,
     /*  355402 */   // Label 6450: @355402
     /*  355402 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(355468), // Rule ID 21727 //
     /*  355407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  355410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  355418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  355421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  355424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355446 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11210:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  355449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355466 */     GIR_RootConstrainSelectedInstOperands,
     /*  355467 */     // GIR_Coverage, 21727,
     /*  355467 */     GIR_EraseRootFromParent_Done,
     /*  355468 */   // Label 6451: @355468
     /*  355468 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(355534), // Rule ID 21730 //
     /*  355473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  355476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  355484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  355487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  355490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355512 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  355512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  355515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355532 */     GIR_RootConstrainSelectedInstOperands,
     /*  355533 */     // GIR_Coverage, 21730,
     /*  355533 */     GIR_EraseRootFromParent_Done,
     /*  355534 */   // Label 6452: @355534
     /*  355534 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(355600), // Rule ID 21731 //
     /*  355539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  355542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  355550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  355553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  355556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355578 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  355581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355598 */     GIR_RootConstrainSelectedInstOperands,
     /*  355599 */     // GIR_Coverage, 21731,
     /*  355599 */     GIR_EraseRootFromParent_Done,
     /*  355600 */   // Label 6453: @355600
     /*  355600 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(355666), // Rule ID 21734 //
     /*  355605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  355608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  355616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  355619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  355622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355644 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  355644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  355647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355664 */     GIR_RootConstrainSelectedInstOperands,
     /*  355665 */     // GIR_Coverage, 21734,
     /*  355665 */     GIR_EraseRootFromParent_Done,
     /*  355666 */   // Label 6454: @355666
     /*  355666 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(355732), // Rule ID 21735 //
     /*  355671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  355674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  355682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  355685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  355688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355710 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  355713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355730 */     GIR_RootConstrainSelectedInstOperands,
     /*  355731 */     // GIR_Coverage, 21735,
     /*  355731 */     GIR_EraseRootFromParent_Done,
     /*  355732 */   // Label 6455: @355732
     /*  355732 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(355798), // Rule ID 21738 //
     /*  355737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  355740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355776 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  355779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355796 */     GIR_RootConstrainSelectedInstOperands,
     /*  355797 */     // GIR_Coverage, 21738,
     /*  355797 */     GIR_EraseRootFromParent_Done,
     /*  355798 */   // Label 6456: @355798
     /*  355798 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(355864), // Rule ID 21739 //
     /*  355803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  355806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355842 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  355845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355862 */     GIR_RootConstrainSelectedInstOperands,
     /*  355863 */     // GIR_Coverage, 21739,
     /*  355863 */     GIR_EraseRootFromParent_Done,
     /*  355864 */   // Label 6457: @355864
     /*  355864 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(355930), // Rule ID 21742 //
     /*  355869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  355872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  355886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355908 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  355911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355928 */     GIR_RootConstrainSelectedInstOperands,
     /*  355929 */     // GIR_Coverage, 21742,
     /*  355929 */     GIR_EraseRootFromParent_Done,
     /*  355930 */   // Label 6458: @355930
     /*  355930 */   GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(355996), // Rule ID 21743 //
     /*  355935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  355938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  355952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355974 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  355977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355994 */     GIR_RootConstrainSelectedInstOperands,
     /*  355995 */     // GIR_Coverage, 21743,
     /*  355995 */     GIR_EraseRootFromParent_Done,
     /*  355996 */   // Label 6459: @355996
     /*  355996 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(356062), // Rule ID 21746 //
     /*  356001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  356004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  356012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  356015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  356018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  356040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  356043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356060 */     GIR_RootConstrainSelectedInstOperands,
     /*  356061 */     // GIR_Coverage, 21746,
     /*  356061 */     GIR_EraseRootFromParent_Done,
     /*  356062 */   // Label 6460: @356062
     /*  356062 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(356128), // Rule ID 21747 //
     /*  356067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  356070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  356078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  356081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  356084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  356106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  356109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356126 */     GIR_RootConstrainSelectedInstOperands,
     /*  356127 */     // GIR_Coverage, 21747,
     /*  356127 */     GIR_EraseRootFromParent_Done,
     /*  356128 */   // Label 6461: @356128
     /*  356128 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(356194), // Rule ID 21750 //
     /*  356133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  356136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  356144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  356147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  356150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356172 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  356172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  356175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356192 */     GIR_RootConstrainSelectedInstOperands,
     /*  356193 */     // GIR_Coverage, 21750,
     /*  356193 */     GIR_EraseRootFromParent_Done,
     /*  356194 */   // Label 6462: @356194
     /*  356194 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(356260), // Rule ID 21751 //
     /*  356199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  356202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  356210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  356213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  356216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356238 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  356238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  356241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356258 */     GIR_RootConstrainSelectedInstOperands,
     /*  356259 */     // GIR_Coverage, 21751,
     /*  356259 */     GIR_EraseRootFromParent_Done,
     /*  356260 */   // Label 6463: @356260
     /*  356260 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(356326), // Rule ID 21754 //
     /*  356265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  356268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  356276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  356279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  356282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356304 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  356304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  356307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356324 */     GIR_RootConstrainSelectedInstOperands,
     /*  356325 */     // GIR_Coverage, 21754,
     /*  356325 */     GIR_EraseRootFromParent_Done,
     /*  356326 */   // Label 6464: @356326
     /*  356326 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(356392), // Rule ID 21755 //
     /*  356331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  356334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  356342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  356345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  356348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356370 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  356370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  356373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356390 */     GIR_RootConstrainSelectedInstOperands,
     /*  356391 */     // GIR_Coverage, 21755,
     /*  356391 */     GIR_EraseRootFromParent_Done,
     /*  356392 */   // Label 6465: @356392
     /*  356392 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(356458), // Rule ID 21758 //
     /*  356397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  356400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  356408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  356411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  356414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356436 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  356439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356456 */     GIR_RootConstrainSelectedInstOperands,
     /*  356457 */     // GIR_Coverage, 21758,
     /*  356457 */     GIR_EraseRootFromParent_Done,
     /*  356458 */   // Label 6466: @356458
     /*  356458 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(356524), // Rule ID 21759 //
     /*  356463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  356466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  356474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  356477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  356480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  356505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356522 */     GIR_RootConstrainSelectedInstOperands,
     /*  356523 */     // GIR_Coverage, 21759,
     /*  356523 */     GIR_EraseRootFromParent_Done,
     /*  356524 */   // Label 6467: @356524
     /*  356524 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(356590), // Rule ID 21762 //
     /*  356529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  356532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  356540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  356543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  356546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356568 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  356571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356588 */     GIR_RootConstrainSelectedInstOperands,
     /*  356589 */     // GIR_Coverage, 21762,
     /*  356589 */     GIR_EraseRootFromParent_Done,
     /*  356590 */   // Label 6468: @356590
     /*  356590 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(356656), // Rule ID 21763 //
     /*  356595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  356598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  356606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  356609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  356612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356634 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  356637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356654 */     GIR_RootConstrainSelectedInstOperands,
     /*  356655 */     // GIR_Coverage, 21763,
     /*  356655 */     GIR_EraseRootFromParent_Done,
     /*  356656 */   // Label 6469: @356656
     /*  356656 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(356722), // Rule ID 21766 //
     /*  356661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  356664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  356672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  356675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  356678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  356703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356720 */     GIR_RootConstrainSelectedInstOperands,
     /*  356721 */     // GIR_Coverage, 21766,
     /*  356721 */     GIR_EraseRootFromParent_Done,
     /*  356722 */   // Label 6470: @356722
     /*  356722 */   GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(356788), // Rule ID 21767 //
     /*  356727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  356730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  356738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  356741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  356744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  356769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356786 */     GIR_RootConstrainSelectedInstOperands,
     /*  356787 */     // GIR_Coverage, 21767,
     /*  356787 */     GIR_EraseRootFromParent_Done,
     /*  356788 */   // Label 6471: @356788
     /*  356788 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(356854), // Rule ID 21770 //
     /*  356793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  356796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  356804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  356807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  356810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356832 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  356835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356852 */     GIR_RootConstrainSelectedInstOperands,
     /*  356853 */     // GIR_Coverage, 21770,
     /*  356853 */     GIR_EraseRootFromParent_Done,
     /*  356854 */   // Label 6472: @356854
     /*  356854 */   GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(356920), // Rule ID 21771 //
     /*  356859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  356862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  356870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  356873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  356876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356898 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  356901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356918 */     GIR_RootConstrainSelectedInstOperands,
     /*  356919 */     // GIR_Coverage, 21771,
     /*  356919 */     GIR_EraseRootFromParent_Done,
     /*  356920 */   // Label 6473: @356920
     /*  356920 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(356986), // Rule ID 21774 //
     /*  356925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  356928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  356933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  356936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  356939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  356942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356964 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  356964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  356967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  356981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356984 */     GIR_RootConstrainSelectedInstOperands,
     /*  356985 */     // GIR_Coverage, 21774,
     /*  356985 */     GIR_EraseRootFromParent_Done,
     /*  356986 */   // Label 6474: @356986
     /*  356986 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(357052), // Rule ID 21775 //
     /*  356991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  356994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  356999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  357002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  357005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  357008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357030 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  357030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  357033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357050 */     GIR_RootConstrainSelectedInstOperands,
     /*  357051 */     // GIR_Coverage, 21775,
     /*  357051 */     GIR_EraseRootFromParent_Done,
     /*  357052 */   // Label 6475: @357052
     /*  357052 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(357118), // Rule ID 21778 //
     /*  357057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  357060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  357068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  357071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  357074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357096 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  357096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  357099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357116 */     GIR_RootConstrainSelectedInstOperands,
     /*  357117 */     // GIR_Coverage, 21778,
     /*  357117 */     GIR_EraseRootFromParent_Done,
     /*  357118 */   // Label 6476: @357118
     /*  357118 */   GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(357184), // Rule ID 21779 //
     /*  357123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  357126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  357134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  357137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  357140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357162 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  357162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  357165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357182 */     GIR_RootConstrainSelectedInstOperands,
     /*  357183 */     // GIR_Coverage, 21779,
     /*  357183 */     GIR_EraseRootFromParent_Done,
     /*  357184 */   // Label 6477: @357184
     /*  357184 */   GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(357250), // Rule ID 21782 //
     /*  357189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  357192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  357200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  357203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  357206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357228 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  357228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  357231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357248 */     GIR_RootConstrainSelectedInstOperands,
     /*  357249 */     // GIR_Coverage, 21782,
     /*  357249 */     GIR_EraseRootFromParent_Done,
     /*  357250 */   // Label 6478: @357250
     /*  357250 */   GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(357316), // Rule ID 21783 //
     /*  357255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  357258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  357266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  357269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  357272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357294 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  357294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  357297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357314 */     GIR_RootConstrainSelectedInstOperands,
     /*  357315 */     // GIR_Coverage, 21783,
     /*  357315 */     GIR_EraseRootFromParent_Done,
     /*  357316 */   // Label 6479: @357316
     /*  357316 */   GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(357382), // Rule ID 21786 //
     /*  357321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  357324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  357332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  357335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  357338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  357360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  357363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357380 */     GIR_RootConstrainSelectedInstOperands,
     /*  357381 */     // GIR_Coverage, 21786,
     /*  357381 */     GIR_EraseRootFromParent_Done,
     /*  357382 */   // Label 6480: @357382
     /*  357382 */   GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(357448), // Rule ID 21787 //
     /*  357387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  357390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  357398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  357401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  357404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  357426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  357429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357446 */     GIR_RootConstrainSelectedInstOperands,
     /*  357447 */     // GIR_Coverage, 21787,
     /*  357447 */     GIR_EraseRootFromParent_Done,
     /*  357448 */   // Label 6481: @357448
     /*  357448 */   GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(357514), // Rule ID 21790 //
     /*  357453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  357456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  357464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  357467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  357470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357492 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  357492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  357495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357512 */     GIR_RootConstrainSelectedInstOperands,
     /*  357513 */     // GIR_Coverage, 21790,
     /*  357513 */     GIR_EraseRootFromParent_Done,
     /*  357514 */   // Label 6482: @357514
     /*  357514 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(357580), // Rule ID 21791 //
     /*  357519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  357522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  357530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  357533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  357536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357558 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  357558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  357561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357578 */     GIR_RootConstrainSelectedInstOperands,
     /*  357579 */     // GIR_Coverage, 21791,
     /*  357579 */     GIR_EraseRootFromParent_Done,
     /*  357580 */   // Label 6483: @357580
     /*  357580 */   GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(357646), // Rule ID 21794 //
     /*  357585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  357588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  357596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  357599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  357602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357624 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  357624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  357627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357644 */     GIR_RootConstrainSelectedInstOperands,
     /*  357645 */     // GIR_Coverage, 21794,
     /*  357645 */     GIR_EraseRootFromParent_Done,
     /*  357646 */   // Label 6484: @357646
     /*  357646 */   GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(357712), // Rule ID 21795 //
     /*  357651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  357654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  357662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  357665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  357668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357690 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  357690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  357693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357710 */     GIR_RootConstrainSelectedInstOperands,
     /*  357711 */     // GIR_Coverage, 21795,
     /*  357711 */     GIR_EraseRootFromParent_Done,
     /*  357712 */   // Label 6485: @357712
     /*  357712 */   GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(357778), // Rule ID 21798 //
     /*  357717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  357720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  357728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  357731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  357734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357756 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  357756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  357759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357776 */     GIR_RootConstrainSelectedInstOperands,
     /*  357777 */     // GIR_Coverage, 21798,
     /*  357777 */     GIR_EraseRootFromParent_Done,
     /*  357778 */   // Label 6486: @357778
     /*  357778 */   GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(357844), // Rule ID 21799 //
     /*  357783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  357786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  357794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  357797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  357800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357822 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  357822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  357825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357842 */     GIR_RootConstrainSelectedInstOperands,
     /*  357843 */     // GIR_Coverage, 21799,
     /*  357843 */     GIR_EraseRootFromParent_Done,
     /*  357844 */   // Label 6487: @357844
     /*  357844 */   GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(357910), // Rule ID 21802 //
     /*  357849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  357852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  357860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  357863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  357866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357888 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  357888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  357891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357908 */     GIR_RootConstrainSelectedInstOperands,
     /*  357909 */     // GIR_Coverage, 21802,
     /*  357909 */     GIR_EraseRootFromParent_Done,
     /*  357910 */   // Label 6488: @357910
     /*  357910 */   GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(357976), // Rule ID 21803 //
     /*  357915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  357918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  357926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  357929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  357932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357954 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  357954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  357957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357974 */     GIR_RootConstrainSelectedInstOperands,
     /*  357975 */     // GIR_Coverage, 21803,
     /*  357975 */     GIR_EraseRootFromParent_Done,
     /*  357976 */   // Label 6489: @357976
     /*  357976 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(358042), // Rule ID 21806 //
     /*  357981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  357984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  357992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  357995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  357998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  358020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  358023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358040 */     GIR_RootConstrainSelectedInstOperands,
     /*  358041 */     // GIR_Coverage, 21806,
     /*  358041 */     GIR_EraseRootFromParent_Done,
     /*  358042 */   // Label 6490: @358042
     /*  358042 */   GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(358108), // Rule ID 21807 //
     /*  358047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  358050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  358058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  358061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  358064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  358086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  358089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358106 */     GIR_RootConstrainSelectedInstOperands,
     /*  358107 */     // GIR_Coverage, 21807,
     /*  358107 */     GIR_EraseRootFromParent_Done,
     /*  358108 */   // Label 6491: @358108
     /*  358108 */   GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(358174), // Rule ID 21810 //
     /*  358113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  358116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  358124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  358127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  358130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  358152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  358155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358172 */     GIR_RootConstrainSelectedInstOperands,
     /*  358173 */     // GIR_Coverage, 21810,
     /*  358173 */     GIR_EraseRootFromParent_Done,
     /*  358174 */   // Label 6492: @358174
     /*  358174 */   GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(358240), // Rule ID 21811 //
     /*  358179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  358182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  358190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  358193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  358196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  358218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  358221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358238 */     GIR_RootConstrainSelectedInstOperands,
     /*  358239 */     // GIR_Coverage, 21811,
     /*  358239 */     GIR_EraseRootFromParent_Done,
     /*  358240 */   // Label 6493: @358240
     /*  358240 */   GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(358306), // Rule ID 21814 //
     /*  358245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  358248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  358256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  358259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  358262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358284 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  358284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  358287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358304 */     GIR_RootConstrainSelectedInstOperands,
     /*  358305 */     // GIR_Coverage, 21814,
     /*  358305 */     GIR_EraseRootFromParent_Done,
     /*  358306 */   // Label 6494: @358306
     /*  358306 */   GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(358372), // Rule ID 21815 //
     /*  358311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  358314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  358322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  358325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  358328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  358350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  358353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358370 */     GIR_RootConstrainSelectedInstOperands,
     /*  358371 */     // GIR_Coverage, 21815,
     /*  358371 */     GIR_EraseRootFromParent_Done,
     /*  358372 */   // Label 6495: @358372
     /*  358372 */   GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(358438), // Rule ID 21818 //
     /*  358377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  358380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  358388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  358391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  358394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  358416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  358419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358436 */     GIR_RootConstrainSelectedInstOperands,
     /*  358437 */     // GIR_Coverage, 21818,
     /*  358437 */     GIR_EraseRootFromParent_Done,
     /*  358438 */   // Label 6496: @358438
     /*  358438 */   GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(358504), // Rule ID 21819 //
     /*  358443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  358446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  358454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  358457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  358460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358482 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  358482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  358485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358502 */     GIR_RootConstrainSelectedInstOperands,
     /*  358503 */     // GIR_Coverage, 21819,
     /*  358503 */     GIR_EraseRootFromParent_Done,
     /*  358504 */   // Label 6497: @358504
     /*  358504 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(358570), // Rule ID 21822 //
     /*  358509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  358512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  358520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  358523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  358526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358548 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  358548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  358551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358568 */     GIR_RootConstrainSelectedInstOperands,
     /*  358569 */     // GIR_Coverage, 21822,
     /*  358569 */     GIR_EraseRootFromParent_Done,
     /*  358570 */   // Label 6498: @358570
     /*  358570 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(358636), // Rule ID 21823 //
     /*  358575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  358578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  358586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  358589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  358592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358614 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  358614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  358617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358634 */     GIR_RootConstrainSelectedInstOperands,
     /*  358635 */     // GIR_Coverage, 21823,
     /*  358635 */     GIR_EraseRootFromParent_Done,
     /*  358636 */   // Label 6499: @358636
     /*  358636 */   GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(358702), // Rule ID 21826 //
     /*  358641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  358644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  358652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  358655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  358658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  358680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  358683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358700 */     GIR_RootConstrainSelectedInstOperands,
     /*  358701 */     // GIR_Coverage, 21826,
     /*  358701 */     GIR_EraseRootFromParent_Done,
     /*  358702 */   // Label 6500: @358702
     /*  358702 */   GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(358768), // Rule ID 21827 //
     /*  358707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  358710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  358718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  358721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  358724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358746 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  358746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  358749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358766 */     GIR_RootConstrainSelectedInstOperands,
     /*  358767 */     // GIR_Coverage, 21827,
     /*  358767 */     GIR_EraseRootFromParent_Done,
     /*  358768 */   // Label 6501: @358768
     /*  358768 */   GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(358834), // Rule ID 21830 //
     /*  358773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  358776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  358784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  358787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  358790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358812 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  358812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  358815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358832 */     GIR_RootConstrainSelectedInstOperands,
     /*  358833 */     // GIR_Coverage, 21830,
     /*  358833 */     GIR_EraseRootFromParent_Done,
     /*  358834 */   // Label 6502: @358834
     /*  358834 */   GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(358900), // Rule ID 21831 //
     /*  358839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  358842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  358850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  358853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  358856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  358878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  358881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358898 */     GIR_RootConstrainSelectedInstOperands,
     /*  358899 */     // GIR_Coverage, 21831,
     /*  358899 */     GIR_EraseRootFromParent_Done,
     /*  358900 */   // Label 6503: @358900
     /*  358900 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(358966), // Rule ID 21942 //
     /*  358905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  358908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  358913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  358916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  358919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  358922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358944 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  358944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  358947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358964 */     GIR_RootConstrainSelectedInstOperands,
     /*  358965 */     // GIR_Coverage, 21942,
     /*  358965 */     GIR_EraseRootFromParent_Done,
     /*  358966 */   // Label 6504: @358966
     /*  358966 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(359032), // Rule ID 21943 //
     /*  358971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  358974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  358979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  358982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  358985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  358988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359010 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  359010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  359013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359030 */     GIR_RootConstrainSelectedInstOperands,
     /*  359031 */     // GIR_Coverage, 21943,
     /*  359031 */     GIR_EraseRootFromParent_Done,
     /*  359032 */   // Label 6505: @359032
     /*  359032 */   GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(359098), // Rule ID 21946 //
     /*  359037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  359040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  359048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  359051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  359054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359076 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  359076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  359079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359096 */     GIR_RootConstrainSelectedInstOperands,
     /*  359097 */     // GIR_Coverage, 21946,
     /*  359097 */     GIR_EraseRootFromParent_Done,
     /*  359098 */   // Label 6506: @359098
     /*  359098 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(359164), // Rule ID 21947 //
     /*  359103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  359106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  359114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  359117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  359120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359142 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  359142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  359145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359162 */     GIR_RootConstrainSelectedInstOperands,
     /*  359163 */     // GIR_Coverage, 21947,
     /*  359163 */     GIR_EraseRootFromParent_Done,
     /*  359164 */   // Label 6507: @359164
     /*  359164 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(359230), // Rule ID 21950 //
     /*  359169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  359172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  359180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  359183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  359186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359208 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  359208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  359211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359228 */     GIR_RootConstrainSelectedInstOperands,
     /*  359229 */     // GIR_Coverage, 21950,
     /*  359229 */     GIR_EraseRootFromParent_Done,
     /*  359230 */   // Label 6508: @359230
     /*  359230 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(359296), // Rule ID 21951 //
     /*  359235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  359238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  359246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  359249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  359252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359274 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  359274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  359277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359294 */     GIR_RootConstrainSelectedInstOperands,
     /*  359295 */     // GIR_Coverage, 21951,
     /*  359295 */     GIR_EraseRootFromParent_Done,
     /*  359296 */   // Label 6509: @359296
     /*  359296 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(359362), // Rule ID 21954 //
     /*  359301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  359304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  359312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  359315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  359318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359340 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  359340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  359343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359360 */     GIR_RootConstrainSelectedInstOperands,
     /*  359361 */     // GIR_Coverage, 21954,
     /*  359361 */     GIR_EraseRootFromParent_Done,
     /*  359362 */   // Label 6510: @359362
     /*  359362 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(359428), // Rule ID 21955 //
     /*  359367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  359370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  359378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  359381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  359384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359406 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  359406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  359409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359426 */     GIR_RootConstrainSelectedInstOperands,
     /*  359427 */     // GIR_Coverage, 21955,
     /*  359427 */     GIR_EraseRootFromParent_Done,
     /*  359428 */   // Label 6511: @359428
     /*  359428 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(359494), // Rule ID 21958 //
     /*  359433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  359436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  359444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  359447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  359450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  359465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359472 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  359472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  359475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359492 */     GIR_RootConstrainSelectedInstOperands,
     /*  359493 */     // GIR_Coverage, 21958,
     /*  359493 */     GIR_EraseRootFromParent_Done,
     /*  359494 */   // Label 6512: @359494
     /*  359494 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(359560), // Rule ID 21959 //
     /*  359499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  359502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  359510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  359513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  359516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  359531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359538 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  359538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  359541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359558 */     GIR_RootConstrainSelectedInstOperands,
     /*  359559 */     // GIR_Coverage, 21959,
     /*  359559 */     GIR_EraseRootFromParent_Done,
     /*  359560 */   // Label 6513: @359560
     /*  359560 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(359626), // Rule ID 21962 //
     /*  359565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  359568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  359576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  359579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  359582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359604 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  359604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  359607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359624 */     GIR_RootConstrainSelectedInstOperands,
     /*  359625 */     // GIR_Coverage, 21962,
     /*  359625 */     GIR_EraseRootFromParent_Done,
     /*  359626 */   // Label 6514: @359626
     /*  359626 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(359692), // Rule ID 21963 //
     /*  359631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  359634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  359642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  359645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  359648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359670 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  359670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  359673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359690 */     GIR_RootConstrainSelectedInstOperands,
     /*  359691 */     // GIR_Coverage, 21963,
     /*  359691 */     GIR_EraseRootFromParent_Done,
     /*  359692 */   // Label 6515: @359692
     /*  359692 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(359758), // Rule ID 21966 //
     /*  359697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  359700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  359708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  359711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  359714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359736 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  359736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  359739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359756 */     GIR_RootConstrainSelectedInstOperands,
     /*  359757 */     // GIR_Coverage, 21966,
     /*  359757 */     GIR_EraseRootFromParent_Done,
     /*  359758 */   // Label 6516: @359758
     /*  359758 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(359824), // Rule ID 21967 //
     /*  359763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  359766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  359774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  359777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  359780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359802 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  359802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  359805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359822 */     GIR_RootConstrainSelectedInstOperands,
     /*  359823 */     // GIR_Coverage, 21967,
     /*  359823 */     GIR_EraseRootFromParent_Done,
     /*  359824 */   // Label 6517: @359824
     /*  359824 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(359890), // Rule ID 21970 //
     /*  359829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  359832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  359840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  359843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  359846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359868 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  359868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  359871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359888 */     GIR_RootConstrainSelectedInstOperands,
     /*  359889 */     // GIR_Coverage, 21970,
     /*  359889 */     GIR_EraseRootFromParent_Done,
     /*  359890 */   // Label 6518: @359890
     /*  359890 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(359956), // Rule ID 21971 //
     /*  359895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  359898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  359906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  359909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  359912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359934 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  359934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  359937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359954 */     GIR_RootConstrainSelectedInstOperands,
     /*  359955 */     // GIR_Coverage, 21971,
     /*  359955 */     GIR_EraseRootFromParent_Done,
     /*  359956 */   // Label 6519: @359956
     /*  359956 */   GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(360022), // Rule ID 21974 //
     /*  359961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  359964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  359972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  359975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  359978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  359993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360000 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  360000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  360003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  360017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360020 */     GIR_RootConstrainSelectedInstOperands,
     /*  360021 */     // GIR_Coverage, 21974,
     /*  360021 */     GIR_EraseRootFromParent_Done,
     /*  360022 */   // Label 6520: @360022
     /*  360022 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(360088), // Rule ID 21975 //
     /*  360027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  360030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  360035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  360038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  360041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  360044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  360051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  360055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  360059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360066 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  360066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  360069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  360083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360086 */     GIR_RootConstrainSelectedInstOperands,
     /*  360087 */     // GIR_Coverage, 21975,
     /*  360087 */     GIR_EraseRootFromParent_Done,
     /*  360088 */   // Label 6521: @360088
     /*  360088 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(360151), // Rule ID 23146 //
     /*  360093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360132 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  360135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360149 */     GIR_RootConstrainSelectedInstOperands,
     /*  360150 */     // GIR_Coverage, 23146,
     /*  360150 */     GIR_EraseRootFromParent_Done,
     /*  360151 */   // Label 6522: @360151
     /*  360151 */   GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(360214), // Rule ID 23147 //
     /*  360156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360195 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  360198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360212 */     GIR_RootConstrainSelectedInstOperands,
     /*  360213 */     // GIR_Coverage, 23147,
     /*  360213 */     GIR_EraseRootFromParent_Done,
     /*  360214 */   // Label 6523: @360214
     /*  360214 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(360277), // Rule ID 23148 //
     /*  360219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360258 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  360261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360275 */     GIR_RootConstrainSelectedInstOperands,
     /*  360276 */     // GIR_Coverage, 23148,
     /*  360276 */     GIR_EraseRootFromParent_Done,
     /*  360277 */   // Label 6524: @360277
     /*  360277 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(360340), // Rule ID 23149 //
     /*  360282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360321 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  360324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360338 */     GIR_RootConstrainSelectedInstOperands,
     /*  360339 */     // GIR_Coverage, 23149,
     /*  360339 */     GIR_EraseRootFromParent_Done,
     /*  360340 */   // Label 6525: @360340
     /*  360340 */   GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(360403), // Rule ID 23150 //
     /*  360345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360384 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  360387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360401 */     GIR_RootConstrainSelectedInstOperands,
     /*  360402 */     // GIR_Coverage, 23150,
     /*  360402 */     GIR_EraseRootFromParent_Done,
     /*  360403 */   // Label 6526: @360403
     /*  360403 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(360466), // Rule ID 23151 //
     /*  360408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360447 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  360450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360464 */     GIR_RootConstrainSelectedInstOperands,
     /*  360465 */     // GIR_Coverage, 23151,
     /*  360465 */     GIR_EraseRootFromParent_Done,
     /*  360466 */   // Label 6527: @360466
     /*  360466 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(360529), // Rule ID 23152 //
     /*  360471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360510 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  360513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360527 */     GIR_RootConstrainSelectedInstOperands,
     /*  360528 */     // GIR_Coverage, 23152,
     /*  360528 */     GIR_EraseRootFromParent_Done,
     /*  360529 */   // Label 6528: @360529
     /*  360529 */   GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(360592), // Rule ID 23153 //
     /*  360534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360573 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  360576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360590 */     GIR_RootConstrainSelectedInstOperands,
     /*  360591 */     // GIR_Coverage, 23153,
     /*  360591 */     GIR_EraseRootFromParent_Done,
     /*  360592 */   // Label 6529: @360592
     /*  360592 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(360655), // Rule ID 23154 //
     /*  360597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360636 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  360639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360653 */     GIR_RootConstrainSelectedInstOperands,
     /*  360654 */     // GIR_Coverage, 23154,
     /*  360654 */     GIR_EraseRootFromParent_Done,
     /*  360655 */   // Label 6530: @360655
     /*  360655 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(360718), // Rule ID 23155 //
     /*  360660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360699 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  360702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360716 */     GIR_RootConstrainSelectedInstOperands,
     /*  360717 */     // GIR_Coverage, 23155,
     /*  360717 */     GIR_EraseRootFromParent_Done,
     /*  360718 */   // Label 6531: @360718
     /*  360718 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(360781), // Rule ID 23156 //
     /*  360723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360762 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  360765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360779 */     GIR_RootConstrainSelectedInstOperands,
     /*  360780 */     // GIR_Coverage, 23156,
     /*  360780 */     GIR_EraseRootFromParent_Done,
     /*  360781 */   // Label 6532: @360781
     /*  360781 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(360844), // Rule ID 23157 //
     /*  360786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360825 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  360828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360842 */     GIR_RootConstrainSelectedInstOperands,
     /*  360843 */     // GIR_Coverage, 23157,
     /*  360843 */     GIR_EraseRootFromParent_Done,
     /*  360844 */   // Label 6533: @360844
     /*  360844 */   GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(360907), // Rule ID 23158 //
     /*  360849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  360857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360888 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  360891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360905 */     GIR_RootConstrainSelectedInstOperands,
     /*  360906 */     // GIR_Coverage, 23158,
     /*  360906 */     GIR_EraseRootFromParent_Done,
     /*  360907 */   // Label 6534: @360907
     /*  360907 */   GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(360970), // Rule ID 23159 //
     /*  360912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  360920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360951 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  360954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360968 */     GIR_RootConstrainSelectedInstOperands,
     /*  360969 */     // GIR_Coverage, 23159,
     /*  360969 */     GIR_EraseRootFromParent_Done,
     /*  360970 */   // Label 6535: @360970
     /*  360970 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(361033), // Rule ID 23160 //
     /*  360975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  360983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361014 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  361017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361031 */     GIR_RootConstrainSelectedInstOperands,
     /*  361032 */     // GIR_Coverage, 23160,
     /*  361032 */     GIR_EraseRootFromParent_Done,
     /*  361033 */   // Label 6536: @361033
     /*  361033 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(361096), // Rule ID 23161 //
     /*  361038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361077 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  361080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361094 */     GIR_RootConstrainSelectedInstOperands,
     /*  361095 */     // GIR_Coverage, 23161,
     /*  361095 */     GIR_EraseRootFromParent_Done,
     /*  361096 */   // Label 6537: @361096
     /*  361096 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(361159), // Rule ID 23162 //
     /*  361101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  361143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361157 */     GIR_RootConstrainSelectedInstOperands,
     /*  361158 */     // GIR_Coverage, 23162,
     /*  361158 */     GIR_EraseRootFromParent_Done,
     /*  361159 */   // Label 6538: @361159
     /*  361159 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(361222), // Rule ID 23163 //
     /*  361164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361203 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  361206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361220 */     GIR_RootConstrainSelectedInstOperands,
     /*  361221 */     // GIR_Coverage, 23163,
     /*  361221 */     GIR_EraseRootFromParent_Done,
     /*  361222 */   // Label 6539: @361222
     /*  361222 */   GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(361285), // Rule ID 23164 //
     /*  361227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361266 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  361269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361283 */     GIR_RootConstrainSelectedInstOperands,
     /*  361284 */     // GIR_Coverage, 23164,
     /*  361284 */     GIR_EraseRootFromParent_Done,
     /*  361285 */   // Label 6540: @361285
     /*  361285 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(361348), // Rule ID 23165 //
     /*  361290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361329 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  361332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361346 */     GIR_RootConstrainSelectedInstOperands,
     /*  361347 */     // GIR_Coverage, 23165,
     /*  361347 */     GIR_EraseRootFromParent_Done,
     /*  361348 */   // Label 6541: @361348
     /*  361348 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(361411), // Rule ID 23166 //
     /*  361353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361392 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  361395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361409 */     GIR_RootConstrainSelectedInstOperands,
     /*  361410 */     // GIR_Coverage, 23166,
     /*  361410 */     GIR_EraseRootFromParent_Done,
     /*  361411 */   // Label 6542: @361411
     /*  361411 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(361474), // Rule ID 23167 //
     /*  361416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361455 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  361458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361472 */     GIR_RootConstrainSelectedInstOperands,
     /*  361473 */     // GIR_Coverage, 23167,
     /*  361473 */     GIR_EraseRootFromParent_Done,
     /*  361474 */   // Label 6543: @361474
     /*  361474 */   GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(361537), // Rule ID 23168 //
     /*  361479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361518 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  361521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361535 */     GIR_RootConstrainSelectedInstOperands,
     /*  361536 */     // GIR_Coverage, 23168,
     /*  361536 */     GIR_EraseRootFromParent_Done,
     /*  361537 */   // Label 6544: @361537
     /*  361537 */   GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(361600), // Rule ID 23169 //
     /*  361542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361581 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  361584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361598 */     GIR_RootConstrainSelectedInstOperands,
     /*  361599 */     // GIR_Coverage, 23169,
     /*  361599 */     GIR_EraseRootFromParent_Done,
     /*  361600 */   // Label 6545: @361600
     /*  361600 */   GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(361663), // Rule ID 23170 //
     /*  361605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361644 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  361647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361661 */     GIR_RootConstrainSelectedInstOperands,
     /*  361662 */     // GIR_Coverage, 23170,
     /*  361662 */     GIR_EraseRootFromParent_Done,
     /*  361663 */   // Label 6546: @361663
     /*  361663 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(361726), // Rule ID 23171 //
     /*  361668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361707 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  361710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361724 */     GIR_RootConstrainSelectedInstOperands,
     /*  361725 */     // GIR_Coverage, 23171,
     /*  361725 */     GIR_EraseRootFromParent_Done,
     /*  361726 */   // Label 6547: @361726
     /*  361726 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(361789), // Rule ID 23172 //
     /*  361731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  361739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361770 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  361773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361787 */     GIR_RootConstrainSelectedInstOperands,
     /*  361788 */     // GIR_Coverage, 23172,
     /*  361788 */     GIR_EraseRootFromParent_Done,
     /*  361789 */   // Label 6548: @361789
     /*  361789 */   GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(361852), // Rule ID 23173 //
     /*  361794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  361802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361833 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  361836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361850 */     GIR_RootConstrainSelectedInstOperands,
     /*  361851 */     // GIR_Coverage, 23173,
     /*  361851 */     GIR_EraseRootFromParent_Done,
     /*  361852 */   // Label 6549: @361852
     /*  361852 */   GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(361915), // Rule ID 23174 //
     /*  361857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  361865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361896 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  361899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361913 */     GIR_RootConstrainSelectedInstOperands,
     /*  361914 */     // GIR_Coverage, 23174,
     /*  361914 */     GIR_EraseRootFromParent_Done,
     /*  361915 */   // Label 6550: @361915
     /*  361915 */   GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(361978), // Rule ID 23175 //
     /*  361920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  361928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361959 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  361962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361976 */     GIR_RootConstrainSelectedInstOperands,
     /*  361977 */     // GIR_Coverage, 23175,
     /*  361977 */     GIR_EraseRootFromParent_Done,
     /*  361978 */   // Label 6551: @361978
     /*  361978 */   GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(362041), // Rule ID 23176 //
     /*  361983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  361991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362022 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  362025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362039 */     GIR_RootConstrainSelectedInstOperands,
     /*  362040 */     // GIR_Coverage, 23176,
     /*  362040 */     GIR_EraseRootFromParent_Done,
     /*  362041 */   // Label 6552: @362041
     /*  362041 */   GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(362104), // Rule ID 23177 //
     /*  362046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362085 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  362088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362102 */     GIR_RootConstrainSelectedInstOperands,
     /*  362103 */     // GIR_Coverage, 23177,
     /*  362103 */     GIR_EraseRootFromParent_Done,
     /*  362104 */   // Label 6553: @362104
     /*  362104 */   GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(362167), // Rule ID 23178 //
     /*  362109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362148 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  362151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362165 */     GIR_RootConstrainSelectedInstOperands,
     /*  362166 */     // GIR_Coverage, 23178,
     /*  362166 */     GIR_EraseRootFromParent_Done,
     /*  362167 */   // Label 6554: @362167
     /*  362167 */   GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(362230), // Rule ID 23179 //
     /*  362172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362211 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  362214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362228 */     GIR_RootConstrainSelectedInstOperands,
     /*  362229 */     // GIR_Coverage, 23179,
     /*  362229 */     GIR_EraseRootFromParent_Done,
     /*  362230 */   // Label 6555: @362230
     /*  362230 */   GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(362293), // Rule ID 23180 //
     /*  362235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362274 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  362277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362291 */     GIR_RootConstrainSelectedInstOperands,
     /*  362292 */     // GIR_Coverage, 23180,
     /*  362292 */     GIR_EraseRootFromParent_Done,
     /*  362293 */   // Label 6556: @362293
     /*  362293 */   GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(362356), // Rule ID 23181 //
     /*  362298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362337 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  362340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362354 */     GIR_RootConstrainSelectedInstOperands,
     /*  362355 */     // GIR_Coverage, 23181,
     /*  362355 */     GIR_EraseRootFromParent_Done,
     /*  362356 */   // Label 6557: @362356
     /*  362356 */   GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(362419), // Rule ID 23182 //
     /*  362361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362400 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  362403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362417 */     GIR_RootConstrainSelectedInstOperands,
     /*  362418 */     // GIR_Coverage, 23182,
     /*  362418 */     GIR_EraseRootFromParent_Done,
     /*  362419 */   // Label 6558: @362419
     /*  362419 */   GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(362482), // Rule ID 23183 //
     /*  362424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362463 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  362466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362480 */     GIR_RootConstrainSelectedInstOperands,
     /*  362481 */     // GIR_Coverage, 23183,
     /*  362481 */     GIR_EraseRootFromParent_Done,
     /*  362482 */   // Label 6559: @362482
     /*  362482 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(362545), // Rule ID 23184 //
     /*  362487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362526 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  362529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362543 */     GIR_RootConstrainSelectedInstOperands,
     /*  362544 */     // GIR_Coverage, 23184,
     /*  362544 */     GIR_EraseRootFromParent_Done,
     /*  362545 */   // Label 6560: @362545
     /*  362545 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(362608), // Rule ID 23185 //
     /*  362550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362589 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  362592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362606 */     GIR_RootConstrainSelectedInstOperands,
     /*  362607 */     // GIR_Coverage, 23185,
     /*  362607 */     GIR_EraseRootFromParent_Done,
     /*  362608 */   // Label 6561: @362608
     /*  362608 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(362671), // Rule ID 23186 //
     /*  362613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  362624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  362627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  362630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362652 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  362655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362669 */     GIR_RootConstrainSelectedInstOperands,
     /*  362670 */     // GIR_Coverage, 23186,
     /*  362670 */     GIR_EraseRootFromParent_Done,
     /*  362671 */   // Label 6562: @362671
     /*  362671 */   GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(362734), // Rule ID 23187 //
     /*  362676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  362687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  362690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  362693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362715 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  362718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362732 */     GIR_RootConstrainSelectedInstOperands,
     /*  362733 */     // GIR_Coverage, 23187,
     /*  362733 */     GIR_EraseRootFromParent_Done,
     /*  362734 */   // Label 6563: @362734
     /*  362734 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(362797), // Rule ID 23188 //
     /*  362739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362778 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  362781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362795 */     GIR_RootConstrainSelectedInstOperands,
     /*  362796 */     // GIR_Coverage, 23188,
     /*  362796 */     GIR_EraseRootFromParent_Done,
     /*  362797 */   // Label 6564: @362797
     /*  362797 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(362860), // Rule ID 23189 //
     /*  362802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362841 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  362844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362858 */     GIR_RootConstrainSelectedInstOperands,
     /*  362859 */     // GIR_Coverage, 23189,
     /*  362859 */     GIR_EraseRootFromParent_Done,
     /*  362860 */   // Label 6565: @362860
     /*  362860 */   GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(362923), // Rule ID 23190 //
     /*  362865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362904 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  362907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362921 */     GIR_RootConstrainSelectedInstOperands,
     /*  362922 */     // GIR_Coverage, 23190,
     /*  362922 */     GIR_EraseRootFromParent_Done,
     /*  362923 */   // Label 6566: @362923
     /*  362923 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(362986), // Rule ID 23191 //
     /*  362928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362967 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  362970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362984 */     GIR_RootConstrainSelectedInstOperands,
     /*  362985 */     // GIR_Coverage, 23191,
     /*  362985 */     GIR_EraseRootFromParent_Done,
     /*  362986 */   // Label 6567: @362986
     /*  362986 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(363049), // Rule ID 23192 //
     /*  362991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  363002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363030 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  363033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363047 */     GIR_RootConstrainSelectedInstOperands,
     /*  363048 */     // GIR_Coverage, 23192,
     /*  363048 */     GIR_EraseRootFromParent_Done,
     /*  363049 */   // Label 6568: @363049
     /*  363049 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(363112), // Rule ID 23193 //
     /*  363054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  363065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363093 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  363096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363110 */     GIR_RootConstrainSelectedInstOperands,
     /*  363111 */     // GIR_Coverage, 23193,
     /*  363111 */     GIR_EraseRootFromParent_Done,
     /*  363112 */   // Label 6569: @363112
     /*  363112 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(363175), // Rule ID 23194 //
     /*  363117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  363128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363156 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  363159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363173 */     GIR_RootConstrainSelectedInstOperands,
     /*  363174 */     // GIR_Coverage, 23194,
     /*  363174 */     GIR_EraseRootFromParent_Done,
     /*  363175 */   // Label 6570: @363175
     /*  363175 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(363238), // Rule ID 23195 //
     /*  363180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  363191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363219 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  363222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363236 */     GIR_RootConstrainSelectedInstOperands,
     /*  363237 */     // GIR_Coverage, 23195,
     /*  363237 */     GIR_EraseRootFromParent_Done,
     /*  363238 */   // Label 6571: @363238
     /*  363238 */   GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(363301), // Rule ID 23196 //
     /*  363243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  363254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363282 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  363285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363299 */     GIR_RootConstrainSelectedInstOperands,
     /*  363300 */     // GIR_Coverage, 23196,
     /*  363300 */     GIR_EraseRootFromParent_Done,
     /*  363301 */   // Label 6572: @363301
     /*  363301 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(363364), // Rule ID 23197 //
     /*  363306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  363317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363345 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  363348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363362 */     GIR_RootConstrainSelectedInstOperands,
     /*  363363 */     // GIR_Coverage, 23197,
     /*  363363 */     GIR_EraseRootFromParent_Done,
     /*  363364 */   // Label 6573: @363364
     /*  363364 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(363427), // Rule ID 23198 //
     /*  363369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  363380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363408 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  363411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363425 */     GIR_RootConstrainSelectedInstOperands,
     /*  363426 */     // GIR_Coverage, 23198,
     /*  363426 */     GIR_EraseRootFromParent_Done,
     /*  363427 */   // Label 6574: @363427
     /*  363427 */   GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(363490), // Rule ID 23199 //
     /*  363432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  363443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363471 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  363474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363488 */     GIR_RootConstrainSelectedInstOperands,
     /*  363489 */     // GIR_Coverage, 23199,
     /*  363489 */     GIR_EraseRootFromParent_Done,
     /*  363490 */   // Label 6575: @363490
     /*  363490 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(363553), // Rule ID 23200 //
     /*  363495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  363506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  363509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  363512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363534 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  363537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363551 */     GIR_RootConstrainSelectedInstOperands,
     /*  363552 */     // GIR_Coverage, 23200,
     /*  363552 */     GIR_EraseRootFromParent_Done,
     /*  363553 */   // Label 6576: @363553
     /*  363553 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(363616), // Rule ID 23201 //
     /*  363558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  363569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  363572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  363575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363597 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  363600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363614 */     GIR_RootConstrainSelectedInstOperands,
     /*  363615 */     // GIR_Coverage, 23201,
     /*  363615 */     GIR_EraseRootFromParent_Done,
     /*  363616 */   // Label 6577: @363616
     /*  363616 */   GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(363679), // Rule ID 23202 //
     /*  363621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  363632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363660 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  363663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363677 */     GIR_RootConstrainSelectedInstOperands,
     /*  363678 */     // GIR_Coverage, 23202,
     /*  363678 */     GIR_EraseRootFromParent_Done,
     /*  363679 */   // Label 6578: @363679
     /*  363679 */   GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(363742), // Rule ID 23203 //
     /*  363684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  363695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363723 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  363726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363740 */     GIR_RootConstrainSelectedInstOperands,
     /*  363741 */     // GIR_Coverage, 23203,
     /*  363741 */     GIR_EraseRootFromParent_Done,
     /*  363742 */   // Label 6579: @363742
     /*  363742 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(363805), // Rule ID 23204 //
     /*  363747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  363758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363786 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  363789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363803 */     GIR_RootConstrainSelectedInstOperands,
     /*  363804 */     // GIR_Coverage, 23204,
     /*  363804 */     GIR_EraseRootFromParent_Done,
     /*  363805 */   // Label 6580: @363805
     /*  363805 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(363868), // Rule ID 23205 //
     /*  363810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  363821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363849 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  363852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363866 */     GIR_RootConstrainSelectedInstOperands,
     /*  363867 */     // GIR_Coverage, 23205,
     /*  363867 */     GIR_EraseRootFromParent_Done,
     /*  363868 */   // Label 6581: @363868
     /*  363868 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(363931), // Rule ID 23206 //
     /*  363873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  363884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  363915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363929 */     GIR_RootConstrainSelectedInstOperands,
     /*  363930 */     // GIR_Coverage, 23206,
     /*  363930 */     GIR_EraseRootFromParent_Done,
     /*  363931 */   // Label 6582: @363931
     /*  363931 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(363994), // Rule ID 23207 //
     /*  363936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  363947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363975 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  363978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363992 */     GIR_RootConstrainSelectedInstOperands,
     /*  363993 */     // GIR_Coverage, 23207,
     /*  363993 */     GIR_EraseRootFromParent_Done,
     /*  363994 */   // Label 6583: @363994
     /*  363994 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(364057), // Rule ID 23208 //
     /*  363999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  364007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  364010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364038 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  364041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364055 */     GIR_RootConstrainSelectedInstOperands,
     /*  364056 */     // GIR_Coverage, 23208,
     /*  364056 */     GIR_EraseRootFromParent_Done,
     /*  364057 */   // Label 6584: @364057
     /*  364057 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(364120), // Rule ID 23209 //
     /*  364062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  364070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  364073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364101 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  364104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364118 */     GIR_RootConstrainSelectedInstOperands,
     /*  364119 */     // GIR_Coverage, 23209,
     /*  364119 */     GIR_EraseRootFromParent_Done,
     /*  364120 */   // Label 6585: @364120
     /*  364120 */   GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(364183), // Rule ID 23210 //
     /*  364125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  364133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  364136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364164 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  364167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364181 */     GIR_RootConstrainSelectedInstOperands,
     /*  364182 */     // GIR_Coverage, 23210,
     /*  364182 */     GIR_EraseRootFromParent_Done,
     /*  364183 */   // Label 6586: @364183
     /*  364183 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(364246), // Rule ID 23211 //
     /*  364188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  364196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  364199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364227 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  364230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364244 */     GIR_RootConstrainSelectedInstOperands,
     /*  364245 */     // GIR_Coverage, 23211,
     /*  364245 */     GIR_EraseRootFromParent_Done,
     /*  364246 */   // Label 6587: @364246
     /*  364246 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(364309), // Rule ID 23212 //
     /*  364251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  364259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  364262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364290 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  364293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364307 */     GIR_RootConstrainSelectedInstOperands,
     /*  364308 */     // GIR_Coverage, 23212,
     /*  364308 */     GIR_EraseRootFromParent_Done,
     /*  364309 */   // Label 6588: @364309
     /*  364309 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(364372), // Rule ID 23213 //
     /*  364314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  364322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  364325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364353 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11415:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  364356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364370 */     GIR_RootConstrainSelectedInstOperands,
     /*  364371 */     // GIR_Coverage, 23213,
     /*  364371 */     GIR_EraseRootFromParent_Done,
     /*  364372 */   // Label 6589: @364372
     /*  364372 */   GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(364435), // Rule ID 23214 //
     /*  364377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  364388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  364391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364416 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  364419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364433 */     GIR_RootConstrainSelectedInstOperands,
     /*  364434 */     // GIR_Coverage, 23214,
     /*  364434 */     GIR_EraseRootFromParent_Done,
     /*  364435 */   // Label 6590: @364435
     /*  364435 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(364498), // Rule ID 23215 //
     /*  364440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  364451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  364454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364479 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  364482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364496 */     GIR_RootConstrainSelectedInstOperands,
     /*  364497 */     // GIR_Coverage, 23215,
     /*  364497 */     GIR_EraseRootFromParent_Done,
     /*  364498 */   // Label 6591: @364498
     /*  364498 */   GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(364561), // Rule ID 23216 //
     /*  364503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  364514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  364517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364542 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  364545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364559 */     GIR_RootConstrainSelectedInstOperands,
     /*  364560 */     // GIR_Coverage, 23216,
     /*  364560 */     GIR_EraseRootFromParent_Done,
     /*  364561 */   // Label 6592: @364561
     /*  364561 */   GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(364624), // Rule ID 23217 //
     /*  364566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  364577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  364580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364605 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  364608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364622 */     GIR_RootConstrainSelectedInstOperands,
     /*  364623 */     // GIR_Coverage, 23217,
     /*  364623 */     GIR_EraseRootFromParent_Done,
     /*  364624 */   // Label 6593: @364624
     /*  364624 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(364687), // Rule ID 23218 //
     /*  364629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  364640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  364643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  364671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364685 */     GIR_RootConstrainSelectedInstOperands,
     /*  364686 */     // GIR_Coverage, 23218,
     /*  364686 */     GIR_EraseRootFromParent_Done,
     /*  364687 */   // Label 6594: @364687
     /*  364687 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(364750), // Rule ID 23219 //
     /*  364692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  364703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  364706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364731 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  364734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364748 */     GIR_RootConstrainSelectedInstOperands,
     /*  364749 */     // GIR_Coverage, 23219,
     /*  364749 */     GIR_EraseRootFromParent_Done,
     /*  364750 */   // Label 6595: @364750
     /*  364750 */   GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(364813), // Rule ID 23220 //
     /*  364755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  364766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  364769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  364772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364794 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  364797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364811 */     GIR_RootConstrainSelectedInstOperands,
     /*  364812 */     // GIR_Coverage, 23220,
     /*  364812 */     GIR_EraseRootFromParent_Done,
     /*  364813 */   // Label 6596: @364813
     /*  364813 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(364876), // Rule ID 23221 //
     /*  364818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  364829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  364832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  364835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364857 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  364860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364874 */     GIR_RootConstrainSelectedInstOperands,
     /*  364875 */     // GIR_Coverage, 23221,
     /*  364875 */     GIR_EraseRootFromParent_Done,
     /*  364876 */   // Label 6597: @364876
     /*  364876 */   GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(364939), // Rule ID 23222 //
     /*  364881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  364892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364920 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  364923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364937 */     GIR_RootConstrainSelectedInstOperands,
     /*  364938 */     // GIR_Coverage, 23222,
     /*  364938 */     GIR_EraseRootFromParent_Done,
     /*  364939 */   // Label 6598: @364939
     /*  364939 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(365002), // Rule ID 23223 //
     /*  364944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  364955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364983 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  364986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365000 */     GIR_RootConstrainSelectedInstOperands,
     /*  365001 */     // GIR_Coverage, 23223,
     /*  365001 */     GIR_EraseRootFromParent_Done,
     /*  365002 */   // Label 6599: @365002
     /*  365002 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(365065), // Rule ID 23224 //
     /*  365007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  365015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  365018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  365021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365046 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  365049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365063 */     GIR_RootConstrainSelectedInstOperands,
     /*  365064 */     // GIR_Coverage, 23224,
     /*  365064 */     GIR_EraseRootFromParent_Done,
     /*  365065 */   // Label 6600: @365065
     /*  365065 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(365128), // Rule ID 23225 //
     /*  365070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  365078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  365081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  365084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365109 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  365112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365126 */     GIR_RootConstrainSelectedInstOperands,
     /*  365127 */     // GIR_Coverage, 23225,
     /*  365127 */     GIR_EraseRootFromParent_Done,
     /*  365128 */   // Label 6601: @365128
     /*  365128 */   GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(365191), // Rule ID 23226 //
     /*  365133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  365141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  365144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  365147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  365150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365172 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  365175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365189 */     GIR_RootConstrainSelectedInstOperands,
     /*  365190 */     // GIR_Coverage, 23226,
     /*  365190 */     GIR_EraseRootFromParent_Done,
     /*  365191 */   // Label 6602: @365191
     /*  365191 */   GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(365254), // Rule ID 23227 //
     /*  365196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  365204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  365207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  365210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  365213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365235 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11414:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  365238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365252 */     GIR_RootConstrainSelectedInstOperands,
     /*  365253 */     // GIR_Coverage, 23227,
     /*  365253 */     GIR_EraseRootFromParent_Done,
     /*  365254 */   // Label 6603: @365254
     /*  365254 */   GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(365317), // Rule ID 23228 //
     /*  365259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  365270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  365273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365298 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  365301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365315 */     GIR_RootConstrainSelectedInstOperands,
     /*  365316 */     // GIR_Coverage, 23228,
     /*  365316 */     GIR_EraseRootFromParent_Done,
     /*  365317 */   // Label 6604: @365317
     /*  365317 */   GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(365380), // Rule ID 23229 //
     /*  365322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  365333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  365336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365361 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  365364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365378 */     GIR_RootConstrainSelectedInstOperands,
     /*  365379 */     // GIR_Coverage, 23229,
     /*  365379 */     GIR_EraseRootFromParent_Done,
     /*  365380 */   // Label 6605: @365380
     /*  365380 */   GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(365443), // Rule ID 23230 //
     /*  365385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  365396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  365399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365424 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  365427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365441 */     GIR_RootConstrainSelectedInstOperands,
     /*  365442 */     // GIR_Coverage, 23230,
     /*  365442 */     GIR_EraseRootFromParent_Done,
     /*  365443 */   // Label 6606: @365443
     /*  365443 */   GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(365506), // Rule ID 23231 //
     /*  365448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  365459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  365462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365487 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  365490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365504 */     GIR_RootConstrainSelectedInstOperands,
     /*  365505 */     // GIR_Coverage, 23231,
     /*  365505 */     GIR_EraseRootFromParent_Done,
     /*  365506 */   // Label 6607: @365506
     /*  365506 */   GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(365569), // Rule ID 23232 //
     /*  365511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  365522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  365525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365550 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  365553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365567 */     GIR_RootConstrainSelectedInstOperands,
     /*  365568 */     // GIR_Coverage, 23232,
     /*  365568 */     GIR_EraseRootFromParent_Done,
     /*  365569 */   // Label 6608: @365569
     /*  365569 */   GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(365632), // Rule ID 23233 //
     /*  365574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  365585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  365588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365613 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  365616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365630 */     GIR_RootConstrainSelectedInstOperands,
     /*  365631 */     // GIR_Coverage, 23233,
     /*  365631 */     GIR_EraseRootFromParent_Done,
     /*  365632 */   // Label 6609: @365632
     /*  365632 */   GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(365695), // Rule ID 23234 //
     /*  365637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  365648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  365651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  365654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365676 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  365679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365693 */     GIR_RootConstrainSelectedInstOperands,
     /*  365694 */     // GIR_Coverage, 23234,
     /*  365694 */     GIR_EraseRootFromParent_Done,
     /*  365695 */   // Label 6610: @365695
     /*  365695 */   GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(365758), // Rule ID 23235 //
     /*  365700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  365711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  365714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  365717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365739 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  365742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365756 */     GIR_RootConstrainSelectedInstOperands,
     /*  365757 */     // GIR_Coverage, 23235,
     /*  365757 */     GIR_EraseRootFromParent_Done,
     /*  365758 */   // Label 6611: @365758
     /*  365758 */   GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(365821), // Rule ID 23236 //
     /*  365763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  365774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  365777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  365780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365802 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  365805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365819 */     GIR_RootConstrainSelectedInstOperands,
     /*  365820 */     // GIR_Coverage, 23236,
     /*  365820 */     GIR_EraseRootFromParent_Done,
     /*  365821 */   // Label 6612: @365821
     /*  365821 */   GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(365884), // Rule ID 23237 //
     /*  365826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  365837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  365840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  365843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365865 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  365868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365882 */     GIR_RootConstrainSelectedInstOperands,
     /*  365883 */     // GIR_Coverage, 23237,
     /*  365883 */     GIR_EraseRootFromParent_Done,
     /*  365884 */   // Label 6613: @365884
     /*  365884 */   GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(365947), // Rule ID 23238 //
     /*  365889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  365900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  365903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365928 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  365931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365945 */     GIR_RootConstrainSelectedInstOperands,
     /*  365946 */     // GIR_Coverage, 23238,
     /*  365946 */     GIR_EraseRootFromParent_Done,
     /*  365947 */   // Label 6614: @365947
     /*  365947 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(366010), // Rule ID 23239 //
     /*  365952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  365963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  365966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365991 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  365994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366008 */     GIR_RootConstrainSelectedInstOperands,
     /*  366009 */     // GIR_Coverage, 23239,
     /*  366009 */     GIR_EraseRootFromParent_Done,
     /*  366010 */   // Label 6615: @366010
     /*  366010 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(366073), // Rule ID 23240 //
     /*  366015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  366023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  366026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  366029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366054 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  366057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366071 */     GIR_RootConstrainSelectedInstOperands,
     /*  366072 */     // GIR_Coverage, 23240,
     /*  366072 */     GIR_EraseRootFromParent_Done,
     /*  366073 */   // Label 6616: @366073
     /*  366073 */   GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(366136), // Rule ID 23241 //
     /*  366078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  366086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  366089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  366092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366117 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11416:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  366120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366134 */     GIR_RootConstrainSelectedInstOperands,
     /*  366135 */     // GIR_Coverage, 23241,
     /*  366135 */     GIR_EraseRootFromParent_Done,
     /*  366136 */   // Label 6617: @366136
     /*  366136 */   GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(366199), // Rule ID 23242 //
     /*  366141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  366152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  366155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  366158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366180 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  366183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366197 */     GIR_RootConstrainSelectedInstOperands,
     /*  366198 */     // GIR_Coverage, 23242,
     /*  366198 */     GIR_EraseRootFromParent_Done,
     /*  366199 */   // Label 6618: @366199
     /*  366199 */   GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(366262), // Rule ID 23243 //
     /*  366204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  366215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  366218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  366221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366243 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  366246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366260 */     GIR_RootConstrainSelectedInstOperands,
     /*  366261 */     // GIR_Coverage, 23243,
     /*  366261 */     GIR_EraseRootFromParent_Done,
     /*  366262 */   // Label 6619: @366262
     /*  366262 */   GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(366325), // Rule ID 23244 //
     /*  366267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  366278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  366281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  366284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366306 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  366309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366323 */     GIR_RootConstrainSelectedInstOperands,
     /*  366324 */     // GIR_Coverage, 23244,
     /*  366324 */     GIR_EraseRootFromParent_Done,
     /*  366325 */   // Label 6620: @366325
     /*  366325 */   GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(366388), // Rule ID 23245 //
     /*  366330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  366341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  366344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  366347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366369 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  366372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366386 */     GIR_RootConstrainSelectedInstOperands,
     /*  366387 */     // GIR_Coverage, 23245,
     /*  366387 */     GIR_EraseRootFromParent_Done,
     /*  366388 */   // Label 6621: @366388
     /*  366388 */   GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(366451), // Rule ID 23246 //
     /*  366393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  366404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  366407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366432 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  366435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366449 */     GIR_RootConstrainSelectedInstOperands,
     /*  366450 */     // GIR_Coverage, 23246,
     /*  366450 */     GIR_EraseRootFromParent_Done,
     /*  366451 */   // Label 6622: @366451
     /*  366451 */   GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(366514), // Rule ID 23247 //
     /*  366456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  366467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  366470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366495 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  366498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366512 */     GIR_RootConstrainSelectedInstOperands,
     /*  366513 */     // GIR_Coverage, 23247,
     /*  366513 */     GIR_EraseRootFromParent_Done,
     /*  366514 */   // Label 6623: @366514
     /*  366514 */   GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(366577), // Rule ID 23248 //
     /*  366519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  366530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  366533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366558 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  366561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366575 */     GIR_RootConstrainSelectedInstOperands,
     /*  366576 */     // GIR_Coverage, 23248,
     /*  366576 */     GIR_EraseRootFromParent_Done,
     /*  366577 */   // Label 6624: @366577
     /*  366577 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(366640), // Rule ID 23249 //
     /*  366582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  366593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  366596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366621 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  366624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366638 */     GIR_RootConstrainSelectedInstOperands,
     /*  366639 */     // GIR_Coverage, 23249,
     /*  366639 */     GIR_EraseRootFromParent_Done,
     /*  366640 */   // Label 6625: @366640
     /*  366640 */   GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(366703), // Rule ID 23250 //
     /*  366645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  366656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  366659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366684 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  366687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366701 */     GIR_RootConstrainSelectedInstOperands,
     /*  366702 */     // GIR_Coverage, 23250,
     /*  366702 */     GIR_EraseRootFromParent_Done,
     /*  366703 */   // Label 6626: @366703
     /*  366703 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(366766), // Rule ID 23251 //
     /*  366708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  366719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  366722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366747 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  366750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366764 */     GIR_RootConstrainSelectedInstOperands,
     /*  366765 */     // GIR_Coverage, 23251,
     /*  366765 */     GIR_EraseRootFromParent_Done,
     /*  366766 */   // Label 6627: @366766
     /*  366766 */   GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(366829), // Rule ID 23252 //
     /*  366771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  366782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  366785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366810 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  366813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366827 */     GIR_RootConstrainSelectedInstOperands,
     /*  366828 */     // GIR_Coverage, 23252,
     /*  366828 */     GIR_EraseRootFromParent_Done,
     /*  366829 */   // Label 6628: @366829
     /*  366829 */   GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(366892), // Rule ID 23253 //
     /*  366834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  366845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  366848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366873 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  366876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366890 */     GIR_RootConstrainSelectedInstOperands,
     /*  366891 */     // GIR_Coverage, 23253,
     /*  366891 */     GIR_EraseRootFromParent_Done,
     /*  366892 */   // Label 6629: @366892
     /*  366892 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(366955), // Rule ID 23254 //
     /*  366897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  366908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  366911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366936 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  366939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366953 */     GIR_RootConstrainSelectedInstOperands,
     /*  366954 */     // GIR_Coverage, 23254,
     /*  366954 */     GIR_EraseRootFromParent_Done,
     /*  366955 */   // Label 6630: @366955
     /*  366955 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(367018), // Rule ID 23255 //
     /*  366960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  366971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  366974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366999 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  367002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367016 */     GIR_RootConstrainSelectedInstOperands,
     /*  367017 */     // GIR_Coverage, 23255,
     /*  367017 */     GIR_EraseRootFromParent_Done,
     /*  367018 */   // Label 6631: @367018
     /*  367018 */   GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(367081), // Rule ID 23284 //
     /*  367023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  367037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367062 */     // (intrinsic_wo_chain:{ *:[i64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  367065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367069 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367079 */     GIR_RootConstrainSelectedInstOperands,
     /*  367080 */     // GIR_Coverage, 23284,
     /*  367080 */     GIR_EraseRootFromParent_Done,
     /*  367081 */   // Label 6632: @367081
     /*  367081 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(367144), // Rule ID 23285 //
     /*  367086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  367100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367125 */     // (intrinsic_wo_chain:{ *:[i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  367128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367132 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367142 */     GIR_RootConstrainSelectedInstOperands,
     /*  367143 */     // GIR_Coverage, 23285,
     /*  367143 */     GIR_EraseRootFromParent_Done,
     /*  367144 */   // Label 6633: @367144
     /*  367144 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(367207), // Rule ID 23288 //
     /*  367149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  367163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367188 */     // (intrinsic_wo_chain:{ *:[i64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  367191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367195 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367205 */     GIR_RootConstrainSelectedInstOperands,
     /*  367206 */     // GIR_Coverage, 23288,
     /*  367206 */     GIR_EraseRootFromParent_Done,
     /*  367207 */   // Label 6634: @367207
     /*  367207 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(367270), // Rule ID 23289 //
     /*  367212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  367226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367251 */     // (intrinsic_wo_chain:{ *:[i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  367254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367258 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367268 */     GIR_RootConstrainSelectedInstOperands,
     /*  367269 */     // GIR_Coverage, 23289,
     /*  367269 */     GIR_EraseRootFromParent_Done,
     /*  367270 */   // Label 6635: @367270
     /*  367270 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(367333), // Rule ID 23292 //
     /*  367275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  367289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367314 */     // (intrinsic_wo_chain:{ *:[i64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  367317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367321 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367331 */     GIR_RootConstrainSelectedInstOperands,
     /*  367332 */     // GIR_Coverage, 23292,
     /*  367332 */     GIR_EraseRootFromParent_Done,
     /*  367333 */   // Label 6636: @367333
     /*  367333 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(367396), // Rule ID 23293 //
     /*  367338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  367352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367377 */     // (intrinsic_wo_chain:{ *:[i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  367380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367384 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367394 */     GIR_RootConstrainSelectedInstOperands,
     /*  367395 */     // GIR_Coverage, 23293,
     /*  367395 */     GIR_EraseRootFromParent_Done,
     /*  367396 */   // Label 6637: @367396
     /*  367396 */   GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(367459), // Rule ID 23296 //
     /*  367401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  367415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367440 */     // (intrinsic_wo_chain:{ *:[i64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  367443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367447 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367457 */     GIR_RootConstrainSelectedInstOperands,
     /*  367458 */     // GIR_Coverage, 23296,
     /*  367458 */     GIR_EraseRootFromParent_Done,
     /*  367459 */   // Label 6638: @367459
     /*  367459 */   GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(367522), // Rule ID 23297 //
     /*  367464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  367478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367503 */     // (intrinsic_wo_chain:{ *:[i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  367506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367510 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367520 */     GIR_RootConstrainSelectedInstOperands,
     /*  367521 */     // GIR_Coverage, 23297,
     /*  367521 */     GIR_EraseRootFromParent_Done,
     /*  367522 */   // Label 6639: @367522
     /*  367522 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(367585), // Rule ID 23300 //
     /*  367527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  367541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  367544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367566 */     // (intrinsic_wo_chain:{ *:[i64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  367569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367573 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367583 */     GIR_RootConstrainSelectedInstOperands,
     /*  367584 */     // GIR_Coverage, 23300,
     /*  367584 */     GIR_EraseRootFromParent_Done,
     /*  367585 */   // Label 6640: @367585
     /*  367585 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(367648), // Rule ID 23301 //
     /*  367590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  367604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  367607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367629 */     // (intrinsic_wo_chain:{ *:[i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  367632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367636 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367646 */     GIR_RootConstrainSelectedInstOperands,
     /*  367647 */     // GIR_Coverage, 23301,
     /*  367647 */     GIR_EraseRootFromParent_Done,
     /*  367648 */   // Label 6641: @367648
     /*  367648 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(367711), // Rule ID 23304 //
     /*  367653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  367667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  367670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367692 */     // (intrinsic_wo_chain:{ *:[i64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  367695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367699 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367709 */     GIR_RootConstrainSelectedInstOperands,
     /*  367710 */     // GIR_Coverage, 23304,
     /*  367710 */     GIR_EraseRootFromParent_Done,
     /*  367711 */   // Label 6642: @367711
     /*  367711 */   GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(367774), // Rule ID 23305 //
     /*  367716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  367730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  367733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367755 */     // (intrinsic_wo_chain:{ *:[i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  367758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367762 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367772 */     GIR_RootConstrainSelectedInstOperands,
     /*  367773 */     // GIR_Coverage, 23305,
     /*  367773 */     GIR_EraseRootFromParent_Done,
     /*  367774 */   // Label 6643: @367774
     /*  367774 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(367837), // Rule ID 23308 //
     /*  367779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  367787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  367793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  367796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367818 */     // (intrinsic_wo_chain:{ *:[i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  367821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367825 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367835 */     GIR_RootConstrainSelectedInstOperands,
     /*  367836 */     // GIR_Coverage, 23308,
     /*  367836 */     GIR_EraseRootFromParent_Done,
     /*  367837 */   // Label 6644: @367837
     /*  367837 */   GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(367900), // Rule ID 23309 //
     /*  367842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  367850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  367856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  367859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367881 */     // (intrinsic_wo_chain:{ *:[i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  367884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367888 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367898 */     GIR_RootConstrainSelectedInstOperands,
     /*  367899 */     // GIR_Coverage, 23309,
     /*  367899 */     GIR_EraseRootFromParent_Done,
     /*  367900 */   // Label 6645: @367900
     /*  367900 */   GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(367963), // Rule ID 23312 //
     /*  367905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  367913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  367919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367944 */     // (intrinsic_wo_chain:{ *:[i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  367947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367951 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367961 */     GIR_RootConstrainSelectedInstOperands,
     /*  367962 */     // GIR_Coverage, 23312,
     /*  367962 */     GIR_EraseRootFromParent_Done,
     /*  367963 */   // Label 6646: @367963
     /*  367963 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(368026), // Rule ID 23313 //
     /*  367968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  367976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  367982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368007 */     // (intrinsic_wo_chain:{ *:[i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  368007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  368010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368014 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368024 */     GIR_RootConstrainSelectedInstOperands,
     /*  368025 */     // GIR_Coverage, 23313,
     /*  368025 */     GIR_EraseRootFromParent_Done,
     /*  368026 */   // Label 6647: @368026
     /*  368026 */   GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(368089), // Rule ID 23316 //
     /*  368031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  368034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  368042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  368045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  368048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368070 */     // (intrinsic_wo_chain:{ *:[i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  368070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  368073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368077 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368087 */     GIR_RootConstrainSelectedInstOperands,
     /*  368088 */     // GIR_Coverage, 23316,
     /*  368088 */     GIR_EraseRootFromParent_Done,
     /*  368089 */   // Label 6648: @368089
     /*  368089 */   GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(368152), // Rule ID 23317 //
     /*  368094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  368097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  368105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  368108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  368111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368133 */     // (intrinsic_wo_chain:{ *:[i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  368133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  368136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368140 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368150 */     GIR_RootConstrainSelectedInstOperands,
     /*  368151 */     // GIR_Coverage, 23317,
     /*  368151 */     GIR_EraseRootFromParent_Done,
     /*  368152 */   // Label 6649: @368152
     /*  368152 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(368215), // Rule ID 23320 //
     /*  368157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  368160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  368168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  368171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  368174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368196 */     // (intrinsic_wo_chain:{ *:[i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  368196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  368199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368203 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368213 */     GIR_RootConstrainSelectedInstOperands,
     /*  368214 */     // GIR_Coverage, 23320,
     /*  368214 */     GIR_EraseRootFromParent_Done,
     /*  368215 */   // Label 6650: @368215
     /*  368215 */   GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(368278), // Rule ID 23321 //
     /*  368220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  368223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  368231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  368234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  368237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368259 */     // (intrinsic_wo_chain:{ *:[i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  368259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  368262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368266 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368276 */     GIR_RootConstrainSelectedInstOperands,
     /*  368277 */     // GIR_Coverage, 23321,
     /*  368277 */     GIR_EraseRootFromParent_Done,
     /*  368278 */   // Label 6651: @368278
     /*  368278 */   GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(368341), // Rule ID 23324 //
     /*  368283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  368286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  368294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  368297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  368300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368322 */     // (intrinsic_wo_chain:{ *:[i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  368322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  368325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368329 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368339 */     GIR_RootConstrainSelectedInstOperands,
     /*  368340 */     // GIR_Coverage, 23324,
     /*  368340 */     GIR_EraseRootFromParent_Done,
     /*  368341 */   // Label 6652: @368341
     /*  368341 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(368404), // Rule ID 23325 //
     /*  368346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  368349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  368357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  368360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  368363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368385 */     // (intrinsic_wo_chain:{ *:[i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  368385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  368388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368392 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368402 */     GIR_RootConstrainSelectedInstOperands,
     /*  368403 */     // GIR_Coverage, 23325,
     /*  368403 */     GIR_EraseRootFromParent_Done,
     /*  368404 */   // Label 6653: @368404
     /*  368404 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(368467), // Rule ID 23328 //
     /*  368409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  368412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  368420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  368423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  368426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368448 */     // (intrinsic_wo_chain:{ *:[i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  368448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  368451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368455 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368465 */     GIR_RootConstrainSelectedInstOperands,
     /*  368466 */     // GIR_Coverage, 23328,
     /*  368466 */     GIR_EraseRootFromParent_Done,
     /*  368467 */   // Label 6654: @368467
     /*  368467 */   GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(368530), // Rule ID 23329 //
     /*  368472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  368475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  368483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  368486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  368489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368511 */     // (intrinsic_wo_chain:{ *:[i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  368511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  368514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368518 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368528 */     GIR_RootConstrainSelectedInstOperands,
     /*  368529 */     // GIR_Coverage, 23329,
     /*  368529 */     GIR_EraseRootFromParent_Done,
     /*  368530 */   // Label 6655: @368530
     /*  368530 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(368593), // Rule ID 23332 //
     /*  368535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  368538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  368546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  368549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  368552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368574 */     // (intrinsic_wo_chain:{ *:[i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  368574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  368577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368581 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368591 */     GIR_RootConstrainSelectedInstOperands,
     /*  368592 */     // GIR_Coverage, 23332,
     /*  368592 */     GIR_EraseRootFromParent_Done,
     /*  368593 */   // Label 6656: @368593
     /*  368593 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(368656), // Rule ID 23333 //
     /*  368598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  368601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  368609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  368612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  368615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368637 */     // (intrinsic_wo_chain:{ *:[i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  368637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  368640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368644 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368654 */     GIR_RootConstrainSelectedInstOperands,
     /*  368655 */     // GIR_Coverage, 23333,
     /*  368655 */     GIR_EraseRootFromParent_Done,
     /*  368656 */   // Label 6657: @368656
     /*  368656 */   GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(368722), // Rule ID 23414 //
     /*  368661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  368664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  368669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  368672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  368675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  368678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368700 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  368703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368720 */     GIR_RootConstrainSelectedInstOperands,
     /*  368721 */     // GIR_Coverage, 23414,
     /*  368721 */     GIR_EraseRootFromParent_Done,
     /*  368722 */   // Label 6658: @368722
     /*  368722 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(368788), // Rule ID 23415 //
     /*  368727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  368730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  368735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  368738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  368741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  368744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368766 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  368769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368786 */     GIR_RootConstrainSelectedInstOperands,
     /*  368787 */     // GIR_Coverage, 23415,
     /*  368787 */     GIR_EraseRootFromParent_Done,
     /*  368788 */   // Label 6659: @368788
     /*  368788 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(368854), // Rule ID 23418 //
     /*  368793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  368796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  368801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  368804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  368807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  368810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368832 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  368835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368852 */     GIR_RootConstrainSelectedInstOperands,
     /*  368853 */     // GIR_Coverage, 23418,
     /*  368853 */     GIR_EraseRootFromParent_Done,
     /*  368854 */   // Label 6660: @368854
     /*  368854 */   GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(368920), // Rule ID 23419 //
     /*  368859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  368862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  368867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  368870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  368873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  368876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368898 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  368901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368918 */     GIR_RootConstrainSelectedInstOperands,
     /*  368919 */     // GIR_Coverage, 23419,
     /*  368919 */     GIR_EraseRootFromParent_Done,
     /*  368920 */   // Label 6661: @368920
     /*  368920 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(368986), // Rule ID 23422 //
     /*  368925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  368928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  368933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  368936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  368939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  368942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368964 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  368967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368984 */     GIR_RootConstrainSelectedInstOperands,
     /*  368985 */     // GIR_Coverage, 23422,
     /*  368985 */     GIR_EraseRootFromParent_Done,
     /*  368986 */   // Label 6662: @368986
     /*  368986 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(369052), // Rule ID 23423 //
     /*  368991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  368994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  368999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  369002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  369005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  369008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369030 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  369033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369050 */     GIR_RootConstrainSelectedInstOperands,
     /*  369051 */     // GIR_Coverage, 23423,
     /*  369051 */     GIR_EraseRootFromParent_Done,
     /*  369052 */   // Label 6663: @369052
     /*  369052 */   GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(369118), // Rule ID 23426 //
     /*  369057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  369068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  369071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  369074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  369099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369116 */     GIR_RootConstrainSelectedInstOperands,
     /*  369117 */     // GIR_Coverage, 23426,
     /*  369117 */     GIR_EraseRootFromParent_Done,
     /*  369118 */   // Label 6664: @369118
     /*  369118 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(369184), // Rule ID 23427 //
     /*  369123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  369134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  369137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  369140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369162 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  369165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369182 */     GIR_RootConstrainSelectedInstOperands,
     /*  369183 */     // GIR_Coverage, 23427,
     /*  369183 */     GIR_EraseRootFromParent_Done,
     /*  369184 */   // Label 6665: @369184
     /*  369184 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(369250), // Rule ID 23430 //
     /*  369189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  369200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  369203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  369206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369228 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  369228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  369231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369248 */     GIR_RootConstrainSelectedInstOperands,
     /*  369249 */     // GIR_Coverage, 23430,
     /*  369249 */     GIR_EraseRootFromParent_Done,
     /*  369250 */   // Label 6666: @369250
     /*  369250 */   GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(369316), // Rule ID 23431 //
     /*  369255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  369266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  369269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  369272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  369294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  369297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369314 */     GIR_RootConstrainSelectedInstOperands,
     /*  369315 */     // GIR_Coverage, 23431,
     /*  369315 */     GIR_EraseRootFromParent_Done,
     /*  369316 */   // Label 6667: @369316
     /*  369316 */   GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(369382), // Rule ID 23434 //
     /*  369321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  369332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  369335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  369338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11300:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369380 */     GIR_RootConstrainSelectedInstOperands,
     /*  369381 */     // GIR_Coverage, 23434,
     /*  369381 */     GIR_EraseRootFromParent_Done,
     /*  369382 */   // Label 6668: @369382
     /*  369382 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(369448), // Rule ID 23435 //
     /*  369387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  369398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  369401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  369404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11300:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369446 */     GIR_RootConstrainSelectedInstOperands,
     /*  369447 */     // GIR_Coverage, 23435,
     /*  369447 */     GIR_EraseRootFromParent_Done,
     /*  369448 */   // Label 6669: @369448
     /*  369448 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(369514), // Rule ID 23438 //
     /*  369453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  369464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  369467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  369470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369492 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369512 */     GIR_RootConstrainSelectedInstOperands,
     /*  369513 */     // GIR_Coverage, 23438,
     /*  369513 */     GIR_EraseRootFromParent_Done,
     /*  369514 */   // Label 6670: @369514
     /*  369514 */   GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(369580), // Rule ID 23439 //
     /*  369519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  369530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  369533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  369536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369578 */     GIR_RootConstrainSelectedInstOperands,
     /*  369579 */     // GIR_Coverage, 23439,
     /*  369579 */     GIR_EraseRootFromParent_Done,
     /*  369580 */   // Label 6671: @369580
     /*  369580 */   GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(369646), // Rule ID 23442 //
     /*  369585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  369596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  369599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  369602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  369624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369644 */     GIR_RootConstrainSelectedInstOperands,
     /*  369645 */     // GIR_Coverage, 23442,
     /*  369645 */     GIR_EraseRootFromParent_Done,
     /*  369646 */   // Label 6672: @369646
     /*  369646 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(369712), // Rule ID 23443 //
     /*  369651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  369662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  369665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  369668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  369690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369710 */     GIR_RootConstrainSelectedInstOperands,
     /*  369711 */     // GIR_Coverage, 23443,
     /*  369711 */     GIR_EraseRootFromParent_Done,
     /*  369712 */   // Label 6673: @369712
     /*  369712 */   GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(369778), // Rule ID 23446 //
     /*  369717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  369720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  369728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  369731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  369734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369756 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  369756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369776 */     GIR_RootConstrainSelectedInstOperands,
     /*  369777 */     // GIR_Coverage, 23446,
     /*  369777 */     GIR_EraseRootFromParent_Done,
     /*  369778 */   // Label 6674: @369778
     /*  369778 */   GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(369844), // Rule ID 23447 //
     /*  369783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  369786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  369794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  369797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  369800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369822 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  369822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369842 */     GIR_RootConstrainSelectedInstOperands,
     /*  369843 */     // GIR_Coverage, 23447,
     /*  369843 */     GIR_EraseRootFromParent_Done,
     /*  369844 */   // Label 6675: @369844
     /*  369844 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(369910), // Rule ID 23450 //
     /*  369849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  369860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  369863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  369866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369888 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  369891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369908 */     GIR_RootConstrainSelectedInstOperands,
     /*  369909 */     // GIR_Coverage, 23450,
     /*  369909 */     GIR_EraseRootFromParent_Done,
     /*  369910 */   // Label 6676: @369910
     /*  369910 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(369976), // Rule ID 23451 //
     /*  369915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  369926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  369929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  369932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369954 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  369957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369974 */     GIR_RootConstrainSelectedInstOperands,
     /*  369975 */     // GIR_Coverage, 23451,
     /*  369975 */     GIR_EraseRootFromParent_Done,
     /*  369976 */   // Label 6677: @369976
     /*  369976 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(370042), // Rule ID 23454 //
     /*  369981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  369992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  369995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  369998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370020 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  370023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370040 */     GIR_RootConstrainSelectedInstOperands,
     /*  370041 */     // GIR_Coverage, 23454,
     /*  370041 */     GIR_EraseRootFromParent_Done,
     /*  370042 */   // Label 6678: @370042
     /*  370042 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(370108), // Rule ID 23455 //
     /*  370047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  370058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  370061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  370064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370086 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  370089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370106 */     GIR_RootConstrainSelectedInstOperands,
     /*  370107 */     // GIR_Coverage, 23455,
     /*  370107 */     GIR_EraseRootFromParent_Done,
     /*  370108 */   // Label 6679: @370108
     /*  370108 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(370174), // Rule ID 23458 //
     /*  370113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  370124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  370127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  370130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370152 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  370155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370172 */     GIR_RootConstrainSelectedInstOperands,
     /*  370173 */     // GIR_Coverage, 23458,
     /*  370173 */     GIR_EraseRootFromParent_Done,
     /*  370174 */   // Label 6680: @370174
     /*  370174 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(370240), // Rule ID 23459 //
     /*  370179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  370190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  370193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  370196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370218 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  370221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370238 */     GIR_RootConstrainSelectedInstOperands,
     /*  370239 */     // GIR_Coverage, 23459,
     /*  370239 */     GIR_EraseRootFromParent_Done,
     /*  370240 */   // Label 6681: @370240
     /*  370240 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(370306), // Rule ID 23462 //
     /*  370245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  370256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  370259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  370262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370284 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  370287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370304 */     GIR_RootConstrainSelectedInstOperands,
     /*  370305 */     // GIR_Coverage, 23462,
     /*  370305 */     GIR_EraseRootFromParent_Done,
     /*  370306 */   // Label 6682: @370306
     /*  370306 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(370372), // Rule ID 23463 //
     /*  370311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  370322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  370325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  370328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  370353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370370 */     GIR_RootConstrainSelectedInstOperands,
     /*  370371 */     // GIR_Coverage, 23463,
     /*  370371 */     GIR_EraseRootFromParent_Done,
     /*  370372 */   // Label 6683: @370372
     /*  370372 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(370438), // Rule ID 23466 //
     /*  370377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  370388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  370391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  370394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370416 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  370419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370436 */     GIR_RootConstrainSelectedInstOperands,
     /*  370437 */     // GIR_Coverage, 23466,
     /*  370437 */     GIR_EraseRootFromParent_Done,
     /*  370438 */   // Label 6684: @370438
     /*  370438 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(370504), // Rule ID 23467 //
     /*  370443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  370454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  370457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  370460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370482 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  370485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370502 */     GIR_RootConstrainSelectedInstOperands,
     /*  370503 */     // GIR_Coverage, 23467,
     /*  370503 */     GIR_EraseRootFromParent_Done,
     /*  370504 */   // Label 6685: @370504
     /*  370504 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(370570), // Rule ID 23470 //
     /*  370509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  370520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  370523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  370526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370548 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  370551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370568 */     GIR_RootConstrainSelectedInstOperands,
     /*  370569 */     // GIR_Coverage, 23470,
     /*  370569 */     GIR_EraseRootFromParent_Done,
     /*  370570 */   // Label 6686: @370570
     /*  370570 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(370636), // Rule ID 23471 //
     /*  370575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  370586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  370589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  370592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  370617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370634 */     GIR_RootConstrainSelectedInstOperands,
     /*  370635 */     // GIR_Coverage, 23471,
     /*  370635 */     GIR_EraseRootFromParent_Done,
     /*  370636 */   // Label 6687: @370636
     /*  370636 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(370702), // Rule ID 23474 //
     /*  370641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  370652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  370655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  370658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  370683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370700 */     GIR_RootConstrainSelectedInstOperands,
     /*  370701 */     // GIR_Coverage, 23474,
     /*  370701 */     GIR_EraseRootFromParent_Done,
     /*  370702 */   // Label 6688: @370702
     /*  370702 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(370768), // Rule ID 23475 //
     /*  370707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  370718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  370721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  370724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370746 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  370749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370766 */     GIR_RootConstrainSelectedInstOperands,
     /*  370767 */     // GIR_Coverage, 23475,
     /*  370767 */     GIR_EraseRootFromParent_Done,
     /*  370768 */   // Label 6689: @370768
     /*  370768 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(370834), // Rule ID 23478 //
     /*  370773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  370784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  370787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  370790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370812 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  370815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370832 */     GIR_RootConstrainSelectedInstOperands,
     /*  370833 */     // GIR_Coverage, 23478,
     /*  370833 */     GIR_EraseRootFromParent_Done,
     /*  370834 */   // Label 6690: @370834
     /*  370834 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(370900), // Rule ID 23479 //
     /*  370839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  370850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  370853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  370856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  370881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370898 */     GIR_RootConstrainSelectedInstOperands,
     /*  370899 */     // GIR_Coverage, 23479,
     /*  370899 */     GIR_EraseRootFromParent_Done,
     /*  370900 */   // Label 6691: @370900
     /*  370900 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(370966), // Rule ID 23482 //
     /*  370905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  370916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  370919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  370922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370944 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  370947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370964 */     GIR_RootConstrainSelectedInstOperands,
     /*  370965 */     // GIR_Coverage, 23482,
     /*  370965 */     GIR_EraseRootFromParent_Done,
     /*  370966 */   // Label 6692: @370966
     /*  370966 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(371032), // Rule ID 23483 //
     /*  370971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  370982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  370985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  370988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371010 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  371010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  371013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371030 */     GIR_RootConstrainSelectedInstOperands,
     /*  371031 */     // GIR_Coverage, 23483,
     /*  371031 */     GIR_EraseRootFromParent_Done,
     /*  371032 */   // Label 6693: @371032
     /*  371032 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(371098), // Rule ID 23486 //
     /*  371037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  371040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  371045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  371048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  371051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  371054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  371076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  371079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371096 */     GIR_RootConstrainSelectedInstOperands,
     /*  371097 */     // GIR_Coverage, 23486,
     /*  371097 */     GIR_EraseRootFromParent_Done,
     /*  371098 */   // Label 6694: @371098
     /*  371098 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(371164), // Rule ID 23487 //
     /*  371103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  371106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  371111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  371114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  371117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  371120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371142 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  371142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  371145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371162 */     GIR_RootConstrainSelectedInstOperands,
     /*  371163 */     // GIR_Coverage, 23487,
     /*  371163 */     GIR_EraseRootFromParent_Done,
     /*  371164 */   // Label 6695: @371164
     /*  371164 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(371230), // Rule ID 23490 //
     /*  371169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  371172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  371177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  371180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  371183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  371186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371208 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  371208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  371211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371228 */     GIR_RootConstrainSelectedInstOperands,
     /*  371229 */     // GIR_Coverage, 23490,
     /*  371229 */     GIR_EraseRootFromParent_Done,
     /*  371230 */   // Label 6696: @371230
     /*  371230 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(371296), // Rule ID 23491 //
     /*  371235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  371238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  371243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  371246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  371249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  371252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371274 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  371274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  371277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371294 */     GIR_RootConstrainSelectedInstOperands,
     /*  371295 */     // GIR_Coverage, 23491,
     /*  371295 */     GIR_EraseRootFromParent_Done,
     /*  371296 */   // Label 6697: @371296
     /*  371296 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(371362), // Rule ID 23494 //
     /*  371301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  371304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  371309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  371312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  371315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  371318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371340 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  371340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  371343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371360 */     GIR_RootConstrainSelectedInstOperands,
     /*  371361 */     // GIR_Coverage, 23494,
     /*  371361 */     GIR_EraseRootFromParent_Done,
     /*  371362 */   // Label 6698: @371362
     /*  371362 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(371428), // Rule ID 23495 //
     /*  371367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  371370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  371375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  371378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  371381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  371384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371406 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  371406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  371409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371426 */     GIR_RootConstrainSelectedInstOperands,
     /*  371427 */     // GIR_Coverage, 23495,
     /*  371427 */     GIR_EraseRootFromParent_Done,
     /*  371428 */   // Label 6699: @371428
     /*  371428 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(371494), // Rule ID 60610 //
     /*  371433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  371444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  371447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  371450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371472 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  371475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371492 */     GIR_RootConstrainSelectedInstOperands,
     /*  371493 */     // GIR_Coverage, 60610,
     /*  371493 */     GIR_EraseRootFromParent_Done,
     /*  371494 */   // Label 6700: @371494
     /*  371494 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(371560), // Rule ID 60611 //
     /*  371499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  371510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  371513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  371516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371538 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  371541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371558 */     GIR_RootConstrainSelectedInstOperands,
     /*  371559 */     // GIR_Coverage, 60611,
     /*  371559 */     GIR_EraseRootFromParent_Done,
     /*  371560 */   // Label 6701: @371560
     /*  371560 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(371626), // Rule ID 60614 //
     /*  371565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  371576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  371579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  371582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371604 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  371607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371624 */     GIR_RootConstrainSelectedInstOperands,
     /*  371625 */     // GIR_Coverage, 60614,
     /*  371625 */     GIR_EraseRootFromParent_Done,
     /*  371626 */   // Label 6702: @371626
     /*  371626 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(371692), // Rule ID 60615 //
     /*  371631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  371642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  371645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  371648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371670 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  371673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371690 */     GIR_RootConstrainSelectedInstOperands,
     /*  371691 */     // GIR_Coverage, 60615,
     /*  371691 */     GIR_EraseRootFromParent_Done,
     /*  371692 */   // Label 6703: @371692
     /*  371692 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(371758), // Rule ID 60618 //
     /*  371697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  371708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  371711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  371714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371736 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  371739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371756 */     GIR_RootConstrainSelectedInstOperands,
     /*  371757 */     // GIR_Coverage, 60618,
     /*  371757 */     GIR_EraseRootFromParent_Done,
     /*  371758 */   // Label 6704: @371758
     /*  371758 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(371824), // Rule ID 60619 //
     /*  371763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  371774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  371777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  371780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371802 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  371805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371822 */     GIR_RootConstrainSelectedInstOperands,
     /*  371823 */     // GIR_Coverage, 60619,
     /*  371823 */     GIR_EraseRootFromParent_Done,
     /*  371824 */   // Label 6705: @371824
     /*  371824 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(371890), // Rule ID 60622 //
     /*  371829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  371840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  371843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  371846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  371871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371888 */     GIR_RootConstrainSelectedInstOperands,
     /*  371889 */     // GIR_Coverage, 60622,
     /*  371889 */     GIR_EraseRootFromParent_Done,
     /*  371890 */   // Label 6706: @371890
     /*  371890 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(371956), // Rule ID 60623 //
     /*  371895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  371906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  371909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  371912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371934 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  371937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371954 */     GIR_RootConstrainSelectedInstOperands,
     /*  371955 */     // GIR_Coverage, 60623,
     /*  371955 */     GIR_EraseRootFromParent_Done,
     /*  371956 */   // Label 6707: @371956
     /*  371956 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(372022), // Rule ID 60626 //
     /*  371961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  371972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  371975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  371978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372000 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  372003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372020 */     GIR_RootConstrainSelectedInstOperands,
     /*  372021 */     // GIR_Coverage, 60626,
     /*  372021 */     GIR_EraseRootFromParent_Done,
     /*  372022 */   // Label 6708: @372022
     /*  372022 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(372088), // Rule ID 60627 //
     /*  372027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  372038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  372041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  372044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372066 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  372069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372086 */     GIR_RootConstrainSelectedInstOperands,
     /*  372087 */     // GIR_Coverage, 60627,
     /*  372087 */     GIR_EraseRootFromParent_Done,
     /*  372088 */   // Label 6709: @372088
     /*  372088 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(372154), // Rule ID 60630 //
     /*  372093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  372104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  372107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  372110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  372135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372152 */     GIR_RootConstrainSelectedInstOperands,
     /*  372153 */     // GIR_Coverage, 60630,
     /*  372153 */     GIR_EraseRootFromParent_Done,
     /*  372154 */   // Label 6710: @372154
     /*  372154 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(372220), // Rule ID 60631 //
     /*  372159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  372170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  372173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  372176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372198 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  372201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372218 */     GIR_RootConstrainSelectedInstOperands,
     /*  372219 */     // GIR_Coverage, 60631,
     /*  372219 */     GIR_EraseRootFromParent_Done,
     /*  372220 */   // Label 6711: @372220
     /*  372220 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(372286), // Rule ID 60634 //
     /*  372225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  372236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  372239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  372242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372264 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372284 */     GIR_RootConstrainSelectedInstOperands,
     /*  372285 */     // GIR_Coverage, 60634,
     /*  372285 */     GIR_EraseRootFromParent_Done,
     /*  372286 */   // Label 6712: @372286
     /*  372286 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(372352), // Rule ID 60635 //
     /*  372291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  372302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  372305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  372308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372330 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372350 */     GIR_RootConstrainSelectedInstOperands,
     /*  372351 */     // GIR_Coverage, 60635,
     /*  372351 */     GIR_EraseRootFromParent_Done,
     /*  372352 */   // Label 6713: @372352
     /*  372352 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(372418), // Rule ID 60638 //
     /*  372357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  372368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  372371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  372374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372396 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372416 */     GIR_RootConstrainSelectedInstOperands,
     /*  372417 */     // GIR_Coverage, 60638,
     /*  372417 */     GIR_EraseRootFromParent_Done,
     /*  372418 */   // Label 6714: @372418
     /*  372418 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(372484), // Rule ID 60639 //
     /*  372423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  372434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  372437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  372440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372462 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372482 */     GIR_RootConstrainSelectedInstOperands,
     /*  372483 */     // GIR_Coverage, 60639,
     /*  372483 */     GIR_EraseRootFromParent_Done,
     /*  372484 */   // Label 6715: @372484
     /*  372484 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(372550), // Rule ID 60642 //
     /*  372489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  372500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  372503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  372506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372548 */     GIR_RootConstrainSelectedInstOperands,
     /*  372549 */     // GIR_Coverage, 60642,
     /*  372549 */     GIR_EraseRootFromParent_Done,
     /*  372550 */   // Label 6716: @372550
     /*  372550 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(372616), // Rule ID 60643 //
     /*  372555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  372566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  372569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  372572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372594 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372614 */     GIR_RootConstrainSelectedInstOperands,
     /*  372615 */     // GIR_Coverage, 60643,
     /*  372615 */     GIR_EraseRootFromParent_Done,
     /*  372616 */   // Label 6717: @372616
     /*  372616 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(372682), // Rule ID 60646 //
     /*  372621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  372632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  372635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  372638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372660 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  372660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372680 */     GIR_RootConstrainSelectedInstOperands,
     /*  372681 */     // GIR_Coverage, 60646,
     /*  372681 */     GIR_EraseRootFromParent_Done,
     /*  372682 */   // Label 6718: @372682
     /*  372682 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(372748), // Rule ID 60647 //
     /*  372687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  372698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  372701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  372704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372726 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  372726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372746 */     GIR_RootConstrainSelectedInstOperands,
     /*  372747 */     // GIR_Coverage, 60647,
     /*  372747 */     GIR_EraseRootFromParent_Done,
     /*  372748 */   // Label 6719: @372748
     /*  372748 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(372814), // Rule ID 60650 //
     /*  372753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  372764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  372767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  372770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372792 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  372795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372812 */     GIR_RootConstrainSelectedInstOperands,
     /*  372813 */     // GIR_Coverage, 60650,
     /*  372813 */     GIR_EraseRootFromParent_Done,
     /*  372814 */   // Label 6720: @372814
     /*  372814 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(372880), // Rule ID 60651 //
     /*  372819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  372830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  372833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  372836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  372861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372878 */     GIR_RootConstrainSelectedInstOperands,
     /*  372879 */     // GIR_Coverage, 60651,
     /*  372879 */     GIR_EraseRootFromParent_Done,
     /*  372880 */   // Label 6721: @372880
     /*  372880 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(372946), // Rule ID 60654 //
     /*  372885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  372896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  372899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  372902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372924 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  372927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372944 */     GIR_RootConstrainSelectedInstOperands,
     /*  372945 */     // GIR_Coverage, 60654,
     /*  372945 */     GIR_EraseRootFromParent_Done,
     /*  372946 */   // Label 6722: @372946
     /*  372946 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(373012), // Rule ID 60655 //
     /*  372951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  372962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  372965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  372968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372990 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  372993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373010 */     GIR_RootConstrainSelectedInstOperands,
     /*  373011 */     // GIR_Coverage, 60655,
     /*  373011 */     GIR_EraseRootFromParent_Done,
     /*  373012 */   // Label 6723: @373012
     /*  373012 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(373078), // Rule ID 60658 //
     /*  373017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  373028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  373031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  373034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373056 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  373059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373076 */     GIR_RootConstrainSelectedInstOperands,
     /*  373077 */     // GIR_Coverage, 60658,
     /*  373077 */     GIR_EraseRootFromParent_Done,
     /*  373078 */   // Label 6724: @373078
     /*  373078 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(373144), // Rule ID 60659 //
     /*  373083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  373094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  373097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  373100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373122 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  373125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373142 */     GIR_RootConstrainSelectedInstOperands,
     /*  373143 */     // GIR_Coverage, 60659,
     /*  373143 */     GIR_EraseRootFromParent_Done,
     /*  373144 */   // Label 6725: @373144
     /*  373144 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(373210), // Rule ID 60662 //
     /*  373149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  373160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  373163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  373166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  373191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373208 */     GIR_RootConstrainSelectedInstOperands,
     /*  373209 */     // GIR_Coverage, 60662,
     /*  373209 */     GIR_EraseRootFromParent_Done,
     /*  373210 */   // Label 6726: @373210
     /*  373210 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(373276), // Rule ID 60663 //
     /*  373215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  373226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  373229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  373232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373254 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  373257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373274 */     GIR_RootConstrainSelectedInstOperands,
     /*  373275 */     // GIR_Coverage, 60663,
     /*  373275 */     GIR_EraseRootFromParent_Done,
     /*  373276 */   // Label 6727: @373276
     /*  373276 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(373342), // Rule ID 60666 //
     /*  373281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  373292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  373295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  373298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373320 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  373323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373340 */     GIR_RootConstrainSelectedInstOperands,
     /*  373341 */     // GIR_Coverage, 60666,
     /*  373341 */     GIR_EraseRootFromParent_Done,
     /*  373342 */   // Label 6728: @373342
     /*  373342 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(373408), // Rule ID 60667 //
     /*  373347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  373358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  373361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  373364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373386 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  373389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373406 */     GIR_RootConstrainSelectedInstOperands,
     /*  373407 */     // GIR_Coverage, 60667,
     /*  373407 */     GIR_EraseRootFromParent_Done,
     /*  373408 */   // Label 6729: @373408
     /*  373408 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(373474), // Rule ID 60670 //
     /*  373413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  373424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  373427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  373430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373452 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  373455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373472 */     GIR_RootConstrainSelectedInstOperands,
     /*  373473 */     // GIR_Coverage, 60670,
     /*  373473 */     GIR_EraseRootFromParent_Done,
     /*  373474 */   // Label 6730: @373474
     /*  373474 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(373540), // Rule ID 60671 //
     /*  373479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  373490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  373493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  373496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373518 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  373521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373538 */     GIR_RootConstrainSelectedInstOperands,
     /*  373539 */     // GIR_Coverage, 60671,
     /*  373539 */     GIR_EraseRootFromParent_Done,
     /*  373540 */   // Label 6731: @373540
     /*  373540 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(373606), // Rule ID 60674 //
     /*  373545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  373556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  373559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  373562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373584 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  373587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373604 */     GIR_RootConstrainSelectedInstOperands,
     /*  373605 */     // GIR_Coverage, 60674,
     /*  373605 */     GIR_EraseRootFromParent_Done,
     /*  373606 */   // Label 6732: @373606
     /*  373606 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(373672), // Rule ID 60675 //
     /*  373611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  373622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  373625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  373628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  373650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  373653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373670 */     GIR_RootConstrainSelectedInstOperands,
     /*  373671 */     // GIR_Coverage, 60675,
     /*  373671 */     GIR_EraseRootFromParent_Done,
     /*  373672 */   // Label 6733: @373672
     /*  373672 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(373738), // Rule ID 60678 //
     /*  373677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  373688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  373691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  373694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  373719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373736 */     GIR_RootConstrainSelectedInstOperands,
     /*  373737 */     // GIR_Coverage, 60678,
     /*  373737 */     GIR_EraseRootFromParent_Done,
     /*  373738 */   // Label 6734: @373738
     /*  373738 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(373804), // Rule ID 60679 //
     /*  373743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  373754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  373757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  373760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373782 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  373782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  373785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373802 */     GIR_RootConstrainSelectedInstOperands,
     /*  373803 */     // GIR_Coverage, 60679,
     /*  373803 */     GIR_EraseRootFromParent_Done,
     /*  373804 */   // Label 6735: @373804
     /*  373804 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(373870), // Rule ID 60682 //
     /*  373809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  373820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  373823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  373826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373848 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  373851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373868 */     GIR_RootConstrainSelectedInstOperands,
     /*  373869 */     // GIR_Coverage, 60682,
     /*  373869 */     GIR_EraseRootFromParent_Done,
     /*  373870 */   // Label 6736: @373870
     /*  373870 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(373936), // Rule ID 60683 //
     /*  373875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  373886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  373889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  373892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  373914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  373917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373934 */     GIR_RootConstrainSelectedInstOperands,
     /*  373935 */     // GIR_Coverage, 60683,
     /*  373935 */     GIR_EraseRootFromParent_Done,
     /*  373936 */   // Label 6737: @373936
     /*  373936 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(374002), // Rule ID 60686 //
     /*  373941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  373952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  373955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  373958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373980 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  373983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374000 */     GIR_RootConstrainSelectedInstOperands,
     /*  374001 */     // GIR_Coverage, 60686,
     /*  374001 */     GIR_EraseRootFromParent_Done,
     /*  374002 */   // Label 6738: @374002
     /*  374002 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(374068), // Rule ID 60687 //
     /*  374007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  374015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  374018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  374021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  374024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  374046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  374049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374066 */     GIR_RootConstrainSelectedInstOperands,
     /*  374067 */     // GIR_Coverage, 60687,
     /*  374067 */     GIR_EraseRootFromParent_Done,
     /*  374068 */   // Label 6739: @374068
     /*  374068 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(374134), // Rule ID 60690 //
     /*  374073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  374081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  374084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  374087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  374090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374112 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  374112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  374115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374132 */     GIR_RootConstrainSelectedInstOperands,
     /*  374133 */     // GIR_Coverage, 60690,
     /*  374133 */     GIR_EraseRootFromParent_Done,
     /*  374134 */   // Label 6740: @374134
     /*  374134 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(374200), // Rule ID 60691 //
     /*  374139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  374147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  374150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  374153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  374156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374178 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  374178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  374181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374198 */     GIR_RootConstrainSelectedInstOperands,
     /*  374199 */     // GIR_Coverage, 60691,
     /*  374199 */     GIR_EraseRootFromParent_Done,
     /*  374200 */   // Label 6741: @374200
     /*  374200 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(374266), // Rule ID 60694 //
     /*  374205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  374213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  374216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  374219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  374222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374244 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  374244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  374247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374264 */     GIR_RootConstrainSelectedInstOperands,
     /*  374265 */     // GIR_Coverage, 60694,
     /*  374265 */     GIR_EraseRootFromParent_Done,
     /*  374266 */   // Label 6742: @374266
     /*  374266 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(374332), // Rule ID 60695 //
     /*  374271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  374279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  374282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  374285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  374288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374310 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  374310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  374313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374330 */     GIR_RootConstrainSelectedInstOperands,
     /*  374331 */     // GIR_Coverage, 60695,
     /*  374331 */     GIR_EraseRootFromParent_Done,
     /*  374332 */   // Label 6743: @374332
     /*  374332 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(374398), // Rule ID 60698 //
     /*  374337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  374348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  374351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  374354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374376 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  374379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374396 */     GIR_RootConstrainSelectedInstOperands,
     /*  374397 */     // GIR_Coverage, 60698,
     /*  374397 */     GIR_EraseRootFromParent_Done,
     /*  374398 */   // Label 6744: @374398
     /*  374398 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(374464), // Rule ID 60699 //
     /*  374403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  374414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  374417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  374420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374442 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  374445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374462 */     GIR_RootConstrainSelectedInstOperands,
     /*  374463 */     // GIR_Coverage, 60699,
     /*  374463 */     GIR_EraseRootFromParent_Done,
     /*  374464 */   // Label 6745: @374464
     /*  374464 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(374530), // Rule ID 60702 //
     /*  374469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  374480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  374483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  374486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374508 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  374511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374528 */     GIR_RootConstrainSelectedInstOperands,
     /*  374529 */     // GIR_Coverage, 60702,
     /*  374529 */     GIR_EraseRootFromParent_Done,
     /*  374530 */   // Label 6746: @374530
     /*  374530 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(374596), // Rule ID 60703 //
     /*  374535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  374546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  374549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  374552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374574 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  374577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374594 */     GIR_RootConstrainSelectedInstOperands,
     /*  374595 */     // GIR_Coverage, 60703,
     /*  374595 */     GIR_EraseRootFromParent_Done,
     /*  374596 */   // Label 6747: @374596
     /*  374596 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(374662), // Rule ID 60706 //
     /*  374601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  374612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  374615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  374618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374640 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  374643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374660 */     GIR_RootConstrainSelectedInstOperands,
     /*  374661 */     // GIR_Coverage, 60706,
     /*  374661 */     GIR_EraseRootFromParent_Done,
     /*  374662 */   // Label 6748: @374662
     /*  374662 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(374728), // Rule ID 60707 //
     /*  374667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  374678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  374681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  374684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374706 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  374709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374726 */     GIR_RootConstrainSelectedInstOperands,
     /*  374727 */     // GIR_Coverage, 60707,
     /*  374727 */     GIR_EraseRootFromParent_Done,
     /*  374728 */   // Label 6749: @374728
     /*  374728 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(374794), // Rule ID 60710 //
     /*  374733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  374744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  374747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  374750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374772 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  374775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374792 */     GIR_RootConstrainSelectedInstOperands,
     /*  374793 */     // GIR_Coverage, 60710,
     /*  374793 */     GIR_EraseRootFromParent_Done,
     /*  374794 */   // Label 6750: @374794
     /*  374794 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(374860), // Rule ID 60711 //
     /*  374799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  374810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  374813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  374816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374838 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  374841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374858 */     GIR_RootConstrainSelectedInstOperands,
     /*  374859 */     // GIR_Coverage, 60711,
     /*  374859 */     GIR_EraseRootFromParent_Done,
     /*  374860 */   // Label 6751: @374860
     /*  374860 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(374926), // Rule ID 60714 //
     /*  374865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  374876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  374879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  374882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374904 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  374907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374924 */     GIR_RootConstrainSelectedInstOperands,
     /*  374925 */     // GIR_Coverage, 60714,
     /*  374925 */     GIR_EraseRootFromParent_Done,
     /*  374926 */   // Label 6752: @374926
     /*  374926 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(374992), // Rule ID 60715 //
     /*  374931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  374942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  374945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  374948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374970 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  374973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374990 */     GIR_RootConstrainSelectedInstOperands,
     /*  374991 */     // GIR_Coverage, 60715,
     /*  374991 */     GIR_EraseRootFromParent_Done,
     /*  374992 */   // Label 6753: @374992
     /*  374992 */   GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(375058), // Rule ID 60718 //
     /*  374997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  375008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  375011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  375014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375036 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  375036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  375039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375056 */     GIR_RootConstrainSelectedInstOperands,
     /*  375057 */     // GIR_Coverage, 60718,
     /*  375057 */     GIR_EraseRootFromParent_Done,
     /*  375058 */   // Label 6754: @375058
     /*  375058 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(375124), // Rule ID 60719 //
     /*  375063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  375074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  375077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  375080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375102 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  375105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375122 */     GIR_RootConstrainSelectedInstOperands,
     /*  375123 */     // GIR_Coverage, 60719,
     /*  375123 */     GIR_EraseRootFromParent_Done,
     /*  375124 */   // Label 6755: @375124
     /*  375124 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(375190), // Rule ID 60722 //
     /*  375129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  375140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  375143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  375146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375168 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375188 */     GIR_RootConstrainSelectedInstOperands,
     /*  375189 */     // GIR_Coverage, 60722,
     /*  375189 */     GIR_EraseRootFromParent_Done,
     /*  375190 */   // Label 6756: @375190
     /*  375190 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(375256), // Rule ID 60723 //
     /*  375195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  375206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  375209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  375212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375234 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11149:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375254 */     GIR_RootConstrainSelectedInstOperands,
     /*  375255 */     // GIR_Coverage, 60723,
     /*  375255 */     GIR_EraseRootFromParent_Done,
     /*  375256 */   // Label 6757: @375256
     /*  375256 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(375322), // Rule ID 60726 //
     /*  375261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  375272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  375275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  375278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375320 */     GIR_RootConstrainSelectedInstOperands,
     /*  375321 */     // GIR_Coverage, 60726,
     /*  375321 */     GIR_EraseRootFromParent_Done,
     /*  375322 */   // Label 6758: @375322
     /*  375322 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(375388), // Rule ID 60727 //
     /*  375327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  375338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  375341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  375344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375386 */     GIR_RootConstrainSelectedInstOperands,
     /*  375387 */     // GIR_Coverage, 60727,
     /*  375387 */     GIR_EraseRootFromParent_Done,
     /*  375388 */   // Label 6759: @375388
     /*  375388 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(375454), // Rule ID 60730 //
     /*  375393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  375404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  375407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  375410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  375432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375452 */     GIR_RootConstrainSelectedInstOperands,
     /*  375453 */     // GIR_Coverage, 60730,
     /*  375453 */     GIR_EraseRootFromParent_Done,
     /*  375454 */   // Label 6760: @375454
     /*  375454 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(375520), // Rule ID 60731 //
     /*  375459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  375470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  375473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  375476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375498 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375518 */     GIR_RootConstrainSelectedInstOperands,
     /*  375519 */     // GIR_Coverage, 60731,
     /*  375519 */     GIR_EraseRootFromParent_Done,
     /*  375520 */   // Label 6761: @375520
     /*  375520 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(375586), // Rule ID 60734 //
     /*  375525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  375536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  375539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  375542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375564 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  375564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375584 */     GIR_RootConstrainSelectedInstOperands,
     /*  375585 */     // GIR_Coverage, 60734,
     /*  375585 */     GIR_EraseRootFromParent_Done,
     /*  375586 */   // Label 6762: @375586
     /*  375586 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(375652), // Rule ID 60735 //
     /*  375591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  375602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  375605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  375608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375630 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  375630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375650 */     GIR_RootConstrainSelectedInstOperands,
     /*  375651 */     // GIR_Coverage, 60735,
     /*  375651 */     GIR_EraseRootFromParent_Done,
     /*  375652 */   // Label 6763: @375652
     /*  375652 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(375718), // Rule ID 60738 //
     /*  375657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  375668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  375671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  375674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  375699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375716 */     GIR_RootConstrainSelectedInstOperands,
     /*  375717 */     // GIR_Coverage, 60738,
     /*  375717 */     GIR_EraseRootFromParent_Done,
     /*  375718 */   // Label 6764: @375718
     /*  375718 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(375784), // Rule ID 60739 //
     /*  375723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  375734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  375737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  375740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375762 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  375765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375782 */     GIR_RootConstrainSelectedInstOperands,
     /*  375783 */     // GIR_Coverage, 60739,
     /*  375783 */     GIR_EraseRootFromParent_Done,
     /*  375784 */   // Label 6765: @375784
     /*  375784 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(375850), // Rule ID 60742 //
     /*  375789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  375800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  375803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  375806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375828 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  375831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375848 */     GIR_RootConstrainSelectedInstOperands,
     /*  375849 */     // GIR_Coverage, 60742,
     /*  375849 */     GIR_EraseRootFromParent_Done,
     /*  375850 */   // Label 6766: @375850
     /*  375850 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(375916), // Rule ID 60743 //
     /*  375855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  375866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  375869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  375872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375894 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  375897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375914 */     GIR_RootConstrainSelectedInstOperands,
     /*  375915 */     // GIR_Coverage, 60743,
     /*  375915 */     GIR_EraseRootFromParent_Done,
     /*  375916 */   // Label 6767: @375916
     /*  375916 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(375982), // Rule ID 60746 //
     /*  375921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  375932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  375935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  375938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375960 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  375963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375980 */     GIR_RootConstrainSelectedInstOperands,
     /*  375981 */     // GIR_Coverage, 60746,
     /*  375981 */     GIR_EraseRootFromParent_Done,
     /*  375982 */   // Label 6768: @375982
     /*  375982 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(376048), // Rule ID 60747 //
     /*  375987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  375998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  376001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  376004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376026 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  376029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376046 */     GIR_RootConstrainSelectedInstOperands,
     /*  376047 */     // GIR_Coverage, 60747,
     /*  376047 */     GIR_EraseRootFromParent_Done,
     /*  376048 */   // Label 6769: @376048
     /*  376048 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(376114), // Rule ID 60750 //
     /*  376053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  376064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  376067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  376070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376092 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  376095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376112 */     GIR_RootConstrainSelectedInstOperands,
     /*  376113 */     // GIR_Coverage, 60750,
     /*  376113 */     GIR_EraseRootFromParent_Done,
     /*  376114 */   // Label 6770: @376114
     /*  376114 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(376180), // Rule ID 60751 //
     /*  376119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  376130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  376133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  376136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376158 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  376161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376178 */     GIR_RootConstrainSelectedInstOperands,
     /*  376179 */     // GIR_Coverage, 60751,
     /*  376179 */     GIR_EraseRootFromParent_Done,
     /*  376180 */   // Label 6771: @376180
     /*  376180 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(376246), // Rule ID 60754 //
     /*  376185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  376196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  376199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  376202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376224 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  376227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376244 */     GIR_RootConstrainSelectedInstOperands,
     /*  376245 */     // GIR_Coverage, 60754,
     /*  376245 */     GIR_EraseRootFromParent_Done,
     /*  376246 */   // Label 6772: @376246
     /*  376246 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(376312), // Rule ID 60755 //
     /*  376251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  376262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  376265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  376268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376290 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  376293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376310 */     GIR_RootConstrainSelectedInstOperands,
     /*  376311 */     // GIR_Coverage, 60755,
     /*  376311 */     GIR_EraseRootFromParent_Done,
     /*  376312 */   // Label 6773: @376312
     /*  376312 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(376378), // Rule ID 60758 //
     /*  376317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  376328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  376331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  376334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376356 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  376359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376376 */     GIR_RootConstrainSelectedInstOperands,
     /*  376377 */     // GIR_Coverage, 60758,
     /*  376377 */     GIR_EraseRootFromParent_Done,
     /*  376378 */   // Label 6774: @376378
     /*  376378 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(376444), // Rule ID 60759 //
     /*  376383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  376394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  376397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  376400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376422 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  376425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376442 */     GIR_RootConstrainSelectedInstOperands,
     /*  376443 */     // GIR_Coverage, 60759,
     /*  376443 */     GIR_EraseRootFromParent_Done,
     /*  376444 */   // Label 6775: @376444
     /*  376444 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(376510), // Rule ID 60762 //
     /*  376449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  376460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  376463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  376466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376488 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  376491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376508 */     GIR_RootConstrainSelectedInstOperands,
     /*  376509 */     // GIR_Coverage, 60762,
     /*  376509 */     GIR_EraseRootFromParent_Done,
     /*  376510 */   // Label 6776: @376510
     /*  376510 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(376576), // Rule ID 60763 //
     /*  376515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  376526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  376529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  376532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  376557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376574 */     GIR_RootConstrainSelectedInstOperands,
     /*  376575 */     // GIR_Coverage, 60763,
     /*  376575 */     GIR_EraseRootFromParent_Done,
     /*  376576 */   // Label 6777: @376576
     /*  376576 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(376642), // Rule ID 60766 //
     /*  376581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  376592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  376595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  376598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376620 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  376623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376640 */     GIR_RootConstrainSelectedInstOperands,
     /*  376641 */     // GIR_Coverage, 60766,
     /*  376641 */     GIR_EraseRootFromParent_Done,
     /*  376642 */   // Label 6778: @376642
     /*  376642 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(376708), // Rule ID 60767 //
     /*  376647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  376658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  376661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  376664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  376689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376706 */     GIR_RootConstrainSelectedInstOperands,
     /*  376707 */     // GIR_Coverage, 60767,
     /*  376707 */     GIR_EraseRootFromParent_Done,
     /*  376708 */   // Label 6779: @376708
     /*  376708 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(376774), // Rule ID 60770 //
     /*  376713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  376724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  376727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  376730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  376755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376772 */     GIR_RootConstrainSelectedInstOperands,
     /*  376773 */     // GIR_Coverage, 60770,
     /*  376773 */     GIR_EraseRootFromParent_Done,
     /*  376774 */   // Label 6780: @376774
     /*  376774 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(376840), // Rule ID 60771 //
     /*  376779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  376790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  376793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  376796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376818 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  376821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376838 */     GIR_RootConstrainSelectedInstOperands,
     /*  376839 */     // GIR_Coverage, 60771,
     /*  376839 */     GIR_EraseRootFromParent_Done,
     /*  376840 */   // Label 6781: @376840
     /*  376840 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(376906), // Rule ID 60774 //
     /*  376845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  376856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  376859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  376862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  376884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  376887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376904 */     GIR_RootConstrainSelectedInstOperands,
     /*  376905 */     // GIR_Coverage, 60774,
     /*  376905 */     GIR_EraseRootFromParent_Done,
     /*  376906 */   // Label 6782: @376906
     /*  376906 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(376972), // Rule ID 60775 //
     /*  376911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  376922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  376925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  376928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  376953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376970 */     GIR_RootConstrainSelectedInstOperands,
     /*  376971 */     // GIR_Coverage, 60775,
     /*  376971 */     GIR_EraseRootFromParent_Done,
     /*  376972 */   // Label 6783: @376972
     /*  376972 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(377038), // Rule ID 60778 //
     /*  376977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  376988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  376991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  376994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377016 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  377016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  377019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377036 */     GIR_RootConstrainSelectedInstOperands,
     /*  377037 */     // GIR_Coverage, 60778,
     /*  377037 */     GIR_EraseRootFromParent_Done,
     /*  377038 */   // Label 6784: @377038
     /*  377038 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(377104), // Rule ID 60779 //
     /*  377043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  377051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  377054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  377057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  377060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377082 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  377082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  377085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377102 */     GIR_RootConstrainSelectedInstOperands,
     /*  377103 */     // GIR_Coverage, 60779,
     /*  377103 */     GIR_EraseRootFromParent_Done,
     /*  377104 */   // Label 6785: @377104
     /*  377104 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(377170), // Rule ID 60782 //
     /*  377109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  377117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  377120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  377123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  377126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377148 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  377148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  377151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377168 */     GIR_RootConstrainSelectedInstOperands,
     /*  377169 */     // GIR_Coverage, 60782,
     /*  377169 */     GIR_EraseRootFromParent_Done,
     /*  377170 */   // Label 6786: @377170
     /*  377170 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(377236), // Rule ID 60783 //
     /*  377175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  377183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  377186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  377189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  377192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  377214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  377217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377234 */     GIR_RootConstrainSelectedInstOperands,
     /*  377235 */     // GIR_Coverage, 60783,
     /*  377235 */     GIR_EraseRootFromParent_Done,
     /*  377236 */   // Label 6787: @377236
     /*  377236 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(377302), // Rule ID 60786 //
     /*  377241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  377252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  377255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  377258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377280 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  377283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377300 */     GIR_RootConstrainSelectedInstOperands,
     /*  377301 */     // GIR_Coverage, 60786,
     /*  377301 */     GIR_EraseRootFromParent_Done,
     /*  377302 */   // Label 6788: @377302
     /*  377302 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(377368), // Rule ID 60787 //
     /*  377307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  377318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  377321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  377324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377346 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  377349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377366 */     GIR_RootConstrainSelectedInstOperands,
     /*  377367 */     // GIR_Coverage, 60787,
     /*  377367 */     GIR_EraseRootFromParent_Done,
     /*  377368 */   // Label 6789: @377368
     /*  377368 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(377434), // Rule ID 60790 //
     /*  377373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  377384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  377387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  377390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377412 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  377415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377432 */     GIR_RootConstrainSelectedInstOperands,
     /*  377433 */     // GIR_Coverage, 60790,
     /*  377433 */     GIR_EraseRootFromParent_Done,
     /*  377434 */   // Label 6790: @377434
     /*  377434 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(377500), // Rule ID 60791 //
     /*  377439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  377450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  377453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  377456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377478 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  377481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377498 */     GIR_RootConstrainSelectedInstOperands,
     /*  377499 */     // GIR_Coverage, 60791,
     /*  377499 */     GIR_EraseRootFromParent_Done,
     /*  377500 */   // Label 6791: @377500
     /*  377500 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(377566), // Rule ID 60794 //
     /*  377505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  377516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  377519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  377522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377544 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  377547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377564 */     GIR_RootConstrainSelectedInstOperands,
     /*  377565 */     // GIR_Coverage, 60794,
     /*  377565 */     GIR_EraseRootFromParent_Done,
     /*  377566 */   // Label 6792: @377566
     /*  377566 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(377632), // Rule ID 60795 //
     /*  377571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  377582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  377585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  377588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377610 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  377613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377630 */     GIR_RootConstrainSelectedInstOperands,
     /*  377631 */     // GIR_Coverage, 60795,
     /*  377631 */     GIR_EraseRootFromParent_Done,
     /*  377632 */   // Label 6793: @377632
     /*  377632 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(377698), // Rule ID 60798 //
     /*  377637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  377648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  377651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  377654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377676 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  377679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377696 */     GIR_RootConstrainSelectedInstOperands,
     /*  377697 */     // GIR_Coverage, 60798,
     /*  377697 */     GIR_EraseRootFromParent_Done,
     /*  377698 */   // Label 6794: @377698
     /*  377698 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(377764), // Rule ID 60799 //
     /*  377703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  377714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  377717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  377720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377742 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  377745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377762 */     GIR_RootConstrainSelectedInstOperands,
     /*  377763 */     // GIR_Coverage, 60799,
     /*  377763 */     GIR_EraseRootFromParent_Done,
     /*  377764 */   // Label 6795: @377764
     /*  377764 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(377830), // Rule ID 60802 //
     /*  377769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  377780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  377783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  377786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377808 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  377811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377828 */     GIR_RootConstrainSelectedInstOperands,
     /*  377829 */     // GIR_Coverage, 60802,
     /*  377829 */     GIR_EraseRootFromParent_Done,
     /*  377830 */   // Label 6796: @377830
     /*  377830 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(377896), // Rule ID 60803 //
     /*  377835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  377846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  377849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  377852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377874 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  377877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377894 */     GIR_RootConstrainSelectedInstOperands,
     /*  377895 */     // GIR_Coverage, 60803,
     /*  377895 */     GIR_EraseRootFromParent_Done,
     /*  377896 */   // Label 6797: @377896
     /*  377896 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(377962), // Rule ID 60806 //
     /*  377901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  377912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  377915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  377918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377940 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  377940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  377943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377960 */     GIR_RootConstrainSelectedInstOperands,
     /*  377961 */     // GIR_Coverage, 60806,
     /*  377961 */     GIR_EraseRootFromParent_Done,
     /*  377962 */   // Label 6798: @377962
     /*  377962 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(378028), // Rule ID 60807 //
     /*  377967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  377978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  377981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  377984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378006 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  378009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378026 */     GIR_RootConstrainSelectedInstOperands,
     /*  378027 */     // GIR_Coverage, 60807,
     /*  378027 */     GIR_EraseRootFromParent_Done,
     /*  378028 */   // Label 6799: @378028
     /*  378028 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(378094), // Rule ID 60810 //
     /*  378033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  378044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  378047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  378050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378072 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378092 */     GIR_RootConstrainSelectedInstOperands,
     /*  378093 */     // GIR_Coverage, 60810,
     /*  378093 */     GIR_EraseRootFromParent_Done,
     /*  378094 */   // Label 6800: @378094
     /*  378094 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(378160), // Rule ID 60811 //
     /*  378099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  378110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  378113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  378116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378138 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378158 */     GIR_RootConstrainSelectedInstOperands,
     /*  378159 */     // GIR_Coverage, 60811,
     /*  378159 */     GIR_EraseRootFromParent_Done,
     /*  378160 */   // Label 6801: @378160
     /*  378160 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(378226), // Rule ID 60814 //
     /*  378165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  378176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  378179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  378182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378204 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378224 */     GIR_RootConstrainSelectedInstOperands,
     /*  378225 */     // GIR_Coverage, 60814,
     /*  378225 */     GIR_EraseRootFromParent_Done,
     /*  378226 */   // Label 6802: @378226
     /*  378226 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(378292), // Rule ID 60815 //
     /*  378231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  378242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  378245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  378248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378270 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378290 */     GIR_RootConstrainSelectedInstOperands,
     /*  378291 */     // GIR_Coverage, 60815,
     /*  378291 */     GIR_EraseRootFromParent_Done,
     /*  378292 */   // Label 6803: @378292
     /*  378292 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(378358), // Rule ID 60818 //
     /*  378297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  378308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  378311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  378314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378356 */     GIR_RootConstrainSelectedInstOperands,
     /*  378357 */     // GIR_Coverage, 60818,
     /*  378357 */     GIR_EraseRootFromParent_Done,
     /*  378358 */   // Label 6804: @378358
     /*  378358 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(378424), // Rule ID 60819 //
     /*  378363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  378374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  378377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  378380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378402 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378422 */     GIR_RootConstrainSelectedInstOperands,
     /*  378423 */     // GIR_Coverage, 60819,
     /*  378423 */     GIR_EraseRootFromParent_Done,
     /*  378424 */   // Label 6805: @378424
     /*  378424 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(378490), // Rule ID 60822 //
     /*  378429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  378440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  378443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  378446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378468 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  378468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378488 */     GIR_RootConstrainSelectedInstOperands,
     /*  378489 */     // GIR_Coverage, 60822,
     /*  378489 */     GIR_EraseRootFromParent_Done,
     /*  378490 */   // Label 6806: @378490
     /*  378490 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(378556), // Rule ID 60823 //
     /*  378495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  378506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  378509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  378512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378534 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  378534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378554 */     GIR_RootConstrainSelectedInstOperands,
     /*  378555 */     // GIR_Coverage, 60823,
     /*  378555 */     GIR_EraseRootFromParent_Done,
     /*  378556 */   // Label 6807: @378556
     /*  378556 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(378622), // Rule ID 60826 //
     /*  378561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  378572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  378575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  378578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378600 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  378603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378620 */     GIR_RootConstrainSelectedInstOperands,
     /*  378621 */     // GIR_Coverage, 60826,
     /*  378621 */     GIR_EraseRootFromParent_Done,
     /*  378622 */   // Label 6808: @378622
     /*  378622 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(378688), // Rule ID 60827 //
     /*  378627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  378638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  378641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  378644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378666 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  378669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378686 */     GIR_RootConstrainSelectedInstOperands,
     /*  378687 */     // GIR_Coverage, 60827,
     /*  378687 */     GIR_EraseRootFromParent_Done,
     /*  378688 */   // Label 6809: @378688
     /*  378688 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(378754), // Rule ID 60830 //
     /*  378693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  378704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  378707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  378710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378732 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  378735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378752 */     GIR_RootConstrainSelectedInstOperands,
     /*  378753 */     // GIR_Coverage, 60830,
     /*  378753 */     GIR_EraseRootFromParent_Done,
     /*  378754 */   // Label 6810: @378754
     /*  378754 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(378820), // Rule ID 60831 //
     /*  378759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  378770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  378773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  378776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378798 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  378801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378818 */     GIR_RootConstrainSelectedInstOperands,
     /*  378819 */     // GIR_Coverage, 60831,
     /*  378819 */     GIR_EraseRootFromParent_Done,
     /*  378820 */   // Label 6811: @378820
     /*  378820 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(378886), // Rule ID 60834 //
     /*  378825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  378836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  378839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  378842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378864 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  378867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378884 */     GIR_RootConstrainSelectedInstOperands,
     /*  378885 */     // GIR_Coverage, 60834,
     /*  378885 */     GIR_EraseRootFromParent_Done,
     /*  378886 */   // Label 6812: @378886
     /*  378886 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(378952), // Rule ID 60835 //
     /*  378891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  378902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  378905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  378908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378930 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  378933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378950 */     GIR_RootConstrainSelectedInstOperands,
     /*  378951 */     // GIR_Coverage, 60835,
     /*  378951 */     GIR_EraseRootFromParent_Done,
     /*  378952 */   // Label 6813: @378952
     /*  378952 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(379018), // Rule ID 60838 //
     /*  378957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  378968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  378971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  378974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  378999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379016 */     GIR_RootConstrainSelectedInstOperands,
     /*  379017 */     // GIR_Coverage, 60838,
     /*  379017 */     GIR_EraseRootFromParent_Done,
     /*  379018 */   // Label 6814: @379018
     /*  379018 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(379084), // Rule ID 60839 //
     /*  379023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  379034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  379037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  379040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379062 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  379065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379082 */     GIR_RootConstrainSelectedInstOperands,
     /*  379083 */     // GIR_Coverage, 60839,
     /*  379083 */     GIR_EraseRootFromParent_Done,
     /*  379084 */   // Label 6815: @379084
     /*  379084 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(379150), // Rule ID 60842 //
     /*  379089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  379100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  379103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  379106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379128 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  379128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  379131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379148 */     GIR_RootConstrainSelectedInstOperands,
     /*  379149 */     // GIR_Coverage, 60842,
     /*  379149 */     GIR_EraseRootFromParent_Done,
     /*  379150 */   // Label 6816: @379150
     /*  379150 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(379216), // Rule ID 60843 //
     /*  379155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  379166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  379169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  379172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379194 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  379197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379214 */     GIR_RootConstrainSelectedInstOperands,
     /*  379215 */     // GIR_Coverage, 60843,
     /*  379215 */     GIR_EraseRootFromParent_Done,
     /*  379216 */   // Label 6817: @379216
     /*  379216 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(379282), // Rule ID 60846 //
     /*  379221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  379232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  379235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  379238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379260 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  379260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  379263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379280 */     GIR_RootConstrainSelectedInstOperands,
     /*  379281 */     // GIR_Coverage, 60846,
     /*  379281 */     GIR_EraseRootFromParent_Done,
     /*  379282 */   // Label 6818: @379282
     /*  379282 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(379348), // Rule ID 60847 //
     /*  379287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  379298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  379301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  379304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379326 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  379329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379346 */     GIR_RootConstrainSelectedInstOperands,
     /*  379347 */     // GIR_Coverage, 60847,
     /*  379347 */     GIR_EraseRootFromParent_Done,
     /*  379348 */   // Label 6819: @379348
     /*  379348 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(379414), // Rule ID 60850 //
     /*  379353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  379364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  379367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  379370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  379395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379412 */     GIR_RootConstrainSelectedInstOperands,
     /*  379413 */     // GIR_Coverage, 60850,
     /*  379413 */     GIR_EraseRootFromParent_Done,
     /*  379414 */   // Label 6820: @379414
     /*  379414 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(379480), // Rule ID 60851 //
     /*  379419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  379430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  379433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  379436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  379461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379478 */     GIR_RootConstrainSelectedInstOperands,
     /*  379479 */     // GIR_Coverage, 60851,
     /*  379479 */     GIR_EraseRootFromParent_Done,
     /*  379480 */   // Label 6821: @379480
     /*  379480 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(379546), // Rule ID 60854 //
     /*  379485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  379496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  379499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  379502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  379527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379544 */     GIR_RootConstrainSelectedInstOperands,
     /*  379545 */     // GIR_Coverage, 60854,
     /*  379545 */     GIR_EraseRootFromParent_Done,
     /*  379546 */   // Label 6822: @379546
     /*  379546 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(379612), // Rule ID 60855 //
     /*  379551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  379562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  379565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  379568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379590 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  379593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379610 */     GIR_RootConstrainSelectedInstOperands,
     /*  379611 */     // GIR_Coverage, 60855,
     /*  379611 */     GIR_EraseRootFromParent_Done,
     /*  379612 */   // Label 6823: @379612
     /*  379612 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(379678), // Rule ID 60858 //
     /*  379617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  379628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  379631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  379634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379656 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  379659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379676 */     GIR_RootConstrainSelectedInstOperands,
     /*  379677 */     // GIR_Coverage, 60858,
     /*  379677 */     GIR_EraseRootFromParent_Done,
     /*  379678 */   // Label 6824: @379678
     /*  379678 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(379744), // Rule ID 60859 //
     /*  379683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  379694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  379697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  379700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  379725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379742 */     GIR_RootConstrainSelectedInstOperands,
     /*  379743 */     // GIR_Coverage, 60859,
     /*  379743 */     GIR_EraseRootFromParent_Done,
     /*  379744 */   // Label 6825: @379744
     /*  379744 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(379810), // Rule ID 60862 //
     /*  379749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  379760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  379763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  379766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  379788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  379791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379808 */     GIR_RootConstrainSelectedInstOperands,
     /*  379809 */     // GIR_Coverage, 60862,
     /*  379809 */     GIR_EraseRootFromParent_Done,
     /*  379810 */   // Label 6826: @379810
     /*  379810 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(379876), // Rule ID 60863 //
     /*  379815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  379826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  379829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  379832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379854 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  379857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379874 */     GIR_RootConstrainSelectedInstOperands,
     /*  379875 */     // GIR_Coverage, 60863,
     /*  379875 */     GIR_EraseRootFromParent_Done,
     /*  379876 */   // Label 6827: @379876
     /*  379876 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(379942), // Rule ID 60866 //
     /*  379881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  379892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  379895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  379898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379920 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  379920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  379923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379940 */     GIR_RootConstrainSelectedInstOperands,
     /*  379941 */     // GIR_Coverage, 60866,
     /*  379941 */     GIR_EraseRootFromParent_Done,
     /*  379942 */   // Label 6828: @379942
     /*  379942 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(380008), // Rule ID 60867 //
     /*  379947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  379958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  379961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  379964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  379989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380006 */     GIR_RootConstrainSelectedInstOperands,
     /*  380007 */     // GIR_Coverage, 60867,
     /*  380007 */     GIR_EraseRootFromParent_Done,
     /*  380008 */   // Label 6829: @380008
     /*  380008 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(380074), // Rule ID 60870 //
     /*  380013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  380021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  380024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  380027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  380030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380052 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  380052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  380055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380072 */     GIR_RootConstrainSelectedInstOperands,
     /*  380073 */     // GIR_Coverage, 60870,
     /*  380073 */     GIR_EraseRootFromParent_Done,
     /*  380074 */   // Label 6830: @380074
     /*  380074 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(380140), // Rule ID 60871 //
     /*  380079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  380087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  380090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  380093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  380096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380118 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  380118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  380121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380138 */     GIR_RootConstrainSelectedInstOperands,
     /*  380139 */     // GIR_Coverage, 60871,
     /*  380139 */     GIR_EraseRootFromParent_Done,
     /*  380140 */   // Label 6831: @380140
     /*  380140 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(380206), // Rule ID 60874 //
     /*  380145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  380156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  380159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  380162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380184 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  380187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380204 */     GIR_RootConstrainSelectedInstOperands,
     /*  380205 */     // GIR_Coverage, 60874,
     /*  380205 */     GIR_EraseRootFromParent_Done,
     /*  380206 */   // Label 6832: @380206
     /*  380206 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(380272), // Rule ID 60875 //
     /*  380211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  380222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  380225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  380228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380250 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  380253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380270 */     GIR_RootConstrainSelectedInstOperands,
     /*  380271 */     // GIR_Coverage, 60875,
     /*  380271 */     GIR_EraseRootFromParent_Done,
     /*  380272 */   // Label 6833: @380272
     /*  380272 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(380338), // Rule ID 60878 //
     /*  380277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  380288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  380291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  380294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380316 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  380319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380336 */     GIR_RootConstrainSelectedInstOperands,
     /*  380337 */     // GIR_Coverage, 60878,
     /*  380337 */     GIR_EraseRootFromParent_Done,
     /*  380338 */   // Label 6834: @380338
     /*  380338 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(380404), // Rule ID 60879 //
     /*  380343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  380354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  380357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  380360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380382 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  380385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380402 */     GIR_RootConstrainSelectedInstOperands,
     /*  380403 */     // GIR_Coverage, 60879,
     /*  380403 */     GIR_EraseRootFromParent_Done,
     /*  380404 */   // Label 6835: @380404
     /*  380404 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(380470), // Rule ID 60882 //
     /*  380409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  380420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  380423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  380426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380448 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  380451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380468 */     GIR_RootConstrainSelectedInstOperands,
     /*  380469 */     // GIR_Coverage, 60882,
     /*  380469 */     GIR_EraseRootFromParent_Done,
     /*  380470 */   // Label 6836: @380470
     /*  380470 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(380536), // Rule ID 60883 //
     /*  380475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  380486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  380489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  380492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380514 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  380517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380534 */     GIR_RootConstrainSelectedInstOperands,
     /*  380535 */     // GIR_Coverage, 60883,
     /*  380535 */     GIR_EraseRootFromParent_Done,
     /*  380536 */   // Label 6837: @380536
     /*  380536 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(380602), // Rule ID 60886 //
     /*  380541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  380552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  380555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  380558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380580 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  380583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380600 */     GIR_RootConstrainSelectedInstOperands,
     /*  380601 */     // GIR_Coverage, 60886,
     /*  380601 */     GIR_EraseRootFromParent_Done,
     /*  380602 */   // Label 6838: @380602
     /*  380602 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(380668), // Rule ID 60887 //
     /*  380607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  380618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  380621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  380624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  380649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380666 */     GIR_RootConstrainSelectedInstOperands,
     /*  380667 */     // GIR_Coverage, 60887,
     /*  380667 */     GIR_EraseRootFromParent_Done,
     /*  380668 */   // Label 6839: @380668
     /*  380668 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(380734), // Rule ID 60890 //
     /*  380673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  380684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  380687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  380690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380712 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  380715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380732 */     GIR_RootConstrainSelectedInstOperands,
     /*  380733 */     // GIR_Coverage, 60890,
     /*  380733 */     GIR_EraseRootFromParent_Done,
     /*  380734 */   // Label 6840: @380734
     /*  380734 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(380800), // Rule ID 60891 //
     /*  380739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  380750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  380753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  380756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380778 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  380781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380798 */     GIR_RootConstrainSelectedInstOperands,
     /*  380799 */     // GIR_Coverage, 60891,
     /*  380799 */     GIR_EraseRootFromParent_Done,
     /*  380800 */   // Label 6841: @380800
     /*  380800 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(380866), // Rule ID 60894 //
     /*  380805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  380816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  380819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  380822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380844 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  380844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  380847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380864 */     GIR_RootConstrainSelectedInstOperands,
     /*  380865 */     // GIR_Coverage, 60894,
     /*  380865 */     GIR_EraseRootFromParent_Done,
     /*  380866 */   // Label 6842: @380866
     /*  380866 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(380932), // Rule ID 60895 //
     /*  380871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  380882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  380885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  380888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380910 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  380910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  380913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380930 */     GIR_RootConstrainSelectedInstOperands,
     /*  380931 */     // GIR_Coverage, 60895,
     /*  380931 */     GIR_EraseRootFromParent_Done,
     /*  380932 */   // Label 6843: @380932
     /*  380932 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(380998), // Rule ID 60898 //
     /*  380937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  380948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  380951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  380954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380976 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  380979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380996 */     GIR_RootConstrainSelectedInstOperands,
     /*  380997 */     // GIR_Coverage, 60898,
     /*  380997 */     GIR_EraseRootFromParent_Done,
     /*  380998 */   // Label 6844: @380998
     /*  380998 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(381064), // Rule ID 60899 //
     /*  381003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  381014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  381017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  381020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381042 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381062 */     GIR_RootConstrainSelectedInstOperands,
     /*  381063 */     // GIR_Coverage, 60899,
     /*  381063 */     GIR_EraseRootFromParent_Done,
     /*  381064 */   // Label 6845: @381064
     /*  381064 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(381130), // Rule ID 60902 //
     /*  381069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  381080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  381083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  381086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381128 */     GIR_RootConstrainSelectedInstOperands,
     /*  381129 */     // GIR_Coverage, 60902,
     /*  381129 */     GIR_EraseRootFromParent_Done,
     /*  381130 */   // Label 6846: @381130
     /*  381130 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(381196), // Rule ID 60903 //
     /*  381135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  381146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  381149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  381152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381194 */     GIR_RootConstrainSelectedInstOperands,
     /*  381195 */     // GIR_Coverage, 60903,
     /*  381195 */     GIR_EraseRootFromParent_Done,
     /*  381196 */   // Label 6847: @381196
     /*  381196 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(381262), // Rule ID 60906 //
     /*  381201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  381212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  381215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  381218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381260 */     GIR_RootConstrainSelectedInstOperands,
     /*  381261 */     // GIR_Coverage, 60906,
     /*  381261 */     GIR_EraseRootFromParent_Done,
     /*  381262 */   // Label 6848: @381262
     /*  381262 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(381328), // Rule ID 60907 //
     /*  381267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  381278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  381281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  381284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381306 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  381306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381326 */     GIR_RootConstrainSelectedInstOperands,
     /*  381327 */     // GIR_Coverage, 60907,
     /*  381327 */     GIR_EraseRootFromParent_Done,
     /*  381328 */   // Label 6849: @381328
     /*  381328 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(381394), // Rule ID 60910 //
     /*  381333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  381344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  381347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  381350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381372 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  381372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381392 */     GIR_RootConstrainSelectedInstOperands,
     /*  381393 */     // GIR_Coverage, 60910,
     /*  381393 */     GIR_EraseRootFromParent_Done,
     /*  381394 */   // Label 6850: @381394
     /*  381394 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(381460), // Rule ID 60911 //
     /*  381399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  381410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  381413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  381416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381438 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  381438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381458 */     GIR_RootConstrainSelectedInstOperands,
     /*  381459 */     // GIR_Coverage, 60911,
     /*  381459 */     GIR_EraseRootFromParent_Done,
     /*  381460 */   // Label 6851: @381460
     /*  381460 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(381526), // Rule ID 60914 //
     /*  381465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  381476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  381479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  381482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381504 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  381507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381524 */     GIR_RootConstrainSelectedInstOperands,
     /*  381525 */     // GIR_Coverage, 60914,
     /*  381525 */     GIR_EraseRootFromParent_Done,
     /*  381526 */   // Label 6852: @381526
     /*  381526 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(381592), // Rule ID 60915 //
     /*  381531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  381542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  381545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  381548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381570 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  381573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381590 */     GIR_RootConstrainSelectedInstOperands,
     /*  381591 */     // GIR_Coverage, 60915,
     /*  381591 */     GIR_EraseRootFromParent_Done,
     /*  381592 */   // Label 6853: @381592
     /*  381592 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(381658), // Rule ID 60918 //
     /*  381597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  381608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  381611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  381614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381636 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  381639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381656 */     GIR_RootConstrainSelectedInstOperands,
     /*  381657 */     // GIR_Coverage, 60918,
     /*  381657 */     GIR_EraseRootFromParent_Done,
     /*  381658 */   // Label 6854: @381658
     /*  381658 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(381724), // Rule ID 60919 //
     /*  381663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  381674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  381677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  381680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381702 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  381705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381722 */     GIR_RootConstrainSelectedInstOperands,
     /*  381723 */     // GIR_Coverage, 60919,
     /*  381723 */     GIR_EraseRootFromParent_Done,
     /*  381724 */   // Label 6855: @381724
     /*  381724 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(381790), // Rule ID 60922 //
     /*  381729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  381740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  381743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  381746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381768 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  381771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381788 */     GIR_RootConstrainSelectedInstOperands,
     /*  381789 */     // GIR_Coverage, 60922,
     /*  381789 */     GIR_EraseRootFromParent_Done,
     /*  381790 */   // Label 6856: @381790
     /*  381790 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(381856), // Rule ID 60923 //
     /*  381795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  381806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  381809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  381812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381834 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  381837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381854 */     GIR_RootConstrainSelectedInstOperands,
     /*  381855 */     // GIR_Coverage, 60923,
     /*  381855 */     GIR_EraseRootFromParent_Done,
     /*  381856 */   // Label 6857: @381856
     /*  381856 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(381922), // Rule ID 60926 //
     /*  381861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  381872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  381875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  381878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381900 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  381903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381920 */     GIR_RootConstrainSelectedInstOperands,
     /*  381921 */     // GIR_Coverage, 60926,
     /*  381921 */     GIR_EraseRootFromParent_Done,
     /*  381922 */   // Label 6858: @381922
     /*  381922 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(381988), // Rule ID 60927 //
     /*  381927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  381938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  381941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  381944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381966 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  381969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381986 */     GIR_RootConstrainSelectedInstOperands,
     /*  381987 */     // GIR_Coverage, 60927,
     /*  381987 */     GIR_EraseRootFromParent_Done,
     /*  381988 */   // Label 6859: @381988
     /*  381988 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(382054), // Rule ID 60930 //
     /*  381993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  382004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  382007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  382010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382032 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  382032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  382035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382052 */     GIR_RootConstrainSelectedInstOperands,
     /*  382053 */     // GIR_Coverage, 60930,
     /*  382053 */     GIR_EraseRootFromParent_Done,
     /*  382054 */   // Label 6860: @382054
     /*  382054 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(382120), // Rule ID 60931 //
     /*  382059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  382070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  382073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  382076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382098 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  382098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  382101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382118 */     GIR_RootConstrainSelectedInstOperands,
     /*  382119 */     // GIR_Coverage, 60931,
     /*  382119 */     GIR_EraseRootFromParent_Done,
     /*  382120 */   // Label 6861: @382120
     /*  382120 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(382186), // Rule ID 60934 //
     /*  382125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  382136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  382139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  382142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382164 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  382164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  382167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382184 */     GIR_RootConstrainSelectedInstOperands,
     /*  382185 */     // GIR_Coverage, 60934,
     /*  382185 */     GIR_EraseRootFromParent_Done,
     /*  382186 */   // Label 6862: @382186
     /*  382186 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(382252), // Rule ID 60935 //
     /*  382191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  382202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  382205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  382208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382230 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  382230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  382233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382250 */     GIR_RootConstrainSelectedInstOperands,
     /*  382251 */     // GIR_Coverage, 60935,
     /*  382251 */     GIR_EraseRootFromParent_Done,
     /*  382252 */   // Label 6863: @382252
     /*  382252 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(382318), // Rule ID 60938 //
     /*  382257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  382268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  382271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  382274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  382299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382316 */     GIR_RootConstrainSelectedInstOperands,
     /*  382317 */     // GIR_Coverage, 60938,
     /*  382317 */     GIR_EraseRootFromParent_Done,
     /*  382318 */   // Label 6864: @382318
     /*  382318 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(382384), // Rule ID 60939 //
     /*  382323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  382334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  382337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  382340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382362 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  382365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382382 */     GIR_RootConstrainSelectedInstOperands,
     /*  382383 */     // GIR_Coverage, 60939,
     /*  382383 */     GIR_EraseRootFromParent_Done,
     /*  382384 */   // Label 6865: @382384
     /*  382384 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(382450), // Rule ID 60942 //
     /*  382389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  382400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  382403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  382406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  382431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382448 */     GIR_RootConstrainSelectedInstOperands,
     /*  382449 */     // GIR_Coverage, 60942,
     /*  382449 */     GIR_EraseRootFromParent_Done,
     /*  382450 */   // Label 6866: @382450
     /*  382450 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(382516), // Rule ID 60943 //
     /*  382455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  382466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  382469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  382472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  382497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382514 */     GIR_RootConstrainSelectedInstOperands,
     /*  382515 */     // GIR_Coverage, 60943,
     /*  382515 */     GIR_EraseRootFromParent_Done,
     /*  382516 */   // Label 6867: @382516
     /*  382516 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(382582), // Rule ID 60946 //
     /*  382521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  382532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  382535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  382538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382560 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  382563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382580 */     GIR_RootConstrainSelectedInstOperands,
     /*  382581 */     // GIR_Coverage, 60946,
     /*  382581 */     GIR_EraseRootFromParent_Done,
     /*  382582 */   // Label 6868: @382582
     /*  382582 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(382648), // Rule ID 60947 //
     /*  382587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  382598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  382601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  382604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  382629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382646 */     GIR_RootConstrainSelectedInstOperands,
     /*  382647 */     // GIR_Coverage, 60947,
     /*  382647 */     GIR_EraseRootFromParent_Done,
     /*  382648 */   // Label 6869: @382648
     /*  382648 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(382714), // Rule ID 60950 //
     /*  382653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  382664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  382667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  382670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  382695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382712 */     GIR_RootConstrainSelectedInstOperands,
     /*  382713 */     // GIR_Coverage, 60950,
     /*  382713 */     GIR_EraseRootFromParent_Done,
     /*  382714 */   // Label 6870: @382714
     /*  382714 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(382780), // Rule ID 60951 //
     /*  382719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  382730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  382733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  382736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382758 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  382761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382778 */     GIR_RootConstrainSelectedInstOperands,
     /*  382779 */     // GIR_Coverage, 60951,
     /*  382779 */     GIR_EraseRootFromParent_Done,
     /*  382780 */   // Label 6871: @382780
     /*  382780 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(382846), // Rule ID 60954 //
     /*  382785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  382796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  382799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  382802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382824 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  382827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382844 */     GIR_RootConstrainSelectedInstOperands,
     /*  382845 */     // GIR_Coverage, 60954,
     /*  382845 */     GIR_EraseRootFromParent_Done,
     /*  382846 */   // Label 6872: @382846
     /*  382846 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(382912), // Rule ID 60955 //
     /*  382851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  382862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  382865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  382868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382890 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  382893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382910 */     GIR_RootConstrainSelectedInstOperands,
     /*  382911 */     // GIR_Coverage, 60955,
     /*  382911 */     GIR_EraseRootFromParent_Done,
     /*  382912 */   // Label 6873: @382912
     /*  382912 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(382978), // Rule ID 60958 //
     /*  382917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  382928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  382931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  382934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382956 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  382959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382976 */     GIR_RootConstrainSelectedInstOperands,
     /*  382977 */     // GIR_Coverage, 60958,
     /*  382977 */     GIR_EraseRootFromParent_Done,
     /*  382978 */   // Label 6874: @382978
     /*  382978 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(383044), // Rule ID 60959 //
     /*  382983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  382994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  382997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  383000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383022 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  383022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  383025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  383039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383042 */     GIR_RootConstrainSelectedInstOperands,
     /*  383043 */     // GIR_Coverage, 60959,
     /*  383043 */     GIR_EraseRootFromParent_Done,
     /*  383044 */   // Label 6875: @383044
     /*  383044 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(383110), // Rule ID 61382 //
     /*  383049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  383060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  383063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  383066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383088 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  383091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383108 */     GIR_RootConstrainSelectedInstOperands,
     /*  383109 */     // GIR_Coverage, 61382,
     /*  383109 */     GIR_EraseRootFromParent_Done,
     /*  383110 */   // Label 6876: @383110
     /*  383110 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(383176), // Rule ID 61383 //
     /*  383115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  383126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  383129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  383132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383154 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  383157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383174 */     GIR_RootConstrainSelectedInstOperands,
     /*  383175 */     // GIR_Coverage, 61383,
     /*  383175 */     GIR_EraseRootFromParent_Done,
     /*  383176 */   // Label 6877: @383176
     /*  383176 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(383242), // Rule ID 61386 //
     /*  383181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  383192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  383195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  383198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383220 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  383223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383240 */     GIR_RootConstrainSelectedInstOperands,
     /*  383241 */     // GIR_Coverage, 61386,
     /*  383241 */     GIR_EraseRootFromParent_Done,
     /*  383242 */   // Label 6878: @383242
     /*  383242 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(383308), // Rule ID 61387 //
     /*  383247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  383258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  383261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  383264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383286 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  383289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383306 */     GIR_RootConstrainSelectedInstOperands,
     /*  383307 */     // GIR_Coverage, 61387,
     /*  383307 */     GIR_EraseRootFromParent_Done,
     /*  383308 */   // Label 6879: @383308
     /*  383308 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(383374), // Rule ID 61390 //
     /*  383313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  383324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  383327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  383330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383352 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  383355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383372 */     GIR_RootConstrainSelectedInstOperands,
     /*  383373 */     // GIR_Coverage, 61390,
     /*  383373 */     GIR_EraseRootFromParent_Done,
     /*  383374 */   // Label 6880: @383374
     /*  383374 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(383440), // Rule ID 61391 //
     /*  383379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  383390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  383393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  383396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383418 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  383421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383438 */     GIR_RootConstrainSelectedInstOperands,
     /*  383439 */     // GIR_Coverage, 61391,
     /*  383439 */     GIR_EraseRootFromParent_Done,
     /*  383440 */   // Label 6881: @383440
     /*  383440 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(383506), // Rule ID 61394 //
     /*  383445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  383456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  383459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  383462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  383487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383504 */     GIR_RootConstrainSelectedInstOperands,
     /*  383505 */     // GIR_Coverage, 61394,
     /*  383505 */     GIR_EraseRootFromParent_Done,
     /*  383506 */   // Label 6882: @383506
     /*  383506 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(383572), // Rule ID 61395 //
     /*  383511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  383522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  383525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  383528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383550 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  383553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383570 */     GIR_RootConstrainSelectedInstOperands,
     /*  383571 */     // GIR_Coverage, 61395,
     /*  383571 */     GIR_EraseRootFromParent_Done,
     /*  383572 */   // Label 6883: @383572
     /*  383572 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(383638), // Rule ID 61398 //
     /*  383577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  383588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  383591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  383594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383616 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  383619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383636 */     GIR_RootConstrainSelectedInstOperands,
     /*  383637 */     // GIR_Coverage, 61398,
     /*  383637 */     GIR_EraseRootFromParent_Done,
     /*  383638 */   // Label 6884: @383638
     /*  383638 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(383704), // Rule ID 61399 //
     /*  383643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  383654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  383657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  383660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383682 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  383685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383702 */     GIR_RootConstrainSelectedInstOperands,
     /*  383703 */     // GIR_Coverage, 61399,
     /*  383703 */     GIR_EraseRootFromParent_Done,
     /*  383704 */   // Label 6885: @383704
     /*  383704 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(383770), // Rule ID 61402 //
     /*  383709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  383720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  383723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  383726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383748 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  383751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383768 */     GIR_RootConstrainSelectedInstOperands,
     /*  383769 */     // GIR_Coverage, 61402,
     /*  383769 */     GIR_EraseRootFromParent_Done,
     /*  383770 */   // Label 6886: @383770
     /*  383770 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(383836), // Rule ID 61403 //
     /*  383775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  383786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  383789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  383792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  383817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383834 */     GIR_RootConstrainSelectedInstOperands,
     /*  383835 */     // GIR_Coverage, 61403,
     /*  383835 */     GIR_EraseRootFromParent_Done,
     /*  383836 */   // Label 6887: @383836
     /*  383836 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(383902), // Rule ID 61406 //
     /*  383841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  383852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  383855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  383858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383880 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  383883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383900 */     GIR_RootConstrainSelectedInstOperands,
     /*  383901 */     // GIR_Coverage, 61406,
     /*  383901 */     GIR_EraseRootFromParent_Done,
     /*  383902 */   // Label 6888: @383902
     /*  383902 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(383968), // Rule ID 61407 //
     /*  383907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  383918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  383921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  383924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383946 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  383949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383966 */     GIR_RootConstrainSelectedInstOperands,
     /*  383967 */     // GIR_Coverage, 61407,
     /*  383967 */     GIR_EraseRootFromParent_Done,
     /*  383968 */   // Label 6889: @383968
     /*  383968 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(384034), // Rule ID 61410 //
     /*  383973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  383984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  383987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  383990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384012 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  384015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384032 */     GIR_RootConstrainSelectedInstOperands,
     /*  384033 */     // GIR_Coverage, 61410,
     /*  384033 */     GIR_EraseRootFromParent_Done,
     /*  384034 */   // Label 6890: @384034
     /*  384034 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(384100), // Rule ID 61411 //
     /*  384039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  384050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  384053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  384056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384078 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  384081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384098 */     GIR_RootConstrainSelectedInstOperands,
     /*  384099 */     // GIR_Coverage, 61411,
     /*  384099 */     GIR_EraseRootFromParent_Done,
     /*  384100 */   // Label 6891: @384100
     /*  384100 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(384166), // Rule ID 61414 //
     /*  384105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  384116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  384119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  384122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  384147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384164 */     GIR_RootConstrainSelectedInstOperands,
     /*  384165 */     // GIR_Coverage, 61414,
     /*  384165 */     GIR_EraseRootFromParent_Done,
     /*  384166 */   // Label 6892: @384166
     /*  384166 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(384232), // Rule ID 61415 //
     /*  384171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  384182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  384185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  384188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384210 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  384210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  384213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384230 */     GIR_RootConstrainSelectedInstOperands,
     /*  384231 */     // GIR_Coverage, 61415,
     /*  384231 */     GIR_EraseRootFromParent_Done,
     /*  384232 */   // Label 6893: @384232
     /*  384232 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(384298), // Rule ID 61418 //
     /*  384237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  384248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  384251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  384254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  384276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  384279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384296 */     GIR_RootConstrainSelectedInstOperands,
     /*  384297 */     // GIR_Coverage, 61418,
     /*  384297 */     GIR_EraseRootFromParent_Done,
     /*  384298 */   // Label 6894: @384298
     /*  384298 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(384364), // Rule ID 61419 //
     /*  384303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  384314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  384317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  384320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384342 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  384345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384362 */     GIR_RootConstrainSelectedInstOperands,
     /*  384363 */     // GIR_Coverage, 61419,
     /*  384363 */     GIR_EraseRootFromParent_Done,
     /*  384364 */   // Label 6895: @384364
     /*  384364 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(384430), // Rule ID 61422 //
     /*  384369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  384380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  384383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  384386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384408 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  384408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  384411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384428 */     GIR_RootConstrainSelectedInstOperands,
     /*  384429 */     // GIR_Coverage, 61422,
     /*  384429 */     GIR_EraseRootFromParent_Done,
     /*  384430 */   // Label 6896: @384430
     /*  384430 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(384496), // Rule ID 61423 //
     /*  384435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  384446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  384449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  384452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  384474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  384477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384494 */     GIR_RootConstrainSelectedInstOperands,
     /*  384495 */     // GIR_Coverage, 61423,
     /*  384495 */     GIR_EraseRootFromParent_Done,
     /*  384496 */   // Label 6897: @384496
     /*  384496 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(384562), // Rule ID 61426 //
     /*  384501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  384512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  384515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  384518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384540 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  384540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  384543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384560 */     GIR_RootConstrainSelectedInstOperands,
     /*  384561 */     // GIR_Coverage, 61426,
     /*  384561 */     GIR_EraseRootFromParent_Done,
     /*  384562 */   // Label 6898: @384562
     /*  384562 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(384628), // Rule ID 61427 //
     /*  384567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  384578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  384581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  384584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384606 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  384606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  384609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384626 */     GIR_RootConstrainSelectedInstOperands,
     /*  384627 */     // GIR_Coverage, 61427,
     /*  384627 */     GIR_EraseRootFromParent_Done,
     /*  384628 */   // Label 6899: @384628
     /*  384628 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(384694), // Rule ID 61430 //
     /*  384633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  384644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  384647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  384650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384672 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  384672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  384675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384692 */     GIR_RootConstrainSelectedInstOperands,
     /*  384693 */     // GIR_Coverage, 61430,
     /*  384693 */     GIR_EraseRootFromParent_Done,
     /*  384694 */   // Label 6900: @384694
     /*  384694 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(384760), // Rule ID 61431 //
     /*  384699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  384710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  384713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  384716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384738 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  384738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  384741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384758 */     GIR_RootConstrainSelectedInstOperands,
     /*  384759 */     // GIR_Coverage, 61431,
     /*  384759 */     GIR_EraseRootFromParent_Done,
     /*  384760 */   // Label 6901: @384760
     /*  384760 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(384826), // Rule ID 61434 //
     /*  384765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  384776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  384779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  384782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384804 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  384807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384824 */     GIR_RootConstrainSelectedInstOperands,
     /*  384825 */     // GIR_Coverage, 61434,
     /*  384825 */     GIR_EraseRootFromParent_Done,
     /*  384826 */   // Label 6902: @384826
     /*  384826 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(384892), // Rule ID 61435 //
     /*  384831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  384842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  384845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  384848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384870 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  384873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384890 */     GIR_RootConstrainSelectedInstOperands,
     /*  384891 */     // GIR_Coverage, 61435,
     /*  384891 */     GIR_EraseRootFromParent_Done,
     /*  384892 */   // Label 6903: @384892
     /*  384892 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(384958), // Rule ID 61438 //
     /*  384897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  384908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  384911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  384914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384936 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  384939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384956 */     GIR_RootConstrainSelectedInstOperands,
     /*  384957 */     // GIR_Coverage, 61438,
     /*  384957 */     GIR_EraseRootFromParent_Done,
     /*  384958 */   // Label 6904: @384958
     /*  384958 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(385024), // Rule ID 61439 //
     /*  384963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  384974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  384977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  384980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385002 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  385002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  385005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  385019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385022 */     GIR_RootConstrainSelectedInstOperands,
     /*  385023 */     // GIR_Coverage, 61439,
     /*  385023 */     GIR_EraseRootFromParent_Done,
     /*  385024 */   // Label 6905: @385024
     /*  385024 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(385090), // Rule ID 61442 //
     /*  385029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  385040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  385043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  385046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385068 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  385068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  385071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  385085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385088 */     GIR_RootConstrainSelectedInstOperands,
     /*  385089 */     // GIR_Coverage, 61442,
     /*  385089 */     GIR_EraseRootFromParent_Done,
     /*  385090 */   // Label 6906: @385090
     /*  385090 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(385156), // Rule ID 61443 //
     /*  385095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  385106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  385109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  385112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385134 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  385134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  385137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  385151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385154 */     GIR_RootConstrainSelectedInstOperands,
     /*  385155 */     // GIR_Coverage, 61443,
     /*  385155 */     GIR_EraseRootFromParent_Done,
     /*  385156 */   // Label 6907: @385156
     /*  385156 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(385222), // Rule ID 61446 //
     /*  385161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  385172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  385175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  385178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  385200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  385203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385220 */     GIR_RootConstrainSelectedInstOperands,
     /*  385221 */     // GIR_Coverage, 61446,
     /*  385221 */     GIR_EraseRootFromParent_Done,
     /*  385222 */   // Label 6908: @385222
     /*  385222 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(385288), // Rule ID 61447 //
     /*  385227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  385238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  385241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  385244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385266 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  385266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  385269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385286 */     GIR_RootConstrainSelectedInstOperands,
     /*  385287 */     // GIR_Coverage, 61447,
     /*  385287 */     GIR_EraseRootFromParent_Done,
     /*  385288 */   // Label 6909: @385288
     /*  385288 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(385354), // Rule ID 61450 //
     /*  385293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  385304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  385307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  385310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385332 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  385332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  385335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385352 */     GIR_RootConstrainSelectedInstOperands,
     /*  385353 */     // GIR_Coverage, 61450,
     /*  385353 */     GIR_EraseRootFromParent_Done,
     /*  385354 */   // Label 6910: @385354
     /*  385354 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(385420), // Rule ID 61451 //
     /*  385359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  385370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  385373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  385376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385398 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  385398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  385401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385418 */     GIR_RootConstrainSelectedInstOperands,
     /*  385419 */     // GIR_Coverage, 61451,
     /*  385419 */     GIR_EraseRootFromParent_Done,
     /*  385420 */   // Label 6911: @385420
     /*  385420 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(385486), // Rule ID 61454 //
     /*  385425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  385436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  385439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  385442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  385464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  385467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385484 */     GIR_RootConstrainSelectedInstOperands,
     /*  385485 */     // GIR_Coverage, 61454,
     /*  385485 */     GIR_EraseRootFromParent_Done,
     /*  385486 */   // Label 6912: @385486
     /*  385486 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(385552), // Rule ID 61455 //
     /*  385491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  385502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  385505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  385508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385530 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  385530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  385533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385550 */     GIR_RootConstrainSelectedInstOperands,
     /*  385551 */     // GIR_Coverage, 61455,
     /*  385551 */     GIR_EraseRootFromParent_Done,
     /*  385552 */   // Label 6913: @385552
     /*  385552 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(385618), // Rule ID 61458 //
     /*  385557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  385568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  385571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  385574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  385596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  385599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385616 */     GIR_RootConstrainSelectedInstOperands,
     /*  385617 */     // GIR_Coverage, 61458,
     /*  385617 */     GIR_EraseRootFromParent_Done,
     /*  385618 */   // Label 6914: @385618
     /*  385618 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(385684), // Rule ID 61459 //
     /*  385623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  385634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  385637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  385640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385662 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  385662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  385665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385682 */     GIR_RootConstrainSelectedInstOperands,
     /*  385683 */     // GIR_Coverage, 61459,
     /*  385683 */     GIR_EraseRootFromParent_Done,
     /*  385684 */   // Label 6915: @385684
     /*  385684 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(385750), // Rule ID 61462 //
     /*  385689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  385700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  385703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  385706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385728 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  385728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  385731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385748 */     GIR_RootConstrainSelectedInstOperands,
     /*  385749 */     // GIR_Coverage, 61462,
     /*  385749 */     GIR_EraseRootFromParent_Done,
     /*  385750 */   // Label 6916: @385750
     /*  385750 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(385816), // Rule ID 61463 //
     /*  385755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  385766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  385769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  385772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385794 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  385794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  385797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385814 */     GIR_RootConstrainSelectedInstOperands,
     /*  385815 */     // GIR_Coverage, 61463,
     /*  385815 */     GIR_EraseRootFromParent_Done,
     /*  385816 */   // Label 6917: @385816
     /*  385816 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(385882), // Rule ID 61466 //
     /*  385821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  385832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  385835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  385838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385860 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  385860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  385863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385880 */     GIR_RootConstrainSelectedInstOperands,
     /*  385881 */     // GIR_Coverage, 61466,
     /*  385881 */     GIR_EraseRootFromParent_Done,
     /*  385882 */   // Label 6918: @385882
     /*  385882 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(385948), // Rule ID 61467 //
     /*  385887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  385898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  385901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  385904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385926 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  385926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  385929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385946 */     GIR_RootConstrainSelectedInstOperands,
     /*  385947 */     // GIR_Coverage, 61467,
     /*  385947 */     GIR_EraseRootFromParent_Done,
     /*  385948 */   // Label 6919: @385948
     /*  385948 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(386014), // Rule ID 61470 //
     /*  385953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  385964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  385967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  385970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385992 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  385992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  385995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386012 */     GIR_RootConstrainSelectedInstOperands,
     /*  386013 */     // GIR_Coverage, 61470,
     /*  386013 */     GIR_EraseRootFromParent_Done,
     /*  386014 */   // Label 6920: @386014
     /*  386014 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(386080), // Rule ID 61471 //
     /*  386019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  386030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  386033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  386036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386058 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  386058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  386061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386078 */     GIR_RootConstrainSelectedInstOperands,
     /*  386079 */     // GIR_Coverage, 61471,
     /*  386079 */     GIR_EraseRootFromParent_Done,
     /*  386080 */   // Label 6921: @386080
     /*  386080 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(386146), // Rule ID 61474 //
     /*  386085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  386096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  386099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  386102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386124 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  386124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  386127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386144 */     GIR_RootConstrainSelectedInstOperands,
     /*  386145 */     // GIR_Coverage, 61474,
     /*  386145 */     GIR_EraseRootFromParent_Done,
     /*  386146 */   // Label 6922: @386146
     /*  386146 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(386212), // Rule ID 61475 //
     /*  386151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  386162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  386165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  386168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386190 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  386190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  386193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386210 */     GIR_RootConstrainSelectedInstOperands,
     /*  386211 */     // GIR_Coverage, 61475,
     /*  386211 */     GIR_EraseRootFromParent_Done,
     /*  386212 */   // Label 6923: @386212
     /*  386212 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(386278), // Rule ID 61478 //
     /*  386217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  386228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  386231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  386234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386256 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  386256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  386259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386276 */     GIR_RootConstrainSelectedInstOperands,
     /*  386277 */     // GIR_Coverage, 61478,
     /*  386277 */     GIR_EraseRootFromParent_Done,
     /*  386278 */   // Label 6924: @386278
     /*  386278 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(386344), // Rule ID 61479 //
     /*  386283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  386294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  386297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  386300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386322 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  386322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  386325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386342 */     GIR_RootConstrainSelectedInstOperands,
     /*  386343 */     // GIR_Coverage, 61479,
     /*  386343 */     GIR_EraseRootFromParent_Done,
     /*  386344 */   // Label 6925: @386344
     /*  386344 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(386410), // Rule ID 61482 //
     /*  386349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  386360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  386363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  386366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386388 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  386388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  386391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386408 */     GIR_RootConstrainSelectedInstOperands,
     /*  386409 */     // GIR_Coverage, 61482,
     /*  386409 */     GIR_EraseRootFromParent_Done,
     /*  386410 */   // Label 6926: @386410
     /*  386410 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(386476), // Rule ID 61483 //
     /*  386415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  386426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  386429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  386432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386454 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  386454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  386457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386474 */     GIR_RootConstrainSelectedInstOperands,
     /*  386475 */     // GIR_Coverage, 61483,
     /*  386475 */     GIR_EraseRootFromParent_Done,
     /*  386476 */   // Label 6927: @386476
     /*  386476 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(386542), // Rule ID 61486 //
     /*  386481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  386492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  386495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  386498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386520 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  386520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  386523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386540 */     GIR_RootConstrainSelectedInstOperands,
     /*  386541 */     // GIR_Coverage, 61486,
     /*  386541 */     GIR_EraseRootFromParent_Done,
     /*  386542 */   // Label 6928: @386542
     /*  386542 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(386608), // Rule ID 61487 //
     /*  386547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  386558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  386561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  386564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386586 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  386586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  386589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386606 */     GIR_RootConstrainSelectedInstOperands,
     /*  386607 */     // GIR_Coverage, 61487,
     /*  386607 */     GIR_EraseRootFromParent_Done,
     /*  386608 */   // Label 6929: @386608
     /*  386608 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(386674), // Rule ID 61490 //
     /*  386613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  386624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  386627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  386630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  386652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  386655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  386669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386672 */     GIR_RootConstrainSelectedInstOperands,
     /*  386673 */     // GIR_Coverage, 61490,
     /*  386673 */     GIR_EraseRootFromParent_Done,
     /*  386674 */   // Label 6930: @386674
     /*  386674 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(386740), // Rule ID 61491 //
     /*  386679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  386690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  386693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  386696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386718 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  386718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  386721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  386735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386738 */     GIR_RootConstrainSelectedInstOperands,
     /*  386739 */     // GIR_Coverage, 61491,
     /*  386739 */     GIR_EraseRootFromParent_Done,
     /*  386740 */   // Label 6931: @386740
     /*  386740 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(386806), // Rule ID 61494 //
     /*  386745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  386756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  386759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  386762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386784 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  386784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  386787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386804 */     GIR_RootConstrainSelectedInstOperands,
     /*  386805 */     // GIR_Coverage, 61494,
     /*  386805 */     GIR_EraseRootFromParent_Done,
     /*  386806 */   // Label 6932: @386806
     /*  386806 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(386872), // Rule ID 61495 //
     /*  386811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  386822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  386825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  386828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  386850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  386853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386870 */     GIR_RootConstrainSelectedInstOperands,
     /*  386871 */     // GIR_Coverage, 61495,
     /*  386871 */     GIR_EraseRootFromParent_Done,
     /*  386872 */   // Label 6933: @386872
     /*  386872 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(386938), // Rule ID 61498 //
     /*  386877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  386888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  386891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  386894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386916 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  386916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  386919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386936 */     GIR_RootConstrainSelectedInstOperands,
     /*  386937 */     // GIR_Coverage, 61498,
     /*  386937 */     GIR_EraseRootFromParent_Done,
     /*  386938 */   // Label 6934: @386938
     /*  386938 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(387004), // Rule ID 61499 //
     /*  386943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  386954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  386957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  386960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386982 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  386982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  386985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387002 */     GIR_RootConstrainSelectedInstOperands,
     /*  387003 */     // GIR_Coverage, 61499,
     /*  387003 */     GIR_EraseRootFromParent_Done,
     /*  387004 */   // Label 6935: @387004
     /*  387004 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(387070), // Rule ID 61502 //
     /*  387009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  387020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  387023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  387026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  387048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  387051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387068 */     GIR_RootConstrainSelectedInstOperands,
     /*  387069 */     // GIR_Coverage, 61502,
     /*  387069 */     GIR_EraseRootFromParent_Done,
     /*  387070 */   // Label 6936: @387070
     /*  387070 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(387136), // Rule ID 61503 //
     /*  387075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  387086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  387089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  387092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  387114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  387117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387134 */     GIR_RootConstrainSelectedInstOperands,
     /*  387135 */     // GIR_Coverage, 61503,
     /*  387135 */     GIR_EraseRootFromParent_Done,
     /*  387136 */   // Label 6937: @387136
     /*  387136 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(387202), // Rule ID 61506 //
     /*  387141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  387152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  387155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  387158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387180 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  387180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  387183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  387197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387200 */     GIR_RootConstrainSelectedInstOperands,
     /*  387201 */     // GIR_Coverage, 61506,
     /*  387201 */     GIR_EraseRootFromParent_Done,
     /*  387202 */   // Label 6938: @387202
     /*  387202 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(387268), // Rule ID 61507 //
     /*  387207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  387218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  387221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  387224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  387246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  387249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  387263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387266 */     GIR_RootConstrainSelectedInstOperands,
     /*  387267 */     // GIR_Coverage, 61507,
     /*  387267 */     GIR_EraseRootFromParent_Done,
     /*  387268 */   // Label 6939: @387268
     /*  387268 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(387334), // Rule ID 61510 //
     /*  387273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  387284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  387287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  387290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387312 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  387312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  387315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387332 */     GIR_RootConstrainSelectedInstOperands,
     /*  387333 */     // GIR_Coverage, 61510,
     /*  387333 */     GIR_EraseRootFromParent_Done,
     /*  387334 */   // Label 6940: @387334
     /*  387334 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(387400), // Rule ID 61511 //
     /*  387339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  387350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  387353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  387356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387378 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  387378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  387381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387398 */     GIR_RootConstrainSelectedInstOperands,
     /*  387399 */     // GIR_Coverage, 61511,
     /*  387399 */     GIR_EraseRootFromParent_Done,
     /*  387400 */   // Label 6941: @387400
     /*  387400 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(387466), // Rule ID 61514 //
     /*  387405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  387416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  387419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  387422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387444 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  387444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  387447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387464 */     GIR_RootConstrainSelectedInstOperands,
     /*  387465 */     // GIR_Coverage, 61514,
     /*  387465 */     GIR_EraseRootFromParent_Done,
     /*  387466 */   // Label 6942: @387466
     /*  387466 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(387532), // Rule ID 61515 //
     /*  387471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  387482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  387485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  387488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387510 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  387510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  387513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387530 */     GIR_RootConstrainSelectedInstOperands,
     /*  387531 */     // GIR_Coverage, 61515,
     /*  387531 */     GIR_EraseRootFromParent_Done,
     /*  387532 */   // Label 6943: @387532
     /*  387532 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(387598), // Rule ID 61518 //
     /*  387537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  387548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  387551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  387554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387576 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11494:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  387576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  387579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387596 */     GIR_RootConstrainSelectedInstOperands,
     /*  387597 */     // GIR_Coverage, 61518,
     /*  387597 */     GIR_EraseRootFromParent_Done,
     /*  387598 */   // Label 6944: @387598
     /*  387598 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(387664), // Rule ID 61519 //
     /*  387603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  387614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  387617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  387620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387642 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11494:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  387642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  387645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387662 */     GIR_RootConstrainSelectedInstOperands,
     /*  387663 */     // GIR_Coverage, 61519,
     /*  387663 */     GIR_EraseRootFromParent_Done,
     /*  387664 */   // Label 6945: @387664
     /*  387664 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(387730), // Rule ID 61522 //
     /*  387669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  387680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  387683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  387686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387708 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  387708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  387711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387728 */     GIR_RootConstrainSelectedInstOperands,
     /*  387729 */     // GIR_Coverage, 61522,
     /*  387729 */     GIR_EraseRootFromParent_Done,
     /*  387730 */   // Label 6946: @387730
     /*  387730 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(387796), // Rule ID 61523 //
     /*  387735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  387746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  387749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  387752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387774 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  387774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  387777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387794 */     GIR_RootConstrainSelectedInstOperands,
     /*  387795 */     // GIR_Coverage, 61523,
     /*  387795 */     GIR_EraseRootFromParent_Done,
     /*  387796 */   // Label 6947: @387796
     /*  387796 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(387862), // Rule ID 61526 //
     /*  387801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  387812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  387815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  387818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387840 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  387840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  387843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387860 */     GIR_RootConstrainSelectedInstOperands,
     /*  387861 */     // GIR_Coverage, 61526,
     /*  387861 */     GIR_EraseRootFromParent_Done,
     /*  387862 */   // Label 6948: @387862
     /*  387862 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(387928), // Rule ID 61527 //
     /*  387867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  387878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  387881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  387884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387906 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  387906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  387909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387926 */     GIR_RootConstrainSelectedInstOperands,
     /*  387927 */     // GIR_Coverage, 61527,
     /*  387927 */     GIR_EraseRootFromParent_Done,
     /*  387928 */   // Label 6949: @387928
     /*  387928 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(387994), // Rule ID 61530 //
     /*  387933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  387944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  387947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  387950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387972 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11494:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  387972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  387975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387992 */     GIR_RootConstrainSelectedInstOperands,
     /*  387993 */     // GIR_Coverage, 61530,
     /*  387993 */     GIR_EraseRootFromParent_Done,
     /*  387994 */   // Label 6950: @387994
     /*  387994 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(388060), // Rule ID 61531 //
     /*  387999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  388010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  388013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  388016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388038 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11494:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  388038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  388041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388058 */     GIR_RootConstrainSelectedInstOperands,
     /*  388059 */     // GIR_Coverage, 61531,
     /*  388059 */     GIR_EraseRootFromParent_Done,
     /*  388060 */   // Label 6951: @388060
     /*  388060 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(388126), // Rule ID 61534 //
     /*  388065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  388076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  388079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  388082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388104 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  388104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  388107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388124 */     GIR_RootConstrainSelectedInstOperands,
     /*  388125 */     // GIR_Coverage, 61534,
     /*  388125 */     GIR_EraseRootFromParent_Done,
     /*  388126 */   // Label 6952: @388126
     /*  388126 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(388192), // Rule ID 61535 //
     /*  388131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  388142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  388145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  388148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388170 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  388170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  388173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388190 */     GIR_RootConstrainSelectedInstOperands,
     /*  388191 */     // GIR_Coverage, 61535,
     /*  388191 */     GIR_EraseRootFromParent_Done,
     /*  388192 */   // Label 6953: @388192
     /*  388192 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(388258), // Rule ID 61538 //
     /*  388197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  388208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  388211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  388214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388236 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  388236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  388239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388256 */     GIR_RootConstrainSelectedInstOperands,
     /*  388257 */     // GIR_Coverage, 61538,
     /*  388257 */     GIR_EraseRootFromParent_Done,
     /*  388258 */   // Label 6954: @388258
     /*  388258 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(388324), // Rule ID 61539 //
     /*  388263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  388274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  388277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  388280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  388302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  388305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388322 */     GIR_RootConstrainSelectedInstOperands,
     /*  388323 */     // GIR_Coverage, 61539,
     /*  388323 */     GIR_EraseRootFromParent_Done,
     /*  388324 */   // Label 6955: @388324
     /*  388324 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(388390), // Rule ID 61542 //
     /*  388329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  388340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  388343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  388346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11494:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  388368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  388371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388388 */     GIR_RootConstrainSelectedInstOperands,
     /*  388389 */     // GIR_Coverage, 61542,
     /*  388389 */     GIR_EraseRootFromParent_Done,
     /*  388390 */   // Label 6956: @388390
     /*  388390 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(388456), // Rule ID 61543 //
     /*  388395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  388406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  388409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  388412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388434 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11494:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  388434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  388437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388454 */     GIR_RootConstrainSelectedInstOperands,
     /*  388455 */     // GIR_Coverage, 61543,
     /*  388455 */     GIR_EraseRootFromParent_Done,
     /*  388456 */   // Label 6957: @388456
     /*  388456 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(388522), // Rule ID 61546 //
     /*  388461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  388472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  388475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  388478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388500 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  388500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  388503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388520 */     GIR_RootConstrainSelectedInstOperands,
     /*  388521 */     // GIR_Coverage, 61546,
     /*  388521 */     GIR_EraseRootFromParent_Done,
     /*  388522 */   // Label 6958: @388522
     /*  388522 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(388588), // Rule ID 61547 //
     /*  388527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  388538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  388541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  388544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  388566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  388569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388586 */     GIR_RootConstrainSelectedInstOperands,
     /*  388587 */     // GIR_Coverage, 61547,
     /*  388587 */     GIR_EraseRootFromParent_Done,
     /*  388588 */   // Label 6959: @388588
     /*  388588 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(388654), // Rule ID 61550 //
     /*  388593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  388604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  388607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  388610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388632 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  388632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  388635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388652 */     GIR_RootConstrainSelectedInstOperands,
     /*  388653 */     // GIR_Coverage, 61550,
     /*  388653 */     GIR_EraseRootFromParent_Done,
     /*  388654 */   // Label 6960: @388654
     /*  388654 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(388720), // Rule ID 61551 //
     /*  388659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  388670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  388673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  388676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388698 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  388698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  388701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388718 */     GIR_RootConstrainSelectedInstOperands,
     /*  388719 */     // GIR_Coverage, 61551,
     /*  388719 */     GIR_EraseRootFromParent_Done,
     /*  388720 */   // Label 6961: @388720
     /*  388720 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(388786), // Rule ID 61554 //
     /*  388725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  388736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  388739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  388742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388764 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11494:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  388764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  388767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388784 */     GIR_RootConstrainSelectedInstOperands,
     /*  388785 */     // GIR_Coverage, 61554,
     /*  388785 */     GIR_EraseRootFromParent_Done,
     /*  388786 */   // Label 6962: @388786
     /*  388786 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(388852), // Rule ID 61555 //
     /*  388791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  388802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  388805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  388808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388830 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11494:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  388830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  388833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388850 */     GIR_RootConstrainSelectedInstOperands,
     /*  388851 */     // GIR_Coverage, 61555,
     /*  388851 */     GIR_EraseRootFromParent_Done,
     /*  388852 */   // Label 6963: @388852
     /*  388852 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(388917), // Rule ID 64446 //
     /*  388857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  388860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  388865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  388868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  388871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  388874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  388881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  388885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  388889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  388901 */     // MIs[1] Operand 1
     /*  388901 */     // No operand predicates
     /*  388901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388903 */     // (intrinsic_wo_chain:{ *:[i32] } 10950:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  388903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDN),
     /*  388906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  388910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  388915 */     GIR_RootConstrainSelectedInstOperands,
     /*  388916 */     // GIR_Coverage, 64446,
     /*  388916 */     GIR_EraseRootFromParent_Done,
     /*  388917 */   // Label 6964: @388917
     /*  388917 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(388982), // Rule ID 64473 //
     /*  388922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  388925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  388930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  388933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  388936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  388939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  388946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  388950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  388954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  388966 */     // MIs[1] Operand 1
     /*  388966 */     // No operand predicates
     /*  388966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388968 */     // (intrinsic_wo_chain:{ *:[i32] } 10952:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  388968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUN),
     /*  388971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  388975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  388980 */     GIR_RootConstrainSelectedInstOperands,
     /*  388981 */     // GIR_Coverage, 64473,
     /*  388981 */     GIR_EraseRootFromParent_Done,
     /*  388982 */   // Label 6965: @388982
     /*  388982 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(389047), // Rule ID 64476 //
     /*  388987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  388990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  388995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  388998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  389031 */     // MIs[1] Operand 1
     /*  389031 */     // No operand predicates
     /*  389031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389033 */     // (intrinsic_wo_chain:{ *:[i32] } 10951:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  389033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRN),
     /*  389036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  389045 */     GIR_RootConstrainSelectedInstOperands,
     /*  389046 */     // GIR_Coverage, 64476,
     /*  389046 */     GIR_EraseRootFromParent_Done,
     /*  389047 */   // Label 6966: @389047
     /*  389047 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(389112), // Rule ID 64479 //
     /*  389052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  389055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  389060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  389096 */     // MIs[1] Operand 1
     /*  389096 */     // No operand predicates
     /*  389096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389098 */     // (intrinsic_wo_chain:{ *:[i32] } 10953:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  389098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURN),
     /*  389101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  389110 */     GIR_RootConstrainSelectedInstOperands,
     /*  389111 */     // GIR_Coverage, 64479,
     /*  389111 */     GIR_EraseRootFromParent_Done,
     /*  389112 */   // Label 6967: @389112
     /*  389112 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(389177), // Rule ID 64482 //
     /*  389117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  389120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  389125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  389161 */     // MIs[1] Operand 1
     /*  389161 */     // No operand predicates
     /*  389161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389163 */     // (intrinsic_wo_chain:{ *:[i32] } 10956:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  389163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBN),
     /*  389166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  389175 */     GIR_RootConstrainSelectedInstOperands,
     /*  389176 */     // GIR_Coverage, 64482,
     /*  389176 */     GIR_EraseRootFromParent_Done,
     /*  389177 */   // Label 6968: @389177
     /*  389177 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(389242), // Rule ID 64485 //
     /*  389182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  389185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  389190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  389226 */     // MIs[1] Operand 1
     /*  389226 */     // No operand predicates
     /*  389226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389228 */     // (intrinsic_wo_chain:{ *:[i32] } 10958:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  389228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUN),
     /*  389231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  389240 */     GIR_RootConstrainSelectedInstOperands,
     /*  389241 */     // GIR_Coverage, 64485,
     /*  389241 */     GIR_EraseRootFromParent_Done,
     /*  389242 */   // Label 6969: @389242
     /*  389242 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(389307), // Rule ID 64488 //
     /*  389247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  389250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  389255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  389291 */     // MIs[1] Operand 1
     /*  389291 */     // No operand predicates
     /*  389291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389293 */     // (intrinsic_wo_chain:{ *:[i32] } 10957:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  389293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRN),
     /*  389296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  389305 */     GIR_RootConstrainSelectedInstOperands,
     /*  389306 */     // GIR_Coverage, 64488,
     /*  389306 */     GIR_EraseRootFromParent_Done,
     /*  389307 */   // Label 6970: @389307
     /*  389307 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(389372), // Rule ID 64491 //
     /*  389312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  389315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  389320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  389356 */     // MIs[1] Operand 1
     /*  389356 */     // No operand predicates
     /*  389356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389358 */     // (intrinsic_wo_chain:{ *:[i32] } 10959:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  389358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURN),
     /*  389361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  389370 */     GIR_RootConstrainSelectedInstOperands,
     /*  389371 */     // GIR_Coverage, 64491,
     /*  389371 */     GIR_EraseRootFromParent_Done,
     /*  389372 */   // Label 6971: @389372
     /*  389372 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(389427), // Rule ID 2639 //
     /*  389377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  389380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsi),
     /*  389385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389406 */     // MIs[0] imm
     /*  389406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389409 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  389414 */     // (intrinsic_wo_chain:{ *:[i32] } 10935:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  389414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSI),
     /*  389417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389423 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  389425 */     GIR_RootConstrainSelectedInstOperands,
     /*  389426 */     // GIR_Coverage, 2639,
     /*  389426 */     GIR_EraseRootFromParent_Done,
     /*  389427 */   // Label 6972: @389427
     /*  389427 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(389482), // Rule ID 2640 //
     /*  389432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  389435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsmi),
     /*  389440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389461 */     // MIs[0] imm
     /*  389461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389464 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  389469 */     // (intrinsic_wo_chain:{ *:[i32] } 10936:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  389469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSMI),
     /*  389472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389478 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  389480 */     GIR_RootConstrainSelectedInstOperands,
     /*  389481 */     // GIR_Coverage, 2640,
     /*  389481 */     GIR_EraseRootFromParent_Done,
     /*  389482 */   // Label 6973: @389482
     /*  389482 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(389537), // Rule ID 2646 //
     /*  389487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  389490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esi),
     /*  389495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389516 */     // MIs[0] imm
     /*  389516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  389524 */     // (intrinsic_wo_chain:{ *:[i32] } 10937:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  389524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESI),
     /*  389527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389533 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  389535 */     GIR_RootConstrainSelectedInstOperands,
     /*  389536 */     // GIR_Coverage, 2646,
     /*  389536 */     GIR_EraseRootFromParent_Done,
     /*  389537 */   // Label 6974: @389537
     /*  389537 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(389592), // Rule ID 2647 //
     /*  389542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  389545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esmi),
     /*  389550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389571 */     // MIs[0] imm
     /*  389571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  389579 */     // (intrinsic_wo_chain:{ *:[i32] } 10938:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  389579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESMI),
     /*  389582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389588 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  389590 */     GIR_RootConstrainSelectedInstOperands,
     /*  389591 */     // GIR_Coverage, 2647,
     /*  389591 */     GIR_EraseRootFromParent_Done,
     /*  389592 */   // Label 6975: @389592
     /*  389592 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(389647), // Rule ID 64502 //
     /*  389597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluN),
     /*  389605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389626 */     // MIs[0] imm5
     /*  389626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389634 */     // (intrinsic_wo_chain:{ *:[i32] } 10983:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULUN),
     /*  389637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389643 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389645 */     GIR_RootConstrainSelectedInstOperands,
     /*  389646 */     // GIR_Coverage, 64502,
     /*  389646 */     GIR_EraseRootFromParent_Done,
     /*  389647 */   // Label 6976: @389647
     /*  389647 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(389702), // Rule ID 64503 //
     /*  389652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuN),
     /*  389660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389681 */     // MIs[0] imm5
     /*  389681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389689 */     // (intrinsic_wo_chain:{ *:[i32] } 10979:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHUN),
     /*  389692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389698 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389700 */     GIR_RootConstrainSelectedInstOperands,
     /*  389701 */     // GIR_Coverage, 64503,
     /*  389701 */     GIR_EraseRootFromParent_Done,
     /*  389702 */   // Label 6977: @389702
     /*  389702 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(389757), // Rule ID 64504 //
     /*  389707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsN),
     /*  389715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389736 */     // MIs[0] imm5
     /*  389736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389744 */     // (intrinsic_wo_chain:{ *:[i32] } 10981:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSN),
     /*  389747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389753 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389755 */     GIR_RootConstrainSelectedInstOperands,
     /*  389756 */     // GIR_Coverage, 64504,
     /*  389756 */     GIR_EraseRootFromParent_Done,
     /*  389757 */   // Label 6978: @389757
     /*  389757 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(389812), // Rule ID 64505 //
     /*  389762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsN),
     /*  389770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389791 */     // MIs[0] imm5
     /*  389791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389799 */     // (intrinsic_wo_chain:{ *:[i32] } 10977:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSN),
     /*  389802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389808 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389810 */     GIR_RootConstrainSelectedInstOperands,
     /*  389811 */     // GIR_Coverage, 64505,
     /*  389811 */     GIR_EraseRootFromParent_Done,
     /*  389812 */   // Label 6979: @389812
     /*  389812 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(389867), // Rule ID 64506 //
     /*  389817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluRN),
     /*  389825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389846 */     // MIs[0] imm5
     /*  389846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389854 */     // (intrinsic_wo_chain:{ *:[i32] } 10984:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULURN),
     /*  389857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389863 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389865 */     GIR_RootConstrainSelectedInstOperands,
     /*  389866 */     // GIR_Coverage, 64506,
     /*  389866 */     GIR_EraseRootFromParent_Done,
     /*  389867 */   // Label 6980: @389867
     /*  389867 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(389922), // Rule ID 64507 //
     /*  389872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuRN),
     /*  389880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389901 */     // MIs[0] imm5
     /*  389901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389909 */     // (intrinsic_wo_chain:{ *:[i32] } 10980:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHURN),
     /*  389912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389918 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389920 */     GIR_RootConstrainSelectedInstOperands,
     /*  389921 */     // GIR_Coverage, 64507,
     /*  389921 */     GIR_EraseRootFromParent_Done,
     /*  389922 */   // Label 6981: @389922
     /*  389922 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(389977), // Rule ID 64508 //
     /*  389927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsRN),
     /*  389935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389956 */     // MIs[0] imm5
     /*  389956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389964 */     // (intrinsic_wo_chain:{ *:[i32] } 10982:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSRN),
     /*  389967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389973 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389975 */     GIR_RootConstrainSelectedInstOperands,
     /*  389976 */     // GIR_Coverage, 64508,
     /*  389976 */     GIR_EraseRootFromParent_Done,
     /*  389977 */   // Label 6982: @389977
     /*  389977 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(390032), // Rule ID 64509 //
     /*  389982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsRN),
     /*  389990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390011 */     // MIs[0] imm5
     /*  390011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  390019 */     // (intrinsic_wo_chain:{ *:[i32] } 10978:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  390019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSRN),
     /*  390022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390028 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  390030 */     GIR_RootConstrainSelectedInstOperands,
     /*  390031 */     // GIR_Coverage, 64509,
     /*  390031 */     GIR_EraseRootFromParent_Done,
     /*  390032 */   // Label 6983: @390032
     /*  390032 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(390086), // Rule ID 64444 //
     /*  390037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  390045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390073 */     // (intrinsic_wo_chain:{ *:[i32] } 10950:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  390076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390084 */     GIR_RootConstrainSelectedInstOperands,
     /*  390085 */     // GIR_Coverage, 64444,
     /*  390085 */     GIR_EraseRootFromParent_Done,
     /*  390086 */   // Label 6984: @390086
     /*  390086 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(390140), // Rule ID 64445 //
     /*  390091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  390099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390127 */     // (intrinsic_wo_chain:{ *:[i32] } 10950:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  390130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390138 */     GIR_RootConstrainSelectedInstOperands,
     /*  390139 */     // GIR_Coverage, 64445,
     /*  390139 */     GIR_EraseRootFromParent_Done,
     /*  390140 */   // Label 6985: @390140
     /*  390140 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(390194), // Rule ID 64471 //
     /*  390145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  390153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390181 */     // (intrinsic_wo_chain:{ *:[i32] } 10952:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  390184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390192 */     GIR_RootConstrainSelectedInstOperands,
     /*  390193 */     // GIR_Coverage, 64471,
     /*  390193 */     GIR_EraseRootFromParent_Done,
     /*  390194 */   // Label 6986: @390194
     /*  390194 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(390248), // Rule ID 64472 //
     /*  390199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  390207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390235 */     // (intrinsic_wo_chain:{ *:[i32] } 10952:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  390238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390246 */     GIR_RootConstrainSelectedInstOperands,
     /*  390247 */     // GIR_Coverage, 64472,
     /*  390247 */     GIR_EraseRootFromParent_Done,
     /*  390248 */   // Label 6987: @390248
     /*  390248 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(390302), // Rule ID 64474 //
     /*  390253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  390261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390289 */     // (intrinsic_wo_chain:{ *:[i32] } 10951:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  390292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390300 */     GIR_RootConstrainSelectedInstOperands,
     /*  390301 */     // GIR_Coverage, 64474,
     /*  390301 */     GIR_EraseRootFromParent_Done,
     /*  390302 */   // Label 6988: @390302
     /*  390302 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(390356), // Rule ID 64475 //
     /*  390307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  390315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390343 */     // (intrinsic_wo_chain:{ *:[i32] } 10951:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  390346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390354 */     GIR_RootConstrainSelectedInstOperands,
     /*  390355 */     // GIR_Coverage, 64475,
     /*  390355 */     GIR_EraseRootFromParent_Done,
     /*  390356 */   // Label 6989: @390356
     /*  390356 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(390410), // Rule ID 64477 //
     /*  390361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  390369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390397 */     // (intrinsic_wo_chain:{ *:[i32] } 10953:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  390400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390408 */     GIR_RootConstrainSelectedInstOperands,
     /*  390409 */     // GIR_Coverage, 64477,
     /*  390409 */     GIR_EraseRootFromParent_Done,
     /*  390410 */   // Label 6990: @390410
     /*  390410 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(390464), // Rule ID 64478 //
     /*  390415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  390423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390451 */     // (intrinsic_wo_chain:{ *:[i32] } 10953:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  390454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390462 */     GIR_RootConstrainSelectedInstOperands,
     /*  390463 */     // GIR_Coverage, 64478,
     /*  390463 */     GIR_EraseRootFromParent_Done,
     /*  390464 */   // Label 6991: @390464
     /*  390464 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(390518), // Rule ID 64480 //
     /*  390469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  390477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390505 */     // (intrinsic_wo_chain:{ *:[i32] } 10956:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  390508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390516 */     GIR_RootConstrainSelectedInstOperands,
     /*  390517 */     // GIR_Coverage, 64480,
     /*  390517 */     GIR_EraseRootFromParent_Done,
     /*  390518 */   // Label 6992: @390518
     /*  390518 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(390572), // Rule ID 64481 //
     /*  390523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  390531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390559 */     // (intrinsic_wo_chain:{ *:[i32] } 10956:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  390562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390570 */     GIR_RootConstrainSelectedInstOperands,
     /*  390571 */     // GIR_Coverage, 64481,
     /*  390571 */     GIR_EraseRootFromParent_Done,
     /*  390572 */   // Label 6993: @390572
     /*  390572 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(390626), // Rule ID 64483 //
     /*  390577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  390585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390613 */     // (intrinsic_wo_chain:{ *:[i32] } 10958:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  390616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390624 */     GIR_RootConstrainSelectedInstOperands,
     /*  390625 */     // GIR_Coverage, 64483,
     /*  390625 */     GIR_EraseRootFromParent_Done,
     /*  390626 */   // Label 6994: @390626
     /*  390626 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(390680), // Rule ID 64484 //
     /*  390631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  390639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390667 */     // (intrinsic_wo_chain:{ *:[i32] } 10958:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  390670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390678 */     GIR_RootConstrainSelectedInstOperands,
     /*  390679 */     // GIR_Coverage, 64484,
     /*  390679 */     GIR_EraseRootFromParent_Done,
     /*  390680 */   // Label 6995: @390680
     /*  390680 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(390734), // Rule ID 64486 //
     /*  390685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  390693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390721 */     // (intrinsic_wo_chain:{ *:[i32] } 10957:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  390724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390732 */     GIR_RootConstrainSelectedInstOperands,
     /*  390733 */     // GIR_Coverage, 64486,
     /*  390733 */     GIR_EraseRootFromParent_Done,
     /*  390734 */   // Label 6996: @390734
     /*  390734 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(390788), // Rule ID 64487 //
     /*  390739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  390747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390775 */     // (intrinsic_wo_chain:{ *:[i32] } 10957:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  390778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390786 */     GIR_RootConstrainSelectedInstOperands,
     /*  390787 */     // GIR_Coverage, 64487,
     /*  390787 */     GIR_EraseRootFromParent_Done,
     /*  390788 */   // Label 6997: @390788
     /*  390788 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(390842), // Rule ID 64489 //
     /*  390793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  390801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390829 */     // (intrinsic_wo_chain:{ *:[i32] } 10959:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  390832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390840 */     GIR_RootConstrainSelectedInstOperands,
     /*  390841 */     // GIR_Coverage, 64489,
     /*  390841 */     GIR_EraseRootFromParent_Done,
     /*  390842 */   // Label 6998: @390842
     /*  390842 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(390896), // Rule ID 64490 //
     /*  390847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  390855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390883 */     // (intrinsic_wo_chain:{ *:[i32] } 10959:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  390886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390894 */     GIR_RootConstrainSelectedInstOperands,
     /*  390895 */     // GIR_Coverage, 64490,
     /*  390895 */     GIR_EraseRootFromParent_Done,
     /*  390896 */   // Label 6999: @390896
     /*  390896 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(390950), // Rule ID 64427 //
     /*  390901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /*  390904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  390909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390937 */     // (intrinsic_wo_chain:{ *:[i32] } 10966:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  390937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  390940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  390944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390948 */     GIR_RootConstrainSelectedInstOperands,
     /*  390949 */     // GIR_Coverage, 64427,
     /*  390949 */     GIR_EraseRootFromParent_Done,
     /*  390950 */   // Label 7000: @390950
     /*  390950 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(391004), // Rule ID 64428 //
     /*  390955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  390958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  390963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390991 */     // (intrinsic_wo_chain:{ *:[i32] } 10966:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  390991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  390994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  390998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  391000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  391002 */     GIR_RootConstrainSelectedInstOperands,
     /*  391003 */     // GIR_Coverage, 64428,
     /*  391003 */     GIR_EraseRootFromParent_Done,
     /*  391004 */   // Label 7001: @391004
     /*  391004 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(391058), // Rule ID 64498 //
     /*  391009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  391012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  391017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  391020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  391023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  391026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391045 */     // (intrinsic_wo_chain:{ *:[i32] } 10967:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  391045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  391048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  391050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  391052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  391054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  391056 */     GIR_RootConstrainSelectedInstOperands,
     /*  391057 */     // GIR_Coverage, 64498,
     /*  391057 */     GIR_EraseRootFromParent_Done,
     /*  391058 */   // Label 7002: @391058
     /*  391058 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(391112), // Rule ID 64499 //
     /*  391063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  391066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  391071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  391074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  391077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  391080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391099 */     // (intrinsic_wo_chain:{ *:[i32] } 10967:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  391099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  391102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  391104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  391106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  391108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  391110 */     GIR_RootConstrainSelectedInstOperands,
     /*  391111 */     // GIR_Coverage, 64499,
     /*  391111 */     GIR_EraseRootFromParent_Done,
     /*  391112 */   // Label 7003: @391112
     /*  391112 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(391166), // Rule ID 64500 //
     /*  391117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  391120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  391125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  391128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  391131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  391134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391153 */     // (intrinsic_wo_chain:{ *:[i32] } 10976:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  391153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  391156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  391158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  391160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  391162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  391164 */     GIR_RootConstrainSelectedInstOperands,
     /*  391165 */     // GIR_Coverage, 64500,
     /*  391165 */     GIR_EraseRootFromParent_Done,
     /*  391166 */   // Label 7004: @391166
     /*  391166 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(391220), // Rule ID 64501 //
     /*  391171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  391174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  391179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  391182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  391185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  391188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391207 */     // (intrinsic_wo_chain:{ *:[i32] } 10976:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  391207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  391210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  391212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  391214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  391216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  391218 */     GIR_RootConstrainSelectedInstOperands,
     /*  391219 */     // GIR_Coverage, 64501,
     /*  391219 */     GIR_EraseRootFromParent_Done,
     /*  391220 */   // Label 7005: @391220
     /*  391220 */   GIM_Reject,
     /*  391221 */ // Label 4380: @391221
     /*  391221 */ GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(909998),
     /*  391226 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  391229 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(391304), // Rule ID 62831 //
     /*  391234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  391245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391252 */     // MIs[0] op1
     /*  391252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391260 */     // MIs[0] op2
     /*  391260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391268 */     // MIs[0] op3
     /*  391268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391283 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF8),
     /*  391286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391288 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391290 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391292 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391302 */     GIR_RootConstrainSelectedInstOperands,
     /*  391303 */     // GIR_Coverage, 62831,
     /*  391303 */     GIR_EraseRootFromParent_Done,
     /*  391304 */   // Label 7007: @391304
     /*  391304 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(391379), // Rule ID 62832 //
     /*  391309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  391320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391327 */     // MIs[0] op1
     /*  391327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391335 */     // MIs[0] op2
     /*  391335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391343 */     // MIs[0] op3
     /*  391343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391346 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391358 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF8),
     /*  391361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391363 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391365 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391367 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391377 */     GIR_RootConstrainSelectedInstOperands,
     /*  391378 */     // GIR_Coverage, 62832,
     /*  391378 */     GIR_EraseRootFromParent_Done,
     /*  391379 */   // Label 7008: @391379
     /*  391379 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(391454), // Rule ID 62863 //
     /*  391384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  391395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391402 */     // MIs[0] op1
     /*  391402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391405 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391410 */     // MIs[0] op2
     /*  391410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391413 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391418 */     // MIs[0] op3
     /*  391418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391433 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  391436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391438 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391440 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391442 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391452 */     GIR_RootConstrainSelectedInstOperands,
     /*  391453 */     // GIR_Coverage, 62863,
     /*  391453 */     GIR_EraseRootFromParent_Done,
     /*  391454 */   // Label 7009: @391454
     /*  391454 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(391529), // Rule ID 62864 //
     /*  391459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  391470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391477 */     // MIs[0] op1
     /*  391477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391485 */     // MIs[0] op2
     /*  391485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391493 */     // MIs[0] op3
     /*  391493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391496 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391508 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  391511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391513 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391515 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391517 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391527 */     GIR_RootConstrainSelectedInstOperands,
     /*  391528 */     // GIR_Coverage, 62864,
     /*  391528 */     GIR_EraseRootFromParent_Done,
     /*  391529 */   // Label 7010: @391529
     /*  391529 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(391604), // Rule ID 62907 //
     /*  391534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  391545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391552 */     // MIs[0] op1
     /*  391552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391555 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391560 */     // MIs[0] op2
     /*  391560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391568 */     // MIs[0] op3
     /*  391568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391583 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  391586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391588 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391590 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391592 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391602 */     GIR_RootConstrainSelectedInstOperands,
     /*  391603 */     // GIR_Coverage, 62907,
     /*  391603 */     GIR_EraseRootFromParent_Done,
     /*  391604 */   // Label 7011: @391604
     /*  391604 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(391679), // Rule ID 62908 //
     /*  391609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  391620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391627 */     // MIs[0] op1
     /*  391627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391635 */     // MIs[0] op2
     /*  391635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391643 */     // MIs[0] op3
     /*  391643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391658 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  391661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391663 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391665 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391667 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391677 */     GIR_RootConstrainSelectedInstOperands,
     /*  391678 */     // GIR_Coverage, 62908,
     /*  391678 */     GIR_EraseRootFromParent_Done,
     /*  391679 */   // Label 7012: @391679
     /*  391679 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(391754), // Rule ID 62951 //
     /*  391684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391702 */     // MIs[0] op1
     /*  391702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391705 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391710 */     // MIs[0] op2
     /*  391710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391718 */     // MIs[0] op3
     /*  391718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391733 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  391736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391738 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391740 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391742 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391752 */     GIR_RootConstrainSelectedInstOperands,
     /*  391753 */     // GIR_Coverage, 62951,
     /*  391753 */     GIR_EraseRootFromParent_Done,
     /*  391754 */   // Label 7013: @391754
     /*  391754 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(391829), // Rule ID 62952 //
     /*  391759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391777 */     // MIs[0] op1
     /*  391777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391785 */     // MIs[0] op2
     /*  391785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391793 */     // MIs[0] op3
     /*  391793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391808 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  391811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391813 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391815 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391817 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391827 */     GIR_RootConstrainSelectedInstOperands,
     /*  391828 */     // GIR_Coverage, 62952,
     /*  391828 */     GIR_EraseRootFromParent_Done,
     /*  391829 */   // Label 7014: @391829
     /*  391829 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(391904), // Rule ID 63007 //
     /*  391834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  391845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391852 */     // MIs[0] op1
     /*  391852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391860 */     // MIs[0] op2
     /*  391860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391868 */     // MIs[0] op3
     /*  391868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391871 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391883 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  391886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391888 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391890 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391892 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391902 */     GIR_RootConstrainSelectedInstOperands,
     /*  391903 */     // GIR_Coverage, 63007,
     /*  391903 */     GIR_EraseRootFromParent_Done,
     /*  391904 */   // Label 7015: @391904
     /*  391904 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(391979), // Rule ID 63008 //
     /*  391909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  391920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391927 */     // MIs[0] op1
     /*  391927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391930 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391935 */     // MIs[0] op2
     /*  391935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391938 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391943 */     // MIs[0] op3
     /*  391943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  391961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391963 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391965 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391967 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391977 */     GIR_RootConstrainSelectedInstOperands,
     /*  391978 */     // GIR_Coverage, 63008,
     /*  391978 */     GIR_EraseRootFromParent_Done,
     /*  391979 */   // Label 7016: @391979
     /*  391979 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(392054), // Rule ID 63063 //
     /*  391984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  391995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392002 */     // MIs[0] op1
     /*  392002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392010 */     // MIs[0] op2
     /*  392010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392013 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392018 */     // MIs[0] op3
     /*  392018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392033 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  392033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  392036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392038 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392040 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392042 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392052 */     GIR_RootConstrainSelectedInstOperands,
     /*  392053 */     // GIR_Coverage, 63063,
     /*  392053 */     GIR_EraseRootFromParent_Done,
     /*  392054 */   // Label 7017: @392054
     /*  392054 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(392129), // Rule ID 63064 //
     /*  392059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  392070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392077 */     // MIs[0] op1
     /*  392077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392080 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392085 */     // MIs[0] op2
     /*  392085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392093 */     // MIs[0] op3
     /*  392093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  392108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  392111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392113 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392115 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392117 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392127 */     GIR_RootConstrainSelectedInstOperands,
     /*  392128 */     // GIR_Coverage, 63064,
     /*  392128 */     GIR_EraseRootFromParent_Done,
     /*  392129 */   // Label 7018: @392129
     /*  392129 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(392204), // Rule ID 63119 //
     /*  392134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  392145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392152 */     // MIs[0] op1
     /*  392152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392155 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392160 */     // MIs[0] op2
     /*  392160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392163 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392168 */     // MIs[0] op3
     /*  392168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392171 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392183 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392188 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392190 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392192 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392202 */     GIR_RootConstrainSelectedInstOperands,
     /*  392203 */     // GIR_Coverage, 63119,
     /*  392203 */     GIR_EraseRootFromParent_Done,
     /*  392204 */   // Label 7019: @392204
     /*  392204 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(392279), // Rule ID 63120 //
     /*  392209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  392220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392227 */     // MIs[0] op1
     /*  392227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392235 */     // MIs[0] op2
     /*  392235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392243 */     // MIs[0] op3
     /*  392243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392258 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392263 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392265 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392267 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392277 */     GIR_RootConstrainSelectedInstOperands,
     /*  392278 */     // GIR_Coverage, 63120,
     /*  392278 */     GIR_EraseRootFromParent_Done,
     /*  392279 */   // Label 7020: @392279
     /*  392279 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(392354), // Rule ID 63163 //
     /*  392284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  392295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392302 */     // MIs[0] op1
     /*  392302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392310 */     // MIs[0] op2
     /*  392310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392313 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392318 */     // MIs[0] op3
     /*  392318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392333 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  392333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392338 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392340 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392342 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392352 */     GIR_RootConstrainSelectedInstOperands,
     /*  392353 */     // GIR_Coverage, 63163,
     /*  392353 */     GIR_EraseRootFromParent_Done,
     /*  392354 */   // Label 7021: @392354
     /*  392354 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(392429), // Rule ID 63164 //
     /*  392359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  392370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392377 */     // MIs[0] op1
     /*  392377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392385 */     // MIs[0] op2
     /*  392385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392393 */     // MIs[0] op3
     /*  392393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392408 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  392408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392413 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392415 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392417 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392427 */     GIR_RootConstrainSelectedInstOperands,
     /*  392428 */     // GIR_Coverage, 63164,
     /*  392428 */     GIR_EraseRootFromParent_Done,
     /*  392429 */   // Label 7022: @392429
     /*  392429 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(392504), // Rule ID 63219 //
     /*  392434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  392445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392452 */     // MIs[0] op1
     /*  392452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392455 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392460 */     // MIs[0] op2
     /*  392460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392463 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392468 */     // MIs[0] op3
     /*  392468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392483 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  392483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392488 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392490 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392492 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392502 */     GIR_RootConstrainSelectedInstOperands,
     /*  392503 */     // GIR_Coverage, 63219,
     /*  392503 */     GIR_EraseRootFromParent_Done,
     /*  392504 */   // Label 7023: @392504
     /*  392504 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(392579), // Rule ID 63220 //
     /*  392509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  392520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392527 */     // MIs[0] op1
     /*  392527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392530 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392535 */     // MIs[0] op2
     /*  392535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392543 */     // MIs[0] op3
     /*  392543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  392558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392563 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392565 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392567 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392577 */     GIR_RootConstrainSelectedInstOperands,
     /*  392578 */     // GIR_Coverage, 63220,
     /*  392578 */     GIR_EraseRootFromParent_Done,
     /*  392579 */   // Label 7024: @392579
     /*  392579 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(392654), // Rule ID 63275 //
     /*  392584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  392595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392602 */     // MIs[0] op1
     /*  392602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392605 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392610 */     // MIs[0] op2
     /*  392610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392613 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392618 */     // MIs[0] op3
     /*  392618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392633 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  392633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392638 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392640 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392642 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  392652 */     GIR_RootConstrainSelectedInstOperands,
     /*  392653 */     // GIR_Coverage, 63275,
     /*  392653 */     GIR_EraseRootFromParent_Done,
     /*  392654 */   // Label 7025: @392654
     /*  392654 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(392729), // Rule ID 63276 //
     /*  392659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  392670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392677 */     // MIs[0] op1
     /*  392677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392685 */     // MIs[0] op2
     /*  392685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392688 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392693 */     // MIs[0] op3
     /*  392693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392708 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  392708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392713 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392715 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392717 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  392727 */     GIR_RootConstrainSelectedInstOperands,
     /*  392728 */     // GIR_Coverage, 63276,
     /*  392728 */     GIR_EraseRootFromParent_Done,
     /*  392729 */   // Label 7026: @392729
     /*  392729 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(392804), // Rule ID 63331 //
     /*  392734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  392745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392752 */     // MIs[0] op1
     /*  392752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392755 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392760 */     // MIs[0] op2
     /*  392760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392768 */     // MIs[0] op3
     /*  392768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392783 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  392786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392788 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392790 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392792 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392802 */     GIR_RootConstrainSelectedInstOperands,
     /*  392803 */     // GIR_Coverage, 63331,
     /*  392803 */     GIR_EraseRootFromParent_Done,
     /*  392804 */   // Label 7027: @392804
     /*  392804 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(392879), // Rule ID 63332 //
     /*  392809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  392820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392827 */     // MIs[0] op1
     /*  392827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392835 */     // MIs[0] op2
     /*  392835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392843 */     // MIs[0] op3
     /*  392843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  392861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392863 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392865 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392867 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392877 */     GIR_RootConstrainSelectedInstOperands,
     /*  392878 */     // GIR_Coverage, 63332,
     /*  392878 */     GIR_EraseRootFromParent_Done,
     /*  392879 */   // Label 7028: @392879
     /*  392879 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(392954), // Rule ID 63375 //
     /*  392884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  392895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392902 */     // MIs[0] op1
     /*  392902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392910 */     // MIs[0] op2
     /*  392910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392913 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392918 */     // MIs[0] op3
     /*  392918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392933 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  392936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392938 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392940 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392942 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392952 */     GIR_RootConstrainSelectedInstOperands,
     /*  392953 */     // GIR_Coverage, 63375,
     /*  392953 */     GIR_EraseRootFromParent_Done,
     /*  392954 */   // Label 7029: @392954
     /*  392954 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(393029), // Rule ID 63376 //
     /*  392959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  392970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392977 */     // MIs[0] op1
     /*  392977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392985 */     // MIs[0] op2
     /*  392985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392993 */     // MIs[0] op3
     /*  392993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393008 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  393008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  393011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393013 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393015 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393017 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393027 */     GIR_RootConstrainSelectedInstOperands,
     /*  393028 */     // GIR_Coverage, 63376,
     /*  393028 */     GIR_EraseRootFromParent_Done,
     /*  393029 */   // Label 7030: @393029
     /*  393029 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(393104), // Rule ID 63419 //
     /*  393034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  393045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393052 */     // MIs[0] op1
     /*  393052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393060 */     // MIs[0] op2
     /*  393060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393068 */     // MIs[0] op3
     /*  393068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393083 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  393083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  393086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393088 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393090 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393092 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393102 */     GIR_RootConstrainSelectedInstOperands,
     /*  393103 */     // GIR_Coverage, 63419,
     /*  393103 */     GIR_EraseRootFromParent_Done,
     /*  393104 */   // Label 7031: @393104
     /*  393104 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(393179), // Rule ID 63420 //
     /*  393109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  393120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393127 */     // MIs[0] op1
     /*  393127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393135 */     // MIs[0] op2
     /*  393135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393143 */     // MIs[0] op3
     /*  393143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393158 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  393158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  393161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393163 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393165 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393167 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393177 */     GIR_RootConstrainSelectedInstOperands,
     /*  393178 */     // GIR_Coverage, 63420,
     /*  393178 */     GIR_EraseRootFromParent_Done,
     /*  393179 */   // Label 7032: @393179
     /*  393179 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(393254), // Rule ID 63463 //
     /*  393184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  393195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393202 */     // MIs[0] op1
     /*  393202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393205 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393210 */     // MIs[0] op2
     /*  393210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393213 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393218 */     // MIs[0] op3
     /*  393218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393221 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393233 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  393233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  393236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393238 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393240 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393242 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393252 */     GIR_RootConstrainSelectedInstOperands,
     /*  393253 */     // GIR_Coverage, 63463,
     /*  393253 */     GIR_EraseRootFromParent_Done,
     /*  393254 */   // Label 7033: @393254
     /*  393254 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(393329), // Rule ID 63464 //
     /*  393259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  393270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393277 */     // MIs[0] op1
     /*  393277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393285 */     // MIs[0] op2
     /*  393285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393293 */     // MIs[0] op3
     /*  393293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  393311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393313 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393315 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393317 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393327 */     GIR_RootConstrainSelectedInstOperands,
     /*  393328 */     // GIR_Coverage, 63464,
     /*  393328 */     GIR_EraseRootFromParent_Done,
     /*  393329 */   // Label 7034: @393329
     /*  393329 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(393404), // Rule ID 63519 //
     /*  393334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  393345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393352 */     // MIs[0] op1
     /*  393352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393360 */     // MIs[0] op2
     /*  393360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393368 */     // MIs[0] op3
     /*  393368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393371 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393383 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  393383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  393386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393388 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393390 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393392 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393402 */     GIR_RootConstrainSelectedInstOperands,
     /*  393403 */     // GIR_Coverage, 63519,
     /*  393403 */     GIR_EraseRootFromParent_Done,
     /*  393404 */   // Label 7035: @393404
     /*  393404 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(393479), // Rule ID 63520 //
     /*  393409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  393420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393427 */     // MIs[0] op1
     /*  393427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393430 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393435 */     // MIs[0] op2
     /*  393435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393438 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393443 */     // MIs[0] op3
     /*  393443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393458 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  393461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393463 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393465 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393467 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393477 */     GIR_RootConstrainSelectedInstOperands,
     /*  393478 */     // GIR_Coverage, 63520,
     /*  393478 */     GIR_EraseRootFromParent_Done,
     /*  393479 */   // Label 7036: @393479
     /*  393479 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(393554), // Rule ID 63575 //
     /*  393484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  393495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393502 */     // MIs[0] op1
     /*  393502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393510 */     // MIs[0] op2
     /*  393510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393518 */     // MIs[0] op3
     /*  393518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393521 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393533 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  393533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  393536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393538 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393540 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393542 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393552 */     GIR_RootConstrainSelectedInstOperands,
     /*  393553 */     // GIR_Coverage, 63575,
     /*  393553 */     GIR_EraseRootFromParent_Done,
     /*  393554 */   // Label 7037: @393554
     /*  393554 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(393629), // Rule ID 63576 //
     /*  393559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  393570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393577 */     // MIs[0] op1
     /*  393577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393580 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393585 */     // MIs[0] op2
     /*  393585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393588 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393593 */     // MIs[0] op3
     /*  393593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393596 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  393611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393613 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393615 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393617 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393627 */     GIR_RootConstrainSelectedInstOperands,
     /*  393628 */     // GIR_Coverage, 63576,
     /*  393628 */     GIR_EraseRootFromParent_Done,
     /*  393629 */   // Label 7038: @393629
     /*  393629 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(393704), // Rule ID 63631 //
     /*  393634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393652 */     // MIs[0] op1
     /*  393652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393660 */     // MIs[0] op2
     /*  393660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393668 */     // MIs[0] op3
     /*  393668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393671 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393683 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  393686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393688 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393690 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393692 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393702 */     GIR_RootConstrainSelectedInstOperands,
     /*  393703 */     // GIR_Coverage, 63631,
     /*  393703 */     GIR_EraseRootFromParent_Done,
     /*  393704 */   // Label 7039: @393704
     /*  393704 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(393779), // Rule ID 63632 //
     /*  393709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393727 */     // MIs[0] op1
     /*  393727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393735 */     // MIs[0] op2
     /*  393735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393743 */     // MIs[0] op3
     /*  393743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393758 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  393761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393763 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393765 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393767 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393777 */     GIR_RootConstrainSelectedInstOperands,
     /*  393778 */     // GIR_Coverage, 63632,
     /*  393778 */     GIR_EraseRootFromParent_Done,
     /*  393779 */   // Label 7040: @393779
     /*  393779 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(393854), // Rule ID 63687 //
     /*  393784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393802 */     // MIs[0] op1
     /*  393802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393805 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393810 */     // MIs[0] op2
     /*  393810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393818 */     // MIs[0] op3
     /*  393818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393833 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  393836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393838 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393840 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393842 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393852 */     GIR_RootConstrainSelectedInstOperands,
     /*  393853 */     // GIR_Coverage, 63687,
     /*  393853 */     GIR_EraseRootFromParent_Done,
     /*  393854 */   // Label 7041: @393854
     /*  393854 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(393929), // Rule ID 63688 //
     /*  393859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393877 */     // MIs[0] op1
     /*  393877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393885 */     // MIs[0] op2
     /*  393885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393888 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393893 */     // MIs[0] op3
     /*  393893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393896 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393908 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  393911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393913 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393915 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393917 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393927 */     GIR_RootConstrainSelectedInstOperands,
     /*  393928 */     // GIR_Coverage, 63688,
     /*  393928 */     GIR_EraseRootFromParent_Done,
     /*  393929 */   // Label 7042: @393929
     /*  393929 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(394004), // Rule ID 63743 //
     /*  393934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  393945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393952 */     // MIs[0] op1
     /*  393952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393960 */     // MIs[0] op2
     /*  393960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393968 */     // MIs[0] op3
     /*  393968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393983 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  393986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393988 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393990 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393992 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394002 */     GIR_RootConstrainSelectedInstOperands,
     /*  394003 */     // GIR_Coverage, 63743,
     /*  394003 */     GIR_EraseRootFromParent_Done,
     /*  394004 */   // Label 7043: @394004
     /*  394004 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(394079), // Rule ID 63744 //
     /*  394009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  394020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394027 */     // MIs[0] op1
     /*  394027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394035 */     // MIs[0] op2
     /*  394035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394043 */     // MIs[0] op3
     /*  394043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394058 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  394058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  394061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394063 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394065 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394067 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394077 */     GIR_RootConstrainSelectedInstOperands,
     /*  394078 */     // GIR_Coverage, 63744,
     /*  394078 */     GIR_EraseRootFromParent_Done,
     /*  394079 */   // Label 7044: @394079
     /*  394079 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(394154), // Rule ID 63799 //
     /*  394084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  394095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394102 */     // MIs[0] op1
     /*  394102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394110 */     // MIs[0] op2
     /*  394110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394118 */     // MIs[0] op3
     /*  394118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394133 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  394133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  394136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394138 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394140 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394142 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394152 */     GIR_RootConstrainSelectedInstOperands,
     /*  394153 */     // GIR_Coverage, 63799,
     /*  394153 */     GIR_EraseRootFromParent_Done,
     /*  394154 */   // Label 7045: @394154
     /*  394154 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(394229), // Rule ID 63800 //
     /*  394159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  394170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394177 */     // MIs[0] op1
     /*  394177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394185 */     // MIs[0] op2
     /*  394185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394193 */     // MIs[0] op3
     /*  394193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394208 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  394208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  394211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394213 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394215 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394217 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394227 */     GIR_RootConstrainSelectedInstOperands,
     /*  394228 */     // GIR_Coverage, 63800,
     /*  394228 */     GIR_EraseRootFromParent_Done,
     /*  394229 */   // Label 7046: @394229
     /*  394229 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(394304), // Rule ID 63855 //
     /*  394234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  394245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394252 */     // MIs[0] op1
     /*  394252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394260 */     // MIs[0] op2
     /*  394260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394268 */     // MIs[0] op3
     /*  394268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394283 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  394283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  394286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394288 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394290 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394292 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394302 */     GIR_RootConstrainSelectedInstOperands,
     /*  394303 */     // GIR_Coverage, 63855,
     /*  394303 */     GIR_EraseRootFromParent_Done,
     /*  394304 */   // Label 7047: @394304
     /*  394304 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(394379), // Rule ID 63856 //
     /*  394309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  394320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394327 */     // MIs[0] op1
     /*  394327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394335 */     // MIs[0] op2
     /*  394335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394343 */     // MIs[0] op3
     /*  394343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394346 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394358 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  394358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  394361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394363 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394365 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394367 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394377 */     GIR_RootConstrainSelectedInstOperands,
     /*  394378 */     // GIR_Coverage, 63856,
     /*  394378 */     GIR_EraseRootFromParent_Done,
     /*  394379 */   // Label 7048: @394379
     /*  394379 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(394454), // Rule ID 63911 //
     /*  394384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  394395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394402 */     // MIs[0] op1
     /*  394402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394405 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394410 */     // MIs[0] op2
     /*  394410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394413 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394418 */     // MIs[0] op3
     /*  394418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394433 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11044:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  394433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  394436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394438 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394440 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394442 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394452 */     GIR_RootConstrainSelectedInstOperands,
     /*  394453 */     // GIR_Coverage, 63911,
     /*  394453 */     GIR_EraseRootFromParent_Done,
     /*  394454 */   // Label 7049: @394454
     /*  394454 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(394529), // Rule ID 63912 //
     /*  394459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  394470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394477 */     // MIs[0] op1
     /*  394477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394485 */     // MIs[0] op2
     /*  394485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394493 */     // MIs[0] op3
     /*  394493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394496 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394508 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  394508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  394511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394513 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394515 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394517 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394527 */     GIR_RootConstrainSelectedInstOperands,
     /*  394528 */     // GIR_Coverage, 63912,
     /*  394528 */     GIR_EraseRootFromParent_Done,
     /*  394529 */   // Label 7050: @394529
     /*  394529 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(394603), // Rule ID 62813 //
     /*  394534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  394545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  394548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394555 */     // MIs[0] op1
     /*  394555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394563 */     // MIs[0] op2
     /*  394563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394582 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF8),
     /*  394585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394587 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394589 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394591 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394601 */     GIR_RootConstrainSelectedInstOperands,
     /*  394602 */     // GIR_Coverage, 62813,
     /*  394602 */     GIR_EraseRootFromParent_Done,
     /*  394603 */   // Label 7051: @394603
     /*  394603 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(394677), // Rule ID 62814 //
     /*  394608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  394619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  394622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394629 */     // MIs[0] op1
     /*  394629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394637 */     // MIs[0] op2
     /*  394637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394656 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF8),
     /*  394659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394661 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394663 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394665 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394675 */     GIR_RootConstrainSelectedInstOperands,
     /*  394676 */     // GIR_Coverage, 62814,
     /*  394676 */     GIR_EraseRootFromParent_Done,
     /*  394677 */   // Label 7052: @394677
     /*  394677 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(394751), // Rule ID 62859 //
     /*  394682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  394693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  394696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394703 */     // MIs[0] op1
     /*  394703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394711 */     // MIs[0] op2
     /*  394711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394730 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  394733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394735 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394737 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394739 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394749 */     GIR_RootConstrainSelectedInstOperands,
     /*  394750 */     // GIR_Coverage, 62859,
     /*  394750 */     GIR_EraseRootFromParent_Done,
     /*  394751 */   // Label 7053: @394751
     /*  394751 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(394825), // Rule ID 62860 //
     /*  394756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  394767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  394770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394777 */     // MIs[0] op1
     /*  394777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394785 */     // MIs[0] op2
     /*  394785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394804 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  394807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394809 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394811 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394813 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394823 */     GIR_RootConstrainSelectedInstOperands,
     /*  394824 */     // GIR_Coverage, 62860,
     /*  394824 */     GIR_EraseRootFromParent_Done,
     /*  394825 */   // Label 7054: @394825
     /*  394825 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(394899), // Rule ID 62903 //
     /*  394830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  394841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  394844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394851 */     // MIs[0] op1
     /*  394851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394859 */     // MIs[0] op2
     /*  394859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394878 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  394881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394883 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394885 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394887 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394897 */     GIR_RootConstrainSelectedInstOperands,
     /*  394898 */     // GIR_Coverage, 62903,
     /*  394898 */     GIR_EraseRootFromParent_Done,
     /*  394899 */   // Label 7055: @394899
     /*  394899 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(394973), // Rule ID 62904 //
     /*  394904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  394915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  394918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394925 */     // MIs[0] op1
     /*  394925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394933 */     // MIs[0] op2
     /*  394933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394952 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  394955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394957 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394959 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394961 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394971 */     GIR_RootConstrainSelectedInstOperands,
     /*  394972 */     // GIR_Coverage, 62904,
     /*  394972 */     GIR_EraseRootFromParent_Done,
     /*  394973 */   // Label 7056: @394973
     /*  394973 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(395047), // Rule ID 62947 //
     /*  394978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  394989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  394992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394999 */     // MIs[0] op1
     /*  394999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395007 */     // MIs[0] op2
     /*  395007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  395029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395031 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395033 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395035 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395045 */     GIR_RootConstrainSelectedInstOperands,
     /*  395046 */     // GIR_Coverage, 62947,
     /*  395046 */     GIR_EraseRootFromParent_Done,
     /*  395047 */   // Label 7057: @395047
     /*  395047 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(395121), // Rule ID 62948 //
     /*  395052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  395063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395073 */     // MIs[0] op1
     /*  395073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395081 */     // MIs[0] op2
     /*  395081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395100 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  395103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395105 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395107 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395109 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395119 */     GIR_RootConstrainSelectedInstOperands,
     /*  395120 */     // GIR_Coverage, 62948,
     /*  395120 */     GIR_EraseRootFromParent_Done,
     /*  395121 */   // Label 7058: @395121
     /*  395121 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(395195), // Rule ID 63003 //
     /*  395126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  395137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  395140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395147 */     // MIs[0] op1
     /*  395147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395155 */     // MIs[0] op2
     /*  395155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395174 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  395177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395179 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395181 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395183 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395193 */     GIR_RootConstrainSelectedInstOperands,
     /*  395194 */     // GIR_Coverage, 63003,
     /*  395194 */     GIR_EraseRootFromParent_Done,
     /*  395195 */   // Label 7059: @395195
     /*  395195 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(395269), // Rule ID 63004 //
     /*  395200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  395211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395221 */     // MIs[0] op1
     /*  395221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395229 */     // MIs[0] op2
     /*  395229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395248 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  395251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395253 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395255 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395257 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395267 */     GIR_RootConstrainSelectedInstOperands,
     /*  395268 */     // GIR_Coverage, 63004,
     /*  395268 */     GIR_EraseRootFromParent_Done,
     /*  395269 */   // Label 7060: @395269
     /*  395269 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(395343), // Rule ID 63059 //
     /*  395274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  395285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  395288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395295 */     // MIs[0] op1
     /*  395295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395303 */     // MIs[0] op2
     /*  395303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  395322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  395325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395327 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395329 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395331 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395341 */     GIR_RootConstrainSelectedInstOperands,
     /*  395342 */     // GIR_Coverage, 63059,
     /*  395342 */     GIR_EraseRootFromParent_Done,
     /*  395343 */   // Label 7061: @395343
     /*  395343 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(395417), // Rule ID 63060 //
     /*  395348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  395359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395369 */     // MIs[0] op1
     /*  395369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395377 */     // MIs[0] op2
     /*  395377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  395396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  395399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395401 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395403 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395405 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395415 */     GIR_RootConstrainSelectedInstOperands,
     /*  395416 */     // GIR_Coverage, 63060,
     /*  395416 */     GIR_EraseRootFromParent_Done,
     /*  395417 */   // Label 7062: @395417
     /*  395417 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(395491), // Rule ID 63115 //
     /*  395422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  395433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  395436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395443 */     // MIs[0] op1
     /*  395443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395451 */     // MIs[0] op2
     /*  395451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395470 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395475 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395477 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395479 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395489 */     GIR_RootConstrainSelectedInstOperands,
     /*  395490 */     // GIR_Coverage, 63115,
     /*  395490 */     GIR_EraseRootFromParent_Done,
     /*  395491 */   // Label 7063: @395491
     /*  395491 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(395565), // Rule ID 63116 //
     /*  395496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  395507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395517 */     // MIs[0] op1
     /*  395517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395525 */     // MIs[0] op2
     /*  395525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395544 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  395544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395549 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395551 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395553 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395563 */     GIR_RootConstrainSelectedInstOperands,
     /*  395564 */     // GIR_Coverage, 63116,
     /*  395564 */     GIR_EraseRootFromParent_Done,
     /*  395565 */   // Label 7064: @395565
     /*  395565 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(395639), // Rule ID 63159 //
     /*  395570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  395581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  395584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395591 */     // MIs[0] op1
     /*  395591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395599 */     // MIs[0] op2
     /*  395599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395618 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395623 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395625 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395627 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395637 */     GIR_RootConstrainSelectedInstOperands,
     /*  395638 */     // GIR_Coverage, 63159,
     /*  395638 */     GIR_EraseRootFromParent_Done,
     /*  395639 */   // Label 7065: @395639
     /*  395639 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(395713), // Rule ID 63160 //
     /*  395644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  395655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395665 */     // MIs[0] op1
     /*  395665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395673 */     // MIs[0] op2
     /*  395673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395692 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395697 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395699 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395701 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395711 */     GIR_RootConstrainSelectedInstOperands,
     /*  395712 */     // GIR_Coverage, 63160,
     /*  395712 */     GIR_EraseRootFromParent_Done,
     /*  395713 */   // Label 7066: @395713
     /*  395713 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(395787), // Rule ID 63215 //
     /*  395718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  395732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395739 */     // MIs[0] op1
     /*  395739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395747 */     // MIs[0] op2
     /*  395747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395766 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  395766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395771 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395773 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395775 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395785 */     GIR_RootConstrainSelectedInstOperands,
     /*  395786 */     // GIR_Coverage, 63215,
     /*  395786 */     GIR_EraseRootFromParent_Done,
     /*  395787 */   // Label 7067: @395787
     /*  395787 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(395861), // Rule ID 63216 //
     /*  395792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395813 */     // MIs[0] op1
     /*  395813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395821 */     // MIs[0] op2
     /*  395821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395824 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  395840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395845 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395847 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395849 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395859 */     GIR_RootConstrainSelectedInstOperands,
     /*  395860 */     // GIR_Coverage, 63216,
     /*  395860 */     GIR_EraseRootFromParent_Done,
     /*  395861 */   // Label 7068: @395861
     /*  395861 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(395935), // Rule ID 63271 //
     /*  395866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  395880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395887 */     // MIs[0] op1
     /*  395887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395895 */     // MIs[0] op2
     /*  395895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395914 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  395914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395919 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395921 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395923 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  395933 */     GIR_RootConstrainSelectedInstOperands,
     /*  395934 */     // GIR_Coverage, 63271,
     /*  395934 */     GIR_EraseRootFromParent_Done,
     /*  395935 */   // Label 7069: @395935
     /*  395935 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(396009), // Rule ID 63272 //
     /*  395940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395961 */     // MIs[0] op1
     /*  395961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395969 */     // MIs[0] op2
     /*  395969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395988 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  395988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395993 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395995 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395997 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396007 */     GIR_RootConstrainSelectedInstOperands,
     /*  396008 */     // GIR_Coverage, 63272,
     /*  396008 */     GIR_EraseRootFromParent_Done,
     /*  396009 */   // Label 7070: @396009
     /*  396009 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(396083), // Rule ID 63327 //
     /*  396014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  396025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396035 */     // MIs[0] op1
     /*  396035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396043 */     // MIs[0] op2
     /*  396043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396062 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  396062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  396065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396067 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396069 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396071 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396081 */     GIR_RootConstrainSelectedInstOperands,
     /*  396082 */     // GIR_Coverage, 63327,
     /*  396082 */     GIR_EraseRootFromParent_Done,
     /*  396083 */   // Label 7071: @396083
     /*  396083 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(396157), // Rule ID 63328 //
     /*  396088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  396099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396109 */     // MIs[0] op1
     /*  396109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396117 */     // MIs[0] op2
     /*  396117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396136 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  396136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  396139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396141 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396143 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396145 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396155 */     GIR_RootConstrainSelectedInstOperands,
     /*  396156 */     // GIR_Coverage, 63328,
     /*  396156 */     GIR_EraseRootFromParent_Done,
     /*  396157 */   // Label 7072: @396157
     /*  396157 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(396231), // Rule ID 63371 //
     /*  396162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  396173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396183 */     // MIs[0] op1
     /*  396183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396191 */     // MIs[0] op2
     /*  396191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396210 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  396210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  396213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396215 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396217 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396219 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396229 */     GIR_RootConstrainSelectedInstOperands,
     /*  396230 */     // GIR_Coverage, 63371,
     /*  396230 */     GIR_EraseRootFromParent_Done,
     /*  396231 */   // Label 7073: @396231
     /*  396231 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(396305), // Rule ID 63372 //
     /*  396236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  396247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396257 */     // MIs[0] op1
     /*  396257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396260 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396265 */     // MIs[0] op2
     /*  396265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396284 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  396284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  396287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396289 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396291 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396293 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396303 */     GIR_RootConstrainSelectedInstOperands,
     /*  396304 */     // GIR_Coverage, 63372,
     /*  396304 */     GIR_EraseRootFromParent_Done,
     /*  396305 */   // Label 7074: @396305
     /*  396305 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(396379), // Rule ID 63415 //
     /*  396310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  396321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396331 */     // MIs[0] op1
     /*  396331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396339 */     // MIs[0] op2
     /*  396339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396358 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  396358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  396361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396363 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396365 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396367 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396377 */     GIR_RootConstrainSelectedInstOperands,
     /*  396378 */     // GIR_Coverage, 63415,
     /*  396378 */     GIR_EraseRootFromParent_Done,
     /*  396379 */   // Label 7075: @396379
     /*  396379 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(396453), // Rule ID 63416 //
     /*  396384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  396395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396405 */     // MIs[0] op1
     /*  396405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396408 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396413 */     // MIs[0] op2
     /*  396413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396432 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  396432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  396435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396437 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396439 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396441 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396451 */     GIR_RootConstrainSelectedInstOperands,
     /*  396452 */     // GIR_Coverage, 63416,
     /*  396452 */     GIR_EraseRootFromParent_Done,
     /*  396453 */   // Label 7076: @396453
     /*  396453 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(396527), // Rule ID 63459 //
     /*  396458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  396469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396479 */     // MIs[0] op1
     /*  396479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396482 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396487 */     // MIs[0] op2
     /*  396487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396506 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  396509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396511 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396513 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396515 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396525 */     GIR_RootConstrainSelectedInstOperands,
     /*  396526 */     // GIR_Coverage, 63459,
     /*  396526 */     GIR_EraseRootFromParent_Done,
     /*  396527 */   // Label 7077: @396527
     /*  396527 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(396601), // Rule ID 63460 //
     /*  396532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  396543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396553 */     // MIs[0] op1
     /*  396553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396561 */     // MIs[0] op2
     /*  396561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396580 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  396583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396585 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396587 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396589 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396599 */     GIR_RootConstrainSelectedInstOperands,
     /*  396600 */     // GIR_Coverage, 63460,
     /*  396600 */     GIR_EraseRootFromParent_Done,
     /*  396601 */   // Label 7078: @396601
     /*  396601 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(396675), // Rule ID 63515 //
     /*  396606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  396617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396627 */     // MIs[0] op1
     /*  396627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396635 */     // MIs[0] op2
     /*  396635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396654 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  396657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396659 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396661 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396663 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396673 */     GIR_RootConstrainSelectedInstOperands,
     /*  396674 */     // GIR_Coverage, 63515,
     /*  396674 */     GIR_EraseRootFromParent_Done,
     /*  396675 */   // Label 7079: @396675
     /*  396675 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(396749), // Rule ID 63516 //
     /*  396680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  396691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396701 */     // MIs[0] op1
     /*  396701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396704 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396709 */     // MIs[0] op2
     /*  396709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396728 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  396731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396733 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396735 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396737 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396747 */     GIR_RootConstrainSelectedInstOperands,
     /*  396748 */     // GIR_Coverage, 63516,
     /*  396748 */     GIR_EraseRootFromParent_Done,
     /*  396749 */   // Label 7080: @396749
     /*  396749 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(396823), // Rule ID 63571 //
     /*  396754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  396765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396775 */     // MIs[0] op1
     /*  396775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396783 */     // MIs[0] op2
     /*  396783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396802 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  396805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396807 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396809 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396811 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396821 */     GIR_RootConstrainSelectedInstOperands,
     /*  396822 */     // GIR_Coverage, 63571,
     /*  396822 */     GIR_EraseRootFromParent_Done,
     /*  396823 */   // Label 7081: @396823
     /*  396823 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(396897), // Rule ID 63572 //
     /*  396828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  396839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396849 */     // MIs[0] op1
     /*  396849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396857 */     // MIs[0] op2
     /*  396857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396876 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  396879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396881 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396883 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396885 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396895 */     GIR_RootConstrainSelectedInstOperands,
     /*  396896 */     // GIR_Coverage, 63572,
     /*  396896 */     GIR_EraseRootFromParent_Done,
     /*  396897 */   // Label 7082: @396897
     /*  396897 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(396971), // Rule ID 63627 //
     /*  396902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  396913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396923 */     // MIs[0] op1
     /*  396923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396931 */     // MIs[0] op2
     /*  396931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396934 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  396953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396955 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396957 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396959 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396969 */     GIR_RootConstrainSelectedInstOperands,
     /*  396970 */     // GIR_Coverage, 63627,
     /*  396970 */     GIR_EraseRootFromParent_Done,
     /*  396971 */   // Label 7083: @396971
     /*  396971 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(397045), // Rule ID 63628 //
     /*  396976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  396987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396997 */     // MIs[0] op1
     /*  396997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397000 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397005 */     // MIs[0] op2
     /*  397005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397024 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  397024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  397027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397029 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397031 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397033 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397043 */     GIR_RootConstrainSelectedInstOperands,
     /*  397044 */     // GIR_Coverage, 63628,
     /*  397044 */     GIR_EraseRootFromParent_Done,
     /*  397045 */   // Label 7084: @397045
     /*  397045 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(397119), // Rule ID 63683 //
     /*  397050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  397061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397071 */     // MIs[0] op1
     /*  397071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397074 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397079 */     // MIs[0] op2
     /*  397079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397082 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397098 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  397098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  397101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397103 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397105 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397107 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397117 */     GIR_RootConstrainSelectedInstOperands,
     /*  397118 */     // GIR_Coverage, 63683,
     /*  397118 */     GIR_EraseRootFromParent_Done,
     /*  397119 */   // Label 7085: @397119
     /*  397119 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(397193), // Rule ID 63684 //
     /*  397124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  397135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397145 */     // MIs[0] op1
     /*  397145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397153 */     // MIs[0] op2
     /*  397153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397156 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397172 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  397172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  397175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397177 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397179 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397181 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397191 */     GIR_RootConstrainSelectedInstOperands,
     /*  397192 */     // GIR_Coverage, 63684,
     /*  397192 */     GIR_EraseRootFromParent_Done,
     /*  397193 */   // Label 7086: @397193
     /*  397193 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(397267), // Rule ID 63739 //
     /*  397198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  397209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397219 */     // MIs[0] op1
     /*  397219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397227 */     // MIs[0] op2
     /*  397227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397246 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  397246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  397249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397251 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397253 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397255 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397265 */     GIR_RootConstrainSelectedInstOperands,
     /*  397266 */     // GIR_Coverage, 63739,
     /*  397266 */     GIR_EraseRootFromParent_Done,
     /*  397267 */   // Label 7087: @397267
     /*  397267 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(397341), // Rule ID 63740 //
     /*  397272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  397283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397293 */     // MIs[0] op1
     /*  397293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397301 */     // MIs[0] op2
     /*  397301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397320 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  397320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  397323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397325 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397327 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397329 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397339 */     GIR_RootConstrainSelectedInstOperands,
     /*  397340 */     // GIR_Coverage, 63740,
     /*  397340 */     GIR_EraseRootFromParent_Done,
     /*  397341 */   // Label 7088: @397341
     /*  397341 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(397415), // Rule ID 63795 //
     /*  397346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  397357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397367 */     // MIs[0] op1
     /*  397367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397375 */     // MIs[0] op2
     /*  397375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  397397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397399 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397401 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397403 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397413 */     GIR_RootConstrainSelectedInstOperands,
     /*  397414 */     // GIR_Coverage, 63795,
     /*  397414 */     GIR_EraseRootFromParent_Done,
     /*  397415 */   // Label 7089: @397415
     /*  397415 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(397489), // Rule ID 63796 //
     /*  397420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  397431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397441 */     // MIs[0] op1
     /*  397441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397449 */     // MIs[0] op2
     /*  397449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397452 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  397471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397473 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397475 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397477 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397487 */     GIR_RootConstrainSelectedInstOperands,
     /*  397488 */     // GIR_Coverage, 63796,
     /*  397488 */     GIR_EraseRootFromParent_Done,
     /*  397489 */   // Label 7090: @397489
     /*  397489 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(397563), // Rule ID 63851 //
     /*  397494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  397505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397515 */     // MIs[0] op1
     /*  397515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397523 */     // MIs[0] op2
     /*  397523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397542 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  397545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397547 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397549 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397551 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397561 */     GIR_RootConstrainSelectedInstOperands,
     /*  397562 */     // GIR_Coverage, 63851,
     /*  397562 */     GIR_EraseRootFromParent_Done,
     /*  397563 */   // Label 7091: @397563
     /*  397563 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(397637), // Rule ID 63852 //
     /*  397568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  397579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397589 */     // MIs[0] op1
     /*  397589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397597 */     // MIs[0] op2
     /*  397597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  397619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397621 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397623 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397625 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397635 */     GIR_RootConstrainSelectedInstOperands,
     /*  397636 */     // GIR_Coverage, 63852,
     /*  397636 */     GIR_EraseRootFromParent_Done,
     /*  397637 */   // Label 7092: @397637
     /*  397637 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(397711), // Rule ID 63907 //
     /*  397642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  397653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397663 */     // MIs[0] op1
     /*  397663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397671 */     // MIs[0] op2
     /*  397671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397690 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11058:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  397693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397695 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397697 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397699 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397709 */     GIR_RootConstrainSelectedInstOperands,
     /*  397710 */     // GIR_Coverage, 63907,
     /*  397710 */     GIR_EraseRootFromParent_Done,
     /*  397711 */   // Label 7093: @397711
     /*  397711 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(397785), // Rule ID 63908 //
     /*  397716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  397727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397737 */     // MIs[0] op1
     /*  397737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397745 */     // MIs[0] op2
     /*  397745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397748 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397764 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11058:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  397767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397769 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397771 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397773 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397783 */     GIR_RootConstrainSelectedInstOperands,
     /*  397784 */     // GIR_Coverage, 63908,
     /*  397784 */     GIR_EraseRootFromParent_Done,
     /*  397785 */   // Label 7094: @397785
     /*  397785 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(397859), // Rule ID 62837 //
     /*  397790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  397801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  397804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397811 */     // MIs[0] op1
     /*  397811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397814 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397823 */     // MIs[0] op3
     /*  397823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397838 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  397838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF8),
     /*  397841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397843 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397845 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397847 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397857 */     GIR_RootConstrainSelectedInstOperands,
     /*  397858 */     // GIR_Coverage, 62837,
     /*  397858 */     GIR_EraseRootFromParent_Done,
     /*  397859 */   // Label 7095: @397859
     /*  397859 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(397933), // Rule ID 62838 //
     /*  397864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  397875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  397878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397885 */     // MIs[0] op1
     /*  397885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397888 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397897 */     // MIs[0] op3
     /*  397897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397912 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  397912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF8),
     /*  397915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397917 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397919 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397921 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397931 */     GIR_RootConstrainSelectedInstOperands,
     /*  397932 */     // GIR_Coverage, 62838,
     /*  397932 */     GIR_EraseRootFromParent_Done,
     /*  397933 */   // Label 7096: @397933
     /*  397933 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(398007), // Rule ID 62875 //
     /*  397938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  397949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  397952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397959 */     // MIs[0] op1
     /*  397959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397971 */     // MIs[0] op3
     /*  397971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397986 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  397986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  397989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397991 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397993 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397995 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398005 */     GIR_RootConstrainSelectedInstOperands,
     /*  398006 */     // GIR_Coverage, 62875,
     /*  398006 */     GIR_EraseRootFromParent_Done,
     /*  398007 */   // Label 7097: @398007
     /*  398007 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(398081), // Rule ID 62876 //
     /*  398012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  398023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  398026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398033 */     // MIs[0] op1
     /*  398033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398045 */     // MIs[0] op3
     /*  398045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398048 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398060 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  398060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  398063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398065 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398067 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398069 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398079 */     GIR_RootConstrainSelectedInstOperands,
     /*  398080 */     // GIR_Coverage, 62876,
     /*  398080 */     GIR_EraseRootFromParent_Done,
     /*  398081 */   // Label 7098: @398081
     /*  398081 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(398155), // Rule ID 62919 //
     /*  398086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  398097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  398100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398107 */     // MIs[0] op1
     /*  398107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398119 */     // MIs[0] op3
     /*  398119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398134 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  398134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  398137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398139 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398141 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398143 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398153 */     GIR_RootConstrainSelectedInstOperands,
     /*  398154 */     // GIR_Coverage, 62919,
     /*  398154 */     GIR_EraseRootFromParent_Done,
     /*  398155 */   // Label 7099: @398155
     /*  398155 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(398229), // Rule ID 62920 //
     /*  398160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  398171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  398174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398181 */     // MIs[0] op1
     /*  398181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398193 */     // MIs[0] op3
     /*  398193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  398208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  398211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398213 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398215 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398217 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398227 */     GIR_RootConstrainSelectedInstOperands,
     /*  398228 */     // GIR_Coverage, 62920,
     /*  398228 */     GIR_EraseRootFromParent_Done,
     /*  398229 */   // Label 7100: @398229
     /*  398229 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(398303), // Rule ID 62963 //
     /*  398234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  398245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  398248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398255 */     // MIs[0] op1
     /*  398255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398267 */     // MIs[0] op3
     /*  398267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398282 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  398282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  398285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398287 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398289 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398291 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398301 */     GIR_RootConstrainSelectedInstOperands,
     /*  398302 */     // GIR_Coverage, 62963,
     /*  398302 */     GIR_EraseRootFromParent_Done,
     /*  398303 */   // Label 7101: @398303
     /*  398303 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(398377), // Rule ID 62964 //
     /*  398308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  398319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  398322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398329 */     // MIs[0] op1
     /*  398329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398341 */     // MIs[0] op3
     /*  398341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398356 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  398356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  398359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398361 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398363 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398365 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398375 */     GIR_RootConstrainSelectedInstOperands,
     /*  398376 */     // GIR_Coverage, 62964,
     /*  398376 */     GIR_EraseRootFromParent_Done,
     /*  398377 */   // Label 7102: @398377
     /*  398377 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(398451), // Rule ID 63019 //
     /*  398382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  398393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  398396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398403 */     // MIs[0] op1
     /*  398403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398415 */     // MIs[0] op3
     /*  398415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398430 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  398430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  398433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398435 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398437 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398439 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398449 */     GIR_RootConstrainSelectedInstOperands,
     /*  398450 */     // GIR_Coverage, 63019,
     /*  398450 */     GIR_EraseRootFromParent_Done,
     /*  398451 */   // Label 7103: @398451
     /*  398451 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(398525), // Rule ID 63020 //
     /*  398456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  398467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  398470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398477 */     // MIs[0] op1
     /*  398477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398489 */     // MIs[0] op3
     /*  398489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398504 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  398504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  398507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398509 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398511 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398513 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398523 */     GIR_RootConstrainSelectedInstOperands,
     /*  398524 */     // GIR_Coverage, 63020,
     /*  398524 */     GIR_EraseRootFromParent_Done,
     /*  398525 */   // Label 7104: @398525
     /*  398525 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(398599), // Rule ID 63075 //
     /*  398530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  398541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  398544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398551 */     // MIs[0] op1
     /*  398551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398554 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398563 */     // MIs[0] op3
     /*  398563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398578 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  398578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  398581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398583 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398585 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398587 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398597 */     GIR_RootConstrainSelectedInstOperands,
     /*  398598 */     // GIR_Coverage, 63075,
     /*  398598 */     GIR_EraseRootFromParent_Done,
     /*  398599 */   // Label 7105: @398599
     /*  398599 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(398673), // Rule ID 63076 //
     /*  398604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  398615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  398618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398625 */     // MIs[0] op1
     /*  398625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398637 */     // MIs[0] op3
     /*  398637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  398652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  398655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398657 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398659 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398661 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398671 */     GIR_RootConstrainSelectedInstOperands,
     /*  398672 */     // GIR_Coverage, 63076,
     /*  398672 */     GIR_EraseRootFromParent_Done,
     /*  398673 */   // Label 7106: @398673
     /*  398673 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(398747), // Rule ID 63131 //
     /*  398678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  398689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  398692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398699 */     // MIs[0] op1
     /*  398699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398711 */     // MIs[0] op3
     /*  398711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398726 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  398726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  398729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398731 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398733 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398735 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398745 */     GIR_RootConstrainSelectedInstOperands,
     /*  398746 */     // GIR_Coverage, 63131,
     /*  398746 */     GIR_EraseRootFromParent_Done,
     /*  398747 */   // Label 7107: @398747
     /*  398747 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(398821), // Rule ID 63132 //
     /*  398752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  398763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  398766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398773 */     // MIs[0] op1
     /*  398773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398776 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398785 */     // MIs[0] op3
     /*  398785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398800 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  398800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  398803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398805 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398807 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398809 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398819 */     GIR_RootConstrainSelectedInstOperands,
     /*  398820 */     // GIR_Coverage, 63132,
     /*  398820 */     GIR_EraseRootFromParent_Done,
     /*  398821 */   // Label 7108: @398821
     /*  398821 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(398895), // Rule ID 63175 //
     /*  398826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  398837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  398840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398847 */     // MIs[0] op1
     /*  398847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398850 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398859 */     // MIs[0] op3
     /*  398859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398874 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  398874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  398877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398879 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398881 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398883 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398893 */     GIR_RootConstrainSelectedInstOperands,
     /*  398894 */     // GIR_Coverage, 63175,
     /*  398894 */     GIR_EraseRootFromParent_Done,
     /*  398895 */   // Label 7109: @398895
     /*  398895 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(398969), // Rule ID 63176 //
     /*  398900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  398911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  398914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398921 */     // MIs[0] op1
     /*  398921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398933 */     // MIs[0] op3
     /*  398933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398948 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  398948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  398951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398953 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398955 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398957 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398967 */     GIR_RootConstrainSelectedInstOperands,
     /*  398968 */     // GIR_Coverage, 63176,
     /*  398968 */     GIR_EraseRootFromParent_Done,
     /*  398969 */   // Label 7110: @398969
     /*  398969 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(399043), // Rule ID 63231 //
     /*  398974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  398985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  398988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398995 */     // MIs[0] op1
     /*  398995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399007 */     // MIs[0] op3
     /*  399007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399022 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  399022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  399025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399027 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399029 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399031 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399041 */     GIR_RootConstrainSelectedInstOperands,
     /*  399042 */     // GIR_Coverage, 63231,
     /*  399042 */     GIR_EraseRootFromParent_Done,
     /*  399043 */   // Label 7111: @399043
     /*  399043 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(399117), // Rule ID 63232 //
     /*  399048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  399059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  399062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399069 */     // MIs[0] op1
     /*  399069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399081 */     // MIs[0] op3
     /*  399081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  399096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  399099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399101 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399103 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399105 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399115 */     GIR_RootConstrainSelectedInstOperands,
     /*  399116 */     // GIR_Coverage, 63232,
     /*  399116 */     GIR_EraseRootFromParent_Done,
     /*  399117 */   // Label 7112: @399117
     /*  399117 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(399191), // Rule ID 63287 //
     /*  399122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  399125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  399133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  399136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399143 */     // MIs[0] op1
     /*  399143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399155 */     // MIs[0] op3
     /*  399155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399170 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  399170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  399173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399175 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399177 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399179 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399189 */     GIR_RootConstrainSelectedInstOperands,
     /*  399190 */     // GIR_Coverage, 63287,
     /*  399190 */     GIR_EraseRootFromParent_Done,
     /*  399191 */   // Label 7113: @399191
     /*  399191 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(399265), // Rule ID 63288 //
     /*  399196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  399207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  399210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399217 */     // MIs[0] op1
     /*  399217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399229 */     // MIs[0] op3
     /*  399229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399244 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  399244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  399247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399249 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399251 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399253 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399263 */     GIR_RootConstrainSelectedInstOperands,
     /*  399264 */     // GIR_Coverage, 63288,
     /*  399264 */     GIR_EraseRootFromParent_Done,
     /*  399265 */   // Label 7114: @399265
     /*  399265 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(399339), // Rule ID 63343 //
     /*  399270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  399273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  399281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  399284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399291 */     // MIs[0] op1
     /*  399291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399303 */     // MIs[0] op3
     /*  399303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  399318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  399321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399323 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399325 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399327 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399337 */     GIR_RootConstrainSelectedInstOperands,
     /*  399338 */     // GIR_Coverage, 63343,
     /*  399338 */     GIR_EraseRootFromParent_Done,
     /*  399339 */   // Label 7115: @399339
     /*  399339 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(399413), // Rule ID 63344 //
     /*  399344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  399355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  399358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399365 */     // MIs[0] op1
     /*  399365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399377 */     // MIs[0] op3
     /*  399377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399392 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  399392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  399395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399397 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399399 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399401 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399411 */     GIR_RootConstrainSelectedInstOperands,
     /*  399412 */     // GIR_Coverage, 63344,
     /*  399412 */     GIR_EraseRootFromParent_Done,
     /*  399413 */   // Label 7116: @399413
     /*  399413 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(399487), // Rule ID 63387 //
     /*  399418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  399421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  399429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  399432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399439 */     // MIs[0] op1
     /*  399439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399451 */     // MIs[0] op3
     /*  399451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399466 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  399466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  399469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399471 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399473 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399475 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399485 */     GIR_RootConstrainSelectedInstOperands,
     /*  399486 */     // GIR_Coverage, 63387,
     /*  399486 */     GIR_EraseRootFromParent_Done,
     /*  399487 */   // Label 7117: @399487
     /*  399487 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(399561), // Rule ID 63388 //
     /*  399492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  399503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  399506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399513 */     // MIs[0] op1
     /*  399513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399525 */     // MIs[0] op3
     /*  399525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399540 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  399540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  399543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399545 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399547 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399549 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399559 */     GIR_RootConstrainSelectedInstOperands,
     /*  399560 */     // GIR_Coverage, 63388,
     /*  399560 */     GIR_EraseRootFromParent_Done,
     /*  399561 */   // Label 7118: @399561
     /*  399561 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(399635), // Rule ID 63431 //
     /*  399566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  399569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  399577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  399580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399587 */     // MIs[0] op1
     /*  399587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399590 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399599 */     // MIs[0] op3
     /*  399599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399614 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  399614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  399617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399619 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399621 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399623 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399633 */     GIR_RootConstrainSelectedInstOperands,
     /*  399634 */     // GIR_Coverage, 63431,
     /*  399634 */     GIR_EraseRootFromParent_Done,
     /*  399635 */   // Label 7119: @399635
     /*  399635 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(399709), // Rule ID 63432 //
     /*  399640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  399651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  399654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399661 */     // MIs[0] op1
     /*  399661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399664 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399673 */     // MIs[0] op3
     /*  399673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399688 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  399688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  399691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399693 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399695 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399697 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399707 */     GIR_RootConstrainSelectedInstOperands,
     /*  399708 */     // GIR_Coverage, 63432,
     /*  399708 */     GIR_EraseRootFromParent_Done,
     /*  399709 */   // Label 7120: @399709
     /*  399709 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(399783), // Rule ID 63475 //
     /*  399714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  399717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399735 */     // MIs[0] op1
     /*  399735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399747 */     // MIs[0] op3
     /*  399747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  399762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  399765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399767 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399769 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399771 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399781 */     GIR_RootConstrainSelectedInstOperands,
     /*  399782 */     // GIR_Coverage, 63475,
     /*  399782 */     GIR_EraseRootFromParent_Done,
     /*  399783 */   // Label 7121: @399783
     /*  399783 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(399857), // Rule ID 63476 //
     /*  399788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399809 */     // MIs[0] op1
     /*  399809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399821 */     // MIs[0] op3
     /*  399821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399824 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  399836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  399839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399841 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399843 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399845 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399855 */     GIR_RootConstrainSelectedInstOperands,
     /*  399856 */     // GIR_Coverage, 63476,
     /*  399856 */     GIR_EraseRootFromParent_Done,
     /*  399857 */   // Label 7122: @399857
     /*  399857 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(399931), // Rule ID 63531 //
     /*  399862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  399865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399883 */     // MIs[0] op1
     /*  399883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399895 */     // MIs[0] op3
     /*  399895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399910 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  399910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  399913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399915 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399917 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399919 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399929 */     GIR_RootConstrainSelectedInstOperands,
     /*  399930 */     // GIR_Coverage, 63531,
     /*  399930 */     GIR_EraseRootFromParent_Done,
     /*  399931 */   // Label 7123: @399931
     /*  399931 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(400005), // Rule ID 63532 //
     /*  399936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399957 */     // MIs[0] op1
     /*  399957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399960 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399969 */     // MIs[0] op3
     /*  399969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399984 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  399984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  399987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399989 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399991 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399993 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400003 */     GIR_RootConstrainSelectedInstOperands,
     /*  400004 */     // GIR_Coverage, 63532,
     /*  400004 */     GIR_EraseRootFromParent_Done,
     /*  400005 */   // Label 7124: @400005
     /*  400005 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(400079), // Rule ID 63587 //
     /*  400010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  400021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  400024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400031 */     // MIs[0] op1
     /*  400031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400043 */     // MIs[0] op3
     /*  400043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400058 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  400058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  400061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400063 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400065 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400067 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400077 */     GIR_RootConstrainSelectedInstOperands,
     /*  400078 */     // GIR_Coverage, 63587,
     /*  400078 */     GIR_EraseRootFromParent_Done,
     /*  400079 */   // Label 7125: @400079
     /*  400079 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(400153), // Rule ID 63588 //
     /*  400084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  400095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  400098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400105 */     // MIs[0] op1
     /*  400105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400108 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400117 */     // MIs[0] op3
     /*  400117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400132 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  400132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  400135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400137 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400139 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400141 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400151 */     GIR_RootConstrainSelectedInstOperands,
     /*  400152 */     // GIR_Coverage, 63588,
     /*  400152 */     GIR_EraseRootFromParent_Done,
     /*  400153 */   // Label 7126: @400153
     /*  400153 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(400227), // Rule ID 63643 //
     /*  400158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  400169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  400172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400179 */     // MIs[0] op1
     /*  400179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400191 */     // MIs[0] op3
     /*  400191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  400206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  400209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400211 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400213 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400215 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400225 */     GIR_RootConstrainSelectedInstOperands,
     /*  400226 */     // GIR_Coverage, 63643,
     /*  400226 */     GIR_EraseRootFromParent_Done,
     /*  400227 */   // Label 7127: @400227
     /*  400227 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(400301), // Rule ID 63644 //
     /*  400232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  400243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  400246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400253 */     // MIs[0] op1
     /*  400253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400265 */     // MIs[0] op3
     /*  400265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  400280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  400283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400285 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400287 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400289 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400299 */     GIR_RootConstrainSelectedInstOperands,
     /*  400300 */     // GIR_Coverage, 63644,
     /*  400300 */     GIR_EraseRootFromParent_Done,
     /*  400301 */   // Label 7128: @400301
     /*  400301 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(400375), // Rule ID 63699 //
     /*  400306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  400317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  400320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400327 */     // MIs[0] op1
     /*  400327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400339 */     // MIs[0] op3
     /*  400339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400354 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  400354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  400357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400359 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400361 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400363 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400373 */     GIR_RootConstrainSelectedInstOperands,
     /*  400374 */     // GIR_Coverage, 63699,
     /*  400374 */     GIR_EraseRootFromParent_Done,
     /*  400375 */   // Label 7129: @400375
     /*  400375 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(400449), // Rule ID 63700 //
     /*  400380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  400391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  400394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400401 */     // MIs[0] op1
     /*  400401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400404 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400413 */     // MIs[0] op3
     /*  400413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  400428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  400431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400433 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400435 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400437 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400447 */     GIR_RootConstrainSelectedInstOperands,
     /*  400448 */     // GIR_Coverage, 63700,
     /*  400448 */     GIR_EraseRootFromParent_Done,
     /*  400449 */   // Label 7130: @400449
     /*  400449 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(400523), // Rule ID 63755 //
     /*  400454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  400465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  400468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400475 */     // MIs[0] op1
     /*  400475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400478 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400487 */     // MIs[0] op3
     /*  400487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400502 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  400502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  400505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400507 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400509 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400511 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400521 */     GIR_RootConstrainSelectedInstOperands,
     /*  400522 */     // GIR_Coverage, 63755,
     /*  400522 */     GIR_EraseRootFromParent_Done,
     /*  400523 */   // Label 7131: @400523
     /*  400523 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(400597), // Rule ID 63756 //
     /*  400528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  400539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  400542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400549 */     // MIs[0] op1
     /*  400549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400561 */     // MIs[0] op3
     /*  400561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400576 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  400576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  400579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400581 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400583 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400585 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400595 */     GIR_RootConstrainSelectedInstOperands,
     /*  400596 */     // GIR_Coverage, 63756,
     /*  400596 */     GIR_EraseRootFromParent_Done,
     /*  400597 */   // Label 7132: @400597
     /*  400597 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(400671), // Rule ID 63811 //
     /*  400602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400623 */     // MIs[0] op1
     /*  400623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400635 */     // MIs[0] op3
     /*  400635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400650 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  400650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  400653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400655 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400657 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400659 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400669 */     GIR_RootConstrainSelectedInstOperands,
     /*  400670 */     // GIR_Coverage, 63811,
     /*  400670 */     GIR_EraseRootFromParent_Done,
     /*  400671 */   // Label 7133: @400671
     /*  400671 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(400745), // Rule ID 63812 //
     /*  400676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400697 */     // MIs[0] op1
     /*  400697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400709 */     // MIs[0] op3
     /*  400709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  400724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  400727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400729 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400731 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400733 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400743 */     GIR_RootConstrainSelectedInstOperands,
     /*  400744 */     // GIR_Coverage, 63812,
     /*  400744 */     GIR_EraseRootFromParent_Done,
     /*  400745 */   // Label 7134: @400745
     /*  400745 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(400819), // Rule ID 63867 //
     /*  400750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  400761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  400764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400771 */     // MIs[0] op1
     /*  400771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400783 */     // MIs[0] op3
     /*  400783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400798 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  400798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  400801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400803 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400805 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400807 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400817 */     GIR_RootConstrainSelectedInstOperands,
     /*  400818 */     // GIR_Coverage, 63867,
     /*  400818 */     GIR_EraseRootFromParent_Done,
     /*  400819 */   // Label 7135: @400819
     /*  400819 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(400893), // Rule ID 63868 //
     /*  400824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  400835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  400838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400845 */     // MIs[0] op1
     /*  400845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400857 */     // MIs[0] op3
     /*  400857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400872 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  400872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  400875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400877 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400879 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400881 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400891 */     GIR_RootConstrainSelectedInstOperands,
     /*  400892 */     // GIR_Coverage, 63868,
     /*  400892 */     GIR_EraseRootFromParent_Done,
     /*  400893 */   // Label 7136: @400893
     /*  400893 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(400967), // Rule ID 63923 //
     /*  400898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  400909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  400912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400919 */     // MIs[0] op1
     /*  400919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400922 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400931 */     // MIs[0] op3
     /*  400931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400934 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11046:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  400946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  400949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400951 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400953 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400955 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400965 */     GIR_RootConstrainSelectedInstOperands,
     /*  400966 */     // GIR_Coverage, 63923,
     /*  400966 */     GIR_EraseRootFromParent_Done,
     /*  400967 */   // Label 7137: @400967
     /*  400967 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(401041), // Rule ID 63924 //
     /*  400972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  400983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  400986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400993 */     // MIs[0] op1
     /*  400993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  401001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401005 */     // MIs[0] op3
     /*  401005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  401008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  401013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401020 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11046:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  401020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  401023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401025 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  401027 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  401029 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  401031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  401039 */     GIR_RootConstrainSelectedInstOperands,
     /*  401040 */     // GIR_Coverage, 63924,
     /*  401040 */     GIR_EraseRootFromParent_Done,
     /*  401041 */   // Label 7138: @401041
     /*  401041 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(401116), // Rule ID 7348 //
     /*  401046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  401057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  401060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  401063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401092 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  401092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  401095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401114 */     GIR_RootConstrainSelectedInstOperands,
     /*  401115 */     // GIR_Coverage, 7348,
     /*  401115 */     GIR_EraseRootFromParent_Done,
     /*  401116 */   // Label 7139: @401116
     /*  401116 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(401191), // Rule ID 7349 //
     /*  401121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  401132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  401135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  401138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401167 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  401167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  401170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401189 */     GIR_RootConstrainSelectedInstOperands,
     /*  401190 */     // GIR_Coverage, 7349,
     /*  401190 */     GIR_EraseRootFromParent_Done,
     /*  401191 */   // Label 7140: @401191
     /*  401191 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(401266), // Rule ID 7352 //
     /*  401196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  401207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  401210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  401213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401242 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  401242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  401245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401264 */     GIR_RootConstrainSelectedInstOperands,
     /*  401265 */     // GIR_Coverage, 7352,
     /*  401265 */     GIR_EraseRootFromParent_Done,
     /*  401266 */   // Label 7141: @401266
     /*  401266 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(401341), // Rule ID 7353 //
     /*  401271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  401282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  401285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  401288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401317 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  401317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  401320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401339 */     GIR_RootConstrainSelectedInstOperands,
     /*  401340 */     // GIR_Coverage, 7353,
     /*  401340 */     GIR_EraseRootFromParent_Done,
     /*  401341 */   // Label 7142: @401341
     /*  401341 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(401416), // Rule ID 7356 //
     /*  401346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  401357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  401360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  401363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401392 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  401392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  401395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401414 */     GIR_RootConstrainSelectedInstOperands,
     /*  401415 */     // GIR_Coverage, 7356,
     /*  401415 */     GIR_EraseRootFromParent_Done,
     /*  401416 */   // Label 7143: @401416
     /*  401416 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(401491), // Rule ID 7357 //
     /*  401421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  401432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  401435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  401438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401467 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  401467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  401470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401489 */     GIR_RootConstrainSelectedInstOperands,
     /*  401490 */     // GIR_Coverage, 7357,
     /*  401490 */     GIR_EraseRootFromParent_Done,
     /*  401491 */   // Label 7144: @401491
     /*  401491 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(401566), // Rule ID 7360 //
     /*  401496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  401507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  401510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  401513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401542 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  401545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401564 */     GIR_RootConstrainSelectedInstOperands,
     /*  401565 */     // GIR_Coverage, 7360,
     /*  401565 */     GIR_EraseRootFromParent_Done,
     /*  401566 */   // Label 7145: @401566
     /*  401566 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(401641), // Rule ID 7361 //
     /*  401571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  401582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  401585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  401588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401617 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  401620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401639 */     GIR_RootConstrainSelectedInstOperands,
     /*  401640 */     // GIR_Coverage, 7361,
     /*  401640 */     GIR_EraseRootFromParent_Done,
     /*  401641 */   // Label 7146: @401641
     /*  401641 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(401716), // Rule ID 7364 //
     /*  401646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  401657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  401660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  401663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401692 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  401695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401714 */     GIR_RootConstrainSelectedInstOperands,
     /*  401715 */     // GIR_Coverage, 7364,
     /*  401715 */     GIR_EraseRootFromParent_Done,
     /*  401716 */   // Label 7147: @401716
     /*  401716 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(401791), // Rule ID 7365 //
     /*  401721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  401732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  401735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  401738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401767 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  401770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401789 */     GIR_RootConstrainSelectedInstOperands,
     /*  401790 */     // GIR_Coverage, 7365,
     /*  401790 */     GIR_EraseRootFromParent_Done,
     /*  401791 */   // Label 7148: @401791
     /*  401791 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(401866), // Rule ID 7368 //
     /*  401796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  401807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  401810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  401813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401842 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  401842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  401845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401864 */     GIR_RootConstrainSelectedInstOperands,
     /*  401865 */     // GIR_Coverage, 7368,
     /*  401865 */     GIR_EraseRootFromParent_Done,
     /*  401866 */   // Label 7149: @401866
     /*  401866 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(401941), // Rule ID 7369 //
     /*  401871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  401882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  401885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  401888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401917 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  401917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  401920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401939 */     GIR_RootConstrainSelectedInstOperands,
     /*  401940 */     // GIR_Coverage, 7369,
     /*  401940 */     GIR_EraseRootFromParent_Done,
     /*  401941 */   // Label 7150: @401941
     /*  401941 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(402016), // Rule ID 7372 //
     /*  401946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  401957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  401960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  401963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401992 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  401992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  401995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402014 */     GIR_RootConstrainSelectedInstOperands,
     /*  402015 */     // GIR_Coverage, 7372,
     /*  402015 */     GIR_EraseRootFromParent_Done,
     /*  402016 */   // Label 7151: @402016
     /*  402016 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(402091), // Rule ID 7373 //
     /*  402021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  402032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  402035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  402038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402067 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  402067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402089 */     GIR_RootConstrainSelectedInstOperands,
     /*  402090 */     // GIR_Coverage, 7373,
     /*  402090 */     GIR_EraseRootFromParent_Done,
     /*  402091 */   // Label 7152: @402091
     /*  402091 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(402166), // Rule ID 7376 //
     /*  402096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  402107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  402110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  402113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402142 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  402142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402164 */     GIR_RootConstrainSelectedInstOperands,
     /*  402165 */     // GIR_Coverage, 7376,
     /*  402165 */     GIR_EraseRootFromParent_Done,
     /*  402166 */   // Label 7153: @402166
     /*  402166 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(402241), // Rule ID 7377 //
     /*  402171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  402182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  402185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  402188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402217 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  402217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402239 */     GIR_RootConstrainSelectedInstOperands,
     /*  402240 */     // GIR_Coverage, 7377,
     /*  402240 */     GIR_EraseRootFromParent_Done,
     /*  402241 */   // Label 7154: @402241
     /*  402241 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(402316), // Rule ID 7380 //
     /*  402246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  402257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  402260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  402263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402314 */     GIR_RootConstrainSelectedInstOperands,
     /*  402315 */     // GIR_Coverage, 7380,
     /*  402315 */     GIR_EraseRootFromParent_Done,
     /*  402316 */   // Label 7155: @402316
     /*  402316 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(402391), // Rule ID 7381 //
     /*  402321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  402332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  402335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  402338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402367 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402389 */     GIR_RootConstrainSelectedInstOperands,
     /*  402390 */     // GIR_Coverage, 7381,
     /*  402390 */     GIR_EraseRootFromParent_Done,
     /*  402391 */   // Label 7156: @402391
     /*  402391 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(402466), // Rule ID 7384 //
     /*  402396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  402399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  402407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  402410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  402413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402442 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  402442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402464 */     GIR_RootConstrainSelectedInstOperands,
     /*  402465 */     // GIR_Coverage, 7384,
     /*  402465 */     GIR_EraseRootFromParent_Done,
     /*  402466 */   // Label 7157: @402466
     /*  402466 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(402541), // Rule ID 7385 //
     /*  402471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  402474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  402482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  402485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  402488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402517 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  402517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402539 */     GIR_RootConstrainSelectedInstOperands,
     /*  402540 */     // GIR_Coverage, 7385,
     /*  402540 */     GIR_EraseRootFromParent_Done,
     /*  402541 */   // Label 7158: @402541
     /*  402541 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(402616), // Rule ID 7388 //
     /*  402546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  402557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  402560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  402563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  402592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  402595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402614 */     GIR_RootConstrainSelectedInstOperands,
     /*  402615 */     // GIR_Coverage, 7388,
     /*  402615 */     GIR_EraseRootFromParent_Done,
     /*  402616 */   // Label 7159: @402616
     /*  402616 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(402691), // Rule ID 7389 //
     /*  402621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  402632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  402635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  402638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402667 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  402667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  402670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402689 */     GIR_RootConstrainSelectedInstOperands,
     /*  402690 */     // GIR_Coverage, 7389,
     /*  402690 */     GIR_EraseRootFromParent_Done,
     /*  402691 */   // Label 7160: @402691
     /*  402691 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(402766), // Rule ID 7392 //
     /*  402696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  402707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  402710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  402713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402742 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  402742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  402745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402764 */     GIR_RootConstrainSelectedInstOperands,
     /*  402765 */     // GIR_Coverage, 7392,
     /*  402765 */     GIR_EraseRootFromParent_Done,
     /*  402766 */   // Label 7161: @402766
     /*  402766 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(402841), // Rule ID 7393 //
     /*  402771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  402782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  402785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  402788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402817 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  402817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  402820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402839 */     GIR_RootConstrainSelectedInstOperands,
     /*  402840 */     // GIR_Coverage, 7393,
     /*  402840 */     GIR_EraseRootFromParent_Done,
     /*  402841 */   // Label 7162: @402841
     /*  402841 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(402916), // Rule ID 7396 //
     /*  402846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  402857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  402860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  402863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402892 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  402892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  402895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402914 */     GIR_RootConstrainSelectedInstOperands,
     /*  402915 */     // GIR_Coverage, 7396,
     /*  402915 */     GIR_EraseRootFromParent_Done,
     /*  402916 */   // Label 7163: @402916
     /*  402916 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(402991), // Rule ID 7397 //
     /*  402921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  402932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  402935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  402938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402967 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  402967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  402970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402989 */     GIR_RootConstrainSelectedInstOperands,
     /*  402990 */     // GIR_Coverage, 7397,
     /*  402990 */     GIR_EraseRootFromParent_Done,
     /*  402991 */   // Label 7164: @402991
     /*  402991 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(403066), // Rule ID 7400 //
     /*  402996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  403007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  403010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  403013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403042 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  403045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403064 */     GIR_RootConstrainSelectedInstOperands,
     /*  403065 */     // GIR_Coverage, 7400,
     /*  403065 */     GIR_EraseRootFromParent_Done,
     /*  403066 */   // Label 7165: @403066
     /*  403066 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(403141), // Rule ID 7401 //
     /*  403071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  403082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  403085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  403088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403106 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403117 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  403120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403139 */     GIR_RootConstrainSelectedInstOperands,
     /*  403140 */     // GIR_Coverage, 7401,
     /*  403140 */     GIR_EraseRootFromParent_Done,
     /*  403141 */   // Label 7166: @403141
     /*  403141 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(403216), // Rule ID 7404 //
     /*  403146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  403157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  403160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  403163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403192 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  403195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403214 */     GIR_RootConstrainSelectedInstOperands,
     /*  403215 */     // GIR_Coverage, 7404,
     /*  403215 */     GIR_EraseRootFromParent_Done,
     /*  403216 */   // Label 7167: @403216
     /*  403216 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(403291), // Rule ID 7405 //
     /*  403221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  403232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  403235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  403238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403267 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  403270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403289 */     GIR_RootConstrainSelectedInstOperands,
     /*  403290 */     // GIR_Coverage, 7405,
     /*  403290 */     GIR_EraseRootFromParent_Done,
     /*  403291 */   // Label 7168: @403291
     /*  403291 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(403366), // Rule ID 7408 //
     /*  403296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  403307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  403310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  403313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403342 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  403345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403364 */     GIR_RootConstrainSelectedInstOperands,
     /*  403365 */     // GIR_Coverage, 7408,
     /*  403365 */     GIR_EraseRootFromParent_Done,
     /*  403366 */   // Label 7169: @403366
     /*  403366 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(403441), // Rule ID 7409 //
     /*  403371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  403382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  403385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  403388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403417 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  403420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403439 */     GIR_RootConstrainSelectedInstOperands,
     /*  403440 */     // GIR_Coverage, 7409,
     /*  403440 */     GIR_EraseRootFromParent_Done,
     /*  403441 */   // Label 7170: @403441
     /*  403441 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(403516), // Rule ID 7412 //
     /*  403446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  403457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  403460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  403463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  403495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403514 */     GIR_RootConstrainSelectedInstOperands,
     /*  403515 */     // GIR_Coverage, 7412,
     /*  403515 */     GIR_EraseRootFromParent_Done,
     /*  403516 */   // Label 7171: @403516
     /*  403516 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(403591), // Rule ID 7413 //
     /*  403521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  403532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  403535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  403538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403567 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  403570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403589 */     GIR_RootConstrainSelectedInstOperands,
     /*  403590 */     // GIR_Coverage, 7413,
     /*  403590 */     GIR_EraseRootFromParent_Done,
     /*  403591 */   // Label 7172: @403591
     /*  403591 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(403666), // Rule ID 7416 //
     /*  403596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  403607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  403610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  403613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403642 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  403645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403664 */     GIR_RootConstrainSelectedInstOperands,
     /*  403665 */     // GIR_Coverage, 7416,
     /*  403665 */     GIR_EraseRootFromParent_Done,
     /*  403666 */   // Label 7173: @403666
     /*  403666 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(403741), // Rule ID 7417 //
     /*  403671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  403682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  403685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  403688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403717 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  403720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403739 */     GIR_RootConstrainSelectedInstOperands,
     /*  403740 */     // GIR_Coverage, 7417,
     /*  403740 */     GIR_EraseRootFromParent_Done,
     /*  403741 */   // Label 7174: @403741
     /*  403741 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(403816), // Rule ID 7420 //
     /*  403746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  403757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  403760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  403763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403792 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  403795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403814 */     GIR_RootConstrainSelectedInstOperands,
     /*  403815 */     // GIR_Coverage, 7420,
     /*  403815 */     GIR_EraseRootFromParent_Done,
     /*  403816 */   // Label 7175: @403816
     /*  403816 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(403891), // Rule ID 7421 //
     /*  403821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  403832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  403835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  403838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403867 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  403870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403889 */     GIR_RootConstrainSelectedInstOperands,
     /*  403890 */     // GIR_Coverage, 7421,
     /*  403890 */     GIR_EraseRootFromParent_Done,
     /*  403891 */   // Label 7176: @403891
     /*  403891 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(403966), // Rule ID 7424 //
     /*  403896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  403899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  403907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  403910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  403913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  403942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  403945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403964 */     GIR_RootConstrainSelectedInstOperands,
     /*  403965 */     // GIR_Coverage, 7424,
     /*  403965 */     GIR_EraseRootFromParent_Done,
     /*  403966 */   // Label 7177: @403966
     /*  403966 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(404041), // Rule ID 7425 //
     /*  403971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  403974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  403982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  403985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  403988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  404010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404017 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  404020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404039 */     GIR_RootConstrainSelectedInstOperands,
     /*  404040 */     // GIR_Coverage, 7425,
     /*  404040 */     GIR_EraseRootFromParent_Done,
     /*  404041 */   // Label 7178: @404041
     /*  404041 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(404116), // Rule ID 7428 //
     /*  404046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  404049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  404054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  404057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  404060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  404063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  404066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  404085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404092 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  404092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  404095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404114 */     GIR_RootConstrainSelectedInstOperands,
     /*  404115 */     // GIR_Coverage, 7428,
     /*  404115 */     GIR_EraseRootFromParent_Done,
     /*  404116 */   // Label 7179: @404116
     /*  404116 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(404191), // Rule ID 7429 //
     /*  404121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  404124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  404129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  404132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  404135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  404138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  404141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  404160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404167 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  404170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404189 */     GIR_RootConstrainSelectedInstOperands,
     /*  404190 */     // GIR_Coverage, 7429,
     /*  404190 */     GIR_EraseRootFromParent_Done,
     /*  404191 */   // Label 7180: @404191
     /*  404191 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(404266), // Rule ID 7432 //
     /*  404196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  404199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  404204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  404207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  404210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  404213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  404216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  404235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404242 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  404242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  404245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404264 */     GIR_RootConstrainSelectedInstOperands,
     /*  404265 */     // GIR_Coverage, 7432,
     /*  404265 */     GIR_EraseRootFromParent_Done,
     /*  404266 */   // Label 7181: @404266
     /*  404266 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(404341), // Rule ID 7433 //
     /*  404271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  404274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  404279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  404282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  404285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  404288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  404291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  404310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404317 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  404320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404339 */     GIR_RootConstrainSelectedInstOperands,
     /*  404340 */     // GIR_Coverage, 7433,
     /*  404340 */     GIR_EraseRootFromParent_Done,
     /*  404341 */   // Label 7182: @404341
     /*  404341 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(404418), // Rule ID 2738 //
     /*  404346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  404357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  404360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  404363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404378 */     // MIs[0] Operand 4
     /*  404378 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404396 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  404399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404416 */     GIR_RootConstrainSelectedInstOperands,
     /*  404417 */     // GIR_Coverage, 2738,
     /*  404417 */     GIR_EraseRootFromParent_Done,
     /*  404418 */   // Label 7183: @404418
     /*  404418 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(404495), // Rule ID 2739 //
     /*  404423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  404434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  404437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  404440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404455 */     // MIs[0] Operand 4
     /*  404455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404473 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  404476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404493 */     GIR_RootConstrainSelectedInstOperands,
     /*  404494 */     // GIR_Coverage, 2739,
     /*  404494 */     GIR_EraseRootFromParent_Done,
     /*  404495 */   // Label 7184: @404495
     /*  404495 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(404572), // Rule ID 20630 //
     /*  404500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  404511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  404514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  404517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404532 */     // MIs[0] Operand 4
     /*  404532 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404550 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  404553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404570 */     GIR_RootConstrainSelectedInstOperands,
     /*  404571 */     // GIR_Coverage, 20630,
     /*  404571 */     GIR_EraseRootFromParent_Done,
     /*  404572 */   // Label 7185: @404572
     /*  404572 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(404649), // Rule ID 20631 //
     /*  404577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  404588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  404591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  404594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404609 */     // MIs[0] Operand 4
     /*  404609 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404627 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  404630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404647 */     GIR_RootConstrainSelectedInstOperands,
     /*  404648 */     // GIR_Coverage, 20631,
     /*  404648 */     GIR_EraseRootFromParent_Done,
     /*  404649 */   // Label 7186: @404649
     /*  404649 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(404726), // Rule ID 20634 //
     /*  404654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  404665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  404668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  404671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404686 */     // MIs[0] Operand 4
     /*  404686 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404704 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  404704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  404707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404724 */     GIR_RootConstrainSelectedInstOperands,
     /*  404725 */     // GIR_Coverage, 20634,
     /*  404725 */     GIR_EraseRootFromParent_Done,
     /*  404726 */   // Label 7187: @404726
     /*  404726 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(404803), // Rule ID 20635 //
     /*  404731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  404734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  404742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  404745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  404748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404763 */     // MIs[0] Operand 4
     /*  404763 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404781 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  404784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404801 */     GIR_RootConstrainSelectedInstOperands,
     /*  404802 */     // GIR_Coverage, 20635,
     /*  404802 */     GIR_EraseRootFromParent_Done,
     /*  404803 */   // Label 7188: @404803
     /*  404803 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(404880), // Rule ID 20638 //
     /*  404808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  404819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  404822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  404825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404840 */     // MIs[0] Operand 4
     /*  404840 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404858 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  404861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404878 */     GIR_RootConstrainSelectedInstOperands,
     /*  404879 */     // GIR_Coverage, 20638,
     /*  404879 */     GIR_EraseRootFromParent_Done,
     /*  404880 */   // Label 7189: @404880
     /*  404880 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(404957), // Rule ID 20639 //
     /*  404885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  404896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  404899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  404902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404917 */     // MIs[0] Operand 4
     /*  404917 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404935 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  404938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404955 */     GIR_RootConstrainSelectedInstOperands,
     /*  404956 */     // GIR_Coverage, 20639,
     /*  404956 */     GIR_EraseRootFromParent_Done,
     /*  404957 */   // Label 7190: @404957
     /*  404957 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(405034), // Rule ID 20642 //
     /*  404962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  404973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  404976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  404979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404994 */     // MIs[0] Operand 4
     /*  404994 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405012 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  405015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405032 */     GIR_RootConstrainSelectedInstOperands,
     /*  405033 */     // GIR_Coverage, 20642,
     /*  405033 */     GIR_EraseRootFromParent_Done,
     /*  405034 */   // Label 7191: @405034
     /*  405034 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(405111), // Rule ID 20643 //
     /*  405039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  405042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  405056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405071 */     // MIs[0] Operand 4
     /*  405071 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405089 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  405089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  405092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405109 */     GIR_RootConstrainSelectedInstOperands,
     /*  405110 */     // GIR_Coverage, 20643,
     /*  405110 */     GIR_EraseRootFromParent_Done,
     /*  405111 */   // Label 7192: @405111
     /*  405111 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(405188), // Rule ID 20646 //
     /*  405116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  405119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  405127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  405130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  405133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405148 */     // MIs[0] Operand 4
     /*  405148 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405166 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  405166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  405169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405186 */     GIR_RootConstrainSelectedInstOperands,
     /*  405187 */     // GIR_Coverage, 20646,
     /*  405187 */     GIR_EraseRootFromParent_Done,
     /*  405188 */   // Label 7193: @405188
     /*  405188 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(405265), // Rule ID 20647 //
     /*  405193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  405196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  405204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  405207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  405210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405225 */     // MIs[0] Operand 4
     /*  405225 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405243 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  405243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  405246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405263 */     GIR_RootConstrainSelectedInstOperands,
     /*  405264 */     // GIR_Coverage, 20647,
     /*  405264 */     GIR_EraseRootFromParent_Done,
     /*  405265 */   // Label 7194: @405265
     /*  405265 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(405342), // Rule ID 20650 //
     /*  405270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  405281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  405284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  405287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405302 */     // MIs[0] Operand 4
     /*  405302 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405320 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  405323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405340 */     GIR_RootConstrainSelectedInstOperands,
     /*  405341 */     // GIR_Coverage, 20650,
     /*  405341 */     GIR_EraseRootFromParent_Done,
     /*  405342 */   // Label 7195: @405342
     /*  405342 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(405419), // Rule ID 20651 //
     /*  405347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  405358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  405361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  405364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405379 */     // MIs[0] Operand 4
     /*  405379 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405397 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  405400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405417 */     GIR_RootConstrainSelectedInstOperands,
     /*  405418 */     // GIR_Coverage, 20651,
     /*  405418 */     GIR_EraseRootFromParent_Done,
     /*  405419 */   // Label 7196: @405419
     /*  405419 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(405496), // Rule ID 20654 //
     /*  405424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  405435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  405438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  405441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405456 */     // MIs[0] Operand 4
     /*  405456 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  405477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405494 */     GIR_RootConstrainSelectedInstOperands,
     /*  405495 */     // GIR_Coverage, 20654,
     /*  405495 */     GIR_EraseRootFromParent_Done,
     /*  405496 */   // Label 7197: @405496
     /*  405496 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(405573), // Rule ID 20655 //
     /*  405501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  405512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  405515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  405518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405533 */     // MIs[0] Operand 4
     /*  405533 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405551 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  405554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405571 */     GIR_RootConstrainSelectedInstOperands,
     /*  405572 */     // GIR_Coverage, 20655,
     /*  405572 */     GIR_EraseRootFromParent_Done,
     /*  405573 */   // Label 7198: @405573
     /*  405573 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(405650), // Rule ID 20658 //
     /*  405578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  405589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  405592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  405595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405610 */     // MIs[0] Operand 4
     /*  405610 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405628 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  405631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405648 */     GIR_RootConstrainSelectedInstOperands,
     /*  405649 */     // GIR_Coverage, 20658,
     /*  405649 */     GIR_EraseRootFromParent_Done,
     /*  405650 */   // Label 7199: @405650
     /*  405650 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(405727), // Rule ID 20659 //
     /*  405655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  405666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  405669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  405672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405687 */     // MIs[0] Operand 4
     /*  405687 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405705 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  405708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405725 */     GIR_RootConstrainSelectedInstOperands,
     /*  405726 */     // GIR_Coverage, 20659,
     /*  405726 */     GIR_EraseRootFromParent_Done,
     /*  405727 */   // Label 7200: @405727
     /*  405727 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(405804), // Rule ID 20662 //
     /*  405732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  405735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  405749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405764 */     // MIs[0] Operand 4
     /*  405764 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  405785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405802 */     GIR_RootConstrainSelectedInstOperands,
     /*  405803 */     // GIR_Coverage, 20662,
     /*  405803 */     GIR_EraseRootFromParent_Done,
     /*  405804 */   // Label 7201: @405804
     /*  405804 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(405881), // Rule ID 20663 //
     /*  405809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  405812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  405826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405841 */     // MIs[0] Operand 4
     /*  405841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405859 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  405859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  405862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405879 */     GIR_RootConstrainSelectedInstOperands,
     /*  405880 */     // GIR_Coverage, 20663,
     /*  405880 */     GIR_EraseRootFromParent_Done,
     /*  405881 */   // Label 7202: @405881
     /*  405881 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(405958), // Rule ID 20666 //
     /*  405886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  405889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  405897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  405900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  405903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405918 */     // MIs[0] Operand 4
     /*  405918 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405936 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  405939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405956 */     GIR_RootConstrainSelectedInstOperands,
     /*  405957 */     // GIR_Coverage, 20666,
     /*  405957 */     GIR_EraseRootFromParent_Done,
     /*  405958 */   // Label 7203: @405958
     /*  405958 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(406035), // Rule ID 20667 //
     /*  405963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  405966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  405974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  405977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  405980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405995 */     // MIs[0] Operand 4
     /*  405995 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406013 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  406016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406033 */     GIR_RootConstrainSelectedInstOperands,
     /*  406034 */     // GIR_Coverage, 20667,
     /*  406034 */     GIR_EraseRootFromParent_Done,
     /*  406035 */   // Label 7204: @406035
     /*  406035 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(406112), // Rule ID 20670 //
     /*  406040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  406043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  406051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  406054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  406057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406072 */     // MIs[0] Operand 4
     /*  406072 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406090 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  406093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406110 */     GIR_RootConstrainSelectedInstOperands,
     /*  406111 */     // GIR_Coverage, 20670,
     /*  406111 */     GIR_EraseRootFromParent_Done,
     /*  406112 */   // Label 7205: @406112
     /*  406112 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(406189), // Rule ID 20671 //
     /*  406117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  406120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  406128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  406131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  406134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406149 */     // MIs[0] Operand 4
     /*  406149 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406167 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  406170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406187 */     GIR_RootConstrainSelectedInstOperands,
     /*  406188 */     // GIR_Coverage, 20671,
     /*  406188 */     GIR_EraseRootFromParent_Done,
     /*  406189 */   // Label 7206: @406189
     /*  406189 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(406266), // Rule ID 20674 //
     /*  406194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  406197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  406205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  406208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  406211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406226 */     // MIs[0] Operand 4
     /*  406226 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  406244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  406247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  406261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406264 */     GIR_RootConstrainSelectedInstOperands,
     /*  406265 */     // GIR_Coverage, 20674,
     /*  406265 */     GIR_EraseRootFromParent_Done,
     /*  406266 */   // Label 7207: @406266
     /*  406266 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(406343), // Rule ID 20675 //
     /*  406271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  406274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  406282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  406285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  406288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406303 */     // MIs[0] Operand 4
     /*  406303 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  406321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  406324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  406338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406341 */     GIR_RootConstrainSelectedInstOperands,
     /*  406342 */     // GIR_Coverage, 20675,
     /*  406342 */     GIR_EraseRootFromParent_Done,
     /*  406343 */   // Label 7208: @406343
     /*  406343 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(406420), // Rule ID 20678 //
     /*  406348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  406351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  406359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  406362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  406365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406380 */     // MIs[0] Operand 4
     /*  406380 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406398 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  406398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  406401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  406415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406418 */     GIR_RootConstrainSelectedInstOperands,
     /*  406419 */     // GIR_Coverage, 20678,
     /*  406419 */     GIR_EraseRootFromParent_Done,
     /*  406420 */   // Label 7209: @406420
     /*  406420 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(406497), // Rule ID 20679 //
     /*  406425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  406428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  406436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  406439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  406442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406457 */     // MIs[0] Operand 4
     /*  406457 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406475 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  406475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  406478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  406492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406495 */     GIR_RootConstrainSelectedInstOperands,
     /*  406496 */     // GIR_Coverage, 20679,
     /*  406496 */     GIR_EraseRootFromParent_Done,
     /*  406497 */   // Label 7210: @406497
     /*  406497 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(406574), // Rule ID 20682 //
     /*  406502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  406505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  406513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  406516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  406519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406534 */     // MIs[0] Operand 4
     /*  406534 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406552 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  406552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  406555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  406569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406572 */     GIR_RootConstrainSelectedInstOperands,
     /*  406573 */     // GIR_Coverage, 20682,
     /*  406573 */     GIR_EraseRootFromParent_Done,
     /*  406574 */   // Label 7211: @406574
     /*  406574 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(406651), // Rule ID 20683 //
     /*  406579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  406582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  406590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  406593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  406596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406611 */     // MIs[0] Operand 4
     /*  406611 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406629 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  406629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  406632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  406646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406649 */     GIR_RootConstrainSelectedInstOperands,
     /*  406650 */     // GIR_Coverage, 20683,
     /*  406650 */     GIR_EraseRootFromParent_Done,
     /*  406651 */   // Label 7212: @406651
     /*  406651 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(406728), // Rule ID 20686 //
     /*  406656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  406664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  406667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  406670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  406673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406688 */     // MIs[0] Operand 4
     /*  406688 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  406709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406726 */     GIR_RootConstrainSelectedInstOperands,
     /*  406727 */     // GIR_Coverage, 20686,
     /*  406727 */     GIR_EraseRootFromParent_Done,
     /*  406728 */   // Label 7213: @406728
     /*  406728 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(406805), // Rule ID 20687 //
     /*  406733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  406741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  406744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  406747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  406750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406765 */     // MIs[0] Operand 4
     /*  406765 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406783 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  406786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406803 */     GIR_RootConstrainSelectedInstOperands,
     /*  406804 */     // GIR_Coverage, 20687,
     /*  406804 */     GIR_EraseRootFromParent_Done,
     /*  406805 */   // Label 7214: @406805
     /*  406805 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(406882), // Rule ID 20690 //
     /*  406810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  406818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  406821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  406824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  406827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406842 */     // MIs[0] Operand 4
     /*  406842 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  406863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406880 */     GIR_RootConstrainSelectedInstOperands,
     /*  406881 */     // GIR_Coverage, 20690,
     /*  406881 */     GIR_EraseRootFromParent_Done,
     /*  406882 */   // Label 7215: @406882
     /*  406882 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(406959), // Rule ID 20691 //
     /*  406887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  406895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  406898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  406901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  406904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406919 */     // MIs[0] Operand 4
     /*  406919 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406937 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  406940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406957 */     GIR_RootConstrainSelectedInstOperands,
     /*  406958 */     // GIR_Coverage, 20691,
     /*  406958 */     GIR_EraseRootFromParent_Done,
     /*  406959 */   // Label 7216: @406959
     /*  406959 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(407036), // Rule ID 20694 //
     /*  406964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  406967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  406972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  406975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  406978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  406981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406996 */     // MIs[0] Operand 4
     /*  406996 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  407017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407034 */     GIR_RootConstrainSelectedInstOperands,
     /*  407035 */     // GIR_Coverage, 20694,
     /*  407035 */     GIR_EraseRootFromParent_Done,
     /*  407036 */   // Label 7217: @407036
     /*  407036 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(407113), // Rule ID 20695 //
     /*  407041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  407044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  407052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  407055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  407058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407073 */     // MIs[0] Operand 4
     /*  407073 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407091 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  407094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407111 */     GIR_RootConstrainSelectedInstOperands,
     /*  407112 */     // GIR_Coverage, 20695,
     /*  407112 */     GIR_EraseRootFromParent_Done,
     /*  407113 */   // Label 7218: @407113
     /*  407113 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(407190), // Rule ID 20698 //
     /*  407118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  407129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  407132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  407135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407150 */     // MIs[0] Operand 4
     /*  407150 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  407171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407188 */     GIR_RootConstrainSelectedInstOperands,
     /*  407189 */     // GIR_Coverage, 20698,
     /*  407189 */     GIR_EraseRootFromParent_Done,
     /*  407190 */   // Label 7219: @407190
     /*  407190 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(407267), // Rule ID 20699 //
     /*  407195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  407206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  407209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  407212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407227 */     // MIs[0] Operand 4
     /*  407227 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407245 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  407248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407265 */     GIR_RootConstrainSelectedInstOperands,
     /*  407266 */     // GIR_Coverage, 20699,
     /*  407266 */     GIR_EraseRootFromParent_Done,
     /*  407267 */   // Label 7220: @407267
     /*  407267 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(407344), // Rule ID 20702 //
     /*  407272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  407275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  407283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  407286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407304 */     // MIs[0] Operand 4
     /*  407304 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  407325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407342 */     GIR_RootConstrainSelectedInstOperands,
     /*  407343 */     // GIR_Coverage, 20702,
     /*  407343 */     GIR_EraseRootFromParent_Done,
     /*  407344 */   // Label 7221: @407344
     /*  407344 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(407421), // Rule ID 20703 //
     /*  407349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  407352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  407360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  407363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407381 */     // MIs[0] Operand 4
     /*  407381 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407399 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  407402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407419 */     GIR_RootConstrainSelectedInstOperands,
     /*  407420 */     // GIR_Coverage, 20703,
     /*  407420 */     GIR_EraseRootFromParent_Done,
     /*  407421 */   // Label 7222: @407421
     /*  407421 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(407498), // Rule ID 20706 //
     /*  407426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  407429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  407437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  407440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  407443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407458 */     // MIs[0] Operand 4
     /*  407458 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  407476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  407479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  407493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407496 */     GIR_RootConstrainSelectedInstOperands,
     /*  407497 */     // GIR_Coverage, 20706,
     /*  407497 */     GIR_EraseRootFromParent_Done,
     /*  407498 */   // Label 7223: @407498
     /*  407498 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(407575), // Rule ID 20707 //
     /*  407503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  407506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  407514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  407517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  407520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407535 */     // MIs[0] Operand 4
     /*  407535 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407553 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  407553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  407556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  407570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407573 */     GIR_RootConstrainSelectedInstOperands,
     /*  407574 */     // GIR_Coverage, 20707,
     /*  407574 */     GIR_EraseRootFromParent_Done,
     /*  407575 */   // Label 7224: @407575
     /*  407575 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(407652), // Rule ID 20710 //
     /*  407580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  407591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  407594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  407597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407612 */     // MIs[0] Operand 4
     /*  407612 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  407633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407650 */     GIR_RootConstrainSelectedInstOperands,
     /*  407651 */     // GIR_Coverage, 20710,
     /*  407651 */     GIR_EraseRootFromParent_Done,
     /*  407652 */   // Label 7225: @407652
     /*  407652 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(407729), // Rule ID 20711 //
     /*  407657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  407668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  407671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  407674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407689 */     // MIs[0] Operand 4
     /*  407689 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  407710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407727 */     GIR_RootConstrainSelectedInstOperands,
     /*  407728 */     // GIR_Coverage, 20711,
     /*  407728 */     GIR_EraseRootFromParent_Done,
     /*  407729 */   // Label 7226: @407729
     /*  407729 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(407806), // Rule ID 20714 //
     /*  407734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  407745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  407748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  407751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407766 */     // MIs[0] Operand 4
     /*  407766 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407784 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  407787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407804 */     GIR_RootConstrainSelectedInstOperands,
     /*  407805 */     // GIR_Coverage, 20714,
     /*  407805 */     GIR_EraseRootFromParent_Done,
     /*  407806 */   // Label 7227: @407806
     /*  407806 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(407883), // Rule ID 20715 //
     /*  407811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  407822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  407825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  407828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407843 */     // MIs[0] Operand 4
     /*  407843 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407861 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  407864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407881 */     GIR_RootConstrainSelectedInstOperands,
     /*  407882 */     // GIR_Coverage, 20715,
     /*  407882 */     GIR_EraseRootFromParent_Done,
     /*  407883 */   // Label 7228: @407883
     /*  407883 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(407960), // Rule ID 20718 //
     /*  407888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  407899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  407902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  407905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407920 */     // MIs[0] Operand 4
     /*  407920 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407938 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  407941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407958 */     GIR_RootConstrainSelectedInstOperands,
     /*  407959 */     // GIR_Coverage, 20718,
     /*  407959 */     GIR_EraseRootFromParent_Done,
     /*  407960 */   // Label 7229: @407960
     /*  407960 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(408037), // Rule ID 20719 //
     /*  407965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  407976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  407979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  407982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407997 */     // MIs[0] Operand 4
     /*  407997 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408015 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  408015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  408018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408035 */     GIR_RootConstrainSelectedInstOperands,
     /*  408036 */     // GIR_Coverage, 20719,
     /*  408036 */     GIR_EraseRootFromParent_Done,
     /*  408037 */   // Label 7230: @408037
     /*  408037 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(408114), // Rule ID 20722 //
     /*  408042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  408053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  408056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  408059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408074 */     // MIs[0] Operand 4
     /*  408074 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408092 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  408092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  408095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408112 */     GIR_RootConstrainSelectedInstOperands,
     /*  408113 */     // GIR_Coverage, 20722,
     /*  408113 */     GIR_EraseRootFromParent_Done,
     /*  408114 */   // Label 7231: @408114
     /*  408114 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(408191), // Rule ID 20723 //
     /*  408119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  408122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  408130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  408133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  408136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408151 */     // MIs[0] Operand 4
     /*  408151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  408169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  408172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408189 */     GIR_RootConstrainSelectedInstOperands,
     /*  408190 */     // GIR_Coverage, 20723,
     /*  408190 */     GIR_EraseRootFromParent_Done,
     /*  408191 */   // Label 7232: @408191
     /*  408191 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(408268), // Rule ID 20726 //
     /*  408196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  408207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  408210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  408213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408228 */     // MIs[0] Operand 4
     /*  408228 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408246 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  408246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  408249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408266 */     GIR_RootConstrainSelectedInstOperands,
     /*  408267 */     // GIR_Coverage, 20726,
     /*  408267 */     GIR_EraseRootFromParent_Done,
     /*  408268 */   // Label 7233: @408268
     /*  408268 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(408345), // Rule ID 20727 //
     /*  408273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  408276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  408284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  408287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  408290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408305 */     // MIs[0] Operand 4
     /*  408305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408323 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  408323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  408326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408343 */     GIR_RootConstrainSelectedInstOperands,
     /*  408344 */     // GIR_Coverage, 20727,
     /*  408344 */     GIR_EraseRootFromParent_Done,
     /*  408345 */   // Label 7234: @408345
     /*  408345 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(408422), // Rule ID 20730 //
     /*  408350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  408361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  408364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  408367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408382 */     // MIs[0] Operand 4
     /*  408382 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  408400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  408403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408420 */     GIR_RootConstrainSelectedInstOperands,
     /*  408421 */     // GIR_Coverage, 20730,
     /*  408421 */     GIR_EraseRootFromParent_Done,
     /*  408422 */   // Label 7235: @408422
     /*  408422 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(408499), // Rule ID 20731 //
     /*  408427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  408430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  408438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  408441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  408444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408459 */     // MIs[0] Operand 4
     /*  408459 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408477 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  408477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  408480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408497 */     GIR_RootConstrainSelectedInstOperands,
     /*  408498 */     // GIR_Coverage, 20731,
     /*  408498 */     GIR_EraseRootFromParent_Done,
     /*  408499 */   // Label 7236: @408499
     /*  408499 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(408576), // Rule ID 20734 //
     /*  408504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  408507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  408515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  408518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  408521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408536 */     // MIs[0] Operand 4
     /*  408536 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408554 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  408554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  408557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  408571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408574 */     GIR_RootConstrainSelectedInstOperands,
     /*  408575 */     // GIR_Coverage, 20734,
     /*  408575 */     GIR_EraseRootFromParent_Done,
     /*  408576 */   // Label 7237: @408576
     /*  408576 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(408653), // Rule ID 20735 //
     /*  408581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  408584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  408592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  408595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  408598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408613 */     // MIs[0] Operand 4
     /*  408613 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  408631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  408634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  408648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408651 */     GIR_RootConstrainSelectedInstOperands,
     /*  408652 */     // GIR_Coverage, 20735,
     /*  408652 */     GIR_EraseRootFromParent_Done,
     /*  408653 */   // Label 7238: @408653
     /*  408653 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(408730), // Rule ID 20738 //
     /*  408658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  408661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  408669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  408672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  408675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408690 */     // MIs[0] Operand 4
     /*  408690 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408708 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  408708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  408711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  408725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408728 */     GIR_RootConstrainSelectedInstOperands,
     /*  408729 */     // GIR_Coverage, 20738,
     /*  408729 */     GIR_EraseRootFromParent_Done,
     /*  408730 */   // Label 7239: @408730
     /*  408730 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(408807), // Rule ID 20739 //
     /*  408735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  408738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  408746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  408749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  408752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408767 */     // MIs[0] Operand 4
     /*  408767 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408785 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  408785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  408788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  408802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408805 */     GIR_RootConstrainSelectedInstOperands,
     /*  408806 */     // GIR_Coverage, 20739,
     /*  408806 */     GIR_EraseRootFromParent_Done,
     /*  408807 */   // Label 7240: @408807
     /*  408807 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(408884), // Rule ID 20742 //
     /*  408812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  408815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  408823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  408826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  408829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408844 */     // MIs[0] Operand 4
     /*  408844 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408862 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  408862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  408865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  408879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408882 */     GIR_RootConstrainSelectedInstOperands,
     /*  408883 */     // GIR_Coverage, 20742,
     /*  408883 */     GIR_EraseRootFromParent_Done,
     /*  408884 */   // Label 7241: @408884
     /*  408884 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(408961), // Rule ID 20743 //
     /*  408889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  408892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  408900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  408903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  408906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408921 */     // MIs[0] Operand 4
     /*  408921 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408939 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  408939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  408942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  408956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408959 */     GIR_RootConstrainSelectedInstOperands,
     /*  408960 */     // GIR_Coverage, 20743,
     /*  408960 */     GIR_EraseRootFromParent_Done,
     /*  408961 */   // Label 7242: @408961
     /*  408961 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(409038), // Rule ID 21102 //
     /*  408966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  408974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  408977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  408980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  408983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408998 */     // MIs[0] Operand 4
     /*  408998 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  409019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409036 */     GIR_RootConstrainSelectedInstOperands,
     /*  409037 */     // GIR_Coverage, 21102,
     /*  409037 */     GIR_EraseRootFromParent_Done,
     /*  409038 */   // Label 7243: @409038
     /*  409038 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(409115), // Rule ID 21103 //
     /*  409043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  409054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  409057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  409060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409075 */     // MIs[0] Operand 4
     /*  409075 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409093 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  409096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409113 */     GIR_RootConstrainSelectedInstOperands,
     /*  409114 */     // GIR_Coverage, 21103,
     /*  409114 */     GIR_EraseRootFromParent_Done,
     /*  409115 */   // Label 7244: @409115
     /*  409115 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(409192), // Rule ID 21106 //
     /*  409120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  409123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  409131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  409134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  409137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409152 */     // MIs[0] Operand 4
     /*  409152 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  409173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409190 */     GIR_RootConstrainSelectedInstOperands,
     /*  409191 */     // GIR_Coverage, 21106,
     /*  409191 */     GIR_EraseRootFromParent_Done,
     /*  409192 */   // Label 7245: @409192
     /*  409192 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(409269), // Rule ID 21107 //
     /*  409197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  409208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  409211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  409214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409229 */     // MIs[0] Operand 4
     /*  409229 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409247 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  409250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409267 */     GIR_RootConstrainSelectedInstOperands,
     /*  409268 */     // GIR_Coverage, 21107,
     /*  409268 */     GIR_EraseRootFromParent_Done,
     /*  409269 */   // Label 7246: @409269
     /*  409269 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(409346), // Rule ID 21110 //
     /*  409274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  409277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  409285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  409288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  409291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409306 */     // MIs[0] Operand 4
     /*  409306 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  409327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409344 */     GIR_RootConstrainSelectedInstOperands,
     /*  409345 */     // GIR_Coverage, 21110,
     /*  409345 */     GIR_EraseRootFromParent_Done,
     /*  409346 */   // Label 7247: @409346
     /*  409346 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(409423), // Rule ID 21111 //
     /*  409351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  409362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  409365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  409368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409383 */     // MIs[0] Operand 4
     /*  409383 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  409404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409421 */     GIR_RootConstrainSelectedInstOperands,
     /*  409422 */     // GIR_Coverage, 21111,
     /*  409422 */     GIR_EraseRootFromParent_Done,
     /*  409423 */   // Label 7248: @409423
     /*  409423 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(409500), // Rule ID 21114 //
     /*  409428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  409431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  409445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409460 */     // MIs[0] Operand 4
     /*  409460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  409481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409498 */     GIR_RootConstrainSelectedInstOperands,
     /*  409499 */     // GIR_Coverage, 21114,
     /*  409499 */     GIR_EraseRootFromParent_Done,
     /*  409500 */   // Label 7249: @409500
     /*  409500 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(409577), // Rule ID 21115 //
     /*  409505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  409522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409537 */     // MIs[0] Operand 4
     /*  409537 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409555 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  409558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409575 */     GIR_RootConstrainSelectedInstOperands,
     /*  409576 */     // GIR_Coverage, 21115,
     /*  409576 */     GIR_EraseRootFromParent_Done,
     /*  409577 */   // Label 7250: @409577
     /*  409577 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(409654), // Rule ID 21118 //
     /*  409582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  409585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  409593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  409596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  409599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409614 */     // MIs[0] Operand 4
     /*  409614 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  409635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409652 */     GIR_RootConstrainSelectedInstOperands,
     /*  409653 */     // GIR_Coverage, 21118,
     /*  409653 */     GIR_EraseRootFromParent_Done,
     /*  409654 */   // Label 7251: @409654
     /*  409654 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(409731), // Rule ID 21119 //
     /*  409659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  409670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  409673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  409676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409691 */     // MIs[0] Operand 4
     /*  409691 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409709 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  409712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409729 */     GIR_RootConstrainSelectedInstOperands,
     /*  409730 */     // GIR_Coverage, 21119,
     /*  409730 */     GIR_EraseRootFromParent_Done,
     /*  409731 */   // Label 7252: @409731
     /*  409731 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(409808), // Rule ID 21122 //
     /*  409736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  409739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  409747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  409750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  409753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409768 */     // MIs[0] Operand 4
     /*  409768 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  409789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409806 */     GIR_RootConstrainSelectedInstOperands,
     /*  409807 */     // GIR_Coverage, 21122,
     /*  409807 */     GIR_EraseRootFromParent_Done,
     /*  409808 */   // Label 7253: @409808
     /*  409808 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(409885), // Rule ID 21123 //
     /*  409813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  409816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  409824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  409827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  409830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409845 */     // MIs[0] Operand 4
     /*  409845 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409863 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  409863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  409866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409883 */     GIR_RootConstrainSelectedInstOperands,
     /*  409884 */     // GIR_Coverage, 21123,
     /*  409884 */     GIR_EraseRootFromParent_Done,
     /*  409885 */   // Label 7254: @409885
     /*  409885 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(409962), // Rule ID 21126 //
     /*  409890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  409893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  409901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  409904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409922 */     // MIs[0] Operand 4
     /*  409922 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409940 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  409943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409960 */     GIR_RootConstrainSelectedInstOperands,
     /*  409961 */     // GIR_Coverage, 21126,
     /*  409961 */     GIR_EraseRootFromParent_Done,
     /*  409962 */   // Label 7255: @409962
     /*  409962 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(410039), // Rule ID 21127 //
     /*  409967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  409970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  409978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  409981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409999 */     // MIs[0] Operand 4
     /*  409999 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410017 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  410020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410037 */     GIR_RootConstrainSelectedInstOperands,
     /*  410038 */     // GIR_Coverage, 21127,
     /*  410038 */     GIR_EraseRootFromParent_Done,
     /*  410039 */   // Label 7256: @410039
     /*  410039 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(410116), // Rule ID 21130 //
     /*  410044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  410047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  410052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  410055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  410058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  410061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410076 */     // MIs[0] Operand 4
     /*  410076 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410094 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  410097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410114 */     GIR_RootConstrainSelectedInstOperands,
     /*  410115 */     // GIR_Coverage, 21130,
     /*  410115 */     GIR_EraseRootFromParent_Done,
     /*  410116 */   // Label 7257: @410116
     /*  410116 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(410193), // Rule ID 21131 //
     /*  410121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  410124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  410129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  410132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  410135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  410138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410153 */     // MIs[0] Operand 4
     /*  410153 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410171 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  410174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410191 */     GIR_RootConstrainSelectedInstOperands,
     /*  410192 */     // GIR_Coverage, 21131,
     /*  410192 */     GIR_EraseRootFromParent_Done,
     /*  410193 */   // Label 7258: @410193
     /*  410193 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(410270), // Rule ID 21134 //
     /*  410198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  410201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  410206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  410209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  410212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  410215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410230 */     // MIs[0] Operand 4
     /*  410230 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410248 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  410251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410268 */     GIR_RootConstrainSelectedInstOperands,
     /*  410269 */     // GIR_Coverage, 21134,
     /*  410269 */     GIR_EraseRootFromParent_Done,
     /*  410270 */   // Label 7259: @410270
     /*  410270 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(410347), // Rule ID 21135 //
     /*  410275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  410278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  410283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  410286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  410289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  410292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410307 */     // MIs[0] Operand 4
     /*  410307 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410325 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  410328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410345 */     GIR_RootConstrainSelectedInstOperands,
     /*  410346 */     // GIR_Coverage, 21135,
     /*  410346 */     GIR_EraseRootFromParent_Done,
     /*  410347 */   // Label 7260: @410347
     /*  410347 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(410424), // Rule ID 21138 //
     /*  410352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  410363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  410366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  410369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410384 */     // MIs[0] Operand 4
     /*  410384 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410402 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  410402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  410405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410422 */     GIR_RootConstrainSelectedInstOperands,
     /*  410423 */     // GIR_Coverage, 21138,
     /*  410423 */     GIR_EraseRootFromParent_Done,
     /*  410424 */   // Label 7261: @410424
     /*  410424 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(410501), // Rule ID 21139 //
     /*  410429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  410440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  410443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  410446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410461 */     // MIs[0] Operand 4
     /*  410461 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410479 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  410479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  410482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410499 */     GIR_RootConstrainSelectedInstOperands,
     /*  410500 */     // GIR_Coverage, 21139,
     /*  410500 */     GIR_EraseRootFromParent_Done,
     /*  410501 */   // Label 7262: @410501
     /*  410501 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(410578), // Rule ID 21142 //
     /*  410506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  410517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  410520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  410523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410538 */     // MIs[0] Operand 4
     /*  410538 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410556 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  410556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  410559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410576 */     GIR_RootConstrainSelectedInstOperands,
     /*  410577 */     // GIR_Coverage, 21142,
     /*  410577 */     GIR_EraseRootFromParent_Done,
     /*  410578 */   // Label 7263: @410578
     /*  410578 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(410655), // Rule ID 21143 //
     /*  410583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  410594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  410597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  410600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410615 */     // MIs[0] Operand 4
     /*  410615 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410633 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  410633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  410636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410653 */     GIR_RootConstrainSelectedInstOperands,
     /*  410654 */     // GIR_Coverage, 21143,
     /*  410654 */     GIR_EraseRootFromParent_Done,
     /*  410655 */   // Label 7264: @410655
     /*  410655 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(410732), // Rule ID 21146 //
     /*  410660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  410671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  410674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  410677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410692 */     // MIs[0] Operand 4
     /*  410692 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  410710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  410713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410730 */     GIR_RootConstrainSelectedInstOperands,
     /*  410731 */     // GIR_Coverage, 21146,
     /*  410731 */     GIR_EraseRootFromParent_Done,
     /*  410732 */   // Label 7265: @410732
     /*  410732 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(410809), // Rule ID 21147 //
     /*  410737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  410748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  410751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  410754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410769 */     // MIs[0] Operand 4
     /*  410769 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410787 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  410787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  410790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410807 */     GIR_RootConstrainSelectedInstOperands,
     /*  410808 */     // GIR_Coverage, 21147,
     /*  410808 */     GIR_EraseRootFromParent_Done,
     /*  410809 */   // Label 7266: @410809
     /*  410809 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(410886), // Rule ID 21150 //
     /*  410814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  410831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410846 */     // MIs[0] Operand 4
     /*  410846 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410864 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  410864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  410867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410884 */     GIR_RootConstrainSelectedInstOperands,
     /*  410885 */     // GIR_Coverage, 21150,
     /*  410885 */     GIR_EraseRootFromParent_Done,
     /*  410886 */   // Label 7267: @410886
     /*  410886 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(410963), // Rule ID 21151 //
     /*  410891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  410908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410923 */     // MIs[0] Operand 4
     /*  410923 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410941 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  410941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  410944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410961 */     GIR_RootConstrainSelectedInstOperands,
     /*  410962 */     // GIR_Coverage, 21151,
     /*  410962 */     GIR_EraseRootFromParent_Done,
     /*  410963 */   // Label 7268: @410963
     /*  410963 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(411040), // Rule ID 21154 //
     /*  410968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  410979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  410982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  410985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411000 */     // MIs[0] Operand 4
     /*  411000 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  411021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411038 */     GIR_RootConstrainSelectedInstOperands,
     /*  411039 */     // GIR_Coverage, 21154,
     /*  411039 */     GIR_EraseRootFromParent_Done,
     /*  411040 */   // Label 7269: @411040
     /*  411040 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(411117), // Rule ID 21155 //
     /*  411045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  411056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  411059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  411062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411077 */     // MIs[0] Operand 4
     /*  411077 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411095 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  411098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411115 */     GIR_RootConstrainSelectedInstOperands,
     /*  411116 */     // GIR_Coverage, 21155,
     /*  411116 */     GIR_EraseRootFromParent_Done,
     /*  411117 */   // Label 7270: @411117
     /*  411117 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(411194), // Rule ID 21158 //
     /*  411122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  411125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  411133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  411136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411154 */     // MIs[0] Operand 4
     /*  411154 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411172 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  411175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411192 */     GIR_RootConstrainSelectedInstOperands,
     /*  411193 */     // GIR_Coverage, 21158,
     /*  411193 */     GIR_EraseRootFromParent_Done,
     /*  411194 */   // Label 7271: @411194
     /*  411194 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(411271), // Rule ID 21159 //
     /*  411199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  411202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  411210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  411213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411231 */     // MIs[0] Operand 4
     /*  411231 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411249 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  411249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  411252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411269 */     GIR_RootConstrainSelectedInstOperands,
     /*  411270 */     // GIR_Coverage, 21159,
     /*  411270 */     GIR_EraseRootFromParent_Done,
     /*  411271 */   // Label 7272: @411271
     /*  411271 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(411348), // Rule ID 21162 //
     /*  411276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  411279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  411287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  411290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411308 */     // MIs[0] Operand 4
     /*  411308 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  411329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411346 */     GIR_RootConstrainSelectedInstOperands,
     /*  411347 */     // GIR_Coverage, 21162,
     /*  411347 */     GIR_EraseRootFromParent_Done,
     /*  411348 */   // Label 7273: @411348
     /*  411348 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(411425), // Rule ID 21163 //
     /*  411353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  411356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  411364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  411367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411385 */     // MIs[0] Operand 4
     /*  411385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411403 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  411403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  411406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411423 */     GIR_RootConstrainSelectedInstOperands,
     /*  411424 */     // GIR_Coverage, 21163,
     /*  411424 */     GIR_EraseRootFromParent_Done,
     /*  411425 */   // Label 7274: @411425
     /*  411425 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(411502), // Rule ID 21166 //
     /*  411430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  411433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  411441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  411444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411462 */     // MIs[0] Operand 4
     /*  411462 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411480 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  411483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411500 */     GIR_RootConstrainSelectedInstOperands,
     /*  411501 */     // GIR_Coverage, 21166,
     /*  411501 */     GIR_EraseRootFromParent_Done,
     /*  411502 */   // Label 7275: @411502
     /*  411502 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(411579), // Rule ID 21167 //
     /*  411507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  411510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  411518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  411521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411539 */     // MIs[0] Operand 4
     /*  411539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411557 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  411557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  411560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411577 */     GIR_RootConstrainSelectedInstOperands,
     /*  411578 */     // GIR_Coverage, 21167,
     /*  411578 */     GIR_EraseRootFromParent_Done,
     /*  411579 */   // Label 7276: @411579
     /*  411579 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(411656), // Rule ID 21170 //
     /*  411584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  411587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  411595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  411598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  411601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411616 */     // MIs[0] Operand 4
     /*  411616 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411634 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  411637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411654 */     GIR_RootConstrainSelectedInstOperands,
     /*  411655 */     // GIR_Coverage, 21170,
     /*  411655 */     GIR_EraseRootFromParent_Done,
     /*  411656 */   // Label 7277: @411656
     /*  411656 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(411733), // Rule ID 21171 //
     /*  411661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  411664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  411672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  411675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  411678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411693 */     // MIs[0] Operand 4
     /*  411693 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411711 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  411711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  411714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411731 */     GIR_RootConstrainSelectedInstOperands,
     /*  411732 */     // GIR_Coverage, 21171,
     /*  411732 */     GIR_EraseRootFromParent_Done,
     /*  411733 */   // Label 7278: @411733
     /*  411733 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(411810), // Rule ID 21474 //
     /*  411738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  411741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  411746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  411749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  411752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  411755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411770 */     // MIs[0] Operand 4
     /*  411770 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411788 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  411791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411808 */     GIR_RootConstrainSelectedInstOperands,
     /*  411809 */     // GIR_Coverage, 21474,
     /*  411809 */     GIR_EraseRootFromParent_Done,
     /*  411810 */   // Label 7279: @411810
     /*  411810 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(411887), // Rule ID 21475 //
     /*  411815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  411823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  411826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  411829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  411832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411847 */     // MIs[0] Operand 4
     /*  411847 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411865 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  411865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  411868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411885 */     GIR_RootConstrainSelectedInstOperands,
     /*  411886 */     // GIR_Coverage, 21475,
     /*  411886 */     GIR_EraseRootFromParent_Done,
     /*  411887 */   // Label 7280: @411887
     /*  411887 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(411964), // Rule ID 21478 //
     /*  411892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  411895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  411900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  411903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  411906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  411909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411924 */     // MIs[0] Operand 4
     /*  411924 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411942 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  411945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411962 */     GIR_RootConstrainSelectedInstOperands,
     /*  411963 */     // GIR_Coverage, 21478,
     /*  411963 */     GIR_EraseRootFromParent_Done,
     /*  411964 */   // Label 7281: @411964
     /*  411964 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(412041), // Rule ID 21479 //
     /*  411969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  411977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  411980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  411983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  411986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412001 */     // MIs[0] Operand 4
     /*  412001 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412019 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  412019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  412022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412039 */     GIR_RootConstrainSelectedInstOperands,
     /*  412040 */     // GIR_Coverage, 21479,
     /*  412040 */     GIR_EraseRootFromParent_Done,
     /*  412041 */   // Label 7282: @412041
     /*  412041 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(412118), // Rule ID 21482 //
     /*  412046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  412049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  412057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  412060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  412063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412078 */     // MIs[0] Operand 4
     /*  412078 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  412096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  412099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412116 */     GIR_RootConstrainSelectedInstOperands,
     /*  412117 */     // GIR_Coverage, 21482,
     /*  412117 */     GIR_EraseRootFromParent_Done,
     /*  412118 */   // Label 7283: @412118
     /*  412118 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(412195), // Rule ID 21483 //
     /*  412123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  412126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  412134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  412137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  412140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412155 */     // MIs[0] Operand 4
     /*  412155 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412173 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  412173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  412176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412193 */     GIR_RootConstrainSelectedInstOperands,
     /*  412194 */     // GIR_Coverage, 21483,
     /*  412194 */     GIR_EraseRootFromParent_Done,
     /*  412195 */   // Label 7284: @412195
     /*  412195 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(412272), // Rule ID 21486 //
     /*  412200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  412203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  412211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  412214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  412217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412232 */     // MIs[0] Operand 4
     /*  412232 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412250 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  412250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  412253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412270 */     GIR_RootConstrainSelectedInstOperands,
     /*  412271 */     // GIR_Coverage, 21486,
     /*  412271 */     GIR_EraseRootFromParent_Done,
     /*  412272 */   // Label 7285: @412272
     /*  412272 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(412349), // Rule ID 21487 //
     /*  412277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  412280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  412288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  412291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  412294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412309 */     // MIs[0] Operand 4
     /*  412309 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  412327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  412330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412347 */     GIR_RootConstrainSelectedInstOperands,
     /*  412348 */     // GIR_Coverage, 21487,
     /*  412348 */     GIR_EraseRootFromParent_Done,
     /*  412349 */   // Label 7286: @412349
     /*  412349 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(412426), // Rule ID 21490 //
     /*  412354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  412357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  412365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  412368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  412371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412386 */     // MIs[0] Operand 4
     /*  412386 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412404 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  412404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  412407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412424 */     GIR_RootConstrainSelectedInstOperands,
     /*  412425 */     // GIR_Coverage, 21490,
     /*  412425 */     GIR_EraseRootFromParent_Done,
     /*  412426 */   // Label 7287: @412426
     /*  412426 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(412503), // Rule ID 21491 //
     /*  412431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  412434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  412442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  412445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  412448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412463 */     // MIs[0] Operand 4
     /*  412463 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412481 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  412481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  412484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412501 */     GIR_RootConstrainSelectedInstOperands,
     /*  412502 */     // GIR_Coverage, 21491,
     /*  412502 */     GIR_EraseRootFromParent_Done,
     /*  412503 */   // Label 7288: @412503
     /*  412503 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(412580), // Rule ID 21494 //
     /*  412508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  412511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  412519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  412522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  412525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412540 */     // MIs[0] Operand 4
     /*  412540 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412558 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  412558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  412561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412578 */     GIR_RootConstrainSelectedInstOperands,
     /*  412579 */     // GIR_Coverage, 21494,
     /*  412579 */     GIR_EraseRootFromParent_Done,
     /*  412580 */   // Label 7289: @412580
     /*  412580 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(412657), // Rule ID 21495 //
     /*  412585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  412588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  412596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  412599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  412602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412617 */     // MIs[0] Operand 4
     /*  412617 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412635 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  412635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  412638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412655 */     GIR_RootConstrainSelectedInstOperands,
     /*  412656 */     // GIR_Coverage, 21495,
     /*  412656 */     GIR_EraseRootFromParent_Done,
     /*  412657 */   // Label 7290: @412657
     /*  412657 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(412734), // Rule ID 21498 //
     /*  412662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  412665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  412673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  412676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  412679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412694 */     // MIs[0] Operand 4
     /*  412694 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412712 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  412712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  412715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412732 */     GIR_RootConstrainSelectedInstOperands,
     /*  412733 */     // GIR_Coverage, 21498,
     /*  412733 */     GIR_EraseRootFromParent_Done,
     /*  412734 */   // Label 7291: @412734
     /*  412734 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(412811), // Rule ID 21499 //
     /*  412739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  412742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  412750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  412753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  412756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412771 */     // MIs[0] Operand 4
     /*  412771 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412789 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  412789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  412792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412809 */     GIR_RootConstrainSelectedInstOperands,
     /*  412810 */     // GIR_Coverage, 21499,
     /*  412810 */     GIR_EraseRootFromParent_Done,
     /*  412811 */   // Label 7292: @412811
     /*  412811 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(412888), // Rule ID 21502 //
     /*  412816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  412819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  412827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  412830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  412833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412848 */     // MIs[0] Operand 4
     /*  412848 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412866 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  412866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  412869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412886 */     GIR_RootConstrainSelectedInstOperands,
     /*  412887 */     // GIR_Coverage, 21502,
     /*  412887 */     GIR_EraseRootFromParent_Done,
     /*  412888 */   // Label 7293: @412888
     /*  412888 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(412965), // Rule ID 21503 //
     /*  412893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  412896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  412904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  412907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  412910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412925 */     // MIs[0] Operand 4
     /*  412925 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412943 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  412943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  412946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412963 */     GIR_RootConstrainSelectedInstOperands,
     /*  412964 */     // GIR_Coverage, 21503,
     /*  412964 */     GIR_EraseRootFromParent_Done,
     /*  412965 */   // Label 7294: @412965
     /*  412965 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(413042), // Rule ID 21506 //
     /*  412970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  412973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  412981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  412984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  412987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413002 */     // MIs[0] Operand 4
     /*  413002 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  413020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  413023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413040 */     GIR_RootConstrainSelectedInstOperands,
     /*  413041 */     // GIR_Coverage, 21506,
     /*  413041 */     GIR_EraseRootFromParent_Done,
     /*  413042 */   // Label 7295: @413042
     /*  413042 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(413119), // Rule ID 21507 //
     /*  413047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  413050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  413058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  413061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  413064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413079 */     // MIs[0] Operand 4
     /*  413079 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413097 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  413097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  413100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413117 */     GIR_RootConstrainSelectedInstOperands,
     /*  413118 */     // GIR_Coverage, 21507,
     /*  413118 */     GIR_EraseRootFromParent_Done,
     /*  413119 */   // Label 7296: @413119
     /*  413119 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(413196), // Rule ID 21510 //
     /*  413124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  413127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  413135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  413138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  413141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413156 */     // MIs[0] Operand 4
     /*  413156 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413174 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  413174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  413177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413194 */     GIR_RootConstrainSelectedInstOperands,
     /*  413195 */     // GIR_Coverage, 21510,
     /*  413195 */     GIR_EraseRootFromParent_Done,
     /*  413196 */   // Label 7297: @413196
     /*  413196 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(413273), // Rule ID 21511 //
     /*  413201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  413204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  413212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  413215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  413218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413233 */     // MIs[0] Operand 4
     /*  413233 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413251 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  413251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  413254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413271 */     GIR_RootConstrainSelectedInstOperands,
     /*  413272 */     // GIR_Coverage, 21511,
     /*  413272 */     GIR_EraseRootFromParent_Done,
     /*  413273 */   // Label 7298: @413273
     /*  413273 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(413350), // Rule ID 21514 //
     /*  413278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  413281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  413289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  413292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  413295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  413310 */     // MIs[0] Operand 4
     /*  413310 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413328 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  413328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  413331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413348 */     GIR_RootConstrainSelectedInstOperands,
     /*  413349 */     // GIR_Coverage, 21514,
     /*  413349 */     GIR_EraseRootFromParent_Done,
     /*  413350 */   // Label 7299: @413350
     /*  413350 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(413427), // Rule ID 21515 //
     /*  413355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  413358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  413366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  413369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  413372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  413387 */     // MIs[0] Operand 4
     /*  413387 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413405 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  413405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  413408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413425 */     GIR_RootConstrainSelectedInstOperands,
     /*  413426 */     // GIR_Coverage, 21515,
     /*  413426 */     GIR_EraseRootFromParent_Done,
     /*  413427 */   // Label 7300: @413427
     /*  413427 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(413504), // Rule ID 21518 //
     /*  413432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  413435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  413443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  413446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  413449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413464 */     // MIs[0] Operand 4
     /*  413464 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413482 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  413482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  413485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413502 */     GIR_RootConstrainSelectedInstOperands,
     /*  413503 */     // GIR_Coverage, 21518,
     /*  413503 */     GIR_EraseRootFromParent_Done,
     /*  413504 */   // Label 7301: @413504
     /*  413504 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(413581), // Rule ID 21519 //
     /*  413509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  413512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  413520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  413523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  413526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413541 */     // MIs[0] Operand 4
     /*  413541 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413559 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  413559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  413562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413579 */     GIR_RootConstrainSelectedInstOperands,
     /*  413580 */     // GIR_Coverage, 21519,
     /*  413580 */     GIR_EraseRootFromParent_Done,
     /*  413581 */   // Label 7302: @413581
     /*  413581 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(413658), // Rule ID 21522 //
     /*  413586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  413589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  413597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  413600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  413603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413618 */     // MIs[0] Operand 4
     /*  413618 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413636 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  413636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  413639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413656 */     GIR_RootConstrainSelectedInstOperands,
     /*  413657 */     // GIR_Coverage, 21522,
     /*  413657 */     GIR_EraseRootFromParent_Done,
     /*  413658 */   // Label 7303: @413658
     /*  413658 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(413735), // Rule ID 21523 //
     /*  413663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  413666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  413674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  413677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  413680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413695 */     // MIs[0] Operand 4
     /*  413695 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413713 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  413713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  413716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413733 */     GIR_RootConstrainSelectedInstOperands,
     /*  413734 */     // GIR_Coverage, 21523,
     /*  413734 */     GIR_EraseRootFromParent_Done,
     /*  413735 */   // Label 7304: @413735
     /*  413735 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(413812), // Rule ID 21526 //
     /*  413740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  413743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  413751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  413754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  413757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413772 */     // MIs[0] Operand 4
     /*  413772 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  413790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  413793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413810 */     GIR_RootConstrainSelectedInstOperands,
     /*  413811 */     // GIR_Coverage, 21526,
     /*  413811 */     GIR_EraseRootFromParent_Done,
     /*  413812 */   // Label 7305: @413812
     /*  413812 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(413889), // Rule ID 21527 //
     /*  413817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  413820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  413828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  413831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  413834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413849 */     // MIs[0] Operand 4
     /*  413849 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413867 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  413867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  413870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413887 */     GIR_RootConstrainSelectedInstOperands,
     /*  413888 */     // GIR_Coverage, 21527,
     /*  413888 */     GIR_EraseRootFromParent_Done,
     /*  413889 */   // Label 7306: @413889
     /*  413889 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(413966), // Rule ID 21530 //
     /*  413894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  413897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  413905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  413908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  413911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  413926 */     // MIs[0] Operand 4
     /*  413926 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413944 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  413944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  413947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413964 */     GIR_RootConstrainSelectedInstOperands,
     /*  413965 */     // GIR_Coverage, 21530,
     /*  413965 */     GIR_EraseRootFromParent_Done,
     /*  413966 */   // Label 7307: @413966
     /*  413966 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(414043), // Rule ID 21531 //
     /*  413971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  413974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  413982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  413985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  413988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414003 */     // MIs[0] Operand 4
     /*  414003 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  414021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  414024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414041 */     GIR_RootConstrainSelectedInstOperands,
     /*  414042 */     // GIR_Coverage, 21531,
     /*  414042 */     GIR_EraseRootFromParent_Done,
     /*  414043 */   // Label 7308: @414043
     /*  414043 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(414120), // Rule ID 21534 //
     /*  414048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  414051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  414059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  414062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  414065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414080 */     // MIs[0] Operand 4
     /*  414080 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414098 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  414098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  414101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414118 */     GIR_RootConstrainSelectedInstOperands,
     /*  414119 */     // GIR_Coverage, 21534,
     /*  414119 */     GIR_EraseRootFromParent_Done,
     /*  414120 */   // Label 7309: @414120
     /*  414120 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(414197), // Rule ID 21535 //
     /*  414125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  414128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  414136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  414139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  414142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414157 */     // MIs[0] Operand 4
     /*  414157 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414175 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  414175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  414178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414195 */     GIR_RootConstrainSelectedInstOperands,
     /*  414196 */     // GIR_Coverage, 21535,
     /*  414196 */     GIR_EraseRootFromParent_Done,
     /*  414197 */   // Label 7310: @414197
     /*  414197 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(414274), // Rule ID 21538 //
     /*  414202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  414205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  414213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  414216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414234 */     // MIs[0] Operand 4
     /*  414234 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414252 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  414252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  414255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414272 */     GIR_RootConstrainSelectedInstOperands,
     /*  414273 */     // GIR_Coverage, 21538,
     /*  414273 */     GIR_EraseRootFromParent_Done,
     /*  414274 */   // Label 7311: @414274
     /*  414274 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(414351), // Rule ID 21539 //
     /*  414279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  414282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  414290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  414293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414311 */     // MIs[0] Operand 4
     /*  414311 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414329 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  414329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  414332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414349 */     GIR_RootConstrainSelectedInstOperands,
     /*  414350 */     // GIR_Coverage, 21539,
     /*  414350 */     GIR_EraseRootFromParent_Done,
     /*  414351 */   // Label 7312: @414351
     /*  414351 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(414428), // Rule ID 21542 //
     /*  414356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  414359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  414367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  414370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  414373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414388 */     // MIs[0] Operand 4
     /*  414388 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414406 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  414406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  414409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414426 */     GIR_RootConstrainSelectedInstOperands,
     /*  414427 */     // GIR_Coverage, 21542,
     /*  414427 */     GIR_EraseRootFromParent_Done,
     /*  414428 */   // Label 7313: @414428
     /*  414428 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(414505), // Rule ID 21543 //
     /*  414433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  414436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  414444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  414447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  414450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414465 */     // MIs[0] Operand 4
     /*  414465 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414483 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  414483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  414486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414503 */     GIR_RootConstrainSelectedInstOperands,
     /*  414504 */     // GIR_Coverage, 21543,
     /*  414504 */     GIR_EraseRootFromParent_Done,
     /*  414505 */   // Label 7314: @414505
     /*  414505 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(414582), // Rule ID 21546 //
     /*  414510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  414513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  414524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  414527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414542 */     // MIs[0] Operand 4
     /*  414542 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414560 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  414560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  414563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414580 */     GIR_RootConstrainSelectedInstOperands,
     /*  414581 */     // GIR_Coverage, 21546,
     /*  414581 */     GIR_EraseRootFromParent_Done,
     /*  414582 */   // Label 7315: @414582
     /*  414582 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(414659), // Rule ID 21547 //
     /*  414587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  414590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  414601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  414604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414619 */     // MIs[0] Operand 4
     /*  414619 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414637 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  414637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  414640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414657 */     GIR_RootConstrainSelectedInstOperands,
     /*  414658 */     // GIR_Coverage, 21547,
     /*  414658 */     GIR_EraseRootFromParent_Done,
     /*  414659 */   // Label 7316: @414659
     /*  414659 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(414736), // Rule ID 21550 //
     /*  414664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  414667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  414675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  414678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  414681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414696 */     // MIs[0] Operand 4
     /*  414696 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414714 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  414714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  414717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414734 */     GIR_RootConstrainSelectedInstOperands,
     /*  414735 */     // GIR_Coverage, 21550,
     /*  414735 */     GIR_EraseRootFromParent_Done,
     /*  414736 */   // Label 7317: @414736
     /*  414736 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(414813), // Rule ID 21551 //
     /*  414741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  414744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  414752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  414755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  414758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414773 */     // MIs[0] Operand 4
     /*  414773 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414791 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  414791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  414794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414811 */     GIR_RootConstrainSelectedInstOperands,
     /*  414812 */     // GIR_Coverage, 21551,
     /*  414812 */     GIR_EraseRootFromParent_Done,
     /*  414813 */   // Label 7318: @414813
     /*  414813 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(414890), // Rule ID 21554 //
     /*  414818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  414821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  414829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  414832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  414835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414850 */     // MIs[0] Operand 4
     /*  414850 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414868 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  414868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  414871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414888 */     GIR_RootConstrainSelectedInstOperands,
     /*  414889 */     // GIR_Coverage, 21554,
     /*  414889 */     GIR_EraseRootFromParent_Done,
     /*  414890 */   // Label 7319: @414890
     /*  414890 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(414967), // Rule ID 21555 //
     /*  414895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  414898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  414906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  414909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  414912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414927 */     // MIs[0] Operand 4
     /*  414927 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414945 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  414945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  414948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414965 */     GIR_RootConstrainSelectedInstOperands,
     /*  414966 */     // GIR_Coverage, 21555,
     /*  414966 */     GIR_EraseRootFromParent_Done,
     /*  414967 */   // Label 7320: @414967
     /*  414967 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(415044), // Rule ID 21558 //
     /*  414972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  414975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  414983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  414986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415004 */     // MIs[0] Operand 4
     /*  415004 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415022 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  415022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  415025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415042 */     GIR_RootConstrainSelectedInstOperands,
     /*  415043 */     // GIR_Coverage, 21558,
     /*  415043 */     GIR_EraseRootFromParent_Done,
     /*  415044 */   // Label 7321: @415044
     /*  415044 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(415121), // Rule ID 21559 //
     /*  415049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  415052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  415060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  415063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  415066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415081 */     // MIs[0] Operand 4
     /*  415081 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415099 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  415099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  415102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415119 */     GIR_RootConstrainSelectedInstOperands,
     /*  415120 */     // GIR_Coverage, 21559,
     /*  415120 */     GIR_EraseRootFromParent_Done,
     /*  415121 */   // Label 7322: @415121
     /*  415121 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(415198), // Rule ID 21562 //
     /*  415126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  415129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  415137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  415140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415158 */     // MIs[0] Operand 4
     /*  415158 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415176 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  415176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  415179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415196 */     GIR_RootConstrainSelectedInstOperands,
     /*  415197 */     // GIR_Coverage, 21562,
     /*  415197 */     GIR_EraseRootFromParent_Done,
     /*  415198 */   // Label 7323: @415198
     /*  415198 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(415275), // Rule ID 21563 //
     /*  415203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  415206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  415214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  415217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415235 */     // MIs[0] Operand 4
     /*  415235 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415253 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  415253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  415256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415273 */     GIR_RootConstrainSelectedInstOperands,
     /*  415274 */     // GIR_Coverage, 21563,
     /*  415274 */     GIR_EraseRootFromParent_Done,
     /*  415275 */   // Label 7324: @415275
     /*  415275 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(415352), // Rule ID 21566 //
     /*  415280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  415283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  415294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  415297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415312 */     // MIs[0] Operand 4
     /*  415312 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415330 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  415330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  415333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415350 */     GIR_RootConstrainSelectedInstOperands,
     /*  415351 */     // GIR_Coverage, 21566,
     /*  415351 */     GIR_EraseRootFromParent_Done,
     /*  415352 */   // Label 7325: @415352
     /*  415352 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(415429), // Rule ID 21567 //
     /*  415357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  415360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  415371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  415374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415389 */     // MIs[0] Operand 4
     /*  415389 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415407 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  415407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  415410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415427 */     GIR_RootConstrainSelectedInstOperands,
     /*  415428 */     // GIR_Coverage, 21567,
     /*  415428 */     GIR_EraseRootFromParent_Done,
     /*  415429 */   // Label 7326: @415429
     /*  415429 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(415506), // Rule ID 21570 //
     /*  415434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  415437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  415445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  415448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  415451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415466 */     // MIs[0] Operand 4
     /*  415466 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  415484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  415487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415504 */     GIR_RootConstrainSelectedInstOperands,
     /*  415505 */     // GIR_Coverage, 21570,
     /*  415505 */     GIR_EraseRootFromParent_Done,
     /*  415506 */   // Label 7327: @415506
     /*  415506 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(415583), // Rule ID 21571 //
     /*  415511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  415514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  415522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  415525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  415528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415543 */     // MIs[0] Operand 4
     /*  415543 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415561 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  415561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  415564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415581 */     GIR_RootConstrainSelectedInstOperands,
     /*  415582 */     // GIR_Coverage, 21571,
     /*  415582 */     GIR_EraseRootFromParent_Done,
     /*  415583 */   // Label 7328: @415583
     /*  415583 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(415660), // Rule ID 21574 //
     /*  415588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  415591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  415599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  415602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  415605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  415620 */     // MIs[0] Operand 4
     /*  415620 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415638 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  415638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  415641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415658 */     GIR_RootConstrainSelectedInstOperands,
     /*  415659 */     // GIR_Coverage, 21574,
     /*  415659 */     GIR_EraseRootFromParent_Done,
     /*  415660 */   // Label 7329: @415660
     /*  415660 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(415737), // Rule ID 21575 //
     /*  415665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  415668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  415676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  415679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  415682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  415697 */     // MIs[0] Operand 4
     /*  415697 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415715 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  415715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  415718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415735 */     GIR_RootConstrainSelectedInstOperands,
     /*  415736 */     // GIR_Coverage, 21575,
     /*  415736 */     GIR_EraseRootFromParent_Done,
     /*  415737 */   // Label 7330: @415737
     /*  415737 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(415814), // Rule ID 21578 //
     /*  415742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  415745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  415753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  415756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415774 */     // MIs[0] Operand 4
     /*  415774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415792 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  415792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  415795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415812 */     GIR_RootConstrainSelectedInstOperands,
     /*  415813 */     // GIR_Coverage, 21578,
     /*  415813 */     GIR_EraseRootFromParent_Done,
     /*  415814 */   // Label 7331: @415814
     /*  415814 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(415891), // Rule ID 21579 //
     /*  415819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  415822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  415830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  415833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415851 */     // MIs[0] Operand 4
     /*  415851 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415869 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  415869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  415872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415889 */     GIR_RootConstrainSelectedInstOperands,
     /*  415890 */     // GIR_Coverage, 21579,
     /*  415890 */     GIR_EraseRootFromParent_Done,
     /*  415891 */   // Label 7332: @415891
     /*  415891 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(415968), // Rule ID 21582 //
     /*  415896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  415899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  415910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  415913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415928 */     // MIs[0] Operand 4
     /*  415928 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  415946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  415949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415966 */     GIR_RootConstrainSelectedInstOperands,
     /*  415967 */     // GIR_Coverage, 21582,
     /*  415967 */     GIR_EraseRootFromParent_Done,
     /*  415968 */   // Label 7333: @415968
     /*  415968 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(416045), // Rule ID 21583 //
     /*  415973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  415976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  415987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  415990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416005 */     // MIs[0] Operand 4
     /*  416005 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  416016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416023 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  416023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  416026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  416030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  416043 */     GIR_RootConstrainSelectedInstOperands,
     /*  416044 */     // GIR_Coverage, 21583,
     /*  416044 */     GIR_EraseRootFromParent_Done,
     /*  416045 */   // Label 7334: @416045
     /*  416045 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(416122), // Rule ID 21586 //
     /*  416050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  416053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  416058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  416061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  416064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  416067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416082 */     // MIs[0] Operand 4
     /*  416082 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  416093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  416100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  416103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  416107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  416120 */     GIR_RootConstrainSelectedInstOperands,
     /*  416121 */     // GIR_Coverage, 21586,
     /*  416121 */     GIR_EraseRootFromParent_Done,
     /*  416122 */   // Label 7335: @416122
     /*  416122 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(416199), // Rule ID 21587 //
     /*  416127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  416130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  416135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  416138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  416141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  416144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416159 */     // MIs[0] Operand 4
     /*  416159 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  416170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  416177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  416180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  416184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  416197 */     GIR_RootConstrainSelectedInstOperands,
     /*  416198 */     // GIR_Coverage, 21587,
     /*  416198 */     GIR_EraseRootFromParent_Done,
     /*  416199 */   // Label 7336: @416199
     /*  416199 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(416276), // Rule ID 21590 //
     /*  416204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  416207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  416212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  416215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  416218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  416221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416236 */     // MIs[0] Operand 4
     /*  416236 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  416247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  416254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  416257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  416261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  416274 */     GIR_RootConstrainSelectedInstOperands,
     /*  416275 */     // GIR_Coverage, 21590,
     /*  416275 */     GIR_EraseRootFromParent_Done,
     /*  416276 */   // Label 7337: @416276
     /*  416276 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(416353), // Rule ID 21591 //
     /*  416281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  416284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  416289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  416292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  416295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  416298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416313 */     // MIs[0] Operand 4
     /*  416313 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  416324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416331 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  416331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  416334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  416338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  416351 */     GIR_RootConstrainSelectedInstOperands,
     /*  416352 */     // GIR_Coverage, 21591,
     /*  416352 */     GIR_EraseRootFromParent_Done,
     /*  416353 */   // Label 7338: @416353
     /*  416353 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(416426), // Rule ID 62819 //
     /*  416358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  416369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  416372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416382 */     // MIs[0] op1
     /*  416382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416405 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF8),
     /*  416408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416410 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416412 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416414 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416424 */     GIR_RootConstrainSelectedInstOperands,
     /*  416425 */     // GIR_Coverage, 62819,
     /*  416425 */     GIR_EraseRootFromParent_Done,
     /*  416426 */   // Label 7339: @416426
     /*  416426 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(416499), // Rule ID 62820 //
     /*  416431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  416442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  416445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416455 */     // MIs[0] op1
     /*  416455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416478 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF8),
     /*  416481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416483 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416485 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416487 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416497 */     GIR_RootConstrainSelectedInstOperands,
     /*  416498 */     // GIR_Coverage, 62820,
     /*  416498 */     GIR_EraseRootFromParent_Done,
     /*  416499 */   // Label 7340: @416499
     /*  416499 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(416572), // Rule ID 62843 //
     /*  416504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  416515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  416518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  416521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416528 */     // MIs[0] op1
     /*  416528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416551 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF8),
     /*  416554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416556 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416558 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416560 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416570 */     GIR_RootConstrainSelectedInstOperands,
     /*  416571 */     // GIR_Coverage, 62843,
     /*  416571 */     GIR_EraseRootFromParent_Done,
     /*  416572 */   // Label 7341: @416572
     /*  416572 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(416645), // Rule ID 62844 //
     /*  416577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  416588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  416591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  416594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416601 */     // MIs[0] op1
     /*  416601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416604 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416624 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF8),
     /*  416627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416629 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416631 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416633 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416643 */     GIR_RootConstrainSelectedInstOperands,
     /*  416644 */     // GIR_Coverage, 62844,
     /*  416644 */     GIR_EraseRootFromParent_Done,
     /*  416645 */   // Label 7342: @416645
     /*  416645 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(416718), // Rule ID 62869 //
     /*  416650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  416661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  416664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416674 */     // MIs[0] op1
     /*  416674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416697 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  416700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416702 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416704 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416706 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416716 */     GIR_RootConstrainSelectedInstOperands,
     /*  416717 */     // GIR_Coverage, 62869,
     /*  416717 */     GIR_EraseRootFromParent_Done,
     /*  416718 */   // Label 7343: @416718
     /*  416718 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(416791), // Rule ID 62870 //
     /*  416723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  416734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  416737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416747 */     // MIs[0] op1
     /*  416747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416770 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  416773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416775 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416777 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416779 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416789 */     GIR_RootConstrainSelectedInstOperands,
     /*  416790 */     // GIR_Coverage, 62870,
     /*  416790 */     GIR_EraseRootFromParent_Done,
     /*  416791 */   // Label 7344: @416791
     /*  416791 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(416864), // Rule ID 62881 //
     /*  416796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  416807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  416810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  416813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416820 */     // MIs[0] op1
     /*  416820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416823 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416843 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  416846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416848 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416850 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416852 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416862 */     GIR_RootConstrainSelectedInstOperands,
     /*  416863 */     // GIR_Coverage, 62881,
     /*  416863 */     GIR_EraseRootFromParent_Done,
     /*  416864 */   // Label 7345: @416864
     /*  416864 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(416937), // Rule ID 62882 //
     /*  416869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  416880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  416883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  416886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416893 */     // MIs[0] op1
     /*  416893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416896 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416916 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  416919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416921 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416923 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416925 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416935 */     GIR_RootConstrainSelectedInstOperands,
     /*  416936 */     // GIR_Coverage, 62882,
     /*  416936 */     GIR_EraseRootFromParent_Done,
     /*  416937 */   // Label 7346: @416937
     /*  416937 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(417010), // Rule ID 62913 //
     /*  416942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  416953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  416956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416966 */     // MIs[0] op1
     /*  416966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416989 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  416992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416994 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416996 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416998 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417008 */     GIR_RootConstrainSelectedInstOperands,
     /*  417009 */     // GIR_Coverage, 62913,
     /*  417009 */     GIR_EraseRootFromParent_Done,
     /*  417010 */   // Label 7347: @417010
     /*  417010 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(417083), // Rule ID 62914 //
     /*  417015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  417026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  417029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417039 */     // MIs[0] op1
     /*  417039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417062 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  417065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417067 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417069 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417071 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417081 */     GIR_RootConstrainSelectedInstOperands,
     /*  417082 */     // GIR_Coverage, 62914,
     /*  417082 */     GIR_EraseRootFromParent_Done,
     /*  417083 */   // Label 7348: @417083
     /*  417083 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(417156), // Rule ID 62925 //
     /*  417088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  417099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  417102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  417105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417112 */     // MIs[0] op1
     /*  417112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417135 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  417135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  417138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417140 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417142 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417144 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417154 */     GIR_RootConstrainSelectedInstOperands,
     /*  417155 */     // GIR_Coverage, 62925,
     /*  417155 */     GIR_EraseRootFromParent_Done,
     /*  417156 */   // Label 7349: @417156
     /*  417156 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(417229), // Rule ID 62926 //
     /*  417161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  417172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  417175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  417178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417185 */     // MIs[0] op1
     /*  417185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  417211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417213 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417215 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417217 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417227 */     GIR_RootConstrainSelectedInstOperands,
     /*  417228 */     // GIR_Coverage, 62926,
     /*  417228 */     GIR_EraseRootFromParent_Done,
     /*  417229 */   // Label 7350: @417229
     /*  417229 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(417302), // Rule ID 62957 //
     /*  417234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  417245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  417248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417258 */     // MIs[0] op1
     /*  417258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417261 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417281 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  417284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417286 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417288 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417290 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417300 */     GIR_RootConstrainSelectedInstOperands,
     /*  417301 */     // GIR_Coverage, 62957,
     /*  417301 */     GIR_EraseRootFromParent_Done,
     /*  417302 */   // Label 7351: @417302
     /*  417302 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(417375), // Rule ID 62958 //
     /*  417307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  417318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  417321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417331 */     // MIs[0] op1
     /*  417331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417354 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  417357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417359 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417361 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417363 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417373 */     GIR_RootConstrainSelectedInstOperands,
     /*  417374 */     // GIR_Coverage, 62958,
     /*  417374 */     GIR_EraseRootFromParent_Done,
     /*  417375 */   // Label 7352: @417375
     /*  417375 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(417448), // Rule ID 62969 //
     /*  417380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  417391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  417394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  417397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417404 */     // MIs[0] op1
     /*  417404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417427 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  417430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417432 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417434 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417436 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417446 */     GIR_RootConstrainSelectedInstOperands,
     /*  417447 */     // GIR_Coverage, 62969,
     /*  417447 */     GIR_EraseRootFromParent_Done,
     /*  417448 */   // Label 7353: @417448
     /*  417448 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(417521), // Rule ID 62970 //
     /*  417453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  417464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  417467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  417470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417477 */     // MIs[0] op1
     /*  417477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417500 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  417503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417505 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417507 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417509 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417519 */     GIR_RootConstrainSelectedInstOperands,
     /*  417520 */     // GIR_Coverage, 62970,
     /*  417520 */     GIR_EraseRootFromParent_Done,
     /*  417521 */   // Label 7354: @417521
     /*  417521 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(417594), // Rule ID 62993 //
     /*  417526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  417537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  417540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417550 */     // MIs[0] op1
     /*  417550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417553 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417573 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF4),
     /*  417576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417578 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417580 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417582 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417592 */     GIR_RootConstrainSelectedInstOperands,
     /*  417593 */     // GIR_Coverage, 62993,
     /*  417593 */     GIR_EraseRootFromParent_Done,
     /*  417594 */   // Label 7355: @417594
     /*  417594 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(417667), // Rule ID 62994 //
     /*  417599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  417610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  417613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417623 */     // MIs[0] op1
     /*  417623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF4),
     /*  417649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417651 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417653 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417655 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417665 */     GIR_RootConstrainSelectedInstOperands,
     /*  417666 */     // GIR_Coverage, 62994,
     /*  417666 */     GIR_EraseRootFromParent_Done,
     /*  417667 */   // Label 7356: @417667
     /*  417667 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(417740), // Rule ID 63013 //
     /*  417672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  417683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  417686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417696 */     // MIs[0] op1
     /*  417696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417699 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417719 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  417722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417724 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417726 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417728 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417738 */     GIR_RootConstrainSelectedInstOperands,
     /*  417739 */     // GIR_Coverage, 63013,
     /*  417739 */     GIR_EraseRootFromParent_Done,
     /*  417740 */   // Label 7357: @417740
     /*  417740 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(417813), // Rule ID 63014 //
     /*  417745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  417756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  417759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417769 */     // MIs[0] op1
     /*  417769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417792 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  417795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417797 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417799 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417801 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417811 */     GIR_RootConstrainSelectedInstOperands,
     /*  417812 */     // GIR_Coverage, 63014,
     /*  417812 */     GIR_EraseRootFromParent_Done,
     /*  417813 */   // Label 7358: @417813
     /*  417813 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(417886), // Rule ID 63025 //
     /*  417818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  417829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  417832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  417835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417842 */     // MIs[0] op1
     /*  417842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417845 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417865 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  417868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417870 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417872 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417874 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417884 */     GIR_RootConstrainSelectedInstOperands,
     /*  417885 */     // GIR_Coverage, 63025,
     /*  417885 */     GIR_EraseRootFromParent_Done,
     /*  417886 */   // Label 7359: @417886
     /*  417886 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(417959), // Rule ID 63026 //
     /*  417891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  417902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  417905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  417908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417915 */     // MIs[0] op1
     /*  417915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417938 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  417941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417943 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417945 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417947 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417957 */     GIR_RootConstrainSelectedInstOperands,
     /*  417958 */     // GIR_Coverage, 63026,
     /*  417958 */     GIR_EraseRootFromParent_Done,
     /*  417959 */   // Label 7360: @417959
     /*  417959 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(418032), // Rule ID 63049 //
     /*  417964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  417975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  417978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417988 */     // MIs[0] op1
     /*  417988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417991 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418011 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF2),
     /*  418014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418016 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418018 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418020 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418030 */     GIR_RootConstrainSelectedInstOperands,
     /*  418031 */     // GIR_Coverage, 63049,
     /*  418031 */     GIR_EraseRootFromParent_Done,
     /*  418032 */   // Label 7361: @418032
     /*  418032 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(418105), // Rule ID 63050 //
     /*  418037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  418048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  418051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418061 */     // MIs[0] op1
     /*  418061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418064 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418084 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF2),
     /*  418087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418089 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418091 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418093 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418103 */     GIR_RootConstrainSelectedInstOperands,
     /*  418104 */     // GIR_Coverage, 63050,
     /*  418104 */     GIR_EraseRootFromParent_Done,
     /*  418105 */   // Label 7362: @418105
     /*  418105 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(418178), // Rule ID 63069 //
     /*  418110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  418121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418134 */     // MIs[0] op1
     /*  418134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418157 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  418160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418162 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418164 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418166 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418176 */     GIR_RootConstrainSelectedInstOperands,
     /*  418177 */     // GIR_Coverage, 63069,
     /*  418177 */     GIR_EraseRootFromParent_Done,
     /*  418178 */   // Label 7363: @418178
     /*  418178 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(418251), // Rule ID 63070 //
     /*  418183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  418194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418207 */     // MIs[0] op1
     /*  418207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418230 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  418233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418235 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418237 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418239 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418249 */     GIR_RootConstrainSelectedInstOperands,
     /*  418250 */     // GIR_Coverage, 63070,
     /*  418250 */     GIR_EraseRootFromParent_Done,
     /*  418251 */   // Label 7364: @418251
     /*  418251 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(418324), // Rule ID 63081 //
     /*  418256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  418267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  418273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418280 */     // MIs[0] op1
     /*  418280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418303 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  418306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418308 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418310 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418312 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418322 */     GIR_RootConstrainSelectedInstOperands,
     /*  418323 */     // GIR_Coverage, 63081,
     /*  418323 */     GIR_EraseRootFromParent_Done,
     /*  418324 */   // Label 7365: @418324
     /*  418324 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(418397), // Rule ID 63082 //
     /*  418329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  418340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  418346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418353 */     // MIs[0] op1
     /*  418353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418376 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  418379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418381 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418383 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418385 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418395 */     GIR_RootConstrainSelectedInstOperands,
     /*  418396 */     // GIR_Coverage, 63082,
     /*  418396 */     GIR_EraseRootFromParent_Done,
     /*  418397 */   // Label 7366: @418397
     /*  418397 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(418470), // Rule ID 63105 //
     /*  418402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  418413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418426 */     // MIs[0] op1
     /*  418426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  418442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418449 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_MF2),
     /*  418452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418454 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418456 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418458 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418468 */     GIR_RootConstrainSelectedInstOperands,
     /*  418469 */     // GIR_Coverage, 63105,
     /*  418469 */     GIR_EraseRootFromParent_Done,
     /*  418470 */   // Label 7367: @418470
     /*  418470 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(418543), // Rule ID 63106 //
     /*  418475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  418486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418499 */     // MIs[0] op1
     /*  418499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  418515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418522 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_MF2),
     /*  418525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418527 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418529 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418531 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418541 */     GIR_RootConstrainSelectedInstOperands,
     /*  418542 */     // GIR_Coverage, 63106,
     /*  418542 */     GIR_EraseRootFromParent_Done,
     /*  418543 */   // Label 7368: @418543
     /*  418543 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(418616), // Rule ID 63125 //
     /*  418548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  418559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  418562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418572 */     // MIs[0] op1
     /*  418572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418595 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  418595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  418598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418600 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418602 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418604 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  418614 */     GIR_RootConstrainSelectedInstOperands,
     /*  418615 */     // GIR_Coverage, 63125,
     /*  418615 */     GIR_EraseRootFromParent_Done,
     /*  418616 */   // Label 7369: @418616
     /*  418616 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(418689), // Rule ID 63126 //
     /*  418621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  418632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  418635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418645 */     // MIs[0] op1
     /*  418645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418668 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  418668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  418671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418673 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418675 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418677 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  418687 */     GIR_RootConstrainSelectedInstOperands,
     /*  418688 */     // GIR_Coverage, 63126,
     /*  418688 */     GIR_EraseRootFromParent_Done,
     /*  418689 */   // Label 7370: @418689
     /*  418689 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(418762), // Rule ID 63137 //
     /*  418694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  418705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  418708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  418711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418718 */     // MIs[0] op1
     /*  418718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418741 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  418741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  418744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418746 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418748 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418750 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  418760 */     GIR_RootConstrainSelectedInstOperands,
     /*  418761 */     // GIR_Coverage, 63137,
     /*  418761 */     GIR_EraseRootFromParent_Done,
     /*  418762 */   // Label 7371: @418762
     /*  418762 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(418835), // Rule ID 63138 //
     /*  418767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  418778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  418781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  418784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418791 */     // MIs[0] op1
     /*  418791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418814 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  418814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  418817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418819 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418821 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418823 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  418833 */     GIR_RootConstrainSelectedInstOperands,
     /*  418834 */     // GIR_Coverage, 63138,
     /*  418834 */     GIR_EraseRootFromParent_Done,
     /*  418835 */   // Label 7372: @418835
     /*  418835 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(418908), // Rule ID 63169 //
     /*  418840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  418851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  418854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418864 */     // MIs[0] op1
     /*  418864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418867 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418887 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  418890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418892 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418894 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418896 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418906 */     GIR_RootConstrainSelectedInstOperands,
     /*  418907 */     // GIR_Coverage, 63169,
     /*  418907 */     GIR_EraseRootFromParent_Done,
     /*  418908 */   // Label 7373: @418908
     /*  418908 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(418981), // Rule ID 63170 //
     /*  418913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  418924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  418927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418937 */     // MIs[0] op1
     /*  418937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418940 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  418963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418965 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418967 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418969 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418979 */     GIR_RootConstrainSelectedInstOperands,
     /*  418980 */     // GIR_Coverage, 63170,
     /*  418980 */     GIR_EraseRootFromParent_Done,
     /*  418981 */   // Label 7374: @418981
     /*  418981 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(419054), // Rule ID 63181 //
     /*  418986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  418997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  419000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  419003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419010 */     // MIs[0] op1
     /*  419010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419013 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419033 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  419033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  419036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419038 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419040 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419042 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  419052 */     GIR_RootConstrainSelectedInstOperands,
     /*  419053 */     // GIR_Coverage, 63181,
     /*  419053 */     GIR_EraseRootFromParent_Done,
     /*  419054 */   // Label 7375: @419054
     /*  419054 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(419127), // Rule ID 63182 //
     /*  419059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  419070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  419073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  419076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419083 */     // MIs[0] op1
     /*  419083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  419106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  419109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419111 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419113 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419115 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  419125 */     GIR_RootConstrainSelectedInstOperands,
     /*  419126 */     // GIR_Coverage, 63182,
     /*  419126 */     GIR_EraseRootFromParent_Done,
     /*  419127 */   // Label 7376: @419127
     /*  419127 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(419200), // Rule ID 63205 //
     /*  419132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  419143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  419146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  419149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419156 */     // MIs[0] op1
     /*  419156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  419172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419179 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  419179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M1),
     /*  419182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419184 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419186 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419188 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  419198 */     GIR_RootConstrainSelectedInstOperands,
     /*  419199 */     // GIR_Coverage, 63205,
     /*  419199 */     GIR_EraseRootFromParent_Done,
     /*  419200 */   // Label 7377: @419200
     /*  419200 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(419273), // Rule ID 63206 //
     /*  419205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  419216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  419219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  419222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419229 */     // MIs[0] op1
     /*  419229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  419245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  419252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M1),
     /*  419255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419257 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419259 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419261 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  419271 */     GIR_RootConstrainSelectedInstOperands,
     /*  419272 */     // GIR_Coverage, 63206,
     /*  419272 */     GIR_EraseRootFromParent_Done,
     /*  419273 */   // Label 7378: @419273
     /*  419273 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(419346), // Rule ID 63225 //
     /*  419278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  419289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419302 */     // MIs[0] op1
     /*  419302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419325 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  419328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419330 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419332 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419334 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419344 */     GIR_RootConstrainSelectedInstOperands,
     /*  419345 */     // GIR_Coverage, 63225,
     /*  419345 */     GIR_EraseRootFromParent_Done,
     /*  419346 */   // Label 7379: @419346
     /*  419346 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(419419), // Rule ID 63226 //
     /*  419351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  419362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419375 */     // MIs[0] op1
     /*  419375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419398 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  419401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419403 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419405 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419407 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419417 */     GIR_RootConstrainSelectedInstOperands,
     /*  419418 */     // GIR_Coverage, 63226,
     /*  419418 */     GIR_EraseRootFromParent_Done,
     /*  419419 */   // Label 7380: @419419
     /*  419419 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(419492), // Rule ID 63237 //
     /*  419424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  419435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  419441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419448 */     // MIs[0] op1
     /*  419448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  419474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419476 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419478 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419480 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419490 */     GIR_RootConstrainSelectedInstOperands,
     /*  419491 */     // GIR_Coverage, 63237,
     /*  419491 */     GIR_EraseRootFromParent_Done,
     /*  419492 */   // Label 7381: @419492
     /*  419492 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(419565), // Rule ID 63238 //
     /*  419497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  419508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  419514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419521 */     // MIs[0] op1
     /*  419521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419544 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  419547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419549 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419551 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419553 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419563 */     GIR_RootConstrainSelectedInstOperands,
     /*  419564 */     // GIR_Coverage, 63238,
     /*  419564 */     GIR_EraseRootFromParent_Done,
     /*  419565 */   // Label 7382: @419565
     /*  419565 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(419638), // Rule ID 63261 //
     /*  419570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  419581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419594 */     // MIs[0] op1
     /*  419594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419597 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419617 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M1),
     /*  419620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419622 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419624 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419626 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419636 */     GIR_RootConstrainSelectedInstOperands,
     /*  419637 */     // GIR_Coverage, 63261,
     /*  419637 */     GIR_EraseRootFromParent_Done,
     /*  419638 */   // Label 7383: @419638
     /*  419638 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(419711), // Rule ID 63262 //
     /*  419643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  419654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419667 */     // MIs[0] op1
     /*  419667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M1),
     /*  419693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419695 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419697 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419699 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419709 */     GIR_RootConstrainSelectedInstOperands,
     /*  419710 */     // GIR_Coverage, 63262,
     /*  419710 */     GIR_EraseRootFromParent_Done,
     /*  419711 */   // Label 7384: @419711
     /*  419711 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(419784), // Rule ID 63281 //
     /*  419716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  419727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  419730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419740 */     // MIs[0] op1
     /*  419740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419763 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  419763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  419766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419768 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419770 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419772 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419782 */     GIR_RootConstrainSelectedInstOperands,
     /*  419783 */     // GIR_Coverage, 63281,
     /*  419783 */     GIR_EraseRootFromParent_Done,
     /*  419784 */   // Label 7385: @419784
     /*  419784 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(419857), // Rule ID 63282 //
     /*  419789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  419800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  419803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419813 */     // MIs[0] op1
     /*  419813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419836 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  419836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  419839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419841 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419843 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419845 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419855 */     GIR_RootConstrainSelectedInstOperands,
     /*  419856 */     // GIR_Coverage, 63282,
     /*  419856 */     GIR_EraseRootFromParent_Done,
     /*  419857 */   // Label 7386: @419857
     /*  419857 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(419930), // Rule ID 63293 //
     /*  419862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  419873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  419876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  419879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419886 */     // MIs[0] op1
     /*  419886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419909 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  419909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  419912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419914 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419916 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419918 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419928 */     GIR_RootConstrainSelectedInstOperands,
     /*  419929 */     // GIR_Coverage, 63293,
     /*  419929 */     GIR_EraseRootFromParent_Done,
     /*  419930 */   // Label 7387: @419930
     /*  419930 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(420003), // Rule ID 63294 //
     /*  419935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  419946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  419949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  419952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419959 */     // MIs[0] op1
     /*  419959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419982 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  419982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  419985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419987 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419989 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419991 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420001 */     GIR_RootConstrainSelectedInstOperands,
     /*  420002 */     // GIR_Coverage, 63294,
     /*  420002 */     GIR_EraseRootFromParent_Done,
     /*  420003 */   // Label 7388: @420003
     /*  420003 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(420076), // Rule ID 63317 //
     /*  420008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  420019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  420022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420032 */     // MIs[0] op1
     /*  420032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420055 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M1),
     /*  420058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420060 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420062 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420064 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420074 */     GIR_RootConstrainSelectedInstOperands,
     /*  420075 */     // GIR_Coverage, 63317,
     /*  420075 */     GIR_EraseRootFromParent_Done,
     /*  420076 */   // Label 7389: @420076
     /*  420076 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(420149), // Rule ID 63318 //
     /*  420081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  420092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  420095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420105 */     // MIs[0] op1
     /*  420105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420108 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420128 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M1),
     /*  420131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420133 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420135 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420137 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420147 */     GIR_RootConstrainSelectedInstOperands,
     /*  420148 */     // GIR_Coverage, 63318,
     /*  420148 */     GIR_EraseRootFromParent_Done,
     /*  420149 */   // Label 7390: @420149
     /*  420149 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(420222), // Rule ID 63337 //
     /*  420154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  420165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  420168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420178 */     // MIs[0] op1
     /*  420178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420201 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  420204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420206 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420208 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420210 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420220 */     GIR_RootConstrainSelectedInstOperands,
     /*  420221 */     // GIR_Coverage, 63337,
     /*  420221 */     GIR_EraseRootFromParent_Done,
     /*  420222 */   // Label 7391: @420222
     /*  420222 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(420295), // Rule ID 63338 //
     /*  420227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  420238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  420241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420251 */     // MIs[0] op1
     /*  420251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420254 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420274 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  420274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  420277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420279 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420281 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420283 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420293 */     GIR_RootConstrainSelectedInstOperands,
     /*  420294 */     // GIR_Coverage, 63338,
     /*  420294 */     GIR_EraseRootFromParent_Done,
     /*  420295 */   // Label 7392: @420295
     /*  420295 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(420368), // Rule ID 63349 //
     /*  420300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  420311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  420314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  420317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420324 */     // MIs[0] op1
     /*  420324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420347 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  420350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420352 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420354 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420356 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420366 */     GIR_RootConstrainSelectedInstOperands,
     /*  420367 */     // GIR_Coverage, 63349,
     /*  420367 */     GIR_EraseRootFromParent_Done,
     /*  420368 */   // Label 7393: @420368
     /*  420368 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(420441), // Rule ID 63350 //
     /*  420373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  420384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  420387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  420390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420397 */     // MIs[0] op1
     /*  420397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420400 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420420 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  420420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  420423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420425 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420427 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420429 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420439 */     GIR_RootConstrainSelectedInstOperands,
     /*  420440 */     // GIR_Coverage, 63350,
     /*  420440 */     GIR_EraseRootFromParent_Done,
     /*  420441 */   // Label 7394: @420441
     /*  420441 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(420514), // Rule ID 63381 //
     /*  420446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  420457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  420460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420470 */     // MIs[0] op1
     /*  420470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420493 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  420496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420498 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420500 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420502 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420512 */     GIR_RootConstrainSelectedInstOperands,
     /*  420513 */     // GIR_Coverage, 63381,
     /*  420513 */     GIR_EraseRootFromParent_Done,
     /*  420514 */   // Label 7395: @420514
     /*  420514 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(420587), // Rule ID 63382 //
     /*  420519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  420530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  420533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420543 */     // MIs[0] op1
     /*  420543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420566 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  420566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  420569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420571 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420573 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420575 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420585 */     GIR_RootConstrainSelectedInstOperands,
     /*  420586 */     // GIR_Coverage, 63382,
     /*  420586 */     GIR_EraseRootFromParent_Done,
     /*  420587 */   // Label 7396: @420587
     /*  420587 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(420660), // Rule ID 63393 //
     /*  420592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  420603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  420606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  420609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420616 */     // MIs[0] op1
     /*  420616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420639 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  420642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420644 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420646 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420648 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420658 */     GIR_RootConstrainSelectedInstOperands,
     /*  420659 */     // GIR_Coverage, 63393,
     /*  420659 */     GIR_EraseRootFromParent_Done,
     /*  420660 */   // Label 7397: @420660
     /*  420660 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(420733), // Rule ID 63394 //
     /*  420665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  420676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  420679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  420682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420689 */     // MIs[0] op1
     /*  420689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420712 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  420712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  420715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420717 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420719 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420721 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420731 */     GIR_RootConstrainSelectedInstOperands,
     /*  420732 */     // GIR_Coverage, 63394,
     /*  420732 */     GIR_EraseRootFromParent_Done,
     /*  420733 */   // Label 7398: @420733
     /*  420733 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(420806), // Rule ID 63425 //
     /*  420738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  420749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  420752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420762 */     // MIs[0] op1
     /*  420762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420765 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420785 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  420788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420790 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420792 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420794 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420804 */     GIR_RootConstrainSelectedInstOperands,
     /*  420805 */     // GIR_Coverage, 63425,
     /*  420805 */     GIR_EraseRootFromParent_Done,
     /*  420806 */   // Label 7399: @420806
     /*  420806 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(420879), // Rule ID 63426 //
     /*  420811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  420822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  420825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420835 */     // MIs[0] op1
     /*  420835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420858 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  420858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  420861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420863 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420865 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420867 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420877 */     GIR_RootConstrainSelectedInstOperands,
     /*  420878 */     // GIR_Coverage, 63426,
     /*  420878 */     GIR_EraseRootFromParent_Done,
     /*  420879 */   // Label 7400: @420879
     /*  420879 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(420952), // Rule ID 63437 //
     /*  420884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  420895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  420898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  420901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420908 */     // MIs[0] op1
     /*  420908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420931 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  420934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420936 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420938 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420940 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420950 */     GIR_RootConstrainSelectedInstOperands,
     /*  420951 */     // GIR_Coverage, 63437,
     /*  420951 */     GIR_EraseRootFromParent_Done,
     /*  420952 */   // Label 7401: @420952
     /*  420952 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(421025), // Rule ID 63438 //
     /*  420957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  420968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  420971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  420974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420981 */     // MIs[0] op1
     /*  420981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421004 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  421007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421009 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421011 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421013 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421023 */     GIR_RootConstrainSelectedInstOperands,
     /*  421024 */     // GIR_Coverage, 63438,
     /*  421024 */     GIR_EraseRootFromParent_Done,
     /*  421025 */   // Label 7402: @421025
     /*  421025 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(421098), // Rule ID 63469 //
     /*  421030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  421041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  421044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421054 */     // MIs[0] op1
     /*  421054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  421080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421082 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421084 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421086 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421096 */     GIR_RootConstrainSelectedInstOperands,
     /*  421097 */     // GIR_Coverage, 63469,
     /*  421097 */     GIR_EraseRootFromParent_Done,
     /*  421098 */   // Label 7403: @421098
     /*  421098 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(421171), // Rule ID 63470 //
     /*  421103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  421114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  421117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  421120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421127 */     // MIs[0] op1
     /*  421127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421150 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  421153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421155 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421157 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421159 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421169 */     GIR_RootConstrainSelectedInstOperands,
     /*  421170 */     // GIR_Coverage, 63470,
     /*  421170 */     GIR_EraseRootFromParent_Done,
     /*  421171 */   // Label 7404: @421171
     /*  421171 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(421244), // Rule ID 63481 //
     /*  421176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  421184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  421187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  421190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  421193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421200 */     // MIs[0] op1
     /*  421200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421223 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  421226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421228 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421230 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421232 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421242 */     GIR_RootConstrainSelectedInstOperands,
     /*  421243 */     // GIR_Coverage, 63481,
     /*  421243 */     GIR_EraseRootFromParent_Done,
     /*  421244 */   // Label 7405: @421244
     /*  421244 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(421317), // Rule ID 63482 //
     /*  421249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  421257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  421260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  421263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  421266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421273 */     // MIs[0] op1
     /*  421273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  421299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421301 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421303 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421305 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421315 */     GIR_RootConstrainSelectedInstOperands,
     /*  421316 */     // GIR_Coverage, 63482,
     /*  421316 */     GIR_EraseRootFromParent_Done,
     /*  421317 */   // Label 7406: @421317
     /*  421317 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(421390), // Rule ID 63505 //
     /*  421322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  421333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  421336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  421339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421346 */     // MIs[0] op1
     /*  421346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421349 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  421362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M2),
     /*  421372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421374 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421376 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421378 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421388 */     GIR_RootConstrainSelectedInstOperands,
     /*  421389 */     // GIR_Coverage, 63505,
     /*  421389 */     GIR_EraseRootFromParent_Done,
     /*  421390 */   // Label 7407: @421390
     /*  421390 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(421463), // Rule ID 63506 //
     /*  421395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  421406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  421409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  421412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421419 */     // MIs[0] op1
     /*  421419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421422 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  421435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M2),
     /*  421445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421447 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421449 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421451 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421461 */     GIR_RootConstrainSelectedInstOperands,
     /*  421462 */     // GIR_Coverage, 63506,
     /*  421462 */     GIR_EraseRootFromParent_Done,
     /*  421463 */   // Label 7408: @421463
     /*  421463 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(421536), // Rule ID 63525 //
     /*  421468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  421479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  421482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421492 */     // MIs[0] op1
     /*  421492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421495 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421515 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  421518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421520 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421522 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421524 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421534 */     GIR_RootConstrainSelectedInstOperands,
     /*  421535 */     // GIR_Coverage, 63525,
     /*  421535 */     GIR_EraseRootFromParent_Done,
     /*  421536 */   // Label 7409: @421536
     /*  421536 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(421609), // Rule ID 63526 //
     /*  421541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  421552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  421555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  421558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421565 */     // MIs[0] op1
     /*  421565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421568 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421588 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  421591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421593 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421595 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421597 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421607 */     GIR_RootConstrainSelectedInstOperands,
     /*  421608 */     // GIR_Coverage, 63526,
     /*  421608 */     GIR_EraseRootFromParent_Done,
     /*  421609 */   // Label 7410: @421609
     /*  421609 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(421682), // Rule ID 63537 //
     /*  421614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  421622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  421625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  421628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  421631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421638 */     // MIs[0] op1
     /*  421638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421641 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421661 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  421664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421666 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421668 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421670 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421680 */     GIR_RootConstrainSelectedInstOperands,
     /*  421681 */     // GIR_Coverage, 63537,
     /*  421681 */     GIR_EraseRootFromParent_Done,
     /*  421682 */   // Label 7411: @421682
     /*  421682 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(421755), // Rule ID 63538 //
     /*  421687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  421695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  421698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  421701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  421704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421711 */     // MIs[0] op1
     /*  421711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421734 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  421737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421739 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421741 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421743 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421753 */     GIR_RootConstrainSelectedInstOperands,
     /*  421754 */     // GIR_Coverage, 63538,
     /*  421754 */     GIR_EraseRootFromParent_Done,
     /*  421755 */   // Label 7412: @421755
     /*  421755 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(421828), // Rule ID 63561 //
     /*  421760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  421771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  421774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  421777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421784 */     // MIs[0] op1
     /*  421784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  421800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421807 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M4),
     /*  421810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421812 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421814 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421816 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421826 */     GIR_RootConstrainSelectedInstOperands,
     /*  421827 */     // GIR_Coverage, 63561,
     /*  421827 */     GIR_EraseRootFromParent_Done,
     /*  421828 */   // Label 7413: @421828
     /*  421828 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(421901), // Rule ID 63562 //
     /*  421833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  421844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  421847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  421850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421857 */     // MIs[0] op1
     /*  421857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  421873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421880 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M4),
     /*  421883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421885 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421887 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421889 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421899 */     GIR_RootConstrainSelectedInstOperands,
     /*  421900 */     // GIR_Coverage, 63562,
     /*  421900 */     GIR_EraseRootFromParent_Done,
     /*  421901 */   // Label 7414: @421901
     /*  421901 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(421974), // Rule ID 63581 //
     /*  421906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  421917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  421920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421930 */     // MIs[0] op1
     /*  421930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421953 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  421956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421958 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421960 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421962 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421972 */     GIR_RootConstrainSelectedInstOperands,
     /*  421973 */     // GIR_Coverage, 63581,
     /*  421973 */     GIR_EraseRootFromParent_Done,
     /*  421974 */   // Label 7415: @421974
     /*  421974 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(422047), // Rule ID 63582 //
     /*  421979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  421990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  421993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  421996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422003 */     // MIs[0] op1
     /*  422003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  422019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422026 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  422029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422031 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422033 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422035 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422045 */     GIR_RootConstrainSelectedInstOperands,
     /*  422046 */     // GIR_Coverage, 63582,
     /*  422046 */     GIR_EraseRootFromParent_Done,
     /*  422047 */   // Label 7416: @422047
     /*  422047 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(422120), // Rule ID 63593 //
     /*  422052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  422060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  422063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  422066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  422069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422076 */     // MIs[0] op1
     /*  422076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422079 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422099 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  422099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  422102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422104 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422106 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422108 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422118 */     GIR_RootConstrainSelectedInstOperands,
     /*  422119 */     // GIR_Coverage, 63593,
     /*  422119 */     GIR_EraseRootFromParent_Done,
     /*  422120 */   // Label 7417: @422120
     /*  422120 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(422193), // Rule ID 63594 //
     /*  422125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  422128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  422133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  422136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  422139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  422142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422149 */     // MIs[0] op1
     /*  422149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422152 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422172 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  422175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422177 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422179 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422181 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422191 */     GIR_RootConstrainSelectedInstOperands,
     /*  422192 */     // GIR_Coverage, 63594,
     /*  422192 */     GIR_EraseRootFromParent_Done,
     /*  422193 */   // Label 7418: @422193
     /*  422193 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(422266), // Rule ID 63617 //
     /*  422198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  422206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  422209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  422212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  422215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422222 */     // MIs[0] op1
     /*  422222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  422230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  422238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422245 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  422245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M8),
     /*  422248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422250 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422252 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422254 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422264 */     GIR_RootConstrainSelectedInstOperands,
     /*  422265 */     // GIR_Coverage, 63617,
     /*  422265 */     GIR_EraseRootFromParent_Done,
     /*  422266 */   // Label 7419: @422266
     /*  422266 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(422339), // Rule ID 63618 //
     /*  422271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  422274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  422279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  422282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  422285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  422288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422295 */     // MIs[0] op1
     /*  422295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  422303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  422311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422318 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M8),
     /*  422321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422323 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422325 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422327 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422337 */     GIR_RootConstrainSelectedInstOperands,
     /*  422338 */     // GIR_Coverage, 63618,
     /*  422338 */     GIR_EraseRootFromParent_Done,
     /*  422339 */   // Label 7420: @422339
     /*  422339 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(422412), // Rule ID 63637 //
     /*  422344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  422352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  422355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  422358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  422361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422368 */     // MIs[0] op1
     /*  422368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422371 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  422384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422391 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  422394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422396 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422398 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422400 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422410 */     GIR_RootConstrainSelectedInstOperands,
     /*  422411 */     // GIR_Coverage, 63637,
     /*  422411 */     GIR_EraseRootFromParent_Done,
     /*  422412 */   // Label 7421: @422412
     /*  422412 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(422485), // Rule ID 63638 //
     /*  422417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  422420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  422425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  422428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  422431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  422434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422441 */     // MIs[0] op1
     /*  422441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  422457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  422467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422469 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422471 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422473 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422483 */     GIR_RootConstrainSelectedInstOperands,
     /*  422484 */     // GIR_Coverage, 63638,
     /*  422484 */     GIR_EraseRootFromParent_Done,
     /*  422485 */   // Label 7422: @422485
     /*  422485 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(422558), // Rule ID 63649 //
     /*  422490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  422498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  422501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  422504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  422507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422514 */     // MIs[0] op1
     /*  422514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422537 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  422540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422542 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422544 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422546 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422556 */     GIR_RootConstrainSelectedInstOperands,
     /*  422557 */     // GIR_Coverage, 63649,
     /*  422557 */     GIR_EraseRootFromParent_Done,
     /*  422558 */   // Label 7423: @422558
     /*  422558 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(422631), // Rule ID 63650 //
     /*  422563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  422566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  422571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  422574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  422577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  422580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422587 */     // MIs[0] op1
     /*  422587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422590 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  422613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422615 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422617 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422619 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422629 */     GIR_RootConstrainSelectedInstOperands,
     /*  422630 */     // GIR_Coverage, 63650,
     /*  422630 */     GIR_EraseRootFromParent_Done,
     /*  422631 */   // Label 7424: @422631
     /*  422631 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(422704), // Rule ID 63673 //
     /*  422636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  422644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  422647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  422650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  422653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422660 */     // MIs[0] op1
     /*  422660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  422668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  422676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422683 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M2),
     /*  422686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422688 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422690 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422692 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422702 */     GIR_RootConstrainSelectedInstOperands,
     /*  422703 */     // GIR_Coverage, 63673,
     /*  422703 */     GIR_EraseRootFromParent_Done,
     /*  422704 */   // Label 7425: @422704
     /*  422704 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(422777), // Rule ID 63674 //
     /*  422709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  422712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  422717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  422720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  422723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  422726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422733 */     // MIs[0] op1
     /*  422733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  422741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  422749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M2),
     /*  422759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422761 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422763 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422765 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422775 */     GIR_RootConstrainSelectedInstOperands,
     /*  422776 */     // GIR_Coverage, 63674,
     /*  422776 */     GIR_EraseRootFromParent_Done,
     /*  422777 */   // Label 7426: @422777
     /*  422777 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(422850), // Rule ID 63693 //
     /*  422782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  422790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  422793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  422796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  422799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422806 */     // MIs[0] op1
     /*  422806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  422822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422829 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  422832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422834 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422836 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422838 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422848 */     GIR_RootConstrainSelectedInstOperands,
     /*  422849 */     // GIR_Coverage, 63693,
     /*  422849 */     GIR_EraseRootFromParent_Done,
     /*  422850 */   // Label 7427: @422850
     /*  422850 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(422923), // Rule ID 63694 //
     /*  422855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  422858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  422863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  422866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  422869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  422872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422879 */     // MIs[0] op1
     /*  422879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  422895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  422905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422907 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422909 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422911 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422921 */     GIR_RootConstrainSelectedInstOperands,
     /*  422922 */     // GIR_Coverage, 63694,
     /*  422922 */     GIR_EraseRootFromParent_Done,
     /*  422923 */   // Label 7428: @422923
     /*  422923 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(422996), // Rule ID 63705 //
     /*  422928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  422936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  422939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  422942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  422945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422952 */     // MIs[0] op1
     /*  422952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422975 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  422978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422980 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422982 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422984 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422994 */     GIR_RootConstrainSelectedInstOperands,
     /*  422995 */     // GIR_Coverage, 63705,
     /*  422995 */     GIR_EraseRootFromParent_Done,
     /*  422996 */   // Label 7429: @422996
     /*  422996 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(423069), // Rule ID 63706 //
     /*  423001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  423009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  423012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  423015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  423018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423025 */     // MIs[0] op1
     /*  423025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423048 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  423051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423053 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423055 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423057 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423067 */     GIR_RootConstrainSelectedInstOperands,
     /*  423068 */     // GIR_Coverage, 63706,
     /*  423068 */     GIR_EraseRootFromParent_Done,
     /*  423069 */   // Label 7430: @423069
     /*  423069 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(423142), // Rule ID 63729 //
     /*  423074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  423082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  423085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  423088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  423091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423098 */     // MIs[0] op1
     /*  423098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  423106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  423114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  423121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M4),
     /*  423124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423126 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423128 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423130 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423140 */     GIR_RootConstrainSelectedInstOperands,
     /*  423141 */     // GIR_Coverage, 63729,
     /*  423141 */     GIR_EraseRootFromParent_Done,
     /*  423142 */   // Label 7431: @423142
     /*  423142 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(423215), // Rule ID 63730 //
     /*  423147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  423155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  423158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  423161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  423164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423171 */     // MIs[0] op1
     /*  423171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  423179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  423187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423194 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M4),
     /*  423197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423199 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423201 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423203 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423213 */     GIR_RootConstrainSelectedInstOperands,
     /*  423214 */     // GIR_Coverage, 63730,
     /*  423214 */     GIR_EraseRootFromParent_Done,
     /*  423215 */   // Label 7432: @423215
     /*  423215 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(423288), // Rule ID 63749 //
     /*  423220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  423228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  423237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423244 */     // MIs[0] op1
     /*  423244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423247 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  423260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423267 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  423267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  423270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423272 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423274 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423276 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423286 */     GIR_RootConstrainSelectedInstOperands,
     /*  423287 */     // GIR_Coverage, 63749,
     /*  423287 */     GIR_EraseRootFromParent_Done,
     /*  423288 */   // Label 7433: @423288
     /*  423288 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(423361), // Rule ID 63750 //
     /*  423293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  423301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  423310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423317 */     // MIs[0] op1
     /*  423317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423320 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  423333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423340 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  423343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423345 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423347 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423349 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423359 */     GIR_RootConstrainSelectedInstOperands,
     /*  423360 */     // GIR_Coverage, 63750,
     /*  423360 */     GIR_EraseRootFromParent_Done,
     /*  423361 */   // Label 7434: @423361
     /*  423361 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(423434), // Rule ID 63761 //
     /*  423366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  423374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  423383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423390 */     // MIs[0] op1
     /*  423390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423413 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  423413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  423416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423418 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423420 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423422 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423432 */     GIR_RootConstrainSelectedInstOperands,
     /*  423433 */     // GIR_Coverage, 63761,
     /*  423433 */     GIR_EraseRootFromParent_Done,
     /*  423434 */   // Label 7435: @423434
     /*  423434 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(423507), // Rule ID 63762 //
     /*  423439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  423447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  423456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423463 */     // MIs[0] op1
     /*  423463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423466 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  423489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423491 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423493 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423495 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423505 */     GIR_RootConstrainSelectedInstOperands,
     /*  423506 */     // GIR_Coverage, 63762,
     /*  423506 */     GIR_EraseRootFromParent_Done,
     /*  423507 */   // Label 7436: @423507
     /*  423507 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(423580), // Rule ID 63785 //
     /*  423512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  423520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  423529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423536 */     // MIs[0] op1
     /*  423536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  423544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  423552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423559 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  423559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M8),
     /*  423562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423564 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423566 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423568 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423578 */     GIR_RootConstrainSelectedInstOperands,
     /*  423579 */     // GIR_Coverage, 63785,
     /*  423579 */     GIR_EraseRootFromParent_Done,
     /*  423580 */   // Label 7437: @423580
     /*  423580 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(423653), // Rule ID 63786 //
     /*  423585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  423593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  423602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423609 */     // MIs[0] op1
     /*  423609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  423617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  423625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M8),
     /*  423635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423637 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423639 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423641 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423651 */     GIR_RootConstrainSelectedInstOperands,
     /*  423652 */     // GIR_Coverage, 63786,
     /*  423652 */     GIR_EraseRootFromParent_Done,
     /*  423653 */   // Label 7438: @423653
     /*  423653 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(423726), // Rule ID 63805 //
     /*  423658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  423666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  423669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  423672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  423675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423682 */     // MIs[0] op1
     /*  423682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  423698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423705 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  423705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  423708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423710 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423712 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423714 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423724 */     GIR_RootConstrainSelectedInstOperands,
     /*  423725 */     // GIR_Coverage, 63805,
     /*  423725 */     GIR_EraseRootFromParent_Done,
     /*  423726 */   // Label 7439: @423726
     /*  423726 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(423799), // Rule ID 63806 //
     /*  423731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  423739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  423742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  423745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  423748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423755 */     // MIs[0] op1
     /*  423755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423758 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  423771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  423778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  423781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423783 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423785 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423787 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423797 */     GIR_RootConstrainSelectedInstOperands,
     /*  423798 */     // GIR_Coverage, 63806,
     /*  423798 */     GIR_EraseRootFromParent_Done,
     /*  423799 */   // Label 7440: @423799
     /*  423799 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(423872), // Rule ID 63817 //
     /*  423804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  423812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  423815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  423818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  423821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423828 */     // MIs[0] op1
     /*  423828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423831 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423851 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  423851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  423854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423856 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423858 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423860 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423870 */     GIR_RootConstrainSelectedInstOperands,
     /*  423871 */     // GIR_Coverage, 63817,
     /*  423871 */     GIR_EraseRootFromParent_Done,
     /*  423872 */   // Label 7441: @423872
     /*  423872 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(423945), // Rule ID 63818 //
     /*  423877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  423885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  423888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  423891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  423894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423901 */     // MIs[0] op1
     /*  423901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  423924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  423927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423929 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423931 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423933 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423943 */     GIR_RootConstrainSelectedInstOperands,
     /*  423944 */     // GIR_Coverage, 63818,
     /*  423944 */     GIR_EraseRootFromParent_Done,
     /*  423945 */   // Label 7442: @423945
     /*  423945 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(424018), // Rule ID 63841 //
     /*  423950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  423958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  423961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  423964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  423967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423974 */     // MIs[0] op1
     /*  423974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  423982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  423990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423997 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  423997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M2),
     /*  424000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424002 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424004 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424006 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424016 */     GIR_RootConstrainSelectedInstOperands,
     /*  424017 */     // GIR_Coverage, 63841,
     /*  424017 */     GIR_EraseRootFromParent_Done,
     /*  424018 */   // Label 7443: @424018
     /*  424018 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(424091), // Rule ID 63842 //
     /*  424023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  424031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  424034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  424037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424047 */     // MIs[0] op1
     /*  424047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  424055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  424063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424070 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M2),
     /*  424073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424075 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424077 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424079 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424089 */     GIR_RootConstrainSelectedInstOperands,
     /*  424090 */     // GIR_Coverage, 63842,
     /*  424090 */     GIR_EraseRootFromParent_Done,
     /*  424091 */   // Label 7444: @424091
     /*  424091 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(424164), // Rule ID 63861 //
     /*  424096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  424099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  424104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  424107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  424110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424120 */     // MIs[0] op1
     /*  424120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  424136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424143 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  424146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424148 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424150 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424152 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424162 */     GIR_RootConstrainSelectedInstOperands,
     /*  424163 */     // GIR_Coverage, 63861,
     /*  424163 */     GIR_EraseRootFromParent_Done,
     /*  424164 */   // Label 7445: @424164
     /*  424164 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(424237), // Rule ID 63862 //
     /*  424169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  424177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  424180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  424183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  424186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424193 */     // MIs[0] op1
     /*  424193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  424209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424216 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  424219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424221 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424223 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424225 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424235 */     GIR_RootConstrainSelectedInstOperands,
     /*  424236 */     // GIR_Coverage, 63862,
     /*  424236 */     GIR_EraseRootFromParent_Done,
     /*  424237 */   // Label 7446: @424237
     /*  424237 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(424310), // Rule ID 63873 //
     /*  424242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  424245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  424250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  424253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  424256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  424259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424266 */     // MIs[0] op1
     /*  424266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424289 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  424292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424294 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424296 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424298 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424308 */     GIR_RootConstrainSelectedInstOperands,
     /*  424309 */     // GIR_Coverage, 63873,
     /*  424309 */     GIR_EraseRootFromParent_Done,
     /*  424310 */   // Label 7447: @424310
     /*  424310 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(424383), // Rule ID 63874 //
     /*  424315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  424323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  424326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  424329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  424332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424339 */     // MIs[0] op1
     /*  424339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424362 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  424365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424367 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424369 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424371 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424381 */     GIR_RootConstrainSelectedInstOperands,
     /*  424382 */     // GIR_Coverage, 63874,
     /*  424382 */     GIR_EraseRootFromParent_Done,
     /*  424383 */   // Label 7448: @424383
     /*  424383 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(424456), // Rule ID 63897 //
     /*  424388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  424391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  424396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  424399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  424402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424412 */     // MIs[0] op1
     /*  424412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  424420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  424428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424435 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M4),
     /*  424438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424440 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424442 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424444 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424454 */     GIR_RootConstrainSelectedInstOperands,
     /*  424455 */     // GIR_Coverage, 63897,
     /*  424455 */     GIR_EraseRootFromParent_Done,
     /*  424456 */   // Label 7449: @424456
     /*  424456 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(424529), // Rule ID 63898 //
     /*  424461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  424469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  424472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  424475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424485 */     // MIs[0] op1
     /*  424485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  424493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  424501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424508 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M4),
     /*  424511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424513 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424515 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424517 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424527 */     GIR_RootConstrainSelectedInstOperands,
     /*  424528 */     // GIR_Coverage, 63898,
     /*  424528 */     GIR_EraseRootFromParent_Done,
     /*  424529 */   // Label 7450: @424529
     /*  424529 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(424602), // Rule ID 63917 //
     /*  424534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  424537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  424542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424558 */     // MIs[0] op1
     /*  424558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  424574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424581 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11060:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  424584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424586 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424588 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424590 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424600 */     GIR_RootConstrainSelectedInstOperands,
     /*  424601 */     // GIR_Coverage, 63917,
     /*  424601 */     GIR_EraseRootFromParent_Done,
     /*  424602 */   // Label 7451: @424602
     /*  424602 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(424675), // Rule ID 63918 //
     /*  424607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  424615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  424624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424631 */     // MIs[0] op1
     /*  424631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  424647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424654 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  424657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424659 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424661 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424663 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424673 */     GIR_RootConstrainSelectedInstOperands,
     /*  424674 */     // GIR_Coverage, 63918,
     /*  424674 */     GIR_EraseRootFromParent_Done,
     /*  424675 */   // Label 7452: @424675
     /*  424675 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(424748), // Rule ID 63929 //
     /*  424680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  424683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  424688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  424697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424704 */     // MIs[0] op1
     /*  424704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424727 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11052:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  424730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424732 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424734 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424736 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424746 */     GIR_RootConstrainSelectedInstOperands,
     /*  424747 */     // GIR_Coverage, 63929,
     /*  424747 */     GIR_EraseRootFromParent_Done,
     /*  424748 */   // Label 7453: @424748
     /*  424748 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(424821), // Rule ID 63930 //
     /*  424753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  424761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  424770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424777 */     // MIs[0] op1
     /*  424777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424800 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11052:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  424803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424805 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424807 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424809 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424819 */     GIR_RootConstrainSelectedInstOperands,
     /*  424820 */     // GIR_Coverage, 63930,
     /*  424820 */     GIR_EraseRootFromParent_Done,
     /*  424821 */   // Label 7454: @424821
     /*  424821 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(424894), // Rule ID 63953 //
     /*  424826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  424829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  424834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424850 */     // MIs[0] op1
     /*  424850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424853 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  424858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  424866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424873 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11038:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M8),
     /*  424876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424878 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424880 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424882 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424892 */     GIR_RootConstrainSelectedInstOperands,
     /*  424893 */     // GIR_Coverage, 63953,
     /*  424893 */     GIR_EraseRootFromParent_Done,
     /*  424894 */   // Label 7455: @424894
     /*  424894 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(424967), // Rule ID 63954 //
     /*  424899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  424907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424923 */     // MIs[0] op1
     /*  424923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  424931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  424939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M8),
     /*  424949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424951 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424953 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424955 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424965 */     GIR_RootConstrainSelectedInstOperands,
     /*  424966 */     // GIR_Coverage, 63954,
     /*  424966 */     GIR_EraseRootFromParent_Done,
     /*  424967 */   // Label 7456: @424967
     /*  424967 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(425050), // Rule ID 5326 //
     /*  424972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  424975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  424983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  424986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  424992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425015 */     // MIs[1] Operand 1
     /*  425015 */     // No operand predicates
     /*  425015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425028 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  425028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  425031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425038 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425048 */     GIR_RootConstrainSelectedInstOperands,
     /*  425049 */     // GIR_Coverage, 5326,
     /*  425049 */     GIR_EraseRootFromParent_Done,
     /*  425050 */   // Label 7457: @425050
     /*  425050 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(425133), // Rule ID 5327 //
     /*  425055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  425058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  425066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  425069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  425075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425098 */     // MIs[1] Operand 1
     /*  425098 */     // No operand predicates
     /*  425098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425111 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  425111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  425114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425131 */     GIR_RootConstrainSelectedInstOperands,
     /*  425132 */     // GIR_Coverage, 5327,
     /*  425132 */     GIR_EraseRootFromParent_Done,
     /*  425133 */   // Label 7458: @425133
     /*  425133 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(425216), // Rule ID 5328 //
     /*  425138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  425149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  425152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  425158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425181 */     // MIs[1] Operand 1
     /*  425181 */     // No operand predicates
     /*  425181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425194 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  425194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  425197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425204 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425214 */     GIR_RootConstrainSelectedInstOperands,
     /*  425215 */     // GIR_Coverage, 5328,
     /*  425215 */     GIR_EraseRootFromParent_Done,
     /*  425216 */   // Label 7459: @425216
     /*  425216 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(425299), // Rule ID 5329 //
     /*  425221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  425224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  425232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  425235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  425241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425264 */     // MIs[1] Operand 1
     /*  425264 */     // No operand predicates
     /*  425264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425277 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  425277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  425280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425297 */     GIR_RootConstrainSelectedInstOperands,
     /*  425298 */     // GIR_Coverage, 5329,
     /*  425298 */     GIR_EraseRootFromParent_Done,
     /*  425299 */   // Label 7460: @425299
     /*  425299 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(425382), // Rule ID 5330 //
     /*  425304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  425315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  425318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  425324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425347 */     // MIs[1] Operand 1
     /*  425347 */     // No operand predicates
     /*  425347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425360 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  425360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  425363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425370 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425380 */     GIR_RootConstrainSelectedInstOperands,
     /*  425381 */     // GIR_Coverage, 5330,
     /*  425381 */     GIR_EraseRootFromParent_Done,
     /*  425382 */   // Label 7461: @425382
     /*  425382 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(425465), // Rule ID 5331 //
     /*  425387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  425390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  425398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  425401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  425407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425430 */     // MIs[1] Operand 1
     /*  425430 */     // No operand predicates
     /*  425430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425443 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  425443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  425446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425463 */     GIR_RootConstrainSelectedInstOperands,
     /*  425464 */     // GIR_Coverage, 5331,
     /*  425464 */     GIR_EraseRootFromParent_Done,
     /*  425465 */   // Label 7462: @425465
     /*  425465 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(425548), // Rule ID 5332 //
     /*  425470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  425481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  425484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  425490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425513 */     // MIs[1] Operand 1
     /*  425513 */     // No operand predicates
     /*  425513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425526 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  425526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  425529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  425546 */     GIR_RootConstrainSelectedInstOperands,
     /*  425547 */     // GIR_Coverage, 5332,
     /*  425547 */     GIR_EraseRootFromParent_Done,
     /*  425548 */   // Label 7463: @425548
     /*  425548 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(425631), // Rule ID 5333 //
     /*  425553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  425556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  425564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  425567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  425573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425596 */     // MIs[1] Operand 1
     /*  425596 */     // No operand predicates
     /*  425596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425609 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  425609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  425612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  425629 */     GIR_RootConstrainSelectedInstOperands,
     /*  425630 */     // GIR_Coverage, 5333,
     /*  425630 */     GIR_EraseRootFromParent_Done,
     /*  425631 */   // Label 7464: @425631
     /*  425631 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(425714), // Rule ID 5334 //
     /*  425636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  425647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  425650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  425656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425679 */     // MIs[1] Operand 1
     /*  425679 */     // No operand predicates
     /*  425679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425692 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  425692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  425695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425702 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  425712 */     GIR_RootConstrainSelectedInstOperands,
     /*  425713 */     // GIR_Coverage, 5334,
     /*  425713 */     GIR_EraseRootFromParent_Done,
     /*  425714 */   // Label 7465: @425714
     /*  425714 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(425797), // Rule ID 5335 //
     /*  425719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  425722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  425730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  425733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  425739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425762 */     // MIs[1] Operand 1
     /*  425762 */     // No operand predicates
     /*  425762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425775 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  425775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  425778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  425795 */     GIR_RootConstrainSelectedInstOperands,
     /*  425796 */     // GIR_Coverage, 5335,
     /*  425796 */     GIR_EraseRootFromParent_Done,
     /*  425797 */   // Label 7466: @425797
     /*  425797 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(425880), // Rule ID 5336 //
     /*  425802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  425813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  425822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425845 */     // MIs[1] Operand 1
     /*  425845 */     // No operand predicates
     /*  425845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425858 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  425858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  425861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425878 */     GIR_RootConstrainSelectedInstOperands,
     /*  425879 */     // GIR_Coverage, 5336,
     /*  425879 */     GIR_EraseRootFromParent_Done,
     /*  425880 */   // Label 7467: @425880
     /*  425880 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(425963), // Rule ID 5337 //
     /*  425885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  425888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  425896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  425905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425928 */     // MIs[1] Operand 1
     /*  425928 */     // No operand predicates
     /*  425928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425941 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  425941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  425944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425961 */     GIR_RootConstrainSelectedInstOperands,
     /*  425962 */     // GIR_Coverage, 5337,
     /*  425962 */     GIR_EraseRootFromParent_Done,
     /*  425963 */   // Label 7468: @425963
     /*  425963 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(426046), // Rule ID 5338 //
     /*  425968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  425979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  425982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  425988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426011 */     // MIs[1] Operand 1
     /*  426011 */     // No operand predicates
     /*  426011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426024 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  426024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426034 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426044 */     GIR_RootConstrainSelectedInstOperands,
     /*  426045 */     // GIR_Coverage, 5338,
     /*  426045 */     GIR_EraseRootFromParent_Done,
     /*  426046 */   // Label 7469: @426046
     /*  426046 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(426129), // Rule ID 5339 //
     /*  426051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  426062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  426065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  426068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  426071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426094 */     // MIs[1] Operand 1
     /*  426094 */     // No operand predicates
     /*  426094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426107 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  426107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426117 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426127 */     GIR_RootConstrainSelectedInstOperands,
     /*  426128 */     // GIR_Coverage, 5339,
     /*  426128 */     GIR_EraseRootFromParent_Done,
     /*  426129 */   // Label 7470: @426129
     /*  426129 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(426212), // Rule ID 5340 //
     /*  426134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  426145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  426148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  426151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  426154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426177 */     // MIs[1] Operand 1
     /*  426177 */     // No operand predicates
     /*  426177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426190 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  426190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426200 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426210 */     GIR_RootConstrainSelectedInstOperands,
     /*  426211 */     // GIR_Coverage, 5340,
     /*  426211 */     GIR_EraseRootFromParent_Done,
     /*  426212 */   // Label 7471: @426212
     /*  426212 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(426295), // Rule ID 5341 //
     /*  426217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  426228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  426231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  426234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  426237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426260 */     // MIs[1] Operand 1
     /*  426260 */     // No operand predicates
     /*  426260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426273 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  426273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426293 */     GIR_RootConstrainSelectedInstOperands,
     /*  426294 */     // GIR_Coverage, 5341,
     /*  426294 */     GIR_EraseRootFromParent_Done,
     /*  426295 */   // Label 7472: @426295
     /*  426295 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(426378), // Rule ID 5342 //
     /*  426300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  426311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  426314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  426317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  426320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426343 */     // MIs[1] Operand 1
     /*  426343 */     // No operand predicates
     /*  426343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426356 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  426356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426376 */     GIR_RootConstrainSelectedInstOperands,
     /*  426377 */     // GIR_Coverage, 5342,
     /*  426377 */     GIR_EraseRootFromParent_Done,
     /*  426378 */   // Label 7473: @426378
     /*  426378 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(426461), // Rule ID 5343 //
     /*  426383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  426394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  426397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  426400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  426403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426426 */     // MIs[1] Operand 1
     /*  426426 */     // No operand predicates
     /*  426426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426439 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  426439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426459 */     GIR_RootConstrainSelectedInstOperands,
     /*  426460 */     // GIR_Coverage, 5343,
     /*  426460 */     GIR_EraseRootFromParent_Done,
     /*  426461 */   // Label 7474: @426461
     /*  426461 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(426544), // Rule ID 5344 //
     /*  426466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  426469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  426477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  426480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  426483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  426486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426509 */     // MIs[1] Operand 1
     /*  426509 */     // No operand predicates
     /*  426509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426522 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  426522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  426542 */     GIR_RootConstrainSelectedInstOperands,
     /*  426543 */     // GIR_Coverage, 5344,
     /*  426543 */     GIR_EraseRootFromParent_Done,
     /*  426544 */   // Label 7475: @426544
     /*  426544 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(426627), // Rule ID 5345 //
     /*  426549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  426552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  426560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  426563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  426566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  426569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426592 */     // MIs[1] Operand 1
     /*  426592 */     // No operand predicates
     /*  426592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426605 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  426605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  426625 */     GIR_RootConstrainSelectedInstOperands,
     /*  426626 */     // GIR_Coverage, 5345,
     /*  426626 */     GIR_EraseRootFromParent_Done,
     /*  426627 */   // Label 7476: @426627
     /*  426627 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(426710), // Rule ID 5346 //
     /*  426632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  426643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  426646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  426649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  426652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426675 */     // MIs[1] Operand 1
     /*  426675 */     // No operand predicates
     /*  426675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426688 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  426688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  426691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426708 */     GIR_RootConstrainSelectedInstOperands,
     /*  426709 */     // GIR_Coverage, 5346,
     /*  426709 */     GIR_EraseRootFromParent_Done,
     /*  426710 */   // Label 7477: @426710
     /*  426710 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(426793), // Rule ID 5347 //
     /*  426715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  426726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  426729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  426732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  426735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426758 */     // MIs[1] Operand 1
     /*  426758 */     // No operand predicates
     /*  426758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426771 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  426771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  426774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426791 */     GIR_RootConstrainSelectedInstOperands,
     /*  426792 */     // GIR_Coverage, 5347,
     /*  426792 */     GIR_EraseRootFromParent_Done,
     /*  426793 */   // Label 7478: @426793
     /*  426793 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(426876), // Rule ID 5348 //
     /*  426798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  426809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  426812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  426815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  426818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426841 */     // MIs[1] Operand 1
     /*  426841 */     // No operand predicates
     /*  426841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426854 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  426854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  426857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426864 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426874 */     GIR_RootConstrainSelectedInstOperands,
     /*  426875 */     // GIR_Coverage, 5348,
     /*  426875 */     GIR_EraseRootFromParent_Done,
     /*  426876 */   // Label 7479: @426876
     /*  426876 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(426959), // Rule ID 5349 //
     /*  426881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  426892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  426895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  426898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  426901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426924 */     // MIs[1] Operand 1
     /*  426924 */     // No operand predicates
     /*  426924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426937 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  426937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  426940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426957 */     GIR_RootConstrainSelectedInstOperands,
     /*  426958 */     // GIR_Coverage, 5349,
     /*  426958 */     GIR_EraseRootFromParent_Done,
     /*  426959 */   // Label 7480: @426959
     /*  426959 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(427042), // Rule ID 5350 //
     /*  426964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  426975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  426978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  426981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  426984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427007 */     // MIs[1] Operand 1
     /*  427007 */     // No operand predicates
     /*  427007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427020 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  427020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  427023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427030 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427040 */     GIR_RootConstrainSelectedInstOperands,
     /*  427041 */     // GIR_Coverage, 5350,
     /*  427041 */     GIR_EraseRootFromParent_Done,
     /*  427042 */   // Label 7481: @427042
     /*  427042 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(427125), // Rule ID 5351 //
     /*  427047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  427058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  427061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  427064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  427067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427090 */     // MIs[1] Operand 1
     /*  427090 */     // No operand predicates
     /*  427090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427103 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  427103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  427106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427123 */     GIR_RootConstrainSelectedInstOperands,
     /*  427124 */     // GIR_Coverage, 5351,
     /*  427124 */     GIR_EraseRootFromParent_Done,
     /*  427125 */   // Label 7482: @427125
     /*  427125 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(427208), // Rule ID 5352 //
     /*  427130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  427141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  427144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  427147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  427150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427173 */     // MIs[1] Operand 1
     /*  427173 */     // No operand predicates
     /*  427173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427186 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  427186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  427189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427196 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427206 */     GIR_RootConstrainSelectedInstOperands,
     /*  427207 */     // GIR_Coverage, 5352,
     /*  427207 */     GIR_EraseRootFromParent_Done,
     /*  427208 */   // Label 7483: @427208
     /*  427208 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(427291), // Rule ID 5353 //
     /*  427213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  427224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  427227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  427230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  427233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427256 */     // MIs[1] Operand 1
     /*  427256 */     // No operand predicates
     /*  427256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427269 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  427269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  427272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427289 */     GIR_RootConstrainSelectedInstOperands,
     /*  427290 */     // GIR_Coverage, 5353,
     /*  427290 */     GIR_EraseRootFromParent_Done,
     /*  427291 */   // Label 7484: @427291
     /*  427291 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(427374), // Rule ID 5354 //
     /*  427296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  427307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  427310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  427313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  427316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427339 */     // MIs[1] Operand 1
     /*  427339 */     // No operand predicates
     /*  427339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427352 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  427352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  427355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427362 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427372 */     GIR_RootConstrainSelectedInstOperands,
     /*  427373 */     // GIR_Coverage, 5354,
     /*  427373 */     GIR_EraseRootFromParent_Done,
     /*  427374 */   // Label 7485: @427374
     /*  427374 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(427457), // Rule ID 5355 //
     /*  427379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  427390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  427393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  427396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  427399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427422 */     // MIs[1] Operand 1
     /*  427422 */     // No operand predicates
     /*  427422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427435 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  427435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  427438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427455 */     GIR_RootConstrainSelectedInstOperands,
     /*  427456 */     // GIR_Coverage, 5355,
     /*  427456 */     GIR_EraseRootFromParent_Done,
     /*  427457 */   // Label 7486: @427457
     /*  427457 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(427540), // Rule ID 5356 //
     /*  427462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  427473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  427476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  427479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  427482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427505 */     // MIs[1] Operand 1
     /*  427505 */     // No operand predicates
     /*  427505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427518 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  427518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  427521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427538 */     GIR_RootConstrainSelectedInstOperands,
     /*  427539 */     // GIR_Coverage, 5356,
     /*  427539 */     GIR_EraseRootFromParent_Done,
     /*  427540 */   // Label 7487: @427540
     /*  427540 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(427623), // Rule ID 5357 //
     /*  427545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  427556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  427559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  427562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  427565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427588 */     // MIs[1] Operand 1
     /*  427588 */     // No operand predicates
     /*  427588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427601 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  427601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  427604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427621 */     GIR_RootConstrainSelectedInstOperands,
     /*  427622 */     // GIR_Coverage, 5357,
     /*  427622 */     GIR_EraseRootFromParent_Done,
     /*  427623 */   // Label 7488: @427623
     /*  427623 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(427706), // Rule ID 5358 //
     /*  427628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  427639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  427642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  427645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  427648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427671 */     // MIs[1] Operand 1
     /*  427671 */     // No operand predicates
     /*  427671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427684 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  427684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  427687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427694 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427704 */     GIR_RootConstrainSelectedInstOperands,
     /*  427705 */     // GIR_Coverage, 5358,
     /*  427705 */     GIR_EraseRootFromParent_Done,
     /*  427706 */   // Label 7489: @427706
     /*  427706 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(427789), // Rule ID 5359 //
     /*  427711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  427722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  427725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  427728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  427731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427754 */     // MIs[1] Operand 1
     /*  427754 */     // No operand predicates
     /*  427754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427767 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  427767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  427770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427787 */     GIR_RootConstrainSelectedInstOperands,
     /*  427788 */     // GIR_Coverage, 5359,
     /*  427788 */     GIR_EraseRootFromParent_Done,
     /*  427789 */   // Label 7490: @427789
     /*  427789 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(427872), // Rule ID 5360 //
     /*  427794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  427805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  427808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  427811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  427814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427837 */     // MIs[1] Operand 1
     /*  427837 */     // No operand predicates
     /*  427837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427850 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  427850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  427853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427870 */     GIR_RootConstrainSelectedInstOperands,
     /*  427871 */     // GIR_Coverage, 5360,
     /*  427871 */     GIR_EraseRootFromParent_Done,
     /*  427872 */   // Label 7491: @427872
     /*  427872 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(427955), // Rule ID 5361 //
     /*  427877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  427888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  427891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  427894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  427897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427920 */     // MIs[1] Operand 1
     /*  427920 */     // No operand predicates
     /*  427920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427933 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  427933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  427936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427953 */     GIR_RootConstrainSelectedInstOperands,
     /*  427954 */     // GIR_Coverage, 5361,
     /*  427954 */     GIR_EraseRootFromParent_Done,
     /*  427955 */   // Label 7492: @427955
     /*  427955 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(428038), // Rule ID 5362 //
     /*  427960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  427971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  427974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  427977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  427980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428003 */     // MIs[1] Operand 1
     /*  428003 */     // No operand predicates
     /*  428003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428016 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  428016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  428019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428026 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428036 */     GIR_RootConstrainSelectedInstOperands,
     /*  428037 */     // GIR_Coverage, 5362,
     /*  428037 */     GIR_EraseRootFromParent_Done,
     /*  428038 */   // Label 7493: @428038
     /*  428038 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(428121), // Rule ID 5363 //
     /*  428043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  428054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  428057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  428060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  428063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428086 */     // MIs[1] Operand 1
     /*  428086 */     // No operand predicates
     /*  428086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428099 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  428099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  428102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428119 */     GIR_RootConstrainSelectedInstOperands,
     /*  428120 */     // GIR_Coverage, 5363,
     /*  428120 */     GIR_EraseRootFromParent_Done,
     /*  428121 */   // Label 7494: @428121
     /*  428121 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(428204), // Rule ID 5364 //
     /*  428126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  428129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  428137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  428140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  428143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  428146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428169 */     // MIs[1] Operand 1
     /*  428169 */     // No operand predicates
     /*  428169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428182 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  428182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  428185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428192 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428202 */     GIR_RootConstrainSelectedInstOperands,
     /*  428203 */     // GIR_Coverage, 5364,
     /*  428203 */     GIR_EraseRootFromParent_Done,
     /*  428204 */   // Label 7495: @428204
     /*  428204 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(428287), // Rule ID 5365 //
     /*  428209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  428212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  428220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  428223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  428226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  428229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428252 */     // MIs[1] Operand 1
     /*  428252 */     // No operand predicates
     /*  428252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428265 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  428265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  428268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428285 */     GIR_RootConstrainSelectedInstOperands,
     /*  428286 */     // GIR_Coverage, 5365,
     /*  428286 */     GIR_EraseRootFromParent_Done,
     /*  428287 */   // Label 7496: @428287
     /*  428287 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(428370), // Rule ID 5366 //
     /*  428292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  428295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  428303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  428306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  428309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  428312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428335 */     // MIs[1] Operand 1
     /*  428335 */     // No operand predicates
     /*  428335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428348 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  428348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  428351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428358 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428368 */     GIR_RootConstrainSelectedInstOperands,
     /*  428369 */     // GIR_Coverage, 5366,
     /*  428369 */     GIR_EraseRootFromParent_Done,
     /*  428370 */   // Label 7497: @428370
     /*  428370 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(428453), // Rule ID 5367 //
     /*  428375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  428378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  428386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  428389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  428392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  428395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428418 */     // MIs[1] Operand 1
     /*  428418 */     // No operand predicates
     /*  428418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428431 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  428431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  428434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428451 */     GIR_RootConstrainSelectedInstOperands,
     /*  428452 */     // GIR_Coverage, 5367,
     /*  428452 */     GIR_EraseRootFromParent_Done,
     /*  428453 */   // Label 7498: @428453
     /*  428453 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(428536), // Rule ID 5368 //
     /*  428458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  428461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  428469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  428472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  428475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  428478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428501 */     // MIs[1] Operand 1
     /*  428501 */     // No operand predicates
     /*  428501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428514 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  428514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  428517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428534 */     GIR_RootConstrainSelectedInstOperands,
     /*  428535 */     // GIR_Coverage, 5368,
     /*  428535 */     GIR_EraseRootFromParent_Done,
     /*  428536 */   // Label 7499: @428536
     /*  428536 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(428619), // Rule ID 5369 //
     /*  428541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  428544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  428552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  428555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  428558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  428561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428584 */     // MIs[1] Operand 1
     /*  428584 */     // No operand predicates
     /*  428584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428597 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  428597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  428600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428617 */     GIR_RootConstrainSelectedInstOperands,
     /*  428618 */     // GIR_Coverage, 5369,
     /*  428618 */     GIR_EraseRootFromParent_Done,
     /*  428619 */   // Label 7500: @428619
     /*  428619 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(428695), // Rule ID 60602 //
     /*  428624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  428627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  428632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  428635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  428638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  428641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428656 */     // MIs[0] rs2
     /*  428656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428659 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  428664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428671 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  428671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  428674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  428682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428693 */     GIR_RootConstrainSelectedInstOperands,
     /*  428694 */     // GIR_Coverage, 60602,
     /*  428694 */     GIR_EraseRootFromParent_Done,
     /*  428695 */   // Label 7501: @428695
     /*  428695 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(428771), // Rule ID 60603 //
     /*  428700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  428703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  428708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  428711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  428714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  428717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428732 */     // MIs[0] rs2
     /*  428732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  428740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428747 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  428747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  428750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  428758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428769 */     GIR_RootConstrainSelectedInstOperands,
     /*  428770 */     // GIR_Coverage, 60603,
     /*  428770 */     GIR_EraseRootFromParent_Done,
     /*  428771 */   // Label 7502: @428771
     /*  428771 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(428847), // Rule ID 62248 //
     /*  428776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  428779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  428784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  428787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  428790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  428793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428808 */     // MIs[0] rs2
     /*  428808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  428816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428823 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  428823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  428826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  428834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428845 */     GIR_RootConstrainSelectedInstOperands,
     /*  428846 */     // GIR_Coverage, 62248,
     /*  428846 */     GIR_EraseRootFromParent_Done,
     /*  428847 */   // Label 7503: @428847
     /*  428847 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(428923), // Rule ID 62249 //
     /*  428852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  428855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  428860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  428863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  428866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  428869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428884 */     // MIs[0] rs2
     /*  428884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428887 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  428892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  428899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  428902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  428910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428921 */     GIR_RootConstrainSelectedInstOperands,
     /*  428922 */     // GIR_Coverage, 62249,
     /*  428922 */     GIR_EraseRootFromParent_Done,
     /*  428923 */   // Label 7504: @428923
     /*  428923 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(428999), // Rule ID 62250 //
     /*  428928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  428931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  428936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  428939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  428942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  428945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428960 */     // MIs[0] rs2
     /*  428960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  428968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428975 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  428975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  428978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  428986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428997 */     GIR_RootConstrainSelectedInstOperands,
     /*  428998 */     // GIR_Coverage, 62250,
     /*  428998 */     GIR_EraseRootFromParent_Done,
     /*  428999 */   // Label 7505: @428999
     /*  428999 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(429075), // Rule ID 62251 //
     /*  429004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  429007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  429012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429036 */     // MIs[0] rs2
     /*  429036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429051 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  429054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429073 */     GIR_RootConstrainSelectedInstOperands,
     /*  429074 */     // GIR_Coverage, 62251,
     /*  429074 */     GIR_EraseRootFromParent_Done,
     /*  429075 */   // Label 7506: @429075
     /*  429075 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(429151), // Rule ID 62252 //
     /*  429080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  429083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  429088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429112 */     // MIs[0] rs2
     /*  429112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429127 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  429130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429149 */     GIR_RootConstrainSelectedInstOperands,
     /*  429150 */     // GIR_Coverage, 62252,
     /*  429150 */     GIR_EraseRootFromParent_Done,
     /*  429151 */   // Label 7507: @429151
     /*  429151 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(429227), // Rule ID 62253 //
     /*  429156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  429159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  429164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429188 */     // MIs[0] rs2
     /*  429188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429191 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429203 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  429206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429225 */     GIR_RootConstrainSelectedInstOperands,
     /*  429226 */     // GIR_Coverage, 62253,
     /*  429226 */     GIR_EraseRootFromParent_Done,
     /*  429227 */   // Label 7508: @429227
     /*  429227 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(429303), // Rule ID 62254 //
     /*  429232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  429235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  429240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  429243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  429246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  429249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429264 */     // MIs[0] rs2
     /*  429264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429279 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  429282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429301 */     GIR_RootConstrainSelectedInstOperands,
     /*  429302 */     // GIR_Coverage, 62254,
     /*  429302 */     GIR_EraseRootFromParent_Done,
     /*  429303 */   // Label 7509: @429303
     /*  429303 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(429379), // Rule ID 62255 //
     /*  429308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  429311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  429316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  429319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  429322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  429325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429340 */     // MIs[0] rs2
     /*  429340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429355 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  429358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429377 */     GIR_RootConstrainSelectedInstOperands,
     /*  429378 */     // GIR_Coverage, 62255,
     /*  429378 */     GIR_EraseRootFromParent_Done,
     /*  429379 */   // Label 7510: @429379
     /*  429379 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(429455), // Rule ID 62376 //
     /*  429384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  429387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  429395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  429398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  429401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429416 */     // MIs[0] rs2
     /*  429416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429431 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  429434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429453 */     GIR_RootConstrainSelectedInstOperands,
     /*  429454 */     // GIR_Coverage, 62376,
     /*  429454 */     GIR_EraseRootFromParent_Done,
     /*  429455 */   // Label 7511: @429455
     /*  429455 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(429531), // Rule ID 62377 //
     /*  429460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  429463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  429471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  429474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  429477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429492 */     // MIs[0] rs2
     /*  429492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429495 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429507 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  429510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429529 */     GIR_RootConstrainSelectedInstOperands,
     /*  429530 */     // GIR_Coverage, 62377,
     /*  429530 */     GIR_EraseRootFromParent_Done,
     /*  429531 */   // Label 7512: @429531
     /*  429531 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(429607), // Rule ID 62378 //
     /*  429536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  429539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  429547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  429550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  429553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429568 */     // MIs[0] rs2
     /*  429568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429583 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  429586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429605 */     GIR_RootConstrainSelectedInstOperands,
     /*  429606 */     // GIR_Coverage, 62378,
     /*  429606 */     GIR_EraseRootFromParent_Done,
     /*  429607 */   // Label 7513: @429607
     /*  429607 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(429683), // Rule ID 62379 //
     /*  429612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  429615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  429623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  429626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  429629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429644 */     // MIs[0] rs2
     /*  429644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429647 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429659 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  429662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429681 */     GIR_RootConstrainSelectedInstOperands,
     /*  429682 */     // GIR_Coverage, 62379,
     /*  429682 */     GIR_EraseRootFromParent_Done,
     /*  429683 */   // Label 7514: @429683
     /*  429683 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(429759), // Rule ID 62380 //
     /*  429688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  429691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429720 */     // MIs[0] rs2
     /*  429720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429735 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  429738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429757 */     GIR_RootConstrainSelectedInstOperands,
     /*  429758 */     // GIR_Coverage, 62380,
     /*  429758 */     GIR_EraseRootFromParent_Done,
     /*  429759 */   // Label 7515: @429759
     /*  429759 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(429835), // Rule ID 62381 //
     /*  429764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  429767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429796 */     // MIs[0] rs2
     /*  429796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429811 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  429814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429833 */     GIR_RootConstrainSelectedInstOperands,
     /*  429834 */     // GIR_Coverage, 62381,
     /*  429834 */     GIR_EraseRootFromParent_Done,
     /*  429835 */   // Label 7516: @429835
     /*  429835 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(429911), // Rule ID 62382 //
     /*  429840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  429843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429872 */     // MIs[0] rs2
     /*  429872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429887 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  429890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429909 */     GIR_RootConstrainSelectedInstOperands,
     /*  429910 */     // GIR_Coverage, 62382,
     /*  429910 */     GIR_EraseRootFromParent_Done,
     /*  429911 */   // Label 7517: @429911
     /*  429911 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(429987), // Rule ID 62383 //
     /*  429916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  429919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429948 */     // MIs[0] rs2
     /*  429948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429963 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  429966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429985 */     GIR_RootConstrainSelectedInstOperands,
     /*  429986 */     // GIR_Coverage, 62383,
     /*  429986 */     GIR_EraseRootFromParent_Done,
     /*  429987 */   // Label 7518: @429987
     /*  429987 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(430063), // Rule ID 62384 //
     /*  429992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  429995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  430000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  430003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  430006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  430009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430024 */     // MIs[0] rs2
     /*  430024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430027 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  430032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430039 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  430039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  430042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  430050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  430058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430061 */     GIR_RootConstrainSelectedInstOperands,
     /*  430062 */     // GIR_Coverage, 62384,
     /*  430062 */     GIR_EraseRootFromParent_Done,
     /*  430063 */   // Label 7519: @430063
     /*  430063 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(430139), // Rule ID 62385 //
     /*  430068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  430071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  430076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  430079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  430082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  430085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430100 */     // MIs[0] rs2
     /*  430100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  430108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430115 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  430115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  430118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  430126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  430134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430137 */     GIR_RootConstrainSelectedInstOperands,
     /*  430138 */     // GIR_Coverage, 62385,
     /*  430138 */     GIR_EraseRootFromParent_Done,
     /*  430139 */   // Label 7520: @430139
     /*  430139 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(430227), // Rule ID 2788 //
     /*  430144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  430155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  430158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  430161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430191 */     // MIs[1] Operand 1
     /*  430191 */     // No operand predicates
     /*  430191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430200 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  430203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430209 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430225 */     GIR_RootConstrainSelectedInstOperands,
     /*  430226 */     // GIR_Coverage, 2788,
     /*  430226 */     GIR_EraseRootFromParent_Done,
     /*  430227 */   // Label 7521: @430227
     /*  430227 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(430315), // Rule ID 2789 //
     /*  430232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  430243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  430246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  430249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430279 */     // MIs[1] Operand 1
     /*  430279 */     // No operand predicates
     /*  430279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430288 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  430291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430297 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430313 */     GIR_RootConstrainSelectedInstOperands,
     /*  430314 */     // GIR_Coverage, 2789,
     /*  430314 */     GIR_EraseRootFromParent_Done,
     /*  430315 */   // Label 7522: @430315
     /*  430315 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(430403), // Rule ID 2796 //
     /*  430320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  430331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  430334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  430337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430367 */     // MIs[1] Operand 1
     /*  430367 */     // No operand predicates
     /*  430367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430385 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430401 */     GIR_RootConstrainSelectedInstOperands,
     /*  430402 */     // GIR_Coverage, 2796,
     /*  430402 */     GIR_EraseRootFromParent_Done,
     /*  430403 */   // Label 7523: @430403
     /*  430403 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(430491), // Rule ID 2797 //
     /*  430408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  430419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  430422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  430425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430455 */     // MIs[1] Operand 1
     /*  430455 */     // No operand predicates
     /*  430455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430464 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430473 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430489 */     GIR_RootConstrainSelectedInstOperands,
     /*  430490 */     // GIR_Coverage, 2797,
     /*  430490 */     GIR_EraseRootFromParent_Done,
     /*  430491 */   // Label 7524: @430491
     /*  430491 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(430579), // Rule ID 2804 //
     /*  430496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  430507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  430510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  430513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430543 */     // MIs[1] Operand 1
     /*  430543 */     // No operand predicates
     /*  430543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430552 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430561 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430577 */     GIR_RootConstrainSelectedInstOperands,
     /*  430578 */     // GIR_Coverage, 2804,
     /*  430578 */     GIR_EraseRootFromParent_Done,
     /*  430579 */   // Label 7525: @430579
     /*  430579 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(430667), // Rule ID 2805 //
     /*  430584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  430595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  430598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  430601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430631 */     // MIs[1] Operand 1
     /*  430631 */     // No operand predicates
     /*  430631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430640 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430649 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430665 */     GIR_RootConstrainSelectedInstOperands,
     /*  430666 */     // GIR_Coverage, 2805,
     /*  430666 */     GIR_EraseRootFromParent_Done,
     /*  430667 */   // Label 7526: @430667
     /*  430667 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(430755), // Rule ID 2812 //
     /*  430672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  430683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  430686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  430689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430719 */     // MIs[1] Operand 1
     /*  430719 */     // No operand predicates
     /*  430719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430728 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430737 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430753 */     GIR_RootConstrainSelectedInstOperands,
     /*  430754 */     // GIR_Coverage, 2812,
     /*  430754 */     GIR_EraseRootFromParent_Done,
     /*  430755 */   // Label 7527: @430755
     /*  430755 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(430843), // Rule ID 2813 //
     /*  430760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  430771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  430774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  430777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430807 */     // MIs[1] Operand 1
     /*  430807 */     // No operand predicates
     /*  430807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430816 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  430816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430825 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430841 */     GIR_RootConstrainSelectedInstOperands,
     /*  430842 */     // GIR_Coverage, 2813,
     /*  430842 */     GIR_EraseRootFromParent_Done,
     /*  430843 */   // Label 7528: @430843
     /*  430843 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(430931), // Rule ID 2820 //
     /*  430848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  430859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  430862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  430865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430895 */     // MIs[1] Operand 1
     /*  430895 */     // No operand predicates
     /*  430895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430904 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430913 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430929 */     GIR_RootConstrainSelectedInstOperands,
     /*  430930 */     // GIR_Coverage, 2820,
     /*  430930 */     GIR_EraseRootFromParent_Done,
     /*  430931 */   // Label 7529: @430931
     /*  430931 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(431019), // Rule ID 2821 //
     /*  430936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  430947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  430950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  430953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430983 */     // MIs[1] Operand 1
     /*  430983 */     // No operand predicates
     /*  430983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430992 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  430992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431001 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431017 */     GIR_RootConstrainSelectedInstOperands,
     /*  431018 */     // GIR_Coverage, 2821,
     /*  431018 */     GIR_EraseRootFromParent_Done,
     /*  431019 */   // Label 7530: @431019
     /*  431019 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(431107), // Rule ID 2828 //
     /*  431024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  431035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  431038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  431041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431071 */     // MIs[1] Operand 1
     /*  431071 */     // No operand predicates
     /*  431071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431080 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431089 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431105 */     GIR_RootConstrainSelectedInstOperands,
     /*  431106 */     // GIR_Coverage, 2828,
     /*  431106 */     GIR_EraseRootFromParent_Done,
     /*  431107 */   // Label 7531: @431107
     /*  431107 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(431195), // Rule ID 2829 //
     /*  431112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  431123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  431126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  431129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431159 */     // MIs[1] Operand 1
     /*  431159 */     // No operand predicates
     /*  431159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431177 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431193 */     GIR_RootConstrainSelectedInstOperands,
     /*  431194 */     // GIR_Coverage, 2829,
     /*  431194 */     GIR_EraseRootFromParent_Done,
     /*  431195 */   // Label 7532: @431195
     /*  431195 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(431283), // Rule ID 2836 //
     /*  431200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  431211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  431214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  431217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431247 */     // MIs[1] Operand 1
     /*  431247 */     // No operand predicates
     /*  431247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431256 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431265 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431281 */     GIR_RootConstrainSelectedInstOperands,
     /*  431282 */     // GIR_Coverage, 2836,
     /*  431282 */     GIR_EraseRootFromParent_Done,
     /*  431283 */   // Label 7533: @431283
     /*  431283 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(431371), // Rule ID 2837 //
     /*  431288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  431299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  431302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  431305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431335 */     // MIs[1] Operand 1
     /*  431335 */     // No operand predicates
     /*  431335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431344 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  431344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431353 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431369 */     GIR_RootConstrainSelectedInstOperands,
     /*  431370 */     // GIR_Coverage, 2837,
     /*  431370 */     GIR_EraseRootFromParent_Done,
     /*  431371 */   // Label 7534: @431371
     /*  431371 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(431459), // Rule ID 2844 //
     /*  431376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  431387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  431390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  431393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431423 */     // MIs[1] Operand 1
     /*  431423 */     // No operand predicates
     /*  431423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431432 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431441 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431457 */     GIR_RootConstrainSelectedInstOperands,
     /*  431458 */     // GIR_Coverage, 2844,
     /*  431458 */     GIR_EraseRootFromParent_Done,
     /*  431459 */   // Label 7535: @431459
     /*  431459 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(431547), // Rule ID 2845 //
     /*  431464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  431475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  431478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  431481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431511 */     // MIs[1] Operand 1
     /*  431511 */     // No operand predicates
     /*  431511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431520 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431529 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431545 */     GIR_RootConstrainSelectedInstOperands,
     /*  431546 */     // GIR_Coverage, 2845,
     /*  431546 */     GIR_EraseRootFromParent_Done,
     /*  431547 */   // Label 7536: @431547
     /*  431547 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(431635), // Rule ID 2852 //
     /*  431552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  431563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  431566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  431569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431599 */     // MIs[1] Operand 1
     /*  431599 */     // No operand predicates
     /*  431599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431608 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431617 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431633 */     GIR_RootConstrainSelectedInstOperands,
     /*  431634 */     // GIR_Coverage, 2852,
     /*  431634 */     GIR_EraseRootFromParent_Done,
     /*  431635 */   // Label 7537: @431635
     /*  431635 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(431723), // Rule ID 2853 //
     /*  431640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  431651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  431654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  431657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431687 */     // MIs[1] Operand 1
     /*  431687 */     // No operand predicates
     /*  431687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431705 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431721 */     GIR_RootConstrainSelectedInstOperands,
     /*  431722 */     // GIR_Coverage, 2853,
     /*  431722 */     GIR_EraseRootFromParent_Done,
     /*  431723 */   // Label 7538: @431723
     /*  431723 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(431811), // Rule ID 2860 //
     /*  431728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  431731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  431739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  431742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  431745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431775 */     // MIs[1] Operand 1
     /*  431775 */     // No operand predicates
     /*  431775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431784 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  431784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431793 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  431806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431809 */     GIR_RootConstrainSelectedInstOperands,
     /*  431810 */     // GIR_Coverage, 2860,
     /*  431810 */     GIR_EraseRootFromParent_Done,
     /*  431811 */   // Label 7539: @431811
     /*  431811 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(431899), // Rule ID 2861 //
     /*  431816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  431819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  431827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  431830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  431833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431863 */     // MIs[1] Operand 1
     /*  431863 */     // No operand predicates
     /*  431863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431872 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  431872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431881 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  431894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431897 */     GIR_RootConstrainSelectedInstOperands,
     /*  431898 */     // GIR_Coverage, 2861,
     /*  431898 */     GIR_EraseRootFromParent_Done,
     /*  431899 */   // Label 7540: @431899
     /*  431899 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(431987), // Rule ID 2868 //
     /*  431904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  431915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  431918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  431921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431951 */     // MIs[1] Operand 1
     /*  431951 */     // No operand predicates
     /*  431951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  431963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431969 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431985 */     GIR_RootConstrainSelectedInstOperands,
     /*  431986 */     // GIR_Coverage, 2868,
     /*  431986 */     GIR_EraseRootFromParent_Done,
     /*  431987 */   // Label 7541: @431987
     /*  431987 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(432075), // Rule ID 2869 //
     /*  431992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  432003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  432006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  432009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432039 */     // MIs[1] Operand 1
     /*  432039 */     // No operand predicates
     /*  432039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432048 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432057 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432073 */     GIR_RootConstrainSelectedInstOperands,
     /*  432074 */     // GIR_Coverage, 2869,
     /*  432074 */     GIR_EraseRootFromParent_Done,
     /*  432075 */   // Label 7542: @432075
     /*  432075 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(432163), // Rule ID 2876 //
     /*  432080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  432091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  432094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  432097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432127 */     // MIs[1] Operand 1
     /*  432127 */     // No operand predicates
     /*  432127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432136 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432145 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432161 */     GIR_RootConstrainSelectedInstOperands,
     /*  432162 */     // GIR_Coverage, 2876,
     /*  432162 */     GIR_EraseRootFromParent_Done,
     /*  432163 */   // Label 7543: @432163
     /*  432163 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(432251), // Rule ID 2877 //
     /*  432168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  432179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  432182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  432185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432215 */     // MIs[1] Operand 1
     /*  432215 */     // No operand predicates
     /*  432215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432224 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432233 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432249 */     GIR_RootConstrainSelectedInstOperands,
     /*  432250 */     // GIR_Coverage, 2877,
     /*  432250 */     GIR_EraseRootFromParent_Done,
     /*  432251 */   // Label 7544: @432251
     /*  432251 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(432339), // Rule ID 2884 //
     /*  432256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  432267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  432270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  432273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432303 */     // MIs[1] Operand 1
     /*  432303 */     // No operand predicates
     /*  432303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432312 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432321 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432337 */     GIR_RootConstrainSelectedInstOperands,
     /*  432338 */     // GIR_Coverage, 2884,
     /*  432338 */     GIR_EraseRootFromParent_Done,
     /*  432339 */   // Label 7545: @432339
     /*  432339 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(432427), // Rule ID 2885 //
     /*  432344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  432355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  432358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  432361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432391 */     // MIs[1] Operand 1
     /*  432391 */     // No operand predicates
     /*  432391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432400 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432409 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432425 */     GIR_RootConstrainSelectedInstOperands,
     /*  432426 */     // GIR_Coverage, 2885,
     /*  432426 */     GIR_EraseRootFromParent_Done,
     /*  432427 */   // Label 7546: @432427
     /*  432427 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(432515), // Rule ID 2892 //
     /*  432432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  432443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  432446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432479 */     // MIs[1] Operand 1
     /*  432479 */     // No operand predicates
     /*  432479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432488 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432497 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432513 */     GIR_RootConstrainSelectedInstOperands,
     /*  432514 */     // GIR_Coverage, 2892,
     /*  432514 */     GIR_EraseRootFromParent_Done,
     /*  432515 */   // Label 7547: @432515
     /*  432515 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(432603), // Rule ID 2893 //
     /*  432520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  432531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  432534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432567 */     // MIs[1] Operand 1
     /*  432567 */     // No operand predicates
     /*  432567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432576 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432585 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432601 */     GIR_RootConstrainSelectedInstOperands,
     /*  432602 */     // GIR_Coverage, 2893,
     /*  432602 */     GIR_EraseRootFromParent_Done,
     /*  432603 */   // Label 7548: @432603
     /*  432603 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(432691), // Rule ID 2900 //
     /*  432608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  432619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  432622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  432625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432655 */     // MIs[1] Operand 1
     /*  432655 */     // No operand predicates
     /*  432655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432664 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432673 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432689 */     GIR_RootConstrainSelectedInstOperands,
     /*  432690 */     // GIR_Coverage, 2900,
     /*  432690 */     GIR_EraseRootFromParent_Done,
     /*  432691 */   // Label 7549: @432691
     /*  432691 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(432779), // Rule ID 2901 //
     /*  432696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  432707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  432710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  432713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432743 */     // MIs[1] Operand 1
     /*  432743 */     // No operand predicates
     /*  432743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432752 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432761 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432777 */     GIR_RootConstrainSelectedInstOperands,
     /*  432778 */     // GIR_Coverage, 2901,
     /*  432778 */     GIR_EraseRootFromParent_Done,
     /*  432779 */   // Label 7550: @432779
     /*  432779 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(432867), // Rule ID 2908 //
     /*  432784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  432795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  432798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  432801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432831 */     // MIs[1] Operand 1
     /*  432831 */     // No operand predicates
     /*  432831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432840 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432849 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432865 */     GIR_RootConstrainSelectedInstOperands,
     /*  432866 */     // GIR_Coverage, 2908,
     /*  432866 */     GIR_EraseRootFromParent_Done,
     /*  432867 */   // Label 7551: @432867
     /*  432867 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(432955), // Rule ID 2909 //
     /*  432872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  432883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  432886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  432889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432919 */     // MIs[1] Operand 1
     /*  432919 */     // No operand predicates
     /*  432919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432928 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432937 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432953 */     GIR_RootConstrainSelectedInstOperands,
     /*  432954 */     // GIR_Coverage, 2909,
     /*  432954 */     GIR_EraseRootFromParent_Done,
     /*  432955 */   // Label 7552: @432955
     /*  432955 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(433043), // Rule ID 2916 //
     /*  432960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  432971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  432974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  432977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433007 */     // MIs[1] Operand 1
     /*  433007 */     // No operand predicates
     /*  433007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433016 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433025 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433041 */     GIR_RootConstrainSelectedInstOperands,
     /*  433042 */     // GIR_Coverage, 2916,
     /*  433042 */     GIR_EraseRootFromParent_Done,
     /*  433043 */   // Label 7553: @433043
     /*  433043 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(433131), // Rule ID 2917 //
     /*  433048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  433059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  433062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  433065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433095 */     // MIs[1] Operand 1
     /*  433095 */     // No operand predicates
     /*  433095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433104 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433113 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433129 */     GIR_RootConstrainSelectedInstOperands,
     /*  433130 */     // GIR_Coverage, 2917,
     /*  433130 */     GIR_EraseRootFromParent_Done,
     /*  433131 */   // Label 7554: @433131
     /*  433131 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(433219), // Rule ID 2924 //
     /*  433136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  433147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  433150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433183 */     // MIs[1] Operand 1
     /*  433183 */     // No operand predicates
     /*  433183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433192 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433201 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433217 */     GIR_RootConstrainSelectedInstOperands,
     /*  433218 */     // GIR_Coverage, 2924,
     /*  433218 */     GIR_EraseRootFromParent_Done,
     /*  433219 */   // Label 7555: @433219
     /*  433219 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(433307), // Rule ID 2925 //
     /*  433224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  433235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  433238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433271 */     // MIs[1] Operand 1
     /*  433271 */     // No operand predicates
     /*  433271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433280 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433289 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433305 */     GIR_RootConstrainSelectedInstOperands,
     /*  433306 */     // GIR_Coverage, 2925,
     /*  433306 */     GIR_EraseRootFromParent_Done,
     /*  433307 */   // Label 7556: @433307
     /*  433307 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(433395), // Rule ID 2932 //
     /*  433312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  433329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433359 */     // MIs[1] Operand 1
     /*  433359 */     // No operand predicates
     /*  433359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433377 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433393 */     GIR_RootConstrainSelectedInstOperands,
     /*  433394 */     // GIR_Coverage, 2932,
     /*  433394 */     GIR_EraseRootFromParent_Done,
     /*  433395 */   // Label 7557: @433395
     /*  433395 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(433483), // Rule ID 2933 //
     /*  433400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  433417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433447 */     // MIs[1] Operand 1
     /*  433447 */     // No operand predicates
     /*  433447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433456 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433465 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433481 */     GIR_RootConstrainSelectedInstOperands,
     /*  433482 */     // GIR_Coverage, 2933,
     /*  433482 */     GIR_EraseRootFromParent_Done,
     /*  433483 */   // Label 7558: @433483
     /*  433483 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(433571), // Rule ID 2940 //
     /*  433488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  433499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  433502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  433505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433535 */     // MIs[1] Operand 1
     /*  433535 */     // No operand predicates
     /*  433535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433544 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433553 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433569 */     GIR_RootConstrainSelectedInstOperands,
     /*  433570 */     // GIR_Coverage, 2940,
     /*  433570 */     GIR_EraseRootFromParent_Done,
     /*  433571 */   // Label 7559: @433571
     /*  433571 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(433659), // Rule ID 2941 //
     /*  433576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  433587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  433590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  433593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433623 */     // MIs[1] Operand 1
     /*  433623 */     // No operand predicates
     /*  433623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433632 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433641 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433657 */     GIR_RootConstrainSelectedInstOperands,
     /*  433658 */     // GIR_Coverage, 2941,
     /*  433658 */     GIR_EraseRootFromParent_Done,
     /*  433659 */   // Label 7560: @433659
     /*  433659 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(433747), // Rule ID 2948 //
     /*  433664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  433675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  433678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  433681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433711 */     // MIs[1] Operand 1
     /*  433711 */     // No operand predicates
     /*  433711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433729 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433745 */     GIR_RootConstrainSelectedInstOperands,
     /*  433746 */     // GIR_Coverage, 2948,
     /*  433746 */     GIR_EraseRootFromParent_Done,
     /*  433747 */   // Label 7561: @433747
     /*  433747 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(433835), // Rule ID 2949 //
     /*  433752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  433763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  433766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  433769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433799 */     // MIs[1] Operand 1
     /*  433799 */     // No operand predicates
     /*  433799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433808 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433817 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433833 */     GIR_RootConstrainSelectedInstOperands,
     /*  433834 */     // GIR_Coverage, 2949,
     /*  433834 */     GIR_EraseRootFromParent_Done,
     /*  433835 */   // Label 7562: @433835
     /*  433835 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(433923), // Rule ID 2956 //
     /*  433840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  433851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  433854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  433857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433887 */     // MIs[1] Operand 1
     /*  433887 */     // No operand predicates
     /*  433887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433896 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433905 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433921 */     GIR_RootConstrainSelectedInstOperands,
     /*  433922 */     // GIR_Coverage, 2956,
     /*  433922 */     GIR_EraseRootFromParent_Done,
     /*  433923 */   // Label 7563: @433923
     /*  433923 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(434011), // Rule ID 2957 //
     /*  433928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  433939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  433942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  433945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433975 */     // MIs[1] Operand 1
     /*  433975 */     // No operand predicates
     /*  433975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433984 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433993 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  434006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434009 */     GIR_RootConstrainSelectedInstOperands,
     /*  434010 */     // GIR_Coverage, 2957,
     /*  434010 */     GIR_EraseRootFromParent_Done,
     /*  434011 */   // Label 7564: @434011
     /*  434011 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(434097), // Rule ID 3140 //
     /*  434016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  434027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  434030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  434033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434063 */     // MIs[1] Operand 1
     /*  434063 */     // No operand predicates
     /*  434063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434072 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  434075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434095 */     GIR_RootConstrainSelectedInstOperands,
     /*  434096 */     // GIR_Coverage, 3140,
     /*  434096 */     GIR_EraseRootFromParent_Done,
     /*  434097 */   // Label 7565: @434097
     /*  434097 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(434183), // Rule ID 3141 //
     /*  434102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  434113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  434116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  434119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434149 */     // MIs[1] Operand 1
     /*  434149 */     // No operand predicates
     /*  434149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434158 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  434161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434181 */     GIR_RootConstrainSelectedInstOperands,
     /*  434182 */     // GIR_Coverage, 3141,
     /*  434182 */     GIR_EraseRootFromParent_Done,
     /*  434183 */   // Label 7566: @434183
     /*  434183 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(434269), // Rule ID 3144 //
     /*  434188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  434199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  434202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  434205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434235 */     // MIs[1] Operand 1
     /*  434235 */     // No operand predicates
     /*  434235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434244 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  434247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434267 */     GIR_RootConstrainSelectedInstOperands,
     /*  434268 */     // GIR_Coverage, 3144,
     /*  434268 */     GIR_EraseRootFromParent_Done,
     /*  434269 */   // Label 7567: @434269
     /*  434269 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(434355), // Rule ID 3145 //
     /*  434274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  434285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  434288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  434291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434321 */     // MIs[1] Operand 1
     /*  434321 */     // No operand predicates
     /*  434321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434330 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  434333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434353 */     GIR_RootConstrainSelectedInstOperands,
     /*  434354 */     // GIR_Coverage, 3145,
     /*  434354 */     GIR_EraseRootFromParent_Done,
     /*  434355 */   // Label 7568: @434355
     /*  434355 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(434441), // Rule ID 3148 //
     /*  434360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  434371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  434374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  434377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434407 */     // MIs[1] Operand 1
     /*  434407 */     // No operand predicates
     /*  434407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434416 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  434419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434439 */     GIR_RootConstrainSelectedInstOperands,
     /*  434440 */     // GIR_Coverage, 3148,
     /*  434440 */     GIR_EraseRootFromParent_Done,
     /*  434441 */   // Label 7569: @434441
     /*  434441 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(434527), // Rule ID 3149 //
     /*  434446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  434457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  434460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  434463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434493 */     // MIs[1] Operand 1
     /*  434493 */     // No operand predicates
     /*  434493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434502 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  434505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434525 */     GIR_RootConstrainSelectedInstOperands,
     /*  434526 */     // GIR_Coverage, 3149,
     /*  434526 */     GIR_EraseRootFromParent_Done,
     /*  434527 */   // Label 7570: @434527
     /*  434527 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(434613), // Rule ID 3152 //
     /*  434532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  434543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  434546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  434549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434579 */     // MIs[1] Operand 1
     /*  434579 */     // No operand predicates
     /*  434579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434588 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  434591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434611 */     GIR_RootConstrainSelectedInstOperands,
     /*  434612 */     // GIR_Coverage, 3152,
     /*  434612 */     GIR_EraseRootFromParent_Done,
     /*  434613 */   // Label 7571: @434613
     /*  434613 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(434699), // Rule ID 3153 //
     /*  434618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  434629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  434632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  434635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434665 */     // MIs[1] Operand 1
     /*  434665 */     // No operand predicates
     /*  434665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  434677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434697 */     GIR_RootConstrainSelectedInstOperands,
     /*  434698 */     // GIR_Coverage, 3153,
     /*  434698 */     GIR_EraseRootFromParent_Done,
     /*  434699 */   // Label 7572: @434699
     /*  434699 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(434785), // Rule ID 3156 //
     /*  434704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  434715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  434718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  434721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434751 */     // MIs[1] Operand 1
     /*  434751 */     // No operand predicates
     /*  434751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434760 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  434763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434783 */     GIR_RootConstrainSelectedInstOperands,
     /*  434784 */     // GIR_Coverage, 3156,
     /*  434784 */     GIR_EraseRootFromParent_Done,
     /*  434785 */   // Label 7573: @434785
     /*  434785 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(434871), // Rule ID 3157 //
     /*  434790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  434801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  434804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  434807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434837 */     // MIs[1] Operand 1
     /*  434837 */     // No operand predicates
     /*  434837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434846 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  434849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434869 */     GIR_RootConstrainSelectedInstOperands,
     /*  434870 */     // GIR_Coverage, 3157,
     /*  434870 */     GIR_EraseRootFromParent_Done,
     /*  434871 */   // Label 7574: @434871
     /*  434871 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(434957), // Rule ID 3160 //
     /*  434876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  434887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  434890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  434893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434923 */     // MIs[1] Operand 1
     /*  434923 */     // No operand predicates
     /*  434923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434932 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  434932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  434935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434955 */     GIR_RootConstrainSelectedInstOperands,
     /*  434956 */     // GIR_Coverage, 3160,
     /*  434956 */     GIR_EraseRootFromParent_Done,
     /*  434957 */   // Label 7575: @434957
     /*  434957 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(435043), // Rule ID 3161 //
     /*  434962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  434973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  434976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  434979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435009 */     // MIs[1] Operand 1
     /*  435009 */     // No operand predicates
     /*  435009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  435018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  435021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435041 */     GIR_RootConstrainSelectedInstOperands,
     /*  435042 */     // GIR_Coverage, 3161,
     /*  435042 */     GIR_EraseRootFromParent_Done,
     /*  435043 */   // Label 7576: @435043
     /*  435043 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(435129), // Rule ID 3164 //
     /*  435048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  435059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  435065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435095 */     // MIs[1] Operand 1
     /*  435095 */     // No operand predicates
     /*  435095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435104 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435127 */     GIR_RootConstrainSelectedInstOperands,
     /*  435128 */     // GIR_Coverage, 3164,
     /*  435128 */     GIR_EraseRootFromParent_Done,
     /*  435129 */   // Label 7577: @435129
     /*  435129 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(435215), // Rule ID 3165 //
     /*  435134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  435145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  435151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435181 */     // MIs[1] Operand 1
     /*  435181 */     // No operand predicates
     /*  435181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435190 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435213 */     GIR_RootConstrainSelectedInstOperands,
     /*  435214 */     // GIR_Coverage, 3165,
     /*  435214 */     GIR_EraseRootFromParent_Done,
     /*  435215 */   // Label 7578: @435215
     /*  435215 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(435301), // Rule ID 3168 //
     /*  435220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  435231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  435234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435267 */     // MIs[1] Operand 1
     /*  435267 */     // No operand predicates
     /*  435267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  435276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435299 */     GIR_RootConstrainSelectedInstOperands,
     /*  435300 */     // GIR_Coverage, 3168,
     /*  435300 */     GIR_EraseRootFromParent_Done,
     /*  435301 */   // Label 7579: @435301
     /*  435301 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(435387), // Rule ID 3169 //
     /*  435306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  435317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  435320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435353 */     // MIs[1] Operand 1
     /*  435353 */     // No operand predicates
     /*  435353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435362 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  435362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435385 */     GIR_RootConstrainSelectedInstOperands,
     /*  435386 */     // GIR_Coverage, 3169,
     /*  435386 */     GIR_EraseRootFromParent_Done,
     /*  435387 */   // Label 7580: @435387
     /*  435387 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(435473), // Rule ID 3172 //
     /*  435392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  435403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  435406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  435409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435439 */     // MIs[1] Operand 1
     /*  435439 */     // No operand predicates
     /*  435439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  435448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435471 */     GIR_RootConstrainSelectedInstOperands,
     /*  435472 */     // GIR_Coverage, 3172,
     /*  435472 */     GIR_EraseRootFromParent_Done,
     /*  435473 */   // Label 7581: @435473
     /*  435473 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(435559), // Rule ID 3173 //
     /*  435478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  435489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  435492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  435495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435525 */     // MIs[1] Operand 1
     /*  435525 */     // No operand predicates
     /*  435525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  435534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435557 */     GIR_RootConstrainSelectedInstOperands,
     /*  435558 */     // GIR_Coverage, 3173,
     /*  435558 */     GIR_EraseRootFromParent_Done,
     /*  435559 */   // Label 7582: @435559
     /*  435559 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(435645), // Rule ID 3176 //
     /*  435564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  435567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  435575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  435578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  435581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435611 */     // MIs[1] Operand 1
     /*  435611 */     // No operand predicates
     /*  435611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435620 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  435620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  435640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435643 */     GIR_RootConstrainSelectedInstOperands,
     /*  435644 */     // GIR_Coverage, 3176,
     /*  435644 */     GIR_EraseRootFromParent_Done,
     /*  435645 */   // Label 7583: @435645
     /*  435645 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(435731), // Rule ID 3177 //
     /*  435650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  435653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  435661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  435664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  435667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435697 */     // MIs[1] Operand 1
     /*  435697 */     // No operand predicates
     /*  435697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  435706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  435726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435729 */     GIR_RootConstrainSelectedInstOperands,
     /*  435730 */     // GIR_Coverage, 3177,
     /*  435730 */     GIR_EraseRootFromParent_Done,
     /*  435731 */   // Label 7584: @435731
     /*  435731 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(435817), // Rule ID 3180 //
     /*  435736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  435747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  435750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  435753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435783 */     // MIs[1] Operand 1
     /*  435783 */     // No operand predicates
     /*  435783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435792 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  435795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435815 */     GIR_RootConstrainSelectedInstOperands,
     /*  435816 */     // GIR_Coverage, 3180,
     /*  435816 */     GIR_EraseRootFromParent_Done,
     /*  435817 */   // Label 7585: @435817
     /*  435817 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(435903), // Rule ID 3181 //
     /*  435822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  435833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  435836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  435839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435869 */     // MIs[1] Operand 1
     /*  435869 */     // No operand predicates
     /*  435869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435878 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  435881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435901 */     GIR_RootConstrainSelectedInstOperands,
     /*  435902 */     // GIR_Coverage, 3181,
     /*  435902 */     GIR_EraseRootFromParent_Done,
     /*  435903 */   // Label 7586: @435903
     /*  435903 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(435989), // Rule ID 3184 //
     /*  435908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  435919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  435922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  435925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435955 */     // MIs[1] Operand 1
     /*  435955 */     // No operand predicates
     /*  435955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435964 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  435967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435987 */     GIR_RootConstrainSelectedInstOperands,
     /*  435988 */     // GIR_Coverage, 3184,
     /*  435988 */     GIR_EraseRootFromParent_Done,
     /*  435989 */   // Label 7587: @435989
     /*  435989 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(436075), // Rule ID 3185 //
     /*  435994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  436005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  436008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  436011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436041 */     // MIs[1] Operand 1
     /*  436041 */     // No operand predicates
     /*  436041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436050 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  436050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  436053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436073 */     GIR_RootConstrainSelectedInstOperands,
     /*  436074 */     // GIR_Coverage, 3185,
     /*  436074 */     GIR_EraseRootFromParent_Done,
     /*  436075 */   // Label 7588: @436075
     /*  436075 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(436161), // Rule ID 3188 //
     /*  436080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  436091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  436094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  436097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436127 */     // MIs[1] Operand 1
     /*  436127 */     // No operand predicates
     /*  436127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436136 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  436136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  436139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436159 */     GIR_RootConstrainSelectedInstOperands,
     /*  436160 */     // GIR_Coverage, 3188,
     /*  436160 */     GIR_EraseRootFromParent_Done,
     /*  436161 */   // Label 7589: @436161
     /*  436161 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(436247), // Rule ID 3189 //
     /*  436166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  436177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  436180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  436183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436213 */     // MIs[1] Operand 1
     /*  436213 */     // No operand predicates
     /*  436213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436222 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  436222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  436225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436245 */     GIR_RootConstrainSelectedInstOperands,
     /*  436246 */     // GIR_Coverage, 3189,
     /*  436246 */     GIR_EraseRootFromParent_Done,
     /*  436247 */   // Label 7590: @436247
     /*  436247 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(436333), // Rule ID 3192 //
     /*  436252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  436269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436299 */     // MIs[1] Operand 1
     /*  436299 */     // No operand predicates
     /*  436299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  436311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436331 */     GIR_RootConstrainSelectedInstOperands,
     /*  436332 */     // GIR_Coverage, 3192,
     /*  436332 */     GIR_EraseRootFromParent_Done,
     /*  436333 */   // Label 7591: @436333
     /*  436333 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(436419), // Rule ID 3193 //
     /*  436338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  436355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436385 */     // MIs[1] Operand 1
     /*  436385 */     // No operand predicates
     /*  436385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436394 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  436397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436417 */     GIR_RootConstrainSelectedInstOperands,
     /*  436418 */     // GIR_Coverage, 3193,
     /*  436418 */     GIR_EraseRootFromParent_Done,
     /*  436419 */   // Label 7592: @436419
     /*  436419 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(436505), // Rule ID 3196 //
     /*  436424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  436441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436471 */     // MIs[1] Operand 1
     /*  436471 */     // No operand predicates
     /*  436471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436480 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  436483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436503 */     GIR_RootConstrainSelectedInstOperands,
     /*  436504 */     // GIR_Coverage, 3196,
     /*  436504 */     GIR_EraseRootFromParent_Done,
     /*  436505 */   // Label 7593: @436505
     /*  436505 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(436591), // Rule ID 3197 //
     /*  436510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  436527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436557 */     // MIs[1] Operand 1
     /*  436557 */     // No operand predicates
     /*  436557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436566 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  436569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436589 */     GIR_RootConstrainSelectedInstOperands,
     /*  436590 */     // GIR_Coverage, 3197,
     /*  436590 */     GIR_EraseRootFromParent_Done,
     /*  436591 */   // Label 7594: @436591
     /*  436591 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(436677), // Rule ID 3200 //
     /*  436596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  436607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  436610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  436613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436643 */     // MIs[1] Operand 1
     /*  436643 */     // No operand predicates
     /*  436643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436652 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  436655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436675 */     GIR_RootConstrainSelectedInstOperands,
     /*  436676 */     // GIR_Coverage, 3200,
     /*  436676 */     GIR_EraseRootFromParent_Done,
     /*  436677 */   // Label 7595: @436677
     /*  436677 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(436763), // Rule ID 3201 //
     /*  436682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  436693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  436696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  436699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436729 */     // MIs[1] Operand 1
     /*  436729 */     // No operand predicates
     /*  436729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436738 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  436741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436761 */     GIR_RootConstrainSelectedInstOperands,
     /*  436762 */     // GIR_Coverage, 3201,
     /*  436762 */     GIR_EraseRootFromParent_Done,
     /*  436763 */   // Label 7596: @436763
     /*  436763 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(436849), // Rule ID 3204 //
     /*  436768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  436779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  436782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  436785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436815 */     // MIs[1] Operand 1
     /*  436815 */     // No operand predicates
     /*  436815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  436827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436847 */     GIR_RootConstrainSelectedInstOperands,
     /*  436848 */     // GIR_Coverage, 3204,
     /*  436848 */     GIR_EraseRootFromParent_Done,
     /*  436849 */   // Label 7597: @436849
     /*  436849 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(436935), // Rule ID 3205 //
     /*  436854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  436865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  436868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  436871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436901 */     // MIs[1] Operand 1
     /*  436901 */     // No operand predicates
     /*  436901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436910 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  436910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  436913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436933 */     GIR_RootConstrainSelectedInstOperands,
     /*  436934 */     // GIR_Coverage, 3205,
     /*  436934 */     GIR_EraseRootFromParent_Done,
     /*  436935 */   // Label 7598: @436935
     /*  436935 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(437021), // Rule ID 3208 //
     /*  436940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  436951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  436954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  436957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436987 */     // MIs[1] Operand 1
     /*  436987 */     // No operand predicates
     /*  436987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436996 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  436999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437019 */     GIR_RootConstrainSelectedInstOperands,
     /*  437020 */     // GIR_Coverage, 3208,
     /*  437020 */     GIR_EraseRootFromParent_Done,
     /*  437021 */   // Label 7599: @437021
     /*  437021 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(437107), // Rule ID 3209 //
     /*  437026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  437037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  437040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  437043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437073 */     // MIs[1] Operand 1
     /*  437073 */     // No operand predicates
     /*  437073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437082 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  437085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437105 */     GIR_RootConstrainSelectedInstOperands,
     /*  437106 */     // GIR_Coverage, 3209,
     /*  437106 */     GIR_EraseRootFromParent_Done,
     /*  437107 */   // Label 7600: @437107
     /*  437107 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(437193), // Rule ID 3212 //
     /*  437112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  437123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  437126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  437129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437159 */     // MIs[1] Operand 1
     /*  437159 */     // No operand predicates
     /*  437159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437168 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  437168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  437171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437191 */     GIR_RootConstrainSelectedInstOperands,
     /*  437192 */     // GIR_Coverage, 3212,
     /*  437192 */     GIR_EraseRootFromParent_Done,
     /*  437193 */   // Label 7601: @437193
     /*  437193 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(437279), // Rule ID 3213 //
     /*  437198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  437209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  437212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  437215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437245 */     // MIs[1] Operand 1
     /*  437245 */     // No operand predicates
     /*  437245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437254 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  437257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437277 */     GIR_RootConstrainSelectedInstOperands,
     /*  437278 */     // GIR_Coverage, 3213,
     /*  437278 */     GIR_EraseRootFromParent_Done,
     /*  437279 */   // Label 7602: @437279
     /*  437279 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(437365), // Rule ID 3216 //
     /*  437284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  437295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  437298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  437301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437331 */     // MIs[1] Operand 1
     /*  437331 */     // No operand predicates
     /*  437331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  437343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437363 */     GIR_RootConstrainSelectedInstOperands,
     /*  437364 */     // GIR_Coverage, 3216,
     /*  437364 */     GIR_EraseRootFromParent_Done,
     /*  437365 */   // Label 7603: @437365
     /*  437365 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(437451), // Rule ID 3217 //
     /*  437370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  437381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  437384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  437387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437417 */     // MIs[1] Operand 1
     /*  437417 */     // No operand predicates
     /*  437417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  437429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437449 */     GIR_RootConstrainSelectedInstOperands,
     /*  437450 */     // GIR_Coverage, 3217,
     /*  437450 */     GIR_EraseRootFromParent_Done,
     /*  437451 */   // Label 7604: @437451
     /*  437451 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(437537), // Rule ID 3220 //
     /*  437456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  437467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  437470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  437473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437503 */     // MIs[1] Operand 1
     /*  437503 */     // No operand predicates
     /*  437503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437512 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  437515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437535 */     GIR_RootConstrainSelectedInstOperands,
     /*  437536 */     // GIR_Coverage, 3220,
     /*  437536 */     GIR_EraseRootFromParent_Done,
     /*  437537 */   // Label 7605: @437537
     /*  437537 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(437623), // Rule ID 3221 //
     /*  437542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  437553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  437556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  437559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437589 */     // MIs[1] Operand 1
     /*  437589 */     // No operand predicates
     /*  437589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437598 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  437601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437621 */     GIR_RootConstrainSelectedInstOperands,
     /*  437622 */     // GIR_Coverage, 3221,
     /*  437622 */     GIR_EraseRootFromParent_Done,
     /*  437623 */   // Label 7606: @437623
     /*  437623 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(437709), // Rule ID 3224 //
     /*  437628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  437639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  437642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  437645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437675 */     // MIs[1] Operand 1
     /*  437675 */     // No operand predicates
     /*  437675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437684 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  437687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437707 */     GIR_RootConstrainSelectedInstOperands,
     /*  437708 */     // GIR_Coverage, 3224,
     /*  437708 */     GIR_EraseRootFromParent_Done,
     /*  437709 */   // Label 7607: @437709
     /*  437709 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(437795), // Rule ID 3225 //
     /*  437714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  437725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  437728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  437731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437761 */     // MIs[1] Operand 1
     /*  437761 */     // No operand predicates
     /*  437761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437770 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  437773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437793 */     GIR_RootConstrainSelectedInstOperands,
     /*  437794 */     // GIR_Coverage, 3225,
     /*  437794 */     GIR_EraseRootFromParent_Done,
     /*  437795 */   // Label 7608: @437795
     /*  437795 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(437881), // Rule ID 3492 //
     /*  437800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  437811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  437814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  437817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437847 */     // MIs[1] Operand 1
     /*  437847 */     // No operand predicates
     /*  437847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437856 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  437859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437879 */     GIR_RootConstrainSelectedInstOperands,
     /*  437880 */     // GIR_Coverage, 3492,
     /*  437880 */     GIR_EraseRootFromParent_Done,
     /*  437881 */   // Label 7609: @437881
     /*  437881 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(437967), // Rule ID 3493 //
     /*  437886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  437897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  437900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  437903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437933 */     // MIs[1] Operand 1
     /*  437933 */     // No operand predicates
     /*  437933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437942 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  437942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  437945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437965 */     GIR_RootConstrainSelectedInstOperands,
     /*  437966 */     // GIR_Coverage, 3493,
     /*  437966 */     GIR_EraseRootFromParent_Done,
     /*  437967 */   // Label 7610: @437967
     /*  437967 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(438053), // Rule ID 3496 //
     /*  437972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  437983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  437986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  437989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438019 */     // MIs[1] Operand 1
     /*  438019 */     // No operand predicates
     /*  438019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438028 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  438031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438051 */     GIR_RootConstrainSelectedInstOperands,
     /*  438052 */     // GIR_Coverage, 3496,
     /*  438052 */     GIR_EraseRootFromParent_Done,
     /*  438053 */   // Label 7611: @438053
     /*  438053 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(438139), // Rule ID 3497 //
     /*  438058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  438069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  438072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  438075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438105 */     // MIs[1] Operand 1
     /*  438105 */     // No operand predicates
     /*  438105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438114 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  438117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438137 */     GIR_RootConstrainSelectedInstOperands,
     /*  438138 */     // GIR_Coverage, 3497,
     /*  438138 */     GIR_EraseRootFromParent_Done,
     /*  438139 */   // Label 7612: @438139
     /*  438139 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(438225), // Rule ID 3500 //
     /*  438144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  438155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  438158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  438161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438191 */     // MIs[1] Operand 1
     /*  438191 */     // No operand predicates
     /*  438191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438200 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  438203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438223 */     GIR_RootConstrainSelectedInstOperands,
     /*  438224 */     // GIR_Coverage, 3500,
     /*  438224 */     GIR_EraseRootFromParent_Done,
     /*  438225 */   // Label 7613: @438225
     /*  438225 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(438311), // Rule ID 3501 //
     /*  438230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  438241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  438244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  438247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438277 */     // MIs[1] Operand 1
     /*  438277 */     // No operand predicates
     /*  438277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438286 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  438289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438309 */     GIR_RootConstrainSelectedInstOperands,
     /*  438310 */     // GIR_Coverage, 3501,
     /*  438310 */     GIR_EraseRootFromParent_Done,
     /*  438311 */   // Label 7614: @438311
     /*  438311 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(438397), // Rule ID 3504 //
     /*  438316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  438333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438363 */     // MIs[1] Operand 1
     /*  438363 */     // No operand predicates
     /*  438363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438372 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  438375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438395 */     GIR_RootConstrainSelectedInstOperands,
     /*  438396 */     // GIR_Coverage, 3504,
     /*  438396 */     GIR_EraseRootFromParent_Done,
     /*  438397 */   // Label 7615: @438397
     /*  438397 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(438483), // Rule ID 3505 //
     /*  438402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  438419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438449 */     // MIs[1] Operand 1
     /*  438449 */     // No operand predicates
     /*  438449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438458 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  438461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438481 */     GIR_RootConstrainSelectedInstOperands,
     /*  438482 */     // GIR_Coverage, 3505,
     /*  438482 */     GIR_EraseRootFromParent_Done,
     /*  438483 */   // Label 7616: @438483
     /*  438483 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(438569), // Rule ID 3508 //
     /*  438488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  438505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438535 */     // MIs[1] Operand 1
     /*  438535 */     // No operand predicates
     /*  438535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438544 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  438547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438567 */     GIR_RootConstrainSelectedInstOperands,
     /*  438568 */     // GIR_Coverage, 3508,
     /*  438568 */     GIR_EraseRootFromParent_Done,
     /*  438569 */   // Label 7617: @438569
     /*  438569 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(438655), // Rule ID 3509 //
     /*  438574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  438591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438621 */     // MIs[1] Operand 1
     /*  438621 */     // No operand predicates
     /*  438621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438630 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  438633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438653 */     GIR_RootConstrainSelectedInstOperands,
     /*  438654 */     // GIR_Coverage, 3509,
     /*  438654 */     GIR_EraseRootFromParent_Done,
     /*  438655 */   // Label 7618: @438655
     /*  438655 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(438741), // Rule ID 3512 //
     /*  438660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  438671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  438674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  438677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438707 */     // MIs[1] Operand 1
     /*  438707 */     // No operand predicates
     /*  438707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438716 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  438716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  438719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438739 */     GIR_RootConstrainSelectedInstOperands,
     /*  438740 */     // GIR_Coverage, 3512,
     /*  438740 */     GIR_EraseRootFromParent_Done,
     /*  438741 */   // Label 7619: @438741
     /*  438741 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(438827), // Rule ID 3513 //
     /*  438746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  438757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  438760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  438763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438793 */     // MIs[1] Operand 1
     /*  438793 */     // No operand predicates
     /*  438793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  438802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  438805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438825 */     GIR_RootConstrainSelectedInstOperands,
     /*  438826 */     // GIR_Coverage, 3513,
     /*  438826 */     GIR_EraseRootFromParent_Done,
     /*  438827 */   // Label 7620: @438827
     /*  438827 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(438913), // Rule ID 3516 //
     /*  438832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  438843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  438846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  438849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438879 */     // MIs[1] Operand 1
     /*  438879 */     // No operand predicates
     /*  438879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438888 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  438891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438911 */     GIR_RootConstrainSelectedInstOperands,
     /*  438912 */     // GIR_Coverage, 3516,
     /*  438912 */     GIR_EraseRootFromParent_Done,
     /*  438913 */   // Label 7621: @438913
     /*  438913 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(438999), // Rule ID 3517 //
     /*  438918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  438929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  438932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  438935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438965 */     // MIs[1] Operand 1
     /*  438965 */     // No operand predicates
     /*  438965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  438977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438997 */     GIR_RootConstrainSelectedInstOperands,
     /*  438998 */     // GIR_Coverage, 3517,
     /*  438998 */     GIR_EraseRootFromParent_Done,
     /*  438999 */   // Label 7622: @438999
     /*  438999 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(439085), // Rule ID 3520 //
     /*  439004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  439015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  439018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  439021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439051 */     // MIs[1] Operand 1
     /*  439051 */     // No operand predicates
     /*  439051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439060 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  439063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439083 */     GIR_RootConstrainSelectedInstOperands,
     /*  439084 */     // GIR_Coverage, 3520,
     /*  439084 */     GIR_EraseRootFromParent_Done,
     /*  439085 */   // Label 7623: @439085
     /*  439085 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(439171), // Rule ID 3521 //
     /*  439090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  439101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  439104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  439107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439137 */     // MIs[1] Operand 1
     /*  439137 */     // No operand predicates
     /*  439137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  439149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439169 */     GIR_RootConstrainSelectedInstOperands,
     /*  439170 */     // GIR_Coverage, 3521,
     /*  439170 */     GIR_EraseRootFromParent_Done,
     /*  439171 */   // Label 7624: @439171
     /*  439171 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(439257), // Rule ID 3524 //
     /*  439176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  439187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  439190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439223 */     // MIs[1] Operand 1
     /*  439223 */     // No operand predicates
     /*  439223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  439232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  439235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439255 */     GIR_RootConstrainSelectedInstOperands,
     /*  439256 */     // GIR_Coverage, 3524,
     /*  439256 */     GIR_EraseRootFromParent_Done,
     /*  439257 */   // Label 7625: @439257
     /*  439257 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(439343), // Rule ID 3525 //
     /*  439262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  439273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  439276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439309 */     // MIs[1] Operand 1
     /*  439309 */     // No operand predicates
     /*  439309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  439318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  439321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439341 */     GIR_RootConstrainSelectedInstOperands,
     /*  439342 */     // GIR_Coverage, 3525,
     /*  439342 */     GIR_EraseRootFromParent_Done,
     /*  439343 */   // Label 7626: @439343
     /*  439343 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(439429), // Rule ID 3528 //
     /*  439348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  439351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  439359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  439362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  439365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439395 */     // MIs[1] Operand 1
     /*  439395 */     // No operand predicates
     /*  439395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439404 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  439404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  439407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  439424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439427 */     GIR_RootConstrainSelectedInstOperands,
     /*  439428 */     // GIR_Coverage, 3528,
     /*  439428 */     GIR_EraseRootFromParent_Done,
     /*  439429 */   // Label 7627: @439429
     /*  439429 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(439515), // Rule ID 3529 //
     /*  439434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  439437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  439445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  439448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  439451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439481 */     // MIs[1] Operand 1
     /*  439481 */     // No operand predicates
     /*  439481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  439490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  439493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  439510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439513 */     GIR_RootConstrainSelectedInstOperands,
     /*  439514 */     // GIR_Coverage, 3529,
     /*  439514 */     GIR_EraseRootFromParent_Done,
     /*  439515 */   // Label 7628: @439515
     /*  439515 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(439601), // Rule ID 3532 //
     /*  439520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  439531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  439534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  439537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439567 */     // MIs[1] Operand 1
     /*  439567 */     // No operand predicates
     /*  439567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  439579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439599 */     GIR_RootConstrainSelectedInstOperands,
     /*  439600 */     // GIR_Coverage, 3532,
     /*  439600 */     GIR_EraseRootFromParent_Done,
     /*  439601 */   // Label 7629: @439601
     /*  439601 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(439687), // Rule ID 3533 //
     /*  439606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  439617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  439620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  439623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439653 */     // MIs[1] Operand 1
     /*  439653 */     // No operand predicates
     /*  439653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439662 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  439665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439685 */     GIR_RootConstrainSelectedInstOperands,
     /*  439686 */     // GIR_Coverage, 3533,
     /*  439686 */     GIR_EraseRootFromParent_Done,
     /*  439687 */   // Label 7630: @439687
     /*  439687 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(439773), // Rule ID 3536 //
     /*  439692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  439703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  439706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  439709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439739 */     // MIs[1] Operand 1
     /*  439739 */     // No operand predicates
     /*  439739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439748 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  439751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439771 */     GIR_RootConstrainSelectedInstOperands,
     /*  439772 */     // GIR_Coverage, 3536,
     /*  439772 */     GIR_EraseRootFromParent_Done,
     /*  439773 */   // Label 7631: @439773
     /*  439773 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(439859), // Rule ID 3537 //
     /*  439778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  439789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  439792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  439795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439825 */     // MIs[1] Operand 1
     /*  439825 */     // No operand predicates
     /*  439825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439834 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  439837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439857 */     GIR_RootConstrainSelectedInstOperands,
     /*  439858 */     // GIR_Coverage, 3537,
     /*  439858 */     GIR_EraseRootFromParent_Done,
     /*  439859 */   // Label 7632: @439859
     /*  439859 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(439945), // Rule ID 3540 //
     /*  439864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  439875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  439878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  439881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439911 */     // MIs[1] Operand 1
     /*  439911 */     // No operand predicates
     /*  439911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439920 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  439923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439943 */     GIR_RootConstrainSelectedInstOperands,
     /*  439944 */     // GIR_Coverage, 3540,
     /*  439944 */     GIR_EraseRootFromParent_Done,
     /*  439945 */   // Label 7633: @439945
     /*  439945 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(440031), // Rule ID 3541 //
     /*  439950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  439961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  439964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  439967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439997 */     // MIs[1] Operand 1
     /*  439997 */     // No operand predicates
     /*  439997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440006 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  440006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  440009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440029 */     GIR_RootConstrainSelectedInstOperands,
     /*  440030 */     // GIR_Coverage, 3541,
     /*  440030 */     GIR_EraseRootFromParent_Done,
     /*  440031 */   // Label 7634: @440031
     /*  440031 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(440117), // Rule ID 3544 //
     /*  440036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  440047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  440050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  440053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440083 */     // MIs[1] Operand 1
     /*  440083 */     // No operand predicates
     /*  440083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440092 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  440095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440115 */     GIR_RootConstrainSelectedInstOperands,
     /*  440116 */     // GIR_Coverage, 3544,
     /*  440116 */     GIR_EraseRootFromParent_Done,
     /*  440117 */   // Label 7635: @440117
     /*  440117 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(440203), // Rule ID 3545 //
     /*  440122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  440133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  440136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  440139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440169 */     // MIs[1] Operand 1
     /*  440169 */     // No operand predicates
     /*  440169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440178 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  440181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440201 */     GIR_RootConstrainSelectedInstOperands,
     /*  440202 */     // GIR_Coverage, 3545,
     /*  440202 */     GIR_EraseRootFromParent_Done,
     /*  440203 */   // Label 7636: @440203
     /*  440203 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(440289), // Rule ID 3548 //
     /*  440208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  440219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  440222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  440225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440255 */     // MIs[1] Operand 1
     /*  440255 */     // No operand predicates
     /*  440255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440264 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  440267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440287 */     GIR_RootConstrainSelectedInstOperands,
     /*  440288 */     // GIR_Coverage, 3548,
     /*  440288 */     GIR_EraseRootFromParent_Done,
     /*  440289 */   // Label 7637: @440289
     /*  440289 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(440375), // Rule ID 3549 //
     /*  440294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  440305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  440308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  440311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440341 */     // MIs[1] Operand 1
     /*  440341 */     // No operand predicates
     /*  440341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  440353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440373 */     GIR_RootConstrainSelectedInstOperands,
     /*  440374 */     // GIR_Coverage, 3549,
     /*  440374 */     GIR_EraseRootFromParent_Done,
     /*  440375 */   // Label 7638: @440375
     /*  440375 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(440461), // Rule ID 3552 //
     /*  440380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  440391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  440394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  440397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440427 */     // MIs[1] Operand 1
     /*  440427 */     // No operand predicates
     /*  440427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440436 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  440439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440459 */     GIR_RootConstrainSelectedInstOperands,
     /*  440460 */     // GIR_Coverage, 3552,
     /*  440460 */     GIR_EraseRootFromParent_Done,
     /*  440461 */   // Label 7639: @440461
     /*  440461 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(440547), // Rule ID 3553 //
     /*  440466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  440477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  440480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  440483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440513 */     // MIs[1] Operand 1
     /*  440513 */     // No operand predicates
     /*  440513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440522 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  440525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440545 */     GIR_RootConstrainSelectedInstOperands,
     /*  440546 */     // GIR_Coverage, 3553,
     /*  440546 */     GIR_EraseRootFromParent_Done,
     /*  440547 */   // Label 7640: @440547
     /*  440547 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(440633), // Rule ID 3556 //
     /*  440552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  440563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  440566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440599 */     // MIs[1] Operand 1
     /*  440599 */     // No operand predicates
     /*  440599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  440611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440631 */     GIR_RootConstrainSelectedInstOperands,
     /*  440632 */     // GIR_Coverage, 3556,
     /*  440632 */     GIR_EraseRootFromParent_Done,
     /*  440633 */   // Label 7641: @440633
     /*  440633 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(440719), // Rule ID 3557 //
     /*  440638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  440649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  440652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440685 */     // MIs[1] Operand 1
     /*  440685 */     // No operand predicates
     /*  440685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  440697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440717 */     GIR_RootConstrainSelectedInstOperands,
     /*  440718 */     // GIR_Coverage, 3557,
     /*  440718 */     GIR_EraseRootFromParent_Done,
     /*  440719 */   // Label 7642: @440719
     /*  440719 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(440805), // Rule ID 3560 //
     /*  440724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  440735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  440738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  440741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440771 */     // MIs[1] Operand 1
     /*  440771 */     // No operand predicates
     /*  440771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440780 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  440783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440803 */     GIR_RootConstrainSelectedInstOperands,
     /*  440804 */     // GIR_Coverage, 3560,
     /*  440804 */     GIR_EraseRootFromParent_Done,
     /*  440805 */   // Label 7643: @440805
     /*  440805 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(440891), // Rule ID 3561 //
     /*  440810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  440821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  440824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  440827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440857 */     // MIs[1] Operand 1
     /*  440857 */     // No operand predicates
     /*  440857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  440869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440889 */     GIR_RootConstrainSelectedInstOperands,
     /*  440890 */     // GIR_Coverage, 3561,
     /*  440890 */     GIR_EraseRootFromParent_Done,
     /*  440891 */   // Label 7644: @440891
     /*  440891 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(440977), // Rule ID 3564 //
     /*  440896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  440907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  440910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  440913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440943 */     // MIs[1] Operand 1
     /*  440943 */     // No operand predicates
     /*  440943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  440955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440975 */     GIR_RootConstrainSelectedInstOperands,
     /*  440976 */     // GIR_Coverage, 3564,
     /*  440976 */     GIR_EraseRootFromParent_Done,
     /*  440977 */   // Label 7645: @440977
     /*  440977 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(441063), // Rule ID 3565 //
     /*  440982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  440993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  440996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  440999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441029 */     // MIs[1] Operand 1
     /*  441029 */     // No operand predicates
     /*  441029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  441038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  441041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441061 */     GIR_RootConstrainSelectedInstOperands,
     /*  441062 */     // GIR_Coverage, 3565,
     /*  441062 */     GIR_EraseRootFromParent_Done,
     /*  441063 */   // Label 7646: @441063
     /*  441063 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(441149), // Rule ID 3568 //
     /*  441068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  441076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  441079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  441082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441115 */     // MIs[1] Operand 1
     /*  441115 */     // No operand predicates
     /*  441115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  441127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441147 */     GIR_RootConstrainSelectedInstOperands,
     /*  441148 */     // GIR_Coverage, 3568,
     /*  441148 */     GIR_EraseRootFromParent_Done,
     /*  441149 */   // Label 7647: @441149
     /*  441149 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(441235), // Rule ID 3569 //
     /*  441154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  441162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  441165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  441168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441201 */     // MIs[1] Operand 1
     /*  441201 */     // No operand predicates
     /*  441201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441210 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  441213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441233 */     GIR_RootConstrainSelectedInstOperands,
     /*  441234 */     // GIR_Coverage, 3569,
     /*  441234 */     GIR_EraseRootFromParent_Done,
     /*  441235 */   // Label 7648: @441235
     /*  441235 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(441321), // Rule ID 3572 //
     /*  441240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  441248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  441251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  441254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441287 */     // MIs[1] Operand 1
     /*  441287 */     // No operand predicates
     /*  441287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  441299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441319 */     GIR_RootConstrainSelectedInstOperands,
     /*  441320 */     // GIR_Coverage, 3572,
     /*  441320 */     GIR_EraseRootFromParent_Done,
     /*  441321 */   // Label 7649: @441321
     /*  441321 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(441407), // Rule ID 3573 //
     /*  441326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  441334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  441337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  441340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441373 */     // MIs[1] Operand 1
     /*  441373 */     // No operand predicates
     /*  441373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441382 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  441385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441405 */     GIR_RootConstrainSelectedInstOperands,
     /*  441406 */     // GIR_Coverage, 3573,
     /*  441406 */     GIR_EraseRootFromParent_Done,
     /*  441407 */   // Label 7650: @441407
     /*  441407 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(441493), // Rule ID 3576 //
     /*  441412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  441420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  441423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  441426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441459 */     // MIs[1] Operand 1
     /*  441459 */     // No operand predicates
     /*  441459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  441471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441491 */     GIR_RootConstrainSelectedInstOperands,
     /*  441492 */     // GIR_Coverage, 3576,
     /*  441492 */     GIR_EraseRootFromParent_Done,
     /*  441493 */   // Label 7651: @441493
     /*  441493 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(441579), // Rule ID 3577 //
     /*  441498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  441506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  441509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  441512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441545 */     // MIs[1] Operand 1
     /*  441545 */     // No operand predicates
     /*  441545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441554 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  441557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441577 */     GIR_RootConstrainSelectedInstOperands,
     /*  441578 */     // GIR_Coverage, 3577,
     /*  441578 */     GIR_EraseRootFromParent_Done,
     /*  441579 */   // Label 7652: @441579
     /*  441579 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(441665), // Rule ID 5940 //
     /*  441584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  441595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  441598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  441601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441631 */     // MIs[1] Operand 1
     /*  441631 */     // No operand predicates
     /*  441631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441640 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  441643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441663 */     GIR_RootConstrainSelectedInstOperands,
     /*  441664 */     // GIR_Coverage, 5940,
     /*  441664 */     GIR_EraseRootFromParent_Done,
     /*  441665 */   // Label 7653: @441665
     /*  441665 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(441751), // Rule ID 5941 //
     /*  441670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  441681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  441684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  441687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441717 */     // MIs[1] Operand 1
     /*  441717 */     // No operand predicates
     /*  441717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441726 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  441726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  441729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441749 */     GIR_RootConstrainSelectedInstOperands,
     /*  441750 */     // GIR_Coverage, 5941,
     /*  441750 */     GIR_EraseRootFromParent_Done,
     /*  441751 */   // Label 7654: @441751
     /*  441751 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(441837), // Rule ID 5944 //
     /*  441756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  441767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  441770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  441773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441803 */     // MIs[1] Operand 1
     /*  441803 */     // No operand predicates
     /*  441803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441812 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  441815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441835 */     GIR_RootConstrainSelectedInstOperands,
     /*  441836 */     // GIR_Coverage, 5944,
     /*  441836 */     GIR_EraseRootFromParent_Done,
     /*  441837 */   // Label 7655: @441837
     /*  441837 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(441923), // Rule ID 5945 //
     /*  441842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  441853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  441856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  441859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441889 */     // MIs[1] Operand 1
     /*  441889 */     // No operand predicates
     /*  441889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441898 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  441898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  441901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441921 */     GIR_RootConstrainSelectedInstOperands,
     /*  441922 */     // GIR_Coverage, 5945,
     /*  441922 */     GIR_EraseRootFromParent_Done,
     /*  441923 */   // Label 7656: @441923
     /*  441923 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(442009), // Rule ID 5948 //
     /*  441928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  441939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  441942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  441945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441975 */     // MIs[1] Operand 1
     /*  441975 */     // No operand predicates
     /*  441975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441984 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  441987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442007 */     GIR_RootConstrainSelectedInstOperands,
     /*  442008 */     // GIR_Coverage, 5948,
     /*  442008 */     GIR_EraseRootFromParent_Done,
     /*  442009 */   // Label 7657: @442009
     /*  442009 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(442095), // Rule ID 5949 //
     /*  442014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  442025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  442028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  442031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442061 */     // MIs[1] Operand 1
     /*  442061 */     // No operand predicates
     /*  442061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442070 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  442073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442093 */     GIR_RootConstrainSelectedInstOperands,
     /*  442094 */     // GIR_Coverage, 5949,
     /*  442094 */     GIR_EraseRootFromParent_Done,
     /*  442095 */   // Label 7658: @442095
     /*  442095 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(442181), // Rule ID 5952 //
     /*  442100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  442117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442147 */     // MIs[1] Operand 1
     /*  442147 */     // No operand predicates
     /*  442147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442156 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  442159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442179 */     GIR_RootConstrainSelectedInstOperands,
     /*  442180 */     // GIR_Coverage, 5952,
     /*  442180 */     GIR_EraseRootFromParent_Done,
     /*  442181 */   // Label 7659: @442181
     /*  442181 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(442267), // Rule ID 5953 //
     /*  442186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  442203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442233 */     // MIs[1] Operand 1
     /*  442233 */     // No operand predicates
     /*  442233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442242 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  442245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442265 */     GIR_RootConstrainSelectedInstOperands,
     /*  442266 */     // GIR_Coverage, 5953,
     /*  442266 */     GIR_EraseRootFromParent_Done,
     /*  442267 */   // Label 7660: @442267
     /*  442267 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(442353), // Rule ID 5956 //
     /*  442272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  442289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442319 */     // MIs[1] Operand 1
     /*  442319 */     // No operand predicates
     /*  442319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442328 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  442331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442351 */     GIR_RootConstrainSelectedInstOperands,
     /*  442352 */     // GIR_Coverage, 5956,
     /*  442352 */     GIR_EraseRootFromParent_Done,
     /*  442353 */   // Label 7661: @442353
     /*  442353 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(442439), // Rule ID 5957 //
     /*  442358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  442375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442405 */     // MIs[1] Operand 1
     /*  442405 */     // No operand predicates
     /*  442405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442414 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  442417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442437 */     GIR_RootConstrainSelectedInstOperands,
     /*  442438 */     // GIR_Coverage, 5957,
     /*  442438 */     GIR_EraseRootFromParent_Done,
     /*  442439 */   // Label 7662: @442439
     /*  442439 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(442525), // Rule ID 5960 //
     /*  442444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  442455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  442458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442491 */     // MIs[1] Operand 1
     /*  442491 */     // No operand predicates
     /*  442491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442500 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  442500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  442503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442523 */     GIR_RootConstrainSelectedInstOperands,
     /*  442524 */     // GIR_Coverage, 5960,
     /*  442524 */     GIR_EraseRootFromParent_Done,
     /*  442525 */   // Label 7663: @442525
     /*  442525 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(442611), // Rule ID 5961 //
     /*  442530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  442541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  442544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442577 */     // MIs[1] Operand 1
     /*  442577 */     // No operand predicates
     /*  442577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  442586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  442589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442609 */     GIR_RootConstrainSelectedInstOperands,
     /*  442610 */     // GIR_Coverage, 5961,
     /*  442610 */     GIR_EraseRootFromParent_Done,
     /*  442611 */   // Label 7664: @442611
     /*  442611 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(442697), // Rule ID 5964 //
     /*  442616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  442627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  442630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  442633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442663 */     // MIs[1] Operand 1
     /*  442663 */     // No operand predicates
     /*  442663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442672 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  442672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  442675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442695 */     GIR_RootConstrainSelectedInstOperands,
     /*  442696 */     // GIR_Coverage, 5964,
     /*  442696 */     GIR_EraseRootFromParent_Done,
     /*  442697 */   // Label 7665: @442697
     /*  442697 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(442783), // Rule ID 5965 //
     /*  442702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  442713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  442716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  442719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442749 */     // MIs[1] Operand 1
     /*  442749 */     // No operand predicates
     /*  442749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  442761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442781 */     GIR_RootConstrainSelectedInstOperands,
     /*  442782 */     // GIR_Coverage, 5965,
     /*  442782 */     GIR_EraseRootFromParent_Done,
     /*  442783 */   // Label 7666: @442783
     /*  442783 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(442869), // Rule ID 5968 //
     /*  442788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  442799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  442802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  442805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442835 */     // MIs[1] Operand 1
     /*  442835 */     // No operand predicates
     /*  442835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442844 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  442847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442867 */     GIR_RootConstrainSelectedInstOperands,
     /*  442868 */     // GIR_Coverage, 5968,
     /*  442868 */     GIR_EraseRootFromParent_Done,
     /*  442869 */   // Label 7667: @442869
     /*  442869 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(442955), // Rule ID 5969 //
     /*  442874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  442885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  442888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  442891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442921 */     // MIs[1] Operand 1
     /*  442921 */     // No operand predicates
     /*  442921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442930 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  442933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442953 */     GIR_RootConstrainSelectedInstOperands,
     /*  442954 */     // GIR_Coverage, 5969,
     /*  442954 */     GIR_EraseRootFromParent_Done,
     /*  442955 */   // Label 7668: @442955
     /*  442955 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(443041), // Rule ID 5972 //
     /*  442960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  442971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  442974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  442977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443007 */     // MIs[1] Operand 1
     /*  443007 */     // No operand predicates
     /*  443007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443016 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  443016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  443019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443039 */     GIR_RootConstrainSelectedInstOperands,
     /*  443040 */     // GIR_Coverage, 5972,
     /*  443040 */     GIR_EraseRootFromParent_Done,
     /*  443041 */   // Label 7669: @443041
     /*  443041 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(443127), // Rule ID 5973 //
     /*  443046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  443057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  443060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  443063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443093 */     // MIs[1] Operand 1
     /*  443093 */     // No operand predicates
     /*  443093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443102 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  443102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  443105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443125 */     GIR_RootConstrainSelectedInstOperands,
     /*  443126 */     // GIR_Coverage, 5973,
     /*  443126 */     GIR_EraseRootFromParent_Done,
     /*  443127 */   // Label 7670: @443127
     /*  443127 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(443213), // Rule ID 5976 //
     /*  443132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  443135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  443143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  443146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  443149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443179 */     // MIs[1] Operand 1
     /*  443179 */     // No operand predicates
     /*  443179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443188 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  443188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  443191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  443208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443211 */     GIR_RootConstrainSelectedInstOperands,
     /*  443212 */     // GIR_Coverage, 5976,
     /*  443212 */     GIR_EraseRootFromParent_Done,
     /*  443213 */   // Label 7671: @443213
     /*  443213 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(443299), // Rule ID 5977 //
     /*  443218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  443221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  443229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  443232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  443235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443265 */     // MIs[1] Operand 1
     /*  443265 */     // No operand predicates
     /*  443265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  443274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  443277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  443294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443297 */     GIR_RootConstrainSelectedInstOperands,
     /*  443298 */     // GIR_Coverage, 5977,
     /*  443298 */     GIR_EraseRootFromParent_Done,
     /*  443299 */   // Label 7672: @443299
     /*  443299 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(443385), // Rule ID 5980 //
     /*  443304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  443315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  443318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  443321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443351 */     // MIs[1] Operand 1
     /*  443351 */     // No operand predicates
     /*  443351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443360 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  443363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443383 */     GIR_RootConstrainSelectedInstOperands,
     /*  443384 */     // GIR_Coverage, 5980,
     /*  443384 */     GIR_EraseRootFromParent_Done,
     /*  443385 */   // Label 7673: @443385
     /*  443385 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(443471), // Rule ID 5981 //
     /*  443390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  443401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  443404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  443407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443437 */     // MIs[1] Operand 1
     /*  443437 */     // No operand predicates
     /*  443437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443446 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  443449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443469 */     GIR_RootConstrainSelectedInstOperands,
     /*  443470 */     // GIR_Coverage, 5981,
     /*  443470 */     GIR_EraseRootFromParent_Done,
     /*  443471 */   // Label 7674: @443471
     /*  443471 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(443557), // Rule ID 5984 //
     /*  443476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  443487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  443490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  443493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443523 */     // MIs[1] Operand 1
     /*  443523 */     // No operand predicates
     /*  443523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443532 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  443535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443555 */     GIR_RootConstrainSelectedInstOperands,
     /*  443556 */     // GIR_Coverage, 5984,
     /*  443556 */     GIR_EraseRootFromParent_Done,
     /*  443557 */   // Label 7675: @443557
     /*  443557 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(443643), // Rule ID 5985 //
     /*  443562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  443573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  443576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  443579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443609 */     // MIs[1] Operand 1
     /*  443609 */     // No operand predicates
     /*  443609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443618 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  443621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443641 */     GIR_RootConstrainSelectedInstOperands,
     /*  443642 */     // GIR_Coverage, 5985,
     /*  443642 */     GIR_EraseRootFromParent_Done,
     /*  443643 */   // Label 7676: @443643
     /*  443643 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(443729), // Rule ID 5988 //
     /*  443648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  443659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  443662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  443665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443695 */     // MIs[1] Operand 1
     /*  443695 */     // No operand predicates
     /*  443695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443704 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  443707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443727 */     GIR_RootConstrainSelectedInstOperands,
     /*  443728 */     // GIR_Coverage, 5988,
     /*  443728 */     GIR_EraseRootFromParent_Done,
     /*  443729 */   // Label 7677: @443729
     /*  443729 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(443815), // Rule ID 5989 //
     /*  443734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  443745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  443748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  443751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443781 */     // MIs[1] Operand 1
     /*  443781 */     // No operand predicates
     /*  443781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443790 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  443793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443813 */     GIR_RootConstrainSelectedInstOperands,
     /*  443814 */     // GIR_Coverage, 5989,
     /*  443814 */     GIR_EraseRootFromParent_Done,
     /*  443815 */   // Label 7678: @443815
     /*  443815 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(443901), // Rule ID 5992 //
     /*  443820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  443831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  443834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  443837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443867 */     // MIs[1] Operand 1
     /*  443867 */     // No operand predicates
     /*  443867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  443876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  443879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443899 */     GIR_RootConstrainSelectedInstOperands,
     /*  443900 */     // GIR_Coverage, 5992,
     /*  443900 */     GIR_EraseRootFromParent_Done,
     /*  443901 */   // Label 7679: @443901
     /*  443901 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(443987), // Rule ID 5993 //
     /*  443906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  443917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  443920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  443923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443953 */     // MIs[1] Operand 1
     /*  443953 */     // No operand predicates
     /*  443953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  443962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  443965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443985 */     GIR_RootConstrainSelectedInstOperands,
     /*  443986 */     // GIR_Coverage, 5993,
     /*  443986 */     GIR_EraseRootFromParent_Done,
     /*  443987 */   // Label 7680: @443987
     /*  443987 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(444073), // Rule ID 5996 //
     /*  443992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  444003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  444006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  444009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444039 */     // MIs[1] Operand 1
     /*  444039 */     // No operand predicates
     /*  444039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444048 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  444051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444071 */     GIR_RootConstrainSelectedInstOperands,
     /*  444072 */     // GIR_Coverage, 5996,
     /*  444072 */     GIR_EraseRootFromParent_Done,
     /*  444073 */   // Label 7681: @444073
     /*  444073 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(444159), // Rule ID 5997 //
     /*  444078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  444089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  444092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  444095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444125 */     // MIs[1] Operand 1
     /*  444125 */     // No operand predicates
     /*  444125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  444137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444157 */     GIR_RootConstrainSelectedInstOperands,
     /*  444158 */     // GIR_Coverage, 5997,
     /*  444158 */     GIR_EraseRootFromParent_Done,
     /*  444159 */   // Label 7682: @444159
     /*  444159 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(444245), // Rule ID 6000 //
     /*  444164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  444175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  444178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  444181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444211 */     // MIs[1] Operand 1
     /*  444211 */     // No operand predicates
     /*  444211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444220 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  444223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444243 */     GIR_RootConstrainSelectedInstOperands,
     /*  444244 */     // GIR_Coverage, 6000,
     /*  444244 */     GIR_EraseRootFromParent_Done,
     /*  444245 */   // Label 7683: @444245
     /*  444245 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(444331), // Rule ID 6001 //
     /*  444250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  444261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  444264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  444267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444297 */     // MIs[1] Operand 1
     /*  444297 */     // No operand predicates
     /*  444297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444306 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  444309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444329 */     GIR_RootConstrainSelectedInstOperands,
     /*  444330 */     // GIR_Coverage, 6001,
     /*  444330 */     GIR_EraseRootFromParent_Done,
     /*  444331 */   // Label 7684: @444331
     /*  444331 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(444417), // Rule ID 6004 //
     /*  444336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  444353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444383 */     // MIs[1] Operand 1
     /*  444383 */     // No operand predicates
     /*  444383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  444395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444415 */     GIR_RootConstrainSelectedInstOperands,
     /*  444416 */     // GIR_Coverage, 6004,
     /*  444416 */     GIR_EraseRootFromParent_Done,
     /*  444417 */   // Label 7685: @444417
     /*  444417 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(444503), // Rule ID 6005 //
     /*  444422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  444439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444469 */     // MIs[1] Operand 1
     /*  444469 */     // No operand predicates
     /*  444469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444478 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  444481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444501 */     GIR_RootConstrainSelectedInstOperands,
     /*  444502 */     // GIR_Coverage, 6005,
     /*  444502 */     GIR_EraseRootFromParent_Done,
     /*  444503 */   // Label 7686: @444503
     /*  444503 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(444589), // Rule ID 6008 //
     /*  444508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  444519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  444522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  444525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444555 */     // MIs[1] Operand 1
     /*  444555 */     // No operand predicates
     /*  444555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444564 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  444567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444587 */     GIR_RootConstrainSelectedInstOperands,
     /*  444588 */     // GIR_Coverage, 6008,
     /*  444588 */     GIR_EraseRootFromParent_Done,
     /*  444589 */   // Label 7687: @444589
     /*  444589 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(444675), // Rule ID 6009 //
     /*  444594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  444605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  444608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  444611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444641 */     // MIs[1] Operand 1
     /*  444641 */     // No operand predicates
     /*  444641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444650 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  444653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444673 */     GIR_RootConstrainSelectedInstOperands,
     /*  444674 */     // GIR_Coverage, 6009,
     /*  444674 */     GIR_EraseRootFromParent_Done,
     /*  444675 */   // Label 7688: @444675
     /*  444675 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(444761), // Rule ID 6012 //
     /*  444680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  444691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  444694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  444697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444727 */     // MIs[1] Operand 1
     /*  444727 */     // No operand predicates
     /*  444727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444736 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  444739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444759 */     GIR_RootConstrainSelectedInstOperands,
     /*  444760 */     // GIR_Coverage, 6012,
     /*  444760 */     GIR_EraseRootFromParent_Done,
     /*  444761 */   // Label 7689: @444761
     /*  444761 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(444847), // Rule ID 6013 //
     /*  444766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  444777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  444780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  444783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444813 */     // MIs[1] Operand 1
     /*  444813 */     // No operand predicates
     /*  444813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444822 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  444825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444845 */     GIR_RootConstrainSelectedInstOperands,
     /*  444846 */     // GIR_Coverage, 6013,
     /*  444846 */     GIR_EraseRootFromParent_Done,
     /*  444847 */   // Label 7690: @444847
     /*  444847 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(444933), // Rule ID 6016 //
     /*  444852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  444855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  444863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  444866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  444869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444899 */     // MIs[1] Operand 1
     /*  444899 */     // No operand predicates
     /*  444899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  444908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  444911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  444928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444931 */     GIR_RootConstrainSelectedInstOperands,
     /*  444932 */     // GIR_Coverage, 6016,
     /*  444932 */     GIR_EraseRootFromParent_Done,
     /*  444933 */   // Label 7691: @444933
     /*  444933 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(445019), // Rule ID 6017 //
     /*  444938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  444941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  444949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  444952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  444955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444985 */     // MIs[1] Operand 1
     /*  444985 */     // No operand predicates
     /*  444985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444994 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  444994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  444997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445017 */     GIR_RootConstrainSelectedInstOperands,
     /*  445018 */     // GIR_Coverage, 6017,
     /*  445018 */     GIR_EraseRootFromParent_Done,
     /*  445019 */   // Label 7692: @445019
     /*  445019 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(445105), // Rule ID 6020 //
     /*  445024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  445027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  445032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  445035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  445038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  445041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445071 */     // MIs[1] Operand 1
     /*  445071 */     // No operand predicates
     /*  445071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445080 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  445083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445103 */     GIR_RootConstrainSelectedInstOperands,
     /*  445104 */     // GIR_Coverage, 6020,
     /*  445104 */     GIR_EraseRootFromParent_Done,
     /*  445105 */   // Label 7693: @445105
     /*  445105 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(445191), // Rule ID 6021 //
     /*  445110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  445118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  445121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  445124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  445127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445157 */     // MIs[1] Operand 1
     /*  445157 */     // No operand predicates
     /*  445157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445166 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  445169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445189 */     GIR_RootConstrainSelectedInstOperands,
     /*  445190 */     // GIR_Coverage, 6021,
     /*  445190 */     GIR_EraseRootFromParent_Done,
     /*  445191 */   // Label 7694: @445191
     /*  445191 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(445277), // Rule ID 6024 //
     /*  445196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  445199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  445204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  445213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445243 */     // MIs[1] Operand 1
     /*  445243 */     // No operand predicates
     /*  445243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445252 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  445255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445275 */     GIR_RootConstrainSelectedInstOperands,
     /*  445276 */     // GIR_Coverage, 6024,
     /*  445276 */     GIR_EraseRootFromParent_Done,
     /*  445277 */   // Label 7695: @445277
     /*  445277 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(445363), // Rule ID 6025 //
     /*  445282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  445290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  445299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445329 */     // MIs[1] Operand 1
     /*  445329 */     // No operand predicates
     /*  445329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445338 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  445341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445361 */     GIR_RootConstrainSelectedInstOperands,
     /*  445362 */     // GIR_Coverage, 6025,
     /*  445362 */     GIR_EraseRootFromParent_Done,
     /*  445363 */   // Label 7696: @445363
     /*  445363 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(445449), // Rule ID 6204 //
     /*  445368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  445379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  445382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  445385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445415 */     // MIs[1] Operand 1
     /*  445415 */     // No operand predicates
     /*  445415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445424 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  445427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445447 */     GIR_RootConstrainSelectedInstOperands,
     /*  445448 */     // GIR_Coverage, 6204,
     /*  445448 */     GIR_EraseRootFromParent_Done,
     /*  445449 */   // Label 7697: @445449
     /*  445449 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(445535), // Rule ID 6205 //
     /*  445454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  445465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  445468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  445471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445501 */     // MIs[1] Operand 1
     /*  445501 */     // No operand predicates
     /*  445501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445510 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  445513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445533 */     GIR_RootConstrainSelectedInstOperands,
     /*  445534 */     // GIR_Coverage, 6205,
     /*  445534 */     GIR_EraseRootFromParent_Done,
     /*  445535 */   // Label 7698: @445535
     /*  445535 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(445621), // Rule ID 6208 //
     /*  445540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  445551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  445554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  445557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445587 */     // MIs[1] Operand 1
     /*  445587 */     // No operand predicates
     /*  445587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445596 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  445599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445619 */     GIR_RootConstrainSelectedInstOperands,
     /*  445620 */     // GIR_Coverage, 6208,
     /*  445620 */     GIR_EraseRootFromParent_Done,
     /*  445621 */   // Label 7699: @445621
     /*  445621 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(445707), // Rule ID 6209 //
     /*  445626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  445637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  445640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  445643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445673 */     // MIs[1] Operand 1
     /*  445673 */     // No operand predicates
     /*  445673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  445685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445705 */     GIR_RootConstrainSelectedInstOperands,
     /*  445706 */     // GIR_Coverage, 6209,
     /*  445706 */     GIR_EraseRootFromParent_Done,
     /*  445707 */   // Label 7700: @445707
     /*  445707 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(445793), // Rule ID 6212 //
     /*  445712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  445723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  445726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  445729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445759 */     // MIs[1] Operand 1
     /*  445759 */     // No operand predicates
     /*  445759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445768 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  445771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445791 */     GIR_RootConstrainSelectedInstOperands,
     /*  445792 */     // GIR_Coverage, 6212,
     /*  445792 */     GIR_EraseRootFromParent_Done,
     /*  445793 */   // Label 7701: @445793
     /*  445793 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(445879), // Rule ID 6213 //
     /*  445798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  445809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  445812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  445815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445845 */     // MIs[1] Operand 1
     /*  445845 */     // No operand predicates
     /*  445845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445854 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  445857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445877 */     GIR_RootConstrainSelectedInstOperands,
     /*  445878 */     // GIR_Coverage, 6213,
     /*  445878 */     GIR_EraseRootFromParent_Done,
     /*  445879 */   // Label 7702: @445879
     /*  445879 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(445965), // Rule ID 6216 //
     /*  445884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  445895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  445898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  445901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445931 */     // MIs[1] Operand 1
     /*  445931 */     // No operand predicates
     /*  445931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445940 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  445940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  445943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  445960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445963 */     GIR_RootConstrainSelectedInstOperands,
     /*  445964 */     // GIR_Coverage, 6216,
     /*  445964 */     GIR_EraseRootFromParent_Done,
     /*  445965 */   // Label 7703: @445965
     /*  445965 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(446051), // Rule ID 6217 //
     /*  445970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  445981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  445984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  445987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446017 */     // MIs[1] Operand 1
     /*  446017 */     // No operand predicates
     /*  446017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  446029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446049 */     GIR_RootConstrainSelectedInstOperands,
     /*  446050 */     // GIR_Coverage, 6217,
     /*  446050 */     GIR_EraseRootFromParent_Done,
     /*  446051 */   // Label 7704: @446051
     /*  446051 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(446137), // Rule ID 6220 //
     /*  446056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  446067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  446070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  446073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446103 */     // MIs[1] Operand 1
     /*  446103 */     // No operand predicates
     /*  446103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446112 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  446115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446135 */     GIR_RootConstrainSelectedInstOperands,
     /*  446136 */     // GIR_Coverage, 6220,
     /*  446136 */     GIR_EraseRootFromParent_Done,
     /*  446137 */   // Label 7705: @446137
     /*  446137 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(446223), // Rule ID 6221 //
     /*  446142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  446153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  446156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  446159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446189 */     // MIs[1] Operand 1
     /*  446189 */     // No operand predicates
     /*  446189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446198 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  446201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446221 */     GIR_RootConstrainSelectedInstOperands,
     /*  446222 */     // GIR_Coverage, 6221,
     /*  446222 */     GIR_EraseRootFromParent_Done,
     /*  446223 */   // Label 7706: @446223
     /*  446223 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(446309), // Rule ID 6224 //
     /*  446228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  446245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446275 */     // MIs[1] Operand 1
     /*  446275 */     // No operand predicates
     /*  446275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446284 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  446284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  446287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446307 */     GIR_RootConstrainSelectedInstOperands,
     /*  446308 */     // GIR_Coverage, 6224,
     /*  446308 */     GIR_EraseRootFromParent_Done,
     /*  446309 */   // Label 7707: @446309
     /*  446309 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(446395), // Rule ID 6225 //
     /*  446314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  446331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446361 */     // MIs[1] Operand 1
     /*  446361 */     // No operand predicates
     /*  446361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  446370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  446373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446393 */     GIR_RootConstrainSelectedInstOperands,
     /*  446394 */     // GIR_Coverage, 6225,
     /*  446394 */     GIR_EraseRootFromParent_Done,
     /*  446395 */   // Label 7708: @446395
     /*  446395 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(446481), // Rule ID 6228 //
     /*  446400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  446411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  446414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  446417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446447 */     // MIs[1] Operand 1
     /*  446447 */     // No operand predicates
     /*  446447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446456 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446479 */     GIR_RootConstrainSelectedInstOperands,
     /*  446480 */     // GIR_Coverage, 6228,
     /*  446480 */     GIR_EraseRootFromParent_Done,
     /*  446481 */   // Label 7709: @446481
     /*  446481 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(446567), // Rule ID 6229 //
     /*  446486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  446497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  446500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  446503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446533 */     // MIs[1] Operand 1
     /*  446533 */     // No operand predicates
     /*  446533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446542 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  446542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446565 */     GIR_RootConstrainSelectedInstOperands,
     /*  446566 */     // GIR_Coverage, 6229,
     /*  446566 */     GIR_EraseRootFromParent_Done,
     /*  446567 */   // Label 7710: @446567
     /*  446567 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(446653), // Rule ID 6232 //
     /*  446572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  446583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  446586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  446589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446619 */     // MIs[1] Operand 1
     /*  446619 */     // No operand predicates
     /*  446619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446628 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446651 */     GIR_RootConstrainSelectedInstOperands,
     /*  446652 */     // GIR_Coverage, 6232,
     /*  446652 */     GIR_EraseRootFromParent_Done,
     /*  446653 */   // Label 7711: @446653
     /*  446653 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(446739), // Rule ID 6233 //
     /*  446658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  446669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  446672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  446675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446705 */     // MIs[1] Operand 1
     /*  446705 */     // No operand predicates
     /*  446705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446737 */     GIR_RootConstrainSelectedInstOperands,
     /*  446738 */     // GIR_Coverage, 6233,
     /*  446738 */     GIR_EraseRootFromParent_Done,
     /*  446739 */   // Label 7712: @446739
     /*  446739 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(446825), // Rule ID 6236 //
     /*  446744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  446755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  446758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  446761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446791 */     // MIs[1] Operand 1
     /*  446791 */     // No operand predicates
     /*  446791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  446800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446823 */     GIR_RootConstrainSelectedInstOperands,
     /*  446824 */     // GIR_Coverage, 6236,
     /*  446824 */     GIR_EraseRootFromParent_Done,
     /*  446825 */   // Label 7713: @446825
     /*  446825 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(446911), // Rule ID 6237 //
     /*  446830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  446841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  446844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  446847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446877 */     // MIs[1] Operand 1
     /*  446877 */     // No operand predicates
     /*  446877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  446886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446909 */     GIR_RootConstrainSelectedInstOperands,
     /*  446910 */     // GIR_Coverage, 6237,
     /*  446910 */     GIR_EraseRootFromParent_Done,
     /*  446911 */   // Label 7714: @446911
     /*  446911 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(446997), // Rule ID 6240 //
     /*  446916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  446919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  446927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  446930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  446933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446963 */     // MIs[1] Operand 1
     /*  446963 */     // No operand predicates
     /*  446963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446972 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  446972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  446992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446995 */     GIR_RootConstrainSelectedInstOperands,
     /*  446996 */     // GIR_Coverage, 6240,
     /*  446996 */     GIR_EraseRootFromParent_Done,
     /*  446997 */   // Label 7715: @446997
     /*  446997 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(447083), // Rule ID 6241 //
     /*  447002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  447005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  447013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  447016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  447019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447049 */     // MIs[1] Operand 1
     /*  447049 */     // No operand predicates
     /*  447049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447058 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  447058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  447061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  447078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447081 */     GIR_RootConstrainSelectedInstOperands,
     /*  447082 */     // GIR_Coverage, 6241,
     /*  447082 */     GIR_EraseRootFromParent_Done,
     /*  447083 */   // Label 7716: @447083
     /*  447083 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(447169), // Rule ID 6244 //
     /*  447088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  447099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  447102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  447105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447135 */     // MIs[1] Operand 1
     /*  447135 */     // No operand predicates
     /*  447135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447144 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  447147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447167 */     GIR_RootConstrainSelectedInstOperands,
     /*  447168 */     // GIR_Coverage, 6244,
     /*  447168 */     GIR_EraseRootFromParent_Done,
     /*  447169 */   // Label 7717: @447169
     /*  447169 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(447255), // Rule ID 6245 //
     /*  447174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  447185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  447188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  447191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447221 */     // MIs[1] Operand 1
     /*  447221 */     // No operand predicates
     /*  447221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  447233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447253 */     GIR_RootConstrainSelectedInstOperands,
     /*  447254 */     // GIR_Coverage, 6245,
     /*  447254 */     GIR_EraseRootFromParent_Done,
     /*  447255 */   // Label 7718: @447255
     /*  447255 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(447341), // Rule ID 6248 //
     /*  447260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  447271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  447274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  447277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447307 */     // MIs[1] Operand 1
     /*  447307 */     // No operand predicates
     /*  447307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447316 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  447319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447339 */     GIR_RootConstrainSelectedInstOperands,
     /*  447340 */     // GIR_Coverage, 6248,
     /*  447340 */     GIR_EraseRootFromParent_Done,
     /*  447341 */   // Label 7719: @447341
     /*  447341 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(447427), // Rule ID 6249 //
     /*  447346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  447357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  447360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  447363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447393 */     // MIs[1] Operand 1
     /*  447393 */     // No operand predicates
     /*  447393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447402 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  447405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447425 */     GIR_RootConstrainSelectedInstOperands,
     /*  447426 */     // GIR_Coverage, 6249,
     /*  447426 */     GIR_EraseRootFromParent_Done,
     /*  447427 */   // Label 7720: @447427
     /*  447427 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(447513), // Rule ID 6252 //
     /*  447432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  447443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  447446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  447449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447479 */     // MIs[1] Operand 1
     /*  447479 */     // No operand predicates
     /*  447479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447488 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  447491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447511 */     GIR_RootConstrainSelectedInstOperands,
     /*  447512 */     // GIR_Coverage, 6252,
     /*  447512 */     GIR_EraseRootFromParent_Done,
     /*  447513 */   // Label 7721: @447513
     /*  447513 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(447599), // Rule ID 6253 //
     /*  447518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  447529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  447532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  447535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447565 */     // MIs[1] Operand 1
     /*  447565 */     // No operand predicates
     /*  447565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447574 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  447577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447597 */     GIR_RootConstrainSelectedInstOperands,
     /*  447598 */     // GIR_Coverage, 6253,
     /*  447598 */     GIR_EraseRootFromParent_Done,
     /*  447599 */   // Label 7722: @447599
     /*  447599 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(447685), // Rule ID 6256 //
     /*  447604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  447615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  447618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  447621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447651 */     // MIs[1] Operand 1
     /*  447651 */     // No operand predicates
     /*  447651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  447663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447683 */     GIR_RootConstrainSelectedInstOperands,
     /*  447684 */     // GIR_Coverage, 6256,
     /*  447684 */     GIR_EraseRootFromParent_Done,
     /*  447685 */   // Label 7723: @447685
     /*  447685 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(447771), // Rule ID 6257 //
     /*  447690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  447701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  447704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  447707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447737 */     // MIs[1] Operand 1
     /*  447737 */     // No operand predicates
     /*  447737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  447746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  447749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447769 */     GIR_RootConstrainSelectedInstOperands,
     /*  447770 */     // GIR_Coverage, 6257,
     /*  447770 */     GIR_EraseRootFromParent_Done,
     /*  447771 */   // Label 7724: @447771
     /*  447771 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(447857), // Rule ID 6260 //
     /*  447776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  447787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  447790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  447793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447823 */     // MIs[1] Operand 1
     /*  447823 */     // No operand predicates
     /*  447823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447832 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  447835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447855 */     GIR_RootConstrainSelectedInstOperands,
     /*  447856 */     // GIR_Coverage, 6260,
     /*  447856 */     GIR_EraseRootFromParent_Done,
     /*  447857 */   // Label 7725: @447857
     /*  447857 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(447943), // Rule ID 6261 //
     /*  447862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  447873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  447876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  447879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447909 */     // MIs[1] Operand 1
     /*  447909 */     // No operand predicates
     /*  447909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  447918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  447921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447941 */     GIR_RootConstrainSelectedInstOperands,
     /*  447942 */     // GIR_Coverage, 6261,
     /*  447942 */     GIR_EraseRootFromParent_Done,
     /*  447943 */   // Label 7726: @447943
     /*  447943 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(448029), // Rule ID 6264 //
     /*  447948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  447959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  447962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  447965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447995 */     // MIs[1] Operand 1
     /*  447995 */     // No operand predicates
     /*  447995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448004 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  448004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  448007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448027 */     GIR_RootConstrainSelectedInstOperands,
     /*  448028 */     // GIR_Coverage, 6264,
     /*  448028 */     GIR_EraseRootFromParent_Done,
     /*  448029 */   // Label 7727: @448029
     /*  448029 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(448115), // Rule ID 6265 //
     /*  448034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  448045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  448048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  448051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448081 */     // MIs[1] Operand 1
     /*  448081 */     // No operand predicates
     /*  448081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448090 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  448093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448113 */     GIR_RootConstrainSelectedInstOperands,
     /*  448114 */     // GIR_Coverage, 6265,
     /*  448114 */     GIR_EraseRootFromParent_Done,
     /*  448115 */   // Label 7728: @448115
     /*  448115 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(448201), // Rule ID 6268 //
     /*  448120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  448137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448167 */     // MIs[1] Operand 1
     /*  448167 */     // No operand predicates
     /*  448167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  448179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448199 */     GIR_RootConstrainSelectedInstOperands,
     /*  448200 */     // GIR_Coverage, 6268,
     /*  448200 */     GIR_EraseRootFromParent_Done,
     /*  448201 */   // Label 7729: @448201
     /*  448201 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(448287), // Rule ID 6269 //
     /*  448206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  448223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448253 */     // MIs[1] Operand 1
     /*  448253 */     // No operand predicates
     /*  448253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  448265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448285 */     GIR_RootConstrainSelectedInstOperands,
     /*  448286 */     // GIR_Coverage, 6269,
     /*  448286 */     GIR_EraseRootFromParent_Done,
     /*  448287 */   // Label 7730: @448287
     /*  448287 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(448373), // Rule ID 6272 //
     /*  448292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  448309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448339 */     // MIs[1] Operand 1
     /*  448339 */     // No operand predicates
     /*  448339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448348 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  448351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448371 */     GIR_RootConstrainSelectedInstOperands,
     /*  448372 */     // GIR_Coverage, 6272,
     /*  448372 */     GIR_EraseRootFromParent_Done,
     /*  448373 */   // Label 7731: @448373
     /*  448373 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(448459), // Rule ID 6273 //
     /*  448378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  448395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448425 */     // MIs[1] Operand 1
     /*  448425 */     // No operand predicates
     /*  448425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  448437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448457 */     GIR_RootConstrainSelectedInstOperands,
     /*  448458 */     // GIR_Coverage, 6273,
     /*  448458 */     GIR_EraseRootFromParent_Done,
     /*  448459 */   // Label 7732: @448459
     /*  448459 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(448545), // Rule ID 6276 //
     /*  448464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  448481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448511 */     // MIs[1] Operand 1
     /*  448511 */     // No operand predicates
     /*  448511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448520 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  448523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448543 */     GIR_RootConstrainSelectedInstOperands,
     /*  448544 */     // GIR_Coverage, 6276,
     /*  448544 */     GIR_EraseRootFromParent_Done,
     /*  448545 */   // Label 7733: @448545
     /*  448545 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(448631), // Rule ID 6277 //
     /*  448550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  448567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448597 */     // MIs[1] Operand 1
     /*  448597 */     // No operand predicates
     /*  448597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448606 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  448609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448629 */     GIR_RootConstrainSelectedInstOperands,
     /*  448630 */     // GIR_Coverage, 6277,
     /*  448630 */     GIR_EraseRootFromParent_Done,
     /*  448631 */   // Label 7734: @448631
     /*  448631 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(448717), // Rule ID 6280 //
     /*  448636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  448647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  448650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  448653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448683 */     // MIs[1] Operand 1
     /*  448683 */     // No operand predicates
     /*  448683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  448692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  448695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448715 */     GIR_RootConstrainSelectedInstOperands,
     /*  448716 */     // GIR_Coverage, 6280,
     /*  448716 */     GIR_EraseRootFromParent_Done,
     /*  448717 */   // Label 7735: @448717
     /*  448717 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(448803), // Rule ID 6281 //
     /*  448722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  448725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  448733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  448736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  448739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448769 */     // MIs[1] Operand 1
     /*  448769 */     // No operand predicates
     /*  448769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  448778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  448781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448801 */     GIR_RootConstrainSelectedInstOperands,
     /*  448802 */     // GIR_Coverage, 6281,
     /*  448802 */     GIR_EraseRootFromParent_Done,
     /*  448803 */   // Label 7736: @448803
     /*  448803 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(448889), // Rule ID 6284 //
     /*  448808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  448819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  448822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  448825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448855 */     // MIs[1] Operand 1
     /*  448855 */     // No operand predicates
     /*  448855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448864 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  448864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  448867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448887 */     GIR_RootConstrainSelectedInstOperands,
     /*  448888 */     // GIR_Coverage, 6284,
     /*  448888 */     GIR_EraseRootFromParent_Done,
     /*  448889 */   // Label 7737: @448889
     /*  448889 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(448975), // Rule ID 6285 //
     /*  448894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  448897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  448905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  448908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  448911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448941 */     // MIs[1] Operand 1
     /*  448941 */     // No operand predicates
     /*  448941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  448950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  448953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448973 */     GIR_RootConstrainSelectedInstOperands,
     /*  448974 */     // GIR_Coverage, 6285,
     /*  448974 */     GIR_EraseRootFromParent_Done,
     /*  448975 */   // Label 7738: @448975
     /*  448975 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(449061), // Rule ID 6288 //
     /*  448980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  448991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  448994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  448997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449027 */     // MIs[1] Operand 1
     /*  449027 */     // No operand predicates
     /*  449027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449036 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  449036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  449039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449059 */     GIR_RootConstrainSelectedInstOperands,
     /*  449060 */     // GIR_Coverage, 6288,
     /*  449060 */     GIR_EraseRootFromParent_Done,
     /*  449061 */   // Label 7739: @449061
     /*  449061 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(449147), // Rule ID 6289 //
     /*  449066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  449069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  449074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  449077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  449080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  449083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449113 */     // MIs[1] Operand 1
     /*  449113 */     // No operand predicates
     /*  449113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449122 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  449122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  449125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449145 */     GIR_RootConstrainSelectedInstOperands,
     /*  449146 */     // GIR_Coverage, 6289,
     /*  449146 */     GIR_EraseRootFromParent_Done,
     /*  449147 */   // Label 7740: @449147
     /*  449147 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(449233), // Rule ID 6468 //
     /*  449152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  449163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  449166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  449169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449199 */     // MIs[1] Operand 1
     /*  449199 */     // No operand predicates
     /*  449199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449208 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  449211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449231 */     GIR_RootConstrainSelectedInstOperands,
     /*  449232 */     // GIR_Coverage, 6468,
     /*  449232 */     GIR_EraseRootFromParent_Done,
     /*  449233 */   // Label 7741: @449233
     /*  449233 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(449319), // Rule ID 6469 //
     /*  449238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  449249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  449252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  449255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449285 */     // MIs[1] Operand 1
     /*  449285 */     // No operand predicates
     /*  449285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449294 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  449297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449317 */     GIR_RootConstrainSelectedInstOperands,
     /*  449318 */     // GIR_Coverage, 6469,
     /*  449318 */     GIR_EraseRootFromParent_Done,
     /*  449319 */   // Label 7742: @449319
     /*  449319 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(449405), // Rule ID 6472 //
     /*  449324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  449335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  449338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  449341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449371 */     // MIs[1] Operand 1
     /*  449371 */     // No operand predicates
     /*  449371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449380 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  449383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449403 */     GIR_RootConstrainSelectedInstOperands,
     /*  449404 */     // GIR_Coverage, 6472,
     /*  449404 */     GIR_EraseRootFromParent_Done,
     /*  449405 */   // Label 7743: @449405
     /*  449405 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(449491), // Rule ID 6473 //
     /*  449410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  449421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  449424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  449427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449457 */     // MIs[1] Operand 1
     /*  449457 */     // No operand predicates
     /*  449457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449466 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  449469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449489 */     GIR_RootConstrainSelectedInstOperands,
     /*  449490 */     // GIR_Coverage, 6473,
     /*  449490 */     GIR_EraseRootFromParent_Done,
     /*  449491 */   // Label 7744: @449491
     /*  449491 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(449577), // Rule ID 6476 //
     /*  449496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  449507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  449510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  449513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449543 */     // MIs[1] Operand 1
     /*  449543 */     // No operand predicates
     /*  449543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449552 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  449555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449575 */     GIR_RootConstrainSelectedInstOperands,
     /*  449576 */     // GIR_Coverage, 6476,
     /*  449576 */     GIR_EraseRootFromParent_Done,
     /*  449577 */   // Label 7745: @449577
     /*  449577 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(449663), // Rule ID 6477 //
     /*  449582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  449593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  449596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  449599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449629 */     // MIs[1] Operand 1
     /*  449629 */     // No operand predicates
     /*  449629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449638 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  449641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449661 */     GIR_RootConstrainSelectedInstOperands,
     /*  449662 */     // GIR_Coverage, 6477,
     /*  449662 */     GIR_EraseRootFromParent_Done,
     /*  449663 */   // Label 7746: @449663
     /*  449663 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(449749), // Rule ID 6480 //
     /*  449668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  449679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  449682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  449685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449715 */     // MIs[1] Operand 1
     /*  449715 */     // No operand predicates
     /*  449715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449724 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  449724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  449727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449747 */     GIR_RootConstrainSelectedInstOperands,
     /*  449748 */     // GIR_Coverage, 6480,
     /*  449748 */     GIR_EraseRootFromParent_Done,
     /*  449749 */   // Label 7747: @449749
     /*  449749 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(449835), // Rule ID 6481 //
     /*  449754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  449765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  449768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  449771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449801 */     // MIs[1] Operand 1
     /*  449801 */     // No operand predicates
     /*  449801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449810 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  449810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  449813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449833 */     GIR_RootConstrainSelectedInstOperands,
     /*  449834 */     // GIR_Coverage, 6481,
     /*  449834 */     GIR_EraseRootFromParent_Done,
     /*  449835 */   // Label 7748: @449835
     /*  449835 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(449921), // Rule ID 6484 //
     /*  449840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  449851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  449854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  449857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449887 */     // MIs[1] Operand 1
     /*  449887 */     // No operand predicates
     /*  449887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  449896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  449899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449919 */     GIR_RootConstrainSelectedInstOperands,
     /*  449920 */     // GIR_Coverage, 6484,
     /*  449920 */     GIR_EraseRootFromParent_Done,
     /*  449921 */   // Label 7749: @449921
     /*  449921 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(450007), // Rule ID 6485 //
     /*  449926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  449937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  449940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  449943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449973 */     // MIs[1] Operand 1
     /*  449973 */     // No operand predicates
     /*  449973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449982 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  449982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  449985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450005 */     GIR_RootConstrainSelectedInstOperands,
     /*  450006 */     // GIR_Coverage, 6485,
     /*  450006 */     GIR_EraseRootFromParent_Done,
     /*  450007 */   // Label 7750: @450007
     /*  450007 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(450093), // Rule ID 6488 //
     /*  450012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  450023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  450026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  450029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450059 */     // MIs[1] Operand 1
     /*  450059 */     // No operand predicates
     /*  450059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450068 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  450068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  450071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450091 */     GIR_RootConstrainSelectedInstOperands,
     /*  450092 */     // GIR_Coverage, 6488,
     /*  450092 */     GIR_EraseRootFromParent_Done,
     /*  450093 */   // Label 7751: @450093
     /*  450093 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(450179), // Rule ID 6489 //
     /*  450098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  450109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  450112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  450115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450145 */     // MIs[1] Operand 1
     /*  450145 */     // No operand predicates
     /*  450145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450154 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  450154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  450157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450177 */     GIR_RootConstrainSelectedInstOperands,
     /*  450178 */     // GIR_Coverage, 6489,
     /*  450178 */     GIR_EraseRootFromParent_Done,
     /*  450179 */   // Label 7752: @450179
     /*  450179 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(450265), // Rule ID 6492 //
     /*  450184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  450195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  450198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  450201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450231 */     // MIs[1] Operand 1
     /*  450231 */     // No operand predicates
     /*  450231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450240 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450263 */     GIR_RootConstrainSelectedInstOperands,
     /*  450264 */     // GIR_Coverage, 6492,
     /*  450264 */     GIR_EraseRootFromParent_Done,
     /*  450265 */   // Label 7753: @450265
     /*  450265 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(450351), // Rule ID 6493 //
     /*  450270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  450281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  450284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  450287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450317 */     // MIs[1] Operand 1
     /*  450317 */     // No operand predicates
     /*  450317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450326 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450349 */     GIR_RootConstrainSelectedInstOperands,
     /*  450350 */     // GIR_Coverage, 6493,
     /*  450350 */     GIR_EraseRootFromParent_Done,
     /*  450351 */   // Label 7754: @450351
     /*  450351 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(450437), // Rule ID 6496 //
     /*  450356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  450367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  450370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  450373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450403 */     // MIs[1] Operand 1
     /*  450403 */     // No operand predicates
     /*  450403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450412 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450435 */     GIR_RootConstrainSelectedInstOperands,
     /*  450436 */     // GIR_Coverage, 6496,
     /*  450436 */     GIR_EraseRootFromParent_Done,
     /*  450437 */   // Label 7755: @450437
     /*  450437 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(450523), // Rule ID 6497 //
     /*  450442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  450453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  450456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  450459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450489 */     // MIs[1] Operand 1
     /*  450489 */     // No operand predicates
     /*  450489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450521 */     GIR_RootConstrainSelectedInstOperands,
     /*  450522 */     // GIR_Coverage, 6497,
     /*  450522 */     GIR_EraseRootFromParent_Done,
     /*  450523 */   // Label 7756: @450523
     /*  450523 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(450609), // Rule ID 6500 //
     /*  450528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  450539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  450542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  450545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450575 */     // MIs[1] Operand 1
     /*  450575 */     // No operand predicates
     /*  450575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  450584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450607 */     GIR_RootConstrainSelectedInstOperands,
     /*  450608 */     // GIR_Coverage, 6500,
     /*  450608 */     GIR_EraseRootFromParent_Done,
     /*  450609 */   // Label 7757: @450609
     /*  450609 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(450695), // Rule ID 6501 //
     /*  450614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  450625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  450628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  450631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450661 */     // MIs[1] Operand 1
     /*  450661 */     // No operand predicates
     /*  450661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  450670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450693 */     GIR_RootConstrainSelectedInstOperands,
     /*  450694 */     // GIR_Coverage, 6501,
     /*  450694 */     GIR_EraseRootFromParent_Done,
     /*  450695 */   // Label 7758: @450695
     /*  450695 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(450781), // Rule ID 6504 //
     /*  450700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  450703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  450711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  450714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  450717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450747 */     // MIs[1] Operand 1
     /*  450747 */     // No operand predicates
     /*  450747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450756 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  450756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  450776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450779 */     GIR_RootConstrainSelectedInstOperands,
     /*  450780 */     // GIR_Coverage, 6504,
     /*  450780 */     GIR_EraseRootFromParent_Done,
     /*  450781 */   // Label 7759: @450781
     /*  450781 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(450867), // Rule ID 6505 //
     /*  450786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  450789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  450797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  450800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  450803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450833 */     // MIs[1] Operand 1
     /*  450833 */     // No operand predicates
     /*  450833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450842 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  450842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  450862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450865 */     GIR_RootConstrainSelectedInstOperands,
     /*  450866 */     // GIR_Coverage, 6505,
     /*  450866 */     GIR_EraseRootFromParent_Done,
     /*  450867 */   // Label 7760: @450867
     /*  450867 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(450953), // Rule ID 6508 //
     /*  450872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  450883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  450886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  450889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450919 */     // MIs[1] Operand 1
     /*  450919 */     // No operand predicates
     /*  450919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450928 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  450931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450951 */     GIR_RootConstrainSelectedInstOperands,
     /*  450952 */     // GIR_Coverage, 6508,
     /*  450952 */     GIR_EraseRootFromParent_Done,
     /*  450953 */   // Label 7761: @450953
     /*  450953 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(451039), // Rule ID 6509 //
     /*  450958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  450969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  450972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  450975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451005 */     // MIs[1] Operand 1
     /*  451005 */     // No operand predicates
     /*  451005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  451017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451037 */     GIR_RootConstrainSelectedInstOperands,
     /*  451038 */     // GIR_Coverage, 6509,
     /*  451038 */     GIR_EraseRootFromParent_Done,
     /*  451039 */   // Label 7762: @451039
     /*  451039 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(451125), // Rule ID 6512 //
     /*  451044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  451055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  451058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  451061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451091 */     // MIs[1] Operand 1
     /*  451091 */     // No operand predicates
     /*  451091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451100 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  451103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451123 */     GIR_RootConstrainSelectedInstOperands,
     /*  451124 */     // GIR_Coverage, 6512,
     /*  451124 */     GIR_EraseRootFromParent_Done,
     /*  451125 */   // Label 7763: @451125
     /*  451125 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(451211), // Rule ID 6513 //
     /*  451130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  451141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  451144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  451147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451177 */     // MIs[1] Operand 1
     /*  451177 */     // No operand predicates
     /*  451177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451186 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  451189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451209 */     GIR_RootConstrainSelectedInstOperands,
     /*  451210 */     // GIR_Coverage, 6513,
     /*  451210 */     GIR_EraseRootFromParent_Done,
     /*  451211 */   // Label 7764: @451211
     /*  451211 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(451297), // Rule ID 6516 //
     /*  451216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  451227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  451230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  451233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451263 */     // MIs[1] Operand 1
     /*  451263 */     // No operand predicates
     /*  451263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451272 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  451275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451295 */     GIR_RootConstrainSelectedInstOperands,
     /*  451296 */     // GIR_Coverage, 6516,
     /*  451296 */     GIR_EraseRootFromParent_Done,
     /*  451297 */   // Label 7765: @451297
     /*  451297 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(451383), // Rule ID 6517 //
     /*  451302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  451313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  451316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  451319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451349 */     // MIs[1] Operand 1
     /*  451349 */     // No operand predicates
     /*  451349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451358 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  451361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451381 */     GIR_RootConstrainSelectedInstOperands,
     /*  451382 */     // GIR_Coverage, 6517,
     /*  451382 */     GIR_EraseRootFromParent_Done,
     /*  451383 */   // Label 7766: @451383
     /*  451383 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(451469), // Rule ID 6520 //
     /*  451388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  451399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  451402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  451405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451435 */     // MIs[1] Operand 1
     /*  451435 */     // No operand predicates
     /*  451435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  451447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451467 */     GIR_RootConstrainSelectedInstOperands,
     /*  451468 */     // GIR_Coverage, 6520,
     /*  451468 */     GIR_EraseRootFromParent_Done,
     /*  451469 */   // Label 7767: @451469
     /*  451469 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(451555), // Rule ID 6521 //
     /*  451474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  451485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  451488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  451491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451521 */     // MIs[1] Operand 1
     /*  451521 */     // No operand predicates
     /*  451521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451530 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  451533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451553 */     GIR_RootConstrainSelectedInstOperands,
     /*  451554 */     // GIR_Coverage, 6521,
     /*  451554 */     GIR_EraseRootFromParent_Done,
     /*  451555 */   // Label 7768: @451555
     /*  451555 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(451641), // Rule ID 6524 //
     /*  451560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  451571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  451574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  451577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451607 */     // MIs[1] Operand 1
     /*  451607 */     // No operand predicates
     /*  451607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451616 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  451619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451639 */     GIR_RootConstrainSelectedInstOperands,
     /*  451640 */     // GIR_Coverage, 6524,
     /*  451640 */     GIR_EraseRootFromParent_Done,
     /*  451641 */   // Label 7769: @451641
     /*  451641 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(451727), // Rule ID 6525 //
     /*  451646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  451657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  451660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  451663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451693 */     // MIs[1] Operand 1
     /*  451693 */     // No operand predicates
     /*  451693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451702 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  451705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451725 */     GIR_RootConstrainSelectedInstOperands,
     /*  451726 */     // GIR_Coverage, 6525,
     /*  451726 */     GIR_EraseRootFromParent_Done,
     /*  451727 */   // Label 7770: @451727
     /*  451727 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(451813), // Rule ID 6528 //
     /*  451732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  451743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  451746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  451749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451779 */     // MIs[1] Operand 1
     /*  451779 */     // No operand predicates
     /*  451779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451788 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  451791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451811 */     GIR_RootConstrainSelectedInstOperands,
     /*  451812 */     // GIR_Coverage, 6528,
     /*  451812 */     GIR_EraseRootFromParent_Done,
     /*  451813 */   // Label 7771: @451813
     /*  451813 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(451899), // Rule ID 6529 //
     /*  451818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  451829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  451832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  451835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451865 */     // MIs[1] Operand 1
     /*  451865 */     // No operand predicates
     /*  451865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451874 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  451877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451897 */     GIR_RootConstrainSelectedInstOperands,
     /*  451898 */     // GIR_Coverage, 6529,
     /*  451898 */     GIR_EraseRootFromParent_Done,
     /*  451899 */   // Label 7772: @451899
     /*  451899 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(451985), // Rule ID 6532 //
     /*  451904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  451915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  451918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  451921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451951 */     // MIs[1] Operand 1
     /*  451951 */     // No operand predicates
     /*  451951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451960 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  451960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  451963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451983 */     GIR_RootConstrainSelectedInstOperands,
     /*  451984 */     // GIR_Coverage, 6532,
     /*  451984 */     GIR_EraseRootFromParent_Done,
     /*  451985 */   // Label 7773: @451985
     /*  451985 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(452071), // Rule ID 6533 //
     /*  451990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  452001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  452004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  452007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452037 */     // MIs[1] Operand 1
     /*  452037 */     // No operand predicates
     /*  452037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452046 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  452049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452069 */     GIR_RootConstrainSelectedInstOperands,
     /*  452070 */     // GIR_Coverage, 6533,
     /*  452070 */     GIR_EraseRootFromParent_Done,
     /*  452071 */   // Label 7774: @452071
     /*  452071 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(452157), // Rule ID 6536 //
     /*  452076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  452087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  452090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  452093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452123 */     // MIs[1] Operand 1
     /*  452123 */     // No operand predicates
     /*  452123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452132 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  452135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452155 */     GIR_RootConstrainSelectedInstOperands,
     /*  452156 */     // GIR_Coverage, 6536,
     /*  452156 */     GIR_EraseRootFromParent_Done,
     /*  452157 */   // Label 7775: @452157
     /*  452157 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(452243), // Rule ID 6537 //
     /*  452162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  452173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  452176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  452179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452209 */     // MIs[1] Operand 1
     /*  452209 */     // No operand predicates
     /*  452209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  452221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452241 */     GIR_RootConstrainSelectedInstOperands,
     /*  452242 */     // GIR_Coverage, 6537,
     /*  452242 */     GIR_EraseRootFromParent_Done,
     /*  452243 */   // Label 7776: @452243
     /*  452243 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(452329), // Rule ID 6540 //
     /*  452248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  452259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  452262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  452265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452295 */     // MIs[1] Operand 1
     /*  452295 */     // No operand predicates
     /*  452295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452304 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  452307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452327 */     GIR_RootConstrainSelectedInstOperands,
     /*  452328 */     // GIR_Coverage, 6540,
     /*  452328 */     GIR_EraseRootFromParent_Done,
     /*  452329 */   // Label 7777: @452329
     /*  452329 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(452415), // Rule ID 6541 //
     /*  452334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  452345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  452348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  452351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452381 */     // MIs[1] Operand 1
     /*  452381 */     // No operand predicates
     /*  452381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452390 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  452393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452413 */     GIR_RootConstrainSelectedInstOperands,
     /*  452414 */     // GIR_Coverage, 6541,
     /*  452414 */     GIR_EraseRootFromParent_Done,
     /*  452415 */   // Label 7778: @452415
     /*  452415 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(452501), // Rule ID 6544 //
     /*  452420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  452431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  452434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  452437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452467 */     // MIs[1] Operand 1
     /*  452467 */     // No operand predicates
     /*  452467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  452479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452499 */     GIR_RootConstrainSelectedInstOperands,
     /*  452500 */     // GIR_Coverage, 6544,
     /*  452500 */     GIR_EraseRootFromParent_Done,
     /*  452501 */   // Label 7779: @452501
     /*  452501 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(452587), // Rule ID 6545 //
     /*  452506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  452517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  452520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  452523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452553 */     // MIs[1] Operand 1
     /*  452553 */     // No operand predicates
     /*  452553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452562 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  452565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452585 */     GIR_RootConstrainSelectedInstOperands,
     /*  452586 */     // GIR_Coverage, 6545,
     /*  452586 */     GIR_EraseRootFromParent_Done,
     /*  452587 */   // Label 7780: @452587
     /*  452587 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(452673), // Rule ID 6548 //
     /*  452592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  452603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  452606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  452609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452639 */     // MIs[1] Operand 1
     /*  452639 */     // No operand predicates
     /*  452639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452648 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  452651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452671 */     GIR_RootConstrainSelectedInstOperands,
     /*  452672 */     // GIR_Coverage, 6548,
     /*  452672 */     GIR_EraseRootFromParent_Done,
     /*  452673 */   // Label 7781: @452673
     /*  452673 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(452759), // Rule ID 6549 //
     /*  452678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  452689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  452692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  452695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452725 */     // MIs[1] Operand 1
     /*  452725 */     // No operand predicates
     /*  452725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  452737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452757 */     GIR_RootConstrainSelectedInstOperands,
     /*  452758 */     // GIR_Coverage, 6549,
     /*  452758 */     GIR_EraseRootFromParent_Done,
     /*  452759 */   // Label 7782: @452759
     /*  452759 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(452845), // Rule ID 6552 //
     /*  452764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  452775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  452778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  452781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452811 */     // MIs[1] Operand 1
     /*  452811 */     // No operand predicates
     /*  452811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452820 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  452823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452843 */     GIR_RootConstrainSelectedInstOperands,
     /*  452844 */     // GIR_Coverage, 6552,
     /*  452844 */     GIR_EraseRootFromParent_Done,
     /*  452845 */   // Label 7783: @452845
     /*  452845 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(452931), // Rule ID 6553 //
     /*  452850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  452861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  452864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  452867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452897 */     // MIs[1] Operand 1
     /*  452897 */     // No operand predicates
     /*  452897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452906 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  452909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452929 */     GIR_RootConstrainSelectedInstOperands,
     /*  452930 */     // GIR_Coverage, 6553,
     /*  452930 */     GIR_EraseRootFromParent_Done,
     /*  452931 */   // Label 7784: @452931
     /*  452931 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(453017), // Rule ID 6732 //
     /*  452936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  452947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452983 */     // MIs[1] Operand 1
     /*  452983 */     // No operand predicates
     /*  452983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452992 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  452992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  452995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453015 */     GIR_RootConstrainSelectedInstOperands,
     /*  453016 */     // GIR_Coverage, 6732,
     /*  453016 */     GIR_EraseRootFromParent_Done,
     /*  453017 */   // Label 7785: @453017
     /*  453017 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(453103), // Rule ID 6733 //
     /*  453022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  453033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  453036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  453039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453069 */     // MIs[1] Operand 1
     /*  453069 */     // No operand predicates
     /*  453069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453078 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  453081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453101 */     GIR_RootConstrainSelectedInstOperands,
     /*  453102 */     // GIR_Coverage, 6733,
     /*  453102 */     GIR_EraseRootFromParent_Done,
     /*  453103 */   // Label 7786: @453103
     /*  453103 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(453189), // Rule ID 6736 //
     /*  453108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  453119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  453122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  453125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453155 */     // MIs[1] Operand 1
     /*  453155 */     // No operand predicates
     /*  453155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453164 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  453167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453187 */     GIR_RootConstrainSelectedInstOperands,
     /*  453188 */     // GIR_Coverage, 6736,
     /*  453188 */     GIR_EraseRootFromParent_Done,
     /*  453189 */   // Label 7787: @453189
     /*  453189 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(453275), // Rule ID 6737 //
     /*  453194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  453205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  453208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  453211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453241 */     // MIs[1] Operand 1
     /*  453241 */     // No operand predicates
     /*  453241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453250 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  453253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453273 */     GIR_RootConstrainSelectedInstOperands,
     /*  453274 */     // GIR_Coverage, 6737,
     /*  453274 */     GIR_EraseRootFromParent_Done,
     /*  453275 */   // Label 7788: @453275
     /*  453275 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(453361), // Rule ID 6740 //
     /*  453280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  453291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  453294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  453297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453327 */     // MIs[1] Operand 1
     /*  453327 */     // No operand predicates
     /*  453327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453336 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  453339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453359 */     GIR_RootConstrainSelectedInstOperands,
     /*  453360 */     // GIR_Coverage, 6740,
     /*  453360 */     GIR_EraseRootFromParent_Done,
     /*  453361 */   // Label 7789: @453361
     /*  453361 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(453447), // Rule ID 6741 //
     /*  453366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  453377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  453380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  453383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453413 */     // MIs[1] Operand 1
     /*  453413 */     // No operand predicates
     /*  453413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453422 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  453425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453445 */     GIR_RootConstrainSelectedInstOperands,
     /*  453446 */     // GIR_Coverage, 6741,
     /*  453446 */     GIR_EraseRootFromParent_Done,
     /*  453447 */   // Label 7790: @453447
     /*  453447 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(453533), // Rule ID 6744 //
     /*  453452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453499 */     // MIs[1] Operand 1
     /*  453499 */     // No operand predicates
     /*  453499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453508 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  453511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453531 */     GIR_RootConstrainSelectedInstOperands,
     /*  453532 */     // GIR_Coverage, 6744,
     /*  453532 */     GIR_EraseRootFromParent_Done,
     /*  453533 */   // Label 7791: @453533
     /*  453533 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(453619), // Rule ID 6745 //
     /*  453538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453585 */     // MIs[1] Operand 1
     /*  453585 */     // No operand predicates
     /*  453585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453594 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  453597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453617 */     GIR_RootConstrainSelectedInstOperands,
     /*  453618 */     // GIR_Coverage, 6745,
     /*  453618 */     GIR_EraseRootFromParent_Done,
     /*  453619 */   // Label 7792: @453619
     /*  453619 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(453705), // Rule ID 6748 //
     /*  453624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  453635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  453638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  453641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453671 */     // MIs[1] Operand 1
     /*  453671 */     // No operand predicates
     /*  453671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453680 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  453683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453703 */     GIR_RootConstrainSelectedInstOperands,
     /*  453704 */     // GIR_Coverage, 6748,
     /*  453704 */     GIR_EraseRootFromParent_Done,
     /*  453705 */   // Label 7793: @453705
     /*  453705 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(453791), // Rule ID 6749 //
     /*  453710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  453721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  453724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  453727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453757 */     // MIs[1] Operand 1
     /*  453757 */     // No operand predicates
     /*  453757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453766 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  453769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453789 */     GIR_RootConstrainSelectedInstOperands,
     /*  453790 */     // GIR_Coverage, 6749,
     /*  453790 */     GIR_EraseRootFromParent_Done,
     /*  453791 */   // Label 7794: @453791
     /*  453791 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(453877), // Rule ID 6752 //
     /*  453796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  453807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  453810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  453813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453843 */     // MIs[1] Operand 1
     /*  453843 */     // No operand predicates
     /*  453843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453852 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  453852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  453855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453875 */     GIR_RootConstrainSelectedInstOperands,
     /*  453876 */     // GIR_Coverage, 6752,
     /*  453876 */     GIR_EraseRootFromParent_Done,
     /*  453877 */   // Label 7795: @453877
     /*  453877 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(453963), // Rule ID 6753 //
     /*  453882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  453893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  453896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  453899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453929 */     // MIs[1] Operand 1
     /*  453929 */     // No operand predicates
     /*  453929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453938 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  453938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  453941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453961 */     GIR_RootConstrainSelectedInstOperands,
     /*  453962 */     // GIR_Coverage, 6753,
     /*  453962 */     GIR_EraseRootFromParent_Done,
     /*  453963 */   // Label 7796: @453963
     /*  453963 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(454049), // Rule ID 6756 //
     /*  453968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  453979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  453982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  453985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454015 */     // MIs[1] Operand 1
     /*  454015 */     // No operand predicates
     /*  454015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454024 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454047 */     GIR_RootConstrainSelectedInstOperands,
     /*  454048 */     // GIR_Coverage, 6756,
     /*  454048 */     GIR_EraseRootFromParent_Done,
     /*  454049 */   // Label 7797: @454049
     /*  454049 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(454135), // Rule ID 6757 //
     /*  454054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  454065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  454068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  454071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454101 */     // MIs[1] Operand 1
     /*  454101 */     // No operand predicates
     /*  454101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454110 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454133 */     GIR_RootConstrainSelectedInstOperands,
     /*  454134 */     // GIR_Coverage, 6757,
     /*  454134 */     GIR_EraseRootFromParent_Done,
     /*  454135 */   // Label 7798: @454135
     /*  454135 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(454221), // Rule ID 6760 //
     /*  454140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  454151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  454154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  454157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454187 */     // MIs[1] Operand 1
     /*  454187 */     // No operand predicates
     /*  454187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454196 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  454196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454219 */     GIR_RootConstrainSelectedInstOperands,
     /*  454220 */     // GIR_Coverage, 6760,
     /*  454220 */     GIR_EraseRootFromParent_Done,
     /*  454221 */   // Label 7799: @454221
     /*  454221 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(454307), // Rule ID 6761 //
     /*  454226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  454237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  454240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  454243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454273 */     // MIs[1] Operand 1
     /*  454273 */     // No operand predicates
     /*  454273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454282 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454305 */     GIR_RootConstrainSelectedInstOperands,
     /*  454306 */     // GIR_Coverage, 6761,
     /*  454306 */     GIR_EraseRootFromParent_Done,
     /*  454307 */   // Label 7800: @454307
     /*  454307 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(454393), // Rule ID 6764 //
     /*  454312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  454323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  454326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  454329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454359 */     // MIs[1] Operand 1
     /*  454359 */     // No operand predicates
     /*  454359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454368 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  454368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454391 */     GIR_RootConstrainSelectedInstOperands,
     /*  454392 */     // GIR_Coverage, 6764,
     /*  454392 */     GIR_EraseRootFromParent_Done,
     /*  454393 */   // Label 7801: @454393
     /*  454393 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(454479), // Rule ID 6765 //
     /*  454398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  454409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  454412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  454415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454445 */     // MIs[1] Operand 1
     /*  454445 */     // No operand predicates
     /*  454445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454454 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  454454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454477 */     GIR_RootConstrainSelectedInstOperands,
     /*  454478 */     // GIR_Coverage, 6765,
     /*  454478 */     GIR_EraseRootFromParent_Done,
     /*  454479 */   // Label 7802: @454479
     /*  454479 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(454565), // Rule ID 6768 //
     /*  454484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  454487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  454501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454531 */     // MIs[1] Operand 1
     /*  454531 */     // No operand predicates
     /*  454531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454540 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  454540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  454560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454563 */     GIR_RootConstrainSelectedInstOperands,
     /*  454564 */     // GIR_Coverage, 6768,
     /*  454564 */     GIR_EraseRootFromParent_Done,
     /*  454565 */   // Label 7803: @454565
     /*  454565 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(454651), // Rule ID 6769 //
     /*  454570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  454573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  454587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454617 */     // MIs[1] Operand 1
     /*  454617 */     // No operand predicates
     /*  454617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454626 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  454626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  454646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454649 */     GIR_RootConstrainSelectedInstOperands,
     /*  454650 */     // GIR_Coverage, 6769,
     /*  454650 */     GIR_EraseRootFromParent_Done,
     /*  454651 */   // Label 7804: @454651
     /*  454651 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(454737), // Rule ID 6772 //
     /*  454656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  454667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  454670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  454673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454703 */     // MIs[1] Operand 1
     /*  454703 */     // No operand predicates
     /*  454703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454712 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  454715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454735 */     GIR_RootConstrainSelectedInstOperands,
     /*  454736 */     // GIR_Coverage, 6772,
     /*  454736 */     GIR_EraseRootFromParent_Done,
     /*  454737 */   // Label 7805: @454737
     /*  454737 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(454823), // Rule ID 6773 //
     /*  454742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  454753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  454756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  454759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454789 */     // MIs[1] Operand 1
     /*  454789 */     // No operand predicates
     /*  454789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454798 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  454801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454821 */     GIR_RootConstrainSelectedInstOperands,
     /*  454822 */     // GIR_Coverage, 6773,
     /*  454822 */     GIR_EraseRootFromParent_Done,
     /*  454823 */   // Label 7806: @454823
     /*  454823 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(454909), // Rule ID 6776 //
     /*  454828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  454839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  454842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  454845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454875 */     // MIs[1] Operand 1
     /*  454875 */     // No operand predicates
     /*  454875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454884 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  454887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454907 */     GIR_RootConstrainSelectedInstOperands,
     /*  454908 */     // GIR_Coverage, 6776,
     /*  454908 */     GIR_EraseRootFromParent_Done,
     /*  454909 */   // Label 7807: @454909
     /*  454909 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(454995), // Rule ID 6777 //
     /*  454914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  454925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  454928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  454931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454961 */     // MIs[1] Operand 1
     /*  454961 */     // No operand predicates
     /*  454961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454970 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  454973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454993 */     GIR_RootConstrainSelectedInstOperands,
     /*  454994 */     // GIR_Coverage, 6777,
     /*  454994 */     GIR_EraseRootFromParent_Done,
     /*  454995 */   // Label 7808: @454995
     /*  454995 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(455081), // Rule ID 6780 //
     /*  455000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  455011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  455014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  455017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455047 */     // MIs[1] Operand 1
     /*  455047 */     // No operand predicates
     /*  455047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455056 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  455056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  455059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455079 */     GIR_RootConstrainSelectedInstOperands,
     /*  455080 */     // GIR_Coverage, 6780,
     /*  455080 */     GIR_EraseRootFromParent_Done,
     /*  455081 */   // Label 7809: @455081
     /*  455081 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(455167), // Rule ID 6781 //
     /*  455086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  455097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  455100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  455103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455133 */     // MIs[1] Operand 1
     /*  455133 */     // No operand predicates
     /*  455133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455142 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  455142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  455145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455165 */     GIR_RootConstrainSelectedInstOperands,
     /*  455166 */     // GIR_Coverage, 6781,
     /*  455166 */     GIR_EraseRootFromParent_Done,
     /*  455167 */   // Label 7810: @455167
     /*  455167 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(455253), // Rule ID 6784 //
     /*  455172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  455183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  455186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  455189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455219 */     // MIs[1] Operand 1
     /*  455219 */     // No operand predicates
     /*  455219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  455231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455251 */     GIR_RootConstrainSelectedInstOperands,
     /*  455252 */     // GIR_Coverage, 6784,
     /*  455252 */     GIR_EraseRootFromParent_Done,
     /*  455253 */   // Label 7811: @455253
     /*  455253 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(455339), // Rule ID 6785 //
     /*  455258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  455269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  455272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  455275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455305 */     // MIs[1] Operand 1
     /*  455305 */     // No operand predicates
     /*  455305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  455317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455337 */     GIR_RootConstrainSelectedInstOperands,
     /*  455338 */     // GIR_Coverage, 6785,
     /*  455338 */     GIR_EraseRootFromParent_Done,
     /*  455339 */   // Label 7812: @455339
     /*  455339 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(455425), // Rule ID 6788 //
     /*  455344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  455355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  455358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  455361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455391 */     // MIs[1] Operand 1
     /*  455391 */     // No operand predicates
     /*  455391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  455403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455423 */     GIR_RootConstrainSelectedInstOperands,
     /*  455424 */     // GIR_Coverage, 6788,
     /*  455424 */     GIR_EraseRootFromParent_Done,
     /*  455425 */   // Label 7813: @455425
     /*  455425 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(455511), // Rule ID 6789 //
     /*  455430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  455441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  455444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  455447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455477 */     // MIs[1] Operand 1
     /*  455477 */     // No operand predicates
     /*  455477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455486 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  455489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455509 */     GIR_RootConstrainSelectedInstOperands,
     /*  455510 */     // GIR_Coverage, 6789,
     /*  455510 */     GIR_EraseRootFromParent_Done,
     /*  455511 */   // Label 7814: @455511
     /*  455511 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(455597), // Rule ID 6792 //
     /*  455516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  455527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  455530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  455533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455563 */     // MIs[1] Operand 1
     /*  455563 */     // No operand predicates
     /*  455563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455572 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  455575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455595 */     GIR_RootConstrainSelectedInstOperands,
     /*  455596 */     // GIR_Coverage, 6792,
     /*  455596 */     GIR_EraseRootFromParent_Done,
     /*  455597 */   // Label 7815: @455597
     /*  455597 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(455683), // Rule ID 6793 //
     /*  455602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  455613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  455616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  455619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455649 */     // MIs[1] Operand 1
     /*  455649 */     // No operand predicates
     /*  455649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455658 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  455661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455681 */     GIR_RootConstrainSelectedInstOperands,
     /*  455682 */     // GIR_Coverage, 6793,
     /*  455682 */     GIR_EraseRootFromParent_Done,
     /*  455683 */   // Label 7816: @455683
     /*  455683 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(455769), // Rule ID 6796 //
     /*  455688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  455699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  455702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  455705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455735 */     // MIs[1] Operand 1
     /*  455735 */     // No operand predicates
     /*  455735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  455747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455767 */     GIR_RootConstrainSelectedInstOperands,
     /*  455768 */     // GIR_Coverage, 6796,
     /*  455768 */     GIR_EraseRootFromParent_Done,
     /*  455769 */   // Label 7817: @455769
     /*  455769 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(455855), // Rule ID 6797 //
     /*  455774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  455785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  455788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  455791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455821 */     // MIs[1] Operand 1
     /*  455821 */     // No operand predicates
     /*  455821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  455830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  455833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455853 */     GIR_RootConstrainSelectedInstOperands,
     /*  455854 */     // GIR_Coverage, 6797,
     /*  455854 */     GIR_EraseRootFromParent_Done,
     /*  455855 */   // Label 7818: @455855
     /*  455855 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(455941), // Rule ID 6800 //
     /*  455860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  455871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  455874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  455877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455907 */     // MIs[1] Operand 1
     /*  455907 */     // No operand predicates
     /*  455907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455916 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  455919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455939 */     GIR_RootConstrainSelectedInstOperands,
     /*  455940 */     // GIR_Coverage, 6800,
     /*  455940 */     GIR_EraseRootFromParent_Done,
     /*  455941 */   // Label 7819: @455941
     /*  455941 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(456027), // Rule ID 6801 //
     /*  455946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  455957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  455960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  455963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455993 */     // MIs[1] Operand 1
     /*  455993 */     // No operand predicates
     /*  455993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  456002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  456005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456025 */     GIR_RootConstrainSelectedInstOperands,
     /*  456026 */     // GIR_Coverage, 6801,
     /*  456026 */     GIR_EraseRootFromParent_Done,
     /*  456027 */   // Label 7820: @456027
     /*  456027 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(456113), // Rule ID 6804 //
     /*  456032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  456043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  456046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  456049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456079 */     // MIs[1] Operand 1
     /*  456079 */     // No operand predicates
     /*  456079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456088 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  456088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  456091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456111 */     GIR_RootConstrainSelectedInstOperands,
     /*  456112 */     // GIR_Coverage, 6804,
     /*  456112 */     GIR_EraseRootFromParent_Done,
     /*  456113 */   // Label 7821: @456113
     /*  456113 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(456199), // Rule ID 6805 //
     /*  456118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  456129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  456132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  456135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456165 */     // MIs[1] Operand 1
     /*  456165 */     // No operand predicates
     /*  456165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  456174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  456177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456197 */     GIR_RootConstrainSelectedInstOperands,
     /*  456198 */     // GIR_Coverage, 6805,
     /*  456198 */     GIR_EraseRootFromParent_Done,
     /*  456199 */   // Label 7822: @456199
     /*  456199 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(456285), // Rule ID 6808 //
     /*  456204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  456215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  456218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  456221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456251 */     // MIs[1] Operand 1
     /*  456251 */     // No operand predicates
     /*  456251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456260 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  456263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456283 */     GIR_RootConstrainSelectedInstOperands,
     /*  456284 */     // GIR_Coverage, 6808,
     /*  456284 */     GIR_EraseRootFromParent_Done,
     /*  456285 */   // Label 7823: @456285
     /*  456285 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(456371), // Rule ID 6809 //
     /*  456290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  456301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  456304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  456307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456337 */     // MIs[1] Operand 1
     /*  456337 */     // No operand predicates
     /*  456337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  456349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456369 */     GIR_RootConstrainSelectedInstOperands,
     /*  456370 */     // GIR_Coverage, 6809,
     /*  456370 */     GIR_EraseRootFromParent_Done,
     /*  456371 */   // Label 7824: @456371
     /*  456371 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(456457), // Rule ID 6812 //
     /*  456376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  456387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  456390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  456393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456423 */     // MIs[1] Operand 1
     /*  456423 */     // No operand predicates
     /*  456423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456432 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  456435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456455 */     GIR_RootConstrainSelectedInstOperands,
     /*  456456 */     // GIR_Coverage, 6812,
     /*  456456 */     GIR_EraseRootFromParent_Done,
     /*  456457 */   // Label 7825: @456457
     /*  456457 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(456543), // Rule ID 6813 //
     /*  456462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  456473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  456476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  456479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456509 */     // MIs[1] Operand 1
     /*  456509 */     // No operand predicates
     /*  456509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  456521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456541 */     GIR_RootConstrainSelectedInstOperands,
     /*  456542 */     // GIR_Coverage, 6813,
     /*  456542 */     GIR_EraseRootFromParent_Done,
     /*  456543 */   // Label 7826: @456543
     /*  456543 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(456629), // Rule ID 6816 //
     /*  456548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  456559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  456562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  456565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456595 */     // MIs[1] Operand 1
     /*  456595 */     // No operand predicates
     /*  456595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456604 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  456607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456627 */     GIR_RootConstrainSelectedInstOperands,
     /*  456628 */     // GIR_Coverage, 6816,
     /*  456628 */     GIR_EraseRootFromParent_Done,
     /*  456629 */   // Label 7827: @456629
     /*  456629 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(456715), // Rule ID 6817 //
     /*  456634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  456645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  456648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  456651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456681 */     // MIs[1] Operand 1
     /*  456681 */     // No operand predicates
     /*  456681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456690 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  456693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456713 */     GIR_RootConstrainSelectedInstOperands,
     /*  456714 */     // GIR_Coverage, 6817,
     /*  456714 */     GIR_EraseRootFromParent_Done,
     /*  456715 */   // Label 7828: @456715
     /*  456715 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(456801), // Rule ID 6996 //
     /*  456720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  456731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  456734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  456737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456767 */     // MIs[1] Operand 1
     /*  456767 */     // No operand predicates
     /*  456767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456776 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  456776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  456779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456799 */     GIR_RootConstrainSelectedInstOperands,
     /*  456800 */     // GIR_Coverage, 6996,
     /*  456800 */     GIR_EraseRootFromParent_Done,
     /*  456801 */   // Label 7829: @456801
     /*  456801 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(456887), // Rule ID 6997 //
     /*  456806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  456817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  456820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  456823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456853 */     // MIs[1] Operand 1
     /*  456853 */     // No operand predicates
     /*  456853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456862 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  456862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  456865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456885 */     GIR_RootConstrainSelectedInstOperands,
     /*  456886 */     // GIR_Coverage, 6997,
     /*  456886 */     GIR_EraseRootFromParent_Done,
     /*  456887 */   // Label 7830: @456887
     /*  456887 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(456973), // Rule ID 7000 //
     /*  456892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  456903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  456906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  456909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456939 */     // MIs[1] Operand 1
     /*  456939 */     // No operand predicates
     /*  456939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456948 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  456948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  456951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456971 */     GIR_RootConstrainSelectedInstOperands,
     /*  456972 */     // GIR_Coverage, 7000,
     /*  456972 */     GIR_EraseRootFromParent_Done,
     /*  456973 */   // Label 7831: @456973
     /*  456973 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(457059), // Rule ID 7001 //
     /*  456978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  456989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  456992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  456995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457025 */     // MIs[1] Operand 1
     /*  457025 */     // No operand predicates
     /*  457025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457034 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  457037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457057 */     GIR_RootConstrainSelectedInstOperands,
     /*  457058 */     // GIR_Coverage, 7001,
     /*  457058 */     GIR_EraseRootFromParent_Done,
     /*  457059 */   // Label 7832: @457059
     /*  457059 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(457145), // Rule ID 7004 //
     /*  457064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  457075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  457078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  457081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457111 */     // MIs[1] Operand 1
     /*  457111 */     // No operand predicates
     /*  457111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457120 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  457123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457143 */     GIR_RootConstrainSelectedInstOperands,
     /*  457144 */     // GIR_Coverage, 7004,
     /*  457144 */     GIR_EraseRootFromParent_Done,
     /*  457145 */   // Label 7833: @457145
     /*  457145 */   GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(457231), // Rule ID 7005 //
     /*  457150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  457161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  457164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  457167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457197 */     // MIs[1] Operand 1
     /*  457197 */     // No operand predicates
     /*  457197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457206 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  457209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457229 */     GIR_RootConstrainSelectedInstOperands,
     /*  457230 */     // GIR_Coverage, 7005,
     /*  457230 */     GIR_EraseRootFromParent_Done,
     /*  457231 */   // Label 7834: @457231
     /*  457231 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(457317), // Rule ID 7008 //
     /*  457236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  457247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  457250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  457253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457283 */     // MIs[1] Operand 1
     /*  457283 */     // No operand predicates
     /*  457283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457292 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  457295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457315 */     GIR_RootConstrainSelectedInstOperands,
     /*  457316 */     // GIR_Coverage, 7008,
     /*  457316 */     GIR_EraseRootFromParent_Done,
     /*  457317 */   // Label 7835: @457317
     /*  457317 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(457403), // Rule ID 7009 //
     /*  457322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  457333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  457336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  457339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457369 */     // MIs[1] Operand 1
     /*  457369 */     // No operand predicates
     /*  457369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457378 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  457381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457401 */     GIR_RootConstrainSelectedInstOperands,
     /*  457402 */     // GIR_Coverage, 7009,
     /*  457402 */     GIR_EraseRootFromParent_Done,
     /*  457403 */   // Label 7836: @457403
     /*  457403 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(457489), // Rule ID 7012 //
     /*  457408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  457419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  457422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  457425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457455 */     // MIs[1] Operand 1
     /*  457455 */     // No operand predicates
     /*  457455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457464 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  457467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457487 */     GIR_RootConstrainSelectedInstOperands,
     /*  457488 */     // GIR_Coverage, 7012,
     /*  457488 */     GIR_EraseRootFromParent_Done,
     /*  457489 */   // Label 7837: @457489
     /*  457489 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(457575), // Rule ID 7013 //
     /*  457494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  457505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  457508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  457511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457541 */     // MIs[1] Operand 1
     /*  457541 */     // No operand predicates
     /*  457541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457550 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  457553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457573 */     GIR_RootConstrainSelectedInstOperands,
     /*  457574 */     // GIR_Coverage, 7013,
     /*  457574 */     GIR_EraseRootFromParent_Done,
     /*  457575 */   // Label 7838: @457575
     /*  457575 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(457661), // Rule ID 7016 //
     /*  457580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  457591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  457594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  457597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457627 */     // MIs[1] Operand 1
     /*  457627 */     // No operand predicates
     /*  457627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457636 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  457636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  457639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457659 */     GIR_RootConstrainSelectedInstOperands,
     /*  457660 */     // GIR_Coverage, 7016,
     /*  457660 */     GIR_EraseRootFromParent_Done,
     /*  457661 */   // Label 7839: @457661
     /*  457661 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(457747), // Rule ID 7017 //
     /*  457666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  457677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  457680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  457683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457713 */     // MIs[1] Operand 1
     /*  457713 */     // No operand predicates
     /*  457713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457722 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  457722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  457725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457745 */     GIR_RootConstrainSelectedInstOperands,
     /*  457746 */     // GIR_Coverage, 7017,
     /*  457746 */     GIR_EraseRootFromParent_Done,
     /*  457747 */   // Label 7840: @457747
     /*  457747 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(457833), // Rule ID 7020 //
     /*  457752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  457763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  457766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  457769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457799 */     // MIs[1] Operand 1
     /*  457799 */     // No operand predicates
     /*  457799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457808 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  457811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457831 */     GIR_RootConstrainSelectedInstOperands,
     /*  457832 */     // GIR_Coverage, 7020,
     /*  457832 */     GIR_EraseRootFromParent_Done,
     /*  457833 */   // Label 7841: @457833
     /*  457833 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(457919), // Rule ID 7021 //
     /*  457838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  457849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  457852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  457855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457885 */     // MIs[1] Operand 1
     /*  457885 */     // No operand predicates
     /*  457885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457894 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  457897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457917 */     GIR_RootConstrainSelectedInstOperands,
     /*  457918 */     // GIR_Coverage, 7021,
     /*  457918 */     GIR_EraseRootFromParent_Done,
     /*  457919 */   // Label 7842: @457919
     /*  457919 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(458005), // Rule ID 7024 //
     /*  457924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  457935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  457938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  457941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457971 */     // MIs[1] Operand 1
     /*  457971 */     // No operand predicates
     /*  457971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457980 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  457983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458003 */     GIR_RootConstrainSelectedInstOperands,
     /*  458004 */     // GIR_Coverage, 7024,
     /*  458004 */     GIR_EraseRootFromParent_Done,
     /*  458005 */   // Label 7843: @458005
     /*  458005 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(458091), // Rule ID 7025 //
     /*  458010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  458021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  458024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  458027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458057 */     // MIs[1] Operand 1
     /*  458057 */     // No operand predicates
     /*  458057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458066 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  458066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  458069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458089 */     GIR_RootConstrainSelectedInstOperands,
     /*  458090 */     // GIR_Coverage, 7025,
     /*  458090 */     GIR_EraseRootFromParent_Done,
     /*  458091 */   // Label 7844: @458091
     /*  458091 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(458177), // Rule ID 7028 //
     /*  458096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  458107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  458110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  458113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458143 */     // MIs[1] Operand 1
     /*  458143 */     // No operand predicates
     /*  458143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  458152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  458155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458175 */     GIR_RootConstrainSelectedInstOperands,
     /*  458176 */     // GIR_Coverage, 7028,
     /*  458176 */     GIR_EraseRootFromParent_Done,
     /*  458177 */   // Label 7845: @458177
     /*  458177 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(458263), // Rule ID 7029 //
     /*  458182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  458193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  458196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  458199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458229 */     // MIs[1] Operand 1
     /*  458229 */     // No operand predicates
     /*  458229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458238 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  458238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  458241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458261 */     GIR_RootConstrainSelectedInstOperands,
     /*  458262 */     // GIR_Coverage, 7029,
     /*  458262 */     GIR_EraseRootFromParent_Done,
     /*  458263 */   // Label 7846: @458263
     /*  458263 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(458349), // Rule ID 7032 //
     /*  458268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  458271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  458279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  458282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  458285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458315 */     // MIs[1] Operand 1
     /*  458315 */     // No operand predicates
     /*  458315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458324 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  458324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  458327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458347 */     GIR_RootConstrainSelectedInstOperands,
     /*  458348 */     // GIR_Coverage, 7032,
     /*  458348 */     GIR_EraseRootFromParent_Done,
     /*  458349 */   // Label 7847: @458349
     /*  458349 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(458435), // Rule ID 7033 //
     /*  458354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  458357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  458365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  458368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  458371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458401 */     // MIs[1] Operand 1
     /*  458401 */     // No operand predicates
     /*  458401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458410 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  458410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  458413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458433 */     GIR_RootConstrainSelectedInstOperands,
     /*  458434 */     // GIR_Coverage, 7033,
     /*  458434 */     GIR_EraseRootFromParent_Done,
     /*  458435 */   // Label 7848: @458435
     /*  458435 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(458521), // Rule ID 7036 //
     /*  458440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  458451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  458454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  458457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458487 */     // MIs[1] Operand 1
     /*  458487 */     // No operand predicates
     /*  458487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458496 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  458499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458519 */     GIR_RootConstrainSelectedInstOperands,
     /*  458520 */     // GIR_Coverage, 7036,
     /*  458520 */     GIR_EraseRootFromParent_Done,
     /*  458521 */   // Label 7849: @458521
     /*  458521 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(458607), // Rule ID 7037 //
     /*  458526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  458537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  458540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  458543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458573 */     // MIs[1] Operand 1
     /*  458573 */     // No operand predicates
     /*  458573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458582 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  458585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458605 */     GIR_RootConstrainSelectedInstOperands,
     /*  458606 */     // GIR_Coverage, 7037,
     /*  458606 */     GIR_EraseRootFromParent_Done,
     /*  458607 */   // Label 7850: @458607
     /*  458607 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(458693), // Rule ID 7040 //
     /*  458612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  458623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  458626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  458629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458659 */     // MIs[1] Operand 1
     /*  458659 */     // No operand predicates
     /*  458659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458668 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  458671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458691 */     GIR_RootConstrainSelectedInstOperands,
     /*  458692 */     // GIR_Coverage, 7040,
     /*  458692 */     GIR_EraseRootFromParent_Done,
     /*  458693 */   // Label 7851: @458693
     /*  458693 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(458779), // Rule ID 7041 //
     /*  458698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  458709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  458712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  458715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458745 */     // MIs[1] Operand 1
     /*  458745 */     // No operand predicates
     /*  458745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458754 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  458757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458777 */     GIR_RootConstrainSelectedInstOperands,
     /*  458778 */     // GIR_Coverage, 7041,
     /*  458778 */     GIR_EraseRootFromParent_Done,
     /*  458779 */   // Label 7852: @458779
     /*  458779 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(458865), // Rule ID 7044 //
     /*  458784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  458795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  458798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  458801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458831 */     // MIs[1] Operand 1
     /*  458831 */     // No operand predicates
     /*  458831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458840 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  458843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458863 */     GIR_RootConstrainSelectedInstOperands,
     /*  458864 */     // GIR_Coverage, 7044,
     /*  458864 */     GIR_EraseRootFromParent_Done,
     /*  458865 */   // Label 7853: @458865
     /*  458865 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(458951), // Rule ID 7045 //
     /*  458870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  458881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  458884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  458887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458917 */     // MIs[1] Operand 1
     /*  458917 */     // No operand predicates
     /*  458917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458926 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  458929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458949 */     GIR_RootConstrainSelectedInstOperands,
     /*  458950 */     // GIR_Coverage, 7045,
     /*  458950 */     GIR_EraseRootFromParent_Done,
     /*  458951 */   // Label 7854: @458951
     /*  458951 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(459037), // Rule ID 7048 //
     /*  458956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  458967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  458970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  458973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459003 */     // MIs[1] Operand 1
     /*  459003 */     // No operand predicates
     /*  459003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459012 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  459015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459035 */     GIR_RootConstrainSelectedInstOperands,
     /*  459036 */     // GIR_Coverage, 7048,
     /*  459036 */     GIR_EraseRootFromParent_Done,
     /*  459037 */   // Label 7855: @459037
     /*  459037 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(459123), // Rule ID 7049 //
     /*  459042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  459053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  459056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  459059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459089 */     // MIs[1] Operand 1
     /*  459089 */     // No operand predicates
     /*  459089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  459101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459121 */     GIR_RootConstrainSelectedInstOperands,
     /*  459122 */     // GIR_Coverage, 7049,
     /*  459122 */     GIR_EraseRootFromParent_Done,
     /*  459123 */   // Label 7856: @459123
     /*  459123 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(459209), // Rule ID 7052 //
     /*  459128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  459139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  459142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  459145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459175 */     // MIs[1] Operand 1
     /*  459175 */     // No operand predicates
     /*  459175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459184 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  459187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459207 */     GIR_RootConstrainSelectedInstOperands,
     /*  459208 */     // GIR_Coverage, 7052,
     /*  459208 */     GIR_EraseRootFromParent_Done,
     /*  459209 */   // Label 7857: @459209
     /*  459209 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(459295), // Rule ID 7053 //
     /*  459214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  459225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  459228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  459231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459261 */     // MIs[1] Operand 1
     /*  459261 */     // No operand predicates
     /*  459261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459270 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  459273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459293 */     GIR_RootConstrainSelectedInstOperands,
     /*  459294 */     // GIR_Coverage, 7053,
     /*  459294 */     GIR_EraseRootFromParent_Done,
     /*  459295 */   // Label 7858: @459295
     /*  459295 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(459381), // Rule ID 7056 //
     /*  459300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  459311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  459314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  459317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459347 */     // MIs[1] Operand 1
     /*  459347 */     // No operand predicates
     /*  459347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459356 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  459359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459379 */     GIR_RootConstrainSelectedInstOperands,
     /*  459380 */     // GIR_Coverage, 7056,
     /*  459380 */     GIR_EraseRootFromParent_Done,
     /*  459381 */   // Label 7859: @459381
     /*  459381 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(459467), // Rule ID 7057 //
     /*  459386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  459397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  459400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  459403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459433 */     // MIs[1] Operand 1
     /*  459433 */     // No operand predicates
     /*  459433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459442 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  459445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459465 */     GIR_RootConstrainSelectedInstOperands,
     /*  459466 */     // GIR_Coverage, 7057,
     /*  459466 */     GIR_EraseRootFromParent_Done,
     /*  459467 */   // Label 7860: @459467
     /*  459467 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(459553), // Rule ID 7060 //
     /*  459472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  459483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  459486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  459489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459519 */     // MIs[1] Operand 1
     /*  459519 */     // No operand predicates
     /*  459519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459528 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  459531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459551 */     GIR_RootConstrainSelectedInstOperands,
     /*  459552 */     // GIR_Coverage, 7060,
     /*  459552 */     GIR_EraseRootFromParent_Done,
     /*  459553 */   // Label 7861: @459553
     /*  459553 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(459639), // Rule ID 7061 //
     /*  459558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  459569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  459572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  459575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459605 */     // MIs[1] Operand 1
     /*  459605 */     // No operand predicates
     /*  459605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  459617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459637 */     GIR_RootConstrainSelectedInstOperands,
     /*  459638 */     // GIR_Coverage, 7061,
     /*  459638 */     GIR_EraseRootFromParent_Done,
     /*  459639 */   // Label 7862: @459639
     /*  459639 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(459725), // Rule ID 7064 //
     /*  459644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  459655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  459658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  459661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459691 */     // MIs[1] Operand 1
     /*  459691 */     // No operand predicates
     /*  459691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459700 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  459703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459723 */     GIR_RootConstrainSelectedInstOperands,
     /*  459724 */     // GIR_Coverage, 7064,
     /*  459724 */     GIR_EraseRootFromParent_Done,
     /*  459725 */   // Label 7863: @459725
     /*  459725 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(459811), // Rule ID 7065 //
     /*  459730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  459741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  459744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  459747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459777 */     // MIs[1] Operand 1
     /*  459777 */     // No operand predicates
     /*  459777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459786 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  459789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459809 */     GIR_RootConstrainSelectedInstOperands,
     /*  459810 */     // GIR_Coverage, 7065,
     /*  459810 */     GIR_EraseRootFromParent_Done,
     /*  459811 */   // Label 7864: @459811
     /*  459811 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(459897), // Rule ID 7068 //
     /*  459816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  459827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  459830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  459833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459863 */     // MIs[1] Operand 1
     /*  459863 */     // No operand predicates
     /*  459863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459872 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  459875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459895 */     GIR_RootConstrainSelectedInstOperands,
     /*  459896 */     // GIR_Coverage, 7068,
     /*  459896 */     GIR_EraseRootFromParent_Done,
     /*  459897 */   // Label 7865: @459897
     /*  459897 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(459983), // Rule ID 7069 //
     /*  459902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  459913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  459916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  459919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459949 */     // MIs[1] Operand 1
     /*  459949 */     // No operand predicates
     /*  459949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459958 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  459961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459981 */     GIR_RootConstrainSelectedInstOperands,
     /*  459982 */     // GIR_Coverage, 7069,
     /*  459982 */     GIR_EraseRootFromParent_Done,
     /*  459983 */   // Label 7866: @459983
     /*  459983 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(460069), // Rule ID 7072 //
     /*  459988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  459991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  459999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  460002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  460005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460035 */     // MIs[1] Operand 1
     /*  460035 */     // No operand predicates
     /*  460035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460044 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  460047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460067 */     GIR_RootConstrainSelectedInstOperands,
     /*  460068 */     // GIR_Coverage, 7072,
     /*  460068 */     GIR_EraseRootFromParent_Done,
     /*  460069 */   // Label 7867: @460069
     /*  460069 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(460155), // Rule ID 7073 //
     /*  460074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  460082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  460085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  460088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  460091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460121 */     // MIs[1] Operand 1
     /*  460121 */     // No operand predicates
     /*  460121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  460133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460153 */     GIR_RootConstrainSelectedInstOperands,
     /*  460154 */     // GIR_Coverage, 7073,
     /*  460154 */     GIR_EraseRootFromParent_Done,
     /*  460155 */   // Label 7868: @460155
     /*  460155 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(460241), // Rule ID 7076 //
     /*  460160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  460168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  460171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  460174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  460177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460207 */     // MIs[1] Operand 1
     /*  460207 */     // No operand predicates
     /*  460207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460216 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  460219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460239 */     GIR_RootConstrainSelectedInstOperands,
     /*  460240 */     // GIR_Coverage, 7076,
     /*  460240 */     GIR_EraseRootFromParent_Done,
     /*  460241 */   // Label 7869: @460241
     /*  460241 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(460327), // Rule ID 7077 //
     /*  460246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  460254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  460257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  460260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  460263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460293 */     // MIs[1] Operand 1
     /*  460293 */     // No operand predicates
     /*  460293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460302 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  460305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460325 */     GIR_RootConstrainSelectedInstOperands,
     /*  460326 */     // GIR_Coverage, 7077,
     /*  460326 */     GIR_EraseRootFromParent_Done,
     /*  460327 */   // Label 7870: @460327
     /*  460327 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(460413), // Rule ID 7080 //
     /*  460332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  460340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  460343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  460346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  460349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460379 */     // MIs[1] Operand 1
     /*  460379 */     // No operand predicates
     /*  460379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460388 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  460391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460411 */     GIR_RootConstrainSelectedInstOperands,
     /*  460412 */     // GIR_Coverage, 7080,
     /*  460412 */     GIR_EraseRootFromParent_Done,
     /*  460413 */   // Label 7871: @460413
     /*  460413 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(460499), // Rule ID 7081 //
     /*  460418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  460426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  460429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  460432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  460435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460465 */     // MIs[1] Operand 1
     /*  460465 */     // No operand predicates
     /*  460465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460474 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  460477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460497 */     GIR_RootConstrainSelectedInstOperands,
     /*  460498 */     // GIR_Coverage, 7081,
     /*  460498 */     GIR_EraseRootFromParent_Done,
     /*  460499 */   // Label 7872: @460499
     /*  460499 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(460585), // Rule ID 7260 //
     /*  460504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  460515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  460518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  460521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460551 */     // MIs[1] Operand 1
     /*  460551 */     // No operand predicates
     /*  460551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460560 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  460563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460583 */     GIR_RootConstrainSelectedInstOperands,
     /*  460584 */     // GIR_Coverage, 7260,
     /*  460584 */     GIR_EraseRootFromParent_Done,
     /*  460585 */   // Label 7873: @460585
     /*  460585 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(460671), // Rule ID 7261 //
     /*  460590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  460601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  460604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  460607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460637 */     // MIs[1] Operand 1
     /*  460637 */     // No operand predicates
     /*  460637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460646 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  460649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460669 */     GIR_RootConstrainSelectedInstOperands,
     /*  460670 */     // GIR_Coverage, 7261,
     /*  460670 */     GIR_EraseRootFromParent_Done,
     /*  460671 */   // Label 7874: @460671
     /*  460671 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(460757), // Rule ID 7264 //
     /*  460676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  460687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  460690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  460693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460723 */     // MIs[1] Operand 1
     /*  460723 */     // No operand predicates
     /*  460723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460732 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  460735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460755 */     GIR_RootConstrainSelectedInstOperands,
     /*  460756 */     // GIR_Coverage, 7264,
     /*  460756 */     GIR_EraseRootFromParent_Done,
     /*  460757 */   // Label 7875: @460757
     /*  460757 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(460843), // Rule ID 7265 //
     /*  460762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  460773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  460776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  460779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460809 */     // MIs[1] Operand 1
     /*  460809 */     // No operand predicates
     /*  460809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460818 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  460821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460841 */     GIR_RootConstrainSelectedInstOperands,
     /*  460842 */     // GIR_Coverage, 7265,
     /*  460842 */     GIR_EraseRootFromParent_Done,
     /*  460843 */   // Label 7876: @460843
     /*  460843 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(460929), // Rule ID 7268 //
     /*  460848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  460859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  460862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  460865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460895 */     // MIs[1] Operand 1
     /*  460895 */     // No operand predicates
     /*  460895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460904 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  460907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460927 */     GIR_RootConstrainSelectedInstOperands,
     /*  460928 */     // GIR_Coverage, 7268,
     /*  460928 */     GIR_EraseRootFromParent_Done,
     /*  460929 */   // Label 7877: @460929
     /*  460929 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(461015), // Rule ID 7269 //
     /*  460934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  460945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  460948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  460951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460981 */     // MIs[1] Operand 1
     /*  460981 */     // No operand predicates
     /*  460981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460990 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  460993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461013 */     GIR_RootConstrainSelectedInstOperands,
     /*  461014 */     // GIR_Coverage, 7269,
     /*  461014 */     GIR_EraseRootFromParent_Done,
     /*  461015 */   // Label 7878: @461015
     /*  461015 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(461101), // Rule ID 7272 //
     /*  461020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  461031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  461034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  461037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461067 */     // MIs[1] Operand 1
     /*  461067 */     // No operand predicates
     /*  461067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461076 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  461079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461099 */     GIR_RootConstrainSelectedInstOperands,
     /*  461100 */     // GIR_Coverage, 7272,
     /*  461100 */     GIR_EraseRootFromParent_Done,
     /*  461101 */   // Label 7879: @461101
     /*  461101 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(461187), // Rule ID 7273 //
     /*  461106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  461117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  461120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  461123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461153 */     // MIs[1] Operand 1
     /*  461153 */     // No operand predicates
     /*  461153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461162 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  461165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461185 */     GIR_RootConstrainSelectedInstOperands,
     /*  461186 */     // GIR_Coverage, 7273,
     /*  461186 */     GIR_EraseRootFromParent_Done,
     /*  461187 */   // Label 7880: @461187
     /*  461187 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(461273), // Rule ID 7276 //
     /*  461192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  461203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  461206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  461209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461239 */     // MIs[1] Operand 1
     /*  461239 */     // No operand predicates
     /*  461239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461248 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  461251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461271 */     GIR_RootConstrainSelectedInstOperands,
     /*  461272 */     // GIR_Coverage, 7276,
     /*  461272 */     GIR_EraseRootFromParent_Done,
     /*  461273 */   // Label 7881: @461273
     /*  461273 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(461359), // Rule ID 7277 //
     /*  461278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  461289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  461292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  461295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461325 */     // MIs[1] Operand 1
     /*  461325 */     // No operand predicates
     /*  461325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461334 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  461337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461357 */     GIR_RootConstrainSelectedInstOperands,
     /*  461358 */     // GIR_Coverage, 7277,
     /*  461358 */     GIR_EraseRootFromParent_Done,
     /*  461359 */   // Label 7882: @461359
     /*  461359 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(461445), // Rule ID 7280 //
     /*  461364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  461375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  461378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  461381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461411 */     // MIs[1] Operand 1
     /*  461411 */     // No operand predicates
     /*  461411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461420 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  461420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  461423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461443 */     GIR_RootConstrainSelectedInstOperands,
     /*  461444 */     // GIR_Coverage, 7280,
     /*  461444 */     GIR_EraseRootFromParent_Done,
     /*  461445 */   // Label 7883: @461445
     /*  461445 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(461531), // Rule ID 7281 //
     /*  461450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  461461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  461464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  461467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461497 */     // MIs[1] Operand 1
     /*  461497 */     // No operand predicates
     /*  461497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461506 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  461506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  461509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461529 */     GIR_RootConstrainSelectedInstOperands,
     /*  461530 */     // GIR_Coverage, 7281,
     /*  461530 */     GIR_EraseRootFromParent_Done,
     /*  461531 */   // Label 7884: @461531
     /*  461531 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(461617), // Rule ID 7284 //
     /*  461536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  461547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  461550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  461553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461583 */     // MIs[1] Operand 1
     /*  461583 */     // No operand predicates
     /*  461583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461592 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  461595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461615 */     GIR_RootConstrainSelectedInstOperands,
     /*  461616 */     // GIR_Coverage, 7284,
     /*  461616 */     GIR_EraseRootFromParent_Done,
     /*  461617 */   // Label 7885: @461617
     /*  461617 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(461703), // Rule ID 7285 //
     /*  461622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  461633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  461636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  461639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461669 */     // MIs[1] Operand 1
     /*  461669 */     // No operand predicates
     /*  461669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461678 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  461681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461701 */     GIR_RootConstrainSelectedInstOperands,
     /*  461702 */     // GIR_Coverage, 7285,
     /*  461702 */     GIR_EraseRootFromParent_Done,
     /*  461703 */   // Label 7886: @461703
     /*  461703 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(461789), // Rule ID 7288 //
     /*  461708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  461719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  461722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  461725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461755 */     // MIs[1] Operand 1
     /*  461755 */     // No operand predicates
     /*  461755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461764 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  461767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461787 */     GIR_RootConstrainSelectedInstOperands,
     /*  461788 */     // GIR_Coverage, 7288,
     /*  461788 */     GIR_EraseRootFromParent_Done,
     /*  461789 */   // Label 7887: @461789
     /*  461789 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(461875), // Rule ID 7289 //
     /*  461794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  461805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  461808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  461811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461841 */     // MIs[1] Operand 1
     /*  461841 */     // No operand predicates
     /*  461841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461850 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  461853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461873 */     GIR_RootConstrainSelectedInstOperands,
     /*  461874 */     // GIR_Coverage, 7289,
     /*  461874 */     GIR_EraseRootFromParent_Done,
     /*  461875 */   // Label 7888: @461875
     /*  461875 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(461961), // Rule ID 7292 //
     /*  461880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  461891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  461894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  461897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461927 */     // MIs[1] Operand 1
     /*  461927 */     // No operand predicates
     /*  461927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461936 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  461936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  461939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461959 */     GIR_RootConstrainSelectedInstOperands,
     /*  461960 */     // GIR_Coverage, 7292,
     /*  461960 */     GIR_EraseRootFromParent_Done,
     /*  461961 */   // Label 7889: @461961
     /*  461961 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(462047), // Rule ID 7293 //
     /*  461966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  461977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  461980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  461983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462013 */     // MIs[1] Operand 1
     /*  462013 */     // No operand predicates
     /*  462013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462022 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  462025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462045 */     GIR_RootConstrainSelectedInstOperands,
     /*  462046 */     // GIR_Coverage, 7293,
     /*  462046 */     GIR_EraseRootFromParent_Done,
     /*  462047 */   // Label 7890: @462047
     /*  462047 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(462133), // Rule ID 7296 //
     /*  462052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  462055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  462063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  462066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  462069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462099 */     // MIs[1] Operand 1
     /*  462099 */     // No operand predicates
     /*  462099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462108 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  462108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  462111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  462128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462131 */     GIR_RootConstrainSelectedInstOperands,
     /*  462132 */     // GIR_Coverage, 7296,
     /*  462132 */     GIR_EraseRootFromParent_Done,
     /*  462133 */   // Label 7891: @462133
     /*  462133 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(462219), // Rule ID 7297 //
     /*  462138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  462141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  462149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  462152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  462155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462185 */     // MIs[1] Operand 1
     /*  462185 */     // No operand predicates
     /*  462185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462194 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  462194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  462197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  462214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462217 */     GIR_RootConstrainSelectedInstOperands,
     /*  462218 */     // GIR_Coverage, 7297,
     /*  462218 */     GIR_EraseRootFromParent_Done,
     /*  462219 */   // Label 7892: @462219
     /*  462219 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(462305), // Rule ID 7300 //
     /*  462224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  462235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  462238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  462241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462271 */     // MIs[1] Operand 1
     /*  462271 */     // No operand predicates
     /*  462271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462280 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  462280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  462283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462303 */     GIR_RootConstrainSelectedInstOperands,
     /*  462304 */     // GIR_Coverage, 7300,
     /*  462304 */     GIR_EraseRootFromParent_Done,
     /*  462305 */   // Label 7893: @462305
     /*  462305 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(462391), // Rule ID 7301 //
     /*  462310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  462321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  462324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  462327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462357 */     // MIs[1] Operand 1
     /*  462357 */     // No operand predicates
     /*  462357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462366 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  462366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  462369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462389 */     GIR_RootConstrainSelectedInstOperands,
     /*  462390 */     // GIR_Coverage, 7301,
     /*  462390 */     GIR_EraseRootFromParent_Done,
     /*  462391 */   // Label 7894: @462391
     /*  462391 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(462477), // Rule ID 7304 //
     /*  462396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  462407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  462410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  462413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462443 */     // MIs[1] Operand 1
     /*  462443 */     // No operand predicates
     /*  462443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462452 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  462452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  462455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462475 */     GIR_RootConstrainSelectedInstOperands,
     /*  462476 */     // GIR_Coverage, 7304,
     /*  462476 */     GIR_EraseRootFromParent_Done,
     /*  462477 */   // Label 7895: @462477
     /*  462477 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(462563), // Rule ID 7305 //
     /*  462482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  462493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  462496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  462499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462529 */     // MIs[1] Operand 1
     /*  462529 */     // No operand predicates
     /*  462529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462538 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  462538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  462541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462561 */     GIR_RootConstrainSelectedInstOperands,
     /*  462562 */     // GIR_Coverage, 7305,
     /*  462562 */     GIR_EraseRootFromParent_Done,
     /*  462563 */   // Label 7896: @462563
     /*  462563 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(462649), // Rule ID 7308 //
     /*  462568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  462579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  462582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  462585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462615 */     // MIs[1] Operand 1
     /*  462615 */     // No operand predicates
     /*  462615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462624 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  462624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  462627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462647 */     GIR_RootConstrainSelectedInstOperands,
     /*  462648 */     // GIR_Coverage, 7308,
     /*  462648 */     GIR_EraseRootFromParent_Done,
     /*  462649 */   // Label 7897: @462649
     /*  462649 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(462735), // Rule ID 7309 //
     /*  462654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  462665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  462668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  462671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462701 */     // MIs[1] Operand 1
     /*  462701 */     // No operand predicates
     /*  462701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462710 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  462710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  462713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462733 */     GIR_RootConstrainSelectedInstOperands,
     /*  462734 */     // GIR_Coverage, 7309,
     /*  462734 */     GIR_EraseRootFromParent_Done,
     /*  462735 */   // Label 7898: @462735
     /*  462735 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(462821), // Rule ID 7312 //
     /*  462740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  462751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  462754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  462757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462787 */     // MIs[1] Operand 1
     /*  462787 */     // No operand predicates
     /*  462787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  462799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462819 */     GIR_RootConstrainSelectedInstOperands,
     /*  462820 */     // GIR_Coverage, 7312,
     /*  462820 */     GIR_EraseRootFromParent_Done,
     /*  462821 */   // Label 7899: @462821
     /*  462821 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(462907), // Rule ID 7313 //
     /*  462826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  462837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  462840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  462843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462873 */     // MIs[1] Operand 1
     /*  462873 */     // No operand predicates
     /*  462873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462882 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  462885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462905 */     GIR_RootConstrainSelectedInstOperands,
     /*  462906 */     // GIR_Coverage, 7313,
     /*  462906 */     GIR_EraseRootFromParent_Done,
     /*  462907 */   // Label 7900: @462907
     /*  462907 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(462993), // Rule ID 7316 //
     /*  462912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  462923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  462926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  462929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462959 */     // MIs[1] Operand 1
     /*  462959 */     // No operand predicates
     /*  462959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462968 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  462971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462991 */     GIR_RootConstrainSelectedInstOperands,
     /*  462992 */     // GIR_Coverage, 7316,
     /*  462992 */     GIR_EraseRootFromParent_Done,
     /*  462993 */   // Label 7901: @462993
     /*  462993 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(463079), // Rule ID 7317 //
     /*  462998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  463009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  463012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  463015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463045 */     // MIs[1] Operand 1
     /*  463045 */     // No operand predicates
     /*  463045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463054 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  463054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  463057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463077 */     GIR_RootConstrainSelectedInstOperands,
     /*  463078 */     // GIR_Coverage, 7317,
     /*  463078 */     GIR_EraseRootFromParent_Done,
     /*  463079 */   // Label 7902: @463079
     /*  463079 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(463165), // Rule ID 7320 //
     /*  463084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  463095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  463098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  463101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463131 */     // MIs[1] Operand 1
     /*  463131 */     // No operand predicates
     /*  463131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463140 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  463140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  463143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463163 */     GIR_RootConstrainSelectedInstOperands,
     /*  463164 */     // GIR_Coverage, 7320,
     /*  463164 */     GIR_EraseRootFromParent_Done,
     /*  463165 */   // Label 7903: @463165
     /*  463165 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(463251), // Rule ID 7321 //
     /*  463170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  463181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  463184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  463187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463217 */     // MIs[1] Operand 1
     /*  463217 */     // No operand predicates
     /*  463217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463226 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  463226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  463229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463249 */     GIR_RootConstrainSelectedInstOperands,
     /*  463250 */     // GIR_Coverage, 7321,
     /*  463250 */     GIR_EraseRootFromParent_Done,
     /*  463251 */   // Label 7904: @463251
     /*  463251 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(463337), // Rule ID 7324 //
     /*  463256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  463267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  463270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  463273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463303 */     // MIs[1] Operand 1
     /*  463303 */     // No operand predicates
     /*  463303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463312 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  463315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463335 */     GIR_RootConstrainSelectedInstOperands,
     /*  463336 */     // GIR_Coverage, 7324,
     /*  463336 */     GIR_EraseRootFromParent_Done,
     /*  463337 */   // Label 7905: @463337
     /*  463337 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(463423), // Rule ID 7325 //
     /*  463342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  463353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  463356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  463359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463389 */     // MIs[1] Operand 1
     /*  463389 */     // No operand predicates
     /*  463389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463398 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  463401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463421 */     GIR_RootConstrainSelectedInstOperands,
     /*  463422 */     // GIR_Coverage, 7325,
     /*  463422 */     GIR_EraseRootFromParent_Done,
     /*  463423 */   // Label 7906: @463423
     /*  463423 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(463509), // Rule ID 7328 //
     /*  463428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  463439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  463442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  463445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463475 */     // MIs[1] Operand 1
     /*  463475 */     // No operand predicates
     /*  463475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  463487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463507 */     GIR_RootConstrainSelectedInstOperands,
     /*  463508 */     // GIR_Coverage, 7328,
     /*  463508 */     GIR_EraseRootFromParent_Done,
     /*  463509 */   // Label 7907: @463509
     /*  463509 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(463595), // Rule ID 7329 //
     /*  463514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  463525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  463528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  463531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463561 */     // MIs[1] Operand 1
     /*  463561 */     // No operand predicates
     /*  463561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463570 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  463573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463593 */     GIR_RootConstrainSelectedInstOperands,
     /*  463594 */     // GIR_Coverage, 7329,
     /*  463594 */     GIR_EraseRootFromParent_Done,
     /*  463595 */   // Label 7908: @463595
     /*  463595 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(463681), // Rule ID 7332 //
     /*  463600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  463611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  463614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  463617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463647 */     // MIs[1] Operand 1
     /*  463647 */     // No operand predicates
     /*  463647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463656 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  463659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463679 */     GIR_RootConstrainSelectedInstOperands,
     /*  463680 */     // GIR_Coverage, 7332,
     /*  463680 */     GIR_EraseRootFromParent_Done,
     /*  463681 */   // Label 7909: @463681
     /*  463681 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(463767), // Rule ID 7333 //
     /*  463686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  463697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  463700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  463703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463733 */     // MIs[1] Operand 1
     /*  463733 */     // No operand predicates
     /*  463733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463742 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  463745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463765 */     GIR_RootConstrainSelectedInstOperands,
     /*  463766 */     // GIR_Coverage, 7333,
     /*  463766 */     GIR_EraseRootFromParent_Done,
     /*  463767 */   // Label 7910: @463767
     /*  463767 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(463853), // Rule ID 7336 //
     /*  463772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  463775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  463783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  463786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  463789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463819 */     // MIs[1] Operand 1
     /*  463819 */     // No operand predicates
     /*  463819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463828 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  463828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  463831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  463848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463851 */     GIR_RootConstrainSelectedInstOperands,
     /*  463852 */     // GIR_Coverage, 7336,
     /*  463852 */     GIR_EraseRootFromParent_Done,
     /*  463853 */   // Label 7911: @463853
     /*  463853 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(463939), // Rule ID 7337 //
     /*  463858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  463861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  463869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  463872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  463875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463905 */     // MIs[1] Operand 1
     /*  463905 */     // No operand predicates
     /*  463905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  463914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  463917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  463934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463937 */     GIR_RootConstrainSelectedInstOperands,
     /*  463938 */     // GIR_Coverage, 7337,
     /*  463938 */     GIR_EraseRootFromParent_Done,
     /*  463939 */   // Label 7912: @463939
     /*  463939 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(464025), // Rule ID 7340 //
     /*  463944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  463947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  463955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  463958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  463961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463991 */     // MIs[1] Operand 1
     /*  463991 */     // No operand predicates
     /*  463991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464000 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  464000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  464003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  464020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464023 */     GIR_RootConstrainSelectedInstOperands,
     /*  464024 */     // GIR_Coverage, 7340,
     /*  464024 */     GIR_EraseRootFromParent_Done,
     /*  464025 */   // Label 7913: @464025
     /*  464025 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(464111), // Rule ID 7341 //
     /*  464030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  464033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  464038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  464041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  464044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  464047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464077 */     // MIs[1] Operand 1
     /*  464077 */     // No operand predicates
     /*  464077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464086 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  464086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  464089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  464106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464109 */     GIR_RootConstrainSelectedInstOperands,
     /*  464110 */     // GIR_Coverage, 7341,
     /*  464110 */     GIR_EraseRootFromParent_Done,
     /*  464111 */   // Label 7914: @464111
     /*  464111 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(464197), // Rule ID 7344 //
     /*  464116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  464119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  464124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  464127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  464130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  464133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464163 */     // MIs[1] Operand 1
     /*  464163 */     // No operand predicates
     /*  464163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464172 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  464172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  464175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  464192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464195 */     GIR_RootConstrainSelectedInstOperands,
     /*  464196 */     // GIR_Coverage, 7344,
     /*  464196 */     GIR_EraseRootFromParent_Done,
     /*  464197 */   // Label 7915: @464197
     /*  464197 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(464283), // Rule ID 7345 //
     /*  464202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  464205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  464210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  464213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  464216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  464219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464249 */     // MIs[1] Operand 1
     /*  464249 */     // No operand predicates
     /*  464249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464258 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  464258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  464261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  464278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464281 */     GIR_RootConstrainSelectedInstOperands,
     /*  464282 */     // GIR_Coverage, 7345,
     /*  464282 */     GIR_EraseRootFromParent_Done,
     /*  464283 */   // Label 7916: @464283
     /*  464283 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(464369), // Rule ID 7556 //
     /*  464288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  464299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  464302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  464305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464335 */     // MIs[1] Operand 1
     /*  464335 */     // No operand predicates
     /*  464335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464344 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  464347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464367 */     GIR_RootConstrainSelectedInstOperands,
     /*  464368 */     // GIR_Coverage, 7556,
     /*  464368 */     GIR_EraseRootFromParent_Done,
     /*  464369 */   // Label 7917: @464369
     /*  464369 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(464455), // Rule ID 7557 //
     /*  464374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  464385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  464388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  464391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464421 */     // MIs[1] Operand 1
     /*  464421 */     // No operand predicates
     /*  464421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464430 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  464433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464453 */     GIR_RootConstrainSelectedInstOperands,
     /*  464454 */     // GIR_Coverage, 7557,
     /*  464454 */     GIR_EraseRootFromParent_Done,
     /*  464455 */   // Label 7918: @464455
     /*  464455 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(464541), // Rule ID 7560 //
     /*  464460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  464471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  464474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  464477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464507 */     // MIs[1] Operand 1
     /*  464507 */     // No operand predicates
     /*  464507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464516 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  464519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464539 */     GIR_RootConstrainSelectedInstOperands,
     /*  464540 */     // GIR_Coverage, 7560,
     /*  464540 */     GIR_EraseRootFromParent_Done,
     /*  464541 */   // Label 7919: @464541
     /*  464541 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(464627), // Rule ID 7561 //
     /*  464546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  464557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  464560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  464563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464593 */     // MIs[1] Operand 1
     /*  464593 */     // No operand predicates
     /*  464593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464602 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  464605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464625 */     GIR_RootConstrainSelectedInstOperands,
     /*  464626 */     // GIR_Coverage, 7561,
     /*  464626 */     GIR_EraseRootFromParent_Done,
     /*  464627 */   // Label 7920: @464627
     /*  464627 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(464713), // Rule ID 7564 //
     /*  464632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  464643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  464646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  464649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464679 */     // MIs[1] Operand 1
     /*  464679 */     // No operand predicates
     /*  464679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464688 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  464691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464711 */     GIR_RootConstrainSelectedInstOperands,
     /*  464712 */     // GIR_Coverage, 7564,
     /*  464712 */     GIR_EraseRootFromParent_Done,
     /*  464713 */   // Label 7921: @464713
     /*  464713 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(464799), // Rule ID 7565 //
     /*  464718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  464729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  464732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  464735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464765 */     // MIs[1] Operand 1
     /*  464765 */     // No operand predicates
     /*  464765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464774 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  464777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464797 */     GIR_RootConstrainSelectedInstOperands,
     /*  464798 */     // GIR_Coverage, 7565,
     /*  464798 */     GIR_EraseRootFromParent_Done,
     /*  464799 */   // Label 7922: @464799
     /*  464799 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(464885), // Rule ID 7568 //
     /*  464804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  464815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  464818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  464821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464851 */     // MIs[1] Operand 1
     /*  464851 */     // No operand predicates
     /*  464851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464860 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  464863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464883 */     GIR_RootConstrainSelectedInstOperands,
     /*  464884 */     // GIR_Coverage, 7568,
     /*  464884 */     GIR_EraseRootFromParent_Done,
     /*  464885 */   // Label 7923: @464885
     /*  464885 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(464971), // Rule ID 7569 //
     /*  464890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  464901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  464904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  464907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464937 */     // MIs[1] Operand 1
     /*  464937 */     // No operand predicates
     /*  464937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464946 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  464949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464969 */     GIR_RootConstrainSelectedInstOperands,
     /*  464970 */     // GIR_Coverage, 7569,
     /*  464970 */     GIR_EraseRootFromParent_Done,
     /*  464971 */   // Label 7924: @464971
     /*  464971 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(465057), // Rule ID 7572 //
     /*  464976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  464987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  464990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  464993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465023 */     // MIs[1] Operand 1
     /*  465023 */     // No operand predicates
     /*  465023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465032 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  465035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465055 */     GIR_RootConstrainSelectedInstOperands,
     /*  465056 */     // GIR_Coverage, 7572,
     /*  465056 */     GIR_EraseRootFromParent_Done,
     /*  465057 */   // Label 7925: @465057
     /*  465057 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(465143), // Rule ID 7573 //
     /*  465062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  465073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  465076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  465079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465109 */     // MIs[1] Operand 1
     /*  465109 */     // No operand predicates
     /*  465109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465118 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  465118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  465121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465141 */     GIR_RootConstrainSelectedInstOperands,
     /*  465142 */     // GIR_Coverage, 7573,
     /*  465142 */     GIR_EraseRootFromParent_Done,
     /*  465143 */   // Label 7926: @465143
     /*  465143 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(465229), // Rule ID 7576 //
     /*  465148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  465159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  465162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  465165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465195 */     // MIs[1] Operand 1
     /*  465195 */     // No operand predicates
     /*  465195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465204 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  465207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465227 */     GIR_RootConstrainSelectedInstOperands,
     /*  465228 */     // GIR_Coverage, 7576,
     /*  465228 */     GIR_EraseRootFromParent_Done,
     /*  465229 */   // Label 7927: @465229
     /*  465229 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(465315), // Rule ID 7577 //
     /*  465234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  465245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  465248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  465251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465281 */     // MIs[1] Operand 1
     /*  465281 */     // No operand predicates
     /*  465281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465290 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  465290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  465293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465313 */     GIR_RootConstrainSelectedInstOperands,
     /*  465314 */     // GIR_Coverage, 7577,
     /*  465314 */     GIR_EraseRootFromParent_Done,
     /*  465315 */   // Label 7928: @465315
     /*  465315 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(465401), // Rule ID 7580 //
     /*  465320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  465331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  465334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  465337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465367 */     // MIs[1] Operand 1
     /*  465367 */     // No operand predicates
     /*  465367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  465379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465399 */     GIR_RootConstrainSelectedInstOperands,
     /*  465400 */     // GIR_Coverage, 7580,
     /*  465400 */     GIR_EraseRootFromParent_Done,
     /*  465401 */   // Label 7929: @465401
     /*  465401 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(465487), // Rule ID 7581 //
     /*  465406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  465417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  465420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  465423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465453 */     // MIs[1] Operand 1
     /*  465453 */     // No operand predicates
     /*  465453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465462 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  465465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465485 */     GIR_RootConstrainSelectedInstOperands,
     /*  465486 */     // GIR_Coverage, 7581,
     /*  465486 */     GIR_EraseRootFromParent_Done,
     /*  465487 */   // Label 7930: @465487
     /*  465487 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(465573), // Rule ID 7584 //
     /*  465492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  465503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  465506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  465509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465539 */     // MIs[1] Operand 1
     /*  465539 */     // No operand predicates
     /*  465539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  465551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465571 */     GIR_RootConstrainSelectedInstOperands,
     /*  465572 */     // GIR_Coverage, 7584,
     /*  465572 */     GIR_EraseRootFromParent_Done,
     /*  465573 */   // Label 7931: @465573
     /*  465573 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(465659), // Rule ID 7585 //
     /*  465578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  465589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  465592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  465595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465625 */     // MIs[1] Operand 1
     /*  465625 */     // No operand predicates
     /*  465625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465634 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  465637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465657 */     GIR_RootConstrainSelectedInstOperands,
     /*  465658 */     // GIR_Coverage, 7585,
     /*  465658 */     GIR_EraseRootFromParent_Done,
     /*  465659 */   // Label 7932: @465659
     /*  465659 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(465745), // Rule ID 7588 //
     /*  465664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  465675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  465678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  465681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465711 */     // MIs[1] Operand 1
     /*  465711 */     // No operand predicates
     /*  465711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  465723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465743 */     GIR_RootConstrainSelectedInstOperands,
     /*  465744 */     // GIR_Coverage, 7588,
     /*  465744 */     GIR_EraseRootFromParent_Done,
     /*  465745 */   // Label 7933: @465745
     /*  465745 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(465831), // Rule ID 7589 //
     /*  465750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  465761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  465764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  465767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465797 */     // MIs[1] Operand 1
     /*  465797 */     // No operand predicates
     /*  465797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465806 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  465809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465829 */     GIR_RootConstrainSelectedInstOperands,
     /*  465830 */     // GIR_Coverage, 7589,
     /*  465830 */     GIR_EraseRootFromParent_Done,
     /*  465831 */   // Label 7934: @465831
     /*  465831 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(465917), // Rule ID 7592 //
     /*  465836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  465847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  465850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  465853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465883 */     // MIs[1] Operand 1
     /*  465883 */     // No operand predicates
     /*  465883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465892 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  465895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465915 */     GIR_RootConstrainSelectedInstOperands,
     /*  465916 */     // GIR_Coverage, 7592,
     /*  465916 */     GIR_EraseRootFromParent_Done,
     /*  465917 */   // Label 7935: @465917
     /*  465917 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(466003), // Rule ID 7593 //
     /*  465922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  465933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  465936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  465939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465969 */     // MIs[1] Operand 1
     /*  465969 */     // No operand predicates
     /*  465969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  465981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466001 */     GIR_RootConstrainSelectedInstOperands,
     /*  466002 */     // GIR_Coverage, 7593,
     /*  466002 */     GIR_EraseRootFromParent_Done,
     /*  466003 */   // Label 7936: @466003
     /*  466003 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(466089), // Rule ID 7596 //
     /*  466008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  466019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  466022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  466025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  466043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466055 */     // MIs[1] Operand 1
     /*  466055 */     // No operand predicates
     /*  466055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  466067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466087 */     GIR_RootConstrainSelectedInstOperands,
     /*  466088 */     // GIR_Coverage, 7596,
     /*  466088 */     GIR_EraseRootFromParent_Done,
     /*  466089 */   // Label 7937: @466089
     /*  466089 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(466175), // Rule ID 7597 //
     /*  466094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  466105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  466108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  466111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  466129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466141 */     // MIs[1] Operand 1
     /*  466141 */     // No operand predicates
     /*  466141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466150 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  466153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466173 */     GIR_RootConstrainSelectedInstOperands,
     /*  466174 */     // GIR_Coverage, 7597,
     /*  466174 */     GIR_EraseRootFromParent_Done,
     /*  466175 */   // Label 7938: @466175
     /*  466175 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(466261), // Rule ID 7600 //
     /*  466180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  466183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  466191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  466197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466227 */     // MIs[1] Operand 1
     /*  466227 */     // No operand predicates
     /*  466227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466236 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  466239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466259 */     GIR_RootConstrainSelectedInstOperands,
     /*  466260 */     // GIR_Coverage, 7600,
     /*  466260 */     GIR_EraseRootFromParent_Done,
     /*  466261 */   // Label 7939: @466261
     /*  466261 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(466347), // Rule ID 7601 //
     /*  466266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  466269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  466277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  466283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466313 */     // MIs[1] Operand 1
     /*  466313 */     // No operand predicates
     /*  466313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  466325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466345 */     GIR_RootConstrainSelectedInstOperands,
     /*  466346 */     // GIR_Coverage, 7601,
     /*  466346 */     GIR_EraseRootFromParent_Done,
     /*  466347 */   // Label 7940: @466347
     /*  466347 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(466433), // Rule ID 7604 //
     /*  466352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  466355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  466363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  466366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  466369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466399 */     // MIs[1] Operand 1
     /*  466399 */     // No operand predicates
     /*  466399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  466411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466431 */     GIR_RootConstrainSelectedInstOperands,
     /*  466432 */     // GIR_Coverage, 7604,
     /*  466432 */     GIR_EraseRootFromParent_Done,
     /*  466433 */   // Label 7941: @466433
     /*  466433 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(466519), // Rule ID 7605 //
     /*  466438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  466441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  466449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  466452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  466455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466485 */     // MIs[1] Operand 1
     /*  466485 */     // No operand predicates
     /*  466485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466494 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  466497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466517 */     GIR_RootConstrainSelectedInstOperands,
     /*  466518 */     // GIR_Coverage, 7605,
     /*  466518 */     GIR_EraseRootFromParent_Done,
     /*  466519 */   // Label 7942: @466519
     /*  466519 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(466605), // Rule ID 7608 //
     /*  466524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  466527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  466535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  466538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  466541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466571 */     // MIs[1] Operand 1
     /*  466571 */     // No operand predicates
     /*  466571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  466583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466603 */     GIR_RootConstrainSelectedInstOperands,
     /*  466604 */     // GIR_Coverage, 7608,
     /*  466604 */     GIR_EraseRootFromParent_Done,
     /*  466605 */   // Label 7943: @466605
     /*  466605 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(466691), // Rule ID 7609 //
     /*  466610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  466613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  466621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  466624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  466627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466657 */     // MIs[1] Operand 1
     /*  466657 */     // No operand predicates
     /*  466657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466666 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  466669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466689 */     GIR_RootConstrainSelectedInstOperands,
     /*  466690 */     // GIR_Coverage, 7609,
     /*  466690 */     GIR_EraseRootFromParent_Done,
     /*  466691 */   // Label 7944: @466691
     /*  466691 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(466777), // Rule ID 7612 //
     /*  466696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  466699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  466707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  466710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  466713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  466731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466743 */     // MIs[1] Operand 1
     /*  466743 */     // No operand predicates
     /*  466743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466752 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  466755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466775 */     GIR_RootConstrainSelectedInstOperands,
     /*  466776 */     // GIR_Coverage, 7612,
     /*  466776 */     GIR_EraseRootFromParent_Done,
     /*  466777 */   // Label 7945: @466777
     /*  466777 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(466863), // Rule ID 7613 //
     /*  466782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  466785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  466793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  466796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  466799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  466817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466829 */     // MIs[1] Operand 1
     /*  466829 */     // No operand predicates
     /*  466829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466838 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  466841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466861 */     GIR_RootConstrainSelectedInstOperands,
     /*  466862 */     // GIR_Coverage, 7613,
     /*  466862 */     GIR_EraseRootFromParent_Done,
     /*  466863 */   // Label 7946: @466863
     /*  466863 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(466949), // Rule ID 7736 //
     /*  466868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  466876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  466879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  466882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466915 */     // MIs[1] Operand 1
     /*  466915 */     // No operand predicates
     /*  466915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466924 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  466927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466947 */     GIR_RootConstrainSelectedInstOperands,
     /*  466948 */     // GIR_Coverage, 7736,
     /*  466948 */     GIR_EraseRootFromParent_Done,
     /*  466949 */   // Label 7947: @466949
     /*  466949 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(467035), // Rule ID 7737 //
     /*  466954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  466962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  466965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  466968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467001 */     // MIs[1] Operand 1
     /*  467001 */     // No operand predicates
     /*  467001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467010 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  467013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467033 */     GIR_RootConstrainSelectedInstOperands,
     /*  467034 */     // GIR_Coverage, 7737,
     /*  467034 */     GIR_EraseRootFromParent_Done,
     /*  467035 */   // Label 7948: @467035
     /*  467035 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(467121), // Rule ID 7740 //
     /*  467040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  467051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  467054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  467057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467087 */     // MIs[1] Operand 1
     /*  467087 */     // No operand predicates
     /*  467087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467096 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  467099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467119 */     GIR_RootConstrainSelectedInstOperands,
     /*  467120 */     // GIR_Coverage, 7740,
     /*  467120 */     GIR_EraseRootFromParent_Done,
     /*  467121 */   // Label 7949: @467121
     /*  467121 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(467207), // Rule ID 7741 //
     /*  467126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  467137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  467140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  467143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467173 */     // MIs[1] Operand 1
     /*  467173 */     // No operand predicates
     /*  467173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467182 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  467185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467205 */     GIR_RootConstrainSelectedInstOperands,
     /*  467206 */     // GIR_Coverage, 7741,
     /*  467206 */     GIR_EraseRootFromParent_Done,
     /*  467207 */   // Label 7950: @467207
     /*  467207 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(467293), // Rule ID 7744 //
     /*  467212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  467223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  467226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  467229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467259 */     // MIs[1] Operand 1
     /*  467259 */     // No operand predicates
     /*  467259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467268 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  467271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467291 */     GIR_RootConstrainSelectedInstOperands,
     /*  467292 */     // GIR_Coverage, 7744,
     /*  467292 */     GIR_EraseRootFromParent_Done,
     /*  467293 */   // Label 7951: @467293
     /*  467293 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(467379), // Rule ID 7745 //
     /*  467298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  467309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  467312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  467315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467345 */     // MIs[1] Operand 1
     /*  467345 */     // No operand predicates
     /*  467345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467354 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  467357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467377 */     GIR_RootConstrainSelectedInstOperands,
     /*  467378 */     // GIR_Coverage, 7745,
     /*  467378 */     GIR_EraseRootFromParent_Done,
     /*  467379 */   // Label 7952: @467379
     /*  467379 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(467465), // Rule ID 7748 //
     /*  467384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  467395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  467398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  467401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467431 */     // MIs[1] Operand 1
     /*  467431 */     // No operand predicates
     /*  467431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467440 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  467443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467463 */     GIR_RootConstrainSelectedInstOperands,
     /*  467464 */     // GIR_Coverage, 7748,
     /*  467464 */     GIR_EraseRootFromParent_Done,
     /*  467465 */   // Label 7953: @467465
     /*  467465 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(467551), // Rule ID 7749 //
     /*  467470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  467481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  467484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  467487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467517 */     // MIs[1] Operand 1
     /*  467517 */     // No operand predicates
     /*  467517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467526 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  467529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467549 */     GIR_RootConstrainSelectedInstOperands,
     /*  467550 */     // GIR_Coverage, 7749,
     /*  467550 */     GIR_EraseRootFromParent_Done,
     /*  467551 */   // Label 7954: @467551
     /*  467551 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(467637), // Rule ID 7752 //
     /*  467556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  467573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467603 */     // MIs[1] Operand 1
     /*  467603 */     // No operand predicates
     /*  467603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467612 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  467615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467635 */     GIR_RootConstrainSelectedInstOperands,
     /*  467636 */     // GIR_Coverage, 7752,
     /*  467636 */     GIR_EraseRootFromParent_Done,
     /*  467637 */   // Label 7955: @467637
     /*  467637 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(467723), // Rule ID 7753 //
     /*  467642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  467659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467689 */     // MIs[1] Operand 1
     /*  467689 */     // No operand predicates
     /*  467689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  467701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467721 */     GIR_RootConstrainSelectedInstOperands,
     /*  467722 */     // GIR_Coverage, 7753,
     /*  467722 */     GIR_EraseRootFromParent_Done,
     /*  467723 */   // Label 7956: @467723
     /*  467723 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(467809), // Rule ID 7756 //
     /*  467728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  467739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  467742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  467745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467775 */     // MIs[1] Operand 1
     /*  467775 */     // No operand predicates
     /*  467775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467784 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  467787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467807 */     GIR_RootConstrainSelectedInstOperands,
     /*  467808 */     // GIR_Coverage, 7756,
     /*  467808 */     GIR_EraseRootFromParent_Done,
     /*  467809 */   // Label 7957: @467809
     /*  467809 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(467895), // Rule ID 7757 //
     /*  467814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  467825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  467828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  467831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467861 */     // MIs[1] Operand 1
     /*  467861 */     // No operand predicates
     /*  467861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  467873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467893 */     GIR_RootConstrainSelectedInstOperands,
     /*  467894 */     // GIR_Coverage, 7757,
     /*  467894 */     GIR_EraseRootFromParent_Done,
     /*  467895 */   // Label 7958: @467895
     /*  467895 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(467981), // Rule ID 7760 //
     /*  467900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  467911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  467914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  467917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467947 */     // MIs[1] Operand 1
     /*  467947 */     // No operand predicates
     /*  467947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467956 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  467956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  467959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467979 */     GIR_RootConstrainSelectedInstOperands,
     /*  467980 */     // GIR_Coverage, 7760,
     /*  467980 */     GIR_EraseRootFromParent_Done,
     /*  467981 */   // Label 7959: @467981
     /*  467981 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(468067), // Rule ID 7761 //
     /*  467986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  467997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  468000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  468003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468033 */     // MIs[1] Operand 1
     /*  468033 */     // No operand predicates
     /*  468033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468042 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  468045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468065 */     GIR_RootConstrainSelectedInstOperands,
     /*  468066 */     // GIR_Coverage, 7761,
     /*  468066 */     GIR_EraseRootFromParent_Done,
     /*  468067 */   // Label 7960: @468067
     /*  468067 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(468153), // Rule ID 7764 //
     /*  468072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  468083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  468086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  468089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468119 */     // MIs[1] Operand 1
     /*  468119 */     // No operand predicates
     /*  468119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468128 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  468131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468151 */     GIR_RootConstrainSelectedInstOperands,
     /*  468152 */     // GIR_Coverage, 7764,
     /*  468152 */     GIR_EraseRootFromParent_Done,
     /*  468153 */   // Label 7961: @468153
     /*  468153 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(468239), // Rule ID 7765 //
     /*  468158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  468169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  468172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  468175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468205 */     // MIs[1] Operand 1
     /*  468205 */     // No operand predicates
     /*  468205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468214 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  468217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468237 */     GIR_RootConstrainSelectedInstOperands,
     /*  468238 */     // GIR_Coverage, 7765,
     /*  468238 */     GIR_EraseRootFromParent_Done,
     /*  468239 */   // Label 7962: @468239
     /*  468239 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(468325), // Rule ID 7768 //
     /*  468244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  468255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  468258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  468261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468291 */     // MIs[1] Operand 1
     /*  468291 */     // No operand predicates
     /*  468291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  468303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468323 */     GIR_RootConstrainSelectedInstOperands,
     /*  468324 */     // GIR_Coverage, 7768,
     /*  468324 */     GIR_EraseRootFromParent_Done,
     /*  468325 */   // Label 7963: @468325
     /*  468325 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(468411), // Rule ID 7769 //
     /*  468330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  468341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  468344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  468347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468377 */     // MIs[1] Operand 1
     /*  468377 */     // No operand predicates
     /*  468377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  468389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468409 */     GIR_RootConstrainSelectedInstOperands,
     /*  468410 */     // GIR_Coverage, 7769,
     /*  468410 */     GIR_EraseRootFromParent_Done,
     /*  468411 */   // Label 7964: @468411
     /*  468411 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(468497), // Rule ID 7772 //
     /*  468416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  468427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  468430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  468433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468463 */     // MIs[1] Operand 1
     /*  468463 */     // No operand predicates
     /*  468463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468472 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  468475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468495 */     GIR_RootConstrainSelectedInstOperands,
     /*  468496 */     // GIR_Coverage, 7772,
     /*  468496 */     GIR_EraseRootFromParent_Done,
     /*  468497 */   // Label 7965: @468497
     /*  468497 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(468583), // Rule ID 7773 //
     /*  468502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  468513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  468516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  468519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468549 */     // MIs[1] Operand 1
     /*  468549 */     // No operand predicates
     /*  468549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468558 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  468561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468581 */     GIR_RootConstrainSelectedInstOperands,
     /*  468582 */     // GIR_Coverage, 7773,
     /*  468582 */     GIR_EraseRootFromParent_Done,
     /*  468583 */   // Label 7966: @468583
     /*  468583 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(468669), // Rule ID 7776 //
     /*  468588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  468599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  468602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  468605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468635 */     // MIs[1] Operand 1
     /*  468635 */     // No operand predicates
     /*  468635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468644 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  468647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468667 */     GIR_RootConstrainSelectedInstOperands,
     /*  468668 */     // GIR_Coverage, 7776,
     /*  468668 */     GIR_EraseRootFromParent_Done,
     /*  468669 */   // Label 7967: @468669
     /*  468669 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(468755), // Rule ID 7777 //
     /*  468674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  468685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  468688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  468691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468721 */     // MIs[1] Operand 1
     /*  468721 */     // No operand predicates
     /*  468721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468730 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  468733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468753 */     GIR_RootConstrainSelectedInstOperands,
     /*  468754 */     // GIR_Coverage, 7777,
     /*  468754 */     GIR_EraseRootFromParent_Done,
     /*  468755 */   // Label 7968: @468755
     /*  468755 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(468841), // Rule ID 7780 //
     /*  468760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  468763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  468771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  468774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  468777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468807 */     // MIs[1] Operand 1
     /*  468807 */     // No operand predicates
     /*  468807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468816 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  468819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468839 */     GIR_RootConstrainSelectedInstOperands,
     /*  468840 */     // GIR_Coverage, 7780,
     /*  468840 */     GIR_EraseRootFromParent_Done,
     /*  468841 */   // Label 7969: @468841
     /*  468841 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(468927), // Rule ID 7781 //
     /*  468846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  468849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  468857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  468860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  468863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468893 */     // MIs[1] Operand 1
     /*  468893 */     // No operand predicates
     /*  468893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468902 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  468905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468925 */     GIR_RootConstrainSelectedInstOperands,
     /*  468926 */     // GIR_Coverage, 7781,
     /*  468926 */     GIR_EraseRootFromParent_Done,
     /*  468927 */   // Label 7970: @468927
     /*  468927 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(469013), // Rule ID 7784 //
     /*  468932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  468935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  468943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  468946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  468949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468979 */     // MIs[1] Operand 1
     /*  468979 */     // No operand predicates
     /*  468979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468988 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  468991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469011 */     GIR_RootConstrainSelectedInstOperands,
     /*  469012 */     // GIR_Coverage, 7784,
     /*  469012 */     GIR_EraseRootFromParent_Done,
     /*  469013 */   // Label 7971: @469013
     /*  469013 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(469099), // Rule ID 7785 //
     /*  469018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  469021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  469026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  469029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  469032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  469035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  469065 */     // MIs[1] Operand 1
     /*  469065 */     // No operand predicates
     /*  469065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  469074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  469077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469097 */     GIR_RootConstrainSelectedInstOperands,
     /*  469098 */     // GIR_Coverage, 7785,
     /*  469098 */     GIR_EraseRootFromParent_Done,
     /*  469099 */   // Label 7972: @469099
     /*  469099 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(469185), // Rule ID 7788 //
     /*  469104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  469107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  469112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  469115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  469118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  469121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  469151 */     // MIs[1] Operand 1
     /*  469151 */     // No operand predicates
     /*  469151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  469160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  469163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469183 */     GIR_RootConstrainSelectedInstOperands,
     /*  469184 */     // GIR_Coverage, 7788,
     /*  469184 */     GIR_EraseRootFromParent_Done,
     /*  469185 */   // Label 7973: @469185
     /*  469185 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(469271), // Rule ID 7789 //
     /*  469190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  469193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  469198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  469201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  469204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  469207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  469237 */     // MIs[1] Operand 1
     /*  469237 */     // No operand predicates
     /*  469237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  469246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  469249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469269 */     GIR_RootConstrainSelectedInstOperands,
     /*  469270 */     // GIR_Coverage, 7789,
     /*  469270 */     GIR_EraseRootFromParent_Done,
     /*  469271 */   // Label 7974: @469271
     /*  469271 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(469357), // Rule ID 7792 //
     /*  469276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  469279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  469284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  469287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  469290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  469293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  469323 */     // MIs[1] Operand 1
     /*  469323 */     // No operand predicates
     /*  469323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469332 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  469332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  469335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469355 */     GIR_RootConstrainSelectedInstOperands,
     /*  469356 */     // GIR_Coverage, 7792,
     /*  469356 */     GIR_EraseRootFromParent_Done,
     /*  469357 */   // Label 7975: @469357
     /*  469357 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(469443), // Rule ID 7793 //
     /*  469362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  469365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  469370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  469373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  469376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  469379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  469409 */     // MIs[1] Operand 1
     /*  469409 */     // No operand predicates
     /*  469409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469418 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  469418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  469421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469441 */     GIR_RootConstrainSelectedInstOperands,
     /*  469442 */     // GIR_Coverage, 7793,
     /*  469442 */     GIR_EraseRootFromParent_Done,
     /*  469443 */   // Label 7976: @469443
     /*  469443 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(469532), // Rule ID 14222 //
     /*  469448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  469459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  469462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  469465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469495 */     // MIs[1] Operand 1
     /*  469495 */     // No operand predicates
     /*  469495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469504 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  469507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469530 */     GIR_RootConstrainSelectedInstOperands,
     /*  469531 */     // GIR_Coverage, 14222,
     /*  469531 */     GIR_EraseRootFromParent_Done,
     /*  469532 */   // Label 7977: @469532
     /*  469532 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(469621), // Rule ID 14223 //
     /*  469537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  469548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  469551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  469554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469584 */     // MIs[1] Operand 1
     /*  469584 */     // No operand predicates
     /*  469584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469593 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  469596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469619 */     GIR_RootConstrainSelectedInstOperands,
     /*  469620 */     // GIR_Coverage, 14223,
     /*  469620 */     GIR_EraseRootFromParent_Done,
     /*  469621 */   // Label 7978: @469621
     /*  469621 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(469710), // Rule ID 14226 //
     /*  469626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  469637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  469640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  469643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469673 */     // MIs[1] Operand 1
     /*  469673 */     // No operand predicates
     /*  469673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  469685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469708 */     GIR_RootConstrainSelectedInstOperands,
     /*  469709 */     // GIR_Coverage, 14226,
     /*  469709 */     GIR_EraseRootFromParent_Done,
     /*  469710 */   // Label 7979: @469710
     /*  469710 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(469799), // Rule ID 14227 //
     /*  469715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  469726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  469729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  469732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469762 */     // MIs[1] Operand 1
     /*  469762 */     // No operand predicates
     /*  469762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469771 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  469774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469797 */     GIR_RootConstrainSelectedInstOperands,
     /*  469798 */     // GIR_Coverage, 14227,
     /*  469798 */     GIR_EraseRootFromParent_Done,
     /*  469799 */   // Label 7980: @469799
     /*  469799 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(469888), // Rule ID 14230 //
     /*  469804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  469815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  469818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  469821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469851 */     // MIs[1] Operand 1
     /*  469851 */     // No operand predicates
     /*  469851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469860 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  469863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469886 */     GIR_RootConstrainSelectedInstOperands,
     /*  469887 */     // GIR_Coverage, 14230,
     /*  469887 */     GIR_EraseRootFromParent_Done,
     /*  469888 */   // Label 7981: @469888
     /*  469888 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(469977), // Rule ID 14231 //
     /*  469893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  469904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  469907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  469910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469940 */     // MIs[1] Operand 1
     /*  469940 */     // No operand predicates
     /*  469940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469949 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  469952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469975 */     GIR_RootConstrainSelectedInstOperands,
     /*  469976 */     // GIR_Coverage, 14231,
     /*  469976 */     GIR_EraseRootFromParent_Done,
     /*  469977 */   // Label 7982: @469977
     /*  469977 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(470066), // Rule ID 14234 //
     /*  469982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  469993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  469996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  469999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470029 */     // MIs[1] Operand 1
     /*  470029 */     // No operand predicates
     /*  470029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470038 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  470041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470064 */     GIR_RootConstrainSelectedInstOperands,
     /*  470065 */     // GIR_Coverage, 14234,
     /*  470065 */     GIR_EraseRootFromParent_Done,
     /*  470066 */   // Label 7983: @470066
     /*  470066 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(470155), // Rule ID 14235 //
     /*  470071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  470082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  470085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  470088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470118 */     // MIs[1] Operand 1
     /*  470118 */     // No operand predicates
     /*  470118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470127 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  470130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470153 */     GIR_RootConstrainSelectedInstOperands,
     /*  470154 */     // GIR_Coverage, 14235,
     /*  470154 */     GIR_EraseRootFromParent_Done,
     /*  470155 */   // Label 7984: @470155
     /*  470155 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(470244), // Rule ID 14238 //
     /*  470160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  470171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  470174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  470177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470207 */     // MIs[1] Operand 1
     /*  470207 */     // No operand predicates
     /*  470207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470216 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  470219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470242 */     GIR_RootConstrainSelectedInstOperands,
     /*  470243 */     // GIR_Coverage, 14238,
     /*  470243 */     GIR_EraseRootFromParent_Done,
     /*  470244 */   // Label 7985: @470244
     /*  470244 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(470333), // Rule ID 14239 //
     /*  470249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  470260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  470263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  470266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470296 */     // MIs[1] Operand 1
     /*  470296 */     // No operand predicates
     /*  470296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470305 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  470308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470331 */     GIR_RootConstrainSelectedInstOperands,
     /*  470332 */     // GIR_Coverage, 14239,
     /*  470332 */     GIR_EraseRootFromParent_Done,
     /*  470333 */   // Label 7986: @470333
     /*  470333 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(470422), // Rule ID 14242 //
     /*  470338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  470349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  470352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  470355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470385 */     // MIs[1] Operand 1
     /*  470385 */     // No operand predicates
     /*  470385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470394 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  470394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  470397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470420 */     GIR_RootConstrainSelectedInstOperands,
     /*  470421 */     // GIR_Coverage, 14242,
     /*  470421 */     GIR_EraseRootFromParent_Done,
     /*  470422 */   // Label 7987: @470422
     /*  470422 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(470511), // Rule ID 14243 //
     /*  470427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  470438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  470441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  470444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470474 */     // MIs[1] Operand 1
     /*  470474 */     // No operand predicates
     /*  470474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470483 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  470483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  470486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470509 */     GIR_RootConstrainSelectedInstOperands,
     /*  470510 */     // GIR_Coverage, 14243,
     /*  470510 */     GIR_EraseRootFromParent_Done,
     /*  470511 */   // Label 7988: @470511
     /*  470511 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(470600), // Rule ID 14246 //
     /*  470516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  470527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  470530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  470533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470563 */     // MIs[1] Operand 1
     /*  470563 */     // No operand predicates
     /*  470563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470572 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  470575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470598 */     GIR_RootConstrainSelectedInstOperands,
     /*  470599 */     // GIR_Coverage, 14246,
     /*  470599 */     GIR_EraseRootFromParent_Done,
     /*  470600 */   // Label 7989: @470600
     /*  470600 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(470689), // Rule ID 14247 //
     /*  470605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  470616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  470619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  470622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470652 */     // MIs[1] Operand 1
     /*  470652 */     // No operand predicates
     /*  470652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470661 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  470664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470687 */     GIR_RootConstrainSelectedInstOperands,
     /*  470688 */     // GIR_Coverage, 14247,
     /*  470688 */     GIR_EraseRootFromParent_Done,
     /*  470689 */   // Label 7990: @470689
     /*  470689 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(470778), // Rule ID 14250 //
     /*  470694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  470705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  470708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  470711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470741 */     // MIs[1] Operand 1
     /*  470741 */     // No operand predicates
     /*  470741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  470753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470776 */     GIR_RootConstrainSelectedInstOperands,
     /*  470777 */     // GIR_Coverage, 14250,
     /*  470777 */     GIR_EraseRootFromParent_Done,
     /*  470778 */   // Label 7991: @470778
     /*  470778 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(470867), // Rule ID 14251 //
     /*  470783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  470794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  470797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  470800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470830 */     // MIs[1] Operand 1
     /*  470830 */     // No operand predicates
     /*  470830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470839 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  470842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470865 */     GIR_RootConstrainSelectedInstOperands,
     /*  470866 */     // GIR_Coverage, 14251,
     /*  470866 */     GIR_EraseRootFromParent_Done,
     /*  470867 */   // Label 7992: @470867
     /*  470867 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(470956), // Rule ID 14254 //
     /*  470872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  470883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  470886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  470889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470919 */     // MIs[1] Operand 1
     /*  470919 */     // No operand predicates
     /*  470919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470928 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  470928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  470931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470954 */     GIR_RootConstrainSelectedInstOperands,
     /*  470955 */     // GIR_Coverage, 14254,
     /*  470955 */     GIR_EraseRootFromParent_Done,
     /*  470956 */   // Label 7993: @470956
     /*  470956 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(471045), // Rule ID 14255 //
     /*  470961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  470972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  470975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  470978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471008 */     // MIs[1] Operand 1
     /*  471008 */     // No operand predicates
     /*  471008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471017 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  471017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  471020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471043 */     GIR_RootConstrainSelectedInstOperands,
     /*  471044 */     // GIR_Coverage, 14255,
     /*  471044 */     GIR_EraseRootFromParent_Done,
     /*  471045 */   // Label 7994: @471045
     /*  471045 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(471134), // Rule ID 14258 //
     /*  471050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  471053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  471061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  471064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  471067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471097 */     // MIs[1] Operand 1
     /*  471097 */     // No operand predicates
     /*  471097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  471106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  471109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471132 */     GIR_RootConstrainSelectedInstOperands,
     /*  471133 */     // GIR_Coverage, 14258,
     /*  471133 */     GIR_EraseRootFromParent_Done,
     /*  471134 */   // Label 7995: @471134
     /*  471134 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(471223), // Rule ID 14259 //
     /*  471139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  471142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  471150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  471153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  471156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471186 */     // MIs[1] Operand 1
     /*  471186 */     // No operand predicates
     /*  471186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471195 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  471195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  471198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471221 */     GIR_RootConstrainSelectedInstOperands,
     /*  471222 */     // GIR_Coverage, 14259,
     /*  471222 */     GIR_EraseRootFromParent_Done,
     /*  471223 */   // Label 7996: @471223
     /*  471223 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(471312), // Rule ID 14262 //
     /*  471228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  471239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  471242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  471245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471275 */     // MIs[1] Operand 1
     /*  471275 */     // No operand predicates
     /*  471275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471284 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  471287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471310 */     GIR_RootConstrainSelectedInstOperands,
     /*  471311 */     // GIR_Coverage, 14262,
     /*  471311 */     GIR_EraseRootFromParent_Done,
     /*  471312 */   // Label 7997: @471312
     /*  471312 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(471401), // Rule ID 14263 //
     /*  471317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  471328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  471331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  471334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471364 */     // MIs[1] Operand 1
     /*  471364 */     // No operand predicates
     /*  471364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471373 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  471376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471399 */     GIR_RootConstrainSelectedInstOperands,
     /*  471400 */     // GIR_Coverage, 14263,
     /*  471400 */     GIR_EraseRootFromParent_Done,
     /*  471401 */   // Label 7998: @471401
     /*  471401 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(471490), // Rule ID 14266 //
     /*  471406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  471417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  471420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  471423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471453 */     // MIs[1] Operand 1
     /*  471453 */     // No operand predicates
     /*  471453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471462 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  471465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471488 */     GIR_RootConstrainSelectedInstOperands,
     /*  471489 */     // GIR_Coverage, 14266,
     /*  471489 */     GIR_EraseRootFromParent_Done,
     /*  471490 */   // Label 7999: @471490
     /*  471490 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(471579), // Rule ID 14267 //
     /*  471495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  471506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  471509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  471512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471542 */     // MIs[1] Operand 1
     /*  471542 */     // No operand predicates
     /*  471542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471551 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  471554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471577 */     GIR_RootConstrainSelectedInstOperands,
     /*  471578 */     // GIR_Coverage, 14267,
     /*  471578 */     GIR_EraseRootFromParent_Done,
     /*  471579 */   // Label 8000: @471579
     /*  471579 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(471668), // Rule ID 14270 //
     /*  471584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  471595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  471598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  471601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471631 */     // MIs[1] Operand 1
     /*  471631 */     // No operand predicates
     /*  471631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471640 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  471643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471666 */     GIR_RootConstrainSelectedInstOperands,
     /*  471667 */     // GIR_Coverage, 14270,
     /*  471667 */     GIR_EraseRootFromParent_Done,
     /*  471668 */   // Label 8001: @471668
     /*  471668 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(471757), // Rule ID 14271 //
     /*  471673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  471684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  471687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  471690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471720 */     // MIs[1] Operand 1
     /*  471720 */     // No operand predicates
     /*  471720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471729 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  471732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471755 */     GIR_RootConstrainSelectedInstOperands,
     /*  471756 */     // GIR_Coverage, 14271,
     /*  471756 */     GIR_EraseRootFromParent_Done,
     /*  471757 */   // Label 8002: @471757
     /*  471757 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(471846), // Rule ID 14274 //
     /*  471762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  471773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  471776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  471779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471809 */     // MIs[1] Operand 1
     /*  471809 */     // No operand predicates
     /*  471809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  471818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  471821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471844 */     GIR_RootConstrainSelectedInstOperands,
     /*  471845 */     // GIR_Coverage, 14274,
     /*  471845 */     GIR_EraseRootFromParent_Done,
     /*  471846 */   // Label 8003: @471846
     /*  471846 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(471935), // Rule ID 14275 //
     /*  471851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  471862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  471865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  471868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471898 */     // MIs[1] Operand 1
     /*  471898 */     // No operand predicates
     /*  471898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471907 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  471907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  471910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471933 */     GIR_RootConstrainSelectedInstOperands,
     /*  471934 */     // GIR_Coverage, 14275,
     /*  471934 */     GIR_EraseRootFromParent_Done,
     /*  471935 */   // Label 8004: @471935
     /*  471935 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(472024), // Rule ID 14278 //
     /*  471940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  471951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  471954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  471957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471987 */     // MIs[1] Operand 1
     /*  471987 */     // No operand predicates
     /*  471987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  471996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  471999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472022 */     GIR_RootConstrainSelectedInstOperands,
     /*  472023 */     // GIR_Coverage, 14278,
     /*  472023 */     GIR_EraseRootFromParent_Done,
     /*  472024 */   // Label 8005: @472024
     /*  472024 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(472113), // Rule ID 14279 //
     /*  472029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  472040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  472043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  472046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472076 */     // MIs[1] Operand 1
     /*  472076 */     // No operand predicates
     /*  472076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472085 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  472088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472111 */     GIR_RootConstrainSelectedInstOperands,
     /*  472112 */     // GIR_Coverage, 14279,
     /*  472112 */     GIR_EraseRootFromParent_Done,
     /*  472113 */   // Label 8006: @472113
     /*  472113 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(472202), // Rule ID 14282 //
     /*  472118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  472129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  472132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  472135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472165 */     // MIs[1] Operand 1
     /*  472165 */     // No operand predicates
     /*  472165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472174 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  472174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  472177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472200 */     GIR_RootConstrainSelectedInstOperands,
     /*  472201 */     // GIR_Coverage, 14282,
     /*  472201 */     GIR_EraseRootFromParent_Done,
     /*  472202 */   // Label 8007: @472202
     /*  472202 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(472291), // Rule ID 14283 //
     /*  472207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  472218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  472221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  472224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472254 */     // MIs[1] Operand 1
     /*  472254 */     // No operand predicates
     /*  472254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472263 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  472266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472289 */     GIR_RootConstrainSelectedInstOperands,
     /*  472290 */     // GIR_Coverage, 14283,
     /*  472290 */     GIR_EraseRootFromParent_Done,
     /*  472291 */   // Label 8008: @472291
     /*  472291 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(472380), // Rule ID 14286 //
     /*  472296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  472307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  472310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  472313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472343 */     // MIs[1] Operand 1
     /*  472343 */     // No operand predicates
     /*  472343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  472355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472378 */     GIR_RootConstrainSelectedInstOperands,
     /*  472379 */     // GIR_Coverage, 14286,
     /*  472379 */     GIR_EraseRootFromParent_Done,
     /*  472380 */   // Label 8009: @472380
     /*  472380 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(472469), // Rule ID 14287 //
     /*  472385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  472396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  472399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  472402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472432 */     // MIs[1] Operand 1
     /*  472432 */     // No operand predicates
     /*  472432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  472444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472467 */     GIR_RootConstrainSelectedInstOperands,
     /*  472468 */     // GIR_Coverage, 14287,
     /*  472468 */     GIR_EraseRootFromParent_Done,
     /*  472469 */   // Label 8010: @472469
     /*  472469 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(472558), // Rule ID 14290 //
     /*  472474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  472485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  472488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  472491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472521 */     // MIs[1] Operand 1
     /*  472521 */     // No operand predicates
     /*  472521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472530 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  472533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472556 */     GIR_RootConstrainSelectedInstOperands,
     /*  472557 */     // GIR_Coverage, 14290,
     /*  472557 */     GIR_EraseRootFromParent_Done,
     /*  472558 */   // Label 8011: @472558
     /*  472558 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(472647), // Rule ID 14291 //
     /*  472563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  472574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  472577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  472580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472610 */     // MIs[1] Operand 1
     /*  472610 */     // No operand predicates
     /*  472610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472619 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  472622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472645 */     GIR_RootConstrainSelectedInstOperands,
     /*  472646 */     // GIR_Coverage, 14291,
     /*  472646 */     GIR_EraseRootFromParent_Done,
     /*  472647 */   // Label 8012: @472647
     /*  472647 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(472736), // Rule ID 14294 //
     /*  472652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  472663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  472666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  472669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472699 */     // MIs[1] Operand 1
     /*  472699 */     // No operand predicates
     /*  472699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472708 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  472711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472734 */     GIR_RootConstrainSelectedInstOperands,
     /*  472735 */     // GIR_Coverage, 14294,
     /*  472735 */     GIR_EraseRootFromParent_Done,
     /*  472736 */   // Label 8013: @472736
     /*  472736 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(472825), // Rule ID 14295 //
     /*  472741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  472752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  472755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  472758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472788 */     // MIs[1] Operand 1
     /*  472788 */     // No operand predicates
     /*  472788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472797 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  472800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472823 */     GIR_RootConstrainSelectedInstOperands,
     /*  472824 */     // GIR_Coverage, 14295,
     /*  472824 */     GIR_EraseRootFromParent_Done,
     /*  472825 */   // Label 8014: @472825
     /*  472825 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(472914), // Rule ID 14298 //
     /*  472830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  472833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  472841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  472844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  472847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472877 */     // MIs[1] Operand 1
     /*  472877 */     // No operand predicates
     /*  472877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  472886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  472889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472912 */     GIR_RootConstrainSelectedInstOperands,
     /*  472913 */     // GIR_Coverage, 14298,
     /*  472913 */     GIR_EraseRootFromParent_Done,
     /*  472914 */   // Label 8015: @472914
     /*  472914 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(473003), // Rule ID 14299 //
     /*  472919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  472922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  472930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  472933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  472936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472966 */     // MIs[1] Operand 1
     /*  472966 */     // No operand predicates
     /*  472966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472975 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  472975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  472978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473001 */     GIR_RootConstrainSelectedInstOperands,
     /*  473002 */     // GIR_Coverage, 14299,
     /*  473002 */     GIR_EraseRootFromParent_Done,
     /*  473003 */   // Label 8016: @473003
     /*  473003 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(473092), // Rule ID 14302 //
     /*  473008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  473016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  473019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  473022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  473025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473055 */     // MIs[1] Operand 1
     /*  473055 */     // No operand predicates
     /*  473055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  473067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473090 */     GIR_RootConstrainSelectedInstOperands,
     /*  473091 */     // GIR_Coverage, 14302,
     /*  473091 */     GIR_EraseRootFromParent_Done,
     /*  473092 */   // Label 8017: @473092
     /*  473092 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(473181), // Rule ID 14303 //
     /*  473097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  473105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  473108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  473111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  473114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473144 */     // MIs[1] Operand 1
     /*  473144 */     // No operand predicates
     /*  473144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473153 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  473156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473179 */     GIR_RootConstrainSelectedInstOperands,
     /*  473180 */     // GIR_Coverage, 14303,
     /*  473180 */     GIR_EraseRootFromParent_Done,
     /*  473181 */   // Label 8018: @473181
     /*  473181 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(473270), // Rule ID 14306 //
     /*  473186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  473194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  473197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  473200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  473203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473233 */     // MIs[1] Operand 1
     /*  473233 */     // No operand predicates
     /*  473233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473242 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  473245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473268 */     GIR_RootConstrainSelectedInstOperands,
     /*  473269 */     // GIR_Coverage, 14306,
     /*  473269 */     GIR_EraseRootFromParent_Done,
     /*  473270 */   // Label 8019: @473270
     /*  473270 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(473359), // Rule ID 14307 //
     /*  473275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  473283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  473286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  473289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  473292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473322 */     // MIs[1] Operand 1
     /*  473322 */     // No operand predicates
     /*  473322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473331 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  473334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473357 */     GIR_RootConstrainSelectedInstOperands,
     /*  473358 */     // GIR_Coverage, 14307,
     /*  473358 */     GIR_EraseRootFromParent_Done,
     /*  473359 */   // Label 8020: @473359
     /*  473359 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(473448), // Rule ID 14486 //
     /*  473364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  473375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  473378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  473381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473411 */     // MIs[1] Operand 1
     /*  473411 */     // No operand predicates
     /*  473411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473420 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  473423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473446 */     GIR_RootConstrainSelectedInstOperands,
     /*  473447 */     // GIR_Coverage, 14486,
     /*  473447 */     GIR_EraseRootFromParent_Done,
     /*  473448 */   // Label 8021: @473448
     /*  473448 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(473537), // Rule ID 14487 //
     /*  473453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  473464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  473467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  473470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473500 */     // MIs[1] Operand 1
     /*  473500 */     // No operand predicates
     /*  473500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473509 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  473512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473535 */     GIR_RootConstrainSelectedInstOperands,
     /*  473536 */     // GIR_Coverage, 14487,
     /*  473536 */     GIR_EraseRootFromParent_Done,
     /*  473537 */   // Label 8022: @473537
     /*  473537 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(473626), // Rule ID 14490 //
     /*  473542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  473553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  473556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  473559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473589 */     // MIs[1] Operand 1
     /*  473589 */     // No operand predicates
     /*  473589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473598 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  473601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473624 */     GIR_RootConstrainSelectedInstOperands,
     /*  473625 */     // GIR_Coverage, 14490,
     /*  473625 */     GIR_EraseRootFromParent_Done,
     /*  473626 */   // Label 8023: @473626
     /*  473626 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(473715), // Rule ID 14491 //
     /*  473631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  473642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  473645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  473648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473678 */     // MIs[1] Operand 1
     /*  473678 */     // No operand predicates
     /*  473678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473687 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  473690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473713 */     GIR_RootConstrainSelectedInstOperands,
     /*  473714 */     // GIR_Coverage, 14491,
     /*  473714 */     GIR_EraseRootFromParent_Done,
     /*  473715 */   // Label 8024: @473715
     /*  473715 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(473804), // Rule ID 14494 //
     /*  473720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  473731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  473734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  473737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473767 */     // MIs[1] Operand 1
     /*  473767 */     // No operand predicates
     /*  473767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473776 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  473779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473802 */     GIR_RootConstrainSelectedInstOperands,
     /*  473803 */     // GIR_Coverage, 14494,
     /*  473803 */     GIR_EraseRootFromParent_Done,
     /*  473804 */   // Label 8025: @473804
     /*  473804 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(473893), // Rule ID 14495 //
     /*  473809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  473820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  473823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  473826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473856 */     // MIs[1] Operand 1
     /*  473856 */     // No operand predicates
     /*  473856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473865 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  473868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473891 */     GIR_RootConstrainSelectedInstOperands,
     /*  473892 */     // GIR_Coverage, 14495,
     /*  473892 */     GIR_EraseRootFromParent_Done,
     /*  473893 */   // Label 8026: @473893
     /*  473893 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(473982), // Rule ID 14498 //
     /*  473898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  473909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  473912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  473915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473945 */     // MIs[1] Operand 1
     /*  473945 */     // No operand predicates
     /*  473945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473954 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  473954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  473957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473980 */     GIR_RootConstrainSelectedInstOperands,
     /*  473981 */     // GIR_Coverage, 14498,
     /*  473981 */     GIR_EraseRootFromParent_Done,
     /*  473982 */   // Label 8027: @473982
     /*  473982 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(474071), // Rule ID 14499 //
     /*  473987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  473998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  474001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  474004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474034 */     // MIs[1] Operand 1
     /*  474034 */     // No operand predicates
     /*  474034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474043 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  474046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474069 */     GIR_RootConstrainSelectedInstOperands,
     /*  474070 */     // GIR_Coverage, 14499,
     /*  474070 */     GIR_EraseRootFromParent_Done,
     /*  474071 */   // Label 8028: @474071
     /*  474071 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(474160), // Rule ID 14502 //
     /*  474076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  474093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474123 */     // MIs[1] Operand 1
     /*  474123 */     // No operand predicates
     /*  474123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474132 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  474135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474158 */     GIR_RootConstrainSelectedInstOperands,
     /*  474159 */     // GIR_Coverage, 14502,
     /*  474159 */     GIR_EraseRootFromParent_Done,
     /*  474160 */   // Label 8029: @474160
     /*  474160 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(474249), // Rule ID 14503 //
     /*  474165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  474182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474212 */     // MIs[1] Operand 1
     /*  474212 */     // No operand predicates
     /*  474212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474221 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  474224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474247 */     GIR_RootConstrainSelectedInstOperands,
     /*  474248 */     // GIR_Coverage, 14503,
     /*  474248 */     GIR_EraseRootFromParent_Done,
     /*  474249 */   // Label 8030: @474249
     /*  474249 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(474338), // Rule ID 14506 //
     /*  474254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  474265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  474268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  474271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474301 */     // MIs[1] Operand 1
     /*  474301 */     // No operand predicates
     /*  474301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474310 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  474313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474336 */     GIR_RootConstrainSelectedInstOperands,
     /*  474337 */     // GIR_Coverage, 14506,
     /*  474337 */     GIR_EraseRootFromParent_Done,
     /*  474338 */   // Label 8031: @474338
     /*  474338 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(474427), // Rule ID 14507 //
     /*  474343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  474354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  474357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  474360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474390 */     // MIs[1] Operand 1
     /*  474390 */     // No operand predicates
     /*  474390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474399 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  474402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474425 */     GIR_RootConstrainSelectedInstOperands,
     /*  474426 */     // GIR_Coverage, 14507,
     /*  474426 */     GIR_EraseRootFromParent_Done,
     /*  474427 */   // Label 8032: @474427
     /*  474427 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(474516), // Rule ID 14510 //
     /*  474432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  474443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  474446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  474449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474479 */     // MIs[1] Operand 1
     /*  474479 */     // No operand predicates
     /*  474479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474488 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  474491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474514 */     GIR_RootConstrainSelectedInstOperands,
     /*  474515 */     // GIR_Coverage, 14510,
     /*  474515 */     GIR_EraseRootFromParent_Done,
     /*  474516 */   // Label 8033: @474516
     /*  474516 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(474605), // Rule ID 14511 //
     /*  474521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  474532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  474535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  474538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474568 */     // MIs[1] Operand 1
     /*  474568 */     // No operand predicates
     /*  474568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474577 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  474580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474603 */     GIR_RootConstrainSelectedInstOperands,
     /*  474604 */     // GIR_Coverage, 14511,
     /*  474604 */     GIR_EraseRootFromParent_Done,
     /*  474605 */   // Label 8034: @474605
     /*  474605 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(474694), // Rule ID 14514 //
     /*  474610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  474621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  474624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  474627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474657 */     // MIs[1] Operand 1
     /*  474657 */     // No operand predicates
     /*  474657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474666 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  474669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474692 */     GIR_RootConstrainSelectedInstOperands,
     /*  474693 */     // GIR_Coverage, 14514,
     /*  474693 */     GIR_EraseRootFromParent_Done,
     /*  474694 */   // Label 8035: @474694
     /*  474694 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(474783), // Rule ID 14515 //
     /*  474699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  474710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  474713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  474716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474746 */     // MIs[1] Operand 1
     /*  474746 */     // No operand predicates
     /*  474746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474755 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  474758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474781 */     GIR_RootConstrainSelectedInstOperands,
     /*  474782 */     // GIR_Coverage, 14515,
     /*  474782 */     GIR_EraseRootFromParent_Done,
     /*  474783 */   // Label 8036: @474783
     /*  474783 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(474872), // Rule ID 14518 //
     /*  474788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  474799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  474802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  474805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474835 */     // MIs[1] Operand 1
     /*  474835 */     // No operand predicates
     /*  474835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474844 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  474847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474870 */     GIR_RootConstrainSelectedInstOperands,
     /*  474871 */     // GIR_Coverage, 14518,
     /*  474871 */     GIR_EraseRootFromParent_Done,
     /*  474872 */   // Label 8037: @474872
     /*  474872 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(474961), // Rule ID 14519 //
     /*  474877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  474888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  474891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  474894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474924 */     // MIs[1] Operand 1
     /*  474924 */     // No operand predicates
     /*  474924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474933 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  474936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474959 */     GIR_RootConstrainSelectedInstOperands,
     /*  474960 */     // GIR_Coverage, 14519,
     /*  474960 */     GIR_EraseRootFromParent_Done,
     /*  474961 */   // Label 8038: @474961
     /*  474961 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(475050), // Rule ID 14522 //
     /*  474966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  474969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  474977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  474980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  474983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475013 */     // MIs[1] Operand 1
     /*  475013 */     // No operand predicates
     /*  475013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475022 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  475022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  475025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  475042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475048 */     GIR_RootConstrainSelectedInstOperands,
     /*  475049 */     // GIR_Coverage, 14522,
     /*  475049 */     GIR_EraseRootFromParent_Done,
     /*  475050 */   // Label 8039: @475050
     /*  475050 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(475139), // Rule ID 14523 //
     /*  475055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  475058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  475066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  475069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  475072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475102 */     // MIs[1] Operand 1
     /*  475102 */     // No operand predicates
     /*  475102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475111 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  475111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  475114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  475131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475137 */     GIR_RootConstrainSelectedInstOperands,
     /*  475138 */     // GIR_Coverage, 14523,
     /*  475138 */     GIR_EraseRootFromParent_Done,
     /*  475139 */   // Label 8040: @475139
     /*  475139 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(475228), // Rule ID 14526 //
     /*  475144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  475155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  475158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475191 */     // MIs[1] Operand 1
     /*  475191 */     // No operand predicates
     /*  475191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  475203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475226 */     GIR_RootConstrainSelectedInstOperands,
     /*  475227 */     // GIR_Coverage, 14526,
     /*  475227 */     GIR_EraseRootFromParent_Done,
     /*  475228 */   // Label 8041: @475228
     /*  475228 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(475317), // Rule ID 14527 //
     /*  475233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  475244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  475247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475280 */     // MIs[1] Operand 1
     /*  475280 */     // No operand predicates
     /*  475280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475289 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  475292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475315 */     GIR_RootConstrainSelectedInstOperands,
     /*  475316 */     // GIR_Coverage, 14527,
     /*  475316 */     GIR_EraseRootFromParent_Done,
     /*  475317 */   // Label 8042: @475317
     /*  475317 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(475406), // Rule ID 14530 //
     /*  475322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  475333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  475336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475369 */     // MIs[1] Operand 1
     /*  475369 */     // No operand predicates
     /*  475369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475378 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  475381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475404 */     GIR_RootConstrainSelectedInstOperands,
     /*  475405 */     // GIR_Coverage, 14530,
     /*  475405 */     GIR_EraseRootFromParent_Done,
     /*  475406 */   // Label 8043: @475406
     /*  475406 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(475495), // Rule ID 14531 //
     /*  475411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  475422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  475425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475458 */     // MIs[1] Operand 1
     /*  475458 */     // No operand predicates
     /*  475458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475467 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  475470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475493 */     GIR_RootConstrainSelectedInstOperands,
     /*  475494 */     // GIR_Coverage, 14531,
     /*  475494 */     GIR_EraseRootFromParent_Done,
     /*  475495 */   // Label 8044: @475495
     /*  475495 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(475584), // Rule ID 14534 //
     /*  475500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  475511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  475514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  475517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475547 */     // MIs[1] Operand 1
     /*  475547 */     // No operand predicates
     /*  475547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475556 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  475559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475582 */     GIR_RootConstrainSelectedInstOperands,
     /*  475583 */     // GIR_Coverage, 14534,
     /*  475583 */     GIR_EraseRootFromParent_Done,
     /*  475584 */   // Label 8045: @475584
     /*  475584 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(475673), // Rule ID 14535 //
     /*  475589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  475600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  475603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  475606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475636 */     // MIs[1] Operand 1
     /*  475636 */     // No operand predicates
     /*  475636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475645 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  475648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475671 */     GIR_RootConstrainSelectedInstOperands,
     /*  475672 */     // GIR_Coverage, 14535,
     /*  475672 */     GIR_EraseRootFromParent_Done,
     /*  475673 */   // Label 8046: @475673
     /*  475673 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(475762), // Rule ID 14538 //
     /*  475678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  475689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  475692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  475695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475725 */     // MIs[1] Operand 1
     /*  475725 */     // No operand predicates
     /*  475725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  475737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475760 */     GIR_RootConstrainSelectedInstOperands,
     /*  475761 */     // GIR_Coverage, 14538,
     /*  475761 */     GIR_EraseRootFromParent_Done,
     /*  475762 */   // Label 8047: @475762
     /*  475762 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(475851), // Rule ID 14539 //
     /*  475767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  475778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  475781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  475784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475814 */     // MIs[1] Operand 1
     /*  475814 */     // No operand predicates
     /*  475814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475823 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  475826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475849 */     GIR_RootConstrainSelectedInstOperands,
     /*  475850 */     // GIR_Coverage, 14539,
     /*  475850 */     GIR_EraseRootFromParent_Done,
     /*  475851 */   // Label 8048: @475851
     /*  475851 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(475940), // Rule ID 14542 //
     /*  475856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  475867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  475870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  475873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475903 */     // MIs[1] Operand 1
     /*  475903 */     // No operand predicates
     /*  475903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475912 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  475915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475938 */     GIR_RootConstrainSelectedInstOperands,
     /*  475939 */     // GIR_Coverage, 14542,
     /*  475939 */     GIR_EraseRootFromParent_Done,
     /*  475940 */   // Label 8049: @475940
     /*  475940 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(476029), // Rule ID 14543 //
     /*  475945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  475956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  475959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  475962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475992 */     // MIs[1] Operand 1
     /*  475992 */     // No operand predicates
     /*  475992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476001 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  476001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  476004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476027 */     GIR_RootConstrainSelectedInstOperands,
     /*  476028 */     // GIR_Coverage, 14543,
     /*  476028 */     GIR_EraseRootFromParent_Done,
     /*  476029 */   // Label 8050: @476029
     /*  476029 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(476118), // Rule ID 14546 //
     /*  476034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  476045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  476048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  476051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476081 */     // MIs[1] Operand 1
     /*  476081 */     // No operand predicates
     /*  476081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476090 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  476090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  476093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476116 */     GIR_RootConstrainSelectedInstOperands,
     /*  476117 */     // GIR_Coverage, 14546,
     /*  476117 */     GIR_EraseRootFromParent_Done,
     /*  476118 */   // Label 8051: @476118
     /*  476118 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(476207), // Rule ID 14547 //
     /*  476123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  476134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  476137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  476140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476170 */     // MIs[1] Operand 1
     /*  476170 */     // No operand predicates
     /*  476170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476179 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  476179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  476182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476205 */     GIR_RootConstrainSelectedInstOperands,
     /*  476206 */     // GIR_Coverage, 14547,
     /*  476206 */     GIR_EraseRootFromParent_Done,
     /*  476207 */   // Label 8052: @476207
     /*  476207 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(476296), // Rule ID 14550 //
     /*  476212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  476223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  476226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476259 */     // MIs[1] Operand 1
     /*  476259 */     // No operand predicates
     /*  476259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  476271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476294 */     GIR_RootConstrainSelectedInstOperands,
     /*  476295 */     // GIR_Coverage, 14550,
     /*  476295 */     GIR_EraseRootFromParent_Done,
     /*  476296 */   // Label 8053: @476296
     /*  476296 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(476385), // Rule ID 14551 //
     /*  476301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  476312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  476315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476348 */     // MIs[1] Operand 1
     /*  476348 */     // No operand predicates
     /*  476348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  476360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476383 */     GIR_RootConstrainSelectedInstOperands,
     /*  476384 */     // GIR_Coverage, 14551,
     /*  476384 */     GIR_EraseRootFromParent_Done,
     /*  476385 */   // Label 8054: @476385
     /*  476385 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(476474), // Rule ID 14554 //
     /*  476390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  476401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  476404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476437 */     // MIs[1] Operand 1
     /*  476437 */     // No operand predicates
     /*  476437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  476449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476472 */     GIR_RootConstrainSelectedInstOperands,
     /*  476473 */     // GIR_Coverage, 14554,
     /*  476473 */     GIR_EraseRootFromParent_Done,
     /*  476474 */   // Label 8055: @476474
     /*  476474 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(476563), // Rule ID 14555 //
     /*  476479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  476490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  476493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476526 */     // MIs[1] Operand 1
     /*  476526 */     // No operand predicates
     /*  476526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476535 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  476538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476561 */     GIR_RootConstrainSelectedInstOperands,
     /*  476562 */     // GIR_Coverage, 14555,
     /*  476562 */     GIR_EraseRootFromParent_Done,
     /*  476563 */   // Label 8056: @476563
     /*  476563 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(476652), // Rule ID 14558 //
     /*  476568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  476579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  476582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  476585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476615 */     // MIs[1] Operand 1
     /*  476615 */     // No operand predicates
     /*  476615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476624 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  476627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476650 */     GIR_RootConstrainSelectedInstOperands,
     /*  476651 */     // GIR_Coverage, 14558,
     /*  476651 */     GIR_EraseRootFromParent_Done,
     /*  476652 */   // Label 8057: @476652
     /*  476652 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(476741), // Rule ID 14559 //
     /*  476657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  476668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  476671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  476674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476704 */     // MIs[1] Operand 1
     /*  476704 */     // No operand predicates
     /*  476704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476713 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  476716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476739 */     GIR_RootConstrainSelectedInstOperands,
     /*  476740 */     // GIR_Coverage, 14559,
     /*  476740 */     GIR_EraseRootFromParent_Done,
     /*  476741 */   // Label 8058: @476741
     /*  476741 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(476830), // Rule ID 14562 //
     /*  476746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  476749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  476757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  476760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  476763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476793 */     // MIs[1] Operand 1
     /*  476793 */     // No operand predicates
     /*  476793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  476802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  476805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476828 */     GIR_RootConstrainSelectedInstOperands,
     /*  476829 */     // GIR_Coverage, 14562,
     /*  476829 */     GIR_EraseRootFromParent_Done,
     /*  476830 */   // Label 8059: @476830
     /*  476830 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(476919), // Rule ID 14563 //
     /*  476835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  476838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  476846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  476849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  476852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476882 */     // MIs[1] Operand 1
     /*  476882 */     // No operand predicates
     /*  476882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  476891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  476894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476917 */     GIR_RootConstrainSelectedInstOperands,
     /*  476918 */     // GIR_Coverage, 14563,
     /*  476918 */     GIR_EraseRootFromParent_Done,
     /*  476919 */   // Label 8060: @476919
     /*  476919 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(477008), // Rule ID 14566 //
     /*  476924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  476927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  476935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  476938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  476941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476971 */     // MIs[1] Operand 1
     /*  476971 */     // No operand predicates
     /*  476971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476980 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  476980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  476983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  477006 */     GIR_RootConstrainSelectedInstOperands,
     /*  477007 */     // GIR_Coverage, 14566,
     /*  477007 */     GIR_EraseRootFromParent_Done,
     /*  477008 */   // Label 8061: @477008
     /*  477008 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(477097), // Rule ID 14567 //
     /*  477013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  477016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  477021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  477024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  477027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  477030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  477060 */     // MIs[1] Operand 1
     /*  477060 */     // No operand predicates
     /*  477060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477069 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  477072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  477095 */     GIR_RootConstrainSelectedInstOperands,
     /*  477096 */     // GIR_Coverage, 14567,
     /*  477096 */     GIR_EraseRootFromParent_Done,
     /*  477097 */   // Label 8062: @477097
     /*  477097 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(477186), // Rule ID 14570 //
     /*  477102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  477105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  477110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  477113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  477116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  477119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  477149 */     // MIs[1] Operand 1
     /*  477149 */     // No operand predicates
     /*  477149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  477158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  477161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  477184 */     GIR_RootConstrainSelectedInstOperands,
     /*  477185 */     // GIR_Coverage, 14570,
     /*  477185 */     GIR_EraseRootFromParent_Done,
     /*  477186 */   // Label 8063: @477186
     /*  477186 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(477275), // Rule ID 14571 //
     /*  477191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  477194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  477199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  477202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  477205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  477208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  477238 */     // MIs[1] Operand 1
     /*  477238 */     // No operand predicates
     /*  477238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477247 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  477250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  477273 */     GIR_RootConstrainSelectedInstOperands,
     /*  477274 */     // GIR_Coverage, 14571,
     /*  477274 */     GIR_EraseRootFromParent_Done,
     /*  477275 */   // Label 8064: @477275
     /*  477275 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(477361), // Rule ID 24666 //
     /*  477280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  477291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  477294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  477297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477327 */     // MIs[1] Operand 1
     /*  477327 */     // No operand predicates
     /*  477327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477336 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  477336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  477339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477359 */     GIR_RootConstrainSelectedInstOperands,
     /*  477360 */     // GIR_Coverage, 24666,
     /*  477360 */     GIR_EraseRootFromParent_Done,
     /*  477361 */   // Label 8065: @477361
     /*  477361 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(477447), // Rule ID 24667 //
     /*  477366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  477377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  477380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  477383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477413 */     // MIs[1] Operand 1
     /*  477413 */     // No operand predicates
     /*  477413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477422 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  477422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  477425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477445 */     GIR_RootConstrainSelectedInstOperands,
     /*  477446 */     // GIR_Coverage, 24667,
     /*  477446 */     GIR_EraseRootFromParent_Done,
     /*  477447 */   // Label 8066: @477447
     /*  477447 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(477533), // Rule ID 24670 //
     /*  477452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  477463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  477466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  477469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477499 */     // MIs[1] Operand 1
     /*  477499 */     // No operand predicates
     /*  477499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477508 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  477508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477531 */     GIR_RootConstrainSelectedInstOperands,
     /*  477532 */     // GIR_Coverage, 24670,
     /*  477532 */     GIR_EraseRootFromParent_Done,
     /*  477533 */   // Label 8067: @477533
     /*  477533 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(477619), // Rule ID 24671 //
     /*  477538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  477549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  477552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  477555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477585 */     // MIs[1] Operand 1
     /*  477585 */     // No operand predicates
     /*  477585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477594 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  477594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477617 */     GIR_RootConstrainSelectedInstOperands,
     /*  477618 */     // GIR_Coverage, 24671,
     /*  477618 */     GIR_EraseRootFromParent_Done,
     /*  477619 */   // Label 8068: @477619
     /*  477619 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(477705), // Rule ID 24674 //
     /*  477624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  477635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  477638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  477641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477671 */     // MIs[1] Operand 1
     /*  477671 */     // No operand predicates
     /*  477671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477680 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  477680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477703 */     GIR_RootConstrainSelectedInstOperands,
     /*  477704 */     // GIR_Coverage, 24674,
     /*  477704 */     GIR_EraseRootFromParent_Done,
     /*  477705 */   // Label 8069: @477705
     /*  477705 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(477791), // Rule ID 24675 //
     /*  477710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  477721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  477724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  477727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477757 */     // MIs[1] Operand 1
     /*  477757 */     // No operand predicates
     /*  477757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477766 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  477766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477789 */     GIR_RootConstrainSelectedInstOperands,
     /*  477790 */     // GIR_Coverage, 24675,
     /*  477790 */     GIR_EraseRootFromParent_Done,
     /*  477791 */   // Label 8070: @477791
     /*  477791 */   GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(477877), // Rule ID 24678 //
     /*  477796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  477807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  477810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477843 */     // MIs[1] Operand 1
     /*  477843 */     // No operand predicates
     /*  477843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477852 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477875 */     GIR_RootConstrainSelectedInstOperands,
     /*  477876 */     // GIR_Coverage, 24678,
     /*  477876 */     GIR_EraseRootFromParent_Done,
     /*  477877 */   // Label 8071: @477877
     /*  477877 */   GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(477963), // Rule ID 24679 //
     /*  477882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  477893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  477896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477929 */     // MIs[1] Operand 1
     /*  477929 */     // No operand predicates
     /*  477929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477938 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  477938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477961 */     GIR_RootConstrainSelectedInstOperands,
     /*  477962 */     // GIR_Coverage, 24679,
     /*  477962 */     GIR_EraseRootFromParent_Done,
     /*  477963 */   // Label 8072: @477963
     /*  477963 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(478049), // Rule ID 24682 //
     /*  477968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  477979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  477982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  477985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478015 */     // MIs[1] Operand 1
     /*  478015 */     // No operand predicates
     /*  478015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478024 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478047 */     GIR_RootConstrainSelectedInstOperands,
     /*  478048 */     // GIR_Coverage, 24682,
     /*  478048 */     GIR_EraseRootFromParent_Done,
     /*  478049 */   // Label 8073: @478049
     /*  478049 */   GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(478135), // Rule ID 24683 //
     /*  478054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  478065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  478068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  478071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478101 */     // MIs[1] Operand 1
     /*  478101 */     // No operand predicates
     /*  478101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478110 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478133 */     GIR_RootConstrainSelectedInstOperands,
     /*  478134 */     // GIR_Coverage, 24683,
     /*  478134 */     GIR_EraseRootFromParent_Done,
     /*  478135 */   // Label 8074: @478135
     /*  478135 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(478221), // Rule ID 24686 //
     /*  478140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  478151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  478154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  478157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478187 */     // MIs[1] Operand 1
     /*  478187 */     // No operand predicates
     /*  478187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478196 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478219 */     GIR_RootConstrainSelectedInstOperands,
     /*  478220 */     // GIR_Coverage, 24686,
     /*  478220 */     GIR_EraseRootFromParent_Done,
     /*  478221 */   // Label 8075: @478221
     /*  478221 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(478307), // Rule ID 24687 //
     /*  478226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  478237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  478240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  478243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478273 */     // MIs[1] Operand 1
     /*  478273 */     // No operand predicates
     /*  478273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478282 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478305 */     GIR_RootConstrainSelectedInstOperands,
     /*  478306 */     // GIR_Coverage, 24687,
     /*  478306 */     GIR_EraseRootFromParent_Done,
     /*  478307 */   // Label 8076: @478307
     /*  478307 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(478393), // Rule ID 24690 //
     /*  478312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  478323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  478326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  478329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478359 */     // MIs[1] Operand 1
     /*  478359 */     // No operand predicates
     /*  478359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478368 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  478368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  478388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478391 */     GIR_RootConstrainSelectedInstOperands,
     /*  478392 */     // GIR_Coverage, 24690,
     /*  478392 */     GIR_EraseRootFromParent_Done,
     /*  478393 */   // Label 8077: @478393
     /*  478393 */   GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(478479), // Rule ID 24691 //
     /*  478398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  478409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  478412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  478415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478445 */     // MIs[1] Operand 1
     /*  478445 */     // No operand predicates
     /*  478445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478454 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  478454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  478474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478477 */     GIR_RootConstrainSelectedInstOperands,
     /*  478478 */     // GIR_Coverage, 24691,
     /*  478478 */     GIR_EraseRootFromParent_Done,
     /*  478479 */   // Label 8078: @478479
     /*  478479 */   GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(478565), // Rule ID 24694 //
     /*  478484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  478495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  478498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  478501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478531 */     // MIs[1] Operand 1
     /*  478531 */     // No operand predicates
     /*  478531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478563 */     GIR_RootConstrainSelectedInstOperands,
     /*  478564 */     // GIR_Coverage, 24694,
     /*  478564 */     GIR_EraseRootFromParent_Done,
     /*  478565 */   // Label 8079: @478565
     /*  478565 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(478651), // Rule ID 24695 //
     /*  478570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  478581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  478584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  478587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478617 */     // MIs[1] Operand 1
     /*  478617 */     // No operand predicates
     /*  478617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478649 */     GIR_RootConstrainSelectedInstOperands,
     /*  478650 */     // GIR_Coverage, 24695,
     /*  478650 */     GIR_EraseRootFromParent_Done,
     /*  478651 */   // Label 8080: @478651
     /*  478651 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(478737), // Rule ID 24698 //
     /*  478656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  478667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  478670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  478673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478703 */     // MIs[1] Operand 1
     /*  478703 */     // No operand predicates
     /*  478703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478712 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478735 */     GIR_RootConstrainSelectedInstOperands,
     /*  478736 */     // GIR_Coverage, 24698,
     /*  478736 */     GIR_EraseRootFromParent_Done,
     /*  478737 */   // Label 8081: @478737
     /*  478737 */   GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(478823), // Rule ID 24699 //
     /*  478742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  478753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  478756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  478759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478789 */     // MIs[1] Operand 1
     /*  478789 */     // No operand predicates
     /*  478789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478798 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478821 */     GIR_RootConstrainSelectedInstOperands,
     /*  478822 */     // GIR_Coverage, 24699,
     /*  478822 */     GIR_EraseRootFromParent_Done,
     /*  478823 */   // Label 8082: @478823
     /*  478823 */   GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(478909), // Rule ID 24702 //
     /*  478828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  478831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  478845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478875 */     // MIs[1] Operand 1
     /*  478875 */     // No operand predicates
     /*  478875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478884 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  478884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478907 */     GIR_RootConstrainSelectedInstOperands,
     /*  478908 */     // GIR_Coverage, 24702,
     /*  478908 */     GIR_EraseRootFromParent_Done,
     /*  478909 */   // Label 8083: @478909
     /*  478909 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(478995), // Rule ID 24703 //
     /*  478914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  478917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  478931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478961 */     // MIs[1] Operand 1
     /*  478961 */     // No operand predicates
     /*  478961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478970 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  478970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478993 */     GIR_RootConstrainSelectedInstOperands,
     /*  478994 */     // GIR_Coverage, 24703,
     /*  478994 */     GIR_EraseRootFromParent_Done,
     /*  478995 */   // Label 8084: @478995
     /*  478995 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(479081), // Rule ID 24706 //
     /*  479000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  479011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  479014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  479017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479047 */     // MIs[1] Operand 1
     /*  479047 */     // No operand predicates
     /*  479047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479056 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479079 */     GIR_RootConstrainSelectedInstOperands,
     /*  479080 */     // GIR_Coverage, 24706,
     /*  479080 */     GIR_EraseRootFromParent_Done,
     /*  479081 */   // Label 8085: @479081
     /*  479081 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(479167), // Rule ID 24707 //
     /*  479086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  479097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  479100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  479103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479133 */     // MIs[1] Operand 1
     /*  479133 */     // No operand predicates
     /*  479133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479142 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479165 */     GIR_RootConstrainSelectedInstOperands,
     /*  479166 */     // GIR_Coverage, 24707,
     /*  479166 */     GIR_EraseRootFromParent_Done,
     /*  479167 */   // Label 8086: @479167
     /*  479167 */   GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(479253), // Rule ID 24710 //
     /*  479172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  479183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  479186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  479189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479219 */     // MIs[1] Operand 1
     /*  479219 */     // No operand predicates
     /*  479219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479228 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479251 */     GIR_RootConstrainSelectedInstOperands,
     /*  479252 */     // GIR_Coverage, 24710,
     /*  479252 */     GIR_EraseRootFromParent_Done,
     /*  479253 */   // Label 8087: @479253
     /*  479253 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(479339), // Rule ID 24711 //
     /*  479258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  479269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  479272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  479275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479305 */     // MIs[1] Operand 1
     /*  479305 */     // No operand predicates
     /*  479305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479314 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479337 */     GIR_RootConstrainSelectedInstOperands,
     /*  479338 */     // GIR_Coverage, 24711,
     /*  479338 */     GIR_EraseRootFromParent_Done,
     /*  479339 */   // Label 8088: @479339
     /*  479339 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(479425), // Rule ID 24714 //
     /*  479344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  479355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  479358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  479361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479391 */     // MIs[1] Operand 1
     /*  479391 */     // No operand predicates
     /*  479391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479400 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479423 */     GIR_RootConstrainSelectedInstOperands,
     /*  479424 */     // GIR_Coverage, 24714,
     /*  479424 */     GIR_EraseRootFromParent_Done,
     /*  479425 */   // Label 8089: @479425
     /*  479425 */   GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(479511), // Rule ID 24715 //
     /*  479430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  479441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  479444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  479447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479477 */     // MIs[1] Operand 1
     /*  479477 */     // No operand predicates
     /*  479477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479486 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479509 */     GIR_RootConstrainSelectedInstOperands,
     /*  479510 */     // GIR_Coverage, 24715,
     /*  479510 */     GIR_EraseRootFromParent_Done,
     /*  479511 */   // Label 8090: @479511
     /*  479511 */   GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(479597), // Rule ID 24718 //
     /*  479516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  479527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  479530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  479533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479563 */     // MIs[1] Operand 1
     /*  479563 */     // No operand predicates
     /*  479563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479572 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  479572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479595 */     GIR_RootConstrainSelectedInstOperands,
     /*  479596 */     // GIR_Coverage, 24718,
     /*  479596 */     GIR_EraseRootFromParent_Done,
     /*  479597 */   // Label 8091: @479597
     /*  479597 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(479683), // Rule ID 24719 //
     /*  479602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  479613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  479616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  479619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479649 */     // MIs[1] Operand 1
     /*  479649 */     // No operand predicates
     /*  479649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479658 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  479658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479681 */     GIR_RootConstrainSelectedInstOperands,
     /*  479682 */     // GIR_Coverage, 24719,
     /*  479682 */     GIR_EraseRootFromParent_Done,
     /*  479683 */   // Label 8092: @479683
     /*  479683 */   GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(479769), // Rule ID 24722 //
     /*  479688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  479699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  479702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  479705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479735 */     // MIs[1] Operand 1
     /*  479735 */     // No operand predicates
     /*  479735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479744 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  479744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479767 */     GIR_RootConstrainSelectedInstOperands,
     /*  479768 */     // GIR_Coverage, 24722,
     /*  479768 */     GIR_EraseRootFromParent_Done,
     /*  479769 */   // Label 8093: @479769
     /*  479769 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(479855), // Rule ID 24723 //
     /*  479774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  479785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  479788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  479791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479821 */     // MIs[1] Operand 1
     /*  479821 */     // No operand predicates
     /*  479821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479830 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  479830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479853 */     GIR_RootConstrainSelectedInstOperands,
     /*  479854 */     // GIR_Coverage, 24723,
     /*  479854 */     GIR_EraseRootFromParent_Done,
     /*  479855 */   // Label 8094: @479855
     /*  479855 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(479941), // Rule ID 24726 //
     /*  479860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  479871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  479874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  479877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479907 */     // MIs[1] Operand 1
     /*  479907 */     // No operand predicates
     /*  479907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479916 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  479916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479939 */     GIR_RootConstrainSelectedInstOperands,
     /*  479940 */     // GIR_Coverage, 24726,
     /*  479940 */     GIR_EraseRootFromParent_Done,
     /*  479941 */   // Label 8095: @479941
     /*  479941 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(480027), // Rule ID 24727 //
     /*  479946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  479957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  479960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  479963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479993 */     // MIs[1] Operand 1
     /*  479993 */     // No operand predicates
     /*  479993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480002 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  480002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  480005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480025 */     GIR_RootConstrainSelectedInstOperands,
     /*  480026 */     // GIR_Coverage, 24727,
     /*  480026 */     GIR_EraseRootFromParent_Done,
     /*  480027 */   // Label 8096: @480027
     /*  480027 */   GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(480113), // Rule ID 24730 //
     /*  480032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  480035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  480043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  480046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  480049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480079 */     // MIs[1] Operand 1
     /*  480079 */     // No operand predicates
     /*  480079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  480088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  480091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480111 */     GIR_RootConstrainSelectedInstOperands,
     /*  480112 */     // GIR_Coverage, 24730,
     /*  480112 */     GIR_EraseRootFromParent_Done,
     /*  480113 */   // Label 8097: @480113
     /*  480113 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(480199), // Rule ID 24731 //
     /*  480118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  480121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  480129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  480132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  480135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480165 */     // MIs[1] Operand 1
     /*  480165 */     // No operand predicates
     /*  480165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  480174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  480177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480197 */     GIR_RootConstrainSelectedInstOperands,
     /*  480198 */     // GIR_Coverage, 24731,
     /*  480198 */     GIR_EraseRootFromParent_Done,
     /*  480199 */   // Label 8098: @480199
     /*  480199 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(480285), // Rule ID 24734 //
     /*  480204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  480207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  480215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  480218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  480221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480251 */     // MIs[1] Operand 1
     /*  480251 */     // No operand predicates
     /*  480251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480260 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  480260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  480263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480283 */     GIR_RootConstrainSelectedInstOperands,
     /*  480284 */     // GIR_Coverage, 24734,
     /*  480284 */     GIR_EraseRootFromParent_Done,
     /*  480285 */   // Label 8099: @480285
     /*  480285 */   GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(480371), // Rule ID 24735 //
     /*  480290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  480293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  480301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  480304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  480307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480337 */     // MIs[1] Operand 1
     /*  480337 */     // No operand predicates
     /*  480337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  480346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  480349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480369 */     GIR_RootConstrainSelectedInstOperands,
     /*  480370 */     // GIR_Coverage, 24735,
     /*  480370 */     GIR_EraseRootFromParent_Done,
     /*  480371 */   // Label 8100: @480371
     /*  480371 */   GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(480457), // Rule ID 24738 //
     /*  480376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  480379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  480387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  480390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  480393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480423 */     // MIs[1] Operand 1
     /*  480423 */     // No operand predicates
     /*  480423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480432 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  480432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  480435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480455 */     GIR_RootConstrainSelectedInstOperands,
     /*  480456 */     // GIR_Coverage, 24738,
     /*  480456 */     GIR_EraseRootFromParent_Done,
     /*  480457 */   // Label 8101: @480457
     /*  480457 */   GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(480543), // Rule ID 24739 //
     /*  480462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  480465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  480473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  480476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  480479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480509 */     // MIs[1] Operand 1
     /*  480509 */     // No operand predicates
     /*  480509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  480518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  480521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480541 */     GIR_RootConstrainSelectedInstOperands,
     /*  480542 */     // GIR_Coverage, 24739,
     /*  480542 */     GIR_EraseRootFromParent_Done,
     /*  480543 */   // Label 8102: @480543
     /*  480543 */   GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(480629), // Rule ID 24742 //
     /*  480548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  480551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  480559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  480562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  480565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480595 */     // MIs[1] Operand 1
     /*  480595 */     // No operand predicates
     /*  480595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480604 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  480604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  480607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480627 */     GIR_RootConstrainSelectedInstOperands,
     /*  480628 */     // GIR_Coverage, 24742,
     /*  480628 */     GIR_EraseRootFromParent_Done,
     /*  480629 */   // Label 8103: @480629
     /*  480629 */   GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(480715), // Rule ID 24743 //
     /*  480634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  480637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  480645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  480648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  480651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480681 */     // MIs[1] Operand 1
     /*  480681 */     // No operand predicates
     /*  480681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  480690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  480693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480713 */     GIR_RootConstrainSelectedInstOperands,
     /*  480714 */     // GIR_Coverage, 24743,
     /*  480714 */     GIR_EraseRootFromParent_Done,
     /*  480715 */   // Label 8104: @480715
     /*  480715 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(480801), // Rule ID 24746 //
     /*  480720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  480723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  480731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  480734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  480737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480767 */     // MIs[1] Operand 1
     /*  480767 */     // No operand predicates
     /*  480767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480776 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  480776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  480779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480799 */     GIR_RootConstrainSelectedInstOperands,
     /*  480800 */     // GIR_Coverage, 24746,
     /*  480800 */     GIR_EraseRootFromParent_Done,
     /*  480801 */   // Label 8105: @480801
     /*  480801 */   GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(480887), // Rule ID 24747 //
     /*  480806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  480809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  480817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  480820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  480823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480853 */     // MIs[1] Operand 1
     /*  480853 */     // No operand predicates
     /*  480853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480862 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  480862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  480865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480885 */     GIR_RootConstrainSelectedInstOperands,
     /*  480886 */     // GIR_Coverage, 24747,
     /*  480886 */     GIR_EraseRootFromParent_Done,
     /*  480887 */   // Label 8106: @480887
     /*  480887 */   GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(480973), // Rule ID 24750 //
     /*  480892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  480895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  480903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  480906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  480909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480939 */     // MIs[1] Operand 1
     /*  480939 */     // No operand predicates
     /*  480939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480948 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  480948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  480951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480971 */     GIR_RootConstrainSelectedInstOperands,
     /*  480972 */     // GIR_Coverage, 24750,
     /*  480972 */     GIR_EraseRootFromParent_Done,
     /*  480973 */   // Label 8107: @480973
     /*  480973 */   GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(481059), // Rule ID 24751 //
     /*  480978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  480981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  480989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  480992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  480995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481025 */     // MIs[1] Operand 1
     /*  481025 */     // No operand predicates
     /*  481025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481034 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  481034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  481037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  481054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481057 */     GIR_RootConstrainSelectedInstOperands,
     /*  481058 */     // GIR_Coverage, 24751,
     /*  481058 */     GIR_EraseRootFromParent_Done,
     /*  481059 */   // Label 8108: @481059
     /*  481059 */   GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(481145), // Rule ID 24910 //
     /*  481064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  481067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  481075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  481078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  481081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481111 */     // MIs[1] Operand 1
     /*  481111 */     // No operand predicates
     /*  481111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481120 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  481123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481143 */     GIR_RootConstrainSelectedInstOperands,
     /*  481144 */     // GIR_Coverage, 24910,
     /*  481144 */     GIR_EraseRootFromParent_Done,
     /*  481145 */   // Label 8109: @481145
     /*  481145 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(481231), // Rule ID 24911 //
     /*  481150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  481153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  481161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  481164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  481167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481197 */     // MIs[1] Operand 1
     /*  481197 */     // No operand predicates
     /*  481197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481206 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  481209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481229 */     GIR_RootConstrainSelectedInstOperands,
     /*  481230 */     // GIR_Coverage, 24911,
     /*  481230 */     GIR_EraseRootFromParent_Done,
     /*  481231 */   // Label 8110: @481231
     /*  481231 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(481317), // Rule ID 24914 //
     /*  481236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  481239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  481247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  481250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  481253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481283 */     // MIs[1] Operand 1
     /*  481283 */     // No operand predicates
     /*  481283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481292 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  481295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481315 */     GIR_RootConstrainSelectedInstOperands,
     /*  481316 */     // GIR_Coverage, 24914,
     /*  481316 */     GIR_EraseRootFromParent_Done,
     /*  481317 */   // Label 8111: @481317
     /*  481317 */   GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(481403), // Rule ID 24915 //
     /*  481322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  481325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  481333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  481336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  481339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481369 */     // MIs[1] Operand 1
     /*  481369 */     // No operand predicates
     /*  481369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481378 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  481381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481401 */     GIR_RootConstrainSelectedInstOperands,
     /*  481402 */     // GIR_Coverage, 24915,
     /*  481402 */     GIR_EraseRootFromParent_Done,
     /*  481403 */   // Label 8112: @481403
     /*  481403 */   GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(481489), // Rule ID 24918 //
     /*  481408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  481411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  481419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  481422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  481425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481455 */     // MIs[1] Operand 1
     /*  481455 */     // No operand predicates
     /*  481455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481464 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  481464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  481467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  481484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481487 */     GIR_RootConstrainSelectedInstOperands,
     /*  481488 */     // GIR_Coverage, 24918,
     /*  481488 */     GIR_EraseRootFromParent_Done,
     /*  481489 */   // Label 8113: @481489
     /*  481489 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(481575), // Rule ID 24919 //
     /*  481494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  481497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  481505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  481508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  481511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481541 */     // MIs[1] Operand 1
     /*  481541 */     // No operand predicates
     /*  481541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481550 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  481550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  481553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  481570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481573 */     GIR_RootConstrainSelectedInstOperands,
     /*  481574 */     // GIR_Coverage, 24919,
     /*  481574 */     GIR_EraseRootFromParent_Done,
     /*  481575 */   // Label 8114: @481575
     /*  481575 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(481661), // Rule ID 24922 //
     /*  481580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  481583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  481591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  481594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  481597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481627 */     // MIs[1] Operand 1
     /*  481627 */     // No operand predicates
     /*  481627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481636 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  481639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481659 */     GIR_RootConstrainSelectedInstOperands,
     /*  481660 */     // GIR_Coverage, 24922,
     /*  481660 */     GIR_EraseRootFromParent_Done,
     /*  481661 */   // Label 8115: @481661
     /*  481661 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(481747), // Rule ID 24923 //
     /*  481666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  481669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  481677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  481680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  481683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481713 */     // MIs[1] Operand 1
     /*  481713 */     // No operand predicates
     /*  481713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481722 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  481725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481745 */     GIR_RootConstrainSelectedInstOperands,
     /*  481746 */     // GIR_Coverage, 24923,
     /*  481746 */     GIR_EraseRootFromParent_Done,
     /*  481747 */   // Label 8116: @481747
     /*  481747 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(481833), // Rule ID 24926 //
     /*  481752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  481755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  481763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  481766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  481769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481799 */     // MIs[1] Operand 1
     /*  481799 */     // No operand predicates
     /*  481799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481808 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  481811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481831 */     GIR_RootConstrainSelectedInstOperands,
     /*  481832 */     // GIR_Coverage, 24926,
     /*  481832 */     GIR_EraseRootFromParent_Done,
     /*  481833 */   // Label 8117: @481833
     /*  481833 */   GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(481919), // Rule ID 24927 //
     /*  481838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  481841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  481849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  481852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  481855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481885 */     // MIs[1] Operand 1
     /*  481885 */     // No operand predicates
     /*  481885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481894 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  481897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481917 */     GIR_RootConstrainSelectedInstOperands,
     /*  481918 */     // GIR_Coverage, 24927,
     /*  481918 */     GIR_EraseRootFromParent_Done,
     /*  481919 */   // Label 8118: @481919
     /*  481919 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(482005), // Rule ID 24930 //
     /*  481924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  481927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  481935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  481938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  481941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481971 */     // MIs[1] Operand 1
     /*  481971 */     // No operand predicates
     /*  481971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481980 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  481983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482003 */     GIR_RootConstrainSelectedInstOperands,
     /*  482004 */     // GIR_Coverage, 24930,
     /*  482004 */     GIR_EraseRootFromParent_Done,
     /*  482005 */   // Label 8119: @482005
     /*  482005 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(482091), // Rule ID 24931 //
     /*  482010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  482013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  482021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  482024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  482027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482057 */     // MIs[1] Operand 1
     /*  482057 */     // No operand predicates
     /*  482057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482066 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  482069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482089 */     GIR_RootConstrainSelectedInstOperands,
     /*  482090 */     // GIR_Coverage, 24931,
     /*  482090 */     GIR_EraseRootFromParent_Done,
     /*  482091 */   // Label 8120: @482091
     /*  482091 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(482177), // Rule ID 24934 //
     /*  482096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  482099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  482107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  482110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  482113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482143 */     // MIs[1] Operand 1
     /*  482143 */     // No operand predicates
     /*  482143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482152 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  482152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  482155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  482172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482175 */     GIR_RootConstrainSelectedInstOperands,
     /*  482176 */     // GIR_Coverage, 24934,
     /*  482176 */     GIR_EraseRootFromParent_Done,
     /*  482177 */   // Label 8121: @482177
     /*  482177 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(482263), // Rule ID 24935 //
     /*  482182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  482185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  482193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  482196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  482199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482229 */     // MIs[1] Operand 1
     /*  482229 */     // No operand predicates
     /*  482229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482238 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  482238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  482241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  482258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482261 */     GIR_RootConstrainSelectedInstOperands,
     /*  482262 */     // GIR_Coverage, 24935,
     /*  482262 */     GIR_EraseRootFromParent_Done,
     /*  482263 */   // Label 8122: @482263
     /*  482263 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(482349), // Rule ID 24938 //
     /*  482268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  482271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  482279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  482282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  482285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482315 */     // MIs[1] Operand 1
     /*  482315 */     // No operand predicates
     /*  482315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482324 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  482324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  482327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  482344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482347 */     GIR_RootConstrainSelectedInstOperands,
     /*  482348 */     // GIR_Coverage, 24938,
     /*  482348 */     GIR_EraseRootFromParent_Done,
     /*  482349 */   // Label 8123: @482349
     /*  482349 */   GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(482435), // Rule ID 24939 //
     /*  482354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  482357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  482365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  482368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  482371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482401 */     // MIs[1] Operand 1
     /*  482401 */     // No operand predicates
     /*  482401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482410 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  482410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  482413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  482430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482433 */     GIR_RootConstrainSelectedInstOperands,
     /*  482434 */     // GIR_Coverage, 24939,
     /*  482434 */     GIR_EraseRootFromParent_Done,
     /*  482435 */   // Label 8124: @482435
     /*  482435 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(482521), // Rule ID 24942 //
     /*  482440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  482443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  482451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  482454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  482457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482487 */     // MIs[1] Operand 1
     /*  482487 */     // No operand predicates
     /*  482487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482496 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  482496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  482499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  482516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482519 */     GIR_RootConstrainSelectedInstOperands,
     /*  482520 */     // GIR_Coverage, 24942,
     /*  482520 */     GIR_EraseRootFromParent_Done,
     /*  482521 */   // Label 8125: @482521
     /*  482521 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(482607), // Rule ID 24943 //
     /*  482526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  482529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  482537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  482540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  482543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482573 */     // MIs[1] Operand 1
     /*  482573 */     // No operand predicates
     /*  482573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482582 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  482582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  482585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  482602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482605 */     GIR_RootConstrainSelectedInstOperands,
     /*  482606 */     // GIR_Coverage, 24943,
     /*  482606 */     GIR_EraseRootFromParent_Done,
     /*  482607 */   // Label 8126: @482607
     /*  482607 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(482693), // Rule ID 24994 //
     /*  482612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  482615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  482623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  482626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  482629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482659 */     // MIs[1] Operand 1
     /*  482659 */     // No operand predicates
     /*  482659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482668 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  482671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482691 */     GIR_RootConstrainSelectedInstOperands,
     /*  482692 */     // GIR_Coverage, 24994,
     /*  482692 */     GIR_EraseRootFromParent_Done,
     /*  482693 */   // Label 8127: @482693
     /*  482693 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(482779), // Rule ID 24995 //
     /*  482698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  482701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  482709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  482712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  482715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482745 */     // MIs[1] Operand 1
     /*  482745 */     // No operand predicates
     /*  482745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482754 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  482754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  482757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482777 */     GIR_RootConstrainSelectedInstOperands,
     /*  482778 */     // GIR_Coverage, 24995,
     /*  482778 */     GIR_EraseRootFromParent_Done,
     /*  482779 */   // Label 8128: @482779
     /*  482779 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(482865), // Rule ID 24998 //
     /*  482784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  482787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  482795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  482798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  482801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482831 */     // MIs[1] Operand 1
     /*  482831 */     // No operand predicates
     /*  482831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482840 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  482843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482863 */     GIR_RootConstrainSelectedInstOperands,
     /*  482864 */     // GIR_Coverage, 24998,
     /*  482864 */     GIR_EraseRootFromParent_Done,
     /*  482865 */   // Label 8129: @482865
     /*  482865 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(482951), // Rule ID 24999 //
     /*  482870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  482873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  482881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  482884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  482887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482917 */     // MIs[1] Operand 1
     /*  482917 */     // No operand predicates
     /*  482917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482926 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  482926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  482929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482949 */     GIR_RootConstrainSelectedInstOperands,
     /*  482950 */     // GIR_Coverage, 24999,
     /*  482950 */     GIR_EraseRootFromParent_Done,
     /*  482951 */   // Label 8130: @482951
     /*  482951 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(483037), // Rule ID 25002 //
     /*  482956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  482959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  482967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  482970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  482973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483003 */     // MIs[1] Operand 1
     /*  483003 */     // No operand predicates
     /*  483003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483012 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  483015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483035 */     GIR_RootConstrainSelectedInstOperands,
     /*  483036 */     // GIR_Coverage, 25002,
     /*  483036 */     GIR_EraseRootFromParent_Done,
     /*  483037 */   // Label 8131: @483037
     /*  483037 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(483123), // Rule ID 25003 //
     /*  483042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  483045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  483053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  483056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  483059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483089 */     // MIs[1] Operand 1
     /*  483089 */     // No operand predicates
     /*  483089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483098 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  483101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483121 */     GIR_RootConstrainSelectedInstOperands,
     /*  483122 */     // GIR_Coverage, 25003,
     /*  483122 */     GIR_EraseRootFromParent_Done,
     /*  483123 */   // Label 8132: @483123
     /*  483123 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(483209), // Rule ID 25006 //
     /*  483128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  483131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  483139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  483142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  483145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483175 */     // MIs[1] Operand 1
     /*  483175 */     // No operand predicates
     /*  483175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483184 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  483187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483207 */     GIR_RootConstrainSelectedInstOperands,
     /*  483208 */     // GIR_Coverage, 25006,
     /*  483208 */     GIR_EraseRootFromParent_Done,
     /*  483209 */   // Label 8133: @483209
     /*  483209 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(483295), // Rule ID 25007 //
     /*  483214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  483217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  483225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  483228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  483231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483261 */     // MIs[1] Operand 1
     /*  483261 */     // No operand predicates
     /*  483261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483270 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  483273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483293 */     GIR_RootConstrainSelectedInstOperands,
     /*  483294 */     // GIR_Coverage, 25007,
     /*  483294 */     GIR_EraseRootFromParent_Done,
     /*  483295 */   // Label 8134: @483295
     /*  483295 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(483381), // Rule ID 25010 //
     /*  483300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  483303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  483311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  483314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  483317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483347 */     // MIs[1] Operand 1
     /*  483347 */     // No operand predicates
     /*  483347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483356 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  483359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483379 */     GIR_RootConstrainSelectedInstOperands,
     /*  483380 */     // GIR_Coverage, 25010,
     /*  483380 */     GIR_EraseRootFromParent_Done,
     /*  483381 */   // Label 8135: @483381
     /*  483381 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(483467), // Rule ID 25011 //
     /*  483386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  483389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  483397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  483400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  483403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483433 */     // MIs[1] Operand 1
     /*  483433 */     // No operand predicates
     /*  483433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483442 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  483445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483465 */     GIR_RootConstrainSelectedInstOperands,
     /*  483466 */     // GIR_Coverage, 25011,
     /*  483466 */     GIR_EraseRootFromParent_Done,
     /*  483467 */   // Label 8136: @483467
     /*  483467 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(483553), // Rule ID 25014 //
     /*  483472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  483475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  483483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  483486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  483489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483519 */     // MIs[1] Operand 1
     /*  483519 */     // No operand predicates
     /*  483519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483528 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  483531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483551 */     GIR_RootConstrainSelectedInstOperands,
     /*  483552 */     // GIR_Coverage, 25014,
     /*  483552 */     GIR_EraseRootFromParent_Done,
     /*  483553 */   // Label 8137: @483553
     /*  483553 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(483639), // Rule ID 25015 //
     /*  483558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  483561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  483569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  483572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  483575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483605 */     // MIs[1] Operand 1
     /*  483605 */     // No operand predicates
     /*  483605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483614 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  483617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483637 */     GIR_RootConstrainSelectedInstOperands,
     /*  483638 */     // GIR_Coverage, 25015,
     /*  483638 */     GIR_EraseRootFromParent_Done,
     /*  483639 */   // Label 8138: @483639
     /*  483639 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(483725), // Rule ID 61026 //
     /*  483644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  483647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  483652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  483655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  483658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  483661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483691 */     // MIs[1] Operand 1
     /*  483691 */     // No operand predicates
     /*  483691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483700 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  483703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483723 */     GIR_RootConstrainSelectedInstOperands,
     /*  483724 */     // GIR_Coverage, 61026,
     /*  483724 */     GIR_EraseRootFromParent_Done,
     /*  483725 */   // Label 8139: @483725
     /*  483725 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(483811), // Rule ID 61027 //
     /*  483730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  483733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  483738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  483741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  483744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  483747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483777 */     // MIs[1] Operand 1
     /*  483777 */     // No operand predicates
     /*  483777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  483789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483809 */     GIR_RootConstrainSelectedInstOperands,
     /*  483810 */     // GIR_Coverage, 61027,
     /*  483810 */     GIR_EraseRootFromParent_Done,
     /*  483811 */   // Label 8140: @483811
     /*  483811 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(483897), // Rule ID 61034 //
     /*  483816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  483819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  483824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  483833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483863 */     // MIs[1] Operand 1
     /*  483863 */     // No operand predicates
     /*  483863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483872 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  483875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483895 */     GIR_RootConstrainSelectedInstOperands,
     /*  483896 */     // GIR_Coverage, 61034,
     /*  483896 */     GIR_EraseRootFromParent_Done,
     /*  483897 */   // Label 8141: @483897
     /*  483897 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(483983), // Rule ID 61035 //
     /*  483902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  483905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  483910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  483919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483949 */     // MIs[1] Operand 1
     /*  483949 */     // No operand predicates
     /*  483949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  483961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483981 */     GIR_RootConstrainSelectedInstOperands,
     /*  483982 */     // GIR_Coverage, 61035,
     /*  483982 */     GIR_EraseRootFromParent_Done,
     /*  483983 */   // Label 8142: @483983
     /*  483983 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(484069), // Rule ID 61042 //
     /*  483988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  483991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  483996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  483999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  484002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  484005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484035 */     // MIs[1] Operand 1
     /*  484035 */     // No operand predicates
     /*  484035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484044 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  484047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484067 */     GIR_RootConstrainSelectedInstOperands,
     /*  484068 */     // GIR_Coverage, 61042,
     /*  484068 */     GIR_EraseRootFromParent_Done,
     /*  484069 */   // Label 8143: @484069
     /*  484069 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(484155), // Rule ID 61043 //
     /*  484074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  484077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  484085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  484088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  484091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484121 */     // MIs[1] Operand 1
     /*  484121 */     // No operand predicates
     /*  484121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484130 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  484133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484153 */     GIR_RootConstrainSelectedInstOperands,
     /*  484154 */     // GIR_Coverage, 61043,
     /*  484154 */     GIR_EraseRootFromParent_Done,
     /*  484155 */   // Label 8144: @484155
     /*  484155 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(484241), // Rule ID 61050 //
     /*  484160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  484163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  484171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  484174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  484177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484207 */     // MIs[1] Operand 1
     /*  484207 */     // No operand predicates
     /*  484207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  484219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484239 */     GIR_RootConstrainSelectedInstOperands,
     /*  484240 */     // GIR_Coverage, 61050,
     /*  484240 */     GIR_EraseRootFromParent_Done,
     /*  484241 */   // Label 8145: @484241
     /*  484241 */   GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(484327), // Rule ID 61051 //
     /*  484246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  484249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  484257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  484260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  484263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484293 */     // MIs[1] Operand 1
     /*  484293 */     // No operand predicates
     /*  484293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  484305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484325 */     GIR_RootConstrainSelectedInstOperands,
     /*  484326 */     // GIR_Coverage, 61051,
     /*  484326 */     GIR_EraseRootFromParent_Done,
     /*  484327 */   // Label 8146: @484327
     /*  484327 */   GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(484413), // Rule ID 61058 //
     /*  484332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  484335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  484343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  484346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484379 */     // MIs[1] Operand 1
     /*  484379 */     // No operand predicates
     /*  484379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484388 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  484391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484411 */     GIR_RootConstrainSelectedInstOperands,
     /*  484412 */     // GIR_Coverage, 61058,
     /*  484412 */     GIR_EraseRootFromParent_Done,
     /*  484413 */   // Label 8147: @484413
     /*  484413 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(484499), // Rule ID 61059 //
     /*  484418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  484421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  484429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  484432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484465 */     // MIs[1] Operand 1
     /*  484465 */     // No operand predicates
     /*  484465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  484477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484497 */     GIR_RootConstrainSelectedInstOperands,
     /*  484498 */     // GIR_Coverage, 61059,
     /*  484498 */     GIR_EraseRootFromParent_Done,
     /*  484499 */   // Label 8148: @484499
     /*  484499 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(484585), // Rule ID 61066 //
     /*  484504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  484507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  484515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  484518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484551 */     // MIs[1] Operand 1
     /*  484551 */     // No operand predicates
     /*  484551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484560 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  484563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484583 */     GIR_RootConstrainSelectedInstOperands,
     /*  484584 */     // GIR_Coverage, 61066,
     /*  484584 */     GIR_EraseRootFromParent_Done,
     /*  484585 */   // Label 8149: @484585
     /*  484585 */   GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(484671), // Rule ID 61067 //
     /*  484590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  484593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  484601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  484604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484637 */     // MIs[1] Operand 1
     /*  484637 */     // No operand predicates
     /*  484637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  484649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484669 */     GIR_RootConstrainSelectedInstOperands,
     /*  484670 */     // GIR_Coverage, 61067,
     /*  484670 */     GIR_EraseRootFromParent_Done,
     /*  484671 */   // Label 8150: @484671
     /*  484671 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(484757), // Rule ID 61074 //
     /*  484676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  484679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  484687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  484690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  484693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484723 */     // MIs[1] Operand 1
     /*  484723 */     // No operand predicates
     /*  484723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  484735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484755 */     GIR_RootConstrainSelectedInstOperands,
     /*  484756 */     // GIR_Coverage, 61074,
     /*  484756 */     GIR_EraseRootFromParent_Done,
     /*  484757 */   // Label 8151: @484757
     /*  484757 */   GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(484843), // Rule ID 61075 //
     /*  484762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  484765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  484773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  484776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  484779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484809 */     // MIs[1] Operand 1
     /*  484809 */     // No operand predicates
     /*  484809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484818 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  484821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484841 */     GIR_RootConstrainSelectedInstOperands,
     /*  484842 */     // GIR_Coverage, 61075,
     /*  484842 */     GIR_EraseRootFromParent_Done,
     /*  484843 */   // Label 8152: @484843
     /*  484843 */   GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(484929), // Rule ID 61082 //
     /*  484848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  484851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  484859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  484862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  484865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484895 */     // MIs[1] Operand 1
     /*  484895 */     // No operand predicates
     /*  484895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  484907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484927 */     GIR_RootConstrainSelectedInstOperands,
     /*  484928 */     // GIR_Coverage, 61082,
     /*  484928 */     GIR_EraseRootFromParent_Done,
     /*  484929 */   // Label 8153: @484929
     /*  484929 */   GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(485015), // Rule ID 61083 //
     /*  484934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  484937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  484945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  484948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  484951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484981 */     // MIs[1] Operand 1
     /*  484981 */     // No operand predicates
     /*  484981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  484993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485013 */     GIR_RootConstrainSelectedInstOperands,
     /*  485014 */     // GIR_Coverage, 61083,
     /*  485014 */     GIR_EraseRootFromParent_Done,
     /*  485015 */   // Label 8154: @485015
     /*  485015 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(485101), // Rule ID 61090 //
     /*  485020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  485023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  485031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  485034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  485037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485067 */     // MIs[1] Operand 1
     /*  485067 */     // No operand predicates
     /*  485067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  485079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485099 */     GIR_RootConstrainSelectedInstOperands,
     /*  485100 */     // GIR_Coverage, 61090,
     /*  485100 */     GIR_EraseRootFromParent_Done,
     /*  485101 */   // Label 8155: @485101
     /*  485101 */   GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(485187), // Rule ID 61091 //
     /*  485106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  485109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  485117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  485120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  485123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485153 */     // MIs[1] Operand 1
     /*  485153 */     // No operand predicates
     /*  485153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  485165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485185 */     GIR_RootConstrainSelectedInstOperands,
     /*  485186 */     // GIR_Coverage, 61091,
     /*  485186 */     GIR_EraseRootFromParent_Done,
     /*  485187 */   // Label 8156: @485187
     /*  485187 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(485273), // Rule ID 61098 //
     /*  485192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  485195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  485203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  485206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  485209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485239 */     // MIs[1] Operand 1
     /*  485239 */     // No operand predicates
     /*  485239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  485251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485271 */     GIR_RootConstrainSelectedInstOperands,
     /*  485272 */     // GIR_Coverage, 61098,
     /*  485272 */     GIR_EraseRootFromParent_Done,
     /*  485273 */   // Label 8157: @485273
     /*  485273 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(485359), // Rule ID 61099 //
     /*  485278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  485281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  485289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  485292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  485295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485325 */     // MIs[1] Operand 1
     /*  485325 */     // No operand predicates
     /*  485325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  485337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485357 */     GIR_RootConstrainSelectedInstOperands,
     /*  485358 */     // GIR_Coverage, 61099,
     /*  485358 */     GIR_EraseRootFromParent_Done,
     /*  485359 */   // Label 8158: @485359
     /*  485359 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(485445), // Rule ID 61106 //
     /*  485364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  485367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  485375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  485378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  485381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485411 */     // MIs[1] Operand 1
     /*  485411 */     // No operand predicates
     /*  485411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485420 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  485423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485443 */     GIR_RootConstrainSelectedInstOperands,
     /*  485444 */     // GIR_Coverage, 61106,
     /*  485444 */     GIR_EraseRootFromParent_Done,
     /*  485445 */   // Label 8159: @485445
     /*  485445 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(485531), // Rule ID 61107 //
     /*  485450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  485453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  485461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  485464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  485467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485497 */     // MIs[1] Operand 1
     /*  485497 */     // No operand predicates
     /*  485497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485506 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  485509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485529 */     GIR_RootConstrainSelectedInstOperands,
     /*  485530 */     // GIR_Coverage, 61107,
     /*  485530 */     GIR_EraseRootFromParent_Done,
     /*  485531 */   // Label 8160: @485531
     /*  485531 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(485617), // Rule ID 61114 //
     /*  485536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  485539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  485547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  485550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  485553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485583 */     // MIs[1] Operand 1
     /*  485583 */     // No operand predicates
     /*  485583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485592 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  485595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485615 */     GIR_RootConstrainSelectedInstOperands,
     /*  485616 */     // GIR_Coverage, 61114,
     /*  485616 */     GIR_EraseRootFromParent_Done,
     /*  485617 */   // Label 8161: @485617
     /*  485617 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(485703), // Rule ID 61115 //
     /*  485622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  485625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  485633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  485636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  485639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485669 */     // MIs[1] Operand 1
     /*  485669 */     // No operand predicates
     /*  485669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485678 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  485681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485701 */     GIR_RootConstrainSelectedInstOperands,
     /*  485702 */     // GIR_Coverage, 61115,
     /*  485702 */     GIR_EraseRootFromParent_Done,
     /*  485703 */   // Label 8162: @485703
     /*  485703 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(485789), // Rule ID 61122 //
     /*  485708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  485711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  485719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  485722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  485725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485755 */     // MIs[1] Operand 1
     /*  485755 */     // No operand predicates
     /*  485755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  485767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485787 */     GIR_RootConstrainSelectedInstOperands,
     /*  485788 */     // GIR_Coverage, 61122,
     /*  485788 */     GIR_EraseRootFromParent_Done,
     /*  485789 */   // Label 8163: @485789
     /*  485789 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(485875), // Rule ID 61123 //
     /*  485794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  485797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  485805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  485808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  485811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485841 */     // MIs[1] Operand 1
     /*  485841 */     // No operand predicates
     /*  485841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485850 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  485853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485873 */     GIR_RootConstrainSelectedInstOperands,
     /*  485874 */     // GIR_Coverage, 61123,
     /*  485874 */     GIR_EraseRootFromParent_Done,
     /*  485875 */   // Label 8164: @485875
     /*  485875 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(485961), // Rule ID 61130 //
     /*  485880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  485883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  485891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  485894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485927 */     // MIs[1] Operand 1
     /*  485927 */     // No operand predicates
     /*  485927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485936 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  485939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485959 */     GIR_RootConstrainSelectedInstOperands,
     /*  485960 */     // GIR_Coverage, 61130,
     /*  485960 */     GIR_EraseRootFromParent_Done,
     /*  485961 */   // Label 8165: @485961
     /*  485961 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(486047), // Rule ID 61131 //
     /*  485966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  485969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  485977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  485980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  486013 */     // MIs[1] Operand 1
     /*  486013 */     // No operand predicates
     /*  486013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486022 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  486022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  486025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  486042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486045 */     GIR_RootConstrainSelectedInstOperands,
     /*  486046 */     // GIR_Coverage, 61131,
     /*  486046 */     GIR_EraseRootFromParent_Done,
     /*  486047 */   // Label 8166: @486047
     /*  486047 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(486133), // Rule ID 61138 //
     /*  486052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  486055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  486060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  486063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  486066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  486069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  486099 */     // MIs[1] Operand 1
     /*  486099 */     // No operand predicates
     /*  486099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486108 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  486108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  486111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  486128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486131 */     GIR_RootConstrainSelectedInstOperands,
     /*  486132 */     // GIR_Coverage, 61138,
     /*  486132 */     GIR_EraseRootFromParent_Done,
     /*  486133 */   // Label 8167: @486133
     /*  486133 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(486219), // Rule ID 61139 //
     /*  486138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  486141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  486146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  486149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  486152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  486155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  486185 */     // MIs[1] Operand 1
     /*  486185 */     // No operand predicates
     /*  486185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486194 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  486194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  486197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  486214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486217 */     GIR_RootConstrainSelectedInstOperands,
     /*  486218 */     // GIR_Coverage, 61139,
     /*  486218 */     GIR_EraseRootFromParent_Done,
     /*  486219 */   // Label 8168: @486219
     /*  486219 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(486305), // Rule ID 61994 //
     /*  486224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  486235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  486238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  486241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486271 */     // MIs[1] Operand 1
     /*  486271 */     // No operand predicates
     /*  486271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486280 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  486280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  486283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486303 */     GIR_RootConstrainSelectedInstOperands,
     /*  486304 */     // GIR_Coverage, 61994,
     /*  486304 */     GIR_EraseRootFromParent_Done,
     /*  486305 */   // Label 8169: @486305
     /*  486305 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(486391), // Rule ID 61995 //
     /*  486310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  486321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  486324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  486327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486357 */     // MIs[1] Operand 1
     /*  486357 */     // No operand predicates
     /*  486357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486366 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  486366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  486369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486389 */     GIR_RootConstrainSelectedInstOperands,
     /*  486390 */     // GIR_Coverage, 61995,
     /*  486390 */     GIR_EraseRootFromParent_Done,
     /*  486391 */   // Label 8170: @486391
     /*  486391 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(486477), // Rule ID 61998 //
     /*  486396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  486407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  486410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  486413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486443 */     // MIs[1] Operand 1
     /*  486443 */     // No operand predicates
     /*  486443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486452 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  486452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  486455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486475 */     GIR_RootConstrainSelectedInstOperands,
     /*  486476 */     // GIR_Coverage, 61998,
     /*  486476 */     GIR_EraseRootFromParent_Done,
     /*  486477 */   // Label 8171: @486477
     /*  486477 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(486563), // Rule ID 61999 //
     /*  486482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  486493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  486496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  486499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486529 */     // MIs[1] Operand 1
     /*  486529 */     // No operand predicates
     /*  486529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486538 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  486538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  486541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486561 */     GIR_RootConstrainSelectedInstOperands,
     /*  486562 */     // GIR_Coverage, 61999,
     /*  486562 */     GIR_EraseRootFromParent_Done,
     /*  486563 */   // Label 8172: @486563
     /*  486563 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(486649), // Rule ID 62002 //
     /*  486568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  486579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  486582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  486585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486615 */     // MIs[1] Operand 1
     /*  486615 */     // No operand predicates
     /*  486615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486624 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  486624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  486627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486647 */     GIR_RootConstrainSelectedInstOperands,
     /*  486648 */     // GIR_Coverage, 62002,
     /*  486648 */     GIR_EraseRootFromParent_Done,
     /*  486649 */   // Label 8173: @486649
     /*  486649 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(486735), // Rule ID 62003 //
     /*  486654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  486665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  486668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  486671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486701 */     // MIs[1] Operand 1
     /*  486701 */     // No operand predicates
     /*  486701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486710 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  486710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  486713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486733 */     GIR_RootConstrainSelectedInstOperands,
     /*  486734 */     // GIR_Coverage, 62003,
     /*  486734 */     GIR_EraseRootFromParent_Done,
     /*  486735 */   // Label 8174: @486735
     /*  486735 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(486821), // Rule ID 62006 //
     /*  486740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  486751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  486754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486787 */     // MIs[1] Operand 1
     /*  486787 */     // No operand predicates
     /*  486787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486796 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  486796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  486799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486819 */     GIR_RootConstrainSelectedInstOperands,
     /*  486820 */     // GIR_Coverage, 62006,
     /*  486820 */     GIR_EraseRootFromParent_Done,
     /*  486821 */   // Label 8175: @486821
     /*  486821 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(486907), // Rule ID 62007 //
     /*  486826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  486837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  486840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486873 */     // MIs[1] Operand 1
     /*  486873 */     // No operand predicates
     /*  486873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486882 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  486882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  486885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486905 */     GIR_RootConstrainSelectedInstOperands,
     /*  486906 */     // GIR_Coverage, 62007,
     /*  486906 */     GIR_EraseRootFromParent_Done,
     /*  486907 */   // Label 8176: @486907
     /*  486907 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(486993), // Rule ID 62010 //
     /*  486912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  486923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  486926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  486929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486959 */     // MIs[1] Operand 1
     /*  486959 */     // No operand predicates
     /*  486959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486968 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  486968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  486971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486991 */     GIR_RootConstrainSelectedInstOperands,
     /*  486992 */     // GIR_Coverage, 62010,
     /*  486992 */     GIR_EraseRootFromParent_Done,
     /*  486993 */   // Label 8177: @486993
     /*  486993 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(487079), // Rule ID 62011 //
     /*  486998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  487001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  487009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  487012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  487015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  487018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487045 */     // MIs[1] Operand 1
     /*  487045 */     // No operand predicates
     /*  487045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487054 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  487054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  487057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487077 */     GIR_RootConstrainSelectedInstOperands,
     /*  487078 */     // GIR_Coverage, 62011,
     /*  487078 */     GIR_EraseRootFromParent_Done,
     /*  487079 */   // Label 8178: @487079
     /*  487079 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(487165), // Rule ID 62014 //
     /*  487084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  487087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  487095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  487098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  487104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487131 */     // MIs[1] Operand 1
     /*  487131 */     // No operand predicates
     /*  487131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487140 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  487140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  487143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487163 */     GIR_RootConstrainSelectedInstOperands,
     /*  487164 */     // GIR_Coverage, 62014,
     /*  487164 */     GIR_EraseRootFromParent_Done,
     /*  487165 */   // Label 8179: @487165
     /*  487165 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(487251), // Rule ID 62015 //
     /*  487170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  487173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  487181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  487184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  487190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487217 */     // MIs[1] Operand 1
     /*  487217 */     // No operand predicates
     /*  487217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487226 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  487226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  487229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487249 */     GIR_RootConstrainSelectedInstOperands,
     /*  487250 */     // GIR_Coverage, 62015,
     /*  487250 */     GIR_EraseRootFromParent_Done,
     /*  487251 */   // Label 8180: @487251
     /*  487251 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(487337), // Rule ID 62018 //
     /*  487256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  487259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  487267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  487270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  487273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  487276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487303 */     // MIs[1] Operand 1
     /*  487303 */     // No operand predicates
     /*  487303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487312 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  487312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487335 */     GIR_RootConstrainSelectedInstOperands,
     /*  487336 */     // GIR_Coverage, 62018,
     /*  487336 */     GIR_EraseRootFromParent_Done,
     /*  487337 */   // Label 8181: @487337
     /*  487337 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(487423), // Rule ID 62019 //
     /*  487342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  487345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  487353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  487356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  487359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  487362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487389 */     // MIs[1] Operand 1
     /*  487389 */     // No operand predicates
     /*  487389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487398 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  487398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487421 */     GIR_RootConstrainSelectedInstOperands,
     /*  487422 */     // GIR_Coverage, 62019,
     /*  487422 */     GIR_EraseRootFromParent_Done,
     /*  487423 */   // Label 8182: @487423
     /*  487423 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(487509), // Rule ID 62022 //
     /*  487428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  487431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  487439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  487442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  487445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  487448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487475 */     // MIs[1] Operand 1
     /*  487475 */     // No operand predicates
     /*  487475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  487484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487507 */     GIR_RootConstrainSelectedInstOperands,
     /*  487508 */     // GIR_Coverage, 62022,
     /*  487508 */     GIR_EraseRootFromParent_Done,
     /*  487509 */   // Label 8183: @487509
     /*  487509 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(487595), // Rule ID 62023 //
     /*  487514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  487517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  487525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  487528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  487531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  487534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487561 */     // MIs[1] Operand 1
     /*  487561 */     // No operand predicates
     /*  487561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487570 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  487570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487593 */     GIR_RootConstrainSelectedInstOperands,
     /*  487594 */     // GIR_Coverage, 62023,
     /*  487594 */     GIR_EraseRootFromParent_Done,
     /*  487595 */   // Label 8184: @487595
     /*  487595 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(487681), // Rule ID 62026 //
     /*  487600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  487603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  487611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  487614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  487620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487647 */     // MIs[1] Operand 1
     /*  487647 */     // No operand predicates
     /*  487647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  487656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487679 */     GIR_RootConstrainSelectedInstOperands,
     /*  487680 */     // GIR_Coverage, 62026,
     /*  487680 */     GIR_EraseRootFromParent_Done,
     /*  487681 */   // Label 8185: @487681
     /*  487681 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(487767), // Rule ID 62027 //
     /*  487686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  487689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  487697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  487700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  487706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487733 */     // MIs[1] Operand 1
     /*  487733 */     // No operand predicates
     /*  487733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487742 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  487742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487765 */     GIR_RootConstrainSelectedInstOperands,
     /*  487766 */     // GIR_Coverage, 62027,
     /*  487766 */     GIR_EraseRootFromParent_Done,
     /*  487767 */   // Label 8186: @487767
     /*  487767 */   GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(487853), // Rule ID 62030 //
     /*  487772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  487775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  487783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  487786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  487789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  487792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487819 */     // MIs[1] Operand 1
     /*  487819 */     // No operand predicates
     /*  487819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487828 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  487828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  487848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487851 */     GIR_RootConstrainSelectedInstOperands,
     /*  487852 */     // GIR_Coverage, 62030,
     /*  487852 */     GIR_EraseRootFromParent_Done,
     /*  487853 */   // Label 8187: @487853
     /*  487853 */   GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(487939), // Rule ID 62031 //
     /*  487858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  487861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  487869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  487872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  487875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  487878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487905 */     // MIs[1] Operand 1
     /*  487905 */     // No operand predicates
     /*  487905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487914 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  487914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  487934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487937 */     GIR_RootConstrainSelectedInstOperands,
     /*  487938 */     // GIR_Coverage, 62031,
     /*  487938 */     GIR_EraseRootFromParent_Done,
     /*  487939 */   // Label 8188: @487939
     /*  487939 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(488025), // Rule ID 62034 //
     /*  487944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  487947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  487955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  487958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  487961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  487964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487991 */     // MIs[1] Operand 1
     /*  487991 */     // No operand predicates
     /*  487991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488000 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  488000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  488003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488023 */     GIR_RootConstrainSelectedInstOperands,
     /*  488024 */     // GIR_Coverage, 62034,
     /*  488024 */     GIR_EraseRootFromParent_Done,
     /*  488025 */   // Label 8189: @488025
     /*  488025 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(488111), // Rule ID 62035 //
     /*  488030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  488033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  488041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  488044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  488047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488077 */     // MIs[1] Operand 1
     /*  488077 */     // No operand predicates
     /*  488077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488086 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  488086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  488089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488109 */     GIR_RootConstrainSelectedInstOperands,
     /*  488110 */     // GIR_Coverage, 62035,
     /*  488110 */     GIR_EraseRootFromParent_Done,
     /*  488111 */   // Label 8190: @488111
     /*  488111 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(488197), // Rule ID 62038 //
     /*  488116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  488119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  488127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  488130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  488133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488163 */     // MIs[1] Operand 1
     /*  488163 */     // No operand predicates
     /*  488163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488172 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  488172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  488175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488195 */     GIR_RootConstrainSelectedInstOperands,
     /*  488196 */     // GIR_Coverage, 62038,
     /*  488196 */     GIR_EraseRootFromParent_Done,
     /*  488197 */   // Label 8191: @488197
     /*  488197 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(488283), // Rule ID 62039 //
     /*  488202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  488205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  488213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  488216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  488219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488249 */     // MIs[1] Operand 1
     /*  488249 */     // No operand predicates
     /*  488249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488258 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  488258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  488261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488281 */     GIR_RootConstrainSelectedInstOperands,
     /*  488282 */     // GIR_Coverage, 62039,
     /*  488282 */     GIR_EraseRootFromParent_Done,
     /*  488283 */   // Label 8192: @488283
     /*  488283 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(488369), // Rule ID 62042 //
     /*  488288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  488291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  488299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  488302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  488305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488335 */     // MIs[1] Operand 1
     /*  488335 */     // No operand predicates
     /*  488335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488344 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  488344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  488347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488367 */     GIR_RootConstrainSelectedInstOperands,
     /*  488368 */     // GIR_Coverage, 62042,
     /*  488368 */     GIR_EraseRootFromParent_Done,
     /*  488369 */   // Label 8193: @488369
     /*  488369 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(488455), // Rule ID 62043 //
     /*  488374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  488377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  488385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  488388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  488391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488421 */     // MIs[1] Operand 1
     /*  488421 */     // No operand predicates
     /*  488421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488430 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  488430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  488433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488453 */     GIR_RootConstrainSelectedInstOperands,
     /*  488454 */     // GIR_Coverage, 62043,
     /*  488454 */     GIR_EraseRootFromParent_Done,
     /*  488455 */   // Label 8194: @488455
     /*  488455 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(488541), // Rule ID 62046 //
     /*  488460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  488463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  488471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  488474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  488477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488507 */     // MIs[1] Operand 1
     /*  488507 */     // No operand predicates
     /*  488507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  488516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  488519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488539 */     GIR_RootConstrainSelectedInstOperands,
     /*  488540 */     // GIR_Coverage, 62046,
     /*  488540 */     GIR_EraseRootFromParent_Done,
     /*  488541 */   // Label 8195: @488541
     /*  488541 */   GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(488627), // Rule ID 62047 //
     /*  488546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  488549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  488557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  488560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  488563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488593 */     // MIs[1] Operand 1
     /*  488593 */     // No operand predicates
     /*  488593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488602 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  488602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  488605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488625 */     GIR_RootConstrainSelectedInstOperands,
     /*  488626 */     // GIR_Coverage, 62047,
     /*  488626 */     GIR_EraseRootFromParent_Done,
     /*  488627 */   // Label 8196: @488627
     /*  488627 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(488713), // Rule ID 62050 //
     /*  488632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  488635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  488643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  488646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  488649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488679 */     // MIs[1] Operand 1
     /*  488679 */     // No operand predicates
     /*  488679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488688 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  488688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  488691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488711 */     GIR_RootConstrainSelectedInstOperands,
     /*  488712 */     // GIR_Coverage, 62050,
     /*  488712 */     GIR_EraseRootFromParent_Done,
     /*  488713 */   // Label 8197: @488713
     /*  488713 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(488799), // Rule ID 62051 //
     /*  488718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  488721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  488729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  488732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  488735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488765 */     // MIs[1] Operand 1
     /*  488765 */     // No operand predicates
     /*  488765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488774 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  488774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  488777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488797 */     GIR_RootConstrainSelectedInstOperands,
     /*  488798 */     // GIR_Coverage, 62051,
     /*  488798 */     GIR_EraseRootFromParent_Done,
     /*  488799 */   // Label 8198: @488799
     /*  488799 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(488885), // Rule ID 62054 //
     /*  488804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  488807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  488815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  488818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  488821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488851 */     // MIs[1] Operand 1
     /*  488851 */     // No operand predicates
     /*  488851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488860 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  488860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  488863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488883 */     GIR_RootConstrainSelectedInstOperands,
     /*  488884 */     // GIR_Coverage, 62054,
     /*  488884 */     GIR_EraseRootFromParent_Done,
     /*  488885 */   // Label 8199: @488885
     /*  488885 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(488971), // Rule ID 62055 //
     /*  488890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  488893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  488901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  488904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  488907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488937 */     // MIs[1] Operand 1
     /*  488937 */     // No operand predicates
     /*  488937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488946 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  488946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  488949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488969 */     GIR_RootConstrainSelectedInstOperands,
     /*  488970 */     // GIR_Coverage, 62055,
     /*  488970 */     GIR_EraseRootFromParent_Done,
     /*  488971 */   // Label 8200: @488971
     /*  488971 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(489057), // Rule ID 62058 //
     /*  488976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  488979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  488987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  488990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  488993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489023 */     // MIs[1] Operand 1
     /*  489023 */     // No operand predicates
     /*  489023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  489032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  489035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489055 */     GIR_RootConstrainSelectedInstOperands,
     /*  489056 */     // GIR_Coverage, 62058,
     /*  489056 */     GIR_EraseRootFromParent_Done,
     /*  489057 */   // Label 8201: @489057
     /*  489057 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(489143), // Rule ID 62059 //
     /*  489062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  489065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  489073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  489076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  489079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489109 */     // MIs[1] Operand 1
     /*  489109 */     // No operand predicates
     /*  489109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  489118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  489121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489141 */     GIR_RootConstrainSelectedInstOperands,
     /*  489142 */     // GIR_Coverage, 62059,
     /*  489142 */     GIR_EraseRootFromParent_Done,
     /*  489143 */   // Label 8202: @489143
     /*  489143 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(489229), // Rule ID 62062 //
     /*  489148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  489151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  489159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  489162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  489165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489195 */     // MIs[1] Operand 1
     /*  489195 */     // No operand predicates
     /*  489195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489204 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  489204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  489207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489227 */     GIR_RootConstrainSelectedInstOperands,
     /*  489228 */     // GIR_Coverage, 62062,
     /*  489228 */     GIR_EraseRootFromParent_Done,
     /*  489229 */   // Label 8203: @489229
     /*  489229 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(489315), // Rule ID 62063 //
     /*  489234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  489237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  489245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  489248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  489251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489281 */     // MIs[1] Operand 1
     /*  489281 */     // No operand predicates
     /*  489281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489290 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  489290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  489293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489313 */     GIR_RootConstrainSelectedInstOperands,
     /*  489314 */     // GIR_Coverage, 62063,
     /*  489314 */     GIR_EraseRootFromParent_Done,
     /*  489315 */   // Label 8204: @489315
     /*  489315 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(489401), // Rule ID 62066 //
     /*  489320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  489323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  489331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  489334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  489337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489367 */     // MIs[1] Operand 1
     /*  489367 */     // No operand predicates
     /*  489367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489376 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  489376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  489379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489399 */     GIR_RootConstrainSelectedInstOperands,
     /*  489400 */     // GIR_Coverage, 62066,
     /*  489400 */     GIR_EraseRootFromParent_Done,
     /*  489401 */   // Label 8205: @489401
     /*  489401 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(489487), // Rule ID 62067 //
     /*  489406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  489409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  489417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  489420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  489423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489453 */     // MIs[1] Operand 1
     /*  489453 */     // No operand predicates
     /*  489453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489462 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  489462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  489465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489485 */     GIR_RootConstrainSelectedInstOperands,
     /*  489486 */     // GIR_Coverage, 62067,
     /*  489486 */     GIR_EraseRootFromParent_Done,
     /*  489487 */   // Label 8206: @489487
     /*  489487 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(489573), // Rule ID 62070 //
     /*  489492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  489495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  489503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  489506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  489509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489539 */     // MIs[1] Operand 1
     /*  489539 */     // No operand predicates
     /*  489539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489548 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  489548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  489551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  489568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489571 */     GIR_RootConstrainSelectedInstOperands,
     /*  489572 */     // GIR_Coverage, 62070,
     /*  489572 */     GIR_EraseRootFromParent_Done,
     /*  489573 */   // Label 8207: @489573
     /*  489573 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(489659), // Rule ID 62071 //
     /*  489578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  489581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  489589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  489592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  489595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489625 */     // MIs[1] Operand 1
     /*  489625 */     // No operand predicates
     /*  489625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489634 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  489634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  489637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  489654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489657 */     GIR_RootConstrainSelectedInstOperands,
     /*  489658 */     // GIR_Coverage, 62071,
     /*  489658 */     GIR_EraseRootFromParent_Done,
     /*  489659 */   // Label 8208: @489659
     /*  489659 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(489745), // Rule ID 62074 //
     /*  489664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  489667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  489675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  489678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  489681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489711 */     // MIs[1] Operand 1
     /*  489711 */     // No operand predicates
     /*  489711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  489720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  489723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  489740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489743 */     GIR_RootConstrainSelectedInstOperands,
     /*  489744 */     // GIR_Coverage, 62074,
     /*  489744 */     GIR_EraseRootFromParent_Done,
     /*  489745 */   // Label 8209: @489745
     /*  489745 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(489831), // Rule ID 62075 //
     /*  489750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  489753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  489761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  489764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  489767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489797 */     // MIs[1] Operand 1
     /*  489797 */     // No operand predicates
     /*  489797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489806 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  489806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  489809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  489826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489829 */     GIR_RootConstrainSelectedInstOperands,
     /*  489830 */     // GIR_Coverage, 62075,
     /*  489830 */     GIR_EraseRootFromParent_Done,
     /*  489831 */   // Label 8210: @489831
     /*  489831 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(489917), // Rule ID 62078 //
     /*  489836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  489839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  489847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  489850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  489853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489883 */     // MIs[1] Operand 1
     /*  489883 */     // No operand predicates
     /*  489883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489892 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  489892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  489895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  489912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489915 */     GIR_RootConstrainSelectedInstOperands,
     /*  489916 */     // GIR_Coverage, 62078,
     /*  489916 */     GIR_EraseRootFromParent_Done,
     /*  489917 */   // Label 8211: @489917
     /*  489917 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(490003), // Rule ID 62079 //
     /*  489922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  489925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  489933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  489936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  489939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489969 */     // MIs[1] Operand 1
     /*  489969 */     // No operand predicates
     /*  489969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489978 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  489978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  489981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  489998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490001 */     GIR_RootConstrainSelectedInstOperands,
     /*  490002 */     // GIR_Coverage, 62079,
     /*  490002 */     GIR_EraseRootFromParent_Done,
     /*  490003 */   // Label 8212: @490003
     /*  490003 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(490082), // Rule ID 2744 //
     /*  490008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  490019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  490022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  490025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  490028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490060 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  490063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490080 */     GIR_RootConstrainSelectedInstOperands,
     /*  490081 */     // GIR_Coverage, 2744,
     /*  490081 */     GIR_EraseRootFromParent_Done,
     /*  490082 */   // Label 8213: @490082
     /*  490082 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(490161), // Rule ID 2745 //
     /*  490087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  490098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  490101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  490104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  490107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490139 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  490142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490159 */     GIR_RootConstrainSelectedInstOperands,
     /*  490160 */     // GIR_Coverage, 2745,
     /*  490160 */     GIR_EraseRootFromParent_Done,
     /*  490161 */   // Label 8214: @490161
     /*  490161 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(490240), // Rule ID 4060 //
     /*  490166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  490177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  490180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  490183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  490186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  490221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490238 */     GIR_RootConstrainSelectedInstOperands,
     /*  490239 */     // GIR_Coverage, 4060,
     /*  490239 */     GIR_EraseRootFromParent_Done,
     /*  490240 */   // Label 8215: @490240
     /*  490240 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(490319), // Rule ID 4061 //
     /*  490245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  490256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  490259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  490262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  490265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490297 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  490300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490317 */     GIR_RootConstrainSelectedInstOperands,
     /*  490318 */     // GIR_Coverage, 4061,
     /*  490318 */     GIR_EraseRootFromParent_Done,
     /*  490319 */   // Label 8216: @490319
     /*  490319 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(490398), // Rule ID 4070 //
     /*  490324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  490335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  490338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  490341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  490344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490376 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  490379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490396 */     GIR_RootConstrainSelectedInstOperands,
     /*  490397 */     // GIR_Coverage, 4070,
     /*  490397 */     GIR_EraseRootFromParent_Done,
     /*  490398 */   // Label 8217: @490398
     /*  490398 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(490477), // Rule ID 4071 //
     /*  490403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  490414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  490417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  490420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  490423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490455 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  490458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490475 */     GIR_RootConstrainSelectedInstOperands,
     /*  490476 */     // GIR_Coverage, 4071,
     /*  490476 */     GIR_EraseRootFromParent_Done,
     /*  490477 */   // Label 8218: @490477
     /*  490477 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(490556), // Rule ID 4080 //
     /*  490482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  490493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  490496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  490499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  490502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490534 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  490537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490554 */     GIR_RootConstrainSelectedInstOperands,
     /*  490555 */     // GIR_Coverage, 4080,
     /*  490555 */     GIR_EraseRootFromParent_Done,
     /*  490556 */   // Label 8219: @490556
     /*  490556 */   GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(490635), // Rule ID 4081 //
     /*  490561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  490572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  490575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  490578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  490581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490613 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  490616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490633 */     GIR_RootConstrainSelectedInstOperands,
     /*  490634 */     // GIR_Coverage, 4081,
     /*  490634 */     GIR_EraseRootFromParent_Done,
     /*  490635 */   // Label 8220: @490635
     /*  490635 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(490714), // Rule ID 4090 //
     /*  490640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  490651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  490654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  490657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  490660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490692 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  490695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490712 */     GIR_RootConstrainSelectedInstOperands,
     /*  490713 */     // GIR_Coverage, 4090,
     /*  490713 */     GIR_EraseRootFromParent_Done,
     /*  490714 */   // Label 8221: @490714
     /*  490714 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(490793), // Rule ID 4091 //
     /*  490719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  490730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  490733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  490736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  490739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  490774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490791 */     GIR_RootConstrainSelectedInstOperands,
     /*  490792 */     // GIR_Coverage, 4091,
     /*  490792 */     GIR_EraseRootFromParent_Done,
     /*  490793 */   // Label 8222: @490793
     /*  490793 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(490872), // Rule ID 4100 //
     /*  490798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  490809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  490812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  490815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  490818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490850 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  490853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490870 */     GIR_RootConstrainSelectedInstOperands,
     /*  490871 */     // GIR_Coverage, 4100,
     /*  490871 */     GIR_EraseRootFromParent_Done,
     /*  490872 */   // Label 8223: @490872
     /*  490872 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(490951), // Rule ID 4101 //
     /*  490877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  490888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  490891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  490894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  490897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490929 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  490932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490949 */     GIR_RootConstrainSelectedInstOperands,
     /*  490950 */     // GIR_Coverage, 4101,
     /*  490950 */     GIR_EraseRootFromParent_Done,
     /*  490951 */   // Label 8224: @490951
     /*  490951 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(491030), // Rule ID 4110 //
     /*  490956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  490967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  490970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  490973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  490976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491008 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  491011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491028 */     GIR_RootConstrainSelectedInstOperands,
     /*  491029 */     // GIR_Coverage, 4110,
     /*  491029 */     GIR_EraseRootFromParent_Done,
     /*  491030 */   // Label 8225: @491030
     /*  491030 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(491109), // Rule ID 4111 //
     /*  491035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  491046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  491049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  491052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  491055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491087 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  491090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491107 */     GIR_RootConstrainSelectedInstOperands,
     /*  491108 */     // GIR_Coverage, 4111,
     /*  491108 */     GIR_EraseRootFromParent_Done,
     /*  491109 */   // Label 8226: @491109
     /*  491109 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(491188), // Rule ID 4120 //
     /*  491114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  491125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  491128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  491131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  491134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  491169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491186 */     GIR_RootConstrainSelectedInstOperands,
     /*  491187 */     // GIR_Coverage, 4120,
     /*  491187 */     GIR_EraseRootFromParent_Done,
     /*  491188 */   // Label 8227: @491188
     /*  491188 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(491267), // Rule ID 4121 //
     /*  491193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  491204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  491207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  491210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  491213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491245 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  491248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491265 */     GIR_RootConstrainSelectedInstOperands,
     /*  491266 */     // GIR_Coverage, 4121,
     /*  491266 */     GIR_EraseRootFromParent_Done,
     /*  491267 */   // Label 8228: @491267
     /*  491267 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(491346), // Rule ID 4130 //
     /*  491272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  491283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  491286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  491289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  491292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  491327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491344 */     GIR_RootConstrainSelectedInstOperands,
     /*  491345 */     // GIR_Coverage, 4130,
     /*  491345 */     GIR_EraseRootFromParent_Done,
     /*  491346 */   // Label 8229: @491346
     /*  491346 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(491425), // Rule ID 4131 //
     /*  491351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  491362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  491365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  491368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  491371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491403 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  491406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491423 */     GIR_RootConstrainSelectedInstOperands,
     /*  491424 */     // GIR_Coverage, 4131,
     /*  491424 */     GIR_EraseRootFromParent_Done,
     /*  491425 */   // Label 8230: @491425
     /*  491425 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(491504), // Rule ID 4140 //
     /*  491430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  491441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  491444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  491447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  491450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  491485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491502 */     GIR_RootConstrainSelectedInstOperands,
     /*  491503 */     // GIR_Coverage, 4140,
     /*  491503 */     GIR_EraseRootFromParent_Done,
     /*  491504 */   // Label 8231: @491504
     /*  491504 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(491583), // Rule ID 4141 //
     /*  491509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  491520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  491523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  491526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  491529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491561 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  491564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491581 */     GIR_RootConstrainSelectedInstOperands,
     /*  491582 */     // GIR_Coverage, 4141,
     /*  491582 */     GIR_EraseRootFromParent_Done,
     /*  491583 */   // Label 8232: @491583
     /*  491583 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(491662), // Rule ID 4150 //
     /*  491588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  491599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  491602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  491605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  491608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  491643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491660 */     GIR_RootConstrainSelectedInstOperands,
     /*  491661 */     // GIR_Coverage, 4150,
     /*  491661 */     GIR_EraseRootFromParent_Done,
     /*  491662 */   // Label 8233: @491662
     /*  491662 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(491741), // Rule ID 4151 //
     /*  491667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  491678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  491681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  491684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  491687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491719 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  491722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491739 */     GIR_RootConstrainSelectedInstOperands,
     /*  491740 */     // GIR_Coverage, 4151,
     /*  491740 */     GIR_EraseRootFromParent_Done,
     /*  491741 */   // Label 8234: @491741
     /*  491741 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(491820), // Rule ID 4160 //
     /*  491746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  491749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  491757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  491760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  491763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  491766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491798 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  491798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  491801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491818 */     GIR_RootConstrainSelectedInstOperands,
     /*  491819 */     // GIR_Coverage, 4160,
     /*  491819 */     GIR_EraseRootFromParent_Done,
     /*  491820 */   // Label 8235: @491820
     /*  491820 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(491899), // Rule ID 4161 //
     /*  491825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  491828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  491836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  491839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  491842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  491845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491877 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  491877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  491880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491897 */     GIR_RootConstrainSelectedInstOperands,
     /*  491898 */     // GIR_Coverage, 4161,
     /*  491898 */     GIR_EraseRootFromParent_Done,
     /*  491899 */   // Label 8236: @491899
     /*  491899 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(491978), // Rule ID 4170 //
     /*  491904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  491907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  491915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  491918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  491921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  491924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491956 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  491956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  491959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491976 */     GIR_RootConstrainSelectedInstOperands,
     /*  491977 */     // GIR_Coverage, 4170,
     /*  491977 */     GIR_EraseRootFromParent_Done,
     /*  491978 */   // Label 8237: @491978
     /*  491978 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(492057), // Rule ID 4171 //
     /*  491983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  491986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  491994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  491997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  492000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  492003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492035 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  492038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492055 */     GIR_RootConstrainSelectedInstOperands,
     /*  492056 */     // GIR_Coverage, 4171,
     /*  492056 */     GIR_EraseRootFromParent_Done,
     /*  492057 */   // Label 8238: @492057
     /*  492057 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(492136), // Rule ID 4180 //
     /*  492062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  492073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  492076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  492079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  492082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492114 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  492114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  492117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492134 */     GIR_RootConstrainSelectedInstOperands,
     /*  492135 */     // GIR_Coverage, 4180,
     /*  492135 */     GIR_EraseRootFromParent_Done,
     /*  492136 */   // Label 8239: @492136
     /*  492136 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(492215), // Rule ID 4181 //
     /*  492141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  492152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  492155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  492158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  492161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492193 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  492196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492213 */     GIR_RootConstrainSelectedInstOperands,
     /*  492214 */     // GIR_Coverage, 4181,
     /*  492214 */     GIR_EraseRootFromParent_Done,
     /*  492215 */   // Label 8240: @492215
     /*  492215 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(492294), // Rule ID 4190 //
     /*  492220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  492231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  492234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  492237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  492240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492272 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  492272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  492275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492292 */     GIR_RootConstrainSelectedInstOperands,
     /*  492293 */     // GIR_Coverage, 4190,
     /*  492293 */     GIR_EraseRootFromParent_Done,
     /*  492294 */   // Label 8241: @492294
     /*  492294 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(492373), // Rule ID 4191 //
     /*  492299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  492310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  492313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  492316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  492319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492351 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  492354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492371 */     GIR_RootConstrainSelectedInstOperands,
     /*  492372 */     // GIR_Coverage, 4191,
     /*  492372 */     GIR_EraseRootFromParent_Done,
     /*  492373 */   // Label 8242: @492373
     /*  492373 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(492452), // Rule ID 4260 //
     /*  492378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  492389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  492392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  492395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  492398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492430 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  492433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492450 */     GIR_RootConstrainSelectedInstOperands,
     /*  492451 */     // GIR_Coverage, 4260,
     /*  492451 */     GIR_EraseRootFromParent_Done,
     /*  492452 */   // Label 8243: @492452
     /*  492452 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(492531), // Rule ID 4261 //
     /*  492457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  492468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  492471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  492474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  492477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492509 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  492509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  492512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492529 */     GIR_RootConstrainSelectedInstOperands,
     /*  492530 */     // GIR_Coverage, 4261,
     /*  492530 */     GIR_EraseRootFromParent_Done,
     /*  492531 */   // Label 8244: @492531
     /*  492531 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(492610), // Rule ID 4270 //
     /*  492536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  492547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  492550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  492553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  492556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492588 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  492591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492608 */     GIR_RootConstrainSelectedInstOperands,
     /*  492609 */     // GIR_Coverage, 4270,
     /*  492609 */     GIR_EraseRootFromParent_Done,
     /*  492610 */   // Label 8245: @492610
     /*  492610 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(492689), // Rule ID 4271 //
     /*  492615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  492626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  492629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  492632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  492635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492667 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  492667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  492670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492687 */     GIR_RootConstrainSelectedInstOperands,
     /*  492688 */     // GIR_Coverage, 4271,
     /*  492688 */     GIR_EraseRootFromParent_Done,
     /*  492689 */   // Label 8246: @492689
     /*  492689 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(492768), // Rule ID 4280 //
     /*  492694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  492705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  492708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  492711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  492714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492746 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  492749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492766 */     GIR_RootConstrainSelectedInstOperands,
     /*  492767 */     // GIR_Coverage, 4280,
     /*  492767 */     GIR_EraseRootFromParent_Done,
     /*  492768 */   // Label 8247: @492768
     /*  492768 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(492847), // Rule ID 4281 //
     /*  492773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  492784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  492787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  492790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  492793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492825 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  492825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  492828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492845 */     GIR_RootConstrainSelectedInstOperands,
     /*  492846 */     // GIR_Coverage, 4281,
     /*  492846 */     GIR_EraseRootFromParent_Done,
     /*  492847 */   // Label 8248: @492847
     /*  492847 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(492926), // Rule ID 4290 //
     /*  492852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  492863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  492866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  492869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  492872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492904 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  492907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492924 */     GIR_RootConstrainSelectedInstOperands,
     /*  492925 */     // GIR_Coverage, 4290,
     /*  492925 */     GIR_EraseRootFromParent_Done,
     /*  492926 */   // Label 8249: @492926
     /*  492926 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(493005), // Rule ID 4291 //
     /*  492931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  492942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  492945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  492948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  492951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492983 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  492983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  492986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493003 */     GIR_RootConstrainSelectedInstOperands,
     /*  493004 */     // GIR_Coverage, 4291,
     /*  493004 */     GIR_EraseRootFromParent_Done,
     /*  493005 */   // Label 8250: @493005
     /*  493005 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(493084), // Rule ID 4300 //
     /*  493010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  493021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  493024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  493027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  493030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493062 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  493065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493082 */     GIR_RootConstrainSelectedInstOperands,
     /*  493083 */     // GIR_Coverage, 4300,
     /*  493083 */     GIR_EraseRootFromParent_Done,
     /*  493084 */   // Label 8251: @493084
     /*  493084 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(493163), // Rule ID 4301 //
     /*  493089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  493100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  493103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  493106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  493109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493141 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  493144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493161 */     GIR_RootConstrainSelectedInstOperands,
     /*  493162 */     // GIR_Coverage, 4301,
     /*  493162 */     GIR_EraseRootFromParent_Done,
     /*  493163 */   // Label 8252: @493163
     /*  493163 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(493242), // Rule ID 4310 //
     /*  493168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  493179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  493182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  493185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  493188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493220 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  493223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493240 */     GIR_RootConstrainSelectedInstOperands,
     /*  493241 */     // GIR_Coverage, 4310,
     /*  493241 */     GIR_EraseRootFromParent_Done,
     /*  493242 */   // Label 8253: @493242
     /*  493242 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(493321), // Rule ID 4311 //
     /*  493247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  493258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  493261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  493264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  493267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493299 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  493302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493319 */     GIR_RootConstrainSelectedInstOperands,
     /*  493320 */     // GIR_Coverage, 4311,
     /*  493320 */     GIR_EraseRootFromParent_Done,
     /*  493321 */   // Label 8254: @493321
     /*  493321 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(493400), // Rule ID 4320 //
     /*  493326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  493337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  493340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  493343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  493346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  493378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  493381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493398 */     GIR_RootConstrainSelectedInstOperands,
     /*  493399 */     // GIR_Coverage, 4320,
     /*  493399 */     GIR_EraseRootFromParent_Done,
     /*  493400 */   // Label 8255: @493400
     /*  493400 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(493479), // Rule ID 4321 //
     /*  493405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  493416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  493419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  493422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  493425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493457 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  493457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  493460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493477 */     GIR_RootConstrainSelectedInstOperands,
     /*  493478 */     // GIR_Coverage, 4321,
     /*  493478 */     GIR_EraseRootFromParent_Done,
     /*  493479 */   // Label 8256: @493479
     /*  493479 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(493558), // Rule ID 4330 //
     /*  493484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  493495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  493498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  493501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  493504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  493536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  493539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493556 */     GIR_RootConstrainSelectedInstOperands,
     /*  493557 */     // GIR_Coverage, 4330,
     /*  493557 */     GIR_EraseRootFromParent_Done,
     /*  493558 */   // Label 8257: @493558
     /*  493558 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(493637), // Rule ID 4331 //
     /*  493563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  493574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  493577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  493580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  493583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493615 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  493615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  493618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493635 */     GIR_RootConstrainSelectedInstOperands,
     /*  493636 */     // GIR_Coverage, 4331,
     /*  493636 */     GIR_EraseRootFromParent_Done,
     /*  493637 */   // Label 8258: @493637
     /*  493637 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(493716), // Rule ID 4340 //
     /*  493642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  493653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  493656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  493659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  493662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  493694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  493697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493714 */     GIR_RootConstrainSelectedInstOperands,
     /*  493715 */     // GIR_Coverage, 4340,
     /*  493715 */     GIR_EraseRootFromParent_Done,
     /*  493716 */   // Label 8259: @493716
     /*  493716 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(493795), // Rule ID 4341 //
     /*  493721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  493732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  493735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  493738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  493741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  493773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  493776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493793 */     GIR_RootConstrainSelectedInstOperands,
     /*  493794 */     // GIR_Coverage, 4341,
     /*  493794 */     GIR_EraseRootFromParent_Done,
     /*  493795 */   // Label 8260: @493795
     /*  493795 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(493874), // Rule ID 4350 //
     /*  493800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  493811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  493814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  493817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  493820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  493852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  493855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493872 */     GIR_RootConstrainSelectedInstOperands,
     /*  493873 */     // GIR_Coverage, 4350,
     /*  493873 */     GIR_EraseRootFromParent_Done,
     /*  493874 */   // Label 8261: @493874
     /*  493874 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(493953), // Rule ID 4351 //
     /*  493879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  493890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  493893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  493896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  493899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493931 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  493931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  493934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493951 */     GIR_RootConstrainSelectedInstOperands,
     /*  493952 */     // GIR_Coverage, 4351,
     /*  493952 */     GIR_EraseRootFromParent_Done,
     /*  493953 */   // Label 8262: @493953
     /*  493953 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(494032), // Rule ID 4360 //
     /*  493958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  493969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  493972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  493975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  493978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494010 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  494013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494030 */     GIR_RootConstrainSelectedInstOperands,
     /*  494031 */     // GIR_Coverage, 4360,
     /*  494031 */     GIR_EraseRootFromParent_Done,
     /*  494032 */   // Label 8263: @494032
     /*  494032 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(494111), // Rule ID 4361 //
     /*  494037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  494048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  494051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  494054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  494057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494089 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  494092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494109 */     GIR_RootConstrainSelectedInstOperands,
     /*  494110 */     // GIR_Coverage, 4361,
     /*  494110 */     GIR_EraseRootFromParent_Done,
     /*  494111 */   // Label 8264: @494111
     /*  494111 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(494190), // Rule ID 4370 //
     /*  494116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  494127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  494130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  494133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  494136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  494168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  494171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494188 */     GIR_RootConstrainSelectedInstOperands,
     /*  494189 */     // GIR_Coverage, 4370,
     /*  494189 */     GIR_EraseRootFromParent_Done,
     /*  494190 */   // Label 8265: @494190
     /*  494190 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(494269), // Rule ID 4371 //
     /*  494195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  494206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  494209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  494212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  494215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494247 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  494247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  494250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494267 */     GIR_RootConstrainSelectedInstOperands,
     /*  494268 */     // GIR_Coverage, 4371,
     /*  494268 */     GIR_EraseRootFromParent_Done,
     /*  494269 */   // Label 8266: @494269
     /*  494269 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(494348), // Rule ID 4380 //
     /*  494274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  494285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  494288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  494291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  494294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  494326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  494329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494346 */     GIR_RootConstrainSelectedInstOperands,
     /*  494347 */     // GIR_Coverage, 4380,
     /*  494347 */     GIR_EraseRootFromParent_Done,
     /*  494348 */   // Label 8267: @494348
     /*  494348 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(494427), // Rule ID 4381 //
     /*  494353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  494364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  494367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  494370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  494373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494405 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  494405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  494408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494425 */     GIR_RootConstrainSelectedInstOperands,
     /*  494426 */     // GIR_Coverage, 4381,
     /*  494426 */     GIR_EraseRootFromParent_Done,
     /*  494427 */   // Label 8268: @494427
     /*  494427 */   GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(494506), // Rule ID 4390 //
     /*  494432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  494443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  494446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  494449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  494452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  494484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  494487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494504 */     GIR_RootConstrainSelectedInstOperands,
     /*  494505 */     // GIR_Coverage, 4390,
     /*  494505 */     GIR_EraseRootFromParent_Done,
     /*  494506 */   // Label 8269: @494506
     /*  494506 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(494585), // Rule ID 4391 //
     /*  494511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  494522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  494525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  494528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  494531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494563 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  494563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  494566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494583 */     GIR_RootConstrainSelectedInstOperands,
     /*  494584 */     // GIR_Coverage, 4391,
     /*  494584 */     GIR_EraseRootFromParent_Done,
     /*  494585 */   // Label 8270: @494585
     /*  494585 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(494664), // Rule ID 4400 //
     /*  494590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  494601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  494604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  494607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  494610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  494642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  494645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494662 */     GIR_RootConstrainSelectedInstOperands,
     /*  494663 */     // GIR_Coverage, 4400,
     /*  494663 */     GIR_EraseRootFromParent_Done,
     /*  494664 */   // Label 8271: @494664
     /*  494664 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(494743), // Rule ID 4401 //
     /*  494669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  494680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  494683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  494686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  494689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494721 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11650:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  494721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  494724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494741 */     GIR_RootConstrainSelectedInstOperands,
     /*  494742 */     // GIR_Coverage, 4401,
     /*  494742 */     GIR_EraseRootFromParent_Done,
     /*  494743 */   // Label 8272: @494743
     /*  494743 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(494822), // Rule ID 4470 //
     /*  494748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  494756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  494759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  494762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  494765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  494768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494800 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  494803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494820 */     GIR_RootConstrainSelectedInstOperands,
     /*  494821 */     // GIR_Coverage, 4470,
     /*  494821 */     GIR_EraseRootFromParent_Done,
     /*  494822 */   // Label 8273: @494822
     /*  494822 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(494901), // Rule ID 4471 //
     /*  494827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  494835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  494838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  494841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  494844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  494847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494879 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  494882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494899 */     GIR_RootConstrainSelectedInstOperands,
     /*  494900 */     // GIR_Coverage, 4471,
     /*  494900 */     GIR_EraseRootFromParent_Done,
     /*  494901 */   // Label 8274: @494901
     /*  494901 */   GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(494980), // Rule ID 4480 //
     /*  494906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  494914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  494917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  494920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  494923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  494926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  494961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494978 */     GIR_RootConstrainSelectedInstOperands,
     /*  494979 */     // GIR_Coverage, 4480,
     /*  494979 */     GIR_EraseRootFromParent_Done,
     /*  494980 */   // Label 8275: @494980
     /*  494980 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(495059), // Rule ID 4481 //
     /*  494985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  494993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  494996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  494999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  495002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  495005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495037 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  495037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  495040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495057 */     GIR_RootConstrainSelectedInstOperands,
     /*  495058 */     // GIR_Coverage, 4481,
     /*  495058 */     GIR_EraseRootFromParent_Done,
     /*  495059 */   // Label 8276: @495059
     /*  495059 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(495138), // Rule ID 4490 //
     /*  495064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  495075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  495078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  495081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  495084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495116 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  495116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  495119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495136 */     GIR_RootConstrainSelectedInstOperands,
     /*  495137 */     // GIR_Coverage, 4490,
     /*  495137 */     GIR_EraseRootFromParent_Done,
     /*  495138 */   // Label 8277: @495138
     /*  495138 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(495217), // Rule ID 4491 //
     /*  495143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  495154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  495157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  495160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  495163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495195 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  495195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  495198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495215 */     GIR_RootConstrainSelectedInstOperands,
     /*  495216 */     // GIR_Coverage, 4491,
     /*  495216 */     GIR_EraseRootFromParent_Done,
     /*  495217 */   // Label 8278: @495217
     /*  495217 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(495296), // Rule ID 4500 //
     /*  495222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  495233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  495236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  495239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  495242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495274 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  495274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  495277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495294 */     GIR_RootConstrainSelectedInstOperands,
     /*  495295 */     // GIR_Coverage, 4500,
     /*  495295 */     GIR_EraseRootFromParent_Done,
     /*  495296 */   // Label 8279: @495296
     /*  495296 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(495375), // Rule ID 4501 //
     /*  495301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  495312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  495315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  495318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  495321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  495353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  495356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495373 */     GIR_RootConstrainSelectedInstOperands,
     /*  495374 */     // GIR_Coverage, 4501,
     /*  495374 */     GIR_EraseRootFromParent_Done,
     /*  495375 */   // Label 8280: @495375
     /*  495375 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(495454), // Rule ID 4510 //
     /*  495380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  495391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  495394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  495397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  495400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495432 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  495432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  495435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495452 */     GIR_RootConstrainSelectedInstOperands,
     /*  495453 */     // GIR_Coverage, 4510,
     /*  495453 */     GIR_EraseRootFromParent_Done,
     /*  495454 */   // Label 8281: @495454
     /*  495454 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(495533), // Rule ID 4511 //
     /*  495459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  495470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  495473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  495476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  495479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495511 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  495511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  495514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495531 */     GIR_RootConstrainSelectedInstOperands,
     /*  495532 */     // GIR_Coverage, 4511,
     /*  495532 */     GIR_EraseRootFromParent_Done,
     /*  495533 */   // Label 8282: @495533
     /*  495533 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(495612), // Rule ID 4520 //
     /*  495538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  495549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  495552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  495555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  495558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495590 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  495590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  495593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495610 */     GIR_RootConstrainSelectedInstOperands,
     /*  495611 */     // GIR_Coverage, 4520,
     /*  495611 */     GIR_EraseRootFromParent_Done,
     /*  495612 */   // Label 8283: @495612
     /*  495612 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(495691), // Rule ID 4521 //
     /*  495617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  495628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  495631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  495634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  495637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495669 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  495669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  495672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495689 */     GIR_RootConstrainSelectedInstOperands,
     /*  495690 */     // GIR_Coverage, 4521,
     /*  495690 */     GIR_EraseRootFromParent_Done,
     /*  495691 */   // Label 8284: @495691
     /*  495691 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(495770), // Rule ID 4530 //
     /*  495696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  495707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  495710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  495713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  495716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495748 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  495748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  495751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495768 */     GIR_RootConstrainSelectedInstOperands,
     /*  495769 */     // GIR_Coverage, 4530,
     /*  495769 */     GIR_EraseRootFromParent_Done,
     /*  495770 */   // Label 8285: @495770
     /*  495770 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(495849), // Rule ID 4531 //
     /*  495775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  495786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  495789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  495792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  495795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495827 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  495827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  495830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495847 */     GIR_RootConstrainSelectedInstOperands,
     /*  495848 */     // GIR_Coverage, 4531,
     /*  495848 */     GIR_EraseRootFromParent_Done,
     /*  495849 */   // Label 8286: @495849
     /*  495849 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(495928), // Rule ID 4540 //
     /*  495854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  495865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  495868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  495871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  495874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  495906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  495909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495926 */     GIR_RootConstrainSelectedInstOperands,
     /*  495927 */     // GIR_Coverage, 4540,
     /*  495927 */     GIR_EraseRootFromParent_Done,
     /*  495928 */   // Label 8287: @495928
     /*  495928 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(496007), // Rule ID 4541 //
     /*  495933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  495944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  495947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  495950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  495953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495985 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  495985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  495988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496005 */     GIR_RootConstrainSelectedInstOperands,
     /*  496006 */     // GIR_Coverage, 4541,
     /*  496006 */     GIR_EraseRootFromParent_Done,
     /*  496007 */   // Label 8288: @496007
     /*  496007 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(496086), // Rule ID 4550 //
     /*  496012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  496023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  496026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  496029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  496032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  496064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  496067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496084 */     GIR_RootConstrainSelectedInstOperands,
     /*  496085 */     // GIR_Coverage, 4550,
     /*  496085 */     GIR_EraseRootFromParent_Done,
     /*  496086 */   // Label 8289: @496086
     /*  496086 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(496165), // Rule ID 4551 //
     /*  496091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  496102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  496105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  496108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  496111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  496143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  496146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496163 */     GIR_RootConstrainSelectedInstOperands,
     /*  496164 */     // GIR_Coverage, 4551,
     /*  496164 */     GIR_EraseRootFromParent_Done,
     /*  496165 */   // Label 8290: @496165
     /*  496165 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(496244), // Rule ID 4560 //
     /*  496170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  496181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  496184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  496187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  496190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496222 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  496222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  496225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496242 */     GIR_RootConstrainSelectedInstOperands,
     /*  496243 */     // GIR_Coverage, 4560,
     /*  496243 */     GIR_EraseRootFromParent_Done,
     /*  496244 */   // Label 8291: @496244
     /*  496244 */   GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(496323), // Rule ID 4561 //
     /*  496249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  496260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  496263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  496266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  496269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496301 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  496301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  496304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496321 */     GIR_RootConstrainSelectedInstOperands,
     /*  496322 */     // GIR_Coverage, 4561,
     /*  496322 */     GIR_EraseRootFromParent_Done,
     /*  496323 */   // Label 8292: @496323
     /*  496323 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(496402), // Rule ID 4570 //
     /*  496328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  496339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  496342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  496345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  496348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496380 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  496380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  496383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496400 */     GIR_RootConstrainSelectedInstOperands,
     /*  496401 */     // GIR_Coverage, 4570,
     /*  496401 */     GIR_EraseRootFromParent_Done,
     /*  496402 */   // Label 8293: @496402
     /*  496402 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(496481), // Rule ID 4571 //
     /*  496407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  496418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  496421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  496424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  496427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496459 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  496459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  496462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496479 */     GIR_RootConstrainSelectedInstOperands,
     /*  496480 */     // GIR_Coverage, 4571,
     /*  496480 */     GIR_EraseRootFromParent_Done,
     /*  496481 */   // Label 8294: @496481
     /*  496481 */   GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(496560), // Rule ID 4580 //
     /*  496486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  496489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  496497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  496500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  496503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  496506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496538 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  496538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  496541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496558 */     GIR_RootConstrainSelectedInstOperands,
     /*  496559 */     // GIR_Coverage, 4580,
     /*  496559 */     GIR_EraseRootFromParent_Done,
     /*  496560 */   // Label 8295: @496560
     /*  496560 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(496639), // Rule ID 4581 //
     /*  496565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  496568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  496576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  496579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  496582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  496585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496617 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  496617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  496620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496637 */     GIR_RootConstrainSelectedInstOperands,
     /*  496638 */     // GIR_Coverage, 4581,
     /*  496638 */     GIR_EraseRootFromParent_Done,
     /*  496639 */   // Label 8296: @496639
     /*  496639 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(496718), // Rule ID 4590 //
     /*  496644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  496647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  496655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  496658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  496661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  496664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496696 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  496696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  496699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496716 */     GIR_RootConstrainSelectedInstOperands,
     /*  496717 */     // GIR_Coverage, 4590,
     /*  496717 */     GIR_EraseRootFromParent_Done,
     /*  496718 */   // Label 8297: @496718
     /*  496718 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(496797), // Rule ID 4591 //
     /*  496723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  496726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  496734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  496737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  496740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  496743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496775 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  496775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  496778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496795 */     GIR_RootConstrainSelectedInstOperands,
     /*  496796 */     // GIR_Coverage, 4591,
     /*  496796 */     GIR_EraseRootFromParent_Done,
     /*  496797 */   // Label 8298: @496797
     /*  496797 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(496876), // Rule ID 4600 //
     /*  496802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  496805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  496813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  496816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  496819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  496822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496854 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  496854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  496857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496874 */     GIR_RootConstrainSelectedInstOperands,
     /*  496875 */     // GIR_Coverage, 4600,
     /*  496875 */     GIR_EraseRootFromParent_Done,
     /*  496876 */   // Label 8299: @496876
     /*  496876 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(496955), // Rule ID 4601 //
     /*  496881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  496884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  496892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  496895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  496898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  496901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496933 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  496933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  496936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496953 */     GIR_RootConstrainSelectedInstOperands,
     /*  496954 */     // GIR_Coverage, 4601,
     /*  496954 */     GIR_EraseRootFromParent_Done,
     /*  496955 */   // Label 8300: @496955
     /*  496955 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(497034), // Rule ID 4610 //
     /*  496960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  496963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  496971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  496974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  496977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  496980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497012 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  497012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  497015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497032 */     GIR_RootConstrainSelectedInstOperands,
     /*  497033 */     // GIR_Coverage, 4610,
     /*  497033 */     GIR_EraseRootFromParent_Done,
     /*  497034 */   // Label 8301: @497034
     /*  497034 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(497113), // Rule ID 4611 //
     /*  497039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  497042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  497047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  497050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  497053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  497056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  497059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497091 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  497091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  497094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497111 */     GIR_RootConstrainSelectedInstOperands,
     /*  497112 */     // GIR_Coverage, 4611,
     /*  497112 */     GIR_EraseRootFromParent_Done,
     /*  497113 */   // Label 8302: @497113
     /*  497113 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(497192), // Rule ID 4680 //
     /*  497118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  497129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  497132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  497135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  497138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497170 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  497170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  497173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497190 */     GIR_RootConstrainSelectedInstOperands,
     /*  497191 */     // GIR_Coverage, 4680,
     /*  497191 */     GIR_EraseRootFromParent_Done,
     /*  497192 */   // Label 8303: @497192
     /*  497192 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(497271), // Rule ID 4681 //
     /*  497197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  497208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  497211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  497214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  497217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497249 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  497249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  497252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497269 */     GIR_RootConstrainSelectedInstOperands,
     /*  497270 */     // GIR_Coverage, 4681,
     /*  497270 */     GIR_EraseRootFromParent_Done,
     /*  497271 */   // Label 8304: @497271
     /*  497271 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(497350), // Rule ID 4690 //
     /*  497276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  497287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  497290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  497293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  497296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497328 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  497328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  497331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497348 */     GIR_RootConstrainSelectedInstOperands,
     /*  497349 */     // GIR_Coverage, 4690,
     /*  497349 */     GIR_EraseRootFromParent_Done,
     /*  497350 */   // Label 8305: @497350
     /*  497350 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(497429), // Rule ID 4691 //
     /*  497355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  497366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  497369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  497372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  497375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497407 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  497407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  497410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497427 */     GIR_RootConstrainSelectedInstOperands,
     /*  497428 */     // GIR_Coverage, 4691,
     /*  497428 */     GIR_EraseRootFromParent_Done,
     /*  497429 */   // Label 8306: @497429
     /*  497429 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(497508), // Rule ID 4700 //
     /*  497434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  497445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  497448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  497451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  497454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497486 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  497486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  497489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497506 */     GIR_RootConstrainSelectedInstOperands,
     /*  497507 */     // GIR_Coverage, 4700,
     /*  497507 */     GIR_EraseRootFromParent_Done,
     /*  497508 */   // Label 8307: @497508
     /*  497508 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(497587), // Rule ID 4701 //
     /*  497513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  497524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  497527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  497530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  497533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497565 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  497565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  497568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497585 */     GIR_RootConstrainSelectedInstOperands,
     /*  497586 */     // GIR_Coverage, 4701,
     /*  497586 */     GIR_EraseRootFromParent_Done,
     /*  497587 */   // Label 8308: @497587
     /*  497587 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(497666), // Rule ID 4710 //
     /*  497592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  497609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  497612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  497644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  497647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497664 */     GIR_RootConstrainSelectedInstOperands,
     /*  497665 */     // GIR_Coverage, 4710,
     /*  497665 */     GIR_EraseRootFromParent_Done,
     /*  497666 */   // Label 8309: @497666
     /*  497666 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(497745), // Rule ID 4711 //
     /*  497671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  497688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  497691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497723 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  497723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  497726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497743 */     GIR_RootConstrainSelectedInstOperands,
     /*  497744 */     // GIR_Coverage, 4711,
     /*  497744 */     GIR_EraseRootFromParent_Done,
     /*  497745 */   // Label 8310: @497745
     /*  497745 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(497824), // Rule ID 4720 //
     /*  497750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  497761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  497764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  497767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  497770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497802 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  497802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  497805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497822 */     GIR_RootConstrainSelectedInstOperands,
     /*  497823 */     // GIR_Coverage, 4720,
     /*  497823 */     GIR_EraseRootFromParent_Done,
     /*  497824 */   // Label 8311: @497824
     /*  497824 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(497903), // Rule ID 4721 //
     /*  497829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  497840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  497843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  497846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  497849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497881 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  497881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  497884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497901 */     GIR_RootConstrainSelectedInstOperands,
     /*  497902 */     // GIR_Coverage, 4721,
     /*  497902 */     GIR_EraseRootFromParent_Done,
     /*  497903 */   // Label 8312: @497903
     /*  497903 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(497982), // Rule ID 4730 //
     /*  497908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  497919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  497922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  497925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  497928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497960 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  497960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  497963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497980 */     GIR_RootConstrainSelectedInstOperands,
     /*  497981 */     // GIR_Coverage, 4730,
     /*  497981 */     GIR_EraseRootFromParent_Done,
     /*  497982 */   // Label 8313: @497982
     /*  497982 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(498061), // Rule ID 4731 //
     /*  497987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  497998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  498001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  498004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  498007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498039 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  498039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  498042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  498056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498059 */     GIR_RootConstrainSelectedInstOperands,
     /*  498060 */     // GIR_Coverage, 4731,
     /*  498060 */     GIR_EraseRootFromParent_Done,
     /*  498061 */   // Label 8314: @498061
     /*  498061 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(498140), // Rule ID 4740 //
     /*  498066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  498086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498118 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  498118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  498121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498138 */     GIR_RootConstrainSelectedInstOperands,
     /*  498139 */     // GIR_Coverage, 4740,
     /*  498139 */     GIR_EraseRootFromParent_Done,
     /*  498140 */   // Label 8315: @498140
     /*  498140 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(498219), // Rule ID 4741 //
     /*  498145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  498165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498197 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  498197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  498200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498217 */     GIR_RootConstrainSelectedInstOperands,
     /*  498218 */     // GIR_Coverage, 4741,
     /*  498218 */     GIR_EraseRootFromParent_Done,
     /*  498219 */   // Label 8316: @498219
     /*  498219 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(498298), // Rule ID 4750 //
     /*  498224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  498235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  498238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  498241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  498244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498276 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  498276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  498279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498296 */     GIR_RootConstrainSelectedInstOperands,
     /*  498297 */     // GIR_Coverage, 4750,
     /*  498297 */     GIR_EraseRootFromParent_Done,
     /*  498298 */   // Label 8317: @498298
     /*  498298 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(498377), // Rule ID 4751 //
     /*  498303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  498314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  498317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  498320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  498323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498355 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  498355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  498358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498375 */     GIR_RootConstrainSelectedInstOperands,
     /*  498376 */     // GIR_Coverage, 4751,
     /*  498376 */     GIR_EraseRootFromParent_Done,
     /*  498377 */   // Label 8318: @498377
     /*  498377 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(498456), // Rule ID 4760 //
     /*  498382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  498393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  498396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  498399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  498402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  498434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  498437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498454 */     GIR_RootConstrainSelectedInstOperands,
     /*  498455 */     // GIR_Coverage, 4760,
     /*  498455 */     GIR_EraseRootFromParent_Done,
     /*  498456 */   // Label 8319: @498456
     /*  498456 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(498535), // Rule ID 4761 //
     /*  498461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  498472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  498475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  498478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  498481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498513 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  498513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  498516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498533 */     GIR_RootConstrainSelectedInstOperands,
     /*  498534 */     // GIR_Coverage, 4761,
     /*  498534 */     GIR_EraseRootFromParent_Done,
     /*  498535 */   // Label 8320: @498535
     /*  498535 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(498614), // Rule ID 4770 //
     /*  498540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  498557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  498560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  498592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  498595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498612 */     GIR_RootConstrainSelectedInstOperands,
     /*  498613 */     // GIR_Coverage, 4770,
     /*  498613 */     GIR_EraseRootFromParent_Done,
     /*  498614 */   // Label 8321: @498614
     /*  498614 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(498693), // Rule ID 4771 //
     /*  498619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  498636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  498639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498671 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  498671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  498674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498691 */     GIR_RootConstrainSelectedInstOperands,
     /*  498692 */     // GIR_Coverage, 4771,
     /*  498692 */     GIR_EraseRootFromParent_Done,
     /*  498693 */   // Label 8322: @498693
     /*  498693 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(498772), // Rule ID 4780 //
     /*  498698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  498715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  498718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  498750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  498753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498770 */     GIR_RootConstrainSelectedInstOperands,
     /*  498771 */     // GIR_Coverage, 4780,
     /*  498771 */     GIR_EraseRootFromParent_Done,
     /*  498772 */   // Label 8323: @498772
     /*  498772 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(498851), // Rule ID 4781 //
     /*  498777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  498794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  498797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498829 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  498829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  498832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498849 */     GIR_RootConstrainSelectedInstOperands,
     /*  498850 */     // GIR_Coverage, 4781,
     /*  498850 */     GIR_EraseRootFromParent_Done,
     /*  498851 */   // Label 8324: @498851
     /*  498851 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(498930), // Rule ID 4790 //
     /*  498856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  498859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  498867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  498870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  498873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  498876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498908 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  498908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  498911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498928 */     GIR_RootConstrainSelectedInstOperands,
     /*  498929 */     // GIR_Coverage, 4790,
     /*  498929 */     GIR_EraseRootFromParent_Done,
     /*  498930 */   // Label 8325: @498930
     /*  498930 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(499009), // Rule ID 4791 //
     /*  498935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  498938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  498946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  498949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  498952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  498955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498987 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  498987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  498990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499007 */     GIR_RootConstrainSelectedInstOperands,
     /*  499008 */     // GIR_Coverage, 4791,
     /*  499008 */     GIR_EraseRootFromParent_Done,
     /*  499009 */   // Label 8326: @499009
     /*  499009 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(499088), // Rule ID 4800 //
     /*  499014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  499017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  499022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  499025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  499028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  499031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  499034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  499037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  499045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  499049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  499059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499066 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  499066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  499069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499086 */     GIR_RootConstrainSelectedInstOperands,
     /*  499087 */     // GIR_Coverage, 4800,
     /*  499087 */     GIR_EraseRootFromParent_Done,
     /*  499088 */   // Label 8327: @499088
     /*  499088 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(499167), // Rule ID 4801 //
     /*  499093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  499096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  499101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  499104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  499107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  499110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  499113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  499116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  499124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  499128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  499138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499145 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  499145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  499148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499165 */     GIR_RootConstrainSelectedInstOperands,
     /*  499166 */     // GIR_Coverage, 4801,
     /*  499166 */     GIR_EraseRootFromParent_Done,
     /*  499167 */   // Label 8328: @499167
     /*  499167 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(499246), // Rule ID 4810 //
     /*  499172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  499175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  499180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  499183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  499186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  499189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  499192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  499195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  499203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  499207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  499217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499224 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  499224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  499227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499244 */     GIR_RootConstrainSelectedInstOperands,
     /*  499245 */     // GIR_Coverage, 4810,
     /*  499245 */     GIR_EraseRootFromParent_Done,
     /*  499246 */   // Label 8329: @499246
     /*  499246 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(499325), // Rule ID 4811 //
     /*  499251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  499254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  499259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  499262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  499265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  499268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  499271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  499274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  499282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  499286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  499296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499303 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  499303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  499306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499323 */     GIR_RootConstrainSelectedInstOperands,
     /*  499324 */     // GIR_Coverage, 4811,
     /*  499324 */     GIR_EraseRootFromParent_Done,
     /*  499325 */   // Label 8330: @499325
     /*  499325 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(499404), // Rule ID 4820 //
     /*  499330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  499333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  499338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  499341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  499344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  499347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  499350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  499353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  499361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  499365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  499375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499382 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  499382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  499385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499402 */     GIR_RootConstrainSelectedInstOperands,
     /*  499403 */     // GIR_Coverage, 4820,
     /*  499403 */     GIR_EraseRootFromParent_Done,
     /*  499404 */   // Label 8331: @499404
     /*  499404 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(499483), // Rule ID 4821 //
     /*  499409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  499412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  499417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  499420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  499423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  499426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  499429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  499432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  499440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  499444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  499454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499461 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  499461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  499464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499481 */     GIR_RootConstrainSelectedInstOperands,
     /*  499482 */     // GIR_Coverage, 4821,
     /*  499482 */     GIR_EraseRootFromParent_Done,
     /*  499483 */   // Label 8332: @499483
     /*  499483 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(499551), // Rule ID 2704 //
     /*  499488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  499499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  499502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  499505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499520 */     // MIs[0] policy
     /*  499520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499530 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  499533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499537 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499547 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499549 */     GIR_RootConstrainSelectedInstOperands,
     /*  499550 */     // GIR_Coverage, 2704,
     /*  499550 */     GIR_EraseRootFromParent_Done,
     /*  499551 */   // Label 8333: @499551
     /*  499551 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(499619), // Rule ID 2705 //
     /*  499556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  499567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  499570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  499573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499588 */     // MIs[0] policy
     /*  499588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499598 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  499601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499605 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499615 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499617 */     GIR_RootConstrainSelectedInstOperands,
     /*  499618 */     // GIR_Coverage, 2705,
     /*  499618 */     GIR_EraseRootFromParent_Done,
     /*  499619 */   // Label 8334: @499619
     /*  499619 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(499687), // Rule ID 23500 //
     /*  499624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  499635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  499638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  499641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499656 */     // MIs[0] policy
     /*  499656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499666 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  499669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499673 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499683 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499685 */     GIR_RootConstrainSelectedInstOperands,
     /*  499686 */     // GIR_Coverage, 23500,
     /*  499686 */     GIR_EraseRootFromParent_Done,
     /*  499687 */   // Label 8335: @499687
     /*  499687 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(499755), // Rule ID 23501 //
     /*  499692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  499703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  499706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  499709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499724 */     // MIs[0] policy
     /*  499724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499734 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  499737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499741 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499751 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499753 */     GIR_RootConstrainSelectedInstOperands,
     /*  499754 */     // GIR_Coverage, 23501,
     /*  499754 */     GIR_EraseRootFromParent_Done,
     /*  499755 */   // Label 8336: @499755
     /*  499755 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(499823), // Rule ID 23504 //
     /*  499760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  499771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  499774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  499777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499792 */     // MIs[0] policy
     /*  499792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499802 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  499805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499809 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499819 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499821 */     GIR_RootConstrainSelectedInstOperands,
     /*  499822 */     // GIR_Coverage, 23504,
     /*  499822 */     GIR_EraseRootFromParent_Done,
     /*  499823 */   // Label 8337: @499823
     /*  499823 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(499891), // Rule ID 23505 //
     /*  499828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  499839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  499842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  499845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499860 */     // MIs[0] policy
     /*  499860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499870 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  499873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499877 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499887 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499889 */     GIR_RootConstrainSelectedInstOperands,
     /*  499890 */     // GIR_Coverage, 23505,
     /*  499890 */     GIR_EraseRootFromParent_Done,
     /*  499891 */   // Label 8338: @499891
     /*  499891 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(499959), // Rule ID 23508 //
     /*  499896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  499907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  499910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  499913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499928 */     // MIs[0] policy
     /*  499928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499938 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  499941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499945 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  499955 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499957 */     GIR_RootConstrainSelectedInstOperands,
     /*  499958 */     // GIR_Coverage, 23508,
     /*  499958 */     GIR_EraseRootFromParent_Done,
     /*  499959 */   // Label 8339: @499959
     /*  499959 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(500027), // Rule ID 23509 //
     /*  499964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  499975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  499978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  499981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499996 */     // MIs[0] policy
     /*  499996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500006 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  500009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500013 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500023 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500025 */     GIR_RootConstrainSelectedInstOperands,
     /*  500026 */     // GIR_Coverage, 23509,
     /*  500026 */     GIR_EraseRootFromParent_Done,
     /*  500027 */   // Label 8340: @500027
     /*  500027 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(500095), // Rule ID 23512 //
     /*  500032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  500043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  500046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  500049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500064 */     // MIs[0] policy
     /*  500064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500074 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  500077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500081 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500091 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500093 */     GIR_RootConstrainSelectedInstOperands,
     /*  500094 */     // GIR_Coverage, 23512,
     /*  500094 */     GIR_EraseRootFromParent_Done,
     /*  500095 */   // Label 8341: @500095
     /*  500095 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(500163), // Rule ID 23513 //
     /*  500100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  500111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  500114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  500117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500132 */     // MIs[0] policy
     /*  500132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500142 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  500145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500149 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500159 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500161 */     GIR_RootConstrainSelectedInstOperands,
     /*  500162 */     // GIR_Coverage, 23513,
     /*  500162 */     GIR_EraseRootFromParent_Done,
     /*  500163 */   // Label 8342: @500163
     /*  500163 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(500231), // Rule ID 23516 //
     /*  500168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  500179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  500182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  500185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500200 */     // MIs[0] policy
     /*  500200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500210 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  500213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500217 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500227 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500229 */     GIR_RootConstrainSelectedInstOperands,
     /*  500230 */     // GIR_Coverage, 23516,
     /*  500230 */     GIR_EraseRootFromParent_Done,
     /*  500231 */   // Label 8343: @500231
     /*  500231 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(500299), // Rule ID 23517 //
     /*  500236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  500247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  500250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  500253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500268 */     // MIs[0] policy
     /*  500268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500278 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  500281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500285 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500295 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500297 */     GIR_RootConstrainSelectedInstOperands,
     /*  500298 */     // GIR_Coverage, 23517,
     /*  500298 */     GIR_EraseRootFromParent_Done,
     /*  500299 */   // Label 8344: @500299
     /*  500299 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(500367), // Rule ID 23520 //
     /*  500304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  500315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  500318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  500321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500336 */     // MIs[0] policy
     /*  500336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500346 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11299:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500353 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  500363 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500365 */     GIR_RootConstrainSelectedInstOperands,
     /*  500366 */     // GIR_Coverage, 23520,
     /*  500366 */     GIR_EraseRootFromParent_Done,
     /*  500367 */   // Label 8345: @500367
     /*  500367 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(500435), // Rule ID 23521 //
     /*  500372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  500383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  500386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  500389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500404 */     // MIs[0] policy
     /*  500404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500414 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11299:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500421 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  500431 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500433 */     GIR_RootConstrainSelectedInstOperands,
     /*  500434 */     // GIR_Coverage, 23521,
     /*  500434 */     GIR_EraseRootFromParent_Done,
     /*  500435 */   // Label 8346: @500435
     /*  500435 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(500503), // Rule ID 23524 //
     /*  500440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  500451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  500454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  500457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500472 */     // MIs[0] policy
     /*  500472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500482 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500489 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500499 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500501 */     GIR_RootConstrainSelectedInstOperands,
     /*  500502 */     // GIR_Coverage, 23524,
     /*  500502 */     GIR_EraseRootFromParent_Done,
     /*  500503 */   // Label 8347: @500503
     /*  500503 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(500571), // Rule ID 23525 //
     /*  500508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  500519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  500522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  500525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500540 */     // MIs[0] policy
     /*  500540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500550 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500557 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500567 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500569 */     GIR_RootConstrainSelectedInstOperands,
     /*  500570 */     // GIR_Coverage, 23525,
     /*  500570 */     GIR_EraseRootFromParent_Done,
     /*  500571 */   // Label 8348: @500571
     /*  500571 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(500639), // Rule ID 23528 //
     /*  500576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  500593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500608 */     // MIs[0] policy
     /*  500608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500625 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500635 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500637 */     GIR_RootConstrainSelectedInstOperands,
     /*  500638 */     // GIR_Coverage, 23528,
     /*  500638 */     GIR_EraseRootFromParent_Done,
     /*  500639 */   // Label 8349: @500639
     /*  500639 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(500707), // Rule ID 23529 //
     /*  500644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  500661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500676 */     // MIs[0] policy
     /*  500676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500686 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500693 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500703 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500705 */     GIR_RootConstrainSelectedInstOperands,
     /*  500706 */     // GIR_Coverage, 23529,
     /*  500706 */     GIR_EraseRootFromParent_Done,
     /*  500707 */   // Label 8350: @500707
     /*  500707 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(500775), // Rule ID 23532 //
     /*  500712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  500715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  500723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  500726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  500729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500744 */     // MIs[0] policy
     /*  500744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500754 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500761 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  500771 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500773 */     GIR_RootConstrainSelectedInstOperands,
     /*  500774 */     // GIR_Coverage, 23532,
     /*  500774 */     GIR_EraseRootFromParent_Done,
     /*  500775 */   // Label 8351: @500775
     /*  500775 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(500843), // Rule ID 23533 //
     /*  500780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  500783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  500791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  500794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  500797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500812 */     // MIs[0] policy
     /*  500812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500822 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500829 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  500839 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500841 */     GIR_RootConstrainSelectedInstOperands,
     /*  500842 */     // GIR_Coverage, 23533,
     /*  500842 */     GIR_EraseRootFromParent_Done,
     /*  500843 */   // Label 8352: @500843
     /*  500843 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(500911), // Rule ID 23536 //
     /*  500848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  500859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  500862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  500865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  500872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500880 */     // MIs[0] policy
     /*  500880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500890 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  500893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500897 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  500907 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500909 */     GIR_RootConstrainSelectedInstOperands,
     /*  500910 */     // GIR_Coverage, 23536,
     /*  500910 */     GIR_EraseRootFromParent_Done,
     /*  500911 */   // Label 8353: @500911
     /*  500911 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(500979), // Rule ID 23537 //
     /*  500916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  500927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  500930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  500933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  500940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500948 */     // MIs[0] policy
     /*  500948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500958 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  500961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500965 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  500975 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500977 */     GIR_RootConstrainSelectedInstOperands,
     /*  500978 */     // GIR_Coverage, 23537,
     /*  500978 */     GIR_EraseRootFromParent_Done,
     /*  500979 */   // Label 8354: @500979
     /*  500979 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(501047), // Rule ID 23540 //
     /*  500984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  500995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  500998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  501001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  501008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501016 */     // MIs[0] policy
     /*  501016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501026 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  501029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501033 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501043 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501045 */     GIR_RootConstrainSelectedInstOperands,
     /*  501046 */     // GIR_Coverage, 23540,
     /*  501046 */     GIR_EraseRootFromParent_Done,
     /*  501047 */   // Label 8355: @501047
     /*  501047 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(501115), // Rule ID 23541 //
     /*  501052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  501063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  501066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  501069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  501076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501084 */     // MIs[0] policy
     /*  501084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501094 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  501097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501101 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501111 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501113 */     GIR_RootConstrainSelectedInstOperands,
     /*  501114 */     // GIR_Coverage, 23541,
     /*  501114 */     GIR_EraseRootFromParent_Done,
     /*  501115 */   // Label 8356: @501115
     /*  501115 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(501183), // Rule ID 23544 //
     /*  501120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  501131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  501134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  501137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  501144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501152 */     // MIs[0] policy
     /*  501152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501162 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  501165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501169 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501179 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501181 */     GIR_RootConstrainSelectedInstOperands,
     /*  501182 */     // GIR_Coverage, 23544,
     /*  501182 */     GIR_EraseRootFromParent_Done,
     /*  501183 */   // Label 8357: @501183
     /*  501183 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(501251), // Rule ID 23545 //
     /*  501188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  501199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  501202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  501205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  501212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501220 */     // MIs[0] policy
     /*  501220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501230 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  501233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501237 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501247 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501249 */     GIR_RootConstrainSelectedInstOperands,
     /*  501250 */     // GIR_Coverage, 23545,
     /*  501250 */     GIR_EraseRootFromParent_Done,
     /*  501251 */   // Label 8358: @501251
     /*  501251 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(501319), // Rule ID 23548 //
     /*  501256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  501267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  501270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  501273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  501280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501288 */     // MIs[0] policy
     /*  501288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  501301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501305 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  501315 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501317 */     GIR_RootConstrainSelectedInstOperands,
     /*  501318 */     // GIR_Coverage, 23548,
     /*  501318 */     GIR_EraseRootFromParent_Done,
     /*  501319 */   // Label 8359: @501319
     /*  501319 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(501387), // Rule ID 23549 //
     /*  501324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  501335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  501338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  501341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  501348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501356 */     // MIs[0] policy
     /*  501356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501366 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  501369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501373 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  501383 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501385 */     GIR_RootConstrainSelectedInstOperands,
     /*  501386 */     // GIR_Coverage, 23549,
     /*  501386 */     GIR_EraseRootFromParent_Done,
     /*  501387 */   // Label 8360: @501387
     /*  501387 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(501455), // Rule ID 23552 //
     /*  501392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  501403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  501406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  501409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  501416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501424 */     // MIs[0] policy
     /*  501424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501434 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  501437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501441 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  501451 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501453 */     GIR_RootConstrainSelectedInstOperands,
     /*  501454 */     // GIR_Coverage, 23552,
     /*  501454 */     GIR_EraseRootFromParent_Done,
     /*  501455 */   // Label 8361: @501455
     /*  501455 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(501523), // Rule ID 23553 //
     /*  501460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  501471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  501474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  501477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  501484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501492 */     // MIs[0] policy
     /*  501492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501502 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  501505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501509 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  501519 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501521 */     GIR_RootConstrainSelectedInstOperands,
     /*  501522 */     // GIR_Coverage, 23553,
     /*  501522 */     GIR_EraseRootFromParent_Done,
     /*  501523 */   // Label 8362: @501523
     /*  501523 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(501591), // Rule ID 23556 //
     /*  501528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  501539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  501542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  501545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  501552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501560 */     // MIs[0] policy
     /*  501560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501570 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  501573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501577 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  501587 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501589 */     GIR_RootConstrainSelectedInstOperands,
     /*  501590 */     // GIR_Coverage, 23556,
     /*  501590 */     GIR_EraseRootFromParent_Done,
     /*  501591 */   // Label 8363: @501591
     /*  501591 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(501659), // Rule ID 23557 //
     /*  501596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  501607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  501610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  501613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  501620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501628 */     // MIs[0] policy
     /*  501628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501638 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  501641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501645 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  501655 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501657 */     GIR_RootConstrainSelectedInstOperands,
     /*  501658 */     // GIR_Coverage, 23557,
     /*  501658 */     GIR_EraseRootFromParent_Done,
     /*  501659 */   // Label 8364: @501659
     /*  501659 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(501727), // Rule ID 23560 //
     /*  501664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  501681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  501688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501696 */     // MIs[0] policy
     /*  501696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  501709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501713 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501723 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501725 */     GIR_RootConstrainSelectedInstOperands,
     /*  501726 */     // GIR_Coverage, 23560,
     /*  501726 */     GIR_EraseRootFromParent_Done,
     /*  501727 */   // Label 8365: @501727
     /*  501727 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(501795), // Rule ID 23561 //
     /*  501732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  501749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  501756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501764 */     // MIs[0] policy
     /*  501764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501774 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  501777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501781 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501791 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501793 */     GIR_RootConstrainSelectedInstOperands,
     /*  501794 */     // GIR_Coverage, 23561,
     /*  501794 */     GIR_EraseRootFromParent_Done,
     /*  501795 */   // Label 8366: @501795
     /*  501795 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(501863), // Rule ID 23564 //
     /*  501800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  501817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  501824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501832 */     // MIs[0] policy
     /*  501832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501842 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  501845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501849 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501859 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501861 */     GIR_RootConstrainSelectedInstOperands,
     /*  501862 */     // GIR_Coverage, 23564,
     /*  501862 */     GIR_EraseRootFromParent_Done,
     /*  501863 */   // Label 8367: @501863
     /*  501863 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(501931), // Rule ID 23565 //
     /*  501868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  501885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  501892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501900 */     // MIs[0] policy
     /*  501900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501910 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  501913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501917 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501927 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501929 */     GIR_RootConstrainSelectedInstOperands,
     /*  501930 */     // GIR_Coverage, 23565,
     /*  501930 */     GIR_EraseRootFromParent_Done,
     /*  501931 */   // Label 8368: @501931
     /*  501931 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(501999), // Rule ID 23568 //
     /*  501936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  501953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  501960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501968 */     // MIs[0] policy
     /*  501968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501978 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  501981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501985 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501995 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501997 */     GIR_RootConstrainSelectedInstOperands,
     /*  501998 */     // GIR_Coverage, 23568,
     /*  501998 */     GIR_EraseRootFromParent_Done,
     /*  501999 */   // Label 8369: @501999
     /*  501999 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(502067), // Rule ID 23569 //
     /*  502004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  502007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  502021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  502028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502036 */     // MIs[0] policy
     /*  502036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  502049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502053 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502063 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502065 */     GIR_RootConstrainSelectedInstOperands,
     /*  502066 */     // GIR_Coverage, 23569,
     /*  502066 */     GIR_EraseRootFromParent_Done,
     /*  502067 */   // Label 8370: @502067
     /*  502067 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(502135), // Rule ID 23572 //
     /*  502072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  502075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  502083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  502086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  502089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  502096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502104 */     // MIs[0] policy
     /*  502104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  502117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502121 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  502131 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502133 */     GIR_RootConstrainSelectedInstOperands,
     /*  502134 */     // GIR_Coverage, 23572,
     /*  502134 */     GIR_EraseRootFromParent_Done,
     /*  502135 */   // Label 8371: @502135
     /*  502135 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(502203), // Rule ID 23573 //
     /*  502140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  502143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  502151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  502154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  502157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  502164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502172 */     // MIs[0] policy
     /*  502172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  502185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502189 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  502199 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502201 */     GIR_RootConstrainSelectedInstOperands,
     /*  502202 */     // GIR_Coverage, 23573,
     /*  502202 */     GIR_EraseRootFromParent_Done,
     /*  502203 */   // Label 8372: @502203
     /*  502203 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(502271), // Rule ID 23576 //
     /*  502208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  502211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  502219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  502222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  502225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  502232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502240 */     // MIs[0] policy
     /*  502240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502250 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  502253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502257 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  502267 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502269 */     GIR_RootConstrainSelectedInstOperands,
     /*  502270 */     // GIR_Coverage, 23576,
     /*  502270 */     GIR_EraseRootFromParent_Done,
     /*  502271 */   // Label 8373: @502271
     /*  502271 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(502339), // Rule ID 23577 //
     /*  502276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  502279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  502287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  502290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  502293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  502300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502308 */     // MIs[0] policy
     /*  502308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502318 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  502321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502325 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  502335 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502337 */     GIR_RootConstrainSelectedInstOperands,
     /*  502338 */     // GIR_Coverage, 23577,
     /*  502338 */     GIR_EraseRootFromParent_Done,
     /*  502339 */   // Label 8374: @502339
     /*  502339 */   GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(502407), // Rule ID 23580 //
     /*  502344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  502347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  502355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  502358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  502361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  502368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502376 */     // MIs[0] policy
     /*  502376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  502389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502393 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  502403 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502405 */     GIR_RootConstrainSelectedInstOperands,
     /*  502406 */     // GIR_Coverage, 23580,
     /*  502406 */     GIR_EraseRootFromParent_Done,
     /*  502407 */   // Label 8375: @502407
     /*  502407 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(502475), // Rule ID 23581 //
     /*  502412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  502415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  502423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  502426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  502429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  502436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502444 */     // MIs[0] policy
     /*  502444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  502457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502461 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  502471 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502473 */     GIR_RootConstrainSelectedInstOperands,
     /*  502474 */     // GIR_Coverage, 23581,
     /*  502474 */     GIR_EraseRootFromParent_Done,
     /*  502475 */   // Label 8376: @502475
     /*  502475 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(502543), // Rule ID 60594 //
     /*  502480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  502483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  502488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502512 */     // MIs[0] policy
     /*  502512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502522 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  502525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502539 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502541 */     GIR_RootConstrainSelectedInstOperands,
     /*  502542 */     // GIR_Coverage, 60594,
     /*  502542 */     GIR_EraseRootFromParent_Done,
     /*  502543 */   // Label 8377: @502543
     /*  502543 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(502611), // Rule ID 60595 //
     /*  502548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  502551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  502556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502580 */     // MIs[0] policy
     /*  502580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502590 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  502593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502607 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502609 */     GIR_RootConstrainSelectedInstOperands,
     /*  502610 */     // GIR_Coverage, 60595,
     /*  502610 */     GIR_EraseRootFromParent_Done,
     /*  502611 */   // Label 8378: @502611
     /*  502611 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(502679), // Rule ID 60596 //
     /*  502616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502648 */     // MIs[0] policy
     /*  502648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502658 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  502661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502675 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502677 */     GIR_RootConstrainSelectedInstOperands,
     /*  502678 */     // GIR_Coverage, 60596,
     /*  502678 */     GIR_EraseRootFromParent_Done,
     /*  502679 */   // Label 8379: @502679
     /*  502679 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(502747), // Rule ID 60597 //
     /*  502684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502716 */     // MIs[0] policy
     /*  502716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502726 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  502729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502743 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502745 */     GIR_RootConstrainSelectedInstOperands,
     /*  502746 */     // GIR_Coverage, 60597,
     /*  502746 */     GIR_EraseRootFromParent_Done,
     /*  502747 */   // Label 8380: @502747
     /*  502747 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(502815), // Rule ID 62090 //
     /*  502752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  502755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  502760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502784 */     // MIs[0] policy
     /*  502784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502794 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  502797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502811 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502813 */     GIR_RootConstrainSelectedInstOperands,
     /*  502814 */     // GIR_Coverage, 62090,
     /*  502814 */     GIR_EraseRootFromParent_Done,
     /*  502815 */   // Label 8381: @502815
     /*  502815 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(502883), // Rule ID 62091 //
     /*  502820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  502823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  502828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502852 */     // MIs[0] policy
     /*  502852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502862 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  502865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502879 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502881 */     GIR_RootConstrainSelectedInstOperands,
     /*  502882 */     // GIR_Coverage, 62091,
     /*  502882 */     GIR_EraseRootFromParent_Done,
     /*  502883 */   // Label 8382: @502883
     /*  502883 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(502951), // Rule ID 62092 //
     /*  502888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  502891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  502896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502920 */     // MIs[0] policy
     /*  502920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  502933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502947 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502949 */     GIR_RootConstrainSelectedInstOperands,
     /*  502950 */     // GIR_Coverage, 62092,
     /*  502950 */     GIR_EraseRootFromParent_Done,
     /*  502951 */   // Label 8383: @502951
     /*  502951 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(503019), // Rule ID 62093 //
     /*  502956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  502959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  502964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502988 */     // MIs[0] policy
     /*  502988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  503001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503015 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503017 */     GIR_RootConstrainSelectedInstOperands,
     /*  503018 */     // GIR_Coverage, 62093,
     /*  503018 */     GIR_EraseRootFromParent_Done,
     /*  503019 */   // Label 8384: @503019
     /*  503019 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(503087), // Rule ID 62094 //
     /*  503024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  503027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  503032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503056 */     // MIs[0] policy
     /*  503056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503066 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  503069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503083 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503085 */     GIR_RootConstrainSelectedInstOperands,
     /*  503086 */     // GIR_Coverage, 62094,
     /*  503086 */     GIR_EraseRootFromParent_Done,
     /*  503087 */   // Label 8385: @503087
     /*  503087 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(503155), // Rule ID 62095 //
     /*  503092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  503095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  503100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503124 */     // MIs[0] policy
     /*  503124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503134 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  503137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503151 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503153 */     GIR_RootConstrainSelectedInstOperands,
     /*  503154 */     // GIR_Coverage, 62095,
     /*  503154 */     GIR_EraseRootFromParent_Done,
     /*  503155 */   // Label 8386: @503155
     /*  503155 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(503223), // Rule ID 62096 //
     /*  503160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  503163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  503168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  503177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503192 */     // MIs[0] policy
     /*  503192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503202 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  503205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503219 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503221 */     GIR_RootConstrainSelectedInstOperands,
     /*  503222 */     // GIR_Coverage, 62096,
     /*  503222 */     GIR_EraseRootFromParent_Done,
     /*  503223 */   // Label 8387: @503223
     /*  503223 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(503291), // Rule ID 62097 //
     /*  503228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  503231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  503236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  503245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503260 */     // MIs[0] policy
     /*  503260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503270 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  503273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503287 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503289 */     GIR_RootConstrainSelectedInstOperands,
     /*  503290 */     // GIR_Coverage, 62097,
     /*  503290 */     GIR_EraseRootFromParent_Done,
     /*  503291 */   // Label 8388: @503291
     /*  503291 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(503359), // Rule ID 62098 //
     /*  503296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  503307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  503310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503328 */     // MIs[0] policy
     /*  503328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503338 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  503341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503355 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503357 */     GIR_RootConstrainSelectedInstOperands,
     /*  503358 */     // GIR_Coverage, 62098,
     /*  503358 */     GIR_EraseRootFromParent_Done,
     /*  503359 */   // Label 8389: @503359
     /*  503359 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(503427), // Rule ID 62099 //
     /*  503364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  503375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  503378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503396 */     // MIs[0] policy
     /*  503396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503406 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  503409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503423 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503425 */     GIR_RootConstrainSelectedInstOperands,
     /*  503426 */     // GIR_Coverage, 62099,
     /*  503426 */     GIR_EraseRootFromParent_Done,
     /*  503427 */   // Label 8390: @503427
     /*  503427 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(503495), // Rule ID 62100 //
     /*  503432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503464 */     // MIs[0] policy
     /*  503464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  503477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503491 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503493 */     GIR_RootConstrainSelectedInstOperands,
     /*  503494 */     // GIR_Coverage, 62100,
     /*  503494 */     GIR_EraseRootFromParent_Done,
     /*  503495 */   // Label 8391: @503495
     /*  503495 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(503563), // Rule ID 62101 //
     /*  503500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503532 */     // MIs[0] policy
     /*  503532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503542 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  503545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503559 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503561 */     GIR_RootConstrainSelectedInstOperands,
     /*  503562 */     // GIR_Coverage, 62101,
     /*  503562 */     GIR_EraseRootFromParent_Done,
     /*  503563 */   // Label 8392: @503563
     /*  503563 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(503631), // Rule ID 62102 //
     /*  503568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503600 */     // MIs[0] policy
     /*  503600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  503613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503627 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503629 */     GIR_RootConstrainSelectedInstOperands,
     /*  503630 */     // GIR_Coverage, 62102,
     /*  503630 */     GIR_EraseRootFromParent_Done,
     /*  503631 */   // Label 8393: @503631
     /*  503631 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(503699), // Rule ID 62103 //
     /*  503636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503668 */     // MIs[0] policy
     /*  503668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503678 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  503681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503695 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503697 */     GIR_RootConstrainSelectedInstOperands,
     /*  503698 */     // GIR_Coverage, 62103,
     /*  503698 */     GIR_EraseRootFromParent_Done,
     /*  503699 */   // Label 8394: @503699
     /*  503699 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(503767), // Rule ID 62104 //
     /*  503704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503736 */     // MIs[0] policy
     /*  503736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  503749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503763 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503765 */     GIR_RootConstrainSelectedInstOperands,
     /*  503766 */     // GIR_Coverage, 62104,
     /*  503766 */     GIR_EraseRootFromParent_Done,
     /*  503767 */   // Label 8395: @503767
     /*  503767 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(503835), // Rule ID 62105 //
     /*  503772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503804 */     // MIs[0] policy
     /*  503804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503814 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  503817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503831 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503833 */     GIR_RootConstrainSelectedInstOperands,
     /*  503834 */     // GIR_Coverage, 62105,
     /*  503834 */     GIR_EraseRootFromParent_Done,
     /*  503835 */   // Label 8396: @503835
     /*  503835 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(503903), // Rule ID 62106 //
     /*  503840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  503857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503872 */     // MIs[0] policy
     /*  503872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503882 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  503885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503899 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503901 */     GIR_RootConstrainSelectedInstOperands,
     /*  503902 */     // GIR_Coverage, 62106,
     /*  503902 */     GIR_EraseRootFromParent_Done,
     /*  503903 */   // Label 8397: @503903
     /*  503903 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(503971), // Rule ID 62107 //
     /*  503908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  503925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503940 */     // MIs[0] policy
     /*  503940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503950 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  503953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503967 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503969 */     GIR_RootConstrainSelectedInstOperands,
     /*  503970 */     // GIR_Coverage, 62107,
     /*  503970 */     GIR_EraseRootFromParent_Done,
     /*  503971 */   // Label 8398: @503971
     /*  503971 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(504039), // Rule ID 62108 //
     /*  503976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  503984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504008 */     // MIs[0] policy
     /*  504008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504018 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  504021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504035 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504037 */     GIR_RootConstrainSelectedInstOperands,
     /*  504038 */     // GIR_Coverage, 62108,
     /*  504038 */     GIR_EraseRootFromParent_Done,
     /*  504039 */   // Label 8399: @504039
     /*  504039 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(504107), // Rule ID 62109 //
     /*  504044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504076 */     // MIs[0] policy
     /*  504076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504086 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  504089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504103 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504105 */     GIR_RootConstrainSelectedInstOperands,
     /*  504106 */     // GIR_Coverage, 62109,
     /*  504106 */     GIR_EraseRootFromParent_Done,
     /*  504107 */   // Label 8400: @504107
     /*  504107 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(504175), // Rule ID 62110 //
     /*  504112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504144 */     // MIs[0] policy
     /*  504144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504154 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  504157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504171 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504173 */     GIR_RootConstrainSelectedInstOperands,
     /*  504174 */     // GIR_Coverage, 62110,
     /*  504174 */     GIR_EraseRootFromParent_Done,
     /*  504175 */   // Label 8401: @504175
     /*  504175 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(504243), // Rule ID 62111 //
     /*  504180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504212 */     // MIs[0] policy
     /*  504212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504222 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  504225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504239 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504241 */     GIR_RootConstrainSelectedInstOperands,
     /*  504242 */     // GIR_Coverage, 62111,
     /*  504242 */     GIR_EraseRootFromParent_Done,
     /*  504243 */   // Label 8402: @504243
     /*  504243 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(504311), // Rule ID 62112 //
     /*  504248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504280 */     // MIs[0] policy
     /*  504280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  504293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504307 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504309 */     GIR_RootConstrainSelectedInstOperands,
     /*  504310 */     // GIR_Coverage, 62112,
     /*  504310 */     GIR_EraseRootFromParent_Done,
     /*  504311 */   // Label 8403: @504311
     /*  504311 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(504379), // Rule ID 62113 //
     /*  504316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504348 */     // MIs[0] policy
     /*  504348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  504361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504375 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504377 */     GIR_RootConstrainSelectedInstOperands,
     /*  504378 */     // GIR_Coverage, 62113,
     /*  504378 */     GIR_EraseRootFromParent_Done,
     /*  504379 */   // Label 8404: @504379
     /*  504379 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(504447), // Rule ID 62114 //
     /*  504384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504416 */     // MIs[0] policy
     /*  504416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  504429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504443 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504445 */     GIR_RootConstrainSelectedInstOperands,
     /*  504446 */     // GIR_Coverage, 62114,
     /*  504446 */     GIR_EraseRootFromParent_Done,
     /*  504447 */   // Label 8405: @504447
     /*  504447 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(504515), // Rule ID 62115 //
     /*  504452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504484 */     // MIs[0] policy
     /*  504484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  504497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504511 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504513 */     GIR_RootConstrainSelectedInstOperands,
     /*  504514 */     // GIR_Coverage, 62115,
     /*  504514 */     GIR_EraseRootFromParent_Done,
     /*  504515 */   // Label 8406: @504515
     /*  504515 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(504583), // Rule ID 62116 //
     /*  504520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504552 */     // MIs[0] policy
     /*  504552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  504565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504579 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504581 */     GIR_RootConstrainSelectedInstOperands,
     /*  504582 */     // GIR_Coverage, 62116,
     /*  504582 */     GIR_EraseRootFromParent_Done,
     /*  504583 */   // Label 8407: @504583
     /*  504583 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(504651), // Rule ID 62117 //
     /*  504588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504620 */     // MIs[0] policy
     /*  504620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  504633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504647 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504649 */     GIR_RootConstrainSelectedInstOperands,
     /*  504650 */     // GIR_Coverage, 62117,
     /*  504650 */     GIR_EraseRootFromParent_Done,
     /*  504651 */   // Label 8408: @504651
     /*  504651 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(504719), // Rule ID 62118 //
     /*  504656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504688 */     // MIs[0] policy
     /*  504688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504698 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  504701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504715 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504717 */     GIR_RootConstrainSelectedInstOperands,
     /*  504718 */     // GIR_Coverage, 62118,
     /*  504718 */     GIR_EraseRootFromParent_Done,
     /*  504719 */   // Label 8409: @504719
     /*  504719 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(504787), // Rule ID 62119 //
     /*  504724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504756 */     // MIs[0] policy
     /*  504756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  504769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504783 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504785 */     GIR_RootConstrainSelectedInstOperands,
     /*  504786 */     // GIR_Coverage, 62119,
     /*  504786 */     GIR_EraseRootFromParent_Done,
     /*  504787 */   // Label 8410: @504787
     /*  504787 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(504855), // Rule ID 62120 //
     /*  504792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504824 */     // MIs[0] policy
     /*  504824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504834 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  504837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504851 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504853 */     GIR_RootConstrainSelectedInstOperands,
     /*  504854 */     // GIR_Coverage, 62120,
     /*  504854 */     GIR_EraseRootFromParent_Done,
     /*  504855 */   // Label 8411: @504855
     /*  504855 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(504923), // Rule ID 62121 //
     /*  504860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504892 */     // MIs[0] policy
     /*  504892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  504905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504919 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504921 */     GIR_RootConstrainSelectedInstOperands,
     /*  504922 */     // GIR_Coverage, 62121,
     /*  504922 */     GIR_EraseRootFromParent_Done,
     /*  504923 */   // Label 8412: @504923
     /*  504923 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(504991), // Rule ID 62122 //
     /*  504928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504960 */     // MIs[0] policy
     /*  504960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504970 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  504973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504987 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504989 */     GIR_RootConstrainSelectedInstOperands,
     /*  504990 */     // GIR_Coverage, 62122,
     /*  504990 */     GIR_EraseRootFromParent_Done,
     /*  504991 */   // Label 8413: @504991
     /*  504991 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(505059), // Rule ID 62123 //
     /*  504996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505028 */     // MIs[0] policy
     /*  505028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505038 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  505041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505055 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505057 */     GIR_RootConstrainSelectedInstOperands,
     /*  505058 */     // GIR_Coverage, 62123,
     /*  505058 */     GIR_EraseRootFromParent_Done,
     /*  505059 */   // Label 8414: @505059
     /*  505059 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(505127), // Rule ID 62124 //
     /*  505064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505096 */     // MIs[0] policy
     /*  505096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505106 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  505109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505123 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505125 */     GIR_RootConstrainSelectedInstOperands,
     /*  505126 */     // GIR_Coverage, 62124,
     /*  505126 */     GIR_EraseRootFromParent_Done,
     /*  505127 */   // Label 8415: @505127
     /*  505127 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(505195), // Rule ID 62125 //
     /*  505132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505164 */     // MIs[0] policy
     /*  505164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505174 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  505177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505191 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505193 */     GIR_RootConstrainSelectedInstOperands,
     /*  505194 */     // GIR_Coverage, 62125,
     /*  505194 */     GIR_EraseRootFromParent_Done,
     /*  505195 */   // Label 8416: @505195
     /*  505195 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(505263), // Rule ID 62126 //
     /*  505200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505232 */     // MIs[0] policy
     /*  505232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505242 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  505245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505259 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505261 */     GIR_RootConstrainSelectedInstOperands,
     /*  505262 */     // GIR_Coverage, 62126,
     /*  505262 */     GIR_EraseRootFromParent_Done,
     /*  505263 */   // Label 8417: @505263
     /*  505263 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(505331), // Rule ID 62127 //
     /*  505268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505300 */     // MIs[0] policy
     /*  505300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505310 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  505313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505327 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505329 */     GIR_RootConstrainSelectedInstOperands,
     /*  505330 */     // GIR_Coverage, 62127,
     /*  505330 */     GIR_EraseRootFromParent_Done,
     /*  505331 */   // Label 8418: @505331
     /*  505331 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(505399), // Rule ID 62128 //
     /*  505336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505368 */     // MIs[0] policy
     /*  505368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505378 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  505381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505395 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505397 */     GIR_RootConstrainSelectedInstOperands,
     /*  505398 */     // GIR_Coverage, 62128,
     /*  505398 */     GIR_EraseRootFromParent_Done,
     /*  505399 */   // Label 8419: @505399
     /*  505399 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(505467), // Rule ID 62129 //
     /*  505404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505436 */     // MIs[0] policy
     /*  505436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  505449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505463 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505465 */     GIR_RootConstrainSelectedInstOperands,
     /*  505466 */     // GIR_Coverage, 62129,
     /*  505466 */     GIR_EraseRootFromParent_Done,
     /*  505467 */   // Label 8420: @505467
     /*  505467 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(505535), // Rule ID 62130 //
     /*  505472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505504 */     // MIs[0] policy
     /*  505504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505514 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  505517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505531 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505533 */     GIR_RootConstrainSelectedInstOperands,
     /*  505534 */     // GIR_Coverage, 62130,
     /*  505534 */     GIR_EraseRootFromParent_Done,
     /*  505535 */   // Label 8421: @505535
     /*  505535 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(505603), // Rule ID 62131 //
     /*  505540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505572 */     // MIs[0] policy
     /*  505572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505582 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  505585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505599 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505601 */     GIR_RootConstrainSelectedInstOperands,
     /*  505602 */     // GIR_Coverage, 62131,
     /*  505602 */     GIR_EraseRootFromParent_Done,
     /*  505603 */   // Label 8422: @505603
     /*  505603 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(505671), // Rule ID 62132 //
     /*  505608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505640 */     // MIs[0] policy
     /*  505640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505650 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  505653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505667 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505669 */     GIR_RootConstrainSelectedInstOperands,
     /*  505670 */     // GIR_Coverage, 62132,
     /*  505670 */     GIR_EraseRootFromParent_Done,
     /*  505671 */   // Label 8423: @505671
     /*  505671 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(505739), // Rule ID 62133 //
     /*  505676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505708 */     // MIs[0] policy
     /*  505708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  505721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505735 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505737 */     GIR_RootConstrainSelectedInstOperands,
     /*  505738 */     // GIR_Coverage, 62133,
     /*  505738 */     GIR_EraseRootFromParent_Done,
     /*  505739 */   // Label 8424: @505739
     /*  505739 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(505807), // Rule ID 62134 //
     /*  505744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  505752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505776 */     // MIs[0] policy
     /*  505776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505786 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  505789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505803 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505805 */     GIR_RootConstrainSelectedInstOperands,
     /*  505806 */     // GIR_Coverage, 62134,
     /*  505806 */     GIR_EraseRootFromParent_Done,
     /*  505807 */   // Label 8425: @505807
     /*  505807 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(505875), // Rule ID 62135 //
     /*  505812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  505820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505844 */     // MIs[0] policy
     /*  505844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505854 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  505857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505871 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505873 */     GIR_RootConstrainSelectedInstOperands,
     /*  505874 */     // GIR_Coverage, 62135,
     /*  505874 */     GIR_EraseRootFromParent_Done,
     /*  505875 */   // Label 8426: @505875
     /*  505875 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(505943), // Rule ID 62136 //
     /*  505880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  505888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505912 */     // MIs[0] policy
     /*  505912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505922 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  505925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505939 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505941 */     GIR_RootConstrainSelectedInstOperands,
     /*  505942 */     // GIR_Coverage, 62136,
     /*  505942 */     GIR_EraseRootFromParent_Done,
     /*  505943 */   // Label 8427: @505943
     /*  505943 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(506011), // Rule ID 62137 //
     /*  505948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  505956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505980 */     // MIs[0] policy
     /*  505980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  505993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506007 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506009 */     GIR_RootConstrainSelectedInstOperands,
     /*  506010 */     // GIR_Coverage, 62137,
     /*  506010 */     GIR_EraseRootFromParent_Done,
     /*  506011 */   // Label 8428: @506011
     /*  506011 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(506079), // Rule ID 62138 //
     /*  506016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  506024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506048 */     // MIs[0] policy
     /*  506048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  506061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506075 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506077 */     GIR_RootConstrainSelectedInstOperands,
     /*  506078 */     // GIR_Coverage, 62138,
     /*  506078 */     GIR_EraseRootFromParent_Done,
     /*  506079 */   // Label 8429: @506079
     /*  506079 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(506147), // Rule ID 62139 //
     /*  506084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  506092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506116 */     // MIs[0] policy
     /*  506116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506126 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  506129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506143 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506145 */     GIR_RootConstrainSelectedInstOperands,
     /*  506146 */     // GIR_Coverage, 62139,
     /*  506146 */     GIR_EraseRootFromParent_Done,
     /*  506147 */   // Label 8430: @506147
     /*  506147 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(506215), // Rule ID 62140 //
     /*  506152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  506160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506184 */     // MIs[0] policy
     /*  506184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506194 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  506197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506211 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506213 */     GIR_RootConstrainSelectedInstOperands,
     /*  506214 */     // GIR_Coverage, 62140,
     /*  506214 */     GIR_EraseRootFromParent_Done,
     /*  506215 */   // Label 8431: @506215
     /*  506215 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(506283), // Rule ID 62141 //
     /*  506220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  506228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506252 */     // MIs[0] policy
     /*  506252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506262 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  506265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506279 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506281 */     GIR_RootConstrainSelectedInstOperands,
     /*  506282 */     // GIR_Coverage, 62141,
     /*  506282 */     GIR_EraseRootFromParent_Done,
     /*  506283 */   // Label 8432: @506283
     /*  506283 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(506351), // Rule ID 62142 //
     /*  506288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  506296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  506305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506320 */     // MIs[0] policy
     /*  506320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506330 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  506333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506347 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506349 */     GIR_RootConstrainSelectedInstOperands,
     /*  506350 */     // GIR_Coverage, 62142,
     /*  506350 */     GIR_EraseRootFromParent_Done,
     /*  506351 */   // Label 8433: @506351
     /*  506351 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(506419), // Rule ID 62143 //
     /*  506356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  506364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  506373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506388 */     // MIs[0] policy
     /*  506388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506398 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  506401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506415 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506417 */     GIR_RootConstrainSelectedInstOperands,
     /*  506418 */     // GIR_Coverage, 62143,
     /*  506418 */     GIR_EraseRootFromParent_Done,
     /*  506419 */   // Label 8434: @506419
     /*  506419 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(506487), // Rule ID 62144 //
     /*  506424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  506435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  506438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506456 */     // MIs[0] policy
     /*  506456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  506469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506483 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506485 */     GIR_RootConstrainSelectedInstOperands,
     /*  506486 */     // GIR_Coverage, 62144,
     /*  506486 */     GIR_EraseRootFromParent_Done,
     /*  506487 */   // Label 8435: @506487
     /*  506487 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(506555), // Rule ID 62145 //
     /*  506492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  506503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  506506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506524 */     // MIs[0] policy
     /*  506524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506534 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  506537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506551 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506553 */     GIR_RootConstrainSelectedInstOperands,
     /*  506554 */     // GIR_Coverage, 62145,
     /*  506554 */     GIR_EraseRootFromParent_Done,
     /*  506555 */   // Label 8436: @506555
     /*  506555 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(506623), // Rule ID 62146 //
     /*  506560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  506571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  506574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506592 */     // MIs[0] policy
     /*  506592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  506605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506619 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506621 */     GIR_RootConstrainSelectedInstOperands,
     /*  506622 */     // GIR_Coverage, 62146,
     /*  506622 */     GIR_EraseRootFromParent_Done,
     /*  506623 */   // Label 8437: @506623
     /*  506623 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(506691), // Rule ID 62147 //
     /*  506628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  506639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  506642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506660 */     // MIs[0] policy
     /*  506660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  506673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506687 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506689 */     GIR_RootConstrainSelectedInstOperands,
     /*  506690 */     // GIR_Coverage, 62147,
     /*  506690 */     GIR_EraseRootFromParent_Done,
     /*  506691 */   // Label 8438: @506691
     /*  506691 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(506759), // Rule ID 62148 //
     /*  506696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  506707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  506710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506728 */     // MIs[0] policy
     /*  506728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506738 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  506741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506755 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506757 */     GIR_RootConstrainSelectedInstOperands,
     /*  506758 */     // GIR_Coverage, 62148,
     /*  506758 */     GIR_EraseRootFromParent_Done,
     /*  506759 */   // Label 8439: @506759
     /*  506759 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(506827), // Rule ID 62149 //
     /*  506764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  506775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  506778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506796 */     // MIs[0] policy
     /*  506796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506806 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  506809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506823 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506825 */     GIR_RootConstrainSelectedInstOperands,
     /*  506826 */     // GIR_Coverage, 62149,
     /*  506826 */     GIR_EraseRootFromParent_Done,
     /*  506827 */   // Label 8440: @506827
     /*  506827 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(506895), // Rule ID 62150 //
     /*  506832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506864 */     // MIs[0] policy
     /*  506864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  506877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506891 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506893 */     GIR_RootConstrainSelectedInstOperands,
     /*  506894 */     // GIR_Coverage, 62150,
     /*  506894 */     GIR_EraseRootFromParent_Done,
     /*  506895 */   // Label 8441: @506895
     /*  506895 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(506963), // Rule ID 62151 //
     /*  506900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506932 */     // MIs[0] policy
     /*  506932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506942 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  506945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506959 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506961 */     GIR_RootConstrainSelectedInstOperands,
     /*  506962 */     // GIR_Coverage, 62151,
     /*  506962 */     GIR_EraseRootFromParent_Done,
     /*  506963 */   // Label 8442: @506963
     /*  506963 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(507031), // Rule ID 62152 //
     /*  506968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507000 */     // MIs[0] policy
     /*  507000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507010 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  507013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507027 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507029 */     GIR_RootConstrainSelectedInstOperands,
     /*  507030 */     // GIR_Coverage, 62152,
     /*  507030 */     GIR_EraseRootFromParent_Done,
     /*  507031 */   // Label 8443: @507031
     /*  507031 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(507099), // Rule ID 62153 //
     /*  507036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507068 */     // MIs[0] policy
     /*  507068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507078 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  507081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507095 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507097 */     GIR_RootConstrainSelectedInstOperands,
     /*  507098 */     // GIR_Coverage, 62153,
     /*  507098 */     GIR_EraseRootFromParent_Done,
     /*  507099 */   // Label 8444: @507099
     /*  507099 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(507167), // Rule ID 62154 //
     /*  507104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507136 */     // MIs[0] policy
     /*  507136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  507149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507163 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507165 */     GIR_RootConstrainSelectedInstOperands,
     /*  507166 */     // GIR_Coverage, 62154,
     /*  507166 */     GIR_EraseRootFromParent_Done,
     /*  507167 */   // Label 8445: @507167
     /*  507167 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(507235), // Rule ID 62155 //
     /*  507172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507204 */     // MIs[0] policy
     /*  507204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  507217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507231 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507233 */     GIR_RootConstrainSelectedInstOperands,
     /*  507234 */     // GIR_Coverage, 62155,
     /*  507234 */     GIR_EraseRootFromParent_Done,
     /*  507235 */   // Label 8446: @507235
     /*  507235 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(507303), // Rule ID 62156 //
     /*  507240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507272 */     // MIs[0] policy
     /*  507272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507282 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  507285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507299 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507301 */     GIR_RootConstrainSelectedInstOperands,
     /*  507302 */     // GIR_Coverage, 62156,
     /*  507302 */     GIR_EraseRootFromParent_Done,
     /*  507303 */   // Label 8447: @507303
     /*  507303 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(507371), // Rule ID 62157 //
     /*  507308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507340 */     // MIs[0] policy
     /*  507340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507350 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  507353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507367 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507369 */     GIR_RootConstrainSelectedInstOperands,
     /*  507370 */     // GIR_Coverage, 62157,
     /*  507370 */     GIR_EraseRootFromParent_Done,
     /*  507371 */   // Label 8448: @507371
     /*  507371 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(507439), // Rule ID 62158 //
     /*  507376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507408 */     // MIs[0] policy
     /*  507408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507418 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  507421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507435 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507437 */     GIR_RootConstrainSelectedInstOperands,
     /*  507438 */     // GIR_Coverage, 62158,
     /*  507438 */     GIR_EraseRootFromParent_Done,
     /*  507439 */   // Label 8449: @507439
     /*  507439 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(507507), // Rule ID 62159 //
     /*  507444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507476 */     // MIs[0] policy
     /*  507476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507486 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  507489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507503 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507505 */     GIR_RootConstrainSelectedInstOperands,
     /*  507506 */     // GIR_Coverage, 62159,
     /*  507506 */     GIR_EraseRootFromParent_Done,
     /*  507507 */   // Label 8450: @507507
     /*  507507 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(507575), // Rule ID 62160 //
     /*  507512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507544 */     // MIs[0] policy
     /*  507544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507554 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  507557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507571 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507573 */     GIR_RootConstrainSelectedInstOperands,
     /*  507574 */     // GIR_Coverage, 62160,
     /*  507574 */     GIR_EraseRootFromParent_Done,
     /*  507575 */   // Label 8451: @507575
     /*  507575 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(507643), // Rule ID 62161 //
     /*  507580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507612 */     // MIs[0] policy
     /*  507612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507622 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  507625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507639 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507641 */     GIR_RootConstrainSelectedInstOperands,
     /*  507642 */     // GIR_Coverage, 62161,
     /*  507642 */     GIR_EraseRootFromParent_Done,
     /*  507643 */   // Label 8452: @507643
     /*  507643 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(507711), // Rule ID 62162 //
     /*  507648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507680 */     // MIs[0] policy
     /*  507680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507690 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  507693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507707 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507709 */     GIR_RootConstrainSelectedInstOperands,
     /*  507710 */     // GIR_Coverage, 62162,
     /*  507710 */     GIR_EraseRootFromParent_Done,
     /*  507711 */   // Label 8453: @507711
     /*  507711 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(507779), // Rule ID 62163 //
     /*  507716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507748 */     // MIs[0] policy
     /*  507748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507758 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  507761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507775 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507777 */     GIR_RootConstrainSelectedInstOperands,
     /*  507778 */     // GIR_Coverage, 62163,
     /*  507778 */     GIR_EraseRootFromParent_Done,
     /*  507779 */   // Label 8454: @507779
     /*  507779 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(507847), // Rule ID 62164 //
     /*  507784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507816 */     // MIs[0] policy
     /*  507816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507826 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  507829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507843 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507845 */     GIR_RootConstrainSelectedInstOperands,
     /*  507846 */     // GIR_Coverage, 62164,
     /*  507846 */     GIR_EraseRootFromParent_Done,
     /*  507847 */   // Label 8455: @507847
     /*  507847 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(507915), // Rule ID 62165 //
     /*  507852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507884 */     // MIs[0] policy
     /*  507884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507894 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  507897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507911 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507913 */     GIR_RootConstrainSelectedInstOperands,
     /*  507914 */     // GIR_Coverage, 62165,
     /*  507914 */     GIR_EraseRootFromParent_Done,
     /*  507915 */   // Label 8456: @507915
     /*  507915 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(507983), // Rule ID 62166 //
     /*  507920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507952 */     // MIs[0] policy
     /*  507952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507962 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  507965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507979 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507981 */     GIR_RootConstrainSelectedInstOperands,
     /*  507982 */     // GIR_Coverage, 62166,
     /*  507982 */     GIR_EraseRootFromParent_Done,
     /*  507983 */   // Label 8457: @507983
     /*  507983 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(508051), // Rule ID 62167 //
     /*  507988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508020 */     // MIs[0] policy
     /*  508020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  508033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508047 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508049 */     GIR_RootConstrainSelectedInstOperands,
     /*  508050 */     // GIR_Coverage, 62167,
     /*  508050 */     GIR_EraseRootFromParent_Done,
     /*  508051 */   // Label 8458: @508051
     /*  508051 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(508119), // Rule ID 62168 //
     /*  508056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  508064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508088 */     // MIs[0] policy
     /*  508088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508098 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  508101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508115 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508117 */     GIR_RootConstrainSelectedInstOperands,
     /*  508118 */     // GIR_Coverage, 62168,
     /*  508118 */     GIR_EraseRootFromParent_Done,
     /*  508119 */   // Label 8459: @508119
     /*  508119 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(508187), // Rule ID 62169 //
     /*  508124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  508132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508156 */     // MIs[0] policy
     /*  508156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  508169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508183 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508185 */     GIR_RootConstrainSelectedInstOperands,
     /*  508186 */     // GIR_Coverage, 62169,
     /*  508186 */     GIR_EraseRootFromParent_Done,
     /*  508187 */   // Label 8460: @508187
     /*  508187 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(508255), // Rule ID 62170 //
     /*  508192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  508200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  508209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508224 */     // MIs[0] policy
     /*  508224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508234 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  508237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508251 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508253 */     GIR_RootConstrainSelectedInstOperands,
     /*  508254 */     // GIR_Coverage, 62170,
     /*  508254 */     GIR_EraseRootFromParent_Done,
     /*  508255 */   // Label 8461: @508255
     /*  508255 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(508323), // Rule ID 62171 //
     /*  508260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  508268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  508277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508292 */     // MIs[0] policy
     /*  508292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508302 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  508305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508319 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508321 */     GIR_RootConstrainSelectedInstOperands,
     /*  508322 */     // GIR_Coverage, 62171,
     /*  508322 */     GIR_EraseRootFromParent_Done,
     /*  508323 */   // Label 8462: @508323
     /*  508323 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(508391), // Rule ID 62172 //
     /*  508328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  508339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  508342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508360 */     // MIs[0] policy
     /*  508360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  508373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508387 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508389 */     GIR_RootConstrainSelectedInstOperands,
     /*  508390 */     // GIR_Coverage, 62172,
     /*  508390 */     GIR_EraseRootFromParent_Done,
     /*  508391 */   // Label 8463: @508391
     /*  508391 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(508459), // Rule ID 62173 //
     /*  508396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  508407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  508410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508428 */     // MIs[0] policy
     /*  508428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508438 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  508441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508455 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508457 */     GIR_RootConstrainSelectedInstOperands,
     /*  508458 */     // GIR_Coverage, 62173,
     /*  508458 */     GIR_EraseRootFromParent_Done,
     /*  508459 */   // Label 8464: @508459
     /*  508459 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(508527), // Rule ID 62174 //
     /*  508464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508496 */     // MIs[0] policy
     /*  508496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508506 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  508509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508523 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508525 */     GIR_RootConstrainSelectedInstOperands,
     /*  508526 */     // GIR_Coverage, 62174,
     /*  508526 */     GIR_EraseRootFromParent_Done,
     /*  508527 */   // Label 8465: @508527
     /*  508527 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(508595), // Rule ID 62175 //
     /*  508532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508564 */     // MIs[0] policy
     /*  508564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508574 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  508577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508591 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508593 */     GIR_RootConstrainSelectedInstOperands,
     /*  508594 */     // GIR_Coverage, 62175,
     /*  508594 */     GIR_EraseRootFromParent_Done,
     /*  508595 */   // Label 8466: @508595
     /*  508595 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(508663), // Rule ID 62176 //
     /*  508600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508632 */     // MIs[0] policy
     /*  508632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508642 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  508645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508659 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508661 */     GIR_RootConstrainSelectedInstOperands,
     /*  508662 */     // GIR_Coverage, 62176,
     /*  508662 */     GIR_EraseRootFromParent_Done,
     /*  508663 */   // Label 8467: @508663
     /*  508663 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(508731), // Rule ID 62177 //
     /*  508668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508700 */     // MIs[0] policy
     /*  508700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  508713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508727 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508729 */     GIR_RootConstrainSelectedInstOperands,
     /*  508730 */     // GIR_Coverage, 62177,
     /*  508730 */     GIR_EraseRootFromParent_Done,
     /*  508731 */   // Label 8468: @508731
     /*  508731 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(508799), // Rule ID 62178 //
     /*  508736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  508753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508768 */     // MIs[0] policy
     /*  508768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508778 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  508781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508795 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508797 */     GIR_RootConstrainSelectedInstOperands,
     /*  508798 */     // GIR_Coverage, 62178,
     /*  508798 */     GIR_EraseRootFromParent_Done,
     /*  508799 */   // Label 8469: @508799
     /*  508799 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(508867), // Rule ID 62179 //
     /*  508804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  508821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508836 */     // MIs[0] policy
     /*  508836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  508849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508863 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508865 */     GIR_RootConstrainSelectedInstOperands,
     /*  508866 */     // GIR_Coverage, 62179,
     /*  508866 */     GIR_EraseRootFromParent_Done,
     /*  508867 */   // Label 8470: @508867
     /*  508867 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(508935), // Rule ID 62180 //
     /*  508872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  508889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508904 */     // MIs[0] policy
     /*  508904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  508917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508931 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508933 */     GIR_RootConstrainSelectedInstOperands,
     /*  508934 */     // GIR_Coverage, 62180,
     /*  508934 */     GIR_EraseRootFromParent_Done,
     /*  508935 */   // Label 8471: @508935
     /*  508935 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(509003), // Rule ID 62181 //
     /*  508940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  508957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508972 */     // MIs[0] policy
     /*  508972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508982 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  508985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508999 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509001 */     GIR_RootConstrainSelectedInstOperands,
     /*  509002 */     // GIR_Coverage, 62181,
     /*  509002 */     GIR_EraseRootFromParent_Done,
     /*  509003 */   // Label 8472: @509003
     /*  509003 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(509071), // Rule ID 62182 //
     /*  509008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  509019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  509022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509040 */     // MIs[0] policy
     /*  509040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509050 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  509053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509067 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509069 */     GIR_RootConstrainSelectedInstOperands,
     /*  509070 */     // GIR_Coverage, 62182,
     /*  509070 */     GIR_EraseRootFromParent_Done,
     /*  509071 */   // Label 8473: @509071
     /*  509071 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(509139), // Rule ID 62183 //
     /*  509076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  509087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  509090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509108 */     // MIs[0] policy
     /*  509108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509118 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  509121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509135 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509137 */     GIR_RootConstrainSelectedInstOperands,
     /*  509138 */     // GIR_Coverage, 62183,
     /*  509138 */     GIR_EraseRootFromParent_Done,
     /*  509139 */   // Label 8474: @509139
     /*  509139 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(509207), // Rule ID 62184 //
     /*  509144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509176 */     // MIs[0] policy
     /*  509176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509186 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  509189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509203 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509205 */     GIR_RootConstrainSelectedInstOperands,
     /*  509206 */     // GIR_Coverage, 62184,
     /*  509206 */     GIR_EraseRootFromParent_Done,
     /*  509207 */   // Label 8475: @509207
     /*  509207 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(509275), // Rule ID 62185 //
     /*  509212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509244 */     // MIs[0] policy
     /*  509244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509254 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  509257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509271 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509273 */     GIR_RootConstrainSelectedInstOperands,
     /*  509274 */     // GIR_Coverage, 62185,
     /*  509274 */     GIR_EraseRootFromParent_Done,
     /*  509275 */   // Label 8476: @509275
     /*  509275 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(509343), // Rule ID 62186 //
     /*  509280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509312 */     // MIs[0] policy
     /*  509312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  509325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509339 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509341 */     GIR_RootConstrainSelectedInstOperands,
     /*  509342 */     // GIR_Coverage, 62186,
     /*  509342 */     GIR_EraseRootFromParent_Done,
     /*  509343 */   // Label 8477: @509343
     /*  509343 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(509411), // Rule ID 62187 //
     /*  509348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509380 */     // MIs[0] policy
     /*  509380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  509393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509407 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509409 */     GIR_RootConstrainSelectedInstOperands,
     /*  509410 */     // GIR_Coverage, 62187,
     /*  509410 */     GIR_EraseRootFromParent_Done,
     /*  509411 */   // Label 8478: @509411
     /*  509411 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(509479), // Rule ID 62188 //
     /*  509416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509448 */     // MIs[0] policy
     /*  509448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  509461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509475 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509477 */     GIR_RootConstrainSelectedInstOperands,
     /*  509478 */     // GIR_Coverage, 62188,
     /*  509478 */     GIR_EraseRootFromParent_Done,
     /*  509479 */   // Label 8479: @509479
     /*  509479 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(509547), // Rule ID 62189 //
     /*  509484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509516 */     // MIs[0] policy
     /*  509516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  509529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509543 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509545 */     GIR_RootConstrainSelectedInstOperands,
     /*  509546 */     // GIR_Coverage, 62189,
     /*  509546 */     GIR_EraseRootFromParent_Done,
     /*  509547 */   // Label 8480: @509547
     /*  509547 */   GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(509615), // Rule ID 62190 //
     /*  509552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509584 */     // MIs[0] policy
     /*  509584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  509597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509611 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509613 */     GIR_RootConstrainSelectedInstOperands,
     /*  509614 */     // GIR_Coverage, 62190,
     /*  509614 */     GIR_EraseRootFromParent_Done,
     /*  509615 */   // Label 8481: @509615
     /*  509615 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(509683), // Rule ID 62191 //
     /*  509620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509652 */     // MIs[0] policy
     /*  509652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  509665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509679 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509681 */     GIR_RootConstrainSelectedInstOperands,
     /*  509682 */     // GIR_Coverage, 62191,
     /*  509682 */     GIR_EraseRootFromParent_Done,
     /*  509683 */   // Label 8482: @509683
     /*  509683 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(509751), // Rule ID 62192 //
     /*  509688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509720 */     // MIs[0] policy
     /*  509720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  509733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509747 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509749 */     GIR_RootConstrainSelectedInstOperands,
     /*  509750 */     // GIR_Coverage, 62192,
     /*  509750 */     GIR_EraseRootFromParent_Done,
     /*  509751 */   // Label 8483: @509751
     /*  509751 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(509819), // Rule ID 62193 //
     /*  509756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509788 */     // MIs[0] policy
     /*  509788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  509801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509815 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509817 */     GIR_RootConstrainSelectedInstOperands,
     /*  509818 */     // GIR_Coverage, 62193,
     /*  509818 */     GIR_EraseRootFromParent_Done,
     /*  509819 */   // Label 8484: @509819
     /*  509819 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(509887), // Rule ID 62194 //
     /*  509824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509856 */     // MIs[0] policy
     /*  509856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  509869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509883 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509885 */     GIR_RootConstrainSelectedInstOperands,
     /*  509886 */     // GIR_Coverage, 62194,
     /*  509886 */     GIR_EraseRootFromParent_Done,
     /*  509887 */   // Label 8485: @509887
     /*  509887 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(509955), // Rule ID 62195 //
     /*  509892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509924 */     // MIs[0] policy
     /*  509924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509934 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  509937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509951 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509953 */     GIR_RootConstrainSelectedInstOperands,
     /*  509954 */     // GIR_Coverage, 62195,
     /*  509954 */     GIR_EraseRootFromParent_Done,
     /*  509955 */   // Label 8486: @509955
     /*  509955 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(510023), // Rule ID 62196 //
     /*  509960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509992 */     // MIs[0] policy
     /*  509992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  510005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510019 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510021 */     GIR_RootConstrainSelectedInstOperands,
     /*  510022 */     // GIR_Coverage, 62196,
     /*  510022 */     GIR_EraseRootFromParent_Done,
     /*  510023 */   // Label 8487: @510023
     /*  510023 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(510091), // Rule ID 62197 //
     /*  510028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510060 */     // MIs[0] policy
     /*  510060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510070 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  510073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510087 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510089 */     GIR_RootConstrainSelectedInstOperands,
     /*  510090 */     // GIR_Coverage, 62197,
     /*  510090 */     GIR_EraseRootFromParent_Done,
     /*  510091 */   // Label 8488: @510091
     /*  510091 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(510159), // Rule ID 62198 //
     /*  510096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510128 */     // MIs[0] policy
     /*  510128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510138 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  510141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510155 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510157 */     GIR_RootConstrainSelectedInstOperands,
     /*  510158 */     // GIR_Coverage, 62198,
     /*  510158 */     GIR_EraseRootFromParent_Done,
     /*  510159 */   // Label 8489: @510159
     /*  510159 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(510227), // Rule ID 62199 //
     /*  510164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510196 */     // MIs[0] policy
     /*  510196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  510209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510223 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510225 */     GIR_RootConstrainSelectedInstOperands,
     /*  510226 */     // GIR_Coverage, 62199,
     /*  510226 */     GIR_EraseRootFromParent_Done,
     /*  510227 */   // Label 8490: @510227
     /*  510227 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(510295), // Rule ID 62200 //
     /*  510232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510264 */     // MIs[0] policy
     /*  510264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510274 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  510277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510291 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510293 */     GIR_RootConstrainSelectedInstOperands,
     /*  510294 */     // GIR_Coverage, 62200,
     /*  510294 */     GIR_EraseRootFromParent_Done,
     /*  510295 */   // Label 8491: @510295
     /*  510295 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(510363), // Rule ID 62201 //
     /*  510300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510332 */     // MIs[0] policy
     /*  510332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510342 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  510345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510359 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510361 */     GIR_RootConstrainSelectedInstOperands,
     /*  510362 */     // GIR_Coverage, 62201,
     /*  510362 */     GIR_EraseRootFromParent_Done,
     /*  510363 */   // Label 8492: @510363
     /*  510363 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(510431), // Rule ID 62202 //
     /*  510368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510400 */     // MIs[0] policy
     /*  510400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510410 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  510413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510427 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510429 */     GIR_RootConstrainSelectedInstOperands,
     /*  510430 */     // GIR_Coverage, 62202,
     /*  510430 */     GIR_EraseRootFromParent_Done,
     /*  510431 */   // Label 8493: @510431
     /*  510431 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(510499), // Rule ID 62203 //
     /*  510436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510468 */     // MIs[0] policy
     /*  510468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  510481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510495 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510497 */     GIR_RootConstrainSelectedInstOperands,
     /*  510498 */     // GIR_Coverage, 62203,
     /*  510498 */     GIR_EraseRootFromParent_Done,
     /*  510499 */   // Label 8494: @510499
     /*  510499 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(510567), // Rule ID 62204 //
     /*  510504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510536 */     // MIs[0] policy
     /*  510536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  510549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510563 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510565 */     GIR_RootConstrainSelectedInstOperands,
     /*  510566 */     // GIR_Coverage, 62204,
     /*  510566 */     GIR_EraseRootFromParent_Done,
     /*  510567 */   // Label 8495: @510567
     /*  510567 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(510635), // Rule ID 62205 //
     /*  510572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510604 */     // MIs[0] policy
     /*  510604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  510617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510631 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510633 */     GIR_RootConstrainSelectedInstOperands,
     /*  510634 */     // GIR_Coverage, 62205,
     /*  510634 */     GIR_EraseRootFromParent_Done,
     /*  510635 */   // Label 8496: @510635
     /*  510635 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(510703), // Rule ID 62206 //
     /*  510640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510672 */     // MIs[0] policy
     /*  510672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510682 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  510685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510699 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510701 */     GIR_RootConstrainSelectedInstOperands,
     /*  510702 */     // GIR_Coverage, 62206,
     /*  510702 */     GIR_EraseRootFromParent_Done,
     /*  510703 */   // Label 8497: @510703
     /*  510703 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(510771), // Rule ID 62207 //
     /*  510708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510740 */     // MIs[0] policy
     /*  510740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  510753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510767 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510769 */     GIR_RootConstrainSelectedInstOperands,
     /*  510770 */     // GIR_Coverage, 62207,
     /*  510770 */     GIR_EraseRootFromParent_Done,
     /*  510771 */   // Label 8498: @510771
     /*  510771 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(510839), // Rule ID 62208 //
     /*  510776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510808 */     // MIs[0] policy
     /*  510808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510818 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  510821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510835 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510837 */     GIR_RootConstrainSelectedInstOperands,
     /*  510838 */     // GIR_Coverage, 62208,
     /*  510838 */     GIR_EraseRootFromParent_Done,
     /*  510839 */   // Label 8499: @510839
     /*  510839 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(510907), // Rule ID 62209 //
     /*  510844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510876 */     // MIs[0] policy
     /*  510876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510886 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  510889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510903 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510905 */     GIR_RootConstrainSelectedInstOperands,
     /*  510906 */     // GIR_Coverage, 62209,
     /*  510906 */     GIR_EraseRootFromParent_Done,
     /*  510907 */   // Label 8500: @510907
     /*  510907 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(510975), // Rule ID 62210 //
     /*  510912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  510920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  510923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  510926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510944 */     // MIs[0] policy
     /*  510944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510954 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  510957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510971 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510973 */     GIR_RootConstrainSelectedInstOperands,
     /*  510974 */     // GIR_Coverage, 62210,
     /*  510974 */     GIR_EraseRootFromParent_Done,
     /*  510975 */   // Label 8501: @510975
     /*  510975 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(511043), // Rule ID 62211 //
     /*  510980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  510988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  510991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  510994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511012 */     // MIs[0] policy
     /*  511012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511022 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  511025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511039 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511041 */     GIR_RootConstrainSelectedInstOperands,
     /*  511042 */     // GIR_Coverage, 62211,
     /*  511042 */     GIR_EraseRootFromParent_Done,
     /*  511043 */   // Label 8502: @511043
     /*  511043 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(511111), // Rule ID 62212 //
     /*  511048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511080 */     // MIs[0] policy
     /*  511080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511090 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  511093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511107 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511109 */     GIR_RootConstrainSelectedInstOperands,
     /*  511110 */     // GIR_Coverage, 62212,
     /*  511110 */     GIR_EraseRootFromParent_Done,
     /*  511111 */   // Label 8503: @511111
     /*  511111 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(511179), // Rule ID 62213 //
     /*  511116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511148 */     // MIs[0] policy
     /*  511148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  511161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511175 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511177 */     GIR_RootConstrainSelectedInstOperands,
     /*  511178 */     // GIR_Coverage, 62213,
     /*  511178 */     GIR_EraseRootFromParent_Done,
     /*  511179 */   // Label 8504: @511179
     /*  511179 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(511247), // Rule ID 62214 //
     /*  511184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  511195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  511198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511216 */     // MIs[0] policy
     /*  511216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  511229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511243 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511245 */     GIR_RootConstrainSelectedInstOperands,
     /*  511246 */     // GIR_Coverage, 62214,
     /*  511246 */     GIR_EraseRootFromParent_Done,
     /*  511247 */   // Label 8505: @511247
     /*  511247 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(511315), // Rule ID 62215 //
     /*  511252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  511263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  511266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511284 */     // MIs[0] policy
     /*  511284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511294 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  511297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511311 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511313 */     GIR_RootConstrainSelectedInstOperands,
     /*  511314 */     // GIR_Coverage, 62215,
     /*  511314 */     GIR_EraseRootFromParent_Done,
     /*  511315 */   // Label 8506: @511315
     /*  511315 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(511383), // Rule ID 62216 //
     /*  511320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511352 */     // MIs[0] policy
     /*  511352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511362 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  511365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511379 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511381 */     GIR_RootConstrainSelectedInstOperands,
     /*  511382 */     // GIR_Coverage, 62216,
     /*  511382 */     GIR_EraseRootFromParent_Done,
     /*  511383 */   // Label 8507: @511383
     /*  511383 */   GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(511451), // Rule ID 62217 //
     /*  511388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511420 */     // MIs[0] policy
     /*  511420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  511433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511447 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511449 */     GIR_RootConstrainSelectedInstOperands,
     /*  511450 */     // GIR_Coverage, 62217,
     /*  511450 */     GIR_EraseRootFromParent_Done,
     /*  511451 */   // Label 8508: @511451
     /*  511451 */   GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(511519), // Rule ID 62218 //
     /*  511456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  511473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511488 */     // MIs[0] policy
     /*  511488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511498 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  511501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511515 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511517 */     GIR_RootConstrainSelectedInstOperands,
     /*  511518 */     // GIR_Coverage, 62218,
     /*  511518 */     GIR_EraseRootFromParent_Done,
     /*  511519 */   // Label 8509: @511519
     /*  511519 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(511587), // Rule ID 62219 //
     /*  511524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  511541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511556 */     // MIs[0] policy
     /*  511556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511566 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  511569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511583 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511585 */     GIR_RootConstrainSelectedInstOperands,
     /*  511586 */     // GIR_Coverage, 62219,
     /*  511586 */     GIR_EraseRootFromParent_Done,
     /*  511587 */   // Label 8510: @511587
     /*  511587 */   GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(511655), // Rule ID 62220 //
     /*  511592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  511600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  511603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511624 */     // MIs[0] policy
     /*  511624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511634 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  511637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511651 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511653 */     GIR_RootConstrainSelectedInstOperands,
     /*  511654 */     // GIR_Coverage, 62220,
     /*  511654 */     GIR_EraseRootFromParent_Done,
     /*  511655 */   // Label 8511: @511655
     /*  511655 */   GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(511723), // Rule ID 62221 //
     /*  511660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  511668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  511671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511692 */     // MIs[0] policy
     /*  511692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  511705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511719 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511721 */     GIR_RootConstrainSelectedInstOperands,
     /*  511722 */     // GIR_Coverage, 62221,
     /*  511722 */     GIR_EraseRootFromParent_Done,
     /*  511723 */   // Label 8512: @511723
     /*  511723 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(511791), // Rule ID 62222 //
     /*  511728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  511736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511760 */     // MIs[0] policy
     /*  511760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  511773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511787 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511789 */     GIR_RootConstrainSelectedInstOperands,
     /*  511790 */     // GIR_Coverage, 62222,
     /*  511790 */     GIR_EraseRootFromParent_Done,
     /*  511791 */   // Label 8513: @511791
     /*  511791 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(511859), // Rule ID 62223 //
     /*  511796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  511804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511828 */     // MIs[0] policy
     /*  511828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  511841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511855 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511857 */     GIR_RootConstrainSelectedInstOperands,
     /*  511858 */     // GIR_Coverage, 62223,
     /*  511858 */     GIR_EraseRootFromParent_Done,
     /*  511859 */   // Label 8514: @511859
     /*  511859 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(511927), // Rule ID 62224 //
     /*  511864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  511872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511896 */     // MIs[0] policy
     /*  511896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  511909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511923 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511925 */     GIR_RootConstrainSelectedInstOperands,
     /*  511926 */     // GIR_Coverage, 62224,
     /*  511926 */     GIR_EraseRootFromParent_Done,
     /*  511927 */   // Label 8515: @511927
     /*  511927 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(511995), // Rule ID 62225 //
     /*  511932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  511940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511964 */     // MIs[0] policy
     /*  511964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  511977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511991 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511993 */     GIR_RootConstrainSelectedInstOperands,
     /*  511994 */     // GIR_Coverage, 62225,
     /*  511994 */     GIR_EraseRootFromParent_Done,
     /*  511995 */   // Label 8516: @511995
     /*  511995 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(512063), // Rule ID 62226 //
     /*  512000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512032 */     // MIs[0] policy
     /*  512032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  512045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512059 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512061 */     GIR_RootConstrainSelectedInstOperands,
     /*  512062 */     // GIR_Coverage, 62226,
     /*  512062 */     GIR_EraseRootFromParent_Done,
     /*  512063 */   // Label 8517: @512063
     /*  512063 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(512131), // Rule ID 62227 //
     /*  512068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512100 */     // MIs[0] policy
     /*  512100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  512113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512127 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512129 */     GIR_RootConstrainSelectedInstOperands,
     /*  512130 */     // GIR_Coverage, 62227,
     /*  512130 */     GIR_EraseRootFromParent_Done,
     /*  512131 */   // Label 8518: @512131
     /*  512131 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(512199), // Rule ID 62228 //
     /*  512136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512168 */     // MIs[0] policy
     /*  512168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512178 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  512181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512195 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512197 */     GIR_RootConstrainSelectedInstOperands,
     /*  512198 */     // GIR_Coverage, 62228,
     /*  512198 */     GIR_EraseRootFromParent_Done,
     /*  512199 */   // Label 8519: @512199
     /*  512199 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(512267), // Rule ID 62229 //
     /*  512204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512236 */     // MIs[0] policy
     /*  512236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  512249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512263 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512265 */     GIR_RootConstrainSelectedInstOperands,
     /*  512266 */     // GIR_Coverage, 62229,
     /*  512266 */     GIR_EraseRootFromParent_Done,
     /*  512267 */   // Label 8520: @512267
     /*  512267 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(512335), // Rule ID 62230 //
     /*  512272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512304 */     // MIs[0] policy
     /*  512304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512314 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  512317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512331 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512333 */     GIR_RootConstrainSelectedInstOperands,
     /*  512334 */     // GIR_Coverage, 62230,
     /*  512334 */     GIR_EraseRootFromParent_Done,
     /*  512335 */   // Label 8521: @512335
     /*  512335 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(512403), // Rule ID 62231 //
     /*  512340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512372 */     // MIs[0] policy
     /*  512372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  512385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512399 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512401 */     GIR_RootConstrainSelectedInstOperands,
     /*  512402 */     // GIR_Coverage, 62231,
     /*  512402 */     GIR_EraseRootFromParent_Done,
     /*  512403 */   // Label 8522: @512403
     /*  512403 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(512471), // Rule ID 62232 //
     /*  512408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512440 */     // MIs[0] policy
     /*  512440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512450 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  512453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512467 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512469 */     GIR_RootConstrainSelectedInstOperands,
     /*  512470 */     // GIR_Coverage, 62232,
     /*  512470 */     GIR_EraseRootFromParent_Done,
     /*  512471 */   // Label 8523: @512471
     /*  512471 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(512539), // Rule ID 62233 //
     /*  512476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512508 */     // MIs[0] policy
     /*  512508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  512521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512535 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512537 */     GIR_RootConstrainSelectedInstOperands,
     /*  512538 */     // GIR_Coverage, 62233,
     /*  512538 */     GIR_EraseRootFromParent_Done,
     /*  512539 */   // Label 8524: @512539
     /*  512539 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(512607), // Rule ID 62234 //
     /*  512544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512576 */     // MIs[0] policy
     /*  512576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  512589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512603 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512605 */     GIR_RootConstrainSelectedInstOperands,
     /*  512606 */     // GIR_Coverage, 62234,
     /*  512606 */     GIR_EraseRootFromParent_Done,
     /*  512607 */   // Label 8525: @512607
     /*  512607 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(512675), // Rule ID 62235 //
     /*  512612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512644 */     // MIs[0] policy
     /*  512644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512654 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  512657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512671 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512673 */     GIR_RootConstrainSelectedInstOperands,
     /*  512674 */     // GIR_Coverage, 62235,
     /*  512674 */     GIR_EraseRootFromParent_Done,
     /*  512675 */   // Label 8526: @512675
     /*  512675 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(512743), // Rule ID 62236 //
     /*  512680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512712 */     // MIs[0] policy
     /*  512712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512722 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  512725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512739 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512741 */     GIR_RootConstrainSelectedInstOperands,
     /*  512742 */     // GIR_Coverage, 62236,
     /*  512742 */     GIR_EraseRootFromParent_Done,
     /*  512743 */   // Label 8527: @512743
     /*  512743 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(512811), // Rule ID 62237 //
     /*  512748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512780 */     // MIs[0] policy
     /*  512780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512790 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  512793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512807 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512809 */     GIR_RootConstrainSelectedInstOperands,
     /*  512810 */     // GIR_Coverage, 62237,
     /*  512810 */     GIR_EraseRootFromParent_Done,
     /*  512811 */   // Label 8528: @512811
     /*  512811 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(512879), // Rule ID 62238 //
     /*  512816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  512833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512848 */     // MIs[0] policy
     /*  512848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512858 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  512861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512875 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512877 */     GIR_RootConstrainSelectedInstOperands,
     /*  512878 */     // GIR_Coverage, 62238,
     /*  512878 */     GIR_EraseRootFromParent_Done,
     /*  512879 */   // Label 8529: @512879
     /*  512879 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(512947), // Rule ID 62239 //
     /*  512884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  512901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512916 */     // MIs[0] policy
     /*  512916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  512929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512943 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512945 */     GIR_RootConstrainSelectedInstOperands,
     /*  512946 */     // GIR_Coverage, 62239,
     /*  512946 */     GIR_EraseRootFromParent_Done,
     /*  512947 */   // Label 8530: @512947
     /*  512947 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(513015), // Rule ID 62240 //
     /*  512952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  512963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  512966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512984 */     // MIs[0] policy
     /*  512984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512994 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  512997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513011 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513013 */     GIR_RootConstrainSelectedInstOperands,
     /*  513014 */     // GIR_Coverage, 62240,
     /*  513014 */     GIR_EraseRootFromParent_Done,
     /*  513015 */   // Label 8531: @513015
     /*  513015 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(513083), // Rule ID 62241 //
     /*  513020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513052 */     // MIs[0] policy
     /*  513052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513062 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  513065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513079 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513081 */     GIR_RootConstrainSelectedInstOperands,
     /*  513082 */     // GIR_Coverage, 62241,
     /*  513082 */     GIR_EraseRootFromParent_Done,
     /*  513083 */   // Label 8532: @513083
     /*  513083 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(513151), // Rule ID 62242 //
     /*  513088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513120 */     // MIs[0] policy
     /*  513120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513130 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  513133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513147 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513149 */     GIR_RootConstrainSelectedInstOperands,
     /*  513150 */     // GIR_Coverage, 62242,
     /*  513150 */     GIR_EraseRootFromParent_Done,
     /*  513151 */   // Label 8533: @513151
     /*  513151 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(513219), // Rule ID 62243 //
     /*  513156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513188 */     // MIs[0] policy
     /*  513188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  513201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513215 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513217 */     GIR_RootConstrainSelectedInstOperands,
     /*  513218 */     // GIR_Coverage, 62243,
     /*  513218 */     GIR_EraseRootFromParent_Done,
     /*  513219 */   // Label 8534: @513219
     /*  513219 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(513287), // Rule ID 62244 //
     /*  513224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513256 */     // MIs[0] policy
     /*  513256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513266 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  513269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513283 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513285 */     GIR_RootConstrainSelectedInstOperands,
     /*  513286 */     // GIR_Coverage, 62244,
     /*  513286 */     GIR_EraseRootFromParent_Done,
     /*  513287 */   // Label 8535: @513287
     /*  513287 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(513355), // Rule ID 62245 //
     /*  513292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513324 */     // MIs[0] policy
     /*  513324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  513337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513351 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513353 */     GIR_RootConstrainSelectedInstOperands,
     /*  513354 */     // GIR_Coverage, 62245,
     /*  513354 */     GIR_EraseRootFromParent_Done,
     /*  513355 */   // Label 8536: @513355
     /*  513355 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(513423), // Rule ID 62246 //
     /*  513360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  513377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513392 */     // MIs[0] policy
     /*  513392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513402 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  513405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513419 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513421 */     GIR_RootConstrainSelectedInstOperands,
     /*  513422 */     // GIR_Coverage, 62246,
     /*  513422 */     GIR_EraseRootFromParent_Done,
     /*  513423 */   // Label 8537: @513423
     /*  513423 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(513491), // Rule ID 62247 //
     /*  513428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  513445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513460 */     // MIs[0] policy
     /*  513460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513470 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  513473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513487 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513489 */     GIR_RootConstrainSelectedInstOperands,
     /*  513490 */     // GIR_Coverage, 62247,
     /*  513490 */     GIR_EraseRootFromParent_Done,
     /*  513491 */   // Label 8538: @513491
     /*  513491 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(513559), // Rule ID 62264 //
     /*  513496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  513507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  513510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513528 */     // MIs[0] policy
     /*  513528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  513541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513555 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513557 */     GIR_RootConstrainSelectedInstOperands,
     /*  513558 */     // GIR_Coverage, 62264,
     /*  513558 */     GIR_EraseRootFromParent_Done,
     /*  513559 */   // Label 8539: @513559
     /*  513559 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(513627), // Rule ID 62265 //
     /*  513564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  513575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  513578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513596 */     // MIs[0] policy
     /*  513596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513606 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  513609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513623 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513625 */     GIR_RootConstrainSelectedInstOperands,
     /*  513626 */     // GIR_Coverage, 62265,
     /*  513626 */     GIR_EraseRootFromParent_Done,
     /*  513627 */   // Label 8540: @513627
     /*  513627 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(513695), // Rule ID 62266 //
     /*  513632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  513643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  513646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513664 */     // MIs[0] policy
     /*  513664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  513677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513691 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513693 */     GIR_RootConstrainSelectedInstOperands,
     /*  513694 */     // GIR_Coverage, 62266,
     /*  513694 */     GIR_EraseRootFromParent_Done,
     /*  513695 */   // Label 8541: @513695
     /*  513695 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(513763), // Rule ID 62267 //
     /*  513700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  513711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  513714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513732 */     // MIs[0] policy
     /*  513732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513742 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  513745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513759 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513761 */     GIR_RootConstrainSelectedInstOperands,
     /*  513762 */     // GIR_Coverage, 62267,
     /*  513762 */     GIR_EraseRootFromParent_Done,
     /*  513763 */   // Label 8542: @513763
     /*  513763 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(513831), // Rule ID 62268 //
     /*  513768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  513779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  513782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513800 */     // MIs[0] policy
     /*  513800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  513813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513827 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513829 */     GIR_RootConstrainSelectedInstOperands,
     /*  513830 */     // GIR_Coverage, 62268,
     /*  513830 */     GIR_EraseRootFromParent_Done,
     /*  513831 */   // Label 8543: @513831
     /*  513831 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(513899), // Rule ID 62269 //
     /*  513836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  513847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  513850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513868 */     // MIs[0] policy
     /*  513868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513878 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  513881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513895 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513897 */     GIR_RootConstrainSelectedInstOperands,
     /*  513898 */     // GIR_Coverage, 62269,
     /*  513898 */     GIR_EraseRootFromParent_Done,
     /*  513899 */   // Label 8544: @513899
     /*  513899 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(513967), // Rule ID 62270 //
     /*  513904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513936 */     // MIs[0] policy
     /*  513936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  513949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513963 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513965 */     GIR_RootConstrainSelectedInstOperands,
     /*  513966 */     // GIR_Coverage, 62270,
     /*  513966 */     GIR_EraseRootFromParent_Done,
     /*  513967 */   // Label 8545: @513967
     /*  513967 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(514035), // Rule ID 62271 //
     /*  513972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514004 */     // MIs[0] policy
     /*  514004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  514017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514031 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514033 */     GIR_RootConstrainSelectedInstOperands,
     /*  514034 */     // GIR_Coverage, 62271,
     /*  514034 */     GIR_EraseRootFromParent_Done,
     /*  514035 */   // Label 8546: @514035
     /*  514035 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(514103), // Rule ID 62272 //
     /*  514040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  514051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  514054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514072 */     // MIs[0] policy
     /*  514072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  514085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514099 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514101 */     GIR_RootConstrainSelectedInstOperands,
     /*  514102 */     // GIR_Coverage, 62272,
     /*  514102 */     GIR_EraseRootFromParent_Done,
     /*  514103 */   // Label 8547: @514103
     /*  514103 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(514171), // Rule ID 62273 //
     /*  514108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  514119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  514122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514140 */     // MIs[0] policy
     /*  514140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  514153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514167 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514169 */     GIR_RootConstrainSelectedInstOperands,
     /*  514170 */     // GIR_Coverage, 62273,
     /*  514170 */     GIR_EraseRootFromParent_Done,
     /*  514171 */   // Label 8548: @514171
     /*  514171 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(514239), // Rule ID 62274 //
     /*  514176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  514187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  514190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  514193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514208 */     // MIs[0] policy
     /*  514208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  514221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514235 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514237 */     GIR_RootConstrainSelectedInstOperands,
     /*  514238 */     // GIR_Coverage, 62274,
     /*  514238 */     GIR_EraseRootFromParent_Done,
     /*  514239 */   // Label 8549: @514239
     /*  514239 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(514307), // Rule ID 62275 //
     /*  514244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  514255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  514258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  514261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514276 */     // MIs[0] policy
     /*  514276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  514289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514303 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514305 */     GIR_RootConstrainSelectedInstOperands,
     /*  514306 */     // GIR_Coverage, 62275,
     /*  514306 */     GIR_EraseRootFromParent_Done,
     /*  514307 */   // Label 8550: @514307
     /*  514307 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(514375), // Rule ID 62276 //
     /*  514312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514344 */     // MIs[0] policy
     /*  514344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514354 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  514357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514371 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514373 */     GIR_RootConstrainSelectedInstOperands,
     /*  514374 */     // GIR_Coverage, 62276,
     /*  514374 */     GIR_EraseRootFromParent_Done,
     /*  514375 */   // Label 8551: @514375
     /*  514375 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(514443), // Rule ID 62277 //
     /*  514380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514412 */     // MIs[0] policy
     /*  514412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  514425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514439 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514441 */     GIR_RootConstrainSelectedInstOperands,
     /*  514442 */     // GIR_Coverage, 62277,
     /*  514442 */     GIR_EraseRootFromParent_Done,
     /*  514443 */   // Label 8552: @514443
     /*  514443 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(514511), // Rule ID 62278 //
     /*  514448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514480 */     // MIs[0] policy
     /*  514480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  514493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514507 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514509 */     GIR_RootConstrainSelectedInstOperands,
     /*  514510 */     // GIR_Coverage, 62278,
     /*  514510 */     GIR_EraseRootFromParent_Done,
     /*  514511 */   // Label 8553: @514511
     /*  514511 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(514579), // Rule ID 62279 //
     /*  514516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514548 */     // MIs[0] policy
     /*  514548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514558 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  514561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514575 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514577 */     GIR_RootConstrainSelectedInstOperands,
     /*  514578 */     // GIR_Coverage, 62279,
     /*  514578 */     GIR_EraseRootFromParent_Done,
     /*  514579 */   // Label 8554: @514579
     /*  514579 */   GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(514647), // Rule ID 62280 //
     /*  514584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  514601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514616 */     // MIs[0] policy
     /*  514616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514626 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  514629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514643 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514645 */     GIR_RootConstrainSelectedInstOperands,
     /*  514646 */     // GIR_Coverage, 62280,
     /*  514646 */     GIR_EraseRootFromParent_Done,
     /*  514647 */   // Label 8555: @514647
     /*  514647 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(514715), // Rule ID 62281 //
     /*  514652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  514669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514684 */     // MIs[0] policy
     /*  514684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514694 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  514697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514711 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514713 */     GIR_RootConstrainSelectedInstOperands,
     /*  514714 */     // GIR_Coverage, 62281,
     /*  514714 */     GIR_EraseRootFromParent_Done,
     /*  514715 */   // Label 8556: @514715
     /*  514715 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(514783), // Rule ID 62282 //
     /*  514720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514752 */     // MIs[0] policy
     /*  514752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514762 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  514765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514779 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514781 */     GIR_RootConstrainSelectedInstOperands,
     /*  514782 */     // GIR_Coverage, 62282,
     /*  514782 */     GIR_EraseRootFromParent_Done,
     /*  514783 */   // Label 8557: @514783
     /*  514783 */   GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(514851), // Rule ID 62283 //
     /*  514788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514820 */     // MIs[0] policy
     /*  514820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514830 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  514833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514847 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514849 */     GIR_RootConstrainSelectedInstOperands,
     /*  514850 */     // GIR_Coverage, 62283,
     /*  514850 */     GIR_EraseRootFromParent_Done,
     /*  514851 */   // Label 8558: @514851
     /*  514851 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(514919), // Rule ID 62284 //
     /*  514856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514888 */     // MIs[0] policy
     /*  514888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514898 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  514901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514915 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514917 */     GIR_RootConstrainSelectedInstOperands,
     /*  514918 */     // GIR_Coverage, 62284,
     /*  514918 */     GIR_EraseRootFromParent_Done,
     /*  514919 */   // Label 8559: @514919
     /*  514919 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(514987), // Rule ID 62285 //
     /*  514924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514956 */     // MIs[0] policy
     /*  514956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514966 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  514969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514983 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514985 */     GIR_RootConstrainSelectedInstOperands,
     /*  514986 */     // GIR_Coverage, 62285,
     /*  514986 */     GIR_EraseRootFromParent_Done,
     /*  514987 */   // Label 8560: @514987
     /*  514987 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(515055), // Rule ID 62286 //
     /*  514992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  515000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515024 */     // MIs[0] policy
     /*  515024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  515037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515051 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515053 */     GIR_RootConstrainSelectedInstOperands,
     /*  515054 */     // GIR_Coverage, 62286,
     /*  515054 */     GIR_EraseRootFromParent_Done,
     /*  515055 */   // Label 8561: @515055
     /*  515055 */   GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(515123), // Rule ID 62287 //
     /*  515060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  515063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  515068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515092 */     // MIs[0] policy
     /*  515092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  515105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515119 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515121 */     GIR_RootConstrainSelectedInstOperands,
     /*  515122 */     // GIR_Coverage, 62287,
     /*  515122 */     GIR_EraseRootFromParent_Done,
     /*  515123 */   // Label 8562: @515123
     /*  515123 */   GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(515191), // Rule ID 62288 //
     /*  515128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  515131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  515136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515160 */     // MIs[0] policy
     /*  515160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515170 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  515173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515187 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515189 */     GIR_RootConstrainSelectedInstOperands,
     /*  515190 */     // GIR_Coverage, 62288,
     /*  515190 */     GIR_EraseRootFromParent_Done,
     /*  515191 */   // Label 8563: @515191
     /*  515191 */   GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(515259), // Rule ID 62289 //
     /*  515196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  515199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  515204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515228 */     // MIs[0] policy
     /*  515228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515238 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  515241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515255 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515257 */     GIR_RootConstrainSelectedInstOperands,
     /*  515258 */     // GIR_Coverage, 62289,
     /*  515258 */     GIR_EraseRootFromParent_Done,
     /*  515259 */   // Label 8564: @515259
     /*  515259 */   GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(515327), // Rule ID 62290 //
     /*  515264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  515267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  515272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515296 */     // MIs[0] policy
     /*  515296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515306 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  515309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515323 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515325 */     GIR_RootConstrainSelectedInstOperands,
     /*  515326 */     // GIR_Coverage, 62290,
     /*  515326 */     GIR_EraseRootFromParent_Done,
     /*  515327 */   // Label 8565: @515327
     /*  515327 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(515395), // Rule ID 62291 //
     /*  515332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  515335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  515340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515364 */     // MIs[0] policy
     /*  515364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515374 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  515377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515391 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515393 */     GIR_RootConstrainSelectedInstOperands,
     /*  515394 */     // GIR_Coverage, 62291,
     /*  515394 */     GIR_EraseRootFromParent_Done,
     /*  515395 */   // Label 8566: @515395
     /*  515395 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(515463), // Rule ID 62386 //
     /*  515400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  515403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  515411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  515414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  515417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515432 */     // MIs[0] policy
     /*  515432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515442 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  515445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515459 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515461 */     GIR_RootConstrainSelectedInstOperands,
     /*  515462 */     // GIR_Coverage, 62386,
     /*  515462 */     GIR_EraseRootFromParent_Done,
     /*  515463 */   // Label 8567: @515463
     /*  515463 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(515531), // Rule ID 62387 //
     /*  515468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  515471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  515479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  515482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  515485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515500 */     // MIs[0] policy
     /*  515500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515510 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  515513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515527 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515529 */     GIR_RootConstrainSelectedInstOperands,
     /*  515530 */     // GIR_Coverage, 62387,
     /*  515530 */     GIR_EraseRootFromParent_Done,
     /*  515531 */   // Label 8568: @515531
     /*  515531 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(515599), // Rule ID 62388 //
     /*  515536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  515539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  515547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  515550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515568 */     // MIs[0] policy
     /*  515568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515578 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  515581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515595 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515597 */     GIR_RootConstrainSelectedInstOperands,
     /*  515598 */     // GIR_Coverage, 62388,
     /*  515598 */     GIR_EraseRootFromParent_Done,
     /*  515599 */   // Label 8569: @515599
     /*  515599 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(515667), // Rule ID 62389 //
     /*  515604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  515607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  515615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  515618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515636 */     // MIs[0] policy
     /*  515636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515646 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  515649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515663 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515665 */     GIR_RootConstrainSelectedInstOperands,
     /*  515666 */     // GIR_Coverage, 62389,
     /*  515666 */     GIR_EraseRootFromParent_Done,
     /*  515667 */   // Label 8570: @515667
     /*  515667 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(515735), // Rule ID 62390 //
     /*  515672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  515675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  515683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  515686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515704 */     // MIs[0] policy
     /*  515704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515714 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  515717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515731 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515733 */     GIR_RootConstrainSelectedInstOperands,
     /*  515734 */     // GIR_Coverage, 62390,
     /*  515734 */     GIR_EraseRootFromParent_Done,
     /*  515735 */   // Label 8571: @515735
     /*  515735 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(515803), // Rule ID 62391 //
     /*  515740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  515743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  515751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  515754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515772 */     // MIs[0] policy
     /*  515772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11537:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  515785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515799 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515801 */     GIR_RootConstrainSelectedInstOperands,
     /*  515802 */     // GIR_Coverage, 62391,
     /*  515802 */     GIR_EraseRootFromParent_Done,
     /*  515803 */   // Label 8572: @515803
     /*  515803 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(515871), // Rule ID 62392 //
     /*  515808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  515811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  515819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  515822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515840 */     // MIs[0] policy
     /*  515840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515850 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  515853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515867 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515869 */     GIR_RootConstrainSelectedInstOperands,
     /*  515870 */     // GIR_Coverage, 62392,
     /*  515870 */     GIR_EraseRootFromParent_Done,
     /*  515871 */   // Label 8573: @515871
     /*  515871 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(515939), // Rule ID 62393 //
     /*  515876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  515879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  515887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  515890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515908 */     // MIs[0] policy
     /*  515908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515918 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11537:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  515921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515935 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515937 */     GIR_RootConstrainSelectedInstOperands,
     /*  515938 */     // GIR_Coverage, 62393,
     /*  515938 */     GIR_EraseRootFromParent_Done,
     /*  515939 */   // Label 8574: @515939
     /*  515939 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(516007), // Rule ID 62394 //
     /*  515944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  515947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  515961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515976 */     // MIs[0] policy
     /*  515976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515986 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  515989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516003 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516005 */     GIR_RootConstrainSelectedInstOperands,
     /*  516006 */     // GIR_Coverage, 62394,
     /*  516006 */     GIR_EraseRootFromParent_Done,
     /*  516007 */   // Label 8575: @516007
     /*  516007 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(516075), // Rule ID 62395 //
     /*  516012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  516020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  516023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  516026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  516029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516044 */     // MIs[0] policy
     /*  516044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11537:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  516057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516071 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516073 */     GIR_RootConstrainSelectedInstOperands,
     /*  516074 */     // GIR_Coverage, 62395,
     /*  516074 */     GIR_EraseRootFromParent_Done,
     /*  516075 */   // Label 8576: @516075
     /*  516075 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(516143), // Rule ID 62396 //
     /*  516080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  516091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  516094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516112 */     // MIs[0] policy
     /*  516112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516122 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  516125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516139 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516141 */     GIR_RootConstrainSelectedInstOperands,
     /*  516142 */     // GIR_Coverage, 62396,
     /*  516142 */     GIR_EraseRootFromParent_Done,
     /*  516143 */   // Label 8577: @516143
     /*  516143 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(516211), // Rule ID 62397 //
     /*  516148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  516159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  516162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516180 */     // MIs[0] policy
     /*  516180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516190 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  516193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516207 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516209 */     GIR_RootConstrainSelectedInstOperands,
     /*  516210 */     // GIR_Coverage, 62397,
     /*  516210 */     GIR_EraseRootFromParent_Done,
     /*  516211 */   // Label 8578: @516211
     /*  516211 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(516279), // Rule ID 62398 //
     /*  516216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  516227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  516230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516248 */     // MIs[0] policy
     /*  516248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516258 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  516261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516275 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516277 */     GIR_RootConstrainSelectedInstOperands,
     /*  516278 */     // GIR_Coverage, 62398,
     /*  516278 */     GIR_EraseRootFromParent_Done,
     /*  516279 */   // Label 8579: @516279
     /*  516279 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(516347), // Rule ID 62399 //
     /*  516284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  516295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  516298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516316 */     // MIs[0] policy
     /*  516316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  516329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516343 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516345 */     GIR_RootConstrainSelectedInstOperands,
     /*  516346 */     // GIR_Coverage, 62399,
     /*  516346 */     GIR_EraseRootFromParent_Done,
     /*  516347 */   // Label 8580: @516347
     /*  516347 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(516415), // Rule ID 62400 //
     /*  516352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  516363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  516366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  516369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516384 */     // MIs[0] policy
     /*  516384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516394 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  516397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516411 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516413 */     GIR_RootConstrainSelectedInstOperands,
     /*  516414 */     // GIR_Coverage, 62400,
     /*  516414 */     GIR_EraseRootFromParent_Done,
     /*  516415 */   // Label 8581: @516415
     /*  516415 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(516483), // Rule ID 62401 //
     /*  516420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  516431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  516434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  516437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516452 */     // MIs[0] policy
     /*  516452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516462 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11536:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  516465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516479 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516481 */     GIR_RootConstrainSelectedInstOperands,
     /*  516482 */     // GIR_Coverage, 62401,
     /*  516482 */     GIR_EraseRootFromParent_Done,
     /*  516483 */   // Label 8582: @516483
     /*  516483 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(516551), // Rule ID 62402 //
     /*  516488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516520 */     // MIs[0] policy
     /*  516520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516530 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  516533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516547 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516549 */     GIR_RootConstrainSelectedInstOperands,
     /*  516550 */     // GIR_Coverage, 62402,
     /*  516550 */     GIR_EraseRootFromParent_Done,
     /*  516551 */   // Label 8583: @516551
     /*  516551 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(516619), // Rule ID 62403 //
     /*  516556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516588 */     // MIs[0] policy
     /*  516588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  516601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516615 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516617 */     GIR_RootConstrainSelectedInstOperands,
     /*  516618 */     // GIR_Coverage, 62403,
     /*  516618 */     GIR_EraseRootFromParent_Done,
     /*  516619 */   // Label 8584: @516619
     /*  516619 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(516687), // Rule ID 62404 //
     /*  516624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  516641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516656 */     // MIs[0] policy
     /*  516656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516666 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  516669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516683 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516685 */     GIR_RootConstrainSelectedInstOperands,
     /*  516686 */     // GIR_Coverage, 62404,
     /*  516686 */     GIR_EraseRootFromParent_Done,
     /*  516687 */   // Label 8585: @516687
     /*  516687 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(516755), // Rule ID 62405 //
     /*  516692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  516709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516724 */     // MIs[0] policy
     /*  516724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  516737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516751 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516753 */     GIR_RootConstrainSelectedInstOperands,
     /*  516754 */     // GIR_Coverage, 62405,
     /*  516754 */     GIR_EraseRootFromParent_Done,
     /*  516755 */   // Label 8586: @516755
     /*  516755 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(516823), // Rule ID 62406 //
     /*  516760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  516777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516792 */     // MIs[0] policy
     /*  516792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  516805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516819 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516821 */     GIR_RootConstrainSelectedInstOperands,
     /*  516822 */     // GIR_Coverage, 62406,
     /*  516822 */     GIR_EraseRootFromParent_Done,
     /*  516823 */   // Label 8587: @516823
     /*  516823 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(516891), // Rule ID 62407 //
     /*  516828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  516845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516860 */     // MIs[0] policy
     /*  516860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11536:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  516873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516887 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516889 */     GIR_RootConstrainSelectedInstOperands,
     /*  516890 */     // GIR_Coverage, 62407,
     /*  516890 */     GIR_EraseRootFromParent_Done,
     /*  516891 */   // Label 8588: @516891
     /*  516891 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(516959), // Rule ID 62408 //
     /*  516896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  516907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  516910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516928 */     // MIs[0] policy
     /*  516928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516938 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  516941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516955 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516957 */     GIR_RootConstrainSelectedInstOperands,
     /*  516958 */     // GIR_Coverage, 62408,
     /*  516958 */     GIR_EraseRootFromParent_Done,
     /*  516959 */   // Label 8589: @516959
     /*  516959 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(517027), // Rule ID 62409 //
     /*  516964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  516975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  516978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516996 */     // MIs[0] policy
     /*  516996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517006 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  517009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517023 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517025 */     GIR_RootConstrainSelectedInstOperands,
     /*  517026 */     // GIR_Coverage, 62409,
     /*  517026 */     GIR_EraseRootFromParent_Done,
     /*  517027 */   // Label 8590: @517027
     /*  517027 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(517095), // Rule ID 62410 //
     /*  517032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517064 */     // MIs[0] policy
     /*  517064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517074 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  517077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517091 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517093 */     GIR_RootConstrainSelectedInstOperands,
     /*  517094 */     // GIR_Coverage, 62410,
     /*  517094 */     GIR_EraseRootFromParent_Done,
     /*  517095 */   // Label 8591: @517095
     /*  517095 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(517163), // Rule ID 62411 //
     /*  517100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517132 */     // MIs[0] policy
     /*  517132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517142 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  517145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517159 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517161 */     GIR_RootConstrainSelectedInstOperands,
     /*  517162 */     // GIR_Coverage, 62411,
     /*  517162 */     GIR_EraseRootFromParent_Done,
     /*  517163 */   // Label 8592: @517163
     /*  517163 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(517231), // Rule ID 62412 //
     /*  517168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517200 */     // MIs[0] policy
     /*  517200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517210 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  517213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517227 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517229 */     GIR_RootConstrainSelectedInstOperands,
     /*  517230 */     // GIR_Coverage, 62412,
     /*  517230 */     GIR_EraseRootFromParent_Done,
     /*  517231 */   // Label 8593: @517231
     /*  517231 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(517299), // Rule ID 62413 //
     /*  517236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517268 */     // MIs[0] policy
     /*  517268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517278 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  517281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517295 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517297 */     GIR_RootConstrainSelectedInstOperands,
     /*  517298 */     // GIR_Coverage, 62413,
     /*  517298 */     GIR_EraseRootFromParent_Done,
     /*  517299 */   // Label 8594: @517299
     /*  517299 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(517367), // Rule ID 62414 //
     /*  517304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517336 */     // MIs[0] policy
     /*  517336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  517349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517363 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517365 */     GIR_RootConstrainSelectedInstOperands,
     /*  517366 */     // GIR_Coverage, 62414,
     /*  517366 */     GIR_EraseRootFromParent_Done,
     /*  517367 */   // Label 8595: @517367
     /*  517367 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(517435), // Rule ID 62415 //
     /*  517372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517404 */     // MIs[0] policy
     /*  517404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517414 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11536:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  517417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517431 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517433 */     GIR_RootConstrainSelectedInstOperands,
     /*  517434 */     // GIR_Coverage, 62415,
     /*  517434 */     GIR_EraseRootFromParent_Done,
     /*  517435 */   // Label 8596: @517435
     /*  517435 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(517503), // Rule ID 62416 //
     /*  517440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  517457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517472 */     // MIs[0] policy
     /*  517472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517482 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  517485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517499 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517501 */     GIR_RootConstrainSelectedInstOperands,
     /*  517502 */     // GIR_Coverage, 62416,
     /*  517502 */     GIR_EraseRootFromParent_Done,
     /*  517503 */   // Label 8597: @517503
     /*  517503 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(517571), // Rule ID 62417 //
     /*  517508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  517525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517540 */     // MIs[0] policy
     /*  517540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517550 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  517553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517567 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517569 */     GIR_RootConstrainSelectedInstOperands,
     /*  517570 */     // GIR_Coverage, 62417,
     /*  517570 */     GIR_EraseRootFromParent_Done,
     /*  517571 */   // Label 8598: @517571
     /*  517571 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(517639), // Rule ID 62418 //
     /*  517576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517608 */     // MIs[0] policy
     /*  517608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  517621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517635 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517637 */     GIR_RootConstrainSelectedInstOperands,
     /*  517638 */     // GIR_Coverage, 62418,
     /*  517638 */     GIR_EraseRootFromParent_Done,
     /*  517639 */   // Label 8599: @517639
     /*  517639 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(517707), // Rule ID 62419 //
     /*  517644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517676 */     // MIs[0] policy
     /*  517676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517686 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  517689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517703 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517705 */     GIR_RootConstrainSelectedInstOperands,
     /*  517706 */     // GIR_Coverage, 62419,
     /*  517706 */     GIR_EraseRootFromParent_Done,
     /*  517707 */   // Label 8600: @517707
     /*  517707 */   GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(517775), // Rule ID 62420 //
     /*  517712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517744 */     // MIs[0] policy
     /*  517744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517754 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  517757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517771 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517773 */     GIR_RootConstrainSelectedInstOperands,
     /*  517774 */     // GIR_Coverage, 62420,
     /*  517774 */     GIR_EraseRootFromParent_Done,
     /*  517775 */   // Label 8601: @517775
     /*  517775 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(517843), // Rule ID 62421 //
     /*  517780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517812 */     // MIs[0] policy
     /*  517812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517822 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  517825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517839 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517841 */     GIR_RootConstrainSelectedInstOperands,
     /*  517842 */     // GIR_Coverage, 62421,
     /*  517842 */     GIR_EraseRootFromParent_Done,
     /*  517843 */   // Label 8602: @517843
     /*  517843 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(517911), // Rule ID 62422 //
     /*  517848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517880 */     // MIs[0] policy
     /*  517880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  517893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517907 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517909 */     GIR_RootConstrainSelectedInstOperands,
     /*  517910 */     // GIR_Coverage, 62422,
     /*  517910 */     GIR_EraseRootFromParent_Done,
     /*  517911 */   // Label 8603: @517911
     /*  517911 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(517979), // Rule ID 62423 //
     /*  517916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517948 */     // MIs[0] policy
     /*  517948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517958 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11536:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  517961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517975 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517977 */     GIR_RootConstrainSelectedInstOperands,
     /*  517978 */     // GIR_Coverage, 62423,
     /*  517978 */     GIR_EraseRootFromParent_Done,
     /*  517979 */   // Label 8604: @517979
     /*  517979 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(518050), // Rule ID 2698 //
     /*  517984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  517992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  517995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  517998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  518001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518016 */     // MIs[0] round
     /*  518016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518026 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  518029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518035 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518048 */     GIR_RootConstrainSelectedInstOperands,
     /*  518049 */     // GIR_Coverage, 2698,
     /*  518049 */     GIR_EraseRootFromParent_Done,
     /*  518050 */   // Label 8605: @518050
     /*  518050 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(518121), // Rule ID 2699 //
     /*  518055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  518058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  518066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  518069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  518072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518087 */     // MIs[0] round
     /*  518087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518097 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  518100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518106 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518119 */     GIR_RootConstrainSelectedInstOperands,
     /*  518120 */     // GIR_Coverage, 2699,
     /*  518120 */     GIR_EraseRootFromParent_Done,
     /*  518121 */   // Label 8606: @518121
     /*  518121 */   GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(518192), // Rule ID 2734 //
     /*  518126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  518129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  518137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  518140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  518143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518158 */     // MIs[0] round
     /*  518158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518168 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  518171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518177 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518190 */     GIR_RootConstrainSelectedInstOperands,
     /*  518191 */     // GIR_Coverage, 2734,
     /*  518191 */     GIR_EraseRootFromParent_Done,
     /*  518192 */   // Label 8607: @518192
     /*  518192 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(518263), // Rule ID 2735 //
     /*  518197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  518200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  518208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  518211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  518214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518229 */     // MIs[0] round
     /*  518229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518239 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  518242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518248 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518261 */     GIR_RootConstrainSelectedInstOperands,
     /*  518262 */     // GIR_Coverage, 2735,
     /*  518262 */     GIR_EraseRootFromParent_Done,
     /*  518263 */   // Label 8608: @518263
     /*  518263 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(518334), // Rule ID 18992 //
     /*  518268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  518271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  518279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  518282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  518285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518300 */     // MIs[0] round
     /*  518300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518310 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  518313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518319 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518332 */     GIR_RootConstrainSelectedInstOperands,
     /*  518333 */     // GIR_Coverage, 18992,
     /*  518333 */     GIR_EraseRootFromParent_Done,
     /*  518334 */   // Label 8609: @518334
     /*  518334 */   GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(518405), // Rule ID 18993 //
     /*  518339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  518342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  518350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  518353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  518356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518371 */     // MIs[0] round
     /*  518371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518381 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  518384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518390 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518403 */     GIR_RootConstrainSelectedInstOperands,
     /*  518404 */     // GIR_Coverage, 18993,
     /*  518404 */     GIR_EraseRootFromParent_Done,
     /*  518405 */   // Label 8610: @518405
     /*  518405 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(518476), // Rule ID 18996 //
     /*  518410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  518413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  518421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  518424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  518427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518442 */     // MIs[0] round
     /*  518442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518452 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  518455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518461 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518474 */     GIR_RootConstrainSelectedInstOperands,
     /*  518475 */     // GIR_Coverage, 18996,
     /*  518475 */     GIR_EraseRootFromParent_Done,
     /*  518476 */   // Label 8611: @518476
     /*  518476 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(518547), // Rule ID 18997 //
     /*  518481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  518484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  518492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  518495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  518498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518513 */     // MIs[0] round
     /*  518513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518523 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  518526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518532 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518545 */     GIR_RootConstrainSelectedInstOperands,
     /*  518546 */     // GIR_Coverage, 18997,
     /*  518546 */     GIR_EraseRootFromParent_Done,
     /*  518547 */   // Label 8612: @518547
     /*  518547 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(518618), // Rule ID 19000 //
     /*  518552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  518555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  518563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  518566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  518569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518584 */     // MIs[0] round
     /*  518584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518594 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  518597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518603 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518616 */     GIR_RootConstrainSelectedInstOperands,
     /*  518617 */     // GIR_Coverage, 19000,
     /*  518617 */     GIR_EraseRootFromParent_Done,
     /*  518618 */   // Label 8613: @518618
     /*  518618 */   GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(518689), // Rule ID 19001 //
     /*  518623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  518626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  518634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  518637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  518640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518655 */     // MIs[0] round
     /*  518655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518665 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  518668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518674 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518687 */     GIR_RootConstrainSelectedInstOperands,
     /*  518688 */     // GIR_Coverage, 19001,
     /*  518688 */     GIR_EraseRootFromParent_Done,
     /*  518689 */   // Label 8614: @518689
     /*  518689 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(518760), // Rule ID 19004 //
     /*  518694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  518697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  518705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  518708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  518711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518726 */     // MIs[0] round
     /*  518726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518736 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  518739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518745 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518758 */     GIR_RootConstrainSelectedInstOperands,
     /*  518759 */     // GIR_Coverage, 19004,
     /*  518759 */     GIR_EraseRootFromParent_Done,
     /*  518760 */   // Label 8615: @518760
     /*  518760 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(518831), // Rule ID 19005 //
     /*  518765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  518768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  518776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  518779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  518782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518797 */     // MIs[0] round
     /*  518797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518807 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  518810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518816 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518829 */     GIR_RootConstrainSelectedInstOperands,
     /*  518830 */     // GIR_Coverage, 19005,
     /*  518830 */     GIR_EraseRootFromParent_Done,
     /*  518831 */   // Label 8616: @518831
     /*  518831 */   GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(518902), // Rule ID 19008 //
     /*  518836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  518847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  518850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  518853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518868 */     // MIs[0] round
     /*  518868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518878 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  518881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518887 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518900 */     GIR_RootConstrainSelectedInstOperands,
     /*  518901 */     // GIR_Coverage, 19008,
     /*  518901 */     GIR_EraseRootFromParent_Done,
     /*  518902 */   // Label 8617: @518902
     /*  518902 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(518973), // Rule ID 19009 //
     /*  518907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  518918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  518921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  518924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518939 */     // MIs[0] round
     /*  518939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518949 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  518952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518958 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518971 */     GIR_RootConstrainSelectedInstOperands,
     /*  518972 */     // GIR_Coverage, 19009,
     /*  518972 */     GIR_EraseRootFromParent_Done,
     /*  518973 */   // Label 8618: @518973
     /*  518973 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(519044), // Rule ID 19012 //
     /*  518978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  518981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  518989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  518992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  518995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519010 */     // MIs[0] round
     /*  519010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519020 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  519023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519029 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519042 */     GIR_RootConstrainSelectedInstOperands,
     /*  519043 */     // GIR_Coverage, 19012,
     /*  519043 */     GIR_EraseRootFromParent_Done,
     /*  519044 */   // Label 8619: @519044
     /*  519044 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(519115), // Rule ID 19013 //
     /*  519049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  519052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  519060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  519063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  519066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519081 */     // MIs[0] round
     /*  519081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519091 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  519094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519100 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519113 */     GIR_RootConstrainSelectedInstOperands,
     /*  519114 */     // GIR_Coverage, 19013,
     /*  519114 */     GIR_EraseRootFromParent_Done,
     /*  519115 */   // Label 8620: @519115
     /*  519115 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(519186), // Rule ID 19016 //
     /*  519120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  519123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  519131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  519137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519152 */     // MIs[0] round
     /*  519152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519162 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  519165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519171 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519184 */     GIR_RootConstrainSelectedInstOperands,
     /*  519185 */     // GIR_Coverage, 19016,
     /*  519185 */     GIR_EraseRootFromParent_Done,
     /*  519186 */   // Label 8621: @519186
     /*  519186 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(519257), // Rule ID 19017 //
     /*  519191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  519194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  519202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  519208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519223 */     // MIs[0] round
     /*  519223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519233 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  519236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519242 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519255 */     GIR_RootConstrainSelectedInstOperands,
     /*  519256 */     // GIR_Coverage, 19017,
     /*  519256 */     GIR_EraseRootFromParent_Done,
     /*  519257 */   // Label 8622: @519257
     /*  519257 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(519328), // Rule ID 19020 //
     /*  519262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  519265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  519273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  519276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  519279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519294 */     // MIs[0] round
     /*  519294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519304 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  519307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519313 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519326 */     GIR_RootConstrainSelectedInstOperands,
     /*  519327 */     // GIR_Coverage, 19020,
     /*  519327 */     GIR_EraseRootFromParent_Done,
     /*  519328 */   // Label 8623: @519328
     /*  519328 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(519399), // Rule ID 19021 //
     /*  519333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  519336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  519344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  519347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  519350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519365 */     // MIs[0] round
     /*  519365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519375 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  519378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519384 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519397 */     GIR_RootConstrainSelectedInstOperands,
     /*  519398 */     // GIR_Coverage, 19021,
     /*  519398 */     GIR_EraseRootFromParent_Done,
     /*  519399 */   // Label 8624: @519399
     /*  519399 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(519470), // Rule ID 19024 //
     /*  519404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  519407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  519415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  519418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  519421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519436 */     // MIs[0] round
     /*  519436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519446 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  519449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519455 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519468 */     GIR_RootConstrainSelectedInstOperands,
     /*  519469 */     // GIR_Coverage, 19024,
     /*  519469 */     GIR_EraseRootFromParent_Done,
     /*  519470 */   // Label 8625: @519470
     /*  519470 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(519541), // Rule ID 19025 //
     /*  519475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  519478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  519486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  519489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  519492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519507 */     // MIs[0] round
     /*  519507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519517 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  519520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519526 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519539 */     GIR_RootConstrainSelectedInstOperands,
     /*  519540 */     // GIR_Coverage, 19025,
     /*  519540 */     GIR_EraseRootFromParent_Done,
     /*  519541 */   // Label 8626: @519541
     /*  519541 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(519612), // Rule ID 19028 //
     /*  519546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  519549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  519557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  519560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  519563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519578 */     // MIs[0] round
     /*  519578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519588 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  519591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519597 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519610 */     GIR_RootConstrainSelectedInstOperands,
     /*  519611 */     // GIR_Coverage, 19028,
     /*  519611 */     GIR_EraseRootFromParent_Done,
     /*  519612 */   // Label 8627: @519612
     /*  519612 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(519683), // Rule ID 19029 //
     /*  519617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  519620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  519628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  519631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  519634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519649 */     // MIs[0] round
     /*  519649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519659 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  519662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519668 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519681 */     GIR_RootConstrainSelectedInstOperands,
     /*  519682 */     // GIR_Coverage, 19029,
     /*  519682 */     GIR_EraseRootFromParent_Done,
     /*  519683 */   // Label 8628: @519683
     /*  519683 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(519754), // Rule ID 19032 //
     /*  519688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  519691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  519699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  519702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  519705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519720 */     // MIs[0] round
     /*  519720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519730 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  519733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519739 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519752 */     GIR_RootConstrainSelectedInstOperands,
     /*  519753 */     // GIR_Coverage, 19032,
     /*  519753 */     GIR_EraseRootFromParent_Done,
     /*  519754 */   // Label 8629: @519754
     /*  519754 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(519825), // Rule ID 19033 //
     /*  519759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  519762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  519770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  519773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  519776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519791 */     // MIs[0] round
     /*  519791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519801 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  519804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519810 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519823 */     GIR_RootConstrainSelectedInstOperands,
     /*  519824 */     // GIR_Coverage, 19033,
     /*  519824 */     GIR_EraseRootFromParent_Done,
     /*  519825 */   // Label 8630: @519825
     /*  519825 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(519896), // Rule ID 19036 //
     /*  519830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  519833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  519841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  519844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  519847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519862 */     // MIs[0] round
     /*  519862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519872 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  519872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  519875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519881 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519894 */     GIR_RootConstrainSelectedInstOperands,
     /*  519895 */     // GIR_Coverage, 19036,
     /*  519895 */     GIR_EraseRootFromParent_Done,
     /*  519896 */   // Label 8631: @519896
     /*  519896 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(519967), // Rule ID 19037 //
     /*  519901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  519904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  519912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  519915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  519918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519933 */     // MIs[0] round
     /*  519933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519943 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  519943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  519946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519952 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519965 */     GIR_RootConstrainSelectedInstOperands,
     /*  519966 */     // GIR_Coverage, 19037,
     /*  519966 */     GIR_EraseRootFromParent_Done,
     /*  519967 */   // Label 8632: @519967
     /*  519967 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(520038), // Rule ID 19040 //
     /*  519972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  519975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  519983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  519986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  519989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520004 */     // MIs[0] round
     /*  520004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520014 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  520017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520023 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520036 */     GIR_RootConstrainSelectedInstOperands,
     /*  520037 */     // GIR_Coverage, 19040,
     /*  520037 */     GIR_EraseRootFromParent_Done,
     /*  520038 */   // Label 8633: @520038
     /*  520038 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(520109), // Rule ID 19041 //
     /*  520043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  520046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  520051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  520054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  520057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  520060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520075 */     // MIs[0] round
     /*  520075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520085 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  520088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520094 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520107 */     GIR_RootConstrainSelectedInstOperands,
     /*  520108 */     // GIR_Coverage, 19041,
     /*  520108 */     GIR_EraseRootFromParent_Done,
     /*  520109 */   // Label 8634: @520109
     /*  520109 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(520180), // Rule ID 19044 //
     /*  520114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  520117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  520122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  520125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  520131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520146 */     // MIs[0] round
     /*  520146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520156 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  520159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520165 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520178 */     GIR_RootConstrainSelectedInstOperands,
     /*  520179 */     // GIR_Coverage, 19044,
     /*  520179 */     GIR_EraseRootFromParent_Done,
     /*  520180 */   // Label 8635: @520180
     /*  520180 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(520251), // Rule ID 19045 //
     /*  520185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  520188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  520193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  520196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  520202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520217 */     // MIs[0] round
     /*  520217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520227 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  520230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520236 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520249 */     GIR_RootConstrainSelectedInstOperands,
     /*  520250 */     // GIR_Coverage, 19045,
     /*  520250 */     GIR_EraseRootFromParent_Done,
     /*  520251 */   // Label 8636: @520251
     /*  520251 */   GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(520322), // Rule ID 19104 //
     /*  520256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  520259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  520267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  520270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  520273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520288 */     // MIs[0] round
     /*  520288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520298 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  520301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520307 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520320 */     GIR_RootConstrainSelectedInstOperands,
     /*  520321 */     // GIR_Coverage, 19104,
     /*  520321 */     GIR_EraseRootFromParent_Done,
     /*  520322 */   // Label 8637: @520322
     /*  520322 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(520393), // Rule ID 19105 //
     /*  520327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  520330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  520338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  520341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  520344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520359 */     // MIs[0] round
     /*  520359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520369 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  520372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520378 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520391 */     GIR_RootConstrainSelectedInstOperands,
     /*  520392 */     // GIR_Coverage, 19105,
     /*  520392 */     GIR_EraseRootFromParent_Done,
     /*  520393 */   // Label 8638: @520393
     /*  520393 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(520464), // Rule ID 19108 //
     /*  520398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  520401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  520409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  520412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  520415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520430 */     // MIs[0] round
     /*  520430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520440 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  520443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520449 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520462 */     GIR_RootConstrainSelectedInstOperands,
     /*  520463 */     // GIR_Coverage, 19108,
     /*  520463 */     GIR_EraseRootFromParent_Done,
     /*  520464 */   // Label 8639: @520464
     /*  520464 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(520535), // Rule ID 19109 //
     /*  520469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  520472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  520480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  520483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  520486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520501 */     // MIs[0] round
     /*  520501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520511 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  520514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520520 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520533 */     GIR_RootConstrainSelectedInstOperands,
     /*  520534 */     // GIR_Coverage, 19109,
     /*  520534 */     GIR_EraseRootFromParent_Done,
     /*  520535 */   // Label 8640: @520535
     /*  520535 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(520606), // Rule ID 19112 //
     /*  520540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  520543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  520551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  520554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  520557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520572 */     // MIs[0] round
     /*  520572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520582 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  520585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520591 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520604 */     GIR_RootConstrainSelectedInstOperands,
     /*  520605 */     // GIR_Coverage, 19112,
     /*  520605 */     GIR_EraseRootFromParent_Done,
     /*  520606 */   // Label 8641: @520606
     /*  520606 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(520677), // Rule ID 19113 //
     /*  520611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  520614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  520622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  520625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  520628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520643 */     // MIs[0] round
     /*  520643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520653 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  520656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520662 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520675 */     GIR_RootConstrainSelectedInstOperands,
     /*  520676 */     // GIR_Coverage, 19113,
     /*  520676 */     GIR_EraseRootFromParent_Done,
     /*  520677 */   // Label 8642: @520677
     /*  520677 */   GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(520748), // Rule ID 19116 //
     /*  520682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  520685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  520693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  520696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  520699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520714 */     // MIs[0] round
     /*  520714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520724 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  520727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520733 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520746 */     GIR_RootConstrainSelectedInstOperands,
     /*  520747 */     // GIR_Coverage, 19116,
     /*  520747 */     GIR_EraseRootFromParent_Done,
     /*  520748 */   // Label 8643: @520748
     /*  520748 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(520819), // Rule ID 19117 //
     /*  520753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  520756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  520764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  520767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  520770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520785 */     // MIs[0] round
     /*  520785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520795 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  520798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520804 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520817 */     GIR_RootConstrainSelectedInstOperands,
     /*  520818 */     // GIR_Coverage, 19117,
     /*  520818 */     GIR_EraseRootFromParent_Done,
     /*  520819 */   // Label 8644: @520819
     /*  520819 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(520890), // Rule ID 19120 //
     /*  520824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  520827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  520835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  520838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  520841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520856 */     // MIs[0] round
     /*  520856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520866 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  520869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520875 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520888 */     GIR_RootConstrainSelectedInstOperands,
     /*  520889 */     // GIR_Coverage, 19120,
     /*  520889 */     GIR_EraseRootFromParent_Done,
     /*  520890 */   // Label 8645: @520890
     /*  520890 */   GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(520961), // Rule ID 19121 //
     /*  520895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  520898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  520906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  520909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  520912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520927 */     // MIs[0] round
     /*  520927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520937 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  520940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520946 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520959 */     GIR_RootConstrainSelectedInstOperands,
     /*  520960 */     // GIR_Coverage, 19121,
     /*  520960 */     GIR_EraseRootFromParent_Done,
     /*  520961 */   // Label 8646: @520961
     /*  520961 */   GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(521032), // Rule ID 19124 //
     /*  520966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  520969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  520977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  520980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  520983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520998 */     // MIs[0] round
     /*  520998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521008 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  521008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  521011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521017 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521030 */     GIR_RootConstrainSelectedInstOperands,
     /*  521031 */     // GIR_Coverage, 19124,
     /*  521031 */     GIR_EraseRootFromParent_Done,
     /*  521032 */   // Label 8647: @521032
     /*  521032 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(521103), // Rule ID 19125 //
     /*  521037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  521040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  521048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  521051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  521054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521069 */     // MIs[0] round
     /*  521069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521079 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  521079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  521082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521088 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521101 */     GIR_RootConstrainSelectedInstOperands,
     /*  521102 */     // GIR_Coverage, 19125,
     /*  521102 */     GIR_EraseRootFromParent_Done,
     /*  521103 */   // Label 8648: @521103
     /*  521103 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(521174), // Rule ID 19128 //
     /*  521108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  521111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  521119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  521122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  521125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521140 */     // MIs[0] round
     /*  521140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521150 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  521153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521159 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521172 */     GIR_RootConstrainSelectedInstOperands,
     /*  521173 */     // GIR_Coverage, 19128,
     /*  521173 */     GIR_EraseRootFromParent_Done,
     /*  521174 */   // Label 8649: @521174
     /*  521174 */   GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(521245), // Rule ID 19129 //
     /*  521179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  521182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  521190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  521193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  521196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521211 */     // MIs[0] round
     /*  521211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521221 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  521224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521230 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521243 */     GIR_RootConstrainSelectedInstOperands,
     /*  521244 */     // GIR_Coverage, 19129,
     /*  521244 */     GIR_EraseRootFromParent_Done,
     /*  521245 */   // Label 8650: @521245
     /*  521245 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(521316), // Rule ID 19132 //
     /*  521250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  521253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  521261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  521264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  521267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521282 */     // MIs[0] round
     /*  521282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521292 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  521295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521301 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521314 */     GIR_RootConstrainSelectedInstOperands,
     /*  521315 */     // GIR_Coverage, 19132,
     /*  521315 */     GIR_EraseRootFromParent_Done,
     /*  521316 */   // Label 8651: @521316
     /*  521316 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(521387), // Rule ID 19133 //
     /*  521321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  521324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  521332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  521335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  521338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521353 */     // MIs[0] round
     /*  521353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521363 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  521366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521372 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521385 */     GIR_RootConstrainSelectedInstOperands,
     /*  521386 */     // GIR_Coverage, 19133,
     /*  521386 */     GIR_EraseRootFromParent_Done,
     /*  521387 */   // Label 8652: @521387
     /*  521387 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(521458), // Rule ID 19136 //
     /*  521392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  521395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  521403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  521406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  521409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521424 */     // MIs[0] round
     /*  521424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521434 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  521437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521443 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521456 */     GIR_RootConstrainSelectedInstOperands,
     /*  521457 */     // GIR_Coverage, 19136,
     /*  521457 */     GIR_EraseRootFromParent_Done,
     /*  521458 */   // Label 8653: @521458
     /*  521458 */   GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(521529), // Rule ID 19137 //
     /*  521463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  521466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  521474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  521477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  521480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521495 */     // MIs[0] round
     /*  521495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521505 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  521508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521514 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521527 */     GIR_RootConstrainSelectedInstOperands,
     /*  521528 */     // GIR_Coverage, 19137,
     /*  521528 */     GIR_EraseRootFromParent_Done,
     /*  521529 */   // Label 8654: @521529
     /*  521529 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(521600), // Rule ID 19140 //
     /*  521534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  521537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  521545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  521548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  521551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521566 */     // MIs[0] round
     /*  521566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521576 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  521579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521585 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521598 */     GIR_RootConstrainSelectedInstOperands,
     /*  521599 */     // GIR_Coverage, 19140,
     /*  521599 */     GIR_EraseRootFromParent_Done,
     /*  521600 */   // Label 8655: @521600
     /*  521600 */   GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(521671), // Rule ID 19141 //
     /*  521605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  521608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  521616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  521619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  521622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521637 */     // MIs[0] round
     /*  521637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521647 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  521650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521656 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521669 */     GIR_RootConstrainSelectedInstOperands,
     /*  521670 */     // GIR_Coverage, 19141,
     /*  521670 */     GIR_EraseRootFromParent_Done,
     /*  521671 */   // Label 8656: @521671
     /*  521671 */   GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(521742), // Rule ID 19144 //
     /*  521676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  521679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  521687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  521690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  521693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521708 */     // MIs[0] round
     /*  521708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521718 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  521721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521727 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521740 */     GIR_RootConstrainSelectedInstOperands,
     /*  521741 */     // GIR_Coverage, 19144,
     /*  521741 */     GIR_EraseRootFromParent_Done,
     /*  521742 */   // Label 8657: @521742
     /*  521742 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(521813), // Rule ID 19145 //
     /*  521747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  521750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  521758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  521761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  521764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521779 */     // MIs[0] round
     /*  521779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521789 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  521792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521798 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521811 */     GIR_RootConstrainSelectedInstOperands,
     /*  521812 */     // GIR_Coverage, 19145,
     /*  521812 */     GIR_EraseRootFromParent_Done,
     /*  521813 */   // Label 8658: @521813
     /*  521813 */   GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(521884), // Rule ID 19148 //
     /*  521818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  521821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  521829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  521832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  521835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521850 */     // MIs[0] round
     /*  521850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521860 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  521863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521869 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521882 */     GIR_RootConstrainSelectedInstOperands,
     /*  521883 */     // GIR_Coverage, 19148,
     /*  521883 */     GIR_EraseRootFromParent_Done,
     /*  521884 */   // Label 8659: @521884
     /*  521884 */   GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(521955), // Rule ID 19149 //
     /*  521889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  521892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  521900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  521903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  521906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521921 */     // MIs[0] round
     /*  521921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521931 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  521934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521940 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521953 */     GIR_RootConstrainSelectedInstOperands,
     /*  521954 */     // GIR_Coverage, 19149,
     /*  521954 */     GIR_EraseRootFromParent_Done,
     /*  521955 */   // Label 8660: @521955
     /*  521955 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(522026), // Rule ID 19152 //
     /*  521960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  521963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  521971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  521974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  521977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521992 */     // MIs[0] round
     /*  521992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522002 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  522005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522011 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522024 */     GIR_RootConstrainSelectedInstOperands,
     /*  522025 */     // GIR_Coverage, 19152,
     /*  522025 */     GIR_EraseRootFromParent_Done,
     /*  522026 */   // Label 8661: @522026
     /*  522026 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(522097), // Rule ID 19153 //
     /*  522031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  522034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  522039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  522042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  522045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  522048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522063 */     // MIs[0] round
     /*  522063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522073 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  522076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522082 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522095 */     GIR_RootConstrainSelectedInstOperands,
     /*  522096 */     // GIR_Coverage, 19153,
     /*  522096 */     GIR_EraseRootFromParent_Done,
     /*  522097 */   // Label 8662: @522097
     /*  522097 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(522168), // Rule ID 19156 //
     /*  522102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  522105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  522110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  522113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  522116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  522119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522134 */     // MIs[0] round
     /*  522134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522144 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  522147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522153 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522166 */     GIR_RootConstrainSelectedInstOperands,
     /*  522167 */     // GIR_Coverage, 19156,
     /*  522167 */     GIR_EraseRootFromParent_Done,
     /*  522168 */   // Label 8663: @522168
     /*  522168 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(522239), // Rule ID 19157 //
     /*  522173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  522176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  522181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  522184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  522187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  522190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522205 */     // MIs[0] round
     /*  522205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522215 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  522218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522224 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522237 */     GIR_RootConstrainSelectedInstOperands,
     /*  522238 */     // GIR_Coverage, 19157,
     /*  522238 */     GIR_EraseRootFromParent_Done,
     /*  522239 */   // Label 8664: @522239
     /*  522239 */   GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(522310), // Rule ID 19160 //
     /*  522244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  522247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  522252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  522255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  522258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  522261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522276 */     // MIs[0] round
     /*  522276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522286 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  522289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522295 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522308 */     GIR_RootConstrainSelectedInstOperands,
     /*  522309 */     // GIR_Coverage, 19160,
     /*  522309 */     GIR_EraseRootFromParent_Done,
     /*  522310 */   // Label 8665: @522310
     /*  522310 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(522381), // Rule ID 19161 //
     /*  522315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  522318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  522323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  522326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  522329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  522332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522347 */     // MIs[0] round
     /*  522347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522357 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  522360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522366 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522379 */     GIR_RootConstrainSelectedInstOperands,
     /*  522380 */     // GIR_Coverage, 19161,
     /*  522380 */     GIR_EraseRootFromParent_Done,
     /*  522381 */   // Label 8666: @522381
     /*  522381 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(522452), // Rule ID 20746 //
     /*  522386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  522397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  522400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  522403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522418 */     // MIs[0] round
     /*  522418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522428 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  522431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522437 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522450 */     GIR_RootConstrainSelectedInstOperands,
     /*  522451 */     // GIR_Coverage, 20746,
     /*  522451 */     GIR_EraseRootFromParent_Done,
     /*  522452 */   // Label 8667: @522452
     /*  522452 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(522523), // Rule ID 20747 //
     /*  522457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  522468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  522471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  522474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522489 */     // MIs[0] round
     /*  522489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522499 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  522502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522508 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522521 */     GIR_RootConstrainSelectedInstOperands,
     /*  522522 */     // GIR_Coverage, 20747,
     /*  522522 */     GIR_EraseRootFromParent_Done,
     /*  522523 */   // Label 8668: @522523
     /*  522523 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(522594), // Rule ID 20750 //
     /*  522528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  522539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  522542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  522545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522560 */     // MIs[0] round
     /*  522560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522570 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  522573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522579 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522592 */     GIR_RootConstrainSelectedInstOperands,
     /*  522593 */     // GIR_Coverage, 20750,
     /*  522593 */     GIR_EraseRootFromParent_Done,
     /*  522594 */   // Label 8669: @522594
     /*  522594 */   GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(522665), // Rule ID 20751 //
     /*  522599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  522610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  522613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  522616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522631 */     // MIs[0] round
     /*  522631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522641 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  522644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522650 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522663 */     GIR_RootConstrainSelectedInstOperands,
     /*  522664 */     // GIR_Coverage, 20751,
     /*  522664 */     GIR_EraseRootFromParent_Done,
     /*  522665 */   // Label 8670: @522665
     /*  522665 */   GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(522736), // Rule ID 20754 //
     /*  522670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  522681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  522684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  522687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522702 */     // MIs[0] round
     /*  522702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522712 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  522715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522721 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522734 */     GIR_RootConstrainSelectedInstOperands,
     /*  522735 */     // GIR_Coverage, 20754,
     /*  522735 */     GIR_EraseRootFromParent_Done,
     /*  522736 */   // Label 8671: @522736
     /*  522736 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(522807), // Rule ID 20755 //
     /*  522741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  522752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  522755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  522758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522773 */     // MIs[0] round
     /*  522773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522783 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  522786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522792 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522805 */     GIR_RootConstrainSelectedInstOperands,
     /*  522806 */     // GIR_Coverage, 20755,
     /*  522806 */     GIR_EraseRootFromParent_Done,
     /*  522807 */   // Label 8672: @522807
     /*  522807 */   GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(522878), // Rule ID 20758 //
     /*  522812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  522823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  522826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  522829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522844 */     // MIs[0] round
     /*  522844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522854 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  522857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522863 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522876 */     GIR_RootConstrainSelectedInstOperands,
     /*  522877 */     // GIR_Coverage, 20758,
     /*  522877 */     GIR_EraseRootFromParent_Done,
     /*  522878 */   // Label 8673: @522878
     /*  522878 */   GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(522949), // Rule ID 20759 //
     /*  522883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  522894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  522897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  522900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522915 */     // MIs[0] round
     /*  522915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522925 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  522928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522934 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522947 */     GIR_RootConstrainSelectedInstOperands,
     /*  522948 */     // GIR_Coverage, 20759,
     /*  522948 */     GIR_EraseRootFromParent_Done,
     /*  522949 */   // Label 8674: @522949
     /*  522949 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(523020), // Rule ID 20762 //
     /*  522954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  522965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  522968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  522971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522986 */     // MIs[0] round
     /*  522986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522996 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  522999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523005 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523018 */     GIR_RootConstrainSelectedInstOperands,
     /*  523019 */     // GIR_Coverage, 20762,
     /*  523019 */     GIR_EraseRootFromParent_Done,
     /*  523020 */   // Label 8675: @523020
     /*  523020 */   GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(523091), // Rule ID 20763 //
     /*  523025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  523028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  523036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  523039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  523042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523057 */     // MIs[0] round
     /*  523057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523067 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  523067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  523070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523076 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523089 */     GIR_RootConstrainSelectedInstOperands,
     /*  523090 */     // GIR_Coverage, 20763,
     /*  523090 */     GIR_EraseRootFromParent_Done,
     /*  523091 */   // Label 8676: @523091
     /*  523091 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(523162), // Rule ID 20766 //
     /*  523096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  523107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  523110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  523113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523128 */     // MIs[0] round
     /*  523128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523138 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  523141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523147 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523160 */     GIR_RootConstrainSelectedInstOperands,
     /*  523161 */     // GIR_Coverage, 20766,
     /*  523161 */     GIR_EraseRootFromParent_Done,
     /*  523162 */   // Label 8677: @523162
     /*  523162 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(523233), // Rule ID 20767 //
     /*  523167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  523178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  523181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  523184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523199 */     // MIs[0] round
     /*  523199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523209 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  523212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523218 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523231 */     GIR_RootConstrainSelectedInstOperands,
     /*  523232 */     // GIR_Coverage, 20767,
     /*  523232 */     GIR_EraseRootFromParent_Done,
     /*  523233 */   // Label 8678: @523233
     /*  523233 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(523304), // Rule ID 20770 //
     /*  523238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  523249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  523252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  523255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523270 */     // MIs[0] round
     /*  523270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523280 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  523283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523289 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523302 */     GIR_RootConstrainSelectedInstOperands,
     /*  523303 */     // GIR_Coverage, 20770,
     /*  523303 */     GIR_EraseRootFromParent_Done,
     /*  523304 */   // Label 8679: @523304
     /*  523304 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(523375), // Rule ID 20771 //
     /*  523309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  523320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  523323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  523326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523341 */     // MIs[0] round
     /*  523341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523351 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  523354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523360 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523373 */     GIR_RootConstrainSelectedInstOperands,
     /*  523374 */     // GIR_Coverage, 20771,
     /*  523374 */     GIR_EraseRootFromParent_Done,
     /*  523375 */   // Label 8680: @523375
     /*  523375 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(523446), // Rule ID 20774 //
     /*  523380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  523391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  523394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  523397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523412 */     // MIs[0] round
     /*  523412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523422 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  523425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523431 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523444 */     GIR_RootConstrainSelectedInstOperands,
     /*  523445 */     // GIR_Coverage, 20774,
     /*  523445 */     GIR_EraseRootFromParent_Done,
     /*  523446 */   // Label 8681: @523446
     /*  523446 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(523517), // Rule ID 20775 //
     /*  523451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  523462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  523465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  523468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523483 */     // MIs[0] round
     /*  523483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523493 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  523496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523502 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523515 */     GIR_RootConstrainSelectedInstOperands,
     /*  523516 */     // GIR_Coverage, 20775,
     /*  523516 */     GIR_EraseRootFromParent_Done,
     /*  523517 */   // Label 8682: @523517
     /*  523517 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(523588), // Rule ID 20778 //
     /*  523522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  523533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  523536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  523539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523554 */     // MIs[0] round
     /*  523554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  523567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523573 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523586 */     GIR_RootConstrainSelectedInstOperands,
     /*  523587 */     // GIR_Coverage, 20778,
     /*  523587 */     GIR_EraseRootFromParent_Done,
     /*  523588 */   // Label 8683: @523588
     /*  523588 */   GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(523659), // Rule ID 20779 //
     /*  523593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  523604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  523607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  523610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523625 */     // MIs[0] round
     /*  523625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523635 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  523638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523644 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523657 */     GIR_RootConstrainSelectedInstOperands,
     /*  523658 */     // GIR_Coverage, 20779,
     /*  523658 */     GIR_EraseRootFromParent_Done,
     /*  523659 */   // Label 8684: @523659
     /*  523659 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(523730), // Rule ID 20782 //
     /*  523664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  523675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  523678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  523681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523696 */     // MIs[0] round
     /*  523696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523706 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  523709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523715 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523728 */     GIR_RootConstrainSelectedInstOperands,
     /*  523729 */     // GIR_Coverage, 20782,
     /*  523729 */     GIR_EraseRootFromParent_Done,
     /*  523730 */   // Label 8685: @523730
     /*  523730 */   GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(523801), // Rule ID 20783 //
     /*  523735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  523746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  523749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  523752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523767 */     // MIs[0] round
     /*  523767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523777 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  523780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523786 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523799 */     GIR_RootConstrainSelectedInstOperands,
     /*  523800 */     // GIR_Coverage, 20783,
     /*  523800 */     GIR_EraseRootFromParent_Done,
     /*  523801 */   // Label 8686: @523801
     /*  523801 */   GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(523872), // Rule ID 20786 //
     /*  523806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  523817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  523820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  523823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523838 */     // MIs[0] round
     /*  523838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523848 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  523851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523857 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523870 */     GIR_RootConstrainSelectedInstOperands,
     /*  523871 */     // GIR_Coverage, 20786,
     /*  523871 */     GIR_EraseRootFromParent_Done,
     /*  523872 */   // Label 8687: @523872
     /*  523872 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(523943), // Rule ID 20787 //
     /*  523877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  523888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  523891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  523894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523909 */     // MIs[0] round
     /*  523909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523919 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  523922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523928 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523941 */     GIR_RootConstrainSelectedInstOperands,
     /*  523942 */     // GIR_Coverage, 20787,
     /*  523942 */     GIR_EraseRootFromParent_Done,
     /*  523943 */   // Label 8688: @523943
     /*  523943 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(524014), // Rule ID 20790 //
     /*  523948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  523951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  523959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  523962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  523965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523980 */     // MIs[0] round
     /*  523980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523990 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  523990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  523993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523999 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524012 */     GIR_RootConstrainSelectedInstOperands,
     /*  524013 */     // GIR_Coverage, 20790,
     /*  524013 */     GIR_EraseRootFromParent_Done,
     /*  524014 */   // Label 8689: @524014
     /*  524014 */   GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(524085), // Rule ID 20791 //
     /*  524019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  524027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  524030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  524033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  524036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524051 */     // MIs[0] round
     /*  524051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524061 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  524064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524070 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524083 */     GIR_RootConstrainSelectedInstOperands,
     /*  524084 */     // GIR_Coverage, 20791,
     /*  524084 */     GIR_EraseRootFromParent_Done,
     /*  524085 */   // Label 8690: @524085
     /*  524085 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(524156), // Rule ID 20794 //
     /*  524090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  524098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  524101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  524104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  524107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524122 */     // MIs[0] round
     /*  524122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524132 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  524135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524141 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524154 */     GIR_RootConstrainSelectedInstOperands,
     /*  524155 */     // GIR_Coverage, 20794,
     /*  524155 */     GIR_EraseRootFromParent_Done,
     /*  524156 */   // Label 8691: @524156
     /*  524156 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(524227), // Rule ID 20795 //
     /*  524161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  524169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  524172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  524175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  524178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524193 */     // MIs[0] round
     /*  524193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524203 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  524206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524212 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524225 */     GIR_RootConstrainSelectedInstOperands,
     /*  524226 */     // GIR_Coverage, 20795,
     /*  524226 */     GIR_EraseRootFromParent_Done,
     /*  524227 */   // Label 8692: @524227
     /*  524227 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(524298), // Rule ID 20798 //
     /*  524232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  524240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  524243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  524246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  524249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524264 */     // MIs[0] round
     /*  524264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524274 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  524277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524283 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524296 */     GIR_RootConstrainSelectedInstOperands,
     /*  524297 */     // GIR_Coverage, 20798,
     /*  524297 */     GIR_EraseRootFromParent_Done,
     /*  524298 */   // Label 8693: @524298
     /*  524298 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(524369), // Rule ID 20799 //
     /*  524303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  524311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  524314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  524317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  524320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524335 */     // MIs[0] round
     /*  524335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524345 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  524348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524354 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524367 */     GIR_RootConstrainSelectedInstOperands,
     /*  524368 */     // GIR_Coverage, 20799,
     /*  524368 */     GIR_EraseRootFromParent_Done,
     /*  524369 */   // Label 8694: @524369
     /*  524369 */   GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(524440), // Rule ID 20802 //
     /*  524374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  524385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  524388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  524391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524406 */     // MIs[0] round
     /*  524406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524416 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  524419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524425 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524438 */     GIR_RootConstrainSelectedInstOperands,
     /*  524439 */     // GIR_Coverage, 20802,
     /*  524439 */     GIR_EraseRootFromParent_Done,
     /*  524440 */   // Label 8695: @524440
     /*  524440 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(524511), // Rule ID 20803 //
     /*  524445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  524456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  524459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  524462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524477 */     // MIs[0] round
     /*  524477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524487 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  524490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524496 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524509 */     GIR_RootConstrainSelectedInstOperands,
     /*  524510 */     // GIR_Coverage, 20803,
     /*  524510 */     GIR_EraseRootFromParent_Done,
     /*  524511 */   // Label 8696: @524511
     /*  524511 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(524582), // Rule ID 20806 //
     /*  524516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  524527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  524530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  524533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524548 */     // MIs[0] round
     /*  524548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524558 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  524561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524567 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524580 */     GIR_RootConstrainSelectedInstOperands,
     /*  524581 */     // GIR_Coverage, 20806,
     /*  524581 */     GIR_EraseRootFromParent_Done,
     /*  524582 */   // Label 8697: @524582
     /*  524582 */   GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(524653), // Rule ID 20807 //
     /*  524587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  524598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  524601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  524604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524619 */     // MIs[0] round
     /*  524619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524629 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  524632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524638 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524651 */     GIR_RootConstrainSelectedInstOperands,
     /*  524652 */     // GIR_Coverage, 20807,
     /*  524652 */     GIR_EraseRootFromParent_Done,
     /*  524653 */   // Label 8698: @524653
     /*  524653 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(524724), // Rule ID 20810 //
     /*  524658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  524669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  524672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  524675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524690 */     // MIs[0] round
     /*  524690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524700 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  524703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524709 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524722 */     GIR_RootConstrainSelectedInstOperands,
     /*  524723 */     // GIR_Coverage, 20810,
     /*  524723 */     GIR_EraseRootFromParent_Done,
     /*  524724 */   // Label 8699: @524724
     /*  524724 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(524795), // Rule ID 20811 //
     /*  524729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  524740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  524743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  524746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524761 */     // MIs[0] round
     /*  524761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524771 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  524774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524780 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524793 */     GIR_RootConstrainSelectedInstOperands,
     /*  524794 */     // GIR_Coverage, 20811,
     /*  524794 */     GIR_EraseRootFromParent_Done,
     /*  524795 */   // Label 8700: @524795
     /*  524795 */   GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(524866), // Rule ID 20814 //
     /*  524800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  524811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  524814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  524817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524832 */     // MIs[0] round
     /*  524832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524842 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  524845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524851 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524864 */     GIR_RootConstrainSelectedInstOperands,
     /*  524865 */     // GIR_Coverage, 20814,
     /*  524865 */     GIR_EraseRootFromParent_Done,
     /*  524866 */   // Label 8701: @524866
     /*  524866 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(524937), // Rule ID 20815 //
     /*  524871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  524882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  524885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  524888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524903 */     // MIs[0] round
     /*  524903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524913 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  524916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524922 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524935 */     GIR_RootConstrainSelectedInstOperands,
     /*  524936 */     // GIR_Coverage, 20815,
     /*  524936 */     GIR_EraseRootFromParent_Done,
     /*  524937 */   // Label 8702: @524937
     /*  524937 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(525008), // Rule ID 20818 //
     /*  524942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  524953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  524956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  524959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524974 */     // MIs[0] round
     /*  524974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  524987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524993 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525006 */     GIR_RootConstrainSelectedInstOperands,
     /*  525007 */     // GIR_Coverage, 20818,
     /*  525007 */     GIR_EraseRootFromParent_Done,
     /*  525008 */   // Label 8703: @525008
     /*  525008 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(525079), // Rule ID 20819 //
     /*  525013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  525024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  525027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  525030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525045 */     // MIs[0] round
     /*  525045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525055 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  525058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525064 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525077 */     GIR_RootConstrainSelectedInstOperands,
     /*  525078 */     // GIR_Coverage, 20819,
     /*  525078 */     GIR_EraseRootFromParent_Done,
     /*  525079 */   // Label 8704: @525079
     /*  525079 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(525150), // Rule ID 20822 //
     /*  525084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  525087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525116 */     // MIs[0] round
     /*  525116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  525126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  525129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525135 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525148 */     GIR_RootConstrainSelectedInstOperands,
     /*  525149 */     // GIR_Coverage, 20822,
     /*  525149 */     GIR_EraseRootFromParent_Done,
     /*  525150 */   // Label 8705: @525150
     /*  525150 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(525221), // Rule ID 20823 //
     /*  525155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  525158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525187 */     // MIs[0] round
     /*  525187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525197 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  525197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  525200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525206 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525219 */     GIR_RootConstrainSelectedInstOperands,
     /*  525220 */     // GIR_Coverage, 20823,
     /*  525220 */     GIR_EraseRootFromParent_Done,
     /*  525221 */   // Label 8706: @525221
     /*  525221 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(525292), // Rule ID 20826 //
     /*  525226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  525237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  525240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  525243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525258 */     // MIs[0] round
     /*  525258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525268 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  525271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525277 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525290 */     GIR_RootConstrainSelectedInstOperands,
     /*  525291 */     // GIR_Coverage, 20826,
     /*  525291 */     GIR_EraseRootFromParent_Done,
     /*  525292 */   // Label 8707: @525292
     /*  525292 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(525363), // Rule ID 20827 //
     /*  525297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  525308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  525311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  525314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525329 */     // MIs[0] round
     /*  525329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  525342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525348 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525361 */     GIR_RootConstrainSelectedInstOperands,
     /*  525362 */     // GIR_Coverage, 20827,
     /*  525362 */     GIR_EraseRootFromParent_Done,
     /*  525363 */   // Label 8708: @525363
     /*  525363 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(525434), // Rule ID 20830 //
     /*  525368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  525379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  525382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  525385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525400 */     // MIs[0] round
     /*  525400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525410 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  525413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525419 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525432 */     GIR_RootConstrainSelectedInstOperands,
     /*  525433 */     // GIR_Coverage, 20830,
     /*  525433 */     GIR_EraseRootFromParent_Done,
     /*  525434 */   // Label 8709: @525434
     /*  525434 */   GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(525505), // Rule ID 20831 //
     /*  525439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  525450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  525453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  525456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525471 */     // MIs[0] round
     /*  525471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525481 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  525484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525490 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525503 */     GIR_RootConstrainSelectedInstOperands,
     /*  525504 */     // GIR_Coverage, 20831,
     /*  525504 */     GIR_EraseRootFromParent_Done,
     /*  525505 */   // Label 8710: @525505
     /*  525505 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(525576), // Rule ID 20834 //
     /*  525510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  525521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  525524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  525527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525542 */     // MIs[0] round
     /*  525542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525552 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  525555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525561 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525574 */     GIR_RootConstrainSelectedInstOperands,
     /*  525575 */     // GIR_Coverage, 20834,
     /*  525575 */     GIR_EraseRootFromParent_Done,
     /*  525576 */   // Label 8711: @525576
     /*  525576 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(525647), // Rule ID 20835 //
     /*  525581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  525592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  525595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  525598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525613 */     // MIs[0] round
     /*  525613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525623 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  525626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525632 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525645 */     GIR_RootConstrainSelectedInstOperands,
     /*  525646 */     // GIR_Coverage, 20835,
     /*  525646 */     GIR_EraseRootFromParent_Done,
     /*  525647 */   // Label 8712: @525647
     /*  525647 */   GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(525718), // Rule ID 20838 //
     /*  525652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  525663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  525666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  525669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525684 */     // MIs[0] round
     /*  525684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  525697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525703 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525716 */     GIR_RootConstrainSelectedInstOperands,
     /*  525717 */     // GIR_Coverage, 20838,
     /*  525717 */     GIR_EraseRootFromParent_Done,
     /*  525718 */   // Label 8713: @525718
     /*  525718 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(525789), // Rule ID 20839 //
     /*  525723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  525734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  525737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  525740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525755 */     // MIs[0] round
     /*  525755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  525768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525774 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525787 */     GIR_RootConstrainSelectedInstOperands,
     /*  525788 */     // GIR_Coverage, 20839,
     /*  525788 */     GIR_EraseRootFromParent_Done,
     /*  525789 */   // Label 8714: @525789
     /*  525789 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(525860), // Rule ID 20842 //
     /*  525794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  525805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  525808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  525811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525826 */     // MIs[0] round
     /*  525826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  525839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525845 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525858 */     GIR_RootConstrainSelectedInstOperands,
     /*  525859 */     // GIR_Coverage, 20842,
     /*  525859 */     GIR_EraseRootFromParent_Done,
     /*  525860 */   // Label 8715: @525860
     /*  525860 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(525931), // Rule ID 20843 //
     /*  525865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  525876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  525879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  525882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525897 */     // MIs[0] round
     /*  525897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525907 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  525910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525916 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525929 */     GIR_RootConstrainSelectedInstOperands,
     /*  525930 */     // GIR_Coverage, 20843,
     /*  525930 */     GIR_EraseRootFromParent_Done,
     /*  525931 */   // Label 8716: @525931
     /*  525931 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(526002), // Rule ID 20846 //
     /*  525936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  525947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  525950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  525953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525968 */     // MIs[0] round
     /*  525968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525978 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  525981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525987 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526000 */     GIR_RootConstrainSelectedInstOperands,
     /*  526001 */     // GIR_Coverage, 20846,
     /*  526001 */     GIR_EraseRootFromParent_Done,
     /*  526002 */   // Label 8717: @526002
     /*  526002 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(526073), // Rule ID 20847 //
     /*  526007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  526018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  526021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  526024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526039 */     // MIs[0] round
     /*  526039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526049 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  526052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526058 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526071 */     GIR_RootConstrainSelectedInstOperands,
     /*  526072 */     // GIR_Coverage, 20847,
     /*  526072 */     GIR_EraseRootFromParent_Done,
     /*  526073 */   // Label 8718: @526073
     /*  526073 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(526144), // Rule ID 20850 //
     /*  526078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  526089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526110 */     // MIs[0] round
     /*  526110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526120 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  526123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526129 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526142 */     GIR_RootConstrainSelectedInstOperands,
     /*  526143 */     // GIR_Coverage, 20850,
     /*  526143 */     GIR_EraseRootFromParent_Done,
     /*  526144 */   // Label 8719: @526144
     /*  526144 */   GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(526215), // Rule ID 20851 //
     /*  526149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  526160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526181 */     // MIs[0] round
     /*  526181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526191 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  526194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526200 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526213 */     GIR_RootConstrainSelectedInstOperands,
     /*  526214 */     // GIR_Coverage, 20851,
     /*  526214 */     GIR_EraseRootFromParent_Done,
     /*  526215 */   // Label 8720: @526215
     /*  526215 */   GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(526286), // Rule ID 20854 //
     /*  526220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  526231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  526234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  526237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526252 */     // MIs[0] round
     /*  526252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526262 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  526265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526271 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526284 */     GIR_RootConstrainSelectedInstOperands,
     /*  526285 */     // GIR_Coverage, 20854,
     /*  526285 */     GIR_EraseRootFromParent_Done,
     /*  526286 */   // Label 8721: @526286
     /*  526286 */   GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(526357), // Rule ID 20855 //
     /*  526291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  526302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  526305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  526308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526323 */     // MIs[0] round
     /*  526323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526333 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  526336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526342 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526355 */     GIR_RootConstrainSelectedInstOperands,
     /*  526356 */     // GIR_Coverage, 20855,
     /*  526356 */     GIR_EraseRootFromParent_Done,
     /*  526357 */   // Label 8722: @526357
     /*  526357 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(526428), // Rule ID 20858 //
     /*  526362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  526373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  526376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  526379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526394 */     // MIs[0] round
     /*  526394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526404 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  526407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526413 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526426 */     GIR_RootConstrainSelectedInstOperands,
     /*  526427 */     // GIR_Coverage, 20858,
     /*  526427 */     GIR_EraseRootFromParent_Done,
     /*  526428 */   // Label 8723: @526428
     /*  526428 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(526499), // Rule ID 20859 //
     /*  526433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  526444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  526447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  526450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526465 */     // MIs[0] round
     /*  526465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526475 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  526478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526484 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526497 */     GIR_RootConstrainSelectedInstOperands,
     /*  526498 */     // GIR_Coverage, 20859,
     /*  526498 */     GIR_EraseRootFromParent_Done,
     /*  526499 */   // Label 8724: @526499
     /*  526499 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(526570), // Rule ID 20982 //
     /*  526504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  526515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  526518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  526521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526536 */     // MIs[0] round
     /*  526536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526546 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  526549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526555 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526568 */     GIR_RootConstrainSelectedInstOperands,
     /*  526569 */     // GIR_Coverage, 20982,
     /*  526569 */     GIR_EraseRootFromParent_Done,
     /*  526570 */   // Label 8725: @526570
     /*  526570 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(526641), // Rule ID 20983 //
     /*  526575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  526586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  526589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  526592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526607 */     // MIs[0] round
     /*  526607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526617 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  526620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526626 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526639 */     GIR_RootConstrainSelectedInstOperands,
     /*  526640 */     // GIR_Coverage, 20983,
     /*  526640 */     GIR_EraseRootFromParent_Done,
     /*  526641 */   // Label 8726: @526641
     /*  526641 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(526712), // Rule ID 20986 //
     /*  526646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  526657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  526660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  526663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526678 */     // MIs[0] round
     /*  526678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526688 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  526691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526697 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526710 */     GIR_RootConstrainSelectedInstOperands,
     /*  526711 */     // GIR_Coverage, 20986,
     /*  526711 */     GIR_EraseRootFromParent_Done,
     /*  526712 */   // Label 8727: @526712
     /*  526712 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(526783), // Rule ID 20987 //
     /*  526717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  526728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  526731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  526734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526749 */     // MIs[0] round
     /*  526749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526759 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  526762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526768 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526781 */     GIR_RootConstrainSelectedInstOperands,
     /*  526782 */     // GIR_Coverage, 20987,
     /*  526782 */     GIR_EraseRootFromParent_Done,
     /*  526783 */   // Label 8728: @526783
     /*  526783 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(526854), // Rule ID 20990 //
     /*  526788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  526799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  526802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  526805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526820 */     // MIs[0] round
     /*  526820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526830 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  526833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526839 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526852 */     GIR_RootConstrainSelectedInstOperands,
     /*  526853 */     // GIR_Coverage, 20990,
     /*  526853 */     GIR_EraseRootFromParent_Done,
     /*  526854 */   // Label 8729: @526854
     /*  526854 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(526925), // Rule ID 20991 //
     /*  526859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  526870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  526873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  526876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526891 */     // MIs[0] round
     /*  526891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526901 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  526904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526910 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526923 */     GIR_RootConstrainSelectedInstOperands,
     /*  526924 */     // GIR_Coverage, 20991,
     /*  526924 */     GIR_EraseRootFromParent_Done,
     /*  526925 */   // Label 8730: @526925
     /*  526925 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(526996), // Rule ID 20994 //
     /*  526930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  526941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  526944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  526947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526962 */     // MIs[0] round
     /*  526962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526972 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  526975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526981 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526994 */     GIR_RootConstrainSelectedInstOperands,
     /*  526995 */     // GIR_Coverage, 20994,
     /*  526995 */     GIR_EraseRootFromParent_Done,
     /*  526996 */   // Label 8731: @526996
     /*  526996 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(527067), // Rule ID 20995 //
     /*  527001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  527012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  527015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  527018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527033 */     // MIs[0] round
     /*  527033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527043 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  527046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527052 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527065 */     GIR_RootConstrainSelectedInstOperands,
     /*  527066 */     // GIR_Coverage, 20995,
     /*  527066 */     GIR_EraseRootFromParent_Done,
     /*  527067 */   // Label 8732: @527067
     /*  527067 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(527138), // Rule ID 20998 //
     /*  527072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  527075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  527089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527104 */     // MIs[0] round
     /*  527104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527114 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  527117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527123 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527136 */     GIR_RootConstrainSelectedInstOperands,
     /*  527137 */     // GIR_Coverage, 20998,
     /*  527137 */     GIR_EraseRootFromParent_Done,
     /*  527138 */   // Label 8733: @527138
     /*  527138 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(527209), // Rule ID 20999 //
     /*  527143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  527146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  527160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527175 */     // MIs[0] round
     /*  527175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527185 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  527185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  527188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527194 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527207 */     GIR_RootConstrainSelectedInstOperands,
     /*  527208 */     // GIR_Coverage, 20999,
     /*  527208 */     GIR_EraseRootFromParent_Done,
     /*  527209 */   // Label 8734: @527209
     /*  527209 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(527280), // Rule ID 21002 //
     /*  527214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  527217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  527225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  527228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  527231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527246 */     // MIs[0] round
     /*  527246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527256 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  527256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  527259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527265 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527278 */     GIR_RootConstrainSelectedInstOperands,
     /*  527279 */     // GIR_Coverage, 21002,
     /*  527279 */     GIR_EraseRootFromParent_Done,
     /*  527280 */   // Label 8735: @527280
     /*  527280 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(527351), // Rule ID 21003 //
     /*  527285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  527288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  527296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  527299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  527302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527317 */     // MIs[0] round
     /*  527317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527327 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  527327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  527330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527336 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527349 */     GIR_RootConstrainSelectedInstOperands,
     /*  527350 */     // GIR_Coverage, 21003,
     /*  527350 */     GIR_EraseRootFromParent_Done,
     /*  527351 */   // Label 8736: @527351
     /*  527351 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(527422), // Rule ID 21006 //
     /*  527356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  527367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  527370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  527373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527388 */     // MIs[0] round
     /*  527388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527398 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  527401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527407 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527420 */     GIR_RootConstrainSelectedInstOperands,
     /*  527421 */     // GIR_Coverage, 21006,
     /*  527421 */     GIR_EraseRootFromParent_Done,
     /*  527422 */   // Label 8737: @527422
     /*  527422 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(527493), // Rule ID 21007 //
     /*  527427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  527438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  527441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  527444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527459 */     // MIs[0] round
     /*  527459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527469 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  527472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527478 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527491 */     GIR_RootConstrainSelectedInstOperands,
     /*  527492 */     // GIR_Coverage, 21007,
     /*  527492 */     GIR_EraseRootFromParent_Done,
     /*  527493 */   // Label 8738: @527493
     /*  527493 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(527564), // Rule ID 21010 //
     /*  527498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  527509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  527512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  527515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527530 */     // MIs[0] round
     /*  527530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527540 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  527543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527549 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527562 */     GIR_RootConstrainSelectedInstOperands,
     /*  527563 */     // GIR_Coverage, 21010,
     /*  527563 */     GIR_EraseRootFromParent_Done,
     /*  527564 */   // Label 8739: @527564
     /*  527564 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(527635), // Rule ID 21011 //
     /*  527569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  527580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  527583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  527586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527601 */     // MIs[0] round
     /*  527601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527611 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  527614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527620 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527633 */     GIR_RootConstrainSelectedInstOperands,
     /*  527634 */     // GIR_Coverage, 21011,
     /*  527634 */     GIR_EraseRootFromParent_Done,
     /*  527635 */   // Label 8740: @527635
     /*  527635 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(527706), // Rule ID 21014 //
     /*  527640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  527651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  527654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  527657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527672 */     // MIs[0] round
     /*  527672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527682 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  527685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527691 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527704 */     GIR_RootConstrainSelectedInstOperands,
     /*  527705 */     // GIR_Coverage, 21014,
     /*  527705 */     GIR_EraseRootFromParent_Done,
     /*  527706 */   // Label 8741: @527706
     /*  527706 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(527777), // Rule ID 21015 //
     /*  527711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  527722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  527725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  527728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527743 */     // MIs[0] round
     /*  527743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527753 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  527756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527762 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527775 */     GIR_RootConstrainSelectedInstOperands,
     /*  527776 */     // GIR_Coverage, 21015,
     /*  527776 */     GIR_EraseRootFromParent_Done,
     /*  527777 */   // Label 8742: @527777
     /*  527777 */   GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(527848), // Rule ID 21018 //
     /*  527782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  527785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  527793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  527796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  527799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527814 */     // MIs[0] round
     /*  527814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  527827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527833 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527846 */     GIR_RootConstrainSelectedInstOperands,
     /*  527847 */     // GIR_Coverage, 21018,
     /*  527847 */     GIR_EraseRootFromParent_Done,
     /*  527848 */   // Label 8743: @527848
     /*  527848 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(527919), // Rule ID 21019 //
     /*  527853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  527856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  527864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  527867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  527870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527885 */     // MIs[0] round
     /*  527885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527895 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  527895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  527898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527904 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527917 */     GIR_RootConstrainSelectedInstOperands,
     /*  527918 */     // GIR_Coverage, 21019,
     /*  527918 */     GIR_EraseRootFromParent_Done,
     /*  527919 */   // Label 8744: @527919
     /*  527919 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(527990), // Rule ID 21022 //
     /*  527924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  527927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  527935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  527938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  527941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527956 */     // MIs[0] round
     /*  527956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527966 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  527969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527975 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527988 */     GIR_RootConstrainSelectedInstOperands,
     /*  527989 */     // GIR_Coverage, 21022,
     /*  527989 */     GIR_EraseRootFromParent_Done,
     /*  527990 */   // Label 8745: @527990
     /*  527990 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(528061), // Rule ID 21023 //
     /*  527995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  527998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  528006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  528009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  528012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528027 */     // MIs[0] round
     /*  528027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528037 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  528040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528046 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528059 */     GIR_RootConstrainSelectedInstOperands,
     /*  528060 */     // GIR_Coverage, 21023,
     /*  528060 */     GIR_EraseRootFromParent_Done,
     /*  528061 */   // Label 8746: @528061
     /*  528061 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(528132), // Rule ID 21026 //
     /*  528066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  528069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  528077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  528080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  528083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528098 */     // MIs[0] round
     /*  528098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528108 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  528111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528117 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528130 */     GIR_RootConstrainSelectedInstOperands,
     /*  528131 */     // GIR_Coverage, 21026,
     /*  528131 */     GIR_EraseRootFromParent_Done,
     /*  528132 */   // Label 8747: @528132
     /*  528132 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(528203), // Rule ID 21027 //
     /*  528137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  528140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  528148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  528151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  528154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528169 */     // MIs[0] round
     /*  528169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528179 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  528182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528188 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528201 */     GIR_RootConstrainSelectedInstOperands,
     /*  528202 */     // GIR_Coverage, 21027,
     /*  528202 */     GIR_EraseRootFromParent_Done,
     /*  528203 */   // Label 8748: @528203
     /*  528203 */   GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(528274), // Rule ID 21030 //
     /*  528208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  528211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  528219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  528222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  528225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528240 */     // MIs[0] round
     /*  528240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  528250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  528253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528259 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528272 */     GIR_RootConstrainSelectedInstOperands,
     /*  528273 */     // GIR_Coverage, 21030,
     /*  528273 */     GIR_EraseRootFromParent_Done,
     /*  528274 */   // Label 8749: @528274
     /*  528274 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(528345), // Rule ID 21031 //
     /*  528279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  528282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  528290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  528293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  528296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528311 */     // MIs[0] round
     /*  528311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528321 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  528321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  528324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528330 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528343 */     GIR_RootConstrainSelectedInstOperands,
     /*  528344 */     // GIR_Coverage, 21031,
     /*  528344 */     GIR_EraseRootFromParent_Done,
     /*  528345 */   // Label 8750: @528345
     /*  528345 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(528416), // Rule ID 21034 //
     /*  528350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  528353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  528361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  528364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  528367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528382 */     // MIs[0] round
     /*  528382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528392 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  528392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  528395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528401 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528414 */     GIR_RootConstrainSelectedInstOperands,
     /*  528415 */     // GIR_Coverage, 21034,
     /*  528415 */     GIR_EraseRootFromParent_Done,
     /*  528416 */   // Label 8751: @528416
     /*  528416 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(528487), // Rule ID 21035 //
     /*  528421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  528424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  528432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  528435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  528438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528453 */     // MIs[0] round
     /*  528453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528463 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  528463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  528466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528472 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528485 */     GIR_RootConstrainSelectedInstOperands,
     /*  528486 */     // GIR_Coverage, 21035,
     /*  528486 */     GIR_EraseRootFromParent_Done,
     /*  528487 */   // Label 8752: @528487
     /*  528487 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(528558), // Rule ID 21038 //
     /*  528492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  528495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  528509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528524 */     // MIs[0] round
     /*  528524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528534 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  528534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  528537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528543 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528556 */     GIR_RootConstrainSelectedInstOperands,
     /*  528557 */     // GIR_Coverage, 21038,
     /*  528557 */     GIR_EraseRootFromParent_Done,
     /*  528558 */   // Label 8753: @528558
     /*  528558 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(528629), // Rule ID 21039 //
     /*  528563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  528566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  528580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528595 */     // MIs[0] round
     /*  528595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528605 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  528605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  528608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528614 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528627 */     GIR_RootConstrainSelectedInstOperands,
     /*  528628 */     // GIR_Coverage, 21039,
     /*  528628 */     GIR_EraseRootFromParent_Done,
     /*  528629 */   // Label 8754: @528629
     /*  528629 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(528700), // Rule ID 21042 //
     /*  528634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  528642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  528645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  528648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  528651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528666 */     // MIs[0] round
     /*  528666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528676 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  528679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528685 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528698 */     GIR_RootConstrainSelectedInstOperands,
     /*  528699 */     // GIR_Coverage, 21042,
     /*  528699 */     GIR_EraseRootFromParent_Done,
     /*  528700 */   // Label 8755: @528700
     /*  528700 */   GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(528771), // Rule ID 21043 //
     /*  528705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  528713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  528716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  528719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  528722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528737 */     // MIs[0] round
     /*  528737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528747 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  528750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528756 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528769 */     GIR_RootConstrainSelectedInstOperands,
     /*  528770 */     // GIR_Coverage, 21043,
     /*  528770 */     GIR_EraseRootFromParent_Done,
     /*  528771 */   // Label 8756: @528771
     /*  528771 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(528842), // Rule ID 21046 //
     /*  528776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  528784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  528787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  528790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  528793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528808 */     // MIs[0] round
     /*  528808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528818 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  528821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528827 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528840 */     GIR_RootConstrainSelectedInstOperands,
     /*  528841 */     // GIR_Coverage, 21046,
     /*  528841 */     GIR_EraseRootFromParent_Done,
     /*  528842 */   // Label 8757: @528842
     /*  528842 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(528913), // Rule ID 21047 //
     /*  528847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  528855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  528858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  528861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  528864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528879 */     // MIs[0] round
     /*  528879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528889 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  528892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528898 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528911 */     GIR_RootConstrainSelectedInstOperands,
     /*  528912 */     // GIR_Coverage, 21047,
     /*  528912 */     GIR_EraseRootFromParent_Done,
     /*  528913 */   // Label 8758: @528913
     /*  528913 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(528984), // Rule ID 21050 //
     /*  528918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  528921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  528926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  528929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  528932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  528935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528950 */     // MIs[0] round
     /*  528950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528960 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  528963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528969 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528982 */     GIR_RootConstrainSelectedInstOperands,
     /*  528983 */     // GIR_Coverage, 21050,
     /*  528983 */     GIR_EraseRootFromParent_Done,
     /*  528984 */   // Label 8759: @528984
     /*  528984 */   GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(529055), // Rule ID 21051 //
     /*  528989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  528992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  528997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  529000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  529003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  529006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529021 */     // MIs[0] round
     /*  529021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529031 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  529034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529040 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529053 */     GIR_RootConstrainSelectedInstOperands,
     /*  529054 */     // GIR_Coverage, 21051,
     /*  529054 */     GIR_EraseRootFromParent_Done,
     /*  529055 */   // Label 8760: @529055
     /*  529055 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(529126), // Rule ID 21054 //
     /*  529060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  529071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  529074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  529077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529092 */     // MIs[0] round
     /*  529092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  529105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529111 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529124 */     GIR_RootConstrainSelectedInstOperands,
     /*  529125 */     // GIR_Coverage, 21054,
     /*  529125 */     GIR_EraseRootFromParent_Done,
     /*  529126 */   // Label 8761: @529126
     /*  529126 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(529197), // Rule ID 21055 //
     /*  529131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  529142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  529145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  529148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529163 */     // MIs[0] round
     /*  529163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529173 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  529176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529182 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529195 */     GIR_RootConstrainSelectedInstOperands,
     /*  529196 */     // GIR_Coverage, 21055,
     /*  529196 */     GIR_EraseRootFromParent_Done,
     /*  529197 */   // Label 8762: @529197
     /*  529197 */   GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(529268), // Rule ID 21058 //
     /*  529202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  529205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  529213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  529216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  529219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529234 */     // MIs[0] round
     /*  529234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529244 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  529247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529253 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529266 */     GIR_RootConstrainSelectedInstOperands,
     /*  529267 */     // GIR_Coverage, 21058,
     /*  529267 */     GIR_EraseRootFromParent_Done,
     /*  529268 */   // Label 8763: @529268
     /*  529268 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(529339), // Rule ID 21059 //
     /*  529273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  529276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  529284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  529287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  529290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529305 */     // MIs[0] round
     /*  529305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529315 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  529318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529324 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529337 */     GIR_RootConstrainSelectedInstOperands,
     /*  529338 */     // GIR_Coverage, 21059,
     /*  529338 */     GIR_EraseRootFromParent_Done,
     /*  529339 */   // Label 8764: @529339
     /*  529339 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(529410), // Rule ID 21062 //
     /*  529344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  529347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  529355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  529358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  529361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529376 */     // MIs[0] round
     /*  529376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529386 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  529386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  529389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529395 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  529405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529408 */     GIR_RootConstrainSelectedInstOperands,
     /*  529409 */     // GIR_Coverage, 21062,
     /*  529409 */     GIR_EraseRootFromParent_Done,
     /*  529410 */   // Label 8765: @529410
     /*  529410 */   GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(529481), // Rule ID 21063 //
     /*  529415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  529418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  529426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  529429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  529432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529447 */     // MIs[0] round
     /*  529447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529457 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  529457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  529460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529466 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  529476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529479 */     GIR_RootConstrainSelectedInstOperands,
     /*  529480 */     // GIR_Coverage, 21063,
     /*  529480 */     GIR_EraseRootFromParent_Done,
     /*  529481 */   // Label 8766: @529481
     /*  529481 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(529552), // Rule ID 21066 //
     /*  529486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  529497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  529500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529518 */     // MIs[0] round
     /*  529518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529528 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  529531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529537 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529550 */     GIR_RootConstrainSelectedInstOperands,
     /*  529551 */     // GIR_Coverage, 21066,
     /*  529551 */     GIR_EraseRootFromParent_Done,
     /*  529552 */   // Label 8767: @529552
     /*  529552 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(529623), // Rule ID 21067 //
     /*  529557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  529568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  529571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529589 */     // MIs[0] round
     /*  529589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529599 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  529602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529608 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529621 */     GIR_RootConstrainSelectedInstOperands,
     /*  529622 */     // GIR_Coverage, 21067,
     /*  529622 */     GIR_EraseRootFromParent_Done,
     /*  529623 */   // Label 8768: @529623
     /*  529623 */   GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(529694), // Rule ID 21070 //
     /*  529628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  529639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  529642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  529645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529660 */     // MIs[0] round
     /*  529660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529670 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  529673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529679 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529692 */     GIR_RootConstrainSelectedInstOperands,
     /*  529693 */     // GIR_Coverage, 21070,
     /*  529693 */     GIR_EraseRootFromParent_Done,
     /*  529694 */   // Label 8769: @529694
     /*  529694 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(529765), // Rule ID 21071 //
     /*  529699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  529710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  529713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  529716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529731 */     // MIs[0] round
     /*  529731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529741 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  529744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529750 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529763 */     GIR_RootConstrainSelectedInstOperands,
     /*  529764 */     // GIR_Coverage, 21071,
     /*  529764 */     GIR_EraseRootFromParent_Done,
     /*  529765 */   // Label 8770: @529765
     /*  529765 */   GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(529836), // Rule ID 21074 //
     /*  529770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  529781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  529784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  529787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529802 */     // MIs[0] round
     /*  529802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529812 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  529815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529821 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529834 */     GIR_RootConstrainSelectedInstOperands,
     /*  529835 */     // GIR_Coverage, 21074,
     /*  529835 */     GIR_EraseRootFromParent_Done,
     /*  529836 */   // Label 8771: @529836
     /*  529836 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(529907), // Rule ID 21075 //
     /*  529841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  529852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  529855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  529858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529873 */     // MIs[0] round
     /*  529873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529883 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  529886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529892 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529905 */     GIR_RootConstrainSelectedInstOperands,
     /*  529906 */     // GIR_Coverage, 21075,
     /*  529906 */     GIR_EraseRootFromParent_Done,
     /*  529907 */   // Label 8772: @529907
     /*  529907 */   GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(529978), // Rule ID 21078 //
     /*  529912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  529915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  529923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  529926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  529929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529944 */     // MIs[0] round
     /*  529944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529954 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  529957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529963 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529976 */     GIR_RootConstrainSelectedInstOperands,
     /*  529977 */     // GIR_Coverage, 21078,
     /*  529977 */     GIR_EraseRootFromParent_Done,
     /*  529978 */   // Label 8773: @529978
     /*  529978 */   GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(530049), // Rule ID 21079 //
     /*  529983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  529986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  529994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  529997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  530000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530015 */     // MIs[0] round
     /*  530015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530025 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  530025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  530028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530034 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530047 */     GIR_RootConstrainSelectedInstOperands,
     /*  530048 */     // GIR_Coverage, 21079,
     /*  530048 */     GIR_EraseRootFromParent_Done,
     /*  530049 */   // Label 8774: @530049
     /*  530049 */   GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(530120), // Rule ID 21082 //
     /*  530054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  530065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  530068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  530071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530086 */     // MIs[0] round
     /*  530086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530096 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  530096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  530099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530105 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530118 */     GIR_RootConstrainSelectedInstOperands,
     /*  530119 */     // GIR_Coverage, 21082,
     /*  530119 */     GIR_EraseRootFromParent_Done,
     /*  530120 */   // Label 8775: @530120
     /*  530120 */   GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(530191), // Rule ID 21083 //
     /*  530125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  530136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  530139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  530142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530157 */     // MIs[0] round
     /*  530157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530167 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  530167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  530170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530176 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530189 */     GIR_RootConstrainSelectedInstOperands,
     /*  530190 */     // GIR_Coverage, 21083,
     /*  530190 */     GIR_EraseRootFromParent_Done,
     /*  530191 */   // Label 8776: @530191
     /*  530191 */   GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(530262), // Rule ID 21086 //
     /*  530196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  530207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  530210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  530213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530228 */     // MIs[0] round
     /*  530228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530238 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  530238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  530241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530247 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530260 */     GIR_RootConstrainSelectedInstOperands,
     /*  530261 */     // GIR_Coverage, 21086,
     /*  530261 */     GIR_EraseRootFromParent_Done,
     /*  530262 */   // Label 8777: @530262
     /*  530262 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(530333), // Rule ID 21087 //
     /*  530267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  530278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  530281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  530284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530299 */     // MIs[0] round
     /*  530299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530309 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  530309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  530312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530318 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530331 */     GIR_RootConstrainSelectedInstOperands,
     /*  530332 */     // GIR_Coverage, 21087,
     /*  530332 */     GIR_EraseRootFromParent_Done,
     /*  530333 */   // Label 8778: @530333
     /*  530333 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(530404), // Rule ID 21090 //
     /*  530338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  530341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  530349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  530352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  530355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530370 */     // MIs[0] round
     /*  530370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530380 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  530380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  530383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530389 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530402 */     GIR_RootConstrainSelectedInstOperands,
     /*  530403 */     // GIR_Coverage, 21090,
     /*  530403 */     GIR_EraseRootFromParent_Done,
     /*  530404 */   // Label 8779: @530404
     /*  530404 */   GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(530475), // Rule ID 21091 //
     /*  530409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  530412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  530420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  530423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  530426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530441 */     // MIs[0] round
     /*  530441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530451 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  530451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  530454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530460 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530473 */     GIR_RootConstrainSelectedInstOperands,
     /*  530474 */     // GIR_Coverage, 21091,
     /*  530474 */     GIR_EraseRootFromParent_Done,
     /*  530475 */   // Label 8780: @530475
     /*  530475 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(530546), // Rule ID 21094 //
     /*  530480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  530483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  530491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  530494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  530497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530512 */     // MIs[0] round
     /*  530512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530522 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  530522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  530525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530531 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530544 */     GIR_RootConstrainSelectedInstOperands,
     /*  530545 */     // GIR_Coverage, 21094,
     /*  530545 */     GIR_EraseRootFromParent_Done,
     /*  530546 */   // Label 8781: @530546
     /*  530546 */   GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(530617), // Rule ID 21095 //
     /*  530551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  530554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  530562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  530565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  530568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530583 */     // MIs[0] round
     /*  530583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530593 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  530593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  530596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530602 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530615 */     GIR_RootConstrainSelectedInstOperands,
     /*  530616 */     // GIR_Coverage, 21095,
     /*  530616 */     GIR_EraseRootFromParent_Done,
     /*  530617 */   // Label 8782: @530617
     /*  530617 */   GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(530688), // Rule ID 21098 //
     /*  530622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  530625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  530633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  530636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  530639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530654 */     // MIs[0] round
     /*  530654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530664 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  530664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  530667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530673 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530686 */     GIR_RootConstrainSelectedInstOperands,
     /*  530687 */     // GIR_Coverage, 21098,
     /*  530687 */     GIR_EraseRootFromParent_Done,
     /*  530688 */   // Label 8783: @530688
     /*  530688 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(530759), // Rule ID 21099 //
     /*  530693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  530696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  530704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  530707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  530710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530725 */     // MIs[0] round
     /*  530725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530735 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  530735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  530738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530744 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530757 */     GIR_RootConstrainSelectedInstOperands,
     /*  530758 */     // GIR_Coverage, 21099,
     /*  530758 */     GIR_EraseRootFromParent_Done,
     /*  530759 */   // Label 8784: @530759
     /*  530759 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(530830), // Rule ID 21174 //
     /*  530764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  530772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  530775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  530778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  530781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530796 */     // MIs[0] round
     /*  530796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530806 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  530809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530815 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530828 */     GIR_RootConstrainSelectedInstOperands,
     /*  530829 */     // GIR_Coverage, 21174,
     /*  530829 */     GIR_EraseRootFromParent_Done,
     /*  530830 */   // Label 8785: @530830
     /*  530830 */   GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(530901), // Rule ID 21175 //
     /*  530835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  530843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  530846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  530849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  530852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530867 */     // MIs[0] round
     /*  530867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530877 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  530880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530886 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530899 */     GIR_RootConstrainSelectedInstOperands,
     /*  530900 */     // GIR_Coverage, 21175,
     /*  530900 */     GIR_EraseRootFromParent_Done,
     /*  530901 */   // Label 8786: @530901
     /*  530901 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(530972), // Rule ID 21178 //
     /*  530906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  530914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  530917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  530920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  530923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530938 */     // MIs[0] round
     /*  530938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530948 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  530951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530957 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530970 */     GIR_RootConstrainSelectedInstOperands,
     /*  530971 */     // GIR_Coverage, 21178,
     /*  530971 */     GIR_EraseRootFromParent_Done,
     /*  530972 */   // Label 8787: @530972
     /*  530972 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(531043), // Rule ID 21179 //
     /*  530977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  530985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  530988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  530991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  530994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531009 */     // MIs[0] round
     /*  531009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531019 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  531022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531028 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531041 */     GIR_RootConstrainSelectedInstOperands,
     /*  531042 */     // GIR_Coverage, 21179,
     /*  531042 */     GIR_EraseRootFromParent_Done,
     /*  531043 */   // Label 8788: @531043
     /*  531043 */   GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(531114), // Rule ID 21182 //
     /*  531048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  531059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  531062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  531065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531080 */     // MIs[0] round
     /*  531080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  531093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531099 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531112 */     GIR_RootConstrainSelectedInstOperands,
     /*  531113 */     // GIR_Coverage, 21182,
     /*  531113 */     GIR_EraseRootFromParent_Done,
     /*  531114 */   // Label 8789: @531114
     /*  531114 */   GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(531185), // Rule ID 21183 //
     /*  531119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  531130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  531133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  531136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531151 */     // MIs[0] round
     /*  531151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  531164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531170 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531183 */     GIR_RootConstrainSelectedInstOperands,
     /*  531184 */     // GIR_Coverage, 21183,
     /*  531184 */     GIR_EraseRootFromParent_Done,
     /*  531185 */   // Label 8790: @531185
     /*  531185 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(531256), // Rule ID 21186 //
     /*  531190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  531201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  531204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  531207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531222 */     // MIs[0] round
     /*  531222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531232 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  531235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531241 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531254 */     GIR_RootConstrainSelectedInstOperands,
     /*  531255 */     // GIR_Coverage, 21186,
     /*  531255 */     GIR_EraseRootFromParent_Done,
     /*  531256 */   // Label 8791: @531256
     /*  531256 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(531327), // Rule ID 21187 //
     /*  531261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  531272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  531275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  531278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531293 */     // MIs[0] round
     /*  531293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531303 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  531306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531312 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531325 */     GIR_RootConstrainSelectedInstOperands,
     /*  531326 */     // GIR_Coverage, 21187,
     /*  531326 */     GIR_EraseRootFromParent_Done,
     /*  531327 */   // Label 8792: @531327
     /*  531327 */   GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(531398), // Rule ID 21190 //
     /*  531332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  531343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  531346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  531349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531364 */     // MIs[0] round
     /*  531364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531374 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  531377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531383 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531396 */     GIR_RootConstrainSelectedInstOperands,
     /*  531397 */     // GIR_Coverage, 21190,
     /*  531397 */     GIR_EraseRootFromParent_Done,
     /*  531398 */   // Label 8793: @531398
     /*  531398 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(531469), // Rule ID 21191 //
     /*  531403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  531414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  531417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  531420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531435 */     // MIs[0] round
     /*  531435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531445 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  531448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531454 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531467 */     GIR_RootConstrainSelectedInstOperands,
     /*  531468 */     // GIR_Coverage, 21191,
     /*  531468 */     GIR_EraseRootFromParent_Done,
     /*  531469 */   // Label 8794: @531469
     /*  531469 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(531540), // Rule ID 21194 //
     /*  531474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  531477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  531485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  531488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  531491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531506 */     // MIs[0] round
     /*  531506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531516 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  531519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531525 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531538 */     GIR_RootConstrainSelectedInstOperands,
     /*  531539 */     // GIR_Coverage, 21194,
     /*  531539 */     GIR_EraseRootFromParent_Done,
     /*  531540 */   // Label 8795: @531540
     /*  531540 */   GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(531611), // Rule ID 21195 //
     /*  531545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  531548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  531556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  531559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  531562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531577 */     // MIs[0] round
     /*  531577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531587 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  531590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531596 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531609 */     GIR_RootConstrainSelectedInstOperands,
     /*  531610 */     // GIR_Coverage, 21195,
     /*  531610 */     GIR_EraseRootFromParent_Done,
     /*  531611 */   // Label 8796: @531611
     /*  531611 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(531682), // Rule ID 21198 //
     /*  531616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  531619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  531627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  531630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  531633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531648 */     // MIs[0] round
     /*  531648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531658 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  531661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531667 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531680 */     GIR_RootConstrainSelectedInstOperands,
     /*  531681 */     // GIR_Coverage, 21198,
     /*  531681 */     GIR_EraseRootFromParent_Done,
     /*  531682 */   // Label 8797: @531682
     /*  531682 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(531753), // Rule ID 21199 //
     /*  531687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  531690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  531698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  531701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  531704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531719 */     // MIs[0] round
     /*  531719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531729 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  531732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531738 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531751 */     GIR_RootConstrainSelectedInstOperands,
     /*  531752 */     // GIR_Coverage, 21199,
     /*  531752 */     GIR_EraseRootFromParent_Done,
     /*  531753 */   // Label 8798: @531753
     /*  531753 */   GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(531824), // Rule ID 21202 //
     /*  531758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  531761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  531769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  531772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  531775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531790 */     // MIs[0] round
     /*  531790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531800 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  531803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531809 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531822 */     GIR_RootConstrainSelectedInstOperands,
     /*  531823 */     // GIR_Coverage, 21202,
     /*  531823 */     GIR_EraseRootFromParent_Done,
     /*  531824 */   // Label 8799: @531824
     /*  531824 */   GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(531895), // Rule ID 21203 //
     /*  531829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  531832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  531840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  531843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  531846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531861 */     // MIs[0] round
     /*  531861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531871 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  531874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531880 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531893 */     GIR_RootConstrainSelectedInstOperands,
     /*  531894 */     // GIR_Coverage, 21203,
     /*  531894 */     GIR_EraseRootFromParent_Done,
     /*  531895 */   // Label 8800: @531895
     /*  531895 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(531966), // Rule ID 21206 //
     /*  531900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  531903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  531911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  531914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  531917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531932 */     // MIs[0] round
     /*  531932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  531945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531951 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531964 */     GIR_RootConstrainSelectedInstOperands,
     /*  531965 */     // GIR_Coverage, 21206,
     /*  531965 */     GIR_EraseRootFromParent_Done,
     /*  531966 */   // Label 8801: @531966
     /*  531966 */   GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(532037), // Rule ID 21207 //
     /*  531971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  531974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  531982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  531985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  531988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532003 */     // MIs[0] round
     /*  532003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532013 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  532013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  532016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532022 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532035 */     GIR_RootConstrainSelectedInstOperands,
     /*  532036 */     // GIR_Coverage, 21207,
     /*  532036 */     GIR_EraseRootFromParent_Done,
     /*  532037 */   // Label 8802: @532037
     /*  532037 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(532108), // Rule ID 21210 //
     /*  532042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  532053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  532056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  532059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532074 */     // MIs[0] round
     /*  532074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  532087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532093 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532106 */     GIR_RootConstrainSelectedInstOperands,
     /*  532107 */     // GIR_Coverage, 21210,
     /*  532107 */     GIR_EraseRootFromParent_Done,
     /*  532108 */   // Label 8803: @532108
     /*  532108 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(532179), // Rule ID 21211 //
     /*  532113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  532124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  532127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  532130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532145 */     // MIs[0] round
     /*  532145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532155 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  532158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532164 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532177 */     GIR_RootConstrainSelectedInstOperands,
     /*  532178 */     // GIR_Coverage, 21211,
     /*  532178 */     GIR_EraseRootFromParent_Done,
     /*  532179 */   // Label 8804: @532179
     /*  532179 */   GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(532250), // Rule ID 21214 //
     /*  532184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  532195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  532198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  532201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532216 */     // MIs[0] round
     /*  532216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532226 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  532229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532235 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532248 */     GIR_RootConstrainSelectedInstOperands,
     /*  532249 */     // GIR_Coverage, 21214,
     /*  532249 */     GIR_EraseRootFromParent_Done,
     /*  532250 */   // Label 8805: @532250
     /*  532250 */   GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(532321), // Rule ID 21215 //
     /*  532255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  532266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  532269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  532272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532287 */     // MIs[0] round
     /*  532287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532297 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  532300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532306 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532319 */     GIR_RootConstrainSelectedInstOperands,
     /*  532320 */     // GIR_Coverage, 21215,
     /*  532320 */     GIR_EraseRootFromParent_Done,
     /*  532321 */   // Label 8806: @532321
     /*  532321 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(532392), // Rule ID 21218 //
     /*  532326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  532337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  532340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  532343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532358 */     // MIs[0] round
     /*  532358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  532371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532377 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532390 */     GIR_RootConstrainSelectedInstOperands,
     /*  532391 */     // GIR_Coverage, 21218,
     /*  532391 */     GIR_EraseRootFromParent_Done,
     /*  532392 */   // Label 8807: @532392
     /*  532392 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(532463), // Rule ID 21219 //
     /*  532397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  532408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  532411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  532414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532429 */     // MIs[0] round
     /*  532429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  532442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532448 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532461 */     GIR_RootConstrainSelectedInstOperands,
     /*  532462 */     // GIR_Coverage, 21219,
     /*  532462 */     GIR_EraseRootFromParent_Done,
     /*  532463 */   // Label 8808: @532463
     /*  532463 */   GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(532534), // Rule ID 21222 //
     /*  532468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  532479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  532482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532500 */     // MIs[0] round
     /*  532500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532510 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  532513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532519 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532532 */     GIR_RootConstrainSelectedInstOperands,
     /*  532533 */     // GIR_Coverage, 21222,
     /*  532533 */     GIR_EraseRootFromParent_Done,
     /*  532534 */   // Label 8809: @532534
     /*  532534 */   GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(532605), // Rule ID 21223 //
     /*  532539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  532550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  532553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532571 */     // MIs[0] round
     /*  532571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532581 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  532584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532590 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532603 */     GIR_RootConstrainSelectedInstOperands,
     /*  532604 */     // GIR_Coverage, 21223,
     /*  532604 */     GIR_EraseRootFromParent_Done,
     /*  532605 */   // Label 8810: @532605
     /*  532605 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(532676), // Rule ID 21226 //
     /*  532610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  532621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  532624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532642 */     // MIs[0] round
     /*  532642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532652 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  532655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532661 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532674 */     GIR_RootConstrainSelectedInstOperands,
     /*  532675 */     // GIR_Coverage, 21226,
     /*  532675 */     GIR_EraseRootFromParent_Done,
     /*  532676 */   // Label 8811: @532676
     /*  532676 */   GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(532747), // Rule ID 21227 //
     /*  532681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  532692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  532695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532713 */     // MIs[0] round
     /*  532713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532723 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  532726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532732 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532745 */     GIR_RootConstrainSelectedInstOperands,
     /*  532746 */     // GIR_Coverage, 21227,
     /*  532746 */     GIR_EraseRootFromParent_Done,
     /*  532747 */   // Label 8812: @532747
     /*  532747 */   GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(532818), // Rule ID 21230 //
     /*  532752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  532755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  532763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  532766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  532769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532784 */     // MIs[0] round
     /*  532784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532794 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  532794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  532797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532803 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532816 */     GIR_RootConstrainSelectedInstOperands,
     /*  532817 */     // GIR_Coverage, 21230,
     /*  532817 */     GIR_EraseRootFromParent_Done,
     /*  532818 */   // Label 8813: @532818
     /*  532818 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(532889), // Rule ID 21231 //
     /*  532823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  532826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  532834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  532837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  532840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532855 */     // MIs[0] round
     /*  532855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532865 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  532865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  532868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532874 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532887 */     GIR_RootConstrainSelectedInstOperands,
     /*  532888 */     // GIR_Coverage, 21231,
     /*  532888 */     GIR_EraseRootFromParent_Done,
     /*  532889 */   // Label 8814: @532889
     /*  532889 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(532960), // Rule ID 21234 //
     /*  532894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  532897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  532905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  532908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  532911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532926 */     // MIs[0] round
     /*  532926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532936 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  532936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  532939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532945 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532958 */     GIR_RootConstrainSelectedInstOperands,
     /*  532959 */     // GIR_Coverage, 21234,
     /*  532959 */     GIR_EraseRootFromParent_Done,
     /*  532960 */   // Label 8815: @532960
     /*  532960 */   GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(533031), // Rule ID 21235 //
     /*  532965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  532968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  532976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  532979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  532982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532997 */     // MIs[0] round
     /*  532997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533007 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  533010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533016 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533029 */     GIR_RootConstrainSelectedInstOperands,
     /*  533030 */     // GIR_Coverage, 21235,
     /*  533030 */     GIR_EraseRootFromParent_Done,
     /*  533031 */   // Label 8816: @533031
     /*  533031 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(533102), // Rule ID 21238 //
     /*  533036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  533039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  533044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  533047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  533050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  533053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533068 */     // MIs[0] round
     /*  533068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533078 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  533081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533087 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533100 */     GIR_RootConstrainSelectedInstOperands,
     /*  533101 */     // GIR_Coverage, 21238,
     /*  533101 */     GIR_EraseRootFromParent_Done,
     /*  533102 */   // Label 8817: @533102
     /*  533102 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(533173), // Rule ID 21239 //
     /*  533107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  533110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  533115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  533118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  533121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  533124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533139 */     // MIs[0] round
     /*  533139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533149 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  533152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533158 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533171 */     GIR_RootConstrainSelectedInstOperands,
     /*  533172 */     // GIR_Coverage, 21239,
     /*  533172 */     GIR_EraseRootFromParent_Done,
     /*  533173 */   // Label 8818: @533173
     /*  533173 */   GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(533244), // Rule ID 21242 //
     /*  533178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  533181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  533186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  533189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  533192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  533195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533210 */     // MIs[0] round
     /*  533210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  533223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533229 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533242 */     GIR_RootConstrainSelectedInstOperands,
     /*  533243 */     // GIR_Coverage, 21242,
     /*  533243 */     GIR_EraseRootFromParent_Done,
     /*  533244 */   // Label 8819: @533244
     /*  533244 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(533315), // Rule ID 21243 //
     /*  533249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  533252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  533257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  533260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  533263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  533266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533281 */     // MIs[0] round
     /*  533281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533291 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  533294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533300 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533313 */     GIR_RootConstrainSelectedInstOperands,
     /*  533314 */     // GIR_Coverage, 21243,
     /*  533314 */     GIR_EraseRootFromParent_Done,
     /*  533315 */   // Label 8820: @533315
     /*  533315 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(533386), // Rule ID 21594 //
     /*  533320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  533331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  533334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  533337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533352 */     // MIs[0] round
     /*  533352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533362 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  533362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  533365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533371 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533384 */     GIR_RootConstrainSelectedInstOperands,
     /*  533385 */     // GIR_Coverage, 21594,
     /*  533385 */     GIR_EraseRootFromParent_Done,
     /*  533386 */   // Label 8821: @533386
     /*  533386 */   GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(533457), // Rule ID 21595 //
     /*  533391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  533402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  533405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  533408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533423 */     // MIs[0] round
     /*  533423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533433 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  533433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  533436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533442 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533455 */     GIR_RootConstrainSelectedInstOperands,
     /*  533456 */     // GIR_Coverage, 21595,
     /*  533456 */     GIR_EraseRootFromParent_Done,
     /*  533457 */   // Label 8822: @533457
     /*  533457 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(533528), // Rule ID 21598 //
     /*  533462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  533473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  533476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  533479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533494 */     // MIs[0] round
     /*  533494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533504 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  533504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  533507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533513 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533526 */     GIR_RootConstrainSelectedInstOperands,
     /*  533527 */     // GIR_Coverage, 21598,
     /*  533527 */     GIR_EraseRootFromParent_Done,
     /*  533528 */   // Label 8823: @533528
     /*  533528 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(533599), // Rule ID 21599 //
     /*  533533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  533544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  533547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  533550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533565 */     // MIs[0] round
     /*  533565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533575 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  533575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  533578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533584 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533597 */     GIR_RootConstrainSelectedInstOperands,
     /*  533598 */     // GIR_Coverage, 21599,
     /*  533598 */     GIR_EraseRootFromParent_Done,
     /*  533599 */   // Label 8824: @533599
     /*  533599 */   GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(533670), // Rule ID 21602 //
     /*  533604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  533615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  533618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  533621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533636 */     // MIs[0] round
     /*  533636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533646 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  533646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  533649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533655 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533668 */     GIR_RootConstrainSelectedInstOperands,
     /*  533669 */     // GIR_Coverage, 21602,
     /*  533669 */     GIR_EraseRootFromParent_Done,
     /*  533670 */   // Label 8825: @533670
     /*  533670 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(533741), // Rule ID 21603 //
     /*  533675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  533686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  533689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  533692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533707 */     // MIs[0] round
     /*  533707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533717 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  533717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  533720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533726 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533739 */     GIR_RootConstrainSelectedInstOperands,
     /*  533740 */     // GIR_Coverage, 21603,
     /*  533740 */     GIR_EraseRootFromParent_Done,
     /*  533741 */   // Label 8826: @533741
     /*  533741 */   GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(533812), // Rule ID 21606 //
     /*  533746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  533757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  533760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  533763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533778 */     // MIs[0] round
     /*  533778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533788 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  533788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  533791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533797 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533810 */     GIR_RootConstrainSelectedInstOperands,
     /*  533811 */     // GIR_Coverage, 21606,
     /*  533811 */     GIR_EraseRootFromParent_Done,
     /*  533812 */   // Label 8827: @533812
     /*  533812 */   GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(533883), // Rule ID 21607 //
     /*  533817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  533828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  533831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  533834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533849 */     // MIs[0] round
     /*  533849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533859 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  533859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  533862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533868 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533881 */     GIR_RootConstrainSelectedInstOperands,
     /*  533882 */     // GIR_Coverage, 21607,
     /*  533882 */     GIR_EraseRootFromParent_Done,
     /*  533883 */   // Label 8828: @533883
     /*  533883 */   GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(533954), // Rule ID 21610 //
     /*  533888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  533899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  533902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  533905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533920 */     // MIs[0] round
     /*  533920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533930 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  533930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  533933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533939 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533952 */     GIR_RootConstrainSelectedInstOperands,
     /*  533953 */     // GIR_Coverage, 21610,
     /*  533953 */     GIR_EraseRootFromParent_Done,
     /*  533954 */   // Label 8829: @533954
     /*  533954 */   GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(534025), // Rule ID 21611 //
     /*  533959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  533970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  533973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  533976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533991 */     // MIs[0] round
     /*  533991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534001 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  534001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  534004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534010 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  534020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534023 */     GIR_RootConstrainSelectedInstOperands,
     /*  534024 */     // GIR_Coverage, 21611,
     /*  534024 */     GIR_EraseRootFromParent_Done,
     /*  534025 */   // Label 8830: @534025
     /*  534025 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(534096), // Rule ID 21614 //
     /*  534030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  534041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  534044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  534047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534062 */     // MIs[0] round
     /*  534062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534072 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  534072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  534075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534081 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  534091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534094 */     GIR_RootConstrainSelectedInstOperands,
     /*  534095 */     // GIR_Coverage, 21614,
     /*  534095 */     GIR_EraseRootFromParent_Done,
     /*  534096 */   // Label 8831: @534096
     /*  534096 */   GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(534167), // Rule ID 21615 //
     /*  534101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  534112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  534115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  534118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534133 */     // MIs[0] round
     /*  534133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534143 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  534143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  534146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534152 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  534162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534165 */     GIR_RootConstrainSelectedInstOperands,
     /*  534166 */     // GIR_Coverage, 21615,
     /*  534166 */     GIR_EraseRootFromParent_Done,
     /*  534167 */   // Label 8832: @534167
     /*  534167 */   GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(534238), // Rule ID 21618 //
     /*  534172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  534175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  534183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  534186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  534189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534204 */     // MIs[0] round
     /*  534204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  534217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534223 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534236 */     GIR_RootConstrainSelectedInstOperands,
     /*  534237 */     // GIR_Coverage, 21618,
     /*  534237 */     GIR_EraseRootFromParent_Done,
     /*  534238 */   // Label 8833: @534238
     /*  534238 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(534309), // Rule ID 21619 //
     /*  534243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  534246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  534254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  534257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  534260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534275 */     // MIs[0] round
     /*  534275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534285 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  534288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534294 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534307 */     GIR_RootConstrainSelectedInstOperands,
     /*  534308 */     // GIR_Coverage, 21619,
     /*  534308 */     GIR_EraseRootFromParent_Done,
     /*  534309 */   // Label 8834: @534309
     /*  534309 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(534380), // Rule ID 21622 //
     /*  534314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  534317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  534325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  534328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  534331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534346 */     // MIs[0] round
     /*  534346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534356 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  534359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534365 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534378 */     GIR_RootConstrainSelectedInstOperands,
     /*  534379 */     // GIR_Coverage, 21622,
     /*  534379 */     GIR_EraseRootFromParent_Done,
     /*  534380 */   // Label 8835: @534380
     /*  534380 */   GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(534451), // Rule ID 21623 //
     /*  534385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  534388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  534396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  534399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  534402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534417 */     // MIs[0] round
     /*  534417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534427 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  534430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534436 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534449 */     GIR_RootConstrainSelectedInstOperands,
     /*  534450 */     // GIR_Coverage, 21623,
     /*  534450 */     GIR_EraseRootFromParent_Done,
     /*  534451 */   // Label 8836: @534451
     /*  534451 */   GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(534522), // Rule ID 21626 //
     /*  534456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  534459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534488 */     // MIs[0] round
     /*  534488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  534501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534507 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534520 */     GIR_RootConstrainSelectedInstOperands,
     /*  534521 */     // GIR_Coverage, 21626,
     /*  534521 */     GIR_EraseRootFromParent_Done,
     /*  534522 */   // Label 8837: @534522
     /*  534522 */   GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(534593), // Rule ID 21627 //
     /*  534527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  534530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534559 */     // MIs[0] round
     /*  534559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534569 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  534572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534578 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534591 */     GIR_RootConstrainSelectedInstOperands,
     /*  534592 */     // GIR_Coverage, 21627,
     /*  534592 */     GIR_EraseRootFromParent_Done,
     /*  534593 */   // Label 8838: @534593
     /*  534593 */   GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(534664), // Rule ID 21630 //
     /*  534598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  534601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  534609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  534612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  534615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534630 */     // MIs[0] round
     /*  534630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  534643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534649 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534662 */     GIR_RootConstrainSelectedInstOperands,
     /*  534663 */     // GIR_Coverage, 21630,
     /*  534663 */     GIR_EraseRootFromParent_Done,
     /*  534664 */   // Label 8839: @534664
     /*  534664 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(534735), // Rule ID 21631 //
     /*  534669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  534672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  534680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  534683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  534686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534701 */     // MIs[0] round
     /*  534701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534711 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  534714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534720 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534733 */     GIR_RootConstrainSelectedInstOperands,
     /*  534734 */     // GIR_Coverage, 21631,
     /*  534734 */     GIR_EraseRootFromParent_Done,
     /*  534735 */   // Label 8840: @534735
     /*  534735 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(534806), // Rule ID 21634 //
     /*  534740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  534743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  534751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  534754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  534757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534772 */     // MIs[0] round
     /*  534772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534782 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  534785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534791 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534804 */     GIR_RootConstrainSelectedInstOperands,
     /*  534805 */     // GIR_Coverage, 21634,
     /*  534805 */     GIR_EraseRootFromParent_Done,
     /*  534806 */   // Label 8841: @534806
     /*  534806 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(534877), // Rule ID 21635 //
     /*  534811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  534814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  534822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  534825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  534828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534843 */     // MIs[0] round
     /*  534843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534853 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  534856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534862 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534875 */     GIR_RootConstrainSelectedInstOperands,
     /*  534876 */     // GIR_Coverage, 21635,
     /*  534876 */     GIR_EraseRootFromParent_Done,
     /*  534877 */   // Label 8842: @534877
     /*  534877 */   GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(534948), // Rule ID 21638 //
     /*  534882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  534885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  534899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534914 */     // MIs[0] round
     /*  534914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  534927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534933 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534946 */     GIR_RootConstrainSelectedInstOperands,
     /*  534947 */     // GIR_Coverage, 21638,
     /*  534947 */     GIR_EraseRootFromParent_Done,
     /*  534948 */   // Label 8843: @534948
     /*  534948 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(535019), // Rule ID 21639 //
     /*  534953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  534956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  534970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534985 */     // MIs[0] round
     /*  534985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534995 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  534998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535004 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535017 */     GIR_RootConstrainSelectedInstOperands,
     /*  535018 */     // GIR_Coverage, 21639,
     /*  535018 */     GIR_EraseRootFromParent_Done,
     /*  535019 */   // Label 8844: @535019
     /*  535019 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(535090), // Rule ID 21642 //
     /*  535024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  535027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  535032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535056 */     // MIs[0] round
     /*  535056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535066 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  535069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535075 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535088 */     GIR_RootConstrainSelectedInstOperands,
     /*  535089 */     // GIR_Coverage, 21642,
     /*  535089 */     GIR_EraseRootFromParent_Done,
     /*  535090 */   // Label 8845: @535090
     /*  535090 */   GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(535161), // Rule ID 21643 //
     /*  535095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  535098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  535103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535127 */     // MIs[0] round
     /*  535127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535137 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  535140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535146 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535159 */     GIR_RootConstrainSelectedInstOperands,
     /*  535160 */     // GIR_Coverage, 21643,
     /*  535160 */     GIR_EraseRootFromParent_Done,
     /*  535161 */   // Label 8846: @535161
     /*  535161 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(535232), // Rule ID 21646 //
     /*  535166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  535169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  535174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  535177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  535180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  535183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535198 */     // MIs[0] round
     /*  535198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535208 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  535211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535217 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535230 */     GIR_RootConstrainSelectedInstOperands,
     /*  535231 */     // GIR_Coverage, 21646,
     /*  535231 */     GIR_EraseRootFromParent_Done,
     /*  535232 */   // Label 8847: @535232
     /*  535232 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(535303), // Rule ID 21647 //
     /*  535237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  535240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  535245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  535248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  535251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  535254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535269 */     // MIs[0] round
     /*  535269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535279 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  535282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535288 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535301 */     GIR_RootConstrainSelectedInstOperands,
     /*  535302 */     // GIR_Coverage, 21647,
     /*  535302 */     GIR_EraseRootFromParent_Done,
     /*  535303 */   // Label 8848: @535303
     /*  535303 */   GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(535374), // Rule ID 21650 //
     /*  535308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  535311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  535316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  535319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  535322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  535325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535340 */     // MIs[0] round
     /*  535340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535350 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  535353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535359 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535372 */     GIR_RootConstrainSelectedInstOperands,
     /*  535373 */     // GIR_Coverage, 21650,
     /*  535373 */     GIR_EraseRootFromParent_Done,
     /*  535374 */   // Label 8849: @535374
     /*  535374 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(535445), // Rule ID 21651 //
     /*  535379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  535382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  535387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  535390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  535393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  535396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535411 */     // MIs[0] round
     /*  535411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  535424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535430 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535443 */     GIR_RootConstrainSelectedInstOperands,
     /*  535444 */     // GIR_Coverage, 21651,
     /*  535444 */     GIR_EraseRootFromParent_Done,
     /*  535445 */   // Label 8850: @535445
     /*  535445 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(535516), // Rule ID 21654 //
     /*  535450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  535461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  535464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  535467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535482 */     // MIs[0] round
     /*  535482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535492 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  535492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  535495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535501 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535514 */     GIR_RootConstrainSelectedInstOperands,
     /*  535515 */     // GIR_Coverage, 21654,
     /*  535515 */     GIR_EraseRootFromParent_Done,
     /*  535516 */   // Label 8851: @535516
     /*  535516 */   GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(535587), // Rule ID 21655 //
     /*  535521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  535532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  535535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  535538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535553 */     // MIs[0] round
     /*  535553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535563 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  535563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  535566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535572 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535585 */     GIR_RootConstrainSelectedInstOperands,
     /*  535586 */     // GIR_Coverage, 21655,
     /*  535586 */     GIR_EraseRootFromParent_Done,
     /*  535587 */   // Label 8852: @535587
     /*  535587 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(535658), // Rule ID 21658 //
     /*  535592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  535603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  535606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  535609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535624 */     // MIs[0] round
     /*  535624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535634 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  535634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  535637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535643 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535656 */     GIR_RootConstrainSelectedInstOperands,
     /*  535657 */     // GIR_Coverage, 21658,
     /*  535657 */     GIR_EraseRootFromParent_Done,
     /*  535658 */   // Label 8853: @535658
     /*  535658 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(535729), // Rule ID 21659 //
     /*  535663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  535674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  535677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  535680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535695 */     // MIs[0] round
     /*  535695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535705 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  535705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  535708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535714 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535727 */     GIR_RootConstrainSelectedInstOperands,
     /*  535728 */     // GIR_Coverage, 21659,
     /*  535728 */     GIR_EraseRootFromParent_Done,
     /*  535729 */   // Label 8854: @535729
     /*  535729 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(535800), // Rule ID 21662 //
     /*  535734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  535745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  535748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  535751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535766 */     // MIs[0] round
     /*  535766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535776 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  535776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  535779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535785 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535798 */     GIR_RootConstrainSelectedInstOperands,
     /*  535799 */     // GIR_Coverage, 21662,
     /*  535799 */     GIR_EraseRootFromParent_Done,
     /*  535800 */   // Label 8855: @535800
     /*  535800 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(535871), // Rule ID 21663 //
     /*  535805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  535816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  535819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  535822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535837 */     // MIs[0] round
     /*  535837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535847 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  535847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  535850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535856 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535869 */     GIR_RootConstrainSelectedInstOperands,
     /*  535870 */     // GIR_Coverage, 21663,
     /*  535870 */     GIR_EraseRootFromParent_Done,
     /*  535871 */   // Label 8856: @535871
     /*  535871 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(535942), // Rule ID 21666 //
     /*  535876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  535887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  535890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  535893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535908 */     // MIs[0] round
     /*  535908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535918 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  535918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  535921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535927 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535940 */     GIR_RootConstrainSelectedInstOperands,
     /*  535941 */     // GIR_Coverage, 21666,
     /*  535941 */     GIR_EraseRootFromParent_Done,
     /*  535942 */   // Label 8857: @535942
     /*  535942 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(536013), // Rule ID 21667 //
     /*  535947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  535958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  535961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  535964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535979 */     // MIs[0] round
     /*  535979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535989 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  535989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  535992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535998 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  536008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536011 */     GIR_RootConstrainSelectedInstOperands,
     /*  536012 */     // GIR_Coverage, 21667,
     /*  536012 */     GIR_EraseRootFromParent_Done,
     /*  536013 */   // Label 8858: @536013
     /*  536013 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(536084), // Rule ID 21670 //
     /*  536018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  536021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  536029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  536032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  536035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536050 */     // MIs[0] round
     /*  536050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536060 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  536060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  536063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536069 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  536079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536082 */     GIR_RootConstrainSelectedInstOperands,
     /*  536083 */     // GIR_Coverage, 21670,
     /*  536083 */     GIR_EraseRootFromParent_Done,
     /*  536084 */   // Label 8859: @536084
     /*  536084 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(536155), // Rule ID 21671 //
     /*  536089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  536092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  536100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  536103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  536106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536121 */     // MIs[0] round
     /*  536121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536131 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  536131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  536134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536140 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  536150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536153 */     GIR_RootConstrainSelectedInstOperands,
     /*  536154 */     // GIR_Coverage, 21671,
     /*  536154 */     GIR_EraseRootFromParent_Done,
     /*  536155 */   // Label 8860: @536155
     /*  536155 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(536226), // Rule ID 21674 //
     /*  536160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  536163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  536171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  536174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  536177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536192 */     // MIs[0] round
     /*  536192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536202 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  536202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  536205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536211 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  536221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536224 */     GIR_RootConstrainSelectedInstOperands,
     /*  536225 */     // GIR_Coverage, 21674,
     /*  536225 */     GIR_EraseRootFromParent_Done,
     /*  536226 */   // Label 8861: @536226
     /*  536226 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(536297), // Rule ID 21675 //
     /*  536231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  536234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  536242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  536245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  536248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536263 */     // MIs[0] round
     /*  536263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536273 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  536273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  536276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536282 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  536292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536295 */     GIR_RootConstrainSelectedInstOperands,
     /*  536296 */     // GIR_Coverage, 21675,
     /*  536296 */     GIR_EraseRootFromParent_Done,
     /*  536297 */   // Label 8862: @536297
     /*  536297 */   GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(536368), // Rule ID 21678 //
     /*  536302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  536305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536334 */     // MIs[0] round
     /*  536334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536344 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  536347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536353 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536366 */     GIR_RootConstrainSelectedInstOperands,
     /*  536367 */     // GIR_Coverage, 21678,
     /*  536367 */     GIR_EraseRootFromParent_Done,
     /*  536368 */   // Label 8863: @536368
     /*  536368 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(536439), // Rule ID 21679 //
     /*  536373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  536376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536405 */     // MIs[0] round
     /*  536405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536415 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  536418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536424 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536437 */     GIR_RootConstrainSelectedInstOperands,
     /*  536438 */     // GIR_Coverage, 21679,
     /*  536438 */     GIR_EraseRootFromParent_Done,
     /*  536439 */   // Label 8864: @536439
     /*  536439 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(536510), // Rule ID 21682 //
     /*  536444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  536447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536476 */     // MIs[0] round
     /*  536476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536486 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  536489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536495 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536508 */     GIR_RootConstrainSelectedInstOperands,
     /*  536509 */     // GIR_Coverage, 21682,
     /*  536509 */     GIR_EraseRootFromParent_Done,
     /*  536510 */   // Label 8865: @536510
     /*  536510 */   GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(536581), // Rule ID 21683 //
     /*  536515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  536518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536547 */     // MIs[0] round
     /*  536547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536557 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  536560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536566 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536579 */     GIR_RootConstrainSelectedInstOperands,
     /*  536580 */     // GIR_Coverage, 21683,
     /*  536580 */     GIR_EraseRootFromParent_Done,
     /*  536581 */   // Label 8866: @536581
     /*  536581 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(536652), // Rule ID 21686 //
     /*  536586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  536589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  536597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  536600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  536603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536618 */     // MIs[0] round
     /*  536618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536628 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  536631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536637 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536650 */     GIR_RootConstrainSelectedInstOperands,
     /*  536651 */     // GIR_Coverage, 21686,
     /*  536651 */     GIR_EraseRootFromParent_Done,
     /*  536652 */   // Label 8867: @536652
     /*  536652 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(536723), // Rule ID 21687 //
     /*  536657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  536660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  536668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  536671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  536674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536689 */     // MIs[0] round
     /*  536689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536699 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  536702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536708 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536721 */     GIR_RootConstrainSelectedInstOperands,
     /*  536722 */     // GIR_Coverage, 21687,
     /*  536722 */     GIR_EraseRootFromParent_Done,
     /*  536723 */   // Label 8868: @536723
     /*  536723 */   GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(536794), // Rule ID 21690 //
     /*  536728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  536731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  536739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  536742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  536745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536760 */     // MIs[0] round
     /*  536760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536770 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  536773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536779 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536792 */     GIR_RootConstrainSelectedInstOperands,
     /*  536793 */     // GIR_Coverage, 21690,
     /*  536793 */     GIR_EraseRootFromParent_Done,
     /*  536794 */   // Label 8869: @536794
     /*  536794 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(536865), // Rule ID 21691 //
     /*  536799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  536802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  536810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  536813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  536816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536831 */     // MIs[0] round
     /*  536831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  536844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536850 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536863 */     GIR_RootConstrainSelectedInstOperands,
     /*  536864 */     // GIR_Coverage, 21691,
     /*  536864 */     GIR_EraseRootFromParent_Done,
     /*  536865 */   // Label 8870: @536865
     /*  536865 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(536936), // Rule ID 21694 //
     /*  536870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  536873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  536881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536902 */     // MIs[0] round
     /*  536902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536912 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  536915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536921 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536934 */     GIR_RootConstrainSelectedInstOperands,
     /*  536935 */     // GIR_Coverage, 21694,
     /*  536935 */     GIR_EraseRootFromParent_Done,
     /*  536936 */   // Label 8871: @536936
     /*  536936 */   GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(537007), // Rule ID 21695 //
     /*  536941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  536944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  536952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536973 */     // MIs[0] round
     /*  536973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536983 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  536986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536992 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537005 */     GIR_RootConstrainSelectedInstOperands,
     /*  537006 */     // GIR_Coverage, 21695,
     /*  537006 */     GIR_EraseRootFromParent_Done,
     /*  537007 */   // Label 8872: @537007
     /*  537007 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(537078), // Rule ID 21698 //
     /*  537012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  537015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  537029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537044 */     // MIs[0] round
     /*  537044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  537057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537063 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537076 */     GIR_RootConstrainSelectedInstOperands,
     /*  537077 */     // GIR_Coverage, 21698,
     /*  537077 */     GIR_EraseRootFromParent_Done,
     /*  537078 */   // Label 8873: @537078
     /*  537078 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(537149), // Rule ID 21699 //
     /*  537083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  537086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  537100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537115 */     // MIs[0] round
     /*  537115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537125 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  537128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537134 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537147 */     GIR_RootConstrainSelectedInstOperands,
     /*  537148 */     // GIR_Coverage, 21699,
     /*  537148 */     GIR_EraseRootFromParent_Done,
     /*  537149 */   // Label 8874: @537149
     /*  537149 */   GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(537220), // Rule ID 21702 //
     /*  537154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  537157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  537165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  537168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  537171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537186 */     // MIs[0] round
     /*  537186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  537199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537205 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537218 */     GIR_RootConstrainSelectedInstOperands,
     /*  537219 */     // GIR_Coverage, 21702,
     /*  537219 */     GIR_EraseRootFromParent_Done,
     /*  537220 */   // Label 8875: @537220
     /*  537220 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(537291), // Rule ID 21703 //
     /*  537225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  537228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  537236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  537239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  537242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537257 */     // MIs[0] round
     /*  537257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537267 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  537270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537276 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537289 */     GIR_RootConstrainSelectedInstOperands,
     /*  537290 */     // GIR_Coverage, 21703,
     /*  537290 */     GIR_EraseRootFromParent_Done,
     /*  537291 */   // Label 8876: @537291
     /*  537291 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(537362), // Rule ID 21706 //
     /*  537296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  537299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  537307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  537310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  537313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537328 */     // MIs[0] round
     /*  537328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537338 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  537341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537347 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537360 */     GIR_RootConstrainSelectedInstOperands,
     /*  537361 */     // GIR_Coverage, 21706,
     /*  537361 */     GIR_EraseRootFromParent_Done,
     /*  537362 */   // Label 8877: @537362
     /*  537362 */   GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(537433), // Rule ID 21707 //
     /*  537367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  537370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  537378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  537381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  537384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537399 */     // MIs[0] round
     /*  537399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537409 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  537412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537418 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537431 */     GIR_RootConstrainSelectedInstOperands,
     /*  537432 */     // GIR_Coverage, 21707,
     /*  537432 */     GIR_EraseRootFromParent_Done,
     /*  537433 */   // Label 8878: @537433
     /*  537433 */   GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(537504), // Rule ID 21710 //
     /*  537438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  537441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  537449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  537452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  537455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537470 */     // MIs[0] round
     /*  537470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537480 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  537483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537489 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537502 */     GIR_RootConstrainSelectedInstOperands,
     /*  537503 */     // GIR_Coverage, 21710,
     /*  537503 */     GIR_EraseRootFromParent_Done,
     /*  537504 */   // Label 8879: @537504
     /*  537504 */   GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(537575), // Rule ID 21711 //
     /*  537509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  537512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  537520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  537523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  537526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537541 */     // MIs[0] round
     /*  537541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  537554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537560 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537573 */     GIR_RootConstrainSelectedInstOperands,
     /*  537574 */     // GIR_Coverage, 21711,
     /*  537574 */     GIR_EraseRootFromParent_Done,
     /*  537575 */   // Label 8880: @537575
     /*  537575 */   GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(537646), // Rule ID 21834 //
     /*  537580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  537583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  537588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  537591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  537594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  537597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537612 */     // MIs[0] round
     /*  537612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537622 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  537625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537631 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537644 */     GIR_RootConstrainSelectedInstOperands,
     /*  537645 */     // GIR_Coverage, 21834,
     /*  537645 */     GIR_EraseRootFromParent_Done,
     /*  537646 */   // Label 8881: @537646
     /*  537646 */   GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(537717), // Rule ID 21835 //
     /*  537651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  537654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  537659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  537662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  537665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  537668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537683 */     // MIs[0] round
     /*  537683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537693 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  537696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537702 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537715 */     GIR_RootConstrainSelectedInstOperands,
     /*  537716 */     // GIR_Coverage, 21835,
     /*  537716 */     GIR_EraseRootFromParent_Done,
     /*  537717 */   // Label 8882: @537717
     /*  537717 */   GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(537788), // Rule ID 21838 //
     /*  537722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  537725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  537730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  537733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  537736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  537739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537754 */     // MIs[0] round
     /*  537754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537764 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  537767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537773 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537786 */     GIR_RootConstrainSelectedInstOperands,
     /*  537787 */     // GIR_Coverage, 21838,
     /*  537787 */     GIR_EraseRootFromParent_Done,
     /*  537788 */   // Label 8883: @537788
     /*  537788 */   GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(537859), // Rule ID 21839 //
     /*  537793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  537796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  537801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  537804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  537807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  537810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537825 */     // MIs[0] round
     /*  537825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537835 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  537838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537844 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537857 */     GIR_RootConstrainSelectedInstOperands,
     /*  537858 */     // GIR_Coverage, 21839,
     /*  537858 */     GIR_EraseRootFromParent_Done,
     /*  537859 */   // Label 8884: @537859
     /*  537859 */   GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(537930), // Rule ID 21842 //
     /*  537864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  537867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  537872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  537881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537896 */     // MIs[0] round
     /*  537896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537906 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  537909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537915 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537928 */     GIR_RootConstrainSelectedInstOperands,
     /*  537929 */     // GIR_Coverage, 21842,
     /*  537929 */     GIR_EraseRootFromParent_Done,
     /*  537930 */   // Label 8885: @537930
     /*  537930 */   GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(538001), // Rule ID 21843 //
     /*  537935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  537938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  537943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  537952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537967 */     // MIs[0] round
     /*  537967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537977 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  537980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537986 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537999 */     GIR_RootConstrainSelectedInstOperands,
     /*  538000 */     // GIR_Coverage, 21843,
     /*  538000 */     GIR_EraseRootFromParent_Done,
     /*  538001 */   // Label 8886: @538001
     /*  538001 */   GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(538072), // Rule ID 21846 //
     /*  538006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  538009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  538017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  538020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  538023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538038 */     // MIs[0] round
     /*  538038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538048 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  538051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538057 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538070 */     GIR_RootConstrainSelectedInstOperands,
     /*  538071 */     // GIR_Coverage, 21846,
     /*  538071 */     GIR_EraseRootFromParent_Done,
     /*  538072 */   // Label 8887: @538072
     /*  538072 */   GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(538143), // Rule ID 21847 //
     /*  538077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  538080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  538088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  538091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  538094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538109 */     // MIs[0] round
     /*  538109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538119 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  538122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538128 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538141 */     GIR_RootConstrainSelectedInstOperands,
     /*  538142 */     // GIR_Coverage, 21847,
     /*  538142 */     GIR_EraseRootFromParent_Done,
     /*  538143 */   // Label 8888: @538143
     /*  538143 */   GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(538214), // Rule ID 21850 //
     /*  538148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  538151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  538159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  538162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  538165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538180 */     // MIs[0] round
     /*  538180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538190 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  538193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538199 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538212 */     GIR_RootConstrainSelectedInstOperands,
     /*  538213 */     // GIR_Coverage, 21850,
     /*  538213 */     GIR_EraseRootFromParent_Done,
     /*  538214 */   // Label 8889: @538214
     /*  538214 */   GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(538285), // Rule ID 21851 //
     /*  538219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  538222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  538230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  538233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  538236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538251 */     // MIs[0] round
     /*  538251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538261 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  538264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538270 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538283 */     GIR_RootConstrainSelectedInstOperands,
     /*  538284 */     // GIR_Coverage, 21851,
     /*  538284 */     GIR_EraseRootFromParent_Done,
     /*  538285 */   // Label 8890: @538285
     /*  538285 */   GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(538356), // Rule ID 21854 //
     /*  538290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  538293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  538301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  538304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  538307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538322 */     // MIs[0] round
     /*  538322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538332 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  538332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  538335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538341 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538354 */     GIR_RootConstrainSelectedInstOperands,
     /*  538355 */     // GIR_Coverage, 21854,
     /*  538355 */     GIR_EraseRootFromParent_Done,
     /*  538356 */   // Label 8891: @538356
     /*  538356 */   GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(538427), // Rule ID 21855 //
     /*  538361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  538364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  538372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  538375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  538378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538393 */     // MIs[0] round
     /*  538393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538403 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  538403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  538406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538412 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538425 */     GIR_RootConstrainSelectedInstOperands,
     /*  538426 */     // GIR_Coverage, 21855,
     /*  538426 */     GIR_EraseRootFromParent_Done,
     /*  538427 */   // Label 8892: @538427
     /*  538427 */   GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(538498), // Rule ID 21858 //
     /*  538432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  538435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  538443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  538446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  538449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538464 */     // MIs[0] round
     /*  538464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538474 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  538474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  538477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538483 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538496 */     GIR_RootConstrainSelectedInstOperands,
     /*  538497 */     // GIR_Coverage, 21858,
     /*  538497 */     GIR_EraseRootFromParent_Done,
     /*  538498 */   // Label 8893: @538498
     /*  538498 */   GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(538569), // Rule ID 21859 //
     /*  538503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  538506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  538514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  538517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  538520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538535 */     // MIs[0] round
     /*  538535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538545 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  538545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  538548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538554 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538567 */     GIR_RootConstrainSelectedInstOperands,
     /*  538568 */     // GIR_Coverage, 21859,
     /*  538568 */     GIR_EraseRootFromParent_Done,
     /*  538569 */   // Label 8894: @538569
     /*  538569 */   GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(538640), // Rule ID 21862 //
     /*  538574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  538577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  538585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  538588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  538591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538606 */     // MIs[0] round
     /*  538606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538616 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  538616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  538619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538625 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538638 */     GIR_RootConstrainSelectedInstOperands,
     /*  538639 */     // GIR_Coverage, 21862,
     /*  538639 */     GIR_EraseRootFromParent_Done,
     /*  538640 */   // Label 8895: @538640
     /*  538640 */   GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(538711), // Rule ID 21863 //
     /*  538645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  538648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  538656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  538659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  538662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538677 */     // MIs[0] round
     /*  538677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538687 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  538687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  538690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538696 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538709 */     GIR_RootConstrainSelectedInstOperands,
     /*  538710 */     // GIR_Coverage, 21863,
     /*  538710 */     GIR_EraseRootFromParent_Done,
     /*  538711 */   // Label 8896: @538711
     /*  538711 */   GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(538782), // Rule ID 21866 //
     /*  538716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  538719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  538727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  538730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  538733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538748 */     // MIs[0] round
     /*  538748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538758 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  538758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  538761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538767 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538780 */     GIR_RootConstrainSelectedInstOperands,
     /*  538781 */     // GIR_Coverage, 21866,
     /*  538781 */     GIR_EraseRootFromParent_Done,
     /*  538782 */   // Label 8897: @538782
     /*  538782 */   GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(538853), // Rule ID 21867 //
     /*  538787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  538790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  538798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  538801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  538804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538819 */     // MIs[0] round
     /*  538819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538829 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  538829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  538832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538838 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538851 */     GIR_RootConstrainSelectedInstOperands,
     /*  538852 */     // GIR_Coverage, 21867,
     /*  538852 */     GIR_EraseRootFromParent_Done,
     /*  538853 */   // Label 8898: @538853
     /*  538853 */   GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(538924), // Rule ID 21870 //
     /*  538858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  538861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  538866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  538869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  538872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  538875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538890 */     // MIs[0] round
     /*  538890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538900 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  538903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538909 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538922 */     GIR_RootConstrainSelectedInstOperands,
     /*  538923 */     // GIR_Coverage, 21870,
     /*  538923 */     GIR_EraseRootFromParent_Done,
     /*  538924 */   // Label 8899: @538924
     /*  538924 */   GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(538995), // Rule ID 21871 //
     /*  538929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  538932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  538937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  538940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  538943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  538946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538961 */     // MIs[0] round
     /*  538961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538971 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  538974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538980 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538993 */     GIR_RootConstrainSelectedInstOperands,
     /*  538994 */     // GIR_Coverage, 21871,
     /*  538994 */     GIR_EraseRootFromParent_Done,
     /*  538995 */   // Label 8900: @538995
     /*  538995 */   GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(539066), // Rule ID 21874 //
     /*  539000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  539003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  539011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  539014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  539017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539032 */     // MIs[0] round
     /*  539032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539042 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  539045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539051 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539064 */     GIR_RootConstrainSelectedInstOperands,
     /*  539065 */     // GIR_Coverage, 21874,
     /*  539065 */     GIR_EraseRootFromParent_Done,
     /*  539066 */   // Label 8901: @539066
     /*  539066 */   GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(539137), // Rule ID 21875 //
     /*  539071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  539074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  539082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  539085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  539088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539103 */     // MIs[0] round
     /*  539103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539113 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  539116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539122 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539135 */     GIR_RootConstrainSelectedInstOperands,
     /*  539136 */     // GIR_Coverage, 21875,
     /*  539136 */     GIR_EraseRootFromParent_Done,
     /*  539137 */   // Label 8902: @539137
     /*  539137 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(539208), // Rule ID 21878 //
     /*  539142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  539145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  539153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  539156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  539159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539174 */     // MIs[0] round
     /*  539174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539184 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  539187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539193 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539206 */     GIR_RootConstrainSelectedInstOperands,
     /*  539207 */     // GIR_Coverage, 21878,
     /*  539207 */     GIR_EraseRootFromParent_Done,
     /*  539208 */   // Label 8903: @539208
     /*  539208 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(539279), // Rule ID 21879 //
     /*  539213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  539216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  539224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  539227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  539230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539245 */     // MIs[0] round
     /*  539245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539255 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  539258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539264 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539277 */     GIR_RootConstrainSelectedInstOperands,
     /*  539278 */     // GIR_Coverage, 21879,
     /*  539278 */     GIR_EraseRootFromParent_Done,
     /*  539279 */   // Label 8904: @539279
     /*  539279 */   GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(539350), // Rule ID 21882 //
     /*  539284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  539287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  539295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  539298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  539301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539316 */     // MIs[0] round
     /*  539316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539326 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  539329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539335 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539348 */     GIR_RootConstrainSelectedInstOperands,
     /*  539349 */     // GIR_Coverage, 21882,
     /*  539349 */     GIR_EraseRootFromParent_Done,
     /*  539350 */   // Label 8905: @539350
     /*  539350 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(539421), // Rule ID 21883 //
     /*  539355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  539358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  539366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  539369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  539372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539387 */     // MIs[0] round
     /*  539387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539397 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  539400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539406 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539419 */     GIR_RootConstrainSelectedInstOperands,
     /*  539420 */     // GIR_Coverage, 21883,
     /*  539420 */     GIR_EraseRootFromParent_Done,
     /*  539421 */   // Label 8906: @539421
     /*  539421 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(539492), // Rule ID 21886 //
     /*  539426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  539429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  539437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  539440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  539443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539458 */     // MIs[0] round
     /*  539458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539468 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  539471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539477 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539490 */     GIR_RootConstrainSelectedInstOperands,
     /*  539491 */     // GIR_Coverage, 21886,
     /*  539491 */     GIR_EraseRootFromParent_Done,
     /*  539492 */   // Label 8907: @539492
     /*  539492 */   GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(539563), // Rule ID 21887 //
     /*  539497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  539500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  539508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  539511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  539514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539529 */     // MIs[0] round
     /*  539529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539539 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  539542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539548 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539561 */     GIR_RootConstrainSelectedInstOperands,
     /*  539562 */     // GIR_Coverage, 21887,
     /*  539562 */     GIR_EraseRootFromParent_Done,
     /*  539563 */   // Label 8908: @539563
     /*  539563 */   GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(539634), // Rule ID 21890 //
     /*  539568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  539571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  539579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  539582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  539585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539600 */     // MIs[0] round
     /*  539600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539610 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  539613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539619 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539632 */     GIR_RootConstrainSelectedInstOperands,
     /*  539633 */     // GIR_Coverage, 21890,
     /*  539633 */     GIR_EraseRootFromParent_Done,
     /*  539634 */   // Label 8909: @539634
     /*  539634 */   GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(539705), // Rule ID 21891 //
     /*  539639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  539642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  539650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  539653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  539656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539671 */     // MIs[0] round
     /*  539671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539681 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  539684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539690 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539703 */     GIR_RootConstrainSelectedInstOperands,
     /*  539704 */     // GIR_Coverage, 21891,
     /*  539704 */     GIR_EraseRootFromParent_Done,
     /*  539705 */   // Label 8910: @539705
     /*  539705 */   GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(539776), // Rule ID 21894 //
     /*  539710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  539713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  539721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  539724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  539727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539742 */     // MIs[0] round
     /*  539742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539752 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  539755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539761 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539774 */     GIR_RootConstrainSelectedInstOperands,
     /*  539775 */     // GIR_Coverage, 21894,
     /*  539775 */     GIR_EraseRootFromParent_Done,
     /*  539776 */   // Label 8911: @539776
     /*  539776 */   GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(539847), // Rule ID 21895 //
     /*  539781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  539784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  539792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  539795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  539798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539813 */     // MIs[0] round
     /*  539813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539823 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  539826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539832 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539845 */     GIR_RootConstrainSelectedInstOperands,
     /*  539846 */     // GIR_Coverage, 21895,
     /*  539846 */     GIR_EraseRootFromParent_Done,
     /*  539847 */   // Label 8912: @539847
     /*  539847 */   GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(539918), // Rule ID 21898 //
     /*  539852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  539855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  539863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  539866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  539869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539884 */     // MIs[0] round
     /*  539884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539894 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  539897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539903 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539916 */     GIR_RootConstrainSelectedInstOperands,
     /*  539917 */     // GIR_Coverage, 21898,
     /*  539917 */     GIR_EraseRootFromParent_Done,
     /*  539918 */   // Label 8913: @539918
     /*  539918 */   GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(539989), // Rule ID 21899 //
     /*  539923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  539926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  539934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  539937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  539940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539955 */     // MIs[0] round
     /*  539955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539965 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  539968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539974 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539987 */     GIR_RootConstrainSelectedInstOperands,
     /*  539988 */     // GIR_Coverage, 21899,
     /*  539988 */     GIR_EraseRootFromParent_Done,
     /*  539989 */   // Label 8914: @539989
     /*  539989 */   GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(540060), // Rule ID 21902 //
     /*  539994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  539997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  540002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  540005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  540008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  540011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540026 */     // MIs[0] round
     /*  540026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540036 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  540039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540045 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540058 */     GIR_RootConstrainSelectedInstOperands,
     /*  540059 */     // GIR_Coverage, 21902,
     /*  540059 */     GIR_EraseRootFromParent_Done,
     /*  540060 */   // Label 8915: @540060
     /*  540060 */   GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(540131), // Rule ID 21903 //
     /*  540065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  540068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  540073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  540076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  540079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  540082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540097 */     // MIs[0] round
     /*  540097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540107 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  540110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540116 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540129 */     GIR_RootConstrainSelectedInstOperands,
     /*  540130 */     // GIR_Coverage, 21903,
     /*  540130 */     GIR_EraseRootFromParent_Done,
     /*  540131 */   // Label 8916: @540131
     /*  540131 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(540202), // Rule ID 21906 //
     /*  540136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  540139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  540147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  540150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  540153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540168 */     // MIs[0] round
     /*  540168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540178 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  540181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540187 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540200 */     GIR_RootConstrainSelectedInstOperands,
     /*  540201 */     // GIR_Coverage, 21906,
     /*  540201 */     GIR_EraseRootFromParent_Done,
     /*  540202 */   // Label 8917: @540202
     /*  540202 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(540273), // Rule ID 21907 //
     /*  540207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  540210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  540218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  540221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  540224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540239 */     // MIs[0] round
     /*  540239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540249 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  540252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540258 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540271 */     GIR_RootConstrainSelectedInstOperands,
     /*  540272 */     // GIR_Coverage, 21907,
     /*  540272 */     GIR_EraseRootFromParent_Done,
     /*  540273 */   // Label 8918: @540273
     /*  540273 */   GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(540344), // Rule ID 21910 //
     /*  540278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  540281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  540289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  540292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  540295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540310 */     // MIs[0] round
     /*  540310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540320 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  540323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540329 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540342 */     GIR_RootConstrainSelectedInstOperands,
     /*  540343 */     // GIR_Coverage, 21910,
     /*  540343 */     GIR_EraseRootFromParent_Done,
     /*  540344 */   // Label 8919: @540344
     /*  540344 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(540415), // Rule ID 21911 //
     /*  540349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  540352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  540360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  540363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  540366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540381 */     // MIs[0] round
     /*  540381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540391 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  540394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540400 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540413 */     GIR_RootConstrainSelectedInstOperands,
     /*  540414 */     // GIR_Coverage, 21911,
     /*  540414 */     GIR_EraseRootFromParent_Done,
     /*  540415 */   // Label 8920: @540415
     /*  540415 */   GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(540486), // Rule ID 21914 //
     /*  540420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  540423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  540431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  540434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  540437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540452 */     // MIs[0] round
     /*  540452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540462 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  540465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540471 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540484 */     GIR_RootConstrainSelectedInstOperands,
     /*  540485 */     // GIR_Coverage, 21914,
     /*  540485 */     GIR_EraseRootFromParent_Done,
     /*  540486 */   // Label 8921: @540486
     /*  540486 */   GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(540557), // Rule ID 21915 //
     /*  540491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  540494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  540502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  540505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  540508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540523 */     // MIs[0] round
     /*  540523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540533 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  540536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540542 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540555 */     GIR_RootConstrainSelectedInstOperands,
     /*  540556 */     // GIR_Coverage, 21915,
     /*  540556 */     GIR_EraseRootFromParent_Done,
     /*  540557 */   // Label 8922: @540557
     /*  540557 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(540628), // Rule ID 21918 //
     /*  540562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  540565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  540573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  540576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  540579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540594 */     // MIs[0] round
     /*  540594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540604 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  540607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540613 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540626 */     GIR_RootConstrainSelectedInstOperands,
     /*  540627 */     // GIR_Coverage, 21918,
     /*  540627 */     GIR_EraseRootFromParent_Done,
     /*  540628 */   // Label 8923: @540628
     /*  540628 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(540699), // Rule ID 21919 //
     /*  540633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  540636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  540644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  540647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  540650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540665 */     // MIs[0] round
     /*  540665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540675 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  540678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540684 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540697 */     GIR_RootConstrainSelectedInstOperands,
     /*  540698 */     // GIR_Coverage, 21919,
     /*  540698 */     GIR_EraseRootFromParent_Done,
     /*  540699 */   // Label 8924: @540699
     /*  540699 */   GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(540770), // Rule ID 21922 //
     /*  540704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  540707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  540715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  540718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  540721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540736 */     // MIs[0] round
     /*  540736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540746 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  540749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540755 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540768 */     GIR_RootConstrainSelectedInstOperands,
     /*  540769 */     // GIR_Coverage, 21922,
     /*  540769 */     GIR_EraseRootFromParent_Done,
     /*  540770 */   // Label 8925: @540770
     /*  540770 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(540841), // Rule ID 21923 //
     /*  540775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  540778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  540786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  540789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  540792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540807 */     // MIs[0] round
     /*  540807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540817 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  540820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540826 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540839 */     GIR_RootConstrainSelectedInstOperands,
     /*  540840 */     // GIR_Coverage, 21923,
     /*  540840 */     GIR_EraseRootFromParent_Done,
     /*  540841 */   // Label 8926: @540841
     /*  540841 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(540912), // Rule ID 21926 //
     /*  540846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  540849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  540857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  540860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  540863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540878 */     // MIs[0] round
     /*  540878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540888 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  540891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540897 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540910 */     GIR_RootConstrainSelectedInstOperands,
     /*  540911 */     // GIR_Coverage, 21926,
     /*  540911 */     GIR_EraseRootFromParent_Done,
     /*  540912 */   // Label 8927: @540912
     /*  540912 */   GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(540983), // Rule ID 21927 //
     /*  540917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  540920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  540928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  540931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  540934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540949 */     // MIs[0] round
     /*  540949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540959 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  540962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540968 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540981 */     GIR_RootConstrainSelectedInstOperands,
     /*  540982 */     // GIR_Coverage, 21927,
     /*  540982 */     GIR_EraseRootFromParent_Done,
     /*  540983 */   // Label 8928: @540983
     /*  540983 */   GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(541054), // Rule ID 21930 //
     /*  540988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  540991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  540999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  541002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  541005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541020 */     // MIs[0] round
     /*  541020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  541023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541030 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  541033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  541039 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  541041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541052 */     GIR_RootConstrainSelectedInstOperands,
     /*  541053 */     // GIR_Coverage, 21930,
     /*  541053 */     GIR_EraseRootFromParent_Done,
     /*  541054 */   // Label 8929: @541054
     /*  541054 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(541125), // Rule ID 21931 //
     /*  541059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  541062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  541067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  541070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  541073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  541076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541091 */     // MIs[0] round
     /*  541091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  541094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541101 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  541104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  541110 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  541112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541123 */     GIR_RootConstrainSelectedInstOperands,
     /*  541124 */     // GIR_Coverage, 21931,
     /*  541124 */     GIR_EraseRootFromParent_Done,
     /*  541125 */   // Label 8930: @541125
     /*  541125 */   GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(541196), // Rule ID 21934 //
     /*  541130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  541133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  541138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  541141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  541144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  541147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541162 */     // MIs[0] round
     /*  541162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  541165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541172 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  541175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  541181 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  541183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541194 */     GIR_RootConstrainSelectedInstOperands,
     /*  541195 */     // GIR_Coverage, 21934,
     /*  541195 */     GIR_EraseRootFromParent_Done,
     /*  541196 */   // Label 8931: @541196
     /*  541196 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(541267), // Rule ID 21935 //
     /*  541201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  541204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  541209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  541212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  541215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  541218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541233 */     // MIs[0] round
     /*  541233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  541236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541243 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  541246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  541252 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  541254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541265 */     GIR_RootConstrainSelectedInstOperands,
     /*  541266 */     // GIR_Coverage, 21935,
     /*  541266 */     GIR_EraseRootFromParent_Done,
     /*  541267 */   // Label 8932: @541267
     /*  541267 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(541338), // Rule ID 21938 //
     /*  541272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  541275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  541280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  541283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  541286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  541289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541304 */     // MIs[0] round
     /*  541304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  541307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541314 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  541317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  541323 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  541325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541336 */     GIR_RootConstrainSelectedInstOperands,
     /*  541337 */     // GIR_Coverage, 21938,
     /*  541337 */     GIR_EraseRootFromParent_Done,
     /*  541338 */   // Label 8933: @541338
     /*  541338 */   GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(541409), // Rule ID 21939 //
     /*  541343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  541346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  541351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  541354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  541357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  541360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541375 */     // MIs[0] round
     /*  541375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  541378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541385 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  541388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  541394 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  541396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541407 */     GIR_RootConstrainSelectedInstOperands,
     /*  541408 */     // GIR_Coverage, 21939,
     /*  541408 */     GIR_EraseRootFromParent_Done,
     /*  541409 */   // Label 8934: @541409
     /*  541409 */   GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(541480), // Rule ID 2748 //
     /*  541414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  541425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  541428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  541431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541442 */     // MIs[0] passthru
     /*  541442 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541458 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  541461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541478 */     GIR_RootConstrainSelectedInstOperands,
     /*  541479 */     // GIR_Coverage, 2748,
     /*  541479 */     GIR_EraseRootFromParent_Done,
     /*  541480 */   // Label 8935: @541480
     /*  541480 */   GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(541551), // Rule ID 2749 //
     /*  541485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  541496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  541499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  541502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541513 */     // MIs[0] passthru
     /*  541513 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541529 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  541532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541549 */     GIR_RootConstrainSelectedInstOperands,
     /*  541550 */     // GIR_Coverage, 2749,
     /*  541550 */     GIR_EraseRootFromParent_Done,
     /*  541551 */   // Label 8936: @541551
     /*  541551 */   GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(541622), // Rule ID 4064 //
     /*  541556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  541567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  541570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  541573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541584 */     // MIs[0] passthru
     /*  541584 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541600 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  541603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541620 */     GIR_RootConstrainSelectedInstOperands,
     /*  541621 */     // GIR_Coverage, 4064,
     /*  541621 */     GIR_EraseRootFromParent_Done,
     /*  541622 */   // Label 8937: @541622
     /*  541622 */   GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(541693), // Rule ID 4065 //
     /*  541627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  541638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  541641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  541644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541655 */     // MIs[0] passthru
     /*  541655 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541671 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  541674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541691 */     GIR_RootConstrainSelectedInstOperands,
     /*  541692 */     // GIR_Coverage, 4065,
     /*  541692 */     GIR_EraseRootFromParent_Done,
     /*  541693 */   // Label 8938: @541693
     /*  541693 */   GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(541764), // Rule ID 4074 //
     /*  541698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  541709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  541712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  541715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541726 */     // MIs[0] passthru
     /*  541726 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541742 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  541745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541762 */     GIR_RootConstrainSelectedInstOperands,
     /*  541763 */     // GIR_Coverage, 4074,
     /*  541763 */     GIR_EraseRootFromParent_Done,
     /*  541764 */   // Label 8939: @541764
     /*  541764 */   GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(541835), // Rule ID 4075 //
     /*  541769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  541780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  541783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  541786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541797 */     // MIs[0] passthru
     /*  541797 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541813 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  541816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541833 */     GIR_RootConstrainSelectedInstOperands,
     /*  541834 */     // GIR_Coverage, 4075,
     /*  541834 */     GIR_EraseRootFromParent_Done,
     /*  541835 */   // Label 8940: @541835
     /*  541835 */   GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(541906), // Rule ID 4084 //
     /*  541840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  541851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  541854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  541857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541868 */     // MIs[0] passthru
     /*  541868 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  541887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541904 */     GIR_RootConstrainSelectedInstOperands,
     /*  541905 */     // GIR_Coverage, 4084,
     /*  541905 */     GIR_EraseRootFromParent_Done,
     /*  541906 */   // Label 8941: @541906
     /*  541906 */   GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(541977), // Rule ID 4085 //
     /*  541911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  541922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  541925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  541928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541939 */     // MIs[0] passthru
     /*  541939 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541955 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  541958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541975 */     GIR_RootConstrainSelectedInstOperands,
     /*  541976 */     // GIR_Coverage, 4085,
     /*  541976 */     GIR_EraseRootFromParent_Done,
     /*  541977 */   // Label 8942: @541977
     /*  541977 */   GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(542048), // Rule ID 4094 //
     /*  541982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  541993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  541996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  541999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542010 */     // MIs[0] passthru
     /*  542010 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  542029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542046 */     GIR_RootConstrainSelectedInstOperands,
     /*  542047 */     // GIR_Coverage, 4094,
     /*  542047 */     GIR_EraseRootFromParent_Done,
     /*  542048 */   // Label 8943: @542048
     /*  542048 */   GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(542119), // Rule ID 4095 //
     /*  542053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  542064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  542067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  542070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542081 */     // MIs[0] passthru
     /*  542081 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542097 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  542100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542117 */     GIR_RootConstrainSelectedInstOperands,
     /*  542118 */     // GIR_Coverage, 4095,
     /*  542118 */     GIR_EraseRootFromParent_Done,
     /*  542119 */   // Label 8944: @542119
     /*  542119 */   GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(542190), // Rule ID 4104 //
     /*  542124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  542135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  542138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  542141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542152 */     // MIs[0] passthru
     /*  542152 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542168 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  542171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542188 */     GIR_RootConstrainSelectedInstOperands,
     /*  542189 */     // GIR_Coverage, 4104,
     /*  542189 */     GIR_EraseRootFromParent_Done,
     /*  542190 */   // Label 8945: @542190
     /*  542190 */   GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(542261), // Rule ID 4105 //
     /*  542195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  542206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  542209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  542212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542223 */     // MIs[0] passthru
     /*  542223 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542239 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  542242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542259 */     GIR_RootConstrainSelectedInstOperands,
     /*  542260 */     // GIR_Coverage, 4105,
     /*  542260 */     GIR_EraseRootFromParent_Done,
     /*  542261 */   // Label 8946: @542261
     /*  542261 */   GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(542332), // Rule ID 4114 //
     /*  542266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  542277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  542280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  542283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542294 */     // MIs[0] passthru
     /*  542294 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542310 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  542313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542330 */     GIR_RootConstrainSelectedInstOperands,
     /*  542331 */     // GIR_Coverage, 4114,
     /*  542331 */     GIR_EraseRootFromParent_Done,
     /*  542332 */   // Label 8947: @542332
     /*  542332 */   GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(542403), // Rule ID 4115 //
     /*  542337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  542348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  542351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  542354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542365 */     // MIs[0] passthru
     /*  542365 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542381 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  542384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542401 */     GIR_RootConstrainSelectedInstOperands,
     /*  542402 */     // GIR_Coverage, 4115,
     /*  542402 */     GIR_EraseRootFromParent_Done,
     /*  542403 */   // Label 8948: @542403
     /*  542403 */   GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(542474), // Rule ID 4124 //
     /*  542408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  542419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  542422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  542425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542436 */     // MIs[0] passthru
     /*  542436 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  542455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542472 */     GIR_RootConstrainSelectedInstOperands,
     /*  542473 */     // GIR_Coverage, 4124,
     /*  542473 */     GIR_EraseRootFromParent_Done,
     /*  542474 */   // Label 8949: @542474
     /*  542474 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(542545), // Rule ID 4125 //
     /*  542479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  542490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  542493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  542496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542507 */     // MIs[0] passthru
     /*  542507 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542523 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  542526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542543 */     GIR_RootConstrainSelectedInstOperands,
     /*  542544 */     // GIR_Coverage, 4125,
     /*  542544 */     GIR_EraseRootFromParent_Done,
     /*  542545 */   // Label 8950: @542545
     /*  542545 */   GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(542616), // Rule ID 4134 //
     /*  542550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  542561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  542564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  542567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542578 */     // MIs[0] passthru
     /*  542578 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  542597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542614 */     GIR_RootConstrainSelectedInstOperands,
     /*  542615 */     // GIR_Coverage, 4134,
     /*  542615 */     GIR_EraseRootFromParent_Done,
     /*  542616 */   // Label 8951: @542616
     /*  542616 */   GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(542687), // Rule ID 4135 //
     /*  542621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  542632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  542635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  542638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542649 */     // MIs[0] passthru
     /*  542649 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  542668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542685 */     GIR_RootConstrainSelectedInstOperands,
     /*  542686 */     // GIR_Coverage, 4135,
     /*  542686 */     GIR_EraseRootFromParent_Done,
     /*  542687 */   // Label 8952: @542687
     /*  542687 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(542758), // Rule ID 4144 //
     /*  542692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  542703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  542706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  542709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542720 */     // MIs[0] passthru
     /*  542720 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  542739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542756 */     GIR_RootConstrainSelectedInstOperands,
     /*  542757 */     // GIR_Coverage, 4144,
     /*  542757 */     GIR_EraseRootFromParent_Done,
     /*  542758 */   // Label 8953: @542758
     /*  542758 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(542829), // Rule ID 4145 //
     /*  542763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  542774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  542777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  542780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542791 */     // MIs[0] passthru
     /*  542791 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542807 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  542810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542827 */     GIR_RootConstrainSelectedInstOperands,
     /*  542828 */     // GIR_Coverage, 4145,
     /*  542828 */     GIR_EraseRootFromParent_Done,
     /*  542829 */   // Label 8954: @542829
     /*  542829 */   GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(542900), // Rule ID 4154 //
     /*  542834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  542845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  542848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  542851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542862 */     // MIs[0] passthru
     /*  542862 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542878 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  542881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542898 */     GIR_RootConstrainSelectedInstOperands,
     /*  542899 */     // GIR_Coverage, 4154,
     /*  542899 */     GIR_EraseRootFromParent_Done,
     /*  542900 */   // Label 8955: @542900
     /*  542900 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(542971), // Rule ID 4155 //
     /*  542905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  542916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  542919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  542922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542933 */     // MIs[0] passthru
     /*  542933 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542949 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  542952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542969 */     GIR_RootConstrainSelectedInstOperands,
     /*  542970 */     // GIR_Coverage, 4155,
     /*  542970 */     GIR_EraseRootFromParent_Done,
     /*  542971 */   // Label 8956: @542971
     /*  542971 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(543042), // Rule ID 4164 //
     /*  542976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  542979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  542987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  542990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  542993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543004 */     // MIs[0] passthru
     /*  543004 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  543023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543040 */     GIR_RootConstrainSelectedInstOperands,
     /*  543041 */     // GIR_Coverage, 4164,
     /*  543041 */     GIR_EraseRootFromParent_Done,
     /*  543042 */   // Label 8957: @543042
     /*  543042 */   GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(543113), // Rule ID 4165 //
     /*  543047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  543058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  543061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  543064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543075 */     // MIs[0] passthru
     /*  543075 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543091 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  543094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543111 */     GIR_RootConstrainSelectedInstOperands,
     /*  543112 */     // GIR_Coverage, 4165,
     /*  543112 */     GIR_EraseRootFromParent_Done,
     /*  543113 */   // Label 8958: @543113
     /*  543113 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(543184), // Rule ID 4174 //
     /*  543118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  543129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  543132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  543135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543146 */     // MIs[0] passthru
     /*  543146 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543162 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  543165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543182 */     GIR_RootConstrainSelectedInstOperands,
     /*  543183 */     // GIR_Coverage, 4174,
     /*  543183 */     GIR_EraseRootFromParent_Done,
     /*  543184 */   // Label 8959: @543184
     /*  543184 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(543255), // Rule ID 4175 //
     /*  543189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  543200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  543203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  543206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543217 */     // MIs[0] passthru
     /*  543217 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543233 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  543236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543253 */     GIR_RootConstrainSelectedInstOperands,
     /*  543254 */     // GIR_Coverage, 4175,
     /*  543254 */     GIR_EraseRootFromParent_Done,
     /*  543255 */   // Label 8960: @543255
     /*  543255 */   GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(543326), // Rule ID 4184 //
     /*  543260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  543271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  543274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  543277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543288 */     // MIs[0] passthru
     /*  543288 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543304 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  543307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543324 */     GIR_RootConstrainSelectedInstOperands,
     /*  543325 */     // GIR_Coverage, 4184,
     /*  543325 */     GIR_EraseRootFromParent_Done,
     /*  543326 */   // Label 8961: @543326
     /*  543326 */   GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(543397), // Rule ID 4185 //
     /*  543331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  543342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  543345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  543348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543359 */     // MIs[0] passthru
     /*  543359 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543375 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  543378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543395 */     GIR_RootConstrainSelectedInstOperands,
     /*  543396 */     // GIR_Coverage, 4185,
     /*  543396 */     GIR_EraseRootFromParent_Done,
     /*  543397 */   // Label 8962: @543397
     /*  543397 */   GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(543468), // Rule ID 4194 //
     /*  543402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  543413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  543416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  543419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543430 */     // MIs[0] passthru
     /*  543430 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543446 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  543449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543466 */     GIR_RootConstrainSelectedInstOperands,
     /*  543467 */     // GIR_Coverage, 4194,
     /*  543467 */     GIR_EraseRootFromParent_Done,
     /*  543468 */   // Label 8963: @543468
     /*  543468 */   GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(543539), // Rule ID 4195 //
     /*  543473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  543484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  543487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  543490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543501 */     // MIs[0] passthru
     /*  543501 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543517 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  543520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543537 */     GIR_RootConstrainSelectedInstOperands,
     /*  543538 */     // GIR_Coverage, 4195,
     /*  543538 */     GIR_EraseRootFromParent_Done,
     /*  543539 */   // Label 8964: @543539
     /*  543539 */   GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(543610), // Rule ID 4264 //
     /*  543544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  543555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  543558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  543561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543572 */     // MIs[0] passthru
     /*  543572 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543588 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  543591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543608 */     GIR_RootConstrainSelectedInstOperands,
     /*  543609 */     // GIR_Coverage, 4264,
     /*  543609 */     GIR_EraseRootFromParent_Done,
     /*  543610 */   // Label 8965: @543610
     /*  543610 */   GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(543681), // Rule ID 4265 //
     /*  543615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  543626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  543629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  543632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543643 */     // MIs[0] passthru
     /*  543643 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543659 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  543662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543679 */     GIR_RootConstrainSelectedInstOperands,
     /*  543680 */     // GIR_Coverage, 4265,
     /*  543680 */     GIR_EraseRootFromParent_Done,
     /*  543681 */   // Label 8966: @543681
     /*  543681 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(543752), // Rule ID 4274 //
     /*  543686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  543697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  543700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  543703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543714 */     // MIs[0] passthru
     /*  543714 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543730 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  543733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543750 */     GIR_RootConstrainSelectedInstOperands,
     /*  543751 */     // GIR_Coverage, 4274,
     /*  543751 */     GIR_EraseRootFromParent_Done,
     /*  543752 */   // Label 8967: @543752
     /*  543752 */   GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(543823), // Rule ID 4275 //
     /*  543757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  543768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  543771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  543774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543785 */     // MIs[0] passthru
     /*  543785 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543801 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  543804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543821 */     GIR_RootConstrainSelectedInstOperands,
     /*  543822 */     // GIR_Coverage, 4275,
     /*  543822 */     GIR_EraseRootFromParent_Done,
     /*  543823 */   // Label 8968: @543823
     /*  543823 */   GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(543894), // Rule ID 4284 //
     /*  543828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  543839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  543842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  543845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543856 */     // MIs[0] passthru
     /*  543856 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543872 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  543875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543892 */     GIR_RootConstrainSelectedInstOperands,
     /*  543893 */     // GIR_Coverage, 4284,
     /*  543893 */     GIR_EraseRootFromParent_Done,
     /*  543894 */   // Label 8969: @543894
     /*  543894 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(543965), // Rule ID 4285 //
     /*  543899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  543910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  543913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  543916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543927 */     // MIs[0] passthru
     /*  543927 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543943 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  543946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543963 */     GIR_RootConstrainSelectedInstOperands,
     /*  543964 */     // GIR_Coverage, 4285,
     /*  543964 */     GIR_EraseRootFromParent_Done,
     /*  543965 */   // Label 8970: @543965
     /*  543965 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(544036), // Rule ID 4294 //
     /*  543970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  543981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  543984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  543987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543998 */     // MIs[0] passthru
     /*  543998 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  544017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544034 */     GIR_RootConstrainSelectedInstOperands,
     /*  544035 */     // GIR_Coverage, 4294,
     /*  544035 */     GIR_EraseRootFromParent_Done,
     /*  544036 */   // Label 8971: @544036
     /*  544036 */   GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(544107), // Rule ID 4295 //
     /*  544041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  544052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  544055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  544058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544069 */     // MIs[0] passthru
     /*  544069 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544085 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  544088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544105 */     GIR_RootConstrainSelectedInstOperands,
     /*  544106 */     // GIR_Coverage, 4295,
     /*  544106 */     GIR_EraseRootFromParent_Done,
     /*  544107 */   // Label 8972: @544107
     /*  544107 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(544178), // Rule ID 4304 //
     /*  544112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  544123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  544126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  544129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544140 */     // MIs[0] passthru
     /*  544140 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544156 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  544159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544176 */     GIR_RootConstrainSelectedInstOperands,
     /*  544177 */     // GIR_Coverage, 4304,
     /*  544177 */     GIR_EraseRootFromParent_Done,
     /*  544178 */   // Label 8973: @544178
     /*  544178 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(544249), // Rule ID 4305 //
     /*  544183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  544194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  544197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  544200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544211 */     // MIs[0] passthru
     /*  544211 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544227 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  544230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544247 */     GIR_RootConstrainSelectedInstOperands,
     /*  544248 */     // GIR_Coverage, 4305,
     /*  544248 */     GIR_EraseRootFromParent_Done,
     /*  544249 */   // Label 8974: @544249
     /*  544249 */   GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(544320), // Rule ID 4314 //
     /*  544254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  544265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  544268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  544271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544282 */     // MIs[0] passthru
     /*  544282 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544298 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  544301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544318 */     GIR_RootConstrainSelectedInstOperands,
     /*  544319 */     // GIR_Coverage, 4314,
     /*  544319 */     GIR_EraseRootFromParent_Done,
     /*  544320 */   // Label 8975: @544320
     /*  544320 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(544391), // Rule ID 4315 //
     /*  544325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  544336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  544339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  544342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544353 */     // MIs[0] passthru
     /*  544353 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544369 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  544372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544389 */     GIR_RootConstrainSelectedInstOperands,
     /*  544390 */     // GIR_Coverage, 4315,
     /*  544390 */     GIR_EraseRootFromParent_Done,
     /*  544391 */   // Label 8976: @544391
     /*  544391 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(544462), // Rule ID 4324 //
     /*  544396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  544407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  544410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  544413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544424 */     // MIs[0] passthru
     /*  544424 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544440 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  544443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544460 */     GIR_RootConstrainSelectedInstOperands,
     /*  544461 */     // GIR_Coverage, 4324,
     /*  544461 */     GIR_EraseRootFromParent_Done,
     /*  544462 */   // Label 8977: @544462
     /*  544462 */   GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(544533), // Rule ID 4325 //
     /*  544467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  544478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  544481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  544484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544495 */     // MIs[0] passthru
     /*  544495 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544511 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  544514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544531 */     GIR_RootConstrainSelectedInstOperands,
     /*  544532 */     // GIR_Coverage, 4325,
     /*  544532 */     GIR_EraseRootFromParent_Done,
     /*  544533 */   // Label 8978: @544533
     /*  544533 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(544604), // Rule ID 4334 //
     /*  544538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  544549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  544552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  544555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544566 */     // MIs[0] passthru
     /*  544566 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544582 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  544585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544602 */     GIR_RootConstrainSelectedInstOperands,
     /*  544603 */     // GIR_Coverage, 4334,
     /*  544603 */     GIR_EraseRootFromParent_Done,
     /*  544604 */   // Label 8979: @544604
     /*  544604 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(544675), // Rule ID 4335 //
     /*  544609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  544620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  544623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  544626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544637 */     // MIs[0] passthru
     /*  544637 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544653 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  544656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544673 */     GIR_RootConstrainSelectedInstOperands,
     /*  544674 */     // GIR_Coverage, 4335,
     /*  544674 */     GIR_EraseRootFromParent_Done,
     /*  544675 */   // Label 8980: @544675
     /*  544675 */   GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(544746), // Rule ID 4344 //
     /*  544680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  544691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  544694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  544697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544708 */     // MIs[0] passthru
     /*  544708 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  544727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544744 */     GIR_RootConstrainSelectedInstOperands,
     /*  544745 */     // GIR_Coverage, 4344,
     /*  544745 */     GIR_EraseRootFromParent_Done,
     /*  544746 */   // Label 8981: @544746
     /*  544746 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(544817), // Rule ID 4345 //
     /*  544751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  544762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  544765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  544768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544779 */     // MIs[0] passthru
     /*  544779 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544795 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  544798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544815 */     GIR_RootConstrainSelectedInstOperands,
     /*  544816 */     // GIR_Coverage, 4345,
     /*  544816 */     GIR_EraseRootFromParent_Done,
     /*  544817 */   // Label 8982: @544817
     /*  544817 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(544888), // Rule ID 4354 //
     /*  544822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  544833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  544836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  544839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544850 */     // MIs[0] passthru
     /*  544850 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  544869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544886 */     GIR_RootConstrainSelectedInstOperands,
     /*  544887 */     // GIR_Coverage, 4354,
     /*  544887 */     GIR_EraseRootFromParent_Done,
     /*  544888 */   // Label 8983: @544888
     /*  544888 */   GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(544959), // Rule ID 4355 //
     /*  544893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  544904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  544907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  544910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544921 */     // MIs[0] passthru
     /*  544921 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544937 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  544940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544957 */     GIR_RootConstrainSelectedInstOperands,
     /*  544958 */     // GIR_Coverage, 4355,
     /*  544958 */     GIR_EraseRootFromParent_Done,
     /*  544959 */   // Label 8984: @544959
     /*  544959 */   GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(545030), // Rule ID 4364 //
     /*  544964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  544975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  544978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  544981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544992 */     // MIs[0] passthru
     /*  544992 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545008 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  545011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545028 */     GIR_RootConstrainSelectedInstOperands,
     /*  545029 */     // GIR_Coverage, 4364,
     /*  545029 */     GIR_EraseRootFromParent_Done,
     /*  545030 */   // Label 8985: @545030
     /*  545030 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(545101), // Rule ID 4365 //
     /*  545035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  545046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  545049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  545052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545063 */     // MIs[0] passthru
     /*  545063 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545079 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  545082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545099 */     GIR_RootConstrainSelectedInstOperands,
     /*  545100 */     // GIR_Coverage, 4365,
     /*  545100 */     GIR_EraseRootFromParent_Done,
     /*  545101 */   // Label 8986: @545101
     /*  545101 */   GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(545172), // Rule ID 4374 //
     /*  545106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  545117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  545120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  545123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545134 */     // MIs[0] passthru
     /*  545134 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545150 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  545153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545170 */     GIR_RootConstrainSelectedInstOperands,
     /*  545171 */     // GIR_Coverage, 4374,
     /*  545171 */     GIR_EraseRootFromParent_Done,
     /*  545172 */   // Label 8987: @545172
     /*  545172 */   GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(545243), // Rule ID 4375 //
     /*  545177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  545188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  545191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  545194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545205 */     // MIs[0] passthru
     /*  545205 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545221 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  545224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545241 */     GIR_RootConstrainSelectedInstOperands,
     /*  545242 */     // GIR_Coverage, 4375,
     /*  545242 */     GIR_EraseRootFromParent_Done,
     /*  545243 */   // Label 8988: @545243
     /*  545243 */   GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(545314), // Rule ID 4384 //
     /*  545248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  545259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  545262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  545265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545276 */     // MIs[0] passthru
     /*  545276 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  545295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545312 */     GIR_RootConstrainSelectedInstOperands,
     /*  545313 */     // GIR_Coverage, 4384,
     /*  545313 */     GIR_EraseRootFromParent_Done,
     /*  545314 */   // Label 8989: @545314
     /*  545314 */   GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(545385), // Rule ID 4385 //
     /*  545319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  545330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  545333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  545336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545347 */     // MIs[0] passthru
     /*  545347 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545363 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  545366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545383 */     GIR_RootConstrainSelectedInstOperands,
     /*  545384 */     // GIR_Coverage, 4385,
     /*  545384 */     GIR_EraseRootFromParent_Done,
     /*  545385 */   // Label 8990: @545385
     /*  545385 */   GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(545456), // Rule ID 4394 //
     /*  545390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  545401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  545404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  545407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545418 */     // MIs[0] passthru
     /*  545418 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545434 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  545437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545454 */     GIR_RootConstrainSelectedInstOperands,
     /*  545455 */     // GIR_Coverage, 4394,
     /*  545455 */     GIR_EraseRootFromParent_Done,
     /*  545456 */   // Label 8991: @545456
     /*  545456 */   GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(545527), // Rule ID 4395 //
     /*  545461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  545472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  545475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  545478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545489 */     // MIs[0] passthru
     /*  545489 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545505 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  545508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545525 */     GIR_RootConstrainSelectedInstOperands,
     /*  545526 */     // GIR_Coverage, 4395,
     /*  545526 */     GIR_EraseRootFromParent_Done,
     /*  545527 */   // Label 8992: @545527
     /*  545527 */   GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(545598), // Rule ID 4404 //
     /*  545532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  545543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  545546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  545549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545560 */     // MIs[0] passthru
     /*  545560 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545576 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  545579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545596 */     GIR_RootConstrainSelectedInstOperands,
     /*  545597 */     // GIR_Coverage, 4404,
     /*  545597 */     GIR_EraseRootFromParent_Done,
     /*  545598 */   // Label 8993: @545598
     /*  545598 */   GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(545669), // Rule ID 4405 //
     /*  545603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  545614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  545617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  545620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545631 */     // MIs[0] passthru
     /*  545631 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545647 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  545650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545667 */     GIR_RootConstrainSelectedInstOperands,
     /*  545668 */     // GIR_Coverage, 4405,
     /*  545668 */     GIR_EraseRootFromParent_Done,
     /*  545669 */   // Label 8994: @545669
     /*  545669 */   GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(545740), // Rule ID 4474 //
     /*  545674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  545682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  545685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  545688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  545691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545702 */     // MIs[0] passthru
     /*  545702 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545718 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  545718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  545721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545738 */     GIR_RootConstrainSelectedInstOperands,
     /*  545739 */     // GIR_Coverage, 4474,
     /*  545739 */     GIR_EraseRootFromParent_Done,
     /*  545740 */   // Label 8995: @545740
     /*  545740 */   GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(545811), // Rule ID 4475 //
     /*  545745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  545753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  545756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  545759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  545762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545773 */     // MIs[0] passthru
     /*  545773 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545789 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  545789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  545792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545809 */     GIR_RootConstrainSelectedInstOperands,
     /*  545810 */     // GIR_Coverage, 4475,
     /*  545810 */     GIR_EraseRootFromParent_Done,
     /*  545811 */   // Label 8996: @545811
     /*  545811 */   GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(545882), // Rule ID 4484 //
     /*  545816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  545824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  545827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  545830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  545833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545844 */     // MIs[0] passthru
     /*  545844 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  545860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  545863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545880 */     GIR_RootConstrainSelectedInstOperands,
     /*  545881 */     // GIR_Coverage, 4484,
     /*  545881 */     GIR_EraseRootFromParent_Done,
     /*  545882 */   // Label 8997: @545882
     /*  545882 */   GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(545953), // Rule ID 4485 //
     /*  545887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  545895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  545898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  545901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  545904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545915 */     // MIs[0] passthru
     /*  545915 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545931 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  545931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  545934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545951 */     GIR_RootConstrainSelectedInstOperands,
     /*  545952 */     // GIR_Coverage, 4485,
     /*  545952 */     GIR_EraseRootFromParent_Done,
     /*  545953 */   // Label 8998: @545953
     /*  545953 */   GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(546024), // Rule ID 4494 //
     /*  545958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  545966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  545969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  545972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  545975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545986 */     // MIs[0] passthru
     /*  545986 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  546005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546022 */     GIR_RootConstrainSelectedInstOperands,
     /*  546023 */     // GIR_Coverage, 4494,
     /*  546023 */     GIR_EraseRootFromParent_Done,
     /*  546024 */   // Label 8999: @546024
     /*  546024 */   GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(546095), // Rule ID 4495 //
     /*  546029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  546040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  546043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  546046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546057 */     // MIs[0] passthru
     /*  546057 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546073 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  546076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546093 */     GIR_RootConstrainSelectedInstOperands,
     /*  546094 */     // GIR_Coverage, 4495,
     /*  546094 */     GIR_EraseRootFromParent_Done,
     /*  546095 */   // Label 9000: @546095
     /*  546095 */   GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(546166), // Rule ID 4504 //
     /*  546100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  546111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  546114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  546117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546128 */     // MIs[0] passthru
     /*  546128 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546144 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  546147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546164 */     GIR_RootConstrainSelectedInstOperands,
     /*  546165 */     // GIR_Coverage, 4504,
     /*  546165 */     GIR_EraseRootFromParent_Done,
     /*  546166 */   // Label 9001: @546166
     /*  546166 */   GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(546237), // Rule ID 4505 //
     /*  546171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  546182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  546185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  546188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546199 */     // MIs[0] passthru
     /*  546199 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546215 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  546218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546235 */     GIR_RootConstrainSelectedInstOperands,
     /*  546236 */     // GIR_Coverage, 4505,
     /*  546236 */     GIR_EraseRootFromParent_Done,
     /*  546237 */   // Label 9002: @546237
     /*  546237 */   GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(546308), // Rule ID 4514 //
     /*  546242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  546253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  546256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  546259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546270 */     // MIs[0] passthru
     /*  546270 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546286 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  546289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546306 */     GIR_RootConstrainSelectedInstOperands,
     /*  546307 */     // GIR_Coverage, 4514,
     /*  546307 */     GIR_EraseRootFromParent_Done,
     /*  546308 */   // Label 9003: @546308
     /*  546308 */   GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(546379), // Rule ID 4515 //
     /*  546313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  546324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  546327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  546330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546341 */     // MIs[0] passthru
     /*  546341 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546357 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  546360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546377 */     GIR_RootConstrainSelectedInstOperands,
     /*  546378 */     // GIR_Coverage, 4515,
     /*  546378 */     GIR_EraseRootFromParent_Done,
     /*  546379 */   // Label 9004: @546379
     /*  546379 */   GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(546450), // Rule ID 4524 //
     /*  546384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  546395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  546398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  546401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546412 */     // MIs[0] passthru
     /*  546412 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546428 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  546431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546448 */     GIR_RootConstrainSelectedInstOperands,
     /*  546449 */     // GIR_Coverage, 4524,
     /*  546449 */     GIR_EraseRootFromParent_Done,
     /*  546450 */   // Label 9005: @546450
     /*  546450 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(546521), // Rule ID 4525 //
     /*  546455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  546466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  546469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  546472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546483 */     // MIs[0] passthru
     /*  546483 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546499 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  546502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546519 */     GIR_RootConstrainSelectedInstOperands,
     /*  546520 */     // GIR_Coverage, 4525,
     /*  546520 */     GIR_EraseRootFromParent_Done,
     /*  546521 */   // Label 9006: @546521
     /*  546521 */   GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(546592), // Rule ID 4534 //
     /*  546526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  546537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  546540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  546543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546554 */     // MIs[0] passthru
     /*  546554 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546570 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  546570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  546573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546590 */     GIR_RootConstrainSelectedInstOperands,
     /*  546591 */     // GIR_Coverage, 4534,
     /*  546591 */     GIR_EraseRootFromParent_Done,
     /*  546592 */   // Label 9007: @546592
     /*  546592 */   GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(546663), // Rule ID 4535 //
     /*  546597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  546608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  546611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  546614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546625 */     // MIs[0] passthru
     /*  546625 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546641 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  546641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  546644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546661 */     GIR_RootConstrainSelectedInstOperands,
     /*  546662 */     // GIR_Coverage, 4535,
     /*  546662 */     GIR_EraseRootFromParent_Done,
     /*  546663 */   // Label 9008: @546663
     /*  546663 */   GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(546734), // Rule ID 4544 //
     /*  546668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  546679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  546682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  546685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546696 */     // MIs[0] passthru
     /*  546696 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546712 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  546712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  546715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546732 */     GIR_RootConstrainSelectedInstOperands,
     /*  546733 */     // GIR_Coverage, 4544,
     /*  546733 */     GIR_EraseRootFromParent_Done,
     /*  546734 */   // Label 9009: @546734
     /*  546734 */   GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(546805), // Rule ID 4545 //
     /*  546739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  546750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  546753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  546756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546767 */     // MIs[0] passthru
     /*  546767 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546783 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  546783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  546786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546803 */     GIR_RootConstrainSelectedInstOperands,
     /*  546804 */     // GIR_Coverage, 4545,
     /*  546804 */     GIR_EraseRootFromParent_Done,
     /*  546805 */   // Label 9010: @546805
     /*  546805 */   GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(546876), // Rule ID 4554 //
     /*  546810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  546821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  546824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  546827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546838 */     // MIs[0] passthru
     /*  546838 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  546854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  546857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546874 */     GIR_RootConstrainSelectedInstOperands,
     /*  546875 */     // GIR_Coverage, 4554,
     /*  546875 */     GIR_EraseRootFromParent_Done,
     /*  546876 */   // Label 9011: @546876
     /*  546876 */   GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(546947), // Rule ID 4555 //
     /*  546881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  546892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  546895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  546898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546909 */     // MIs[0] passthru
     /*  546909 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546925 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  546925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  546928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546945 */     GIR_RootConstrainSelectedInstOperands,
     /*  546946 */     // GIR_Coverage, 4555,
     /*  546946 */     GIR_EraseRootFromParent_Done,
     /*  546947 */   // Label 9012: @546947
     /*  546947 */   GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(547018), // Rule ID 4564 //
     /*  546952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  546963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  546966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  546969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546980 */     // MIs[0] passthru
     /*  546980 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546996 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  546996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  546999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547016 */     GIR_RootConstrainSelectedInstOperands,
     /*  547017 */     // GIR_Coverage, 4564,
     /*  547017 */     GIR_EraseRootFromParent_Done,
     /*  547018 */   // Label 9013: @547018
     /*  547018 */   GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(547089), // Rule ID 4565 //
     /*  547023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  547034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  547037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  547040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547051 */     // MIs[0] passthru
     /*  547051 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547067 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  547067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  547070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547087 */     GIR_RootConstrainSelectedInstOperands,
     /*  547088 */     // GIR_Coverage, 4565,
     /*  547088 */     GIR_EraseRootFromParent_Done,
     /*  547089 */   // Label 9014: @547089
     /*  547089 */   GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(547160), // Rule ID 4574 //
     /*  547094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  547105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  547108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  547111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547122 */     // MIs[0] passthru
     /*  547122 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547138 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  547138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  547141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547158 */     GIR_RootConstrainSelectedInstOperands,
     /*  547159 */     // GIR_Coverage, 4574,
     /*  547159 */     GIR_EraseRootFromParent_Done,
     /*  547160 */   // Label 9015: @547160
     /*  547160 */   GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(547231), // Rule ID 4575 //
     /*  547165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  547176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  547179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  547182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547193 */     // MIs[0] passthru
     /*  547193 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547209 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  547209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  547212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547229 */     GIR_RootConstrainSelectedInstOperands,
     /*  547230 */     // GIR_Coverage, 4575,
     /*  547230 */     GIR_EraseRootFromParent_Done,
     /*  547231 */   // Label 9016: @547231
     /*  547231 */   GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(547302), // Rule ID 4584 //
     /*  547236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  547239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  547247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  547250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  547253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547264 */     // MIs[0] passthru
     /*  547264 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547280 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  547280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  547283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547300 */     GIR_RootConstrainSelectedInstOperands,
     /*  547301 */     // GIR_Coverage, 4584,
     /*  547301 */     GIR_EraseRootFromParent_Done,
     /*  547302 */   // Label 9017: @547302
     /*  547302 */   GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(547373), // Rule ID 4585 //
     /*  547307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  547310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  547318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  547321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  547324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547335 */     // MIs[0] passthru
     /*  547335 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547351 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  547351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  547354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547371 */     GIR_RootConstrainSelectedInstOperands,
     /*  547372 */     // GIR_Coverage, 4585,
     /*  547372 */     GIR_EraseRootFromParent_Done,
     /*  547373 */   // Label 9018: @547373
     /*  547373 */   GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(547444), // Rule ID 4594 //
     /*  547378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  547381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  547389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  547392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  547395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547406 */     // MIs[0] passthru
     /*  547406 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547422 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  547422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  547425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547442 */     GIR_RootConstrainSelectedInstOperands,
     /*  547443 */     // GIR_Coverage, 4594,
     /*  547443 */     GIR_EraseRootFromParent_Done,
     /*  547444 */   // Label 9019: @547444
     /*  547444 */   GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(547515), // Rule ID 4595 //
     /*  547449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  547452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  547460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  547463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  547466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547477 */     // MIs[0] passthru
     /*  547477 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547493 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  547493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  547496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547513 */     GIR_RootConstrainSelectedInstOperands,
     /*  547514 */     // GIR_Coverage, 4595,
     /*  547514 */     GIR_EraseRootFromParent_Done,
     /*  547515 */   // Label 9020: @547515
     /*  547515 */   GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(547586), // Rule ID 4604 //
     /*  547520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  547523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  547531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  547534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  547537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547548 */     // MIs[0] passthru
     /*  547548 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547564 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  547564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  547567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547584 */     GIR_RootConstrainSelectedInstOperands,
     /*  547585 */     // GIR_Coverage, 4604,
     /*  547585 */     GIR_EraseRootFromParent_Done,
     /*  547586 */   // Label 9021: @547586
     /*  547586 */   GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(547657), // Rule ID 4605 //
     /*  547591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  547594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  547602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  547605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  547608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547619 */     // MIs[0] passthru
     /*  547619 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547635 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  547635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  547638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547655 */     GIR_RootConstrainSelectedInstOperands,
     /*  547656 */     // GIR_Coverage, 4605,
     /*  547656 */     GIR_EraseRootFromParent_Done,
     /*  547657 */   // Label 9022: @547657
     /*  547657 */   GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(547728), // Rule ID 4614 //
     /*  547662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  547665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  547673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  547676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  547679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547690 */     // MIs[0] passthru
     /*  547690 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547706 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  547706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  547709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547726 */     GIR_RootConstrainSelectedInstOperands,
     /*  547727 */     // GIR_Coverage, 4614,
     /*  547727 */     GIR_EraseRootFromParent_Done,
     /*  547728 */   // Label 9023: @547728
     /*  547728 */   GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(547799), // Rule ID 4615 //
     /*  547733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  547736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  547744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  547747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  547750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547761 */     // MIs[0] passthru
     /*  547761 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547777 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  547777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  547780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547797 */     GIR_RootConstrainSelectedInstOperands,
     /*  547798 */     // GIR_Coverage, 4615,
     /*  547798 */     GIR_EraseRootFromParent_Done,
     /*  547799 */   // Label 9024: @547799
     /*  547799 */   GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(547870), // Rule ID 4684 //
     /*  547804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  547812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547832 */     // MIs[0] passthru
     /*  547832 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547848 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  547851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547868 */     GIR_RootConstrainSelectedInstOperands,
     /*  547869 */     // GIR_Coverage, 4684,
     /*  547869 */     GIR_EraseRootFromParent_Done,
     /*  547870 */   // Label 9025: @547870
     /*  547870 */   GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(547941), // Rule ID 4685 //
     /*  547875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  547883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547903 */     // MIs[0] passthru
     /*  547903 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547919 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  547922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547939 */     GIR_RootConstrainSelectedInstOperands,
     /*  547940 */     // GIR_Coverage, 4685,
     /*  547940 */     GIR_EraseRootFromParent_Done,
     /*  547941 */   // Label 9026: @547941
     /*  547941 */   GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(548012), // Rule ID 4694 //
     /*  547946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  547954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  547957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  547960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  547963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547974 */     // MIs[0] passthru
     /*  547974 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547990 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  547993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548010 */     GIR_RootConstrainSelectedInstOperands,
     /*  548011 */     // GIR_Coverage, 4694,
     /*  548011 */     GIR_EraseRootFromParent_Done,
     /*  548012 */   // Label 9027: @548012
     /*  548012 */   GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(548083), // Rule ID 4695 //
     /*  548017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  548028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  548031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  548034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548045 */     // MIs[0] passthru
     /*  548045 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548061 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  548064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548081 */     GIR_RootConstrainSelectedInstOperands,
     /*  548082 */     // GIR_Coverage, 4695,
     /*  548082 */     GIR_EraseRootFromParent_Done,
     /*  548083 */   // Label 9028: @548083
     /*  548083 */   GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(548154), // Rule ID 4704 //
     /*  548088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  548105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548116 */     // MIs[0] passthru
     /*  548116 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548132 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  548135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548152 */     GIR_RootConstrainSelectedInstOperands,
     /*  548153 */     // GIR_Coverage, 4704,
     /*  548153 */     GIR_EraseRootFromParent_Done,
     /*  548154 */   // Label 9029: @548154
     /*  548154 */   GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(548225), // Rule ID 4705 //
     /*  548159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  548176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548187 */     // MIs[0] passthru
     /*  548187 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548203 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  548206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548223 */     GIR_RootConstrainSelectedInstOperands,
     /*  548224 */     // GIR_Coverage, 4705,
     /*  548224 */     GIR_EraseRootFromParent_Done,
     /*  548225 */   // Label 9030: @548225
     /*  548225 */   GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(548296), // Rule ID 4714 //
     /*  548230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  548241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  548244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  548247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548258 */     // MIs[0] passthru
     /*  548258 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548274 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  548277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548294 */     GIR_RootConstrainSelectedInstOperands,
     /*  548295 */     // GIR_Coverage, 4714,
     /*  548295 */     GIR_EraseRootFromParent_Done,
     /*  548296 */   // Label 9031: @548296
     /*  548296 */   GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(548367), // Rule ID 4715 //
     /*  548301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  548312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  548315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  548318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548329 */     // MIs[0] passthru
     /*  548329 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548345 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  548348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548365 */     GIR_RootConstrainSelectedInstOperands,
     /*  548366 */     // GIR_Coverage, 4715,
     /*  548366 */     GIR_EraseRootFromParent_Done,
     /*  548367 */   // Label 9032: @548367
     /*  548367 */   GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(548438), // Rule ID 4724 //
     /*  548372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  548383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  548386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  548389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548400 */     // MIs[0] passthru
     /*  548400 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548416 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  548419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548436 */     GIR_RootConstrainSelectedInstOperands,
     /*  548437 */     // GIR_Coverage, 4724,
     /*  548437 */     GIR_EraseRootFromParent_Done,
     /*  548438 */   // Label 9033: @548438
     /*  548438 */   GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(548509), // Rule ID 4725 //
     /*  548443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  548454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  548457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  548460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548471 */     // MIs[0] passthru
     /*  548471 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548487 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  548490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548507 */     GIR_RootConstrainSelectedInstOperands,
     /*  548508 */     // GIR_Coverage, 4725,
     /*  548508 */     GIR_EraseRootFromParent_Done,
     /*  548509 */   // Label 9034: @548509
     /*  548509 */   GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(548580), // Rule ID 4734 //
     /*  548514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  548525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  548528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  548531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548542 */     // MIs[0] passthru
     /*  548542 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  548561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548578 */     GIR_RootConstrainSelectedInstOperands,
     /*  548579 */     // GIR_Coverage, 4734,
     /*  548579 */     GIR_EraseRootFromParent_Done,
     /*  548580 */   // Label 9035: @548580
     /*  548580 */   GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(548651), // Rule ID 4735 //
     /*  548585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  548596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  548599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  548602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548613 */     // MIs[0] passthru
     /*  548613 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548629 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  548632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548649 */     GIR_RootConstrainSelectedInstOperands,
     /*  548650 */     // GIR_Coverage, 4735,
     /*  548650 */     GIR_EraseRootFromParent_Done,
     /*  548651 */   // Label 9036: @548651
     /*  548651 */   GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(548722), // Rule ID 4744 //
     /*  548656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  548667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  548670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  548673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548684 */     // MIs[0] passthru
     /*  548684 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548700 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  548703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548720 */     GIR_RootConstrainSelectedInstOperands,
     /*  548721 */     // GIR_Coverage, 4744,
     /*  548721 */     GIR_EraseRootFromParent_Done,
     /*  548722 */   // Label 9037: @548722
     /*  548722 */   GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(548793), // Rule ID 4745 //
     /*  548727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  548738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  548741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  548744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548755 */     // MIs[0] passthru
     /*  548755 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548771 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  548774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548791 */     GIR_RootConstrainSelectedInstOperands,
     /*  548792 */     // GIR_Coverage, 4745,
     /*  548792 */     GIR_EraseRootFromParent_Done,
     /*  548793 */   // Label 9038: @548793
     /*  548793 */   GIM_Try, /*On fail goto*//*Label 9039*/ GIMT_Encode4(548864), // Rule ID 4754 //
     /*  548798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  548815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548826 */     // MIs[0] passthru
     /*  548826 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  548845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548862 */     GIR_RootConstrainSelectedInstOperands,
     /*  548863 */     // GIR_Coverage, 4754,
     /*  548863 */     GIR_EraseRootFromParent_Done,
     /*  548864 */   // Label 9039: @548864
     /*  548864 */   GIM_Try, /*On fail goto*//*Label 9040*/ GIMT_Encode4(548935), // Rule ID 4755 //
     /*  548869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  548886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548897 */     // MIs[0] passthru
     /*  548897 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548913 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  548916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548933 */     GIR_RootConstrainSelectedInstOperands,
     /*  548934 */     // GIR_Coverage, 4755,
     /*  548934 */     GIR_EraseRootFromParent_Done,
     /*  548935 */   // Label 9040: @548935
     /*  548935 */   GIM_Try, /*On fail goto*//*Label 9041*/ GIMT_Encode4(549006), // Rule ID 4764 //
     /*  548940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  548951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  548954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  548957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548968 */     // MIs[0] passthru
     /*  548968 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  548987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549004 */     GIR_RootConstrainSelectedInstOperands,
     /*  549005 */     // GIR_Coverage, 4764,
     /*  549005 */     GIR_EraseRootFromParent_Done,
     /*  549006 */   // Label 9041: @549006
     /*  549006 */   GIM_Try, /*On fail goto*//*Label 9042*/ GIMT_Encode4(549077), // Rule ID 4765 //
     /*  549011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  549022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  549025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  549028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549039 */     // MIs[0] passthru
     /*  549039 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  549058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549075 */     GIR_RootConstrainSelectedInstOperands,
     /*  549076 */     // GIR_Coverage, 4765,
     /*  549076 */     GIR_EraseRootFromParent_Done,
     /*  549077 */   // Label 9042: @549077
     /*  549077 */   GIM_Try, /*On fail goto*//*Label 9043*/ GIMT_Encode4(549148), // Rule ID 4774 //
     /*  549082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  549093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  549096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  549099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549110 */     // MIs[0] passthru
     /*  549110 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549126 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  549129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549146 */     GIR_RootConstrainSelectedInstOperands,
     /*  549147 */     // GIR_Coverage, 4774,
     /*  549147 */     GIR_EraseRootFromParent_Done,
     /*  549148 */   // Label 9043: @549148
     /*  549148 */   GIM_Try, /*On fail goto*//*Label 9044*/ GIMT_Encode4(549219), // Rule ID 4775 //
     /*  549153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  549164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  549167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  549170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549181 */     // MIs[0] passthru
     /*  549181 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549197 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  549200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549217 */     GIR_RootConstrainSelectedInstOperands,
     /*  549218 */     // GIR_Coverage, 4775,
     /*  549218 */     GIR_EraseRootFromParent_Done,
     /*  549219 */   // Label 9044: @549219
     /*  549219 */   GIM_Try, /*On fail goto*//*Label 9045*/ GIMT_Encode4(549290), // Rule ID 4784 //
     /*  549224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  549235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  549238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549252 */     // MIs[0] passthru
     /*  549252 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549268 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  549271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549288 */     GIR_RootConstrainSelectedInstOperands,
     /*  549289 */     // GIR_Coverage, 4784,
     /*  549289 */     GIR_EraseRootFromParent_Done,
     /*  549290 */   // Label 9045: @549290
     /*  549290 */   GIM_Try, /*On fail goto*//*Label 9046*/ GIMT_Encode4(549361), // Rule ID 4785 //
     /*  549295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  549306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  549309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549323 */     // MIs[0] passthru
     /*  549323 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549339 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  549342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549359 */     GIR_RootConstrainSelectedInstOperands,
     /*  549360 */     // GIR_Coverage, 4785,
     /*  549360 */     GIR_EraseRootFromParent_Done,
     /*  549361 */   // Label 9046: @549361
     /*  549361 */   GIM_Try, /*On fail goto*//*Label 9047*/ GIMT_Encode4(549432), // Rule ID 4794 //
     /*  549366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  549369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  549377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  549380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  549383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549394 */     // MIs[0] passthru
     /*  549394 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549410 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  549413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549430 */     GIR_RootConstrainSelectedInstOperands,
     /*  549431 */     // GIR_Coverage, 4794,
     /*  549431 */     GIR_EraseRootFromParent_Done,
     /*  549432 */   // Label 9047: @549432
     /*  549432 */   GIM_Try, /*On fail goto*//*Label 9048*/ GIMT_Encode4(549503), // Rule ID 4795 //
     /*  549437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  549440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  549448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  549451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  549454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549465 */     // MIs[0] passthru
     /*  549465 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549481 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  549484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549501 */     GIR_RootConstrainSelectedInstOperands,
     /*  549502 */     // GIR_Coverage, 4795,
     /*  549502 */     GIR_EraseRootFromParent_Done,
     /*  549503 */   // Label 9048: @549503
     /*  549503 */   GIM_Try, /*On fail goto*//*Label 9049*/ GIMT_Encode4(549574), // Rule ID 4804 //
     /*  549508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  549511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  549519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  549522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  549525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549536 */     // MIs[0] passthru
     /*  549536 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549552 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  549555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549572 */     GIR_RootConstrainSelectedInstOperands,
     /*  549573 */     // GIR_Coverage, 4804,
     /*  549573 */     GIR_EraseRootFromParent_Done,
     /*  549574 */   // Label 9049: @549574
     /*  549574 */   GIM_Try, /*On fail goto*//*Label 9050*/ GIMT_Encode4(549645), // Rule ID 4805 //
     /*  549579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  549582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  549590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  549593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  549596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549607 */     // MIs[0] passthru
     /*  549607 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  549626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549643 */     GIR_RootConstrainSelectedInstOperands,
     /*  549644 */     // GIR_Coverage, 4805,
     /*  549644 */     GIR_EraseRootFromParent_Done,
     /*  549645 */   // Label 9050: @549645
     /*  549645 */   GIM_Try, /*On fail goto*//*Label 9051*/ GIMT_Encode4(549716), // Rule ID 4814 //
     /*  549650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  549653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  549661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  549664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549678 */     // MIs[0] passthru
     /*  549678 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549694 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  549697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549714 */     GIR_RootConstrainSelectedInstOperands,
     /*  549715 */     // GIR_Coverage, 4814,
     /*  549715 */     GIR_EraseRootFromParent_Done,
     /*  549716 */   // Label 9051: @549716
     /*  549716 */   GIM_Try, /*On fail goto*//*Label 9052*/ GIMT_Encode4(549787), // Rule ID 4815 //
     /*  549721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  549724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  549732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  549735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549749 */     // MIs[0] passthru
     /*  549749 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549765 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  549768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549785 */     GIR_RootConstrainSelectedInstOperands,
     /*  549786 */     // GIR_Coverage, 4815,
     /*  549786 */     GIR_EraseRootFromParent_Done,
     /*  549787 */   // Label 9052: @549787
     /*  549787 */   GIM_Try, /*On fail goto*//*Label 9053*/ GIMT_Encode4(549858), // Rule ID 4824 //
     /*  549792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  549795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  549803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  549806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  549809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549820 */     // MIs[0] passthru
     /*  549820 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549836 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  549839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549856 */     GIR_RootConstrainSelectedInstOperands,
     /*  549857 */     // GIR_Coverage, 4824,
     /*  549857 */     GIR_EraseRootFromParent_Done,
     /*  549858 */   // Label 9053: @549858
     /*  549858 */   GIM_Try, /*On fail goto*//*Label 9054*/ GIMT_Encode4(549929), // Rule ID 4825 //
     /*  549863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  549866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  549874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  549877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  549880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549891 */     // MIs[0] passthru
     /*  549891 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549907 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  549910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549927 */     GIR_RootConstrainSelectedInstOperands,
     /*  549928 */     // GIR_Coverage, 4825,
     /*  549928 */     GIR_EraseRootFromParent_Done,
     /*  549929 */   // Label 9054: @549929
     /*  549929 */   GIM_Try, /*On fail goto*//*Label 9055*/ GIMT_Encode4(550001), // Rule ID 2680 //
     /*  549934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  549942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  549945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  549948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  549951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  549954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549980 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  549980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  549983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549999 */     GIR_RootConstrainSelectedInstOperands,
     /*  550000 */     // GIR_Coverage, 2680,
     /*  550000 */     GIR_EraseRootFromParent_Done,
     /*  550001 */   // Label 9055: @550001
     /*  550001 */   GIM_Try, /*On fail goto*//*Label 9056*/ GIMT_Encode4(550073), // Rule ID 2681 //
     /*  550006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  550014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  550017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  550026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550052 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  550052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  550055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550071 */     GIR_RootConstrainSelectedInstOperands,
     /*  550072 */     // GIR_Coverage, 2681,
     /*  550072 */     GIR_EraseRootFromParent_Done,
     /*  550073 */   // Label 9056: @550073
     /*  550073 */   GIM_Try, /*On fail goto*//*Label 9057*/ GIMT_Encode4(550148), // Rule ID 2684 //
     /*  550078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  550081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  550086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  550089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  550092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  550095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  550098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  550105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  550117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550124 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  550124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  550127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  550135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  550146 */     GIR_RootConstrainSelectedInstOperands,
     /*  550147 */     // GIR_Coverage, 2684,
     /*  550147 */     GIR_EraseRootFromParent_Done,
     /*  550148 */   // Label 9057: @550148
     /*  550148 */   GIM_Try, /*On fail goto*//*Label 9058*/ GIMT_Encode4(550223), // Rule ID 2685 //
     /*  550153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  550156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  550161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  550164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  550167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  550170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  550173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  550180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  550192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550199 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  550199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  550202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550208 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  550210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  550221 */     GIR_RootConstrainSelectedInstOperands,
     /*  550222 */     // GIR_Coverage, 2685,
     /*  550222 */     GIR_EraseRootFromParent_Done,
     /*  550223 */   // Label 9058: @550223
     /*  550223 */   GIM_Try, /*On fail goto*//*Label 9059*/ GIMT_Encode4(550298), // Rule ID 2712 //
     /*  550228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  550239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  550248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550274 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  550277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550296 */     GIR_RootConstrainSelectedInstOperands,
     /*  550297 */     // GIR_Coverage, 2712,
     /*  550297 */     GIR_EraseRootFromParent_Done,
     /*  550298 */   // Label 9059: @550298
     /*  550298 */   GIM_Try, /*On fail goto*//*Label 9060*/ GIMT_Encode4(550373), // Rule ID 2713 //
     /*  550303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  550314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  550323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550349 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  550352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550371 */     GIR_RootConstrainSelectedInstOperands,
     /*  550372 */     // GIR_Coverage, 2713,
     /*  550372 */     GIR_EraseRootFromParent_Done,
     /*  550373 */   // Label 9060: @550373
     /*  550373 */   GIM_Try, /*On fail goto*//*Label 9061*/ GIMT_Encode4(550445), // Rule ID 2726 //
     /*  550378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  550386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  550389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  550398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  550417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550424 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  550424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  550427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  550431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  550435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550443 */     GIR_RootConstrainSelectedInstOperands,
     /*  550444 */     // GIR_Coverage, 2726,
     /*  550444 */     GIR_EraseRootFromParent_Done,
     /*  550445 */   // Label 9061: @550445
     /*  550445 */   GIM_Try, /*On fail goto*//*Label 9062*/ GIMT_Encode4(550517), // Rule ID 2727 //
     /*  550450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  550458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  550461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  550470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  550489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550496 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  550496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  550499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  550503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  550507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550515 */     GIR_RootConstrainSelectedInstOperands,
     /*  550516 */     // GIR_Coverage, 2727,
     /*  550516 */     GIR_EraseRootFromParent_Done,
     /*  550517 */   // Label 9062: @550517
     /*  550517 */   GIM_Try, /*On fail goto*//*Label 9063*/ GIMT_Encode4(550592), // Rule ID 2746 //
     /*  550522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  550530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  550533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  550536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  550539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  550542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  550571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550590 */     GIR_RootConstrainSelectedInstOperands,
     /*  550591 */     // GIR_Coverage, 2746,
     /*  550591 */     GIR_EraseRootFromParent_Done,
     /*  550592 */   // Label 9063: @550592
     /*  550592 */   GIM_Try, /*On fail goto*//*Label 9064*/ GIMT_Encode4(550667), // Rule ID 2747 //
     /*  550597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  550605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  550608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  550611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  550614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  550617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550643 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  550646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550665 */     GIR_RootConstrainSelectedInstOperands,
     /*  550666 */     // GIR_Coverage, 2747,
     /*  550666 */     GIR_EraseRootFromParent_Done,
     /*  550667 */   // Label 9064: @550667
     /*  550667 */   GIM_Try, /*On fail goto*//*Label 9065*/ GIMT_Encode4(550742), // Rule ID 2772 //
     /*  550672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  550680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  550683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  550686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  550692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  550721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  550725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550740 */     GIR_RootConstrainSelectedInstOperands,
     /*  550741 */     // GIR_Coverage, 2772,
     /*  550741 */     GIR_EraseRootFromParent_Done,
     /*  550742 */   // Label 9065: @550742
     /*  550742 */   GIM_Try, /*On fail goto*//*Label 9066*/ GIMT_Encode4(550817), // Rule ID 2773 //
     /*  550747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  550755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  550758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  550761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  550767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550793 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  550796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  550800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550815 */     GIR_RootConstrainSelectedInstOperands,
     /*  550816 */     // GIR_Coverage, 2773,
     /*  550816 */     GIR_EraseRootFromParent_Done,
     /*  550817 */   // Label 9066: @550817
     /*  550817 */   GIM_Try, /*On fail goto*//*Label 9067*/ GIMT_Encode4(550892), // Rule ID 2784 //
     /*  550822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  550833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  550842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550868 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  550871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550890 */     GIR_RootConstrainSelectedInstOperands,
     /*  550891 */     // GIR_Coverage, 2784,
     /*  550891 */     GIR_EraseRootFromParent_Done,
     /*  550892 */   // Label 9067: @550892
     /*  550892 */   GIM_Try, /*On fail goto*//*Label 9068*/ GIMT_Encode4(550967), // Rule ID 2785 //
     /*  550897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  550908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  550917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550943 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  550946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550965 */     GIR_RootConstrainSelectedInstOperands,
     /*  550966 */     // GIR_Coverage, 2785,
     /*  550966 */     GIR_EraseRootFromParent_Done,
     /*  550967 */   // Label 9068: @550967
     /*  550967 */   GIM_Try, /*On fail goto*//*Label 9069*/ GIMT_Encode4(551042), // Rule ID 2792 //
     /*  550972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  550983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  550986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  550989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  550992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551018 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  551021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551040 */     GIR_RootConstrainSelectedInstOperands,
     /*  551041 */     // GIR_Coverage, 2792,
     /*  551041 */     GIR_EraseRootFromParent_Done,
     /*  551042 */   // Label 9069: @551042
     /*  551042 */   GIM_Try, /*On fail goto*//*Label 9070*/ GIMT_Encode4(551117), // Rule ID 2793 //
     /*  551047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  551058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  551061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  551064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  551067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551093 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  551096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551115 */     GIR_RootConstrainSelectedInstOperands,
     /*  551116 */     // GIR_Coverage, 2793,
     /*  551116 */     GIR_EraseRootFromParent_Done,
     /*  551117 */   // Label 9070: @551117
     /*  551117 */   GIM_Try, /*On fail goto*//*Label 9071*/ GIMT_Encode4(551192), // Rule ID 2800 //
     /*  551122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  551133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  551136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  551139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  551142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551168 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  551171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551190 */     GIR_RootConstrainSelectedInstOperands,
     /*  551191 */     // GIR_Coverage, 2800,
     /*  551191 */     GIR_EraseRootFromParent_Done,
     /*  551192 */   // Label 9071: @551192
     /*  551192 */   GIM_Try, /*On fail goto*//*Label 9072*/ GIMT_Encode4(551267), // Rule ID 2801 //
     /*  551197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  551208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  551211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  551214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  551217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551243 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  551246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551265 */     GIR_RootConstrainSelectedInstOperands,
     /*  551266 */     // GIR_Coverage, 2801,
     /*  551266 */     GIR_EraseRootFromParent_Done,
     /*  551267 */   // Label 9072: @551267
     /*  551267 */   GIM_Try, /*On fail goto*//*Label 9073*/ GIMT_Encode4(551342), // Rule ID 2808 //
     /*  551272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  551283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  551286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  551289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  551292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551318 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  551321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551340 */     GIR_RootConstrainSelectedInstOperands,
     /*  551341 */     // GIR_Coverage, 2808,
     /*  551341 */     GIR_EraseRootFromParent_Done,
     /*  551342 */   // Label 9073: @551342
     /*  551342 */   GIM_Try, /*On fail goto*//*Label 9074*/ GIMT_Encode4(551417), // Rule ID 2809 //
     /*  551347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  551358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  551361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  551364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  551367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551393 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  551396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551415 */     GIR_RootConstrainSelectedInstOperands,
     /*  551416 */     // GIR_Coverage, 2809,
     /*  551416 */     GIR_EraseRootFromParent_Done,
     /*  551417 */   // Label 9074: @551417
     /*  551417 */   GIM_Try, /*On fail goto*//*Label 9075*/ GIMT_Encode4(551492), // Rule ID 2816 //
     /*  551422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  551433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  551436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  551439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  551442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551468 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  551471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551490 */     GIR_RootConstrainSelectedInstOperands,
     /*  551491 */     // GIR_Coverage, 2816,
     /*  551491 */     GIR_EraseRootFromParent_Done,
     /*  551492 */   // Label 9075: @551492
     /*  551492 */   GIM_Try, /*On fail goto*//*Label 9076*/ GIMT_Encode4(551567), // Rule ID 2817 //
     /*  551497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  551508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  551511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  551514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  551517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551543 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  551546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551565 */     GIR_RootConstrainSelectedInstOperands,
     /*  551566 */     // GIR_Coverage, 2817,
     /*  551566 */     GIR_EraseRootFromParent_Done,
     /*  551567 */   // Label 9076: @551567
     /*  551567 */   GIM_Try, /*On fail goto*//*Label 9077*/ GIMT_Encode4(551642), // Rule ID 2824 //
     /*  551572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  551583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  551586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  551589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  551592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551618 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  551618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  551621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551640 */     GIR_RootConstrainSelectedInstOperands,
     /*  551641 */     // GIR_Coverage, 2824,
     /*  551641 */     GIR_EraseRootFromParent_Done,
     /*  551642 */   // Label 9077: @551642
     /*  551642 */   GIM_Try, /*On fail goto*//*Label 9078*/ GIMT_Encode4(551717), // Rule ID 2825 //
     /*  551647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  551658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  551661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  551664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  551667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551693 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  551693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  551696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551715 */     GIR_RootConstrainSelectedInstOperands,
     /*  551716 */     // GIR_Coverage, 2825,
     /*  551716 */     GIR_EraseRootFromParent_Done,
     /*  551717 */   // Label 9078: @551717
     /*  551717 */   GIM_Try, /*On fail goto*//*Label 9079*/ GIMT_Encode4(551792), // Rule ID 2832 //
     /*  551722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  551742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551768 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  551771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551790 */     GIR_RootConstrainSelectedInstOperands,
     /*  551791 */     // GIR_Coverage, 2832,
     /*  551791 */     GIR_EraseRootFromParent_Done,
     /*  551792 */   // Label 9079: @551792
     /*  551792 */   GIM_Try, /*On fail goto*//*Label 9080*/ GIMT_Encode4(551867), // Rule ID 2833 //
     /*  551797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  551817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551843 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  551846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551865 */     GIR_RootConstrainSelectedInstOperands,
     /*  551866 */     // GIR_Coverage, 2833,
     /*  551866 */     GIR_EraseRootFromParent_Done,
     /*  551867 */   // Label 9080: @551867
     /*  551867 */   GIM_Try, /*On fail goto*//*Label 9081*/ GIMT_Encode4(551942), // Rule ID 2840 //
     /*  551872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  551892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  551921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551940 */     GIR_RootConstrainSelectedInstOperands,
     /*  551941 */     // GIR_Coverage, 2840,
     /*  551941 */     GIR_EraseRootFromParent_Done,
     /*  551942 */   // Label 9081: @551942
     /*  551942 */   GIM_Try, /*On fail goto*//*Label 9082*/ GIMT_Encode4(552017), // Rule ID 2841 //
     /*  551947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  551967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551993 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  551996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552015 */     GIR_RootConstrainSelectedInstOperands,
     /*  552016 */     // GIR_Coverage, 2841,
     /*  552016 */     GIR_EraseRootFromParent_Done,
     /*  552017 */   // Label 9082: @552017
     /*  552017 */   GIM_Try, /*On fail goto*//*Label 9083*/ GIMT_Encode4(552092), // Rule ID 2848 //
     /*  552022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  552033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  552036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  552039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  552042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552068 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  552068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  552071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552090 */     GIR_RootConstrainSelectedInstOperands,
     /*  552091 */     // GIR_Coverage, 2848,
     /*  552091 */     GIR_EraseRootFromParent_Done,
     /*  552092 */   // Label 9083: @552092
     /*  552092 */   GIM_Try, /*On fail goto*//*Label 9084*/ GIMT_Encode4(552167), // Rule ID 2849 //
     /*  552097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  552108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  552111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  552114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  552117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552143 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  552143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  552146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552165 */     GIR_RootConstrainSelectedInstOperands,
     /*  552166 */     // GIR_Coverage, 2849,
     /*  552166 */     GIR_EraseRootFromParent_Done,
     /*  552167 */   // Label 9084: @552167
     /*  552167 */   GIM_Try, /*On fail goto*//*Label 9085*/ GIMT_Encode4(552242), // Rule ID 2856 //
     /*  552172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  552175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  552183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  552186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  552189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  552192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552218 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  552218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  552221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552240 */     GIR_RootConstrainSelectedInstOperands,
     /*  552241 */     // GIR_Coverage, 2856,
     /*  552241 */     GIR_EraseRootFromParent_Done,
     /*  552242 */   // Label 9085: @552242
     /*  552242 */   GIM_Try, /*On fail goto*//*Label 9086*/ GIMT_Encode4(552317), // Rule ID 2857 //
     /*  552247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  552250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  552258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  552261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  552264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  552267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552293 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  552293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  552296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552315 */     GIR_RootConstrainSelectedInstOperands,
     /*  552316 */     // GIR_Coverage, 2857,
     /*  552316 */     GIR_EraseRootFromParent_Done,
     /*  552317 */   // Label 9086: @552317
     /*  552317 */   GIM_Try, /*On fail goto*//*Label 9087*/ GIMT_Encode4(552392), // Rule ID 2864 //
     /*  552322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  552333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  552336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  552339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  552342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552368 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  552371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552390 */     GIR_RootConstrainSelectedInstOperands,
     /*  552391 */     // GIR_Coverage, 2864,
     /*  552391 */     GIR_EraseRootFromParent_Done,
     /*  552392 */   // Label 9087: @552392
     /*  552392 */   GIM_Try, /*On fail goto*//*Label 9088*/ GIMT_Encode4(552467), // Rule ID 2865 //
     /*  552397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  552408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  552411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  552414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  552417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552443 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  552446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552465 */     GIR_RootConstrainSelectedInstOperands,
     /*  552466 */     // GIR_Coverage, 2865,
     /*  552466 */     GIR_EraseRootFromParent_Done,
     /*  552467 */   // Label 9088: @552467
     /*  552467 */   GIM_Try, /*On fail goto*//*Label 9089*/ GIMT_Encode4(552542), // Rule ID 2872 //
     /*  552472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  552483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  552486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  552489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  552492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552518 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  552521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552540 */     GIR_RootConstrainSelectedInstOperands,
     /*  552541 */     // GIR_Coverage, 2872,
     /*  552541 */     GIR_EraseRootFromParent_Done,
     /*  552542 */   // Label 9089: @552542
     /*  552542 */   GIM_Try, /*On fail goto*//*Label 9090*/ GIMT_Encode4(552617), // Rule ID 2873 //
     /*  552547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  552558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  552561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  552564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  552567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552593 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  552596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552615 */     GIR_RootConstrainSelectedInstOperands,
     /*  552616 */     // GIR_Coverage, 2873,
     /*  552616 */     GIR_EraseRootFromParent_Done,
     /*  552617 */   // Label 9090: @552617
     /*  552617 */   GIM_Try, /*On fail goto*//*Label 9091*/ GIMT_Encode4(552692), // Rule ID 2880 //
     /*  552622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  552633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  552636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  552639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  552642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552668 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  552671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552690 */     GIR_RootConstrainSelectedInstOperands,
     /*  552691 */     // GIR_Coverage, 2880,
     /*  552691 */     GIR_EraseRootFromParent_Done,
     /*  552692 */   // Label 9091: @552692
     /*  552692 */   GIM_Try, /*On fail goto*//*Label 9092*/ GIMT_Encode4(552767), // Rule ID 2881 //
     /*  552697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  552708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  552711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  552714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  552717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552743 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  552746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552765 */     GIR_RootConstrainSelectedInstOperands,
     /*  552766 */     // GIR_Coverage, 2881,
     /*  552766 */     GIR_EraseRootFromParent_Done,
     /*  552767 */   // Label 9092: @552767
     /*  552767 */   GIM_Try, /*On fail goto*//*Label 9093*/ GIMT_Encode4(552842), // Rule ID 2888 //
     /*  552772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  552792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  552821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552840 */     GIR_RootConstrainSelectedInstOperands,
     /*  552841 */     // GIR_Coverage, 2888,
     /*  552841 */     GIR_EraseRootFromParent_Done,
     /*  552842 */   // Label 9093: @552842
     /*  552842 */   GIM_Try, /*On fail goto*//*Label 9094*/ GIMT_Encode4(552917), // Rule ID 2889 //
     /*  552847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  552867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  552896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552915 */     GIR_RootConstrainSelectedInstOperands,
     /*  552916 */     // GIR_Coverage, 2889,
     /*  552916 */     GIR_EraseRootFromParent_Done,
     /*  552917 */   // Label 9094: @552917
     /*  552917 */   GIM_Try, /*On fail goto*//*Label 9095*/ GIMT_Encode4(552992), // Rule ID 2896 //
     /*  552922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  552933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  552936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  552939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  552942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552968 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  552971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552990 */     GIR_RootConstrainSelectedInstOperands,
     /*  552991 */     // GIR_Coverage, 2896,
     /*  552991 */     GIR_EraseRootFromParent_Done,
     /*  552992 */   // Label 9095: @552992
     /*  552992 */   GIM_Try, /*On fail goto*//*Label 9096*/ GIMT_Encode4(553067), // Rule ID 2897 //
     /*  552997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  553008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  553011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  553014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  553017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553043 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  553043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  553046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  553062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553065 */     GIR_RootConstrainSelectedInstOperands,
     /*  553066 */     // GIR_Coverage, 2897,
     /*  553066 */     GIR_EraseRootFromParent_Done,
     /*  553067 */   // Label 9096: @553067
     /*  553067 */   GIM_Try, /*On fail goto*//*Label 9097*/ GIMT_Encode4(553142), // Rule ID 2904 //
     /*  553072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  553083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  553086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  553089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  553092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553118 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  553118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  553121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  553137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553140 */     GIR_RootConstrainSelectedInstOperands,
     /*  553141 */     // GIR_Coverage, 2904,
     /*  553141 */     GIR_EraseRootFromParent_Done,
     /*  553142 */   // Label 9097: @553142
     /*  553142 */   GIM_Try, /*On fail goto*//*Label 9098*/ GIMT_Encode4(553217), // Rule ID 2905 //
     /*  553147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  553158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  553161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  553164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  553167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553193 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  553193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  553196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  553212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553215 */     GIR_RootConstrainSelectedInstOperands,
     /*  553216 */     // GIR_Coverage, 2905,
     /*  553216 */     GIR_EraseRootFromParent_Done,
     /*  553217 */   // Label 9098: @553217
     /*  553217 */   GIM_Try, /*On fail goto*//*Label 9099*/ GIMT_Encode4(553292), // Rule ID 2912 //
     /*  553222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  553233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  553236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  553239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  553242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  553271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553290 */     GIR_RootConstrainSelectedInstOperands,
     /*  553291 */     // GIR_Coverage, 2912,
     /*  553291 */     GIR_EraseRootFromParent_Done,
     /*  553292 */   // Label 9099: @553292
     /*  553292 */   GIM_Try, /*On fail goto*//*Label 9100*/ GIMT_Encode4(553367), // Rule ID 2913 //
     /*  553297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  553308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  553311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  553314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  553317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553343 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  553346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553365 */     GIR_RootConstrainSelectedInstOperands,
     /*  553366 */     // GIR_Coverage, 2913,
     /*  553366 */     GIR_EraseRootFromParent_Done,
     /*  553367 */   // Label 9100: @553367
     /*  553367 */   GIM_Try, /*On fail goto*//*Label 9101*/ GIMT_Encode4(553442), // Rule ID 2920 //
     /*  553372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  553383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  553386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  553389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  553392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553418 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  553421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553440 */     GIR_RootConstrainSelectedInstOperands,
     /*  553441 */     // GIR_Coverage, 2920,
     /*  553441 */     GIR_EraseRootFromParent_Done,
     /*  553442 */   // Label 9101: @553442
     /*  553442 */   GIM_Try, /*On fail goto*//*Label 9102*/ GIMT_Encode4(553517), // Rule ID 2921 //
     /*  553447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  553458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  553461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  553464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  553467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553493 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  553496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553515 */     GIR_RootConstrainSelectedInstOperands,
     /*  553516 */     // GIR_Coverage, 2921,
     /*  553516 */     GIR_EraseRootFromParent_Done,
     /*  553517 */   // Label 9102: @553517
     /*  553517 */   GIM_Try, /*On fail goto*//*Label 9103*/ GIMT_Encode4(553592), // Rule ID 2928 //
     /*  553522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  553533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  553536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  553539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  553542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553568 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  553571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553590 */     GIR_RootConstrainSelectedInstOperands,
     /*  553591 */     // GIR_Coverage, 2928,
     /*  553591 */     GIR_EraseRootFromParent_Done,
     /*  553592 */   // Label 9103: @553592
     /*  553592 */   GIM_Try, /*On fail goto*//*Label 9104*/ GIMT_Encode4(553667), // Rule ID 2929 //
     /*  553597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  553608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  553611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  553614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  553617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553643 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  553646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553665 */     GIR_RootConstrainSelectedInstOperands,
     /*  553666 */     // GIR_Coverage, 2929,
     /*  553666 */     GIR_EraseRootFromParent_Done,
     /*  553667 */   // Label 9104: @553667
     /*  553667 */   GIM_Try, /*On fail goto*//*Label 9105*/ GIMT_Encode4(553742), // Rule ID 2936 //
     /*  553672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  553683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  553686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  553689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  553692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553718 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  553721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553740 */     GIR_RootConstrainSelectedInstOperands,
     /*  553741 */     // GIR_Coverage, 2936,
     /*  553741 */     GIR_EraseRootFromParent_Done,
     /*  553742 */   // Label 9105: @553742
     /*  553742 */   GIM_Try, /*On fail goto*//*Label 9106*/ GIMT_Encode4(553817), // Rule ID 2937 //
     /*  553747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  553758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  553761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  553764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  553767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553793 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  553796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553815 */     GIR_RootConstrainSelectedInstOperands,
     /*  553816 */     // GIR_Coverage, 2937,
     /*  553816 */     GIR_EraseRootFromParent_Done,
     /*  553817 */   // Label 9106: @553817
     /*  553817 */   GIM_Try, /*On fail goto*//*Label 9107*/ GIMT_Encode4(553892), // Rule ID 2944 //
     /*  553822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  553842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553868 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  553871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553890 */     GIR_RootConstrainSelectedInstOperands,
     /*  553891 */     // GIR_Coverage, 2944,
     /*  553891 */     GIR_EraseRootFromParent_Done,
     /*  553892 */   // Label 9107: @553892
     /*  553892 */   GIM_Try, /*On fail goto*//*Label 9108*/ GIMT_Encode4(553967), // Rule ID 2945 //
     /*  553897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  553917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553943 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  553946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553965 */     GIR_RootConstrainSelectedInstOperands,
     /*  553966 */     // GIR_Coverage, 2945,
     /*  553966 */     GIR_EraseRootFromParent_Done,
     /*  553967 */   // Label 9108: @553967
     /*  553967 */   GIM_Try, /*On fail goto*//*Label 9109*/ GIMT_Encode4(554042), // Rule ID 2952 //
     /*  553972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  553983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  553986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  553989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  553992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554018 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  554018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  554021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  554027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  554029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  554037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554040 */     GIR_RootConstrainSelectedInstOperands,
     /*  554041 */     // GIR_Coverage, 2952,
     /*  554041 */     GIR_EraseRootFromParent_Done,
     /*  554042 */   // Label 9109: @554042
     /*  554042 */   GIM_Try, /*On fail goto*//*Label 9110*/ GIMT_Encode4(554117), // Rule ID 2953 //
     /*  554047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  554050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  554055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  554058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  554061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  554064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  554067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554093 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  554093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  554096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  554102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  554104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  554112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554115 */     GIR_RootConstrainSelectedInstOperands,
     /*  554116 */     // GIR_Coverage, 2953,
     /*  554116 */     GIR_EraseRootFromParent_Done,
     /*  554117 */   // Label 9110: @554117
     /*  554117 */   GIM_Try, /*On fail goto*//*Label 9111*/ GIMT_Encode4(554192), // Rule ID 2968 //
     /*  554122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  554133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  554136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  554139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  554142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554168 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  554171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554190 */     GIR_RootConstrainSelectedInstOperands,
     /*  554191 */     // GIR_Coverage, 2968,
     /*  554191 */     GIR_EraseRootFromParent_Done,
     /*  554192 */   // Label 9111: @554192
     /*  554192 */   GIM_Try, /*On fail goto*//*Label 9112*/ GIMT_Encode4(554267), // Rule ID 2969 //
     /*  554197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  554208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  554211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  554214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  554217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554243 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  554246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554265 */     GIR_RootConstrainSelectedInstOperands,
     /*  554266 */     // GIR_Coverage, 2969,
     /*  554266 */     GIR_EraseRootFromParent_Done,
     /*  554267 */   // Label 9112: @554267
     /*  554267 */   GIM_Try, /*On fail goto*//*Label 9113*/ GIMT_Encode4(554342), // Rule ID 2972 //
     /*  554272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  554283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  554286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  554289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  554292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554318 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  554321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554340 */     GIR_RootConstrainSelectedInstOperands,
     /*  554341 */     // GIR_Coverage, 2972,
     /*  554341 */     GIR_EraseRootFromParent_Done,
     /*  554342 */   // Label 9113: @554342
     /*  554342 */   GIM_Try, /*On fail goto*//*Label 9114*/ GIMT_Encode4(554417), // Rule ID 2973 //
     /*  554347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  554358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  554361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  554364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  554367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554393 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  554396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554415 */     GIR_RootConstrainSelectedInstOperands,
     /*  554416 */     // GIR_Coverage, 2973,
     /*  554416 */     GIR_EraseRootFromParent_Done,
     /*  554417 */   // Label 9114: @554417
     /*  554417 */   GIM_Try, /*On fail goto*//*Label 9115*/ GIMT_Encode4(554492), // Rule ID 2976 //
     /*  554422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  554433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  554436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  554439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  554442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554468 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  554471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554490 */     GIR_RootConstrainSelectedInstOperands,
     /*  554491 */     // GIR_Coverage, 2976,
     /*  554491 */     GIR_EraseRootFromParent_Done,
     /*  554492 */   // Label 9115: @554492
     /*  554492 */   GIM_Try, /*On fail goto*//*Label 9116*/ GIMT_Encode4(554567), // Rule ID 2977 //
     /*  554497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  554508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  554511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  554514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  554517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554543 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  554546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554565 */     GIR_RootConstrainSelectedInstOperands,
     /*  554566 */     // GIR_Coverage, 2977,
     /*  554566 */     GIR_EraseRootFromParent_Done,
     /*  554567 */   // Label 9116: @554567
     /*  554567 */   GIM_Try, /*On fail goto*//*Label 9117*/ GIMT_Encode4(554642), // Rule ID 2980 //
     /*  554572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  554592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554618 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  554621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554640 */     GIR_RootConstrainSelectedInstOperands,
     /*  554641 */     // GIR_Coverage, 2980,
     /*  554641 */     GIR_EraseRootFromParent_Done,
     /*  554642 */   // Label 9117: @554642
     /*  554642 */   GIM_Try, /*On fail goto*//*Label 9118*/ GIMT_Encode4(554717), // Rule ID 2981 //
     /*  554647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  554667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554693 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  554696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554715 */     GIR_RootConstrainSelectedInstOperands,
     /*  554716 */     // GIR_Coverage, 2981,
     /*  554716 */     GIR_EraseRootFromParent_Done,
     /*  554717 */   // Label 9118: @554717
     /*  554717 */   GIM_Try, /*On fail goto*//*Label 9119*/ GIMT_Encode4(554792), // Rule ID 2984 //
     /*  554722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  554742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  554768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  554771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554790 */     GIR_RootConstrainSelectedInstOperands,
     /*  554791 */     // GIR_Coverage, 2984,
     /*  554791 */     GIR_EraseRootFromParent_Done,
     /*  554792 */   // Label 9119: @554792
     /*  554792 */   GIM_Try, /*On fail goto*//*Label 9120*/ GIMT_Encode4(554867), // Rule ID 2985 //
     /*  554797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  554817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554843 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  554843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  554846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554865 */     GIR_RootConstrainSelectedInstOperands,
     /*  554866 */     // GIR_Coverage, 2985,
     /*  554866 */     GIR_EraseRootFromParent_Done,
     /*  554867 */   // Label 9120: @554867
     /*  554867 */   GIM_Try, /*On fail goto*//*Label 9121*/ GIMT_Encode4(554942), // Rule ID 2988 //
     /*  554872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  554892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554918 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  554921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554940 */     GIR_RootConstrainSelectedInstOperands,
     /*  554941 */     // GIR_Coverage, 2988,
     /*  554941 */     GIR_EraseRootFromParent_Done,
     /*  554942 */   // Label 9121: @554942
     /*  554942 */   GIM_Try, /*On fail goto*//*Label 9122*/ GIMT_Encode4(555017), // Rule ID 2989 //
     /*  554947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  554967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554993 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  554996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555015 */     GIR_RootConstrainSelectedInstOperands,
     /*  555016 */     // GIR_Coverage, 2989,
     /*  555016 */     GIR_EraseRootFromParent_Done,
     /*  555017 */   // Label 9122: @555017
     /*  555017 */   GIM_Try, /*On fail goto*//*Label 9123*/ GIMT_Encode4(555092), // Rule ID 2992 //
     /*  555022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  555033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  555036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  555039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  555042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  555071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555090 */     GIR_RootConstrainSelectedInstOperands,
     /*  555091 */     // GIR_Coverage, 2992,
     /*  555091 */     GIR_EraseRootFromParent_Done,
     /*  555092 */   // Label 9123: @555092
     /*  555092 */   GIM_Try, /*On fail goto*//*Label 9124*/ GIMT_Encode4(555167), // Rule ID 2993 //
     /*  555097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  555108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  555111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  555114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  555117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555143 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  555146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555165 */     GIR_RootConstrainSelectedInstOperands,
     /*  555166 */     // GIR_Coverage, 2993,
     /*  555166 */     GIR_EraseRootFromParent_Done,
     /*  555167 */   // Label 9124: @555167
     /*  555167 */   GIM_Try, /*On fail goto*//*Label 9125*/ GIMT_Encode4(555242), // Rule ID 2996 //
     /*  555172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  555183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  555186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  555189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  555192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  555218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  555221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555240 */     GIR_RootConstrainSelectedInstOperands,
     /*  555241 */     // GIR_Coverage, 2996,
     /*  555241 */     GIR_EraseRootFromParent_Done,
     /*  555242 */   // Label 9125: @555242
     /*  555242 */   GIM_Try, /*On fail goto*//*Label 9126*/ GIMT_Encode4(555317), // Rule ID 2997 //
     /*  555247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  555258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  555261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  555264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  555267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555293 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  555293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  555296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555315 */     GIR_RootConstrainSelectedInstOperands,
     /*  555316 */     // GIR_Coverage, 2997,
     /*  555316 */     GIR_EraseRootFromParent_Done,
     /*  555317 */   // Label 9126: @555317
     /*  555317 */   GIM_Try, /*On fail goto*//*Label 9127*/ GIMT_Encode4(555392), // Rule ID 3000 //
     /*  555322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  555325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  555333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  555336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  555339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  555342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555368 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  555368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  555371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  555387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555390 */     GIR_RootConstrainSelectedInstOperands,
     /*  555391 */     // GIR_Coverage, 3000,
     /*  555391 */     GIR_EraseRootFromParent_Done,
     /*  555392 */   // Label 9127: @555392
     /*  555392 */   GIM_Try, /*On fail goto*//*Label 9128*/ GIMT_Encode4(555467), // Rule ID 3001 //
     /*  555397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  555400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  555408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  555411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  555414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  555417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555443 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  555443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  555446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  555462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555465 */     GIR_RootConstrainSelectedInstOperands,
     /*  555466 */     // GIR_Coverage, 3001,
     /*  555466 */     GIR_EraseRootFromParent_Done,
     /*  555467 */   // Label 9128: @555467
     /*  555467 */   GIM_Try, /*On fail goto*//*Label 9129*/ GIMT_Encode4(555542), // Rule ID 3004 //
     /*  555472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  555483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  555486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  555489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  555492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555518 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  555521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555540 */     GIR_RootConstrainSelectedInstOperands,
     /*  555541 */     // GIR_Coverage, 3004,
     /*  555541 */     GIR_EraseRootFromParent_Done,
     /*  555542 */   // Label 9129: @555542
     /*  555542 */   GIM_Try, /*On fail goto*//*Label 9130*/ GIMT_Encode4(555617), // Rule ID 3005 //
     /*  555547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  555558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  555561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  555564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  555567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555593 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  555596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555615 */     GIR_RootConstrainSelectedInstOperands,
     /*  555616 */     // GIR_Coverage, 3005,
     /*  555616 */     GIR_EraseRootFromParent_Done,
     /*  555617 */   // Label 9130: @555617
     /*  555617 */   GIM_Try, /*On fail goto*//*Label 9131*/ GIMT_Encode4(555692), // Rule ID 3008 //
     /*  555622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  555642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555668 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  555671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555690 */     GIR_RootConstrainSelectedInstOperands,
     /*  555691 */     // GIR_Coverage, 3008,
     /*  555691 */     GIR_EraseRootFromParent_Done,
     /*  555692 */   // Label 9131: @555692
     /*  555692 */   GIM_Try, /*On fail goto*//*Label 9132*/ GIMT_Encode4(555767), // Rule ID 3009 //
     /*  555697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  555717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555743 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  555746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555765 */     GIR_RootConstrainSelectedInstOperands,
     /*  555766 */     // GIR_Coverage, 3009,
     /*  555766 */     GIR_EraseRootFromParent_Done,
     /*  555767 */   // Label 9132: @555767
     /*  555767 */   GIM_Try, /*On fail goto*//*Label 9133*/ GIMT_Encode4(555842), // Rule ID 3012 //
     /*  555772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  555792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555818 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  555821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555840 */     GIR_RootConstrainSelectedInstOperands,
     /*  555841 */     // GIR_Coverage, 3012,
     /*  555841 */     GIR_EraseRootFromParent_Done,
     /*  555842 */   // Label 9133: @555842
     /*  555842 */   GIM_Try, /*On fail goto*//*Label 9134*/ GIMT_Encode4(555917), // Rule ID 3013 //
     /*  555847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  555867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555893 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  555896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555915 */     GIR_RootConstrainSelectedInstOperands,
     /*  555916 */     // GIR_Coverage, 3013,
     /*  555916 */     GIR_EraseRootFromParent_Done,
     /*  555917 */   // Label 9134: @555917
     /*  555917 */   GIM_Try, /*On fail goto*//*Label 9135*/ GIMT_Encode4(555992), // Rule ID 3016 //
     /*  555922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  555933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  555936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  555939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  555942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  555971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555990 */     GIR_RootConstrainSelectedInstOperands,
     /*  555991 */     // GIR_Coverage, 3016,
     /*  555991 */     GIR_EraseRootFromParent_Done,
     /*  555992 */   // Label 9135: @555992
     /*  555992 */   GIM_Try, /*On fail goto*//*Label 9136*/ GIMT_Encode4(556067), // Rule ID 3017 //
     /*  555997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  556008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  556011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  556014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  556017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  556043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  556046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556065 */     GIR_RootConstrainSelectedInstOperands,
     /*  556066 */     // GIR_Coverage, 3017,
     /*  556066 */     GIR_EraseRootFromParent_Done,
     /*  556067 */   // Label 9136: @556067
     /*  556067 */   GIM_Try, /*On fail goto*//*Label 9137*/ GIMT_Encode4(556142), // Rule ID 3020 //
     /*  556072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  556083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  556086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  556089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  556092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  556118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  556121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556140 */     GIR_RootConstrainSelectedInstOperands,
     /*  556141 */     // GIR_Coverage, 3020,
     /*  556141 */     GIR_EraseRootFromParent_Done,
     /*  556142 */   // Label 9137: @556142
     /*  556142 */   GIM_Try, /*On fail goto*//*Label 9138*/ GIMT_Encode4(556217), // Rule ID 3021 //
     /*  556147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  556158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  556161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  556164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  556167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556193 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  556193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  556196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556215 */     GIR_RootConstrainSelectedInstOperands,
     /*  556216 */     // GIR_Coverage, 3021,
     /*  556216 */     GIR_EraseRootFromParent_Done,
     /*  556217 */   // Label 9138: @556217
     /*  556217 */   GIM_Try, /*On fail goto*//*Label 9139*/ GIMT_Encode4(556292), // Rule ID 3024 //
     /*  556222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  556233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  556236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  556239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  556242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  556268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  556271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556290 */     GIR_RootConstrainSelectedInstOperands,
     /*  556291 */     // GIR_Coverage, 3024,
     /*  556291 */     GIR_EraseRootFromParent_Done,
     /*  556292 */   // Label 9139: @556292
     /*  556292 */   GIM_Try, /*On fail goto*//*Label 9140*/ GIMT_Encode4(556367), // Rule ID 3025 //
     /*  556297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  556308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  556311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  556314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  556317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556343 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  556343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  556346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556365 */     GIR_RootConstrainSelectedInstOperands,
     /*  556366 */     // GIR_Coverage, 3025,
     /*  556366 */     GIR_EraseRootFromParent_Done,
     /*  556367 */   // Label 9140: @556367
     /*  556367 */   GIM_Try, /*On fail goto*//*Label 9141*/ GIMT_Encode4(556442), // Rule ID 3028 //
     /*  556372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  556383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  556386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  556389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  556392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  556421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556440 */     GIR_RootConstrainSelectedInstOperands,
     /*  556441 */     // GIR_Coverage, 3028,
     /*  556441 */     GIR_EraseRootFromParent_Done,
     /*  556442 */   // Label 9141: @556442
     /*  556442 */   GIM_Try, /*On fail goto*//*Label 9142*/ GIMT_Encode4(556517), // Rule ID 3029 //
     /*  556447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  556458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  556461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  556464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  556467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  556496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556515 */     GIR_RootConstrainSelectedInstOperands,
     /*  556516 */     // GIR_Coverage, 3029,
     /*  556516 */     GIR_EraseRootFromParent_Done,
     /*  556517 */   // Label 9142: @556517
     /*  556517 */   GIM_Try, /*On fail goto*//*Label 9143*/ GIMT_Encode4(556592), // Rule ID 3032 //
     /*  556522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  556533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  556536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  556539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  556542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  556571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556590 */     GIR_RootConstrainSelectedInstOperands,
     /*  556591 */     // GIR_Coverage, 3032,
     /*  556591 */     GIR_EraseRootFromParent_Done,
     /*  556592 */   // Label 9143: @556592
     /*  556592 */   GIM_Try, /*On fail goto*//*Label 9144*/ GIMT_Encode4(556667), // Rule ID 3033 //
     /*  556597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  556608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  556611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  556614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  556617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556643 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  556646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556665 */     GIR_RootConstrainSelectedInstOperands,
     /*  556666 */     // GIR_Coverage, 3033,
     /*  556666 */     GIR_EraseRootFromParent_Done,
     /*  556667 */   // Label 9144: @556667
     /*  556667 */   GIM_Try, /*On fail goto*//*Label 9145*/ GIMT_Encode4(556742), // Rule ID 3036 //
     /*  556672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  556692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  556721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556740 */     GIR_RootConstrainSelectedInstOperands,
     /*  556741 */     // GIR_Coverage, 3036,
     /*  556741 */     GIR_EraseRootFromParent_Done,
     /*  556742 */   // Label 9145: @556742
     /*  556742 */   GIM_Try, /*On fail goto*//*Label 9146*/ GIMT_Encode4(556817), // Rule ID 3037 //
     /*  556747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  556767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556793 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  556796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556815 */     GIR_RootConstrainSelectedInstOperands,
     /*  556816 */     // GIR_Coverage, 3037,
     /*  556816 */     GIR_EraseRootFromParent_Done,
     /*  556817 */   // Label 9146: @556817
     /*  556817 */   GIM_Try, /*On fail goto*//*Label 9147*/ GIMT_Encode4(556892), // Rule ID 3040 //
     /*  556822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  556842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  556871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556890 */     GIR_RootConstrainSelectedInstOperands,
     /*  556891 */     // GIR_Coverage, 3040,
     /*  556891 */     GIR_EraseRootFromParent_Done,
     /*  556892 */   // Label 9147: @556892
     /*  556892 */   GIM_Try, /*On fail goto*//*Label 9148*/ GIMT_Encode4(556967), // Rule ID 3041 //
     /*  556897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  556917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  556946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556965 */     GIR_RootConstrainSelectedInstOperands,
     /*  556966 */     // GIR_Coverage, 3041,
     /*  556966 */     GIR_EraseRootFromParent_Done,
     /*  556967 */   // Label 9148: @556967
     /*  556967 */   GIM_Try, /*On fail goto*//*Label 9149*/ GIMT_Encode4(557042), // Rule ID 3044 //
     /*  556972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  556983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  556986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  556989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  556992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  557018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  557021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557040 */     GIR_RootConstrainSelectedInstOperands,
     /*  557041 */     // GIR_Coverage, 3044,
     /*  557041 */     GIR_EraseRootFromParent_Done,
     /*  557042 */   // Label 9149: @557042
     /*  557042 */   GIM_Try, /*On fail goto*//*Label 9150*/ GIMT_Encode4(557117), // Rule ID 3045 //
     /*  557047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  557050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  557058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  557061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  557064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  557067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557093 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  557093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  557096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557115 */     GIR_RootConstrainSelectedInstOperands,
     /*  557116 */     // GIR_Coverage, 3045,
     /*  557116 */     GIR_EraseRootFromParent_Done,
     /*  557117 */   // Label 9150: @557117
     /*  557117 */   GIM_Try, /*On fail goto*//*Label 9151*/ GIMT_Encode4(557192), // Rule ID 3048 //
     /*  557122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  557125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  557133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  557136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  557139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  557142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  557168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  557171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557190 */     GIR_RootConstrainSelectedInstOperands,
     /*  557191 */     // GIR_Coverage, 3048,
     /*  557191 */     GIR_EraseRootFromParent_Done,
     /*  557192 */   // Label 9151: @557192
     /*  557192 */   GIM_Try, /*On fail goto*//*Label 9152*/ GIMT_Encode4(557267), // Rule ID 3049 //
     /*  557197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  557200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  557208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  557211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  557214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  557217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557243 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  557243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  557246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557265 */     GIR_RootConstrainSelectedInstOperands,
     /*  557266 */     // GIR_Coverage, 3049,
     /*  557266 */     GIR_EraseRootFromParent_Done,
     /*  557267 */   // Label 9152: @557267
     /*  557267 */   GIM_Try, /*On fail goto*//*Label 9153*/ GIMT_Encode4(557342), // Rule ID 3052 //
     /*  557272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  557283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  557286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  557289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557318 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  557321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557340 */     GIR_RootConstrainSelectedInstOperands,
     /*  557341 */     // GIR_Coverage, 3052,
     /*  557341 */     GIR_EraseRootFromParent_Done,
     /*  557342 */   // Label 9153: @557342
     /*  557342 */   GIM_Try, /*On fail goto*//*Label 9154*/ GIMT_Encode4(557417), // Rule ID 3053 //
     /*  557347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  557358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  557361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  557364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557393 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  557396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557415 */     GIR_RootConstrainSelectedInstOperands,
     /*  557416 */     // GIR_Coverage, 3053,
     /*  557416 */     GIR_EraseRootFromParent_Done,
     /*  557417 */   // Label 9154: @557417
     /*  557417 */   GIM_Try, /*On fail goto*//*Label 9155*/ GIMT_Encode4(557492), // Rule ID 3056 //
     /*  557422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  557433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  557436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  557439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557468 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  557471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557490 */     GIR_RootConstrainSelectedInstOperands,
     /*  557491 */     // GIR_Coverage, 3056,
     /*  557491 */     GIR_EraseRootFromParent_Done,
     /*  557492 */   // Label 9155: @557492
     /*  557492 */   GIM_Try, /*On fail goto*//*Label 9156*/ GIMT_Encode4(557567), // Rule ID 3057 //
     /*  557497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  557508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  557511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  557514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557543 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  557546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557565 */     GIR_RootConstrainSelectedInstOperands,
     /*  557566 */     // GIR_Coverage, 3057,
     /*  557566 */     GIR_EraseRootFromParent_Done,
     /*  557567 */   // Label 9156: @557567
     /*  557567 */   GIM_Try, /*On fail goto*//*Label 9157*/ GIMT_Encode4(557642), // Rule ID 3060 //
     /*  557572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557618 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  557621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557640 */     GIR_RootConstrainSelectedInstOperands,
     /*  557641 */     // GIR_Coverage, 3060,
     /*  557641 */     GIR_EraseRootFromParent_Done,
     /*  557642 */   // Label 9157: @557642
     /*  557642 */   GIM_Try, /*On fail goto*//*Label 9158*/ GIMT_Encode4(557717), // Rule ID 3061 //
     /*  557647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557693 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  557696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557715 */     GIR_RootConstrainSelectedInstOperands,
     /*  557716 */     // GIR_Coverage, 3061,
     /*  557716 */     GIR_EraseRootFromParent_Done,
     /*  557717 */   // Label 9158: @557717
     /*  557717 */   GIM_Try, /*On fail goto*//*Label 9159*/ GIMT_Encode4(557792), // Rule ID 3064 //
     /*  557722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  557771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557790 */     GIR_RootConstrainSelectedInstOperands,
     /*  557791 */     // GIR_Coverage, 3064,
     /*  557791 */     GIR_EraseRootFromParent_Done,
     /*  557792 */   // Label 9159: @557792
     /*  557792 */   GIM_Try, /*On fail goto*//*Label 9160*/ GIMT_Encode4(557867), // Rule ID 3065 //
     /*  557797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  557846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557865 */     GIR_RootConstrainSelectedInstOperands,
     /*  557866 */     // GIR_Coverage, 3065,
     /*  557866 */     GIR_EraseRootFromParent_Done,
     /*  557867 */   // Label 9160: @557867
     /*  557867 */   GIM_Try, /*On fail goto*//*Label 9161*/ GIMT_Encode4(557942), // Rule ID 3068 //
     /*  557872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  557921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557940 */     GIR_RootConstrainSelectedInstOperands,
     /*  557941 */     // GIR_Coverage, 3068,
     /*  557941 */     GIR_EraseRootFromParent_Done,
     /*  557942 */   // Label 9161: @557942
     /*  557942 */   GIM_Try, /*On fail goto*//*Label 9162*/ GIMT_Encode4(558017), // Rule ID 3069 //
     /*  557947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557993 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  557996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558015 */     GIR_RootConstrainSelectedInstOperands,
     /*  558016 */     // GIR_Coverage, 3069,
     /*  558016 */     GIR_EraseRootFromParent_Done,
     /*  558017 */   // Label 9162: @558017
     /*  558017 */   GIM_Try, /*On fail goto*//*Label 9163*/ GIMT_Encode4(558092), // Rule ID 3072 //
     /*  558022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  558033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  558036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  558039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558068 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  558068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  558071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558090 */     GIR_RootConstrainSelectedInstOperands,
     /*  558091 */     // GIR_Coverage, 3072,
     /*  558091 */     GIR_EraseRootFromParent_Done,
     /*  558092 */   // Label 9163: @558092
     /*  558092 */   GIM_Try, /*On fail goto*//*Label 9164*/ GIMT_Encode4(558167), // Rule ID 3073 //
     /*  558097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  558108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  558111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  558114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558143 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  558143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  558146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558165 */     GIR_RootConstrainSelectedInstOperands,
     /*  558166 */     // GIR_Coverage, 3073,
     /*  558166 */     GIR_EraseRootFromParent_Done,
     /*  558167 */   // Label 9164: @558167
     /*  558167 */   GIM_Try, /*On fail goto*//*Label 9165*/ GIMT_Encode4(558242), // Rule ID 3076 //
     /*  558172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  558183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  558186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  558189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558218 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558240 */     GIR_RootConstrainSelectedInstOperands,
     /*  558241 */     // GIR_Coverage, 3076,
     /*  558241 */     GIR_EraseRootFromParent_Done,
     /*  558242 */   // Label 9165: @558242
     /*  558242 */   GIM_Try, /*On fail goto*//*Label 9166*/ GIMT_Encode4(558317), // Rule ID 3077 //
     /*  558247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  558258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  558261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  558264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558293 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558315 */     GIR_RootConstrainSelectedInstOperands,
     /*  558316 */     // GIR_Coverage, 3077,
     /*  558316 */     GIR_EraseRootFromParent_Done,
     /*  558317 */   // Label 9166: @558317
     /*  558317 */   GIM_Try, /*On fail goto*//*Label 9167*/ GIMT_Encode4(558392), // Rule ID 3080 //
     /*  558322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  558333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  558336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  558339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  558368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558390 */     GIR_RootConstrainSelectedInstOperands,
     /*  558391 */     // GIR_Coverage, 3080,
     /*  558391 */     GIR_EraseRootFromParent_Done,
     /*  558392 */   // Label 9167: @558392
     /*  558392 */   GIM_Try, /*On fail goto*//*Label 9168*/ GIMT_Encode4(558467), // Rule ID 3081 //
     /*  558397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  558408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  558411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  558414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558443 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  558443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558465 */     GIR_RootConstrainSelectedInstOperands,
     /*  558466 */     // GIR_Coverage, 3081,
     /*  558466 */     GIR_EraseRootFromParent_Done,
     /*  558467 */   // Label 9168: @558467
     /*  558467 */   GIM_Try, /*On fail goto*//*Label 9169*/ GIMT_Encode4(558542), // Rule ID 3084 //
     /*  558472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  558483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  558486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  558489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558518 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  558518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558540 */     GIR_RootConstrainSelectedInstOperands,
     /*  558541 */     // GIR_Coverage, 3084,
     /*  558541 */     GIR_EraseRootFromParent_Done,
     /*  558542 */   // Label 9169: @558542
     /*  558542 */   GIM_Try, /*On fail goto*//*Label 9170*/ GIMT_Encode4(558617), // Rule ID 3085 //
     /*  558547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  558558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  558561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  558564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558593 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  558593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558615 */     GIR_RootConstrainSelectedInstOperands,
     /*  558616 */     // GIR_Coverage, 3085,
     /*  558616 */     GIR_EraseRootFromParent_Done,
     /*  558617 */   // Label 9170: @558617
     /*  558617 */   GIM_Try, /*On fail goto*//*Label 9171*/ GIMT_Encode4(558692), // Rule ID 3088 //
     /*  558622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  558625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  558668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558690 */     GIR_RootConstrainSelectedInstOperands,
     /*  558691 */     // GIR_Coverage, 3088,
     /*  558691 */     GIR_EraseRootFromParent_Done,
     /*  558692 */   // Label 9171: @558692
     /*  558692 */   GIM_Try, /*On fail goto*//*Label 9172*/ GIMT_Encode4(558767), // Rule ID 3089 //
     /*  558697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  558700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558743 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  558743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558765 */     GIR_RootConstrainSelectedInstOperands,
     /*  558766 */     // GIR_Coverage, 3089,
     /*  558766 */     GIR_EraseRootFromParent_Done,
     /*  558767 */   // Label 9172: @558767
     /*  558767 */   GIM_Try, /*On fail goto*//*Label 9173*/ GIMT_Encode4(558842), // Rule ID 3092 //
     /*  558772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  558821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558840 */     GIR_RootConstrainSelectedInstOperands,
     /*  558841 */     // GIR_Coverage, 3092,
     /*  558841 */     GIR_EraseRootFromParent_Done,
     /*  558842 */   // Label 9173: @558842
     /*  558842 */   GIM_Try, /*On fail goto*//*Label 9174*/ GIMT_Encode4(558917), // Rule ID 3093 //
     /*  558847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558893 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  558896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558915 */     GIR_RootConstrainSelectedInstOperands,
     /*  558916 */     // GIR_Coverage, 3093,
     /*  558916 */     GIR_EraseRootFromParent_Done,
     /*  558917 */   // Label 9174: @558917
     /*  558917 */   GIM_Try, /*On fail goto*//*Label 9175*/ GIMT_Encode4(558992), // Rule ID 3096 //
     /*  558922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  558933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  558936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  558939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558968 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  558971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558990 */     GIR_RootConstrainSelectedInstOperands,
     /*  558991 */     // GIR_Coverage, 3096,
     /*  558991 */     GIR_EraseRootFromParent_Done,
     /*  558992 */   // Label 9175: @558992
     /*  558992 */   GIM_Try, /*On fail goto*//*Label 9176*/ GIMT_Encode4(559067), // Rule ID 3097 //
     /*  558997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  559008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  559011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  559014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559043 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  559043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  559046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559065 */     GIR_RootConstrainSelectedInstOperands,
     /*  559066 */     // GIR_Coverage, 3097,
     /*  559066 */     GIR_EraseRootFromParent_Done,
     /*  559067 */   // Label 9176: @559067
     /*  559067 */   GIM_Try, /*On fail goto*//*Label 9177*/ GIMT_Encode4(559142), // Rule ID 3100 //
     /*  559072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  559083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  559086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  559089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559118 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  559118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  559121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559140 */     GIR_RootConstrainSelectedInstOperands,
     /*  559141 */     // GIR_Coverage, 3100,
     /*  559141 */     GIR_EraseRootFromParent_Done,
     /*  559142 */   // Label 9177: @559142
     /*  559142 */   GIM_Try, /*On fail goto*//*Label 9178*/ GIMT_Encode4(559217), // Rule ID 3101 //
     /*  559147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  559158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  559161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  559164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559193 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  559193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  559196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559215 */     GIR_RootConstrainSelectedInstOperands,
     /*  559216 */     // GIR_Coverage, 3101,
     /*  559216 */     GIR_EraseRootFromParent_Done,
     /*  559217 */   // Label 9178: @559217
     /*  559217 */   GIM_Try, /*On fail goto*//*Label 9179*/ GIMT_Encode4(559292), // Rule ID 3104 //
     /*  559222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  559233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  559236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  559239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559268 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  559271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559290 */     GIR_RootConstrainSelectedInstOperands,
     /*  559291 */     // GIR_Coverage, 3104,
     /*  559291 */     GIR_EraseRootFromParent_Done,
     /*  559292 */   // Label 9179: @559292
     /*  559292 */   GIM_Try, /*On fail goto*//*Label 9180*/ GIMT_Encode4(559367), // Rule ID 3105 //
     /*  559297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  559308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  559311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  559314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559343 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  559346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559365 */     GIR_RootConstrainSelectedInstOperands,
     /*  559366 */     // GIR_Coverage, 3105,
     /*  559366 */     GIR_EraseRootFromParent_Done,
     /*  559367 */   // Label 9180: @559367
     /*  559367 */   GIM_Try, /*On fail goto*//*Label 9181*/ GIMT_Encode4(559442), // Rule ID 3108 //
     /*  559372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  559383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  559386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  559389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559418 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  559421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559440 */     GIR_RootConstrainSelectedInstOperands,
     /*  559441 */     // GIR_Coverage, 3108,
     /*  559441 */     GIR_EraseRootFromParent_Done,
     /*  559442 */   // Label 9181: @559442
     /*  559442 */   GIM_Try, /*On fail goto*//*Label 9182*/ GIMT_Encode4(559517), // Rule ID 3109 //
     /*  559447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  559458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  559461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  559464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559493 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  559496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559515 */     GIR_RootConstrainSelectedInstOperands,
     /*  559516 */     // GIR_Coverage, 3109,
     /*  559516 */     GIR_EraseRootFromParent_Done,
     /*  559517 */   // Label 9182: @559517
     /*  559517 */   GIM_Try, /*On fail goto*//*Label 9183*/ GIMT_Encode4(559592), // Rule ID 3112 //
     /*  559522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  559533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  559536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  559539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559568 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  559571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559590 */     GIR_RootConstrainSelectedInstOperands,
     /*  559591 */     // GIR_Coverage, 3112,
     /*  559591 */     GIR_EraseRootFromParent_Done,
     /*  559592 */   // Label 9183: @559592
     /*  559592 */   GIM_Try, /*On fail goto*//*Label 9184*/ GIMT_Encode4(559667), // Rule ID 3113 //
     /*  559597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  559608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  559611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  559614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559643 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  559646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559665 */     GIR_RootConstrainSelectedInstOperands,
     /*  559666 */     // GIR_Coverage, 3113,
     /*  559666 */     GIR_EraseRootFromParent_Done,
     /*  559667 */   // Label 9184: @559667
     /*  559667 */   GIM_Try, /*On fail goto*//*Label 9185*/ GIMT_Encode4(559742), // Rule ID 3116 //
     /*  559672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  559721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559740 */     GIR_RootConstrainSelectedInstOperands,
     /*  559741 */     // GIR_Coverage, 3116,
     /*  559741 */     GIR_EraseRootFromParent_Done,
     /*  559742 */   // Label 9185: @559742
     /*  559742 */   GIM_Try, /*On fail goto*//*Label 9186*/ GIMT_Encode4(559817), // Rule ID 3117 //
     /*  559747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  559796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559815 */     GIR_RootConstrainSelectedInstOperands,
     /*  559816 */     // GIR_Coverage, 3117,
     /*  559816 */     GIR_EraseRootFromParent_Done,
     /*  559817 */   // Label 9186: @559817
     /*  559817 */   GIM_Try, /*On fail goto*//*Label 9187*/ GIMT_Encode4(559892), // Rule ID 3120 //
     /*  559822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  559871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559890 */     GIR_RootConstrainSelectedInstOperands,
     /*  559891 */     // GIR_Coverage, 3120,
     /*  559891 */     GIR_EraseRootFromParent_Done,
     /*  559892 */   // Label 9187: @559892
     /*  559892 */   GIM_Try, /*On fail goto*//*Label 9188*/ GIMT_Encode4(559967), // Rule ID 3121 //
     /*  559897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559943 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  559946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559965 */     GIR_RootConstrainSelectedInstOperands,
     /*  559966 */     // GIR_Coverage, 3121,
     /*  559966 */     GIR_EraseRootFromParent_Done,
     /*  559967 */   // Label 9188: @559967
     /*  559967 */   GIM_Try, /*On fail goto*//*Label 9189*/ GIMT_Encode4(560042), // Rule ID 3124 //
     /*  559972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  559983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  559986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  559989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  560018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  560021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560040 */     GIR_RootConstrainSelectedInstOperands,
     /*  560041 */     // GIR_Coverage, 3124,
     /*  560041 */     GIR_EraseRootFromParent_Done,
     /*  560042 */   // Label 9189: @560042
     /*  560042 */   GIM_Try, /*On fail goto*//*Label 9190*/ GIMT_Encode4(560117), // Rule ID 3125 //
     /*  560047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  560058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  560061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  560064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560093 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  560093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  560096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560115 */     GIR_RootConstrainSelectedInstOperands,
     /*  560116 */     // GIR_Coverage, 3125,
     /*  560116 */     GIR_EraseRootFromParent_Done,
     /*  560117 */   // Label 9190: @560117
     /*  560117 */   GIM_Try, /*On fail goto*//*Label 9191*/ GIMT_Encode4(560192), // Rule ID 3128 //
     /*  560122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  560133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  560136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  560139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  560171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560190 */     GIR_RootConstrainSelectedInstOperands,
     /*  560191 */     // GIR_Coverage, 3128,
     /*  560191 */     GIR_EraseRootFromParent_Done,
     /*  560192 */   // Label 9191: @560192
     /*  560192 */   GIM_Try, /*On fail goto*//*Label 9192*/ GIMT_Encode4(560267), // Rule ID 3129 //
     /*  560197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  560208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  560211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  560214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  560246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560265 */     GIR_RootConstrainSelectedInstOperands,
     /*  560266 */     // GIR_Coverage, 3129,
     /*  560266 */     GIR_EraseRootFromParent_Done,
     /*  560267 */   // Label 9192: @560267
     /*  560267 */   GIM_Try, /*On fail goto*//*Label 9193*/ GIMT_Encode4(560342), // Rule ID 3132 //
     /*  560272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  560283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  560286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  560289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560318 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  560321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560340 */     GIR_RootConstrainSelectedInstOperands,
     /*  560341 */     // GIR_Coverage, 3132,
     /*  560341 */     GIR_EraseRootFromParent_Done,
     /*  560342 */   // Label 9193: @560342
     /*  560342 */   GIM_Try, /*On fail goto*//*Label 9194*/ GIMT_Encode4(560417), // Rule ID 3133 //
     /*  560347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  560358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  560361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  560364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560393 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  560396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560415 */     GIR_RootConstrainSelectedInstOperands,
     /*  560416 */     // GIR_Coverage, 3133,
     /*  560416 */     GIR_EraseRootFromParent_Done,
     /*  560417 */   // Label 9194: @560417
     /*  560417 */   GIM_Try, /*On fail goto*//*Label 9195*/ GIMT_Encode4(560492), // Rule ID 3136 //
     /*  560422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  560433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  560436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  560439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  560471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560490 */     GIR_RootConstrainSelectedInstOperands,
     /*  560491 */     // GIR_Coverage, 3136,
     /*  560491 */     GIR_EraseRootFromParent_Done,
     /*  560492 */   // Label 9195: @560492
     /*  560492 */   GIM_Try, /*On fail goto*//*Label 9196*/ GIMT_Encode4(560567), // Rule ID 3137 //
     /*  560497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  560508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  560511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  560514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560543 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  560546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560565 */     GIR_RootConstrainSelectedInstOperands,
     /*  560566 */     // GIR_Coverage, 3137,
     /*  560566 */     GIR_EraseRootFromParent_Done,
     /*  560567 */   // Label 9196: @560567
     /*  560567 */   GIM_Try, /*On fail goto*//*Label 9197*/ GIMT_Encode4(560642), // Rule ID 3228 //
     /*  560572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  560589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  560592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560618 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  560621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560640 */     GIR_RootConstrainSelectedInstOperands,
     /*  560641 */     // GIR_Coverage, 3228,
     /*  560641 */     GIR_EraseRootFromParent_Done,
     /*  560642 */   // Label 9197: @560642
     /*  560642 */   GIM_Try, /*On fail goto*//*Label 9198*/ GIMT_Encode4(560717), // Rule ID 3229 //
     /*  560647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  560664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  560667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560693 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  560696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560715 */     GIR_RootConstrainSelectedInstOperands,
     /*  560716 */     // GIR_Coverage, 3229,
     /*  560716 */     GIR_EraseRootFromParent_Done,
     /*  560717 */   // Label 9198: @560717
     /*  560717 */   GIM_Try, /*On fail goto*//*Label 9199*/ GIMT_Encode4(560792), // Rule ID 3232 //
     /*  560722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  560739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  560742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560768 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  560771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560790 */     GIR_RootConstrainSelectedInstOperands,
     /*  560791 */     // GIR_Coverage, 3232,
     /*  560791 */     GIR_EraseRootFromParent_Done,
     /*  560792 */   // Label 9199: @560792
     /*  560792 */   GIM_Try, /*On fail goto*//*Label 9200*/ GIMT_Encode4(560867), // Rule ID 3233 //
     /*  560797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  560814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  560817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560843 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  560846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560865 */     GIR_RootConstrainSelectedInstOperands,
     /*  560866 */     // GIR_Coverage, 3233,
     /*  560866 */     GIR_EraseRootFromParent_Done,
     /*  560867 */   // Label 9200: @560867
     /*  560867 */   GIM_Try, /*On fail goto*//*Label 9201*/ GIMT_Encode4(560942), // Rule ID 3236 //
     /*  560872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  560889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  560892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560918 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  560921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560940 */     GIR_RootConstrainSelectedInstOperands,
     /*  560941 */     // GIR_Coverage, 3236,
     /*  560941 */     GIR_EraseRootFromParent_Done,
     /*  560942 */   // Label 9201: @560942
     /*  560942 */   GIM_Try, /*On fail goto*//*Label 9202*/ GIMT_Encode4(561017), // Rule ID 3237 //
     /*  560947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  560964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  560967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560993 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  560996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561015 */     GIR_RootConstrainSelectedInstOperands,
     /*  561016 */     // GIR_Coverage, 3237,
     /*  561016 */     GIR_EraseRootFromParent_Done,
     /*  561017 */   // Label 9202: @561017
     /*  561017 */   GIM_Try, /*On fail goto*//*Label 9203*/ GIMT_Encode4(561092), // Rule ID 3240 //
     /*  561022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  561033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  561036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  561039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  561042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561068 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  561071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561090 */     GIR_RootConstrainSelectedInstOperands,
     /*  561091 */     // GIR_Coverage, 3240,
     /*  561091 */     GIR_EraseRootFromParent_Done,
     /*  561092 */   // Label 9203: @561092
     /*  561092 */   GIM_Try, /*On fail goto*//*Label 9204*/ GIMT_Encode4(561167), // Rule ID 3241 //
     /*  561097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  561108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  561111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  561114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  561117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561143 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  561146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561165 */     GIR_RootConstrainSelectedInstOperands,
     /*  561166 */     // GIR_Coverage, 3241,
     /*  561166 */     GIR_EraseRootFromParent_Done,
     /*  561167 */   // Label 9204: @561167
     /*  561167 */   GIM_Try, /*On fail goto*//*Label 9205*/ GIMT_Encode4(561242), // Rule ID 3244 //
     /*  561172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  561183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  561186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  561189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  561192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  561221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561240 */     GIR_RootConstrainSelectedInstOperands,
     /*  561241 */     // GIR_Coverage, 3244,
     /*  561241 */     GIR_EraseRootFromParent_Done,
     /*  561242 */   // Label 9205: @561242
     /*  561242 */   GIM_Try, /*On fail goto*//*Label 9206*/ GIMT_Encode4(561317), // Rule ID 3245 //
     /*  561247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  561258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  561261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  561264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  561267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561293 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  561296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561315 */     GIR_RootConstrainSelectedInstOperands,
     /*  561316 */     // GIR_Coverage, 3245,
     /*  561316 */     GIR_EraseRootFromParent_Done,
     /*  561317 */   // Label 9206: @561317
     /*  561317 */   GIM_Try, /*On fail goto*//*Label 9207*/ GIMT_Encode4(561392), // Rule ID 3248 //
     /*  561322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  561333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  561336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  561339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  561342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561368 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  561368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  561371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561390 */     GIR_RootConstrainSelectedInstOperands,
     /*  561391 */     // GIR_Coverage, 3248,
     /*  561391 */     GIR_EraseRootFromParent_Done,
     /*  561392 */   // Label 9207: @561392
     /*  561392 */   GIM_Try, /*On fail goto*//*Label 9208*/ GIMT_Encode4(561467), // Rule ID 3249 //
     /*  561397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  561408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  561411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  561414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  561417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561443 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  561443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  561446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561465 */     GIR_RootConstrainSelectedInstOperands,
     /*  561466 */     // GIR_Coverage, 3249,
     /*  561466 */     GIR_EraseRootFromParent_Done,
     /*  561467 */   // Label 9208: @561467
     /*  561467 */   GIM_Try, /*On fail goto*//*Label 9209*/ GIMT_Encode4(561542), // Rule ID 3252 //
     /*  561472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  561483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  561486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  561489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  561492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561518 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561540 */     GIR_RootConstrainSelectedInstOperands,
     /*  561541 */     // GIR_Coverage, 3252,
     /*  561541 */     GIR_EraseRootFromParent_Done,
     /*  561542 */   // Label 9209: @561542
     /*  561542 */   GIM_Try, /*On fail goto*//*Label 9210*/ GIMT_Encode4(561617), // Rule ID 3253 //
     /*  561547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  561558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  561561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  561564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  561567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561593 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561615 */     GIR_RootConstrainSelectedInstOperands,
     /*  561616 */     // GIR_Coverage, 3253,
     /*  561616 */     GIR_EraseRootFromParent_Done,
     /*  561617 */   // Label 9210: @561617
     /*  561617 */   GIM_Try, /*On fail goto*//*Label 9211*/ GIMT_Encode4(561692), // Rule ID 3256 //
     /*  561622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  561639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  561642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561690 */     GIR_RootConstrainSelectedInstOperands,
     /*  561691 */     // GIR_Coverage, 3256,
     /*  561691 */     GIR_EraseRootFromParent_Done,
     /*  561692 */   // Label 9211: @561692
     /*  561692 */   GIM_Try, /*On fail goto*//*Label 9212*/ GIMT_Encode4(561767), // Rule ID 3257 //
     /*  561697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  561714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  561717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561743 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561765 */     GIR_RootConstrainSelectedInstOperands,
     /*  561766 */     // GIR_Coverage, 3257,
     /*  561766 */     GIR_EraseRootFromParent_Done,
     /*  561767 */   // Label 9212: @561767
     /*  561767 */   GIM_Try, /*On fail goto*//*Label 9213*/ GIMT_Encode4(561842), // Rule ID 3260 //
     /*  561772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  561783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  561786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  561792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  561818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561840 */     GIR_RootConstrainSelectedInstOperands,
     /*  561841 */     // GIR_Coverage, 3260,
     /*  561841 */     GIR_EraseRootFromParent_Done,
     /*  561842 */   // Label 9213: @561842
     /*  561842 */   GIM_Try, /*On fail goto*//*Label 9214*/ GIMT_Encode4(561917), // Rule ID 3261 //
     /*  561847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  561858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  561861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  561867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561893 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  561893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561915 */     GIR_RootConstrainSelectedInstOperands,
     /*  561916 */     // GIR_Coverage, 3261,
     /*  561916 */     GIR_EraseRootFromParent_Done,
     /*  561917 */   // Label 9214: @561917
     /*  561917 */   GIM_Try, /*On fail goto*//*Label 9215*/ GIMT_Encode4(561992), // Rule ID 3264 //
     /*  561922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  561925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  561933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  561936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  561939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  561942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  561968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  561987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561990 */     GIR_RootConstrainSelectedInstOperands,
     /*  561991 */     // GIR_Coverage, 3264,
     /*  561991 */     GIR_EraseRootFromParent_Done,
     /*  561992 */   // Label 9215: @561992
     /*  561992 */   GIM_Try, /*On fail goto*//*Label 9216*/ GIMT_Encode4(562067), // Rule ID 3265 //
     /*  561997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  562000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  562008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  562011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  562014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  562017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562043 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  562043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  562046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  562062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562065 */     GIR_RootConstrainSelectedInstOperands,
     /*  562066 */     // GIR_Coverage, 3265,
     /*  562066 */     GIR_EraseRootFromParent_Done,
     /*  562067 */   // Label 9216: @562067
     /*  562067 */   GIM_Try, /*On fail goto*//*Label 9217*/ GIMT_Encode4(562142), // Rule ID 3268 //
     /*  562072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  562083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  562086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  562089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  562092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562118 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  562121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562140 */     GIR_RootConstrainSelectedInstOperands,
     /*  562141 */     // GIR_Coverage, 3268,
     /*  562141 */     GIR_EraseRootFromParent_Done,
     /*  562142 */   // Label 9217: @562142
     /*  562142 */   GIM_Try, /*On fail goto*//*Label 9218*/ GIMT_Encode4(562217), // Rule ID 3269 //
     /*  562147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  562158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  562161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  562164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  562167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562193 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  562196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562215 */     GIR_RootConstrainSelectedInstOperands,
     /*  562216 */     // GIR_Coverage, 3269,
     /*  562216 */     GIR_EraseRootFromParent_Done,
     /*  562217 */   // Label 9218: @562217
     /*  562217 */   GIM_Try, /*On fail goto*//*Label 9219*/ GIMT_Encode4(562292), // Rule ID 3272 //
     /*  562222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  562233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  562236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  562239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  562242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562268 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  562271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562290 */     GIR_RootConstrainSelectedInstOperands,
     /*  562291 */     // GIR_Coverage, 3272,
     /*  562291 */     GIR_EraseRootFromParent_Done,
     /*  562292 */   // Label 9219: @562292
     /*  562292 */   GIM_Try, /*On fail goto*//*Label 9220*/ GIMT_Encode4(562367), // Rule ID 3273 //
     /*  562297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  562308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  562311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  562314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  562317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562343 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  562346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562365 */     GIR_RootConstrainSelectedInstOperands,
     /*  562366 */     // GIR_Coverage, 3273,
     /*  562366 */     GIR_EraseRootFromParent_Done,
     /*  562367 */   // Label 9220: @562367
     /*  562367 */   GIM_Try, /*On fail goto*//*Label 9221*/ GIMT_Encode4(562442), // Rule ID 3276 //
     /*  562372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  562383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  562386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  562389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  562392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562418 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  562421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562440 */     GIR_RootConstrainSelectedInstOperands,
     /*  562441 */     // GIR_Coverage, 3276,
     /*  562441 */     GIR_EraseRootFromParent_Done,
     /*  562442 */   // Label 9221: @562442
     /*  562442 */   GIM_Try, /*On fail goto*//*Label 9222*/ GIMT_Encode4(562517), // Rule ID 3277 //
     /*  562447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  562458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  562461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  562464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  562467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562493 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  562496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562515 */     GIR_RootConstrainSelectedInstOperands,
     /*  562516 */     // GIR_Coverage, 3277,
     /*  562516 */     GIR_EraseRootFromParent_Done,
     /*  562517 */   // Label 9222: @562517
     /*  562517 */   GIM_Try, /*On fail goto*//*Label 9223*/ GIMT_Encode4(562592), // Rule ID 3280 //
     /*  562522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  562533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  562536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  562539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  562542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  562571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562590 */     GIR_RootConstrainSelectedInstOperands,
     /*  562591 */     // GIR_Coverage, 3280,
     /*  562591 */     GIR_EraseRootFromParent_Done,
     /*  562592 */   // Label 9223: @562592
     /*  562592 */   GIM_Try, /*On fail goto*//*Label 9224*/ GIMT_Encode4(562667), // Rule ID 3281 //
     /*  562597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  562608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  562611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  562614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  562617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562643 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  562646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562665 */     GIR_RootConstrainSelectedInstOperands,
     /*  562666 */     // GIR_Coverage, 3281,
     /*  562666 */     GIR_EraseRootFromParent_Done,
     /*  562667 */   // Label 9224: @562667
     /*  562667 */   GIM_Try, /*On fail goto*//*Label 9225*/ GIMT_Encode4(562742), // Rule ID 3284 //
     /*  562672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  562683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  562686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  562689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  562692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562718 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  562721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562740 */     GIR_RootConstrainSelectedInstOperands,
     /*  562741 */     // GIR_Coverage, 3284,
     /*  562741 */     GIR_EraseRootFromParent_Done,
     /*  562742 */   // Label 9225: @562742
     /*  562742 */   GIM_Try, /*On fail goto*//*Label 9226*/ GIMT_Encode4(562817), // Rule ID 3285 //
     /*  562747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  562758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  562761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  562764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  562767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562793 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  562796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562815 */     GIR_RootConstrainSelectedInstOperands,
     /*  562816 */     // GIR_Coverage, 3285,
     /*  562816 */     GIR_EraseRootFromParent_Done,
     /*  562817 */   // Label 9226: @562817
     /*  562817 */   GIM_Try, /*On fail goto*//*Label 9227*/ GIMT_Encode4(562892), // Rule ID 3288 //
     /*  562822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  562833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  562836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  562839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  562842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562868 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  562871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562890 */     GIR_RootConstrainSelectedInstOperands,
     /*  562891 */     // GIR_Coverage, 3288,
     /*  562891 */     GIR_EraseRootFromParent_Done,
     /*  562892 */   // Label 9227: @562892
     /*  562892 */   GIM_Try, /*On fail goto*//*Label 9228*/ GIMT_Encode4(562967), // Rule ID 3289 //
     /*  562897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  562908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  562911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  562914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  562917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562943 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  562946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562965 */     GIR_RootConstrainSelectedInstOperands,
     /*  562966 */     // GIR_Coverage, 3289,
     /*  562966 */     GIR_EraseRootFromParent_Done,
     /*  562967 */   // Label 9228: @562967
     /*  562967 */   GIM_Try, /*On fail goto*//*Label 9229*/ GIMT_Encode4(563042), // Rule ID 3292 //
     /*  562972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  562983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  562986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  562989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  562992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563018 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  563018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  563021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563040 */     GIR_RootConstrainSelectedInstOperands,
     /*  563041 */     // GIR_Coverage, 3292,
     /*  563041 */     GIR_EraseRootFromParent_Done,
     /*  563042 */   // Label 9229: @563042
     /*  563042 */   GIM_Try, /*On fail goto*//*Label 9230*/ GIMT_Encode4(563117), // Rule ID 3293 //
     /*  563047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  563058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  563061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  563064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  563067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563093 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  563093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  563096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563115 */     GIR_RootConstrainSelectedInstOperands,
     /*  563116 */     // GIR_Coverage, 3293,
     /*  563116 */     GIR_EraseRootFromParent_Done,
     /*  563117 */   // Label 9230: @563117
     /*  563117 */   GIM_Try, /*On fail goto*//*Label 9231*/ GIMT_Encode4(563192), // Rule ID 3296 //
     /*  563122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  563133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  563136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  563139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  563142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563168 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  563168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  563171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563190 */     GIR_RootConstrainSelectedInstOperands,
     /*  563191 */     // GIR_Coverage, 3296,
     /*  563191 */     GIR_EraseRootFromParent_Done,
     /*  563192 */   // Label 9231: @563192
     /*  563192 */   GIM_Try, /*On fail goto*//*Label 9232*/ GIMT_Encode4(563267), // Rule ID 3297 //
     /*  563197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  563208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  563211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  563214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  563217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563243 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  563243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  563246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563265 */     GIR_RootConstrainSelectedInstOperands,
     /*  563266 */     // GIR_Coverage, 3297,
     /*  563266 */     GIR_EraseRootFromParent_Done,
     /*  563267 */   // Label 9232: @563267
     /*  563267 */   GIM_Try, /*On fail goto*//*Label 9233*/ GIMT_Encode4(563342), // Rule ID 3300 //
     /*  563272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  563283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  563286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  563289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  563292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563318 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  563318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  563321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563340 */     GIR_RootConstrainSelectedInstOperands,
     /*  563341 */     // GIR_Coverage, 3300,
     /*  563341 */     GIR_EraseRootFromParent_Done,
     /*  563342 */   // Label 9233: @563342
     /*  563342 */   GIM_Try, /*On fail goto*//*Label 9234*/ GIMT_Encode4(563417), // Rule ID 3301 //
     /*  563347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  563358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  563361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  563364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  563367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563393 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  563393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  563396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563415 */     GIR_RootConstrainSelectedInstOperands,
     /*  563416 */     // GIR_Coverage, 3301,
     /*  563416 */     GIR_EraseRootFromParent_Done,
     /*  563417 */   // Label 9234: @563417
     /*  563417 */   GIM_Try, /*On fail goto*//*Label 9235*/ GIMT_Encode4(563492), // Rule ID 3304 //
     /*  563422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  563433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  563436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  563439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  563442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  563471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563490 */     GIR_RootConstrainSelectedInstOperands,
     /*  563491 */     // GIR_Coverage, 3304,
     /*  563491 */     GIR_EraseRootFromParent_Done,
     /*  563492 */   // Label 9235: @563492
     /*  563492 */   GIM_Try, /*On fail goto*//*Label 9236*/ GIMT_Encode4(563567), // Rule ID 3305 //
     /*  563497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  563508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  563511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  563514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  563517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563543 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  563546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563565 */     GIR_RootConstrainSelectedInstOperands,
     /*  563566 */     // GIR_Coverage, 3305,
     /*  563566 */     GIR_EraseRootFromParent_Done,
     /*  563567 */   // Label 9236: @563567
     /*  563567 */   GIM_Try, /*On fail goto*//*Label 9237*/ GIMT_Encode4(563642), // Rule ID 3308 //
     /*  563572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  563583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  563586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  563589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  563592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563618 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  563621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563640 */     GIR_RootConstrainSelectedInstOperands,
     /*  563641 */     // GIR_Coverage, 3308,
     /*  563641 */     GIR_EraseRootFromParent_Done,
     /*  563642 */   // Label 9237: @563642
     /*  563642 */   GIM_Try, /*On fail goto*//*Label 9238*/ GIMT_Encode4(563717), // Rule ID 3309 //
     /*  563647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  563658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  563661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  563664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  563667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563693 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  563696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563715 */     GIR_RootConstrainSelectedInstOperands,
     /*  563716 */     // GIR_Coverage, 3309,
     /*  563716 */     GIR_EraseRootFromParent_Done,
     /*  563717 */   // Label 9238: @563717
     /*  563717 */   GIM_Try, /*On fail goto*//*Label 9239*/ GIMT_Encode4(563792), // Rule ID 3312 //
     /*  563722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  563733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  563736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  563739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  563742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  563771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563790 */     GIR_RootConstrainSelectedInstOperands,
     /*  563791 */     // GIR_Coverage, 3312,
     /*  563791 */     GIR_EraseRootFromParent_Done,
     /*  563792 */   // Label 9239: @563792
     /*  563792 */   GIM_Try, /*On fail goto*//*Label 9240*/ GIMT_Encode4(563867), // Rule ID 3313 //
     /*  563797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  563808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  563811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  563814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  563817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563843 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  563846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563865 */     GIR_RootConstrainSelectedInstOperands,
     /*  563866 */     // GIR_Coverage, 3313,
     /*  563866 */     GIR_EraseRootFromParent_Done,
     /*  563867 */   // Label 9240: @563867
     /*  563867 */   GIM_Try, /*On fail goto*//*Label 9241*/ GIMT_Encode4(563942), // Rule ID 3316 //
     /*  563872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  563883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  563886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  563889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563918 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  563921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563940 */     GIR_RootConstrainSelectedInstOperands,
     /*  563941 */     // GIR_Coverage, 3316,
     /*  563941 */     GIR_EraseRootFromParent_Done,
     /*  563942 */   // Label 9241: @563942
     /*  563942 */   GIM_Try, /*On fail goto*//*Label 9242*/ GIMT_Encode4(564017), // Rule ID 3317 //
     /*  563947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  563958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  563961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  563964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563993 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  563996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564015 */     GIR_RootConstrainSelectedInstOperands,
     /*  564016 */     // GIR_Coverage, 3317,
     /*  564016 */     GIR_EraseRootFromParent_Done,
     /*  564017 */   // Label 9242: @564017
     /*  564017 */   GIM_Try, /*On fail goto*//*Label 9243*/ GIMT_Encode4(564092), // Rule ID 3320 //
     /*  564022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  564033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  564036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  564039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564068 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  564071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564090 */     GIR_RootConstrainSelectedInstOperands,
     /*  564091 */     // GIR_Coverage, 3320,
     /*  564091 */     GIR_EraseRootFromParent_Done,
     /*  564092 */   // Label 9243: @564092
     /*  564092 */   GIM_Try, /*On fail goto*//*Label 9244*/ GIMT_Encode4(564167), // Rule ID 3321 //
     /*  564097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  564108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  564111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  564114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564143 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  564146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564165 */     GIR_RootConstrainSelectedInstOperands,
     /*  564166 */     // GIR_Coverage, 3321,
     /*  564166 */     GIR_EraseRootFromParent_Done,
     /*  564167 */   // Label 9244: @564167
     /*  564167 */   GIM_Try, /*On fail goto*//*Label 9245*/ GIMT_Encode4(564242), // Rule ID 3324 //
     /*  564172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  564183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  564186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  564189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564218 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  564221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564240 */     GIR_RootConstrainSelectedInstOperands,
     /*  564241 */     // GIR_Coverage, 3324,
     /*  564241 */     GIR_EraseRootFromParent_Done,
     /*  564242 */   // Label 9245: @564242
     /*  564242 */   GIM_Try, /*On fail goto*//*Label 9246*/ GIMT_Encode4(564317), // Rule ID 3325 //
     /*  564247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  564258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  564261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  564264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564293 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  564296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564315 */     GIR_RootConstrainSelectedInstOperands,
     /*  564316 */     // GIR_Coverage, 3325,
     /*  564316 */     GIR_EraseRootFromParent_Done,
     /*  564317 */   // Label 9246: @564317
     /*  564317 */   GIM_Try, /*On fail goto*//*Label 9247*/ GIMT_Encode4(564392), // Rule ID 3328 //
     /*  564322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  564333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  564336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  564339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564368 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  564371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564390 */     GIR_RootConstrainSelectedInstOperands,
     /*  564391 */     // GIR_Coverage, 3328,
     /*  564391 */     GIR_EraseRootFromParent_Done,
     /*  564392 */   // Label 9247: @564392
     /*  564392 */   GIM_Try, /*On fail goto*//*Label 9248*/ GIMT_Encode4(564467), // Rule ID 3329 //
     /*  564397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  564408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  564411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  564414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564443 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  564446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564465 */     GIR_RootConstrainSelectedInstOperands,
     /*  564466 */     // GIR_Coverage, 3329,
     /*  564466 */     GIR_EraseRootFromParent_Done,
     /*  564467 */   // Label 9248: @564467
     /*  564467 */   GIM_Try, /*On fail goto*//*Label 9249*/ GIMT_Encode4(564542), // Rule ID 3332 //
     /*  564472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  564483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  564486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  564489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  564521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564540 */     GIR_RootConstrainSelectedInstOperands,
     /*  564541 */     // GIR_Coverage, 3332,
     /*  564541 */     GIR_EraseRootFromParent_Done,
     /*  564542 */   // Label 9249: @564542
     /*  564542 */   GIM_Try, /*On fail goto*//*Label 9250*/ GIMT_Encode4(564617), // Rule ID 3333 //
     /*  564547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  564558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  564561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  564564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564593 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  564596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564615 */     GIR_RootConstrainSelectedInstOperands,
     /*  564616 */     // GIR_Coverage, 3333,
     /*  564616 */     GIR_EraseRootFromParent_Done,
     /*  564617 */   // Label 9250: @564617
     /*  564617 */   GIM_Try, /*On fail goto*//*Label 9251*/ GIMT_Encode4(564692), // Rule ID 3336 //
     /*  564622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  564639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  564668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  564671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564690 */     GIR_RootConstrainSelectedInstOperands,
     /*  564691 */     // GIR_Coverage, 3336,
     /*  564691 */     GIR_EraseRootFromParent_Done,
     /*  564692 */   // Label 9251: @564692
     /*  564692 */   GIM_Try, /*On fail goto*//*Label 9252*/ GIMT_Encode4(564767), // Rule ID 3337 //
     /*  564697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  564714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564743 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  564743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  564746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564765 */     GIR_RootConstrainSelectedInstOperands,
     /*  564766 */     // GIR_Coverage, 3337,
     /*  564766 */     GIR_EraseRootFromParent_Done,
     /*  564767 */   // Label 9252: @564767
     /*  564767 */   GIM_Try, /*On fail goto*//*Label 9253*/ GIMT_Encode4(564842), // Rule ID 3340 //
     /*  564772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  564783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  564786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  564789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  564821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564840 */     GIR_RootConstrainSelectedInstOperands,
     /*  564841 */     // GIR_Coverage, 3340,
     /*  564841 */     GIR_EraseRootFromParent_Done,
     /*  564842 */   // Label 9253: @564842
     /*  564842 */   GIM_Try, /*On fail goto*//*Label 9254*/ GIMT_Encode4(564917), // Rule ID 3341 //
     /*  564847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  564858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  564861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  564864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564893 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11598:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  564896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564915 */     GIR_RootConstrainSelectedInstOperands,
     /*  564916 */     // GIR_Coverage, 3341,
     /*  564916 */     GIR_EraseRootFromParent_Done,
     /*  564917 */   // Label 9254: @564917
     /*  564917 */   GIM_Try, /*On fail goto*//*Label 9255*/ GIMT_Encode4(564992), // Rule ID 3344 //
     /*  564922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  564933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  564936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  564939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564968 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  564971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564990 */     GIR_RootConstrainSelectedInstOperands,
     /*  564991 */     // GIR_Coverage, 3344,
     /*  564991 */     GIR_EraseRootFromParent_Done,
     /*  564992 */   // Label 9255: @564992
     /*  564992 */   GIM_Try, /*On fail goto*//*Label 9256*/ GIMT_Encode4(565067), // Rule ID 3345 //
     /*  564997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  565008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  565011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  565014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565043 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  565046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565065 */     GIR_RootConstrainSelectedInstOperands,
     /*  565066 */     // GIR_Coverage, 3345,
     /*  565066 */     GIR_EraseRootFromParent_Done,
     /*  565067 */   // Label 9256: @565067
     /*  565067 */   GIM_Try, /*On fail goto*//*Label 9257*/ GIMT_Encode4(565142), // Rule ID 3348 //
     /*  565072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  565083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  565086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  565089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  565118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  565121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565140 */     GIR_RootConstrainSelectedInstOperands,
     /*  565141 */     // GIR_Coverage, 3348,
     /*  565141 */     GIR_EraseRootFromParent_Done,
     /*  565142 */   // Label 9257: @565142
     /*  565142 */   GIM_Try, /*On fail goto*//*Label 9258*/ GIMT_Encode4(565217), // Rule ID 3349 //
     /*  565147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  565158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  565161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  565164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565193 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  565193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  565196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565215 */     GIR_RootConstrainSelectedInstOperands,
     /*  565216 */     // GIR_Coverage, 3349,
     /*  565216 */     GIR_EraseRootFromParent_Done,
     /*  565217 */   // Label 9258: @565217
     /*  565217 */   GIM_Try, /*On fail goto*//*Label 9259*/ GIMT_Encode4(565292), // Rule ID 3352 //
     /*  565222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  565225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  565233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  565236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  565239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  565268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  565271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  565287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565290 */     GIR_RootConstrainSelectedInstOperands,
     /*  565291 */     // GIR_Coverage, 3352,
     /*  565291 */     GIR_EraseRootFromParent_Done,
     /*  565292 */   // Label 9259: @565292
     /*  565292 */   GIM_Try, /*On fail goto*//*Label 9260*/ GIMT_Encode4(565367), // Rule ID 3353 //
     /*  565297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  565300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  565308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  565311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  565314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565343 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  565343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  565346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  565362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565365 */     GIR_RootConstrainSelectedInstOperands,
     /*  565366 */     // GIR_Coverage, 3353,
     /*  565366 */     GIR_EraseRootFromParent_Done,
     /*  565367 */   // Label 9260: @565367
     /*  565367 */   GIM_Try, /*On fail goto*//*Label 9261*/ GIMT_Encode4(565442), // Rule ID 3356 //
     /*  565372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  565383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  565386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  565389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565418 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  565421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565440 */     GIR_RootConstrainSelectedInstOperands,
     /*  565441 */     // GIR_Coverage, 3356,
     /*  565441 */     GIR_EraseRootFromParent_Done,
     /*  565442 */   // Label 9261: @565442
     /*  565442 */   GIM_Try, /*On fail goto*//*Label 9262*/ GIMT_Encode4(565517), // Rule ID 3357 //
     /*  565447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  565458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  565461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  565464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565493 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  565496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565515 */     GIR_RootConstrainSelectedInstOperands,
     /*  565516 */     // GIR_Coverage, 3357,
     /*  565516 */     GIR_EraseRootFromParent_Done,
     /*  565517 */   // Label 9262: @565517
     /*  565517 */   GIM_Try, /*On fail goto*//*Label 9263*/ GIMT_Encode4(565592), // Rule ID 3360 //
     /*  565522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  565533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  565536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  565539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565568 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  565571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565590 */     GIR_RootConstrainSelectedInstOperands,
     /*  565591 */     // GIR_Coverage, 3360,
     /*  565591 */     GIR_EraseRootFromParent_Done,
     /*  565592 */   // Label 9263: @565592
     /*  565592 */   GIM_Try, /*On fail goto*//*Label 9264*/ GIMT_Encode4(565667), // Rule ID 3361 //
     /*  565597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  565608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  565611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  565614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565643 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  565646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565665 */     GIR_RootConstrainSelectedInstOperands,
     /*  565666 */     // GIR_Coverage, 3361,
     /*  565666 */     GIR_EraseRootFromParent_Done,
     /*  565667 */   // Label 9264: @565667
     /*  565667 */   GIM_Try, /*On fail goto*//*Label 9265*/ GIMT_Encode4(565742), // Rule ID 3364 //
     /*  565672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  565683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  565686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  565689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565718 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  565721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565740 */     GIR_RootConstrainSelectedInstOperands,
     /*  565741 */     // GIR_Coverage, 3364,
     /*  565741 */     GIR_EraseRootFromParent_Done,
     /*  565742 */   // Label 9265: @565742
     /*  565742 */   GIM_Try, /*On fail goto*//*Label 9266*/ GIMT_Encode4(565817), // Rule ID 3365 //
     /*  565747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  565758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  565761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  565764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565793 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  565796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565815 */     GIR_RootConstrainSelectedInstOperands,
     /*  565816 */     // GIR_Coverage, 3365,
     /*  565816 */     GIR_EraseRootFromParent_Done,
     /*  565817 */   // Label 9266: @565817
     /*  565817 */   GIM_Try, /*On fail goto*//*Label 9267*/ GIMT_Encode4(565892), // Rule ID 3368 //
     /*  565822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  565833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  565836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  565871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565890 */     GIR_RootConstrainSelectedInstOperands,
     /*  565891 */     // GIR_Coverage, 3368,
     /*  565891 */     GIR_EraseRootFromParent_Done,
     /*  565892 */   // Label 9267: @565892
     /*  565892 */   GIM_Try, /*On fail goto*//*Label 9268*/ GIMT_Encode4(565967), // Rule ID 3369 //
     /*  565897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  565908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  565911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565943 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  565946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565965 */     GIR_RootConstrainSelectedInstOperands,
     /*  565966 */     // GIR_Coverage, 3369,
     /*  565966 */     GIR_EraseRootFromParent_Done,
     /*  565967 */   // Label 9268: @565967
     /*  565967 */   GIM_Try, /*On fail goto*//*Label 9269*/ GIMT_Encode4(566042), // Rule ID 3372 //
     /*  565972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  565983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  565986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  565989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566018 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  566018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  566021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566040 */     GIR_RootConstrainSelectedInstOperands,
     /*  566041 */     // GIR_Coverage, 3372,
     /*  566041 */     GIR_EraseRootFromParent_Done,
     /*  566042 */   // Label 9269: @566042
     /*  566042 */   GIM_Try, /*On fail goto*//*Label 9270*/ GIMT_Encode4(566117), // Rule ID 3373 //
     /*  566047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  566058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  566061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  566064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566093 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  566093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  566096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566115 */     GIR_RootConstrainSelectedInstOperands,
     /*  566116 */     // GIR_Coverage, 3373,
     /*  566116 */     GIR_EraseRootFromParent_Done,
     /*  566117 */   // Label 9270: @566117
     /*  566117 */   GIM_Try, /*On fail goto*//*Label 9271*/ GIMT_Encode4(566192), // Rule ID 3376 //
     /*  566122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  566133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  566136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  566139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566168 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  566168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  566171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566190 */     GIR_RootConstrainSelectedInstOperands,
     /*  566191 */     // GIR_Coverage, 3376,
     /*  566191 */     GIR_EraseRootFromParent_Done,
     /*  566192 */   // Label 9271: @566192
     /*  566192 */   GIM_Try, /*On fail goto*//*Label 9272*/ GIMT_Encode4(566267), // Rule ID 3377 //
     /*  566197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  566208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  566211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  566214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566243 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  566243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  566246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566265 */     GIR_RootConstrainSelectedInstOperands,
     /*  566266 */     // GIR_Coverage, 3377,
     /*  566266 */     GIR_EraseRootFromParent_Done,
     /*  566267 */   // Label 9272: @566267
     /*  566267 */   GIM_Try, /*On fail goto*//*Label 9273*/ GIMT_Encode4(566342), // Rule ID 3380 //
     /*  566272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  566283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  566286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  566289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  566321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566340 */     GIR_RootConstrainSelectedInstOperands,
     /*  566341 */     // GIR_Coverage, 3380,
     /*  566341 */     GIR_EraseRootFromParent_Done,
     /*  566342 */   // Label 9273: @566342
     /*  566342 */   GIM_Try, /*On fail goto*//*Label 9274*/ GIMT_Encode4(566417), // Rule ID 3381 //
     /*  566347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  566358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  566361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  566364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  566396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566415 */     GIR_RootConstrainSelectedInstOperands,
     /*  566416 */     // GIR_Coverage, 3381,
     /*  566416 */     GIR_EraseRootFromParent_Done,
     /*  566417 */   // Label 9274: @566417
     /*  566417 */   GIM_Try, /*On fail goto*//*Label 9275*/ GIMT_Encode4(566492), // Rule ID 3384 //
     /*  566422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  566433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  566436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  566439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  566471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566490 */     GIR_RootConstrainSelectedInstOperands,
     /*  566491 */     // GIR_Coverage, 3384,
     /*  566491 */     GIR_EraseRootFromParent_Done,
     /*  566492 */   // Label 9275: @566492
     /*  566492 */   GIM_Try, /*On fail goto*//*Label 9276*/ GIMT_Encode4(566567), // Rule ID 3385 //
     /*  566497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  566508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  566511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  566514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  566546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566565 */     GIR_RootConstrainSelectedInstOperands,
     /*  566566 */     // GIR_Coverage, 3385,
     /*  566566 */     GIR_EraseRootFromParent_Done,
     /*  566567 */   // Label 9276: @566567
     /*  566567 */   GIM_Try, /*On fail goto*//*Label 9277*/ GIMT_Encode4(566642), // Rule ID 3388 //
     /*  566572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  566583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  566586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  566621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566640 */     GIR_RootConstrainSelectedInstOperands,
     /*  566641 */     // GIR_Coverage, 3388,
     /*  566641 */     GIR_EraseRootFromParent_Done,
     /*  566642 */   // Label 9277: @566642
     /*  566642 */   GIM_Try, /*On fail goto*//*Label 9278*/ GIMT_Encode4(566717), // Rule ID 3389 //
     /*  566647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  566658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  566661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566693 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  566696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566715 */     GIR_RootConstrainSelectedInstOperands,
     /*  566716 */     // GIR_Coverage, 3389,
     /*  566716 */     GIR_EraseRootFromParent_Done,
     /*  566717 */   // Label 9278: @566717
     /*  566717 */   GIM_Try, /*On fail goto*//*Label 9279*/ GIMT_Encode4(566792), // Rule ID 3392 //
     /*  566722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  566733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  566736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566768 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  566771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566790 */     GIR_RootConstrainSelectedInstOperands,
     /*  566791 */     // GIR_Coverage, 3392,
     /*  566791 */     GIR_EraseRootFromParent_Done,
     /*  566792 */   // Label 9279: @566792
     /*  566792 */   GIM_Try, /*On fail goto*//*Label 9280*/ GIMT_Encode4(566867), // Rule ID 3393 //
     /*  566797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  566808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  566811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566843 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  566846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566865 */     GIR_RootConstrainSelectedInstOperands,
     /*  566866 */     // GIR_Coverage, 3393,
     /*  566866 */     GIR_EraseRootFromParent_Done,
     /*  566867 */   // Label 9280: @566867
     /*  566867 */   GIM_Try, /*On fail goto*//*Label 9281*/ GIMT_Encode4(566942), // Rule ID 3396 //
     /*  566872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  566883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  566886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566918 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  566921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566940 */     GIR_RootConstrainSelectedInstOperands,
     /*  566941 */     // GIR_Coverage, 3396,
     /*  566941 */     GIR_EraseRootFromParent_Done,
     /*  566942 */   // Label 9281: @566942
     /*  566942 */   GIM_Try, /*On fail goto*//*Label 9282*/ GIMT_Encode4(567017), // Rule ID 3397 //
     /*  566947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  566958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  566961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566993 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  566996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  567012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567015 */     GIR_RootConstrainSelectedInstOperands,
     /*  567016 */     // GIR_Coverage, 3397,
     /*  567016 */     GIR_EraseRootFromParent_Done,
     /*  567017 */   // Label 9282: @567017
     /*  567017 */   GIM_Try, /*On fail goto*//*Label 9283*/ GIMT_Encode4(567092), // Rule ID 3400 //
     /*  567022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  567025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  567030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  567033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  567036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  567039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567068 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  567068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  567071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  567087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567090 */     GIR_RootConstrainSelectedInstOperands,
     /*  567091 */     // GIR_Coverage, 3400,
     /*  567091 */     GIR_EraseRootFromParent_Done,
     /*  567092 */   // Label 9283: @567092
     /*  567092 */   GIM_Try, /*On fail goto*//*Label 9284*/ GIMT_Encode4(567167), // Rule ID 3401 //
     /*  567097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  567100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  567105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  567108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  567111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  567114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567143 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  567143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  567146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  567162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567165 */     GIR_RootConstrainSelectedInstOperands,
     /*  567166 */     // GIR_Coverage, 3401,
     /*  567166 */     GIR_EraseRootFromParent_Done,
     /*  567167 */   // Label 9284: @567167
     /*  567167 */   GIM_Try, /*On fail goto*//*Label 9285*/ GIMT_Encode4(567242), // Rule ID 3404 //
     /*  567172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  567183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  567186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  567189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567218 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  567221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567240 */     GIR_RootConstrainSelectedInstOperands,
     /*  567241 */     // GIR_Coverage, 3404,
     /*  567241 */     GIR_EraseRootFromParent_Done,
     /*  567242 */   // Label 9285: @567242
     /*  567242 */   GIM_Try, /*On fail goto*//*Label 9286*/ GIMT_Encode4(567317), // Rule ID 3405 //
     /*  567247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  567258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  567261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  567264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567293 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  567296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567315 */     GIR_RootConstrainSelectedInstOperands,
     /*  567316 */     // GIR_Coverage, 3405,
     /*  567316 */     GIR_EraseRootFromParent_Done,
     /*  567317 */   // Label 9286: @567317
     /*  567317 */   GIM_Try, /*On fail goto*//*Label 9287*/ GIMT_Encode4(567392), // Rule ID 3408 //
     /*  567322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  567333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  567336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  567339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567368 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  567371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567390 */     GIR_RootConstrainSelectedInstOperands,
     /*  567391 */     // GIR_Coverage, 3408,
     /*  567391 */     GIR_EraseRootFromParent_Done,
     /*  567392 */   // Label 9287: @567392
     /*  567392 */   GIM_Try, /*On fail goto*//*Label 9288*/ GIMT_Encode4(567467), // Rule ID 3409 //
     /*  567397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  567408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  567411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  567414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567443 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  567446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567465 */     GIR_RootConstrainSelectedInstOperands,
     /*  567466 */     // GIR_Coverage, 3409,
     /*  567466 */     GIR_EraseRootFromParent_Done,
     /*  567467 */   // Label 9288: @567467
     /*  567467 */   GIM_Try, /*On fail goto*//*Label 9289*/ GIMT_Encode4(567542), // Rule ID 3412 //
     /*  567472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  567483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  567486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  567489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567518 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  567521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567540 */     GIR_RootConstrainSelectedInstOperands,
     /*  567541 */     // GIR_Coverage, 3412,
     /*  567541 */     GIR_EraseRootFromParent_Done,
     /*  567542 */   // Label 9289: @567542
     /*  567542 */   GIM_Try, /*On fail goto*//*Label 9290*/ GIMT_Encode4(567617), // Rule ID 3413 //
     /*  567547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  567558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  567561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  567564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567593 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  567596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567615 */     GIR_RootConstrainSelectedInstOperands,
     /*  567616 */     // GIR_Coverage, 3413,
     /*  567616 */     GIR_EraseRootFromParent_Done,
     /*  567617 */   // Label 9290: @567617
     /*  567617 */   GIM_Try, /*On fail goto*//*Label 9291*/ GIMT_Encode4(567692), // Rule ID 3416 //
     /*  567622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  567633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  567636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  567639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  567671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567690 */     GIR_RootConstrainSelectedInstOperands,
     /*  567691 */     // GIR_Coverage, 3416,
     /*  567691 */     GIR_EraseRootFromParent_Done,
     /*  567692 */   // Label 9291: @567692
     /*  567692 */   GIM_Try, /*On fail goto*//*Label 9292*/ GIMT_Encode4(567767), // Rule ID 3417 //
     /*  567697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  567708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  567711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  567714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567743 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  567746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567765 */     GIR_RootConstrainSelectedInstOperands,
     /*  567766 */     // GIR_Coverage, 3417,
     /*  567766 */     GIR_EraseRootFromParent_Done,
     /*  567767 */   // Label 9292: @567767
     /*  567767 */   GIM_Try, /*On fail goto*//*Label 9293*/ GIMT_Encode4(567842), // Rule ID 3420 //
     /*  567772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  567783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  567786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  567789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567818 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  567821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567840 */     GIR_RootConstrainSelectedInstOperands,
     /*  567841 */     // GIR_Coverage, 3420,
     /*  567841 */     GIR_EraseRootFromParent_Done,
     /*  567842 */   // Label 9293: @567842
     /*  567842 */   GIM_Try, /*On fail goto*//*Label 9294*/ GIMT_Encode4(567917), // Rule ID 3421 //
     /*  567847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  567858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  567861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  567864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567893 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  567896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567915 */     GIR_RootConstrainSelectedInstOperands,
     /*  567916 */     // GIR_Coverage, 3421,
     /*  567916 */     GIR_EraseRootFromParent_Done,
     /*  567917 */   // Label 9294: @567917
     /*  567917 */   GIM_Try, /*On fail goto*//*Label 9295*/ GIMT_Encode4(567992), // Rule ID 3424 //
     /*  567922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  567933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  567936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  567939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  567968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  567971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  567987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567990 */     GIR_RootConstrainSelectedInstOperands,
     /*  567991 */     // GIR_Coverage, 3424,
     /*  567991 */     GIR_EraseRootFromParent_Done,
     /*  567992 */   // Label 9295: @567992
     /*  567992 */   GIM_Try, /*On fail goto*//*Label 9296*/ GIMT_Encode4(568067), // Rule ID 3425 //
     /*  567997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  568008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  568011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  568014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568043 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  568046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568065 */     GIR_RootConstrainSelectedInstOperands,
     /*  568066 */     // GIR_Coverage, 3425,
     /*  568066 */     GIR_EraseRootFromParent_Done,
     /*  568067 */   // Label 9296: @568067
     /*  568067 */   GIM_Try, /*On fail goto*//*Label 9297*/ GIMT_Encode4(568142), // Rule ID 3428 //
     /*  568072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  568083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  568086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  568089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568118 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  568118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568140 */     GIR_RootConstrainSelectedInstOperands,
     /*  568141 */     // GIR_Coverage, 3428,
     /*  568141 */     GIR_EraseRootFromParent_Done,
     /*  568142 */   // Label 9297: @568142
     /*  568142 */   GIM_Try, /*On fail goto*//*Label 9298*/ GIMT_Encode4(568217), // Rule ID 3429 //
     /*  568147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  568158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  568161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  568164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568193 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  568193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568215 */     GIR_RootConstrainSelectedInstOperands,
     /*  568216 */     // GIR_Coverage, 3429,
     /*  568216 */     GIR_EraseRootFromParent_Done,
     /*  568217 */   // Label 9298: @568217
     /*  568217 */   GIM_Try, /*On fail goto*//*Label 9299*/ GIMT_Encode4(568292), // Rule ID 3432 //
     /*  568222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  568233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  568236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  568239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568290 */     GIR_RootConstrainSelectedInstOperands,
     /*  568291 */     // GIR_Coverage, 3432,
     /*  568291 */     GIR_EraseRootFromParent_Done,
     /*  568292 */   // Label 9299: @568292
     /*  568292 */   GIM_Try, /*On fail goto*//*Label 9300*/ GIMT_Encode4(568367), // Rule ID 3433 //
     /*  568297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  568308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  568311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  568314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568343 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568365 */     GIR_RootConstrainSelectedInstOperands,
     /*  568366 */     // GIR_Coverage, 3433,
     /*  568366 */     GIR_EraseRootFromParent_Done,
     /*  568367 */   // Label 9300: @568367
     /*  568367 */   GIM_Try, /*On fail goto*//*Label 9301*/ GIMT_Encode4(568442), // Rule ID 3436 //
     /*  568372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  568383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  568386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568440 */     GIR_RootConstrainSelectedInstOperands,
     /*  568441 */     // GIR_Coverage, 3436,
     /*  568441 */     GIR_EraseRootFromParent_Done,
     /*  568442 */   // Label 9301: @568442
     /*  568442 */   GIM_Try, /*On fail goto*//*Label 9302*/ GIMT_Encode4(568517), // Rule ID 3437 //
     /*  568447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  568458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  568461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568515 */     GIR_RootConstrainSelectedInstOperands,
     /*  568516 */     // GIR_Coverage, 3437,
     /*  568516 */     GIR_EraseRootFromParent_Done,
     /*  568517 */   // Label 9302: @568517
     /*  568517 */   GIM_Try, /*On fail goto*//*Label 9303*/ GIMT_Encode4(568592), // Rule ID 3440 //
     /*  568522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  568525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  568533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  568536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  568539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568568 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  568568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  568587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568590 */     GIR_RootConstrainSelectedInstOperands,
     /*  568591 */     // GIR_Coverage, 3440,
     /*  568591 */     GIR_EraseRootFromParent_Done,
     /*  568592 */   // Label 9303: @568592
     /*  568592 */   GIM_Try, /*On fail goto*//*Label 9304*/ GIMT_Encode4(568667), // Rule ID 3441 //
     /*  568597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  568600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  568608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  568611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  568614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568643 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  568643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  568662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568665 */     GIR_RootConstrainSelectedInstOperands,
     /*  568666 */     // GIR_Coverage, 3441,
     /*  568666 */     GIR_EraseRootFromParent_Done,
     /*  568667 */   // Label 9304: @568667
     /*  568667 */   GIM_Try, /*On fail goto*//*Label 9305*/ GIMT_Encode4(568742), // Rule ID 3444 //
     /*  568672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  568683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  568686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  568689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568718 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  568718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  568721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568740 */     GIR_RootConstrainSelectedInstOperands,
     /*  568741 */     // GIR_Coverage, 3444,
     /*  568741 */     GIR_EraseRootFromParent_Done,
     /*  568742 */   // Label 9305: @568742
     /*  568742 */   GIM_Try, /*On fail goto*//*Label 9306*/ GIMT_Encode4(568817), // Rule ID 3445 //
     /*  568747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  568758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  568761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  568764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568793 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  568793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  568796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568815 */     GIR_RootConstrainSelectedInstOperands,
     /*  568816 */     // GIR_Coverage, 3445,
     /*  568816 */     GIR_EraseRootFromParent_Done,
     /*  568817 */   // Label 9306: @568817
     /*  568817 */   GIM_Try, /*On fail goto*//*Label 9307*/ GIMT_Encode4(568892), // Rule ID 3448 //
     /*  568822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  568833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  568836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  568839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568868 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  568868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  568871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568890 */     GIR_RootConstrainSelectedInstOperands,
     /*  568891 */     // GIR_Coverage, 3448,
     /*  568891 */     GIR_EraseRootFromParent_Done,
     /*  568892 */   // Label 9307: @568892
     /*  568892 */   GIM_Try, /*On fail goto*//*Label 9308*/ GIMT_Encode4(568967), // Rule ID 3449 //
     /*  568897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  568908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  568911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  568914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568943 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  568943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  568946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568965 */     GIR_RootConstrainSelectedInstOperands,
     /*  568966 */     // GIR_Coverage, 3449,
     /*  568966 */     GIR_EraseRootFromParent_Done,
     /*  568967 */   // Label 9308: @568967
     /*  568967 */   GIM_Try, /*On fail goto*//*Label 9309*/ GIMT_Encode4(569042), // Rule ID 3452 //
     /*  568972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  568983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  568986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  568989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569018 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  569021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569040 */     GIR_RootConstrainSelectedInstOperands,
     /*  569041 */     // GIR_Coverage, 3452,
     /*  569041 */     GIR_EraseRootFromParent_Done,
     /*  569042 */   // Label 9309: @569042
     /*  569042 */   GIM_Try, /*On fail goto*//*Label 9310*/ GIMT_Encode4(569117), // Rule ID 3453 //
     /*  569047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  569058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  569061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  569064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569093 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  569096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569115 */     GIR_RootConstrainSelectedInstOperands,
     /*  569116 */     // GIR_Coverage, 3453,
     /*  569116 */     GIR_EraseRootFromParent_Done,
     /*  569117 */   // Label 9310: @569117
     /*  569117 */   GIM_Try, /*On fail goto*//*Label 9311*/ GIMT_Encode4(569192), // Rule ID 3456 //
     /*  569122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  569133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  569136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  569139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  569171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569190 */     GIR_RootConstrainSelectedInstOperands,
     /*  569191 */     // GIR_Coverage, 3456,
     /*  569191 */     GIR_EraseRootFromParent_Done,
     /*  569192 */   // Label 9311: @569192
     /*  569192 */   GIM_Try, /*On fail goto*//*Label 9312*/ GIMT_Encode4(569267), // Rule ID 3457 //
     /*  569197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  569208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  569211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  569214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  569246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569265 */     GIR_RootConstrainSelectedInstOperands,
     /*  569266 */     // GIR_Coverage, 3457,
     /*  569266 */     GIR_EraseRootFromParent_Done,
     /*  569267 */   // Label 9312: @569267
     /*  569267 */   GIM_Try, /*On fail goto*//*Label 9313*/ GIMT_Encode4(569342), // Rule ID 3460 //
     /*  569272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  569283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  569286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  569289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569318 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  569321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569340 */     GIR_RootConstrainSelectedInstOperands,
     /*  569341 */     // GIR_Coverage, 3460,
     /*  569341 */     GIR_EraseRootFromParent_Done,
     /*  569342 */   // Label 9313: @569342
     /*  569342 */   GIM_Try, /*On fail goto*//*Label 9314*/ GIMT_Encode4(569417), // Rule ID 3461 //
     /*  569347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  569358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  569361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  569364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569393 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  569396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569415 */     GIR_RootConstrainSelectedInstOperands,
     /*  569416 */     // GIR_Coverage, 3461,
     /*  569416 */     GIR_EraseRootFromParent_Done,
     /*  569417 */   // Label 9314: @569417
     /*  569417 */   GIM_Try, /*On fail goto*//*Label 9315*/ GIMT_Encode4(569492), // Rule ID 3464 //
     /*  569422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  569433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  569436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  569439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569468 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  569471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569490 */     GIR_RootConstrainSelectedInstOperands,
     /*  569491 */     // GIR_Coverage, 3464,
     /*  569491 */     GIR_EraseRootFromParent_Done,
     /*  569492 */   // Label 9315: @569492
     /*  569492 */   GIM_Try, /*On fail goto*//*Label 9316*/ GIMT_Encode4(569567), // Rule ID 3465 //
     /*  569497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  569508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  569511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  569514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569543 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  569546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569565 */     GIR_RootConstrainSelectedInstOperands,
     /*  569566 */     // GIR_Coverage, 3465,
     /*  569566 */     GIR_EraseRootFromParent_Done,
     /*  569567 */   // Label 9316: @569567
     /*  569567 */   GIM_Try, /*On fail goto*//*Label 9317*/ GIMT_Encode4(569642), // Rule ID 3468 //
     /*  569572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  569583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  569586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  569589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569618 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  569618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  569621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569640 */     GIR_RootConstrainSelectedInstOperands,
     /*  569641 */     // GIR_Coverage, 3468,
     /*  569641 */     GIR_EraseRootFromParent_Done,
     /*  569642 */   // Label 9317: @569642
     /*  569642 */   GIM_Try, /*On fail goto*//*Label 9318*/ GIMT_Encode4(569717), // Rule ID 3469 //
     /*  569647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  569658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  569661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  569664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569693 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  569696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569715 */     GIR_RootConstrainSelectedInstOperands,
     /*  569716 */     // GIR_Coverage, 3469,
     /*  569716 */     GIR_EraseRootFromParent_Done,
     /*  569717 */   // Label 9318: @569717
     /*  569717 */   GIM_Try, /*On fail goto*//*Label 9319*/ GIMT_Encode4(569792), // Rule ID 3472 //
     /*  569722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  569733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  569736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  569739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  569768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  569771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569790 */     GIR_RootConstrainSelectedInstOperands,
     /*  569791 */     // GIR_Coverage, 3472,
     /*  569791 */     GIR_EraseRootFromParent_Done,
     /*  569792 */   // Label 9319: @569792
     /*  569792 */   GIM_Try, /*On fail goto*//*Label 9320*/ GIMT_Encode4(569867), // Rule ID 3473 //
     /*  569797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  569808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  569811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  569814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569843 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  569846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569865 */     GIR_RootConstrainSelectedInstOperands,
     /*  569866 */     // GIR_Coverage, 3473,
     /*  569866 */     GIR_EraseRootFromParent_Done,
     /*  569867 */   // Label 9320: @569867
     /*  569867 */   GIM_Try, /*On fail goto*//*Label 9321*/ GIMT_Encode4(569942), // Rule ID 3476 //
     /*  569872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  569883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  569886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  569889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  569918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  569921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569940 */     GIR_RootConstrainSelectedInstOperands,
     /*  569941 */     // GIR_Coverage, 3476,
     /*  569941 */     GIR_EraseRootFromParent_Done,
     /*  569942 */   // Label 9321: @569942
     /*  569942 */   GIM_Try, /*On fail goto*//*Label 9322*/ GIMT_Encode4(570017), // Rule ID 3477 //
     /*  569947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  569958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  569961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  569964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569993 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  569996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570015 */     GIR_RootConstrainSelectedInstOperands,
     /*  570016 */     // GIR_Coverage, 3477,
     /*  570016 */     GIR_EraseRootFromParent_Done,
     /*  570017 */   // Label 9322: @570017
     /*  570017 */   GIM_Try, /*On fail goto*//*Label 9323*/ GIMT_Encode4(570092), // Rule ID 3480 //
     /*  570022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  570025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  570030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  570033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  570036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  570039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  570068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  570071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570090 */     GIR_RootConstrainSelectedInstOperands,
     /*  570091 */     // GIR_Coverage, 3480,
     /*  570091 */     GIR_EraseRootFromParent_Done,
     /*  570092 */   // Label 9323: @570092
     /*  570092 */   GIM_Try, /*On fail goto*//*Label 9324*/ GIMT_Encode4(570167), // Rule ID 3481 //
     /*  570097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  570100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  570105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  570108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  570111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  570114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11506:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  570143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  570146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570165 */     GIR_RootConstrainSelectedInstOperands,
     /*  570166 */     // GIR_Coverage, 3481,
     /*  570166 */     GIR_EraseRootFromParent_Done,
     /*  570167 */   // Label 9324: @570167
     /*  570167 */   GIM_Try, /*On fail goto*//*Label 9325*/ GIMT_Encode4(570242), // Rule ID 3484 //
     /*  570172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  570175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  570180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  570183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  570186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  570189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570218 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  570218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  570221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570240 */     GIR_RootConstrainSelectedInstOperands,
     /*  570241 */     // GIR_Coverage, 3484,
     /*  570241 */     GIR_EraseRootFromParent_Done,
     /*  570242 */   // Label 9325: @570242
     /*  570242 */   GIM_Try, /*On fail goto*//*Label 9326*/ GIMT_Encode4(570317), // Rule ID 3485 //
     /*  570247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  570250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  570255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  570258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  570261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  570264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570293 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11506:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  570293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  570296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570315 */     GIR_RootConstrainSelectedInstOperands,
     /*  570316 */     // GIR_Coverage, 3485,
     /*  570316 */     GIR_EraseRootFromParent_Done,
     /*  570317 */   // Label 9326: @570317
     /*  570317 */   GIM_Try, /*On fail goto*//*Label 9327*/ GIMT_Encode4(570392), // Rule ID 3488 //
     /*  570322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  570325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  570330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  570333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  570336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  570339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  570368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  570371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570390 */     GIR_RootConstrainSelectedInstOperands,
     /*  570391 */     // GIR_Coverage, 3488,
     /*  570391 */     GIR_EraseRootFromParent_Done,
     /*  570392 */   // Label 9327: @570392
     /*  570392 */   GIM_Try, /*On fail goto*//*Label 9328*/ GIMT_Encode4(570467), // Rule ID 3489 //
     /*  570397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  570400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  570405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  570408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  570411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  570414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570443 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11506:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  570443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  570446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570465 */     GIR_RootConstrainSelectedInstOperands,
     /*  570466 */     // GIR_Coverage, 3489,
     /*  570466 */     GIR_EraseRootFromParent_Done,
     /*  570467 */   // Label 9328: @570467
     /*  570467 */   GIM_Try, /*On fail goto*//*Label 9329*/ GIMT_Encode4(570542), // Rule ID 3580 //
     /*  570472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  570483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  570486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  570489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  570492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570518 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  570521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570540 */     GIR_RootConstrainSelectedInstOperands,
     /*  570541 */     // GIR_Coverage, 3580,
     /*  570541 */     GIR_EraseRootFromParent_Done,
     /*  570542 */   // Label 9329: @570542
     /*  570542 */   GIM_Try, /*On fail goto*//*Label 9330*/ GIMT_Encode4(570617), // Rule ID 3581 //
     /*  570547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  570558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  570561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  570564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  570567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570593 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  570596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570615 */     GIR_RootConstrainSelectedInstOperands,
     /*  570616 */     // GIR_Coverage, 3581,
     /*  570616 */     GIR_EraseRootFromParent_Done,
     /*  570617 */   // Label 9330: @570617
     /*  570617 */   GIM_Try, /*On fail goto*//*Label 9331*/ GIMT_Encode4(570692), // Rule ID 3584 //
     /*  570622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  570633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  570636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  570639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  570642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570668 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  570671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570690 */     GIR_RootConstrainSelectedInstOperands,
     /*  570691 */     // GIR_Coverage, 3584,
     /*  570691 */     GIR_EraseRootFromParent_Done,
     /*  570692 */   // Label 9331: @570692
     /*  570692 */   GIM_Try, /*On fail goto*//*Label 9332*/ GIMT_Encode4(570767), // Rule ID 3585 //
     /*  570697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  570708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  570711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  570714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  570717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570743 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  570746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570765 */     GIR_RootConstrainSelectedInstOperands,
     /*  570766 */     // GIR_Coverage, 3585,
     /*  570766 */     GIR_EraseRootFromParent_Done,
     /*  570767 */   // Label 9332: @570767
     /*  570767 */   GIM_Try, /*On fail goto*//*Label 9333*/ GIMT_Encode4(570842), // Rule ID 3588 //
     /*  570772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  570783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  570786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  570789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  570792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  570821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570840 */     GIR_RootConstrainSelectedInstOperands,
     /*  570841 */     // GIR_Coverage, 3588,
     /*  570841 */     GIR_EraseRootFromParent_Done,
     /*  570842 */   // Label 9333: @570842
     /*  570842 */   GIM_Try, /*On fail goto*//*Label 9334*/ GIMT_Encode4(570917), // Rule ID 3589 //
     /*  570847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  570858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  570861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  570864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  570867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570893 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  570896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570915 */     GIR_RootConstrainSelectedInstOperands,
     /*  570916 */     // GIR_Coverage, 3589,
     /*  570916 */     GIR_EraseRootFromParent_Done,
     /*  570917 */   // Label 9334: @570917
     /*  570917 */   GIM_Try, /*On fail goto*//*Label 9335*/ GIMT_Encode4(570992), // Rule ID 3592 //
     /*  570922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  570933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  570936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  570939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  570942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  570971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570990 */     GIR_RootConstrainSelectedInstOperands,
     /*  570991 */     // GIR_Coverage, 3592,
     /*  570991 */     GIR_EraseRootFromParent_Done,
     /*  570992 */   // Label 9335: @570992
     /*  570992 */   GIM_Try, /*On fail goto*//*Label 9336*/ GIMT_Encode4(571067), // Rule ID 3593 //
     /*  570997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  571008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  571011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  571014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  571017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  571046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571065 */     GIR_RootConstrainSelectedInstOperands,
     /*  571066 */     // GIR_Coverage, 3593,
     /*  571066 */     GIR_EraseRootFromParent_Done,
     /*  571067 */   // Label 9336: @571067
     /*  571067 */   GIM_Try, /*On fail goto*//*Label 9337*/ GIMT_Encode4(571142), // Rule ID 3596 //
     /*  571072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  571083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  571086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  571089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  571092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  571121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571140 */     GIR_RootConstrainSelectedInstOperands,
     /*  571141 */     // GIR_Coverage, 3596,
     /*  571141 */     GIR_EraseRootFromParent_Done,
     /*  571142 */   // Label 9337: @571142
     /*  571142 */   GIM_Try, /*On fail goto*//*Label 9338*/ GIMT_Encode4(571217), // Rule ID 3597 //
     /*  571147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  571158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  571161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  571164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  571167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571193 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  571196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571215 */     GIR_RootConstrainSelectedInstOperands,
     /*  571216 */     // GIR_Coverage, 3597,
     /*  571216 */     GIR_EraseRootFromParent_Done,
     /*  571217 */   // Label 9338: @571217
     /*  571217 */   GIM_Try, /*On fail goto*//*Label 9339*/ GIMT_Encode4(571292), // Rule ID 3600 //
     /*  571222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  571233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  571236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  571239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  571242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  571271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571290 */     GIR_RootConstrainSelectedInstOperands,
     /*  571291 */     // GIR_Coverage, 3600,
     /*  571291 */     GIR_EraseRootFromParent_Done,
     /*  571292 */   // Label 9339: @571292
     /*  571292 */   GIM_Try, /*On fail goto*//*Label 9340*/ GIMT_Encode4(571367), // Rule ID 3601 //
     /*  571297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  571308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  571311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  571314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  571317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571343 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  571346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571365 */     GIR_RootConstrainSelectedInstOperands,
     /*  571366 */     // GIR_Coverage, 3601,
     /*  571366 */     GIR_EraseRootFromParent_Done,
     /*  571367 */   // Label 9340: @571367
     /*  571367 */   GIM_Try, /*On fail goto*//*Label 9341*/ GIMT_Encode4(571442), // Rule ID 3604 //
     /*  571372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  571383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  571386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  571389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  571392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571418 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  571421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571440 */     GIR_RootConstrainSelectedInstOperands,
     /*  571441 */     // GIR_Coverage, 3604,
     /*  571441 */     GIR_EraseRootFromParent_Done,
     /*  571442 */   // Label 9341: @571442
     /*  571442 */   GIM_Try, /*On fail goto*//*Label 9342*/ GIMT_Encode4(571517), // Rule ID 3605 //
     /*  571447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  571458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  571461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  571464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  571467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571493 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  571496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571515 */     GIR_RootConstrainSelectedInstOperands,
     /*  571516 */     // GIR_Coverage, 3605,
     /*  571516 */     GIR_EraseRootFromParent_Done,
     /*  571517 */   // Label 9342: @571517
     /*  571517 */   GIM_Try, /*On fail goto*//*Label 9343*/ GIMT_Encode4(571592), // Rule ID 3608 //
     /*  571522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  571533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  571536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  571539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  571542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571568 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  571571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571590 */     GIR_RootConstrainSelectedInstOperands,
     /*  571591 */     // GIR_Coverage, 3608,
     /*  571591 */     GIR_EraseRootFromParent_Done,
     /*  571592 */   // Label 9343: @571592
     /*  571592 */   GIM_Try, /*On fail goto*//*Label 9344*/ GIMT_Encode4(571667), // Rule ID 3609 //
     /*  571597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  571608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  571611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  571614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  571617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571643 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  571646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571665 */     GIR_RootConstrainSelectedInstOperands,
     /*  571666 */     // GIR_Coverage, 3609,
     /*  571666 */     GIR_EraseRootFromParent_Done,
     /*  571667 */   // Label 9344: @571667
     /*  571667 */   GIM_Try, /*On fail goto*//*Label 9345*/ GIMT_Encode4(571742), // Rule ID 3612 //
     /*  571672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  571683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  571686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  571689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  571692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  571721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571740 */     GIR_RootConstrainSelectedInstOperands,
     /*  571741 */     // GIR_Coverage, 3612,
     /*  571741 */     GIR_EraseRootFromParent_Done,
     /*  571742 */   // Label 9345: @571742
     /*  571742 */   GIM_Try, /*On fail goto*//*Label 9346*/ GIMT_Encode4(571817), // Rule ID 3613 //
     /*  571747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  571758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  571761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  571764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  571767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  571796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571815 */     GIR_RootConstrainSelectedInstOperands,
     /*  571816 */     // GIR_Coverage, 3613,
     /*  571816 */     GIR_EraseRootFromParent_Done,
     /*  571817 */   // Label 9346: @571817
     /*  571817 */   GIM_Try, /*On fail goto*//*Label 9347*/ GIMT_Encode4(571892), // Rule ID 3616 //
     /*  571822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  571833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  571836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  571839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  571842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  571871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571890 */     GIR_RootConstrainSelectedInstOperands,
     /*  571891 */     // GIR_Coverage, 3616,
     /*  571891 */     GIR_EraseRootFromParent_Done,
     /*  571892 */   // Label 9347: @571892
     /*  571892 */   GIM_Try, /*On fail goto*//*Label 9348*/ GIMT_Encode4(571967), // Rule ID 3617 //
     /*  571897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  571908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  571911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  571914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  571917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571943 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  571946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571965 */     GIR_RootConstrainSelectedInstOperands,
     /*  571966 */     // GIR_Coverage, 3617,
     /*  571966 */     GIR_EraseRootFromParent_Done,
     /*  571967 */   // Label 9348: @571967
     /*  571967 */   GIM_Try, /*On fail goto*//*Label 9349*/ GIMT_Encode4(572042), // Rule ID 3620 //
     /*  571972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  571983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  571986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  571989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  571992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  572021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572040 */     GIR_RootConstrainSelectedInstOperands,
     /*  572041 */     // GIR_Coverage, 3620,
     /*  572041 */     GIR_EraseRootFromParent_Done,
     /*  572042 */   // Label 9349: @572042
     /*  572042 */   GIM_Try, /*On fail goto*//*Label 9350*/ GIMT_Encode4(572117), // Rule ID 3621 //
     /*  572047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  572058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  572061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  572064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  572067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572093 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  572096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572115 */     GIR_RootConstrainSelectedInstOperands,
     /*  572116 */     // GIR_Coverage, 3621,
     /*  572116 */     GIR_EraseRootFromParent_Done,
     /*  572117 */   // Label 9350: @572117
     /*  572117 */   GIM_Try, /*On fail goto*//*Label 9351*/ GIMT_Encode4(572192), // Rule ID 3624 //
     /*  572122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  572133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  572136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  572139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  572142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  572171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572190 */     GIR_RootConstrainSelectedInstOperands,
     /*  572191 */     // GIR_Coverage, 3624,
     /*  572191 */     GIR_EraseRootFromParent_Done,
     /*  572192 */   // Label 9351: @572192
     /*  572192 */   GIM_Try, /*On fail goto*//*Label 9352*/ GIMT_Encode4(572267), // Rule ID 3625 //
     /*  572197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  572208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  572211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  572214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  572217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572243 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  572246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572265 */     GIR_RootConstrainSelectedInstOperands,
     /*  572266 */     // GIR_Coverage, 3625,
     /*  572266 */     GIR_EraseRootFromParent_Done,
     /*  572267 */   // Label 9352: @572267
     /*  572267 */   GIM_Try, /*On fail goto*//*Label 9353*/ GIMT_Encode4(572342), // Rule ID 3628 //
     /*  572272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  572283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  572286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  572289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  572292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  572321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572340 */     GIR_RootConstrainSelectedInstOperands,
     /*  572341 */     // GIR_Coverage, 3628,
     /*  572341 */     GIR_EraseRootFromParent_Done,
     /*  572342 */   // Label 9353: @572342
     /*  572342 */   GIM_Try, /*On fail goto*//*Label 9354*/ GIMT_Encode4(572417), // Rule ID 3629 //
     /*  572347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  572358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  572361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  572364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  572367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572393 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  572396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572415 */     GIR_RootConstrainSelectedInstOperands,
     /*  572416 */     // GIR_Coverage, 3629,
     /*  572416 */     GIR_EraseRootFromParent_Done,
     /*  572417 */   // Label 9354: @572417
     /*  572417 */   GIM_Try, /*On fail goto*//*Label 9355*/ GIMT_Encode4(572492), // Rule ID 3632 //
     /*  572422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  572433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  572436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  572439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  572442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  572471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572490 */     GIR_RootConstrainSelectedInstOperands,
     /*  572491 */     // GIR_Coverage, 3632,
     /*  572491 */     GIR_EraseRootFromParent_Done,
     /*  572492 */   // Label 9355: @572492
     /*  572492 */   GIM_Try, /*On fail goto*//*Label 9356*/ GIMT_Encode4(572567), // Rule ID 3633 //
     /*  572497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  572508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  572511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  572514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  572517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572543 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  572546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572565 */     GIR_RootConstrainSelectedInstOperands,
     /*  572566 */     // GIR_Coverage, 3633,
     /*  572566 */     GIR_EraseRootFromParent_Done,
     /*  572567 */   // Label 9356: @572567
     /*  572567 */   GIM_Try, /*On fail goto*//*Label 9357*/ GIMT_Encode4(572642), // Rule ID 3636 //
     /*  572572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  572583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  572586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  572589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  572592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572618 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  572621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572640 */     GIR_RootConstrainSelectedInstOperands,
     /*  572641 */     // GIR_Coverage, 3636,
     /*  572641 */     GIR_EraseRootFromParent_Done,
     /*  572642 */   // Label 9357: @572642
     /*  572642 */   GIM_Try, /*On fail goto*//*Label 9358*/ GIMT_Encode4(572717), // Rule ID 3637 //
     /*  572647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  572658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  572661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  572664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  572667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572693 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  572696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572715 */     GIR_RootConstrainSelectedInstOperands,
     /*  572716 */     // GIR_Coverage, 3637,
     /*  572716 */     GIR_EraseRootFromParent_Done,
     /*  572717 */   // Label 9358: @572717
     /*  572717 */   GIM_Try, /*On fail goto*//*Label 9359*/ GIMT_Encode4(572792), // Rule ID 3640 //
     /*  572722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  572733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  572736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  572739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  572742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  572771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572790 */     GIR_RootConstrainSelectedInstOperands,
     /*  572791 */     // GIR_Coverage, 3640,
     /*  572791 */     GIR_EraseRootFromParent_Done,
     /*  572792 */   // Label 9359: @572792
     /*  572792 */   GIM_Try, /*On fail goto*//*Label 9360*/ GIMT_Encode4(572867), // Rule ID 3641 //
     /*  572797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  572808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  572811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  572814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  572817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  572846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572865 */     GIR_RootConstrainSelectedInstOperands,
     /*  572866 */     // GIR_Coverage, 3641,
     /*  572866 */     GIR_EraseRootFromParent_Done,
     /*  572867 */   // Label 9360: @572867
     /*  572867 */   GIM_Try, /*On fail goto*//*Label 9361*/ GIMT_Encode4(572942), // Rule ID 3644 //
     /*  572872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  572883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  572886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  572889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  572892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  572921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572940 */     GIR_RootConstrainSelectedInstOperands,
     /*  572941 */     // GIR_Coverage, 3644,
     /*  572941 */     GIR_EraseRootFromParent_Done,
     /*  572942 */   // Label 9361: @572942
     /*  572942 */   GIM_Try, /*On fail goto*//*Label 9362*/ GIMT_Encode4(573017), // Rule ID 3645 //
     /*  572947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  572958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  572961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  572964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  572967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572993 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  572996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573015 */     GIR_RootConstrainSelectedInstOperands,
     /*  573016 */     // GIR_Coverage, 3645,
     /*  573016 */     GIR_EraseRootFromParent_Done,
     /*  573017 */   // Label 9362: @573017
     /*  573017 */   GIM_Try, /*On fail goto*//*Label 9363*/ GIMT_Encode4(573092), // Rule ID 3648 //
     /*  573022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  573033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  573036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  573039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  573071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573090 */     GIR_RootConstrainSelectedInstOperands,
     /*  573091 */     // GIR_Coverage, 3648,
     /*  573091 */     GIR_EraseRootFromParent_Done,
     /*  573092 */   // Label 9363: @573092
     /*  573092 */   GIM_Try, /*On fail goto*//*Label 9364*/ GIMT_Encode4(573167), // Rule ID 3649 //
     /*  573097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  573108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  573111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  573114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573143 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  573146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573165 */     GIR_RootConstrainSelectedInstOperands,
     /*  573166 */     // GIR_Coverage, 3649,
     /*  573166 */     GIR_EraseRootFromParent_Done,
     /*  573167 */   // Label 9364: @573167
     /*  573167 */   GIM_Try, /*On fail goto*//*Label 9365*/ GIMT_Encode4(573242), // Rule ID 3652 //
     /*  573172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  573183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  573186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  573189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  573221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573240 */     GIR_RootConstrainSelectedInstOperands,
     /*  573241 */     // GIR_Coverage, 3652,
     /*  573241 */     GIR_EraseRootFromParent_Done,
     /*  573242 */   // Label 9365: @573242
     /*  573242 */   GIM_Try, /*On fail goto*//*Label 9366*/ GIMT_Encode4(573317), // Rule ID 3653 //
     /*  573247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  573258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  573261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  573264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573293 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  573296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573315 */     GIR_RootConstrainSelectedInstOperands,
     /*  573316 */     // GIR_Coverage, 3653,
     /*  573316 */     GIR_EraseRootFromParent_Done,
     /*  573317 */   // Label 9366: @573317
     /*  573317 */   GIM_Try, /*On fail goto*//*Label 9367*/ GIMT_Encode4(573392), // Rule ID 3656 //
     /*  573322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  573333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  573336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  573339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573368 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  573371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573390 */     GIR_RootConstrainSelectedInstOperands,
     /*  573391 */     // GIR_Coverage, 3656,
     /*  573391 */     GIR_EraseRootFromParent_Done,
     /*  573392 */   // Label 9367: @573392
     /*  573392 */   GIM_Try, /*On fail goto*//*Label 9368*/ GIMT_Encode4(573467), // Rule ID 3657 //
     /*  573397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  573408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  573411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  573414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573443 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  573446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573465 */     GIR_RootConstrainSelectedInstOperands,
     /*  573466 */     // GIR_Coverage, 3657,
     /*  573466 */     GIR_EraseRootFromParent_Done,
     /*  573467 */   // Label 9368: @573467
     /*  573467 */   GIM_Try, /*On fail goto*//*Label 9369*/ GIMT_Encode4(573542), // Rule ID 3660 //
     /*  573472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  573483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  573486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  573489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573518 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  573521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573540 */     GIR_RootConstrainSelectedInstOperands,
     /*  573541 */     // GIR_Coverage, 3660,
     /*  573541 */     GIR_EraseRootFromParent_Done,
     /*  573542 */   // Label 9369: @573542
     /*  573542 */   GIM_Try, /*On fail goto*//*Label 9370*/ GIMT_Encode4(573617), // Rule ID 3661 //
     /*  573547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  573558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  573561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  573564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573593 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  573596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573615 */     GIR_RootConstrainSelectedInstOperands,
     /*  573616 */     // GIR_Coverage, 3661,
     /*  573616 */     GIR_EraseRootFromParent_Done,
     /*  573617 */   // Label 9370: @573617
     /*  573617 */   GIM_Try, /*On fail goto*//*Label 9371*/ GIMT_Encode4(573692), // Rule ID 3664 //
     /*  573622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  573633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  573636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  573639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  573668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  573671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573690 */     GIR_RootConstrainSelectedInstOperands,
     /*  573691 */     // GIR_Coverage, 3664,
     /*  573691 */     GIR_EraseRootFromParent_Done,
     /*  573692 */   // Label 9371: @573692
     /*  573692 */   GIM_Try, /*On fail goto*//*Label 9372*/ GIMT_Encode4(573767), // Rule ID 3665 //
     /*  573697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  573708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  573711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  573714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573743 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  573743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  573746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573765 */     GIR_RootConstrainSelectedInstOperands,
     /*  573766 */     // GIR_Coverage, 3665,
     /*  573766 */     GIR_EraseRootFromParent_Done,
     /*  573767 */   // Label 9372: @573767
     /*  573767 */   GIM_Try, /*On fail goto*//*Label 9373*/ GIMT_Encode4(573842), // Rule ID 3668 //
     /*  573772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  573783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  573786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  573789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  573818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  573821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573840 */     GIR_RootConstrainSelectedInstOperands,
     /*  573841 */     // GIR_Coverage, 3668,
     /*  573841 */     GIR_EraseRootFromParent_Done,
     /*  573842 */   // Label 9373: @573842
     /*  573842 */   GIM_Try, /*On fail goto*//*Label 9374*/ GIMT_Encode4(573917), // Rule ID 3669 //
     /*  573847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  573858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  573861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  573864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573893 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  573893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  573896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573915 */     GIR_RootConstrainSelectedInstOperands,
     /*  573916 */     // GIR_Coverage, 3669,
     /*  573916 */     GIR_EraseRootFromParent_Done,
     /*  573917 */   // Label 9374: @573917
     /*  573917 */   GIM_Try, /*On fail goto*//*Label 9375*/ GIMT_Encode4(573992), // Rule ID 3672 //
     /*  573922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  573933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  573936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  573939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573968 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  573968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  573971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573990 */     GIR_RootConstrainSelectedInstOperands,
     /*  573991 */     // GIR_Coverage, 3672,
     /*  573991 */     GIR_EraseRootFromParent_Done,
     /*  573992 */   // Label 9375: @573992
     /*  573992 */   GIM_Try, /*On fail goto*//*Label 9376*/ GIMT_Encode4(574067), // Rule ID 3673 //
     /*  573997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  574008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  574011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  574014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  574046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574065 */     GIR_RootConstrainSelectedInstOperands,
     /*  574066 */     // GIR_Coverage, 3673,
     /*  574066 */     GIR_EraseRootFromParent_Done,
     /*  574067 */   // Label 9376: @574067
     /*  574067 */   GIM_Try, /*On fail goto*//*Label 9377*/ GIMT_Encode4(574142), // Rule ID 3676 //
     /*  574072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  574083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  574086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  574089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  574121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574140 */     GIR_RootConstrainSelectedInstOperands,
     /*  574141 */     // GIR_Coverage, 3676,
     /*  574141 */     GIR_EraseRootFromParent_Done,
     /*  574142 */   // Label 9377: @574142
     /*  574142 */   GIM_Try, /*On fail goto*//*Label 9378*/ GIMT_Encode4(574217), // Rule ID 3677 //
     /*  574147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  574158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  574161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  574164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574193 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  574196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574215 */     GIR_RootConstrainSelectedInstOperands,
     /*  574216 */     // GIR_Coverage, 3677,
     /*  574216 */     GIR_EraseRootFromParent_Done,
     /*  574217 */   // Label 9378: @574217
     /*  574217 */   GIM_Try, /*On fail goto*//*Label 9379*/ GIMT_Encode4(574292), // Rule ID 3680 //
     /*  574222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  574233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  574236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  574239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574268 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  574271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574290 */     GIR_RootConstrainSelectedInstOperands,
     /*  574291 */     // GIR_Coverage, 3680,
     /*  574291 */     GIR_EraseRootFromParent_Done,
     /*  574292 */   // Label 9379: @574292
     /*  574292 */   GIM_Try, /*On fail goto*//*Label 9380*/ GIMT_Encode4(574367), // Rule ID 3681 //
     /*  574297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  574308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  574311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  574314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574343 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  574346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574365 */     GIR_RootConstrainSelectedInstOperands,
     /*  574366 */     // GIR_Coverage, 3681,
     /*  574366 */     GIR_EraseRootFromParent_Done,
     /*  574367 */   // Label 9380: @574367
     /*  574367 */   GIM_Try, /*On fail goto*//*Label 9381*/ GIMT_Encode4(574442), // Rule ID 3684 //
     /*  574372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  574375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  574383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  574386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  574389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574418 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  574418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  574421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574440 */     GIR_RootConstrainSelectedInstOperands,
     /*  574441 */     // GIR_Coverage, 3684,
     /*  574441 */     GIR_EraseRootFromParent_Done,
     /*  574442 */   // Label 9381: @574442
     /*  574442 */   GIM_Try, /*On fail goto*//*Label 9382*/ GIMT_Encode4(574517), // Rule ID 3685 //
     /*  574447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  574450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  574458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  574461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  574464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574493 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  574493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  574496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574515 */     GIR_RootConstrainSelectedInstOperands,
     /*  574516 */     // GIR_Coverage, 3685,
     /*  574516 */     GIR_EraseRootFromParent_Done,
     /*  574517 */   // Label 9382: @574517
     /*  574517 */   GIM_Try, /*On fail goto*//*Label 9383*/ GIMT_Encode4(574592), // Rule ID 3688 //
     /*  574522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  574525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  574533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  574536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  574539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574568 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  574568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  574571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574590 */     GIR_RootConstrainSelectedInstOperands,
     /*  574591 */     // GIR_Coverage, 3688,
     /*  574591 */     GIR_EraseRootFromParent_Done,
     /*  574592 */   // Label 9383: @574592
     /*  574592 */   GIM_Try, /*On fail goto*//*Label 9384*/ GIMT_Encode4(574667), // Rule ID 3689 //
     /*  574597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  574600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  574608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  574611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  574614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574643 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  574643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  574646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574665 */     GIR_RootConstrainSelectedInstOperands,
     /*  574666 */     // GIR_Coverage, 3689,
     /*  574666 */     GIR_EraseRootFromParent_Done,
     /*  574667 */   // Label 9384: @574667
     /*  574667 */   GIM_Try, /*On fail goto*//*Label 9385*/ GIMT_Encode4(574742), // Rule ID 3692 //
     /*  574672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  574675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  574683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  574686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  574689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574718 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  574718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  574721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574740 */     GIR_RootConstrainSelectedInstOperands,
     /*  574741 */     // GIR_Coverage, 3692,
     /*  574741 */     GIR_EraseRootFromParent_Done,
     /*  574742 */   // Label 9385: @574742
     /*  574742 */   GIM_Try, /*On fail goto*//*Label 9386*/ GIMT_Encode4(574817), // Rule ID 3693 //
     /*  574747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  574750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  574758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  574761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  574764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574793 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  574793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  574796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574815 */     GIR_RootConstrainSelectedInstOperands,
     /*  574816 */     // GIR_Coverage, 3693,
     /*  574816 */     GIR_EraseRootFromParent_Done,
     /*  574817 */   // Label 9386: @574817
     /*  574817 */   GIM_Try, /*On fail goto*//*Label 9387*/ GIMT_Encode4(574892), // Rule ID 3696 //
     /*  574822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  574825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  574833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  574836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  574839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  574868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  574871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574890 */     GIR_RootConstrainSelectedInstOperands,
     /*  574891 */     // GIR_Coverage, 3696,
     /*  574891 */     GIR_EraseRootFromParent_Done,
     /*  574892 */   // Label 9387: @574892
     /*  574892 */   GIM_Try, /*On fail goto*//*Label 9388*/ GIMT_Encode4(574967), // Rule ID 3697 //
     /*  574897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  574900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  574908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  574911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  574914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574943 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  574943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  574946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574965 */     GIR_RootConstrainSelectedInstOperands,
     /*  574966 */     // GIR_Coverage, 3697,
     /*  574966 */     GIR_EraseRootFromParent_Done,
     /*  574967 */   // Label 9388: @574967
     /*  574967 */   GIM_Try, /*On fail goto*//*Label 9389*/ GIMT_Encode4(575042), // Rule ID 3700 //
     /*  574972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  574983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  574986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  574989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  574992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575018 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  575021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575040 */     GIR_RootConstrainSelectedInstOperands,
     /*  575041 */     // GIR_Coverage, 3700,
     /*  575041 */     GIR_EraseRootFromParent_Done,
     /*  575042 */   // Label 9389: @575042
     /*  575042 */   GIM_Try, /*On fail goto*//*Label 9390*/ GIMT_Encode4(575117), // Rule ID 3701 //
     /*  575047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  575058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  575061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  575064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  575067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575093 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  575096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575115 */     GIR_RootConstrainSelectedInstOperands,
     /*  575116 */     // GIR_Coverage, 3701,
     /*  575116 */     GIR_EraseRootFromParent_Done,
     /*  575117 */   // Label 9390: @575117
     /*  575117 */   GIM_Try, /*On fail goto*//*Label 9391*/ GIMT_Encode4(575192), // Rule ID 3704 //
     /*  575122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  575133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  575136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  575139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  575142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575168 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  575171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575190 */     GIR_RootConstrainSelectedInstOperands,
     /*  575191 */     // GIR_Coverage, 3704,
     /*  575191 */     GIR_EraseRootFromParent_Done,
     /*  575192 */   // Label 9391: @575192
     /*  575192 */   GIM_Try, /*On fail goto*//*Label 9392*/ GIMT_Encode4(575267), // Rule ID 3705 //
     /*  575197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  575208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  575211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  575214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  575217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575243 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  575246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575265 */     GIR_RootConstrainSelectedInstOperands,
     /*  575266 */     // GIR_Coverage, 3705,
     /*  575266 */     GIR_EraseRootFromParent_Done,
     /*  575267 */   // Label 9392: @575267
     /*  575267 */   GIM_Try, /*On fail goto*//*Label 9393*/ GIMT_Encode4(575342), // Rule ID 3708 //
     /*  575272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  575283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  575286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  575289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  575292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  575321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575340 */     GIR_RootConstrainSelectedInstOperands,
     /*  575341 */     // GIR_Coverage, 3708,
     /*  575341 */     GIR_EraseRootFromParent_Done,
     /*  575342 */   // Label 9393: @575342
     /*  575342 */   GIM_Try, /*On fail goto*//*Label 9394*/ GIMT_Encode4(575417), // Rule ID 3709 //
     /*  575347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  575358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  575361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  575364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  575367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575393 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  575396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575415 */     GIR_RootConstrainSelectedInstOperands,
     /*  575416 */     // GIR_Coverage, 3709,
     /*  575416 */     GIR_EraseRootFromParent_Done,
     /*  575417 */   // Label 9394: @575417
     /*  575417 */   GIM_Try, /*On fail goto*//*Label 9395*/ GIMT_Encode4(575492), // Rule ID 3712 //
     /*  575422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  575433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  575436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  575439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  575442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  575471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575490 */     GIR_RootConstrainSelectedInstOperands,
     /*  575491 */     // GIR_Coverage, 3712,
     /*  575491 */     GIR_EraseRootFromParent_Done,
     /*  575492 */   // Label 9395: @575492
     /*  575492 */   GIM_Try, /*On fail goto*//*Label 9396*/ GIMT_Encode4(575567), // Rule ID 3713 //
     /*  575497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  575508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  575511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  575514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  575517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575543 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  575546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575565 */     GIR_RootConstrainSelectedInstOperands,
     /*  575566 */     // GIR_Coverage, 3713,
     /*  575566 */     GIR_EraseRootFromParent_Done,
     /*  575567 */   // Label 9396: @575567
     /*  575567 */   GIM_Try, /*On fail goto*//*Label 9397*/ GIMT_Encode4(575642), // Rule ID 3716 //
     /*  575572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  575583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  575586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  575589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  575592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575618 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  575621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575640 */     GIR_RootConstrainSelectedInstOperands,
     /*  575641 */     // GIR_Coverage, 3716,
     /*  575641 */     GIR_EraseRootFromParent_Done,
     /*  575642 */   // Label 9397: @575642
     /*  575642 */   GIM_Try, /*On fail goto*//*Label 9398*/ GIMT_Encode4(575717), // Rule ID 3717 //
     /*  575647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  575658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  575661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  575664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  575667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575693 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  575696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575715 */     GIR_RootConstrainSelectedInstOperands,
     /*  575716 */     // GIR_Coverage, 3717,
     /*  575716 */     GIR_EraseRootFromParent_Done,
     /*  575717 */   // Label 9398: @575717
     /*  575717 */   GIM_Try, /*On fail goto*//*Label 9399*/ GIMT_Encode4(575792), // Rule ID 3720 //
     /*  575722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  575733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  575736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  575739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  575742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  575771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575790 */     GIR_RootConstrainSelectedInstOperands,
     /*  575791 */     // GIR_Coverage, 3720,
     /*  575791 */     GIR_EraseRootFromParent_Done,
     /*  575792 */   // Label 9399: @575792
     /*  575792 */   GIM_Try, /*On fail goto*//*Label 9400*/ GIMT_Encode4(575867), // Rule ID 3721 //
     /*  575797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  575808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  575811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  575814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  575817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575843 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  575846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575865 */     GIR_RootConstrainSelectedInstOperands,
     /*  575866 */     // GIR_Coverage, 3721,
     /*  575866 */     GIR_EraseRootFromParent_Done,
     /*  575867 */   // Label 9400: @575867
     /*  575867 */   GIM_Try, /*On fail goto*//*Label 9401*/ GIMT_Encode4(575942), // Rule ID 3724 //
     /*  575872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  575883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  575886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  575889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  575892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  575918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  575921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575940 */     GIR_RootConstrainSelectedInstOperands,
     /*  575941 */     // GIR_Coverage, 3724,
     /*  575941 */     GIR_EraseRootFromParent_Done,
     /*  575942 */   // Label 9401: @575942
     /*  575942 */   GIM_Try, /*On fail goto*//*Label 9402*/ GIMT_Encode4(576017), // Rule ID 3725 //
     /*  575947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  575958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  575961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  575964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  575967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575993 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  575993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  575996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576015 */     GIR_RootConstrainSelectedInstOperands,
     /*  576016 */     // GIR_Coverage, 3725,
     /*  576016 */     GIR_EraseRootFromParent_Done,
     /*  576017 */   // Label 9402: @576017
     /*  576017 */   GIM_Try, /*On fail goto*//*Label 9403*/ GIMT_Encode4(576092), // Rule ID 3728 //
     /*  576022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  576033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  576036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  576039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  576042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576068 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  576071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576090 */     GIR_RootConstrainSelectedInstOperands,
     /*  576091 */     // GIR_Coverage, 3728,
     /*  576091 */     GIR_EraseRootFromParent_Done,
     /*  576092 */   // Label 9403: @576092
     /*  576092 */   GIM_Try, /*On fail goto*//*Label 9404*/ GIMT_Encode4(576167), // Rule ID 3729 //
     /*  576097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  576108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  576111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  576114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  576117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576143 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  576146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576165 */     GIR_RootConstrainSelectedInstOperands,
     /*  576166 */     // GIR_Coverage, 3729,
     /*  576166 */     GIR_EraseRootFromParent_Done,
     /*  576167 */   // Label 9404: @576167
     /*  576167 */   GIM_Try, /*On fail goto*//*Label 9405*/ GIMT_Encode4(576242), // Rule ID 3732 //
     /*  576172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  576183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  576186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  576189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  576192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  576221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576240 */     GIR_RootConstrainSelectedInstOperands,
     /*  576241 */     // GIR_Coverage, 3732,
     /*  576241 */     GIR_EraseRootFromParent_Done,
     /*  576242 */   // Label 9405: @576242
     /*  576242 */   GIM_Try, /*On fail goto*//*Label 9406*/ GIMT_Encode4(576317), // Rule ID 3733 //
     /*  576247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  576258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  576261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  576264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  576267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  576296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576315 */     GIR_RootConstrainSelectedInstOperands,
     /*  576316 */     // GIR_Coverage, 3733,
     /*  576316 */     GIR_EraseRootFromParent_Done,
     /*  576317 */   // Label 9406: @576317
     /*  576317 */   GIM_Try, /*On fail goto*//*Label 9407*/ GIMT_Encode4(576392), // Rule ID 3736 //
     /*  576322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  576333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  576336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  576339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  576342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  576371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576390 */     GIR_RootConstrainSelectedInstOperands,
     /*  576391 */     // GIR_Coverage, 3736,
     /*  576391 */     GIR_EraseRootFromParent_Done,
     /*  576392 */   // Label 9407: @576392
     /*  576392 */   GIM_Try, /*On fail goto*//*Label 9408*/ GIMT_Encode4(576467), // Rule ID 3737 //
     /*  576397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  576408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  576411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  576414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  576417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576443 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  576446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576465 */     GIR_RootConstrainSelectedInstOperands,
     /*  576466 */     // GIR_Coverage, 3737,
     /*  576466 */     GIR_EraseRootFromParent_Done,
     /*  576467 */   // Label 9408: @576467
     /*  576467 */   GIM_Try, /*On fail goto*//*Label 9409*/ GIMT_Encode4(576542), // Rule ID 3740 //
     /*  576472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  576483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  576486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  576489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  576492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  576521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576540 */     GIR_RootConstrainSelectedInstOperands,
     /*  576541 */     // GIR_Coverage, 3740,
     /*  576541 */     GIR_EraseRootFromParent_Done,
     /*  576542 */   // Label 9409: @576542
     /*  576542 */   GIM_Try, /*On fail goto*//*Label 9410*/ GIMT_Encode4(576617), // Rule ID 3741 //
     /*  576547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  576558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  576561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  576564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  576567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576593 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  576596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576615 */     GIR_RootConstrainSelectedInstOperands,
     /*  576616 */     // GIR_Coverage, 3741,
     /*  576616 */     GIR_EraseRootFromParent_Done,
     /*  576617 */   // Label 9410: @576617
     /*  576617 */   GIM_Try, /*On fail goto*//*Label 9411*/ GIMT_Encode4(576692), // Rule ID 3744 //
     /*  576622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  576625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  576633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  576636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  576639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  576642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  576668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  576671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576690 */     GIR_RootConstrainSelectedInstOperands,
     /*  576691 */     // GIR_Coverage, 3744,
     /*  576691 */     GIR_EraseRootFromParent_Done,
     /*  576692 */   // Label 9411: @576692
     /*  576692 */   GIM_Try, /*On fail goto*//*Label 9412*/ GIMT_Encode4(576767), // Rule ID 3745 //
     /*  576697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  576700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  576708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  576711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  576714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  576717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576743 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  576743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  576746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576765 */     GIR_RootConstrainSelectedInstOperands,
     /*  576766 */     // GIR_Coverage, 3745,
     /*  576766 */     GIR_EraseRootFromParent_Done,
     /*  576767 */   // Label 9412: @576767
     /*  576767 */   GIM_Try, /*On fail goto*//*Label 9413*/ GIMT_Encode4(576842), // Rule ID 3748 //
     /*  576772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  576775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  576783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  576786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  576789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  576792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576818 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  576818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  576821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576840 */     GIR_RootConstrainSelectedInstOperands,
     /*  576841 */     // GIR_Coverage, 3748,
     /*  576841 */     GIR_EraseRootFromParent_Done,
     /*  576842 */   // Label 9413: @576842
     /*  576842 */   GIM_Try, /*On fail goto*//*Label 9414*/ GIMT_Encode4(576917), // Rule ID 3749 //
     /*  576847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  576850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  576858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  576861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  576864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  576867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576893 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  576893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  576896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576915 */     GIR_RootConstrainSelectedInstOperands,
     /*  576916 */     // GIR_Coverage, 3749,
     /*  576916 */     GIR_EraseRootFromParent_Done,
     /*  576917 */   // Label 9414: @576917
     /*  576917 */   GIM_Try, /*On fail goto*//*Label 9415*/ GIMT_Encode4(576992), // Rule ID 3752 //
     /*  576922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  576925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  576933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  576936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  576939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  576942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576968 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  576968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  576971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576990 */     GIR_RootConstrainSelectedInstOperands,
     /*  576991 */     // GIR_Coverage, 3752,
     /*  576991 */     GIR_EraseRootFromParent_Done,
     /*  576992 */   // Label 9415: @576992
     /*  576992 */   GIM_Try, /*On fail goto*//*Label 9416*/ GIMT_Encode4(577067), // Rule ID 3753 //
     /*  576997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  577008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  577011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  577014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  577017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577043 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  577046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577065 */     GIR_RootConstrainSelectedInstOperands,
     /*  577066 */     // GIR_Coverage, 3753,
     /*  577066 */     GIR_EraseRootFromParent_Done,
     /*  577067 */   // Label 9416: @577067
     /*  577067 */   GIM_Try, /*On fail goto*//*Label 9417*/ GIMT_Encode4(577142), // Rule ID 3756 //
     /*  577072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  577083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  577086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  577089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  577092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577118 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  577121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577140 */     GIR_RootConstrainSelectedInstOperands,
     /*  577141 */     // GIR_Coverage, 3756,
     /*  577141 */     GIR_EraseRootFromParent_Done,
     /*  577142 */   // Label 9417: @577142
     /*  577142 */   GIM_Try, /*On fail goto*//*Label 9418*/ GIMT_Encode4(577217), // Rule ID 3757 //
     /*  577147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  577158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  577161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  577164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  577167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577193 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  577196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577215 */     GIR_RootConstrainSelectedInstOperands,
     /*  577216 */     // GIR_Coverage, 3757,
     /*  577216 */     GIR_EraseRootFromParent_Done,
     /*  577217 */   // Label 9418: @577217
     /*  577217 */   GIM_Try, /*On fail goto*//*Label 9419*/ GIMT_Encode4(577292), // Rule ID 3760 //
     /*  577222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  577233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  577236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  577239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  577271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577290 */     GIR_RootConstrainSelectedInstOperands,
     /*  577291 */     // GIR_Coverage, 3760,
     /*  577291 */     GIR_EraseRootFromParent_Done,
     /*  577292 */   // Label 9419: @577292
     /*  577292 */   GIM_Try, /*On fail goto*//*Label 9420*/ GIMT_Encode4(577367), // Rule ID 3761 //
     /*  577297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  577308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  577311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  577314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577343 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  577346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577365 */     GIR_RootConstrainSelectedInstOperands,
     /*  577366 */     // GIR_Coverage, 3761,
     /*  577366 */     GIR_EraseRootFromParent_Done,
     /*  577367 */   // Label 9420: @577367
     /*  577367 */   GIM_Try, /*On fail goto*//*Label 9421*/ GIMT_Encode4(577442), // Rule ID 3764 //
     /*  577372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  577383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  577386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  577389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577418 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  577421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577440 */     GIR_RootConstrainSelectedInstOperands,
     /*  577441 */     // GIR_Coverage, 3764,
     /*  577441 */     GIR_EraseRootFromParent_Done,
     /*  577442 */   // Label 9421: @577442
     /*  577442 */   GIM_Try, /*On fail goto*//*Label 9422*/ GIMT_Encode4(577517), // Rule ID 3765 //
     /*  577447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  577458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  577461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  577464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  577496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577515 */     GIR_RootConstrainSelectedInstOperands,
     /*  577516 */     // GIR_Coverage, 3765,
     /*  577516 */     GIR_EraseRootFromParent_Done,
     /*  577517 */   // Label 9422: @577517
     /*  577517 */   GIM_Try, /*On fail goto*//*Label 9423*/ GIMT_Encode4(577592), // Rule ID 3768 //
     /*  577522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  577533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  577536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  577539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  577571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577590 */     GIR_RootConstrainSelectedInstOperands,
     /*  577591 */     // GIR_Coverage, 3768,
     /*  577591 */     GIR_EraseRootFromParent_Done,
     /*  577592 */   // Label 9423: @577592
     /*  577592 */   GIM_Try, /*On fail goto*//*Label 9424*/ GIMT_Encode4(577667), // Rule ID 3769 //
     /*  577597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  577608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  577611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  577614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  577646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577665 */     GIR_RootConstrainSelectedInstOperands,
     /*  577666 */     // GIR_Coverage, 3769,
     /*  577666 */     GIR_EraseRootFromParent_Done,
     /*  577667 */   // Label 9424: @577667
     /*  577667 */   GIM_Try, /*On fail goto*//*Label 9425*/ GIMT_Encode4(577742), // Rule ID 3772 //
     /*  577672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  577683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  577686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  577689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  577721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577740 */     GIR_RootConstrainSelectedInstOperands,
     /*  577741 */     // GIR_Coverage, 3772,
     /*  577741 */     GIR_EraseRootFromParent_Done,
     /*  577742 */   // Label 9425: @577742
     /*  577742 */   GIM_Try, /*On fail goto*//*Label 9426*/ GIMT_Encode4(577817), // Rule ID 3773 //
     /*  577747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  577758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  577761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  577764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  577796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577815 */     GIR_RootConstrainSelectedInstOperands,
     /*  577816 */     // GIR_Coverage, 3773,
     /*  577816 */     GIR_EraseRootFromParent_Done,
     /*  577817 */   // Label 9426: @577817
     /*  577817 */   GIM_Try, /*On fail goto*//*Label 9427*/ GIMT_Encode4(577892), // Rule ID 3776 //
     /*  577822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  577833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  577836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  577839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577868 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  577871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577890 */     GIR_RootConstrainSelectedInstOperands,
     /*  577891 */     // GIR_Coverage, 3776,
     /*  577891 */     GIR_EraseRootFromParent_Done,
     /*  577892 */   // Label 9427: @577892
     /*  577892 */   GIM_Try, /*On fail goto*//*Label 9428*/ GIMT_Encode4(577967), // Rule ID 3777 //
     /*  577897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  577908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  577911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  577914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577943 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  577946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577965 */     GIR_RootConstrainSelectedInstOperands,
     /*  577966 */     // GIR_Coverage, 3777,
     /*  577966 */     GIR_EraseRootFromParent_Done,
     /*  577967 */   // Label 9428: @577967
     /*  577967 */   GIM_Try, /*On fail goto*//*Label 9429*/ GIMT_Encode4(578042), // Rule ID 3780 //
     /*  577972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  577983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  577986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  577989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578018 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  578021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578040 */     GIR_RootConstrainSelectedInstOperands,
     /*  578041 */     // GIR_Coverage, 3780,
     /*  578041 */     GIR_EraseRootFromParent_Done,
     /*  578042 */   // Label 9429: @578042
     /*  578042 */   GIM_Try, /*On fail goto*//*Label 9430*/ GIMT_Encode4(578117), // Rule ID 3781 //
     /*  578047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  578058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  578061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  578064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578093 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  578096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578115 */     GIR_RootConstrainSelectedInstOperands,
     /*  578116 */     // GIR_Coverage, 3781,
     /*  578116 */     GIR_EraseRootFromParent_Done,
     /*  578117 */   // Label 9430: @578117
     /*  578117 */   GIM_Try, /*On fail goto*//*Label 9431*/ GIMT_Encode4(578192), // Rule ID 3784 //
     /*  578122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  578133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  578136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  578139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  578171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578190 */     GIR_RootConstrainSelectedInstOperands,
     /*  578191 */     // GIR_Coverage, 3784,
     /*  578191 */     GIR_EraseRootFromParent_Done,
     /*  578192 */   // Label 9431: @578192
     /*  578192 */   GIM_Try, /*On fail goto*//*Label 9432*/ GIMT_Encode4(578267), // Rule ID 3785 //
     /*  578197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  578208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  578211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  578214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578243 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  578246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578265 */     GIR_RootConstrainSelectedInstOperands,
     /*  578266 */     // GIR_Coverage, 3785,
     /*  578266 */     GIR_EraseRootFromParent_Done,
     /*  578267 */   // Label 9432: @578267
     /*  578267 */   GIM_Try, /*On fail goto*//*Label 9433*/ GIMT_Encode4(578342), // Rule ID 3788 //
     /*  578272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  578283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  578286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  578289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  578321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578340 */     GIR_RootConstrainSelectedInstOperands,
     /*  578341 */     // GIR_Coverage, 3788,
     /*  578341 */     GIR_EraseRootFromParent_Done,
     /*  578342 */   // Label 9433: @578342
     /*  578342 */   GIM_Try, /*On fail goto*//*Label 9434*/ GIMT_Encode4(578417), // Rule ID 3789 //
     /*  578347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  578358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  578361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  578364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578393 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  578396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578415 */     GIR_RootConstrainSelectedInstOperands,
     /*  578416 */     // GIR_Coverage, 3789,
     /*  578416 */     GIR_EraseRootFromParent_Done,
     /*  578417 */   // Label 9434: @578417
     /*  578417 */   GIM_Try, /*On fail goto*//*Label 9435*/ GIMT_Encode4(578492), // Rule ID 3792 //
     /*  578422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  578433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  578436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  578439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578468 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  578471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578490 */     GIR_RootConstrainSelectedInstOperands,
     /*  578491 */     // GIR_Coverage, 3792,
     /*  578491 */     GIR_EraseRootFromParent_Done,
     /*  578492 */   // Label 9435: @578492
     /*  578492 */   GIM_Try, /*On fail goto*//*Label 9436*/ GIMT_Encode4(578567), // Rule ID 3793 //
     /*  578497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  578508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  578511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  578514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  578546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578565 */     GIR_RootConstrainSelectedInstOperands,
     /*  578566 */     // GIR_Coverage, 3793,
     /*  578566 */     GIR_EraseRootFromParent_Done,
     /*  578567 */   // Label 9436: @578567
     /*  578567 */   GIM_Try, /*On fail goto*//*Label 9437*/ GIMT_Encode4(578642), // Rule ID 3796 //
     /*  578572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  578583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  578586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  578589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  578621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578640 */     GIR_RootConstrainSelectedInstOperands,
     /*  578641 */     // GIR_Coverage, 3796,
     /*  578641 */     GIR_EraseRootFromParent_Done,
     /*  578642 */   // Label 9437: @578642
     /*  578642 */   GIM_Try, /*On fail goto*//*Label 9438*/ GIMT_Encode4(578717), // Rule ID 3797 //
     /*  578647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  578658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  578661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  578664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578693 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  578696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578715 */     GIR_RootConstrainSelectedInstOperands,
     /*  578716 */     // GIR_Coverage, 3797,
     /*  578716 */     GIR_EraseRootFromParent_Done,
     /*  578717 */   // Label 9438: @578717
     /*  578717 */   GIM_Try, /*On fail goto*//*Label 9439*/ GIMT_Encode4(578792), // Rule ID 3800 //
     /*  578722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  578733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  578736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  578739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578768 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  578771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578790 */     GIR_RootConstrainSelectedInstOperands,
     /*  578791 */     // GIR_Coverage, 3800,
     /*  578791 */     GIR_EraseRootFromParent_Done,
     /*  578792 */   // Label 9439: @578792
     /*  578792 */   GIM_Try, /*On fail goto*//*Label 9440*/ GIMT_Encode4(578867), // Rule ID 3801 //
     /*  578797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  578808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  578811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  578814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578843 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  578846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578865 */     GIR_RootConstrainSelectedInstOperands,
     /*  578866 */     // GIR_Coverage, 3801,
     /*  578866 */     GIR_EraseRootFromParent_Done,
     /*  578867 */   // Label 9440: @578867
     /*  578867 */   GIM_Try, /*On fail goto*//*Label 9441*/ GIMT_Encode4(578942), // Rule ID 3804 //
     /*  578872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  578875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  578883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  578886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  578889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578918 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  578918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  578921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578940 */     GIR_RootConstrainSelectedInstOperands,
     /*  578941 */     // GIR_Coverage, 3804,
     /*  578941 */     GIR_EraseRootFromParent_Done,
     /*  578942 */   // Label 9441: @578942
     /*  578942 */   GIM_Try, /*On fail goto*//*Label 9442*/ GIMT_Encode4(579017), // Rule ID 3805 //
     /*  578947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  578950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  578958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  578961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  578964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578993 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  578993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  578996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579015 */     GIR_RootConstrainSelectedInstOperands,
     /*  579016 */     // GIR_Coverage, 3805,
     /*  579016 */     GIR_EraseRootFromParent_Done,
     /*  579017 */   // Label 9442: @579017
     /*  579017 */   GIM_Try, /*On fail goto*//*Label 9443*/ GIMT_Encode4(579092), // Rule ID 3808 //
     /*  579022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  579030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  579033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  579036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  579039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  579071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579090 */     GIR_RootConstrainSelectedInstOperands,
     /*  579091 */     // GIR_Coverage, 3808,
     /*  579091 */     GIR_EraseRootFromParent_Done,
     /*  579092 */   // Label 9443: @579092
     /*  579092 */   GIM_Try, /*On fail goto*//*Label 9444*/ GIMT_Encode4(579167), // Rule ID 3809 //
     /*  579097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  579105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  579108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  579111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  579114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  579146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579165 */     GIR_RootConstrainSelectedInstOperands,
     /*  579166 */     // GIR_Coverage, 3809,
     /*  579166 */     GIR_EraseRootFromParent_Done,
     /*  579167 */   // Label 9444: @579167
     /*  579167 */   GIM_Try, /*On fail goto*//*Label 9445*/ GIMT_Encode4(579242), // Rule ID 3812 //
     /*  579172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  579180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  579183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  579186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  579189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579218 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  579221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579240 */     GIR_RootConstrainSelectedInstOperands,
     /*  579241 */     // GIR_Coverage, 3812,
     /*  579241 */     GIR_EraseRootFromParent_Done,
     /*  579242 */   // Label 9445: @579242
     /*  579242 */   GIM_Try, /*On fail goto*//*Label 9446*/ GIMT_Encode4(579317), // Rule ID 3813 //
     /*  579247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  579255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  579258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  579261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  579264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579293 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  579296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579315 */     GIR_RootConstrainSelectedInstOperands,
     /*  579316 */     // GIR_Coverage, 3813,
     /*  579316 */     GIR_EraseRootFromParent_Done,
     /*  579317 */   // Label 9446: @579317
     /*  579317 */   GIM_Try, /*On fail goto*//*Label 9447*/ GIMT_Encode4(579392), // Rule ID 3816 //
     /*  579322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  579330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  579333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  579336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  579339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  579371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579390 */     GIR_RootConstrainSelectedInstOperands,
     /*  579391 */     // GIR_Coverage, 3816,
     /*  579391 */     GIR_EraseRootFromParent_Done,
     /*  579392 */   // Label 9447: @579392
     /*  579392 */   GIM_Try, /*On fail goto*//*Label 9448*/ GIMT_Encode4(579467), // Rule ID 3817 //
     /*  579397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  579405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  579408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  579411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  579414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579443 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  579446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579465 */     GIR_RootConstrainSelectedInstOperands,
     /*  579466 */     // GIR_Coverage, 3817,
     /*  579466 */     GIR_EraseRootFromParent_Done,
     /*  579467 */   // Label 9448: @579467
     /*  579467 */   GIM_Try, /*On fail goto*//*Label 9449*/ GIMT_Encode4(579542), // Rule ID 3820 //
     /*  579472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  579483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  579486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  579489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  579492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579518 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  579521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579540 */     GIR_RootConstrainSelectedInstOperands,
     /*  579541 */     // GIR_Coverage, 3820,
     /*  579541 */     GIR_EraseRootFromParent_Done,
     /*  579542 */   // Label 9449: @579542
     /*  579542 */   GIM_Try, /*On fail goto*//*Label 9450*/ GIMT_Encode4(579617), // Rule ID 3821 //
     /*  579547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  579558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  579561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  579564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  579567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579593 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  579596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579615 */     GIR_RootConstrainSelectedInstOperands,
     /*  579616 */     // GIR_Coverage, 3821,
     /*  579616 */     GIR_EraseRootFromParent_Done,
     /*  579617 */   // Label 9450: @579617
     /*  579617 */   GIM_Try, /*On fail goto*//*Label 9451*/ GIMT_Encode4(579692), // Rule ID 3824 //
     /*  579622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  579633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  579636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  579639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  579642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579668 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  579671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579690 */     GIR_RootConstrainSelectedInstOperands,
     /*  579691 */     // GIR_Coverage, 3824,
     /*  579691 */     GIR_EraseRootFromParent_Done,
     /*  579692 */   // Label 9451: @579692
     /*  579692 */   GIM_Try, /*On fail goto*//*Label 9452*/ GIMT_Encode4(579767), // Rule ID 3825 //
     /*  579697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  579708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  579711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  579714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  579717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579743 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  579746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579765 */     GIR_RootConstrainSelectedInstOperands,
     /*  579766 */     // GIR_Coverage, 3825,
     /*  579766 */     GIR_EraseRootFromParent_Done,
     /*  579767 */   // Label 9452: @579767
     /*  579767 */   GIM_Try, /*On fail goto*//*Label 9453*/ GIMT_Encode4(579842), // Rule ID 3828 //
     /*  579772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  579783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  579786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  579789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  579792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  579821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579840 */     GIR_RootConstrainSelectedInstOperands,
     /*  579841 */     // GIR_Coverage, 3828,
     /*  579841 */     GIR_EraseRootFromParent_Done,
     /*  579842 */   // Label 9453: @579842
     /*  579842 */   GIM_Try, /*On fail goto*//*Label 9454*/ GIMT_Encode4(579917), // Rule ID 3829 //
     /*  579847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  579858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  579861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  579864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  579867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579893 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  579896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579915 */     GIR_RootConstrainSelectedInstOperands,
     /*  579916 */     // GIR_Coverage, 3829,
     /*  579916 */     GIR_EraseRootFromParent_Done,
     /*  579917 */   // Label 9454: @579917
     /*  579917 */   GIM_Try, /*On fail goto*//*Label 9455*/ GIMT_Encode4(579992), // Rule ID 3832 //
     /*  579922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  579933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  579936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  579939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  579942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  579971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579990 */     GIR_RootConstrainSelectedInstOperands,
     /*  579991 */     // GIR_Coverage, 3832,
     /*  579991 */     GIR_EraseRootFromParent_Done,
     /*  579992 */   // Label 9455: @579992
     /*  579992 */   GIM_Try, /*On fail goto*//*Label 9456*/ GIMT_Encode4(580067), // Rule ID 3833 //
     /*  579997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  580008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  580011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  580014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  580017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  580046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580065 */     GIR_RootConstrainSelectedInstOperands,
     /*  580066 */     // GIR_Coverage, 3833,
     /*  580066 */     GIR_EraseRootFromParent_Done,
     /*  580067 */   // Label 9456: @580067
     /*  580067 */   GIM_Try, /*On fail goto*//*Label 9457*/ GIMT_Encode4(580142), // Rule ID 3836 //
     /*  580072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  580083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  580086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  580089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  580092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  580121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580140 */     GIR_RootConstrainSelectedInstOperands,
     /*  580141 */     // GIR_Coverage, 3836,
     /*  580141 */     GIR_EraseRootFromParent_Done,
     /*  580142 */   // Label 9457: @580142
     /*  580142 */   GIM_Try, /*On fail goto*//*Label 9458*/ GIMT_Encode4(580217), // Rule ID 3837 //
     /*  580147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  580158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  580161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  580164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  580167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580193 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  580196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580215 */     GIR_RootConstrainSelectedInstOperands,
     /*  580216 */     // GIR_Coverage, 3837,
     /*  580216 */     GIR_EraseRootFromParent_Done,
     /*  580217 */   // Label 9458: @580217
     /*  580217 */   GIM_Try, /*On fail goto*//*Label 9459*/ GIMT_Encode4(580292), // Rule ID 3840 //
     /*  580222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  580233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  580236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  580239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  580242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  580271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580290 */     GIR_RootConstrainSelectedInstOperands,
     /*  580291 */     // GIR_Coverage, 3840,
     /*  580291 */     GIR_EraseRootFromParent_Done,
     /*  580292 */   // Label 9459: @580292
     /*  580292 */   GIM_Try, /*On fail goto*//*Label 9460*/ GIMT_Encode4(580367), // Rule ID 3841 //
     /*  580297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  580308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  580311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  580314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  580317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580343 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  580346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580365 */     GIR_RootConstrainSelectedInstOperands,
     /*  580366 */     // GIR_Coverage, 3841,
     /*  580366 */     GIR_EraseRootFromParent_Done,
     /*  580367 */   // Label 9460: @580367
     /*  580367 */   GIM_Try, /*On fail goto*//*Label 9461*/ GIMT_Encode4(580442), // Rule ID 3844 //
     /*  580372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  580383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  580386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  580389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  580392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580418 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  580418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  580421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580440 */     GIR_RootConstrainSelectedInstOperands,
     /*  580441 */     // GIR_Coverage, 3844,
     /*  580441 */     GIR_EraseRootFromParent_Done,
     /*  580442 */   // Label 9461: @580442
     /*  580442 */   GIM_Try, /*On fail goto*//*Label 9462*/ GIMT_Encode4(580517), // Rule ID 3845 //
     /*  580447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  580458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  580461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  580464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  580467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580493 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  580493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  580496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580515 */     GIR_RootConstrainSelectedInstOperands,
     /*  580516 */     // GIR_Coverage, 3845,
     /*  580516 */     GIR_EraseRootFromParent_Done,
     /*  580517 */   // Label 9462: @580517
     /*  580517 */   GIM_Try, /*On fail goto*//*Label 9463*/ GIMT_Encode4(580592), // Rule ID 3848 //
     /*  580522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  580533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  580536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  580539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  580542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580568 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  580568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  580571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580590 */     GIR_RootConstrainSelectedInstOperands,
     /*  580591 */     // GIR_Coverage, 3848,
     /*  580591 */     GIR_EraseRootFromParent_Done,
     /*  580592 */   // Label 9463: @580592
     /*  580592 */   GIM_Try, /*On fail goto*//*Label 9464*/ GIMT_Encode4(580667), // Rule ID 3849 //
     /*  580597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  580608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  580611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  580614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  580617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580643 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  580643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  580646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580665 */     GIR_RootConstrainSelectedInstOperands,
     /*  580666 */     // GIR_Coverage, 3849,
     /*  580666 */     GIR_EraseRootFromParent_Done,
     /*  580667 */   // Label 9464: @580667
     /*  580667 */   GIM_Try, /*On fail goto*//*Label 9465*/ GIMT_Encode4(580742), // Rule ID 3852 //
     /*  580672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  580683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  580686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  580689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  580692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  580718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  580721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580740 */     GIR_RootConstrainSelectedInstOperands,
     /*  580741 */     // GIR_Coverage, 3852,
     /*  580741 */     GIR_EraseRootFromParent_Done,
     /*  580742 */   // Label 9465: @580742
     /*  580742 */   GIM_Try, /*On fail goto*//*Label 9466*/ GIMT_Encode4(580817), // Rule ID 3853 //
     /*  580747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  580758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  580761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  580764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  580767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  580793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  580796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580815 */     GIR_RootConstrainSelectedInstOperands,
     /*  580816 */     // GIR_Coverage, 3853,
     /*  580816 */     GIR_EraseRootFromParent_Done,
     /*  580817 */   // Label 9466: @580817
     /*  580817 */   GIM_Try, /*On fail goto*//*Label 9467*/ GIMT_Encode4(580892), // Rule ID 3856 //
     /*  580822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  580833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  580836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  580839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  580842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  580868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  580871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580890 */     GIR_RootConstrainSelectedInstOperands,
     /*  580891 */     // GIR_Coverage, 3856,
     /*  580891 */     GIR_EraseRootFromParent_Done,
     /*  580892 */   // Label 9467: @580892
     /*  580892 */   GIM_Try, /*On fail goto*//*Label 9468*/ GIMT_Encode4(580967), // Rule ID 3857 //
     /*  580897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  580908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  580911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  580914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  580917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580943 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  580943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  580946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580965 */     GIR_RootConstrainSelectedInstOperands,
     /*  580966 */     // GIR_Coverage, 3857,
     /*  580966 */     GIR_EraseRootFromParent_Done,
     /*  580967 */   // Label 9468: @580967
     /*  580967 */   GIM_Try, /*On fail goto*//*Label 9469*/ GIMT_Encode4(581042), // Rule ID 3860 //
     /*  580972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  580983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  580986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  580989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  580992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  581021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581040 */     GIR_RootConstrainSelectedInstOperands,
     /*  581041 */     // GIR_Coverage, 3860,
     /*  581041 */     GIR_EraseRootFromParent_Done,
     /*  581042 */   // Label 9469: @581042
     /*  581042 */   GIM_Try, /*On fail goto*//*Label 9470*/ GIMT_Encode4(581117), // Rule ID 3861 //
     /*  581047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  581058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  581061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  581064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  581067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581093 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  581096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581115 */     GIR_RootConstrainSelectedInstOperands,
     /*  581116 */     // GIR_Coverage, 3861,
     /*  581116 */     GIR_EraseRootFromParent_Done,
     /*  581117 */   // Label 9470: @581117
     /*  581117 */   GIM_Try, /*On fail goto*//*Label 9471*/ GIMT_Encode4(581192), // Rule ID 3864 //
     /*  581122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  581133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  581136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  581139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  581142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  581171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581190 */     GIR_RootConstrainSelectedInstOperands,
     /*  581191 */     // GIR_Coverage, 3864,
     /*  581191 */     GIR_EraseRootFromParent_Done,
     /*  581192 */   // Label 9471: @581192
     /*  581192 */   GIM_Try, /*On fail goto*//*Label 9472*/ GIMT_Encode4(581267), // Rule ID 3865 //
     /*  581197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  581208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  581211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  581214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  581217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581243 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  581246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581265 */     GIR_RootConstrainSelectedInstOperands,
     /*  581266 */     // GIR_Coverage, 3865,
     /*  581266 */     GIR_EraseRootFromParent_Done,
     /*  581267 */   // Label 9472: @581267
     /*  581267 */   GIM_Try, /*On fail goto*//*Label 9473*/ GIMT_Encode4(581342), // Rule ID 3868 //
     /*  581272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  581283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  581286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  581289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  581292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  581321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581340 */     GIR_RootConstrainSelectedInstOperands,
     /*  581341 */     // GIR_Coverage, 3868,
     /*  581341 */     GIR_EraseRootFromParent_Done,
     /*  581342 */   // Label 9473: @581342
     /*  581342 */   GIM_Try, /*On fail goto*//*Label 9474*/ GIMT_Encode4(581417), // Rule ID 3869 //
     /*  581347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  581358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  581361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  581364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  581367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581393 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  581396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581415 */     GIR_RootConstrainSelectedInstOperands,
     /*  581416 */     // GIR_Coverage, 3869,
     /*  581416 */     GIR_EraseRootFromParent_Done,
     /*  581417 */   // Label 9474: @581417
     /*  581417 */   GIM_Try, /*On fail goto*//*Label 9475*/ GIMT_Encode4(581492), // Rule ID 3872 //
     /*  581422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  581433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  581436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  581439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  581442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  581471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581490 */     GIR_RootConstrainSelectedInstOperands,
     /*  581491 */     // GIR_Coverage, 3872,
     /*  581491 */     GIR_EraseRootFromParent_Done,
     /*  581492 */   // Label 9475: @581492
     /*  581492 */   GIM_Try, /*On fail goto*//*Label 9476*/ GIMT_Encode4(581567), // Rule ID 3873 //
     /*  581497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  581508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  581511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  581514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  581517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581543 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  581546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581565 */     GIR_RootConstrainSelectedInstOperands,
     /*  581566 */     // GIR_Coverage, 3873,
     /*  581566 */     GIR_EraseRootFromParent_Done,
     /*  581567 */   // Label 9476: @581567
     /*  581567 */   GIM_Try, /*On fail goto*//*Label 9477*/ GIMT_Encode4(581642), // Rule ID 3876 //
     /*  581572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  581583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  581586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  581589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  581592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581618 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  581621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581640 */     GIR_RootConstrainSelectedInstOperands,
     /*  581641 */     // GIR_Coverage, 3876,
     /*  581641 */     GIR_EraseRootFromParent_Done,
     /*  581642 */   // Label 9477: @581642
     /*  581642 */   GIM_Try, /*On fail goto*//*Label 9478*/ GIMT_Encode4(581717), // Rule ID 3877 //
     /*  581647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  581658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  581661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  581664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  581667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581693 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  581696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581715 */     GIR_RootConstrainSelectedInstOperands,
     /*  581716 */     // GIR_Coverage, 3877,
     /*  581716 */     GIR_EraseRootFromParent_Done,
     /*  581717 */   // Label 9478: @581717
     /*  581717 */   GIM_Try, /*On fail goto*//*Label 9479*/ GIMT_Encode4(581792), // Rule ID 3880 //
     /*  581722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  581733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  581736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  581739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  581742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  581768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  581771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581790 */     GIR_RootConstrainSelectedInstOperands,
     /*  581791 */     // GIR_Coverage, 3880,
     /*  581791 */     GIR_EraseRootFromParent_Done,
     /*  581792 */   // Label 9479: @581792
     /*  581792 */   GIM_Try, /*On fail goto*//*Label 9480*/ GIMT_Encode4(581867), // Rule ID 3881 //
     /*  581797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  581808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  581811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  581814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  581817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  581846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581865 */     GIR_RootConstrainSelectedInstOperands,
     /*  581866 */     // GIR_Coverage, 3881,
     /*  581866 */     GIR_EraseRootFromParent_Done,
     /*  581867 */   // Label 9480: @581867
     /*  581867 */   GIM_Try, /*On fail goto*//*Label 9481*/ GIMT_Encode4(581942), // Rule ID 3884 //
     /*  581872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  581883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  581886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  581889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  581892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  581918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  581921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581940 */     GIR_RootConstrainSelectedInstOperands,
     /*  581941 */     // GIR_Coverage, 3884,
     /*  581941 */     GIR_EraseRootFromParent_Done,
     /*  581942 */   // Label 9481: @581942
     /*  581942 */   GIM_Try, /*On fail goto*//*Label 9482*/ GIMT_Encode4(582017), // Rule ID 3885 //
     /*  581947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  581958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  581961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  581964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  581967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581993 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  581996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582015 */     GIR_RootConstrainSelectedInstOperands,
     /*  582016 */     // GIR_Coverage, 3885,
     /*  582016 */     GIR_EraseRootFromParent_Done,
     /*  582017 */   // Label 9482: @582017
     /*  582017 */   GIM_Try, /*On fail goto*//*Label 9483*/ GIMT_Encode4(582092), // Rule ID 3888 //
     /*  582022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  582033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  582036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  582039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  582071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582090 */     GIR_RootConstrainSelectedInstOperands,
     /*  582091 */     // GIR_Coverage, 3888,
     /*  582091 */     GIR_EraseRootFromParent_Done,
     /*  582092 */   // Label 9483: @582092
     /*  582092 */   GIM_Try, /*On fail goto*//*Label 9484*/ GIMT_Encode4(582167), // Rule ID 3889 //
     /*  582097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  582108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  582111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  582114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582143 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  582146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582165 */     GIR_RootConstrainSelectedInstOperands,
     /*  582166 */     // GIR_Coverage, 3889,
     /*  582166 */     GIR_EraseRootFromParent_Done,
     /*  582167 */   // Label 9484: @582167
     /*  582167 */   GIM_Try, /*On fail goto*//*Label 9485*/ GIMT_Encode4(582242), // Rule ID 3892 //
     /*  582172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  582183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  582186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  582189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  582221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582240 */     GIR_RootConstrainSelectedInstOperands,
     /*  582241 */     // GIR_Coverage, 3892,
     /*  582241 */     GIR_EraseRootFromParent_Done,
     /*  582242 */   // Label 9485: @582242
     /*  582242 */   GIM_Try, /*On fail goto*//*Label 9486*/ GIMT_Encode4(582317), // Rule ID 3893 //
     /*  582247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  582258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  582261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  582264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582293 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  582296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582315 */     GIR_RootConstrainSelectedInstOperands,
     /*  582316 */     // GIR_Coverage, 3893,
     /*  582316 */     GIR_EraseRootFromParent_Done,
     /*  582317 */   // Label 9486: @582317
     /*  582317 */   GIM_Try, /*On fail goto*//*Label 9487*/ GIMT_Encode4(582392), // Rule ID 3896 //
     /*  582322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  582333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  582336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  582339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582368 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  582371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582390 */     GIR_RootConstrainSelectedInstOperands,
     /*  582391 */     // GIR_Coverage, 3896,
     /*  582391 */     GIR_EraseRootFromParent_Done,
     /*  582392 */   // Label 9487: @582392
     /*  582392 */   GIM_Try, /*On fail goto*//*Label 9488*/ GIMT_Encode4(582467), // Rule ID 3897 //
     /*  582397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  582408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  582411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  582414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582443 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  582446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582465 */     GIR_RootConstrainSelectedInstOperands,
     /*  582466 */     // GIR_Coverage, 3897,
     /*  582466 */     GIR_EraseRootFromParent_Done,
     /*  582467 */   // Label 9488: @582467
     /*  582467 */   GIM_Try, /*On fail goto*//*Label 9489*/ GIMT_Encode4(582542), // Rule ID 3900 //
     /*  582472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  582483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  582486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  582489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582518 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  582521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582540 */     GIR_RootConstrainSelectedInstOperands,
     /*  582541 */     // GIR_Coverage, 3900,
     /*  582541 */     GIR_EraseRootFromParent_Done,
     /*  582542 */   // Label 9489: @582542
     /*  582542 */   GIM_Try, /*On fail goto*//*Label 9490*/ GIMT_Encode4(582617), // Rule ID 3901 //
     /*  582547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  582558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  582561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  582564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582593 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  582596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582615 */     GIR_RootConstrainSelectedInstOperands,
     /*  582616 */     // GIR_Coverage, 3901,
     /*  582616 */     GIR_EraseRootFromParent_Done,
     /*  582617 */   // Label 9490: @582617
     /*  582617 */   GIM_Try, /*On fail goto*//*Label 9491*/ GIMT_Encode4(582692), // Rule ID 3904 //
     /*  582622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  582633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  582636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  582639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  582668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  582671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582690 */     GIR_RootConstrainSelectedInstOperands,
     /*  582691 */     // GIR_Coverage, 3904,
     /*  582691 */     GIR_EraseRootFromParent_Done,
     /*  582692 */   // Label 9491: @582692
     /*  582692 */   GIM_Try, /*On fail goto*//*Label 9492*/ GIMT_Encode4(582767), // Rule ID 3905 //
     /*  582697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  582708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  582711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  582714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582743 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  582743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  582746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582765 */     GIR_RootConstrainSelectedInstOperands,
     /*  582766 */     // GIR_Coverage, 3905,
     /*  582766 */     GIR_EraseRootFromParent_Done,
     /*  582767 */   // Label 9492: @582767
     /*  582767 */   GIM_Try, /*On fail goto*//*Label 9493*/ GIMT_Encode4(582842), // Rule ID 3908 //
     /*  582772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  582783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  582786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  582789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  582818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  582821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582840 */     GIR_RootConstrainSelectedInstOperands,
     /*  582841 */     // GIR_Coverage, 3908,
     /*  582841 */     GIR_EraseRootFromParent_Done,
     /*  582842 */   // Label 9493: @582842
     /*  582842 */   GIM_Try, /*On fail goto*//*Label 9494*/ GIMT_Encode4(582917), // Rule ID 3909 //
     /*  582847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  582858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  582861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  582864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582893 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  582893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  582896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582915 */     GIR_RootConstrainSelectedInstOperands,
     /*  582916 */     // GIR_Coverage, 3909,
     /*  582916 */     GIR_EraseRootFromParent_Done,
     /*  582917 */   // Label 9494: @582917
     /*  582917 */   GIM_Try, /*On fail goto*//*Label 9495*/ GIMT_Encode4(582992), // Rule ID 3912 //
     /*  582922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  582933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  582936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  582939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582968 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  582968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  582971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582990 */     GIR_RootConstrainSelectedInstOperands,
     /*  582991 */     // GIR_Coverage, 3912,
     /*  582991 */     GIR_EraseRootFromParent_Done,
     /*  582992 */   // Label 9495: @582992
     /*  582992 */   GIM_Try, /*On fail goto*//*Label 9496*/ GIMT_Encode4(583067), // Rule ID 3913 //
     /*  582997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  583008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  583011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  583014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  583046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583065 */     GIR_RootConstrainSelectedInstOperands,
     /*  583066 */     // GIR_Coverage, 3913,
     /*  583066 */     GIR_EraseRootFromParent_Done,
     /*  583067 */   // Label 9496: @583067
     /*  583067 */   GIM_Try, /*On fail goto*//*Label 9497*/ GIMT_Encode4(583142), // Rule ID 3916 //
     /*  583072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  583083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  583086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  583089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  583121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583140 */     GIR_RootConstrainSelectedInstOperands,
     /*  583141 */     // GIR_Coverage, 3916,
     /*  583141 */     GIR_EraseRootFromParent_Done,
     /*  583142 */   // Label 9497: @583142
     /*  583142 */   GIM_Try, /*On fail goto*//*Label 9498*/ GIMT_Encode4(583217), // Rule ID 3917 //
     /*  583147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  583158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  583161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  583164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583193 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  583196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583215 */     GIR_RootConstrainSelectedInstOperands,
     /*  583216 */     // GIR_Coverage, 3917,
     /*  583216 */     GIR_EraseRootFromParent_Done,
     /*  583217 */   // Label 9498: @583217
     /*  583217 */   GIM_Try, /*On fail goto*//*Label 9499*/ GIMT_Encode4(583292), // Rule ID 3920 //
     /*  583222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  583233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  583236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  583239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583268 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  583271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583290 */     GIR_RootConstrainSelectedInstOperands,
     /*  583291 */     // GIR_Coverage, 3920,
     /*  583291 */     GIR_EraseRootFromParent_Done,
     /*  583292 */   // Label 9499: @583292
     /*  583292 */   GIM_Try, /*On fail goto*//*Label 9500*/ GIMT_Encode4(583367), // Rule ID 3921 //
     /*  583297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  583308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  583311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  583314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583343 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  583346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583365 */     GIR_RootConstrainSelectedInstOperands,
     /*  583366 */     // GIR_Coverage, 3921,
     /*  583366 */     GIR_EraseRootFromParent_Done,
     /*  583367 */   // Label 9500: @583367
     /*  583367 */   GIM_Try, /*On fail goto*//*Label 9501*/ GIMT_Encode4(583442), // Rule ID 3924 //
     /*  583372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  583375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  583383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  583386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  583389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583418 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  583418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  583421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583440 */     GIR_RootConstrainSelectedInstOperands,
     /*  583441 */     // GIR_Coverage, 3924,
     /*  583441 */     GIR_EraseRootFromParent_Done,
     /*  583442 */   // Label 9501: @583442
     /*  583442 */   GIM_Try, /*On fail goto*//*Label 9502*/ GIMT_Encode4(583517), // Rule ID 3925 //
     /*  583447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  583450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  583458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  583461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  583464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583493 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  583493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  583496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583515 */     GIR_RootConstrainSelectedInstOperands,
     /*  583516 */     // GIR_Coverage, 3925,
     /*  583516 */     GIR_EraseRootFromParent_Done,
     /*  583517 */   // Label 9502: @583517
     /*  583517 */   GIM_Try, /*On fail goto*//*Label 9503*/ GIMT_Encode4(583592), // Rule ID 3928 //
     /*  583522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  583525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  583533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  583536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  583539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583568 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  583568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  583571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583590 */     GIR_RootConstrainSelectedInstOperands,
     /*  583591 */     // GIR_Coverage, 3928,
     /*  583591 */     GIR_EraseRootFromParent_Done,
     /*  583592 */   // Label 9503: @583592
     /*  583592 */   GIM_Try, /*On fail goto*//*Label 9504*/ GIMT_Encode4(583667), // Rule ID 3929 //
     /*  583597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  583600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  583608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  583611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  583614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583643 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  583643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  583646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583665 */     GIR_RootConstrainSelectedInstOperands,
     /*  583666 */     // GIR_Coverage, 3929,
     /*  583666 */     GIR_EraseRootFromParent_Done,
     /*  583667 */   // Label 9504: @583667
     /*  583667 */   GIM_Try, /*On fail goto*//*Label 9505*/ GIMT_Encode4(583742), // Rule ID 3932 //
     /*  583672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  583675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  583683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  583686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  583689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583718 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  583718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  583721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583740 */     GIR_RootConstrainSelectedInstOperands,
     /*  583741 */     // GIR_Coverage, 3932,
     /*  583741 */     GIR_EraseRootFromParent_Done,
     /*  583742 */   // Label 9505: @583742
     /*  583742 */   GIM_Try, /*On fail goto*//*Label 9506*/ GIMT_Encode4(583817), // Rule ID 3933 //
     /*  583747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  583750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  583758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  583761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  583764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583793 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  583793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  583796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583815 */     GIR_RootConstrainSelectedInstOperands,
     /*  583816 */     // GIR_Coverage, 3933,
     /*  583816 */     GIR_EraseRootFromParent_Done,
     /*  583817 */   // Label 9506: @583817
     /*  583817 */   GIM_Try, /*On fail goto*//*Label 9507*/ GIMT_Encode4(583892), // Rule ID 3936 //
     /*  583822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  583825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  583833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  583836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  583839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  583868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  583871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583890 */     GIR_RootConstrainSelectedInstOperands,
     /*  583891 */     // GIR_Coverage, 3936,
     /*  583891 */     GIR_EraseRootFromParent_Done,
     /*  583892 */   // Label 9507: @583892
     /*  583892 */   GIM_Try, /*On fail goto*//*Label 9508*/ GIMT_Encode4(583967), // Rule ID 3937 //
     /*  583897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  583900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  583908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  583911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  583914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583943 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  583943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  583946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583965 */     GIR_RootConstrainSelectedInstOperands,
     /*  583966 */     // GIR_Coverage, 3937,
     /*  583966 */     GIR_EraseRootFromParent_Done,
     /*  583967 */   // Label 9508: @583967
     /*  583967 */   GIM_Try, /*On fail goto*//*Label 9509*/ GIMT_Encode4(584042), // Rule ID 3940 //
     /*  583972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  583983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  583986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  583989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  583992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584018 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  584021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584040 */     GIR_RootConstrainSelectedInstOperands,
     /*  584041 */     // GIR_Coverage, 3940,
     /*  584041 */     GIR_EraseRootFromParent_Done,
     /*  584042 */   // Label 9509: @584042
     /*  584042 */   GIM_Try, /*On fail goto*//*Label 9510*/ GIMT_Encode4(584117), // Rule ID 3941 //
     /*  584047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  584058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  584061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  584064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  584067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584093 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  584096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584115 */     GIR_RootConstrainSelectedInstOperands,
     /*  584116 */     // GIR_Coverage, 3941,
     /*  584116 */     GIR_EraseRootFromParent_Done,
     /*  584117 */   // Label 9510: @584117
     /*  584117 */   GIM_Try, /*On fail goto*//*Label 9511*/ GIMT_Encode4(584192), // Rule ID 3944 //
     /*  584122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  584133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  584136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  584139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  584142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584168 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  584171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584190 */     GIR_RootConstrainSelectedInstOperands,
     /*  584191 */     // GIR_Coverage, 3944,
     /*  584191 */     GIR_EraseRootFromParent_Done,
     /*  584192 */   // Label 9511: @584192
     /*  584192 */   GIM_Try, /*On fail goto*//*Label 9512*/ GIMT_Encode4(584267), // Rule ID 3945 //
     /*  584197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  584208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  584211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  584214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  584217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584243 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  584246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584265 */     GIR_RootConstrainSelectedInstOperands,
     /*  584266 */     // GIR_Coverage, 3945,
     /*  584266 */     GIR_EraseRootFromParent_Done,
     /*  584267 */   // Label 9512: @584267
     /*  584267 */   GIM_Try, /*On fail goto*//*Label 9513*/ GIMT_Encode4(584342), // Rule ID 3948 //
     /*  584272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  584283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  584286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  584289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  584292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  584321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584340 */     GIR_RootConstrainSelectedInstOperands,
     /*  584341 */     // GIR_Coverage, 3948,
     /*  584341 */     GIR_EraseRootFromParent_Done,
     /*  584342 */   // Label 9513: @584342
     /*  584342 */   GIM_Try, /*On fail goto*//*Label 9514*/ GIMT_Encode4(584417), // Rule ID 3949 //
     /*  584347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  584358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  584361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  584364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  584367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584393 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  584396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584415 */     GIR_RootConstrainSelectedInstOperands,
     /*  584416 */     // GIR_Coverage, 3949,
     /*  584416 */     GIR_EraseRootFromParent_Done,
     /*  584417 */   // Label 9514: @584417
     /*  584417 */   GIM_Try, /*On fail goto*//*Label 9515*/ GIMT_Encode4(584492), // Rule ID 3952 //
     /*  584422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  584433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  584436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  584439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  584442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  584471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584490 */     GIR_RootConstrainSelectedInstOperands,
     /*  584491 */     // GIR_Coverage, 3952,
     /*  584491 */     GIR_EraseRootFromParent_Done,
     /*  584492 */   // Label 9515: @584492
     /*  584492 */   GIM_Try, /*On fail goto*//*Label 9516*/ GIMT_Encode4(584567), // Rule ID 3953 //
     /*  584497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  584508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  584511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  584514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  584517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584543 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  584546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584565 */     GIR_RootConstrainSelectedInstOperands,
     /*  584566 */     // GIR_Coverage, 3953,
     /*  584566 */     GIR_EraseRootFromParent_Done,
     /*  584567 */   // Label 9516: @584567
     /*  584567 */   GIM_Try, /*On fail goto*//*Label 9517*/ GIMT_Encode4(584642), // Rule ID 3956 //
     /*  584572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  584583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  584586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  584589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  584592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584618 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  584621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584640 */     GIR_RootConstrainSelectedInstOperands,
     /*  584641 */     // GIR_Coverage, 3956,
     /*  584641 */     GIR_EraseRootFromParent_Done,
     /*  584642 */   // Label 9517: @584642
     /*  584642 */   GIM_Try, /*On fail goto*//*Label 9518*/ GIMT_Encode4(584717), // Rule ID 3957 //
     /*  584647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  584658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  584661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  584664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  584667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584693 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  584696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584715 */     GIR_RootConstrainSelectedInstOperands,
     /*  584716 */     // GIR_Coverage, 3957,
     /*  584716 */     GIR_EraseRootFromParent_Done,
     /*  584717 */   // Label 9518: @584717
     /*  584717 */   GIM_Try, /*On fail goto*//*Label 9519*/ GIMT_Encode4(584792), // Rule ID 3960 //
     /*  584722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  584733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  584736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  584739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  584742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  584771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584790 */     GIR_RootConstrainSelectedInstOperands,
     /*  584791 */     // GIR_Coverage, 3960,
     /*  584791 */     GIR_EraseRootFromParent_Done,
     /*  584792 */   // Label 9519: @584792
     /*  584792 */   GIM_Try, /*On fail goto*//*Label 9520*/ GIMT_Encode4(584867), // Rule ID 3961 //
     /*  584797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  584808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  584811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  584814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  584817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584843 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  584846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584865 */     GIR_RootConstrainSelectedInstOperands,
     /*  584866 */     // GIR_Coverage, 3961,
     /*  584866 */     GIR_EraseRootFromParent_Done,
     /*  584867 */   // Label 9520: @584867
     /*  584867 */   GIM_Try, /*On fail goto*//*Label 9521*/ GIMT_Encode4(584942), // Rule ID 3964 //
     /*  584872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  584883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  584886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  584889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  584892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  584918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  584921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584940 */     GIR_RootConstrainSelectedInstOperands,
     /*  584941 */     // GIR_Coverage, 3964,
     /*  584941 */     GIR_EraseRootFromParent_Done,
     /*  584942 */   // Label 9521: @584942
     /*  584942 */   GIM_Try, /*On fail goto*//*Label 9522*/ GIMT_Encode4(585017), // Rule ID 3965 //
     /*  584947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  584958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  584961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  584964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  584967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584993 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  584996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585015 */     GIR_RootConstrainSelectedInstOperands,
     /*  585016 */     // GIR_Coverage, 3965,
     /*  585016 */     GIR_EraseRootFromParent_Done,
     /*  585017 */   // Label 9522: @585017
     /*  585017 */   GIM_Try, /*On fail goto*//*Label 9523*/ GIMT_Encode4(585092), // Rule ID 3968 //
     /*  585022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  585033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  585036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  585039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  585042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585068 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  585071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585090 */     GIR_RootConstrainSelectedInstOperands,
     /*  585091 */     // GIR_Coverage, 3968,
     /*  585091 */     GIR_EraseRootFromParent_Done,
     /*  585092 */   // Label 9523: @585092
     /*  585092 */   GIM_Try, /*On fail goto*//*Label 9524*/ GIMT_Encode4(585167), // Rule ID 3969 //
     /*  585097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  585108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  585111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  585114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  585117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585143 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  585146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585165 */     GIR_RootConstrainSelectedInstOperands,
     /*  585166 */     // GIR_Coverage, 3969,
     /*  585166 */     GIR_EraseRootFromParent_Done,
     /*  585167 */   // Label 9524: @585167
     /*  585167 */   GIM_Try, /*On fail goto*//*Label 9525*/ GIMT_Encode4(585242), // Rule ID 3972 //
     /*  585172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  585183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  585186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  585189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  585192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  585221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585240 */     GIR_RootConstrainSelectedInstOperands,
     /*  585241 */     // GIR_Coverage, 3972,
     /*  585241 */     GIR_EraseRootFromParent_Done,
     /*  585242 */   // Label 9525: @585242
     /*  585242 */   GIM_Try, /*On fail goto*//*Label 9526*/ GIMT_Encode4(585317), // Rule ID 3973 //
     /*  585247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  585258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  585261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  585264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  585267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  585296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585315 */     GIR_RootConstrainSelectedInstOperands,
     /*  585316 */     // GIR_Coverage, 3973,
     /*  585316 */     GIR_EraseRootFromParent_Done,
     /*  585317 */   // Label 9526: @585317
     /*  585317 */   GIM_Try, /*On fail goto*//*Label 9527*/ GIMT_Encode4(585392), // Rule ID 3976 //
     /*  585322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  585333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  585336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  585339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  585342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  585371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585390 */     GIR_RootConstrainSelectedInstOperands,
     /*  585391 */     // GIR_Coverage, 3976,
     /*  585391 */     GIR_EraseRootFromParent_Done,
     /*  585392 */   // Label 9527: @585392
     /*  585392 */   GIM_Try, /*On fail goto*//*Label 9528*/ GIMT_Encode4(585467), // Rule ID 3977 //
     /*  585397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  585408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  585411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  585414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  585417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585443 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  585446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585465 */     GIR_RootConstrainSelectedInstOperands,
     /*  585466 */     // GIR_Coverage, 3977,
     /*  585466 */     GIR_EraseRootFromParent_Done,
     /*  585467 */   // Label 9528: @585467
     /*  585467 */   GIM_Try, /*On fail goto*//*Label 9529*/ GIMT_Encode4(585542), // Rule ID 3980 //
     /*  585472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  585483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  585486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  585489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  585492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  585521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585540 */     GIR_RootConstrainSelectedInstOperands,
     /*  585541 */     // GIR_Coverage, 3980,
     /*  585541 */     GIR_EraseRootFromParent_Done,
     /*  585542 */   // Label 9529: @585542
     /*  585542 */   GIM_Try, /*On fail goto*//*Label 9530*/ GIMT_Encode4(585617), // Rule ID 3981 //
     /*  585547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  585558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  585561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  585564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  585567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585593 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  585596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585615 */     GIR_RootConstrainSelectedInstOperands,
     /*  585616 */     // GIR_Coverage, 3981,
     /*  585616 */     GIR_EraseRootFromParent_Done,
     /*  585617 */   // Label 9530: @585617
     /*  585617 */   GIM_Try, /*On fail goto*//*Label 9531*/ GIMT_Encode4(585692), // Rule ID 3984 //
     /*  585622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  585625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  585633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  585636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  585639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  585642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  585668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  585671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585690 */     GIR_RootConstrainSelectedInstOperands,
     /*  585691 */     // GIR_Coverage, 3984,
     /*  585691 */     GIR_EraseRootFromParent_Done,
     /*  585692 */   // Label 9531: @585692
     /*  585692 */   GIM_Try, /*On fail goto*//*Label 9532*/ GIMT_Encode4(585767), // Rule ID 3985 //
     /*  585697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  585700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  585708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  585711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  585714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  585717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585743 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  585743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  585746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585765 */     GIR_RootConstrainSelectedInstOperands,
     /*  585766 */     // GIR_Coverage, 3985,
     /*  585766 */     GIR_EraseRootFromParent_Done,
     /*  585767 */   // Label 9532: @585767
     /*  585767 */   GIM_Try, /*On fail goto*//*Label 9533*/ GIMT_Encode4(585842), // Rule ID 3988 //
     /*  585772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  585775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  585783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  585786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  585789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  585792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585818 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  585818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  585821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585840 */     GIR_RootConstrainSelectedInstOperands,
     /*  585841 */     // GIR_Coverage, 3988,
     /*  585841 */     GIR_EraseRootFromParent_Done,
     /*  585842 */   // Label 9533: @585842
     /*  585842 */   GIM_Try, /*On fail goto*//*Label 9534*/ GIMT_Encode4(585917), // Rule ID 3989 //
     /*  585847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  585850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  585858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  585861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  585864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  585867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585893 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  585893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  585896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585915 */     GIR_RootConstrainSelectedInstOperands,
     /*  585916 */     // GIR_Coverage, 3989,
     /*  585916 */     GIR_EraseRootFromParent_Done,
     /*  585917 */   // Label 9534: @585917
     /*  585917 */   GIM_Try, /*On fail goto*//*Label 9535*/ GIMT_Encode4(585992), // Rule ID 3992 //
     /*  585922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  585925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  585933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  585936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  585939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  585942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585968 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  585968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  585971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585990 */     GIR_RootConstrainSelectedInstOperands,
     /*  585991 */     // GIR_Coverage, 3992,
     /*  585991 */     GIR_EraseRootFromParent_Done,
     /*  585992 */   // Label 9535: @585992
     /*  585992 */   GIM_Try, /*On fail goto*//*Label 9536*/ GIMT_Encode4(586067), // Rule ID 3993 //
     /*  585997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  586008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  586011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  586014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  586017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586043 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  586046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586065 */     GIR_RootConstrainSelectedInstOperands,
     /*  586066 */     // GIR_Coverage, 3993,
     /*  586066 */     GIR_EraseRootFromParent_Done,
     /*  586067 */   // Label 9536: @586067
     /*  586067 */   GIM_Try, /*On fail goto*//*Label 9537*/ GIMT_Encode4(586142), // Rule ID 3996 //
     /*  586072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  586083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  586086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  586089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  586092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586118 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  586121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586140 */     GIR_RootConstrainSelectedInstOperands,
     /*  586141 */     // GIR_Coverage, 3996,
     /*  586141 */     GIR_EraseRootFromParent_Done,
     /*  586142 */   // Label 9537: @586142
     /*  586142 */   GIM_Try, /*On fail goto*//*Label 9538*/ GIMT_Encode4(586217), // Rule ID 3997 //
     /*  586147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  586158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  586161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  586164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  586167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586193 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  586196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586215 */     GIR_RootConstrainSelectedInstOperands,
     /*  586216 */     // GIR_Coverage, 3997,
     /*  586216 */     GIR_EraseRootFromParent_Done,
     /*  586217 */   // Label 9538: @586217
     /*  586217 */   GIM_Try, /*On fail goto*//*Label 9539*/ GIMT_Encode4(586292), // Rule ID 4000 //
     /*  586222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  586233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  586236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  586239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  586271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586290 */     GIR_RootConstrainSelectedInstOperands,
     /*  586291 */     // GIR_Coverage, 4000,
     /*  586291 */     GIR_EraseRootFromParent_Done,
     /*  586292 */   // Label 9539: @586292
     /*  586292 */   GIM_Try, /*On fail goto*//*Label 9540*/ GIMT_Encode4(586367), // Rule ID 4001 //
     /*  586297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  586308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  586311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  586314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586343 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  586346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586365 */     GIR_RootConstrainSelectedInstOperands,
     /*  586366 */     // GIR_Coverage, 4001,
     /*  586366 */     GIR_EraseRootFromParent_Done,
     /*  586367 */   // Label 9540: @586367
     /*  586367 */   GIM_Try, /*On fail goto*//*Label 9541*/ GIMT_Encode4(586442), // Rule ID 4004 //
     /*  586372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  586383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  586386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  586389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586418 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  586421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586440 */     GIR_RootConstrainSelectedInstOperands,
     /*  586441 */     // GIR_Coverage, 4004,
     /*  586441 */     GIR_EraseRootFromParent_Done,
     /*  586442 */   // Label 9541: @586442
     /*  586442 */   GIM_Try, /*On fail goto*//*Label 9542*/ GIMT_Encode4(586517), // Rule ID 4005 //
     /*  586447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  586458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  586461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  586464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  586496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586515 */     GIR_RootConstrainSelectedInstOperands,
     /*  586516 */     // GIR_Coverage, 4005,
     /*  586516 */     GIR_EraseRootFromParent_Done,
     /*  586517 */   // Label 9542: @586517
     /*  586517 */   GIM_Try, /*On fail goto*//*Label 9543*/ GIMT_Encode4(586592), // Rule ID 4008 //
     /*  586522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  586533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  586536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  586539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  586571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586590 */     GIR_RootConstrainSelectedInstOperands,
     /*  586591 */     // GIR_Coverage, 4008,
     /*  586591 */     GIR_EraseRootFromParent_Done,
     /*  586592 */   // Label 9543: @586592
     /*  586592 */   GIM_Try, /*On fail goto*//*Label 9544*/ GIMT_Encode4(586667), // Rule ID 4009 //
     /*  586597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  586608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  586611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  586614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  586646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586665 */     GIR_RootConstrainSelectedInstOperands,
     /*  586666 */     // GIR_Coverage, 4009,
     /*  586666 */     GIR_EraseRootFromParent_Done,
     /*  586667 */   // Label 9544: @586667
     /*  586667 */   GIM_Try, /*On fail goto*//*Label 9545*/ GIMT_Encode4(586742), // Rule ID 4012 //
     /*  586672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  586683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  586686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  586689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  586721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586740 */     GIR_RootConstrainSelectedInstOperands,
     /*  586741 */     // GIR_Coverage, 4012,
     /*  586741 */     GIR_EraseRootFromParent_Done,
     /*  586742 */   // Label 9545: @586742
     /*  586742 */   GIM_Try, /*On fail goto*//*Label 9546*/ GIMT_Encode4(586817), // Rule ID 4013 //
     /*  586747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  586758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  586761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  586764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  586796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586815 */     GIR_RootConstrainSelectedInstOperands,
     /*  586816 */     // GIR_Coverage, 4013,
     /*  586816 */     GIR_EraseRootFromParent_Done,
     /*  586817 */   // Label 9546: @586817
     /*  586817 */   GIM_Try, /*On fail goto*//*Label 9547*/ GIMT_Encode4(586892), // Rule ID 4016 //
     /*  586822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  586833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  586836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  586839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586868 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  586871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586890 */     GIR_RootConstrainSelectedInstOperands,
     /*  586891 */     // GIR_Coverage, 4016,
     /*  586891 */     GIR_EraseRootFromParent_Done,
     /*  586892 */   // Label 9547: @586892
     /*  586892 */   GIM_Try, /*On fail goto*//*Label 9548*/ GIMT_Encode4(586967), // Rule ID 4017 //
     /*  586897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  586908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  586911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  586914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586943 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  586946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586965 */     GIR_RootConstrainSelectedInstOperands,
     /*  586966 */     // GIR_Coverage, 4017,
     /*  586966 */     GIR_EraseRootFromParent_Done,
     /*  586967 */   // Label 9548: @586967
     /*  586967 */   GIM_Try, /*On fail goto*//*Label 9549*/ GIMT_Encode4(587042), // Rule ID 4020 //
     /*  586972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  586983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  586986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  586989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587018 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  587021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587040 */     GIR_RootConstrainSelectedInstOperands,
     /*  587041 */     // GIR_Coverage, 4020,
     /*  587041 */     GIR_EraseRootFromParent_Done,
     /*  587042 */   // Label 9549: @587042
     /*  587042 */   GIM_Try, /*On fail goto*//*Label 9550*/ GIMT_Encode4(587117), // Rule ID 4021 //
     /*  587047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  587058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  587061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  587064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587093 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  587096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587115 */     GIR_RootConstrainSelectedInstOperands,
     /*  587116 */     // GIR_Coverage, 4021,
     /*  587116 */     GIR_EraseRootFromParent_Done,
     /*  587117 */   // Label 9550: @587117
     /*  587117 */   GIM_Try, /*On fail goto*//*Label 9551*/ GIMT_Encode4(587192), // Rule ID 4024 //
     /*  587122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  587133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  587136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  587139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  587171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587190 */     GIR_RootConstrainSelectedInstOperands,
     /*  587191 */     // GIR_Coverage, 4024,
     /*  587191 */     GIR_EraseRootFromParent_Done,
     /*  587192 */   // Label 9551: @587192
     /*  587192 */   GIM_Try, /*On fail goto*//*Label 9552*/ GIMT_Encode4(587267), // Rule ID 4025 //
     /*  587197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  587208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  587211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  587214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587243 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  587246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587265 */     GIR_RootConstrainSelectedInstOperands,
     /*  587266 */     // GIR_Coverage, 4025,
     /*  587266 */     GIR_EraseRootFromParent_Done,
     /*  587267 */   // Label 9552: @587267
     /*  587267 */   GIM_Try, /*On fail goto*//*Label 9553*/ GIMT_Encode4(587342), // Rule ID 4028 //
     /*  587272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  587283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  587286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  587289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  587321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587340 */     GIR_RootConstrainSelectedInstOperands,
     /*  587341 */     // GIR_Coverage, 4028,
     /*  587341 */     GIR_EraseRootFromParent_Done,
     /*  587342 */   // Label 9553: @587342
     /*  587342 */   GIM_Try, /*On fail goto*//*Label 9554*/ GIMT_Encode4(587417), // Rule ID 4029 //
     /*  587347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  587358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  587361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  587364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587393 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  587396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587415 */     GIR_RootConstrainSelectedInstOperands,
     /*  587416 */     // GIR_Coverage, 4029,
     /*  587416 */     GIR_EraseRootFromParent_Done,
     /*  587417 */   // Label 9554: @587417
     /*  587417 */   GIM_Try, /*On fail goto*//*Label 9555*/ GIMT_Encode4(587492), // Rule ID 4032 //
     /*  587422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  587433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  587436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  587439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587468 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  587471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587490 */     GIR_RootConstrainSelectedInstOperands,
     /*  587491 */     // GIR_Coverage, 4032,
     /*  587491 */     GIR_EraseRootFromParent_Done,
     /*  587492 */   // Label 9555: @587492
     /*  587492 */   GIM_Try, /*On fail goto*//*Label 9556*/ GIMT_Encode4(587567), // Rule ID 4033 //
     /*  587497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  587508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  587511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  587514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  587546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587565 */     GIR_RootConstrainSelectedInstOperands,
     /*  587566 */     // GIR_Coverage, 4033,
     /*  587566 */     GIR_EraseRootFromParent_Done,
     /*  587567 */   // Label 9556: @587567
     /*  587567 */   GIM_Try, /*On fail goto*//*Label 9557*/ GIMT_Encode4(587642), // Rule ID 4036 //
     /*  587572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  587583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  587586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  587621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587640 */     GIR_RootConstrainSelectedInstOperands,
     /*  587641 */     // GIR_Coverage, 4036,
     /*  587641 */     GIR_EraseRootFromParent_Done,
     /*  587642 */   // Label 9557: @587642
     /*  587642 */   GIM_Try, /*On fail goto*//*Label 9558*/ GIMT_Encode4(587717), // Rule ID 4037 //
     /*  587647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  587658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  587661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587693 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  587696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587715 */     GIR_RootConstrainSelectedInstOperands,
     /*  587716 */     // GIR_Coverage, 4037,
     /*  587716 */     GIR_EraseRootFromParent_Done,
     /*  587717 */   // Label 9558: @587717
     /*  587717 */   GIM_Try, /*On fail goto*//*Label 9559*/ GIMT_Encode4(587792), // Rule ID 4040 //
     /*  587722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  587733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  587736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587768 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  587771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587790 */     GIR_RootConstrainSelectedInstOperands,
     /*  587791 */     // GIR_Coverage, 4040,
     /*  587791 */     GIR_EraseRootFromParent_Done,
     /*  587792 */   // Label 9559: @587792
     /*  587792 */   GIM_Try, /*On fail goto*//*Label 9560*/ GIMT_Encode4(587867), // Rule ID 4041 //
     /*  587797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  587808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  587811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587843 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  587846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587865 */     GIR_RootConstrainSelectedInstOperands,
     /*  587866 */     // GIR_Coverage, 4041,
     /*  587866 */     GIR_EraseRootFromParent_Done,
     /*  587867 */   // Label 9560: @587867
     /*  587867 */   GIM_Try, /*On fail goto*//*Label 9561*/ GIMT_Encode4(587942), // Rule ID 4044 //
     /*  587872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  587875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  587883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  587886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  587889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587918 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  587918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  587921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  587937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587940 */     GIR_RootConstrainSelectedInstOperands,
     /*  587941 */     // GIR_Coverage, 4044,
     /*  587941 */     GIR_EraseRootFromParent_Done,
     /*  587942 */   // Label 9561: @587942
     /*  587942 */   GIM_Try, /*On fail goto*//*Label 9562*/ GIMT_Encode4(588017), // Rule ID 4045 //
     /*  587947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  587950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  587958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  587961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  587964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587993 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  587993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  587996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588015 */     GIR_RootConstrainSelectedInstOperands,
     /*  588016 */     // GIR_Coverage, 4045,
     /*  588016 */     GIR_EraseRootFromParent_Done,
     /*  588017 */   // Label 9562: @588017
     /*  588017 */   GIM_Try, /*On fail goto*//*Label 9563*/ GIMT_Encode4(588092), // Rule ID 4048 //
     /*  588022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  588030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  588033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  588036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  588039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  588071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588090 */     GIR_RootConstrainSelectedInstOperands,
     /*  588091 */     // GIR_Coverage, 4048,
     /*  588091 */     GIR_EraseRootFromParent_Done,
     /*  588092 */   // Label 9563: @588092
     /*  588092 */   GIM_Try, /*On fail goto*//*Label 9564*/ GIMT_Encode4(588167), // Rule ID 4049 //
     /*  588097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  588105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  588108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  588111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  588114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  588146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588165 */     GIR_RootConstrainSelectedInstOperands,
     /*  588166 */     // GIR_Coverage, 4049,
     /*  588166 */     GIR_EraseRootFromParent_Done,
     /*  588167 */   // Label 9564: @588167
     /*  588167 */   GIM_Try, /*On fail goto*//*Label 9565*/ GIMT_Encode4(588242), // Rule ID 4052 //
     /*  588172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  588180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  588183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  588186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  588189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588218 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  588221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588240 */     GIR_RootConstrainSelectedInstOperands,
     /*  588241 */     // GIR_Coverage, 4052,
     /*  588241 */     GIR_EraseRootFromParent_Done,
     /*  588242 */   // Label 9565: @588242
     /*  588242 */   GIM_Try, /*On fail goto*//*Label 9566*/ GIMT_Encode4(588317), // Rule ID 4053 //
     /*  588247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  588255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  588258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  588261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  588264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588293 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  588296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588315 */     GIR_RootConstrainSelectedInstOperands,
     /*  588316 */     // GIR_Coverage, 4053,
     /*  588316 */     GIR_EraseRootFromParent_Done,
     /*  588317 */   // Label 9566: @588317
     /*  588317 */   GIM_Try, /*On fail goto*//*Label 9567*/ GIMT_Encode4(588392), // Rule ID 4056 //
     /*  588322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  588330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  588333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  588336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  588371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588390 */     GIR_RootConstrainSelectedInstOperands,
     /*  588391 */     // GIR_Coverage, 4056,
     /*  588391 */     GIR_EraseRootFromParent_Done,
     /*  588392 */   // Label 9567: @588392
     /*  588392 */   GIM_Try, /*On fail goto*//*Label 9568*/ GIMT_Encode4(588467), // Rule ID 4057 //
     /*  588397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  588405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  588408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  588411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588443 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  588446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588465 */     GIR_RootConstrainSelectedInstOperands,
     /*  588466 */     // GIR_Coverage, 4057,
     /*  588466 */     GIR_EraseRootFromParent_Done,
     /*  588467 */   // Label 9568: @588467
     /*  588467 */   GIM_Try, /*On fail goto*//*Label 9569*/ GIMT_Encode4(588542), // Rule ID 4062 //
     /*  588472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  588483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  588486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  588489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  588492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  588518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  588521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588540 */     GIR_RootConstrainSelectedInstOperands,
     /*  588541 */     // GIR_Coverage, 4062,
     /*  588541 */     GIR_EraseRootFromParent_Done,
     /*  588542 */   // Label 9569: @588542
     /*  588542 */   GIM_Try, /*On fail goto*//*Label 9570*/ GIMT_Encode4(588617), // Rule ID 4063 //
     /*  588547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  588558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  588561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  588564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  588567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588593 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  588593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  588596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588615 */     GIR_RootConstrainSelectedInstOperands,
     /*  588616 */     // GIR_Coverage, 4063,
     /*  588616 */     GIR_EraseRootFromParent_Done,
     /*  588617 */   // Label 9570: @588617
     /*  588617 */   GIM_Try, /*On fail goto*//*Label 9571*/ GIMT_Encode4(588692), // Rule ID 4072 //
     /*  588622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  588633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  588636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  588639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  588642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  588668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  588671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588690 */     GIR_RootConstrainSelectedInstOperands,
     /*  588691 */     // GIR_Coverage, 4072,
     /*  588691 */     GIR_EraseRootFromParent_Done,
     /*  588692 */   // Label 9571: @588692
     /*  588692 */   GIM_Try, /*On fail goto*//*Label 9572*/ GIMT_Encode4(588767), // Rule ID 4073 //
     /*  588697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  588708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  588711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  588714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  588717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588743 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  588743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  588746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588765 */     GIR_RootConstrainSelectedInstOperands,
     /*  588766 */     // GIR_Coverage, 4073,
     /*  588766 */     GIR_EraseRootFromParent_Done,
     /*  588767 */   // Label 9572: @588767
     /*  588767 */   GIM_Try, /*On fail goto*//*Label 9573*/ GIMT_Encode4(588842), // Rule ID 4082 //
     /*  588772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  588783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  588786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  588789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  588792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  588818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  588821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588840 */     GIR_RootConstrainSelectedInstOperands,
     /*  588841 */     // GIR_Coverage, 4082,
     /*  588841 */     GIR_EraseRootFromParent_Done,
     /*  588842 */   // Label 9573: @588842
     /*  588842 */   GIM_Try, /*On fail goto*//*Label 9574*/ GIMT_Encode4(588917), // Rule ID 4083 //
     /*  588847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  588858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  588861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  588864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  588867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  588893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  588896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588915 */     GIR_RootConstrainSelectedInstOperands,
     /*  588916 */     // GIR_Coverage, 4083,
     /*  588916 */     GIR_EraseRootFromParent_Done,
     /*  588917 */   // Label 9574: @588917
     /*  588917 */   GIM_Try, /*On fail goto*//*Label 9575*/ GIMT_Encode4(588992), // Rule ID 4092 //
     /*  588922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  588933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  588936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  588939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  588942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588968 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  588968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  588971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588990 */     GIR_RootConstrainSelectedInstOperands,
     /*  588991 */     // GIR_Coverage, 4092,
     /*  588991 */     GIR_EraseRootFromParent_Done,
     /*  588992 */   // Label 9575: @588992
     /*  588992 */   GIM_Try, /*On fail goto*//*Label 9576*/ GIMT_Encode4(589067), // Rule ID 4093 //
     /*  588997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  589008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  589011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  589014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  589017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589043 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  589046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589065 */     GIR_RootConstrainSelectedInstOperands,
     /*  589066 */     // GIR_Coverage, 4093,
     /*  589066 */     GIR_EraseRootFromParent_Done,
     /*  589067 */   // Label 9576: @589067
     /*  589067 */   GIM_Try, /*On fail goto*//*Label 9577*/ GIMT_Encode4(589142), // Rule ID 4102 //
     /*  589072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  589083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  589086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  589089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  589092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589118 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  589121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589140 */     GIR_RootConstrainSelectedInstOperands,
     /*  589141 */     // GIR_Coverage, 4102,
     /*  589141 */     GIR_EraseRootFromParent_Done,
     /*  589142 */   // Label 9577: @589142
     /*  589142 */   GIM_Try, /*On fail goto*//*Label 9578*/ GIMT_Encode4(589217), // Rule ID 4103 //
     /*  589147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  589158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  589161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  589164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  589167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589193 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  589196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589215 */     GIR_RootConstrainSelectedInstOperands,
     /*  589216 */     // GIR_Coverage, 4103,
     /*  589216 */     GIR_EraseRootFromParent_Done,
     /*  589217 */   // Label 9578: @589217
     /*  589217 */   GIM_Try, /*On fail goto*//*Label 9579*/ GIMT_Encode4(589292), // Rule ID 4112 //
     /*  589222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  589233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  589236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  589239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  589242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  589271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589290 */     GIR_RootConstrainSelectedInstOperands,
     /*  589291 */     // GIR_Coverage, 4112,
     /*  589291 */     GIR_EraseRootFromParent_Done,
     /*  589292 */   // Label 9579: @589292
     /*  589292 */   GIM_Try, /*On fail goto*//*Label 9580*/ GIMT_Encode4(589367), // Rule ID 4113 //
     /*  589297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  589308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  589311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  589314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  589317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589343 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  589346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589365 */     GIR_RootConstrainSelectedInstOperands,
     /*  589366 */     // GIR_Coverage, 4113,
     /*  589366 */     GIR_EraseRootFromParent_Done,
     /*  589367 */   // Label 9580: @589367
     /*  589367 */   GIM_Try, /*On fail goto*//*Label 9581*/ GIMT_Encode4(589442), // Rule ID 4122 //
     /*  589372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  589383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  589386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  589389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  589392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  589421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589440 */     GIR_RootConstrainSelectedInstOperands,
     /*  589441 */     // GIR_Coverage, 4122,
     /*  589441 */     GIR_EraseRootFromParent_Done,
     /*  589442 */   // Label 9581: @589442
     /*  589442 */   GIM_Try, /*On fail goto*//*Label 9582*/ GIMT_Encode4(589517), // Rule ID 4123 //
     /*  589447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  589458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  589461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  589464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  589467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  589496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589515 */     GIR_RootConstrainSelectedInstOperands,
     /*  589516 */     // GIR_Coverage, 4123,
     /*  589516 */     GIR_EraseRootFromParent_Done,
     /*  589517 */   // Label 9582: @589517
     /*  589517 */   GIM_Try, /*On fail goto*//*Label 9583*/ GIMT_Encode4(589592), // Rule ID 4132 //
     /*  589522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  589533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  589536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  589539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  589542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  589571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589590 */     GIR_RootConstrainSelectedInstOperands,
     /*  589591 */     // GIR_Coverage, 4132,
     /*  589591 */     GIR_EraseRootFromParent_Done,
     /*  589592 */   // Label 9583: @589592
     /*  589592 */   GIM_Try, /*On fail goto*//*Label 9584*/ GIMT_Encode4(589667), // Rule ID 4133 //
     /*  589597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  589608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  589611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  589614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  589617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589643 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  589646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589665 */     GIR_RootConstrainSelectedInstOperands,
     /*  589666 */     // GIR_Coverage, 4133,
     /*  589666 */     GIR_EraseRootFromParent_Done,
     /*  589667 */   // Label 9584: @589667
     /*  589667 */   GIM_Try, /*On fail goto*//*Label 9585*/ GIMT_Encode4(589742), // Rule ID 4142 //
     /*  589672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  589683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  589686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  589689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  589692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589718 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  589721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589740 */     GIR_RootConstrainSelectedInstOperands,
     /*  589741 */     // GIR_Coverage, 4142,
     /*  589741 */     GIR_EraseRootFromParent_Done,
     /*  589742 */   // Label 9585: @589742
     /*  589742 */   GIM_Try, /*On fail goto*//*Label 9586*/ GIMT_Encode4(589817), // Rule ID 4143 //
     /*  589747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  589758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  589761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  589764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  589767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589793 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  589796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589815 */     GIR_RootConstrainSelectedInstOperands,
     /*  589816 */     // GIR_Coverage, 4143,
     /*  589816 */     GIR_EraseRootFromParent_Done,
     /*  589817 */   // Label 9586: @589817
     /*  589817 */   GIM_Try, /*On fail goto*//*Label 9587*/ GIMT_Encode4(589892), // Rule ID 4152 //
     /*  589822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  589833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  589836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  589839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  589842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589868 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  589871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589890 */     GIR_RootConstrainSelectedInstOperands,
     /*  589891 */     // GIR_Coverage, 4152,
     /*  589891 */     GIR_EraseRootFromParent_Done,
     /*  589892 */   // Label 9587: @589892
     /*  589892 */   GIM_Try, /*On fail goto*//*Label 9588*/ GIMT_Encode4(589967), // Rule ID 4153 //
     /*  589897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  589908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  589911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  589914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  589917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589943 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  589946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589965 */     GIR_RootConstrainSelectedInstOperands,
     /*  589966 */     // GIR_Coverage, 4153,
     /*  589966 */     GIR_EraseRootFromParent_Done,
     /*  589967 */   // Label 9588: @589967
     /*  589967 */   GIM_Try, /*On fail goto*//*Label 9589*/ GIMT_Encode4(590042), // Rule ID 4162 //
     /*  589972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  589975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  589983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  589986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  589989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  589992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590018 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  590021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590040 */     GIR_RootConstrainSelectedInstOperands,
     /*  590041 */     // GIR_Coverage, 4162,
     /*  590041 */     GIR_EraseRootFromParent_Done,
     /*  590042 */   // Label 9589: @590042
     /*  590042 */   GIM_Try, /*On fail goto*//*Label 9590*/ GIMT_Encode4(590117), // Rule ID 4163 //
     /*  590047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  590058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  590061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  590064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  590067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590093 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  590096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590115 */     GIR_RootConstrainSelectedInstOperands,
     /*  590116 */     // GIR_Coverage, 4163,
     /*  590116 */     GIR_EraseRootFromParent_Done,
     /*  590117 */   // Label 9590: @590117
     /*  590117 */   GIM_Try, /*On fail goto*//*Label 9591*/ GIMT_Encode4(590192), // Rule ID 4172 //
     /*  590122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  590133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  590136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  590139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  590142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  590171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590190 */     GIR_RootConstrainSelectedInstOperands,
     /*  590191 */     // GIR_Coverage, 4172,
     /*  590191 */     GIR_EraseRootFromParent_Done,
     /*  590192 */   // Label 9591: @590192
     /*  590192 */   GIM_Try, /*On fail goto*//*Label 9592*/ GIMT_Encode4(590267), // Rule ID 4173 //
     /*  590197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  590208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  590211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  590214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  590217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  590246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590265 */     GIR_RootConstrainSelectedInstOperands,
     /*  590266 */     // GIR_Coverage, 4173,
     /*  590266 */     GIR_EraseRootFromParent_Done,
     /*  590267 */   // Label 9592: @590267
     /*  590267 */   GIM_Try, /*On fail goto*//*Label 9593*/ GIMT_Encode4(590342), // Rule ID 4182 //
     /*  590272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  590283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  590286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  590289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  590292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590318 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  590321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590340 */     GIR_RootConstrainSelectedInstOperands,
     /*  590341 */     // GIR_Coverage, 4182,
     /*  590341 */     GIR_EraseRootFromParent_Done,
     /*  590342 */   // Label 9593: @590342
     /*  590342 */   GIM_Try, /*On fail goto*//*Label 9594*/ GIMT_Encode4(590417), // Rule ID 4183 //
     /*  590347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  590358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  590361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  590364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  590367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590393 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  590396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590415 */     GIR_RootConstrainSelectedInstOperands,
     /*  590416 */     // GIR_Coverage, 4183,
     /*  590416 */     GIR_EraseRootFromParent_Done,
     /*  590417 */   // Label 9594: @590417
     /*  590417 */   GIM_Try, /*On fail goto*//*Label 9595*/ GIMT_Encode4(590492), // Rule ID 4192 //
     /*  590422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  590433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  590436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  590439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  590442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  590471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590490 */     GIR_RootConstrainSelectedInstOperands,
     /*  590491 */     // GIR_Coverage, 4192,
     /*  590491 */     GIR_EraseRootFromParent_Done,
     /*  590492 */   // Label 9595: @590492
     /*  590492 */   GIM_Try, /*On fail goto*//*Label 9596*/ GIMT_Encode4(590567), // Rule ID 4193 //
     /*  590497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  590508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  590511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  590514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  590517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590543 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  590546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590565 */     GIR_RootConstrainSelectedInstOperands,
     /*  590566 */     // GIR_Coverage, 4193,
     /*  590566 */     GIR_EraseRootFromParent_Done,
     /*  590567 */   // Label 9596: @590567
     /*  590567 */   GIM_Try, /*On fail goto*//*Label 9597*/ GIMT_Encode4(590642), // Rule ID 4200 //
     /*  590572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  590583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  590586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  590589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  590592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590618 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  590621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590640 */     GIR_RootConstrainSelectedInstOperands,
     /*  590641 */     // GIR_Coverage, 4200,
     /*  590641 */     GIR_EraseRootFromParent_Done,
     /*  590642 */   // Label 9597: @590642
     /*  590642 */   GIM_Try, /*On fail goto*//*Label 9598*/ GIMT_Encode4(590717), // Rule ID 4201 //
     /*  590647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  590658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  590661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  590664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  590667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590693 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  590696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590715 */     GIR_RootConstrainSelectedInstOperands,
     /*  590716 */     // GIR_Coverage, 4201,
     /*  590716 */     GIR_EraseRootFromParent_Done,
     /*  590717 */   // Label 9598: @590717
     /*  590717 */   GIM_Try, /*On fail goto*//*Label 9599*/ GIMT_Encode4(590792), // Rule ID 4204 //
     /*  590722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  590733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  590736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  590739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  590742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  590771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590790 */     GIR_RootConstrainSelectedInstOperands,
     /*  590791 */     // GIR_Coverage, 4204,
     /*  590791 */     GIR_EraseRootFromParent_Done,
     /*  590792 */   // Label 9599: @590792
     /*  590792 */   GIM_Try, /*On fail goto*//*Label 9600*/ GIMT_Encode4(590867), // Rule ID 4205 //
     /*  590797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  590808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  590811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  590814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  590817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590843 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  590846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590865 */     GIR_RootConstrainSelectedInstOperands,
     /*  590866 */     // GIR_Coverage, 4205,
     /*  590866 */     GIR_EraseRootFromParent_Done,
     /*  590867 */   // Label 9600: @590867
     /*  590867 */   GIM_Try, /*On fail goto*//*Label 9601*/ GIMT_Encode4(590942), // Rule ID 4208 //
     /*  590872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  590883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  590886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  590889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  590892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  590921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590940 */     GIR_RootConstrainSelectedInstOperands,
     /*  590941 */     // GIR_Coverage, 4208,
     /*  590941 */     GIR_EraseRootFromParent_Done,
     /*  590942 */   // Label 9601: @590942
     /*  590942 */   GIM_Try, /*On fail goto*//*Label 9602*/ GIMT_Encode4(591017), // Rule ID 4209 //
     /*  590947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  590958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  590961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  590964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  590967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590993 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  590996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591015 */     GIR_RootConstrainSelectedInstOperands,
     /*  591016 */     // GIR_Coverage, 4209,
     /*  591016 */     GIR_EraseRootFromParent_Done,
     /*  591017 */   // Label 9602: @591017
     /*  591017 */   GIM_Try, /*On fail goto*//*Label 9603*/ GIMT_Encode4(591092), // Rule ID 4212 //
     /*  591022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  591033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  591036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  591039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  591071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591090 */     GIR_RootConstrainSelectedInstOperands,
     /*  591091 */     // GIR_Coverage, 4212,
     /*  591091 */     GIR_EraseRootFromParent_Done,
     /*  591092 */   // Label 9603: @591092
     /*  591092 */   GIM_Try, /*On fail goto*//*Label 9604*/ GIMT_Encode4(591167), // Rule ID 4213 //
     /*  591097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  591108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  591111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  591114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  591146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591165 */     GIR_RootConstrainSelectedInstOperands,
     /*  591166 */     // GIR_Coverage, 4213,
     /*  591166 */     GIR_EraseRootFromParent_Done,
     /*  591167 */   // Label 9604: @591167
     /*  591167 */   GIM_Try, /*On fail goto*//*Label 9605*/ GIMT_Encode4(591242), // Rule ID 4216 //
     /*  591172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  591183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  591186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  591189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  591221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591240 */     GIR_RootConstrainSelectedInstOperands,
     /*  591241 */     // GIR_Coverage, 4216,
     /*  591241 */     GIR_EraseRootFromParent_Done,
     /*  591242 */   // Label 9605: @591242
     /*  591242 */   GIM_Try, /*On fail goto*//*Label 9606*/ GIMT_Encode4(591317), // Rule ID 4217 //
     /*  591247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  591258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  591261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  591264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591293 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  591296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591315 */     GIR_RootConstrainSelectedInstOperands,
     /*  591316 */     // GIR_Coverage, 4217,
     /*  591316 */     GIR_EraseRootFromParent_Done,
     /*  591317 */   // Label 9606: @591317
     /*  591317 */   GIM_Try, /*On fail goto*//*Label 9607*/ GIMT_Encode4(591392), // Rule ID 4220 //
     /*  591322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  591333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  591336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  591339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591368 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  591371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591390 */     GIR_RootConstrainSelectedInstOperands,
     /*  591391 */     // GIR_Coverage, 4220,
     /*  591391 */     GIR_EraseRootFromParent_Done,
     /*  591392 */   // Label 9607: @591392
     /*  591392 */   GIM_Try, /*On fail goto*//*Label 9608*/ GIMT_Encode4(591467), // Rule ID 4221 //
     /*  591397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  591408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  591411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  591414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591443 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  591446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591465 */     GIR_RootConstrainSelectedInstOperands,
     /*  591466 */     // GIR_Coverage, 4221,
     /*  591466 */     GIR_EraseRootFromParent_Done,
     /*  591467 */   // Label 9608: @591467
     /*  591467 */   GIM_Try, /*On fail goto*//*Label 9609*/ GIMT_Encode4(591542), // Rule ID 4224 //
     /*  591472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  591483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  591486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  591489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591518 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  591521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591540 */     GIR_RootConstrainSelectedInstOperands,
     /*  591541 */     // GIR_Coverage, 4224,
     /*  591541 */     GIR_EraseRootFromParent_Done,
     /*  591542 */   // Label 9609: @591542
     /*  591542 */   GIM_Try, /*On fail goto*//*Label 9610*/ GIMT_Encode4(591617), // Rule ID 4225 //
     /*  591547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  591558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  591561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  591564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591593 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  591593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  591596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591615 */     GIR_RootConstrainSelectedInstOperands,
     /*  591616 */     // GIR_Coverage, 4225,
     /*  591616 */     GIR_EraseRootFromParent_Done,
     /*  591617 */   // Label 9610: @591617
     /*  591617 */   GIM_Try, /*On fail goto*//*Label 9611*/ GIMT_Encode4(591692), // Rule ID 4228 //
     /*  591622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  591633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  591636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  591639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591668 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  591671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591690 */     GIR_RootConstrainSelectedInstOperands,
     /*  591691 */     // GIR_Coverage, 4228,
     /*  591691 */     GIR_EraseRootFromParent_Done,
     /*  591692 */   // Label 9611: @591692
     /*  591692 */   GIM_Try, /*On fail goto*//*Label 9612*/ GIMT_Encode4(591767), // Rule ID 4229 //
     /*  591697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  591708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  591711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  591714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591743 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  591743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  591746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591765 */     GIR_RootConstrainSelectedInstOperands,
     /*  591766 */     // GIR_Coverage, 4229,
     /*  591766 */     GIR_EraseRootFromParent_Done,
     /*  591767 */   // Label 9612: @591767
     /*  591767 */   GIM_Try, /*On fail goto*//*Label 9613*/ GIMT_Encode4(591842), // Rule ID 4232 //
     /*  591772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  591783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  591786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  591789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  591821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591840 */     GIR_RootConstrainSelectedInstOperands,
     /*  591841 */     // GIR_Coverage, 4232,
     /*  591841 */     GIR_EraseRootFromParent_Done,
     /*  591842 */   // Label 9613: @591842
     /*  591842 */   GIM_Try, /*On fail goto*//*Label 9614*/ GIMT_Encode4(591917), // Rule ID 4233 //
     /*  591847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  591858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  591861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  591864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  591893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  591896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591915 */     GIR_RootConstrainSelectedInstOperands,
     /*  591916 */     // GIR_Coverage, 4233,
     /*  591916 */     GIR_EraseRootFromParent_Done,
     /*  591917 */   // Label 9614: @591917
     /*  591917 */   GIM_Try, /*On fail goto*//*Label 9615*/ GIMT_Encode4(591992), // Rule ID 4236 //
     /*  591922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  591933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  591936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  591939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  591971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591990 */     GIR_RootConstrainSelectedInstOperands,
     /*  591991 */     // GIR_Coverage, 4236,
     /*  591991 */     GIR_EraseRootFromParent_Done,
     /*  591992 */   // Label 9615: @591992
     /*  591992 */   GIM_Try, /*On fail goto*//*Label 9616*/ GIMT_Encode4(592067), // Rule ID 4237 //
     /*  591997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  592008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  592011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  592014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  592046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592065 */     GIR_RootConstrainSelectedInstOperands,
     /*  592066 */     // GIR_Coverage, 4237,
     /*  592066 */     GIR_EraseRootFromParent_Done,
     /*  592067 */   // Label 9616: @592067
     /*  592067 */   GIM_Try, /*On fail goto*//*Label 9617*/ GIMT_Encode4(592142), // Rule ID 4240 //
     /*  592072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  592083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  592086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  592089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  592121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592140 */     GIR_RootConstrainSelectedInstOperands,
     /*  592141 */     // GIR_Coverage, 4240,
     /*  592141 */     GIR_EraseRootFromParent_Done,
     /*  592142 */   // Label 9617: @592142
     /*  592142 */   GIM_Try, /*On fail goto*//*Label 9618*/ GIMT_Encode4(592217), // Rule ID 4241 //
     /*  592147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  592158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  592161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  592164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592193 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  592196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592215 */     GIR_RootConstrainSelectedInstOperands,
     /*  592216 */     // GIR_Coverage, 4241,
     /*  592216 */     GIR_EraseRootFromParent_Done,
     /*  592217 */   // Label 9618: @592217
     /*  592217 */   GIM_Try, /*On fail goto*//*Label 9619*/ GIMT_Encode4(592292), // Rule ID 4244 //
     /*  592222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  592233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  592236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  592239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  592271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592290 */     GIR_RootConstrainSelectedInstOperands,
     /*  592291 */     // GIR_Coverage, 4244,
     /*  592291 */     GIR_EraseRootFromParent_Done,
     /*  592292 */   // Label 9619: @592292
     /*  592292 */   GIM_Try, /*On fail goto*//*Label 9620*/ GIMT_Encode4(592367), // Rule ID 4245 //
     /*  592297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  592308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  592311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  592314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592343 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  592343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  592346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592365 */     GIR_RootConstrainSelectedInstOperands,
     /*  592366 */     // GIR_Coverage, 4245,
     /*  592366 */     GIR_EraseRootFromParent_Done,
     /*  592367 */   // Label 9620: @592367
     /*  592367 */   GIM_Try, /*On fail goto*//*Label 9621*/ GIMT_Encode4(592442), // Rule ID 4248 //
     /*  592372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  592383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  592386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  592389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592418 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  592421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592440 */     GIR_RootConstrainSelectedInstOperands,
     /*  592441 */     // GIR_Coverage, 4248,
     /*  592441 */     GIR_EraseRootFromParent_Done,
     /*  592442 */   // Label 9621: @592442
     /*  592442 */   GIM_Try, /*On fail goto*//*Label 9622*/ GIMT_Encode4(592517), // Rule ID 4249 //
     /*  592447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  592458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  592461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  592464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592493 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  592493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  592496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592515 */     GIR_RootConstrainSelectedInstOperands,
     /*  592516 */     // GIR_Coverage, 4249,
     /*  592516 */     GIR_EraseRootFromParent_Done,
     /*  592517 */   // Label 9622: @592517
     /*  592517 */   GIM_Try, /*On fail goto*//*Label 9623*/ GIMT_Encode4(592592), // Rule ID 4252 //
     /*  592522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  592533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  592536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  592539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592568 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  592571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592590 */     GIR_RootConstrainSelectedInstOperands,
     /*  592591 */     // GIR_Coverage, 4252,
     /*  592591 */     GIR_EraseRootFromParent_Done,
     /*  592592 */   // Label 9623: @592592
     /*  592592 */   GIM_Try, /*On fail goto*//*Label 9624*/ GIMT_Encode4(592667), // Rule ID 4253 //
     /*  592597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  592608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  592611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  592614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592643 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  592643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  592646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592665 */     GIR_RootConstrainSelectedInstOperands,
     /*  592666 */     // GIR_Coverage, 4253,
     /*  592666 */     GIR_EraseRootFromParent_Done,
     /*  592667 */   // Label 9624: @592667
     /*  592667 */   GIM_Try, /*On fail goto*//*Label 9625*/ GIMT_Encode4(592742), // Rule ID 4256 //
     /*  592672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  592683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  592686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  592689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  592721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592740 */     GIR_RootConstrainSelectedInstOperands,
     /*  592741 */     // GIR_Coverage, 4256,
     /*  592741 */     GIR_EraseRootFromParent_Done,
     /*  592742 */   // Label 9625: @592742
     /*  592742 */   GIM_Try, /*On fail goto*//*Label 9626*/ GIMT_Encode4(592817), // Rule ID 4257 //
     /*  592747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  592758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  592761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  592764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592793 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  592793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  592796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592815 */     GIR_RootConstrainSelectedInstOperands,
     /*  592816 */     // GIR_Coverage, 4257,
     /*  592816 */     GIR_EraseRootFromParent_Done,
     /*  592817 */   // Label 9626: @592817
     /*  592817 */   GIM_Try, /*On fail goto*//*Label 9627*/ GIMT_Encode4(592892), // Rule ID 4262 //
     /*  592822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  592833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  592836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  592839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  592842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  592871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592890 */     GIR_RootConstrainSelectedInstOperands,
     /*  592891 */     // GIR_Coverage, 4262,
     /*  592891 */     GIR_EraseRootFromParent_Done,
     /*  592892 */   // Label 9627: @592892
     /*  592892 */   GIM_Try, /*On fail goto*//*Label 9628*/ GIMT_Encode4(592967), // Rule ID 4263 //
     /*  592897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  592908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  592911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  592914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  592917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592943 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  592946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592965 */     GIR_RootConstrainSelectedInstOperands,
     /*  592966 */     // GIR_Coverage, 4263,
     /*  592966 */     GIR_EraseRootFromParent_Done,
     /*  592967 */   // Label 9628: @592967
     /*  592967 */   GIM_Try, /*On fail goto*//*Label 9629*/ GIMT_Encode4(593042), // Rule ID 4272 //
     /*  592972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  592983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  592986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  592989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  592992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593018 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  593021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593040 */     GIR_RootConstrainSelectedInstOperands,
     /*  593041 */     // GIR_Coverage, 4272,
     /*  593041 */     GIR_EraseRootFromParent_Done,
     /*  593042 */   // Label 9629: @593042
     /*  593042 */   GIM_Try, /*On fail goto*//*Label 9630*/ GIMT_Encode4(593117), // Rule ID 4273 //
     /*  593047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  593058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  593061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  593064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  593067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593093 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  593096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593115 */     GIR_RootConstrainSelectedInstOperands,
     /*  593116 */     // GIR_Coverage, 4273,
     /*  593116 */     GIR_EraseRootFromParent_Done,
     /*  593117 */   // Label 9630: @593117
     /*  593117 */   GIM_Try, /*On fail goto*//*Label 9631*/ GIMT_Encode4(593192), // Rule ID 4282 //
     /*  593122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  593133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  593136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  593139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  593142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  593171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593190 */     GIR_RootConstrainSelectedInstOperands,
     /*  593191 */     // GIR_Coverage, 4282,
     /*  593191 */     GIR_EraseRootFromParent_Done,
     /*  593192 */   // Label 9631: @593192
     /*  593192 */   GIM_Try, /*On fail goto*//*Label 9632*/ GIMT_Encode4(593267), // Rule ID 4283 //
     /*  593197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  593208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  593211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  593214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  593217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593243 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  593246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593265 */     GIR_RootConstrainSelectedInstOperands,
     /*  593266 */     // GIR_Coverage, 4283,
     /*  593266 */     GIR_EraseRootFromParent_Done,
     /*  593267 */   // Label 9632: @593267
     /*  593267 */   GIM_Try, /*On fail goto*//*Label 9633*/ GIMT_Encode4(593342), // Rule ID 4292 //
     /*  593272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  593283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  593286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  593289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  593292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  593321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593340 */     GIR_RootConstrainSelectedInstOperands,
     /*  593341 */     // GIR_Coverage, 4292,
     /*  593341 */     GIR_EraseRootFromParent_Done,
     /*  593342 */   // Label 9633: @593342
     /*  593342 */   GIM_Try, /*On fail goto*//*Label 9634*/ GIMT_Encode4(593417), // Rule ID 4293 //
     /*  593347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  593358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  593361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  593364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  593367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593393 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  593396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593415 */     GIR_RootConstrainSelectedInstOperands,
     /*  593416 */     // GIR_Coverage, 4293,
     /*  593416 */     GIR_EraseRootFromParent_Done,
     /*  593417 */   // Label 9634: @593417
     /*  593417 */   GIM_Try, /*On fail goto*//*Label 9635*/ GIMT_Encode4(593492), // Rule ID 4302 //
     /*  593422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  593433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  593436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  593439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  593442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593468 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  593471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593490 */     GIR_RootConstrainSelectedInstOperands,
     /*  593491 */     // GIR_Coverage, 4302,
     /*  593491 */     GIR_EraseRootFromParent_Done,
     /*  593492 */   // Label 9635: @593492
     /*  593492 */   GIM_Try, /*On fail goto*//*Label 9636*/ GIMT_Encode4(593567), // Rule ID 4303 //
     /*  593497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  593508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  593511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  593514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  593517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593543 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  593546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593565 */     GIR_RootConstrainSelectedInstOperands,
     /*  593566 */     // GIR_Coverage, 4303,
     /*  593566 */     GIR_EraseRootFromParent_Done,
     /*  593567 */   // Label 9636: @593567
     /*  593567 */   GIM_Try, /*On fail goto*//*Label 9637*/ GIMT_Encode4(593642), // Rule ID 4312 //
     /*  593572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  593583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  593586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  593589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  593592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593618 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  593621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593640 */     GIR_RootConstrainSelectedInstOperands,
     /*  593641 */     // GIR_Coverage, 4312,
     /*  593641 */     GIR_EraseRootFromParent_Done,
     /*  593642 */   // Label 9637: @593642
     /*  593642 */   GIM_Try, /*On fail goto*//*Label 9638*/ GIMT_Encode4(593717), // Rule ID 4313 //
     /*  593647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  593658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  593661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  593664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  593667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593693 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  593696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593715 */     GIR_RootConstrainSelectedInstOperands,
     /*  593716 */     // GIR_Coverage, 4313,
     /*  593716 */     GIR_EraseRootFromParent_Done,
     /*  593717 */   // Label 9638: @593717
     /*  593717 */   GIM_Try, /*On fail goto*//*Label 9639*/ GIMT_Encode4(593792), // Rule ID 4322 //
     /*  593722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  593733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  593736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  593739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  593742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  593768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  593771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593790 */     GIR_RootConstrainSelectedInstOperands,
     /*  593791 */     // GIR_Coverage, 4322,
     /*  593791 */     GIR_EraseRootFromParent_Done,
     /*  593792 */   // Label 9639: @593792
     /*  593792 */   GIM_Try, /*On fail goto*//*Label 9640*/ GIMT_Encode4(593867), // Rule ID 4323 //
     /*  593797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  593808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  593811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  593814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  593817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593843 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  593843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  593846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593865 */     GIR_RootConstrainSelectedInstOperands,
     /*  593866 */     // GIR_Coverage, 4323,
     /*  593866 */     GIR_EraseRootFromParent_Done,
     /*  593867 */   // Label 9640: @593867
     /*  593867 */   GIM_Try, /*On fail goto*//*Label 9641*/ GIMT_Encode4(593942), // Rule ID 4332 //
     /*  593872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  593883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  593886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  593889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  593892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  593918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  593921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593940 */     GIR_RootConstrainSelectedInstOperands,
     /*  593941 */     // GIR_Coverage, 4332,
     /*  593941 */     GIR_EraseRootFromParent_Done,
     /*  593942 */   // Label 9641: @593942
     /*  593942 */   GIM_Try, /*On fail goto*//*Label 9642*/ GIMT_Encode4(594017), // Rule ID 4333 //
     /*  593947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  593958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  593961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  593964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  593967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593993 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  593993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  593996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594015 */     GIR_RootConstrainSelectedInstOperands,
     /*  594016 */     // GIR_Coverage, 4333,
     /*  594016 */     GIR_EraseRootFromParent_Done,
     /*  594017 */   // Label 9642: @594017
     /*  594017 */   GIM_Try, /*On fail goto*//*Label 9643*/ GIMT_Encode4(594092), // Rule ID 4342 //
     /*  594022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  594033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  594036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  594039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  594042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  594071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594090 */     GIR_RootConstrainSelectedInstOperands,
     /*  594091 */     // GIR_Coverage, 4342,
     /*  594091 */     GIR_EraseRootFromParent_Done,
     /*  594092 */   // Label 9643: @594092
     /*  594092 */   GIM_Try, /*On fail goto*//*Label 9644*/ GIMT_Encode4(594167), // Rule ID 4343 //
     /*  594097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  594108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  594111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  594114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  594117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  594146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594165 */     GIR_RootConstrainSelectedInstOperands,
     /*  594166 */     // GIR_Coverage, 4343,
     /*  594166 */     GIR_EraseRootFromParent_Done,
     /*  594167 */   // Label 9644: @594167
     /*  594167 */   GIM_Try, /*On fail goto*//*Label 9645*/ GIMT_Encode4(594242), // Rule ID 4352 //
     /*  594172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  594183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  594186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  594189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  594192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  594221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594240 */     GIR_RootConstrainSelectedInstOperands,
     /*  594241 */     // GIR_Coverage, 4352,
     /*  594241 */     GIR_EraseRootFromParent_Done,
     /*  594242 */   // Label 9645: @594242
     /*  594242 */   GIM_Try, /*On fail goto*//*Label 9646*/ GIMT_Encode4(594317), // Rule ID 4353 //
     /*  594247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  594258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  594261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  594264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  594267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594293 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  594296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594315 */     GIR_RootConstrainSelectedInstOperands,
     /*  594316 */     // GIR_Coverage, 4353,
     /*  594316 */     GIR_EraseRootFromParent_Done,
     /*  594317 */   // Label 9646: @594317
     /*  594317 */   GIM_Try, /*On fail goto*//*Label 9647*/ GIMT_Encode4(594392), // Rule ID 4362 //
     /*  594322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  594333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  594336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  594339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  594342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  594371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594390 */     GIR_RootConstrainSelectedInstOperands,
     /*  594391 */     // GIR_Coverage, 4362,
     /*  594391 */     GIR_EraseRootFromParent_Done,
     /*  594392 */   // Label 9647: @594392
     /*  594392 */   GIM_Try, /*On fail goto*//*Label 9648*/ GIMT_Encode4(594467), // Rule ID 4363 //
     /*  594397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  594408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  594411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  594414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  594417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594443 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  594446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594465 */     GIR_RootConstrainSelectedInstOperands,
     /*  594466 */     // GIR_Coverage, 4363,
     /*  594466 */     GIR_EraseRootFromParent_Done,
     /*  594467 */   // Label 9648: @594467
     /*  594467 */   GIM_Try, /*On fail goto*//*Label 9649*/ GIMT_Encode4(594542), // Rule ID 4372 //
     /*  594472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  594475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  594483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  594486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  594489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  594492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  594518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  594521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594540 */     GIR_RootConstrainSelectedInstOperands,
     /*  594541 */     // GIR_Coverage, 4372,
     /*  594541 */     GIR_EraseRootFromParent_Done,
     /*  594542 */   // Label 9649: @594542
     /*  594542 */   GIM_Try, /*On fail goto*//*Label 9650*/ GIMT_Encode4(594617), // Rule ID 4373 //
     /*  594547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  594550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  594558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  594561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  594564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  594567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594593 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  594593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  594596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594615 */     GIR_RootConstrainSelectedInstOperands,
     /*  594616 */     // GIR_Coverage, 4373,
     /*  594616 */     GIR_EraseRootFromParent_Done,
     /*  594617 */   // Label 9650: @594617
     /*  594617 */   GIM_Try, /*On fail goto*//*Label 9651*/ GIMT_Encode4(594692), // Rule ID 4382 //
     /*  594622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  594625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  594633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  594636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  594639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  594642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  594668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  594671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594690 */     GIR_RootConstrainSelectedInstOperands,
     /*  594691 */     // GIR_Coverage, 4382,
     /*  594691 */     GIR_EraseRootFromParent_Done,
     /*  594692 */   // Label 9651: @594692
     /*  594692 */   GIM_Try, /*On fail goto*//*Label 9652*/ GIMT_Encode4(594767), // Rule ID 4383 //
     /*  594697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  594700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  594708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  594711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  594714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  594717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  594743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  594746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594765 */     GIR_RootConstrainSelectedInstOperands,
     /*  594766 */     // GIR_Coverage, 4383,
     /*  594766 */     GIR_EraseRootFromParent_Done,
     /*  594767 */   // Label 9652: @594767
     /*  594767 */   GIM_Try, /*On fail goto*//*Label 9653*/ GIMT_Encode4(594842), // Rule ID 4392 //
     /*  594772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  594775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  594783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  594786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  594789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  594792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594818 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  594818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  594821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594840 */     GIR_RootConstrainSelectedInstOperands,
     /*  594841 */     // GIR_Coverage, 4392,
     /*  594841 */     GIR_EraseRootFromParent_Done,
     /*  594842 */   // Label 9653: @594842
     /*  594842 */   GIM_Try, /*On fail goto*//*Label 9654*/ GIMT_Encode4(594917), // Rule ID 4393 //
     /*  594847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  594850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  594858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  594861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  594864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  594867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594893 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  594893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  594896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594915 */     GIR_RootConstrainSelectedInstOperands,
     /*  594916 */     // GIR_Coverage, 4393,
     /*  594916 */     GIR_EraseRootFromParent_Done,
     /*  594917 */   // Label 9654: @594917
     /*  594917 */   GIM_Try, /*On fail goto*//*Label 9655*/ GIMT_Encode4(594992), // Rule ID 4402 //
     /*  594922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  594925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  594933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  594936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  594939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  594942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  594968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  594971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594990 */     GIR_RootConstrainSelectedInstOperands,
     /*  594991 */     // GIR_Coverage, 4402,
     /*  594991 */     GIR_EraseRootFromParent_Done,
     /*  594992 */   // Label 9655: @594992
     /*  594992 */   GIM_Try, /*On fail goto*//*Label 9656*/ GIMT_Encode4(595067), // Rule ID 4403 //
     /*  594997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  595008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  595011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  595014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  595017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  595046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595065 */     GIR_RootConstrainSelectedInstOperands,
     /*  595066 */     // GIR_Coverage, 4403,
     /*  595066 */     GIR_EraseRootFromParent_Done,
     /*  595067 */   // Label 9656: @595067
     /*  595067 */   GIM_Try, /*On fail goto*//*Label 9657*/ GIMT_Encode4(595142), // Rule ID 4410 //
     /*  595072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  595083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  595086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  595089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595118 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  595121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595140 */     GIR_RootConstrainSelectedInstOperands,
     /*  595141 */     // GIR_Coverage, 4410,
     /*  595141 */     GIR_EraseRootFromParent_Done,
     /*  595142 */   // Label 9657: @595142
     /*  595142 */   GIM_Try, /*On fail goto*//*Label 9658*/ GIMT_Encode4(595217), // Rule ID 4411 //
     /*  595147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  595158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  595161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  595164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595193 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  595196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595215 */     GIR_RootConstrainSelectedInstOperands,
     /*  595216 */     // GIR_Coverage, 4411,
     /*  595216 */     GIR_EraseRootFromParent_Done,
     /*  595217 */   // Label 9658: @595217
     /*  595217 */   GIM_Try, /*On fail goto*//*Label 9659*/ GIMT_Encode4(595292), // Rule ID 4414 //
     /*  595222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  595233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  595236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  595239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595268 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  595271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595290 */     GIR_RootConstrainSelectedInstOperands,
     /*  595291 */     // GIR_Coverage, 4414,
     /*  595291 */     GIR_EraseRootFromParent_Done,
     /*  595292 */   // Label 9659: @595292
     /*  595292 */   GIM_Try, /*On fail goto*//*Label 9660*/ GIMT_Encode4(595367), // Rule ID 4415 //
     /*  595297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  595308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  595311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  595314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595343 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  595346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595365 */     GIR_RootConstrainSelectedInstOperands,
     /*  595366 */     // GIR_Coverage, 4415,
     /*  595366 */     GIR_EraseRootFromParent_Done,
     /*  595367 */   // Label 9660: @595367
     /*  595367 */   GIM_Try, /*On fail goto*//*Label 9661*/ GIMT_Encode4(595442), // Rule ID 4418 //
     /*  595372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  595383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  595386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  595389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595418 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  595421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595440 */     GIR_RootConstrainSelectedInstOperands,
     /*  595441 */     // GIR_Coverage, 4418,
     /*  595441 */     GIR_EraseRootFromParent_Done,
     /*  595442 */   // Label 9661: @595442
     /*  595442 */   GIM_Try, /*On fail goto*//*Label 9662*/ GIMT_Encode4(595517), // Rule ID 4419 //
     /*  595447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  595458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  595461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  595464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595493 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  595496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595515 */     GIR_RootConstrainSelectedInstOperands,
     /*  595516 */     // GIR_Coverage, 4419,
     /*  595516 */     GIR_EraseRootFromParent_Done,
     /*  595517 */   // Label 9662: @595517
     /*  595517 */   GIM_Try, /*On fail goto*//*Label 9663*/ GIMT_Encode4(595592), // Rule ID 4422 //
     /*  595522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  595533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  595536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  595539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  595571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595590 */     GIR_RootConstrainSelectedInstOperands,
     /*  595591 */     // GIR_Coverage, 4422,
     /*  595591 */     GIR_EraseRootFromParent_Done,
     /*  595592 */   // Label 9663: @595592
     /*  595592 */   GIM_Try, /*On fail goto*//*Label 9664*/ GIMT_Encode4(595667), // Rule ID 4423 //
     /*  595597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  595608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  595611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  595614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595643 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  595646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595665 */     GIR_RootConstrainSelectedInstOperands,
     /*  595666 */     // GIR_Coverage, 4423,
     /*  595666 */     GIR_EraseRootFromParent_Done,
     /*  595667 */   // Label 9664: @595667
     /*  595667 */   GIM_Try, /*On fail goto*//*Label 9665*/ GIMT_Encode4(595742), // Rule ID 4426 //
     /*  595672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  595683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  595686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  595689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595718 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  595721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595740 */     GIR_RootConstrainSelectedInstOperands,
     /*  595741 */     // GIR_Coverage, 4426,
     /*  595741 */     GIR_EraseRootFromParent_Done,
     /*  595742 */   // Label 9665: @595742
     /*  595742 */   GIM_Try, /*On fail goto*//*Label 9666*/ GIMT_Encode4(595817), // Rule ID 4427 //
     /*  595747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  595758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  595761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  595764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595793 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  595796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595815 */     GIR_RootConstrainSelectedInstOperands,
     /*  595816 */     // GIR_Coverage, 4427,
     /*  595816 */     GIR_EraseRootFromParent_Done,
     /*  595817 */   // Label 9666: @595817
     /*  595817 */   GIM_Try, /*On fail goto*//*Label 9667*/ GIMT_Encode4(595892), // Rule ID 4430 //
     /*  595822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  595833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  595836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  595839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595868 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  595871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595890 */     GIR_RootConstrainSelectedInstOperands,
     /*  595891 */     // GIR_Coverage, 4430,
     /*  595891 */     GIR_EraseRootFromParent_Done,
     /*  595892 */   // Label 9667: @595892
     /*  595892 */   GIM_Try, /*On fail goto*//*Label 9668*/ GIMT_Encode4(595967), // Rule ID 4431 //
     /*  595897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  595908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  595911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  595914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595943 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  595946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595965 */     GIR_RootConstrainSelectedInstOperands,
     /*  595966 */     // GIR_Coverage, 4431,
     /*  595966 */     GIR_EraseRootFromParent_Done,
     /*  595967 */   // Label 9668: @595967
     /*  595967 */   GIM_Try, /*On fail goto*//*Label 9669*/ GIMT_Encode4(596042), // Rule ID 4434 //
     /*  595972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  595983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  595986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  595989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  596021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596040 */     GIR_RootConstrainSelectedInstOperands,
     /*  596041 */     // GIR_Coverage, 4434,
     /*  596041 */     GIR_EraseRootFromParent_Done,
     /*  596042 */   // Label 9669: @596042
     /*  596042 */   GIM_Try, /*On fail goto*//*Label 9670*/ GIMT_Encode4(596117), // Rule ID 4435 //
     /*  596047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  596058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  596061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  596064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596093 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  596096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596115 */     GIR_RootConstrainSelectedInstOperands,
     /*  596116 */     // GIR_Coverage, 4435,
     /*  596116 */     GIR_EraseRootFromParent_Done,
     /*  596117 */   // Label 9670: @596117
     /*  596117 */   GIM_Try, /*On fail goto*//*Label 9671*/ GIMT_Encode4(596192), // Rule ID 4438 //
     /*  596122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  596133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  596136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  596139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596168 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  596171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596190 */     GIR_RootConstrainSelectedInstOperands,
     /*  596191 */     // GIR_Coverage, 4438,
     /*  596191 */     GIR_EraseRootFromParent_Done,
     /*  596192 */   // Label 9671: @596192
     /*  596192 */   GIM_Try, /*On fail goto*//*Label 9672*/ GIMT_Encode4(596267), // Rule ID 4439 //
     /*  596197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  596208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  596211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  596214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596243 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  596246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596265 */     GIR_RootConstrainSelectedInstOperands,
     /*  596266 */     // GIR_Coverage, 4439,
     /*  596266 */     GIR_EraseRootFromParent_Done,
     /*  596267 */   // Label 9672: @596267
     /*  596267 */   GIM_Try, /*On fail goto*//*Label 9673*/ GIMT_Encode4(596342), // Rule ID 4442 //
     /*  596272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  596283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  596286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  596289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  596321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596340 */     GIR_RootConstrainSelectedInstOperands,
     /*  596341 */     // GIR_Coverage, 4442,
     /*  596341 */     GIR_EraseRootFromParent_Done,
     /*  596342 */   // Label 9673: @596342
     /*  596342 */   GIM_Try, /*On fail goto*//*Label 9674*/ GIMT_Encode4(596417), // Rule ID 4443 //
     /*  596347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  596358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  596361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  596364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  596396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596415 */     GIR_RootConstrainSelectedInstOperands,
     /*  596416 */     // GIR_Coverage, 4443,
     /*  596416 */     GIR_EraseRootFromParent_Done,
     /*  596417 */   // Label 9674: @596417
     /*  596417 */   GIM_Try, /*On fail goto*//*Label 9675*/ GIMT_Encode4(596492), // Rule ID 4446 //
     /*  596422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  596433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  596436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  596439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  596471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596490 */     GIR_RootConstrainSelectedInstOperands,
     /*  596491 */     // GIR_Coverage, 4446,
     /*  596491 */     GIR_EraseRootFromParent_Done,
     /*  596492 */   // Label 9675: @596492
     /*  596492 */   GIM_Try, /*On fail goto*//*Label 9676*/ GIMT_Encode4(596567), // Rule ID 4447 //
     /*  596497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  596508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  596511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  596514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  596546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596565 */     GIR_RootConstrainSelectedInstOperands,
     /*  596566 */     // GIR_Coverage, 4447,
     /*  596566 */     GIR_EraseRootFromParent_Done,
     /*  596567 */   // Label 9676: @596567
     /*  596567 */   GIM_Try, /*On fail goto*//*Label 9677*/ GIMT_Encode4(596642), // Rule ID 4450 //
     /*  596572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  596583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  596586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  596589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  596621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596640 */     GIR_RootConstrainSelectedInstOperands,
     /*  596641 */     // GIR_Coverage, 4450,
     /*  596641 */     GIR_EraseRootFromParent_Done,
     /*  596642 */   // Label 9677: @596642
     /*  596642 */   GIM_Try, /*On fail goto*//*Label 9678*/ GIMT_Encode4(596717), // Rule ID 4451 //
     /*  596647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  596658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  596661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  596664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596693 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  596696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596715 */     GIR_RootConstrainSelectedInstOperands,
     /*  596716 */     // GIR_Coverage, 4451,
     /*  596716 */     GIR_EraseRootFromParent_Done,
     /*  596717 */   // Label 9678: @596717
     /*  596717 */   GIM_Try, /*On fail goto*//*Label 9679*/ GIMT_Encode4(596792), // Rule ID 4454 //
     /*  596722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  596725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  596733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  596736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  596739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596768 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  596768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  596771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596790 */     GIR_RootConstrainSelectedInstOperands,
     /*  596791 */     // GIR_Coverage, 4454,
     /*  596791 */     GIR_EraseRootFromParent_Done,
     /*  596792 */   // Label 9679: @596792
     /*  596792 */   GIM_Try, /*On fail goto*//*Label 9680*/ GIMT_Encode4(596867), // Rule ID 4455 //
     /*  596797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  596800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  596808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  596811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  596814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596843 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  596843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  596846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596865 */     GIR_RootConstrainSelectedInstOperands,
     /*  596866 */     // GIR_Coverage, 4455,
     /*  596866 */     GIR_EraseRootFromParent_Done,
     /*  596867 */   // Label 9680: @596867
     /*  596867 */   GIM_Try, /*On fail goto*//*Label 9681*/ GIMT_Encode4(596942), // Rule ID 4458 //
     /*  596872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  596875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  596883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  596886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  596889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596918 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  596918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  596921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596940 */     GIR_RootConstrainSelectedInstOperands,
     /*  596941 */     // GIR_Coverage, 4458,
     /*  596941 */     GIR_EraseRootFromParent_Done,
     /*  596942 */   // Label 9681: @596942
     /*  596942 */   GIM_Try, /*On fail goto*//*Label 9682*/ GIMT_Encode4(597017), // Rule ID 4459 //
     /*  596947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  596950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  596958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  596961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  596964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  596993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  596996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597015 */     GIR_RootConstrainSelectedInstOperands,
     /*  597016 */     // GIR_Coverage, 4459,
     /*  597016 */     GIR_EraseRootFromParent_Done,
     /*  597017 */   // Label 9682: @597017
     /*  597017 */   GIM_Try, /*On fail goto*//*Label 9683*/ GIMT_Encode4(597092), // Rule ID 4462 //
     /*  597022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  597030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  597033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  597036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  597039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597068 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  597071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597090 */     GIR_RootConstrainSelectedInstOperands,
     /*  597091 */     // GIR_Coverage, 4462,
     /*  597091 */     GIR_EraseRootFromParent_Done,
     /*  597092 */   // Label 9683: @597092
     /*  597092 */   GIM_Try, /*On fail goto*//*Label 9684*/ GIMT_Encode4(597167), // Rule ID 4463 //
     /*  597097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  597105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  597108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  597111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  597114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597143 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  597146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597165 */     GIR_RootConstrainSelectedInstOperands,
     /*  597166 */     // GIR_Coverage, 4463,
     /*  597166 */     GIR_EraseRootFromParent_Done,
     /*  597167 */   // Label 9684: @597167
     /*  597167 */   GIM_Try, /*On fail goto*//*Label 9685*/ GIMT_Encode4(597242), // Rule ID 4466 //
     /*  597172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  597180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  597183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  597186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  597189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597218 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  597221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597240 */     GIR_RootConstrainSelectedInstOperands,
     /*  597241 */     // GIR_Coverage, 4466,
     /*  597241 */     GIR_EraseRootFromParent_Done,
     /*  597242 */   // Label 9685: @597242
     /*  597242 */   GIM_Try, /*On fail goto*//*Label 9686*/ GIMT_Encode4(597317), // Rule ID 4467 //
     /*  597247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  597255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  597258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  597261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  597264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597293 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  597296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597315 */     GIR_RootConstrainSelectedInstOperands,
     /*  597316 */     // GIR_Coverage, 4467,
     /*  597316 */     GIR_EraseRootFromParent_Done,
     /*  597317 */   // Label 9686: @597317
     /*  597317 */   GIM_Try, /*On fail goto*//*Label 9687*/ GIMT_Encode4(597392), // Rule ID 4472 //
     /*  597322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  597333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  597336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  597339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  597342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597368 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  597371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597390 */     GIR_RootConstrainSelectedInstOperands,
     /*  597391 */     // GIR_Coverage, 4472,
     /*  597391 */     GIR_EraseRootFromParent_Done,
     /*  597392 */   // Label 9687: @597392
     /*  597392 */   GIM_Try, /*On fail goto*//*Label 9688*/ GIMT_Encode4(597467), // Rule ID 4473 //
     /*  597397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  597408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  597411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  597414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  597417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597443 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  597446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597465 */     GIR_RootConstrainSelectedInstOperands,
     /*  597466 */     // GIR_Coverage, 4473,
     /*  597466 */     GIR_EraseRootFromParent_Done,
     /*  597467 */   // Label 9688: @597467
     /*  597467 */   GIM_Try, /*On fail goto*//*Label 9689*/ GIMT_Encode4(597542), // Rule ID 4482 //
     /*  597472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  597483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  597486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  597489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  597492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  597521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597540 */     GIR_RootConstrainSelectedInstOperands,
     /*  597541 */     // GIR_Coverage, 4482,
     /*  597541 */     GIR_EraseRootFromParent_Done,
     /*  597542 */   // Label 9689: @597542
     /*  597542 */   GIM_Try, /*On fail goto*//*Label 9690*/ GIMT_Encode4(597617), // Rule ID 4483 //
     /*  597547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  597558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  597561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  597564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  597567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597593 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  597596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597615 */     GIR_RootConstrainSelectedInstOperands,
     /*  597616 */     // GIR_Coverage, 4483,
     /*  597616 */     GIR_EraseRootFromParent_Done,
     /*  597617 */   // Label 9690: @597617
     /*  597617 */   GIM_Try, /*On fail goto*//*Label 9691*/ GIMT_Encode4(597692), // Rule ID 4492 //
     /*  597622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  597633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  597636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  597639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  597642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  597671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597690 */     GIR_RootConstrainSelectedInstOperands,
     /*  597691 */     // GIR_Coverage, 4492,
     /*  597691 */     GIR_EraseRootFromParent_Done,
     /*  597692 */   // Label 9691: @597692
     /*  597692 */   GIM_Try, /*On fail goto*//*Label 9692*/ GIMT_Encode4(597767), // Rule ID 4493 //
     /*  597697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  597708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  597711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  597714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  597717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597743 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  597746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597765 */     GIR_RootConstrainSelectedInstOperands,
     /*  597766 */     // GIR_Coverage, 4493,
     /*  597766 */     GIR_EraseRootFromParent_Done,
     /*  597767 */   // Label 9692: @597767
     /*  597767 */   GIM_Try, /*On fail goto*//*Label 9693*/ GIMT_Encode4(597842), // Rule ID 4502 //
     /*  597772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  597783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  597786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  597789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  597792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  597821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597840 */     GIR_RootConstrainSelectedInstOperands,
     /*  597841 */     // GIR_Coverage, 4502,
     /*  597841 */     GIR_EraseRootFromParent_Done,
     /*  597842 */   // Label 9693: @597842
     /*  597842 */   GIM_Try, /*On fail goto*//*Label 9694*/ GIMT_Encode4(597917), // Rule ID 4503 //
     /*  597847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  597858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  597861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  597864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  597867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  597896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597915 */     GIR_RootConstrainSelectedInstOperands,
     /*  597916 */     // GIR_Coverage, 4503,
     /*  597916 */     GIR_EraseRootFromParent_Done,
     /*  597917 */   // Label 9694: @597917
     /*  597917 */   GIM_Try, /*On fail goto*//*Label 9695*/ GIMT_Encode4(597992), // Rule ID 4512 //
     /*  597922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  597933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  597936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  597939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  597942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597968 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  597971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597990 */     GIR_RootConstrainSelectedInstOperands,
     /*  597991 */     // GIR_Coverage, 4512,
     /*  597991 */     GIR_EraseRootFromParent_Done,
     /*  597992 */   // Label 9695: @597992
     /*  597992 */   GIM_Try, /*On fail goto*//*Label 9696*/ GIMT_Encode4(598067), // Rule ID 4513 //
     /*  597997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  598008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  598011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  598014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  598017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598043 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  598046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598065 */     GIR_RootConstrainSelectedInstOperands,
     /*  598066 */     // GIR_Coverage, 4513,
     /*  598066 */     GIR_EraseRootFromParent_Done,
     /*  598067 */   // Label 9696: @598067
     /*  598067 */   GIM_Try, /*On fail goto*//*Label 9697*/ GIMT_Encode4(598142), // Rule ID 4522 //
     /*  598072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  598083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  598086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  598089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  598092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598118 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  598121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598140 */     GIR_RootConstrainSelectedInstOperands,
     /*  598141 */     // GIR_Coverage, 4522,
     /*  598141 */     GIR_EraseRootFromParent_Done,
     /*  598142 */   // Label 9697: @598142
     /*  598142 */   GIM_Try, /*On fail goto*//*Label 9698*/ GIMT_Encode4(598217), // Rule ID 4523 //
     /*  598147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  598158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  598161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  598164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  598167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598193 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  598196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598215 */     GIR_RootConstrainSelectedInstOperands,
     /*  598216 */     // GIR_Coverage, 4523,
     /*  598216 */     GIR_EraseRootFromParent_Done,
     /*  598217 */   // Label 9698: @598217
     /*  598217 */   GIM_Try, /*On fail goto*//*Label 9699*/ GIMT_Encode4(598292), // Rule ID 4532 //
     /*  598222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  598233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  598236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  598239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  598242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  598271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598290 */     GIR_RootConstrainSelectedInstOperands,
     /*  598291 */     // GIR_Coverage, 4532,
     /*  598291 */     GIR_EraseRootFromParent_Done,
     /*  598292 */   // Label 9699: @598292
     /*  598292 */   GIM_Try, /*On fail goto*//*Label 9700*/ GIMT_Encode4(598367), // Rule ID 4533 //
     /*  598297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  598308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  598311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  598314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  598317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598343 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  598346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598365 */     GIR_RootConstrainSelectedInstOperands,
     /*  598366 */     // GIR_Coverage, 4533,
     /*  598366 */     GIR_EraseRootFromParent_Done,
     /*  598367 */   // Label 9700: @598367
     /*  598367 */   GIM_Try, /*On fail goto*//*Label 9701*/ GIMT_Encode4(598442), // Rule ID 4542 //
     /*  598372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  598383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  598386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  598389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  598392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  598421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598440 */     GIR_RootConstrainSelectedInstOperands,
     /*  598441 */     // GIR_Coverage, 4542,
     /*  598441 */     GIR_EraseRootFromParent_Done,
     /*  598442 */   // Label 9701: @598442
     /*  598442 */   GIM_Try, /*On fail goto*//*Label 9702*/ GIMT_Encode4(598517), // Rule ID 4543 //
     /*  598447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  598458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  598461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  598464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  598467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  598496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598515 */     GIR_RootConstrainSelectedInstOperands,
     /*  598516 */     // GIR_Coverage, 4543,
     /*  598516 */     GIR_EraseRootFromParent_Done,
     /*  598517 */   // Label 9702: @598517
     /*  598517 */   GIM_Try, /*On fail goto*//*Label 9703*/ GIMT_Encode4(598592), // Rule ID 4552 //
     /*  598522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  598533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  598536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  598539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  598542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  598571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598590 */     GIR_RootConstrainSelectedInstOperands,
     /*  598591 */     // GIR_Coverage, 4552,
     /*  598591 */     GIR_EraseRootFromParent_Done,
     /*  598592 */   // Label 9703: @598592
     /*  598592 */   GIM_Try, /*On fail goto*//*Label 9704*/ GIMT_Encode4(598667), // Rule ID 4553 //
     /*  598597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  598608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  598611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  598614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  598617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598643 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  598646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598665 */     GIR_RootConstrainSelectedInstOperands,
     /*  598666 */     // GIR_Coverage, 4553,
     /*  598666 */     GIR_EraseRootFromParent_Done,
     /*  598667 */   // Label 9704: @598667
     /*  598667 */   GIM_Try, /*On fail goto*//*Label 9705*/ GIMT_Encode4(598742), // Rule ID 4562 //
     /*  598672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  598683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  598686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  598689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  598692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598718 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  598721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598740 */     GIR_RootConstrainSelectedInstOperands,
     /*  598741 */     // GIR_Coverage, 4562,
     /*  598741 */     GIR_EraseRootFromParent_Done,
     /*  598742 */   // Label 9705: @598742
     /*  598742 */   GIM_Try, /*On fail goto*//*Label 9706*/ GIMT_Encode4(598817), // Rule ID 4563 //
     /*  598747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  598758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  598761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  598764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  598767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598793 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  598796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598815 */     GIR_RootConstrainSelectedInstOperands,
     /*  598816 */     // GIR_Coverage, 4563,
     /*  598816 */     GIR_EraseRootFromParent_Done,
     /*  598817 */   // Label 9706: @598817
     /*  598817 */   GIM_Try, /*On fail goto*//*Label 9707*/ GIMT_Encode4(598892), // Rule ID 4572 //
     /*  598822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  598833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  598836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  598839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  598842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598868 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  598871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598890 */     GIR_RootConstrainSelectedInstOperands,
     /*  598891 */     // GIR_Coverage, 4572,
     /*  598891 */     GIR_EraseRootFromParent_Done,
     /*  598892 */   // Label 9707: @598892
     /*  598892 */   GIM_Try, /*On fail goto*//*Label 9708*/ GIMT_Encode4(598967), // Rule ID 4573 //
     /*  598897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  598908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  598911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  598914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  598917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598943 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  598946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598965 */     GIR_RootConstrainSelectedInstOperands,
     /*  598966 */     // GIR_Coverage, 4573,
     /*  598966 */     GIR_EraseRootFromParent_Done,
     /*  598967 */   // Label 9708: @598967
     /*  598967 */   GIM_Try, /*On fail goto*//*Label 9709*/ GIMT_Encode4(599042), // Rule ID 4582 //
     /*  598972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  598975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  598983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  598986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  598989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  598992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599018 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  599021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599040 */     GIR_RootConstrainSelectedInstOperands,
     /*  599041 */     // GIR_Coverage, 4582,
     /*  599041 */     GIR_EraseRootFromParent_Done,
     /*  599042 */   // Label 9709: @599042
     /*  599042 */   GIM_Try, /*On fail goto*//*Label 9710*/ GIMT_Encode4(599117), // Rule ID 4583 //
     /*  599047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  599058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  599061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  599064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  599067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599093 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  599096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599115 */     GIR_RootConstrainSelectedInstOperands,
     /*  599116 */     // GIR_Coverage, 4583,
     /*  599116 */     GIR_EraseRootFromParent_Done,
     /*  599117 */   // Label 9710: @599117
     /*  599117 */   GIM_Try, /*On fail goto*//*Label 9711*/ GIMT_Encode4(599192), // Rule ID 4592 //
     /*  599122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  599133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  599136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  599139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  599142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  599171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599190 */     GIR_RootConstrainSelectedInstOperands,
     /*  599191 */     // GIR_Coverage, 4592,
     /*  599191 */     GIR_EraseRootFromParent_Done,
     /*  599192 */   // Label 9711: @599192
     /*  599192 */   GIM_Try, /*On fail goto*//*Label 9712*/ GIMT_Encode4(599267), // Rule ID 4593 //
     /*  599197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  599208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  599211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  599214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  599217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  599246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599265 */     GIR_RootConstrainSelectedInstOperands,
     /*  599266 */     // GIR_Coverage, 4593,
     /*  599266 */     GIR_EraseRootFromParent_Done,
     /*  599267 */   // Label 9712: @599267
     /*  599267 */   GIM_Try, /*On fail goto*//*Label 9713*/ GIMT_Encode4(599342), // Rule ID 4602 //
     /*  599272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  599283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  599286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  599289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  599292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599318 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  599321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599340 */     GIR_RootConstrainSelectedInstOperands,
     /*  599341 */     // GIR_Coverage, 4602,
     /*  599341 */     GIR_EraseRootFromParent_Done,
     /*  599342 */   // Label 9713: @599342
     /*  599342 */   GIM_Try, /*On fail goto*//*Label 9714*/ GIMT_Encode4(599417), // Rule ID 4603 //
     /*  599347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  599358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  599361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  599364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  599367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599393 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  599396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599415 */     GIR_RootConstrainSelectedInstOperands,
     /*  599416 */     // GIR_Coverage, 4603,
     /*  599416 */     GIR_EraseRootFromParent_Done,
     /*  599417 */   // Label 9714: @599417
     /*  599417 */   GIM_Try, /*On fail goto*//*Label 9715*/ GIMT_Encode4(599492), // Rule ID 4612 //
     /*  599422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  599433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  599436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  599439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  599442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  599471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599490 */     GIR_RootConstrainSelectedInstOperands,
     /*  599491 */     // GIR_Coverage, 4612,
     /*  599491 */     GIR_EraseRootFromParent_Done,
     /*  599492 */   // Label 9715: @599492
     /*  599492 */   GIM_Try, /*On fail goto*//*Label 9716*/ GIMT_Encode4(599567), // Rule ID 4613 //
     /*  599497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  599508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  599511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  599514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  599517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599543 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  599546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599565 */     GIR_RootConstrainSelectedInstOperands,
     /*  599566 */     // GIR_Coverage, 4613,
     /*  599566 */     GIR_EraseRootFromParent_Done,
     /*  599567 */   // Label 9716: @599567
     /*  599567 */   GIM_Try, /*On fail goto*//*Label 9717*/ GIMT_Encode4(599642), // Rule ID 4620 //
     /*  599572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  599583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  599586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  599589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599618 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  599621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599640 */     GIR_RootConstrainSelectedInstOperands,
     /*  599641 */     // GIR_Coverage, 4620,
     /*  599641 */     GIR_EraseRootFromParent_Done,
     /*  599642 */   // Label 9717: @599642
     /*  599642 */   GIM_Try, /*On fail goto*//*Label 9718*/ GIMT_Encode4(599717), // Rule ID 4621 //
     /*  599647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  599658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  599661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  599664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599693 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  599696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599715 */     GIR_RootConstrainSelectedInstOperands,
     /*  599716 */     // GIR_Coverage, 4621,
     /*  599716 */     GIR_EraseRootFromParent_Done,
     /*  599717 */   // Label 9718: @599717
     /*  599717 */   GIM_Try, /*On fail goto*//*Label 9719*/ GIMT_Encode4(599792), // Rule ID 4624 //
     /*  599722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  599733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  599736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  599739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  599771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599790 */     GIR_RootConstrainSelectedInstOperands,
     /*  599791 */     // GIR_Coverage, 4624,
     /*  599791 */     GIR_EraseRootFromParent_Done,
     /*  599792 */   // Label 9719: @599792
     /*  599792 */   GIM_Try, /*On fail goto*//*Label 9720*/ GIMT_Encode4(599867), // Rule ID 4625 //
     /*  599797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  599808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  599811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  599814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599843 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  599846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599865 */     GIR_RootConstrainSelectedInstOperands,
     /*  599866 */     // GIR_Coverage, 4625,
     /*  599866 */     GIR_EraseRootFromParent_Done,
     /*  599867 */   // Label 9720: @599867
     /*  599867 */   GIM_Try, /*On fail goto*//*Label 9721*/ GIMT_Encode4(599942), // Rule ID 4628 //
     /*  599872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  599883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  599886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  599889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  599921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599940 */     GIR_RootConstrainSelectedInstOperands,
     /*  599941 */     // GIR_Coverage, 4628,
     /*  599941 */     GIR_EraseRootFromParent_Done,
     /*  599942 */   // Label 9721: @599942
     /*  599942 */   GIM_Try, /*On fail goto*//*Label 9722*/ GIMT_Encode4(600017), // Rule ID 4629 //
     /*  599947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  599958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  599961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  599964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599993 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  599996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600015 */     GIR_RootConstrainSelectedInstOperands,
     /*  600016 */     // GIR_Coverage, 4629,
     /*  600016 */     GIR_EraseRootFromParent_Done,
     /*  600017 */   // Label 9722: @600017
     /*  600017 */   GIM_Try, /*On fail goto*//*Label 9723*/ GIMT_Encode4(600092), // Rule ID 4632 //
     /*  600022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  600033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  600036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  600039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  600071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600090 */     GIR_RootConstrainSelectedInstOperands,
     /*  600091 */     // GIR_Coverage, 4632,
     /*  600091 */     GIR_EraseRootFromParent_Done,
     /*  600092 */   // Label 9723: @600092
     /*  600092 */   GIM_Try, /*On fail goto*//*Label 9724*/ GIMT_Encode4(600167), // Rule ID 4633 //
     /*  600097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  600108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  600111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  600114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  600146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600165 */     GIR_RootConstrainSelectedInstOperands,
     /*  600166 */     // GIR_Coverage, 4633,
     /*  600166 */     GIR_EraseRootFromParent_Done,
     /*  600167 */   // Label 9724: @600167
     /*  600167 */   GIM_Try, /*On fail goto*//*Label 9725*/ GIMT_Encode4(600242), // Rule ID 4636 //
     /*  600172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  600183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  600186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  600189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  600221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600240 */     GIR_RootConstrainSelectedInstOperands,
     /*  600241 */     // GIR_Coverage, 4636,
     /*  600241 */     GIR_EraseRootFromParent_Done,
     /*  600242 */   // Label 9725: @600242
     /*  600242 */   GIM_Try, /*On fail goto*//*Label 9726*/ GIMT_Encode4(600317), // Rule ID 4637 //
     /*  600247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  600258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  600261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  600264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600293 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  600296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600315 */     GIR_RootConstrainSelectedInstOperands,
     /*  600316 */     // GIR_Coverage, 4637,
     /*  600316 */     GIR_EraseRootFromParent_Done,
     /*  600317 */   // Label 9726: @600317
     /*  600317 */   GIM_Try, /*On fail goto*//*Label 9727*/ GIMT_Encode4(600392), // Rule ID 4640 //
     /*  600322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  600333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  600336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  600339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600368 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  600371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600390 */     GIR_RootConstrainSelectedInstOperands,
     /*  600391 */     // GIR_Coverage, 4640,
     /*  600391 */     GIR_EraseRootFromParent_Done,
     /*  600392 */   // Label 9727: @600392
     /*  600392 */   GIM_Try, /*On fail goto*//*Label 9728*/ GIMT_Encode4(600467), // Rule ID 4641 //
     /*  600397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  600408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  600411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  600414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600443 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  600446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600465 */     GIR_RootConstrainSelectedInstOperands,
     /*  600466 */     // GIR_Coverage, 4641,
     /*  600466 */     GIR_EraseRootFromParent_Done,
     /*  600467 */   // Label 9728: @600467
     /*  600467 */   GIM_Try, /*On fail goto*//*Label 9729*/ GIMT_Encode4(600542), // Rule ID 4644 //
     /*  600472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  600483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  600486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  600489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600518 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  600518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  600521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600540 */     GIR_RootConstrainSelectedInstOperands,
     /*  600541 */     // GIR_Coverage, 4644,
     /*  600541 */     GIR_EraseRootFromParent_Done,
     /*  600542 */   // Label 9729: @600542
     /*  600542 */   GIM_Try, /*On fail goto*//*Label 9730*/ GIMT_Encode4(600617), // Rule ID 4645 //
     /*  600547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  600558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  600561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  600564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600593 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  600593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  600596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600615 */     GIR_RootConstrainSelectedInstOperands,
     /*  600616 */     // GIR_Coverage, 4645,
     /*  600616 */     GIR_EraseRootFromParent_Done,
     /*  600617 */   // Label 9730: @600617
     /*  600617 */   GIM_Try, /*On fail goto*//*Label 9731*/ GIMT_Encode4(600692), // Rule ID 4648 //
     /*  600622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  600633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  600636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  600639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600668 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  600668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  600671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600690 */     GIR_RootConstrainSelectedInstOperands,
     /*  600691 */     // GIR_Coverage, 4648,
     /*  600691 */     GIR_EraseRootFromParent_Done,
     /*  600692 */   // Label 9731: @600692
     /*  600692 */   GIM_Try, /*On fail goto*//*Label 9732*/ GIMT_Encode4(600767), // Rule ID 4649 //
     /*  600697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  600708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  600711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  600714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600743 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  600743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  600746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600765 */     GIR_RootConstrainSelectedInstOperands,
     /*  600766 */     // GIR_Coverage, 4649,
     /*  600766 */     GIR_EraseRootFromParent_Done,
     /*  600767 */   // Label 9732: @600767
     /*  600767 */   GIM_Try, /*On fail goto*//*Label 9733*/ GIMT_Encode4(600842), // Rule ID 4652 //
     /*  600772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  600783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  600786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  600789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  600818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  600821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600840 */     GIR_RootConstrainSelectedInstOperands,
     /*  600841 */     // GIR_Coverage, 4652,
     /*  600841 */     GIR_EraseRootFromParent_Done,
     /*  600842 */   // Label 9733: @600842
     /*  600842 */   GIM_Try, /*On fail goto*//*Label 9734*/ GIMT_Encode4(600917), // Rule ID 4653 //
     /*  600847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  600858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  600861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  600864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  600893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  600896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600915 */     GIR_RootConstrainSelectedInstOperands,
     /*  600916 */     // GIR_Coverage, 4653,
     /*  600916 */     GIR_EraseRootFromParent_Done,
     /*  600917 */   // Label 9734: @600917
     /*  600917 */   GIM_Try, /*On fail goto*//*Label 9735*/ GIMT_Encode4(600992), // Rule ID 4656 //
     /*  600922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  600933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  600936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  600939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  600968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  600971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600990 */     GIR_RootConstrainSelectedInstOperands,
     /*  600991 */     // GIR_Coverage, 4656,
     /*  600991 */     GIR_EraseRootFromParent_Done,
     /*  600992 */   // Label 9735: @600992
     /*  600992 */   GIM_Try, /*On fail goto*//*Label 9736*/ GIMT_Encode4(601067), // Rule ID 4657 //
     /*  600997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  601008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  601011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  601014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  601046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601065 */     GIR_RootConstrainSelectedInstOperands,
     /*  601066 */     // GIR_Coverage, 4657,
     /*  601066 */     GIR_EraseRootFromParent_Done,
     /*  601067 */   // Label 9736: @601067
     /*  601067 */   GIM_Try, /*On fail goto*//*Label 9737*/ GIMT_Encode4(601142), // Rule ID 4660 //
     /*  601072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  601083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  601086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  601089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  601121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601140 */     GIR_RootConstrainSelectedInstOperands,
     /*  601141 */     // GIR_Coverage, 4660,
     /*  601141 */     GIR_EraseRootFromParent_Done,
     /*  601142 */   // Label 9737: @601142
     /*  601142 */   GIM_Try, /*On fail goto*//*Label 9738*/ GIMT_Encode4(601217), // Rule ID 4661 //
     /*  601147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  601158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  601161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  601164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601193 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  601196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601215 */     GIR_RootConstrainSelectedInstOperands,
     /*  601216 */     // GIR_Coverage, 4661,
     /*  601216 */     GIR_EraseRootFromParent_Done,
     /*  601217 */   // Label 9738: @601217
     /*  601217 */   GIM_Try, /*On fail goto*//*Label 9739*/ GIMT_Encode4(601292), // Rule ID 4664 //
     /*  601222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  601233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  601236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  601239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  601271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601290 */     GIR_RootConstrainSelectedInstOperands,
     /*  601291 */     // GIR_Coverage, 4664,
     /*  601291 */     GIR_EraseRootFromParent_Done,
     /*  601292 */   // Label 9739: @601292
     /*  601292 */   GIM_Try, /*On fail goto*//*Label 9740*/ GIMT_Encode4(601367), // Rule ID 4665 //
     /*  601297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  601308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  601311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  601314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601343 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  601346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601365 */     GIR_RootConstrainSelectedInstOperands,
     /*  601366 */     // GIR_Coverage, 4665,
     /*  601366 */     GIR_EraseRootFromParent_Done,
     /*  601367 */   // Label 9740: @601367
     /*  601367 */   GIM_Try, /*On fail goto*//*Label 9741*/ GIMT_Encode4(601442), // Rule ID 4668 //
     /*  601372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  601383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  601386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  601389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601418 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  601421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601440 */     GIR_RootConstrainSelectedInstOperands,
     /*  601441 */     // GIR_Coverage, 4668,
     /*  601441 */     GIR_EraseRootFromParent_Done,
     /*  601442 */   // Label 9741: @601442
     /*  601442 */   GIM_Try, /*On fail goto*//*Label 9742*/ GIMT_Encode4(601517), // Rule ID 4669 //
     /*  601447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  601458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  601461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  601464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601493 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  601496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601515 */     GIR_RootConstrainSelectedInstOperands,
     /*  601516 */     // GIR_Coverage, 4669,
     /*  601516 */     GIR_EraseRootFromParent_Done,
     /*  601517 */   // Label 9742: @601517
     /*  601517 */   GIM_Try, /*On fail goto*//*Label 9743*/ GIMT_Encode4(601592), // Rule ID 4672 //
     /*  601522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  601533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  601536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  601539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601568 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  601571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601590 */     GIR_RootConstrainSelectedInstOperands,
     /*  601591 */     // GIR_Coverage, 4672,
     /*  601591 */     GIR_EraseRootFromParent_Done,
     /*  601592 */   // Label 9743: @601592
     /*  601592 */   GIM_Try, /*On fail goto*//*Label 9744*/ GIMT_Encode4(601667), // Rule ID 4673 //
     /*  601597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  601608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  601611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  601614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601643 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  601646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601665 */     GIR_RootConstrainSelectedInstOperands,
     /*  601666 */     // GIR_Coverage, 4673,
     /*  601666 */     GIR_EraseRootFromParent_Done,
     /*  601667 */   // Label 9744: @601667
     /*  601667 */   GIM_Try, /*On fail goto*//*Label 9745*/ GIMT_Encode4(601742), // Rule ID 4676 //
     /*  601672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  601683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  601686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  601689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  601721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601740 */     GIR_RootConstrainSelectedInstOperands,
     /*  601741 */     // GIR_Coverage, 4676,
     /*  601741 */     GIR_EraseRootFromParent_Done,
     /*  601742 */   // Label 9745: @601742
     /*  601742 */   GIM_Try, /*On fail goto*//*Label 9746*/ GIMT_Encode4(601817), // Rule ID 4677 //
     /*  601747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  601758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  601761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  601764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601793 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  601796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601815 */     GIR_RootConstrainSelectedInstOperands,
     /*  601816 */     // GIR_Coverage, 4677,
     /*  601816 */     GIR_EraseRootFromParent_Done,
     /*  601817 */   // Label 9746: @601817
     /*  601817 */   GIM_Try, /*On fail goto*//*Label 9747*/ GIMT_Encode4(601892), // Rule ID 4682 //
     /*  601822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  601833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  601836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  601839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  601842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  601868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  601871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601890 */     GIR_RootConstrainSelectedInstOperands,
     /*  601891 */     // GIR_Coverage, 4682,
     /*  601891 */     GIR_EraseRootFromParent_Done,
     /*  601892 */   // Label 9747: @601892
     /*  601892 */   GIM_Try, /*On fail goto*//*Label 9748*/ GIMT_Encode4(601967), // Rule ID 4683 //
     /*  601897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  601908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  601911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  601914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  601917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601943 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  601943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  601946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601965 */     GIR_RootConstrainSelectedInstOperands,
     /*  601966 */     // GIR_Coverage, 4683,
     /*  601966 */     GIR_EraseRootFromParent_Done,
     /*  601967 */   // Label 9748: @601967
     /*  601967 */   GIM_Try, /*On fail goto*//*Label 9749*/ GIMT_Encode4(602042), // Rule ID 4692 //
     /*  601972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  601983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  601986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  601989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  601992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602018 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  602018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  602021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602040 */     GIR_RootConstrainSelectedInstOperands,
     /*  602041 */     // GIR_Coverage, 4692,
     /*  602041 */     GIR_EraseRootFromParent_Done,
     /*  602042 */   // Label 9749: @602042
     /*  602042 */   GIM_Try, /*On fail goto*//*Label 9750*/ GIMT_Encode4(602117), // Rule ID 4693 //
     /*  602047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  602058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  602061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  602064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  602067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602093 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  602093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  602096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602115 */     GIR_RootConstrainSelectedInstOperands,
     /*  602116 */     // GIR_Coverage, 4693,
     /*  602116 */     GIR_EraseRootFromParent_Done,
     /*  602117 */   // Label 9750: @602117
     /*  602117 */   GIM_Try, /*On fail goto*//*Label 9751*/ GIMT_Encode4(602192), // Rule ID 4702 //
     /*  602122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  602133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  602136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  602139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  602142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  602168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  602171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602190 */     GIR_RootConstrainSelectedInstOperands,
     /*  602191 */     // GIR_Coverage, 4702,
     /*  602191 */     GIR_EraseRootFromParent_Done,
     /*  602192 */   // Label 9751: @602192
     /*  602192 */   GIM_Try, /*On fail goto*//*Label 9752*/ GIMT_Encode4(602267), // Rule ID 4703 //
     /*  602197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  602208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  602211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  602214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  602217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602243 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  602243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  602246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602265 */     GIR_RootConstrainSelectedInstOperands,
     /*  602266 */     // GIR_Coverage, 4703,
     /*  602266 */     GIR_EraseRootFromParent_Done,
     /*  602267 */   // Label 9752: @602267
     /*  602267 */   GIM_Try, /*On fail goto*//*Label 9753*/ GIMT_Encode4(602342), // Rule ID 4712 //
     /*  602272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  602283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  602286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  602289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  602292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  602318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  602321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602340 */     GIR_RootConstrainSelectedInstOperands,
     /*  602341 */     // GIR_Coverage, 4712,
     /*  602341 */     GIR_EraseRootFromParent_Done,
     /*  602342 */   // Label 9753: @602342
     /*  602342 */   GIM_Try, /*On fail goto*//*Label 9754*/ GIMT_Encode4(602417), // Rule ID 4713 //
     /*  602347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  602358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  602361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  602364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  602367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602393 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  602393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  602396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602415 */     GIR_RootConstrainSelectedInstOperands,
     /*  602416 */     // GIR_Coverage, 4713,
     /*  602416 */     GIR_EraseRootFromParent_Done,
     /*  602417 */   // Label 9754: @602417
     /*  602417 */   GIM_Try, /*On fail goto*//*Label 9755*/ GIMT_Encode4(602492), // Rule ID 4722 //
     /*  602422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  602433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  602436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  602439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  602442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602468 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  602468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  602471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602490 */     GIR_RootConstrainSelectedInstOperands,
     /*  602491 */     // GIR_Coverage, 4722,
     /*  602491 */     GIR_EraseRootFromParent_Done,
     /*  602492 */   // Label 9755: @602492
     /*  602492 */   GIM_Try, /*On fail goto*//*Label 9756*/ GIMT_Encode4(602567), // Rule ID 4723 //
     /*  602497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  602508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  602511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  602514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  602517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602543 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  602543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  602546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602565 */     GIR_RootConstrainSelectedInstOperands,
     /*  602566 */     // GIR_Coverage, 4723,
     /*  602566 */     GIR_EraseRootFromParent_Done,
     /*  602567 */   // Label 9756: @602567
     /*  602567 */   GIM_Try, /*On fail goto*//*Label 9757*/ GIMT_Encode4(602642), // Rule ID 4732 //
     /*  602572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  602583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  602586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  602589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  602592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602618 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  602618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  602621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602640 */     GIR_RootConstrainSelectedInstOperands,
     /*  602641 */     // GIR_Coverage, 4732,
     /*  602641 */     GIR_EraseRootFromParent_Done,
     /*  602642 */   // Label 9757: @602642
     /*  602642 */   GIM_Try, /*On fail goto*//*Label 9758*/ GIMT_Encode4(602717), // Rule ID 4733 //
     /*  602647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  602658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  602661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  602664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  602667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602693 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  602693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  602696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602715 */     GIR_RootConstrainSelectedInstOperands,
     /*  602716 */     // GIR_Coverage, 4733,
     /*  602716 */     GIR_EraseRootFromParent_Done,
     /*  602717 */   // Label 9758: @602717
     /*  602717 */   GIM_Try, /*On fail goto*//*Label 9759*/ GIMT_Encode4(602792), // Rule ID 4742 //
     /*  602722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  602733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  602736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  602739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  602742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  602768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  602771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602790 */     GIR_RootConstrainSelectedInstOperands,
     /*  602791 */     // GIR_Coverage, 4742,
     /*  602791 */     GIR_EraseRootFromParent_Done,
     /*  602792 */   // Label 9759: @602792
     /*  602792 */   GIM_Try, /*On fail goto*//*Label 9760*/ GIMT_Encode4(602867), // Rule ID 4743 //
     /*  602797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  602808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  602811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  602814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  602817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602843 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  602843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  602846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602865 */     GIR_RootConstrainSelectedInstOperands,
     /*  602866 */     // GIR_Coverage, 4743,
     /*  602866 */     GIR_EraseRootFromParent_Done,
     /*  602867 */   // Label 9760: @602867
     /*  602867 */   GIM_Try, /*On fail goto*//*Label 9761*/ GIMT_Encode4(602942), // Rule ID 4752 //
     /*  602872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  602883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  602886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  602889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  602892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  602918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  602921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602940 */     GIR_RootConstrainSelectedInstOperands,
     /*  602941 */     // GIR_Coverage, 4752,
     /*  602941 */     GIR_EraseRootFromParent_Done,
     /*  602942 */   // Label 9761: @602942
     /*  602942 */   GIM_Try, /*On fail goto*//*Label 9762*/ GIMT_Encode4(603017), // Rule ID 4753 //
     /*  602947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  602958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  602961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  602964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  602967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602993 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  602993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  602996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603015 */     GIR_RootConstrainSelectedInstOperands,
     /*  603016 */     // GIR_Coverage, 4753,
     /*  603016 */     GIR_EraseRootFromParent_Done,
     /*  603017 */   // Label 9762: @603017
     /*  603017 */   GIM_Try, /*On fail goto*//*Label 9763*/ GIMT_Encode4(603092), // Rule ID 4762 //
     /*  603022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  603033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  603036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  603039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  603042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  603068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  603071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603090 */     GIR_RootConstrainSelectedInstOperands,
     /*  603091 */     // GIR_Coverage, 4762,
     /*  603091 */     GIR_EraseRootFromParent_Done,
     /*  603092 */   // Label 9763: @603092
     /*  603092 */   GIM_Try, /*On fail goto*//*Label 9764*/ GIMT_Encode4(603167), // Rule ID 4763 //
     /*  603097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  603108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  603111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  603114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  603117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  603143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  603146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603165 */     GIR_RootConstrainSelectedInstOperands,
     /*  603166 */     // GIR_Coverage, 4763,
     /*  603166 */     GIR_EraseRootFromParent_Done,
     /*  603167 */   // Label 9764: @603167
     /*  603167 */   GIM_Try, /*On fail goto*//*Label 9765*/ GIMT_Encode4(603242), // Rule ID 4772 //
     /*  603172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  603183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  603186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  603189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  603192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  603218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  603221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603240 */     GIR_RootConstrainSelectedInstOperands,
     /*  603241 */     // GIR_Coverage, 4772,
     /*  603241 */     GIR_EraseRootFromParent_Done,
     /*  603242 */   // Label 9765: @603242
     /*  603242 */   GIM_Try, /*On fail goto*//*Label 9766*/ GIMT_Encode4(603317), // Rule ID 4773 //
     /*  603247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  603258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  603261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  603264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  603267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603293 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  603293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  603296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603315 */     GIR_RootConstrainSelectedInstOperands,
     /*  603316 */     // GIR_Coverage, 4773,
     /*  603316 */     GIR_EraseRootFromParent_Done,
     /*  603317 */   // Label 9766: @603317
     /*  603317 */   GIM_Try, /*On fail goto*//*Label 9767*/ GIMT_Encode4(603392), // Rule ID 4782 //
     /*  603322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  603333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  603336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  603339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  603342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  603368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  603371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603390 */     GIR_RootConstrainSelectedInstOperands,
     /*  603391 */     // GIR_Coverage, 4782,
     /*  603391 */     GIR_EraseRootFromParent_Done,
     /*  603392 */   // Label 9767: @603392
     /*  603392 */   GIM_Try, /*On fail goto*//*Label 9768*/ GIMT_Encode4(603467), // Rule ID 4783 //
     /*  603397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  603408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  603411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  603414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  603417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603443 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  603443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  603446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603465 */     GIR_RootConstrainSelectedInstOperands,
     /*  603466 */     // GIR_Coverage, 4783,
     /*  603466 */     GIR_EraseRootFromParent_Done,
     /*  603467 */   // Label 9768: @603467
     /*  603467 */   GIM_Try, /*On fail goto*//*Label 9769*/ GIMT_Encode4(603542), // Rule ID 4792 //
     /*  603472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  603475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  603483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  603486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  603489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  603492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  603518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  603521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603540 */     GIR_RootConstrainSelectedInstOperands,
     /*  603541 */     // GIR_Coverage, 4792,
     /*  603541 */     GIR_EraseRootFromParent_Done,
     /*  603542 */   // Label 9769: @603542
     /*  603542 */   GIM_Try, /*On fail goto*//*Label 9770*/ GIMT_Encode4(603617), // Rule ID 4793 //
     /*  603547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  603550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  603558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  603561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  603564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  603567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603593 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  603593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  603596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603615 */     GIR_RootConstrainSelectedInstOperands,
     /*  603616 */     // GIR_Coverage, 4793,
     /*  603616 */     GIR_EraseRootFromParent_Done,
     /*  603617 */   // Label 9770: @603617
     /*  603617 */   GIM_Try, /*On fail goto*//*Label 9771*/ GIMT_Encode4(603692), // Rule ID 4802 //
     /*  603622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  603625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  603633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  603636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  603639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  603642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  603668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  603671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603690 */     GIR_RootConstrainSelectedInstOperands,
     /*  603691 */     // GIR_Coverage, 4802,
     /*  603691 */     GIR_EraseRootFromParent_Done,
     /*  603692 */   // Label 9771: @603692
     /*  603692 */   GIM_Try, /*On fail goto*//*Label 9772*/ GIMT_Encode4(603767), // Rule ID 4803 //
     /*  603697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  603700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  603708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  603711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  603714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  603717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  603743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  603746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603765 */     GIR_RootConstrainSelectedInstOperands,
     /*  603766 */     // GIR_Coverage, 4803,
     /*  603766 */     GIR_EraseRootFromParent_Done,
     /*  603767 */   // Label 9772: @603767
     /*  603767 */   GIM_Try, /*On fail goto*//*Label 9773*/ GIMT_Encode4(603842), // Rule ID 4812 //
     /*  603772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  603775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  603783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  603786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  603789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  603792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603818 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  603818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  603821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603840 */     GIR_RootConstrainSelectedInstOperands,
     /*  603841 */     // GIR_Coverage, 4812,
     /*  603841 */     GIR_EraseRootFromParent_Done,
     /*  603842 */   // Label 9773: @603842
     /*  603842 */   GIM_Try, /*On fail goto*//*Label 9774*/ GIMT_Encode4(603917), // Rule ID 4813 //
     /*  603847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  603850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  603858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  603861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  603864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  603867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603893 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  603893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  603896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603915 */     GIR_RootConstrainSelectedInstOperands,
     /*  603916 */     // GIR_Coverage, 4813,
     /*  603916 */     GIR_EraseRootFromParent_Done,
     /*  603917 */   // Label 9774: @603917
     /*  603917 */   GIM_Try, /*On fail goto*//*Label 9775*/ GIMT_Encode4(603992), // Rule ID 4822 //
     /*  603922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  603925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  603933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  603936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  603939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  603942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  603968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  603971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603990 */     GIR_RootConstrainSelectedInstOperands,
     /*  603991 */     // GIR_Coverage, 4822,
     /*  603991 */     GIR_EraseRootFromParent_Done,
     /*  603992 */   // Label 9775: @603992
     /*  603992 */   GIM_Try, /*On fail goto*//*Label 9776*/ GIMT_Encode4(604067), // Rule ID 4823 //
     /*  603997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  604000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  604008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  604011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  604014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  604017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  604043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  604046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604065 */     GIR_RootConstrainSelectedInstOperands,
     /*  604066 */     // GIR_Coverage, 4823,
     /*  604066 */     GIR_EraseRootFromParent_Done,
     /*  604067 */   // Label 9776: @604067
     /*  604067 */   GIM_Try, /*On fail goto*//*Label 9777*/ GIMT_Encode4(604142), // Rule ID 4830 //
     /*  604072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  604083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  604086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  604089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604118 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  604118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  604121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604140 */     GIR_RootConstrainSelectedInstOperands,
     /*  604141 */     // GIR_Coverage, 4830,
     /*  604141 */     GIR_EraseRootFromParent_Done,
     /*  604142 */   // Label 9777: @604142
     /*  604142 */   GIM_Try, /*On fail goto*//*Label 9778*/ GIMT_Encode4(604217), // Rule ID 4831 //
     /*  604147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  604158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  604161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  604164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  604167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604193 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  604193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  604196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604215 */     GIR_RootConstrainSelectedInstOperands,
     /*  604216 */     // GIR_Coverage, 4831,
     /*  604216 */     GIR_EraseRootFromParent_Done,
     /*  604217 */   // Label 9778: @604217
     /*  604217 */   GIM_Try, /*On fail goto*//*Label 9779*/ GIMT_Encode4(604292), // Rule ID 4834 //
     /*  604222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  604233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  604236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  604239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604268 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  604268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  604271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604290 */     GIR_RootConstrainSelectedInstOperands,
     /*  604291 */     // GIR_Coverage, 4834,
     /*  604291 */     GIR_EraseRootFromParent_Done,
     /*  604292 */   // Label 9779: @604292
     /*  604292 */   GIM_Try, /*On fail goto*//*Label 9780*/ GIMT_Encode4(604367), // Rule ID 4835 //
     /*  604297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  604308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  604311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  604314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  604317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604343 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  604343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  604346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604365 */     GIR_RootConstrainSelectedInstOperands,
     /*  604366 */     // GIR_Coverage, 4835,
     /*  604366 */     GIR_EraseRootFromParent_Done,
     /*  604367 */   // Label 9780: @604367
     /*  604367 */   GIM_Try, /*On fail goto*//*Label 9781*/ GIMT_Encode4(604442), // Rule ID 4838 //
     /*  604372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  604383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  604386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  604389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604418 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  604418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  604421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604440 */     GIR_RootConstrainSelectedInstOperands,
     /*  604441 */     // GIR_Coverage, 4838,
     /*  604441 */     GIR_EraseRootFromParent_Done,
     /*  604442 */   // Label 9781: @604442
     /*  604442 */   GIM_Try, /*On fail goto*//*Label 9782*/ GIMT_Encode4(604517), // Rule ID 4839 //
     /*  604447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  604458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  604461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  604464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  604467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604493 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  604493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  604496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604515 */     GIR_RootConstrainSelectedInstOperands,
     /*  604516 */     // GIR_Coverage, 4839,
     /*  604516 */     GIR_EraseRootFromParent_Done,
     /*  604517 */   // Label 9782: @604517
     /*  604517 */   GIM_Try, /*On fail goto*//*Label 9783*/ GIMT_Encode4(604592), // Rule ID 4842 //
     /*  604522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  604533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  604568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  604571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604590 */     GIR_RootConstrainSelectedInstOperands,
     /*  604591 */     // GIR_Coverage, 4842,
     /*  604591 */     GIR_EraseRootFromParent_Done,
     /*  604592 */   // Label 9783: @604592
     /*  604592 */   GIM_Try, /*On fail goto*//*Label 9784*/ GIMT_Encode4(604667), // Rule ID 4843 //
     /*  604597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  604608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  604617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604643 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  604643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  604646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604665 */     GIR_RootConstrainSelectedInstOperands,
     /*  604666 */     // GIR_Coverage, 4843,
     /*  604666 */     GIR_EraseRootFromParent_Done,
     /*  604667 */   // Label 9784: @604667
     /*  604667 */   GIM_Try, /*On fail goto*//*Label 9785*/ GIMT_Encode4(604742), // Rule ID 4846 //
     /*  604672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  604683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604718 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  604718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  604721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604740 */     GIR_RootConstrainSelectedInstOperands,
     /*  604741 */     // GIR_Coverage, 4846,
     /*  604741 */     GIR_EraseRootFromParent_Done,
     /*  604742 */   // Label 9785: @604742
     /*  604742 */   GIM_Try, /*On fail goto*//*Label 9786*/ GIMT_Encode4(604817), // Rule ID 4847 //
     /*  604747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  604758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  604767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604793 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  604793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  604796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604815 */     GIR_RootConstrainSelectedInstOperands,
     /*  604816 */     // GIR_Coverage, 4847,
     /*  604816 */     GIR_EraseRootFromParent_Done,
     /*  604817 */   // Label 9786: @604817
     /*  604817 */   GIM_Try, /*On fail goto*//*Label 9787*/ GIMT_Encode4(604892), // Rule ID 4850 //
     /*  604822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  604833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604868 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  604868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  604871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604890 */     GIR_RootConstrainSelectedInstOperands,
     /*  604891 */     // GIR_Coverage, 4850,
     /*  604891 */     GIR_EraseRootFromParent_Done,
     /*  604892 */   // Label 9787: @604892
     /*  604892 */   GIM_Try, /*On fail goto*//*Label 9788*/ GIMT_Encode4(604967), // Rule ID 4851 //
     /*  604897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  604908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  604917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604943 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  604943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  604946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604965 */     GIR_RootConstrainSelectedInstOperands,
     /*  604966 */     // GIR_Coverage, 4851,
     /*  604966 */     GIR_EraseRootFromParent_Done,
     /*  604967 */   // Label 9788: @604967
     /*  604967 */   GIM_Try, /*On fail goto*//*Label 9789*/ GIMT_Encode4(605042), // Rule ID 4854 //
     /*  604972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  604983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  604986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  604989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  605018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  605021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605040 */     GIR_RootConstrainSelectedInstOperands,
     /*  605041 */     // GIR_Coverage, 4854,
     /*  605041 */     GIR_EraseRootFromParent_Done,
     /*  605042 */   // Label 9789: @605042
     /*  605042 */   GIM_Try, /*On fail goto*//*Label 9790*/ GIMT_Encode4(605117), // Rule ID 4855 //
     /*  605047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  605058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  605061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  605064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605093 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  605093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  605096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605115 */     GIR_RootConstrainSelectedInstOperands,
     /*  605116 */     // GIR_Coverage, 4855,
     /*  605116 */     GIR_EraseRootFromParent_Done,
     /*  605117 */   // Label 9790: @605117
     /*  605117 */   GIM_Try, /*On fail goto*//*Label 9791*/ GIMT_Encode4(605192), // Rule ID 4858 //
     /*  605122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  605133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  605136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  605139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605168 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  605168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  605171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605190 */     GIR_RootConstrainSelectedInstOperands,
     /*  605191 */     // GIR_Coverage, 4858,
     /*  605191 */     GIR_EraseRootFromParent_Done,
     /*  605192 */   // Label 9791: @605192
     /*  605192 */   GIM_Try, /*On fail goto*//*Label 9792*/ GIMT_Encode4(605267), // Rule ID 4859 //
     /*  605197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  605208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  605211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  605214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605243 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  605243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  605246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605265 */     GIR_RootConstrainSelectedInstOperands,
     /*  605266 */     // GIR_Coverage, 4859,
     /*  605266 */     GIR_EraseRootFromParent_Done,
     /*  605267 */   // Label 9792: @605267
     /*  605267 */   GIM_Try, /*On fail goto*//*Label 9793*/ GIMT_Encode4(605342), // Rule ID 4862 //
     /*  605272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  605283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  605286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  605289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  605318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  605321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605340 */     GIR_RootConstrainSelectedInstOperands,
     /*  605341 */     // GIR_Coverage, 4862,
     /*  605341 */     GIR_EraseRootFromParent_Done,
     /*  605342 */   // Label 9793: @605342
     /*  605342 */   GIM_Try, /*On fail goto*//*Label 9794*/ GIMT_Encode4(605417), // Rule ID 4863 //
     /*  605347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  605358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  605361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  605364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  605393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  605396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605415 */     GIR_RootConstrainSelectedInstOperands,
     /*  605416 */     // GIR_Coverage, 4863,
     /*  605416 */     GIR_EraseRootFromParent_Done,
     /*  605417 */   // Label 9794: @605417
     /*  605417 */   GIM_Try, /*On fail goto*//*Label 9795*/ GIMT_Encode4(605492), // Rule ID 4866 //
     /*  605422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  605433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  605436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  605439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  605468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  605471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605490 */     GIR_RootConstrainSelectedInstOperands,
     /*  605491 */     // GIR_Coverage, 4866,
     /*  605491 */     GIR_EraseRootFromParent_Done,
     /*  605492 */   // Label 9795: @605492
     /*  605492 */   GIM_Try, /*On fail goto*//*Label 9796*/ GIMT_Encode4(605567), // Rule ID 4867 //
     /*  605497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  605508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  605511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  605514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  605543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  605546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605565 */     GIR_RootConstrainSelectedInstOperands,
     /*  605566 */     // GIR_Coverage, 4867,
     /*  605566 */     GIR_EraseRootFromParent_Done,
     /*  605567 */   // Label 9796: @605567
     /*  605567 */   GIM_Try, /*On fail goto*//*Label 9797*/ GIMT_Encode4(605642), // Rule ID 4870 //
     /*  605572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  605583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  605586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  605589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  605618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  605621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605640 */     GIR_RootConstrainSelectedInstOperands,
     /*  605641 */     // GIR_Coverage, 4870,
     /*  605641 */     GIR_EraseRootFromParent_Done,
     /*  605642 */   // Label 9797: @605642
     /*  605642 */   GIM_Try, /*On fail goto*//*Label 9798*/ GIMT_Encode4(605717), // Rule ID 4871 //
     /*  605647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  605658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  605661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  605664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605693 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  605693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  605696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605715 */     GIR_RootConstrainSelectedInstOperands,
     /*  605716 */     // GIR_Coverage, 4871,
     /*  605716 */     GIR_EraseRootFromParent_Done,
     /*  605717 */   // Label 9798: @605717
     /*  605717 */   GIM_Try, /*On fail goto*//*Label 9799*/ GIMT_Encode4(605792), // Rule ID 4874 //
     /*  605722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  605725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  605733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  605736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  605739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605768 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  605768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  605771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605790 */     GIR_RootConstrainSelectedInstOperands,
     /*  605791 */     // GIR_Coverage, 4874,
     /*  605791 */     GIR_EraseRootFromParent_Done,
     /*  605792 */   // Label 9799: @605792
     /*  605792 */   GIM_Try, /*On fail goto*//*Label 9800*/ GIMT_Encode4(605867), // Rule ID 4875 //
     /*  605797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  605800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  605808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  605811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  605814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605843 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  605843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  605846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605865 */     GIR_RootConstrainSelectedInstOperands,
     /*  605866 */     // GIR_Coverage, 4875,
     /*  605866 */     GIR_EraseRootFromParent_Done,
     /*  605867 */   // Label 9800: @605867
     /*  605867 */   GIM_Try, /*On fail goto*//*Label 9801*/ GIMT_Encode4(605942), // Rule ID 4878 //
     /*  605872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  605875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  605883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  605886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  605889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605918 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  605918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  605921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605940 */     GIR_RootConstrainSelectedInstOperands,
     /*  605941 */     // GIR_Coverage, 4878,
     /*  605941 */     GIR_EraseRootFromParent_Done,
     /*  605942 */   // Label 9801: @605942
     /*  605942 */   GIM_Try, /*On fail goto*//*Label 9802*/ GIMT_Encode4(606017), // Rule ID 4879 //
     /*  605947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  605950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  605958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  605961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  605964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  605993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  605996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606015 */     GIR_RootConstrainSelectedInstOperands,
     /*  606016 */     // GIR_Coverage, 4879,
     /*  606016 */     GIR_EraseRootFromParent_Done,
     /*  606017 */   // Label 9802: @606017
     /*  606017 */   GIM_Try, /*On fail goto*//*Label 9803*/ GIMT_Encode4(606092), // Rule ID 4882 //
     /*  606022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  606025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  606030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  606033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  606036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  606039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  606042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606068 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  606068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  606071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606090 */     GIR_RootConstrainSelectedInstOperands,
     /*  606091 */     // GIR_Coverage, 4882,
     /*  606091 */     GIR_EraseRootFromParent_Done,
     /*  606092 */   // Label 9803: @606092
     /*  606092 */   GIM_Try, /*On fail goto*//*Label 9804*/ GIMT_Encode4(606167), // Rule ID 4883 //
     /*  606097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  606100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  606105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  606108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  606111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  606114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  606117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606143 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  606143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  606146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606165 */     GIR_RootConstrainSelectedInstOperands,
     /*  606166 */     // GIR_Coverage, 4883,
     /*  606166 */     GIR_EraseRootFromParent_Done,
     /*  606167 */   // Label 9804: @606167
     /*  606167 */   GIM_Try, /*On fail goto*//*Label 9805*/ GIMT_Encode4(606242), // Rule ID 4886 //
     /*  606172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  606175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  606180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  606183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  606186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  606189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  606192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606218 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  606218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  606221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606240 */     GIR_RootConstrainSelectedInstOperands,
     /*  606241 */     // GIR_Coverage, 4886,
     /*  606241 */     GIR_EraseRootFromParent_Done,
     /*  606242 */   // Label 9805: @606242
     /*  606242 */   GIM_Try, /*On fail goto*//*Label 9806*/ GIMT_Encode4(606317), // Rule ID 4887 //
     /*  606247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  606250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  606255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  606258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  606261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  606264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  606267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606293 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  606293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  606296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606315 */     GIR_RootConstrainSelectedInstOperands,
     /*  606316 */     // GIR_Coverage, 4887,
     /*  606316 */     GIR_EraseRootFromParent_Done,
     /*  606317 */   // Label 9806: @606317
     /*  606317 */   GIM_Try, /*On fail goto*//*Label 9807*/ GIMT_Encode4(606389), // Rule ID 5240 //
     /*  606322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  606336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  606339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  606371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606387 */     GIR_RootConstrainSelectedInstOperands,
     /*  606388 */     // GIR_Coverage, 5240,
     /*  606388 */     GIR_EraseRootFromParent_Done,
     /*  606389 */   // Label 9807: @606389
     /*  606389 */   GIM_Try, /*On fail goto*//*Label 9808*/ GIMT_Encode4(606461), // Rule ID 5241 //
     /*  606394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  606408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  606411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606440 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  606443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606459 */     GIR_RootConstrainSelectedInstOperands,
     /*  606460 */     // GIR_Coverage, 5241,
     /*  606460 */     GIR_EraseRootFromParent_Done,
     /*  606461 */   // Label 9808: @606461
     /*  606461 */   GIM_Try, /*On fail goto*//*Label 9809*/ GIMT_Encode4(606533), // Rule ID 5242 //
     /*  606466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  606480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  606483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  606515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606531 */     GIR_RootConstrainSelectedInstOperands,
     /*  606532 */     // GIR_Coverage, 5242,
     /*  606532 */     GIR_EraseRootFromParent_Done,
     /*  606533 */   // Label 9809: @606533
     /*  606533 */   GIM_Try, /*On fail goto*//*Label 9810*/ GIMT_Encode4(606605), // Rule ID 5243 //
     /*  606538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  606552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  606555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606584 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  606587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606603 */     GIR_RootConstrainSelectedInstOperands,
     /*  606604 */     // GIR_Coverage, 5243,
     /*  606604 */     GIR_EraseRootFromParent_Done,
     /*  606605 */   // Label 9810: @606605
     /*  606605 */   GIM_Try, /*On fail goto*//*Label 9811*/ GIMT_Encode4(606677), // Rule ID 5244 //
     /*  606610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  606624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  606627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606656 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  606659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606675 */     GIR_RootConstrainSelectedInstOperands,
     /*  606676 */     // GIR_Coverage, 5244,
     /*  606676 */     GIR_EraseRootFromParent_Done,
     /*  606677 */   // Label 9811: @606677
     /*  606677 */   GIM_Try, /*On fail goto*//*Label 9812*/ GIMT_Encode4(606749), // Rule ID 5245 //
     /*  606682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  606696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  606699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606728 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  606731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606747 */     GIR_RootConstrainSelectedInstOperands,
     /*  606748 */     // GIR_Coverage, 5245,
     /*  606748 */     GIR_EraseRootFromParent_Done,
     /*  606749 */   // Label 9812: @606749
     /*  606749 */   GIM_Try, /*On fail goto*//*Label 9813*/ GIMT_Encode4(606821), // Rule ID 5246 //
     /*  606754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  606768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  606771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606800 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  606803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606819 */     GIR_RootConstrainSelectedInstOperands,
     /*  606820 */     // GIR_Coverage, 5246,
     /*  606820 */     GIR_EraseRootFromParent_Done,
     /*  606821 */   // Label 9813: @606821
     /*  606821 */   GIM_Try, /*On fail goto*//*Label 9814*/ GIMT_Encode4(606893), // Rule ID 5247 //
     /*  606826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  606840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  606843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  606875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606891 */     GIR_RootConstrainSelectedInstOperands,
     /*  606892 */     // GIR_Coverage, 5247,
     /*  606892 */     GIR_EraseRootFromParent_Done,
     /*  606893 */   // Label 9814: @606893
     /*  606893 */   GIM_Try, /*On fail goto*//*Label 9815*/ GIMT_Encode4(606965), // Rule ID 5248 //
     /*  606898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  606912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  606915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606944 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  606944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  606947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606963 */     GIR_RootConstrainSelectedInstOperands,
     /*  606964 */     // GIR_Coverage, 5248,
     /*  606964 */     GIR_EraseRootFromParent_Done,
     /*  606965 */   // Label 9815: @606965
     /*  606965 */   GIM_Try, /*On fail goto*//*Label 9816*/ GIMT_Encode4(607037), // Rule ID 5249 //
     /*  606970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  606984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  606987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607016 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  607016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  607019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607035 */     GIR_RootConstrainSelectedInstOperands,
     /*  607036 */     // GIR_Coverage, 5249,
     /*  607036 */     GIR_EraseRootFromParent_Done,
     /*  607037 */   // Label 9816: @607037
     /*  607037 */   GIM_Try, /*On fail goto*//*Label 9817*/ GIMT_Encode4(607109), // Rule ID 5250 //
     /*  607042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  607056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  607059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607088 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607107 */     GIR_RootConstrainSelectedInstOperands,
     /*  607108 */     // GIR_Coverage, 5250,
     /*  607108 */     GIR_EraseRootFromParent_Done,
     /*  607109 */   // Label 9817: @607109
     /*  607109 */   GIM_Try, /*On fail goto*//*Label 9818*/ GIMT_Encode4(607181), // Rule ID 5251 //
     /*  607114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  607128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  607131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607160 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607179 */     GIR_RootConstrainSelectedInstOperands,
     /*  607180 */     // GIR_Coverage, 5251,
     /*  607180 */     GIR_EraseRootFromParent_Done,
     /*  607181 */   // Label 9818: @607181
     /*  607181 */   GIM_Try, /*On fail goto*//*Label 9819*/ GIMT_Encode4(607253), // Rule ID 5252 //
     /*  607186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  607200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  607203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607232 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607251 */     GIR_RootConstrainSelectedInstOperands,
     /*  607252 */     // GIR_Coverage, 5252,
     /*  607252 */     GIR_EraseRootFromParent_Done,
     /*  607253 */   // Label 9819: @607253
     /*  607253 */   GIM_Try, /*On fail goto*//*Label 9820*/ GIMT_Encode4(607325), // Rule ID 5253 //
     /*  607258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  607272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  607275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607304 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607323 */     GIR_RootConstrainSelectedInstOperands,
     /*  607324 */     // GIR_Coverage, 5253,
     /*  607324 */     GIR_EraseRootFromParent_Done,
     /*  607325 */   // Label 9820: @607325
     /*  607325 */   GIM_Try, /*On fail goto*//*Label 9821*/ GIMT_Encode4(607397), // Rule ID 5254 //
     /*  607330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  607341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  607344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  607347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  607350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  607376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607395 */     GIR_RootConstrainSelectedInstOperands,
     /*  607396 */     // GIR_Coverage, 5254,
     /*  607396 */     GIR_EraseRootFromParent_Done,
     /*  607397 */   // Label 9821: @607397
     /*  607397 */   GIM_Try, /*On fail goto*//*Label 9822*/ GIMT_Encode4(607469), // Rule ID 5255 //
     /*  607402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  607413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  607416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  607419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  607422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607448 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  607448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607467 */     GIR_RootConstrainSelectedInstOperands,
     /*  607468 */     // GIR_Coverage, 5255,
     /*  607468 */     GIR_EraseRootFromParent_Done,
     /*  607469 */   // Label 9822: @607469
     /*  607469 */   GIM_Try, /*On fail goto*//*Label 9823*/ GIMT_Encode4(607541), // Rule ID 5256 //
     /*  607474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  607477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  607485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  607488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  607491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  607494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607520 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  607520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  607539 */     GIR_RootConstrainSelectedInstOperands,
     /*  607540 */     // GIR_Coverage, 5256,
     /*  607540 */     GIR_EraseRootFromParent_Done,
     /*  607541 */   // Label 9823: @607541
     /*  607541 */   GIM_Try, /*On fail goto*//*Label 9824*/ GIMT_Encode4(607613), // Rule ID 5257 //
     /*  607546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  607549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  607557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  607560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  607563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  607566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607592 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  607592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  607611 */     GIR_RootConstrainSelectedInstOperands,
     /*  607612 */     // GIR_Coverage, 5257,
     /*  607612 */     GIR_EraseRootFromParent_Done,
     /*  607613 */   // Label 9824: @607613
     /*  607613 */   GIM_Try, /*On fail goto*//*Label 9825*/ GIMT_Encode4(607685), // Rule ID 5258 //
     /*  607618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  607632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  607635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607664 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  607667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607683 */     GIR_RootConstrainSelectedInstOperands,
     /*  607684 */     // GIR_Coverage, 5258,
     /*  607684 */     GIR_EraseRootFromParent_Done,
     /*  607685 */   // Label 9825: @607685
     /*  607685 */   GIM_Try, /*On fail goto*//*Label 9826*/ GIMT_Encode4(607757), // Rule ID 5259 //
     /*  607690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  607704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  607707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607736 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  607739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607755 */     GIR_RootConstrainSelectedInstOperands,
     /*  607756 */     // GIR_Coverage, 5259,
     /*  607756 */     GIR_EraseRootFromParent_Done,
     /*  607757 */   // Label 9826: @607757
     /*  607757 */   GIM_Try, /*On fail goto*//*Label 9827*/ GIMT_Encode4(607829), // Rule ID 5260 //
     /*  607762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  607776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  607779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607808 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  607811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607827 */     GIR_RootConstrainSelectedInstOperands,
     /*  607828 */     // GIR_Coverage, 5260,
     /*  607828 */     GIR_EraseRootFromParent_Done,
     /*  607829 */   // Label 9827: @607829
     /*  607829 */   GIM_Try, /*On fail goto*//*Label 9828*/ GIMT_Encode4(607901), // Rule ID 5261 //
     /*  607834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  607848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  607851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607880 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  607883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607899 */     GIR_RootConstrainSelectedInstOperands,
     /*  607900 */     // GIR_Coverage, 5261,
     /*  607900 */     GIR_EraseRootFromParent_Done,
     /*  607901 */   // Label 9828: @607901
     /*  607901 */   GIM_Try, /*On fail goto*//*Label 9829*/ GIMT_Encode4(607973), // Rule ID 5262 //
     /*  607906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  607917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  607920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  607923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  607926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607952 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  607955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607971 */     GIR_RootConstrainSelectedInstOperands,
     /*  607972 */     // GIR_Coverage, 5262,
     /*  607972 */     GIR_EraseRootFromParent_Done,
     /*  607973 */   // Label 9829: @607973
     /*  607973 */   GIM_Try, /*On fail goto*//*Label 9830*/ GIMT_Encode4(608045), // Rule ID 5263 //
     /*  607978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  607989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  607992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  607995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  607998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608024 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  608024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  608027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608043 */     GIR_RootConstrainSelectedInstOperands,
     /*  608044 */     // GIR_Coverage, 5263,
     /*  608044 */     GIR_EraseRootFromParent_Done,
     /*  608045 */   // Label 9830: @608045
     /*  608045 */   GIM_Try, /*On fail goto*//*Label 9831*/ GIMT_Encode4(608117), // Rule ID 5264 //
     /*  608050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  608064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  608067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608096 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  608096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  608099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608115 */     GIR_RootConstrainSelectedInstOperands,
     /*  608116 */     // GIR_Coverage, 5264,
     /*  608116 */     GIR_EraseRootFromParent_Done,
     /*  608117 */   // Label 9831: @608117
     /*  608117 */   GIM_Try, /*On fail goto*//*Label 9832*/ GIMT_Encode4(608189), // Rule ID 5265 //
     /*  608122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  608136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  608139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608168 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  608168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  608171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608187 */     GIR_RootConstrainSelectedInstOperands,
     /*  608188 */     // GIR_Coverage, 5265,
     /*  608188 */     GIR_EraseRootFromParent_Done,
     /*  608189 */   // Label 9832: @608189
     /*  608189 */   GIM_Try, /*On fail goto*//*Label 9833*/ GIMT_Encode4(608261), // Rule ID 5266 //
     /*  608194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  608208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  608211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608240 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  608240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  608243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608259 */     GIR_RootConstrainSelectedInstOperands,
     /*  608260 */     // GIR_Coverage, 5266,
     /*  608260 */     GIR_EraseRootFromParent_Done,
     /*  608261 */   // Label 9833: @608261
     /*  608261 */   GIM_Try, /*On fail goto*//*Label 9834*/ GIMT_Encode4(608333), // Rule ID 5267 //
     /*  608266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  608280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  608283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608312 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  608312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  608315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608331 */     GIR_RootConstrainSelectedInstOperands,
     /*  608332 */     // GIR_Coverage, 5267,
     /*  608332 */     GIR_EraseRootFromParent_Done,
     /*  608333 */   // Label 9834: @608333
     /*  608333 */   GIM_Try, /*On fail goto*//*Label 9835*/ GIMT_Encode4(608405), // Rule ID 5268 //
     /*  608338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  608349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  608352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  608355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  608358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608384 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  608384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  608387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608403 */     GIR_RootConstrainSelectedInstOperands,
     /*  608404 */     // GIR_Coverage, 5268,
     /*  608404 */     GIR_EraseRootFromParent_Done,
     /*  608405 */   // Label 9835: @608405
     /*  608405 */   GIM_Try, /*On fail goto*//*Label 9836*/ GIMT_Encode4(608477), // Rule ID 5269 //
     /*  608410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  608421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  608424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  608427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  608430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608456 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  608456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  608459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608475 */     GIR_RootConstrainSelectedInstOperands,
     /*  608476 */     // GIR_Coverage, 5269,
     /*  608476 */     GIR_EraseRootFromParent_Done,
     /*  608477 */   // Label 9836: @608477
     /*  608477 */   GIM_Try, /*On fail goto*//*Label 9837*/ GIMT_Encode4(608549), // Rule ID 5270 //
     /*  608482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  608496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  608499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608528 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  608531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608547 */     GIR_RootConstrainSelectedInstOperands,
     /*  608548 */     // GIR_Coverage, 5270,
     /*  608548 */     GIR_EraseRootFromParent_Done,
     /*  608549 */   // Label 9837: @608549
     /*  608549 */   GIM_Try, /*On fail goto*//*Label 9838*/ GIMT_Encode4(608621), // Rule ID 5271 //
     /*  608554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  608568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  608571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608600 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  608603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608619 */     GIR_RootConstrainSelectedInstOperands,
     /*  608620 */     // GIR_Coverage, 5271,
     /*  608620 */     GIR_EraseRootFromParent_Done,
     /*  608621 */   // Label 9838: @608621
     /*  608621 */   GIM_Try, /*On fail goto*//*Label 9839*/ GIMT_Encode4(608693), // Rule ID 5272 //
     /*  608626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  608640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  608643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  608675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608691 */     GIR_RootConstrainSelectedInstOperands,
     /*  608692 */     // GIR_Coverage, 5272,
     /*  608692 */     GIR_EraseRootFromParent_Done,
     /*  608693 */   // Label 9839: @608693
     /*  608693 */   GIM_Try, /*On fail goto*//*Label 9840*/ GIMT_Encode4(608765), // Rule ID 5273 //
     /*  608698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  608712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  608715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608744 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  608747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608763 */     GIR_RootConstrainSelectedInstOperands,
     /*  608764 */     // GIR_Coverage, 5273,
     /*  608764 */     GIR_EraseRootFromParent_Done,
     /*  608765 */   // Label 9840: @608765
     /*  608765 */   GIM_Try, /*On fail goto*//*Label 9841*/ GIMT_Encode4(608837), // Rule ID 5274 //
     /*  608770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  608784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  608787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608816 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  608819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608835 */     GIR_RootConstrainSelectedInstOperands,
     /*  608836 */     // GIR_Coverage, 5274,
     /*  608836 */     GIR_EraseRootFromParent_Done,
     /*  608837 */   // Label 9841: @608837
     /*  608837 */   GIM_Try, /*On fail goto*//*Label 9842*/ GIMT_Encode4(608909), // Rule ID 5275 //
     /*  608842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  608856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  608859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608888 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  608891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608907 */     GIR_RootConstrainSelectedInstOperands,
     /*  608908 */     // GIR_Coverage, 5275,
     /*  608908 */     GIR_EraseRootFromParent_Done,
     /*  608909 */   // Label 9842: @608909
     /*  608909 */   GIM_Try, /*On fail goto*//*Label 9843*/ GIMT_Encode4(608981), // Rule ID 5276 //
     /*  608914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  608928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  608931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608960 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  608960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  608963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608979 */     GIR_RootConstrainSelectedInstOperands,
     /*  608980 */     // GIR_Coverage, 5276,
     /*  608980 */     GIR_EraseRootFromParent_Done,
     /*  608981 */   // Label 9843: @608981
     /*  608981 */   GIM_Try, /*On fail goto*//*Label 9844*/ GIMT_Encode4(609053), // Rule ID 5277 //
     /*  608986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  608989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  609000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  609003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609032 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  609032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  609035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609051 */     GIR_RootConstrainSelectedInstOperands,
     /*  609052 */     // GIR_Coverage, 5277,
     /*  609052 */     GIR_EraseRootFromParent_Done,
     /*  609053 */   // Label 9844: @609053
     /*  609053 */   GIM_Try, /*On fail goto*//*Label 9845*/ GIMT_Encode4(609125), // Rule ID 5278 //
     /*  609058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  609061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  609072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  609075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609104 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  609104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  609107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609123 */     GIR_RootConstrainSelectedInstOperands,
     /*  609124 */     // GIR_Coverage, 5278,
     /*  609124 */     GIR_EraseRootFromParent_Done,
     /*  609125 */   // Label 9845: @609125
     /*  609125 */   GIM_Try, /*On fail goto*//*Label 9846*/ GIMT_Encode4(609197), // Rule ID 5279 //
     /*  609130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  609133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  609144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  609147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  609176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  609179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609195 */     GIR_RootConstrainSelectedInstOperands,
     /*  609196 */     // GIR_Coverage, 5279,
     /*  609196 */     GIR_EraseRootFromParent_Done,
     /*  609197 */   // Label 9846: @609197
     /*  609197 */   GIM_Try, /*On fail goto*//*Label 9847*/ GIMT_Encode4(609269), // Rule ID 5280 //
     /*  609202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  609205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  609216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  609219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  609248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  609251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609267 */     GIR_RootConstrainSelectedInstOperands,
     /*  609268 */     // GIR_Coverage, 5280,
     /*  609268 */     GIR_EraseRootFromParent_Done,
     /*  609269 */   // Label 9847: @609269
     /*  609269 */   GIM_Try, /*On fail goto*//*Label 9848*/ GIMT_Encode4(609341), // Rule ID 5281 //
     /*  609274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  609277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  609288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  609291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609320 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  609320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  609323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609339 */     GIR_RootConstrainSelectedInstOperands,
     /*  609340 */     // GIR_Coverage, 5281,
     /*  609340 */     GIR_EraseRootFromParent_Done,
     /*  609341 */   // Label 9848: @609341
     /*  609341 */   GIM_Try, /*On fail goto*//*Label 9849*/ GIMT_Encode4(609413), // Rule ID 5282 //
     /*  609346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  609360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  609363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  609395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609411 */     GIR_RootConstrainSelectedInstOperands,
     /*  609412 */     // GIR_Coverage, 5282,
     /*  609412 */     GIR_EraseRootFromParent_Done,
     /*  609413 */   // Label 9849: @609413
     /*  609413 */   GIM_Try, /*On fail goto*//*Label 9850*/ GIMT_Encode4(609485), // Rule ID 5283 //
     /*  609418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  609432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  609435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609464 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  609467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609483 */     GIR_RootConstrainSelectedInstOperands,
     /*  609484 */     // GIR_Coverage, 5283,
     /*  609484 */     GIR_EraseRootFromParent_Done,
     /*  609485 */   // Label 9850: @609485
     /*  609485 */   GIM_Try, /*On fail goto*//*Label 9851*/ GIMT_Encode4(609557), // Rule ID 5284 //
     /*  609490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  609504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  609507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609536 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  609539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609555 */     GIR_RootConstrainSelectedInstOperands,
     /*  609556 */     // GIR_Coverage, 5284,
     /*  609556 */     GIR_EraseRootFromParent_Done,
     /*  609557 */   // Label 9851: @609557
     /*  609557 */   GIM_Try, /*On fail goto*//*Label 9852*/ GIMT_Encode4(609629), // Rule ID 5285 //
     /*  609562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  609576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  609579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609608 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  609611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609627 */     GIR_RootConstrainSelectedInstOperands,
     /*  609628 */     // GIR_Coverage, 5285,
     /*  609628 */     GIR_EraseRootFromParent_Done,
     /*  609629 */   // Label 9852: @609629
     /*  609629 */   GIM_Try, /*On fail goto*//*Label 9853*/ GIMT_Encode4(609701), // Rule ID 5286 //
     /*  609634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  609648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  609651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  609683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609699 */     GIR_RootConstrainSelectedInstOperands,
     /*  609700 */     // GIR_Coverage, 5286,
     /*  609700 */     GIR_EraseRootFromParent_Done,
     /*  609701 */   // Label 9853: @609701
     /*  609701 */   GIM_Try, /*On fail goto*//*Label 9854*/ GIMT_Encode4(609773), // Rule ID 5287 //
     /*  609706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  609720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  609723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609752 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  609755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609771 */     GIR_RootConstrainSelectedInstOperands,
     /*  609772 */     // GIR_Coverage, 5287,
     /*  609772 */     GIR_EraseRootFromParent_Done,
     /*  609773 */   // Label 9854: @609773
     /*  609773 */   GIM_Try, /*On fail goto*//*Label 9855*/ GIMT_Encode4(609845), // Rule ID 5288 //
     /*  609778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  609792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  609795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609824 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  609827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609843 */     GIR_RootConstrainSelectedInstOperands,
     /*  609844 */     // GIR_Coverage, 5288,
     /*  609844 */     GIR_EraseRootFromParent_Done,
     /*  609845 */   // Label 9855: @609845
     /*  609845 */   GIM_Try, /*On fail goto*//*Label 9856*/ GIMT_Encode4(609917), // Rule ID 5289 //
     /*  609850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  609864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  609867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609896 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  609896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  609899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609915 */     GIR_RootConstrainSelectedInstOperands,
     /*  609916 */     // GIR_Coverage, 5289,
     /*  609916 */     GIR_EraseRootFromParent_Done,
     /*  609917 */   // Label 9856: @609917
     /*  609917 */   GIM_Try, /*On fail goto*//*Label 9857*/ GIMT_Encode4(609989), // Rule ID 5290 //
     /*  609922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  609936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  609939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609968 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  609971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609987 */     GIR_RootConstrainSelectedInstOperands,
     /*  609988 */     // GIR_Coverage, 5290,
     /*  609988 */     GIR_EraseRootFromParent_Done,
     /*  609989 */   // Label 9857: @609989
     /*  609989 */   GIM_Try, /*On fail goto*//*Label 9858*/ GIMT_Encode4(610061), // Rule ID 5291 //
     /*  609994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  610005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  610008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  610014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610040 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  610043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610059 */     GIR_RootConstrainSelectedInstOperands,
     /*  610060 */     // GIR_Coverage, 5291,
     /*  610060 */     GIR_EraseRootFromParent_Done,
     /*  610061 */   // Label 9858: @610061
     /*  610061 */   GIM_Try, /*On fail goto*//*Label 9859*/ GIMT_Encode4(610133), // Rule ID 5292 //
     /*  610066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  610080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610112 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  610112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  610115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610131 */     GIR_RootConstrainSelectedInstOperands,
     /*  610132 */     // GIR_Coverage, 5292,
     /*  610132 */     GIR_EraseRootFromParent_Done,
     /*  610133 */   // Label 9859: @610133
     /*  610133 */   GIM_Try, /*On fail goto*//*Label 9860*/ GIMT_Encode4(610205), // Rule ID 5293 //
     /*  610138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  610152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610184 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  610184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  610187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610203 */     GIR_RootConstrainSelectedInstOperands,
     /*  610204 */     // GIR_Coverage, 5293,
     /*  610204 */     GIR_EraseRootFromParent_Done,
     /*  610205 */   // Label 9860: @610205
     /*  610205 */   GIM_Try, /*On fail goto*//*Label 9861*/ GIMT_Encode4(610277), // Rule ID 5294 //
     /*  610210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  610224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610256 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610275 */     GIR_RootConstrainSelectedInstOperands,
     /*  610276 */     // GIR_Coverage, 5294,
     /*  610276 */     GIR_EraseRootFromParent_Done,
     /*  610277 */   // Label 9861: @610277
     /*  610277 */   GIM_Try, /*On fail goto*//*Label 9862*/ GIMT_Encode4(610349), // Rule ID 5295 //
     /*  610282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  610296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610328 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610347 */     GIR_RootConstrainSelectedInstOperands,
     /*  610348 */     // GIR_Coverage, 5295,
     /*  610348 */     GIR_EraseRootFromParent_Done,
     /*  610349 */   // Label 9862: @610349
     /*  610349 */   GIM_Try, /*On fail goto*//*Label 9863*/ GIMT_Encode4(610421), // Rule ID 5296 //
     /*  610354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  610365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  610368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  610374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610400 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  610400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610419 */     GIR_RootConstrainSelectedInstOperands,
     /*  610420 */     // GIR_Coverage, 5296,
     /*  610420 */     GIR_EraseRootFromParent_Done,
     /*  610421 */   // Label 9863: @610421
     /*  610421 */   GIM_Try, /*On fail goto*//*Label 9864*/ GIMT_Encode4(610493), // Rule ID 5297 //
     /*  610426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  610437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  610440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  610446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610472 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610491 */     GIR_RootConstrainSelectedInstOperands,
     /*  610492 */     // GIR_Coverage, 5297,
     /*  610492 */     GIR_EraseRootFromParent_Done,
     /*  610493 */   // Label 9864: @610493
     /*  610493 */   GIM_Try, /*On fail goto*//*Label 9865*/ GIMT_Encode4(610565), // Rule ID 5298 //
     /*  610498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  610509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  610512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  610518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  610544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610563 */     GIR_RootConstrainSelectedInstOperands,
     /*  610564 */     // GIR_Coverage, 5298,
     /*  610564 */     GIR_EraseRootFromParent_Done,
     /*  610565 */   // Label 9865: @610565
     /*  610565 */   GIM_Try, /*On fail goto*//*Label 9866*/ GIMT_Encode4(610637), // Rule ID 5299 //
     /*  610570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  610581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  610584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  610590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610616 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  610616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610635 */     GIR_RootConstrainSelectedInstOperands,
     /*  610636 */     // GIR_Coverage, 5299,
     /*  610636 */     GIR_EraseRootFromParent_Done,
     /*  610637 */   // Label 9866: @610637
     /*  610637 */   GIM_Try, /*On fail goto*//*Label 9867*/ GIMT_Encode4(610709), // Rule ID 5300 //
     /*  610642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  610645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  610656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  610688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  610707 */     GIR_RootConstrainSelectedInstOperands,
     /*  610708 */     // GIR_Coverage, 5300,
     /*  610708 */     GIR_EraseRootFromParent_Done,
     /*  610709 */   // Label 9867: @610709
     /*  610709 */   GIM_Try, /*On fail goto*//*Label 9868*/ GIMT_Encode4(610781), // Rule ID 5301 //
     /*  610714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  610717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  610728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610760 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  610760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  610779 */     GIR_RootConstrainSelectedInstOperands,
     /*  610780 */     // GIR_Coverage, 5301,
     /*  610780 */     GIR_EraseRootFromParent_Done,
     /*  610781 */   // Label 9868: @610781
     /*  610781 */   GIM_Try, /*On fail goto*//*Label 9869*/ GIMT_Encode4(610853), // Rule ID 5302 //
     /*  610786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  610800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610832 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  610835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610851 */     GIR_RootConstrainSelectedInstOperands,
     /*  610852 */     // GIR_Coverage, 5302,
     /*  610852 */     GIR_EraseRootFromParent_Done,
     /*  610853 */   // Label 9869: @610853
     /*  610853 */   GIM_Try, /*On fail goto*//*Label 9870*/ GIMT_Encode4(610925), // Rule ID 5303 //
     /*  610858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  610872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610904 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  610907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610923 */     GIR_RootConstrainSelectedInstOperands,
     /*  610924 */     // GIR_Coverage, 5303,
     /*  610924 */     GIR_EraseRootFromParent_Done,
     /*  610925 */   // Label 9870: @610925
     /*  610925 */   GIM_Try, /*On fail goto*//*Label 9871*/ GIMT_Encode4(610997), // Rule ID 5304 //
     /*  610930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  610944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610976 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  610979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610995 */     GIR_RootConstrainSelectedInstOperands,
     /*  610996 */     // GIR_Coverage, 5304,
     /*  610996 */     GIR_EraseRootFromParent_Done,
     /*  610997 */   // Label 9871: @610997
     /*  610997 */   GIM_Try, /*On fail goto*//*Label 9872*/ GIMT_Encode4(611069), // Rule ID 5305 //
     /*  611002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  611013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  611016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  611022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611048 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  611048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  611051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611067 */     GIR_RootConstrainSelectedInstOperands,
     /*  611068 */     // GIR_Coverage, 5305,
     /*  611068 */     GIR_EraseRootFromParent_Done,
     /*  611069 */   // Label 9872: @611069
     /*  611069 */   GIM_Try, /*On fail goto*//*Label 9873*/ GIMT_Encode4(611141), // Rule ID 5306 //
     /*  611074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  611085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  611088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  611094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611120 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  611120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  611123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611139 */     GIR_RootConstrainSelectedInstOperands,
     /*  611140 */     // GIR_Coverage, 5306,
     /*  611140 */     GIR_EraseRootFromParent_Done,
     /*  611141 */   // Label 9873: @611141
     /*  611141 */   GIM_Try, /*On fail goto*//*Label 9874*/ GIMT_Encode4(611213), // Rule ID 5307 //
     /*  611146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  611157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  611160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  611166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611192 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  611192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  611195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611211 */     GIR_RootConstrainSelectedInstOperands,
     /*  611212 */     // GIR_Coverage, 5307,
     /*  611212 */     GIR_EraseRootFromParent_Done,
     /*  611213 */   // Label 9874: @611213
     /*  611213 */   GIM_Try, /*On fail goto*//*Label 9875*/ GIMT_Encode4(611285), // Rule ID 5308 //
     /*  611218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  611232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  611267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611283 */     GIR_RootConstrainSelectedInstOperands,
     /*  611284 */     // GIR_Coverage, 5308,
     /*  611284 */     GIR_EraseRootFromParent_Done,
     /*  611285 */   // Label 9875: @611285
     /*  611285 */   GIM_Try, /*On fail goto*//*Label 9876*/ GIMT_Encode4(611357), // Rule ID 5309 //
     /*  611290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  611304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611336 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  611336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  611339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611355 */     GIR_RootConstrainSelectedInstOperands,
     /*  611356 */     // GIR_Coverage, 5309,
     /*  611356 */     GIR_EraseRootFromParent_Done,
     /*  611357 */   // Label 9876: @611357
     /*  611357 */   GIM_Try, /*On fail goto*//*Label 9877*/ GIMT_Encode4(611429), // Rule ID 5310 //
     /*  611362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  611376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611408 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  611411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611427 */     GIR_RootConstrainSelectedInstOperands,
     /*  611428 */     // GIR_Coverage, 5310,
     /*  611428 */     GIR_EraseRootFromParent_Done,
     /*  611429 */   // Label 9877: @611429
     /*  611429 */   GIM_Try, /*On fail goto*//*Label 9878*/ GIMT_Encode4(611501), // Rule ID 5311 //
     /*  611434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  611448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611480 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  611480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  611483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611499 */     GIR_RootConstrainSelectedInstOperands,
     /*  611500 */     // GIR_Coverage, 5311,
     /*  611500 */     GIR_EraseRootFromParent_Done,
     /*  611501 */   // Label 9878: @611501
     /*  611501 */   GIM_Try, /*On fail goto*//*Label 9879*/ GIMT_Encode4(611573), // Rule ID 5312 //
     /*  611506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  611517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  611520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  611526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611552 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  611555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611571 */     GIR_RootConstrainSelectedInstOperands,
     /*  611572 */     // GIR_Coverage, 5312,
     /*  611572 */     GIR_EraseRootFromParent_Done,
     /*  611573 */   // Label 9879: @611573
     /*  611573 */   GIM_Try, /*On fail goto*//*Label 9880*/ GIMT_Encode4(611645), // Rule ID 5313 //
     /*  611578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  611589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  611592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  611598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611624 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  611624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  611627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611643 */     GIR_RootConstrainSelectedInstOperands,
     /*  611644 */     // GIR_Coverage, 5313,
     /*  611644 */     GIR_EraseRootFromParent_Done,
     /*  611645 */   // Label 9880: @611645
     /*  611645 */   GIM_Try, /*On fail goto*//*Label 9881*/ GIMT_Encode4(611717), // Rule ID 5314 //
     /*  611650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  611664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611696 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  611699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611715 */     GIR_RootConstrainSelectedInstOperands,
     /*  611716 */     // GIR_Coverage, 5314,
     /*  611716 */     GIR_EraseRootFromParent_Done,
     /*  611717 */   // Label 9881: @611717
     /*  611717 */   GIM_Try, /*On fail goto*//*Label 9882*/ GIMT_Encode4(611789), // Rule ID 5315 //
     /*  611722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  611736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611768 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  611771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611787 */     GIR_RootConstrainSelectedInstOperands,
     /*  611788 */     // GIR_Coverage, 5315,
     /*  611788 */     GIR_EraseRootFromParent_Done,
     /*  611789 */   // Label 9882: @611789
     /*  611789 */   GIM_Try, /*On fail goto*//*Label 9883*/ GIMT_Encode4(611861), // Rule ID 5316 //
     /*  611794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  611808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611840 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  611843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611859 */     GIR_RootConstrainSelectedInstOperands,
     /*  611860 */     // GIR_Coverage, 5316,
     /*  611860 */     GIR_EraseRootFromParent_Done,
     /*  611861 */   // Label 9883: @611861
     /*  611861 */   GIM_Try, /*On fail goto*//*Label 9884*/ GIMT_Encode4(611933), // Rule ID 5317 //
     /*  611866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  611880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  611915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611931 */     GIR_RootConstrainSelectedInstOperands,
     /*  611932 */     // GIR_Coverage, 5317,
     /*  611932 */     GIR_EraseRootFromParent_Done,
     /*  611933 */   // Label 9884: @611933
     /*  611933 */   GIM_Try, /*On fail goto*//*Label 9885*/ GIMT_Encode4(612005), // Rule ID 5318 //
     /*  611938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  611952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611984 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  611987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612003 */     GIR_RootConstrainSelectedInstOperands,
     /*  612004 */     // GIR_Coverage, 5318,
     /*  612004 */     GIR_EraseRootFromParent_Done,
     /*  612005 */   // Label 9885: @612005
     /*  612005 */   GIM_Try, /*On fail goto*//*Label 9886*/ GIMT_Encode4(612077), // Rule ID 5319 //
     /*  612010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  612021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  612024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  612030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612056 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  612056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  612059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612075 */     GIR_RootConstrainSelectedInstOperands,
     /*  612076 */     // GIR_Coverage, 5319,
     /*  612076 */     GIR_EraseRootFromParent_Done,
     /*  612077 */   // Label 9886: @612077
     /*  612077 */   GIM_Try, /*On fail goto*//*Label 9887*/ GIMT_Encode4(612149), // Rule ID 5320 //
     /*  612082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  612085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  612096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612128 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  612128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  612131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612147 */     GIR_RootConstrainSelectedInstOperands,
     /*  612148 */     // GIR_Coverage, 5320,
     /*  612148 */     GIR_EraseRootFromParent_Done,
     /*  612149 */   // Label 9887: @612149
     /*  612149 */   GIM_Try, /*On fail goto*//*Label 9888*/ GIMT_Encode4(612221), // Rule ID 5321 //
     /*  612154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  612157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  612168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612200 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  612200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  612203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612219 */     GIR_RootConstrainSelectedInstOperands,
     /*  612220 */     // GIR_Coverage, 5321,
     /*  612220 */     GIR_EraseRootFromParent_Done,
     /*  612221 */   // Label 9888: @612221
     /*  612221 */   GIM_Try, /*On fail goto*//*Label 9889*/ GIMT_Encode4(612293), // Rule ID 5322 //
     /*  612226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  612229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  612240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612272 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  612272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  612275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612291 */     GIR_RootConstrainSelectedInstOperands,
     /*  612292 */     // GIR_Coverage, 5322,
     /*  612292 */     GIR_EraseRootFromParent_Done,
     /*  612293 */   // Label 9889: @612293
     /*  612293 */   GIM_Try, /*On fail goto*//*Label 9890*/ GIMT_Encode4(612365), // Rule ID 5323 //
     /*  612298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  612301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  612312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612344 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  612344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  612347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612363 */     GIR_RootConstrainSelectedInstOperands,
     /*  612364 */     // GIR_Coverage, 5323,
     /*  612364 */     GIR_EraseRootFromParent_Done,
     /*  612365 */   // Label 9890: @612365
     /*  612365 */   GIM_Try, /*On fail goto*//*Label 9891*/ GIMT_Encode4(612437), // Rule ID 5324 //
     /*  612370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  612373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  612384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612416 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  612416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  612419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612435 */     GIR_RootConstrainSelectedInstOperands,
     /*  612436 */     // GIR_Coverage, 5324,
     /*  612436 */     GIR_EraseRootFromParent_Done,
     /*  612437 */   // Label 9891: @612437
     /*  612437 */   GIM_Try, /*On fail goto*//*Label 9892*/ GIMT_Encode4(612509), // Rule ID 5325 //
     /*  612442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  612445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  612456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612488 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  612488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  612491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612507 */     GIR_RootConstrainSelectedInstOperands,
     /*  612508 */     // GIR_Coverage, 5325,
     /*  612508 */     GIR_EraseRootFromParent_Done,
     /*  612509 */   // Label 9892: @612509
     /*  612509 */   GIM_Try, /*On fail goto*//*Label 9893*/ GIMT_Encode4(612581), // Rule ID 5588 //
     /*  612514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  612528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  612531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612560 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  612563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612579 */     GIR_RootConstrainSelectedInstOperands,
     /*  612580 */     // GIR_Coverage, 5588,
     /*  612580 */     GIR_EraseRootFromParent_Done,
     /*  612581 */   // Label 9893: @612581
     /*  612581 */   GIM_Try, /*On fail goto*//*Label 9894*/ GIMT_Encode4(612653), // Rule ID 5589 //
     /*  612586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  612600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  612603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612632 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  612635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612651 */     GIR_RootConstrainSelectedInstOperands,
     /*  612652 */     // GIR_Coverage, 5589,
     /*  612652 */     GIR_EraseRootFromParent_Done,
     /*  612653 */   // Label 9894: @612653
     /*  612653 */   GIM_Try, /*On fail goto*//*Label 9895*/ GIMT_Encode4(612725), // Rule ID 5590 //
     /*  612658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  612672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  612675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  612707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612723 */     GIR_RootConstrainSelectedInstOperands,
     /*  612724 */     // GIR_Coverage, 5590,
     /*  612724 */     GIR_EraseRootFromParent_Done,
     /*  612725 */   // Label 9895: @612725
     /*  612725 */   GIM_Try, /*On fail goto*//*Label 9896*/ GIMT_Encode4(612797), // Rule ID 5591 //
     /*  612730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  612744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  612747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  612779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612795 */     GIR_RootConstrainSelectedInstOperands,
     /*  612796 */     // GIR_Coverage, 5591,
     /*  612796 */     GIR_EraseRootFromParent_Done,
     /*  612797 */   // Label 9896: @612797
     /*  612797 */   GIM_Try, /*On fail goto*//*Label 9897*/ GIMT_Encode4(612869), // Rule ID 5592 //
     /*  612802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  612816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  612819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612848 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  612851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612867 */     GIR_RootConstrainSelectedInstOperands,
     /*  612868 */     // GIR_Coverage, 5592,
     /*  612868 */     GIR_EraseRootFromParent_Done,
     /*  612869 */   // Label 9897: @612869
     /*  612869 */   GIM_Try, /*On fail goto*//*Label 9898*/ GIMT_Encode4(612941), // Rule ID 5593 //
     /*  612874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  612888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  612891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612920 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  612923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612939 */     GIR_RootConstrainSelectedInstOperands,
     /*  612940 */     // GIR_Coverage, 5593,
     /*  612940 */     GIR_EraseRootFromParent_Done,
     /*  612941 */   // Label 9898: @612941
     /*  612941 */   GIM_Try, /*On fail goto*//*Label 9899*/ GIMT_Encode4(613013), // Rule ID 5594 //
     /*  612946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  612960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  612963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612992 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  612992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  612995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613011 */     GIR_RootConstrainSelectedInstOperands,
     /*  613012 */     // GIR_Coverage, 5594,
     /*  613012 */     GIR_EraseRootFromParent_Done,
     /*  613013 */   // Label 9899: @613013
     /*  613013 */   GIM_Try, /*On fail goto*//*Label 9900*/ GIMT_Encode4(613085), // Rule ID 5595 //
     /*  613018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  613032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  613035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613064 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  613067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613083 */     GIR_RootConstrainSelectedInstOperands,
     /*  613084 */     // GIR_Coverage, 5595,
     /*  613084 */     GIR_EraseRootFromParent_Done,
     /*  613085 */   // Label 9900: @613085
     /*  613085 */   GIM_Try, /*On fail goto*//*Label 9901*/ GIMT_Encode4(613157), // Rule ID 5596 //
     /*  613090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  613104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  613107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613136 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  613136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  613139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613155 */     GIR_RootConstrainSelectedInstOperands,
     /*  613156 */     // GIR_Coverage, 5596,
     /*  613156 */     GIR_EraseRootFromParent_Done,
     /*  613157 */   // Label 9901: @613157
     /*  613157 */   GIM_Try, /*On fail goto*//*Label 9902*/ GIMT_Encode4(613229), // Rule ID 5597 //
     /*  613162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  613176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  613179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613208 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  613211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613227 */     GIR_RootConstrainSelectedInstOperands,
     /*  613228 */     // GIR_Coverage, 5597,
     /*  613228 */     GIR_EraseRootFromParent_Done,
     /*  613229 */   // Label 9902: @613229
     /*  613229 */   GIM_Try, /*On fail goto*//*Label 9903*/ GIMT_Encode4(613301), // Rule ID 5598 //
     /*  613234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  613248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  613251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  613280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  613283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613299 */     GIR_RootConstrainSelectedInstOperands,
     /*  613300 */     // GIR_Coverage, 5598,
     /*  613300 */     GIR_EraseRootFromParent_Done,
     /*  613301 */   // Label 9903: @613301
     /*  613301 */   GIM_Try, /*On fail goto*//*Label 9904*/ GIMT_Encode4(613373), // Rule ID 5599 //
     /*  613306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  613320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  613323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613352 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  613352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  613355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613371 */     GIR_RootConstrainSelectedInstOperands,
     /*  613372 */     // GIR_Coverage, 5599,
     /*  613372 */     GIR_EraseRootFromParent_Done,
     /*  613373 */   // Label 9904: @613373
     /*  613373 */   GIM_Try, /*On fail goto*//*Label 9905*/ GIMT_Encode4(613445), // Rule ID 5600 //
     /*  613378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  613392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  613395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613424 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613443 */     GIR_RootConstrainSelectedInstOperands,
     /*  613444 */     // GIR_Coverage, 5600,
     /*  613444 */     GIR_EraseRootFromParent_Done,
     /*  613445 */   // Label 9905: @613445
     /*  613445 */   GIM_Try, /*On fail goto*//*Label 9906*/ GIMT_Encode4(613517), // Rule ID 5601 //
     /*  613450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  613464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  613467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613496 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613515 */     GIR_RootConstrainSelectedInstOperands,
     /*  613516 */     // GIR_Coverage, 5601,
     /*  613516 */     GIR_EraseRootFromParent_Done,
     /*  613517 */   // Label 9906: @613517
     /*  613517 */   GIM_Try, /*On fail goto*//*Label 9907*/ GIMT_Encode4(613589), // Rule ID 5602 //
     /*  613522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  613533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  613536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  613539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  613542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613568 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  613568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613587 */     GIR_RootConstrainSelectedInstOperands,
     /*  613588 */     // GIR_Coverage, 5602,
     /*  613588 */     GIR_EraseRootFromParent_Done,
     /*  613589 */   // Label 9907: @613589
     /*  613589 */   GIM_Try, /*On fail goto*//*Label 9908*/ GIMT_Encode4(613661), // Rule ID 5603 //
     /*  613594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  613605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  613608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  613611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  613614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613640 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613659 */     GIR_RootConstrainSelectedInstOperands,
     /*  613660 */     // GIR_Coverage, 5603,
     /*  613660 */     GIR_EraseRootFromParent_Done,
     /*  613661 */   // Label 9908: @613661
     /*  613661 */   GIM_Try, /*On fail goto*//*Label 9909*/ GIMT_Encode4(613733), // Rule ID 5604 //
     /*  613666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  613680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  613683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613712 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  613712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613731 */     GIR_RootConstrainSelectedInstOperands,
     /*  613732 */     // GIR_Coverage, 5604,
     /*  613732 */     GIR_EraseRootFromParent_Done,
     /*  613733 */   // Label 9909: @613733
     /*  613733 */   GIM_Try, /*On fail goto*//*Label 9910*/ GIMT_Encode4(613805), // Rule ID 5605 //
     /*  613738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  613752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  613755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613784 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  613784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613803 */     GIR_RootConstrainSelectedInstOperands,
     /*  613804 */     // GIR_Coverage, 5605,
     /*  613804 */     GIR_EraseRootFromParent_Done,
     /*  613805 */   // Label 9910: @613805
     /*  613805 */   GIM_Try, /*On fail goto*//*Label 9911*/ GIMT_Encode4(613877), // Rule ID 5606 //
     /*  613810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  613813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  613824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  613827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613856 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  613856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  613875 */     GIR_RootConstrainSelectedInstOperands,
     /*  613876 */     // GIR_Coverage, 5606,
     /*  613876 */     GIR_EraseRootFromParent_Done,
     /*  613877 */   // Label 9911: @613877
     /*  613877 */   GIM_Try, /*On fail goto*//*Label 9912*/ GIMT_Encode4(613949), // Rule ID 5607 //
     /*  613882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  613885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  613896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  613899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613928 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  613928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  613947 */     GIR_RootConstrainSelectedInstOperands,
     /*  613948 */     // GIR_Coverage, 5607,
     /*  613948 */     GIR_EraseRootFromParent_Done,
     /*  613949 */   // Label 9912: @613949
     /*  613949 */   GIM_Try, /*On fail goto*//*Label 9913*/ GIMT_Encode4(614021), // Rule ID 5608 //
     /*  613954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  613968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  613971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614000 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  614000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  614003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614019 */     GIR_RootConstrainSelectedInstOperands,
     /*  614020 */     // GIR_Coverage, 5608,
     /*  614020 */     GIR_EraseRootFromParent_Done,
     /*  614021 */   // Label 9913: @614021
     /*  614021 */   GIM_Try, /*On fail goto*//*Label 9914*/ GIMT_Encode4(614093), // Rule ID 5609 //
     /*  614026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  614040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  614043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614072 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  614072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  614075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614091 */     GIR_RootConstrainSelectedInstOperands,
     /*  614092 */     // GIR_Coverage, 5609,
     /*  614092 */     GIR_EraseRootFromParent_Done,
     /*  614093 */   // Label 9914: @614093
     /*  614093 */   GIM_Try, /*On fail goto*//*Label 9915*/ GIMT_Encode4(614165), // Rule ID 5610 //
     /*  614098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  614112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  614115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614144 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  614144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  614147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614163 */     GIR_RootConstrainSelectedInstOperands,
     /*  614164 */     // GIR_Coverage, 5610,
     /*  614164 */     GIR_EraseRootFromParent_Done,
     /*  614165 */   // Label 9915: @614165
     /*  614165 */   GIM_Try, /*On fail goto*//*Label 9916*/ GIMT_Encode4(614237), // Rule ID 5611 //
     /*  614170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  614184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  614187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614216 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  614216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  614219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614235 */     GIR_RootConstrainSelectedInstOperands,
     /*  614236 */     // GIR_Coverage, 5611,
     /*  614236 */     GIR_EraseRootFromParent_Done,
     /*  614237 */   // Label 9916: @614237
     /*  614237 */   GIM_Try, /*On fail goto*//*Label 9917*/ GIMT_Encode4(614309), // Rule ID 5612 //
     /*  614242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  614253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  614256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  614259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  614262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614288 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  614288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  614291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614307 */     GIR_RootConstrainSelectedInstOperands,
     /*  614308 */     // GIR_Coverage, 5612,
     /*  614308 */     GIR_EraseRootFromParent_Done,
     /*  614309 */   // Label 9917: @614309
     /*  614309 */   GIM_Try, /*On fail goto*//*Label 9918*/ GIMT_Encode4(614381), // Rule ID 5613 //
     /*  614314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  614325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  614328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  614331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  614334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614360 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  614360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  614363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614379 */     GIR_RootConstrainSelectedInstOperands,
     /*  614380 */     // GIR_Coverage, 5613,
     /*  614380 */     GIR_EraseRootFromParent_Done,
     /*  614381 */   // Label 9918: @614381
     /*  614381 */   GIM_Try, /*On fail goto*//*Label 9919*/ GIMT_Encode4(614453), // Rule ID 5614 //
     /*  614386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  614400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  614403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  614435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614451 */     GIR_RootConstrainSelectedInstOperands,
     /*  614452 */     // GIR_Coverage, 5614,
     /*  614452 */     GIR_EraseRootFromParent_Done,
     /*  614453 */   // Label 9919: @614453
     /*  614453 */   GIM_Try, /*On fail goto*//*Label 9920*/ GIMT_Encode4(614525), // Rule ID 5615 //
     /*  614458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  614472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  614475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614504 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  614507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614523 */     GIR_RootConstrainSelectedInstOperands,
     /*  614524 */     // GIR_Coverage, 5615,
     /*  614524 */     GIR_EraseRootFromParent_Done,
     /*  614525 */   // Label 9920: @614525
     /*  614525 */   GIM_Try, /*On fail goto*//*Label 9921*/ GIMT_Encode4(614597), // Rule ID 5616 //
     /*  614530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  614544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  614547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614576 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  614579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614595 */     GIR_RootConstrainSelectedInstOperands,
     /*  614596 */     // GIR_Coverage, 5616,
     /*  614596 */     GIR_EraseRootFromParent_Done,
     /*  614597 */   // Label 9921: @614597
     /*  614597 */   GIM_Try, /*On fail goto*//*Label 9922*/ GIMT_Encode4(614669), // Rule ID 5617 //
     /*  614602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  614616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  614619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614648 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  614651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614667 */     GIR_RootConstrainSelectedInstOperands,
     /*  614668 */     // GIR_Coverage, 5617,
     /*  614668 */     GIR_EraseRootFromParent_Done,
     /*  614669 */   // Label 9922: @614669
     /*  614669 */   GIM_Try, /*On fail goto*//*Label 9923*/ GIMT_Encode4(614741), // Rule ID 5618 //
     /*  614674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  614688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  614691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614720 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  614723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614739 */     GIR_RootConstrainSelectedInstOperands,
     /*  614740 */     // GIR_Coverage, 5618,
     /*  614740 */     GIR_EraseRootFromParent_Done,
     /*  614741 */   // Label 9923: @614741
     /*  614741 */   GIM_Try, /*On fail goto*//*Label 9924*/ GIMT_Encode4(614813), // Rule ID 5619 //
     /*  614746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  614760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  614763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614792 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  614795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614811 */     GIR_RootConstrainSelectedInstOperands,
     /*  614812 */     // GIR_Coverage, 5619,
     /*  614812 */     GIR_EraseRootFromParent_Done,
     /*  614813 */   // Label 9924: @614813
     /*  614813 */   GIM_Try, /*On fail goto*//*Label 9925*/ GIMT_Encode4(614885), // Rule ID 5620 //
     /*  614818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  614832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  614835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614864 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  614867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614883 */     GIR_RootConstrainSelectedInstOperands,
     /*  614884 */     // GIR_Coverage, 5620,
     /*  614884 */     GIR_EraseRootFromParent_Done,
     /*  614885 */   // Label 9925: @614885
     /*  614885 */   GIM_Try, /*On fail goto*//*Label 9926*/ GIMT_Encode4(614957), // Rule ID 5621 //
     /*  614890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  614904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  614907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614936 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  614936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  614939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614955 */     GIR_RootConstrainSelectedInstOperands,
     /*  614956 */     // GIR_Coverage, 5621,
     /*  614956 */     GIR_EraseRootFromParent_Done,
     /*  614957 */   // Label 9926: @614957
     /*  614957 */   GIM_Try, /*On fail goto*//*Label 9927*/ GIMT_Encode4(615029), // Rule ID 5622 //
     /*  614962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  614976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  614979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615008 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  615008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  615011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615027 */     GIR_RootConstrainSelectedInstOperands,
     /*  615028 */     // GIR_Coverage, 5622,
     /*  615028 */     GIR_EraseRootFromParent_Done,
     /*  615029 */   // Label 9927: @615029
     /*  615029 */   GIM_Try, /*On fail goto*//*Label 9928*/ GIMT_Encode4(615101), // Rule ID 5623 //
     /*  615034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  615045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  615048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  615051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  615054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615080 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  615080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  615083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615099 */     GIR_RootConstrainSelectedInstOperands,
     /*  615100 */     // GIR_Coverage, 5623,
     /*  615100 */     GIR_EraseRootFromParent_Done,
     /*  615101 */   // Label 9928: @615101
     /*  615101 */   GIM_Try, /*On fail goto*//*Label 9929*/ GIMT_Encode4(615173), // Rule ID 5624 //
     /*  615106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  615117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  615120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  615123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  615126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615152 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  615152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  615155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615171 */     GIR_RootConstrainSelectedInstOperands,
     /*  615172 */     // GIR_Coverage, 5624,
     /*  615172 */     GIR_EraseRootFromParent_Done,
     /*  615173 */   // Label 9929: @615173
     /*  615173 */   GIM_Try, /*On fail goto*//*Label 9930*/ GIMT_Encode4(615245), // Rule ID 5625 //
     /*  615178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  615189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  615192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  615195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  615198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615224 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  615224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  615227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615243 */     GIR_RootConstrainSelectedInstOperands,
     /*  615244 */     // GIR_Coverage, 5625,
     /*  615244 */     GIR_EraseRootFromParent_Done,
     /*  615245 */   // Label 9930: @615245
     /*  615245 */   GIM_Try, /*On fail goto*//*Label 9931*/ GIMT_Encode4(615317), // Rule ID 5626 //
     /*  615250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  615253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  615261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  615264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  615267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  615270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615296 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  615296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  615299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615315 */     GIR_RootConstrainSelectedInstOperands,
     /*  615316 */     // GIR_Coverage, 5626,
     /*  615316 */     GIR_EraseRootFromParent_Done,
     /*  615317 */   // Label 9931: @615317
     /*  615317 */   GIM_Try, /*On fail goto*//*Label 9932*/ GIMT_Encode4(615389), // Rule ID 5627 //
     /*  615322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  615325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  615333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  615336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  615339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  615342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  615368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  615371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615387 */     GIR_RootConstrainSelectedInstOperands,
     /*  615388 */     // GIR_Coverage, 5627,
     /*  615388 */     GIR_EraseRootFromParent_Done,
     /*  615389 */   // Label 9932: @615389
     /*  615389 */   GIM_Try, /*On fail goto*//*Label 9933*/ GIMT_Encode4(615461), // Rule ID 5628 //
     /*  615394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  615397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  615405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  615408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  615411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  615414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615440 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  615440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  615443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615459 */     GIR_RootConstrainSelectedInstOperands,
     /*  615460 */     // GIR_Coverage, 5628,
     /*  615460 */     GIR_EraseRootFromParent_Done,
     /*  615461 */   // Label 9933: @615461
     /*  615461 */   GIM_Try, /*On fail goto*//*Label 9934*/ GIMT_Encode4(615533), // Rule ID 5629 //
     /*  615466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  615469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  615477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  615480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  615483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  615486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  615512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  615515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615531 */     GIR_RootConstrainSelectedInstOperands,
     /*  615532 */     // GIR_Coverage, 5629,
     /*  615532 */     GIR_EraseRootFromParent_Done,
     /*  615533 */   // Label 9934: @615533
     /*  615533 */   GIM_Try, /*On fail goto*//*Label 9935*/ GIMT_Encode4(615605), // Rule ID 5630 //
     /*  615538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  615541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  615549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  615552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  615555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  615558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615584 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  615584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  615587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615603 */     GIR_RootConstrainSelectedInstOperands,
     /*  615604 */     // GIR_Coverage, 5630,
     /*  615604 */     GIR_EraseRootFromParent_Done,
     /*  615605 */   // Label 9935: @615605
     /*  615605 */   GIM_Try, /*On fail goto*//*Label 9936*/ GIMT_Encode4(615677), // Rule ID 5631 //
     /*  615610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  615613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  615621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  615624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  615627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  615630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615656 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  615656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  615659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615675 */     GIR_RootConstrainSelectedInstOperands,
     /*  615676 */     // GIR_Coverage, 5631,
     /*  615676 */     GIR_EraseRootFromParent_Done,
     /*  615677 */   // Label 9936: @615677
     /*  615677 */   GIM_Try, /*On fail goto*//*Label 9937*/ GIMT_Encode4(615749), // Rule ID 5632 //
     /*  615682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  615693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  615699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  615702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615728 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  615728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  615731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615747 */     GIR_RootConstrainSelectedInstOperands,
     /*  615748 */     // GIR_Coverage, 5632,
     /*  615748 */     GIR_EraseRootFromParent_Done,
     /*  615749 */   // Label 9937: @615749
     /*  615749 */   GIM_Try, /*On fail goto*//*Label 9938*/ GIMT_Encode4(615821), // Rule ID 5633 //
     /*  615754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  615765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  615771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  615774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615800 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  615800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  615803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615819 */     GIR_RootConstrainSelectedInstOperands,
     /*  615820 */     // GIR_Coverage, 5633,
     /*  615820 */     GIR_EraseRootFromParent_Done,
     /*  615821 */   // Label 9938: @615821
     /*  615821 */   GIM_Try, /*On fail goto*//*Label 9939*/ GIMT_Encode4(615893), // Rule ID 5634 //
     /*  615826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  615837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  615843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  615846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  615872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  615875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615891 */     GIR_RootConstrainSelectedInstOperands,
     /*  615892 */     // GIR_Coverage, 5634,
     /*  615892 */     GIR_EraseRootFromParent_Done,
     /*  615893 */   // Label 9939: @615893
     /*  615893 */   GIM_Try, /*On fail goto*//*Label 9940*/ GIMT_Encode4(615965), // Rule ID 5635 //
     /*  615898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  615909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  615915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  615918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615944 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  615944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  615947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615963 */     GIR_RootConstrainSelectedInstOperands,
     /*  615964 */     // GIR_Coverage, 5635,
     /*  615964 */     GIR_EraseRootFromParent_Done,
     /*  615965 */   // Label 9940: @615965
     /*  615965 */   GIM_Try, /*On fail goto*//*Label 9941*/ GIMT_Encode4(616037), // Rule ID 5636 //
     /*  615970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  615981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  615984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  615987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  615990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616016 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  616016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  616019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616035 */     GIR_RootConstrainSelectedInstOperands,
     /*  616036 */     // GIR_Coverage, 5636,
     /*  616036 */     GIR_EraseRootFromParent_Done,
     /*  616037 */   // Label 9941: @616037
     /*  616037 */   GIM_Try, /*On fail goto*//*Label 9942*/ GIMT_Encode4(616109), // Rule ID 5637 //
     /*  616042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  616053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  616056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  616062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616088 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  616088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  616091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616107 */     GIR_RootConstrainSelectedInstOperands,
     /*  616108 */     // GIR_Coverage, 5637,
     /*  616108 */     GIR_EraseRootFromParent_Done,
     /*  616109 */   // Label 9942: @616109
     /*  616109 */   GIM_Try, /*On fail goto*//*Label 9943*/ GIMT_Encode4(616181), // Rule ID 5638 //
     /*  616114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  616125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  616128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  616134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616160 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  616160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  616163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616179 */     GIR_RootConstrainSelectedInstOperands,
     /*  616180 */     // GIR_Coverage, 5638,
     /*  616180 */     GIR_EraseRootFromParent_Done,
     /*  616181 */   // Label 9943: @616181
     /*  616181 */   GIM_Try, /*On fail goto*//*Label 9944*/ GIMT_Encode4(616253), // Rule ID 5639 //
     /*  616186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  616197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  616200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  616206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616232 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  616232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  616235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616251 */     GIR_RootConstrainSelectedInstOperands,
     /*  616252 */     // GIR_Coverage, 5639,
     /*  616252 */     GIR_EraseRootFromParent_Done,
     /*  616253 */   // Label 9944: @616253
     /*  616253 */   GIM_Try, /*On fail goto*//*Label 9945*/ GIMT_Encode4(616325), // Rule ID 5640 //
     /*  616258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  616269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  616272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  616278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616304 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  616304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  616307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616323 */     GIR_RootConstrainSelectedInstOperands,
     /*  616324 */     // GIR_Coverage, 5640,
     /*  616324 */     GIR_EraseRootFromParent_Done,
     /*  616325 */   // Label 9945: @616325
     /*  616325 */   GIM_Try, /*On fail goto*//*Label 9946*/ GIMT_Encode4(616397), // Rule ID 5641 //
     /*  616330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  616341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  616344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  616350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  616376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  616379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616395 */     GIR_RootConstrainSelectedInstOperands,
     /*  616396 */     // GIR_Coverage, 5641,
     /*  616396 */     GIR_EraseRootFromParent_Done,
     /*  616397 */   // Label 9946: @616397
     /*  616397 */   GIM_Try, /*On fail goto*//*Label 9947*/ GIMT_Encode4(616469), // Rule ID 5642 //
     /*  616402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  616413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  616416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  616422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616448 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  616448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  616451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616467 */     GIR_RootConstrainSelectedInstOperands,
     /*  616468 */     // GIR_Coverage, 5642,
     /*  616468 */     GIR_EraseRootFromParent_Done,
     /*  616469 */   // Label 9947: @616469
     /*  616469 */   GIM_Try, /*On fail goto*//*Label 9948*/ GIMT_Encode4(616541), // Rule ID 5643 //
     /*  616474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  616485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  616488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  616494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616520 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  616520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  616523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616539 */     GIR_RootConstrainSelectedInstOperands,
     /*  616540 */     // GIR_Coverage, 5643,
     /*  616540 */     GIR_EraseRootFromParent_Done,
     /*  616541 */   // Label 9948: @616541
     /*  616541 */   GIM_Try, /*On fail goto*//*Label 9949*/ GIMT_Encode4(616613), // Rule ID 5644 //
     /*  616546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  616557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  616560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  616566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616592 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  616592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  616595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616611 */     GIR_RootConstrainSelectedInstOperands,
     /*  616612 */     // GIR_Coverage, 5644,
     /*  616612 */     GIR_EraseRootFromParent_Done,
     /*  616613 */   // Label 9949: @616613
     /*  616613 */   GIM_Try, /*On fail goto*//*Label 9950*/ GIMT_Encode4(616685), // Rule ID 5645 //
     /*  616618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  616629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  616632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  616638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616664 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  616664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  616667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616683 */     GIR_RootConstrainSelectedInstOperands,
     /*  616684 */     // GIR_Coverage, 5645,
     /*  616684 */     GIR_EraseRootFromParent_Done,
     /*  616685 */   // Label 9950: @616685
     /*  616685 */   GIM_Try, /*On fail goto*//*Label 9951*/ GIMT_Encode4(616757), // Rule ID 5646 //
     /*  616690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  616701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  616710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616736 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  616736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  616739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616755 */     GIR_RootConstrainSelectedInstOperands,
     /*  616756 */     // GIR_Coverage, 5646,
     /*  616756 */     GIR_EraseRootFromParent_Done,
     /*  616757 */   // Label 9951: @616757
     /*  616757 */   GIM_Try, /*On fail goto*//*Label 9952*/ GIMT_Encode4(616829), // Rule ID 5647 //
     /*  616762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  616773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  616782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616808 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  616808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  616811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616827 */     GIR_RootConstrainSelectedInstOperands,
     /*  616828 */     // GIR_Coverage, 5647,
     /*  616828 */     GIR_EraseRootFromParent_Done,
     /*  616829 */   // Label 9952: @616829
     /*  616829 */   GIM_Try, /*On fail goto*//*Label 9953*/ GIMT_Encode4(616901), // Rule ID 5648 //
     /*  616834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  616845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  616848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  616854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  616880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  616883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616899 */     GIR_RootConstrainSelectedInstOperands,
     /*  616900 */     // GIR_Coverage, 5648,
     /*  616900 */     GIR_EraseRootFromParent_Done,
     /*  616901 */   // Label 9953: @616901
     /*  616901 */   GIM_Try, /*On fail goto*//*Label 9954*/ GIMT_Encode4(616973), // Rule ID 5649 //
     /*  616906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  616917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  616920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  616926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616952 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  616952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  616955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616971 */     GIR_RootConstrainSelectedInstOperands,
     /*  616972 */     // GIR_Coverage, 5649,
     /*  616972 */     GIR_EraseRootFromParent_Done,
     /*  616973 */   // Label 9954: @616973
     /*  616973 */   GIM_Try, /*On fail goto*//*Label 9955*/ GIMT_Encode4(617045), // Rule ID 5650 //
     /*  616978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  616981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  616989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  616992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  616998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  617024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  617027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  617043 */     GIR_RootConstrainSelectedInstOperands,
     /*  617044 */     // GIR_Coverage, 5650,
     /*  617044 */     GIR_EraseRootFromParent_Done,
     /*  617045 */   // Label 9955: @617045
     /*  617045 */   GIM_Try, /*On fail goto*//*Label 9956*/ GIMT_Encode4(617117), // Rule ID 5651 //
     /*  617050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  617053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  617061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  617064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  617070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617096 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  617096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  617099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  617115 */     GIR_RootConstrainSelectedInstOperands,
     /*  617116 */     // GIR_Coverage, 5651,
     /*  617116 */     GIR_EraseRootFromParent_Done,
     /*  617117 */   // Label 9956: @617117
     /*  617117 */   GIM_Try, /*On fail goto*//*Label 9957*/ GIMT_Encode4(617189), // Rule ID 5652 //
     /*  617122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  617133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  617136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  617139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  617142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617168 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  617168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  617171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617187 */     GIR_RootConstrainSelectedInstOperands,
     /*  617188 */     // GIR_Coverage, 5652,
     /*  617188 */     GIR_EraseRootFromParent_Done,
     /*  617189 */   // Label 9957: @617189
     /*  617189 */   GIM_Try, /*On fail goto*//*Label 9958*/ GIMT_Encode4(617261), // Rule ID 5653 //
     /*  617194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  617205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  617208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  617214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617240 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  617240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  617243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617259 */     GIR_RootConstrainSelectedInstOperands,
     /*  617260 */     // GIR_Coverage, 5653,
     /*  617260 */     GIR_EraseRootFromParent_Done,
     /*  617261 */   // Label 9958: @617261
     /*  617261 */   GIM_Try, /*On fail goto*//*Label 9959*/ GIMT_Encode4(617333), // Rule ID 5654 //
     /*  617266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  617277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  617280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  617283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  617286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617312 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  617312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  617315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617331 */     GIR_RootConstrainSelectedInstOperands,
     /*  617332 */     // GIR_Coverage, 5654,
     /*  617332 */     GIR_EraseRootFromParent_Done,
     /*  617333 */   // Label 9959: @617333
     /*  617333 */   GIM_Try, /*On fail goto*//*Label 9960*/ GIMT_Encode4(617405), // Rule ID 5655 //
     /*  617338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  617349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  617352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  617358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617384 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  617384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  617387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617403 */     GIR_RootConstrainSelectedInstOperands,
     /*  617404 */     // GIR_Coverage, 5655,
     /*  617404 */     GIR_EraseRootFromParent_Done,
     /*  617405 */   // Label 9960: @617405
     /*  617405 */   GIM_Try, /*On fail goto*//*Label 9961*/ GIMT_Encode4(617477), // Rule ID 5656 //
     /*  617410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  617421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  617424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  617427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  617430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617456 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  617456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  617459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617475 */     GIR_RootConstrainSelectedInstOperands,
     /*  617476 */     // GIR_Coverage, 5656,
     /*  617476 */     GIR_EraseRootFromParent_Done,
     /*  617477 */   // Label 9961: @617477
     /*  617477 */   GIM_Try, /*On fail goto*//*Label 9962*/ GIMT_Encode4(617549), // Rule ID 5657 //
     /*  617482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  617493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  617496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  617502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617528 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  617528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  617531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617547 */     GIR_RootConstrainSelectedInstOperands,
     /*  617548 */     // GIR_Coverage, 5657,
     /*  617548 */     GIR_EraseRootFromParent_Done,
     /*  617549 */   // Label 9962: @617549
     /*  617549 */   GIM_Try, /*On fail goto*//*Label 9963*/ GIMT_Encode4(617621), // Rule ID 5658 //
     /*  617554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  617565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  617568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  617571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  617574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617600 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  617600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  617603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617619 */     GIR_RootConstrainSelectedInstOperands,
     /*  617620 */     // GIR_Coverage, 5658,
     /*  617620 */     GIR_EraseRootFromParent_Done,
     /*  617621 */   // Label 9963: @617621
     /*  617621 */   GIM_Try, /*On fail goto*//*Label 9964*/ GIMT_Encode4(617693), // Rule ID 5659 //
     /*  617626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  617637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  617640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  617646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  617672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  617675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617691 */     GIR_RootConstrainSelectedInstOperands,
     /*  617692 */     // GIR_Coverage, 5659,
     /*  617692 */     GIR_EraseRootFromParent_Done,
     /*  617693 */   // Label 9964: @617693
     /*  617693 */   GIM_Try, /*On fail goto*//*Label 9965*/ GIMT_Encode4(617765), // Rule ID 5660 //
     /*  617698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  617709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  617715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  617718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617744 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  617744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  617747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617763 */     GIR_RootConstrainSelectedInstOperands,
     /*  617764 */     // GIR_Coverage, 5660,
     /*  617764 */     GIR_EraseRootFromParent_Done,
     /*  617765 */   // Label 9965: @617765
     /*  617765 */   GIM_Try, /*On fail goto*//*Label 9966*/ GIMT_Encode4(617837), // Rule ID 5661 //
     /*  617770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  617781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  617790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617816 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  617816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  617819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617835 */     GIR_RootConstrainSelectedInstOperands,
     /*  617836 */     // GIR_Coverage, 5661,
     /*  617836 */     GIR_EraseRootFromParent_Done,
     /*  617837 */   // Label 9966: @617837
     /*  617837 */   GIM_Try, /*On fail goto*//*Label 9967*/ GIMT_Encode4(617909), // Rule ID 5662 //
     /*  617842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  617853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  617859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  617862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617888 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  617888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  617891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617907 */     GIR_RootConstrainSelectedInstOperands,
     /*  617908 */     // GIR_Coverage, 5662,
     /*  617908 */     GIR_EraseRootFromParent_Done,
     /*  617909 */   // Label 9967: @617909
     /*  617909 */   GIM_Try, /*On fail goto*//*Label 9968*/ GIMT_Encode4(617981), // Rule ID 5663 //
     /*  617914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  617925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  617934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617960 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  617960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  617963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617979 */     GIR_RootConstrainSelectedInstOperands,
     /*  617980 */     // GIR_Coverage, 5663,
     /*  617980 */     GIR_EraseRootFromParent_Done,
     /*  617981 */   // Label 9968: @617981
     /*  617981 */   GIM_Try, /*On fail goto*//*Label 9969*/ GIMT_Encode4(618053), // Rule ID 5664 //
     /*  617986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  617997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  618000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  618003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  618006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618032 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  618032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  618035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618051 */     GIR_RootConstrainSelectedInstOperands,
     /*  618052 */     // GIR_Coverage, 5664,
     /*  618052 */     GIR_EraseRootFromParent_Done,
     /*  618053 */   // Label 9969: @618053
     /*  618053 */   GIM_Try, /*On fail goto*//*Label 9970*/ GIMT_Encode4(618125), // Rule ID 5665 //
     /*  618058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  618069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  618072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  618075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  618078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618104 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  618104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  618107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618123 */     GIR_RootConstrainSelectedInstOperands,
     /*  618124 */     // GIR_Coverage, 5665,
     /*  618124 */     GIR_EraseRootFromParent_Done,
     /*  618125 */   // Label 9970: @618125
     /*  618125 */   GIM_Try, /*On fail goto*//*Label 9971*/ GIMT_Encode4(618197), // Rule ID 5666 //
     /*  618130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  618141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  618144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  618147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  618150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618176 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  618176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  618179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618195 */     GIR_RootConstrainSelectedInstOperands,
     /*  618196 */     // GIR_Coverage, 5666,
     /*  618196 */     GIR_EraseRootFromParent_Done,
     /*  618197 */   // Label 9971: @618197
     /*  618197 */   GIM_Try, /*On fail goto*//*Label 9972*/ GIMT_Encode4(618269), // Rule ID 5667 //
     /*  618202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  618213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  618216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  618219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  618222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  618248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  618251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618267 */     GIR_RootConstrainSelectedInstOperands,
     /*  618268 */     // GIR_Coverage, 5667,
     /*  618268 */     GIR_EraseRootFromParent_Done,
     /*  618269 */   // Label 9972: @618269
     /*  618269 */   GIM_Try, /*On fail goto*//*Label 9973*/ GIMT_Encode4(618341), // Rule ID 5668 //
     /*  618274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  618285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  618288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  618291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  618294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618320 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  618320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  618323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618339 */     GIR_RootConstrainSelectedInstOperands,
     /*  618340 */     // GIR_Coverage, 5668,
     /*  618340 */     GIR_EraseRootFromParent_Done,
     /*  618341 */   // Label 9973: @618341
     /*  618341 */   GIM_Try, /*On fail goto*//*Label 9974*/ GIMT_Encode4(618413), // Rule ID 5669 //
     /*  618346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  618357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  618360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  618363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  618366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618392 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  618392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  618395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618411 */     GIR_RootConstrainSelectedInstOperands,
     /*  618412 */     // GIR_Coverage, 5669,
     /*  618412 */     GIR_EraseRootFromParent_Done,
     /*  618413 */   // Label 9974: @618413
     /*  618413 */   GIM_Try, /*On fail goto*//*Label 9975*/ GIMT_Encode4(618485), // Rule ID 5670 //
     /*  618418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  618429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  618432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  618435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  618438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618464 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  618464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  618467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618483 */     GIR_RootConstrainSelectedInstOperands,
     /*  618484 */     // GIR_Coverage, 5670,
     /*  618484 */     GIR_EraseRootFromParent_Done,
     /*  618485 */   // Label 9975: @618485
     /*  618485 */   GIM_Try, /*On fail goto*//*Label 9976*/ GIMT_Encode4(618557), // Rule ID 5671 //
     /*  618490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  618501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  618504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  618507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  618510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618536 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  618536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  618539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618555 */     GIR_RootConstrainSelectedInstOperands,
     /*  618556 */     // GIR_Coverage, 5671,
     /*  618556 */     GIR_EraseRootFromParent_Done,
     /*  618557 */   // Label 9976: @618557
     /*  618557 */   GIM_Try, /*On fail goto*//*Label 9977*/ GIMT_Encode4(618629), // Rule ID 5672 //
     /*  618562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  618573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  618579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  618582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  618608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  618611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618627 */     GIR_RootConstrainSelectedInstOperands,
     /*  618628 */     // GIR_Coverage, 5672,
     /*  618628 */     GIR_EraseRootFromParent_Done,
     /*  618629 */   // Label 9977: @618629
     /*  618629 */   GIM_Try, /*On fail goto*//*Label 9978*/ GIMT_Encode4(618701), // Rule ID 5673 //
     /*  618634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  618645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  618651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  618654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  618680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  618683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618699 */     GIR_RootConstrainSelectedInstOperands,
     /*  618700 */     // GIR_Coverage, 5673,
     /*  618700 */     GIR_EraseRootFromParent_Done,
     /*  618701 */   // Label 9978: @618701
     /*  618701 */   GIM_Try, /*On fail goto*//*Label 9979*/ GIMT_Encode4(618773), // Rule ID 5674 //
     /*  618706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  618717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  618723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  618726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618752 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  618752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  618755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618771 */     GIR_RootConstrainSelectedInstOperands,
     /*  618772 */     // GIR_Coverage, 5674,
     /*  618772 */     GIR_EraseRootFromParent_Done,
     /*  618773 */   // Label 9979: @618773
     /*  618773 */   GIM_Try, /*On fail goto*//*Label 9980*/ GIMT_Encode4(618845), // Rule ID 5675 //
     /*  618778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  618789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  618795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  618798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618824 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  618824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  618827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618843 */     GIR_RootConstrainSelectedInstOperands,
     /*  618844 */     // GIR_Coverage, 5675,
     /*  618844 */     GIR_EraseRootFromParent_Done,
     /*  618845 */   // Label 9980: @618845
     /*  618845 */   GIM_Try, /*On fail goto*//*Label 9981*/ GIMT_Encode4(618920), // Rule ID 5764 //
     /*  618850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  618861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  618864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  618867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  618870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  618899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618918 */     GIR_RootConstrainSelectedInstOperands,
     /*  618919 */     // GIR_Coverage, 5764,
     /*  618919 */     GIR_EraseRootFromParent_Done,
     /*  618920 */   // Label 9981: @618920
     /*  618920 */   GIM_Try, /*On fail goto*//*Label 9982*/ GIMT_Encode4(618995), // Rule ID 5765 //
     /*  618925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  618936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  618939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  618942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  618945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  618971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  618974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618993 */     GIR_RootConstrainSelectedInstOperands,
     /*  618994 */     // GIR_Coverage, 5765,
     /*  618994 */     GIR_EraseRootFromParent_Done,
     /*  618995 */   // Label 9982: @618995
     /*  618995 */   GIM_Try, /*On fail goto*//*Label 9983*/ GIMT_Encode4(619070), // Rule ID 5768 //
     /*  619000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  619011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  619014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  619017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  619020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  619049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619068 */     GIR_RootConstrainSelectedInstOperands,
     /*  619069 */     // GIR_Coverage, 5768,
     /*  619069 */     GIR_EraseRootFromParent_Done,
     /*  619070 */   // Label 9983: @619070
     /*  619070 */   GIM_Try, /*On fail goto*//*Label 9984*/ GIMT_Encode4(619145), // Rule ID 5769 //
     /*  619075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  619086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  619089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  619092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  619095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619121 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  619124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619143 */     GIR_RootConstrainSelectedInstOperands,
     /*  619144 */     // GIR_Coverage, 5769,
     /*  619144 */     GIR_EraseRootFromParent_Done,
     /*  619145 */   // Label 9984: @619145
     /*  619145 */   GIM_Try, /*On fail goto*//*Label 9985*/ GIMT_Encode4(619220), // Rule ID 5772 //
     /*  619150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  619161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  619164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  619167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  619170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  619199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619218 */     GIR_RootConstrainSelectedInstOperands,
     /*  619219 */     // GIR_Coverage, 5772,
     /*  619219 */     GIR_EraseRootFromParent_Done,
     /*  619220 */   // Label 9985: @619220
     /*  619220 */   GIM_Try, /*On fail goto*//*Label 9986*/ GIMT_Encode4(619295), // Rule ID 5773 //
     /*  619225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  619236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  619239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  619242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  619245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  619274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619293 */     GIR_RootConstrainSelectedInstOperands,
     /*  619294 */     // GIR_Coverage, 5773,
     /*  619294 */     GIR_EraseRootFromParent_Done,
     /*  619295 */   // Label 9986: @619295
     /*  619295 */   GIM_Try, /*On fail goto*//*Label 9987*/ GIMT_Encode4(619370), // Rule ID 5776 //
     /*  619300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  619311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  619314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  619317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  619320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  619349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619368 */     GIR_RootConstrainSelectedInstOperands,
     /*  619369 */     // GIR_Coverage, 5776,
     /*  619369 */     GIR_EraseRootFromParent_Done,
     /*  619370 */   // Label 9987: @619370
     /*  619370 */   GIM_Try, /*On fail goto*//*Label 9988*/ GIMT_Encode4(619445), // Rule ID 5777 //
     /*  619375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  619386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  619389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  619392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  619395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619421 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  619424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619443 */     GIR_RootConstrainSelectedInstOperands,
     /*  619444 */     // GIR_Coverage, 5777,
     /*  619444 */     GIR_EraseRootFromParent_Done,
     /*  619445 */   // Label 9988: @619445
     /*  619445 */   GIM_Try, /*On fail goto*//*Label 9989*/ GIMT_Encode4(619520), // Rule ID 5780 //
     /*  619450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  619461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  619464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  619467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  619470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  619499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619518 */     GIR_RootConstrainSelectedInstOperands,
     /*  619519 */     // GIR_Coverage, 5780,
     /*  619519 */     GIR_EraseRootFromParent_Done,
     /*  619520 */   // Label 9989: @619520
     /*  619520 */   GIM_Try, /*On fail goto*//*Label 9990*/ GIMT_Encode4(619595), // Rule ID 5781 //
     /*  619525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  619536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  619539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  619542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  619545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619571 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  619574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619593 */     GIR_RootConstrainSelectedInstOperands,
     /*  619594 */     // GIR_Coverage, 5781,
     /*  619594 */     GIR_EraseRootFromParent_Done,
     /*  619595 */   // Label 9990: @619595
     /*  619595 */   GIM_Try, /*On fail goto*//*Label 9991*/ GIMT_Encode4(619670), // Rule ID 5784 //
     /*  619600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  619611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  619614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  619617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  619620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  619646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  619649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619668 */     GIR_RootConstrainSelectedInstOperands,
     /*  619669 */     // GIR_Coverage, 5784,
     /*  619669 */     GIR_EraseRootFromParent_Done,
     /*  619670 */   // Label 9991: @619670
     /*  619670 */   GIM_Try, /*On fail goto*//*Label 9992*/ GIMT_Encode4(619745), // Rule ID 5785 //
     /*  619675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  619686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  619689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  619692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  619695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  619721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  619724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619743 */     GIR_RootConstrainSelectedInstOperands,
     /*  619744 */     // GIR_Coverage, 5785,
     /*  619744 */     GIR_EraseRootFromParent_Done,
     /*  619745 */   // Label 9992: @619745
     /*  619745 */   GIM_Try, /*On fail goto*//*Label 9993*/ GIMT_Encode4(619820), // Rule ID 5788 //
     /*  619750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  619761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  619764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  619767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  619770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  619799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619818 */     GIR_RootConstrainSelectedInstOperands,
     /*  619819 */     // GIR_Coverage, 5788,
     /*  619819 */     GIR_EraseRootFromParent_Done,
     /*  619820 */   // Label 9993: @619820
     /*  619820 */   GIM_Try, /*On fail goto*//*Label 9994*/ GIMT_Encode4(619895), // Rule ID 5789 //
     /*  619825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  619836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  619839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  619842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  619845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619871 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  619874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619893 */     GIR_RootConstrainSelectedInstOperands,
     /*  619894 */     // GIR_Coverage, 5789,
     /*  619894 */     GIR_EraseRootFromParent_Done,
     /*  619895 */   // Label 9994: @619895
     /*  619895 */   GIM_Try, /*On fail goto*//*Label 9995*/ GIMT_Encode4(619970), // Rule ID 5792 //
     /*  619900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  619911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  619914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  619917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  619920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  619949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619968 */     GIR_RootConstrainSelectedInstOperands,
     /*  619969 */     // GIR_Coverage, 5792,
     /*  619969 */     GIR_EraseRootFromParent_Done,
     /*  619970 */   // Label 9995: @619970
     /*  619970 */   GIM_Try, /*On fail goto*//*Label 9996*/ GIMT_Encode4(620045), // Rule ID 5793 //
     /*  619975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  619986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  619989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  619992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  619995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620021 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  620024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620043 */     GIR_RootConstrainSelectedInstOperands,
     /*  620044 */     // GIR_Coverage, 5793,
     /*  620044 */     GIR_EraseRootFromParent_Done,
     /*  620045 */   // Label 9996: @620045
     /*  620045 */   GIM_Try, /*On fail goto*//*Label 9997*/ GIMT_Encode4(620120), // Rule ID 5796 //
     /*  620050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  620061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  620064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  620067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  620070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  620096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  620099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620118 */     GIR_RootConstrainSelectedInstOperands,
     /*  620119 */     // GIR_Coverage, 5796,
     /*  620119 */     GIR_EraseRootFromParent_Done,
     /*  620120 */   // Label 9997: @620120
     /*  620120 */   GIM_Try, /*On fail goto*//*Label 9998*/ GIMT_Encode4(620195), // Rule ID 5797 //
     /*  620125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  620136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  620139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  620142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  620145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  620171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  620174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620193 */     GIR_RootConstrainSelectedInstOperands,
     /*  620194 */     // GIR_Coverage, 5797,
     /*  620194 */     GIR_EraseRootFromParent_Done,
     /*  620195 */   // Label 9998: @620195
     /*  620195 */   GIM_Try, /*On fail goto*//*Label 9999*/ GIMT_Encode4(620270), // Rule ID 5800 //
     /*  620200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  620203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  620211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  620214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  620217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  620220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  620246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  620249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620268 */     GIR_RootConstrainSelectedInstOperands,
     /*  620269 */     // GIR_Coverage, 5800,
     /*  620269 */     GIR_EraseRootFromParent_Done,
     /*  620270 */   // Label 9999: @620270
     /*  620270 */   GIM_Try, /*On fail goto*//*Label 10000*/ GIMT_Encode4(620345), // Rule ID 5801 //
     /*  620275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  620278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  620286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  620289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  620292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  620295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620321 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  620321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  620324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620343 */     GIR_RootConstrainSelectedInstOperands,
     /*  620344 */     // GIR_Coverage, 5801,
     /*  620344 */     GIR_EraseRootFromParent_Done,
     /*  620345 */   // Label 10000: @620345
     /*  620345 */   GIM_Try, /*On fail goto*//*Label 10001*/ GIMT_Encode4(620420), // Rule ID 5804 //
     /*  620350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  620361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  620364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  620367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  620370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  620399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620418 */     GIR_RootConstrainSelectedInstOperands,
     /*  620419 */     // GIR_Coverage, 5804,
     /*  620419 */     GIR_EraseRootFromParent_Done,
     /*  620420 */   // Label 10001: @620420
     /*  620420 */   GIM_Try, /*On fail goto*//*Label 10002*/ GIMT_Encode4(620495), // Rule ID 5805 //
     /*  620425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  620436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  620439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  620442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  620445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  620474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620493 */     GIR_RootConstrainSelectedInstOperands,
     /*  620494 */     // GIR_Coverage, 5805,
     /*  620494 */     GIR_EraseRootFromParent_Done,
     /*  620495 */   // Label 10002: @620495
     /*  620495 */   GIM_Try, /*On fail goto*//*Label 10003*/ GIMT_Encode4(620570), // Rule ID 5808 //
     /*  620500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  620511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  620514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  620517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  620520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  620549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620568 */     GIR_RootConstrainSelectedInstOperands,
     /*  620569 */     // GIR_Coverage, 5808,
     /*  620569 */     GIR_EraseRootFromParent_Done,
     /*  620570 */   // Label 10003: @620570
     /*  620570 */   GIM_Try, /*On fail goto*//*Label 10004*/ GIMT_Encode4(620645), // Rule ID 5809 //
     /*  620575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  620586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  620589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  620592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  620595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620621 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  620624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620643 */     GIR_RootConstrainSelectedInstOperands,
     /*  620644 */     // GIR_Coverage, 5809,
     /*  620644 */     GIR_EraseRootFromParent_Done,
     /*  620645 */   // Label 10004: @620645
     /*  620645 */   GIM_Try, /*On fail goto*//*Label 10005*/ GIMT_Encode4(620720), // Rule ID 5812 //
     /*  620650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  620661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  620664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  620667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  620670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620696 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  620699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620718 */     GIR_RootConstrainSelectedInstOperands,
     /*  620719 */     // GIR_Coverage, 5812,
     /*  620719 */     GIR_EraseRootFromParent_Done,
     /*  620720 */   // Label 10005: @620720
     /*  620720 */   GIM_Try, /*On fail goto*//*Label 10006*/ GIMT_Encode4(620795), // Rule ID 5813 //
     /*  620725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  620736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  620739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  620742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  620745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620771 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  620774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620793 */     GIR_RootConstrainSelectedInstOperands,
     /*  620794 */     // GIR_Coverage, 5813,
     /*  620794 */     GIR_EraseRootFromParent_Done,
     /*  620795 */   // Label 10006: @620795
     /*  620795 */   GIM_Try, /*On fail goto*//*Label 10007*/ GIMT_Encode4(620870), // Rule ID 5816 //
     /*  620800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  620811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  620814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  620817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  620820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  620849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620868 */     GIR_RootConstrainSelectedInstOperands,
     /*  620869 */     // GIR_Coverage, 5816,
     /*  620869 */     GIR_EraseRootFromParent_Done,
     /*  620870 */   // Label 10007: @620870
     /*  620870 */   GIM_Try, /*On fail goto*//*Label 10008*/ GIMT_Encode4(620945), // Rule ID 5817 //
     /*  620875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  620886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  620889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  620892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  620895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  620924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620943 */     GIR_RootConstrainSelectedInstOperands,
     /*  620944 */     // GIR_Coverage, 5817,
     /*  620944 */     GIR_EraseRootFromParent_Done,
     /*  620945 */   // Label 10008: @620945
     /*  620945 */   GIM_Try, /*On fail goto*//*Label 10009*/ GIMT_Encode4(621020), // Rule ID 5820 //
     /*  620950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  620961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  620964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  620967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  620970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  620999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621018 */     GIR_RootConstrainSelectedInstOperands,
     /*  621019 */     // GIR_Coverage, 5820,
     /*  621019 */     GIR_EraseRootFromParent_Done,
     /*  621020 */   // Label 10009: @621020
     /*  621020 */   GIM_Try, /*On fail goto*//*Label 10010*/ GIMT_Encode4(621095), // Rule ID 5821 //
     /*  621025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  621036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  621039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  621042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  621045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  621071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  621074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621093 */     GIR_RootConstrainSelectedInstOperands,
     /*  621094 */     // GIR_Coverage, 5821,
     /*  621094 */     GIR_EraseRootFromParent_Done,
     /*  621095 */   // Label 10010: @621095
     /*  621095 */   GIM_Try, /*On fail goto*//*Label 10011*/ GIMT_Encode4(621170), // Rule ID 5824 //
     /*  621100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  621111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  621114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  621117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  621120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  621146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  621149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621168 */     GIR_RootConstrainSelectedInstOperands,
     /*  621169 */     // GIR_Coverage, 5824,
     /*  621169 */     GIR_EraseRootFromParent_Done,
     /*  621170 */   // Label 10011: @621170
     /*  621170 */   GIM_Try, /*On fail goto*//*Label 10012*/ GIMT_Encode4(621245), // Rule ID 5825 //
     /*  621175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  621186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  621189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  621192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  621195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621221 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  621221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  621224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621243 */     GIR_RootConstrainSelectedInstOperands,
     /*  621244 */     // GIR_Coverage, 5825,
     /*  621244 */     GIR_EraseRootFromParent_Done,
     /*  621245 */   // Label 10012: @621245
     /*  621245 */   GIM_Try, /*On fail goto*//*Label 10013*/ GIMT_Encode4(621320), // Rule ID 5828 //
     /*  621250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  621261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  621264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  621267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  621270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  621299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621318 */     GIR_RootConstrainSelectedInstOperands,
     /*  621319 */     // GIR_Coverage, 5828,
     /*  621319 */     GIR_EraseRootFromParent_Done,
     /*  621320 */   // Label 10013: @621320
     /*  621320 */   GIM_Try, /*On fail goto*//*Label 10014*/ GIMT_Encode4(621395), // Rule ID 5829 //
     /*  621325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  621336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  621339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  621342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  621345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  621374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621393 */     GIR_RootConstrainSelectedInstOperands,
     /*  621394 */     // GIR_Coverage, 5829,
     /*  621394 */     GIR_EraseRootFromParent_Done,
     /*  621395 */   // Label 10014: @621395
     /*  621395 */   GIM_Try, /*On fail goto*//*Label 10015*/ GIMT_Encode4(621470), // Rule ID 5832 //
     /*  621400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  621411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  621414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  621417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  621420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  621449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621468 */     GIR_RootConstrainSelectedInstOperands,
     /*  621469 */     // GIR_Coverage, 5832,
     /*  621469 */     GIR_EraseRootFromParent_Done,
     /*  621470 */   // Label 10015: @621470
     /*  621470 */   GIM_Try, /*On fail goto*//*Label 10016*/ GIMT_Encode4(621545), // Rule ID 5833 //
     /*  621475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  621486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  621489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  621492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  621495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  621524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621543 */     GIR_RootConstrainSelectedInstOperands,
     /*  621544 */     // GIR_Coverage, 5833,
     /*  621544 */     GIR_EraseRootFromParent_Done,
     /*  621545 */   // Label 10016: @621545
     /*  621545 */   GIM_Try, /*On fail goto*//*Label 10017*/ GIMT_Encode4(621620), // Rule ID 5836 //
     /*  621550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  621561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  621564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  621567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  621570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  621599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621618 */     GIR_RootConstrainSelectedInstOperands,
     /*  621619 */     // GIR_Coverage, 5836,
     /*  621619 */     GIR_EraseRootFromParent_Done,
     /*  621620 */   // Label 10017: @621620
     /*  621620 */   GIM_Try, /*On fail goto*//*Label 10018*/ GIMT_Encode4(621695), // Rule ID 5837 //
     /*  621625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  621636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  621639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  621642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  621645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621671 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  621674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621693 */     GIR_RootConstrainSelectedInstOperands,
     /*  621694 */     // GIR_Coverage, 5837,
     /*  621694 */     GIR_EraseRootFromParent_Done,
     /*  621695 */   // Label 10018: @621695
     /*  621695 */   GIM_Try, /*On fail goto*//*Label 10019*/ GIMT_Encode4(621770), // Rule ID 5840 //
     /*  621700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  621720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  621749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621768 */     GIR_RootConstrainSelectedInstOperands,
     /*  621769 */     // GIR_Coverage, 5840,
     /*  621769 */     GIR_EraseRootFromParent_Done,
     /*  621770 */   // Label 10019: @621770
     /*  621770 */   GIM_Try, /*On fail goto*//*Label 10020*/ GIMT_Encode4(621845), // Rule ID 5841 //
     /*  621775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  621795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  621824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621843 */     GIR_RootConstrainSelectedInstOperands,
     /*  621844 */     // GIR_Coverage, 5841,
     /*  621844 */     GIR_EraseRootFromParent_Done,
     /*  621845 */   // Label 10020: @621845
     /*  621845 */   GIM_Try, /*On fail goto*//*Label 10021*/ GIMT_Encode4(621920), // Rule ID 5844 //
     /*  621850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  621870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  621899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621918 */     GIR_RootConstrainSelectedInstOperands,
     /*  621919 */     // GIR_Coverage, 5844,
     /*  621919 */     GIR_EraseRootFromParent_Done,
     /*  621920 */   // Label 10021: @621920
     /*  621920 */   GIM_Try, /*On fail goto*//*Label 10022*/ GIMT_Encode4(621995), // Rule ID 5845 //
     /*  621925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  621945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  621974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621993 */     GIR_RootConstrainSelectedInstOperands,
     /*  621994 */     // GIR_Coverage, 5845,
     /*  621994 */     GIR_EraseRootFromParent_Done,
     /*  621995 */   // Label 10022: @621995
     /*  621995 */   GIM_Try, /*On fail goto*//*Label 10023*/ GIMT_Encode4(622070), // Rule ID 5848 //
     /*  622000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  622003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  622011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  622014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  622017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  622020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  622046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  622049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  622065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622068 */     GIR_RootConstrainSelectedInstOperands,
     /*  622069 */     // GIR_Coverage, 5848,
     /*  622069 */     GIR_EraseRootFromParent_Done,
     /*  622070 */   // Label 10023: @622070
     /*  622070 */   GIM_Try, /*On fail goto*//*Label 10024*/ GIMT_Encode4(622145), // Rule ID 5849 //
     /*  622075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  622078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  622086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  622089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  622092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  622095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622121 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  622121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  622124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  622140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622143 */     GIR_RootConstrainSelectedInstOperands,
     /*  622144 */     // GIR_Coverage, 5849,
     /*  622144 */     GIR_EraseRootFromParent_Done,
     /*  622145 */   // Label 10024: @622145
     /*  622145 */   GIM_Try, /*On fail goto*//*Label 10025*/ GIMT_Encode4(622220), // Rule ID 5852 //
     /*  622150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  622161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  622164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  622167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  622170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  622199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622218 */     GIR_RootConstrainSelectedInstOperands,
     /*  622219 */     // GIR_Coverage, 5852,
     /*  622219 */     GIR_EraseRootFromParent_Done,
     /*  622220 */   // Label 10025: @622220
     /*  622220 */   GIM_Try, /*On fail goto*//*Label 10026*/ GIMT_Encode4(622295), // Rule ID 5853 //
     /*  622225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  622236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  622239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  622242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622271 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  622274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622293 */     GIR_RootConstrainSelectedInstOperands,
     /*  622294 */     // GIR_Coverage, 5853,
     /*  622294 */     GIR_EraseRootFromParent_Done,
     /*  622295 */   // Label 10026: @622295
     /*  622295 */   GIM_Try, /*On fail goto*//*Label 10027*/ GIMT_Encode4(622370), // Rule ID 5856 //
     /*  622300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  622311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  622314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  622317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  622320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  622349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622368 */     GIR_RootConstrainSelectedInstOperands,
     /*  622369 */     // GIR_Coverage, 5856,
     /*  622369 */     GIR_EraseRootFromParent_Done,
     /*  622370 */   // Label 10027: @622370
     /*  622370 */   GIM_Try, /*On fail goto*//*Label 10028*/ GIMT_Encode4(622445), // Rule ID 5857 //
     /*  622375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  622386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  622389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  622392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622421 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  622424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622443 */     GIR_RootConstrainSelectedInstOperands,
     /*  622444 */     // GIR_Coverage, 5857,
     /*  622444 */     GIR_EraseRootFromParent_Done,
     /*  622445 */   // Label 10028: @622445
     /*  622445 */   GIM_Try, /*On fail goto*//*Label 10029*/ GIMT_Encode4(622520), // Rule ID 5860 //
     /*  622450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  622461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  622464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  622467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  622470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  622499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622518 */     GIR_RootConstrainSelectedInstOperands,
     /*  622519 */     // GIR_Coverage, 5860,
     /*  622519 */     GIR_EraseRootFromParent_Done,
     /*  622520 */   // Label 10029: @622520
     /*  622520 */   GIM_Try, /*On fail goto*//*Label 10030*/ GIMT_Encode4(622595), // Rule ID 5861 //
     /*  622525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  622536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  622539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  622542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622571 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  622574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622593 */     GIR_RootConstrainSelectedInstOperands,
     /*  622594 */     // GIR_Coverage, 5861,
     /*  622594 */     GIR_EraseRootFromParent_Done,
     /*  622595 */   // Label 10030: @622595
     /*  622595 */   GIM_Try, /*On fail goto*//*Label 10031*/ GIMT_Encode4(622670), // Rule ID 5864 //
     /*  622600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  622620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  622649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622668 */     GIR_RootConstrainSelectedInstOperands,
     /*  622669 */     // GIR_Coverage, 5864,
     /*  622669 */     GIR_EraseRootFromParent_Done,
     /*  622670 */   // Label 10031: @622670
     /*  622670 */   GIM_Try, /*On fail goto*//*Label 10032*/ GIMT_Encode4(622745), // Rule ID 5865 //
     /*  622675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622721 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  622724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622743 */     GIR_RootConstrainSelectedInstOperands,
     /*  622744 */     // GIR_Coverage, 5865,
     /*  622744 */     GIR_EraseRootFromParent_Done,
     /*  622745 */   // Label 10032: @622745
     /*  622745 */   GIM_Try, /*On fail goto*//*Label 10033*/ GIMT_Encode4(622820), // Rule ID 5868 //
     /*  622750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  622770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  622799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622818 */     GIR_RootConstrainSelectedInstOperands,
     /*  622819 */     // GIR_Coverage, 5868,
     /*  622819 */     GIR_EraseRootFromParent_Done,
     /*  622820 */   // Label 10033: @622820
     /*  622820 */   GIM_Try, /*On fail goto*//*Label 10034*/ GIMT_Encode4(622895), // Rule ID 5869 //
     /*  622825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  622874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622893 */     GIR_RootConstrainSelectedInstOperands,
     /*  622894 */     // GIR_Coverage, 5869,
     /*  622894 */     GIR_EraseRootFromParent_Done,
     /*  622895 */   // Label 10034: @622895
     /*  622895 */   GIM_Try, /*On fail goto*//*Label 10035*/ GIMT_Encode4(622970), // Rule ID 5872 //
     /*  622900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  622920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  622946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  622949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622968 */     GIR_RootConstrainSelectedInstOperands,
     /*  622969 */     // GIR_Coverage, 5872,
     /*  622969 */     GIR_EraseRootFromParent_Done,
     /*  622970 */   // Label 10035: @622970
     /*  622970 */   GIM_Try, /*On fail goto*//*Label 10036*/ GIMT_Encode4(623045), // Rule ID 5873 //
     /*  622975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623021 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  623021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  623024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623043 */     GIR_RootConstrainSelectedInstOperands,
     /*  623044 */     // GIR_Coverage, 5873,
     /*  623044 */     GIR_EraseRootFromParent_Done,
     /*  623045 */   // Label 10036: @623045
     /*  623045 */   GIM_Try, /*On fail goto*//*Label 10037*/ GIMT_Encode4(623120), // Rule ID 5876 //
     /*  623050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  623061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  623064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  623067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623118 */     GIR_RootConstrainSelectedInstOperands,
     /*  623119 */     // GIR_Coverage, 5876,
     /*  623119 */     GIR_EraseRootFromParent_Done,
     /*  623120 */   // Label 10037: @623120
     /*  623120 */   GIM_Try, /*On fail goto*//*Label 10038*/ GIMT_Encode4(623195), // Rule ID 5877 //
     /*  623125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  623136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  623139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  623142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  623145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623171 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623193 */     GIR_RootConstrainSelectedInstOperands,
     /*  623194 */     // GIR_Coverage, 5877,
     /*  623194 */     GIR_EraseRootFromParent_Done,
     /*  623195 */   // Label 10038: @623195
     /*  623195 */   GIM_Try, /*On fail goto*//*Label 10039*/ GIMT_Encode4(623270), // Rule ID 5880 //
     /*  623200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  623211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  623214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  623217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623268 */     GIR_RootConstrainSelectedInstOperands,
     /*  623269 */     // GIR_Coverage, 5880,
     /*  623269 */     GIR_EraseRootFromParent_Done,
     /*  623270 */   // Label 10039: @623270
     /*  623270 */   GIM_Try, /*On fail goto*//*Label 10040*/ GIMT_Encode4(623345), // Rule ID 5881 //
     /*  623275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  623286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  623289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  623292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  623295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623343 */     GIR_RootConstrainSelectedInstOperands,
     /*  623344 */     // GIR_Coverage, 5881,
     /*  623344 */     GIR_EraseRootFromParent_Done,
     /*  623345 */   // Label 10040: @623345
     /*  623345 */   GIM_Try, /*On fail goto*//*Label 10041*/ GIMT_Encode4(623420), // Rule ID 5884 //
     /*  623350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  623361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  623364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  623367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  623396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623418 */     GIR_RootConstrainSelectedInstOperands,
     /*  623419 */     // GIR_Coverage, 5884,
     /*  623419 */     GIR_EraseRootFromParent_Done,
     /*  623420 */   // Label 10041: @623420
     /*  623420 */   GIM_Try, /*On fail goto*//*Label 10042*/ GIMT_Encode4(623495), // Rule ID 5885 //
     /*  623425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  623436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  623439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  623442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  623445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  623471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623493 */     GIR_RootConstrainSelectedInstOperands,
     /*  623494 */     // GIR_Coverage, 5885,
     /*  623494 */     GIR_EraseRootFromParent_Done,
     /*  623495 */   // Label 10042: @623495
     /*  623495 */   GIM_Try, /*On fail goto*//*Label 10043*/ GIMT_Encode4(623570), // Rule ID 5888 //
     /*  623500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  623503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  623511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  623514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  623517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623546 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  623546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623568 */     GIR_RootConstrainSelectedInstOperands,
     /*  623569 */     // GIR_Coverage, 5888,
     /*  623569 */     GIR_EraseRootFromParent_Done,
     /*  623570 */   // Label 10043: @623570
     /*  623570 */   GIM_Try, /*On fail goto*//*Label 10044*/ GIMT_Encode4(623645), // Rule ID 5889 //
     /*  623575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  623578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  623586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  623589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  623592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  623595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623621 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  623621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623643 */     GIR_RootConstrainSelectedInstOperands,
     /*  623644 */     // GIR_Coverage, 5889,
     /*  623644 */     GIR_EraseRootFromParent_Done,
     /*  623645 */   // Label 10044: @623645
     /*  623645 */   GIM_Try, /*On fail goto*//*Label 10045*/ GIMT_Encode4(623720), // Rule ID 5892 //
     /*  623650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  623699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623718 */     GIR_RootConstrainSelectedInstOperands,
     /*  623719 */     // GIR_Coverage, 5892,
     /*  623719 */     GIR_EraseRootFromParent_Done,
     /*  623720 */   // Label 10045: @623720
     /*  623720 */   GIM_Try, /*On fail goto*//*Label 10046*/ GIMT_Encode4(623795), // Rule ID 5893 //
     /*  623725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  623745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623771 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  623774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623793 */     GIR_RootConstrainSelectedInstOperands,
     /*  623794 */     // GIR_Coverage, 5893,
     /*  623794 */     GIR_EraseRootFromParent_Done,
     /*  623795 */   // Label 10046: @623795
     /*  623795 */   GIM_Try, /*On fail goto*//*Label 10047*/ GIMT_Encode4(623870), // Rule ID 5896 //
     /*  623800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  623849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623868 */     GIR_RootConstrainSelectedInstOperands,
     /*  623869 */     // GIR_Coverage, 5896,
     /*  623869 */     GIR_EraseRootFromParent_Done,
     /*  623870 */   // Label 10047: @623870
     /*  623870 */   GIM_Try, /*On fail goto*//*Label 10048*/ GIMT_Encode4(623945), // Rule ID 5897 //
     /*  623875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  623895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  623924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623943 */     GIR_RootConstrainSelectedInstOperands,
     /*  623944 */     // GIR_Coverage, 5897,
     /*  623944 */     GIR_EraseRootFromParent_Done,
     /*  623945 */   // Label 10048: @623945
     /*  623945 */   GIM_Try, /*On fail goto*//*Label 10049*/ GIMT_Encode4(624020), // Rule ID 5900 //
     /*  623950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  623961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  623964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  623967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623996 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  623999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624018 */     GIR_RootConstrainSelectedInstOperands,
     /*  624019 */     // GIR_Coverage, 5900,
     /*  624019 */     GIR_EraseRootFromParent_Done,
     /*  624020 */   // Label 10049: @624020
     /*  624020 */   GIM_Try, /*On fail goto*//*Label 10050*/ GIMT_Encode4(624095), // Rule ID 5901 //
     /*  624025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  624036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  624039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  624042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624071 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  624071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  624074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624093 */     GIR_RootConstrainSelectedInstOperands,
     /*  624094 */     // GIR_Coverage, 5901,
     /*  624094 */     GIR_EraseRootFromParent_Done,
     /*  624095 */   // Label 10050: @624095
     /*  624095 */   GIM_Try, /*On fail goto*//*Label 10051*/ GIMT_Encode4(624170), // Rule ID 5904 //
     /*  624100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  624111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  624114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  624117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  624149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624168 */     GIR_RootConstrainSelectedInstOperands,
     /*  624169 */     // GIR_Coverage, 5904,
     /*  624169 */     GIR_EraseRootFromParent_Done,
     /*  624170 */   // Label 10051: @624170
     /*  624170 */   GIM_Try, /*On fail goto*//*Label 10052*/ GIMT_Encode4(624245), // Rule ID 5905 //
     /*  624175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  624186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  624189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  624192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  624224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624243 */     GIR_RootConstrainSelectedInstOperands,
     /*  624244 */     // GIR_Coverage, 5905,
     /*  624244 */     GIR_EraseRootFromParent_Done,
     /*  624245 */   // Label 10052: @624245
     /*  624245 */   GIM_Try, /*On fail goto*//*Label 10053*/ GIMT_Encode4(624320), // Rule ID 5908 //
     /*  624250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  624261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  624264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  624267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  624299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624318 */     GIR_RootConstrainSelectedInstOperands,
     /*  624319 */     // GIR_Coverage, 5908,
     /*  624319 */     GIR_EraseRootFromParent_Done,
     /*  624320 */   // Label 10053: @624320
     /*  624320 */   GIM_Try, /*On fail goto*//*Label 10054*/ GIMT_Encode4(624395), // Rule ID 5909 //
     /*  624325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  624336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  624339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  624342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624371 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  624374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624393 */     GIR_RootConstrainSelectedInstOperands,
     /*  624394 */     // GIR_Coverage, 5909,
     /*  624394 */     GIR_EraseRootFromParent_Done,
     /*  624395 */   // Label 10054: @624395
     /*  624395 */   GIM_Try, /*On fail goto*//*Label 10055*/ GIMT_Encode4(624470), // Rule ID 5912 //
     /*  624400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  624411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  624414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  624417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  624449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624468 */     GIR_RootConstrainSelectedInstOperands,
     /*  624469 */     // GIR_Coverage, 5912,
     /*  624469 */     GIR_EraseRootFromParent_Done,
     /*  624470 */   // Label 10055: @624470
     /*  624470 */   GIM_Try, /*On fail goto*//*Label 10056*/ GIMT_Encode4(624545), // Rule ID 5913 //
     /*  624475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  624486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  624489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  624492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  624524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624543 */     GIR_RootConstrainSelectedInstOperands,
     /*  624544 */     // GIR_Coverage, 5913,
     /*  624544 */     GIR_EraseRootFromParent_Done,
     /*  624545 */   // Label 10056: @624545
     /*  624545 */   GIM_Try, /*On fail goto*//*Label 10057*/ GIMT_Encode4(624620), // Rule ID 5916 //
     /*  624550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  624599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624618 */     GIR_RootConstrainSelectedInstOperands,
     /*  624619 */     // GIR_Coverage, 5916,
     /*  624619 */     GIR_EraseRootFromParent_Done,
     /*  624620 */   // Label 10057: @624620
     /*  624620 */   GIM_Try, /*On fail goto*//*Label 10058*/ GIMT_Encode4(624695), // Rule ID 5917 //
     /*  624625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624671 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  624674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624693 */     GIR_RootConstrainSelectedInstOperands,
     /*  624694 */     // GIR_Coverage, 5917,
     /*  624694 */     GIR_EraseRootFromParent_Done,
     /*  624695 */   // Label 10058: @624695
     /*  624695 */   GIM_Try, /*On fail goto*//*Label 10059*/ GIMT_Encode4(624770), // Rule ID 5920 //
     /*  624700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  624749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624768 */     GIR_RootConstrainSelectedInstOperands,
     /*  624769 */     // GIR_Coverage, 5920,
     /*  624769 */     GIR_EraseRootFromParent_Done,
     /*  624770 */   // Label 10059: @624770
     /*  624770 */   GIM_Try, /*On fail goto*//*Label 10060*/ GIMT_Encode4(624845), // Rule ID 5921 //
     /*  624775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624821 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  624824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624843 */     GIR_RootConstrainSelectedInstOperands,
     /*  624844 */     // GIR_Coverage, 5921,
     /*  624844 */     GIR_EraseRootFromParent_Done,
     /*  624845 */   // Label 10060: @624845
     /*  624845 */   GIM_Try, /*On fail goto*//*Label 10061*/ GIMT_Encode4(624920), // Rule ID 5924 //
     /*  624850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624896 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  624899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624918 */     GIR_RootConstrainSelectedInstOperands,
     /*  624919 */     // GIR_Coverage, 5924,
     /*  624919 */     GIR_EraseRootFromParent_Done,
     /*  624920 */   // Label 10061: @624920
     /*  624920 */   GIM_Try, /*On fail goto*//*Label 10062*/ GIMT_Encode4(624995), // Rule ID 5925 //
     /*  624925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624971 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  624974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624993 */     GIR_RootConstrainSelectedInstOperands,
     /*  624994 */     // GIR_Coverage, 5925,
     /*  624994 */     GIR_EraseRootFromParent_Done,
     /*  624995 */   // Label 10062: @624995
     /*  624995 */   GIM_Try, /*On fail goto*//*Label 10063*/ GIMT_Encode4(625070), // Rule ID 5928 //
     /*  625000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  625003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  625008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  625011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  625014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  625017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  625046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  625049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625068 */     GIR_RootConstrainSelectedInstOperands,
     /*  625069 */     // GIR_Coverage, 5928,
     /*  625069 */     GIR_EraseRootFromParent_Done,
     /*  625070 */   // Label 10063: @625070
     /*  625070 */   GIM_Try, /*On fail goto*//*Label 10064*/ GIMT_Encode4(625145), // Rule ID 5929 //
     /*  625075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  625083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  625086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  625089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  625092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  625124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625143 */     GIR_RootConstrainSelectedInstOperands,
     /*  625144 */     // GIR_Coverage, 5929,
     /*  625144 */     GIR_EraseRootFromParent_Done,
     /*  625145 */   // Label 10064: @625145
     /*  625145 */   GIM_Try, /*On fail goto*//*Label 10065*/ GIMT_Encode4(625220), // Rule ID 5932 //
     /*  625150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  625153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  625158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  625161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  625164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  625167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  625196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  625199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625218 */     GIR_RootConstrainSelectedInstOperands,
     /*  625219 */     // GIR_Coverage, 5932,
     /*  625219 */     GIR_EraseRootFromParent_Done,
     /*  625220 */   // Label 10065: @625220
     /*  625220 */   GIM_Try, /*On fail goto*//*Label 10066*/ GIMT_Encode4(625295), // Rule ID 5933 //
     /*  625225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  625233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  625236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  625239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  625242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  625274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625293 */     GIR_RootConstrainSelectedInstOperands,
     /*  625294 */     // GIR_Coverage, 5933,
     /*  625294 */     GIR_EraseRootFromParent_Done,
     /*  625295 */   // Label 10066: @625295
     /*  625295 */   GIM_Try, /*On fail goto*//*Label 10067*/ GIMT_Encode4(625370), // Rule ID 5936 //
     /*  625300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  625303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  625308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  625311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  625314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  625317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  625346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  625349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625368 */     GIR_RootConstrainSelectedInstOperands,
     /*  625369 */     // GIR_Coverage, 5936,
     /*  625369 */     GIR_EraseRootFromParent_Done,
     /*  625370 */   // Label 10067: @625370
     /*  625370 */   GIM_Try, /*On fail goto*//*Label 10068*/ GIMT_Encode4(625445), // Rule ID 5937 //
     /*  625375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  625383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  625386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  625389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  625392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625421 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  625424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625443 */     GIR_RootConstrainSelectedInstOperands,
     /*  625444 */     // GIR_Coverage, 5937,
     /*  625444 */     GIR_EraseRootFromParent_Done,
     /*  625445 */   // Label 10068: @625445
     /*  625445 */   GIM_Try, /*On fail goto*//*Label 10069*/ GIMT_Encode4(625520), // Rule ID 6028 //
     /*  625450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  625461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  625464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  625467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  625470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  625499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625518 */     GIR_RootConstrainSelectedInstOperands,
     /*  625519 */     // GIR_Coverage, 6028,
     /*  625519 */     GIR_EraseRootFromParent_Done,
     /*  625520 */   // Label 10069: @625520
     /*  625520 */   GIM_Try, /*On fail goto*//*Label 10070*/ GIMT_Encode4(625595), // Rule ID 6029 //
     /*  625525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  625536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  625539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  625542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  625545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625571 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  625574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625593 */     GIR_RootConstrainSelectedInstOperands,
     /*  625594 */     // GIR_Coverage, 6029,
     /*  625594 */     GIR_EraseRootFromParent_Done,
     /*  625595 */   // Label 10070: @625595
     /*  625595 */   GIM_Try, /*On fail goto*//*Label 10071*/ GIMT_Encode4(625670), // Rule ID 6032 //
     /*  625600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  625620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625646 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  625649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625668 */     GIR_RootConstrainSelectedInstOperands,
     /*  625669 */     // GIR_Coverage, 6032,
     /*  625669 */     GIR_EraseRootFromParent_Done,
     /*  625670 */   // Label 10071: @625670
     /*  625670 */   GIM_Try, /*On fail goto*//*Label 10072*/ GIMT_Encode4(625745), // Rule ID 6033 //
     /*  625675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  625695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625721 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  625724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625743 */     GIR_RootConstrainSelectedInstOperands,
     /*  625744 */     // GIR_Coverage, 6033,
     /*  625744 */     GIR_EraseRootFromParent_Done,
     /*  625745 */   // Label 10072: @625745
     /*  625745 */   GIM_Try, /*On fail goto*//*Label 10073*/ GIMT_Encode4(625820), // Rule ID 6036 //
     /*  625750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  625770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  625799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625818 */     GIR_RootConstrainSelectedInstOperands,
     /*  625819 */     // GIR_Coverage, 6036,
     /*  625819 */     GIR_EraseRootFromParent_Done,
     /*  625820 */   // Label 10073: @625820
     /*  625820 */   GIM_Try, /*On fail goto*//*Label 10074*/ GIMT_Encode4(625895), // Rule ID 6037 //
     /*  625825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  625845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625871 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  625874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625893 */     GIR_RootConstrainSelectedInstOperands,
     /*  625894 */     // GIR_Coverage, 6037,
     /*  625894 */     GIR_EraseRootFromParent_Done,
     /*  625895 */   // Label 10074: @625895
     /*  625895 */   GIM_Try, /*On fail goto*//*Label 10075*/ GIMT_Encode4(625970), // Rule ID 6040 //
     /*  625900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  625920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  625946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  625949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625968 */     GIR_RootConstrainSelectedInstOperands,
     /*  625969 */     // GIR_Coverage, 6040,
     /*  625969 */     GIR_EraseRootFromParent_Done,
     /*  625970 */   // Label 10075: @625970
     /*  625970 */   GIM_Try, /*On fail goto*//*Label 10076*/ GIMT_Encode4(626045), // Rule ID 6041 //
     /*  625975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  625995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626021 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  626024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626043 */     GIR_RootConstrainSelectedInstOperands,
     /*  626044 */     // GIR_Coverage, 6041,
     /*  626044 */     GIR_EraseRootFromParent_Done,
     /*  626045 */   // Label 10076: @626045
     /*  626045 */   GIM_Try, /*On fail goto*//*Label 10077*/ GIMT_Encode4(626120), // Rule ID 6044 //
     /*  626050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  626061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  626064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  626067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  626070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  626099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626118 */     GIR_RootConstrainSelectedInstOperands,
     /*  626119 */     // GIR_Coverage, 6044,
     /*  626119 */     GIR_EraseRootFromParent_Done,
     /*  626120 */   // Label 10077: @626120
     /*  626120 */   GIM_Try, /*On fail goto*//*Label 10078*/ GIMT_Encode4(626195), // Rule ID 6045 //
     /*  626125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  626136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  626139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  626142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  626145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  626174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626193 */     GIR_RootConstrainSelectedInstOperands,
     /*  626194 */     // GIR_Coverage, 6045,
     /*  626194 */     GIR_EraseRootFromParent_Done,
     /*  626195 */   // Label 10078: @626195
     /*  626195 */   GIM_Try, /*On fail goto*//*Label 10079*/ GIMT_Encode4(626270), // Rule ID 6048 //
     /*  626200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  626211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  626214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  626217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  626220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  626249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626268 */     GIR_RootConstrainSelectedInstOperands,
     /*  626269 */     // GIR_Coverage, 6048,
     /*  626269 */     GIR_EraseRootFromParent_Done,
     /*  626270 */   // Label 10079: @626270
     /*  626270 */   GIM_Try, /*On fail goto*//*Label 10080*/ GIMT_Encode4(626345), // Rule ID 6049 //
     /*  626275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  626286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  626289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  626292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  626295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626321 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  626321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  626324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626343 */     GIR_RootConstrainSelectedInstOperands,
     /*  626344 */     // GIR_Coverage, 6049,
     /*  626344 */     GIR_EraseRootFromParent_Done,
     /*  626345 */   // Label 10080: @626345
     /*  626345 */   GIM_Try, /*On fail goto*//*Label 10081*/ GIMT_Encode4(626420), // Rule ID 6052 //
     /*  626350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  626361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  626364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  626367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  626370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626418 */     GIR_RootConstrainSelectedInstOperands,
     /*  626419 */     // GIR_Coverage, 6052,
     /*  626419 */     GIR_EraseRootFromParent_Done,
     /*  626420 */   // Label 10081: @626420
     /*  626420 */   GIM_Try, /*On fail goto*//*Label 10082*/ GIMT_Encode4(626495), // Rule ID 6053 //
     /*  626425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  626436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  626439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  626442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  626445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626471 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626493 */     GIR_RootConstrainSelectedInstOperands,
     /*  626494 */     // GIR_Coverage, 6053,
     /*  626494 */     GIR_EraseRootFromParent_Done,
     /*  626495 */   // Label 10082: @626495
     /*  626495 */   GIM_Try, /*On fail goto*//*Label 10083*/ GIMT_Encode4(626570), // Rule ID 6056 //
     /*  626500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  626511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  626514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  626517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  626520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626568 */     GIR_RootConstrainSelectedInstOperands,
     /*  626569 */     // GIR_Coverage, 6056,
     /*  626569 */     GIR_EraseRootFromParent_Done,
     /*  626570 */   // Label 10083: @626570
     /*  626570 */   GIM_Try, /*On fail goto*//*Label 10084*/ GIMT_Encode4(626645), // Rule ID 6057 //
     /*  626575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  626586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  626589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  626592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  626595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626643 */     GIR_RootConstrainSelectedInstOperands,
     /*  626644 */     // GIR_Coverage, 6057,
     /*  626644 */     GIR_EraseRootFromParent_Done,
     /*  626645 */   // Label 10084: @626645
     /*  626645 */   GIM_Try, /*On fail goto*//*Label 10085*/ GIMT_Encode4(626720), // Rule ID 6060 //
     /*  626650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  626670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626718 */     GIR_RootConstrainSelectedInstOperands,
     /*  626719 */     // GIR_Coverage, 6060,
     /*  626719 */     GIR_EraseRootFromParent_Done,
     /*  626720 */   // Label 10085: @626720
     /*  626720 */   GIM_Try, /*On fail goto*//*Label 10086*/ GIMT_Encode4(626795), // Rule ID 6061 //
     /*  626725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  626745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626771 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  626771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626793 */     GIR_RootConstrainSelectedInstOperands,
     /*  626794 */     // GIR_Coverage, 6061,
     /*  626794 */     GIR_EraseRootFromParent_Done,
     /*  626795 */   // Label 10086: @626795
     /*  626795 */   GIM_Try, /*On fail goto*//*Label 10087*/ GIMT_Encode4(626870), // Rule ID 6064 //
     /*  626800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  626803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  626820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626846 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  626846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626868 */     GIR_RootConstrainSelectedInstOperands,
     /*  626869 */     // GIR_Coverage, 6064,
     /*  626869 */     GIR_EraseRootFromParent_Done,
     /*  626870 */   // Label 10087: @626870
     /*  626870 */   GIM_Try, /*On fail goto*//*Label 10088*/ GIMT_Encode4(626945), // Rule ID 6065 //
     /*  626875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  626878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  626895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626921 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  626921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626943 */     GIR_RootConstrainSelectedInstOperands,
     /*  626944 */     // GIR_Coverage, 6065,
     /*  626944 */     GIR_EraseRootFromParent_Done,
     /*  626945 */   // Label 10088: @626945
     /*  626945 */   GIM_Try, /*On fail goto*//*Label 10089*/ GIMT_Encode4(627020), // Rule ID 6068 //
     /*  626950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  626961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  626964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  626967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  626970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626996 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  626999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627018 */     GIR_RootConstrainSelectedInstOperands,
     /*  627019 */     // GIR_Coverage, 6068,
     /*  627019 */     GIR_EraseRootFromParent_Done,
     /*  627020 */   // Label 10089: @627020
     /*  627020 */   GIM_Try, /*On fail goto*//*Label 10090*/ GIMT_Encode4(627095), // Rule ID 6069 //
     /*  627025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  627036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  627039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  627042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  627045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627071 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  627074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627093 */     GIR_RootConstrainSelectedInstOperands,
     /*  627094 */     // GIR_Coverage, 6069,
     /*  627094 */     GIR_EraseRootFromParent_Done,
     /*  627095 */   // Label 10090: @627095
     /*  627095 */   GIM_Try, /*On fail goto*//*Label 10091*/ GIMT_Encode4(627170), // Rule ID 6072 //
     /*  627100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  627111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  627114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  627117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  627120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627146 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  627146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  627149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627168 */     GIR_RootConstrainSelectedInstOperands,
     /*  627169 */     // GIR_Coverage, 6072,
     /*  627169 */     GIR_EraseRootFromParent_Done,
     /*  627170 */   // Label 10091: @627170
     /*  627170 */   GIM_Try, /*On fail goto*//*Label 10092*/ GIMT_Encode4(627245), // Rule ID 6073 //
     /*  627175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  627186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  627189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  627192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  627195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627221 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  627224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627243 */     GIR_RootConstrainSelectedInstOperands,
     /*  627244 */     // GIR_Coverage, 6073,
     /*  627244 */     GIR_EraseRootFromParent_Done,
     /*  627245 */   // Label 10092: @627245
     /*  627245 */   GIM_Try, /*On fail goto*//*Label 10093*/ GIMT_Encode4(627320), // Rule ID 6076 //
     /*  627250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  627261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  627264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  627267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  627270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627296 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  627296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  627299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627318 */     GIR_RootConstrainSelectedInstOperands,
     /*  627319 */     // GIR_Coverage, 6076,
     /*  627319 */     GIR_EraseRootFromParent_Done,
     /*  627320 */   // Label 10093: @627320
     /*  627320 */   GIM_Try, /*On fail goto*//*Label 10094*/ GIMT_Encode4(627395), // Rule ID 6077 //
     /*  627325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  627336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  627339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  627342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  627345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627371 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  627374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627393 */     GIR_RootConstrainSelectedInstOperands,
     /*  627394 */     // GIR_Coverage, 6077,
     /*  627394 */     GIR_EraseRootFromParent_Done,
     /*  627395 */   // Label 10094: @627395
     /*  627395 */   GIM_Try, /*On fail goto*//*Label 10095*/ GIMT_Encode4(627470), // Rule ID 6080 //
     /*  627400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  627411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  627414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  627417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  627420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627446 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  627449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627468 */     GIR_RootConstrainSelectedInstOperands,
     /*  627469 */     // GIR_Coverage, 6080,
     /*  627469 */     GIR_EraseRootFromParent_Done,
     /*  627470 */   // Label 10095: @627470
     /*  627470 */   GIM_Try, /*On fail goto*//*Label 10096*/ GIMT_Encode4(627545), // Rule ID 6081 //
     /*  627475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  627486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  627489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  627492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  627495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  627524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627543 */     GIR_RootConstrainSelectedInstOperands,
     /*  627544 */     // GIR_Coverage, 6081,
     /*  627544 */     GIR_EraseRootFromParent_Done,
     /*  627545 */   // Label 10096: @627545
     /*  627545 */   GIM_Try, /*On fail goto*//*Label 10097*/ GIMT_Encode4(627620), // Rule ID 6084 //
     /*  627550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  627570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627596 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  627599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627618 */     GIR_RootConstrainSelectedInstOperands,
     /*  627619 */     // GIR_Coverage, 6084,
     /*  627619 */     GIR_EraseRootFromParent_Done,
     /*  627620 */   // Label 10097: @627620
     /*  627620 */   GIM_Try, /*On fail goto*//*Label 10098*/ GIMT_Encode4(627695), // Rule ID 6085 //
     /*  627625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  627645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627671 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  627674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627693 */     GIR_RootConstrainSelectedInstOperands,
     /*  627694 */     // GIR_Coverage, 6085,
     /*  627694 */     GIR_EraseRootFromParent_Done,
     /*  627695 */   // Label 10098: @627695
     /*  627695 */   GIM_Try, /*On fail goto*//*Label 10099*/ GIMT_Encode4(627770), // Rule ID 6088 //
     /*  627700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  627720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  627749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627768 */     GIR_RootConstrainSelectedInstOperands,
     /*  627769 */     // GIR_Coverage, 6088,
     /*  627769 */     GIR_EraseRootFromParent_Done,
     /*  627770 */   // Label 10099: @627770
     /*  627770 */   GIM_Try, /*On fail goto*//*Label 10100*/ GIMT_Encode4(627845), // Rule ID 6089 //
     /*  627775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  627795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627821 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  627824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627843 */     GIR_RootConstrainSelectedInstOperands,
     /*  627844 */     // GIR_Coverage, 6089,
     /*  627844 */     GIR_EraseRootFromParent_Done,
     /*  627845 */   // Label 10100: @627845
     /*  627845 */   GIM_Try, /*On fail goto*//*Label 10101*/ GIMT_Encode4(627920), // Rule ID 6092 //
     /*  627850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  627870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  627899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627918 */     GIR_RootConstrainSelectedInstOperands,
     /*  627919 */     // GIR_Coverage, 6092,
     /*  627919 */     GIR_EraseRootFromParent_Done,
     /*  627920 */   // Label 10101: @627920
     /*  627920 */   GIM_Try, /*On fail goto*//*Label 10102*/ GIMT_Encode4(627995), // Rule ID 6093 //
     /*  627925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  627945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  627974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627993 */     GIR_RootConstrainSelectedInstOperands,
     /*  627994 */     // GIR_Coverage, 6093,
     /*  627994 */     GIR_EraseRootFromParent_Done,
     /*  627995 */   // Label 10102: @627995
     /*  627995 */   GIM_Try, /*On fail goto*//*Label 10103*/ GIMT_Encode4(628070), // Rule ID 6096 //
     /*  628000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  628011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  628014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  628017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  628020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  628046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  628049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628068 */     GIR_RootConstrainSelectedInstOperands,
     /*  628069 */     // GIR_Coverage, 6096,
     /*  628069 */     GIR_EraseRootFromParent_Done,
     /*  628070 */   // Label 10103: @628070
     /*  628070 */   GIM_Try, /*On fail goto*//*Label 10104*/ GIMT_Encode4(628145), // Rule ID 6097 //
     /*  628075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  628086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  628089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  628092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  628095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  628121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  628124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628143 */     GIR_RootConstrainSelectedInstOperands,
     /*  628144 */     // GIR_Coverage, 6097,
     /*  628144 */     GIR_EraseRootFromParent_Done,
     /*  628145 */   // Label 10104: @628145
     /*  628145 */   GIM_Try, /*On fail goto*//*Label 10105*/ GIMT_Encode4(628220), // Rule ID 6100 //
     /*  628150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  628161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  628164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  628167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  628170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  628196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  628199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628218 */     GIR_RootConstrainSelectedInstOperands,
     /*  628219 */     // GIR_Coverage, 6100,
     /*  628219 */     GIR_EraseRootFromParent_Done,
     /*  628220 */   // Label 10105: @628220
     /*  628220 */   GIM_Try, /*On fail goto*//*Label 10106*/ GIMT_Encode4(628295), // Rule ID 6101 //
     /*  628225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  628236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  628239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  628242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  628245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628271 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  628271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  628274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628293 */     GIR_RootConstrainSelectedInstOperands,
     /*  628294 */     // GIR_Coverage, 6101,
     /*  628294 */     GIR_EraseRootFromParent_Done,
     /*  628295 */   // Label 10106: @628295
     /*  628295 */   GIM_Try, /*On fail goto*//*Label 10107*/ GIMT_Encode4(628370), // Rule ID 6104 //
     /*  628300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  628311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  628314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  628317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  628320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  628349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628368 */     GIR_RootConstrainSelectedInstOperands,
     /*  628369 */     // GIR_Coverage, 6104,
     /*  628369 */     GIR_EraseRootFromParent_Done,
     /*  628370 */   // Label 10107: @628370
     /*  628370 */   GIM_Try, /*On fail goto*//*Label 10108*/ GIMT_Encode4(628445), // Rule ID 6105 //
     /*  628375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  628386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  628389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  628392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  628395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  628424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628443 */     GIR_RootConstrainSelectedInstOperands,
     /*  628444 */     // GIR_Coverage, 6105,
     /*  628444 */     GIR_EraseRootFromParent_Done,
     /*  628445 */   // Label 10108: @628445
     /*  628445 */   GIM_Try, /*On fail goto*//*Label 10109*/ GIMT_Encode4(628520), // Rule ID 6108 //
     /*  628450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  628461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  628464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  628467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  628470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  628499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628518 */     GIR_RootConstrainSelectedInstOperands,
     /*  628519 */     // GIR_Coverage, 6108,
     /*  628519 */     GIR_EraseRootFromParent_Done,
     /*  628520 */   // Label 10109: @628520
     /*  628520 */   GIM_Try, /*On fail goto*//*Label 10110*/ GIMT_Encode4(628595), // Rule ID 6109 //
     /*  628525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  628536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  628539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  628542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  628545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628571 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  628574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628593 */     GIR_RootConstrainSelectedInstOperands,
     /*  628594 */     // GIR_Coverage, 6109,
     /*  628594 */     GIR_EraseRootFromParent_Done,
     /*  628595 */   // Label 10110: @628595
     /*  628595 */   GIM_Try, /*On fail goto*//*Label 10111*/ GIMT_Encode4(628670), // Rule ID 6112 //
     /*  628600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  628620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  628649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628668 */     GIR_RootConstrainSelectedInstOperands,
     /*  628669 */     // GIR_Coverage, 6112,
     /*  628669 */     GIR_EraseRootFromParent_Done,
     /*  628670 */   // Label 10111: @628670
     /*  628670 */   GIM_Try, /*On fail goto*//*Label 10112*/ GIMT_Encode4(628745), // Rule ID 6113 //
     /*  628675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  628695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628721 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  628724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628743 */     GIR_RootConstrainSelectedInstOperands,
     /*  628744 */     // GIR_Coverage, 6113,
     /*  628744 */     GIR_EraseRootFromParent_Done,
     /*  628745 */   // Label 10112: @628745
     /*  628745 */   GIM_Try, /*On fail goto*//*Label 10113*/ GIMT_Encode4(628820), // Rule ID 6116 //
     /*  628750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628796 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  628799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628818 */     GIR_RootConstrainSelectedInstOperands,
     /*  628819 */     // GIR_Coverage, 6116,
     /*  628819 */     GIR_EraseRootFromParent_Done,
     /*  628820 */   // Label 10113: @628820
     /*  628820 */   GIM_Try, /*On fail goto*//*Label 10114*/ GIMT_Encode4(628895), // Rule ID 6117 //
     /*  628825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628871 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  628874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628893 */     GIR_RootConstrainSelectedInstOperands,
     /*  628894 */     // GIR_Coverage, 6117,
     /*  628894 */     GIR_EraseRootFromParent_Done,
     /*  628895 */   // Label 10114: @628895
     /*  628895 */   GIM_Try, /*On fail goto*//*Label 10115*/ GIMT_Encode4(628970), // Rule ID 6120 //
     /*  628900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628946 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  628949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628968 */     GIR_RootConstrainSelectedInstOperands,
     /*  628969 */     // GIR_Coverage, 6120,
     /*  628969 */     GIR_EraseRootFromParent_Done,
     /*  628970 */   // Label 10115: @628970
     /*  628970 */   GIM_Try, /*On fail goto*//*Label 10116*/ GIMT_Encode4(629045), // Rule ID 6121 //
     /*  628975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629021 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  629024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629043 */     GIR_RootConstrainSelectedInstOperands,
     /*  629044 */     // GIR_Coverage, 6121,
     /*  629044 */     GIR_EraseRootFromParent_Done,
     /*  629045 */   // Label 10116: @629045
     /*  629045 */   GIM_Try, /*On fail goto*//*Label 10117*/ GIMT_Encode4(629120), // Rule ID 6124 //
     /*  629050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  629061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  629064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  629067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  629099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629118 */     GIR_RootConstrainSelectedInstOperands,
     /*  629119 */     // GIR_Coverage, 6124,
     /*  629119 */     GIR_EraseRootFromParent_Done,
     /*  629120 */   // Label 10117: @629120
     /*  629120 */   GIM_Try, /*On fail goto*//*Label 10118*/ GIMT_Encode4(629195), // Rule ID 6125 //
     /*  629125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  629136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  629139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  629142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  629145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629171 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  629174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629193 */     GIR_RootConstrainSelectedInstOperands,
     /*  629194 */     // GIR_Coverage, 6125,
     /*  629194 */     GIR_EraseRootFromParent_Done,
     /*  629195 */   // Label 10118: @629195
     /*  629195 */   GIM_Try, /*On fail goto*//*Label 10119*/ GIMT_Encode4(629270), // Rule ID 6128 //
     /*  629200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  629211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  629214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  629217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629246 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  629249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629268 */     GIR_RootConstrainSelectedInstOperands,
     /*  629269 */     // GIR_Coverage, 6128,
     /*  629269 */     GIR_EraseRootFromParent_Done,
     /*  629270 */   // Label 10119: @629270
     /*  629270 */   GIM_Try, /*On fail goto*//*Label 10120*/ GIMT_Encode4(629345), // Rule ID 6129 //
     /*  629275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  629286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  629289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  629292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  629295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629321 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  629324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629343 */     GIR_RootConstrainSelectedInstOperands,
     /*  629344 */     // GIR_Coverage, 6129,
     /*  629344 */     GIR_EraseRootFromParent_Done,
     /*  629345 */   // Label 10120: @629345
     /*  629345 */   GIM_Try, /*On fail goto*//*Label 10121*/ GIMT_Encode4(629420), // Rule ID 6132 //
     /*  629350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  629361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  629364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  629367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629396 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  629399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629418 */     GIR_RootConstrainSelectedInstOperands,
     /*  629419 */     // GIR_Coverage, 6132,
     /*  629419 */     GIR_EraseRootFromParent_Done,
     /*  629420 */   // Label 10121: @629420
     /*  629420 */   GIM_Try, /*On fail goto*//*Label 10122*/ GIMT_Encode4(629495), // Rule ID 6133 //
     /*  629425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  629436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  629439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  629442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  629445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629471 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  629474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629493 */     GIR_RootConstrainSelectedInstOperands,
     /*  629494 */     // GIR_Coverage, 6133,
     /*  629494 */     GIR_EraseRootFromParent_Done,
     /*  629495 */   // Label 10122: @629495
     /*  629495 */   GIM_Try, /*On fail goto*//*Label 10123*/ GIMT_Encode4(629570), // Rule ID 6136 //
     /*  629500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  629511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  629514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  629517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  629549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629568 */     GIR_RootConstrainSelectedInstOperands,
     /*  629569 */     // GIR_Coverage, 6136,
     /*  629569 */     GIR_EraseRootFromParent_Done,
     /*  629570 */   // Label 10123: @629570
     /*  629570 */   GIM_Try, /*On fail goto*//*Label 10124*/ GIMT_Encode4(629645), // Rule ID 6137 //
     /*  629575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  629586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  629589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  629592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  629595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629621 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  629621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  629624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629643 */     GIR_RootConstrainSelectedInstOperands,
     /*  629644 */     // GIR_Coverage, 6137,
     /*  629644 */     GIR_EraseRootFromParent_Done,
     /*  629645 */   // Label 10124: @629645
     /*  629645 */   GIM_Try, /*On fail goto*//*Label 10125*/ GIMT_Encode4(629720), // Rule ID 6140 //
     /*  629650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  629699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629718 */     GIR_RootConstrainSelectedInstOperands,
     /*  629719 */     // GIR_Coverage, 6140,
     /*  629719 */     GIR_EraseRootFromParent_Done,
     /*  629720 */   // Label 10125: @629720
     /*  629720 */   GIM_Try, /*On fail goto*//*Label 10126*/ GIMT_Encode4(629795), // Rule ID 6141 //
     /*  629725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  629745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629771 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  629774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629793 */     GIR_RootConstrainSelectedInstOperands,
     /*  629794 */     // GIR_Coverage, 6141,
     /*  629794 */     GIR_EraseRootFromParent_Done,
     /*  629795 */   // Label 10126: @629795
     /*  629795 */   GIM_Try, /*On fail goto*//*Label 10127*/ GIMT_Encode4(629870), // Rule ID 6144 //
     /*  629800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629846 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  629849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629868 */     GIR_RootConstrainSelectedInstOperands,
     /*  629869 */     // GIR_Coverage, 6144,
     /*  629869 */     GIR_EraseRootFromParent_Done,
     /*  629870 */   // Label 10127: @629870
     /*  629870 */   GIM_Try, /*On fail goto*//*Label 10128*/ GIMT_Encode4(629945), // Rule ID 6145 //
     /*  629875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  629895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629921 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  629924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629943 */     GIR_RootConstrainSelectedInstOperands,
     /*  629944 */     // GIR_Coverage, 6145,
     /*  629944 */     GIR_EraseRootFromParent_Done,
     /*  629945 */   // Label 10128: @629945
     /*  629945 */   GIM_Try, /*On fail goto*//*Label 10129*/ GIMT_Encode4(630020), // Rule ID 6148 //
     /*  629950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  629961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  629964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  629967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  629999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630018 */     GIR_RootConstrainSelectedInstOperands,
     /*  630019 */     // GIR_Coverage, 6148,
     /*  630019 */     GIR_EraseRootFromParent_Done,
     /*  630020 */   // Label 10129: @630020
     /*  630020 */   GIM_Try, /*On fail goto*//*Label 10130*/ GIMT_Encode4(630095), // Rule ID 6149 //
     /*  630025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  630036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  630039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  630042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  630071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  630074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630093 */     GIR_RootConstrainSelectedInstOperands,
     /*  630094 */     // GIR_Coverage, 6149,
     /*  630094 */     GIR_EraseRootFromParent_Done,
     /*  630095 */   // Label 10130: @630095
     /*  630095 */   GIM_Try, /*On fail goto*//*Label 10131*/ GIMT_Encode4(630170), // Rule ID 6152 //
     /*  630100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  630103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  630111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  630114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  630117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  630120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630146 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  630146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  630149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630168 */     GIR_RootConstrainSelectedInstOperands,
     /*  630169 */     // GIR_Coverage, 6152,
     /*  630169 */     GIR_EraseRootFromParent_Done,
     /*  630170 */   // Label 10131: @630170
     /*  630170 */   GIM_Try, /*On fail goto*//*Label 10132*/ GIMT_Encode4(630245), // Rule ID 6153 //
     /*  630175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  630178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  630186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  630189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  630192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630221 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  630221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  630224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630243 */     GIR_RootConstrainSelectedInstOperands,
     /*  630244 */     // GIR_Coverage, 6153,
     /*  630244 */     GIR_EraseRootFromParent_Done,
     /*  630245 */   // Label 10132: @630245
     /*  630245 */   GIM_Try, /*On fail goto*//*Label 10133*/ GIMT_Encode4(630320), // Rule ID 6156 //
     /*  630250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  630261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  630264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  630267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  630270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630296 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  630299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630318 */     GIR_RootConstrainSelectedInstOperands,
     /*  630319 */     // GIR_Coverage, 6156,
     /*  630319 */     GIR_EraseRootFromParent_Done,
     /*  630320 */   // Label 10133: @630320
     /*  630320 */   GIM_Try, /*On fail goto*//*Label 10134*/ GIMT_Encode4(630395), // Rule ID 6157 //
     /*  630325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  630336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  630339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  630342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  630374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630393 */     GIR_RootConstrainSelectedInstOperands,
     /*  630394 */     // GIR_Coverage, 6157,
     /*  630394 */     GIR_EraseRootFromParent_Done,
     /*  630395 */   // Label 10134: @630395
     /*  630395 */   GIM_Try, /*On fail goto*//*Label 10135*/ GIMT_Encode4(630470), // Rule ID 6160 //
     /*  630400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  630411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  630414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  630417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  630420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630446 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  630449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630468 */     GIR_RootConstrainSelectedInstOperands,
     /*  630469 */     // GIR_Coverage, 6160,
     /*  630469 */     GIR_EraseRootFromParent_Done,
     /*  630470 */   // Label 10135: @630470
     /*  630470 */   GIM_Try, /*On fail goto*//*Label 10136*/ GIMT_Encode4(630545), // Rule ID 6161 //
     /*  630475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  630486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  630489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  630492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630521 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  630524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630543 */     GIR_RootConstrainSelectedInstOperands,
     /*  630544 */     // GIR_Coverage, 6161,
     /*  630544 */     GIR_EraseRootFromParent_Done,
     /*  630545 */   // Label 10136: @630545
     /*  630545 */   GIM_Try, /*On fail goto*//*Label 10137*/ GIMT_Encode4(630620), // Rule ID 6164 //
     /*  630550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  630570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630596 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  630599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630618 */     GIR_RootConstrainSelectedInstOperands,
     /*  630619 */     // GIR_Coverage, 6164,
     /*  630619 */     GIR_EraseRootFromParent_Done,
     /*  630620 */   // Label 10137: @630620
     /*  630620 */   GIM_Try, /*On fail goto*//*Label 10138*/ GIMT_Encode4(630695), // Rule ID 6165 //
     /*  630625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630671 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  630674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630693 */     GIR_RootConstrainSelectedInstOperands,
     /*  630694 */     // GIR_Coverage, 6165,
     /*  630694 */     GIR_EraseRootFromParent_Done,
     /*  630695 */   // Label 10138: @630695
     /*  630695 */   GIM_Try, /*On fail goto*//*Label 10139*/ GIMT_Encode4(630770), // Rule ID 6168 //
     /*  630700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  630720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  630749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630768 */     GIR_RootConstrainSelectedInstOperands,
     /*  630769 */     // GIR_Coverage, 6168,
     /*  630769 */     GIR_EraseRootFromParent_Done,
     /*  630770 */   // Label 10139: @630770
     /*  630770 */   GIM_Try, /*On fail goto*//*Label 10140*/ GIMT_Encode4(630845), // Rule ID 6169 //
     /*  630775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630821 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  630824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630843 */     GIR_RootConstrainSelectedInstOperands,
     /*  630844 */     // GIR_Coverage, 6169,
     /*  630844 */     GIR_EraseRootFromParent_Done,
     /*  630845 */   // Label 10140: @630845
     /*  630845 */   GIM_Try, /*On fail goto*//*Label 10141*/ GIMT_Encode4(630920), // Rule ID 6172 //
     /*  630850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  630870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630896 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  630899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630918 */     GIR_RootConstrainSelectedInstOperands,
     /*  630919 */     // GIR_Coverage, 6172,
     /*  630919 */     GIR_EraseRootFromParent_Done,
     /*  630920 */   // Label 10141: @630920
     /*  630920 */   GIM_Try, /*On fail goto*//*Label 10142*/ GIMT_Encode4(630995), // Rule ID 6173 //
     /*  630925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630971 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  630974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630993 */     GIR_RootConstrainSelectedInstOperands,
     /*  630994 */     // GIR_Coverage, 6173,
     /*  630994 */     GIR_EraseRootFromParent_Done,
     /*  630995 */   // Label 10142: @630995
     /*  630995 */   GIM_Try, /*On fail goto*//*Label 10143*/ GIMT_Encode4(631070), // Rule ID 6176 //
     /*  631000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  631011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  631014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  631017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  631046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  631049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  631065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631068 */     GIR_RootConstrainSelectedInstOperands,
     /*  631069 */     // GIR_Coverage, 6176,
     /*  631069 */     GIR_EraseRootFromParent_Done,
     /*  631070 */   // Label 10143: @631070
     /*  631070 */   GIM_Try, /*On fail goto*//*Label 10144*/ GIMT_Encode4(631145), // Rule ID 6177 //
     /*  631075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  631086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  631089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  631092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631121 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  631121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  631124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  631140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631143 */     GIR_RootConstrainSelectedInstOperands,
     /*  631144 */     // GIR_Coverage, 6177,
     /*  631144 */     GIR_EraseRootFromParent_Done,
     /*  631145 */   // Label 10144: @631145
     /*  631145 */   GIM_Try, /*On fail goto*//*Label 10145*/ GIMT_Encode4(631220), // Rule ID 6180 //
     /*  631150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  631161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  631164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  631167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  631199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631218 */     GIR_RootConstrainSelectedInstOperands,
     /*  631219 */     // GIR_Coverage, 6180,
     /*  631219 */     GIR_EraseRootFromParent_Done,
     /*  631220 */   // Label 10145: @631220
     /*  631220 */   GIM_Try, /*On fail goto*//*Label 10146*/ GIMT_Encode4(631295), // Rule ID 6181 //
     /*  631225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  631236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  631239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  631242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  631274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631293 */     GIR_RootConstrainSelectedInstOperands,
     /*  631294 */     // GIR_Coverage, 6181,
     /*  631294 */     GIR_EraseRootFromParent_Done,
     /*  631295 */   // Label 10146: @631295
     /*  631295 */   GIM_Try, /*On fail goto*//*Label 10147*/ GIMT_Encode4(631370), // Rule ID 6184 //
     /*  631300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  631311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  631314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  631317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  631349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631368 */     GIR_RootConstrainSelectedInstOperands,
     /*  631369 */     // GIR_Coverage, 6184,
     /*  631369 */     GIR_EraseRootFromParent_Done,
     /*  631370 */   // Label 10147: @631370
     /*  631370 */   GIM_Try, /*On fail goto*//*Label 10148*/ GIMT_Encode4(631445), // Rule ID 6185 //
     /*  631375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  631386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  631389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  631392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  631424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631443 */     GIR_RootConstrainSelectedInstOperands,
     /*  631444 */     // GIR_Coverage, 6185,
     /*  631444 */     GIR_EraseRootFromParent_Done,
     /*  631445 */   // Label 10148: @631445
     /*  631445 */   GIM_Try, /*On fail goto*//*Label 10149*/ GIMT_Encode4(631520), // Rule ID 6188 //
     /*  631450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  631461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  631464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  631467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631496 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  631499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631518 */     GIR_RootConstrainSelectedInstOperands,
     /*  631519 */     // GIR_Coverage, 6188,
     /*  631519 */     GIR_EraseRootFromParent_Done,
     /*  631520 */   // Label 10149: @631520
     /*  631520 */   GIM_Try, /*On fail goto*//*Label 10150*/ GIMT_Encode4(631595), // Rule ID 6189 //
     /*  631525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  631536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  631539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  631542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631571 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  631574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631593 */     GIR_RootConstrainSelectedInstOperands,
     /*  631594 */     // GIR_Coverage, 6189,
     /*  631594 */     GIR_EraseRootFromParent_Done,
     /*  631595 */   // Label 10150: @631595
     /*  631595 */   GIM_Try, /*On fail goto*//*Label 10151*/ GIMT_Encode4(631670), // Rule ID 6192 //
     /*  631600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  631649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631668 */     GIR_RootConstrainSelectedInstOperands,
     /*  631669 */     // GIR_Coverage, 6192,
     /*  631669 */     GIR_EraseRootFromParent_Done,
     /*  631670 */   // Label 10151: @631670
     /*  631670 */   GIM_Try, /*On fail goto*//*Label 10152*/ GIMT_Encode4(631745), // Rule ID 6193 //
     /*  631675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631721 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  631724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631743 */     GIR_RootConstrainSelectedInstOperands,
     /*  631744 */     // GIR_Coverage, 6193,
     /*  631744 */     GIR_EraseRootFromParent_Done,
     /*  631745 */   // Label 10152: @631745
     /*  631745 */   GIM_Try, /*On fail goto*//*Label 10153*/ GIMT_Encode4(631820), // Rule ID 6196 //
     /*  631750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631796 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  631799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631818 */     GIR_RootConstrainSelectedInstOperands,
     /*  631819 */     // GIR_Coverage, 6196,
     /*  631819 */     GIR_EraseRootFromParent_Done,
     /*  631820 */   // Label 10153: @631820
     /*  631820 */   GIM_Try, /*On fail goto*//*Label 10154*/ GIMT_Encode4(631895), // Rule ID 6197 //
     /*  631825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631871 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  631874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631893 */     GIR_RootConstrainSelectedInstOperands,
     /*  631894 */     // GIR_Coverage, 6197,
     /*  631894 */     GIR_EraseRootFromParent_Done,
     /*  631895 */   // Label 10154: @631895
     /*  631895 */   GIM_Try, /*On fail goto*//*Label 10155*/ GIMT_Encode4(631970), // Rule ID 6200 //
     /*  631900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  631949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631968 */     GIR_RootConstrainSelectedInstOperands,
     /*  631969 */     // GIR_Coverage, 6200,
     /*  631969 */     GIR_EraseRootFromParent_Done,
     /*  631970 */   // Label 10155: @631970
     /*  631970 */   GIM_Try, /*On fail goto*//*Label 10156*/ GIMT_Encode4(632045), // Rule ID 6201 //
     /*  631975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  632002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  632006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  632010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632021 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  632021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  632024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  632040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632043 */     GIR_RootConstrainSelectedInstOperands,
     /*  632044 */     // GIR_Coverage, 6201,
     /*  632044 */     GIR_EraseRootFromParent_Done,
     /*  632045 */   // Label 10156: @632045
     /*  632045 */   GIM_Try, /*On fail goto*//*Label 10157*/ GIMT_Encode4(632120), // Rule ID 6292 //
     /*  632050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  632061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  632064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  632067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  632070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632096 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  632099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632118 */     GIR_RootConstrainSelectedInstOperands,
     /*  632119 */     // GIR_Coverage, 6292,
     /*  632119 */     GIR_EraseRootFromParent_Done,
     /*  632120 */   // Label 10157: @632120
     /*  632120 */   GIM_Try, /*On fail goto*//*Label 10158*/ GIMT_Encode4(632195), // Rule ID 6293 //
     /*  632125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  632136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  632139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  632142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  632145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632171 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  632174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632193 */     GIR_RootConstrainSelectedInstOperands,
     /*  632194 */     // GIR_Coverage, 6293,
     /*  632194 */     GIR_EraseRootFromParent_Done,
     /*  632195 */   // Label 10158: @632195
     /*  632195 */   GIM_Try, /*On fail goto*//*Label 10159*/ GIMT_Encode4(632270), // Rule ID 6296 //
     /*  632200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  632211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  632214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  632217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  632220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632246 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  632249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632268 */     GIR_RootConstrainSelectedInstOperands,
     /*  632269 */     // GIR_Coverage, 6296,
     /*  632269 */     GIR_EraseRootFromParent_Done,
     /*  632270 */   // Label 10159: @632270
     /*  632270 */   GIM_Try, /*On fail goto*//*Label 10160*/ GIMT_Encode4(632345), // Rule ID 6297 //
     /*  632275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  632286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  632289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  632292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  632295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632321 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  632324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632343 */     GIR_RootConstrainSelectedInstOperands,
     /*  632344 */     // GIR_Coverage, 6297,
     /*  632344 */     GIR_EraseRootFromParent_Done,
     /*  632345 */   // Label 10160: @632345
     /*  632345 */   GIM_Try, /*On fail goto*//*Label 10161*/ GIMT_Encode4(632420), // Rule ID 6300 //
     /*  632350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  632361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  632364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  632367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  632370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  632399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632418 */     GIR_RootConstrainSelectedInstOperands,
     /*  632419 */     // GIR_Coverage, 6300,
     /*  632419 */     GIR_EraseRootFromParent_Done,
     /*  632420 */   // Label 10161: @632420
     /*  632420 */   GIM_Try, /*On fail goto*//*Label 10162*/ GIMT_Encode4(632495), // Rule ID 6301 //
     /*  632425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  632436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  632439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  632442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  632445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632471 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  632474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632493 */     GIR_RootConstrainSelectedInstOperands,
     /*  632494 */     // GIR_Coverage, 6301,
     /*  632494 */     GIR_EraseRootFromParent_Done,
     /*  632495 */   // Label 10162: @632495
     /*  632495 */   GIM_Try, /*On fail goto*//*Label 10163*/ GIMT_Encode4(632570), // Rule ID 6304 //
     /*  632500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  632511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  632514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  632517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  632520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  632549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632568 */     GIR_RootConstrainSelectedInstOperands,
     /*  632569 */     // GIR_Coverage, 6304,
     /*  632569 */     GIR_EraseRootFromParent_Done,
     /*  632570 */   // Label 10163: @632570
     /*  632570 */   GIM_Try, /*On fail goto*//*Label 10164*/ GIMT_Encode4(632645), // Rule ID 6305 //
     /*  632575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  632586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  632589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  632592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  632595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632621 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  632624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632643 */     GIR_RootConstrainSelectedInstOperands,
     /*  632644 */     // GIR_Coverage, 6305,
     /*  632644 */     GIR_EraseRootFromParent_Done,
     /*  632645 */   // Label 10164: @632645
     /*  632645 */   GIM_Try, /*On fail goto*//*Label 10165*/ GIMT_Encode4(632720), // Rule ID 6308 //
     /*  632650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  632670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  632699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632718 */     GIR_RootConstrainSelectedInstOperands,
     /*  632719 */     // GIR_Coverage, 6308,
     /*  632719 */     GIR_EraseRootFromParent_Done,
     /*  632720 */   // Label 10165: @632720
     /*  632720 */   GIM_Try, /*On fail goto*//*Label 10166*/ GIMT_Encode4(632795), // Rule ID 6309 //
     /*  632725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  632745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632771 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  632774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632793 */     GIR_RootConstrainSelectedInstOperands,
     /*  632794 */     // GIR_Coverage, 6309,
     /*  632794 */     GIR_EraseRootFromParent_Done,
     /*  632795 */   // Label 10166: @632795
     /*  632795 */   GIM_Try, /*On fail goto*//*Label 10167*/ GIMT_Encode4(632870), // Rule ID 6312 //
     /*  632800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  632820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  632846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  632849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632868 */     GIR_RootConstrainSelectedInstOperands,
     /*  632869 */     // GIR_Coverage, 6312,
     /*  632869 */     GIR_EraseRootFromParent_Done,
     /*  632870 */   // Label 10167: @632870
     /*  632870 */   GIM_Try, /*On fail goto*//*Label 10168*/ GIMT_Encode4(632945), // Rule ID 6313 //
     /*  632875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  632895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632921 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  632921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  632924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632943 */     GIR_RootConstrainSelectedInstOperands,
     /*  632944 */     // GIR_Coverage, 6313,
     /*  632944 */     GIR_EraseRootFromParent_Done,
     /*  632945 */   // Label 10168: @632945
     /*  632945 */   GIM_Try, /*On fail goto*//*Label 10169*/ GIMT_Encode4(633020), // Rule ID 6316 //
     /*  632950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  632961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  632964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  632967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  632970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  632999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633018 */     GIR_RootConstrainSelectedInstOperands,
     /*  633019 */     // GIR_Coverage, 6316,
     /*  633019 */     GIR_EraseRootFromParent_Done,
     /*  633020 */   // Label 10169: @633020
     /*  633020 */   GIM_Try, /*On fail goto*//*Label 10170*/ GIMT_Encode4(633095), // Rule ID 6317 //
     /*  633025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  633036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  633039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  633042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  633045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633071 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633093 */     GIR_RootConstrainSelectedInstOperands,
     /*  633094 */     // GIR_Coverage, 6317,
     /*  633094 */     GIR_EraseRootFromParent_Done,
     /*  633095 */   // Label 10170: @633095
     /*  633095 */   GIM_Try, /*On fail goto*//*Label 10171*/ GIMT_Encode4(633170), // Rule ID 6320 //
     /*  633100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  633111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  633114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  633117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  633120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633168 */     GIR_RootConstrainSelectedInstOperands,
     /*  633169 */     // GIR_Coverage, 6320,
     /*  633169 */     GIR_EraseRootFromParent_Done,
     /*  633170 */   // Label 10171: @633170
     /*  633170 */   GIM_Try, /*On fail goto*//*Label 10172*/ GIMT_Encode4(633245), // Rule ID 6321 //
     /*  633175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  633186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  633189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  633192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  633195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633221 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633243 */     GIR_RootConstrainSelectedInstOperands,
     /*  633244 */     // GIR_Coverage, 6321,
     /*  633244 */     GIR_EraseRootFromParent_Done,
     /*  633245 */   // Label 10172: @633245
     /*  633245 */   GIM_Try, /*On fail goto*//*Label 10173*/ GIMT_Encode4(633320), // Rule ID 6324 //
     /*  633250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  633261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  633264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  633267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  633270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  633296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633318 */     GIR_RootConstrainSelectedInstOperands,
     /*  633319 */     // GIR_Coverage, 6324,
     /*  633319 */     GIR_EraseRootFromParent_Done,
     /*  633320 */   // Label 10173: @633320
     /*  633320 */   GIM_Try, /*On fail goto*//*Label 10174*/ GIMT_Encode4(633395), // Rule ID 6325 //
     /*  633325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  633336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  633339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  633342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  633345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633371 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  633371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633393 */     GIR_RootConstrainSelectedInstOperands,
     /*  633394 */     // GIR_Coverage, 6325,
     /*  633394 */     GIR_EraseRootFromParent_Done,
     /*  633395 */   // Label 10174: @633395
     /*  633395 */   GIM_Try, /*On fail goto*//*Label 10175*/ GIMT_Encode4(633470), // Rule ID 6328 //
     /*  633400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  633403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  633411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  633414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  633417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  633420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  633446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  633465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633468 */     GIR_RootConstrainSelectedInstOperands,
     /*  633469 */     // GIR_Coverage, 6328,
     /*  633469 */     GIR_EraseRootFromParent_Done,
     /*  633470 */   // Label 10175: @633470
     /*  633470 */   GIM_Try, /*On fail goto*//*Label 10176*/ GIMT_Encode4(633545), // Rule ID 6329 //
     /*  633475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  633478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  633486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  633489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  633492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  633495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633521 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  633521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  633540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633543 */     GIR_RootConstrainSelectedInstOperands,
     /*  633544 */     // GIR_Coverage, 6329,
     /*  633544 */     GIR_EraseRootFromParent_Done,
     /*  633545 */   // Label 10176: @633545
     /*  633545 */   GIM_Try, /*On fail goto*//*Label 10177*/ GIMT_Encode4(633620), // Rule ID 6332 //
     /*  633550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  633570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  633599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633618 */     GIR_RootConstrainSelectedInstOperands,
     /*  633619 */     // GIR_Coverage, 6332,
     /*  633619 */     GIR_EraseRootFromParent_Done,
     /*  633620 */   // Label 10177: @633620
     /*  633620 */   GIM_Try, /*On fail goto*//*Label 10178*/ GIMT_Encode4(633695), // Rule ID 6333 //
     /*  633625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  633645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633671 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  633674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633693 */     GIR_RootConstrainSelectedInstOperands,
     /*  633694 */     // GIR_Coverage, 6333,
     /*  633694 */     GIR_EraseRootFromParent_Done,
     /*  633695 */   // Label 10178: @633695
     /*  633695 */   GIM_Try, /*On fail goto*//*Label 10179*/ GIMT_Encode4(633770), // Rule ID 6336 //
     /*  633700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  633720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633746 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  633749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633768 */     GIR_RootConstrainSelectedInstOperands,
     /*  633769 */     // GIR_Coverage, 6336,
     /*  633769 */     GIR_EraseRootFromParent_Done,
     /*  633770 */   // Label 10179: @633770
     /*  633770 */   GIM_Try, /*On fail goto*//*Label 10180*/ GIMT_Encode4(633845), // Rule ID 6337 //
     /*  633775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  633795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633821 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  633824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633843 */     GIR_RootConstrainSelectedInstOperands,
     /*  633844 */     // GIR_Coverage, 6337,
     /*  633844 */     GIR_EraseRootFromParent_Done,
     /*  633845 */   // Label 10180: @633845
     /*  633845 */   GIM_Try, /*On fail goto*//*Label 10181*/ GIMT_Encode4(633920), // Rule ID 6340 //
     /*  633850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  633870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633896 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  633899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633918 */     GIR_RootConstrainSelectedInstOperands,
     /*  633919 */     // GIR_Coverage, 6340,
     /*  633919 */     GIR_EraseRootFromParent_Done,
     /*  633920 */   // Label 10181: @633920
     /*  633920 */   GIM_Try, /*On fail goto*//*Label 10182*/ GIMT_Encode4(633995), // Rule ID 6341 //
     /*  633925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  633945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633971 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  633974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633993 */     GIR_RootConstrainSelectedInstOperands,
     /*  633994 */     // GIR_Coverage, 6341,
     /*  633994 */     GIR_EraseRootFromParent_Done,
     /*  633995 */   // Label 10182: @633995
     /*  633995 */   GIM_Try, /*On fail goto*//*Label 10183*/ GIMT_Encode4(634070), // Rule ID 6344 //
     /*  634000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  634011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  634014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  634017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  634020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634046 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  634049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634068 */     GIR_RootConstrainSelectedInstOperands,
     /*  634069 */     // GIR_Coverage, 6344,
     /*  634069 */     GIR_EraseRootFromParent_Done,
     /*  634070 */   // Label 10183: @634070
     /*  634070 */   GIM_Try, /*On fail goto*//*Label 10184*/ GIMT_Encode4(634145), // Rule ID 6345 //
     /*  634075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  634086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  634089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  634092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  634095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634121 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  634124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634143 */     GIR_RootConstrainSelectedInstOperands,
     /*  634144 */     // GIR_Coverage, 6345,
     /*  634144 */     GIR_EraseRootFromParent_Done,
     /*  634145 */   // Label 10184: @634145
     /*  634145 */   GIM_Try, /*On fail goto*//*Label 10185*/ GIMT_Encode4(634220), // Rule ID 6348 //
     /*  634150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  634161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  634164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  634167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  634170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634196 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  634199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634218 */     GIR_RootConstrainSelectedInstOperands,
     /*  634219 */     // GIR_Coverage, 6348,
     /*  634219 */     GIR_EraseRootFromParent_Done,
     /*  634220 */   // Label 10185: @634220
     /*  634220 */   GIM_Try, /*On fail goto*//*Label 10186*/ GIMT_Encode4(634295), // Rule ID 6349 //
     /*  634225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  634236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  634239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  634242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  634245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634271 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  634274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634293 */     GIR_RootConstrainSelectedInstOperands,
     /*  634294 */     // GIR_Coverage, 6349,
     /*  634294 */     GIR_EraseRootFromParent_Done,
     /*  634295 */   // Label 10186: @634295
     /*  634295 */   GIM_Try, /*On fail goto*//*Label 10187*/ GIMT_Encode4(634370), // Rule ID 6352 //
     /*  634300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  634311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  634314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  634317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  634320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634346 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  634349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634368 */     GIR_RootConstrainSelectedInstOperands,
     /*  634369 */     // GIR_Coverage, 6352,
     /*  634369 */     GIR_EraseRootFromParent_Done,
     /*  634370 */   // Label 10187: @634370
     /*  634370 */   GIM_Try, /*On fail goto*//*Label 10188*/ GIMT_Encode4(634445), // Rule ID 6353 //
     /*  634375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  634386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  634389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  634392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  634395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634421 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  634424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634443 */     GIR_RootConstrainSelectedInstOperands,
     /*  634444 */     // GIR_Coverage, 6353,
     /*  634444 */     GIR_EraseRootFromParent_Done,
     /*  634445 */   // Label 10188: @634445
     /*  634445 */   GIM_Try, /*On fail goto*//*Label 10189*/ GIMT_Encode4(634520), // Rule ID 6356 //
     /*  634450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  634461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  634464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  634467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  634470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  634499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634518 */     GIR_RootConstrainSelectedInstOperands,
     /*  634519 */     // GIR_Coverage, 6356,
     /*  634519 */     GIR_EraseRootFromParent_Done,
     /*  634520 */   // Label 10189: @634520
     /*  634520 */   GIM_Try, /*On fail goto*//*Label 10190*/ GIMT_Encode4(634595), // Rule ID 6357 //
     /*  634525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  634536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  634539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  634542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  634545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  634574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634593 */     GIR_RootConstrainSelectedInstOperands,
     /*  634594 */     // GIR_Coverage, 6357,
     /*  634594 */     GIR_EraseRootFromParent_Done,
     /*  634595 */   // Label 10190: @634595
     /*  634595 */   GIM_Try, /*On fail goto*//*Label 10191*/ GIMT_Encode4(634670), // Rule ID 6360 //
     /*  634600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  634620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634646 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  634649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634668 */     GIR_RootConstrainSelectedInstOperands,
     /*  634669 */     // GIR_Coverage, 6360,
     /*  634669 */     GIR_EraseRootFromParent_Done,
     /*  634670 */   // Label 10191: @634670
     /*  634670 */   GIM_Try, /*On fail goto*//*Label 10192*/ GIMT_Encode4(634745), // Rule ID 6361 //
     /*  634675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  634695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634721 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  634724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634743 */     GIR_RootConstrainSelectedInstOperands,
     /*  634744 */     // GIR_Coverage, 6361,
     /*  634744 */     GIR_EraseRootFromParent_Done,
     /*  634745 */   // Label 10192: @634745
     /*  634745 */   GIM_Try, /*On fail goto*//*Label 10193*/ GIMT_Encode4(634820), // Rule ID 6364 //
     /*  634750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  634770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  634799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634818 */     GIR_RootConstrainSelectedInstOperands,
     /*  634819 */     // GIR_Coverage, 6364,
     /*  634819 */     GIR_EraseRootFromParent_Done,
     /*  634820 */   // Label 10193: @634820
     /*  634820 */   GIM_Try, /*On fail goto*//*Label 10194*/ GIMT_Encode4(634895), // Rule ID 6365 //
     /*  634825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  634845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634871 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  634874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634893 */     GIR_RootConstrainSelectedInstOperands,
     /*  634894 */     // GIR_Coverage, 6365,
     /*  634894 */     GIR_EraseRootFromParent_Done,
     /*  634895 */   // Label 10194: @634895
     /*  634895 */   GIM_Try, /*On fail goto*//*Label 10195*/ GIMT_Encode4(634970), // Rule ID 6368 //
     /*  634900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  634920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  634949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634968 */     GIR_RootConstrainSelectedInstOperands,
     /*  634969 */     // GIR_Coverage, 6368,
     /*  634969 */     GIR_EraseRootFromParent_Done,
     /*  634970 */   // Label 10195: @634970
     /*  634970 */   GIM_Try, /*On fail goto*//*Label 10196*/ GIMT_Encode4(635045), // Rule ID 6369 //
     /*  634975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  634995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  635021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  635024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635043 */     GIR_RootConstrainSelectedInstOperands,
     /*  635044 */     // GIR_Coverage, 6369,
     /*  635044 */     GIR_EraseRootFromParent_Done,
     /*  635045 */   // Label 10196: @635045
     /*  635045 */   GIM_Try, /*On fail goto*//*Label 10197*/ GIMT_Encode4(635120), // Rule ID 6372 //
     /*  635050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  635053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  635061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  635064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  635067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  635070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  635096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  635099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635118 */     GIR_RootConstrainSelectedInstOperands,
     /*  635119 */     // GIR_Coverage, 6372,
     /*  635119 */     GIR_EraseRootFromParent_Done,
     /*  635120 */   // Label 10197: @635120
     /*  635120 */   GIM_Try, /*On fail goto*//*Label 10198*/ GIMT_Encode4(635195), // Rule ID 6373 //
     /*  635125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  635128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  635136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  635139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  635142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  635145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635171 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  635171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  635174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635193 */     GIR_RootConstrainSelectedInstOperands,
     /*  635194 */     // GIR_Coverage, 6373,
     /*  635194 */     GIR_EraseRootFromParent_Done,
     /*  635195 */   // Label 10198: @635195
     /*  635195 */   GIM_Try, /*On fail goto*//*Label 10199*/ GIMT_Encode4(635270), // Rule ID 6376 //
     /*  635200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  635203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  635211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  635214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  635217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  635220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635246 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  635246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  635249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635268 */     GIR_RootConstrainSelectedInstOperands,
     /*  635269 */     // GIR_Coverage, 6376,
     /*  635269 */     GIR_EraseRootFromParent_Done,
     /*  635270 */   // Label 10199: @635270
     /*  635270 */   GIM_Try, /*On fail goto*//*Label 10200*/ GIMT_Encode4(635345), // Rule ID 6377 //
     /*  635275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  635278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  635286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  635289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  635292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  635295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635321 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  635321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  635324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635343 */     GIR_RootConstrainSelectedInstOperands,
     /*  635344 */     // GIR_Coverage, 6377,
     /*  635344 */     GIR_EraseRootFromParent_Done,
     /*  635345 */   // Label 10200: @635345
     /*  635345 */   GIM_Try, /*On fail goto*//*Label 10201*/ GIMT_Encode4(635420), // Rule ID 6380 //
     /*  635350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  635361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  635364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  635367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635396 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  635399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635418 */     GIR_RootConstrainSelectedInstOperands,
     /*  635419 */     // GIR_Coverage, 6380,
     /*  635419 */     GIR_EraseRootFromParent_Done,
     /*  635420 */   // Label 10201: @635420
     /*  635420 */   GIM_Try, /*On fail goto*//*Label 10202*/ GIMT_Encode4(635495), // Rule ID 6381 //
     /*  635425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  635436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  635439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  635442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635471 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  635474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635493 */     GIR_RootConstrainSelectedInstOperands,
     /*  635494 */     // GIR_Coverage, 6381,
     /*  635494 */     GIR_EraseRootFromParent_Done,
     /*  635495 */   // Label 10202: @635495
     /*  635495 */   GIM_Try, /*On fail goto*//*Label 10203*/ GIMT_Encode4(635570), // Rule ID 6384 //
     /*  635500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  635511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  635514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  635517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635546 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  635549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635568 */     GIR_RootConstrainSelectedInstOperands,
     /*  635569 */     // GIR_Coverage, 6384,
     /*  635569 */     GIR_EraseRootFromParent_Done,
     /*  635570 */   // Label 10203: @635570
     /*  635570 */   GIM_Try, /*On fail goto*//*Label 10204*/ GIMT_Encode4(635645), // Rule ID 6385 //
     /*  635575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  635586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  635589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  635592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635621 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  635624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635643 */     GIR_RootConstrainSelectedInstOperands,
     /*  635644 */     // GIR_Coverage, 6385,
     /*  635644 */     GIR_EraseRootFromParent_Done,
     /*  635645 */   // Label 10204: @635645
     /*  635645 */   GIM_Try, /*On fail goto*//*Label 10205*/ GIMT_Encode4(635720), // Rule ID 6388 //
     /*  635650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635696 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  635699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635718 */     GIR_RootConstrainSelectedInstOperands,
     /*  635719 */     // GIR_Coverage, 6388,
     /*  635719 */     GIR_EraseRootFromParent_Done,
     /*  635720 */   // Label 10205: @635720
     /*  635720 */   GIM_Try, /*On fail goto*//*Label 10206*/ GIMT_Encode4(635795), // Rule ID 6389 //
     /*  635725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635771 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  635774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635793 */     GIR_RootConstrainSelectedInstOperands,
     /*  635794 */     // GIR_Coverage, 6389,
     /*  635794 */     GIR_EraseRootFromParent_Done,
     /*  635795 */   // Label 10206: @635795
     /*  635795 */   GIM_Try, /*On fail goto*//*Label 10207*/ GIMT_Encode4(635870), // Rule ID 6392 //
     /*  635800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  635849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635868 */     GIR_RootConstrainSelectedInstOperands,
     /*  635869 */     // GIR_Coverage, 6392,
     /*  635869 */     GIR_EraseRootFromParent_Done,
     /*  635870 */   // Label 10207: @635870
     /*  635870 */   GIM_Try, /*On fail goto*//*Label 10208*/ GIMT_Encode4(635945), // Rule ID 6393 //
     /*  635875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635921 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  635924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635943 */     GIR_RootConstrainSelectedInstOperands,
     /*  635944 */     // GIR_Coverage, 6393,
     /*  635944 */     GIR_EraseRootFromParent_Done,
     /*  635945 */   // Label 10208: @635945
     /*  635945 */   GIM_Try, /*On fail goto*//*Label 10209*/ GIMT_Encode4(636020), // Rule ID 6396 //
     /*  635950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  635961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  635964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  635967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635996 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  635999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636018 */     GIR_RootConstrainSelectedInstOperands,
     /*  636019 */     // GIR_Coverage, 6396,
     /*  636019 */     GIR_EraseRootFromParent_Done,
     /*  636020 */   // Label 10209: @636020
     /*  636020 */   GIM_Try, /*On fail goto*//*Label 10210*/ GIMT_Encode4(636095), // Rule ID 6397 //
     /*  636025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  636036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  636039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  636042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636071 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  636071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  636074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636093 */     GIR_RootConstrainSelectedInstOperands,
     /*  636094 */     // GIR_Coverage, 6397,
     /*  636094 */     GIR_EraseRootFromParent_Done,
     /*  636095 */   // Label 10210: @636095
     /*  636095 */   GIM_Try, /*On fail goto*//*Label 10211*/ GIMT_Encode4(636170), // Rule ID 6400 //
     /*  636100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  636111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  636114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  636117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  636120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  636149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636168 */     GIR_RootConstrainSelectedInstOperands,
     /*  636169 */     // GIR_Coverage, 6400,
     /*  636169 */     GIR_EraseRootFromParent_Done,
     /*  636170 */   // Label 10211: @636170
     /*  636170 */   GIM_Try, /*On fail goto*//*Label 10212*/ GIMT_Encode4(636245), // Rule ID 6401 //
     /*  636175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  636186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  636189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  636192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636221 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  636224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636243 */     GIR_RootConstrainSelectedInstOperands,
     /*  636244 */     // GIR_Coverage, 6401,
     /*  636244 */     GIR_EraseRootFromParent_Done,
     /*  636245 */   // Label 10212: @636245
     /*  636245 */   GIM_Try, /*On fail goto*//*Label 10213*/ GIMT_Encode4(636320), // Rule ID 6404 //
     /*  636250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  636261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  636264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  636267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  636270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636296 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636318 */     GIR_RootConstrainSelectedInstOperands,
     /*  636319 */     // GIR_Coverage, 6404,
     /*  636319 */     GIR_EraseRootFromParent_Done,
     /*  636320 */   // Label 10213: @636320
     /*  636320 */   GIM_Try, /*On fail goto*//*Label 10214*/ GIMT_Encode4(636395), // Rule ID 6405 //
     /*  636325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  636336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  636339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  636342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636371 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11652:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636393 */     GIR_RootConstrainSelectedInstOperands,
     /*  636394 */     // GIR_Coverage, 6405,
     /*  636394 */     GIR_EraseRootFromParent_Done,
     /*  636395 */   // Label 10214: @636395
     /*  636395 */   GIM_Try, /*On fail goto*//*Label 10215*/ GIMT_Encode4(636470), // Rule ID 6408 //
     /*  636400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  636411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  636414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  636417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  636420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  636446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636468 */     GIR_RootConstrainSelectedInstOperands,
     /*  636469 */     // GIR_Coverage, 6408,
     /*  636469 */     GIR_EraseRootFromParent_Done,
     /*  636470 */   // Label 10215: @636470
     /*  636470 */   GIM_Try, /*On fail goto*//*Label 10216*/ GIMT_Encode4(636545), // Rule ID 6409 //
     /*  636475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  636486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  636489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  636492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636521 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  636521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636543 */     GIR_RootConstrainSelectedInstOperands,
     /*  636544 */     // GIR_Coverage, 6409,
     /*  636544 */     GIR_EraseRootFromParent_Done,
     /*  636545 */   // Label 10216: @636545
     /*  636545 */   GIM_Try, /*On fail goto*//*Label 10217*/ GIMT_Encode4(636620), // Rule ID 6412 //
     /*  636550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  636570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636618 */     GIR_RootConstrainSelectedInstOperands,
     /*  636619 */     // GIR_Coverage, 6412,
     /*  636619 */     GIR_EraseRootFromParent_Done,
     /*  636620 */   // Label 10217: @636620
     /*  636620 */   GIM_Try, /*On fail goto*//*Label 10218*/ GIMT_Encode4(636695), // Rule ID 6413 //
     /*  636625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636671 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636693 */     GIR_RootConstrainSelectedInstOperands,
     /*  636694 */     // GIR_Coverage, 6413,
     /*  636694 */     GIR_EraseRootFromParent_Done,
     /*  636695 */   // Label 10218: @636695
     /*  636695 */   GIM_Try, /*On fail goto*//*Label 10219*/ GIMT_Encode4(636770), // Rule ID 6416 //
     /*  636700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  636703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  636720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636746 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  636746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636768 */     GIR_RootConstrainSelectedInstOperands,
     /*  636769 */     // GIR_Coverage, 6416,
     /*  636769 */     GIR_EraseRootFromParent_Done,
     /*  636770 */   // Label 10219: @636770
     /*  636770 */   GIM_Try, /*On fail goto*//*Label 10220*/ GIMT_Encode4(636845), // Rule ID 6417 //
     /*  636775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  636778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636821 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  636821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636843 */     GIR_RootConstrainSelectedInstOperands,
     /*  636844 */     // GIR_Coverage, 6417,
     /*  636844 */     GIR_EraseRootFromParent_Done,
     /*  636845 */   // Label 10220: @636845
     /*  636845 */   GIM_Try, /*On fail goto*//*Label 10221*/ GIMT_Encode4(636920), // Rule ID 6420 //
     /*  636850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  636870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  636899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636918 */     GIR_RootConstrainSelectedInstOperands,
     /*  636919 */     // GIR_Coverage, 6420,
     /*  636919 */     GIR_EraseRootFromParent_Done,
     /*  636920 */   // Label 10221: @636920
     /*  636920 */   GIM_Try, /*On fail goto*//*Label 10222*/ GIMT_Encode4(636995), // Rule ID 6421 //
     /*  636925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636971 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  636974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636993 */     GIR_RootConstrainSelectedInstOperands,
     /*  636994 */     // GIR_Coverage, 6421,
     /*  636994 */     GIR_EraseRootFromParent_Done,
     /*  636995 */   // Label 10222: @636995
     /*  636995 */   GIM_Try, /*On fail goto*//*Label 10223*/ GIMT_Encode4(637070), // Rule ID 6424 //
     /*  637000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  637011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  637014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  637017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637046 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  637046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  637049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637068 */     GIR_RootConstrainSelectedInstOperands,
     /*  637069 */     // GIR_Coverage, 6424,
     /*  637069 */     GIR_EraseRootFromParent_Done,
     /*  637070 */   // Label 10223: @637070
     /*  637070 */   GIM_Try, /*On fail goto*//*Label 10224*/ GIMT_Encode4(637145), // Rule ID 6425 //
     /*  637075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  637086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  637089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  637092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637121 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  637121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  637124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637143 */     GIR_RootConstrainSelectedInstOperands,
     /*  637144 */     // GIR_Coverage, 6425,
     /*  637144 */     GIR_EraseRootFromParent_Done,
     /*  637145 */   // Label 10224: @637145
     /*  637145 */   GIM_Try, /*On fail goto*//*Label 10225*/ GIMT_Encode4(637220), // Rule ID 6428 //
     /*  637150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  637161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  637164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  637167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637196 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  637196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  637199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637218 */     GIR_RootConstrainSelectedInstOperands,
     /*  637219 */     // GIR_Coverage, 6428,
     /*  637219 */     GIR_EraseRootFromParent_Done,
     /*  637220 */   // Label 10225: @637220
     /*  637220 */   GIM_Try, /*On fail goto*//*Label 10226*/ GIMT_Encode4(637295), // Rule ID 6429 //
     /*  637225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  637236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  637239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  637242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637271 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  637271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  637274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637293 */     GIR_RootConstrainSelectedInstOperands,
     /*  637294 */     // GIR_Coverage, 6429,
     /*  637294 */     GIR_EraseRootFromParent_Done,
     /*  637295 */   // Label 10226: @637295
     /*  637295 */   GIM_Try, /*On fail goto*//*Label 10227*/ GIMT_Encode4(637370), // Rule ID 6432 //
     /*  637300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  637311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  637314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  637317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  637349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637368 */     GIR_RootConstrainSelectedInstOperands,
     /*  637369 */     // GIR_Coverage, 6432,
     /*  637369 */     GIR_EraseRootFromParent_Done,
     /*  637370 */   // Label 10227: @637370
     /*  637370 */   GIM_Try, /*On fail goto*//*Label 10228*/ GIMT_Encode4(637445), // Rule ID 6433 //
     /*  637375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  637386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  637389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  637392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  637424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637443 */     GIR_RootConstrainSelectedInstOperands,
     /*  637444 */     // GIR_Coverage, 6433,
     /*  637444 */     GIR_EraseRootFromParent_Done,
     /*  637445 */   // Label 10228: @637445
     /*  637445 */   GIM_Try, /*On fail goto*//*Label 10229*/ GIMT_Encode4(637520), // Rule ID 6436 //
     /*  637450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  637461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  637464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  637467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  637499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637518 */     GIR_RootConstrainSelectedInstOperands,
     /*  637519 */     // GIR_Coverage, 6436,
     /*  637519 */     GIR_EraseRootFromParent_Done,
     /*  637520 */   // Label 10229: @637520
     /*  637520 */   GIM_Try, /*On fail goto*//*Label 10230*/ GIMT_Encode4(637595), // Rule ID 6437 //
     /*  637525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  637536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  637539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  637542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637571 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  637574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637593 */     GIR_RootConstrainSelectedInstOperands,
     /*  637594 */     // GIR_Coverage, 6437,
     /*  637594 */     GIR_EraseRootFromParent_Done,
     /*  637595 */   // Label 10230: @637595
     /*  637595 */   GIM_Try, /*On fail goto*//*Label 10231*/ GIMT_Encode4(637670), // Rule ID 6440 //
     /*  637600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  637649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637668 */     GIR_RootConstrainSelectedInstOperands,
     /*  637669 */     // GIR_Coverage, 6440,
     /*  637669 */     GIR_EraseRootFromParent_Done,
     /*  637670 */   // Label 10231: @637670
     /*  637670 */   GIM_Try, /*On fail goto*//*Label 10232*/ GIMT_Encode4(637745), // Rule ID 6441 //
     /*  637675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637721 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  637724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637743 */     GIR_RootConstrainSelectedInstOperands,
     /*  637744 */     // GIR_Coverage, 6441,
     /*  637744 */     GIR_EraseRootFromParent_Done,
     /*  637745 */   // Label 10232: @637745
     /*  637745 */   GIM_Try, /*On fail goto*//*Label 10233*/ GIMT_Encode4(637820), // Rule ID 6444 //
     /*  637750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  637799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637818 */     GIR_RootConstrainSelectedInstOperands,
     /*  637819 */     // GIR_Coverage, 6444,
     /*  637819 */     GIR_EraseRootFromParent_Done,
     /*  637820 */   // Label 10233: @637820
     /*  637820 */   GIM_Try, /*On fail goto*//*Label 10234*/ GIMT_Encode4(637895), // Rule ID 6445 //
     /*  637825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  637874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637893 */     GIR_RootConstrainSelectedInstOperands,
     /*  637894 */     // GIR_Coverage, 6445,
     /*  637894 */     GIR_EraseRootFromParent_Done,
     /*  637895 */   // Label 10234: @637895
     /*  637895 */   GIM_Try, /*On fail goto*//*Label 10235*/ GIMT_Encode4(637970), // Rule ID 6448 //
     /*  637900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  637949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637968 */     GIR_RootConstrainSelectedInstOperands,
     /*  637969 */     // GIR_Coverage, 6448,
     /*  637969 */     GIR_EraseRootFromParent_Done,
     /*  637970 */   // Label 10235: @637970
     /*  637970 */   GIM_Try, /*On fail goto*//*Label 10236*/ GIMT_Encode4(638045), // Rule ID 6449 //
     /*  637975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  638021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  638024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638043 */     GIR_RootConstrainSelectedInstOperands,
     /*  638044 */     // GIR_Coverage, 6449,
     /*  638044 */     GIR_EraseRootFromParent_Done,
     /*  638045 */   // Label 10236: @638045
     /*  638045 */   GIM_Try, /*On fail goto*//*Label 10237*/ GIMT_Encode4(638120), // Rule ID 6452 //
     /*  638050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  638061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  638064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  638067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638096 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  638096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  638099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638118 */     GIR_RootConstrainSelectedInstOperands,
     /*  638119 */     // GIR_Coverage, 6452,
     /*  638119 */     GIR_EraseRootFromParent_Done,
     /*  638120 */   // Label 10237: @638120
     /*  638120 */   GIM_Try, /*On fail goto*//*Label 10238*/ GIMT_Encode4(638195), // Rule ID 6453 //
     /*  638125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  638136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  638139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  638142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638171 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  638171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  638174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638193 */     GIR_RootConstrainSelectedInstOperands,
     /*  638194 */     // GIR_Coverage, 6453,
     /*  638194 */     GIR_EraseRootFromParent_Done,
     /*  638195 */   // Label 10238: @638195
     /*  638195 */   GIM_Try, /*On fail goto*//*Label 10239*/ GIMT_Encode4(638270), // Rule ID 6456 //
     /*  638200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  638211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  638214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  638217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  638249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638268 */     GIR_RootConstrainSelectedInstOperands,
     /*  638269 */     // GIR_Coverage, 6456,
     /*  638269 */     GIR_EraseRootFromParent_Done,
     /*  638270 */   // Label 10239: @638270
     /*  638270 */   GIM_Try, /*On fail goto*//*Label 10240*/ GIMT_Encode4(638345), // Rule ID 6457 //
     /*  638275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  638286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  638289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  638292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  638324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638343 */     GIR_RootConstrainSelectedInstOperands,
     /*  638344 */     // GIR_Coverage, 6457,
     /*  638344 */     GIR_EraseRootFromParent_Done,
     /*  638345 */   // Label 10240: @638345
     /*  638345 */   GIM_Try, /*On fail goto*//*Label 10241*/ GIMT_Encode4(638420), // Rule ID 6460 //
     /*  638350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  638361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  638364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  638367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  638399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638418 */     GIR_RootConstrainSelectedInstOperands,
     /*  638419 */     // GIR_Coverage, 6460,
     /*  638419 */     GIR_EraseRootFromParent_Done,
     /*  638420 */   // Label 10241: @638420
     /*  638420 */   GIM_Try, /*On fail goto*//*Label 10242*/ GIMT_Encode4(638495), // Rule ID 6461 //
     /*  638425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  638436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  638439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  638442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638471 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  638474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638493 */     GIR_RootConstrainSelectedInstOperands,
     /*  638494 */     // GIR_Coverage, 6461,
     /*  638494 */     GIR_EraseRootFromParent_Done,
     /*  638495 */   // Label 10242: @638495
     /*  638495 */   GIM_Try, /*On fail goto*//*Label 10243*/ GIMT_Encode4(638570), // Rule ID 6464 //
     /*  638500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  638511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  638514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  638517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  638549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638568 */     GIR_RootConstrainSelectedInstOperands,
     /*  638569 */     // GIR_Coverage, 6464,
     /*  638569 */     GIR_EraseRootFromParent_Done,
     /*  638570 */   // Label 10243: @638570
     /*  638570 */   GIM_Try, /*On fail goto*//*Label 10244*/ GIMT_Encode4(638645), // Rule ID 6465 //
     /*  638575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  638586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  638589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  638592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638621 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  638624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638643 */     GIR_RootConstrainSelectedInstOperands,
     /*  638644 */     // GIR_Coverage, 6465,
     /*  638644 */     GIR_EraseRootFromParent_Done,
     /*  638645 */   // Label 10244: @638645
     /*  638645 */   GIM_Try, /*On fail goto*//*Label 10245*/ GIMT_Encode4(638720), // Rule ID 6556 //
     /*  638650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  638670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638696 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  638699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638718 */     GIR_RootConstrainSelectedInstOperands,
     /*  638719 */     // GIR_Coverage, 6556,
     /*  638719 */     GIR_EraseRootFromParent_Done,
     /*  638720 */   // Label 10245: @638720
     /*  638720 */   GIM_Try, /*On fail goto*//*Label 10246*/ GIMT_Encode4(638795), // Rule ID 6557 //
     /*  638725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  638745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638771 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  638774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638793 */     GIR_RootConstrainSelectedInstOperands,
     /*  638794 */     // GIR_Coverage, 6557,
     /*  638794 */     GIR_EraseRootFromParent_Done,
     /*  638795 */   // Label 10246: @638795
     /*  638795 */   GIM_Try, /*On fail goto*//*Label 10247*/ GIMT_Encode4(638870), // Rule ID 6560 //
     /*  638800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  638820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638846 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  638849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638868 */     GIR_RootConstrainSelectedInstOperands,
     /*  638869 */     // GIR_Coverage, 6560,
     /*  638869 */     GIR_EraseRootFromParent_Done,
     /*  638870 */   // Label 10247: @638870
     /*  638870 */   GIM_Try, /*On fail goto*//*Label 10248*/ GIMT_Encode4(638945), // Rule ID 6561 //
     /*  638875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  638895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638921 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  638924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638943 */     GIR_RootConstrainSelectedInstOperands,
     /*  638944 */     // GIR_Coverage, 6561,
     /*  638944 */     GIR_EraseRootFromParent_Done,
     /*  638945 */   // Label 10248: @638945
     /*  638945 */   GIM_Try, /*On fail goto*//*Label 10249*/ GIMT_Encode4(639020), // Rule ID 6564 //
     /*  638950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  638961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  638964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  638967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  638970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638996 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  638999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639018 */     GIR_RootConstrainSelectedInstOperands,
     /*  639019 */     // GIR_Coverage, 6564,
     /*  639019 */     GIR_EraseRootFromParent_Done,
     /*  639020 */   // Label 10249: @639020
     /*  639020 */   GIM_Try, /*On fail goto*//*Label 10250*/ GIMT_Encode4(639095), // Rule ID 6565 //
     /*  639025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  639036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  639039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  639042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  639045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639071 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  639074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639093 */     GIR_RootConstrainSelectedInstOperands,
     /*  639094 */     // GIR_Coverage, 6565,
     /*  639094 */     GIR_EraseRootFromParent_Done,
     /*  639095 */   // Label 10250: @639095
     /*  639095 */   GIM_Try, /*On fail goto*//*Label 10251*/ GIMT_Encode4(639170), // Rule ID 6568 //
     /*  639100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  639111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  639114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  639117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  639120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639146 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  639149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639168 */     GIR_RootConstrainSelectedInstOperands,
     /*  639169 */     // GIR_Coverage, 6568,
     /*  639169 */     GIR_EraseRootFromParent_Done,
     /*  639170 */   // Label 10251: @639170
     /*  639170 */   GIM_Try, /*On fail goto*//*Label 10252*/ GIMT_Encode4(639245), // Rule ID 6569 //
     /*  639175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  639186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  639189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  639192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  639195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639221 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  639224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639243 */     GIR_RootConstrainSelectedInstOperands,
     /*  639244 */     // GIR_Coverage, 6569,
     /*  639244 */     GIR_EraseRootFromParent_Done,
     /*  639245 */   // Label 10252: @639245
     /*  639245 */   GIM_Try, /*On fail goto*//*Label 10253*/ GIMT_Encode4(639320), // Rule ID 6572 //
     /*  639250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  639261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  639264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  639267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  639270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639296 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  639299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639318 */     GIR_RootConstrainSelectedInstOperands,
     /*  639319 */     // GIR_Coverage, 6572,
     /*  639319 */     GIR_EraseRootFromParent_Done,
     /*  639320 */   // Label 10253: @639320
     /*  639320 */   GIM_Try, /*On fail goto*//*Label 10254*/ GIMT_Encode4(639395), // Rule ID 6573 //
     /*  639325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  639336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  639339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  639342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  639345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639371 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  639374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639393 */     GIR_RootConstrainSelectedInstOperands,
     /*  639394 */     // GIR_Coverage, 6573,
     /*  639394 */     GIR_EraseRootFromParent_Done,
     /*  639395 */   // Label 10254: @639395
     /*  639395 */   GIM_Try, /*On fail goto*//*Label 10255*/ GIMT_Encode4(639470), // Rule ID 6576 //
     /*  639400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  639411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  639414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  639417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  639420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639446 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  639446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  639449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639468 */     GIR_RootConstrainSelectedInstOperands,
     /*  639469 */     // GIR_Coverage, 6576,
     /*  639469 */     GIR_EraseRootFromParent_Done,
     /*  639470 */   // Label 10255: @639470
     /*  639470 */   GIM_Try, /*On fail goto*//*Label 10256*/ GIMT_Encode4(639545), // Rule ID 6577 //
     /*  639475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  639486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  639489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  639492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  639495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639521 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  639521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  639524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639543 */     GIR_RootConstrainSelectedInstOperands,
     /*  639544 */     // GIR_Coverage, 6577,
     /*  639544 */     GIR_EraseRootFromParent_Done,
     /*  639545 */   // Label 10256: @639545
     /*  639545 */   GIM_Try, /*On fail goto*//*Label 10257*/ GIMT_Encode4(639620), // Rule ID 6580 //
     /*  639550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  639570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  639599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639618 */     GIR_RootConstrainSelectedInstOperands,
     /*  639619 */     // GIR_Coverage, 6580,
     /*  639619 */     GIR_EraseRootFromParent_Done,
     /*  639620 */   // Label 10257: @639620
     /*  639620 */   GIM_Try, /*On fail goto*//*Label 10258*/ GIMT_Encode4(639695), // Rule ID 6581 //
     /*  639625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  639645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639671 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  639674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639693 */     GIR_RootConstrainSelectedInstOperands,
     /*  639694 */     // GIR_Coverage, 6581,
     /*  639694 */     GIR_EraseRootFromParent_Done,
     /*  639695 */   // Label 10258: @639695
     /*  639695 */   GIM_Try, /*On fail goto*//*Label 10259*/ GIMT_Encode4(639770), // Rule ID 6584 //
     /*  639700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  639720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639746 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  639749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639768 */     GIR_RootConstrainSelectedInstOperands,
     /*  639769 */     // GIR_Coverage, 6584,
     /*  639769 */     GIR_EraseRootFromParent_Done,
     /*  639770 */   // Label 10259: @639770
     /*  639770 */   GIM_Try, /*On fail goto*//*Label 10260*/ GIMT_Encode4(639845), // Rule ID 6585 //
     /*  639775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  639795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639821 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  639824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639843 */     GIR_RootConstrainSelectedInstOperands,
     /*  639844 */     // GIR_Coverage, 6585,
     /*  639844 */     GIR_EraseRootFromParent_Done,
     /*  639845 */   // Label 10260: @639845
     /*  639845 */   GIM_Try, /*On fail goto*//*Label 10261*/ GIMT_Encode4(639920), // Rule ID 6588 //
     /*  639850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  639870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639896 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  639896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  639899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639918 */     GIR_RootConstrainSelectedInstOperands,
     /*  639919 */     // GIR_Coverage, 6588,
     /*  639919 */     GIR_EraseRootFromParent_Done,
     /*  639920 */   // Label 10261: @639920
     /*  639920 */   GIM_Try, /*On fail goto*//*Label 10262*/ GIMT_Encode4(639995), // Rule ID 6589 //
     /*  639925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  639945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639971 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  639971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  639974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639993 */     GIR_RootConstrainSelectedInstOperands,
     /*  639994 */     // GIR_Coverage, 6589,
     /*  639994 */     GIR_EraseRootFromParent_Done,
     /*  639995 */   // Label 10262: @639995
     /*  639995 */   GIM_Try, /*On fail goto*//*Label 10263*/ GIMT_Encode4(640070), // Rule ID 6592 //
     /*  640000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  640003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  640011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  640014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  640017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  640020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640046 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  640046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  640049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  640065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640068 */     GIR_RootConstrainSelectedInstOperands,
     /*  640069 */     // GIR_Coverage, 6592,
     /*  640069 */     GIR_EraseRootFromParent_Done,
     /*  640070 */   // Label 10263: @640070
     /*  640070 */   GIM_Try, /*On fail goto*//*Label 10264*/ GIMT_Encode4(640145), // Rule ID 6593 //
     /*  640075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  640078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  640086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  640089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  640092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  640095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640121 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  640121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  640124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  640140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640143 */     GIR_RootConstrainSelectedInstOperands,
     /*  640144 */     // GIR_Coverage, 6593,
     /*  640144 */     GIR_EraseRootFromParent_Done,
     /*  640145 */   // Label 10264: @640145
     /*  640145 */   GIM_Try, /*On fail goto*//*Label 10265*/ GIMT_Encode4(640220), // Rule ID 6596 //
     /*  640150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  640161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  640164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  640167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  640170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640196 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  640199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640218 */     GIR_RootConstrainSelectedInstOperands,
     /*  640219 */     // GIR_Coverage, 6596,
     /*  640219 */     GIR_EraseRootFromParent_Done,
     /*  640220 */   // Label 10265: @640220
     /*  640220 */   GIM_Try, /*On fail goto*//*Label 10266*/ GIMT_Encode4(640295), // Rule ID 6597 //
     /*  640225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  640236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  640239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  640242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  640245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640271 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  640274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640293 */     GIR_RootConstrainSelectedInstOperands,
     /*  640294 */     // GIR_Coverage, 6597,
     /*  640294 */     GIR_EraseRootFromParent_Done,
     /*  640295 */   // Label 10266: @640295
     /*  640295 */   GIM_Try, /*On fail goto*//*Label 10267*/ GIMT_Encode4(640370), // Rule ID 6600 //
     /*  640300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  640311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  640314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  640317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  640320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640346 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  640349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640368 */     GIR_RootConstrainSelectedInstOperands,
     /*  640369 */     // GIR_Coverage, 6600,
     /*  640369 */     GIR_EraseRootFromParent_Done,
     /*  640370 */   // Label 10267: @640370
     /*  640370 */   GIM_Try, /*On fail goto*//*Label 10268*/ GIMT_Encode4(640445), // Rule ID 6601 //
     /*  640375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  640386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  640389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  640392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  640395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640421 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  640424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640443 */     GIR_RootConstrainSelectedInstOperands,
     /*  640444 */     // GIR_Coverage, 6601,
     /*  640444 */     GIR_EraseRootFromParent_Done,
     /*  640445 */   // Label 10268: @640445
     /*  640445 */   GIM_Try, /*On fail goto*//*Label 10269*/ GIMT_Encode4(640520), // Rule ID 6604 //
     /*  640450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  640461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  640464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  640467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  640470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640496 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  640499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640518 */     GIR_RootConstrainSelectedInstOperands,
     /*  640519 */     // GIR_Coverage, 6604,
     /*  640519 */     GIR_EraseRootFromParent_Done,
     /*  640520 */   // Label 10269: @640520
     /*  640520 */   GIM_Try, /*On fail goto*//*Label 10270*/ GIMT_Encode4(640595), // Rule ID 6605 //
     /*  640525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  640536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  640539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  640542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  640545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640571 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  640574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640593 */     GIR_RootConstrainSelectedInstOperands,
     /*  640594 */     // GIR_Coverage, 6605,
     /*  640594 */     GIR_EraseRootFromParent_Done,
     /*  640595 */   // Label 10270: @640595
     /*  640595 */   GIM_Try, /*On fail goto*//*Label 10271*/ GIMT_Encode4(640670), // Rule ID 6608 //
     /*  640600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  640620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  640649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640668 */     GIR_RootConstrainSelectedInstOperands,
     /*  640669 */     // GIR_Coverage, 6608,
     /*  640669 */     GIR_EraseRootFromParent_Done,
     /*  640670 */   // Label 10271: @640670
     /*  640670 */   GIM_Try, /*On fail goto*//*Label 10272*/ GIMT_Encode4(640745), // Rule ID 6609 //
     /*  640675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  640695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640721 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  640724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640743 */     GIR_RootConstrainSelectedInstOperands,
     /*  640744 */     // GIR_Coverage, 6609,
     /*  640744 */     GIR_EraseRootFromParent_Done,
     /*  640745 */   // Label 10272: @640745
     /*  640745 */   GIM_Try, /*On fail goto*//*Label 10273*/ GIMT_Encode4(640820), // Rule ID 6612 //
     /*  640750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  640770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640796 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  640799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640818 */     GIR_RootConstrainSelectedInstOperands,
     /*  640819 */     // GIR_Coverage, 6612,
     /*  640819 */     GIR_EraseRootFromParent_Done,
     /*  640820 */   // Label 10273: @640820
     /*  640820 */   GIM_Try, /*On fail goto*//*Label 10274*/ GIMT_Encode4(640895), // Rule ID 6613 //
     /*  640825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  640845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640871 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  640874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640893 */     GIR_RootConstrainSelectedInstOperands,
     /*  640894 */     // GIR_Coverage, 6613,
     /*  640894 */     GIR_EraseRootFromParent_Done,
     /*  640895 */   // Label 10274: @640895
     /*  640895 */   GIM_Try, /*On fail goto*//*Label 10275*/ GIMT_Encode4(640970), // Rule ID 6616 //
     /*  640900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  640920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640946 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  640949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640968 */     GIR_RootConstrainSelectedInstOperands,
     /*  640969 */     // GIR_Coverage, 6616,
     /*  640969 */     GIR_EraseRootFromParent_Done,
     /*  640970 */   // Label 10275: @640970
     /*  640970 */   GIM_Try, /*On fail goto*//*Label 10276*/ GIMT_Encode4(641045), // Rule ID 6617 //
     /*  640975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  640995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641021 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  641021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  641024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  641040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641043 */     GIR_RootConstrainSelectedInstOperands,
     /*  641044 */     // GIR_Coverage, 6617,
     /*  641044 */     GIR_EraseRootFromParent_Done,
     /*  641045 */   // Label 10276: @641045
     /*  641045 */   GIM_Try, /*On fail goto*//*Label 10277*/ GIMT_Encode4(641120), // Rule ID 6620 //
     /*  641050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  641061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  641064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  641067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  641070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  641099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641118 */     GIR_RootConstrainSelectedInstOperands,
     /*  641119 */     // GIR_Coverage, 6620,
     /*  641119 */     GIR_EraseRootFromParent_Done,
     /*  641120 */   // Label 10277: @641120
     /*  641120 */   GIM_Try, /*On fail goto*//*Label 10278*/ GIMT_Encode4(641195), // Rule ID 6621 //
     /*  641125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  641136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  641139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  641142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  641145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641171 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  641174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641193 */     GIR_RootConstrainSelectedInstOperands,
     /*  641194 */     // GIR_Coverage, 6621,
     /*  641194 */     GIR_EraseRootFromParent_Done,
     /*  641195 */   // Label 10278: @641195
     /*  641195 */   GIM_Try, /*On fail goto*//*Label 10279*/ GIMT_Encode4(641270), // Rule ID 6624 //
     /*  641200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  641211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  641214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  641217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  641220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641246 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  641249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641268 */     GIR_RootConstrainSelectedInstOperands,
     /*  641269 */     // GIR_Coverage, 6624,
     /*  641269 */     GIR_EraseRootFromParent_Done,
     /*  641270 */   // Label 10279: @641270
     /*  641270 */   GIM_Try, /*On fail goto*//*Label 10280*/ GIMT_Encode4(641345), // Rule ID 6625 //
     /*  641275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  641286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  641289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  641292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  641295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641321 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  641324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641343 */     GIR_RootConstrainSelectedInstOperands,
     /*  641344 */     // GIR_Coverage, 6625,
     /*  641344 */     GIR_EraseRootFromParent_Done,
     /*  641345 */   // Label 10280: @641345
     /*  641345 */   GIM_Try, /*On fail goto*//*Label 10281*/ GIMT_Encode4(641420), // Rule ID 6628 //
     /*  641350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  641361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  641364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  641367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  641370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641396 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  641399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641418 */     GIR_RootConstrainSelectedInstOperands,
     /*  641419 */     // GIR_Coverage, 6628,
     /*  641419 */     GIR_EraseRootFromParent_Done,
     /*  641420 */   // Label 10281: @641420
     /*  641420 */   GIM_Try, /*On fail goto*//*Label 10282*/ GIMT_Encode4(641495), // Rule ID 6629 //
     /*  641425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  641436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  641439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  641442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  641445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641471 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  641474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641493 */     GIR_RootConstrainSelectedInstOperands,
     /*  641494 */     // GIR_Coverage, 6629,
     /*  641494 */     GIR_EraseRootFromParent_Done,
     /*  641495 */   // Label 10282: @641495
     /*  641495 */   GIM_Try, /*On fail goto*//*Label 10283*/ GIMT_Encode4(641570), // Rule ID 6632 //
     /*  641500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  641511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  641514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  641517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  641520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641546 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  641549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641568 */     GIR_RootConstrainSelectedInstOperands,
     /*  641569 */     // GIR_Coverage, 6632,
     /*  641569 */     GIR_EraseRootFromParent_Done,
     /*  641570 */   // Label 10283: @641570
     /*  641570 */   GIM_Try, /*On fail goto*//*Label 10284*/ GIMT_Encode4(641645), // Rule ID 6633 //
     /*  641575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  641586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  641589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  641592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  641595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641621 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  641624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641643 */     GIR_RootConstrainSelectedInstOperands,
     /*  641644 */     // GIR_Coverage, 6633,
     /*  641644 */     GIR_EraseRootFromParent_Done,
     /*  641645 */   // Label 10284: @641645
     /*  641645 */   GIM_Try, /*On fail goto*//*Label 10285*/ GIMT_Encode4(641720), // Rule ID 6636 //
     /*  641650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  641670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641696 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  641699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641718 */     GIR_RootConstrainSelectedInstOperands,
     /*  641719 */     // GIR_Coverage, 6636,
     /*  641719 */     GIR_EraseRootFromParent_Done,
     /*  641720 */   // Label 10285: @641720
     /*  641720 */   GIM_Try, /*On fail goto*//*Label 10286*/ GIMT_Encode4(641795), // Rule ID 6637 //
     /*  641725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  641745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641771 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  641774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641793 */     GIR_RootConstrainSelectedInstOperands,
     /*  641794 */     // GIR_Coverage, 6637,
     /*  641794 */     GIR_EraseRootFromParent_Done,
     /*  641795 */   // Label 10286: @641795
     /*  641795 */   GIM_Try, /*On fail goto*//*Label 10287*/ GIMT_Encode4(641870), // Rule ID 6640 //
     /*  641800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  641820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  641849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641868 */     GIR_RootConstrainSelectedInstOperands,
     /*  641869 */     // GIR_Coverage, 6640,
     /*  641869 */     GIR_EraseRootFromParent_Done,
     /*  641870 */   // Label 10287: @641870
     /*  641870 */   GIM_Try, /*On fail goto*//*Label 10288*/ GIMT_Encode4(641945), // Rule ID 6641 //
     /*  641875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  641895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641921 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  641924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641943 */     GIR_RootConstrainSelectedInstOperands,
     /*  641944 */     // GIR_Coverage, 6641,
     /*  641944 */     GIR_EraseRootFromParent_Done,
     /*  641945 */   // Label 10288: @641945
     /*  641945 */   GIM_Try, /*On fail goto*//*Label 10289*/ GIMT_Encode4(642020), // Rule ID 6644 //
     /*  641950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  641961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  641964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  641967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  641999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642018 */     GIR_RootConstrainSelectedInstOperands,
     /*  642019 */     // GIR_Coverage, 6644,
     /*  642019 */     GIR_EraseRootFromParent_Done,
     /*  642020 */   // Label 10289: @642020
     /*  642020 */   GIM_Try, /*On fail goto*//*Label 10290*/ GIMT_Encode4(642095), // Rule ID 6645 //
     /*  642025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  642036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  642039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  642042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642071 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  642074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642093 */     GIR_RootConstrainSelectedInstOperands,
     /*  642094 */     // GIR_Coverage, 6645,
     /*  642094 */     GIR_EraseRootFromParent_Done,
     /*  642095 */   // Label 10290: @642095
     /*  642095 */   GIM_Try, /*On fail goto*//*Label 10291*/ GIMT_Encode4(642170), // Rule ID 6648 //
     /*  642100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  642111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  642114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  642117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  642120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642146 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  642149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642168 */     GIR_RootConstrainSelectedInstOperands,
     /*  642169 */     // GIR_Coverage, 6648,
     /*  642169 */     GIR_EraseRootFromParent_Done,
     /*  642170 */   // Label 10291: @642170
     /*  642170 */   GIM_Try, /*On fail goto*//*Label 10292*/ GIMT_Encode4(642245), // Rule ID 6649 //
     /*  642175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  642186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  642189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  642192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642221 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  642224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642243 */     GIR_RootConstrainSelectedInstOperands,
     /*  642244 */     // GIR_Coverage, 6649,
     /*  642244 */     GIR_EraseRootFromParent_Done,
     /*  642245 */   // Label 10292: @642245
     /*  642245 */   GIM_Try, /*On fail goto*//*Label 10293*/ GIMT_Encode4(642320), // Rule ID 6652 //
     /*  642250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  642261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  642264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  642267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  642270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642296 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  642299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642318 */     GIR_RootConstrainSelectedInstOperands,
     /*  642319 */     // GIR_Coverage, 6652,
     /*  642319 */     GIR_EraseRootFromParent_Done,
     /*  642320 */   // Label 10293: @642320
     /*  642320 */   GIM_Try, /*On fail goto*//*Label 10294*/ GIMT_Encode4(642395), // Rule ID 6653 //
     /*  642325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  642336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  642339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  642342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642371 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  642374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642393 */     GIR_RootConstrainSelectedInstOperands,
     /*  642394 */     // GIR_Coverage, 6653,
     /*  642394 */     GIR_EraseRootFromParent_Done,
     /*  642395 */   // Label 10294: @642395
     /*  642395 */   GIM_Try, /*On fail goto*//*Label 10295*/ GIMT_Encode4(642470), // Rule ID 6656 //
     /*  642400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  642411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  642414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  642417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  642420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  642449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642468 */     GIR_RootConstrainSelectedInstOperands,
     /*  642469 */     // GIR_Coverage, 6656,
     /*  642469 */     GIR_EraseRootFromParent_Done,
     /*  642470 */   // Label 10295: @642470
     /*  642470 */   GIM_Try, /*On fail goto*//*Label 10296*/ GIMT_Encode4(642545), // Rule ID 6657 //
     /*  642475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  642486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  642489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  642492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642521 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  642524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642543 */     GIR_RootConstrainSelectedInstOperands,
     /*  642544 */     // GIR_Coverage, 6657,
     /*  642544 */     GIR_EraseRootFromParent_Done,
     /*  642545 */   // Label 10296: @642545
     /*  642545 */   GIM_Try, /*On fail goto*//*Label 10297*/ GIMT_Encode4(642620), // Rule ID 6660 //
     /*  642550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  642570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642596 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  642599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642618 */     GIR_RootConstrainSelectedInstOperands,
     /*  642619 */     // GIR_Coverage, 6660,
     /*  642619 */     GIR_EraseRootFromParent_Done,
     /*  642620 */   // Label 10297: @642620
     /*  642620 */   GIM_Try, /*On fail goto*//*Label 10298*/ GIMT_Encode4(642695), // Rule ID 6661 //
     /*  642625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642671 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  642674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642693 */     GIR_RootConstrainSelectedInstOperands,
     /*  642694 */     // GIR_Coverage, 6661,
     /*  642694 */     GIR_EraseRootFromParent_Done,
     /*  642695 */   // Label 10298: @642695
     /*  642695 */   GIM_Try, /*On fail goto*//*Label 10299*/ GIMT_Encode4(642770), // Rule ID 6664 //
     /*  642700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  642720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  642746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  642749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642768 */     GIR_RootConstrainSelectedInstOperands,
     /*  642769 */     // GIR_Coverage, 6664,
     /*  642769 */     GIR_EraseRootFromParent_Done,
     /*  642770 */   // Label 10299: @642770
     /*  642770 */   GIM_Try, /*On fail goto*//*Label 10300*/ GIMT_Encode4(642845), // Rule ID 6665 //
     /*  642775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642821 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  642821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  642824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642843 */     GIR_RootConstrainSelectedInstOperands,
     /*  642844 */     // GIR_Coverage, 6665,
     /*  642844 */     GIR_EraseRootFromParent_Done,
     /*  642845 */   // Label 10300: @642845
     /*  642845 */   GIM_Try, /*On fail goto*//*Label 10301*/ GIMT_Encode4(642920), // Rule ID 6668 //
     /*  642850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  642870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  642899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642918 */     GIR_RootConstrainSelectedInstOperands,
     /*  642919 */     // GIR_Coverage, 6668,
     /*  642919 */     GIR_EraseRootFromParent_Done,
     /*  642920 */   // Label 10301: @642920
     /*  642920 */   GIM_Try, /*On fail goto*//*Label 10302*/ GIMT_Encode4(642995), // Rule ID 6669 //
     /*  642925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642971 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  642974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642993 */     GIR_RootConstrainSelectedInstOperands,
     /*  642994 */     // GIR_Coverage, 6669,
     /*  642994 */     GIR_EraseRootFromParent_Done,
     /*  642995 */   // Label 10302: @642995
     /*  642995 */   GIM_Try, /*On fail goto*//*Label 10303*/ GIMT_Encode4(643070), // Rule ID 6672 //
     /*  643000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  643011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  643014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  643017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643046 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  643049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643068 */     GIR_RootConstrainSelectedInstOperands,
     /*  643069 */     // GIR_Coverage, 6672,
     /*  643069 */     GIR_EraseRootFromParent_Done,
     /*  643070 */   // Label 10303: @643070
     /*  643070 */   GIM_Try, /*On fail goto*//*Label 10304*/ GIMT_Encode4(643145), // Rule ID 6673 //
     /*  643075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  643086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  643089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  643092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643121 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  643124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643143 */     GIR_RootConstrainSelectedInstOperands,
     /*  643144 */     // GIR_Coverage, 6673,
     /*  643144 */     GIR_EraseRootFromParent_Done,
     /*  643145 */   // Label 10304: @643145
     /*  643145 */   GIM_Try, /*On fail goto*//*Label 10305*/ GIMT_Encode4(643220), // Rule ID 6676 //
     /*  643150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  643161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  643164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  643167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  643196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  643199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643218 */     GIR_RootConstrainSelectedInstOperands,
     /*  643219 */     // GIR_Coverage, 6676,
     /*  643219 */     GIR_EraseRootFromParent_Done,
     /*  643220 */   // Label 10305: @643220
     /*  643220 */   GIM_Try, /*On fail goto*//*Label 10306*/ GIMT_Encode4(643295), // Rule ID 6677 //
     /*  643225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  643236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  643239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  643242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643271 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  643271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  643274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643293 */     GIR_RootConstrainSelectedInstOperands,
     /*  643294 */     // GIR_Coverage, 6677,
     /*  643294 */     GIR_EraseRootFromParent_Done,
     /*  643295 */   // Label 10306: @643295
     /*  643295 */   GIM_Try, /*On fail goto*//*Label 10307*/ GIMT_Encode4(643370), // Rule ID 6680 //
     /*  643300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  643303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  643311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  643314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  643317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643346 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  643346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  643349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  643365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643368 */     GIR_RootConstrainSelectedInstOperands,
     /*  643369 */     // GIR_Coverage, 6680,
     /*  643369 */     GIR_EraseRootFromParent_Done,
     /*  643370 */   // Label 10307: @643370
     /*  643370 */   GIM_Try, /*On fail goto*//*Label 10308*/ GIMT_Encode4(643445), // Rule ID 6681 //
     /*  643375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  643378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  643386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  643389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  643392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643421 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  643421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  643424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  643440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643443 */     GIR_RootConstrainSelectedInstOperands,
     /*  643444 */     // GIR_Coverage, 6681,
     /*  643444 */     GIR_EraseRootFromParent_Done,
     /*  643445 */   // Label 10308: @643445
     /*  643445 */   GIM_Try, /*On fail goto*//*Label 10309*/ GIMT_Encode4(643520), // Rule ID 6684 //
     /*  643450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  643461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  643464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  643467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643496 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  643499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643518 */     GIR_RootConstrainSelectedInstOperands,
     /*  643519 */     // GIR_Coverage, 6684,
     /*  643519 */     GIR_EraseRootFromParent_Done,
     /*  643520 */   // Label 10309: @643520
     /*  643520 */   GIM_Try, /*On fail goto*//*Label 10310*/ GIMT_Encode4(643595), // Rule ID 6685 //
     /*  643525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  643536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  643539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  643542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643571 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  643574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643593 */     GIR_RootConstrainSelectedInstOperands,
     /*  643594 */     // GIR_Coverage, 6685,
     /*  643594 */     GIR_EraseRootFromParent_Done,
     /*  643595 */   // Label 10310: @643595
     /*  643595 */   GIM_Try, /*On fail goto*//*Label 10311*/ GIMT_Encode4(643670), // Rule ID 6688 //
     /*  643600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643646 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  643649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643668 */     GIR_RootConstrainSelectedInstOperands,
     /*  643669 */     // GIR_Coverage, 6688,
     /*  643669 */     GIR_EraseRootFromParent_Done,
     /*  643670 */   // Label 10311: @643670
     /*  643670 */   GIM_Try, /*On fail goto*//*Label 10312*/ GIMT_Encode4(643745), // Rule ID 6689 //
     /*  643675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643721 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  643724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643743 */     GIR_RootConstrainSelectedInstOperands,
     /*  643744 */     // GIR_Coverage, 6689,
     /*  643744 */     GIR_EraseRootFromParent_Done,
     /*  643745 */   // Label 10312: @643745
     /*  643745 */   GIM_Try, /*On fail goto*//*Label 10313*/ GIMT_Encode4(643820), // Rule ID 6692 //
     /*  643750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643796 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  643799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643818 */     GIR_RootConstrainSelectedInstOperands,
     /*  643819 */     // GIR_Coverage, 6692,
     /*  643819 */     GIR_EraseRootFromParent_Done,
     /*  643820 */   // Label 10313: @643820
     /*  643820 */   GIM_Try, /*On fail goto*//*Label 10314*/ GIMT_Encode4(643895), // Rule ID 6693 //
     /*  643825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643871 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  643874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643893 */     GIR_RootConstrainSelectedInstOperands,
     /*  643894 */     // GIR_Coverage, 6693,
     /*  643894 */     GIR_EraseRootFromParent_Done,
     /*  643895 */   // Label 10314: @643895
     /*  643895 */   GIM_Try, /*On fail goto*//*Label 10315*/ GIMT_Encode4(643970), // Rule ID 6696 //
     /*  643900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643946 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  643949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643968 */     GIR_RootConstrainSelectedInstOperands,
     /*  643969 */     // GIR_Coverage, 6696,
     /*  643969 */     GIR_EraseRootFromParent_Done,
     /*  643970 */   // Label 10315: @643970
     /*  643970 */   GIM_Try, /*On fail goto*//*Label 10316*/ GIMT_Encode4(644045), // Rule ID 6697 //
     /*  643975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644021 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  644024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644043 */     GIR_RootConstrainSelectedInstOperands,
     /*  644044 */     // GIR_Coverage, 6697,
     /*  644044 */     GIR_EraseRootFromParent_Done,
     /*  644045 */   // Label 10316: @644045
     /*  644045 */   GIM_Try, /*On fail goto*//*Label 10317*/ GIMT_Encode4(644120), // Rule ID 6700 //
     /*  644050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  644061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  644064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  644067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644096 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  644096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  644099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644118 */     GIR_RootConstrainSelectedInstOperands,
     /*  644119 */     // GIR_Coverage, 6700,
     /*  644119 */     GIR_EraseRootFromParent_Done,
     /*  644120 */   // Label 10317: @644120
     /*  644120 */   GIM_Try, /*On fail goto*//*Label 10318*/ GIMT_Encode4(644195), // Rule ID 6701 //
     /*  644125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  644136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  644139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  644142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644171 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  644174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644193 */     GIR_RootConstrainSelectedInstOperands,
     /*  644194 */     // GIR_Coverage, 6701,
     /*  644194 */     GIR_EraseRootFromParent_Done,
     /*  644195 */   // Label 10318: @644195
     /*  644195 */   GIM_Try, /*On fail goto*//*Label 10319*/ GIMT_Encode4(644270), // Rule ID 6704 //
     /*  644200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  644211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  644214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  644217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644246 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  644246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  644249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644268 */     GIR_RootConstrainSelectedInstOperands,
     /*  644269 */     // GIR_Coverage, 6704,
     /*  644269 */     GIR_EraseRootFromParent_Done,
     /*  644270 */   // Label 10319: @644270
     /*  644270 */   GIM_Try, /*On fail goto*//*Label 10320*/ GIMT_Encode4(644345), // Rule ID 6705 //
     /*  644275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  644286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  644289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  644292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644321 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  644324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644343 */     GIR_RootConstrainSelectedInstOperands,
     /*  644344 */     // GIR_Coverage, 6705,
     /*  644344 */     GIR_EraseRootFromParent_Done,
     /*  644345 */   // Label 10320: @644345
     /*  644345 */   GIM_Try, /*On fail goto*//*Label 10321*/ GIMT_Encode4(644420), // Rule ID 6708 //
     /*  644350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  644361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  644364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  644367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  644399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644418 */     GIR_RootConstrainSelectedInstOperands,
     /*  644419 */     // GIR_Coverage, 6708,
     /*  644419 */     GIR_EraseRootFromParent_Done,
     /*  644420 */   // Label 10321: @644420
     /*  644420 */   GIM_Try, /*On fail goto*//*Label 10322*/ GIMT_Encode4(644495), // Rule ID 6709 //
     /*  644425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  644436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  644439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  644442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  644474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644493 */     GIR_RootConstrainSelectedInstOperands,
     /*  644494 */     // GIR_Coverage, 6709,
     /*  644494 */     GIR_EraseRootFromParent_Done,
     /*  644495 */   // Label 10322: @644495
     /*  644495 */   GIM_Try, /*On fail goto*//*Label 10323*/ GIMT_Encode4(644570), // Rule ID 6712 //
     /*  644500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  644511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  644514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  644517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  644549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644568 */     GIR_RootConstrainSelectedInstOperands,
     /*  644569 */     // GIR_Coverage, 6712,
     /*  644569 */     GIR_EraseRootFromParent_Done,
     /*  644570 */   // Label 10323: @644570
     /*  644570 */   GIM_Try, /*On fail goto*//*Label 10324*/ GIMT_Encode4(644645), // Rule ID 6713 //
     /*  644575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  644586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  644589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  644592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644621 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  644624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644643 */     GIR_RootConstrainSelectedInstOperands,
     /*  644644 */     // GIR_Coverage, 6713,
     /*  644644 */     GIR_EraseRootFromParent_Done,
     /*  644645 */   // Label 10324: @644645
     /*  644645 */   GIM_Try, /*On fail goto*//*Label 10325*/ GIMT_Encode4(644720), // Rule ID 6716 //
     /*  644650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644696 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  644699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644718 */     GIR_RootConstrainSelectedInstOperands,
     /*  644719 */     // GIR_Coverage, 6716,
     /*  644719 */     GIR_EraseRootFromParent_Done,
     /*  644720 */   // Label 10325: @644720
     /*  644720 */   GIM_Try, /*On fail goto*//*Label 10326*/ GIMT_Encode4(644795), // Rule ID 6717 //
     /*  644725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644771 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  644774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644793 */     GIR_RootConstrainSelectedInstOperands,
     /*  644794 */     // GIR_Coverage, 6717,
     /*  644794 */     GIR_EraseRootFromParent_Done,
     /*  644795 */   // Label 10326: @644795
     /*  644795 */   GIM_Try, /*On fail goto*//*Label 10327*/ GIMT_Encode4(644870), // Rule ID 6720 //
     /*  644800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  644849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644868 */     GIR_RootConstrainSelectedInstOperands,
     /*  644869 */     // GIR_Coverage, 6720,
     /*  644869 */     GIR_EraseRootFromParent_Done,
     /*  644870 */   // Label 10327: @644870
     /*  644870 */   GIM_Try, /*On fail goto*//*Label 10328*/ GIMT_Encode4(644945), // Rule ID 6721 //
     /*  644875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  644924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644943 */     GIR_RootConstrainSelectedInstOperands,
     /*  644944 */     // GIR_Coverage, 6721,
     /*  644944 */     GIR_EraseRootFromParent_Done,
     /*  644945 */   // Label 10328: @644945
     /*  644945 */   GIM_Try, /*On fail goto*//*Label 10329*/ GIMT_Encode4(645020), // Rule ID 6724 //
     /*  644950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  644961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  644964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  644967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  644999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645018 */     GIR_RootConstrainSelectedInstOperands,
     /*  645019 */     // GIR_Coverage, 6724,
     /*  645019 */     GIR_EraseRootFromParent_Done,
     /*  645020 */   // Label 10329: @645020
     /*  645020 */   GIM_Try, /*On fail goto*//*Label 10330*/ GIMT_Encode4(645095), // Rule ID 6725 //
     /*  645025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  645028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  645033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  645036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  645039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  645042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  645052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  645056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  645060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645071 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  645071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  645074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645093 */     GIR_RootConstrainSelectedInstOperands,
     /*  645094 */     // GIR_Coverage, 6725,
     /*  645094 */     GIR_EraseRootFromParent_Done,
     /*  645095 */   // Label 10330: @645095
     /*  645095 */   GIM_Try, /*On fail goto*//*Label 10331*/ GIMT_Encode4(645170), // Rule ID 6728 //
     /*  645100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  645103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  645108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  645111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  645114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  645117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  645146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  645149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645168 */     GIR_RootConstrainSelectedInstOperands,
     /*  645169 */     // GIR_Coverage, 6728,
     /*  645169 */     GIR_EraseRootFromParent_Done,
     /*  645170 */   // Label 10331: @645170
     /*  645170 */   GIM_Try, /*On fail goto*//*Label 10332*/ GIMT_Encode4(645245), // Rule ID 6729 //
     /*  645175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  645178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  645183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  645186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  645189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  645192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645221 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  645221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  645224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645243 */     GIR_RootConstrainSelectedInstOperands,
     /*  645244 */     // GIR_Coverage, 6729,
     /*  645244 */     GIR_EraseRootFromParent_Done,
     /*  645245 */   // Label 10332: @645245
     /*  645245 */   GIM_Try, /*On fail goto*//*Label 10333*/ GIMT_Encode4(645320), // Rule ID 6820 //
     /*  645250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  645261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  645264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  645267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  645270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  645299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645318 */     GIR_RootConstrainSelectedInstOperands,
     /*  645319 */     // GIR_Coverage, 6820,
     /*  645319 */     GIR_EraseRootFromParent_Done,
     /*  645320 */   // Label 10333: @645320
     /*  645320 */   GIM_Try, /*On fail goto*//*Label 10334*/ GIMT_Encode4(645395), // Rule ID 6821 //
     /*  645325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  645336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  645339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  645342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  645345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645371 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  645374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645393 */     GIR_RootConstrainSelectedInstOperands,
     /*  645394 */     // GIR_Coverage, 6821,
     /*  645394 */     GIR_EraseRootFromParent_Done,
     /*  645395 */   // Label 10334: @645395
     /*  645395 */   GIM_Try, /*On fail goto*//*Label 10335*/ GIMT_Encode4(645470), // Rule ID 6824 //
     /*  645400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  645411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  645414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  645417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  645420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645446 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  645449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645468 */     GIR_RootConstrainSelectedInstOperands,
     /*  645469 */     // GIR_Coverage, 6824,
     /*  645469 */     GIR_EraseRootFromParent_Done,
     /*  645470 */   // Label 10335: @645470
     /*  645470 */   GIM_Try, /*On fail goto*//*Label 10336*/ GIMT_Encode4(645545), // Rule ID 6825 //
     /*  645475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  645486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  645489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  645492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  645495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645521 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  645524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645543 */     GIR_RootConstrainSelectedInstOperands,
     /*  645544 */     // GIR_Coverage, 6825,
     /*  645544 */     GIR_EraseRootFromParent_Done,
     /*  645545 */   // Label 10336: @645545
     /*  645545 */   GIM_Try, /*On fail goto*//*Label 10337*/ GIMT_Encode4(645620), // Rule ID 6828 //
     /*  645550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  645570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645596 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  645599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645618 */     GIR_RootConstrainSelectedInstOperands,
     /*  645619 */     // GIR_Coverage, 6828,
     /*  645619 */     GIR_EraseRootFromParent_Done,
     /*  645620 */   // Label 10337: @645620
     /*  645620 */   GIM_Try, /*On fail goto*//*Label 10338*/ GIMT_Encode4(645695), // Rule ID 6829 //
     /*  645625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  645645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645671 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  645674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645693 */     GIR_RootConstrainSelectedInstOperands,
     /*  645694 */     // GIR_Coverage, 6829,
     /*  645694 */     GIR_EraseRootFromParent_Done,
     /*  645695 */   // Label 10338: @645695
     /*  645695 */   GIM_Try, /*On fail goto*//*Label 10339*/ GIMT_Encode4(645770), // Rule ID 6832 //
     /*  645700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  645720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  645749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645768 */     GIR_RootConstrainSelectedInstOperands,
     /*  645769 */     // GIR_Coverage, 6832,
     /*  645769 */     GIR_EraseRootFromParent_Done,
     /*  645770 */   // Label 10339: @645770
     /*  645770 */   GIM_Try, /*On fail goto*//*Label 10340*/ GIMT_Encode4(645845), // Rule ID 6833 //
     /*  645775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  645795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645821 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  645824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645843 */     GIR_RootConstrainSelectedInstOperands,
     /*  645844 */     // GIR_Coverage, 6833,
     /*  645844 */     GIR_EraseRootFromParent_Done,
     /*  645845 */   // Label 10340: @645845
     /*  645845 */   GIM_Try, /*On fail goto*//*Label 10341*/ GIMT_Encode4(645920), // Rule ID 6836 //
     /*  645850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  645870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  645899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645918 */     GIR_RootConstrainSelectedInstOperands,
     /*  645919 */     // GIR_Coverage, 6836,
     /*  645919 */     GIR_EraseRootFromParent_Done,
     /*  645920 */   // Label 10341: @645920
     /*  645920 */   GIM_Try, /*On fail goto*//*Label 10342*/ GIMT_Encode4(645995), // Rule ID 6837 //
     /*  645925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  645945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645971 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  645974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645993 */     GIR_RootConstrainSelectedInstOperands,
     /*  645994 */     // GIR_Coverage, 6837,
     /*  645994 */     GIR_EraseRootFromParent_Done,
     /*  645995 */   // Label 10342: @645995
     /*  645995 */   GIM_Try, /*On fail goto*//*Label 10343*/ GIMT_Encode4(646070), // Rule ID 6840 //
     /*  646000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  646011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  646014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  646017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  646020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  646046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  646049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646068 */     GIR_RootConstrainSelectedInstOperands,
     /*  646069 */     // GIR_Coverage, 6840,
     /*  646069 */     GIR_EraseRootFromParent_Done,
     /*  646070 */   // Label 10343: @646070
     /*  646070 */   GIM_Try, /*On fail goto*//*Label 10344*/ GIMT_Encode4(646145), // Rule ID 6841 //
     /*  646075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  646086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  646089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  646092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  646095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646121 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  646121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  646124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646143 */     GIR_RootConstrainSelectedInstOperands,
     /*  646144 */     // GIR_Coverage, 6841,
     /*  646144 */     GIR_EraseRootFromParent_Done,
     /*  646145 */   // Label 10344: @646145
     /*  646145 */   GIM_Try, /*On fail goto*//*Label 10345*/ GIMT_Encode4(646220), // Rule ID 6844 //
     /*  646150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  646161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  646164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  646167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  646170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646218 */     GIR_RootConstrainSelectedInstOperands,
     /*  646219 */     // GIR_Coverage, 6844,
     /*  646219 */     GIR_EraseRootFromParent_Done,
     /*  646220 */   // Label 10345: @646220
     /*  646220 */   GIM_Try, /*On fail goto*//*Label 10346*/ GIMT_Encode4(646295), // Rule ID 6845 //
     /*  646225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  646236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  646239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  646242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  646245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646271 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646293 */     GIR_RootConstrainSelectedInstOperands,
     /*  646294 */     // GIR_Coverage, 6845,
     /*  646294 */     GIR_EraseRootFromParent_Done,
     /*  646295 */   // Label 10346: @646295
     /*  646295 */   GIM_Try, /*On fail goto*//*Label 10347*/ GIMT_Encode4(646370), // Rule ID 6848 //
     /*  646300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  646311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  646314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  646317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  646320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646346 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  646346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646368 */     GIR_RootConstrainSelectedInstOperands,
     /*  646369 */     // GIR_Coverage, 6848,
     /*  646369 */     GIR_EraseRootFromParent_Done,
     /*  646370 */   // Label 10347: @646370
     /*  646370 */   GIM_Try, /*On fail goto*//*Label 10348*/ GIMT_Encode4(646445), // Rule ID 6849 //
     /*  646375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  646386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  646389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  646392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  646395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646421 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  646421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646443 */     GIR_RootConstrainSelectedInstOperands,
     /*  646444 */     // GIR_Coverage, 6849,
     /*  646444 */     GIR_EraseRootFromParent_Done,
     /*  646445 */   // Label 10348: @646445
     /*  646445 */   GIM_Try, /*On fail goto*//*Label 10349*/ GIMT_Encode4(646520), // Rule ID 6852 //
     /*  646450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  646461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  646464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  646467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  646470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  646496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646518 */     GIR_RootConstrainSelectedInstOperands,
     /*  646519 */     // GIR_Coverage, 6852,
     /*  646519 */     GIR_EraseRootFromParent_Done,
     /*  646520 */   // Label 10349: @646520
     /*  646520 */   GIM_Try, /*On fail goto*//*Label 10350*/ GIMT_Encode4(646595), // Rule ID 6853 //
     /*  646525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  646536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  646539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  646542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  646545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646571 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  646571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646593 */     GIR_RootConstrainSelectedInstOperands,
     /*  646594 */     // GIR_Coverage, 6853,
     /*  646594 */     GIR_EraseRootFromParent_Done,
     /*  646595 */   // Label 10350: @646595
     /*  646595 */   GIM_Try, /*On fail goto*//*Label 10351*/ GIMT_Encode4(646670), // Rule ID 6856 //
     /*  646600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  646603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  646620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646646 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  646646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646668 */     GIR_RootConstrainSelectedInstOperands,
     /*  646669 */     // GIR_Coverage, 6856,
     /*  646669 */     GIR_EraseRootFromParent_Done,
     /*  646670 */   // Label 10351: @646670
     /*  646670 */   GIM_Try, /*On fail goto*//*Label 10352*/ GIMT_Encode4(646745), // Rule ID 6857 //
     /*  646675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  646678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  646695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646721 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  646721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646743 */     GIR_RootConstrainSelectedInstOperands,
     /*  646744 */     // GIR_Coverage, 6857,
     /*  646744 */     GIR_EraseRootFromParent_Done,
     /*  646745 */   // Label 10352: @646745
     /*  646745 */   GIM_Try, /*On fail goto*//*Label 10353*/ GIMT_Encode4(646820), // Rule ID 6860 //
     /*  646750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  646770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  646799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646818 */     GIR_RootConstrainSelectedInstOperands,
     /*  646819 */     // GIR_Coverage, 6860,
     /*  646819 */     GIR_EraseRootFromParent_Done,
     /*  646820 */   // Label 10353: @646820
     /*  646820 */   GIM_Try, /*On fail goto*//*Label 10354*/ GIMT_Encode4(646895), // Rule ID 6861 //
     /*  646825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  646845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646871 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  646874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646893 */     GIR_RootConstrainSelectedInstOperands,
     /*  646894 */     // GIR_Coverage, 6861,
     /*  646894 */     GIR_EraseRootFromParent_Done,
     /*  646895 */   // Label 10354: @646895
     /*  646895 */   GIM_Try, /*On fail goto*//*Label 10355*/ GIMT_Encode4(646970), // Rule ID 6864 //
     /*  646900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  646920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646946 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  646949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646968 */     GIR_RootConstrainSelectedInstOperands,
     /*  646969 */     // GIR_Coverage, 6864,
     /*  646969 */     GIR_EraseRootFromParent_Done,
     /*  646970 */   // Label 10355: @646970
     /*  646970 */   GIM_Try, /*On fail goto*//*Label 10356*/ GIMT_Encode4(647045), // Rule ID 6865 //
     /*  646975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  646995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647021 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  647021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  647024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647043 */     GIR_RootConstrainSelectedInstOperands,
     /*  647044 */     // GIR_Coverage, 6865,
     /*  647044 */     GIR_EraseRootFromParent_Done,
     /*  647045 */   // Label 10356: @647045
     /*  647045 */   GIM_Try, /*On fail goto*//*Label 10357*/ GIMT_Encode4(647120), // Rule ID 6868 //
     /*  647050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  647061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  647064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  647067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  647070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647096 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  647096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  647099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647118 */     GIR_RootConstrainSelectedInstOperands,
     /*  647119 */     // GIR_Coverage, 6868,
     /*  647119 */     GIR_EraseRootFromParent_Done,
     /*  647120 */   // Label 10357: @647120
     /*  647120 */   GIM_Try, /*On fail goto*//*Label 10358*/ GIMT_Encode4(647195), // Rule ID 6869 //
     /*  647125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  647136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  647139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  647142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  647145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647171 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  647171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  647174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647193 */     GIR_RootConstrainSelectedInstOperands,
     /*  647194 */     // GIR_Coverage, 6869,
     /*  647194 */     GIR_EraseRootFromParent_Done,
     /*  647195 */   // Label 10358: @647195
     /*  647195 */   GIM_Try, /*On fail goto*//*Label 10359*/ GIMT_Encode4(647270), // Rule ID 6872 //
     /*  647200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  647211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  647214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  647217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  647220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  647249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647268 */     GIR_RootConstrainSelectedInstOperands,
     /*  647269 */     // GIR_Coverage, 6872,
     /*  647269 */     GIR_EraseRootFromParent_Done,
     /*  647270 */   // Label 10359: @647270
     /*  647270 */   GIM_Try, /*On fail goto*//*Label 10360*/ GIMT_Encode4(647345), // Rule ID 6873 //
     /*  647275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  647286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  647289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  647292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  647295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  647324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647343 */     GIR_RootConstrainSelectedInstOperands,
     /*  647344 */     // GIR_Coverage, 6873,
     /*  647344 */     GIR_EraseRootFromParent_Done,
     /*  647345 */   // Label 10360: @647345
     /*  647345 */   GIM_Try, /*On fail goto*//*Label 10361*/ GIMT_Encode4(647420), // Rule ID 6876 //
     /*  647350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  647361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  647364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  647367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  647370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  647399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647418 */     GIR_RootConstrainSelectedInstOperands,
     /*  647419 */     // GIR_Coverage, 6876,
     /*  647419 */     GIR_EraseRootFromParent_Done,
     /*  647420 */   // Label 10361: @647420
     /*  647420 */   GIM_Try, /*On fail goto*//*Label 10362*/ GIMT_Encode4(647495), // Rule ID 6877 //
     /*  647425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  647436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  647439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  647442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  647445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647471 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  647474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647493 */     GIR_RootConstrainSelectedInstOperands,
     /*  647494 */     // GIR_Coverage, 6877,
     /*  647494 */     GIR_EraseRootFromParent_Done,
     /*  647495 */   // Label 10362: @647495
     /*  647495 */   GIM_Try, /*On fail goto*//*Label 10363*/ GIMT_Encode4(647570), // Rule ID 6880 //
     /*  647500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  647511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  647514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  647517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  647520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  647549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647568 */     GIR_RootConstrainSelectedInstOperands,
     /*  647569 */     // GIR_Coverage, 6880,
     /*  647569 */     GIR_EraseRootFromParent_Done,
     /*  647570 */   // Label 10363: @647570
     /*  647570 */   GIM_Try, /*On fail goto*//*Label 10364*/ GIMT_Encode4(647645), // Rule ID 6881 //
     /*  647575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  647586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  647589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  647592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  647595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647621 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  647624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647643 */     GIR_RootConstrainSelectedInstOperands,
     /*  647644 */     // GIR_Coverage, 6881,
     /*  647644 */     GIR_EraseRootFromParent_Done,
     /*  647645 */   // Label 10364: @647645
     /*  647645 */   GIM_Try, /*On fail goto*//*Label 10365*/ GIMT_Encode4(647720), // Rule ID 6884 //
     /*  647650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  647670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  647699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647718 */     GIR_RootConstrainSelectedInstOperands,
     /*  647719 */     // GIR_Coverage, 6884,
     /*  647719 */     GIR_EraseRootFromParent_Done,
     /*  647720 */   // Label 10365: @647720
     /*  647720 */   GIM_Try, /*On fail goto*//*Label 10366*/ GIMT_Encode4(647795), // Rule ID 6885 //
     /*  647725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  647745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  647774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647793 */     GIR_RootConstrainSelectedInstOperands,
     /*  647794 */     // GIR_Coverage, 6885,
     /*  647794 */     GIR_EraseRootFromParent_Done,
     /*  647795 */   // Label 10366: @647795
     /*  647795 */   GIM_Try, /*On fail goto*//*Label 10367*/ GIMT_Encode4(647870), // Rule ID 6888 //
     /*  647800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  647820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  647849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647868 */     GIR_RootConstrainSelectedInstOperands,
     /*  647869 */     // GIR_Coverage, 6888,
     /*  647869 */     GIR_EraseRootFromParent_Done,
     /*  647870 */   // Label 10367: @647870
     /*  647870 */   GIM_Try, /*On fail goto*//*Label 10368*/ GIMT_Encode4(647945), // Rule ID 6889 //
     /*  647875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  647895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647921 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  647924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647943 */     GIR_RootConstrainSelectedInstOperands,
     /*  647944 */     // GIR_Coverage, 6889,
     /*  647944 */     GIR_EraseRootFromParent_Done,
     /*  647945 */   // Label 10368: @647945
     /*  647945 */   GIM_Try, /*On fail goto*//*Label 10369*/ GIMT_Encode4(648020), // Rule ID 6892 //
     /*  647950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  647961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  647964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  647967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  647970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647996 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  647999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648018 */     GIR_RootConstrainSelectedInstOperands,
     /*  648019 */     // GIR_Coverage, 6892,
     /*  648019 */     GIR_EraseRootFromParent_Done,
     /*  648020 */   // Label 10369: @648020
     /*  648020 */   GIM_Try, /*On fail goto*//*Label 10370*/ GIMT_Encode4(648095), // Rule ID 6893 //
     /*  648025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  648036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  648039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  648042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  648045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648071 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  648071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  648074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648093 */     GIR_RootConstrainSelectedInstOperands,
     /*  648094 */     // GIR_Coverage, 6893,
     /*  648094 */     GIR_EraseRootFromParent_Done,
     /*  648095 */   // Label 10370: @648095
     /*  648095 */   GIM_Try, /*On fail goto*//*Label 10371*/ GIMT_Encode4(648170), // Rule ID 6896 //
     /*  648100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  648111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  648114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  648117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  648120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648146 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  648149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648168 */     GIR_RootConstrainSelectedInstOperands,
     /*  648169 */     // GIR_Coverage, 6896,
     /*  648169 */     GIR_EraseRootFromParent_Done,
     /*  648170 */   // Label 10371: @648170
     /*  648170 */   GIM_Try, /*On fail goto*//*Label 10372*/ GIMT_Encode4(648245), // Rule ID 6897 //
     /*  648175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  648186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  648189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  648192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  648195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648221 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  648224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648243 */     GIR_RootConstrainSelectedInstOperands,
     /*  648244 */     // GIR_Coverage, 6897,
     /*  648244 */     GIR_EraseRootFromParent_Done,
     /*  648245 */   // Label 10372: @648245
     /*  648245 */   GIM_Try, /*On fail goto*//*Label 10373*/ GIMT_Encode4(648320), // Rule ID 6900 //
     /*  648250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  648261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  648264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  648267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  648270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  648299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648318 */     GIR_RootConstrainSelectedInstOperands,
     /*  648319 */     // GIR_Coverage, 6900,
     /*  648319 */     GIR_EraseRootFromParent_Done,
     /*  648320 */   // Label 10373: @648320
     /*  648320 */   GIM_Try, /*On fail goto*//*Label 10374*/ GIMT_Encode4(648395), // Rule ID 6901 //
     /*  648325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  648336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  648339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  648342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  648345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648371 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  648374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648393 */     GIR_RootConstrainSelectedInstOperands,
     /*  648394 */     // GIR_Coverage, 6901,
     /*  648394 */     GIR_EraseRootFromParent_Done,
     /*  648395 */   // Label 10374: @648395
     /*  648395 */   GIM_Try, /*On fail goto*//*Label 10375*/ GIMT_Encode4(648470), // Rule ID 6904 //
     /*  648400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  648411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  648414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  648417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  648420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648446 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  648449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648468 */     GIR_RootConstrainSelectedInstOperands,
     /*  648469 */     // GIR_Coverage, 6904,
     /*  648469 */     GIR_EraseRootFromParent_Done,
     /*  648470 */   // Label 10375: @648470
     /*  648470 */   GIM_Try, /*On fail goto*//*Label 10376*/ GIMT_Encode4(648545), // Rule ID 6905 //
     /*  648475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  648486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  648489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  648492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  648495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648521 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  648524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648543 */     GIR_RootConstrainSelectedInstOperands,
     /*  648544 */     // GIR_Coverage, 6905,
     /*  648544 */     GIR_EraseRootFromParent_Done,
     /*  648545 */   // Label 10376: @648545
     /*  648545 */   GIM_Try, /*On fail goto*//*Label 10377*/ GIMT_Encode4(648620), // Rule ID 6908 //
     /*  648550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  648561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  648564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  648599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648618 */     GIR_RootConstrainSelectedInstOperands,
     /*  648619 */     // GIR_Coverage, 6908,
     /*  648619 */     GIR_EraseRootFromParent_Done,
     /*  648620 */   // Label 10377: @648620
     /*  648620 */   GIM_Try, /*On fail goto*//*Label 10378*/ GIMT_Encode4(648695), // Rule ID 6909 //
     /*  648625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  648636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  648639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648671 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  648674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648693 */     GIR_RootConstrainSelectedInstOperands,
     /*  648694 */     // GIR_Coverage, 6909,
     /*  648694 */     GIR_EraseRootFromParent_Done,
     /*  648695 */   // Label 10378: @648695
     /*  648695 */   GIM_Try, /*On fail goto*//*Label 10379*/ GIMT_Encode4(648770), // Rule ID 6912 //
     /*  648700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  648711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  648714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648746 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  648749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648768 */     GIR_RootConstrainSelectedInstOperands,
     /*  648769 */     // GIR_Coverage, 6912,
     /*  648769 */     GIR_EraseRootFromParent_Done,
     /*  648770 */   // Label 10379: @648770
     /*  648770 */   GIM_Try, /*On fail goto*//*Label 10380*/ GIMT_Encode4(648845), // Rule ID 6913 //
     /*  648775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  648786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  648789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648821 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  648824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648843 */     GIR_RootConstrainSelectedInstOperands,
     /*  648844 */     // GIR_Coverage, 6913,
     /*  648844 */     GIR_EraseRootFromParent_Done,
     /*  648845 */   // Label 10380: @648845
     /*  648845 */   GIM_Try, /*On fail goto*//*Label 10381*/ GIMT_Encode4(648920), // Rule ID 6916 //
     /*  648850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  648861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  648864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648896 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  648899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648918 */     GIR_RootConstrainSelectedInstOperands,
     /*  648919 */     // GIR_Coverage, 6916,
     /*  648919 */     GIR_EraseRootFromParent_Done,
     /*  648920 */   // Label 10381: @648920
     /*  648920 */   GIM_Try, /*On fail goto*//*Label 10382*/ GIMT_Encode4(648995), // Rule ID 6917 //
     /*  648925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  648936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  648939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  648974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648993 */     GIR_RootConstrainSelectedInstOperands,
     /*  648994 */     // GIR_Coverage, 6917,
     /*  648994 */     GIR_EraseRootFromParent_Done,
     /*  648995 */   // Label 10382: @648995
     /*  648995 */   GIM_Try, /*On fail goto*//*Label 10383*/ GIMT_Encode4(649070), // Rule ID 6920 //
     /*  649000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  649011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  649014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  649017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  649049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649068 */     GIR_RootConstrainSelectedInstOperands,
     /*  649069 */     // GIR_Coverage, 6920,
     /*  649069 */     GIR_EraseRootFromParent_Done,
     /*  649070 */   // Label 10383: @649070
     /*  649070 */   GIM_Try, /*On fail goto*//*Label 10384*/ GIMT_Encode4(649145), // Rule ID 6921 //
     /*  649075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  649086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  649089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  649092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649121 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  649124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649143 */     GIR_RootConstrainSelectedInstOperands,
     /*  649144 */     // GIR_Coverage, 6921,
     /*  649144 */     GIR_EraseRootFromParent_Done,
     /*  649145 */   // Label 10384: @649145
     /*  649145 */   GIM_Try, /*On fail goto*//*Label 10385*/ GIMT_Encode4(649220), // Rule ID 6924 //
     /*  649150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  649161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  649164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  649167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  649199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649218 */     GIR_RootConstrainSelectedInstOperands,
     /*  649219 */     // GIR_Coverage, 6924,
     /*  649219 */     GIR_EraseRootFromParent_Done,
     /*  649220 */   // Label 10385: @649220
     /*  649220 */   GIM_Try, /*On fail goto*//*Label 10386*/ GIMT_Encode4(649295), // Rule ID 6925 //
     /*  649225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  649236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  649239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  649242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649271 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  649274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649293 */     GIR_RootConstrainSelectedInstOperands,
     /*  649294 */     // GIR_Coverage, 6925,
     /*  649294 */     GIR_EraseRootFromParent_Done,
     /*  649295 */   // Label 10386: @649295
     /*  649295 */   GIM_Try, /*On fail goto*//*Label 10387*/ GIMT_Encode4(649370), // Rule ID 6928 //
     /*  649300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  649311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  649314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  649317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  649346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  649349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649368 */     GIR_RootConstrainSelectedInstOperands,
     /*  649369 */     // GIR_Coverage, 6928,
     /*  649369 */     GIR_EraseRootFromParent_Done,
     /*  649370 */   // Label 10387: @649370
     /*  649370 */   GIM_Try, /*On fail goto*//*Label 10388*/ GIMT_Encode4(649445), // Rule ID 6929 //
     /*  649375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  649386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  649389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  649392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  649421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  649424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649443 */     GIR_RootConstrainSelectedInstOperands,
     /*  649444 */     // GIR_Coverage, 6929,
     /*  649444 */     GIR_EraseRootFromParent_Done,
     /*  649445 */   // Label 10388: @649445
     /*  649445 */   GIM_Try, /*On fail goto*//*Label 10389*/ GIMT_Encode4(649520), // Rule ID 6932 //
     /*  649450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  649461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  649464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  649467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649496 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649518 */     GIR_RootConstrainSelectedInstOperands,
     /*  649519 */     // GIR_Coverage, 6932,
     /*  649519 */     GIR_EraseRootFromParent_Done,
     /*  649520 */   // Label 10389: @649520
     /*  649520 */   GIM_Try, /*On fail goto*//*Label 10390*/ GIMT_Encode4(649595), // Rule ID 6933 //
     /*  649525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  649536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  649539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  649542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649571 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649593 */     GIR_RootConstrainSelectedInstOperands,
     /*  649594 */     // GIR_Coverage, 6933,
     /*  649594 */     GIR_EraseRootFromParent_Done,
     /*  649595 */   // Label 10390: @649595
     /*  649595 */   GIM_Try, /*On fail goto*//*Label 10391*/ GIMT_Encode4(649670), // Rule ID 6936 //
     /*  649600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  649611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  649614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649668 */     GIR_RootConstrainSelectedInstOperands,
     /*  649669 */     // GIR_Coverage, 6936,
     /*  649669 */     GIR_EraseRootFromParent_Done,
     /*  649670 */   // Label 10391: @649670
     /*  649670 */   GIM_Try, /*On fail goto*//*Label 10392*/ GIMT_Encode4(649745), // Rule ID 6937 //
     /*  649675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  649686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  649689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649721 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649743 */     GIR_RootConstrainSelectedInstOperands,
     /*  649744 */     // GIR_Coverage, 6937,
     /*  649744 */     GIR_EraseRootFromParent_Done,
     /*  649745 */   // Label 10392: @649745
     /*  649745 */   GIM_Try, /*On fail goto*//*Label 10393*/ GIMT_Encode4(649820), // Rule ID 6940 //
     /*  649750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  649767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  649796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649818 */     GIR_RootConstrainSelectedInstOperands,
     /*  649819 */     // GIR_Coverage, 6940,
     /*  649819 */     GIR_EraseRootFromParent_Done,
     /*  649820 */   // Label 10393: @649820
     /*  649820 */   GIM_Try, /*On fail goto*//*Label 10394*/ GIMT_Encode4(649895), // Rule ID 6941 //
     /*  649825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  649842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  649871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649893 */     GIR_RootConstrainSelectedInstOperands,
     /*  649894 */     // GIR_Coverage, 6941,
     /*  649894 */     GIR_EraseRootFromParent_Done,
     /*  649895 */   // Label 10394: @649895
     /*  649895 */   GIM_Try, /*On fail goto*//*Label 10395*/ GIMT_Encode4(649970), // Rule ID 6944 //
     /*  649900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  649903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  649911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  649914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  649917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  649946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  649965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649968 */     GIR_RootConstrainSelectedInstOperands,
     /*  649969 */     // GIR_Coverage, 6944,
     /*  649969 */     GIR_EraseRootFromParent_Done,
     /*  649970 */   // Label 10395: @649970
     /*  649970 */   GIM_Try, /*On fail goto*//*Label 10396*/ GIMT_Encode4(650045), // Rule ID 6945 //
     /*  649975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  649978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  649986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  649989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  649992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650021 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  650021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  650024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  650040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650043 */     GIR_RootConstrainSelectedInstOperands,
     /*  650044 */     // GIR_Coverage, 6945,
     /*  650044 */     GIR_EraseRootFromParent_Done,
     /*  650045 */   // Label 10396: @650045
     /*  650045 */   GIM_Try, /*On fail goto*//*Label 10397*/ GIMT_Encode4(650120), // Rule ID 6948 //
     /*  650050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  650061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  650064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  650067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650096 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  650099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650118 */     GIR_RootConstrainSelectedInstOperands,
     /*  650119 */     // GIR_Coverage, 6948,
     /*  650119 */     GIR_EraseRootFromParent_Done,
     /*  650120 */   // Label 10397: @650120
     /*  650120 */   GIM_Try, /*On fail goto*//*Label 10398*/ GIMT_Encode4(650195), // Rule ID 6949 //
     /*  650125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  650136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  650139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  650142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650171 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  650174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650193 */     GIR_RootConstrainSelectedInstOperands,
     /*  650194 */     // GIR_Coverage, 6949,
     /*  650194 */     GIR_EraseRootFromParent_Done,
     /*  650195 */   // Label 10398: @650195
     /*  650195 */   GIM_Try, /*On fail goto*//*Label 10399*/ GIMT_Encode4(650270), // Rule ID 6952 //
     /*  650200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  650211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  650214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  650217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650246 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  650249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650268 */     GIR_RootConstrainSelectedInstOperands,
     /*  650269 */     // GIR_Coverage, 6952,
     /*  650269 */     GIR_EraseRootFromParent_Done,
     /*  650270 */   // Label 10399: @650270
     /*  650270 */   GIM_Try, /*On fail goto*//*Label 10400*/ GIMT_Encode4(650345), // Rule ID 6953 //
     /*  650275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  650286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  650289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  650292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650321 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  650324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650343 */     GIR_RootConstrainSelectedInstOperands,
     /*  650344 */     // GIR_Coverage, 6953,
     /*  650344 */     GIR_EraseRootFromParent_Done,
     /*  650345 */   // Label 10400: @650345
     /*  650345 */   GIM_Try, /*On fail goto*//*Label 10401*/ GIMT_Encode4(650420), // Rule ID 6956 //
     /*  650350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  650361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  650364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  650367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650396 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  650399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650418 */     GIR_RootConstrainSelectedInstOperands,
     /*  650419 */     // GIR_Coverage, 6956,
     /*  650419 */     GIR_EraseRootFromParent_Done,
     /*  650420 */   // Label 10401: @650420
     /*  650420 */   GIM_Try, /*On fail goto*//*Label 10402*/ GIMT_Encode4(650495), // Rule ID 6957 //
     /*  650425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  650436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  650439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  650442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650471 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  650474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650493 */     GIR_RootConstrainSelectedInstOperands,
     /*  650494 */     // GIR_Coverage, 6957,
     /*  650494 */     GIR_EraseRootFromParent_Done,
     /*  650495 */   // Label 10402: @650495
     /*  650495 */   GIM_Try, /*On fail goto*//*Label 10403*/ GIMT_Encode4(650570), // Rule ID 6960 //
     /*  650500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  650511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  650514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  650517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650546 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  650549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650568 */     GIR_RootConstrainSelectedInstOperands,
     /*  650569 */     // GIR_Coverage, 6960,
     /*  650569 */     GIR_EraseRootFromParent_Done,
     /*  650570 */   // Label 10403: @650570
     /*  650570 */   GIM_Try, /*On fail goto*//*Label 10404*/ GIMT_Encode4(650645), // Rule ID 6961 //
     /*  650575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  650586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  650589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  650592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  650624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650643 */     GIR_RootConstrainSelectedInstOperands,
     /*  650644 */     // GIR_Coverage, 6961,
     /*  650644 */     GIR_EraseRootFromParent_Done,
     /*  650645 */   // Label 10404: @650645
     /*  650645 */   GIM_Try, /*On fail goto*//*Label 10405*/ GIMT_Encode4(650720), // Rule ID 6964 //
     /*  650650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  650661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  650664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  650667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650696 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  650699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650718 */     GIR_RootConstrainSelectedInstOperands,
     /*  650719 */     // GIR_Coverage, 6964,
     /*  650719 */     GIR_EraseRootFromParent_Done,
     /*  650720 */   // Label 10405: @650720
     /*  650720 */   GIM_Try, /*On fail goto*//*Label 10406*/ GIMT_Encode4(650795), // Rule ID 6965 //
     /*  650725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  650736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  650739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  650742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  650774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650793 */     GIR_RootConstrainSelectedInstOperands,
     /*  650794 */     // GIR_Coverage, 6965,
     /*  650794 */     GIR_EraseRootFromParent_Done,
     /*  650795 */   // Label 10406: @650795
     /*  650795 */   GIM_Try, /*On fail goto*//*Label 10407*/ GIMT_Encode4(650870), // Rule ID 6968 //
     /*  650800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  650811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  650814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  650817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650846 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  650849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650868 */     GIR_RootConstrainSelectedInstOperands,
     /*  650869 */     // GIR_Coverage, 6968,
     /*  650869 */     GIR_EraseRootFromParent_Done,
     /*  650870 */   // Label 10407: @650870
     /*  650870 */   GIM_Try, /*On fail goto*//*Label 10408*/ GIMT_Encode4(650945), // Rule ID 6969 //
     /*  650875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  650886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  650889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  650892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650921 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  650924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650943 */     GIR_RootConstrainSelectedInstOperands,
     /*  650944 */     // GIR_Coverage, 6969,
     /*  650944 */     GIR_EraseRootFromParent_Done,
     /*  650945 */   // Label 10408: @650945
     /*  650945 */   GIM_Try, /*On fail goto*//*Label 10409*/ GIMT_Encode4(651020), // Rule ID 6972 //
     /*  650950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  650961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  650964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  650967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  650999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651018 */     GIR_RootConstrainSelectedInstOperands,
     /*  651019 */     // GIR_Coverage, 6972,
     /*  651019 */     GIR_EraseRootFromParent_Done,
     /*  651020 */   // Label 10409: @651020
     /*  651020 */   GIM_Try, /*On fail goto*//*Label 10410*/ GIMT_Encode4(651095), // Rule ID 6973 //
     /*  651025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  651036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  651039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  651042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651071 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  651071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  651074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651093 */     GIR_RootConstrainSelectedInstOperands,
     /*  651094 */     // GIR_Coverage, 6973,
     /*  651094 */     GIR_EraseRootFromParent_Done,
     /*  651095 */   // Label 10410: @651095
     /*  651095 */   GIM_Try, /*On fail goto*//*Label 10411*/ GIMT_Encode4(651170), // Rule ID 6976 //
     /*  651100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  651111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  651114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  651117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  651146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  651149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651168 */     GIR_RootConstrainSelectedInstOperands,
     /*  651169 */     // GIR_Coverage, 6976,
     /*  651169 */     GIR_EraseRootFromParent_Done,
     /*  651170 */   // Label 10411: @651170
     /*  651170 */   GIM_Try, /*On fail goto*//*Label 10412*/ GIMT_Encode4(651245), // Rule ID 6977 //
     /*  651175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  651186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  651189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  651192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651221 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  651221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  651224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651243 */     GIR_RootConstrainSelectedInstOperands,
     /*  651244 */     // GIR_Coverage, 6977,
     /*  651244 */     GIR_EraseRootFromParent_Done,
     /*  651245 */   // Label 10412: @651245
     /*  651245 */   GIM_Try, /*On fail goto*//*Label 10413*/ GIMT_Encode4(651320), // Rule ID 6980 //
     /*  651250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  651261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  651264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  651267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651296 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  651296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  651299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651318 */     GIR_RootConstrainSelectedInstOperands,
     /*  651319 */     // GIR_Coverage, 6980,
     /*  651319 */     GIR_EraseRootFromParent_Done,
     /*  651320 */   // Label 10413: @651320
     /*  651320 */   GIM_Try, /*On fail goto*//*Label 10414*/ GIMT_Encode4(651395), // Rule ID 6981 //
     /*  651325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  651336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  651339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  651342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651371 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  651371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  651374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651393 */     GIR_RootConstrainSelectedInstOperands,
     /*  651394 */     // GIR_Coverage, 6981,
     /*  651394 */     GIR_EraseRootFromParent_Done,
     /*  651395 */   // Label 10414: @651395
     /*  651395 */   GIM_Try, /*On fail goto*//*Label 10415*/ GIMT_Encode4(651470), // Rule ID 6984 //
     /*  651400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  651411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  651414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  651417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  651449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651468 */     GIR_RootConstrainSelectedInstOperands,
     /*  651469 */     // GIR_Coverage, 6984,
     /*  651469 */     GIR_EraseRootFromParent_Done,
     /*  651470 */   // Label 10415: @651470
     /*  651470 */   GIM_Try, /*On fail goto*//*Label 10416*/ GIMT_Encode4(651545), // Rule ID 6985 //
     /*  651475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  651486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  651489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  651492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  651524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651543 */     GIR_RootConstrainSelectedInstOperands,
     /*  651544 */     // GIR_Coverage, 6985,
     /*  651544 */     GIR_EraseRootFromParent_Done,
     /*  651545 */   // Label 10416: @651545
     /*  651545 */   GIM_Try, /*On fail goto*//*Label 10417*/ GIMT_Encode4(651620), // Rule ID 6988 //
     /*  651550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  651561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  651564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  651567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  651599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651618 */     GIR_RootConstrainSelectedInstOperands,
     /*  651619 */     // GIR_Coverage, 6988,
     /*  651619 */     GIR_EraseRootFromParent_Done,
     /*  651620 */   // Label 10417: @651620
     /*  651620 */   GIM_Try, /*On fail goto*//*Label 10418*/ GIMT_Encode4(651695), // Rule ID 6989 //
     /*  651625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  651636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  651639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  651642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651671 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  651674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651693 */     GIR_RootConstrainSelectedInstOperands,
     /*  651694 */     // GIR_Coverage, 6989,
     /*  651694 */     GIR_EraseRootFromParent_Done,
     /*  651695 */   // Label 10418: @651695
     /*  651695 */   GIM_Try, /*On fail goto*//*Label 10419*/ GIMT_Encode4(651770), // Rule ID 6992 //
     /*  651700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  651711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  651714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  651717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651746 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  651749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651768 */     GIR_RootConstrainSelectedInstOperands,
     /*  651769 */     // GIR_Coverage, 6992,
     /*  651769 */     GIR_EraseRootFromParent_Done,
     /*  651770 */   // Label 10419: @651770
     /*  651770 */   GIM_Try, /*On fail goto*//*Label 10420*/ GIMT_Encode4(651845), // Rule ID 6993 //
     /*  651775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  651786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  651789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  651792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651821 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  651824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651843 */     GIR_RootConstrainSelectedInstOperands,
     /*  651844 */     // GIR_Coverage, 6993,
     /*  651844 */     GIR_EraseRootFromParent_Done,
     /*  651845 */   // Label 10420: @651845
     /*  651845 */   GIM_Try, /*On fail goto*//*Label 10421*/ GIMT_Encode4(651920), // Rule ID 7084 //
     /*  651850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  651861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  651864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  651867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  651870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  651899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651918 */     GIR_RootConstrainSelectedInstOperands,
     /*  651919 */     // GIR_Coverage, 7084,
     /*  651919 */     GIR_EraseRootFromParent_Done,
     /*  651920 */   // Label 10421: @651920
     /*  651920 */   GIM_Try, /*On fail goto*//*Label 10422*/ GIMT_Encode4(651995), // Rule ID 7085 //
     /*  651925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  651936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  651939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  651942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  651945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  651974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651993 */     GIR_RootConstrainSelectedInstOperands,
     /*  651994 */     // GIR_Coverage, 7085,
     /*  651994 */     GIR_EraseRootFromParent_Done,
     /*  651995 */   // Label 10422: @651995
     /*  651995 */   GIM_Try, /*On fail goto*//*Label 10423*/ GIMT_Encode4(652070), // Rule ID 7088 //
     /*  652000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  652011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  652014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  652017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  652020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  652049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652068 */     GIR_RootConstrainSelectedInstOperands,
     /*  652069 */     // GIR_Coverage, 7088,
     /*  652069 */     GIR_EraseRootFromParent_Done,
     /*  652070 */   // Label 10423: @652070
     /*  652070 */   GIM_Try, /*On fail goto*//*Label 10424*/ GIMT_Encode4(652145), // Rule ID 7089 //
     /*  652075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  652086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  652089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  652092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  652095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652121 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  652124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652143 */     GIR_RootConstrainSelectedInstOperands,
     /*  652144 */     // GIR_Coverage, 7089,
     /*  652144 */     GIR_EraseRootFromParent_Done,
     /*  652145 */   // Label 10424: @652145
     /*  652145 */   GIM_Try, /*On fail goto*//*Label 10425*/ GIMT_Encode4(652220), // Rule ID 7092 //
     /*  652150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  652161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  652164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  652167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  652170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  652199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652218 */     GIR_RootConstrainSelectedInstOperands,
     /*  652219 */     // GIR_Coverage, 7092,
     /*  652219 */     GIR_EraseRootFromParent_Done,
     /*  652220 */   // Label 10425: @652220
     /*  652220 */   GIM_Try, /*On fail goto*//*Label 10426*/ GIMT_Encode4(652295), // Rule ID 7093 //
     /*  652225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  652236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  652239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  652242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  652245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  652274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652293 */     GIR_RootConstrainSelectedInstOperands,
     /*  652294 */     // GIR_Coverage, 7093,
     /*  652294 */     GIR_EraseRootFromParent_Done,
     /*  652295 */   // Label 10426: @652295
     /*  652295 */   GIM_Try, /*On fail goto*//*Label 10427*/ GIMT_Encode4(652370), // Rule ID 7096 //
     /*  652300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  652311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  652314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  652317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  652320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  652349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652368 */     GIR_RootConstrainSelectedInstOperands,
     /*  652369 */     // GIR_Coverage, 7096,
     /*  652369 */     GIR_EraseRootFromParent_Done,
     /*  652370 */   // Label 10427: @652370
     /*  652370 */   GIM_Try, /*On fail goto*//*Label 10428*/ GIMT_Encode4(652445), // Rule ID 7097 //
     /*  652375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  652386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  652389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  652392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  652395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652421 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  652424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652443 */     GIR_RootConstrainSelectedInstOperands,
     /*  652444 */     // GIR_Coverage, 7097,
     /*  652444 */     GIR_EraseRootFromParent_Done,
     /*  652445 */   // Label 10428: @652445
     /*  652445 */   GIM_Try, /*On fail goto*//*Label 10429*/ GIMT_Encode4(652520), // Rule ID 7100 //
     /*  652450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  652461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  652464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  652467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  652470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  652499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652518 */     GIR_RootConstrainSelectedInstOperands,
     /*  652519 */     // GIR_Coverage, 7100,
     /*  652519 */     GIR_EraseRootFromParent_Done,
     /*  652520 */   // Label 10429: @652520
     /*  652520 */   GIM_Try, /*On fail goto*//*Label 10430*/ GIMT_Encode4(652595), // Rule ID 7101 //
     /*  652525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  652536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  652539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  652542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  652545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652571 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  652574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652593 */     GIR_RootConstrainSelectedInstOperands,
     /*  652594 */     // GIR_Coverage, 7101,
     /*  652594 */     GIR_EraseRootFromParent_Done,
     /*  652595 */   // Label 10430: @652595
     /*  652595 */   GIM_Try, /*On fail goto*//*Label 10431*/ GIMT_Encode4(652670), // Rule ID 7104 //
     /*  652600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  652611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  652614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  652620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  652646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  652649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652668 */     GIR_RootConstrainSelectedInstOperands,
     /*  652669 */     // GIR_Coverage, 7104,
     /*  652669 */     GIR_EraseRootFromParent_Done,
     /*  652670 */   // Label 10431: @652670
     /*  652670 */   GIM_Try, /*On fail goto*//*Label 10432*/ GIMT_Encode4(652745), // Rule ID 7105 //
     /*  652675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  652686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  652689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  652695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  652721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  652724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652743 */     GIR_RootConstrainSelectedInstOperands,
     /*  652744 */     // GIR_Coverage, 7105,
     /*  652744 */     GIR_EraseRootFromParent_Done,
     /*  652745 */   // Label 10432: @652745
     /*  652745 */   GIM_Try, /*On fail goto*//*Label 10433*/ GIMT_Encode4(652820), // Rule ID 7108 //
     /*  652750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  652761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  652764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  652767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  652770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  652799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652818 */     GIR_RootConstrainSelectedInstOperands,
     /*  652819 */     // GIR_Coverage, 7108,
     /*  652819 */     GIR_EraseRootFromParent_Done,
     /*  652820 */   // Label 10433: @652820
     /*  652820 */   GIM_Try, /*On fail goto*//*Label 10434*/ GIMT_Encode4(652895), // Rule ID 7109 //
     /*  652825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  652836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  652839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  652842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  652845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652871 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  652874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652893 */     GIR_RootConstrainSelectedInstOperands,
     /*  652894 */     // GIR_Coverage, 7109,
     /*  652894 */     GIR_EraseRootFromParent_Done,
     /*  652895 */   // Label 10434: @652895
     /*  652895 */   GIM_Try, /*On fail goto*//*Label 10435*/ GIMT_Encode4(652970), // Rule ID 7112 //
     /*  652900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  652911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  652914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  652917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  652920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  652949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652968 */     GIR_RootConstrainSelectedInstOperands,
     /*  652969 */     // GIR_Coverage, 7112,
     /*  652969 */     GIR_EraseRootFromParent_Done,
     /*  652970 */   // Label 10435: @652970
     /*  652970 */   GIM_Try, /*On fail goto*//*Label 10436*/ GIMT_Encode4(653045), // Rule ID 7113 //
     /*  652975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  652986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  652989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  652992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  652995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653021 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  653024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653043 */     GIR_RootConstrainSelectedInstOperands,
     /*  653044 */     // GIR_Coverage, 7113,
     /*  653044 */     GIR_EraseRootFromParent_Done,
     /*  653045 */   // Label 10436: @653045
     /*  653045 */   GIM_Try, /*On fail goto*//*Label 10437*/ GIMT_Encode4(653120), // Rule ID 7116 //
     /*  653050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  653061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  653064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  653067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  653070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  653096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  653099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653118 */     GIR_RootConstrainSelectedInstOperands,
     /*  653119 */     // GIR_Coverage, 7116,
     /*  653119 */     GIR_EraseRootFromParent_Done,
     /*  653120 */   // Label 10437: @653120
     /*  653120 */   GIM_Try, /*On fail goto*//*Label 10438*/ GIMT_Encode4(653195), // Rule ID 7117 //
     /*  653125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  653136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  653139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  653142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  653145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  653171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  653174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653193 */     GIR_RootConstrainSelectedInstOperands,
     /*  653194 */     // GIR_Coverage, 7117,
     /*  653194 */     GIR_EraseRootFromParent_Done,
     /*  653195 */   // Label 10438: @653195
     /*  653195 */   GIM_Try, /*On fail goto*//*Label 10439*/ GIMT_Encode4(653270), // Rule ID 7120 //
     /*  653200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  653203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  653211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  653214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  653217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  653220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  653246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  653249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  653265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653268 */     GIR_RootConstrainSelectedInstOperands,
     /*  653269 */     // GIR_Coverage, 7120,
     /*  653269 */     GIR_EraseRootFromParent_Done,
     /*  653270 */   // Label 10439: @653270
     /*  653270 */   GIM_Try, /*On fail goto*//*Label 10440*/ GIMT_Encode4(653345), // Rule ID 7121 //
     /*  653275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  653278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  653286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  653289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  653292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  653295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653321 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  653321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  653324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  653340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653343 */     GIR_RootConstrainSelectedInstOperands,
     /*  653344 */     // GIR_Coverage, 7121,
     /*  653344 */     GIR_EraseRootFromParent_Done,
     /*  653345 */   // Label 10440: @653345
     /*  653345 */   GIM_Try, /*On fail goto*//*Label 10441*/ GIMT_Encode4(653420), // Rule ID 7124 //
     /*  653350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  653361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  653364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  653367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  653370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  653399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653418 */     GIR_RootConstrainSelectedInstOperands,
     /*  653419 */     // GIR_Coverage, 7124,
     /*  653419 */     GIR_EraseRootFromParent_Done,
     /*  653420 */   // Label 10441: @653420
     /*  653420 */   GIM_Try, /*On fail goto*//*Label 10442*/ GIMT_Encode4(653495), // Rule ID 7125 //
     /*  653425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  653436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  653439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  653442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  653445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  653474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653493 */     GIR_RootConstrainSelectedInstOperands,
     /*  653494 */     // GIR_Coverage, 7125,
     /*  653494 */     GIR_EraseRootFromParent_Done,
     /*  653495 */   // Label 10442: @653495
     /*  653495 */   GIM_Try, /*On fail goto*//*Label 10443*/ GIMT_Encode4(653570), // Rule ID 7128 //
     /*  653500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  653511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  653514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  653517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  653520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  653549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653568 */     GIR_RootConstrainSelectedInstOperands,
     /*  653569 */     // GIR_Coverage, 7128,
     /*  653569 */     GIR_EraseRootFromParent_Done,
     /*  653570 */   // Label 10443: @653570
     /*  653570 */   GIM_Try, /*On fail goto*//*Label 10444*/ GIMT_Encode4(653645), // Rule ID 7129 //
     /*  653575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  653586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  653589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  653592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  653595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653621 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  653624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653643 */     GIR_RootConstrainSelectedInstOperands,
     /*  653644 */     // GIR_Coverage, 7129,
     /*  653644 */     GIR_EraseRootFromParent_Done,
     /*  653645 */   // Label 10444: @653645
     /*  653645 */   GIM_Try, /*On fail goto*//*Label 10445*/ GIMT_Encode4(653720), // Rule ID 7132 //
     /*  653650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  653661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  653664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  653667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  653670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653696 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  653699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653718 */     GIR_RootConstrainSelectedInstOperands,
     /*  653719 */     // GIR_Coverage, 7132,
     /*  653719 */     GIR_EraseRootFromParent_Done,
     /*  653720 */   // Label 10445: @653720
     /*  653720 */   GIM_Try, /*On fail goto*//*Label 10446*/ GIMT_Encode4(653795), // Rule ID 7133 //
     /*  653725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  653736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  653739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  653742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  653745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653771 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  653774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653793 */     GIR_RootConstrainSelectedInstOperands,
     /*  653794 */     // GIR_Coverage, 7133,
     /*  653794 */     GIR_EraseRootFromParent_Done,
     /*  653795 */   // Label 10446: @653795
     /*  653795 */   GIM_Try, /*On fail goto*//*Label 10447*/ GIMT_Encode4(653870), // Rule ID 7136 //
     /*  653800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  653817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  653820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  653849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653868 */     GIR_RootConstrainSelectedInstOperands,
     /*  653869 */     // GIR_Coverage, 7136,
     /*  653869 */     GIR_EraseRootFromParent_Done,
     /*  653870 */   // Label 10447: @653870
     /*  653870 */   GIM_Try, /*On fail goto*//*Label 10448*/ GIMT_Encode4(653945), // Rule ID 7137 //
     /*  653875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  653892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  653895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  653924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653943 */     GIR_RootConstrainSelectedInstOperands,
     /*  653944 */     // GIR_Coverage, 7137,
     /*  653944 */     GIR_EraseRootFromParent_Done,
     /*  653945 */   // Label 10448: @653945
     /*  653945 */   GIM_Try, /*On fail goto*//*Label 10449*/ GIMT_Encode4(654020), // Rule ID 7140 //
     /*  653950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  653961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  653964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  653967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  653970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  653999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654018 */     GIR_RootConstrainSelectedInstOperands,
     /*  654019 */     // GIR_Coverage, 7140,
     /*  654019 */     GIR_EraseRootFromParent_Done,
     /*  654020 */   // Label 10449: @654020
     /*  654020 */   GIM_Try, /*On fail goto*//*Label 10450*/ GIMT_Encode4(654095), // Rule ID 7141 //
     /*  654025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  654036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  654039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  654042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  654045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  654071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  654074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654093 */     GIR_RootConstrainSelectedInstOperands,
     /*  654094 */     // GIR_Coverage, 7141,
     /*  654094 */     GIR_EraseRootFromParent_Done,
     /*  654095 */   // Label 10450: @654095
     /*  654095 */   GIM_Try, /*On fail goto*//*Label 10451*/ GIMT_Encode4(654170), // Rule ID 7144 //
     /*  654100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  654111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  654114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  654117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  654120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  654146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  654149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654168 */     GIR_RootConstrainSelectedInstOperands,
     /*  654169 */     // GIR_Coverage, 7144,
     /*  654169 */     GIR_EraseRootFromParent_Done,
     /*  654170 */   // Label 10451: @654170
     /*  654170 */   GIM_Try, /*On fail goto*//*Label 10452*/ GIMT_Encode4(654245), // Rule ID 7145 //
     /*  654175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  654186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  654189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  654192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  654195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654221 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  654221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  654224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654243 */     GIR_RootConstrainSelectedInstOperands,
     /*  654244 */     // GIR_Coverage, 7145,
     /*  654244 */     GIR_EraseRootFromParent_Done,
     /*  654245 */   // Label 10452: @654245
     /*  654245 */   GIM_Try, /*On fail goto*//*Label 10453*/ GIMT_Encode4(654320), // Rule ID 7148 //
     /*  654250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  654261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  654264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  654267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  654270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  654299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654318 */     GIR_RootConstrainSelectedInstOperands,
     /*  654319 */     // GIR_Coverage, 7148,
     /*  654319 */     GIR_EraseRootFromParent_Done,
     /*  654320 */   // Label 10453: @654320
     /*  654320 */   GIM_Try, /*On fail goto*//*Label 10454*/ GIMT_Encode4(654395), // Rule ID 7149 //
     /*  654325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  654336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  654339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  654342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  654345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  654374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654393 */     GIR_RootConstrainSelectedInstOperands,
     /*  654394 */     // GIR_Coverage, 7149,
     /*  654394 */     GIR_EraseRootFromParent_Done,
     /*  654395 */   // Label 10454: @654395
     /*  654395 */   GIM_Try, /*On fail goto*//*Label 10455*/ GIMT_Encode4(654470), // Rule ID 7152 //
     /*  654400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  654411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  654414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  654417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  654420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  654449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654468 */     GIR_RootConstrainSelectedInstOperands,
     /*  654469 */     // GIR_Coverage, 7152,
     /*  654469 */     GIR_EraseRootFromParent_Done,
     /*  654470 */   // Label 10455: @654470
     /*  654470 */   GIM_Try, /*On fail goto*//*Label 10456*/ GIMT_Encode4(654545), // Rule ID 7153 //
     /*  654475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  654486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  654489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  654492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  654495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  654524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654543 */     GIR_RootConstrainSelectedInstOperands,
     /*  654544 */     // GIR_Coverage, 7153,
     /*  654544 */     GIR_EraseRootFromParent_Done,
     /*  654545 */   // Label 10456: @654545
     /*  654545 */   GIM_Try, /*On fail goto*//*Label 10457*/ GIMT_Encode4(654620), // Rule ID 7156 //
     /*  654550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  654567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  654570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  654599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654618 */     GIR_RootConstrainSelectedInstOperands,
     /*  654619 */     // GIR_Coverage, 7156,
     /*  654619 */     GIR_EraseRootFromParent_Done,
     /*  654620 */   // Label 10457: @654620
     /*  654620 */   GIM_Try, /*On fail goto*//*Label 10458*/ GIMT_Encode4(654695), // Rule ID 7157 //
     /*  654625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  654642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  654645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654671 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  654674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654693 */     GIR_RootConstrainSelectedInstOperands,
     /*  654694 */     // GIR_Coverage, 7157,
     /*  654694 */     GIR_EraseRootFromParent_Done,
     /*  654695 */   // Label 10458: @654695
     /*  654695 */   GIM_Try, /*On fail goto*//*Label 10459*/ GIMT_Encode4(654770), // Rule ID 7160 //
     /*  654700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  654717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  654720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  654749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654768 */     GIR_RootConstrainSelectedInstOperands,
     /*  654769 */     // GIR_Coverage, 7160,
     /*  654769 */     GIR_EraseRootFromParent_Done,
     /*  654770 */   // Label 10459: @654770
     /*  654770 */   GIM_Try, /*On fail goto*//*Label 10460*/ GIMT_Encode4(654845), // Rule ID 7161 //
     /*  654775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  654792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  654795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  654824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654843 */     GIR_RootConstrainSelectedInstOperands,
     /*  654844 */     // GIR_Coverage, 7161,
     /*  654844 */     GIR_EraseRootFromParent_Done,
     /*  654845 */   // Label 10460: @654845
     /*  654845 */   GIM_Try, /*On fail goto*//*Label 10461*/ GIMT_Encode4(654920), // Rule ID 7164 //
     /*  654850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  654867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  654870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  654899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654918 */     GIR_RootConstrainSelectedInstOperands,
     /*  654919 */     // GIR_Coverage, 7164,
     /*  654919 */     GIR_EraseRootFromParent_Done,
     /*  654920 */   // Label 10461: @654920
     /*  654920 */   GIM_Try, /*On fail goto*//*Label 10462*/ GIMT_Encode4(654995), // Rule ID 7165 //
     /*  654925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  654942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  654945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  654974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654993 */     GIR_RootConstrainSelectedInstOperands,
     /*  654994 */     // GIR_Coverage, 7165,
     /*  654994 */     GIR_EraseRootFromParent_Done,
     /*  654995 */   // Label 10462: @654995
     /*  654995 */   GIM_Try, /*On fail goto*//*Label 10463*/ GIMT_Encode4(655070), // Rule ID 7168 //
     /*  655000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  655003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  655011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  655014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  655017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  655020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  655046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  655049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  655065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655068 */     GIR_RootConstrainSelectedInstOperands,
     /*  655069 */     // GIR_Coverage, 7168,
     /*  655069 */     GIR_EraseRootFromParent_Done,
     /*  655070 */   // Label 10463: @655070
     /*  655070 */   GIM_Try, /*On fail goto*//*Label 10464*/ GIMT_Encode4(655145), // Rule ID 7169 //
     /*  655075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  655078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  655086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  655089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  655092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  655095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655121 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  655121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  655124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  655140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655143 */     GIR_RootConstrainSelectedInstOperands,
     /*  655144 */     // GIR_Coverage, 7169,
     /*  655144 */     GIR_EraseRootFromParent_Done,
     /*  655145 */   // Label 10464: @655145
     /*  655145 */   GIM_Try, /*On fail goto*//*Label 10465*/ GIMT_Encode4(655220), // Rule ID 7172 //
     /*  655150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  655161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  655164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  655167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  655199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655218 */     GIR_RootConstrainSelectedInstOperands,
     /*  655219 */     // GIR_Coverage, 7172,
     /*  655219 */     GIR_EraseRootFromParent_Done,
     /*  655220 */   // Label 10465: @655220
     /*  655220 */   GIM_Try, /*On fail goto*//*Label 10466*/ GIMT_Encode4(655295), // Rule ID 7173 //
     /*  655225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  655236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  655239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  655242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655271 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  655274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655293 */     GIR_RootConstrainSelectedInstOperands,
     /*  655294 */     // GIR_Coverage, 7173,
     /*  655294 */     GIR_EraseRootFromParent_Done,
     /*  655295 */   // Label 10466: @655295
     /*  655295 */   GIM_Try, /*On fail goto*//*Label 10467*/ GIMT_Encode4(655370), // Rule ID 7176 //
     /*  655300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  655311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  655314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  655317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  655349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655368 */     GIR_RootConstrainSelectedInstOperands,
     /*  655369 */     // GIR_Coverage, 7176,
     /*  655369 */     GIR_EraseRootFromParent_Done,
     /*  655370 */   // Label 10467: @655370
     /*  655370 */   GIM_Try, /*On fail goto*//*Label 10468*/ GIMT_Encode4(655445), // Rule ID 7177 //
     /*  655375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  655386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  655389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  655392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655421 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  655424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655443 */     GIR_RootConstrainSelectedInstOperands,
     /*  655444 */     // GIR_Coverage, 7177,
     /*  655444 */     GIR_EraseRootFromParent_Done,
     /*  655445 */   // Label 10468: @655445
     /*  655445 */   GIM_Try, /*On fail goto*//*Label 10469*/ GIMT_Encode4(655520), // Rule ID 7180 //
     /*  655450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  655461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  655464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  655467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  655499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655518 */     GIR_RootConstrainSelectedInstOperands,
     /*  655519 */     // GIR_Coverage, 7180,
     /*  655519 */     GIR_EraseRootFromParent_Done,
     /*  655520 */   // Label 10469: @655520
     /*  655520 */   GIM_Try, /*On fail goto*//*Label 10470*/ GIMT_Encode4(655595), // Rule ID 7181 //
     /*  655525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  655536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  655539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  655542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655571 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  655574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655593 */     GIR_RootConstrainSelectedInstOperands,
     /*  655594 */     // GIR_Coverage, 7181,
     /*  655594 */     GIR_EraseRootFromParent_Done,
     /*  655595 */   // Label 10470: @655595
     /*  655595 */   GIM_Try, /*On fail goto*//*Label 10471*/ GIMT_Encode4(655670), // Rule ID 7184 //
     /*  655600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  655617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  655649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655668 */     GIR_RootConstrainSelectedInstOperands,
     /*  655669 */     // GIR_Coverage, 7184,
     /*  655669 */     GIR_EraseRootFromParent_Done,
     /*  655670 */   // Label 10471: @655670
     /*  655670 */   GIM_Try, /*On fail goto*//*Label 10472*/ GIMT_Encode4(655745), // Rule ID 7185 //
     /*  655675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  655692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655721 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  655724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655743 */     GIR_RootConstrainSelectedInstOperands,
     /*  655744 */     // GIR_Coverage, 7185,
     /*  655744 */     GIR_EraseRootFromParent_Done,
     /*  655745 */   // Label 10472: @655745
     /*  655745 */   GIM_Try, /*On fail goto*//*Label 10473*/ GIMT_Encode4(655820), // Rule ID 7188 //
     /*  655750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  655761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  655764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  655767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  655799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655818 */     GIR_RootConstrainSelectedInstOperands,
     /*  655819 */     // GIR_Coverage, 7188,
     /*  655819 */     GIR_EraseRootFromParent_Done,
     /*  655820 */   // Label 10473: @655820
     /*  655820 */   GIM_Try, /*On fail goto*//*Label 10474*/ GIMT_Encode4(655895), // Rule ID 7189 //
     /*  655825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  655836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  655839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  655842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  655874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655893 */     GIR_RootConstrainSelectedInstOperands,
     /*  655894 */     // GIR_Coverage, 7189,
     /*  655894 */     GIR_EraseRootFromParent_Done,
     /*  655895 */   // Label 10474: @655895
     /*  655895 */   GIM_Try, /*On fail goto*//*Label 10475*/ GIMT_Encode4(655970), // Rule ID 7192 //
     /*  655900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  655911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  655914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  655917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  655946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  655949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  655965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655968 */     GIR_RootConstrainSelectedInstOperands,
     /*  655969 */     // GIR_Coverage, 7192,
     /*  655969 */     GIR_EraseRootFromParent_Done,
     /*  655970 */   // Label 10475: @655970
     /*  655970 */   GIM_Try, /*On fail goto*//*Label 10476*/ GIMT_Encode4(656045), // Rule ID 7193 //
     /*  655975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  655986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  655989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  655992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656021 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  656024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656043 */     GIR_RootConstrainSelectedInstOperands,
     /*  656044 */     // GIR_Coverage, 7193,
     /*  656044 */     GIR_EraseRootFromParent_Done,
     /*  656045 */   // Label 10476: @656045
     /*  656045 */   GIM_Try, /*On fail goto*//*Label 10477*/ GIMT_Encode4(656120), // Rule ID 7196 //
     /*  656050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  656061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  656064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  656067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656118 */     GIR_RootConstrainSelectedInstOperands,
     /*  656119 */     // GIR_Coverage, 7196,
     /*  656119 */     GIR_EraseRootFromParent_Done,
     /*  656120 */   // Label 10477: @656120
     /*  656120 */   GIM_Try, /*On fail goto*//*Label 10478*/ GIMT_Encode4(656195), // Rule ID 7197 //
     /*  656125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  656136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  656139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  656142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656171 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  656171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656193 */     GIR_RootConstrainSelectedInstOperands,
     /*  656194 */     // GIR_Coverage, 7197,
     /*  656194 */     GIR_EraseRootFromParent_Done,
     /*  656195 */   // Label 10478: @656195
     /*  656195 */   GIM_Try, /*On fail goto*//*Label 10479*/ GIMT_Encode4(656270), // Rule ID 7200 //
     /*  656200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  656211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  656214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  656217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656268 */     GIR_RootConstrainSelectedInstOperands,
     /*  656269 */     // GIR_Coverage, 7200,
     /*  656269 */     GIR_EraseRootFromParent_Done,
     /*  656270 */   // Label 10479: @656270
     /*  656270 */   GIM_Try, /*On fail goto*//*Label 10480*/ GIMT_Encode4(656345), // Rule ID 7201 //
     /*  656275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  656286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  656289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  656292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656343 */     GIR_RootConstrainSelectedInstOperands,
     /*  656344 */     // GIR_Coverage, 7201,
     /*  656344 */     GIR_EraseRootFromParent_Done,
     /*  656345 */   // Label 10480: @656345
     /*  656345 */   GIM_Try, /*On fail goto*//*Label 10481*/ GIMT_Encode4(656420), // Rule ID 7204 //
     /*  656350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  656367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656418 */     GIR_RootConstrainSelectedInstOperands,
     /*  656419 */     // GIR_Coverage, 7204,
     /*  656419 */     GIR_EraseRootFromParent_Done,
     /*  656420 */   // Label 10481: @656420
     /*  656420 */   GIM_Try, /*On fail goto*//*Label 10482*/ GIMT_Encode4(656495), // Rule ID 7205 //
     /*  656425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  656442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656493 */     GIR_RootConstrainSelectedInstOperands,
     /*  656494 */     // GIR_Coverage, 7205,
     /*  656494 */     GIR_EraseRootFromParent_Done,
     /*  656495 */   // Label 10482: @656495
     /*  656495 */   GIM_Try, /*On fail goto*//*Label 10483*/ GIMT_Encode4(656570), // Rule ID 7208 //
     /*  656500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  656503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  656511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  656514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  656517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656546 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  656546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  656565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656568 */     GIR_RootConstrainSelectedInstOperands,
     /*  656569 */     // GIR_Coverage, 7208,
     /*  656569 */     GIR_EraseRootFromParent_Done,
     /*  656570 */   // Label 10483: @656570
     /*  656570 */   GIM_Try, /*On fail goto*//*Label 10484*/ GIMT_Encode4(656645), // Rule ID 7209 //
     /*  656575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  656578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  656586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  656589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  656592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656621 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  656621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  656640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656643 */     GIR_RootConstrainSelectedInstOperands,
     /*  656644 */     // GIR_Coverage, 7209,
     /*  656644 */     GIR_EraseRootFromParent_Done,
     /*  656645 */   // Label 10484: @656645
     /*  656645 */   GIM_Try, /*On fail goto*//*Label 10485*/ GIMT_Encode4(656720), // Rule ID 7212 //
     /*  656650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  656661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  656664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  656667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  656699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656718 */     GIR_RootConstrainSelectedInstOperands,
     /*  656719 */     // GIR_Coverage, 7212,
     /*  656719 */     GIR_EraseRootFromParent_Done,
     /*  656720 */   // Label 10485: @656720
     /*  656720 */   GIM_Try, /*On fail goto*//*Label 10486*/ GIMT_Encode4(656795), // Rule ID 7213 //
     /*  656725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  656736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  656739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  656742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656771 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  656771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  656774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656793 */     GIR_RootConstrainSelectedInstOperands,
     /*  656794 */     // GIR_Coverage, 7213,
     /*  656794 */     GIR_EraseRootFromParent_Done,
     /*  656795 */   // Label 10486: @656795
     /*  656795 */   GIM_Try, /*On fail goto*//*Label 10487*/ GIMT_Encode4(656870), // Rule ID 7216 //
     /*  656800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  656811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  656814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  656817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  656849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656868 */     GIR_RootConstrainSelectedInstOperands,
     /*  656869 */     // GIR_Coverage, 7216,
     /*  656869 */     GIR_EraseRootFromParent_Done,
     /*  656870 */   // Label 10487: @656870
     /*  656870 */   GIM_Try, /*On fail goto*//*Label 10488*/ GIMT_Encode4(656945), // Rule ID 7217 //
     /*  656875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  656886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  656889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  656892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  656921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  656924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656943 */     GIR_RootConstrainSelectedInstOperands,
     /*  656944 */     // GIR_Coverage, 7217,
     /*  656944 */     GIR_EraseRootFromParent_Done,
     /*  656945 */   // Label 10488: @656945
     /*  656945 */   GIM_Try, /*On fail goto*//*Label 10489*/ GIMT_Encode4(657020), // Rule ID 7220 //
     /*  656950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  656961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  656964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  656967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656996 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  656999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657018 */     GIR_RootConstrainSelectedInstOperands,
     /*  657019 */     // GIR_Coverage, 7220,
     /*  657019 */     GIR_EraseRootFromParent_Done,
     /*  657020 */   // Label 10489: @657020
     /*  657020 */   GIM_Try, /*On fail goto*//*Label 10490*/ GIMT_Encode4(657095), // Rule ID 7221 //
     /*  657025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  657036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  657039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  657042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657071 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  657074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657093 */     GIR_RootConstrainSelectedInstOperands,
     /*  657094 */     // GIR_Coverage, 7221,
     /*  657094 */     GIR_EraseRootFromParent_Done,
     /*  657095 */   // Label 10490: @657095
     /*  657095 */   GIM_Try, /*On fail goto*//*Label 10491*/ GIMT_Encode4(657170), // Rule ID 7224 //
     /*  657100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  657111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  657114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  657117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  657149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657168 */     GIR_RootConstrainSelectedInstOperands,
     /*  657169 */     // GIR_Coverage, 7224,
     /*  657169 */     GIR_EraseRootFromParent_Done,
     /*  657170 */   // Label 10491: @657170
     /*  657170 */   GIM_Try, /*On fail goto*//*Label 10492*/ GIMT_Encode4(657245), // Rule ID 7225 //
     /*  657175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  657186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  657189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  657192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  657221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  657224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657243 */     GIR_RootConstrainSelectedInstOperands,
     /*  657244 */     // GIR_Coverage, 7225,
     /*  657244 */     GIR_EraseRootFromParent_Done,
     /*  657245 */   // Label 10492: @657245
     /*  657245 */   GIM_Try, /*On fail goto*//*Label 10493*/ GIMT_Encode4(657320), // Rule ID 7228 //
     /*  657250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  657261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  657264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  657267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  657299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657318 */     GIR_RootConstrainSelectedInstOperands,
     /*  657319 */     // GIR_Coverage, 7228,
     /*  657319 */     GIR_EraseRootFromParent_Done,
     /*  657320 */   // Label 10493: @657320
     /*  657320 */   GIM_Try, /*On fail goto*//*Label 10494*/ GIMT_Encode4(657395), // Rule ID 7229 //
     /*  657325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  657336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  657339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  657342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657371 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  657371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  657374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657393 */     GIR_RootConstrainSelectedInstOperands,
     /*  657394 */     // GIR_Coverage, 7229,
     /*  657394 */     GIR_EraseRootFromParent_Done,
     /*  657395 */   // Label 10494: @657395
     /*  657395 */   GIM_Try, /*On fail goto*//*Label 10495*/ GIMT_Encode4(657470), // Rule ID 7232 //
     /*  657400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  657411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  657414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  657417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  657449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657468 */     GIR_RootConstrainSelectedInstOperands,
     /*  657469 */     // GIR_Coverage, 7232,
     /*  657469 */     GIR_EraseRootFromParent_Done,
     /*  657470 */   // Label 10495: @657470
     /*  657470 */   GIM_Try, /*On fail goto*//*Label 10496*/ GIMT_Encode4(657545), // Rule ID 7233 //
     /*  657475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  657486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  657489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  657492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  657521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  657524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657543 */     GIR_RootConstrainSelectedInstOperands,
     /*  657544 */     // GIR_Coverage, 7233,
     /*  657544 */     GIR_EraseRootFromParent_Done,
     /*  657545 */   // Label 10496: @657545
     /*  657545 */   GIM_Try, /*On fail goto*//*Label 10497*/ GIMT_Encode4(657620), // Rule ID 7236 //
     /*  657550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  657561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  657564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  657567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  657596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  657599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657618 */     GIR_RootConstrainSelectedInstOperands,
     /*  657619 */     // GIR_Coverage, 7236,
     /*  657619 */     GIR_EraseRootFromParent_Done,
     /*  657620 */   // Label 10497: @657620
     /*  657620 */   GIM_Try, /*On fail goto*//*Label 10498*/ GIMT_Encode4(657695), // Rule ID 7237 //
     /*  657625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  657636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  657639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  657642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657671 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  657674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657693 */     GIR_RootConstrainSelectedInstOperands,
     /*  657694 */     // GIR_Coverage, 7237,
     /*  657694 */     GIR_EraseRootFromParent_Done,
     /*  657695 */   // Label 10498: @657695
     /*  657695 */   GIM_Try, /*On fail goto*//*Label 10499*/ GIMT_Encode4(657770), // Rule ID 7240 //
     /*  657700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  657711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  657714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  657717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  657746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  657749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657768 */     GIR_RootConstrainSelectedInstOperands,
     /*  657769 */     // GIR_Coverage, 7240,
     /*  657769 */     GIR_EraseRootFromParent_Done,
     /*  657770 */   // Label 10499: @657770
     /*  657770 */   GIM_Try, /*On fail goto*//*Label 10500*/ GIMT_Encode4(657845), // Rule ID 7241 //
     /*  657775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  657786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  657789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  657792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657821 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  657824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657843 */     GIR_RootConstrainSelectedInstOperands,
     /*  657844 */     // GIR_Coverage, 7241,
     /*  657844 */     GIR_EraseRootFromParent_Done,
     /*  657845 */   // Label 10500: @657845
     /*  657845 */   GIM_Try, /*On fail goto*//*Label 10501*/ GIMT_Encode4(657920), // Rule ID 7244 //
     /*  657850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  657861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  657864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  657867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657896 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  657896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  657899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657918 */     GIR_RootConstrainSelectedInstOperands,
     /*  657919 */     // GIR_Coverage, 7244,
     /*  657919 */     GIR_EraseRootFromParent_Done,
     /*  657920 */   // Label 10501: @657920
     /*  657920 */   GIM_Try, /*On fail goto*//*Label 10502*/ GIMT_Encode4(657995), // Rule ID 7245 //
     /*  657925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  657936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  657939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  657942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657971 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  657974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657993 */     GIR_RootConstrainSelectedInstOperands,
     /*  657994 */     // GIR_Coverage, 7245,
     /*  657994 */     GIR_EraseRootFromParent_Done,
     /*  657995 */   // Label 10502: @657995
     /*  657995 */   GIM_Try, /*On fail goto*//*Label 10503*/ GIMT_Encode4(658070), // Rule ID 7248 //
     /*  658000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  658003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  658008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  658011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  658014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  658017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  658046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  658049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  658065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658068 */     GIR_RootConstrainSelectedInstOperands,
     /*  658069 */     // GIR_Coverage, 7248,
     /*  658069 */     GIR_EraseRootFromParent_Done,
     /*  658070 */   // Label 10503: @658070
     /*  658070 */   GIM_Try, /*On fail goto*//*Label 10504*/ GIMT_Encode4(658145), // Rule ID 7249 //
     /*  658075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  658078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  658083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  658086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  658089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  658092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  658121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  658124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  658140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658143 */     GIR_RootConstrainSelectedInstOperands,
     /*  658144 */     // GIR_Coverage, 7249,
     /*  658144 */     GIR_EraseRootFromParent_Done,
     /*  658145 */   // Label 10504: @658145
     /*  658145 */   GIM_Try, /*On fail goto*//*Label 10505*/ GIMT_Encode4(658220), // Rule ID 7252 //
     /*  658150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  658153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  658158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  658161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  658164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  658167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  658196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  658199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  658215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658218 */     GIR_RootConstrainSelectedInstOperands,
     /*  658219 */     // GIR_Coverage, 7252,
     /*  658219 */     GIR_EraseRootFromParent_Done,
     /*  658220 */   // Label 10505: @658220
     /*  658220 */   GIM_Try, /*On fail goto*//*Label 10506*/ GIMT_Encode4(658295), // Rule ID 7253 //
     /*  658225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  658228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  658233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  658236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  658239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  658242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  658271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  658274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  658290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658293 */     GIR_RootConstrainSelectedInstOperands,
     /*  658294 */     // GIR_Coverage, 7253,
     /*  658294 */     GIR_EraseRootFromParent_Done,
     /*  658295 */   // Label 10506: @658295
     /*  658295 */   GIM_Try, /*On fail goto*//*Label 10507*/ GIMT_Encode4(658370), // Rule ID 7256 //
     /*  658300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  658303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  658308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  658311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  658314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  658317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  658346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  658349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  658365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658368 */     GIR_RootConstrainSelectedInstOperands,
     /*  658369 */     // GIR_Coverage, 7256,
     /*  658369 */     GIR_EraseRootFromParent_Done,
     /*  658370 */   // Label 10507: @658370
     /*  658370 */   GIM_Try, /*On fail goto*//*Label 10508*/ GIMT_Encode4(658445), // Rule ID 7257 //
     /*  658375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  658378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  658383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  658386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  658389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  658392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658421 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  658421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  658424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  658440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658443 */     GIR_RootConstrainSelectedInstOperands,
     /*  658444 */     // GIR_Coverage, 7257,
     /*  658444 */     GIR_EraseRootFromParent_Done,
     /*  658445 */   // Label 10508: @658445
     /*  658445 */   GIM_Try, /*On fail goto*//*Label 10509*/ GIMT_Encode4(658520), // Rule ID 7436 //
     /*  658450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  658461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  658464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  658467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  658470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  658499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658518 */     GIR_RootConstrainSelectedInstOperands,
     /*  658519 */     // GIR_Coverage, 7436,
     /*  658519 */     GIR_EraseRootFromParent_Done,
     /*  658520 */   // Label 10509: @658520
     /*  658520 */   GIM_Try, /*On fail goto*//*Label 10510*/ GIMT_Encode4(658595), // Rule ID 7437 //
     /*  658525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  658536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  658539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  658542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  658545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658571 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  658574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658593 */     GIR_RootConstrainSelectedInstOperands,
     /*  658594 */     // GIR_Coverage, 7437,
     /*  658594 */     GIR_EraseRootFromParent_Done,
     /*  658595 */   // Label 10510: @658595
     /*  658595 */   GIM_Try, /*On fail goto*//*Label 10511*/ GIMT_Encode4(658670), // Rule ID 7440 //
     /*  658600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  658611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  658614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  658617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  658620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658646 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  658649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658668 */     GIR_RootConstrainSelectedInstOperands,
     /*  658669 */     // GIR_Coverage, 7440,
     /*  658669 */     GIR_EraseRootFromParent_Done,
     /*  658670 */   // Label 10511: @658670
     /*  658670 */   GIM_Try, /*On fail goto*//*Label 10512*/ GIMT_Encode4(658745), // Rule ID 7441 //
     /*  658675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  658686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  658689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  658692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  658695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658721 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  658724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658743 */     GIR_RootConstrainSelectedInstOperands,
     /*  658744 */     // GIR_Coverage, 7441,
     /*  658744 */     GIR_EraseRootFromParent_Done,
     /*  658745 */   // Label 10512: @658745
     /*  658745 */   GIM_Try, /*On fail goto*//*Label 10513*/ GIMT_Encode4(658820), // Rule ID 7444 //
     /*  658750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  658761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  658764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  658767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  658770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  658799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658818 */     GIR_RootConstrainSelectedInstOperands,
     /*  658819 */     // GIR_Coverage, 7444,
     /*  658819 */     GIR_EraseRootFromParent_Done,
     /*  658820 */   // Label 10513: @658820
     /*  658820 */   GIM_Try, /*On fail goto*//*Label 10514*/ GIMT_Encode4(658895), // Rule ID 7445 //
     /*  658825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  658836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  658839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  658842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  658845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658871 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  658874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658893 */     GIR_RootConstrainSelectedInstOperands,
     /*  658894 */     // GIR_Coverage, 7445,
     /*  658894 */     GIR_EraseRootFromParent_Done,
     /*  658895 */   // Label 10514: @658895
     /*  658895 */   GIM_Try, /*On fail goto*//*Label 10515*/ GIMT_Encode4(658970), // Rule ID 7448 //
     /*  658900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  658911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  658914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  658917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  658920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658946 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  658949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658968 */     GIR_RootConstrainSelectedInstOperands,
     /*  658969 */     // GIR_Coverage, 7448,
     /*  658969 */     GIR_EraseRootFromParent_Done,
     /*  658970 */   // Label 10515: @658970
     /*  658970 */   GIM_Try, /*On fail goto*//*Label 10516*/ GIMT_Encode4(659045), // Rule ID 7449 //
     /*  658975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  658986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  658989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  658992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  658995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659021 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  659024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659043 */     GIR_RootConstrainSelectedInstOperands,
     /*  659044 */     // GIR_Coverage, 7449,
     /*  659044 */     GIR_EraseRootFromParent_Done,
     /*  659045 */   // Label 10516: @659045
     /*  659045 */   GIM_Try, /*On fail goto*//*Label 10517*/ GIMT_Encode4(659120), // Rule ID 7452 //
     /*  659050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  659061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  659064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  659067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  659070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659096 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  659099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659118 */     GIR_RootConstrainSelectedInstOperands,
     /*  659119 */     // GIR_Coverage, 7452,
     /*  659119 */     GIR_EraseRootFromParent_Done,
     /*  659120 */   // Label 10517: @659120
     /*  659120 */   GIM_Try, /*On fail goto*//*Label 10518*/ GIMT_Encode4(659195), // Rule ID 7453 //
     /*  659125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  659136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  659139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  659142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  659145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659171 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  659174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659193 */     GIR_RootConstrainSelectedInstOperands,
     /*  659194 */     // GIR_Coverage, 7453,
     /*  659194 */     GIR_EraseRootFromParent_Done,
     /*  659195 */   // Label 10518: @659195
     /*  659195 */   GIM_Try, /*On fail goto*//*Label 10519*/ GIMT_Encode4(659270), // Rule ID 7456 //
     /*  659200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  659211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  659214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  659217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  659220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659246 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  659249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659268 */     GIR_RootConstrainSelectedInstOperands,
     /*  659269 */     // GIR_Coverage, 7456,
     /*  659269 */     GIR_EraseRootFromParent_Done,
     /*  659270 */   // Label 10519: @659270
     /*  659270 */   GIM_Try, /*On fail goto*//*Label 10520*/ GIMT_Encode4(659345), // Rule ID 7457 //
     /*  659275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  659286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  659289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  659292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  659295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659321 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  659324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659343 */     GIR_RootConstrainSelectedInstOperands,
     /*  659344 */     // GIR_Coverage, 7457,
     /*  659344 */     GIR_EraseRootFromParent_Done,
     /*  659345 */   // Label 10520: @659345
     /*  659345 */   GIM_Try, /*On fail goto*//*Label 10521*/ GIMT_Encode4(659420), // Rule ID 7460 //
     /*  659350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  659361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  659364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  659367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  659370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659396 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  659399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659418 */     GIR_RootConstrainSelectedInstOperands,
     /*  659419 */     // GIR_Coverage, 7460,
     /*  659419 */     GIR_EraseRootFromParent_Done,
     /*  659420 */   // Label 10521: @659420
     /*  659420 */   GIM_Try, /*On fail goto*//*Label 10522*/ GIMT_Encode4(659495), // Rule ID 7461 //
     /*  659425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  659436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  659439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  659442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  659445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659471 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  659471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  659474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659493 */     GIR_RootConstrainSelectedInstOperands,
     /*  659494 */     // GIR_Coverage, 7461,
     /*  659494 */     GIR_EraseRootFromParent_Done,
     /*  659495 */   // Label 10522: @659495
     /*  659495 */   GIM_Try, /*On fail goto*//*Label 10523*/ GIMT_Encode4(659570), // Rule ID 7464 //
     /*  659500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  659511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  659514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  659517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  659520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659546 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  659549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659568 */     GIR_RootConstrainSelectedInstOperands,
     /*  659569 */     // GIR_Coverage, 7464,
     /*  659569 */     GIR_EraseRootFromParent_Done,
     /*  659570 */   // Label 10523: @659570
     /*  659570 */   GIM_Try, /*On fail goto*//*Label 10524*/ GIMT_Encode4(659645), // Rule ID 7465 //
     /*  659575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  659586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  659589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  659592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  659595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659621 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  659621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  659624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659643 */     GIR_RootConstrainSelectedInstOperands,
     /*  659644 */     // GIR_Coverage, 7465,
     /*  659644 */     GIR_EraseRootFromParent_Done,
     /*  659645 */   // Label 10524: @659645
     /*  659645 */   GIM_Try, /*On fail goto*//*Label 10525*/ GIMT_Encode4(659720), // Rule ID 7468 //
     /*  659650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  659661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  659664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  659667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  659670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659696 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  659699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659718 */     GIR_RootConstrainSelectedInstOperands,
     /*  659719 */     // GIR_Coverage, 7468,
     /*  659719 */     GIR_EraseRootFromParent_Done,
     /*  659720 */   // Label 10525: @659720
     /*  659720 */   GIM_Try, /*On fail goto*//*Label 10526*/ GIMT_Encode4(659795), // Rule ID 7469 //
     /*  659725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  659736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  659739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  659742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  659745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659771 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  659771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  659774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659793 */     GIR_RootConstrainSelectedInstOperands,
     /*  659794 */     // GIR_Coverage, 7469,
     /*  659794 */     GIR_EraseRootFromParent_Done,
     /*  659795 */   // Label 10526: @659795
     /*  659795 */   GIM_Try, /*On fail goto*//*Label 10527*/ GIMT_Encode4(659870), // Rule ID 7472 //
     /*  659800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  659811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  659814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  659817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  659820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  659849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659868 */     GIR_RootConstrainSelectedInstOperands,
     /*  659869 */     // GIR_Coverage, 7472,
     /*  659869 */     GIR_EraseRootFromParent_Done,
     /*  659870 */   // Label 10527: @659870
     /*  659870 */   GIM_Try, /*On fail goto*//*Label 10528*/ GIMT_Encode4(659945), // Rule ID 7473 //
     /*  659875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  659886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  659889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  659892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  659895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  659921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  659924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659943 */     GIR_RootConstrainSelectedInstOperands,
     /*  659944 */     // GIR_Coverage, 7473,
     /*  659944 */     GIR_EraseRootFromParent_Done,
     /*  659945 */   // Label 10528: @659945
     /*  659945 */   GIM_Try, /*On fail goto*//*Label 10529*/ GIMT_Encode4(660020), // Rule ID 7476 //
     /*  659950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  659961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  659964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  659967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  659970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  659999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660018 */     GIR_RootConstrainSelectedInstOperands,
     /*  660019 */     // GIR_Coverage, 7476,
     /*  660019 */     GIR_EraseRootFromParent_Done,
     /*  660020 */   // Label 10529: @660020
     /*  660020 */   GIM_Try, /*On fail goto*//*Label 10530*/ GIMT_Encode4(660095), // Rule ID 7477 //
     /*  660025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  660036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  660039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  660042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  660045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  660074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660093 */     GIR_RootConstrainSelectedInstOperands,
     /*  660094 */     // GIR_Coverage, 7477,
     /*  660094 */     GIR_EraseRootFromParent_Done,
     /*  660095 */   // Label 10530: @660095
     /*  660095 */   GIM_Try, /*On fail goto*//*Label 10531*/ GIMT_Encode4(660170), // Rule ID 7480 //
     /*  660100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  660111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  660114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  660117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  660120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  660149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660168 */     GIR_RootConstrainSelectedInstOperands,
     /*  660169 */     // GIR_Coverage, 7480,
     /*  660169 */     GIR_EraseRootFromParent_Done,
     /*  660170 */   // Label 10531: @660170
     /*  660170 */   GIM_Try, /*On fail goto*//*Label 10532*/ GIMT_Encode4(660245), // Rule ID 7481 //
     /*  660175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  660186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  660189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  660192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  660195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660221 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  660224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660243 */     GIR_RootConstrainSelectedInstOperands,
     /*  660244 */     // GIR_Coverage, 7481,
     /*  660244 */     GIR_EraseRootFromParent_Done,
     /*  660245 */   // Label 10532: @660245
     /*  660245 */   GIM_Try, /*On fail goto*//*Label 10533*/ GIMT_Encode4(660320), // Rule ID 7484 //
     /*  660250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  660261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  660264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  660267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  660270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  660299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660318 */     GIR_RootConstrainSelectedInstOperands,
     /*  660319 */     // GIR_Coverage, 7484,
     /*  660319 */     GIR_EraseRootFromParent_Done,
     /*  660320 */   // Label 10533: @660320
     /*  660320 */   GIM_Try, /*On fail goto*//*Label 10534*/ GIMT_Encode4(660395), // Rule ID 7485 //
     /*  660325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  660336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  660339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  660342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  660345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660371 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  660374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660393 */     GIR_RootConstrainSelectedInstOperands,
     /*  660394 */     // GIR_Coverage, 7485,
     /*  660394 */     GIR_EraseRootFromParent_Done,
     /*  660395 */   // Label 10534: @660395
     /*  660395 */   GIM_Try, /*On fail goto*//*Label 10535*/ GIMT_Encode4(660470), // Rule ID 7488 //
     /*  660400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  660411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  660414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  660417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  660420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  660449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660468 */     GIR_RootConstrainSelectedInstOperands,
     /*  660469 */     // GIR_Coverage, 7488,
     /*  660469 */     GIR_EraseRootFromParent_Done,
     /*  660470 */   // Label 10535: @660470
     /*  660470 */   GIM_Try, /*On fail goto*//*Label 10536*/ GIMT_Encode4(660545), // Rule ID 7489 //
     /*  660475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  660486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  660489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  660492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  660495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  660524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660543 */     GIR_RootConstrainSelectedInstOperands,
     /*  660544 */     // GIR_Coverage, 7489,
     /*  660544 */     GIR_EraseRootFromParent_Done,
     /*  660545 */   // Label 10536: @660545
     /*  660545 */   GIM_Try, /*On fail goto*//*Label 10537*/ GIMT_Encode4(660620), // Rule ID 7492 //
     /*  660550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  660561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  660564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  660567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  660570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  660599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660618 */     GIR_RootConstrainSelectedInstOperands,
     /*  660619 */     // GIR_Coverage, 7492,
     /*  660619 */     GIR_EraseRootFromParent_Done,
     /*  660620 */   // Label 10537: @660620
     /*  660620 */   GIM_Try, /*On fail goto*//*Label 10538*/ GIMT_Encode4(660695), // Rule ID 7493 //
     /*  660625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  660636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  660639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  660642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  660645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660671 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  660674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660693 */     GIR_RootConstrainSelectedInstOperands,
     /*  660694 */     // GIR_Coverage, 7493,
     /*  660694 */     GIR_EraseRootFromParent_Done,
     /*  660695 */   // Label 10538: @660695
     /*  660695 */   GIM_Try, /*On fail goto*//*Label 10539*/ GIMT_Encode4(660770), // Rule ID 7496 //
     /*  660700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  660711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  660714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  660717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  660720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660746 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  660749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660768 */     GIR_RootConstrainSelectedInstOperands,
     /*  660769 */     // GIR_Coverage, 7496,
     /*  660769 */     GIR_EraseRootFromParent_Done,
     /*  660770 */   // Label 10539: @660770
     /*  660770 */   GIM_Try, /*On fail goto*//*Label 10540*/ GIMT_Encode4(660845), // Rule ID 7497 //
     /*  660775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  660786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  660789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  660792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  660795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660821 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  660824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660843 */     GIR_RootConstrainSelectedInstOperands,
     /*  660844 */     // GIR_Coverage, 7497,
     /*  660844 */     GIR_EraseRootFromParent_Done,
     /*  660845 */   // Label 10540: @660845
     /*  660845 */   GIM_Try, /*On fail goto*//*Label 10541*/ GIMT_Encode4(660920), // Rule ID 7500 //
     /*  660850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  660861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  660864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  660867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  660870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660896 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  660899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660918 */     GIR_RootConstrainSelectedInstOperands,
     /*  660919 */     // GIR_Coverage, 7500,
     /*  660919 */     GIR_EraseRootFromParent_Done,
     /*  660920 */   // Label 10541: @660920
     /*  660920 */   GIM_Try, /*On fail goto*//*Label 10542*/ GIMT_Encode4(660995), // Rule ID 7501 //
     /*  660925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  660936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  660939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  660942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  660945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660971 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  660974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660993 */     GIR_RootConstrainSelectedInstOperands,
     /*  660994 */     // GIR_Coverage, 7501,
     /*  660994 */     GIR_EraseRootFromParent_Done,
     /*  660995 */   // Label 10542: @660995
     /*  660995 */   GIM_Try, /*On fail goto*//*Label 10543*/ GIMT_Encode4(661070), // Rule ID 7504 //
     /*  661000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  661011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  661014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  661017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661046 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  661049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661068 */     GIR_RootConstrainSelectedInstOperands,
     /*  661069 */     // GIR_Coverage, 7504,
     /*  661069 */     GIR_EraseRootFromParent_Done,
     /*  661070 */   // Label 10543: @661070
     /*  661070 */   GIM_Try, /*On fail goto*//*Label 10544*/ GIMT_Encode4(661145), // Rule ID 7505 //
     /*  661075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  661086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  661089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  661092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661121 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  661124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661143 */     GIR_RootConstrainSelectedInstOperands,
     /*  661144 */     // GIR_Coverage, 7505,
     /*  661144 */     GIR_EraseRootFromParent_Done,
     /*  661145 */   // Label 10544: @661145
     /*  661145 */   GIM_Try, /*On fail goto*//*Label 10545*/ GIMT_Encode4(661220), // Rule ID 7508 //
     /*  661150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  661161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  661164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  661167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  661199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661218 */     GIR_RootConstrainSelectedInstOperands,
     /*  661219 */     // GIR_Coverage, 7508,
     /*  661219 */     GIR_EraseRootFromParent_Done,
     /*  661220 */   // Label 10545: @661220
     /*  661220 */   GIM_Try, /*On fail goto*//*Label 10546*/ GIMT_Encode4(661295), // Rule ID 7509 //
     /*  661225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  661236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  661239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  661242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661271 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  661274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661293 */     GIR_RootConstrainSelectedInstOperands,
     /*  661294 */     // GIR_Coverage, 7509,
     /*  661294 */     GIR_EraseRootFromParent_Done,
     /*  661295 */   // Label 10546: @661295
     /*  661295 */   GIM_Try, /*On fail goto*//*Label 10547*/ GIMT_Encode4(661370), // Rule ID 7512 //
     /*  661300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  661311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  661314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  661317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  661349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661368 */     GIR_RootConstrainSelectedInstOperands,
     /*  661369 */     // GIR_Coverage, 7512,
     /*  661369 */     GIR_EraseRootFromParent_Done,
     /*  661370 */   // Label 10547: @661370
     /*  661370 */   GIM_Try, /*On fail goto*//*Label 10548*/ GIMT_Encode4(661445), // Rule ID 7513 //
     /*  661375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  661386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  661389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  661392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661421 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  661424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661443 */     GIR_RootConstrainSelectedInstOperands,
     /*  661444 */     // GIR_Coverage, 7513,
     /*  661444 */     GIR_EraseRootFromParent_Done,
     /*  661445 */   // Label 10548: @661445
     /*  661445 */   GIM_Try, /*On fail goto*//*Label 10549*/ GIMT_Encode4(661520), // Rule ID 7516 //
     /*  661450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  661461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  661464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  661467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661496 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  661499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661518 */     GIR_RootConstrainSelectedInstOperands,
     /*  661519 */     // GIR_Coverage, 7516,
     /*  661519 */     GIR_EraseRootFromParent_Done,
     /*  661520 */   // Label 10549: @661520
     /*  661520 */   GIM_Try, /*On fail goto*//*Label 10550*/ GIMT_Encode4(661595), // Rule ID 7517 //
     /*  661525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  661536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  661539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  661542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661571 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  661574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661593 */     GIR_RootConstrainSelectedInstOperands,
     /*  661594 */     // GIR_Coverage, 7517,
     /*  661594 */     GIR_EraseRootFromParent_Done,
     /*  661595 */   // Label 10550: @661595
     /*  661595 */   GIM_Try, /*On fail goto*//*Label 10551*/ GIMT_Encode4(661670), // Rule ID 7520 //
     /*  661600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  661611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  661614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  661617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  661646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  661649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661668 */     GIR_RootConstrainSelectedInstOperands,
     /*  661669 */     // GIR_Coverage, 7520,
     /*  661669 */     GIR_EraseRootFromParent_Done,
     /*  661670 */   // Label 10551: @661670
     /*  661670 */   GIM_Try, /*On fail goto*//*Label 10552*/ GIMT_Encode4(661745), // Rule ID 7521 //
     /*  661675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  661686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  661689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  661692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661721 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  661721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  661724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661743 */     GIR_RootConstrainSelectedInstOperands,
     /*  661744 */     // GIR_Coverage, 7521,
     /*  661744 */     GIR_EraseRootFromParent_Done,
     /*  661745 */   // Label 10552: @661745
     /*  661745 */   GIM_Try, /*On fail goto*//*Label 10553*/ GIMT_Encode4(661820), // Rule ID 7524 //
     /*  661750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  661761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  661764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  661767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  661796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  661799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661818 */     GIR_RootConstrainSelectedInstOperands,
     /*  661819 */     // GIR_Coverage, 7524,
     /*  661819 */     GIR_EraseRootFromParent_Done,
     /*  661820 */   // Label 10553: @661820
     /*  661820 */   GIM_Try, /*On fail goto*//*Label 10554*/ GIMT_Encode4(661895), // Rule ID 7525 //
     /*  661825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  661836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  661839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  661842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  661871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  661874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661893 */     GIR_RootConstrainSelectedInstOperands,
     /*  661894 */     // GIR_Coverage, 7525,
     /*  661894 */     GIR_EraseRootFromParent_Done,
     /*  661895 */   // Label 10554: @661895
     /*  661895 */   GIM_Try, /*On fail goto*//*Label 10555*/ GIMT_Encode4(661970), // Rule ID 7528 //
     /*  661900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  661911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  661914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  661917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  661946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  661949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661968 */     GIR_RootConstrainSelectedInstOperands,
     /*  661969 */     // GIR_Coverage, 7528,
     /*  661969 */     GIR_EraseRootFromParent_Done,
     /*  661970 */   // Label 10555: @661970
     /*  661970 */   GIM_Try, /*On fail goto*//*Label 10556*/ GIMT_Encode4(662045), // Rule ID 7529 //
     /*  661975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  661986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  661989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  661992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662021 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  662024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662043 */     GIR_RootConstrainSelectedInstOperands,
     /*  662044 */     // GIR_Coverage, 7529,
     /*  662044 */     GIR_EraseRootFromParent_Done,
     /*  662045 */   // Label 10556: @662045
     /*  662045 */   GIM_Try, /*On fail goto*//*Label 10557*/ GIMT_Encode4(662120), // Rule ID 7532 //
     /*  662050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  662061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  662064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  662067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  662099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662118 */     GIR_RootConstrainSelectedInstOperands,
     /*  662119 */     // GIR_Coverage, 7532,
     /*  662119 */     GIR_EraseRootFromParent_Done,
     /*  662120 */   // Label 10557: @662120
     /*  662120 */   GIM_Try, /*On fail goto*//*Label 10558*/ GIMT_Encode4(662195), // Rule ID 7533 //
     /*  662125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  662136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  662139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  662142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662171 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  662174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662193 */     GIR_RootConstrainSelectedInstOperands,
     /*  662194 */     // GIR_Coverage, 7533,
     /*  662194 */     GIR_EraseRootFromParent_Done,
     /*  662195 */   // Label 10558: @662195
     /*  662195 */   GIM_Try, /*On fail goto*//*Label 10559*/ GIMT_Encode4(662270), // Rule ID 7536 //
     /*  662200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  662211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  662214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  662217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662246 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  662249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662268 */     GIR_RootConstrainSelectedInstOperands,
     /*  662269 */     // GIR_Coverage, 7536,
     /*  662269 */     GIR_EraseRootFromParent_Done,
     /*  662270 */   // Label 10559: @662270
     /*  662270 */   GIM_Try, /*On fail goto*//*Label 10560*/ GIMT_Encode4(662345), // Rule ID 7537 //
     /*  662275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  662286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  662289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  662292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662321 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  662324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662343 */     GIR_RootConstrainSelectedInstOperands,
     /*  662344 */     // GIR_Coverage, 7537,
     /*  662344 */     GIR_EraseRootFromParent_Done,
     /*  662345 */   // Label 10560: @662345
     /*  662345 */   GIM_Try, /*On fail goto*//*Label 10561*/ GIMT_Encode4(662420), // Rule ID 7540 //
     /*  662350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  662353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  662361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  662364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  662367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  662396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  662399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662418 */     GIR_RootConstrainSelectedInstOperands,
     /*  662419 */     // GIR_Coverage, 7540,
     /*  662419 */     GIR_EraseRootFromParent_Done,
     /*  662420 */   // Label 10561: @662420
     /*  662420 */   GIM_Try, /*On fail goto*//*Label 10562*/ GIMT_Encode4(662495), // Rule ID 7541 //
     /*  662425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  662428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  662436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  662439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  662442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662471 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  662471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  662474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662493 */     GIR_RootConstrainSelectedInstOperands,
     /*  662494 */     // GIR_Coverage, 7541,
     /*  662494 */     GIR_EraseRootFromParent_Done,
     /*  662495 */   // Label 10562: @662495
     /*  662495 */   GIM_Try, /*On fail goto*//*Label 10563*/ GIMT_Encode4(662570), // Rule ID 7544 //
     /*  662500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  662503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  662511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  662514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  662517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662546 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  662546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  662549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662568 */     GIR_RootConstrainSelectedInstOperands,
     /*  662569 */     // GIR_Coverage, 7544,
     /*  662569 */     GIR_EraseRootFromParent_Done,
     /*  662570 */   // Label 10563: @662570
     /*  662570 */   GIM_Try, /*On fail goto*//*Label 10564*/ GIMT_Encode4(662645), // Rule ID 7545 //
     /*  662575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  662578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  662586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  662589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  662592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662621 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  662621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  662624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662643 */     GIR_RootConstrainSelectedInstOperands,
     /*  662644 */     // GIR_Coverage, 7545,
     /*  662644 */     GIR_EraseRootFromParent_Done,
     /*  662645 */   // Label 10564: @662645
     /*  662645 */   GIM_Try, /*On fail goto*//*Label 10565*/ GIMT_Encode4(662720), // Rule ID 7548 //
     /*  662650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  662653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  662661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  662664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  662667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  662696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  662699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662718 */     GIR_RootConstrainSelectedInstOperands,
     /*  662719 */     // GIR_Coverage, 7548,
     /*  662719 */     GIR_EraseRootFromParent_Done,
     /*  662720 */   // Label 10565: @662720
     /*  662720 */   GIM_Try, /*On fail goto*//*Label 10566*/ GIMT_Encode4(662795), // Rule ID 7549 //
     /*  662725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  662728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  662736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  662739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  662742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  662771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  662774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662793 */     GIR_RootConstrainSelectedInstOperands,
     /*  662794 */     // GIR_Coverage, 7549,
     /*  662794 */     GIR_EraseRootFromParent_Done,
     /*  662795 */   // Label 10566: @662795
     /*  662795 */   GIM_Try, /*On fail goto*//*Label 10567*/ GIMT_Encode4(662870), // Rule ID 7552 //
     /*  662800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  662803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  662811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  662814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  662817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  662846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  662849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662868 */     GIR_RootConstrainSelectedInstOperands,
     /*  662869 */     // GIR_Coverage, 7552,
     /*  662869 */     GIR_EraseRootFromParent_Done,
     /*  662870 */   // Label 10567: @662870
     /*  662870 */   GIM_Try, /*On fail goto*//*Label 10568*/ GIMT_Encode4(662945), // Rule ID 7553 //
     /*  662875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  662878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  662886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  662889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  662892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662921 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  662921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  662924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662943 */     GIR_RootConstrainSelectedInstOperands,
     /*  662944 */     // GIR_Coverage, 7553,
     /*  662944 */     GIR_EraseRootFromParent_Done,
     /*  662945 */   // Label 10568: @662945
     /*  662945 */   GIM_Try, /*On fail goto*//*Label 10569*/ GIMT_Encode4(663020), // Rule ID 7616 //
     /*  662950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  662961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  662964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  662967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  662970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  662999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663018 */     GIR_RootConstrainSelectedInstOperands,
     /*  663019 */     // GIR_Coverage, 7616,
     /*  663019 */     GIR_EraseRootFromParent_Done,
     /*  663020 */   // Label 10569: @663020
     /*  663020 */   GIM_Try, /*On fail goto*//*Label 10570*/ GIMT_Encode4(663095), // Rule ID 7617 //
     /*  663025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  663036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  663039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  663042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  663045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663071 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  663074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663093 */     GIR_RootConstrainSelectedInstOperands,
     /*  663094 */     // GIR_Coverage, 7617,
     /*  663094 */     GIR_EraseRootFromParent_Done,
     /*  663095 */   // Label 10570: @663095
     /*  663095 */   GIM_Try, /*On fail goto*//*Label 10571*/ GIMT_Encode4(663170), // Rule ID 7620 //
     /*  663100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  663111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  663114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  663117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  663120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663146 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  663149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663168 */     GIR_RootConstrainSelectedInstOperands,
     /*  663169 */     // GIR_Coverage, 7620,
     /*  663169 */     GIR_EraseRootFromParent_Done,
     /*  663170 */   // Label 10571: @663170
     /*  663170 */   GIM_Try, /*On fail goto*//*Label 10572*/ GIMT_Encode4(663245), // Rule ID 7621 //
     /*  663175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  663186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  663189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  663192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  663195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663221 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  663224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663243 */     GIR_RootConstrainSelectedInstOperands,
     /*  663244 */     // GIR_Coverage, 7621,
     /*  663244 */     GIR_EraseRootFromParent_Done,
     /*  663245 */   // Label 10572: @663245
     /*  663245 */   GIM_Try, /*On fail goto*//*Label 10573*/ GIMT_Encode4(663320), // Rule ID 7624 //
     /*  663250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  663261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  663264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  663267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  663270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663296 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  663299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663318 */     GIR_RootConstrainSelectedInstOperands,
     /*  663319 */     // GIR_Coverage, 7624,
     /*  663319 */     GIR_EraseRootFromParent_Done,
     /*  663320 */   // Label 10573: @663320
     /*  663320 */   GIM_Try, /*On fail goto*//*Label 10574*/ GIMT_Encode4(663395), // Rule ID 7625 //
     /*  663325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  663336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  663339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  663342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  663345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663371 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  663374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663393 */     GIR_RootConstrainSelectedInstOperands,
     /*  663394 */     // GIR_Coverage, 7625,
     /*  663394 */     GIR_EraseRootFromParent_Done,
     /*  663395 */   // Label 10574: @663395
     /*  663395 */   GIM_Try, /*On fail goto*//*Label 10575*/ GIMT_Encode4(663470), // Rule ID 7628 //
     /*  663400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  663411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  663414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  663417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  663420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663446 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  663449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663468 */     GIR_RootConstrainSelectedInstOperands,
     /*  663469 */     // GIR_Coverage, 7628,
     /*  663469 */     GIR_EraseRootFromParent_Done,
     /*  663470 */   // Label 10575: @663470
     /*  663470 */   GIM_Try, /*On fail goto*//*Label 10576*/ GIMT_Encode4(663545), // Rule ID 7629 //
     /*  663475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  663486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  663489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  663492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  663495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663521 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  663524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663543 */     GIR_RootConstrainSelectedInstOperands,
     /*  663544 */     // GIR_Coverage, 7629,
     /*  663544 */     GIR_EraseRootFromParent_Done,
     /*  663545 */   // Label 10576: @663545
     /*  663545 */   GIM_Try, /*On fail goto*//*Label 10577*/ GIMT_Encode4(663620), // Rule ID 7632 //
     /*  663550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  663561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  663564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  663567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  663570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  663599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663618 */     GIR_RootConstrainSelectedInstOperands,
     /*  663619 */     // GIR_Coverage, 7632,
     /*  663619 */     GIR_EraseRootFromParent_Done,
     /*  663620 */   // Label 10577: @663620
     /*  663620 */   GIM_Try, /*On fail goto*//*Label 10578*/ GIMT_Encode4(663695), // Rule ID 7633 //
     /*  663625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  663636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  663639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  663642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  663645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663671 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  663674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663693 */     GIR_RootConstrainSelectedInstOperands,
     /*  663694 */     // GIR_Coverage, 7633,
     /*  663694 */     GIR_EraseRootFromParent_Done,
     /*  663695 */   // Label 10578: @663695
     /*  663695 */   GIM_Try, /*On fail goto*//*Label 10579*/ GIMT_Encode4(663770), // Rule ID 7636 //
     /*  663700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  663711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  663714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  663717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  663720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663746 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  663749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663768 */     GIR_RootConstrainSelectedInstOperands,
     /*  663769 */     // GIR_Coverage, 7636,
     /*  663769 */     GIR_EraseRootFromParent_Done,
     /*  663770 */   // Label 10579: @663770
     /*  663770 */   GIM_Try, /*On fail goto*//*Label 10580*/ GIMT_Encode4(663845), // Rule ID 7637 //
     /*  663775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  663786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  663789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  663792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  663795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663821 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  663824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663843 */     GIR_RootConstrainSelectedInstOperands,
     /*  663844 */     // GIR_Coverage, 7637,
     /*  663844 */     GIR_EraseRootFromParent_Done,
     /*  663845 */   // Label 10580: @663845
     /*  663845 */   GIM_Try, /*On fail goto*//*Label 10581*/ GIMT_Encode4(663920), // Rule ID 7640 //
     /*  663850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  663861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  663864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  663867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  663870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663896 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  663896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  663899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663918 */     GIR_RootConstrainSelectedInstOperands,
     /*  663919 */     // GIR_Coverage, 7640,
     /*  663919 */     GIR_EraseRootFromParent_Done,
     /*  663920 */   // Label 10581: @663920
     /*  663920 */   GIM_Try, /*On fail goto*//*Label 10582*/ GIMT_Encode4(663995), // Rule ID 7641 //
     /*  663925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  663936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  663939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  663942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  663945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663971 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  663971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  663974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663993 */     GIR_RootConstrainSelectedInstOperands,
     /*  663994 */     // GIR_Coverage, 7641,
     /*  663994 */     GIR_EraseRootFromParent_Done,
     /*  663995 */   // Label 10582: @663995
     /*  663995 */   GIM_Try, /*On fail goto*//*Label 10583*/ GIMT_Encode4(664070), // Rule ID 7644 //
     /*  664000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  664011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  664014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  664017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  664020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664046 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  664049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664068 */     GIR_RootConstrainSelectedInstOperands,
     /*  664069 */     // GIR_Coverage, 7644,
     /*  664069 */     GIR_EraseRootFromParent_Done,
     /*  664070 */   // Label 10583: @664070
     /*  664070 */   GIM_Try, /*On fail goto*//*Label 10584*/ GIMT_Encode4(664145), // Rule ID 7645 //
     /*  664075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  664086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  664089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  664092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  664095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664121 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  664124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664143 */     GIR_RootConstrainSelectedInstOperands,
     /*  664144 */     // GIR_Coverage, 7645,
     /*  664144 */     GIR_EraseRootFromParent_Done,
     /*  664145 */   // Label 10584: @664145
     /*  664145 */   GIM_Try, /*On fail goto*//*Label 10585*/ GIMT_Encode4(664220), // Rule ID 7648 //
     /*  664150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  664161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  664164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  664167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  664170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664196 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  664199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664218 */     GIR_RootConstrainSelectedInstOperands,
     /*  664219 */     // GIR_Coverage, 7648,
     /*  664219 */     GIR_EraseRootFromParent_Done,
     /*  664220 */   // Label 10585: @664220
     /*  664220 */   GIM_Try, /*On fail goto*//*Label 10586*/ GIMT_Encode4(664295), // Rule ID 7649 //
     /*  664225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  664236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  664239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  664242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  664245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664271 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  664274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664293 */     GIR_RootConstrainSelectedInstOperands,
     /*  664294 */     // GIR_Coverage, 7649,
     /*  664294 */     GIR_EraseRootFromParent_Done,
     /*  664295 */   // Label 10586: @664295
     /*  664295 */   GIM_Try, /*On fail goto*//*Label 10587*/ GIMT_Encode4(664370), // Rule ID 7652 //
     /*  664300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  664311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  664314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  664317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  664320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  664349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664368 */     GIR_RootConstrainSelectedInstOperands,
     /*  664369 */     // GIR_Coverage, 7652,
     /*  664369 */     GIR_EraseRootFromParent_Done,
     /*  664370 */   // Label 10587: @664370
     /*  664370 */   GIM_Try, /*On fail goto*//*Label 10588*/ GIMT_Encode4(664445), // Rule ID 7653 //
     /*  664375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  664386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  664389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  664392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  664395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  664424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664443 */     GIR_RootConstrainSelectedInstOperands,
     /*  664444 */     // GIR_Coverage, 7653,
     /*  664444 */     GIR_EraseRootFromParent_Done,
     /*  664445 */   // Label 10588: @664445
     /*  664445 */   GIM_Try, /*On fail goto*//*Label 10589*/ GIMT_Encode4(664520), // Rule ID 7656 //
     /*  664450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  664461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  664464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  664467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  664470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  664499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664518 */     GIR_RootConstrainSelectedInstOperands,
     /*  664519 */     // GIR_Coverage, 7656,
     /*  664519 */     GIR_EraseRootFromParent_Done,
     /*  664520 */   // Label 10589: @664520
     /*  664520 */   GIM_Try, /*On fail goto*//*Label 10590*/ GIMT_Encode4(664595), // Rule ID 7657 //
     /*  664525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  664536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  664539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  664542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  664545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664571 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  664574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664593 */     GIR_RootConstrainSelectedInstOperands,
     /*  664594 */     // GIR_Coverage, 7657,
     /*  664594 */     GIR_EraseRootFromParent_Done,
     /*  664595 */   // Label 10590: @664595
     /*  664595 */   GIM_Try, /*On fail goto*//*Label 10591*/ GIMT_Encode4(664670), // Rule ID 7660 //
     /*  664600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  664603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  664611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  664614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  664617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  664620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  664649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664668 */     GIR_RootConstrainSelectedInstOperands,
     /*  664669 */     // GIR_Coverage, 7660,
     /*  664669 */     GIR_EraseRootFromParent_Done,
     /*  664670 */   // Label 10591: @664670
     /*  664670 */   GIM_Try, /*On fail goto*//*Label 10592*/ GIMT_Encode4(664745), // Rule ID 7661 //
     /*  664675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  664678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  664686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  664689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  664692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  664695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  664724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664743 */     GIR_RootConstrainSelectedInstOperands,
     /*  664744 */     // GIR_Coverage, 7661,
     /*  664744 */     GIR_EraseRootFromParent_Done,
     /*  664745 */   // Label 10592: @664745
     /*  664745 */   GIM_Try, /*On fail goto*//*Label 10593*/ GIMT_Encode4(664820), // Rule ID 7664 //
     /*  664750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  664753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  664761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  664764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  664767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  664770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  664799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664818 */     GIR_RootConstrainSelectedInstOperands,
     /*  664819 */     // GIR_Coverage, 7664,
     /*  664819 */     GIR_EraseRootFromParent_Done,
     /*  664820 */   // Label 10593: @664820
     /*  664820 */   GIM_Try, /*On fail goto*//*Label 10594*/ GIMT_Encode4(664895), // Rule ID 7665 //
     /*  664825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  664828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  664836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  664839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  664842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  664845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  664874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664893 */     GIR_RootConstrainSelectedInstOperands,
     /*  664894 */     // GIR_Coverage, 7665,
     /*  664894 */     GIR_EraseRootFromParent_Done,
     /*  664895 */   // Label 10594: @664895
     /*  664895 */   GIM_Try, /*On fail goto*//*Label 10595*/ GIMT_Encode4(664970), // Rule ID 7668 //
     /*  664900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  664903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  664911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  664914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  664917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  664920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  664949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664968 */     GIR_RootConstrainSelectedInstOperands,
     /*  664969 */     // GIR_Coverage, 7668,
     /*  664969 */     GIR_EraseRootFromParent_Done,
     /*  664970 */   // Label 10595: @664970
     /*  664970 */   GIM_Try, /*On fail goto*//*Label 10596*/ GIMT_Encode4(665045), // Rule ID 7669 //
     /*  664975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  664978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  664986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  664989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  664992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  664995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665021 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  665021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  665024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665043 */     GIR_RootConstrainSelectedInstOperands,
     /*  665044 */     // GIR_Coverage, 7669,
     /*  665044 */     GIR_EraseRootFromParent_Done,
     /*  665045 */   // Label 10596: @665045
     /*  665045 */   GIM_Try, /*On fail goto*//*Label 10597*/ GIMT_Encode4(665120), // Rule ID 7672 //
     /*  665050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  665053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  665061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  665064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  665067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  665070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665096 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  665096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  665099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665118 */     GIR_RootConstrainSelectedInstOperands,
     /*  665119 */     // GIR_Coverage, 7672,
     /*  665119 */     GIR_EraseRootFromParent_Done,
     /*  665120 */   // Label 10597: @665120
     /*  665120 */   GIM_Try, /*On fail goto*//*Label 10598*/ GIMT_Encode4(665195), // Rule ID 7673 //
     /*  665125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  665128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  665136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  665139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  665142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  665145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665171 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  665171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  665174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665193 */     GIR_RootConstrainSelectedInstOperands,
     /*  665194 */     // GIR_Coverage, 7673,
     /*  665194 */     GIR_EraseRootFromParent_Done,
     /*  665195 */   // Label 10598: @665195
     /*  665195 */   GIM_Try, /*On fail goto*//*Label 10599*/ GIMT_Encode4(665270), // Rule ID 7676 //
     /*  665200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  665211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  665214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  665217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665246 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  665249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665268 */     GIR_RootConstrainSelectedInstOperands,
     /*  665269 */     // GIR_Coverage, 7676,
     /*  665269 */     GIR_EraseRootFromParent_Done,
     /*  665270 */   // Label 10599: @665270
     /*  665270 */   GIM_Try, /*On fail goto*//*Label 10600*/ GIMT_Encode4(665345), // Rule ID 7677 //
     /*  665275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  665286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  665289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  665292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665321 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  665324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665343 */     GIR_RootConstrainSelectedInstOperands,
     /*  665344 */     // GIR_Coverage, 7677,
     /*  665344 */     GIR_EraseRootFromParent_Done,
     /*  665345 */   // Label 10600: @665345
     /*  665345 */   GIM_Try, /*On fail goto*//*Label 10601*/ GIMT_Encode4(665420), // Rule ID 7680 //
     /*  665350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  665361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  665364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  665367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665396 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  665399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665418 */     GIR_RootConstrainSelectedInstOperands,
     /*  665419 */     // GIR_Coverage, 7680,
     /*  665419 */     GIR_EraseRootFromParent_Done,
     /*  665420 */   // Label 10601: @665420
     /*  665420 */   GIM_Try, /*On fail goto*//*Label 10602*/ GIMT_Encode4(665495), // Rule ID 7681 //
     /*  665425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  665436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  665439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  665442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665471 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  665474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665493 */     GIR_RootConstrainSelectedInstOperands,
     /*  665494 */     // GIR_Coverage, 7681,
     /*  665494 */     GIR_EraseRootFromParent_Done,
     /*  665495 */   // Label 10602: @665495
     /*  665495 */   GIM_Try, /*On fail goto*//*Label 10603*/ GIMT_Encode4(665570), // Rule ID 7684 //
     /*  665500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  665511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  665514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  665517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665546 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  665549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665568 */     GIR_RootConstrainSelectedInstOperands,
     /*  665569 */     // GIR_Coverage, 7684,
     /*  665569 */     GIR_EraseRootFromParent_Done,
     /*  665570 */   // Label 10603: @665570
     /*  665570 */   GIM_Try, /*On fail goto*//*Label 10604*/ GIMT_Encode4(665645), // Rule ID 7685 //
     /*  665575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  665586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  665589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  665592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665621 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  665624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665643 */     GIR_RootConstrainSelectedInstOperands,
     /*  665644 */     // GIR_Coverage, 7685,
     /*  665644 */     GIR_EraseRootFromParent_Done,
     /*  665645 */   // Label 10604: @665645
     /*  665645 */   GIM_Try, /*On fail goto*//*Label 10605*/ GIMT_Encode4(665720), // Rule ID 7688 //
     /*  665650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  665661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  665664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  665667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  665699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665718 */     GIR_RootConstrainSelectedInstOperands,
     /*  665719 */     // GIR_Coverage, 7688,
     /*  665719 */     GIR_EraseRootFromParent_Done,
     /*  665720 */   // Label 10605: @665720
     /*  665720 */   GIM_Try, /*On fail goto*//*Label 10606*/ GIMT_Encode4(665795), // Rule ID 7689 //
     /*  665725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  665736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  665739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  665742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665771 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  665774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665793 */     GIR_RootConstrainSelectedInstOperands,
     /*  665794 */     // GIR_Coverage, 7689,
     /*  665794 */     GIR_EraseRootFromParent_Done,
     /*  665795 */   // Label 10606: @665795
     /*  665795 */   GIM_Try, /*On fail goto*//*Label 10607*/ GIMT_Encode4(665870), // Rule ID 7692 //
     /*  665800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  665811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  665814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  665817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665846 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  665849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665868 */     GIR_RootConstrainSelectedInstOperands,
     /*  665869 */     // GIR_Coverage, 7692,
     /*  665869 */     GIR_EraseRootFromParent_Done,
     /*  665870 */   // Label 10607: @665870
     /*  665870 */   GIM_Try, /*On fail goto*//*Label 10608*/ GIMT_Encode4(665945), // Rule ID 7693 //
     /*  665875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  665886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  665889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  665892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665921 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  665924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665943 */     GIR_RootConstrainSelectedInstOperands,
     /*  665944 */     // GIR_Coverage, 7693,
     /*  665944 */     GIR_EraseRootFromParent_Done,
     /*  665945 */   // Label 10608: @665945
     /*  665945 */   GIM_Try, /*On fail goto*//*Label 10609*/ GIMT_Encode4(666020), // Rule ID 7696 //
     /*  665950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  665961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  665964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  665967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665996 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  665999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666018 */     GIR_RootConstrainSelectedInstOperands,
     /*  666019 */     // GIR_Coverage, 7696,
     /*  666019 */     GIR_EraseRootFromParent_Done,
     /*  666020 */   // Label 10609: @666020
     /*  666020 */   GIM_Try, /*On fail goto*//*Label 10610*/ GIMT_Encode4(666095), // Rule ID 7697 //
     /*  666025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  666036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  666039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  666042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666071 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  666071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  666074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666093 */     GIR_RootConstrainSelectedInstOperands,
     /*  666094 */     // GIR_Coverage, 7697,
     /*  666094 */     GIR_EraseRootFromParent_Done,
     /*  666095 */   // Label 10610: @666095
     /*  666095 */   GIM_Try, /*On fail goto*//*Label 10611*/ GIMT_Encode4(666170), // Rule ID 7700 //
     /*  666100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  666111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  666114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  666117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666146 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  666149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666168 */     GIR_RootConstrainSelectedInstOperands,
     /*  666169 */     // GIR_Coverage, 7700,
     /*  666169 */     GIR_EraseRootFromParent_Done,
     /*  666170 */   // Label 10611: @666170
     /*  666170 */   GIM_Try, /*On fail goto*//*Label 10612*/ GIMT_Encode4(666245), // Rule ID 7701 //
     /*  666175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  666186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  666189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  666192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666221 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  666224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666243 */     GIR_RootConstrainSelectedInstOperands,
     /*  666244 */     // GIR_Coverage, 7701,
     /*  666244 */     GIR_EraseRootFromParent_Done,
     /*  666245 */   // Label 10612: @666245
     /*  666245 */   GIM_Try, /*On fail goto*//*Label 10613*/ GIMT_Encode4(666320), // Rule ID 7704 //
     /*  666250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  666261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  666264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  666267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666296 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  666299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666318 */     GIR_RootConstrainSelectedInstOperands,
     /*  666319 */     // GIR_Coverage, 7704,
     /*  666319 */     GIR_EraseRootFromParent_Done,
     /*  666320 */   // Label 10613: @666320
     /*  666320 */   GIM_Try, /*On fail goto*//*Label 10614*/ GIMT_Encode4(666395), // Rule ID 7705 //
     /*  666325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  666336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  666339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  666342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666371 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  666374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666393 */     GIR_RootConstrainSelectedInstOperands,
     /*  666394 */     // GIR_Coverage, 7705,
     /*  666394 */     GIR_EraseRootFromParent_Done,
     /*  666395 */   // Label 10614: @666395
     /*  666395 */   GIM_Try, /*On fail goto*//*Label 10615*/ GIMT_Encode4(666470), // Rule ID 7708 //
     /*  666400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  666411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  666414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  666417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  666449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666468 */     GIR_RootConstrainSelectedInstOperands,
     /*  666469 */     // GIR_Coverage, 7708,
     /*  666469 */     GIR_EraseRootFromParent_Done,
     /*  666470 */   // Label 10615: @666470
     /*  666470 */   GIM_Try, /*On fail goto*//*Label 10616*/ GIMT_Encode4(666545), // Rule ID 7709 //
     /*  666475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  666486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  666489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  666492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666521 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  666524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666543 */     GIR_RootConstrainSelectedInstOperands,
     /*  666544 */     // GIR_Coverage, 7709,
     /*  666544 */     GIR_EraseRootFromParent_Done,
     /*  666545 */   // Label 10616: @666545
     /*  666545 */   GIM_Try, /*On fail goto*//*Label 10617*/ GIMT_Encode4(666620), // Rule ID 7712 //
     /*  666550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  666561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  666564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  666567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666596 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  666599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666618 */     GIR_RootConstrainSelectedInstOperands,
     /*  666619 */     // GIR_Coverage, 7712,
     /*  666619 */     GIR_EraseRootFromParent_Done,
     /*  666620 */   // Label 10617: @666620
     /*  666620 */   GIM_Try, /*On fail goto*//*Label 10618*/ GIMT_Encode4(666695), // Rule ID 7713 //
     /*  666625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  666636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  666639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  666642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666671 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  666674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666693 */     GIR_RootConstrainSelectedInstOperands,
     /*  666694 */     // GIR_Coverage, 7713,
     /*  666694 */     GIR_EraseRootFromParent_Done,
     /*  666695 */   // Label 10618: @666695
     /*  666695 */   GIM_Try, /*On fail goto*//*Label 10619*/ GIMT_Encode4(666770), // Rule ID 7716 //
     /*  666700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  666711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  666714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  666717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666746 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  666749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666768 */     GIR_RootConstrainSelectedInstOperands,
     /*  666769 */     // GIR_Coverage, 7716,
     /*  666769 */     GIR_EraseRootFromParent_Done,
     /*  666770 */   // Label 10619: @666770
     /*  666770 */   GIM_Try, /*On fail goto*//*Label 10620*/ GIMT_Encode4(666845), // Rule ID 7717 //
     /*  666775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  666786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  666789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  666792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666821 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  666824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666843 */     GIR_RootConstrainSelectedInstOperands,
     /*  666844 */     // GIR_Coverage, 7717,
     /*  666844 */     GIR_EraseRootFromParent_Done,
     /*  666845 */   // Label 10620: @666845
     /*  666845 */   GIM_Try, /*On fail goto*//*Label 10621*/ GIMT_Encode4(666920), // Rule ID 7720 //
     /*  666850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  666853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  666861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  666864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  666867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666896 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  666899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666918 */     GIR_RootConstrainSelectedInstOperands,
     /*  666919 */     // GIR_Coverage, 7720,
     /*  666919 */     GIR_EraseRootFromParent_Done,
     /*  666920 */   // Label 10621: @666920
     /*  666920 */   GIM_Try, /*On fail goto*//*Label 10622*/ GIMT_Encode4(666995), // Rule ID 7721 //
     /*  666925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  666928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  666936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  666939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  666942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666971 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  666974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666993 */     GIR_RootConstrainSelectedInstOperands,
     /*  666994 */     // GIR_Coverage, 7721,
     /*  666994 */     GIR_EraseRootFromParent_Done,
     /*  666995 */   // Label 10622: @666995
     /*  666995 */   GIM_Try, /*On fail goto*//*Label 10623*/ GIMT_Encode4(667070), // Rule ID 7724 //
     /*  667000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  667003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  667008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  667011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  667014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  667017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667046 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  667046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  667049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667068 */     GIR_RootConstrainSelectedInstOperands,
     /*  667069 */     // GIR_Coverage, 7724,
     /*  667069 */     GIR_EraseRootFromParent_Done,
     /*  667070 */   // Label 10623: @667070
     /*  667070 */   GIM_Try, /*On fail goto*//*Label 10624*/ GIMT_Encode4(667145), // Rule ID 7725 //
     /*  667075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  667078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  667083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  667086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  667089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  667092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667121 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  667121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  667124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667143 */     GIR_RootConstrainSelectedInstOperands,
     /*  667144 */     // GIR_Coverage, 7725,
     /*  667144 */     GIR_EraseRootFromParent_Done,
     /*  667145 */   // Label 10624: @667145
     /*  667145 */   GIM_Try, /*On fail goto*//*Label 10625*/ GIMT_Encode4(667220), // Rule ID 7728 //
     /*  667150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  667153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  667158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  667161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  667164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  667167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  667196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  667199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667218 */     GIR_RootConstrainSelectedInstOperands,
     /*  667219 */     // GIR_Coverage, 7728,
     /*  667219 */     GIR_EraseRootFromParent_Done,
     /*  667220 */   // Label 10625: @667220
     /*  667220 */   GIM_Try, /*On fail goto*//*Label 10626*/ GIMT_Encode4(667295), // Rule ID 7729 //
     /*  667225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  667228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  667233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  667236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  667239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  667242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  667271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  667274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667293 */     GIR_RootConstrainSelectedInstOperands,
     /*  667294 */     // GIR_Coverage, 7729,
     /*  667294 */     GIR_EraseRootFromParent_Done,
     /*  667295 */   // Label 10626: @667295
     /*  667295 */   GIM_Try, /*On fail goto*//*Label 10627*/ GIMT_Encode4(667370), // Rule ID 7732 //
     /*  667300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  667303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  667308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  667311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  667314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  667317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  667346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  667349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667368 */     GIR_RootConstrainSelectedInstOperands,
     /*  667369 */     // GIR_Coverage, 7732,
     /*  667369 */     GIR_EraseRootFromParent_Done,
     /*  667370 */   // Label 10627: @667370
     /*  667370 */   GIM_Try, /*On fail goto*//*Label 10628*/ GIMT_Encode4(667445), // Rule ID 7733 //
     /*  667375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  667378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  667383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  667386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  667389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  667392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  667421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  667424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667443 */     GIR_RootConstrainSelectedInstOperands,
     /*  667444 */     // GIR_Coverage, 7733,
     /*  667444 */     GIR_EraseRootFromParent_Done,
     /*  667445 */   // Label 10628: @667445
     /*  667445 */   GIM_Try, /*On fail goto*//*Label 10629*/ GIMT_Encode4(667520), // Rule ID 10248 //
     /*  667450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  667461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  667464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  667467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  667470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  667499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667518 */     GIR_RootConstrainSelectedInstOperands,
     /*  667519 */     // GIR_Coverage, 10248,
     /*  667519 */     GIR_EraseRootFromParent_Done,
     /*  667520 */   // Label 10629: @667520
     /*  667520 */   GIM_Try, /*On fail goto*//*Label 10630*/ GIMT_Encode4(667595), // Rule ID 10249 //
     /*  667525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  667536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  667539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  667542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  667545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667571 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  667574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667593 */     GIR_RootConstrainSelectedInstOperands,
     /*  667594 */     // GIR_Coverage, 10249,
     /*  667594 */     GIR_EraseRootFromParent_Done,
     /*  667595 */   // Label 10630: @667595
     /*  667595 */   GIM_Try, /*On fail goto*//*Label 10631*/ GIMT_Encode4(667670), // Rule ID 10252 //
     /*  667600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  667611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  667614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  667617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  667620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667646 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  667649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667668 */     GIR_RootConstrainSelectedInstOperands,
     /*  667669 */     // GIR_Coverage, 10252,
     /*  667669 */     GIR_EraseRootFromParent_Done,
     /*  667670 */   // Label 10631: @667670
     /*  667670 */   GIM_Try, /*On fail goto*//*Label 10632*/ GIMT_Encode4(667745), // Rule ID 10253 //
     /*  667675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  667686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  667689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  667692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  667695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667721 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  667724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667743 */     GIR_RootConstrainSelectedInstOperands,
     /*  667744 */     // GIR_Coverage, 10253,
     /*  667744 */     GIR_EraseRootFromParent_Done,
     /*  667745 */   // Label 10632: @667745
     /*  667745 */   GIM_Try, /*On fail goto*//*Label 10633*/ GIMT_Encode4(667820), // Rule ID 10256 //
     /*  667750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  667761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  667764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  667767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  667770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  667799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667818 */     GIR_RootConstrainSelectedInstOperands,
     /*  667819 */     // GIR_Coverage, 10256,
     /*  667819 */     GIR_EraseRootFromParent_Done,
     /*  667820 */   // Label 10633: @667820
     /*  667820 */   GIM_Try, /*On fail goto*//*Label 10634*/ GIMT_Encode4(667895), // Rule ID 10257 //
     /*  667825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  667836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  667839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  667842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  667845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667871 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  667874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667893 */     GIR_RootConstrainSelectedInstOperands,
     /*  667894 */     // GIR_Coverage, 10257,
     /*  667894 */     GIR_EraseRootFromParent_Done,
     /*  667895 */   // Label 10634: @667895
     /*  667895 */   GIM_Try, /*On fail goto*//*Label 10635*/ GIMT_Encode4(667970), // Rule ID 10260 //
     /*  667900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  667911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  667914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  667917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  667920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  667946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  667949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667968 */     GIR_RootConstrainSelectedInstOperands,
     /*  667969 */     // GIR_Coverage, 10260,
     /*  667969 */     GIR_EraseRootFromParent_Done,
     /*  667970 */   // Label 10635: @667970
     /*  667970 */   GIM_Try, /*On fail goto*//*Label 10636*/ GIMT_Encode4(668045), // Rule ID 10261 //
     /*  667975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  667986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  667989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  667992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  667995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668021 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  668024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668043 */     GIR_RootConstrainSelectedInstOperands,
     /*  668044 */     // GIR_Coverage, 10261,
     /*  668044 */     GIR_EraseRootFromParent_Done,
     /*  668045 */   // Label 10636: @668045
     /*  668045 */   GIM_Try, /*On fail goto*//*Label 10637*/ GIMT_Encode4(668120), // Rule ID 10264 //
     /*  668050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  668061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  668064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  668067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  668070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  668099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668118 */     GIR_RootConstrainSelectedInstOperands,
     /*  668119 */     // GIR_Coverage, 10264,
     /*  668119 */     GIR_EraseRootFromParent_Done,
     /*  668120 */   // Label 10637: @668120
     /*  668120 */   GIM_Try, /*On fail goto*//*Label 10638*/ GIMT_Encode4(668195), // Rule ID 10265 //
     /*  668125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  668136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  668139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  668142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  668145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  668174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668193 */     GIR_RootConstrainSelectedInstOperands,
     /*  668194 */     // GIR_Coverage, 10265,
     /*  668194 */     GIR_EraseRootFromParent_Done,
     /*  668195 */   // Label 10638: @668195
     /*  668195 */   GIM_Try, /*On fail goto*//*Label 10639*/ GIMT_Encode4(668270), // Rule ID 10268 //
     /*  668200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  668211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  668214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  668217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  668220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  668249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668268 */     GIR_RootConstrainSelectedInstOperands,
     /*  668269 */     // GIR_Coverage, 10268,
     /*  668269 */     GIR_EraseRootFromParent_Done,
     /*  668270 */   // Label 10639: @668270
     /*  668270 */   GIM_Try, /*On fail goto*//*Label 10640*/ GIMT_Encode4(668345), // Rule ID 10269 //
     /*  668275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  668286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  668289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  668292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  668295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668321 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  668321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  668324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668343 */     GIR_RootConstrainSelectedInstOperands,
     /*  668344 */     // GIR_Coverage, 10269,
     /*  668344 */     GIR_EraseRootFromParent_Done,
     /*  668345 */   // Label 10640: @668345
     /*  668345 */   GIM_Try, /*On fail goto*//*Label 10641*/ GIMT_Encode4(668420), // Rule ID 10272 //
     /*  668350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  668361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  668364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  668367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  668370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668418 */     GIR_RootConstrainSelectedInstOperands,
     /*  668419 */     // GIR_Coverage, 10272,
     /*  668419 */     GIR_EraseRootFromParent_Done,
     /*  668420 */   // Label 10641: @668420
     /*  668420 */   GIM_Try, /*On fail goto*//*Label 10642*/ GIMT_Encode4(668495), // Rule ID 10273 //
     /*  668425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  668436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  668439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  668442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  668445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668471 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668493 */     GIR_RootConstrainSelectedInstOperands,
     /*  668494 */     // GIR_Coverage, 10273,
     /*  668494 */     GIR_EraseRootFromParent_Done,
     /*  668495 */   // Label 10642: @668495
     /*  668495 */   GIM_Try, /*On fail goto*//*Label 10643*/ GIMT_Encode4(668570), // Rule ID 10276 //
     /*  668500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  668511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  668514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  668517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  668520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668568 */     GIR_RootConstrainSelectedInstOperands,
     /*  668569 */     // GIR_Coverage, 10276,
     /*  668569 */     GIR_EraseRootFromParent_Done,
     /*  668570 */   // Label 10643: @668570
     /*  668570 */   GIM_Try, /*On fail goto*//*Label 10644*/ GIMT_Encode4(668645), // Rule ID 10277 //
     /*  668575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  668586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  668589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  668592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  668595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668643 */     GIR_RootConstrainSelectedInstOperands,
     /*  668644 */     // GIR_Coverage, 10277,
     /*  668644 */     GIR_EraseRootFromParent_Done,
     /*  668645 */   // Label 10644: @668645
     /*  668645 */   GIM_Try, /*On fail goto*//*Label 10645*/ GIMT_Encode4(668720), // Rule ID 10280 //
     /*  668650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  668661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  668664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  668667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  668670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668718 */     GIR_RootConstrainSelectedInstOperands,
     /*  668719 */     // GIR_Coverage, 10280,
     /*  668719 */     GIR_EraseRootFromParent_Done,
     /*  668720 */   // Label 10645: @668720
     /*  668720 */   GIM_Try, /*On fail goto*//*Label 10646*/ GIMT_Encode4(668795), // Rule ID 10281 //
     /*  668725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  668736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  668739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  668742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  668745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668771 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  668771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668793 */     GIR_RootConstrainSelectedInstOperands,
     /*  668794 */     // GIR_Coverage, 10281,
     /*  668794 */     GIR_EraseRootFromParent_Done,
     /*  668795 */   // Label 10646: @668795
     /*  668795 */   GIM_Try, /*On fail goto*//*Label 10647*/ GIMT_Encode4(668870), // Rule ID 10284 //
     /*  668800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  668803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  668811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  668814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  668817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  668820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668846 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  668846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668868 */     GIR_RootConstrainSelectedInstOperands,
     /*  668869 */     // GIR_Coverage, 10284,
     /*  668869 */     GIR_EraseRootFromParent_Done,
     /*  668870 */   // Label 10647: @668870
     /*  668870 */   GIM_Try, /*On fail goto*//*Label 10648*/ GIMT_Encode4(668945), // Rule ID 10285 //
     /*  668875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  668878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  668886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  668889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  668892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  668895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668921 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  668921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668943 */     GIR_RootConstrainSelectedInstOperands,
     /*  668944 */     // GIR_Coverage, 10285,
     /*  668944 */     GIR_EraseRootFromParent_Done,
     /*  668945 */   // Label 10648: @668945
     /*  668945 */   GIM_Try, /*On fail goto*//*Label 10649*/ GIMT_Encode4(669020), // Rule ID 10288 //
     /*  668950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  668961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  668964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  668967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  668970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668996 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  668999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669018 */     GIR_RootConstrainSelectedInstOperands,
     /*  669019 */     // GIR_Coverage, 10288,
     /*  669019 */     GIR_EraseRootFromParent_Done,
     /*  669020 */   // Label 10649: @669020
     /*  669020 */   GIM_Try, /*On fail goto*//*Label 10650*/ GIMT_Encode4(669095), // Rule ID 10289 //
     /*  669025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  669036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  669039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  669042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  669045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669071 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  669074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669093 */     GIR_RootConstrainSelectedInstOperands,
     /*  669094 */     // GIR_Coverage, 10289,
     /*  669094 */     GIR_EraseRootFromParent_Done,
     /*  669095 */   // Label 10650: @669095
     /*  669095 */   GIM_Try, /*On fail goto*//*Label 10651*/ GIMT_Encode4(669170), // Rule ID 10292 //
     /*  669100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  669111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  669114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  669117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  669120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669146 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  669146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  669149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669168 */     GIR_RootConstrainSelectedInstOperands,
     /*  669169 */     // GIR_Coverage, 10292,
     /*  669169 */     GIR_EraseRootFromParent_Done,
     /*  669170 */   // Label 10651: @669170
     /*  669170 */   GIM_Try, /*On fail goto*//*Label 10652*/ GIMT_Encode4(669245), // Rule ID 10293 //
     /*  669175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  669186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  669189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  669192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  669195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669221 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  669224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669243 */     GIR_RootConstrainSelectedInstOperands,
     /*  669244 */     // GIR_Coverage, 10293,
     /*  669244 */     GIR_EraseRootFromParent_Done,
     /*  669245 */   // Label 10652: @669245
     /*  669245 */   GIM_Try, /*On fail goto*//*Label 10653*/ GIMT_Encode4(669320), // Rule ID 10296 //
     /*  669250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  669261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  669264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  669267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  669270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669296 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  669296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  669299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669318 */     GIR_RootConstrainSelectedInstOperands,
     /*  669319 */     // GIR_Coverage, 10296,
     /*  669319 */     GIR_EraseRootFromParent_Done,
     /*  669320 */   // Label 10653: @669320
     /*  669320 */   GIM_Try, /*On fail goto*//*Label 10654*/ GIMT_Encode4(669395), // Rule ID 10297 //
     /*  669325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  669336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  669339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  669342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  669345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669371 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  669374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669393 */     GIR_RootConstrainSelectedInstOperands,
     /*  669394 */     // GIR_Coverage, 10297,
     /*  669394 */     GIR_EraseRootFromParent_Done,
     /*  669395 */   // Label 10654: @669395
     /*  669395 */   GIM_Try, /*On fail goto*//*Label 10655*/ GIMT_Encode4(669470), // Rule ID 10300 //
     /*  669400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  669411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  669414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  669417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  669420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669446 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  669449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669468 */     GIR_RootConstrainSelectedInstOperands,
     /*  669469 */     // GIR_Coverage, 10300,
     /*  669469 */     GIR_EraseRootFromParent_Done,
     /*  669470 */   // Label 10655: @669470
     /*  669470 */   GIM_Try, /*On fail goto*//*Label 10656*/ GIMT_Encode4(669545), // Rule ID 10301 //
     /*  669475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  669486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  669489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  669492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  669495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  669524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669543 */     GIR_RootConstrainSelectedInstOperands,
     /*  669544 */     // GIR_Coverage, 10301,
     /*  669544 */     GIR_EraseRootFromParent_Done,
     /*  669545 */   // Label 10656: @669545
     /*  669545 */   GIM_Try, /*On fail goto*//*Label 10657*/ GIMT_Encode4(669620), // Rule ID 10304 //
     /*  669550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  669561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  669564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  669567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  669570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669596 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  669599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669618 */     GIR_RootConstrainSelectedInstOperands,
     /*  669619 */     // GIR_Coverage, 10304,
     /*  669619 */     GIR_EraseRootFromParent_Done,
     /*  669620 */   // Label 10657: @669620
     /*  669620 */   GIM_Try, /*On fail goto*//*Label 10658*/ GIMT_Encode4(669695), // Rule ID 10305 //
     /*  669625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  669636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  669639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  669642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  669645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669671 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  669674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669693 */     GIR_RootConstrainSelectedInstOperands,
     /*  669694 */     // GIR_Coverage, 10305,
     /*  669694 */     GIR_EraseRootFromParent_Done,
     /*  669695 */   // Label 10658: @669695
     /*  669695 */   GIM_Try, /*On fail goto*//*Label 10659*/ GIMT_Encode4(669770), // Rule ID 10308 //
     /*  669700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  669711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  669714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  669717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  669720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  669749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669768 */     GIR_RootConstrainSelectedInstOperands,
     /*  669769 */     // GIR_Coverage, 10308,
     /*  669769 */     GIR_EraseRootFromParent_Done,
     /*  669770 */   // Label 10659: @669770
     /*  669770 */   GIM_Try, /*On fail goto*//*Label 10660*/ GIMT_Encode4(669845), // Rule ID 10309 //
     /*  669775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  669786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  669789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  669792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  669795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669821 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  669824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669843 */     GIR_RootConstrainSelectedInstOperands,
     /*  669844 */     // GIR_Coverage, 10309,
     /*  669844 */     GIR_EraseRootFromParent_Done,
     /*  669845 */   // Label 10660: @669845
     /*  669845 */   GIM_Try, /*On fail goto*//*Label 10661*/ GIMT_Encode4(669920), // Rule ID 10312 //
     /*  669850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  669861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  669864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  669867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  669870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  669899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669918 */     GIR_RootConstrainSelectedInstOperands,
     /*  669919 */     // GIR_Coverage, 10312,
     /*  669919 */     GIR_EraseRootFromParent_Done,
     /*  669920 */   // Label 10661: @669920
     /*  669920 */   GIM_Try, /*On fail goto*//*Label 10662*/ GIMT_Encode4(669995), // Rule ID 10313 //
     /*  669925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  669936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  669939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  669942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  669945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  669971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  669974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669993 */     GIR_RootConstrainSelectedInstOperands,
     /*  669994 */     // GIR_Coverage, 10313,
     /*  669994 */     GIR_EraseRootFromParent_Done,
     /*  669995 */   // Label 10662: @669995
     /*  669995 */   GIM_Try, /*On fail goto*//*Label 10663*/ GIMT_Encode4(670070), // Rule ID 10316 //
     /*  670000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  670011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  670014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  670017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  670020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  670046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  670049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670068 */     GIR_RootConstrainSelectedInstOperands,
     /*  670069 */     // GIR_Coverage, 10316,
     /*  670069 */     GIR_EraseRootFromParent_Done,
     /*  670070 */   // Label 10663: @670070
     /*  670070 */   GIM_Try, /*On fail goto*//*Label 10664*/ GIMT_Encode4(670145), // Rule ID 10317 //
     /*  670075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  670086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  670089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  670092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  670095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  670121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  670124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670143 */     GIR_RootConstrainSelectedInstOperands,
     /*  670144 */     // GIR_Coverage, 10317,
     /*  670144 */     GIR_EraseRootFromParent_Done,
     /*  670145 */   // Label 10664: @670145
     /*  670145 */   GIM_Try, /*On fail goto*//*Label 10665*/ GIMT_Encode4(670220), // Rule ID 10320 //
     /*  670150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  670161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  670164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  670167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  670170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  670196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  670199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670218 */     GIR_RootConstrainSelectedInstOperands,
     /*  670219 */     // GIR_Coverage, 10320,
     /*  670219 */     GIR_EraseRootFromParent_Done,
     /*  670220 */   // Label 10665: @670220
     /*  670220 */   GIM_Try, /*On fail goto*//*Label 10666*/ GIMT_Encode4(670295), // Rule ID 10321 //
     /*  670225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  670236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  670239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  670242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  670245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670271 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  670271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  670274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670293 */     GIR_RootConstrainSelectedInstOperands,
     /*  670294 */     // GIR_Coverage, 10321,
     /*  670294 */     GIR_EraseRootFromParent_Done,
     /*  670295 */   // Label 10666: @670295
     /*  670295 */   GIM_Try, /*On fail goto*//*Label 10667*/ GIMT_Encode4(670370), // Rule ID 10324 //
     /*  670300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  670311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  670314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  670317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  670320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  670349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670368 */     GIR_RootConstrainSelectedInstOperands,
     /*  670369 */     // GIR_Coverage, 10324,
     /*  670369 */     GIR_EraseRootFromParent_Done,
     /*  670370 */   // Label 10667: @670370
     /*  670370 */   GIM_Try, /*On fail goto*//*Label 10668*/ GIMT_Encode4(670445), // Rule ID 10325 //
     /*  670375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  670386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  670389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  670392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  670395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  670424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670443 */     GIR_RootConstrainSelectedInstOperands,
     /*  670444 */     // GIR_Coverage, 10325,
     /*  670444 */     GIR_EraseRootFromParent_Done,
     /*  670445 */   // Label 10668: @670445
     /*  670445 */   GIM_Try, /*On fail goto*//*Label 10669*/ GIMT_Encode4(670520), // Rule ID 10328 //
     /*  670450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  670461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  670464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  670467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  670470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  670499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670518 */     GIR_RootConstrainSelectedInstOperands,
     /*  670519 */     // GIR_Coverage, 10328,
     /*  670519 */     GIR_EraseRootFromParent_Done,
     /*  670520 */   // Label 10669: @670520
     /*  670520 */   GIM_Try, /*On fail goto*//*Label 10670*/ GIMT_Encode4(670595), // Rule ID 10329 //
     /*  670525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  670536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  670539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  670542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  670545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670571 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  670574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670593 */     GIR_RootConstrainSelectedInstOperands,
     /*  670594 */     // GIR_Coverage, 10329,
     /*  670594 */     GIR_EraseRootFromParent_Done,
     /*  670595 */   // Label 10670: @670595
     /*  670595 */   GIM_Try, /*On fail goto*//*Label 10671*/ GIMT_Encode4(670670), // Rule ID 10332 //
     /*  670600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  670611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  670614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  670617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  670620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  670649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670668 */     GIR_RootConstrainSelectedInstOperands,
     /*  670669 */     // GIR_Coverage, 10332,
     /*  670669 */     GIR_EraseRootFromParent_Done,
     /*  670670 */   // Label 10671: @670670
     /*  670670 */   GIM_Try, /*On fail goto*//*Label 10672*/ GIMT_Encode4(670745), // Rule ID 10333 //
     /*  670675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  670686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  670689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  670692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  670695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670721 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  670724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670743 */     GIR_RootConstrainSelectedInstOperands,
     /*  670744 */     // GIR_Coverage, 10333,
     /*  670744 */     GIR_EraseRootFromParent_Done,
     /*  670745 */   // Label 10672: @670745
     /*  670745 */   GIM_Try, /*On fail goto*//*Label 10673*/ GIMT_Encode4(670820), // Rule ID 10336 //
     /*  670750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  670761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  670764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  670767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670796 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  670799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670818 */     GIR_RootConstrainSelectedInstOperands,
     /*  670819 */     // GIR_Coverage, 10336,
     /*  670819 */     GIR_EraseRootFromParent_Done,
     /*  670820 */   // Label 10673: @670820
     /*  670820 */   GIM_Try, /*On fail goto*//*Label 10674*/ GIMT_Encode4(670895), // Rule ID 10337 //
     /*  670825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  670836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  670839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  670842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670871 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  670874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670893 */     GIR_RootConstrainSelectedInstOperands,
     /*  670894 */     // GIR_Coverage, 10337,
     /*  670894 */     GIR_EraseRootFromParent_Done,
     /*  670895 */   // Label 10674: @670895
     /*  670895 */   GIM_Try, /*On fail goto*//*Label 10675*/ GIMT_Encode4(670970), // Rule ID 10340 //
     /*  670900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  670911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  670914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  670917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670946 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  670949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670968 */     GIR_RootConstrainSelectedInstOperands,
     /*  670969 */     // GIR_Coverage, 10340,
     /*  670969 */     GIR_EraseRootFromParent_Done,
     /*  670970 */   // Label 10675: @670970
     /*  670970 */   GIM_Try, /*On fail goto*//*Label 10676*/ GIMT_Encode4(671045), // Rule ID 10341 //
     /*  670975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  670986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  670989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  670992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671021 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  671024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671043 */     GIR_RootConstrainSelectedInstOperands,
     /*  671044 */     // GIR_Coverage, 10341,
     /*  671044 */     GIR_EraseRootFromParent_Done,
     /*  671045 */   // Label 10676: @671045
     /*  671045 */   GIM_Try, /*On fail goto*//*Label 10677*/ GIMT_Encode4(671120), // Rule ID 10344 //
     /*  671050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  671061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  671064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  671067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  671099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671118 */     GIR_RootConstrainSelectedInstOperands,
     /*  671119 */     // GIR_Coverage, 10344,
     /*  671119 */     GIR_EraseRootFromParent_Done,
     /*  671120 */   // Label 10677: @671120
     /*  671120 */   GIM_Try, /*On fail goto*//*Label 10678*/ GIMT_Encode4(671195), // Rule ID 10345 //
     /*  671125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  671136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  671139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  671142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  671145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671171 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  671174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671193 */     GIR_RootConstrainSelectedInstOperands,
     /*  671194 */     // GIR_Coverage, 10345,
     /*  671194 */     GIR_EraseRootFromParent_Done,
     /*  671195 */   // Label 10678: @671195
     /*  671195 */   GIM_Try, /*On fail goto*//*Label 10679*/ GIMT_Encode4(671270), // Rule ID 10348 //
     /*  671200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  671211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  671214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  671217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671246 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  671249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671268 */     GIR_RootConstrainSelectedInstOperands,
     /*  671269 */     // GIR_Coverage, 10348,
     /*  671269 */     GIR_EraseRootFromParent_Done,
     /*  671270 */   // Label 10679: @671270
     /*  671270 */   GIM_Try, /*On fail goto*//*Label 10680*/ GIMT_Encode4(671345), // Rule ID 10349 //
     /*  671275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  671286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  671289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  671292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  671295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671321 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  671324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671343 */     GIR_RootConstrainSelectedInstOperands,
     /*  671344 */     // GIR_Coverage, 10349,
     /*  671344 */     GIR_EraseRootFromParent_Done,
     /*  671345 */   // Label 10680: @671345
     /*  671345 */   GIM_Try, /*On fail goto*//*Label 10681*/ GIMT_Encode4(671420), // Rule ID 10352 //
     /*  671350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  671361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  671364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  671367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671396 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  671399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671418 */     GIR_RootConstrainSelectedInstOperands,
     /*  671419 */     // GIR_Coverage, 10352,
     /*  671419 */     GIR_EraseRootFromParent_Done,
     /*  671420 */   // Label 10681: @671420
     /*  671420 */   GIM_Try, /*On fail goto*//*Label 10682*/ GIMT_Encode4(671495), // Rule ID 10353 //
     /*  671425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  671436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  671439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  671442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  671445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671471 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  671474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671493 */     GIR_RootConstrainSelectedInstOperands,
     /*  671494 */     // GIR_Coverage, 10353,
     /*  671494 */     GIR_EraseRootFromParent_Done,
     /*  671495 */   // Label 10682: @671495
     /*  671495 */   GIM_Try, /*On fail goto*//*Label 10683*/ GIMT_Encode4(671570), // Rule ID 10356 //
     /*  671500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  671511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  671514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  671517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  671549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671568 */     GIR_RootConstrainSelectedInstOperands,
     /*  671569 */     // GIR_Coverage, 10356,
     /*  671569 */     GIR_EraseRootFromParent_Done,
     /*  671570 */   // Label 10683: @671570
     /*  671570 */   GIM_Try, /*On fail goto*//*Label 10684*/ GIMT_Encode4(671645), // Rule ID 10357 //
     /*  671575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  671586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  671589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  671592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  671595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671621 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  671621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  671624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671643 */     GIR_RootConstrainSelectedInstOperands,
     /*  671644 */     // GIR_Coverage, 10357,
     /*  671644 */     GIR_EraseRootFromParent_Done,
     /*  671645 */   // Label 10684: @671645
     /*  671645 */   GIM_Try, /*On fail goto*//*Label 10685*/ GIMT_Encode4(671720), // Rule ID 10360 //
     /*  671650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  671661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  671664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  671667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  671699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671718 */     GIR_RootConstrainSelectedInstOperands,
     /*  671719 */     // GIR_Coverage, 10360,
     /*  671719 */     GIR_EraseRootFromParent_Done,
     /*  671720 */   // Label 10685: @671720
     /*  671720 */   GIM_Try, /*On fail goto*//*Label 10686*/ GIMT_Encode4(671795), // Rule ID 10361 //
     /*  671725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  671736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  671739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  671742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  671745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671771 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  671774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671793 */     GIR_RootConstrainSelectedInstOperands,
     /*  671794 */     // GIR_Coverage, 10361,
     /*  671794 */     GIR_EraseRootFromParent_Done,
     /*  671795 */   // Label 10686: @671795
     /*  671795 */   GIM_Try, /*On fail goto*//*Label 10687*/ GIMT_Encode4(671870), // Rule ID 10364 //
     /*  671800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  671811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  671814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  671817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671846 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  671849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671868 */     GIR_RootConstrainSelectedInstOperands,
     /*  671869 */     // GIR_Coverage, 10364,
     /*  671869 */     GIR_EraseRootFromParent_Done,
     /*  671870 */   // Label 10687: @671870
     /*  671870 */   GIM_Try, /*On fail goto*//*Label 10688*/ GIMT_Encode4(671945), // Rule ID 10365 //
     /*  671875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  671886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  671889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  671892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  671895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671921 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  671924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671943 */     GIR_RootConstrainSelectedInstOperands,
     /*  671944 */     // GIR_Coverage, 10365,
     /*  671944 */     GIR_EraseRootFromParent_Done,
     /*  671945 */   // Label 10688: @671945
     /*  671945 */   GIM_Try, /*On fail goto*//*Label 10689*/ GIMT_Encode4(672020), // Rule ID 10368 //
     /*  671950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  671961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  671964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  671967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  671999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672018 */     GIR_RootConstrainSelectedInstOperands,
     /*  672019 */     // GIR_Coverage, 10368,
     /*  672019 */     GIR_EraseRootFromParent_Done,
     /*  672020 */   // Label 10689: @672020
     /*  672020 */   GIM_Try, /*On fail goto*//*Label 10690*/ GIMT_Encode4(672095), // Rule ID 10369 //
     /*  672025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  672036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  672039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  672042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  672071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  672074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672093 */     GIR_RootConstrainSelectedInstOperands,
     /*  672094 */     // GIR_Coverage, 10369,
     /*  672094 */     GIR_EraseRootFromParent_Done,
     /*  672095 */   // Label 10690: @672095
     /*  672095 */   GIM_Try, /*On fail goto*//*Label 10691*/ GIMT_Encode4(672170), // Rule ID 10372 //
     /*  672100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  672103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  672111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  672114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  672117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672146 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  672146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  672149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672168 */     GIR_RootConstrainSelectedInstOperands,
     /*  672169 */     // GIR_Coverage, 10372,
     /*  672169 */     GIR_EraseRootFromParent_Done,
     /*  672170 */   // Label 10691: @672170
     /*  672170 */   GIM_Try, /*On fail goto*//*Label 10692*/ GIMT_Encode4(672245), // Rule ID 10373 //
     /*  672175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  672178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  672186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  672189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  672192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672221 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  672221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  672224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672243 */     GIR_RootConstrainSelectedInstOperands,
     /*  672244 */     // GIR_Coverage, 10373,
     /*  672244 */     GIR_EraseRootFromParent_Done,
     /*  672245 */   // Label 10692: @672245
     /*  672245 */   GIM_Try, /*On fail goto*//*Label 10693*/ GIMT_Encode4(672320), // Rule ID 10376 //
     /*  672250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  672261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  672264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  672267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672296 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  672299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672318 */     GIR_RootConstrainSelectedInstOperands,
     /*  672319 */     // GIR_Coverage, 10376,
     /*  672319 */     GIR_EraseRootFromParent_Done,
     /*  672320 */   // Label 10693: @672320
     /*  672320 */   GIM_Try, /*On fail goto*//*Label 10694*/ GIMT_Encode4(672395), // Rule ID 10377 //
     /*  672325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  672336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  672339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  672342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  672374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672393 */     GIR_RootConstrainSelectedInstOperands,
     /*  672394 */     // GIR_Coverage, 10377,
     /*  672394 */     GIR_EraseRootFromParent_Done,
     /*  672395 */   // Label 10694: @672395
     /*  672395 */   GIM_Try, /*On fail goto*//*Label 10695*/ GIMT_Encode4(672470), // Rule ID 10380 //
     /*  672400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  672411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  672414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  672417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672446 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  672449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672468 */     GIR_RootConstrainSelectedInstOperands,
     /*  672469 */     // GIR_Coverage, 10380,
     /*  672469 */     GIR_EraseRootFromParent_Done,
     /*  672470 */   // Label 10695: @672470
     /*  672470 */   GIM_Try, /*On fail goto*//*Label 10696*/ GIMT_Encode4(672545), // Rule ID 10381 //
     /*  672475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  672486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  672489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  672492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672521 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  672524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672543 */     GIR_RootConstrainSelectedInstOperands,
     /*  672544 */     // GIR_Coverage, 10381,
     /*  672544 */     GIR_EraseRootFromParent_Done,
     /*  672545 */   // Label 10696: @672545
     /*  672545 */   GIM_Try, /*On fail goto*//*Label 10697*/ GIMT_Encode4(672620), // Rule ID 10384 //
     /*  672550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  672561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  672564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  672567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672596 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  672599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672618 */     GIR_RootConstrainSelectedInstOperands,
     /*  672619 */     // GIR_Coverage, 10384,
     /*  672619 */     GIR_EraseRootFromParent_Done,
     /*  672620 */   // Label 10697: @672620
     /*  672620 */   GIM_Try, /*On fail goto*//*Label 10698*/ GIMT_Encode4(672695), // Rule ID 10385 //
     /*  672625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  672636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  672639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  672642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672671 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  672674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672693 */     GIR_RootConstrainSelectedInstOperands,
     /*  672694 */     // GIR_Coverage, 10385,
     /*  672694 */     GIR_EraseRootFromParent_Done,
     /*  672695 */   // Label 10698: @672695
     /*  672695 */   GIM_Try, /*On fail goto*//*Label 10699*/ GIMT_Encode4(672770), // Rule ID 10388 //
     /*  672700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  672711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  672714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  672717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  672749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672768 */     GIR_RootConstrainSelectedInstOperands,
     /*  672769 */     // GIR_Coverage, 10388,
     /*  672769 */     GIR_EraseRootFromParent_Done,
     /*  672770 */   // Label 10699: @672770
     /*  672770 */   GIM_Try, /*On fail goto*//*Label 10700*/ GIMT_Encode4(672845), // Rule ID 10389 //
     /*  672775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  672786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  672789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  672792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672821 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  672824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672843 */     GIR_RootConstrainSelectedInstOperands,
     /*  672844 */     // GIR_Coverage, 10389,
     /*  672844 */     GIR_EraseRootFromParent_Done,
     /*  672845 */   // Label 10700: @672845
     /*  672845 */   GIM_Try, /*On fail goto*//*Label 10701*/ GIMT_Encode4(672920), // Rule ID 10392 //
     /*  672850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  672861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  672864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  672867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672896 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  672899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672918 */     GIR_RootConstrainSelectedInstOperands,
     /*  672919 */     // GIR_Coverage, 10392,
     /*  672919 */     GIR_EraseRootFromParent_Done,
     /*  672920 */   // Label 10701: @672920
     /*  672920 */   GIM_Try, /*On fail goto*//*Label 10702*/ GIMT_Encode4(672995), // Rule ID 10393 //
     /*  672925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  672936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  672939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  672942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672971 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  672974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672993 */     GIR_RootConstrainSelectedInstOperands,
     /*  672994 */     // GIR_Coverage, 10393,
     /*  672994 */     GIR_EraseRootFromParent_Done,
     /*  672995 */   // Label 10702: @672995
     /*  672995 */   GIM_Try, /*On fail goto*//*Label 10703*/ GIMT_Encode4(673070), // Rule ID 10396 //
     /*  673000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  673011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  673014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  673017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  673046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  673049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  673065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673068 */     GIR_RootConstrainSelectedInstOperands,
     /*  673069 */     // GIR_Coverage, 10396,
     /*  673069 */     GIR_EraseRootFromParent_Done,
     /*  673070 */   // Label 10703: @673070
     /*  673070 */   GIM_Try, /*On fail goto*//*Label 10704*/ GIMT_Encode4(673145), // Rule ID 10397 //
     /*  673075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  673086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  673089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  673092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673121 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  673121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  673124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  673140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673143 */     GIR_RootConstrainSelectedInstOperands,
     /*  673144 */     // GIR_Coverage, 10397,
     /*  673144 */     GIR_EraseRootFromParent_Done,
     /*  673145 */   // Label 10704: @673145
     /*  673145 */   GIM_Try, /*On fail goto*//*Label 10705*/ GIMT_Encode4(673220), // Rule ID 10400 //
     /*  673150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  673161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  673164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  673167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  673199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673218 */     GIR_RootConstrainSelectedInstOperands,
     /*  673219 */     // GIR_Coverage, 10400,
     /*  673219 */     GIR_EraseRootFromParent_Done,
     /*  673220 */   // Label 10705: @673220
     /*  673220 */   GIM_Try, /*On fail goto*//*Label 10706*/ GIMT_Encode4(673295), // Rule ID 10401 //
     /*  673225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  673236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  673239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  673242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  673274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673293 */     GIR_RootConstrainSelectedInstOperands,
     /*  673294 */     // GIR_Coverage, 10401,
     /*  673294 */     GIR_EraseRootFromParent_Done,
     /*  673295 */   // Label 10706: @673295
     /*  673295 */   GIM_Try, /*On fail goto*//*Label 10707*/ GIMT_Encode4(673370), // Rule ID 10404 //
     /*  673300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  673311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  673314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  673317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  673349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673368 */     GIR_RootConstrainSelectedInstOperands,
     /*  673369 */     // GIR_Coverage, 10404,
     /*  673369 */     GIR_EraseRootFromParent_Done,
     /*  673370 */   // Label 10707: @673370
     /*  673370 */   GIM_Try, /*On fail goto*//*Label 10708*/ GIMT_Encode4(673445), // Rule ID 10405 //
     /*  673375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  673386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  673389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  673392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  673424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673443 */     GIR_RootConstrainSelectedInstOperands,
     /*  673444 */     // GIR_Coverage, 10405,
     /*  673444 */     GIR_EraseRootFromParent_Done,
     /*  673445 */   // Label 10708: @673445
     /*  673445 */   GIM_Try, /*On fail goto*//*Label 10709*/ GIMT_Encode4(673520), // Rule ID 10408 //
     /*  673450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  673461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  673464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  673467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673496 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  673499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673518 */     GIR_RootConstrainSelectedInstOperands,
     /*  673519 */     // GIR_Coverage, 10408,
     /*  673519 */     GIR_EraseRootFromParent_Done,
     /*  673520 */   // Label 10709: @673520
     /*  673520 */   GIM_Try, /*On fail goto*//*Label 10710*/ GIMT_Encode4(673595), // Rule ID 10409 //
     /*  673525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  673536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  673539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  673542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673571 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  673574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673593 */     GIR_RootConstrainSelectedInstOperands,
     /*  673594 */     // GIR_Coverage, 10409,
     /*  673594 */     GIR_EraseRootFromParent_Done,
     /*  673595 */   // Label 10710: @673595
     /*  673595 */   GIM_Try, /*On fail goto*//*Label 10711*/ GIMT_Encode4(673670), // Rule ID 10412 //
     /*  673600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  673611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  673614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  673617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  673649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673668 */     GIR_RootConstrainSelectedInstOperands,
     /*  673669 */     // GIR_Coverage, 10412,
     /*  673669 */     GIR_EraseRootFromParent_Done,
     /*  673670 */   // Label 10711: @673670
     /*  673670 */   GIM_Try, /*On fail goto*//*Label 10712*/ GIMT_Encode4(673745), // Rule ID 10413 //
     /*  673675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  673686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  673689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  673692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673721 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  673724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673743 */     GIR_RootConstrainSelectedInstOperands,
     /*  673744 */     // GIR_Coverage, 10413,
     /*  673744 */     GIR_EraseRootFromParent_Done,
     /*  673745 */   // Label 10712: @673745
     /*  673745 */   GIM_Try, /*On fail goto*//*Label 10713*/ GIMT_Encode4(673820), // Rule ID 10416 //
     /*  673750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  673761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  673764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  673767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673796 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  673799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673818 */     GIR_RootConstrainSelectedInstOperands,
     /*  673819 */     // GIR_Coverage, 10416,
     /*  673819 */     GIR_EraseRootFromParent_Done,
     /*  673820 */   // Label 10713: @673820
     /*  673820 */   GIM_Try, /*On fail goto*//*Label 10714*/ GIMT_Encode4(673895), // Rule ID 10417 //
     /*  673825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  673836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  673839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  673842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673871 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  673874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673893 */     GIR_RootConstrainSelectedInstOperands,
     /*  673894 */     // GIR_Coverage, 10417,
     /*  673894 */     GIR_EraseRootFromParent_Done,
     /*  673895 */   // Label 10714: @673895
     /*  673895 */   GIM_Try, /*On fail goto*//*Label 10715*/ GIMT_Encode4(673970), // Rule ID 10420 //
     /*  673900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  673911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  673914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  673917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  673949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673968 */     GIR_RootConstrainSelectedInstOperands,
     /*  673969 */     // GIR_Coverage, 10420,
     /*  673969 */     GIR_EraseRootFromParent_Done,
     /*  673970 */   // Label 10715: @673970
     /*  673970 */   GIM_Try, /*On fail goto*//*Label 10716*/ GIMT_Encode4(674045), // Rule ID 10421 //
     /*  673975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  673986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  673989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  673992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674021 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  674021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  674024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  674040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674043 */     GIR_RootConstrainSelectedInstOperands,
     /*  674044 */     // GIR_Coverage, 10421,
     /*  674044 */     GIR_EraseRootFromParent_Done,
     /*  674045 */   // Label 10716: @674045
     /*  674045 */   GIM_Try, /*On fail goto*//*Label 10717*/ GIMT_Encode4(674120), // Rule ID 10424 //
     /*  674050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  674061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  674064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  674067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  674070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674096 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  674099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674118 */     GIR_RootConstrainSelectedInstOperands,
     /*  674119 */     // GIR_Coverage, 10424,
     /*  674119 */     GIR_EraseRootFromParent_Done,
     /*  674120 */   // Label 10717: @674120
     /*  674120 */   GIM_Try, /*On fail goto*//*Label 10718*/ GIMT_Encode4(674195), // Rule ID 10425 //
     /*  674125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  674136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  674139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  674142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  674145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674171 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  674174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674193 */     GIR_RootConstrainSelectedInstOperands,
     /*  674194 */     // GIR_Coverage, 10425,
     /*  674194 */     GIR_EraseRootFromParent_Done,
     /*  674195 */   // Label 10718: @674195
     /*  674195 */   GIM_Try, /*On fail goto*//*Label 10719*/ GIMT_Encode4(674270), // Rule ID 10428 //
     /*  674200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  674211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  674214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  674217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  674220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674246 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  674249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674268 */     GIR_RootConstrainSelectedInstOperands,
     /*  674269 */     // GIR_Coverage, 10428,
     /*  674269 */     GIR_EraseRootFromParent_Done,
     /*  674270 */   // Label 10719: @674270
     /*  674270 */   GIM_Try, /*On fail goto*//*Label 10720*/ GIMT_Encode4(674345), // Rule ID 10429 //
     /*  674275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  674286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  674289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  674292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  674295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674321 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  674324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674343 */     GIR_RootConstrainSelectedInstOperands,
     /*  674344 */     // GIR_Coverage, 10429,
     /*  674344 */     GIR_EraseRootFromParent_Done,
     /*  674345 */   // Label 10720: @674345
     /*  674345 */   GIM_Try, /*On fail goto*//*Label 10721*/ GIMT_Encode4(674420), // Rule ID 10432 //
     /*  674350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  674361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  674364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  674367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  674370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  674399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674418 */     GIR_RootConstrainSelectedInstOperands,
     /*  674419 */     // GIR_Coverage, 10432,
     /*  674419 */     GIR_EraseRootFromParent_Done,
     /*  674420 */   // Label 10721: @674420
     /*  674420 */   GIM_Try, /*On fail goto*//*Label 10722*/ GIMT_Encode4(674495), // Rule ID 10433 //
     /*  674425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  674436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  674439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  674442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  674445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674471 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  674474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674493 */     GIR_RootConstrainSelectedInstOperands,
     /*  674494 */     // GIR_Coverage, 10433,
     /*  674494 */     GIR_EraseRootFromParent_Done,
     /*  674495 */   // Label 10722: @674495
     /*  674495 */   GIM_Try, /*On fail goto*//*Label 10723*/ GIMT_Encode4(674570), // Rule ID 10436 //
     /*  674500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  674511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  674514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  674517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  674520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  674549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674568 */     GIR_RootConstrainSelectedInstOperands,
     /*  674569 */     // GIR_Coverage, 10436,
     /*  674569 */     GIR_EraseRootFromParent_Done,
     /*  674570 */   // Label 10723: @674570
     /*  674570 */   GIM_Try, /*On fail goto*//*Label 10724*/ GIMT_Encode4(674645), // Rule ID 10437 //
     /*  674575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  674586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  674589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  674592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  674595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674621 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  674624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674643 */     GIR_RootConstrainSelectedInstOperands,
     /*  674644 */     // GIR_Coverage, 10437,
     /*  674644 */     GIR_EraseRootFromParent_Done,
     /*  674645 */   // Label 10724: @674645
     /*  674645 */   GIM_Try, /*On fail goto*//*Label 10725*/ GIMT_Encode4(674720), // Rule ID 10440 //
     /*  674650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  674661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  674664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  674667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  674670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  674699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674718 */     GIR_RootConstrainSelectedInstOperands,
     /*  674719 */     // GIR_Coverage, 10440,
     /*  674719 */     GIR_EraseRootFromParent_Done,
     /*  674720 */   // Label 10725: @674720
     /*  674720 */   GIM_Try, /*On fail goto*//*Label 10726*/ GIMT_Encode4(674795), // Rule ID 10441 //
     /*  674725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  674736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  674739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  674742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  674745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674771 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  674774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674793 */     GIR_RootConstrainSelectedInstOperands,
     /*  674794 */     // GIR_Coverage, 10441,
     /*  674794 */     GIR_EraseRootFromParent_Done,
     /*  674795 */   // Label 10726: @674795
     /*  674795 */   GIM_Try, /*On fail goto*//*Label 10727*/ GIMT_Encode4(674870), // Rule ID 10444 //
     /*  674800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  674811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  674814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  674817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  674820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  674846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  674849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674868 */     GIR_RootConstrainSelectedInstOperands,
     /*  674869 */     // GIR_Coverage, 10444,
     /*  674869 */     GIR_EraseRootFromParent_Done,
     /*  674870 */   // Label 10727: @674870
     /*  674870 */   GIM_Try, /*On fail goto*//*Label 10728*/ GIMT_Encode4(674945), // Rule ID 10445 //
     /*  674875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  674886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  674889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  674892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  674895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674921 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  674921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  674924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674943 */     GIR_RootConstrainSelectedInstOperands,
     /*  674944 */     // GIR_Coverage, 10445,
     /*  674944 */     GIR_EraseRootFromParent_Done,
     /*  674945 */   // Label 10728: @674945
     /*  674945 */   GIM_Try, /*On fail goto*//*Label 10729*/ GIMT_Encode4(675020), // Rule ID 10448 //
     /*  674950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  674961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  674964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  674967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  674970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  674999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675018 */     GIR_RootConstrainSelectedInstOperands,
     /*  675019 */     // GIR_Coverage, 10448,
     /*  675019 */     GIR_EraseRootFromParent_Done,
     /*  675020 */   // Label 10729: @675020
     /*  675020 */   GIM_Try, /*On fail goto*//*Label 10730*/ GIMT_Encode4(675095), // Rule ID 10449 //
     /*  675025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  675036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  675039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  675042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  675045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675071 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675093 */     GIR_RootConstrainSelectedInstOperands,
     /*  675094 */     // GIR_Coverage, 10449,
     /*  675094 */     GIR_EraseRootFromParent_Done,
     /*  675095 */   // Label 10730: @675095
     /*  675095 */   GIM_Try, /*On fail goto*//*Label 10731*/ GIMT_Encode4(675170), // Rule ID 10452 //
     /*  675100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  675111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  675114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  675117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  675120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675168 */     GIR_RootConstrainSelectedInstOperands,
     /*  675169 */     // GIR_Coverage, 10452,
     /*  675169 */     GIR_EraseRootFromParent_Done,
     /*  675170 */   // Label 10731: @675170
     /*  675170 */   GIM_Try, /*On fail goto*//*Label 10732*/ GIMT_Encode4(675245), // Rule ID 10453 //
     /*  675175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  675186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  675189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  675192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  675195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675221 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  675221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675243 */     GIR_RootConstrainSelectedInstOperands,
     /*  675244 */     // GIR_Coverage, 10453,
     /*  675244 */     GIR_EraseRootFromParent_Done,
     /*  675245 */   // Label 10732: @675245
     /*  675245 */   GIM_Try, /*On fail goto*//*Label 10733*/ GIMT_Encode4(675320), // Rule ID 10456 //
     /*  675250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  675261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  675264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  675267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  675270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  675296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675318 */     GIR_RootConstrainSelectedInstOperands,
     /*  675319 */     // GIR_Coverage, 10456,
     /*  675319 */     GIR_EraseRootFromParent_Done,
     /*  675320 */   // Label 10733: @675320
     /*  675320 */   GIM_Try, /*On fail goto*//*Label 10734*/ GIMT_Encode4(675395), // Rule ID 10457 //
     /*  675325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  675336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  675339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  675342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  675345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675371 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  675371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675393 */     GIR_RootConstrainSelectedInstOperands,
     /*  675394 */     // GIR_Coverage, 10457,
     /*  675394 */     GIR_EraseRootFromParent_Done,
     /*  675395 */   // Label 10734: @675395
     /*  675395 */   GIM_Try, /*On fail goto*//*Label 10735*/ GIMT_Encode4(675470), // Rule ID 10460 //
     /*  675400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  675403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  675411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  675414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  675417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  675420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  675446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675468 */     GIR_RootConstrainSelectedInstOperands,
     /*  675469 */     // GIR_Coverage, 10460,
     /*  675469 */     GIR_EraseRootFromParent_Done,
     /*  675470 */   // Label 10735: @675470
     /*  675470 */   GIM_Try, /*On fail goto*//*Label 10736*/ GIMT_Encode4(675545), // Rule ID 10461 //
     /*  675475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  675478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  675486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  675489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  675492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  675495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675521 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  675521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675543 */     GIR_RootConstrainSelectedInstOperands,
     /*  675544 */     // GIR_Coverage, 10461,
     /*  675544 */     GIR_EraseRootFromParent_Done,
     /*  675545 */   // Label 10736: @675545
     /*  675545 */   GIM_Try, /*On fail goto*//*Label 10737*/ GIMT_Encode4(675620), // Rule ID 10464 //
     /*  675550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  675561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  675564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  675567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  675570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  675599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675618 */     GIR_RootConstrainSelectedInstOperands,
     /*  675619 */     // GIR_Coverage, 10464,
     /*  675619 */     GIR_EraseRootFromParent_Done,
     /*  675620 */   // Label 10737: @675620
     /*  675620 */   GIM_Try, /*On fail goto*//*Label 10738*/ GIMT_Encode4(675695), // Rule ID 10465 //
     /*  675625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  675636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  675639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  675642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  675645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675671 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  675674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675693 */     GIR_RootConstrainSelectedInstOperands,
     /*  675694 */     // GIR_Coverage, 10465,
     /*  675694 */     GIR_EraseRootFromParent_Done,
     /*  675695 */   // Label 10738: @675695
     /*  675695 */   GIM_Try, /*On fail goto*//*Label 10739*/ GIMT_Encode4(675770), // Rule ID 10468 //
     /*  675700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  675711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  675714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  675717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  675720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675746 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  675749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675768 */     GIR_RootConstrainSelectedInstOperands,
     /*  675769 */     // GIR_Coverage, 10468,
     /*  675769 */     GIR_EraseRootFromParent_Done,
     /*  675770 */   // Label 10739: @675770
     /*  675770 */   GIM_Try, /*On fail goto*//*Label 10740*/ GIMT_Encode4(675845), // Rule ID 10469 //
     /*  675775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  675786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  675789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  675792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  675795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675821 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  675824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675843 */     GIR_RootConstrainSelectedInstOperands,
     /*  675844 */     // GIR_Coverage, 10469,
     /*  675844 */     GIR_EraseRootFromParent_Done,
     /*  675845 */   // Label 10740: @675845
     /*  675845 */   GIM_Try, /*On fail goto*//*Label 10741*/ GIMT_Encode4(675920), // Rule ID 10472 //
     /*  675850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  675861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  675864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  675867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  675870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675896 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  675899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675918 */     GIR_RootConstrainSelectedInstOperands,
     /*  675919 */     // GIR_Coverage, 10472,
     /*  675919 */     GIR_EraseRootFromParent_Done,
     /*  675920 */   // Label 10741: @675920
     /*  675920 */   GIM_Try, /*On fail goto*//*Label 10742*/ GIMT_Encode4(675995), // Rule ID 10473 //
     /*  675925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  675936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  675939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  675942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  675945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675971 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  675974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675993 */     GIR_RootConstrainSelectedInstOperands,
     /*  675994 */     // GIR_Coverage, 10473,
     /*  675994 */     GIR_EraseRootFromParent_Done,
     /*  675995 */   // Label 10742: @675995
     /*  675995 */   GIM_Try, /*On fail goto*//*Label 10743*/ GIMT_Encode4(676070), // Rule ID 10476 //
     /*  676000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  676011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  676014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  676017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  676020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676046 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  676049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676068 */     GIR_RootConstrainSelectedInstOperands,
     /*  676069 */     // GIR_Coverage, 10476,
     /*  676069 */     GIR_EraseRootFromParent_Done,
     /*  676070 */   // Label 10743: @676070
     /*  676070 */   GIM_Try, /*On fail goto*//*Label 10744*/ GIMT_Encode4(676145), // Rule ID 10477 //
     /*  676075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  676086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  676089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  676092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  676095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676121 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  676124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676143 */     GIR_RootConstrainSelectedInstOperands,
     /*  676144 */     // GIR_Coverage, 10477,
     /*  676144 */     GIR_EraseRootFromParent_Done,
     /*  676145 */   // Label 10744: @676145
     /*  676145 */   GIM_Try, /*On fail goto*//*Label 10745*/ GIMT_Encode4(676220), // Rule ID 10480 //
     /*  676150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  676161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  676164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  676167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  676170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676196 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  676199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676218 */     GIR_RootConstrainSelectedInstOperands,
     /*  676219 */     // GIR_Coverage, 10480,
     /*  676219 */     GIR_EraseRootFromParent_Done,
     /*  676220 */   // Label 10745: @676220
     /*  676220 */   GIM_Try, /*On fail goto*//*Label 10746*/ GIMT_Encode4(676295), // Rule ID 10481 //
     /*  676225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  676236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  676239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  676242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  676245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676271 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  676274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676293 */     GIR_RootConstrainSelectedInstOperands,
     /*  676294 */     // GIR_Coverage, 10481,
     /*  676294 */     GIR_EraseRootFromParent_Done,
     /*  676295 */   // Label 10746: @676295
     /*  676295 */   GIM_Try, /*On fail goto*//*Label 10747*/ GIMT_Encode4(676370), // Rule ID 10484 //
     /*  676300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  676311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  676314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  676317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  676320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676346 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  676349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676368 */     GIR_RootConstrainSelectedInstOperands,
     /*  676369 */     // GIR_Coverage, 10484,
     /*  676369 */     GIR_EraseRootFromParent_Done,
     /*  676370 */   // Label 10747: @676370
     /*  676370 */   GIM_Try, /*On fail goto*//*Label 10748*/ GIMT_Encode4(676445), // Rule ID 10485 //
     /*  676375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  676386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  676389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  676392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  676395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676421 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  676424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676443 */     GIR_RootConstrainSelectedInstOperands,
     /*  676444 */     // GIR_Coverage, 10485,
     /*  676444 */     GIR_EraseRootFromParent_Done,
     /*  676445 */   // Label 10748: @676445
     /*  676445 */   GIM_Try, /*On fail goto*//*Label 10749*/ GIMT_Encode4(676520), // Rule ID 10488 //
     /*  676450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  676461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  676464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  676467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  676470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  676499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676518 */     GIR_RootConstrainSelectedInstOperands,
     /*  676519 */     // GIR_Coverage, 10488,
     /*  676519 */     GIR_EraseRootFromParent_Done,
     /*  676520 */   // Label 10749: @676520
     /*  676520 */   GIM_Try, /*On fail goto*//*Label 10750*/ GIMT_Encode4(676595), // Rule ID 10489 //
     /*  676525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  676536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  676539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  676542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  676545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  676574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676593 */     GIR_RootConstrainSelectedInstOperands,
     /*  676594 */     // GIR_Coverage, 10489,
     /*  676594 */     GIR_EraseRootFromParent_Done,
     /*  676595 */   // Label 10750: @676595
     /*  676595 */   GIM_Try, /*On fail goto*//*Label 10751*/ GIMT_Encode4(676670), // Rule ID 10492 //
     /*  676600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  676611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  676614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  676617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  676620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676646 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  676649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676668 */     GIR_RootConstrainSelectedInstOperands,
     /*  676669 */     // GIR_Coverage, 10492,
     /*  676669 */     GIR_EraseRootFromParent_Done,
     /*  676670 */   // Label 10751: @676670
     /*  676670 */   GIM_Try, /*On fail goto*//*Label 10752*/ GIMT_Encode4(676745), // Rule ID 10493 //
     /*  676675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  676686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  676689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  676692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  676695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676721 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  676724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676743 */     GIR_RootConstrainSelectedInstOperands,
     /*  676744 */     // GIR_Coverage, 10493,
     /*  676744 */     GIR_EraseRootFromParent_Done,
     /*  676745 */   // Label 10752: @676745
     /*  676745 */   GIM_Try, /*On fail goto*//*Label 10753*/ GIMT_Encode4(676820), // Rule ID 10496 //
     /*  676750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  676761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  676764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  676767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  676770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  676799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676818 */     GIR_RootConstrainSelectedInstOperands,
     /*  676819 */     // GIR_Coverage, 10496,
     /*  676819 */     GIR_EraseRootFromParent_Done,
     /*  676820 */   // Label 10753: @676820
     /*  676820 */   GIM_Try, /*On fail goto*//*Label 10754*/ GIMT_Encode4(676895), // Rule ID 10497 //
     /*  676825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  676836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  676839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  676842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  676845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676871 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  676874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676893 */     GIR_RootConstrainSelectedInstOperands,
     /*  676894 */     // GIR_Coverage, 10497,
     /*  676894 */     GIR_EraseRootFromParent_Done,
     /*  676895 */   // Label 10754: @676895
     /*  676895 */   GIM_Try, /*On fail goto*//*Label 10755*/ GIMT_Encode4(676970), // Rule ID 10500 //
     /*  676900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  676911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  676914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  676917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  676920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  676946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  676949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676968 */     GIR_RootConstrainSelectedInstOperands,
     /*  676969 */     // GIR_Coverage, 10500,
     /*  676969 */     GIR_EraseRootFromParent_Done,
     /*  676970 */   // Label 10755: @676970
     /*  676970 */   GIM_Try, /*On fail goto*//*Label 10756*/ GIMT_Encode4(677045), // Rule ID 10501 //
     /*  676975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  676978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  676986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  676989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  676992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  676995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  677021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  677024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677043 */     GIR_RootConstrainSelectedInstOperands,
     /*  677044 */     // GIR_Coverage, 10501,
     /*  677044 */     GIR_EraseRootFromParent_Done,
     /*  677045 */   // Label 10756: @677045
     /*  677045 */   GIM_Try, /*On fail goto*//*Label 10757*/ GIMT_Encode4(677120), // Rule ID 10504 //
     /*  677050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  677053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  677061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  677064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  677067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  677070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  677096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  677099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677118 */     GIR_RootConstrainSelectedInstOperands,
     /*  677119 */     // GIR_Coverage, 10504,
     /*  677119 */     GIR_EraseRootFromParent_Done,
     /*  677120 */   // Label 10757: @677120
     /*  677120 */   GIM_Try, /*On fail goto*//*Label 10758*/ GIMT_Encode4(677195), // Rule ID 10505 //
     /*  677125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  677128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  677136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  677139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  677142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  677145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677171 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  677171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  677174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677193 */     GIR_RootConstrainSelectedInstOperands,
     /*  677194 */     // GIR_Coverage, 10505,
     /*  677194 */     GIR_EraseRootFromParent_Done,
     /*  677195 */   // Label 10758: @677195
     /*  677195 */   GIM_Try, /*On fail goto*//*Label 10759*/ GIMT_Encode4(677270), // Rule ID 10508 //
     /*  677200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  677203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  677211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  677214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  677217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  677220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677246 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  677246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  677249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677268 */     GIR_RootConstrainSelectedInstOperands,
     /*  677269 */     // GIR_Coverage, 10508,
     /*  677269 */     GIR_EraseRootFromParent_Done,
     /*  677270 */   // Label 10759: @677270
     /*  677270 */   GIM_Try, /*On fail goto*//*Label 10760*/ GIMT_Encode4(677345), // Rule ID 10509 //
     /*  677275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  677278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  677286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  677289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  677292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  677295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677321 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  677321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  677324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677343 */     GIR_RootConstrainSelectedInstOperands,
     /*  677344 */     // GIR_Coverage, 10509,
     /*  677344 */     GIR_EraseRootFromParent_Done,
     /*  677345 */   // Label 10760: @677345
     /*  677345 */   GIM_Try, /*On fail goto*//*Label 10761*/ GIMT_Encode4(677420), // Rule ID 10512 //
     /*  677350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  677361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  677364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  677367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  677370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677396 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  677399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677418 */     GIR_RootConstrainSelectedInstOperands,
     /*  677419 */     // GIR_Coverage, 10512,
     /*  677419 */     GIR_EraseRootFromParent_Done,
     /*  677420 */   // Label 10761: @677420
     /*  677420 */   GIM_Try, /*On fail goto*//*Label 10762*/ GIMT_Encode4(677495), // Rule ID 10513 //
     /*  677425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  677436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  677439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  677442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  677445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677471 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  677474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677493 */     GIR_RootConstrainSelectedInstOperands,
     /*  677494 */     // GIR_Coverage, 10513,
     /*  677494 */     GIR_EraseRootFromParent_Done,
     /*  677495 */   // Label 10762: @677495
     /*  677495 */   GIM_Try, /*On fail goto*//*Label 10763*/ GIMT_Encode4(677570), // Rule ID 10516 //
     /*  677500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  677511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  677514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  677517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  677520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677546 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  677549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677568 */     GIR_RootConstrainSelectedInstOperands,
     /*  677569 */     // GIR_Coverage, 10516,
     /*  677569 */     GIR_EraseRootFromParent_Done,
     /*  677570 */   // Label 10763: @677570
     /*  677570 */   GIM_Try, /*On fail goto*//*Label 10764*/ GIMT_Encode4(677645), // Rule ID 10517 //
     /*  677575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  677586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  677589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  677592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  677595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677621 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  677624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677643 */     GIR_RootConstrainSelectedInstOperands,
     /*  677644 */     // GIR_Coverage, 10517,
     /*  677644 */     GIR_EraseRootFromParent_Done,
     /*  677645 */   // Label 10764: @677645
     /*  677645 */   GIM_Try, /*On fail goto*//*Label 10765*/ GIMT_Encode4(677720), // Rule ID 10520 //
     /*  677650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  677661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  677664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  677667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  677670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677696 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  677699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677718 */     GIR_RootConstrainSelectedInstOperands,
     /*  677719 */     // GIR_Coverage, 10520,
     /*  677719 */     GIR_EraseRootFromParent_Done,
     /*  677720 */   // Label 10765: @677720
     /*  677720 */   GIM_Try, /*On fail goto*//*Label 10766*/ GIMT_Encode4(677795), // Rule ID 10521 //
     /*  677725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  677736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  677739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  677742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  677745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677771 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  677774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677793 */     GIR_RootConstrainSelectedInstOperands,
     /*  677794 */     // GIR_Coverage, 10521,
     /*  677794 */     GIR_EraseRootFromParent_Done,
     /*  677795 */   // Label 10766: @677795
     /*  677795 */   GIM_Try, /*On fail goto*//*Label 10767*/ GIMT_Encode4(677870), // Rule ID 10524 //
     /*  677800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  677811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  677814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  677817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  677820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  677849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677868 */     GIR_RootConstrainSelectedInstOperands,
     /*  677869 */     // GIR_Coverage, 10524,
     /*  677869 */     GIR_EraseRootFromParent_Done,
     /*  677870 */   // Label 10767: @677870
     /*  677870 */   GIM_Try, /*On fail goto*//*Label 10768*/ GIMT_Encode4(677945), // Rule ID 10525 //
     /*  677875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  677886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  677889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  677892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  677895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677921 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  677924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677943 */     GIR_RootConstrainSelectedInstOperands,
     /*  677944 */     // GIR_Coverage, 10525,
     /*  677944 */     GIR_EraseRootFromParent_Done,
     /*  677945 */   // Label 10768: @677945
     /*  677945 */   GIM_Try, /*On fail goto*//*Label 10769*/ GIMT_Encode4(678020), // Rule ID 10528 //
     /*  677950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  677961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  677964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  677967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  677970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677996 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  677999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678018 */     GIR_RootConstrainSelectedInstOperands,
     /*  678019 */     // GIR_Coverage, 10528,
     /*  678019 */     GIR_EraseRootFromParent_Done,
     /*  678020 */   // Label 10769: @678020
     /*  678020 */   GIM_Try, /*On fail goto*//*Label 10770*/ GIMT_Encode4(678095), // Rule ID 10529 //
     /*  678025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  678036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  678039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  678042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678071 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  678071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  678074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678093 */     GIR_RootConstrainSelectedInstOperands,
     /*  678094 */     // GIR_Coverage, 10529,
     /*  678094 */     GIR_EraseRootFromParent_Done,
     /*  678095 */   // Label 10770: @678095
     /*  678095 */   GIM_Try, /*On fail goto*//*Label 10771*/ GIMT_Encode4(678170), // Rule ID 10532 //
     /*  678100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  678111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  678114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  678117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  678120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  678149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678168 */     GIR_RootConstrainSelectedInstOperands,
     /*  678169 */     // GIR_Coverage, 10532,
     /*  678169 */     GIR_EraseRootFromParent_Done,
     /*  678170 */   // Label 10771: @678170
     /*  678170 */   GIM_Try, /*On fail goto*//*Label 10772*/ GIMT_Encode4(678245), // Rule ID 10533 //
     /*  678175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  678186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  678189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  678192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678221 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  678224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678243 */     GIR_RootConstrainSelectedInstOperands,
     /*  678244 */     // GIR_Coverage, 10533,
     /*  678244 */     GIR_EraseRootFromParent_Done,
     /*  678245 */   // Label 10772: @678245
     /*  678245 */   GIM_Try, /*On fail goto*//*Label 10773*/ GIMT_Encode4(678320), // Rule ID 10536 //
     /*  678250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  678261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  678264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  678267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  678270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678296 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678318 */     GIR_RootConstrainSelectedInstOperands,
     /*  678319 */     // GIR_Coverage, 10536,
     /*  678319 */     GIR_EraseRootFromParent_Done,
     /*  678320 */   // Label 10773: @678320
     /*  678320 */   GIM_Try, /*On fail goto*//*Label 10774*/ GIMT_Encode4(678395), // Rule ID 10537 //
     /*  678325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  678336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  678339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  678342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678371 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678393 */     GIR_RootConstrainSelectedInstOperands,
     /*  678394 */     // GIR_Coverage, 10537,
     /*  678394 */     GIR_EraseRootFromParent_Done,
     /*  678395 */   // Label 10774: @678395
     /*  678395 */   GIM_Try, /*On fail goto*//*Label 10775*/ GIMT_Encode4(678470), // Rule ID 10540 //
     /*  678400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  678411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  678414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  678417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  678420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  678446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678468 */     GIR_RootConstrainSelectedInstOperands,
     /*  678469 */     // GIR_Coverage, 10540,
     /*  678469 */     GIR_EraseRootFromParent_Done,
     /*  678470 */   // Label 10775: @678470
     /*  678470 */   GIM_Try, /*On fail goto*//*Label 10776*/ GIMT_Encode4(678545), // Rule ID 10541 //
     /*  678475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  678486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  678489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  678492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678521 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  678521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678543 */     GIR_RootConstrainSelectedInstOperands,
     /*  678544 */     // GIR_Coverage, 10541,
     /*  678544 */     GIR_EraseRootFromParent_Done,
     /*  678545 */   // Label 10776: @678545
     /*  678545 */   GIM_Try, /*On fail goto*//*Label 10777*/ GIMT_Encode4(678620), // Rule ID 10544 //
     /*  678550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  678561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  678564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  678567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  678570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678618 */     GIR_RootConstrainSelectedInstOperands,
     /*  678619 */     // GIR_Coverage, 10544,
     /*  678619 */     GIR_EraseRootFromParent_Done,
     /*  678620 */   // Label 10777: @678620
     /*  678620 */   GIM_Try, /*On fail goto*//*Label 10778*/ GIMT_Encode4(678695), // Rule ID 10545 //
     /*  678625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  678636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  678639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  678642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678671 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678693 */     GIR_RootConstrainSelectedInstOperands,
     /*  678694 */     // GIR_Coverage, 10545,
     /*  678694 */     GIR_EraseRootFromParent_Done,
     /*  678695 */   // Label 10778: @678695
     /*  678695 */   GIM_Try, /*On fail goto*//*Label 10779*/ GIMT_Encode4(678770), // Rule ID 10548 //
     /*  678700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  678703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  678711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  678714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  678717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  678720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678746 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  678746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678768 */     GIR_RootConstrainSelectedInstOperands,
     /*  678769 */     // GIR_Coverage, 10548,
     /*  678769 */     GIR_EraseRootFromParent_Done,
     /*  678770 */   // Label 10779: @678770
     /*  678770 */   GIM_Try, /*On fail goto*//*Label 10780*/ GIMT_Encode4(678845), // Rule ID 10549 //
     /*  678775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  678778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  678786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  678789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  678792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678821 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  678821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678843 */     GIR_RootConstrainSelectedInstOperands,
     /*  678844 */     // GIR_Coverage, 10549,
     /*  678844 */     GIR_EraseRootFromParent_Done,
     /*  678845 */   // Label 10780: @678845
     /*  678845 */   GIM_Try, /*On fail goto*//*Label 10781*/ GIMT_Encode4(678920), // Rule ID 10552 //
     /*  678850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  678861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  678864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  678867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  678870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  678899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678918 */     GIR_RootConstrainSelectedInstOperands,
     /*  678919 */     // GIR_Coverage, 10552,
     /*  678919 */     GIR_EraseRootFromParent_Done,
     /*  678920 */   // Label 10781: @678920
     /*  678920 */   GIM_Try, /*On fail goto*//*Label 10782*/ GIMT_Encode4(678995), // Rule ID 10553 //
     /*  678925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  678936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  678939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  678942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678971 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  678974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678993 */     GIR_RootConstrainSelectedInstOperands,
     /*  678994 */     // GIR_Coverage, 10553,
     /*  678994 */     GIR_EraseRootFromParent_Done,
     /*  678995 */   // Label 10782: @678995
     /*  678995 */   GIM_Try, /*On fail goto*//*Label 10783*/ GIMT_Encode4(679070), // Rule ID 10556 //
     /*  679000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  679011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  679014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  679017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679046 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  679046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  679049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679068 */     GIR_RootConstrainSelectedInstOperands,
     /*  679069 */     // GIR_Coverage, 10556,
     /*  679069 */     GIR_EraseRootFromParent_Done,
     /*  679070 */   // Label 10783: @679070
     /*  679070 */   GIM_Try, /*On fail goto*//*Label 10784*/ GIMT_Encode4(679145), // Rule ID 10557 //
     /*  679075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  679086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  679089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  679092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679121 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  679121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  679124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679143 */     GIR_RootConstrainSelectedInstOperands,
     /*  679144 */     // GIR_Coverage, 10557,
     /*  679144 */     GIR_EraseRootFromParent_Done,
     /*  679145 */   // Label 10784: @679145
     /*  679145 */   GIM_Try, /*On fail goto*//*Label 10785*/ GIMT_Encode4(679220), // Rule ID 10560 //
     /*  679150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  679161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  679164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  679167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679196 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  679196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  679199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679218 */     GIR_RootConstrainSelectedInstOperands,
     /*  679219 */     // GIR_Coverage, 10560,
     /*  679219 */     GIR_EraseRootFromParent_Done,
     /*  679220 */   // Label 10785: @679220
     /*  679220 */   GIM_Try, /*On fail goto*//*Label 10786*/ GIMT_Encode4(679295), // Rule ID 10561 //
     /*  679225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  679236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  679239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  679242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679271 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  679271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  679274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679293 */     GIR_RootConstrainSelectedInstOperands,
     /*  679294 */     // GIR_Coverage, 10561,
     /*  679294 */     GIR_EraseRootFromParent_Done,
     /*  679295 */   // Label 10786: @679295
     /*  679295 */   GIM_Try, /*On fail goto*//*Label 10787*/ GIMT_Encode4(679370), // Rule ID 10564 //
     /*  679300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  679311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  679314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  679317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  679349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679368 */     GIR_RootConstrainSelectedInstOperands,
     /*  679369 */     // GIR_Coverage, 10564,
     /*  679369 */     GIR_EraseRootFromParent_Done,
     /*  679370 */   // Label 10787: @679370
     /*  679370 */   GIM_Try, /*On fail goto*//*Label 10788*/ GIMT_Encode4(679445), // Rule ID 10565 //
     /*  679375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  679386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  679389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  679392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  679424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679443 */     GIR_RootConstrainSelectedInstOperands,
     /*  679444 */     // GIR_Coverage, 10565,
     /*  679444 */     GIR_EraseRootFromParent_Done,
     /*  679445 */   // Label 10788: @679445
     /*  679445 */   GIM_Try, /*On fail goto*//*Label 10789*/ GIMT_Encode4(679520), // Rule ID 10568 //
     /*  679450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  679461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  679464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  679467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  679499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679518 */     GIR_RootConstrainSelectedInstOperands,
     /*  679519 */     // GIR_Coverage, 10568,
     /*  679519 */     GIR_EraseRootFromParent_Done,
     /*  679520 */   // Label 10789: @679520
     /*  679520 */   GIM_Try, /*On fail goto*//*Label 10790*/ GIMT_Encode4(679595), // Rule ID 10569 //
     /*  679525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  679536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  679539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  679542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679571 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  679574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679593 */     GIR_RootConstrainSelectedInstOperands,
     /*  679594 */     // GIR_Coverage, 10569,
     /*  679594 */     GIR_EraseRootFromParent_Done,
     /*  679595 */   // Label 10790: @679595
     /*  679595 */   GIM_Try, /*On fail goto*//*Label 10791*/ GIMT_Encode4(679670), // Rule ID 10572 //
     /*  679600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  679611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  679614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  679617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  679649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679668 */     GIR_RootConstrainSelectedInstOperands,
     /*  679669 */     // GIR_Coverage, 10572,
     /*  679669 */     GIR_EraseRootFromParent_Done,
     /*  679670 */   // Label 10791: @679670
     /*  679670 */   GIM_Try, /*On fail goto*//*Label 10792*/ GIMT_Encode4(679745), // Rule ID 10573 //
     /*  679675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  679686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  679689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  679692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679721 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  679724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679743 */     GIR_RootConstrainSelectedInstOperands,
     /*  679744 */     // GIR_Coverage, 10573,
     /*  679744 */     GIR_EraseRootFromParent_Done,
     /*  679745 */   // Label 10792: @679745
     /*  679745 */   GIM_Try, /*On fail goto*//*Label 10793*/ GIMT_Encode4(679820), // Rule ID 10576 //
     /*  679750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  679761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  679764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  679767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  679799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679818 */     GIR_RootConstrainSelectedInstOperands,
     /*  679819 */     // GIR_Coverage, 10576,
     /*  679819 */     GIR_EraseRootFromParent_Done,
     /*  679820 */   // Label 10793: @679820
     /*  679820 */   GIM_Try, /*On fail goto*//*Label 10794*/ GIMT_Encode4(679895), // Rule ID 10577 //
     /*  679825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  679836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  679839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  679842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  679874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679893 */     GIR_RootConstrainSelectedInstOperands,
     /*  679894 */     // GIR_Coverage, 10577,
     /*  679894 */     GIR_EraseRootFromParent_Done,
     /*  679895 */   // Label 10794: @679895
     /*  679895 */   GIM_Try, /*On fail goto*//*Label 10795*/ GIMT_Encode4(679970), // Rule ID 10580 //
     /*  679900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  679911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  679914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  679917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  679949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679968 */     GIR_RootConstrainSelectedInstOperands,
     /*  679969 */     // GIR_Coverage, 10580,
     /*  679969 */     GIR_EraseRootFromParent_Done,
     /*  679970 */   // Label 10795: @679970
     /*  679970 */   GIM_Try, /*On fail goto*//*Label 10796*/ GIMT_Encode4(680045), // Rule ID 10581 //
     /*  679975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  679986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  679989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  679992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  680021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  680024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680043 */     GIR_RootConstrainSelectedInstOperands,
     /*  680044 */     // GIR_Coverage, 10581,
     /*  680044 */     GIR_EraseRootFromParent_Done,
     /*  680045 */   // Label 10796: @680045
     /*  680045 */   GIM_Try, /*On fail goto*//*Label 10797*/ GIMT_Encode4(680120), // Rule ID 10584 //
     /*  680050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  680061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  680064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  680067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680096 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  680096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  680099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680118 */     GIR_RootConstrainSelectedInstOperands,
     /*  680119 */     // GIR_Coverage, 10584,
     /*  680119 */     GIR_EraseRootFromParent_Done,
     /*  680120 */   // Label 10797: @680120
     /*  680120 */   GIM_Try, /*On fail goto*//*Label 10798*/ GIMT_Encode4(680195), // Rule ID 10585 //
     /*  680125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  680136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  680139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  680142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680171 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  680171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  680174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680193 */     GIR_RootConstrainSelectedInstOperands,
     /*  680194 */     // GIR_Coverage, 10585,
     /*  680194 */     GIR_EraseRootFromParent_Done,
     /*  680195 */   // Label 10798: @680195
     /*  680195 */   GIM_Try, /*On fail goto*//*Label 10799*/ GIMT_Encode4(680270), // Rule ID 10588 //
     /*  680200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  680211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  680214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  680217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  680249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680268 */     GIR_RootConstrainSelectedInstOperands,
     /*  680269 */     // GIR_Coverage, 10588,
     /*  680269 */     GIR_EraseRootFromParent_Done,
     /*  680270 */   // Label 10799: @680270
     /*  680270 */   GIM_Try, /*On fail goto*//*Label 10800*/ GIMT_Encode4(680345), // Rule ID 10589 //
     /*  680275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  680286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  680289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  680292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  680324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680343 */     GIR_RootConstrainSelectedInstOperands,
     /*  680344 */     // GIR_Coverage, 10589,
     /*  680344 */     GIR_EraseRootFromParent_Done,
     /*  680345 */   // Label 10800: @680345
     /*  680345 */   GIM_Try, /*On fail goto*//*Label 10801*/ GIMT_Encode4(680420), // Rule ID 10592 //
     /*  680350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  680361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  680364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  680367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  680399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680418 */     GIR_RootConstrainSelectedInstOperands,
     /*  680419 */     // GIR_Coverage, 10592,
     /*  680419 */     GIR_EraseRootFromParent_Done,
     /*  680420 */   // Label 10801: @680420
     /*  680420 */   GIM_Try, /*On fail goto*//*Label 10802*/ GIMT_Encode4(680495), // Rule ID 10593 //
     /*  680425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  680436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  680439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  680442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680471 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  680474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680493 */     GIR_RootConstrainSelectedInstOperands,
     /*  680494 */     // GIR_Coverage, 10593,
     /*  680494 */     GIR_EraseRootFromParent_Done,
     /*  680495 */   // Label 10802: @680495
     /*  680495 */   GIM_Try, /*On fail goto*//*Label 10803*/ GIMT_Encode4(680570), // Rule ID 10596 //
     /*  680500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  680511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  680514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  680517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  680549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680568 */     GIR_RootConstrainSelectedInstOperands,
     /*  680569 */     // GIR_Coverage, 10596,
     /*  680569 */     GIR_EraseRootFromParent_Done,
     /*  680570 */   // Label 10803: @680570
     /*  680570 */   GIM_Try, /*On fail goto*//*Label 10804*/ GIMT_Encode4(680645), // Rule ID 10597 //
     /*  680575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  680586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  680589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  680592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680621 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  680624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680643 */     GIR_RootConstrainSelectedInstOperands,
     /*  680644 */     // GIR_Coverage, 10597,
     /*  680644 */     GIR_EraseRootFromParent_Done,
     /*  680645 */   // Label 10804: @680645
     /*  680645 */   GIM_Try, /*On fail goto*//*Label 10805*/ GIMT_Encode4(680720), // Rule ID 10600 //
     /*  680650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  680661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  680664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  680667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  680670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680696 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  680699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680718 */     GIR_RootConstrainSelectedInstOperands,
     /*  680719 */     // GIR_Coverage, 10600,
     /*  680719 */     GIR_EraseRootFromParent_Done,
     /*  680720 */   // Label 10805: @680720
     /*  680720 */   GIM_Try, /*On fail goto*//*Label 10806*/ GIMT_Encode4(680795), // Rule ID 10601 //
     /*  680725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  680736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  680739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  680742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  680745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680771 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  680774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680793 */     GIR_RootConstrainSelectedInstOperands,
     /*  680794 */     // GIR_Coverage, 10601,
     /*  680794 */     GIR_EraseRootFromParent_Done,
     /*  680795 */   // Label 10806: @680795
     /*  680795 */   GIM_Try, /*On fail goto*//*Label 10807*/ GIMT_Encode4(680870), // Rule ID 10604 //
     /*  680800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  680811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  680814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  680817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  680820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680846 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  680849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680868 */     GIR_RootConstrainSelectedInstOperands,
     /*  680869 */     // GIR_Coverage, 10604,
     /*  680869 */     GIR_EraseRootFromParent_Done,
     /*  680870 */   // Label 10807: @680870
     /*  680870 */   GIM_Try, /*On fail goto*//*Label 10808*/ GIMT_Encode4(680945), // Rule ID 10605 //
     /*  680875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  680886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  680889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  680892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  680895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680921 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  680924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680943 */     GIR_RootConstrainSelectedInstOperands,
     /*  680944 */     // GIR_Coverage, 10605,
     /*  680944 */     GIR_EraseRootFromParent_Done,
     /*  680945 */   // Label 10808: @680945
     /*  680945 */   GIM_Try, /*On fail goto*//*Label 10809*/ GIMT_Encode4(681020), // Rule ID 10608 //
     /*  680950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  680961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  680964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  680967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  680970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680996 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  680999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681018 */     GIR_RootConstrainSelectedInstOperands,
     /*  681019 */     // GIR_Coverage, 10608,
     /*  681019 */     GIR_EraseRootFromParent_Done,
     /*  681020 */   // Label 10809: @681020
     /*  681020 */   GIM_Try, /*On fail goto*//*Label 10810*/ GIMT_Encode4(681095), // Rule ID 10609 //
     /*  681025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  681036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  681039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  681042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  681045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681071 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  681074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681093 */     GIR_RootConstrainSelectedInstOperands,
     /*  681094 */     // GIR_Coverage, 10609,
     /*  681094 */     GIR_EraseRootFromParent_Done,
     /*  681095 */   // Label 10810: @681095
     /*  681095 */   GIM_Try, /*On fail goto*//*Label 10811*/ GIMT_Encode4(681170), // Rule ID 10612 //
     /*  681100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  681111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  681114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  681117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  681120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681146 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  681149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681168 */     GIR_RootConstrainSelectedInstOperands,
     /*  681169 */     // GIR_Coverage, 10612,
     /*  681169 */     GIR_EraseRootFromParent_Done,
     /*  681170 */   // Label 10811: @681170
     /*  681170 */   GIM_Try, /*On fail goto*//*Label 10812*/ GIMT_Encode4(681245), // Rule ID 10613 //
     /*  681175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  681186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  681189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  681192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  681195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681221 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  681224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681243 */     GIR_RootConstrainSelectedInstOperands,
     /*  681244 */     // GIR_Coverage, 10613,
     /*  681244 */     GIR_EraseRootFromParent_Done,
     /*  681245 */   // Label 10812: @681245
     /*  681245 */   GIM_Try, /*On fail goto*//*Label 10813*/ GIMT_Encode4(681320), // Rule ID 10616 //
     /*  681250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  681261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  681264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  681267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  681270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681296 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  681299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681318 */     GIR_RootConstrainSelectedInstOperands,
     /*  681319 */     // GIR_Coverage, 10616,
     /*  681319 */     GIR_EraseRootFromParent_Done,
     /*  681320 */   // Label 10813: @681320
     /*  681320 */   GIM_Try, /*On fail goto*//*Label 10814*/ GIMT_Encode4(681395), // Rule ID 10617 //
     /*  681325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  681336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  681339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  681342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  681345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681371 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  681374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681393 */     GIR_RootConstrainSelectedInstOperands,
     /*  681394 */     // GIR_Coverage, 10617,
     /*  681394 */     GIR_EraseRootFromParent_Done,
     /*  681395 */   // Label 10814: @681395
     /*  681395 */   GIM_Try, /*On fail goto*//*Label 10815*/ GIMT_Encode4(681470), // Rule ID 10620 //
     /*  681400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  681411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  681414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  681417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  681420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681446 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  681446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  681449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681468 */     GIR_RootConstrainSelectedInstOperands,
     /*  681469 */     // GIR_Coverage, 10620,
     /*  681469 */     GIR_EraseRootFromParent_Done,
     /*  681470 */   // Label 10815: @681470
     /*  681470 */   GIM_Try, /*On fail goto*//*Label 10816*/ GIMT_Encode4(681545), // Rule ID 10621 //
     /*  681475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  681486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  681489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  681492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  681495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681521 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  681521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  681524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681543 */     GIR_RootConstrainSelectedInstOperands,
     /*  681544 */     // GIR_Coverage, 10621,
     /*  681544 */     GIR_EraseRootFromParent_Done,
     /*  681545 */   // Label 10816: @681545
     /*  681545 */   GIM_Try, /*On fail goto*//*Label 10817*/ GIMT_Encode4(681620), // Rule ID 10624 //
     /*  681550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  681561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  681564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  681567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  681570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  681599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681618 */     GIR_RootConstrainSelectedInstOperands,
     /*  681619 */     // GIR_Coverage, 10624,
     /*  681619 */     GIR_EraseRootFromParent_Done,
     /*  681620 */   // Label 10817: @681620
     /*  681620 */   GIM_Try, /*On fail goto*//*Label 10818*/ GIMT_Encode4(681695), // Rule ID 10625 //
     /*  681625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  681636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  681639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  681642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  681645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681671 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  681674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681693 */     GIR_RootConstrainSelectedInstOperands,
     /*  681694 */     // GIR_Coverage, 10625,
     /*  681694 */     GIR_EraseRootFromParent_Done,
     /*  681695 */   // Label 10818: @681695
     /*  681695 */   GIM_Try, /*On fail goto*//*Label 10819*/ GIMT_Encode4(681770), // Rule ID 10628 //
     /*  681700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  681711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  681714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  681717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  681720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681746 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  681749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681768 */     GIR_RootConstrainSelectedInstOperands,
     /*  681769 */     // GIR_Coverage, 10628,
     /*  681769 */     GIR_EraseRootFromParent_Done,
     /*  681770 */   // Label 10819: @681770
     /*  681770 */   GIM_Try, /*On fail goto*//*Label 10820*/ GIMT_Encode4(681845), // Rule ID 10629 //
     /*  681775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  681786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  681789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  681792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  681795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681821 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  681824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681843 */     GIR_RootConstrainSelectedInstOperands,
     /*  681844 */     // GIR_Coverage, 10629,
     /*  681844 */     GIR_EraseRootFromParent_Done,
     /*  681845 */   // Label 10820: @681845
     /*  681845 */   GIM_Try, /*On fail goto*//*Label 10821*/ GIMT_Encode4(681920), // Rule ID 10632 //
     /*  681850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  681861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  681864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  681867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  681870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681896 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  681896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  681899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681918 */     GIR_RootConstrainSelectedInstOperands,
     /*  681919 */     // GIR_Coverage, 10632,
     /*  681919 */     GIR_EraseRootFromParent_Done,
     /*  681920 */   // Label 10821: @681920
     /*  681920 */   GIM_Try, /*On fail goto*//*Label 10822*/ GIMT_Encode4(681995), // Rule ID 10633 //
     /*  681925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  681936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  681939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  681942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  681945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681971 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  681971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  681974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681993 */     GIR_RootConstrainSelectedInstOperands,
     /*  681994 */     // GIR_Coverage, 10633,
     /*  681994 */     GIR_EraseRootFromParent_Done,
     /*  681995 */   // Label 10822: @681995
     /*  681995 */   GIM_Try, /*On fail goto*//*Label 10823*/ GIMT_Encode4(682070), // Rule ID 10636 //
     /*  682000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  682003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  682011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  682014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  682017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  682020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682046 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  682046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  682049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682068 */     GIR_RootConstrainSelectedInstOperands,
     /*  682069 */     // GIR_Coverage, 10636,
     /*  682069 */     GIR_EraseRootFromParent_Done,
     /*  682070 */   // Label 10823: @682070
     /*  682070 */   GIM_Try, /*On fail goto*//*Label 10824*/ GIMT_Encode4(682145), // Rule ID 10637 //
     /*  682075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  682078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  682086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  682089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  682092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  682095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682121 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  682121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  682124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682143 */     GIR_RootConstrainSelectedInstOperands,
     /*  682144 */     // GIR_Coverage, 10637,
     /*  682144 */     GIR_EraseRootFromParent_Done,
     /*  682145 */   // Label 10824: @682145
     /*  682145 */   GIM_Try, /*On fail goto*//*Label 10825*/ GIMT_Encode4(682220), // Rule ID 10640 //
     /*  682150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  682161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  682164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  682167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  682170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682196 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  682199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682218 */     GIR_RootConstrainSelectedInstOperands,
     /*  682219 */     // GIR_Coverage, 10640,
     /*  682219 */     GIR_EraseRootFromParent_Done,
     /*  682220 */   // Label 10825: @682220
     /*  682220 */   GIM_Try, /*On fail goto*//*Label 10826*/ GIMT_Encode4(682295), // Rule ID 10641 //
     /*  682225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  682236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  682239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  682242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  682245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682271 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  682274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682293 */     GIR_RootConstrainSelectedInstOperands,
     /*  682294 */     // GIR_Coverage, 10641,
     /*  682294 */     GIR_EraseRootFromParent_Done,
     /*  682295 */   // Label 10826: @682295
     /*  682295 */   GIM_Try, /*On fail goto*//*Label 10827*/ GIMT_Encode4(682370), // Rule ID 10644 //
     /*  682300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  682311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  682314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  682317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  682320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682346 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  682349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682368 */     GIR_RootConstrainSelectedInstOperands,
     /*  682369 */     // GIR_Coverage, 10644,
     /*  682369 */     GIR_EraseRootFromParent_Done,
     /*  682370 */   // Label 10827: @682370
     /*  682370 */   GIM_Try, /*On fail goto*//*Label 10828*/ GIMT_Encode4(682445), // Rule ID 10645 //
     /*  682375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  682386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  682389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  682392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  682395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682421 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  682424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682443 */     GIR_RootConstrainSelectedInstOperands,
     /*  682444 */     // GIR_Coverage, 10645,
     /*  682444 */     GIR_EraseRootFromParent_Done,
     /*  682445 */   // Label 10828: @682445
     /*  682445 */   GIM_Try, /*On fail goto*//*Label 10829*/ GIMT_Encode4(682520), // Rule ID 10648 //
     /*  682450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  682461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  682464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  682467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  682470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682496 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  682499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682518 */     GIR_RootConstrainSelectedInstOperands,
     /*  682519 */     // GIR_Coverage, 10648,
     /*  682519 */     GIR_EraseRootFromParent_Done,
     /*  682520 */   // Label 10829: @682520
     /*  682520 */   GIM_Try, /*On fail goto*//*Label 10830*/ GIMT_Encode4(682595), // Rule ID 10649 //
     /*  682525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  682536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  682539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  682542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  682545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682571 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  682574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682593 */     GIR_RootConstrainSelectedInstOperands,
     /*  682594 */     // GIR_Coverage, 10649,
     /*  682594 */     GIR_EraseRootFromParent_Done,
     /*  682595 */   // Label 10830: @682595
     /*  682595 */   GIM_Try, /*On fail goto*//*Label 10831*/ GIMT_Encode4(682670), // Rule ID 10652 //
     /*  682600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  682611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  682614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  682617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  682620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  682649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682668 */     GIR_RootConstrainSelectedInstOperands,
     /*  682669 */     // GIR_Coverage, 10652,
     /*  682669 */     GIR_EraseRootFromParent_Done,
     /*  682670 */   // Label 10831: @682670
     /*  682670 */   GIM_Try, /*On fail goto*//*Label 10832*/ GIMT_Encode4(682745), // Rule ID 10653 //
     /*  682675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  682686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  682689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  682692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  682695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682721 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  682724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682743 */     GIR_RootConstrainSelectedInstOperands,
     /*  682744 */     // GIR_Coverage, 10653,
     /*  682744 */     GIR_EraseRootFromParent_Done,
     /*  682745 */   // Label 10832: @682745
     /*  682745 */   GIM_Try, /*On fail goto*//*Label 10833*/ GIMT_Encode4(682820), // Rule ID 10656 //
     /*  682750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  682761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  682764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  682767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  682770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682796 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  682799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682818 */     GIR_RootConstrainSelectedInstOperands,
     /*  682819 */     // GIR_Coverage, 10656,
     /*  682819 */     GIR_EraseRootFromParent_Done,
     /*  682820 */   // Label 10833: @682820
     /*  682820 */   GIM_Try, /*On fail goto*//*Label 10834*/ GIMT_Encode4(682895), // Rule ID 10657 //
     /*  682825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  682836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  682839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  682842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  682845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682871 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  682874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682893 */     GIR_RootConstrainSelectedInstOperands,
     /*  682894 */     // GIR_Coverage, 10657,
     /*  682894 */     GIR_EraseRootFromParent_Done,
     /*  682895 */   // Label 10834: @682895
     /*  682895 */   GIM_Try, /*On fail goto*//*Label 10835*/ GIMT_Encode4(682970), // Rule ID 10660 //
     /*  682900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  682911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  682914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  682917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  682920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682946 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  682949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682968 */     GIR_RootConstrainSelectedInstOperands,
     /*  682969 */     // GIR_Coverage, 10660,
     /*  682969 */     GIR_EraseRootFromParent_Done,
     /*  682970 */   // Label 10835: @682970
     /*  682970 */   GIM_Try, /*On fail goto*//*Label 10836*/ GIMT_Encode4(683045), // Rule ID 10661 //
     /*  682975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  682986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  682989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  682992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  682995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683021 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  683021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  683024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683043 */     GIR_RootConstrainSelectedInstOperands,
     /*  683044 */     // GIR_Coverage, 10661,
     /*  683044 */     GIR_EraseRootFromParent_Done,
     /*  683045 */   // Label 10836: @683045
     /*  683045 */   GIM_Try, /*On fail goto*//*Label 10837*/ GIMT_Encode4(683120), // Rule ID 10664 //
     /*  683050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  683061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  683064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  683067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  683070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  683099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683118 */     GIR_RootConstrainSelectedInstOperands,
     /*  683119 */     // GIR_Coverage, 10664,
     /*  683119 */     GIR_EraseRootFromParent_Done,
     /*  683120 */   // Label 10837: @683120
     /*  683120 */   GIM_Try, /*On fail goto*//*Label 10838*/ GIMT_Encode4(683195), // Rule ID 10665 //
     /*  683125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  683136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  683139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  683142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  683145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683171 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  683174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683193 */     GIR_RootConstrainSelectedInstOperands,
     /*  683194 */     // GIR_Coverage, 10665,
     /*  683194 */     GIR_EraseRootFromParent_Done,
     /*  683195 */   // Label 10838: @683195
     /*  683195 */   GIM_Try, /*On fail goto*//*Label 10839*/ GIMT_Encode4(683270), // Rule ID 10668 //
     /*  683200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  683211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  683214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  683217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  683220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683246 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  683249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683268 */     GIR_RootConstrainSelectedInstOperands,
     /*  683269 */     // GIR_Coverage, 10668,
     /*  683269 */     GIR_EraseRootFromParent_Done,
     /*  683270 */   // Label 10839: @683270
     /*  683270 */   GIM_Try, /*On fail goto*//*Label 10840*/ GIMT_Encode4(683345), // Rule ID 10669 //
     /*  683275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  683286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  683289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  683292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  683295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683321 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  683324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683343 */     GIR_RootConstrainSelectedInstOperands,
     /*  683344 */     // GIR_Coverage, 10669,
     /*  683344 */     GIR_EraseRootFromParent_Done,
     /*  683345 */   // Label 10840: @683345
     /*  683345 */   GIM_Try, /*On fail goto*//*Label 10841*/ GIMT_Encode4(683420), // Rule ID 10672 //
     /*  683350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  683361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  683364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  683367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  683370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683396 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  683399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683418 */     GIR_RootConstrainSelectedInstOperands,
     /*  683419 */     // GIR_Coverage, 10672,
     /*  683419 */     GIR_EraseRootFromParent_Done,
     /*  683420 */   // Label 10841: @683420
     /*  683420 */   GIM_Try, /*On fail goto*//*Label 10842*/ GIMT_Encode4(683495), // Rule ID 10673 //
     /*  683425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  683436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  683439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  683442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  683445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683471 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  683474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683493 */     GIR_RootConstrainSelectedInstOperands,
     /*  683494 */     // GIR_Coverage, 10673,
     /*  683494 */     GIR_EraseRootFromParent_Done,
     /*  683495 */   // Label 10842: @683495
     /*  683495 */   GIM_Try, /*On fail goto*//*Label 10843*/ GIMT_Encode4(683570), // Rule ID 10676 //
     /*  683500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  683511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  683514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  683517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  683520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683546 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  683549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683568 */     GIR_RootConstrainSelectedInstOperands,
     /*  683569 */     // GIR_Coverage, 10676,
     /*  683569 */     GIR_EraseRootFromParent_Done,
     /*  683570 */   // Label 10843: @683570
     /*  683570 */   GIM_Try, /*On fail goto*//*Label 10844*/ GIMT_Encode4(683645), // Rule ID 10677 //
     /*  683575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  683586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  683589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  683592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  683595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683621 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  683624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683643 */     GIR_RootConstrainSelectedInstOperands,
     /*  683644 */     // GIR_Coverage, 10677,
     /*  683644 */     GIR_EraseRootFromParent_Done,
     /*  683645 */   // Label 10844: @683645
     /*  683645 */   GIM_Try, /*On fail goto*//*Label 10845*/ GIMT_Encode4(683720), // Rule ID 10680 //
     /*  683650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  683661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  683664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  683667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  683670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683696 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  683699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683718 */     GIR_RootConstrainSelectedInstOperands,
     /*  683719 */     // GIR_Coverage, 10680,
     /*  683719 */     GIR_EraseRootFromParent_Done,
     /*  683720 */   // Label 10845: @683720
     /*  683720 */   GIM_Try, /*On fail goto*//*Label 10846*/ GIMT_Encode4(683795), // Rule ID 10681 //
     /*  683725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  683736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  683739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  683742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  683745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683771 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  683774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683793 */     GIR_RootConstrainSelectedInstOperands,
     /*  683794 */     // GIR_Coverage, 10681,
     /*  683794 */     GIR_EraseRootFromParent_Done,
     /*  683795 */   // Label 10846: @683795
     /*  683795 */   GIM_Try, /*On fail goto*//*Label 10847*/ GIMT_Encode4(683870), // Rule ID 10684 //
     /*  683800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  683811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  683814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  683817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  683820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  683849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683868 */     GIR_RootConstrainSelectedInstOperands,
     /*  683869 */     // GIR_Coverage, 10684,
     /*  683869 */     GIR_EraseRootFromParent_Done,
     /*  683870 */   // Label 10847: @683870
     /*  683870 */   GIM_Try, /*On fail goto*//*Label 10848*/ GIMT_Encode4(683945), // Rule ID 10685 //
     /*  683875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  683886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  683889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  683892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  683895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683921 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  683924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683943 */     GIR_RootConstrainSelectedInstOperands,
     /*  683944 */     // GIR_Coverage, 10685,
     /*  683944 */     GIR_EraseRootFromParent_Done,
     /*  683945 */   // Label 10848: @683945
     /*  683945 */   GIM_Try, /*On fail goto*//*Label 10849*/ GIMT_Encode4(684020), // Rule ID 10688 //
     /*  683950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  683961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  683964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  683967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  683999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684018 */     GIR_RootConstrainSelectedInstOperands,
     /*  684019 */     // GIR_Coverage, 10688,
     /*  684019 */     GIR_EraseRootFromParent_Done,
     /*  684020 */   // Label 10849: @684020
     /*  684020 */   GIM_Try, /*On fail goto*//*Label 10850*/ GIMT_Encode4(684095), // Rule ID 10689 //
     /*  684025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  684036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  684039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  684042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684071 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  684074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684093 */     GIR_RootConstrainSelectedInstOperands,
     /*  684094 */     // GIR_Coverage, 10689,
     /*  684094 */     GIR_EraseRootFromParent_Done,
     /*  684095 */   // Label 10850: @684095
     /*  684095 */   GIM_Try, /*On fail goto*//*Label 10851*/ GIMT_Encode4(684170), // Rule ID 10692 //
     /*  684100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  684111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  684114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  684117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  684120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684146 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  684149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684168 */     GIR_RootConstrainSelectedInstOperands,
     /*  684169 */     // GIR_Coverage, 10692,
     /*  684169 */     GIR_EraseRootFromParent_Done,
     /*  684170 */   // Label 10851: @684170
     /*  684170 */   GIM_Try, /*On fail goto*//*Label 10852*/ GIMT_Encode4(684245), // Rule ID 10693 //
     /*  684175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  684186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  684189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  684192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684221 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  684224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684243 */     GIR_RootConstrainSelectedInstOperands,
     /*  684244 */     // GIR_Coverage, 10693,
     /*  684244 */     GIR_EraseRootFromParent_Done,
     /*  684245 */   // Label 10852: @684245
     /*  684245 */   GIM_Try, /*On fail goto*//*Label 10853*/ GIMT_Encode4(684320), // Rule ID 10696 //
     /*  684250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  684261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  684264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  684267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  684270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684296 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  684299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684318 */     GIR_RootConstrainSelectedInstOperands,
     /*  684319 */     // GIR_Coverage, 10696,
     /*  684319 */     GIR_EraseRootFromParent_Done,
     /*  684320 */   // Label 10853: @684320
     /*  684320 */   GIM_Try, /*On fail goto*//*Label 10854*/ GIMT_Encode4(684395), // Rule ID 10697 //
     /*  684325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  684336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  684339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  684342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684371 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  684374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684393 */     GIR_RootConstrainSelectedInstOperands,
     /*  684394 */     // GIR_Coverage, 10697,
     /*  684394 */     GIR_EraseRootFromParent_Done,
     /*  684395 */   // Label 10854: @684395
     /*  684395 */   GIM_Try, /*On fail goto*//*Label 10855*/ GIMT_Encode4(684470), // Rule ID 10700 //
     /*  684400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  684411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  684414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  684417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  684420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  684449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684468 */     GIR_RootConstrainSelectedInstOperands,
     /*  684469 */     // GIR_Coverage, 10700,
     /*  684469 */     GIR_EraseRootFromParent_Done,
     /*  684470 */   // Label 10855: @684470
     /*  684470 */   GIM_Try, /*On fail goto*//*Label 10856*/ GIMT_Encode4(684545), // Rule ID 10701 //
     /*  684475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  684486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  684489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  684492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684521 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  684524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684543 */     GIR_RootConstrainSelectedInstOperands,
     /*  684544 */     // GIR_Coverage, 10701,
     /*  684544 */     GIR_EraseRootFromParent_Done,
     /*  684545 */   // Label 10856: @684545
     /*  684545 */   GIM_Try, /*On fail goto*//*Label 10857*/ GIMT_Encode4(684620), // Rule ID 10704 //
     /*  684550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  684561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  684564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  684567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  684570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684596 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  684599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684618 */     GIR_RootConstrainSelectedInstOperands,
     /*  684619 */     // GIR_Coverage, 10704,
     /*  684619 */     GIR_EraseRootFromParent_Done,
     /*  684620 */   // Label 10857: @684620
     /*  684620 */   GIM_Try, /*On fail goto*//*Label 10858*/ GIMT_Encode4(684695), // Rule ID 10705 //
     /*  684625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  684636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  684639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  684642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684671 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  684674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684693 */     GIR_RootConstrainSelectedInstOperands,
     /*  684694 */     // GIR_Coverage, 10705,
     /*  684694 */     GIR_EraseRootFromParent_Done,
     /*  684695 */   // Label 10858: @684695
     /*  684695 */   GIM_Try, /*On fail goto*//*Label 10859*/ GIMT_Encode4(684770), // Rule ID 10708 //
     /*  684700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  684711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  684714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  684717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  684720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  684746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  684749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684768 */     GIR_RootConstrainSelectedInstOperands,
     /*  684769 */     // GIR_Coverage, 10708,
     /*  684769 */     GIR_EraseRootFromParent_Done,
     /*  684770 */   // Label 10859: @684770
     /*  684770 */   GIM_Try, /*On fail goto*//*Label 10860*/ GIMT_Encode4(684845), // Rule ID 10709 //
     /*  684775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  684786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  684789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  684792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684821 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  684821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  684824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684843 */     GIR_RootConstrainSelectedInstOperands,
     /*  684844 */     // GIR_Coverage, 10709,
     /*  684844 */     GIR_EraseRootFromParent_Done,
     /*  684845 */   // Label 10860: @684845
     /*  684845 */   GIM_Try, /*On fail goto*//*Label 10861*/ GIMT_Encode4(684920), // Rule ID 10712 //
     /*  684850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  684861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  684864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  684867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  684870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  684899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684918 */     GIR_RootConstrainSelectedInstOperands,
     /*  684919 */     // GIR_Coverage, 10712,
     /*  684919 */     GIR_EraseRootFromParent_Done,
     /*  684920 */   // Label 10861: @684920
     /*  684920 */   GIM_Try, /*On fail goto*//*Label 10862*/ GIMT_Encode4(684995), // Rule ID 10713 //
     /*  684925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  684936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  684939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  684942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684971 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  684974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684993 */     GIR_RootConstrainSelectedInstOperands,
     /*  684994 */     // GIR_Coverage, 10713,
     /*  684994 */     GIR_EraseRootFromParent_Done,
     /*  684995 */   // Label 10862: @684995
     /*  684995 */   GIM_Try, /*On fail goto*//*Label 10863*/ GIMT_Encode4(685070), // Rule ID 10716 //
     /*  685000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  685011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  685014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  685017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685046 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  685049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685068 */     GIR_RootConstrainSelectedInstOperands,
     /*  685069 */     // GIR_Coverage, 10716,
     /*  685069 */     GIR_EraseRootFromParent_Done,
     /*  685070 */   // Label 10863: @685070
     /*  685070 */   GIM_Try, /*On fail goto*//*Label 10864*/ GIMT_Encode4(685145), // Rule ID 10717 //
     /*  685075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  685086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  685089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  685092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685121 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  685124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685143 */     GIR_RootConstrainSelectedInstOperands,
     /*  685144 */     // GIR_Coverage, 10717,
     /*  685144 */     GIR_EraseRootFromParent_Done,
     /*  685145 */   // Label 10864: @685145
     /*  685145 */   GIM_Try, /*On fail goto*//*Label 10865*/ GIMT_Encode4(685220), // Rule ID 10720 //
     /*  685150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  685161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  685164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  685167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  685196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  685199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685218 */     GIR_RootConstrainSelectedInstOperands,
     /*  685219 */     // GIR_Coverage, 10720,
     /*  685219 */     GIR_EraseRootFromParent_Done,
     /*  685220 */   // Label 10865: @685220
     /*  685220 */   GIM_Try, /*On fail goto*//*Label 10866*/ GIMT_Encode4(685295), // Rule ID 10721 //
     /*  685225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  685236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  685239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  685242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685271 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  685271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  685274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685293 */     GIR_RootConstrainSelectedInstOperands,
     /*  685294 */     // GIR_Coverage, 10721,
     /*  685294 */     GIR_EraseRootFromParent_Done,
     /*  685295 */   // Label 10866: @685295
     /*  685295 */   GIM_Try, /*On fail goto*//*Label 10867*/ GIMT_Encode4(685370), // Rule ID 10724 //
     /*  685300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  685303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  685311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  685314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  685317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685346 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  685346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  685349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685368 */     GIR_RootConstrainSelectedInstOperands,
     /*  685369 */     // GIR_Coverage, 10724,
     /*  685369 */     GIR_EraseRootFromParent_Done,
     /*  685370 */   // Label 10867: @685370
     /*  685370 */   GIM_Try, /*On fail goto*//*Label 10868*/ GIMT_Encode4(685445), // Rule ID 10725 //
     /*  685375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  685378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  685386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  685389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  685392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685421 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  685421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  685424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685443 */     GIR_RootConstrainSelectedInstOperands,
     /*  685444 */     // GIR_Coverage, 10725,
     /*  685444 */     GIR_EraseRootFromParent_Done,
     /*  685445 */   // Label 10868: @685445
     /*  685445 */   GIM_Try, /*On fail goto*//*Label 10869*/ GIMT_Encode4(685520), // Rule ID 10728 //
     /*  685450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  685461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  685464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  685467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685496 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  685499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685518 */     GIR_RootConstrainSelectedInstOperands,
     /*  685519 */     // GIR_Coverage, 10728,
     /*  685519 */     GIR_EraseRootFromParent_Done,
     /*  685520 */   // Label 10869: @685520
     /*  685520 */   GIM_Try, /*On fail goto*//*Label 10870*/ GIMT_Encode4(685595), // Rule ID 10729 //
     /*  685525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  685536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  685539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  685542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685571 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  685574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685593 */     GIR_RootConstrainSelectedInstOperands,
     /*  685594 */     // GIR_Coverage, 10729,
     /*  685594 */     GIR_EraseRootFromParent_Done,
     /*  685595 */   // Label 10870: @685595
     /*  685595 */   GIM_Try, /*On fail goto*//*Label 10871*/ GIMT_Encode4(685670), // Rule ID 10732 //
     /*  685600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  685611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  685614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  685617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685646 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  685649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685668 */     GIR_RootConstrainSelectedInstOperands,
     /*  685669 */     // GIR_Coverage, 10732,
     /*  685669 */     GIR_EraseRootFromParent_Done,
     /*  685670 */   // Label 10871: @685670
     /*  685670 */   GIM_Try, /*On fail goto*//*Label 10872*/ GIMT_Encode4(685745), // Rule ID 10733 //
     /*  685675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  685686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  685689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  685692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685721 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  685724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685743 */     GIR_RootConstrainSelectedInstOperands,
     /*  685744 */     // GIR_Coverage, 10733,
     /*  685744 */     GIR_EraseRootFromParent_Done,
     /*  685745 */   // Label 10872: @685745
     /*  685745 */   GIM_Try, /*On fail goto*//*Label 10873*/ GIMT_Encode4(685820), // Rule ID 10736 //
     /*  685750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  685761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  685764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  685767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685796 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  685799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685818 */     GIR_RootConstrainSelectedInstOperands,
     /*  685819 */     // GIR_Coverage, 10736,
     /*  685819 */     GIR_EraseRootFromParent_Done,
     /*  685820 */   // Label 10873: @685820
     /*  685820 */   GIM_Try, /*On fail goto*//*Label 10874*/ GIMT_Encode4(685895), // Rule ID 10737 //
     /*  685825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  685836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  685839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  685842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685871 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  685874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685893 */     GIR_RootConstrainSelectedInstOperands,
     /*  685894 */     // GIR_Coverage, 10737,
     /*  685894 */     GIR_EraseRootFromParent_Done,
     /*  685895 */   // Label 10874: @685895
     /*  685895 */   GIM_Try, /*On fail goto*//*Label 10875*/ GIMT_Encode4(685970), // Rule ID 10740 //
     /*  685900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  685911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  685914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  685917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685946 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  685949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685968 */     GIR_RootConstrainSelectedInstOperands,
     /*  685969 */     // GIR_Coverage, 10740,
     /*  685969 */     GIR_EraseRootFromParent_Done,
     /*  685970 */   // Label 10875: @685970
     /*  685970 */   GIM_Try, /*On fail goto*//*Label 10876*/ GIMT_Encode4(686045), // Rule ID 10741 //
     /*  685975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  685986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  685989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  685992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686021 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  686024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686043 */     GIR_RootConstrainSelectedInstOperands,
     /*  686044 */     // GIR_Coverage, 10741,
     /*  686044 */     GIR_EraseRootFromParent_Done,
     /*  686045 */   // Label 10876: @686045
     /*  686045 */   GIM_Try, /*On fail goto*//*Label 10877*/ GIMT_Encode4(686120), // Rule ID 10744 //
     /*  686050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  686061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  686064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  686067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686096 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  686096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  686099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686118 */     GIR_RootConstrainSelectedInstOperands,
     /*  686119 */     // GIR_Coverage, 10744,
     /*  686119 */     GIR_EraseRootFromParent_Done,
     /*  686120 */   // Label 10877: @686120
     /*  686120 */   GIM_Try, /*On fail goto*//*Label 10878*/ GIMT_Encode4(686195), // Rule ID 10745 //
     /*  686125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  686136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  686139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  686142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686171 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  686174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686193 */     GIR_RootConstrainSelectedInstOperands,
     /*  686194 */     // GIR_Coverage, 10745,
     /*  686194 */     GIR_EraseRootFromParent_Done,
     /*  686195 */   // Label 10878: @686195
     /*  686195 */   GIM_Try, /*On fail goto*//*Label 10879*/ GIMT_Encode4(686270), // Rule ID 10748 //
     /*  686200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  686211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  686214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  686217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686246 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  686246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  686249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686268 */     GIR_RootConstrainSelectedInstOperands,
     /*  686269 */     // GIR_Coverage, 10748,
     /*  686269 */     GIR_EraseRootFromParent_Done,
     /*  686270 */   // Label 10879: @686270
     /*  686270 */   GIM_Try, /*On fail goto*//*Label 10880*/ GIMT_Encode4(686345), // Rule ID 10749 //
     /*  686275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  686286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  686289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  686292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686321 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  686324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686343 */     GIR_RootConstrainSelectedInstOperands,
     /*  686344 */     // GIR_Coverage, 10749,
     /*  686344 */     GIR_EraseRootFromParent_Done,
     /*  686345 */   // Label 10880: @686345
     /*  686345 */   GIM_Try, /*On fail goto*//*Label 10881*/ GIMT_Encode4(686420), // Rule ID 10752 //
     /*  686350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  686361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  686364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  686367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  686399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686418 */     GIR_RootConstrainSelectedInstOperands,
     /*  686419 */     // GIR_Coverage, 10752,
     /*  686419 */     GIR_EraseRootFromParent_Done,
     /*  686420 */   // Label 10881: @686420
     /*  686420 */   GIM_Try, /*On fail goto*//*Label 10882*/ GIMT_Encode4(686495), // Rule ID 10753 //
     /*  686425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  686436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  686439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  686442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  686474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686493 */     GIR_RootConstrainSelectedInstOperands,
     /*  686494 */     // GIR_Coverage, 10753,
     /*  686494 */     GIR_EraseRootFromParent_Done,
     /*  686495 */   // Label 10882: @686495
     /*  686495 */   GIM_Try, /*On fail goto*//*Label 10883*/ GIMT_Encode4(686570), // Rule ID 10756 //
     /*  686500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  686511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  686514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  686517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  686549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686568 */     GIR_RootConstrainSelectedInstOperands,
     /*  686569 */     // GIR_Coverage, 10756,
     /*  686569 */     GIR_EraseRootFromParent_Done,
     /*  686570 */   // Label 10883: @686570
     /*  686570 */   GIM_Try, /*On fail goto*//*Label 10884*/ GIMT_Encode4(686645), // Rule ID 10757 //
     /*  686575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  686586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  686589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  686592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686621 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  686624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686643 */     GIR_RootConstrainSelectedInstOperands,
     /*  686644 */     // GIR_Coverage, 10757,
     /*  686644 */     GIR_EraseRootFromParent_Done,
     /*  686645 */   // Label 10884: @686645
     /*  686645 */   GIM_Try, /*On fail goto*//*Label 10885*/ GIMT_Encode4(686720), // Rule ID 10760 //
     /*  686650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  686661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  686664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  686667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686696 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  686699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686718 */     GIR_RootConstrainSelectedInstOperands,
     /*  686719 */     // GIR_Coverage, 10760,
     /*  686719 */     GIR_EraseRootFromParent_Done,
     /*  686720 */   // Label 10885: @686720
     /*  686720 */   GIM_Try, /*On fail goto*//*Label 10886*/ GIMT_Encode4(686795), // Rule ID 10761 //
     /*  686725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  686736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  686739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  686742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686771 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  686774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686793 */     GIR_RootConstrainSelectedInstOperands,
     /*  686794 */     // GIR_Coverage, 10761,
     /*  686794 */     GIR_EraseRootFromParent_Done,
     /*  686795 */   // Label 10886: @686795
     /*  686795 */   GIM_Try, /*On fail goto*//*Label 10887*/ GIMT_Encode4(686870), // Rule ID 10764 //
     /*  686800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  686811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  686814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  686817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  686849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686868 */     GIR_RootConstrainSelectedInstOperands,
     /*  686869 */     // GIR_Coverage, 10764,
     /*  686869 */     GIR_EraseRootFromParent_Done,
     /*  686870 */   // Label 10887: @686870
     /*  686870 */   GIM_Try, /*On fail goto*//*Label 10888*/ GIMT_Encode4(686945), // Rule ID 10765 //
     /*  686875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  686878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  686886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  686889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  686892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11393:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  686921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  686924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686943 */     GIR_RootConstrainSelectedInstOperands,
     /*  686944 */     // GIR_Coverage, 10765,
     /*  686944 */     GIR_EraseRootFromParent_Done,
     /*  686945 */   // Label 10888: @686945
     /*  686945 */   GIM_Try, /*On fail goto*//*Label 10889*/ GIMT_Encode4(687020), // Rule ID 10768 //
     /*  686950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  686961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  686964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  686967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  686999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687018 */     GIR_RootConstrainSelectedInstOperands,
     /*  687019 */     // GIR_Coverage, 10768,
     /*  687019 */     GIR_EraseRootFromParent_Done,
     /*  687020 */   // Label 10889: @687020
     /*  687020 */   GIM_Try, /*On fail goto*//*Label 10890*/ GIMT_Encode4(687095), // Rule ID 10769 //
     /*  687025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  687028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  687033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  687036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  687039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  687042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687071 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11393:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  687071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  687074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687093 */     GIR_RootConstrainSelectedInstOperands,
     /*  687094 */     // GIR_Coverage, 10769,
     /*  687094 */     GIR_EraseRootFromParent_Done,
     /*  687095 */   // Label 10890: @687095
     /*  687095 */   GIM_Try, /*On fail goto*//*Label 10891*/ GIMT_Encode4(687170), // Rule ID 10772 //
     /*  687100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  687103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  687108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  687111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  687114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  687117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  687146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  687149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687168 */     GIR_RootConstrainSelectedInstOperands,
     /*  687169 */     // GIR_Coverage, 10772,
     /*  687169 */     GIR_EraseRootFromParent_Done,
     /*  687170 */   // Label 10891: @687170
     /*  687170 */   GIM_Try, /*On fail goto*//*Label 10892*/ GIMT_Encode4(687245), // Rule ID 10773 //
     /*  687175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  687178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  687183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  687186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  687189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  687192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687221 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11393:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  687221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  687224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687243 */     GIR_RootConstrainSelectedInstOperands,
     /*  687244 */     // GIR_Coverage, 10773,
     /*  687244 */     GIR_EraseRootFromParent_Done,
     /*  687245 */   // Label 10892: @687245
     /*  687245 */   GIM_Try, /*On fail goto*//*Label 10893*/ GIMT_Encode4(687320), // Rule ID 10776 //
     /*  687250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  687261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  687264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  687267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  687270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  687299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687318 */     GIR_RootConstrainSelectedInstOperands,
     /*  687319 */     // GIR_Coverage, 10776,
     /*  687319 */     GIR_EraseRootFromParent_Done,
     /*  687320 */   // Label 10893: @687320
     /*  687320 */   GIM_Try, /*On fail goto*//*Label 10894*/ GIMT_Encode4(687395), // Rule ID 10777 //
     /*  687325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  687336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  687339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  687342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  687345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687371 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  687374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687393 */     GIR_RootConstrainSelectedInstOperands,
     /*  687394 */     // GIR_Coverage, 10777,
     /*  687394 */     GIR_EraseRootFromParent_Done,
     /*  687395 */   // Label 10894: @687395
     /*  687395 */   GIM_Try, /*On fail goto*//*Label 10895*/ GIMT_Encode4(687470), // Rule ID 10780 //
     /*  687400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  687411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  687414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  687417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  687420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687446 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  687449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687468 */     GIR_RootConstrainSelectedInstOperands,
     /*  687469 */     // GIR_Coverage, 10780,
     /*  687469 */     GIR_EraseRootFromParent_Done,
     /*  687470 */   // Label 10895: @687470
     /*  687470 */   GIM_Try, /*On fail goto*//*Label 10896*/ GIMT_Encode4(687545), // Rule ID 10781 //
     /*  687475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  687486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  687489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  687492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  687495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687521 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  687524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687543 */     GIR_RootConstrainSelectedInstOperands,
     /*  687544 */     // GIR_Coverage, 10781,
     /*  687544 */     GIR_EraseRootFromParent_Done,
     /*  687545 */   // Label 10896: @687545
     /*  687545 */   GIM_Try, /*On fail goto*//*Label 10897*/ GIMT_Encode4(687620), // Rule ID 10784 //
     /*  687550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  687561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  687564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  687567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  687570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687596 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  687599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687618 */     GIR_RootConstrainSelectedInstOperands,
     /*  687619 */     // GIR_Coverage, 10784,
     /*  687619 */     GIR_EraseRootFromParent_Done,
     /*  687620 */   // Label 10897: @687620
     /*  687620 */   GIM_Try, /*On fail goto*//*Label 10898*/ GIMT_Encode4(687695), // Rule ID 10785 //
     /*  687625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  687636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  687639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  687642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  687645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687671 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  687674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687693 */     GIR_RootConstrainSelectedInstOperands,
     /*  687694 */     // GIR_Coverage, 10785,
     /*  687694 */     GIR_EraseRootFromParent_Done,
     /*  687695 */   // Label 10898: @687695
     /*  687695 */   GIM_Try, /*On fail goto*//*Label 10899*/ GIMT_Encode4(687770), // Rule ID 10788 //
     /*  687700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  687711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  687714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  687717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  687720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  687749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687768 */     GIR_RootConstrainSelectedInstOperands,
     /*  687769 */     // GIR_Coverage, 10788,
     /*  687769 */     GIR_EraseRootFromParent_Done,
     /*  687770 */   // Label 10899: @687770
     /*  687770 */   GIM_Try, /*On fail goto*//*Label 10900*/ GIMT_Encode4(687845), // Rule ID 10789 //
     /*  687775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  687786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  687789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  687792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  687795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687821 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  687824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687843 */     GIR_RootConstrainSelectedInstOperands,
     /*  687844 */     // GIR_Coverage, 10789,
     /*  687844 */     GIR_EraseRootFromParent_Done,
     /*  687845 */   // Label 10900: @687845
     /*  687845 */   GIM_Try, /*On fail goto*//*Label 10901*/ GIMT_Encode4(687920), // Rule ID 10792 //
     /*  687850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  687861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  687864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  687867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  687870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  687899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687918 */     GIR_RootConstrainSelectedInstOperands,
     /*  687919 */     // GIR_Coverage, 10792,
     /*  687919 */     GIR_EraseRootFromParent_Done,
     /*  687920 */   // Label 10901: @687920
     /*  687920 */   GIM_Try, /*On fail goto*//*Label 10902*/ GIMT_Encode4(687995), // Rule ID 10793 //
     /*  687925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  687936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  687939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  687942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  687945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687971 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  687974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687993 */     GIR_RootConstrainSelectedInstOperands,
     /*  687994 */     // GIR_Coverage, 10793,
     /*  687994 */     GIR_EraseRootFromParent_Done,
     /*  687995 */   // Label 10902: @687995
     /*  687995 */   GIM_Try, /*On fail goto*//*Label 10903*/ GIMT_Encode4(688070), // Rule ID 10796 //
     /*  688000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  688011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  688014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  688017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  688020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  688046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  688049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688068 */     GIR_RootConstrainSelectedInstOperands,
     /*  688069 */     // GIR_Coverage, 10796,
     /*  688069 */     GIR_EraseRootFromParent_Done,
     /*  688070 */   // Label 10903: @688070
     /*  688070 */   GIM_Try, /*On fail goto*//*Label 10904*/ GIMT_Encode4(688145), // Rule ID 10797 //
     /*  688075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  688086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  688089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  688092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  688095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688121 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  688124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688143 */     GIR_RootConstrainSelectedInstOperands,
     /*  688144 */     // GIR_Coverage, 10797,
     /*  688144 */     GIR_EraseRootFromParent_Done,
     /*  688145 */   // Label 10904: @688145
     /*  688145 */   GIM_Try, /*On fail goto*//*Label 10905*/ GIMT_Encode4(688220), // Rule ID 10800 //
     /*  688150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  688161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  688164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  688167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  688170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688218 */     GIR_RootConstrainSelectedInstOperands,
     /*  688219 */     // GIR_Coverage, 10800,
     /*  688219 */     GIR_EraseRootFromParent_Done,
     /*  688220 */   // Label 10905: @688220
     /*  688220 */   GIM_Try, /*On fail goto*//*Label 10906*/ GIMT_Encode4(688295), // Rule ID 10801 //
     /*  688225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  688236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  688239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  688242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  688245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688271 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688293 */     GIR_RootConstrainSelectedInstOperands,
     /*  688294 */     // GIR_Coverage, 10801,
     /*  688294 */     GIR_EraseRootFromParent_Done,
     /*  688295 */   // Label 10906: @688295
     /*  688295 */   GIM_Try, /*On fail goto*//*Label 10907*/ GIMT_Encode4(688370), // Rule ID 10804 //
     /*  688300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  688311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  688314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  688317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  688320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688346 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688368 */     GIR_RootConstrainSelectedInstOperands,
     /*  688369 */     // GIR_Coverage, 10804,
     /*  688369 */     GIR_EraseRootFromParent_Done,
     /*  688370 */   // Label 10907: @688370
     /*  688370 */   GIM_Try, /*On fail goto*//*Label 10908*/ GIMT_Encode4(688445), // Rule ID 10805 //
     /*  688375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  688386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  688389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  688392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  688395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688421 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688443 */     GIR_RootConstrainSelectedInstOperands,
     /*  688444 */     // GIR_Coverage, 10805,
     /*  688444 */     GIR_EraseRootFromParent_Done,
     /*  688445 */   // Label 10908: @688445
     /*  688445 */   GIM_Try, /*On fail goto*//*Label 10909*/ GIMT_Encode4(688520), // Rule ID 10808 //
     /*  688450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  688461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  688464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  688467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  688470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  688496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688518 */     GIR_RootConstrainSelectedInstOperands,
     /*  688519 */     // GIR_Coverage, 10808,
     /*  688519 */     GIR_EraseRootFromParent_Done,
     /*  688520 */   // Label 10909: @688520
     /*  688520 */   GIM_Try, /*On fail goto*//*Label 10910*/ GIMT_Encode4(688595), // Rule ID 10809 //
     /*  688525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  688536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  688539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  688542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  688545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688571 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688593 */     GIR_RootConstrainSelectedInstOperands,
     /*  688594 */     // GIR_Coverage, 10809,
     /*  688594 */     GIR_EraseRootFromParent_Done,
     /*  688595 */   // Label 10910: @688595
     /*  688595 */   GIM_Try, /*On fail goto*//*Label 10911*/ GIMT_Encode4(688670), // Rule ID 10812 //
     /*  688600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  688603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  688611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  688614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  688617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  688620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688646 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  688646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  688665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688668 */     GIR_RootConstrainSelectedInstOperands,
     /*  688669 */     // GIR_Coverage, 10812,
     /*  688669 */     GIR_EraseRootFromParent_Done,
     /*  688670 */   // Label 10911: @688670
     /*  688670 */   GIM_Try, /*On fail goto*//*Label 10912*/ GIMT_Encode4(688745), // Rule ID 10813 //
     /*  688675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  688678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  688686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  688689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  688692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  688695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688721 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  688721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  688740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688743 */     GIR_RootConstrainSelectedInstOperands,
     /*  688744 */     // GIR_Coverage, 10813,
     /*  688744 */     GIR_EraseRootFromParent_Done,
     /*  688745 */   // Label 10912: @688745
     /*  688745 */   GIM_Try, /*On fail goto*//*Label 10913*/ GIMT_Encode4(688820), // Rule ID 10816 //
     /*  688750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  688761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  688764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  688767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  688770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  688799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688818 */     GIR_RootConstrainSelectedInstOperands,
     /*  688819 */     // GIR_Coverage, 10816,
     /*  688819 */     GIR_EraseRootFromParent_Done,
     /*  688820 */   // Label 10913: @688820
     /*  688820 */   GIM_Try, /*On fail goto*//*Label 10914*/ GIMT_Encode4(688895), // Rule ID 10817 //
     /*  688825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  688836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  688839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  688842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  688845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688871 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  688874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688893 */     GIR_RootConstrainSelectedInstOperands,
     /*  688894 */     // GIR_Coverage, 10817,
     /*  688894 */     GIR_EraseRootFromParent_Done,
     /*  688895 */   // Label 10914: @688895
     /*  688895 */   GIM_Try, /*On fail goto*//*Label 10915*/ GIMT_Encode4(688970), // Rule ID 10820 //
     /*  688900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  688911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  688914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  688917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  688920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688946 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  688949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688968 */     GIR_RootConstrainSelectedInstOperands,
     /*  688969 */     // GIR_Coverage, 10820,
     /*  688969 */     GIR_EraseRootFromParent_Done,
     /*  688970 */   // Label 10915: @688970
     /*  688970 */   GIM_Try, /*On fail goto*//*Label 10916*/ GIMT_Encode4(689045), // Rule ID 10821 //
     /*  688975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  688986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  688989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  688992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  688995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689021 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  689021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  689024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689043 */     GIR_RootConstrainSelectedInstOperands,
     /*  689044 */     // GIR_Coverage, 10821,
     /*  689044 */     GIR_EraseRootFromParent_Done,
     /*  689045 */   // Label 10916: @689045
     /*  689045 */   GIM_Try, /*On fail goto*//*Label 10917*/ GIMT_Encode4(689120), // Rule ID 10824 //
     /*  689050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  689061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  689064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  689067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  689070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689096 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  689096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  689099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689118 */     GIR_RootConstrainSelectedInstOperands,
     /*  689119 */     // GIR_Coverage, 10824,
     /*  689119 */     GIR_EraseRootFromParent_Done,
     /*  689120 */   // Label 10917: @689120
     /*  689120 */   GIM_Try, /*On fail goto*//*Label 10918*/ GIMT_Encode4(689195), // Rule ID 10825 //
     /*  689125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  689136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  689139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  689142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  689145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689171 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  689171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  689174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689193 */     GIR_RootConstrainSelectedInstOperands,
     /*  689194 */     // GIR_Coverage, 10825,
     /*  689194 */     GIR_EraseRootFromParent_Done,
     /*  689195 */   // Label 10918: @689195
     /*  689195 */   GIM_Try, /*On fail goto*//*Label 10919*/ GIMT_Encode4(689270), // Rule ID 10828 //
     /*  689200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  689211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  689214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  689217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  689220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  689249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689268 */     GIR_RootConstrainSelectedInstOperands,
     /*  689269 */     // GIR_Coverage, 10828,
     /*  689269 */     GIR_EraseRootFromParent_Done,
     /*  689270 */   // Label 10919: @689270
     /*  689270 */   GIM_Try, /*On fail goto*//*Label 10920*/ GIMT_Encode4(689345), // Rule ID 10829 //
     /*  689275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  689286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  689289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  689292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  689295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  689324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689343 */     GIR_RootConstrainSelectedInstOperands,
     /*  689344 */     // GIR_Coverage, 10829,
     /*  689344 */     GIR_EraseRootFromParent_Done,
     /*  689345 */   // Label 10920: @689345
     /*  689345 */   GIM_Try, /*On fail goto*//*Label 10921*/ GIMT_Encode4(689420), // Rule ID 10832 //
     /*  689350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  689361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  689364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  689367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  689370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  689399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689418 */     GIR_RootConstrainSelectedInstOperands,
     /*  689419 */     // GIR_Coverage, 10832,
     /*  689419 */     GIR_EraseRootFromParent_Done,
     /*  689420 */   // Label 10921: @689420
     /*  689420 */   GIM_Try, /*On fail goto*//*Label 10922*/ GIMT_Encode4(689495), // Rule ID 10833 //
     /*  689425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  689436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  689439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  689442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  689445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689471 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  689474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689493 */     GIR_RootConstrainSelectedInstOperands,
     /*  689494 */     // GIR_Coverage, 10833,
     /*  689494 */     GIR_EraseRootFromParent_Done,
     /*  689495 */   // Label 10922: @689495
     /*  689495 */   GIM_Try, /*On fail goto*//*Label 10923*/ GIMT_Encode4(689570), // Rule ID 10836 //
     /*  689500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  689511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  689514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  689517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  689520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  689549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689568 */     GIR_RootConstrainSelectedInstOperands,
     /*  689569 */     // GIR_Coverage, 10836,
     /*  689569 */     GIR_EraseRootFromParent_Done,
     /*  689570 */   // Label 10923: @689570
     /*  689570 */   GIM_Try, /*On fail goto*//*Label 10924*/ GIMT_Encode4(689645), // Rule ID 10837 //
     /*  689575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  689586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  689589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  689592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  689595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689621 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  689624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689643 */     GIR_RootConstrainSelectedInstOperands,
     /*  689644 */     // GIR_Coverage, 10837,
     /*  689644 */     GIR_EraseRootFromParent_Done,
     /*  689645 */   // Label 10924: @689645
     /*  689645 */   GIM_Try, /*On fail goto*//*Label 10925*/ GIMT_Encode4(689720), // Rule ID 10840 //
     /*  689650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  689661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  689664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  689667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  689670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  689699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689718 */     GIR_RootConstrainSelectedInstOperands,
     /*  689719 */     // GIR_Coverage, 10840,
     /*  689719 */     GIR_EraseRootFromParent_Done,
     /*  689720 */   // Label 10925: @689720
     /*  689720 */   GIM_Try, /*On fail goto*//*Label 10926*/ GIMT_Encode4(689795), // Rule ID 10841 //
     /*  689725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  689736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  689739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  689742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  689745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  689774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689793 */     GIR_RootConstrainSelectedInstOperands,
     /*  689794 */     // GIR_Coverage, 10841,
     /*  689794 */     GIR_EraseRootFromParent_Done,
     /*  689795 */   // Label 10926: @689795
     /*  689795 */   GIM_Try, /*On fail goto*//*Label 10927*/ GIMT_Encode4(689870), // Rule ID 10844 //
     /*  689800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  689811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  689814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  689817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  689820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  689849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689868 */     GIR_RootConstrainSelectedInstOperands,
     /*  689869 */     // GIR_Coverage, 10844,
     /*  689869 */     GIR_EraseRootFromParent_Done,
     /*  689870 */   // Label 10927: @689870
     /*  689870 */   GIM_Try, /*On fail goto*//*Label 10928*/ GIMT_Encode4(689945), // Rule ID 10845 //
     /*  689875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  689886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  689889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  689892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  689895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689921 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  689924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689943 */     GIR_RootConstrainSelectedInstOperands,
     /*  689944 */     // GIR_Coverage, 10845,
     /*  689944 */     GIR_EraseRootFromParent_Done,
     /*  689945 */   // Label 10928: @689945
     /*  689945 */   GIM_Try, /*On fail goto*//*Label 10929*/ GIMT_Encode4(690020), // Rule ID 10848 //
     /*  689950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  689961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  689964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  689967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  689970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689996 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  689999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690018 */     GIR_RootConstrainSelectedInstOperands,
     /*  690019 */     // GIR_Coverage, 10848,
     /*  690019 */     GIR_EraseRootFromParent_Done,
     /*  690020 */   // Label 10929: @690020
     /*  690020 */   GIM_Try, /*On fail goto*//*Label 10930*/ GIMT_Encode4(690095), // Rule ID 10849 //
     /*  690025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  690036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  690039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  690042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  690045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690071 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  690071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  690074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690093 */     GIR_RootConstrainSelectedInstOperands,
     /*  690094 */     // GIR_Coverage, 10849,
     /*  690094 */     GIR_EraseRootFromParent_Done,
     /*  690095 */   // Label 10930: @690095
     /*  690095 */   GIM_Try, /*On fail goto*//*Label 10931*/ GIMT_Encode4(690170), // Rule ID 10852 //
     /*  690100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  690103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  690111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  690114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  690117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  690120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690146 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  690149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690168 */     GIR_RootConstrainSelectedInstOperands,
     /*  690169 */     // GIR_Coverage, 10852,
     /*  690169 */     GIR_EraseRootFromParent_Done,
     /*  690170 */   // Label 10931: @690170
     /*  690170 */   GIM_Try, /*On fail goto*//*Label 10932*/ GIMT_Encode4(690245), // Rule ID 10853 //
     /*  690175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  690178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  690186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  690189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  690192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  690195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690221 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  690224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690243 */     GIR_RootConstrainSelectedInstOperands,
     /*  690244 */     // GIR_Coverage, 10853,
     /*  690244 */     GIR_EraseRootFromParent_Done,
     /*  690245 */   // Label 10932: @690245
     /*  690245 */   GIM_Try, /*On fail goto*//*Label 10933*/ GIMT_Encode4(690320), // Rule ID 10856 //
     /*  690250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  690253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  690261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  690264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  690267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  690270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  690299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690318 */     GIR_RootConstrainSelectedInstOperands,
     /*  690319 */     // GIR_Coverage, 10856,
     /*  690319 */     GIR_EraseRootFromParent_Done,
     /*  690320 */   // Label 10933: @690320
     /*  690320 */   GIM_Try, /*On fail goto*//*Label 10934*/ GIMT_Encode4(690395), // Rule ID 10857 //
     /*  690325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  690328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  690336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  690339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  690342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  690345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690371 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  690374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690393 */     GIR_RootConstrainSelectedInstOperands,
     /*  690394 */     // GIR_Coverage, 10857,
     /*  690394 */     GIR_EraseRootFromParent_Done,
     /*  690395 */   // Label 10934: @690395
     /*  690395 */   GIM_Try, /*On fail goto*//*Label 10935*/ GIMT_Encode4(690470), // Rule ID 10860 //
     /*  690400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  690403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  690411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  690414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  690417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  690420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690446 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  690449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690468 */     GIR_RootConstrainSelectedInstOperands,
     /*  690469 */     // GIR_Coverage, 10860,
     /*  690469 */     GIR_EraseRootFromParent_Done,
     /*  690470 */   // Label 10935: @690470
     /*  690470 */   GIM_Try, /*On fail goto*//*Label 10936*/ GIMT_Encode4(690545), // Rule ID 10861 //
     /*  690475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  690478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  690486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  690489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  690492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  690495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690521 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  690524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690543 */     GIR_RootConstrainSelectedInstOperands,
     /*  690544 */     // GIR_Coverage, 10861,
     /*  690544 */     GIR_EraseRootFromParent_Done,
     /*  690545 */   // Label 10936: @690545
     /*  690545 */   GIM_Try, /*On fail goto*//*Label 10937*/ GIMT_Encode4(690620), // Rule ID 10864 //
     /*  690550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  690561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  690564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  690567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  690570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  690599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690618 */     GIR_RootConstrainSelectedInstOperands,
     /*  690619 */     // GIR_Coverage, 10864,
     /*  690619 */     GIR_EraseRootFromParent_Done,
     /*  690620 */   // Label 10937: @690620
     /*  690620 */   GIM_Try, /*On fail goto*//*Label 10938*/ GIMT_Encode4(690695), // Rule ID 10865 //
     /*  690625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  690636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  690639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  690642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  690645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690671 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  690674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690693 */     GIR_RootConstrainSelectedInstOperands,
     /*  690694 */     // GIR_Coverage, 10865,
     /*  690694 */     GIR_EraseRootFromParent_Done,
     /*  690695 */   // Label 10938: @690695
     /*  690695 */   GIM_Try, /*On fail goto*//*Label 10939*/ GIMT_Encode4(690770), // Rule ID 10868 //
     /*  690700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  690711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  690714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  690717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  690720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690746 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  690749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690768 */     GIR_RootConstrainSelectedInstOperands,
     /*  690769 */     // GIR_Coverage, 10868,
     /*  690769 */     GIR_EraseRootFromParent_Done,
     /*  690770 */   // Label 10939: @690770
     /*  690770 */   GIM_Try, /*On fail goto*//*Label 10940*/ GIMT_Encode4(690845), // Rule ID 10869 //
     /*  690775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  690786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  690789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  690792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  690795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690821 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  690824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690843 */     GIR_RootConstrainSelectedInstOperands,
     /*  690844 */     // GIR_Coverage, 10869,
     /*  690844 */     GIR_EraseRootFromParent_Done,
     /*  690845 */   // Label 10940: @690845
     /*  690845 */   GIM_Try, /*On fail goto*//*Label 10941*/ GIMT_Encode4(690920), // Rule ID 10872 //
     /*  690850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  690861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  690864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  690867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  690870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690896 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  690899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690918 */     GIR_RootConstrainSelectedInstOperands,
     /*  690919 */     // GIR_Coverage, 10872,
     /*  690919 */     GIR_EraseRootFromParent_Done,
     /*  690920 */   // Label 10941: @690920
     /*  690920 */   GIM_Try, /*On fail goto*//*Label 10942*/ GIMT_Encode4(690995), // Rule ID 10873 //
     /*  690925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  690936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  690939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  690942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  690945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  690974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690993 */     GIR_RootConstrainSelectedInstOperands,
     /*  690994 */     // GIR_Coverage, 10873,
     /*  690994 */     GIR_EraseRootFromParent_Done,
     /*  690995 */   // Label 10942: @690995
     /*  690995 */   GIM_Try, /*On fail goto*//*Label 10943*/ GIMT_Encode4(691070), // Rule ID 10876 //
     /*  691000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  691011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  691014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  691017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  691049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691068 */     GIR_RootConstrainSelectedInstOperands,
     /*  691069 */     // GIR_Coverage, 10876,
     /*  691069 */     GIR_EraseRootFromParent_Done,
     /*  691070 */   // Label 10943: @691070
     /*  691070 */   GIM_Try, /*On fail goto*//*Label 10944*/ GIMT_Encode4(691145), // Rule ID 10877 //
     /*  691075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  691086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  691089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  691092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691121 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  691124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691143 */     GIR_RootConstrainSelectedInstOperands,
     /*  691144 */     // GIR_Coverage, 10877,
     /*  691144 */     GIR_EraseRootFromParent_Done,
     /*  691145 */   // Label 10944: @691145
     /*  691145 */   GIM_Try, /*On fail goto*//*Label 10945*/ GIMT_Encode4(691220), // Rule ID 10880 //
     /*  691150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  691161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  691164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  691167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  691199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691218 */     GIR_RootConstrainSelectedInstOperands,
     /*  691219 */     // GIR_Coverage, 10880,
     /*  691219 */     GIR_EraseRootFromParent_Done,
     /*  691220 */   // Label 10945: @691220
     /*  691220 */   GIM_Try, /*On fail goto*//*Label 10946*/ GIMT_Encode4(691295), // Rule ID 10881 //
     /*  691225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  691236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  691239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  691242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691271 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  691274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691293 */     GIR_RootConstrainSelectedInstOperands,
     /*  691294 */     // GIR_Coverage, 10881,
     /*  691294 */     GIR_EraseRootFromParent_Done,
     /*  691295 */   // Label 10946: @691295
     /*  691295 */   GIM_Try, /*On fail goto*//*Label 10947*/ GIMT_Encode4(691370), // Rule ID 10884 //
     /*  691300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  691311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  691314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  691317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  691346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  691349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691368 */     GIR_RootConstrainSelectedInstOperands,
     /*  691369 */     // GIR_Coverage, 10884,
     /*  691369 */     GIR_EraseRootFromParent_Done,
     /*  691370 */   // Label 10947: @691370
     /*  691370 */   GIM_Try, /*On fail goto*//*Label 10948*/ GIMT_Encode4(691445), // Rule ID 10885 //
     /*  691375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  691386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  691389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  691392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  691421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  691424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691443 */     GIR_RootConstrainSelectedInstOperands,
     /*  691444 */     // GIR_Coverage, 10885,
     /*  691444 */     GIR_EraseRootFromParent_Done,
     /*  691445 */   // Label 10948: @691445
     /*  691445 */   GIM_Try, /*On fail goto*//*Label 10949*/ GIMT_Encode4(691520), // Rule ID 10888 //
     /*  691450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  691461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  691464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  691467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691496 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  691496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691518 */     GIR_RootConstrainSelectedInstOperands,
     /*  691519 */     // GIR_Coverage, 10888,
     /*  691519 */     GIR_EraseRootFromParent_Done,
     /*  691520 */   // Label 10949: @691520
     /*  691520 */   GIM_Try, /*On fail goto*//*Label 10950*/ GIMT_Encode4(691595), // Rule ID 10889 //
     /*  691525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  691536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  691539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  691542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691571 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691593 */     GIR_RootConstrainSelectedInstOperands,
     /*  691594 */     // GIR_Coverage, 10889,
     /*  691594 */     GIR_EraseRootFromParent_Done,
     /*  691595 */   // Label 10950: @691595
     /*  691595 */   GIM_Try, /*On fail goto*//*Label 10951*/ GIMT_Encode4(691670), // Rule ID 10892 //
     /*  691600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  691611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  691614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  691617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691668 */     GIR_RootConstrainSelectedInstOperands,
     /*  691669 */     // GIR_Coverage, 10892,
     /*  691669 */     GIR_EraseRootFromParent_Done,
     /*  691670 */   // Label 10951: @691670
     /*  691670 */   GIM_Try, /*On fail goto*//*Label 10952*/ GIMT_Encode4(691745), // Rule ID 10893 //
     /*  691675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  691686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  691689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  691692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691721 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691743 */     GIR_RootConstrainSelectedInstOperands,
     /*  691744 */     // GIR_Coverage, 10893,
     /*  691744 */     GIR_EraseRootFromParent_Done,
     /*  691745 */   // Label 10952: @691745
     /*  691745 */   GIM_Try, /*On fail goto*//*Label 10953*/ GIMT_Encode4(691820), // Rule ID 10896 //
     /*  691750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  691761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  691764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  691767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  691796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691818 */     GIR_RootConstrainSelectedInstOperands,
     /*  691819 */     // GIR_Coverage, 10896,
     /*  691819 */     GIR_EraseRootFromParent_Done,
     /*  691820 */   // Label 10953: @691820
     /*  691820 */   GIM_Try, /*On fail goto*//*Label 10954*/ GIMT_Encode4(691895), // Rule ID 10897 //
     /*  691825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  691836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  691839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  691842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  691871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691893 */     GIR_RootConstrainSelectedInstOperands,
     /*  691894 */     // GIR_Coverage, 10897,
     /*  691894 */     GIR_EraseRootFromParent_Done,
     /*  691895 */   // Label 10954: @691895
     /*  691895 */   GIM_Try, /*On fail goto*//*Label 10955*/ GIMT_Encode4(691970), // Rule ID 10900 //
     /*  691900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  691903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  691911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  691914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  691917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  691946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691968 */     GIR_RootConstrainSelectedInstOperands,
     /*  691969 */     // GIR_Coverage, 10900,
     /*  691969 */     GIR_EraseRootFromParent_Done,
     /*  691970 */   // Label 10955: @691970
     /*  691970 */   GIM_Try, /*On fail goto*//*Label 10956*/ GIMT_Encode4(692045), // Rule ID 10901 //
     /*  691975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  691978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  691986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  691989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  691992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692021 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  692021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  692024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  692040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692043 */     GIR_RootConstrainSelectedInstOperands,
     /*  692044 */     // GIR_Coverage, 10901,
     /*  692044 */     GIR_EraseRootFromParent_Done,
     /*  692045 */   // Label 10956: @692045
     /*  692045 */   GIM_Try, /*On fail goto*//*Label 10957*/ GIMT_Encode4(692120), // Rule ID 10904 //
     /*  692050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  692061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  692064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  692067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692096 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  692099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692118 */     GIR_RootConstrainSelectedInstOperands,
     /*  692119 */     // GIR_Coverage, 10904,
     /*  692119 */     GIR_EraseRootFromParent_Done,
     /*  692120 */   // Label 10957: @692120
     /*  692120 */   GIM_Try, /*On fail goto*//*Label 10958*/ GIMT_Encode4(692195), // Rule ID 10905 //
     /*  692125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  692136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  692139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  692142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692171 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  692171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  692174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692193 */     GIR_RootConstrainSelectedInstOperands,
     /*  692194 */     // GIR_Coverage, 10905,
     /*  692194 */     GIR_EraseRootFromParent_Done,
     /*  692195 */   // Label 10958: @692195
     /*  692195 */   GIM_Try, /*On fail goto*//*Label 10959*/ GIMT_Encode4(692270), // Rule ID 10908 //
     /*  692200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  692211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  692214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  692217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692246 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  692249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692268 */     GIR_RootConstrainSelectedInstOperands,
     /*  692269 */     // GIR_Coverage, 10908,
     /*  692269 */     GIR_EraseRootFromParent_Done,
     /*  692270 */   // Label 10959: @692270
     /*  692270 */   GIM_Try, /*On fail goto*//*Label 10960*/ GIMT_Encode4(692345), // Rule ID 10909 //
     /*  692275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  692286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  692289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  692292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692321 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  692321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  692324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692343 */     GIR_RootConstrainSelectedInstOperands,
     /*  692344 */     // GIR_Coverage, 10909,
     /*  692344 */     GIR_EraseRootFromParent_Done,
     /*  692345 */   // Label 10960: @692345
     /*  692345 */   GIM_Try, /*On fail goto*//*Label 10961*/ GIMT_Encode4(692420), // Rule ID 10912 //
     /*  692350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  692361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  692364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  692367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692396 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  692399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692418 */     GIR_RootConstrainSelectedInstOperands,
     /*  692419 */     // GIR_Coverage, 10912,
     /*  692419 */     GIR_EraseRootFromParent_Done,
     /*  692420 */   // Label 10961: @692420
     /*  692420 */   GIM_Try, /*On fail goto*//*Label 10962*/ GIMT_Encode4(692495), // Rule ID 10913 //
     /*  692425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  692436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  692439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  692442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692471 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  692471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  692474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692493 */     GIR_RootConstrainSelectedInstOperands,
     /*  692494 */     // GIR_Coverage, 10913,
     /*  692494 */     GIR_EraseRootFromParent_Done,
     /*  692495 */   // Label 10962: @692495
     /*  692495 */   GIM_Try, /*On fail goto*//*Label 10963*/ GIMT_Encode4(692570), // Rule ID 10916 //
     /*  692500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  692511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  692514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  692517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692546 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  692549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692568 */     GIR_RootConstrainSelectedInstOperands,
     /*  692569 */     // GIR_Coverage, 10916,
     /*  692569 */     GIR_EraseRootFromParent_Done,
     /*  692570 */   // Label 10963: @692570
     /*  692570 */   GIM_Try, /*On fail goto*//*Label 10964*/ GIMT_Encode4(692645), // Rule ID 10917 //
     /*  692575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  692586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  692589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  692592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  692624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692643 */     GIR_RootConstrainSelectedInstOperands,
     /*  692644 */     // GIR_Coverage, 10917,
     /*  692644 */     GIR_EraseRootFromParent_Done,
     /*  692645 */   // Label 10964: @692645
     /*  692645 */   GIM_Try, /*On fail goto*//*Label 10965*/ GIMT_Encode4(692720), // Rule ID 10920 //
     /*  692650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692696 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  692699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692718 */     GIR_RootConstrainSelectedInstOperands,
     /*  692719 */     // GIR_Coverage, 10920,
     /*  692719 */     GIR_EraseRootFromParent_Done,
     /*  692720 */   // Label 10965: @692720
     /*  692720 */   GIM_Try, /*On fail goto*//*Label 10966*/ GIMT_Encode4(692795), // Rule ID 10921 //
     /*  692725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  692774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692793 */     GIR_RootConstrainSelectedInstOperands,
     /*  692794 */     // GIR_Coverage, 10921,
     /*  692794 */     GIR_EraseRootFromParent_Done,
     /*  692795 */   // Label 10966: @692795
     /*  692795 */   GIM_Try, /*On fail goto*//*Label 10967*/ GIMT_Encode4(692870), // Rule ID 10924 //
     /*  692800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692846 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  692849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692868 */     GIR_RootConstrainSelectedInstOperands,
     /*  692869 */     // GIR_Coverage, 10924,
     /*  692869 */     GIR_EraseRootFromParent_Done,
     /*  692870 */   // Label 10967: @692870
     /*  692870 */   GIM_Try, /*On fail goto*//*Label 10968*/ GIMT_Encode4(692945), // Rule ID 10925 //
     /*  692875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692921 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  692924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692943 */     GIR_RootConstrainSelectedInstOperands,
     /*  692944 */     // GIR_Coverage, 10925,
     /*  692944 */     GIR_EraseRootFromParent_Done,
     /*  692945 */   // Label 10968: @692945
     /*  692945 */   GIM_Try, /*On fail goto*//*Label 10969*/ GIMT_Encode4(693020), // Rule ID 10928 //
     /*  692950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  692961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  692964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  692967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  692996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  692999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693018 */     GIR_RootConstrainSelectedInstOperands,
     /*  693019 */     // GIR_Coverage, 10928,
     /*  693019 */     GIR_EraseRootFromParent_Done,
     /*  693020 */   // Label 10969: @693020
     /*  693020 */   GIM_Try, /*On fail goto*//*Label 10970*/ GIMT_Encode4(693095), // Rule ID 10929 //
     /*  693025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  693036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  693039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  693042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693071 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  693074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693093 */     GIR_RootConstrainSelectedInstOperands,
     /*  693094 */     // GIR_Coverage, 10929,
     /*  693094 */     GIR_EraseRootFromParent_Done,
     /*  693095 */   // Label 10970: @693095
     /*  693095 */   GIM_Try, /*On fail goto*//*Label 10971*/ GIMT_Encode4(693170), // Rule ID 10932 //
     /*  693100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  693111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  693114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  693117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  693146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  693149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693168 */     GIR_RootConstrainSelectedInstOperands,
     /*  693169 */     // GIR_Coverage, 10932,
     /*  693169 */     GIR_EraseRootFromParent_Done,
     /*  693170 */   // Label 10971: @693170
     /*  693170 */   GIM_Try, /*On fail goto*//*Label 10972*/ GIMT_Encode4(693245), // Rule ID 10933 //
     /*  693175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  693186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  693189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  693192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693221 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  693224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693243 */     GIR_RootConstrainSelectedInstOperands,
     /*  693244 */     // GIR_Coverage, 10933,
     /*  693244 */     GIR_EraseRootFromParent_Done,
     /*  693245 */   // Label 10972: @693245
     /*  693245 */   GIM_Try, /*On fail goto*//*Label 10973*/ GIMT_Encode4(693320), // Rule ID 10936 //
     /*  693250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  693261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  693264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  693267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693296 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  693296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  693299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693318 */     GIR_RootConstrainSelectedInstOperands,
     /*  693319 */     // GIR_Coverage, 10936,
     /*  693319 */     GIR_EraseRootFromParent_Done,
     /*  693320 */   // Label 10973: @693320
     /*  693320 */   GIM_Try, /*On fail goto*//*Label 10974*/ GIMT_Encode4(693395), // Rule ID 10937 //
     /*  693325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  693336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  693339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  693342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693371 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  693374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693393 */     GIR_RootConstrainSelectedInstOperands,
     /*  693394 */     // GIR_Coverage, 10937,
     /*  693394 */     GIR_EraseRootFromParent_Done,
     /*  693395 */   // Label 10974: @693395
     /*  693395 */   GIM_Try, /*On fail goto*//*Label 10975*/ GIMT_Encode4(693470), // Rule ID 10940 //
     /*  693400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  693411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  693414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  693417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  693449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693468 */     GIR_RootConstrainSelectedInstOperands,
     /*  693469 */     // GIR_Coverage, 10940,
     /*  693469 */     GIR_EraseRootFromParent_Done,
     /*  693470 */   // Label 10975: @693470
     /*  693470 */   GIM_Try, /*On fail goto*//*Label 10976*/ GIMT_Encode4(693545), // Rule ID 10941 //
     /*  693475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  693486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  693489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  693492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11391:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  693524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693543 */     GIR_RootConstrainSelectedInstOperands,
     /*  693544 */     // GIR_Coverage, 10941,
     /*  693544 */     GIR_EraseRootFromParent_Done,
     /*  693545 */   // Label 10976: @693545
     /*  693545 */   GIM_Try, /*On fail goto*//*Label 10977*/ GIMT_Encode4(693620), // Rule ID 10944 //
     /*  693550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  693599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693618 */     GIR_RootConstrainSelectedInstOperands,
     /*  693619 */     // GIR_Coverage, 10944,
     /*  693619 */     GIR_EraseRootFromParent_Done,
     /*  693620 */   // Label 10977: @693620
     /*  693620 */   GIM_Try, /*On fail goto*//*Label 10978*/ GIMT_Encode4(693695), // Rule ID 10945 //
     /*  693625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693671 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11391:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  693674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693693 */     GIR_RootConstrainSelectedInstOperands,
     /*  693694 */     // GIR_Coverage, 10945,
     /*  693694 */     GIR_EraseRootFromParent_Done,
     /*  693695 */   // Label 10978: @693695
     /*  693695 */   GIM_Try, /*On fail goto*//*Label 10979*/ GIMT_Encode4(693770), // Rule ID 10948 //
     /*  693700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693746 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  693749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693768 */     GIR_RootConstrainSelectedInstOperands,
     /*  693769 */     // GIR_Coverage, 10948,
     /*  693769 */     GIR_EraseRootFromParent_Done,
     /*  693770 */   // Label 10979: @693770
     /*  693770 */   GIM_Try, /*On fail goto*//*Label 10980*/ GIMT_Encode4(693845), // Rule ID 10949 //
     /*  693775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693821 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11391:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  693824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693843 */     GIR_RootConstrainSelectedInstOperands,
     /*  693844 */     // GIR_Coverage, 10949,
     /*  693844 */     GIR_EraseRootFromParent_Done,
     /*  693845 */   // Label 10980: @693845
     /*  693845 */   GIM_Try, /*On fail goto*//*Label 10981*/ GIMT_Encode4(693920), // Rule ID 10952 //
     /*  693850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  693861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  693864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  693867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  693870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  693899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693918 */     GIR_RootConstrainSelectedInstOperands,
     /*  693919 */     // GIR_Coverage, 10952,
     /*  693919 */     GIR_EraseRootFromParent_Done,
     /*  693920 */   // Label 10981: @693920
     /*  693920 */   GIM_Try, /*On fail goto*//*Label 10982*/ GIMT_Encode4(693995), // Rule ID 10953 //
     /*  693925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  693936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  693939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  693942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  693945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  693971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  693974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693993 */     GIR_RootConstrainSelectedInstOperands,
     /*  693994 */     // GIR_Coverage, 10953,
     /*  693994 */     GIR_EraseRootFromParent_Done,
     /*  693995 */   // Label 10982: @693995
     /*  693995 */   GIM_Try, /*On fail goto*//*Label 10983*/ GIMT_Encode4(694070), // Rule ID 10956 //
     /*  694000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  694011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  694014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  694017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  694020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  694049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694068 */     GIR_RootConstrainSelectedInstOperands,
     /*  694069 */     // GIR_Coverage, 10956,
     /*  694069 */     GIR_EraseRootFromParent_Done,
     /*  694070 */   // Label 10983: @694070
     /*  694070 */   GIM_Try, /*On fail goto*//*Label 10984*/ GIMT_Encode4(694145), // Rule ID 10957 //
     /*  694075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  694086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  694089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  694092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  694095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694121 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  694124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694143 */     GIR_RootConstrainSelectedInstOperands,
     /*  694144 */     // GIR_Coverage, 10957,
     /*  694144 */     GIR_EraseRootFromParent_Done,
     /*  694145 */   // Label 10984: @694145
     /*  694145 */   GIM_Try, /*On fail goto*//*Label 10985*/ GIMT_Encode4(694220), // Rule ID 10960 //
     /*  694150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  694161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  694164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  694167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  694170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  694199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694218 */     GIR_RootConstrainSelectedInstOperands,
     /*  694219 */     // GIR_Coverage, 10960,
     /*  694219 */     GIR_EraseRootFromParent_Done,
     /*  694220 */   // Label 10985: @694220
     /*  694220 */   GIM_Try, /*On fail goto*//*Label 10986*/ GIMT_Encode4(694295), // Rule ID 10961 //
     /*  694225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  694236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  694239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  694242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  694245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  694274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694293 */     GIR_RootConstrainSelectedInstOperands,
     /*  694294 */     // GIR_Coverage, 10961,
     /*  694294 */     GIR_EraseRootFromParent_Done,
     /*  694295 */   // Label 10986: @694295
     /*  694295 */   GIM_Try, /*On fail goto*//*Label 10987*/ GIMT_Encode4(694370), // Rule ID 10964 //
     /*  694300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  694311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  694314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  694317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  694320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  694349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694368 */     GIR_RootConstrainSelectedInstOperands,
     /*  694369 */     // GIR_Coverage, 10964,
     /*  694369 */     GIR_EraseRootFromParent_Done,
     /*  694370 */   // Label 10987: @694370
     /*  694370 */   GIM_Try, /*On fail goto*//*Label 10988*/ GIMT_Encode4(694445), // Rule ID 10965 //
     /*  694375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  694386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  694389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  694392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  694395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694421 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  694424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694443 */     GIR_RootConstrainSelectedInstOperands,
     /*  694444 */     // GIR_Coverage, 10965,
     /*  694444 */     GIR_EraseRootFromParent_Done,
     /*  694445 */   // Label 10988: @694445
     /*  694445 */   GIM_Try, /*On fail goto*//*Label 10989*/ GIMT_Encode4(694520), // Rule ID 10968 //
     /*  694450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  694461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  694464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  694467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  694470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  694499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694518 */     GIR_RootConstrainSelectedInstOperands,
     /*  694519 */     // GIR_Coverage, 10968,
     /*  694519 */     GIR_EraseRootFromParent_Done,
     /*  694520 */   // Label 10989: @694520
     /*  694520 */   GIM_Try, /*On fail goto*//*Label 10990*/ GIMT_Encode4(694595), // Rule ID 10969 //
     /*  694525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  694536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  694539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  694542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  694545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694571 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  694574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694593 */     GIR_RootConstrainSelectedInstOperands,
     /*  694594 */     // GIR_Coverage, 10969,
     /*  694594 */     GIR_EraseRootFromParent_Done,
     /*  694595 */   // Label 10990: @694595
     /*  694595 */   GIM_Try, /*On fail goto*//*Label 10991*/ GIMT_Encode4(694670), // Rule ID 10972 //
     /*  694600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  694620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  694646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  694649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694668 */     GIR_RootConstrainSelectedInstOperands,
     /*  694669 */     // GIR_Coverage, 10972,
     /*  694669 */     GIR_EraseRootFromParent_Done,
     /*  694670 */   // Label 10991: @694670
     /*  694670 */   GIM_Try, /*On fail goto*//*Label 10992*/ GIMT_Encode4(694745), // Rule ID 10973 //
     /*  694675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  694695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  694721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  694724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694743 */     GIR_RootConstrainSelectedInstOperands,
     /*  694744 */     // GIR_Coverage, 10973,
     /*  694744 */     GIR_EraseRootFromParent_Done,
     /*  694745 */   // Label 10992: @694745
     /*  694745 */   GIM_Try, /*On fail goto*//*Label 10993*/ GIMT_Encode4(694820), // Rule ID 10976 //
     /*  694750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  694761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  694764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  694767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  694770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  694799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694818 */     GIR_RootConstrainSelectedInstOperands,
     /*  694819 */     // GIR_Coverage, 10976,
     /*  694819 */     GIR_EraseRootFromParent_Done,
     /*  694820 */   // Label 10993: @694820
     /*  694820 */   GIM_Try, /*On fail goto*//*Label 10994*/ GIMT_Encode4(694895), // Rule ID 10977 //
     /*  694825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  694836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  694839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  694842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  694845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694871 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  694874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694893 */     GIR_RootConstrainSelectedInstOperands,
     /*  694894 */     // GIR_Coverage, 10977,
     /*  694894 */     GIR_EraseRootFromParent_Done,
     /*  694895 */   // Label 10994: @694895
     /*  694895 */   GIM_Try, /*On fail goto*//*Label 10995*/ GIMT_Encode4(694970), // Rule ID 10980 //
     /*  694900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  694920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  694949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694968 */     GIR_RootConstrainSelectedInstOperands,
     /*  694969 */     // GIR_Coverage, 10980,
     /*  694969 */     GIR_EraseRootFromParent_Done,
     /*  694970 */   // Label 10995: @694970
     /*  694970 */   GIM_Try, /*On fail goto*//*Label 10996*/ GIMT_Encode4(695045), // Rule ID 10981 //
     /*  694975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  694995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695021 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  695024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695043 */     GIR_RootConstrainSelectedInstOperands,
     /*  695044 */     // GIR_Coverage, 10981,
     /*  695044 */     GIR_EraseRootFromParent_Done,
     /*  695045 */   // Label 10996: @695045
     /*  695045 */   GIM_Try, /*On fail goto*//*Label 10997*/ GIMT_Encode4(695120), // Rule ID 10984 //
     /*  695050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  695061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  695064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  695067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  695070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  695099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695118 */     GIR_RootConstrainSelectedInstOperands,
     /*  695119 */     // GIR_Coverage, 10984,
     /*  695119 */     GIR_EraseRootFromParent_Done,
     /*  695120 */   // Label 10997: @695120
     /*  695120 */   GIM_Try, /*On fail goto*//*Label 10998*/ GIMT_Encode4(695195), // Rule ID 10985 //
     /*  695125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  695136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  695139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  695142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  695145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  695174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695193 */     GIR_RootConstrainSelectedInstOperands,
     /*  695194 */     // GIR_Coverage, 10985,
     /*  695194 */     GIR_EraseRootFromParent_Done,
     /*  695195 */   // Label 10998: @695195
     /*  695195 */   GIM_Try, /*On fail goto*//*Label 10999*/ GIMT_Encode4(695270), // Rule ID 10988 //
     /*  695200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  695203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  695211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  695214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  695217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  695220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  695246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  695249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695268 */     GIR_RootConstrainSelectedInstOperands,
     /*  695269 */     // GIR_Coverage, 10988,
     /*  695269 */     GIR_EraseRootFromParent_Done,
     /*  695270 */   // Label 10999: @695270
     /*  695270 */   GIM_Try, /*On fail goto*//*Label 11000*/ GIMT_Encode4(695345), // Rule ID 10989 //
     /*  695275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  695278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  695286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  695289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  695292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  695295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695321 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  695321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  695324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695343 */     GIR_RootConstrainSelectedInstOperands,
     /*  695344 */     // GIR_Coverage, 10989,
     /*  695344 */     GIR_EraseRootFromParent_Done,
     /*  695345 */   // Label 11000: @695345
     /*  695345 */   GIM_Try, /*On fail goto*//*Label 11001*/ GIMT_Encode4(695420), // Rule ID 10992 //
     /*  695350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  695361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  695364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  695367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  695370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  695399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695418 */     GIR_RootConstrainSelectedInstOperands,
     /*  695419 */     // GIR_Coverage, 10992,
     /*  695419 */     GIR_EraseRootFromParent_Done,
     /*  695420 */   // Label 11001: @695420
     /*  695420 */   GIM_Try, /*On fail goto*//*Label 11002*/ GIMT_Encode4(695495), // Rule ID 10993 //
     /*  695425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  695436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  695439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  695442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  695445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  695474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695493 */     GIR_RootConstrainSelectedInstOperands,
     /*  695494 */     // GIR_Coverage, 10993,
     /*  695494 */     GIR_EraseRootFromParent_Done,
     /*  695495 */   // Label 11002: @695495
     /*  695495 */   GIM_Try, /*On fail goto*//*Label 11003*/ GIMT_Encode4(695570), // Rule ID 10996 //
     /*  695500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  695511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  695514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  695517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  695520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  695549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695568 */     GIR_RootConstrainSelectedInstOperands,
     /*  695569 */     // GIR_Coverage, 10996,
     /*  695569 */     GIR_EraseRootFromParent_Done,
     /*  695570 */   // Label 11003: @695570
     /*  695570 */   GIM_Try, /*On fail goto*//*Label 11004*/ GIMT_Encode4(695645), // Rule ID 10997 //
     /*  695575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  695586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  695589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  695592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  695595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695621 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  695624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695643 */     GIR_RootConstrainSelectedInstOperands,
     /*  695644 */     // GIR_Coverage, 10997,
     /*  695644 */     GIR_EraseRootFromParent_Done,
     /*  695645 */   // Label 11004: @695645
     /*  695645 */   GIM_Try, /*On fail goto*//*Label 11005*/ GIMT_Encode4(695720), // Rule ID 11000 //
     /*  695650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  695661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  695664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  695667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  695670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695696 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  695699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695718 */     GIR_RootConstrainSelectedInstOperands,
     /*  695719 */     // GIR_Coverage, 11000,
     /*  695719 */     GIR_EraseRootFromParent_Done,
     /*  695720 */   // Label 11005: @695720
     /*  695720 */   GIM_Try, /*On fail goto*//*Label 11006*/ GIMT_Encode4(695795), // Rule ID 11001 //
     /*  695725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  695736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  695739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  695742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  695745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695771 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  695774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695793 */     GIR_RootConstrainSelectedInstOperands,
     /*  695794 */     // GIR_Coverage, 11001,
     /*  695794 */     GIR_EraseRootFromParent_Done,
     /*  695795 */   // Label 11006: @695795
     /*  695795 */   GIM_Try, /*On fail goto*//*Label 11007*/ GIMT_Encode4(695870), // Rule ID 11004 //
     /*  695800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  695811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  695814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  695817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  695820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  695849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695868 */     GIR_RootConstrainSelectedInstOperands,
     /*  695869 */     // GIR_Coverage, 11004,
     /*  695869 */     GIR_EraseRootFromParent_Done,
     /*  695870 */   // Label 11007: @695870
     /*  695870 */   GIM_Try, /*On fail goto*//*Label 11008*/ GIMT_Encode4(695945), // Rule ID 11005 //
     /*  695875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  695886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  695889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  695892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  695895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  695924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695943 */     GIR_RootConstrainSelectedInstOperands,
     /*  695944 */     // GIR_Coverage, 11005,
     /*  695944 */     GIR_EraseRootFromParent_Done,
     /*  695945 */   // Label 11008: @695945
     /*  695945 */   GIM_Try, /*On fail goto*//*Label 11009*/ GIMT_Encode4(696020), // Rule ID 11008 //
     /*  695950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  695961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  695964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  695967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  695970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  695999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696018 */     GIR_RootConstrainSelectedInstOperands,
     /*  696019 */     // GIR_Coverage, 11008,
     /*  696019 */     GIR_EraseRootFromParent_Done,
     /*  696020 */   // Label 11009: @696020
     /*  696020 */   GIM_Try, /*On fail goto*//*Label 11010*/ GIMT_Encode4(696095), // Rule ID 11009 //
     /*  696025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  696036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  696039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  696042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  696045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  696071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  696074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696093 */     GIR_RootConstrainSelectedInstOperands,
     /*  696094 */     // GIR_Coverage, 11009,
     /*  696094 */     GIR_EraseRootFromParent_Done,
     /*  696095 */   // Label 11010: @696095
     /*  696095 */   GIM_Try, /*On fail goto*//*Label 11011*/ GIMT_Encode4(696170), // Rule ID 11012 //
     /*  696100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  696111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  696114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  696117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  696120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  696146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  696149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696168 */     GIR_RootConstrainSelectedInstOperands,
     /*  696169 */     // GIR_Coverage, 11012,
     /*  696169 */     GIR_EraseRootFromParent_Done,
     /*  696170 */   // Label 11011: @696170
     /*  696170 */   GIM_Try, /*On fail goto*//*Label 11012*/ GIMT_Encode4(696245), // Rule ID 11013 //
     /*  696175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  696186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  696189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  696192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  696195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696221 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  696221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  696224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696243 */     GIR_RootConstrainSelectedInstOperands,
     /*  696244 */     // GIR_Coverage, 11013,
     /*  696244 */     GIR_EraseRootFromParent_Done,
     /*  696245 */   // Label 11012: @696245
     /*  696245 */   GIM_Try, /*On fail goto*//*Label 11013*/ GIMT_Encode4(696320), // Rule ID 11016 //
     /*  696250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  696261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  696264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  696267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  696270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  696299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696318 */     GIR_RootConstrainSelectedInstOperands,
     /*  696319 */     // GIR_Coverage, 11016,
     /*  696319 */     GIR_EraseRootFromParent_Done,
     /*  696320 */   // Label 11013: @696320
     /*  696320 */   GIM_Try, /*On fail goto*//*Label 11014*/ GIMT_Encode4(696395), // Rule ID 11017 //
     /*  696325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  696336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  696339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  696342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  696345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  696374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696393 */     GIR_RootConstrainSelectedInstOperands,
     /*  696394 */     // GIR_Coverage, 11017,
     /*  696394 */     GIR_EraseRootFromParent_Done,
     /*  696395 */   // Label 11014: @696395
     /*  696395 */   GIM_Try, /*On fail goto*//*Label 11015*/ GIMT_Encode4(696470), // Rule ID 11020 //
     /*  696400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  696411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  696414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  696417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  696420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  696449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696468 */     GIR_RootConstrainSelectedInstOperands,
     /*  696469 */     // GIR_Coverage, 11020,
     /*  696469 */     GIR_EraseRootFromParent_Done,
     /*  696470 */   // Label 11015: @696470
     /*  696470 */   GIM_Try, /*On fail goto*//*Label 11016*/ GIMT_Encode4(696545), // Rule ID 11021 //
     /*  696475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  696486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  696489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  696492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  696495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  696524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696543 */     GIR_RootConstrainSelectedInstOperands,
     /*  696544 */     // GIR_Coverage, 11021,
     /*  696544 */     GIR_EraseRootFromParent_Done,
     /*  696545 */   // Label 11016: @696545
     /*  696545 */   GIM_Try, /*On fail goto*//*Label 11017*/ GIMT_Encode4(696620), // Rule ID 11024 //
     /*  696550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  696561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  696564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  696567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  696570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  696599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696618 */     GIR_RootConstrainSelectedInstOperands,
     /*  696619 */     // GIR_Coverage, 11024,
     /*  696619 */     GIR_EraseRootFromParent_Done,
     /*  696620 */   // Label 11017: @696620
     /*  696620 */   GIM_Try, /*On fail goto*//*Label 11018*/ GIMT_Encode4(696695), // Rule ID 11025 //
     /*  696625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  696636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  696639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  696642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  696645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696671 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  696674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696693 */     GIR_RootConstrainSelectedInstOperands,
     /*  696694 */     // GIR_Coverage, 11025,
     /*  696694 */     GIR_EraseRootFromParent_Done,
     /*  696695 */   // Label 11018: @696695
     /*  696695 */   GIM_Try, /*On fail goto*//*Label 11019*/ GIMT_Encode4(696770), // Rule ID 11028 //
     /*  696700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  696711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  696714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  696717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  696720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  696749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696768 */     GIR_RootConstrainSelectedInstOperands,
     /*  696769 */     // GIR_Coverage, 11028,
     /*  696769 */     GIR_EraseRootFromParent_Done,
     /*  696770 */   // Label 11019: @696770
     /*  696770 */   GIM_Try, /*On fail goto*//*Label 11020*/ GIMT_Encode4(696845), // Rule ID 11029 //
     /*  696775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  696786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  696789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  696792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  696795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  696824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696843 */     GIR_RootConstrainSelectedInstOperands,
     /*  696844 */     // GIR_Coverage, 11029,
     /*  696844 */     GIR_EraseRootFromParent_Done,
     /*  696845 */   // Label 11020: @696845
     /*  696845 */   GIM_Try, /*On fail goto*//*Label 11021*/ GIMT_Encode4(696920), // Rule ID 11032 //
     /*  696850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  696861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  696864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  696867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  696870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  696899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696918 */     GIR_RootConstrainSelectedInstOperands,
     /*  696919 */     // GIR_Coverage, 11032,
     /*  696919 */     GIR_EraseRootFromParent_Done,
     /*  696920 */   // Label 11021: @696920
     /*  696920 */   GIM_Try, /*On fail goto*//*Label 11022*/ GIMT_Encode4(696995), // Rule ID 11033 //
     /*  696925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  696936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  696939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  696942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  696945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  696974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696993 */     GIR_RootConstrainSelectedInstOperands,
     /*  696994 */     // GIR_Coverage, 11033,
     /*  696994 */     GIR_EraseRootFromParent_Done,
     /*  696995 */   // Label 11022: @696995
     /*  696995 */   GIM_Try, /*On fail goto*//*Label 11023*/ GIMT_Encode4(697070), // Rule ID 11036 //
     /*  697000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  697003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  697011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  697014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  697017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  697020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  697046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  697049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  697065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697068 */     GIR_RootConstrainSelectedInstOperands,
     /*  697069 */     // GIR_Coverage, 11036,
     /*  697069 */     GIR_EraseRootFromParent_Done,
     /*  697070 */   // Label 11023: @697070
     /*  697070 */   GIM_Try, /*On fail goto*//*Label 11024*/ GIMT_Encode4(697145), // Rule ID 11037 //
     /*  697075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  697078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  697086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  697089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  697092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  697095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697121 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  697121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  697124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  697140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697143 */     GIR_RootConstrainSelectedInstOperands,
     /*  697144 */     // GIR_Coverage, 11037,
     /*  697144 */     GIR_EraseRootFromParent_Done,
     /*  697145 */   // Label 11024: @697145
     /*  697145 */   GIM_Try, /*On fail goto*//*Label 11025*/ GIMT_Encode4(697220), // Rule ID 11040 //
     /*  697150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  697161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  697164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  697167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  697170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  697199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697218 */     GIR_RootConstrainSelectedInstOperands,
     /*  697219 */     // GIR_Coverage, 11040,
     /*  697219 */     GIR_EraseRootFromParent_Done,
     /*  697220 */   // Label 11025: @697220
     /*  697220 */   GIM_Try, /*On fail goto*//*Label 11026*/ GIMT_Encode4(697295), // Rule ID 11041 //
     /*  697225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  697236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  697239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  697242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697271 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  697274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697293 */     GIR_RootConstrainSelectedInstOperands,
     /*  697294 */     // GIR_Coverage, 11041,
     /*  697294 */     GIR_EraseRootFromParent_Done,
     /*  697295 */   // Label 11026: @697295
     /*  697295 */   GIM_Try, /*On fail goto*//*Label 11027*/ GIMT_Encode4(697370), // Rule ID 11044 //
     /*  697300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  697311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  697314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  697317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  697320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  697349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697368 */     GIR_RootConstrainSelectedInstOperands,
     /*  697369 */     // GIR_Coverage, 11044,
     /*  697369 */     GIR_EraseRootFromParent_Done,
     /*  697370 */   // Label 11027: @697370
     /*  697370 */   GIM_Try, /*On fail goto*//*Label 11028*/ GIMT_Encode4(697445), // Rule ID 11045 //
     /*  697375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  697386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  697389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  697392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697421 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  697424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697443 */     GIR_RootConstrainSelectedInstOperands,
     /*  697444 */     // GIR_Coverage, 11045,
     /*  697444 */     GIR_EraseRootFromParent_Done,
     /*  697445 */   // Label 11028: @697445
     /*  697445 */   GIM_Try, /*On fail goto*//*Label 11029*/ GIMT_Encode4(697520), // Rule ID 11048 //
     /*  697450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  697461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  697464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  697467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  697470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  697499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697518 */     GIR_RootConstrainSelectedInstOperands,
     /*  697519 */     // GIR_Coverage, 11048,
     /*  697519 */     GIR_EraseRootFromParent_Done,
     /*  697520 */   // Label 11029: @697520
     /*  697520 */   GIM_Try, /*On fail goto*//*Label 11030*/ GIMT_Encode4(697595), // Rule ID 11049 //
     /*  697525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  697536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  697539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  697542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697571 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  697574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697593 */     GIR_RootConstrainSelectedInstOperands,
     /*  697594 */     // GIR_Coverage, 11049,
     /*  697594 */     GIR_EraseRootFromParent_Done,
     /*  697595 */   // Label 11030: @697595
     /*  697595 */   GIM_Try, /*On fail goto*//*Label 11031*/ GIMT_Encode4(697670), // Rule ID 11052 //
     /*  697600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  697611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  697614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  697617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  697620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  697649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697668 */     GIR_RootConstrainSelectedInstOperands,
     /*  697669 */     // GIR_Coverage, 11052,
     /*  697669 */     GIR_EraseRootFromParent_Done,
     /*  697670 */   // Label 11031: @697670
     /*  697670 */   GIM_Try, /*On fail goto*//*Label 11032*/ GIMT_Encode4(697745), // Rule ID 11053 //
     /*  697675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  697686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  697689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  697692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697721 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  697724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697743 */     GIR_RootConstrainSelectedInstOperands,
     /*  697744 */     // GIR_Coverage, 11053,
     /*  697744 */     GIR_EraseRootFromParent_Done,
     /*  697745 */   // Label 11032: @697745
     /*  697745 */   GIM_Try, /*On fail goto*//*Label 11033*/ GIMT_Encode4(697820), // Rule ID 11056 //
     /*  697750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  697761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  697764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  697767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  697770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  697799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697818 */     GIR_RootConstrainSelectedInstOperands,
     /*  697819 */     // GIR_Coverage, 11056,
     /*  697819 */     GIR_EraseRootFromParent_Done,
     /*  697820 */   // Label 11033: @697820
     /*  697820 */   GIM_Try, /*On fail goto*//*Label 11034*/ GIMT_Encode4(697895), // Rule ID 11057 //
     /*  697825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  697836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  697839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  697842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  697874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697893 */     GIR_RootConstrainSelectedInstOperands,
     /*  697894 */     // GIR_Coverage, 11057,
     /*  697894 */     GIR_EraseRootFromParent_Done,
     /*  697895 */   // Label 11034: @697895
     /*  697895 */   GIM_Try, /*On fail goto*//*Label 11035*/ GIMT_Encode4(697970), // Rule ID 11060 //
     /*  697900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  697911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  697914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  697917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  697920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  697946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  697949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697968 */     GIR_RootConstrainSelectedInstOperands,
     /*  697969 */     // GIR_Coverage, 11060,
     /*  697969 */     GIR_EraseRootFromParent_Done,
     /*  697970 */   // Label 11035: @697970
     /*  697970 */   GIM_Try, /*On fail goto*//*Label 11036*/ GIMT_Encode4(698045), // Rule ID 11061 //
     /*  697975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  697986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  697989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  697992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698021 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  698021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  698024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698043 */     GIR_RootConstrainSelectedInstOperands,
     /*  698044 */     // GIR_Coverage, 11061,
     /*  698044 */     GIR_EraseRootFromParent_Done,
     /*  698045 */   // Label 11036: @698045
     /*  698045 */   GIM_Try, /*On fail goto*//*Label 11037*/ GIMT_Encode4(698120), // Rule ID 11064 //
     /*  698050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  698061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  698064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  698067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698118 */     GIR_RootConstrainSelectedInstOperands,
     /*  698119 */     // GIR_Coverage, 11064,
     /*  698119 */     GIR_EraseRootFromParent_Done,
     /*  698120 */   // Label 11037: @698120
     /*  698120 */   GIM_Try, /*On fail goto*//*Label 11038*/ GIMT_Encode4(698195), // Rule ID 11065 //
     /*  698125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  698136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  698139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  698142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  698145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698171 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698193 */     GIR_RootConstrainSelectedInstOperands,
     /*  698194 */     // GIR_Coverage, 11065,
     /*  698194 */     GIR_EraseRootFromParent_Done,
     /*  698195 */   // Label 11038: @698195
     /*  698195 */   GIM_Try, /*On fail goto*//*Label 11039*/ GIMT_Encode4(698270), // Rule ID 11068 //
     /*  698200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  698211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  698214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  698217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698268 */     GIR_RootConstrainSelectedInstOperands,
     /*  698269 */     // GIR_Coverage, 11068,
     /*  698269 */     GIR_EraseRootFromParent_Done,
     /*  698270 */   // Label 11039: @698270
     /*  698270 */   GIM_Try, /*On fail goto*//*Label 11040*/ GIMT_Encode4(698345), // Rule ID 11069 //
     /*  698275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  698286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  698289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  698292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  698295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698343 */     GIR_RootConstrainSelectedInstOperands,
     /*  698344 */     // GIR_Coverage, 11069,
     /*  698344 */     GIR_EraseRootFromParent_Done,
     /*  698345 */   // Label 11040: @698345
     /*  698345 */   GIM_Try, /*On fail goto*//*Label 11041*/ GIMT_Encode4(698420), // Rule ID 11072 //
     /*  698350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  698361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  698364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  698367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  698396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698418 */     GIR_RootConstrainSelectedInstOperands,
     /*  698419 */     // GIR_Coverage, 11072,
     /*  698419 */     GIR_EraseRootFromParent_Done,
     /*  698420 */   // Label 11041: @698420
     /*  698420 */   GIM_Try, /*On fail goto*//*Label 11042*/ GIMT_Encode4(698495), // Rule ID 11073 //
     /*  698425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  698436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  698439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  698442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  698445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  698471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698493 */     GIR_RootConstrainSelectedInstOperands,
     /*  698494 */     // GIR_Coverage, 11073,
     /*  698494 */     GIR_EraseRootFromParent_Done,
     /*  698495 */   // Label 11042: @698495
     /*  698495 */   GIM_Try, /*On fail goto*//*Label 11043*/ GIMT_Encode4(698570), // Rule ID 11076 //
     /*  698500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  698503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  698511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  698514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  698517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698546 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  698546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  698565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698568 */     GIR_RootConstrainSelectedInstOperands,
     /*  698569 */     // GIR_Coverage, 11076,
     /*  698569 */     GIR_EraseRootFromParent_Done,
     /*  698570 */   // Label 11043: @698570
     /*  698570 */   GIM_Try, /*On fail goto*//*Label 11044*/ GIMT_Encode4(698645), // Rule ID 11077 //
     /*  698575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  698578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  698586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  698589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  698592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  698595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698621 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  698621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  698640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698643 */     GIR_RootConstrainSelectedInstOperands,
     /*  698644 */     // GIR_Coverage, 11077,
     /*  698644 */     GIR_EraseRootFromParent_Done,
     /*  698645 */   // Label 11044: @698645
     /*  698645 */   GIM_Try, /*On fail goto*//*Label 11045*/ GIMT_Encode4(698720), // Rule ID 11080 //
     /*  698650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  698661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  698664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  698667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  698699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698718 */     GIR_RootConstrainSelectedInstOperands,
     /*  698719 */     // GIR_Coverage, 11080,
     /*  698719 */     GIR_EraseRootFromParent_Done,
     /*  698720 */   // Label 11045: @698720
     /*  698720 */   GIM_Try, /*On fail goto*//*Label 11046*/ GIMT_Encode4(698795), // Rule ID 11081 //
     /*  698725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  698736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  698739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  698742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  698745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698771 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  698774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698793 */     GIR_RootConstrainSelectedInstOperands,
     /*  698794 */     // GIR_Coverage, 11081,
     /*  698794 */     GIR_EraseRootFromParent_Done,
     /*  698795 */   // Label 11046: @698795
     /*  698795 */   GIM_Try, /*On fail goto*//*Label 11047*/ GIMT_Encode4(698870), // Rule ID 11084 //
     /*  698800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  698811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  698814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  698817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  698849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698868 */     GIR_RootConstrainSelectedInstOperands,
     /*  698869 */     // GIR_Coverage, 11084,
     /*  698869 */     GIR_EraseRootFromParent_Done,
     /*  698870 */   // Label 11047: @698870
     /*  698870 */   GIM_Try, /*On fail goto*//*Label 11048*/ GIMT_Encode4(698945), // Rule ID 11085 //
     /*  698875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  698886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  698889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  698892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  698895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  698924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698943 */     GIR_RootConstrainSelectedInstOperands,
     /*  698944 */     // GIR_Coverage, 11085,
     /*  698944 */     GIR_EraseRootFromParent_Done,
     /*  698945 */   // Label 11048: @698945
     /*  698945 */   GIM_Try, /*On fail goto*//*Label 11049*/ GIMT_Encode4(699020), // Rule ID 11088 //
     /*  698950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  698961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  698964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  698967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698996 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  698999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699018 */     GIR_RootConstrainSelectedInstOperands,
     /*  699019 */     // GIR_Coverage, 11088,
     /*  699019 */     GIR_EraseRootFromParent_Done,
     /*  699020 */   // Label 11049: @699020
     /*  699020 */   GIM_Try, /*On fail goto*//*Label 11050*/ GIMT_Encode4(699095), // Rule ID 11089 //
     /*  699025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  699036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  699039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  699042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699071 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  699071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  699074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699093 */     GIR_RootConstrainSelectedInstOperands,
     /*  699094 */     // GIR_Coverage, 11089,
     /*  699094 */     GIR_EraseRootFromParent_Done,
     /*  699095 */   // Label 11050: @699095
     /*  699095 */   GIM_Try, /*On fail goto*//*Label 11051*/ GIMT_Encode4(699170), // Rule ID 11092 //
     /*  699100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  699111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  699114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  699117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  699149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699168 */     GIR_RootConstrainSelectedInstOperands,
     /*  699169 */     // GIR_Coverage, 11092,
     /*  699169 */     GIR_EraseRootFromParent_Done,
     /*  699170 */   // Label 11051: @699170
     /*  699170 */   GIM_Try, /*On fail goto*//*Label 11052*/ GIMT_Encode4(699245), // Rule ID 11093 //
     /*  699175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  699186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  699189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  699192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  699224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699243 */     GIR_RootConstrainSelectedInstOperands,
     /*  699244 */     // GIR_Coverage, 11093,
     /*  699244 */     GIR_EraseRootFromParent_Done,
     /*  699245 */   // Label 11052: @699245
     /*  699245 */   GIM_Try, /*On fail goto*//*Label 11053*/ GIMT_Encode4(699320), // Rule ID 11096 //
     /*  699250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  699261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  699264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  699267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  699299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699318 */     GIR_RootConstrainSelectedInstOperands,
     /*  699319 */     // GIR_Coverage, 11096,
     /*  699319 */     GIR_EraseRootFromParent_Done,
     /*  699320 */   // Label 11053: @699320
     /*  699320 */   GIM_Try, /*On fail goto*//*Label 11054*/ GIMT_Encode4(699395), // Rule ID 11097 //
     /*  699325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  699336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  699339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  699342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699371 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  699374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699393 */     GIR_RootConstrainSelectedInstOperands,
     /*  699394 */     // GIR_Coverage, 11097,
     /*  699394 */     GIR_EraseRootFromParent_Done,
     /*  699395 */   // Label 11054: @699395
     /*  699395 */   GIM_Try, /*On fail goto*//*Label 11055*/ GIMT_Encode4(699470), // Rule ID 11100 //
     /*  699400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  699411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  699414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  699417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  699449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699468 */     GIR_RootConstrainSelectedInstOperands,
     /*  699469 */     // GIR_Coverage, 11100,
     /*  699469 */     GIR_EraseRootFromParent_Done,
     /*  699470 */   // Label 11055: @699470
     /*  699470 */   GIM_Try, /*On fail goto*//*Label 11056*/ GIMT_Encode4(699545), // Rule ID 11101 //
     /*  699475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  699486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  699489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  699492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  699524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699543 */     GIR_RootConstrainSelectedInstOperands,
     /*  699544 */     // GIR_Coverage, 11101,
     /*  699544 */     GIR_EraseRootFromParent_Done,
     /*  699545 */   // Label 11056: @699545
     /*  699545 */   GIM_Try, /*On fail goto*//*Label 11057*/ GIMT_Encode4(699620), // Rule ID 11104 //
     /*  699550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  699561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  699564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  699567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  699599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699618 */     GIR_RootConstrainSelectedInstOperands,
     /*  699619 */     // GIR_Coverage, 11104,
     /*  699619 */     GIR_EraseRootFromParent_Done,
     /*  699620 */   // Label 11057: @699620
     /*  699620 */   GIM_Try, /*On fail goto*//*Label 11058*/ GIMT_Encode4(699695), // Rule ID 11105 //
     /*  699625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  699636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  699639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  699642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699671 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  699674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699693 */     GIR_RootConstrainSelectedInstOperands,
     /*  699694 */     // GIR_Coverage, 11105,
     /*  699694 */     GIR_EraseRootFromParent_Done,
     /*  699695 */   // Label 11058: @699695
     /*  699695 */   GIM_Try, /*On fail goto*//*Label 11059*/ GIMT_Encode4(699770), // Rule ID 11108 //
     /*  699700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  699749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699768 */     GIR_RootConstrainSelectedInstOperands,
     /*  699769 */     // GIR_Coverage, 11108,
     /*  699769 */     GIR_EraseRootFromParent_Done,
     /*  699770 */   // Label 11059: @699770
     /*  699770 */   GIM_Try, /*On fail goto*//*Label 11060*/ GIMT_Encode4(699845), // Rule ID 11109 //
     /*  699775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699821 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  699824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699843 */     GIR_RootConstrainSelectedInstOperands,
     /*  699844 */     // GIR_Coverage, 11109,
     /*  699844 */     GIR_EraseRootFromParent_Done,
     /*  699845 */   // Label 11060: @699845
     /*  699845 */   GIM_Try, /*On fail goto*//*Label 11061*/ GIMT_Encode4(699920), // Rule ID 11112 //
     /*  699850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  699861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  699864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  699867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699896 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  699899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699918 */     GIR_RootConstrainSelectedInstOperands,
     /*  699919 */     // GIR_Coverage, 11112,
     /*  699919 */     GIR_EraseRootFromParent_Done,
     /*  699920 */   // Label 11061: @699920
     /*  699920 */   GIM_Try, /*On fail goto*//*Label 11062*/ GIMT_Encode4(699995), // Rule ID 11113 //
     /*  699925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  699936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  699939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  699942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699971 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  699974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699993 */     GIR_RootConstrainSelectedInstOperands,
     /*  699994 */     // GIR_Coverage, 11113,
     /*  699994 */     GIR_EraseRootFromParent_Done,
     /*  699995 */   // Label 11062: @699995
     /*  699995 */   GIM_Try, /*On fail goto*//*Label 11063*/ GIMT_Encode4(700070), // Rule ID 11116 //
     /*  700000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  700003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  700008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  700011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  700014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  700017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  700046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  700049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700068 */     GIR_RootConstrainSelectedInstOperands,
     /*  700069 */     // GIR_Coverage, 11116,
     /*  700069 */     GIR_EraseRootFromParent_Done,
     /*  700070 */   // Label 11063: @700070
     /*  700070 */   GIM_Try, /*On fail goto*//*Label 11064*/ GIMT_Encode4(700145), // Rule ID 11117 //
     /*  700075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  700078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  700083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  700086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  700089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  700092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  700121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  700124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700143 */     GIR_RootConstrainSelectedInstOperands,
     /*  700144 */     // GIR_Coverage, 11117,
     /*  700144 */     GIR_EraseRootFromParent_Done,
     /*  700145 */   // Label 11064: @700145
     /*  700145 */   GIM_Try, /*On fail goto*//*Label 11065*/ GIMT_Encode4(700220), // Rule ID 11120 //
     /*  700150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  700153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  700158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  700161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  700164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  700167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  700196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  700199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700218 */     GIR_RootConstrainSelectedInstOperands,
     /*  700219 */     // GIR_Coverage, 11120,
     /*  700219 */     GIR_EraseRootFromParent_Done,
     /*  700220 */   // Label 11065: @700220
     /*  700220 */   GIM_Try, /*On fail goto*//*Label 11066*/ GIMT_Encode4(700295), // Rule ID 11121 //
     /*  700225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  700228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  700233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  700236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  700239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  700242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  700271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  700274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700293 */     GIR_RootConstrainSelectedInstOperands,
     /*  700294 */     // GIR_Coverage, 11121,
     /*  700294 */     GIR_EraseRootFromParent_Done,
     /*  700295 */   // Label 11066: @700295
     /*  700295 */   GIM_Try, /*On fail goto*//*Label 11067*/ GIMT_Encode4(700370), // Rule ID 11124 //
     /*  700300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  700303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  700308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  700311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  700314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  700317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  700346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  700349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700368 */     GIR_RootConstrainSelectedInstOperands,
     /*  700369 */     // GIR_Coverage, 11124,
     /*  700369 */     GIR_EraseRootFromParent_Done,
     /*  700370 */   // Label 11067: @700370
     /*  700370 */   GIM_Try, /*On fail goto*//*Label 11068*/ GIMT_Encode4(700445), // Rule ID 11125 //
     /*  700375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  700378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  700383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  700386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  700389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  700392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700421 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  700421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  700424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700443 */     GIR_RootConstrainSelectedInstOperands,
     /*  700444 */     // GIR_Coverage, 11125,
     /*  700444 */     GIR_EraseRootFromParent_Done,
     /*  700445 */   // Label 11068: @700445
     /*  700445 */   GIM_Try, /*On fail goto*//*Label 11069*/ GIMT_Encode4(700520), // Rule ID 11128 //
     /*  700450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  700461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  700464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  700467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  700470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  700499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700518 */     GIR_RootConstrainSelectedInstOperands,
     /*  700519 */     // GIR_Coverage, 11128,
     /*  700519 */     GIR_EraseRootFromParent_Done,
     /*  700520 */   // Label 11069: @700520
     /*  700520 */   GIM_Try, /*On fail goto*//*Label 11070*/ GIMT_Encode4(700595), // Rule ID 11129 //
     /*  700525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  700536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  700539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  700542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  700545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700571 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  700574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700593 */     GIR_RootConstrainSelectedInstOperands,
     /*  700594 */     // GIR_Coverage, 11129,
     /*  700594 */     GIR_EraseRootFromParent_Done,
     /*  700595 */   // Label 11070: @700595
     /*  700595 */   GIM_Try, /*On fail goto*//*Label 11071*/ GIMT_Encode4(700670), // Rule ID 11132 //
     /*  700600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  700611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  700614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  700617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  700620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700646 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  700649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700668 */     GIR_RootConstrainSelectedInstOperands,
     /*  700669 */     // GIR_Coverage, 11132,
     /*  700669 */     GIR_EraseRootFromParent_Done,
     /*  700670 */   // Label 11071: @700670
     /*  700670 */   GIM_Try, /*On fail goto*//*Label 11072*/ GIMT_Encode4(700745), // Rule ID 11133 //
     /*  700675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  700686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  700689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  700692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  700695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700721 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  700724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700743 */     GIR_RootConstrainSelectedInstOperands,
     /*  700744 */     // GIR_Coverage, 11133,
     /*  700744 */     GIR_EraseRootFromParent_Done,
     /*  700745 */   // Label 11072: @700745
     /*  700745 */   GIM_Try, /*On fail goto*//*Label 11073*/ GIMT_Encode4(700820), // Rule ID 11136 //
     /*  700750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  700761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  700764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  700767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  700770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  700799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700818 */     GIR_RootConstrainSelectedInstOperands,
     /*  700819 */     // GIR_Coverage, 11136,
     /*  700819 */     GIR_EraseRootFromParent_Done,
     /*  700820 */   // Label 11073: @700820
     /*  700820 */   GIM_Try, /*On fail goto*//*Label 11074*/ GIMT_Encode4(700895), // Rule ID 11137 //
     /*  700825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  700836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  700839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  700842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  700845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700871 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  700874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700893 */     GIR_RootConstrainSelectedInstOperands,
     /*  700894 */     // GIR_Coverage, 11137,
     /*  700894 */     GIR_EraseRootFromParent_Done,
     /*  700895 */   // Label 11074: @700895
     /*  700895 */   GIM_Try, /*On fail goto*//*Label 11075*/ GIMT_Encode4(700970), // Rule ID 11140 //
     /*  700900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  700911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  700914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  700917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  700920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  700949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700968 */     GIR_RootConstrainSelectedInstOperands,
     /*  700969 */     // GIR_Coverage, 11140,
     /*  700969 */     GIR_EraseRootFromParent_Done,
     /*  700970 */   // Label 11075: @700970
     /*  700970 */   GIM_Try, /*On fail goto*//*Label 11076*/ GIMT_Encode4(701045), // Rule ID 11141 //
     /*  700975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  700986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  700989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  700992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  700995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701021 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  701024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701043 */     GIR_RootConstrainSelectedInstOperands,
     /*  701044 */     // GIR_Coverage, 11141,
     /*  701044 */     GIR_EraseRootFromParent_Done,
     /*  701045 */   // Label 11076: @701045
     /*  701045 */   GIM_Try, /*On fail goto*//*Label 11077*/ GIMT_Encode4(701120), // Rule ID 11144 //
     /*  701050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  701061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  701064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  701067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  701070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  701099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701118 */     GIR_RootConstrainSelectedInstOperands,
     /*  701119 */     // GIR_Coverage, 11144,
     /*  701119 */     GIR_EraseRootFromParent_Done,
     /*  701120 */   // Label 11077: @701120
     /*  701120 */   GIM_Try, /*On fail goto*//*Label 11078*/ GIMT_Encode4(701195), // Rule ID 11145 //
     /*  701125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  701136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  701139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  701142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  701145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  701174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701193 */     GIR_RootConstrainSelectedInstOperands,
     /*  701194 */     // GIR_Coverage, 11145,
     /*  701194 */     GIR_EraseRootFromParent_Done,
     /*  701195 */   // Label 11078: @701195
     /*  701195 */   GIM_Try, /*On fail goto*//*Label 11079*/ GIMT_Encode4(701270), // Rule ID 11148 //
     /*  701200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  701211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  701214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  701217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  701220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  701249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701268 */     GIR_RootConstrainSelectedInstOperands,
     /*  701269 */     // GIR_Coverage, 11148,
     /*  701269 */     GIR_EraseRootFromParent_Done,
     /*  701270 */   // Label 11079: @701270
     /*  701270 */   GIM_Try, /*On fail goto*//*Label 11080*/ GIMT_Encode4(701345), // Rule ID 11149 //
     /*  701275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  701286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  701289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  701292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  701295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701321 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  701324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701343 */     GIR_RootConstrainSelectedInstOperands,
     /*  701344 */     // GIR_Coverage, 11149,
     /*  701344 */     GIR_EraseRootFromParent_Done,
     /*  701345 */   // Label 11080: @701345
     /*  701345 */   GIM_Try, /*On fail goto*//*Label 11081*/ GIMT_Encode4(701420), // Rule ID 11152 //
     /*  701350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  701361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  701364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  701367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  701370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  701399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701418 */     GIR_RootConstrainSelectedInstOperands,
     /*  701419 */     // GIR_Coverage, 11152,
     /*  701419 */     GIR_EraseRootFromParent_Done,
     /*  701420 */   // Label 11081: @701420
     /*  701420 */   GIM_Try, /*On fail goto*//*Label 11082*/ GIMT_Encode4(701495), // Rule ID 11153 //
     /*  701425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  701436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  701439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  701442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  701445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701471 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  701474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701493 */     GIR_RootConstrainSelectedInstOperands,
     /*  701494 */     // GIR_Coverage, 11153,
     /*  701494 */     GIR_EraseRootFromParent_Done,
     /*  701495 */   // Label 11082: @701495
     /*  701495 */   GIM_Try, /*On fail goto*//*Label 11083*/ GIMT_Encode4(701570), // Rule ID 11156 //
     /*  701500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  701511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  701514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  701517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  701520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  701549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701568 */     GIR_RootConstrainSelectedInstOperands,
     /*  701569 */     // GIR_Coverage, 11156,
     /*  701569 */     GIR_EraseRootFromParent_Done,
     /*  701570 */   // Label 11083: @701570
     /*  701570 */   GIM_Try, /*On fail goto*//*Label 11084*/ GIMT_Encode4(701645), // Rule ID 11157 //
     /*  701575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  701586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  701589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  701592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  701595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  701624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701643 */     GIR_RootConstrainSelectedInstOperands,
     /*  701644 */     // GIR_Coverage, 11157,
     /*  701644 */     GIR_EraseRootFromParent_Done,
     /*  701645 */   // Label 11084: @701645
     /*  701645 */   GIM_Try, /*On fail goto*//*Label 11085*/ GIMT_Encode4(701720), // Rule ID 11160 //
     /*  701650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  701661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  701664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  701667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  701670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  701699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701718 */     GIR_RootConstrainSelectedInstOperands,
     /*  701719 */     // GIR_Coverage, 11160,
     /*  701719 */     GIR_EraseRootFromParent_Done,
     /*  701720 */   // Label 11085: @701720
     /*  701720 */   GIM_Try, /*On fail goto*//*Label 11086*/ GIMT_Encode4(701795), // Rule ID 11161 //
     /*  701725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  701736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  701739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  701742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  701745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701771 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  701774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701793 */     GIR_RootConstrainSelectedInstOperands,
     /*  701794 */     // GIR_Coverage, 11161,
     /*  701794 */     GIR_EraseRootFromParent_Done,
     /*  701795 */   // Label 11086: @701795
     /*  701795 */   GIM_Try, /*On fail goto*//*Label 11087*/ GIMT_Encode4(701870), // Rule ID 11164 //
     /*  701800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  701811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  701814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  701817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  701820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701846 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  701849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701868 */     GIR_RootConstrainSelectedInstOperands,
     /*  701869 */     // GIR_Coverage, 11164,
     /*  701869 */     GIR_EraseRootFromParent_Done,
     /*  701870 */   // Label 11087: @701870
     /*  701870 */   GIM_Try, /*On fail goto*//*Label 11088*/ GIMT_Encode4(701945), // Rule ID 11165 //
     /*  701875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  701886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  701889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  701892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  701895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701921 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  701924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701943 */     GIR_RootConstrainSelectedInstOperands,
     /*  701944 */     // GIR_Coverage, 11165,
     /*  701944 */     GIR_EraseRootFromParent_Done,
     /*  701945 */   // Label 11088: @701945
     /*  701945 */   GIM_Try, /*On fail goto*//*Label 11089*/ GIMT_Encode4(702020), // Rule ID 11168 //
     /*  701950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  701961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  701964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  701967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  701970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701996 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  701999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702018 */     GIR_RootConstrainSelectedInstOperands,
     /*  702019 */     // GIR_Coverage, 11168,
     /*  702019 */     GIR_EraseRootFromParent_Done,
     /*  702020 */   // Label 11089: @702020
     /*  702020 */   GIM_Try, /*On fail goto*//*Label 11090*/ GIMT_Encode4(702095), // Rule ID 11169 //
     /*  702025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  702036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  702039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  702042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  702045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702071 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  702074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702093 */     GIR_RootConstrainSelectedInstOperands,
     /*  702094 */     // GIR_Coverage, 11169,
     /*  702094 */     GIR_EraseRootFromParent_Done,
     /*  702095 */   // Label 11090: @702095
     /*  702095 */   GIM_Try, /*On fail goto*//*Label 11091*/ GIMT_Encode4(702170), // Rule ID 11172 //
     /*  702100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  702111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  702114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  702117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  702120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702146 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  702149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702168 */     GIR_RootConstrainSelectedInstOperands,
     /*  702169 */     // GIR_Coverage, 11172,
     /*  702169 */     GIR_EraseRootFromParent_Done,
     /*  702170 */   // Label 11091: @702170
     /*  702170 */   GIM_Try, /*On fail goto*//*Label 11092*/ GIMT_Encode4(702245), // Rule ID 11173 //
     /*  702175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  702186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  702189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  702192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  702195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702221 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  702224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702243 */     GIR_RootConstrainSelectedInstOperands,
     /*  702244 */     // GIR_Coverage, 11173,
     /*  702244 */     GIR_EraseRootFromParent_Done,
     /*  702245 */   // Label 11092: @702245
     /*  702245 */   GIM_Try, /*On fail goto*//*Label 11093*/ GIMT_Encode4(702320), // Rule ID 11176 //
     /*  702250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  702261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  702264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  702267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  702270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  702299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702318 */     GIR_RootConstrainSelectedInstOperands,
     /*  702319 */     // GIR_Coverage, 11176,
     /*  702319 */     GIR_EraseRootFromParent_Done,
     /*  702320 */   // Label 11093: @702320
     /*  702320 */   GIM_Try, /*On fail goto*//*Label 11094*/ GIMT_Encode4(702395), // Rule ID 11177 //
     /*  702325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  702336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  702339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  702342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  702345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702371 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  702374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702393 */     GIR_RootConstrainSelectedInstOperands,
     /*  702394 */     // GIR_Coverage, 11177,
     /*  702394 */     GIR_EraseRootFromParent_Done,
     /*  702395 */   // Label 11094: @702395
     /*  702395 */   GIM_Try, /*On fail goto*//*Label 11095*/ GIMT_Encode4(702470), // Rule ID 11180 //
     /*  702400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  702411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  702414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  702417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  702420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702446 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  702449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702468 */     GIR_RootConstrainSelectedInstOperands,
     /*  702469 */     // GIR_Coverage, 11180,
     /*  702469 */     GIR_EraseRootFromParent_Done,
     /*  702470 */   // Label 11095: @702470
     /*  702470 */   GIM_Try, /*On fail goto*//*Label 11096*/ GIMT_Encode4(702545), // Rule ID 11181 //
     /*  702475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  702486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  702489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  702492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  702495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702521 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  702524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702543 */     GIR_RootConstrainSelectedInstOperands,
     /*  702544 */     // GIR_Coverage, 11181,
     /*  702544 */     GIR_EraseRootFromParent_Done,
     /*  702545 */   // Label 11096: @702545
     /*  702545 */   GIM_Try, /*On fail goto*//*Label 11097*/ GIMT_Encode4(702620), // Rule ID 11184 //
     /*  702550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  702561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  702564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  702567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  702570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702596 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  702599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702618 */     GIR_RootConstrainSelectedInstOperands,
     /*  702619 */     // GIR_Coverage, 11184,
     /*  702619 */     GIR_EraseRootFromParent_Done,
     /*  702620 */   // Label 11097: @702620
     /*  702620 */   GIM_Try, /*On fail goto*//*Label 11098*/ GIMT_Encode4(702695), // Rule ID 11185 //
     /*  702625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  702636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  702639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  702642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  702645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702671 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  702674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702693 */     GIR_RootConstrainSelectedInstOperands,
     /*  702694 */     // GIR_Coverage, 11185,
     /*  702694 */     GIR_EraseRootFromParent_Done,
     /*  702695 */   // Label 11098: @702695
     /*  702695 */   GIM_Try, /*On fail goto*//*Label 11099*/ GIMT_Encode4(702770), // Rule ID 11188 //
     /*  702700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  702711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  702714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  702717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  702720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702746 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  702749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702768 */     GIR_RootConstrainSelectedInstOperands,
     /*  702769 */     // GIR_Coverage, 11188,
     /*  702769 */     GIR_EraseRootFromParent_Done,
     /*  702770 */   // Label 11099: @702770
     /*  702770 */   GIM_Try, /*On fail goto*//*Label 11100*/ GIMT_Encode4(702845), // Rule ID 11189 //
     /*  702775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  702786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  702789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  702792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  702795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702821 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  702824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702843 */     GIR_RootConstrainSelectedInstOperands,
     /*  702844 */     // GIR_Coverage, 11189,
     /*  702844 */     GIR_EraseRootFromParent_Done,
     /*  702845 */   // Label 11100: @702845
     /*  702845 */   GIM_Try, /*On fail goto*//*Label 11101*/ GIMT_Encode4(702920), // Rule ID 11192 //
     /*  702850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  702861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  702864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  702867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  702870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702896 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  702899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702918 */     GIR_RootConstrainSelectedInstOperands,
     /*  702919 */     // GIR_Coverage, 11192,
     /*  702919 */     GIR_EraseRootFromParent_Done,
     /*  702920 */   // Label 11101: @702920
     /*  702920 */   GIM_Try, /*On fail goto*//*Label 11102*/ GIMT_Encode4(702995), // Rule ID 11193 //
     /*  702925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  702936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  702939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  702942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  702945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702971 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  702974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702993 */     GIR_RootConstrainSelectedInstOperands,
     /*  702994 */     // GIR_Coverage, 11193,
     /*  702994 */     GIR_EraseRootFromParent_Done,
     /*  702995 */   // Label 11102: @702995
     /*  702995 */   GIM_Try, /*On fail goto*//*Label 11103*/ GIMT_Encode4(703070), // Rule ID 11196 //
     /*  703000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  703011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  703014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  703017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  703020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  703049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703068 */     GIR_RootConstrainSelectedInstOperands,
     /*  703069 */     // GIR_Coverage, 11196,
     /*  703069 */     GIR_EraseRootFromParent_Done,
     /*  703070 */   // Label 11103: @703070
     /*  703070 */   GIM_Try, /*On fail goto*//*Label 11104*/ GIMT_Encode4(703145), // Rule ID 11197 //
     /*  703075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  703086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  703089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  703092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  703095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703121 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  703121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  703124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703143 */     GIR_RootConstrainSelectedInstOperands,
     /*  703144 */     // GIR_Coverage, 11197,
     /*  703144 */     GIR_EraseRootFromParent_Done,
     /*  703145 */   // Label 11104: @703145
     /*  703145 */   GIM_Try, /*On fail goto*//*Label 11105*/ GIMT_Encode4(703220), // Rule ID 11200 //
     /*  703150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  703161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  703164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  703167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  703170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  703199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703218 */     GIR_RootConstrainSelectedInstOperands,
     /*  703219 */     // GIR_Coverage, 11200,
     /*  703219 */     GIR_EraseRootFromParent_Done,
     /*  703220 */   // Label 11105: @703220
     /*  703220 */   GIM_Try, /*On fail goto*//*Label 11106*/ GIMT_Encode4(703295), // Rule ID 11201 //
     /*  703225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  703236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  703239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  703242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  703245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703271 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  703274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703293 */     GIR_RootConstrainSelectedInstOperands,
     /*  703294 */     // GIR_Coverage, 11201,
     /*  703294 */     GIR_EraseRootFromParent_Done,
     /*  703295 */   // Label 11106: @703295
     /*  703295 */   GIM_Try, /*On fail goto*//*Label 11107*/ GIMT_Encode4(703370), // Rule ID 11204 //
     /*  703300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  703311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  703314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  703317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  703320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  703349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703368 */     GIR_RootConstrainSelectedInstOperands,
     /*  703369 */     // GIR_Coverage, 11204,
     /*  703369 */     GIR_EraseRootFromParent_Done,
     /*  703370 */   // Label 11107: @703370
     /*  703370 */   GIM_Try, /*On fail goto*//*Label 11108*/ GIMT_Encode4(703445), // Rule ID 11205 //
     /*  703375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  703386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  703389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  703392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  703395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703421 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  703424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703443 */     GIR_RootConstrainSelectedInstOperands,
     /*  703444 */     // GIR_Coverage, 11205,
     /*  703444 */     GIR_EraseRootFromParent_Done,
     /*  703445 */   // Label 11108: @703445
     /*  703445 */   GIM_Try, /*On fail goto*//*Label 11109*/ GIMT_Encode4(703520), // Rule ID 11208 //
     /*  703450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  703461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  703464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  703467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  703470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  703499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703518 */     GIR_RootConstrainSelectedInstOperands,
     /*  703519 */     // GIR_Coverage, 11208,
     /*  703519 */     GIR_EraseRootFromParent_Done,
     /*  703520 */   // Label 11109: @703520
     /*  703520 */   GIM_Try, /*On fail goto*//*Label 11110*/ GIMT_Encode4(703595), // Rule ID 11209 //
     /*  703525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  703536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  703539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  703542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  703545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703571 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  703574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703593 */     GIR_RootConstrainSelectedInstOperands,
     /*  703594 */     // GIR_Coverage, 11209,
     /*  703594 */     GIR_EraseRootFromParent_Done,
     /*  703595 */   // Label 11110: @703595
     /*  703595 */   GIM_Try, /*On fail goto*//*Label 11111*/ GIMT_Encode4(703670), // Rule ID 11212 //
     /*  703600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  703611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  703614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  703617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  703620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  703649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703668 */     GIR_RootConstrainSelectedInstOperands,
     /*  703669 */     // GIR_Coverage, 11212,
     /*  703669 */     GIR_EraseRootFromParent_Done,
     /*  703670 */   // Label 11111: @703670
     /*  703670 */   GIM_Try, /*On fail goto*//*Label 11112*/ GIMT_Encode4(703745), // Rule ID 11213 //
     /*  703675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  703686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  703689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  703692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  703695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703721 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  703724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703743 */     GIR_RootConstrainSelectedInstOperands,
     /*  703744 */     // GIR_Coverage, 11213,
     /*  703744 */     GIR_EraseRootFromParent_Done,
     /*  703745 */   // Label 11112: @703745
     /*  703745 */   GIM_Try, /*On fail goto*//*Label 11113*/ GIMT_Encode4(703820), // Rule ID 11216 //
     /*  703750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  703761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  703764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  703767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  703770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  703799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703818 */     GIR_RootConstrainSelectedInstOperands,
     /*  703819 */     // GIR_Coverage, 11216,
     /*  703819 */     GIR_EraseRootFromParent_Done,
     /*  703820 */   // Label 11113: @703820
     /*  703820 */   GIM_Try, /*On fail goto*//*Label 11114*/ GIMT_Encode4(703895), // Rule ID 11217 //
     /*  703825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  703836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  703839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  703842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  703845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  703874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703893 */     GIR_RootConstrainSelectedInstOperands,
     /*  703894 */     // GIR_Coverage, 11217,
     /*  703894 */     GIR_EraseRootFromParent_Done,
     /*  703895 */   // Label 11114: @703895
     /*  703895 */   GIM_Try, /*On fail goto*//*Label 11115*/ GIMT_Encode4(703970), // Rule ID 11220 //
     /*  703900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  703911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  703914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  703917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  703920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  703949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703968 */     GIR_RootConstrainSelectedInstOperands,
     /*  703969 */     // GIR_Coverage, 11220,
     /*  703969 */     GIR_EraseRootFromParent_Done,
     /*  703970 */   // Label 11115: @703970
     /*  703970 */   GIM_Try, /*On fail goto*//*Label 11116*/ GIMT_Encode4(704045), // Rule ID 11221 //
     /*  703975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  703986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  703989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  703992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  703995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704021 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  704024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704043 */     GIR_RootConstrainSelectedInstOperands,
     /*  704044 */     // GIR_Coverage, 11221,
     /*  704044 */     GIR_EraseRootFromParent_Done,
     /*  704045 */   // Label 11116: @704045
     /*  704045 */   GIM_Try, /*On fail goto*//*Label 11117*/ GIMT_Encode4(704120), // Rule ID 11224 //
     /*  704050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  704061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  704064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  704067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  704099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704118 */     GIR_RootConstrainSelectedInstOperands,
     /*  704119 */     // GIR_Coverage, 11224,
     /*  704119 */     GIR_EraseRootFromParent_Done,
     /*  704120 */   // Label 11117: @704120
     /*  704120 */   GIM_Try, /*On fail goto*//*Label 11118*/ GIMT_Encode4(704195), // Rule ID 11225 //
     /*  704125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  704136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  704139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  704142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704171 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  704174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704193 */     GIR_RootConstrainSelectedInstOperands,
     /*  704194 */     // GIR_Coverage, 11225,
     /*  704194 */     GIR_EraseRootFromParent_Done,
     /*  704195 */   // Label 11118: @704195
     /*  704195 */   GIM_Try, /*On fail goto*//*Label 11119*/ GIMT_Encode4(704270), // Rule ID 11228 //
     /*  704200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  704211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  704214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  704217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  704249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704268 */     GIR_RootConstrainSelectedInstOperands,
     /*  704269 */     // GIR_Coverage, 11228,
     /*  704269 */     GIR_EraseRootFromParent_Done,
     /*  704270 */   // Label 11119: @704270
     /*  704270 */   GIM_Try, /*On fail goto*//*Label 11120*/ GIMT_Encode4(704345), // Rule ID 11229 //
     /*  704275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  704286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  704289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  704292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  704324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704343 */     GIR_RootConstrainSelectedInstOperands,
     /*  704344 */     // GIR_Coverage, 11229,
     /*  704344 */     GIR_EraseRootFromParent_Done,
     /*  704345 */   // Label 11120: @704345
     /*  704345 */   GIM_Try, /*On fail goto*//*Label 11121*/ GIMT_Encode4(704420), // Rule ID 11232 //
     /*  704350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  704361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  704364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  704367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  704399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704418 */     GIR_RootConstrainSelectedInstOperands,
     /*  704419 */     // GIR_Coverage, 11232,
     /*  704419 */     GIR_EraseRootFromParent_Done,
     /*  704420 */   // Label 11121: @704420
     /*  704420 */   GIM_Try, /*On fail goto*//*Label 11122*/ GIMT_Encode4(704495), // Rule ID 11233 //
     /*  704425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  704436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  704439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  704442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  704474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704493 */     GIR_RootConstrainSelectedInstOperands,
     /*  704494 */     // GIR_Coverage, 11233,
     /*  704494 */     GIR_EraseRootFromParent_Done,
     /*  704495 */   // Label 11122: @704495
     /*  704495 */   GIM_Try, /*On fail goto*//*Label 11123*/ GIMT_Encode4(704570), // Rule ID 11236 //
     /*  704500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  704511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  704514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  704517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704546 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  704549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704568 */     GIR_RootConstrainSelectedInstOperands,
     /*  704569 */     // GIR_Coverage, 11236,
     /*  704569 */     GIR_EraseRootFromParent_Done,
     /*  704570 */   // Label 11123: @704570
     /*  704570 */   GIM_Try, /*On fail goto*//*Label 11124*/ GIMT_Encode4(704645), // Rule ID 11237 //
     /*  704575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  704586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  704589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  704592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704621 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  704624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704643 */     GIR_RootConstrainSelectedInstOperands,
     /*  704644 */     // GIR_Coverage, 11237,
     /*  704644 */     GIR_EraseRootFromParent_Done,
     /*  704645 */   // Label 11124: @704645
     /*  704645 */   GIM_Try, /*On fail goto*//*Label 11125*/ GIMT_Encode4(704720), // Rule ID 11240 //
     /*  704650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  704661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  704664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  704667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704696 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  704699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704718 */     GIR_RootConstrainSelectedInstOperands,
     /*  704719 */     // GIR_Coverage, 11240,
     /*  704719 */     GIR_EraseRootFromParent_Done,
     /*  704720 */   // Label 11125: @704720
     /*  704720 */   GIM_Try, /*On fail goto*//*Label 11126*/ GIMT_Encode4(704795), // Rule ID 11241 //
     /*  704725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  704736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  704739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  704742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704771 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  704774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704793 */     GIR_RootConstrainSelectedInstOperands,
     /*  704794 */     // GIR_Coverage, 11241,
     /*  704794 */     GIR_EraseRootFromParent_Done,
     /*  704795 */   // Label 11126: @704795
     /*  704795 */   GIM_Try, /*On fail goto*//*Label 11127*/ GIMT_Encode4(704870), // Rule ID 11244 //
     /*  704800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  704811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  704814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  704817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704846 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  704849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704868 */     GIR_RootConstrainSelectedInstOperands,
     /*  704869 */     // GIR_Coverage, 11244,
     /*  704869 */     GIR_EraseRootFromParent_Done,
     /*  704870 */   // Label 11127: @704870
     /*  704870 */   GIM_Try, /*On fail goto*//*Label 11128*/ GIMT_Encode4(704945), // Rule ID 11245 //
     /*  704875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  704886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  704889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  704892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704921 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  704924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704943 */     GIR_RootConstrainSelectedInstOperands,
     /*  704944 */     // GIR_Coverage, 11245,
     /*  704944 */     GIR_EraseRootFromParent_Done,
     /*  704945 */   // Label 11128: @704945
     /*  704945 */   GIM_Try, /*On fail goto*//*Label 11129*/ GIMT_Encode4(705020), // Rule ID 11248 //
     /*  704950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  704961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  704964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  704967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  704999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705018 */     GIR_RootConstrainSelectedInstOperands,
     /*  705019 */     // GIR_Coverage, 11248,
     /*  705019 */     GIR_EraseRootFromParent_Done,
     /*  705020 */   // Label 11129: @705020
     /*  705020 */   GIM_Try, /*On fail goto*//*Label 11130*/ GIMT_Encode4(705095), // Rule ID 11249 //
     /*  705025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  705036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  705039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  705042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705071 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  705074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705093 */     GIR_RootConstrainSelectedInstOperands,
     /*  705094 */     // GIR_Coverage, 11249,
     /*  705094 */     GIR_EraseRootFromParent_Done,
     /*  705095 */   // Label 11130: @705095
     /*  705095 */   GIM_Try, /*On fail goto*//*Label 11131*/ GIMT_Encode4(705170), // Rule ID 11252 //
     /*  705100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  705111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  705114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  705117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705146 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  705149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705168 */     GIR_RootConstrainSelectedInstOperands,
     /*  705169 */     // GIR_Coverage, 11252,
     /*  705169 */     GIR_EraseRootFromParent_Done,
     /*  705170 */   // Label 11131: @705170
     /*  705170 */   GIM_Try, /*On fail goto*//*Label 11132*/ GIMT_Encode4(705245), // Rule ID 11253 //
     /*  705175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  705186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  705189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  705192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705221 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  705224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705243 */     GIR_RootConstrainSelectedInstOperands,
     /*  705244 */     // GIR_Coverage, 11253,
     /*  705244 */     GIR_EraseRootFromParent_Done,
     /*  705245 */   // Label 11132: @705245
     /*  705245 */   GIM_Try, /*On fail goto*//*Label 11133*/ GIMT_Encode4(705320), // Rule ID 11256 //
     /*  705250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  705261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  705264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  705267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705296 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  705299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705318 */     GIR_RootConstrainSelectedInstOperands,
     /*  705319 */     // GIR_Coverage, 11256,
     /*  705319 */     GIR_EraseRootFromParent_Done,
     /*  705320 */   // Label 11133: @705320
     /*  705320 */   GIM_Try, /*On fail goto*//*Label 11134*/ GIMT_Encode4(705395), // Rule ID 11257 //
     /*  705325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  705336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  705339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  705342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705371 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  705374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705393 */     GIR_RootConstrainSelectedInstOperands,
     /*  705394 */     // GIR_Coverage, 11257,
     /*  705394 */     GIR_EraseRootFromParent_Done,
     /*  705395 */   // Label 11134: @705395
     /*  705395 */   GIM_Try, /*On fail goto*//*Label 11135*/ GIMT_Encode4(705470), // Rule ID 11260 //
     /*  705400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  705411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  705414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  705417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  705449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705468 */     GIR_RootConstrainSelectedInstOperands,
     /*  705469 */     // GIR_Coverage, 11260,
     /*  705469 */     GIR_EraseRootFromParent_Done,
     /*  705470 */   // Label 11135: @705470
     /*  705470 */   GIM_Try, /*On fail goto*//*Label 11136*/ GIMT_Encode4(705545), // Rule ID 11261 //
     /*  705475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  705486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  705489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  705492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  705524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705543 */     GIR_RootConstrainSelectedInstOperands,
     /*  705544 */     // GIR_Coverage, 11261,
     /*  705544 */     GIR_EraseRootFromParent_Done,
     /*  705545 */   // Label 11136: @705545
     /*  705545 */   GIM_Try, /*On fail goto*//*Label 11137*/ GIMT_Encode4(705620), // Rule ID 11264 //
     /*  705550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  705561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  705564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  705567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  705599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705618 */     GIR_RootConstrainSelectedInstOperands,
     /*  705619 */     // GIR_Coverage, 11264,
     /*  705619 */     GIR_EraseRootFromParent_Done,
     /*  705620 */   // Label 11137: @705620
     /*  705620 */   GIM_Try, /*On fail goto*//*Label 11138*/ GIMT_Encode4(705695), // Rule ID 11265 //
     /*  705625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  705636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  705639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  705642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705671 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  705674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705693 */     GIR_RootConstrainSelectedInstOperands,
     /*  705694 */     // GIR_Coverage, 11265,
     /*  705694 */     GIR_EraseRootFromParent_Done,
     /*  705695 */   // Label 11138: @705695
     /*  705695 */   GIM_Try, /*On fail goto*//*Label 11139*/ GIMT_Encode4(705770), // Rule ID 11268 //
     /*  705700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  705711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  705714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  705717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705746 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  705749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705768 */     GIR_RootConstrainSelectedInstOperands,
     /*  705769 */     // GIR_Coverage, 11268,
     /*  705769 */     GIR_EraseRootFromParent_Done,
     /*  705770 */   // Label 11139: @705770
     /*  705770 */   GIM_Try, /*On fail goto*//*Label 11140*/ GIMT_Encode4(705845), // Rule ID 11269 //
     /*  705775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  705786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  705789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  705792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705821 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  705824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705843 */     GIR_RootConstrainSelectedInstOperands,
     /*  705844 */     // GIR_Coverage, 11269,
     /*  705844 */     GIR_EraseRootFromParent_Done,
     /*  705845 */   // Label 11140: @705845
     /*  705845 */   GIM_Try, /*On fail goto*//*Label 11141*/ GIMT_Encode4(705920), // Rule ID 11272 //
     /*  705850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  705861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  705864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  705867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  705870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  705899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705918 */     GIR_RootConstrainSelectedInstOperands,
     /*  705919 */     // GIR_Coverage, 11272,
     /*  705919 */     GIR_EraseRootFromParent_Done,
     /*  705920 */   // Label 11141: @705920
     /*  705920 */   GIM_Try, /*On fail goto*//*Label 11142*/ GIMT_Encode4(705995), // Rule ID 11273 //
     /*  705925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  705936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  705939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  705942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  705945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  705974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705993 */     GIR_RootConstrainSelectedInstOperands,
     /*  705994 */     // GIR_Coverage, 11273,
     /*  705994 */     GIR_EraseRootFromParent_Done,
     /*  705995 */   // Label 11142: @705995
     /*  705995 */   GIM_Try, /*On fail goto*//*Label 11143*/ GIMT_Encode4(706070), // Rule ID 11276 //
     /*  706000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  706011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  706014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  706017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  706020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  706049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706068 */     GIR_RootConstrainSelectedInstOperands,
     /*  706069 */     // GIR_Coverage, 11276,
     /*  706069 */     GIR_EraseRootFromParent_Done,
     /*  706070 */   // Label 11143: @706070
     /*  706070 */   GIM_Try, /*On fail goto*//*Label 11144*/ GIMT_Encode4(706145), // Rule ID 11277 //
     /*  706075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  706086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  706089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  706092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  706095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706121 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  706124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706143 */     GIR_RootConstrainSelectedInstOperands,
     /*  706144 */     // GIR_Coverage, 11277,
     /*  706144 */     GIR_EraseRootFromParent_Done,
     /*  706145 */   // Label 11144: @706145
     /*  706145 */   GIM_Try, /*On fail goto*//*Label 11145*/ GIMT_Encode4(706220), // Rule ID 11280 //
     /*  706150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  706161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  706164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  706167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  706170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  706199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706218 */     GIR_RootConstrainSelectedInstOperands,
     /*  706219 */     // GIR_Coverage, 11280,
     /*  706219 */     GIR_EraseRootFromParent_Done,
     /*  706220 */   // Label 11145: @706220
     /*  706220 */   GIM_Try, /*On fail goto*//*Label 11146*/ GIMT_Encode4(706295), // Rule ID 11281 //
     /*  706225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  706236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  706239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  706242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  706245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  706274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706293 */     GIR_RootConstrainSelectedInstOperands,
     /*  706294 */     // GIR_Coverage, 11281,
     /*  706294 */     GIR_EraseRootFromParent_Done,
     /*  706295 */   // Label 11146: @706295
     /*  706295 */   GIM_Try, /*On fail goto*//*Label 11147*/ GIMT_Encode4(706370), // Rule ID 11284 //
     /*  706300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  706311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  706314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  706317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  706320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  706349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706368 */     GIR_RootConstrainSelectedInstOperands,
     /*  706369 */     // GIR_Coverage, 11284,
     /*  706369 */     GIR_EraseRootFromParent_Done,
     /*  706370 */   // Label 11147: @706370
     /*  706370 */   GIM_Try, /*On fail goto*//*Label 11148*/ GIMT_Encode4(706445), // Rule ID 11285 //
     /*  706375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  706386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  706389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  706392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  706395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706421 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  706424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706443 */     GIR_RootConstrainSelectedInstOperands,
     /*  706444 */     // GIR_Coverage, 11285,
     /*  706444 */     GIR_EraseRootFromParent_Done,
     /*  706445 */   // Label 11148: @706445
     /*  706445 */   GIM_Try, /*On fail goto*//*Label 11149*/ GIMT_Encode4(706520), // Rule ID 11288 //
     /*  706450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  706461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  706464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  706467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  706470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  706499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706518 */     GIR_RootConstrainSelectedInstOperands,
     /*  706519 */     // GIR_Coverage, 11288,
     /*  706519 */     GIR_EraseRootFromParent_Done,
     /*  706520 */   // Label 11149: @706520
     /*  706520 */   GIM_Try, /*On fail goto*//*Label 11150*/ GIMT_Encode4(706595), // Rule ID 11289 //
     /*  706525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  706536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  706539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  706542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  706545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706571 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  706574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706593 */     GIR_RootConstrainSelectedInstOperands,
     /*  706594 */     // GIR_Coverage, 11289,
     /*  706594 */     GIR_EraseRootFromParent_Done,
     /*  706595 */   // Label 11150: @706595
     /*  706595 */   GIM_Try, /*On fail goto*//*Label 11151*/ GIMT_Encode4(706670), // Rule ID 11292 //
     /*  706600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  706611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  706614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  706617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  706620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  706646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  706649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706668 */     GIR_RootConstrainSelectedInstOperands,
     /*  706669 */     // GIR_Coverage, 11292,
     /*  706669 */     GIR_EraseRootFromParent_Done,
     /*  706670 */   // Label 11151: @706670
     /*  706670 */   GIM_Try, /*On fail goto*//*Label 11152*/ GIMT_Encode4(706745), // Rule ID 11293 //
     /*  706675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  706686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  706689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  706692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  706695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  706724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706743 */     GIR_RootConstrainSelectedInstOperands,
     /*  706744 */     // GIR_Coverage, 11293,
     /*  706744 */     GIR_EraseRootFromParent_Done,
     /*  706745 */   // Label 11152: @706745
     /*  706745 */   GIM_Try, /*On fail goto*//*Label 11153*/ GIMT_Encode4(706820), // Rule ID 11296 //
     /*  706750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  706761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  706764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  706767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  706770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  706799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706818 */     GIR_RootConstrainSelectedInstOperands,
     /*  706819 */     // GIR_Coverage, 11296,
     /*  706819 */     GIR_EraseRootFromParent_Done,
     /*  706820 */   // Label 11153: @706820
     /*  706820 */   GIM_Try, /*On fail goto*//*Label 11154*/ GIMT_Encode4(706895), // Rule ID 11297 //
     /*  706825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  706836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  706839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  706842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  706845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706871 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  706874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706893 */     GIR_RootConstrainSelectedInstOperands,
     /*  706894 */     // GIR_Coverage, 11297,
     /*  706894 */     GIR_EraseRootFromParent_Done,
     /*  706895 */   // Label 11154: @706895
     /*  706895 */   GIM_Try, /*On fail goto*//*Label 11155*/ GIMT_Encode4(706970), // Rule ID 11300 //
     /*  706900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  706911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  706914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  706917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  706920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  706949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706968 */     GIR_RootConstrainSelectedInstOperands,
     /*  706969 */     // GIR_Coverage, 11300,
     /*  706969 */     GIR_EraseRootFromParent_Done,
     /*  706970 */   // Label 11155: @706970
     /*  706970 */   GIM_Try, /*On fail goto*//*Label 11156*/ GIMT_Encode4(707045), // Rule ID 11301 //
     /*  706975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  706986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  706989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  706992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  706995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707021 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  707024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707043 */     GIR_RootConstrainSelectedInstOperands,
     /*  707044 */     // GIR_Coverage, 11301,
     /*  707044 */     GIR_EraseRootFromParent_Done,
     /*  707045 */   // Label 11156: @707045
     /*  707045 */   GIM_Try, /*On fail goto*//*Label 11157*/ GIMT_Encode4(707120), // Rule ID 11304 //
     /*  707050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  707061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  707064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  707067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  707070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  707099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707118 */     GIR_RootConstrainSelectedInstOperands,
     /*  707119 */     // GIR_Coverage, 11304,
     /*  707119 */     GIR_EraseRootFromParent_Done,
     /*  707120 */   // Label 11157: @707120
     /*  707120 */   GIM_Try, /*On fail goto*//*Label 11158*/ GIMT_Encode4(707195), // Rule ID 11305 //
     /*  707125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  707136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  707139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  707142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  707145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  707174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707193 */     GIR_RootConstrainSelectedInstOperands,
     /*  707194 */     // GIR_Coverage, 11305,
     /*  707194 */     GIR_EraseRootFromParent_Done,
     /*  707195 */   // Label 11158: @707195
     /*  707195 */   GIM_Try, /*On fail goto*//*Label 11159*/ GIMT_Encode4(707270), // Rule ID 11308 //
     /*  707200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  707211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  707214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  707217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  707220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707246 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  707249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707268 */     GIR_RootConstrainSelectedInstOperands,
     /*  707269 */     // GIR_Coverage, 11308,
     /*  707269 */     GIR_EraseRootFromParent_Done,
     /*  707270 */   // Label 11159: @707270
     /*  707270 */   GIM_Try, /*On fail goto*//*Label 11160*/ GIMT_Encode4(707345), // Rule ID 11309 //
     /*  707275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  707286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  707289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  707292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  707295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707321 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  707324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707343 */     GIR_RootConstrainSelectedInstOperands,
     /*  707344 */     // GIR_Coverage, 11309,
     /*  707344 */     GIR_EraseRootFromParent_Done,
     /*  707345 */   // Label 11160: @707345
     /*  707345 */   GIM_Try, /*On fail goto*//*Label 11161*/ GIMT_Encode4(707420), // Rule ID 11312 //
     /*  707350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  707361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  707364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  707367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  707370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707396 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  707399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707418 */     GIR_RootConstrainSelectedInstOperands,
     /*  707419 */     // GIR_Coverage, 11312,
     /*  707419 */     GIR_EraseRootFromParent_Done,
     /*  707420 */   // Label 11161: @707420
     /*  707420 */   GIM_Try, /*On fail goto*//*Label 11162*/ GIMT_Encode4(707495), // Rule ID 11313 //
     /*  707425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  707436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  707439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  707442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  707445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707471 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  707474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707493 */     GIR_RootConstrainSelectedInstOperands,
     /*  707494 */     // GIR_Coverage, 11313,
     /*  707494 */     GIR_EraseRootFromParent_Done,
     /*  707495 */   // Label 11162: @707495
     /*  707495 */   GIM_Try, /*On fail goto*//*Label 11163*/ GIMT_Encode4(707570), // Rule ID 11316 //
     /*  707500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  707511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  707514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  707517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  707520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707546 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  707549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707568 */     GIR_RootConstrainSelectedInstOperands,
     /*  707569 */     // GIR_Coverage, 11316,
     /*  707569 */     GIR_EraseRootFromParent_Done,
     /*  707570 */   // Label 11163: @707570
     /*  707570 */   GIM_Try, /*On fail goto*//*Label 11164*/ GIMT_Encode4(707645), // Rule ID 11317 //
     /*  707575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  707586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  707589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  707592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  707595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707621 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  707624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707643 */     GIR_RootConstrainSelectedInstOperands,
     /*  707644 */     // GIR_Coverage, 11317,
     /*  707644 */     GIR_EraseRootFromParent_Done,
     /*  707645 */   // Label 11164: @707645
     /*  707645 */   GIM_Try, /*On fail goto*//*Label 11165*/ GIMT_Encode4(707720), // Rule ID 11320 //
     /*  707650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  707661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  707664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  707667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  707670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707696 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  707699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707718 */     GIR_RootConstrainSelectedInstOperands,
     /*  707719 */     // GIR_Coverage, 11320,
     /*  707719 */     GIR_EraseRootFromParent_Done,
     /*  707720 */   // Label 11165: @707720
     /*  707720 */   GIM_Try, /*On fail goto*//*Label 11166*/ GIMT_Encode4(707795), // Rule ID 11321 //
     /*  707725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  707736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  707739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  707742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  707745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707771 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  707774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707793 */     GIR_RootConstrainSelectedInstOperands,
     /*  707794 */     // GIR_Coverage, 11321,
     /*  707794 */     GIR_EraseRootFromParent_Done,
     /*  707795 */   // Label 11166: @707795
     /*  707795 */   GIM_Try, /*On fail goto*//*Label 11167*/ GIMT_Encode4(707870), // Rule ID 11324 //
     /*  707800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  707811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  707814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  707817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  707820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707846 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  707849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707868 */     GIR_RootConstrainSelectedInstOperands,
     /*  707869 */     // GIR_Coverage, 11324,
     /*  707869 */     GIR_EraseRootFromParent_Done,
     /*  707870 */   // Label 11167: @707870
     /*  707870 */   GIM_Try, /*On fail goto*//*Label 11168*/ GIMT_Encode4(707945), // Rule ID 11325 //
     /*  707875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  707886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  707889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  707892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  707895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707921 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  707924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707943 */     GIR_RootConstrainSelectedInstOperands,
     /*  707944 */     // GIR_Coverage, 11325,
     /*  707944 */     GIR_EraseRootFromParent_Done,
     /*  707945 */   // Label 11168: @707945
     /*  707945 */   GIM_Try, /*On fail goto*//*Label 11169*/ GIMT_Encode4(708020), // Rule ID 11328 //
     /*  707950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  707961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  707964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  707967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  707970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707996 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  707999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708018 */     GIR_RootConstrainSelectedInstOperands,
     /*  708019 */     // GIR_Coverage, 11328,
     /*  708019 */     GIR_EraseRootFromParent_Done,
     /*  708020 */   // Label 11169: @708020
     /*  708020 */   GIM_Try, /*On fail goto*//*Label 11170*/ GIMT_Encode4(708095), // Rule ID 11329 //
     /*  708025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  708036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  708039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  708042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  708045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708071 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  708074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708093 */     GIR_RootConstrainSelectedInstOperands,
     /*  708094 */     // GIR_Coverage, 11329,
     /*  708094 */     GIR_EraseRootFromParent_Done,
     /*  708095 */   // Label 11170: @708095
     /*  708095 */   GIM_Try, /*On fail goto*//*Label 11171*/ GIMT_Encode4(708170), // Rule ID 11332 //
     /*  708100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  708111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  708114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  708117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  708120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  708149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708168 */     GIR_RootConstrainSelectedInstOperands,
     /*  708169 */     // GIR_Coverage, 11332,
     /*  708169 */     GIR_EraseRootFromParent_Done,
     /*  708170 */   // Label 11171: @708170
     /*  708170 */   GIM_Try, /*On fail goto*//*Label 11172*/ GIMT_Encode4(708245), // Rule ID 11333 //
     /*  708175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  708186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  708189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  708192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  708195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708221 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  708224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708243 */     GIR_RootConstrainSelectedInstOperands,
     /*  708244 */     // GIR_Coverage, 11333,
     /*  708244 */     GIR_EraseRootFromParent_Done,
     /*  708245 */   // Label 11172: @708245
     /*  708245 */   GIM_Try, /*On fail goto*//*Label 11173*/ GIMT_Encode4(708320), // Rule ID 11336 //
     /*  708250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  708261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  708264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  708267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  708270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708296 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  708299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708318 */     GIR_RootConstrainSelectedInstOperands,
     /*  708319 */     // GIR_Coverage, 11336,
     /*  708319 */     GIR_EraseRootFromParent_Done,
     /*  708320 */   // Label 11173: @708320
     /*  708320 */   GIM_Try, /*On fail goto*//*Label 11174*/ GIMT_Encode4(708395), // Rule ID 11337 //
     /*  708325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  708336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  708339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  708342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  708345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708371 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  708374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708393 */     GIR_RootConstrainSelectedInstOperands,
     /*  708394 */     // GIR_Coverage, 11337,
     /*  708394 */     GIR_EraseRootFromParent_Done,
     /*  708395 */   // Label 11174: @708395
     /*  708395 */   GIM_Try, /*On fail goto*//*Label 11175*/ GIMT_Encode4(708470), // Rule ID 11340 //
     /*  708400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  708411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  708414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  708417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  708420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  708449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708468 */     GIR_RootConstrainSelectedInstOperands,
     /*  708469 */     // GIR_Coverage, 11340,
     /*  708469 */     GIR_EraseRootFromParent_Done,
     /*  708470 */   // Label 11175: @708470
     /*  708470 */   GIM_Try, /*On fail goto*//*Label 11176*/ GIMT_Encode4(708545), // Rule ID 11341 //
     /*  708475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  708486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  708489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  708492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  708495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708521 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  708524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708543 */     GIR_RootConstrainSelectedInstOperands,
     /*  708544 */     // GIR_Coverage, 11341,
     /*  708544 */     GIR_EraseRootFromParent_Done,
     /*  708545 */   // Label 11176: @708545
     /*  708545 */   GIM_Try, /*On fail goto*//*Label 11177*/ GIMT_Encode4(708620), // Rule ID 11344 //
     /*  708550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  708561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  708564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  708567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  708570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  708589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  708599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708618 */     GIR_RootConstrainSelectedInstOperands,
     /*  708619 */     // GIR_Coverage, 11344,
     /*  708619 */     GIR_EraseRootFromParent_Done,
     /*  708620 */   // Label 11177: @708620
     /*  708620 */   GIM_Try, /*On fail goto*//*Label 11178*/ GIMT_Encode4(708695), // Rule ID 11345 //
     /*  708625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  708636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  708639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  708642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  708645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  708664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708671 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  708674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708693 */     GIR_RootConstrainSelectedInstOperands,
     /*  708694 */     // GIR_Coverage, 11345,
     /*  708694 */     GIR_EraseRootFromParent_Done,
     /*  708695 */   // Label 11178: @708695
     /*  708695 */   GIM_Try, /*On fail goto*//*Label 11179*/ GIMT_Encode4(708770), // Rule ID 11348 //
     /*  708700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  708711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  708714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  708717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  708720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  708739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708746 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  708749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708768 */     GIR_RootConstrainSelectedInstOperands,
     /*  708769 */     // GIR_Coverage, 11348,
     /*  708769 */     GIR_EraseRootFromParent_Done,
     /*  708770 */   // Label 11179: @708770
     /*  708770 */   GIM_Try, /*On fail goto*//*Label 11180*/ GIMT_Encode4(708845), // Rule ID 11349 //
     /*  708775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  708786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  708789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  708792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  708795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  708814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708821 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  708824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708843 */     GIR_RootConstrainSelectedInstOperands,
     /*  708844 */     // GIR_Coverage, 11349,
     /*  708844 */     GIR_EraseRootFromParent_Done,
     /*  708845 */   // Label 11180: @708845
     /*  708845 */   GIM_Try, /*On fail goto*//*Label 11181*/ GIMT_Encode4(708920), // Rule ID 11352 //
     /*  708850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  708861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  708864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  708867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  708870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  708889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708896 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  708899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708918 */     GIR_RootConstrainSelectedInstOperands,
     /*  708919 */     // GIR_Coverage, 11352,
     /*  708919 */     GIR_EraseRootFromParent_Done,
     /*  708920 */   // Label 11181: @708920
     /*  708920 */   GIM_Try, /*On fail goto*//*Label 11182*/ GIMT_Encode4(708995), // Rule ID 11353 //
     /*  708925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  708936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  708939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  708942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  708945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  708964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  708974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708993 */     GIR_RootConstrainSelectedInstOperands,
     /*  708994 */     // GIR_Coverage, 11353,
     /*  708994 */     GIR_EraseRootFromParent_Done,
     /*  708995 */   // Label 11182: @708995
     /*  708995 */   GIM_Try, /*On fail goto*//*Label 11183*/ GIMT_Encode4(709070), // Rule ID 11356 //
     /*  709000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  709011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  709014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  709017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  709049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709068 */     GIR_RootConstrainSelectedInstOperands,
     /*  709069 */     // GIR_Coverage, 11356,
     /*  709069 */     GIR_EraseRootFromParent_Done,
     /*  709070 */   // Label 11183: @709070
     /*  709070 */   GIM_Try, /*On fail goto*//*Label 11184*/ GIMT_Encode4(709145), // Rule ID 11357 //
     /*  709075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  709086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  709089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  709092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709121 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  709124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709143 */     GIR_RootConstrainSelectedInstOperands,
     /*  709144 */     // GIR_Coverage, 11357,
     /*  709144 */     GIR_EraseRootFromParent_Done,
     /*  709145 */   // Label 11184: @709145
     /*  709145 */   GIM_Try, /*On fail goto*//*Label 11185*/ GIMT_Encode4(709220), // Rule ID 11360 //
     /*  709150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  709161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  709164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  709167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  709199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709218 */     GIR_RootConstrainSelectedInstOperands,
     /*  709219 */     // GIR_Coverage, 11360,
     /*  709219 */     GIR_EraseRootFromParent_Done,
     /*  709220 */   // Label 11185: @709220
     /*  709220 */   GIM_Try, /*On fail goto*//*Label 11186*/ GIMT_Encode4(709295), // Rule ID 11361 //
     /*  709225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  709236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  709239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  709242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709271 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  709274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709293 */     GIR_RootConstrainSelectedInstOperands,
     /*  709294 */     // GIR_Coverage, 11361,
     /*  709294 */     GIR_EraseRootFromParent_Done,
     /*  709295 */   // Label 11186: @709295
     /*  709295 */   GIM_Try, /*On fail goto*//*Label 11187*/ GIMT_Encode4(709370), // Rule ID 11364 //
     /*  709300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  709311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  709314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  709317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  709349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709368 */     GIR_RootConstrainSelectedInstOperands,
     /*  709369 */     // GIR_Coverage, 11364,
     /*  709369 */     GIR_EraseRootFromParent_Done,
     /*  709370 */   // Label 11187: @709370
     /*  709370 */   GIM_Try, /*On fail goto*//*Label 11188*/ GIMT_Encode4(709445), // Rule ID 11365 //
     /*  709375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  709386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  709389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  709392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  709424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709443 */     GIR_RootConstrainSelectedInstOperands,
     /*  709444 */     // GIR_Coverage, 11365,
     /*  709444 */     GIR_EraseRootFromParent_Done,
     /*  709445 */   // Label 11188: @709445
     /*  709445 */   GIM_Try, /*On fail goto*//*Label 11189*/ GIMT_Encode4(709520), // Rule ID 11368 //
     /*  709450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  709461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  709464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  709467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709496 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  709499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709518 */     GIR_RootConstrainSelectedInstOperands,
     /*  709519 */     // GIR_Coverage, 11368,
     /*  709519 */     GIR_EraseRootFromParent_Done,
     /*  709520 */   // Label 11189: @709520
     /*  709520 */   GIM_Try, /*On fail goto*//*Label 11190*/ GIMT_Encode4(709595), // Rule ID 11369 //
     /*  709525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  709536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  709539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  709542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709571 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  709574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709593 */     GIR_RootConstrainSelectedInstOperands,
     /*  709594 */     // GIR_Coverage, 11369,
     /*  709594 */     GIR_EraseRootFromParent_Done,
     /*  709595 */   // Label 11190: @709595
     /*  709595 */   GIM_Try, /*On fail goto*//*Label 11191*/ GIMT_Encode4(709670), // Rule ID 11372 //
     /*  709600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  709611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  709614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  709617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  709649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709668 */     GIR_RootConstrainSelectedInstOperands,
     /*  709669 */     // GIR_Coverage, 11372,
     /*  709669 */     GIR_EraseRootFromParent_Done,
     /*  709670 */   // Label 11191: @709670
     /*  709670 */   GIM_Try, /*On fail goto*//*Label 11192*/ GIMT_Encode4(709745), // Rule ID 11373 //
     /*  709675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  709686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  709689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  709692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709721 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  709724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709743 */     GIR_RootConstrainSelectedInstOperands,
     /*  709744 */     // GIR_Coverage, 11373,
     /*  709744 */     GIR_EraseRootFromParent_Done,
     /*  709745 */   // Label 11192: @709745
     /*  709745 */   GIM_Try, /*On fail goto*//*Label 11193*/ GIMT_Encode4(709820), // Rule ID 11376 //
     /*  709750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  709761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  709764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  709767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  709799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709818 */     GIR_RootConstrainSelectedInstOperands,
     /*  709819 */     // GIR_Coverage, 11376,
     /*  709819 */     GIR_EraseRootFromParent_Done,
     /*  709820 */   // Label 11193: @709820
     /*  709820 */   GIM_Try, /*On fail goto*//*Label 11194*/ GIMT_Encode4(709895), // Rule ID 11377 //
     /*  709825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  709836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  709839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  709842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  709874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709893 */     GIR_RootConstrainSelectedInstOperands,
     /*  709894 */     // GIR_Coverage, 11377,
     /*  709894 */     GIR_EraseRootFromParent_Done,
     /*  709895 */   // Label 11194: @709895
     /*  709895 */   GIM_Try, /*On fail goto*//*Label 11195*/ GIMT_Encode4(709970), // Rule ID 11380 //
     /*  709900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  709911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  709914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  709917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709946 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  709949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709968 */     GIR_RootConstrainSelectedInstOperands,
     /*  709969 */     // GIR_Coverage, 11380,
     /*  709969 */     GIR_EraseRootFromParent_Done,
     /*  709970 */   // Label 11195: @709970
     /*  709970 */   GIM_Try, /*On fail goto*//*Label 11196*/ GIMT_Encode4(710045), // Rule ID 11381 //
     /*  709975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  709986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  709989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  709992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710021 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  710024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710043 */     GIR_RootConstrainSelectedInstOperands,
     /*  710044 */     // GIR_Coverage, 11381,
     /*  710044 */     GIR_EraseRootFromParent_Done,
     /*  710045 */   // Label 11196: @710045
     /*  710045 */   GIM_Try, /*On fail goto*//*Label 11197*/ GIMT_Encode4(710120), // Rule ID 11384 //
     /*  710050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  710061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  710064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  710067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710096 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  710099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710118 */     GIR_RootConstrainSelectedInstOperands,
     /*  710119 */     // GIR_Coverage, 11384,
     /*  710119 */     GIR_EraseRootFromParent_Done,
     /*  710120 */   // Label 11197: @710120
     /*  710120 */   GIM_Try, /*On fail goto*//*Label 11198*/ GIMT_Encode4(710195), // Rule ID 11385 //
     /*  710125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  710136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  710139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  710142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710171 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  710174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710193 */     GIR_RootConstrainSelectedInstOperands,
     /*  710194 */     // GIR_Coverage, 11385,
     /*  710194 */     GIR_EraseRootFromParent_Done,
     /*  710195 */   // Label 11198: @710195
     /*  710195 */   GIM_Try, /*On fail goto*//*Label 11199*/ GIMT_Encode4(710270), // Rule ID 11388 //
     /*  710200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  710211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  710214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  710217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710246 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  710249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710268 */     GIR_RootConstrainSelectedInstOperands,
     /*  710269 */     // GIR_Coverage, 11388,
     /*  710269 */     GIR_EraseRootFromParent_Done,
     /*  710270 */   // Label 11199: @710270
     /*  710270 */   GIM_Try, /*On fail goto*//*Label 11200*/ GIMT_Encode4(710345), // Rule ID 11389 //
     /*  710275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  710286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  710289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  710292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710321 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  710324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710343 */     GIR_RootConstrainSelectedInstOperands,
     /*  710344 */     // GIR_Coverage, 11389,
     /*  710344 */     GIR_EraseRootFromParent_Done,
     /*  710345 */   // Label 11200: @710345
     /*  710345 */   GIM_Try, /*On fail goto*//*Label 11201*/ GIMT_Encode4(710420), // Rule ID 11392 //
     /*  710350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  710361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  710364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  710367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  710399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710418 */     GIR_RootConstrainSelectedInstOperands,
     /*  710419 */     // GIR_Coverage, 11392,
     /*  710419 */     GIR_EraseRootFromParent_Done,
     /*  710420 */   // Label 11201: @710420
     /*  710420 */   GIM_Try, /*On fail goto*//*Label 11202*/ GIMT_Encode4(710495), // Rule ID 11393 //
     /*  710425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  710436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  710439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  710442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  710474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710493 */     GIR_RootConstrainSelectedInstOperands,
     /*  710494 */     // GIR_Coverage, 11393,
     /*  710494 */     GIR_EraseRootFromParent_Done,
     /*  710495 */   // Label 11202: @710495
     /*  710495 */   GIM_Try, /*On fail goto*//*Label 11203*/ GIMT_Encode4(710570), // Rule ID 11396 //
     /*  710500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  710511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  710514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  710517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  710549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710568 */     GIR_RootConstrainSelectedInstOperands,
     /*  710569 */     // GIR_Coverage, 11396,
     /*  710569 */     GIR_EraseRootFromParent_Done,
     /*  710570 */   // Label 11203: @710570
     /*  710570 */   GIM_Try, /*On fail goto*//*Label 11204*/ GIMT_Encode4(710645), // Rule ID 11397 //
     /*  710575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  710586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  710589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  710592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710621 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  710624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710643 */     GIR_RootConstrainSelectedInstOperands,
     /*  710644 */     // GIR_Coverage, 11397,
     /*  710644 */     GIR_EraseRootFromParent_Done,
     /*  710645 */   // Label 11204: @710645
     /*  710645 */   GIM_Try, /*On fail goto*//*Label 11205*/ GIMT_Encode4(710720), // Rule ID 11400 //
     /*  710650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  710661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  710664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  710667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710696 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  710699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710718 */     GIR_RootConstrainSelectedInstOperands,
     /*  710719 */     // GIR_Coverage, 11400,
     /*  710719 */     GIR_EraseRootFromParent_Done,
     /*  710720 */   // Label 11205: @710720
     /*  710720 */   GIM_Try, /*On fail goto*//*Label 11206*/ GIMT_Encode4(710795), // Rule ID 11401 //
     /*  710725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  710736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  710739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  710742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710771 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  710774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710793 */     GIR_RootConstrainSelectedInstOperands,
     /*  710794 */     // GIR_Coverage, 11401,
     /*  710794 */     GIR_EraseRootFromParent_Done,
     /*  710795 */   // Label 11206: @710795
     /*  710795 */   GIM_Try, /*On fail goto*//*Label 11207*/ GIMT_Encode4(710870), // Rule ID 11404 //
     /*  710800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  710811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  710814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  710817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710846 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  710849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710868 */     GIR_RootConstrainSelectedInstOperands,
     /*  710869 */     // GIR_Coverage, 11404,
     /*  710869 */     GIR_EraseRootFromParent_Done,
     /*  710870 */   // Label 11207: @710870
     /*  710870 */   GIM_Try, /*On fail goto*//*Label 11208*/ GIMT_Encode4(710945), // Rule ID 11405 //
     /*  710875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  710886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  710889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  710892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710921 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  710924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710943 */     GIR_RootConstrainSelectedInstOperands,
     /*  710944 */     // GIR_Coverage, 11405,
     /*  710944 */     GIR_EraseRootFromParent_Done,
     /*  710945 */   // Label 11208: @710945
     /*  710945 */   GIM_Try, /*On fail goto*//*Label 11209*/ GIMT_Encode4(711020), // Rule ID 11408 //
     /*  710950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  710961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  710964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  710967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710996 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  710999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711018 */     GIR_RootConstrainSelectedInstOperands,
     /*  711019 */     // GIR_Coverage, 11408,
     /*  711019 */     GIR_EraseRootFromParent_Done,
     /*  711020 */   // Label 11209: @711020
     /*  711020 */   GIM_Try, /*On fail goto*//*Label 11210*/ GIMT_Encode4(711095), // Rule ID 11409 //
     /*  711025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  711033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  711036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  711039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  711042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711071 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  711074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711093 */     GIR_RootConstrainSelectedInstOperands,
     /*  711094 */     // GIR_Coverage, 11409,
     /*  711094 */     GIR_EraseRootFromParent_Done,
     /*  711095 */   // Label 11210: @711095
     /*  711095 */   GIM_Try, /*On fail goto*//*Label 11211*/ GIMT_Encode4(711170), // Rule ID 11412 //
     /*  711100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  711108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  711111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  711114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  711117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711146 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  711146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  711149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711168 */     GIR_RootConstrainSelectedInstOperands,
     /*  711169 */     // GIR_Coverage, 11412,
     /*  711169 */     GIR_EraseRootFromParent_Done,
     /*  711170 */   // Label 11211: @711170
     /*  711170 */   GIM_Try, /*On fail goto*//*Label 11212*/ GIMT_Encode4(711245), // Rule ID 11413 //
     /*  711175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  711183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  711186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  711189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  711192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711221 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  711224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711243 */     GIR_RootConstrainSelectedInstOperands,
     /*  711244 */     // GIR_Coverage, 11413,
     /*  711244 */     GIR_EraseRootFromParent_Done,
     /*  711245 */   // Label 11212: @711245
     /*  711245 */   GIM_Try, /*On fail goto*//*Label 11213*/ GIMT_Encode4(711320), // Rule ID 11416 //
     /*  711250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  711261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  711264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  711267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  711270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  711299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711318 */     GIR_RootConstrainSelectedInstOperands,
     /*  711319 */     // GIR_Coverage, 11416,
     /*  711319 */     GIR_EraseRootFromParent_Done,
     /*  711320 */   // Label 11213: @711320
     /*  711320 */   GIM_Try, /*On fail goto*//*Label 11214*/ GIMT_Encode4(711395), // Rule ID 11417 //
     /*  711325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  711336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  711339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  711342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  711345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711371 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  711374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711393 */     GIR_RootConstrainSelectedInstOperands,
     /*  711394 */     // GIR_Coverage, 11417,
     /*  711394 */     GIR_EraseRootFromParent_Done,
     /*  711395 */   // Label 11214: @711395
     /*  711395 */   GIM_Try, /*On fail goto*//*Label 11215*/ GIMT_Encode4(711470), // Rule ID 11420 //
     /*  711400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  711411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  711414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  711417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  711420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711446 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  711449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711468 */     GIR_RootConstrainSelectedInstOperands,
     /*  711469 */     // GIR_Coverage, 11420,
     /*  711469 */     GIR_EraseRootFromParent_Done,
     /*  711470 */   // Label 11215: @711470
     /*  711470 */   GIM_Try, /*On fail goto*//*Label 11216*/ GIMT_Encode4(711545), // Rule ID 11421 //
     /*  711475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  711486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  711489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  711492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  711495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711521 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  711524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711543 */     GIR_RootConstrainSelectedInstOperands,
     /*  711544 */     // GIR_Coverage, 11421,
     /*  711544 */     GIR_EraseRootFromParent_Done,
     /*  711545 */   // Label 11216: @711545
     /*  711545 */   GIM_Try, /*On fail goto*//*Label 11217*/ GIMT_Encode4(711620), // Rule ID 11424 //
     /*  711550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  711561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  711564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  711567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  711570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711596 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  711599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711618 */     GIR_RootConstrainSelectedInstOperands,
     /*  711619 */     // GIR_Coverage, 11424,
     /*  711619 */     GIR_EraseRootFromParent_Done,
     /*  711620 */   // Label 11217: @711620
     /*  711620 */   GIM_Try, /*On fail goto*//*Label 11218*/ GIMT_Encode4(711695), // Rule ID 11425 //
     /*  711625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  711636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  711639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  711642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  711645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711671 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  711674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711693 */     GIR_RootConstrainSelectedInstOperands,
     /*  711694 */     // GIR_Coverage, 11425,
     /*  711694 */     GIR_EraseRootFromParent_Done,
     /*  711695 */   // Label 11218: @711695
     /*  711695 */   GIM_Try, /*On fail goto*//*Label 11219*/ GIMT_Encode4(711770), // Rule ID 11428 //
     /*  711700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  711711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  711714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  711717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  711720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  711749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711768 */     GIR_RootConstrainSelectedInstOperands,
     /*  711769 */     // GIR_Coverage, 11428,
     /*  711769 */     GIR_EraseRootFromParent_Done,
     /*  711770 */   // Label 11219: @711770
     /*  711770 */   GIM_Try, /*On fail goto*//*Label 11220*/ GIMT_Encode4(711845), // Rule ID 11429 //
     /*  711775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  711786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  711789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  711792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  711795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711821 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  711824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711843 */     GIR_RootConstrainSelectedInstOperands,
     /*  711844 */     // GIR_Coverage, 11429,
     /*  711844 */     GIR_EraseRootFromParent_Done,
     /*  711845 */   // Label 11220: @711845
     /*  711845 */   GIM_Try, /*On fail goto*//*Label 11221*/ GIMT_Encode4(711920), // Rule ID 11432 //
     /*  711850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  711861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  711864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  711867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  711870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  711899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711918 */     GIR_RootConstrainSelectedInstOperands,
     /*  711919 */     // GIR_Coverage, 11432,
     /*  711919 */     GIR_EraseRootFromParent_Done,
     /*  711920 */   // Label 11221: @711920
     /*  711920 */   GIM_Try, /*On fail goto*//*Label 11222*/ GIMT_Encode4(711995), // Rule ID 11433 //
     /*  711925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  711936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  711939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  711942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  711945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711971 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  711974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711993 */     GIR_RootConstrainSelectedInstOperands,
     /*  711994 */     // GIR_Coverage, 11433,
     /*  711994 */     GIR_EraseRootFromParent_Done,
     /*  711995 */   // Label 11222: @711995
     /*  711995 */   GIM_Try, /*On fail goto*//*Label 11223*/ GIMT_Encode4(712070), // Rule ID 11436 //
     /*  712000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  712011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  712014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  712017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  712020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  712049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712068 */     GIR_RootConstrainSelectedInstOperands,
     /*  712069 */     // GIR_Coverage, 11436,
     /*  712069 */     GIR_EraseRootFromParent_Done,
     /*  712070 */   // Label 11223: @712070
     /*  712070 */   GIM_Try, /*On fail goto*//*Label 11224*/ GIMT_Encode4(712145), // Rule ID 11437 //
     /*  712075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  712086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  712089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  712092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  712095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712121 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  712124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712143 */     GIR_RootConstrainSelectedInstOperands,
     /*  712144 */     // GIR_Coverage, 11437,
     /*  712144 */     GIR_EraseRootFromParent_Done,
     /*  712145 */   // Label 11224: @712145
     /*  712145 */   GIM_Try, /*On fail goto*//*Label 11225*/ GIMT_Encode4(712220), // Rule ID 11440 //
     /*  712150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  712161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  712164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  712167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  712170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  712199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712218 */     GIR_RootConstrainSelectedInstOperands,
     /*  712219 */     // GIR_Coverage, 11440,
     /*  712219 */     GIR_EraseRootFromParent_Done,
     /*  712220 */   // Label 11225: @712220
     /*  712220 */   GIM_Try, /*On fail goto*//*Label 11226*/ GIMT_Encode4(712295), // Rule ID 11441 //
     /*  712225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  712236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  712239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  712242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  712245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712271 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  712274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712293 */     GIR_RootConstrainSelectedInstOperands,
     /*  712294 */     // GIR_Coverage, 11441,
     /*  712294 */     GIR_EraseRootFromParent_Done,
     /*  712295 */   // Label 11226: @712295
     /*  712295 */   GIM_Try, /*On fail goto*//*Label 11227*/ GIMT_Encode4(712370), // Rule ID 11444 //
     /*  712300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  712311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  712314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  712317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  712320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712346 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  712349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712368 */     GIR_RootConstrainSelectedInstOperands,
     /*  712369 */     // GIR_Coverage, 11444,
     /*  712369 */     GIR_EraseRootFromParent_Done,
     /*  712370 */   // Label 11227: @712370
     /*  712370 */   GIM_Try, /*On fail goto*//*Label 11228*/ GIMT_Encode4(712445), // Rule ID 11445 //
     /*  712375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  712386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  712389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  712392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  712395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712421 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  712424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712443 */     GIR_RootConstrainSelectedInstOperands,
     /*  712444 */     // GIR_Coverage, 11445,
     /*  712444 */     GIR_EraseRootFromParent_Done,
     /*  712445 */   // Label 11228: @712445
     /*  712445 */   GIM_Try, /*On fail goto*//*Label 11229*/ GIMT_Encode4(712520), // Rule ID 11448 //
     /*  712450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  712461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  712464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  712467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  712470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  712499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712518 */     GIR_RootConstrainSelectedInstOperands,
     /*  712519 */     // GIR_Coverage, 11448,
     /*  712519 */     GIR_EraseRootFromParent_Done,
     /*  712520 */   // Label 11229: @712520
     /*  712520 */   GIM_Try, /*On fail goto*//*Label 11230*/ GIMT_Encode4(712595), // Rule ID 11449 //
     /*  712525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  712536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  712539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  712542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  712545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712571 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  712574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712593 */     GIR_RootConstrainSelectedInstOperands,
     /*  712594 */     // GIR_Coverage, 11449,
     /*  712594 */     GIR_EraseRootFromParent_Done,
     /*  712595 */   // Label 11230: @712595
     /*  712595 */   GIM_Try, /*On fail goto*//*Label 11231*/ GIMT_Encode4(712670), // Rule ID 11452 //
     /*  712600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  712611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  712614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  712617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  712620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712646 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  712649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712668 */     GIR_RootConstrainSelectedInstOperands,
     /*  712669 */     // GIR_Coverage, 11452,
     /*  712669 */     GIR_EraseRootFromParent_Done,
     /*  712670 */   // Label 11231: @712670
     /*  712670 */   GIM_Try, /*On fail goto*//*Label 11232*/ GIMT_Encode4(712745), // Rule ID 11453 //
     /*  712675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  712686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  712689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  712692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  712695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712721 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  712724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712743 */     GIR_RootConstrainSelectedInstOperands,
     /*  712744 */     // GIR_Coverage, 11453,
     /*  712744 */     GIR_EraseRootFromParent_Done,
     /*  712745 */   // Label 11232: @712745
     /*  712745 */   GIM_Try, /*On fail goto*//*Label 11233*/ GIMT_Encode4(712820), // Rule ID 11456 //
     /*  712750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  712761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  712764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  712767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  712770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712796 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  712799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712818 */     GIR_RootConstrainSelectedInstOperands,
     /*  712819 */     // GIR_Coverage, 11456,
     /*  712819 */     GIR_EraseRootFromParent_Done,
     /*  712820 */   // Label 11233: @712820
     /*  712820 */   GIM_Try, /*On fail goto*//*Label 11234*/ GIMT_Encode4(712895), // Rule ID 11457 //
     /*  712825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  712836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  712839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  712842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  712845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712871 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  712874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712893 */     GIR_RootConstrainSelectedInstOperands,
     /*  712894 */     // GIR_Coverage, 11457,
     /*  712894 */     GIR_EraseRootFromParent_Done,
     /*  712895 */   // Label 11234: @712895
     /*  712895 */   GIM_Try, /*On fail goto*//*Label 11235*/ GIMT_Encode4(712970), // Rule ID 11460 //
     /*  712900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  712911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  712914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  712917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  712920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712946 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  712949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712968 */     GIR_RootConstrainSelectedInstOperands,
     /*  712969 */     // GIR_Coverage, 11460,
     /*  712969 */     GIR_EraseRootFromParent_Done,
     /*  712970 */   // Label 11235: @712970
     /*  712970 */   GIM_Try, /*On fail goto*//*Label 11236*/ GIMT_Encode4(713045), // Rule ID 11461 //
     /*  712975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  712986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  712989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  712992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  712995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713021 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  713021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  713024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  713040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713043 */     GIR_RootConstrainSelectedInstOperands,
     /*  713044 */     // GIR_Coverage, 11461,
     /*  713044 */     GIR_EraseRootFromParent_Done,
     /*  713045 */   // Label 11236: @713045
     /*  713045 */   GIM_Try, /*On fail goto*//*Label 11237*/ GIMT_Encode4(713120), // Rule ID 11464 //
     /*  713050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  713061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  713064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  713067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  713070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  713096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  713099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713118 */     GIR_RootConstrainSelectedInstOperands,
     /*  713119 */     // GIR_Coverage, 11464,
     /*  713119 */     GIR_EraseRootFromParent_Done,
     /*  713120 */   // Label 11237: @713120
     /*  713120 */   GIM_Try, /*On fail goto*//*Label 11238*/ GIMT_Encode4(713195), // Rule ID 11465 //
     /*  713125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  713136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  713139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  713142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  713145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713171 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  713171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  713174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713193 */     GIR_RootConstrainSelectedInstOperands,
     /*  713194 */     // GIR_Coverage, 11465,
     /*  713194 */     GIR_EraseRootFromParent_Done,
     /*  713195 */   // Label 11238: @713195
     /*  713195 */   GIM_Try, /*On fail goto*//*Label 11239*/ GIMT_Encode4(713270), // Rule ID 11468 //
     /*  713200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  713211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  713214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  713217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  713220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713246 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  713246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  713249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713268 */     GIR_RootConstrainSelectedInstOperands,
     /*  713269 */     // GIR_Coverage, 11468,
     /*  713269 */     GIR_EraseRootFromParent_Done,
     /*  713270 */   // Label 11239: @713270
     /*  713270 */   GIM_Try, /*On fail goto*//*Label 11240*/ GIMT_Encode4(713345), // Rule ID 11469 //
     /*  713275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  713286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  713289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  713292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  713295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713321 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  713321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  713324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713343 */     GIR_RootConstrainSelectedInstOperands,
     /*  713344 */     // GIR_Coverage, 11469,
     /*  713344 */     GIR_EraseRootFromParent_Done,
     /*  713345 */   // Label 11240: @713345
     /*  713345 */   GIM_Try, /*On fail goto*//*Label 11241*/ GIMT_Encode4(713420), // Rule ID 11472 //
     /*  713350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  713361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  713364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  713367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  713370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713396 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  713396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  713399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713418 */     GIR_RootConstrainSelectedInstOperands,
     /*  713419 */     // GIR_Coverage, 11472,
     /*  713419 */     GIR_EraseRootFromParent_Done,
     /*  713420 */   // Label 11241: @713420
     /*  713420 */   GIM_Try, /*On fail goto*//*Label 11242*/ GIMT_Encode4(713495), // Rule ID 11473 //
     /*  713425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  713436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  713439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  713442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  713445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713471 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  713471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  713474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713493 */     GIR_RootConstrainSelectedInstOperands,
     /*  713494 */     // GIR_Coverage, 11473,
     /*  713494 */     GIR_EraseRootFromParent_Done,
     /*  713495 */   // Label 11242: @713495
     /*  713495 */   GIM_Try, /*On fail goto*//*Label 11243*/ GIMT_Encode4(713570), // Rule ID 11476 //
     /*  713500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  713511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  713514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  713517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  713520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713546 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  713546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  713549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713568 */     GIR_RootConstrainSelectedInstOperands,
     /*  713569 */     // GIR_Coverage, 11476,
     /*  713569 */     GIR_EraseRootFromParent_Done,
     /*  713570 */   // Label 11243: @713570
     /*  713570 */   GIM_Try, /*On fail goto*//*Label 11244*/ GIMT_Encode4(713645), // Rule ID 11477 //
     /*  713575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  713586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  713589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  713592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  713595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713621 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  713621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  713624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713643 */     GIR_RootConstrainSelectedInstOperands,
     /*  713644 */     // GIR_Coverage, 11477,
     /*  713644 */     GIR_EraseRootFromParent_Done,
     /*  713645 */   // Label 11244: @713645
     /*  713645 */   GIM_Try, /*On fail goto*//*Label 11245*/ GIMT_Encode4(713720), // Rule ID 11480 //
     /*  713650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  713661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  713664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  713667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  713670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713696 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  713696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  713699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713718 */     GIR_RootConstrainSelectedInstOperands,
     /*  713719 */     // GIR_Coverage, 11480,
     /*  713719 */     GIR_EraseRootFromParent_Done,
     /*  713720 */   // Label 11245: @713720
     /*  713720 */   GIM_Try, /*On fail goto*//*Label 11246*/ GIMT_Encode4(713795), // Rule ID 11481 //
     /*  713725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  713736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  713739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  713742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  713745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713771 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  713771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  713774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713793 */     GIR_RootConstrainSelectedInstOperands,
     /*  713794 */     // GIR_Coverage, 11481,
     /*  713794 */     GIR_EraseRootFromParent_Done,
     /*  713795 */   // Label 11246: @713795
     /*  713795 */   GIM_Try, /*On fail goto*//*Label 11247*/ GIMT_Encode4(713870), // Rule ID 11484 //
     /*  713800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  713811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  713814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  713817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  713820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713846 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  713846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  713849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713868 */     GIR_RootConstrainSelectedInstOperands,
     /*  713869 */     // GIR_Coverage, 11484,
     /*  713869 */     GIR_EraseRootFromParent_Done,
     /*  713870 */   // Label 11247: @713870
     /*  713870 */   GIM_Try, /*On fail goto*//*Label 11248*/ GIMT_Encode4(713945), // Rule ID 11485 //
     /*  713875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  713886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  713889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  713892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  713895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713921 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  713921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  713924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713943 */     GIR_RootConstrainSelectedInstOperands,
     /*  713944 */     // GIR_Coverage, 11485,
     /*  713944 */     GIR_EraseRootFromParent_Done,
     /*  713945 */   // Label 11248: @713945
     /*  713945 */   GIM_Try, /*On fail goto*//*Label 11249*/ GIMT_Encode4(714020), // Rule ID 11488 //
     /*  713950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  713961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  713964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  713967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  713996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  713999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714018 */     GIR_RootConstrainSelectedInstOperands,
     /*  714019 */     // GIR_Coverage, 11488,
     /*  714019 */     GIR_EraseRootFromParent_Done,
     /*  714020 */   // Label 11249: @714020
     /*  714020 */   GIM_Try, /*On fail goto*//*Label 11250*/ GIMT_Encode4(714095), // Rule ID 11489 //
     /*  714025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  714036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  714039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  714042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714071 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  714071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  714074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714093 */     GIR_RootConstrainSelectedInstOperands,
     /*  714094 */     // GIR_Coverage, 11489,
     /*  714094 */     GIR_EraseRootFromParent_Done,
     /*  714095 */   // Label 11250: @714095
     /*  714095 */   GIM_Try, /*On fail goto*//*Label 11251*/ GIMT_Encode4(714170), // Rule ID 11492 //
     /*  714100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  714111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  714114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  714117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714146 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  714146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  714149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714168 */     GIR_RootConstrainSelectedInstOperands,
     /*  714169 */     // GIR_Coverage, 11492,
     /*  714169 */     GIR_EraseRootFromParent_Done,
     /*  714170 */   // Label 11251: @714170
     /*  714170 */   GIM_Try, /*On fail goto*//*Label 11252*/ GIMT_Encode4(714245), // Rule ID 11493 //
     /*  714175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  714186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  714189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  714192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714221 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  714221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  714224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714243 */     GIR_RootConstrainSelectedInstOperands,
     /*  714244 */     // GIR_Coverage, 11493,
     /*  714244 */     GIR_EraseRootFromParent_Done,
     /*  714245 */   // Label 11252: @714245
     /*  714245 */   GIM_Try, /*On fail goto*//*Label 11253*/ GIMT_Encode4(714320), // Rule ID 11496 //
     /*  714250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  714261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  714264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  714267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714296 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  714296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  714299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714318 */     GIR_RootConstrainSelectedInstOperands,
     /*  714319 */     // GIR_Coverage, 11496,
     /*  714319 */     GIR_EraseRootFromParent_Done,
     /*  714320 */   // Label 11253: @714320
     /*  714320 */   GIM_Try, /*On fail goto*//*Label 11254*/ GIMT_Encode4(714395), // Rule ID 11497 //
     /*  714325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  714336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  714339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  714342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714371 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  714371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  714374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714393 */     GIR_RootConstrainSelectedInstOperands,
     /*  714394 */     // GIR_Coverage, 11497,
     /*  714394 */     GIR_EraseRootFromParent_Done,
     /*  714395 */   // Label 11254: @714395
     /*  714395 */   GIM_Try, /*On fail goto*//*Label 11255*/ GIMT_Encode4(714470), // Rule ID 11500 //
     /*  714400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  714411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  714414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  714417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  714446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  714449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  714465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714468 */     GIR_RootConstrainSelectedInstOperands,
     /*  714469 */     // GIR_Coverage, 11500,
     /*  714469 */     GIR_EraseRootFromParent_Done,
     /*  714470 */   // Label 11255: @714470
     /*  714470 */   GIM_Try, /*On fail goto*//*Label 11256*/ GIMT_Encode4(714545), // Rule ID 11501 //
     /*  714475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  714486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  714489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  714492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714521 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  714521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  714524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  714540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714543 */     GIR_RootConstrainSelectedInstOperands,
     /*  714544 */     // GIR_Coverage, 11501,
     /*  714544 */     GIR_EraseRootFromParent_Done,
     /*  714545 */   // Label 11256: @714545
     /*  714545 */   GIM_Try, /*On fail goto*//*Label 11257*/ GIMT_Encode4(714620), // Rule ID 11504 //
     /*  714550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  714561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  714564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  714567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714596 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  714596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  714599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  714615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714618 */     GIR_RootConstrainSelectedInstOperands,
     /*  714619 */     // GIR_Coverage, 11504,
     /*  714619 */     GIR_EraseRootFromParent_Done,
     /*  714620 */   // Label 11257: @714620
     /*  714620 */   GIM_Try, /*On fail goto*//*Label 11258*/ GIMT_Encode4(714695), // Rule ID 11505 //
     /*  714625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  714636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  714639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  714642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714671 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  714671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  714674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  714690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714693 */     GIR_RootConstrainSelectedInstOperands,
     /*  714694 */     // GIR_Coverage, 11505,
     /*  714694 */     GIR_EraseRootFromParent_Done,
     /*  714695 */   // Label 11258: @714695
     /*  714695 */   GIM_Try, /*On fail goto*//*Label 11259*/ GIMT_Encode4(714770), // Rule ID 11508 //
     /*  714700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  714711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  714714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  714717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  714746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  714749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  714765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714768 */     GIR_RootConstrainSelectedInstOperands,
     /*  714769 */     // GIR_Coverage, 11508,
     /*  714769 */     GIR_EraseRootFromParent_Done,
     /*  714770 */   // Label 11259: @714770
     /*  714770 */   GIM_Try, /*On fail goto*//*Label 11260*/ GIMT_Encode4(714845), // Rule ID 11509 //
     /*  714775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  714786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  714789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  714792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714821 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  714821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  714824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  714840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714843 */     GIR_RootConstrainSelectedInstOperands,
     /*  714844 */     // GIR_Coverage, 11509,
     /*  714844 */     GIR_EraseRootFromParent_Done,
     /*  714845 */   // Label 11260: @714845
     /*  714845 */   GIM_Try, /*On fail goto*//*Label 11261*/ GIMT_Encode4(714920), // Rule ID 11512 //
     /*  714850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  714861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  714864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  714867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  714896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  714899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714918 */     GIR_RootConstrainSelectedInstOperands,
     /*  714919 */     // GIR_Coverage, 11512,
     /*  714919 */     GIR_EraseRootFromParent_Done,
     /*  714920 */   // Label 11261: @714920
     /*  714920 */   GIM_Try, /*On fail goto*//*Label 11262*/ GIMT_Encode4(714995), // Rule ID 11513 //
     /*  714925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  714936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  714939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  714942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714971 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  714971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  714974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714993 */     GIR_RootConstrainSelectedInstOperands,
     /*  714994 */     // GIR_Coverage, 11513,
     /*  714994 */     GIR_EraseRootFromParent_Done,
     /*  714995 */   // Label 11262: @714995
     /*  714995 */   GIM_Try, /*On fail goto*//*Label 11263*/ GIMT_Encode4(715070), // Rule ID 11516 //
     /*  715000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  715011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  715014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  715017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715046 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  715046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715068 */     GIR_RootConstrainSelectedInstOperands,
     /*  715069 */     // GIR_Coverage, 11516,
     /*  715069 */     GIR_EraseRootFromParent_Done,
     /*  715070 */   // Label 11263: @715070
     /*  715070 */   GIM_Try, /*On fail goto*//*Label 11264*/ GIMT_Encode4(715145), // Rule ID 11517 //
     /*  715075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  715086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  715089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  715092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715121 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  715121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715143 */     GIR_RootConstrainSelectedInstOperands,
     /*  715144 */     // GIR_Coverage, 11517,
     /*  715144 */     GIR_EraseRootFromParent_Done,
     /*  715145 */   // Label 11264: @715145
     /*  715145 */   GIM_Try, /*On fail goto*//*Label 11265*/ GIMT_Encode4(715220), // Rule ID 11520 //
     /*  715150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  715161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  715164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  715167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  715196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  715215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715218 */     GIR_RootConstrainSelectedInstOperands,
     /*  715219 */     // GIR_Coverage, 11520,
     /*  715219 */     GIR_EraseRootFromParent_Done,
     /*  715220 */   // Label 11265: @715220
     /*  715220 */   GIM_Try, /*On fail goto*//*Label 11266*/ GIMT_Encode4(715295), // Rule ID 11521 //
     /*  715225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  715236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  715239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  715242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715271 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  715271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  715290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715293 */     GIR_RootConstrainSelectedInstOperands,
     /*  715294 */     // GIR_Coverage, 11521,
     /*  715294 */     GIR_EraseRootFromParent_Done,
     /*  715295 */   // Label 11266: @715295
     /*  715295 */   GIM_Try, /*On fail goto*//*Label 11267*/ GIMT_Encode4(715370), // Rule ID 11524 //
     /*  715300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  715311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  715314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  715317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  715346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  715349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715368 */     GIR_RootConstrainSelectedInstOperands,
     /*  715369 */     // GIR_Coverage, 11524,
     /*  715369 */     GIR_EraseRootFromParent_Done,
     /*  715370 */   // Label 11267: @715370
     /*  715370 */   GIM_Try, /*On fail goto*//*Label 11268*/ GIMT_Encode4(715445), // Rule ID 11525 //
     /*  715375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  715386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  715389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  715392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715421 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  715421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  715424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715443 */     GIR_RootConstrainSelectedInstOperands,
     /*  715444 */     // GIR_Coverage, 11525,
     /*  715444 */     GIR_EraseRootFromParent_Done,
     /*  715445 */   // Label 11268: @715445
     /*  715445 */   GIM_Try, /*On fail goto*//*Label 11269*/ GIMT_Encode4(715520), // Rule ID 11528 //
     /*  715450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  715461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  715464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  715467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715496 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  715496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  715499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715518 */     GIR_RootConstrainSelectedInstOperands,
     /*  715519 */     // GIR_Coverage, 11528,
     /*  715519 */     GIR_EraseRootFromParent_Done,
     /*  715520 */   // Label 11269: @715520
     /*  715520 */   GIM_Try, /*On fail goto*//*Label 11270*/ GIMT_Encode4(715595), // Rule ID 11529 //
     /*  715525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  715536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  715539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  715542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715571 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  715571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  715574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715593 */     GIR_RootConstrainSelectedInstOperands,
     /*  715594 */     // GIR_Coverage, 11529,
     /*  715594 */     GIR_EraseRootFromParent_Done,
     /*  715595 */   // Label 11270: @715595
     /*  715595 */   GIM_Try, /*On fail goto*//*Label 11271*/ GIMT_Encode4(715670), // Rule ID 11532 //
     /*  715600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  715611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  715614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  715617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715646 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  715646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  715649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715668 */     GIR_RootConstrainSelectedInstOperands,
     /*  715669 */     // GIR_Coverage, 11532,
     /*  715669 */     GIR_EraseRootFromParent_Done,
     /*  715670 */   // Label 11271: @715670
     /*  715670 */   GIM_Try, /*On fail goto*//*Label 11272*/ GIMT_Encode4(715745), // Rule ID 11533 //
     /*  715675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  715686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  715689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  715692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715721 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  715721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  715724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715743 */     GIR_RootConstrainSelectedInstOperands,
     /*  715744 */     // GIR_Coverage, 11533,
     /*  715744 */     GIR_EraseRootFromParent_Done,
     /*  715745 */   // Label 11272: @715745
     /*  715745 */   GIM_Try, /*On fail goto*//*Label 11273*/ GIMT_Encode4(715820), // Rule ID 11536 //
     /*  715750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  715761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  715764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  715767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  715796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  715799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715818 */     GIR_RootConstrainSelectedInstOperands,
     /*  715819 */     // GIR_Coverage, 11536,
     /*  715819 */     GIR_EraseRootFromParent_Done,
     /*  715820 */   // Label 11273: @715820
     /*  715820 */   GIM_Try, /*On fail goto*//*Label 11274*/ GIMT_Encode4(715895), // Rule ID 11537 //
     /*  715825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  715836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  715839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  715842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715871 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  715871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  715874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715893 */     GIR_RootConstrainSelectedInstOperands,
     /*  715894 */     // GIR_Coverage, 11537,
     /*  715894 */     GIR_EraseRootFromParent_Done,
     /*  715895 */   // Label 11274: @715895
     /*  715895 */   GIM_Try, /*On fail goto*//*Label 11275*/ GIMT_Encode4(715970), // Rule ID 11540 //
     /*  715900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  715911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  715914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  715917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715946 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  715946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  715949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715968 */     GIR_RootConstrainSelectedInstOperands,
     /*  715969 */     // GIR_Coverage, 11540,
     /*  715969 */     GIR_EraseRootFromParent_Done,
     /*  715970 */   // Label 11275: @715970
     /*  715970 */   GIM_Try, /*On fail goto*//*Label 11276*/ GIMT_Encode4(716045), // Rule ID 11541 //
     /*  715975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  715986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  715989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  715992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716021 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  716021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716043 */     GIR_RootConstrainSelectedInstOperands,
     /*  716044 */     // GIR_Coverage, 11541,
     /*  716044 */     GIR_EraseRootFromParent_Done,
     /*  716045 */   // Label 11276: @716045
     /*  716045 */   GIM_Try, /*On fail goto*//*Label 11277*/ GIMT_Encode4(716120), // Rule ID 11544 //
     /*  716050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  716061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  716064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  716067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716096 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  716096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716118 */     GIR_RootConstrainSelectedInstOperands,
     /*  716119 */     // GIR_Coverage, 11544,
     /*  716119 */     GIR_EraseRootFromParent_Done,
     /*  716120 */   // Label 11277: @716120
     /*  716120 */   GIM_Try, /*On fail goto*//*Label 11278*/ GIMT_Encode4(716195), // Rule ID 11545 //
     /*  716125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  716136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  716139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  716142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716171 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  716171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716193 */     GIR_RootConstrainSelectedInstOperands,
     /*  716194 */     // GIR_Coverage, 11545,
     /*  716194 */     GIR_EraseRootFromParent_Done,
     /*  716195 */   // Label 11278: @716195
     /*  716195 */   GIM_Try, /*On fail goto*//*Label 11279*/ GIMT_Encode4(716270), // Rule ID 11548 //
     /*  716200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  716211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  716214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  716217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  716246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  716249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716268 */     GIR_RootConstrainSelectedInstOperands,
     /*  716269 */     // GIR_Coverage, 11548,
     /*  716269 */     GIR_EraseRootFromParent_Done,
     /*  716270 */   // Label 11279: @716270
     /*  716270 */   GIM_Try, /*On fail goto*//*Label 11280*/ GIMT_Encode4(716345), // Rule ID 11549 //
     /*  716275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  716286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  716289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  716292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716321 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  716321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  716324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716343 */     GIR_RootConstrainSelectedInstOperands,
     /*  716344 */     // GIR_Coverage, 11549,
     /*  716344 */     GIR_EraseRootFromParent_Done,
     /*  716345 */   // Label 11280: @716345
     /*  716345 */   GIM_Try, /*On fail goto*//*Label 11281*/ GIMT_Encode4(716420), // Rule ID 11552 //
     /*  716350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  716361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  716364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  716367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716396 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  716396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716418 */     GIR_RootConstrainSelectedInstOperands,
     /*  716419 */     // GIR_Coverage, 11552,
     /*  716419 */     GIR_EraseRootFromParent_Done,
     /*  716420 */   // Label 11281: @716420
     /*  716420 */   GIM_Try, /*On fail goto*//*Label 11282*/ GIMT_Encode4(716495), // Rule ID 11553 //
     /*  716425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  716436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  716439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  716442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716471 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  716471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716493 */     GIR_RootConstrainSelectedInstOperands,
     /*  716494 */     // GIR_Coverage, 11553,
     /*  716494 */     GIR_EraseRootFromParent_Done,
     /*  716495 */   // Label 11282: @716495
     /*  716495 */   GIM_Try, /*On fail goto*//*Label 11283*/ GIMT_Encode4(716570), // Rule ID 11556 //
     /*  716500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  716511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  716514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  716517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  716546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716568 */     GIR_RootConstrainSelectedInstOperands,
     /*  716569 */     // GIR_Coverage, 11556,
     /*  716569 */     GIR_EraseRootFromParent_Done,
     /*  716570 */   // Label 11283: @716570
     /*  716570 */   GIM_Try, /*On fail goto*//*Label 11284*/ GIMT_Encode4(716645), // Rule ID 11557 //
     /*  716575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  716586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  716589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  716592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716621 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  716621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716643 */     GIR_RootConstrainSelectedInstOperands,
     /*  716644 */     // GIR_Coverage, 11557,
     /*  716644 */     GIR_EraseRootFromParent_Done,
     /*  716645 */   // Label 11284: @716645
     /*  716645 */   GIM_Try, /*On fail goto*//*Label 11285*/ GIMT_Encode4(716720), // Rule ID 11560 //
     /*  716650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  716658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  716661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  716664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  716667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  716670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716696 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  716699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716718 */     GIR_RootConstrainSelectedInstOperands,
     /*  716719 */     // GIR_Coverage, 11560,
     /*  716719 */     GIR_EraseRootFromParent_Done,
     /*  716720 */   // Label 11285: @716720
     /*  716720 */   GIM_Try, /*On fail goto*//*Label 11286*/ GIMT_Encode4(716795), // Rule ID 11561 //
     /*  716725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  716733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  716736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  716739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  716742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  716745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716771 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  716774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716793 */     GIR_RootConstrainSelectedInstOperands,
     /*  716794 */     // GIR_Coverage, 11561,
     /*  716794 */     GIR_EraseRootFromParent_Done,
     /*  716795 */   // Label 11286: @716795
     /*  716795 */   GIM_Try, /*On fail goto*//*Label 11287*/ GIMT_Encode4(716870), // Rule ID 11564 //
     /*  716800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  716808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  716811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  716814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  716817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  716820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  716849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716868 */     GIR_RootConstrainSelectedInstOperands,
     /*  716869 */     // GIR_Coverage, 11564,
     /*  716869 */     GIR_EraseRootFromParent_Done,
     /*  716870 */   // Label 11287: @716870
     /*  716870 */   GIM_Try, /*On fail goto*//*Label 11288*/ GIMT_Encode4(716945), // Rule ID 11565 //
     /*  716875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  716883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  716886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  716889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  716892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  716895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  716924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716943 */     GIR_RootConstrainSelectedInstOperands,
     /*  716944 */     // GIR_Coverage, 11565,
     /*  716944 */     GIR_EraseRootFromParent_Done,
     /*  716945 */   // Label 11288: @716945
     /*  716945 */   GIM_Try, /*On fail goto*//*Label 11289*/ GIMT_Encode4(717020), // Rule ID 11568 //
     /*  716950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  716958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  716961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  716964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  716967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  716970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  716999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717018 */     GIR_RootConstrainSelectedInstOperands,
     /*  717019 */     // GIR_Coverage, 11568,
     /*  717019 */     GIR_EraseRootFromParent_Done,
     /*  717020 */   // Label 11289: @717020
     /*  717020 */   GIM_Try, /*On fail goto*//*Label 11290*/ GIMT_Encode4(717095), // Rule ID 11569 //
     /*  717025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  717036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  717039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  717042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  717045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717071 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  717074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717093 */     GIR_RootConstrainSelectedInstOperands,
     /*  717094 */     // GIR_Coverage, 11569,
     /*  717094 */     GIR_EraseRootFromParent_Done,
     /*  717095 */   // Label 11290: @717095
     /*  717095 */   GIM_Try, /*On fail goto*//*Label 11291*/ GIMT_Encode4(717170), // Rule ID 11572 //
     /*  717100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  717103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  717111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  717114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  717117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  717120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  717149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717168 */     GIR_RootConstrainSelectedInstOperands,
     /*  717169 */     // GIR_Coverage, 11572,
     /*  717169 */     GIR_EraseRootFromParent_Done,
     /*  717170 */   // Label 11291: @717170
     /*  717170 */   GIM_Try, /*On fail goto*//*Label 11292*/ GIMT_Encode4(717245), // Rule ID 11573 //
     /*  717175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  717186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  717189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  717192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  717195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717221 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  717224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717243 */     GIR_RootConstrainSelectedInstOperands,
     /*  717244 */     // GIR_Coverage, 11573,
     /*  717244 */     GIR_EraseRootFromParent_Done,
     /*  717245 */   // Label 11292: @717245
     /*  717245 */   GIM_Try, /*On fail goto*//*Label 11293*/ GIMT_Encode4(717320), // Rule ID 11576 //
     /*  717250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  717253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  717270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717296 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  717299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717318 */     GIR_RootConstrainSelectedInstOperands,
     /*  717319 */     // GIR_Coverage, 11576,
     /*  717319 */     GIR_EraseRootFromParent_Done,
     /*  717320 */   // Label 11293: @717320
     /*  717320 */   GIM_Try, /*On fail goto*//*Label 11294*/ GIMT_Encode4(717395), // Rule ID 11577 //
     /*  717325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  717345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717371 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  717374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717393 */     GIR_RootConstrainSelectedInstOperands,
     /*  717394 */     // GIR_Coverage, 11577,
     /*  717394 */     GIR_EraseRootFromParent_Done,
     /*  717395 */   // Label 11294: @717395
     /*  717395 */   GIM_Try, /*On fail goto*//*Label 11295*/ GIMT_Encode4(717470), // Rule ID 11580 //
     /*  717400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  717403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  717411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  717414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  717417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  717420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  717449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717468 */     GIR_RootConstrainSelectedInstOperands,
     /*  717469 */     // GIR_Coverage, 11580,
     /*  717469 */     GIR_EraseRootFromParent_Done,
     /*  717470 */   // Label 11295: @717470
     /*  717470 */   GIM_Try, /*On fail goto*//*Label 11296*/ GIMT_Encode4(717545), // Rule ID 11581 //
     /*  717475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  717486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  717489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  717492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  717495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  717524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717543 */     GIR_RootConstrainSelectedInstOperands,
     /*  717544 */     // GIR_Coverage, 11581,
     /*  717544 */     GIR_EraseRootFromParent_Done,
     /*  717545 */   // Label 11296: @717545
     /*  717545 */   GIM_Try, /*On fail goto*//*Label 11297*/ GIMT_Encode4(717620), // Rule ID 11584 //
     /*  717550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  717553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  717561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  717564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  717567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  717570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  717599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717618 */     GIR_RootConstrainSelectedInstOperands,
     /*  717619 */     // GIR_Coverage, 11584,
     /*  717619 */     GIR_EraseRootFromParent_Done,
     /*  717620 */   // Label 11297: @717620
     /*  717620 */   GIM_Try, /*On fail goto*//*Label 11298*/ GIMT_Encode4(717695), // Rule ID 11585 //
     /*  717625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  717636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  717639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  717642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  717645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717671 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  717674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717693 */     GIR_RootConstrainSelectedInstOperands,
     /*  717694 */     // GIR_Coverage, 11585,
     /*  717694 */     GIR_EraseRootFromParent_Done,
     /*  717695 */   // Label 11298: @717695
     /*  717695 */   GIM_Try, /*On fail goto*//*Label 11299*/ GIMT_Encode4(717770), // Rule ID 11588 //
     /*  717700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  717703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  717711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  717714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  717717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  717720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717746 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  717749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717768 */     GIR_RootConstrainSelectedInstOperands,
     /*  717769 */     // GIR_Coverage, 11588,
     /*  717769 */     GIR_EraseRootFromParent_Done,
     /*  717770 */   // Label 11299: @717770
     /*  717770 */   GIM_Try, /*On fail goto*//*Label 11300*/ GIMT_Encode4(717845), // Rule ID 11589 //
     /*  717775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  717786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  717789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  717792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  717795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717821 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  717824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717843 */     GIR_RootConstrainSelectedInstOperands,
     /*  717844 */     // GIR_Coverage, 11589,
     /*  717844 */     GIR_EraseRootFromParent_Done,
     /*  717845 */   // Label 11300: @717845
     /*  717845 */   GIM_Try, /*On fail goto*//*Label 11301*/ GIMT_Encode4(717920), // Rule ID 11592 //
     /*  717850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  717853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  717858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  717870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717896 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  717899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717918 */     GIR_RootConstrainSelectedInstOperands,
     /*  717919 */     // GIR_Coverage, 11592,
     /*  717919 */     GIR_EraseRootFromParent_Done,
     /*  717920 */   // Label 11301: @717920
     /*  717920 */   GIM_Try, /*On fail goto*//*Label 11302*/ GIMT_Encode4(717995), // Rule ID 11593 //
     /*  717925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  717933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  717945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717971 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  717974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717993 */     GIR_RootConstrainSelectedInstOperands,
     /*  717994 */     // GIR_Coverage, 11593,
     /*  717994 */     GIR_EraseRootFromParent_Done,
     /*  717995 */   // Label 11302: @717995
     /*  717995 */   GIM_Try, /*On fail goto*//*Label 11303*/ GIMT_Encode4(718070), // Rule ID 11596 //
     /*  718000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  718011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  718014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  718017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  718020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  718049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718068 */     GIR_RootConstrainSelectedInstOperands,
     /*  718069 */     // GIR_Coverage, 11596,
     /*  718069 */     GIR_EraseRootFromParent_Done,
     /*  718070 */   // Label 11303: @718070
     /*  718070 */   GIM_Try, /*On fail goto*//*Label 11304*/ GIMT_Encode4(718145), // Rule ID 11597 //
     /*  718075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  718086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  718089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  718092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  718095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  718124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718143 */     GIR_RootConstrainSelectedInstOperands,
     /*  718144 */     // GIR_Coverage, 11597,
     /*  718144 */     GIR_EraseRootFromParent_Done,
     /*  718145 */   // Label 11304: @718145
     /*  718145 */   GIM_Try, /*On fail goto*//*Label 11305*/ GIMT_Encode4(718220), // Rule ID 11600 //
     /*  718150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  718161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  718164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  718167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  718170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  718199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718218 */     GIR_RootConstrainSelectedInstOperands,
     /*  718219 */     // GIR_Coverage, 11600,
     /*  718219 */     GIR_EraseRootFromParent_Done,
     /*  718220 */   // Label 11305: @718220
     /*  718220 */   GIM_Try, /*On fail goto*//*Label 11306*/ GIMT_Encode4(718295), // Rule ID 11601 //
     /*  718225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  718236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  718239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  718242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  718245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  718274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718293 */     GIR_RootConstrainSelectedInstOperands,
     /*  718294 */     // GIR_Coverage, 11601,
     /*  718294 */     GIR_EraseRootFromParent_Done,
     /*  718295 */   // Label 11306: @718295
     /*  718295 */   GIM_Try, /*On fail goto*//*Label 11307*/ GIMT_Encode4(718370), // Rule ID 11604 //
     /*  718300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  718311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  718314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  718317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  718320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  718349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718368 */     GIR_RootConstrainSelectedInstOperands,
     /*  718369 */     // GIR_Coverage, 11604,
     /*  718369 */     GIR_EraseRootFromParent_Done,
     /*  718370 */   // Label 11307: @718370
     /*  718370 */   GIM_Try, /*On fail goto*//*Label 11308*/ GIMT_Encode4(718445), // Rule ID 11605 //
     /*  718375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  718386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  718389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  718392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  718395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718421 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  718424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718443 */     GIR_RootConstrainSelectedInstOperands,
     /*  718444 */     // GIR_Coverage, 11605,
     /*  718444 */     GIR_EraseRootFromParent_Done,
     /*  718445 */   // Label 11308: @718445
     /*  718445 */   GIM_Try, /*On fail goto*//*Label 11309*/ GIMT_Encode4(718520), // Rule ID 11608 //
     /*  718450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  718461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  718464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  718467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  718470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718496 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  718499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718518 */     GIR_RootConstrainSelectedInstOperands,
     /*  718519 */     // GIR_Coverage, 11608,
     /*  718519 */     GIR_EraseRootFromParent_Done,
     /*  718520 */   // Label 11309: @718520
     /*  718520 */   GIM_Try, /*On fail goto*//*Label 11310*/ GIMT_Encode4(718595), // Rule ID 11609 //
     /*  718525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  718536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  718539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  718542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  718545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718571 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  718574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718593 */     GIR_RootConstrainSelectedInstOperands,
     /*  718594 */     // GIR_Coverage, 11609,
     /*  718594 */     GIR_EraseRootFromParent_Done,
     /*  718595 */   // Label 11310: @718595
     /*  718595 */   GIM_Try, /*On fail goto*//*Label 11311*/ GIMT_Encode4(718670), // Rule ID 11612 //
     /*  718600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  718611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  718614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  718617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  718620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  718649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718668 */     GIR_RootConstrainSelectedInstOperands,
     /*  718669 */     // GIR_Coverage, 11612,
     /*  718669 */     GIR_EraseRootFromParent_Done,
     /*  718670 */   // Label 11311: @718670
     /*  718670 */   GIM_Try, /*On fail goto*//*Label 11312*/ GIMT_Encode4(718745), // Rule ID 11613 //
     /*  718675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  718686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  718689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  718692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  718695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718721 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  718724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718743 */     GIR_RootConstrainSelectedInstOperands,
     /*  718744 */     // GIR_Coverage, 11613,
     /*  718744 */     GIR_EraseRootFromParent_Done,
     /*  718745 */   // Label 11312: @718745
     /*  718745 */   GIM_Try, /*On fail goto*//*Label 11313*/ GIMT_Encode4(718820), // Rule ID 11616 //
     /*  718750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  718761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  718764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  718767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  718770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718796 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  718799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718818 */     GIR_RootConstrainSelectedInstOperands,
     /*  718819 */     // GIR_Coverage, 11616,
     /*  718819 */     GIR_EraseRootFromParent_Done,
     /*  718820 */   // Label 11313: @718820
     /*  718820 */   GIM_Try, /*On fail goto*//*Label 11314*/ GIMT_Encode4(718895), // Rule ID 11617 //
     /*  718825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  718836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  718839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  718842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  718845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718871 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  718874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718893 */     GIR_RootConstrainSelectedInstOperands,
     /*  718894 */     // GIR_Coverage, 11617,
     /*  718894 */     GIR_EraseRootFromParent_Done,
     /*  718895 */   // Label 11314: @718895
     /*  718895 */   GIM_Try, /*On fail goto*//*Label 11315*/ GIMT_Encode4(718970), // Rule ID 11620 //
     /*  718900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  718911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  718914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  718917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  718920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  718949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718968 */     GIR_RootConstrainSelectedInstOperands,
     /*  718969 */     // GIR_Coverage, 11620,
     /*  718969 */     GIR_EraseRootFromParent_Done,
     /*  718970 */   // Label 11315: @718970
     /*  718970 */   GIM_Try, /*On fail goto*//*Label 11316*/ GIMT_Encode4(719045), // Rule ID 11621 //
     /*  718975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  718986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  718989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  718992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  718995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719021 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  719024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719043 */     GIR_RootConstrainSelectedInstOperands,
     /*  719044 */     // GIR_Coverage, 11621,
     /*  719044 */     GIR_EraseRootFromParent_Done,
     /*  719045 */   // Label 11316: @719045
     /*  719045 */   GIM_Try, /*On fail goto*//*Label 11317*/ GIMT_Encode4(719120), // Rule ID 11624 //
     /*  719050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  719061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  719064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  719067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  719070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719096 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  719099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719118 */     GIR_RootConstrainSelectedInstOperands,
     /*  719119 */     // GIR_Coverage, 11624,
     /*  719119 */     GIR_EraseRootFromParent_Done,
     /*  719120 */   // Label 11317: @719120
     /*  719120 */   GIM_Try, /*On fail goto*//*Label 11318*/ GIMT_Encode4(719195), // Rule ID 11625 //
     /*  719125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  719128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  719136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  719139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  719142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  719145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719171 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  719174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719193 */     GIR_RootConstrainSelectedInstOperands,
     /*  719194 */     // GIR_Coverage, 11625,
     /*  719194 */     GIR_EraseRootFromParent_Done,
     /*  719195 */   // Label 11318: @719195
     /*  719195 */   GIM_Try, /*On fail goto*//*Label 11319*/ GIMT_Encode4(719270), // Rule ID 11628 //
     /*  719200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  719220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  719249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719268 */     GIR_RootConstrainSelectedInstOperands,
     /*  719269 */     // GIR_Coverage, 11628,
     /*  719269 */     GIR_EraseRootFromParent_Done,
     /*  719270 */   // Label 11319: @719270
     /*  719270 */   GIM_Try, /*On fail goto*//*Label 11320*/ GIMT_Encode4(719345), // Rule ID 11629 //
     /*  719275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  719278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  719295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  719324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719343 */     GIR_RootConstrainSelectedInstOperands,
     /*  719344 */     // GIR_Coverage, 11629,
     /*  719344 */     GIR_EraseRootFromParent_Done,
     /*  719345 */   // Label 11320: @719345
     /*  719345 */   GIM_Try, /*On fail goto*//*Label 11321*/ GIMT_Encode4(719420), // Rule ID 11632 //
     /*  719350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  719370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  719399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719418 */     GIR_RootConstrainSelectedInstOperands,
     /*  719419 */     // GIR_Coverage, 11632,
     /*  719419 */     GIR_EraseRootFromParent_Done,
     /*  719420 */   // Label 11321: @719420
     /*  719420 */   GIM_Try, /*On fail goto*//*Label 11322*/ GIMT_Encode4(719495), // Rule ID 11633 //
     /*  719425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  719428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  719445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719471 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  719474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719493 */     GIR_RootConstrainSelectedInstOperands,
     /*  719494 */     // GIR_Coverage, 11633,
     /*  719494 */     GIR_EraseRootFromParent_Done,
     /*  719495 */   // Label 11322: @719495
     /*  719495 */   GIM_Try, /*On fail goto*//*Label 11323*/ GIMT_Encode4(719570), // Rule ID 11636 //
     /*  719500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  719511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  719514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  719517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  719520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  719549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719568 */     GIR_RootConstrainSelectedInstOperands,
     /*  719569 */     // GIR_Coverage, 11636,
     /*  719569 */     GIR_EraseRootFromParent_Done,
     /*  719570 */   // Label 11323: @719570
     /*  719570 */   GIM_Try, /*On fail goto*//*Label 11324*/ GIMT_Encode4(719645), // Rule ID 11637 //
     /*  719575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  719578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  719586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  719589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  719592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  719595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719621 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  719624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719643 */     GIR_RootConstrainSelectedInstOperands,
     /*  719644 */     // GIR_Coverage, 11637,
     /*  719644 */     GIR_EraseRootFromParent_Done,
     /*  719645 */   // Label 11324: @719645
     /*  719645 */   GIM_Try, /*On fail goto*//*Label 11325*/ GIMT_Encode4(719720), // Rule ID 11640 //
     /*  719650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  719661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  719664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  719667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719696 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  719699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719718 */     GIR_RootConstrainSelectedInstOperands,
     /*  719719 */     // GIR_Coverage, 11640,
     /*  719719 */     GIR_EraseRootFromParent_Done,
     /*  719720 */   // Label 11325: @719720
     /*  719720 */   GIM_Try, /*On fail goto*//*Label 11326*/ GIMT_Encode4(719795), // Rule ID 11641 //
     /*  719725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  719728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  719736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  719739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  719742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  719745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719771 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  719774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719793 */     GIR_RootConstrainSelectedInstOperands,
     /*  719794 */     // GIR_Coverage, 11641,
     /*  719794 */     GIR_EraseRootFromParent_Done,
     /*  719795 */   // Label 11326: @719795
     /*  719795 */   GIM_Try, /*On fail goto*//*Label 11327*/ GIMT_Encode4(719870), // Rule ID 11644 //
     /*  719800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  719849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719868 */     GIR_RootConstrainSelectedInstOperands,
     /*  719869 */     // GIR_Coverage, 11644,
     /*  719869 */     GIR_EraseRootFromParent_Done,
     /*  719870 */   // Label 11327: @719870
     /*  719870 */   GIM_Try, /*On fail goto*//*Label 11328*/ GIMT_Encode4(719945), // Rule ID 11645 //
     /*  719875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  719878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  719895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  719924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719943 */     GIR_RootConstrainSelectedInstOperands,
     /*  719944 */     // GIR_Coverage, 11645,
     /*  719944 */     GIR_EraseRootFromParent_Done,
     /*  719945 */   // Label 11328: @719945
     /*  719945 */   GIM_Try, /*On fail goto*//*Label 11329*/ GIMT_Encode4(720020), // Rule ID 11648 //
     /*  719950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  719999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720018 */     GIR_RootConstrainSelectedInstOperands,
     /*  720019 */     // GIR_Coverage, 11648,
     /*  720019 */     GIR_EraseRootFromParent_Done,
     /*  720020 */   // Label 11329: @720020
     /*  720020 */   GIM_Try, /*On fail goto*//*Label 11330*/ GIMT_Encode4(720095), // Rule ID 11649 //
     /*  720025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  720028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  720033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  720036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  720039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  720042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720071 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  720071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  720074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720093 */     GIR_RootConstrainSelectedInstOperands,
     /*  720094 */     // GIR_Coverage, 11649,
     /*  720094 */     GIR_EraseRootFromParent_Done,
     /*  720095 */   // Label 11330: @720095
     /*  720095 */   GIM_Try, /*On fail goto*//*Label 11331*/ GIMT_Encode4(720170), // Rule ID 11652 //
     /*  720100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  720103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  720108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  720111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  720114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  720117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  720146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  720149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720168 */     GIR_RootConstrainSelectedInstOperands,
     /*  720169 */     // GIR_Coverage, 11652,
     /*  720169 */     GIR_EraseRootFromParent_Done,
     /*  720170 */   // Label 11331: @720170
     /*  720170 */   GIM_Try, /*On fail goto*//*Label 11332*/ GIMT_Encode4(720245), // Rule ID 11653 //
     /*  720175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  720178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  720183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  720186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  720189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  720192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720221 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  720221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  720224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720243 */     GIR_RootConstrainSelectedInstOperands,
     /*  720244 */     // GIR_Coverage, 11653,
     /*  720244 */     GIR_EraseRootFromParent_Done,
     /*  720245 */   // Label 11332: @720245
     /*  720245 */   GIM_Try, /*On fail goto*//*Label 11333*/ GIMT_Encode4(720320), // Rule ID 11656 //
     /*  720250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  720261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  720264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  720267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  720270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  720299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720318 */     GIR_RootConstrainSelectedInstOperands,
     /*  720319 */     // GIR_Coverage, 11656,
     /*  720319 */     GIR_EraseRootFromParent_Done,
     /*  720320 */   // Label 11333: @720320
     /*  720320 */   GIM_Try, /*On fail goto*//*Label 11334*/ GIMT_Encode4(720395), // Rule ID 11657 //
     /*  720325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  720336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  720339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  720342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  720345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720371 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  720374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720393 */     GIR_RootConstrainSelectedInstOperands,
     /*  720394 */     // GIR_Coverage, 11657,
     /*  720394 */     GIR_EraseRootFromParent_Done,
     /*  720395 */   // Label 11334: @720395
     /*  720395 */   GIM_Try, /*On fail goto*//*Label 11335*/ GIMT_Encode4(720470), // Rule ID 11660 //
     /*  720400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  720411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  720414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  720417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  720420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720446 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  720449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720468 */     GIR_RootConstrainSelectedInstOperands,
     /*  720469 */     // GIR_Coverage, 11660,
     /*  720469 */     GIR_EraseRootFromParent_Done,
     /*  720470 */   // Label 11335: @720470
     /*  720470 */   GIM_Try, /*On fail goto*//*Label 11336*/ GIMT_Encode4(720545), // Rule ID 11661 //
     /*  720475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  720486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  720489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  720492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  720495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720521 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  720524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720543 */     GIR_RootConstrainSelectedInstOperands,
     /*  720544 */     // GIR_Coverage, 11661,
     /*  720544 */     GIR_EraseRootFromParent_Done,
     /*  720545 */   // Label 11336: @720545
     /*  720545 */   GIM_Try, /*On fail goto*//*Label 11337*/ GIMT_Encode4(720620), // Rule ID 11664 //
     /*  720550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  720561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  720564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  720567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  720570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720596 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  720599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720618 */     GIR_RootConstrainSelectedInstOperands,
     /*  720619 */     // GIR_Coverage, 11664,
     /*  720619 */     GIR_EraseRootFromParent_Done,
     /*  720620 */   // Label 11337: @720620
     /*  720620 */   GIM_Try, /*On fail goto*//*Label 11338*/ GIMT_Encode4(720695), // Rule ID 11665 //
     /*  720625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  720636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  720639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  720642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  720645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720671 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  720674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720693 */     GIR_RootConstrainSelectedInstOperands,
     /*  720694 */     // GIR_Coverage, 11665,
     /*  720694 */     GIR_EraseRootFromParent_Done,
     /*  720695 */   // Label 11338: @720695
     /*  720695 */   GIM_Try, /*On fail goto*//*Label 11339*/ GIMT_Encode4(720770), // Rule ID 11668 //
     /*  720700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  720711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  720714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  720717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  720720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  720749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720768 */     GIR_RootConstrainSelectedInstOperands,
     /*  720769 */     // GIR_Coverage, 11668,
     /*  720769 */     GIR_EraseRootFromParent_Done,
     /*  720770 */   // Label 11339: @720770
     /*  720770 */   GIM_Try, /*On fail goto*//*Label 11340*/ GIMT_Encode4(720845), // Rule ID 11669 //
     /*  720775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  720786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  720789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  720792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  720795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720821 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  720824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720843 */     GIR_RootConstrainSelectedInstOperands,
     /*  720844 */     // GIR_Coverage, 11669,
     /*  720844 */     GIR_EraseRootFromParent_Done,
     /*  720845 */   // Label 11340: @720845
     /*  720845 */   GIM_Try, /*On fail goto*//*Label 11341*/ GIMT_Encode4(720920), // Rule ID 11672 //
     /*  720850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  720861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  720864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  720867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  720870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  720899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720918 */     GIR_RootConstrainSelectedInstOperands,
     /*  720919 */     // GIR_Coverage, 11672,
     /*  720919 */     GIR_EraseRootFromParent_Done,
     /*  720920 */   // Label 11341: @720920
     /*  720920 */   GIM_Try, /*On fail goto*//*Label 11342*/ GIMT_Encode4(720995), // Rule ID 11673 //
     /*  720925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  720936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  720939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  720942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  720945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720971 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  720974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720993 */     GIR_RootConstrainSelectedInstOperands,
     /*  720994 */     // GIR_Coverage, 11673,
     /*  720994 */     GIR_EraseRootFromParent_Done,
     /*  720995 */   // Label 11342: @720995
     /*  720995 */   GIM_Try, /*On fail goto*//*Label 11343*/ GIMT_Encode4(721070), // Rule ID 11676 //
     /*  721000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  721011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  721014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  721017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  721020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  721046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  721049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721068 */     GIR_RootConstrainSelectedInstOperands,
     /*  721069 */     // GIR_Coverage, 11676,
     /*  721069 */     GIR_EraseRootFromParent_Done,
     /*  721070 */   // Label 11343: @721070
     /*  721070 */   GIM_Try, /*On fail goto*//*Label 11344*/ GIMT_Encode4(721145), // Rule ID 11677 //
     /*  721075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  721086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  721089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  721092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  721095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721121 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  721121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  721124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721143 */     GIR_RootConstrainSelectedInstOperands,
     /*  721144 */     // GIR_Coverage, 11677,
     /*  721144 */     GIR_EraseRootFromParent_Done,
     /*  721145 */   // Label 11344: @721145
     /*  721145 */   GIM_Try, /*On fail goto*//*Label 11345*/ GIMT_Encode4(721220), // Rule ID 11680 //
     /*  721150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  721161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  721164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  721167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  721170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  721199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721218 */     GIR_RootConstrainSelectedInstOperands,
     /*  721219 */     // GIR_Coverage, 11680,
     /*  721219 */     GIR_EraseRootFromParent_Done,
     /*  721220 */   // Label 11345: @721220
     /*  721220 */   GIM_Try, /*On fail goto*//*Label 11346*/ GIMT_Encode4(721295), // Rule ID 11681 //
     /*  721225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  721236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  721239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  721242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  721245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721271 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  721274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721293 */     GIR_RootConstrainSelectedInstOperands,
     /*  721294 */     // GIR_Coverage, 11681,
     /*  721294 */     GIR_EraseRootFromParent_Done,
     /*  721295 */   // Label 11346: @721295
     /*  721295 */   GIM_Try, /*On fail goto*//*Label 11347*/ GIMT_Encode4(721370), // Rule ID 11684 //
     /*  721300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  721311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  721314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  721317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  721320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721346 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  721346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  721349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721368 */     GIR_RootConstrainSelectedInstOperands,
     /*  721369 */     // GIR_Coverage, 11684,
     /*  721369 */     GIR_EraseRootFromParent_Done,
     /*  721370 */   // Label 11347: @721370
     /*  721370 */   GIM_Try, /*On fail goto*//*Label 11348*/ GIMT_Encode4(721445), // Rule ID 11685 //
     /*  721375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  721386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  721389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  721392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  721395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721421 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  721421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  721424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721443 */     GIR_RootConstrainSelectedInstOperands,
     /*  721444 */     // GIR_Coverage, 11685,
     /*  721444 */     GIR_EraseRootFromParent_Done,
     /*  721445 */   // Label 11348: @721445
     /*  721445 */   GIM_Try, /*On fail goto*//*Label 11349*/ GIMT_Encode4(721520), // Rule ID 11688 //
     /*  721450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  721461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  721464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  721467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  721470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  721496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  721499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721518 */     GIR_RootConstrainSelectedInstOperands,
     /*  721519 */     // GIR_Coverage, 11688,
     /*  721519 */     GIR_EraseRootFromParent_Done,
     /*  721520 */   // Label 11349: @721520
     /*  721520 */   GIM_Try, /*On fail goto*//*Label 11350*/ GIMT_Encode4(721595), // Rule ID 11689 //
     /*  721525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  721536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  721539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  721542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  721545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721571 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  721571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  721574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721593 */     GIR_RootConstrainSelectedInstOperands,
     /*  721594 */     // GIR_Coverage, 11689,
     /*  721594 */     GIR_EraseRootFromParent_Done,
     /*  721595 */   // Label 11350: @721595
     /*  721595 */   GIM_Try, /*On fail goto*//*Label 11351*/ GIMT_Encode4(721670), // Rule ID 11692 //
     /*  721600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  721603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  721617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  721620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721646 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  721646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  721649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721668 */     GIR_RootConstrainSelectedInstOperands,
     /*  721669 */     // GIR_Coverage, 11692,
     /*  721669 */     GIR_EraseRootFromParent_Done,
     /*  721670 */   // Label 11351: @721670
     /*  721670 */   GIM_Try, /*On fail goto*//*Label 11352*/ GIMT_Encode4(721745), // Rule ID 11693 //
     /*  721675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  721678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  721692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  721695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721721 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  721721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  721724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721743 */     GIR_RootConstrainSelectedInstOperands,
     /*  721744 */     // GIR_Coverage, 11693,
     /*  721744 */     GIR_EraseRootFromParent_Done,
     /*  721745 */   // Label 11352: @721745
     /*  721745 */   GIM_Try, /*On fail goto*//*Label 11353*/ GIMT_Encode4(721820), // Rule ID 11696 //
     /*  721750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  721761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  721764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  721767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  721770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  721799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721818 */     GIR_RootConstrainSelectedInstOperands,
     /*  721819 */     // GIR_Coverage, 11696,
     /*  721819 */     GIR_EraseRootFromParent_Done,
     /*  721820 */   // Label 11353: @721820
     /*  721820 */   GIM_Try, /*On fail goto*//*Label 11354*/ GIMT_Encode4(721895), // Rule ID 11697 //
     /*  721825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  721836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  721839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  721842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  721845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721871 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  721874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721893 */     GIR_RootConstrainSelectedInstOperands,
     /*  721894 */     // GIR_Coverage, 11697,
     /*  721894 */     GIR_EraseRootFromParent_Done,
     /*  721895 */   // Label 11354: @721895
     /*  721895 */   GIM_Try, /*On fail goto*//*Label 11355*/ GIMT_Encode4(721970), // Rule ID 11700 //
     /*  721900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  721911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  721914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  721917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  721920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721946 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  721949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721968 */     GIR_RootConstrainSelectedInstOperands,
     /*  721969 */     // GIR_Coverage, 11700,
     /*  721969 */     GIR_EraseRootFromParent_Done,
     /*  721970 */   // Label 11355: @721970
     /*  721970 */   GIM_Try, /*On fail goto*//*Label 11356*/ GIMT_Encode4(722045), // Rule ID 11701 //
     /*  721975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  721986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  721989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  721992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  721995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722021 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  722021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  722024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722043 */     GIR_RootConstrainSelectedInstOperands,
     /*  722044 */     // GIR_Coverage, 11701,
     /*  722044 */     GIR_EraseRootFromParent_Done,
     /*  722045 */   // Label 11356: @722045
     /*  722045 */   GIM_Try, /*On fail goto*//*Label 11357*/ GIMT_Encode4(722120), // Rule ID 11704 //
     /*  722050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  722061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  722064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  722067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  722070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722096 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  722096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  722099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722118 */     GIR_RootConstrainSelectedInstOperands,
     /*  722119 */     // GIR_Coverage, 11704,
     /*  722119 */     GIR_EraseRootFromParent_Done,
     /*  722120 */   // Label 11357: @722120
     /*  722120 */   GIM_Try, /*On fail goto*//*Label 11358*/ GIMT_Encode4(722195), // Rule ID 11705 //
     /*  722125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  722136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  722139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  722142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  722145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722171 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  722171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  722174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722193 */     GIR_RootConstrainSelectedInstOperands,
     /*  722194 */     // GIR_Coverage, 11705,
     /*  722194 */     GIR_EraseRootFromParent_Done,
     /*  722195 */   // Label 11358: @722195
     /*  722195 */   GIM_Try, /*On fail goto*//*Label 11359*/ GIMT_Encode4(722270), // Rule ID 11708 //
     /*  722200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  722211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  722214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  722217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  722220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  722249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722268 */     GIR_RootConstrainSelectedInstOperands,
     /*  722269 */     // GIR_Coverage, 11708,
     /*  722269 */     GIR_EraseRootFromParent_Done,
     /*  722270 */   // Label 11359: @722270
     /*  722270 */   GIM_Try, /*On fail goto*//*Label 11360*/ GIMT_Encode4(722345), // Rule ID 11709 //
     /*  722275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  722286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  722289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  722292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  722295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  722324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722343 */     GIR_RootConstrainSelectedInstOperands,
     /*  722344 */     // GIR_Coverage, 11709,
     /*  722344 */     GIR_EraseRootFromParent_Done,
     /*  722345 */   // Label 11360: @722345
     /*  722345 */   GIM_Try, /*On fail goto*//*Label 11361*/ GIMT_Encode4(722420), // Rule ID 11712 //
     /*  722350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  722361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  722364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  722367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  722370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  722399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722418 */     GIR_RootConstrainSelectedInstOperands,
     /*  722419 */     // GIR_Coverage, 11712,
     /*  722419 */     GIR_EraseRootFromParent_Done,
     /*  722420 */   // Label 11361: @722420
     /*  722420 */   GIM_Try, /*On fail goto*//*Label 11362*/ GIMT_Encode4(722495), // Rule ID 11713 //
     /*  722425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  722436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  722439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  722442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  722445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722471 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  722474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722493 */     GIR_RootConstrainSelectedInstOperands,
     /*  722494 */     // GIR_Coverage, 11713,
     /*  722494 */     GIR_EraseRootFromParent_Done,
     /*  722495 */   // Label 11362: @722495
     /*  722495 */   GIM_Try, /*On fail goto*//*Label 11363*/ GIMT_Encode4(722570), // Rule ID 11716 //
     /*  722500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  722511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  722514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  722517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  722520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  722549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722568 */     GIR_RootConstrainSelectedInstOperands,
     /*  722569 */     // GIR_Coverage, 11716,
     /*  722569 */     GIR_EraseRootFromParent_Done,
     /*  722570 */   // Label 11363: @722570
     /*  722570 */   GIM_Try, /*On fail goto*//*Label 11364*/ GIMT_Encode4(722645), // Rule ID 11717 //
     /*  722575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  722586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  722589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  722592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  722595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722621 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  722624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722643 */     GIR_RootConstrainSelectedInstOperands,
     /*  722644 */     // GIR_Coverage, 11717,
     /*  722644 */     GIR_EraseRootFromParent_Done,
     /*  722645 */   // Label 11364: @722645
     /*  722645 */   GIM_Try, /*On fail goto*//*Label 11365*/ GIMT_Encode4(722720), // Rule ID 11720 //
     /*  722650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  722661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  722664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  722667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  722670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  722699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722718 */     GIR_RootConstrainSelectedInstOperands,
     /*  722719 */     // GIR_Coverage, 11720,
     /*  722719 */     GIR_EraseRootFromParent_Done,
     /*  722720 */   // Label 11365: @722720
     /*  722720 */   GIM_Try, /*On fail goto*//*Label 11366*/ GIMT_Encode4(722795), // Rule ID 11721 //
     /*  722725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  722736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  722739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  722742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  722745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  722774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722793 */     GIR_RootConstrainSelectedInstOperands,
     /*  722794 */     // GIR_Coverage, 11721,
     /*  722794 */     GIR_EraseRootFromParent_Done,
     /*  722795 */   // Label 11366: @722795
     /*  722795 */   GIM_Try, /*On fail goto*//*Label 11367*/ GIMT_Encode4(722870), // Rule ID 11724 //
     /*  722800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  722811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  722814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  722817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  722820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  722849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722868 */     GIR_RootConstrainSelectedInstOperands,
     /*  722869 */     // GIR_Coverage, 11724,
     /*  722869 */     GIR_EraseRootFromParent_Done,
     /*  722870 */   // Label 11367: @722870
     /*  722870 */   GIM_Try, /*On fail goto*//*Label 11368*/ GIMT_Encode4(722945), // Rule ID 11725 //
     /*  722875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  722886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  722889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  722892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  722895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722921 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  722924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722943 */     GIR_RootConstrainSelectedInstOperands,
     /*  722944 */     // GIR_Coverage, 11725,
     /*  722944 */     GIR_EraseRootFromParent_Done,
     /*  722945 */   // Label 11368: @722945
     /*  722945 */   GIM_Try, /*On fail goto*//*Label 11369*/ GIMT_Encode4(723020), // Rule ID 11728 //
     /*  722950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  722961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  722964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  722967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  722970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722996 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  722999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723018 */     GIR_RootConstrainSelectedInstOperands,
     /*  723019 */     // GIR_Coverage, 11728,
     /*  723019 */     GIR_EraseRootFromParent_Done,
     /*  723020 */   // Label 11369: @723020
     /*  723020 */   GIM_Try, /*On fail goto*//*Label 11370*/ GIMT_Encode4(723095), // Rule ID 11729 //
     /*  723025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  723036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  723039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  723042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  723045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723071 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  723071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  723074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723093 */     GIR_RootConstrainSelectedInstOperands,
     /*  723094 */     // GIR_Coverage, 11729,
     /*  723094 */     GIR_EraseRootFromParent_Done,
     /*  723095 */   // Label 11370: @723095
     /*  723095 */   GIM_Try, /*On fail goto*//*Label 11371*/ GIMT_Encode4(723170), // Rule ID 11732 //
     /*  723100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  723103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  723111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  723114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  723117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  723120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723146 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  723149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723168 */     GIR_RootConstrainSelectedInstOperands,
     /*  723169 */     // GIR_Coverage, 11732,
     /*  723169 */     GIR_EraseRootFromParent_Done,
     /*  723170 */   // Label 11371: @723170
     /*  723170 */   GIM_Try, /*On fail goto*//*Label 11372*/ GIMT_Encode4(723245), // Rule ID 11733 //
     /*  723175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  723186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  723189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  723192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  723195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723221 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  723224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723243 */     GIR_RootConstrainSelectedInstOperands,
     /*  723244 */     // GIR_Coverage, 11733,
     /*  723244 */     GIR_EraseRootFromParent_Done,
     /*  723245 */   // Label 11372: @723245
     /*  723245 */   GIM_Try, /*On fail goto*//*Label 11373*/ GIMT_Encode4(723320), // Rule ID 11736 //
     /*  723250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  723253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  723261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  723264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  723267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  723270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  723299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723318 */     GIR_RootConstrainSelectedInstOperands,
     /*  723319 */     // GIR_Coverage, 11736,
     /*  723319 */     GIR_EraseRootFromParent_Done,
     /*  723320 */   // Label 11373: @723320
     /*  723320 */   GIM_Try, /*On fail goto*//*Label 11374*/ GIMT_Encode4(723395), // Rule ID 11737 //
     /*  723325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  723336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  723339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  723342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  723345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723371 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  723374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723393 */     GIR_RootConstrainSelectedInstOperands,
     /*  723394 */     // GIR_Coverage, 11737,
     /*  723394 */     GIR_EraseRootFromParent_Done,
     /*  723395 */   // Label 11374: @723395
     /*  723395 */   GIM_Try, /*On fail goto*//*Label 11375*/ GIMT_Encode4(723470), // Rule ID 11740 //
     /*  723400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  723403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  723411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  723414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  723417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  723420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723446 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  723449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723468 */     GIR_RootConstrainSelectedInstOperands,
     /*  723469 */     // GIR_Coverage, 11740,
     /*  723469 */     GIR_EraseRootFromParent_Done,
     /*  723470 */   // Label 11375: @723470
     /*  723470 */   GIM_Try, /*On fail goto*//*Label 11376*/ GIMT_Encode4(723545), // Rule ID 11741 //
     /*  723475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  723486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  723489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  723492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  723495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723521 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  723524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723543 */     GIR_RootConstrainSelectedInstOperands,
     /*  723544 */     // GIR_Coverage, 11741,
     /*  723544 */     GIR_EraseRootFromParent_Done,
     /*  723545 */   // Label 11376: @723545
     /*  723545 */   GIM_Try, /*On fail goto*//*Label 11377*/ GIMT_Encode4(723620), // Rule ID 11744 //
     /*  723550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  723561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  723564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  723567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  723570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  723599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723618 */     GIR_RootConstrainSelectedInstOperands,
     /*  723619 */     // GIR_Coverage, 11744,
     /*  723619 */     GIR_EraseRootFromParent_Done,
     /*  723620 */   // Label 11377: @723620
     /*  723620 */   GIM_Try, /*On fail goto*//*Label 11378*/ GIMT_Encode4(723695), // Rule ID 11745 //
     /*  723625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  723636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  723639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  723642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  723645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723671 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  723674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723693 */     GIR_RootConstrainSelectedInstOperands,
     /*  723694 */     // GIR_Coverage, 11745,
     /*  723694 */     GIR_EraseRootFromParent_Done,
     /*  723695 */   // Label 11378: @723695
     /*  723695 */   GIM_Try, /*On fail goto*//*Label 11379*/ GIMT_Encode4(723770), // Rule ID 11748 //
     /*  723700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  723711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  723714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  723717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  723720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723746 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  723749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723768 */     GIR_RootConstrainSelectedInstOperands,
     /*  723769 */     // GIR_Coverage, 11748,
     /*  723769 */     GIR_EraseRootFromParent_Done,
     /*  723770 */   // Label 11379: @723770
     /*  723770 */   GIM_Try, /*On fail goto*//*Label 11380*/ GIMT_Encode4(723845), // Rule ID 11749 //
     /*  723775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  723786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  723789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  723792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  723795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723821 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  723824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723843 */     GIR_RootConstrainSelectedInstOperands,
     /*  723844 */     // GIR_Coverage, 11749,
     /*  723844 */     GIR_EraseRootFromParent_Done,
     /*  723845 */   // Label 11380: @723845
     /*  723845 */   GIM_Try, /*On fail goto*//*Label 11381*/ GIMT_Encode4(723920), // Rule ID 11752 //
     /*  723850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  723861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  723864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  723867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  723870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723896 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  723899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723918 */     GIR_RootConstrainSelectedInstOperands,
     /*  723919 */     // GIR_Coverage, 11752,
     /*  723919 */     GIR_EraseRootFromParent_Done,
     /*  723920 */   // Label 11381: @723920
     /*  723920 */   GIM_Try, /*On fail goto*//*Label 11382*/ GIMT_Encode4(723995), // Rule ID 11753 //
     /*  723925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  723936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  723939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  723942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  723945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  723974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723993 */     GIR_RootConstrainSelectedInstOperands,
     /*  723994 */     // GIR_Coverage, 11753,
     /*  723994 */     GIR_EraseRootFromParent_Done,
     /*  723995 */   // Label 11382: @723995
     /*  723995 */   GIM_Try, /*On fail goto*//*Label 11383*/ GIMT_Encode4(724070), // Rule ID 11756 //
     /*  724000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  724011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  724014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  724017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  724049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724068 */     GIR_RootConstrainSelectedInstOperands,
     /*  724069 */     // GIR_Coverage, 11756,
     /*  724069 */     GIR_EraseRootFromParent_Done,
     /*  724070 */   // Label 11383: @724070
     /*  724070 */   GIM_Try, /*On fail goto*//*Label 11384*/ GIMT_Encode4(724145), // Rule ID 11757 //
     /*  724075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  724086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  724089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  724092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724121 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  724124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724143 */     GIR_RootConstrainSelectedInstOperands,
     /*  724144 */     // GIR_Coverage, 11757,
     /*  724144 */     GIR_EraseRootFromParent_Done,
     /*  724145 */   // Label 11384: @724145
     /*  724145 */   GIM_Try, /*On fail goto*//*Label 11385*/ GIMT_Encode4(724220), // Rule ID 11760 //
     /*  724150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  724161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  724164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  724167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  724199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724218 */     GIR_RootConstrainSelectedInstOperands,
     /*  724219 */     // GIR_Coverage, 11760,
     /*  724219 */     GIR_EraseRootFromParent_Done,
     /*  724220 */   // Label 11385: @724220
     /*  724220 */   GIM_Try, /*On fail goto*//*Label 11386*/ GIMT_Encode4(724295), // Rule ID 11761 //
     /*  724225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  724236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  724239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  724242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724271 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  724274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724293 */     GIR_RootConstrainSelectedInstOperands,
     /*  724294 */     // GIR_Coverage, 11761,
     /*  724294 */     GIR_EraseRootFromParent_Done,
     /*  724295 */   // Label 11386: @724295
     /*  724295 */   GIM_Try, /*On fail goto*//*Label 11387*/ GIMT_Encode4(724370), // Rule ID 11764 //
     /*  724300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  724311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  724314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  724317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  724349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724368 */     GIR_RootConstrainSelectedInstOperands,
     /*  724369 */     // GIR_Coverage, 11764,
     /*  724369 */     GIR_EraseRootFromParent_Done,
     /*  724370 */   // Label 11387: @724370
     /*  724370 */   GIM_Try, /*On fail goto*//*Label 11388*/ GIMT_Encode4(724445), // Rule ID 11765 //
     /*  724375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  724386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  724389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  724392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  724421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  724424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724443 */     GIR_RootConstrainSelectedInstOperands,
     /*  724444 */     // GIR_Coverage, 11765,
     /*  724444 */     GIR_EraseRootFromParent_Done,
     /*  724445 */   // Label 11388: @724445
     /*  724445 */   GIM_Try, /*On fail goto*//*Label 11389*/ GIMT_Encode4(724520), // Rule ID 11768 //
     /*  724450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  724461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  724464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  724467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724496 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  724499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724518 */     GIR_RootConstrainSelectedInstOperands,
     /*  724519 */     // GIR_Coverage, 11768,
     /*  724519 */     GIR_EraseRootFromParent_Done,
     /*  724520 */   // Label 11389: @724520
     /*  724520 */   GIM_Try, /*On fail goto*//*Label 11390*/ GIMT_Encode4(724595), // Rule ID 11769 //
     /*  724525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  724536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  724539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  724542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724571 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  724574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724593 */     GIR_RootConstrainSelectedInstOperands,
     /*  724594 */     // GIR_Coverage, 11769,
     /*  724594 */     GIR_EraseRootFromParent_Done,
     /*  724595 */   // Label 11390: @724595
     /*  724595 */   GIM_Try, /*On fail goto*//*Label 11391*/ GIMT_Encode4(724670), // Rule ID 11772 //
     /*  724600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  724611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  724614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  724617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  724649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724668 */     GIR_RootConstrainSelectedInstOperands,
     /*  724669 */     // GIR_Coverage, 11772,
     /*  724669 */     GIR_EraseRootFromParent_Done,
     /*  724670 */   // Label 11391: @724670
     /*  724670 */   GIM_Try, /*On fail goto*//*Label 11392*/ GIMT_Encode4(724745), // Rule ID 11773 //
     /*  724675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  724686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  724689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  724692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724721 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  724724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724743 */     GIR_RootConstrainSelectedInstOperands,
     /*  724744 */     // GIR_Coverage, 11773,
     /*  724744 */     GIR_EraseRootFromParent_Done,
     /*  724745 */   // Label 11392: @724745
     /*  724745 */   GIM_Try, /*On fail goto*//*Label 11393*/ GIMT_Encode4(724820), // Rule ID 11776 //
     /*  724750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  724767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  724799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724818 */     GIR_RootConstrainSelectedInstOperands,
     /*  724819 */     // GIR_Coverage, 11776,
     /*  724819 */     GIR_EraseRootFromParent_Done,
     /*  724820 */   // Label 11393: @724820
     /*  724820 */   GIM_Try, /*On fail goto*//*Label 11394*/ GIMT_Encode4(724895), // Rule ID 11777 //
     /*  724825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  724842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  724871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  724874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724893 */     GIR_RootConstrainSelectedInstOperands,
     /*  724894 */     // GIR_Coverage, 11777,
     /*  724894 */     GIR_EraseRootFromParent_Done,
     /*  724895 */   // Label 11394: @724895
     /*  724895 */   GIM_Try, /*On fail goto*//*Label 11395*/ GIMT_Encode4(724970), // Rule ID 11780 //
     /*  724900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  724903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  724917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  724946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  724949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724968 */     GIR_RootConstrainSelectedInstOperands,
     /*  724969 */     // GIR_Coverage, 11780,
     /*  724969 */     GIR_EraseRootFromParent_Done,
     /*  724970 */   // Label 11395: @724970
     /*  724970 */   GIM_Try, /*On fail goto*//*Label 11396*/ GIMT_Encode4(725045), // Rule ID 11781 //
     /*  724975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  724978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  724992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725021 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  725021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  725024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  725040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725043 */     GIR_RootConstrainSelectedInstOperands,
     /*  725044 */     // GIR_Coverage, 11781,
     /*  725044 */     GIR_EraseRootFromParent_Done,
     /*  725045 */   // Label 11396: @725045
     /*  725045 */   GIM_Try, /*On fail goto*//*Label 11397*/ GIMT_Encode4(725120), // Rule ID 11784 //
     /*  725050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  725061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  725064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  725067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725096 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  725099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725118 */     GIR_RootConstrainSelectedInstOperands,
     /*  725119 */     // GIR_Coverage, 11784,
     /*  725119 */     GIR_EraseRootFromParent_Done,
     /*  725120 */   // Label 11397: @725120
     /*  725120 */   GIM_Try, /*On fail goto*//*Label 11398*/ GIMT_Encode4(725195), // Rule ID 11785 //
     /*  725125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  725136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  725139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  725142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  725145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725171 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  725174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725193 */     GIR_RootConstrainSelectedInstOperands,
     /*  725194 */     // GIR_Coverage, 11785,
     /*  725194 */     GIR_EraseRootFromParent_Done,
     /*  725195 */   // Label 11398: @725195
     /*  725195 */   GIM_Try, /*On fail goto*//*Label 11399*/ GIMT_Encode4(725270), // Rule ID 11788 //
     /*  725200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  725211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  725214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  725217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725246 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  725249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725268 */     GIR_RootConstrainSelectedInstOperands,
     /*  725269 */     // GIR_Coverage, 11788,
     /*  725269 */     GIR_EraseRootFromParent_Done,
     /*  725270 */   // Label 11399: @725270
     /*  725270 */   GIM_Try, /*On fail goto*//*Label 11400*/ GIMT_Encode4(725345), // Rule ID 11789 //
     /*  725275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  725286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  725289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  725292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  725295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725321 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  725324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725343 */     GIR_RootConstrainSelectedInstOperands,
     /*  725344 */     // GIR_Coverage, 11789,
     /*  725344 */     GIR_EraseRootFromParent_Done,
     /*  725345 */   // Label 11400: @725345
     /*  725345 */   GIM_Try, /*On fail goto*//*Label 11401*/ GIMT_Encode4(725420), // Rule ID 11792 //
     /*  725350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  725361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  725364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  725367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725396 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  725399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725418 */     GIR_RootConstrainSelectedInstOperands,
     /*  725419 */     // GIR_Coverage, 11792,
     /*  725419 */     GIR_EraseRootFromParent_Done,
     /*  725420 */   // Label 11401: @725420
     /*  725420 */   GIM_Try, /*On fail goto*//*Label 11402*/ GIMT_Encode4(725495), // Rule ID 11793 //
     /*  725425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  725436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  725439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  725442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  725445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725471 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  725474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725493 */     GIR_RootConstrainSelectedInstOperands,
     /*  725494 */     // GIR_Coverage, 11793,
     /*  725494 */     GIR_EraseRootFromParent_Done,
     /*  725495 */   // Label 11402: @725495
     /*  725495 */   GIM_Try, /*On fail goto*//*Label 11403*/ GIMT_Encode4(725570), // Rule ID 11796 //
     /*  725500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  725511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  725514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  725517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725546 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  725549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725568 */     GIR_RootConstrainSelectedInstOperands,
     /*  725569 */     // GIR_Coverage, 11796,
     /*  725569 */     GIR_EraseRootFromParent_Done,
     /*  725570 */   // Label 11403: @725570
     /*  725570 */   GIM_Try, /*On fail goto*//*Label 11404*/ GIMT_Encode4(725645), // Rule ID 11797 //
     /*  725575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  725586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  725589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  725592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  725595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  725624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725643 */     GIR_RootConstrainSelectedInstOperands,
     /*  725644 */     // GIR_Coverage, 11797,
     /*  725644 */     GIR_EraseRootFromParent_Done,
     /*  725645 */   // Label 11404: @725645
     /*  725645 */   GIM_Try, /*On fail goto*//*Label 11405*/ GIMT_Encode4(725720), // Rule ID 11800 //
     /*  725650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  725661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  725664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  725667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725696 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  725699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725718 */     GIR_RootConstrainSelectedInstOperands,
     /*  725719 */     // GIR_Coverage, 11800,
     /*  725719 */     GIR_EraseRootFromParent_Done,
     /*  725720 */   // Label 11405: @725720
     /*  725720 */   GIM_Try, /*On fail goto*//*Label 11406*/ GIMT_Encode4(725795), // Rule ID 11801 //
     /*  725725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  725736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  725739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  725742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  725745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  725774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725793 */     GIR_RootConstrainSelectedInstOperands,
     /*  725794 */     // GIR_Coverage, 11801,
     /*  725794 */     GIR_EraseRootFromParent_Done,
     /*  725795 */   // Label 11406: @725795
     /*  725795 */   GIM_Try, /*On fail goto*//*Label 11407*/ GIMT_Encode4(725870), // Rule ID 11804 //
     /*  725800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  725811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  725814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  725817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725846 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  725849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725868 */     GIR_RootConstrainSelectedInstOperands,
     /*  725869 */     // GIR_Coverage, 11804,
     /*  725869 */     GIR_EraseRootFromParent_Done,
     /*  725870 */   // Label 11407: @725870
     /*  725870 */   GIM_Try, /*On fail goto*//*Label 11408*/ GIMT_Encode4(725945), // Rule ID 11805 //
     /*  725875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  725886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  725889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  725892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  725895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725921 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  725924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725943 */     GIR_RootConstrainSelectedInstOperands,
     /*  725944 */     // GIR_Coverage, 11805,
     /*  725944 */     GIR_EraseRootFromParent_Done,
     /*  725945 */   // Label 11408: @725945
     /*  725945 */   GIM_Try, /*On fail goto*//*Label 11409*/ GIMT_Encode4(726020), // Rule ID 11808 //
     /*  725950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  725961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  725964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  725967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  725996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  725999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726018 */     GIR_RootConstrainSelectedInstOperands,
     /*  726019 */     // GIR_Coverage, 11808,
     /*  726019 */     GIR_EraseRootFromParent_Done,
     /*  726020 */   // Label 11409: @726020
     /*  726020 */   GIM_Try, /*On fail goto*//*Label 11410*/ GIMT_Encode4(726095), // Rule ID 11809 //
     /*  726025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  726036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  726039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  726042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726071 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  726071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  726074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726093 */     GIR_RootConstrainSelectedInstOperands,
     /*  726094 */     // GIR_Coverage, 11809,
     /*  726094 */     GIR_EraseRootFromParent_Done,
     /*  726095 */   // Label 11410: @726095
     /*  726095 */   GIM_Try, /*On fail goto*//*Label 11411*/ GIMT_Encode4(726170), // Rule ID 11812 //
     /*  726100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  726111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  726114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  726117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  726146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  726149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726168 */     GIR_RootConstrainSelectedInstOperands,
     /*  726169 */     // GIR_Coverage, 11812,
     /*  726169 */     GIR_EraseRootFromParent_Done,
     /*  726170 */   // Label 11411: @726170
     /*  726170 */   GIM_Try, /*On fail goto*//*Label 11412*/ GIMT_Encode4(726245), // Rule ID 11813 //
     /*  726175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  726186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  726189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  726192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726221 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  726221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  726224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726243 */     GIR_RootConstrainSelectedInstOperands,
     /*  726244 */     // GIR_Coverage, 11813,
     /*  726244 */     GIR_EraseRootFromParent_Done,
     /*  726245 */   // Label 11412: @726245
     /*  726245 */   GIM_Try, /*On fail goto*//*Label 11413*/ GIMT_Encode4(726320), // Rule ID 11816 //
     /*  726250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  726261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  726264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  726267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726296 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  726296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  726299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726318 */     GIR_RootConstrainSelectedInstOperands,
     /*  726319 */     // GIR_Coverage, 11816,
     /*  726319 */     GIR_EraseRootFromParent_Done,
     /*  726320 */   // Label 11413: @726320
     /*  726320 */   GIM_Try, /*On fail goto*//*Label 11414*/ GIMT_Encode4(726395), // Rule ID 11817 //
     /*  726325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  726336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  726339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  726342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726371 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  726371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  726374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726393 */     GIR_RootConstrainSelectedInstOperands,
     /*  726394 */     // GIR_Coverage, 11817,
     /*  726394 */     GIR_EraseRootFromParent_Done,
     /*  726395 */   // Label 11414: @726395
     /*  726395 */   GIM_Try, /*On fail goto*//*Label 11415*/ GIMT_Encode4(726470), // Rule ID 11820 //
     /*  726400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  726411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  726414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  726417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  726449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726468 */     GIR_RootConstrainSelectedInstOperands,
     /*  726469 */     // GIR_Coverage, 11820,
     /*  726469 */     GIR_EraseRootFromParent_Done,
     /*  726470 */   // Label 11415: @726470
     /*  726470 */   GIM_Try, /*On fail goto*//*Label 11416*/ GIMT_Encode4(726545), // Rule ID 11821 //
     /*  726475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  726486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  726489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  726492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  726524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726543 */     GIR_RootConstrainSelectedInstOperands,
     /*  726544 */     // GIR_Coverage, 11821,
     /*  726544 */     GIR_EraseRootFromParent_Done,
     /*  726545 */   // Label 11416: @726545
     /*  726545 */   GIM_Try, /*On fail goto*//*Label 11417*/ GIMT_Encode4(726620), // Rule ID 11824 //
     /*  726550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  726561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  726564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  726567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  726599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726618 */     GIR_RootConstrainSelectedInstOperands,
     /*  726619 */     // GIR_Coverage, 11824,
     /*  726619 */     GIR_EraseRootFromParent_Done,
     /*  726620 */   // Label 11417: @726620
     /*  726620 */   GIM_Try, /*On fail goto*//*Label 11418*/ GIMT_Encode4(726695), // Rule ID 11825 //
     /*  726625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  726636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  726639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  726642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726671 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  726674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726693 */     GIR_RootConstrainSelectedInstOperands,
     /*  726694 */     // GIR_Coverage, 11825,
     /*  726694 */     GIR_EraseRootFromParent_Done,
     /*  726695 */   // Label 11418: @726695
     /*  726695 */   GIM_Try, /*On fail goto*//*Label 11419*/ GIMT_Encode4(726770), // Rule ID 11828 //
     /*  726700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  726711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  726714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  726717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726746 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  726749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726768 */     GIR_RootConstrainSelectedInstOperands,
     /*  726769 */     // GIR_Coverage, 11828,
     /*  726769 */     GIR_EraseRootFromParent_Done,
     /*  726770 */   // Label 11419: @726770
     /*  726770 */   GIM_Try, /*On fail goto*//*Label 11420*/ GIMT_Encode4(726845), // Rule ID 11829 //
     /*  726775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  726786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  726789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  726792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726821 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  726824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726843 */     GIR_RootConstrainSelectedInstOperands,
     /*  726844 */     // GIR_Coverage, 11829,
     /*  726844 */     GIR_EraseRootFromParent_Done,
     /*  726845 */   // Label 11420: @726845
     /*  726845 */   GIM_Try, /*On fail goto*//*Label 11421*/ GIMT_Encode4(726920), // Rule ID 11832 //
     /*  726850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  726861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  726864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  726867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  726870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  726899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726918 */     GIR_RootConstrainSelectedInstOperands,
     /*  726919 */     // GIR_Coverage, 11832,
     /*  726919 */     GIR_EraseRootFromParent_Done,
     /*  726920 */   // Label 11421: @726920
     /*  726920 */   GIM_Try, /*On fail goto*//*Label 11422*/ GIMT_Encode4(726995), // Rule ID 11833 //
     /*  726925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  726936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  726939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  726942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  726945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  726974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726993 */     GIR_RootConstrainSelectedInstOperands,
     /*  726994 */     // GIR_Coverage, 11833,
     /*  726994 */     GIR_EraseRootFromParent_Done,
     /*  726995 */   // Label 11422: @726995
     /*  726995 */   GIM_Try, /*On fail goto*//*Label 11423*/ GIMT_Encode4(727070), // Rule ID 11836 //
     /*  727000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  727011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  727014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  727017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  727020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  727049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727068 */     GIR_RootConstrainSelectedInstOperands,
     /*  727069 */     // GIR_Coverage, 11836,
     /*  727069 */     GIR_EraseRootFromParent_Done,
     /*  727070 */   // Label 11423: @727070
     /*  727070 */   GIM_Try, /*On fail goto*//*Label 11424*/ GIMT_Encode4(727145), // Rule ID 11837 //
     /*  727075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  727086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  727089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  727092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  727095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727121 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  727124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727143 */     GIR_RootConstrainSelectedInstOperands,
     /*  727144 */     // GIR_Coverage, 11837,
     /*  727144 */     GIR_EraseRootFromParent_Done,
     /*  727145 */   // Label 11424: @727145
     /*  727145 */   GIM_Try, /*On fail goto*//*Label 11425*/ GIMT_Encode4(727220), // Rule ID 11840 //
     /*  727150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  727161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  727164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  727167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  727170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  727199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727218 */     GIR_RootConstrainSelectedInstOperands,
     /*  727219 */     // GIR_Coverage, 11840,
     /*  727219 */     GIR_EraseRootFromParent_Done,
     /*  727220 */   // Label 11425: @727220
     /*  727220 */   GIM_Try, /*On fail goto*//*Label 11426*/ GIMT_Encode4(727295), // Rule ID 11841 //
     /*  727225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  727236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  727239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  727242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  727245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  727274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727293 */     GIR_RootConstrainSelectedInstOperands,
     /*  727294 */     // GIR_Coverage, 11841,
     /*  727294 */     GIR_EraseRootFromParent_Done,
     /*  727295 */   // Label 11426: @727295
     /*  727295 */   GIM_Try, /*On fail goto*//*Label 11427*/ GIMT_Encode4(727370), // Rule ID 11844 //
     /*  727300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  727311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  727314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  727317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  727320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  727349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727368 */     GIR_RootConstrainSelectedInstOperands,
     /*  727369 */     // GIR_Coverage, 11844,
     /*  727369 */     GIR_EraseRootFromParent_Done,
     /*  727370 */   // Label 11427: @727370
     /*  727370 */   GIM_Try, /*On fail goto*//*Label 11428*/ GIMT_Encode4(727445), // Rule ID 11845 //
     /*  727375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  727386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  727389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  727392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  727395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727421 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  727424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727443 */     GIR_RootConstrainSelectedInstOperands,
     /*  727444 */     // GIR_Coverage, 11845,
     /*  727444 */     GIR_EraseRootFromParent_Done,
     /*  727445 */   // Label 11428: @727445
     /*  727445 */   GIM_Try, /*On fail goto*//*Label 11429*/ GIMT_Encode4(727520), // Rule ID 11848 //
     /*  727450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  727461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  727464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  727467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  727470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  727499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727518 */     GIR_RootConstrainSelectedInstOperands,
     /*  727519 */     // GIR_Coverage, 11848,
     /*  727519 */     GIR_EraseRootFromParent_Done,
     /*  727520 */   // Label 11429: @727520
     /*  727520 */   GIM_Try, /*On fail goto*//*Label 11430*/ GIMT_Encode4(727595), // Rule ID 11849 //
     /*  727525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  727536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  727539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  727542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  727545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727571 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  727574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727593 */     GIR_RootConstrainSelectedInstOperands,
     /*  727594 */     // GIR_Coverage, 11849,
     /*  727594 */     GIR_EraseRootFromParent_Done,
     /*  727595 */   // Label 11430: @727595
     /*  727595 */   GIM_Try, /*On fail goto*//*Label 11431*/ GIMT_Encode4(727670), // Rule ID 11852 //
     /*  727600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  727611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  727614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  727617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  727620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  727646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  727649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727668 */     GIR_RootConstrainSelectedInstOperands,
     /*  727669 */     // GIR_Coverage, 11852,
     /*  727669 */     GIR_EraseRootFromParent_Done,
     /*  727670 */   // Label 11431: @727670
     /*  727670 */   GIM_Try, /*On fail goto*//*Label 11432*/ GIMT_Encode4(727745), // Rule ID 11853 //
     /*  727675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  727686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  727689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  727692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  727695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  727721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  727724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727743 */     GIR_RootConstrainSelectedInstOperands,
     /*  727744 */     // GIR_Coverage, 11853,
     /*  727744 */     GIR_EraseRootFromParent_Done,
     /*  727745 */   // Label 11432: @727745
     /*  727745 */   GIM_Try, /*On fail goto*//*Label 11433*/ GIMT_Encode4(727820), // Rule ID 11856 //
     /*  727750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  727761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  727764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  727767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  727770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  727799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727818 */     GIR_RootConstrainSelectedInstOperands,
     /*  727819 */     // GIR_Coverage, 11856,
     /*  727819 */     GIR_EraseRootFromParent_Done,
     /*  727820 */   // Label 11433: @727820
     /*  727820 */   GIM_Try, /*On fail goto*//*Label 11434*/ GIMT_Encode4(727895), // Rule ID 11857 //
     /*  727825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  727836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  727839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  727842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  727845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727871 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  727874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727893 */     GIR_RootConstrainSelectedInstOperands,
     /*  727894 */     // GIR_Coverage, 11857,
     /*  727894 */     GIR_EraseRootFromParent_Done,
     /*  727895 */   // Label 11434: @727895
     /*  727895 */   GIM_Try, /*On fail goto*//*Label 11435*/ GIMT_Encode4(727970), // Rule ID 11860 //
     /*  727900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  727917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  727920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  727949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727968 */     GIR_RootConstrainSelectedInstOperands,
     /*  727969 */     // GIR_Coverage, 11860,
     /*  727969 */     GIR_EraseRootFromParent_Done,
     /*  727970 */   // Label 11435: @727970
     /*  727970 */   GIM_Try, /*On fail goto*//*Label 11436*/ GIMT_Encode4(728045), // Rule ID 11861 //
     /*  727975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  727992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  727995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728021 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  728024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728043 */     GIR_RootConstrainSelectedInstOperands,
     /*  728044 */     // GIR_Coverage, 11861,
     /*  728044 */     GIR_EraseRootFromParent_Done,
     /*  728045 */   // Label 11436: @728045
     /*  728045 */   GIM_Try, /*On fail goto*//*Label 11437*/ GIMT_Encode4(728120), // Rule ID 11864 //
     /*  728050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  728061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  728064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  728067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  728070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  728096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  728099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728118 */     GIR_RootConstrainSelectedInstOperands,
     /*  728119 */     // GIR_Coverage, 11864,
     /*  728119 */     GIR_EraseRootFromParent_Done,
     /*  728120 */   // Label 11437: @728120
     /*  728120 */   GIM_Try, /*On fail goto*//*Label 11438*/ GIMT_Encode4(728195), // Rule ID 11865 //
     /*  728125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  728136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  728139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  728142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  728145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  728171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  728174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728193 */     GIR_RootConstrainSelectedInstOperands,
     /*  728194 */     // GIR_Coverage, 11865,
     /*  728194 */     GIR_EraseRootFromParent_Done,
     /*  728195 */   // Label 11438: @728195
     /*  728195 */   GIM_Try, /*On fail goto*//*Label 11439*/ GIMT_Encode4(728270), // Rule ID 11868 //
     /*  728200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  728203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  728211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  728214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  728217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  728220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  728246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  728249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728268 */     GIR_RootConstrainSelectedInstOperands,
     /*  728269 */     // GIR_Coverage, 11868,
     /*  728269 */     GIR_EraseRootFromParent_Done,
     /*  728270 */   // Label 11439: @728270
     /*  728270 */   GIM_Try, /*On fail goto*//*Label 11440*/ GIMT_Encode4(728345), // Rule ID 11869 //
     /*  728275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  728278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  728286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  728289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  728292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  728295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728321 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  728321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  728324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728343 */     GIR_RootConstrainSelectedInstOperands,
     /*  728344 */     // GIR_Coverage, 11869,
     /*  728344 */     GIR_EraseRootFromParent_Done,
     /*  728345 */   // Label 11440: @728345
     /*  728345 */   GIM_Try, /*On fail goto*//*Label 11441*/ GIMT_Encode4(728420), // Rule ID 11872 //
     /*  728350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  728361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  728364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  728367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  728370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  728399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728418 */     GIR_RootConstrainSelectedInstOperands,
     /*  728419 */     // GIR_Coverage, 11872,
     /*  728419 */     GIR_EraseRootFromParent_Done,
     /*  728420 */   // Label 11441: @728420
     /*  728420 */   GIM_Try, /*On fail goto*//*Label 11442*/ GIMT_Encode4(728495), // Rule ID 11873 //
     /*  728425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  728436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  728439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  728442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  728445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  728474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728493 */     GIR_RootConstrainSelectedInstOperands,
     /*  728494 */     // GIR_Coverage, 11873,
     /*  728494 */     GIR_EraseRootFromParent_Done,
     /*  728495 */   // Label 11442: @728495
     /*  728495 */   GIM_Try, /*On fail goto*//*Label 11443*/ GIMT_Encode4(728570), // Rule ID 11876 //
     /*  728500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  728511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  728514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  728517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  728520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  728549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728568 */     GIR_RootConstrainSelectedInstOperands,
     /*  728569 */     // GIR_Coverage, 11876,
     /*  728569 */     GIR_EraseRootFromParent_Done,
     /*  728570 */   // Label 11443: @728570
     /*  728570 */   GIM_Try, /*On fail goto*//*Label 11444*/ GIMT_Encode4(728645), // Rule ID 11877 //
     /*  728575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  728586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  728589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  728592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  728595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728621 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  728624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728643 */     GIR_RootConstrainSelectedInstOperands,
     /*  728644 */     // GIR_Coverage, 11877,
     /*  728644 */     GIR_EraseRootFromParent_Done,
     /*  728645 */   // Label 11444: @728645
     /*  728645 */   GIM_Try, /*On fail goto*//*Label 11445*/ GIMT_Encode4(728720), // Rule ID 11880 //
     /*  728650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  728661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  728664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  728667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  728670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728696 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  728699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728718 */     GIR_RootConstrainSelectedInstOperands,
     /*  728719 */     // GIR_Coverage, 11880,
     /*  728719 */     GIR_EraseRootFromParent_Done,
     /*  728720 */   // Label 11445: @728720
     /*  728720 */   GIM_Try, /*On fail goto*//*Label 11446*/ GIMT_Encode4(728795), // Rule ID 11881 //
     /*  728725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  728736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  728739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  728742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  728745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728771 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  728774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728793 */     GIR_RootConstrainSelectedInstOperands,
     /*  728794 */     // GIR_Coverage, 11881,
     /*  728794 */     GIR_EraseRootFromParent_Done,
     /*  728795 */   // Label 11446: @728795
     /*  728795 */   GIM_Try, /*On fail goto*//*Label 11447*/ GIMT_Encode4(728870), // Rule ID 11884 //
     /*  728800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  728811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  728814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  728817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  728820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  728849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728868 */     GIR_RootConstrainSelectedInstOperands,
     /*  728869 */     // GIR_Coverage, 11884,
     /*  728869 */     GIR_EraseRootFromParent_Done,
     /*  728870 */   // Label 11447: @728870
     /*  728870 */   GIM_Try, /*On fail goto*//*Label 11448*/ GIMT_Encode4(728945), // Rule ID 11885 //
     /*  728875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  728886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  728889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  728892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  728895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  728924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728943 */     GIR_RootConstrainSelectedInstOperands,
     /*  728944 */     // GIR_Coverage, 11885,
     /*  728944 */     GIR_EraseRootFromParent_Done,
     /*  728945 */   // Label 11448: @728945
     /*  728945 */   GIM_Try, /*On fail goto*//*Label 11449*/ GIMT_Encode4(729020), // Rule ID 11888 //
     /*  728950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  728961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  728964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  728967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  728970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  728999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729018 */     GIR_RootConstrainSelectedInstOperands,
     /*  729019 */     // GIR_Coverage, 11888,
     /*  729019 */     GIR_EraseRootFromParent_Done,
     /*  729020 */   // Label 11449: @729020
     /*  729020 */   GIM_Try, /*On fail goto*//*Label 11450*/ GIMT_Encode4(729095), // Rule ID 11889 //
     /*  729025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  729036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  729039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  729042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  729045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  729071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  729074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729093 */     GIR_RootConstrainSelectedInstOperands,
     /*  729094 */     // GIR_Coverage, 11889,
     /*  729094 */     GIR_EraseRootFromParent_Done,
     /*  729095 */   // Label 11450: @729095
     /*  729095 */   GIM_Try, /*On fail goto*//*Label 11451*/ GIMT_Encode4(729170), // Rule ID 11892 //
     /*  729100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  729111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  729114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  729117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  729120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  729146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  729149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729168 */     GIR_RootConstrainSelectedInstOperands,
     /*  729169 */     // GIR_Coverage, 11892,
     /*  729169 */     GIR_EraseRootFromParent_Done,
     /*  729170 */   // Label 11451: @729170
     /*  729170 */   GIM_Try, /*On fail goto*//*Label 11452*/ GIMT_Encode4(729245), // Rule ID 11893 //
     /*  729175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  729186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  729189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  729192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  729195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729221 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  729221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  729224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729243 */     GIR_RootConstrainSelectedInstOperands,
     /*  729244 */     // GIR_Coverage, 11893,
     /*  729244 */     GIR_EraseRootFromParent_Done,
     /*  729245 */   // Label 11452: @729245
     /*  729245 */   GIM_Try, /*On fail goto*//*Label 11453*/ GIMT_Encode4(729320), // Rule ID 11896 //
     /*  729250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  729261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  729264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  729267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  729270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  729299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729318 */     GIR_RootConstrainSelectedInstOperands,
     /*  729319 */     // GIR_Coverage, 11896,
     /*  729319 */     GIR_EraseRootFromParent_Done,
     /*  729320 */   // Label 11453: @729320
     /*  729320 */   GIM_Try, /*On fail goto*//*Label 11454*/ GIMT_Encode4(729395), // Rule ID 11897 //
     /*  729325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  729336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  729339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  729342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  729345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  729374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729393 */     GIR_RootConstrainSelectedInstOperands,
     /*  729394 */     // GIR_Coverage, 11897,
     /*  729394 */     GIR_EraseRootFromParent_Done,
     /*  729395 */   // Label 11454: @729395
     /*  729395 */   GIM_Try, /*On fail goto*//*Label 11455*/ GIMT_Encode4(729470), // Rule ID 11900 //
     /*  729400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  729411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  729414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  729417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  729420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  729449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729468 */     GIR_RootConstrainSelectedInstOperands,
     /*  729469 */     // GIR_Coverage, 11900,
     /*  729469 */     GIR_EraseRootFromParent_Done,
     /*  729470 */   // Label 11455: @729470
     /*  729470 */   GIM_Try, /*On fail goto*//*Label 11456*/ GIMT_Encode4(729545), // Rule ID 11901 //
     /*  729475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  729486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  729489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  729492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  729495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  729524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729543 */     GIR_RootConstrainSelectedInstOperands,
     /*  729544 */     // GIR_Coverage, 11901,
     /*  729544 */     GIR_EraseRootFromParent_Done,
     /*  729545 */   // Label 11456: @729545
     /*  729545 */   GIM_Try, /*On fail goto*//*Label 11457*/ GIMT_Encode4(729620), // Rule ID 11904 //
     /*  729550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  729561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  729564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  729567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  729570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  729599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729618 */     GIR_RootConstrainSelectedInstOperands,
     /*  729619 */     // GIR_Coverage, 11904,
     /*  729619 */     GIR_EraseRootFromParent_Done,
     /*  729620 */   // Label 11457: @729620
     /*  729620 */   GIM_Try, /*On fail goto*//*Label 11458*/ GIMT_Encode4(729695), // Rule ID 11905 //
     /*  729625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  729636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  729639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  729642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  729645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729671 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  729674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729693 */     GIR_RootConstrainSelectedInstOperands,
     /*  729694 */     // GIR_Coverage, 11905,
     /*  729694 */     GIR_EraseRootFromParent_Done,
     /*  729695 */   // Label 11458: @729695
     /*  729695 */   GIM_Try, /*On fail goto*//*Label 11459*/ GIMT_Encode4(729770), // Rule ID 11908 //
     /*  729700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  729711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  729714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  729717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  729720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  729749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729768 */     GIR_RootConstrainSelectedInstOperands,
     /*  729769 */     // GIR_Coverage, 11908,
     /*  729769 */     GIR_EraseRootFromParent_Done,
     /*  729770 */   // Label 11459: @729770
     /*  729770 */   GIM_Try, /*On fail goto*//*Label 11460*/ GIMT_Encode4(729845), // Rule ID 11909 //
     /*  729775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  729786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  729789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  729792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  729795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  729824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729843 */     GIR_RootConstrainSelectedInstOperands,
     /*  729844 */     // GIR_Coverage, 11909,
     /*  729844 */     GIR_EraseRootFromParent_Done,
     /*  729845 */   // Label 11460: @729845
     /*  729845 */   GIM_Try, /*On fail goto*//*Label 11461*/ GIMT_Encode4(729920), // Rule ID 11912 //
     /*  729850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  729861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  729864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  729867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  729870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  729899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729918 */     GIR_RootConstrainSelectedInstOperands,
     /*  729919 */     // GIR_Coverage, 11912,
     /*  729919 */     GIR_EraseRootFromParent_Done,
     /*  729920 */   // Label 11461: @729920
     /*  729920 */   GIM_Try, /*On fail goto*//*Label 11462*/ GIMT_Encode4(729995), // Rule ID 11913 //
     /*  729925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  729936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  729939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  729942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  729945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  729974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729993 */     GIR_RootConstrainSelectedInstOperands,
     /*  729994 */     // GIR_Coverage, 11913,
     /*  729994 */     GIR_EraseRootFromParent_Done,
     /*  729995 */   // Label 11462: @729995
     /*  729995 */   GIM_Try, /*On fail goto*//*Label 11463*/ GIMT_Encode4(730070), // Rule ID 11916 //
     /*  730000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  730003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  730011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  730014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  730017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  730020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  730046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  730049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  730065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730068 */     GIR_RootConstrainSelectedInstOperands,
     /*  730069 */     // GIR_Coverage, 11916,
     /*  730069 */     GIR_EraseRootFromParent_Done,
     /*  730070 */   // Label 11463: @730070
     /*  730070 */   GIM_Try, /*On fail goto*//*Label 11464*/ GIMT_Encode4(730145), // Rule ID 11917 //
     /*  730075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  730078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  730086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  730089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  730092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  730095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730121 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  730121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  730124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  730140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730143 */     GIR_RootConstrainSelectedInstOperands,
     /*  730144 */     // GIR_Coverage, 11917,
     /*  730144 */     GIR_EraseRootFromParent_Done,
     /*  730145 */   // Label 11464: @730145
     /*  730145 */   GIM_Try, /*On fail goto*//*Label 11465*/ GIMT_Encode4(730220), // Rule ID 11920 //
     /*  730150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  730161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  730164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  730167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  730170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  730199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730218 */     GIR_RootConstrainSelectedInstOperands,
     /*  730219 */     // GIR_Coverage, 11920,
     /*  730219 */     GIR_EraseRootFromParent_Done,
     /*  730220 */   // Label 11465: @730220
     /*  730220 */   GIM_Try, /*On fail goto*//*Label 11466*/ GIMT_Encode4(730295), // Rule ID 11921 //
     /*  730225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  730236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  730239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  730242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730271 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  730274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730293 */     GIR_RootConstrainSelectedInstOperands,
     /*  730294 */     // GIR_Coverage, 11921,
     /*  730294 */     GIR_EraseRootFromParent_Done,
     /*  730295 */   // Label 11466: @730295
     /*  730295 */   GIM_Try, /*On fail goto*//*Label 11467*/ GIMT_Encode4(730370), // Rule ID 11924 //
     /*  730300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  730311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  730314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  730317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  730320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  730349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730368 */     GIR_RootConstrainSelectedInstOperands,
     /*  730369 */     // GIR_Coverage, 11924,
     /*  730369 */     GIR_EraseRootFromParent_Done,
     /*  730370 */   // Label 11467: @730370
     /*  730370 */   GIM_Try, /*On fail goto*//*Label 11468*/ GIMT_Encode4(730445), // Rule ID 11925 //
     /*  730375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  730386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  730389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  730392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730421 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  730424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730443 */     GIR_RootConstrainSelectedInstOperands,
     /*  730444 */     // GIR_Coverage, 11925,
     /*  730444 */     GIR_EraseRootFromParent_Done,
     /*  730445 */   // Label 11468: @730445
     /*  730445 */   GIM_Try, /*On fail goto*//*Label 11469*/ GIMT_Encode4(730520), // Rule ID 11928 //
     /*  730450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  730461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  730464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  730467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  730470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  730499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730518 */     GIR_RootConstrainSelectedInstOperands,
     /*  730519 */     // GIR_Coverage, 11928,
     /*  730519 */     GIR_EraseRootFromParent_Done,
     /*  730520 */   // Label 11469: @730520
     /*  730520 */   GIM_Try, /*On fail goto*//*Label 11470*/ GIMT_Encode4(730595), // Rule ID 11929 //
     /*  730525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  730536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  730539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  730542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730571 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  730574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730593 */     GIR_RootConstrainSelectedInstOperands,
     /*  730594 */     // GIR_Coverage, 11929,
     /*  730594 */     GIR_EraseRootFromParent_Done,
     /*  730595 */   // Label 11470: @730595
     /*  730595 */   GIM_Try, /*On fail goto*//*Label 11471*/ GIMT_Encode4(730670), // Rule ID 11932 //
     /*  730600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  730611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  730614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  730617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  730620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  730649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730668 */     GIR_RootConstrainSelectedInstOperands,
     /*  730669 */     // GIR_Coverage, 11932,
     /*  730669 */     GIR_EraseRootFromParent_Done,
     /*  730670 */   // Label 11471: @730670
     /*  730670 */   GIM_Try, /*On fail goto*//*Label 11472*/ GIMT_Encode4(730745), // Rule ID 11933 //
     /*  730675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  730686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  730689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  730692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730721 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  730724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730743 */     GIR_RootConstrainSelectedInstOperands,
     /*  730744 */     // GIR_Coverage, 11933,
     /*  730744 */     GIR_EraseRootFromParent_Done,
     /*  730745 */   // Label 11472: @730745
     /*  730745 */   GIM_Try, /*On fail goto*//*Label 11473*/ GIMT_Encode4(730820), // Rule ID 11936 //
     /*  730750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  730761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  730764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  730767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  730770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  730799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730818 */     GIR_RootConstrainSelectedInstOperands,
     /*  730819 */     // GIR_Coverage, 11936,
     /*  730819 */     GIR_EraseRootFromParent_Done,
     /*  730820 */   // Label 11473: @730820
     /*  730820 */   GIM_Try, /*On fail goto*//*Label 11474*/ GIMT_Encode4(730895), // Rule ID 11937 //
     /*  730825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  730836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  730839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  730842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  730874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730893 */     GIR_RootConstrainSelectedInstOperands,
     /*  730894 */     // GIR_Coverage, 11937,
     /*  730894 */     GIR_EraseRootFromParent_Done,
     /*  730895 */   // Label 11474: @730895
     /*  730895 */   GIM_Try, /*On fail goto*//*Label 11475*/ GIMT_Encode4(730970), // Rule ID 11940 //
     /*  730900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  730911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  730914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  730917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  730920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  730946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  730949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730968 */     GIR_RootConstrainSelectedInstOperands,
     /*  730969 */     // GIR_Coverage, 11940,
     /*  730969 */     GIR_EraseRootFromParent_Done,
     /*  730970 */   // Label 11475: @730970
     /*  730970 */   GIM_Try, /*On fail goto*//*Label 11476*/ GIMT_Encode4(731045), // Rule ID 11941 //
     /*  730975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  730986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  730989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  730992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731021 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  731021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  731024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731043 */     GIR_RootConstrainSelectedInstOperands,
     /*  731044 */     // GIR_Coverage, 11941,
     /*  731044 */     GIR_EraseRootFromParent_Done,
     /*  731045 */   // Label 11476: @731045
     /*  731045 */   GIM_Try, /*On fail goto*//*Label 11477*/ GIMT_Encode4(731120), // Rule ID 11944 //
     /*  731050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  731061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  731064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  731067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  731099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731118 */     GIR_RootConstrainSelectedInstOperands,
     /*  731119 */     // GIR_Coverage, 11944,
     /*  731119 */     GIR_EraseRootFromParent_Done,
     /*  731120 */   // Label 11477: @731120
     /*  731120 */   GIM_Try, /*On fail goto*//*Label 11478*/ GIMT_Encode4(731195), // Rule ID 11945 //
     /*  731125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  731136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  731139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  731142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  731145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731171 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  731174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731193 */     GIR_RootConstrainSelectedInstOperands,
     /*  731194 */     // GIR_Coverage, 11945,
     /*  731194 */     GIR_EraseRootFromParent_Done,
     /*  731195 */   // Label 11478: @731195
     /*  731195 */   GIM_Try, /*On fail goto*//*Label 11479*/ GIMT_Encode4(731270), // Rule ID 11948 //
     /*  731200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  731211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  731214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  731217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  731246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  731249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731268 */     GIR_RootConstrainSelectedInstOperands,
     /*  731269 */     // GIR_Coverage, 11948,
     /*  731269 */     GIR_EraseRootFromParent_Done,
     /*  731270 */   // Label 11479: @731270
     /*  731270 */   GIM_Try, /*On fail goto*//*Label 11480*/ GIMT_Encode4(731345), // Rule ID 11949 //
     /*  731275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  731286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  731289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  731292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  731295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  731321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  731324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731343 */     GIR_RootConstrainSelectedInstOperands,
     /*  731344 */     // GIR_Coverage, 11949,
     /*  731344 */     GIR_EraseRootFromParent_Done,
     /*  731345 */   // Label 11480: @731345
     /*  731345 */   GIM_Try, /*On fail goto*//*Label 11481*/ GIMT_Encode4(731420), // Rule ID 11952 //
     /*  731350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  731361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  731364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  731367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  731396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  731399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731418 */     GIR_RootConstrainSelectedInstOperands,
     /*  731419 */     // GIR_Coverage, 11952,
     /*  731419 */     GIR_EraseRootFromParent_Done,
     /*  731420 */   // Label 11481: @731420
     /*  731420 */   GIM_Try, /*On fail goto*//*Label 11482*/ GIMT_Encode4(731495), // Rule ID 11953 //
     /*  731425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  731436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  731439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  731442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  731445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  731471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  731474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731493 */     GIR_RootConstrainSelectedInstOperands,
     /*  731494 */     // GIR_Coverage, 11953,
     /*  731494 */     GIR_EraseRootFromParent_Done,
     /*  731495 */   // Label 11482: @731495
     /*  731495 */   GIM_Try, /*On fail goto*//*Label 11483*/ GIMT_Encode4(731570), // Rule ID 11956 //
     /*  731500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  731503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  731517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731546 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  731546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  731549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731568 */     GIR_RootConstrainSelectedInstOperands,
     /*  731569 */     // GIR_Coverage, 11956,
     /*  731569 */     GIR_EraseRootFromParent_Done,
     /*  731570 */   // Label 11483: @731570
     /*  731570 */   GIM_Try, /*On fail goto*//*Label 11484*/ GIMT_Encode4(731645), // Rule ID 11957 //
     /*  731575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  731578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  731592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  731595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731621 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  731621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  731624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731643 */     GIR_RootConstrainSelectedInstOperands,
     /*  731644 */     // GIR_Coverage, 11957,
     /*  731644 */     GIR_EraseRootFromParent_Done,
     /*  731645 */   // Label 11484: @731645
     /*  731645 */   GIM_Try, /*On fail goto*//*Label 11485*/ GIMT_Encode4(731720), // Rule ID 11960 //
     /*  731650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  731661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  731664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  731667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  731699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731718 */     GIR_RootConstrainSelectedInstOperands,
     /*  731719 */     // GIR_Coverage, 11960,
     /*  731719 */     GIR_EraseRootFromParent_Done,
     /*  731720 */   // Label 11485: @731720
     /*  731720 */   GIM_Try, /*On fail goto*//*Label 11486*/ GIMT_Encode4(731795), // Rule ID 11961 //
     /*  731725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  731736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  731739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  731742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  731745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731771 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  731774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731793 */     GIR_RootConstrainSelectedInstOperands,
     /*  731794 */     // GIR_Coverage, 11961,
     /*  731794 */     GIR_EraseRootFromParent_Done,
     /*  731795 */   // Label 11486: @731795
     /*  731795 */   GIM_Try, /*On fail goto*//*Label 11487*/ GIMT_Encode4(731870), // Rule ID 11964 //
     /*  731800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  731811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  731814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  731817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  731849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731868 */     GIR_RootConstrainSelectedInstOperands,
     /*  731869 */     // GIR_Coverage, 11964,
     /*  731869 */     GIR_EraseRootFromParent_Done,
     /*  731870 */   // Label 11487: @731870
     /*  731870 */   GIM_Try, /*On fail goto*//*Label 11488*/ GIMT_Encode4(731945), // Rule ID 11965 //
     /*  731875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  731886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  731889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  731892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  731895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  731924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731943 */     GIR_RootConstrainSelectedInstOperands,
     /*  731944 */     // GIR_Coverage, 11965,
     /*  731944 */     GIR_EraseRootFromParent_Done,
     /*  731945 */   // Label 11488: @731945
     /*  731945 */   GIM_Try, /*On fail goto*//*Label 11489*/ GIMT_Encode4(732020), // Rule ID 11968 //
     /*  731950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  731961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  731964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  731967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731996 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  731999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732018 */     GIR_RootConstrainSelectedInstOperands,
     /*  732019 */     // GIR_Coverage, 11968,
     /*  732019 */     GIR_EraseRootFromParent_Done,
     /*  732020 */   // Label 11489: @732020
     /*  732020 */   GIM_Try, /*On fail goto*//*Label 11490*/ GIMT_Encode4(732095), // Rule ID 11969 //
     /*  732025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  732036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  732039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  732042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732071 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  732071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  732074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732093 */     GIR_RootConstrainSelectedInstOperands,
     /*  732094 */     // GIR_Coverage, 11969,
     /*  732094 */     GIR_EraseRootFromParent_Done,
     /*  732095 */   // Label 11490: @732095
     /*  732095 */   GIM_Try, /*On fail goto*//*Label 11491*/ GIMT_Encode4(732170), // Rule ID 11972 //
     /*  732100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  732111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  732114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  732117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  732149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732168 */     GIR_RootConstrainSelectedInstOperands,
     /*  732169 */     // GIR_Coverage, 11972,
     /*  732169 */     GIR_EraseRootFromParent_Done,
     /*  732170 */   // Label 11491: @732170
     /*  732170 */   GIM_Try, /*On fail goto*//*Label 11492*/ GIMT_Encode4(732245), // Rule ID 11973 //
     /*  732175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  732186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  732189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  732192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  732224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732243 */     GIR_RootConstrainSelectedInstOperands,
     /*  732244 */     // GIR_Coverage, 11973,
     /*  732244 */     GIR_EraseRootFromParent_Done,
     /*  732245 */   // Label 11492: @732245
     /*  732245 */   GIM_Try, /*On fail goto*//*Label 11493*/ GIMT_Encode4(732320), // Rule ID 11976 //
     /*  732250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  732261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  732264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  732267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  732299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732318 */     GIR_RootConstrainSelectedInstOperands,
     /*  732319 */     // GIR_Coverage, 11976,
     /*  732319 */     GIR_EraseRootFromParent_Done,
     /*  732320 */   // Label 11493: @732320
     /*  732320 */   GIM_Try, /*On fail goto*//*Label 11494*/ GIMT_Encode4(732395), // Rule ID 11977 //
     /*  732325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  732336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  732339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  732342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732371 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  732374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732393 */     GIR_RootConstrainSelectedInstOperands,
     /*  732394 */     // GIR_Coverage, 11977,
     /*  732394 */     GIR_EraseRootFromParent_Done,
     /*  732395 */   // Label 11494: @732395
     /*  732395 */   GIM_Try, /*On fail goto*//*Label 11495*/ GIMT_Encode4(732470), // Rule ID 11980 //
     /*  732400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  732411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  732414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  732417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  732449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732468 */     GIR_RootConstrainSelectedInstOperands,
     /*  732469 */     // GIR_Coverage, 11980,
     /*  732469 */     GIR_EraseRootFromParent_Done,
     /*  732470 */   // Label 11495: @732470
     /*  732470 */   GIM_Try, /*On fail goto*//*Label 11496*/ GIMT_Encode4(732545), // Rule ID 11981 //
     /*  732475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  732486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  732489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  732492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  732524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732543 */     GIR_RootConstrainSelectedInstOperands,
     /*  732544 */     // GIR_Coverage, 11981,
     /*  732544 */     GIR_EraseRootFromParent_Done,
     /*  732545 */   // Label 11496: @732545
     /*  732545 */   GIM_Try, /*On fail goto*//*Label 11497*/ GIMT_Encode4(732620), // Rule ID 11984 //
     /*  732550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  732561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  732564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  732567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  732599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732618 */     GIR_RootConstrainSelectedInstOperands,
     /*  732619 */     // GIR_Coverage, 11984,
     /*  732619 */     GIR_EraseRootFromParent_Done,
     /*  732620 */   // Label 11497: @732620
     /*  732620 */   GIM_Try, /*On fail goto*//*Label 11498*/ GIMT_Encode4(732695), // Rule ID 11985 //
     /*  732625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  732636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  732639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  732642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732671 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  732674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732693 */     GIR_RootConstrainSelectedInstOperands,
     /*  732694 */     // GIR_Coverage, 11985,
     /*  732694 */     GIR_EraseRootFromParent_Done,
     /*  732695 */   // Label 11498: @732695
     /*  732695 */   GIM_Try, /*On fail goto*//*Label 11499*/ GIMT_Encode4(732770), // Rule ID 11988 //
     /*  732700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  732711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  732714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  732717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  732749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732768 */     GIR_RootConstrainSelectedInstOperands,
     /*  732769 */     // GIR_Coverage, 11988,
     /*  732769 */     GIR_EraseRootFromParent_Done,
     /*  732770 */   // Label 11499: @732770
     /*  732770 */   GIM_Try, /*On fail goto*//*Label 11500*/ GIMT_Encode4(732845), // Rule ID 11989 //
     /*  732775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  732786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  732789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  732792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732821 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  732824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732843 */     GIR_RootConstrainSelectedInstOperands,
     /*  732844 */     // GIR_Coverage, 11989,
     /*  732844 */     GIR_EraseRootFromParent_Done,
     /*  732845 */   // Label 11500: @732845
     /*  732845 */   GIM_Try, /*On fail goto*//*Label 11501*/ GIMT_Encode4(732920), // Rule ID 11992 //
     /*  732850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  732861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  732864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  732867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732896 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  732899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732918 */     GIR_RootConstrainSelectedInstOperands,
     /*  732919 */     // GIR_Coverage, 11992,
     /*  732919 */     GIR_EraseRootFromParent_Done,
     /*  732920 */   // Label 11501: @732920
     /*  732920 */   GIM_Try, /*On fail goto*//*Label 11502*/ GIMT_Encode4(732995), // Rule ID 11993 //
     /*  732925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  732936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  732939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  732942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732971 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  732974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732993 */     GIR_RootConstrainSelectedInstOperands,
     /*  732994 */     // GIR_Coverage, 11993,
     /*  732994 */     GIR_EraseRootFromParent_Done,
     /*  732995 */   // Label 11502: @732995
     /*  732995 */   GIM_Try, /*On fail goto*//*Label 11503*/ GIMT_Encode4(733070), // Rule ID 11996 //
     /*  733000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  733003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  733008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  733011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  733014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  733017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  733046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  733049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733068 */     GIR_RootConstrainSelectedInstOperands,
     /*  733069 */     // GIR_Coverage, 11996,
     /*  733069 */     GIR_EraseRootFromParent_Done,
     /*  733070 */   // Label 11503: @733070
     /*  733070 */   GIM_Try, /*On fail goto*//*Label 11504*/ GIMT_Encode4(733145), // Rule ID 11997 //
     /*  733075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  733078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  733083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  733086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  733089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  733092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  733121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  733124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733143 */     GIR_RootConstrainSelectedInstOperands,
     /*  733144 */     // GIR_Coverage, 11997,
     /*  733144 */     GIR_EraseRootFromParent_Done,
     /*  733145 */   // Label 11504: @733145
     /*  733145 */   GIM_Try, /*On fail goto*//*Label 11505*/ GIMT_Encode4(733220), // Rule ID 12000 //
     /*  733150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  733153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  733158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  733161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  733164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  733167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  733196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  733199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733218 */     GIR_RootConstrainSelectedInstOperands,
     /*  733219 */     // GIR_Coverage, 12000,
     /*  733219 */     GIR_EraseRootFromParent_Done,
     /*  733220 */   // Label 11505: @733220
     /*  733220 */   GIM_Try, /*On fail goto*//*Label 11506*/ GIMT_Encode4(733295), // Rule ID 12001 //
     /*  733225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  733228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  733233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  733236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  733239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  733242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  733271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  733274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733293 */     GIR_RootConstrainSelectedInstOperands,
     /*  733294 */     // GIR_Coverage, 12001,
     /*  733294 */     GIR_EraseRootFromParent_Done,
     /*  733295 */   // Label 11506: @733295
     /*  733295 */   GIM_Try, /*On fail goto*//*Label 11507*/ GIMT_Encode4(733370), // Rule ID 12004 //
     /*  733300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  733303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  733308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  733311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  733314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  733317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  733346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  733349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733368 */     GIR_RootConstrainSelectedInstOperands,
     /*  733369 */     // GIR_Coverage, 12004,
     /*  733369 */     GIR_EraseRootFromParent_Done,
     /*  733370 */   // Label 11507: @733370
     /*  733370 */   GIM_Try, /*On fail goto*//*Label 11508*/ GIMT_Encode4(733445), // Rule ID 12005 //
     /*  733375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  733378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  733383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  733386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  733389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  733392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733421 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  733421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  733424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733443 */     GIR_RootConstrainSelectedInstOperands,
     /*  733444 */     // GIR_Coverage, 12005,
     /*  733444 */     GIR_EraseRootFromParent_Done,
     /*  733445 */   // Label 11508: @733445
     /*  733445 */   GIM_Try, /*On fail goto*//*Label 11509*/ GIMT_Encode4(733520), // Rule ID 12008 //
     /*  733450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  733461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  733464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  733467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  733470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  733499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733518 */     GIR_RootConstrainSelectedInstOperands,
     /*  733519 */     // GIR_Coverage, 12008,
     /*  733519 */     GIR_EraseRootFromParent_Done,
     /*  733520 */   // Label 11509: @733520
     /*  733520 */   GIM_Try, /*On fail goto*//*Label 11510*/ GIMT_Encode4(733595), // Rule ID 12009 //
     /*  733525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  733536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  733539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  733542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  733545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733571 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  733574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733593 */     GIR_RootConstrainSelectedInstOperands,
     /*  733594 */     // GIR_Coverage, 12009,
     /*  733594 */     GIR_EraseRootFromParent_Done,
     /*  733595 */   // Label 11510: @733595
     /*  733595 */   GIM_Try, /*On fail goto*//*Label 11511*/ GIMT_Encode4(733670), // Rule ID 12012 //
     /*  733600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  733611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  733614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  733617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  733620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733646 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  733649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733668 */     GIR_RootConstrainSelectedInstOperands,
     /*  733669 */     // GIR_Coverage, 12012,
     /*  733669 */     GIR_EraseRootFromParent_Done,
     /*  733670 */   // Label 11511: @733670
     /*  733670 */   GIM_Try, /*On fail goto*//*Label 11512*/ GIMT_Encode4(733745), // Rule ID 12013 //
     /*  733675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  733686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  733689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  733692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  733695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733721 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  733724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733743 */     GIR_RootConstrainSelectedInstOperands,
     /*  733744 */     // GIR_Coverage, 12013,
     /*  733744 */     GIR_EraseRootFromParent_Done,
     /*  733745 */   // Label 11512: @733745
     /*  733745 */   GIM_Try, /*On fail goto*//*Label 11513*/ GIMT_Encode4(733820), // Rule ID 12016 //
     /*  733750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  733761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  733764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  733767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  733770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  733799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733818 */     GIR_RootConstrainSelectedInstOperands,
     /*  733819 */     // GIR_Coverage, 12016,
     /*  733819 */     GIR_EraseRootFromParent_Done,
     /*  733820 */   // Label 11513: @733820
     /*  733820 */   GIM_Try, /*On fail goto*//*Label 11514*/ GIMT_Encode4(733895), // Rule ID 12017 //
     /*  733825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  733836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  733839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  733842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  733845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733871 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  733874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733893 */     GIR_RootConstrainSelectedInstOperands,
     /*  733894 */     // GIR_Coverage, 12017,
     /*  733894 */     GIR_EraseRootFromParent_Done,
     /*  733895 */   // Label 11514: @733895
     /*  733895 */   GIM_Try, /*On fail goto*//*Label 11515*/ GIMT_Encode4(733970), // Rule ID 12020 //
     /*  733900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  733911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  733914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  733917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  733920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  733946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  733949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733968 */     GIR_RootConstrainSelectedInstOperands,
     /*  733969 */     // GIR_Coverage, 12020,
     /*  733969 */     GIR_EraseRootFromParent_Done,
     /*  733970 */   // Label 11515: @733970
     /*  733970 */   GIM_Try, /*On fail goto*//*Label 11516*/ GIMT_Encode4(734045), // Rule ID 12021 //
     /*  733975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  733986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  733989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  733992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  733995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734021 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  734024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734043 */     GIR_RootConstrainSelectedInstOperands,
     /*  734044 */     // GIR_Coverage, 12021,
     /*  734044 */     GIR_EraseRootFromParent_Done,
     /*  734045 */   // Label 11516: @734045
     /*  734045 */   GIM_Try, /*On fail goto*//*Label 11517*/ GIMT_Encode4(734120), // Rule ID 12024 //
     /*  734050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  734061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  734064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  734067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  734070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  734099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734118 */     GIR_RootConstrainSelectedInstOperands,
     /*  734119 */     // GIR_Coverage, 12024,
     /*  734119 */     GIR_EraseRootFromParent_Done,
     /*  734120 */   // Label 11517: @734120
     /*  734120 */   GIM_Try, /*On fail goto*//*Label 11518*/ GIMT_Encode4(734195), // Rule ID 12025 //
     /*  734125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  734136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  734139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  734142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  734145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  734174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734193 */     GIR_RootConstrainSelectedInstOperands,
     /*  734194 */     // GIR_Coverage, 12025,
     /*  734194 */     GIR_EraseRootFromParent_Done,
     /*  734195 */   // Label 11518: @734195
     /*  734195 */   GIM_Try, /*On fail goto*//*Label 11519*/ GIMT_Encode4(734270), // Rule ID 12028 //
     /*  734200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  734211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  734214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  734217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  734220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  734249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734268 */     GIR_RootConstrainSelectedInstOperands,
     /*  734269 */     // GIR_Coverage, 12028,
     /*  734269 */     GIR_EraseRootFromParent_Done,
     /*  734270 */   // Label 11519: @734270
     /*  734270 */   GIM_Try, /*On fail goto*//*Label 11520*/ GIMT_Encode4(734345), // Rule ID 12029 //
     /*  734275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  734286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  734289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  734292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  734295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734321 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  734324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734343 */     GIR_RootConstrainSelectedInstOperands,
     /*  734344 */     // GIR_Coverage, 12029,
     /*  734344 */     GIR_EraseRootFromParent_Done,
     /*  734345 */   // Label 11520: @734345
     /*  734345 */   GIM_Try, /*On fail goto*//*Label 11521*/ GIMT_Encode4(734420), // Rule ID 12032 //
     /*  734350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  734361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  734364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  734367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  734370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  734399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734418 */     GIR_RootConstrainSelectedInstOperands,
     /*  734419 */     // GIR_Coverage, 12032,
     /*  734419 */     GIR_EraseRootFromParent_Done,
     /*  734420 */   // Label 11521: @734420
     /*  734420 */   GIM_Try, /*On fail goto*//*Label 11522*/ GIMT_Encode4(734495), // Rule ID 12033 //
     /*  734425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  734436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  734439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  734442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  734445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734471 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  734474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734493 */     GIR_RootConstrainSelectedInstOperands,
     /*  734494 */     // GIR_Coverage, 12033,
     /*  734494 */     GIR_EraseRootFromParent_Done,
     /*  734495 */   // Label 11522: @734495
     /*  734495 */   GIM_Try, /*On fail goto*//*Label 11523*/ GIMT_Encode4(734570), // Rule ID 12036 //
     /*  734500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  734511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  734514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  734517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  734520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  734549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734568 */     GIR_RootConstrainSelectedInstOperands,
     /*  734569 */     // GIR_Coverage, 12036,
     /*  734569 */     GIR_EraseRootFromParent_Done,
     /*  734570 */   // Label 11523: @734570
     /*  734570 */   GIM_Try, /*On fail goto*//*Label 11524*/ GIMT_Encode4(734645), // Rule ID 12037 //
     /*  734575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  734586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  734589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  734592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  734595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  734624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734643 */     GIR_RootConstrainSelectedInstOperands,
     /*  734644 */     // GIR_Coverage, 12037,
     /*  734644 */     GIR_EraseRootFromParent_Done,
     /*  734645 */   // Label 11524: @734645
     /*  734645 */   GIM_Try, /*On fail goto*//*Label 11525*/ GIMT_Encode4(734720), // Rule ID 12040 //
     /*  734650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  734667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  734670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  734699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734718 */     GIR_RootConstrainSelectedInstOperands,
     /*  734719 */     // GIR_Coverage, 12040,
     /*  734719 */     GIR_EraseRootFromParent_Done,
     /*  734720 */   // Label 11525: @734720
     /*  734720 */   GIM_Try, /*On fail goto*//*Label 11526*/ GIMT_Encode4(734795), // Rule ID 12041 //
     /*  734725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  734742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  734745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734771 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  734774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734793 */     GIR_RootConstrainSelectedInstOperands,
     /*  734794 */     // GIR_Coverage, 12041,
     /*  734794 */     GIR_EraseRootFromParent_Done,
     /*  734795 */   // Label 11526: @734795
     /*  734795 */   GIM_Try, /*On fail goto*//*Label 11527*/ GIMT_Encode4(734870), // Rule ID 12044 //
     /*  734800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  734803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  734817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  734820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734846 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  734846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  734849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734868 */     GIR_RootConstrainSelectedInstOperands,
     /*  734869 */     // GIR_Coverage, 12044,
     /*  734869 */     GIR_EraseRootFromParent_Done,
     /*  734870 */   // Label 11527: @734870
     /*  734870 */   GIM_Try, /*On fail goto*//*Label 11528*/ GIMT_Encode4(734945), // Rule ID 12045 //
     /*  734875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  734878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  734892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  734895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734921 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  734921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  734924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734943 */     GIR_RootConstrainSelectedInstOperands,
     /*  734944 */     // GIR_Coverage, 12045,
     /*  734944 */     GIR_EraseRootFromParent_Done,
     /*  734945 */   // Label 11528: @734945
     /*  734945 */   GIM_Try, /*On fail goto*//*Label 11529*/ GIMT_Encode4(735020), // Rule ID 12048 //
     /*  734950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  734961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  734964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  734967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  734970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734996 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  734999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735018 */     GIR_RootConstrainSelectedInstOperands,
     /*  735019 */     // GIR_Coverage, 12048,
     /*  735019 */     GIR_EraseRootFromParent_Done,
     /*  735020 */   // Label 11529: @735020
     /*  735020 */   GIM_Try, /*On fail goto*//*Label 11530*/ GIMT_Encode4(735095), // Rule ID 12049 //
     /*  735025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  735036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  735039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  735042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  735045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735071 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  735074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735093 */     GIR_RootConstrainSelectedInstOperands,
     /*  735094 */     // GIR_Coverage, 12049,
     /*  735094 */     GIR_EraseRootFromParent_Done,
     /*  735095 */   // Label 11530: @735095
     /*  735095 */   GIM_Try, /*On fail goto*//*Label 11531*/ GIMT_Encode4(735170), // Rule ID 12052 //
     /*  735100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  735111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  735114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  735117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  735120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735146 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  735146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  735149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735168 */     GIR_RootConstrainSelectedInstOperands,
     /*  735169 */     // GIR_Coverage, 12052,
     /*  735169 */     GIR_EraseRootFromParent_Done,
     /*  735170 */   // Label 11531: @735170
     /*  735170 */   GIM_Try, /*On fail goto*//*Label 11532*/ GIMT_Encode4(735245), // Rule ID 12053 //
     /*  735175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  735186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  735189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  735192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  735195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735221 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  735224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735243 */     GIR_RootConstrainSelectedInstOperands,
     /*  735244 */     // GIR_Coverage, 12053,
     /*  735244 */     GIR_EraseRootFromParent_Done,
     /*  735245 */   // Label 11532: @735245
     /*  735245 */   GIM_Try, /*On fail goto*//*Label 11533*/ GIMT_Encode4(735320), // Rule ID 12056 //
     /*  735250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  735261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  735264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  735267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  735270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735296 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  735296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  735299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735318 */     GIR_RootConstrainSelectedInstOperands,
     /*  735319 */     // GIR_Coverage, 12056,
     /*  735319 */     GIR_EraseRootFromParent_Done,
     /*  735320 */   // Label 11533: @735320
     /*  735320 */   GIM_Try, /*On fail goto*//*Label 11534*/ GIMT_Encode4(735395), // Rule ID 12057 //
     /*  735325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  735336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  735339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  735342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  735345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735371 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  735374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735393 */     GIR_RootConstrainSelectedInstOperands,
     /*  735394 */     // GIR_Coverage, 12057,
     /*  735394 */     GIR_EraseRootFromParent_Done,
     /*  735395 */   // Label 11534: @735395
     /*  735395 */   GIM_Try, /*On fail goto*//*Label 11535*/ GIMT_Encode4(735470), // Rule ID 12060 //
     /*  735400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  735411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  735414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  735417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  735420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735446 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  735449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735468 */     GIR_RootConstrainSelectedInstOperands,
     /*  735469 */     // GIR_Coverage, 12060,
     /*  735469 */     GIR_EraseRootFromParent_Done,
     /*  735470 */   // Label 11535: @735470
     /*  735470 */   GIM_Try, /*On fail goto*//*Label 11536*/ GIMT_Encode4(735545), // Rule ID 12061 //
     /*  735475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  735486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  735489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  735492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  735495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  735524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735543 */     GIR_RootConstrainSelectedInstOperands,
     /*  735544 */     // GIR_Coverage, 12061,
     /*  735544 */     GIR_EraseRootFromParent_Done,
     /*  735545 */   // Label 11536: @735545
     /*  735545 */   GIM_Try, /*On fail goto*//*Label 11537*/ GIMT_Encode4(735620), // Rule ID 12064 //
     /*  735550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  735561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  735564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  735567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  735570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735596 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  735599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735618 */     GIR_RootConstrainSelectedInstOperands,
     /*  735619 */     // GIR_Coverage, 12064,
     /*  735619 */     GIR_EraseRootFromParent_Done,
     /*  735620 */   // Label 11537: @735620
     /*  735620 */   GIM_Try, /*On fail goto*//*Label 11538*/ GIMT_Encode4(735695), // Rule ID 12065 //
     /*  735625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  735636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  735639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  735642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  735645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735671 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  735674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735693 */     GIR_RootConstrainSelectedInstOperands,
     /*  735694 */     // GIR_Coverage, 12065,
     /*  735694 */     GIR_EraseRootFromParent_Done,
     /*  735695 */   // Label 11538: @735695
     /*  735695 */   GIM_Try, /*On fail goto*//*Label 11539*/ GIMT_Encode4(735770), // Rule ID 12068 //
     /*  735700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  735711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  735714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  735717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  735720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  735749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735768 */     GIR_RootConstrainSelectedInstOperands,
     /*  735769 */     // GIR_Coverage, 12068,
     /*  735769 */     GIR_EraseRootFromParent_Done,
     /*  735770 */   // Label 11539: @735770
     /*  735770 */   GIM_Try, /*On fail goto*//*Label 11540*/ GIMT_Encode4(735845), // Rule ID 12069 //
     /*  735775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  735786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  735789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  735792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  735795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735821 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  735824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735843 */     GIR_RootConstrainSelectedInstOperands,
     /*  735844 */     // GIR_Coverage, 12069,
     /*  735844 */     GIR_EraseRootFromParent_Done,
     /*  735845 */   // Label 11540: @735845
     /*  735845 */   GIM_Try, /*On fail goto*//*Label 11541*/ GIMT_Encode4(735920), // Rule ID 12072 //
     /*  735850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  735861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  735864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  735867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  735870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  735899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735918 */     GIR_RootConstrainSelectedInstOperands,
     /*  735919 */     // GIR_Coverage, 12072,
     /*  735919 */     GIR_EraseRootFromParent_Done,
     /*  735920 */   // Label 11541: @735920
     /*  735920 */   GIM_Try, /*On fail goto*//*Label 11542*/ GIMT_Encode4(735995), // Rule ID 12073 //
     /*  735925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  735936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  735939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  735942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  735945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  735971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  735974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735993 */     GIR_RootConstrainSelectedInstOperands,
     /*  735994 */     // GIR_Coverage, 12073,
     /*  735994 */     GIR_EraseRootFromParent_Done,
     /*  735995 */   // Label 11542: @735995
     /*  735995 */   GIM_Try, /*On fail goto*//*Label 11543*/ GIMT_Encode4(736070), // Rule ID 12076 //
     /*  736000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  736011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  736014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  736017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  736020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  736046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  736049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736068 */     GIR_RootConstrainSelectedInstOperands,
     /*  736069 */     // GIR_Coverage, 12076,
     /*  736069 */     GIR_EraseRootFromParent_Done,
     /*  736070 */   // Label 11543: @736070
     /*  736070 */   GIM_Try, /*On fail goto*//*Label 11544*/ GIMT_Encode4(736145), // Rule ID 12077 //
     /*  736075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  736086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  736089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  736092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  736095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  736121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  736124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736143 */     GIR_RootConstrainSelectedInstOperands,
     /*  736144 */     // GIR_Coverage, 12077,
     /*  736144 */     GIR_EraseRootFromParent_Done,
     /*  736145 */   // Label 11544: @736145
     /*  736145 */   GIM_Try, /*On fail goto*//*Label 11545*/ GIMT_Encode4(736220), // Rule ID 12080 //
     /*  736150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  736161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  736164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  736167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  736170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  736196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  736199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736218 */     GIR_RootConstrainSelectedInstOperands,
     /*  736219 */     // GIR_Coverage, 12080,
     /*  736219 */     GIR_EraseRootFromParent_Done,
     /*  736220 */   // Label 11545: @736220
     /*  736220 */   GIM_Try, /*On fail goto*//*Label 11546*/ GIMT_Encode4(736295), // Rule ID 12081 //
     /*  736225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  736236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  736239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  736242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  736245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736271 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  736271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  736274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736293 */     GIR_RootConstrainSelectedInstOperands,
     /*  736294 */     // GIR_Coverage, 12081,
     /*  736294 */     GIR_EraseRootFromParent_Done,
     /*  736295 */   // Label 11546: @736295
     /*  736295 */   GIM_Try, /*On fail goto*//*Label 11547*/ GIMT_Encode4(736370), // Rule ID 12084 //
     /*  736300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  736311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  736314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  736317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  736320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  736349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736368 */     GIR_RootConstrainSelectedInstOperands,
     /*  736369 */     // GIR_Coverage, 12084,
     /*  736369 */     GIR_EraseRootFromParent_Done,
     /*  736370 */   // Label 11547: @736370
     /*  736370 */   GIM_Try, /*On fail goto*//*Label 11548*/ GIMT_Encode4(736445), // Rule ID 12085 //
     /*  736375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  736386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  736389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  736392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  736395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  736424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736443 */     GIR_RootConstrainSelectedInstOperands,
     /*  736444 */     // GIR_Coverage, 12085,
     /*  736444 */     GIR_EraseRootFromParent_Done,
     /*  736445 */   // Label 11548: @736445
     /*  736445 */   GIM_Try, /*On fail goto*//*Label 11549*/ GIMT_Encode4(736520), // Rule ID 12088 //
     /*  736450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  736461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  736464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  736467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  736470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  736499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736518 */     GIR_RootConstrainSelectedInstOperands,
     /*  736519 */     // GIR_Coverage, 12088,
     /*  736519 */     GIR_EraseRootFromParent_Done,
     /*  736520 */   // Label 11549: @736520
     /*  736520 */   GIM_Try, /*On fail goto*//*Label 11550*/ GIMT_Encode4(736595), // Rule ID 12089 //
     /*  736525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  736536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  736539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  736542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  736545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736571 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  736574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736593 */     GIR_RootConstrainSelectedInstOperands,
     /*  736594 */     // GIR_Coverage, 12089,
     /*  736594 */     GIR_EraseRootFromParent_Done,
     /*  736595 */   // Label 11550: @736595
     /*  736595 */   GIM_Try, /*On fail goto*//*Label 11551*/ GIMT_Encode4(736670), // Rule ID 12092 //
     /*  736600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  736611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  736614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  736617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  736620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  736649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736668 */     GIR_RootConstrainSelectedInstOperands,
     /*  736669 */     // GIR_Coverage, 12092,
     /*  736669 */     GIR_EraseRootFromParent_Done,
     /*  736670 */   // Label 11551: @736670
     /*  736670 */   GIM_Try, /*On fail goto*//*Label 11552*/ GIMT_Encode4(736745), // Rule ID 12093 //
     /*  736675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  736686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  736689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  736692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  736695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736721 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  736724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736743 */     GIR_RootConstrainSelectedInstOperands,
     /*  736744 */     // GIR_Coverage, 12093,
     /*  736744 */     GIR_EraseRootFromParent_Done,
     /*  736745 */   // Label 11552: @736745
     /*  736745 */   GIM_Try, /*On fail goto*//*Label 11553*/ GIMT_Encode4(736820), // Rule ID 12096 //
     /*  736750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  736761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  736764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  736767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736796 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  736799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736818 */     GIR_RootConstrainSelectedInstOperands,
     /*  736819 */     // GIR_Coverage, 12096,
     /*  736819 */     GIR_EraseRootFromParent_Done,
     /*  736820 */   // Label 11553: @736820
     /*  736820 */   GIM_Try, /*On fail goto*//*Label 11554*/ GIMT_Encode4(736895), // Rule ID 12097 //
     /*  736825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  736836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  736839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  736842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736871 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  736874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736893 */     GIR_RootConstrainSelectedInstOperands,
     /*  736894 */     // GIR_Coverage, 12097,
     /*  736894 */     GIR_EraseRootFromParent_Done,
     /*  736895 */   // Label 11554: @736895
     /*  736895 */   GIM_Try, /*On fail goto*//*Label 11555*/ GIMT_Encode4(736970), // Rule ID 12100 //
     /*  736900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  736911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  736914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  736917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736946 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  736949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736968 */     GIR_RootConstrainSelectedInstOperands,
     /*  736969 */     // GIR_Coverage, 12100,
     /*  736969 */     GIR_EraseRootFromParent_Done,
     /*  736970 */   // Label 11555: @736970
     /*  736970 */   GIM_Try, /*On fail goto*//*Label 11556*/ GIMT_Encode4(737045), // Rule ID 12101 //
     /*  736975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  736986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  736989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  736992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737021 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  737024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737043 */     GIR_RootConstrainSelectedInstOperands,
     /*  737044 */     // GIR_Coverage, 12101,
     /*  737044 */     GIR_EraseRootFromParent_Done,
     /*  737045 */   // Label 11556: @737045
     /*  737045 */   GIM_Try, /*On fail goto*//*Label 11557*/ GIMT_Encode4(737120), // Rule ID 12104 //
     /*  737050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  737061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  737064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  737067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  737099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737118 */     GIR_RootConstrainSelectedInstOperands,
     /*  737119 */     // GIR_Coverage, 12104,
     /*  737119 */     GIR_EraseRootFromParent_Done,
     /*  737120 */   // Label 11557: @737120
     /*  737120 */   GIM_Try, /*On fail goto*//*Label 11558*/ GIMT_Encode4(737195), // Rule ID 12105 //
     /*  737125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  737136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  737139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  737142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  737145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737171 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  737174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737193 */     GIR_RootConstrainSelectedInstOperands,
     /*  737194 */     // GIR_Coverage, 12105,
     /*  737194 */     GIR_EraseRootFromParent_Done,
     /*  737195 */   // Label 11558: @737195
     /*  737195 */   GIM_Try, /*On fail goto*//*Label 11559*/ GIMT_Encode4(737270), // Rule ID 12108 //
     /*  737200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  737211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  737214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  737217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737246 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  737249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737268 */     GIR_RootConstrainSelectedInstOperands,
     /*  737269 */     // GIR_Coverage, 12108,
     /*  737269 */     GIR_EraseRootFromParent_Done,
     /*  737270 */   // Label 11559: @737270
     /*  737270 */   GIM_Try, /*On fail goto*//*Label 11560*/ GIMT_Encode4(737345), // Rule ID 12109 //
     /*  737275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  737286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  737289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  737292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  737295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737321 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  737324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737343 */     GIR_RootConstrainSelectedInstOperands,
     /*  737344 */     // GIR_Coverage, 12109,
     /*  737344 */     GIR_EraseRootFromParent_Done,
     /*  737345 */   // Label 11560: @737345
     /*  737345 */   GIM_Try, /*On fail goto*//*Label 11561*/ GIMT_Encode4(737420), // Rule ID 12112 //
     /*  737350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  737361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  737364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  737367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737396 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  737399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737418 */     GIR_RootConstrainSelectedInstOperands,
     /*  737419 */     // GIR_Coverage, 12112,
     /*  737419 */     GIR_EraseRootFromParent_Done,
     /*  737420 */   // Label 11561: @737420
     /*  737420 */   GIM_Try, /*On fail goto*//*Label 11562*/ GIMT_Encode4(737495), // Rule ID 12113 //
     /*  737425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  737436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  737439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  737442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  737445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737471 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  737474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737493 */     GIR_RootConstrainSelectedInstOperands,
     /*  737494 */     // GIR_Coverage, 12113,
     /*  737494 */     GIR_EraseRootFromParent_Done,
     /*  737495 */   // Label 11562: @737495
     /*  737495 */   GIM_Try, /*On fail goto*//*Label 11563*/ GIMT_Encode4(737570), // Rule ID 12116 //
     /*  737500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  737511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  737514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  737517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  737549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737568 */     GIR_RootConstrainSelectedInstOperands,
     /*  737569 */     // GIR_Coverage, 12116,
     /*  737569 */     GIR_EraseRootFromParent_Done,
     /*  737570 */   // Label 11563: @737570
     /*  737570 */   GIM_Try, /*On fail goto*//*Label 11564*/ GIMT_Encode4(737645), // Rule ID 12117 //
     /*  737575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  737586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  737589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  737592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  737595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737621 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  737621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  737624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737643 */     GIR_RootConstrainSelectedInstOperands,
     /*  737644 */     // GIR_Coverage, 12117,
     /*  737644 */     GIR_EraseRootFromParent_Done,
     /*  737645 */   // Label 11564: @737645
     /*  737645 */   GIM_Try, /*On fail goto*//*Label 11565*/ GIMT_Encode4(737720), // Rule ID 12120 //
     /*  737650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  737661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  737664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  737667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  737699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737718 */     GIR_RootConstrainSelectedInstOperands,
     /*  737719 */     // GIR_Coverage, 12120,
     /*  737719 */     GIR_EraseRootFromParent_Done,
     /*  737720 */   // Label 11565: @737720
     /*  737720 */   GIM_Try, /*On fail goto*//*Label 11566*/ GIMT_Encode4(737795), // Rule ID 12121 //
     /*  737725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  737736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  737739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  737742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  737745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737771 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  737774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737793 */     GIR_RootConstrainSelectedInstOperands,
     /*  737794 */     // GIR_Coverage, 12121,
     /*  737794 */     GIR_EraseRootFromParent_Done,
     /*  737795 */   // Label 11566: @737795
     /*  737795 */   GIM_Try, /*On fail goto*//*Label 11567*/ GIMT_Encode4(737870), // Rule ID 12124 //
     /*  737800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  737817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737846 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  737849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737868 */     GIR_RootConstrainSelectedInstOperands,
     /*  737869 */     // GIR_Coverage, 12124,
     /*  737869 */     GIR_EraseRootFromParent_Done,
     /*  737870 */   // Label 11567: @737870
     /*  737870 */   GIM_Try, /*On fail goto*//*Label 11568*/ GIMT_Encode4(737945), // Rule ID 12125 //
     /*  737875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  737892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  737895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737921 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  737924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737943 */     GIR_RootConstrainSelectedInstOperands,
     /*  737944 */     // GIR_Coverage, 12125,
     /*  737944 */     GIR_EraseRootFromParent_Done,
     /*  737945 */   // Label 11568: @737945
     /*  737945 */   GIM_Try, /*On fail goto*//*Label 11569*/ GIMT_Encode4(738020), // Rule ID 12128 //
     /*  737950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  737967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  737999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738018 */     GIR_RootConstrainSelectedInstOperands,
     /*  738019 */     // GIR_Coverage, 12128,
     /*  738019 */     GIR_EraseRootFromParent_Done,
     /*  738020 */   // Label 11569: @738020
     /*  738020 */   GIM_Try, /*On fail goto*//*Label 11570*/ GIMT_Encode4(738095), // Rule ID 12129 //
     /*  738025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  738036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  738039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  738042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  738071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  738074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738093 */     GIR_RootConstrainSelectedInstOperands,
     /*  738094 */     // GIR_Coverage, 12129,
     /*  738094 */     GIR_EraseRootFromParent_Done,
     /*  738095 */   // Label 11570: @738095
     /*  738095 */   GIM_Try, /*On fail goto*//*Label 11571*/ GIMT_Encode4(738170), // Rule ID 12132 //
     /*  738100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  738103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  738111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  738114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  738117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  738120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738146 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  738146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  738149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738168 */     GIR_RootConstrainSelectedInstOperands,
     /*  738169 */     // GIR_Coverage, 12132,
     /*  738169 */     GIR_EraseRootFromParent_Done,
     /*  738170 */   // Label 11571: @738170
     /*  738170 */   GIM_Try, /*On fail goto*//*Label 11572*/ GIMT_Encode4(738245), // Rule ID 12133 //
     /*  738175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  738178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  738186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  738189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  738192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738221 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  738221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  738224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738243 */     GIR_RootConstrainSelectedInstOperands,
     /*  738244 */     // GIR_Coverage, 12133,
     /*  738244 */     GIR_EraseRootFromParent_Done,
     /*  738245 */   // Label 11572: @738245
     /*  738245 */   GIM_Try, /*On fail goto*//*Label 11573*/ GIMT_Encode4(738320), // Rule ID 12136 //
     /*  738250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  738261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  738264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  738267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  738270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738296 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  738299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738318 */     GIR_RootConstrainSelectedInstOperands,
     /*  738319 */     // GIR_Coverage, 12136,
     /*  738319 */     GIR_EraseRootFromParent_Done,
     /*  738320 */   // Label 11573: @738320
     /*  738320 */   GIM_Try, /*On fail goto*//*Label 11574*/ GIMT_Encode4(738395), // Rule ID 12137 //
     /*  738325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  738336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  738339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  738342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  738374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738393 */     GIR_RootConstrainSelectedInstOperands,
     /*  738394 */     // GIR_Coverage, 12137,
     /*  738394 */     GIR_EraseRootFromParent_Done,
     /*  738395 */   // Label 11574: @738395
     /*  738395 */   GIM_Try, /*On fail goto*//*Label 11575*/ GIMT_Encode4(738470), // Rule ID 12140 //
     /*  738400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  738411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  738414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  738417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  738420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738446 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  738449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738468 */     GIR_RootConstrainSelectedInstOperands,
     /*  738469 */     // GIR_Coverage, 12140,
     /*  738469 */     GIR_EraseRootFromParent_Done,
     /*  738470 */   // Label 11575: @738470
     /*  738470 */   GIM_Try, /*On fail goto*//*Label 11576*/ GIMT_Encode4(738545), // Rule ID 12141 //
     /*  738475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  738486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  738489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  738492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738521 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  738524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738543 */     GIR_RootConstrainSelectedInstOperands,
     /*  738544 */     // GIR_Coverage, 12141,
     /*  738544 */     GIR_EraseRootFromParent_Done,
     /*  738545 */   // Label 11576: @738545
     /*  738545 */   GIM_Try, /*On fail goto*//*Label 11577*/ GIMT_Encode4(738620), // Rule ID 12144 //
     /*  738550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  738561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  738564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  738567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  738570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738596 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  738599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738618 */     GIR_RootConstrainSelectedInstOperands,
     /*  738619 */     // GIR_Coverage, 12144,
     /*  738619 */     GIR_EraseRootFromParent_Done,
     /*  738620 */   // Label 11577: @738620
     /*  738620 */   GIM_Try, /*On fail goto*//*Label 11578*/ GIMT_Encode4(738695), // Rule ID 12145 //
     /*  738625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  738636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  738639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  738642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738671 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  738674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738693 */     GIR_RootConstrainSelectedInstOperands,
     /*  738694 */     // GIR_Coverage, 12145,
     /*  738694 */     GIR_EraseRootFromParent_Done,
     /*  738695 */   // Label 11578: @738695
     /*  738695 */   GIM_Try, /*On fail goto*//*Label 11579*/ GIMT_Encode4(738770), // Rule ID 12148 //
     /*  738700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  738711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  738714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  738717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  738720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  738749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738768 */     GIR_RootConstrainSelectedInstOperands,
     /*  738769 */     // GIR_Coverage, 12148,
     /*  738769 */     GIR_EraseRootFromParent_Done,
     /*  738770 */   // Label 11579: @738770
     /*  738770 */   GIM_Try, /*On fail goto*//*Label 11580*/ GIMT_Encode4(738845), // Rule ID 12149 //
     /*  738775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  738786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  738789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  738792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738821 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  738824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738843 */     GIR_RootConstrainSelectedInstOperands,
     /*  738844 */     // GIR_Coverage, 12149,
     /*  738844 */     GIR_EraseRootFromParent_Done,
     /*  738845 */   // Label 11580: @738845
     /*  738845 */   GIM_Try, /*On fail goto*//*Label 11581*/ GIMT_Encode4(738920), // Rule ID 12152 //
     /*  738850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  738861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  738864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  738867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  738870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738896 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  738899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738918 */     GIR_RootConstrainSelectedInstOperands,
     /*  738919 */     // GIR_Coverage, 12152,
     /*  738919 */     GIR_EraseRootFromParent_Done,
     /*  738920 */   // Label 11581: @738920
     /*  738920 */   GIM_Try, /*On fail goto*//*Label 11582*/ GIMT_Encode4(738995), // Rule ID 12153 //
     /*  738925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  738936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  738939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  738942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738971 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  738974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738993 */     GIR_RootConstrainSelectedInstOperands,
     /*  738994 */     // GIR_Coverage, 12153,
     /*  738994 */     GIR_EraseRootFromParent_Done,
     /*  738995 */   // Label 11582: @738995
     /*  738995 */   GIM_Try, /*On fail goto*//*Label 11583*/ GIMT_Encode4(739070), // Rule ID 12156 //
     /*  739000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  739011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  739014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  739017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  739046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  739049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  739065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739068 */     GIR_RootConstrainSelectedInstOperands,
     /*  739069 */     // GIR_Coverage, 12156,
     /*  739069 */     GIR_EraseRootFromParent_Done,
     /*  739070 */   // Label 11583: @739070
     /*  739070 */   GIM_Try, /*On fail goto*//*Label 11584*/ GIMT_Encode4(739145), // Rule ID 12157 //
     /*  739075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  739086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  739089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  739092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739121 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  739121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  739124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  739140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739143 */     GIR_RootConstrainSelectedInstOperands,
     /*  739144 */     // GIR_Coverage, 12157,
     /*  739144 */     GIR_EraseRootFromParent_Done,
     /*  739145 */   // Label 11584: @739145
     /*  739145 */   GIM_Try, /*On fail goto*//*Label 11585*/ GIMT_Encode4(739220), // Rule ID 12160 //
     /*  739150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  739161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  739164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  739167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  739199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739218 */     GIR_RootConstrainSelectedInstOperands,
     /*  739219 */     // GIR_Coverage, 12160,
     /*  739219 */     GIR_EraseRootFromParent_Done,
     /*  739220 */   // Label 11585: @739220
     /*  739220 */   GIM_Try, /*On fail goto*//*Label 11586*/ GIMT_Encode4(739295), // Rule ID 12161 //
     /*  739225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  739236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  739239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  739242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  739274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739293 */     GIR_RootConstrainSelectedInstOperands,
     /*  739294 */     // GIR_Coverage, 12161,
     /*  739294 */     GIR_EraseRootFromParent_Done,
     /*  739295 */   // Label 11586: @739295
     /*  739295 */   GIM_Try, /*On fail goto*//*Label 11587*/ GIMT_Encode4(739370), // Rule ID 12164 //
     /*  739300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  739311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  739314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  739317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  739349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739368 */     GIR_RootConstrainSelectedInstOperands,
     /*  739369 */     // GIR_Coverage, 12164,
     /*  739369 */     GIR_EraseRootFromParent_Done,
     /*  739370 */   // Label 11587: @739370
     /*  739370 */   GIM_Try, /*On fail goto*//*Label 11588*/ GIMT_Encode4(739445), // Rule ID 12165 //
     /*  739375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  739386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  739389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  739392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  739424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739443 */     GIR_RootConstrainSelectedInstOperands,
     /*  739444 */     // GIR_Coverage, 12165,
     /*  739444 */     GIR_EraseRootFromParent_Done,
     /*  739445 */   // Label 11588: @739445
     /*  739445 */   GIM_Try, /*On fail goto*//*Label 11589*/ GIMT_Encode4(739520), // Rule ID 12168 //
     /*  739450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  739461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  739464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  739467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739496 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  739499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739518 */     GIR_RootConstrainSelectedInstOperands,
     /*  739519 */     // GIR_Coverage, 12168,
     /*  739519 */     GIR_EraseRootFromParent_Done,
     /*  739520 */   // Label 11589: @739520
     /*  739520 */   GIM_Try, /*On fail goto*//*Label 11590*/ GIMT_Encode4(739595), // Rule ID 12169 //
     /*  739525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  739536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  739539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  739542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739571 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  739574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739593 */     GIR_RootConstrainSelectedInstOperands,
     /*  739594 */     // GIR_Coverage, 12169,
     /*  739594 */     GIR_EraseRootFromParent_Done,
     /*  739595 */   // Label 11590: @739595
     /*  739595 */   GIM_Try, /*On fail goto*//*Label 11591*/ GIMT_Encode4(739670), // Rule ID 12172 //
     /*  739600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  739611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  739614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  739617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  739649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739668 */     GIR_RootConstrainSelectedInstOperands,
     /*  739669 */     // GIR_Coverage, 12172,
     /*  739669 */     GIR_EraseRootFromParent_Done,
     /*  739670 */   // Label 11591: @739670
     /*  739670 */   GIM_Try, /*On fail goto*//*Label 11592*/ GIMT_Encode4(739745), // Rule ID 12173 //
     /*  739675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  739686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  739689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  739692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739721 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  739724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739743 */     GIR_RootConstrainSelectedInstOperands,
     /*  739744 */     // GIR_Coverage, 12173,
     /*  739744 */     GIR_EraseRootFromParent_Done,
     /*  739745 */   // Label 11592: @739745
     /*  739745 */   GIM_Try, /*On fail goto*//*Label 11593*/ GIMT_Encode4(739820), // Rule ID 12176 //
     /*  739750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  739761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  739764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  739767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739796 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  739799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739818 */     GIR_RootConstrainSelectedInstOperands,
     /*  739819 */     // GIR_Coverage, 12176,
     /*  739819 */     GIR_EraseRootFromParent_Done,
     /*  739820 */   // Label 11593: @739820
     /*  739820 */   GIM_Try, /*On fail goto*//*Label 11594*/ GIMT_Encode4(739895), // Rule ID 12177 //
     /*  739825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  739836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  739839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  739842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739871 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  739874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739893 */     GIR_RootConstrainSelectedInstOperands,
     /*  739894 */     // GIR_Coverage, 12177,
     /*  739894 */     GIR_EraseRootFromParent_Done,
     /*  739895 */   // Label 11594: @739895
     /*  739895 */   GIM_Try, /*On fail goto*//*Label 11595*/ GIMT_Encode4(739970), // Rule ID 12180 //
     /*  739900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  739911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  739914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  739917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  739949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739968 */     GIR_RootConstrainSelectedInstOperands,
     /*  739969 */     // GIR_Coverage, 12180,
     /*  739969 */     GIR_EraseRootFromParent_Done,
     /*  739970 */   // Label 11595: @739970
     /*  739970 */   GIM_Try, /*On fail goto*//*Label 11596*/ GIMT_Encode4(740045), // Rule ID 12181 //
     /*  739975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  739986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  739989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  739992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740021 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  740021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  740024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  740040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740043 */     GIR_RootConstrainSelectedInstOperands,
     /*  740044 */     // GIR_Coverage, 12181,
     /*  740044 */     GIR_EraseRootFromParent_Done,
     /*  740045 */   // Label 11596: @740045
     /*  740045 */   GIM_Try, /*On fail goto*//*Label 11597*/ GIMT_Encode4(740120), // Rule ID 12184 //
     /*  740050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  740061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  740064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  740067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  740070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740096 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  740099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740118 */     GIR_RootConstrainSelectedInstOperands,
     /*  740119 */     // GIR_Coverage, 12184,
     /*  740119 */     GIR_EraseRootFromParent_Done,
     /*  740120 */   // Label 11597: @740120
     /*  740120 */   GIM_Try, /*On fail goto*//*Label 11598*/ GIMT_Encode4(740195), // Rule ID 12185 //
     /*  740125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  740136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  740139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  740142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  740145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740171 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  740174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740193 */     GIR_RootConstrainSelectedInstOperands,
     /*  740194 */     // GIR_Coverage, 12185,
     /*  740194 */     GIR_EraseRootFromParent_Done,
     /*  740195 */   // Label 11598: @740195
     /*  740195 */   GIM_Try, /*On fail goto*//*Label 11599*/ GIMT_Encode4(740270), // Rule ID 12188 //
     /*  740200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  740211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  740214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  740217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  740220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740246 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  740249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740268 */     GIR_RootConstrainSelectedInstOperands,
     /*  740269 */     // GIR_Coverage, 12188,
     /*  740269 */     GIR_EraseRootFromParent_Done,
     /*  740270 */   // Label 11599: @740270
     /*  740270 */   GIM_Try, /*On fail goto*//*Label 11600*/ GIMT_Encode4(740345), // Rule ID 12189 //
     /*  740275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  740286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  740289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  740292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  740295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740321 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  740324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740343 */     GIR_RootConstrainSelectedInstOperands,
     /*  740344 */     // GIR_Coverage, 12189,
     /*  740344 */     GIR_EraseRootFromParent_Done,
     /*  740345 */   // Label 11600: @740345
     /*  740345 */   GIM_Try, /*On fail goto*//*Label 11601*/ GIMT_Encode4(740420), // Rule ID 12192 //
     /*  740350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  740361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  740364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  740367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  740370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  740399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740418 */     GIR_RootConstrainSelectedInstOperands,
     /*  740419 */     // GIR_Coverage, 12192,
     /*  740419 */     GIR_EraseRootFromParent_Done,
     /*  740420 */   // Label 11601: @740420
     /*  740420 */   GIM_Try, /*On fail goto*//*Label 11602*/ GIMT_Encode4(740495), // Rule ID 12193 //
     /*  740425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  740436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  740439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  740442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  740445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740471 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  740474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740493 */     GIR_RootConstrainSelectedInstOperands,
     /*  740494 */     // GIR_Coverage, 12193,
     /*  740494 */     GIR_EraseRootFromParent_Done,
     /*  740495 */   // Label 11602: @740495
     /*  740495 */   GIM_Try, /*On fail goto*//*Label 11603*/ GIMT_Encode4(740570), // Rule ID 12196 //
     /*  740500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  740511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  740514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  740517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  740520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  740549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740568 */     GIR_RootConstrainSelectedInstOperands,
     /*  740569 */     // GIR_Coverage, 12196,
     /*  740569 */     GIR_EraseRootFromParent_Done,
     /*  740570 */   // Label 11603: @740570
     /*  740570 */   GIM_Try, /*On fail goto*//*Label 11604*/ GIMT_Encode4(740645), // Rule ID 12197 //
     /*  740575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  740586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  740589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  740592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  740595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740621 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  740624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740643 */     GIR_RootConstrainSelectedInstOperands,
     /*  740644 */     // GIR_Coverage, 12197,
     /*  740644 */     GIR_EraseRootFromParent_Done,
     /*  740645 */   // Label 11604: @740645
     /*  740645 */   GIM_Try, /*On fail goto*//*Label 11605*/ GIMT_Encode4(740720), // Rule ID 12200 //
     /*  740650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  740661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  740664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  740667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  740670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  740699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740718 */     GIR_RootConstrainSelectedInstOperands,
     /*  740719 */     // GIR_Coverage, 12200,
     /*  740719 */     GIR_EraseRootFromParent_Done,
     /*  740720 */   // Label 11605: @740720
     /*  740720 */   GIM_Try, /*On fail goto*//*Label 11606*/ GIMT_Encode4(740795), // Rule ID 12201 //
     /*  740725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  740736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  740739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  740742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  740745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740771 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  740774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740793 */     GIR_RootConstrainSelectedInstOperands,
     /*  740794 */     // GIR_Coverage, 12201,
     /*  740794 */     GIR_EraseRootFromParent_Done,
     /*  740795 */   // Label 11606: @740795
     /*  740795 */   GIM_Try, /*On fail goto*//*Label 11607*/ GIMT_Encode4(740870), // Rule ID 12204 //
     /*  740800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  740811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  740814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  740817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  740820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  740846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  740849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740868 */     GIR_RootConstrainSelectedInstOperands,
     /*  740869 */     // GIR_Coverage, 12204,
     /*  740869 */     GIR_EraseRootFromParent_Done,
     /*  740870 */   // Label 11607: @740870
     /*  740870 */   GIM_Try, /*On fail goto*//*Label 11608*/ GIMT_Encode4(740945), // Rule ID 12205 //
     /*  740875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  740886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  740889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  740892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  740895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740921 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  740921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  740924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740943 */     GIR_RootConstrainSelectedInstOperands,
     /*  740944 */     // GIR_Coverage, 12205,
     /*  740944 */     GIR_EraseRootFromParent_Done,
     /*  740945 */   // Label 11608: @740945
     /*  740945 */   GIM_Try, /*On fail goto*//*Label 11609*/ GIMT_Encode4(741020), // Rule ID 12208 //
     /*  740950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  740961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  740964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  740967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  740970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  740999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741018 */     GIR_RootConstrainSelectedInstOperands,
     /*  741019 */     // GIR_Coverage, 12208,
     /*  741019 */     GIR_EraseRootFromParent_Done,
     /*  741020 */   // Label 11609: @741020
     /*  741020 */   GIM_Try, /*On fail goto*//*Label 11610*/ GIMT_Encode4(741095), // Rule ID 12209 //
     /*  741025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  741036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  741039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  741042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  741045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741071 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  741074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741093 */     GIR_RootConstrainSelectedInstOperands,
     /*  741094 */     // GIR_Coverage, 12209,
     /*  741094 */     GIR_EraseRootFromParent_Done,
     /*  741095 */   // Label 11610: @741095
     /*  741095 */   GIM_Try, /*On fail goto*//*Label 11611*/ GIMT_Encode4(741170), // Rule ID 12212 //
     /*  741100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  741111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  741114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  741117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  741120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  741149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741168 */     GIR_RootConstrainSelectedInstOperands,
     /*  741169 */     // GIR_Coverage, 12212,
     /*  741169 */     GIR_EraseRootFromParent_Done,
     /*  741170 */   // Label 11611: @741170
     /*  741170 */   GIM_Try, /*On fail goto*//*Label 11612*/ GIMT_Encode4(741245), // Rule ID 12213 //
     /*  741175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  741186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  741189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  741192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  741195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741221 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  741224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741243 */     GIR_RootConstrainSelectedInstOperands,
     /*  741244 */     // GIR_Coverage, 12213,
     /*  741244 */     GIR_EraseRootFromParent_Done,
     /*  741245 */   // Label 11612: @741245
     /*  741245 */   GIM_Try, /*On fail goto*//*Label 11613*/ GIMT_Encode4(741320), // Rule ID 12216 //
     /*  741250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  741267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  741270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  741296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  741299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741318 */     GIR_RootConstrainSelectedInstOperands,
     /*  741319 */     // GIR_Coverage, 12216,
     /*  741319 */     GIR_EraseRootFromParent_Done,
     /*  741320 */   // Label 11613: @741320
     /*  741320 */   GIM_Try, /*On fail goto*//*Label 11614*/ GIMT_Encode4(741395), // Rule ID 12217 //
     /*  741325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  741342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  741345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741371 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  741371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  741374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741393 */     GIR_RootConstrainSelectedInstOperands,
     /*  741394 */     // GIR_Coverage, 12217,
     /*  741394 */     GIR_EraseRootFromParent_Done,
     /*  741395 */   // Label 11614: @741395
     /*  741395 */   GIM_Try, /*On fail goto*//*Label 11615*/ GIMT_Encode4(741470), // Rule ID 12220 //
     /*  741400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  741403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  741411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  741414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  741417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  741420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  741446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  741449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  741465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741468 */     GIR_RootConstrainSelectedInstOperands,
     /*  741469 */     // GIR_Coverage, 12220,
     /*  741469 */     GIR_EraseRootFromParent_Done,
     /*  741470 */   // Label 11615: @741470
     /*  741470 */   GIM_Try, /*On fail goto*//*Label 11616*/ GIMT_Encode4(741545), // Rule ID 12221 //
     /*  741475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  741478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  741486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  741489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  741492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  741495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741521 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  741521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  741524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  741540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741543 */     GIR_RootConstrainSelectedInstOperands,
     /*  741544 */     // GIR_Coverage, 12221,
     /*  741544 */     GIR_EraseRootFromParent_Done,
     /*  741545 */   // Label 11616: @741545
     /*  741545 */   GIM_Try, /*On fail goto*//*Label 11617*/ GIMT_Encode4(741620), // Rule ID 12224 //
     /*  741550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  741561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  741564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  741567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  741570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  741599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741618 */     GIR_RootConstrainSelectedInstOperands,
     /*  741619 */     // GIR_Coverage, 12224,
     /*  741619 */     GIR_EraseRootFromParent_Done,
     /*  741620 */   // Label 11617: @741620
     /*  741620 */   GIM_Try, /*On fail goto*//*Label 11618*/ GIMT_Encode4(741695), // Rule ID 12225 //
     /*  741625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  741636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  741639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  741642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  741645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741671 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  741674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741693 */     GIR_RootConstrainSelectedInstOperands,
     /*  741694 */     // GIR_Coverage, 12225,
     /*  741694 */     GIR_EraseRootFromParent_Done,
     /*  741695 */   // Label 11618: @741695
     /*  741695 */   GIM_Try, /*On fail goto*//*Label 11619*/ GIMT_Encode4(741770), // Rule ID 12228 //
     /*  741700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  741711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  741714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  741717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  741720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741746 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  741749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741768 */     GIR_RootConstrainSelectedInstOperands,
     /*  741769 */     // GIR_Coverage, 12228,
     /*  741769 */     GIR_EraseRootFromParent_Done,
     /*  741770 */   // Label 11619: @741770
     /*  741770 */   GIM_Try, /*On fail goto*//*Label 11620*/ GIMT_Encode4(741845), // Rule ID 12229 //
     /*  741775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  741786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  741789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  741792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  741795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741821 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  741824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741843 */     GIR_RootConstrainSelectedInstOperands,
     /*  741844 */     // GIR_Coverage, 12229,
     /*  741844 */     GIR_EraseRootFromParent_Done,
     /*  741845 */   // Label 11620: @741845
     /*  741845 */   GIM_Try, /*On fail goto*//*Label 11621*/ GIMT_Encode4(741920), // Rule ID 12232 //
     /*  741850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  741861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  741864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  741867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  741870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741896 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  741899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741918 */     GIR_RootConstrainSelectedInstOperands,
     /*  741919 */     // GIR_Coverage, 12232,
     /*  741919 */     GIR_EraseRootFromParent_Done,
     /*  741920 */   // Label 11621: @741920
     /*  741920 */   GIM_Try, /*On fail goto*//*Label 11622*/ GIMT_Encode4(741995), // Rule ID 12233 //
     /*  741925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  741936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  741939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  741942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  741945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741971 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  741974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741993 */     GIR_RootConstrainSelectedInstOperands,
     /*  741994 */     // GIR_Coverage, 12233,
     /*  741994 */     GIR_EraseRootFromParent_Done,
     /*  741995 */   // Label 11622: @741995
     /*  741995 */   GIM_Try, /*On fail goto*//*Label 11623*/ GIMT_Encode4(742070), // Rule ID 12236 //
     /*  742000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  742011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  742014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  742017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  742020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742046 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  742046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  742049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742068 */     GIR_RootConstrainSelectedInstOperands,
     /*  742069 */     // GIR_Coverage, 12236,
     /*  742069 */     GIR_EraseRootFromParent_Done,
     /*  742070 */   // Label 11623: @742070
     /*  742070 */   GIM_Try, /*On fail goto*//*Label 11624*/ GIMT_Encode4(742145), // Rule ID 12237 //
     /*  742075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  742086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  742089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  742092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  742095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742121 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  742124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742143 */     GIR_RootConstrainSelectedInstOperands,
     /*  742144 */     // GIR_Coverage, 12237,
     /*  742144 */     GIR_EraseRootFromParent_Done,
     /*  742145 */   // Label 11624: @742145
     /*  742145 */   GIM_Try, /*On fail goto*//*Label 11625*/ GIMT_Encode4(742220), // Rule ID 12240 //
     /*  742150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  742161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  742164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  742167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  742170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742196 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  742196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  742199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742218 */     GIR_RootConstrainSelectedInstOperands,
     /*  742219 */     // GIR_Coverage, 12240,
     /*  742219 */     GIR_EraseRootFromParent_Done,
     /*  742220 */   // Label 11625: @742220
     /*  742220 */   GIM_Try, /*On fail goto*//*Label 11626*/ GIMT_Encode4(742295), // Rule ID 12241 //
     /*  742225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  742236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  742239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  742242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  742245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742271 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  742274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742293 */     GIR_RootConstrainSelectedInstOperands,
     /*  742294 */     // GIR_Coverage, 12241,
     /*  742294 */     GIR_EraseRootFromParent_Done,
     /*  742295 */   // Label 11626: @742295
     /*  742295 */   GIM_Try, /*On fail goto*//*Label 11627*/ GIMT_Encode4(742370), // Rule ID 12244 //
     /*  742300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  742311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  742314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  742317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  742320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742346 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  742346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  742349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742368 */     GIR_RootConstrainSelectedInstOperands,
     /*  742369 */     // GIR_Coverage, 12244,
     /*  742369 */     GIR_EraseRootFromParent_Done,
     /*  742370 */   // Label 11627: @742370
     /*  742370 */   GIM_Try, /*On fail goto*//*Label 11628*/ GIMT_Encode4(742445), // Rule ID 12245 //
     /*  742375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  742386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  742389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  742392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  742395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742421 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  742424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742443 */     GIR_RootConstrainSelectedInstOperands,
     /*  742444 */     // GIR_Coverage, 12245,
     /*  742444 */     GIR_EraseRootFromParent_Done,
     /*  742445 */   // Label 11628: @742445
     /*  742445 */   GIM_Try, /*On fail goto*//*Label 11629*/ GIMT_Encode4(742520), // Rule ID 12248 //
     /*  742450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  742461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  742464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  742467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  742470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  742499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742518 */     GIR_RootConstrainSelectedInstOperands,
     /*  742519 */     // GIR_Coverage, 12248,
     /*  742519 */     GIR_EraseRootFromParent_Done,
     /*  742520 */   // Label 11629: @742520
     /*  742520 */   GIM_Try, /*On fail goto*//*Label 11630*/ GIMT_Encode4(742595), // Rule ID 12249 //
     /*  742525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  742536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  742539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  742542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  742545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  742574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742593 */     GIR_RootConstrainSelectedInstOperands,
     /*  742594 */     // GIR_Coverage, 12249,
     /*  742594 */     GIR_EraseRootFromParent_Done,
     /*  742595 */   // Label 11630: @742595
     /*  742595 */   GIM_Try, /*On fail goto*//*Label 11631*/ GIMT_Encode4(742670), // Rule ID 12252 //
     /*  742600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  742611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  742614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  742617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  742620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742646 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  742649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742668 */     GIR_RootConstrainSelectedInstOperands,
     /*  742669 */     // GIR_Coverage, 12252,
     /*  742669 */     GIR_EraseRootFromParent_Done,
     /*  742670 */   // Label 11631: @742670
     /*  742670 */   GIM_Try, /*On fail goto*//*Label 11632*/ GIMT_Encode4(742745), // Rule ID 12253 //
     /*  742675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  742686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  742689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  742692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  742695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742721 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  742724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742743 */     GIR_RootConstrainSelectedInstOperands,
     /*  742744 */     // GIR_Coverage, 12253,
     /*  742744 */     GIR_EraseRootFromParent_Done,
     /*  742745 */   // Label 11632: @742745
     /*  742745 */   GIM_Try, /*On fail goto*//*Label 11633*/ GIMT_Encode4(742820), // Rule ID 12256 //
     /*  742750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  742761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  742764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  742767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  742770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  742799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742818 */     GIR_RootConstrainSelectedInstOperands,
     /*  742819 */     // GIR_Coverage, 12256,
     /*  742819 */     GIR_EraseRootFromParent_Done,
     /*  742820 */   // Label 11633: @742820
     /*  742820 */   GIM_Try, /*On fail goto*//*Label 11634*/ GIMT_Encode4(742895), // Rule ID 12257 //
     /*  742825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  742836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  742839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  742842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  742845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742871 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  742874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742893 */     GIR_RootConstrainSelectedInstOperands,
     /*  742894 */     // GIR_Coverage, 12257,
     /*  742894 */     GIR_EraseRootFromParent_Done,
     /*  742895 */   // Label 11634: @742895
     /*  742895 */   GIM_Try, /*On fail goto*//*Label 11635*/ GIMT_Encode4(742970), // Rule ID 12260 //
     /*  742900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  742911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  742914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  742917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  742920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  742946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  742949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742968 */     GIR_RootConstrainSelectedInstOperands,
     /*  742969 */     // GIR_Coverage, 12260,
     /*  742969 */     GIR_EraseRootFromParent_Done,
     /*  742970 */   // Label 11635: @742970
     /*  742970 */   GIM_Try, /*On fail goto*//*Label 11636*/ GIMT_Encode4(743045), // Rule ID 12261 //
     /*  742975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  742978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  742986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  742989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  742992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  742995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  743021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  743024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743043 */     GIR_RootConstrainSelectedInstOperands,
     /*  743044 */     // GIR_Coverage, 12261,
     /*  743044 */     GIR_EraseRootFromParent_Done,
     /*  743045 */   // Label 11636: @743045
     /*  743045 */   GIM_Try, /*On fail goto*//*Label 11637*/ GIMT_Encode4(743120), // Rule ID 12264 //
     /*  743050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  743053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  743061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  743064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  743067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  743070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  743096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  743099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743118 */     GIR_RootConstrainSelectedInstOperands,
     /*  743119 */     // GIR_Coverage, 12264,
     /*  743119 */     GIR_EraseRootFromParent_Done,
     /*  743120 */   // Label 11637: @743120
     /*  743120 */   GIM_Try, /*On fail goto*//*Label 11638*/ GIMT_Encode4(743195), // Rule ID 12265 //
     /*  743125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  743128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  743136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  743139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  743142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  743145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743171 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  743171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  743174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743193 */     GIR_RootConstrainSelectedInstOperands,
     /*  743194 */     // GIR_Coverage, 12265,
     /*  743194 */     GIR_EraseRootFromParent_Done,
     /*  743195 */   // Label 11638: @743195
     /*  743195 */   GIM_Try, /*On fail goto*//*Label 11639*/ GIMT_Encode4(743270), // Rule ID 12268 //
     /*  743200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  743203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  743211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  743214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  743217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  743220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743246 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  743246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  743249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743268 */     GIR_RootConstrainSelectedInstOperands,
     /*  743269 */     // GIR_Coverage, 12268,
     /*  743269 */     GIR_EraseRootFromParent_Done,
     /*  743270 */   // Label 11639: @743270
     /*  743270 */   GIM_Try, /*On fail goto*//*Label 11640*/ GIMT_Encode4(743345), // Rule ID 12269 //
     /*  743275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  743278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  743286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  743289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  743292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  743295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743321 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  743321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  743324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743343 */     GIR_RootConstrainSelectedInstOperands,
     /*  743344 */     // GIR_Coverage, 12269,
     /*  743344 */     GIR_EraseRootFromParent_Done,
     /*  743345 */   // Label 11640: @743345
     /*  743345 */   GIM_Try, /*On fail goto*//*Label 11641*/ GIMT_Encode4(743420), // Rule ID 12272 //
     /*  743350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  743361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  743364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  743367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  743370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743396 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  743399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743418 */     GIR_RootConstrainSelectedInstOperands,
     /*  743419 */     // GIR_Coverage, 12272,
     /*  743419 */     GIR_EraseRootFromParent_Done,
     /*  743420 */   // Label 11641: @743420
     /*  743420 */   GIM_Try, /*On fail goto*//*Label 11642*/ GIMT_Encode4(743495), // Rule ID 12273 //
     /*  743425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  743436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  743439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  743442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  743445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743471 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  743474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743493 */     GIR_RootConstrainSelectedInstOperands,
     /*  743494 */     // GIR_Coverage, 12273,
     /*  743494 */     GIR_EraseRootFromParent_Done,
     /*  743495 */   // Label 11642: @743495
     /*  743495 */   GIM_Try, /*On fail goto*//*Label 11643*/ GIMT_Encode4(743570), // Rule ID 12276 //
     /*  743500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  743511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  743514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  743517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  743520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743546 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  743549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743568 */     GIR_RootConstrainSelectedInstOperands,
     /*  743569 */     // GIR_Coverage, 12276,
     /*  743569 */     GIR_EraseRootFromParent_Done,
     /*  743570 */   // Label 11643: @743570
     /*  743570 */   GIM_Try, /*On fail goto*//*Label 11644*/ GIMT_Encode4(743645), // Rule ID 12277 //
     /*  743575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  743586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  743589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  743592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  743595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743621 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  743624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743643 */     GIR_RootConstrainSelectedInstOperands,
     /*  743644 */     // GIR_Coverage, 12277,
     /*  743644 */     GIR_EraseRootFromParent_Done,
     /*  743645 */   // Label 11644: @743645
     /*  743645 */   GIM_Try, /*On fail goto*//*Label 11645*/ GIMT_Encode4(743720), // Rule ID 12280 //
     /*  743650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  743661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  743664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  743667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  743670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743696 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  743699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743718 */     GIR_RootConstrainSelectedInstOperands,
     /*  743719 */     // GIR_Coverage, 12280,
     /*  743719 */     GIR_EraseRootFromParent_Done,
     /*  743720 */   // Label 11645: @743720
     /*  743720 */   GIM_Try, /*On fail goto*//*Label 11646*/ GIMT_Encode4(743795), // Rule ID 12281 //
     /*  743725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  743736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  743739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  743742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  743745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743771 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  743774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743793 */     GIR_RootConstrainSelectedInstOperands,
     /*  743794 */     // GIR_Coverage, 12281,
     /*  743794 */     GIR_EraseRootFromParent_Done,
     /*  743795 */   // Label 11646: @743795
     /*  743795 */   GIM_Try, /*On fail goto*//*Label 11647*/ GIMT_Encode4(743870), // Rule ID 12284 //
     /*  743800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  743811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  743814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  743817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  743820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  743849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743868 */     GIR_RootConstrainSelectedInstOperands,
     /*  743869 */     // GIR_Coverage, 12284,
     /*  743869 */     GIR_EraseRootFromParent_Done,
     /*  743870 */   // Label 11647: @743870
     /*  743870 */   GIM_Try, /*On fail goto*//*Label 11648*/ GIMT_Encode4(743945), // Rule ID 12285 //
     /*  743875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  743886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  743889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  743892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  743895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743921 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  743924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743943 */     GIR_RootConstrainSelectedInstOperands,
     /*  743944 */     // GIR_Coverage, 12285,
     /*  743944 */     GIR_EraseRootFromParent_Done,
     /*  743945 */   // Label 11648: @743945
     /*  743945 */   GIM_Try, /*On fail goto*//*Label 11649*/ GIMT_Encode4(744020), // Rule ID 12288 //
     /*  743950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  743961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  743964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  743967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  743970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743996 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  743999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744018 */     GIR_RootConstrainSelectedInstOperands,
     /*  744019 */     // GIR_Coverage, 12288,
     /*  744019 */     GIR_EraseRootFromParent_Done,
     /*  744020 */   // Label 11649: @744020
     /*  744020 */   GIM_Try, /*On fail goto*//*Label 11650*/ GIMT_Encode4(744095), // Rule ID 12289 //
     /*  744025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  744036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  744039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  744042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744071 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  744074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744093 */     GIR_RootConstrainSelectedInstOperands,
     /*  744094 */     // GIR_Coverage, 12289,
     /*  744094 */     GIR_EraseRootFromParent_Done,
     /*  744095 */   // Label 11650: @744095
     /*  744095 */   GIM_Try, /*On fail goto*//*Label 11651*/ GIMT_Encode4(744170), // Rule ID 12292 //
     /*  744100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  744111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  744114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  744117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  744149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744168 */     GIR_RootConstrainSelectedInstOperands,
     /*  744169 */     // GIR_Coverage, 12292,
     /*  744169 */     GIR_EraseRootFromParent_Done,
     /*  744170 */   // Label 11651: @744170
     /*  744170 */   GIM_Try, /*On fail goto*//*Label 11652*/ GIMT_Encode4(744245), // Rule ID 12293 //
     /*  744175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  744186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  744189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  744192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744221 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  744224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744243 */     GIR_RootConstrainSelectedInstOperands,
     /*  744244 */     // GIR_Coverage, 12293,
     /*  744244 */     GIR_EraseRootFromParent_Done,
     /*  744245 */   // Label 11652: @744245
     /*  744245 */   GIM_Try, /*On fail goto*//*Label 11653*/ GIMT_Encode4(744320), // Rule ID 12296 //
     /*  744250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  744261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  744264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  744267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744296 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  744296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  744299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744318 */     GIR_RootConstrainSelectedInstOperands,
     /*  744319 */     // GIR_Coverage, 12296,
     /*  744319 */     GIR_EraseRootFromParent_Done,
     /*  744320 */   // Label 11653: @744320
     /*  744320 */   GIM_Try, /*On fail goto*//*Label 11654*/ GIMT_Encode4(744395), // Rule ID 12297 //
     /*  744325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  744336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  744339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  744342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744371 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  744371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  744374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744393 */     GIR_RootConstrainSelectedInstOperands,
     /*  744394 */     // GIR_Coverage, 12297,
     /*  744394 */     GIR_EraseRootFromParent_Done,
     /*  744395 */   // Label 11654: @744395
     /*  744395 */   GIM_Try, /*On fail goto*//*Label 11655*/ GIMT_Encode4(744470), // Rule ID 12300 //
     /*  744400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  744411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  744414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  744417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  744449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744468 */     GIR_RootConstrainSelectedInstOperands,
     /*  744469 */     // GIR_Coverage, 12300,
     /*  744469 */     GIR_EraseRootFromParent_Done,
     /*  744470 */   // Label 11655: @744470
     /*  744470 */   GIM_Try, /*On fail goto*//*Label 11656*/ GIMT_Encode4(744545), // Rule ID 12301 //
     /*  744475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  744486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  744489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  744492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744521 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  744524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744543 */     GIR_RootConstrainSelectedInstOperands,
     /*  744544 */     // GIR_Coverage, 12301,
     /*  744544 */     GIR_EraseRootFromParent_Done,
     /*  744545 */   // Label 11656: @744545
     /*  744545 */   GIM_Try, /*On fail goto*//*Label 11657*/ GIMT_Encode4(744620), // Rule ID 12304 //
     /*  744550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  744561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  744564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  744567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  744599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744618 */     GIR_RootConstrainSelectedInstOperands,
     /*  744619 */     // GIR_Coverage, 12304,
     /*  744619 */     GIR_EraseRootFromParent_Done,
     /*  744620 */   // Label 11657: @744620
     /*  744620 */   GIM_Try, /*On fail goto*//*Label 11658*/ GIMT_Encode4(744695), // Rule ID 12305 //
     /*  744625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  744636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  744639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  744642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744671 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  744674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744693 */     GIR_RootConstrainSelectedInstOperands,
     /*  744694 */     // GIR_Coverage, 12305,
     /*  744694 */     GIR_EraseRootFromParent_Done,
     /*  744695 */   // Label 11658: @744695
     /*  744695 */   GIM_Try, /*On fail goto*//*Label 11659*/ GIMT_Encode4(744770), // Rule ID 12308 //
     /*  744700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  744703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  744711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  744714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  744717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744746 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  744746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  744749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  744765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744768 */     GIR_RootConstrainSelectedInstOperands,
     /*  744769 */     // GIR_Coverage, 12308,
     /*  744769 */     GIR_EraseRootFromParent_Done,
     /*  744770 */   // Label 11659: @744770
     /*  744770 */   GIM_Try, /*On fail goto*//*Label 11660*/ GIMT_Encode4(744845), // Rule ID 12309 //
     /*  744775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  744778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  744786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  744789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  744792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744821 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  744821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  744824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  744840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744843 */     GIR_RootConstrainSelectedInstOperands,
     /*  744844 */     // GIR_Coverage, 12309,
     /*  744844 */     GIR_EraseRootFromParent_Done,
     /*  744845 */   // Label 11660: @744845
     /*  744845 */   GIM_Try, /*On fail goto*//*Label 11661*/ GIMT_Encode4(744920), // Rule ID 12312 //
     /*  744850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  744861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  744864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  744867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  744896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  744899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744918 */     GIR_RootConstrainSelectedInstOperands,
     /*  744919 */     // GIR_Coverage, 12312,
     /*  744919 */     GIR_EraseRootFromParent_Done,
     /*  744920 */   // Label 11661: @744920
     /*  744920 */   GIM_Try, /*On fail goto*//*Label 11662*/ GIMT_Encode4(744995), // Rule ID 12313 //
     /*  744925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  744936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  744939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  744942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744971 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  744971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  744974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744993 */     GIR_RootConstrainSelectedInstOperands,
     /*  744994 */     // GIR_Coverage, 12313,
     /*  744994 */     GIR_EraseRootFromParent_Done,
     /*  744995 */   // Label 11662: @744995
     /*  744995 */   GIM_Try, /*On fail goto*//*Label 11663*/ GIMT_Encode4(745070), // Rule ID 12316 //
     /*  745000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  745011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  745014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  745017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745046 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  745049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745068 */     GIR_RootConstrainSelectedInstOperands,
     /*  745069 */     // GIR_Coverage, 12316,
     /*  745069 */     GIR_EraseRootFromParent_Done,
     /*  745070 */   // Label 11663: @745070
     /*  745070 */   GIM_Try, /*On fail goto*//*Label 11664*/ GIMT_Encode4(745145), // Rule ID 12317 //
     /*  745075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  745086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  745089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  745092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745121 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  745124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745143 */     GIR_RootConstrainSelectedInstOperands,
     /*  745144 */     // GIR_Coverage, 12317,
     /*  745144 */     GIR_EraseRootFromParent_Done,
     /*  745145 */   // Label 11664: @745145
     /*  745145 */   GIM_Try, /*On fail goto*//*Label 11665*/ GIMT_Encode4(745220), // Rule ID 12320 //
     /*  745150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  745161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  745164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  745167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745196 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  745199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745218 */     GIR_RootConstrainSelectedInstOperands,
     /*  745219 */     // GIR_Coverage, 12320,
     /*  745219 */     GIR_EraseRootFromParent_Done,
     /*  745220 */   // Label 11665: @745220
     /*  745220 */   GIM_Try, /*On fail goto*//*Label 11666*/ GIMT_Encode4(745295), // Rule ID 12321 //
     /*  745225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  745236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  745239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  745242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745271 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  745274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745293 */     GIR_RootConstrainSelectedInstOperands,
     /*  745294 */     // GIR_Coverage, 12321,
     /*  745294 */     GIR_EraseRootFromParent_Done,
     /*  745295 */   // Label 11666: @745295
     /*  745295 */   GIM_Try, /*On fail goto*//*Label 11667*/ GIMT_Encode4(745370), // Rule ID 12324 //
     /*  745300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  745311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  745314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  745317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  745346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  745349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745368 */     GIR_RootConstrainSelectedInstOperands,
     /*  745369 */     // GIR_Coverage, 12324,
     /*  745369 */     GIR_EraseRootFromParent_Done,
     /*  745370 */   // Label 11667: @745370
     /*  745370 */   GIM_Try, /*On fail goto*//*Label 11668*/ GIMT_Encode4(745445), // Rule ID 12325 //
     /*  745375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  745386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  745389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  745392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  745421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  745424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745443 */     GIR_RootConstrainSelectedInstOperands,
     /*  745444 */     // GIR_Coverage, 12325,
     /*  745444 */     GIR_EraseRootFromParent_Done,
     /*  745445 */   // Label 11668: @745445
     /*  745445 */   GIM_Try, /*On fail goto*//*Label 11669*/ GIMT_Encode4(745520), // Rule ID 12328 //
     /*  745450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  745461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  745464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  745467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  745496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  745499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745518 */     GIR_RootConstrainSelectedInstOperands,
     /*  745519 */     // GIR_Coverage, 12328,
     /*  745519 */     GIR_EraseRootFromParent_Done,
     /*  745520 */   // Label 11669: @745520
     /*  745520 */   GIM_Try, /*On fail goto*//*Label 11670*/ GIMT_Encode4(745595), // Rule ID 12329 //
     /*  745525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  745536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  745539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  745542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745571 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  745571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  745574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745593 */     GIR_RootConstrainSelectedInstOperands,
     /*  745594 */     // GIR_Coverage, 12329,
     /*  745594 */     GIR_EraseRootFromParent_Done,
     /*  745595 */   // Label 11670: @745595
     /*  745595 */   GIM_Try, /*On fail goto*//*Label 11671*/ GIMT_Encode4(745670), // Rule ID 12332 //
     /*  745600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  745611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  745614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  745617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  745646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  745649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745668 */     GIR_RootConstrainSelectedInstOperands,
     /*  745669 */     // GIR_Coverage, 12332,
     /*  745669 */     GIR_EraseRootFromParent_Done,
     /*  745670 */   // Label 11671: @745670
     /*  745670 */   GIM_Try, /*On fail goto*//*Label 11672*/ GIMT_Encode4(745745), // Rule ID 12333 //
     /*  745675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  745686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  745689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  745692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745721 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  745721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  745724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745743 */     GIR_RootConstrainSelectedInstOperands,
     /*  745744 */     // GIR_Coverage, 12333,
     /*  745744 */     GIR_EraseRootFromParent_Done,
     /*  745745 */   // Label 11672: @745745
     /*  745745 */   GIM_Try, /*On fail goto*//*Label 11673*/ GIMT_Encode4(745820), // Rule ID 12336 //
     /*  745750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  745761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  745764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  745767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  745796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  745799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745818 */     GIR_RootConstrainSelectedInstOperands,
     /*  745819 */     // GIR_Coverage, 12336,
     /*  745819 */     GIR_EraseRootFromParent_Done,
     /*  745820 */   // Label 11673: @745820
     /*  745820 */   GIM_Try, /*On fail goto*//*Label 11674*/ GIMT_Encode4(745895), // Rule ID 12337 //
     /*  745825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  745836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  745839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  745842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  745874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745893 */     GIR_RootConstrainSelectedInstOperands,
     /*  745894 */     // GIR_Coverage, 12337,
     /*  745894 */     GIR_EraseRootFromParent_Done,
     /*  745895 */   // Label 11674: @745895
     /*  745895 */   GIM_Try, /*On fail goto*//*Label 11675*/ GIMT_Encode4(745970), // Rule ID 12340 //
     /*  745900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  745911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  745914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  745917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  745946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  745949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745968 */     GIR_RootConstrainSelectedInstOperands,
     /*  745969 */     // GIR_Coverage, 12340,
     /*  745969 */     GIR_EraseRootFromParent_Done,
     /*  745970 */   // Label 11675: @745970
     /*  745970 */   GIM_Try, /*On fail goto*//*Label 11676*/ GIMT_Encode4(746045), // Rule ID 12341 //
     /*  745975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  745986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  745989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  745992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  746024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746043 */     GIR_RootConstrainSelectedInstOperands,
     /*  746044 */     // GIR_Coverage, 12341,
     /*  746044 */     GIR_EraseRootFromParent_Done,
     /*  746045 */   // Label 11676: @746045
     /*  746045 */   GIM_Try, /*On fail goto*//*Label 11677*/ GIMT_Encode4(746120), // Rule ID 12344 //
     /*  746050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  746061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  746064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  746067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746096 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  746096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  746099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746118 */     GIR_RootConstrainSelectedInstOperands,
     /*  746119 */     // GIR_Coverage, 12344,
     /*  746119 */     GIR_EraseRootFromParent_Done,
     /*  746120 */   // Label 11677: @746120
     /*  746120 */   GIM_Try, /*On fail goto*//*Label 11678*/ GIMT_Encode4(746195), // Rule ID 12345 //
     /*  746125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  746136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  746139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  746142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746171 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  746174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746193 */     GIR_RootConstrainSelectedInstOperands,
     /*  746194 */     // GIR_Coverage, 12345,
     /*  746194 */     GIR_EraseRootFromParent_Done,
     /*  746195 */   // Label 11678: @746195
     /*  746195 */   GIM_Try, /*On fail goto*//*Label 11679*/ GIMT_Encode4(746270), // Rule ID 12348 //
     /*  746200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  746203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  746211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  746214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  746217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  746246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  746249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746268 */     GIR_RootConstrainSelectedInstOperands,
     /*  746269 */     // GIR_Coverage, 12348,
     /*  746269 */     GIR_EraseRootFromParent_Done,
     /*  746270 */   // Label 11679: @746270
     /*  746270 */   GIM_Try, /*On fail goto*//*Label 11680*/ GIMT_Encode4(746345), // Rule ID 12349 //
     /*  746275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  746278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  746286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  746289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  746292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  746321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  746324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746343 */     GIR_RootConstrainSelectedInstOperands,
     /*  746344 */     // GIR_Coverage, 12349,
     /*  746344 */     GIR_EraseRootFromParent_Done,
     /*  746345 */   // Label 11680: @746345
     /*  746345 */   GIM_Try, /*On fail goto*//*Label 11681*/ GIMT_Encode4(746420), // Rule ID 12352 //
     /*  746350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  746353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  746361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  746364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  746367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  746396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  746399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746418 */     GIR_RootConstrainSelectedInstOperands,
     /*  746419 */     // GIR_Coverage, 12352,
     /*  746419 */     GIR_EraseRootFromParent_Done,
     /*  746420 */   // Label 11681: @746420
     /*  746420 */   GIM_Try, /*On fail goto*//*Label 11682*/ GIMT_Encode4(746495), // Rule ID 12353 //
     /*  746425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  746428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  746436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  746439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  746442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746471 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  746471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  746474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746493 */     GIR_RootConstrainSelectedInstOperands,
     /*  746494 */     // GIR_Coverage, 12353,
     /*  746494 */     GIR_EraseRootFromParent_Done,
     /*  746495 */   // Label 11682: @746495
     /*  746495 */   GIM_Try, /*On fail goto*//*Label 11683*/ GIMT_Encode4(746570), // Rule ID 12356 //
     /*  746500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  746503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  746511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  746514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  746517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  746546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  746549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746568 */     GIR_RootConstrainSelectedInstOperands,
     /*  746569 */     // GIR_Coverage, 12356,
     /*  746569 */     GIR_EraseRootFromParent_Done,
     /*  746570 */   // Label 11683: @746570
     /*  746570 */   GIM_Try, /*On fail goto*//*Label 11684*/ GIMT_Encode4(746645), // Rule ID 12357 //
     /*  746575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  746578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  746586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  746589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  746592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746621 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  746621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  746624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746643 */     GIR_RootConstrainSelectedInstOperands,
     /*  746644 */     // GIR_Coverage, 12357,
     /*  746644 */     GIR_EraseRootFromParent_Done,
     /*  746645 */   // Label 11684: @746645
     /*  746645 */   GIM_Try, /*On fail goto*//*Label 11685*/ GIMT_Encode4(746720), // Rule ID 12360 //
     /*  746650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  746661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  746664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  746667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  746670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746696 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  746699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746718 */     GIR_RootConstrainSelectedInstOperands,
     /*  746719 */     // GIR_Coverage, 12360,
     /*  746719 */     GIR_EraseRootFromParent_Done,
     /*  746720 */   // Label 11685: @746720
     /*  746720 */   GIM_Try, /*On fail goto*//*Label 11686*/ GIMT_Encode4(746795), // Rule ID 12361 //
     /*  746725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  746736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  746739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  746742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  746745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746771 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  746771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  746774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746793 */     GIR_RootConstrainSelectedInstOperands,
     /*  746794 */     // GIR_Coverage, 12361,
     /*  746794 */     GIR_EraseRootFromParent_Done,
     /*  746795 */   // Label 11686: @746795
     /*  746795 */   GIM_Try, /*On fail goto*//*Label 11687*/ GIMT_Encode4(746870), // Rule ID 12364 //
     /*  746800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  746811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  746814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  746817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  746820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746846 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  746849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746868 */     GIR_RootConstrainSelectedInstOperands,
     /*  746869 */     // GIR_Coverage, 12364,
     /*  746869 */     GIR_EraseRootFromParent_Done,
     /*  746870 */   // Label 11687: @746870
     /*  746870 */   GIM_Try, /*On fail goto*//*Label 11688*/ GIMT_Encode4(746945), // Rule ID 12365 //
     /*  746875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  746886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  746889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  746892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  746895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746921 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  746921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  746924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746943 */     GIR_RootConstrainSelectedInstOperands,
     /*  746944 */     // GIR_Coverage, 12365,
     /*  746944 */     GIR_EraseRootFromParent_Done,
     /*  746945 */   // Label 11688: @746945
     /*  746945 */   GIM_Try, /*On fail goto*//*Label 11689*/ GIMT_Encode4(747020), // Rule ID 12368 //
     /*  746950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  746961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  746964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  746967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  746970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  746999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747018 */     GIR_RootConstrainSelectedInstOperands,
     /*  747019 */     // GIR_Coverage, 12368,
     /*  747019 */     GIR_EraseRootFromParent_Done,
     /*  747020 */   // Label 11689: @747020
     /*  747020 */   GIM_Try, /*On fail goto*//*Label 11690*/ GIMT_Encode4(747095), // Rule ID 12369 //
     /*  747025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  747036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  747039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  747042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  747045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747071 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  747074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747093 */     GIR_RootConstrainSelectedInstOperands,
     /*  747094 */     // GIR_Coverage, 12369,
     /*  747094 */     GIR_EraseRootFromParent_Done,
     /*  747095 */   // Label 11690: @747095
     /*  747095 */   GIM_Try, /*On fail goto*//*Label 11691*/ GIMT_Encode4(747170), // Rule ID 12372 //
     /*  747100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  747111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  747114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  747117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  747120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  747149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747168 */     GIR_RootConstrainSelectedInstOperands,
     /*  747169 */     // GIR_Coverage, 12372,
     /*  747169 */     GIR_EraseRootFromParent_Done,
     /*  747170 */   // Label 11691: @747170
     /*  747170 */   GIM_Try, /*On fail goto*//*Label 11692*/ GIMT_Encode4(747245), // Rule ID 12373 //
     /*  747175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  747186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  747189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  747192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  747195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  747224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747243 */     GIR_RootConstrainSelectedInstOperands,
     /*  747244 */     // GIR_Coverage, 12373,
     /*  747244 */     GIR_EraseRootFromParent_Done,
     /*  747245 */   // Label 11692: @747245
     /*  747245 */   GIM_Try, /*On fail goto*//*Label 11693*/ GIMT_Encode4(747320), // Rule ID 12376 //
     /*  747250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  747261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  747264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  747267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  747270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  747299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747318 */     GIR_RootConstrainSelectedInstOperands,
     /*  747319 */     // GIR_Coverage, 12376,
     /*  747319 */     GIR_EraseRootFromParent_Done,
     /*  747320 */   // Label 11693: @747320
     /*  747320 */   GIM_Try, /*On fail goto*//*Label 11694*/ GIMT_Encode4(747395), // Rule ID 12377 //
     /*  747325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  747336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  747339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  747342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  747345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747371 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  747374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747393 */     GIR_RootConstrainSelectedInstOperands,
     /*  747394 */     // GIR_Coverage, 12377,
     /*  747394 */     GIR_EraseRootFromParent_Done,
     /*  747395 */   // Label 11694: @747395
     /*  747395 */   GIM_Try, /*On fail goto*//*Label 11695*/ GIMT_Encode4(747470), // Rule ID 12380 //
     /*  747400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  747411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  747414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  747417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  747420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  747449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747468 */     GIR_RootConstrainSelectedInstOperands,
     /*  747469 */     // GIR_Coverage, 12380,
     /*  747469 */     GIR_EraseRootFromParent_Done,
     /*  747470 */   // Label 11695: @747470
     /*  747470 */   GIM_Try, /*On fail goto*//*Label 11696*/ GIMT_Encode4(747545), // Rule ID 12381 //
     /*  747475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  747486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  747489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  747492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  747495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  747524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747543 */     GIR_RootConstrainSelectedInstOperands,
     /*  747544 */     // GIR_Coverage, 12381,
     /*  747544 */     GIR_EraseRootFromParent_Done,
     /*  747545 */   // Label 11696: @747545
     /*  747545 */   GIM_Try, /*On fail goto*//*Label 11697*/ GIMT_Encode4(747620), // Rule ID 12384 //
     /*  747550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  747561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  747564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  747567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  747570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747596 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  747596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  747599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747618 */     GIR_RootConstrainSelectedInstOperands,
     /*  747619 */     // GIR_Coverage, 12384,
     /*  747619 */     GIR_EraseRootFromParent_Done,
     /*  747620 */   // Label 11697: @747620
     /*  747620 */   GIM_Try, /*On fail goto*//*Label 11698*/ GIMT_Encode4(747695), // Rule ID 12385 //
     /*  747625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  747636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  747639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  747642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  747645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747671 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  747671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  747674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747693 */     GIR_RootConstrainSelectedInstOperands,
     /*  747694 */     // GIR_Coverage, 12385,
     /*  747694 */     GIR_EraseRootFromParent_Done,
     /*  747695 */   // Label 11698: @747695
     /*  747695 */   GIM_Try, /*On fail goto*//*Label 11699*/ GIMT_Encode4(747770), // Rule ID 12388 //
     /*  747700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  747711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  747714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  747717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  747720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747746 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  747746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  747749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747768 */     GIR_RootConstrainSelectedInstOperands,
     /*  747769 */     // GIR_Coverage, 12388,
     /*  747769 */     GIR_EraseRootFromParent_Done,
     /*  747770 */   // Label 11699: @747770
     /*  747770 */   GIM_Try, /*On fail goto*//*Label 11700*/ GIMT_Encode4(747845), // Rule ID 12389 //
     /*  747775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  747786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  747789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  747792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  747795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747821 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  747821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  747824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747843 */     GIR_RootConstrainSelectedInstOperands,
     /*  747844 */     // GIR_Coverage, 12389,
     /*  747844 */     GIR_EraseRootFromParent_Done,
     /*  747845 */   // Label 11700: @747845
     /*  747845 */   GIM_Try, /*On fail goto*//*Label 11701*/ GIMT_Encode4(747920), // Rule ID 12392 //
     /*  747850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  747861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  747864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  747867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  747870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  747896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  747899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747918 */     GIR_RootConstrainSelectedInstOperands,
     /*  747919 */     // GIR_Coverage, 12392,
     /*  747919 */     GIR_EraseRootFromParent_Done,
     /*  747920 */   // Label 11701: @747920
     /*  747920 */   GIM_Try, /*On fail goto*//*Label 11702*/ GIMT_Encode4(747995), // Rule ID 12393 //
     /*  747925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  747936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  747939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  747942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  747945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  747971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  747974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747993 */     GIR_RootConstrainSelectedInstOperands,
     /*  747994 */     // GIR_Coverage, 12393,
     /*  747994 */     GIR_EraseRootFromParent_Done,
     /*  747995 */   // Label 11702: @747995
     /*  747995 */   GIM_Try, /*On fail goto*//*Label 11703*/ GIMT_Encode4(748070), // Rule ID 12396 //
     /*  748000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  748011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  748014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  748017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  748020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  748049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748068 */     GIR_RootConstrainSelectedInstOperands,
     /*  748069 */     // GIR_Coverage, 12396,
     /*  748069 */     GIR_EraseRootFromParent_Done,
     /*  748070 */   // Label 11703: @748070
     /*  748070 */   GIM_Try, /*On fail goto*//*Label 11704*/ GIMT_Encode4(748145), // Rule ID 12397 //
     /*  748075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  748086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  748089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  748092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  748095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  748124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748143 */     GIR_RootConstrainSelectedInstOperands,
     /*  748144 */     // GIR_Coverage, 12397,
     /*  748144 */     GIR_EraseRootFromParent_Done,
     /*  748145 */   // Label 11704: @748145
     /*  748145 */   GIM_Try, /*On fail goto*//*Label 11705*/ GIMT_Encode4(748220), // Rule ID 12400 //
     /*  748150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  748161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  748164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  748167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  748170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  748199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748218 */     GIR_RootConstrainSelectedInstOperands,
     /*  748219 */     // GIR_Coverage, 12400,
     /*  748219 */     GIR_EraseRootFromParent_Done,
     /*  748220 */   // Label 11705: @748220
     /*  748220 */   GIM_Try, /*On fail goto*//*Label 11706*/ GIMT_Encode4(748295), // Rule ID 12401 //
     /*  748225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  748236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  748239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  748242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  748245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748271 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  748274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748293 */     GIR_RootConstrainSelectedInstOperands,
     /*  748294 */     // GIR_Coverage, 12401,
     /*  748294 */     GIR_EraseRootFromParent_Done,
     /*  748295 */   // Label 11706: @748295
     /*  748295 */   GIM_Try, /*On fail goto*//*Label 11707*/ GIMT_Encode4(748370), // Rule ID 12404 //
     /*  748300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  748311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  748314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  748317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  748320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748346 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  748346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  748349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748368 */     GIR_RootConstrainSelectedInstOperands,
     /*  748369 */     // GIR_Coverage, 12404,
     /*  748369 */     GIR_EraseRootFromParent_Done,
     /*  748370 */   // Label 11707: @748370
     /*  748370 */   GIM_Try, /*On fail goto*//*Label 11708*/ GIMT_Encode4(748445), // Rule ID 12405 //
     /*  748375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  748378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  748386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  748389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  748392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  748395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748421 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  748421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  748424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748443 */     GIR_RootConstrainSelectedInstOperands,
     /*  748444 */     // GIR_Coverage, 12405,
     /*  748444 */     GIR_EraseRootFromParent_Done,
     /*  748445 */   // Label 11708: @748445
     /*  748445 */   GIM_Try, /*On fail goto*//*Label 11709*/ GIMT_Encode4(748520), // Rule ID 12408 //
     /*  748450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  748461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  748464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  748467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  748470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  748496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  748499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748518 */     GIR_RootConstrainSelectedInstOperands,
     /*  748519 */     // GIR_Coverage, 12408,
     /*  748519 */     GIR_EraseRootFromParent_Done,
     /*  748520 */   // Label 11709: @748520
     /*  748520 */   GIM_Try, /*On fail goto*//*Label 11710*/ GIMT_Encode4(748595), // Rule ID 12409 //
     /*  748525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  748528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  748536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  748539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  748542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  748545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748571 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  748571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  748574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748593 */     GIR_RootConstrainSelectedInstOperands,
     /*  748594 */     // GIR_Coverage, 12409,
     /*  748594 */     GIR_EraseRootFromParent_Done,
     /*  748595 */   // Label 11710: @748595
     /*  748595 */   GIM_Try, /*On fail goto*//*Label 11711*/ GIMT_Encode4(748670), // Rule ID 12412 //
     /*  748600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  748611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  748614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  748617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  748620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748646 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  748646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  748649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748668 */     GIR_RootConstrainSelectedInstOperands,
     /*  748669 */     // GIR_Coverage, 12412,
     /*  748669 */     GIR_EraseRootFromParent_Done,
     /*  748670 */   // Label 11711: @748670
     /*  748670 */   GIM_Try, /*On fail goto*//*Label 11712*/ GIMT_Encode4(748745), // Rule ID 12413 //
     /*  748675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  748678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  748686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  748689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  748692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  748695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748721 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  748721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  748724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748743 */     GIR_RootConstrainSelectedInstOperands,
     /*  748744 */     // GIR_Coverage, 12413,
     /*  748744 */     GIR_EraseRootFromParent_Done,
     /*  748745 */   // Label 11712: @748745
     /*  748745 */   GIM_Try, /*On fail goto*//*Label 11713*/ GIMT_Encode4(748820), // Rule ID 12416 //
     /*  748750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  748761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  748764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  748767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  748770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748796 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  748796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  748799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748818 */     GIR_RootConstrainSelectedInstOperands,
     /*  748819 */     // GIR_Coverage, 12416,
     /*  748819 */     GIR_EraseRootFromParent_Done,
     /*  748820 */   // Label 11713: @748820
     /*  748820 */   GIM_Try, /*On fail goto*//*Label 11714*/ GIMT_Encode4(748895), // Rule ID 12417 //
     /*  748825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  748828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  748836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  748839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  748842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  748845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748871 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  748871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  748874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748893 */     GIR_RootConstrainSelectedInstOperands,
     /*  748894 */     // GIR_Coverage, 12417,
     /*  748894 */     GIR_EraseRootFromParent_Done,
     /*  748895 */   // Label 11714: @748895
     /*  748895 */   GIM_Try, /*On fail goto*//*Label 11715*/ GIMT_Encode4(748970), // Rule ID 12420 //
     /*  748900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  748911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  748914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  748917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  748920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  748939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  748946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  748949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748968 */     GIR_RootConstrainSelectedInstOperands,
     /*  748969 */     // GIR_Coverage, 12420,
     /*  748969 */     GIR_EraseRootFromParent_Done,
     /*  748970 */   // Label 11715: @748970
     /*  748970 */   GIM_Try, /*On fail goto*//*Label 11716*/ GIMT_Encode4(749045), // Rule ID 12421 //
     /*  748975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  748986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  748989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  748992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  748995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749021 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  749024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749043 */     GIR_RootConstrainSelectedInstOperands,
     /*  749044 */     // GIR_Coverage, 12421,
     /*  749044 */     GIR_EraseRootFromParent_Done,
     /*  749045 */   // Label 11716: @749045
     /*  749045 */   GIM_Try, /*On fail goto*//*Label 11717*/ GIMT_Encode4(749120), // Rule ID 12424 //
     /*  749050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  749061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  749064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  749067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  749099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749118 */     GIR_RootConstrainSelectedInstOperands,
     /*  749119 */     // GIR_Coverage, 12424,
     /*  749119 */     GIR_EraseRootFromParent_Done,
     /*  749120 */   // Label 11717: @749120
     /*  749120 */   GIM_Try, /*On fail goto*//*Label 11718*/ GIMT_Encode4(749195), // Rule ID 12425 //
     /*  749125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  749136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  749139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  749142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  749174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749193 */     GIR_RootConstrainSelectedInstOperands,
     /*  749194 */     // GIR_Coverage, 12425,
     /*  749194 */     GIR_EraseRootFromParent_Done,
     /*  749195 */   // Label 11718: @749195
     /*  749195 */   GIM_Try, /*On fail goto*//*Label 11719*/ GIMT_Encode4(749270), // Rule ID 12428 //
     /*  749200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  749211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  749214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  749217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  749249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749268 */     GIR_RootConstrainSelectedInstOperands,
     /*  749269 */     // GIR_Coverage, 12428,
     /*  749269 */     GIR_EraseRootFromParent_Done,
     /*  749270 */   // Label 11719: @749270
     /*  749270 */   GIM_Try, /*On fail goto*//*Label 11720*/ GIMT_Encode4(749345), // Rule ID 12429 //
     /*  749275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  749286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  749289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  749292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11632:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  749324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749343 */     GIR_RootConstrainSelectedInstOperands,
     /*  749344 */     // GIR_Coverage, 12429,
     /*  749344 */     GIR_EraseRootFromParent_Done,
     /*  749345 */   // Label 11720: @749345
     /*  749345 */   GIM_Try, /*On fail goto*//*Label 11721*/ GIMT_Encode4(749420), // Rule ID 12432 //
     /*  749350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  749361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  749364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  749367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  749399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749418 */     GIR_RootConstrainSelectedInstOperands,
     /*  749419 */     // GIR_Coverage, 12432,
     /*  749419 */     GIR_EraseRootFromParent_Done,
     /*  749420 */   // Label 11721: @749420
     /*  749420 */   GIM_Try, /*On fail goto*//*Label 11722*/ GIMT_Encode4(749495), // Rule ID 12433 //
     /*  749425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  749436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  749439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  749442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  749474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749493 */     GIR_RootConstrainSelectedInstOperands,
     /*  749494 */     // GIR_Coverage, 12433,
     /*  749494 */     GIR_EraseRootFromParent_Done,
     /*  749495 */   // Label 11722: @749495
     /*  749495 */   GIM_Try, /*On fail goto*//*Label 11723*/ GIMT_Encode4(749570), // Rule ID 12436 //
     /*  749500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  749511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  749514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  749517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  749549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749568 */     GIR_RootConstrainSelectedInstOperands,
     /*  749569 */     // GIR_Coverage, 12436,
     /*  749569 */     GIR_EraseRootFromParent_Done,
     /*  749570 */   // Label 11723: @749570
     /*  749570 */   GIM_Try, /*On fail goto*//*Label 11724*/ GIMT_Encode4(749645), // Rule ID 12437 //
     /*  749575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  749586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  749589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  749592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749621 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  749624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749643 */     GIR_RootConstrainSelectedInstOperands,
     /*  749644 */     // GIR_Coverage, 12437,
     /*  749644 */     GIR_EraseRootFromParent_Done,
     /*  749645 */   // Label 11724: @749645
     /*  749645 */   GIM_Try, /*On fail goto*//*Label 11725*/ GIMT_Encode4(749720), // Rule ID 12440 //
     /*  749650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  749661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  749664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  749667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749696 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  749699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749718 */     GIR_RootConstrainSelectedInstOperands,
     /*  749719 */     // GIR_Coverage, 12440,
     /*  749719 */     GIR_EraseRootFromParent_Done,
     /*  749720 */   // Label 11725: @749720
     /*  749720 */   GIM_Try, /*On fail goto*//*Label 11726*/ GIMT_Encode4(749795), // Rule ID 12441 //
     /*  749725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  749736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  749739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  749742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749771 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  749774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749793 */     GIR_RootConstrainSelectedInstOperands,
     /*  749794 */     // GIR_Coverage, 12441,
     /*  749794 */     GIR_EraseRootFromParent_Done,
     /*  749795 */   // Label 11726: @749795
     /*  749795 */   GIM_Try, /*On fail goto*//*Label 11727*/ GIMT_Encode4(749870), // Rule ID 12444 //
     /*  749800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  749811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  749814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  749817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  749846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  749849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749868 */     GIR_RootConstrainSelectedInstOperands,
     /*  749869 */     // GIR_Coverage, 12444,
     /*  749869 */     GIR_EraseRootFromParent_Done,
     /*  749870 */   // Label 11727: @749870
     /*  749870 */   GIM_Try, /*On fail goto*//*Label 11728*/ GIMT_Encode4(749945), // Rule ID 12445 //
     /*  749875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  749886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  749889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  749892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749921 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  749921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  749924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749943 */     GIR_RootConstrainSelectedInstOperands,
     /*  749944 */     // GIR_Coverage, 12445,
     /*  749944 */     GIR_EraseRootFromParent_Done,
     /*  749945 */   // Label 11728: @749945
     /*  749945 */   GIM_Try, /*On fail goto*//*Label 11729*/ GIMT_Encode4(750020), // Rule ID 12448 //
     /*  749950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  749961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  749964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  749967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  749996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  749999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750018 */     GIR_RootConstrainSelectedInstOperands,
     /*  750019 */     // GIR_Coverage, 12448,
     /*  750019 */     GIR_EraseRootFromParent_Done,
     /*  750020 */   // Label 11729: @750020
     /*  750020 */   GIM_Try, /*On fail goto*//*Label 11730*/ GIMT_Encode4(750095), // Rule ID 12449 //
     /*  750025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  750036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  750039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  750042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11632:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  750074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750093 */     GIR_RootConstrainSelectedInstOperands,
     /*  750094 */     // GIR_Coverage, 12449,
     /*  750094 */     GIR_EraseRootFromParent_Done,
     /*  750095 */   // Label 11730: @750095
     /*  750095 */   GIM_Try, /*On fail goto*//*Label 11731*/ GIMT_Encode4(750170), // Rule ID 12452 //
     /*  750100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  750111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  750114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  750117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  750149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750168 */     GIR_RootConstrainSelectedInstOperands,
     /*  750169 */     // GIR_Coverage, 12452,
     /*  750169 */     GIR_EraseRootFromParent_Done,
     /*  750170 */   // Label 11731: @750170
     /*  750170 */   GIM_Try, /*On fail goto*//*Label 11732*/ GIMT_Encode4(750245), // Rule ID 12453 //
     /*  750175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  750186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  750189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  750192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750221 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  750224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750243 */     GIR_RootConstrainSelectedInstOperands,
     /*  750244 */     // GIR_Coverage, 12453,
     /*  750244 */     GIR_EraseRootFromParent_Done,
     /*  750245 */   // Label 11732: @750245
     /*  750245 */   GIM_Try, /*On fail goto*//*Label 11733*/ GIMT_Encode4(750320), // Rule ID 12456 //
     /*  750250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  750261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  750264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  750267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750296 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  750299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750318 */     GIR_RootConstrainSelectedInstOperands,
     /*  750319 */     // GIR_Coverage, 12456,
     /*  750319 */     GIR_EraseRootFromParent_Done,
     /*  750320 */   // Label 11733: @750320
     /*  750320 */   GIM_Try, /*On fail goto*//*Label 11734*/ GIMT_Encode4(750395), // Rule ID 12457 //
     /*  750325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  750336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  750339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  750342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750371 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  750374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750393 */     GIR_RootConstrainSelectedInstOperands,
     /*  750394 */     // GIR_Coverage, 12457,
     /*  750394 */     GIR_EraseRootFromParent_Done,
     /*  750395 */   // Label 11734: @750395
     /*  750395 */   GIM_Try, /*On fail goto*//*Label 11735*/ GIMT_Encode4(750470), // Rule ID 12460 //
     /*  750400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  750411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  750414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  750417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  750449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750468 */     GIR_RootConstrainSelectedInstOperands,
     /*  750469 */     // GIR_Coverage, 12460,
     /*  750469 */     GIR_EraseRootFromParent_Done,
     /*  750470 */   // Label 11735: @750470
     /*  750470 */   GIM_Try, /*On fail goto*//*Label 11736*/ GIMT_Encode4(750545), // Rule ID 12461 //
     /*  750475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  750486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  750489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  750492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750521 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  750524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750543 */     GIR_RootConstrainSelectedInstOperands,
     /*  750544 */     // GIR_Coverage, 12461,
     /*  750544 */     GIR_EraseRootFromParent_Done,
     /*  750545 */   // Label 11736: @750545
     /*  750545 */   GIM_Try, /*On fail goto*//*Label 11737*/ GIMT_Encode4(750620), // Rule ID 12464 //
     /*  750550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  750553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  750561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  750564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  750567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750596 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  750596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  750599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750618 */     GIR_RootConstrainSelectedInstOperands,
     /*  750619 */     // GIR_Coverage, 12464,
     /*  750619 */     GIR_EraseRootFromParent_Done,
     /*  750620 */   // Label 11737: @750620
     /*  750620 */   GIM_Try, /*On fail goto*//*Label 11738*/ GIMT_Encode4(750695), // Rule ID 12465 //
     /*  750625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  750628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  750636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  750639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  750642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750671 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11632:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  750671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  750674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750693 */     GIR_RootConstrainSelectedInstOperands,
     /*  750694 */     // GIR_Coverage, 12465,
     /*  750694 */     GIR_EraseRootFromParent_Done,
     /*  750695 */   // Label 11738: @750695
     /*  750695 */   GIM_Try, /*On fail goto*//*Label 11739*/ GIMT_Encode4(750770), // Rule ID 12468 //
     /*  750700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  750703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  750711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  750714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  750717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  750746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  750749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750768 */     GIR_RootConstrainSelectedInstOperands,
     /*  750769 */     // GIR_Coverage, 12468,
     /*  750769 */     GIR_EraseRootFromParent_Done,
     /*  750770 */   // Label 11739: @750770
     /*  750770 */   GIM_Try, /*On fail goto*//*Label 11740*/ GIMT_Encode4(750845), // Rule ID 12469 //
     /*  750775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  750778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  750786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  750789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  750792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11632:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  750821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  750824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750843 */     GIR_RootConstrainSelectedInstOperands,
     /*  750844 */     // GIR_Coverage, 12469,
     /*  750844 */     GIR_EraseRootFromParent_Done,
     /*  750845 */   // Label 11740: @750845
     /*  750845 */   GIM_Try, /*On fail goto*//*Label 11741*/ GIMT_Encode4(750920), // Rule ID 12472 //
     /*  750850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  750853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  750861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  750864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  750867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  750896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  750899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750918 */     GIR_RootConstrainSelectedInstOperands,
     /*  750919 */     // GIR_Coverage, 12472,
     /*  750919 */     GIR_EraseRootFromParent_Done,
     /*  750920 */   // Label 11741: @750920
     /*  750920 */   GIM_Try, /*On fail goto*//*Label 11742*/ GIMT_Encode4(750995), // Rule ID 12473 //
     /*  750925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  750928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  750936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  750939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  750942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11632:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  750971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  750974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750993 */     GIR_RootConstrainSelectedInstOperands,
     /*  750994 */     // GIR_Coverage, 12473,
     /*  750994 */     GIR_EraseRootFromParent_Done,
     /*  750995 */   // Label 11742: @750995
     /*  750995 */   GIM_Try, /*On fail goto*//*Label 11743*/ GIMT_Encode4(751070), // Rule ID 12476 //
     /*  751000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  751008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  751011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  751014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  751017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  751049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751068 */     GIR_RootConstrainSelectedInstOperands,
     /*  751069 */     // GIR_Coverage, 12476,
     /*  751069 */     GIR_EraseRootFromParent_Done,
     /*  751070 */   // Label 11743: @751070
     /*  751070 */   GIM_Try, /*On fail goto*//*Label 11744*/ GIMT_Encode4(751145), // Rule ID 12477 //
     /*  751075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  751083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  751086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  751089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  751092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751121 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11632:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  751124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751143 */     GIR_RootConstrainSelectedInstOperands,
     /*  751144 */     // GIR_Coverage, 12477,
     /*  751144 */     GIR_EraseRootFromParent_Done,
     /*  751145 */   // Label 11744: @751145
     /*  751145 */   GIM_Try, /*On fail goto*//*Label 11745*/ GIMT_Encode4(751220), // Rule ID 12480 //
     /*  751150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  751161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  751164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  751167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  751170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751196 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  751199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751218 */     GIR_RootConstrainSelectedInstOperands,
     /*  751219 */     // GIR_Coverage, 12480,
     /*  751219 */     GIR_EraseRootFromParent_Done,
     /*  751220 */   // Label 11745: @751220
     /*  751220 */   GIM_Try, /*On fail goto*//*Label 11746*/ GIMT_Encode4(751295), // Rule ID 12481 //
     /*  751225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  751236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  751239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  751242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  751245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751271 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  751274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751293 */     GIR_RootConstrainSelectedInstOperands,
     /*  751294 */     // GIR_Coverage, 12481,
     /*  751294 */     GIR_EraseRootFromParent_Done,
     /*  751295 */   // Label 11746: @751295
     /*  751295 */   GIM_Try, /*On fail goto*//*Label 11747*/ GIMT_Encode4(751370), // Rule ID 12484 //
     /*  751300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  751311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  751314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  751317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  751320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751346 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  751349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751368 */     GIR_RootConstrainSelectedInstOperands,
     /*  751369 */     // GIR_Coverage, 12484,
     /*  751369 */     GIR_EraseRootFromParent_Done,
     /*  751370 */   // Label 11747: @751370
     /*  751370 */   GIM_Try, /*On fail goto*//*Label 11748*/ GIMT_Encode4(751445), // Rule ID 12485 //
     /*  751375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  751386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  751389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  751392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  751395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751421 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  751424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751443 */     GIR_RootConstrainSelectedInstOperands,
     /*  751444 */     // GIR_Coverage, 12485,
     /*  751444 */     GIR_EraseRootFromParent_Done,
     /*  751445 */   // Label 11748: @751445
     /*  751445 */   GIM_Try, /*On fail goto*//*Label 11749*/ GIMT_Encode4(751520), // Rule ID 12488 //
     /*  751450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  751461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  751464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  751467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  751470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751496 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  751499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751518 */     GIR_RootConstrainSelectedInstOperands,
     /*  751519 */     // GIR_Coverage, 12488,
     /*  751519 */     GIR_EraseRootFromParent_Done,
     /*  751520 */   // Label 11749: @751520
     /*  751520 */   GIM_Try, /*On fail goto*//*Label 11750*/ GIMT_Encode4(751595), // Rule ID 12489 //
     /*  751525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  751536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  751539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  751542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  751545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751571 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  751574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751593 */     GIR_RootConstrainSelectedInstOperands,
     /*  751594 */     // GIR_Coverage, 12489,
     /*  751594 */     GIR_EraseRootFromParent_Done,
     /*  751595 */   // Label 11750: @751595
     /*  751595 */   GIM_Try, /*On fail goto*//*Label 11751*/ GIMT_Encode4(751670), // Rule ID 12492 //
     /*  751600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  751611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  751614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  751617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  751620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  751649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751668 */     GIR_RootConstrainSelectedInstOperands,
     /*  751669 */     // GIR_Coverage, 12492,
     /*  751669 */     GIR_EraseRootFromParent_Done,
     /*  751670 */   // Label 11751: @751670
     /*  751670 */   GIM_Try, /*On fail goto*//*Label 11752*/ GIMT_Encode4(751745), // Rule ID 12493 //
     /*  751675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  751686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  751689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  751692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  751695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751721 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  751724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751743 */     GIR_RootConstrainSelectedInstOperands,
     /*  751744 */     // GIR_Coverage, 12493,
     /*  751744 */     GIR_EraseRootFromParent_Done,
     /*  751745 */   // Label 11752: @751745
     /*  751745 */   GIM_Try, /*On fail goto*//*Label 11753*/ GIMT_Encode4(751820), // Rule ID 12496 //
     /*  751750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  751761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  751764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  751767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  751770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751796 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  751799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751818 */     GIR_RootConstrainSelectedInstOperands,
     /*  751819 */     // GIR_Coverage, 12496,
     /*  751819 */     GIR_EraseRootFromParent_Done,
     /*  751820 */   // Label 11753: @751820
     /*  751820 */   GIM_Try, /*On fail goto*//*Label 11754*/ GIMT_Encode4(751895), // Rule ID 12497 //
     /*  751825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  751836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  751839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  751842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  751845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751871 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  751874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751893 */     GIR_RootConstrainSelectedInstOperands,
     /*  751894 */     // GIR_Coverage, 12497,
     /*  751894 */     GIR_EraseRootFromParent_Done,
     /*  751895 */   // Label 11754: @751895
     /*  751895 */   GIM_Try, /*On fail goto*//*Label 11755*/ GIMT_Encode4(751970), // Rule ID 12500 //
     /*  751900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  751911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  751914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  751917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  751920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751946 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  751949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751968 */     GIR_RootConstrainSelectedInstOperands,
     /*  751969 */     // GIR_Coverage, 12500,
     /*  751969 */     GIR_EraseRootFromParent_Done,
     /*  751970 */   // Label 11755: @751970
     /*  751970 */   GIM_Try, /*On fail goto*//*Label 11756*/ GIMT_Encode4(752045), // Rule ID 12501 //
     /*  751975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  751986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  751989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  751992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  751995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752021 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  752024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752043 */     GIR_RootConstrainSelectedInstOperands,
     /*  752044 */     // GIR_Coverage, 12501,
     /*  752044 */     GIR_EraseRootFromParent_Done,
     /*  752045 */   // Label 11756: @752045
     /*  752045 */   GIM_Try, /*On fail goto*//*Label 11757*/ GIMT_Encode4(752120), // Rule ID 12504 //
     /*  752050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  752061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  752064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  752067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  752070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752096 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  752099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752118 */     GIR_RootConstrainSelectedInstOperands,
     /*  752119 */     // GIR_Coverage, 12504,
     /*  752119 */     GIR_EraseRootFromParent_Done,
     /*  752120 */   // Label 11757: @752120
     /*  752120 */   GIM_Try, /*On fail goto*//*Label 11758*/ GIMT_Encode4(752195), // Rule ID 12505 //
     /*  752125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  752136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  752139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  752142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  752145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752171 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  752174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752193 */     GIR_RootConstrainSelectedInstOperands,
     /*  752194 */     // GIR_Coverage, 12505,
     /*  752194 */     GIR_EraseRootFromParent_Done,
     /*  752195 */   // Label 11758: @752195
     /*  752195 */   GIM_Try, /*On fail goto*//*Label 11759*/ GIMT_Encode4(752270), // Rule ID 12508 //
     /*  752200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  752211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  752214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  752217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  752220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752246 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  752249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752268 */     GIR_RootConstrainSelectedInstOperands,
     /*  752269 */     // GIR_Coverage, 12508,
     /*  752269 */     GIR_EraseRootFromParent_Done,
     /*  752270 */   // Label 11759: @752270
     /*  752270 */   GIM_Try, /*On fail goto*//*Label 11760*/ GIMT_Encode4(752345), // Rule ID 12509 //
     /*  752275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  752286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  752289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  752292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  752295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752321 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  752324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752343 */     GIR_RootConstrainSelectedInstOperands,
     /*  752344 */     // GIR_Coverage, 12509,
     /*  752344 */     GIR_EraseRootFromParent_Done,
     /*  752345 */   // Label 11760: @752345
     /*  752345 */   GIM_Try, /*On fail goto*//*Label 11761*/ GIMT_Encode4(752420), // Rule ID 12512 //
     /*  752350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  752361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  752364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  752367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  752370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  752399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752418 */     GIR_RootConstrainSelectedInstOperands,
     /*  752419 */     // GIR_Coverage, 12512,
     /*  752419 */     GIR_EraseRootFromParent_Done,
     /*  752420 */   // Label 11761: @752420
     /*  752420 */   GIM_Try, /*On fail goto*//*Label 11762*/ GIMT_Encode4(752495), // Rule ID 12513 //
     /*  752425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  752436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  752439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  752442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  752445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  752474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752493 */     GIR_RootConstrainSelectedInstOperands,
     /*  752494 */     // GIR_Coverage, 12513,
     /*  752494 */     GIR_EraseRootFromParent_Done,
     /*  752495 */   // Label 11762: @752495
     /*  752495 */   GIM_Try, /*On fail goto*//*Label 11763*/ GIMT_Encode4(752570), // Rule ID 12516 //
     /*  752500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  752511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  752514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  752517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  752520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  752549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752568 */     GIR_RootConstrainSelectedInstOperands,
     /*  752569 */     // GIR_Coverage, 12516,
     /*  752569 */     GIR_EraseRootFromParent_Done,
     /*  752570 */   // Label 11763: @752570
     /*  752570 */   GIM_Try, /*On fail goto*//*Label 11764*/ GIMT_Encode4(752645), // Rule ID 12517 //
     /*  752575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  752586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  752589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  752592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  752595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752621 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  752624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752643 */     GIR_RootConstrainSelectedInstOperands,
     /*  752644 */     // GIR_Coverage, 12517,
     /*  752644 */     GIR_EraseRootFromParent_Done,
     /*  752645 */   // Label 11764: @752645
     /*  752645 */   GIM_Try, /*On fail goto*//*Label 11765*/ GIMT_Encode4(752720), // Rule ID 12520 //
     /*  752650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  752661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  752664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  752667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  752670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752696 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  752699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752718 */     GIR_RootConstrainSelectedInstOperands,
     /*  752719 */     // GIR_Coverage, 12520,
     /*  752719 */     GIR_EraseRootFromParent_Done,
     /*  752720 */   // Label 11765: @752720
     /*  752720 */   GIM_Try, /*On fail goto*//*Label 11766*/ GIMT_Encode4(752795), // Rule ID 12521 //
     /*  752725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  752736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  752739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  752742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  752745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752771 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  752774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752793 */     GIR_RootConstrainSelectedInstOperands,
     /*  752794 */     // GIR_Coverage, 12521,
     /*  752794 */     GIR_EraseRootFromParent_Done,
     /*  752795 */   // Label 11766: @752795
     /*  752795 */   GIM_Try, /*On fail goto*//*Label 11767*/ GIMT_Encode4(752870), // Rule ID 12524 //
     /*  752800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  752803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  752811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  752814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  752817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  752820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752846 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  752846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  752849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752868 */     GIR_RootConstrainSelectedInstOperands,
     /*  752869 */     // GIR_Coverage, 12524,
     /*  752869 */     GIR_EraseRootFromParent_Done,
     /*  752870 */   // Label 11767: @752870
     /*  752870 */   GIM_Try, /*On fail goto*//*Label 11768*/ GIMT_Encode4(752945), // Rule ID 12525 //
     /*  752875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  752878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  752886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  752889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  752892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  752895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752921 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  752921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  752924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752943 */     GIR_RootConstrainSelectedInstOperands,
     /*  752944 */     // GIR_Coverage, 12525,
     /*  752944 */     GIR_EraseRootFromParent_Done,
     /*  752945 */   // Label 11768: @752945
     /*  752945 */   GIM_Try, /*On fail goto*//*Label 11769*/ GIMT_Encode4(753020), // Rule ID 12528 //
     /*  752950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  752953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  752961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  752964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  752967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  752970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752996 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  752996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  752999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753018 */     GIR_RootConstrainSelectedInstOperands,
     /*  753019 */     // GIR_Coverage, 12528,
     /*  753019 */     GIR_EraseRootFromParent_Done,
     /*  753020 */   // Label 11769: @753020
     /*  753020 */   GIM_Try, /*On fail goto*//*Label 11770*/ GIMT_Encode4(753095), // Rule ID 12529 //
     /*  753025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  753036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  753039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  753042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  753045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753071 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  753074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753093 */     GIR_RootConstrainSelectedInstOperands,
     /*  753094 */     // GIR_Coverage, 12529,
     /*  753094 */     GIR_EraseRootFromParent_Done,
     /*  753095 */   // Label 11770: @753095
     /*  753095 */   GIM_Try, /*On fail goto*//*Label 11771*/ GIMT_Encode4(753170), // Rule ID 12532 //
     /*  753100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  753111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  753114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  753117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  753120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753146 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  753149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753168 */     GIR_RootConstrainSelectedInstOperands,
     /*  753169 */     // GIR_Coverage, 12532,
     /*  753169 */     GIR_EraseRootFromParent_Done,
     /*  753170 */   // Label 11771: @753170
     /*  753170 */   GIM_Try, /*On fail goto*//*Label 11772*/ GIMT_Encode4(753245), // Rule ID 12533 //
     /*  753175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  753186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  753189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  753192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  753195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753221 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  753224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753243 */     GIR_RootConstrainSelectedInstOperands,
     /*  753244 */     // GIR_Coverage, 12533,
     /*  753244 */     GIR_EraseRootFromParent_Done,
     /*  753245 */   // Label 11772: @753245
     /*  753245 */   GIM_Try, /*On fail goto*//*Label 11773*/ GIMT_Encode4(753320), // Rule ID 12536 //
     /*  753250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  753261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  753264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  753267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  753270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753296 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  753299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753318 */     GIR_RootConstrainSelectedInstOperands,
     /*  753319 */     // GIR_Coverage, 12536,
     /*  753319 */     GIR_EraseRootFromParent_Done,
     /*  753320 */   // Label 11773: @753320
     /*  753320 */   GIM_Try, /*On fail goto*//*Label 11774*/ GIMT_Encode4(753395), // Rule ID 12537 //
     /*  753325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  753336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  753339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  753342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  753345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753371 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  753374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753393 */     GIR_RootConstrainSelectedInstOperands,
     /*  753394 */     // GIR_Coverage, 12537,
     /*  753394 */     GIR_EraseRootFromParent_Done,
     /*  753395 */   // Label 11774: @753395
     /*  753395 */   GIM_Try, /*On fail goto*//*Label 11775*/ GIMT_Encode4(753470), // Rule ID 12540 //
     /*  753400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  753411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  753414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  753417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  753446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  753449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753468 */     GIR_RootConstrainSelectedInstOperands,
     /*  753469 */     // GIR_Coverage, 12540,
     /*  753469 */     GIR_EraseRootFromParent_Done,
     /*  753470 */   // Label 11775: @753470
     /*  753470 */   GIM_Try, /*On fail goto*//*Label 11776*/ GIMT_Encode4(753545), // Rule ID 12541 //
     /*  753475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  753486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  753489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  753492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753521 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  753524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753543 */     GIR_RootConstrainSelectedInstOperands,
     /*  753544 */     // GIR_Coverage, 12541,
     /*  753544 */     GIR_EraseRootFromParent_Done,
     /*  753545 */   // Label 11776: @753545
     /*  753545 */   GIM_Try, /*On fail goto*//*Label 11777*/ GIMT_Encode4(753620), // Rule ID 12544 //
     /*  753550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  753561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  753564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  753567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753596 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  753596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  753599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753618 */     GIR_RootConstrainSelectedInstOperands,
     /*  753619 */     // GIR_Coverage, 12544,
     /*  753619 */     GIR_EraseRootFromParent_Done,
     /*  753620 */   // Label 11777: @753620
     /*  753620 */   GIM_Try, /*On fail goto*//*Label 11778*/ GIMT_Encode4(753695), // Rule ID 12545 //
     /*  753625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  753636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  753639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  753642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753671 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  753674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753693 */     GIR_RootConstrainSelectedInstOperands,
     /*  753694 */     // GIR_Coverage, 12545,
     /*  753694 */     GIR_EraseRootFromParent_Done,
     /*  753695 */   // Label 11778: @753695
     /*  753695 */   GIM_Try, /*On fail goto*//*Label 11779*/ GIMT_Encode4(753770), // Rule ID 12548 //
     /*  753700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  753711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  753714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  753717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753746 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  753746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  753749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753768 */     GIR_RootConstrainSelectedInstOperands,
     /*  753769 */     // GIR_Coverage, 12548,
     /*  753769 */     GIR_EraseRootFromParent_Done,
     /*  753770 */   // Label 11779: @753770
     /*  753770 */   GIM_Try, /*On fail goto*//*Label 11780*/ GIMT_Encode4(753845), // Rule ID 12549 //
     /*  753775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  753786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  753789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  753792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753821 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  753824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753843 */     GIR_RootConstrainSelectedInstOperands,
     /*  753844 */     // GIR_Coverage, 12549,
     /*  753844 */     GIR_EraseRootFromParent_Done,
     /*  753845 */   // Label 11780: @753845
     /*  753845 */   GIM_Try, /*On fail goto*//*Label 11781*/ GIMT_Encode4(753920), // Rule ID 12552 //
     /*  753850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  753861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  753864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  753867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  753896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  753899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753918 */     GIR_RootConstrainSelectedInstOperands,
     /*  753919 */     // GIR_Coverage, 12552,
     /*  753919 */     GIR_EraseRootFromParent_Done,
     /*  753920 */   // Label 11781: @753920
     /*  753920 */   GIM_Try, /*On fail goto*//*Label 11782*/ GIMT_Encode4(753995), // Rule ID 12553 //
     /*  753925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  753936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  753939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  753942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753971 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  753974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753993 */     GIR_RootConstrainSelectedInstOperands,
     /*  753994 */     // GIR_Coverage, 12553,
     /*  753994 */     GIR_EraseRootFromParent_Done,
     /*  753995 */   // Label 11782: @753995
     /*  753995 */   GIM_Try, /*On fail goto*//*Label 11783*/ GIMT_Encode4(754070), // Rule ID 12556 //
     /*  754000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  754011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  754014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  754017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754046 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  754049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754068 */     GIR_RootConstrainSelectedInstOperands,
     /*  754069 */     // GIR_Coverage, 12556,
     /*  754069 */     GIR_EraseRootFromParent_Done,
     /*  754070 */   // Label 11783: @754070
     /*  754070 */   GIM_Try, /*On fail goto*//*Label 11784*/ GIMT_Encode4(754145), // Rule ID 12557 //
     /*  754075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  754086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  754089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  754092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754121 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  754124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754143 */     GIR_RootConstrainSelectedInstOperands,
     /*  754144 */     // GIR_Coverage, 12557,
     /*  754144 */     GIR_EraseRootFromParent_Done,
     /*  754145 */   // Label 11784: @754145
     /*  754145 */   GIM_Try, /*On fail goto*//*Label 11785*/ GIMT_Encode4(754220), // Rule ID 12560 //
     /*  754150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  754161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  754164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  754167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754196 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  754199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754218 */     GIR_RootConstrainSelectedInstOperands,
     /*  754219 */     // GIR_Coverage, 12560,
     /*  754219 */     GIR_EraseRootFromParent_Done,
     /*  754220 */   // Label 11785: @754220
     /*  754220 */   GIM_Try, /*On fail goto*//*Label 11786*/ GIMT_Encode4(754295), // Rule ID 12561 //
     /*  754225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  754236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  754239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  754242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754271 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  754274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754293 */     GIR_RootConstrainSelectedInstOperands,
     /*  754294 */     // GIR_Coverage, 12561,
     /*  754294 */     GIR_EraseRootFromParent_Done,
     /*  754295 */   // Label 11786: @754295
     /*  754295 */   GIM_Try, /*On fail goto*//*Label 11787*/ GIMT_Encode4(754370), // Rule ID 12564 //
     /*  754300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  754311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  754314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  754317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  754349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754368 */     GIR_RootConstrainSelectedInstOperands,
     /*  754369 */     // GIR_Coverage, 12564,
     /*  754369 */     GIR_EraseRootFromParent_Done,
     /*  754370 */   // Label 11787: @754370
     /*  754370 */   GIM_Try, /*On fail goto*//*Label 11788*/ GIMT_Encode4(754445), // Rule ID 12565 //
     /*  754375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  754386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  754389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  754392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  754421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  754424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754443 */     GIR_RootConstrainSelectedInstOperands,
     /*  754444 */     // GIR_Coverage, 12565,
     /*  754444 */     GIR_EraseRootFromParent_Done,
     /*  754445 */   // Label 11788: @754445
     /*  754445 */   GIM_Try, /*On fail goto*//*Label 11789*/ GIMT_Encode4(754520), // Rule ID 12568 //
     /*  754450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  754461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  754464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  754467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  754499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754518 */     GIR_RootConstrainSelectedInstOperands,
     /*  754519 */     // GIR_Coverage, 12568,
     /*  754519 */     GIR_EraseRootFromParent_Done,
     /*  754520 */   // Label 11789: @754520
     /*  754520 */   GIM_Try, /*On fail goto*//*Label 11790*/ GIMT_Encode4(754595), // Rule ID 12569 //
     /*  754525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  754536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  754539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  754542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754571 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  754571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  754574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754593 */     GIR_RootConstrainSelectedInstOperands,
     /*  754594 */     // GIR_Coverage, 12569,
     /*  754594 */     GIR_EraseRootFromParent_Done,
     /*  754595 */   // Label 11790: @754595
     /*  754595 */   GIM_Try, /*On fail goto*//*Label 11791*/ GIMT_Encode4(754670), // Rule ID 12572 //
     /*  754600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  754611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  754614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  754617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  754649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754668 */     GIR_RootConstrainSelectedInstOperands,
     /*  754669 */     // GIR_Coverage, 12572,
     /*  754669 */     GIR_EraseRootFromParent_Done,
     /*  754670 */   // Label 11791: @754670
     /*  754670 */   GIM_Try, /*On fail goto*//*Label 11792*/ GIMT_Encode4(754745), // Rule ID 12573 //
     /*  754675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  754686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  754689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  754692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754721 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  754721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  754724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754743 */     GIR_RootConstrainSelectedInstOperands,
     /*  754744 */     // GIR_Coverage, 12573,
     /*  754744 */     GIR_EraseRootFromParent_Done,
     /*  754745 */   // Label 11792: @754745
     /*  754745 */   GIM_Try, /*On fail goto*//*Label 11793*/ GIMT_Encode4(754820), // Rule ID 12576 //
     /*  754750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  754761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  754764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  754767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754796 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  754799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754818 */     GIR_RootConstrainSelectedInstOperands,
     /*  754819 */     // GIR_Coverage, 12576,
     /*  754819 */     GIR_EraseRootFromParent_Done,
     /*  754820 */   // Label 11793: @754820
     /*  754820 */   GIM_Try, /*On fail goto*//*Label 11794*/ GIMT_Encode4(754895), // Rule ID 12577 //
     /*  754825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  754836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  754839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  754842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754871 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  754871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  754874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754893 */     GIR_RootConstrainSelectedInstOperands,
     /*  754894 */     // GIR_Coverage, 12577,
     /*  754894 */     GIR_EraseRootFromParent_Done,
     /*  754895 */   // Label 11794: @754895
     /*  754895 */   GIM_Try, /*On fail goto*//*Label 11795*/ GIMT_Encode4(754970), // Rule ID 12580 //
     /*  754900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  754911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  754914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  754917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754946 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  754949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754968 */     GIR_RootConstrainSelectedInstOperands,
     /*  754969 */     // GIR_Coverage, 12580,
     /*  754969 */     GIR_EraseRootFromParent_Done,
     /*  754970 */   // Label 11795: @754970
     /*  754970 */   GIM_Try, /*On fail goto*//*Label 11796*/ GIMT_Encode4(755045), // Rule ID 12581 //
     /*  754975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  754986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  754989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  754992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755021 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  755024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755043 */     GIR_RootConstrainSelectedInstOperands,
     /*  755044 */     // GIR_Coverage, 12581,
     /*  755044 */     GIR_EraseRootFromParent_Done,
     /*  755045 */   // Label 11796: @755045
     /*  755045 */   GIM_Try, /*On fail goto*//*Label 11797*/ GIMT_Encode4(755120), // Rule ID 12584 //
     /*  755050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  755061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  755064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  755067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755096 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  755099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755118 */     GIR_RootConstrainSelectedInstOperands,
     /*  755119 */     // GIR_Coverage, 12584,
     /*  755119 */     GIR_EraseRootFromParent_Done,
     /*  755120 */   // Label 11797: @755120
     /*  755120 */   GIM_Try, /*On fail goto*//*Label 11798*/ GIMT_Encode4(755195), // Rule ID 12585 //
     /*  755125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  755136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  755139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  755142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755171 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  755174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755193 */     GIR_RootConstrainSelectedInstOperands,
     /*  755194 */     // GIR_Coverage, 12585,
     /*  755194 */     GIR_EraseRootFromParent_Done,
     /*  755195 */   // Label 11798: @755195
     /*  755195 */   GIM_Try, /*On fail goto*//*Label 11799*/ GIMT_Encode4(755270), // Rule ID 12588 //
     /*  755200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  755211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  755214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  755217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  755249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755268 */     GIR_RootConstrainSelectedInstOperands,
     /*  755269 */     // GIR_Coverage, 12588,
     /*  755269 */     GIR_EraseRootFromParent_Done,
     /*  755270 */   // Label 11799: @755270
     /*  755270 */   GIM_Try, /*On fail goto*//*Label 11800*/ GIMT_Encode4(755345), // Rule ID 12589 //
     /*  755275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  755286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  755289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  755292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  755324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755343 */     GIR_RootConstrainSelectedInstOperands,
     /*  755344 */     // GIR_Coverage, 12589,
     /*  755344 */     GIR_EraseRootFromParent_Done,
     /*  755345 */   // Label 11800: @755345
     /*  755345 */   GIM_Try, /*On fail goto*//*Label 11801*/ GIMT_Encode4(755420), // Rule ID 12592 //
     /*  755350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  755361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  755364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  755367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  755399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755418 */     GIR_RootConstrainSelectedInstOperands,
     /*  755419 */     // GIR_Coverage, 12592,
     /*  755419 */     GIR_EraseRootFromParent_Done,
     /*  755420 */   // Label 11801: @755420
     /*  755420 */   GIM_Try, /*On fail goto*//*Label 11802*/ GIMT_Encode4(755495), // Rule ID 12593 //
     /*  755425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  755436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  755439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  755442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755471 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  755474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755493 */     GIR_RootConstrainSelectedInstOperands,
     /*  755494 */     // GIR_Coverage, 12593,
     /*  755494 */     GIR_EraseRootFromParent_Done,
     /*  755495 */   // Label 11802: @755495
     /*  755495 */   GIM_Try, /*On fail goto*//*Label 11803*/ GIMT_Encode4(755570), // Rule ID 12596 //
     /*  755500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  755511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  755514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  755517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  755549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755568 */     GIR_RootConstrainSelectedInstOperands,
     /*  755569 */     // GIR_Coverage, 12596,
     /*  755569 */     GIR_EraseRootFromParent_Done,
     /*  755570 */   // Label 11803: @755570
     /*  755570 */   GIM_Try, /*On fail goto*//*Label 11804*/ GIMT_Encode4(755645), // Rule ID 12597 //
     /*  755575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  755586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  755589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  755592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755621 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  755624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755643 */     GIR_RootConstrainSelectedInstOperands,
     /*  755644 */     // GIR_Coverage, 12597,
     /*  755644 */     GIR_EraseRootFromParent_Done,
     /*  755645 */   // Label 11804: @755645
     /*  755645 */   GIM_Try, /*On fail goto*//*Label 11805*/ GIMT_Encode4(755720), // Rule ID 12600 //
     /*  755650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  755661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  755664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  755667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  755670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755696 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  755699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755718 */     GIR_RootConstrainSelectedInstOperands,
     /*  755719 */     // GIR_Coverage, 12600,
     /*  755719 */     GIR_EraseRootFromParent_Done,
     /*  755720 */   // Label 11805: @755720
     /*  755720 */   GIM_Try, /*On fail goto*//*Label 11806*/ GIMT_Encode4(755795), // Rule ID 12601 //
     /*  755725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  755736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  755739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  755742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  755745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755771 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  755771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  755774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755793 */     GIR_RootConstrainSelectedInstOperands,
     /*  755794 */     // GIR_Coverage, 12601,
     /*  755794 */     GIR_EraseRootFromParent_Done,
     /*  755795 */   // Label 11806: @755795
     /*  755795 */   GIM_Try, /*On fail goto*//*Label 11807*/ GIMT_Encode4(755870), // Rule ID 12604 //
     /*  755800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  755811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  755814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  755817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  755820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755846 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  755849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755868 */     GIR_RootConstrainSelectedInstOperands,
     /*  755869 */     // GIR_Coverage, 12604,
     /*  755869 */     GIR_EraseRootFromParent_Done,
     /*  755870 */   // Label 11807: @755870
     /*  755870 */   GIM_Try, /*On fail goto*//*Label 11808*/ GIMT_Encode4(755945), // Rule ID 12605 //
     /*  755875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  755886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  755889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  755892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  755895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755921 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  755921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  755924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755943 */     GIR_RootConstrainSelectedInstOperands,
     /*  755944 */     // GIR_Coverage, 12605,
     /*  755944 */     GIR_EraseRootFromParent_Done,
     /*  755945 */   // Label 11808: @755945
     /*  755945 */   GIM_Try, /*On fail goto*//*Label 11809*/ GIMT_Encode4(756020), // Rule ID 12608 //
     /*  755950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  755961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  755964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  755967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  755970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  755999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756018 */     GIR_RootConstrainSelectedInstOperands,
     /*  756019 */     // GIR_Coverage, 12608,
     /*  756019 */     GIR_EraseRootFromParent_Done,
     /*  756020 */   // Label 11809: @756020
     /*  756020 */   GIM_Try, /*On fail goto*//*Label 11810*/ GIMT_Encode4(756095), // Rule ID 12609 //
     /*  756025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  756036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  756039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  756042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  756045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756071 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  756074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756093 */     GIR_RootConstrainSelectedInstOperands,
     /*  756094 */     // GIR_Coverage, 12609,
     /*  756094 */     GIR_EraseRootFromParent_Done,
     /*  756095 */   // Label 11810: @756095
     /*  756095 */   GIM_Try, /*On fail goto*//*Label 11811*/ GIMT_Encode4(756170), // Rule ID 12612 //
     /*  756100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  756111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  756114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  756117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  756120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  756149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756168 */     GIR_RootConstrainSelectedInstOperands,
     /*  756169 */     // GIR_Coverage, 12612,
     /*  756169 */     GIR_EraseRootFromParent_Done,
     /*  756170 */   // Label 11811: @756170
     /*  756170 */   GIM_Try, /*On fail goto*//*Label 11812*/ GIMT_Encode4(756245), // Rule ID 12613 //
     /*  756175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  756186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  756189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  756192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  756195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  756224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756243 */     GIR_RootConstrainSelectedInstOperands,
     /*  756244 */     // GIR_Coverage, 12613,
     /*  756244 */     GIR_EraseRootFromParent_Done,
     /*  756245 */   // Label 11812: @756245
     /*  756245 */   GIM_Try, /*On fail goto*//*Label 11813*/ GIMT_Encode4(756320), // Rule ID 12616 //
     /*  756250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  756261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  756264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  756267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  756270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  756299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756318 */     GIR_RootConstrainSelectedInstOperands,
     /*  756319 */     // GIR_Coverage, 12616,
     /*  756319 */     GIR_EraseRootFromParent_Done,
     /*  756320 */   // Label 11813: @756320
     /*  756320 */   GIM_Try, /*On fail goto*//*Label 11814*/ GIMT_Encode4(756395), // Rule ID 12617 //
     /*  756325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  756336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  756339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  756342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  756345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756371 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  756374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756393 */     GIR_RootConstrainSelectedInstOperands,
     /*  756394 */     // GIR_Coverage, 12617,
     /*  756394 */     GIR_EraseRootFromParent_Done,
     /*  756395 */   // Label 11814: @756395
     /*  756395 */   GIM_Try, /*On fail goto*//*Label 11815*/ GIMT_Encode4(756470), // Rule ID 12620 //
     /*  756400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  756411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  756414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  756417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  756420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  756449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756468 */     GIR_RootConstrainSelectedInstOperands,
     /*  756469 */     // GIR_Coverage, 12620,
     /*  756469 */     GIR_EraseRootFromParent_Done,
     /*  756470 */   // Label 11815: @756470
     /*  756470 */   GIM_Try, /*On fail goto*//*Label 11816*/ GIMT_Encode4(756545), // Rule ID 12621 //
     /*  756475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  756486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  756489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  756492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  756495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  756524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756543 */     GIR_RootConstrainSelectedInstOperands,
     /*  756544 */     // GIR_Coverage, 12621,
     /*  756544 */     GIR_EraseRootFromParent_Done,
     /*  756545 */   // Label 11816: @756545
     /*  756545 */   GIM_Try, /*On fail goto*//*Label 11817*/ GIMT_Encode4(756620), // Rule ID 12624 //
     /*  756550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  756561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  756564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  756567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  756570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756596 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  756599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756618 */     GIR_RootConstrainSelectedInstOperands,
     /*  756619 */     // GIR_Coverage, 12624,
     /*  756619 */     GIR_EraseRootFromParent_Done,
     /*  756620 */   // Label 11817: @756620
     /*  756620 */   GIM_Try, /*On fail goto*//*Label 11818*/ GIMT_Encode4(756695), // Rule ID 12625 //
     /*  756625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  756636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  756639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  756642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  756645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756671 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  756674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756693 */     GIR_RootConstrainSelectedInstOperands,
     /*  756694 */     // GIR_Coverage, 12625,
     /*  756694 */     GIR_EraseRootFromParent_Done,
     /*  756695 */   // Label 11818: @756695
     /*  756695 */   GIM_Try, /*On fail goto*//*Label 11819*/ GIMT_Encode4(756770), // Rule ID 12628 //
     /*  756700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  756711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  756714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  756717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  756720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756746 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  756749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756768 */     GIR_RootConstrainSelectedInstOperands,
     /*  756769 */     // GIR_Coverage, 12628,
     /*  756769 */     GIR_EraseRootFromParent_Done,
     /*  756770 */   // Label 11819: @756770
     /*  756770 */   GIM_Try, /*On fail goto*//*Label 11820*/ GIMT_Encode4(756845), // Rule ID 12629 //
     /*  756775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  756786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  756789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  756792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  756795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756821 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  756824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756843 */     GIR_RootConstrainSelectedInstOperands,
     /*  756844 */     // GIR_Coverage, 12629,
     /*  756844 */     GIR_EraseRootFromParent_Done,
     /*  756845 */   // Label 11820: @756845
     /*  756845 */   GIM_Try, /*On fail goto*//*Label 11821*/ GIMT_Encode4(756920), // Rule ID 12632 //
     /*  756850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  756861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  756864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  756867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  756870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  756899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756918 */     GIR_RootConstrainSelectedInstOperands,
     /*  756919 */     // GIR_Coverage, 12632,
     /*  756919 */     GIR_EraseRootFromParent_Done,
     /*  756920 */   // Label 11821: @756920
     /*  756920 */   GIM_Try, /*On fail goto*//*Label 11822*/ GIMT_Encode4(756995), // Rule ID 12633 //
     /*  756925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  756936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  756939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  756942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  756945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  756974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756993 */     GIR_RootConstrainSelectedInstOperands,
     /*  756994 */     // GIR_Coverage, 12633,
     /*  756994 */     GIR_EraseRootFromParent_Done,
     /*  756995 */   // Label 11822: @756995
     /*  756995 */   GIM_Try, /*On fail goto*//*Label 11823*/ GIMT_Encode4(757070), // Rule ID 12636 //
     /*  757000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  757011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  757014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  757017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  757020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  757049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757068 */     GIR_RootConstrainSelectedInstOperands,
     /*  757069 */     // GIR_Coverage, 12636,
     /*  757069 */     GIR_EraseRootFromParent_Done,
     /*  757070 */   // Label 11823: @757070
     /*  757070 */   GIM_Try, /*On fail goto*//*Label 11824*/ GIMT_Encode4(757145), // Rule ID 12637 //
     /*  757075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  757086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  757089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  757092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  757095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  757124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757143 */     GIR_RootConstrainSelectedInstOperands,
     /*  757144 */     // GIR_Coverage, 12637,
     /*  757144 */     GIR_EraseRootFromParent_Done,
     /*  757145 */   // Label 11824: @757145
     /*  757145 */   GIM_Try, /*On fail goto*//*Label 11825*/ GIMT_Encode4(757220), // Rule ID 12640 //
     /*  757150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  757161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  757164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  757167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  757170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  757199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757218 */     GIR_RootConstrainSelectedInstOperands,
     /*  757219 */     // GIR_Coverage, 12640,
     /*  757219 */     GIR_EraseRootFromParent_Done,
     /*  757220 */   // Label 11825: @757220
     /*  757220 */   GIM_Try, /*On fail goto*//*Label 11826*/ GIMT_Encode4(757295), // Rule ID 12641 //
     /*  757225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  757236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  757239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  757242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  757245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757271 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  757274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757293 */     GIR_RootConstrainSelectedInstOperands,
     /*  757294 */     // GIR_Coverage, 12641,
     /*  757294 */     GIR_EraseRootFromParent_Done,
     /*  757295 */   // Label 11826: @757295
     /*  757295 */   GIM_Try, /*On fail goto*//*Label 11827*/ GIMT_Encode4(757370), // Rule ID 12644 //
     /*  757300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  757303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  757311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  757314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  757317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  757320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757346 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  757349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757368 */     GIR_RootConstrainSelectedInstOperands,
     /*  757369 */     // GIR_Coverage, 12644,
     /*  757369 */     GIR_EraseRootFromParent_Done,
     /*  757370 */   // Label 11827: @757370
     /*  757370 */   GIM_Try, /*On fail goto*//*Label 11828*/ GIMT_Encode4(757445), // Rule ID 12645 //
     /*  757375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  757378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  757386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  757389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  757392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  757395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757421 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  757424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757443 */     GIR_RootConstrainSelectedInstOperands,
     /*  757444 */     // GIR_Coverage, 12645,
     /*  757444 */     GIR_EraseRootFromParent_Done,
     /*  757445 */   // Label 11828: @757445
     /*  757445 */   GIM_Try, /*On fail goto*//*Label 11829*/ GIMT_Encode4(757520), // Rule ID 12648 //
     /*  757450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  757453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  757461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  757464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  757467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  757470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  757499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757518 */     GIR_RootConstrainSelectedInstOperands,
     /*  757519 */     // GIR_Coverage, 12648,
     /*  757519 */     GIR_EraseRootFromParent_Done,
     /*  757520 */   // Label 11829: @757520
     /*  757520 */   GIM_Try, /*On fail goto*//*Label 11830*/ GIMT_Encode4(757595), // Rule ID 12649 //
     /*  757525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  757528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  757536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  757539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  757542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  757545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757571 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  757574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757593 */     GIR_RootConstrainSelectedInstOperands,
     /*  757594 */     // GIR_Coverage, 12649,
     /*  757594 */     GIR_EraseRootFromParent_Done,
     /*  757595 */   // Label 11830: @757595
     /*  757595 */   GIM_Try, /*On fail goto*//*Label 11831*/ GIMT_Encode4(757670), // Rule ID 12652 //
     /*  757600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  757603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  757611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  757614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  757617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  757620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757646 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  757649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757668 */     GIR_RootConstrainSelectedInstOperands,
     /*  757669 */     // GIR_Coverage, 12652,
     /*  757669 */     GIR_EraseRootFromParent_Done,
     /*  757670 */   // Label 11831: @757670
     /*  757670 */   GIM_Try, /*On fail goto*//*Label 11832*/ GIMT_Encode4(757745), // Rule ID 12653 //
     /*  757675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  757678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  757686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  757689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  757692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  757695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757721 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  757724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757743 */     GIR_RootConstrainSelectedInstOperands,
     /*  757744 */     // GIR_Coverage, 12653,
     /*  757744 */     GIR_EraseRootFromParent_Done,
     /*  757745 */   // Label 11832: @757745
     /*  757745 */   GIM_Try, /*On fail goto*//*Label 11833*/ GIMT_Encode4(757820), // Rule ID 12656 //
     /*  757750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  757753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  757761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  757764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  757767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  757770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757796 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  757799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757818 */     GIR_RootConstrainSelectedInstOperands,
     /*  757819 */     // GIR_Coverage, 12656,
     /*  757819 */     GIR_EraseRootFromParent_Done,
     /*  757820 */   // Label 11833: @757820
     /*  757820 */   GIM_Try, /*On fail goto*//*Label 11834*/ GIMT_Encode4(757895), // Rule ID 12657 //
     /*  757825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  757828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  757836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  757839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  757842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  757845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757871 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  757874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757893 */     GIR_RootConstrainSelectedInstOperands,
     /*  757894 */     // GIR_Coverage, 12657,
     /*  757894 */     GIR_EraseRootFromParent_Done,
     /*  757895 */   // Label 11834: @757895
     /*  757895 */   GIM_Try, /*On fail goto*//*Label 11835*/ GIMT_Encode4(757970), // Rule ID 12660 //
     /*  757900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  757911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  757914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  757917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  757920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  757939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  757946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  757949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757968 */     GIR_RootConstrainSelectedInstOperands,
     /*  757969 */     // GIR_Coverage, 12660,
     /*  757969 */     GIR_EraseRootFromParent_Done,
     /*  757970 */   // Label 11835: @757970
     /*  757970 */   GIM_Try, /*On fail goto*//*Label 11836*/ GIMT_Encode4(758045), // Rule ID 12661 //
     /*  757975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  757986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  757989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  757992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  757995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758021 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  758024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758043 */     GIR_RootConstrainSelectedInstOperands,
     /*  758044 */     // GIR_Coverage, 12661,
     /*  758044 */     GIR_EraseRootFromParent_Done,
     /*  758045 */   // Label 11836: @758045
     /*  758045 */   GIM_Try, /*On fail goto*//*Label 11837*/ GIMT_Encode4(758120), // Rule ID 12664 //
     /*  758050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  758061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  758064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  758067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  758099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758118 */     GIR_RootConstrainSelectedInstOperands,
     /*  758119 */     // GIR_Coverage, 12664,
     /*  758119 */     GIR_EraseRootFromParent_Done,
     /*  758120 */   // Label 11837: @758120
     /*  758120 */   GIM_Try, /*On fail goto*//*Label 11838*/ GIMT_Encode4(758195), // Rule ID 12665 //
     /*  758125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  758136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  758139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  758142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  758174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758193 */     GIR_RootConstrainSelectedInstOperands,
     /*  758194 */     // GIR_Coverage, 12665,
     /*  758194 */     GIR_EraseRootFromParent_Done,
     /*  758195 */   // Label 11838: @758195
     /*  758195 */   GIM_Try, /*On fail goto*//*Label 11839*/ GIMT_Encode4(758270), // Rule ID 12668 //
     /*  758200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  758211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  758214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  758217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  758249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758268 */     GIR_RootConstrainSelectedInstOperands,
     /*  758269 */     // GIR_Coverage, 12668,
     /*  758269 */     GIR_EraseRootFromParent_Done,
     /*  758270 */   // Label 11839: @758270
     /*  758270 */   GIM_Try, /*On fail goto*//*Label 11840*/ GIMT_Encode4(758345), // Rule ID 12669 //
     /*  758275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  758286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  758289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  758292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11634:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  758324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758343 */     GIR_RootConstrainSelectedInstOperands,
     /*  758344 */     // GIR_Coverage, 12669,
     /*  758344 */     GIR_EraseRootFromParent_Done,
     /*  758345 */   // Label 11840: @758345
     /*  758345 */   GIM_Try, /*On fail goto*//*Label 11841*/ GIMT_Encode4(758420), // Rule ID 12672 //
     /*  758350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  758367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  758399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758418 */     GIR_RootConstrainSelectedInstOperands,
     /*  758419 */     // GIR_Coverage, 12672,
     /*  758419 */     GIR_EraseRootFromParent_Done,
     /*  758420 */   // Label 11841: @758420
     /*  758420 */   GIM_Try, /*On fail goto*//*Label 11842*/ GIMT_Encode4(758495), // Rule ID 12673 //
     /*  758425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  758442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  758474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758493 */     GIR_RootConstrainSelectedInstOperands,
     /*  758494 */     // GIR_Coverage, 12673,
     /*  758494 */     GIR_EraseRootFromParent_Done,
     /*  758495 */   // Label 11842: @758495
     /*  758495 */   GIM_Try, /*On fail goto*//*Label 11843*/ GIMT_Encode4(758570), // Rule ID 12676 //
     /*  758500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  758511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  758514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  758517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  758549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758568 */     GIR_RootConstrainSelectedInstOperands,
     /*  758569 */     // GIR_Coverage, 12676,
     /*  758569 */     GIR_EraseRootFromParent_Done,
     /*  758570 */   // Label 11843: @758570
     /*  758570 */   GIM_Try, /*On fail goto*//*Label 11844*/ GIMT_Encode4(758645), // Rule ID 12677 //
     /*  758575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  758586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  758589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  758592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758621 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  758624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758643 */     GIR_RootConstrainSelectedInstOperands,
     /*  758644 */     // GIR_Coverage, 12677,
     /*  758644 */     GIR_EraseRootFromParent_Done,
     /*  758645 */   // Label 11844: @758645
     /*  758645 */   GIM_Try, /*On fail goto*//*Label 11845*/ GIMT_Encode4(758720), // Rule ID 12680 //
     /*  758650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  758661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  758664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  758667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758696 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  758699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758718 */     GIR_RootConstrainSelectedInstOperands,
     /*  758719 */     // GIR_Coverage, 12680,
     /*  758719 */     GIR_EraseRootFromParent_Done,
     /*  758720 */   // Label 11845: @758720
     /*  758720 */   GIM_Try, /*On fail goto*//*Label 11846*/ GIMT_Encode4(758795), // Rule ID 12681 //
     /*  758725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  758736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  758739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  758742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758771 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  758774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758793 */     GIR_RootConstrainSelectedInstOperands,
     /*  758794 */     // GIR_Coverage, 12681,
     /*  758794 */     GIR_EraseRootFromParent_Done,
     /*  758795 */   // Label 11846: @758795
     /*  758795 */   GIM_Try, /*On fail goto*//*Label 11847*/ GIMT_Encode4(758870), // Rule ID 12684 //
     /*  758800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  758811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  758814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  758817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  758849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758868 */     GIR_RootConstrainSelectedInstOperands,
     /*  758869 */     // GIR_Coverage, 12684,
     /*  758869 */     GIR_EraseRootFromParent_Done,
     /*  758870 */   // Label 11847: @758870
     /*  758870 */   GIM_Try, /*On fail goto*//*Label 11848*/ GIMT_Encode4(758945), // Rule ID 12685 //
     /*  758875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  758886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  758889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  758892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758921 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  758924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758943 */     GIR_RootConstrainSelectedInstOperands,
     /*  758944 */     // GIR_Coverage, 12685,
     /*  758944 */     GIR_EraseRootFromParent_Done,
     /*  758945 */   // Label 11848: @758945
     /*  758945 */   GIM_Try, /*On fail goto*//*Label 11849*/ GIMT_Encode4(759020), // Rule ID 12688 //
     /*  758950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  758961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  758964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  758967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  758999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759018 */     GIR_RootConstrainSelectedInstOperands,
     /*  759019 */     // GIR_Coverage, 12688,
     /*  759019 */     GIR_EraseRootFromParent_Done,
     /*  759020 */   // Label 11849: @759020
     /*  759020 */   GIM_Try, /*On fail goto*//*Label 11850*/ GIMT_Encode4(759095), // Rule ID 12689 //
     /*  759025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  759036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  759039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  759042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11634:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  759074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759093 */     GIR_RootConstrainSelectedInstOperands,
     /*  759094 */     // GIR_Coverage, 12689,
     /*  759094 */     GIR_EraseRootFromParent_Done,
     /*  759095 */   // Label 11850: @759095
     /*  759095 */   GIM_Try, /*On fail goto*//*Label 11851*/ GIMT_Encode4(759170), // Rule ID 12692 //
     /*  759100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  759111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  759114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  759117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  759146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  759149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759168 */     GIR_RootConstrainSelectedInstOperands,
     /*  759169 */     // GIR_Coverage, 12692,
     /*  759169 */     GIR_EraseRootFromParent_Done,
     /*  759170 */   // Label 11851: @759170
     /*  759170 */   GIM_Try, /*On fail goto*//*Label 11852*/ GIMT_Encode4(759245), // Rule ID 12693 //
     /*  759175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  759186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  759189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  759192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759221 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  759224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759243 */     GIR_RootConstrainSelectedInstOperands,
     /*  759244 */     // GIR_Coverage, 12693,
     /*  759244 */     GIR_EraseRootFromParent_Done,
     /*  759245 */   // Label 11852: @759245
     /*  759245 */   GIM_Try, /*On fail goto*//*Label 11853*/ GIMT_Encode4(759320), // Rule ID 12696 //
     /*  759250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  759261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  759264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  759267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759296 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  759296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  759299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759318 */     GIR_RootConstrainSelectedInstOperands,
     /*  759319 */     // GIR_Coverage, 12696,
     /*  759319 */     GIR_EraseRootFromParent_Done,
     /*  759320 */   // Label 11853: @759320
     /*  759320 */   GIM_Try, /*On fail goto*//*Label 11854*/ GIMT_Encode4(759395), // Rule ID 12697 //
     /*  759325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  759336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  759339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  759342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759371 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  759374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759393 */     GIR_RootConstrainSelectedInstOperands,
     /*  759394 */     // GIR_Coverage, 12697,
     /*  759394 */     GIR_EraseRootFromParent_Done,
     /*  759395 */   // Label 11854: @759395
     /*  759395 */   GIM_Try, /*On fail goto*//*Label 11855*/ GIMT_Encode4(759470), // Rule ID 12700 //
     /*  759400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  759417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  759446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  759449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759468 */     GIR_RootConstrainSelectedInstOperands,
     /*  759469 */     // GIR_Coverage, 12700,
     /*  759469 */     GIR_EraseRootFromParent_Done,
     /*  759470 */   // Label 11855: @759470
     /*  759470 */   GIM_Try, /*On fail goto*//*Label 11856*/ GIMT_Encode4(759545), // Rule ID 12701 //
     /*  759475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  759492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759521 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  759524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759543 */     GIR_RootConstrainSelectedInstOperands,
     /*  759544 */     // GIR_Coverage, 12701,
     /*  759544 */     GIR_EraseRootFromParent_Done,
     /*  759545 */   // Label 11856: @759545
     /*  759545 */   GIM_Try, /*On fail goto*//*Label 11857*/ GIMT_Encode4(759620), // Rule ID 12704 //
     /*  759550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  759553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  759561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  759564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  759567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759596 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  759599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759618 */     GIR_RootConstrainSelectedInstOperands,
     /*  759619 */     // GIR_Coverage, 12704,
     /*  759619 */     GIR_EraseRootFromParent_Done,
     /*  759620 */   // Label 11857: @759620
     /*  759620 */   GIM_Try, /*On fail goto*//*Label 11858*/ GIMT_Encode4(759695), // Rule ID 12705 //
     /*  759625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  759628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  759636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  759639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  759642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759671 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11634:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  759674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759693 */     GIR_RootConstrainSelectedInstOperands,
     /*  759694 */     // GIR_Coverage, 12705,
     /*  759694 */     GIR_EraseRootFromParent_Done,
     /*  759695 */   // Label 11858: @759695
     /*  759695 */   GIM_Try, /*On fail goto*//*Label 11859*/ GIMT_Encode4(759770), // Rule ID 12708 //
     /*  759700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  759703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  759717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  759749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759768 */     GIR_RootConstrainSelectedInstOperands,
     /*  759769 */     // GIR_Coverage, 12708,
     /*  759769 */     GIR_EraseRootFromParent_Done,
     /*  759770 */   // Label 11859: @759770
     /*  759770 */   GIM_Try, /*On fail goto*//*Label 11860*/ GIMT_Encode4(759845), // Rule ID 12709 //
     /*  759775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  759778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  759792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11634:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  759824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759843 */     GIR_RootConstrainSelectedInstOperands,
     /*  759844 */     // GIR_Coverage, 12709,
     /*  759844 */     GIR_EraseRootFromParent_Done,
     /*  759845 */   // Label 11860: @759845
     /*  759845 */   GIM_Try, /*On fail goto*//*Label 11861*/ GIMT_Encode4(759920), // Rule ID 12712 //
     /*  759850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  759853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  759867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  759899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759918 */     GIR_RootConstrainSelectedInstOperands,
     /*  759919 */     // GIR_Coverage, 12712,
     /*  759919 */     GIR_EraseRootFromParent_Done,
     /*  759920 */   // Label 11861: @759920
     /*  759920 */   GIM_Try, /*On fail goto*//*Label 11862*/ GIMT_Encode4(759995), // Rule ID 12713 //
     /*  759925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  759928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  759942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11634:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  759974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759993 */     GIR_RootConstrainSelectedInstOperands,
     /*  759994 */     // GIR_Coverage, 12713,
     /*  759994 */     GIR_EraseRootFromParent_Done,
     /*  759995 */   // Label 11862: @759995
     /*  759995 */   GIM_Try, /*On fail goto*//*Label 11863*/ GIMT_Encode4(760070), // Rule ID 12716 //
     /*  760000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  760003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  760008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  760011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  760014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  760017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  760046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  760049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760068 */     GIR_RootConstrainSelectedInstOperands,
     /*  760069 */     // GIR_Coverage, 12716,
     /*  760069 */     GIR_EraseRootFromParent_Done,
     /*  760070 */   // Label 11863: @760070
     /*  760070 */   GIM_Try, /*On fail goto*//*Label 11864*/ GIMT_Encode4(760145), // Rule ID 12717 //
     /*  760075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  760078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  760083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  760086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  760089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  760092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760121 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11634:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  760121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  760124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760143 */     GIR_RootConstrainSelectedInstOperands,
     /*  760144 */     // GIR_Coverage, 12717,
     /*  760144 */     GIR_EraseRootFromParent_Done,
     /*  760145 */   // Label 11864: @760145
     /*  760145 */   GIM_Try, /*On fail goto*//*Label 11865*/ GIMT_Encode4(760223), // Rule ID 14046 //
     /*  760150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  760161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  760164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  760167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  760170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  760199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760221 */     GIR_RootConstrainSelectedInstOperands,
     /*  760222 */     // GIR_Coverage, 14046,
     /*  760222 */     GIR_EraseRootFromParent_Done,
     /*  760223 */   // Label 11865: @760223
     /*  760223 */   GIM_Try, /*On fail goto*//*Label 11866*/ GIMT_Encode4(760301), // Rule ID 14047 //
     /*  760228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  760239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  760242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  760245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  760248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760274 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  760277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760299 */     GIR_RootConstrainSelectedInstOperands,
     /*  760300 */     // GIR_Coverage, 14047,
     /*  760300 */     GIR_EraseRootFromParent_Done,
     /*  760301 */   // Label 11866: @760301
     /*  760301 */   GIM_Try, /*On fail goto*//*Label 11867*/ GIMT_Encode4(760379), // Rule ID 14050 //
     /*  760306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  760317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  760320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  760323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  760326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760352 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  760355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760377 */     GIR_RootConstrainSelectedInstOperands,
     /*  760378 */     // GIR_Coverage, 14050,
     /*  760378 */     GIR_EraseRootFromParent_Done,
     /*  760379 */   // Label 11867: @760379
     /*  760379 */   GIM_Try, /*On fail goto*//*Label 11868*/ GIMT_Encode4(760457), // Rule ID 14051 //
     /*  760384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  760395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  760398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  760401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  760404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760430 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  760433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760455 */     GIR_RootConstrainSelectedInstOperands,
     /*  760456 */     // GIR_Coverage, 14051,
     /*  760456 */     GIR_EraseRootFromParent_Done,
     /*  760457 */   // Label 11868: @760457
     /*  760457 */   GIM_Try, /*On fail goto*//*Label 11869*/ GIMT_Encode4(760535), // Rule ID 14054 //
     /*  760462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  760473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  760476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  760479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  760482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760508 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  760511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760533 */     GIR_RootConstrainSelectedInstOperands,
     /*  760534 */     // GIR_Coverage, 14054,
     /*  760534 */     GIR_EraseRootFromParent_Done,
     /*  760535 */   // Label 11869: @760535
     /*  760535 */   GIM_Try, /*On fail goto*//*Label 11870*/ GIMT_Encode4(760613), // Rule ID 14055 //
     /*  760540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  760551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  760554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  760557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  760560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760586 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  760589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760611 */     GIR_RootConstrainSelectedInstOperands,
     /*  760612 */     // GIR_Coverage, 14055,
     /*  760612 */     GIR_EraseRootFromParent_Done,
     /*  760613 */   // Label 11870: @760613
     /*  760613 */   GIM_Try, /*On fail goto*//*Label 11871*/ GIMT_Encode4(760691), // Rule ID 14058 //
     /*  760618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  760629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  760632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  760635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  760638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760664 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  760667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760689 */     GIR_RootConstrainSelectedInstOperands,
     /*  760690 */     // GIR_Coverage, 14058,
     /*  760690 */     GIR_EraseRootFromParent_Done,
     /*  760691 */   // Label 11871: @760691
     /*  760691 */   GIM_Try, /*On fail goto*//*Label 11872*/ GIMT_Encode4(760769), // Rule ID 14059 //
     /*  760696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  760707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  760710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  760713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  760716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760742 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  760745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760767 */     GIR_RootConstrainSelectedInstOperands,
     /*  760768 */     // GIR_Coverage, 14059,
     /*  760768 */     GIR_EraseRootFromParent_Done,
     /*  760769 */   // Label 11872: @760769
     /*  760769 */   GIM_Try, /*On fail goto*//*Label 11873*/ GIMT_Encode4(760847), // Rule ID 14062 //
     /*  760774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  760794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760820 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  760823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760845 */     GIR_RootConstrainSelectedInstOperands,
     /*  760846 */     // GIR_Coverage, 14062,
     /*  760846 */     GIR_EraseRootFromParent_Done,
     /*  760847 */   // Label 11873: @760847
     /*  760847 */   GIM_Try, /*On fail goto*//*Label 11874*/ GIMT_Encode4(760925), // Rule ID 14063 //
     /*  760852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  760872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760898 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  760901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760923 */     GIR_RootConstrainSelectedInstOperands,
     /*  760924 */     // GIR_Coverage, 14063,
     /*  760924 */     GIR_EraseRootFromParent_Done,
     /*  760925 */   // Label 11874: @760925
     /*  760925 */   GIM_Try, /*On fail goto*//*Label 11875*/ GIMT_Encode4(761003), // Rule ID 14066 //
     /*  760930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  760941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  760944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  760947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  760950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760976 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  760976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  760979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761001 */     GIR_RootConstrainSelectedInstOperands,
     /*  761002 */     // GIR_Coverage, 14066,
     /*  761002 */     GIR_EraseRootFromParent_Done,
     /*  761003 */   // Label 11875: @761003
     /*  761003 */   GIM_Try, /*On fail goto*//*Label 11876*/ GIMT_Encode4(761081), // Rule ID 14067 //
     /*  761008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  761019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  761022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  761025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  761028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  761057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761076 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761079 */     GIR_RootConstrainSelectedInstOperands,
     /*  761080 */     // GIR_Coverage, 14067,
     /*  761080 */     GIR_EraseRootFromParent_Done,
     /*  761081 */   // Label 11876: @761081
     /*  761081 */   GIM_Try, /*On fail goto*//*Label 11877*/ GIMT_Encode4(761159), // Rule ID 14070 //
     /*  761086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  761097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  761100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  761103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  761106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761132 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761157 */     GIR_RootConstrainSelectedInstOperands,
     /*  761158 */     // GIR_Coverage, 14070,
     /*  761158 */     GIR_EraseRootFromParent_Done,
     /*  761159 */   // Label 11877: @761159
     /*  761159 */   GIM_Try, /*On fail goto*//*Label 11878*/ GIMT_Encode4(761237), // Rule ID 14071 //
     /*  761164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  761175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  761178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  761181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  761184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761210 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761235 */     GIR_RootConstrainSelectedInstOperands,
     /*  761236 */     // GIR_Coverage, 14071,
     /*  761236 */     GIR_EraseRootFromParent_Done,
     /*  761237 */   // Label 11878: @761237
     /*  761237 */   GIM_Try, /*On fail goto*//*Label 11879*/ GIMT_Encode4(761315), // Rule ID 14074 //
     /*  761242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  761253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  761256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  761259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  761262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761288 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  761288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761310 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761313 */     GIR_RootConstrainSelectedInstOperands,
     /*  761314 */     // GIR_Coverage, 14074,
     /*  761314 */     GIR_EraseRootFromParent_Done,
     /*  761315 */   // Label 11879: @761315
     /*  761315 */   GIM_Try, /*On fail goto*//*Label 11880*/ GIMT_Encode4(761393), // Rule ID 14075 //
     /*  761320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  761331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  761334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  761337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  761340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  761366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761391 */     GIR_RootConstrainSelectedInstOperands,
     /*  761392 */     // GIR_Coverage, 14075,
     /*  761392 */     GIR_EraseRootFromParent_Done,
     /*  761393 */   // Label 11880: @761393
     /*  761393 */   GIM_Try, /*On fail goto*//*Label 11881*/ GIMT_Encode4(761471), // Rule ID 14078 //
     /*  761398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  761409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  761412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  761415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  761418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  761444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761469 */     GIR_RootConstrainSelectedInstOperands,
     /*  761470 */     // GIR_Coverage, 14078,
     /*  761470 */     GIR_EraseRootFromParent_Done,
     /*  761471 */   // Label 11881: @761471
     /*  761471 */   GIM_Try, /*On fail goto*//*Label 11882*/ GIMT_Encode4(761549), // Rule ID 14079 //
     /*  761476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  761487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  761490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  761493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  761496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761522 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761547 */     GIR_RootConstrainSelectedInstOperands,
     /*  761548 */     // GIR_Coverage, 14079,
     /*  761548 */     GIR_EraseRootFromParent_Done,
     /*  761549 */   // Label 11882: @761549
     /*  761549 */   GIM_Try, /*On fail goto*//*Label 11883*/ GIMT_Encode4(761627), // Rule ID 14082 //
     /*  761554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  761557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  761565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  761568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  761571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  761574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  761600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761625 */     GIR_RootConstrainSelectedInstOperands,
     /*  761626 */     // GIR_Coverage, 14082,
     /*  761626 */     GIR_EraseRootFromParent_Done,
     /*  761627 */   // Label 11883: @761627
     /*  761627 */   GIM_Try, /*On fail goto*//*Label 11884*/ GIMT_Encode4(761705), // Rule ID 14083 //
     /*  761632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  761635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  761643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  761646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  761649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  761652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761678 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  761678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761703 */     GIR_RootConstrainSelectedInstOperands,
     /*  761704 */     // GIR_Coverage, 14083,
     /*  761704 */     GIR_EraseRootFromParent_Done,
     /*  761705 */   // Label 11884: @761705
     /*  761705 */   GIM_Try, /*On fail goto*//*Label 11885*/ GIMT_Encode4(761783), // Rule ID 14086 //
     /*  761710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  761721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  761724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  761727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  761730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761756 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  761759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761781 */     GIR_RootConstrainSelectedInstOperands,
     /*  761782 */     // GIR_Coverage, 14086,
     /*  761782 */     GIR_EraseRootFromParent_Done,
     /*  761783 */   // Label 11885: @761783
     /*  761783 */   GIM_Try, /*On fail goto*//*Label 11886*/ GIMT_Encode4(761861), // Rule ID 14087 //
     /*  761788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  761799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  761802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  761805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  761808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761834 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  761837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761859 */     GIR_RootConstrainSelectedInstOperands,
     /*  761860 */     // GIR_Coverage, 14087,
     /*  761860 */     GIR_EraseRootFromParent_Done,
     /*  761861 */   // Label 11886: @761861
     /*  761861 */   GIM_Try, /*On fail goto*//*Label 11887*/ GIMT_Encode4(761939), // Rule ID 14090 //
     /*  761866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  761877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  761880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  761883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  761886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761912 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  761915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761937 */     GIR_RootConstrainSelectedInstOperands,
     /*  761938 */     // GIR_Coverage, 14090,
     /*  761938 */     GIR_EraseRootFromParent_Done,
     /*  761939 */   // Label 11887: @761939
     /*  761939 */   GIM_Try, /*On fail goto*//*Label 11888*/ GIMT_Encode4(762017), // Rule ID 14091 //
     /*  761944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  761955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  761958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  761961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  761964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761990 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  761993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762015 */     GIR_RootConstrainSelectedInstOperands,
     /*  762016 */     // GIR_Coverage, 14091,
     /*  762016 */     GIR_EraseRootFromParent_Done,
     /*  762017 */   // Label 11888: @762017
     /*  762017 */   GIM_Try, /*On fail goto*//*Label 11889*/ GIMT_Encode4(762095), // Rule ID 14094 //
     /*  762022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  762033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  762036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  762039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  762042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762068 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  762068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  762071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762093 */     GIR_RootConstrainSelectedInstOperands,
     /*  762094 */     // GIR_Coverage, 14094,
     /*  762094 */     GIR_EraseRootFromParent_Done,
     /*  762095 */   // Label 11889: @762095
     /*  762095 */   GIM_Try, /*On fail goto*//*Label 11890*/ GIMT_Encode4(762173), // Rule ID 14095 //
     /*  762100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  762111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  762114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  762117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  762120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762146 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  762146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  762149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762171 */     GIR_RootConstrainSelectedInstOperands,
     /*  762172 */     // GIR_Coverage, 14095,
     /*  762172 */     GIR_EraseRootFromParent_Done,
     /*  762173 */   // Label 11890: @762173
     /*  762173 */   GIM_Try, /*On fail goto*//*Label 11891*/ GIMT_Encode4(762251), // Rule ID 14098 //
     /*  762178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  762189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  762192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  762195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  762198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  762227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762249 */     GIR_RootConstrainSelectedInstOperands,
     /*  762250 */     // GIR_Coverage, 14098,
     /*  762250 */     GIR_EraseRootFromParent_Done,
     /*  762251 */   // Label 11891: @762251
     /*  762251 */   GIM_Try, /*On fail goto*//*Label 11892*/ GIMT_Encode4(762329), // Rule ID 14099 //
     /*  762256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  762267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  762270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  762273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  762276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  762305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762327 */     GIR_RootConstrainSelectedInstOperands,
     /*  762328 */     // GIR_Coverage, 14099,
     /*  762328 */     GIR_EraseRootFromParent_Done,
     /*  762329 */   // Label 11892: @762329
     /*  762329 */   GIM_Try, /*On fail goto*//*Label 11893*/ GIMT_Encode4(762407), // Rule ID 14102 //
     /*  762334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  762345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  762348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  762351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  762354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762380 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  762383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762405 */     GIR_RootConstrainSelectedInstOperands,
     /*  762406 */     // GIR_Coverage, 14102,
     /*  762406 */     GIR_EraseRootFromParent_Done,
     /*  762407 */   // Label 11893: @762407
     /*  762407 */   GIM_Try, /*On fail goto*//*Label 11894*/ GIMT_Encode4(762485), // Rule ID 14103 //
     /*  762412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  762423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  762426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  762429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  762432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762458 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  762461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762483 */     GIR_RootConstrainSelectedInstOperands,
     /*  762484 */     // GIR_Coverage, 14103,
     /*  762484 */     GIR_EraseRootFromParent_Done,
     /*  762485 */   // Label 11894: @762485
     /*  762485 */   GIM_Try, /*On fail goto*//*Label 11895*/ GIMT_Encode4(762563), // Rule ID 14106 //
     /*  762490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  762501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  762504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  762507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  762510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762536 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  762539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762561 */     GIR_RootConstrainSelectedInstOperands,
     /*  762562 */     // GIR_Coverage, 14106,
     /*  762562 */     GIR_EraseRootFromParent_Done,
     /*  762563 */   // Label 11895: @762563
     /*  762563 */   GIM_Try, /*On fail goto*//*Label 11896*/ GIMT_Encode4(762641), // Rule ID 14107 //
     /*  762568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  762579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  762582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  762585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  762588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  762617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762636 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762639 */     GIR_RootConstrainSelectedInstOperands,
     /*  762640 */     // GIR_Coverage, 14107,
     /*  762640 */     GIR_EraseRootFromParent_Done,
     /*  762641 */   // Label 11896: @762641
     /*  762641 */   GIM_Try, /*On fail goto*//*Label 11897*/ GIMT_Encode4(762719), // Rule ID 14110 //
     /*  762646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  762657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  762660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  762663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  762666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  762695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762717 */     GIR_RootConstrainSelectedInstOperands,
     /*  762718 */     // GIR_Coverage, 14110,
     /*  762718 */     GIR_EraseRootFromParent_Done,
     /*  762719 */   // Label 11897: @762719
     /*  762719 */   GIM_Try, /*On fail goto*//*Label 11898*/ GIMT_Encode4(762797), // Rule ID 14111 //
     /*  762724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  762735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  762738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  762741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  762744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  762773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762795 */     GIR_RootConstrainSelectedInstOperands,
     /*  762796 */     // GIR_Coverage, 14111,
     /*  762796 */     GIR_EraseRootFromParent_Done,
     /*  762797 */   // Label 11898: @762797
     /*  762797 */   GIM_Try, /*On fail goto*//*Label 11899*/ GIMT_Encode4(762875), // Rule ID 14114 //
     /*  762802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  762813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  762816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  762819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  762822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762848 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  762851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762870 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762873 */     GIR_RootConstrainSelectedInstOperands,
     /*  762874 */     // GIR_Coverage, 14114,
     /*  762874 */     GIR_EraseRootFromParent_Done,
     /*  762875 */   // Label 11899: @762875
     /*  762875 */   GIM_Try, /*On fail goto*//*Label 11900*/ GIMT_Encode4(762953), // Rule ID 14115 //
     /*  762880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  762891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  762894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  762897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  762900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  762929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762951 */     GIR_RootConstrainSelectedInstOperands,
     /*  762952 */     // GIR_Coverage, 14115,
     /*  762952 */     GIR_EraseRootFromParent_Done,
     /*  762953 */   // Label 11900: @762953
     /*  762953 */   GIM_Try, /*On fail goto*//*Label 11901*/ GIMT_Encode4(763031), // Rule ID 14118 //
     /*  762958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  762969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  762972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  762975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  762978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763004 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  763004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  763007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763029 */     GIR_RootConstrainSelectedInstOperands,
     /*  763030 */     // GIR_Coverage, 14118,
     /*  763030 */     GIR_EraseRootFromParent_Done,
     /*  763031 */   // Label 11901: @763031
     /*  763031 */   GIM_Try, /*On fail goto*//*Label 11902*/ GIMT_Encode4(763109), // Rule ID 14119 //
     /*  763036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  763047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  763050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  763053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  763056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763082 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  763082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  763085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763107 */     GIR_RootConstrainSelectedInstOperands,
     /*  763108 */     // GIR_Coverage, 14119,
     /*  763108 */     GIR_EraseRootFromParent_Done,
     /*  763109 */   // Label 11902: @763109
     /*  763109 */   GIM_Try, /*On fail goto*//*Label 11903*/ GIMT_Encode4(763187), // Rule ID 14122 //
     /*  763114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  763125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  763128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  763131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  763134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763160 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  763163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763185 */     GIR_RootConstrainSelectedInstOperands,
     /*  763186 */     // GIR_Coverage, 14122,
     /*  763186 */     GIR_EraseRootFromParent_Done,
     /*  763187 */   // Label 11903: @763187
     /*  763187 */   GIM_Try, /*On fail goto*//*Label 11904*/ GIMT_Encode4(763265), // Rule ID 14123 //
     /*  763192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  763203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  763206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  763209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  763212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  763241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763263 */     GIR_RootConstrainSelectedInstOperands,
     /*  763264 */     // GIR_Coverage, 14123,
     /*  763264 */     GIR_EraseRootFromParent_Done,
     /*  763265 */   // Label 11904: @763265
     /*  763265 */   GIM_Try, /*On fail goto*//*Label 11905*/ GIMT_Encode4(763343), // Rule ID 14126 //
     /*  763270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  763281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  763284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  763287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  763290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763316 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  763319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763338 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763341 */     GIR_RootConstrainSelectedInstOperands,
     /*  763342 */     // GIR_Coverage, 14126,
     /*  763342 */     GIR_EraseRootFromParent_Done,
     /*  763343 */   // Label 11905: @763343
     /*  763343 */   GIM_Try, /*On fail goto*//*Label 11906*/ GIMT_Encode4(763421), // Rule ID 14127 //
     /*  763348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  763359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  763362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  763365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  763368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763394 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  763397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763419 */     GIR_RootConstrainSelectedInstOperands,
     /*  763420 */     // GIR_Coverage, 14127,
     /*  763420 */     GIR_EraseRootFromParent_Done,
     /*  763421 */   // Label 11906: @763421
     /*  763421 */   GIM_Try, /*On fail goto*//*Label 11907*/ GIMT_Encode4(763499), // Rule ID 14130 //
     /*  763426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  763437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  763440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  763443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  763446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763472 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  763475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763494 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763497 */     GIR_RootConstrainSelectedInstOperands,
     /*  763498 */     // GIR_Coverage, 14130,
     /*  763498 */     GIR_EraseRootFromParent_Done,
     /*  763499 */   // Label 11907: @763499
     /*  763499 */   GIM_Try, /*On fail goto*//*Label 11908*/ GIMT_Encode4(763577), // Rule ID 14131 //
     /*  763504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  763515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  763518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  763521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  763524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763550 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  763553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763575 */     GIR_RootConstrainSelectedInstOperands,
     /*  763576 */     // GIR_Coverage, 14131,
     /*  763576 */     GIR_EraseRootFromParent_Done,
     /*  763577 */   // Label 11908: @763577
     /*  763577 */   GIM_Try, /*On fail goto*//*Label 11909*/ GIMT_Encode4(763655), // Rule ID 14134 //
     /*  763582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  763593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  763596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  763599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763628 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  763631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763653 */     GIR_RootConstrainSelectedInstOperands,
     /*  763654 */     // GIR_Coverage, 14134,
     /*  763654 */     GIR_EraseRootFromParent_Done,
     /*  763655 */   // Label 11909: @763655
     /*  763655 */   GIM_Try, /*On fail goto*//*Label 11910*/ GIMT_Encode4(763733), // Rule ID 14135 //
     /*  763660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  763671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  763674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  763677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763706 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  763709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763731 */     GIR_RootConstrainSelectedInstOperands,
     /*  763732 */     // GIR_Coverage, 14135,
     /*  763732 */     GIR_EraseRootFromParent_Done,
     /*  763733 */   // Label 11910: @763733
     /*  763733 */   GIM_Try, /*On fail goto*//*Label 11911*/ GIMT_Encode4(763811), // Rule ID 14138 //
     /*  763738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  763749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  763752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  763755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763784 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  763787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763809 */     GIR_RootConstrainSelectedInstOperands,
     /*  763810 */     // GIR_Coverage, 14138,
     /*  763810 */     GIR_EraseRootFromParent_Done,
     /*  763811 */   // Label 11911: @763811
     /*  763811 */   GIM_Try, /*On fail goto*//*Label 11912*/ GIMT_Encode4(763889), // Rule ID 14139 //
     /*  763816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  763827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  763830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  763833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763862 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  763865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763887 */     GIR_RootConstrainSelectedInstOperands,
     /*  763888 */     // GIR_Coverage, 14139,
     /*  763888 */     GIR_EraseRootFromParent_Done,
     /*  763889 */   // Label 11912: @763889
     /*  763889 */   GIM_Try, /*On fail goto*//*Label 11913*/ GIMT_Encode4(763967), // Rule ID 14142 //
     /*  763894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  763905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  763908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  763911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763940 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  763943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763965 */     GIR_RootConstrainSelectedInstOperands,
     /*  763966 */     // GIR_Coverage, 14142,
     /*  763966 */     GIR_EraseRootFromParent_Done,
     /*  763967 */   // Label 11913: @763967
     /*  763967 */   GIM_Try, /*On fail goto*//*Label 11914*/ GIMT_Encode4(764045), // Rule ID 14143 //
     /*  763972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  763983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  763986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  763989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764018 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  764021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764043 */     GIR_RootConstrainSelectedInstOperands,
     /*  764044 */     // GIR_Coverage, 14143,
     /*  764044 */     GIR_EraseRootFromParent_Done,
     /*  764045 */   // Label 11914: @764045
     /*  764045 */   GIM_Try, /*On fail goto*//*Label 11915*/ GIMT_Encode4(764123), // Rule ID 14146 //
     /*  764050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  764061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  764064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  764067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  764070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764096 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  764099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764121 */     GIR_RootConstrainSelectedInstOperands,
     /*  764122 */     // GIR_Coverage, 14146,
     /*  764122 */     GIR_EraseRootFromParent_Done,
     /*  764123 */   // Label 11915: @764123
     /*  764123 */   GIM_Try, /*On fail goto*//*Label 11916*/ GIMT_Encode4(764201), // Rule ID 14147 //
     /*  764128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  764139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  764142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  764145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  764148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764174 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  764177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764199 */     GIR_RootConstrainSelectedInstOperands,
     /*  764200 */     // GIR_Coverage, 14147,
     /*  764200 */     GIR_EraseRootFromParent_Done,
     /*  764201 */   // Label 11916: @764201
     /*  764201 */   GIM_Try, /*On fail goto*//*Label 11917*/ GIMT_Encode4(764279), // Rule ID 14150 //
     /*  764206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  764217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  764220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  764223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  764226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  764255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764277 */     GIR_RootConstrainSelectedInstOperands,
     /*  764278 */     // GIR_Coverage, 14150,
     /*  764278 */     GIR_EraseRootFromParent_Done,
     /*  764279 */   // Label 11917: @764279
     /*  764279 */   GIM_Try, /*On fail goto*//*Label 11918*/ GIMT_Encode4(764357), // Rule ID 14151 //
     /*  764284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  764295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  764298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  764301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  764304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764330 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  764333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764355 */     GIR_RootConstrainSelectedInstOperands,
     /*  764356 */     // GIR_Coverage, 14151,
     /*  764356 */     GIR_EraseRootFromParent_Done,
     /*  764357 */   // Label 11918: @764357
     /*  764357 */   GIM_Try, /*On fail goto*//*Label 11919*/ GIMT_Encode4(764435), // Rule ID 14154 //
     /*  764362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  764373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  764376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  764379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  764382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764408 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  764411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764433 */     GIR_RootConstrainSelectedInstOperands,
     /*  764434 */     // GIR_Coverage, 14154,
     /*  764434 */     GIR_EraseRootFromParent_Done,
     /*  764435 */   // Label 11919: @764435
     /*  764435 */   GIM_Try, /*On fail goto*//*Label 11920*/ GIMT_Encode4(764513), // Rule ID 14155 //
     /*  764440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  764451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  764454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  764457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  764460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  764489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764511 */     GIR_RootConstrainSelectedInstOperands,
     /*  764512 */     // GIR_Coverage, 14155,
     /*  764512 */     GIR_EraseRootFromParent_Done,
     /*  764513 */   // Label 11920: @764513
     /*  764513 */   GIM_Try, /*On fail goto*//*Label 11921*/ GIMT_Encode4(764591), // Rule ID 14158 //
     /*  764518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  764529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  764532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  764535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  764538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764564 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  764567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764589 */     GIR_RootConstrainSelectedInstOperands,
     /*  764590 */     // GIR_Coverage, 14158,
     /*  764590 */     GIR_EraseRootFromParent_Done,
     /*  764591 */   // Label 11921: @764591
     /*  764591 */   GIM_Try, /*On fail goto*//*Label 11922*/ GIMT_Encode4(764669), // Rule ID 14159 //
     /*  764596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  764607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  764610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  764613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  764616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764642 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  764645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764667 */     GIR_RootConstrainSelectedInstOperands,
     /*  764668 */     // GIR_Coverage, 14159,
     /*  764668 */     GIR_EraseRootFromParent_Done,
     /*  764669 */   // Label 11922: @764669
     /*  764669 */   GIM_Try, /*On fail goto*//*Label 11923*/ GIMT_Encode4(764747), // Rule ID 14162 //
     /*  764674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  764685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  764688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  764691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  764694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  764723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764745 */     GIR_RootConstrainSelectedInstOperands,
     /*  764746 */     // GIR_Coverage, 14162,
     /*  764746 */     GIR_EraseRootFromParent_Done,
     /*  764747 */   // Label 11923: @764747
     /*  764747 */   GIM_Try, /*On fail goto*//*Label 11924*/ GIMT_Encode4(764825), // Rule ID 14163 //
     /*  764752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  764763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  764766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  764769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  764772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764798 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  764801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764823 */     GIR_RootConstrainSelectedInstOperands,
     /*  764824 */     // GIR_Coverage, 14163,
     /*  764824 */     GIR_EraseRootFromParent_Done,
     /*  764825 */   // Label 11924: @764825
     /*  764825 */   GIM_Try, /*On fail goto*//*Label 11925*/ GIMT_Encode4(764903), // Rule ID 14166 //
     /*  764830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  764841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  764844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  764847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  764850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764876 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  764879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764901 */     GIR_RootConstrainSelectedInstOperands,
     /*  764902 */     // GIR_Coverage, 14166,
     /*  764902 */     GIR_EraseRootFromParent_Done,
     /*  764903 */   // Label 11925: @764903
     /*  764903 */   GIM_Try, /*On fail goto*//*Label 11926*/ GIMT_Encode4(764981), // Rule ID 14167 //
     /*  764908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  764919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  764922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  764925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  764928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764954 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  764957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764979 */     GIR_RootConstrainSelectedInstOperands,
     /*  764980 */     // GIR_Coverage, 14167,
     /*  764980 */     GIR_EraseRootFromParent_Done,
     /*  764981 */   // Label 11926: @764981
     /*  764981 */   GIM_Try, /*On fail goto*//*Label 11927*/ GIMT_Encode4(765059), // Rule ID 14170 //
     /*  764986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  764989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  764997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  765000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  765003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765032 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  765032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  765035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765057 */     GIR_RootConstrainSelectedInstOperands,
     /*  765058 */     // GIR_Coverage, 14170,
     /*  765058 */     GIR_EraseRootFromParent_Done,
     /*  765059 */   // Label 11927: @765059
     /*  765059 */   GIM_Try, /*On fail goto*//*Label 11928*/ GIMT_Encode4(765137), // Rule ID 14171 //
     /*  765064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  765067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  765075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  765078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  765081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765110 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  765110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  765113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765132 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765135 */     GIR_RootConstrainSelectedInstOperands,
     /*  765136 */     // GIR_Coverage, 14171,
     /*  765136 */     GIR_EraseRootFromParent_Done,
     /*  765137 */   // Label 11928: @765137
     /*  765137 */   GIM_Try, /*On fail goto*//*Label 11929*/ GIMT_Encode4(765215), // Rule ID 14174 //
     /*  765142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  765153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  765156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  765159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765188 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  765191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765213 */     GIR_RootConstrainSelectedInstOperands,
     /*  765214 */     // GIR_Coverage, 14174,
     /*  765214 */     GIR_EraseRootFromParent_Done,
     /*  765215 */   // Label 11929: @765215
     /*  765215 */   GIM_Try, /*On fail goto*//*Label 11930*/ GIMT_Encode4(765293), // Rule ID 14175 //
     /*  765220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  765231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  765234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  765237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  765269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765291 */     GIR_RootConstrainSelectedInstOperands,
     /*  765292 */     // GIR_Coverage, 14175,
     /*  765292 */     GIR_EraseRootFromParent_Done,
     /*  765293 */   // Label 11930: @765293
     /*  765293 */   GIM_Try, /*On fail goto*//*Label 11931*/ GIMT_Encode4(765371), // Rule ID 14178 //
     /*  765298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  765309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  765312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  765315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765344 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  765347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765369 */     GIR_RootConstrainSelectedInstOperands,
     /*  765370 */     // GIR_Coverage, 14178,
     /*  765370 */     GIR_EraseRootFromParent_Done,
     /*  765371 */   // Label 11931: @765371
     /*  765371 */   GIM_Try, /*On fail goto*//*Label 11932*/ GIMT_Encode4(765449), // Rule ID 14179 //
     /*  765376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  765387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  765390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  765393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765422 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  765425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765447 */     GIR_RootConstrainSelectedInstOperands,
     /*  765448 */     // GIR_Coverage, 14179,
     /*  765448 */     GIR_EraseRootFromParent_Done,
     /*  765449 */   // Label 11932: @765449
     /*  765449 */   GIM_Try, /*On fail goto*//*Label 11933*/ GIMT_Encode4(765527), // Rule ID 14182 //
     /*  765454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  765465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  765468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  765471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765500 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  765503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765525 */     GIR_RootConstrainSelectedInstOperands,
     /*  765526 */     // GIR_Coverage, 14182,
     /*  765526 */     GIR_EraseRootFromParent_Done,
     /*  765527 */   // Label 11933: @765527
     /*  765527 */   GIM_Try, /*On fail goto*//*Label 11934*/ GIMT_Encode4(765605), // Rule ID 14183 //
     /*  765532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  765543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  765546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  765549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765578 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  765581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765603 */     GIR_RootConstrainSelectedInstOperands,
     /*  765604 */     // GIR_Coverage, 14183,
     /*  765604 */     GIR_EraseRootFromParent_Done,
     /*  765605 */   // Label 11934: @765605
     /*  765605 */   GIM_Try, /*On fail goto*//*Label 11935*/ GIMT_Encode4(765683), // Rule ID 14186 //
     /*  765610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  765621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  765624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  765627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765656 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  765659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765681 */     GIR_RootConstrainSelectedInstOperands,
     /*  765682 */     // GIR_Coverage, 14186,
     /*  765682 */     GIR_EraseRootFromParent_Done,
     /*  765683 */   // Label 11935: @765683
     /*  765683 */   GIM_Try, /*On fail goto*//*Label 11936*/ GIMT_Encode4(765761), // Rule ID 14187 //
     /*  765688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  765699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  765702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  765705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  765737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765759 */     GIR_RootConstrainSelectedInstOperands,
     /*  765760 */     // GIR_Coverage, 14187,
     /*  765760 */     GIR_EraseRootFromParent_Done,
     /*  765761 */   // Label 11936: @765761
     /*  765761 */   GIM_Try, /*On fail goto*//*Label 11937*/ GIMT_Encode4(765839), // Rule ID 14190 //
     /*  765766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  765777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  765780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  765783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765812 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  765815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765834 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765837 */     GIR_RootConstrainSelectedInstOperands,
     /*  765838 */     // GIR_Coverage, 14190,
     /*  765838 */     GIR_EraseRootFromParent_Done,
     /*  765839 */   // Label 11937: @765839
     /*  765839 */   GIM_Try, /*On fail goto*//*Label 11938*/ GIMT_Encode4(765917), // Rule ID 14191 //
     /*  765844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  765855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  765858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  765861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765890 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  765893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765915 */     GIR_RootConstrainSelectedInstOperands,
     /*  765916 */     // GIR_Coverage, 14191,
     /*  765916 */     GIR_EraseRootFromParent_Done,
     /*  765917 */   // Label 11938: @765917
     /*  765917 */   GIM_Try, /*On fail goto*//*Label 11939*/ GIMT_Encode4(765995), // Rule ID 14194 //
     /*  765922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  765933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  765936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  765939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765968 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  765971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765993 */     GIR_RootConstrainSelectedInstOperands,
     /*  765994 */     // GIR_Coverage, 14194,
     /*  765994 */     GIR_EraseRootFromParent_Done,
     /*  765995 */   // Label 11939: @765995
     /*  765995 */   GIM_Try, /*On fail goto*//*Label 11940*/ GIMT_Encode4(766073), // Rule ID 14195 //
     /*  766000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  766011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  766014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  766017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  766046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  766049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766068 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766071 */     GIR_RootConstrainSelectedInstOperands,
     /*  766072 */     // GIR_Coverage, 14195,
     /*  766072 */     GIR_EraseRootFromParent_Done,
     /*  766073 */   // Label 11940: @766073
     /*  766073 */   GIM_Try, /*On fail goto*//*Label 11941*/ GIMT_Encode4(766151), // Rule ID 14198 //
     /*  766078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  766089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  766092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  766095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766124 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  766127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766149 */     GIR_RootConstrainSelectedInstOperands,
     /*  766150 */     // GIR_Coverage, 14198,
     /*  766150 */     GIR_EraseRootFromParent_Done,
     /*  766151 */   // Label 11941: @766151
     /*  766151 */   GIM_Try, /*On fail goto*//*Label 11942*/ GIMT_Encode4(766229), // Rule ID 14199 //
     /*  766156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  766167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  766170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  766173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  766205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766227 */     GIR_RootConstrainSelectedInstOperands,
     /*  766228 */     // GIR_Coverage, 14199,
     /*  766228 */     GIR_EraseRootFromParent_Done,
     /*  766229 */   // Label 11942: @766229
     /*  766229 */   GIM_Try, /*On fail goto*//*Label 11943*/ GIMT_Encode4(766307), // Rule ID 14202 //
     /*  766234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  766245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  766248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  766251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766280 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  766283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766305 */     GIR_RootConstrainSelectedInstOperands,
     /*  766306 */     // GIR_Coverage, 14202,
     /*  766306 */     GIR_EraseRootFromParent_Done,
     /*  766307 */   // Label 11943: @766307
     /*  766307 */   GIM_Try, /*On fail goto*//*Label 11944*/ GIMT_Encode4(766385), // Rule ID 14203 //
     /*  766312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  766323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  766326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  766329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766358 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  766361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766383 */     GIR_RootConstrainSelectedInstOperands,
     /*  766384 */     // GIR_Coverage, 14203,
     /*  766384 */     GIR_EraseRootFromParent_Done,
     /*  766385 */   // Label 11944: @766385
     /*  766385 */   GIM_Try, /*On fail goto*//*Label 11945*/ GIMT_Encode4(766463), // Rule ID 14206 //
     /*  766390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  766401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  766404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  766407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766436 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  766439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766458 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766461 */     GIR_RootConstrainSelectedInstOperands,
     /*  766462 */     // GIR_Coverage, 14206,
     /*  766462 */     GIR_EraseRootFromParent_Done,
     /*  766463 */   // Label 11945: @766463
     /*  766463 */   GIM_Try, /*On fail goto*//*Label 11946*/ GIMT_Encode4(766541), // Rule ID 14207 //
     /*  766468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  766479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  766482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  766485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766514 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  766517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766539 */     GIR_RootConstrainSelectedInstOperands,
     /*  766540 */     // GIR_Coverage, 14207,
     /*  766540 */     GIR_EraseRootFromParent_Done,
     /*  766541 */   // Label 11946: @766541
     /*  766541 */   GIM_Try, /*On fail goto*//*Label 11947*/ GIMT_Encode4(766619), // Rule ID 14210 //
     /*  766546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  766557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  766560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  766563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766592 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  766595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766617 */     GIR_RootConstrainSelectedInstOperands,
     /*  766618 */     // GIR_Coverage, 14210,
     /*  766618 */     GIR_EraseRootFromParent_Done,
     /*  766619 */   // Label 11947: @766619
     /*  766619 */   GIM_Try, /*On fail goto*//*Label 11948*/ GIMT_Encode4(766697), // Rule ID 14211 //
     /*  766624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  766635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  766638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  766641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  766673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766695 */     GIR_RootConstrainSelectedInstOperands,
     /*  766696 */     // GIR_Coverage, 14211,
     /*  766696 */     GIR_EraseRootFromParent_Done,
     /*  766697 */   // Label 11948: @766697
     /*  766697 */   GIM_Try, /*On fail goto*//*Label 11949*/ GIMT_Encode4(766775), // Rule ID 14214 //
     /*  766702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  766713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  766716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  766719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766748 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  766751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766773 */     GIR_RootConstrainSelectedInstOperands,
     /*  766774 */     // GIR_Coverage, 14214,
     /*  766774 */     GIR_EraseRootFromParent_Done,
     /*  766775 */   // Label 11949: @766775
     /*  766775 */   GIM_Try, /*On fail goto*//*Label 11950*/ GIMT_Encode4(766853), // Rule ID 14215 //
     /*  766780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  766791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  766794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  766797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766826 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  766829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766851 */     GIR_RootConstrainSelectedInstOperands,
     /*  766852 */     // GIR_Coverage, 14215,
     /*  766852 */     GIR_EraseRootFromParent_Done,
     /*  766853 */   // Label 11950: @766853
     /*  766853 */   GIM_Try, /*On fail goto*//*Label 11951*/ GIMT_Encode4(766931), // Rule ID 14218 //
     /*  766858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  766869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  766872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  766875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766904 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  766907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766929 */     GIR_RootConstrainSelectedInstOperands,
     /*  766930 */     // GIR_Coverage, 14218,
     /*  766930 */     GIR_EraseRootFromParent_Done,
     /*  766931 */   // Label 11951: @766931
     /*  766931 */   GIM_Try, /*On fail goto*//*Label 11952*/ GIMT_Encode4(767009), // Rule ID 14219 //
     /*  766936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  766947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  766950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  766953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766982 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  766985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  767001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767007 */     GIR_RootConstrainSelectedInstOperands,
     /*  767008 */     // GIR_Coverage, 14219,
     /*  767008 */     GIR_EraseRootFromParent_Done,
     /*  767009 */   // Label 11952: @767009
     /*  767009 */   GIM_Try, /*On fail goto*//*Label 11953*/ GIMT_Encode4(767087), // Rule ID 14310 //
     /*  767014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  767025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  767028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  767031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  767034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767060 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  767063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767085 */     GIR_RootConstrainSelectedInstOperands,
     /*  767086 */     // GIR_Coverage, 14310,
     /*  767086 */     GIR_EraseRootFromParent_Done,
     /*  767087 */   // Label 11953: @767087
     /*  767087 */   GIM_Try, /*On fail goto*//*Label 11954*/ GIMT_Encode4(767165), // Rule ID 14311 //
     /*  767092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  767103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  767106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  767109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  767112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767138 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  767141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767163 */     GIR_RootConstrainSelectedInstOperands,
     /*  767164 */     // GIR_Coverage, 14311,
     /*  767164 */     GIR_EraseRootFromParent_Done,
     /*  767165 */   // Label 11954: @767165
     /*  767165 */   GIM_Try, /*On fail goto*//*Label 11955*/ GIMT_Encode4(767243), // Rule ID 14314 //
     /*  767170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  767181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  767184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  767187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  767190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767216 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  767219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767241 */     GIR_RootConstrainSelectedInstOperands,
     /*  767242 */     // GIR_Coverage, 14314,
     /*  767242 */     GIR_EraseRootFromParent_Done,
     /*  767243 */   // Label 11955: @767243
     /*  767243 */   GIM_Try, /*On fail goto*//*Label 11956*/ GIMT_Encode4(767321), // Rule ID 14315 //
     /*  767248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  767259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  767262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  767265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  767268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767294 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  767297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767319 */     GIR_RootConstrainSelectedInstOperands,
     /*  767320 */     // GIR_Coverage, 14315,
     /*  767320 */     GIR_EraseRootFromParent_Done,
     /*  767321 */   // Label 11956: @767321
     /*  767321 */   GIM_Try, /*On fail goto*//*Label 11957*/ GIMT_Encode4(767399), // Rule ID 14318 //
     /*  767326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  767337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  767340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  767343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  767346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767372 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  767375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767397 */     GIR_RootConstrainSelectedInstOperands,
     /*  767398 */     // GIR_Coverage, 14318,
     /*  767398 */     GIR_EraseRootFromParent_Done,
     /*  767399 */   // Label 11957: @767399
     /*  767399 */   GIM_Try, /*On fail goto*//*Label 11958*/ GIMT_Encode4(767477), // Rule ID 14319 //
     /*  767404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  767415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  767418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  767421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  767424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767450 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  767453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767475 */     GIR_RootConstrainSelectedInstOperands,
     /*  767476 */     // GIR_Coverage, 14319,
     /*  767476 */     GIR_EraseRootFromParent_Done,
     /*  767477 */   // Label 11958: @767477
     /*  767477 */   GIM_Try, /*On fail goto*//*Label 11959*/ GIMT_Encode4(767555), // Rule ID 14322 //
     /*  767482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  767493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  767496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  767499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  767502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767528 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  767531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767553 */     GIR_RootConstrainSelectedInstOperands,
     /*  767554 */     // GIR_Coverage, 14322,
     /*  767554 */     GIR_EraseRootFromParent_Done,
     /*  767555 */   // Label 11959: @767555
     /*  767555 */   GIM_Try, /*On fail goto*//*Label 11960*/ GIMT_Encode4(767633), // Rule ID 14323 //
     /*  767560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  767571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  767574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  767577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  767580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767606 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  767609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767631 */     GIR_RootConstrainSelectedInstOperands,
     /*  767632 */     // GIR_Coverage, 14323,
     /*  767632 */     GIR_EraseRootFromParent_Done,
     /*  767633 */   // Label 11960: @767633
     /*  767633 */   GIM_Try, /*On fail goto*//*Label 11961*/ GIMT_Encode4(767711), // Rule ID 14326 //
     /*  767638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  767649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  767652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  767655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  767658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767684 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  767687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767709 */     GIR_RootConstrainSelectedInstOperands,
     /*  767710 */     // GIR_Coverage, 14326,
     /*  767710 */     GIR_EraseRootFromParent_Done,
     /*  767711 */   // Label 11961: @767711
     /*  767711 */   GIM_Try, /*On fail goto*//*Label 11962*/ GIMT_Encode4(767789), // Rule ID 14327 //
     /*  767716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  767727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  767730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  767733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  767736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767762 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  767765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767787 */     GIR_RootConstrainSelectedInstOperands,
     /*  767788 */     // GIR_Coverage, 14327,
     /*  767788 */     GIR_EraseRootFromParent_Done,
     /*  767789 */   // Label 11962: @767789
     /*  767789 */   GIM_Try, /*On fail goto*//*Label 11963*/ GIMT_Encode4(767867), // Rule ID 14330 //
     /*  767794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  767805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  767808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  767811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  767814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  767840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  767843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767865 */     GIR_RootConstrainSelectedInstOperands,
     /*  767866 */     // GIR_Coverage, 14330,
     /*  767866 */     GIR_EraseRootFromParent_Done,
     /*  767867 */   // Label 11963: @767867
     /*  767867 */   GIM_Try, /*On fail goto*//*Label 11964*/ GIMT_Encode4(767945), // Rule ID 14331 //
     /*  767872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  767883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  767886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  767889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  767892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  767918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  767921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767943 */     GIR_RootConstrainSelectedInstOperands,
     /*  767944 */     // GIR_Coverage, 14331,
     /*  767944 */     GIR_EraseRootFromParent_Done,
     /*  767945 */   // Label 11964: @767945
     /*  767945 */   GIM_Try, /*On fail goto*//*Label 11965*/ GIMT_Encode4(768023), // Rule ID 14334 //
     /*  767950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  767961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  767964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  767967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  767970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  767999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768021 */     GIR_RootConstrainSelectedInstOperands,
     /*  768022 */     // GIR_Coverage, 14334,
     /*  768022 */     GIR_EraseRootFromParent_Done,
     /*  768023 */   // Label 11965: @768023
     /*  768023 */   GIM_Try, /*On fail goto*//*Label 11966*/ GIMT_Encode4(768101), // Rule ID 14335 //
     /*  768028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  768039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  768042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  768045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  768048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768074 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768099 */     GIR_RootConstrainSelectedInstOperands,
     /*  768100 */     // GIR_Coverage, 14335,
     /*  768100 */     GIR_EraseRootFromParent_Done,
     /*  768101 */   // Label 11966: @768101
     /*  768101 */   GIM_Try, /*On fail goto*//*Label 11967*/ GIMT_Encode4(768179), // Rule ID 14338 //
     /*  768106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  768117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  768120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  768123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  768126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  768152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768177 */     GIR_RootConstrainSelectedInstOperands,
     /*  768178 */     // GIR_Coverage, 14338,
     /*  768178 */     GIR_EraseRootFromParent_Done,
     /*  768179 */   // Label 11967: @768179
     /*  768179 */   GIM_Try, /*On fail goto*//*Label 11968*/ GIMT_Encode4(768257), // Rule ID 14339 //
     /*  768184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  768195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  768198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  768201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  768204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768230 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  768230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768255 */     GIR_RootConstrainSelectedInstOperands,
     /*  768256 */     // GIR_Coverage, 14339,
     /*  768256 */     GIR_EraseRootFromParent_Done,
     /*  768257 */   // Label 11968: @768257
     /*  768257 */   GIM_Try, /*On fail goto*//*Label 11969*/ GIMT_Encode4(768335), // Rule ID 14342 //
     /*  768262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  768273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  768276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  768279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  768282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768308 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  768308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768333 */     GIR_RootConstrainSelectedInstOperands,
     /*  768334 */     // GIR_Coverage, 14342,
     /*  768334 */     GIR_EraseRootFromParent_Done,
     /*  768335 */   // Label 11969: @768335
     /*  768335 */   GIM_Try, /*On fail goto*//*Label 11970*/ GIMT_Encode4(768413), // Rule ID 14343 //
     /*  768340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  768351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  768354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  768357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  768360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768386 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  768386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768411 */     GIR_RootConstrainSelectedInstOperands,
     /*  768412 */     // GIR_Coverage, 14343,
     /*  768412 */     GIR_EraseRootFromParent_Done,
     /*  768413 */   // Label 11970: @768413
     /*  768413 */   GIM_Try, /*On fail goto*//*Label 11971*/ GIMT_Encode4(768491), // Rule ID 14346 //
     /*  768418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  768421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  768429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  768432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  768435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  768438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768464 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  768464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768489 */     GIR_RootConstrainSelectedInstOperands,
     /*  768490 */     // GIR_Coverage, 14346,
     /*  768490 */     GIR_EraseRootFromParent_Done,
     /*  768491 */   // Label 11971: @768491
     /*  768491 */   GIM_Try, /*On fail goto*//*Label 11972*/ GIMT_Encode4(768569), // Rule ID 14347 //
     /*  768496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  768499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  768507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  768510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  768513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  768516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768542 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  768542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768567 */     GIR_RootConstrainSelectedInstOperands,
     /*  768568 */     // GIR_Coverage, 14347,
     /*  768568 */     GIR_EraseRootFromParent_Done,
     /*  768569 */   // Label 11972: @768569
     /*  768569 */   GIM_Try, /*On fail goto*//*Label 11973*/ GIMT_Encode4(768647), // Rule ID 14350 //
     /*  768574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  768585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  768588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  768591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  768594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768620 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  768623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768645 */     GIR_RootConstrainSelectedInstOperands,
     /*  768646 */     // GIR_Coverage, 14350,
     /*  768646 */     GIR_EraseRootFromParent_Done,
     /*  768647 */   // Label 11973: @768647
     /*  768647 */   GIM_Try, /*On fail goto*//*Label 11974*/ GIMT_Encode4(768725), // Rule ID 14351 //
     /*  768652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  768663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  768666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  768669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  768672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  768701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768723 */     GIR_RootConstrainSelectedInstOperands,
     /*  768724 */     // GIR_Coverage, 14351,
     /*  768724 */     GIR_EraseRootFromParent_Done,
     /*  768725 */   // Label 11974: @768725
     /*  768725 */   GIM_Try, /*On fail goto*//*Label 11975*/ GIMT_Encode4(768803), // Rule ID 14354 //
     /*  768730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  768741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  768744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  768747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  768750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768776 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  768779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768801 */     GIR_RootConstrainSelectedInstOperands,
     /*  768802 */     // GIR_Coverage, 14354,
     /*  768802 */     GIR_EraseRootFromParent_Done,
     /*  768803 */   // Label 11975: @768803
     /*  768803 */   GIM_Try, /*On fail goto*//*Label 11976*/ GIMT_Encode4(768881), // Rule ID 14355 //
     /*  768808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  768819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  768822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  768825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  768828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768854 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  768857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768879 */     GIR_RootConstrainSelectedInstOperands,
     /*  768880 */     // GIR_Coverage, 14355,
     /*  768880 */     GIR_EraseRootFromParent_Done,
     /*  768881 */   // Label 11976: @768881
     /*  768881 */   GIM_Try, /*On fail goto*//*Label 11977*/ GIMT_Encode4(768959), // Rule ID 14358 //
     /*  768886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  768897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  768900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  768903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  768906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768932 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  768935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768957 */     GIR_RootConstrainSelectedInstOperands,
     /*  768958 */     // GIR_Coverage, 14358,
     /*  768958 */     GIR_EraseRootFromParent_Done,
     /*  768959 */   // Label 11977: @768959
     /*  768959 */   GIM_Try, /*On fail goto*//*Label 11978*/ GIMT_Encode4(769037), // Rule ID 14359 //
     /*  768964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  768975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  768978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  768981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  768984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769010 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  769010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  769013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769035 */     GIR_RootConstrainSelectedInstOperands,
     /*  769036 */     // GIR_Coverage, 14359,
     /*  769036 */     GIR_EraseRootFromParent_Done,
     /*  769037 */   // Label 11978: @769037
     /*  769037 */   GIM_Try, /*On fail goto*//*Label 11979*/ GIMT_Encode4(769115), // Rule ID 14362 //
     /*  769042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  769053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  769056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  769059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  769062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769088 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  769091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769113 */     GIR_RootConstrainSelectedInstOperands,
     /*  769114 */     // GIR_Coverage, 14362,
     /*  769114 */     GIR_EraseRootFromParent_Done,
     /*  769115 */   // Label 11979: @769115
     /*  769115 */   GIM_Try, /*On fail goto*//*Label 11980*/ GIMT_Encode4(769193), // Rule ID 14363 //
     /*  769120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  769131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  769134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  769137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  769140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769166 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  769169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769191 */     GIR_RootConstrainSelectedInstOperands,
     /*  769192 */     // GIR_Coverage, 14363,
     /*  769192 */     GIR_EraseRootFromParent_Done,
     /*  769193 */   // Label 11980: @769193
     /*  769193 */   GIM_Try, /*On fail goto*//*Label 11981*/ GIMT_Encode4(769271), // Rule ID 14366 //
     /*  769198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  769209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  769212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  769215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  769218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  769247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769269 */     GIR_RootConstrainSelectedInstOperands,
     /*  769270 */     // GIR_Coverage, 14366,
     /*  769270 */     GIR_EraseRootFromParent_Done,
     /*  769271 */   // Label 11981: @769271
     /*  769271 */   GIM_Try, /*On fail goto*//*Label 11982*/ GIMT_Encode4(769349), // Rule ID 14367 //
     /*  769276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  769287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  769290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  769293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  769296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769322 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  769325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769347 */     GIR_RootConstrainSelectedInstOperands,
     /*  769348 */     // GIR_Coverage, 14367,
     /*  769348 */     GIR_EraseRootFromParent_Done,
     /*  769349 */   // Label 11982: @769349
     /*  769349 */   GIM_Try, /*On fail goto*//*Label 11983*/ GIMT_Encode4(769427), // Rule ID 14370 //
     /*  769354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  769365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  769368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  769371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  769374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769400 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  769403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769425 */     GIR_RootConstrainSelectedInstOperands,
     /*  769426 */     // GIR_Coverage, 14370,
     /*  769426 */     GIR_EraseRootFromParent_Done,
     /*  769427 */   // Label 11983: @769427
     /*  769427 */   GIM_Try, /*On fail goto*//*Label 11984*/ GIMT_Encode4(769505), // Rule ID 14371 //
     /*  769432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  769443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  769446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  769449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  769452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769478 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  769481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769500 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769503 */     GIR_RootConstrainSelectedInstOperands,
     /*  769504 */     // GIR_Coverage, 14371,
     /*  769504 */     GIR_EraseRootFromParent_Done,
     /*  769505 */   // Label 11984: @769505
     /*  769505 */   GIM_Try, /*On fail goto*//*Label 11985*/ GIMT_Encode4(769583), // Rule ID 14374 //
     /*  769510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  769521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  769524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  769527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  769530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769556 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  769559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769581 */     GIR_RootConstrainSelectedInstOperands,
     /*  769582 */     // GIR_Coverage, 14374,
     /*  769582 */     GIR_EraseRootFromParent_Done,
     /*  769583 */   // Label 11985: @769583
     /*  769583 */   GIM_Try, /*On fail goto*//*Label 11986*/ GIMT_Encode4(769661), // Rule ID 14375 //
     /*  769588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  769599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  769602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  769605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  769608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  769637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769659 */     GIR_RootConstrainSelectedInstOperands,
     /*  769660 */     // GIR_Coverage, 14375,
     /*  769660 */     GIR_EraseRootFromParent_Done,
     /*  769661 */   // Label 11986: @769661
     /*  769661 */   GIM_Try, /*On fail goto*//*Label 11987*/ GIMT_Encode4(769739), // Rule ID 14378 //
     /*  769666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  769677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  769680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  769683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  769686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769712 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  769715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769737 */     GIR_RootConstrainSelectedInstOperands,
     /*  769738 */     // GIR_Coverage, 14378,
     /*  769738 */     GIR_EraseRootFromParent_Done,
     /*  769739 */   // Label 11987: @769739
     /*  769739 */   GIM_Try, /*On fail goto*//*Label 11988*/ GIMT_Encode4(769817), // Rule ID 14379 //
     /*  769744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  769755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  769758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  769761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  769764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769790 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  769793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769815 */     GIR_RootConstrainSelectedInstOperands,
     /*  769816 */     // GIR_Coverage, 14379,
     /*  769816 */     GIR_EraseRootFromParent_Done,
     /*  769817 */   // Label 11988: @769817
     /*  769817 */   GIM_Try, /*On fail goto*//*Label 11989*/ GIMT_Encode4(769895), // Rule ID 14382 //
     /*  769822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  769833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  769836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  769839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  769842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769868 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  769871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769893 */     GIR_RootConstrainSelectedInstOperands,
     /*  769894 */     // GIR_Coverage, 14382,
     /*  769894 */     GIR_EraseRootFromParent_Done,
     /*  769895 */   // Label 11989: @769895
     /*  769895 */   GIM_Try, /*On fail goto*//*Label 11990*/ GIMT_Encode4(769973), // Rule ID 14383 //
     /*  769900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  769911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  769914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  769917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  769920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769946 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  769949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769971 */     GIR_RootConstrainSelectedInstOperands,
     /*  769972 */     // GIR_Coverage, 14383,
     /*  769972 */     GIR_EraseRootFromParent_Done,
     /*  769973 */   // Label 11990: @769973
     /*  769973 */   GIM_Try, /*On fail goto*//*Label 11991*/ GIMT_Encode4(770051), // Rule ID 14386 //
     /*  769978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  769981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  769989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  769992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  769995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  769998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  770027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770049 */     GIR_RootConstrainSelectedInstOperands,
     /*  770050 */     // GIR_Coverage, 14386,
     /*  770050 */     GIR_EraseRootFromParent_Done,
     /*  770051 */   // Label 11991: @770051
     /*  770051 */   GIM_Try, /*On fail goto*//*Label 11992*/ GIMT_Encode4(770129), // Rule ID 14387 //
     /*  770056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  770059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  770067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  770070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  770073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  770076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770102 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  770105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770127 */     GIR_RootConstrainSelectedInstOperands,
     /*  770128 */     // GIR_Coverage, 14387,
     /*  770128 */     GIR_EraseRootFromParent_Done,
     /*  770129 */   // Label 11992: @770129
     /*  770129 */   GIM_Try, /*On fail goto*//*Label 11993*/ GIMT_Encode4(770207), // Rule ID 14390 //
     /*  770134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  770137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  770145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  770148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  770151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  770154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770180 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  770183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770205 */     GIR_RootConstrainSelectedInstOperands,
     /*  770206 */     // GIR_Coverage, 14390,
     /*  770206 */     GIR_EraseRootFromParent_Done,
     /*  770207 */   // Label 11993: @770207
     /*  770207 */   GIM_Try, /*On fail goto*//*Label 11994*/ GIMT_Encode4(770285), // Rule ID 14391 //
     /*  770212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  770215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  770223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  770226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  770229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  770232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770258 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  770261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770283 */     GIR_RootConstrainSelectedInstOperands,
     /*  770284 */     // GIR_Coverage, 14391,
     /*  770284 */     GIR_EraseRootFromParent_Done,
     /*  770285 */   // Label 11994: @770285
     /*  770285 */   GIM_Try, /*On fail goto*//*Label 11995*/ GIMT_Encode4(770363), // Rule ID 14394 //
     /*  770290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  770293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  770301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  770304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  770307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  770310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770336 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  770339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770361 */     GIR_RootConstrainSelectedInstOperands,
     /*  770362 */     // GIR_Coverage, 14394,
     /*  770362 */     GIR_EraseRootFromParent_Done,
     /*  770363 */   // Label 11995: @770363
     /*  770363 */   GIM_Try, /*On fail goto*//*Label 11996*/ GIMT_Encode4(770441), // Rule ID 14395 //
     /*  770368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  770371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  770379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  770382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  770385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  770388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770414 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  770417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770439 */     GIR_RootConstrainSelectedInstOperands,
     /*  770440 */     // GIR_Coverage, 14395,
     /*  770440 */     GIR_EraseRootFromParent_Done,
     /*  770441 */   // Label 11996: @770441
     /*  770441 */   GIM_Try, /*On fail goto*//*Label 11997*/ GIMT_Encode4(770519), // Rule ID 14398 //
     /*  770446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  770457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  770460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  770463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770492 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  770495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770517 */     GIR_RootConstrainSelectedInstOperands,
     /*  770518 */     // GIR_Coverage, 14398,
     /*  770518 */     GIR_EraseRootFromParent_Done,
     /*  770519 */   // Label 11997: @770519
     /*  770519 */   GIM_Try, /*On fail goto*//*Label 11998*/ GIMT_Encode4(770597), // Rule ID 14399 //
     /*  770524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  770535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  770538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  770541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  770544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770570 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  770573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770595 */     GIR_RootConstrainSelectedInstOperands,
     /*  770596 */     // GIR_Coverage, 14399,
     /*  770596 */     GIR_EraseRootFromParent_Done,
     /*  770597 */   // Label 11998: @770597
     /*  770597 */   GIM_Try, /*On fail goto*//*Label 11999*/ GIMT_Encode4(770675), // Rule ID 14402 //
     /*  770602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  770613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  770616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  770619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770648 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  770651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770673 */     GIR_RootConstrainSelectedInstOperands,
     /*  770674 */     // GIR_Coverage, 14402,
     /*  770674 */     GIR_EraseRootFromParent_Done,
     /*  770675 */   // Label 11999: @770675
     /*  770675 */   GIM_Try, /*On fail goto*//*Label 12000*/ GIMT_Encode4(770753), // Rule ID 14403 //
     /*  770680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  770691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  770694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  770697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  770700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770726 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  770729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770751 */     GIR_RootConstrainSelectedInstOperands,
     /*  770752 */     // GIR_Coverage, 14403,
     /*  770752 */     GIR_EraseRootFromParent_Done,
     /*  770753 */   // Label 12000: @770753
     /*  770753 */   GIM_Try, /*On fail goto*//*Label 12001*/ GIMT_Encode4(770831), // Rule ID 14406 //
     /*  770758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  770769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  770772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  770775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770804 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  770807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770829 */     GIR_RootConstrainSelectedInstOperands,
     /*  770830 */     // GIR_Coverage, 14406,
     /*  770830 */     GIR_EraseRootFromParent_Done,
     /*  770831 */   // Label 12001: @770831
     /*  770831 */   GIM_Try, /*On fail goto*//*Label 12002*/ GIMT_Encode4(770909), // Rule ID 14407 //
     /*  770836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  770847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  770850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  770853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  770856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770882 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  770885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770907 */     GIR_RootConstrainSelectedInstOperands,
     /*  770908 */     // GIR_Coverage, 14407,
     /*  770908 */     GIR_EraseRootFromParent_Done,
     /*  770909 */   // Label 12002: @770909
     /*  770909 */   GIM_Try, /*On fail goto*//*Label 12003*/ GIMT_Encode4(770987), // Rule ID 14410 //
     /*  770914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  770925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  770928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  770931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770960 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  770960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  770963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770985 */     GIR_RootConstrainSelectedInstOperands,
     /*  770986 */     // GIR_Coverage, 14410,
     /*  770986 */     GIR_EraseRootFromParent_Done,
     /*  770987 */   // Label 12003: @770987
     /*  770987 */   GIM_Try, /*On fail goto*//*Label 12004*/ GIMT_Encode4(771065), // Rule ID 14411 //
     /*  770992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  771003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  771006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  771009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771038 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  771041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771063 */     GIR_RootConstrainSelectedInstOperands,
     /*  771064 */     // GIR_Coverage, 14411,
     /*  771064 */     GIR_EraseRootFromParent_Done,
     /*  771065 */   // Label 12004: @771065
     /*  771065 */   GIM_Try, /*On fail goto*//*Label 12005*/ GIMT_Encode4(771143), // Rule ID 14414 //
     /*  771070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  771081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  771084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  771087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  771090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771116 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  771119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771141 */     GIR_RootConstrainSelectedInstOperands,
     /*  771142 */     // GIR_Coverage, 14414,
     /*  771142 */     GIR_EraseRootFromParent_Done,
     /*  771143 */   // Label 12005: @771143
     /*  771143 */   GIM_Try, /*On fail goto*//*Label 12006*/ GIMT_Encode4(771221), // Rule ID 14415 //
     /*  771148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  771159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  771162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  771165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771194 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  771197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771219 */     GIR_RootConstrainSelectedInstOperands,
     /*  771220 */     // GIR_Coverage, 14415,
     /*  771220 */     GIR_EraseRootFromParent_Done,
     /*  771221 */   // Label 12006: @771221
     /*  771221 */   GIM_Try, /*On fail goto*//*Label 12007*/ GIMT_Encode4(771299), // Rule ID 14418 //
     /*  771226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  771237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  771240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  771243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  771246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771272 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  771275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771294 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771297 */     GIR_RootConstrainSelectedInstOperands,
     /*  771298 */     // GIR_Coverage, 14418,
     /*  771298 */     GIR_EraseRootFromParent_Done,
     /*  771299 */   // Label 12007: @771299
     /*  771299 */   GIM_Try, /*On fail goto*//*Label 12008*/ GIMT_Encode4(771377), // Rule ID 14419 //
     /*  771304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  771315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  771318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  771321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771350 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  771353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771375 */     GIR_RootConstrainSelectedInstOperands,
     /*  771376 */     // GIR_Coverage, 14419,
     /*  771376 */     GIR_EraseRootFromParent_Done,
     /*  771377 */   // Label 12008: @771377
     /*  771377 */   GIM_Try, /*On fail goto*//*Label 12009*/ GIMT_Encode4(771455), // Rule ID 14422 //
     /*  771382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  771393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  771396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  771399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  771402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771428 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771453 */     GIR_RootConstrainSelectedInstOperands,
     /*  771454 */     // GIR_Coverage, 14422,
     /*  771454 */     GIR_EraseRootFromParent_Done,
     /*  771455 */   // Label 12009: @771455
     /*  771455 */   GIM_Try, /*On fail goto*//*Label 12010*/ GIMT_Encode4(771533), // Rule ID 14423 //
     /*  771460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  771471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  771474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  771477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771506 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  771506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771531 */     GIR_RootConstrainSelectedInstOperands,
     /*  771532 */     // GIR_Coverage, 14423,
     /*  771532 */     GIR_EraseRootFromParent_Done,
     /*  771533 */   // Label 12010: @771533
     /*  771533 */   GIM_Try, /*On fail goto*//*Label 12011*/ GIMT_Encode4(771611), // Rule ID 14426 //
     /*  771538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  771549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  771552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  771555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  771558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771609 */     GIR_RootConstrainSelectedInstOperands,
     /*  771610 */     // GIR_Coverage, 14426,
     /*  771610 */     GIR_EraseRootFromParent_Done,
     /*  771611 */   // Label 12011: @771611
     /*  771611 */   GIM_Try, /*On fail goto*//*Label 12012*/ GIMT_Encode4(771689), // Rule ID 14427 //
     /*  771616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  771627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  771630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  771633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771662 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771687 */     GIR_RootConstrainSelectedInstOperands,
     /*  771688 */     // GIR_Coverage, 14427,
     /*  771688 */     GIR_EraseRootFromParent_Done,
     /*  771689 */   // Label 12012: @771689
     /*  771689 */   GIM_Try, /*On fail goto*//*Label 12013*/ GIMT_Encode4(771767), // Rule ID 14430 //
     /*  771694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  771705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  771708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  771711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  771714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771765 */     GIR_RootConstrainSelectedInstOperands,
     /*  771766 */     // GIR_Coverage, 14430,
     /*  771766 */     GIR_EraseRootFromParent_Done,
     /*  771767 */   // Label 12013: @771767
     /*  771767 */   GIM_Try, /*On fail goto*//*Label 12014*/ GIMT_Encode4(771845), // Rule ID 14431 //
     /*  771772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  771783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  771786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  771789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771843 */     GIR_RootConstrainSelectedInstOperands,
     /*  771844 */     // GIR_Coverage, 14431,
     /*  771844 */     GIR_EraseRootFromParent_Done,
     /*  771845 */   // Label 12014: @771845
     /*  771845 */   GIM_Try, /*On fail goto*//*Label 12015*/ GIMT_Encode4(771923), // Rule ID 14434 //
     /*  771850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  771853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  771861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  771864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  771867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  771870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771896 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  771896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771921 */     GIR_RootConstrainSelectedInstOperands,
     /*  771922 */     // GIR_Coverage, 14434,
     /*  771922 */     GIR_EraseRootFromParent_Done,
     /*  771923 */   // Label 12015: @771923
     /*  771923 */   GIM_Try, /*On fail goto*//*Label 12016*/ GIMT_Encode4(772001), // Rule ID 14435 //
     /*  771928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  771931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  771939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  771942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  771945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771974 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  771974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771999 */     GIR_RootConstrainSelectedInstOperands,
     /*  772000 */     // GIR_Coverage, 14435,
     /*  772000 */     GIR_EraseRootFromParent_Done,
     /*  772001 */   // Label 12016: @772001
     /*  772001 */   GIM_Try, /*On fail goto*//*Label 12017*/ GIMT_Encode4(772079), // Rule ID 14438 //
     /*  772006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  772017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  772020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  772023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772052 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  772052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  772055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772077 */     GIR_RootConstrainSelectedInstOperands,
     /*  772078 */     // GIR_Coverage, 14438,
     /*  772078 */     GIR_EraseRootFromParent_Done,
     /*  772079 */   // Label 12017: @772079
     /*  772079 */   GIM_Try, /*On fail goto*//*Label 12018*/ GIMT_Encode4(772157), // Rule ID 14439 //
     /*  772084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  772095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  772098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  772101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  772104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772130 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  772133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772155 */     GIR_RootConstrainSelectedInstOperands,
     /*  772156 */     // GIR_Coverage, 14439,
     /*  772156 */     GIR_EraseRootFromParent_Done,
     /*  772157 */   // Label 12018: @772157
     /*  772157 */   GIM_Try, /*On fail goto*//*Label 12019*/ GIMT_Encode4(772235), // Rule ID 14442 //
     /*  772162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  772173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  772176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  772179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772208 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  772208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  772211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772233 */     GIR_RootConstrainSelectedInstOperands,
     /*  772234 */     // GIR_Coverage, 14442,
     /*  772234 */     GIR_EraseRootFromParent_Done,
     /*  772235 */   // Label 12019: @772235
     /*  772235 */   GIM_Try, /*On fail goto*//*Label 12020*/ GIMT_Encode4(772313), // Rule ID 14443 //
     /*  772240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  772251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  772254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  772257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  772260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772286 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  772289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772311 */     GIR_RootConstrainSelectedInstOperands,
     /*  772312 */     // GIR_Coverage, 14443,
     /*  772312 */     GIR_EraseRootFromParent_Done,
     /*  772313 */   // Label 12020: @772313
     /*  772313 */   GIM_Try, /*On fail goto*//*Label 12021*/ GIMT_Encode4(772391), // Rule ID 14446 //
     /*  772318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  772329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  772332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  772335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772364 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  772364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  772367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772389 */     GIR_RootConstrainSelectedInstOperands,
     /*  772390 */     // GIR_Coverage, 14446,
     /*  772390 */     GIR_EraseRootFromParent_Done,
     /*  772391 */   // Label 12021: @772391
     /*  772391 */   GIM_Try, /*On fail goto*//*Label 12022*/ GIMT_Encode4(772469), // Rule ID 14447 //
     /*  772396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  772407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  772410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  772413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  772416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772442 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  772445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772467 */     GIR_RootConstrainSelectedInstOperands,
     /*  772468 */     // GIR_Coverage, 14447,
     /*  772468 */     GIR_EraseRootFromParent_Done,
     /*  772469 */   // Label 12022: @772469
     /*  772469 */   GIM_Try, /*On fail goto*//*Label 12023*/ GIMT_Encode4(772547), // Rule ID 14450 //
     /*  772474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  772485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  772488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  772491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772520 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  772523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772545 */     GIR_RootConstrainSelectedInstOperands,
     /*  772546 */     // GIR_Coverage, 14450,
     /*  772546 */     GIR_EraseRootFromParent_Done,
     /*  772547 */   // Label 12023: @772547
     /*  772547 */   GIM_Try, /*On fail goto*//*Label 12024*/ GIMT_Encode4(772625), // Rule ID 14451 //
     /*  772552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  772563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  772566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  772569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  772572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772598 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  772601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772623 */     GIR_RootConstrainSelectedInstOperands,
     /*  772624 */     // GIR_Coverage, 14451,
     /*  772624 */     GIR_EraseRootFromParent_Done,
     /*  772625 */   // Label 12024: @772625
     /*  772625 */   GIM_Try, /*On fail goto*//*Label 12025*/ GIMT_Encode4(772703), // Rule ID 14454 //
     /*  772630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  772641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  772644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  772647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  772679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772701 */     GIR_RootConstrainSelectedInstOperands,
     /*  772702 */     // GIR_Coverage, 14454,
     /*  772702 */     GIR_EraseRootFromParent_Done,
     /*  772703 */   // Label 12025: @772703
     /*  772703 */   GIM_Try, /*On fail goto*//*Label 12026*/ GIMT_Encode4(772781), // Rule ID 14455 //
     /*  772708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  772719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  772722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  772725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  772728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772754 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  772757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772779 */     GIR_RootConstrainSelectedInstOperands,
     /*  772780 */     // GIR_Coverage, 14455,
     /*  772780 */     GIR_EraseRootFromParent_Done,
     /*  772781 */   // Label 12026: @772781
     /*  772781 */   GIM_Try, /*On fail goto*//*Label 12027*/ GIMT_Encode4(772859), // Rule ID 14458 //
     /*  772786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  772797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  772800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  772803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772832 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  772835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772857 */     GIR_RootConstrainSelectedInstOperands,
     /*  772858 */     // GIR_Coverage, 14458,
     /*  772858 */     GIR_EraseRootFromParent_Done,
     /*  772859 */   // Label 12027: @772859
     /*  772859 */   GIM_Try, /*On fail goto*//*Label 12028*/ GIMT_Encode4(772937), // Rule ID 14459 //
     /*  772864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  772875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  772878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  772881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  772884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772910 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  772913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772935 */     GIR_RootConstrainSelectedInstOperands,
     /*  772936 */     // GIR_Coverage, 14459,
     /*  772936 */     GIR_EraseRootFromParent_Done,
     /*  772937 */   // Label 12028: @772937
     /*  772937 */   GIM_Try, /*On fail goto*//*Label 12029*/ GIMT_Encode4(773015), // Rule ID 14462 //
     /*  772942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  772953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  772956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  772959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772988 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  772991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773013 */     GIR_RootConstrainSelectedInstOperands,
     /*  773014 */     // GIR_Coverage, 14462,
     /*  773014 */     GIR_EraseRootFromParent_Done,
     /*  773015 */   // Label 12029: @773015
     /*  773015 */   GIM_Try, /*On fail goto*//*Label 12030*/ GIMT_Encode4(773093), // Rule ID 14463 //
     /*  773020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  773031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  773034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  773037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773066 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  773069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773091 */     GIR_RootConstrainSelectedInstOperands,
     /*  773092 */     // GIR_Coverage, 14463,
     /*  773092 */     GIR_EraseRootFromParent_Done,
     /*  773093 */   // Label 12030: @773093
     /*  773093 */   GIM_Try, /*On fail goto*//*Label 12031*/ GIMT_Encode4(773171), // Rule ID 14466 //
     /*  773098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  773109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  773112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  773115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773144 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  773147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773169 */     GIR_RootConstrainSelectedInstOperands,
     /*  773170 */     // GIR_Coverage, 14466,
     /*  773170 */     GIR_EraseRootFromParent_Done,
     /*  773171 */   // Label 12031: @773171
     /*  773171 */   GIM_Try, /*On fail goto*//*Label 12032*/ GIMT_Encode4(773249), // Rule ID 14467 //
     /*  773176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  773187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  773190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  773193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773222 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  773225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773247 */     GIR_RootConstrainSelectedInstOperands,
     /*  773248 */     // GIR_Coverage, 14467,
     /*  773248 */     GIR_EraseRootFromParent_Done,
     /*  773249 */   // Label 12032: @773249
     /*  773249 */   GIM_Try, /*On fail goto*//*Label 12033*/ GIMT_Encode4(773327), // Rule ID 14470 //
     /*  773254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  773265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  773268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  773271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773300 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  773303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773325 */     GIR_RootConstrainSelectedInstOperands,
     /*  773326 */     // GIR_Coverage, 14470,
     /*  773326 */     GIR_EraseRootFromParent_Done,
     /*  773327 */   // Label 12033: @773327
     /*  773327 */   GIM_Try, /*On fail goto*//*Label 12034*/ GIMT_Encode4(773405), // Rule ID 14471 //
     /*  773332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  773343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  773346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  773349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773378 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  773381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773403 */     GIR_RootConstrainSelectedInstOperands,
     /*  773404 */     // GIR_Coverage, 14471,
     /*  773404 */     GIR_EraseRootFromParent_Done,
     /*  773405 */   // Label 12034: @773405
     /*  773405 */   GIM_Try, /*On fail goto*//*Label 12035*/ GIMT_Encode4(773483), // Rule ID 14474 //
     /*  773410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  773421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  773424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  773427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  773459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773481 */     GIR_RootConstrainSelectedInstOperands,
     /*  773482 */     // GIR_Coverage, 14474,
     /*  773482 */     GIR_EraseRootFromParent_Done,
     /*  773483 */   // Label 12035: @773483
     /*  773483 */   GIM_Try, /*On fail goto*//*Label 12036*/ GIMT_Encode4(773561), // Rule ID 14475 //
     /*  773488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  773499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  773502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  773505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11508:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  773537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773559 */     GIR_RootConstrainSelectedInstOperands,
     /*  773560 */     // GIR_Coverage, 14475,
     /*  773560 */     GIR_EraseRootFromParent_Done,
     /*  773561 */   // Label 12036: @773561
     /*  773561 */   GIM_Try, /*On fail goto*//*Label 12037*/ GIMT_Encode4(773639), // Rule ID 14478 //
     /*  773566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  773577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  773580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  773583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773612 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  773615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773637 */     GIR_RootConstrainSelectedInstOperands,
     /*  773638 */     // GIR_Coverage, 14478,
     /*  773638 */     GIR_EraseRootFromParent_Done,
     /*  773639 */   // Label 12037: @773639
     /*  773639 */   GIM_Try, /*On fail goto*//*Label 12038*/ GIMT_Encode4(773717), // Rule ID 14479 //
     /*  773644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  773655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  773658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  773661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773690 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11508:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  773693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773715 */     GIR_RootConstrainSelectedInstOperands,
     /*  773716 */     // GIR_Coverage, 14479,
     /*  773716 */     GIR_EraseRootFromParent_Done,
     /*  773717 */   // Label 12038: @773717
     /*  773717 */   GIM_Try, /*On fail goto*//*Label 12039*/ GIMT_Encode4(773795), // Rule ID 14482 //
     /*  773722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  773771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773793 */     GIR_RootConstrainSelectedInstOperands,
     /*  773794 */     // GIR_Coverage, 14482,
     /*  773794 */     GIR_EraseRootFromParent_Done,
     /*  773795 */   // Label 12039: @773795
     /*  773795 */   GIM_Try, /*On fail goto*//*Label 12040*/ GIMT_Encode4(773873), // Rule ID 14483 //
     /*  773800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11508:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  773849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773871 */     GIR_RootConstrainSelectedInstOperands,
     /*  773872 */     // GIR_Coverage, 14483,
     /*  773872 */     GIR_EraseRootFromParent_Done,
     /*  773873 */   // Label 12040: @773873
     /*  773873 */   GIM_Try, /*On fail goto*//*Label 12041*/ GIMT_Encode4(773951), // Rule ID 14574 //
     /*  773878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  773889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  773892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  773895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  773898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773924 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  773927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773949 */     GIR_RootConstrainSelectedInstOperands,
     /*  773950 */     // GIR_Coverage, 14574,
     /*  773950 */     GIR_EraseRootFromParent_Done,
     /*  773951 */   // Label 12041: @773951
     /*  773951 */   GIM_Try, /*On fail goto*//*Label 12042*/ GIMT_Encode4(774029), // Rule ID 14575 //
     /*  773956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  773967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  773970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  773973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  773976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774002 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  774005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774027 */     GIR_RootConstrainSelectedInstOperands,
     /*  774028 */     // GIR_Coverage, 14575,
     /*  774028 */     GIR_EraseRootFromParent_Done,
     /*  774029 */   // Label 12042: @774029
     /*  774029 */   GIM_Try, /*On fail goto*//*Label 12043*/ GIMT_Encode4(774107), // Rule ID 14578 //
     /*  774034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  774045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  774048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  774051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  774054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774080 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  774083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774102 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774105 */     GIR_RootConstrainSelectedInstOperands,
     /*  774106 */     // GIR_Coverage, 14578,
     /*  774106 */     GIR_EraseRootFromParent_Done,
     /*  774107 */   // Label 12043: @774107
     /*  774107 */   GIM_Try, /*On fail goto*//*Label 12044*/ GIMT_Encode4(774185), // Rule ID 14579 //
     /*  774112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  774123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  774126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  774129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  774132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774158 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  774161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774183 */     GIR_RootConstrainSelectedInstOperands,
     /*  774184 */     // GIR_Coverage, 14579,
     /*  774184 */     GIR_EraseRootFromParent_Done,
     /*  774185 */   // Label 12044: @774185
     /*  774185 */   GIM_Try, /*On fail goto*//*Label 12045*/ GIMT_Encode4(774263), // Rule ID 14582 //
     /*  774190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  774201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  774204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  774207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  774210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774236 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  774239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774261 */     GIR_RootConstrainSelectedInstOperands,
     /*  774262 */     // GIR_Coverage, 14582,
     /*  774262 */     GIR_EraseRootFromParent_Done,
     /*  774263 */   // Label 12045: @774263
     /*  774263 */   GIM_Try, /*On fail goto*//*Label 12046*/ GIMT_Encode4(774341), // Rule ID 14583 //
     /*  774268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  774279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  774282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  774285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  774288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774314 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  774317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774339 */     GIR_RootConstrainSelectedInstOperands,
     /*  774340 */     // GIR_Coverage, 14583,
     /*  774340 */     GIR_EraseRootFromParent_Done,
     /*  774341 */   // Label 12046: @774341
     /*  774341 */   GIM_Try, /*On fail goto*//*Label 12047*/ GIMT_Encode4(774419), // Rule ID 14586 //
     /*  774346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  774357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  774360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  774363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  774366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774392 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  774395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774417 */     GIR_RootConstrainSelectedInstOperands,
     /*  774418 */     // GIR_Coverage, 14586,
     /*  774418 */     GIR_EraseRootFromParent_Done,
     /*  774419 */   // Label 12047: @774419
     /*  774419 */   GIM_Try, /*On fail goto*//*Label 12048*/ GIMT_Encode4(774497), // Rule ID 14587 //
     /*  774424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  774435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  774438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  774441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  774444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774470 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  774473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774495 */     GIR_RootConstrainSelectedInstOperands,
     /*  774496 */     // GIR_Coverage, 14587,
     /*  774496 */     GIR_EraseRootFromParent_Done,
     /*  774497 */   // Label 12048: @774497
     /*  774497 */   GIM_Try, /*On fail goto*//*Label 12049*/ GIMT_Encode4(774575), // Rule ID 14590 //
     /*  774502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  774522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  774551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774573 */     GIR_RootConstrainSelectedInstOperands,
     /*  774574 */     // GIR_Coverage, 14590,
     /*  774574 */     GIR_EraseRootFromParent_Done,
     /*  774575 */   // Label 12049: @774575
     /*  774575 */   GIM_Try, /*On fail goto*//*Label 12050*/ GIMT_Encode4(774653), // Rule ID 14591 //
     /*  774580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  774600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774626 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  774629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774651 */     GIR_RootConstrainSelectedInstOperands,
     /*  774652 */     // GIR_Coverage, 14591,
     /*  774652 */     GIR_EraseRootFromParent_Done,
     /*  774653 */   // Label 12050: @774653
     /*  774653 */   GIM_Try, /*On fail goto*//*Label 12051*/ GIMT_Encode4(774731), // Rule ID 14594 //
     /*  774658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  774669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  774672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  774675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  774678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774704 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  774704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  774707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774729 */     GIR_RootConstrainSelectedInstOperands,
     /*  774730 */     // GIR_Coverage, 14594,
     /*  774730 */     GIR_EraseRootFromParent_Done,
     /*  774731 */   // Label 12051: @774731
     /*  774731 */   GIM_Try, /*On fail goto*//*Label 12052*/ GIMT_Encode4(774809), // Rule ID 14595 //
     /*  774736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  774747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  774750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  774753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  774756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  774782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  774785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774807 */     GIR_RootConstrainSelectedInstOperands,
     /*  774808 */     // GIR_Coverage, 14595,
     /*  774808 */     GIR_EraseRootFromParent_Done,
     /*  774809 */   // Label 12052: @774809
     /*  774809 */   GIM_Try, /*On fail goto*//*Label 12053*/ GIMT_Encode4(774887), // Rule ID 14598 //
     /*  774814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  774825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  774828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  774831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  774834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774860 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  774863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774885 */     GIR_RootConstrainSelectedInstOperands,
     /*  774886 */     // GIR_Coverage, 14598,
     /*  774886 */     GIR_EraseRootFromParent_Done,
     /*  774887 */   // Label 12053: @774887
     /*  774887 */   GIM_Try, /*On fail goto*//*Label 12054*/ GIMT_Encode4(774965), // Rule ID 14599 //
     /*  774892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  774903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  774906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  774909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  774912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774938 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  774941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774963 */     GIR_RootConstrainSelectedInstOperands,
     /*  774964 */     // GIR_Coverage, 14599,
     /*  774964 */     GIR_EraseRootFromParent_Done,
     /*  774965 */   // Label 12054: @774965
     /*  774965 */   GIM_Try, /*On fail goto*//*Label 12055*/ GIMT_Encode4(775043), // Rule ID 14602 //
     /*  774970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  774981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  774984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  774987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  774990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  775019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775041 */     GIR_RootConstrainSelectedInstOperands,
     /*  775042 */     // GIR_Coverage, 14602,
     /*  775042 */     GIR_EraseRootFromParent_Done,
     /*  775043 */   // Label 12055: @775043
     /*  775043 */   GIM_Try, /*On fail goto*//*Label 12056*/ GIMT_Encode4(775121), // Rule ID 14603 //
     /*  775048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  775059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  775062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  775065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  775068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  775097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775119 */     GIR_RootConstrainSelectedInstOperands,
     /*  775120 */     // GIR_Coverage, 14603,
     /*  775120 */     GIR_EraseRootFromParent_Done,
     /*  775121 */   // Label 12056: @775121
     /*  775121 */   GIM_Try, /*On fail goto*//*Label 12057*/ GIMT_Encode4(775199), // Rule ID 14606 //
     /*  775126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  775137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  775140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  775143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  775146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775172 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  775172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  775175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775197 */     GIR_RootConstrainSelectedInstOperands,
     /*  775198 */     // GIR_Coverage, 14606,
     /*  775198 */     GIR_EraseRootFromParent_Done,
     /*  775199 */   // Label 12057: @775199
     /*  775199 */   GIM_Try, /*On fail goto*//*Label 12058*/ GIMT_Encode4(775277), // Rule ID 14607 //
     /*  775204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  775215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  775218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  775221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  775224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  775250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  775253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775275 */     GIR_RootConstrainSelectedInstOperands,
     /*  775276 */     // GIR_Coverage, 14607,
     /*  775276 */     GIR_EraseRootFromParent_Done,
     /*  775277 */   // Label 12058: @775277
     /*  775277 */   GIM_Try, /*On fail goto*//*Label 12059*/ GIMT_Encode4(775355), // Rule ID 14610 //
     /*  775282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  775285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  775293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  775296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  775299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  775302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  775328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  775331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  775347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775353 */     GIR_RootConstrainSelectedInstOperands,
     /*  775354 */     // GIR_Coverage, 14610,
     /*  775354 */     GIR_EraseRootFromParent_Done,
     /*  775355 */   // Label 12059: @775355
     /*  775355 */   GIM_Try, /*On fail goto*//*Label 12060*/ GIMT_Encode4(775433), // Rule ID 14611 //
     /*  775360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  775363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  775371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  775374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  775377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  775380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775406 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  775406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  775409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  775425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775431 */     GIR_RootConstrainSelectedInstOperands,
     /*  775432 */     // GIR_Coverage, 14611,
     /*  775432 */     GIR_EraseRootFromParent_Done,
     /*  775433 */   // Label 12060: @775433
     /*  775433 */   GIM_Try, /*On fail goto*//*Label 12061*/ GIMT_Encode4(775511), // Rule ID 14614 //
     /*  775438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  775449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  775452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  775455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  775458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775484 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  775487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775509 */     GIR_RootConstrainSelectedInstOperands,
     /*  775510 */     // GIR_Coverage, 14614,
     /*  775510 */     GIR_EraseRootFromParent_Done,
     /*  775511 */   // Label 12061: @775511
     /*  775511 */   GIM_Try, /*On fail goto*//*Label 12062*/ GIMT_Encode4(775589), // Rule ID 14615 //
     /*  775516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  775527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  775530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  775533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  775536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775562 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  775565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775587 */     GIR_RootConstrainSelectedInstOperands,
     /*  775588 */     // GIR_Coverage, 14615,
     /*  775588 */     GIR_EraseRootFromParent_Done,
     /*  775589 */   // Label 12062: @775589
     /*  775589 */   GIM_Try, /*On fail goto*//*Label 12063*/ GIMT_Encode4(775667), // Rule ID 14618 //
     /*  775594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  775605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  775608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  775611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  775614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775640 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  775643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775665 */     GIR_RootConstrainSelectedInstOperands,
     /*  775666 */     // GIR_Coverage, 14618,
     /*  775666 */     GIR_EraseRootFromParent_Done,
     /*  775667 */   // Label 12063: @775667
     /*  775667 */   GIM_Try, /*On fail goto*//*Label 12064*/ GIMT_Encode4(775745), // Rule ID 14619 //
     /*  775672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  775683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  775686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  775689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  775692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775718 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  775721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775743 */     GIR_RootConstrainSelectedInstOperands,
     /*  775744 */     // GIR_Coverage, 14619,
     /*  775744 */     GIR_EraseRootFromParent_Done,
     /*  775745 */   // Label 12064: @775745
     /*  775745 */   GIM_Try, /*On fail goto*//*Label 12065*/ GIMT_Encode4(775823), // Rule ID 14622 //
     /*  775750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  775761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  775764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  775767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  775770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775796 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  775799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775821 */     GIR_RootConstrainSelectedInstOperands,
     /*  775822 */     // GIR_Coverage, 14622,
     /*  775822 */     GIR_EraseRootFromParent_Done,
     /*  775823 */   // Label 12065: @775823
     /*  775823 */   GIM_Try, /*On fail goto*//*Label 12066*/ GIMT_Encode4(775901), // Rule ID 14623 //
     /*  775828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  775839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  775842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  775845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  775848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775874 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  775877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775899 */     GIR_RootConstrainSelectedInstOperands,
     /*  775900 */     // GIR_Coverage, 14623,
     /*  775900 */     GIR_EraseRootFromParent_Done,
     /*  775901 */   // Label 12066: @775901
     /*  775901 */   GIM_Try, /*On fail goto*//*Label 12067*/ GIMT_Encode4(775979), // Rule ID 14626 //
     /*  775906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  775923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  775926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775952 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  775955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775977 */     GIR_RootConstrainSelectedInstOperands,
     /*  775978 */     // GIR_Coverage, 14626,
     /*  775978 */     GIR_EraseRootFromParent_Done,
     /*  775979 */   // Label 12067: @775979
     /*  775979 */   GIM_Try, /*On fail goto*//*Label 12068*/ GIMT_Encode4(776057), // Rule ID 14627 //
     /*  775984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  776001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  776004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776030 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  776033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776055 */     GIR_RootConstrainSelectedInstOperands,
     /*  776056 */     // GIR_Coverage, 14627,
     /*  776056 */     GIR_EraseRootFromParent_Done,
     /*  776057 */   // Label 12068: @776057
     /*  776057 */   GIM_Try, /*On fail goto*//*Label 12069*/ GIMT_Encode4(776135), // Rule ID 14630 //
     /*  776062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  776073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  776076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  776079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  776082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776108 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  776111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776133 */     GIR_RootConstrainSelectedInstOperands,
     /*  776134 */     // GIR_Coverage, 14630,
     /*  776134 */     GIR_EraseRootFromParent_Done,
     /*  776135 */   // Label 12069: @776135
     /*  776135 */   GIM_Try, /*On fail goto*//*Label 12070*/ GIMT_Encode4(776213), // Rule ID 14631 //
     /*  776140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  776151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  776154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  776157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  776160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776186 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  776189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776211 */     GIR_RootConstrainSelectedInstOperands,
     /*  776212 */     // GIR_Coverage, 14631,
     /*  776212 */     GIR_EraseRootFromParent_Done,
     /*  776213 */   // Label 12070: @776213
     /*  776213 */   GIM_Try, /*On fail goto*//*Label 12071*/ GIMT_Encode4(776291), // Rule ID 14634 //
     /*  776218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  776229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  776232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  776235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  776238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776264 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  776267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776289 */     GIR_RootConstrainSelectedInstOperands,
     /*  776290 */     // GIR_Coverage, 14634,
     /*  776290 */     GIR_EraseRootFromParent_Done,
     /*  776291 */   // Label 12071: @776291
     /*  776291 */   GIM_Try, /*On fail goto*//*Label 12072*/ GIMT_Encode4(776369), // Rule ID 14635 //
     /*  776296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  776307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  776310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  776313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  776316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776342 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  776345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776367 */     GIR_RootConstrainSelectedInstOperands,
     /*  776368 */     // GIR_Coverage, 14635,
     /*  776368 */     GIR_EraseRootFromParent_Done,
     /*  776369 */   // Label 12072: @776369
     /*  776369 */   GIM_Try, /*On fail goto*//*Label 12073*/ GIMT_Encode4(776447), // Rule ID 14638 //
     /*  776374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  776385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  776388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  776391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  776394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  776423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776445 */     GIR_RootConstrainSelectedInstOperands,
     /*  776446 */     // GIR_Coverage, 14638,
     /*  776446 */     GIR_EraseRootFromParent_Done,
     /*  776447 */   // Label 12073: @776447
     /*  776447 */   GIM_Try, /*On fail goto*//*Label 12074*/ GIMT_Encode4(776525), // Rule ID 14639 //
     /*  776452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  776463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  776466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  776469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  776472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776498 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  776501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776523 */     GIR_RootConstrainSelectedInstOperands,
     /*  776524 */     // GIR_Coverage, 14639,
     /*  776524 */     GIR_EraseRootFromParent_Done,
     /*  776525 */   // Label 12074: @776525
     /*  776525 */   GIM_Try, /*On fail goto*//*Label 12075*/ GIMT_Encode4(776603), // Rule ID 14642 //
     /*  776530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  776541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  776544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  776547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  776550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776576 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  776579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776601 */     GIR_RootConstrainSelectedInstOperands,
     /*  776602 */     // GIR_Coverage, 14642,
     /*  776602 */     GIR_EraseRootFromParent_Done,
     /*  776603 */   // Label 12075: @776603
     /*  776603 */   GIM_Try, /*On fail goto*//*Label 12076*/ GIMT_Encode4(776681), // Rule ID 14643 //
     /*  776608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  776619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  776622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  776625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  776628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776654 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  776657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776679 */     GIR_RootConstrainSelectedInstOperands,
     /*  776680 */     // GIR_Coverage, 14643,
     /*  776680 */     GIR_EraseRootFromParent_Done,
     /*  776681 */   // Label 12076: @776681
     /*  776681 */   GIM_Try, /*On fail goto*//*Label 12077*/ GIMT_Encode4(776759), // Rule ID 14646 //
     /*  776686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  776697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  776700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  776703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  776706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776732 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  776735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776757 */     GIR_RootConstrainSelectedInstOperands,
     /*  776758 */     // GIR_Coverage, 14646,
     /*  776758 */     GIR_EraseRootFromParent_Done,
     /*  776759 */   // Label 12077: @776759
     /*  776759 */   GIM_Try, /*On fail goto*//*Label 12078*/ GIMT_Encode4(776837), // Rule ID 14647 //
     /*  776764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  776775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  776778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  776781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  776784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776810 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  776813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776835 */     GIR_RootConstrainSelectedInstOperands,
     /*  776836 */     // GIR_Coverage, 14647,
     /*  776836 */     GIR_EraseRootFromParent_Done,
     /*  776837 */   // Label 12078: @776837
     /*  776837 */   GIM_Try, /*On fail goto*//*Label 12079*/ GIMT_Encode4(776915), // Rule ID 14650 //
     /*  776842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  776845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  776853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  776856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  776859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  776862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776888 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  776888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  776891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776913 */     GIR_RootConstrainSelectedInstOperands,
     /*  776914 */     // GIR_Coverage, 14650,
     /*  776914 */     GIR_EraseRootFromParent_Done,
     /*  776915 */   // Label 12079: @776915
     /*  776915 */   GIM_Try, /*On fail goto*//*Label 12080*/ GIMT_Encode4(776993), // Rule ID 14651 //
     /*  776920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  776923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  776931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  776934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  776937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  776940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776966 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  776966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  776969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776991 */     GIR_RootConstrainSelectedInstOperands,
     /*  776992 */     // GIR_Coverage, 14651,
     /*  776992 */     GIR_EraseRootFromParent_Done,
     /*  776993 */   // Label 12080: @776993
     /*  776993 */   GIM_Try, /*On fail goto*//*Label 12081*/ GIMT_Encode4(777071), // Rule ID 14654 //
     /*  776998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  777001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  777009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  777012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  777015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  777018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777044 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  777044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  777047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777069 */     GIR_RootConstrainSelectedInstOperands,
     /*  777070 */     // GIR_Coverage, 14654,
     /*  777070 */     GIR_EraseRootFromParent_Done,
     /*  777071 */   // Label 12081: @777071
     /*  777071 */   GIM_Try, /*On fail goto*//*Label 12082*/ GIMT_Encode4(777149), // Rule ID 14655 //
     /*  777076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  777079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  777087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  777090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  777093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  777096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777122 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  777122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  777125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777147 */     GIR_RootConstrainSelectedInstOperands,
     /*  777148 */     // GIR_Coverage, 14655,
     /*  777148 */     GIR_EraseRootFromParent_Done,
     /*  777149 */   // Label 12082: @777149
     /*  777149 */   GIM_Try, /*On fail goto*//*Label 12083*/ GIMT_Encode4(777227), // Rule ID 14658 //
     /*  777154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  777157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  777165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  777168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  777171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  777174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777200 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  777200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  777203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777225 */     GIR_RootConstrainSelectedInstOperands,
     /*  777226 */     // GIR_Coverage, 14658,
     /*  777226 */     GIR_EraseRootFromParent_Done,
     /*  777227 */   // Label 12083: @777227
     /*  777227 */   GIM_Try, /*On fail goto*//*Label 12084*/ GIMT_Encode4(777305), // Rule ID 14659 //
     /*  777232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  777235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  777243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  777246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  777249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  777252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777278 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  777278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  777281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777303 */     GIR_RootConstrainSelectedInstOperands,
     /*  777304 */     // GIR_Coverage, 14659,
     /*  777304 */     GIR_EraseRootFromParent_Done,
     /*  777305 */   // Label 12084: @777305
     /*  777305 */   GIM_Try, /*On fail goto*//*Label 12085*/ GIMT_Encode4(777383), // Rule ID 14662 //
     /*  777310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  777321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  777324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  777327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777356 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  777359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777381 */     GIR_RootConstrainSelectedInstOperands,
     /*  777382 */     // GIR_Coverage, 14662,
     /*  777382 */     GIR_EraseRootFromParent_Done,
     /*  777383 */   // Label 12085: @777383
     /*  777383 */   GIM_Try, /*On fail goto*//*Label 12086*/ GIMT_Encode4(777461), // Rule ID 14663 //
     /*  777388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  777399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  777402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  777405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  777408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777434 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  777437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777459 */     GIR_RootConstrainSelectedInstOperands,
     /*  777460 */     // GIR_Coverage, 14663,
     /*  777460 */     GIR_EraseRootFromParent_Done,
     /*  777461 */   // Label 12086: @777461
     /*  777461 */   GIM_Try, /*On fail goto*//*Label 12087*/ GIMT_Encode4(777539), // Rule ID 14666 //
     /*  777466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  777477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  777480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  777483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777512 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  777515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777537 */     GIR_RootConstrainSelectedInstOperands,
     /*  777538 */     // GIR_Coverage, 14666,
     /*  777538 */     GIR_EraseRootFromParent_Done,
     /*  777539 */   // Label 12087: @777539
     /*  777539 */   GIM_Try, /*On fail goto*//*Label 12088*/ GIMT_Encode4(777617), // Rule ID 14667 //
     /*  777544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  777555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  777558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  777561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  777564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777590 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  777593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777615 */     GIR_RootConstrainSelectedInstOperands,
     /*  777616 */     // GIR_Coverage, 14667,
     /*  777616 */     GIR_EraseRootFromParent_Done,
     /*  777617 */   // Label 12088: @777617
     /*  777617 */   GIM_Try, /*On fail goto*//*Label 12089*/ GIMT_Encode4(777695), // Rule ID 14670 //
     /*  777622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  777633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  777636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  777639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777668 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  777671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777693 */     GIR_RootConstrainSelectedInstOperands,
     /*  777694 */     // GIR_Coverage, 14670,
     /*  777694 */     GIR_EraseRootFromParent_Done,
     /*  777695 */   // Label 12089: @777695
     /*  777695 */   GIM_Try, /*On fail goto*//*Label 12090*/ GIMT_Encode4(777773), // Rule ID 14671 //
     /*  777700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  777711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  777714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  777717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  777720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777746 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  777749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777771 */     GIR_RootConstrainSelectedInstOperands,
     /*  777772 */     // GIR_Coverage, 14671,
     /*  777772 */     GIR_EraseRootFromParent_Done,
     /*  777773 */   // Label 12090: @777773
     /*  777773 */   GIM_Try, /*On fail goto*//*Label 12091*/ GIMT_Encode4(777851), // Rule ID 14674 //
     /*  777778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  777789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  777792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  777795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777824 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  777827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777849 */     GIR_RootConstrainSelectedInstOperands,
     /*  777850 */     // GIR_Coverage, 14674,
     /*  777850 */     GIR_EraseRootFromParent_Done,
     /*  777851 */   // Label 12091: @777851
     /*  777851 */   GIM_Try, /*On fail goto*//*Label 12092*/ GIMT_Encode4(777929), // Rule ID 14675 //
     /*  777856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  777867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  777870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  777873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  777876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777902 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  777902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  777905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777927 */     GIR_RootConstrainSelectedInstOperands,
     /*  777928 */     // GIR_Coverage, 14675,
     /*  777928 */     GIR_EraseRootFromParent_Done,
     /*  777929 */   // Label 12092: @777929
     /*  777929 */   GIM_Try, /*On fail goto*//*Label 12093*/ GIMT_Encode4(778007), // Rule ID 14678 //
     /*  777934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  777945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  777948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  777951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777980 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  777983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778005 */     GIR_RootConstrainSelectedInstOperands,
     /*  778006 */     // GIR_Coverage, 14678,
     /*  778006 */     GIR_EraseRootFromParent_Done,
     /*  778007 */   // Label 12093: @778007
     /*  778007 */   GIM_Try, /*On fail goto*//*Label 12094*/ GIMT_Encode4(778085), // Rule ID 14679 //
     /*  778012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  778023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  778026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  778029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778058 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  778058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  778061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778080 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778083 */     GIR_RootConstrainSelectedInstOperands,
     /*  778084 */     // GIR_Coverage, 14679,
     /*  778084 */     GIR_EraseRootFromParent_Done,
     /*  778085 */   // Label 12094: @778085
     /*  778085 */   GIM_Try, /*On fail goto*//*Label 12095*/ GIMT_Encode4(778163), // Rule ID 14682 //
     /*  778090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  778101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  778104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  778107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  778110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778136 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  778136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  778139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778161 */     GIR_RootConstrainSelectedInstOperands,
     /*  778162 */     // GIR_Coverage, 14682,
     /*  778162 */     GIR_EraseRootFromParent_Done,
     /*  778163 */   // Label 12095: @778163
     /*  778163 */   GIM_Try, /*On fail goto*//*Label 12096*/ GIMT_Encode4(778241), // Rule ID 14683 //
     /*  778168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  778179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  778182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  778185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778214 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  778214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  778217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778239 */     GIR_RootConstrainSelectedInstOperands,
     /*  778240 */     // GIR_Coverage, 14683,
     /*  778240 */     GIR_EraseRootFromParent_Done,
     /*  778241 */   // Label 12096: @778241
     /*  778241 */   GIM_Try, /*On fail goto*//*Label 12097*/ GIMT_Encode4(778319), // Rule ID 14686 //
     /*  778246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  778257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  778260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  778263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  778266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778292 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778317 */     GIR_RootConstrainSelectedInstOperands,
     /*  778318 */     // GIR_Coverage, 14686,
     /*  778318 */     GIR_EraseRootFromParent_Done,
     /*  778319 */   // Label 12097: @778319
     /*  778319 */   GIM_Try, /*On fail goto*//*Label 12098*/ GIMT_Encode4(778397), // Rule ID 14687 //
     /*  778324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  778335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  778338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  778341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778370 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11596:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778395 */     GIR_RootConstrainSelectedInstOperands,
     /*  778396 */     // GIR_Coverage, 14687,
     /*  778396 */     GIR_EraseRootFromParent_Done,
     /*  778397 */   // Label 12098: @778397
     /*  778397 */   GIM_Try, /*On fail goto*//*Label 12099*/ GIMT_Encode4(778475), // Rule ID 14690 //
     /*  778402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  778413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  778416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  778419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  778422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  778448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778473 */     GIR_RootConstrainSelectedInstOperands,
     /*  778474 */     // GIR_Coverage, 14690,
     /*  778474 */     GIR_EraseRootFromParent_Done,
     /*  778475 */   // Label 12099: @778475
     /*  778475 */   GIM_Try, /*On fail goto*//*Label 12100*/ GIMT_Encode4(778553), // Rule ID 14691 //
     /*  778480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  778491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  778494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  778497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778526 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  778526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778551 */     GIR_RootConstrainSelectedInstOperands,
     /*  778552 */     // GIR_Coverage, 14691,
     /*  778552 */     GIR_EraseRootFromParent_Done,
     /*  778553 */   // Label 12100: @778553
     /*  778553 */   GIM_Try, /*On fail goto*//*Label 12101*/ GIMT_Encode4(778631), // Rule ID 14694 //
     /*  778558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  778569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  778572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  778575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  778578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778604 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  778604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778629 */     GIR_RootConstrainSelectedInstOperands,
     /*  778630 */     // GIR_Coverage, 14694,
     /*  778630 */     GIR_EraseRootFromParent_Done,
     /*  778631 */   // Label 12101: @778631
     /*  778631 */   GIM_Try, /*On fail goto*//*Label 12102*/ GIMT_Encode4(778709), // Rule ID 14695 //
     /*  778636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  778647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  778650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  778653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  778682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778707 */     GIR_RootConstrainSelectedInstOperands,
     /*  778708 */     // GIR_Coverage, 14695,
     /*  778708 */     GIR_EraseRootFromParent_Done,
     /*  778709 */   // Label 12102: @778709
     /*  778709 */   GIM_Try, /*On fail goto*//*Label 12103*/ GIMT_Encode4(778787), // Rule ID 14698 //
     /*  778714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  778717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  778725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  778728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  778731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  778734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  778760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778782 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778785 */     GIR_RootConstrainSelectedInstOperands,
     /*  778786 */     // GIR_Coverage, 14698,
     /*  778786 */     GIR_EraseRootFromParent_Done,
     /*  778787 */   // Label 12103: @778787
     /*  778787 */   GIM_Try, /*On fail goto*//*Label 12104*/ GIMT_Encode4(778865), // Rule ID 14699 //
     /*  778792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  778795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  778803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  778806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  778809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778838 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  778838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778863 */     GIR_RootConstrainSelectedInstOperands,
     /*  778864 */     // GIR_Coverage, 14699,
     /*  778864 */     GIR_EraseRootFromParent_Done,
     /*  778865 */   // Label 12104: @778865
     /*  778865 */   GIM_Try, /*On fail goto*//*Label 12105*/ GIMT_Encode4(778943), // Rule ID 14702 //
     /*  778870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  778881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  778884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  778887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  778890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778916 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  778919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778938 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778941 */     GIR_RootConstrainSelectedInstOperands,
     /*  778942 */     // GIR_Coverage, 14702,
     /*  778942 */     GIR_EraseRootFromParent_Done,
     /*  778943 */   // Label 12105: @778943
     /*  778943 */   GIM_Try, /*On fail goto*//*Label 12106*/ GIMT_Encode4(779021), // Rule ID 14703 //
     /*  778948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  778959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  778962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  778965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778994 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  778997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779019 */     GIR_RootConstrainSelectedInstOperands,
     /*  779020 */     // GIR_Coverage, 14703,
     /*  779020 */     GIR_EraseRootFromParent_Done,
     /*  779021 */   // Label 12106: @779021
     /*  779021 */   GIM_Try, /*On fail goto*//*Label 12107*/ GIMT_Encode4(779099), // Rule ID 14706 //
     /*  779026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  779037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  779040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  779043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779072 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  779072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  779075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779097 */     GIR_RootConstrainSelectedInstOperands,
     /*  779098 */     // GIR_Coverage, 14706,
     /*  779098 */     GIR_EraseRootFromParent_Done,
     /*  779099 */   // Label 12107: @779099
     /*  779099 */   GIM_Try, /*On fail goto*//*Label 12108*/ GIMT_Encode4(779177), // Rule ID 14707 //
     /*  779104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  779115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  779118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  779121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  779124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779150 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  779150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  779153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779175 */     GIR_RootConstrainSelectedInstOperands,
     /*  779176 */     // GIR_Coverage, 14707,
     /*  779176 */     GIR_EraseRootFromParent_Done,
     /*  779177 */   // Label 12108: @779177
     /*  779177 */   GIM_Try, /*On fail goto*//*Label 12109*/ GIMT_Encode4(779255), // Rule ID 14710 //
     /*  779182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  779193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  779196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  779199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779228 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  779228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  779231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779253 */     GIR_RootConstrainSelectedInstOperands,
     /*  779254 */     // GIR_Coverage, 14710,
     /*  779254 */     GIR_EraseRootFromParent_Done,
     /*  779255 */   // Label 12109: @779255
     /*  779255 */   GIM_Try, /*On fail goto*//*Label 12110*/ GIMT_Encode4(779333), // Rule ID 14711 //
     /*  779260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  779271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  779274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  779277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  779280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779306 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  779306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  779309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779331 */     GIR_RootConstrainSelectedInstOperands,
     /*  779332 */     // GIR_Coverage, 14711,
     /*  779332 */     GIR_EraseRootFromParent_Done,
     /*  779333 */   // Label 12110: @779333
     /*  779333 */   GIM_Try, /*On fail goto*//*Label 12111*/ GIMT_Encode4(779411), // Rule ID 14714 //
     /*  779338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  779349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  779352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  779355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  779387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779409 */     GIR_RootConstrainSelectedInstOperands,
     /*  779410 */     // GIR_Coverage, 14714,
     /*  779410 */     GIR_EraseRootFromParent_Done,
     /*  779411 */   // Label 12111: @779411
     /*  779411 */   GIM_Try, /*On fail goto*//*Label 12112*/ GIMT_Encode4(779489), // Rule ID 14715 //
     /*  779416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  779427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  779430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  779433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  779436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779462 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  779465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779487 */     GIR_RootConstrainSelectedInstOperands,
     /*  779488 */     // GIR_Coverage, 14715,
     /*  779488 */     GIR_EraseRootFromParent_Done,
     /*  779489 */   // Label 12112: @779489
     /*  779489 */   GIM_Try, /*On fail goto*//*Label 12113*/ GIMT_Encode4(779567), // Rule ID 14718 //
     /*  779494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  779505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  779508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  779511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779540 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  779543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779565 */     GIR_RootConstrainSelectedInstOperands,
     /*  779566 */     // GIR_Coverage, 14718,
     /*  779566 */     GIR_EraseRootFromParent_Done,
     /*  779567 */   // Label 12113: @779567
     /*  779567 */   GIM_Try, /*On fail goto*//*Label 12114*/ GIMT_Encode4(779645), // Rule ID 14719 //
     /*  779572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  779583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  779586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  779589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  779592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779618 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  779621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779643 */     GIR_RootConstrainSelectedInstOperands,
     /*  779644 */     // GIR_Coverage, 14719,
     /*  779644 */     GIR_EraseRootFromParent_Done,
     /*  779645 */   // Label 12114: @779645
     /*  779645 */   GIM_Try, /*On fail goto*//*Label 12115*/ GIMT_Encode4(779723), // Rule ID 14722 //
     /*  779650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  779661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  779664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  779667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779696 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  779699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779721 */     GIR_RootConstrainSelectedInstOperands,
     /*  779722 */     // GIR_Coverage, 14722,
     /*  779722 */     GIR_EraseRootFromParent_Done,
     /*  779723 */   // Label 12115: @779723
     /*  779723 */   GIM_Try, /*On fail goto*//*Label 12116*/ GIMT_Encode4(779801), // Rule ID 14723 //
     /*  779728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  779739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  779742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  779745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  779748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779774 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  779777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779799 */     GIR_RootConstrainSelectedInstOperands,
     /*  779800 */     // GIR_Coverage, 14723,
     /*  779800 */     GIR_EraseRootFromParent_Done,
     /*  779801 */   // Label 12116: @779801
     /*  779801 */   GIM_Try, /*On fail goto*//*Label 12117*/ GIMT_Encode4(779879), // Rule ID 14726 //
     /*  779806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  779817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  779820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  779823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  779852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  779855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779877 */     GIR_RootConstrainSelectedInstOperands,
     /*  779878 */     // GIR_Coverage, 14726,
     /*  779878 */     GIR_EraseRootFromParent_Done,
     /*  779879 */   // Label 12117: @779879
     /*  779879 */   GIM_Try, /*On fail goto*//*Label 12118*/ GIMT_Encode4(779957), // Rule ID 14727 //
     /*  779884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  779895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  779898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  779901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  779904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  779930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  779933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779955 */     GIR_RootConstrainSelectedInstOperands,
     /*  779956 */     // GIR_Coverage, 14727,
     /*  779956 */     GIR_EraseRootFromParent_Done,
     /*  779957 */   // Label 12118: @779957
     /*  779957 */   GIM_Try, /*On fail goto*//*Label 12119*/ GIMT_Encode4(780035), // Rule ID 14730 //
     /*  779962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  779973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  779976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  779979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780008 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  780008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  780011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780033 */     GIR_RootConstrainSelectedInstOperands,
     /*  780034 */     // GIR_Coverage, 14730,
     /*  780034 */     GIR_EraseRootFromParent_Done,
     /*  780035 */   // Label 12119: @780035
     /*  780035 */   GIM_Try, /*On fail goto*//*Label 12120*/ GIMT_Encode4(780113), // Rule ID 14731 //
     /*  780040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  780051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  780054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  780057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780086 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  780086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  780089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780111 */     GIR_RootConstrainSelectedInstOperands,
     /*  780112 */     // GIR_Coverage, 14731,
     /*  780112 */     GIR_EraseRootFromParent_Done,
     /*  780113 */   // Label 12120: @780113
     /*  780113 */   GIM_Try, /*On fail goto*//*Label 12121*/ GIMT_Encode4(780191), // Rule ID 14734 //
     /*  780118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  780129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  780132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  780135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780164 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  780164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  780167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780189 */     GIR_RootConstrainSelectedInstOperands,
     /*  780190 */     // GIR_Coverage, 14734,
     /*  780190 */     GIR_EraseRootFromParent_Done,
     /*  780191 */   // Label 12121: @780191
     /*  780191 */   GIM_Try, /*On fail goto*//*Label 12122*/ GIMT_Encode4(780269), // Rule ID 14735 //
     /*  780196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  780207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  780210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  780213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780242 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  780242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  780245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780267 */     GIR_RootConstrainSelectedInstOperands,
     /*  780268 */     // GIR_Coverage, 14735,
     /*  780268 */     GIR_EraseRootFromParent_Done,
     /*  780269 */   // Label 12122: @780269
     /*  780269 */   GIM_Try, /*On fail goto*//*Label 12123*/ GIMT_Encode4(780347), // Rule ID 14738 //
     /*  780274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  780285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  780288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  780291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  780323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780345 */     GIR_RootConstrainSelectedInstOperands,
     /*  780346 */     // GIR_Coverage, 14738,
     /*  780346 */     GIR_EraseRootFromParent_Done,
     /*  780347 */   // Label 12123: @780347
     /*  780347 */   GIM_Try, /*On fail goto*//*Label 12124*/ GIMT_Encode4(780425), // Rule ID 14739 //
     /*  780352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  780363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  780366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  780369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  780401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780423 */     GIR_RootConstrainSelectedInstOperands,
     /*  780424 */     // GIR_Coverage, 14739,
     /*  780424 */     GIR_EraseRootFromParent_Done,
     /*  780425 */   // Label 12124: @780425
     /*  780425 */   GIM_Try, /*On fail goto*//*Label 12125*/ GIMT_Encode4(780503), // Rule ID 14742 //
     /*  780430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  780441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  780444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  780447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780476 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  780479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780501 */     GIR_RootConstrainSelectedInstOperands,
     /*  780502 */     // GIR_Coverage, 14742,
     /*  780502 */     GIR_EraseRootFromParent_Done,
     /*  780503 */   // Label 12125: @780503
     /*  780503 */   GIM_Try, /*On fail goto*//*Label 12126*/ GIMT_Encode4(780581), // Rule ID 14743 //
     /*  780508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  780519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  780522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  780525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780554 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  780557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780579 */     GIR_RootConstrainSelectedInstOperands,
     /*  780580 */     // GIR_Coverage, 14743,
     /*  780580 */     GIR_EraseRootFromParent_Done,
     /*  780581 */   // Label 12126: @780581
     /*  780581 */   GIM_Try, /*On fail goto*//*Label 12127*/ GIMT_Encode4(780659), // Rule ID 14746 //
     /*  780586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  780597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  780600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  780603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780632 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  780635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780657 */     GIR_RootConstrainSelectedInstOperands,
     /*  780658 */     // GIR_Coverage, 14746,
     /*  780658 */     GIR_EraseRootFromParent_Done,
     /*  780659 */   // Label 12127: @780659
     /*  780659 */   GIM_Try, /*On fail goto*//*Label 12128*/ GIMT_Encode4(780737), // Rule ID 14747 //
     /*  780664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  780675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  780678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  780681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780710 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  780713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780735 */     GIR_RootConstrainSelectedInstOperands,
     /*  780736 */     // GIR_Coverage, 14747,
     /*  780736 */     GIR_EraseRootFromParent_Done,
     /*  780737 */   // Label 12128: @780737
     /*  780737 */   GIM_Try, /*On fail goto*//*Label 12129*/ GIMT_Encode4(780815), // Rule ID 14750 //
     /*  780742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  780753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  780756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  780759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  780762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780788 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  780791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780813 */     GIR_RootConstrainSelectedInstOperands,
     /*  780814 */     // GIR_Coverage, 14750,
     /*  780814 */     GIR_EraseRootFromParent_Done,
     /*  780815 */   // Label 12129: @780815
     /*  780815 */   GIM_Try, /*On fail goto*//*Label 12130*/ GIMT_Encode4(780893), // Rule ID 14751 //
     /*  780820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  780831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  780834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  780837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  780840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780866 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  780866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  780869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780891 */     GIR_RootConstrainSelectedInstOperands,
     /*  780892 */     // GIR_Coverage, 14751,
     /*  780892 */     GIR_EraseRootFromParent_Done,
     /*  780893 */   // Label 12130: @780893
     /*  780893 */   GIM_Try, /*On fail goto*//*Label 12131*/ GIMT_Encode4(780971), // Rule ID 14754 //
     /*  780898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  780909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  780912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  780915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  780918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780944 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  780947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780966 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780969 */     GIR_RootConstrainSelectedInstOperands,
     /*  780970 */     // GIR_Coverage, 14754,
     /*  780970 */     GIR_EraseRootFromParent_Done,
     /*  780971 */   // Label 12131: @780971
     /*  780971 */   GIM_Try, /*On fail goto*//*Label 12132*/ GIMT_Encode4(781049), // Rule ID 14755 //
     /*  780976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  780987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  780990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  780993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  780996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781022 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  781025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781047 */     GIR_RootConstrainSelectedInstOperands,
     /*  781048 */     // GIR_Coverage, 14755,
     /*  781048 */     GIR_EraseRootFromParent_Done,
     /*  781049 */   // Label 12132: @781049
     /*  781049 */   GIM_Try, /*On fail goto*//*Label 12133*/ GIMT_Encode4(781127), // Rule ID 14758 //
     /*  781054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  781065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  781068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  781071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  781074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781100 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  781103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781125 */     GIR_RootConstrainSelectedInstOperands,
     /*  781126 */     // GIR_Coverage, 14758,
     /*  781126 */     GIR_EraseRootFromParent_Done,
     /*  781127 */   // Label 12133: @781127
     /*  781127 */   GIM_Try, /*On fail goto*//*Label 12134*/ GIMT_Encode4(781205), // Rule ID 14759 //
     /*  781132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  781143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  781146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  781149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  781152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781178 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  781181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781203 */     GIR_RootConstrainSelectedInstOperands,
     /*  781204 */     // GIR_Coverage, 14759,
     /*  781204 */     GIR_EraseRootFromParent_Done,
     /*  781205 */   // Label 12134: @781205
     /*  781205 */   GIM_Try, /*On fail goto*//*Label 12135*/ GIMT_Encode4(781283), // Rule ID 14762 //
     /*  781210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  781221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  781224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  781227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  781230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781256 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  781259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781281 */     GIR_RootConstrainSelectedInstOperands,
     /*  781282 */     // GIR_Coverage, 14762,
     /*  781282 */     GIR_EraseRootFromParent_Done,
     /*  781283 */   // Label 12135: @781283
     /*  781283 */   GIM_Try, /*On fail goto*//*Label 12136*/ GIMT_Encode4(781361), // Rule ID 14763 //
     /*  781288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  781299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  781302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  781305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  781308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781334 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  781337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781359 */     GIR_RootConstrainSelectedInstOperands,
     /*  781360 */     // GIR_Coverage, 14763,
     /*  781360 */     GIR_EraseRootFromParent_Done,
     /*  781361 */   // Label 12136: @781361
     /*  781361 */   GIM_Try, /*On fail goto*//*Label 12137*/ GIMT_Encode4(781439), // Rule ID 14766 //
     /*  781366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  781377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  781380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  781383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  781386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781412 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  781415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781437 */     GIR_RootConstrainSelectedInstOperands,
     /*  781438 */     // GIR_Coverage, 14766,
     /*  781438 */     GIR_EraseRootFromParent_Done,
     /*  781439 */   // Label 12137: @781439
     /*  781439 */   GIM_Try, /*On fail goto*//*Label 12138*/ GIMT_Encode4(781517), // Rule ID 14767 //
     /*  781444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  781455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  781458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  781461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  781464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781490 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  781493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781515 */     GIR_RootConstrainSelectedInstOperands,
     /*  781516 */     // GIR_Coverage, 14767,
     /*  781516 */     GIR_EraseRootFromParent_Done,
     /*  781517 */   // Label 12138: @781517
     /*  781517 */   GIM_Try, /*On fail goto*//*Label 12139*/ GIMT_Encode4(781595), // Rule ID 14770 //
     /*  781522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  781542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  781568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  781571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781593 */     GIR_RootConstrainSelectedInstOperands,
     /*  781594 */     // GIR_Coverage, 14770,
     /*  781594 */     GIR_EraseRootFromParent_Done,
     /*  781595 */   // Label 12139: @781595
     /*  781595 */   GIM_Try, /*On fail goto*//*Label 12140*/ GIMT_Encode4(781673), // Rule ID 14771 //
     /*  781600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  781620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  781646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  781649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781671 */     GIR_RootConstrainSelectedInstOperands,
     /*  781672 */     // GIR_Coverage, 14771,
     /*  781672 */     GIR_EraseRootFromParent_Done,
     /*  781673 */   // Label 12140: @781673
     /*  781673 */   GIM_Try, /*On fail goto*//*Label 12141*/ GIMT_Encode4(781751), // Rule ID 14774 //
     /*  781678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  781689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  781692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  781695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  781698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781724 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  781727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781749 */     GIR_RootConstrainSelectedInstOperands,
     /*  781750 */     // GIR_Coverage, 14774,
     /*  781750 */     GIR_EraseRootFromParent_Done,
     /*  781751 */   // Label 12141: @781751
     /*  781751 */   GIM_Try, /*On fail goto*//*Label 12142*/ GIMT_Encode4(781829), // Rule ID 14775 //
     /*  781756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  781767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  781770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  781773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  781776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  781805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781827 */     GIR_RootConstrainSelectedInstOperands,
     /*  781828 */     // GIR_Coverage, 14775,
     /*  781828 */     GIR_EraseRootFromParent_Done,
     /*  781829 */   // Label 12142: @781829
     /*  781829 */   GIM_Try, /*On fail goto*//*Label 12143*/ GIMT_Encode4(781907), // Rule ID 14778 //
     /*  781834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  781845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  781848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  781851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  781854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781880 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  781883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781902 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781905 */     GIR_RootConstrainSelectedInstOperands,
     /*  781906 */     // GIR_Coverage, 14778,
     /*  781906 */     GIR_EraseRootFromParent_Done,
     /*  781907 */   // Label 12143: @781907
     /*  781907 */   GIM_Try, /*On fail goto*//*Label 12144*/ GIMT_Encode4(781985), // Rule ID 14779 //
     /*  781912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  781923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  781926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  781929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  781932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781958 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  781961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781983 */     GIR_RootConstrainSelectedInstOperands,
     /*  781984 */     // GIR_Coverage, 14779,
     /*  781984 */     GIR_EraseRootFromParent_Done,
     /*  781985 */   // Label 12144: @781985
     /*  781985 */   GIM_Try, /*On fail goto*//*Label 12145*/ GIMT_Encode4(782063), // Rule ID 14782 //
     /*  781990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  782001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  782004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  782007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  782010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782036 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  782036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  782039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782061 */     GIR_RootConstrainSelectedInstOperands,
     /*  782062 */     // GIR_Coverage, 14782,
     /*  782062 */     GIR_EraseRootFromParent_Done,
     /*  782063 */   // Label 12145: @782063
     /*  782063 */   GIM_Try, /*On fail goto*//*Label 12146*/ GIMT_Encode4(782141), // Rule ID 14783 //
     /*  782068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  782079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  782082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  782085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  782088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  782114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  782117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782139 */     GIR_RootConstrainSelectedInstOperands,
     /*  782140 */     // GIR_Coverage, 14783,
     /*  782140 */     GIR_EraseRootFromParent_Done,
     /*  782141 */   // Label 12146: @782141
     /*  782141 */   GIM_Try, /*On fail goto*//*Label 12147*/ GIMT_Encode4(782219), // Rule ID 14786 //
     /*  782146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  782149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  782157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  782160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  782163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  782166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782192 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  782192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  782195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782217 */     GIR_RootConstrainSelectedInstOperands,
     /*  782218 */     // GIR_Coverage, 14786,
     /*  782218 */     GIR_EraseRootFromParent_Done,
     /*  782219 */   // Label 12147: @782219
     /*  782219 */   GIM_Try, /*On fail goto*//*Label 12148*/ GIMT_Encode4(782297), // Rule ID 14787 //
     /*  782224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  782227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  782235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  782238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  782241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  782244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782270 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  782270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  782273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782295 */     GIR_RootConstrainSelectedInstOperands,
     /*  782296 */     // GIR_Coverage, 14787,
     /*  782296 */     GIR_EraseRootFromParent_Done,
     /*  782297 */   // Label 12148: @782297
     /*  782297 */   GIM_Try, /*On fail goto*//*Label 12149*/ GIMT_Encode4(782375), // Rule ID 14790 //
     /*  782302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  782313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  782316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  782319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  782322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782348 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  782351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782373 */     GIR_RootConstrainSelectedInstOperands,
     /*  782374 */     // GIR_Coverage, 14790,
     /*  782374 */     GIR_EraseRootFromParent_Done,
     /*  782375 */   // Label 12149: @782375
     /*  782375 */   GIM_Try, /*On fail goto*//*Label 12150*/ GIMT_Encode4(782453), // Rule ID 14791 //
     /*  782380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  782391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  782394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  782397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  782400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782426 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  782429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782448 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782451 */     GIR_RootConstrainSelectedInstOperands,
     /*  782452 */     // GIR_Coverage, 14791,
     /*  782452 */     GIR_EraseRootFromParent_Done,
     /*  782453 */   // Label 12150: @782453
     /*  782453 */   GIM_Try, /*On fail goto*//*Label 12151*/ GIMT_Encode4(782531), // Rule ID 14794 //
     /*  782458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  782469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  782472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  782475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  782478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782504 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  782507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782529 */     GIR_RootConstrainSelectedInstOperands,
     /*  782530 */     // GIR_Coverage, 14794,
     /*  782530 */     GIR_EraseRootFromParent_Done,
     /*  782531 */   // Label 12151: @782531
     /*  782531 */   GIM_Try, /*On fail goto*//*Label 12152*/ GIMT_Encode4(782609), // Rule ID 14795 //
     /*  782536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  782547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  782550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  782553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  782556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782582 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  782585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782607 */     GIR_RootConstrainSelectedInstOperands,
     /*  782608 */     // GIR_Coverage, 14795,
     /*  782608 */     GIR_EraseRootFromParent_Done,
     /*  782609 */   // Label 12152: @782609
     /*  782609 */   GIM_Try, /*On fail goto*//*Label 12153*/ GIMT_Encode4(782687), // Rule ID 14798 //
     /*  782614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  782625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  782628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  782631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  782634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782660 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  782663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782685 */     GIR_RootConstrainSelectedInstOperands,
     /*  782686 */     // GIR_Coverage, 14798,
     /*  782686 */     GIR_EraseRootFromParent_Done,
     /*  782687 */   // Label 12153: @782687
     /*  782687 */   GIM_Try, /*On fail goto*//*Label 12154*/ GIMT_Encode4(782765), // Rule ID 14799 //
     /*  782692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  782703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  782706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  782709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  782712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782738 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  782741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782763 */     GIR_RootConstrainSelectedInstOperands,
     /*  782764 */     // GIR_Coverage, 14799,
     /*  782764 */     GIR_EraseRootFromParent_Done,
     /*  782765 */   // Label 12154: @782765
     /*  782765 */   GIM_Try, /*On fail goto*//*Label 12155*/ GIMT_Encode4(782843), // Rule ID 14802 //
     /*  782770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  782781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  782784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  782787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  782790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782816 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  782819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782841 */     GIR_RootConstrainSelectedInstOperands,
     /*  782842 */     // GIR_Coverage, 14802,
     /*  782842 */     GIR_EraseRootFromParent_Done,
     /*  782843 */   // Label 12155: @782843
     /*  782843 */   GIM_Try, /*On fail goto*//*Label 12156*/ GIMT_Encode4(782921), // Rule ID 14803 //
     /*  782848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  782859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  782862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  782865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  782868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  782897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782919 */     GIR_RootConstrainSelectedInstOperands,
     /*  782920 */     // GIR_Coverage, 14803,
     /*  782920 */     GIR_EraseRootFromParent_Done,
     /*  782921 */   // Label 12156: @782921
     /*  782921 */   GIM_Try, /*On fail goto*//*Label 12157*/ GIMT_Encode4(782999), // Rule ID 14806 //
     /*  782926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  782937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  782940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  782943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  782946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782972 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  782975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782997 */     GIR_RootConstrainSelectedInstOperands,
     /*  782998 */     // GIR_Coverage, 14806,
     /*  782998 */     GIR_EraseRootFromParent_Done,
     /*  782999 */   // Label 12157: @782999
     /*  782999 */   GIM_Try, /*On fail goto*//*Label 12158*/ GIMT_Encode4(783077), // Rule ID 14807 //
     /*  783004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  783015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  783018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  783021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  783024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783050 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  783050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  783053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783075 */     GIR_RootConstrainSelectedInstOperands,
     /*  783076 */     // GIR_Coverage, 14807,
     /*  783076 */     GIR_EraseRootFromParent_Done,
     /*  783077 */   // Label 12158: @783077
     /*  783077 */   GIM_Try, /*On fail goto*//*Label 12159*/ GIMT_Encode4(783155), // Rule ID 14810 //
     /*  783082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  783093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  783096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  783099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  783102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783128 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  783128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  783131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783153 */     GIR_RootConstrainSelectedInstOperands,
     /*  783154 */     // GIR_Coverage, 14810,
     /*  783154 */     GIR_EraseRootFromParent_Done,
     /*  783155 */   // Label 12159: @783155
     /*  783155 */   GIM_Try, /*On fail goto*//*Label 12160*/ GIMT_Encode4(783233), // Rule ID 14811 //
     /*  783160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  783171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  783174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  783177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  783180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  783206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  783209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783231 */     GIR_RootConstrainSelectedInstOperands,
     /*  783232 */     // GIR_Coverage, 14811,
     /*  783232 */     GIR_EraseRootFromParent_Done,
     /*  783233 */   // Label 12160: @783233
     /*  783233 */   GIM_Try, /*On fail goto*//*Label 12161*/ GIMT_Encode4(783311), // Rule ID 14814 //
     /*  783238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  783249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  783252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  783255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  783258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783284 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  783287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783309 */     GIR_RootConstrainSelectedInstOperands,
     /*  783310 */     // GIR_Coverage, 14814,
     /*  783310 */     GIR_EraseRootFromParent_Done,
     /*  783311 */   // Label 12161: @783311
     /*  783311 */   GIM_Try, /*On fail goto*//*Label 12162*/ GIMT_Encode4(783389), // Rule ID 14815 //
     /*  783316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  783327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  783330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  783333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  783336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783362 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  783365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783387 */     GIR_RootConstrainSelectedInstOperands,
     /*  783388 */     // GIR_Coverage, 14815,
     /*  783388 */     GIR_EraseRootFromParent_Done,
     /*  783389 */   // Label 12162: @783389
     /*  783389 */   GIM_Try, /*On fail goto*//*Label 12163*/ GIMT_Encode4(783467), // Rule ID 14818 //
     /*  783394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  783405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  783408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  783411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  783414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783440 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  783443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783465 */     GIR_RootConstrainSelectedInstOperands,
     /*  783466 */     // GIR_Coverage, 14818,
     /*  783466 */     GIR_EraseRootFromParent_Done,
     /*  783467 */   // Label 12163: @783467
     /*  783467 */   GIM_Try, /*On fail goto*//*Label 12164*/ GIMT_Encode4(783545), // Rule ID 14819 //
     /*  783472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  783483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  783486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  783489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  783492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  783521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783543 */     GIR_RootConstrainSelectedInstOperands,
     /*  783544 */     // GIR_Coverage, 14819,
     /*  783544 */     GIR_EraseRootFromParent_Done,
     /*  783545 */   // Label 12164: @783545
     /*  783545 */   GIM_Try, /*On fail goto*//*Label 12165*/ GIMT_Encode4(783623), // Rule ID 14822 //
     /*  783550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  783561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  783564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  783567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  783570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  783599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783621 */     GIR_RootConstrainSelectedInstOperands,
     /*  783622 */     // GIR_Coverage, 14822,
     /*  783622 */     GIR_EraseRootFromParent_Done,
     /*  783623 */   // Label 12165: @783623
     /*  783623 */   GIM_Try, /*On fail goto*//*Label 12166*/ GIMT_Encode4(783701), // Rule ID 14823 //
     /*  783628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  783639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  783642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  783645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  783648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783674 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  783677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783699 */     GIR_RootConstrainSelectedInstOperands,
     /*  783700 */     // GIR_Coverage, 14823,
     /*  783700 */     GIR_EraseRootFromParent_Done,
     /*  783701 */   // Label 12166: @783701
     /*  783701 */   GIM_Try, /*On fail goto*//*Label 12167*/ GIMT_Encode4(783779), // Rule ID 14826 //
     /*  783706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  783717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  783720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  783723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  783726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  783755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783777 */     GIR_RootConstrainSelectedInstOperands,
     /*  783778 */     // GIR_Coverage, 14826,
     /*  783778 */     GIR_EraseRootFromParent_Done,
     /*  783779 */   // Label 12167: @783779
     /*  783779 */   GIM_Try, /*On fail goto*//*Label 12168*/ GIMT_Encode4(783857), // Rule ID 14827 //
     /*  783784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  783795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  783798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  783801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  783804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783830 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  783833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783855 */     GIR_RootConstrainSelectedInstOperands,
     /*  783856 */     // GIR_Coverage, 14827,
     /*  783856 */     GIR_EraseRootFromParent_Done,
     /*  783857 */   // Label 12168: @783857
     /*  783857 */   GIM_Try, /*On fail goto*//*Label 12169*/ GIMT_Encode4(783935), // Rule ID 14830 //
     /*  783862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  783873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  783876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  783879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  783882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783908 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  783911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783933 */     GIR_RootConstrainSelectedInstOperands,
     /*  783934 */     // GIR_Coverage, 14830,
     /*  783934 */     GIR_EraseRootFromParent_Done,
     /*  783935 */   // Label 12169: @783935
     /*  783935 */   GIM_Try, /*On fail goto*//*Label 12170*/ GIMT_Encode4(784013), // Rule ID 14831 //
     /*  783940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  783951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  783954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  783957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  783960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  783989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784011 */     GIR_RootConstrainSelectedInstOperands,
     /*  784012 */     // GIR_Coverage, 14831,
     /*  784012 */     GIR_EraseRootFromParent_Done,
     /*  784013 */   // Label 12170: @784013
     /*  784013 */   GIM_Try, /*On fail goto*//*Label 12171*/ GIMT_Encode4(784091), // Rule ID 14834 //
     /*  784018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  784021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  784029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  784032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  784035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  784038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784064 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  784064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  784067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784089 */     GIR_RootConstrainSelectedInstOperands,
     /*  784090 */     // GIR_Coverage, 14834,
     /*  784090 */     GIR_EraseRootFromParent_Done,
     /*  784091 */   // Label 12171: @784091
     /*  784091 */   GIM_Try, /*On fail goto*//*Label 12172*/ GIMT_Encode4(784169), // Rule ID 14835 //
     /*  784096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  784099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  784107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  784110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  784113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  784116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784142 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  784142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  784145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784167 */     GIR_RootConstrainSelectedInstOperands,
     /*  784168 */     // GIR_Coverage, 14835,
     /*  784168 */     GIR_EraseRootFromParent_Done,
     /*  784169 */   // Label 12172: @784169
     /*  784169 */   GIM_Try, /*On fail goto*//*Label 12173*/ GIMT_Encode4(784247), // Rule ID 14838 //
     /*  784174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  784177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  784185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  784188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  784191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784220 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  784220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  784223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784245 */     GIR_RootConstrainSelectedInstOperands,
     /*  784246 */     // GIR_Coverage, 14838,
     /*  784246 */     GIR_EraseRootFromParent_Done,
     /*  784247 */   // Label 12173: @784247
     /*  784247 */   GIM_Try, /*On fail goto*//*Label 12174*/ GIMT_Encode4(784325), // Rule ID 14839 //
     /*  784252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  784255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  784263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  784266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  784269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784298 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  784298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  784301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784323 */     GIR_RootConstrainSelectedInstOperands,
     /*  784324 */     // GIR_Coverage, 14839,
     /*  784324 */     GIR_EraseRootFromParent_Done,
     /*  784325 */   // Label 12174: @784325
     /*  784325 */   GIM_Try, /*On fail goto*//*Label 12175*/ GIMT_Encode4(784403), // Rule ID 14842 //
     /*  784330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  784333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  784341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  784344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  784347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  784376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  784379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784401 */     GIR_RootConstrainSelectedInstOperands,
     /*  784402 */     // GIR_Coverage, 14842,
     /*  784402 */     GIR_EraseRootFromParent_Done,
     /*  784403 */   // Label 12175: @784403
     /*  784403 */   GIM_Try, /*On fail goto*//*Label 12176*/ GIMT_Encode4(784481), // Rule ID 14843 //
     /*  784408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  784411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  784419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  784422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  784425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784454 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  784454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  784457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784479 */     GIR_RootConstrainSelectedInstOperands,
     /*  784480 */     // GIR_Coverage, 14843,
     /*  784480 */     GIR_EraseRootFromParent_Done,
     /*  784481 */   // Label 12176: @784481
     /*  784481 */   GIM_Try, /*On fail goto*//*Label 12177*/ GIMT_Encode4(784559), // Rule ID 14846 //
     /*  784486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  784489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  784497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  784500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  784503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784532 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  784532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  784535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784557 */     GIR_RootConstrainSelectedInstOperands,
     /*  784558 */     // GIR_Coverage, 14846,
     /*  784558 */     GIR_EraseRootFromParent_Done,
     /*  784559 */   // Label 12177: @784559
     /*  784559 */   GIM_Try, /*On fail goto*//*Label 12178*/ GIMT_Encode4(784637), // Rule ID 14847 //
     /*  784564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  784567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  784575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  784578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  784581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784610 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  784610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  784613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784635 */     GIR_RootConstrainSelectedInstOperands,
     /*  784636 */     // GIR_Coverage, 14847,
     /*  784636 */     GIR_EraseRootFromParent_Done,
     /*  784637 */   // Label 12178: @784637
     /*  784637 */   GIM_Try, /*On fail goto*//*Label 12179*/ GIMT_Encode4(784715), // Rule ID 14850 //
     /*  784642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  784645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  784653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  784656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  784659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784688 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  784691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784713 */     GIR_RootConstrainSelectedInstOperands,
     /*  784714 */     // GIR_Coverage, 14850,
     /*  784714 */     GIR_EraseRootFromParent_Done,
     /*  784715 */   // Label 12179: @784715
     /*  784715 */   GIM_Try, /*On fail goto*//*Label 12180*/ GIMT_Encode4(784793), // Rule ID 14851 //
     /*  784720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  784723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  784731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  784734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  784737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784766 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  784769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784791 */     GIR_RootConstrainSelectedInstOperands,
     /*  784792 */     // GIR_Coverage, 14851,
     /*  784792 */     GIR_EraseRootFromParent_Done,
     /*  784793 */   // Label 12180: @784793
     /*  784793 */   GIM_Try, /*On fail goto*//*Label 12181*/ GIMT_Encode4(784871), // Rule ID 14854 //
     /*  784798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  784801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  784809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  784812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  784815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  784847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784869 */     GIR_RootConstrainSelectedInstOperands,
     /*  784870 */     // GIR_Coverage, 14854,
     /*  784870 */     GIR_EraseRootFromParent_Done,
     /*  784871 */   // Label 12181: @784871
     /*  784871 */   GIM_Try, /*On fail goto*//*Label 12182*/ GIMT_Encode4(784949), // Rule ID 14855 //
     /*  784876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  784879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  784887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  784890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  784893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784922 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  784925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784947 */     GIR_RootConstrainSelectedInstOperands,
     /*  784948 */     // GIR_Coverage, 14855,
     /*  784948 */     GIR_EraseRootFromParent_Done,
     /*  784949 */   // Label 12182: @784949
     /*  784949 */   GIM_Try, /*On fail goto*//*Label 12183*/ GIMT_Encode4(785027), // Rule ID 14858 //
     /*  784954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  784957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  784965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  784968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  784971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785000 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  785003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785025 */     GIR_RootConstrainSelectedInstOperands,
     /*  785026 */     // GIR_Coverage, 14858,
     /*  785026 */     GIR_EraseRootFromParent_Done,
     /*  785027 */   // Label 12183: @785027
     /*  785027 */   GIM_Try, /*On fail goto*//*Label 12184*/ GIMT_Encode4(785105), // Rule ID 14859 //
     /*  785032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  785035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  785043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  785046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  785049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785078 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  785081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785103 */     GIR_RootConstrainSelectedInstOperands,
     /*  785104 */     // GIR_Coverage, 14859,
     /*  785104 */     GIR_EraseRootFromParent_Done,
     /*  785105 */   // Label 12184: @785105
     /*  785105 */   GIM_Try, /*On fail goto*//*Label 12185*/ GIMT_Encode4(785183), // Rule ID 14862 //
     /*  785110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  785113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  785121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  785124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  785127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  785130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785156 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  785156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  785175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785181 */     GIR_RootConstrainSelectedInstOperands,
     /*  785182 */     // GIR_Coverage, 14862,
     /*  785182 */     GIR_EraseRootFromParent_Done,
     /*  785183 */   // Label 12185: @785183
     /*  785183 */   GIM_Try, /*On fail goto*//*Label 12186*/ GIMT_Encode4(785261), // Rule ID 14863 //
     /*  785188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  785191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  785199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  785202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  785205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785234 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11594:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  785234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  785253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785259 */     GIR_RootConstrainSelectedInstOperands,
     /*  785260 */     // GIR_Coverage, 14863,
     /*  785260 */     GIR_EraseRootFromParent_Done,
     /*  785261 */   // Label 12186: @785261
     /*  785261 */   GIM_Try, /*On fail goto*//*Label 12187*/ GIMT_Encode4(785339), // Rule ID 14866 //
     /*  785266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  785269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  785277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  785280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  785283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  785286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785312 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785337 */     GIR_RootConstrainSelectedInstOperands,
     /*  785338 */     // GIR_Coverage, 14866,
     /*  785338 */     GIR_EraseRootFromParent_Done,
     /*  785339 */   // Label 12187: @785339
     /*  785339 */   GIM_Try, /*On fail goto*//*Label 12188*/ GIMT_Encode4(785417), // Rule ID 14867 //
     /*  785344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  785347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  785355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  785358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  785361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785415 */     GIR_RootConstrainSelectedInstOperands,
     /*  785416 */     // GIR_Coverage, 14867,
     /*  785416 */     GIR_EraseRootFromParent_Done,
     /*  785417 */   // Label 12188: @785417
     /*  785417 */   GIM_Try, /*On fail goto*//*Label 12189*/ GIMT_Encode4(785495), // Rule ID 14870 //
     /*  785422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  785425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  785433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  785436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  785439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  785442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785468 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785493 */     GIR_RootConstrainSelectedInstOperands,
     /*  785494 */     // GIR_Coverage, 14870,
     /*  785494 */     GIR_EraseRootFromParent_Done,
     /*  785495 */   // Label 12189: @785495
     /*  785495 */   GIM_Try, /*On fail goto*//*Label 12190*/ GIMT_Encode4(785573), // Rule ID 14871 //
     /*  785500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  785503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  785511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  785514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  785517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785546 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785571 */     GIR_RootConstrainSelectedInstOperands,
     /*  785572 */     // GIR_Coverage, 14871,
     /*  785572 */     GIR_EraseRootFromParent_Done,
     /*  785573 */   // Label 12190: @785573
     /*  785573 */   GIM_Try, /*On fail goto*//*Label 12191*/ GIMT_Encode4(785651), // Rule ID 14874 //
     /*  785578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  785581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  785589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  785592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  785595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  785598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785624 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  785624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785649 */     GIR_RootConstrainSelectedInstOperands,
     /*  785650 */     // GIR_Coverage, 14874,
     /*  785650 */     GIR_EraseRootFromParent_Done,
     /*  785651 */   // Label 12191: @785651
     /*  785651 */   GIM_Try, /*On fail goto*//*Label 12192*/ GIMT_Encode4(785729), // Rule ID 14875 //
     /*  785656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  785659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  785667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  785670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  785673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  785702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785727 */     GIR_RootConstrainSelectedInstOperands,
     /*  785728 */     // GIR_Coverage, 14875,
     /*  785728 */     GIR_EraseRootFromParent_Done,
     /*  785729 */   // Label 12192: @785729
     /*  785729 */   GIM_Try, /*On fail goto*//*Label 12193*/ GIMT_Encode4(785807), // Rule ID 14878 //
     /*  785734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  785737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  785745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  785748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  785751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  785754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785780 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  785780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  785783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  785799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785805 */     GIR_RootConstrainSelectedInstOperands,
     /*  785806 */     // GIR_Coverage, 14878,
     /*  785806 */     GIR_EraseRootFromParent_Done,
     /*  785807 */   // Label 12193: @785807
     /*  785807 */   GIM_Try, /*On fail goto*//*Label 12194*/ GIMT_Encode4(785885), // Rule ID 14879 //
     /*  785812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  785815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  785823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  785826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  785829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  785858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  785861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  785877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785883 */     GIR_RootConstrainSelectedInstOperands,
     /*  785884 */     // GIR_Coverage, 14879,
     /*  785884 */     GIR_EraseRootFromParent_Done,
     /*  785885 */   // Label 12194: @785885
     /*  785885 */   GIM_Try, /*On fail goto*//*Label 12195*/ GIMT_Encode4(785963), // Rule ID 14882 //
     /*  785890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  785893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  785901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  785904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  785907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  785910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785936 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  785936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  785939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  785955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785961 */     GIR_RootConstrainSelectedInstOperands,
     /*  785962 */     // GIR_Coverage, 14882,
     /*  785962 */     GIR_EraseRootFromParent_Done,
     /*  785963 */   // Label 12195: @785963
     /*  785963 */   GIM_Try, /*On fail goto*//*Label 12196*/ GIMT_Encode4(786041), // Rule ID 14883 //
     /*  785968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  785971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  785979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  785982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  785985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786014 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  786014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  786017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786039 */     GIR_RootConstrainSelectedInstOperands,
     /*  786040 */     // GIR_Coverage, 14883,
     /*  786040 */     GIR_EraseRootFromParent_Done,
     /*  786041 */   // Label 12196: @786041
     /*  786041 */   GIM_Try, /*On fail goto*//*Label 12197*/ GIMT_Encode4(786119), // Rule ID 14886 //
     /*  786046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  786057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  786060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  786063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  786092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  786095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786117 */     GIR_RootConstrainSelectedInstOperands,
     /*  786118 */     // GIR_Coverage, 14886,
     /*  786118 */     GIR_EraseRootFromParent_Done,
     /*  786119 */   // Label 12197: @786119
     /*  786119 */   GIM_Try, /*On fail goto*//*Label 12198*/ GIMT_Encode4(786197), // Rule ID 14887 //
     /*  786124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  786127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  786135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  786138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  786141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786170 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  786170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  786173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786195 */     GIR_RootConstrainSelectedInstOperands,
     /*  786196 */     // GIR_Coverage, 14887,
     /*  786196 */     GIR_EraseRootFromParent_Done,
     /*  786197 */   // Label 12198: @786197
     /*  786197 */   GIM_Try, /*On fail goto*//*Label 12199*/ GIMT_Encode4(786275), // Rule ID 14890 //
     /*  786202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  786213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  786216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  786219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786248 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  786251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786273 */     GIR_RootConstrainSelectedInstOperands,
     /*  786274 */     // GIR_Coverage, 14890,
     /*  786274 */     GIR_EraseRootFromParent_Done,
     /*  786275 */   // Label 12199: @786275
     /*  786275 */   GIM_Try, /*On fail goto*//*Label 12200*/ GIMT_Encode4(786353), // Rule ID 14891 //
     /*  786280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  786283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  786291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  786294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  786297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  786329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786351 */     GIR_RootConstrainSelectedInstOperands,
     /*  786352 */     // GIR_Coverage, 14891,
     /*  786352 */     GIR_EraseRootFromParent_Done,
     /*  786353 */   // Label 12200: @786353
     /*  786353 */   GIM_Try, /*On fail goto*//*Label 12201*/ GIMT_Encode4(786431), // Rule ID 14894 //
     /*  786358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  786369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  786372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  786375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  786407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786429 */     GIR_RootConstrainSelectedInstOperands,
     /*  786430 */     // GIR_Coverage, 14894,
     /*  786430 */     GIR_EraseRootFromParent_Done,
     /*  786431 */   // Label 12201: @786431
     /*  786431 */   GIM_Try, /*On fail goto*//*Label 12202*/ GIMT_Encode4(786509), // Rule ID 14895 //
     /*  786436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  786439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  786447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  786450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  786453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786482 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  786485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786507 */     GIR_RootConstrainSelectedInstOperands,
     /*  786508 */     // GIR_Coverage, 14895,
     /*  786508 */     GIR_EraseRootFromParent_Done,
     /*  786509 */   // Label 12202: @786509
     /*  786509 */   GIM_Try, /*On fail goto*//*Label 12203*/ GIMT_Encode4(786587), // Rule ID 14898 //
     /*  786514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  786525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  786528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  786531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786560 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  786563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786585 */     GIR_RootConstrainSelectedInstOperands,
     /*  786586 */     // GIR_Coverage, 14898,
     /*  786586 */     GIR_EraseRootFromParent_Done,
     /*  786587 */   // Label 12203: @786587
     /*  786587 */   GIM_Try, /*On fail goto*//*Label 12204*/ GIMT_Encode4(786665), // Rule ID 14899 //
     /*  786592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  786595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  786603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  786606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  786609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786638 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  786641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786663 */     GIR_RootConstrainSelectedInstOperands,
     /*  786664 */     // GIR_Coverage, 14899,
     /*  786664 */     GIR_EraseRootFromParent_Done,
     /*  786665 */   // Label 12204: @786665
     /*  786665 */   GIM_Try, /*On fail goto*//*Label 12205*/ GIMT_Encode4(786743), // Rule ID 14902 //
     /*  786670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  786681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  786684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  786687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786716 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  786716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  786719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786741 */     GIR_RootConstrainSelectedInstOperands,
     /*  786742 */     // GIR_Coverage, 14902,
     /*  786742 */     GIR_EraseRootFromParent_Done,
     /*  786743 */   // Label 12205: @786743
     /*  786743 */   GIM_Try, /*On fail goto*//*Label 12206*/ GIMT_Encode4(786821), // Rule ID 14903 //
     /*  786748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  786751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  786759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  786762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  786765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  786797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786819 */     GIR_RootConstrainSelectedInstOperands,
     /*  786820 */     // GIR_Coverage, 14903,
     /*  786820 */     GIR_EraseRootFromParent_Done,
     /*  786821 */   // Label 12206: @786821
     /*  786821 */   GIM_Try, /*On fail goto*//*Label 12207*/ GIMT_Encode4(786899), // Rule ID 14906 //
     /*  786826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  786837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  786840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  786843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786872 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  786872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  786875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786897 */     GIR_RootConstrainSelectedInstOperands,
     /*  786898 */     // GIR_Coverage, 14906,
     /*  786898 */     GIR_EraseRootFromParent_Done,
     /*  786899 */   // Label 12207: @786899
     /*  786899 */   GIM_Try, /*On fail goto*//*Label 12208*/ GIMT_Encode4(786977), // Rule ID 14907 //
     /*  786904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  786907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  786915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  786918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  786921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786950 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  786953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786975 */     GIR_RootConstrainSelectedInstOperands,
     /*  786976 */     // GIR_Coverage, 14907,
     /*  786976 */     GIR_EraseRootFromParent_Done,
     /*  786977 */   // Label 12208: @786977
     /*  786977 */   GIM_Try, /*On fail goto*//*Label 12209*/ GIMT_Encode4(787055), // Rule ID 14910 //
     /*  786982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  786993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  786996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  786999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787028 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  787031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787053 */     GIR_RootConstrainSelectedInstOperands,
     /*  787054 */     // GIR_Coverage, 14910,
     /*  787054 */     GIR_EraseRootFromParent_Done,
     /*  787055 */   // Label 12209: @787055
     /*  787055 */   GIM_Try, /*On fail goto*//*Label 12210*/ GIMT_Encode4(787133), // Rule ID 14911 //
     /*  787060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  787063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  787071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  787074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  787077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787106 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  787109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787131 */     GIR_RootConstrainSelectedInstOperands,
     /*  787132 */     // GIR_Coverage, 14911,
     /*  787132 */     GIR_EraseRootFromParent_Done,
     /*  787133 */   // Label 12210: @787133
     /*  787133 */   GIM_Try, /*On fail goto*//*Label 12211*/ GIMT_Encode4(787211), // Rule ID 14914 //
     /*  787138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  787141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  787149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  787152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  787155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  787184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  787187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787209 */     GIR_RootConstrainSelectedInstOperands,
     /*  787210 */     // GIR_Coverage, 14914,
     /*  787210 */     GIR_EraseRootFromParent_Done,
     /*  787211 */   // Label 12211: @787211
     /*  787211 */   GIM_Try, /*On fail goto*//*Label 12212*/ GIMT_Encode4(787289), // Rule ID 14915 //
     /*  787216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  787219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  787227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  787230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  787233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787262 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  787262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  787265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787287 */     GIR_RootConstrainSelectedInstOperands,
     /*  787288 */     // GIR_Coverage, 14915,
     /*  787288 */     GIR_EraseRootFromParent_Done,
     /*  787289 */   // Label 12212: @787289
     /*  787289 */   GIM_Try, /*On fail goto*//*Label 12213*/ GIMT_Encode4(787367), // Rule ID 14918 //
     /*  787294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  787297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  787305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  787308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  787311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787340 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  787340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  787343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787365 */     GIR_RootConstrainSelectedInstOperands,
     /*  787366 */     // GIR_Coverage, 14918,
     /*  787366 */     GIR_EraseRootFromParent_Done,
     /*  787367 */   // Label 12213: @787367
     /*  787367 */   GIM_Try, /*On fail goto*//*Label 12214*/ GIMT_Encode4(787445), // Rule ID 14919 //
     /*  787372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  787375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  787383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  787386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  787389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  787418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  787421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787443 */     GIR_RootConstrainSelectedInstOperands,
     /*  787444 */     // GIR_Coverage, 14919,
     /*  787444 */     GIR_EraseRootFromParent_Done,
     /*  787445 */   // Label 12214: @787445
     /*  787445 */   GIM_Try, /*On fail goto*//*Label 12215*/ GIMT_Encode4(787523), // Rule ID 14922 //
     /*  787450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  787453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  787461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  787464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  787467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787496 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  787496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  787499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787521 */     GIR_RootConstrainSelectedInstOperands,
     /*  787522 */     // GIR_Coverage, 14922,
     /*  787522 */     GIR_EraseRootFromParent_Done,
     /*  787523 */   // Label 12215: @787523
     /*  787523 */   GIM_Try, /*On fail goto*//*Label 12216*/ GIMT_Encode4(787601), // Rule ID 14923 //
     /*  787528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  787531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  787539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  787542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  787545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787574 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  787574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  787577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787599 */     GIR_RootConstrainSelectedInstOperands,
     /*  787600 */     // GIR_Coverage, 14923,
     /*  787600 */     GIR_EraseRootFromParent_Done,
     /*  787601 */   // Label 12216: @787601
     /*  787601 */   GIM_Try, /*On fail goto*//*Label 12217*/ GIMT_Encode4(787676), // Rule ID 19164 //
     /*  787606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  787617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  787620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  787623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  787626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787652 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  787655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787674 */     GIR_RootConstrainSelectedInstOperands,
     /*  787675 */     // GIR_Coverage, 19164,
     /*  787675 */     GIR_EraseRootFromParent_Done,
     /*  787676 */   // Label 12217: @787676
     /*  787676 */   GIM_Try, /*On fail goto*//*Label 12218*/ GIMT_Encode4(787751), // Rule ID 19165 //
     /*  787681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  787692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  787695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  787698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  787701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787727 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  787730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787749 */     GIR_RootConstrainSelectedInstOperands,
     /*  787750 */     // GIR_Coverage, 19165,
     /*  787750 */     GIR_EraseRootFromParent_Done,
     /*  787751 */   // Label 12218: @787751
     /*  787751 */   GIM_Try, /*On fail goto*//*Label 12219*/ GIMT_Encode4(787826), // Rule ID 19168 //
     /*  787756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  787767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  787770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  787773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  787776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787802 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  787805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787824 */     GIR_RootConstrainSelectedInstOperands,
     /*  787825 */     // GIR_Coverage, 19168,
     /*  787825 */     GIR_EraseRootFromParent_Done,
     /*  787826 */   // Label 12219: @787826
     /*  787826 */   GIM_Try, /*On fail goto*//*Label 12220*/ GIMT_Encode4(787901), // Rule ID 19169 //
     /*  787831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  787842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  787845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  787848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  787851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787877 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  787880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787899 */     GIR_RootConstrainSelectedInstOperands,
     /*  787900 */     // GIR_Coverage, 19169,
     /*  787900 */     GIR_EraseRootFromParent_Done,
     /*  787901 */   // Label 12220: @787901
     /*  787901 */   GIM_Try, /*On fail goto*//*Label 12221*/ GIMT_Encode4(787976), // Rule ID 19172 //
     /*  787906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  787917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  787920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  787923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  787926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787952 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  787955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787974 */     GIR_RootConstrainSelectedInstOperands,
     /*  787975 */     // GIR_Coverage, 19172,
     /*  787975 */     GIR_EraseRootFromParent_Done,
     /*  787976 */   // Label 12221: @787976
     /*  787976 */   GIM_Try, /*On fail goto*//*Label 12222*/ GIMT_Encode4(788051), // Rule ID 19173 //
     /*  787981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  787992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  787995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  787998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  788001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788027 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  788030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788049 */     GIR_RootConstrainSelectedInstOperands,
     /*  788050 */     // GIR_Coverage, 19173,
     /*  788050 */     GIR_EraseRootFromParent_Done,
     /*  788051 */   // Label 12222: @788051
     /*  788051 */   GIM_Try, /*On fail goto*//*Label 12223*/ GIMT_Encode4(788126), // Rule ID 19176 //
     /*  788056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  788067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  788070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  788073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  788076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  788105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788124 */     GIR_RootConstrainSelectedInstOperands,
     /*  788125 */     // GIR_Coverage, 19176,
     /*  788125 */     GIR_EraseRootFromParent_Done,
     /*  788126 */   // Label 12223: @788126
     /*  788126 */   GIM_Try, /*On fail goto*//*Label 12224*/ GIMT_Encode4(788201), // Rule ID 19177 //
     /*  788131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  788142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  788145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  788148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  788151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788177 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  788180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788199 */     GIR_RootConstrainSelectedInstOperands,
     /*  788200 */     // GIR_Coverage, 19177,
     /*  788200 */     GIR_EraseRootFromParent_Done,
     /*  788201 */   // Label 12224: @788201
     /*  788201 */   GIM_Try, /*On fail goto*//*Label 12225*/ GIMT_Encode4(788276), // Rule ID 19180 //
     /*  788206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  788209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  788217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  788220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  788223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  788226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  788255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788274 */     GIR_RootConstrainSelectedInstOperands,
     /*  788275 */     // GIR_Coverage, 19180,
     /*  788275 */     GIR_EraseRootFromParent_Done,
     /*  788276 */   // Label 12225: @788276
     /*  788276 */   GIM_Try, /*On fail goto*//*Label 12226*/ GIMT_Encode4(788351), // Rule ID 19181 //
     /*  788281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  788284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  788292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  788295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  788298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  788301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788327 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  788330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788349 */     GIR_RootConstrainSelectedInstOperands,
     /*  788350 */     // GIR_Coverage, 19181,
     /*  788350 */     GIR_EraseRootFromParent_Done,
     /*  788351 */   // Label 12226: @788351
     /*  788351 */   GIM_Try, /*On fail goto*//*Label 12227*/ GIMT_Encode4(788426), // Rule ID 19184 //
     /*  788356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  788359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  788367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  788370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  788373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  788376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788402 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  788405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788424 */     GIR_RootConstrainSelectedInstOperands,
     /*  788425 */     // GIR_Coverage, 19184,
     /*  788425 */     GIR_EraseRootFromParent_Done,
     /*  788426 */   // Label 12227: @788426
     /*  788426 */   GIM_Try, /*On fail goto*//*Label 12228*/ GIMT_Encode4(788501), // Rule ID 19185 //
     /*  788431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  788434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  788442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  788445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  788448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  788451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788477 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  788480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788499 */     GIR_RootConstrainSelectedInstOperands,
     /*  788500 */     // GIR_Coverage, 19185,
     /*  788500 */     GIR_EraseRootFromParent_Done,
     /*  788501 */   // Label 12228: @788501
     /*  788501 */   GIM_Try, /*On fail goto*//*Label 12229*/ GIMT_Encode4(788576), // Rule ID 19188 //
     /*  788506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  788517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  788520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  788523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  788526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  788555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788574 */     GIR_RootConstrainSelectedInstOperands,
     /*  788575 */     // GIR_Coverage, 19188,
     /*  788575 */     GIR_EraseRootFromParent_Done,
     /*  788576 */   // Label 12229: @788576
     /*  788576 */   GIM_Try, /*On fail goto*//*Label 12230*/ GIMT_Encode4(788651), // Rule ID 19189 //
     /*  788581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  788592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  788595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  788598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  788601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788627 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  788630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788649 */     GIR_RootConstrainSelectedInstOperands,
     /*  788650 */     // GIR_Coverage, 19189,
     /*  788650 */     GIR_EraseRootFromParent_Done,
     /*  788651 */   // Label 12230: @788651
     /*  788651 */   GIM_Try, /*On fail goto*//*Label 12231*/ GIMT_Encode4(788726), // Rule ID 19192 //
     /*  788656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  788667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  788670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  788673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  788676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788702 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  788705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788724 */     GIR_RootConstrainSelectedInstOperands,
     /*  788725 */     // GIR_Coverage, 19192,
     /*  788725 */     GIR_EraseRootFromParent_Done,
     /*  788726 */   // Label 12231: @788726
     /*  788726 */   GIM_Try, /*On fail goto*//*Label 12232*/ GIMT_Encode4(788801), // Rule ID 19193 //
     /*  788731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  788742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  788745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  788748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  788751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788777 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  788780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788799 */     GIR_RootConstrainSelectedInstOperands,
     /*  788800 */     // GIR_Coverage, 19193,
     /*  788800 */     GIR_EraseRootFromParent_Done,
     /*  788801 */   // Label 12232: @788801
     /*  788801 */   GIM_Try, /*On fail goto*//*Label 12233*/ GIMT_Encode4(788876), // Rule ID 19196 //
     /*  788806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  788817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  788820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  788823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  788826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788852 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  788855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788874 */     GIR_RootConstrainSelectedInstOperands,
     /*  788875 */     // GIR_Coverage, 19196,
     /*  788875 */     GIR_EraseRootFromParent_Done,
     /*  788876 */   // Label 12233: @788876
     /*  788876 */   GIM_Try, /*On fail goto*//*Label 12234*/ GIMT_Encode4(788951), // Rule ID 19197 //
     /*  788881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  788892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  788895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  788898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  788901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788927 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  788930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788949 */     GIR_RootConstrainSelectedInstOperands,
     /*  788950 */     // GIR_Coverage, 19197,
     /*  788950 */     GIR_EraseRootFromParent_Done,
     /*  788951 */   // Label 12234: @788951
     /*  788951 */   GIM_Try, /*On fail goto*//*Label 12235*/ GIMT_Encode4(789026), // Rule ID 19200 //
     /*  788956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  788959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  788967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  788970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  788973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  788976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789002 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  789005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789024 */     GIR_RootConstrainSelectedInstOperands,
     /*  789025 */     // GIR_Coverage, 19200,
     /*  789025 */     GIR_EraseRootFromParent_Done,
     /*  789026 */   // Label 12235: @789026
     /*  789026 */   GIM_Try, /*On fail goto*//*Label 12236*/ GIMT_Encode4(789101), // Rule ID 19201 //
     /*  789031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  789042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  789045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  789048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  789051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789077 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  789080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789099 */     GIR_RootConstrainSelectedInstOperands,
     /*  789100 */     // GIR_Coverage, 19201,
     /*  789100 */     GIR_EraseRootFromParent_Done,
     /*  789101 */   // Label 12236: @789101
     /*  789101 */   GIM_Try, /*On fail goto*//*Label 12237*/ GIMT_Encode4(789176), // Rule ID 19204 //
     /*  789106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  789117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  789120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  789123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  789126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789152 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  789155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789174 */     GIR_RootConstrainSelectedInstOperands,
     /*  789175 */     // GIR_Coverage, 19204,
     /*  789175 */     GIR_EraseRootFromParent_Done,
     /*  789176 */   // Label 12237: @789176
     /*  789176 */   GIM_Try, /*On fail goto*//*Label 12238*/ GIMT_Encode4(789251), // Rule ID 19205 //
     /*  789181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  789192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  789195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  789198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  789201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789227 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  789230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789249 */     GIR_RootConstrainSelectedInstOperands,
     /*  789250 */     // GIR_Coverage, 19205,
     /*  789250 */     GIR_EraseRootFromParent_Done,
     /*  789251 */   // Label 12238: @789251
     /*  789251 */   GIM_Try, /*On fail goto*//*Label 12239*/ GIMT_Encode4(789326), // Rule ID 19208 //
     /*  789256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  789267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  789270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  789273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  789276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789302 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  789305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789324 */     GIR_RootConstrainSelectedInstOperands,
     /*  789325 */     // GIR_Coverage, 19208,
     /*  789325 */     GIR_EraseRootFromParent_Done,
     /*  789326 */   // Label 12239: @789326
     /*  789326 */   GIM_Try, /*On fail goto*//*Label 12240*/ GIMT_Encode4(789401), // Rule ID 19209 //
     /*  789331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  789342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  789345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  789348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  789351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789377 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  789380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789399 */     GIR_RootConstrainSelectedInstOperands,
     /*  789400 */     // GIR_Coverage, 19209,
     /*  789400 */     GIR_EraseRootFromParent_Done,
     /*  789401 */   // Label 12240: @789401
     /*  789401 */   GIM_Try, /*On fail goto*//*Label 12241*/ GIMT_Encode4(789476), // Rule ID 19212 //
     /*  789406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  789409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  789417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  789420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  789423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  789426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789452 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  789455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789474 */     GIR_RootConstrainSelectedInstOperands,
     /*  789475 */     // GIR_Coverage, 19212,
     /*  789475 */     GIR_EraseRootFromParent_Done,
     /*  789476 */   // Label 12241: @789476
     /*  789476 */   GIM_Try, /*On fail goto*//*Label 12242*/ GIMT_Encode4(789551), // Rule ID 19213 //
     /*  789481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  789484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  789492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  789495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  789498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  789501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789527 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  789530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789549 */     GIR_RootConstrainSelectedInstOperands,
     /*  789550 */     // GIR_Coverage, 19213,
     /*  789550 */     GIR_EraseRootFromParent_Done,
     /*  789551 */   // Label 12242: @789551
     /*  789551 */   GIM_Try, /*On fail goto*//*Label 12243*/ GIMT_Encode4(789626), // Rule ID 19216 //
     /*  789556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  789559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  789567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  789570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  789573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  789576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789602 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  789605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789624 */     GIR_RootConstrainSelectedInstOperands,
     /*  789625 */     // GIR_Coverage, 19216,
     /*  789625 */     GIR_EraseRootFromParent_Done,
     /*  789626 */   // Label 12243: @789626
     /*  789626 */   GIM_Try, /*On fail goto*//*Label 12244*/ GIMT_Encode4(789701), // Rule ID 19217 //
     /*  789631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  789634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  789642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  789645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  789648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  789651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789677 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  789680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789699 */     GIR_RootConstrainSelectedInstOperands,
     /*  789700 */     // GIR_Coverage, 19217,
     /*  789700 */     GIR_EraseRootFromParent_Done,
     /*  789701 */   // Label 12244: @789701
     /*  789701 */   GIM_Try, /*On fail goto*//*Label 12245*/ GIMT_Encode4(789776), // Rule ID 19220 //
     /*  789706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  789709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  789717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  789720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  789723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  789726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789752 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  789755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789774 */     GIR_RootConstrainSelectedInstOperands,
     /*  789775 */     // GIR_Coverage, 19220,
     /*  789775 */     GIR_EraseRootFromParent_Done,
     /*  789776 */   // Label 12245: @789776
     /*  789776 */   GIM_Try, /*On fail goto*//*Label 12246*/ GIMT_Encode4(789851), // Rule ID 19221 //
     /*  789781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  789784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  789792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  789795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  789798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  789801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789827 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  789830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789849 */     GIR_RootConstrainSelectedInstOperands,
     /*  789850 */     // GIR_Coverage, 19221,
     /*  789850 */     GIR_EraseRootFromParent_Done,
     /*  789851 */   // Label 12246: @789851
     /*  789851 */   GIM_Try, /*On fail goto*//*Label 12247*/ GIMT_Encode4(789926), // Rule ID 19224 //
     /*  789856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  789867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  789870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  789873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  789876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  789895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789902 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  789905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789924 */     GIR_RootConstrainSelectedInstOperands,
     /*  789925 */     // GIR_Coverage, 19224,
     /*  789925 */     GIR_EraseRootFromParent_Done,
     /*  789926 */   // Label 12247: @789926
     /*  789926 */   GIM_Try, /*On fail goto*//*Label 12248*/ GIMT_Encode4(790001), // Rule ID 19225 //
     /*  789931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  789942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  789945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  789948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  789951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  789970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789977 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  789980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789999 */     GIR_RootConstrainSelectedInstOperands,
     /*  790000 */     // GIR_Coverage, 19225,
     /*  790000 */     GIR_EraseRootFromParent_Done,
     /*  790001 */   // Label 12248: @790001
     /*  790001 */   GIM_Try, /*On fail goto*//*Label 12249*/ GIMT_Encode4(790076), // Rule ID 19228 //
     /*  790006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  790017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  790020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  790023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  790055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790074 */     GIR_RootConstrainSelectedInstOperands,
     /*  790075 */     // GIR_Coverage, 19228,
     /*  790075 */     GIR_EraseRootFromParent_Done,
     /*  790076 */   // Label 12249: @790076
     /*  790076 */   GIM_Try, /*On fail goto*//*Label 12250*/ GIMT_Encode4(790151), // Rule ID 19229 //
     /*  790081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  790092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  790095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  790098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790127 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  790130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790149 */     GIR_RootConstrainSelectedInstOperands,
     /*  790150 */     // GIR_Coverage, 19229,
     /*  790150 */     GIR_EraseRootFromParent_Done,
     /*  790151 */   // Label 12250: @790151
     /*  790151 */   GIM_Try, /*On fail goto*//*Label 12251*/ GIMT_Encode4(790226), // Rule ID 19232 //
     /*  790156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  790167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  790170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  790173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790202 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  790205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790224 */     GIR_RootConstrainSelectedInstOperands,
     /*  790225 */     // GIR_Coverage, 19232,
     /*  790225 */     GIR_EraseRootFromParent_Done,
     /*  790226 */   // Label 12251: @790226
     /*  790226 */   GIM_Try, /*On fail goto*//*Label 12252*/ GIMT_Encode4(790301), // Rule ID 19233 //
     /*  790231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  790242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  790245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  790248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790277 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  790280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790299 */     GIR_RootConstrainSelectedInstOperands,
     /*  790300 */     // GIR_Coverage, 19233,
     /*  790300 */     GIR_EraseRootFromParent_Done,
     /*  790301 */   // Label 12252: @790301
     /*  790301 */   GIM_Try, /*On fail goto*//*Label 12253*/ GIMT_Encode4(790376), // Rule ID 19236 //
     /*  790306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  790317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  790320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  790323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  790355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790374 */     GIR_RootConstrainSelectedInstOperands,
     /*  790375 */     // GIR_Coverage, 19236,
     /*  790375 */     GIR_EraseRootFromParent_Done,
     /*  790376 */   // Label 12253: @790376
     /*  790376 */   GIM_Try, /*On fail goto*//*Label 12254*/ GIMT_Encode4(790451), // Rule ID 19237 //
     /*  790381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  790392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  790395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  790398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790427 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  790430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790449 */     GIR_RootConstrainSelectedInstOperands,
     /*  790450 */     // GIR_Coverage, 19237,
     /*  790450 */     GIR_EraseRootFromParent_Done,
     /*  790451 */   // Label 12254: @790451
     /*  790451 */   GIM_Try, /*On fail goto*//*Label 12255*/ GIMT_Encode4(790526), // Rule ID 19240 //
     /*  790456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  790467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  790470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  790473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790502 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  790505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790524 */     GIR_RootConstrainSelectedInstOperands,
     /*  790525 */     // GIR_Coverage, 19240,
     /*  790525 */     GIR_EraseRootFromParent_Done,
     /*  790526 */   // Label 12255: @790526
     /*  790526 */   GIM_Try, /*On fail goto*//*Label 12256*/ GIMT_Encode4(790601), // Rule ID 19241 //
     /*  790531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  790542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  790545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  790548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790577 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  790580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790599 */     GIR_RootConstrainSelectedInstOperands,
     /*  790600 */     // GIR_Coverage, 19241,
     /*  790600 */     GIR_EraseRootFromParent_Done,
     /*  790601 */   // Label 12256: @790601
     /*  790601 */   GIM_Try, /*On fail goto*//*Label 12257*/ GIMT_Encode4(790676), // Rule ID 19244 //
     /*  790606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  790617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  790620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  790623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  790626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  790645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790652 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  790655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790674 */     GIR_RootConstrainSelectedInstOperands,
     /*  790675 */     // GIR_Coverage, 19244,
     /*  790675 */     GIR_EraseRootFromParent_Done,
     /*  790676 */   // Label 12257: @790676
     /*  790676 */   GIM_Try, /*On fail goto*//*Label 12258*/ GIMT_Encode4(790751), // Rule ID 19245 //
     /*  790681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  790692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  790695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  790698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  790701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  790720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790727 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  790730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790749 */     GIR_RootConstrainSelectedInstOperands,
     /*  790750 */     // GIR_Coverage, 19245,
     /*  790750 */     GIR_EraseRootFromParent_Done,
     /*  790751 */   // Label 12258: @790751
     /*  790751 */   GIM_Try, /*On fail goto*//*Label 12259*/ GIMT_Encode4(790826), // Rule ID 19248 //
     /*  790756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  790767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  790770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  790773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790802 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  790805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790824 */     GIR_RootConstrainSelectedInstOperands,
     /*  790825 */     // GIR_Coverage, 19248,
     /*  790825 */     GIR_EraseRootFromParent_Done,
     /*  790826 */   // Label 12259: @790826
     /*  790826 */   GIM_Try, /*On fail goto*//*Label 12260*/ GIMT_Encode4(790901), // Rule ID 19249 //
     /*  790831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  790842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  790845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  790848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790877 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  790880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790899 */     GIR_RootConstrainSelectedInstOperands,
     /*  790900 */     // GIR_Coverage, 19249,
     /*  790900 */     GIR_EraseRootFromParent_Done,
     /*  790901 */   // Label 12260: @790901
     /*  790901 */   GIM_Try, /*On fail goto*//*Label 12261*/ GIMT_Encode4(790976), // Rule ID 19252 //
     /*  790906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  790917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  790920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  790923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790952 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  790955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790974 */     GIR_RootConstrainSelectedInstOperands,
     /*  790975 */     // GIR_Coverage, 19252,
     /*  790975 */     GIR_EraseRootFromParent_Done,
     /*  790976 */   // Label 12261: @790976
     /*  790976 */   GIM_Try, /*On fail goto*//*Label 12262*/ GIMT_Encode4(791051), // Rule ID 19253 //
     /*  790981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  790992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  790995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  790998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791027 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  791030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791049 */     GIR_RootConstrainSelectedInstOperands,
     /*  791050 */     // GIR_Coverage, 19253,
     /*  791050 */     GIR_EraseRootFromParent_Done,
     /*  791051 */   // Label 12262: @791051
     /*  791051 */   GIM_Try, /*On fail goto*//*Label 12263*/ GIMT_Encode4(791126), // Rule ID 19256 //
     /*  791056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  791067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  791070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  791073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791102 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  791105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791124 */     GIR_RootConstrainSelectedInstOperands,
     /*  791125 */     // GIR_Coverage, 19256,
     /*  791125 */     GIR_EraseRootFromParent_Done,
     /*  791126 */   // Label 12263: @791126
     /*  791126 */   GIM_Try, /*On fail goto*//*Label 12264*/ GIMT_Encode4(791201), // Rule ID 19257 //
     /*  791131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  791142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  791145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  791148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791177 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  791180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791199 */     GIR_RootConstrainSelectedInstOperands,
     /*  791200 */     // GIR_Coverage, 19257,
     /*  791200 */     GIR_EraseRootFromParent_Done,
     /*  791201 */   // Label 12264: @791201
     /*  791201 */   GIM_Try, /*On fail goto*//*Label 12265*/ GIMT_Encode4(791276), // Rule ID 19260 //
     /*  791206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  791217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  791220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  791223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  791255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791274 */     GIR_RootConstrainSelectedInstOperands,
     /*  791275 */     // GIR_Coverage, 19260,
     /*  791275 */     GIR_EraseRootFromParent_Done,
     /*  791276 */   // Label 12265: @791276
     /*  791276 */   GIM_Try, /*On fail goto*//*Label 12266*/ GIMT_Encode4(791351), // Rule ID 19261 //
     /*  791281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  791292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  791295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  791298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791327 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  791330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791349 */     GIR_RootConstrainSelectedInstOperands,
     /*  791350 */     // GIR_Coverage, 19261,
     /*  791350 */     GIR_EraseRootFromParent_Done,
     /*  791351 */   // Label 12266: @791351
     /*  791351 */   GIM_Try, /*On fail goto*//*Label 12267*/ GIMT_Encode4(791426), // Rule ID 19264 //
     /*  791356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  791367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  791370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  791373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791402 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  791405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791424 */     GIR_RootConstrainSelectedInstOperands,
     /*  791425 */     // GIR_Coverage, 19264,
     /*  791425 */     GIR_EraseRootFromParent_Done,
     /*  791426 */   // Label 12267: @791426
     /*  791426 */   GIM_Try, /*On fail goto*//*Label 12268*/ GIMT_Encode4(791501), // Rule ID 19265 //
     /*  791431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  791442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  791445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  791448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791477 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  791480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791499 */     GIR_RootConstrainSelectedInstOperands,
     /*  791500 */     // GIR_Coverage, 19265,
     /*  791500 */     GIR_EraseRootFromParent_Done,
     /*  791501 */   // Label 12268: @791501
     /*  791501 */   GIM_Try, /*On fail goto*//*Label 12269*/ GIMT_Encode4(791576), // Rule ID 19268 //
     /*  791506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  791517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  791520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  791523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791552 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  791555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791574 */     GIR_RootConstrainSelectedInstOperands,
     /*  791575 */     // GIR_Coverage, 19268,
     /*  791575 */     GIR_EraseRootFromParent_Done,
     /*  791576 */   // Label 12269: @791576
     /*  791576 */   GIM_Try, /*On fail goto*//*Label 12270*/ GIMT_Encode4(791651), // Rule ID 19269 //
     /*  791581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  791592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  791595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  791598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791627 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  791630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791649 */     GIR_RootConstrainSelectedInstOperands,
     /*  791650 */     // GIR_Coverage, 19269,
     /*  791650 */     GIR_EraseRootFromParent_Done,
     /*  791651 */   // Label 12270: @791651
     /*  791651 */   GIM_Try, /*On fail goto*//*Label 12271*/ GIMT_Encode4(791726), // Rule ID 19272 //
     /*  791656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  791659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  791667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  791670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  791673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791702 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  791702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  791705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791724 */     GIR_RootConstrainSelectedInstOperands,
     /*  791725 */     // GIR_Coverage, 19272,
     /*  791725 */     GIR_EraseRootFromParent_Done,
     /*  791726 */   // Label 12271: @791726
     /*  791726 */   GIM_Try, /*On fail goto*//*Label 12272*/ GIMT_Encode4(791801), // Rule ID 19273 //
     /*  791731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  791734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  791742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  791745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  791748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791777 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  791777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  791780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791799 */     GIR_RootConstrainSelectedInstOperands,
     /*  791800 */     // GIR_Coverage, 19273,
     /*  791800 */     GIR_EraseRootFromParent_Done,
     /*  791801 */   // Label 12272: @791801
     /*  791801 */   GIM_Try, /*On fail goto*//*Label 12273*/ GIMT_Encode4(791876), // Rule ID 19276 //
     /*  791806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  791809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  791817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  791820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  791823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791852 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  791852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  791855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791874 */     GIR_RootConstrainSelectedInstOperands,
     /*  791875 */     // GIR_Coverage, 19276,
     /*  791875 */     GIR_EraseRootFromParent_Done,
     /*  791876 */   // Label 12273: @791876
     /*  791876 */   GIM_Try, /*On fail goto*//*Label 12274*/ GIMT_Encode4(791951), // Rule ID 19277 //
     /*  791881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  791884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  791892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  791895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  791898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791927 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  791927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  791930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791949 */     GIR_RootConstrainSelectedInstOperands,
     /*  791950 */     // GIR_Coverage, 19277,
     /*  791950 */     GIR_EraseRootFromParent_Done,
     /*  791951 */   // Label 12274: @791951
     /*  791951 */   GIM_Try, /*On fail goto*//*Label 12275*/ GIMT_Encode4(792026), // Rule ID 19280 //
     /*  791956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  791959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  791967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  791970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  791973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792002 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  792005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792024 */     GIR_RootConstrainSelectedInstOperands,
     /*  792025 */     // GIR_Coverage, 19280,
     /*  792025 */     GIR_EraseRootFromParent_Done,
     /*  792026 */   // Label 12275: @792026
     /*  792026 */   GIM_Try, /*On fail goto*//*Label 12276*/ GIMT_Encode4(792101), // Rule ID 19281 //
     /*  792031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  792039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  792042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  792045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  792048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792077 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  792080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792099 */     GIR_RootConstrainSelectedInstOperands,
     /*  792100 */     // GIR_Coverage, 19281,
     /*  792100 */     GIR_EraseRootFromParent_Done,
     /*  792101 */   // Label 12276: @792101
     /*  792101 */   GIM_Try, /*On fail goto*//*Label 12277*/ GIMT_Encode4(792176), // Rule ID 19284 //
     /*  792106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  792117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  792120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  792123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  792126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792152 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  792155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792174 */     GIR_RootConstrainSelectedInstOperands,
     /*  792175 */     // GIR_Coverage, 19284,
     /*  792175 */     GIR_EraseRootFromParent_Done,
     /*  792176 */   // Label 12277: @792176
     /*  792176 */   GIM_Try, /*On fail goto*//*Label 12278*/ GIMT_Encode4(792251), // Rule ID 19285 //
     /*  792181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  792192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  792195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  792198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  792201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792227 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  792230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792249 */     GIR_RootConstrainSelectedInstOperands,
     /*  792250 */     // GIR_Coverage, 19285,
     /*  792250 */     GIR_EraseRootFromParent_Done,
     /*  792251 */   // Label 12278: @792251
     /*  792251 */   GIM_Try, /*On fail goto*//*Label 12279*/ GIMT_Encode4(792326), // Rule ID 19288 //
     /*  792256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  792267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  792270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  792273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  792276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792302 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  792305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792324 */     GIR_RootConstrainSelectedInstOperands,
     /*  792325 */     // GIR_Coverage, 19288,
     /*  792325 */     GIR_EraseRootFromParent_Done,
     /*  792326 */   // Label 12279: @792326
     /*  792326 */   GIM_Try, /*On fail goto*//*Label 12280*/ GIMT_Encode4(792401), // Rule ID 19289 //
     /*  792331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  792342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  792345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  792348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  792351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792377 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  792380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792399 */     GIR_RootConstrainSelectedInstOperands,
     /*  792400 */     // GIR_Coverage, 19289,
     /*  792400 */     GIR_EraseRootFromParent_Done,
     /*  792401 */   // Label 12280: @792401
     /*  792401 */   GIM_Try, /*On fail goto*//*Label 12281*/ GIMT_Encode4(792476), // Rule ID 19292 //
     /*  792406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  792417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  792420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  792423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  792426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792452 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  792455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792474 */     GIR_RootConstrainSelectedInstOperands,
     /*  792475 */     // GIR_Coverage, 19292,
     /*  792475 */     GIR_EraseRootFromParent_Done,
     /*  792476 */   // Label 12281: @792476
     /*  792476 */   GIM_Try, /*On fail goto*//*Label 12282*/ GIMT_Encode4(792551), // Rule ID 19293 //
     /*  792481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  792492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  792495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  792498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  792501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792527 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  792530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792549 */     GIR_RootConstrainSelectedInstOperands,
     /*  792550 */     // GIR_Coverage, 19293,
     /*  792550 */     GIR_EraseRootFromParent_Done,
     /*  792551 */   // Label 12282: @792551
     /*  792551 */   GIM_Try, /*On fail goto*//*Label 12283*/ GIMT_Encode4(792626), // Rule ID 19296 //
     /*  792556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  792567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  792570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  792573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  792576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792602 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  792605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792624 */     GIR_RootConstrainSelectedInstOperands,
     /*  792625 */     // GIR_Coverage, 19296,
     /*  792625 */     GIR_EraseRootFromParent_Done,
     /*  792626 */   // Label 12283: @792626
     /*  792626 */   GIM_Try, /*On fail goto*//*Label 12284*/ GIMT_Encode4(792701), // Rule ID 19297 //
     /*  792631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  792642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  792645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  792648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  792651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792677 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  792680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792699 */     GIR_RootConstrainSelectedInstOperands,
     /*  792700 */     // GIR_Coverage, 19297,
     /*  792700 */     GIR_EraseRootFromParent_Done,
     /*  792701 */   // Label 12284: @792701
     /*  792701 */   GIM_Try, /*On fail goto*//*Label 12285*/ GIMT_Encode4(792776), // Rule ID 19300 //
     /*  792706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  792717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  792720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  792723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  792726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792752 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  792755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792774 */     GIR_RootConstrainSelectedInstOperands,
     /*  792775 */     // GIR_Coverage, 19300,
     /*  792775 */     GIR_EraseRootFromParent_Done,
     /*  792776 */   // Label 12285: @792776
     /*  792776 */   GIM_Try, /*On fail goto*//*Label 12286*/ GIMT_Encode4(792851), // Rule ID 19301 //
     /*  792781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  792792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  792795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  792798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  792801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792827 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  792830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792849 */     GIR_RootConstrainSelectedInstOperands,
     /*  792850 */     // GIR_Coverage, 19301,
     /*  792850 */     GIR_EraseRootFromParent_Done,
     /*  792851 */   // Label 12286: @792851
     /*  792851 */   GIM_Try, /*On fail goto*//*Label 12287*/ GIMT_Encode4(792926), // Rule ID 19304 //
     /*  792856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  792859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  792867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  792870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  792873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  792876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792902 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  792905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792924 */     GIR_RootConstrainSelectedInstOperands,
     /*  792925 */     // GIR_Coverage, 19304,
     /*  792925 */     GIR_EraseRootFromParent_Done,
     /*  792926 */   // Label 12287: @792926
     /*  792926 */   GIM_Try, /*On fail goto*//*Label 12288*/ GIMT_Encode4(793001), // Rule ID 19305 //
     /*  792931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  792942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  792945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  792948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  792951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792977 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  792980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792999 */     GIR_RootConstrainSelectedInstOperands,
     /*  793000 */     // GIR_Coverage, 19305,
     /*  793000 */     GIR_EraseRootFromParent_Done,
     /*  793001 */   // Label 12288: @793001
     /*  793001 */   GIM_Try, /*On fail goto*//*Label 12289*/ GIMT_Encode4(793076), // Rule ID 19308 //
     /*  793006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  793017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  793020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  793023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  793026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793052 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  793055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793074 */     GIR_RootConstrainSelectedInstOperands,
     /*  793075 */     // GIR_Coverage, 19308,
     /*  793075 */     GIR_EraseRootFromParent_Done,
     /*  793076 */   // Label 12289: @793076
     /*  793076 */   GIM_Try, /*On fail goto*//*Label 12290*/ GIMT_Encode4(793151), // Rule ID 19309 //
     /*  793081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  793092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  793095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  793098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  793101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793127 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  793130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793149 */     GIR_RootConstrainSelectedInstOperands,
     /*  793150 */     // GIR_Coverage, 19309,
     /*  793150 */     GIR_EraseRootFromParent_Done,
     /*  793151 */   // Label 12290: @793151
     /*  793151 */   GIM_Try, /*On fail goto*//*Label 12291*/ GIMT_Encode4(793226), // Rule ID 19312 //
     /*  793156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  793167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  793170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  793173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  793176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793202 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  793205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793224 */     GIR_RootConstrainSelectedInstOperands,
     /*  793225 */     // GIR_Coverage, 19312,
     /*  793225 */     GIR_EraseRootFromParent_Done,
     /*  793226 */   // Label 12291: @793226
     /*  793226 */   GIM_Try, /*On fail goto*//*Label 12292*/ GIMT_Encode4(793301), // Rule ID 19313 //
     /*  793231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  793242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  793245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  793248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  793251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793277 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  793280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793299 */     GIR_RootConstrainSelectedInstOperands,
     /*  793300 */     // GIR_Coverage, 19313,
     /*  793300 */     GIR_EraseRootFromParent_Done,
     /*  793301 */   // Label 12292: @793301
     /*  793301 */   GIM_Try, /*On fail goto*//*Label 12293*/ GIMT_Encode4(793376), // Rule ID 19316 //
     /*  793306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  793317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  793320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  793323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  793326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793352 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  793355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793374 */     GIR_RootConstrainSelectedInstOperands,
     /*  793375 */     // GIR_Coverage, 19316,
     /*  793375 */     GIR_EraseRootFromParent_Done,
     /*  793376 */   // Label 12293: @793376
     /*  793376 */   GIM_Try, /*On fail goto*//*Label 12294*/ GIMT_Encode4(793451), // Rule ID 19317 //
     /*  793381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  793392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  793395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  793398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  793401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793427 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  793430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793449 */     GIR_RootConstrainSelectedInstOperands,
     /*  793450 */     // GIR_Coverage, 19317,
     /*  793450 */     GIR_EraseRootFromParent_Done,
     /*  793451 */   // Label 12294: @793451
     /*  793451 */   GIM_Try, /*On fail goto*//*Label 12295*/ GIMT_Encode4(793526), // Rule ID 19320 //
     /*  793456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  793467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  793470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  793473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  793476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793502 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  793505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793524 */     GIR_RootConstrainSelectedInstOperands,
     /*  793525 */     // GIR_Coverage, 19320,
     /*  793525 */     GIR_EraseRootFromParent_Done,
     /*  793526 */   // Label 12295: @793526
     /*  793526 */   GIM_Try, /*On fail goto*//*Label 12296*/ GIMT_Encode4(793601), // Rule ID 19321 //
     /*  793531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  793542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  793545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  793548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  793551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793577 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  793580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793599 */     GIR_RootConstrainSelectedInstOperands,
     /*  793600 */     // GIR_Coverage, 19321,
     /*  793600 */     GIR_EraseRootFromParent_Done,
     /*  793601 */   // Label 12296: @793601
     /*  793601 */   GIM_Try, /*On fail goto*//*Label 12297*/ GIMT_Encode4(793676), // Rule ID 19324 //
     /*  793606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  793617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  793620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  793623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  793626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793652 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  793655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793674 */     GIR_RootConstrainSelectedInstOperands,
     /*  793675 */     // GIR_Coverage, 19324,
     /*  793675 */     GIR_EraseRootFromParent_Done,
     /*  793676 */   // Label 12297: @793676
     /*  793676 */   GIM_Try, /*On fail goto*//*Label 12298*/ GIMT_Encode4(793751), // Rule ID 19325 //
     /*  793681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  793692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  793695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  793698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  793701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793727 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  793730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793749 */     GIR_RootConstrainSelectedInstOperands,
     /*  793750 */     // GIR_Coverage, 19325,
     /*  793750 */     GIR_EraseRootFromParent_Done,
     /*  793751 */   // Label 12298: @793751
     /*  793751 */   GIM_Try, /*On fail goto*//*Label 12299*/ GIMT_Encode4(793826), // Rule ID 19328 //
     /*  793756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  793767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  793770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  793773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  793776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793802 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  793805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793824 */     GIR_RootConstrainSelectedInstOperands,
     /*  793825 */     // GIR_Coverage, 19328,
     /*  793825 */     GIR_EraseRootFromParent_Done,
     /*  793826 */   // Label 12299: @793826
     /*  793826 */   GIM_Try, /*On fail goto*//*Label 12300*/ GIMT_Encode4(793901), // Rule ID 19329 //
     /*  793831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  793842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  793845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  793848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  793851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793877 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  793880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793899 */     GIR_RootConstrainSelectedInstOperands,
     /*  793900 */     // GIR_Coverage, 19329,
     /*  793900 */     GIR_EraseRootFromParent_Done,
     /*  793901 */   // Label 12300: @793901
     /*  793901 */   GIM_Try, /*On fail goto*//*Label 12301*/ GIMT_Encode4(793976), // Rule ID 19332 //
     /*  793906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  793909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  793917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  793920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  793923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  793926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  793952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  793955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793974 */     GIR_RootConstrainSelectedInstOperands,
     /*  793975 */     // GIR_Coverage, 19332,
     /*  793975 */     GIR_EraseRootFromParent_Done,
     /*  793976 */   // Label 12301: @793976
     /*  793976 */   GIM_Try, /*On fail goto*//*Label 12302*/ GIMT_Encode4(794051), // Rule ID 19333 //
     /*  793981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  793984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  793992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  793995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  793998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  794001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794027 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  794030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794049 */     GIR_RootConstrainSelectedInstOperands,
     /*  794050 */     // GIR_Coverage, 19333,
     /*  794050 */     GIR_EraseRootFromParent_Done,
     /*  794051 */   // Label 12302: @794051
     /*  794051 */   GIM_Try, /*On fail goto*//*Label 12303*/ GIMT_Encode4(794126), // Rule ID 19336 //
     /*  794056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  794059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  794067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  794070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  794073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  794076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  794105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794124 */     GIR_RootConstrainSelectedInstOperands,
     /*  794125 */     // GIR_Coverage, 19336,
     /*  794125 */     GIR_EraseRootFromParent_Done,
     /*  794126 */   // Label 12303: @794126
     /*  794126 */   GIM_Try, /*On fail goto*//*Label 12304*/ GIMT_Encode4(794201), // Rule ID 19337 //
     /*  794131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  794142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  794145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  794148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  794151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794177 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  794180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794199 */     GIR_RootConstrainSelectedInstOperands,
     /*  794200 */     // GIR_Coverage, 19337,
     /*  794200 */     GIR_EraseRootFromParent_Done,
     /*  794201 */   // Label 12304: @794201
     /*  794201 */   GIM_Try, /*On fail goto*//*Label 12305*/ GIMT_Encode4(794276), // Rule ID 19340 //
     /*  794206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  794209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  794217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  794220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  794223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  794226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794252 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  794255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794274 */     GIR_RootConstrainSelectedInstOperands,
     /*  794275 */     // GIR_Coverage, 19340,
     /*  794275 */     GIR_EraseRootFromParent_Done,
     /*  794276 */   // Label 12305: @794276
     /*  794276 */   GIM_Try, /*On fail goto*//*Label 12306*/ GIMT_Encode4(794351), // Rule ID 19341 //
     /*  794281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  794292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  794295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  794298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  794301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794327 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  794330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794349 */     GIR_RootConstrainSelectedInstOperands,
     /*  794350 */     // GIR_Coverage, 19341,
     /*  794350 */     GIR_EraseRootFromParent_Done,
     /*  794351 */   // Label 12306: @794351
     /*  794351 */   GIM_Try, /*On fail goto*//*Label 12307*/ GIMT_Encode4(794426), // Rule ID 19344 //
     /*  794356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  794367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  794370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  794373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794402 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  794405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794424 */     GIR_RootConstrainSelectedInstOperands,
     /*  794425 */     // GIR_Coverage, 19344,
     /*  794425 */     GIR_EraseRootFromParent_Done,
     /*  794426 */   // Label 12307: @794426
     /*  794426 */   GIM_Try, /*On fail goto*//*Label 12308*/ GIMT_Encode4(794501), // Rule ID 19345 //
     /*  794431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  794442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  794445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  794448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794477 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  794480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794499 */     GIR_RootConstrainSelectedInstOperands,
     /*  794500 */     // GIR_Coverage, 19345,
     /*  794500 */     GIR_EraseRootFromParent_Done,
     /*  794501 */   // Label 12308: @794501
     /*  794501 */   GIM_Try, /*On fail goto*//*Label 12309*/ GIMT_Encode4(794576), // Rule ID 19348 //
     /*  794506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  794517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  794520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  794523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794552 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  794555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794574 */     GIR_RootConstrainSelectedInstOperands,
     /*  794575 */     // GIR_Coverage, 19348,
     /*  794575 */     GIR_EraseRootFromParent_Done,
     /*  794576 */   // Label 12309: @794576
     /*  794576 */   GIM_Try, /*On fail goto*//*Label 12310*/ GIMT_Encode4(794651), // Rule ID 19349 //
     /*  794581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  794592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  794595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  794598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794627 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  794630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794649 */     GIR_RootConstrainSelectedInstOperands,
     /*  794650 */     // GIR_Coverage, 19349,
     /*  794650 */     GIR_EraseRootFromParent_Done,
     /*  794651 */   // Label 12310: @794651
     /*  794651 */   GIM_Try, /*On fail goto*//*Label 12311*/ GIMT_Encode4(794726), // Rule ID 19352 //
     /*  794656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  794667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  794670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  794673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  794695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794702 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  794705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794724 */     GIR_RootConstrainSelectedInstOperands,
     /*  794725 */     // GIR_Coverage, 19352,
     /*  794725 */     GIR_EraseRootFromParent_Done,
     /*  794726 */   // Label 12311: @794726
     /*  794726 */   GIM_Try, /*On fail goto*//*Label 12312*/ GIMT_Encode4(794801), // Rule ID 19353 //
     /*  794731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  794742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  794745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  794748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  794770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794777 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  794780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794799 */     GIR_RootConstrainSelectedInstOperands,
     /*  794800 */     // GIR_Coverage, 19353,
     /*  794800 */     GIR_EraseRootFromParent_Done,
     /*  794801 */   // Label 12312: @794801
     /*  794801 */   GIM_Try, /*On fail goto*//*Label 12313*/ GIMT_Encode4(794876), // Rule ID 19356 //
     /*  794806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  794817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  794820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  794823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794852 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  794855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794874 */     GIR_RootConstrainSelectedInstOperands,
     /*  794875 */     // GIR_Coverage, 19356,
     /*  794875 */     GIR_EraseRootFromParent_Done,
     /*  794876 */   // Label 12313: @794876
     /*  794876 */   GIM_Try, /*On fail goto*//*Label 12314*/ GIMT_Encode4(794951), // Rule ID 19357 //
     /*  794881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  794892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  794895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  794898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794927 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  794930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794949 */     GIR_RootConstrainSelectedInstOperands,
     /*  794950 */     // GIR_Coverage, 19357,
     /*  794950 */     GIR_EraseRootFromParent_Done,
     /*  794951 */   // Label 12314: @794951
     /*  794951 */   GIM_Try, /*On fail goto*//*Label 12315*/ GIMT_Encode4(795026), // Rule ID 19360 //
     /*  794956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  794967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  794970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  794973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  794995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795002 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  795005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795024 */     GIR_RootConstrainSelectedInstOperands,
     /*  795025 */     // GIR_Coverage, 19360,
     /*  795025 */     GIR_EraseRootFromParent_Done,
     /*  795026 */   // Label 12315: @795026
     /*  795026 */   GIM_Try, /*On fail goto*//*Label 12316*/ GIMT_Encode4(795101), // Rule ID 19361 //
     /*  795031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  795042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  795045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  795048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795077 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  795080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795099 */     GIR_RootConstrainSelectedInstOperands,
     /*  795100 */     // GIR_Coverage, 19361,
     /*  795100 */     GIR_EraseRootFromParent_Done,
     /*  795101 */   // Label 12316: @795101
     /*  795101 */   GIM_Try, /*On fail goto*//*Label 12317*/ GIMT_Encode4(795176), // Rule ID 19364 //
     /*  795106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  795109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  795117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  795120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  795123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  795145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795152 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  795152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  795155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795174 */     GIR_RootConstrainSelectedInstOperands,
     /*  795175 */     // GIR_Coverage, 19364,
     /*  795175 */     GIR_EraseRootFromParent_Done,
     /*  795176 */   // Label 12317: @795176
     /*  795176 */   GIM_Try, /*On fail goto*//*Label 12318*/ GIMT_Encode4(795251), // Rule ID 19365 //
     /*  795181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  795184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  795192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  795195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  795198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  795220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795227 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  795227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  795230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795249 */     GIR_RootConstrainSelectedInstOperands,
     /*  795250 */     // GIR_Coverage, 19365,
     /*  795250 */     GIR_EraseRootFromParent_Done,
     /*  795251 */   // Label 12318: @795251
     /*  795251 */   GIM_Try, /*On fail goto*//*Label 12319*/ GIMT_Encode4(795326), // Rule ID 19368 //
     /*  795256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  795267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  795270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  795273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795302 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  795305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795324 */     GIR_RootConstrainSelectedInstOperands,
     /*  795325 */     // GIR_Coverage, 19368,
     /*  795325 */     GIR_EraseRootFromParent_Done,
     /*  795326 */   // Label 12319: @795326
     /*  795326 */   GIM_Try, /*On fail goto*//*Label 12320*/ GIMT_Encode4(795401), // Rule ID 19369 //
     /*  795331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  795342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  795345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  795348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795377 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  795380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795399 */     GIR_RootConstrainSelectedInstOperands,
     /*  795400 */     // GIR_Coverage, 19369,
     /*  795400 */     GIR_EraseRootFromParent_Done,
     /*  795401 */   // Label 12320: @795401
     /*  795401 */   GIM_Try, /*On fail goto*//*Label 12321*/ GIMT_Encode4(795476), // Rule ID 19372 //
     /*  795406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  795417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  795420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  795423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795452 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  795455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795474 */     GIR_RootConstrainSelectedInstOperands,
     /*  795475 */     // GIR_Coverage, 19372,
     /*  795475 */     GIR_EraseRootFromParent_Done,
     /*  795476 */   // Label 12321: @795476
     /*  795476 */   GIM_Try, /*On fail goto*//*Label 12322*/ GIMT_Encode4(795551), // Rule ID 19373 //
     /*  795481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  795492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  795495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  795498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795527 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  795530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795549 */     GIR_RootConstrainSelectedInstOperands,
     /*  795550 */     // GIR_Coverage, 19373,
     /*  795550 */     GIR_EraseRootFromParent_Done,
     /*  795551 */   // Label 12322: @795551
     /*  795551 */   GIM_Try, /*On fail goto*//*Label 12323*/ GIMT_Encode4(795626), // Rule ID 19376 //
     /*  795556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  795567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  795570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  795573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795602 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  795605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795624 */     GIR_RootConstrainSelectedInstOperands,
     /*  795625 */     // GIR_Coverage, 19376,
     /*  795625 */     GIR_EraseRootFromParent_Done,
     /*  795626 */   // Label 12323: @795626
     /*  795626 */   GIM_Try, /*On fail goto*//*Label 12324*/ GIMT_Encode4(795701), // Rule ID 19377 //
     /*  795631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  795642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  795645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  795648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795677 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  795680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795699 */     GIR_RootConstrainSelectedInstOperands,
     /*  795700 */     // GIR_Coverage, 19377,
     /*  795700 */     GIR_EraseRootFromParent_Done,
     /*  795701 */   // Label 12324: @795701
     /*  795701 */   GIM_Try, /*On fail goto*//*Label 12325*/ GIMT_Encode4(795776), // Rule ID 19380 //
     /*  795706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  795709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  795717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  795720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  795723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795752 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  795755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795774 */     GIR_RootConstrainSelectedInstOperands,
     /*  795775 */     // GIR_Coverage, 19380,
     /*  795775 */     GIR_EraseRootFromParent_Done,
     /*  795776 */   // Label 12325: @795776
     /*  795776 */   GIM_Try, /*On fail goto*//*Label 12326*/ GIMT_Encode4(795851), // Rule ID 19381 //
     /*  795781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  795792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  795795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  795798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795827 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  795830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795849 */     GIR_RootConstrainSelectedInstOperands,
     /*  795850 */     // GIR_Coverage, 19381,
     /*  795850 */     GIR_EraseRootFromParent_Done,
     /*  795851 */   // Label 12326: @795851
     /*  795851 */   GIM_Try, /*On fail goto*//*Label 12327*/ GIMT_Encode4(795926), // Rule ID 19384 //
     /*  795856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  795859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  795867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  795870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  795873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795902 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  795905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795924 */     GIR_RootConstrainSelectedInstOperands,
     /*  795925 */     // GIR_Coverage, 19384,
     /*  795925 */     GIR_EraseRootFromParent_Done,
     /*  795926 */   // Label 12327: @795926
     /*  795926 */   GIM_Try, /*On fail goto*//*Label 12328*/ GIMT_Encode4(796001), // Rule ID 19385 //
     /*  795931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  795942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  795945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  795948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795977 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  795980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795999 */     GIR_RootConstrainSelectedInstOperands,
     /*  796000 */     // GIR_Coverage, 19385,
     /*  796000 */     GIR_EraseRootFromParent_Done,
     /*  796001 */   // Label 12328: @796001
     /*  796001 */   GIM_Try, /*On fail goto*//*Label 12329*/ GIMT_Encode4(796076), // Rule ID 19388 //
     /*  796006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  796017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  796020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  796023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796052 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  796055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796074 */     GIR_RootConstrainSelectedInstOperands,
     /*  796075 */     // GIR_Coverage, 19388,
     /*  796075 */     GIR_EraseRootFromParent_Done,
     /*  796076 */   // Label 12329: @796076
     /*  796076 */   GIM_Try, /*On fail goto*//*Label 12330*/ GIMT_Encode4(796151), // Rule ID 19389 //
     /*  796081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  796092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  796095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  796098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796127 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  796130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796149 */     GIR_RootConstrainSelectedInstOperands,
     /*  796150 */     // GIR_Coverage, 19389,
     /*  796150 */     GIR_EraseRootFromParent_Done,
     /*  796151 */   // Label 12330: @796151
     /*  796151 */   GIM_Try, /*On fail goto*//*Label 12331*/ GIMT_Encode4(796226), // Rule ID 19392 //
     /*  796156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  796167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  796170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  796173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796202 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  796202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  796205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796224 */     GIR_RootConstrainSelectedInstOperands,
     /*  796225 */     // GIR_Coverage, 19392,
     /*  796225 */     GIR_EraseRootFromParent_Done,
     /*  796226 */   // Label 12331: @796226
     /*  796226 */   GIM_Try, /*On fail goto*//*Label 12332*/ GIMT_Encode4(796301), // Rule ID 19393 //
     /*  796231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  796234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  796242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  796245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  796248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796277 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  796277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  796280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796299 */     GIR_RootConstrainSelectedInstOperands,
     /*  796300 */     // GIR_Coverage, 19393,
     /*  796300 */     GIR_EraseRootFromParent_Done,
     /*  796301 */   // Label 12332: @796301
     /*  796301 */   GIM_Try, /*On fail goto*//*Label 12333*/ GIMT_Encode4(796376), // Rule ID 19396 //
     /*  796306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  796317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  796320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  796323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796352 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  796352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  796355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796374 */     GIR_RootConstrainSelectedInstOperands,
     /*  796375 */     // GIR_Coverage, 19396,
     /*  796375 */     GIR_EraseRootFromParent_Done,
     /*  796376 */   // Label 12333: @796376
     /*  796376 */   GIM_Try, /*On fail goto*//*Label 12334*/ GIMT_Encode4(796451), // Rule ID 19397 //
     /*  796381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  796384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  796392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  796395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  796398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796427 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  796427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  796430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796449 */     GIR_RootConstrainSelectedInstOperands,
     /*  796450 */     // GIR_Coverage, 19397,
     /*  796450 */     GIR_EraseRootFromParent_Done,
     /*  796451 */   // Label 12334: @796451
     /*  796451 */   GIM_Try, /*On fail goto*//*Label 12335*/ GIMT_Encode4(796526), // Rule ID 19400 //
     /*  796456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  796467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  796470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  796473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796502 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  796502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  796505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796524 */     GIR_RootConstrainSelectedInstOperands,
     /*  796525 */     // GIR_Coverage, 19400,
     /*  796525 */     GIR_EraseRootFromParent_Done,
     /*  796526 */   // Label 12335: @796526
     /*  796526 */   GIM_Try, /*On fail goto*//*Label 12336*/ GIMT_Encode4(796601), // Rule ID 19401 //
     /*  796531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  796534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  796542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  796545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  796548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796577 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  796577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  796580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796599 */     GIR_RootConstrainSelectedInstOperands,
     /*  796600 */     // GIR_Coverage, 19401,
     /*  796600 */     GIR_EraseRootFromParent_Done,
     /*  796601 */   // Label 12336: @796601
     /*  796601 */   GIM_Try, /*On fail goto*//*Label 12337*/ GIMT_Encode4(796676), // Rule ID 19404 //
     /*  796606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  796617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  796620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  796623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  796626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796652 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  796655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796674 */     GIR_RootConstrainSelectedInstOperands,
     /*  796675 */     // GIR_Coverage, 19404,
     /*  796675 */     GIR_EraseRootFromParent_Done,
     /*  796676 */   // Label 12337: @796676
     /*  796676 */   GIM_Try, /*On fail goto*//*Label 12338*/ GIMT_Encode4(796751), // Rule ID 19405 //
     /*  796681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  796692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  796695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  796698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  796701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796727 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  796730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796749 */     GIR_RootConstrainSelectedInstOperands,
     /*  796750 */     // GIR_Coverage, 19405,
     /*  796750 */     GIR_EraseRootFromParent_Done,
     /*  796751 */   // Label 12338: @796751
     /*  796751 */   GIM_Try, /*On fail goto*//*Label 12339*/ GIMT_Encode4(796826), // Rule ID 19408 //
     /*  796756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  796767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  796770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  796773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  796776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796802 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  796805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796824 */     GIR_RootConstrainSelectedInstOperands,
     /*  796825 */     // GIR_Coverage, 19408,
     /*  796825 */     GIR_EraseRootFromParent_Done,
     /*  796826 */   // Label 12339: @796826
     /*  796826 */   GIM_Try, /*On fail goto*//*Label 12340*/ GIMT_Encode4(796901), // Rule ID 19409 //
     /*  796831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  796842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  796845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  796848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  796851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796877 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  796880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796899 */     GIR_RootConstrainSelectedInstOperands,
     /*  796900 */     // GIR_Coverage, 19409,
     /*  796900 */     GIR_EraseRootFromParent_Done,
     /*  796901 */   // Label 12340: @796901
     /*  796901 */   GIM_Try, /*On fail goto*//*Label 12341*/ GIMT_Encode4(796976), // Rule ID 19412 //
     /*  796906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  796917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  796920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  796923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  796926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796952 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  796955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796974 */     GIR_RootConstrainSelectedInstOperands,
     /*  796975 */     // GIR_Coverage, 19412,
     /*  796975 */     GIR_EraseRootFromParent_Done,
     /*  796976 */   // Label 12341: @796976
     /*  796976 */   GIM_Try, /*On fail goto*//*Label 12342*/ GIMT_Encode4(797051), // Rule ID 19413 //
     /*  796981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  796992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  796995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  796998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  797001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797027 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  797030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797049 */     GIR_RootConstrainSelectedInstOperands,
     /*  797050 */     // GIR_Coverage, 19413,
     /*  797050 */     GIR_EraseRootFromParent_Done,
     /*  797051 */   // Label 12342: @797051
     /*  797051 */   GIM_Try, /*On fail goto*//*Label 12343*/ GIMT_Encode4(797126), // Rule ID 19416 //
     /*  797056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  797067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  797070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  797073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  797076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  797105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797124 */     GIR_RootConstrainSelectedInstOperands,
     /*  797125 */     // GIR_Coverage, 19416,
     /*  797125 */     GIR_EraseRootFromParent_Done,
     /*  797126 */   // Label 12343: @797126
     /*  797126 */   GIM_Try, /*On fail goto*//*Label 12344*/ GIMT_Encode4(797201), // Rule ID 19417 //
     /*  797131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  797142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  797145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  797148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  797151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797177 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  797180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797199 */     GIR_RootConstrainSelectedInstOperands,
     /*  797200 */     // GIR_Coverage, 19417,
     /*  797200 */     GIR_EraseRootFromParent_Done,
     /*  797201 */   // Label 12344: @797201
     /*  797201 */   GIM_Try, /*On fail goto*//*Label 12345*/ GIMT_Encode4(797276), // Rule ID 19420 //
     /*  797206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  797209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  797217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  797220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  797223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  797226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  797252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  797255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797274 */     GIR_RootConstrainSelectedInstOperands,
     /*  797275 */     // GIR_Coverage, 19420,
     /*  797275 */     GIR_EraseRootFromParent_Done,
     /*  797276 */   // Label 12345: @797276
     /*  797276 */   GIM_Try, /*On fail goto*//*Label 12346*/ GIMT_Encode4(797351), // Rule ID 19421 //
     /*  797281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  797284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  797292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  797295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  797298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  797301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797327 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  797330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797349 */     GIR_RootConstrainSelectedInstOperands,
     /*  797350 */     // GIR_Coverage, 19421,
     /*  797350 */     GIR_EraseRootFromParent_Done,
     /*  797351 */   // Label 12346: @797351
     /*  797351 */   GIM_Try, /*On fail goto*//*Label 12347*/ GIMT_Encode4(797426), // Rule ID 19424 //
     /*  797356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  797359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  797367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  797370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  797373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  797376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797402 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  797405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797424 */     GIR_RootConstrainSelectedInstOperands,
     /*  797425 */     // GIR_Coverage, 19424,
     /*  797425 */     GIR_EraseRootFromParent_Done,
     /*  797426 */   // Label 12347: @797426
     /*  797426 */   GIM_Try, /*On fail goto*//*Label 12348*/ GIMT_Encode4(797501), // Rule ID 19425 //
     /*  797431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  797434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  797442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  797445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  797448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  797451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797477 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  797480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797499 */     GIR_RootConstrainSelectedInstOperands,
     /*  797500 */     // GIR_Coverage, 19425,
     /*  797500 */     GIR_EraseRootFromParent_Done,
     /*  797501 */   // Label 12348: @797501
     /*  797501 */   GIM_Try, /*On fail goto*//*Label 12349*/ GIMT_Encode4(797576), // Rule ID 19428 //
     /*  797506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  797517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  797520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  797523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  797526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  797555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797574 */     GIR_RootConstrainSelectedInstOperands,
     /*  797575 */     // GIR_Coverage, 19428,
     /*  797575 */     GIR_EraseRootFromParent_Done,
     /*  797576 */   // Label 12349: @797576
     /*  797576 */   GIM_Try, /*On fail goto*//*Label 12350*/ GIMT_Encode4(797651), // Rule ID 19429 //
     /*  797581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  797592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  797595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  797598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  797601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797627 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  797630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797649 */     GIR_RootConstrainSelectedInstOperands,
     /*  797650 */     // GIR_Coverage, 19429,
     /*  797650 */     GIR_EraseRootFromParent_Done,
     /*  797651 */   // Label 12350: @797651
     /*  797651 */   GIM_Try, /*On fail goto*//*Label 12351*/ GIMT_Encode4(797726), // Rule ID 19432 //
     /*  797656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  797667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  797670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  797673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  797676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797702 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  797705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797724 */     GIR_RootConstrainSelectedInstOperands,
     /*  797725 */     // GIR_Coverage, 19432,
     /*  797725 */     GIR_EraseRootFromParent_Done,
     /*  797726 */   // Label 12351: @797726
     /*  797726 */   GIM_Try, /*On fail goto*//*Label 12352*/ GIMT_Encode4(797801), // Rule ID 19433 //
     /*  797731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  797742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  797745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  797748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  797751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797777 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  797780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797799 */     GIR_RootConstrainSelectedInstOperands,
     /*  797800 */     // GIR_Coverage, 19433,
     /*  797800 */     GIR_EraseRootFromParent_Done,
     /*  797801 */   // Label 12352: @797801
     /*  797801 */   GIM_Try, /*On fail goto*//*Label 12353*/ GIMT_Encode4(797876), // Rule ID 19436 //
     /*  797806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  797817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  797820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  797823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  797826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797852 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  797855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797874 */     GIR_RootConstrainSelectedInstOperands,
     /*  797875 */     // GIR_Coverage, 19436,
     /*  797875 */     GIR_EraseRootFromParent_Done,
     /*  797876 */   // Label 12353: @797876
     /*  797876 */   GIM_Try, /*On fail goto*//*Label 12354*/ GIMT_Encode4(797951), // Rule ID 19437 //
     /*  797881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  797892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  797895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  797898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  797901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797927 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  797930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797949 */     GIR_RootConstrainSelectedInstOperands,
     /*  797950 */     // GIR_Coverage, 19437,
     /*  797950 */     GIR_EraseRootFromParent_Done,
     /*  797951 */   // Label 12354: @797951
     /*  797951 */   GIM_Try, /*On fail goto*//*Label 12355*/ GIMT_Encode4(798026), // Rule ID 19440 //
     /*  797956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  797959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  797967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  797970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  797973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  797976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798002 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  798005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798024 */     GIR_RootConstrainSelectedInstOperands,
     /*  798025 */     // GIR_Coverage, 19440,
     /*  798025 */     GIR_EraseRootFromParent_Done,
     /*  798026 */   // Label 12355: @798026
     /*  798026 */   GIM_Try, /*On fail goto*//*Label 12356*/ GIMT_Encode4(798101), // Rule ID 19441 //
     /*  798031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  798042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  798045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  798048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  798051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798077 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  798080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798099 */     GIR_RootConstrainSelectedInstOperands,
     /*  798100 */     // GIR_Coverage, 19441,
     /*  798100 */     GIR_EraseRootFromParent_Done,
     /*  798101 */   // Label 12356: @798101
     /*  798101 */   GIM_Try, /*On fail goto*//*Label 12357*/ GIMT_Encode4(798176), // Rule ID 19444 //
     /*  798106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  798117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  798120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  798123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  798126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798152 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  798155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798174 */     GIR_RootConstrainSelectedInstOperands,
     /*  798175 */     // GIR_Coverage, 19444,
     /*  798175 */     GIR_EraseRootFromParent_Done,
     /*  798176 */   // Label 12357: @798176
     /*  798176 */   GIM_Try, /*On fail goto*//*Label 12358*/ GIMT_Encode4(798251), // Rule ID 19445 //
     /*  798181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  798192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  798195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  798198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  798201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798227 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  798230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798249 */     GIR_RootConstrainSelectedInstOperands,
     /*  798250 */     // GIR_Coverage, 19445,
     /*  798250 */     GIR_EraseRootFromParent_Done,
     /*  798251 */   // Label 12358: @798251
     /*  798251 */   GIM_Try, /*On fail goto*//*Label 12359*/ GIMT_Encode4(798326), // Rule ID 19448 //
     /*  798256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  798267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  798270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  798273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  798276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798302 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  798305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798324 */     GIR_RootConstrainSelectedInstOperands,
     /*  798325 */     // GIR_Coverage, 19448,
     /*  798325 */     GIR_EraseRootFromParent_Done,
     /*  798326 */   // Label 12359: @798326
     /*  798326 */   GIM_Try, /*On fail goto*//*Label 12360*/ GIMT_Encode4(798401), // Rule ID 19449 //
     /*  798331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  798342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  798345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  798348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  798351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798377 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  798380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798399 */     GIR_RootConstrainSelectedInstOperands,
     /*  798400 */     // GIR_Coverage, 19449,
     /*  798400 */     GIR_EraseRootFromParent_Done,
     /*  798401 */   // Label 12360: @798401
     /*  798401 */   GIM_Try, /*On fail goto*//*Label 12361*/ GIMT_Encode4(798476), // Rule ID 19452 //
     /*  798406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  798409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  798417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  798420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  798423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  798426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798452 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  798455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798474 */     GIR_RootConstrainSelectedInstOperands,
     /*  798475 */     // GIR_Coverage, 19452,
     /*  798475 */     GIR_EraseRootFromParent_Done,
     /*  798476 */   // Label 12361: @798476
     /*  798476 */   GIM_Try, /*On fail goto*//*Label 12362*/ GIMT_Encode4(798551), // Rule ID 19453 //
     /*  798481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  798484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  798492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  798495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  798498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  798501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798527 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  798530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798549 */     GIR_RootConstrainSelectedInstOperands,
     /*  798550 */     // GIR_Coverage, 19453,
     /*  798550 */     GIR_EraseRootFromParent_Done,
     /*  798551 */   // Label 12362: @798551
     /*  798551 */   GIM_Try, /*On fail goto*//*Label 12363*/ GIMT_Encode4(798626), // Rule ID 19456 //
     /*  798556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  798559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  798567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  798570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  798573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  798576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798602 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  798605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798624 */     GIR_RootConstrainSelectedInstOperands,
     /*  798625 */     // GIR_Coverage, 19456,
     /*  798625 */     GIR_EraseRootFromParent_Done,
     /*  798626 */   // Label 12363: @798626
     /*  798626 */   GIM_Try, /*On fail goto*//*Label 12364*/ GIMT_Encode4(798701), // Rule ID 19457 //
     /*  798631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  798634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  798642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  798645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  798648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  798651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798677 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  798680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798699 */     GIR_RootConstrainSelectedInstOperands,
     /*  798700 */     // GIR_Coverage, 19457,
     /*  798700 */     GIR_EraseRootFromParent_Done,
     /*  798701 */   // Label 12364: @798701
     /*  798701 */   GIM_Try, /*On fail goto*//*Label 12365*/ GIMT_Encode4(798776), // Rule ID 19460 //
     /*  798706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  798709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  798717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  798720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  798723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  798726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798752 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  798755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798774 */     GIR_RootConstrainSelectedInstOperands,
     /*  798775 */     // GIR_Coverage, 19460,
     /*  798775 */     GIR_EraseRootFromParent_Done,
     /*  798776 */   // Label 12365: @798776
     /*  798776 */   GIM_Try, /*On fail goto*//*Label 12366*/ GIMT_Encode4(798851), // Rule ID 19461 //
     /*  798781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  798784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  798792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  798795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  798798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  798801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798827 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  798830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798849 */     GIR_RootConstrainSelectedInstOperands,
     /*  798850 */     // GIR_Coverage, 19461,
     /*  798850 */     GIR_EraseRootFromParent_Done,
     /*  798851 */   // Label 12366: @798851
     /*  798851 */   GIM_Try, /*On fail goto*//*Label 12367*/ GIMT_Encode4(798926), // Rule ID 19464 //
     /*  798856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  798867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  798870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  798873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  798876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  798895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798902 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  798905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798924 */     GIR_RootConstrainSelectedInstOperands,
     /*  798925 */     // GIR_Coverage, 19464,
     /*  798925 */     GIR_EraseRootFromParent_Done,
     /*  798926 */   // Label 12367: @798926
     /*  798926 */   GIM_Try, /*On fail goto*//*Label 12368*/ GIMT_Encode4(799001), // Rule ID 19465 //
     /*  798931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  798942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  798945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  798948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  798951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  798970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798977 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  798980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798999 */     GIR_RootConstrainSelectedInstOperands,
     /*  799000 */     // GIR_Coverage, 19465,
     /*  799000 */     GIR_EraseRootFromParent_Done,
     /*  799001 */   // Label 12368: @799001
     /*  799001 */   GIM_Try, /*On fail goto*//*Label 12369*/ GIMT_Encode4(799076), // Rule ID 19468 //
     /*  799006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  799017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  799020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  799023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  799055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799074 */     GIR_RootConstrainSelectedInstOperands,
     /*  799075 */     // GIR_Coverage, 19468,
     /*  799075 */     GIR_EraseRootFromParent_Done,
     /*  799076 */   // Label 12369: @799076
     /*  799076 */   GIM_Try, /*On fail goto*//*Label 12370*/ GIMT_Encode4(799151), // Rule ID 19469 //
     /*  799081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  799092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  799095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  799098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799127 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  799130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799149 */     GIR_RootConstrainSelectedInstOperands,
     /*  799150 */     // GIR_Coverage, 19469,
     /*  799150 */     GIR_EraseRootFromParent_Done,
     /*  799151 */   // Label 12370: @799151
     /*  799151 */   GIM_Try, /*On fail goto*//*Label 12371*/ GIMT_Encode4(799226), // Rule ID 19472 //
     /*  799156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  799167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  799170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  799173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799202 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  799205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799224 */     GIR_RootConstrainSelectedInstOperands,
     /*  799225 */     // GIR_Coverage, 19472,
     /*  799225 */     GIR_EraseRootFromParent_Done,
     /*  799226 */   // Label 12371: @799226
     /*  799226 */   GIM_Try, /*On fail goto*//*Label 12372*/ GIMT_Encode4(799301), // Rule ID 19473 //
     /*  799231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  799242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  799245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  799248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799277 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  799280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799299 */     GIR_RootConstrainSelectedInstOperands,
     /*  799300 */     // GIR_Coverage, 19473,
     /*  799300 */     GIR_EraseRootFromParent_Done,
     /*  799301 */   // Label 12372: @799301
     /*  799301 */   GIM_Try, /*On fail goto*//*Label 12373*/ GIMT_Encode4(799376), // Rule ID 19476 //
     /*  799306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  799317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  799320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  799323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  799355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799374 */     GIR_RootConstrainSelectedInstOperands,
     /*  799375 */     // GIR_Coverage, 19476,
     /*  799375 */     GIR_EraseRootFromParent_Done,
     /*  799376 */   // Label 12373: @799376
     /*  799376 */   GIM_Try, /*On fail goto*//*Label 12374*/ GIMT_Encode4(799451), // Rule ID 19477 //
     /*  799381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  799392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  799395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  799398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799427 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  799430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799449 */     GIR_RootConstrainSelectedInstOperands,
     /*  799450 */     // GIR_Coverage, 19477,
     /*  799450 */     GIR_EraseRootFromParent_Done,
     /*  799451 */   // Label 12374: @799451
     /*  799451 */   GIM_Try, /*On fail goto*//*Label 12375*/ GIMT_Encode4(799526), // Rule ID 19480 //
     /*  799456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  799467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  799470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  799473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799502 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  799505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799524 */     GIR_RootConstrainSelectedInstOperands,
     /*  799525 */     // GIR_Coverage, 19480,
     /*  799525 */     GIR_EraseRootFromParent_Done,
     /*  799526 */   // Label 12375: @799526
     /*  799526 */   GIM_Try, /*On fail goto*//*Label 12376*/ GIMT_Encode4(799601), // Rule ID 19481 //
     /*  799531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  799542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  799545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  799548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799577 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  799580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799599 */     GIR_RootConstrainSelectedInstOperands,
     /*  799600 */     // GIR_Coverage, 19481,
     /*  799600 */     GIR_EraseRootFromParent_Done,
     /*  799601 */   // Label 12376: @799601
     /*  799601 */   GIM_Try, /*On fail goto*//*Label 12377*/ GIMT_Encode4(799676), // Rule ID 19484 //
     /*  799606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  799617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  799620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  799623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  799626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  799645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799652 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  799655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799674 */     GIR_RootConstrainSelectedInstOperands,
     /*  799675 */     // GIR_Coverage, 19484,
     /*  799675 */     GIR_EraseRootFromParent_Done,
     /*  799676 */   // Label 12377: @799676
     /*  799676 */   GIM_Try, /*On fail goto*//*Label 12378*/ GIMT_Encode4(799751), // Rule ID 19485 //
     /*  799681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  799692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  799695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  799698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  799701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  799720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799727 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  799730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799749 */     GIR_RootConstrainSelectedInstOperands,
     /*  799750 */     // GIR_Coverage, 19485,
     /*  799750 */     GIR_EraseRootFromParent_Done,
     /*  799751 */   // Label 12378: @799751
     /*  799751 */   GIM_Try, /*On fail goto*//*Label 12379*/ GIMT_Encode4(799826), // Rule ID 19488 //
     /*  799756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  799767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  799770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  799773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799802 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  799805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799824 */     GIR_RootConstrainSelectedInstOperands,
     /*  799825 */     // GIR_Coverage, 19488,
     /*  799825 */     GIR_EraseRootFromParent_Done,
     /*  799826 */   // Label 12379: @799826
     /*  799826 */   GIM_Try, /*On fail goto*//*Label 12380*/ GIMT_Encode4(799901), // Rule ID 19489 //
     /*  799831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  799842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  799845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  799848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799877 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  799880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799899 */     GIR_RootConstrainSelectedInstOperands,
     /*  799900 */     // GIR_Coverage, 19489,
     /*  799900 */     GIR_EraseRootFromParent_Done,
     /*  799901 */   // Label 12380: @799901
     /*  799901 */   GIM_Try, /*On fail goto*//*Label 12381*/ GIMT_Encode4(799976), // Rule ID 19492 //
     /*  799906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  799917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  799920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  799923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799952 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  799955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799974 */     GIR_RootConstrainSelectedInstOperands,
     /*  799975 */     // GIR_Coverage, 19492,
     /*  799975 */     GIR_EraseRootFromParent_Done,
     /*  799976 */   // Label 12381: @799976
     /*  799976 */   GIM_Try, /*On fail goto*//*Label 12382*/ GIMT_Encode4(800051), // Rule ID 19493 //
     /*  799981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  799992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  799995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  799998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800027 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  800030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800049 */     GIR_RootConstrainSelectedInstOperands,
     /*  800050 */     // GIR_Coverage, 19493,
     /*  800050 */     GIR_EraseRootFromParent_Done,
     /*  800051 */   // Label 12382: @800051
     /*  800051 */   GIM_Try, /*On fail goto*//*Label 12383*/ GIMT_Encode4(800126), // Rule ID 19496 //
     /*  800056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  800067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  800070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  800073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800102 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  800105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800124 */     GIR_RootConstrainSelectedInstOperands,
     /*  800125 */     // GIR_Coverage, 19496,
     /*  800125 */     GIR_EraseRootFromParent_Done,
     /*  800126 */   // Label 12383: @800126
     /*  800126 */   GIM_Try, /*On fail goto*//*Label 12384*/ GIMT_Encode4(800201), // Rule ID 19497 //
     /*  800131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  800142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  800145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  800148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800177 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  800180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800199 */     GIR_RootConstrainSelectedInstOperands,
     /*  800200 */     // GIR_Coverage, 19497,
     /*  800200 */     GIR_EraseRootFromParent_Done,
     /*  800201 */   // Label 12384: @800201
     /*  800201 */   GIM_Try, /*On fail goto*//*Label 12385*/ GIMT_Encode4(800276), // Rule ID 19500 //
     /*  800206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  800217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  800220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  800223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  800255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800274 */     GIR_RootConstrainSelectedInstOperands,
     /*  800275 */     // GIR_Coverage, 19500,
     /*  800275 */     GIR_EraseRootFromParent_Done,
     /*  800276 */   // Label 12385: @800276
     /*  800276 */   GIM_Try, /*On fail goto*//*Label 12386*/ GIMT_Encode4(800351), // Rule ID 19501 //
     /*  800281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  800292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  800295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  800298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800327 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  800330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800349 */     GIR_RootConstrainSelectedInstOperands,
     /*  800350 */     // GIR_Coverage, 19501,
     /*  800350 */     GIR_EraseRootFromParent_Done,
     /*  800351 */   // Label 12386: @800351
     /*  800351 */   GIM_Try, /*On fail goto*//*Label 12387*/ GIMT_Encode4(800426), // Rule ID 19504 //
     /*  800356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  800367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  800370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  800373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800402 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  800405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800424 */     GIR_RootConstrainSelectedInstOperands,
     /*  800425 */     // GIR_Coverage, 19504,
     /*  800425 */     GIR_EraseRootFromParent_Done,
     /*  800426 */   // Label 12387: @800426
     /*  800426 */   GIM_Try, /*On fail goto*//*Label 12388*/ GIMT_Encode4(800501), // Rule ID 19505 //
     /*  800431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  800442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  800445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  800448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800477 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  800480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800499 */     GIR_RootConstrainSelectedInstOperands,
     /*  800500 */     // GIR_Coverage, 19505,
     /*  800500 */     GIR_EraseRootFromParent_Done,
     /*  800501 */   // Label 12388: @800501
     /*  800501 */   GIM_Try, /*On fail goto*//*Label 12389*/ GIMT_Encode4(800576), // Rule ID 19508 //
     /*  800506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  800517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  800520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  800523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800552 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  800555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800574 */     GIR_RootConstrainSelectedInstOperands,
     /*  800575 */     // GIR_Coverage, 19508,
     /*  800575 */     GIR_EraseRootFromParent_Done,
     /*  800576 */   // Label 12389: @800576
     /*  800576 */   GIM_Try, /*On fail goto*//*Label 12390*/ GIMT_Encode4(800651), // Rule ID 19509 //
     /*  800581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  800592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  800595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  800598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800627 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  800630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800649 */     GIR_RootConstrainSelectedInstOperands,
     /*  800650 */     // GIR_Coverage, 19509,
     /*  800650 */     GIR_EraseRootFromParent_Done,
     /*  800651 */   // Label 12390: @800651
     /*  800651 */   GIM_Try, /*On fail goto*//*Label 12391*/ GIMT_Encode4(800726), // Rule ID 19512 //
     /*  800656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  800659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  800667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  800670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  800673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800702 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  800702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  800705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800724 */     GIR_RootConstrainSelectedInstOperands,
     /*  800725 */     // GIR_Coverage, 19512,
     /*  800725 */     GIR_EraseRootFromParent_Done,
     /*  800726 */   // Label 12391: @800726
     /*  800726 */   GIM_Try, /*On fail goto*//*Label 12392*/ GIMT_Encode4(800801), // Rule ID 19513 //
     /*  800731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  800734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  800742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  800745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  800748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800777 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  800777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  800780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800799 */     GIR_RootConstrainSelectedInstOperands,
     /*  800800 */     // GIR_Coverage, 19513,
     /*  800800 */     GIR_EraseRootFromParent_Done,
     /*  800801 */   // Label 12392: @800801
     /*  800801 */   GIM_Try, /*On fail goto*//*Label 12393*/ GIMT_Encode4(800876), // Rule ID 19516 //
     /*  800806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  800809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  800817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  800820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  800823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800852 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  800852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  800855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800874 */     GIR_RootConstrainSelectedInstOperands,
     /*  800875 */     // GIR_Coverage, 19516,
     /*  800875 */     GIR_EraseRootFromParent_Done,
     /*  800876 */   // Label 12393: @800876
     /*  800876 */   GIM_Try, /*On fail goto*//*Label 12394*/ GIMT_Encode4(800951), // Rule ID 19517 //
     /*  800881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  800884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  800892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  800895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  800898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800927 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  800927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  800930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800949 */     GIR_RootConstrainSelectedInstOperands,
     /*  800950 */     // GIR_Coverage, 19517,
     /*  800950 */     GIR_EraseRootFromParent_Done,
     /*  800951 */   // Label 12394: @800951
     /*  800951 */   GIM_Try, /*On fail goto*//*Label 12395*/ GIMT_Encode4(801026), // Rule ID 19520 //
     /*  800956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  800959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  800967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  800970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  800973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801002 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  801005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801024 */     GIR_RootConstrainSelectedInstOperands,
     /*  801025 */     // GIR_Coverage, 19520,
     /*  801025 */     GIR_EraseRootFromParent_Done,
     /*  801026 */   // Label 12395: @801026
     /*  801026 */   GIM_Try, /*On fail goto*//*Label 12396*/ GIMT_Encode4(801101), // Rule ID 19521 //
     /*  801031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  801039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  801042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  801045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  801048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801077 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  801080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801099 */     GIR_RootConstrainSelectedInstOperands,
     /*  801100 */     // GIR_Coverage, 19521,
     /*  801100 */     GIR_EraseRootFromParent_Done,
     /*  801101 */   // Label 12396: @801101
     /*  801101 */   GIM_Try, /*On fail goto*//*Label 12397*/ GIMT_Encode4(801176), // Rule ID 19524 //
     /*  801106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  801117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  801120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  801123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  801126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801152 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  801155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801174 */     GIR_RootConstrainSelectedInstOperands,
     /*  801175 */     // GIR_Coverage, 19524,
     /*  801175 */     GIR_EraseRootFromParent_Done,
     /*  801176 */   // Label 12397: @801176
     /*  801176 */   GIM_Try, /*On fail goto*//*Label 12398*/ GIMT_Encode4(801251), // Rule ID 19525 //
     /*  801181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  801192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  801195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  801198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  801201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801227 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  801230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801249 */     GIR_RootConstrainSelectedInstOperands,
     /*  801250 */     // GIR_Coverage, 19525,
     /*  801250 */     GIR_EraseRootFromParent_Done,
     /*  801251 */   // Label 12398: @801251
     /*  801251 */   GIM_Try, /*On fail goto*//*Label 12399*/ GIMT_Encode4(801326), // Rule ID 19528 //
     /*  801256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  801267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  801270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  801273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  801276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801302 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  801305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801324 */     GIR_RootConstrainSelectedInstOperands,
     /*  801325 */     // GIR_Coverage, 19528,
     /*  801325 */     GIR_EraseRootFromParent_Done,
     /*  801326 */   // Label 12399: @801326
     /*  801326 */   GIM_Try, /*On fail goto*//*Label 12400*/ GIMT_Encode4(801401), // Rule ID 19529 //
     /*  801331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  801342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  801345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  801348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  801351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801377 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  801380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801399 */     GIR_RootConstrainSelectedInstOperands,
     /*  801400 */     // GIR_Coverage, 19529,
     /*  801400 */     GIR_EraseRootFromParent_Done,
     /*  801401 */   // Label 12400: @801401
     /*  801401 */   GIM_Try, /*On fail goto*//*Label 12401*/ GIMT_Encode4(801476), // Rule ID 19532 //
     /*  801406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  801417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  801420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  801423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  801426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801452 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  801455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801474 */     GIR_RootConstrainSelectedInstOperands,
     /*  801475 */     // GIR_Coverage, 19532,
     /*  801475 */     GIR_EraseRootFromParent_Done,
     /*  801476 */   // Label 12401: @801476
     /*  801476 */   GIM_Try, /*On fail goto*//*Label 12402*/ GIMT_Encode4(801551), // Rule ID 19533 //
     /*  801481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  801492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  801495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  801498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  801501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801527 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  801530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801549 */     GIR_RootConstrainSelectedInstOperands,
     /*  801550 */     // GIR_Coverage, 19533,
     /*  801550 */     GIR_EraseRootFromParent_Done,
     /*  801551 */   // Label 12402: @801551
     /*  801551 */   GIM_Try, /*On fail goto*//*Label 12403*/ GIMT_Encode4(801626), // Rule ID 19536 //
     /*  801556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  801567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  801570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  801573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  801576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801602 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  801605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801624 */     GIR_RootConstrainSelectedInstOperands,
     /*  801625 */     // GIR_Coverage, 19536,
     /*  801625 */     GIR_EraseRootFromParent_Done,
     /*  801626 */   // Label 12403: @801626
     /*  801626 */   GIM_Try, /*On fail goto*//*Label 12404*/ GIMT_Encode4(801701), // Rule ID 19537 //
     /*  801631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  801642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  801645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  801648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  801651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801677 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  801680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801699 */     GIR_RootConstrainSelectedInstOperands,
     /*  801700 */     // GIR_Coverage, 19537,
     /*  801700 */     GIR_EraseRootFromParent_Done,
     /*  801701 */   // Label 12404: @801701
     /*  801701 */   GIM_Try, /*On fail goto*//*Label 12405*/ GIMT_Encode4(801776), // Rule ID 19540 //
     /*  801706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  801717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  801720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  801723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  801726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801752 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  801755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801774 */     GIR_RootConstrainSelectedInstOperands,
     /*  801775 */     // GIR_Coverage, 19540,
     /*  801775 */     GIR_EraseRootFromParent_Done,
     /*  801776 */   // Label 12405: @801776
     /*  801776 */   GIM_Try, /*On fail goto*//*Label 12406*/ GIMT_Encode4(801851), // Rule ID 19541 //
     /*  801781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  801792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  801795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  801798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  801801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801827 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  801830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801849 */     GIR_RootConstrainSelectedInstOperands,
     /*  801850 */     // GIR_Coverage, 19541,
     /*  801850 */     GIR_EraseRootFromParent_Done,
     /*  801851 */   // Label 12406: @801851
     /*  801851 */   GIM_Try, /*On fail goto*//*Label 12407*/ GIMT_Encode4(801926), // Rule ID 19544 //
     /*  801856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  801859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  801867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  801870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  801873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  801876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801902 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  801905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801924 */     GIR_RootConstrainSelectedInstOperands,
     /*  801925 */     // GIR_Coverage, 19544,
     /*  801925 */     GIR_EraseRootFromParent_Done,
     /*  801926 */   // Label 12407: @801926
     /*  801926 */   GIM_Try, /*On fail goto*//*Label 12408*/ GIMT_Encode4(802001), // Rule ID 19545 //
     /*  801931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  801942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  801945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  801948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  801951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801977 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  801980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801999 */     GIR_RootConstrainSelectedInstOperands,
     /*  802000 */     // GIR_Coverage, 19545,
     /*  802000 */     GIR_EraseRootFromParent_Done,
     /*  802001 */   // Label 12408: @802001
     /*  802001 */   GIM_Try, /*On fail goto*//*Label 12409*/ GIMT_Encode4(802076), // Rule ID 19548 //
     /*  802006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  802017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  802020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  802023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  802026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802052 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  802055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802074 */     GIR_RootConstrainSelectedInstOperands,
     /*  802075 */     // GIR_Coverage, 19548,
     /*  802075 */     GIR_EraseRootFromParent_Done,
     /*  802076 */   // Label 12409: @802076
     /*  802076 */   GIM_Try, /*On fail goto*//*Label 12410*/ GIMT_Encode4(802151), // Rule ID 19549 //
     /*  802081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  802092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  802095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  802098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  802101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802127 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  802130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802149 */     GIR_RootConstrainSelectedInstOperands,
     /*  802150 */     // GIR_Coverage, 19549,
     /*  802150 */     GIR_EraseRootFromParent_Done,
     /*  802151 */   // Label 12410: @802151
     /*  802151 */   GIM_Try, /*On fail goto*//*Label 12411*/ GIMT_Encode4(802226), // Rule ID 19552 //
     /*  802156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  802167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  802170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  802173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  802176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802202 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  802205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802224 */     GIR_RootConstrainSelectedInstOperands,
     /*  802225 */     // GIR_Coverage, 19552,
     /*  802225 */     GIR_EraseRootFromParent_Done,
     /*  802226 */   // Label 12411: @802226
     /*  802226 */   GIM_Try, /*On fail goto*//*Label 12412*/ GIMT_Encode4(802301), // Rule ID 19553 //
     /*  802231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  802242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  802245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  802248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  802251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802277 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  802280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802299 */     GIR_RootConstrainSelectedInstOperands,
     /*  802300 */     // GIR_Coverage, 19553,
     /*  802300 */     GIR_EraseRootFromParent_Done,
     /*  802301 */   // Label 12412: @802301
     /*  802301 */   GIM_Try, /*On fail goto*//*Label 12413*/ GIMT_Encode4(802376), // Rule ID 19556 //
     /*  802306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  802317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  802320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  802323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  802326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802352 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  802355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802374 */     GIR_RootConstrainSelectedInstOperands,
     /*  802375 */     // GIR_Coverage, 19556,
     /*  802375 */     GIR_EraseRootFromParent_Done,
     /*  802376 */   // Label 12413: @802376
     /*  802376 */   GIM_Try, /*On fail goto*//*Label 12414*/ GIMT_Encode4(802451), // Rule ID 19557 //
     /*  802381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  802392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  802395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  802398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  802401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802427 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  802430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802449 */     GIR_RootConstrainSelectedInstOperands,
     /*  802450 */     // GIR_Coverage, 19557,
     /*  802450 */     GIR_EraseRootFromParent_Done,
     /*  802451 */   // Label 12414: @802451
     /*  802451 */   GIM_Try, /*On fail goto*//*Label 12415*/ GIMT_Encode4(802526), // Rule ID 19560 //
     /*  802456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  802467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  802470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  802473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  802476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802502 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  802505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802524 */     GIR_RootConstrainSelectedInstOperands,
     /*  802525 */     // GIR_Coverage, 19560,
     /*  802525 */     GIR_EraseRootFromParent_Done,
     /*  802526 */   // Label 12415: @802526
     /*  802526 */   GIM_Try, /*On fail goto*//*Label 12416*/ GIMT_Encode4(802601), // Rule ID 19561 //
     /*  802531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  802542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  802545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  802548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  802551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802577 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  802580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802599 */     GIR_RootConstrainSelectedInstOperands,
     /*  802600 */     // GIR_Coverage, 19561,
     /*  802600 */     GIR_EraseRootFromParent_Done,
     /*  802601 */   // Label 12416: @802601
     /*  802601 */   GIM_Try, /*On fail goto*//*Label 12417*/ GIMT_Encode4(802676), // Rule ID 19564 //
     /*  802606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  802617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  802620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  802623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  802626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802652 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  802655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802674 */     GIR_RootConstrainSelectedInstOperands,
     /*  802675 */     // GIR_Coverage, 19564,
     /*  802675 */     GIR_EraseRootFromParent_Done,
     /*  802676 */   // Label 12417: @802676
     /*  802676 */   GIM_Try, /*On fail goto*//*Label 12418*/ GIMT_Encode4(802751), // Rule ID 19565 //
     /*  802681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  802692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  802695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  802698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  802701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802727 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  802730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802749 */     GIR_RootConstrainSelectedInstOperands,
     /*  802750 */     // GIR_Coverage, 19565,
     /*  802750 */     GIR_EraseRootFromParent_Done,
     /*  802751 */   // Label 12418: @802751
     /*  802751 */   GIM_Try, /*On fail goto*//*Label 12419*/ GIMT_Encode4(802826), // Rule ID 19568 //
     /*  802756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  802767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  802770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  802773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  802776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802802 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  802805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802824 */     GIR_RootConstrainSelectedInstOperands,
     /*  802825 */     // GIR_Coverage, 19568,
     /*  802825 */     GIR_EraseRootFromParent_Done,
     /*  802826 */   // Label 12419: @802826
     /*  802826 */   GIM_Try, /*On fail goto*//*Label 12420*/ GIMT_Encode4(802901), // Rule ID 19569 //
     /*  802831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  802842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  802845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  802848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  802851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802877 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  802880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802899 */     GIR_RootConstrainSelectedInstOperands,
     /*  802900 */     // GIR_Coverage, 19569,
     /*  802900 */     GIR_EraseRootFromParent_Done,
     /*  802901 */   // Label 12420: @802901
     /*  802901 */   GIM_Try, /*On fail goto*//*Label 12421*/ GIMT_Encode4(802976), // Rule ID 19572 //
     /*  802906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  802909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  802917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  802920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  802923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  802926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  802952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  802955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802974 */     GIR_RootConstrainSelectedInstOperands,
     /*  802975 */     // GIR_Coverage, 19572,
     /*  802975 */     GIR_EraseRootFromParent_Done,
     /*  802976 */   // Label 12421: @802976
     /*  802976 */   GIM_Try, /*On fail goto*//*Label 12422*/ GIMT_Encode4(803051), // Rule ID 19573 //
     /*  802981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  802984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  802992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  802995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  802998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  803001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803027 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  803030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803049 */     GIR_RootConstrainSelectedInstOperands,
     /*  803050 */     // GIR_Coverage, 19573,
     /*  803050 */     GIR_EraseRootFromParent_Done,
     /*  803051 */   // Label 12422: @803051
     /*  803051 */   GIM_Try, /*On fail goto*//*Label 12423*/ GIMT_Encode4(803126), // Rule ID 19576 //
     /*  803056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  803059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  803067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  803070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  803073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  803076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  803105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803124 */     GIR_RootConstrainSelectedInstOperands,
     /*  803125 */     // GIR_Coverage, 19576,
     /*  803125 */     GIR_EraseRootFromParent_Done,
     /*  803126 */   // Label 12423: @803126
     /*  803126 */   GIM_Try, /*On fail goto*//*Label 12424*/ GIMT_Encode4(803201), // Rule ID 19577 //
     /*  803131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  803142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  803145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  803148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  803151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803177 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  803180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803199 */     GIR_RootConstrainSelectedInstOperands,
     /*  803200 */     // GIR_Coverage, 19577,
     /*  803200 */     GIR_EraseRootFromParent_Done,
     /*  803201 */   // Label 12424: @803201
     /*  803201 */   GIM_Try, /*On fail goto*//*Label 12425*/ GIMT_Encode4(803276), // Rule ID 19580 //
     /*  803206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  803209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  803217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  803220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  803223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  803226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803252 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  803255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803274 */     GIR_RootConstrainSelectedInstOperands,
     /*  803275 */     // GIR_Coverage, 19580,
     /*  803275 */     GIR_EraseRootFromParent_Done,
     /*  803276 */   // Label 12425: @803276
     /*  803276 */   GIM_Try, /*On fail goto*//*Label 12426*/ GIMT_Encode4(803351), // Rule ID 19581 //
     /*  803281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  803292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  803295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  803298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  803301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803327 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  803330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803349 */     GIR_RootConstrainSelectedInstOperands,
     /*  803350 */     // GIR_Coverage, 19581,
     /*  803350 */     GIR_EraseRootFromParent_Done,
     /*  803351 */   // Label 12426: @803351
     /*  803351 */   GIM_Try, /*On fail goto*//*Label 12427*/ GIMT_Encode4(803426), // Rule ID 19584 //
     /*  803356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  803367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  803370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  803373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803402 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  803405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803424 */     GIR_RootConstrainSelectedInstOperands,
     /*  803425 */     // GIR_Coverage, 19584,
     /*  803425 */     GIR_EraseRootFromParent_Done,
     /*  803426 */   // Label 12427: @803426
     /*  803426 */   GIM_Try, /*On fail goto*//*Label 12428*/ GIMT_Encode4(803501), // Rule ID 19585 //
     /*  803431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  803442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  803445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  803448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803477 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  803480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803499 */     GIR_RootConstrainSelectedInstOperands,
     /*  803500 */     // GIR_Coverage, 19585,
     /*  803500 */     GIR_EraseRootFromParent_Done,
     /*  803501 */   // Label 12428: @803501
     /*  803501 */   GIM_Try, /*On fail goto*//*Label 12429*/ GIMT_Encode4(803576), // Rule ID 19588 //
     /*  803506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  803517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  803520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  803523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803552 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  803555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803574 */     GIR_RootConstrainSelectedInstOperands,
     /*  803575 */     // GIR_Coverage, 19588,
     /*  803575 */     GIR_EraseRootFromParent_Done,
     /*  803576 */   // Label 12429: @803576
     /*  803576 */   GIM_Try, /*On fail goto*//*Label 12430*/ GIMT_Encode4(803651), // Rule ID 19589 //
     /*  803581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  803592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  803595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  803598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803627 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  803630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803649 */     GIR_RootConstrainSelectedInstOperands,
     /*  803650 */     // GIR_Coverage, 19589,
     /*  803650 */     GIR_EraseRootFromParent_Done,
     /*  803651 */   // Label 12430: @803651
     /*  803651 */   GIM_Try, /*On fail goto*//*Label 12431*/ GIMT_Encode4(803726), // Rule ID 19592 //
     /*  803656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  803667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  803670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  803673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  803695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803702 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  803705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803724 */     GIR_RootConstrainSelectedInstOperands,
     /*  803725 */     // GIR_Coverage, 19592,
     /*  803725 */     GIR_EraseRootFromParent_Done,
     /*  803726 */   // Label 12431: @803726
     /*  803726 */   GIM_Try, /*On fail goto*//*Label 12432*/ GIMT_Encode4(803801), // Rule ID 19593 //
     /*  803731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  803742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  803745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  803748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  803770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803777 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  803780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803799 */     GIR_RootConstrainSelectedInstOperands,
     /*  803800 */     // GIR_Coverage, 19593,
     /*  803800 */     GIR_EraseRootFromParent_Done,
     /*  803801 */   // Label 12432: @803801
     /*  803801 */   GIM_Try, /*On fail goto*//*Label 12433*/ GIMT_Encode4(803876), // Rule ID 19596 //
     /*  803806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  803817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  803820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  803823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803852 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  803855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803874 */     GIR_RootConstrainSelectedInstOperands,
     /*  803875 */     // GIR_Coverage, 19596,
     /*  803875 */     GIR_EraseRootFromParent_Done,
     /*  803876 */   // Label 12433: @803876
     /*  803876 */   GIM_Try, /*On fail goto*//*Label 12434*/ GIMT_Encode4(803951), // Rule ID 19597 //
     /*  803881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  803892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  803895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  803898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803927 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  803930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803949 */     GIR_RootConstrainSelectedInstOperands,
     /*  803950 */     // GIR_Coverage, 19597,
     /*  803950 */     GIR_EraseRootFromParent_Done,
     /*  803951 */   // Label 12434: @803951
     /*  803951 */   GIM_Try, /*On fail goto*//*Label 12435*/ GIMT_Encode4(804026), // Rule ID 19600 //
     /*  803956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  803967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  803970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  803973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  803995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804002 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  804005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804024 */     GIR_RootConstrainSelectedInstOperands,
     /*  804025 */     // GIR_Coverage, 19600,
     /*  804025 */     GIR_EraseRootFromParent_Done,
     /*  804026 */   // Label 12435: @804026
     /*  804026 */   GIM_Try, /*On fail goto*//*Label 12436*/ GIMT_Encode4(804101), // Rule ID 19601 //
     /*  804031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  804042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  804045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  804048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804077 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  804080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804099 */     GIR_RootConstrainSelectedInstOperands,
     /*  804100 */     // GIR_Coverage, 19601,
     /*  804100 */     GIR_EraseRootFromParent_Done,
     /*  804101 */   // Label 12436: @804101
     /*  804101 */   GIM_Try, /*On fail goto*//*Label 12437*/ GIMT_Encode4(804176), // Rule ID 19604 //
     /*  804106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  804109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  804117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  804120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  804123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  804126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  804145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804152 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  804152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  804155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804174 */     GIR_RootConstrainSelectedInstOperands,
     /*  804175 */     // GIR_Coverage, 19604,
     /*  804175 */     GIR_EraseRootFromParent_Done,
     /*  804176 */   // Label 12437: @804176
     /*  804176 */   GIM_Try, /*On fail goto*//*Label 12438*/ GIMT_Encode4(804251), // Rule ID 19605 //
     /*  804181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  804184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  804192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  804195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  804198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  804201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  804220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804227 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  804227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  804230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804249 */     GIR_RootConstrainSelectedInstOperands,
     /*  804250 */     // GIR_Coverage, 19605,
     /*  804250 */     GIR_EraseRootFromParent_Done,
     /*  804251 */   // Label 12438: @804251
     /*  804251 */   GIM_Try, /*On fail goto*//*Label 12439*/ GIMT_Encode4(804326), // Rule ID 19608 //
     /*  804256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  804267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  804270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  804273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804302 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  804305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804324 */     GIR_RootConstrainSelectedInstOperands,
     /*  804325 */     // GIR_Coverage, 19608,
     /*  804325 */     GIR_EraseRootFromParent_Done,
     /*  804326 */   // Label 12439: @804326
     /*  804326 */   GIM_Try, /*On fail goto*//*Label 12440*/ GIMT_Encode4(804401), // Rule ID 19609 //
     /*  804331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  804342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  804345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  804348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804377 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  804380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804399 */     GIR_RootConstrainSelectedInstOperands,
     /*  804400 */     // GIR_Coverage, 19609,
     /*  804400 */     GIR_EraseRootFromParent_Done,
     /*  804401 */   // Label 12440: @804401
     /*  804401 */   GIM_Try, /*On fail goto*//*Label 12441*/ GIMT_Encode4(804476), // Rule ID 19612 //
     /*  804406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  804417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  804420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  804423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804452 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  804455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804474 */     GIR_RootConstrainSelectedInstOperands,
     /*  804475 */     // GIR_Coverage, 19612,
     /*  804475 */     GIR_EraseRootFromParent_Done,
     /*  804476 */   // Label 12441: @804476
     /*  804476 */   GIM_Try, /*On fail goto*//*Label 12442*/ GIMT_Encode4(804551), // Rule ID 19613 //
     /*  804481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  804492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  804495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  804498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804527 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  804530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804549 */     GIR_RootConstrainSelectedInstOperands,
     /*  804550 */     // GIR_Coverage, 19613,
     /*  804550 */     GIR_EraseRootFromParent_Done,
     /*  804551 */   // Label 12442: @804551
     /*  804551 */   GIM_Try, /*On fail goto*//*Label 12443*/ GIMT_Encode4(804626), // Rule ID 19616 //
     /*  804556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  804567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  804570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  804573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804602 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  804605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804624 */     GIR_RootConstrainSelectedInstOperands,
     /*  804625 */     // GIR_Coverage, 19616,
     /*  804625 */     GIR_EraseRootFromParent_Done,
     /*  804626 */   // Label 12443: @804626
     /*  804626 */   GIM_Try, /*On fail goto*//*Label 12444*/ GIMT_Encode4(804701), // Rule ID 19617 //
     /*  804631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  804642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  804645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  804648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804677 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  804680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804699 */     GIR_RootConstrainSelectedInstOperands,
     /*  804700 */     // GIR_Coverage, 19617,
     /*  804700 */     GIR_EraseRootFromParent_Done,
     /*  804701 */   // Label 12444: @804701
     /*  804701 */   GIM_Try, /*On fail goto*//*Label 12445*/ GIMT_Encode4(804776), // Rule ID 19620 //
     /*  804706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  804709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  804717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  804720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  804723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804752 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  804755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804774 */     GIR_RootConstrainSelectedInstOperands,
     /*  804775 */     // GIR_Coverage, 19620,
     /*  804775 */     GIR_EraseRootFromParent_Done,
     /*  804776 */   // Label 12445: @804776
     /*  804776 */   GIM_Try, /*On fail goto*//*Label 12446*/ GIMT_Encode4(804851), // Rule ID 19621 //
     /*  804781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  804792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  804795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  804798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804827 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  804830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804849 */     GIR_RootConstrainSelectedInstOperands,
     /*  804850 */     // GIR_Coverage, 19621,
     /*  804850 */     GIR_EraseRootFromParent_Done,
     /*  804851 */   // Label 12446: @804851
     /*  804851 */   GIM_Try, /*On fail goto*//*Label 12447*/ GIMT_Encode4(804926), // Rule ID 19624 //
     /*  804856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  804859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  804867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  804870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  804873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804902 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  804905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804924 */     GIR_RootConstrainSelectedInstOperands,
     /*  804925 */     // GIR_Coverage, 19624,
     /*  804925 */     GIR_EraseRootFromParent_Done,
     /*  804926 */   // Label 12447: @804926
     /*  804926 */   GIM_Try, /*On fail goto*//*Label 12448*/ GIMT_Encode4(805001), // Rule ID 19625 //
     /*  804931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  804942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  804945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  804948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804977 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  804980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804999 */     GIR_RootConstrainSelectedInstOperands,
     /*  805000 */     // GIR_Coverage, 19625,
     /*  805000 */     GIR_EraseRootFromParent_Done,
     /*  805001 */   // Label 12448: @805001
     /*  805001 */   GIM_Try, /*On fail goto*//*Label 12449*/ GIMT_Encode4(805076), // Rule ID 19628 //
     /*  805006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  805017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  805020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  805023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805052 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  805055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805074 */     GIR_RootConstrainSelectedInstOperands,
     /*  805075 */     // GIR_Coverage, 19628,
     /*  805075 */     GIR_EraseRootFromParent_Done,
     /*  805076 */   // Label 12449: @805076
     /*  805076 */   GIM_Try, /*On fail goto*//*Label 12450*/ GIMT_Encode4(805151), // Rule ID 19629 //
     /*  805081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  805092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  805095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  805098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805127 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  805130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805149 */     GIR_RootConstrainSelectedInstOperands,
     /*  805150 */     // GIR_Coverage, 19629,
     /*  805150 */     GIR_EraseRootFromParent_Done,
     /*  805151 */   // Label 12450: @805151
     /*  805151 */   GIM_Try, /*On fail goto*//*Label 12451*/ GIMT_Encode4(805226), // Rule ID 19632 //
     /*  805156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  805167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  805170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  805173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805202 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  805205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805224 */     GIR_RootConstrainSelectedInstOperands,
     /*  805225 */     // GIR_Coverage, 19632,
     /*  805225 */     GIR_EraseRootFromParent_Done,
     /*  805226 */   // Label 12451: @805226
     /*  805226 */   GIM_Try, /*On fail goto*//*Label 12452*/ GIMT_Encode4(805301), // Rule ID 19633 //
     /*  805231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  805234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  805242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  805245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  805248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805277 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  805280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805299 */     GIR_RootConstrainSelectedInstOperands,
     /*  805300 */     // GIR_Coverage, 19633,
     /*  805300 */     GIR_EraseRootFromParent_Done,
     /*  805301 */   // Label 12452: @805301
     /*  805301 */   GIM_Try, /*On fail goto*//*Label 12453*/ GIMT_Encode4(805376), // Rule ID 19636 //
     /*  805306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  805317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  805320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  805323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805352 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  805355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805374 */     GIR_RootConstrainSelectedInstOperands,
     /*  805375 */     // GIR_Coverage, 19636,
     /*  805375 */     GIR_EraseRootFromParent_Done,
     /*  805376 */   // Label 12453: @805376
     /*  805376 */   GIM_Try, /*On fail goto*//*Label 12454*/ GIMT_Encode4(805451), // Rule ID 19637 //
     /*  805381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  805384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  805392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  805395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  805398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805427 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  805430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805449 */     GIR_RootConstrainSelectedInstOperands,
     /*  805450 */     // GIR_Coverage, 19637,
     /*  805450 */     GIR_EraseRootFromParent_Done,
     /*  805451 */   // Label 12454: @805451
     /*  805451 */   GIM_Try, /*On fail goto*//*Label 12455*/ GIMT_Encode4(805526), // Rule ID 19640 //
     /*  805456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  805467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  805470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  805473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805502 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  805505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805524 */     GIR_RootConstrainSelectedInstOperands,
     /*  805525 */     // GIR_Coverage, 19640,
     /*  805525 */     GIR_EraseRootFromParent_Done,
     /*  805526 */   // Label 12455: @805526
     /*  805526 */   GIM_Try, /*On fail goto*//*Label 12456*/ GIMT_Encode4(805601), // Rule ID 19641 //
     /*  805531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  805534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  805542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  805545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  805548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805577 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  805580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805599 */     GIR_RootConstrainSelectedInstOperands,
     /*  805600 */     // GIR_Coverage, 19641,
     /*  805600 */     GIR_EraseRootFromParent_Done,
     /*  805601 */   // Label 12456: @805601
     /*  805601 */   GIM_Try, /*On fail goto*//*Label 12457*/ GIMT_Encode4(805676), // Rule ID 19644 //
     /*  805606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  805617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  805620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  805623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  805626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805652 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  805655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805674 */     GIR_RootConstrainSelectedInstOperands,
     /*  805675 */     // GIR_Coverage, 19644,
     /*  805675 */     GIR_EraseRootFromParent_Done,
     /*  805676 */   // Label 12457: @805676
     /*  805676 */   GIM_Try, /*On fail goto*//*Label 12458*/ GIMT_Encode4(805751), // Rule ID 19645 //
     /*  805681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  805692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  805695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  805698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  805701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805727 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  805730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805749 */     GIR_RootConstrainSelectedInstOperands,
     /*  805750 */     // GIR_Coverage, 19645,
     /*  805750 */     GIR_EraseRootFromParent_Done,
     /*  805751 */   // Label 12458: @805751
     /*  805751 */   GIM_Try, /*On fail goto*//*Label 12459*/ GIMT_Encode4(805826), // Rule ID 19648 //
     /*  805756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  805767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  805770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  805773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  805776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805802 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  805805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805824 */     GIR_RootConstrainSelectedInstOperands,
     /*  805825 */     // GIR_Coverage, 19648,
     /*  805825 */     GIR_EraseRootFromParent_Done,
     /*  805826 */   // Label 12459: @805826
     /*  805826 */   GIM_Try, /*On fail goto*//*Label 12460*/ GIMT_Encode4(805901), // Rule ID 19649 //
     /*  805831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  805842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  805845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  805848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  805851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805877 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  805880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805899 */     GIR_RootConstrainSelectedInstOperands,
     /*  805900 */     // GIR_Coverage, 19649,
     /*  805900 */     GIR_EraseRootFromParent_Done,
     /*  805901 */   // Label 12460: @805901
     /*  805901 */   GIM_Try, /*On fail goto*//*Label 12461*/ GIMT_Encode4(805976), // Rule ID 19652 //
     /*  805906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  805917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  805920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  805923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  805926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805952 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  805955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805974 */     GIR_RootConstrainSelectedInstOperands,
     /*  805975 */     // GIR_Coverage, 19652,
     /*  805975 */     GIR_EraseRootFromParent_Done,
     /*  805976 */   // Label 12461: @805976
     /*  805976 */   GIM_Try, /*On fail goto*//*Label 12462*/ GIMT_Encode4(806051), // Rule ID 19653 //
     /*  805981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  805992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  805995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  805998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  806001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806027 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  806030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806049 */     GIR_RootConstrainSelectedInstOperands,
     /*  806050 */     // GIR_Coverage, 19653,
     /*  806050 */     GIR_EraseRootFromParent_Done,
     /*  806051 */   // Label 12462: @806051
     /*  806051 */   GIM_Try, /*On fail goto*//*Label 12463*/ GIMT_Encode4(806126), // Rule ID 19656 //
     /*  806056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  806059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  806073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  806105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806124 */     GIR_RootConstrainSelectedInstOperands,
     /*  806125 */     // GIR_Coverage, 19656,
     /*  806125 */     GIR_EraseRootFromParent_Done,
     /*  806126 */   // Label 12463: @806126
     /*  806126 */   GIM_Try, /*On fail goto*//*Label 12464*/ GIMT_Encode4(806201), // Rule ID 19657 //
     /*  806131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  806134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  806148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806177 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  806180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806199 */     GIR_RootConstrainSelectedInstOperands,
     /*  806200 */     // GIR_Coverage, 19657,
     /*  806200 */     GIR_EraseRootFromParent_Done,
     /*  806201 */   // Label 12464: @806201
     /*  806201 */   GIM_Try, /*On fail goto*//*Label 12465*/ GIMT_Encode4(806276), // Rule ID 19660 //
     /*  806206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  806209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  806217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  806220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  806223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  806226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  806252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  806255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806274 */     GIR_RootConstrainSelectedInstOperands,
     /*  806275 */     // GIR_Coverage, 19660,
     /*  806275 */     GIR_EraseRootFromParent_Done,
     /*  806276 */   // Label 12465: @806276
     /*  806276 */   GIM_Try, /*On fail goto*//*Label 12466*/ GIMT_Encode4(806351), // Rule ID 19661 //
     /*  806281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  806284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  806292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  806295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  806298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  806301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806327 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  806330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806349 */     GIR_RootConstrainSelectedInstOperands,
     /*  806350 */     // GIR_Coverage, 19661,
     /*  806350 */     GIR_EraseRootFromParent_Done,
     /*  806351 */   // Label 12466: @806351
     /*  806351 */   GIM_Try, /*On fail goto*//*Label 12467*/ GIMT_Encode4(806426), // Rule ID 19664 //
     /*  806356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  806359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  806367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  806370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  806373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  806376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806402 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  806402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  806405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806424 */     GIR_RootConstrainSelectedInstOperands,
     /*  806425 */     // GIR_Coverage, 19664,
     /*  806425 */     GIR_EraseRootFromParent_Done,
     /*  806426 */   // Label 12467: @806426
     /*  806426 */   GIM_Try, /*On fail goto*//*Label 12468*/ GIMT_Encode4(806501), // Rule ID 19665 //
     /*  806431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  806434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  806442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  806445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  806448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  806451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806477 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  806477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  806480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806499 */     GIR_RootConstrainSelectedInstOperands,
     /*  806500 */     // GIR_Coverage, 19665,
     /*  806500 */     GIR_EraseRootFromParent_Done,
     /*  806501 */   // Label 12468: @806501
     /*  806501 */   GIM_Try, /*On fail goto*//*Label 12469*/ GIMT_Encode4(806576), // Rule ID 19668 //
     /*  806506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  806509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  806517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  806520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  806523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  806526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  806555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806574 */     GIR_RootConstrainSelectedInstOperands,
     /*  806575 */     // GIR_Coverage, 19668,
     /*  806575 */     GIR_EraseRootFromParent_Done,
     /*  806576 */   // Label 12469: @806576
     /*  806576 */   GIM_Try, /*On fail goto*//*Label 12470*/ GIMT_Encode4(806651), // Rule ID 19669 //
     /*  806581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  806584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  806592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  806595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  806598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  806601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806627 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  806630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806649 */     GIR_RootConstrainSelectedInstOperands,
     /*  806650 */     // GIR_Coverage, 19669,
     /*  806650 */     GIR_EraseRootFromParent_Done,
     /*  806651 */   // Label 12470: @806651
     /*  806651 */   GIM_Try, /*On fail goto*//*Label 12471*/ GIMT_Encode4(806726), // Rule ID 19672 //
     /*  806656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  806659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  806667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  806670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  806673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  806676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806702 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  806705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806724 */     GIR_RootConstrainSelectedInstOperands,
     /*  806725 */     // GIR_Coverage, 19672,
     /*  806725 */     GIR_EraseRootFromParent_Done,
     /*  806726 */   // Label 12471: @806726
     /*  806726 */   GIM_Try, /*On fail goto*//*Label 12472*/ GIMT_Encode4(806801), // Rule ID 19673 //
     /*  806731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  806734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  806742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  806745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  806748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  806751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806777 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  806780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806799 */     GIR_RootConstrainSelectedInstOperands,
     /*  806800 */     // GIR_Coverage, 19673,
     /*  806800 */     GIR_EraseRootFromParent_Done,
     /*  806801 */   // Label 12472: @806801
     /*  806801 */   GIM_Try, /*On fail goto*//*Label 12473*/ GIMT_Encode4(806876), // Rule ID 19676 //
     /*  806806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  806809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  806817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  806820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  806823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  806826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806852 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  806855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806874 */     GIR_RootConstrainSelectedInstOperands,
     /*  806875 */     // GIR_Coverage, 19676,
     /*  806875 */     GIR_EraseRootFromParent_Done,
     /*  806876 */   // Label 12473: @806876
     /*  806876 */   GIM_Try, /*On fail goto*//*Label 12474*/ GIMT_Encode4(806951), // Rule ID 19677 //
     /*  806881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  806884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  806892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  806895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  806898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  806901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806927 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  806930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806949 */     GIR_RootConstrainSelectedInstOperands,
     /*  806950 */     // GIR_Coverage, 19677,
     /*  806950 */     GIR_EraseRootFromParent_Done,
     /*  806951 */   // Label 12474: @806951
     /*  806951 */   GIM_Try, /*On fail goto*//*Label 12475*/ GIMT_Encode4(807026), // Rule ID 19680 //
     /*  806956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  806959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  806967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  806970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  806973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  806976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807002 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  807002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  807005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807024 */     GIR_RootConstrainSelectedInstOperands,
     /*  807025 */     // GIR_Coverage, 19680,
     /*  807025 */     GIR_EraseRootFromParent_Done,
     /*  807026 */   // Label 12475: @807026
     /*  807026 */   GIM_Try, /*On fail goto*//*Label 12476*/ GIMT_Encode4(807101), // Rule ID 19681 //
     /*  807031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  807034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  807042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  807045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  807048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  807051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807077 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  807077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  807080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807099 */     GIR_RootConstrainSelectedInstOperands,
     /*  807100 */     // GIR_Coverage, 19681,
     /*  807100 */     GIR_EraseRootFromParent_Done,
     /*  807101 */   // Label 12476: @807101
     /*  807101 */   GIM_Try, /*On fail goto*//*Label 12477*/ GIMT_Encode4(807176), // Rule ID 19684 //
     /*  807106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  807109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  807117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  807120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  807123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  807126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807152 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  807152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  807155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807174 */     GIR_RootConstrainSelectedInstOperands,
     /*  807175 */     // GIR_Coverage, 19684,
     /*  807175 */     GIR_EraseRootFromParent_Done,
     /*  807176 */   // Label 12477: @807176
     /*  807176 */   GIM_Try, /*On fail goto*//*Label 12478*/ GIMT_Encode4(807251), // Rule ID 19685 //
     /*  807181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  807184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  807192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  807195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  807198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  807201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807227 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  807227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  807230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807249 */     GIR_RootConstrainSelectedInstOperands,
     /*  807250 */     // GIR_Coverage, 19685,
     /*  807250 */     GIR_EraseRootFromParent_Done,
     /*  807251 */   // Label 12478: @807251
     /*  807251 */   GIM_Try, /*On fail goto*//*Label 12479*/ GIMT_Encode4(807326), // Rule ID 19688 //
     /*  807256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  807259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  807267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  807270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  807273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  807276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807302 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  807302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  807305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807324 */     GIR_RootConstrainSelectedInstOperands,
     /*  807325 */     // GIR_Coverage, 19688,
     /*  807325 */     GIR_EraseRootFromParent_Done,
     /*  807326 */   // Label 12479: @807326
     /*  807326 */   GIM_Try, /*On fail goto*//*Label 12480*/ GIMT_Encode4(807401), // Rule ID 19689 //
     /*  807331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  807334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  807342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  807345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  807348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  807351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807377 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  807377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  807380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807399 */     GIR_RootConstrainSelectedInstOperands,
     /*  807400 */     // GIR_Coverage, 19689,
     /*  807400 */     GIR_EraseRootFromParent_Done,
     /*  807401 */   // Label 12480: @807401
     /*  807401 */   GIM_Try, /*On fail goto*//*Label 12481*/ GIMT_Encode4(807476), // Rule ID 19692 //
     /*  807406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  807409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  807417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  807420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  807423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  807426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807452 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  807452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  807455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807474 */     GIR_RootConstrainSelectedInstOperands,
     /*  807475 */     // GIR_Coverage, 19692,
     /*  807475 */     GIR_EraseRootFromParent_Done,
     /*  807476 */   // Label 12481: @807476
     /*  807476 */   GIM_Try, /*On fail goto*//*Label 12482*/ GIMT_Encode4(807551), // Rule ID 19693 //
     /*  807481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  807484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  807492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  807495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  807498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  807501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807527 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  807527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  807530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807549 */     GIR_RootConstrainSelectedInstOperands,
     /*  807550 */     // GIR_Coverage, 19693,
     /*  807550 */     GIR_EraseRootFromParent_Done,
     /*  807551 */   // Label 12482: @807551
     /*  807551 */   GIM_Try, /*On fail goto*//*Label 12483*/ GIMT_Encode4(807626), // Rule ID 19696 //
     /*  807556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  807559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  807567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  807570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  807573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  807576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807602 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  807602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  807605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807624 */     GIR_RootConstrainSelectedInstOperands,
     /*  807625 */     // GIR_Coverage, 19696,
     /*  807625 */     GIR_EraseRootFromParent_Done,
     /*  807626 */   // Label 12483: @807626
     /*  807626 */   GIM_Try, /*On fail goto*//*Label 12484*/ GIMT_Encode4(807701), // Rule ID 19697 //
     /*  807631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  807634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  807642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  807645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  807648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  807651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807677 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  807677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  807680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807699 */     GIR_RootConstrainSelectedInstOperands,
     /*  807700 */     // GIR_Coverage, 19697,
     /*  807700 */     GIR_EraseRootFromParent_Done,
     /*  807701 */   // Label 12484: @807701
     /*  807701 */   GIM_Try, /*On fail goto*//*Label 12485*/ GIMT_Encode4(807776), // Rule ID 19700 //
     /*  807706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  807709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  807717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  807720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  807723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  807726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807752 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  807752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  807755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807774 */     GIR_RootConstrainSelectedInstOperands,
     /*  807775 */     // GIR_Coverage, 19700,
     /*  807775 */     GIR_EraseRootFromParent_Done,
     /*  807776 */   // Label 12485: @807776
     /*  807776 */   GIM_Try, /*On fail goto*//*Label 12486*/ GIMT_Encode4(807851), // Rule ID 19701 //
     /*  807781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  807784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  807792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  807795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  807798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  807801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807827 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  807827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  807830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807849 */     GIR_RootConstrainSelectedInstOperands,
     /*  807850 */     // GIR_Coverage, 19701,
     /*  807850 */     GIR_EraseRootFromParent_Done,
     /*  807851 */   // Label 12486: @807851
     /*  807851 */   GIM_Try, /*On fail goto*//*Label 12487*/ GIMT_Encode4(807926), // Rule ID 19704 //
     /*  807856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  807859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  807867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  807870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  807873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  807876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  807895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807902 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  807905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807924 */     GIR_RootConstrainSelectedInstOperands,
     /*  807925 */     // GIR_Coverage, 19704,
     /*  807925 */     GIR_EraseRootFromParent_Done,
     /*  807926 */   // Label 12487: @807926
     /*  807926 */   GIM_Try, /*On fail goto*//*Label 12488*/ GIMT_Encode4(808001), // Rule ID 19705 //
     /*  807931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  807934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  807942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  807945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  807948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  807951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  807970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807977 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  807980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807999 */     GIR_RootConstrainSelectedInstOperands,
     /*  808000 */     // GIR_Coverage, 19705,
     /*  808000 */     GIR_EraseRootFromParent_Done,
     /*  808001 */   // Label 12488: @808001
     /*  808001 */   GIM_Try, /*On fail goto*//*Label 12489*/ GIMT_Encode4(808076), // Rule ID 19708 //
     /*  808006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  808009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  808017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  808020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  808023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  808055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808074 */     GIR_RootConstrainSelectedInstOperands,
     /*  808075 */     // GIR_Coverage, 19708,
     /*  808075 */     GIR_EraseRootFromParent_Done,
     /*  808076 */   // Label 12489: @808076
     /*  808076 */   GIM_Try, /*On fail goto*//*Label 12490*/ GIMT_Encode4(808151), // Rule ID 19709 //
     /*  808081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  808084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  808092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  808095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  808098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808127 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  808130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808149 */     GIR_RootConstrainSelectedInstOperands,
     /*  808150 */     // GIR_Coverage, 19709,
     /*  808150 */     GIR_EraseRootFromParent_Done,
     /*  808151 */   // Label 12490: @808151
     /*  808151 */   GIM_Try, /*On fail goto*//*Label 12491*/ GIMT_Encode4(808226), // Rule ID 19712 //
     /*  808156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  808159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  808167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  808170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  808173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  808195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808202 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  808205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808224 */     GIR_RootConstrainSelectedInstOperands,
     /*  808225 */     // GIR_Coverage, 19712,
     /*  808225 */     GIR_EraseRootFromParent_Done,
     /*  808226 */   // Label 12491: @808226
     /*  808226 */   GIM_Try, /*On fail goto*//*Label 12492*/ GIMT_Encode4(808301), // Rule ID 19713 //
     /*  808231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  808234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  808242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  808245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  808248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  808270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808277 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  808280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808299 */     GIR_RootConstrainSelectedInstOperands,
     /*  808300 */     // GIR_Coverage, 19713,
     /*  808300 */     GIR_EraseRootFromParent_Done,
     /*  808301 */   // Label 12492: @808301
     /*  808301 */   GIM_Try, /*On fail goto*//*Label 12493*/ GIMT_Encode4(808376), // Rule ID 19716 //
     /*  808306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  808309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  808323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  808355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808374 */     GIR_RootConstrainSelectedInstOperands,
     /*  808375 */     // GIR_Coverage, 19716,
     /*  808375 */     GIR_EraseRootFromParent_Done,
     /*  808376 */   // Label 12493: @808376
     /*  808376 */   GIM_Try, /*On fail goto*//*Label 12494*/ GIMT_Encode4(808451), // Rule ID 19717 //
     /*  808381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  808384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  808398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808427 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  808430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808449 */     GIR_RootConstrainSelectedInstOperands,
     /*  808450 */     // GIR_Coverage, 19717,
     /*  808450 */     GIR_EraseRootFromParent_Done,
     /*  808451 */   // Label 12494: @808451
     /*  808451 */   GIM_Try, /*On fail goto*//*Label 12495*/ GIMT_Encode4(808526), // Rule ID 19720 //
     /*  808456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  808459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  808473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  808495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808502 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  808505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808524 */     GIR_RootConstrainSelectedInstOperands,
     /*  808525 */     // GIR_Coverage, 19720,
     /*  808525 */     GIR_EraseRootFromParent_Done,
     /*  808526 */   // Label 12495: @808526
     /*  808526 */   GIM_Try, /*On fail goto*//*Label 12496*/ GIMT_Encode4(808601), // Rule ID 19721 //
     /*  808531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  808534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  808548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  808570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808577 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  808580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808599 */     GIR_RootConstrainSelectedInstOperands,
     /*  808600 */     // GIR_Coverage, 19721,
     /*  808600 */     GIR_EraseRootFromParent_Done,
     /*  808601 */   // Label 12496: @808601
     /*  808601 */   GIM_Try, /*On fail goto*//*Label 12497*/ GIMT_Encode4(808676), // Rule ID 19724 //
     /*  808606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  808609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  808623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  808626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  808645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808652 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  808652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  808655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808674 */     GIR_RootConstrainSelectedInstOperands,
     /*  808675 */     // GIR_Coverage, 19724,
     /*  808675 */     GIR_EraseRootFromParent_Done,
     /*  808676 */   // Label 12497: @808676
     /*  808676 */   GIM_Try, /*On fail goto*//*Label 12498*/ GIMT_Encode4(808751), // Rule ID 19725 //
     /*  808681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  808684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  808698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  808701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  808720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808727 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  808727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  808730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808749 */     GIR_RootConstrainSelectedInstOperands,
     /*  808750 */     // GIR_Coverage, 19725,
     /*  808750 */     GIR_EraseRootFromParent_Done,
     /*  808751 */   // Label 12498: @808751
     /*  808751 */   GIM_Try, /*On fail goto*//*Label 12499*/ GIMT_Encode4(808826), // Rule ID 19728 //
     /*  808756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  808759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  808767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  808770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  808773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808802 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  808805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808824 */     GIR_RootConstrainSelectedInstOperands,
     /*  808825 */     // GIR_Coverage, 19728,
     /*  808825 */     GIR_EraseRootFromParent_Done,
     /*  808826 */   // Label 12499: @808826
     /*  808826 */   GIM_Try, /*On fail goto*//*Label 12500*/ GIMT_Encode4(808901), // Rule ID 19729 //
     /*  808831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  808834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  808842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  808845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  808848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808877 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  808880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808899 */     GIR_RootConstrainSelectedInstOperands,
     /*  808900 */     // GIR_Coverage, 19729,
     /*  808900 */     GIR_EraseRootFromParent_Done,
     /*  808901 */   // Label 12500: @808901
     /*  808901 */   GIM_Try, /*On fail goto*//*Label 12501*/ GIMT_Encode4(808976), // Rule ID 19732 //
     /*  808906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  808909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  808917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  808920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  808923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808952 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  808955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808974 */     GIR_RootConstrainSelectedInstOperands,
     /*  808975 */     // GIR_Coverage, 19732,
     /*  808975 */     GIR_EraseRootFromParent_Done,
     /*  808976 */   // Label 12501: @808976
     /*  808976 */   GIM_Try, /*On fail goto*//*Label 12502*/ GIMT_Encode4(809051), // Rule ID 19733 //
     /*  808981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  808984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  808992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  808995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  808998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  809001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  809020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809027 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  809027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  809030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809049 */     GIR_RootConstrainSelectedInstOperands,
     /*  809050 */     // GIR_Coverage, 19733,
     /*  809050 */     GIR_EraseRootFromParent_Done,
     /*  809051 */   // Label 12502: @809051
     /*  809051 */   GIM_Try, /*On fail goto*//*Label 12503*/ GIMT_Encode4(809126), // Rule ID 19736 //
     /*  809056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  809059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  809067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  809070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  809073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  809076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  809095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809102 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  809102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  809105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809124 */     GIR_RootConstrainSelectedInstOperands,
     /*  809125 */     // GIR_Coverage, 19736,
     /*  809125 */     GIR_EraseRootFromParent_Done,
     /*  809126 */   // Label 12503: @809126
     /*  809126 */   GIM_Try, /*On fail goto*//*Label 12504*/ GIMT_Encode4(809201), // Rule ID 19737 //
     /*  809131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  809134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  809142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  809145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  809148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  809151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  809170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809177 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  809177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  809180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809199 */     GIR_RootConstrainSelectedInstOperands,
     /*  809200 */     // GIR_Coverage, 19737,
     /*  809200 */     GIR_EraseRootFromParent_Done,
     /*  809201 */   // Label 12504: @809201
     /*  809201 */   GIM_Try, /*On fail goto*//*Label 12505*/ GIMT_Encode4(809276), // Rule ID 19740 //
     /*  809206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  809209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  809217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  809220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  809223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  809245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  809255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809274 */     GIR_RootConstrainSelectedInstOperands,
     /*  809275 */     // GIR_Coverage, 19740,
     /*  809275 */     GIR_EraseRootFromParent_Done,
     /*  809276 */   // Label 12505: @809276
     /*  809276 */   GIM_Try, /*On fail goto*//*Label 12506*/ GIMT_Encode4(809351), // Rule ID 19741 //
     /*  809281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  809284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  809292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  809295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  809298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  809320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809327 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  809330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809349 */     GIR_RootConstrainSelectedInstOperands,
     /*  809350 */     // GIR_Coverage, 19741,
     /*  809350 */     GIR_EraseRootFromParent_Done,
     /*  809351 */   // Label 12506: @809351
     /*  809351 */   GIM_Try, /*On fail goto*//*Label 12507*/ GIMT_Encode4(809426), // Rule ID 19744 //
     /*  809356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  809359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  809367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  809370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  809373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  809395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809402 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  809405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809424 */     GIR_RootConstrainSelectedInstOperands,
     /*  809425 */     // GIR_Coverage, 19744,
     /*  809425 */     GIR_EraseRootFromParent_Done,
     /*  809426 */   // Label 12507: @809426
     /*  809426 */   GIM_Try, /*On fail goto*//*Label 12508*/ GIMT_Encode4(809501), // Rule ID 19745 //
     /*  809431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  809434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  809442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  809445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  809448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  809470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809477 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  809480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809499 */     GIR_RootConstrainSelectedInstOperands,
     /*  809500 */     // GIR_Coverage, 19745,
     /*  809500 */     GIR_EraseRootFromParent_Done,
     /*  809501 */   // Label 12508: @809501
     /*  809501 */   GIM_Try, /*On fail goto*//*Label 12509*/ GIMT_Encode4(809576), // Rule ID 19748 //
     /*  809506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  809509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  809517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  809520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  809523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  809545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809552 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  809555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809574 */     GIR_RootConstrainSelectedInstOperands,
     /*  809575 */     // GIR_Coverage, 19748,
     /*  809575 */     GIR_EraseRootFromParent_Done,
     /*  809576 */   // Label 12509: @809576
     /*  809576 */   GIM_Try, /*On fail goto*//*Label 12510*/ GIMT_Encode4(809651), // Rule ID 19749 //
     /*  809581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  809584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  809592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  809595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  809598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  809620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809627 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  809630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809649 */     GIR_RootConstrainSelectedInstOperands,
     /*  809650 */     // GIR_Coverage, 19749,
     /*  809650 */     GIR_EraseRootFromParent_Done,
     /*  809651 */   // Label 12510: @809651
     /*  809651 */   GIM_Try, /*On fail goto*//*Label 12511*/ GIMT_Encode4(809726), // Rule ID 19752 //
     /*  809656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  809659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  809667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  809670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  809673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  809695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809702 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  809705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809724 */     GIR_RootConstrainSelectedInstOperands,
     /*  809725 */     // GIR_Coverage, 19752,
     /*  809725 */     GIR_EraseRootFromParent_Done,
     /*  809726 */   // Label 12511: @809726
     /*  809726 */   GIM_Try, /*On fail goto*//*Label 12512*/ GIMT_Encode4(809801), // Rule ID 19753 //
     /*  809731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  809734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  809742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  809745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  809748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  809770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809777 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  809780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809799 */     GIR_RootConstrainSelectedInstOperands,
     /*  809800 */     // GIR_Coverage, 19753,
     /*  809800 */     GIR_EraseRootFromParent_Done,
     /*  809801 */   // Label 12512: @809801
     /*  809801 */   GIM_Try, /*On fail goto*//*Label 12513*/ GIMT_Encode4(809876), // Rule ID 19756 //
     /*  809806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  809809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  809817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  809820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  809823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  809845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809852 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  809855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809874 */     GIR_RootConstrainSelectedInstOperands,
     /*  809875 */     // GIR_Coverage, 19756,
     /*  809875 */     GIR_EraseRootFromParent_Done,
     /*  809876 */   // Label 12513: @809876
     /*  809876 */   GIM_Try, /*On fail goto*//*Label 12514*/ GIMT_Encode4(809951), // Rule ID 19757 //
     /*  809881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  809884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  809892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  809895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  809898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  809920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809927 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  809930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809949 */     GIR_RootConstrainSelectedInstOperands,
     /*  809950 */     // GIR_Coverage, 19757,
     /*  809950 */     GIR_EraseRootFromParent_Done,
     /*  809951 */   // Label 12514: @809951
     /*  809951 */   GIM_Try, /*On fail goto*//*Label 12515*/ GIMT_Encode4(810026), // Rule ID 19760 //
     /*  809956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  809959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  809967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  809970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  809973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  809995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810002 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  810002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  810005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810024 */     GIR_RootConstrainSelectedInstOperands,
     /*  810025 */     // GIR_Coverage, 19760,
     /*  810025 */     GIR_EraseRootFromParent_Done,
     /*  810026 */   // Label 12515: @810026
     /*  810026 */   GIM_Try, /*On fail goto*//*Label 12516*/ GIMT_Encode4(810101), // Rule ID 19761 //
     /*  810031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  810034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  810039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  810042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  810045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  810048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  810051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  810070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810077 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  810077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  810080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810099 */     GIR_RootConstrainSelectedInstOperands,
     /*  810100 */     // GIR_Coverage, 19761,
     /*  810100 */     GIR_EraseRootFromParent_Done,
     /*  810101 */   // Label 12516: @810101
     /*  810101 */   GIM_Try, /*On fail goto*//*Label 12517*/ GIMT_Encode4(810176), // Rule ID 21978 //
     /*  810106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  810123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810152 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  810155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810174 */     GIR_RootConstrainSelectedInstOperands,
     /*  810175 */     // GIR_Coverage, 21978,
     /*  810175 */     GIR_EraseRootFromParent_Done,
     /*  810176 */   // Label 12517: @810176
     /*  810176 */   GIM_Try, /*On fail goto*//*Label 12518*/ GIMT_Encode4(810251), // Rule ID 21979 //
     /*  810181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  810198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810227 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  810230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810249 */     GIR_RootConstrainSelectedInstOperands,
     /*  810250 */     // GIR_Coverage, 21979,
     /*  810250 */     GIR_EraseRootFromParent_Done,
     /*  810251 */   // Label 12518: @810251
     /*  810251 */   GIM_Try, /*On fail goto*//*Label 12519*/ GIMT_Encode4(810326), // Rule ID 21982 //
     /*  810256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  810273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  810305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810324 */     GIR_RootConstrainSelectedInstOperands,
     /*  810325 */     // GIR_Coverage, 21982,
     /*  810325 */     GIR_EraseRootFromParent_Done,
     /*  810326 */   // Label 12519: @810326
     /*  810326 */   GIM_Try, /*On fail goto*//*Label 12520*/ GIMT_Encode4(810401), // Rule ID 21983 //
     /*  810331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  810348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810377 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  810380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810399 */     GIR_RootConstrainSelectedInstOperands,
     /*  810400 */     // GIR_Coverage, 21983,
     /*  810400 */     GIR_EraseRootFromParent_Done,
     /*  810401 */   // Label 12520: @810401
     /*  810401 */   GIM_Try, /*On fail goto*//*Label 12521*/ GIMT_Encode4(810476), // Rule ID 21986 //
     /*  810406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  810423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  810455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810474 */     GIR_RootConstrainSelectedInstOperands,
     /*  810475 */     // GIR_Coverage, 21986,
     /*  810475 */     GIR_EraseRootFromParent_Done,
     /*  810476 */   // Label 12521: @810476
     /*  810476 */   GIM_Try, /*On fail goto*//*Label 12522*/ GIMT_Encode4(810551), // Rule ID 21987 //
     /*  810481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  810498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810527 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  810530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810549 */     GIR_RootConstrainSelectedInstOperands,
     /*  810550 */     // GIR_Coverage, 21987,
     /*  810550 */     GIR_EraseRootFromParent_Done,
     /*  810551 */   // Label 12522: @810551
     /*  810551 */   GIM_Try, /*On fail goto*//*Label 12523*/ GIMT_Encode4(810626), // Rule ID 21990 //
     /*  810556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  810573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  810605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810624 */     GIR_RootConstrainSelectedInstOperands,
     /*  810625 */     // GIR_Coverage, 21990,
     /*  810625 */     GIR_EraseRootFromParent_Done,
     /*  810626 */   // Label 12523: @810626
     /*  810626 */   GIM_Try, /*On fail goto*//*Label 12524*/ GIMT_Encode4(810701), // Rule ID 21991 //
     /*  810631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  810648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810677 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  810680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810699 */     GIR_RootConstrainSelectedInstOperands,
     /*  810700 */     // GIR_Coverage, 21991,
     /*  810700 */     GIR_EraseRootFromParent_Done,
     /*  810701 */   // Label 12524: @810701
     /*  810701 */   GIM_Try, /*On fail goto*//*Label 12525*/ GIMT_Encode4(810776), // Rule ID 21994 //
     /*  810706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  810723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  810752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  810755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810774 */     GIR_RootConstrainSelectedInstOperands,
     /*  810775 */     // GIR_Coverage, 21994,
     /*  810775 */     GIR_EraseRootFromParent_Done,
     /*  810776 */   // Label 12525: @810776
     /*  810776 */   GIM_Try, /*On fail goto*//*Label 12526*/ GIMT_Encode4(810851), // Rule ID 21995 //
     /*  810781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  810798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810827 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  810827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  810830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810849 */     GIR_RootConstrainSelectedInstOperands,
     /*  810850 */     // GIR_Coverage, 21995,
     /*  810850 */     GIR_EraseRootFromParent_Done,
     /*  810851 */   // Label 12526: @810851
     /*  810851 */   GIM_Try, /*On fail goto*//*Label 12527*/ GIMT_Encode4(810926), // Rule ID 21998 //
     /*  810856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  810873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  810905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810924 */     GIR_RootConstrainSelectedInstOperands,
     /*  810925 */     // GIR_Coverage, 21998,
     /*  810925 */     GIR_EraseRootFromParent_Done,
     /*  810926 */   // Label 12527: @810926
     /*  810926 */   GIM_Try, /*On fail goto*//*Label 12528*/ GIMT_Encode4(811001), // Rule ID 21999 //
     /*  810931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  810948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810977 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  810980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810999 */     GIR_RootConstrainSelectedInstOperands,
     /*  811000 */     // GIR_Coverage, 21999,
     /*  811000 */     GIR_EraseRootFromParent_Done,
     /*  811001 */   // Label 12528: @811001
     /*  811001 */   GIM_Try, /*On fail goto*//*Label 12529*/ GIMT_Encode4(811076), // Rule ID 22002 //
     /*  811006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  811023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  811055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811074 */     GIR_RootConstrainSelectedInstOperands,
     /*  811075 */     // GIR_Coverage, 22002,
     /*  811075 */     GIR_EraseRootFromParent_Done,
     /*  811076 */   // Label 12529: @811076
     /*  811076 */   GIM_Try, /*On fail goto*//*Label 12530*/ GIMT_Encode4(811151), // Rule ID 22003 //
     /*  811081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  811098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  811130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811149 */     GIR_RootConstrainSelectedInstOperands,
     /*  811150 */     // GIR_Coverage, 22003,
     /*  811150 */     GIR_EraseRootFromParent_Done,
     /*  811151 */   // Label 12530: @811151
     /*  811151 */   GIM_Try, /*On fail goto*//*Label 12531*/ GIMT_Encode4(811226), // Rule ID 22006 //
     /*  811156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  811173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  811202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  811205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811224 */     GIR_RootConstrainSelectedInstOperands,
     /*  811225 */     // GIR_Coverage, 22006,
     /*  811225 */     GIR_EraseRootFromParent_Done,
     /*  811226 */   // Label 12531: @811226
     /*  811226 */   GIM_Try, /*On fail goto*//*Label 12532*/ GIMT_Encode4(811301), // Rule ID 22007 //
     /*  811231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  811248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  811277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  811280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811299 */     GIR_RootConstrainSelectedInstOperands,
     /*  811300 */     // GIR_Coverage, 22007,
     /*  811300 */     GIR_EraseRootFromParent_Done,
     /*  811301 */   // Label 12532: @811301
     /*  811301 */   GIM_Try, /*On fail goto*//*Label 12533*/ GIMT_Encode4(811376), // Rule ID 22010 //
     /*  811306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  811309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  811317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  811320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  811323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  811326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  811352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  811355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  811371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811374 */     GIR_RootConstrainSelectedInstOperands,
     /*  811375 */     // GIR_Coverage, 22010,
     /*  811375 */     GIR_EraseRootFromParent_Done,
     /*  811376 */   // Label 12533: @811376
     /*  811376 */   GIM_Try, /*On fail goto*//*Label 12534*/ GIMT_Encode4(811451), // Rule ID 22011 //
     /*  811381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  811384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  811392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  811395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  811398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  811401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811427 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  811427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  811430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  811446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811449 */     GIR_RootConstrainSelectedInstOperands,
     /*  811450 */     // GIR_Coverage, 22011,
     /*  811450 */     GIR_EraseRootFromParent_Done,
     /*  811451 */   // Label 12534: @811451
     /*  811451 */   GIM_Try, /*On fail goto*//*Label 12535*/ GIMT_Encode4(811526), // Rule ID 22014 //
     /*  811456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  811473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  811505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811524 */     GIR_RootConstrainSelectedInstOperands,
     /*  811525 */     // GIR_Coverage, 22014,
     /*  811525 */     GIR_EraseRootFromParent_Done,
     /*  811526 */   // Label 12535: @811526
     /*  811526 */   GIM_Try, /*On fail goto*//*Label 12536*/ GIMT_Encode4(811601), // Rule ID 22015 //
     /*  811531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  811548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811577 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  811580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811599 */     GIR_RootConstrainSelectedInstOperands,
     /*  811600 */     // GIR_Coverage, 22015,
     /*  811600 */     GIR_EraseRootFromParent_Done,
     /*  811601 */   // Label 12536: @811601
     /*  811601 */   GIM_Try, /*On fail goto*//*Label 12537*/ GIMT_Encode4(811676), // Rule ID 22018 //
     /*  811606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  811623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  811655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811674 */     GIR_RootConstrainSelectedInstOperands,
     /*  811675 */     // GIR_Coverage, 22018,
     /*  811675 */     GIR_EraseRootFromParent_Done,
     /*  811676 */   // Label 12537: @811676
     /*  811676 */   GIM_Try, /*On fail goto*//*Label 12538*/ GIMT_Encode4(811751), // Rule ID 22019 //
     /*  811681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  811698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811727 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  811730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811749 */     GIR_RootConstrainSelectedInstOperands,
     /*  811750 */     // GIR_Coverage, 22019,
     /*  811750 */     GIR_EraseRootFromParent_Done,
     /*  811751 */   // Label 12538: @811751
     /*  811751 */   GIM_Try, /*On fail goto*//*Label 12539*/ GIMT_Encode4(811826), // Rule ID 22022 //
     /*  811756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  811773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  811805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811824 */     GIR_RootConstrainSelectedInstOperands,
     /*  811825 */     // GIR_Coverage, 22022,
     /*  811825 */     GIR_EraseRootFromParent_Done,
     /*  811826 */   // Label 12539: @811826
     /*  811826 */   GIM_Try, /*On fail goto*//*Label 12540*/ GIMT_Encode4(811901), // Rule ID 22023 //
     /*  811831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  811848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811877 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  811880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811899 */     GIR_RootConstrainSelectedInstOperands,
     /*  811900 */     // GIR_Coverage, 22023,
     /*  811900 */     GIR_EraseRootFromParent_Done,
     /*  811901 */   // Label 12540: @811901
     /*  811901 */   GIM_Try, /*On fail goto*//*Label 12541*/ GIMT_Encode4(811976), // Rule ID 22026 //
     /*  811906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  811923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811952 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  811955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811974 */     GIR_RootConstrainSelectedInstOperands,
     /*  811975 */     // GIR_Coverage, 22026,
     /*  811975 */     GIR_EraseRootFromParent_Done,
     /*  811976 */   // Label 12541: @811976
     /*  811976 */   GIM_Try, /*On fail goto*//*Label 12542*/ GIMT_Encode4(812051), // Rule ID 22027 //
     /*  811981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  811998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812027 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  812027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  812030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812049 */     GIR_RootConstrainSelectedInstOperands,
     /*  812050 */     // GIR_Coverage, 22027,
     /*  812050 */     GIR_EraseRootFromParent_Done,
     /*  812051 */   // Label 12542: @812051
     /*  812051 */   GIM_Try, /*On fail goto*//*Label 12543*/ GIMT_Encode4(812126), // Rule ID 22030 //
     /*  812056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  812073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  812102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  812105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812124 */     GIR_RootConstrainSelectedInstOperands,
     /*  812125 */     // GIR_Coverage, 22030,
     /*  812125 */     GIR_EraseRootFromParent_Done,
     /*  812126 */   // Label 12543: @812126
     /*  812126 */   GIM_Try, /*On fail goto*//*Label 12544*/ GIMT_Encode4(812201), // Rule ID 22031 //
     /*  812131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  812148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812177 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  812177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  812180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812199 */     GIR_RootConstrainSelectedInstOperands,
     /*  812200 */     // GIR_Coverage, 22031,
     /*  812200 */     GIR_EraseRootFromParent_Done,
     /*  812201 */   // Label 12544: @812201
     /*  812201 */   GIM_Try, /*On fail goto*//*Label 12545*/ GIMT_Encode4(812276), // Rule ID 22034 //
     /*  812206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  812223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  812252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  812255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812274 */     GIR_RootConstrainSelectedInstOperands,
     /*  812275 */     // GIR_Coverage, 22034,
     /*  812275 */     GIR_EraseRootFromParent_Done,
     /*  812276 */   // Label 12545: @812276
     /*  812276 */   GIM_Try, /*On fail goto*//*Label 12546*/ GIMT_Encode4(812351), // Rule ID 22035 //
     /*  812281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  812298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  812327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  812330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812349 */     GIR_RootConstrainSelectedInstOperands,
     /*  812350 */     // GIR_Coverage, 22035,
     /*  812350 */     GIR_EraseRootFromParent_Done,
     /*  812351 */   // Label 12546: @812351
     /*  812351 */   GIM_Try, /*On fail goto*//*Label 12547*/ GIMT_Encode4(812426), // Rule ID 22038 //
     /*  812356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  812373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812402 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  812405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812424 */     GIR_RootConstrainSelectedInstOperands,
     /*  812425 */     // GIR_Coverage, 22038,
     /*  812425 */     GIR_EraseRootFromParent_Done,
     /*  812426 */   // Label 12547: @812426
     /*  812426 */   GIM_Try, /*On fail goto*//*Label 12548*/ GIMT_Encode4(812501), // Rule ID 22039 //
     /*  812431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  812448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812477 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  812480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812499 */     GIR_RootConstrainSelectedInstOperands,
     /*  812500 */     // GIR_Coverage, 22039,
     /*  812500 */     GIR_EraseRootFromParent_Done,
     /*  812501 */   // Label 12548: @812501
     /*  812501 */   GIM_Try, /*On fail goto*//*Label 12549*/ GIMT_Encode4(812576), // Rule ID 22042 //
     /*  812506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  812523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  812555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812574 */     GIR_RootConstrainSelectedInstOperands,
     /*  812575 */     // GIR_Coverage, 22042,
     /*  812575 */     GIR_EraseRootFromParent_Done,
     /*  812576 */   // Label 12549: @812576
     /*  812576 */   GIM_Try, /*On fail goto*//*Label 12550*/ GIMT_Encode4(812651), // Rule ID 22043 //
     /*  812581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  812598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812627 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  812630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812649 */     GIR_RootConstrainSelectedInstOperands,
     /*  812650 */     // GIR_Coverage, 22043,
     /*  812650 */     GIR_EraseRootFromParent_Done,
     /*  812651 */   // Label 12550: @812651
     /*  812651 */   GIM_Try, /*On fail goto*//*Label 12551*/ GIMT_Encode4(812726), // Rule ID 22046 //
     /*  812656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  812673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  812705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812724 */     GIR_RootConstrainSelectedInstOperands,
     /*  812725 */     // GIR_Coverage, 22046,
     /*  812725 */     GIR_EraseRootFromParent_Done,
     /*  812726 */   // Label 12551: @812726
     /*  812726 */   GIM_Try, /*On fail goto*//*Label 12552*/ GIMT_Encode4(812801), // Rule ID 22047 //
     /*  812731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  812748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812777 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  812780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812799 */     GIR_RootConstrainSelectedInstOperands,
     /*  812800 */     // GIR_Coverage, 22047,
     /*  812800 */     GIR_EraseRootFromParent_Done,
     /*  812801 */   // Label 12552: @812801
     /*  812801 */   GIM_Try, /*On fail goto*//*Label 12553*/ GIMT_Encode4(812876), // Rule ID 22050 //
     /*  812806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  812823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  812852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  812855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812874 */     GIR_RootConstrainSelectedInstOperands,
     /*  812875 */     // GIR_Coverage, 22050,
     /*  812875 */     GIR_EraseRootFromParent_Done,
     /*  812876 */   // Label 12553: @812876
     /*  812876 */   GIM_Try, /*On fail goto*//*Label 12554*/ GIMT_Encode4(812951), // Rule ID 22051 //
     /*  812881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  812884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  812898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812927 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  812927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  812930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812949 */     GIR_RootConstrainSelectedInstOperands,
     /*  812950 */     // GIR_Coverage, 22051,
     /*  812950 */     GIR_EraseRootFromParent_Done,
     /*  812951 */   // Label 12554: @812951
     /*  812951 */   GIM_Try, /*On fail goto*//*Label 12555*/ GIMT_Encode4(813026), // Rule ID 22054 //
     /*  812956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  812973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813002 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  813002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  813005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813024 */     GIR_RootConstrainSelectedInstOperands,
     /*  813025 */     // GIR_Coverage, 22054,
     /*  813025 */     GIR_EraseRootFromParent_Done,
     /*  813026 */   // Label 12555: @813026
     /*  813026 */   GIM_Try, /*On fail goto*//*Label 12556*/ GIMT_Encode4(813101), // Rule ID 22055 //
     /*  813031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  813034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  813039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  813045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  813048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  813066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813077 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  813077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  813080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813099 */     GIR_RootConstrainSelectedInstOperands,
     /*  813100 */     // GIR_Coverage, 22055,
     /*  813100 */     GIR_EraseRootFromParent_Done,
     /*  813101 */   // Label 12556: @813101
     /*  813101 */   GIM_Try, /*On fail goto*//*Label 12557*/ GIMT_Encode4(813176), // Rule ID 22058 //
     /*  813106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  813109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  813114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  813120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  813123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  813152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  813155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813174 */     GIR_RootConstrainSelectedInstOperands,
     /*  813175 */     // GIR_Coverage, 22058,
     /*  813175 */     GIR_EraseRootFromParent_Done,
     /*  813176 */   // Label 12557: @813176
     /*  813176 */   GIM_Try, /*On fail goto*//*Label 12558*/ GIMT_Encode4(813251), // Rule ID 22059 //
     /*  813181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  813184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  813189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  813195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  813198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813227 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  813227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  813230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813249 */     GIR_RootConstrainSelectedInstOperands,
     /*  813250 */     // GIR_Coverage, 22059,
     /*  813250 */     GIR_EraseRootFromParent_Done,
     /*  813251 */   // Label 12558: @813251
     /*  813251 */   GIM_Try, /*On fail goto*//*Label 12559*/ GIMT_Encode4(813326), // Rule ID 22062 //
     /*  813256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  813273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  813305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813324 */     GIR_RootConstrainSelectedInstOperands,
     /*  813325 */     // GIR_Coverage, 22062,
     /*  813325 */     GIR_EraseRootFromParent_Done,
     /*  813326 */   // Label 12559: @813326
     /*  813326 */   GIM_Try, /*On fail goto*//*Label 12560*/ GIMT_Encode4(813401), // Rule ID 22063 //
     /*  813331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  813348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813377 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  813380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813399 */     GIR_RootConstrainSelectedInstOperands,
     /*  813400 */     // GIR_Coverage, 22063,
     /*  813400 */     GIR_EraseRootFromParent_Done,
     /*  813401 */   // Label 12560: @813401
     /*  813401 */   GIM_Try, /*On fail goto*//*Label 12561*/ GIMT_Encode4(813476), // Rule ID 22066 //
     /*  813406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  813423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  813455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813474 */     GIR_RootConstrainSelectedInstOperands,
     /*  813475 */     // GIR_Coverage, 22066,
     /*  813475 */     GIR_EraseRootFromParent_Done,
     /*  813476 */   // Label 12561: @813476
     /*  813476 */   GIM_Try, /*On fail goto*//*Label 12562*/ GIMT_Encode4(813551), // Rule ID 22067 //
     /*  813481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  813498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813527 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  813530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813549 */     GIR_RootConstrainSelectedInstOperands,
     /*  813550 */     // GIR_Coverage, 22067,
     /*  813550 */     GIR_EraseRootFromParent_Done,
     /*  813551 */   // Label 12562: @813551
     /*  813551 */   GIM_Try, /*On fail goto*//*Label 12563*/ GIMT_Encode4(813626), // Rule ID 22070 //
     /*  813556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  813573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  813605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813624 */     GIR_RootConstrainSelectedInstOperands,
     /*  813625 */     // GIR_Coverage, 22070,
     /*  813625 */     GIR_EraseRootFromParent_Done,
     /*  813626 */   // Label 12563: @813626
     /*  813626 */   GIM_Try, /*On fail goto*//*Label 12564*/ GIMT_Encode4(813701), // Rule ID 22071 //
     /*  813631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  813648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813677 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  813680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813699 */     GIR_RootConstrainSelectedInstOperands,
     /*  813700 */     // GIR_Coverage, 22071,
     /*  813700 */     GIR_EraseRootFromParent_Done,
     /*  813701 */   // Label 12564: @813701
     /*  813701 */   GIM_Try, /*On fail goto*//*Label 12565*/ GIMT_Encode4(813776), // Rule ID 22074 //
     /*  813706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  813723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  813755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813774 */     GIR_RootConstrainSelectedInstOperands,
     /*  813775 */     // GIR_Coverage, 22074,
     /*  813775 */     GIR_EraseRootFromParent_Done,
     /*  813776 */   // Label 12565: @813776
     /*  813776 */   GIM_Try, /*On fail goto*//*Label 12566*/ GIMT_Encode4(813851), // Rule ID 22075 //
     /*  813781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  813798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  813830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813849 */     GIR_RootConstrainSelectedInstOperands,
     /*  813850 */     // GIR_Coverage, 22075,
     /*  813850 */     GIR_EraseRootFromParent_Done,
     /*  813851 */   // Label 12566: @813851
     /*  813851 */   GIM_Try, /*On fail goto*//*Label 12567*/ GIMT_Encode4(813926), // Rule ID 22078 //
     /*  813856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  813873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  813905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813924 */     GIR_RootConstrainSelectedInstOperands,
     /*  813925 */     // GIR_Coverage, 22078,
     /*  813925 */     GIR_EraseRootFromParent_Done,
     /*  813926 */   // Label 12567: @813926
     /*  813926 */   GIM_Try, /*On fail goto*//*Label 12568*/ GIMT_Encode4(814001), // Rule ID 22079 //
     /*  813931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  813948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813977 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  813980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813999 */     GIR_RootConstrainSelectedInstOperands,
     /*  814000 */     // GIR_Coverage, 22079,
     /*  814000 */     GIR_EraseRootFromParent_Done,
     /*  814001 */   // Label 12568: @814001
     /*  814001 */   GIM_Try, /*On fail goto*//*Label 12569*/ GIMT_Encode4(814076), // Rule ID 22082 //
     /*  814006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  814023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  814052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  814055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814074 */     GIR_RootConstrainSelectedInstOperands,
     /*  814075 */     // GIR_Coverage, 22082,
     /*  814075 */     GIR_EraseRootFromParent_Done,
     /*  814076 */   // Label 12569: @814076
     /*  814076 */   GIM_Try, /*On fail goto*//*Label 12570*/ GIMT_Encode4(814151), // Rule ID 22083 //
     /*  814081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  814098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814127 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  814127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  814130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814149 */     GIR_RootConstrainSelectedInstOperands,
     /*  814150 */     // GIR_Coverage, 22083,
     /*  814150 */     GIR_EraseRootFromParent_Done,
     /*  814151 */   // Label 12570: @814151
     /*  814151 */   GIM_Try, /*On fail goto*//*Label 12571*/ GIMT_Encode4(814226), // Rule ID 22086 //
     /*  814156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  814173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814202 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  814205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814224 */     GIR_RootConstrainSelectedInstOperands,
     /*  814225 */     // GIR_Coverage, 22086,
     /*  814225 */     GIR_EraseRootFromParent_Done,
     /*  814226 */   // Label 12571: @814226
     /*  814226 */   GIM_Try, /*On fail goto*//*Label 12572*/ GIMT_Encode4(814301), // Rule ID 22087 //
     /*  814231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  814248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814277 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  814280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814299 */     GIR_RootConstrainSelectedInstOperands,
     /*  814300 */     // GIR_Coverage, 22087,
     /*  814300 */     GIR_EraseRootFromParent_Done,
     /*  814301 */   // Label 12572: @814301
     /*  814301 */   GIM_Try, /*On fail goto*//*Label 12573*/ GIMT_Encode4(814376), // Rule ID 22090 //
     /*  814306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  814323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  814352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  814355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814374 */     GIR_RootConstrainSelectedInstOperands,
     /*  814375 */     // GIR_Coverage, 22090,
     /*  814375 */     GIR_EraseRootFromParent_Done,
     /*  814376 */   // Label 12573: @814376
     /*  814376 */   GIM_Try, /*On fail goto*//*Label 12574*/ GIMT_Encode4(814451), // Rule ID 22091 //
     /*  814381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  814398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814427 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  814427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  814430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814449 */     GIR_RootConstrainSelectedInstOperands,
     /*  814450 */     // GIR_Coverage, 22091,
     /*  814450 */     GIR_EraseRootFromParent_Done,
     /*  814451 */   // Label 12574: @814451
     /*  814451 */   GIM_Try, /*On fail goto*//*Label 12575*/ GIMT_Encode4(814526), // Rule ID 22094 //
     /*  814456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  814473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  814502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  814505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814524 */     GIR_RootConstrainSelectedInstOperands,
     /*  814525 */     // GIR_Coverage, 22094,
     /*  814525 */     GIR_EraseRootFromParent_Done,
     /*  814526 */   // Label 12575: @814526
     /*  814526 */   GIM_Try, /*On fail goto*//*Label 12576*/ GIMT_Encode4(814601), // Rule ID 22095 //
     /*  814531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  814548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814577 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  814577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  814580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814599 */     GIR_RootConstrainSelectedInstOperands,
     /*  814600 */     // GIR_Coverage, 22095,
     /*  814600 */     GIR_EraseRootFromParent_Done,
     /*  814601 */   // Label 12576: @814601
     /*  814601 */   GIM_Try, /*On fail goto*//*Label 12577*/ GIMT_Encode4(814676), // Rule ID 22098 //
     /*  814606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  814609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  814617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  814620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  814623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  814626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  814652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  814655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  814671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814674 */     GIR_RootConstrainSelectedInstOperands,
     /*  814675 */     // GIR_Coverage, 22098,
     /*  814675 */     GIR_EraseRootFromParent_Done,
     /*  814676 */   // Label 12577: @814676
     /*  814676 */   GIM_Try, /*On fail goto*//*Label 12578*/ GIMT_Encode4(814751), // Rule ID 22099 //
     /*  814681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  814684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  814692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  814695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  814698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  814701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  814727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  814730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  814746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814749 */     GIR_RootConstrainSelectedInstOperands,
     /*  814750 */     // GIR_Coverage, 22099,
     /*  814750 */     GIR_EraseRootFromParent_Done,
     /*  814751 */   // Label 12578: @814751
     /*  814751 */   GIM_Try, /*On fail goto*//*Label 12579*/ GIMT_Encode4(814826), // Rule ID 22102 //
     /*  814756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  814773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  814805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814824 */     GIR_RootConstrainSelectedInstOperands,
     /*  814825 */     // GIR_Coverage, 22102,
     /*  814825 */     GIR_EraseRootFromParent_Done,
     /*  814826 */   // Label 12579: @814826
     /*  814826 */   GIM_Try, /*On fail goto*//*Label 12580*/ GIMT_Encode4(814901), // Rule ID 22103 //
     /*  814831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  814848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814877 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  814880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814899 */     GIR_RootConstrainSelectedInstOperands,
     /*  814900 */     // GIR_Coverage, 22103,
     /*  814900 */     GIR_EraseRootFromParent_Done,
     /*  814901 */   // Label 12580: @814901
     /*  814901 */   GIM_Try, /*On fail goto*//*Label 12581*/ GIMT_Encode4(814976), // Rule ID 22106 //
     /*  814906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  814923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  814955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814974 */     GIR_RootConstrainSelectedInstOperands,
     /*  814975 */     // GIR_Coverage, 22106,
     /*  814975 */     GIR_EraseRootFromParent_Done,
     /*  814976 */   // Label 12581: @814976
     /*  814976 */   GIM_Try, /*On fail goto*//*Label 12582*/ GIMT_Encode4(815051), // Rule ID 22107 //
     /*  814981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  814998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  815027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  815030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815049 */     GIR_RootConstrainSelectedInstOperands,
     /*  815050 */     // GIR_Coverage, 22107,
     /*  815050 */     GIR_EraseRootFromParent_Done,
     /*  815051 */   // Label 12582: @815051
     /*  815051 */   GIM_Try, /*On fail goto*//*Label 12583*/ GIMT_Encode4(815126), // Rule ID 22110 //
     /*  815056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  815067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  815070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  815073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  815102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  815105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815124 */     GIR_RootConstrainSelectedInstOperands,
     /*  815125 */     // GIR_Coverage, 22110,
     /*  815125 */     GIR_EraseRootFromParent_Done,
     /*  815126 */   // Label 12583: @815126
     /*  815126 */   GIM_Try, /*On fail goto*//*Label 12584*/ GIMT_Encode4(815201), // Rule ID 22111 //
     /*  815131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  815142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  815145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  815148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815177 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  815177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  815180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815199 */     GIR_RootConstrainSelectedInstOperands,
     /*  815200 */     // GIR_Coverage, 22111,
     /*  815200 */     GIR_EraseRootFromParent_Done,
     /*  815201 */   // Label 12584: @815201
     /*  815201 */   GIM_Try, /*On fail goto*//*Label 12585*/ GIMT_Encode4(815276), // Rule ID 22114 //
     /*  815206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  815223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  815255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815274 */     GIR_RootConstrainSelectedInstOperands,
     /*  815275 */     // GIR_Coverage, 22114,
     /*  815275 */     GIR_EraseRootFromParent_Done,
     /*  815276 */   // Label 12585: @815276
     /*  815276 */   GIM_Try, /*On fail goto*//*Label 12586*/ GIMT_Encode4(815351), // Rule ID 22115 //
     /*  815281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  815298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  815330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815349 */     GIR_RootConstrainSelectedInstOperands,
     /*  815350 */     // GIR_Coverage, 22115,
     /*  815350 */     GIR_EraseRootFromParent_Done,
     /*  815351 */   // Label 12586: @815351
     /*  815351 */   GIM_Try, /*On fail goto*//*Label 12587*/ GIMT_Encode4(815426), // Rule ID 22118 //
     /*  815356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  815373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  815405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815424 */     GIR_RootConstrainSelectedInstOperands,
     /*  815425 */     // GIR_Coverage, 22118,
     /*  815425 */     GIR_EraseRootFromParent_Done,
     /*  815426 */   // Label 12587: @815426
     /*  815426 */   GIM_Try, /*On fail goto*//*Label 12588*/ GIMT_Encode4(815501), // Rule ID 22119 //
     /*  815431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  815448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  815480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815499 */     GIR_RootConstrainSelectedInstOperands,
     /*  815500 */     // GIR_Coverage, 22119,
     /*  815500 */     GIR_EraseRootFromParent_Done,
     /*  815501 */   // Label 12588: @815501
     /*  815501 */   GIM_Try, /*On fail goto*//*Label 12589*/ GIMT_Encode4(815576), // Rule ID 22122 //
     /*  815506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  815523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  815555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815574 */     GIR_RootConstrainSelectedInstOperands,
     /*  815575 */     // GIR_Coverage, 22122,
     /*  815575 */     GIR_EraseRootFromParent_Done,
     /*  815576 */   // Label 12589: @815576
     /*  815576 */   GIM_Try, /*On fail goto*//*Label 12590*/ GIMT_Encode4(815651), // Rule ID 22123 //
     /*  815581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  815598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815627 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  815630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815649 */     GIR_RootConstrainSelectedInstOperands,
     /*  815650 */     // GIR_Coverage, 22123,
     /*  815650 */     GIR_EraseRootFromParent_Done,
     /*  815651 */   // Label 12590: @815651
     /*  815651 */   GIM_Try, /*On fail goto*//*Label 12591*/ GIMT_Encode4(815726), // Rule ID 22126 //
     /*  815656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  815673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  815705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815724 */     GIR_RootConstrainSelectedInstOperands,
     /*  815725 */     // GIR_Coverage, 22126,
     /*  815725 */     GIR_EraseRootFromParent_Done,
     /*  815726 */   // Label 12591: @815726
     /*  815726 */   GIM_Try, /*On fail goto*//*Label 12592*/ GIMT_Encode4(815801), // Rule ID 22127 //
     /*  815731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  815748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815777 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  815780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815799 */     GIR_RootConstrainSelectedInstOperands,
     /*  815800 */     // GIR_Coverage, 22127,
     /*  815800 */     GIR_EraseRootFromParent_Done,
     /*  815801 */   // Label 12592: @815801
     /*  815801 */   GIM_Try, /*On fail goto*//*Label 12593*/ GIMT_Encode4(815876), // Rule ID 22130 //
     /*  815806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  815823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  815855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815874 */     GIR_RootConstrainSelectedInstOperands,
     /*  815875 */     // GIR_Coverage, 22130,
     /*  815875 */     GIR_EraseRootFromParent_Done,
     /*  815876 */   // Label 12593: @815876
     /*  815876 */   GIM_Try, /*On fail goto*//*Label 12594*/ GIMT_Encode4(815951), // Rule ID 22131 //
     /*  815881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  815898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  815930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815949 */     GIR_RootConstrainSelectedInstOperands,
     /*  815950 */     // GIR_Coverage, 22131,
     /*  815950 */     GIR_EraseRootFromParent_Done,
     /*  815951 */   // Label 12594: @815951
     /*  815951 */   GIM_Try, /*On fail goto*//*Label 12595*/ GIMT_Encode4(816026), // Rule ID 22134 //
     /*  815956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  815973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  816002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  816005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816024 */     GIR_RootConstrainSelectedInstOperands,
     /*  816025 */     // GIR_Coverage, 22134,
     /*  816025 */     GIR_EraseRootFromParent_Done,
     /*  816026 */   // Label 12595: @816026
     /*  816026 */   GIM_Try, /*On fail goto*//*Label 12596*/ GIMT_Encode4(816101), // Rule ID 22135 //
     /*  816031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  816042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  816045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  816048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  816051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816077 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  816077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  816080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816099 */     GIR_RootConstrainSelectedInstOperands,
     /*  816100 */     // GIR_Coverage, 22135,
     /*  816100 */     GIR_EraseRootFromParent_Done,
     /*  816101 */   // Label 12596: @816101
     /*  816101 */   GIM_Try, /*On fail goto*//*Label 12597*/ GIMT_Encode4(816176), // Rule ID 22138 //
     /*  816106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  816109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  816123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  816152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  816155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816174 */     GIR_RootConstrainSelectedInstOperands,
     /*  816175 */     // GIR_Coverage, 22138,
     /*  816175 */     GIR_EraseRootFromParent_Done,
     /*  816176 */   // Label 12597: @816176
     /*  816176 */   GIM_Try, /*On fail goto*//*Label 12598*/ GIMT_Encode4(816251), // Rule ID 22139 //
     /*  816181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  816184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  816198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816227 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  816227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  816230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816249 */     GIR_RootConstrainSelectedInstOperands,
     /*  816250 */     // GIR_Coverage, 22139,
     /*  816250 */     GIR_EraseRootFromParent_Done,
     /*  816251 */   // Label 12598: @816251
     /*  816251 */   GIM_Try, /*On fail goto*//*Label 12599*/ GIMT_Encode4(816326), // Rule ID 22142 //
     /*  816256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  816259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  816273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816302 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  816302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  816305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816324 */     GIR_RootConstrainSelectedInstOperands,
     /*  816325 */     // GIR_Coverage, 22142,
     /*  816325 */     GIR_EraseRootFromParent_Done,
     /*  816326 */   // Label 12599: @816326
     /*  816326 */   GIM_Try, /*On fail goto*//*Label 12600*/ GIMT_Encode4(816401), // Rule ID 22143 //
     /*  816331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  816334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  816348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816377 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  816377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  816380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816399 */     GIR_RootConstrainSelectedInstOperands,
     /*  816400 */     // GIR_Coverage, 22143,
     /*  816400 */     GIR_EraseRootFromParent_Done,
     /*  816401 */   // Label 12600: @816401
     /*  816401 */   GIM_Try, /*On fail goto*//*Label 12601*/ GIMT_Encode4(816476), // Rule ID 22146 //
     /*  816406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  816409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  816423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816452 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  816452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  816455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816474 */     GIR_RootConstrainSelectedInstOperands,
     /*  816475 */     // GIR_Coverage, 22146,
     /*  816475 */     GIR_EraseRootFromParent_Done,
     /*  816476 */   // Label 12601: @816476
     /*  816476 */   GIM_Try, /*On fail goto*//*Label 12602*/ GIMT_Encode4(816551), // Rule ID 22147 //
     /*  816481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  816484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  816498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816527 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  816527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  816530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816549 */     GIR_RootConstrainSelectedInstOperands,
     /*  816550 */     // GIR_Coverage, 22147,
     /*  816550 */     GIR_EraseRootFromParent_Done,
     /*  816551 */   // Label 12602: @816551
     /*  816551 */   GIM_Try, /*On fail goto*//*Label 12603*/ GIMT_Encode4(816626), // Rule ID 22150 //
     /*  816556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  816573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  816605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816624 */     GIR_RootConstrainSelectedInstOperands,
     /*  816625 */     // GIR_Coverage, 22150,
     /*  816625 */     GIR_EraseRootFromParent_Done,
     /*  816626 */   // Label 12603: @816626
     /*  816626 */   GIM_Try, /*On fail goto*//*Label 12604*/ GIMT_Encode4(816701), // Rule ID 22151 //
     /*  816631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  816648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816677 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  816680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816699 */     GIR_RootConstrainSelectedInstOperands,
     /*  816700 */     // GIR_Coverage, 22151,
     /*  816700 */     GIR_EraseRootFromParent_Done,
     /*  816701 */   // Label 12604: @816701
     /*  816701 */   GIM_Try, /*On fail goto*//*Label 12605*/ GIMT_Encode4(816776), // Rule ID 22154 //
     /*  816706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  816723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816752 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  816755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816774 */     GIR_RootConstrainSelectedInstOperands,
     /*  816775 */     // GIR_Coverage, 22154,
     /*  816775 */     GIR_EraseRootFromParent_Done,
     /*  816776 */   // Label 12605: @816776
     /*  816776 */   GIM_Try, /*On fail goto*//*Label 12606*/ GIMT_Encode4(816851), // Rule ID 22155 //
     /*  816781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  816798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816827 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  816830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816849 */     GIR_RootConstrainSelectedInstOperands,
     /*  816850 */     // GIR_Coverage, 22155,
     /*  816850 */     GIR_EraseRootFromParent_Done,
     /*  816851 */   // Label 12606: @816851
     /*  816851 */   GIM_Try, /*On fail goto*//*Label 12607*/ GIMT_Encode4(816926), // Rule ID 22158 //
     /*  816856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  816873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  816905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816924 */     GIR_RootConstrainSelectedInstOperands,
     /*  816925 */     // GIR_Coverage, 22158,
     /*  816925 */     GIR_EraseRootFromParent_Done,
     /*  816926 */   // Label 12607: @816926
     /*  816926 */   GIM_Try, /*On fail goto*//*Label 12608*/ GIMT_Encode4(817001), // Rule ID 22159 //
     /*  816931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  816948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816977 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  816980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816999 */     GIR_RootConstrainSelectedInstOperands,
     /*  817000 */     // GIR_Coverage, 22159,
     /*  817000 */     GIR_EraseRootFromParent_Done,
     /*  817001 */   // Label 12608: @817001
     /*  817001 */   GIM_Try, /*On fail goto*//*Label 12609*/ GIMT_Encode4(817076), // Rule ID 22162 //
     /*  817006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  817023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  817055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817074 */     GIR_RootConstrainSelectedInstOperands,
     /*  817075 */     // GIR_Coverage, 22162,
     /*  817075 */     GIR_EraseRootFromParent_Done,
     /*  817076 */   // Label 12609: @817076
     /*  817076 */   GIM_Try, /*On fail goto*//*Label 12610*/ GIMT_Encode4(817151), // Rule ID 22163 //
     /*  817081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  817098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  817130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817149 */     GIR_RootConstrainSelectedInstOperands,
     /*  817150 */     // GIR_Coverage, 22163,
     /*  817150 */     GIR_EraseRootFromParent_Done,
     /*  817151 */   // Label 12610: @817151
     /*  817151 */   GIM_Try, /*On fail goto*//*Label 12611*/ GIMT_Encode4(817226), // Rule ID 22166 //
     /*  817156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  817173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  817205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817224 */     GIR_RootConstrainSelectedInstOperands,
     /*  817225 */     // GIR_Coverage, 22166,
     /*  817225 */     GIR_EraseRootFromParent_Done,
     /*  817226 */   // Label 12611: @817226
     /*  817226 */   GIM_Try, /*On fail goto*//*Label 12612*/ GIMT_Encode4(817301), // Rule ID 22167 //
     /*  817231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  817248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817277 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  817280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817299 */     GIR_RootConstrainSelectedInstOperands,
     /*  817300 */     // GIR_Coverage, 22167,
     /*  817300 */     GIR_EraseRootFromParent_Done,
     /*  817301 */   // Label 12612: @817301
     /*  817301 */   GIM_Try, /*On fail goto*//*Label 12613*/ GIMT_Encode4(817376), // Rule ID 22170 //
     /*  817306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  817323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  817352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  817355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817374 */     GIR_RootConstrainSelectedInstOperands,
     /*  817375 */     // GIR_Coverage, 22170,
     /*  817375 */     GIR_EraseRootFromParent_Done,
     /*  817376 */   // Label 12613: @817376
     /*  817376 */   GIM_Try, /*On fail goto*//*Label 12614*/ GIMT_Encode4(817451), // Rule ID 22171 //
     /*  817381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  817398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817427 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  817427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  817430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817449 */     GIR_RootConstrainSelectedInstOperands,
     /*  817450 */     // GIR_Coverage, 22171,
     /*  817450 */     GIR_EraseRootFromParent_Done,
     /*  817451 */   // Label 12614: @817451
     /*  817451 */   GIM_Try, /*On fail goto*//*Label 12615*/ GIMT_Encode4(817526), // Rule ID 22174 //
     /*  817456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  817473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  817502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  817505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817524 */     GIR_RootConstrainSelectedInstOperands,
     /*  817525 */     // GIR_Coverage, 22174,
     /*  817525 */     GIR_EraseRootFromParent_Done,
     /*  817526 */   // Label 12615: @817526
     /*  817526 */   GIM_Try, /*On fail goto*//*Label 12616*/ GIMT_Encode4(817601), // Rule ID 22175 //
     /*  817531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  817548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817577 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  817580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817599 */     GIR_RootConstrainSelectedInstOperands,
     /*  817600 */     // GIR_Coverage, 22175,
     /*  817600 */     GIR_EraseRootFromParent_Done,
     /*  817601 */   // Label 12616: @817601
     /*  817601 */   GIM_Try, /*On fail goto*//*Label 12617*/ GIMT_Encode4(817676), // Rule ID 22178 //
     /*  817606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  817623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  817655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817674 */     GIR_RootConstrainSelectedInstOperands,
     /*  817675 */     // GIR_Coverage, 22178,
     /*  817675 */     GIR_EraseRootFromParent_Done,
     /*  817676 */   // Label 12617: @817676
     /*  817676 */   GIM_Try, /*On fail goto*//*Label 12618*/ GIMT_Encode4(817751), // Rule ID 22179 //
     /*  817681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  817698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817727 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  817730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817749 */     GIR_RootConstrainSelectedInstOperands,
     /*  817750 */     // GIR_Coverage, 22179,
     /*  817750 */     GIR_EraseRootFromParent_Done,
     /*  817751 */   // Label 12618: @817751
     /*  817751 */   GIM_Try, /*On fail goto*//*Label 12619*/ GIMT_Encode4(817826), // Rule ID 22182 //
     /*  817756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  817773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  817802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  817805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817824 */     GIR_RootConstrainSelectedInstOperands,
     /*  817825 */     // GIR_Coverage, 22182,
     /*  817825 */     GIR_EraseRootFromParent_Done,
     /*  817826 */   // Label 12619: @817826
     /*  817826 */   GIM_Try, /*On fail goto*//*Label 12620*/ GIMT_Encode4(817901), // Rule ID 22183 //
     /*  817831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  817848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  817877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  817880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817899 */     GIR_RootConstrainSelectedInstOperands,
     /*  817900 */     // GIR_Coverage, 22183,
     /*  817900 */     GIR_EraseRootFromParent_Done,
     /*  817901 */   // Label 12620: @817901
     /*  817901 */   GIM_Try, /*On fail goto*//*Label 12621*/ GIMT_Encode4(817976), // Rule ID 22186 //
     /*  817906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  817909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  817920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  817926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  817952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  817955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  817971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817974 */     GIR_RootConstrainSelectedInstOperands,
     /*  817975 */     // GIR_Coverage, 22186,
     /*  817975 */     GIR_EraseRootFromParent_Done,
     /*  817976 */   // Label 12621: @817976
     /*  817976 */   GIM_Try, /*On fail goto*//*Label 12622*/ GIMT_Encode4(818051), // Rule ID 22187 //
     /*  817981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  817984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  817995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  818001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818027 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  818027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  818030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  818046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818049 */     GIR_RootConstrainSelectedInstOperands,
     /*  818050 */     // GIR_Coverage, 22187,
     /*  818050 */     GIR_EraseRootFromParent_Done,
     /*  818051 */   // Label 12622: @818051
     /*  818051 */   GIM_Try, /*On fail goto*//*Label 12623*/ GIMT_Encode4(818126), // Rule ID 22190 //
     /*  818056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  818073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  818102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  818105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818124 */     GIR_RootConstrainSelectedInstOperands,
     /*  818125 */     // GIR_Coverage, 22190,
     /*  818125 */     GIR_EraseRootFromParent_Done,
     /*  818126 */   // Label 12623: @818126
     /*  818126 */   GIM_Try, /*On fail goto*//*Label 12624*/ GIMT_Encode4(818201), // Rule ID 22191 //
     /*  818131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  818148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818177 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  818177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  818180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818199 */     GIR_RootConstrainSelectedInstOperands,
     /*  818200 */     // GIR_Coverage, 22191,
     /*  818200 */     GIR_EraseRootFromParent_Done,
     /*  818201 */   // Label 12624: @818201
     /*  818201 */   GIM_Try, /*On fail goto*//*Label 12625*/ GIMT_Encode4(818276), // Rule ID 22194 //
     /*  818206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  818223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  818252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  818255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818274 */     GIR_RootConstrainSelectedInstOperands,
     /*  818275 */     // GIR_Coverage, 22194,
     /*  818275 */     GIR_EraseRootFromParent_Done,
     /*  818276 */   // Label 12625: @818276
     /*  818276 */   GIM_Try, /*On fail goto*//*Label 12626*/ GIMT_Encode4(818351), // Rule ID 22195 //
     /*  818281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  818298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  818327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  818330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818349 */     GIR_RootConstrainSelectedInstOperands,
     /*  818350 */     // GIR_Coverage, 22195,
     /*  818350 */     GIR_EraseRootFromParent_Done,
     /*  818351 */   // Label 12626: @818351
     /*  818351 */   GIM_Try, /*On fail goto*//*Label 12627*/ GIMT_Encode4(818426), // Rule ID 22198 //
     /*  818356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  818373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818402 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  818402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  818405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818424 */     GIR_RootConstrainSelectedInstOperands,
     /*  818425 */     // GIR_Coverage, 22198,
     /*  818425 */     GIR_EraseRootFromParent_Done,
     /*  818426 */   // Label 12627: @818426
     /*  818426 */   GIM_Try, /*On fail goto*//*Label 12628*/ GIMT_Encode4(818501), // Rule ID 22199 //
     /*  818431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  818448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818477 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  818477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  818480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818499 */     GIR_RootConstrainSelectedInstOperands,
     /*  818500 */     // GIR_Coverage, 22199,
     /*  818500 */     GIR_EraseRootFromParent_Done,
     /*  818501 */   // Label 12628: @818501
     /*  818501 */   GIM_Try, /*On fail goto*//*Label 12629*/ GIMT_Encode4(818576), // Rule ID 22202 //
     /*  818506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  818523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  818555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818574 */     GIR_RootConstrainSelectedInstOperands,
     /*  818575 */     // GIR_Coverage, 22202,
     /*  818575 */     GIR_EraseRootFromParent_Done,
     /*  818576 */   // Label 12629: @818576
     /*  818576 */   GIM_Try, /*On fail goto*//*Label 12630*/ GIMT_Encode4(818651), // Rule ID 22203 //
     /*  818581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  818598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818627 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  818630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818649 */     GIR_RootConstrainSelectedInstOperands,
     /*  818650 */     // GIR_Coverage, 22203,
     /*  818650 */     GIR_EraseRootFromParent_Done,
     /*  818651 */   // Label 12630: @818651
     /*  818651 */   GIM_Try, /*On fail goto*//*Label 12631*/ GIMT_Encode4(818726), // Rule ID 22206 //
     /*  818656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  818673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  818705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818724 */     GIR_RootConstrainSelectedInstOperands,
     /*  818725 */     // GIR_Coverage, 22206,
     /*  818725 */     GIR_EraseRootFromParent_Done,
     /*  818726 */   // Label 12631: @818726
     /*  818726 */   GIM_Try, /*On fail goto*//*Label 12632*/ GIMT_Encode4(818801), // Rule ID 22207 //
     /*  818731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  818748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818777 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  818780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818799 */     GIR_RootConstrainSelectedInstOperands,
     /*  818800 */     // GIR_Coverage, 22207,
     /*  818800 */     GIR_EraseRootFromParent_Done,
     /*  818801 */   // Label 12632: @818801
     /*  818801 */   GIM_Try, /*On fail goto*//*Label 12633*/ GIMT_Encode4(818876), // Rule ID 22210 //
     /*  818806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  818823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  818855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818874 */     GIR_RootConstrainSelectedInstOperands,
     /*  818875 */     // GIR_Coverage, 22210,
     /*  818875 */     GIR_EraseRootFromParent_Done,
     /*  818876 */   // Label 12633: @818876
     /*  818876 */   GIM_Try, /*On fail goto*//*Label 12634*/ GIMT_Encode4(818951), // Rule ID 22211 //
     /*  818881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  818898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818927 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  818930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818949 */     GIR_RootConstrainSelectedInstOperands,
     /*  818950 */     // GIR_Coverage, 22211,
     /*  818950 */     GIR_EraseRootFromParent_Done,
     /*  818951 */   // Label 12634: @818951
     /*  818951 */   GIM_Try, /*On fail goto*//*Label 12635*/ GIMT_Encode4(819026), // Rule ID 22214 //
     /*  818956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  818973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  819002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  819005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819024 */     GIR_RootConstrainSelectedInstOperands,
     /*  819025 */     // GIR_Coverage, 22214,
     /*  819025 */     GIR_EraseRootFromParent_Done,
     /*  819026 */   // Label 12635: @819026
     /*  819026 */   GIM_Try, /*On fail goto*//*Label 12636*/ GIMT_Encode4(819101), // Rule ID 22215 //
     /*  819031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  819048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819077 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  819077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  819080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819099 */     GIR_RootConstrainSelectedInstOperands,
     /*  819100 */     // GIR_Coverage, 22215,
     /*  819100 */     GIR_EraseRootFromParent_Done,
     /*  819101 */   // Label 12636: @819101
     /*  819101 */   GIM_Try, /*On fail goto*//*Label 12637*/ GIMT_Encode4(819176), // Rule ID 22218 //
     /*  819106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  819123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  819152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  819155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819174 */     GIR_RootConstrainSelectedInstOperands,
     /*  819175 */     // GIR_Coverage, 22218,
     /*  819175 */     GIR_EraseRootFromParent_Done,
     /*  819176 */   // Label 12637: @819176
     /*  819176 */   GIM_Try, /*On fail goto*//*Label 12638*/ GIMT_Encode4(819251), // Rule ID 22219 //
     /*  819181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  819198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819227 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  819227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  819230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819249 */     GIR_RootConstrainSelectedInstOperands,
     /*  819250 */     // GIR_Coverage, 22219,
     /*  819250 */     GIR_EraseRootFromParent_Done,
     /*  819251 */   // Label 12638: @819251
     /*  819251 */   GIM_Try, /*On fail goto*//*Label 12639*/ GIMT_Encode4(819326), // Rule ID 22222 //
     /*  819256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  819273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819302 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  819302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  819305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819324 */     GIR_RootConstrainSelectedInstOperands,
     /*  819325 */     // GIR_Coverage, 22222,
     /*  819325 */     GIR_EraseRootFromParent_Done,
     /*  819326 */   // Label 12639: @819326
     /*  819326 */   GIM_Try, /*On fail goto*//*Label 12640*/ GIMT_Encode4(819401), // Rule ID 22223 //
     /*  819331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  819348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819377 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  819377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  819380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819399 */     GIR_RootConstrainSelectedInstOperands,
     /*  819400 */     // GIR_Coverage, 22223,
     /*  819400 */     GIR_EraseRootFromParent_Done,
     /*  819401 */   // Label 12640: @819401
     /*  819401 */   GIM_Try, /*On fail goto*//*Label 12641*/ GIMT_Encode4(819476), // Rule ID 22226 //
     /*  819406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  819423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819452 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  819455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819474 */     GIR_RootConstrainSelectedInstOperands,
     /*  819475 */     // GIR_Coverage, 22226,
     /*  819475 */     GIR_EraseRootFromParent_Done,
     /*  819476 */   // Label 12641: @819476
     /*  819476 */   GIM_Try, /*On fail goto*//*Label 12642*/ GIMT_Encode4(819551), // Rule ID 22227 //
     /*  819481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  819498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819527 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  819530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819549 */     GIR_RootConstrainSelectedInstOperands,
     /*  819550 */     // GIR_Coverage, 22227,
     /*  819550 */     GIR_EraseRootFromParent_Done,
     /*  819551 */   // Label 12642: @819551
     /*  819551 */   GIM_Try, /*On fail goto*//*Label 12643*/ GIMT_Encode4(819626), // Rule ID 22230 //
     /*  819556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  819573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819602 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  819605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819624 */     GIR_RootConstrainSelectedInstOperands,
     /*  819625 */     // GIR_Coverage, 22230,
     /*  819625 */     GIR_EraseRootFromParent_Done,
     /*  819626 */   // Label 12643: @819626
     /*  819626 */   GIM_Try, /*On fail goto*//*Label 12644*/ GIMT_Encode4(819701), // Rule ID 22231 //
     /*  819631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  819648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819677 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  819680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819699 */     GIR_RootConstrainSelectedInstOperands,
     /*  819700 */     // GIR_Coverage, 22231,
     /*  819700 */     GIR_EraseRootFromParent_Done,
     /*  819701 */   // Label 12644: @819701
     /*  819701 */   GIM_Try, /*On fail goto*//*Label 12645*/ GIMT_Encode4(819776), // Rule ID 22234 //
     /*  819706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  819723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  819755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819774 */     GIR_RootConstrainSelectedInstOperands,
     /*  819775 */     // GIR_Coverage, 22234,
     /*  819775 */     GIR_EraseRootFromParent_Done,
     /*  819776 */   // Label 12645: @819776
     /*  819776 */   GIM_Try, /*On fail goto*//*Label 12646*/ GIMT_Encode4(819851), // Rule ID 22235 //
     /*  819781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  819798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  819830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819849 */     GIR_RootConstrainSelectedInstOperands,
     /*  819850 */     // GIR_Coverage, 22235,
     /*  819850 */     GIR_EraseRootFromParent_Done,
     /*  819851 */   // Label 12646: @819851
     /*  819851 */   GIM_Try, /*On fail goto*//*Label 12647*/ GIMT_Encode4(819926), // Rule ID 22238 //
     /*  819856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  819905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819924 */     GIR_RootConstrainSelectedInstOperands,
     /*  819925 */     // GIR_Coverage, 22238,
     /*  819925 */     GIR_EraseRootFromParent_Done,
     /*  819926 */   // Label 12647: @819926
     /*  819926 */   GIM_Try, /*On fail goto*//*Label 12648*/ GIMT_Encode4(820001), // Rule ID 22239 //
     /*  819931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819977 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  819977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  819980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819999 */     GIR_RootConstrainSelectedInstOperands,
     /*  820000 */     // GIR_Coverage, 22239,
     /*  820000 */     GIR_EraseRootFromParent_Done,
     /*  820001 */   // Label 12648: @820001
     /*  820001 */   GIM_Try, /*On fail goto*//*Label 12649*/ GIMT_Encode4(820076), // Rule ID 22242 //
     /*  820006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  820023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820052 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  820055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820074 */     GIR_RootConstrainSelectedInstOperands,
     /*  820075 */     // GIR_Coverage, 22242,
     /*  820075 */     GIR_EraseRootFromParent_Done,
     /*  820076 */   // Label 12649: @820076
     /*  820076 */   GIM_Try, /*On fail goto*//*Label 12650*/ GIMT_Encode4(820151), // Rule ID 22243 //
     /*  820081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  820098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820127 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  820130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820149 */     GIR_RootConstrainSelectedInstOperands,
     /*  820150 */     // GIR_Coverage, 22243,
     /*  820150 */     GIR_EraseRootFromParent_Done,
     /*  820151 */   // Label 12650: @820151
     /*  820151 */   GIM_Try, /*On fail goto*//*Label 12651*/ GIMT_Encode4(820226), // Rule ID 22246 //
     /*  820156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  820173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820202 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  820205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820224 */     GIR_RootConstrainSelectedInstOperands,
     /*  820225 */     // GIR_Coverage, 22246,
     /*  820225 */     GIR_EraseRootFromParent_Done,
     /*  820226 */   // Label 12651: @820226
     /*  820226 */   GIM_Try, /*On fail goto*//*Label 12652*/ GIMT_Encode4(820301), // Rule ID 22247 //
     /*  820231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  820248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820277 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  820280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820299 */     GIR_RootConstrainSelectedInstOperands,
     /*  820300 */     // GIR_Coverage, 22247,
     /*  820300 */     GIR_EraseRootFromParent_Done,
     /*  820301 */   // Label 12652: @820301
     /*  820301 */   GIM_Try, /*On fail goto*//*Label 12653*/ GIMT_Encode4(820376), // Rule ID 22250 //
     /*  820306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  820323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  820355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820374 */     GIR_RootConstrainSelectedInstOperands,
     /*  820375 */     // GIR_Coverage, 22250,
     /*  820375 */     GIR_EraseRootFromParent_Done,
     /*  820376 */   // Label 12653: @820376
     /*  820376 */   GIM_Try, /*On fail goto*//*Label 12654*/ GIMT_Encode4(820451), // Rule ID 22251 //
     /*  820381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  820398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820427 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  820430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820449 */     GIR_RootConstrainSelectedInstOperands,
     /*  820450 */     // GIR_Coverage, 22251,
     /*  820450 */     GIR_EraseRootFromParent_Done,
     /*  820451 */   // Label 12654: @820451
     /*  820451 */   GIM_Try, /*On fail goto*//*Label 12655*/ GIMT_Encode4(820526), // Rule ID 22254 //
     /*  820456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  820473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820502 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  820505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820524 */     GIR_RootConstrainSelectedInstOperands,
     /*  820525 */     // GIR_Coverage, 22254,
     /*  820525 */     GIR_EraseRootFromParent_Done,
     /*  820526 */   // Label 12655: @820526
     /*  820526 */   GIM_Try, /*On fail goto*//*Label 12656*/ GIMT_Encode4(820601), // Rule ID 22255 //
     /*  820531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  820548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820577 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  820580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820599 */     GIR_RootConstrainSelectedInstOperands,
     /*  820600 */     // GIR_Coverage, 22255,
     /*  820600 */     GIR_EraseRootFromParent_Done,
     /*  820601 */   // Label 12656: @820601
     /*  820601 */   GIM_Try, /*On fail goto*//*Label 12657*/ GIMT_Encode4(820676), // Rule ID 22258 //
     /*  820606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  820652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  820655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820674 */     GIR_RootConstrainSelectedInstOperands,
     /*  820675 */     // GIR_Coverage, 22258,
     /*  820675 */     GIR_EraseRootFromParent_Done,
     /*  820676 */   // Label 12657: @820676
     /*  820676 */   GIM_Try, /*On fail goto*//*Label 12658*/ GIMT_Encode4(820751), // Rule ID 22259 //
     /*  820681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820727 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  820727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  820730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820749 */     GIR_RootConstrainSelectedInstOperands,
     /*  820750 */     // GIR_Coverage, 22259,
     /*  820750 */     GIR_EraseRootFromParent_Done,
     /*  820751 */   // Label 12658: @820751
     /*  820751 */   GIM_Try, /*On fail goto*//*Label 12659*/ GIMT_Encode4(820826), // Rule ID 22262 //
     /*  820756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  820805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820824 */     GIR_RootConstrainSelectedInstOperands,
     /*  820825 */     // GIR_Coverage, 22262,
     /*  820825 */     GIR_EraseRootFromParent_Done,
     /*  820826 */   // Label 12659: @820826
     /*  820826 */   GIM_Try, /*On fail goto*//*Label 12660*/ GIMT_Encode4(820901), // Rule ID 22263 //
     /*  820831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820877 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  820880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820899 */     GIR_RootConstrainSelectedInstOperands,
     /*  820900 */     // GIR_Coverage, 22263,
     /*  820900 */     GIR_EraseRootFromParent_Done,
     /*  820901 */   // Label 12660: @820901
     /*  820901 */   GIM_Try, /*On fail goto*//*Label 12661*/ GIMT_Encode4(820976), // Rule ID 22266 //
     /*  820906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820952 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  820955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820974 */     GIR_RootConstrainSelectedInstOperands,
     /*  820975 */     // GIR_Coverage, 22266,
     /*  820975 */     GIR_EraseRootFromParent_Done,
     /*  820976 */   // Label 12661: @820976
     /*  820976 */   GIM_Try, /*On fail goto*//*Label 12662*/ GIMT_Encode4(821051), // Rule ID 22267 //
     /*  820981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821027 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  821030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821049 */     GIR_RootConstrainSelectedInstOperands,
     /*  821050 */     // GIR_Coverage, 22267,
     /*  821050 */     GIR_EraseRootFromParent_Done,
     /*  821051 */   // Label 12662: @821051
     /*  821051 */   GIM_Try, /*On fail goto*//*Label 12663*/ GIMT_Encode4(821126), // Rule ID 22270 //
     /*  821056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  821073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821102 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  821102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  821105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821124 */     GIR_RootConstrainSelectedInstOperands,
     /*  821125 */     // GIR_Coverage, 22270,
     /*  821125 */     GIR_EraseRootFromParent_Done,
     /*  821126 */   // Label 12663: @821126
     /*  821126 */   GIM_Try, /*On fail goto*//*Label 12664*/ GIMT_Encode4(821201), // Rule ID 22271 //
     /*  821131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  821148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821177 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  821177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  821180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821199 */     GIR_RootConstrainSelectedInstOperands,
     /*  821200 */     // GIR_Coverage, 22271,
     /*  821200 */     GIR_EraseRootFromParent_Done,
     /*  821201 */   // Label 12664: @821201
     /*  821201 */   GIM_Try, /*On fail goto*//*Label 12665*/ GIMT_Encode4(821276), // Rule ID 22274 //
     /*  821206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  821209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  821223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  821226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  821252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  821255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821274 */     GIR_RootConstrainSelectedInstOperands,
     /*  821275 */     // GIR_Coverage, 22274,
     /*  821275 */     GIR_EraseRootFromParent_Done,
     /*  821276 */   // Label 12665: @821276
     /*  821276 */   GIM_Try, /*On fail goto*//*Label 12666*/ GIMT_Encode4(821351), // Rule ID 22275 //
     /*  821281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  821284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  821298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  821301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821327 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  821327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  821330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821349 */     GIR_RootConstrainSelectedInstOperands,
     /*  821350 */     // GIR_Coverage, 22275,
     /*  821350 */     GIR_EraseRootFromParent_Done,
     /*  821351 */   // Label 12666: @821351
     /*  821351 */   GIM_Try, /*On fail goto*//*Label 12667*/ GIMT_Encode4(821426), // Rule ID 22278 //
     /*  821356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  821373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821402 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  821405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821424 */     GIR_RootConstrainSelectedInstOperands,
     /*  821425 */     // GIR_Coverage, 22278,
     /*  821425 */     GIR_EraseRootFromParent_Done,
     /*  821426 */   // Label 12667: @821426
     /*  821426 */   GIM_Try, /*On fail goto*//*Label 12668*/ GIMT_Encode4(821501), // Rule ID 22279 //
     /*  821431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  821448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821477 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  821480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821499 */     GIR_RootConstrainSelectedInstOperands,
     /*  821500 */     // GIR_Coverage, 22279,
     /*  821500 */     GIR_EraseRootFromParent_Done,
     /*  821501 */   // Label 12668: @821501
     /*  821501 */   GIM_Try, /*On fail goto*//*Label 12669*/ GIMT_Encode4(821576), // Rule ID 22282 //
     /*  821506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  821523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821552 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  821555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821574 */     GIR_RootConstrainSelectedInstOperands,
     /*  821575 */     // GIR_Coverage, 22282,
     /*  821575 */     GIR_EraseRootFromParent_Done,
     /*  821576 */   // Label 12669: @821576
     /*  821576 */   GIM_Try, /*On fail goto*//*Label 12670*/ GIMT_Encode4(821651), // Rule ID 22283 //
     /*  821581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  821598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821627 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  821630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821649 */     GIR_RootConstrainSelectedInstOperands,
     /*  821650 */     // GIR_Coverage, 22283,
     /*  821650 */     GIR_EraseRootFromParent_Done,
     /*  821651 */   // Label 12670: @821651
     /*  821651 */   GIM_Try, /*On fail goto*//*Label 12671*/ GIMT_Encode4(821726), // Rule ID 22286 //
     /*  821656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821702 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  821705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821724 */     GIR_RootConstrainSelectedInstOperands,
     /*  821725 */     // GIR_Coverage, 22286,
     /*  821725 */     GIR_EraseRootFromParent_Done,
     /*  821726 */   // Label 12671: @821726
     /*  821726 */   GIM_Try, /*On fail goto*//*Label 12672*/ GIMT_Encode4(821801), // Rule ID 22287 //
     /*  821731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821777 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  821780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821799 */     GIR_RootConstrainSelectedInstOperands,
     /*  821800 */     // GIR_Coverage, 22287,
     /*  821800 */     GIR_EraseRootFromParent_Done,
     /*  821801 */   // Label 12672: @821801
     /*  821801 */   GIM_Try, /*On fail goto*//*Label 12673*/ GIMT_Encode4(821876), // Rule ID 22290 //
     /*  821806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  821852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  821855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821874 */     GIR_RootConstrainSelectedInstOperands,
     /*  821875 */     // GIR_Coverage, 22290,
     /*  821875 */     GIR_EraseRootFromParent_Done,
     /*  821876 */   // Label 12673: @821876
     /*  821876 */   GIM_Try, /*On fail goto*//*Label 12674*/ GIMT_Encode4(821951), // Rule ID 22291 //
     /*  821881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821927 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  821930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821949 */     GIR_RootConstrainSelectedInstOperands,
     /*  821950 */     // GIR_Coverage, 22291,
     /*  821950 */     GIR_EraseRootFromParent_Done,
     /*  821951 */   // Label 12674: @821951
     /*  821951 */   GIM_Try, /*On fail goto*//*Label 12675*/ GIMT_Encode4(822026), // Rule ID 22294 //
     /*  821956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  821973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  822002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  822005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822024 */     GIR_RootConstrainSelectedInstOperands,
     /*  822025 */     // GIR_Coverage, 22294,
     /*  822025 */     GIR_EraseRootFromParent_Done,
     /*  822026 */   // Label 12675: @822026
     /*  822026 */   GIM_Try, /*On fail goto*//*Label 12676*/ GIMT_Encode4(822101), // Rule ID 22295 //
     /*  822031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  822048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822077 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  822077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  822080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822099 */     GIR_RootConstrainSelectedInstOperands,
     /*  822100 */     // GIR_Coverage, 22295,
     /*  822100 */     GIR_EraseRootFromParent_Done,
     /*  822101 */   // Label 12676: @822101
     /*  822101 */   GIM_Try, /*On fail goto*//*Label 12677*/ GIMT_Encode4(822176), // Rule ID 22298 //
     /*  822106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  822123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  822152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  822155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822174 */     GIR_RootConstrainSelectedInstOperands,
     /*  822175 */     // GIR_Coverage, 22298,
     /*  822175 */     GIR_EraseRootFromParent_Done,
     /*  822176 */   // Label 12677: @822176
     /*  822176 */   GIM_Try, /*On fail goto*//*Label 12678*/ GIMT_Encode4(822251), // Rule ID 22299 //
     /*  822181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  822198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  822227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  822230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822249 */     GIR_RootConstrainSelectedInstOperands,
     /*  822250 */     // GIR_Coverage, 22299,
     /*  822250 */     GIR_EraseRootFromParent_Done,
     /*  822251 */   // Label 12678: @822251
     /*  822251 */   GIM_Try, /*On fail goto*//*Label 12679*/ GIMT_Encode4(822326), // Rule ID 22302 //
     /*  822256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  822273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822302 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  822305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822324 */     GIR_RootConstrainSelectedInstOperands,
     /*  822325 */     // GIR_Coverage, 22302,
     /*  822325 */     GIR_EraseRootFromParent_Done,
     /*  822326 */   // Label 12679: @822326
     /*  822326 */   GIM_Try, /*On fail goto*//*Label 12680*/ GIMT_Encode4(822401), // Rule ID 22303 //
     /*  822331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  822348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822377 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  822380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822399 */     GIR_RootConstrainSelectedInstOperands,
     /*  822400 */     // GIR_Coverage, 22303,
     /*  822400 */     GIR_EraseRootFromParent_Done,
     /*  822401 */   // Label 12680: @822401
     /*  822401 */   GIM_Try, /*On fail goto*//*Label 12681*/ GIMT_Encode4(822476), // Rule ID 22306 //
     /*  822406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  822423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  822455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822474 */     GIR_RootConstrainSelectedInstOperands,
     /*  822475 */     // GIR_Coverage, 22306,
     /*  822475 */     GIR_EraseRootFromParent_Done,
     /*  822476 */   // Label 12681: @822476
     /*  822476 */   GIM_Try, /*On fail goto*//*Label 12682*/ GIMT_Encode4(822551), // Rule ID 22307 //
     /*  822481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  822498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822527 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  822530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822549 */     GIR_RootConstrainSelectedInstOperands,
     /*  822550 */     // GIR_Coverage, 22307,
     /*  822550 */     GIR_EraseRootFromParent_Done,
     /*  822551 */   // Label 12682: @822551
     /*  822551 */   GIM_Try, /*On fail goto*//*Label 12683*/ GIMT_Encode4(822626), // Rule ID 22310 //
     /*  822556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  822605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822624 */     GIR_RootConstrainSelectedInstOperands,
     /*  822625 */     // GIR_Coverage, 22310,
     /*  822625 */     GIR_EraseRootFromParent_Done,
     /*  822626 */   // Label 12683: @822626
     /*  822626 */   GIM_Try, /*On fail goto*//*Label 12684*/ GIMT_Encode4(822701), // Rule ID 22311 //
     /*  822631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822677 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  822680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822699 */     GIR_RootConstrainSelectedInstOperands,
     /*  822700 */     // GIR_Coverage, 22311,
     /*  822700 */     GIR_EraseRootFromParent_Done,
     /*  822701 */   // Label 12684: @822701
     /*  822701 */   GIM_Try, /*On fail goto*//*Label 12685*/ GIMT_Encode4(822776), // Rule ID 22314 //
     /*  822706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  822755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822774 */     GIR_RootConstrainSelectedInstOperands,
     /*  822775 */     // GIR_Coverage, 22314,
     /*  822775 */     GIR_EraseRootFromParent_Done,
     /*  822776 */   // Label 12685: @822776
     /*  822776 */   GIM_Try, /*On fail goto*//*Label 12686*/ GIMT_Encode4(822851), // Rule ID 22315 //
     /*  822781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  822830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822849 */     GIR_RootConstrainSelectedInstOperands,
     /*  822850 */     // GIR_Coverage, 22315,
     /*  822850 */     GIR_EraseRootFromParent_Done,
     /*  822851 */   // Label 12686: @822851
     /*  822851 */   GIM_Try, /*On fail goto*//*Label 12687*/ GIMT_Encode4(822926), // Rule ID 22318 //
     /*  822856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  822873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822902 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  822905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822924 */     GIR_RootConstrainSelectedInstOperands,
     /*  822925 */     // GIR_Coverage, 22318,
     /*  822925 */     GIR_EraseRootFromParent_Done,
     /*  822926 */   // Label 12687: @822926
     /*  822926 */   GIM_Try, /*On fail goto*//*Label 12688*/ GIMT_Encode4(823001), // Rule ID 22319 //
     /*  822931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  822948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822977 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  822980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822999 */     GIR_RootConstrainSelectedInstOperands,
     /*  823000 */     // GIR_Coverage, 22319,
     /*  823000 */     GIR_EraseRootFromParent_Done,
     /*  823001 */   // Label 12688: @823001
     /*  823001 */   GIM_Try, /*On fail goto*//*Label 12689*/ GIMT_Encode4(823076), // Rule ID 22322 //
     /*  823006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  823009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  823014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  823017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  823020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  823023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  823026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  823041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  823052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  823055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  823071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823074 */     GIR_RootConstrainSelectedInstOperands,
     /*  823075 */     // GIR_Coverage, 22322,
     /*  823075 */     GIR_EraseRootFromParent_Done,
     /*  823076 */   // Label 12689: @823076
     /*  823076 */   GIM_Try, /*On fail goto*//*Label 12690*/ GIMT_Encode4(823151), // Rule ID 22323 //
     /*  823081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  823084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  823089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  823092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  823095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  823098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  823101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  823116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823127 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  823127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  823130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  823146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823149 */     GIR_RootConstrainSelectedInstOperands,
     /*  823150 */     // GIR_Coverage, 22323,
     /*  823150 */     GIR_EraseRootFromParent_Done,
     /*  823151 */   // Label 12690: @823151
     /*  823151 */   GIM_Try, /*On fail goto*//*Label 12691*/ GIMT_Encode4(823226), // Rule ID 22326 //
     /*  823156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  823173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823202 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  823205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823224 */     GIR_RootConstrainSelectedInstOperands,
     /*  823225 */     // GIR_Coverage, 22326,
     /*  823225 */     GIR_EraseRootFromParent_Done,
     /*  823226 */   // Label 12691: @823226
     /*  823226 */   GIM_Try, /*On fail goto*//*Label 12692*/ GIMT_Encode4(823301), // Rule ID 22327 //
     /*  823231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  823248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823277 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  823280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823299 */     GIR_RootConstrainSelectedInstOperands,
     /*  823300 */     // GIR_Coverage, 22327,
     /*  823300 */     GIR_EraseRootFromParent_Done,
     /*  823301 */   // Label 12692: @823301
     /*  823301 */   GIM_Try, /*On fail goto*//*Label 12693*/ GIMT_Encode4(823376), // Rule ID 22330 //
     /*  823306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  823323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  823355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823374 */     GIR_RootConstrainSelectedInstOperands,
     /*  823375 */     // GIR_Coverage, 22330,
     /*  823375 */     GIR_EraseRootFromParent_Done,
     /*  823376 */   // Label 12693: @823376
     /*  823376 */   GIM_Try, /*On fail goto*//*Label 12694*/ GIMT_Encode4(823451), // Rule ID 22331 //
     /*  823381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  823398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823427 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  823430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823449 */     GIR_RootConstrainSelectedInstOperands,
     /*  823450 */     // GIR_Coverage, 22331,
     /*  823450 */     GIR_EraseRootFromParent_Done,
     /*  823451 */   // Label 12694: @823451
     /*  823451 */   GIM_Try, /*On fail goto*//*Label 12695*/ GIMT_Encode4(823526), // Rule ID 22334 //
     /*  823456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  823473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  823505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823524 */     GIR_RootConstrainSelectedInstOperands,
     /*  823525 */     // GIR_Coverage, 22334,
     /*  823525 */     GIR_EraseRootFromParent_Done,
     /*  823526 */   // Label 12695: @823526
     /*  823526 */   GIM_Try, /*On fail goto*//*Label 12696*/ GIMT_Encode4(823601), // Rule ID 22335 //
     /*  823531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  823548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823577 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  823580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823599 */     GIR_RootConstrainSelectedInstOperands,
     /*  823600 */     // GIR_Coverage, 22335,
     /*  823600 */     GIR_EraseRootFromParent_Done,
     /*  823601 */   // Label 12696: @823601
     /*  823601 */   GIM_Try, /*On fail goto*//*Label 12697*/ GIMT_Encode4(823676), // Rule ID 22338 //
     /*  823606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  823655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823674 */     GIR_RootConstrainSelectedInstOperands,
     /*  823675 */     // GIR_Coverage, 22338,
     /*  823675 */     GIR_EraseRootFromParent_Done,
     /*  823676 */   // Label 12697: @823676
     /*  823676 */   GIM_Try, /*On fail goto*//*Label 12698*/ GIMT_Encode4(823751), // Rule ID 22339 //
     /*  823681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823727 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  823730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823749 */     GIR_RootConstrainSelectedInstOperands,
     /*  823750 */     // GIR_Coverage, 22339,
     /*  823750 */     GIR_EraseRootFromParent_Done,
     /*  823751 */   // Label 12698: @823751
     /*  823751 */   GIM_Try, /*On fail goto*//*Label 12699*/ GIMT_Encode4(823826), // Rule ID 22342 //
     /*  823756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  823773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823802 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  823805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823824 */     GIR_RootConstrainSelectedInstOperands,
     /*  823825 */     // GIR_Coverage, 22342,
     /*  823825 */     GIR_EraseRootFromParent_Done,
     /*  823826 */   // Label 12699: @823826
     /*  823826 */   GIM_Try, /*On fail goto*//*Label 12700*/ GIMT_Encode4(823901), // Rule ID 22343 //
     /*  823831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  823848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823877 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  823880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823899 */     GIR_RootConstrainSelectedInstOperands,
     /*  823900 */     // GIR_Coverage, 22343,
     /*  823900 */     GIR_EraseRootFromParent_Done,
     /*  823901 */   // Label 12700: @823901
     /*  823901 */   GIM_Try, /*On fail goto*//*Label 12701*/ GIMT_Encode4(823976), // Rule ID 22346 //
     /*  823906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  823923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  823952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  823955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823974 */     GIR_RootConstrainSelectedInstOperands,
     /*  823975 */     // GIR_Coverage, 22346,
     /*  823975 */     GIR_EraseRootFromParent_Done,
     /*  823976 */   // Label 12701: @823976
     /*  823976 */   GIM_Try, /*On fail goto*//*Label 12702*/ GIMT_Encode4(824051), // Rule ID 22347 //
     /*  823981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  823998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824027 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  824027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  824030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824049 */     GIR_RootConstrainSelectedInstOperands,
     /*  824050 */     // GIR_Coverage, 22347,
     /*  824050 */     GIR_EraseRootFromParent_Done,
     /*  824051 */   // Label 12702: @824051
     /*  824051 */   GIM_Try, /*On fail goto*//*Label 12703*/ GIMT_Encode4(824126), // Rule ID 22350 //
     /*  824056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  824073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  824105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824124 */     GIR_RootConstrainSelectedInstOperands,
     /*  824125 */     // GIR_Coverage, 22350,
     /*  824125 */     GIR_EraseRootFromParent_Done,
     /*  824126 */   // Label 12703: @824126
     /*  824126 */   GIM_Try, /*On fail goto*//*Label 12704*/ GIMT_Encode4(824201), // Rule ID 22351 //
     /*  824131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  824148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824177 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  824180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824199 */     GIR_RootConstrainSelectedInstOperands,
     /*  824200 */     // GIR_Coverage, 22351,
     /*  824200 */     GIR_EraseRootFromParent_Done,
     /*  824201 */   // Label 12704: @824201
     /*  824201 */   GIM_Try, /*On fail goto*//*Label 12705*/ GIMT_Encode4(824276), // Rule ID 22354 //
     /*  824206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  824223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  824252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  824255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824274 */     GIR_RootConstrainSelectedInstOperands,
     /*  824275 */     // GIR_Coverage, 22354,
     /*  824275 */     GIR_EraseRootFromParent_Done,
     /*  824276 */   // Label 12705: @824276
     /*  824276 */   GIM_Try, /*On fail goto*//*Label 12706*/ GIMT_Encode4(824351), // Rule ID 22355 //
     /*  824281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  824298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  824327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  824330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824349 */     GIR_RootConstrainSelectedInstOperands,
     /*  824350 */     // GIR_Coverage, 22355,
     /*  824350 */     GIR_EraseRootFromParent_Done,
     /*  824351 */   // Label 12706: @824351
     /*  824351 */   GIM_Try, /*On fail goto*//*Label 12707*/ GIMT_Encode4(824426), // Rule ID 22358 //
     /*  824356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  824373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824402 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  824402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  824405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824424 */     GIR_RootConstrainSelectedInstOperands,
     /*  824425 */     // GIR_Coverage, 22358,
     /*  824425 */     GIR_EraseRootFromParent_Done,
     /*  824426 */   // Label 12707: @824426
     /*  824426 */   GIM_Try, /*On fail goto*//*Label 12708*/ GIMT_Encode4(824501), // Rule ID 22359 //
     /*  824431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  824448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824477 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  824477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  824480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824499 */     GIR_RootConstrainSelectedInstOperands,
     /*  824500 */     // GIR_Coverage, 22359,
     /*  824500 */     GIR_EraseRootFromParent_Done,
     /*  824501 */   // Label 12708: @824501
     /*  824501 */   GIM_Try, /*On fail goto*//*Label 12709*/ GIMT_Encode4(824576), // Rule ID 22362 //
     /*  824506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  824509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  824517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  824520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  824523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  824526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824552 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  824552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  824555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  824571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824574 */     GIR_RootConstrainSelectedInstOperands,
     /*  824575 */     // GIR_Coverage, 22362,
     /*  824575 */     GIR_EraseRootFromParent_Done,
     /*  824576 */   // Label 12709: @824576
     /*  824576 */   GIM_Try, /*On fail goto*//*Label 12710*/ GIMT_Encode4(824651), // Rule ID 22363 //
     /*  824581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  824584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  824592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  824595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  824598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  824601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824627 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  824627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  824630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  824646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824649 */     GIR_RootConstrainSelectedInstOperands,
     /*  824650 */     // GIR_Coverage, 22363,
     /*  824650 */     GIR_EraseRootFromParent_Done,
     /*  824651 */   // Label 12710: @824651
     /*  824651 */   GIM_Try, /*On fail goto*//*Label 12711*/ GIMT_Encode4(824726), // Rule ID 22366 //
     /*  824656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  824673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824702 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  824705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824724 */     GIR_RootConstrainSelectedInstOperands,
     /*  824725 */     // GIR_Coverage, 22366,
     /*  824725 */     GIR_EraseRootFromParent_Done,
     /*  824726 */   // Label 12711: @824726
     /*  824726 */   GIM_Try, /*On fail goto*//*Label 12712*/ GIMT_Encode4(824801), // Rule ID 22367 //
     /*  824731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  824748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824777 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  824780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824799 */     GIR_RootConstrainSelectedInstOperands,
     /*  824800 */     // GIR_Coverage, 22367,
     /*  824800 */     GIR_EraseRootFromParent_Done,
     /*  824801 */   // Label 12712: @824801
     /*  824801 */   GIM_Try, /*On fail goto*//*Label 12713*/ GIMT_Encode4(824876), // Rule ID 22370 //
     /*  824806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  824823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824852 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  824855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824874 */     GIR_RootConstrainSelectedInstOperands,
     /*  824875 */     // GIR_Coverage, 22370,
     /*  824875 */     GIR_EraseRootFromParent_Done,
     /*  824876 */   // Label 12713: @824876
     /*  824876 */   GIM_Try, /*On fail goto*//*Label 12714*/ GIMT_Encode4(824951), // Rule ID 22371 //
     /*  824881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  824898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824927 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  824930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824949 */     GIR_RootConstrainSelectedInstOperands,
     /*  824950 */     // GIR_Coverage, 22371,
     /*  824950 */     GIR_EraseRootFromParent_Done,
     /*  824951 */   // Label 12714: @824951
     /*  824951 */   GIM_Try, /*On fail goto*//*Label 12715*/ GIMT_Encode4(825026), // Rule ID 22374 //
     /*  824956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  824973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825002 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  825002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  825005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825024 */     GIR_RootConstrainSelectedInstOperands,
     /*  825025 */     // GIR_Coverage, 22374,
     /*  825025 */     GIR_EraseRootFromParent_Done,
     /*  825026 */   // Label 12715: @825026
     /*  825026 */   GIM_Try, /*On fail goto*//*Label 12716*/ GIMT_Encode4(825101), // Rule ID 22375 //
     /*  825031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  825042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  825045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  825048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  825051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825077 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  825077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  825080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825099 */     GIR_RootConstrainSelectedInstOperands,
     /*  825100 */     // GIR_Coverage, 22375,
     /*  825100 */     GIR_EraseRootFromParent_Done,
     /*  825101 */   // Label 12716: @825101
     /*  825101 */   GIM_Try, /*On fail goto*//*Label 12717*/ GIMT_Encode4(825176), // Rule ID 22378 //
     /*  825106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  825123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  825152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  825155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825174 */     GIR_RootConstrainSelectedInstOperands,
     /*  825175 */     // GIR_Coverage, 22378,
     /*  825175 */     GIR_EraseRootFromParent_Done,
     /*  825176 */   // Label 12717: @825176
     /*  825176 */   GIM_Try, /*On fail goto*//*Label 12718*/ GIMT_Encode4(825251), // Rule ID 22379 //
     /*  825181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  825198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  825227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  825230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825249 */     GIR_RootConstrainSelectedInstOperands,
     /*  825250 */     // GIR_Coverage, 22379,
     /*  825250 */     GIR_EraseRootFromParent_Done,
     /*  825251 */   // Label 12718: @825251
     /*  825251 */   GIM_Try, /*On fail goto*//*Label 12719*/ GIMT_Encode4(825326), // Rule ID 22382 //
     /*  825256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  825273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  825302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  825305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825324 */     GIR_RootConstrainSelectedInstOperands,
     /*  825325 */     // GIR_Coverage, 22382,
     /*  825325 */     GIR_EraseRootFromParent_Done,
     /*  825326 */   // Label 12719: @825326
     /*  825326 */   GIM_Try, /*On fail goto*//*Label 12720*/ GIMT_Encode4(825401), // Rule ID 22383 //
     /*  825331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  825348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825377 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  825377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  825380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825399 */     GIR_RootConstrainSelectedInstOperands,
     /*  825400 */     // GIR_Coverage, 22383,
     /*  825400 */     GIR_EraseRootFromParent_Done,
     /*  825401 */   // Label 12720: @825401
     /*  825401 */   GIM_Try, /*On fail goto*//*Label 12721*/ GIMT_Encode4(825476), // Rule ID 22386 //
     /*  825406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  825423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  825452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  825455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825474 */     GIR_RootConstrainSelectedInstOperands,
     /*  825475 */     // GIR_Coverage, 22386,
     /*  825475 */     GIR_EraseRootFromParent_Done,
     /*  825476 */   // Label 12721: @825476
     /*  825476 */   GIM_Try, /*On fail goto*//*Label 12722*/ GIMT_Encode4(825551), // Rule ID 22387 //
     /*  825481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  825498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825527 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  825527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  825530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825549 */     GIR_RootConstrainSelectedInstOperands,
     /*  825550 */     // GIR_Coverage, 22387,
     /*  825550 */     GIR_EraseRootFromParent_Done,
     /*  825551 */   // Label 12722: @825551
     /*  825551 */   GIM_Try, /*On fail goto*//*Label 12723*/ GIMT_Encode4(825626), // Rule ID 22390 //
     /*  825556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  825573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  825605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825624 */     GIR_RootConstrainSelectedInstOperands,
     /*  825625 */     // GIR_Coverage, 22390,
     /*  825625 */     GIR_EraseRootFromParent_Done,
     /*  825626 */   // Label 12723: @825626
     /*  825626 */   GIM_Try, /*On fail goto*//*Label 12724*/ GIMT_Encode4(825701), // Rule ID 22391 //
     /*  825631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  825648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825677 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  825680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825699 */     GIR_RootConstrainSelectedInstOperands,
     /*  825700 */     // GIR_Coverage, 22391,
     /*  825700 */     GIR_EraseRootFromParent_Done,
     /*  825701 */   // Label 12724: @825701
     /*  825701 */   GIM_Try, /*On fail goto*//*Label 12725*/ GIMT_Encode4(825776), // Rule ID 22394 //
     /*  825706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  825723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  825755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825774 */     GIR_RootConstrainSelectedInstOperands,
     /*  825775 */     // GIR_Coverage, 22394,
     /*  825775 */     GIR_EraseRootFromParent_Done,
     /*  825776 */   // Label 12725: @825776
     /*  825776 */   GIM_Try, /*On fail goto*//*Label 12726*/ GIMT_Encode4(825851), // Rule ID 22395 //
     /*  825781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  825798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825827 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  825830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825849 */     GIR_RootConstrainSelectedInstOperands,
     /*  825850 */     // GIR_Coverage, 22395,
     /*  825850 */     GIR_EraseRootFromParent_Done,
     /*  825851 */   // Label 12726: @825851
     /*  825851 */   GIM_Try, /*On fail goto*//*Label 12727*/ GIMT_Encode4(825926), // Rule ID 22398 //
     /*  825856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  825873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  825905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825924 */     GIR_RootConstrainSelectedInstOperands,
     /*  825925 */     // GIR_Coverage, 22398,
     /*  825925 */     GIR_EraseRootFromParent_Done,
     /*  825926 */   // Label 12727: @825926
     /*  825926 */   GIM_Try, /*On fail goto*//*Label 12728*/ GIMT_Encode4(826001), // Rule ID 22399 //
     /*  825931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  825948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825977 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  825980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825999 */     GIR_RootConstrainSelectedInstOperands,
     /*  826000 */     // GIR_Coverage, 22399,
     /*  826000 */     GIR_EraseRootFromParent_Done,
     /*  826001 */   // Label 12728: @826001
     /*  826001 */   GIM_Try, /*On fail goto*//*Label 12729*/ GIMT_Encode4(826076), // Rule ID 22402 //
     /*  826006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  826009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  826014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  826023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  826052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  826055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826074 */     GIR_RootConstrainSelectedInstOperands,
     /*  826075 */     // GIR_Coverage, 22402,
     /*  826075 */     GIR_EraseRootFromParent_Done,
     /*  826076 */   // Label 12729: @826076
     /*  826076 */   GIM_Try, /*On fail goto*//*Label 12730*/ GIMT_Encode4(826151), // Rule ID 22403 //
     /*  826081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  826089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  826098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826127 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  826127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  826130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826149 */     GIR_RootConstrainSelectedInstOperands,
     /*  826150 */     // GIR_Coverage, 22403,
     /*  826150 */     GIR_EraseRootFromParent_Done,
     /*  826151 */   // Label 12730: @826151
     /*  826151 */   GIM_Try, /*On fail goto*//*Label 12731*/ GIMT_Encode4(826226), // Rule ID 22406 //
     /*  826156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  826159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  826164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  826173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826202 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  826202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  826205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826224 */     GIR_RootConstrainSelectedInstOperands,
     /*  826225 */     // GIR_Coverage, 22406,
     /*  826225 */     GIR_EraseRootFromParent_Done,
     /*  826226 */   // Label 12731: @826226
     /*  826226 */   GIM_Try, /*On fail goto*//*Label 12732*/ GIMT_Encode4(826301), // Rule ID 22407 //
     /*  826231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  826239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  826248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826277 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  826277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  826280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826299 */     GIR_RootConstrainSelectedInstOperands,
     /*  826300 */     // GIR_Coverage, 22407,
     /*  826300 */     GIR_EraseRootFromParent_Done,
     /*  826301 */   // Label 12732: @826301
     /*  826301 */   GIM_Try, /*On fail goto*//*Label 12733*/ GIMT_Encode4(826376), // Rule ID 22410 //
     /*  826306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  826309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  826314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  826323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  826352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  826355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826374 */     GIR_RootConstrainSelectedInstOperands,
     /*  826375 */     // GIR_Coverage, 22410,
     /*  826375 */     GIR_EraseRootFromParent_Done,
     /*  826376 */   // Label 12733: @826376
     /*  826376 */   GIM_Try, /*On fail goto*//*Label 12734*/ GIMT_Encode4(826451), // Rule ID 22411 //
     /*  826381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  826389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  826398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826427 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  826427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  826430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826449 */     GIR_RootConstrainSelectedInstOperands,
     /*  826450 */     // GIR_Coverage, 22411,
     /*  826450 */     GIR_EraseRootFromParent_Done,
     /*  826451 */   // Label 12734: @826451
     /*  826451 */   GIM_Try, /*On fail goto*//*Label 12735*/ GIMT_Encode4(826526), // Rule ID 22414 //
     /*  826456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  826473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  826505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826524 */     GIR_RootConstrainSelectedInstOperands,
     /*  826525 */     // GIR_Coverage, 22414,
     /*  826525 */     GIR_EraseRootFromParent_Done,
     /*  826526 */   // Label 12735: @826526
     /*  826526 */   GIM_Try, /*On fail goto*//*Label 12736*/ GIMT_Encode4(826601), // Rule ID 22415 //
     /*  826531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  826548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826577 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  826580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826599 */     GIR_RootConstrainSelectedInstOperands,
     /*  826600 */     // GIR_Coverage, 22415,
     /*  826600 */     GIR_EraseRootFromParent_Done,
     /*  826601 */   // Label 12736: @826601
     /*  826601 */   GIM_Try, /*On fail goto*//*Label 12737*/ GIMT_Encode4(826676), // Rule ID 22418 //
     /*  826606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  826623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  826655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826674 */     GIR_RootConstrainSelectedInstOperands,
     /*  826675 */     // GIR_Coverage, 22418,
     /*  826675 */     GIR_EraseRootFromParent_Done,
     /*  826676 */   // Label 12737: @826676
     /*  826676 */   GIM_Try, /*On fail goto*//*Label 12738*/ GIMT_Encode4(826751), // Rule ID 22419 //
     /*  826681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  826698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826727 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  826730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826749 */     GIR_RootConstrainSelectedInstOperands,
     /*  826750 */     // GIR_Coverage, 22419,
     /*  826750 */     GIR_EraseRootFromParent_Done,
     /*  826751 */   // Label 12738: @826751
     /*  826751 */   GIM_Try, /*On fail goto*//*Label 12739*/ GIMT_Encode4(826826), // Rule ID 22422 //
     /*  826756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  826773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  826805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826824 */     GIR_RootConstrainSelectedInstOperands,
     /*  826825 */     // GIR_Coverage, 22422,
     /*  826825 */     GIR_EraseRootFromParent_Done,
     /*  826826 */   // Label 12739: @826826
     /*  826826 */   GIM_Try, /*On fail goto*//*Label 12740*/ GIMT_Encode4(826901), // Rule ID 22423 //
     /*  826831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  826848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826877 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  826880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826899 */     GIR_RootConstrainSelectedInstOperands,
     /*  826900 */     // GIR_Coverage, 22423,
     /*  826900 */     GIR_EraseRootFromParent_Done,
     /*  826901 */   // Label 12740: @826901
     /*  826901 */   GIM_Try, /*On fail goto*//*Label 12741*/ GIMT_Encode4(826976), // Rule ID 22426 //
     /*  826906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  826923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826952 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  826952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  826955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826974 */     GIR_RootConstrainSelectedInstOperands,
     /*  826975 */     // GIR_Coverage, 22426,
     /*  826975 */     GIR_EraseRootFromParent_Done,
     /*  826976 */   // Label 12741: @826976
     /*  826976 */   GIM_Try, /*On fail goto*//*Label 12742*/ GIMT_Encode4(827051), // Rule ID 22427 //
     /*  826981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  826998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827027 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  827030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827049 */     GIR_RootConstrainSelectedInstOperands,
     /*  827050 */     // GIR_Coverage, 22427,
     /*  827050 */     GIR_EraseRootFromParent_Done,
     /*  827051 */   // Label 12742: @827051
     /*  827051 */   GIM_Try, /*On fail goto*//*Label 12743*/ GIMT_Encode4(827126), // Rule ID 22430 //
     /*  827056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  827073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  827105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827124 */     GIR_RootConstrainSelectedInstOperands,
     /*  827125 */     // GIR_Coverage, 22430,
     /*  827125 */     GIR_EraseRootFromParent_Done,
     /*  827126 */   // Label 12743: @827126
     /*  827126 */   GIM_Try, /*On fail goto*//*Label 12744*/ GIMT_Encode4(827201), // Rule ID 22431 //
     /*  827131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  827148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827177 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  827180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827199 */     GIR_RootConstrainSelectedInstOperands,
     /*  827200 */     // GIR_Coverage, 22431,
     /*  827200 */     GIR_EraseRootFromParent_Done,
     /*  827201 */   // Label 12744: @827201
     /*  827201 */   GIM_Try, /*On fail goto*//*Label 12745*/ GIMT_Encode4(827276), // Rule ID 22434 //
     /*  827206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  827223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  827252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  827255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827274 */     GIR_RootConstrainSelectedInstOperands,
     /*  827275 */     // GIR_Coverage, 22434,
     /*  827275 */     GIR_EraseRootFromParent_Done,
     /*  827276 */   // Label 12745: @827276
     /*  827276 */   GIM_Try, /*On fail goto*//*Label 12746*/ GIMT_Encode4(827351), // Rule ID 22435 //
     /*  827281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  827298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827327 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  827327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  827330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827349 */     GIR_RootConstrainSelectedInstOperands,
     /*  827350 */     // GIR_Coverage, 22435,
     /*  827350 */     GIR_EraseRootFromParent_Done,
     /*  827351 */   // Label 12746: @827351
     /*  827351 */   GIM_Try, /*On fail goto*//*Label 12747*/ GIMT_Encode4(827426), // Rule ID 22438 //
     /*  827356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  827373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827402 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  827405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827424 */     GIR_RootConstrainSelectedInstOperands,
     /*  827425 */     // GIR_Coverage, 22438,
     /*  827425 */     GIR_EraseRootFromParent_Done,
     /*  827426 */   // Label 12747: @827426
     /*  827426 */   GIM_Try, /*On fail goto*//*Label 12748*/ GIMT_Encode4(827501), // Rule ID 22439 //
     /*  827431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  827448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827477 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  827480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827499 */     GIR_RootConstrainSelectedInstOperands,
     /*  827500 */     // GIR_Coverage, 22439,
     /*  827500 */     GIR_EraseRootFromParent_Done,
     /*  827501 */   // Label 12748: @827501
     /*  827501 */   GIM_Try, /*On fail goto*//*Label 12749*/ GIMT_Encode4(827576), // Rule ID 22442 //
     /*  827506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  827523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  827555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827574 */     GIR_RootConstrainSelectedInstOperands,
     /*  827575 */     // GIR_Coverage, 22442,
     /*  827575 */     GIR_EraseRootFromParent_Done,
     /*  827576 */   // Label 12749: @827576
     /*  827576 */   GIM_Try, /*On fail goto*//*Label 12750*/ GIMT_Encode4(827651), // Rule ID 22443 //
     /*  827581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  827598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827627 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  827630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827649 */     GIR_RootConstrainSelectedInstOperands,
     /*  827650 */     // GIR_Coverage, 22443,
     /*  827650 */     GIR_EraseRootFromParent_Done,
     /*  827651 */   // Label 12750: @827651
     /*  827651 */   GIM_Try, /*On fail goto*//*Label 12751*/ GIMT_Encode4(827726), // Rule ID 22446 //
     /*  827656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  827673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  827702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  827705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827724 */     GIR_RootConstrainSelectedInstOperands,
     /*  827725 */     // GIR_Coverage, 22446,
     /*  827725 */     GIR_EraseRootFromParent_Done,
     /*  827726 */   // Label 12751: @827726
     /*  827726 */   GIM_Try, /*On fail goto*//*Label 12752*/ GIMT_Encode4(827801), // Rule ID 22447 //
     /*  827731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  827748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827777 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  827777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  827780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827799 */     GIR_RootConstrainSelectedInstOperands,
     /*  827800 */     // GIR_Coverage, 22447,
     /*  827800 */     GIR_EraseRootFromParent_Done,
     /*  827801 */   // Label 12752: @827801
     /*  827801 */   GIM_Try, /*On fail goto*//*Label 12753*/ GIMT_Encode4(827876), // Rule ID 22450 //
     /*  827806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  827809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  827817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  827820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  827823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  827826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  827852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  827855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827874 */     GIR_RootConstrainSelectedInstOperands,
     /*  827875 */     // GIR_Coverage, 22450,
     /*  827875 */     GIR_EraseRootFromParent_Done,
     /*  827876 */   // Label 12753: @827876
     /*  827876 */   GIM_Try, /*On fail goto*//*Label 12754*/ GIMT_Encode4(827951), // Rule ID 22451 //
     /*  827881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  827884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  827892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  827895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  827898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  827901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827927 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  827927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  827930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827949 */     GIR_RootConstrainSelectedInstOperands,
     /*  827950 */     // GIR_Coverage, 22451,
     /*  827950 */     GIR_EraseRootFromParent_Done,
     /*  827951 */   // Label 12754: @827951
     /*  827951 */   GIM_Try, /*On fail goto*//*Label 12755*/ GIMT_Encode4(828026), // Rule ID 22454 //
     /*  827956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  827973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828002 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  828002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  828005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828024 */     GIR_RootConstrainSelectedInstOperands,
     /*  828025 */     // GIR_Coverage, 22454,
     /*  828025 */     GIR_EraseRootFromParent_Done,
     /*  828026 */   // Label 12755: @828026
     /*  828026 */   GIM_Try, /*On fail goto*//*Label 12756*/ GIMT_Encode4(828101), // Rule ID 22455 //
     /*  828031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  828048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828077 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  828077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  828080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828099 */     GIR_RootConstrainSelectedInstOperands,
     /*  828100 */     // GIR_Coverage, 22455,
     /*  828100 */     GIR_EraseRootFromParent_Done,
     /*  828101 */   // Label 12756: @828101
     /*  828101 */   GIM_Try, /*On fail goto*//*Label 12757*/ GIMT_Encode4(828176), // Rule ID 22458 //
     /*  828106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  828123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828152 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  828152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  828155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828174 */     GIR_RootConstrainSelectedInstOperands,
     /*  828175 */     // GIR_Coverage, 22458,
     /*  828175 */     GIR_EraseRootFromParent_Done,
     /*  828176 */   // Label 12757: @828176
     /*  828176 */   GIM_Try, /*On fail goto*//*Label 12758*/ GIMT_Encode4(828251), // Rule ID 22459 //
     /*  828181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  828198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828227 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  828227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  828230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828249 */     GIR_RootConstrainSelectedInstOperands,
     /*  828250 */     // GIR_Coverage, 22459,
     /*  828250 */     GIR_EraseRootFromParent_Done,
     /*  828251 */   // Label 12758: @828251
     /*  828251 */   GIM_Try, /*On fail goto*//*Label 12759*/ GIMT_Encode4(828326), // Rule ID 22462 //
     /*  828256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  828273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  828302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  828305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828324 */     GIR_RootConstrainSelectedInstOperands,
     /*  828325 */     // GIR_Coverage, 22462,
     /*  828325 */     GIR_EraseRootFromParent_Done,
     /*  828326 */   // Label 12759: @828326
     /*  828326 */   GIM_Try, /*On fail goto*//*Label 12760*/ GIMT_Encode4(828401), // Rule ID 22463 //
     /*  828331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  828348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828377 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  828377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  828380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828399 */     GIR_RootConstrainSelectedInstOperands,
     /*  828400 */     // GIR_Coverage, 22463,
     /*  828400 */     GIR_EraseRootFromParent_Done,
     /*  828401 */   // Label 12760: @828401
     /*  828401 */   GIM_Try, /*On fail goto*//*Label 12761*/ GIMT_Encode4(828476), // Rule ID 22466 //
     /*  828406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  828423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  828455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828474 */     GIR_RootConstrainSelectedInstOperands,
     /*  828475 */     // GIR_Coverage, 22466,
     /*  828475 */     GIR_EraseRootFromParent_Done,
     /*  828476 */   // Label 12761: @828476
     /*  828476 */   GIM_Try, /*On fail goto*//*Label 12762*/ GIMT_Encode4(828551), // Rule ID 22467 //
     /*  828481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  828498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828527 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  828530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828549 */     GIR_RootConstrainSelectedInstOperands,
     /*  828550 */     // GIR_Coverage, 22467,
     /*  828550 */     GIR_EraseRootFromParent_Done,
     /*  828551 */   // Label 12762: @828551
     /*  828551 */   GIM_Try, /*On fail goto*//*Label 12763*/ GIMT_Encode4(828626), // Rule ID 22470 //
     /*  828556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  828605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828624 */     GIR_RootConstrainSelectedInstOperands,
     /*  828625 */     // GIR_Coverage, 22470,
     /*  828625 */     GIR_EraseRootFromParent_Done,
     /*  828626 */   // Label 12763: @828626
     /*  828626 */   GIM_Try, /*On fail goto*//*Label 12764*/ GIMT_Encode4(828701), // Rule ID 22471 //
     /*  828631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828677 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  828680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828699 */     GIR_RootConstrainSelectedInstOperands,
     /*  828700 */     // GIR_Coverage, 22471,
     /*  828700 */     GIR_EraseRootFromParent_Done,
     /*  828701 */   // Label 12764: @828701
     /*  828701 */   GIM_Try, /*On fail goto*//*Label 12765*/ GIMT_Encode4(828776), // Rule ID 22474 //
     /*  828706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  828755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828774 */     GIR_RootConstrainSelectedInstOperands,
     /*  828775 */     // GIR_Coverage, 22474,
     /*  828775 */     GIR_EraseRootFromParent_Done,
     /*  828776 */   // Label 12765: @828776
     /*  828776 */   GIM_Try, /*On fail goto*//*Label 12766*/ GIMT_Encode4(828851), // Rule ID 22475 //
     /*  828781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  828830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828849 */     GIR_RootConstrainSelectedInstOperands,
     /*  828850 */     // GIR_Coverage, 22475,
     /*  828850 */     GIR_EraseRootFromParent_Done,
     /*  828851 */   // Label 12766: @828851
     /*  828851 */   GIM_Try, /*On fail goto*//*Label 12767*/ GIMT_Encode4(828926), // Rule ID 22478 //
     /*  828856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  828905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828924 */     GIR_RootConstrainSelectedInstOperands,
     /*  828925 */     // GIR_Coverage, 22478,
     /*  828925 */     GIR_EraseRootFromParent_Done,
     /*  828926 */   // Label 12767: @828926
     /*  828926 */   GIM_Try, /*On fail goto*//*Label 12768*/ GIMT_Encode4(829001), // Rule ID 22479 //
     /*  828931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828977 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  828977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  828980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828999 */     GIR_RootConstrainSelectedInstOperands,
     /*  829000 */     // GIR_Coverage, 22479,
     /*  829000 */     GIR_EraseRootFromParent_Done,
     /*  829001 */   // Label 12768: @829001
     /*  829001 */   GIM_Try, /*On fail goto*//*Label 12769*/ GIMT_Encode4(829076), // Rule ID 22482 //
     /*  829006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  829023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  829052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  829055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829074 */     GIR_RootConstrainSelectedInstOperands,
     /*  829075 */     // GIR_Coverage, 22482,
     /*  829075 */     GIR_EraseRootFromParent_Done,
     /*  829076 */   // Label 12769: @829076
     /*  829076 */   GIM_Try, /*On fail goto*//*Label 12770*/ GIMT_Encode4(829151), // Rule ID 22483 //
     /*  829081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  829098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829127 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  829127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  829130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829149 */     GIR_RootConstrainSelectedInstOperands,
     /*  829150 */     // GIR_Coverage, 22483,
     /*  829150 */     GIR_EraseRootFromParent_Done,
     /*  829151 */   // Label 12770: @829151
     /*  829151 */   GIM_Try, /*On fail goto*//*Label 12771*/ GIMT_Encode4(829226), // Rule ID 22486 //
     /*  829156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  829173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  829202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  829205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829224 */     GIR_RootConstrainSelectedInstOperands,
     /*  829225 */     // GIR_Coverage, 22486,
     /*  829225 */     GIR_EraseRootFromParent_Done,
     /*  829226 */   // Label 12771: @829226
     /*  829226 */   GIM_Try, /*On fail goto*//*Label 12772*/ GIMT_Encode4(829301), // Rule ID 22487 //
     /*  829231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  829248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  829277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  829280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829299 */     GIR_RootConstrainSelectedInstOperands,
     /*  829300 */     // GIR_Coverage, 22487,
     /*  829300 */     GIR_EraseRootFromParent_Done,
     /*  829301 */   // Label 12772: @829301
     /*  829301 */   GIM_Try, /*On fail goto*//*Label 12773*/ GIMT_Encode4(829376), // Rule ID 22490 //
     /*  829306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  829323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  829355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829374 */     GIR_RootConstrainSelectedInstOperands,
     /*  829375 */     // GIR_Coverage, 22490,
     /*  829375 */     GIR_EraseRootFromParent_Done,
     /*  829376 */   // Label 12773: @829376
     /*  829376 */   GIM_Try, /*On fail goto*//*Label 12774*/ GIMT_Encode4(829451), // Rule ID 22491 //
     /*  829381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  829398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829427 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  829430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829449 */     GIR_RootConstrainSelectedInstOperands,
     /*  829450 */     // GIR_Coverage, 22491,
     /*  829450 */     GIR_EraseRootFromParent_Done,
     /*  829451 */   // Label 12774: @829451
     /*  829451 */   GIM_Try, /*On fail goto*//*Label 12775*/ GIMT_Encode4(829526), // Rule ID 22494 //
     /*  829456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  829473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  829505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829524 */     GIR_RootConstrainSelectedInstOperands,
     /*  829525 */     // GIR_Coverage, 22494,
     /*  829525 */     GIR_EraseRootFromParent_Done,
     /*  829526 */   // Label 12775: @829526
     /*  829526 */   GIM_Try, /*On fail goto*//*Label 12776*/ GIMT_Encode4(829601), // Rule ID 22495 //
     /*  829531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  829548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829577 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  829580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829599 */     GIR_RootConstrainSelectedInstOperands,
     /*  829600 */     // GIR_Coverage, 22495,
     /*  829600 */     GIR_EraseRootFromParent_Done,
     /*  829601 */   // Label 12776: @829601
     /*  829601 */   GIM_Try, /*On fail goto*//*Label 12777*/ GIMT_Encode4(829676), // Rule ID 22498 //
     /*  829606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  829655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829674 */     GIR_RootConstrainSelectedInstOperands,
     /*  829675 */     // GIR_Coverage, 22498,
     /*  829675 */     GIR_EraseRootFromParent_Done,
     /*  829676 */   // Label 12777: @829676
     /*  829676 */   GIM_Try, /*On fail goto*//*Label 12778*/ GIMT_Encode4(829751), // Rule ID 22499 //
     /*  829681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  829730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829749 */     GIR_RootConstrainSelectedInstOperands,
     /*  829750 */     // GIR_Coverage, 22499,
     /*  829750 */     GIR_EraseRootFromParent_Done,
     /*  829751 */   // Label 12778: @829751
     /*  829751 */   GIM_Try, /*On fail goto*//*Label 12779*/ GIMT_Encode4(829826), // Rule ID 22502 //
     /*  829756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  829773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  829805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829824 */     GIR_RootConstrainSelectedInstOperands,
     /*  829825 */     // GIR_Coverage, 22502,
     /*  829825 */     GIR_EraseRootFromParent_Done,
     /*  829826 */   // Label 12779: @829826
     /*  829826 */   GIM_Try, /*On fail goto*//*Label 12780*/ GIMT_Encode4(829901), // Rule ID 22503 //
     /*  829831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  829848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829877 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  829880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829899 */     GIR_RootConstrainSelectedInstOperands,
     /*  829900 */     // GIR_Coverage, 22503,
     /*  829900 */     GIR_EraseRootFromParent_Done,
     /*  829901 */   // Label 12780: @829901
     /*  829901 */   GIM_Try, /*On fail goto*//*Label 12781*/ GIMT_Encode4(829976), // Rule ID 22506 //
     /*  829906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  829923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  829955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829974 */     GIR_RootConstrainSelectedInstOperands,
     /*  829975 */     // GIR_Coverage, 22506,
     /*  829975 */     GIR_EraseRootFromParent_Done,
     /*  829976 */   // Label 12781: @829976
     /*  829976 */   GIM_Try, /*On fail goto*//*Label 12782*/ GIMT_Encode4(830051), // Rule ID 22507 //
     /*  829981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  829998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  830030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830049 */     GIR_RootConstrainSelectedInstOperands,
     /*  830050 */     // GIR_Coverage, 22507,
     /*  830050 */     GIR_EraseRootFromParent_Done,
     /*  830051 */   // Label 12782: @830051
     /*  830051 */   GIM_Try, /*On fail goto*//*Label 12783*/ GIMT_Encode4(830126), // Rule ID 22510 //
     /*  830056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  830073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  830105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830124 */     GIR_RootConstrainSelectedInstOperands,
     /*  830125 */     // GIR_Coverage, 22510,
     /*  830125 */     GIR_EraseRootFromParent_Done,
     /*  830126 */   // Label 12783: @830126
     /*  830126 */   GIM_Try, /*On fail goto*//*Label 12784*/ GIMT_Encode4(830201), // Rule ID 22511 //
     /*  830131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  830148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830177 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  830180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830199 */     GIR_RootConstrainSelectedInstOperands,
     /*  830200 */     // GIR_Coverage, 22511,
     /*  830200 */     GIR_EraseRootFromParent_Done,
     /*  830201 */   // Label 12784: @830201
     /*  830201 */   GIM_Try, /*On fail goto*//*Label 12785*/ GIMT_Encode4(830276), // Rule ID 22514 //
     /*  830206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  830223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  830255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830274 */     GIR_RootConstrainSelectedInstOperands,
     /*  830275 */     // GIR_Coverage, 22514,
     /*  830275 */     GIR_EraseRootFromParent_Done,
     /*  830276 */   // Label 12785: @830276
     /*  830276 */   GIM_Try, /*On fail goto*//*Label 12786*/ GIMT_Encode4(830351), // Rule ID 22515 //
     /*  830281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  830298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  830330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830349 */     GIR_RootConstrainSelectedInstOperands,
     /*  830350 */     // GIR_Coverage, 22515,
     /*  830350 */     GIR_EraseRootFromParent_Done,
     /*  830351 */   // Label 12786: @830351
     /*  830351 */   GIM_Try, /*On fail goto*//*Label 12787*/ GIMT_Encode4(830426), // Rule ID 22518 //
     /*  830356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  830373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  830405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830424 */     GIR_RootConstrainSelectedInstOperands,
     /*  830425 */     // GIR_Coverage, 22518,
     /*  830425 */     GIR_EraseRootFromParent_Done,
     /*  830426 */   // Label 12787: @830426
     /*  830426 */   GIM_Try, /*On fail goto*//*Label 12788*/ GIMT_Encode4(830501), // Rule ID 22519 //
     /*  830431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  830448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  830480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830499 */     GIR_RootConstrainSelectedInstOperands,
     /*  830500 */     // GIR_Coverage, 22519,
     /*  830500 */     GIR_EraseRootFromParent_Done,
     /*  830501 */   // Label 12788: @830501
     /*  830501 */   GIM_Try, /*On fail goto*//*Label 12789*/ GIMT_Encode4(830576), // Rule ID 22522 //
     /*  830506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  830523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  830552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  830555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830574 */     GIR_RootConstrainSelectedInstOperands,
     /*  830575 */     // GIR_Coverage, 22522,
     /*  830575 */     GIR_EraseRootFromParent_Done,
     /*  830576 */   // Label 12789: @830576
     /*  830576 */   GIM_Try, /*On fail goto*//*Label 12790*/ GIMT_Encode4(830651), // Rule ID 22523 //
     /*  830581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  830598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830627 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  830627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  830630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830649 */     GIR_RootConstrainSelectedInstOperands,
     /*  830650 */     // GIR_Coverage, 22523,
     /*  830650 */     GIR_EraseRootFromParent_Done,
     /*  830651 */   // Label 12790: @830651
     /*  830651 */   GIM_Try, /*On fail goto*//*Label 12791*/ GIMT_Encode4(830726), // Rule ID 22526 //
     /*  830656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  830673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830702 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  830705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830724 */     GIR_RootConstrainSelectedInstOperands,
     /*  830725 */     // GIR_Coverage, 22526,
     /*  830725 */     GIR_EraseRootFromParent_Done,
     /*  830726 */   // Label 12791: @830726
     /*  830726 */   GIM_Try, /*On fail goto*//*Label 12792*/ GIMT_Encode4(830801), // Rule ID 22527 //
     /*  830731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  830748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830777 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  830780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830799 */     GIR_RootConstrainSelectedInstOperands,
     /*  830800 */     // GIR_Coverage, 22527,
     /*  830800 */     GIR_EraseRootFromParent_Done,
     /*  830801 */   // Label 12792: @830801
     /*  830801 */   GIM_Try, /*On fail goto*//*Label 12793*/ GIMT_Encode4(830876), // Rule ID 22530 //
     /*  830806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  830855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830874 */     GIR_RootConstrainSelectedInstOperands,
     /*  830875 */     // GIR_Coverage, 22530,
     /*  830875 */     GIR_EraseRootFromParent_Done,
     /*  830876 */   // Label 12793: @830876
     /*  830876 */   GIM_Try, /*On fail goto*//*Label 12794*/ GIMT_Encode4(830951), // Rule ID 22531 //
     /*  830881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830927 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  830930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830949 */     GIR_RootConstrainSelectedInstOperands,
     /*  830950 */     // GIR_Coverage, 22531,
     /*  830950 */     GIR_EraseRootFromParent_Done,
     /*  830951 */   // Label 12794: @830951
     /*  830951 */   GIM_Try, /*On fail goto*//*Label 12795*/ GIMT_Encode4(831026), // Rule ID 22534 //
     /*  830956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  830973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  831002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  831005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831024 */     GIR_RootConstrainSelectedInstOperands,
     /*  831025 */     // GIR_Coverage, 22534,
     /*  831025 */     GIR_EraseRootFromParent_Done,
     /*  831026 */   // Label 12795: @831026
     /*  831026 */   GIM_Try, /*On fail goto*//*Label 12796*/ GIMT_Encode4(831101), // Rule ID 22535 //
     /*  831031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  831048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831077 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  831077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  831080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831099 */     GIR_RootConstrainSelectedInstOperands,
     /*  831100 */     // GIR_Coverage, 22535,
     /*  831100 */     GIR_EraseRootFromParent_Done,
     /*  831101 */   // Label 12796: @831101
     /*  831101 */   GIM_Try, /*On fail goto*//*Label 12797*/ GIMT_Encode4(831176), // Rule ID 22538 //
     /*  831106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  831109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  831123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  831152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  831155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831174 */     GIR_RootConstrainSelectedInstOperands,
     /*  831175 */     // GIR_Coverage, 22538,
     /*  831175 */     GIR_EraseRootFromParent_Done,
     /*  831176 */   // Label 12797: @831176
     /*  831176 */   GIM_Try, /*On fail goto*//*Label 12798*/ GIMT_Encode4(831251), // Rule ID 22539 //
     /*  831181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  831184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  831198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831227 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  831227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  831230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831249 */     GIR_RootConstrainSelectedInstOperands,
     /*  831250 */     // GIR_Coverage, 22539,
     /*  831250 */     GIR_EraseRootFromParent_Done,
     /*  831251 */   // Label 12798: @831251
     /*  831251 */   GIM_Try, /*On fail goto*//*Label 12799*/ GIMT_Encode4(831326), // Rule ID 22542 //
     /*  831256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  831273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  831305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831324 */     GIR_RootConstrainSelectedInstOperands,
     /*  831325 */     // GIR_Coverage, 22542,
     /*  831325 */     GIR_EraseRootFromParent_Done,
     /*  831326 */   // Label 12799: @831326
     /*  831326 */   GIM_Try, /*On fail goto*//*Label 12800*/ GIMT_Encode4(831401), // Rule ID 22543 //
     /*  831331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  831348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831377 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  831380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831399 */     GIR_RootConstrainSelectedInstOperands,
     /*  831400 */     // GIR_Coverage, 22543,
     /*  831400 */     GIR_EraseRootFromParent_Done,
     /*  831401 */   // Label 12800: @831401
     /*  831401 */   GIM_Try, /*On fail goto*//*Label 12801*/ GIMT_Encode4(831476), // Rule ID 22546 //
     /*  831406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  831423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  831455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831474 */     GIR_RootConstrainSelectedInstOperands,
     /*  831475 */     // GIR_Coverage, 22546,
     /*  831475 */     GIR_EraseRootFromParent_Done,
     /*  831476 */   // Label 12801: @831476
     /*  831476 */   GIM_Try, /*On fail goto*//*Label 12802*/ GIMT_Encode4(831551), // Rule ID 22547 //
     /*  831481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  831498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831527 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  831530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831549 */     GIR_RootConstrainSelectedInstOperands,
     /*  831550 */     // GIR_Coverage, 22547,
     /*  831550 */     GIR_EraseRootFromParent_Done,
     /*  831551 */   // Label 12802: @831551
     /*  831551 */   GIM_Try, /*On fail goto*//*Label 12803*/ GIMT_Encode4(831626), // Rule ID 22550 //
     /*  831556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  831573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  831605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831624 */     GIR_RootConstrainSelectedInstOperands,
     /*  831625 */     // GIR_Coverage, 22550,
     /*  831625 */     GIR_EraseRootFromParent_Done,
     /*  831626 */   // Label 12803: @831626
     /*  831626 */   GIM_Try, /*On fail goto*//*Label 12804*/ GIMT_Encode4(831701), // Rule ID 22551 //
     /*  831631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  831648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831677 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  831680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831699 */     GIR_RootConstrainSelectedInstOperands,
     /*  831700 */     // GIR_Coverage, 22551,
     /*  831700 */     GIR_EraseRootFromParent_Done,
     /*  831701 */   // Label 12804: @831701
     /*  831701 */   GIM_Try, /*On fail goto*//*Label 12805*/ GIMT_Encode4(831776), // Rule ID 22554 //
     /*  831706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  831723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  831755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831774 */     GIR_RootConstrainSelectedInstOperands,
     /*  831775 */     // GIR_Coverage, 22554,
     /*  831775 */     GIR_EraseRootFromParent_Done,
     /*  831776 */   // Label 12805: @831776
     /*  831776 */   GIM_Try, /*On fail goto*//*Label 12806*/ GIMT_Encode4(831851), // Rule ID 22555 //
     /*  831781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  831798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  831830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831849 */     GIR_RootConstrainSelectedInstOperands,
     /*  831850 */     // GIR_Coverage, 22555,
     /*  831850 */     GIR_EraseRootFromParent_Done,
     /*  831851 */   // Label 12806: @831851
     /*  831851 */   GIM_Try, /*On fail goto*//*Label 12807*/ GIMT_Encode4(831926), // Rule ID 22558 //
     /*  831856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  831905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831924 */     GIR_RootConstrainSelectedInstOperands,
     /*  831925 */     // GIR_Coverage, 22558,
     /*  831925 */     GIR_EraseRootFromParent_Done,
     /*  831926 */   // Label 12807: @831926
     /*  831926 */   GIM_Try, /*On fail goto*//*Label 12808*/ GIMT_Encode4(832001), // Rule ID 22559 //
     /*  831931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831977 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  831980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831999 */     GIR_RootConstrainSelectedInstOperands,
     /*  832000 */     // GIR_Coverage, 22559,
     /*  832000 */     GIR_EraseRootFromParent_Done,
     /*  832001 */   // Label 12808: @832001
     /*  832001 */   GIM_Try, /*On fail goto*//*Label 12809*/ GIMT_Encode4(832076), // Rule ID 22562 //
     /*  832006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  832023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  832052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  832055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  832071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832074 */     GIR_RootConstrainSelectedInstOperands,
     /*  832075 */     // GIR_Coverage, 22562,
     /*  832075 */     GIR_EraseRootFromParent_Done,
     /*  832076 */   // Label 12809: @832076
     /*  832076 */   GIM_Try, /*On fail goto*//*Label 12810*/ GIMT_Encode4(832151), // Rule ID 22563 //
     /*  832081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  832098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  832127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  832130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  832146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832149 */     GIR_RootConstrainSelectedInstOperands,
     /*  832150 */     // GIR_Coverage, 22563,
     /*  832150 */     GIR_EraseRootFromParent_Done,
     /*  832151 */   // Label 12810: @832151
     /*  832151 */   GIM_Try, /*On fail goto*//*Label 12811*/ GIMT_Encode4(832226), // Rule ID 22566 //
     /*  832156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  832173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  832202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  832205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832224 */     GIR_RootConstrainSelectedInstOperands,
     /*  832225 */     // GIR_Coverage, 22566,
     /*  832225 */     GIR_EraseRootFromParent_Done,
     /*  832226 */   // Label 12811: @832226
     /*  832226 */   GIM_Try, /*On fail goto*//*Label 12812*/ GIMT_Encode4(832301), // Rule ID 22567 //
     /*  832231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  832248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  832280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832299 */     GIR_RootConstrainSelectedInstOperands,
     /*  832300 */     // GIR_Coverage, 22567,
     /*  832300 */     GIR_EraseRootFromParent_Done,
     /*  832301 */   // Label 12812: @832301
     /*  832301 */   GIM_Try, /*On fail goto*//*Label 12813*/ GIMT_Encode4(832376), // Rule ID 22570 //
     /*  832306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  832323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  832352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  832355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832374 */     GIR_RootConstrainSelectedInstOperands,
     /*  832375 */     // GIR_Coverage, 22570,
     /*  832375 */     GIR_EraseRootFromParent_Done,
     /*  832376 */   // Label 12813: @832376
     /*  832376 */   GIM_Try, /*On fail goto*//*Label 12814*/ GIMT_Encode4(832451), // Rule ID 22571 //
     /*  832381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  832398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832427 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  832430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832449 */     GIR_RootConstrainSelectedInstOperands,
     /*  832450 */     // GIR_Coverage, 22571,
     /*  832450 */     GIR_EraseRootFromParent_Done,
     /*  832451 */   // Label 12814: @832451
     /*  832451 */   GIM_Try, /*On fail goto*//*Label 12815*/ GIMT_Encode4(832526), // Rule ID 22574 //
     /*  832456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  832473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  832502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  832505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832524 */     GIR_RootConstrainSelectedInstOperands,
     /*  832525 */     // GIR_Coverage, 22574,
     /*  832525 */     GIR_EraseRootFromParent_Done,
     /*  832526 */   // Label 12815: @832526
     /*  832526 */   GIM_Try, /*On fail goto*//*Label 12816*/ GIMT_Encode4(832601), // Rule ID 22575 //
     /*  832531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  832548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832577 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  832580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832599 */     GIR_RootConstrainSelectedInstOperands,
     /*  832600 */     // GIR_Coverage, 22575,
     /*  832600 */     GIR_EraseRootFromParent_Done,
     /*  832601 */   // Label 12816: @832601
     /*  832601 */   GIM_Try, /*On fail goto*//*Label 12817*/ GIMT_Encode4(832676), // Rule ID 22578 //
     /*  832606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  832623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  832655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832674 */     GIR_RootConstrainSelectedInstOperands,
     /*  832675 */     // GIR_Coverage, 22578,
     /*  832675 */     GIR_EraseRootFromParent_Done,
     /*  832676 */   // Label 12817: @832676
     /*  832676 */   GIM_Try, /*On fail goto*//*Label 12818*/ GIMT_Encode4(832751), // Rule ID 22579 //
     /*  832681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  832698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  832730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832749 */     GIR_RootConstrainSelectedInstOperands,
     /*  832750 */     // GIR_Coverage, 22579,
     /*  832750 */     GIR_EraseRootFromParent_Done,
     /*  832751 */   // Label 12818: @832751
     /*  832751 */   GIM_Try, /*On fail goto*//*Label 12819*/ GIMT_Encode4(832826), // Rule ID 22582 //
     /*  832756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  832805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832824 */     GIR_RootConstrainSelectedInstOperands,
     /*  832825 */     // GIR_Coverage, 22582,
     /*  832825 */     GIR_EraseRootFromParent_Done,
     /*  832826 */   // Label 12819: @832826
     /*  832826 */   GIM_Try, /*On fail goto*//*Label 12820*/ GIMT_Encode4(832901), // Rule ID 22583 //
     /*  832831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832877 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  832880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832899 */     GIR_RootConstrainSelectedInstOperands,
     /*  832900 */     // GIR_Coverage, 22583,
     /*  832900 */     GIR_EraseRootFromParent_Done,
     /*  832901 */   // Label 12820: @832901
     /*  832901 */   GIM_Try, /*On fail goto*//*Label 12821*/ GIMT_Encode4(832976), // Rule ID 22586 //
     /*  832906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  832955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832974 */     GIR_RootConstrainSelectedInstOperands,
     /*  832975 */     // GIR_Coverage, 22586,
     /*  832975 */     GIR_EraseRootFromParent_Done,
     /*  832976 */   // Label 12821: @832976
     /*  832976 */   GIM_Try, /*On fail goto*//*Label 12822*/ GIMT_Encode4(833051), // Rule ID 22587 //
     /*  832981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  833016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833027 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  833027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  833030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  833046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833049 */     GIR_RootConstrainSelectedInstOperands,
     /*  833050 */     // GIR_Coverage, 22587,
     /*  833050 */     GIR_EraseRootFromParent_Done,
     /*  833051 */   // Label 12822: @833051
     /*  833051 */   GIM_Try, /*On fail goto*//*Label 12823*/ GIMT_Encode4(833126), // Rule ID 22590 //
     /*  833056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  833073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  833105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833124 */     GIR_RootConstrainSelectedInstOperands,
     /*  833125 */     // GIR_Coverage, 22590,
     /*  833125 */     GIR_EraseRootFromParent_Done,
     /*  833126 */   // Label 12823: @833126
     /*  833126 */   GIM_Try, /*On fail goto*//*Label 12824*/ GIMT_Encode4(833201), // Rule ID 22591 //
     /*  833131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  833148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833177 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  833180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833199 */     GIR_RootConstrainSelectedInstOperands,
     /*  833200 */     // GIR_Coverage, 22591,
     /*  833200 */     GIR_EraseRootFromParent_Done,
     /*  833201 */   // Label 12824: @833201
     /*  833201 */   GIM_Try, /*On fail goto*//*Label 12825*/ GIMT_Encode4(833276), // Rule ID 22594 //
     /*  833206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  833223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  833255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833274 */     GIR_RootConstrainSelectedInstOperands,
     /*  833275 */     // GIR_Coverage, 22594,
     /*  833275 */     GIR_EraseRootFromParent_Done,
     /*  833276 */   // Label 12825: @833276
     /*  833276 */   GIM_Try, /*On fail goto*//*Label 12826*/ GIMT_Encode4(833351), // Rule ID 22595 //
     /*  833281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  833298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  833330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833349 */     GIR_RootConstrainSelectedInstOperands,
     /*  833350 */     // GIR_Coverage, 22595,
     /*  833350 */     GIR_EraseRootFromParent_Done,
     /*  833351 */   // Label 12826: @833351
     /*  833351 */   GIM_Try, /*On fail goto*//*Label 12827*/ GIMT_Encode4(833426), // Rule ID 22598 //
     /*  833356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  833373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833402 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  833405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833424 */     GIR_RootConstrainSelectedInstOperands,
     /*  833425 */     // GIR_Coverage, 22598,
     /*  833425 */     GIR_EraseRootFromParent_Done,
     /*  833426 */   // Label 12827: @833426
     /*  833426 */   GIM_Try, /*On fail goto*//*Label 12828*/ GIMT_Encode4(833501), // Rule ID 22599 //
     /*  833431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  833448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833477 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  833480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833499 */     GIR_RootConstrainSelectedInstOperands,
     /*  833500 */     // GIR_Coverage, 22599,
     /*  833500 */     GIR_EraseRootFromParent_Done,
     /*  833501 */   // Label 12828: @833501
     /*  833501 */   GIM_Try, /*On fail goto*//*Label 12829*/ GIMT_Encode4(833576), // Rule ID 22602 //
     /*  833506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  833523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  833555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833574 */     GIR_RootConstrainSelectedInstOperands,
     /*  833575 */     // GIR_Coverage, 22602,
     /*  833575 */     GIR_EraseRootFromParent_Done,
     /*  833576 */   // Label 12829: @833576
     /*  833576 */   GIM_Try, /*On fail goto*//*Label 12830*/ GIMT_Encode4(833651), // Rule ID 22603 //
     /*  833581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  833598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833627 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  833630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833649 */     GIR_RootConstrainSelectedInstOperands,
     /*  833650 */     // GIR_Coverage, 22603,
     /*  833650 */     GIR_EraseRootFromParent_Done,
     /*  833651 */   // Label 12830: @833651
     /*  833651 */   GIM_Try, /*On fail goto*//*Label 12831*/ GIMT_Encode4(833726), // Rule ID 22606 //
     /*  833656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  833705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833724 */     GIR_RootConstrainSelectedInstOperands,
     /*  833725 */     // GIR_Coverage, 22606,
     /*  833725 */     GIR_EraseRootFromParent_Done,
     /*  833726 */   // Label 12831: @833726
     /*  833726 */   GIM_Try, /*On fail goto*//*Label 12832*/ GIMT_Encode4(833801), // Rule ID 22607 //
     /*  833731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833777 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  833780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833799 */     GIR_RootConstrainSelectedInstOperands,
     /*  833800 */     // GIR_Coverage, 22607,
     /*  833800 */     GIR_EraseRootFromParent_Done,
     /*  833801 */   // Label 12832: @833801
     /*  833801 */   GIM_Try, /*On fail goto*//*Label 12833*/ GIMT_Encode4(833876), // Rule ID 22610 //
     /*  833806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  833852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  833855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833874 */     GIR_RootConstrainSelectedInstOperands,
     /*  833875 */     // GIR_Coverage, 22610,
     /*  833875 */     GIR_EraseRootFromParent_Done,
     /*  833876 */   // Label 12833: @833876
     /*  833876 */   GIM_Try, /*On fail goto*//*Label 12834*/ GIMT_Encode4(833951), // Rule ID 22611 //
     /*  833881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  833927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  833930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833949 */     GIR_RootConstrainSelectedInstOperands,
     /*  833950 */     // GIR_Coverage, 22611,
     /*  833950 */     GIR_EraseRootFromParent_Done,
     /*  833951 */   // Label 12834: @833951
     /*  833951 */   GIM_Try, /*On fail goto*//*Label 12835*/ GIMT_Encode4(834026), // Rule ID 22614 //
     /*  833956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  833973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834002 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  834005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834024 */     GIR_RootConstrainSelectedInstOperands,
     /*  834025 */     // GIR_Coverage, 22614,
     /*  834025 */     GIR_EraseRootFromParent_Done,
     /*  834026 */   // Label 12835: @834026
     /*  834026 */   GIM_Try, /*On fail goto*//*Label 12836*/ GIMT_Encode4(834101), // Rule ID 22615 //
     /*  834031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  834048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834077 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  834080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834099 */     GIR_RootConstrainSelectedInstOperands,
     /*  834100 */     // GIR_Coverage, 22615,
     /*  834100 */     GIR_EraseRootFromParent_Done,
     /*  834101 */   // Label 12836: @834101
     /*  834101 */   GIM_Try, /*On fail goto*//*Label 12837*/ GIMT_Encode4(834176), // Rule ID 22618 //
     /*  834106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  834123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  834155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834174 */     GIR_RootConstrainSelectedInstOperands,
     /*  834175 */     // GIR_Coverage, 22618,
     /*  834175 */     GIR_EraseRootFromParent_Done,
     /*  834176 */   // Label 12837: @834176
     /*  834176 */   GIM_Try, /*On fail goto*//*Label 12838*/ GIMT_Encode4(834251), // Rule ID 22619 //
     /*  834181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  834198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  834230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834249 */     GIR_RootConstrainSelectedInstOperands,
     /*  834250 */     // GIR_Coverage, 22619,
     /*  834250 */     GIR_EraseRootFromParent_Done,
     /*  834251 */   // Label 12838: @834251
     /*  834251 */   GIM_Try, /*On fail goto*//*Label 12839*/ GIMT_Encode4(834326), // Rule ID 22622 //
     /*  834256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  834273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834302 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  834302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  834305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834324 */     GIR_RootConstrainSelectedInstOperands,
     /*  834325 */     // GIR_Coverage, 22622,
     /*  834325 */     GIR_EraseRootFromParent_Done,
     /*  834326 */   // Label 12839: @834326
     /*  834326 */   GIM_Try, /*On fail goto*//*Label 12840*/ GIMT_Encode4(834401), // Rule ID 22623 //
     /*  834331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  834348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834377 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  834377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  834380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834399 */     GIR_RootConstrainSelectedInstOperands,
     /*  834400 */     // GIR_Coverage, 22623,
     /*  834400 */     GIR_EraseRootFromParent_Done,
     /*  834401 */   // Label 12840: @834401
     /*  834401 */   GIM_Try, /*On fail goto*//*Label 12841*/ GIMT_Encode4(834476), // Rule ID 22626 //
     /*  834406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  834409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  834423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834452 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  834452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  834455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  834471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834474 */     GIR_RootConstrainSelectedInstOperands,
     /*  834475 */     // GIR_Coverage, 22626,
     /*  834475 */     GIR_EraseRootFromParent_Done,
     /*  834476 */   // Label 12841: @834476
     /*  834476 */   GIM_Try, /*On fail goto*//*Label 12842*/ GIMT_Encode4(834551), // Rule ID 22627 //
     /*  834481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  834484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  834498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834527 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  834527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  834530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  834546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834549 */     GIR_RootConstrainSelectedInstOperands,
     /*  834550 */     // GIR_Coverage, 22627,
     /*  834550 */     GIR_EraseRootFromParent_Done,
     /*  834551 */   // Label 12842: @834551
     /*  834551 */   GIM_Try, /*On fail goto*//*Label 12843*/ GIMT_Encode4(834626), // Rule ID 22630 //
     /*  834556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  834573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  834605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834624 */     GIR_RootConstrainSelectedInstOperands,
     /*  834625 */     // GIR_Coverage, 22630,
     /*  834625 */     GIR_EraseRootFromParent_Done,
     /*  834626 */   // Label 12843: @834626
     /*  834626 */   GIM_Try, /*On fail goto*//*Label 12844*/ GIMT_Encode4(834701), // Rule ID 22631 //
     /*  834631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  834648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834677 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  834680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834699 */     GIR_RootConstrainSelectedInstOperands,
     /*  834700 */     // GIR_Coverage, 22631,
     /*  834700 */     GIR_EraseRootFromParent_Done,
     /*  834701 */   // Label 12844: @834701
     /*  834701 */   GIM_Try, /*On fail goto*//*Label 12845*/ GIMT_Encode4(834776), // Rule ID 22634 //
     /*  834706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834752 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  834755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834774 */     GIR_RootConstrainSelectedInstOperands,
     /*  834775 */     // GIR_Coverage, 22634,
     /*  834775 */     GIR_EraseRootFromParent_Done,
     /*  834776 */   // Label 12845: @834776
     /*  834776 */   GIM_Try, /*On fail goto*//*Label 12846*/ GIMT_Encode4(834851), // Rule ID 22635 //
     /*  834781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834827 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  834830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834849 */     GIR_RootConstrainSelectedInstOperands,
     /*  834850 */     // GIR_Coverage, 22635,
     /*  834850 */     GIR_EraseRootFromParent_Done,
     /*  834851 */   // Label 12846: @834851
     /*  834851 */   GIM_Try, /*On fail goto*//*Label 12847*/ GIMT_Encode4(834926), // Rule ID 22638 //
     /*  834856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  834905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834924 */     GIR_RootConstrainSelectedInstOperands,
     /*  834925 */     // GIR_Coverage, 22638,
     /*  834925 */     GIR_EraseRootFromParent_Done,
     /*  834926 */   // Label 12847: @834926
     /*  834926 */   GIM_Try, /*On fail goto*//*Label 12848*/ GIMT_Encode4(835001), // Rule ID 22639 //
     /*  834931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834977 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  834980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834999 */     GIR_RootConstrainSelectedInstOperands,
     /*  835000 */     // GIR_Coverage, 22639,
     /*  835000 */     GIR_EraseRootFromParent_Done,
     /*  835001 */   // Label 12848: @835001
     /*  835001 */   GIM_Try, /*On fail goto*//*Label 12849*/ GIMT_Encode4(835076), // Rule ID 22642 //
     /*  835006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  835023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  835055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835074 */     GIR_RootConstrainSelectedInstOperands,
     /*  835075 */     // GIR_Coverage, 22642,
     /*  835075 */     GIR_EraseRootFromParent_Done,
     /*  835076 */   // Label 12849: @835076
     /*  835076 */   GIM_Try, /*On fail goto*//*Label 12850*/ GIMT_Encode4(835151), // Rule ID 22643 //
     /*  835081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  835098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  835130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835149 */     GIR_RootConstrainSelectedInstOperands,
     /*  835150 */     // GIR_Coverage, 22643,
     /*  835150 */     GIR_EraseRootFromParent_Done,
     /*  835151 */   // Label 12850: @835151
     /*  835151 */   GIM_Try, /*On fail goto*//*Label 12851*/ GIMT_Encode4(835226), // Rule ID 22646 //
     /*  835156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  835173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  835205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835224 */     GIR_RootConstrainSelectedInstOperands,
     /*  835225 */     // GIR_Coverage, 22646,
     /*  835225 */     GIR_EraseRootFromParent_Done,
     /*  835226 */   // Label 12851: @835226
     /*  835226 */   GIM_Try, /*On fail goto*//*Label 12852*/ GIMT_Encode4(835301), // Rule ID 22647 //
     /*  835231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  835248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835277 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  835280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835299 */     GIR_RootConstrainSelectedInstOperands,
     /*  835300 */     // GIR_Coverage, 22647,
     /*  835300 */     GIR_EraseRootFromParent_Done,
     /*  835301 */   // Label 12852: @835301
     /*  835301 */   GIM_Try, /*On fail goto*//*Label 12853*/ GIMT_Encode4(835376), // Rule ID 22650 //
     /*  835306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  835323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  835355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835374 */     GIR_RootConstrainSelectedInstOperands,
     /*  835375 */     // GIR_Coverage, 22650,
     /*  835375 */     GIR_EraseRootFromParent_Done,
     /*  835376 */   // Label 12853: @835376
     /*  835376 */   GIM_Try, /*On fail goto*//*Label 12854*/ GIMT_Encode4(835451), // Rule ID 22651 //
     /*  835381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  835398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835427 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  835430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835449 */     GIR_RootConstrainSelectedInstOperands,
     /*  835450 */     // GIR_Coverage, 22651,
     /*  835450 */     GIR_EraseRootFromParent_Done,
     /*  835451 */   // Label 12854: @835451
     /*  835451 */   GIM_Try, /*On fail goto*//*Label 12855*/ GIMT_Encode4(835526), // Rule ID 22654 //
     /*  835456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  835473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  835505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835524 */     GIR_RootConstrainSelectedInstOperands,
     /*  835525 */     // GIR_Coverage, 22654,
     /*  835525 */     GIR_EraseRootFromParent_Done,
     /*  835526 */   // Label 12855: @835526
     /*  835526 */   GIM_Try, /*On fail goto*//*Label 12856*/ GIMT_Encode4(835601), // Rule ID 22655 //
     /*  835531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  835548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835577 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  835580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835599 */     GIR_RootConstrainSelectedInstOperands,
     /*  835600 */     // GIR_Coverage, 22655,
     /*  835600 */     GIR_EraseRootFromParent_Done,
     /*  835601 */   // Label 12856: @835601
     /*  835601 */   GIM_Try, /*On fail goto*//*Label 12857*/ GIMT_Encode4(835676), // Rule ID 22658 //
     /*  835606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  835623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  835655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835674 */     GIR_RootConstrainSelectedInstOperands,
     /*  835675 */     // GIR_Coverage, 22658,
     /*  835675 */     GIR_EraseRootFromParent_Done,
     /*  835676 */   // Label 12857: @835676
     /*  835676 */   GIM_Try, /*On fail goto*//*Label 12858*/ GIMT_Encode4(835751), // Rule ID 22659 //
     /*  835681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  835698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835727 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  835730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835749 */     GIR_RootConstrainSelectedInstOperands,
     /*  835750 */     // GIR_Coverage, 22659,
     /*  835750 */     GIR_EraseRootFromParent_Done,
     /*  835751 */   // Label 12858: @835751
     /*  835751 */   GIM_Try, /*On fail goto*//*Label 12859*/ GIMT_Encode4(835826), // Rule ID 22662 //
     /*  835756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  835805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835824 */     GIR_RootConstrainSelectedInstOperands,
     /*  835825 */     // GIR_Coverage, 22662,
     /*  835825 */     GIR_EraseRootFromParent_Done,
     /*  835826 */   // Label 12859: @835826
     /*  835826 */   GIM_Try, /*On fail goto*//*Label 12860*/ GIMT_Encode4(835901), // Rule ID 22663 //
     /*  835831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  835880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835899 */     GIR_RootConstrainSelectedInstOperands,
     /*  835900 */     // GIR_Coverage, 22663,
     /*  835900 */     GIR_EraseRootFromParent_Done,
     /*  835901 */   // Label 12860: @835901
     /*  835901 */   GIM_Try, /*On fail goto*//*Label 12861*/ GIMT_Encode4(835976), // Rule ID 22666 //
     /*  835906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  835909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  835923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  835952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  835955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  835971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835974 */     GIR_RootConstrainSelectedInstOperands,
     /*  835975 */     // GIR_Coverage, 22666,
     /*  835975 */     GIR_EraseRootFromParent_Done,
     /*  835976 */   // Label 12861: @835976
     /*  835976 */   GIM_Try, /*On fail goto*//*Label 12862*/ GIMT_Encode4(836051), // Rule ID 22667 //
     /*  835981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  835984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  835998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836027 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  836027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  836030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836049 */     GIR_RootConstrainSelectedInstOperands,
     /*  836050 */     // GIR_Coverage, 22667,
     /*  836050 */     GIR_EraseRootFromParent_Done,
     /*  836051 */   // Label 12862: @836051
     /*  836051 */   GIM_Try, /*On fail goto*//*Label 12863*/ GIMT_Encode4(836126), // Rule ID 22670 //
     /*  836056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  836059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  836064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  836073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836102 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  836102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  836105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836124 */     GIR_RootConstrainSelectedInstOperands,
     /*  836125 */     // GIR_Coverage, 22670,
     /*  836125 */     GIR_EraseRootFromParent_Done,
     /*  836126 */   // Label 12863: @836126
     /*  836126 */   GIM_Try, /*On fail goto*//*Label 12864*/ GIMT_Encode4(836201), // Rule ID 22671 //
     /*  836131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  836134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  836139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  836148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836177 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  836177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  836180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836199 */     GIR_RootConstrainSelectedInstOperands,
     /*  836200 */     // GIR_Coverage, 22671,
     /*  836200 */     GIR_EraseRootFromParent_Done,
     /*  836201 */   // Label 12864: @836201
     /*  836201 */   GIM_Try, /*On fail goto*//*Label 12865*/ GIMT_Encode4(836276), // Rule ID 22674 //
     /*  836206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  836209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  836214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  836223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  836252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  836255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836274 */     GIR_RootConstrainSelectedInstOperands,
     /*  836275 */     // GIR_Coverage, 22674,
     /*  836275 */     GIR_EraseRootFromParent_Done,
     /*  836276 */   // Label 12865: @836276
     /*  836276 */   GIM_Try, /*On fail goto*//*Label 12866*/ GIMT_Encode4(836351), // Rule ID 22675 //
     /*  836281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  836284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  836289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  836298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836327 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  836327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  836330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836349 */     GIR_RootConstrainSelectedInstOperands,
     /*  836350 */     // GIR_Coverage, 22675,
     /*  836350 */     GIR_EraseRootFromParent_Done,
     /*  836351 */   // Label 12866: @836351
     /*  836351 */   GIM_Try, /*On fail goto*//*Label 12867*/ GIMT_Encode4(836426), // Rule ID 22678 //
     /*  836356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  836373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  836405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836424 */     GIR_RootConstrainSelectedInstOperands,
     /*  836425 */     // GIR_Coverage, 22678,
     /*  836425 */     GIR_EraseRootFromParent_Done,
     /*  836426 */   // Label 12867: @836426
     /*  836426 */   GIM_Try, /*On fail goto*//*Label 12868*/ GIMT_Encode4(836501), // Rule ID 22679 //
     /*  836431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  836448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  836480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836499 */     GIR_RootConstrainSelectedInstOperands,
     /*  836500 */     // GIR_Coverage, 22679,
     /*  836500 */     GIR_EraseRootFromParent_Done,
     /*  836501 */   // Label 12868: @836501
     /*  836501 */   GIM_Try, /*On fail goto*//*Label 12869*/ GIMT_Encode4(836576), // Rule ID 22682 //
     /*  836506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  836523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  836555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836574 */     GIR_RootConstrainSelectedInstOperands,
     /*  836575 */     // GIR_Coverage, 22682,
     /*  836575 */     GIR_EraseRootFromParent_Done,
     /*  836576 */   // Label 12869: @836576
     /*  836576 */   GIM_Try, /*On fail goto*//*Label 12870*/ GIMT_Encode4(836651), // Rule ID 22683 //
     /*  836581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  836598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836627 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  836630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836649 */     GIR_RootConstrainSelectedInstOperands,
     /*  836650 */     // GIR_Coverage, 22683,
     /*  836650 */     GIR_EraseRootFromParent_Done,
     /*  836651 */   // Label 12870: @836651
     /*  836651 */   GIM_Try, /*On fail goto*//*Label 12871*/ GIMT_Encode4(836726), // Rule ID 22686 //
     /*  836656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  836673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  836705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836724 */     GIR_RootConstrainSelectedInstOperands,
     /*  836725 */     // GIR_Coverage, 22686,
     /*  836725 */     GIR_EraseRootFromParent_Done,
     /*  836726 */   // Label 12871: @836726
     /*  836726 */   GIM_Try, /*On fail goto*//*Label 12872*/ GIMT_Encode4(836801), // Rule ID 22687 //
     /*  836731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  836748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836777 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  836780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836799 */     GIR_RootConstrainSelectedInstOperands,
     /*  836800 */     // GIR_Coverage, 22687,
     /*  836800 */     GIR_EraseRootFromParent_Done,
     /*  836801 */   // Label 12872: @836801
     /*  836801 */   GIM_Try, /*On fail goto*//*Label 12873*/ GIMT_Encode4(836876), // Rule ID 22690 //
     /*  836806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  836823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  836852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  836855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836874 */     GIR_RootConstrainSelectedInstOperands,
     /*  836875 */     // GIR_Coverage, 22690,
     /*  836875 */     GIR_EraseRootFromParent_Done,
     /*  836876 */   // Label 12873: @836876
     /*  836876 */   GIM_Try, /*On fail goto*//*Label 12874*/ GIMT_Encode4(836951), // Rule ID 22691 //
     /*  836881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  836898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  836927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  836930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836949 */     GIR_RootConstrainSelectedInstOperands,
     /*  836950 */     // GIR_Coverage, 22691,
     /*  836950 */     GIR_EraseRootFromParent_Done,
     /*  836951 */   // Label 12874: @836951
     /*  836951 */   GIM_Try, /*On fail goto*//*Label 12875*/ GIMT_Encode4(837026), // Rule ID 22694 //
     /*  836956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  836973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  837005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837024 */     GIR_RootConstrainSelectedInstOperands,
     /*  837025 */     // GIR_Coverage, 22694,
     /*  837025 */     GIR_EraseRootFromParent_Done,
     /*  837026 */   // Label 12875: @837026
     /*  837026 */   GIM_Try, /*On fail goto*//*Label 12876*/ GIMT_Encode4(837101), // Rule ID 22695 //
     /*  837031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  837048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837077 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  837080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837099 */     GIR_RootConstrainSelectedInstOperands,
     /*  837100 */     // GIR_Coverage, 22695,
     /*  837100 */     GIR_EraseRootFromParent_Done,
     /*  837101 */   // Label 12876: @837101
     /*  837101 */   GIM_Try, /*On fail goto*//*Label 12877*/ GIMT_Encode4(837176), // Rule ID 22698 //
     /*  837106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  837123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  837155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837174 */     GIR_RootConstrainSelectedInstOperands,
     /*  837175 */     // GIR_Coverage, 22698,
     /*  837175 */     GIR_EraseRootFromParent_Done,
     /*  837176 */   // Label 12877: @837176
     /*  837176 */   GIM_Try, /*On fail goto*//*Label 12878*/ GIMT_Encode4(837251), // Rule ID 22699 //
     /*  837181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  837198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837227 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  837230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837249 */     GIR_RootConstrainSelectedInstOperands,
     /*  837250 */     // GIR_Coverage, 22699,
     /*  837250 */     GIR_EraseRootFromParent_Done,
     /*  837251 */   // Label 12878: @837251
     /*  837251 */   GIM_Try, /*On fail goto*//*Label 12879*/ GIMT_Encode4(837326), // Rule ID 22702 //
     /*  837256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  837273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  837302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  837305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837324 */     GIR_RootConstrainSelectedInstOperands,
     /*  837325 */     // GIR_Coverage, 22702,
     /*  837325 */     GIR_EraseRootFromParent_Done,
     /*  837326 */   // Label 12879: @837326
     /*  837326 */   GIM_Try, /*On fail goto*//*Label 12880*/ GIMT_Encode4(837401), // Rule ID 22703 //
     /*  837331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  837348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837377 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  837380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837399 */     GIR_RootConstrainSelectedInstOperands,
     /*  837400 */     // GIR_Coverage, 22703,
     /*  837400 */     GIR_EraseRootFromParent_Done,
     /*  837401 */   // Label 12880: @837401
     /*  837401 */   GIM_Try, /*On fail goto*//*Label 12881*/ GIMT_Encode4(837476), // Rule ID 22706 //
     /*  837406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  837423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  837455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837474 */     GIR_RootConstrainSelectedInstOperands,
     /*  837475 */     // GIR_Coverage, 22706,
     /*  837475 */     GIR_EraseRootFromParent_Done,
     /*  837476 */   // Label 12881: @837476
     /*  837476 */   GIM_Try, /*On fail goto*//*Label 12882*/ GIMT_Encode4(837551), // Rule ID 22707 //
     /*  837481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  837498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837527 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  837530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837549 */     GIR_RootConstrainSelectedInstOperands,
     /*  837550 */     // GIR_Coverage, 22707,
     /*  837550 */     GIR_EraseRootFromParent_Done,
     /*  837551 */   // Label 12882: @837551
     /*  837551 */   GIM_Try, /*On fail goto*//*Label 12883*/ GIMT_Encode4(837626), // Rule ID 22710 //
     /*  837556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  837573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837602 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  837605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837624 */     GIR_RootConstrainSelectedInstOperands,
     /*  837625 */     // GIR_Coverage, 22710,
     /*  837625 */     GIR_EraseRootFromParent_Done,
     /*  837626 */   // Label 12883: @837626
     /*  837626 */   GIM_Try, /*On fail goto*//*Label 12884*/ GIMT_Encode4(837701), // Rule ID 22711 //
     /*  837631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  837648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837677 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  837680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837699 */     GIR_RootConstrainSelectedInstOperands,
     /*  837700 */     // GIR_Coverage, 22711,
     /*  837700 */     GIR_EraseRootFromParent_Done,
     /*  837701 */   // Label 12884: @837701
     /*  837701 */   GIM_Try, /*On fail goto*//*Label 12885*/ GIMT_Encode4(837776), // Rule ID 22714 //
     /*  837706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  837723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  837752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  837755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837774 */     GIR_RootConstrainSelectedInstOperands,
     /*  837775 */     // GIR_Coverage, 22714,
     /*  837775 */     GIR_EraseRootFromParent_Done,
     /*  837776 */   // Label 12885: @837776
     /*  837776 */   GIM_Try, /*On fail goto*//*Label 12886*/ GIMT_Encode4(837851), // Rule ID 22715 //
     /*  837781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  837798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  837830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837849 */     GIR_RootConstrainSelectedInstOperands,
     /*  837850 */     // GIR_Coverage, 22715,
     /*  837850 */     GIR_EraseRootFromParent_Done,
     /*  837851 */   // Label 12886: @837851
     /*  837851 */   GIM_Try, /*On fail goto*//*Label 12887*/ GIMT_Encode4(837926), // Rule ID 22718 //
     /*  837856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  837873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  837902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  837905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837924 */     GIR_RootConstrainSelectedInstOperands,
     /*  837925 */     // GIR_Coverage, 22718,
     /*  837925 */     GIR_EraseRootFromParent_Done,
     /*  837926 */   // Label 12887: @837926
     /*  837926 */   GIM_Try, /*On fail goto*//*Label 12888*/ GIMT_Encode4(838001), // Rule ID 22719 //
     /*  837931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  837948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837977 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  837980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837999 */     GIR_RootConstrainSelectedInstOperands,
     /*  838000 */     // GIR_Coverage, 22719,
     /*  838000 */     GIR_EraseRootFromParent_Done,
     /*  838001 */   // Label 12888: @838001
     /*  838001 */   GIM_Try, /*On fail goto*//*Label 12889*/ GIMT_Encode4(838076), // Rule ID 22722 //
     /*  838006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  838023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  838052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  838055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  838071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838074 */     GIR_RootConstrainSelectedInstOperands,
     /*  838075 */     // GIR_Coverage, 22722,
     /*  838075 */     GIR_EraseRootFromParent_Done,
     /*  838076 */   // Label 12889: @838076
     /*  838076 */   GIM_Try, /*On fail goto*//*Label 12890*/ GIMT_Encode4(838151), // Rule ID 22723 //
     /*  838081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  838098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  838127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  838130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  838146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838149 */     GIR_RootConstrainSelectedInstOperands,
     /*  838150 */     // GIR_Coverage, 22723,
     /*  838150 */     GIR_EraseRootFromParent_Done,
     /*  838151 */   // Label 12890: @838151
     /*  838151 */   GIM_Try, /*On fail goto*//*Label 12891*/ GIMT_Encode4(838226), // Rule ID 22726 //
     /*  838156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  838173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  838205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838224 */     GIR_RootConstrainSelectedInstOperands,
     /*  838225 */     // GIR_Coverage, 22726,
     /*  838225 */     GIR_EraseRootFromParent_Done,
     /*  838226 */   // Label 12891: @838226
     /*  838226 */   GIM_Try, /*On fail goto*//*Label 12892*/ GIMT_Encode4(838301), // Rule ID 22727 //
     /*  838231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  838248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  838280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838299 */     GIR_RootConstrainSelectedInstOperands,
     /*  838300 */     // GIR_Coverage, 22727,
     /*  838300 */     GIR_EraseRootFromParent_Done,
     /*  838301 */   // Label 12892: @838301
     /*  838301 */   GIM_Try, /*On fail goto*//*Label 12893*/ GIMT_Encode4(838376), // Rule ID 22730 //
     /*  838306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  838323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  838355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838374 */     GIR_RootConstrainSelectedInstOperands,
     /*  838375 */     // GIR_Coverage, 22730,
     /*  838375 */     GIR_EraseRootFromParent_Done,
     /*  838376 */   // Label 12893: @838376
     /*  838376 */   GIM_Try, /*On fail goto*//*Label 12894*/ GIMT_Encode4(838451), // Rule ID 22731 //
     /*  838381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  838398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838427 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  838430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838449 */     GIR_RootConstrainSelectedInstOperands,
     /*  838450 */     // GIR_Coverage, 22731,
     /*  838450 */     GIR_EraseRootFromParent_Done,
     /*  838451 */   // Label 12894: @838451
     /*  838451 */   GIM_Try, /*On fail goto*//*Label 12895*/ GIMT_Encode4(838526), // Rule ID 22734 //
     /*  838456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  838473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  838505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838524 */     GIR_RootConstrainSelectedInstOperands,
     /*  838525 */     // GIR_Coverage, 22734,
     /*  838525 */     GIR_EraseRootFromParent_Done,
     /*  838526 */   // Label 12895: @838526
     /*  838526 */   GIM_Try, /*On fail goto*//*Label 12896*/ GIMT_Encode4(838601), // Rule ID 22735 //
     /*  838531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  838548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838577 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  838580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838599 */     GIR_RootConstrainSelectedInstOperands,
     /*  838600 */     // GIR_Coverage, 22735,
     /*  838600 */     GIR_EraseRootFromParent_Done,
     /*  838601 */   // Label 12896: @838601
     /*  838601 */   GIM_Try, /*On fail goto*//*Label 12897*/ GIMT_Encode4(838676), // Rule ID 22738 //
     /*  838606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  838623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  838655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838674 */     GIR_RootConstrainSelectedInstOperands,
     /*  838675 */     // GIR_Coverage, 22738,
     /*  838675 */     GIR_EraseRootFromParent_Done,
     /*  838676 */   // Label 12897: @838676
     /*  838676 */   GIM_Try, /*On fail goto*//*Label 12898*/ GIMT_Encode4(838751), // Rule ID 22739 //
     /*  838681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  838698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  838730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838749 */     GIR_RootConstrainSelectedInstOperands,
     /*  838750 */     // GIR_Coverage, 22739,
     /*  838750 */     GIR_EraseRootFromParent_Done,
     /*  838751 */   // Label 12898: @838751
     /*  838751 */   GIM_Try, /*On fail goto*//*Label 12899*/ GIMT_Encode4(838826), // Rule ID 22742 //
     /*  838756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  838773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  838805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838824 */     GIR_RootConstrainSelectedInstOperands,
     /*  838825 */     // GIR_Coverage, 22742,
     /*  838825 */     GIR_EraseRootFromParent_Done,
     /*  838826 */   // Label 12899: @838826
     /*  838826 */   GIM_Try, /*On fail goto*//*Label 12900*/ GIMT_Encode4(838901), // Rule ID 22743 //
     /*  838831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  838848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838877 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  838880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838899 */     GIR_RootConstrainSelectedInstOperands,
     /*  838900 */     // GIR_Coverage, 22743,
     /*  838900 */     GIR_EraseRootFromParent_Done,
     /*  838901 */   // Label 12900: @838901
     /*  838901 */   GIM_Try, /*On fail goto*//*Label 12901*/ GIMT_Encode4(838976), // Rule ID 22746 //
     /*  838906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  838923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  838955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838974 */     GIR_RootConstrainSelectedInstOperands,
     /*  838975 */     // GIR_Coverage, 22746,
     /*  838975 */     GIR_EraseRootFromParent_Done,
     /*  838976 */   // Label 12901: @838976
     /*  838976 */   GIM_Try, /*On fail goto*//*Label 12902*/ GIMT_Encode4(839051), // Rule ID 22747 //
     /*  838981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  838998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839027 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  839030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839049 */     GIR_RootConstrainSelectedInstOperands,
     /*  839050 */     // GIR_Coverage, 22747,
     /*  839050 */     GIR_EraseRootFromParent_Done,
     /*  839051 */   // Label 12902: @839051
     /*  839051 */   GIM_Try, /*On fail goto*//*Label 12903*/ GIMT_Encode4(839126), // Rule ID 22750 //
     /*  839056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  839073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  839102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  839105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  839121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839124 */     GIR_RootConstrainSelectedInstOperands,
     /*  839125 */     // GIR_Coverage, 22750,
     /*  839125 */     GIR_EraseRootFromParent_Done,
     /*  839126 */   // Label 12903: @839126
     /*  839126 */   GIM_Try, /*On fail goto*//*Label 12904*/ GIMT_Encode4(839201), // Rule ID 22751 //
     /*  839131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  839148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839177 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  839177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  839180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  839196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839199 */     GIR_RootConstrainSelectedInstOperands,
     /*  839200 */     // GIR_Coverage, 22751,
     /*  839200 */     GIR_EraseRootFromParent_Done,
     /*  839201 */   // Label 12904: @839201
     /*  839201 */   GIM_Try, /*On fail goto*//*Label 12905*/ GIMT_Encode4(839276), // Rule ID 22754 //
     /*  839206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  839223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  839252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  839255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  839271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839274 */     GIR_RootConstrainSelectedInstOperands,
     /*  839275 */     // GIR_Coverage, 22754,
     /*  839275 */     GIR_EraseRootFromParent_Done,
     /*  839276 */   // Label 12905: @839276
     /*  839276 */   GIM_Try, /*On fail goto*//*Label 12906*/ GIMT_Encode4(839351), // Rule ID 22755 //
     /*  839281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  839298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  839327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  839330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  839346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839349 */     GIR_RootConstrainSelectedInstOperands,
     /*  839350 */     // GIR_Coverage, 22755,
     /*  839350 */     GIR_EraseRootFromParent_Done,
     /*  839351 */   // Label 12906: @839351
     /*  839351 */   GIM_Try, /*On fail goto*//*Label 12907*/ GIMT_Encode4(839426), // Rule ID 22758 //
     /*  839356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  839373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  839402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  839405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  839421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839424 */     GIR_RootConstrainSelectedInstOperands,
     /*  839425 */     // GIR_Coverage, 22758,
     /*  839425 */     GIR_EraseRootFromParent_Done,
     /*  839426 */   // Label 12907: @839426
     /*  839426 */   GIM_Try, /*On fail goto*//*Label 12908*/ GIMT_Encode4(839501), // Rule ID 22759 //
     /*  839431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  839448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  839477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  839480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  839496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839499 */     GIR_RootConstrainSelectedInstOperands,
     /*  839500 */     // GIR_Coverage, 22759,
     /*  839500 */     GIR_EraseRootFromParent_Done,
     /*  839501 */   // Label 12908: @839501
     /*  839501 */   GIM_Try, /*On fail goto*//*Label 12909*/ GIMT_Encode4(839576), // Rule ID 22762 //
     /*  839506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  839523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  839555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839574 */     GIR_RootConstrainSelectedInstOperands,
     /*  839575 */     // GIR_Coverage, 22762,
     /*  839575 */     GIR_EraseRootFromParent_Done,
     /*  839576 */   // Label 12909: @839576
     /*  839576 */   GIM_Try, /*On fail goto*//*Label 12910*/ GIMT_Encode4(839651), // Rule ID 22763 //
     /*  839581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  839598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839627 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  839630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839649 */     GIR_RootConstrainSelectedInstOperands,
     /*  839650 */     // GIR_Coverage, 22763,
     /*  839650 */     GIR_EraseRootFromParent_Done,
     /*  839651 */   // Label 12910: @839651
     /*  839651 */   GIM_Try, /*On fail goto*//*Label 12911*/ GIMT_Encode4(839726), // Rule ID 22766 //
     /*  839656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  839673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  839705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839724 */     GIR_RootConstrainSelectedInstOperands,
     /*  839725 */     // GIR_Coverage, 22766,
     /*  839725 */     GIR_EraseRootFromParent_Done,
     /*  839726 */   // Label 12911: @839726
     /*  839726 */   GIM_Try, /*On fail goto*//*Label 12912*/ GIMT_Encode4(839801), // Rule ID 22767 //
     /*  839731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  839748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839777 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  839780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839799 */     GIR_RootConstrainSelectedInstOperands,
     /*  839800 */     // GIR_Coverage, 22767,
     /*  839800 */     GIR_EraseRootFromParent_Done,
     /*  839801 */   // Label 12912: @839801
     /*  839801 */   GIM_Try, /*On fail goto*//*Label 12913*/ GIMT_Encode4(839876), // Rule ID 22770 //
     /*  839806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  839823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  839855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839874 */     GIR_RootConstrainSelectedInstOperands,
     /*  839875 */     // GIR_Coverage, 22770,
     /*  839875 */     GIR_EraseRootFromParent_Done,
     /*  839876 */   // Label 12913: @839876
     /*  839876 */   GIM_Try, /*On fail goto*//*Label 12914*/ GIMT_Encode4(839951), // Rule ID 22771 //
     /*  839881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  839898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839927 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  839930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839949 */     GIR_RootConstrainSelectedInstOperands,
     /*  839950 */     // GIR_Coverage, 22771,
     /*  839950 */     GIR_EraseRootFromParent_Done,
     /*  839951 */   // Label 12914: @839951
     /*  839951 */   GIM_Try, /*On fail goto*//*Label 12915*/ GIMT_Encode4(840026), // Rule ID 22774 //
     /*  839956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  839973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  840002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  840005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840024 */     GIR_RootConstrainSelectedInstOperands,
     /*  840025 */     // GIR_Coverage, 22774,
     /*  840025 */     GIR_EraseRootFromParent_Done,
     /*  840026 */   // Label 12915: @840026
     /*  840026 */   GIM_Try, /*On fail goto*//*Label 12916*/ GIMT_Encode4(840101), // Rule ID 22775 //
     /*  840031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  840048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840077 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  840077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  840080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840099 */     GIR_RootConstrainSelectedInstOperands,
     /*  840100 */     // GIR_Coverage, 22775,
     /*  840100 */     GIR_EraseRootFromParent_Done,
     /*  840101 */   // Label 12916: @840101
     /*  840101 */   GIM_Try, /*On fail goto*//*Label 12917*/ GIMT_Encode4(840176), // Rule ID 22778 //
     /*  840106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  840123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  840155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840174 */     GIR_RootConstrainSelectedInstOperands,
     /*  840175 */     // GIR_Coverage, 22778,
     /*  840175 */     GIR_EraseRootFromParent_Done,
     /*  840176 */   // Label 12917: @840176
     /*  840176 */   GIM_Try, /*On fail goto*//*Label 12918*/ GIMT_Encode4(840251), // Rule ID 22779 //
     /*  840181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  840198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840227 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  840230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840249 */     GIR_RootConstrainSelectedInstOperands,
     /*  840250 */     // GIR_Coverage, 22779,
     /*  840250 */     GIR_EraseRootFromParent_Done,
     /*  840251 */   // Label 12918: @840251
     /*  840251 */   GIM_Try, /*On fail goto*//*Label 12919*/ GIMT_Encode4(840326), // Rule ID 22782 //
     /*  840256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  840273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840302 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  840302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  840305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840324 */     GIR_RootConstrainSelectedInstOperands,
     /*  840325 */     // GIR_Coverage, 22782,
     /*  840325 */     GIR_EraseRootFromParent_Done,
     /*  840326 */   // Label 12919: @840326
     /*  840326 */   GIM_Try, /*On fail goto*//*Label 12920*/ GIMT_Encode4(840401), // Rule ID 22783 //
     /*  840331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  840348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840377 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  840377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  840380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840399 */     GIR_RootConstrainSelectedInstOperands,
     /*  840400 */     // GIR_Coverage, 22783,
     /*  840400 */     GIR_EraseRootFromParent_Done,
     /*  840401 */   // Label 12920: @840401
     /*  840401 */   GIM_Try, /*On fail goto*//*Label 12921*/ GIMT_Encode4(840476), // Rule ID 22786 //
     /*  840406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  840423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  840452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  840455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840474 */     GIR_RootConstrainSelectedInstOperands,
     /*  840475 */     // GIR_Coverage, 22786,
     /*  840475 */     GIR_EraseRootFromParent_Done,
     /*  840476 */   // Label 12921: @840476
     /*  840476 */   GIM_Try, /*On fail goto*//*Label 12922*/ GIMT_Encode4(840551), // Rule ID 22787 //
     /*  840481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  840498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840527 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  840527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  840530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840549 */     GIR_RootConstrainSelectedInstOperands,
     /*  840550 */     // GIR_Coverage, 22787,
     /*  840550 */     GIR_EraseRootFromParent_Done,
     /*  840551 */   // Label 12922: @840551
     /*  840551 */   GIM_Try, /*On fail goto*//*Label 12923*/ GIMT_Encode4(840626), // Rule ID 22790 //
     /*  840556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  840573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  840602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  840605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840624 */     GIR_RootConstrainSelectedInstOperands,
     /*  840625 */     // GIR_Coverage, 22790,
     /*  840625 */     GIR_EraseRootFromParent_Done,
     /*  840626 */   // Label 12923: @840626
     /*  840626 */   GIM_Try, /*On fail goto*//*Label 12924*/ GIMT_Encode4(840701), // Rule ID 22791 //
     /*  840631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  840648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840677 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  840677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  840680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840699 */     GIR_RootConstrainSelectedInstOperands,
     /*  840700 */     // GIR_Coverage, 22791,
     /*  840700 */     GIR_EraseRootFromParent_Done,
     /*  840701 */   // Label 12924: @840701
     /*  840701 */   GIM_Try, /*On fail goto*//*Label 12925*/ GIMT_Encode4(840776), // Rule ID 22794 //
     /*  840706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  840723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  840752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  840755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840774 */     GIR_RootConstrainSelectedInstOperands,
     /*  840775 */     // GIR_Coverage, 22794,
     /*  840775 */     GIR_EraseRootFromParent_Done,
     /*  840776 */   // Label 12925: @840776
     /*  840776 */   GIM_Try, /*On fail goto*//*Label 12926*/ GIMT_Encode4(840851), // Rule ID 22795 //
     /*  840781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  840798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  840827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  840830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840849 */     GIR_RootConstrainSelectedInstOperands,
     /*  840850 */     // GIR_Coverage, 22795,
     /*  840850 */     GIR_EraseRootFromParent_Done,
     /*  840851 */   // Label 12926: @840851
     /*  840851 */   GIM_Try, /*On fail goto*//*Label 12927*/ GIMT_Encode4(840926), // Rule ID 22798 //
     /*  840856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  840873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  840905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840924 */     GIR_RootConstrainSelectedInstOperands,
     /*  840925 */     // GIR_Coverage, 22798,
     /*  840925 */     GIR_EraseRootFromParent_Done,
     /*  840926 */   // Label 12927: @840926
     /*  840926 */   GIM_Try, /*On fail goto*//*Label 12928*/ GIMT_Encode4(841001), // Rule ID 22799 //
     /*  840931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  840948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840977 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  840980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840999 */     GIR_RootConstrainSelectedInstOperands,
     /*  841000 */     // GIR_Coverage, 22799,
     /*  841000 */     GIR_EraseRootFromParent_Done,
     /*  841001 */   // Label 12928: @841001
     /*  841001 */   GIM_Try, /*On fail goto*//*Label 12929*/ GIMT_Encode4(841076), // Rule ID 22802 //
     /*  841006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  841055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841074 */     GIR_RootConstrainSelectedInstOperands,
     /*  841075 */     // GIR_Coverage, 22802,
     /*  841075 */     GIR_EraseRootFromParent_Done,
     /*  841076 */   // Label 12929: @841076
     /*  841076 */   GIM_Try, /*On fail goto*//*Label 12930*/ GIMT_Encode4(841151), // Rule ID 22803 //
     /*  841081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841127 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  841130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841149 */     GIR_RootConstrainSelectedInstOperands,
     /*  841150 */     // GIR_Coverage, 22803,
     /*  841150 */     GIR_EraseRootFromParent_Done,
     /*  841151 */   // Label 12930: @841151
     /*  841151 */   GIM_Try, /*On fail goto*//*Label 12931*/ GIMT_Encode4(841226), // Rule ID 22806 //
     /*  841156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  841205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841224 */     GIR_RootConstrainSelectedInstOperands,
     /*  841225 */     // GIR_Coverage, 22806,
     /*  841225 */     GIR_EraseRootFromParent_Done,
     /*  841226 */   // Label 12931: @841226
     /*  841226 */   GIM_Try, /*On fail goto*//*Label 12932*/ GIMT_Encode4(841301), // Rule ID 22807 //
     /*  841231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  841280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841299 */     GIR_RootConstrainSelectedInstOperands,
     /*  841300 */     // GIR_Coverage, 22807,
     /*  841300 */     GIR_EraseRootFromParent_Done,
     /*  841301 */   // Label 12932: @841301
     /*  841301 */   GIM_Try, /*On fail goto*//*Label 12933*/ GIMT_Encode4(841376), // Rule ID 22810 //
     /*  841306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  841323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  841355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841374 */     GIR_RootConstrainSelectedInstOperands,
     /*  841375 */     // GIR_Coverage, 22810,
     /*  841375 */     GIR_EraseRootFromParent_Done,
     /*  841376 */   // Label 12933: @841376
     /*  841376 */   GIM_Try, /*On fail goto*//*Label 12934*/ GIMT_Encode4(841451), // Rule ID 22811 //
     /*  841381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  841398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841427 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  841430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841449 */     GIR_RootConstrainSelectedInstOperands,
     /*  841450 */     // GIR_Coverage, 22811,
     /*  841450 */     GIR_EraseRootFromParent_Done,
     /*  841451 */   // Label 12934: @841451
     /*  841451 */   GIM_Try, /*On fail goto*//*Label 12935*/ GIMT_Encode4(841526), // Rule ID 22814 //
     /*  841456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  841473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  841505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841524 */     GIR_RootConstrainSelectedInstOperands,
     /*  841525 */     // GIR_Coverage, 22814,
     /*  841525 */     GIR_EraseRootFromParent_Done,
     /*  841526 */   // Label 12935: @841526
     /*  841526 */   GIM_Try, /*On fail goto*//*Label 12936*/ GIMT_Encode4(841601), // Rule ID 22815 //
     /*  841531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  841548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841577 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  841580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841599 */     GIR_RootConstrainSelectedInstOperands,
     /*  841600 */     // GIR_Coverage, 22815,
     /*  841600 */     GIR_EraseRootFromParent_Done,
     /*  841601 */   // Label 12936: @841601
     /*  841601 */   GIM_Try, /*On fail goto*//*Label 12937*/ GIMT_Encode4(841676), // Rule ID 22818 //
     /*  841606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  841623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  841655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841674 */     GIR_RootConstrainSelectedInstOperands,
     /*  841675 */     // GIR_Coverage, 22818,
     /*  841675 */     GIR_EraseRootFromParent_Done,
     /*  841676 */   // Label 12937: @841676
     /*  841676 */   GIM_Try, /*On fail goto*//*Label 12938*/ GIMT_Encode4(841751), // Rule ID 22819 //
     /*  841681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  841698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  841730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841749 */     GIR_RootConstrainSelectedInstOperands,
     /*  841750 */     // GIR_Coverage, 22819,
     /*  841750 */     GIR_EraseRootFromParent_Done,
     /*  841751 */   // Label 12938: @841751
     /*  841751 */   GIM_Try, /*On fail goto*//*Label 12939*/ GIMT_Encode4(841826), // Rule ID 22938 //
     /*  841756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  841764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  841773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841802 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  841805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841824 */     GIR_RootConstrainSelectedInstOperands,
     /*  841825 */     // GIR_Coverage, 22938,
     /*  841825 */     GIR_EraseRootFromParent_Done,
     /*  841826 */   // Label 12939: @841826
     /*  841826 */   GIM_Try, /*On fail goto*//*Label 12940*/ GIMT_Encode4(841901), // Rule ID 22939 //
     /*  841831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  841839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  841848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841877 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  841880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841899 */     GIR_RootConstrainSelectedInstOperands,
     /*  841900 */     // GIR_Coverage, 22939,
     /*  841900 */     GIR_EraseRootFromParent_Done,
     /*  841901 */   // Label 12940: @841901
     /*  841901 */   GIM_Try, /*On fail goto*//*Label 12941*/ GIMT_Encode4(841976), // Rule ID 22942 //
     /*  841906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  841914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  841923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841952 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  841955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841974 */     GIR_RootConstrainSelectedInstOperands,
     /*  841975 */     // GIR_Coverage, 22942,
     /*  841975 */     GIR_EraseRootFromParent_Done,
     /*  841976 */   // Label 12941: @841976
     /*  841976 */   GIM_Try, /*On fail goto*//*Label 12942*/ GIMT_Encode4(842051), // Rule ID 22943 //
     /*  841981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  841989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  841998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842027 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  842027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  842030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842049 */     GIR_RootConstrainSelectedInstOperands,
     /*  842050 */     // GIR_Coverage, 22943,
     /*  842050 */     GIR_EraseRootFromParent_Done,
     /*  842051 */   // Label 12942: @842051
     /*  842051 */   GIM_Try, /*On fail goto*//*Label 12943*/ GIMT_Encode4(842126), // Rule ID 22946 //
     /*  842056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  842059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  842073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842102 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  842102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  842105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842124 */     GIR_RootConstrainSelectedInstOperands,
     /*  842125 */     // GIR_Coverage, 22946,
     /*  842125 */     GIR_EraseRootFromParent_Done,
     /*  842126 */   // Label 12943: @842126
     /*  842126 */   GIM_Try, /*On fail goto*//*Label 12944*/ GIMT_Encode4(842201), // Rule ID 22947 //
     /*  842131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  842134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  842148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842177 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  842177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  842180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842199 */     GIR_RootConstrainSelectedInstOperands,
     /*  842200 */     // GIR_Coverage, 22947,
     /*  842200 */     GIR_EraseRootFromParent_Done,
     /*  842201 */   // Label 12944: @842201
     /*  842201 */   GIM_Try, /*On fail goto*//*Label 12945*/ GIMT_Encode4(842276), // Rule ID 22950 //
     /*  842206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  842209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  842223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842252 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  842252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  842255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842274 */     GIR_RootConstrainSelectedInstOperands,
     /*  842275 */     // GIR_Coverage, 22950,
     /*  842275 */     GIR_EraseRootFromParent_Done,
     /*  842276 */   // Label 12945: @842276
     /*  842276 */   GIM_Try, /*On fail goto*//*Label 12946*/ GIMT_Encode4(842351), // Rule ID 22951 //
     /*  842281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  842284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  842298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842327 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  842327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  842330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842349 */     GIR_RootConstrainSelectedInstOperands,
     /*  842350 */     // GIR_Coverage, 22951,
     /*  842350 */     GIR_EraseRootFromParent_Done,
     /*  842351 */   // Label 12946: @842351
     /*  842351 */   GIM_Try, /*On fail goto*//*Label 12947*/ GIMT_Encode4(842426), // Rule ID 22954 //
     /*  842356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  842359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  842373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842402 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  842402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  842405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842424 */     GIR_RootConstrainSelectedInstOperands,
     /*  842425 */     // GIR_Coverage, 22954,
     /*  842425 */     GIR_EraseRootFromParent_Done,
     /*  842426 */   // Label 12947: @842426
     /*  842426 */   GIM_Try, /*On fail goto*//*Label 12948*/ GIMT_Encode4(842501), // Rule ID 22955 //
     /*  842431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  842434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  842448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842477 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  842477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  842480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842499 */     GIR_RootConstrainSelectedInstOperands,
     /*  842500 */     // GIR_Coverage, 22955,
     /*  842500 */     GIR_EraseRootFromParent_Done,
     /*  842501 */   // Label 12948: @842501
     /*  842501 */   GIM_Try, /*On fail goto*//*Label 12949*/ GIMT_Encode4(842576), // Rule ID 22958 //
     /*  842506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  842509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  842523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842552 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  842555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842574 */     GIR_RootConstrainSelectedInstOperands,
     /*  842575 */     // GIR_Coverage, 22958,
     /*  842575 */     GIR_EraseRootFromParent_Done,
     /*  842576 */   // Label 12949: @842576
     /*  842576 */   GIM_Try, /*On fail goto*//*Label 12950*/ GIMT_Encode4(842651), // Rule ID 22959 //
     /*  842581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  842598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842627 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  842630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842649 */     GIR_RootConstrainSelectedInstOperands,
     /*  842650 */     // GIR_Coverage, 22959,
     /*  842650 */     GIR_EraseRootFromParent_Done,
     /*  842651 */   // Label 12950: @842651
     /*  842651 */   GIM_Try, /*On fail goto*//*Label 12951*/ GIMT_Encode4(842726), // Rule ID 22962 //
     /*  842656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  842659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  842673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842702 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  842702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  842705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842724 */     GIR_RootConstrainSelectedInstOperands,
     /*  842725 */     // GIR_Coverage, 22962,
     /*  842725 */     GIR_EraseRootFromParent_Done,
     /*  842726 */   // Label 12951: @842726
     /*  842726 */   GIM_Try, /*On fail goto*//*Label 12952*/ GIMT_Encode4(842801), // Rule ID 22963 //
     /*  842731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  842734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  842748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842777 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  842777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  842780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842799 */     GIR_RootConstrainSelectedInstOperands,
     /*  842800 */     // GIR_Coverage, 22963,
     /*  842800 */     GIR_EraseRootFromParent_Done,
     /*  842801 */   // Label 12952: @842801
     /*  842801 */   GIM_Try, /*On fail goto*//*Label 12953*/ GIMT_Encode4(842876), // Rule ID 22966 //
     /*  842806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  842809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  842823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842852 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  842852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  842855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842874 */     GIR_RootConstrainSelectedInstOperands,
     /*  842875 */     // GIR_Coverage, 22966,
     /*  842875 */     GIR_EraseRootFromParent_Done,
     /*  842876 */   // Label 12953: @842876
     /*  842876 */   GIM_Try, /*On fail goto*//*Label 12954*/ GIMT_Encode4(842951), // Rule ID 22967 //
     /*  842881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  842884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  842898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842927 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  842927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  842930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842949 */     GIR_RootConstrainSelectedInstOperands,
     /*  842950 */     // GIR_Coverage, 22967,
     /*  842950 */     GIR_EraseRootFromParent_Done,
     /*  842951 */   // Label 12954: @842951
     /*  842951 */   GIM_Try, /*On fail goto*//*Label 12955*/ GIMT_Encode4(843026), // Rule ID 22970 //
     /*  842956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  842959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  842973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843002 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  843002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  843005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  843021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843024 */     GIR_RootConstrainSelectedInstOperands,
     /*  843025 */     // GIR_Coverage, 22970,
     /*  843025 */     GIR_EraseRootFromParent_Done,
     /*  843026 */   // Label 12955: @843026
     /*  843026 */   GIM_Try, /*On fail goto*//*Label 12956*/ GIMT_Encode4(843101), // Rule ID 22971 //
     /*  843031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  843034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  843042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  843045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  843048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  843051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  843066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843077 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  843077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  843080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  843096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843099 */     GIR_RootConstrainSelectedInstOperands,
     /*  843100 */     // GIR_Coverage, 22971,
     /*  843100 */     GIR_EraseRootFromParent_Done,
     /*  843101 */   // Label 12956: @843101
     /*  843101 */   GIM_Try, /*On fail goto*//*Label 12957*/ GIMT_Encode4(843176), // Rule ID 22974 //
     /*  843106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  843109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  843117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  843120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  843123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  843126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  843141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843152 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  843152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  843155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843174 */     GIR_RootConstrainSelectedInstOperands,
     /*  843175 */     // GIR_Coverage, 22974,
     /*  843175 */     GIR_EraseRootFromParent_Done,
     /*  843176 */   // Label 12957: @843176
     /*  843176 */   GIM_Try, /*On fail goto*//*Label 12958*/ GIMT_Encode4(843251), // Rule ID 22975 //
     /*  843181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  843184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  843192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  843195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  843198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  843201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  843216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843227 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  843227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  843230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843249 */     GIR_RootConstrainSelectedInstOperands,
     /*  843250 */     // GIR_Coverage, 22975,
     /*  843250 */     GIR_EraseRootFromParent_Done,
     /*  843251 */   // Label 12958: @843251
     /*  843251 */   GIM_Try, /*On fail goto*//*Label 12959*/ GIMT_Encode4(843326), // Rule ID 22978 //
     /*  843256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  843259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  843267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  843270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  843273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  843276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  843291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843302 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  843302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  843305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843324 */     GIR_RootConstrainSelectedInstOperands,
     /*  843325 */     // GIR_Coverage, 22978,
     /*  843325 */     GIR_EraseRootFromParent_Done,
     /*  843326 */   // Label 12959: @843326
     /*  843326 */   GIM_Try, /*On fail goto*//*Label 12960*/ GIMT_Encode4(843401), // Rule ID 22979 //
     /*  843331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  843334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  843342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  843345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  843348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  843351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  843366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843377 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  843377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  843380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843399 */     GIR_RootConstrainSelectedInstOperands,
     /*  843400 */     // GIR_Coverage, 22979,
     /*  843400 */     GIR_EraseRootFromParent_Done,
     /*  843401 */   // Label 12960: @843401
     /*  843401 */   GIM_Try, /*On fail goto*//*Label 12961*/ GIMT_Encode4(843476), // Rule ID 22982 //
     /*  843406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  843409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  843417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  843420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  843423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  843426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  843441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843452 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  843452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  843455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843474 */     GIR_RootConstrainSelectedInstOperands,
     /*  843475 */     // GIR_Coverage, 22982,
     /*  843475 */     GIR_EraseRootFromParent_Done,
     /*  843476 */   // Label 12961: @843476
     /*  843476 */   GIM_Try, /*On fail goto*//*Label 12962*/ GIMT_Encode4(843551), // Rule ID 22983 //
     /*  843481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  843484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  843492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  843495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  843498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  843501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  843516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843527 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  843527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  843530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843549 */     GIR_RootConstrainSelectedInstOperands,
     /*  843550 */     // GIR_Coverage, 22983,
     /*  843550 */     GIR_EraseRootFromParent_Done,
     /*  843551 */   // Label 12962: @843551
     /*  843551 */   GIM_Try, /*On fail goto*//*Label 12963*/ GIMT_Encode4(843626), // Rule ID 22986 //
     /*  843556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  843559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  843567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  843570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  843573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  843576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  843591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843602 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  843602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  843605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  843621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843624 */     GIR_RootConstrainSelectedInstOperands,
     /*  843625 */     // GIR_Coverage, 22986,
     /*  843625 */     GIR_EraseRootFromParent_Done,
     /*  843626 */   // Label 12963: @843626
     /*  843626 */   GIM_Try, /*On fail goto*//*Label 12964*/ GIMT_Encode4(843701), // Rule ID 22987 //
     /*  843631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  843634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  843642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  843645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  843648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  843651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  843666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843677 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  843677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  843680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  843696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843699 */     GIR_RootConstrainSelectedInstOperands,
     /*  843700 */     // GIR_Coverage, 22987,
     /*  843700 */     GIR_EraseRootFromParent_Done,
     /*  843701 */   // Label 12964: @843701
     /*  843701 */   GIM_Try, /*On fail goto*//*Label 12965*/ GIMT_Encode4(843776), // Rule ID 22990 //
     /*  843706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  843709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  843717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  843720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  843723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  843726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  843741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843752 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  843752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  843755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  843771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843774 */     GIR_RootConstrainSelectedInstOperands,
     /*  843775 */     // GIR_Coverage, 22990,
     /*  843775 */     GIR_EraseRootFromParent_Done,
     /*  843776 */   // Label 12965: @843776
     /*  843776 */   GIM_Try, /*On fail goto*//*Label 12966*/ GIMT_Encode4(843851), // Rule ID 22991 //
     /*  843781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  843784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  843792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  843795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  843798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  843801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  843816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843827 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  843827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  843830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  843846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843849 */     GIR_RootConstrainSelectedInstOperands,
     /*  843850 */     // GIR_Coverage, 22991,
     /*  843850 */     GIR_EraseRootFromParent_Done,
     /*  843851 */   // Label 12966: @843851
     /*  843851 */   GIM_Try, /*On fail goto*//*Label 12967*/ GIMT_Encode4(843926), // Rule ID 22994 //
     /*  843856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  843859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  843867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  843870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  843873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  843876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  843891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843902 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  843902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  843905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  843921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843924 */     GIR_RootConstrainSelectedInstOperands,
     /*  843925 */     // GIR_Coverage, 22994,
     /*  843925 */     GIR_EraseRootFromParent_Done,
     /*  843926 */   // Label 12967: @843926
     /*  843926 */   GIM_Try, /*On fail goto*//*Label 12968*/ GIMT_Encode4(844001), // Rule ID 22995 //
     /*  843931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  843934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  843942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  843945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  843948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  843951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  843966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843977 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  843977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  843980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  843996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843999 */     GIR_RootConstrainSelectedInstOperands,
     /*  844000 */     // GIR_Coverage, 22995,
     /*  844000 */     GIR_EraseRootFromParent_Done,
     /*  844001 */   // Label 12968: @844001
     /*  844001 */   GIM_Try, /*On fail goto*//*Label 12969*/ GIMT_Encode4(844076), // Rule ID 22998 //
     /*  844006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  844009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  844023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844052 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  844052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  844055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844074 */     GIR_RootConstrainSelectedInstOperands,
     /*  844075 */     // GIR_Coverage, 22998,
     /*  844075 */     GIR_EraseRootFromParent_Done,
     /*  844076 */   // Label 12969: @844076
     /*  844076 */   GIM_Try, /*On fail goto*//*Label 12970*/ GIMT_Encode4(844151), // Rule ID 22999 //
     /*  844081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  844084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  844098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844127 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  844127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  844130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844149 */     GIR_RootConstrainSelectedInstOperands,
     /*  844150 */     // GIR_Coverage, 22999,
     /*  844150 */     GIR_EraseRootFromParent_Done,
     /*  844151 */   // Label 12970: @844151
     /*  844151 */   GIM_Try, /*On fail goto*//*Label 12971*/ GIMT_Encode4(844226), // Rule ID 23002 //
     /*  844156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  844159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  844173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844202 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  844202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  844205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844224 */     GIR_RootConstrainSelectedInstOperands,
     /*  844225 */     // GIR_Coverage, 23002,
     /*  844225 */     GIR_EraseRootFromParent_Done,
     /*  844226 */   // Label 12971: @844226
     /*  844226 */   GIM_Try, /*On fail goto*//*Label 12972*/ GIMT_Encode4(844301), // Rule ID 23003 //
     /*  844231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  844234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  844248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844277 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  844277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  844280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844299 */     GIR_RootConstrainSelectedInstOperands,
     /*  844300 */     // GIR_Coverage, 23003,
     /*  844300 */     GIR_EraseRootFromParent_Done,
     /*  844301 */   // Label 12972: @844301
     /*  844301 */   GIM_Try, /*On fail goto*//*Label 12973*/ GIMT_Encode4(844376), // Rule ID 23006 //
     /*  844306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  844309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  844317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  844320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  844323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  844326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844352 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  844352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  844355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  844371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844374 */     GIR_RootConstrainSelectedInstOperands,
     /*  844375 */     // GIR_Coverage, 23006,
     /*  844375 */     GIR_EraseRootFromParent_Done,
     /*  844376 */   // Label 12973: @844376
     /*  844376 */   GIM_Try, /*On fail goto*//*Label 12974*/ GIMT_Encode4(844451), // Rule ID 23007 //
     /*  844381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  844384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  844392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  844395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  844398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  844401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844427 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  844427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  844430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  844446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844449 */     GIR_RootConstrainSelectedInstOperands,
     /*  844450 */     // GIR_Coverage, 23007,
     /*  844450 */     GIR_EraseRootFromParent_Done,
     /*  844451 */   // Label 12974: @844451
     /*  844451 */   GIM_Try, /*On fail goto*//*Label 12975*/ GIMT_Encode4(844526), // Rule ID 23010 //
     /*  844456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  844459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  844473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844502 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  844502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  844505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844524 */     GIR_RootConstrainSelectedInstOperands,
     /*  844525 */     // GIR_Coverage, 23010,
     /*  844525 */     GIR_EraseRootFromParent_Done,
     /*  844526 */   // Label 12975: @844526
     /*  844526 */   GIM_Try, /*On fail goto*//*Label 12976*/ GIMT_Encode4(844601), // Rule ID 23011 //
     /*  844531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  844534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  844548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844577 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  844577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  844580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844599 */     GIR_RootConstrainSelectedInstOperands,
     /*  844600 */     // GIR_Coverage, 23011,
     /*  844600 */     GIR_EraseRootFromParent_Done,
     /*  844601 */   // Label 12976: @844601
     /*  844601 */   GIM_Try, /*On fail goto*//*Label 12977*/ GIMT_Encode4(844676), // Rule ID 23014 //
     /*  844606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  844609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  844617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  844620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  844623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  844626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844652 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  844652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  844655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  844671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844674 */     GIR_RootConstrainSelectedInstOperands,
     /*  844675 */     // GIR_Coverage, 23014,
     /*  844675 */     GIR_EraseRootFromParent_Done,
     /*  844676 */   // Label 12977: @844676
     /*  844676 */   GIM_Try, /*On fail goto*//*Label 12978*/ GIMT_Encode4(844751), // Rule ID 23015 //
     /*  844681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  844684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  844692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  844695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  844698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  844701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844727 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  844727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  844730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  844746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844749 */     GIR_RootConstrainSelectedInstOperands,
     /*  844750 */     // GIR_Coverage, 23015,
     /*  844750 */     GIR_EraseRootFromParent_Done,
     /*  844751 */   // Label 12978: @844751
     /*  844751 */   GIM_Try, /*On fail goto*//*Label 12979*/ GIMT_Encode4(844826), // Rule ID 23018 //
     /*  844756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  844759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  844767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  844770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  844773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  844776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844802 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  844802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  844805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  844821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844824 */     GIR_RootConstrainSelectedInstOperands,
     /*  844825 */     // GIR_Coverage, 23018,
     /*  844825 */     GIR_EraseRootFromParent_Done,
     /*  844826 */   // Label 12979: @844826
     /*  844826 */   GIM_Try, /*On fail goto*//*Label 12980*/ GIMT_Encode4(844901), // Rule ID 23019 //
     /*  844831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  844834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  844842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  844845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  844848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  844851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844877 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  844877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  844880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  844896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844899 */     GIR_RootConstrainSelectedInstOperands,
     /*  844900 */     // GIR_Coverage, 23019,
     /*  844900 */     GIR_EraseRootFromParent_Done,
     /*  844901 */   // Label 12980: @844901
     /*  844901 */   GIM_Try, /*On fail goto*//*Label 12981*/ GIMT_Encode4(844976), // Rule ID 23022 //
     /*  844906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  844909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  844923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  844941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844952 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  844952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  844955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844974 */     GIR_RootConstrainSelectedInstOperands,
     /*  844975 */     // GIR_Coverage, 23022,
     /*  844975 */     GIR_EraseRootFromParent_Done,
     /*  844976 */   // Label 12981: @844976
     /*  844976 */   GIM_Try, /*On fail goto*//*Label 12982*/ GIMT_Encode4(845051), // Rule ID 23023 //
     /*  844981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  844984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  844998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  845001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845027 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  845027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  845030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845049 */     GIR_RootConstrainSelectedInstOperands,
     /*  845050 */     // GIR_Coverage, 23023,
     /*  845050 */     GIR_EraseRootFromParent_Done,
     /*  845051 */   // Label 12982: @845051
     /*  845051 */   GIM_Try, /*On fail goto*//*Label 12983*/ GIMT_Encode4(845126), // Rule ID 23026 //
     /*  845056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  845059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  845067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  845070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  845073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  845076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  845102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  845105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845124 */     GIR_RootConstrainSelectedInstOperands,
     /*  845125 */     // GIR_Coverage, 23026,
     /*  845125 */     GIR_EraseRootFromParent_Done,
     /*  845126 */   // Label 12983: @845126
     /*  845126 */   GIM_Try, /*On fail goto*//*Label 12984*/ GIMT_Encode4(845201), // Rule ID 23027 //
     /*  845131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  845134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  845142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  845145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  845148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  845151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845177 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  845177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  845180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845199 */     GIR_RootConstrainSelectedInstOperands,
     /*  845200 */     // GIR_Coverage, 23027,
     /*  845200 */     GIR_EraseRootFromParent_Done,
     /*  845201 */   // Label 12984: @845201
     /*  845201 */   GIM_Try, /*On fail goto*//*Label 12985*/ GIMT_Encode4(845276), // Rule ID 23030 //
     /*  845206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  845209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  845217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  845220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  845223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  845226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  845241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845252 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  845252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  845255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845274 */     GIR_RootConstrainSelectedInstOperands,
     /*  845275 */     // GIR_Coverage, 23030,
     /*  845275 */     GIR_EraseRootFromParent_Done,
     /*  845276 */   // Label 12985: @845276
     /*  845276 */   GIM_Try, /*On fail goto*//*Label 12986*/ GIMT_Encode4(845351), // Rule ID 23031 //
     /*  845281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  845284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  845292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  845295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  845298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  845301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  845316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845327 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  845327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  845330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845349 */     GIR_RootConstrainSelectedInstOperands,
     /*  845350 */     // GIR_Coverage, 23031,
     /*  845350 */     GIR_EraseRootFromParent_Done,
     /*  845351 */   // Label 12986: @845351
     /*  845351 */   GIM_Try, /*On fail goto*//*Label 12987*/ GIMT_Encode4(845426), // Rule ID 23034 //
     /*  845356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  845359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  845373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  845376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845402 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  845402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  845405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845424 */     GIR_RootConstrainSelectedInstOperands,
     /*  845425 */     // GIR_Coverage, 23034,
     /*  845425 */     GIR_EraseRootFromParent_Done,
     /*  845426 */   // Label 12987: @845426
     /*  845426 */   GIM_Try, /*On fail goto*//*Label 12988*/ GIMT_Encode4(845501), // Rule ID 23035 //
     /*  845431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  845434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  845448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  845451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845477 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  845477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  845480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845499 */     GIR_RootConstrainSelectedInstOperands,
     /*  845500 */     // GIR_Coverage, 23035,
     /*  845500 */     GIR_EraseRootFromParent_Done,
     /*  845501 */   // Label 12988: @845501
     /*  845501 */   GIM_Try, /*On fail goto*//*Label 12989*/ GIMT_Encode4(845576), // Rule ID 23038 //
     /*  845506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  845509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  845523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  845526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845552 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  845552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  845555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845574 */     GIR_RootConstrainSelectedInstOperands,
     /*  845575 */     // GIR_Coverage, 23038,
     /*  845575 */     GIR_EraseRootFromParent_Done,
     /*  845576 */   // Label 12989: @845576
     /*  845576 */   GIM_Try, /*On fail goto*//*Label 12990*/ GIMT_Encode4(845651), // Rule ID 23039 //
     /*  845581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  845584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  845598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  845601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845627 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  845627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  845630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845649 */     GIR_RootConstrainSelectedInstOperands,
     /*  845650 */     // GIR_Coverage, 23039,
     /*  845650 */     GIR_EraseRootFromParent_Done,
     /*  845651 */   // Label 12990: @845651
     /*  845651 */   GIM_Try, /*On fail goto*//*Label 12991*/ GIMT_Encode4(845726), // Rule ID 23042 //
     /*  845656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  845659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  845673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  845676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  845691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845702 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  845702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  845705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845724 */     GIR_RootConstrainSelectedInstOperands,
     /*  845725 */     // GIR_Coverage, 23042,
     /*  845725 */     GIR_EraseRootFromParent_Done,
     /*  845726 */   // Label 12991: @845726
     /*  845726 */   GIM_Try, /*On fail goto*//*Label 12992*/ GIMT_Encode4(845801), // Rule ID 23043 //
     /*  845731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  845734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  845748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  845751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  845766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845777 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  845777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  845780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845799 */     GIR_RootConstrainSelectedInstOperands,
     /*  845800 */     // GIR_Coverage, 23043,
     /*  845800 */     GIR_EraseRootFromParent_Done,
     /*  845801 */   // Label 12992: @845801
     /*  845801 */   GIM_Try, /*On fail goto*//*Label 12993*/ GIMT_Encode4(845876), // Rule ID 23046 //
     /*  845806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  845809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  845817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  845820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  845823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  845826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845852 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  845852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  845855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  845871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845874 */     GIR_RootConstrainSelectedInstOperands,
     /*  845875 */     // GIR_Coverage, 23046,
     /*  845875 */     GIR_EraseRootFromParent_Done,
     /*  845876 */   // Label 12993: @845876
     /*  845876 */   GIM_Try, /*On fail goto*//*Label 12994*/ GIMT_Encode4(845951), // Rule ID 23047 //
     /*  845881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  845884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  845892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  845895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  845898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  845901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845927 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  845927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  845930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  845946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845949 */     GIR_RootConstrainSelectedInstOperands,
     /*  845950 */     // GIR_Coverage, 23047,
     /*  845950 */     GIR_EraseRootFromParent_Done,
     /*  845951 */   // Label 12994: @845951
     /*  845951 */   GIM_Try, /*On fail goto*//*Label 12995*/ GIMT_Encode4(846026), // Rule ID 23050 //
     /*  845956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  845959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  845967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  845970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  845973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  845976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846002 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  846002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  846005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  846009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846024 */     GIR_RootConstrainSelectedInstOperands,
     /*  846025 */     // GIR_Coverage, 23050,
     /*  846025 */     GIR_EraseRootFromParent_Done,
     /*  846026 */   // Label 12995: @846026
     /*  846026 */   GIM_Try, /*On fail goto*//*Label 12996*/ GIMT_Encode4(846101), // Rule ID 23051 //
     /*  846031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  846034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  846039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  846042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  846045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  846048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  846051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846077 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  846077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  846080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  846084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846099 */     GIR_RootConstrainSelectedInstOperands,
     /*  846100 */     // GIR_Coverage, 23051,
     /*  846100 */     GIR_EraseRootFromParent_Done,
     /*  846101 */   // Label 12996: @846101
     /*  846101 */   GIM_Try, /*On fail goto*//*Label 12997*/ GIMT_Encode4(846176), // Rule ID 23054 //
     /*  846106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  846109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  846114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  846117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  846120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  846123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  846126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846152 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  846152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  846155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  846159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846174 */     GIR_RootConstrainSelectedInstOperands,
     /*  846175 */     // GIR_Coverage, 23054,
     /*  846175 */     GIR_EraseRootFromParent_Done,
     /*  846176 */   // Label 12997: @846176
     /*  846176 */   GIM_Try, /*On fail goto*//*Label 12998*/ GIMT_Encode4(846251), // Rule ID 23055 //
     /*  846181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  846184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  846189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  846192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  846195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  846198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  846201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846227 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  846227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  846230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  846234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846249 */     GIR_RootConstrainSelectedInstOperands,
     /*  846250 */     // GIR_Coverage, 23055,
     /*  846250 */     GIR_EraseRootFromParent_Done,
     /*  846251 */   // Label 12998: @846251
     /*  846251 */   GIM_Try, /*On fail goto*//*Label 12999*/ GIMT_Encode4(846326), // Rule ID 23336 //
     /*  846256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  846259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  846267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  846270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  846273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  846276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846302 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  846302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  846305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846324 */     GIR_RootConstrainSelectedInstOperands,
     /*  846325 */     // GIR_Coverage, 23336,
     /*  846325 */     GIR_EraseRootFromParent_Done,
     /*  846326 */   // Label 12999: @846326
     /*  846326 */   GIM_Try, /*On fail goto*//*Label 13000*/ GIMT_Encode4(846401), // Rule ID 23337 //
     /*  846331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  846334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  846342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  846345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  846348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  846351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846377 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  846377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  846380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846386 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846399 */     GIR_RootConstrainSelectedInstOperands,
     /*  846400 */     // GIR_Coverage, 23337,
     /*  846400 */     GIR_EraseRootFromParent_Done,
     /*  846401 */   // Label 13000: @846401
     /*  846401 */   GIM_Try, /*On fail goto*//*Label 13001*/ GIMT_Encode4(846476), // Rule ID 23340 //
     /*  846406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  846409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  846417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  846420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  846423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  846426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846452 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  846452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  846455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846474 */     GIR_RootConstrainSelectedInstOperands,
     /*  846475 */     // GIR_Coverage, 23340,
     /*  846475 */     GIR_EraseRootFromParent_Done,
     /*  846476 */   // Label 13001: @846476
     /*  846476 */   GIM_Try, /*On fail goto*//*Label 13002*/ GIMT_Encode4(846551), // Rule ID 23341 //
     /*  846481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  846484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  846492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  846495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  846498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  846501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846527 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  846527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  846530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846549 */     GIR_RootConstrainSelectedInstOperands,
     /*  846550 */     // GIR_Coverage, 23341,
     /*  846550 */     GIR_EraseRootFromParent_Done,
     /*  846551 */   // Label 13002: @846551
     /*  846551 */   GIM_Try, /*On fail goto*//*Label 13003*/ GIMT_Encode4(846626), // Rule ID 23344 //
     /*  846556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  846559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  846567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  846570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  846573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  846576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846602 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  846602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  846605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846624 */     GIR_RootConstrainSelectedInstOperands,
     /*  846625 */     // GIR_Coverage, 23344,
     /*  846625 */     GIR_EraseRootFromParent_Done,
     /*  846626 */   // Label 13003: @846626
     /*  846626 */   GIM_Try, /*On fail goto*//*Label 13004*/ GIMT_Encode4(846701), // Rule ID 23345 //
     /*  846631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  846634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  846642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  846645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  846648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  846651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846677 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  846677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  846680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846686 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846699 */     GIR_RootConstrainSelectedInstOperands,
     /*  846700 */     // GIR_Coverage, 23345,
     /*  846700 */     GIR_EraseRootFromParent_Done,
     /*  846701 */   // Label 13004: @846701
     /*  846701 */   GIM_Try, /*On fail goto*//*Label 13005*/ GIMT_Encode4(846776), // Rule ID 23348 //
     /*  846706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  846709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  846717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  846720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  846723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  846726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846752 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  846752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  846755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846774 */     GIR_RootConstrainSelectedInstOperands,
     /*  846775 */     // GIR_Coverage, 23348,
     /*  846775 */     GIR_EraseRootFromParent_Done,
     /*  846776 */   // Label 13005: @846776
     /*  846776 */   GIM_Try, /*On fail goto*//*Label 13006*/ GIMT_Encode4(846851), // Rule ID 23349 //
     /*  846781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  846784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  846792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  846795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  846798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  846801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846827 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  846827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  846830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846849 */     GIR_RootConstrainSelectedInstOperands,
     /*  846850 */     // GIR_Coverage, 23349,
     /*  846850 */     GIR_EraseRootFromParent_Done,
     /*  846851 */   // Label 13006: @846851
     /*  846851 */   GIM_Try, /*On fail goto*//*Label 13007*/ GIMT_Encode4(846926), // Rule ID 23352 //
     /*  846856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  846859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  846867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  846870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  846873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  846876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846902 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  846902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  846905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846924 */     GIR_RootConstrainSelectedInstOperands,
     /*  846925 */     // GIR_Coverage, 23352,
     /*  846925 */     GIR_EraseRootFromParent_Done,
     /*  846926 */   // Label 13007: @846926
     /*  846926 */   GIM_Try, /*On fail goto*//*Label 13008*/ GIMT_Encode4(847001), // Rule ID 23353 //
     /*  846931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  846934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  846942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  846945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  846948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  846951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846977 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  846977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  846980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846986 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846999 */     GIR_RootConstrainSelectedInstOperands,
     /*  847000 */     // GIR_Coverage, 23353,
     /*  847000 */     GIR_EraseRootFromParent_Done,
     /*  847001 */   // Label 13008: @847001
     /*  847001 */   GIM_Try, /*On fail goto*//*Label 13009*/ GIMT_Encode4(847076), // Rule ID 23356 //
     /*  847006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  847014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  847017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  847020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  847023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  847026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847052 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  847055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847074 */     GIR_RootConstrainSelectedInstOperands,
     /*  847075 */     // GIR_Coverage, 23356,
     /*  847075 */     GIR_EraseRootFromParent_Done,
     /*  847076 */   // Label 13009: @847076
     /*  847076 */   GIM_Try, /*On fail goto*//*Label 13010*/ GIMT_Encode4(847151), // Rule ID 23357 //
     /*  847081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  847089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  847092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  847095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  847098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  847101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847127 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  847127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  847130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847136 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847149 */     GIR_RootConstrainSelectedInstOperands,
     /*  847150 */     // GIR_Coverage, 23357,
     /*  847150 */     GIR_EraseRootFromParent_Done,
     /*  847151 */   // Label 13010: @847151
     /*  847151 */   GIM_Try, /*On fail goto*//*Label 13011*/ GIMT_Encode4(847226), // Rule ID 23360 //
     /*  847156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  847167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  847170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  847173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  847176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847202 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  847205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847224 */     GIR_RootConstrainSelectedInstOperands,
     /*  847225 */     // GIR_Coverage, 23360,
     /*  847225 */     GIR_EraseRootFromParent_Done,
     /*  847226 */   // Label 13011: @847226
     /*  847226 */   GIM_Try, /*On fail goto*//*Label 13012*/ GIMT_Encode4(847301), // Rule ID 23361 //
     /*  847231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  847242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  847245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  847248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  847251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847277 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  847277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  847280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847286 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847299 */     GIR_RootConstrainSelectedInstOperands,
     /*  847300 */     // GIR_Coverage, 23361,
     /*  847300 */     GIR_EraseRootFromParent_Done,
     /*  847301 */   // Label 13012: @847301
     /*  847301 */   GIM_Try, /*On fail goto*//*Label 13013*/ GIMT_Encode4(847376), // Rule ID 23364 //
     /*  847306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  847317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  847320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  847323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  847326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847352 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  847355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847374 */     GIR_RootConstrainSelectedInstOperands,
     /*  847375 */     // GIR_Coverage, 23364,
     /*  847375 */     GIR_EraseRootFromParent_Done,
     /*  847376 */   // Label 13013: @847376
     /*  847376 */   GIM_Try, /*On fail goto*//*Label 13014*/ GIMT_Encode4(847451), // Rule ID 23365 //
     /*  847381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  847392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  847395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  847398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  847401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847427 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  847427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  847430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847436 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847449 */     GIR_RootConstrainSelectedInstOperands,
     /*  847450 */     // GIR_Coverage, 23365,
     /*  847450 */     GIR_EraseRootFromParent_Done,
     /*  847451 */   // Label 13014: @847451
     /*  847451 */   GIM_Try, /*On fail goto*//*Label 13015*/ GIMT_Encode4(847526), // Rule ID 23368 //
     /*  847456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  847467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  847470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  847473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  847476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847502 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  847505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847524 */     GIR_RootConstrainSelectedInstOperands,
     /*  847525 */     // GIR_Coverage, 23368,
     /*  847525 */     GIR_EraseRootFromParent_Done,
     /*  847526 */   // Label 13015: @847526
     /*  847526 */   GIM_Try, /*On fail goto*//*Label 13016*/ GIMT_Encode4(847601), // Rule ID 23369 //
     /*  847531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  847542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  847545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  847548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  847551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847577 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  847577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  847580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847586 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847599 */     GIR_RootConstrainSelectedInstOperands,
     /*  847600 */     // GIR_Coverage, 23369,
     /*  847600 */     GIR_EraseRootFromParent_Done,
     /*  847601 */   // Label 13016: @847601
     /*  847601 */   GIM_Try, /*On fail goto*//*Label 13017*/ GIMT_Encode4(847676), // Rule ID 23372 //
     /*  847606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  847617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  847620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  847623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  847626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847652 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  847655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847674 */     GIR_RootConstrainSelectedInstOperands,
     /*  847675 */     // GIR_Coverage, 23372,
     /*  847675 */     GIR_EraseRootFromParent_Done,
     /*  847676 */   // Label 13017: @847676
     /*  847676 */   GIM_Try, /*On fail goto*//*Label 13018*/ GIMT_Encode4(847751), // Rule ID 23373 //
     /*  847681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  847692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  847695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  847698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  847701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847727 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  847727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  847730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847736 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847749 */     GIR_RootConstrainSelectedInstOperands,
     /*  847750 */     // GIR_Coverage, 23373,
     /*  847750 */     GIR_EraseRootFromParent_Done,
     /*  847751 */   // Label 13018: @847751
     /*  847751 */   GIM_Try, /*On fail goto*//*Label 13019*/ GIMT_Encode4(847826), // Rule ID 23376 //
     /*  847756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  847767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  847770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  847773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  847776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847802 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  847805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847824 */     GIR_RootConstrainSelectedInstOperands,
     /*  847825 */     // GIR_Coverage, 23376,
     /*  847825 */     GIR_EraseRootFromParent_Done,
     /*  847826 */   // Label 13019: @847826
     /*  847826 */   GIM_Try, /*On fail goto*//*Label 13020*/ GIMT_Encode4(847901), // Rule ID 23377 //
     /*  847831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  847842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  847845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  847848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  847851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847877 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  847877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  847880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847886 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847899 */     GIR_RootConstrainSelectedInstOperands,
     /*  847900 */     // GIR_Coverage, 23377,
     /*  847900 */     GIR_EraseRootFromParent_Done,
     /*  847901 */   // Label 13020: @847901
     /*  847901 */   GIM_Try, /*On fail goto*//*Label 13021*/ GIMT_Encode4(847976), // Rule ID 23380 //
     /*  847906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  847917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  847920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  847923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  847926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847952 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  847955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847974 */     GIR_RootConstrainSelectedInstOperands,
     /*  847975 */     // GIR_Coverage, 23380,
     /*  847975 */     GIR_EraseRootFromParent_Done,
     /*  847976 */   // Label 13021: @847976
     /*  847976 */   GIM_Try, /*On fail goto*//*Label 13022*/ GIMT_Encode4(848051), // Rule ID 23381 //
     /*  847981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  847992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  847995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  847998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  848001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848027 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  848030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848036 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848049 */     GIR_RootConstrainSelectedInstOperands,
     /*  848050 */     // GIR_Coverage, 23381,
     /*  848050 */     GIR_EraseRootFromParent_Done,
     /*  848051 */   // Label 13022: @848051
     /*  848051 */   GIM_Try, /*On fail goto*//*Label 13023*/ GIMT_Encode4(848126), // Rule ID 23384 //
     /*  848056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  848064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  848067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  848070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  848073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  848076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848102 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  848102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  848105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848124 */     GIR_RootConstrainSelectedInstOperands,
     /*  848125 */     // GIR_Coverage, 23384,
     /*  848125 */     GIR_EraseRootFromParent_Done,
     /*  848126 */   // Label 13023: @848126
     /*  848126 */   GIM_Try, /*On fail goto*//*Label 13024*/ GIMT_Encode4(848201), // Rule ID 23385 //
     /*  848131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  848134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  848139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  848142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  848145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  848148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  848151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848177 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11433:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  848180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848186 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848199 */     GIR_RootConstrainSelectedInstOperands,
     /*  848200 */     // GIR_Coverage, 23385,
     /*  848200 */     GIR_EraseRootFromParent_Done,
     /*  848201 */   // Label 13024: @848201
     /*  848201 */   GIM_Try, /*On fail goto*//*Label 13025*/ GIMT_Encode4(848276), // Rule ID 23388 //
     /*  848206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  848217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  848220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  848223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  848226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848252 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  848252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  848255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848274 */     GIR_RootConstrainSelectedInstOperands,
     /*  848275 */     // GIR_Coverage, 23388,
     /*  848275 */     GIR_EraseRootFromParent_Done,
     /*  848276 */   // Label 13025: @848276
     /*  848276 */   GIM_Try, /*On fail goto*//*Label 13026*/ GIMT_Encode4(848351), // Rule ID 23389 //
     /*  848281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  848284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  848292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  848295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  848298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  848301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848327 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  848330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848336 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848349 */     GIR_RootConstrainSelectedInstOperands,
     /*  848350 */     // GIR_Coverage, 23389,
     /*  848350 */     GIR_EraseRootFromParent_Done,
     /*  848351 */   // Label 13026: @848351
     /*  848351 */   GIM_Try, /*On fail goto*//*Label 13027*/ GIMT_Encode4(848426), // Rule ID 23392 //
     /*  848356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  848367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  848370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  848373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  848376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848402 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  848402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  848405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848424 */     GIR_RootConstrainSelectedInstOperands,
     /*  848425 */     // GIR_Coverage, 23392,
     /*  848425 */     GIR_EraseRootFromParent_Done,
     /*  848426 */   // Label 13027: @848426
     /*  848426 */   GIM_Try, /*On fail goto*//*Label 13028*/ GIMT_Encode4(848501), // Rule ID 23393 //
     /*  848431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  848434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  848442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  848445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  848448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  848451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848477 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  848480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848486 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848499 */     GIR_RootConstrainSelectedInstOperands,
     /*  848500 */     // GIR_Coverage, 23393,
     /*  848500 */     GIR_EraseRootFromParent_Done,
     /*  848501 */   // Label 13028: @848501
     /*  848501 */   GIM_Try, /*On fail goto*//*Label 13029*/ GIMT_Encode4(848576), // Rule ID 23396 //
     /*  848506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  848517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  848520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  848523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  848526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848552 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  848552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  848555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848574 */     GIR_RootConstrainSelectedInstOperands,
     /*  848575 */     // GIR_Coverage, 23396,
     /*  848575 */     GIR_EraseRootFromParent_Done,
     /*  848576 */   // Label 13029: @848576
     /*  848576 */   GIM_Try, /*On fail goto*//*Label 13030*/ GIMT_Encode4(848651), // Rule ID 23397 //
     /*  848581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  848584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  848592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  848595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  848598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  848601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848627 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  848630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848636 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848649 */     GIR_RootConstrainSelectedInstOperands,
     /*  848650 */     // GIR_Coverage, 23397,
     /*  848650 */     GIR_EraseRootFromParent_Done,
     /*  848651 */   // Label 13030: @848651
     /*  848651 */   GIM_Try, /*On fail goto*//*Label 13031*/ GIMT_Encode4(848726), // Rule ID 23400 //
     /*  848656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  848667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  848670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  848673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  848676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848702 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  848702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  848705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848724 */     GIR_RootConstrainSelectedInstOperands,
     /*  848725 */     // GIR_Coverage, 23400,
     /*  848725 */     GIR_EraseRootFromParent_Done,
     /*  848726 */   // Label 13031: @848726
     /*  848726 */   GIM_Try, /*On fail goto*//*Label 13032*/ GIMT_Encode4(848801), // Rule ID 23401 //
     /*  848731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  848734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  848742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  848745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  848748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  848751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848777 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  848780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848786 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848799 */     GIR_RootConstrainSelectedInstOperands,
     /*  848800 */     // GIR_Coverage, 23401,
     /*  848800 */     GIR_EraseRootFromParent_Done,
     /*  848801 */   // Label 13032: @848801
     /*  848801 */   GIM_Try, /*On fail goto*//*Label 13033*/ GIMT_Encode4(848876), // Rule ID 23404 //
     /*  848806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  848817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  848820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  848823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  848826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848852 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  848852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  848855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848874 */     GIR_RootConstrainSelectedInstOperands,
     /*  848875 */     // GIR_Coverage, 23404,
     /*  848875 */     GIR_EraseRootFromParent_Done,
     /*  848876 */   // Label 13033: @848876
     /*  848876 */   GIM_Try, /*On fail goto*//*Label 13034*/ GIMT_Encode4(848951), // Rule ID 23405 //
     /*  848881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  848884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  848892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  848895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  848898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  848901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848927 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  848930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848936 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848949 */     GIR_RootConstrainSelectedInstOperands,
     /*  848950 */     // GIR_Coverage, 23405,
     /*  848950 */     GIR_EraseRootFromParent_Done,
     /*  848951 */   // Label 13034: @848951
     /*  848951 */   GIM_Try, /*On fail goto*//*Label 13035*/ GIMT_Encode4(849026), // Rule ID 23408 //
     /*  848956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  848967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  848970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  848973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  848976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849002 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  849002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  849005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  849011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  849013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  849024 */     GIR_RootConstrainSelectedInstOperands,
     /*  849025 */     // GIR_Coverage, 23408,
     /*  849025 */     GIR_EraseRootFromParent_Done,
     /*  849026 */   // Label 13035: @849026
     /*  849026 */   GIM_Try, /*On fail goto*//*Label 13036*/ GIMT_Encode4(849101), // Rule ID 23409 //
     /*  849031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  849034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  849039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  849042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  849045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  849048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  849051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  849058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  849070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849077 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  849077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  849080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  849086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  849088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  849099 */     GIR_RootConstrainSelectedInstOperands,
     /*  849100 */     // GIR_Coverage, 23409,
     /*  849100 */     GIR_EraseRootFromParent_Done,
     /*  849101 */   // Label 13036: @849101
     /*  849101 */   GIM_Try, /*On fail goto*//*Label 13037*/ GIMT_Encode4(849176), // Rule ID 23412 //
     /*  849106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  849109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  849114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  849117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  849120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  849123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  849126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  849133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  849145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849152 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  849152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  849155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  849161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  849163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  849174 */     GIR_RootConstrainSelectedInstOperands,
     /*  849175 */     // GIR_Coverage, 23412,
     /*  849175 */     GIR_EraseRootFromParent_Done,
     /*  849176 */   // Label 13037: @849176
     /*  849176 */   GIM_Try, /*On fail goto*//*Label 13038*/ GIMT_Encode4(849251), // Rule ID 23413 //
     /*  849181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  849184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  849189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  849192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  849195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  849198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  849201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  849208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  849220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849227 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  849227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  849230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  849236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  849238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  849249 */     GIR_RootConstrainSelectedInstOperands,
     /*  849250 */     // GIR_Coverage, 23413,
     /*  849250 */     GIR_EraseRootFromParent_Done,
     /*  849251 */   // Label 13038: @849251
     /*  849251 */   GIM_Try, /*On fail goto*//*Label 13039*/ GIMT_Encode4(849326), // Rule ID 23954 //
     /*  849256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  849267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  849270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  849273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849302 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  849305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849324 */     GIR_RootConstrainSelectedInstOperands,
     /*  849325 */     // GIR_Coverage, 23954,
     /*  849325 */     GIR_EraseRootFromParent_Done,
     /*  849326 */   // Label 13039: @849326
     /*  849326 */   GIM_Try, /*On fail goto*//*Label 13040*/ GIMT_Encode4(849401), // Rule ID 23955 //
     /*  849331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  849342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  849345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  849348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849377 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  849380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849399 */     GIR_RootConstrainSelectedInstOperands,
     /*  849400 */     // GIR_Coverage, 23955,
     /*  849400 */     GIR_EraseRootFromParent_Done,
     /*  849401 */   // Label 13040: @849401
     /*  849401 */   GIM_Try, /*On fail goto*//*Label 13041*/ GIMT_Encode4(849476), // Rule ID 23958 //
     /*  849406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  849417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  849420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  849423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849452 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  849455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849474 */     GIR_RootConstrainSelectedInstOperands,
     /*  849475 */     // GIR_Coverage, 23958,
     /*  849475 */     GIR_EraseRootFromParent_Done,
     /*  849476 */   // Label 13041: @849476
     /*  849476 */   GIM_Try, /*On fail goto*//*Label 13042*/ GIMT_Encode4(849551), // Rule ID 23959 //
     /*  849481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  849492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  849495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  849498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849527 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  849530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849549 */     GIR_RootConstrainSelectedInstOperands,
     /*  849550 */     // GIR_Coverage, 23959,
     /*  849550 */     GIR_EraseRootFromParent_Done,
     /*  849551 */   // Label 13042: @849551
     /*  849551 */   GIM_Try, /*On fail goto*//*Label 13043*/ GIMT_Encode4(849626), // Rule ID 23962 //
     /*  849556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  849570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849602 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  849605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849624 */     GIR_RootConstrainSelectedInstOperands,
     /*  849625 */     // GIR_Coverage, 23962,
     /*  849625 */     GIR_EraseRootFromParent_Done,
     /*  849626 */   // Label 13043: @849626
     /*  849626 */   GIM_Try, /*On fail goto*//*Label 13044*/ GIMT_Encode4(849701), // Rule ID 23963 //
     /*  849631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  849645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849677 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  849680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849699 */     GIR_RootConstrainSelectedInstOperands,
     /*  849700 */     // GIR_Coverage, 23963,
     /*  849700 */     GIR_EraseRootFromParent_Done,
     /*  849701 */   // Label 13044: @849701
     /*  849701 */   GIM_Try, /*On fail goto*//*Label 13045*/ GIMT_Encode4(849776), // Rule ID 23966 //
     /*  849706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  849717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  849720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  849723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849752 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  849755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849774 */     GIR_RootConstrainSelectedInstOperands,
     /*  849775 */     // GIR_Coverage, 23966,
     /*  849775 */     GIR_EraseRootFromParent_Done,
     /*  849776 */   // Label 13045: @849776
     /*  849776 */   GIM_Try, /*On fail goto*//*Label 13046*/ GIMT_Encode4(849851), // Rule ID 23967 //
     /*  849781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  849792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  849795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  849798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849827 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  849830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849849 */     GIR_RootConstrainSelectedInstOperands,
     /*  849850 */     // GIR_Coverage, 23967,
     /*  849850 */     GIR_EraseRootFromParent_Done,
     /*  849851 */   // Label 13046: @849851
     /*  849851 */   GIM_Try, /*On fail goto*//*Label 13047*/ GIMT_Encode4(849926), // Rule ID 23970 //
     /*  849856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  849867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  849870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  849873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849902 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  849905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849924 */     GIR_RootConstrainSelectedInstOperands,
     /*  849925 */     // GIR_Coverage, 23970,
     /*  849925 */     GIR_EraseRootFromParent_Done,
     /*  849926 */   // Label 13047: @849926
     /*  849926 */   GIM_Try, /*On fail goto*//*Label 13048*/ GIMT_Encode4(850001), // Rule ID 23971 //
     /*  849931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  849942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  849945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  849948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849977 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  849980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849999 */     GIR_RootConstrainSelectedInstOperands,
     /*  850000 */     // GIR_Coverage, 23971,
     /*  850000 */     GIR_EraseRootFromParent_Done,
     /*  850001 */   // Label 13048: @850001
     /*  850001 */   GIM_Try, /*On fail goto*//*Label 13049*/ GIMT_Encode4(850076), // Rule ID 23974 //
     /*  850006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  850017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  850020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  850023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850052 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  850052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  850055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850074 */     GIR_RootConstrainSelectedInstOperands,
     /*  850075 */     // GIR_Coverage, 23974,
     /*  850075 */     GIR_EraseRootFromParent_Done,
     /*  850076 */   // Label 13049: @850076
     /*  850076 */   GIM_Try, /*On fail goto*//*Label 13050*/ GIMT_Encode4(850151), // Rule ID 23975 //
     /*  850081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  850092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  850095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  850098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850127 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  850127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  850130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850149 */     GIR_RootConstrainSelectedInstOperands,
     /*  850150 */     // GIR_Coverage, 23975,
     /*  850150 */     GIR_EraseRootFromParent_Done,
     /*  850151 */   // Label 13050: @850151
     /*  850151 */   GIM_Try, /*On fail goto*//*Label 13051*/ GIMT_Encode4(850226), // Rule ID 23978 //
     /*  850156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  850167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  850170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  850173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850202 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850224 */     GIR_RootConstrainSelectedInstOperands,
     /*  850225 */     // GIR_Coverage, 23978,
     /*  850225 */     GIR_EraseRootFromParent_Done,
     /*  850226 */   // Label 13051: @850226
     /*  850226 */   GIM_Try, /*On fail goto*//*Label 13052*/ GIMT_Encode4(850301), // Rule ID 23979 //
     /*  850231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  850242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  850245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  850248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850277 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850299 */     GIR_RootConstrainSelectedInstOperands,
     /*  850300 */     // GIR_Coverage, 23979,
     /*  850300 */     GIR_EraseRootFromParent_Done,
     /*  850301 */   // Label 13052: @850301
     /*  850301 */   GIM_Try, /*On fail goto*//*Label 13053*/ GIMT_Encode4(850376), // Rule ID 23982 //
     /*  850306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  850317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  850320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  850323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  850352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850374 */     GIR_RootConstrainSelectedInstOperands,
     /*  850375 */     // GIR_Coverage, 23982,
     /*  850375 */     GIR_EraseRootFromParent_Done,
     /*  850376 */   // Label 13053: @850376
     /*  850376 */   GIM_Try, /*On fail goto*//*Label 13054*/ GIMT_Encode4(850451), // Rule ID 23983 //
     /*  850381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  850392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  850395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  850398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850427 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  850427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850449 */     GIR_RootConstrainSelectedInstOperands,
     /*  850450 */     // GIR_Coverage, 23983,
     /*  850450 */     GIR_EraseRootFromParent_Done,
     /*  850451 */   // Label 13054: @850451
     /*  850451 */   GIM_Try, /*On fail goto*//*Label 13055*/ GIMT_Encode4(850526), // Rule ID 23986 //
     /*  850456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  850467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  850470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  850473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  850502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850524 */     GIR_RootConstrainSelectedInstOperands,
     /*  850525 */     // GIR_Coverage, 23986,
     /*  850525 */     GIR_EraseRootFromParent_Done,
     /*  850526 */   // Label 13055: @850526
     /*  850526 */   GIM_Try, /*On fail goto*//*Label 13056*/ GIMT_Encode4(850601), // Rule ID 23987 //
     /*  850531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  850542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  850545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  850548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850577 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  850577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850599 */     GIR_RootConstrainSelectedInstOperands,
     /*  850600 */     // GIR_Coverage, 23987,
     /*  850600 */     GIR_EraseRootFromParent_Done,
     /*  850601 */   // Label 13056: @850601
     /*  850601 */   GIM_Try, /*On fail goto*//*Label 13057*/ GIMT_Encode4(850676), // Rule ID 23990 //
     /*  850606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  850609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  850617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  850620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  850623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  850652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  850671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850674 */     GIR_RootConstrainSelectedInstOperands,
     /*  850675 */     // GIR_Coverage, 23990,
     /*  850675 */     GIR_EraseRootFromParent_Done,
     /*  850676 */   // Label 13057: @850676
     /*  850676 */   GIM_Try, /*On fail goto*//*Label 13058*/ GIMT_Encode4(850751), // Rule ID 23991 //
     /*  850681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  850684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  850692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  850695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  850698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  850727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  850746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850749 */     GIR_RootConstrainSelectedInstOperands,
     /*  850750 */     // GIR_Coverage, 23991,
     /*  850750 */     GIR_EraseRootFromParent_Done,
     /*  850751 */   // Label 13058: @850751
     /*  850751 */   GIM_Try, /*On fail goto*//*Label 13059*/ GIMT_Encode4(850826), // Rule ID 23994 //
     /*  850756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  850767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  850770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  850773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850802 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  850805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850824 */     GIR_RootConstrainSelectedInstOperands,
     /*  850825 */     // GIR_Coverage, 23994,
     /*  850825 */     GIR_EraseRootFromParent_Done,
     /*  850826 */   // Label 13059: @850826
     /*  850826 */   GIM_Try, /*On fail goto*//*Label 13060*/ GIMT_Encode4(850901), // Rule ID 23995 //
     /*  850831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  850842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  850845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  850848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850877 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  850880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850899 */     GIR_RootConstrainSelectedInstOperands,
     /*  850900 */     // GIR_Coverage, 23995,
     /*  850900 */     GIR_EraseRootFromParent_Done,
     /*  850901 */   // Label 13060: @850901
     /*  850901 */   GIM_Try, /*On fail goto*//*Label 13061*/ GIMT_Encode4(850976), // Rule ID 23998 //
     /*  850906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  850917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  850920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  850923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850952 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  850955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850974 */     GIR_RootConstrainSelectedInstOperands,
     /*  850975 */     // GIR_Coverage, 23998,
     /*  850975 */     GIR_EraseRootFromParent_Done,
     /*  850976 */   // Label 13061: @850976
     /*  850976 */   GIM_Try, /*On fail goto*//*Label 13062*/ GIMT_Encode4(851051), // Rule ID 23999 //
     /*  850981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  850992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  850995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  850998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851027 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  851027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  851030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851049 */     GIR_RootConstrainSelectedInstOperands,
     /*  851050 */     // GIR_Coverage, 23999,
     /*  851050 */     GIR_EraseRootFromParent_Done,
     /*  851051 */   // Label 13062: @851051
     /*  851051 */   GIM_Try, /*On fail goto*//*Label 13063*/ GIMT_Encode4(851126), // Rule ID 24002 //
     /*  851056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  851067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  851070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  851073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851102 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  851102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  851105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851124 */     GIR_RootConstrainSelectedInstOperands,
     /*  851125 */     // GIR_Coverage, 24002,
     /*  851125 */     GIR_EraseRootFromParent_Done,
     /*  851126 */   // Label 13063: @851126
     /*  851126 */   GIM_Try, /*On fail goto*//*Label 13064*/ GIMT_Encode4(851201), // Rule ID 24003 //
     /*  851131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  851142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  851145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  851148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851177 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  851177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  851180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851199 */     GIR_RootConstrainSelectedInstOperands,
     /*  851200 */     // GIR_Coverage, 24003,
     /*  851200 */     GIR_EraseRootFromParent_Done,
     /*  851201 */   // Label 13064: @851201
     /*  851201 */   GIM_Try, /*On fail goto*//*Label 13065*/ GIMT_Encode4(851276), // Rule ID 24006 //
     /*  851206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  851217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  851220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  851223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851252 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  851255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851274 */     GIR_RootConstrainSelectedInstOperands,
     /*  851275 */     // GIR_Coverage, 24006,
     /*  851275 */     GIR_EraseRootFromParent_Done,
     /*  851276 */   // Label 13065: @851276
     /*  851276 */   GIM_Try, /*On fail goto*//*Label 13066*/ GIMT_Encode4(851351), // Rule ID 24007 //
     /*  851281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  851292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  851295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  851298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851327 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  851330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851349 */     GIR_RootConstrainSelectedInstOperands,
     /*  851350 */     // GIR_Coverage, 24007,
     /*  851350 */     GIR_EraseRootFromParent_Done,
     /*  851351 */   // Label 13066: @851351
     /*  851351 */   GIM_Try, /*On fail goto*//*Label 13067*/ GIMT_Encode4(851426), // Rule ID 24010 //
     /*  851356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  851367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  851370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  851373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851402 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  851405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851424 */     GIR_RootConstrainSelectedInstOperands,
     /*  851425 */     // GIR_Coverage, 24010,
     /*  851425 */     GIR_EraseRootFromParent_Done,
     /*  851426 */   // Label 13067: @851426
     /*  851426 */   GIM_Try, /*On fail goto*//*Label 13068*/ GIMT_Encode4(851501), // Rule ID 24011 //
     /*  851431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  851442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  851445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  851448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851477 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  851480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851499 */     GIR_RootConstrainSelectedInstOperands,
     /*  851500 */     // GIR_Coverage, 24011,
     /*  851500 */     GIR_EraseRootFromParent_Done,
     /*  851501 */   // Label 13068: @851501
     /*  851501 */   GIM_Try, /*On fail goto*//*Label 13069*/ GIMT_Encode4(851576), // Rule ID 24014 //
     /*  851506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  851517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  851520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  851523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851552 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  851555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851574 */     GIR_RootConstrainSelectedInstOperands,
     /*  851575 */     // GIR_Coverage, 24014,
     /*  851575 */     GIR_EraseRootFromParent_Done,
     /*  851576 */   // Label 13069: @851576
     /*  851576 */   GIM_Try, /*On fail goto*//*Label 13070*/ GIMT_Encode4(851651), // Rule ID 24015 //
     /*  851581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  851592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  851595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  851598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851627 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  851630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851649 */     GIR_RootConstrainSelectedInstOperands,
     /*  851650 */     // GIR_Coverage, 24015,
     /*  851650 */     GIR_EraseRootFromParent_Done,
     /*  851651 */   // Label 13070: @851651
     /*  851651 */   GIM_Try, /*On fail goto*//*Label 13071*/ GIMT_Encode4(851726), // Rule ID 24018 //
     /*  851656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  851667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  851670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  851673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  851705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851724 */     GIR_RootConstrainSelectedInstOperands,
     /*  851725 */     // GIR_Coverage, 24018,
     /*  851725 */     GIR_EraseRootFromParent_Done,
     /*  851726 */   // Label 13071: @851726
     /*  851726 */   GIM_Try, /*On fail goto*//*Label 13072*/ GIMT_Encode4(851801), // Rule ID 24019 //
     /*  851731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  851742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  851745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  851748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851777 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  851780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851799 */     GIR_RootConstrainSelectedInstOperands,
     /*  851800 */     // GIR_Coverage, 24019,
     /*  851800 */     GIR_EraseRootFromParent_Done,
     /*  851801 */   // Label 13072: @851801
     /*  851801 */   GIM_Try, /*On fail goto*//*Label 13073*/ GIMT_Encode4(851876), // Rule ID 24022 //
     /*  851806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  851817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  851820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  851823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  851855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851874 */     GIR_RootConstrainSelectedInstOperands,
     /*  851875 */     // GIR_Coverage, 24022,
     /*  851875 */     GIR_EraseRootFromParent_Done,
     /*  851876 */   // Label 13073: @851876
     /*  851876 */   GIM_Try, /*On fail goto*//*Label 13074*/ GIMT_Encode4(851951), // Rule ID 24023 //
     /*  851881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  851892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  851895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  851898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851927 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  851930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851949 */     GIR_RootConstrainSelectedInstOperands,
     /*  851950 */     // GIR_Coverage, 24023,
     /*  851950 */     GIR_EraseRootFromParent_Done,
     /*  851951 */   // Label 13074: @851951
     /*  851951 */   GIM_Try, /*On fail goto*//*Label 13075*/ GIMT_Encode4(852026), // Rule ID 24026 //
     /*  851956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  851967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  851970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  851973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852002 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  852002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  852005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852024 */     GIR_RootConstrainSelectedInstOperands,
     /*  852025 */     // GIR_Coverage, 24026,
     /*  852025 */     GIR_EraseRootFromParent_Done,
     /*  852026 */   // Label 13075: @852026
     /*  852026 */   GIM_Try, /*On fail goto*//*Label 13076*/ GIMT_Encode4(852101), // Rule ID 24027 //
     /*  852031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  852034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  852042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  852045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  852048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852077 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  852077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  852080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852099 */     GIR_RootConstrainSelectedInstOperands,
     /*  852100 */     // GIR_Coverage, 24027,
     /*  852100 */     GIR_EraseRootFromParent_Done,
     /*  852101 */   // Label 13076: @852101
     /*  852101 */   GIM_Try, /*On fail goto*//*Label 13077*/ GIMT_Encode4(852176), // Rule ID 24030 //
     /*  852106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  852109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  852117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  852120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  852123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852152 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  852155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852174 */     GIR_RootConstrainSelectedInstOperands,
     /*  852175 */     // GIR_Coverage, 24030,
     /*  852175 */     GIR_EraseRootFromParent_Done,
     /*  852176 */   // Label 13077: @852176
     /*  852176 */   GIM_Try, /*On fail goto*//*Label 13078*/ GIMT_Encode4(852251), // Rule ID 24031 //
     /*  852181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  852184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  852192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  852195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  852198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852227 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  852230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852249 */     GIR_RootConstrainSelectedInstOperands,
     /*  852250 */     // GIR_Coverage, 24031,
     /*  852250 */     GIR_EraseRootFromParent_Done,
     /*  852251 */   // Label 13078: @852251
     /*  852251 */   GIM_Try, /*On fail goto*//*Label 13079*/ GIMT_Encode4(852326), // Rule ID 24034 //
     /*  852256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  852259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  852267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  852270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  852273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852302 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  852305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852324 */     GIR_RootConstrainSelectedInstOperands,
     /*  852325 */     // GIR_Coverage, 24034,
     /*  852325 */     GIR_EraseRootFromParent_Done,
     /*  852326 */   // Label 13079: @852326
     /*  852326 */   GIM_Try, /*On fail goto*//*Label 13080*/ GIMT_Encode4(852401), // Rule ID 24035 //
     /*  852331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  852334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  852342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  852345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  852348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852377 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  852380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852399 */     GIR_RootConstrainSelectedInstOperands,
     /*  852400 */     // GIR_Coverage, 24035,
     /*  852400 */     GIR_EraseRootFromParent_Done,
     /*  852401 */   // Label 13080: @852401
     /*  852401 */   GIM_Try, /*On fail goto*//*Label 13081*/ GIMT_Encode4(852476), // Rule ID 24038 //
     /*  852406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  852409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  852417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  852420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  852423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852452 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  852455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852474 */     GIR_RootConstrainSelectedInstOperands,
     /*  852475 */     // GIR_Coverage, 24038,
     /*  852475 */     GIR_EraseRootFromParent_Done,
     /*  852476 */   // Label 13081: @852476
     /*  852476 */   GIM_Try, /*On fail goto*//*Label 13082*/ GIMT_Encode4(852551), // Rule ID 24039 //
     /*  852481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  852484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  852492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  852495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  852498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852527 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  852530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852549 */     GIR_RootConstrainSelectedInstOperands,
     /*  852550 */     // GIR_Coverage, 24039,
     /*  852550 */     GIR_EraseRootFromParent_Done,
     /*  852551 */   // Label 13082: @852551
     /*  852551 */   GIM_Try, /*On fail goto*//*Label 13083*/ GIMT_Encode4(852626), // Rule ID 24042 //
     /*  852556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  852559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  852567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  852570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  852573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852602 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  852602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  852605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  852621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852624 */     GIR_RootConstrainSelectedInstOperands,
     /*  852625 */     // GIR_Coverage, 24042,
     /*  852625 */     GIR_EraseRootFromParent_Done,
     /*  852626 */   // Label 13083: @852626
     /*  852626 */   GIM_Try, /*On fail goto*//*Label 13084*/ GIMT_Encode4(852701), // Rule ID 24043 //
     /*  852631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  852634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  852642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  852645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  852648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852677 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  852677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  852680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  852696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852699 */     GIR_RootConstrainSelectedInstOperands,
     /*  852700 */     // GIR_Coverage, 24043,
     /*  852700 */     GIR_EraseRootFromParent_Done,
     /*  852701 */   // Label 13084: @852701
     /*  852701 */   GIM_Try, /*On fail goto*//*Label 13085*/ GIMT_Encode4(852776), // Rule ID 24046 //
     /*  852706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  852709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  852717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  852720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  852723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852752 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  852752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  852755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  852771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852774 */     GIR_RootConstrainSelectedInstOperands,
     /*  852775 */     // GIR_Coverage, 24046,
     /*  852775 */     GIR_EraseRootFromParent_Done,
     /*  852776 */   // Label 13085: @852776
     /*  852776 */   GIM_Try, /*On fail goto*//*Label 13086*/ GIMT_Encode4(852851), // Rule ID 24047 //
     /*  852781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  852784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  852792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  852795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  852798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852827 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  852827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  852830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  852846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852849 */     GIR_RootConstrainSelectedInstOperands,
     /*  852850 */     // GIR_Coverage, 24047,
     /*  852850 */     GIR_EraseRootFromParent_Done,
     /*  852851 */   // Label 13086: @852851
     /*  852851 */   GIM_Try, /*On fail goto*//*Label 13087*/ GIMT_Encode4(852926), // Rule ID 24050 //
     /*  852856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  852859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  852867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  852870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  852873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852902 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  852902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  852905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  852921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852924 */     GIR_RootConstrainSelectedInstOperands,
     /*  852925 */     // GIR_Coverage, 24050,
     /*  852925 */     GIR_EraseRootFromParent_Done,
     /*  852926 */   // Label 13087: @852926
     /*  852926 */   GIM_Try, /*On fail goto*//*Label 13088*/ GIMT_Encode4(853001), // Rule ID 24051 //
     /*  852931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  852934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  852942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  852945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  852948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852977 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  852977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  852980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  852996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852999 */     GIR_RootConstrainSelectedInstOperands,
     /*  853000 */     // GIR_Coverage, 24051,
     /*  853000 */     GIR_EraseRootFromParent_Done,
     /*  853001 */   // Label 13088: @853001
     /*  853001 */   GIM_Try, /*On fail goto*//*Label 13089*/ GIMT_Encode4(853076), // Rule ID 24054 //
     /*  853006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  853009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  853017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  853020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  853023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853052 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  853055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853074 */     GIR_RootConstrainSelectedInstOperands,
     /*  853075 */     // GIR_Coverage, 24054,
     /*  853075 */     GIR_EraseRootFromParent_Done,
     /*  853076 */   // Label 13089: @853076
     /*  853076 */   GIM_Try, /*On fail goto*//*Label 13090*/ GIMT_Encode4(853151), // Rule ID 24055 //
     /*  853081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  853084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  853092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  853095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  853098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853127 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  853130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853149 */     GIR_RootConstrainSelectedInstOperands,
     /*  853150 */     // GIR_Coverage, 24055,
     /*  853150 */     GIR_EraseRootFromParent_Done,
     /*  853151 */   // Label 13090: @853151
     /*  853151 */   GIM_Try, /*On fail goto*//*Label 13091*/ GIMT_Encode4(853226), // Rule ID 24058 //
     /*  853156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  853159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  853167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  853170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  853173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853202 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  853205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853224 */     GIR_RootConstrainSelectedInstOperands,
     /*  853225 */     // GIR_Coverage, 24058,
     /*  853225 */     GIR_EraseRootFromParent_Done,
     /*  853226 */   // Label 13091: @853226
     /*  853226 */   GIM_Try, /*On fail goto*//*Label 13092*/ GIMT_Encode4(853301), // Rule ID 24059 //
     /*  853231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  853234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  853242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  853245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  853248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853277 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  853280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853299 */     GIR_RootConstrainSelectedInstOperands,
     /*  853300 */     // GIR_Coverage, 24059,
     /*  853300 */     GIR_EraseRootFromParent_Done,
     /*  853301 */   // Label 13092: @853301
     /*  853301 */   GIM_Try, /*On fail goto*//*Label 13093*/ GIMT_Encode4(853376), // Rule ID 24062 //
     /*  853306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  853309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  853317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  853320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  853323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  853355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853374 */     GIR_RootConstrainSelectedInstOperands,
     /*  853375 */     // GIR_Coverage, 24062,
     /*  853375 */     GIR_EraseRootFromParent_Done,
     /*  853376 */   // Label 13093: @853376
     /*  853376 */   GIM_Try, /*On fail goto*//*Label 13094*/ GIMT_Encode4(853451), // Rule ID 24063 //
     /*  853381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  853384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  853392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  853395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  853398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853427 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  853430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853449 */     GIR_RootConstrainSelectedInstOperands,
     /*  853450 */     // GIR_Coverage, 24063,
     /*  853450 */     GIR_EraseRootFromParent_Done,
     /*  853451 */   // Label 13094: @853451
     /*  853451 */   GIM_Try, /*On fail goto*//*Label 13095*/ GIMT_Encode4(853526), // Rule ID 24066 //
     /*  853456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  853459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  853467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  853470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  853473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  853502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  853521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853524 */     GIR_RootConstrainSelectedInstOperands,
     /*  853525 */     // GIR_Coverage, 24066,
     /*  853525 */     GIR_EraseRootFromParent_Done,
     /*  853526 */   // Label 13095: @853526
     /*  853526 */   GIM_Try, /*On fail goto*//*Label 13096*/ GIMT_Encode4(853601), // Rule ID 24067 //
     /*  853531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  853534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  853542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  853545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  853548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853577 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  853577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  853596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853599 */     GIR_RootConstrainSelectedInstOperands,
     /*  853600 */     // GIR_Coverage, 24067,
     /*  853600 */     GIR_EraseRootFromParent_Done,
     /*  853601 */   // Label 13096: @853601
     /*  853601 */   GIM_Try, /*On fail goto*//*Label 13097*/ GIMT_Encode4(853676), // Rule ID 24070 //
     /*  853606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  853609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  853617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  853620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  853623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853674 */     GIR_RootConstrainSelectedInstOperands,
     /*  853675 */     // GIR_Coverage, 24070,
     /*  853675 */     GIR_EraseRootFromParent_Done,
     /*  853676 */   // Label 13097: @853676
     /*  853676 */   GIM_Try, /*On fail goto*//*Label 13098*/ GIMT_Encode4(853751), // Rule ID 24071 //
     /*  853681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  853684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  853692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  853695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  853698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853727 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853749 */     GIR_RootConstrainSelectedInstOperands,
     /*  853750 */     // GIR_Coverage, 24071,
     /*  853750 */     GIR_EraseRootFromParent_Done,
     /*  853751 */   // Label 13098: @853751
     /*  853751 */   GIM_Try, /*On fail goto*//*Label 13099*/ GIMT_Encode4(853826), // Rule ID 24074 //
     /*  853756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  853759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  853767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  853770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  853773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853824 */     GIR_RootConstrainSelectedInstOperands,
     /*  853825 */     // GIR_Coverage, 24074,
     /*  853825 */     GIR_EraseRootFromParent_Done,
     /*  853826 */   // Label 13099: @853826
     /*  853826 */   GIM_Try, /*On fail goto*//*Label 13100*/ GIMT_Encode4(853901), // Rule ID 24075 //
     /*  853831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  853834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  853842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  853845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  853848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853899 */     GIR_RootConstrainSelectedInstOperands,
     /*  853900 */     // GIR_Coverage, 24075,
     /*  853900 */     GIR_EraseRootFromParent_Done,
     /*  853901 */   // Label 13100: @853901
     /*  853901 */   GIM_Try, /*On fail goto*//*Label 13101*/ GIMT_Encode4(853976), // Rule ID 24078 //
     /*  853906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  853909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  853917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  853920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  853923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  853952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853974 */     GIR_RootConstrainSelectedInstOperands,
     /*  853975 */     // GIR_Coverage, 24078,
     /*  853975 */     GIR_EraseRootFromParent_Done,
     /*  853976 */   // Label 13101: @853976
     /*  853976 */   GIM_Try, /*On fail goto*//*Label 13102*/ GIMT_Encode4(854051), // Rule ID 24079 //
     /*  853981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  853984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  853992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  853995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  853998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854027 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  854027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  854030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854049 */     GIR_RootConstrainSelectedInstOperands,
     /*  854050 */     // GIR_Coverage, 24079,
     /*  854050 */     GIR_EraseRootFromParent_Done,
     /*  854051 */   // Label 13102: @854051
     /*  854051 */   GIM_Try, /*On fail goto*//*Label 13103*/ GIMT_Encode4(854126), // Rule ID 24082 //
     /*  854056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  854067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  854070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  854073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854102 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  854102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  854105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854124 */     GIR_RootConstrainSelectedInstOperands,
     /*  854125 */     // GIR_Coverage, 24082,
     /*  854125 */     GIR_EraseRootFromParent_Done,
     /*  854126 */   // Label 13103: @854126
     /*  854126 */   GIM_Try, /*On fail goto*//*Label 13104*/ GIMT_Encode4(854201), // Rule ID 24083 //
     /*  854131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  854134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  854142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  854145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  854148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854177 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  854177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  854180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854199 */     GIR_RootConstrainSelectedInstOperands,
     /*  854200 */     // GIR_Coverage, 24083,
     /*  854200 */     GIR_EraseRootFromParent_Done,
     /*  854201 */   // Label 13104: @854201
     /*  854201 */   GIM_Try, /*On fail goto*//*Label 13105*/ GIMT_Encode4(854276), // Rule ID 24086 //
     /*  854206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  854217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  854220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  854223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854252 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  854252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  854255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854274 */     GIR_RootConstrainSelectedInstOperands,
     /*  854275 */     // GIR_Coverage, 24086,
     /*  854275 */     GIR_EraseRootFromParent_Done,
     /*  854276 */   // Label 13105: @854276
     /*  854276 */   GIM_Try, /*On fail goto*//*Label 13106*/ GIMT_Encode4(854351), // Rule ID 24087 //
     /*  854281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  854284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  854292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  854295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  854298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854327 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  854327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  854330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854349 */     GIR_RootConstrainSelectedInstOperands,
     /*  854350 */     // GIR_Coverage, 24087,
     /*  854350 */     GIR_EraseRootFromParent_Done,
     /*  854351 */   // Label 13106: @854351
     /*  854351 */   GIM_Try, /*On fail goto*//*Label 13107*/ GIMT_Encode4(854426), // Rule ID 24090 //
     /*  854356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  854367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  854370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  854373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854402 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  854402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  854405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854424 */     GIR_RootConstrainSelectedInstOperands,
     /*  854425 */     // GIR_Coverage, 24090,
     /*  854425 */     GIR_EraseRootFromParent_Done,
     /*  854426 */   // Label 13107: @854426
     /*  854426 */   GIM_Try, /*On fail goto*//*Label 13108*/ GIMT_Encode4(854501), // Rule ID 24091 //
     /*  854431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  854434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  854442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  854445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  854448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854477 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  854477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  854480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854499 */     GIR_RootConstrainSelectedInstOperands,
     /*  854500 */     // GIR_Coverage, 24091,
     /*  854500 */     GIR_EraseRootFromParent_Done,
     /*  854501 */   // Label 13108: @854501
     /*  854501 */   GIM_Try, /*On fail goto*//*Label 13109*/ GIMT_Encode4(854576), // Rule ID 24094 //
     /*  854506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  854517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  854520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  854523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  854555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854574 */     GIR_RootConstrainSelectedInstOperands,
     /*  854575 */     // GIR_Coverage, 24094,
     /*  854575 */     GIR_EraseRootFromParent_Done,
     /*  854576 */   // Label 13109: @854576
     /*  854576 */   GIM_Try, /*On fail goto*//*Label 13110*/ GIMT_Encode4(854651), // Rule ID 24095 //
     /*  854581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  854584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  854592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  854595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  854598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854627 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  854630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854649 */     GIR_RootConstrainSelectedInstOperands,
     /*  854650 */     // GIR_Coverage, 24095,
     /*  854650 */     GIR_EraseRootFromParent_Done,
     /*  854651 */   // Label 13110: @854651
     /*  854651 */   GIM_Try, /*On fail goto*//*Label 13111*/ GIMT_Encode4(854726), // Rule ID 24098 //
     /*  854656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  854667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  854670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  854673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854702 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  854705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854724 */     GIR_RootConstrainSelectedInstOperands,
     /*  854725 */     // GIR_Coverage, 24098,
     /*  854725 */     GIR_EraseRootFromParent_Done,
     /*  854726 */   // Label 13111: @854726
     /*  854726 */   GIM_Try, /*On fail goto*//*Label 13112*/ GIMT_Encode4(854801), // Rule ID 24099 //
     /*  854731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  854734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  854742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  854745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  854748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854777 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  854780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854799 */     GIR_RootConstrainSelectedInstOperands,
     /*  854800 */     // GIR_Coverage, 24099,
     /*  854800 */     GIR_EraseRootFromParent_Done,
     /*  854801 */   // Label 13112: @854801
     /*  854801 */   GIM_Try, /*On fail goto*//*Label 13113*/ GIMT_Encode4(854876), // Rule ID 24102 //
     /*  854806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  854817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  854820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  854823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854852 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  854855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854874 */     GIR_RootConstrainSelectedInstOperands,
     /*  854875 */     // GIR_Coverage, 24102,
     /*  854875 */     GIR_EraseRootFromParent_Done,
     /*  854876 */   // Label 13113: @854876
     /*  854876 */   GIM_Try, /*On fail goto*//*Label 13114*/ GIMT_Encode4(854951), // Rule ID 24103 //
     /*  854881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  854884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  854892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  854895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  854898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854927 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  854930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854949 */     GIR_RootConstrainSelectedInstOperands,
     /*  854950 */     // GIR_Coverage, 24103,
     /*  854950 */     GIR_EraseRootFromParent_Done,
     /*  854951 */   // Label 13114: @854951
     /*  854951 */   GIM_Try, /*On fail goto*//*Label 13115*/ GIMT_Encode4(855026), // Rule ID 24106 //
     /*  854956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  854967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  854970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  854973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  855005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855024 */     GIR_RootConstrainSelectedInstOperands,
     /*  855025 */     // GIR_Coverage, 24106,
     /*  855025 */     GIR_EraseRootFromParent_Done,
     /*  855026 */   // Label 13115: @855026
     /*  855026 */   GIM_Try, /*On fail goto*//*Label 13116*/ GIMT_Encode4(855101), // Rule ID 24107 //
     /*  855031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  855034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  855042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  855045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  855048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855077 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  855080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855099 */     GIR_RootConstrainSelectedInstOperands,
     /*  855100 */     // GIR_Coverage, 24107,
     /*  855100 */     GIR_EraseRootFromParent_Done,
     /*  855101 */   // Label 13116: @855101
     /*  855101 */   GIM_Try, /*On fail goto*//*Label 13117*/ GIMT_Encode4(855176), // Rule ID 24110 //
     /*  855106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  855109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  855117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  855120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  855123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855152 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  855155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855174 */     GIR_RootConstrainSelectedInstOperands,
     /*  855175 */     // GIR_Coverage, 24110,
     /*  855175 */     GIR_EraseRootFromParent_Done,
     /*  855176 */   // Label 13117: @855176
     /*  855176 */   GIM_Try, /*On fail goto*//*Label 13118*/ GIMT_Encode4(855251), // Rule ID 24111 //
     /*  855181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  855184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  855192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  855195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  855198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855227 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  855230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855249 */     GIR_RootConstrainSelectedInstOperands,
     /*  855250 */     // GIR_Coverage, 24111,
     /*  855250 */     GIR_EraseRootFromParent_Done,
     /*  855251 */   // Label 13118: @855251
     /*  855251 */   GIM_Try, /*On fail goto*//*Label 13119*/ GIMT_Encode4(855326), // Rule ID 24114 //
     /*  855256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  855259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  855267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  855270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  855273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855302 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  855305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855324 */     GIR_RootConstrainSelectedInstOperands,
     /*  855325 */     // GIR_Coverage, 24114,
     /*  855325 */     GIR_EraseRootFromParent_Done,
     /*  855326 */   // Label 13119: @855326
     /*  855326 */   GIM_Try, /*On fail goto*//*Label 13120*/ GIMT_Encode4(855401), // Rule ID 24115 //
     /*  855331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  855334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  855342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  855345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  855348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855377 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  855380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855399 */     GIR_RootConstrainSelectedInstOperands,
     /*  855400 */     // GIR_Coverage, 24115,
     /*  855400 */     GIR_EraseRootFromParent_Done,
     /*  855401 */   // Label 13120: @855401
     /*  855401 */   GIM_Try, /*On fail goto*//*Label 13121*/ GIMT_Encode4(855476), // Rule ID 24118 //
     /*  855406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  855409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  855417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  855420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  855423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855452 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  855452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  855455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855474 */     GIR_RootConstrainSelectedInstOperands,
     /*  855475 */     // GIR_Coverage, 24118,
     /*  855475 */     GIR_EraseRootFromParent_Done,
     /*  855476 */   // Label 13121: @855476
     /*  855476 */   GIM_Try, /*On fail goto*//*Label 13122*/ GIMT_Encode4(855551), // Rule ID 24119 //
     /*  855481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  855484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  855492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  855495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  855498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855527 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  855527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  855530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855549 */     GIR_RootConstrainSelectedInstOperands,
     /*  855550 */     // GIR_Coverage, 24119,
     /*  855550 */     GIR_EraseRootFromParent_Done,
     /*  855551 */   // Label 13122: @855551
     /*  855551 */   GIM_Try, /*On fail goto*//*Label 13123*/ GIMT_Encode4(855626), // Rule ID 24122 //
     /*  855556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  855559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  855567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  855570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  855573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855602 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  855602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  855605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855624 */     GIR_RootConstrainSelectedInstOperands,
     /*  855625 */     // GIR_Coverage, 24122,
     /*  855625 */     GIR_EraseRootFromParent_Done,
     /*  855626 */   // Label 13123: @855626
     /*  855626 */   GIM_Try, /*On fail goto*//*Label 13124*/ GIMT_Encode4(855701), // Rule ID 24123 //
     /*  855631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  855634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  855642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  855645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  855648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855677 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  855677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  855680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855699 */     GIR_RootConstrainSelectedInstOperands,
     /*  855700 */     // GIR_Coverage, 24123,
     /*  855700 */     GIR_EraseRootFromParent_Done,
     /*  855701 */   // Label 13124: @855701
     /*  855701 */   GIM_Try, /*On fail goto*//*Label 13125*/ GIMT_Encode4(855776), // Rule ID 24126 //
     /*  855706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  855709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  855717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  855720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  855723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855752 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  855752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  855755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855774 */     GIR_RootConstrainSelectedInstOperands,
     /*  855775 */     // GIR_Coverage, 24126,
     /*  855775 */     GIR_EraseRootFromParent_Done,
     /*  855776 */   // Label 13125: @855776
     /*  855776 */   GIM_Try, /*On fail goto*//*Label 13126*/ GIMT_Encode4(855851), // Rule ID 24127 //
     /*  855781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  855784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  855792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  855795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  855798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855827 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  855827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  855830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855849 */     GIR_RootConstrainSelectedInstOperands,
     /*  855850 */     // GIR_Coverage, 24127,
     /*  855850 */     GIR_EraseRootFromParent_Done,
     /*  855851 */   // Label 13126: @855851
     /*  855851 */   GIM_Try, /*On fail goto*//*Label 13127*/ GIMT_Encode4(855926), // Rule ID 24370 //
     /*  855856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  855864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  855867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  855870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  855873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855902 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  855905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855924 */     GIR_RootConstrainSelectedInstOperands,
     /*  855925 */     // GIR_Coverage, 24370,
     /*  855925 */     GIR_EraseRootFromParent_Done,
     /*  855926 */   // Label 13127: @855926
     /*  855926 */   GIM_Try, /*On fail goto*//*Label 13128*/ GIMT_Encode4(856001), // Rule ID 24371 //
     /*  855931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  855939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  855942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  855945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  855948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855977 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  855980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855999 */     GIR_RootConstrainSelectedInstOperands,
     /*  856000 */     // GIR_Coverage, 24371,
     /*  856000 */     GIR_EraseRootFromParent_Done,
     /*  856001 */   // Label 13128: @856001
     /*  856001 */   GIM_Try, /*On fail goto*//*Label 13129*/ GIMT_Encode4(856076), // Rule ID 24374 //
     /*  856006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  856009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  856017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  856020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  856023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  856052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  856055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856074 */     GIR_RootConstrainSelectedInstOperands,
     /*  856075 */     // GIR_Coverage, 24374,
     /*  856075 */     GIR_EraseRootFromParent_Done,
     /*  856076 */   // Label 13129: @856076
     /*  856076 */   GIM_Try, /*On fail goto*//*Label 13130*/ GIMT_Encode4(856151), // Rule ID 24375 //
     /*  856081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  856084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  856092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  856095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  856098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856127 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  856127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  856130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856149 */     GIR_RootConstrainSelectedInstOperands,
     /*  856150 */     // GIR_Coverage, 24375,
     /*  856150 */     GIR_EraseRootFromParent_Done,
     /*  856151 */   // Label 13130: @856151
     /*  856151 */   GIM_Try, /*On fail goto*//*Label 13131*/ GIMT_Encode4(856226), // Rule ID 24378 //
     /*  856156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  856159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  856167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  856170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  856173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856202 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  856202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  856205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856224 */     GIR_RootConstrainSelectedInstOperands,
     /*  856225 */     // GIR_Coverage, 24378,
     /*  856225 */     GIR_EraseRootFromParent_Done,
     /*  856226 */   // Label 13131: @856226
     /*  856226 */   GIM_Try, /*On fail goto*//*Label 13132*/ GIMT_Encode4(856301), // Rule ID 24379 //
     /*  856231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  856234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  856242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  856245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  856248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856277 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  856277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  856280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856299 */     GIR_RootConstrainSelectedInstOperands,
     /*  856300 */     // GIR_Coverage, 24379,
     /*  856300 */     GIR_EraseRootFromParent_Done,
     /*  856301 */   // Label 13132: @856301
     /*  856301 */   GIM_Try, /*On fail goto*//*Label 13133*/ GIMT_Encode4(856376), // Rule ID 24382 //
     /*  856306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  856309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  856317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  856320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  856323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  856352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  856355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856374 */     GIR_RootConstrainSelectedInstOperands,
     /*  856375 */     // GIR_Coverage, 24382,
     /*  856375 */     GIR_EraseRootFromParent_Done,
     /*  856376 */   // Label 13133: @856376
     /*  856376 */   GIM_Try, /*On fail goto*//*Label 13134*/ GIMT_Encode4(856451), // Rule ID 24383 //
     /*  856381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  856384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  856392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  856395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  856398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856427 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  856427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  856430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856449 */     GIR_RootConstrainSelectedInstOperands,
     /*  856450 */     // GIR_Coverage, 24383,
     /*  856450 */     GIR_EraseRootFromParent_Done,
     /*  856451 */   // Label 13134: @856451
     /*  856451 */   GIM_Try, /*On fail goto*//*Label 13135*/ GIMT_Encode4(856526), // Rule ID 24386 //
     /*  856456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  856459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  856467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  856470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  856473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856502 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  856502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  856505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856524 */     GIR_RootConstrainSelectedInstOperands,
     /*  856525 */     // GIR_Coverage, 24386,
     /*  856525 */     GIR_EraseRootFromParent_Done,
     /*  856526 */   // Label 13135: @856526
     /*  856526 */   GIM_Try, /*On fail goto*//*Label 13136*/ GIMT_Encode4(856601), // Rule ID 24387 //
     /*  856531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  856534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  856542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  856545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  856548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856577 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  856577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  856580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856599 */     GIR_RootConstrainSelectedInstOperands,
     /*  856600 */     // GIR_Coverage, 24387,
     /*  856600 */     GIR_EraseRootFromParent_Done,
     /*  856601 */   // Label 13136: @856601
     /*  856601 */   GIM_Try, /*On fail goto*//*Label 13137*/ GIMT_Encode4(856676), // Rule ID 24390 //
     /*  856606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  856617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  856620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  856623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856652 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  856655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856674 */     GIR_RootConstrainSelectedInstOperands,
     /*  856675 */     // GIR_Coverage, 24390,
     /*  856675 */     GIR_EraseRootFromParent_Done,
     /*  856676 */   // Label 13137: @856676
     /*  856676 */   GIM_Try, /*On fail goto*//*Label 13138*/ GIMT_Encode4(856751), // Rule ID 24391 //
     /*  856681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  856692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  856695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  856698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856727 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  856730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856749 */     GIR_RootConstrainSelectedInstOperands,
     /*  856750 */     // GIR_Coverage, 24391,
     /*  856750 */     GIR_EraseRootFromParent_Done,
     /*  856751 */   // Label 13138: @856751
     /*  856751 */   GIM_Try, /*On fail goto*//*Label 13139*/ GIMT_Encode4(856826), // Rule ID 24394 //
     /*  856756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  856759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  856767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  856770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  856773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856802 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  856802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  856805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856824 */     GIR_RootConstrainSelectedInstOperands,
     /*  856825 */     // GIR_Coverage, 24394,
     /*  856825 */     GIR_EraseRootFromParent_Done,
     /*  856826 */   // Label 13139: @856826
     /*  856826 */   GIM_Try, /*On fail goto*//*Label 13140*/ GIMT_Encode4(856901), // Rule ID 24395 //
     /*  856831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  856834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  856842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  856845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  856848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856877 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  856877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  856880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856899 */     GIR_RootConstrainSelectedInstOperands,
     /*  856900 */     // GIR_Coverage, 24395,
     /*  856900 */     GIR_EraseRootFromParent_Done,
     /*  856901 */   // Label 13140: @856901
     /*  856901 */   GIM_Try, /*On fail goto*//*Label 13141*/ GIMT_Encode4(856976), // Rule ID 24398 //
     /*  856906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  856909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  856917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  856920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  856923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856952 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  856952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  856955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856974 */     GIR_RootConstrainSelectedInstOperands,
     /*  856975 */     // GIR_Coverage, 24398,
     /*  856975 */     GIR_EraseRootFromParent_Done,
     /*  856976 */   // Label 13141: @856976
     /*  856976 */   GIM_Try, /*On fail goto*//*Label 13142*/ GIMT_Encode4(857051), // Rule ID 24399 //
     /*  856981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  856984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  856992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  856995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  856998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  857001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  857020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857027 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  857030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857049 */     GIR_RootConstrainSelectedInstOperands,
     /*  857050 */     // GIR_Coverage, 24399,
     /*  857050 */     GIR_EraseRootFromParent_Done,
     /*  857051 */   // Label 13142: @857051
     /*  857051 */   GIM_Try, /*On fail goto*//*Label 13143*/ GIMT_Encode4(857126), // Rule ID 24402 //
     /*  857056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  857059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  857067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  857070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  857073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  857076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  857095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857102 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  857102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  857105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857124 */     GIR_RootConstrainSelectedInstOperands,
     /*  857125 */     // GIR_Coverage, 24402,
     /*  857125 */     GIR_EraseRootFromParent_Done,
     /*  857126 */   // Label 13143: @857126
     /*  857126 */   GIM_Try, /*On fail goto*//*Label 13144*/ GIMT_Encode4(857201), // Rule ID 24403 //
     /*  857131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  857134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  857142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  857145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  857148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  857151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  857170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857177 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  857180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857199 */     GIR_RootConstrainSelectedInstOperands,
     /*  857200 */     // GIR_Coverage, 24403,
     /*  857200 */     GIR_EraseRootFromParent_Done,
     /*  857201 */   // Label 13144: @857201
     /*  857201 */   GIM_Try, /*On fail goto*//*Label 13145*/ GIMT_Encode4(857276), // Rule ID 24406 //
     /*  857206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  857209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  857217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  857220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  857223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  857226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  857252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  857255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857274 */     GIR_RootConstrainSelectedInstOperands,
     /*  857275 */     // GIR_Coverage, 24406,
     /*  857275 */     GIR_EraseRootFromParent_Done,
     /*  857276 */   // Label 13145: @857276
     /*  857276 */   GIM_Try, /*On fail goto*//*Label 13146*/ GIMT_Encode4(857351), // Rule ID 24407 //
     /*  857281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  857284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  857292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  857295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  857298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  857301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857327 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  857327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  857330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857349 */     GIR_RootConstrainSelectedInstOperands,
     /*  857350 */     // GIR_Coverage, 24407,
     /*  857350 */     GIR_EraseRootFromParent_Done,
     /*  857351 */   // Label 13146: @857351
     /*  857351 */   GIM_Try, /*On fail goto*//*Label 13147*/ GIMT_Encode4(857426), // Rule ID 24410 //
     /*  857356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  857359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  857367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  857370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  857373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  857376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857402 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  857402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  857405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857424 */     GIR_RootConstrainSelectedInstOperands,
     /*  857425 */     // GIR_Coverage, 24410,
     /*  857425 */     GIR_EraseRootFromParent_Done,
     /*  857426 */   // Label 13147: @857426
     /*  857426 */   GIM_Try, /*On fail goto*//*Label 13148*/ GIMT_Encode4(857501), // Rule ID 24411 //
     /*  857431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  857434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  857442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  857445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  857448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  857451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857477 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  857477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  857480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857499 */     GIR_RootConstrainSelectedInstOperands,
     /*  857500 */     // GIR_Coverage, 24411,
     /*  857500 */     GIR_EraseRootFromParent_Done,
     /*  857501 */   // Label 13148: @857501
     /*  857501 */   GIM_Try, /*On fail goto*//*Label 13149*/ GIMT_Encode4(857576), // Rule ID 24414 //
     /*  857506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  857509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  857517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  857520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  857523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  857526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857552 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  857552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  857555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857574 */     GIR_RootConstrainSelectedInstOperands,
     /*  857575 */     // GIR_Coverage, 24414,
     /*  857575 */     GIR_EraseRootFromParent_Done,
     /*  857576 */   // Label 13149: @857576
     /*  857576 */   GIM_Try, /*On fail goto*//*Label 13150*/ GIMT_Encode4(857651), // Rule ID 24415 //
     /*  857581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  857584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  857592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  857595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  857598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  857601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857627 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  857627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  857630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857649 */     GIR_RootConstrainSelectedInstOperands,
     /*  857650 */     // GIR_Coverage, 24415,
     /*  857650 */     GIR_EraseRootFromParent_Done,
     /*  857651 */   // Label 13150: @857651
     /*  857651 */   GIM_Try, /*On fail goto*//*Label 13151*/ GIMT_Encode4(857726), // Rule ID 24418 //
     /*  857656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  857659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  857667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  857670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  857673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  857676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  857695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857702 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  857702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  857705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857724 */     GIR_RootConstrainSelectedInstOperands,
     /*  857725 */     // GIR_Coverage, 24418,
     /*  857725 */     GIR_EraseRootFromParent_Done,
     /*  857726 */   // Label 13151: @857726
     /*  857726 */   GIM_Try, /*On fail goto*//*Label 13152*/ GIMT_Encode4(857801), // Rule ID 24419 //
     /*  857731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  857734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  857742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  857745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  857748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  857751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  857770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857777 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  857777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  857780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857799 */     GIR_RootConstrainSelectedInstOperands,
     /*  857800 */     // GIR_Coverage, 24419,
     /*  857800 */     GIR_EraseRootFromParent_Done,
     /*  857801 */   // Label 13152: @857801
     /*  857801 */   GIM_Try, /*On fail goto*//*Label 13153*/ GIMT_Encode4(857876), // Rule ID 24422 //
     /*  857806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  857809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  857817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  857820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  857823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  857826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  857845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857852 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  857852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  857855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857874 */     GIR_RootConstrainSelectedInstOperands,
     /*  857875 */     // GIR_Coverage, 24422,
     /*  857875 */     GIR_EraseRootFromParent_Done,
     /*  857876 */   // Label 13153: @857876
     /*  857876 */   GIM_Try, /*On fail goto*//*Label 13154*/ GIMT_Encode4(857951), // Rule ID 24423 //
     /*  857881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  857884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  857892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  857895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  857898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  857901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  857920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857927 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  857927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  857930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857949 */     GIR_RootConstrainSelectedInstOperands,
     /*  857950 */     // GIR_Coverage, 24423,
     /*  857950 */     GIR_EraseRootFromParent_Done,
     /*  857951 */   // Label 13154: @857951
     /*  857951 */   GIM_Try, /*On fail goto*//*Label 13155*/ GIMT_Encode4(858026), // Rule ID 24426 //
     /*  857956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  857959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  857967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  857970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  857973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  857976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  857995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858002 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  858002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  858005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858024 */     GIR_RootConstrainSelectedInstOperands,
     /*  858025 */     // GIR_Coverage, 24426,
     /*  858025 */     GIR_EraseRootFromParent_Done,
     /*  858026 */   // Label 13155: @858026
     /*  858026 */   GIM_Try, /*On fail goto*//*Label 13156*/ GIMT_Encode4(858101), // Rule ID 24427 //
     /*  858031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  858034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  858039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  858042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  858045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  858048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  858051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  858070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858077 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  858077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  858080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858099 */     GIR_RootConstrainSelectedInstOperands,
     /*  858100 */     // GIR_Coverage, 24427,
     /*  858100 */     GIR_EraseRootFromParent_Done,
     /*  858101 */   // Label 13156: @858101
     /*  858101 */   GIM_Try, /*On fail goto*//*Label 13157*/ GIMT_Encode4(858176), // Rule ID 24430 //
     /*  858106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  858109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  858117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  858120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  858123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  858126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  858145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858152 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  858155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858174 */     GIR_RootConstrainSelectedInstOperands,
     /*  858175 */     // GIR_Coverage, 24430,
     /*  858175 */     GIR_EraseRootFromParent_Done,
     /*  858176 */   // Label 13157: @858176
     /*  858176 */   GIM_Try, /*On fail goto*//*Label 13158*/ GIMT_Encode4(858251), // Rule ID 24431 //
     /*  858181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  858184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  858192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  858195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  858198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  858201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  858220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858227 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  858230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858249 */     GIR_RootConstrainSelectedInstOperands,
     /*  858250 */     // GIR_Coverage, 24431,
     /*  858250 */     GIR_EraseRootFromParent_Done,
     /*  858251 */   // Label 13158: @858251
     /*  858251 */   GIM_Try, /*On fail goto*//*Label 13159*/ GIMT_Encode4(858326), // Rule ID 24434 //
     /*  858256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  858259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  858267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  858270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  858273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  858276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  858295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858302 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  858305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858324 */     GIR_RootConstrainSelectedInstOperands,
     /*  858325 */     // GIR_Coverage, 24434,
     /*  858325 */     GIR_EraseRootFromParent_Done,
     /*  858326 */   // Label 13159: @858326
     /*  858326 */   GIM_Try, /*On fail goto*//*Label 13160*/ GIMT_Encode4(858401), // Rule ID 24435 //
     /*  858331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  858334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  858342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  858345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  858348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  858351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  858370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858377 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  858380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858399 */     GIR_RootConstrainSelectedInstOperands,
     /*  858400 */     // GIR_Coverage, 24435,
     /*  858400 */     GIR_EraseRootFromParent_Done,
     /*  858401 */   // Label 13160: @858401
     /*  858401 */   GIM_Try, /*On fail goto*//*Label 13161*/ GIMT_Encode4(858476), // Rule ID 24438 //
     /*  858406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  858409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  858417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  858420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  858423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  858426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  858445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858452 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  858452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  858455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858474 */     GIR_RootConstrainSelectedInstOperands,
     /*  858475 */     // GIR_Coverage, 24438,
     /*  858475 */     GIR_EraseRootFromParent_Done,
     /*  858476 */   // Label 13161: @858476
     /*  858476 */   GIM_Try, /*On fail goto*//*Label 13162*/ GIMT_Encode4(858551), // Rule ID 24439 //
     /*  858481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  858484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  858492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  858495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  858498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  858501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  858520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858527 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  858527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  858530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858549 */     GIR_RootConstrainSelectedInstOperands,
     /*  858550 */     // GIR_Coverage, 24439,
     /*  858550 */     GIR_EraseRootFromParent_Done,
     /*  858551 */   // Label 13162: @858551
     /*  858551 */   GIM_Try, /*On fail goto*//*Label 13163*/ GIMT_Encode4(858626), // Rule ID 24442 //
     /*  858556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  858559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  858567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  858570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  858573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  858576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  858595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858602 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  858605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858624 */     GIR_RootConstrainSelectedInstOperands,
     /*  858625 */     // GIR_Coverage, 24442,
     /*  858625 */     GIR_EraseRootFromParent_Done,
     /*  858626 */   // Label 13163: @858626
     /*  858626 */   GIM_Try, /*On fail goto*//*Label 13164*/ GIMT_Encode4(858701), // Rule ID 24443 //
     /*  858631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  858634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  858642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  858645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  858648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  858651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  858670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858677 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  858680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858699 */     GIR_RootConstrainSelectedInstOperands,
     /*  858700 */     // GIR_Coverage, 24443,
     /*  858700 */     GIR_EraseRootFromParent_Done,
     /*  858701 */   // Label 13164: @858701
     /*  858701 */   GIM_Try, /*On fail goto*//*Label 13165*/ GIMT_Encode4(858776), // Rule ID 24446 //
     /*  858706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  858709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  858717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  858720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  858723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  858726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  858745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858752 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  858752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  858755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858774 */     GIR_RootConstrainSelectedInstOperands,
     /*  858775 */     // GIR_Coverage, 24446,
     /*  858775 */     GIR_EraseRootFromParent_Done,
     /*  858776 */   // Label 13165: @858776
     /*  858776 */   GIM_Try, /*On fail goto*//*Label 13166*/ GIMT_Encode4(858851), // Rule ID 24447 //
     /*  858781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  858784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  858792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  858795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  858798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  858801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  858820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858827 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  858827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  858830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858849 */     GIR_RootConstrainSelectedInstOperands,
     /*  858850 */     // GIR_Coverage, 24447,
     /*  858850 */     GIR_EraseRootFromParent_Done,
     /*  858851 */   // Label 13166: @858851
     /*  858851 */   GIM_Try, /*On fail goto*//*Label 13167*/ GIMT_Encode4(858926), // Rule ID 24450 //
     /*  858856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  858859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  858867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  858870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  858873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  858876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  858895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858902 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  858902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  858905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858924 */     GIR_RootConstrainSelectedInstOperands,
     /*  858925 */     // GIR_Coverage, 24450,
     /*  858925 */     GIR_EraseRootFromParent_Done,
     /*  858926 */   // Label 13167: @858926
     /*  858926 */   GIM_Try, /*On fail goto*//*Label 13168*/ GIMT_Encode4(859001), // Rule ID 24451 //
     /*  858931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  858934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  858942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  858945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  858948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  858951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  858970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858977 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  858977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  858980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858999 */     GIR_RootConstrainSelectedInstOperands,
     /*  859000 */     // GIR_Coverage, 24451,
     /*  859000 */     GIR_EraseRootFromParent_Done,
     /*  859001 */   // Label 13168: @859001
     /*  859001 */   GIM_Try, /*On fail goto*//*Label 13169*/ GIMT_Encode4(859076), // Rule ID 24454 //
     /*  859006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  859009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  859017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  859020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  859023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  859026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  859045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859052 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  859052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  859055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859074 */     GIR_RootConstrainSelectedInstOperands,
     /*  859075 */     // GIR_Coverage, 24454,
     /*  859075 */     GIR_EraseRootFromParent_Done,
     /*  859076 */   // Label 13169: @859076
     /*  859076 */   GIM_Try, /*On fail goto*//*Label 13170*/ GIMT_Encode4(859151), // Rule ID 24455 //
     /*  859081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  859084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  859092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  859095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  859098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  859101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  859120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859127 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  859127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  859130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859149 */     GIR_RootConstrainSelectedInstOperands,
     /*  859150 */     // GIR_Coverage, 24455,
     /*  859150 */     GIR_EraseRootFromParent_Done,
     /*  859151 */   // Label 13170: @859151
     /*  859151 */   GIM_Try, /*On fail goto*//*Label 13171*/ GIMT_Encode4(859226), // Rule ID 24458 //
     /*  859156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  859159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  859167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  859170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  859173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  859176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  859195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859202 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  859202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  859205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859224 */     GIR_RootConstrainSelectedInstOperands,
     /*  859225 */     // GIR_Coverage, 24458,
     /*  859225 */     GIR_EraseRootFromParent_Done,
     /*  859226 */   // Label 13171: @859226
     /*  859226 */   GIM_Try, /*On fail goto*//*Label 13172*/ GIMT_Encode4(859301), // Rule ID 24459 //
     /*  859231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  859234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  859242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  859245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  859248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  859251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  859270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859277 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  859277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  859280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859299 */     GIR_RootConstrainSelectedInstOperands,
     /*  859300 */     // GIR_Coverage, 24459,
     /*  859300 */     GIR_EraseRootFromParent_Done,
     /*  859301 */   // Label 13172: @859301
     /*  859301 */   GIM_Try, /*On fail goto*//*Label 13173*/ GIMT_Encode4(859376), // Rule ID 24462 //
     /*  859306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  859309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  859317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  859320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  859323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  859326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  859345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859352 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  859352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  859355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859374 */     GIR_RootConstrainSelectedInstOperands,
     /*  859375 */     // GIR_Coverage, 24462,
     /*  859375 */     GIR_EraseRootFromParent_Done,
     /*  859376 */   // Label 13173: @859376
     /*  859376 */   GIM_Try, /*On fail goto*//*Label 13174*/ GIMT_Encode4(859451), // Rule ID 24463 //
     /*  859381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  859384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  859392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  859395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  859398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  859401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  859420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859427 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  859427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  859430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859449 */     GIR_RootConstrainSelectedInstOperands,
     /*  859450 */     // GIR_Coverage, 24463,
     /*  859450 */     GIR_EraseRootFromParent_Done,
     /*  859451 */   // Label 13174: @859451
     /*  859451 */   GIM_Try, /*On fail goto*//*Label 13175*/ GIMT_Encode4(859526), // Rule ID 24466 //
     /*  859456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  859459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  859467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  859470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  859473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  859495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859502 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  859505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859524 */     GIR_RootConstrainSelectedInstOperands,
     /*  859525 */     // GIR_Coverage, 24466,
     /*  859525 */     GIR_EraseRootFromParent_Done,
     /*  859526 */   // Label 13175: @859526
     /*  859526 */   GIM_Try, /*On fail goto*//*Label 13176*/ GIMT_Encode4(859601), // Rule ID 24467 //
     /*  859531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  859534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  859542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  859545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  859548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  859570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859577 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  859580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859599 */     GIR_RootConstrainSelectedInstOperands,
     /*  859600 */     // GIR_Coverage, 24467,
     /*  859600 */     GIR_EraseRootFromParent_Done,
     /*  859601 */   // Label 13176: @859601
     /*  859601 */   GIM_Try, /*On fail goto*//*Label 13177*/ GIMT_Encode4(859676), // Rule ID 24470 //
     /*  859606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  859609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  859617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  859620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  859623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  859645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859652 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  859655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859674 */     GIR_RootConstrainSelectedInstOperands,
     /*  859675 */     // GIR_Coverage, 24470,
     /*  859675 */     GIR_EraseRootFromParent_Done,
     /*  859676 */   // Label 13177: @859676
     /*  859676 */   GIM_Try, /*On fail goto*//*Label 13178*/ GIMT_Encode4(859751), // Rule ID 24471 //
     /*  859681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  859684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  859692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  859695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  859698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  859720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859727 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  859730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859749 */     GIR_RootConstrainSelectedInstOperands,
     /*  859750 */     // GIR_Coverage, 24471,
     /*  859750 */     GIR_EraseRootFromParent_Done,
     /*  859751 */   // Label 13178: @859751
     /*  859751 */   GIM_Try, /*On fail goto*//*Label 13179*/ GIMT_Encode4(859826), // Rule ID 24474 //
     /*  859756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  859759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  859767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  859770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  859773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  859795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859802 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  859805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859824 */     GIR_RootConstrainSelectedInstOperands,
     /*  859825 */     // GIR_Coverage, 24474,
     /*  859825 */     GIR_EraseRootFromParent_Done,
     /*  859826 */   // Label 13179: @859826
     /*  859826 */   GIM_Try, /*On fail goto*//*Label 13180*/ GIMT_Encode4(859901), // Rule ID 24475 //
     /*  859831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  859834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  859842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  859845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  859848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  859870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859877 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  859880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859899 */     GIR_RootConstrainSelectedInstOperands,
     /*  859900 */     // GIR_Coverage, 24475,
     /*  859900 */     GIR_EraseRootFromParent_Done,
     /*  859901 */   // Label 13180: @859901
     /*  859901 */   GIM_Try, /*On fail goto*//*Label 13181*/ GIMT_Encode4(859976), // Rule ID 24478 //
     /*  859906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  859909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  859917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  859920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  859923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  859926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  859945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  859952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  859955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859974 */     GIR_RootConstrainSelectedInstOperands,
     /*  859975 */     // GIR_Coverage, 24478,
     /*  859975 */     GIR_EraseRootFromParent_Done,
     /*  859976 */   // Label 13181: @859976
     /*  859976 */   GIM_Try, /*On fail goto*//*Label 13182*/ GIMT_Encode4(860051), // Rule ID 24479 //
     /*  859981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  859984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  859992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  859995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  859998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  860020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860027 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  860027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  860030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860049 */     GIR_RootConstrainSelectedInstOperands,
     /*  860050 */     // GIR_Coverage, 24479,
     /*  860050 */     GIR_EraseRootFromParent_Done,
     /*  860051 */   // Label 13182: @860051
     /*  860051 */   GIM_Try, /*On fail goto*//*Label 13183*/ GIMT_Encode4(860126), // Rule ID 24482 //
     /*  860056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  860059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  860064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  860067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  860070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  860073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  860095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  860102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  860105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860124 */     GIR_RootConstrainSelectedInstOperands,
     /*  860125 */     // GIR_Coverage, 24482,
     /*  860125 */     GIR_EraseRootFromParent_Done,
     /*  860126 */   // Label 13183: @860126
     /*  860126 */   GIM_Try, /*On fail goto*//*Label 13184*/ GIMT_Encode4(860201), // Rule ID 24483 //
     /*  860131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  860134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  860139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  860142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  860145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  860148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  860170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860177 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  860177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  860180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860199 */     GIR_RootConstrainSelectedInstOperands,
     /*  860200 */     // GIR_Coverage, 24483,
     /*  860200 */     GIR_EraseRootFromParent_Done,
     /*  860201 */   // Label 13184: @860201
     /*  860201 */   GIM_Try, /*On fail goto*//*Label 13185*/ GIMT_Encode4(860276), // Rule ID 24486 //
     /*  860206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  860209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  860214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  860217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  860220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  860223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  860245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860252 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  860252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  860255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860274 */     GIR_RootConstrainSelectedInstOperands,
     /*  860275 */     // GIR_Coverage, 24486,
     /*  860275 */     GIR_EraseRootFromParent_Done,
     /*  860276 */   // Label 13185: @860276
     /*  860276 */   GIM_Try, /*On fail goto*//*Label 13186*/ GIMT_Encode4(860351), // Rule ID 24487 //
     /*  860281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  860284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  860289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  860292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  860295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  860298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  860320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860327 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  860327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  860330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860349 */     GIR_RootConstrainSelectedInstOperands,
     /*  860350 */     // GIR_Coverage, 24487,
     /*  860350 */     GIR_EraseRootFromParent_Done,
     /*  860351 */   // Label 13186: @860351
     /*  860351 */   GIM_Try, /*On fail goto*//*Label 13187*/ GIMT_Encode4(860426), // Rule ID 24490 //
     /*  860356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  860367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  860370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  860373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  860376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860402 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  860405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860424 */     GIR_RootConstrainSelectedInstOperands,
     /*  860425 */     // GIR_Coverage, 24490,
     /*  860425 */     GIR_EraseRootFromParent_Done,
     /*  860426 */   // Label 13187: @860426
     /*  860426 */   GIM_Try, /*On fail goto*//*Label 13188*/ GIMT_Encode4(860501), // Rule ID 24491 //
     /*  860431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  860442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  860445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  860448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  860451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860477 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  860480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860499 */     GIR_RootConstrainSelectedInstOperands,
     /*  860500 */     // GIR_Coverage, 24491,
     /*  860500 */     GIR_EraseRootFromParent_Done,
     /*  860501 */   // Label 13188: @860501
     /*  860501 */   GIM_Try, /*On fail goto*//*Label 13189*/ GIMT_Encode4(860576), // Rule ID 24494 //
     /*  860506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  860517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  860520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  860523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  860526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  860555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860574 */     GIR_RootConstrainSelectedInstOperands,
     /*  860575 */     // GIR_Coverage, 24494,
     /*  860575 */     GIR_EraseRootFromParent_Done,
     /*  860576 */   // Label 13189: @860576
     /*  860576 */   GIM_Try, /*On fail goto*//*Label 13190*/ GIMT_Encode4(860651), // Rule ID 24495 //
     /*  860581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  860592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  860595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  860598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  860601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860627 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  860630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860649 */     GIR_RootConstrainSelectedInstOperands,
     /*  860650 */     // GIR_Coverage, 24495,
     /*  860650 */     GIR_EraseRootFromParent_Done,
     /*  860651 */   // Label 13190: @860651
     /*  860651 */   GIM_Try, /*On fail goto*//*Label 13191*/ GIMT_Encode4(860726), // Rule ID 24498 //
     /*  860656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  860667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  860670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  860673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  860676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860702 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  860705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860724 */     GIR_RootConstrainSelectedInstOperands,
     /*  860725 */     // GIR_Coverage, 24498,
     /*  860725 */     GIR_EraseRootFromParent_Done,
     /*  860726 */   // Label 13191: @860726
     /*  860726 */   GIM_Try, /*On fail goto*//*Label 13192*/ GIMT_Encode4(860801), // Rule ID 24499 //
     /*  860731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  860742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  860745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  860748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  860751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860777 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  860780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860799 */     GIR_RootConstrainSelectedInstOperands,
     /*  860800 */     // GIR_Coverage, 24499,
     /*  860800 */     GIR_EraseRootFromParent_Done,
     /*  860801 */   // Label 13192: @860801
     /*  860801 */   GIM_Try, /*On fail goto*//*Label 13193*/ GIMT_Encode4(860876), // Rule ID 24502 //
     /*  860806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  860817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  860820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  860823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  860826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860852 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  860852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  860855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860874 */     GIR_RootConstrainSelectedInstOperands,
     /*  860875 */     // GIR_Coverage, 24502,
     /*  860875 */     GIR_EraseRootFromParent_Done,
     /*  860876 */   // Label 13193: @860876
     /*  860876 */   GIM_Try, /*On fail goto*//*Label 13194*/ GIMT_Encode4(860951), // Rule ID 24503 //
     /*  860881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  860892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  860895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  860898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  860901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860927 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  860927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  860930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860949 */     GIR_RootConstrainSelectedInstOperands,
     /*  860950 */     // GIR_Coverage, 24503,
     /*  860950 */     GIR_EraseRootFromParent_Done,
     /*  860951 */   // Label 13194: @860951
     /*  860951 */   GIM_Try, /*On fail goto*//*Label 13195*/ GIMT_Encode4(861026), // Rule ID 24506 //
     /*  860956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  860967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  860970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  860973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  860976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861002 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  861002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  861005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861024 */     GIR_RootConstrainSelectedInstOperands,
     /*  861025 */     // GIR_Coverage, 24506,
     /*  861025 */     GIR_EraseRootFromParent_Done,
     /*  861026 */   // Label 13195: @861026
     /*  861026 */   GIM_Try, /*On fail goto*//*Label 13196*/ GIMT_Encode4(861101), // Rule ID 24507 //
     /*  861031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  861042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  861045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  861048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  861051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861077 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  861077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  861080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861099 */     GIR_RootConstrainSelectedInstOperands,
     /*  861100 */     // GIR_Coverage, 24507,
     /*  861100 */     GIR_EraseRootFromParent_Done,
     /*  861101 */   // Label 13196: @861101
     /*  861101 */   GIM_Try, /*On fail goto*//*Label 13197*/ GIMT_Encode4(861176), // Rule ID 24510 //
     /*  861106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  861117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  861120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  861123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  861126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861152 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  861152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  861155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861174 */     GIR_RootConstrainSelectedInstOperands,
     /*  861175 */     // GIR_Coverage, 24510,
     /*  861175 */     GIR_EraseRootFromParent_Done,
     /*  861176 */   // Label 13197: @861176
     /*  861176 */   GIM_Try, /*On fail goto*//*Label 13198*/ GIMT_Encode4(861251), // Rule ID 24511 //
     /*  861181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  861192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  861195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  861198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  861201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861227 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  861227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  861230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861249 */     GIR_RootConstrainSelectedInstOperands,
     /*  861250 */     // GIR_Coverage, 24511,
     /*  861250 */     GIR_EraseRootFromParent_Done,
     /*  861251 */   // Label 13198: @861251
     /*  861251 */   GIM_Try, /*On fail goto*//*Label 13199*/ GIMT_Encode4(861326), // Rule ID 24514 //
     /*  861256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  861267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  861270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  861273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  861276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  861305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861324 */     GIR_RootConstrainSelectedInstOperands,
     /*  861325 */     // GIR_Coverage, 24514,
     /*  861325 */     GIR_EraseRootFromParent_Done,
     /*  861326 */   // Label 13199: @861326
     /*  861326 */   GIM_Try, /*On fail goto*//*Label 13200*/ GIMT_Encode4(861401), // Rule ID 24515 //
     /*  861331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  861342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  861345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  861348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  861351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861377 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  861380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861399 */     GIR_RootConstrainSelectedInstOperands,
     /*  861400 */     // GIR_Coverage, 24515,
     /*  861400 */     GIR_EraseRootFromParent_Done,
     /*  861401 */   // Label 13200: @861401
     /*  861401 */   GIM_Try, /*On fail goto*//*Label 13201*/ GIMT_Encode4(861476), // Rule ID 24518 //
     /*  861406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  861417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  861420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  861423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  861426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  861452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  861455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861474 */     GIR_RootConstrainSelectedInstOperands,
     /*  861475 */     // GIR_Coverage, 24518,
     /*  861475 */     GIR_EraseRootFromParent_Done,
     /*  861476 */   // Label 13201: @861476
     /*  861476 */   GIM_Try, /*On fail goto*//*Label 13202*/ GIMT_Encode4(861551), // Rule ID 24519 //
     /*  861481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  861492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  861495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  861498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  861501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861527 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  861527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  861530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861549 */     GIR_RootConstrainSelectedInstOperands,
     /*  861550 */     // GIR_Coverage, 24519,
     /*  861550 */     GIR_EraseRootFromParent_Done,
     /*  861551 */   // Label 13202: @861551
     /*  861551 */   GIM_Try, /*On fail goto*//*Label 13203*/ GIMT_Encode4(861626), // Rule ID 24522 //
     /*  861556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  861570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  861576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  861602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  861605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861624 */     GIR_RootConstrainSelectedInstOperands,
     /*  861625 */     // GIR_Coverage, 24522,
     /*  861625 */     GIR_EraseRootFromParent_Done,
     /*  861626 */   // Label 13203: @861626
     /*  861626 */   GIM_Try, /*On fail goto*//*Label 13204*/ GIMT_Encode4(861701), // Rule ID 24523 //
     /*  861631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  861645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  861651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861677 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  861677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  861680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861699 */     GIR_RootConstrainSelectedInstOperands,
     /*  861700 */     // GIR_Coverage, 24523,
     /*  861700 */     GIR_EraseRootFromParent_Done,
     /*  861701 */   // Label 13204: @861701
     /*  861701 */   GIM_Try, /*On fail goto*//*Label 13205*/ GIMT_Encode4(861776), // Rule ID 24526 //
     /*  861706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  861709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  861717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  861720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  861723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  861726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  861752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  861755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  861771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861774 */     GIR_RootConstrainSelectedInstOperands,
     /*  861775 */     // GIR_Coverage, 24526,
     /*  861775 */     GIR_EraseRootFromParent_Done,
     /*  861776 */   // Label 13205: @861776
     /*  861776 */   GIM_Try, /*On fail goto*//*Label 13206*/ GIMT_Encode4(861851), // Rule ID 24527 //
     /*  861781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  861784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  861792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  861795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  861798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  861801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  861827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  861830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  861846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861849 */     GIR_RootConstrainSelectedInstOperands,
     /*  861850 */     // GIR_Coverage, 24527,
     /*  861850 */     GIR_EraseRootFromParent_Done,
     /*  861851 */   // Label 13206: @861851
     /*  861851 */   GIM_Try, /*On fail goto*//*Label 13207*/ GIMT_Encode4(861926), // Rule ID 24530 //
     /*  861856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  861867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  861870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  861873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  861876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861902 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  861905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861924 */     GIR_RootConstrainSelectedInstOperands,
     /*  861925 */     // GIR_Coverage, 24530,
     /*  861925 */     GIR_EraseRootFromParent_Done,
     /*  861926 */   // Label 13207: @861926
     /*  861926 */   GIM_Try, /*On fail goto*//*Label 13208*/ GIMT_Encode4(862001), // Rule ID 24531 //
     /*  861931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  861942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  861945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  861948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  861951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861977 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  861980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861999 */     GIR_RootConstrainSelectedInstOperands,
     /*  862000 */     // GIR_Coverage, 24531,
     /*  862000 */     GIR_EraseRootFromParent_Done,
     /*  862001 */   // Label 13208: @862001
     /*  862001 */   GIM_Try, /*On fail goto*//*Label 13209*/ GIMT_Encode4(862076), // Rule ID 24534 //
     /*  862006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  862017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  862020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  862023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  862026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862052 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  862052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  862055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862074 */     GIR_RootConstrainSelectedInstOperands,
     /*  862075 */     // GIR_Coverage, 24534,
     /*  862075 */     GIR_EraseRootFromParent_Done,
     /*  862076 */   // Label 13209: @862076
     /*  862076 */   GIM_Try, /*On fail goto*//*Label 13210*/ GIMT_Encode4(862151), // Rule ID 24535 //
     /*  862081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  862092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  862095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  862098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  862101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862127 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  862127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  862130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862149 */     GIR_RootConstrainSelectedInstOperands,
     /*  862150 */     // GIR_Coverage, 24535,
     /*  862150 */     GIR_EraseRootFromParent_Done,
     /*  862151 */   // Label 13210: @862151
     /*  862151 */   GIM_Try, /*On fail goto*//*Label 13211*/ GIMT_Encode4(862226), // Rule ID 24538 //
     /*  862156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  862167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  862170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  862173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  862176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862202 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  862202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  862205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862224 */     GIR_RootConstrainSelectedInstOperands,
     /*  862225 */     // GIR_Coverage, 24538,
     /*  862225 */     GIR_EraseRootFromParent_Done,
     /*  862226 */   // Label 13211: @862226
     /*  862226 */   GIM_Try, /*On fail goto*//*Label 13212*/ GIMT_Encode4(862301), // Rule ID 24539 //
     /*  862231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  862242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  862245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  862248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  862251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862277 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  862277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  862280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862299 */     GIR_RootConstrainSelectedInstOperands,
     /*  862300 */     // GIR_Coverage, 24539,
     /*  862300 */     GIR_EraseRootFromParent_Done,
     /*  862301 */   // Label 13212: @862301
     /*  862301 */   GIM_Try, /*On fail goto*//*Label 13213*/ GIMT_Encode4(862376), // Rule ID 24542 //
     /*  862306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  862317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  862320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  862323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  862326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862352 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  862355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862374 */     GIR_RootConstrainSelectedInstOperands,
     /*  862375 */     // GIR_Coverage, 24542,
     /*  862375 */     GIR_EraseRootFromParent_Done,
     /*  862376 */   // Label 13213: @862376
     /*  862376 */   GIM_Try, /*On fail goto*//*Label 13214*/ GIMT_Encode4(862451), // Rule ID 24543 //
     /*  862381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  862392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  862395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  862398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  862401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862427 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  862430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862449 */     GIR_RootConstrainSelectedInstOperands,
     /*  862450 */     // GIR_Coverage, 24543,
     /*  862450 */     GIR_EraseRootFromParent_Done,
     /*  862451 */   // Label 13214: @862451
     /*  862451 */   GIM_Try, /*On fail goto*//*Label 13215*/ GIMT_Encode4(862526), // Rule ID 24546 //
     /*  862456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  862467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  862470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  862473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  862476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862502 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  862505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862524 */     GIR_RootConstrainSelectedInstOperands,
     /*  862525 */     // GIR_Coverage, 24546,
     /*  862525 */     GIR_EraseRootFromParent_Done,
     /*  862526 */   // Label 13215: @862526
     /*  862526 */   GIM_Try, /*On fail goto*//*Label 13216*/ GIMT_Encode4(862601), // Rule ID 24547 //
     /*  862531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  862542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  862545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  862548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  862551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862577 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  862580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862599 */     GIR_RootConstrainSelectedInstOperands,
     /*  862600 */     // GIR_Coverage, 24547,
     /*  862600 */     GIR_EraseRootFromParent_Done,
     /*  862601 */   // Label 13216: @862601
     /*  862601 */   GIM_Try, /*On fail goto*//*Label 13217*/ GIMT_Encode4(862676), // Rule ID 24550 //
     /*  862606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  862617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  862620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  862623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  862626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862652 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  862655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862674 */     GIR_RootConstrainSelectedInstOperands,
     /*  862675 */     // GIR_Coverage, 24550,
     /*  862675 */     GIR_EraseRootFromParent_Done,
     /*  862676 */   // Label 13217: @862676
     /*  862676 */   GIM_Try, /*On fail goto*//*Label 13218*/ GIMT_Encode4(862751), // Rule ID 24551 //
     /*  862681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  862692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  862695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  862698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  862701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862727 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  862730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862749 */     GIR_RootConstrainSelectedInstOperands,
     /*  862750 */     // GIR_Coverage, 24551,
     /*  862750 */     GIR_EraseRootFromParent_Done,
     /*  862751 */   // Label 13218: @862751
     /*  862751 */   GIM_Try, /*On fail goto*//*Label 13219*/ GIMT_Encode4(862826), // Rule ID 24554 //
     /*  862756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  862770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  862776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  862805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862824 */     GIR_RootConstrainSelectedInstOperands,
     /*  862825 */     // GIR_Coverage, 24554,
     /*  862825 */     GIR_EraseRootFromParent_Done,
     /*  862826 */   // Label 13219: @862826
     /*  862826 */   GIM_Try, /*On fail goto*//*Label 13220*/ GIMT_Encode4(862901), // Rule ID 24555 //
     /*  862831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  862845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  862851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  862877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  862880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862899 */     GIR_RootConstrainSelectedInstOperands,
     /*  862900 */     // GIR_Coverage, 24555,
     /*  862900 */     GIR_EraseRootFromParent_Done,
     /*  862901 */   // Label 13220: @862901
     /*  862901 */   GIM_Try, /*On fail goto*//*Label 13221*/ GIMT_Encode4(862976), // Rule ID 24558 //
     /*  862906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  862920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  862926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862952 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  862955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862974 */     GIR_RootConstrainSelectedInstOperands,
     /*  862975 */     // GIR_Coverage, 24558,
     /*  862975 */     GIR_EraseRootFromParent_Done,
     /*  862976 */   // Label 13221: @862976
     /*  862976 */   GIM_Try, /*On fail goto*//*Label 13222*/ GIMT_Encode4(863051), // Rule ID 24559 //
     /*  862981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  862995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  863001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863027 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  863027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  863030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863049 */     GIR_RootConstrainSelectedInstOperands,
     /*  863050 */     // GIR_Coverage, 24559,
     /*  863050 */     GIR_EraseRootFromParent_Done,
     /*  863051 */   // Label 13222: @863051
     /*  863051 */   GIM_Try, /*On fail goto*//*Label 13223*/ GIMT_Encode4(863126), // Rule ID 24562 //
     /*  863056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  863067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  863070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  863073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  863076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  863102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  863105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863124 */     GIR_RootConstrainSelectedInstOperands,
     /*  863125 */     // GIR_Coverage, 24562,
     /*  863125 */     GIR_EraseRootFromParent_Done,
     /*  863126 */   // Label 13223: @863126
     /*  863126 */   GIM_Try, /*On fail goto*//*Label 13224*/ GIMT_Encode4(863201), // Rule ID 24563 //
     /*  863131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  863142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  863145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  863148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  863151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863177 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  863177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  863180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863199 */     GIR_RootConstrainSelectedInstOperands,
     /*  863200 */     // GIR_Coverage, 24563,
     /*  863200 */     GIR_EraseRootFromParent_Done,
     /*  863201 */   // Label 13224: @863201
     /*  863201 */   GIM_Try, /*On fail goto*//*Label 13225*/ GIMT_Encode4(863276), // Rule ID 24566 //
     /*  863206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  863209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  863217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  863220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  863223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  863226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  863255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863274 */     GIR_RootConstrainSelectedInstOperands,
     /*  863275 */     // GIR_Coverage, 24566,
     /*  863275 */     GIR_EraseRootFromParent_Done,
     /*  863276 */   // Label 13225: @863276
     /*  863276 */   GIM_Try, /*On fail goto*//*Label 13226*/ GIMT_Encode4(863351), // Rule ID 24567 //
     /*  863281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  863292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  863295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  863298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  863301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863327 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  863330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863349 */     GIR_RootConstrainSelectedInstOperands,
     /*  863350 */     // GIR_Coverage, 24567,
     /*  863350 */     GIR_EraseRootFromParent_Done,
     /*  863351 */   // Label 13226: @863351
     /*  863351 */   GIM_Try, /*On fail goto*//*Label 13227*/ GIMT_Encode4(863426), // Rule ID 24570 //
     /*  863356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  863359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  863367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  863370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  863373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  863376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863402 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  863405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863424 */     GIR_RootConstrainSelectedInstOperands,
     /*  863425 */     // GIR_Coverage, 24570,
     /*  863425 */     GIR_EraseRootFromParent_Done,
     /*  863426 */   // Label 13227: @863426
     /*  863426 */   GIM_Try, /*On fail goto*//*Label 13228*/ GIMT_Encode4(863501), // Rule ID 24571 //
     /*  863431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  863442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  863445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  863448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  863451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863477 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  863480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863499 */     GIR_RootConstrainSelectedInstOperands,
     /*  863500 */     // GIR_Coverage, 24571,
     /*  863500 */     GIR_EraseRootFromParent_Done,
     /*  863501 */   // Label 13228: @863501
     /*  863501 */   GIM_Try, /*On fail goto*//*Label 13229*/ GIMT_Encode4(863576), // Rule ID 24574 //
     /*  863506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  863509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  863517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  863520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  863523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  863526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863552 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  863555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863574 */     GIR_RootConstrainSelectedInstOperands,
     /*  863575 */     // GIR_Coverage, 24574,
     /*  863575 */     GIR_EraseRootFromParent_Done,
     /*  863576 */   // Label 13229: @863576
     /*  863576 */   GIM_Try, /*On fail goto*//*Label 13230*/ GIMT_Encode4(863651), // Rule ID 24575 //
     /*  863581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  863592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  863595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  863598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  863601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863627 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  863630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863649 */     GIR_RootConstrainSelectedInstOperands,
     /*  863650 */     // GIR_Coverage, 24575,
     /*  863650 */     GIR_EraseRootFromParent_Done,
     /*  863651 */   // Label 13230: @863651
     /*  863651 */   GIM_Try, /*On fail goto*//*Label 13231*/ GIMT_Encode4(863726), // Rule ID 24578 //
     /*  863656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  863667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  863670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  863673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  863676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863702 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  863705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863724 */     GIR_RootConstrainSelectedInstOperands,
     /*  863725 */     // GIR_Coverage, 24578,
     /*  863725 */     GIR_EraseRootFromParent_Done,
     /*  863726 */   // Label 13231: @863726
     /*  863726 */   GIM_Try, /*On fail goto*//*Label 13232*/ GIMT_Encode4(863801), // Rule ID 24579 //
     /*  863731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  863742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  863745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  863748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863777 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  863780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863799 */     GIR_RootConstrainSelectedInstOperands,
     /*  863800 */     // GIR_Coverage, 24579,
     /*  863800 */     GIR_EraseRootFromParent_Done,
     /*  863801 */   // Label 13232: @863801
     /*  863801 */   GIM_Try, /*On fail goto*//*Label 13233*/ GIMT_Encode4(863876), // Rule ID 24582 //
     /*  863806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  863817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  863820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  863823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  863826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863852 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  863855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863874 */     GIR_RootConstrainSelectedInstOperands,
     /*  863875 */     // GIR_Coverage, 24582,
     /*  863875 */     GIR_EraseRootFromParent_Done,
     /*  863876 */   // Label 13233: @863876
     /*  863876 */   GIM_Try, /*On fail goto*//*Label 13234*/ GIMT_Encode4(863951), // Rule ID 24583 //
     /*  863881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  863892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  863895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  863898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863927 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  863930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863949 */     GIR_RootConstrainSelectedInstOperands,
     /*  863950 */     // GIR_Coverage, 24583,
     /*  863950 */     GIR_EraseRootFromParent_Done,
     /*  863951 */   // Label 13234: @863951
     /*  863951 */   GIM_Try, /*On fail goto*//*Label 13235*/ GIMT_Encode4(864026), // Rule ID 24586 //
     /*  863956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  863967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  863970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  863973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  863976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864002 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  864005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864024 */     GIR_RootConstrainSelectedInstOperands,
     /*  864025 */     // GIR_Coverage, 24586,
     /*  864025 */     GIR_EraseRootFromParent_Done,
     /*  864026 */   // Label 13235: @864026
     /*  864026 */   GIM_Try, /*On fail goto*//*Label 13236*/ GIMT_Encode4(864101), // Rule ID 24587 //
     /*  864031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  864042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  864045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  864048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864077 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  864080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864099 */     GIR_RootConstrainSelectedInstOperands,
     /*  864100 */     // GIR_Coverage, 24587,
     /*  864100 */     GIR_EraseRootFromParent_Done,
     /*  864101 */   // Label 13236: @864101
     /*  864101 */   GIM_Try, /*On fail goto*//*Label 13237*/ GIMT_Encode4(864176), // Rule ID 24590 //
     /*  864106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  864117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  864120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  864123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  864126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864152 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  864155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864174 */     GIR_RootConstrainSelectedInstOperands,
     /*  864175 */     // GIR_Coverage, 24590,
     /*  864175 */     GIR_EraseRootFromParent_Done,
     /*  864176 */   // Label 13237: @864176
     /*  864176 */   GIM_Try, /*On fail goto*//*Label 13238*/ GIMT_Encode4(864251), // Rule ID 24591 //
     /*  864181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  864192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  864195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  864198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864227 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  864230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864249 */     GIR_RootConstrainSelectedInstOperands,
     /*  864250 */     // GIR_Coverage, 24591,
     /*  864250 */     GIR_EraseRootFromParent_Done,
     /*  864251 */   // Label 13238: @864251
     /*  864251 */   GIM_Try, /*On fail goto*//*Label 13239*/ GIMT_Encode4(864326), // Rule ID 24594 //
     /*  864256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  864267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  864270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  864273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  864276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864302 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  864305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864324 */     GIR_RootConstrainSelectedInstOperands,
     /*  864325 */     // GIR_Coverage, 24594,
     /*  864325 */     GIR_EraseRootFromParent_Done,
     /*  864326 */   // Label 13239: @864326
     /*  864326 */   GIM_Try, /*On fail goto*//*Label 13240*/ GIMT_Encode4(864401), // Rule ID 24595 //
     /*  864331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  864342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  864345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  864348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864377 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  864380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864399 */     GIR_RootConstrainSelectedInstOperands,
     /*  864400 */     // GIR_Coverage, 24595,
     /*  864400 */     GIR_EraseRootFromParent_Done,
     /*  864401 */   // Label 13240: @864401
     /*  864401 */   GIM_Try, /*On fail goto*//*Label 13241*/ GIMT_Encode4(864476), // Rule ID 24598 //
     /*  864406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  864417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  864420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  864423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  864426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864452 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  864452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  864455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864474 */     GIR_RootConstrainSelectedInstOperands,
     /*  864475 */     // GIR_Coverage, 24598,
     /*  864475 */     GIR_EraseRootFromParent_Done,
     /*  864476 */   // Label 13241: @864476
     /*  864476 */   GIM_Try, /*On fail goto*//*Label 13242*/ GIMT_Encode4(864551), // Rule ID 24599 //
     /*  864481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  864492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  864495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  864498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864527 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  864527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  864530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864549 */     GIR_RootConstrainSelectedInstOperands,
     /*  864550 */     // GIR_Coverage, 24599,
     /*  864550 */     GIR_EraseRootFromParent_Done,
     /*  864551 */   // Label 13242: @864551
     /*  864551 */   GIM_Try, /*On fail goto*//*Label 13243*/ GIMT_Encode4(864626), // Rule ID 24602 //
     /*  864556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  864567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  864570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  864573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  864576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  864605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864624 */     GIR_RootConstrainSelectedInstOperands,
     /*  864625 */     // GIR_Coverage, 24602,
     /*  864625 */     GIR_EraseRootFromParent_Done,
     /*  864626 */   // Label 13243: @864626
     /*  864626 */   GIM_Try, /*On fail goto*//*Label 13244*/ GIMT_Encode4(864701), // Rule ID 24603 //
     /*  864631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  864642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  864645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  864648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864677 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  864680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864699 */     GIR_RootConstrainSelectedInstOperands,
     /*  864700 */     // GIR_Coverage, 24603,
     /*  864700 */     GIR_EraseRootFromParent_Done,
     /*  864701 */   // Label 13244: @864701
     /*  864701 */   GIM_Try, /*On fail goto*//*Label 13245*/ GIMT_Encode4(864776), // Rule ID 24606 //
     /*  864706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  864717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  864720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  864723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  864726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  864755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864774 */     GIR_RootConstrainSelectedInstOperands,
     /*  864775 */     // GIR_Coverage, 24606,
     /*  864775 */     GIR_EraseRootFromParent_Done,
     /*  864776 */   // Label 13245: @864776
     /*  864776 */   GIM_Try, /*On fail goto*//*Label 13246*/ GIMT_Encode4(864851), // Rule ID 24607 //
     /*  864781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  864792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  864795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  864798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  864830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864849 */     GIR_RootConstrainSelectedInstOperands,
     /*  864850 */     // GIR_Coverage, 24607,
     /*  864850 */     GIR_EraseRootFromParent_Done,
     /*  864851 */   // Label 13246: @864851
     /*  864851 */   GIM_Try, /*On fail goto*//*Label 13247*/ GIMT_Encode4(864926), // Rule ID 24610 //
     /*  864856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  864867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  864870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  864873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  864876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  864902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  864905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864924 */     GIR_RootConstrainSelectedInstOperands,
     /*  864925 */     // GIR_Coverage, 24610,
     /*  864925 */     GIR_EraseRootFromParent_Done,
     /*  864926 */   // Label 13247: @864926
     /*  864926 */   GIM_Try, /*On fail goto*//*Label 13248*/ GIMT_Encode4(865001), // Rule ID 24611 //
     /*  864931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  864942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  864945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  864948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864977 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  864977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  864980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864999 */     GIR_RootConstrainSelectedInstOperands,
     /*  865000 */     // GIR_Coverage, 24611,
     /*  865000 */     GIR_EraseRootFromParent_Done,
     /*  865001 */   // Label 13248: @865001
     /*  865001 */   GIM_Try, /*On fail goto*//*Label 13249*/ GIMT_Encode4(865076), // Rule ID 24614 //
     /*  865006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  865009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  865017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  865020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  865023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  865052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  865055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865074 */     GIR_RootConstrainSelectedInstOperands,
     /*  865075 */     // GIR_Coverage, 24614,
     /*  865075 */     GIR_EraseRootFromParent_Done,
     /*  865076 */   // Label 13249: @865076
     /*  865076 */   GIM_Try, /*On fail goto*//*Label 13250*/ GIMT_Encode4(865151), // Rule ID 24615 //
     /*  865081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  865084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  865092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  865095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  865098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865127 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  865127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  865130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865149 */     GIR_RootConstrainSelectedInstOperands,
     /*  865150 */     // GIR_Coverage, 24615,
     /*  865150 */     GIR_EraseRootFromParent_Done,
     /*  865151 */   // Label 13250: @865151
     /*  865151 */   GIM_Try, /*On fail goto*//*Label 13251*/ GIMT_Encode4(865226), // Rule ID 24618 //
     /*  865156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  865167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  865170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  865173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865202 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  865202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  865205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865224 */     GIR_RootConstrainSelectedInstOperands,
     /*  865225 */     // GIR_Coverage, 24618,
     /*  865225 */     GIR_EraseRootFromParent_Done,
     /*  865226 */   // Label 13251: @865226
     /*  865226 */   GIM_Try, /*On fail goto*//*Label 13252*/ GIMT_Encode4(865301), // Rule ID 24619 //
     /*  865231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  865242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  865245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  865248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865277 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  865277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  865280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865299 */     GIR_RootConstrainSelectedInstOperands,
     /*  865300 */     // GIR_Coverage, 24619,
     /*  865300 */     GIR_EraseRootFromParent_Done,
     /*  865301 */   // Label 13252: @865301
     /*  865301 */   GIM_Try, /*On fail goto*//*Label 13253*/ GIMT_Encode4(865376), // Rule ID 24622 //
     /*  865306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  865317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  865320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  865323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865352 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  865352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  865355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865374 */     GIR_RootConstrainSelectedInstOperands,
     /*  865375 */     // GIR_Coverage, 24622,
     /*  865375 */     GIR_EraseRootFromParent_Done,
     /*  865376 */   // Label 13253: @865376
     /*  865376 */   GIM_Try, /*On fail goto*//*Label 13254*/ GIMT_Encode4(865451), // Rule ID 24623 //
     /*  865381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  865392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  865395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  865398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865427 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  865427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  865430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865449 */     GIR_RootConstrainSelectedInstOperands,
     /*  865450 */     // GIR_Coverage, 24623,
     /*  865450 */     GIR_EraseRootFromParent_Done,
     /*  865451 */   // Label 13254: @865451
     /*  865451 */   GIM_Try, /*On fail goto*//*Label 13255*/ GIMT_Encode4(865526), // Rule ID 24626 //
     /*  865456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  865467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  865470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  865473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865502 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  865502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  865505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865524 */     GIR_RootConstrainSelectedInstOperands,
     /*  865525 */     // GIR_Coverage, 24626,
     /*  865525 */     GIR_EraseRootFromParent_Done,
     /*  865526 */   // Label 13255: @865526
     /*  865526 */   GIM_Try, /*On fail goto*//*Label 13256*/ GIMT_Encode4(865601), // Rule ID 24627 //
     /*  865531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  865542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  865545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  865548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865577 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  865577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  865580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865599 */     GIR_RootConstrainSelectedInstOperands,
     /*  865600 */     // GIR_Coverage, 24627,
     /*  865600 */     GIR_EraseRootFromParent_Done,
     /*  865601 */   // Label 13256: @865601
     /*  865601 */   GIM_Try, /*On fail goto*//*Label 13257*/ GIMT_Encode4(865676), // Rule ID 24630 //
     /*  865606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  865617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  865620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  865623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  865655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865674 */     GIR_RootConstrainSelectedInstOperands,
     /*  865675 */     // GIR_Coverage, 24630,
     /*  865675 */     GIR_EraseRootFromParent_Done,
     /*  865676 */   // Label 13257: @865676
     /*  865676 */   GIM_Try, /*On fail goto*//*Label 13258*/ GIMT_Encode4(865751), // Rule ID 24631 //
     /*  865681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  865692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  865695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  865698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865727 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  865730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865749 */     GIR_RootConstrainSelectedInstOperands,
     /*  865750 */     // GIR_Coverage, 24631,
     /*  865750 */     GIR_EraseRootFromParent_Done,
     /*  865751 */   // Label 13258: @865751
     /*  865751 */   GIM_Try, /*On fail goto*//*Label 13259*/ GIMT_Encode4(865826), // Rule ID 24634 //
     /*  865756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  865767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  865770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  865773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865802 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  865805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865824 */     GIR_RootConstrainSelectedInstOperands,
     /*  865825 */     // GIR_Coverage, 24634,
     /*  865825 */     GIR_EraseRootFromParent_Done,
     /*  865826 */   // Label 13259: @865826
     /*  865826 */   GIM_Try, /*On fail goto*//*Label 13260*/ GIMT_Encode4(865901), // Rule ID 24635 //
     /*  865831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  865842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  865845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  865848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865877 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  865880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865899 */     GIR_RootConstrainSelectedInstOperands,
     /*  865900 */     // GIR_Coverage, 24635,
     /*  865900 */     GIR_EraseRootFromParent_Done,
     /*  865901 */   // Label 13260: @865901
     /*  865901 */   GIM_Try, /*On fail goto*//*Label 13261*/ GIMT_Encode4(865976), // Rule ID 24638 //
     /*  865906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  865917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  865920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  865923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865952 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  865955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865974 */     GIR_RootConstrainSelectedInstOperands,
     /*  865975 */     // GIR_Coverage, 24638,
     /*  865975 */     GIR_EraseRootFromParent_Done,
     /*  865976 */   // Label 13261: @865976
     /*  865976 */   GIM_Try, /*On fail goto*//*Label 13262*/ GIMT_Encode4(866051), // Rule ID 24639 //
     /*  865981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  865992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  865995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  865998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866027 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  866027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  866030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866049 */     GIR_RootConstrainSelectedInstOperands,
     /*  866050 */     // GIR_Coverage, 24639,
     /*  866050 */     GIR_EraseRootFromParent_Done,
     /*  866051 */   // Label 13262: @866051
     /*  866051 */   GIM_Try, /*On fail goto*//*Label 13263*/ GIMT_Encode4(866126), // Rule ID 24642 //
     /*  866056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  866067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  866070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  866073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  866105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866124 */     GIR_RootConstrainSelectedInstOperands,
     /*  866125 */     // GIR_Coverage, 24642,
     /*  866125 */     GIR_EraseRootFromParent_Done,
     /*  866126 */   // Label 13263: @866126
     /*  866126 */   GIM_Try, /*On fail goto*//*Label 13264*/ GIMT_Encode4(866201), // Rule ID 24643 //
     /*  866131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  866142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  866145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  866148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  866180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866199 */     GIR_RootConstrainSelectedInstOperands,
     /*  866200 */     // GIR_Coverage, 24643,
     /*  866200 */     GIR_EraseRootFromParent_Done,
     /*  866201 */   // Label 13264: @866201
     /*  866201 */   GIM_Try, /*On fail goto*//*Label 13265*/ GIMT_Encode4(866276), // Rule ID 24646 //
     /*  866206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  866217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  866220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  866223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866252 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  866255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866274 */     GIR_RootConstrainSelectedInstOperands,
     /*  866275 */     // GIR_Coverage, 24646,
     /*  866275 */     GIR_EraseRootFromParent_Done,
     /*  866276 */   // Label 13265: @866276
     /*  866276 */   GIM_Try, /*On fail goto*//*Label 13266*/ GIMT_Encode4(866351), // Rule ID 24647 //
     /*  866281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  866292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  866295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  866298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866327 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  866330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866349 */     GIR_RootConstrainSelectedInstOperands,
     /*  866350 */     // GIR_Coverage, 24647,
     /*  866350 */     GIR_EraseRootFromParent_Done,
     /*  866351 */   // Label 13266: @866351
     /*  866351 */   GIM_Try, /*On fail goto*//*Label 13267*/ GIMT_Encode4(866426), // Rule ID 24650 //
     /*  866356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  866367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  866370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  866373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866402 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  866405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866424 */     GIR_RootConstrainSelectedInstOperands,
     /*  866425 */     // GIR_Coverage, 24650,
     /*  866425 */     GIR_EraseRootFromParent_Done,
     /*  866426 */   // Label 13267: @866426
     /*  866426 */   GIM_Try, /*On fail goto*//*Label 13268*/ GIMT_Encode4(866501), // Rule ID 24651 //
     /*  866431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  866442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  866445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  866448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866477 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  866480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866499 */     GIR_RootConstrainSelectedInstOperands,
     /*  866500 */     // GIR_Coverage, 24651,
     /*  866500 */     GIR_EraseRootFromParent_Done,
     /*  866501 */   // Label 13268: @866501
     /*  866501 */   GIM_Try, /*On fail goto*//*Label 13269*/ GIMT_Encode4(866576), // Rule ID 24654 //
     /*  866506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  866509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  866517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  866520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  866523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866552 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  866555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866574 */     GIR_RootConstrainSelectedInstOperands,
     /*  866575 */     // GIR_Coverage, 24654,
     /*  866575 */     GIR_EraseRootFromParent_Done,
     /*  866576 */   // Label 13269: @866576
     /*  866576 */   GIM_Try, /*On fail goto*//*Label 13270*/ GIMT_Encode4(866651), // Rule ID 24655 //
     /*  866581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  866584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  866592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  866595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  866598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866627 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  866630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866649 */     GIR_RootConstrainSelectedInstOperands,
     /*  866650 */     // GIR_Coverage, 24655,
     /*  866650 */     GIR_EraseRootFromParent_Done,
     /*  866651 */   // Label 13270: @866651
     /*  866651 */   GIM_Try, /*On fail goto*//*Label 13271*/ GIMT_Encode4(866726), // Rule ID 24658 //
     /*  866656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  866659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  866667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  866670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  866673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866702 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  866705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866724 */     GIR_RootConstrainSelectedInstOperands,
     /*  866725 */     // GIR_Coverage, 24658,
     /*  866725 */     GIR_EraseRootFromParent_Done,
     /*  866726 */   // Label 13271: @866726
     /*  866726 */   GIM_Try, /*On fail goto*//*Label 13272*/ GIMT_Encode4(866801), // Rule ID 24659 //
     /*  866731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  866734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  866742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  866745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  866748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866777 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  866780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866799 */     GIR_RootConstrainSelectedInstOperands,
     /*  866800 */     // GIR_Coverage, 24659,
     /*  866800 */     GIR_EraseRootFromParent_Done,
     /*  866801 */   // Label 13272: @866801
     /*  866801 */   GIM_Try, /*On fail goto*//*Label 13273*/ GIMT_Encode4(866876), // Rule ID 24662 //
     /*  866806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  866809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  866817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  866820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  866823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866852 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  866855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866874 */     GIR_RootConstrainSelectedInstOperands,
     /*  866875 */     // GIR_Coverage, 24662,
     /*  866875 */     GIR_EraseRootFromParent_Done,
     /*  866876 */   // Label 13273: @866876
     /*  866876 */   GIM_Try, /*On fail goto*//*Label 13274*/ GIMT_Encode4(866951), // Rule ID 24663 //
     /*  866881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  866884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  866892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  866895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  866898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866927 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  866930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866949 */     GIR_RootConstrainSelectedInstOperands,
     /*  866950 */     // GIR_Coverage, 24663,
     /*  866950 */     GIR_EraseRootFromParent_Done,
     /*  866951 */   // Label 13274: @866951
     /*  866951 */   GIM_Try, /*On fail goto*//*Label 13275*/ GIMT_Encode4(867026), // Rule ID 24754 //
     /*  866956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  866967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  866970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  866973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  866976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867002 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  867002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  867005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867024 */     GIR_RootConstrainSelectedInstOperands,
     /*  867025 */     // GIR_Coverage, 24754,
     /*  867025 */     GIR_EraseRootFromParent_Done,
     /*  867026 */   // Label 13275: @867026
     /*  867026 */   GIM_Try, /*On fail goto*//*Label 13276*/ GIMT_Encode4(867101), // Rule ID 24755 //
     /*  867031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  867042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  867045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  867048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  867051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867077 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  867077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  867080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867099 */     GIR_RootConstrainSelectedInstOperands,
     /*  867100 */     // GIR_Coverage, 24755,
     /*  867100 */     GIR_EraseRootFromParent_Done,
     /*  867101 */   // Label 13276: @867101
     /*  867101 */   GIM_Try, /*On fail goto*//*Label 13277*/ GIMT_Encode4(867176), // Rule ID 24758 //
     /*  867106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  867117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  867120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  867123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  867126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867152 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  867152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  867155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867174 */     GIR_RootConstrainSelectedInstOperands,
     /*  867175 */     // GIR_Coverage, 24758,
     /*  867175 */     GIR_EraseRootFromParent_Done,
     /*  867176 */   // Label 13277: @867176
     /*  867176 */   GIM_Try, /*On fail goto*//*Label 13278*/ GIMT_Encode4(867251), // Rule ID 24759 //
     /*  867181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  867192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  867195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  867198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  867201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867227 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  867227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  867230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867249 */     GIR_RootConstrainSelectedInstOperands,
     /*  867250 */     // GIR_Coverage, 24759,
     /*  867250 */     GIR_EraseRootFromParent_Done,
     /*  867251 */   // Label 13278: @867251
     /*  867251 */   GIM_Try, /*On fail goto*//*Label 13279*/ GIMT_Encode4(867326), // Rule ID 24762 //
     /*  867256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  867267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  867270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  867273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  867276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867302 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  867302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  867305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867324 */     GIR_RootConstrainSelectedInstOperands,
     /*  867325 */     // GIR_Coverage, 24762,
     /*  867325 */     GIR_EraseRootFromParent_Done,
     /*  867326 */   // Label 13279: @867326
     /*  867326 */   GIM_Try, /*On fail goto*//*Label 13280*/ GIMT_Encode4(867401), // Rule ID 24763 //
     /*  867331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  867342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  867345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  867348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  867351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867377 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  867377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  867380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867399 */     GIR_RootConstrainSelectedInstOperands,
     /*  867400 */     // GIR_Coverage, 24763,
     /*  867400 */     GIR_EraseRootFromParent_Done,
     /*  867401 */   // Label 13280: @867401
     /*  867401 */   GIM_Try, /*On fail goto*//*Label 13281*/ GIMT_Encode4(867476), // Rule ID 24766 //
     /*  867406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  867417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  867420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  867423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  867426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867452 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  867455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867474 */     GIR_RootConstrainSelectedInstOperands,
     /*  867475 */     // GIR_Coverage, 24766,
     /*  867475 */     GIR_EraseRootFromParent_Done,
     /*  867476 */   // Label 13281: @867476
     /*  867476 */   GIM_Try, /*On fail goto*//*Label 13282*/ GIMT_Encode4(867551), // Rule ID 24767 //
     /*  867481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  867492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  867495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  867498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  867501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867527 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  867530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867549 */     GIR_RootConstrainSelectedInstOperands,
     /*  867550 */     // GIR_Coverage, 24767,
     /*  867550 */     GIR_EraseRootFromParent_Done,
     /*  867551 */   // Label 13282: @867551
     /*  867551 */   GIM_Try, /*On fail goto*//*Label 13283*/ GIMT_Encode4(867626), // Rule ID 24770 //
     /*  867556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  867567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  867570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  867573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  867576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867602 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  867605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867624 */     GIR_RootConstrainSelectedInstOperands,
     /*  867625 */     // GIR_Coverage, 24770,
     /*  867625 */     GIR_EraseRootFromParent_Done,
     /*  867626 */   // Label 13283: @867626
     /*  867626 */   GIM_Try, /*On fail goto*//*Label 13284*/ GIMT_Encode4(867701), // Rule ID 24771 //
     /*  867631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  867642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  867645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  867648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  867651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867677 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  867680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867699 */     GIR_RootConstrainSelectedInstOperands,
     /*  867700 */     // GIR_Coverage, 24771,
     /*  867700 */     GIR_EraseRootFromParent_Done,
     /*  867701 */   // Label 13284: @867701
     /*  867701 */   GIM_Try, /*On fail goto*//*Label 13285*/ GIMT_Encode4(867776), // Rule ID 24774 //
     /*  867706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  867717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  867720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  867723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  867726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867752 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  867755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867774 */     GIR_RootConstrainSelectedInstOperands,
     /*  867775 */     // GIR_Coverage, 24774,
     /*  867775 */     GIR_EraseRootFromParent_Done,
     /*  867776 */   // Label 13285: @867776
     /*  867776 */   GIM_Try, /*On fail goto*//*Label 13286*/ GIMT_Encode4(867851), // Rule ID 24775 //
     /*  867781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  867792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  867795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  867798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  867801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867827 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  867830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867849 */     GIR_RootConstrainSelectedInstOperands,
     /*  867850 */     // GIR_Coverage, 24775,
     /*  867850 */     GIR_EraseRootFromParent_Done,
     /*  867851 */   // Label 13286: @867851
     /*  867851 */   GIM_Try, /*On fail goto*//*Label 13287*/ GIMT_Encode4(867926), // Rule ID 24778 //
     /*  867856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  867867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  867870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  867873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  867876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  867902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  867905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867924 */     GIR_RootConstrainSelectedInstOperands,
     /*  867925 */     // GIR_Coverage, 24778,
     /*  867925 */     GIR_EraseRootFromParent_Done,
     /*  867926 */   // Label 13287: @867926
     /*  867926 */   GIM_Try, /*On fail goto*//*Label 13288*/ GIMT_Encode4(868001), // Rule ID 24779 //
     /*  867931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  867942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  867945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  867948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  867951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867977 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  867977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  867980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867999 */     GIR_RootConstrainSelectedInstOperands,
     /*  868000 */     // GIR_Coverage, 24779,
     /*  868000 */     GIR_EraseRootFromParent_Done,
     /*  868001 */   // Label 13288: @868001
     /*  868001 */   GIM_Try, /*On fail goto*//*Label 13289*/ GIMT_Encode4(868076), // Rule ID 24782 //
     /*  868006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  868017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  868020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  868023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  868026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  868055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868074 */     GIR_RootConstrainSelectedInstOperands,
     /*  868075 */     // GIR_Coverage, 24782,
     /*  868075 */     GIR_EraseRootFromParent_Done,
     /*  868076 */   // Label 13289: @868076
     /*  868076 */   GIM_Try, /*On fail goto*//*Label 13290*/ GIMT_Encode4(868151), // Rule ID 24783 //
     /*  868081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  868092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  868095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  868098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  868101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  868127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  868130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868149 */     GIR_RootConstrainSelectedInstOperands,
     /*  868150 */     // GIR_Coverage, 24783,
     /*  868150 */     GIR_EraseRootFromParent_Done,
     /*  868151 */   // Label 13290: @868151
     /*  868151 */   GIM_Try, /*On fail goto*//*Label 13291*/ GIMT_Encode4(868226), // Rule ID 24786 //
     /*  868156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  868167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  868170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  868173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  868176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  868202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  868205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868224 */     GIR_RootConstrainSelectedInstOperands,
     /*  868225 */     // GIR_Coverage, 24786,
     /*  868225 */     GIR_EraseRootFromParent_Done,
     /*  868226 */   // Label 13291: @868226
     /*  868226 */   GIM_Try, /*On fail goto*//*Label 13292*/ GIMT_Encode4(868301), // Rule ID 24787 //
     /*  868231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  868242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  868245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  868248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  868251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  868277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  868280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868299 */     GIR_RootConstrainSelectedInstOperands,
     /*  868300 */     // GIR_Coverage, 24787,
     /*  868300 */     GIR_EraseRootFromParent_Done,
     /*  868301 */   // Label 13292: @868301
     /*  868301 */   GIM_Try, /*On fail goto*//*Label 13293*/ GIMT_Encode4(868376), // Rule ID 24790 //
     /*  868306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  868309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  868317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  868320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  868323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  868326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  868355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868374 */     GIR_RootConstrainSelectedInstOperands,
     /*  868375 */     // GIR_Coverage, 24790,
     /*  868375 */     GIR_EraseRootFromParent_Done,
     /*  868376 */   // Label 13293: @868376
     /*  868376 */   GIM_Try, /*On fail goto*//*Label 13294*/ GIMT_Encode4(868451), // Rule ID 24791 //
     /*  868381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  868384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  868392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  868395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  868398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  868401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868427 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  868430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868449 */     GIR_RootConstrainSelectedInstOperands,
     /*  868450 */     // GIR_Coverage, 24791,
     /*  868450 */     GIR_EraseRootFromParent_Done,
     /*  868451 */   // Label 13294: @868451
     /*  868451 */   GIM_Try, /*On fail goto*//*Label 13295*/ GIMT_Encode4(868526), // Rule ID 24794 //
     /*  868456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  868467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  868470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  868473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  868476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868502 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  868502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  868505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  868521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868524 */     GIR_RootConstrainSelectedInstOperands,
     /*  868525 */     // GIR_Coverage, 24794,
     /*  868525 */     GIR_EraseRootFromParent_Done,
     /*  868526 */   // Label 13295: @868526
     /*  868526 */   GIM_Try, /*On fail goto*//*Label 13296*/ GIMT_Encode4(868601), // Rule ID 24795 //
     /*  868531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  868542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  868545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  868548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  868551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868577 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  868577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  868580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  868596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868599 */     GIR_RootConstrainSelectedInstOperands,
     /*  868600 */     // GIR_Coverage, 24795,
     /*  868600 */     GIR_EraseRootFromParent_Done,
     /*  868601 */   // Label 13296: @868601
     /*  868601 */   GIM_Try, /*On fail goto*//*Label 13297*/ GIMT_Encode4(868676), // Rule ID 24798 //
     /*  868606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  868617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  868620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  868623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  868626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868652 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  868652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  868655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  868671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868674 */     GIR_RootConstrainSelectedInstOperands,
     /*  868675 */     // GIR_Coverage, 24798,
     /*  868675 */     GIR_EraseRootFromParent_Done,
     /*  868676 */   // Label 13297: @868676
     /*  868676 */   GIM_Try, /*On fail goto*//*Label 13298*/ GIMT_Encode4(868751), // Rule ID 24799 //
     /*  868681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  868692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  868695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  868698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  868701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868727 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  868727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  868730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  868746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868749 */     GIR_RootConstrainSelectedInstOperands,
     /*  868750 */     // GIR_Coverage, 24799,
     /*  868750 */     GIR_EraseRootFromParent_Done,
     /*  868751 */   // Label 13298: @868751
     /*  868751 */   GIM_Try, /*On fail goto*//*Label 13299*/ GIMT_Encode4(868826), // Rule ID 24802 //
     /*  868756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  868767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  868770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  868773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  868776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  868805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868824 */     GIR_RootConstrainSelectedInstOperands,
     /*  868825 */     // GIR_Coverage, 24802,
     /*  868825 */     GIR_EraseRootFromParent_Done,
     /*  868826 */   // Label 13299: @868826
     /*  868826 */   GIM_Try, /*On fail goto*//*Label 13300*/ GIMT_Encode4(868901), // Rule ID 24803 //
     /*  868831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  868842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  868845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  868848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  868851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868877 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  868877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  868880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868899 */     GIR_RootConstrainSelectedInstOperands,
     /*  868900 */     // GIR_Coverage, 24803,
     /*  868900 */     GIR_EraseRootFromParent_Done,
     /*  868901 */   // Label 13300: @868901
     /*  868901 */   GIM_Try, /*On fail goto*//*Label 13301*/ GIMT_Encode4(868976), // Rule ID 24806 //
     /*  868906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  868917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  868920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  868923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  868926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868952 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  868955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868974 */     GIR_RootConstrainSelectedInstOperands,
     /*  868975 */     // GIR_Coverage, 24806,
     /*  868975 */     GIR_EraseRootFromParent_Done,
     /*  868976 */   // Label 13301: @868976
     /*  868976 */   GIM_Try, /*On fail goto*//*Label 13302*/ GIMT_Encode4(869051), // Rule ID 24807 //
     /*  868981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  868992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  868995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  868998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  869001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869027 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  869030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869049 */     GIR_RootConstrainSelectedInstOperands,
     /*  869050 */     // GIR_Coverage, 24807,
     /*  869050 */     GIR_EraseRootFromParent_Done,
     /*  869051 */   // Label 13302: @869051
     /*  869051 */   GIM_Try, /*On fail goto*//*Label 13303*/ GIMT_Encode4(869126), // Rule ID 24810 //
     /*  869056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  869067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  869070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  869073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  869076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869102 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  869105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869124 */     GIR_RootConstrainSelectedInstOperands,
     /*  869125 */     // GIR_Coverage, 24810,
     /*  869125 */     GIR_EraseRootFromParent_Done,
     /*  869126 */   // Label 13303: @869126
     /*  869126 */   GIM_Try, /*On fail goto*//*Label 13304*/ GIMT_Encode4(869201), // Rule ID 24811 //
     /*  869131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  869142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  869145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  869148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  869151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869177 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  869180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869199 */     GIR_RootConstrainSelectedInstOperands,
     /*  869200 */     // GIR_Coverage, 24811,
     /*  869200 */     GIR_EraseRootFromParent_Done,
     /*  869201 */   // Label 13304: @869201
     /*  869201 */   GIM_Try, /*On fail goto*//*Label 13305*/ GIMT_Encode4(869276), // Rule ID 24814 //
     /*  869206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  869217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  869220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  869223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  869226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  869255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869274 */     GIR_RootConstrainSelectedInstOperands,
     /*  869275 */     // GIR_Coverage, 24814,
     /*  869275 */     GIR_EraseRootFromParent_Done,
     /*  869276 */   // Label 13305: @869276
     /*  869276 */   GIM_Try, /*On fail goto*//*Label 13306*/ GIMT_Encode4(869351), // Rule ID 24815 //
     /*  869281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  869292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  869295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  869298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  869301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869327 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  869330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869349 */     GIR_RootConstrainSelectedInstOperands,
     /*  869350 */     // GIR_Coverage, 24815,
     /*  869350 */     GIR_EraseRootFromParent_Done,
     /*  869351 */   // Label 13306: @869351
     /*  869351 */   GIM_Try, /*On fail goto*//*Label 13307*/ GIMT_Encode4(869426), // Rule ID 24818 //
     /*  869356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  869367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  869370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  869373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  869376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869402 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  869405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869424 */     GIR_RootConstrainSelectedInstOperands,
     /*  869425 */     // GIR_Coverage, 24818,
     /*  869425 */     GIR_EraseRootFromParent_Done,
     /*  869426 */   // Label 13307: @869426
     /*  869426 */   GIM_Try, /*On fail goto*//*Label 13308*/ GIMT_Encode4(869501), // Rule ID 24819 //
     /*  869431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  869442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  869445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  869448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  869451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869477 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  869480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869499 */     GIR_RootConstrainSelectedInstOperands,
     /*  869500 */     // GIR_Coverage, 24819,
     /*  869500 */     GIR_EraseRootFromParent_Done,
     /*  869501 */   // Label 13308: @869501
     /*  869501 */   GIM_Try, /*On fail goto*//*Label 13309*/ GIMT_Encode4(869576), // Rule ID 24822 //
     /*  869506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  869517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  869520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  869523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  869526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869552 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  869555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869574 */     GIR_RootConstrainSelectedInstOperands,
     /*  869575 */     // GIR_Coverage, 24822,
     /*  869575 */     GIR_EraseRootFromParent_Done,
     /*  869576 */   // Label 13309: @869576
     /*  869576 */   GIM_Try, /*On fail goto*//*Label 13310*/ GIMT_Encode4(869651), // Rule ID 24823 //
     /*  869581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  869592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  869595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  869598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  869601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869627 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  869630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869649 */     GIR_RootConstrainSelectedInstOperands,
     /*  869650 */     // GIR_Coverage, 24823,
     /*  869650 */     GIR_EraseRootFromParent_Done,
     /*  869651 */   // Label 13310: @869651
     /*  869651 */   GIM_Try, /*On fail goto*//*Label 13311*/ GIMT_Encode4(869726), // Rule ID 24826 //
     /*  869656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  869659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  869667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  869670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  869673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  869676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  869702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  869705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869724 */     GIR_RootConstrainSelectedInstOperands,
     /*  869725 */     // GIR_Coverage, 24826,
     /*  869725 */     GIR_EraseRootFromParent_Done,
     /*  869726 */   // Label 13311: @869726
     /*  869726 */   GIM_Try, /*On fail goto*//*Label 13312*/ GIMT_Encode4(869801), // Rule ID 24827 //
     /*  869731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  869734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  869742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  869745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  869748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  869751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869777 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  869777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  869780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869799 */     GIR_RootConstrainSelectedInstOperands,
     /*  869800 */     // GIR_Coverage, 24827,
     /*  869800 */     GIR_EraseRootFromParent_Done,
     /*  869801 */   // Label 13312: @869801
     /*  869801 */   GIM_Try, /*On fail goto*//*Label 13313*/ GIMT_Encode4(869876), // Rule ID 24830 //
     /*  869806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  869809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  869817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  869820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  869823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  869826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869852 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  869852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  869855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869874 */     GIR_RootConstrainSelectedInstOperands,
     /*  869875 */     // GIR_Coverage, 24830,
     /*  869875 */     GIR_EraseRootFromParent_Done,
     /*  869876 */   // Label 13313: @869876
     /*  869876 */   GIM_Try, /*On fail goto*//*Label 13314*/ GIMT_Encode4(869951), // Rule ID 24831 //
     /*  869881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  869884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  869892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  869895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  869898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  869901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869927 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  869927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  869930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869949 */     GIR_RootConstrainSelectedInstOperands,
     /*  869950 */     // GIR_Coverage, 24831,
     /*  869950 */     GIR_EraseRootFromParent_Done,
     /*  869951 */   // Label 13314: @869951
     /*  869951 */   GIM_Try, /*On fail goto*//*Label 13315*/ GIMT_Encode4(870026), // Rule ID 24834 //
     /*  869956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  869959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  869967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  869970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  869973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  869976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870002 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  870005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870024 */     GIR_RootConstrainSelectedInstOperands,
     /*  870025 */     // GIR_Coverage, 24834,
     /*  870025 */     GIR_EraseRootFromParent_Done,
     /*  870026 */   // Label 13315: @870026
     /*  870026 */   GIM_Try, /*On fail goto*//*Label 13316*/ GIMT_Encode4(870101), // Rule ID 24835 //
     /*  870031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  870034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  870042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  870045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  870048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  870051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870077 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  870077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  870080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870099 */     GIR_RootConstrainSelectedInstOperands,
     /*  870100 */     // GIR_Coverage, 24835,
     /*  870100 */     GIR_EraseRootFromParent_Done,
     /*  870101 */   // Label 13316: @870101
     /*  870101 */   GIM_Try, /*On fail goto*//*Label 13317*/ GIMT_Encode4(870176), // Rule ID 24838 //
     /*  870106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  870109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  870117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  870120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  870123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  870126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870152 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  870155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870174 */     GIR_RootConstrainSelectedInstOperands,
     /*  870175 */     // GIR_Coverage, 24838,
     /*  870175 */     GIR_EraseRootFromParent_Done,
     /*  870176 */   // Label 13317: @870176
     /*  870176 */   GIM_Try, /*On fail goto*//*Label 13318*/ GIMT_Encode4(870251), // Rule ID 24839 //
     /*  870181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  870184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  870192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  870195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  870198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  870201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870227 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  870230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870249 */     GIR_RootConstrainSelectedInstOperands,
     /*  870250 */     // GIR_Coverage, 24839,
     /*  870250 */     GIR_EraseRootFromParent_Done,
     /*  870251 */   // Label 13318: @870251
     /*  870251 */   GIM_Try, /*On fail goto*//*Label 13319*/ GIMT_Encode4(870326), // Rule ID 24842 //
     /*  870256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  870259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  870267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  870270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  870273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  870276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870302 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  870305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870324 */     GIR_RootConstrainSelectedInstOperands,
     /*  870325 */     // GIR_Coverage, 24842,
     /*  870325 */     GIR_EraseRootFromParent_Done,
     /*  870326 */   // Label 13319: @870326
     /*  870326 */   GIM_Try, /*On fail goto*//*Label 13320*/ GIMT_Encode4(870401), // Rule ID 24843 //
     /*  870331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  870334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  870342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  870345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  870348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  870351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870377 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  870380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870399 */     GIR_RootConstrainSelectedInstOperands,
     /*  870400 */     // GIR_Coverage, 24843,
     /*  870400 */     GIR_EraseRootFromParent_Done,
     /*  870401 */   // Label 13320: @870401
     /*  870401 */   GIM_Try, /*On fail goto*//*Label 13321*/ GIMT_Encode4(870476), // Rule ID 24846 //
     /*  870406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  870409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  870417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  870420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  870423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  870426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870452 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  870455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870474 */     GIR_RootConstrainSelectedInstOperands,
     /*  870475 */     // GIR_Coverage, 24846,
     /*  870475 */     GIR_EraseRootFromParent_Done,
     /*  870476 */   // Label 13321: @870476
     /*  870476 */   GIM_Try, /*On fail goto*//*Label 13322*/ GIMT_Encode4(870551), // Rule ID 24847 //
     /*  870481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  870484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  870492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  870495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  870498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  870501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870527 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  870527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  870530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870549 */     GIR_RootConstrainSelectedInstOperands,
     /*  870550 */     // GIR_Coverage, 24847,
     /*  870550 */     GIR_EraseRootFromParent_Done,
     /*  870551 */   // Label 13322: @870551
     /*  870551 */   GIM_Try, /*On fail goto*//*Label 13323*/ GIMT_Encode4(870626), // Rule ID 24850 //
     /*  870556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  870559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  870567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  870570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  870573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  870576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870602 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  870605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870624 */     GIR_RootConstrainSelectedInstOperands,
     /*  870625 */     // GIR_Coverage, 24850,
     /*  870625 */     GIR_EraseRootFromParent_Done,
     /*  870626 */   // Label 13323: @870626
     /*  870626 */   GIM_Try, /*On fail goto*//*Label 13324*/ GIMT_Encode4(870701), // Rule ID 24851 //
     /*  870631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  870634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  870642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  870645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  870648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  870651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870677 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  870680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870699 */     GIR_RootConstrainSelectedInstOperands,
     /*  870700 */     // GIR_Coverage, 24851,
     /*  870700 */     GIR_EraseRootFromParent_Done,
     /*  870701 */   // Label 13324: @870701
     /*  870701 */   GIM_Try, /*On fail goto*//*Label 13325*/ GIMT_Encode4(870776), // Rule ID 24854 //
     /*  870706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  870709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  870717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  870720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  870723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  870726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870752 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  870755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870774 */     GIR_RootConstrainSelectedInstOperands,
     /*  870775 */     // GIR_Coverage, 24854,
     /*  870775 */     GIR_EraseRootFromParent_Done,
     /*  870776 */   // Label 13325: @870776
     /*  870776 */   GIM_Try, /*On fail goto*//*Label 13326*/ GIMT_Encode4(870851), // Rule ID 24855 //
     /*  870781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  870784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  870792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  870795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  870798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  870801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870827 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  870830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870849 */     GIR_RootConstrainSelectedInstOperands,
     /*  870850 */     // GIR_Coverage, 24855,
     /*  870850 */     GIR_EraseRootFromParent_Done,
     /*  870851 */   // Label 13326: @870851
     /*  870851 */   GIM_Try, /*On fail goto*//*Label 13327*/ GIMT_Encode4(870926), // Rule ID 24858 //
     /*  870856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  870859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  870867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  870870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  870873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  870876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870902 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  870905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870924 */     GIR_RootConstrainSelectedInstOperands,
     /*  870925 */     // GIR_Coverage, 24858,
     /*  870925 */     GIR_EraseRootFromParent_Done,
     /*  870926 */   // Label 13327: @870926
     /*  870926 */   GIM_Try, /*On fail goto*//*Label 13328*/ GIMT_Encode4(871001), // Rule ID 24859 //
     /*  870931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  870934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  870942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  870945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  870948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  870951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870977 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  870980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870999 */     GIR_RootConstrainSelectedInstOperands,
     /*  871000 */     // GIR_Coverage, 24859,
     /*  871000 */     GIR_EraseRootFromParent_Done,
     /*  871001 */   // Label 13328: @871001
     /*  871001 */   GIM_Try, /*On fail goto*//*Label 13329*/ GIMT_Encode4(871076), // Rule ID 24862 //
     /*  871006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  871009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  871014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  871017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  871020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  871023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  871026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871052 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  871052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  871055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871074 */     GIR_RootConstrainSelectedInstOperands,
     /*  871075 */     // GIR_Coverage, 24862,
     /*  871075 */     GIR_EraseRootFromParent_Done,
     /*  871076 */   // Label 13329: @871076
     /*  871076 */   GIM_Try, /*On fail goto*//*Label 13330*/ GIMT_Encode4(871151), // Rule ID 24863 //
     /*  871081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  871084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  871089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  871092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  871095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  871098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  871101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871127 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  871130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871149 */     GIR_RootConstrainSelectedInstOperands,
     /*  871150 */     // GIR_Coverage, 24863,
     /*  871150 */     GIR_EraseRootFromParent_Done,
     /*  871151 */   // Label 13330: @871151
     /*  871151 */   GIM_Try, /*On fail goto*//*Label 13331*/ GIMT_Encode4(871226), // Rule ID 24866 //
     /*  871156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  871159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  871164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  871167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  871170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  871173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  871176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871202 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  871202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  871205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871224 */     GIR_RootConstrainSelectedInstOperands,
     /*  871225 */     // GIR_Coverage, 24866,
     /*  871225 */     GIR_EraseRootFromParent_Done,
     /*  871226 */   // Label 13331: @871226
     /*  871226 */   GIM_Try, /*On fail goto*//*Label 13332*/ GIMT_Encode4(871301), // Rule ID 24867 //
     /*  871231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  871234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  871239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  871242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  871245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  871248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  871251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871277 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  871280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871299 */     GIR_RootConstrainSelectedInstOperands,
     /*  871300 */     // GIR_Coverage, 24867,
     /*  871300 */     GIR_EraseRootFromParent_Done,
     /*  871301 */   // Label 13332: @871301
     /*  871301 */   GIM_Try, /*On fail goto*//*Label 13333*/ GIMT_Encode4(871376), // Rule ID 24870 //
     /*  871306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  871309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  871314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  871317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  871320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  871323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  871326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871352 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  871352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  871355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871374 */     GIR_RootConstrainSelectedInstOperands,
     /*  871375 */     // GIR_Coverage, 24870,
     /*  871375 */     GIR_EraseRootFromParent_Done,
     /*  871376 */   // Label 13333: @871376
     /*  871376 */   GIM_Try, /*On fail goto*//*Label 13334*/ GIMT_Encode4(871451), // Rule ID 24871 //
     /*  871381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  871384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  871389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  871392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  871395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  871398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  871401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871427 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  871430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871449 */     GIR_RootConstrainSelectedInstOperands,
     /*  871450 */     // GIR_Coverage, 24871,
     /*  871450 */     GIR_EraseRootFromParent_Done,
     /*  871451 */   // Label 13334: @871451
     /*  871451 */   GIM_Try, /*On fail goto*//*Label 13335*/ GIMT_Encode4(871526), // Rule ID 24874 //
     /*  871456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  871459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  871467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  871470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  871473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871502 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  871505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871524 */     GIR_RootConstrainSelectedInstOperands,
     /*  871525 */     // GIR_Coverage, 24874,
     /*  871525 */     GIR_EraseRootFromParent_Done,
     /*  871526 */   // Label 13335: @871526
     /*  871526 */   GIM_Try, /*On fail goto*//*Label 13336*/ GIMT_Encode4(871601), // Rule ID 24875 //
     /*  871531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  871534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  871542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  871545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  871548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871577 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  871580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871599 */     GIR_RootConstrainSelectedInstOperands,
     /*  871600 */     // GIR_Coverage, 24875,
     /*  871600 */     GIR_EraseRootFromParent_Done,
     /*  871601 */   // Label 13336: @871601
     /*  871601 */   GIM_Try, /*On fail goto*//*Label 13337*/ GIMT_Encode4(871676), // Rule ID 24878 //
     /*  871606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  871609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  871617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  871620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  871623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871652 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  871655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871674 */     GIR_RootConstrainSelectedInstOperands,
     /*  871675 */     // GIR_Coverage, 24878,
     /*  871675 */     GIR_EraseRootFromParent_Done,
     /*  871676 */   // Label 13337: @871676
     /*  871676 */   GIM_Try, /*On fail goto*//*Label 13338*/ GIMT_Encode4(871751), // Rule ID 24879 //
     /*  871681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  871684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  871692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  871695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  871698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871727 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  871730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871749 */     GIR_RootConstrainSelectedInstOperands,
     /*  871750 */     // GIR_Coverage, 24879,
     /*  871750 */     GIR_EraseRootFromParent_Done,
     /*  871751 */   // Label 13338: @871751
     /*  871751 */   GIM_Try, /*On fail goto*//*Label 13339*/ GIMT_Encode4(871826), // Rule ID 24882 //
     /*  871756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  871759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  871767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  871770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  871773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871802 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  871802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  871805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871824 */     GIR_RootConstrainSelectedInstOperands,
     /*  871825 */     // GIR_Coverage, 24882,
     /*  871825 */     GIR_EraseRootFromParent_Done,
     /*  871826 */   // Label 13339: @871826
     /*  871826 */   GIM_Try, /*On fail goto*//*Label 13340*/ GIMT_Encode4(871901), // Rule ID 24883 //
     /*  871831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  871834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  871842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  871845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  871848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871877 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  871880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871899 */     GIR_RootConstrainSelectedInstOperands,
     /*  871900 */     // GIR_Coverage, 24883,
     /*  871900 */     GIR_EraseRootFromParent_Done,
     /*  871901 */   // Label 13340: @871901
     /*  871901 */   GIM_Try, /*On fail goto*//*Label 13341*/ GIMT_Encode4(871976), // Rule ID 24886 //
     /*  871906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  871909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  871917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  871920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  871923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871952 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  871955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871974 */     GIR_RootConstrainSelectedInstOperands,
     /*  871975 */     // GIR_Coverage, 24886,
     /*  871975 */     GIR_EraseRootFromParent_Done,
     /*  871976 */   // Label 13341: @871976
     /*  871976 */   GIM_Try, /*On fail goto*//*Label 13342*/ GIMT_Encode4(872051), // Rule ID 24887 //
     /*  871981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  871984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  871992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  871995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  871998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872027 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  872030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872049 */     GIR_RootConstrainSelectedInstOperands,
     /*  872050 */     // GIR_Coverage, 24887,
     /*  872050 */     GIR_EraseRootFromParent_Done,
     /*  872051 */   // Label 13342: @872051
     /*  872051 */   GIM_Try, /*On fail goto*//*Label 13343*/ GIMT_Encode4(872126), // Rule ID 24890 //
     /*  872056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  872059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  872067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  872070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872102 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  872105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872124 */     GIR_RootConstrainSelectedInstOperands,
     /*  872125 */     // GIR_Coverage, 24890,
     /*  872125 */     GIR_EraseRootFromParent_Done,
     /*  872126 */   // Label 13343: @872126
     /*  872126 */   GIM_Try, /*On fail goto*//*Label 13344*/ GIMT_Encode4(872201), // Rule ID 24891 //
     /*  872131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  872134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  872142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  872145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872177 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  872180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872199 */     GIR_RootConstrainSelectedInstOperands,
     /*  872200 */     // GIR_Coverage, 24891,
     /*  872200 */     GIR_EraseRootFromParent_Done,
     /*  872201 */   // Label 13344: @872201
     /*  872201 */   GIM_Try, /*On fail goto*//*Label 13345*/ GIMT_Encode4(872276), // Rule ID 24894 //
     /*  872206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  872209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  872217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  872220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872252 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  872255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872274 */     GIR_RootConstrainSelectedInstOperands,
     /*  872275 */     // GIR_Coverage, 24894,
     /*  872275 */     GIR_EraseRootFromParent_Done,
     /*  872276 */   // Label 13345: @872276
     /*  872276 */   GIM_Try, /*On fail goto*//*Label 13346*/ GIMT_Encode4(872351), // Rule ID 24895 //
     /*  872281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  872284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  872292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  872295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872327 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  872330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872349 */     GIR_RootConstrainSelectedInstOperands,
     /*  872350 */     // GIR_Coverage, 24895,
     /*  872350 */     GIR_EraseRootFromParent_Done,
     /*  872351 */   // Label 13346: @872351
     /*  872351 */   GIM_Try, /*On fail goto*//*Label 13347*/ GIMT_Encode4(872426), // Rule ID 24898 //
     /*  872356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  872359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  872367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  872370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  872373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872402 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  872405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872424 */     GIR_RootConstrainSelectedInstOperands,
     /*  872425 */     // GIR_Coverage, 24898,
     /*  872425 */     GIR_EraseRootFromParent_Done,
     /*  872426 */   // Label 13347: @872426
     /*  872426 */   GIM_Try, /*On fail goto*//*Label 13348*/ GIMT_Encode4(872501), // Rule ID 24899 //
     /*  872431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  872434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  872442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  872445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  872448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872477 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  872480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872499 */     GIR_RootConstrainSelectedInstOperands,
     /*  872500 */     // GIR_Coverage, 24899,
     /*  872500 */     GIR_EraseRootFromParent_Done,
     /*  872501 */   // Label 13348: @872501
     /*  872501 */   GIM_Try, /*On fail goto*//*Label 13349*/ GIMT_Encode4(872576), // Rule ID 24902 //
     /*  872506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  872509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  872517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  872520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  872523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872552 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  872555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872574 */     GIR_RootConstrainSelectedInstOperands,
     /*  872575 */     // GIR_Coverage, 24902,
     /*  872575 */     GIR_EraseRootFromParent_Done,
     /*  872576 */   // Label 13349: @872576
     /*  872576 */   GIM_Try, /*On fail goto*//*Label 13350*/ GIMT_Encode4(872651), // Rule ID 24903 //
     /*  872581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  872584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  872592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  872595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  872598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872627 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  872630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872649 */     GIR_RootConstrainSelectedInstOperands,
     /*  872650 */     // GIR_Coverage, 24903,
     /*  872650 */     GIR_EraseRootFromParent_Done,
     /*  872651 */   // Label 13350: @872651
     /*  872651 */   GIM_Try, /*On fail goto*//*Label 13351*/ GIMT_Encode4(872726), // Rule ID 24906 //
     /*  872656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  872659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  872667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  872670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  872673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872702 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  872705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872724 */     GIR_RootConstrainSelectedInstOperands,
     /*  872725 */     // GIR_Coverage, 24906,
     /*  872725 */     GIR_EraseRootFromParent_Done,
     /*  872726 */   // Label 13351: @872726
     /*  872726 */   GIM_Try, /*On fail goto*//*Label 13352*/ GIMT_Encode4(872801), // Rule ID 24907 //
     /*  872731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  872734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  872742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  872745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  872748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872777 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  872780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872799 */     GIR_RootConstrainSelectedInstOperands,
     /*  872800 */     // GIR_Coverage, 24907,
     /*  872800 */     GIR_EraseRootFromParent_Done,
     /*  872801 */   // Label 13352: @872801
     /*  872801 */   GIM_Try, /*On fail goto*//*Label 13353*/ GIMT_Encode4(872876), // Rule ID 24946 //
     /*  872806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  872809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  872814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  872817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  872820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  872823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  872826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872852 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  872852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  872855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872874 */     GIR_RootConstrainSelectedInstOperands,
     /*  872875 */     // GIR_Coverage, 24946,
     /*  872875 */     GIR_EraseRootFromParent_Done,
     /*  872876 */   // Label 13353: @872876
     /*  872876 */   GIM_Try, /*On fail goto*//*Label 13354*/ GIMT_Encode4(872951), // Rule ID 24947 //
     /*  872881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  872884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  872889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  872892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  872895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  872898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  872901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872927 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  872927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  872930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872949 */     GIR_RootConstrainSelectedInstOperands,
     /*  872950 */     // GIR_Coverage, 24947,
     /*  872950 */     GIR_EraseRootFromParent_Done,
     /*  872951 */   // Label 13354: @872951
     /*  872951 */   GIM_Try, /*On fail goto*//*Label 13355*/ GIMT_Encode4(873026), // Rule ID 24950 //
     /*  872956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  872959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  872964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  872967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  872970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  872973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  872976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873002 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  873005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873024 */     GIR_RootConstrainSelectedInstOperands,
     /*  873025 */     // GIR_Coverage, 24950,
     /*  873025 */     GIR_EraseRootFromParent_Done,
     /*  873026 */   // Label 13355: @873026
     /*  873026 */   GIM_Try, /*On fail goto*//*Label 13356*/ GIMT_Encode4(873101), // Rule ID 24951 //
     /*  873031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  873051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873077 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  873080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873099 */     GIR_RootConstrainSelectedInstOperands,
     /*  873100 */     // GIR_Coverage, 24951,
     /*  873100 */     GIR_EraseRootFromParent_Done,
     /*  873101 */   // Label 13356: @873101
     /*  873101 */   GIM_Try, /*On fail goto*//*Label 13357*/ GIMT_Encode4(873176), // Rule ID 24954 //
     /*  873106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  873109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  873117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  873120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  873123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  873126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873152 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  873155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873174 */     GIR_RootConstrainSelectedInstOperands,
     /*  873175 */     // GIR_Coverage, 24954,
     /*  873175 */     GIR_EraseRootFromParent_Done,
     /*  873176 */   // Label 13357: @873176
     /*  873176 */   GIM_Try, /*On fail goto*//*Label 13358*/ GIMT_Encode4(873251), // Rule ID 24955 //
     /*  873181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  873192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  873195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  873198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  873201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873227 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  873230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873249 */     GIR_RootConstrainSelectedInstOperands,
     /*  873250 */     // GIR_Coverage, 24955,
     /*  873250 */     GIR_EraseRootFromParent_Done,
     /*  873251 */   // Label 13358: @873251
     /*  873251 */   GIM_Try, /*On fail goto*//*Label 13359*/ GIMT_Encode4(873326), // Rule ID 24958 //
     /*  873256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  873259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  873267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  873270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  873273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  873276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873302 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  873305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873324 */     GIR_RootConstrainSelectedInstOperands,
     /*  873325 */     // GIR_Coverage, 24958,
     /*  873325 */     GIR_EraseRootFromParent_Done,
     /*  873326 */   // Label 13359: @873326
     /*  873326 */   GIM_Try, /*On fail goto*//*Label 13360*/ GIMT_Encode4(873401), // Rule ID 24959 //
     /*  873331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  873342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  873345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  873348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  873351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873377 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  873380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873399 */     GIR_RootConstrainSelectedInstOperands,
     /*  873400 */     // GIR_Coverage, 24959,
     /*  873400 */     GIR_EraseRootFromParent_Done,
     /*  873401 */   // Label 13360: @873401
     /*  873401 */   GIM_Try, /*On fail goto*//*Label 13361*/ GIMT_Encode4(873476), // Rule ID 24962 //
     /*  873406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  873409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  873417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  873420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  873423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  873426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873452 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  873455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873474 */     GIR_RootConstrainSelectedInstOperands,
     /*  873475 */     // GIR_Coverage, 24962,
     /*  873475 */     GIR_EraseRootFromParent_Done,
     /*  873476 */   // Label 13361: @873476
     /*  873476 */   GIM_Try, /*On fail goto*//*Label 13362*/ GIMT_Encode4(873551), // Rule ID 24963 //
     /*  873481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  873492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  873495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  873498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  873501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873527 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  873530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873549 */     GIR_RootConstrainSelectedInstOperands,
     /*  873550 */     // GIR_Coverage, 24963,
     /*  873550 */     GIR_EraseRootFromParent_Done,
     /*  873551 */   // Label 13362: @873551
     /*  873551 */   GIM_Try, /*On fail goto*//*Label 13363*/ GIMT_Encode4(873626), // Rule ID 24966 //
     /*  873556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  873559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  873567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  873570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  873573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  873576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873602 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  873605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873624 */     GIR_RootConstrainSelectedInstOperands,
     /*  873625 */     // GIR_Coverage, 24966,
     /*  873625 */     GIR_EraseRootFromParent_Done,
     /*  873626 */   // Label 13363: @873626
     /*  873626 */   GIM_Try, /*On fail goto*//*Label 13364*/ GIMT_Encode4(873701), // Rule ID 24967 //
     /*  873631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  873642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  873645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  873648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  873651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873677 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  873680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873699 */     GIR_RootConstrainSelectedInstOperands,
     /*  873700 */     // GIR_Coverage, 24967,
     /*  873700 */     GIR_EraseRootFromParent_Done,
     /*  873701 */   // Label 13364: @873701
     /*  873701 */   GIM_Try, /*On fail goto*//*Label 13365*/ GIMT_Encode4(873776), // Rule ID 24970 //
     /*  873706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  873709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  873714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  873717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  873720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  873723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  873726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  873745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873752 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  873755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873774 */     GIR_RootConstrainSelectedInstOperands,
     /*  873775 */     // GIR_Coverage, 24970,
     /*  873775 */     GIR_EraseRootFromParent_Done,
     /*  873776 */   // Label 13365: @873776
     /*  873776 */   GIM_Try, /*On fail goto*//*Label 13366*/ GIMT_Encode4(873851), // Rule ID 24971 //
     /*  873781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  873789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  873792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  873795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  873798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  873801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  873820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873827 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  873830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873849 */     GIR_RootConstrainSelectedInstOperands,
     /*  873850 */     // GIR_Coverage, 24971,
     /*  873850 */     GIR_EraseRootFromParent_Done,
     /*  873851 */   // Label 13366: @873851
     /*  873851 */   GIM_Try, /*On fail goto*//*Label 13367*/ GIMT_Encode4(873926), // Rule ID 24974 //
     /*  873856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  873859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  873864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  873876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  873895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873902 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  873905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873924 */     GIR_RootConstrainSelectedInstOperands,
     /*  873925 */     // GIR_Coverage, 24974,
     /*  873925 */     GIR_EraseRootFromParent_Done,
     /*  873926 */   // Label 13367: @873926
     /*  873926 */   GIM_Try, /*On fail goto*//*Label 13368*/ GIMT_Encode4(874001), // Rule ID 24975 //
     /*  873931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  873939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  873951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  873970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873977 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  873980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873999 */     GIR_RootConstrainSelectedInstOperands,
     /*  874000 */     // GIR_Coverage, 24975,
     /*  874000 */     GIR_EraseRootFromParent_Done,
     /*  874001 */   // Label 13368: @874001
     /*  874001 */   GIM_Try, /*On fail goto*//*Label 13369*/ GIMT_Encode4(874076), // Rule ID 24978 //
     /*  874006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  874009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  874017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  874020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  874023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  874026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874052 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  874052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  874055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874074 */     GIR_RootConstrainSelectedInstOperands,
     /*  874075 */     // GIR_Coverage, 24978,
     /*  874075 */     GIR_EraseRootFromParent_Done,
     /*  874076 */   // Label 13369: @874076
     /*  874076 */   GIM_Try, /*On fail goto*//*Label 13370*/ GIMT_Encode4(874151), // Rule ID 24979 //
     /*  874081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  874084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  874092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  874095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  874098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  874101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874127 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  874127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  874130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874149 */     GIR_RootConstrainSelectedInstOperands,
     /*  874150 */     // GIR_Coverage, 24979,
     /*  874150 */     GIR_EraseRootFromParent_Done,
     /*  874151 */   // Label 13370: @874151
     /*  874151 */   GIM_Try, /*On fail goto*//*Label 13371*/ GIMT_Encode4(874226), // Rule ID 24982 //
     /*  874156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  874159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  874167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  874170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  874173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  874176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874202 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  874202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  874205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874224 */     GIR_RootConstrainSelectedInstOperands,
     /*  874225 */     // GIR_Coverage, 24982,
     /*  874225 */     GIR_EraseRootFromParent_Done,
     /*  874226 */   // Label 13371: @874226
     /*  874226 */   GIM_Try, /*On fail goto*//*Label 13372*/ GIMT_Encode4(874301), // Rule ID 24983 //
     /*  874231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  874234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  874242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  874245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  874248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  874251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874277 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  874277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  874280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874299 */     GIR_RootConstrainSelectedInstOperands,
     /*  874300 */     // GIR_Coverage, 24983,
     /*  874300 */     GIR_EraseRootFromParent_Done,
     /*  874301 */   // Label 13372: @874301
     /*  874301 */   GIM_Try, /*On fail goto*//*Label 13373*/ GIMT_Encode4(874376), // Rule ID 24986 //
     /*  874306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  874309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  874317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  874320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  874323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  874326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874352 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  874352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  874355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874374 */     GIR_RootConstrainSelectedInstOperands,
     /*  874375 */     // GIR_Coverage, 24986,
     /*  874375 */     GIR_EraseRootFromParent_Done,
     /*  874376 */   // Label 13373: @874376
     /*  874376 */   GIM_Try, /*On fail goto*//*Label 13374*/ GIMT_Encode4(874451), // Rule ID 24987 //
     /*  874381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  874384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  874392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  874395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  874398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  874401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874427 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  874427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  874430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874449 */     GIR_RootConstrainSelectedInstOperands,
     /*  874450 */     // GIR_Coverage, 24987,
     /*  874450 */     GIR_EraseRootFromParent_Done,
     /*  874451 */   // Label 13374: @874451
     /*  874451 */   GIM_Try, /*On fail goto*//*Label 13375*/ GIMT_Encode4(874526), // Rule ID 24990 //
     /*  874456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  874459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  874467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  874470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  874473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  874476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874502 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  874502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  874505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874524 */     GIR_RootConstrainSelectedInstOperands,
     /*  874525 */     // GIR_Coverage, 24990,
     /*  874525 */     GIR_EraseRootFromParent_Done,
     /*  874526 */   // Label 13375: @874526
     /*  874526 */   GIM_Try, /*On fail goto*//*Label 13376*/ GIMT_Encode4(874601), // Rule ID 24991 //
     /*  874531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  874534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  874542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  874545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  874548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  874551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874577 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  874577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  874580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874599 */     GIR_RootConstrainSelectedInstOperands,
     /*  874600 */     // GIR_Coverage, 24991,
     /*  874600 */     GIR_EraseRootFromParent_Done,
     /*  874601 */   // Label 13376: @874601
     /*  874601 */   GIM_Try, /*On fail goto*//*Label 13377*/ GIMT_Encode4(874676), // Rule ID 25018 //
     /*  874606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  874609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  874614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  874617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  874620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  874623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  874626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874652 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  874652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  874655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874674 */     GIR_RootConstrainSelectedInstOperands,
     /*  874675 */     // GIR_Coverage, 25018,
     /*  874675 */     GIR_EraseRootFromParent_Done,
     /*  874676 */   // Label 13377: @874676
     /*  874676 */   GIM_Try, /*On fail goto*//*Label 13378*/ GIMT_Encode4(874751), // Rule ID 25019 //
     /*  874681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  874684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  874689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  874692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  874695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  874698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  874701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874727 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  874727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  874730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874749 */     GIR_RootConstrainSelectedInstOperands,
     /*  874750 */     // GIR_Coverage, 25019,
     /*  874750 */     GIR_EraseRootFromParent_Done,
     /*  874751 */   // Label 13378: @874751
     /*  874751 */   GIM_Try, /*On fail goto*//*Label 13379*/ GIMT_Encode4(874826), // Rule ID 25022 //
     /*  874756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  874759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  874764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  874767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  874770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  874773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  874776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874802 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  874802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  874805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874824 */     GIR_RootConstrainSelectedInstOperands,
     /*  874825 */     // GIR_Coverage, 25022,
     /*  874825 */     GIR_EraseRootFromParent_Done,
     /*  874826 */   // Label 13379: @874826
     /*  874826 */   GIM_Try, /*On fail goto*//*Label 13380*/ GIMT_Encode4(874901), // Rule ID 25023 //
     /*  874831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  874834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  874839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  874842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  874845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  874848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  874851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874877 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  874877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  874880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874899 */     GIR_RootConstrainSelectedInstOperands,
     /*  874900 */     // GIR_Coverage, 25023,
     /*  874900 */     GIR_EraseRootFromParent_Done,
     /*  874901 */   // Label 13380: @874901
     /*  874901 */   GIM_Try, /*On fail goto*//*Label 13381*/ GIMT_Encode4(874976), // Rule ID 25026 //
     /*  874906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  874909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  874914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  874917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  874920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  874923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  874926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874952 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  874952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  874955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874974 */     GIR_RootConstrainSelectedInstOperands,
     /*  874975 */     // GIR_Coverage, 25026,
     /*  874975 */     GIR_EraseRootFromParent_Done,
     /*  874976 */   // Label 13381: @874976
     /*  874976 */   GIM_Try, /*On fail goto*//*Label 13382*/ GIMT_Encode4(875051), // Rule ID 25027 //
     /*  874981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  874984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  874989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  874992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  874995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  874998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  875001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875027 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  875027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  875030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875049 */     GIR_RootConstrainSelectedInstOperands,
     /*  875050 */     // GIR_Coverage, 25027,
     /*  875050 */     GIR_EraseRootFromParent_Done,
     /*  875051 */   // Label 13382: @875051
     /*  875051 */   GIM_Try, /*On fail goto*//*Label 13383*/ GIMT_Encode4(875126), // Rule ID 25030 //
     /*  875056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  875059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  875067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  875070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  875073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  875076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  875102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  875105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875124 */     GIR_RootConstrainSelectedInstOperands,
     /*  875125 */     // GIR_Coverage, 25030,
     /*  875125 */     GIR_EraseRootFromParent_Done,
     /*  875126 */   // Label 13383: @875126
     /*  875126 */   GIM_Try, /*On fail goto*//*Label 13384*/ GIMT_Encode4(875201), // Rule ID 25031 //
     /*  875131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  875134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  875142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  875145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  875148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  875151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875177 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  875177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  875180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875199 */     GIR_RootConstrainSelectedInstOperands,
     /*  875200 */     // GIR_Coverage, 25031,
     /*  875200 */     GIR_EraseRootFromParent_Done,
     /*  875201 */   // Label 13384: @875201
     /*  875201 */   GIM_Try, /*On fail goto*//*Label 13385*/ GIMT_Encode4(875276), // Rule ID 25034 //
     /*  875206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  875209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  875217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  875220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  875223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  875226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  875252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  875255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875274 */     GIR_RootConstrainSelectedInstOperands,
     /*  875275 */     // GIR_Coverage, 25034,
     /*  875275 */     GIR_EraseRootFromParent_Done,
     /*  875276 */   // Label 13385: @875276
     /*  875276 */   GIM_Try, /*On fail goto*//*Label 13386*/ GIMT_Encode4(875351), // Rule ID 25035 //
     /*  875281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  875284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  875292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  875295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  875298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  875301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875327 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  875327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  875330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875349 */     GIR_RootConstrainSelectedInstOperands,
     /*  875350 */     // GIR_Coverage, 25035,
     /*  875350 */     GIR_EraseRootFromParent_Done,
     /*  875351 */   // Label 13386: @875351
     /*  875351 */   GIM_Try, /*On fail goto*//*Label 13387*/ GIMT_Encode4(875426), // Rule ID 25038 //
     /*  875356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  875359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  875367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  875370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  875373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  875376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875402 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  875402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  875405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875424 */     GIR_RootConstrainSelectedInstOperands,
     /*  875425 */     // GIR_Coverage, 25038,
     /*  875425 */     GIR_EraseRootFromParent_Done,
     /*  875426 */   // Label 13387: @875426
     /*  875426 */   GIM_Try, /*On fail goto*//*Label 13388*/ GIMT_Encode4(875501), // Rule ID 25039 //
     /*  875431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  875434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  875442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  875445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  875448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  875451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875477 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  875477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  875480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875499 */     GIR_RootConstrainSelectedInstOperands,
     /*  875500 */     // GIR_Coverage, 25039,
     /*  875500 */     GIR_EraseRootFromParent_Done,
     /*  875501 */   // Label 13388: @875501
     /*  875501 */   GIM_Try, /*On fail goto*//*Label 13389*/ GIMT_Encode4(875576), // Rule ID 25042 //
     /*  875506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  875509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  875517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  875520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  875523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  875526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  875552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  875555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875574 */     GIR_RootConstrainSelectedInstOperands,
     /*  875575 */     // GIR_Coverage, 25042,
     /*  875575 */     GIR_EraseRootFromParent_Done,
     /*  875576 */   // Label 13389: @875576
     /*  875576 */   GIM_Try, /*On fail goto*//*Label 13390*/ GIMT_Encode4(875651), // Rule ID 25043 //
     /*  875581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  875584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  875592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  875595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  875598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  875601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875627 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  875627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  875630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875649 */     GIR_RootConstrainSelectedInstOperands,
     /*  875650 */     // GIR_Coverage, 25043,
     /*  875650 */     GIR_EraseRootFromParent_Done,
     /*  875651 */   // Label 13390: @875651
     /*  875651 */   GIM_Try, /*On fail goto*//*Label 13391*/ GIMT_Encode4(875726), // Rule ID 25046 //
     /*  875656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  875659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  875667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  875670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  875673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  875676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875702 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  875702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  875705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875724 */     GIR_RootConstrainSelectedInstOperands,
     /*  875725 */     // GIR_Coverage, 25046,
     /*  875725 */     GIR_EraseRootFromParent_Done,
     /*  875726 */   // Label 13391: @875726
     /*  875726 */   GIM_Try, /*On fail goto*//*Label 13392*/ GIMT_Encode4(875801), // Rule ID 25047 //
     /*  875731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  875734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  875742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  875745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  875748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  875751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875777 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  875777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  875780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875799 */     GIR_RootConstrainSelectedInstOperands,
     /*  875800 */     // GIR_Coverage, 25047,
     /*  875800 */     GIR_EraseRootFromParent_Done,
     /*  875801 */   // Label 13392: @875801
     /*  875801 */   GIM_Try, /*On fail goto*//*Label 13393*/ GIMT_Encode4(875876), // Rule ID 25050 //
     /*  875806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  875809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  875817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  875820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  875823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  875826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875852 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  875852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  875855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875874 */     GIR_RootConstrainSelectedInstOperands,
     /*  875875 */     // GIR_Coverage, 25050,
     /*  875875 */     GIR_EraseRootFromParent_Done,
     /*  875876 */   // Label 13393: @875876
     /*  875876 */   GIM_Try, /*On fail goto*//*Label 13394*/ GIMT_Encode4(875951), // Rule ID 25051 //
     /*  875881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  875884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  875892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  875895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  875898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  875901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875927 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  875927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  875930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875949 */     GIR_RootConstrainSelectedInstOperands,
     /*  875950 */     // GIR_Coverage, 25051,
     /*  875950 */     GIR_EraseRootFromParent_Done,
     /*  875951 */   // Label 13394: @875951
     /*  875951 */   GIM_Try, /*On fail goto*//*Label 13395*/ GIMT_Encode4(876026), // Rule ID 25054 //
     /*  875956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  875959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  875967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  875970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  875973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  875976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876002 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  876002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  876005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876024 */     GIR_RootConstrainSelectedInstOperands,
     /*  876025 */     // GIR_Coverage, 25054,
     /*  876025 */     GIR_EraseRootFromParent_Done,
     /*  876026 */   // Label 13395: @876026
     /*  876026 */   GIM_Try, /*On fail goto*//*Label 13396*/ GIMT_Encode4(876101), // Rule ID 25055 //
     /*  876031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  876034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  876042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  876045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  876048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  876051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876077 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  876077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  876080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876099 */     GIR_RootConstrainSelectedInstOperands,
     /*  876100 */     // GIR_Coverage, 25055,
     /*  876100 */     GIR_EraseRootFromParent_Done,
     /*  876101 */   // Label 13396: @876101
     /*  876101 */   GIM_Try, /*On fail goto*//*Label 13397*/ GIMT_Encode4(876176), // Rule ID 25058 //
     /*  876106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  876109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  876117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  876120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  876123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  876126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876152 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  876152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  876155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876174 */     GIR_RootConstrainSelectedInstOperands,
     /*  876175 */     // GIR_Coverage, 25058,
     /*  876175 */     GIR_EraseRootFromParent_Done,
     /*  876176 */   // Label 13397: @876176
     /*  876176 */   GIM_Try, /*On fail goto*//*Label 13398*/ GIMT_Encode4(876251), // Rule ID 25059 //
     /*  876181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  876184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  876192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  876195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  876198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  876201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876227 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  876227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  876230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876249 */     GIR_RootConstrainSelectedInstOperands,
     /*  876250 */     // GIR_Coverage, 25059,
     /*  876250 */     GIR_EraseRootFromParent_Done,
     /*  876251 */   // Label 13398: @876251
     /*  876251 */   GIM_Try, /*On fail goto*//*Label 13399*/ GIMT_Encode4(876326), // Rule ID 25062 //
     /*  876256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  876259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  876267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  876270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  876273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  876276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876302 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  876302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  876305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876324 */     GIR_RootConstrainSelectedInstOperands,
     /*  876325 */     // GIR_Coverage, 25062,
     /*  876325 */     GIR_EraseRootFromParent_Done,
     /*  876326 */   // Label 13399: @876326
     /*  876326 */   GIM_Try, /*On fail goto*//*Label 13400*/ GIMT_Encode4(876401), // Rule ID 25063 //
     /*  876331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  876334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  876342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  876345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  876348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  876351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876377 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  876377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  876380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876399 */     GIR_RootConstrainSelectedInstOperands,
     /*  876400 */     // GIR_Coverage, 25063,
     /*  876400 */     GIR_EraseRootFromParent_Done,
     /*  876401 */   // Label 13400: @876401
     /*  876401 */   GIM_Try, /*On fail goto*//*Label 13401*/ GIMT_Encode4(876476), // Rule ID 25066 //
     /*  876406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  876409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  876417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  876420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  876423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  876426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876452 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  876452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  876455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876474 */     GIR_RootConstrainSelectedInstOperands,
     /*  876475 */     // GIR_Coverage, 25066,
     /*  876475 */     GIR_EraseRootFromParent_Done,
     /*  876476 */   // Label 13401: @876476
     /*  876476 */   GIM_Try, /*On fail goto*//*Label 13402*/ GIMT_Encode4(876551), // Rule ID 25067 //
     /*  876481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  876484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  876492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  876495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  876498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  876501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876527 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  876527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  876530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876549 */     GIR_RootConstrainSelectedInstOperands,
     /*  876550 */     // GIR_Coverage, 25067,
     /*  876550 */     GIR_EraseRootFromParent_Done,
     /*  876551 */   // Label 13402: @876551
     /*  876551 */   GIM_Try, /*On fail goto*//*Label 13403*/ GIMT_Encode4(876626), // Rule ID 25070 //
     /*  876556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  876559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  876567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  876570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  876573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  876576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876602 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  876602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  876605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876624 */     GIR_RootConstrainSelectedInstOperands,
     /*  876625 */     // GIR_Coverage, 25070,
     /*  876625 */     GIR_EraseRootFromParent_Done,
     /*  876626 */   // Label 13403: @876626
     /*  876626 */   GIM_Try, /*On fail goto*//*Label 13404*/ GIMT_Encode4(876701), // Rule ID 25071 //
     /*  876631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  876634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  876642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  876645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  876648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  876651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876677 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  876677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  876680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876699 */     GIR_RootConstrainSelectedInstOperands,
     /*  876700 */     // GIR_Coverage, 25071,
     /*  876700 */     GIR_EraseRootFromParent_Done,
     /*  876701 */   // Label 13404: @876701
     /*  876701 */   GIM_Try, /*On fail goto*//*Label 13405*/ GIMT_Encode4(876776), // Rule ID 25074 //
     /*  876706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  876709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  876717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  876720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  876723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  876726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876752 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  876752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  876755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876774 */     GIR_RootConstrainSelectedInstOperands,
     /*  876775 */     // GIR_Coverage, 25074,
     /*  876775 */     GIR_EraseRootFromParent_Done,
     /*  876776 */   // Label 13405: @876776
     /*  876776 */   GIM_Try, /*On fail goto*//*Label 13406*/ GIMT_Encode4(876851), // Rule ID 25075 //
     /*  876781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  876784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  876792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  876795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  876798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  876801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876827 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  876827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  876830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876849 */     GIR_RootConstrainSelectedInstOperands,
     /*  876850 */     // GIR_Coverage, 25075,
     /*  876850 */     GIR_EraseRootFromParent_Done,
     /*  876851 */   // Label 13406: @876851
     /*  876851 */   GIM_Try, /*On fail goto*//*Label 13407*/ GIMT_Encode4(876923), // Rule ID 25078 //
     /*  876856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  876867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  876870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  876873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876902 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  876902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  876905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  876921 */     GIR_RootConstrainSelectedInstOperands,
     /*  876922 */     // GIR_Coverage, 25078,
     /*  876922 */     GIR_EraseRootFromParent_Done,
     /*  876923 */   // Label 13407: @876923
     /*  876923 */   GIM_Try, /*On fail goto*//*Label 13408*/ GIMT_Encode4(876995), // Rule ID 25079 //
     /*  876928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  876939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  876942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  876945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876974 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  876974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  876977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  876993 */     GIR_RootConstrainSelectedInstOperands,
     /*  876994 */     // GIR_Coverage, 25079,
     /*  876994 */     GIR_EraseRootFromParent_Done,
     /*  876995 */   // Label 13408: @876995
     /*  876995 */   GIM_Try, /*On fail goto*//*Label 13409*/ GIMT_Encode4(877067), // Rule ID 25080 //
     /*  877000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  877011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  877014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  877017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877046 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  877046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  877049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  877065 */     GIR_RootConstrainSelectedInstOperands,
     /*  877066 */     // GIR_Coverage, 25080,
     /*  877066 */     GIR_EraseRootFromParent_Done,
     /*  877067 */   // Label 13409: @877067
     /*  877067 */   GIM_Try, /*On fail goto*//*Label 13410*/ GIMT_Encode4(877139), // Rule ID 25081 //
     /*  877072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  877083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  877086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  877089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  877118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  877121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  877137 */     GIR_RootConstrainSelectedInstOperands,
     /*  877138 */     // GIR_Coverage, 25081,
     /*  877138 */     GIR_EraseRootFromParent_Done,
     /*  877139 */   // Label 13410: @877139
     /*  877139 */   GIM_Try, /*On fail goto*//*Label 13411*/ GIMT_Encode4(877211), // Rule ID 25082 //
     /*  877144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  877155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  877158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  877161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  877164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  877193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877209 */     GIR_RootConstrainSelectedInstOperands,
     /*  877210 */     // GIR_Coverage, 25082,
     /*  877210 */     GIR_EraseRootFromParent_Done,
     /*  877211 */   // Label 13411: @877211
     /*  877211 */   GIM_Try, /*On fail goto*//*Label 13412*/ GIMT_Encode4(877283), // Rule ID 25083 //
     /*  877216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  877227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  877230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  877233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  877236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877262 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  877265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877281 */     GIR_RootConstrainSelectedInstOperands,
     /*  877282 */     // GIR_Coverage, 25083,
     /*  877282 */     GIR_EraseRootFromParent_Done,
     /*  877283 */   // Label 13412: @877283
     /*  877283 */   GIM_Try, /*On fail goto*//*Label 13413*/ GIMT_Encode4(877355), // Rule ID 25084 //
     /*  877288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  877299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  877302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  877305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877334 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  877337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877353 */     GIR_RootConstrainSelectedInstOperands,
     /*  877354 */     // GIR_Coverage, 25084,
     /*  877354 */     GIR_EraseRootFromParent_Done,
     /*  877355 */   // Label 13413: @877355
     /*  877355 */   GIM_Try, /*On fail goto*//*Label 13414*/ GIMT_Encode4(877427), // Rule ID 25085 //
     /*  877360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  877371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  877374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  877377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877406 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  877409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877425 */     GIR_RootConstrainSelectedInstOperands,
     /*  877426 */     // GIR_Coverage, 25085,
     /*  877426 */     GIR_EraseRootFromParent_Done,
     /*  877427 */   // Label 13414: @877427
     /*  877427 */   GIM_Try, /*On fail goto*//*Label 13415*/ GIMT_Encode4(877499), // Rule ID 25086 //
     /*  877432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  877443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  877446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  877449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  877452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  877481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877497 */     GIR_RootConstrainSelectedInstOperands,
     /*  877498 */     // GIR_Coverage, 25086,
     /*  877498 */     GIR_EraseRootFromParent_Done,
     /*  877499 */   // Label 13415: @877499
     /*  877499 */   GIM_Try, /*On fail goto*//*Label 13416*/ GIMT_Encode4(877571), // Rule ID 25087 //
     /*  877504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  877515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  877518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  877521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  877524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877550 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  877553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877569 */     GIR_RootConstrainSelectedInstOperands,
     /*  877570 */     // GIR_Coverage, 25087,
     /*  877570 */     GIR_EraseRootFromParent_Done,
     /*  877571 */   // Label 13416: @877571
     /*  877571 */   GIM_Try, /*On fail goto*//*Label 13417*/ GIMT_Encode4(877643), // Rule ID 25088 //
     /*  877576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  877587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  877590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  877593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877622 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  877622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  877625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  877641 */     GIR_RootConstrainSelectedInstOperands,
     /*  877642 */     // GIR_Coverage, 25088,
     /*  877642 */     GIR_EraseRootFromParent_Done,
     /*  877643 */   // Label 13417: @877643
     /*  877643 */   GIM_Try, /*On fail goto*//*Label 13418*/ GIMT_Encode4(877715), // Rule ID 25089 //
     /*  877648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  877659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  877662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  877665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877694 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11151:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  877694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  877697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  877713 */     GIR_RootConstrainSelectedInstOperands,
     /*  877714 */     // GIR_Coverage, 25089,
     /*  877714 */     GIR_EraseRootFromParent_Done,
     /*  877715 */   // Label 13418: @877715
     /*  877715 */   GIM_Try, /*On fail goto*//*Label 13419*/ GIMT_Encode4(877787), // Rule ID 25090 //
     /*  877720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  877731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  877734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  877737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877766 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  877769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877785 */     GIR_RootConstrainSelectedInstOperands,
     /*  877786 */     // GIR_Coverage, 25090,
     /*  877786 */     GIR_EraseRootFromParent_Done,
     /*  877787 */   // Label 13419: @877787
     /*  877787 */   GIM_Try, /*On fail goto*//*Label 13420*/ GIMT_Encode4(877859), // Rule ID 25091 //
     /*  877792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  877803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  877806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  877809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877838 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  877841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877857 */     GIR_RootConstrainSelectedInstOperands,
     /*  877858 */     // GIR_Coverage, 25091,
     /*  877858 */     GIR_EraseRootFromParent_Done,
     /*  877859 */   // Label 13420: @877859
     /*  877859 */   GIM_Try, /*On fail goto*//*Label 13421*/ GIMT_Encode4(877931), // Rule ID 25092 //
     /*  877864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  877875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  877878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  877881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877910 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  877913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877929 */     GIR_RootConstrainSelectedInstOperands,
     /*  877930 */     // GIR_Coverage, 25092,
     /*  877930 */     GIR_EraseRootFromParent_Done,
     /*  877931 */   // Label 13421: @877931
     /*  877931 */   GIM_Try, /*On fail goto*//*Label 13422*/ GIMT_Encode4(878003), // Rule ID 25093 //
     /*  877936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  877947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  877950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  877953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877982 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  877985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878001 */     GIR_RootConstrainSelectedInstOperands,
     /*  878002 */     // GIR_Coverage, 25093,
     /*  878002 */     GIR_EraseRootFromParent_Done,
     /*  878003 */   // Label 13422: @878003
     /*  878003 */   GIM_Try, /*On fail goto*//*Label 13423*/ GIMT_Encode4(878075), // Rule ID 25094 //
     /*  878008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  878011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  878019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  878022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  878025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  878028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878054 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  878054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  878057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878073 */     GIR_RootConstrainSelectedInstOperands,
     /*  878074 */     // GIR_Coverage, 25094,
     /*  878074 */     GIR_EraseRootFromParent_Done,
     /*  878075 */   // Label 13423: @878075
     /*  878075 */   GIM_Try, /*On fail goto*//*Label 13424*/ GIMT_Encode4(878147), // Rule ID 25095 //
     /*  878080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  878083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  878091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  878094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  878097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  878100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  878126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  878129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878145 */     GIR_RootConstrainSelectedInstOperands,
     /*  878146 */     // GIR_Coverage, 25095,
     /*  878146 */     GIR_EraseRootFromParent_Done,
     /*  878147 */   // Label 13424: @878147
     /*  878147 */   GIM_Try, /*On fail goto*//*Label 13425*/ GIMT_Encode4(878219), // Rule ID 25096 //
     /*  878152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  878163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  878166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  878169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  878172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878198 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  878198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  878201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878217 */     GIR_RootConstrainSelectedInstOperands,
     /*  878218 */     // GIR_Coverage, 25096,
     /*  878218 */     GIR_EraseRootFromParent_Done,
     /*  878219 */   // Label 13425: @878219
     /*  878219 */   GIM_Try, /*On fail goto*//*Label 13426*/ GIMT_Encode4(878291), // Rule ID 25097 //
     /*  878224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  878235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  878238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  878241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  878244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878270 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  878270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  878273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878289 */     GIR_RootConstrainSelectedInstOperands,
     /*  878290 */     // GIR_Coverage, 25097,
     /*  878290 */     GIR_EraseRootFromParent_Done,
     /*  878291 */   // Label 13426: @878291
     /*  878291 */   GIM_Try, /*On fail goto*//*Label 13427*/ GIMT_Encode4(878363), // Rule ID 25098 //
     /*  878296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  878307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  878310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  878313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  878316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878342 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  878342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  878345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878361 */     GIR_RootConstrainSelectedInstOperands,
     /*  878362 */     // GIR_Coverage, 25098,
     /*  878362 */     GIR_EraseRootFromParent_Done,
     /*  878363 */   // Label 13427: @878363
     /*  878363 */   GIM_Try, /*On fail goto*//*Label 13428*/ GIMT_Encode4(878435), // Rule ID 25099 //
     /*  878368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  878379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  878382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  878385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  878388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878414 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  878414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  878417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878433 */     GIR_RootConstrainSelectedInstOperands,
     /*  878434 */     // GIR_Coverage, 25099,
     /*  878434 */     GIR_EraseRootFromParent_Done,
     /*  878435 */   // Label 13428: @878435
     /*  878435 */   GIM_Try, /*On fail goto*//*Label 13429*/ GIMT_Encode4(878507), // Rule ID 25100 //
     /*  878440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  878451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  878454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  878457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  878460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878486 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  878486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  878489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878505 */     GIR_RootConstrainSelectedInstOperands,
     /*  878506 */     // GIR_Coverage, 25100,
     /*  878506 */     GIR_EraseRootFromParent_Done,
     /*  878507 */   // Label 13429: @878507
     /*  878507 */   GIM_Try, /*On fail goto*//*Label 13430*/ GIMT_Encode4(878579), // Rule ID 25101 //
     /*  878512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  878523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  878526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  878529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  878532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878558 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  878558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  878561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878577 */     GIR_RootConstrainSelectedInstOperands,
     /*  878578 */     // GIR_Coverage, 25101,
     /*  878578 */     GIR_EraseRootFromParent_Done,
     /*  878579 */   // Label 13430: @878579
     /*  878579 */   GIM_Try, /*On fail goto*//*Label 13431*/ GIMT_Encode4(878651), // Rule ID 25102 //
     /*  878584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  878595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  878598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  878601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  878630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  878633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878649 */     GIR_RootConstrainSelectedInstOperands,
     /*  878650 */     // GIR_Coverage, 25102,
     /*  878650 */     GIR_EraseRootFromParent_Done,
     /*  878651 */   // Label 13431: @878651
     /*  878651 */   GIM_Try, /*On fail goto*//*Label 13432*/ GIMT_Encode4(878723), // Rule ID 25103 //
     /*  878656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  878667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  878670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  878673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  878702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  878705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878721 */     GIR_RootConstrainSelectedInstOperands,
     /*  878722 */     // GIR_Coverage, 25103,
     /*  878722 */     GIR_EraseRootFromParent_Done,
     /*  878723 */   // Label 13432: @878723
     /*  878723 */   GIM_Try, /*On fail goto*//*Label 13433*/ GIMT_Encode4(878795), // Rule ID 25104 //
     /*  878728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  878739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  878742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  878745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  878748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878774 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  878774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  878777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878793 */     GIR_RootConstrainSelectedInstOperands,
     /*  878794 */     // GIR_Coverage, 25104,
     /*  878794 */     GIR_EraseRootFromParent_Done,
     /*  878795 */   // Label 13433: @878795
     /*  878795 */   GIM_Try, /*On fail goto*//*Label 13434*/ GIMT_Encode4(878867), // Rule ID 25105 //
     /*  878800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  878811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  878814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  878817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  878820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878846 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  878846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  878849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878865 */     GIR_RootConstrainSelectedInstOperands,
     /*  878866 */     // GIR_Coverage, 25105,
     /*  878866 */     GIR_EraseRootFromParent_Done,
     /*  878867 */   // Label 13434: @878867
     /*  878867 */   GIM_Try, /*On fail goto*//*Label 13435*/ GIMT_Encode4(878939), // Rule ID 25106 //
     /*  878872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  878883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  878886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  878889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  878892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878918 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  878918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  878921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878937 */     GIR_RootConstrainSelectedInstOperands,
     /*  878938 */     // GIR_Coverage, 25106,
     /*  878938 */     GIR_EraseRootFromParent_Done,
     /*  878939 */   // Label 13435: @878939
     /*  878939 */   GIM_Try, /*On fail goto*//*Label 13436*/ GIMT_Encode4(879011), // Rule ID 25107 //
     /*  878944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  878955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  878958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  878961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  878964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878990 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  878990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  878993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879009 */     GIR_RootConstrainSelectedInstOperands,
     /*  879010 */     // GIR_Coverage, 25107,
     /*  879010 */     GIR_EraseRootFromParent_Done,
     /*  879011 */   // Label 13436: @879011
     /*  879011 */   GIM_Try, /*On fail goto*//*Label 13437*/ GIMT_Encode4(879083), // Rule ID 25108 //
     /*  879016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  879019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  879027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  879030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  879033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  879036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879062 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  879062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  879065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879081 */     GIR_RootConstrainSelectedInstOperands,
     /*  879082 */     // GIR_Coverage, 25108,
     /*  879082 */     GIR_EraseRootFromParent_Done,
     /*  879083 */   // Label 13437: @879083
     /*  879083 */   GIM_Try, /*On fail goto*//*Label 13438*/ GIMT_Encode4(879155), // Rule ID 25109 //
     /*  879088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  879091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  879099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  879102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  879105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  879108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  879134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  879137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879153 */     GIR_RootConstrainSelectedInstOperands,
     /*  879154 */     // GIR_Coverage, 25109,
     /*  879154 */     GIR_EraseRootFromParent_Done,
     /*  879155 */   // Label 13438: @879155
     /*  879155 */   GIM_Try, /*On fail goto*//*Label 13439*/ GIMT_Encode4(879227), // Rule ID 25110 //
     /*  879160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  879163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  879171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  879174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  879177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  879180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  879206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  879209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879225 */     GIR_RootConstrainSelectedInstOperands,
     /*  879226 */     // GIR_Coverage, 25110,
     /*  879226 */     GIR_EraseRootFromParent_Done,
     /*  879227 */   // Label 13439: @879227
     /*  879227 */   GIM_Try, /*On fail goto*//*Label 13440*/ GIMT_Encode4(879299), // Rule ID 25111 //
     /*  879232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  879235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  879243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  879246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  879249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  879252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879278 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  879278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  879281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879297 */     GIR_RootConstrainSelectedInstOperands,
     /*  879298 */     // GIR_Coverage, 25111,
     /*  879298 */     GIR_EraseRootFromParent_Done,
     /*  879299 */   // Label 13440: @879299
     /*  879299 */   GIM_Try, /*On fail goto*//*Label 13441*/ GIMT_Encode4(879371), // Rule ID 25112 //
     /*  879304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  879307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  879315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  879318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  879321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  879324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879350 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  879350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  879353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879369 */     GIR_RootConstrainSelectedInstOperands,
     /*  879370 */     // GIR_Coverage, 25112,
     /*  879370 */     GIR_EraseRootFromParent_Done,
     /*  879371 */   // Label 13441: @879371
     /*  879371 */   GIM_Try, /*On fail goto*//*Label 13442*/ GIMT_Encode4(879443), // Rule ID 25113 //
     /*  879376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  879379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  879387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  879390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  879393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  879396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879422 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  879422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  879425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879441 */     GIR_RootConstrainSelectedInstOperands,
     /*  879442 */     // GIR_Coverage, 25113,
     /*  879442 */     GIR_EraseRootFromParent_Done,
     /*  879443 */   // Label 13442: @879443
     /*  879443 */   GIM_Try, /*On fail goto*//*Label 13443*/ GIMT_Encode4(879515), // Rule ID 25114 //
     /*  879448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  879451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  879459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  879462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  879465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  879468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  879494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  879497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879513 */     GIR_RootConstrainSelectedInstOperands,
     /*  879514 */     // GIR_Coverage, 25114,
     /*  879514 */     GIR_EraseRootFromParent_Done,
     /*  879515 */   // Label 13443: @879515
     /*  879515 */   GIM_Try, /*On fail goto*//*Label 13444*/ GIMT_Encode4(879587), // Rule ID 25115 //
     /*  879520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  879523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  879531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  879534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  879537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  879540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  879566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  879569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879585 */     GIR_RootConstrainSelectedInstOperands,
     /*  879586 */     // GIR_Coverage, 25115,
     /*  879586 */     GIR_EraseRootFromParent_Done,
     /*  879587 */   // Label 13444: @879587
     /*  879587 */   GIM_Try, /*On fail goto*//*Label 13445*/ GIMT_Encode4(879659), // Rule ID 25116 //
     /*  879592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  879595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  879603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  879606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  879609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  879612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879638 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  879638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  879641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879657 */     GIR_RootConstrainSelectedInstOperands,
     /*  879658 */     // GIR_Coverage, 25116,
     /*  879658 */     GIR_EraseRootFromParent_Done,
     /*  879659 */   // Label 13445: @879659
     /*  879659 */   GIM_Try, /*On fail goto*//*Label 13446*/ GIMT_Encode4(879731), // Rule ID 25117 //
     /*  879664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  879667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  879675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  879678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  879681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  879684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879710 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  879710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  879713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879729 */     GIR_RootConstrainSelectedInstOperands,
     /*  879730 */     // GIR_Coverage, 25117,
     /*  879730 */     GIR_EraseRootFromParent_Done,
     /*  879731 */   // Label 13446: @879731
     /*  879731 */   GIM_Try, /*On fail goto*//*Label 13447*/ GIMT_Encode4(879803), // Rule ID 25118 //
     /*  879736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  879739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  879747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  879750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  879753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  879756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879782 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  879782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  879785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879801 */     GIR_RootConstrainSelectedInstOperands,
     /*  879802 */     // GIR_Coverage, 25118,
     /*  879802 */     GIR_EraseRootFromParent_Done,
     /*  879803 */   // Label 13447: @879803
     /*  879803 */   GIM_Try, /*On fail goto*//*Label 13448*/ GIMT_Encode4(879875), // Rule ID 25119 //
     /*  879808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  879811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  879819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  879822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  879825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  879828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879854 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  879854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  879857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879873 */     GIR_RootConstrainSelectedInstOperands,
     /*  879874 */     // GIR_Coverage, 25119,
     /*  879874 */     GIR_EraseRootFromParent_Done,
     /*  879875 */   // Label 13448: @879875
     /*  879875 */   GIM_Try, /*On fail goto*//*Label 13449*/ GIMT_Encode4(879947), // Rule ID 25120 //
     /*  879880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  879883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  879891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  879894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  879897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  879900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879926 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  879926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  879929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879945 */     GIR_RootConstrainSelectedInstOperands,
     /*  879946 */     // GIR_Coverage, 25120,
     /*  879946 */     GIR_EraseRootFromParent_Done,
     /*  879947 */   // Label 13449: @879947
     /*  879947 */   GIM_Try, /*On fail goto*//*Label 13450*/ GIMT_Encode4(880019), // Rule ID 25121 //
     /*  879952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  879955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  879963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  879966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  879969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  879972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879998 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  879998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  880001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880017 */     GIR_RootConstrainSelectedInstOperands,
     /*  880018 */     // GIR_Coverage, 25121,
     /*  880018 */     GIR_EraseRootFromParent_Done,
     /*  880019 */   // Label 13450: @880019
     /*  880019 */   GIM_Try, /*On fail goto*//*Label 13451*/ GIMT_Encode4(880091), // Rule ID 25122 //
     /*  880024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  880027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  880035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  880038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  880041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  880044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880070 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  880070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  880073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880089 */     GIR_RootConstrainSelectedInstOperands,
     /*  880090 */     // GIR_Coverage, 25122,
     /*  880090 */     GIR_EraseRootFromParent_Done,
     /*  880091 */   // Label 13451: @880091
     /*  880091 */   GIM_Try, /*On fail goto*//*Label 13452*/ GIMT_Encode4(880163), // Rule ID 25123 //
     /*  880096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  880099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  880107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  880110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  880113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  880116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880142 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  880142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  880145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880161 */     GIR_RootConstrainSelectedInstOperands,
     /*  880162 */     // GIR_Coverage, 25123,
     /*  880162 */     GIR_EraseRootFromParent_Done,
     /*  880163 */   // Label 13452: @880163
     /*  880163 */   GIM_Try, /*On fail goto*//*Label 13453*/ GIMT_Encode4(880235), // Rule ID 25124 //
     /*  880168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  880171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  880179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  880182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  880185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  880188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880214 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  880214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  880217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  880233 */     GIR_RootConstrainSelectedInstOperands,
     /*  880234 */     // GIR_Coverage, 25124,
     /*  880234 */     GIR_EraseRootFromParent_Done,
     /*  880235 */   // Label 13453: @880235
     /*  880235 */   GIM_Try, /*On fail goto*//*Label 13454*/ GIMT_Encode4(880307), // Rule ID 25125 //
     /*  880240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  880243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  880251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  880254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  880257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  880260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880286 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  880286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  880289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  880305 */     GIR_RootConstrainSelectedInstOperands,
     /*  880306 */     // GIR_Coverage, 25125,
     /*  880306 */     GIR_EraseRootFromParent_Done,
     /*  880307 */   // Label 13454: @880307
     /*  880307 */   GIM_Try, /*On fail goto*//*Label 13455*/ GIMT_Encode4(880379), // Rule ID 25126 //
     /*  880312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  880315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  880323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  880326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  880332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880358 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  880358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  880361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880377 */     GIR_RootConstrainSelectedInstOperands,
     /*  880378 */     // GIR_Coverage, 25126,
     /*  880378 */     GIR_EraseRootFromParent_Done,
     /*  880379 */   // Label 13455: @880379
     /*  880379 */   GIM_Try, /*On fail goto*//*Label 13456*/ GIMT_Encode4(880451), // Rule ID 25127 //
     /*  880384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  880387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  880395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  880398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  880404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880430 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  880430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  880433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880449 */     GIR_RootConstrainSelectedInstOperands,
     /*  880450 */     // GIR_Coverage, 25127,
     /*  880450 */     GIR_EraseRootFromParent_Done,
     /*  880451 */   // Label 13456: @880451
     /*  880451 */   GIM_Try, /*On fail goto*//*Label 13457*/ GIMT_Encode4(880523), // Rule ID 25128 //
     /*  880456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  880459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  880467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  880470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  880473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  880476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880502 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  880502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  880505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880521 */     GIR_RootConstrainSelectedInstOperands,
     /*  880522 */     // GIR_Coverage, 25128,
     /*  880522 */     GIR_EraseRootFromParent_Done,
     /*  880523 */   // Label 13457: @880523
     /*  880523 */   GIM_Try, /*On fail goto*//*Label 13458*/ GIMT_Encode4(880595), // Rule ID 25129 //
     /*  880528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  880531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  880539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  880542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  880545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  880548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880574 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  880574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  880577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880593 */     GIR_RootConstrainSelectedInstOperands,
     /*  880594 */     // GIR_Coverage, 25129,
     /*  880594 */     GIR_EraseRootFromParent_Done,
     /*  880595 */   // Label 13458: @880595
     /*  880595 */   GIM_Try, /*On fail goto*//*Label 13459*/ GIMT_Encode4(880667), // Rule ID 25130 //
     /*  880600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  880603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  880611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  880614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  880617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  880620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880646 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  880646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  880649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880665 */     GIR_RootConstrainSelectedInstOperands,
     /*  880666 */     // GIR_Coverage, 25130,
     /*  880666 */     GIR_EraseRootFromParent_Done,
     /*  880667 */   // Label 13459: @880667
     /*  880667 */   GIM_Try, /*On fail goto*//*Label 13460*/ GIMT_Encode4(880739), // Rule ID 25131 //
     /*  880672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  880675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  880683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  880686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  880689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  880692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880718 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  880718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  880721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880737 */     GIR_RootConstrainSelectedInstOperands,
     /*  880738 */     // GIR_Coverage, 25131,
     /*  880738 */     GIR_EraseRootFromParent_Done,
     /*  880739 */   // Label 13460: @880739
     /*  880739 */   GIM_Try, /*On fail goto*//*Label 13461*/ GIMT_Encode4(880811), // Rule ID 25132 //
     /*  880744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  880747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  880755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  880758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  880761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  880764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880790 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  880790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  880793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  880809 */     GIR_RootConstrainSelectedInstOperands,
     /*  880810 */     // GIR_Coverage, 25132,
     /*  880810 */     GIR_EraseRootFromParent_Done,
     /*  880811 */   // Label 13461: @880811
     /*  880811 */   GIM_Try, /*On fail goto*//*Label 13462*/ GIMT_Encode4(880883), // Rule ID 25133 //
     /*  880816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  880819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  880827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  880830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  880833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  880836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880862 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  880862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  880865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  880881 */     GIR_RootConstrainSelectedInstOperands,
     /*  880882 */     // GIR_Coverage, 25133,
     /*  880882 */     GIR_EraseRootFromParent_Done,
     /*  880883 */   // Label 13462: @880883
     /*  880883 */   GIM_Try, /*On fail goto*//*Label 13463*/ GIMT_Encode4(880955), // Rule ID 25134 //
     /*  880888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  880891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  880899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  880902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  880905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  880908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880934 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  880934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  880937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  880953 */     GIR_RootConstrainSelectedInstOperands,
     /*  880954 */     // GIR_Coverage, 25134,
     /*  880954 */     GIR_EraseRootFromParent_Done,
     /*  880955 */   // Label 13463: @880955
     /*  880955 */   GIM_Try, /*On fail goto*//*Label 13464*/ GIMT_Encode4(881027), // Rule ID 25135 //
     /*  880960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  880963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  880971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  880974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  880977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  880980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881006 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  881006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  881009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  881025 */     GIR_RootConstrainSelectedInstOperands,
     /*  881026 */     // GIR_Coverage, 25135,
     /*  881026 */     GIR_EraseRootFromParent_Done,
     /*  881027 */   // Label 13464: @881027
     /*  881027 */   GIM_Try, /*On fail goto*//*Label 13465*/ GIMT_Encode4(881099), // Rule ID 25136 //
     /*  881032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  881035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  881043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  881046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  881049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  881052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881078 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  881078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  881081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  881097 */     GIR_RootConstrainSelectedInstOperands,
     /*  881098 */     // GIR_Coverage, 25136,
     /*  881098 */     GIR_EraseRootFromParent_Done,
     /*  881099 */   // Label 13465: @881099
     /*  881099 */   GIM_Try, /*On fail goto*//*Label 13466*/ GIMT_Encode4(881171), // Rule ID 25137 //
     /*  881104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  881107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  881115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  881118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  881121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  881124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881150 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  881150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  881153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  881169 */     GIR_RootConstrainSelectedInstOperands,
     /*  881170 */     // GIR_Coverage, 25137,
     /*  881170 */     GIR_EraseRootFromParent_Done,
     /*  881171 */   // Label 13466: @881171
     /*  881171 */   GIM_Try, /*On fail goto*//*Label 13467*/ GIMT_Encode4(881243), // Rule ID 25138 //
     /*  881176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  881179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  881187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  881190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  881193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  881196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881222 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  881222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  881225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881241 */     GIR_RootConstrainSelectedInstOperands,
     /*  881242 */     // GIR_Coverage, 25138,
     /*  881242 */     GIR_EraseRootFromParent_Done,
     /*  881243 */   // Label 13467: @881243
     /*  881243 */   GIM_Try, /*On fail goto*//*Label 13468*/ GIMT_Encode4(881315), // Rule ID 25139 //
     /*  881248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  881251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  881259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  881262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  881265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  881268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881294 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  881294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  881297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881313 */     GIR_RootConstrainSelectedInstOperands,
     /*  881314 */     // GIR_Coverage, 25139,
     /*  881314 */     GIR_EraseRootFromParent_Done,
     /*  881315 */   // Label 13468: @881315
     /*  881315 */   GIM_Try, /*On fail goto*//*Label 13469*/ GIMT_Encode4(881387), // Rule ID 25140 //
     /*  881320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  881323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  881331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  881334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  881337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  881340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881366 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  881366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  881369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881385 */     GIR_RootConstrainSelectedInstOperands,
     /*  881386 */     // GIR_Coverage, 25140,
     /*  881386 */     GIR_EraseRootFromParent_Done,
     /*  881387 */   // Label 13469: @881387
     /*  881387 */   GIM_Try, /*On fail goto*//*Label 13470*/ GIMT_Encode4(881459), // Rule ID 25141 //
     /*  881392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  881395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  881403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  881406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  881409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  881412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881438 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  881438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  881441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881457 */     GIR_RootConstrainSelectedInstOperands,
     /*  881458 */     // GIR_Coverage, 25141,
     /*  881458 */     GIR_EraseRootFromParent_Done,
     /*  881459 */   // Label 13470: @881459
     /*  881459 */   GIM_Try, /*On fail goto*//*Label 13471*/ GIMT_Encode4(881531), // Rule ID 25142 //
     /*  881464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  881467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  881475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  881478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  881481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  881484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881510 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  881510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  881513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881529 */     GIR_RootConstrainSelectedInstOperands,
     /*  881530 */     // GIR_Coverage, 25142,
     /*  881530 */     GIR_EraseRootFromParent_Done,
     /*  881531 */   // Label 13471: @881531
     /*  881531 */   GIM_Try, /*On fail goto*//*Label 13472*/ GIMT_Encode4(881603), // Rule ID 25143 //
     /*  881536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  881539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  881547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  881550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  881553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  881556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881582 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  881582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  881585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881601 */     GIR_RootConstrainSelectedInstOperands,
     /*  881602 */     // GIR_Coverage, 25143,
     /*  881602 */     GIR_EraseRootFromParent_Done,
     /*  881603 */   // Label 13472: @881603
     /*  881603 */   GIM_Try, /*On fail goto*//*Label 13473*/ GIMT_Encode4(881675), // Rule ID 25144 //
     /*  881608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  881611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  881619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  881622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  881625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  881628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881654 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  881654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  881657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881673 */     GIR_RootConstrainSelectedInstOperands,
     /*  881674 */     // GIR_Coverage, 25144,
     /*  881674 */     GIR_EraseRootFromParent_Done,
     /*  881675 */   // Label 13473: @881675
     /*  881675 */   GIM_Try, /*On fail goto*//*Label 13474*/ GIMT_Encode4(881747), // Rule ID 25145 //
     /*  881680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  881683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  881691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  881694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  881697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  881700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881726 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  881726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  881729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881745 */     GIR_RootConstrainSelectedInstOperands,
     /*  881746 */     // GIR_Coverage, 25145,
     /*  881746 */     GIR_EraseRootFromParent_Done,
     /*  881747 */   // Label 13474: @881747
     /*  881747 */   GIM_Try, /*On fail goto*//*Label 13475*/ GIMT_Encode4(881819), // Rule ID 25146 //
     /*  881752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  881755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  881763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  881766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  881769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  881772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881798 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  881798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  881801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881817 */     GIR_RootConstrainSelectedInstOperands,
     /*  881818 */     // GIR_Coverage, 25146,
     /*  881818 */     GIR_EraseRootFromParent_Done,
     /*  881819 */   // Label 13475: @881819
     /*  881819 */   GIM_Try, /*On fail goto*//*Label 13476*/ GIMT_Encode4(881891), // Rule ID 25147 //
     /*  881824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  881827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  881835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  881838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  881841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  881844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881870 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  881870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  881873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881889 */     GIR_RootConstrainSelectedInstOperands,
     /*  881890 */     // GIR_Coverage, 25147,
     /*  881890 */     GIR_EraseRootFromParent_Done,
     /*  881891 */   // Label 13476: @881891
     /*  881891 */   GIM_Try, /*On fail goto*//*Label 13477*/ GIMT_Encode4(881963), // Rule ID 25148 //
     /*  881896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  881899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  881907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  881910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  881913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  881916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881942 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  881942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  881945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881961 */     GIR_RootConstrainSelectedInstOperands,
     /*  881962 */     // GIR_Coverage, 25148,
     /*  881962 */     GIR_EraseRootFromParent_Done,
     /*  881963 */   // Label 13477: @881963
     /*  881963 */   GIM_Try, /*On fail goto*//*Label 13478*/ GIMT_Encode4(882035), // Rule ID 25149 //
     /*  881968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  881971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  881979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  881982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  881985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  881988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882014 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  882014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  882017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882033 */     GIR_RootConstrainSelectedInstOperands,
     /*  882034 */     // GIR_Coverage, 25149,
     /*  882034 */     GIR_EraseRootFromParent_Done,
     /*  882035 */   // Label 13478: @882035
     /*  882035 */   GIM_Try, /*On fail goto*//*Label 13479*/ GIMT_Encode4(882110), // Rule ID 60604 //
     /*  882040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  882043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  882048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  882051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  882054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  882060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  882089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882108 */     GIR_RootConstrainSelectedInstOperands,
     /*  882109 */     // GIR_Coverage, 60604,
     /*  882109 */     GIR_EraseRootFromParent_Done,
     /*  882110 */   // Label 13479: @882110
     /*  882110 */   GIM_Try, /*On fail goto*//*Label 13480*/ GIMT_Encode4(882185), // Rule ID 60605 //
     /*  882115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  882118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  882123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  882126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  882129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  882135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882161 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  882164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882183 */     GIR_RootConstrainSelectedInstOperands,
     /*  882184 */     // GIR_Coverage, 60605,
     /*  882184 */     GIR_EraseRootFromParent_Done,
     /*  882185 */   // Label 13480: @882185
     /*  882185 */   GIM_Try, /*On fail goto*//*Label 13481*/ GIMT_Encode4(882260), // Rule ID 60962 //
     /*  882190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  882201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  882204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  882207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  882210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882236 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  882236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  882239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882258 */     GIR_RootConstrainSelectedInstOperands,
     /*  882259 */     // GIR_Coverage, 60962,
     /*  882259 */     GIR_EraseRootFromParent_Done,
     /*  882260 */   // Label 13481: @882260
     /*  882260 */   GIM_Try, /*On fail goto*//*Label 13482*/ GIMT_Encode4(882335), // Rule ID 60963 //
     /*  882265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  882276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  882279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  882282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  882285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882311 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  882311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  882314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882333 */     GIR_RootConstrainSelectedInstOperands,
     /*  882334 */     // GIR_Coverage, 60963,
     /*  882334 */     GIR_EraseRootFromParent_Done,
     /*  882335 */   // Label 13482: @882335
     /*  882335 */   GIM_Try, /*On fail goto*//*Label 13483*/ GIMT_Encode4(882410), // Rule ID 60966 //
     /*  882340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  882351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  882354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  882357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  882360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882386 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  882386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  882389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882408 */     GIR_RootConstrainSelectedInstOperands,
     /*  882409 */     // GIR_Coverage, 60966,
     /*  882409 */     GIR_EraseRootFromParent_Done,
     /*  882410 */   // Label 13483: @882410
     /*  882410 */   GIM_Try, /*On fail goto*//*Label 13484*/ GIMT_Encode4(882485), // Rule ID 60967 //
     /*  882415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  882426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  882429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  882432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  882435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882461 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  882461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  882464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882483 */     GIR_RootConstrainSelectedInstOperands,
     /*  882484 */     // GIR_Coverage, 60967,
     /*  882484 */     GIR_EraseRootFromParent_Done,
     /*  882485 */   // Label 13484: @882485
     /*  882485 */   GIM_Try, /*On fail goto*//*Label 13485*/ GIMT_Encode4(882560), // Rule ID 60970 //
     /*  882490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  882501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  882504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  882507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  882510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882536 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  882536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  882539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882558 */     GIR_RootConstrainSelectedInstOperands,
     /*  882559 */     // GIR_Coverage, 60970,
     /*  882559 */     GIR_EraseRootFromParent_Done,
     /*  882560 */   // Label 13485: @882560
     /*  882560 */   GIM_Try, /*On fail goto*//*Label 13486*/ GIMT_Encode4(882635), // Rule ID 60971 //
     /*  882565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  882576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  882579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  882582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  882585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882611 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  882611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  882614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882633 */     GIR_RootConstrainSelectedInstOperands,
     /*  882634 */     // GIR_Coverage, 60971,
     /*  882634 */     GIR_EraseRootFromParent_Done,
     /*  882635 */   // Label 13486: @882635
     /*  882635 */   GIM_Try, /*On fail goto*//*Label 13487*/ GIMT_Encode4(882710), // Rule ID 60974 //
     /*  882640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  882651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  882654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  882657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  882660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  882686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  882689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882708 */     GIR_RootConstrainSelectedInstOperands,
     /*  882709 */     // GIR_Coverage, 60974,
     /*  882709 */     GIR_EraseRootFromParent_Done,
     /*  882710 */   // Label 13487: @882710
     /*  882710 */   GIM_Try, /*On fail goto*//*Label 13488*/ GIMT_Encode4(882785), // Rule ID 60975 //
     /*  882715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  882726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  882729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  882732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  882735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882761 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  882761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  882764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882783 */     GIR_RootConstrainSelectedInstOperands,
     /*  882784 */     // GIR_Coverage, 60975,
     /*  882784 */     GIR_EraseRootFromParent_Done,
     /*  882785 */   // Label 13488: @882785
     /*  882785 */   GIM_Try, /*On fail goto*//*Label 13489*/ GIMT_Encode4(882860), // Rule ID 60978 //
     /*  882790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  882801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  882804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  882807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  882810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882836 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  882836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  882839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882858 */     GIR_RootConstrainSelectedInstOperands,
     /*  882859 */     // GIR_Coverage, 60978,
     /*  882859 */     GIR_EraseRootFromParent_Done,
     /*  882860 */   // Label 13489: @882860
     /*  882860 */   GIM_Try, /*On fail goto*//*Label 13490*/ GIMT_Encode4(882935), // Rule ID 60979 //
     /*  882865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  882876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  882879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  882882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  882885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882911 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  882911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  882914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882933 */     GIR_RootConstrainSelectedInstOperands,
     /*  882934 */     // GIR_Coverage, 60979,
     /*  882934 */     GIR_EraseRootFromParent_Done,
     /*  882935 */   // Label 13490: @882935
     /*  882935 */   GIM_Try, /*On fail goto*//*Label 13491*/ GIMT_Encode4(883010), // Rule ID 60982 //
     /*  882940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  882951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  882954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  882957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  882960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882986 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  882986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  882989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  883005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883008 */     GIR_RootConstrainSelectedInstOperands,
     /*  883009 */     // GIR_Coverage, 60982,
     /*  883009 */     GIR_EraseRootFromParent_Done,
     /*  883010 */   // Label 13491: @883010
     /*  883010 */   GIM_Try, /*On fail goto*//*Label 13492*/ GIMT_Encode4(883085), // Rule ID 60983 //
     /*  883015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  883026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  883029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  883032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  883035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883061 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  883061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  883064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  883080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883083 */     GIR_RootConstrainSelectedInstOperands,
     /*  883084 */     // GIR_Coverage, 60983,
     /*  883084 */     GIR_EraseRootFromParent_Done,
     /*  883085 */   // Label 13492: @883085
     /*  883085 */   GIM_Try, /*On fail goto*//*Label 13493*/ GIMT_Encode4(883160), // Rule ID 60986 //
     /*  883090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  883101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  883104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  883107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  883110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883136 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  883136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  883139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883158 */     GIR_RootConstrainSelectedInstOperands,
     /*  883159 */     // GIR_Coverage, 60986,
     /*  883159 */     GIR_EraseRootFromParent_Done,
     /*  883160 */   // Label 13493: @883160
     /*  883160 */   GIM_Try, /*On fail goto*//*Label 13494*/ GIMT_Encode4(883235), // Rule ID 60987 //
     /*  883165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  883176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  883179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  883182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  883185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883211 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  883211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  883214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883233 */     GIR_RootConstrainSelectedInstOperands,
     /*  883234 */     // GIR_Coverage, 60987,
     /*  883234 */     GIR_EraseRootFromParent_Done,
     /*  883235 */   // Label 13494: @883235
     /*  883235 */   GIM_Try, /*On fail goto*//*Label 13495*/ GIMT_Encode4(883310), // Rule ID 60990 //
     /*  883240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  883251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  883254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  883257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  883260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  883286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  883289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883308 */     GIR_RootConstrainSelectedInstOperands,
     /*  883309 */     // GIR_Coverage, 60990,
     /*  883309 */     GIR_EraseRootFromParent_Done,
     /*  883310 */   // Label 13495: @883310
     /*  883310 */   GIM_Try, /*On fail goto*//*Label 13496*/ GIMT_Encode4(883385), // Rule ID 60991 //
     /*  883315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  883326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  883329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  883332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  883335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883361 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  883361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  883364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883383 */     GIR_RootConstrainSelectedInstOperands,
     /*  883384 */     // GIR_Coverage, 60991,
     /*  883384 */     GIR_EraseRootFromParent_Done,
     /*  883385 */   // Label 13496: @883385
     /*  883385 */   GIM_Try, /*On fail goto*//*Label 13497*/ GIMT_Encode4(883460), // Rule ID 60994 //
     /*  883390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  883401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  883404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  883407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  883410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  883436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  883439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883458 */     GIR_RootConstrainSelectedInstOperands,
     /*  883459 */     // GIR_Coverage, 60994,
     /*  883459 */     GIR_EraseRootFromParent_Done,
     /*  883460 */   // Label 13497: @883460
     /*  883460 */   GIM_Try, /*On fail goto*//*Label 13498*/ GIMT_Encode4(883535), // Rule ID 60995 //
     /*  883465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  883476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  883479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  883482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  883485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883511 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  883511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  883514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883533 */     GIR_RootConstrainSelectedInstOperands,
     /*  883534 */     // GIR_Coverage, 60995,
     /*  883534 */     GIR_EraseRootFromParent_Done,
     /*  883535 */   // Label 13498: @883535
     /*  883535 */   GIM_Try, /*On fail goto*//*Label 13499*/ GIMT_Encode4(883610), // Rule ID 60998 //
     /*  883540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  883551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  883554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  883557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  883560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  883586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  883589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883608 */     GIR_RootConstrainSelectedInstOperands,
     /*  883609 */     // GIR_Coverage, 60998,
     /*  883609 */     GIR_EraseRootFromParent_Done,
     /*  883610 */   // Label 13499: @883610
     /*  883610 */   GIM_Try, /*On fail goto*//*Label 13500*/ GIMT_Encode4(883685), // Rule ID 60999 //
     /*  883615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  883626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  883629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  883632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  883635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883661 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  883661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  883664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883683 */     GIR_RootConstrainSelectedInstOperands,
     /*  883684 */     // GIR_Coverage, 60999,
     /*  883684 */     GIR_EraseRootFromParent_Done,
     /*  883685 */   // Label 13500: @883685
     /*  883685 */   GIM_Try, /*On fail goto*//*Label 13501*/ GIMT_Encode4(883760), // Rule ID 61002 //
     /*  883690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  883701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  883704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  883707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  883710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883736 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  883736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  883739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883758 */     GIR_RootConstrainSelectedInstOperands,
     /*  883759 */     // GIR_Coverage, 61002,
     /*  883759 */     GIR_EraseRootFromParent_Done,
     /*  883760 */   // Label 13501: @883760
     /*  883760 */   GIM_Try, /*On fail goto*//*Label 13502*/ GIMT_Encode4(883835), // Rule ID 61003 //
     /*  883765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  883776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  883779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  883782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  883785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883811 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  883811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  883814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883833 */     GIR_RootConstrainSelectedInstOperands,
     /*  883834 */     // GIR_Coverage, 61003,
     /*  883834 */     GIR_EraseRootFromParent_Done,
     /*  883835 */   // Label 13502: @883835
     /*  883835 */   GIM_Try, /*On fail goto*//*Label 13503*/ GIMT_Encode4(883910), // Rule ID 61006 //
     /*  883840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  883857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  883860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883886 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  883886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  883889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883908 */     GIR_RootConstrainSelectedInstOperands,
     /*  883909 */     // GIR_Coverage, 61006,
     /*  883909 */     GIR_EraseRootFromParent_Done,
     /*  883910 */   // Label 13503: @883910
     /*  883910 */   GIM_Try, /*On fail goto*//*Label 13504*/ GIMT_Encode4(883985), // Rule ID 61007 //
     /*  883915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  883932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  883935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883961 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  883961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  883964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883983 */     GIR_RootConstrainSelectedInstOperands,
     /*  883984 */     // GIR_Coverage, 61007,
     /*  883984 */     GIR_EraseRootFromParent_Done,
     /*  883985 */   // Label 13504: @883985
     /*  883985 */   GIM_Try, /*On fail goto*//*Label 13505*/ GIMT_Encode4(884060), // Rule ID 61010 //
     /*  883990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  884007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  884010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  884036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  884039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  884055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884058 */     GIR_RootConstrainSelectedInstOperands,
     /*  884059 */     // GIR_Coverage, 61010,
     /*  884059 */     GIR_EraseRootFromParent_Done,
     /*  884060 */   // Label 13505: @884060
     /*  884060 */   GIM_Try, /*On fail goto*//*Label 13506*/ GIMT_Encode4(884135), // Rule ID 61011 //
     /*  884065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  884082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  884085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884111 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  884111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  884114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  884130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884133 */     GIR_RootConstrainSelectedInstOperands,
     /*  884134 */     // GIR_Coverage, 61011,
     /*  884134 */     GIR_EraseRootFromParent_Done,
     /*  884135 */   // Label 13506: @884135
     /*  884135 */   GIM_Try, /*On fail goto*//*Label 13507*/ GIMT_Encode4(884210), // Rule ID 61014 //
     /*  884140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  884143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  884157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  884160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884186 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  884186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  884189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  884205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884208 */     GIR_RootConstrainSelectedInstOperands,
     /*  884209 */     // GIR_Coverage, 61014,
     /*  884209 */     GIR_EraseRootFromParent_Done,
     /*  884210 */   // Label 13507: @884210
     /*  884210 */   GIM_Try, /*On fail goto*//*Label 13508*/ GIMT_Encode4(884285), // Rule ID 61015 //
     /*  884215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  884232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  884235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884261 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  884261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  884264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  884280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884283 */     GIR_RootConstrainSelectedInstOperands,
     /*  884284 */     // GIR_Coverage, 61015,
     /*  884284 */     GIR_EraseRootFromParent_Done,
     /*  884285 */   // Label 13508: @884285
     /*  884285 */   GIM_Try, /*On fail goto*//*Label 13509*/ GIMT_Encode4(884360), // Rule ID 61018 //
     /*  884290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  884293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  884307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  884310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884336 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  884336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  884339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  884355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884358 */     GIR_RootConstrainSelectedInstOperands,
     /*  884359 */     // GIR_Coverage, 61018,
     /*  884359 */     GIR_EraseRootFromParent_Done,
     /*  884360 */   // Label 13509: @884360
     /*  884360 */   GIM_Try, /*On fail goto*//*Label 13510*/ GIMT_Encode4(884435), // Rule ID 61019 //
     /*  884365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  884382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  884385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884411 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  884411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  884414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  884430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884433 */     GIR_RootConstrainSelectedInstOperands,
     /*  884434 */     // GIR_Coverage, 61019,
     /*  884434 */     GIR_EraseRootFromParent_Done,
     /*  884435 */   // Label 13510: @884435
     /*  884435 */   GIM_Try, /*On fail goto*//*Label 13511*/ GIMT_Encode4(884510), // Rule ID 61022 //
     /*  884440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  884443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  884451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  884454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  884457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884486 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  884486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  884489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884508 */     GIR_RootConstrainSelectedInstOperands,
     /*  884509 */     // GIR_Coverage, 61022,
     /*  884509 */     GIR_EraseRootFromParent_Done,
     /*  884510 */   // Label 13511: @884510
     /*  884510 */   GIM_Try, /*On fail goto*//*Label 13512*/ GIMT_Encode4(884585), // Rule ID 61023 //
     /*  884515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  884526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  884529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  884532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884561 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  884561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  884564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884583 */     GIR_RootConstrainSelectedInstOperands,
     /*  884584 */     // GIR_Coverage, 61023,
     /*  884584 */     GIR_EraseRootFromParent_Done,
     /*  884585 */   // Label 13512: @884585
     /*  884585 */   GIM_Try, /*On fail goto*//*Label 13513*/ GIMT_Encode4(884660), // Rule ID 61030 //
     /*  884590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  884593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  884601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  884604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  884607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884636 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  884636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  884639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884658 */     GIR_RootConstrainSelectedInstOperands,
     /*  884659 */     // GIR_Coverage, 61030,
     /*  884659 */     GIR_EraseRootFromParent_Done,
     /*  884660 */   // Label 13513: @884660
     /*  884660 */   GIM_Try, /*On fail goto*//*Label 13514*/ GIMT_Encode4(884735), // Rule ID 61031 //
     /*  884665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  884676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  884679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  884682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884711 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  884711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  884714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884733 */     GIR_RootConstrainSelectedInstOperands,
     /*  884734 */     // GIR_Coverage, 61031,
     /*  884734 */     GIR_EraseRootFromParent_Done,
     /*  884735 */   // Label 13514: @884735
     /*  884735 */   GIM_Try, /*On fail goto*//*Label 13515*/ GIMT_Encode4(884810), // Rule ID 61038 //
     /*  884740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  884743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  884751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  884754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  884757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884786 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  884786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  884789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884808 */     GIR_RootConstrainSelectedInstOperands,
     /*  884809 */     // GIR_Coverage, 61038,
     /*  884809 */     GIR_EraseRootFromParent_Done,
     /*  884810 */   // Label 13515: @884810
     /*  884810 */   GIM_Try, /*On fail goto*//*Label 13516*/ GIMT_Encode4(884885), // Rule ID 61039 //
     /*  884815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  884826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  884829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  884832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884861 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  884861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  884864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884883 */     GIR_RootConstrainSelectedInstOperands,
     /*  884884 */     // GIR_Coverage, 61039,
     /*  884884 */     GIR_EraseRootFromParent_Done,
     /*  884885 */   // Label 13516: @884885
     /*  884885 */   GIM_Try, /*On fail goto*//*Label 13517*/ GIMT_Encode4(884960), // Rule ID 61046 //
     /*  884890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  884893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  884901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  884904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  884907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884936 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  884936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  884939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884958 */     GIR_RootConstrainSelectedInstOperands,
     /*  884959 */     // GIR_Coverage, 61046,
     /*  884959 */     GIR_EraseRootFromParent_Done,
     /*  884960 */   // Label 13517: @884960
     /*  884960 */   GIM_Try, /*On fail goto*//*Label 13518*/ GIMT_Encode4(885035), // Rule ID 61047 //
     /*  884965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  884976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  884979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  884982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885011 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  885014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885033 */     GIR_RootConstrainSelectedInstOperands,
     /*  885034 */     // GIR_Coverage, 61047,
     /*  885034 */     GIR_EraseRootFromParent_Done,
     /*  885035 */   // Label 13518: @885035
     /*  885035 */   GIM_Try, /*On fail goto*//*Label 13519*/ GIMT_Encode4(885110), // Rule ID 61054 //
     /*  885040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  885051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  885054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  885057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885086 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  885089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885108 */     GIR_RootConstrainSelectedInstOperands,
     /*  885109 */     // GIR_Coverage, 61054,
     /*  885109 */     GIR_EraseRootFromParent_Done,
     /*  885110 */   // Label 13519: @885110
     /*  885110 */   GIM_Try, /*On fail goto*//*Label 13520*/ GIMT_Encode4(885185), // Rule ID 61055 //
     /*  885115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  885118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  885126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  885129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  885132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885161 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  885164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885183 */     GIR_RootConstrainSelectedInstOperands,
     /*  885184 */     // GIR_Coverage, 61055,
     /*  885184 */     GIR_EraseRootFromParent_Done,
     /*  885185 */   // Label 13520: @885185
     /*  885185 */   GIM_Try, /*On fail goto*//*Label 13521*/ GIMT_Encode4(885260), // Rule ID 61062 //
     /*  885190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  885201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  885204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  885207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885236 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  885239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885258 */     GIR_RootConstrainSelectedInstOperands,
     /*  885259 */     // GIR_Coverage, 61062,
     /*  885259 */     GIR_EraseRootFromParent_Done,
     /*  885260 */   // Label 13521: @885260
     /*  885260 */   GIM_Try, /*On fail goto*//*Label 13522*/ GIMT_Encode4(885335), // Rule ID 61063 //
     /*  885265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  885268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  885276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  885279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  885282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885311 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  885314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885333 */     GIR_RootConstrainSelectedInstOperands,
     /*  885334 */     // GIR_Coverage, 61063,
     /*  885334 */     GIR_EraseRootFromParent_Done,
     /*  885335 */   // Label 13522: @885335
     /*  885335 */   GIM_Try, /*On fail goto*//*Label 13523*/ GIMT_Encode4(885410), // Rule ID 61070 //
     /*  885340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  885351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  885354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  885357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885386 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  885389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885408 */     GIR_RootConstrainSelectedInstOperands,
     /*  885409 */     // GIR_Coverage, 61070,
     /*  885409 */     GIR_EraseRootFromParent_Done,
     /*  885410 */   // Label 13523: @885410
     /*  885410 */   GIM_Try, /*On fail goto*//*Label 13524*/ GIMT_Encode4(885485), // Rule ID 61071 //
     /*  885415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  885418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  885426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  885429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  885432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885461 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  885464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885483 */     GIR_RootConstrainSelectedInstOperands,
     /*  885484 */     // GIR_Coverage, 61071,
     /*  885484 */     GIR_EraseRootFromParent_Done,
     /*  885485 */   // Label 13524: @885485
     /*  885485 */   GIM_Try, /*On fail goto*//*Label 13525*/ GIMT_Encode4(885560), // Rule ID 61078 //
     /*  885490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  885501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  885504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  885507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  885539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885558 */     GIR_RootConstrainSelectedInstOperands,
     /*  885559 */     // GIR_Coverage, 61078,
     /*  885559 */     GIR_EraseRootFromParent_Done,
     /*  885560 */   // Label 13525: @885560
     /*  885560 */   GIM_Try, /*On fail goto*//*Label 13526*/ GIMT_Encode4(885635), // Rule ID 61079 //
     /*  885565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  885568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  885576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  885579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  885582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885611 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  885614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885633 */     GIR_RootConstrainSelectedInstOperands,
     /*  885634 */     // GIR_Coverage, 61079,
     /*  885634 */     GIR_EraseRootFromParent_Done,
     /*  885635 */   // Label 13526: @885635
     /*  885635 */   GIM_Try, /*On fail goto*//*Label 13527*/ GIMT_Encode4(885710), // Rule ID 61086 //
     /*  885640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  885651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  885654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  885657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885686 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  885689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885708 */     GIR_RootConstrainSelectedInstOperands,
     /*  885709 */     // GIR_Coverage, 61086,
     /*  885709 */     GIR_EraseRootFromParent_Done,
     /*  885710 */   // Label 13527: @885710
     /*  885710 */   GIM_Try, /*On fail goto*//*Label 13528*/ GIMT_Encode4(885785), // Rule ID 61087 //
     /*  885715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  885718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  885726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  885729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  885732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885761 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  885764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885783 */     GIR_RootConstrainSelectedInstOperands,
     /*  885784 */     // GIR_Coverage, 61087,
     /*  885784 */     GIR_EraseRootFromParent_Done,
     /*  885785 */   // Label 13528: @885785
     /*  885785 */   GIM_Try, /*On fail goto*//*Label 13529*/ GIMT_Encode4(885860), // Rule ID 61094 //
     /*  885790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  885801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  885804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  885807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  885839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885858 */     GIR_RootConstrainSelectedInstOperands,
     /*  885859 */     // GIR_Coverage, 61094,
     /*  885859 */     GIR_EraseRootFromParent_Done,
     /*  885860 */   // Label 13529: @885860
     /*  885860 */   GIM_Try, /*On fail goto*//*Label 13530*/ GIMT_Encode4(885935), // Rule ID 61095 //
     /*  885865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  885868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  885876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  885879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  885882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885911 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  885914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885933 */     GIR_RootConstrainSelectedInstOperands,
     /*  885934 */     // GIR_Coverage, 61095,
     /*  885934 */     GIR_EraseRootFromParent_Done,
     /*  885935 */   // Label 13530: @885935
     /*  885935 */   GIM_Try, /*On fail goto*//*Label 13531*/ GIMT_Encode4(886010), // Rule ID 61102 //
     /*  885940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  885951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  885954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  885957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885986 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  885989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886008 */     GIR_RootConstrainSelectedInstOperands,
     /*  886009 */     // GIR_Coverage, 61102,
     /*  886009 */     GIR_EraseRootFromParent_Done,
     /*  886010 */   // Label 13531: @886010
     /*  886010 */   GIM_Try, /*On fail goto*//*Label 13532*/ GIMT_Encode4(886085), // Rule ID 61103 //
     /*  886015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  886018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  886026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  886029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  886032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886061 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  886061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  886064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886083 */     GIR_RootConstrainSelectedInstOperands,
     /*  886084 */     // GIR_Coverage, 61103,
     /*  886084 */     GIR_EraseRootFromParent_Done,
     /*  886085 */   // Label 13532: @886085
     /*  886085 */   GIM_Try, /*On fail goto*//*Label 13533*/ GIMT_Encode4(886160), // Rule ID 61110 //
     /*  886090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  886093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  886107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886136 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  886139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886158 */     GIR_RootConstrainSelectedInstOperands,
     /*  886159 */     // GIR_Coverage, 61110,
     /*  886159 */     GIR_EraseRootFromParent_Done,
     /*  886160 */   // Label 13533: @886160
     /*  886160 */   GIM_Try, /*On fail goto*//*Label 13534*/ GIMT_Encode4(886235), // Rule ID 61111 //
     /*  886165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  886168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  886182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886211 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  886214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886233 */     GIR_RootConstrainSelectedInstOperands,
     /*  886234 */     // GIR_Coverage, 61111,
     /*  886234 */     GIR_EraseRootFromParent_Done,
     /*  886235 */   // Label 13534: @886235
     /*  886235 */   GIM_Try, /*On fail goto*//*Label 13535*/ GIMT_Encode4(886310), // Rule ID 61118 //
     /*  886240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  886243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  886251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  886254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  886257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886286 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  886289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886308 */     GIR_RootConstrainSelectedInstOperands,
     /*  886309 */     // GIR_Coverage, 61118,
     /*  886309 */     GIR_EraseRootFromParent_Done,
     /*  886310 */   // Label 13535: @886310
     /*  886310 */   GIM_Try, /*On fail goto*//*Label 13536*/ GIMT_Encode4(886385), // Rule ID 61119 //
     /*  886315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  886318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  886326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  886329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  886332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886361 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  886364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886383 */     GIR_RootConstrainSelectedInstOperands,
     /*  886384 */     // GIR_Coverage, 61119,
     /*  886384 */     GIR_EraseRootFromParent_Done,
     /*  886385 */   // Label 13536: @886385
     /*  886385 */   GIM_Try, /*On fail goto*//*Label 13537*/ GIMT_Encode4(886460), // Rule ID 61126 //
     /*  886390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  886393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  886401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  886404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  886407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  886439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886458 */     GIR_RootConstrainSelectedInstOperands,
     /*  886459 */     // GIR_Coverage, 61126,
     /*  886459 */     GIR_EraseRootFromParent_Done,
     /*  886460 */   // Label 13537: @886460
     /*  886460 */   GIM_Try, /*On fail goto*//*Label 13538*/ GIMT_Encode4(886535), // Rule ID 61127 //
     /*  886465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  886468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  886476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  886479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  886482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886511 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  886514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886533 */     GIR_RootConstrainSelectedInstOperands,
     /*  886534 */     // GIR_Coverage, 61127,
     /*  886534 */     GIR_EraseRootFromParent_Done,
     /*  886535 */   // Label 13538: @886535
     /*  886535 */   GIM_Try, /*On fail goto*//*Label 13539*/ GIMT_Encode4(886610), // Rule ID 61134 //
     /*  886540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  886543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  886551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  886554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  886557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886586 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  886589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886608 */     GIR_RootConstrainSelectedInstOperands,
     /*  886609 */     // GIR_Coverage, 61134,
     /*  886609 */     GIR_EraseRootFromParent_Done,
     /*  886610 */   // Label 13539: @886610
     /*  886610 */   GIM_Try, /*On fail goto*//*Label 13540*/ GIMT_Encode4(886685), // Rule ID 61135 //
     /*  886615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  886618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  886626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  886629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  886632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886661 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  886664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886683 */     GIR_RootConstrainSelectedInstOperands,
     /*  886684 */     // GIR_Coverage, 61135,
     /*  886684 */     GIR_EraseRootFromParent_Done,
     /*  886685 */   // Label 13540: @886685
     /*  886685 */   GIM_Try, /*On fail goto*//*Label 13541*/ GIMT_Encode4(886760), // Rule ID 61142 //
     /*  886690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  886693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  886698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  886707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  886710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886736 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  886736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  886739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886758 */     GIR_RootConstrainSelectedInstOperands,
     /*  886759 */     // GIR_Coverage, 61142,
     /*  886759 */     GIR_EraseRootFromParent_Done,
     /*  886760 */   // Label 13541: @886760
     /*  886760 */   GIM_Try, /*On fail goto*//*Label 13542*/ GIMT_Encode4(886835), // Rule ID 61143 //
     /*  886765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  886768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  886773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  886782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  886785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886811 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  886811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  886814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886833 */     GIR_RootConstrainSelectedInstOperands,
     /*  886834 */     // GIR_Coverage, 61143,
     /*  886834 */     GIR_EraseRootFromParent_Done,
     /*  886835 */   // Label 13542: @886835
     /*  886835 */   GIM_Try, /*On fail goto*//*Label 13543*/ GIMT_Encode4(886910), // Rule ID 61146 //
     /*  886840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  886843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  886848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  886851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  886854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  886857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  886860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  886886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  886889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886908 */     GIR_RootConstrainSelectedInstOperands,
     /*  886909 */     // GIR_Coverage, 61146,
     /*  886909 */     GIR_EraseRootFromParent_Done,
     /*  886910 */   // Label 13543: @886910
     /*  886910 */   GIM_Try, /*On fail goto*//*Label 13544*/ GIMT_Encode4(886985), // Rule ID 61147 //
     /*  886915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  886918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  886923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  886926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  886929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  886932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  886935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  886961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  886964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886983 */     GIR_RootConstrainSelectedInstOperands,
     /*  886984 */     // GIR_Coverage, 61147,
     /*  886984 */     GIR_EraseRootFromParent_Done,
     /*  886985 */   // Label 13544: @886985
     /*  886985 */   GIM_Try, /*On fail goto*//*Label 13545*/ GIMT_Encode4(887060), // Rule ID 61150 //
     /*  886990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  886993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  886998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  887001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  887004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  887007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  887010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  887039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887058 */     GIR_RootConstrainSelectedInstOperands,
     /*  887059 */     // GIR_Coverage, 61150,
     /*  887059 */     GIR_EraseRootFromParent_Done,
     /*  887060 */   // Label 13545: @887060
     /*  887060 */   GIM_Try, /*On fail goto*//*Label 13546*/ GIMT_Encode4(887135), // Rule ID 61151 //
     /*  887065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  887076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  887079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  887082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  887085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887111 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  887114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887133 */     GIR_RootConstrainSelectedInstOperands,
     /*  887134 */     // GIR_Coverage, 61151,
     /*  887134 */     GIR_EraseRootFromParent_Done,
     /*  887135 */   // Label 13546: @887135
     /*  887135 */   GIM_Try, /*On fail goto*//*Label 13547*/ GIMT_Encode4(887210), // Rule ID 61154 //
     /*  887140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  887143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  887151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  887154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  887157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  887160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887186 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  887189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887208 */     GIR_RootConstrainSelectedInstOperands,
     /*  887209 */     // GIR_Coverage, 61154,
     /*  887209 */     GIR_EraseRootFromParent_Done,
     /*  887210 */   // Label 13547: @887210
     /*  887210 */   GIM_Try, /*On fail goto*//*Label 13548*/ GIMT_Encode4(887285), // Rule ID 61155 //
     /*  887215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  887226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  887229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  887232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  887235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887261 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  887264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887283 */     GIR_RootConstrainSelectedInstOperands,
     /*  887284 */     // GIR_Coverage, 61155,
     /*  887284 */     GIR_EraseRootFromParent_Done,
     /*  887285 */   // Label 13548: @887285
     /*  887285 */   GIM_Try, /*On fail goto*//*Label 13549*/ GIMT_Encode4(887360), // Rule ID 61158 //
     /*  887290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  887293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  887301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  887304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  887310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  887339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887358 */     GIR_RootConstrainSelectedInstOperands,
     /*  887359 */     // GIR_Coverage, 61158,
     /*  887359 */     GIR_EraseRootFromParent_Done,
     /*  887360 */   // Label 13549: @887360
     /*  887360 */   GIM_Try, /*On fail goto*//*Label 13550*/ GIMT_Encode4(887435), // Rule ID 61159 //
     /*  887365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  887376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  887379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  887385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887411 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  887414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887433 */     GIR_RootConstrainSelectedInstOperands,
     /*  887434 */     // GIR_Coverage, 61159,
     /*  887434 */     GIR_EraseRootFromParent_Done,
     /*  887435 */   // Label 13550: @887435
     /*  887435 */   GIM_Try, /*On fail goto*//*Label 13551*/ GIMT_Encode4(887510), // Rule ID 61162 //
     /*  887440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  887443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  887451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  887454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  887457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  887460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  887489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887508 */     GIR_RootConstrainSelectedInstOperands,
     /*  887509 */     // GIR_Coverage, 61162,
     /*  887509 */     GIR_EraseRootFromParent_Done,
     /*  887510 */   // Label 13551: @887510
     /*  887510 */   GIM_Try, /*On fail goto*//*Label 13552*/ GIMT_Encode4(887585), // Rule ID 61163 //
     /*  887515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  887526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  887529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  887532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  887535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887561 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  887564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887583 */     GIR_RootConstrainSelectedInstOperands,
     /*  887584 */     // GIR_Coverage, 61163,
     /*  887584 */     GIR_EraseRootFromParent_Done,
     /*  887585 */   // Label 13552: @887585
     /*  887585 */   GIM_Try, /*On fail goto*//*Label 13553*/ GIMT_Encode4(887660), // Rule ID 61166 //
     /*  887590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  887593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  887601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  887604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  887607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  887610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887636 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  887639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887658 */     GIR_RootConstrainSelectedInstOperands,
     /*  887659 */     // GIR_Coverage, 61166,
     /*  887659 */     GIR_EraseRootFromParent_Done,
     /*  887660 */   // Label 13553: @887660
     /*  887660 */   GIM_Try, /*On fail goto*//*Label 13554*/ GIMT_Encode4(887735), // Rule ID 61167 //
     /*  887665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  887676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  887679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  887682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  887685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887711 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  887714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887733 */     GIR_RootConstrainSelectedInstOperands,
     /*  887734 */     // GIR_Coverage, 61167,
     /*  887734 */     GIR_EraseRootFromParent_Done,
     /*  887735 */   // Label 13554: @887735
     /*  887735 */   GIM_Try, /*On fail goto*//*Label 13555*/ GIMT_Encode4(887810), // Rule ID 61170 //
     /*  887740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  887743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  887751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  887754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  887757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  887760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  887789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887808 */     GIR_RootConstrainSelectedInstOperands,
     /*  887809 */     // GIR_Coverage, 61170,
     /*  887809 */     GIR_EraseRootFromParent_Done,
     /*  887810 */   // Label 13555: @887810
     /*  887810 */   GIM_Try, /*On fail goto*//*Label 13556*/ GIMT_Encode4(887885), // Rule ID 61171 //
     /*  887815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  887826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  887829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  887832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  887835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887861 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  887864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887883 */     GIR_RootConstrainSelectedInstOperands,
     /*  887884 */     // GIR_Coverage, 61171,
     /*  887884 */     GIR_EraseRootFromParent_Done,
     /*  887885 */   // Label 13556: @887885
     /*  887885 */   GIM_Try, /*On fail goto*//*Label 13557*/ GIMT_Encode4(887960), // Rule ID 61174 //
     /*  887890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  887893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  887898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  887901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  887904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  887910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887936 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  887939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887958 */     GIR_RootConstrainSelectedInstOperands,
     /*  887959 */     // GIR_Coverage, 61174,
     /*  887959 */     GIR_EraseRootFromParent_Done,
     /*  887960 */   // Label 13557: @887960
     /*  887960 */   GIM_Try, /*On fail goto*//*Label 13558*/ GIMT_Encode4(888035), // Rule ID 61175 //
     /*  887965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  887973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  887976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  887979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  887985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888011 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  888014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888033 */     GIR_RootConstrainSelectedInstOperands,
     /*  888034 */     // GIR_Coverage, 61175,
     /*  888034 */     GIR_EraseRootFromParent_Done,
     /*  888035 */   // Label 13558: @888035
     /*  888035 */   GIM_Try, /*On fail goto*//*Label 13559*/ GIMT_Encode4(888110), // Rule ID 61178 //
     /*  888040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  888060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888086 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  888089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888108 */     GIR_RootConstrainSelectedInstOperands,
     /*  888109 */     // GIR_Coverage, 61178,
     /*  888109 */     GIR_EraseRootFromParent_Done,
     /*  888110 */   // Label 13559: @888110
     /*  888110 */   GIM_Try, /*On fail goto*//*Label 13560*/ GIMT_Encode4(888185), // Rule ID 61179 //
     /*  888115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  888118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  888135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  888164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888183 */     GIR_RootConstrainSelectedInstOperands,
     /*  888184 */     // GIR_Coverage, 61179,
     /*  888184 */     GIR_EraseRootFromParent_Done,
     /*  888185 */   // Label 13560: @888185
     /*  888185 */   GIM_Try, /*On fail goto*//*Label 13561*/ GIMT_Encode4(888260), // Rule ID 61182 //
     /*  888190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  888210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888236 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  888239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888258 */     GIR_RootConstrainSelectedInstOperands,
     /*  888259 */     // GIR_Coverage, 61182,
     /*  888259 */     GIR_EraseRootFromParent_Done,
     /*  888260 */   // Label 13561: @888260
     /*  888260 */   GIM_Try, /*On fail goto*//*Label 13562*/ GIMT_Encode4(888335), // Rule ID 61183 //
     /*  888265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  888268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  888285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888311 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  888314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888333 */     GIR_RootConstrainSelectedInstOperands,
     /*  888334 */     // GIR_Coverage, 61183,
     /*  888334 */     GIR_EraseRootFromParent_Done,
     /*  888335 */   // Label 13562: @888335
     /*  888335 */   GIM_Try, /*On fail goto*//*Label 13563*/ GIMT_Encode4(888410), // Rule ID 61186 //
     /*  888340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  888360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  888389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888408 */     GIR_RootConstrainSelectedInstOperands,
     /*  888409 */     // GIR_Coverage, 61186,
     /*  888409 */     GIR_EraseRootFromParent_Done,
     /*  888410 */   // Label 13563: @888410
     /*  888410 */   GIM_Try, /*On fail goto*//*Label 13564*/ GIMT_Encode4(888485), // Rule ID 61187 //
     /*  888415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  888418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  888435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888461 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  888464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888483 */     GIR_RootConstrainSelectedInstOperands,
     /*  888484 */     // GIR_Coverage, 61187,
     /*  888484 */     GIR_EraseRootFromParent_Done,
     /*  888485 */   // Label 13564: @888485
     /*  888485 */   GIM_Try, /*On fail goto*//*Label 13565*/ GIMT_Encode4(888560), // Rule ID 61190 //
     /*  888490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  888501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  888504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  888507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888536 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  888539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888558 */     GIR_RootConstrainSelectedInstOperands,
     /*  888559 */     // GIR_Coverage, 61190,
     /*  888559 */     GIR_EraseRootFromParent_Done,
     /*  888560 */   // Label 13565: @888560
     /*  888560 */   GIM_Try, /*On fail goto*//*Label 13566*/ GIMT_Encode4(888635), // Rule ID 61191 //
     /*  888565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  888568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  888576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  888579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  888582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888611 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  888614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888633 */     GIR_RootConstrainSelectedInstOperands,
     /*  888634 */     // GIR_Coverage, 61191,
     /*  888634 */     GIR_EraseRootFromParent_Done,
     /*  888635 */   // Label 13566: @888635
     /*  888635 */   GIM_Try, /*On fail goto*//*Label 13567*/ GIMT_Encode4(888710), // Rule ID 61194 //
     /*  888640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888686 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  888689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888708 */     GIR_RootConstrainSelectedInstOperands,
     /*  888709 */     // GIR_Coverage, 61194,
     /*  888709 */     GIR_EraseRootFromParent_Done,
     /*  888710 */   // Label 13567: @888710
     /*  888710 */   GIM_Try, /*On fail goto*//*Label 13568*/ GIMT_Encode4(888785), // Rule ID 61195 //
     /*  888715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  888718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888761 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  888764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888783 */     GIR_RootConstrainSelectedInstOperands,
     /*  888784 */     // GIR_Coverage, 61195,
     /*  888784 */     GIR_EraseRootFromParent_Done,
     /*  888785 */   // Label 13568: @888785
     /*  888785 */   GIM_Try, /*On fail goto*//*Label 13569*/ GIMT_Encode4(888860), // Rule ID 61198 //
     /*  888790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888836 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  888839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888858 */     GIR_RootConstrainSelectedInstOperands,
     /*  888859 */     // GIR_Coverage, 61198,
     /*  888859 */     GIR_EraseRootFromParent_Done,
     /*  888860 */   // Label 13569: @888860
     /*  888860 */   GIM_Try, /*On fail goto*//*Label 13570*/ GIMT_Encode4(888935), // Rule ID 61199 //
     /*  888865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  888868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888911 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  888914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888933 */     GIR_RootConstrainSelectedInstOperands,
     /*  888934 */     // GIR_Coverage, 61199,
     /*  888934 */     GIR_EraseRootFromParent_Done,
     /*  888935 */   // Label 13570: @888935
     /*  888935 */   GIM_Try, /*On fail goto*//*Label 13571*/ GIMT_Encode4(889010), // Rule ID 61202 //
     /*  888940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888986 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  888989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889008 */     GIR_RootConstrainSelectedInstOperands,
     /*  889009 */     // GIR_Coverage, 61202,
     /*  889009 */     GIR_EraseRootFromParent_Done,
     /*  889010 */   // Label 13571: @889010
     /*  889010 */   GIM_Try, /*On fail goto*//*Label 13572*/ GIMT_Encode4(889085), // Rule ID 61203 //
     /*  889015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  889018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  889023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  889026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  889029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  889032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889061 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  889061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  889064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889083 */     GIR_RootConstrainSelectedInstOperands,
     /*  889084 */     // GIR_Coverage, 61203,
     /*  889084 */     GIR_EraseRootFromParent_Done,
     /*  889085 */   // Label 13572: @889085
     /*  889085 */   GIM_Try, /*On fail goto*//*Label 13573*/ GIMT_Encode4(889160), // Rule ID 61206 //
     /*  889090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  889101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  889104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  889107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  889110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889136 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  889139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889158 */     GIR_RootConstrainSelectedInstOperands,
     /*  889159 */     // GIR_Coverage, 61206,
     /*  889159 */     GIR_EraseRootFromParent_Done,
     /*  889160 */   // Label 13573: @889160
     /*  889160 */   GIM_Try, /*On fail goto*//*Label 13574*/ GIMT_Encode4(889235), // Rule ID 61207 //
     /*  889165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  889176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  889179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  889182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  889185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889211 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  889214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889233 */     GIR_RootConstrainSelectedInstOperands,
     /*  889234 */     // GIR_Coverage, 61207,
     /*  889234 */     GIR_EraseRootFromParent_Done,
     /*  889235 */   // Label 13574: @889235
     /*  889235 */   GIM_Try, /*On fail goto*//*Label 13575*/ GIMT_Encode4(889310), // Rule ID 61210 //
     /*  889240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  889251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  889254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  889257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  889260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889286 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  889289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889308 */     GIR_RootConstrainSelectedInstOperands,
     /*  889309 */     // GIR_Coverage, 61210,
     /*  889309 */     GIR_EraseRootFromParent_Done,
     /*  889310 */   // Label 13575: @889310
     /*  889310 */   GIM_Try, /*On fail goto*//*Label 13576*/ GIMT_Encode4(889385), // Rule ID 61211 //
     /*  889315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  889326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  889329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  889332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  889335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889361 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  889364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889383 */     GIR_RootConstrainSelectedInstOperands,
     /*  889384 */     // GIR_Coverage, 61211,
     /*  889384 */     GIR_EraseRootFromParent_Done,
     /*  889385 */   // Label 13576: @889385
     /*  889385 */   GIM_Try, /*On fail goto*//*Label 13577*/ GIMT_Encode4(889460), // Rule ID 61214 //
     /*  889390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  889401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  889404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  889407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  889410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889436 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  889439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889458 */     GIR_RootConstrainSelectedInstOperands,
     /*  889459 */     // GIR_Coverage, 61214,
     /*  889459 */     GIR_EraseRootFromParent_Done,
     /*  889460 */   // Label 13577: @889460
     /*  889460 */   GIM_Try, /*On fail goto*//*Label 13578*/ GIMT_Encode4(889535), // Rule ID 61215 //
     /*  889465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  889476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  889479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  889482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  889485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889511 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  889514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889533 */     GIR_RootConstrainSelectedInstOperands,
     /*  889534 */     // GIR_Coverage, 61215,
     /*  889534 */     GIR_EraseRootFromParent_Done,
     /*  889535 */   // Label 13578: @889535
     /*  889535 */   GIM_Try, /*On fail goto*//*Label 13579*/ GIMT_Encode4(889610), // Rule ID 61218 //
     /*  889540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  889551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  889554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  889557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  889560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889586 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  889589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889608 */     GIR_RootConstrainSelectedInstOperands,
     /*  889609 */     // GIR_Coverage, 61218,
     /*  889609 */     GIR_EraseRootFromParent_Done,
     /*  889610 */   // Label 13579: @889610
     /*  889610 */   GIM_Try, /*On fail goto*//*Label 13580*/ GIMT_Encode4(889685), // Rule ID 61219 //
     /*  889615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  889626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  889629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  889632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  889635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889661 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  889664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889683 */     GIR_RootConstrainSelectedInstOperands,
     /*  889684 */     // GIR_Coverage, 61219,
     /*  889684 */     GIR_EraseRootFromParent_Done,
     /*  889685 */   // Label 13580: @889685
     /*  889685 */   GIM_Try, /*On fail goto*//*Label 13581*/ GIMT_Encode4(889760), // Rule ID 61222 //
     /*  889690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  889701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  889704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  889707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  889710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889736 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  889739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889758 */     GIR_RootConstrainSelectedInstOperands,
     /*  889759 */     // GIR_Coverage, 61222,
     /*  889759 */     GIR_EraseRootFromParent_Done,
     /*  889760 */   // Label 13581: @889760
     /*  889760 */   GIM_Try, /*On fail goto*//*Label 13582*/ GIMT_Encode4(889835), // Rule ID 61223 //
     /*  889765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  889776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  889779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  889782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  889785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889811 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  889814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889833 */     GIR_RootConstrainSelectedInstOperands,
     /*  889834 */     // GIR_Coverage, 61223,
     /*  889834 */     GIR_EraseRootFromParent_Done,
     /*  889835 */   // Label 13582: @889835
     /*  889835 */   GIM_Try, /*On fail goto*//*Label 13583*/ GIMT_Encode4(889910), // Rule ID 61226 //
     /*  889840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  889851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  889854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  889857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  889860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889886 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  889886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  889889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889908 */     GIR_RootConstrainSelectedInstOperands,
     /*  889909 */     // GIR_Coverage, 61226,
     /*  889909 */     GIR_EraseRootFromParent_Done,
     /*  889910 */   // Label 13583: @889910
     /*  889910 */   GIM_Try, /*On fail goto*//*Label 13584*/ GIMT_Encode4(889985), // Rule ID 61227 //
     /*  889915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  889926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  889929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  889932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  889935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889961 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  889961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  889964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889983 */     GIR_RootConstrainSelectedInstOperands,
     /*  889984 */     // GIR_Coverage, 61227,
     /*  889984 */     GIR_EraseRootFromParent_Done,
     /*  889985 */   // Label 13584: @889985
     /*  889985 */   GIM_Try, /*On fail goto*//*Label 13585*/ GIMT_Encode4(890060), // Rule ID 61230 //
     /*  889990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  890001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  890004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  890007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  890010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890036 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890058 */     GIR_RootConstrainSelectedInstOperands,
     /*  890059 */     // GIR_Coverage, 61230,
     /*  890059 */     GIR_EraseRootFromParent_Done,
     /*  890060 */   // Label 13585: @890060
     /*  890060 */   GIM_Try, /*On fail goto*//*Label 13586*/ GIMT_Encode4(890135), // Rule ID 61231 //
     /*  890065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  890076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  890079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  890082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  890085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890111 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890133 */     GIR_RootConstrainSelectedInstOperands,
     /*  890134 */     // GIR_Coverage, 61231,
     /*  890134 */     GIR_EraseRootFromParent_Done,
     /*  890135 */   // Label 13586: @890135
     /*  890135 */   GIM_Try, /*On fail goto*//*Label 13587*/ GIMT_Encode4(890210), // Rule ID 61234 //
     /*  890140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  890151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  890154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  890157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  890160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890186 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  890186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890208 */     GIR_RootConstrainSelectedInstOperands,
     /*  890209 */     // GIR_Coverage, 61234,
     /*  890209 */     GIR_EraseRootFromParent_Done,
     /*  890210 */   // Label 13587: @890210
     /*  890210 */   GIM_Try, /*On fail goto*//*Label 13588*/ GIMT_Encode4(890285), // Rule ID 61235 //
     /*  890215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  890226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  890229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  890232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  890235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890261 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  890261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890283 */     GIR_RootConstrainSelectedInstOperands,
     /*  890284 */     // GIR_Coverage, 61235,
     /*  890284 */     GIR_EraseRootFromParent_Done,
     /*  890285 */   // Label 13588: @890285
     /*  890285 */   GIM_Try, /*On fail goto*//*Label 13589*/ GIMT_Encode4(890360), // Rule ID 61238 //
     /*  890290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  890301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  890304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  890307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  890310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  890336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890358 */     GIR_RootConstrainSelectedInstOperands,
     /*  890359 */     // GIR_Coverage, 61238,
     /*  890359 */     GIR_EraseRootFromParent_Done,
     /*  890360 */   // Label 13589: @890360
     /*  890360 */   GIM_Try, /*On fail goto*//*Label 13590*/ GIMT_Encode4(890435), // Rule ID 61239 //
     /*  890365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  890376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  890379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  890382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  890385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890411 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  890411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890433 */     GIR_RootConstrainSelectedInstOperands,
     /*  890434 */     // GIR_Coverage, 61239,
     /*  890434 */     GIR_EraseRootFromParent_Done,
     /*  890435 */   // Label 13590: @890435
     /*  890435 */   GIM_Try, /*On fail goto*//*Label 13591*/ GIMT_Encode4(890510), // Rule ID 61242 //
     /*  890440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  890451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  890454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  890457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  890460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890486 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  890486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  890505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890508 */     GIR_RootConstrainSelectedInstOperands,
     /*  890509 */     // GIR_Coverage, 61242,
     /*  890509 */     GIR_EraseRootFromParent_Done,
     /*  890510 */   // Label 13591: @890510
     /*  890510 */   GIM_Try, /*On fail goto*//*Label 13592*/ GIMT_Encode4(890585), // Rule ID 61243 //
     /*  890515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  890526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  890529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  890532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  890535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890561 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  890561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  890580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890583 */     GIR_RootConstrainSelectedInstOperands,
     /*  890584 */     // GIR_Coverage, 61243,
     /*  890584 */     GIR_EraseRootFromParent_Done,
     /*  890585 */   // Label 13592: @890585
     /*  890585 */   GIM_Try, /*On fail goto*//*Label 13593*/ GIMT_Encode4(890660), // Rule ID 61246 //
     /*  890590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  890601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  890604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  890607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  890610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890636 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  890639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890658 */     GIR_RootConstrainSelectedInstOperands,
     /*  890659 */     // GIR_Coverage, 61246,
     /*  890659 */     GIR_EraseRootFromParent_Done,
     /*  890660 */   // Label 13593: @890660
     /*  890660 */   GIM_Try, /*On fail goto*//*Label 13594*/ GIMT_Encode4(890735), // Rule ID 61247 //
     /*  890665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  890676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  890679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  890682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  890685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890711 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  890714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890733 */     GIR_RootConstrainSelectedInstOperands,
     /*  890734 */     // GIR_Coverage, 61247,
     /*  890734 */     GIR_EraseRootFromParent_Done,
     /*  890735 */   // Label 13594: @890735
     /*  890735 */   GIM_Try, /*On fail goto*//*Label 13595*/ GIMT_Encode4(890810), // Rule ID 61250 //
     /*  890740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  890751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  890754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  890757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  890760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890786 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  890789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890808 */     GIR_RootConstrainSelectedInstOperands,
     /*  890809 */     // GIR_Coverage, 61250,
     /*  890809 */     GIR_EraseRootFromParent_Done,
     /*  890810 */   // Label 13595: @890810
     /*  890810 */   GIM_Try, /*On fail goto*//*Label 13596*/ GIMT_Encode4(890885), // Rule ID 61251 //
     /*  890815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  890826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  890829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  890832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  890835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890861 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  890864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890883 */     GIR_RootConstrainSelectedInstOperands,
     /*  890884 */     // GIR_Coverage, 61251,
     /*  890884 */     GIR_EraseRootFromParent_Done,
     /*  890885 */   // Label 13596: @890885
     /*  890885 */   GIM_Try, /*On fail goto*//*Label 13597*/ GIMT_Encode4(890960), // Rule ID 61254 //
     /*  890890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  890901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  890904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  890907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  890910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890936 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  890939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890958 */     GIR_RootConstrainSelectedInstOperands,
     /*  890959 */     // GIR_Coverage, 61254,
     /*  890959 */     GIR_EraseRootFromParent_Done,
     /*  890960 */   // Label 13597: @890960
     /*  890960 */   GIM_Try, /*On fail goto*//*Label 13598*/ GIMT_Encode4(891035), // Rule ID 61255 //
     /*  890965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  890976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  890979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  890982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  890985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891011 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  891011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  891014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891033 */     GIR_RootConstrainSelectedInstOperands,
     /*  891034 */     // GIR_Coverage, 61255,
     /*  891034 */     GIR_EraseRootFromParent_Done,
     /*  891035 */   // Label 13598: @891035
     /*  891035 */   GIM_Try, /*On fail goto*//*Label 13599*/ GIMT_Encode4(891110), // Rule ID 61258 //
     /*  891040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  891051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  891054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  891057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  891060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891086 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  891089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891108 */     GIR_RootConstrainSelectedInstOperands,
     /*  891109 */     // GIR_Coverage, 61258,
     /*  891109 */     GIR_EraseRootFromParent_Done,
     /*  891110 */   // Label 13599: @891110
     /*  891110 */   GIM_Try, /*On fail goto*//*Label 13600*/ GIMT_Encode4(891185), // Rule ID 61259 //
     /*  891115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  891126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  891129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  891132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  891135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891161 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  891161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  891164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891183 */     GIR_RootConstrainSelectedInstOperands,
     /*  891184 */     // GIR_Coverage, 61259,
     /*  891184 */     GIR_EraseRootFromParent_Done,
     /*  891185 */   // Label 13600: @891185
     /*  891185 */   GIM_Try, /*On fail goto*//*Label 13601*/ GIMT_Encode4(891260), // Rule ID 61262 //
     /*  891190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  891201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  891204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  891207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  891210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891236 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  891239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891258 */     GIR_RootConstrainSelectedInstOperands,
     /*  891259 */     // GIR_Coverage, 61262,
     /*  891259 */     GIR_EraseRootFromParent_Done,
     /*  891260 */   // Label 13601: @891260
     /*  891260 */   GIM_Try, /*On fail goto*//*Label 13602*/ GIMT_Encode4(891335), // Rule ID 61263 //
     /*  891265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  891276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  891279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  891282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  891285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891311 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  891311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  891314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891333 */     GIR_RootConstrainSelectedInstOperands,
     /*  891334 */     // GIR_Coverage, 61263,
     /*  891334 */     GIR_EraseRootFromParent_Done,
     /*  891335 */   // Label 13602: @891335
     /*  891335 */   GIM_Try, /*On fail goto*//*Label 13603*/ GIMT_Encode4(891410), // Rule ID 61266 //
     /*  891340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  891351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  891354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  891357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  891360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891386 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  891389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891408 */     GIR_RootConstrainSelectedInstOperands,
     /*  891409 */     // GIR_Coverage, 61266,
     /*  891409 */     GIR_EraseRootFromParent_Done,
     /*  891410 */   // Label 13603: @891410
     /*  891410 */   GIM_Try, /*On fail goto*//*Label 13604*/ GIMT_Encode4(891485), // Rule ID 61267 //
     /*  891415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  891426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  891429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  891432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  891435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891461 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  891461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  891464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891483 */     GIR_RootConstrainSelectedInstOperands,
     /*  891484 */     // GIR_Coverage, 61267,
     /*  891484 */     GIR_EraseRootFromParent_Done,
     /*  891485 */   // Label 13604: @891485
     /*  891485 */   GIM_Try, /*On fail goto*//*Label 13605*/ GIMT_Encode4(891560), // Rule ID 61270 //
     /*  891490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  891501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  891504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  891507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  891510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  891539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891558 */     GIR_RootConstrainSelectedInstOperands,
     /*  891559 */     // GIR_Coverage, 61270,
     /*  891559 */     GIR_EraseRootFromParent_Done,
     /*  891560 */   // Label 13605: @891560
     /*  891560 */   GIM_Try, /*On fail goto*//*Label 13606*/ GIMT_Encode4(891635), // Rule ID 61271 //
     /*  891565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  891576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  891579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  891582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  891585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891611 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  891614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891633 */     GIR_RootConstrainSelectedInstOperands,
     /*  891634 */     // GIR_Coverage, 61271,
     /*  891634 */     GIR_EraseRootFromParent_Done,
     /*  891635 */   // Label 13606: @891635
     /*  891635 */   GIM_Try, /*On fail goto*//*Label 13607*/ GIMT_Encode4(891710), // Rule ID 61274 //
     /*  891640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  891651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  891654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  891657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  891660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  891689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891708 */     GIR_RootConstrainSelectedInstOperands,
     /*  891709 */     // GIR_Coverage, 61274,
     /*  891709 */     GIR_EraseRootFromParent_Done,
     /*  891710 */   // Label 13607: @891710
     /*  891710 */   GIM_Try, /*On fail goto*//*Label 13608*/ GIMT_Encode4(891785), // Rule ID 61275 //
     /*  891715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  891726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  891729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  891732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  891735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891761 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  891764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891783 */     GIR_RootConstrainSelectedInstOperands,
     /*  891784 */     // GIR_Coverage, 61275,
     /*  891784 */     GIR_EraseRootFromParent_Done,
     /*  891785 */   // Label 13608: @891785
     /*  891785 */   GIM_Try, /*On fail goto*//*Label 13609*/ GIMT_Encode4(891860), // Rule ID 61278 //
     /*  891790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  891801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  891804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  891807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  891810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891836 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  891839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891858 */     GIR_RootConstrainSelectedInstOperands,
     /*  891859 */     // GIR_Coverage, 61278,
     /*  891859 */     GIR_EraseRootFromParent_Done,
     /*  891860 */   // Label 13609: @891860
     /*  891860 */   GIM_Try, /*On fail goto*//*Label 13610*/ GIMT_Encode4(891935), // Rule ID 61279 //
     /*  891865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  891876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  891879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  891882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  891885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891911 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  891914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891933 */     GIR_RootConstrainSelectedInstOperands,
     /*  891934 */     // GIR_Coverage, 61279,
     /*  891934 */     GIR_EraseRootFromParent_Done,
     /*  891935 */   // Label 13610: @891935
     /*  891935 */   GIM_Try, /*On fail goto*//*Label 13611*/ GIMT_Encode4(892010), // Rule ID 61282 //
     /*  891940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  891951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  891954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  891957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  891960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891986 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  891986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  891989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892008 */     GIR_RootConstrainSelectedInstOperands,
     /*  892009 */     // GIR_Coverage, 61282,
     /*  892009 */     GIR_EraseRootFromParent_Done,
     /*  892010 */   // Label 13611: @892010
     /*  892010 */   GIM_Try, /*On fail goto*//*Label 13612*/ GIMT_Encode4(892085), // Rule ID 61283 //
     /*  892015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  892026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  892029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  892032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  892035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892061 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  892061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  892064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892083 */     GIR_RootConstrainSelectedInstOperands,
     /*  892084 */     // GIR_Coverage, 61283,
     /*  892084 */     GIR_EraseRootFromParent_Done,
     /*  892085 */   // Label 13612: @892085
     /*  892085 */   GIM_Try, /*On fail goto*//*Label 13613*/ GIMT_Encode4(892160), // Rule ID 61286 //
     /*  892090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  892101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  892104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  892107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  892110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892136 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  892136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  892139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892158 */     GIR_RootConstrainSelectedInstOperands,
     /*  892159 */     // GIR_Coverage, 61286,
     /*  892159 */     GIR_EraseRootFromParent_Done,
     /*  892160 */   // Label 13613: @892160
     /*  892160 */   GIM_Try, /*On fail goto*//*Label 13614*/ GIMT_Encode4(892235), // Rule ID 61287 //
     /*  892165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  892176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  892179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  892182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  892185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892211 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  892211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  892214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892233 */     GIR_RootConstrainSelectedInstOperands,
     /*  892234 */     // GIR_Coverage, 61287,
     /*  892234 */     GIR_EraseRootFromParent_Done,
     /*  892235 */   // Label 13614: @892235
     /*  892235 */   GIM_Try, /*On fail goto*//*Label 13615*/ GIMT_Encode4(892310), // Rule ID 61290 //
     /*  892240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  892251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  892254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  892257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  892260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892286 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  892286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  892289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892308 */     GIR_RootConstrainSelectedInstOperands,
     /*  892309 */     // GIR_Coverage, 61290,
     /*  892309 */     GIR_EraseRootFromParent_Done,
     /*  892310 */   // Label 13615: @892310
     /*  892310 */   GIM_Try, /*On fail goto*//*Label 13616*/ GIMT_Encode4(892385), // Rule ID 61291 //
     /*  892315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  892326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  892329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  892332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  892335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892361 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  892361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  892364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892383 */     GIR_RootConstrainSelectedInstOperands,
     /*  892384 */     // GIR_Coverage, 61291,
     /*  892384 */     GIR_EraseRootFromParent_Done,
     /*  892385 */   // Label 13616: @892385
     /*  892385 */   GIM_Try, /*On fail goto*//*Label 13617*/ GIMT_Encode4(892460), // Rule ID 61294 //
     /*  892390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  892401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  892404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  892407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892436 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  892439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892458 */     GIR_RootConstrainSelectedInstOperands,
     /*  892459 */     // GIR_Coverage, 61294,
     /*  892459 */     GIR_EraseRootFromParent_Done,
     /*  892460 */   // Label 13617: @892460
     /*  892460 */   GIM_Try, /*On fail goto*//*Label 13618*/ GIMT_Encode4(892535), // Rule ID 61295 //
     /*  892465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  892476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  892479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  892482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892511 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  892514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892533 */     GIR_RootConstrainSelectedInstOperands,
     /*  892534 */     // GIR_Coverage, 61295,
     /*  892534 */     GIR_EraseRootFromParent_Done,
     /*  892535 */   // Label 13618: @892535
     /*  892535 */   GIM_Try, /*On fail goto*//*Label 13619*/ GIMT_Encode4(892610), // Rule ID 61298 //
     /*  892540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  892551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  892554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  892557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892586 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  892589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892608 */     GIR_RootConstrainSelectedInstOperands,
     /*  892609 */     // GIR_Coverage, 61298,
     /*  892609 */     GIR_EraseRootFromParent_Done,
     /*  892610 */   // Label 13619: @892610
     /*  892610 */   GIM_Try, /*On fail goto*//*Label 13620*/ GIMT_Encode4(892685), // Rule ID 61299 //
     /*  892615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  892626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  892629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  892632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892661 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  892664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892683 */     GIR_RootConstrainSelectedInstOperands,
     /*  892684 */     // GIR_Coverage, 61299,
     /*  892684 */     GIR_EraseRootFromParent_Done,
     /*  892685 */   // Label 13620: @892685
     /*  892685 */   GIM_Try, /*On fail goto*//*Label 13621*/ GIMT_Encode4(892760), // Rule ID 61302 //
     /*  892690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  892701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  892704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  892707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892736 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  892739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892758 */     GIR_RootConstrainSelectedInstOperands,
     /*  892759 */     // GIR_Coverage, 61302,
     /*  892759 */     GIR_EraseRootFromParent_Done,
     /*  892760 */   // Label 13621: @892760
     /*  892760 */   GIM_Try, /*On fail goto*//*Label 13622*/ GIMT_Encode4(892835), // Rule ID 61303 //
     /*  892765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  892776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  892779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  892782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892811 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  892814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892833 */     GIR_RootConstrainSelectedInstOperands,
     /*  892834 */     // GIR_Coverage, 61303,
     /*  892834 */     GIR_EraseRootFromParent_Done,
     /*  892835 */   // Label 13622: @892835
     /*  892835 */   GIM_Try, /*On fail goto*//*Label 13623*/ GIMT_Encode4(892910), // Rule ID 61306 //
     /*  892840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  892851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  892854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  892857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892886 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  892886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  892889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892908 */     GIR_RootConstrainSelectedInstOperands,
     /*  892909 */     // GIR_Coverage, 61306,
     /*  892909 */     GIR_EraseRootFromParent_Done,
     /*  892910 */   // Label 13623: @892910
     /*  892910 */   GIM_Try, /*On fail goto*//*Label 13624*/ GIMT_Encode4(892985), // Rule ID 61307 //
     /*  892915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  892926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  892929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  892932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892961 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  892961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  892964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892983 */     GIR_RootConstrainSelectedInstOperands,
     /*  892984 */     // GIR_Coverage, 61307,
     /*  892984 */     GIR_EraseRootFromParent_Done,
     /*  892985 */   // Label 13624: @892985
     /*  892985 */   GIM_Try, /*On fail goto*//*Label 13625*/ GIMT_Encode4(893060), // Rule ID 61310 //
     /*  892990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  893001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  893004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  893007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893036 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  893036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  893039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893058 */     GIR_RootConstrainSelectedInstOperands,
     /*  893059 */     // GIR_Coverage, 61310,
     /*  893059 */     GIR_EraseRootFromParent_Done,
     /*  893060 */   // Label 13625: @893060
     /*  893060 */   GIM_Try, /*On fail goto*//*Label 13626*/ GIMT_Encode4(893135), // Rule ID 61311 //
     /*  893065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  893076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  893079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  893082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893111 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  893114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893133 */     GIR_RootConstrainSelectedInstOperands,
     /*  893134 */     // GIR_Coverage, 61311,
     /*  893134 */     GIR_EraseRootFromParent_Done,
     /*  893135 */   // Label 13626: @893135
     /*  893135 */   GIM_Try, /*On fail goto*//*Label 13627*/ GIMT_Encode4(893210), // Rule ID 61314 //
     /*  893140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  893151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  893154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  893157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  893186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  893189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893208 */     GIR_RootConstrainSelectedInstOperands,
     /*  893209 */     // GIR_Coverage, 61314,
     /*  893209 */     GIR_EraseRootFromParent_Done,
     /*  893210 */   // Label 13627: @893210
     /*  893210 */   GIM_Try, /*On fail goto*//*Label 13628*/ GIMT_Encode4(893285), // Rule ID 61315 //
     /*  893215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  893226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  893229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  893232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893261 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  893261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  893264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893283 */     GIR_RootConstrainSelectedInstOperands,
     /*  893284 */     // GIR_Coverage, 61315,
     /*  893284 */     GIR_EraseRootFromParent_Done,
     /*  893285 */   // Label 13628: @893285
     /*  893285 */   GIM_Try, /*On fail goto*//*Label 13629*/ GIMT_Encode4(893360), // Rule ID 61318 //
     /*  893290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  893301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  893304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  893307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893336 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893358 */     GIR_RootConstrainSelectedInstOperands,
     /*  893359 */     // GIR_Coverage, 61318,
     /*  893359 */     GIR_EraseRootFromParent_Done,
     /*  893360 */   // Label 13629: @893360
     /*  893360 */   GIM_Try, /*On fail goto*//*Label 13630*/ GIMT_Encode4(893435), // Rule ID 61319 //
     /*  893365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  893376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  893379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  893382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893411 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893433 */     GIR_RootConstrainSelectedInstOperands,
     /*  893434 */     // GIR_Coverage, 61319,
     /*  893434 */     GIR_EraseRootFromParent_Done,
     /*  893435 */   // Label 13630: @893435
     /*  893435 */   GIM_Try, /*On fail goto*//*Label 13631*/ GIMT_Encode4(893510), // Rule ID 61322 //
     /*  893440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  893451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  893454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  893457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893486 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  893486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893508 */     GIR_RootConstrainSelectedInstOperands,
     /*  893509 */     // GIR_Coverage, 61322,
     /*  893509 */     GIR_EraseRootFromParent_Done,
     /*  893510 */   // Label 13631: @893510
     /*  893510 */   GIM_Try, /*On fail goto*//*Label 13632*/ GIMT_Encode4(893585), // Rule ID 61323 //
     /*  893515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  893526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  893529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  893532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893561 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893583 */     GIR_RootConstrainSelectedInstOperands,
     /*  893584 */     // GIR_Coverage, 61323,
     /*  893584 */     GIR_EraseRootFromParent_Done,
     /*  893585 */   // Label 13632: @893585
     /*  893585 */   GIM_Try, /*On fail goto*//*Label 13633*/ GIMT_Encode4(893660), // Rule ID 61326 //
     /*  893590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  893601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  893604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  893607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893636 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  893636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893658 */     GIR_RootConstrainSelectedInstOperands,
     /*  893659 */     // GIR_Coverage, 61326,
     /*  893659 */     GIR_EraseRootFromParent_Done,
     /*  893660 */   // Label 13633: @893660
     /*  893660 */   GIM_Try, /*On fail goto*//*Label 13634*/ GIMT_Encode4(893735), // Rule ID 61327 //
     /*  893665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  893676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  893679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  893682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893711 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  893711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893733 */     GIR_RootConstrainSelectedInstOperands,
     /*  893734 */     // GIR_Coverage, 61327,
     /*  893734 */     GIR_EraseRootFromParent_Done,
     /*  893735 */   // Label 13634: @893735
     /*  893735 */   GIM_Try, /*On fail goto*//*Label 13635*/ GIMT_Encode4(893810), // Rule ID 61330 //
     /*  893740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  893751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  893754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  893757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  893786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893808 */     GIR_RootConstrainSelectedInstOperands,
     /*  893809 */     // GIR_Coverage, 61330,
     /*  893809 */     GIR_EraseRootFromParent_Done,
     /*  893810 */   // Label 13635: @893810
     /*  893810 */   GIM_Try, /*On fail goto*//*Label 13636*/ GIMT_Encode4(893885), // Rule ID 61331 //
     /*  893815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  893826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  893829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  893832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893861 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  893861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893883 */     GIR_RootConstrainSelectedInstOperands,
     /*  893884 */     // GIR_Coverage, 61331,
     /*  893884 */     GIR_EraseRootFromParent_Done,
     /*  893885 */   // Label 13636: @893885
     /*  893885 */   GIM_Try, /*On fail goto*//*Label 13637*/ GIMT_Encode4(893960), // Rule ID 61334 //
     /*  893890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  893901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  893904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  893907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893936 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  893939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893958 */     GIR_RootConstrainSelectedInstOperands,
     /*  893959 */     // GIR_Coverage, 61334,
     /*  893959 */     GIR_EraseRootFromParent_Done,
     /*  893960 */   // Label 13637: @893960
     /*  893960 */   GIM_Try, /*On fail goto*//*Label 13638*/ GIMT_Encode4(894035), // Rule ID 61335 //
     /*  893965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  893976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  893979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  893982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894011 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  894011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  894014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894033 */     GIR_RootConstrainSelectedInstOperands,
     /*  894034 */     // GIR_Coverage, 61335,
     /*  894034 */     GIR_EraseRootFromParent_Done,
     /*  894035 */   // Label 13638: @894035
     /*  894035 */   GIM_Try, /*On fail goto*//*Label 13639*/ GIMT_Encode4(894110), // Rule ID 61338 //
     /*  894040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  894051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  894054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  894057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894086 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  894086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  894089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894108 */     GIR_RootConstrainSelectedInstOperands,
     /*  894109 */     // GIR_Coverage, 61338,
     /*  894109 */     GIR_EraseRootFromParent_Done,
     /*  894110 */   // Label 13639: @894110
     /*  894110 */   GIM_Try, /*On fail goto*//*Label 13640*/ GIMT_Encode4(894185), // Rule ID 61339 //
     /*  894115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  894126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  894129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  894132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894161 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  894161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  894164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894183 */     GIR_RootConstrainSelectedInstOperands,
     /*  894184 */     // GIR_Coverage, 61339,
     /*  894184 */     GIR_EraseRootFromParent_Done,
     /*  894185 */   // Label 13640: @894185
     /*  894185 */   GIM_Try, /*On fail goto*//*Label 13641*/ GIMT_Encode4(894260), // Rule ID 61342 //
     /*  894190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  894201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  894204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  894207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894236 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  894236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  894239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894258 */     GIR_RootConstrainSelectedInstOperands,
     /*  894259 */     // GIR_Coverage, 61342,
     /*  894259 */     GIR_EraseRootFromParent_Done,
     /*  894260 */   // Label 13641: @894260
     /*  894260 */   GIM_Try, /*On fail goto*//*Label 13642*/ GIMT_Encode4(894335), // Rule ID 61343 //
     /*  894265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  894276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  894279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  894282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894311 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  894311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  894314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894333 */     GIR_RootConstrainSelectedInstOperands,
     /*  894334 */     // GIR_Coverage, 61343,
     /*  894334 */     GIR_EraseRootFromParent_Done,
     /*  894335 */   // Label 13642: @894335
     /*  894335 */   GIM_Try, /*On fail goto*//*Label 13643*/ GIMT_Encode4(894410), // Rule ID 61346 //
     /*  894340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  894351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  894354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  894357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894386 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  894389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894408 */     GIR_RootConstrainSelectedInstOperands,
     /*  894409 */     // GIR_Coverage, 61346,
     /*  894409 */     GIR_EraseRootFromParent_Done,
     /*  894410 */   // Label 13643: @894410
     /*  894410 */   GIM_Try, /*On fail goto*//*Label 13644*/ GIMT_Encode4(894485), // Rule ID 61347 //
     /*  894415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  894426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  894429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  894432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894461 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  894464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894483 */     GIR_RootConstrainSelectedInstOperands,
     /*  894484 */     // GIR_Coverage, 61347,
     /*  894484 */     GIR_EraseRootFromParent_Done,
     /*  894485 */   // Label 13644: @894485
     /*  894485 */   GIM_Try, /*On fail goto*//*Label 13645*/ GIMT_Encode4(894560), // Rule ID 61350 //
     /*  894490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  894501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  894504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  894507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894536 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  894539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894558 */     GIR_RootConstrainSelectedInstOperands,
     /*  894559 */     // GIR_Coverage, 61350,
     /*  894559 */     GIR_EraseRootFromParent_Done,
     /*  894560 */   // Label 13645: @894560
     /*  894560 */   GIM_Try, /*On fail goto*//*Label 13646*/ GIMT_Encode4(894635), // Rule ID 61351 //
     /*  894565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  894576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  894579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  894582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894611 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  894614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894633 */     GIR_RootConstrainSelectedInstOperands,
     /*  894634 */     // GIR_Coverage, 61351,
     /*  894634 */     GIR_EraseRootFromParent_Done,
     /*  894635 */   // Label 13646: @894635
     /*  894635 */   GIM_Try, /*On fail goto*//*Label 13647*/ GIMT_Encode4(894710), // Rule ID 61354 //
     /*  894640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  894651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  894654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  894657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894686 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  894689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894708 */     GIR_RootConstrainSelectedInstOperands,
     /*  894709 */     // GIR_Coverage, 61354,
     /*  894709 */     GIR_EraseRootFromParent_Done,
     /*  894710 */   // Label 13647: @894710
     /*  894710 */   GIM_Try, /*On fail goto*//*Label 13648*/ GIMT_Encode4(894785), // Rule ID 61355 //
     /*  894715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  894726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  894729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  894732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894761 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  894764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894783 */     GIR_RootConstrainSelectedInstOperands,
     /*  894784 */     // GIR_Coverage, 61355,
     /*  894784 */     GIR_EraseRootFromParent_Done,
     /*  894785 */   // Label 13648: @894785
     /*  894785 */   GIM_Try, /*On fail goto*//*Label 13649*/ GIMT_Encode4(894860), // Rule ID 61358 //
     /*  894790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  894801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  894804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  894807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  894839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894858 */     GIR_RootConstrainSelectedInstOperands,
     /*  894859 */     // GIR_Coverage, 61358,
     /*  894859 */     GIR_EraseRootFromParent_Done,
     /*  894860 */   // Label 13649: @894860
     /*  894860 */   GIM_Try, /*On fail goto*//*Label 13650*/ GIMT_Encode4(894935), // Rule ID 61359 //
     /*  894865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  894876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  894879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  894882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894911 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  894914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894933 */     GIR_RootConstrainSelectedInstOperands,
     /*  894934 */     // GIR_Coverage, 61359,
     /*  894934 */     GIR_EraseRootFromParent_Done,
     /*  894935 */   // Label 13650: @894935
     /*  894935 */   GIM_Try, /*On fail goto*//*Label 13651*/ GIMT_Encode4(895010), // Rule ID 61362 //
     /*  894940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  894951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  894954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  894957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894986 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  894989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895008 */     GIR_RootConstrainSelectedInstOperands,
     /*  895009 */     // GIR_Coverage, 61362,
     /*  895009 */     GIR_EraseRootFromParent_Done,
     /*  895010 */   // Label 13651: @895010
     /*  895010 */   GIM_Try, /*On fail goto*//*Label 13652*/ GIMT_Encode4(895085), // Rule ID 61363 //
     /*  895015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  895026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  895029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  895032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895061 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  895061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  895064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895083 */     GIR_RootConstrainSelectedInstOperands,
     /*  895084 */     // GIR_Coverage, 61363,
     /*  895084 */     GIR_EraseRootFromParent_Done,
     /*  895085 */   // Label 13652: @895085
     /*  895085 */   GIM_Try, /*On fail goto*//*Label 13653*/ GIMT_Encode4(895160), // Rule ID 61366 //
     /*  895090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  895101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  895104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  895107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895136 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  895136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  895139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895158 */     GIR_RootConstrainSelectedInstOperands,
     /*  895159 */     // GIR_Coverage, 61366,
     /*  895159 */     GIR_EraseRootFromParent_Done,
     /*  895160 */   // Label 13653: @895160
     /*  895160 */   GIM_Try, /*On fail goto*//*Label 13654*/ GIMT_Encode4(895235), // Rule ID 61367 //
     /*  895165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  895176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  895179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  895182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895211 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  895211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  895214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895233 */     GIR_RootConstrainSelectedInstOperands,
     /*  895234 */     // GIR_Coverage, 61367,
     /*  895234 */     GIR_EraseRootFromParent_Done,
     /*  895235 */   // Label 13654: @895235
     /*  895235 */   GIM_Try, /*On fail goto*//*Label 13655*/ GIMT_Encode4(895310), // Rule ID 61370 //
     /*  895240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  895251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  895254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  895257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895286 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  895289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895308 */     GIR_RootConstrainSelectedInstOperands,
     /*  895309 */     // GIR_Coverage, 61370,
     /*  895309 */     GIR_EraseRootFromParent_Done,
     /*  895310 */   // Label 13655: @895310
     /*  895310 */   GIM_Try, /*On fail goto*//*Label 13656*/ GIMT_Encode4(895385), // Rule ID 61371 //
     /*  895315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  895326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  895329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  895332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895361 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  895364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895383 */     GIR_RootConstrainSelectedInstOperands,
     /*  895384 */     // GIR_Coverage, 61371,
     /*  895384 */     GIR_EraseRootFromParent_Done,
     /*  895385 */   // Label 13656: @895385
     /*  895385 */   GIM_Try, /*On fail goto*//*Label 13657*/ GIMT_Encode4(895460), // Rule ID 61374 //
     /*  895390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  895401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  895404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  895407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  895439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895458 */     GIR_RootConstrainSelectedInstOperands,
     /*  895459 */     // GIR_Coverage, 61374,
     /*  895459 */     GIR_EraseRootFromParent_Done,
     /*  895460 */   // Label 13657: @895460
     /*  895460 */   GIM_Try, /*On fail goto*//*Label 13658*/ GIMT_Encode4(895535), // Rule ID 61375 //
     /*  895465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  895476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  895479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  895482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895511 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  895514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895533 */     GIR_RootConstrainSelectedInstOperands,
     /*  895534 */     // GIR_Coverage, 61375,
     /*  895534 */     GIR_EraseRootFromParent_Done,
     /*  895535 */   // Label 13658: @895535
     /*  895535 */   GIM_Try, /*On fail goto*//*Label 13659*/ GIMT_Encode4(895610), // Rule ID 61378 //
     /*  895540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  895551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  895554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  895557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895586 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  895589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895608 */     GIR_RootConstrainSelectedInstOperands,
     /*  895609 */     // GIR_Coverage, 61378,
     /*  895609 */     GIR_EraseRootFromParent_Done,
     /*  895610 */   // Label 13659: @895610
     /*  895610 */   GIM_Try, /*On fail goto*//*Label 13660*/ GIMT_Encode4(895685), // Rule ID 61379 //
     /*  895615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  895626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  895629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  895632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895661 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  895664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895683 */     GIR_RootConstrainSelectedInstOperands,
     /*  895684 */     // GIR_Coverage, 61379,
     /*  895684 */     GIR_EraseRootFromParent_Done,
     /*  895685 */   // Label 13660: @895685
     /*  895685 */   GIM_Try, /*On fail goto*//*Label 13661*/ GIMT_Encode4(895760), // Rule ID 61558 //
     /*  895690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  895701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  895704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  895707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  895710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895736 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  895739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895758 */     GIR_RootConstrainSelectedInstOperands,
     /*  895759 */     // GIR_Coverage, 61558,
     /*  895759 */     GIR_EraseRootFromParent_Done,
     /*  895760 */   // Label 13661: @895760
     /*  895760 */   GIM_Try, /*On fail goto*//*Label 13662*/ GIMT_Encode4(895835), // Rule ID 61559 //
     /*  895765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  895776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  895779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  895782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  895785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895811 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  895814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895833 */     GIR_RootConstrainSelectedInstOperands,
     /*  895834 */     // GIR_Coverage, 61559,
     /*  895834 */     GIR_EraseRootFromParent_Done,
     /*  895835 */   // Label 13662: @895835
     /*  895835 */   GIM_Try, /*On fail goto*//*Label 13663*/ GIMT_Encode4(895910), // Rule ID 61562 //
     /*  895840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  895851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  895854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  895857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  895860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895886 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  895889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895908 */     GIR_RootConstrainSelectedInstOperands,
     /*  895909 */     // GIR_Coverage, 61562,
     /*  895909 */     GIR_EraseRootFromParent_Done,
     /*  895910 */   // Label 13663: @895910
     /*  895910 */   GIM_Try, /*On fail goto*//*Label 13664*/ GIMT_Encode4(895985), // Rule ID 61563 //
     /*  895915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  895926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  895929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  895932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  895935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895961 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  895964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895983 */     GIR_RootConstrainSelectedInstOperands,
     /*  895984 */     // GIR_Coverage, 61563,
     /*  895984 */     GIR_EraseRootFromParent_Done,
     /*  895985 */   // Label 13664: @895985
     /*  895985 */   GIM_Try, /*On fail goto*//*Label 13665*/ GIMT_Encode4(896060), // Rule ID 61566 //
     /*  895990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  896001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  896004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  896007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  896010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896036 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  896039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896058 */     GIR_RootConstrainSelectedInstOperands,
     /*  896059 */     // GIR_Coverage, 61566,
     /*  896059 */     GIR_EraseRootFromParent_Done,
     /*  896060 */   // Label 13665: @896060
     /*  896060 */   GIM_Try, /*On fail goto*//*Label 13666*/ GIMT_Encode4(896135), // Rule ID 61567 //
     /*  896065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  896076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  896079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  896082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  896085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896111 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  896114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896133 */     GIR_RootConstrainSelectedInstOperands,
     /*  896134 */     // GIR_Coverage, 61567,
     /*  896134 */     GIR_EraseRootFromParent_Done,
     /*  896135 */   // Label 13666: @896135
     /*  896135 */   GIM_Try, /*On fail goto*//*Label 13667*/ GIMT_Encode4(896210), // Rule ID 61570 //
     /*  896140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  896151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  896154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  896157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  896160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896186 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  896189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896208 */     GIR_RootConstrainSelectedInstOperands,
     /*  896209 */     // GIR_Coverage, 61570,
     /*  896209 */     GIR_EraseRootFromParent_Done,
     /*  896210 */   // Label 13667: @896210
     /*  896210 */   GIM_Try, /*On fail goto*//*Label 13668*/ GIMT_Encode4(896285), // Rule ID 61571 //
     /*  896215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  896226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  896229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  896232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  896235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896261 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  896264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896283 */     GIR_RootConstrainSelectedInstOperands,
     /*  896284 */     // GIR_Coverage, 61571,
     /*  896284 */     GIR_EraseRootFromParent_Done,
     /*  896285 */   // Label 13668: @896285
     /*  896285 */   GIM_Try, /*On fail goto*//*Label 13669*/ GIMT_Encode4(896360), // Rule ID 61574 //
     /*  896290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  896301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  896304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  896307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  896310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896336 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  896339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896358 */     GIR_RootConstrainSelectedInstOperands,
     /*  896359 */     // GIR_Coverage, 61574,
     /*  896359 */     GIR_EraseRootFromParent_Done,
     /*  896360 */   // Label 13669: @896360
     /*  896360 */   GIM_Try, /*On fail goto*//*Label 13670*/ GIMT_Encode4(896435), // Rule ID 61575 //
     /*  896365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  896376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  896379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  896382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  896385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896411 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  896414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896433 */     GIR_RootConstrainSelectedInstOperands,
     /*  896434 */     // GIR_Coverage, 61575,
     /*  896434 */     GIR_EraseRootFromParent_Done,
     /*  896435 */   // Label 13670: @896435
     /*  896435 */   GIM_Try, /*On fail goto*//*Label 13671*/ GIMT_Encode4(896510), // Rule ID 61578 //
     /*  896440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  896451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  896454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  896457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  896460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  896486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  896489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896508 */     GIR_RootConstrainSelectedInstOperands,
     /*  896509 */     // GIR_Coverage, 61578,
     /*  896509 */     GIR_EraseRootFromParent_Done,
     /*  896510 */   // Label 13671: @896510
     /*  896510 */   GIM_Try, /*On fail goto*//*Label 13672*/ GIMT_Encode4(896585), // Rule ID 61579 //
     /*  896515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  896526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  896529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  896532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  896535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896561 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  896561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  896564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896583 */     GIR_RootConstrainSelectedInstOperands,
     /*  896584 */     // GIR_Coverage, 61579,
     /*  896584 */     GIR_EraseRootFromParent_Done,
     /*  896585 */   // Label 13672: @896585
     /*  896585 */   GIM_Try, /*On fail goto*//*Label 13673*/ GIMT_Encode4(896660), // Rule ID 61582 //
     /*  896590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  896601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  896604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  896607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  896610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896636 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  896639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896658 */     GIR_RootConstrainSelectedInstOperands,
     /*  896659 */     // GIR_Coverage, 61582,
     /*  896659 */     GIR_EraseRootFromParent_Done,
     /*  896660 */   // Label 13673: @896660
     /*  896660 */   GIM_Try, /*On fail goto*//*Label 13674*/ GIMT_Encode4(896735), // Rule ID 61583 //
     /*  896665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  896676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  896679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  896682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  896685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896711 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  896714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896733 */     GIR_RootConstrainSelectedInstOperands,
     /*  896734 */     // GIR_Coverage, 61583,
     /*  896734 */     GIR_EraseRootFromParent_Done,
     /*  896735 */   // Label 13674: @896735
     /*  896735 */   GIM_Try, /*On fail goto*//*Label 13675*/ GIMT_Encode4(896810), // Rule ID 61586 //
     /*  896740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  896751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  896754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  896757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  896760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896786 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  896789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896808 */     GIR_RootConstrainSelectedInstOperands,
     /*  896809 */     // GIR_Coverage, 61586,
     /*  896809 */     GIR_EraseRootFromParent_Done,
     /*  896810 */   // Label 13675: @896810
     /*  896810 */   GIM_Try, /*On fail goto*//*Label 13676*/ GIMT_Encode4(896885), // Rule ID 61587 //
     /*  896815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  896826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  896829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  896832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  896835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896861 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  896864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896883 */     GIR_RootConstrainSelectedInstOperands,
     /*  896884 */     // GIR_Coverage, 61587,
     /*  896884 */     GIR_EraseRootFromParent_Done,
     /*  896885 */   // Label 13676: @896885
     /*  896885 */   GIM_Try, /*On fail goto*//*Label 13677*/ GIMT_Encode4(896960), // Rule ID 61590 //
     /*  896890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  896901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  896904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  896907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  896910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896936 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  896936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  896939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896958 */     GIR_RootConstrainSelectedInstOperands,
     /*  896959 */     // GIR_Coverage, 61590,
     /*  896959 */     GIR_EraseRootFromParent_Done,
     /*  896960 */   // Label 13677: @896960
     /*  896960 */   GIM_Try, /*On fail goto*//*Label 13678*/ GIMT_Encode4(897035), // Rule ID 61591 //
     /*  896965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  896976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  896979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  896982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  896985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897011 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  897011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  897014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897033 */     GIR_RootConstrainSelectedInstOperands,
     /*  897034 */     // GIR_Coverage, 61591,
     /*  897034 */     GIR_EraseRootFromParent_Done,
     /*  897035 */   // Label 13678: @897035
     /*  897035 */   GIM_Try, /*On fail goto*//*Label 13679*/ GIMT_Encode4(897110), // Rule ID 61594 //
     /*  897040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  897051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  897054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  897057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  897060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  897086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  897089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897108 */     GIR_RootConstrainSelectedInstOperands,
     /*  897109 */     // GIR_Coverage, 61594,
     /*  897109 */     GIR_EraseRootFromParent_Done,
     /*  897110 */   // Label 13679: @897110
     /*  897110 */   GIM_Try, /*On fail goto*//*Label 13680*/ GIMT_Encode4(897185), // Rule ID 61595 //
     /*  897115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  897126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  897129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  897132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  897135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897161 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  897161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  897164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897183 */     GIR_RootConstrainSelectedInstOperands,
     /*  897184 */     // GIR_Coverage, 61595,
     /*  897184 */     GIR_EraseRootFromParent_Done,
     /*  897185 */   // Label 13680: @897185
     /*  897185 */   GIM_Try, /*On fail goto*//*Label 13681*/ GIMT_Encode4(897260), // Rule ID 61598 //
     /*  897190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  897201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  897204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  897207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  897210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897236 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  897239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897258 */     GIR_RootConstrainSelectedInstOperands,
     /*  897259 */     // GIR_Coverage, 61598,
     /*  897259 */     GIR_EraseRootFromParent_Done,
     /*  897260 */   // Label 13681: @897260
     /*  897260 */   GIM_Try, /*On fail goto*//*Label 13682*/ GIMT_Encode4(897335), // Rule ID 61599 //
     /*  897265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  897276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  897279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  897282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  897285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897311 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  897314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897333 */     GIR_RootConstrainSelectedInstOperands,
     /*  897334 */     // GIR_Coverage, 61599,
     /*  897334 */     GIR_EraseRootFromParent_Done,
     /*  897335 */   // Label 13682: @897335
     /*  897335 */   GIM_Try, /*On fail goto*//*Label 13683*/ GIMT_Encode4(897410), // Rule ID 61602 //
     /*  897340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  897351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  897354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  897357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  897360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897386 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  897389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897408 */     GIR_RootConstrainSelectedInstOperands,
     /*  897409 */     // GIR_Coverage, 61602,
     /*  897409 */     GIR_EraseRootFromParent_Done,
     /*  897410 */   // Label 13683: @897410
     /*  897410 */   GIM_Try, /*On fail goto*//*Label 13684*/ GIMT_Encode4(897485), // Rule ID 61603 //
     /*  897415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  897426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  897429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  897432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  897435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897461 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  897464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897483 */     GIR_RootConstrainSelectedInstOperands,
     /*  897484 */     // GIR_Coverage, 61603,
     /*  897484 */     GIR_EraseRootFromParent_Done,
     /*  897485 */   // Label 13684: @897485
     /*  897485 */   GIM_Try, /*On fail goto*//*Label 13685*/ GIMT_Encode4(897560), // Rule ID 61606 //
     /*  897490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  897501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  897504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  897507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  897510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897536 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  897539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897558 */     GIR_RootConstrainSelectedInstOperands,
     /*  897559 */     // GIR_Coverage, 61606,
     /*  897559 */     GIR_EraseRootFromParent_Done,
     /*  897560 */   // Label 13685: @897560
     /*  897560 */   GIM_Try, /*On fail goto*//*Label 13686*/ GIMT_Encode4(897635), // Rule ID 61607 //
     /*  897565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  897576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  897579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  897582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  897585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897611 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  897614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897633 */     GIR_RootConstrainSelectedInstOperands,
     /*  897634 */     // GIR_Coverage, 61607,
     /*  897634 */     GIR_EraseRootFromParent_Done,
     /*  897635 */   // Label 13686: @897635
     /*  897635 */   GIM_Try, /*On fail goto*//*Label 13687*/ GIMT_Encode4(897710), // Rule ID 61610 //
     /*  897640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  897651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  897654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  897657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  897660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  897689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897708 */     GIR_RootConstrainSelectedInstOperands,
     /*  897709 */     // GIR_Coverage, 61610,
     /*  897709 */     GIR_EraseRootFromParent_Done,
     /*  897710 */   // Label 13687: @897710
     /*  897710 */   GIM_Try, /*On fail goto*//*Label 13688*/ GIMT_Encode4(897785), // Rule ID 61611 //
     /*  897715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  897726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  897729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  897732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  897735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897761 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  897764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897783 */     GIR_RootConstrainSelectedInstOperands,
     /*  897784 */     // GIR_Coverage, 61611,
     /*  897784 */     GIR_EraseRootFromParent_Done,
     /*  897785 */   // Label 13688: @897785
     /*  897785 */   GIM_Try, /*On fail goto*//*Label 13689*/ GIMT_Encode4(897860), // Rule ID 61614 //
     /*  897790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  897801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  897804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  897807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  897810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897836 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  897839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897858 */     GIR_RootConstrainSelectedInstOperands,
     /*  897859 */     // GIR_Coverage, 61614,
     /*  897859 */     GIR_EraseRootFromParent_Done,
     /*  897860 */   // Label 13689: @897860
     /*  897860 */   GIM_Try, /*On fail goto*//*Label 13690*/ GIMT_Encode4(897935), // Rule ID 61615 //
     /*  897865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  897876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  897879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  897882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  897885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897911 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  897914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897933 */     GIR_RootConstrainSelectedInstOperands,
     /*  897934 */     // GIR_Coverage, 61615,
     /*  897934 */     GIR_EraseRootFromParent_Done,
     /*  897935 */   // Label 13690: @897935
     /*  897935 */   GIM_Try, /*On fail goto*//*Label 13691*/ GIMT_Encode4(898010), // Rule ID 61618 //
     /*  897940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  897951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  897954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  897957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  897960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897986 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  897989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898008 */     GIR_RootConstrainSelectedInstOperands,
     /*  898009 */     // GIR_Coverage, 61618,
     /*  898009 */     GIR_EraseRootFromParent_Done,
     /*  898010 */   // Label 13691: @898010
     /*  898010 */   GIM_Try, /*On fail goto*//*Label 13692*/ GIMT_Encode4(898085), // Rule ID 61619 //
     /*  898015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  898026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  898029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  898032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  898035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898061 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  898061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  898064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898083 */     GIR_RootConstrainSelectedInstOperands,
     /*  898084 */     // GIR_Coverage, 61619,
     /*  898084 */     GIR_EraseRootFromParent_Done,
     /*  898085 */   // Label 13692: @898085
     /*  898085 */   GIM_Try, /*On fail goto*//*Label 13693*/ GIMT_Encode4(898160), // Rule ID 61622 //
     /*  898090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  898101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  898104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  898107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  898110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  898136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  898139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898158 */     GIR_RootConstrainSelectedInstOperands,
     /*  898159 */     // GIR_Coverage, 61622,
     /*  898159 */     GIR_EraseRootFromParent_Done,
     /*  898160 */   // Label 13693: @898160
     /*  898160 */   GIM_Try, /*On fail goto*//*Label 13694*/ GIMT_Encode4(898235), // Rule ID 61623 //
     /*  898165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  898176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  898179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  898182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  898185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  898211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  898214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898233 */     GIR_RootConstrainSelectedInstOperands,
     /*  898234 */     // GIR_Coverage, 61623,
     /*  898234 */     GIR_EraseRootFromParent_Done,
     /*  898235 */   // Label 13694: @898235
     /*  898235 */   GIM_Try, /*On fail goto*//*Label 13695*/ GIMT_Encode4(898310), // Rule ID 61626 //
     /*  898240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  898251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  898254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  898257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  898260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898286 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  898286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  898289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898308 */     GIR_RootConstrainSelectedInstOperands,
     /*  898309 */     // GIR_Coverage, 61626,
     /*  898309 */     GIR_EraseRootFromParent_Done,
     /*  898310 */   // Label 13695: @898310
     /*  898310 */   GIM_Try, /*On fail goto*//*Label 13696*/ GIMT_Encode4(898385), // Rule ID 61627 //
     /*  898315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  898326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  898329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  898332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  898335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898361 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  898361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  898364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898383 */     GIR_RootConstrainSelectedInstOperands,
     /*  898384 */     // GIR_Coverage, 61627,
     /*  898384 */     GIR_EraseRootFromParent_Done,
     /*  898385 */   // Label 13696: @898385
     /*  898385 */   GIM_Try, /*On fail goto*//*Label 13697*/ GIMT_Encode4(898460), // Rule ID 61630 //
     /*  898390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  898401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  898404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  898407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  898410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898436 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  898436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  898439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898458 */     GIR_RootConstrainSelectedInstOperands,
     /*  898459 */     // GIR_Coverage, 61630,
     /*  898459 */     GIR_EraseRootFromParent_Done,
     /*  898460 */   // Label 13697: @898460
     /*  898460 */   GIM_Try, /*On fail goto*//*Label 13698*/ GIMT_Encode4(898535), // Rule ID 61631 //
     /*  898465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  898476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  898479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  898482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  898485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898511 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  898511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  898514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898533 */     GIR_RootConstrainSelectedInstOperands,
     /*  898534 */     // GIR_Coverage, 61631,
     /*  898534 */     GIR_EraseRootFromParent_Done,
     /*  898535 */   // Label 13698: @898535
     /*  898535 */   GIM_Try, /*On fail goto*//*Label 13699*/ GIMT_Encode4(898610), // Rule ID 61634 //
     /*  898540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  898551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  898554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  898557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  898560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  898589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898608 */     GIR_RootConstrainSelectedInstOperands,
     /*  898609 */     // GIR_Coverage, 61634,
     /*  898609 */     GIR_EraseRootFromParent_Done,
     /*  898610 */   // Label 13699: @898610
     /*  898610 */   GIM_Try, /*On fail goto*//*Label 13700*/ GIMT_Encode4(898685), // Rule ID 61635 //
     /*  898615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  898626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  898629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  898632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  898635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898661 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  898664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898683 */     GIR_RootConstrainSelectedInstOperands,
     /*  898684 */     // GIR_Coverage, 61635,
     /*  898684 */     GIR_EraseRootFromParent_Done,
     /*  898685 */   // Label 13700: @898685
     /*  898685 */   GIM_Try, /*On fail goto*//*Label 13701*/ GIMT_Encode4(898760), // Rule ID 61638 //
     /*  898690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  898710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898736 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  898739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898758 */     GIR_RootConstrainSelectedInstOperands,
     /*  898759 */     // GIR_Coverage, 61638,
     /*  898759 */     GIR_EraseRootFromParent_Done,
     /*  898760 */   // Label 13701: @898760
     /*  898760 */   GIM_Try, /*On fail goto*//*Label 13702*/ GIMT_Encode4(898835), // Rule ID 61639 //
     /*  898765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  898785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898811 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  898814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898833 */     GIR_RootConstrainSelectedInstOperands,
     /*  898834 */     // GIR_Coverage, 61639,
     /*  898834 */     GIR_EraseRootFromParent_Done,
     /*  898835 */   // Label 13702: @898835
     /*  898835 */   GIM_Try, /*On fail goto*//*Label 13703*/ GIMT_Encode4(898910), // Rule ID 61642 //
     /*  898840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  898860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  898889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898908 */     GIR_RootConstrainSelectedInstOperands,
     /*  898909 */     // GIR_Coverage, 61642,
     /*  898909 */     GIR_EraseRootFromParent_Done,
     /*  898910 */   // Label 13703: @898910
     /*  898910 */   GIM_Try, /*On fail goto*//*Label 13704*/ GIMT_Encode4(898985), // Rule ID 61643 //
     /*  898915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  898935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898961 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  898964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898983 */     GIR_RootConstrainSelectedInstOperands,
     /*  898984 */     // GIR_Coverage, 61643,
     /*  898984 */     GIR_EraseRootFromParent_Done,
     /*  898985 */   // Label 13704: @898985
     /*  898985 */   GIM_Try, /*On fail goto*//*Label 13705*/ GIMT_Encode4(899060), // Rule ID 61646 //
     /*  898990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  899001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  899004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  899007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899036 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  899039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899058 */     GIR_RootConstrainSelectedInstOperands,
     /*  899059 */     // GIR_Coverage, 61646,
     /*  899059 */     GIR_EraseRootFromParent_Done,
     /*  899060 */   // Label 13705: @899060
     /*  899060 */   GIM_Try, /*On fail goto*//*Label 13706*/ GIMT_Encode4(899135), // Rule ID 61647 //
     /*  899065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  899076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  899079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  899082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899111 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  899114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899133 */     GIR_RootConstrainSelectedInstOperands,
     /*  899134 */     // GIR_Coverage, 61647,
     /*  899134 */     GIR_EraseRootFromParent_Done,
     /*  899135 */   // Label 13706: @899135
     /*  899135 */   GIM_Try, /*On fail goto*//*Label 13707*/ GIMT_Encode4(899210), // Rule ID 61650 //
     /*  899140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  899151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  899154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  899157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899186 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  899189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899208 */     GIR_RootConstrainSelectedInstOperands,
     /*  899209 */     // GIR_Coverage, 61650,
     /*  899209 */     GIR_EraseRootFromParent_Done,
     /*  899210 */   // Label 13707: @899210
     /*  899210 */   GIM_Try, /*On fail goto*//*Label 13708*/ GIMT_Encode4(899285), // Rule ID 61651 //
     /*  899215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  899226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  899229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  899232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899261 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  899264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899283 */     GIR_RootConstrainSelectedInstOperands,
     /*  899284 */     // GIR_Coverage, 61651,
     /*  899284 */     GIR_EraseRootFromParent_Done,
     /*  899285 */   // Label 13708: @899285
     /*  899285 */   GIM_Try, /*On fail goto*//*Label 13709*/ GIMT_Encode4(899360), // Rule ID 61654 //
     /*  899290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  899301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  899304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  899307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899336 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  899339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899358 */     GIR_RootConstrainSelectedInstOperands,
     /*  899359 */     // GIR_Coverage, 61654,
     /*  899359 */     GIR_EraseRootFromParent_Done,
     /*  899360 */   // Label 13709: @899360
     /*  899360 */   GIM_Try, /*On fail goto*//*Label 13710*/ GIMT_Encode4(899435), // Rule ID 61655 //
     /*  899365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  899376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  899379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  899382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899411 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  899414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899433 */     GIR_RootConstrainSelectedInstOperands,
     /*  899434 */     // GIR_Coverage, 61655,
     /*  899434 */     GIR_EraseRootFromParent_Done,
     /*  899435 */   // Label 13710: @899435
     /*  899435 */   GIM_Try, /*On fail goto*//*Label 13711*/ GIMT_Encode4(899510), // Rule ID 61658 //
     /*  899440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  899451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  899454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  899457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899486 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  899489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899508 */     GIR_RootConstrainSelectedInstOperands,
     /*  899509 */     // GIR_Coverage, 61658,
     /*  899509 */     GIR_EraseRootFromParent_Done,
     /*  899510 */   // Label 13711: @899510
     /*  899510 */   GIM_Try, /*On fail goto*//*Label 13712*/ GIMT_Encode4(899585), // Rule ID 61659 //
     /*  899515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  899526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  899529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  899532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899561 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  899564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899583 */     GIR_RootConstrainSelectedInstOperands,
     /*  899584 */     // GIR_Coverage, 61659,
     /*  899584 */     GIR_EraseRootFromParent_Done,
     /*  899585 */   // Label 13712: @899585
     /*  899585 */   GIM_Try, /*On fail goto*//*Label 13713*/ GIMT_Encode4(899660), // Rule ID 61662 //
     /*  899590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  899601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  899604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  899607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899636 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  899639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899658 */     GIR_RootConstrainSelectedInstOperands,
     /*  899659 */     // GIR_Coverage, 61662,
     /*  899659 */     GIR_EraseRootFromParent_Done,
     /*  899660 */   // Label 13713: @899660
     /*  899660 */   GIM_Try, /*On fail goto*//*Label 13714*/ GIMT_Encode4(899735), // Rule ID 61663 //
     /*  899665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  899676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  899679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  899682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899711 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  899714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899733 */     GIR_RootConstrainSelectedInstOperands,
     /*  899734 */     // GIR_Coverage, 61663,
     /*  899734 */     GIR_EraseRootFromParent_Done,
     /*  899735 */   // Label 13714: @899735
     /*  899735 */   GIM_Try, /*On fail goto*//*Label 13715*/ GIMT_Encode4(899810), // Rule ID 61666 //
     /*  899740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  899757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899786 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  899786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  899789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899808 */     GIR_RootConstrainSelectedInstOperands,
     /*  899809 */     // GIR_Coverage, 61666,
     /*  899809 */     GIR_EraseRootFromParent_Done,
     /*  899810 */   // Label 13715: @899810
     /*  899810 */   GIM_Try, /*On fail goto*//*Label 13716*/ GIMT_Encode4(899885), // Rule ID 61667 //
     /*  899815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  899832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899861 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  899861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  899864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899883 */     GIR_RootConstrainSelectedInstOperands,
     /*  899884 */     // GIR_Coverage, 61667,
     /*  899884 */     GIR_EraseRootFromParent_Done,
     /*  899885 */   // Label 13716: @899885
     /*  899885 */   GIM_Try, /*On fail goto*//*Label 13717*/ GIMT_Encode4(899960), // Rule ID 61670 //
     /*  899890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  899901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  899904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  899907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899936 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  899939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899958 */     GIR_RootConstrainSelectedInstOperands,
     /*  899959 */     // GIR_Coverage, 61670,
     /*  899959 */     GIR_EraseRootFromParent_Done,
     /*  899960 */   // Label 13717: @899960
     /*  899960 */   GIM_Try, /*On fail goto*//*Label 13718*/ GIMT_Encode4(900035), // Rule ID 61671 //
     /*  899965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  899976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  899979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  899982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900011 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900033 */     GIR_RootConstrainSelectedInstOperands,
     /*  900034 */     // GIR_Coverage, 61671,
     /*  900034 */     GIR_EraseRootFromParent_Done,
     /*  900035 */   // Label 13718: @900035
     /*  900035 */   GIM_Try, /*On fail goto*//*Label 13719*/ GIMT_Encode4(900110), // Rule ID 61674 //
     /*  900040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  900051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  900054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  900057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900108 */     GIR_RootConstrainSelectedInstOperands,
     /*  900109 */     // GIR_Coverage, 61674,
     /*  900109 */     GIR_EraseRootFromParent_Done,
     /*  900110 */   // Label 13719: @900110
     /*  900110 */   GIM_Try, /*On fail goto*//*Label 13720*/ GIMT_Encode4(900185), // Rule ID 61675 //
     /*  900115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  900126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  900129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  900132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  900135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900161 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900183 */     GIR_RootConstrainSelectedInstOperands,
     /*  900184 */     // GIR_Coverage, 61675,
     /*  900184 */     GIR_EraseRootFromParent_Done,
     /*  900185 */   // Label 13720: @900185
     /*  900185 */   GIM_Try, /*On fail goto*//*Label 13721*/ GIMT_Encode4(900260), // Rule ID 61678 //
     /*  900190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  900201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  900204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  900207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  900236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900258 */     GIR_RootConstrainSelectedInstOperands,
     /*  900259 */     // GIR_Coverage, 61678,
     /*  900259 */     GIR_EraseRootFromParent_Done,
     /*  900260 */   // Label 13721: @900260
     /*  900260 */   GIM_Try, /*On fail goto*//*Label 13722*/ GIMT_Encode4(900335), // Rule ID 61679 //
     /*  900265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  900276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  900279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  900282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  900285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900311 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  900311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900333 */     GIR_RootConstrainSelectedInstOperands,
     /*  900334 */     // GIR_Coverage, 61679,
     /*  900334 */     GIR_EraseRootFromParent_Done,
     /*  900335 */   // Label 13722: @900335
     /*  900335 */   GIM_Try, /*On fail goto*//*Label 13723*/ GIMT_Encode4(900410), // Rule ID 61682 //
     /*  900340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  900351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  900354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  900357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900386 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  900386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  900405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900408 */     GIR_RootConstrainSelectedInstOperands,
     /*  900409 */     // GIR_Coverage, 61682,
     /*  900409 */     GIR_EraseRootFromParent_Done,
     /*  900410 */   // Label 13723: @900410
     /*  900410 */   GIM_Try, /*On fail goto*//*Label 13724*/ GIMT_Encode4(900485), // Rule ID 61683 //
     /*  900415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  900426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  900429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  900432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  900435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900461 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  900461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  900480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900483 */     GIR_RootConstrainSelectedInstOperands,
     /*  900484 */     // GIR_Coverage, 61683,
     /*  900484 */     GIR_EraseRootFromParent_Done,
     /*  900485 */   // Label 13724: @900485
     /*  900485 */   GIM_Try, /*On fail goto*//*Label 13725*/ GIMT_Encode4(900560), // Rule ID 61686 //
     /*  900490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  900501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  900504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  900507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  900539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900558 */     GIR_RootConstrainSelectedInstOperands,
     /*  900559 */     // GIR_Coverage, 61686,
     /*  900559 */     GIR_EraseRootFromParent_Done,
     /*  900560 */   // Label 13725: @900560
     /*  900560 */   GIM_Try, /*On fail goto*//*Label 13726*/ GIMT_Encode4(900635), // Rule ID 61687 //
     /*  900565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  900576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  900579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  900582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  900585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900611 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  900614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900633 */     GIR_RootConstrainSelectedInstOperands,
     /*  900634 */     // GIR_Coverage, 61687,
     /*  900634 */     GIR_EraseRootFromParent_Done,
     /*  900635 */   // Label 13726: @900635
     /*  900635 */   GIM_Try, /*On fail goto*//*Label 13727*/ GIMT_Encode4(900710), // Rule ID 61690 //
     /*  900640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  900651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  900654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  900657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900686 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  900689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900708 */     GIR_RootConstrainSelectedInstOperands,
     /*  900709 */     // GIR_Coverage, 61690,
     /*  900709 */     GIR_EraseRootFromParent_Done,
     /*  900710 */   // Label 13727: @900710
     /*  900710 */   GIM_Try, /*On fail goto*//*Label 13728*/ GIMT_Encode4(900785), // Rule ID 61691 //
     /*  900715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  900726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  900729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  900732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  900735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900761 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  900764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900783 */     GIR_RootConstrainSelectedInstOperands,
     /*  900784 */     // GIR_Coverage, 61691,
     /*  900784 */     GIR_EraseRootFromParent_Done,
     /*  900785 */   // Label 13728: @900785
     /*  900785 */   GIM_Try, /*On fail goto*//*Label 13729*/ GIMT_Encode4(900860), // Rule ID 61694 //
     /*  900790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  900801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  900804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  900807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900836 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  900839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900858 */     GIR_RootConstrainSelectedInstOperands,
     /*  900859 */     // GIR_Coverage, 61694,
     /*  900859 */     GIR_EraseRootFromParent_Done,
     /*  900860 */   // Label 13729: @900860
     /*  900860 */   GIM_Try, /*On fail goto*//*Label 13730*/ GIMT_Encode4(900935), // Rule ID 61695 //
     /*  900865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  900876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  900879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  900882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  900885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900911 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  900914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900933 */     GIR_RootConstrainSelectedInstOperands,
     /*  900934 */     // GIR_Coverage, 61695,
     /*  900934 */     GIR_EraseRootFromParent_Done,
     /*  900935 */   // Label 13730: @900935
     /*  900935 */   GIM_Try, /*On fail goto*//*Label 13731*/ GIMT_Encode4(901010), // Rule ID 61698 //
     /*  900940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  900951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  900954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  900957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  900989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901008 */     GIR_RootConstrainSelectedInstOperands,
     /*  901009 */     // GIR_Coverage, 61698,
     /*  901009 */     GIR_EraseRootFromParent_Done,
     /*  901010 */   // Label 13731: @901010
     /*  901010 */   GIM_Try, /*On fail goto*//*Label 13732*/ GIMT_Encode4(901085), // Rule ID 61699 //
     /*  901015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  901026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  901029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  901032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901061 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  901061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  901064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901083 */     GIR_RootConstrainSelectedInstOperands,
     /*  901084 */     // GIR_Coverage, 61699,
     /*  901084 */     GIR_EraseRootFromParent_Done,
     /*  901085 */   // Label 13732: @901085
     /*  901085 */   GIM_Try, /*On fail goto*//*Label 13733*/ GIMT_Encode4(901160), // Rule ID 61702 //
     /*  901090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  901101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  901104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  901107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  901136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  901139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901158 */     GIR_RootConstrainSelectedInstOperands,
     /*  901159 */     // GIR_Coverage, 61702,
     /*  901159 */     GIR_EraseRootFromParent_Done,
     /*  901160 */   // Label 13733: @901160
     /*  901160 */   GIM_Try, /*On fail goto*//*Label 13734*/ GIMT_Encode4(901235), // Rule ID 61703 //
     /*  901165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  901176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  901179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  901182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901211 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  901211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  901214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901233 */     GIR_RootConstrainSelectedInstOperands,
     /*  901234 */     // GIR_Coverage, 61703,
     /*  901234 */     GIR_EraseRootFromParent_Done,
     /*  901235 */   // Label 13734: @901235
     /*  901235 */   GIM_Try, /*On fail goto*//*Label 13735*/ GIMT_Encode4(901310), // Rule ID 61706 //
     /*  901240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  901251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  901254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  901257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  901286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  901289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901308 */     GIR_RootConstrainSelectedInstOperands,
     /*  901309 */     // GIR_Coverage, 61706,
     /*  901309 */     GIR_EraseRootFromParent_Done,
     /*  901310 */   // Label 13735: @901310
     /*  901310 */   GIM_Try, /*On fail goto*//*Label 13736*/ GIMT_Encode4(901385), // Rule ID 61707 //
     /*  901315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  901326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  901329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  901332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901361 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  901361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  901364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901383 */     GIR_RootConstrainSelectedInstOperands,
     /*  901384 */     // GIR_Coverage, 61707,
     /*  901384 */     GIR_EraseRootFromParent_Done,
     /*  901385 */   // Label 13736: @901385
     /*  901385 */   GIM_Try, /*On fail goto*//*Label 13737*/ GIMT_Encode4(901460), // Rule ID 61710 //
     /*  901390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  901401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  901404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  901407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  901439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901458 */     GIR_RootConstrainSelectedInstOperands,
     /*  901459 */     // GIR_Coverage, 61710,
     /*  901459 */     GIR_EraseRootFromParent_Done,
     /*  901460 */   // Label 13737: @901460
     /*  901460 */   GIM_Try, /*On fail goto*//*Label 13738*/ GIMT_Encode4(901535), // Rule ID 61711 //
     /*  901465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  901476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  901479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  901482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901511 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  901514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901533 */     GIR_RootConstrainSelectedInstOperands,
     /*  901534 */     // GIR_Coverage, 61711,
     /*  901534 */     GIR_EraseRootFromParent_Done,
     /*  901535 */   // Label 13738: @901535
     /*  901535 */   GIM_Try, /*On fail goto*//*Label 13739*/ GIMT_Encode4(901610), // Rule ID 61714 //
     /*  901540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  901551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  901554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  901557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  901589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901608 */     GIR_RootConstrainSelectedInstOperands,
     /*  901609 */     // GIR_Coverage, 61714,
     /*  901609 */     GIR_EraseRootFromParent_Done,
     /*  901610 */   // Label 13739: @901610
     /*  901610 */   GIM_Try, /*On fail goto*//*Label 13740*/ GIMT_Encode4(901685), // Rule ID 61715 //
     /*  901615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  901626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  901629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  901632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901661 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  901664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901683 */     GIR_RootConstrainSelectedInstOperands,
     /*  901684 */     // GIR_Coverage, 61715,
     /*  901684 */     GIR_EraseRootFromParent_Done,
     /*  901685 */   // Label 13740: @901685
     /*  901685 */   GIM_Try, /*On fail goto*//*Label 13741*/ GIMT_Encode4(901760), // Rule ID 61718 //
     /*  901690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  901701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  901704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  901707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901736 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  901739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901758 */     GIR_RootConstrainSelectedInstOperands,
     /*  901759 */     // GIR_Coverage, 61718,
     /*  901759 */     GIR_EraseRootFromParent_Done,
     /*  901760 */   // Label 13741: @901760
     /*  901760 */   GIM_Try, /*On fail goto*//*Label 13742*/ GIMT_Encode4(901835), // Rule ID 61719 //
     /*  901765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  901776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  901779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  901782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901811 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  901814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901833 */     GIR_RootConstrainSelectedInstOperands,
     /*  901834 */     // GIR_Coverage, 61719,
     /*  901834 */     GIR_EraseRootFromParent_Done,
     /*  901835 */   // Label 13742: @901835
     /*  901835 */   GIM_Try, /*On fail goto*//*Label 13743*/ GIMT_Encode4(901910), // Rule ID 61722 //
     /*  901840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  901851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  901854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  901857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  901886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  901889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901908 */     GIR_RootConstrainSelectedInstOperands,
     /*  901909 */     // GIR_Coverage, 61722,
     /*  901909 */     GIR_EraseRootFromParent_Done,
     /*  901910 */   // Label 13743: @901910
     /*  901910 */   GIM_Try, /*On fail goto*//*Label 13744*/ GIMT_Encode4(901985), // Rule ID 61723 //
     /*  901915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  901926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  901929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  901932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11502:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  901961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  901964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901983 */     GIR_RootConstrainSelectedInstOperands,
     /*  901984 */     // GIR_Coverage, 61723,
     /*  901984 */     GIR_EraseRootFromParent_Done,
     /*  901985 */   // Label 13744: @901985
     /*  901985 */   GIM_Try, /*On fail goto*//*Label 13745*/ GIMT_Encode4(902060), // Rule ID 61726 //
     /*  901990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  902001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  902004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  902007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  902036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  902039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902058 */     GIR_RootConstrainSelectedInstOperands,
     /*  902059 */     // GIR_Coverage, 61726,
     /*  902059 */     GIR_EraseRootFromParent_Done,
     /*  902060 */   // Label 13745: @902060
     /*  902060 */   GIM_Try, /*On fail goto*//*Label 13746*/ GIMT_Encode4(902135), // Rule ID 61727 //
     /*  902065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  902073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  902076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  902079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  902082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902111 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11502:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  902111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  902114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902133 */     GIR_RootConstrainSelectedInstOperands,
     /*  902134 */     // GIR_Coverage, 61727,
     /*  902134 */     GIR_EraseRootFromParent_Done,
     /*  902135 */   // Label 13746: @902135
     /*  902135 */   GIM_Try, /*On fail goto*//*Label 13747*/ GIMT_Encode4(902210), // Rule ID 61730 //
     /*  902140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  902148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  902151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  902154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  902157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902186 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  902186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  902189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902208 */     GIR_RootConstrainSelectedInstOperands,
     /*  902209 */     // GIR_Coverage, 61730,
     /*  902209 */     GIR_EraseRootFromParent_Done,
     /*  902210 */   // Label 13747: @902210
     /*  902210 */   GIM_Try, /*On fail goto*//*Label 13748*/ GIMT_Encode4(902285), // Rule ID 61731 //
     /*  902215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  902223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  902226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  902229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  902232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902261 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11502:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  902261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  902264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902283 */     GIR_RootConstrainSelectedInstOperands,
     /*  902284 */     // GIR_Coverage, 61731,
     /*  902284 */     GIR_EraseRootFromParent_Done,
     /*  902285 */   // Label 13748: @902285
     /*  902285 */   GIM_Try, /*On fail goto*//*Label 13749*/ GIMT_Encode4(902360), // Rule ID 61818 //
     /*  902290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  902301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  902304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  902307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  902310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902336 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  902339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902358 */     GIR_RootConstrainSelectedInstOperands,
     /*  902359 */     // GIR_Coverage, 61818,
     /*  902359 */     GIR_EraseRootFromParent_Done,
     /*  902360 */   // Label 13749: @902360
     /*  902360 */   GIM_Try, /*On fail goto*//*Label 13750*/ GIMT_Encode4(902435), // Rule ID 61819 //
     /*  902365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  902376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  902379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  902382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  902385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902411 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  902414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902433 */     GIR_RootConstrainSelectedInstOperands,
     /*  902434 */     // GIR_Coverage, 61819,
     /*  902434 */     GIR_EraseRootFromParent_Done,
     /*  902435 */   // Label 13750: @902435
     /*  902435 */   GIM_Try, /*On fail goto*//*Label 13751*/ GIMT_Encode4(902510), // Rule ID 61822 //
     /*  902440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  902451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  902454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  902457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  902460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902486 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  902489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902508 */     GIR_RootConstrainSelectedInstOperands,
     /*  902509 */     // GIR_Coverage, 61822,
     /*  902509 */     GIR_EraseRootFromParent_Done,
     /*  902510 */   // Label 13751: @902510
     /*  902510 */   GIM_Try, /*On fail goto*//*Label 13752*/ GIMT_Encode4(902585), // Rule ID 61823 //
     /*  902515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  902526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  902529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  902532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  902535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902561 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  902564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902583 */     GIR_RootConstrainSelectedInstOperands,
     /*  902584 */     // GIR_Coverage, 61823,
     /*  902584 */     GIR_EraseRootFromParent_Done,
     /*  902585 */   // Label 13752: @902585
     /*  902585 */   GIM_Try, /*On fail goto*//*Label 13753*/ GIMT_Encode4(902660), // Rule ID 61826 //
     /*  902590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  902601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  902604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  902610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902636 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  902639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902658 */     GIR_RootConstrainSelectedInstOperands,
     /*  902659 */     // GIR_Coverage, 61826,
     /*  902659 */     GIR_EraseRootFromParent_Done,
     /*  902660 */   // Label 13753: @902660
     /*  902660 */   GIM_Try, /*On fail goto*//*Label 13754*/ GIMT_Encode4(902735), // Rule ID 61827 //
     /*  902665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  902676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  902679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  902685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902711 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  902714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902733 */     GIR_RootConstrainSelectedInstOperands,
     /*  902734 */     // GIR_Coverage, 61827,
     /*  902734 */     GIR_EraseRootFromParent_Done,
     /*  902735 */   // Label 13754: @902735
     /*  902735 */   GIM_Try, /*On fail goto*//*Label 13755*/ GIMT_Encode4(902810), // Rule ID 61830 //
     /*  902740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  902751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  902754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  902760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  902789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902808 */     GIR_RootConstrainSelectedInstOperands,
     /*  902809 */     // GIR_Coverage, 61830,
     /*  902809 */     GIR_EraseRootFromParent_Done,
     /*  902810 */   // Label 13755: @902810
     /*  902810 */   GIM_Try, /*On fail goto*//*Label 13756*/ GIMT_Encode4(902885), // Rule ID 61831 //
     /*  902815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  902826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  902829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  902835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902861 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  902861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  902864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902883 */     GIR_RootConstrainSelectedInstOperands,
     /*  902884 */     // GIR_Coverage, 61831,
     /*  902884 */     GIR_EraseRootFromParent_Done,
     /*  902885 */   // Label 13756: @902885
     /*  902885 */   GIM_Try, /*On fail goto*//*Label 13757*/ GIMT_Encode4(902960), // Rule ID 61834 //
     /*  902890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  902901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  902904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  902910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902936 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  902939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902958 */     GIR_RootConstrainSelectedInstOperands,
     /*  902959 */     // GIR_Coverage, 61834,
     /*  902959 */     GIR_EraseRootFromParent_Done,
     /*  902960 */   // Label 13757: @902960
     /*  902960 */   GIM_Try, /*On fail goto*//*Label 13758*/ GIMT_Encode4(903035), // Rule ID 61835 //
     /*  902965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  902976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  902979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  902985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903011 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  903011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  903014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903033 */     GIR_RootConstrainSelectedInstOperands,
     /*  903034 */     // GIR_Coverage, 61835,
     /*  903034 */     GIR_EraseRootFromParent_Done,
     /*  903035 */   // Label 13758: @903035
     /*  903035 */   GIM_Try, /*On fail goto*//*Label 13759*/ GIMT_Encode4(903110), // Rule ID 61838 //
     /*  903040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  903051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  903054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  903057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  903060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  903086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  903089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903108 */     GIR_RootConstrainSelectedInstOperands,
     /*  903109 */     // GIR_Coverage, 61838,
     /*  903109 */     GIR_EraseRootFromParent_Done,
     /*  903110 */   // Label 13759: @903110
     /*  903110 */   GIM_Try, /*On fail goto*//*Label 13760*/ GIMT_Encode4(903185), // Rule ID 61839 //
     /*  903115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  903126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  903129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  903132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  903135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903161 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  903161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  903164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903183 */     GIR_RootConstrainSelectedInstOperands,
     /*  903184 */     // GIR_Coverage, 61839,
     /*  903184 */     GIR_EraseRootFromParent_Done,
     /*  903185 */   // Label 13760: @903185
     /*  903185 */   GIM_Try, /*On fail goto*//*Label 13761*/ GIMT_Encode4(903260), // Rule ID 61842 //
     /*  903190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  903201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  903204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  903207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  903210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903236 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903258 */     GIR_RootConstrainSelectedInstOperands,
     /*  903259 */     // GIR_Coverage, 61842,
     /*  903259 */     GIR_EraseRootFromParent_Done,
     /*  903260 */   // Label 13761: @903260
     /*  903260 */   GIM_Try, /*On fail goto*//*Label 13762*/ GIMT_Encode4(903335), // Rule ID 61843 //
     /*  903265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  903276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  903279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  903282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  903285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903311 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903333 */     GIR_RootConstrainSelectedInstOperands,
     /*  903334 */     // GIR_Coverage, 61843,
     /*  903334 */     GIR_EraseRootFromParent_Done,
     /*  903335 */   // Label 13762: @903335
     /*  903335 */   GIM_Try, /*On fail goto*//*Label 13763*/ GIMT_Encode4(903410), // Rule ID 61846 //
     /*  903340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  903351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  903354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  903357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  903360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  903386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903408 */     GIR_RootConstrainSelectedInstOperands,
     /*  903409 */     // GIR_Coverage, 61846,
     /*  903409 */     GIR_EraseRootFromParent_Done,
     /*  903410 */   // Label 13763: @903410
     /*  903410 */   GIM_Try, /*On fail goto*//*Label 13764*/ GIMT_Encode4(903485), // Rule ID 61847 //
     /*  903415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  903426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  903429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  903432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  903435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903461 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  903461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903483 */     GIR_RootConstrainSelectedInstOperands,
     /*  903484 */     // GIR_Coverage, 61847,
     /*  903484 */     GIR_EraseRootFromParent_Done,
     /*  903485 */   // Label 13764: @903485
     /*  903485 */   GIM_Try, /*On fail goto*//*Label 13765*/ GIMT_Encode4(903560), // Rule ID 61850 //
     /*  903490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  903501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  903504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  903507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  903510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  903536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903558 */     GIR_RootConstrainSelectedInstOperands,
     /*  903559 */     // GIR_Coverage, 61850,
     /*  903559 */     GIR_EraseRootFromParent_Done,
     /*  903560 */   // Label 13765: @903560
     /*  903560 */   GIM_Try, /*On fail goto*//*Label 13766*/ GIMT_Encode4(903635), // Rule ID 61851 //
     /*  903565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  903576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  903579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  903582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  903585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903611 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  903611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903633 */     GIR_RootConstrainSelectedInstOperands,
     /*  903634 */     // GIR_Coverage, 61851,
     /*  903634 */     GIR_EraseRootFromParent_Done,
     /*  903635 */   // Label 13766: @903635
     /*  903635 */   GIM_Try, /*On fail goto*//*Label 13767*/ GIMT_Encode4(903710), // Rule ID 61854 //
     /*  903640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  903657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  903660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903686 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  903686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903708 */     GIR_RootConstrainSelectedInstOperands,
     /*  903709 */     // GIR_Coverage, 61854,
     /*  903709 */     GIR_EraseRootFromParent_Done,
     /*  903710 */   // Label 13767: @903710
     /*  903710 */   GIM_Try, /*On fail goto*//*Label 13768*/ GIMT_Encode4(903785), // Rule ID 61855 //
     /*  903715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  903732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  903735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903761 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  903761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903783 */     GIR_RootConstrainSelectedInstOperands,
     /*  903784 */     // GIR_Coverage, 61855,
     /*  903784 */     GIR_EraseRootFromParent_Done,
     /*  903785 */   // Label 13768: @903785
     /*  903785 */   GIM_Try, /*On fail goto*//*Label 13769*/ GIMT_Encode4(903860), // Rule ID 61858 //
     /*  903790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  903801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  903804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  903807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  903810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903836 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  903839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903858 */     GIR_RootConstrainSelectedInstOperands,
     /*  903859 */     // GIR_Coverage, 61858,
     /*  903859 */     GIR_EraseRootFromParent_Done,
     /*  903860 */   // Label 13769: @903860
     /*  903860 */   GIM_Try, /*On fail goto*//*Label 13770*/ GIMT_Encode4(903935), // Rule ID 61859 //
     /*  903865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  903876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  903879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  903882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  903885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903911 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  903914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903933 */     GIR_RootConstrainSelectedInstOperands,
     /*  903934 */     // GIR_Coverage, 61859,
     /*  903934 */     GIR_EraseRootFromParent_Done,
     /*  903935 */   // Label 13770: @903935
     /*  903935 */   GIM_Try, /*On fail goto*//*Label 13771*/ GIMT_Encode4(904010), // Rule ID 61862 //
     /*  903940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  903951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  903954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  903957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  903960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903986 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  903989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904008 */     GIR_RootConstrainSelectedInstOperands,
     /*  904009 */     // GIR_Coverage, 61862,
     /*  904009 */     GIR_EraseRootFromParent_Done,
     /*  904010 */   // Label 13771: @904010
     /*  904010 */   GIM_Try, /*On fail goto*//*Label 13772*/ GIMT_Encode4(904085), // Rule ID 61863 //
     /*  904015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  904026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  904029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  904032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  904035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904061 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  904061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  904064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904083 */     GIR_RootConstrainSelectedInstOperands,
     /*  904084 */     // GIR_Coverage, 61863,
     /*  904084 */     GIR_EraseRootFromParent_Done,
     /*  904085 */   // Label 13772: @904085
     /*  904085 */   GIM_Try, /*On fail goto*//*Label 13773*/ GIMT_Encode4(904160), // Rule ID 61866 //
     /*  904090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  904101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  904104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  904107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  904110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904136 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  904136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  904139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904158 */     GIR_RootConstrainSelectedInstOperands,
     /*  904159 */     // GIR_Coverage, 61866,
     /*  904159 */     GIR_EraseRootFromParent_Done,
     /*  904160 */   // Label 13773: @904160
     /*  904160 */   GIM_Try, /*On fail goto*//*Label 13774*/ GIMT_Encode4(904235), // Rule ID 61867 //
     /*  904165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  904176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  904179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  904182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  904185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904211 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  904211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  904214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904233 */     GIR_RootConstrainSelectedInstOperands,
     /*  904234 */     // GIR_Coverage, 61867,
     /*  904234 */     GIR_EraseRootFromParent_Done,
     /*  904235 */   // Label 13774: @904235
     /*  904235 */   GIM_Try, /*On fail goto*//*Label 13775*/ GIMT_Encode4(904310), // Rule ID 61870 //
     /*  904240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  904251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  904254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  904257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  904260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904286 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  904289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904308 */     GIR_RootConstrainSelectedInstOperands,
     /*  904309 */     // GIR_Coverage, 61870,
     /*  904309 */     GIR_EraseRootFromParent_Done,
     /*  904310 */   // Label 13775: @904310
     /*  904310 */   GIM_Try, /*On fail goto*//*Label 13776*/ GIMT_Encode4(904385), // Rule ID 61871 //
     /*  904315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  904326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  904329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  904332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  904335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904361 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  904364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904383 */     GIR_RootConstrainSelectedInstOperands,
     /*  904384 */     // GIR_Coverage, 61871,
     /*  904384 */     GIR_EraseRootFromParent_Done,
     /*  904385 */   // Label 13776: @904385
     /*  904385 */   GIM_Try, /*On fail goto*//*Label 13777*/ GIMT_Encode4(904460), // Rule ID 61874 //
     /*  904390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  904401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  904404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  904407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  904410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904436 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  904439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904458 */     GIR_RootConstrainSelectedInstOperands,
     /*  904459 */     // GIR_Coverage, 61874,
     /*  904459 */     GIR_EraseRootFromParent_Done,
     /*  904460 */   // Label 13777: @904460
     /*  904460 */   GIM_Try, /*On fail goto*//*Label 13778*/ GIMT_Encode4(904535), // Rule ID 61875 //
     /*  904465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  904476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  904479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  904482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  904485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904511 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  904514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904533 */     GIR_RootConstrainSelectedInstOperands,
     /*  904534 */     // GIR_Coverage, 61875,
     /*  904534 */     GIR_EraseRootFromParent_Done,
     /*  904535 */   // Label 13778: @904535
     /*  904535 */   GIM_Try, /*On fail goto*//*Label 13779*/ GIMT_Encode4(904610), // Rule ID 61878 //
     /*  904540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  904551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  904554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  904557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  904560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904586 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  904589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904608 */     GIR_RootConstrainSelectedInstOperands,
     /*  904609 */     // GIR_Coverage, 61878,
     /*  904609 */     GIR_EraseRootFromParent_Done,
     /*  904610 */   // Label 13779: @904610
     /*  904610 */   GIM_Try, /*On fail goto*//*Label 13780*/ GIMT_Encode4(904685), // Rule ID 61879 //
     /*  904615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  904626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  904629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  904632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  904635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904661 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  904664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904683 */     GIR_RootConstrainSelectedInstOperands,
     /*  904684 */     // GIR_Coverage, 61879,
     /*  904684 */     GIR_EraseRootFromParent_Done,
     /*  904685 */   // Label 13780: @904685
     /*  904685 */   GIM_Try, /*On fail goto*//*Label 13781*/ GIMT_Encode4(904760), // Rule ID 61882 //
     /*  904690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  904710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  904739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904758 */     GIR_RootConstrainSelectedInstOperands,
     /*  904759 */     // GIR_Coverage, 61882,
     /*  904759 */     GIR_EraseRootFromParent_Done,
     /*  904760 */   // Label 13781: @904760
     /*  904760 */   GIM_Try, /*On fail goto*//*Label 13782*/ GIMT_Encode4(904835), // Rule ID 61883 //
     /*  904765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  904785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904811 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  904814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904833 */     GIR_RootConstrainSelectedInstOperands,
     /*  904834 */     // GIR_Coverage, 61883,
     /*  904834 */     GIR_EraseRootFromParent_Done,
     /*  904835 */   // Label 13782: @904835
     /*  904835 */   GIM_Try, /*On fail goto*//*Label 13783*/ GIMT_Encode4(904910), // Rule ID 61886 //
     /*  904840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  904860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904886 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  904889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904908 */     GIR_RootConstrainSelectedInstOperands,
     /*  904909 */     // GIR_Coverage, 61886,
     /*  904909 */     GIR_EraseRootFromParent_Done,
     /*  904910 */   // Label 13783: @904910
     /*  904910 */   GIM_Try, /*On fail goto*//*Label 13784*/ GIMT_Encode4(904985), // Rule ID 61887 //
     /*  904915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  904935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904961 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  904964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904983 */     GIR_RootConstrainSelectedInstOperands,
     /*  904984 */     // GIR_Coverage, 61887,
     /*  904984 */     GIR_EraseRootFromParent_Done,
     /*  904985 */   // Label 13784: @904985
     /*  904985 */   GIM_Try, /*On fail goto*//*Label 13785*/ GIMT_Encode4(905060), // Rule ID 61890 //
     /*  904990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  905001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  905010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905036 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  905039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905058 */     GIR_RootConstrainSelectedInstOperands,
     /*  905059 */     // GIR_Coverage, 61890,
     /*  905059 */     GIR_EraseRootFromParent_Done,
     /*  905060 */   // Label 13785: @905060
     /*  905060 */   GIM_Try, /*On fail goto*//*Label 13786*/ GIMT_Encode4(905135), // Rule ID 61891 //
     /*  905065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  905076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  905085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905111 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  905114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905133 */     GIR_RootConstrainSelectedInstOperands,
     /*  905134 */     // GIR_Coverage, 61891,
     /*  905134 */     GIR_EraseRootFromParent_Done,
     /*  905135 */   // Label 13786: @905135
     /*  905135 */   GIM_Try, /*On fail goto*//*Label 13787*/ GIMT_Encode4(905210), // Rule ID 61894 //
     /*  905140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  905151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  905154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  905157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  905160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905186 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  905186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  905189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905208 */     GIR_RootConstrainSelectedInstOperands,
     /*  905209 */     // GIR_Coverage, 61894,
     /*  905209 */     GIR_EraseRootFromParent_Done,
     /*  905210 */   // Label 13787: @905210
     /*  905210 */   GIM_Try, /*On fail goto*//*Label 13788*/ GIMT_Encode4(905285), // Rule ID 61895 //
     /*  905215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  905226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  905229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  905232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  905235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905261 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  905264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905283 */     GIR_RootConstrainSelectedInstOperands,
     /*  905284 */     // GIR_Coverage, 61895,
     /*  905284 */     GIR_EraseRootFromParent_Done,
     /*  905285 */   // Label 13788: @905285
     /*  905285 */   GIM_Try, /*On fail goto*//*Label 13789*/ GIMT_Encode4(905360), // Rule ID 61898 //
     /*  905290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  905301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  905304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  905307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  905310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905336 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  905336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  905339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905358 */     GIR_RootConstrainSelectedInstOperands,
     /*  905359 */     // GIR_Coverage, 61898,
     /*  905359 */     GIR_EraseRootFromParent_Done,
     /*  905360 */   // Label 13789: @905360
     /*  905360 */   GIM_Try, /*On fail goto*//*Label 13790*/ GIMT_Encode4(905435), // Rule ID 61899 //
     /*  905365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  905376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  905379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  905382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  905385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905411 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  905414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905433 */     GIR_RootConstrainSelectedInstOperands,
     /*  905434 */     // GIR_Coverage, 61899,
     /*  905434 */     GIR_EraseRootFromParent_Done,
     /*  905435 */   // Label 13790: @905435
     /*  905435 */   GIM_Try, /*On fail goto*//*Label 13791*/ GIMT_Encode4(905510), // Rule ID 61902 //
     /*  905440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  905451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  905454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  905457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  905460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905486 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  905486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  905489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905508 */     GIR_RootConstrainSelectedInstOperands,
     /*  905509 */     // GIR_Coverage, 61902,
     /*  905509 */     GIR_EraseRootFromParent_Done,
     /*  905510 */   // Label 13791: @905510
     /*  905510 */   GIM_Try, /*On fail goto*//*Label 13792*/ GIMT_Encode4(905585), // Rule ID 61903 //
     /*  905515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  905526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  905529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  905532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  905535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905561 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  905564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905583 */     GIR_RootConstrainSelectedInstOperands,
     /*  905584 */     // GIR_Coverage, 61903,
     /*  905584 */     GIR_EraseRootFromParent_Done,
     /*  905585 */   // Label 13792: @905585
     /*  905585 */   GIM_Try, /*On fail goto*//*Label 13793*/ GIMT_Encode4(905660), // Rule ID 61906 //
     /*  905590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  905601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  905604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  905607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  905610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905636 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  905636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  905639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905658 */     GIR_RootConstrainSelectedInstOperands,
     /*  905659 */     // GIR_Coverage, 61906,
     /*  905659 */     GIR_EraseRootFromParent_Done,
     /*  905660 */   // Label 13793: @905660
     /*  905660 */   GIM_Try, /*On fail goto*//*Label 13794*/ GIMT_Encode4(905735), // Rule ID 61907 //
     /*  905665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  905676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  905679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  905682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905711 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  905711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  905714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905733 */     GIR_RootConstrainSelectedInstOperands,
     /*  905734 */     // GIR_Coverage, 61907,
     /*  905734 */     GIR_EraseRootFromParent_Done,
     /*  905735 */   // Label 13794: @905735
     /*  905735 */   GIM_Try, /*On fail goto*//*Label 13795*/ GIMT_Encode4(905810), // Rule ID 61910 //
     /*  905740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  905751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  905754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  905757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  905760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905786 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  905786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  905789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905808 */     GIR_RootConstrainSelectedInstOperands,
     /*  905809 */     // GIR_Coverage, 61910,
     /*  905809 */     GIR_EraseRootFromParent_Done,
     /*  905810 */   // Label 13795: @905810
     /*  905810 */   GIM_Try, /*On fail goto*//*Label 13796*/ GIMT_Encode4(905885), // Rule ID 61911 //
     /*  905815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  905826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  905829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  905832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905861 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  905861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  905864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905883 */     GIR_RootConstrainSelectedInstOperands,
     /*  905884 */     // GIR_Coverage, 61911,
     /*  905884 */     GIR_EraseRootFromParent_Done,
     /*  905885 */   // Label 13796: @905885
     /*  905885 */   GIM_Try, /*On fail goto*//*Label 13797*/ GIMT_Encode4(905960), // Rule ID 61914 //
     /*  905890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  905901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  905904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  905907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  905910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905936 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  905936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  905939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905958 */     GIR_RootConstrainSelectedInstOperands,
     /*  905959 */     // GIR_Coverage, 61914,
     /*  905959 */     GIR_EraseRootFromParent_Done,
     /*  905960 */   // Label 13797: @905960
     /*  905960 */   GIM_Try, /*On fail goto*//*Label 13798*/ GIMT_Encode4(906035), // Rule ID 61915 //
     /*  905965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  905976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  905979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  905982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906011 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  906011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  906014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906033 */     GIR_RootConstrainSelectedInstOperands,
     /*  906034 */     // GIR_Coverage, 61915,
     /*  906034 */     GIR_EraseRootFromParent_Done,
     /*  906035 */   // Label 13798: @906035
     /*  906035 */   GIM_Try, /*On fail goto*//*Label 13799*/ GIMT_Encode4(906110), // Rule ID 61918 //
     /*  906040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  906051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  906054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  906057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906086 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  906086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  906089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906108 */     GIR_RootConstrainSelectedInstOperands,
     /*  906109 */     // GIR_Coverage, 61918,
     /*  906109 */     GIR_EraseRootFromParent_Done,
     /*  906110 */   // Label 13799: @906110
     /*  906110 */   GIM_Try, /*On fail goto*//*Label 13800*/ GIMT_Encode4(906185), // Rule ID 61919 //
     /*  906115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  906118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  906126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  906129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  906132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906161 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  906161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  906164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906183 */     GIR_RootConstrainSelectedInstOperands,
     /*  906184 */     // GIR_Coverage, 61919,
     /*  906184 */     GIR_EraseRootFromParent_Done,
     /*  906185 */   // Label 13800: @906185
     /*  906185 */   GIM_Try, /*On fail goto*//*Label 13801*/ GIMT_Encode4(906260), // Rule ID 61922 //
     /*  906190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  906201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  906204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  906207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906236 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  906236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  906239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906258 */     GIR_RootConstrainSelectedInstOperands,
     /*  906259 */     // GIR_Coverage, 61922,
     /*  906259 */     GIR_EraseRootFromParent_Done,
     /*  906260 */   // Label 13801: @906260
     /*  906260 */   GIM_Try, /*On fail goto*//*Label 13802*/ GIMT_Encode4(906335), // Rule ID 61923 //
     /*  906265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  906268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  906276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  906279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  906282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906311 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  906311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  906314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906333 */     GIR_RootConstrainSelectedInstOperands,
     /*  906334 */     // GIR_Coverage, 61923,
     /*  906334 */     GIR_EraseRootFromParent_Done,
     /*  906335 */   // Label 13802: @906335
     /*  906335 */   GIM_Try, /*On fail goto*//*Label 13803*/ GIMT_Encode4(906410), // Rule ID 61926 //
     /*  906340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  906351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  906354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  906357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906386 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  906386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  906389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906408 */     GIR_RootConstrainSelectedInstOperands,
     /*  906409 */     // GIR_Coverage, 61926,
     /*  906409 */     GIR_EraseRootFromParent_Done,
     /*  906410 */   // Label 13803: @906410
     /*  906410 */   GIM_Try, /*On fail goto*//*Label 13804*/ GIMT_Encode4(906485), // Rule ID 61927 //
     /*  906415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  906418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  906426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  906429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  906432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906461 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  906461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  906464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906483 */     GIR_RootConstrainSelectedInstOperands,
     /*  906484 */     // GIR_Coverage, 61927,
     /*  906484 */     GIR_EraseRootFromParent_Done,
     /*  906485 */   // Label 13804: @906485
     /*  906485 */   GIM_Try, /*On fail goto*//*Label 13805*/ GIMT_Encode4(906560), // Rule ID 61930 //
     /*  906490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  906501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  906504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  906507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906536 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  906536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906558 */     GIR_RootConstrainSelectedInstOperands,
     /*  906559 */     // GIR_Coverage, 61930,
     /*  906559 */     GIR_EraseRootFromParent_Done,
     /*  906560 */   // Label 13805: @906560
     /*  906560 */   GIM_Try, /*On fail goto*//*Label 13806*/ GIMT_Encode4(906635), // Rule ID 61931 //
     /*  906565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  906568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  906576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  906579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  906582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906611 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  906611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906633 */     GIR_RootConstrainSelectedInstOperands,
     /*  906634 */     // GIR_Coverage, 61931,
     /*  906634 */     GIR_EraseRootFromParent_Done,
     /*  906635 */   // Label 13806: @906635
     /*  906635 */   GIM_Try, /*On fail goto*//*Label 13807*/ GIMT_Encode4(906710), // Rule ID 61934 //
     /*  906640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  906651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  906654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  906657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906686 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  906686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906708 */     GIR_RootConstrainSelectedInstOperands,
     /*  906709 */     // GIR_Coverage, 61934,
     /*  906709 */     GIR_EraseRootFromParent_Done,
     /*  906710 */   // Label 13807: @906710
     /*  906710 */   GIM_Try, /*On fail goto*//*Label 13808*/ GIMT_Encode4(906785), // Rule ID 61935 //
     /*  906715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  906718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  906726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  906729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  906732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906761 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  906761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906783 */     GIR_RootConstrainSelectedInstOperands,
     /*  906784 */     // GIR_Coverage, 61935,
     /*  906784 */     GIR_EraseRootFromParent_Done,
     /*  906785 */   // Label 13808: @906785
     /*  906785 */   GIM_Try, /*On fail goto*//*Label 13809*/ GIMT_Encode4(906860), // Rule ID 61938 //
     /*  906790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  906801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  906804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  906807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906836 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  906836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906858 */     GIR_RootConstrainSelectedInstOperands,
     /*  906859 */     // GIR_Coverage, 61938,
     /*  906859 */     GIR_EraseRootFromParent_Done,
     /*  906860 */   // Label 13809: @906860
     /*  906860 */   GIM_Try, /*On fail goto*//*Label 13810*/ GIMT_Encode4(906935), // Rule ID 61939 //
     /*  906865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  906868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  906876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  906879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  906882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906911 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  906911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906933 */     GIR_RootConstrainSelectedInstOperands,
     /*  906934 */     // GIR_Coverage, 61939,
     /*  906934 */     GIR_EraseRootFromParent_Done,
     /*  906935 */   // Label 13810: @906935
     /*  906935 */   GIM_Try, /*On fail goto*//*Label 13811*/ GIMT_Encode4(907010), // Rule ID 61942 //
     /*  906940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  906951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  906954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  906957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906986 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  906986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  907005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907008 */     GIR_RootConstrainSelectedInstOperands,
     /*  907009 */     // GIR_Coverage, 61942,
     /*  907009 */     GIR_EraseRootFromParent_Done,
     /*  907010 */   // Label 13811: @907010
     /*  907010 */   GIM_Try, /*On fail goto*//*Label 13812*/ GIMT_Encode4(907085), // Rule ID 61943 //
     /*  907015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  907026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  907029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  907032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907061 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  907061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  907064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  907080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907083 */     GIR_RootConstrainSelectedInstOperands,
     /*  907084 */     // GIR_Coverage, 61943,
     /*  907084 */     GIR_EraseRootFromParent_Done,
     /*  907085 */   // Label 13812: @907085
     /*  907085 */   GIM_Try, /*On fail goto*//*Label 13813*/ GIMT_Encode4(907160), // Rule ID 61946 //
     /*  907090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  907101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  907104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  907107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  907110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907136 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  907136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  907139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907158 */     GIR_RootConstrainSelectedInstOperands,
     /*  907159 */     // GIR_Coverage, 61946,
     /*  907159 */     GIR_EraseRootFromParent_Done,
     /*  907160 */   // Label 13813: @907160
     /*  907160 */   GIM_Try, /*On fail goto*//*Label 13814*/ GIMT_Encode4(907235), // Rule ID 61947 //
     /*  907165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  907176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  907179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  907182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907211 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  907211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  907214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907233 */     GIR_RootConstrainSelectedInstOperands,
     /*  907234 */     // GIR_Coverage, 61947,
     /*  907234 */     GIR_EraseRootFromParent_Done,
     /*  907235 */   // Label 13814: @907235
     /*  907235 */   GIM_Try, /*On fail goto*//*Label 13815*/ GIMT_Encode4(907310), // Rule ID 61950 //
     /*  907240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  907251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  907254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  907257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  907260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907286 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  907286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  907289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907308 */     GIR_RootConstrainSelectedInstOperands,
     /*  907309 */     // GIR_Coverage, 61950,
     /*  907309 */     GIR_EraseRootFromParent_Done,
     /*  907310 */   // Label 13815: @907310
     /*  907310 */   GIM_Try, /*On fail goto*//*Label 13816*/ GIMT_Encode4(907385), // Rule ID 61951 //
     /*  907315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  907326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  907329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  907332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907361 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  907361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  907364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907383 */     GIR_RootConstrainSelectedInstOperands,
     /*  907384 */     // GIR_Coverage, 61951,
     /*  907384 */     GIR_EraseRootFromParent_Done,
     /*  907385 */   // Label 13816: @907385
     /*  907385 */   GIM_Try, /*On fail goto*//*Label 13817*/ GIMT_Encode4(907460), // Rule ID 61954 //
     /*  907390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  907401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  907404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  907407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  907410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907436 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  907436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  907439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907458 */     GIR_RootConstrainSelectedInstOperands,
     /*  907459 */     // GIR_Coverage, 61954,
     /*  907459 */     GIR_EraseRootFromParent_Done,
     /*  907460 */   // Label 13817: @907460
     /*  907460 */   GIM_Try, /*On fail goto*//*Label 13818*/ GIMT_Encode4(907535), // Rule ID 61955 //
     /*  907465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  907476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  907479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  907482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907511 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  907511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  907514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907533 */     GIR_RootConstrainSelectedInstOperands,
     /*  907534 */     // GIR_Coverage, 61955,
     /*  907534 */     GIR_EraseRootFromParent_Done,
     /*  907535 */   // Label 13818: @907535
     /*  907535 */   GIM_Try, /*On fail goto*//*Label 13819*/ GIMT_Encode4(907610), // Rule ID 61958 //
     /*  907540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  907551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  907554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  907557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  907560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907586 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  907586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  907589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907608 */     GIR_RootConstrainSelectedInstOperands,
     /*  907609 */     // GIR_Coverage, 61958,
     /*  907609 */     GIR_EraseRootFromParent_Done,
     /*  907610 */   // Label 13819: @907610
     /*  907610 */   GIM_Try, /*On fail goto*//*Label 13820*/ GIMT_Encode4(907685), // Rule ID 61959 //
     /*  907615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  907626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  907629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  907632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907661 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  907661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  907664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907683 */     GIR_RootConstrainSelectedInstOperands,
     /*  907684 */     // GIR_Coverage, 61959,
     /*  907684 */     GIR_EraseRootFromParent_Done,
     /*  907685 */   // Label 13820: @907685
     /*  907685 */   GIM_Try, /*On fail goto*//*Label 13821*/ GIMT_Encode4(907760), // Rule ID 61962 //
     /*  907690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  907701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  907704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  907707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  907710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907736 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  907736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  907739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907758 */     GIR_RootConstrainSelectedInstOperands,
     /*  907759 */     // GIR_Coverage, 61962,
     /*  907759 */     GIR_EraseRootFromParent_Done,
     /*  907760 */   // Label 13821: @907760
     /*  907760 */   GIM_Try, /*On fail goto*//*Label 13822*/ GIMT_Encode4(907835), // Rule ID 61963 //
     /*  907765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  907776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  907779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  907782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907811 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  907811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  907814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907833 */     GIR_RootConstrainSelectedInstOperands,
     /*  907834 */     // GIR_Coverage, 61963,
     /*  907834 */     GIR_EraseRootFromParent_Done,
     /*  907835 */   // Label 13822: @907835
     /*  907835 */   GIM_Try, /*On fail goto*//*Label 13823*/ GIMT_Encode4(907910), // Rule ID 61966 //
     /*  907840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  907851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  907854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  907857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  907860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907886 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  907886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  907889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907908 */     GIR_RootConstrainSelectedInstOperands,
     /*  907909 */     // GIR_Coverage, 61966,
     /*  907909 */     GIR_EraseRootFromParent_Done,
     /*  907910 */   // Label 13823: @907910
     /*  907910 */   GIM_Try, /*On fail goto*//*Label 13824*/ GIMT_Encode4(907985), // Rule ID 61967 //
     /*  907915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  907926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  907929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  907932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907961 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  907961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  907964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907983 */     GIR_RootConstrainSelectedInstOperands,
     /*  907984 */     // GIR_Coverage, 61967,
     /*  907984 */     GIR_EraseRootFromParent_Done,
     /*  907985 */   // Label 13824: @907985
     /*  907985 */   GIM_Try, /*On fail goto*//*Label 13825*/ GIMT_Encode4(908060), // Rule ID 61970 //
     /*  907990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  908001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  908004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  908007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  908010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908036 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  908036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  908039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908058 */     GIR_RootConstrainSelectedInstOperands,
     /*  908059 */     // GIR_Coverage, 61970,
     /*  908059 */     GIR_EraseRootFromParent_Done,
     /*  908060 */   // Label 13825: @908060
     /*  908060 */   GIM_Try, /*On fail goto*//*Label 13826*/ GIMT_Encode4(908135), // Rule ID 61971 //
     /*  908065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  908068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  908076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  908079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  908082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  908085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908111 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  908111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  908114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908133 */     GIR_RootConstrainSelectedInstOperands,
     /*  908134 */     // GIR_Coverage, 61971,
     /*  908134 */     GIR_EraseRootFromParent_Done,
     /*  908135 */   // Label 13826: @908135
     /*  908135 */   GIM_Try, /*On fail goto*//*Label 13827*/ GIMT_Encode4(908210), // Rule ID 61974 //
     /*  908140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  908143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  908151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  908154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  908157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  908160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908186 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  908186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  908189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908208 */     GIR_RootConstrainSelectedInstOperands,
     /*  908209 */     // GIR_Coverage, 61974,
     /*  908209 */     GIR_EraseRootFromParent_Done,
     /*  908210 */   // Label 13827: @908210
     /*  908210 */   GIM_Try, /*On fail goto*//*Label 13828*/ GIMT_Encode4(908285), // Rule ID 61975 //
     /*  908215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  908218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  908226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  908229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  908232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  908235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908261 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  908261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  908264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908283 */     GIR_RootConstrainSelectedInstOperands,
     /*  908284 */     // GIR_Coverage, 61975,
     /*  908284 */     GIR_EraseRootFromParent_Done,
     /*  908285 */   // Label 13828: @908285
     /*  908285 */   GIM_Try, /*On fail goto*//*Label 13829*/ GIMT_Encode4(908360), // Rule ID 61978 //
     /*  908290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  908293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  908301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  908304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  908307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  908310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908336 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  908336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  908339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908358 */     GIR_RootConstrainSelectedInstOperands,
     /*  908359 */     // GIR_Coverage, 61978,
     /*  908359 */     GIR_EraseRootFromParent_Done,
     /*  908360 */   // Label 13829: @908360
     /*  908360 */   GIM_Try, /*On fail goto*//*Label 13830*/ GIMT_Encode4(908435), // Rule ID 61979 //
     /*  908365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  908368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  908376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  908379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  908382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  908385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908411 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  908411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  908414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908433 */     GIR_RootConstrainSelectedInstOperands,
     /*  908434 */     // GIR_Coverage, 61979,
     /*  908434 */     GIR_EraseRootFromParent_Done,
     /*  908435 */   // Label 13830: @908435
     /*  908435 */   GIM_Try, /*On fail goto*//*Label 13831*/ GIMT_Encode4(908510), // Rule ID 61982 //
     /*  908440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  908443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  908451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  908454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  908457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  908460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  908486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  908489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908508 */     GIR_RootConstrainSelectedInstOperands,
     /*  908509 */     // GIR_Coverage, 61982,
     /*  908509 */     GIR_EraseRootFromParent_Done,
     /*  908510 */   // Label 13831: @908510
     /*  908510 */   GIM_Try, /*On fail goto*//*Label 13832*/ GIMT_Encode4(908585), // Rule ID 61983 //
     /*  908515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  908518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  908526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  908529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  908532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  908535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908561 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11504:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  908561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  908564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908583 */     GIR_RootConstrainSelectedInstOperands,
     /*  908584 */     // GIR_Coverage, 61983,
     /*  908584 */     GIR_EraseRootFromParent_Done,
     /*  908585 */   // Label 13832: @908585
     /*  908585 */   GIM_Try, /*On fail goto*//*Label 13833*/ GIMT_Encode4(908660), // Rule ID 61986 //
     /*  908590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  908593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  908601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  908604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  908607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  908610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908636 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  908636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  908639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908658 */     GIR_RootConstrainSelectedInstOperands,
     /*  908659 */     // GIR_Coverage, 61986,
     /*  908659 */     GIR_EraseRootFromParent_Done,
     /*  908660 */   // Label 13833: @908660
     /*  908660 */   GIM_Try, /*On fail goto*//*Label 13834*/ GIMT_Encode4(908735), // Rule ID 61987 //
     /*  908665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  908668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  908676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  908679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  908682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  908685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908711 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11504:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  908711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  908714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908733 */     GIR_RootConstrainSelectedInstOperands,
     /*  908734 */     // GIR_Coverage, 61987,
     /*  908734 */     GIR_EraseRootFromParent_Done,
     /*  908735 */   // Label 13834: @908735
     /*  908735 */   GIM_Try, /*On fail goto*//*Label 13835*/ GIMT_Encode4(908810), // Rule ID 61990 //
     /*  908740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  908743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  908751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  908754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  908757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  908760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  908786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  908789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908808 */     GIR_RootConstrainSelectedInstOperands,
     /*  908809 */     // GIR_Coverage, 61990,
     /*  908809 */     GIR_EraseRootFromParent_Done,
     /*  908810 */   // Label 13835: @908810
     /*  908810 */   GIM_Try, /*On fail goto*//*Label 13836*/ GIMT_Encode4(908885), // Rule ID 61991 //
     /*  908815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  908818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  908826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  908829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  908832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  908835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908861 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11504:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  908861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  908864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908883 */     GIR_RootConstrainSelectedInstOperands,
     /*  908884 */     // GIR_Coverage, 61991,
     /*  908884 */     GIR_EraseRootFromParent_Done,
     /*  908885 */   // Label 13836: @908885
     /*  908885 */   GIM_Try, /*On fail goto*//*Label 13837*/ GIMT_Encode4(908960), // Rule ID 62434 //
     /*  908890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  908893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  908898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  908901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  908904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  908907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  908910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908936 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  908936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  908939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908958 */     GIR_RootConstrainSelectedInstOperands,
     /*  908959 */     // GIR_Coverage, 62434,
     /*  908959 */     GIR_EraseRootFromParent_Done,
     /*  908960 */   // Label 13837: @908960
     /*  908960 */   GIM_Try, /*On fail goto*//*Label 13838*/ GIMT_Encode4(909035), // Rule ID 62435 //
     /*  908965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  908968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  908973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  908976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  908979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  908982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  908985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909011 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  909011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  909014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909033 */     GIR_RootConstrainSelectedInstOperands,
     /*  909034 */     // GIR_Coverage, 62435,
     /*  909034 */     GIR_EraseRootFromParent_Done,
     /*  909035 */   // Label 13838: @909035
     /*  909035 */   GIM_Try, /*On fail goto*//*Label 13839*/ GIMT_Encode4(909110), // Rule ID 62436 //
     /*  909040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  909043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  909048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  909051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  909054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  909057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  909060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  909063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909086 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  909086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  909089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909108 */     GIR_RootConstrainSelectedInstOperands,
     /*  909109 */     // GIR_Coverage, 62436,
     /*  909109 */     GIR_EraseRootFromParent_Done,
     /*  909110 */   // Label 13839: @909110
     /*  909110 */   GIM_Try, /*On fail goto*//*Label 13840*/ GIMT_Encode4(909185), // Rule ID 62437 //
     /*  909115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  909118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  909123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  909126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  909129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  909132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  909135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  909138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  909161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  909164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909183 */     GIR_RootConstrainSelectedInstOperands,
     /*  909184 */     // GIR_Coverage, 62437,
     /*  909184 */     GIR_EraseRootFromParent_Done,
     /*  909185 */   // Label 13840: @909185
     /*  909185 */   GIM_Try, /*On fail goto*//*Label 13841*/ GIMT_Encode4(909260), // Rule ID 62438 //
     /*  909190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  909193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  909198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  909201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  909204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  909207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  909210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  909213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909236 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  909236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  909239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909258 */     GIR_RootConstrainSelectedInstOperands,
     /*  909259 */     // GIR_Coverage, 62438,
     /*  909259 */     GIR_EraseRootFromParent_Done,
     /*  909260 */   // Label 13841: @909260
     /*  909260 */   GIM_Try, /*On fail goto*//*Label 13842*/ GIMT_Encode4(909335), // Rule ID 62439 //
     /*  909265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  909268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  909273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  909276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  909279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  909282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  909285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  909288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909311 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  909311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  909314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909333 */     GIR_RootConstrainSelectedInstOperands,
     /*  909334 */     // GIR_Coverage, 62439,
     /*  909334 */     GIR_EraseRootFromParent_Done,
     /*  909335 */   // Label 13842: @909335
     /*  909335 */   GIM_Try, /*On fail goto*//*Label 13843*/ GIMT_Encode4(909410), // Rule ID 62440 //
     /*  909340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  909343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  909348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  909354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  909357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  909360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  909363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909386 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  909386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  909389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909408 */     GIR_RootConstrainSelectedInstOperands,
     /*  909409 */     // GIR_Coverage, 62440,
     /*  909409 */     GIR_EraseRootFromParent_Done,
     /*  909410 */   // Label 13843: @909410
     /*  909410 */   GIM_Try, /*On fail goto*//*Label 13844*/ GIMT_Encode4(909485), // Rule ID 62441 //
     /*  909415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  909418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  909423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  909429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  909432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  909435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  909438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909461 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  909461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  909464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909483 */     GIR_RootConstrainSelectedInstOperands,
     /*  909484 */     // GIR_Coverage, 62441,
     /*  909484 */     GIR_EraseRootFromParent_Done,
     /*  909485 */   // Label 13844: @909485
     /*  909485 */   GIM_Try, /*On fail goto*//*Label 13845*/ GIMT_Encode4(909549), // Rule ID 64510 //
     /*  909490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuN),
     /*  909498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909526 */     // MIs[0] imm5
     /*  909526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909529 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909534 */     // (intrinsic_wo_chain:{ *:[i32] } 10974:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACUN),
     /*  909537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909545 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909547 */     GIR_RootConstrainSelectedInstOperands,
     /*  909548 */     // GIR_Coverage, 64510,
     /*  909548 */     GIR_EraseRootFromParent_Done,
     /*  909549 */   // Label 13845: @909549
     /*  909549 */   GIM_Try, /*On fail goto*//*Label 13846*/ GIMT_Encode4(909613), // Rule ID 64511 //
     /*  909554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuN),
     /*  909562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909590 */     // MIs[0] imm5
     /*  909590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909598 */     // (intrinsic_wo_chain:{ *:[i32] } 10970:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHUN),
     /*  909601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909609 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909611 */     GIR_RootConstrainSelectedInstOperands,
     /*  909612 */     // GIR_Coverage, 64511,
     /*  909612 */     GIR_EraseRootFromParent_Done,
     /*  909613 */   // Label 13846: @909613
     /*  909613 */   GIM_Try, /*On fail goto*//*Label 13847*/ GIMT_Encode4(909677), // Rule ID 64512 //
     /*  909618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsN),
     /*  909626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909654 */     // MIs[0] imm5
     /*  909654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909657 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909662 */     // (intrinsic_wo_chain:{ *:[i32] } 10972:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSN),
     /*  909665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909673 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909675 */     GIR_RootConstrainSelectedInstOperands,
     /*  909676 */     // GIR_Coverage, 64512,
     /*  909676 */     GIR_EraseRootFromParent_Done,
     /*  909677 */   // Label 13847: @909677
     /*  909677 */   GIM_Try, /*On fail goto*//*Label 13848*/ GIMT_Encode4(909741), // Rule ID 64513 //
     /*  909682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsN),
     /*  909690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909718 */     // MIs[0] imm5
     /*  909718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909726 */     // (intrinsic_wo_chain:{ *:[i32] } 10968:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSN),
     /*  909729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909737 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909739 */     GIR_RootConstrainSelectedInstOperands,
     /*  909740 */     // GIR_Coverage, 64513,
     /*  909740 */     GIR_EraseRootFromParent_Done,
     /*  909741 */   // Label 13848: @909741
     /*  909741 */   GIM_Try, /*On fail goto*//*Label 13849*/ GIMT_Encode4(909805), // Rule ID 64514 //
     /*  909746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuRN),
     /*  909754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909782 */     // MIs[0] imm5
     /*  909782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909790 */     // (intrinsic_wo_chain:{ *:[i32] } 10975:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACURN),
     /*  909793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909801 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909803 */     GIR_RootConstrainSelectedInstOperands,
     /*  909804 */     // GIR_Coverage, 64514,
     /*  909804 */     GIR_EraseRootFromParent_Done,
     /*  909805 */   // Label 13849: @909805
     /*  909805 */   GIM_Try, /*On fail goto*//*Label 13850*/ GIMT_Encode4(909869), // Rule ID 64515 //
     /*  909810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuRN),
     /*  909818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909846 */     // MIs[0] imm5
     /*  909846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909854 */     // (intrinsic_wo_chain:{ *:[i32] } 10971:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHURN),
     /*  909857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909865 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909867 */     GIR_RootConstrainSelectedInstOperands,
     /*  909868 */     // GIR_Coverage, 64515,
     /*  909868 */     GIR_EraseRootFromParent_Done,
     /*  909869 */   // Label 13850: @909869
     /*  909869 */   GIM_Try, /*On fail goto*//*Label 13851*/ GIMT_Encode4(909933), // Rule ID 64516 //
     /*  909874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsRN),
     /*  909882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909910 */     // MIs[0] imm5
     /*  909910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909913 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909918 */     // (intrinsic_wo_chain:{ *:[i32] } 10973:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSRN),
     /*  909921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909929 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909931 */     GIR_RootConstrainSelectedInstOperands,
     /*  909932 */     // GIR_Coverage, 64516,
     /*  909932 */     GIR_EraseRootFromParent_Done,
     /*  909933 */   // Label 13851: @909933
     /*  909933 */   GIM_Try, /*On fail goto*//*Label 13852*/ GIMT_Encode4(909997), // Rule ID 64517 //
     /*  909938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsRN),
     /*  909946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909974 */     // MIs[0] imm5
     /*  909974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909982 */     // (intrinsic_wo_chain:{ *:[i32] } 10969:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSRN),
     /*  909985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909993 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909995 */     GIR_RootConstrainSelectedInstOperands,
     /*  909996 */     // GIR_Coverage, 64517,
     /*  909996 */     GIR_EraseRootFromParent_Done,
     /*  909997 */   // Label 13852: @909997
     /*  909997 */   GIM_Reject,
     /*  909998 */ // Label 7006: @909998
     /*  909998 */ GIM_Try, /*On fail goto*//*Label 13853*/ GIMT_Encode4(1405549),
     /*  910003 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  910006 */   GIM_Try, /*On fail goto*//*Label 13854*/ GIMT_Encode4(910089), // Rule ID 62849 //
     /*  910011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  910022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  910025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  910028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910035 */     // MIs[0] op1
     /*  910035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910051 */     // MIs[0] op4
     /*  910051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910066 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF8),
     /*  910069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910071 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910073 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910075 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910077 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910087 */     GIR_RootConstrainSelectedInstOperands,
     /*  910088 */     // GIR_Coverage, 62849,
     /*  910088 */     GIR_EraseRootFromParent_Done,
     /*  910089 */   // Label 13854: @910089
     /*  910089 */   GIM_Try, /*On fail goto*//*Label 13855*/ GIMT_Encode4(910172), // Rule ID 62850 //
     /*  910094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  910105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  910108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  910111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910118 */     // MIs[0] op1
     /*  910118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910134 */     // MIs[0] op4
     /*  910134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910149 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF8),
     /*  910152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910154 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910156 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910158 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910160 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910170 */     GIR_RootConstrainSelectedInstOperands,
     /*  910171 */     // GIR_Coverage, 62850,
     /*  910171 */     GIR_EraseRootFromParent_Done,
     /*  910172 */   // Label 13855: @910172
     /*  910172 */   GIM_Try, /*On fail goto*//*Label 13856*/ GIMT_Encode4(910255), // Rule ID 62893 //
     /*  910177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  910188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  910191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910201 */     // MIs[0] op1
     /*  910201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910217 */     // MIs[0] op4
     /*  910217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910232 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  910235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910237 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910239 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910241 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910243 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910253 */     GIR_RootConstrainSelectedInstOperands,
     /*  910254 */     // GIR_Coverage, 62893,
     /*  910254 */     GIR_EraseRootFromParent_Done,
     /*  910255 */   // Label 13856: @910255
     /*  910255 */   GIM_Try, /*On fail goto*//*Label 13857*/ GIMT_Encode4(910338), // Rule ID 62894 //
     /*  910260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  910271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  910274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910284 */     // MIs[0] op1
     /*  910284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910300 */     // MIs[0] op4
     /*  910300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910315 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  910318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910320 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910322 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910324 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910326 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910336 */     GIR_RootConstrainSelectedInstOperands,
     /*  910337 */     // GIR_Coverage, 62894,
     /*  910337 */     GIR_EraseRootFromParent_Done,
     /*  910338 */   // Label 13857: @910338
     /*  910338 */   GIM_Try, /*On fail goto*//*Label 13858*/ GIMT_Encode4(910421), // Rule ID 62937 //
     /*  910343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  910354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  910357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910367 */     // MIs[0] op1
     /*  910367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910383 */     // MIs[0] op4
     /*  910383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910398 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  910401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910403 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910405 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910407 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910409 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910419 */     GIR_RootConstrainSelectedInstOperands,
     /*  910420 */     // GIR_Coverage, 62937,
     /*  910420 */     GIR_EraseRootFromParent_Done,
     /*  910421 */   // Label 13858: @910421
     /*  910421 */   GIM_Try, /*On fail goto*//*Label 13859*/ GIMT_Encode4(910504), // Rule ID 62938 //
     /*  910426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  910437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  910440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910450 */     // MIs[0] op1
     /*  910450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910466 */     // MIs[0] op4
     /*  910466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910469 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910481 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  910484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910486 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910488 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910490 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910492 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910502 */     GIR_RootConstrainSelectedInstOperands,
     /*  910503 */     // GIR_Coverage, 62938,
     /*  910503 */     GIR_EraseRootFromParent_Done,
     /*  910504 */   // Label 13859: @910504
     /*  910504 */   GIM_Try, /*On fail goto*//*Label 13860*/ GIMT_Encode4(910587), // Rule ID 62981 //
     /*  910509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  910520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  910523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  910526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910533 */     // MIs[0] op1
     /*  910533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910549 */     // MIs[0] op4
     /*  910549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910564 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  910564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  910567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910569 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910571 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910573 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910575 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910585 */     GIR_RootConstrainSelectedInstOperands,
     /*  910586 */     // GIR_Coverage, 62981,
     /*  910586 */     GIR_EraseRootFromParent_Done,
     /*  910587 */   // Label 13860: @910587
     /*  910587 */   GIM_Try, /*On fail goto*//*Label 13861*/ GIMT_Encode4(910670), // Rule ID 62982 //
     /*  910592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  910603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  910606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  910609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910616 */     // MIs[0] op1
     /*  910616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910632 */     // MIs[0] op4
     /*  910632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910635 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910647 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  910647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  910650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910652 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910654 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910656 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910658 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910668 */     GIR_RootConstrainSelectedInstOperands,
     /*  910669 */     // GIR_Coverage, 62982,
     /*  910669 */     GIR_EraseRootFromParent_Done,
     /*  910670 */   // Label 13861: @910670
     /*  910670 */   GIM_Try, /*On fail goto*//*Label 13862*/ GIMT_Encode4(910753), // Rule ID 63037 //
     /*  910675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  910686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  910689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  910692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910699 */     // MIs[0] op1
     /*  910699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910715 */     // MIs[0] op4
     /*  910715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910730 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  910730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  910733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910735 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910737 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910739 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910741 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910751 */     GIR_RootConstrainSelectedInstOperands,
     /*  910752 */     // GIR_Coverage, 63037,
     /*  910752 */     GIR_EraseRootFromParent_Done,
     /*  910753 */   // Label 13862: @910753
     /*  910753 */   GIM_Try, /*On fail goto*//*Label 13863*/ GIMT_Encode4(910836), // Rule ID 63038 //
     /*  910758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  910769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  910772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  910775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910782 */     // MIs[0] op1
     /*  910782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910798 */     // MIs[0] op4
     /*  910798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910813 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  910813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  910816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910818 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910820 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910822 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910824 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910834 */     GIR_RootConstrainSelectedInstOperands,
     /*  910835 */     // GIR_Coverage, 63038,
     /*  910835 */     GIR_EraseRootFromParent_Done,
     /*  910836 */   // Label 13863: @910836
     /*  910836 */   GIM_Try, /*On fail goto*//*Label 13864*/ GIMT_Encode4(910919), // Rule ID 63093 //
     /*  910841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  910852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  910855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  910858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910865 */     // MIs[0] op1
     /*  910865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910881 */     // MIs[0] op4
     /*  910881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910884 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910896 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  910896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  910899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910901 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910903 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910905 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910907 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  910917 */     GIR_RootConstrainSelectedInstOperands,
     /*  910918 */     // GIR_Coverage, 63093,
     /*  910918 */     GIR_EraseRootFromParent_Done,
     /*  910919 */   // Label 13864: @910919
     /*  910919 */   GIM_Try, /*On fail goto*//*Label 13865*/ GIMT_Encode4(911002), // Rule ID 63094 //
     /*  910924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  910935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  910938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  910941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910948 */     // MIs[0] op1
     /*  910948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910964 */     // MIs[0] op4
     /*  910964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910979 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  910979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  910982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910984 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910986 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910988 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910990 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911000 */     GIR_RootConstrainSelectedInstOperands,
     /*  911001 */     // GIR_Coverage, 63094,
     /*  911001 */     GIR_EraseRootFromParent_Done,
     /*  911002 */   // Label 13865: @911002
     /*  911002 */   GIM_Try, /*On fail goto*//*Label 13866*/ GIMT_Encode4(911085), // Rule ID 63149 //
     /*  911007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  911018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  911021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  911024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911031 */     // MIs[0] op1
     /*  911031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911047 */     // MIs[0] op4
     /*  911047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911062 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  911062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911067 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911069 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911071 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911073 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911083 */     GIR_RootConstrainSelectedInstOperands,
     /*  911084 */     // GIR_Coverage, 63149,
     /*  911084 */     GIR_EraseRootFromParent_Done,
     /*  911085 */   // Label 13866: @911085
     /*  911085 */   GIM_Try, /*On fail goto*//*Label 13867*/ GIMT_Encode4(911168), // Rule ID 63150 //
     /*  911090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  911101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  911104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  911107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911114 */     // MIs[0] op1
     /*  911114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911130 */     // MIs[0] op4
     /*  911130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911145 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  911145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911150 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911152 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911154 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911156 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911166 */     GIR_RootConstrainSelectedInstOperands,
     /*  911167 */     // GIR_Coverage, 63150,
     /*  911167 */     GIR_EraseRootFromParent_Done,
     /*  911168 */   // Label 13867: @911168
     /*  911168 */   GIM_Try, /*On fail goto*//*Label 13868*/ GIMT_Encode4(911251), // Rule ID 63193 //
     /*  911173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  911184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  911187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911197 */     // MIs[0] op1
     /*  911197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911200 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911213 */     // MIs[0] op4
     /*  911213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911216 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911228 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911233 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911235 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911237 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911239 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911249 */     GIR_RootConstrainSelectedInstOperands,
     /*  911250 */     // GIR_Coverage, 63193,
     /*  911250 */     GIR_EraseRootFromParent_Done,
     /*  911251 */   // Label 13868: @911251
     /*  911251 */   GIM_Try, /*On fail goto*//*Label 13869*/ GIMT_Encode4(911334), // Rule ID 63194 //
     /*  911256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  911267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  911270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911280 */     // MIs[0] op1
     /*  911280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911296 */     // MIs[0] op4
     /*  911296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911299 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911311 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911316 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911318 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911320 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911322 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911332 */     GIR_RootConstrainSelectedInstOperands,
     /*  911333 */     // GIR_Coverage, 63194,
     /*  911333 */     GIR_EraseRootFromParent_Done,
     /*  911334 */   // Label 13869: @911334
     /*  911334 */   GIM_Try, /*On fail goto*//*Label 13870*/ GIMT_Encode4(911417), // Rule ID 63249 //
     /*  911339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  911356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911363 */     // MIs[0] op1
     /*  911363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911379 */     // MIs[0] op4
     /*  911379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911382 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911394 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  911394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911399 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911401 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911403 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911405 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911415 */     GIR_RootConstrainSelectedInstOperands,
     /*  911416 */     // GIR_Coverage, 63249,
     /*  911416 */     GIR_EraseRootFromParent_Done,
     /*  911417 */   // Label 13870: @911417
     /*  911417 */   GIM_Try, /*On fail goto*//*Label 13871*/ GIMT_Encode4(911500), // Rule ID 63250 //
     /*  911422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  911439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911446 */     // MIs[0] op1
     /*  911446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911462 */     // MIs[0] op4
     /*  911462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911477 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  911477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911482 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911484 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911486 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911488 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911498 */     GIR_RootConstrainSelectedInstOperands,
     /*  911499 */     // GIR_Coverage, 63250,
     /*  911499 */     GIR_EraseRootFromParent_Done,
     /*  911500 */   // Label 13871: @911500
     /*  911500 */   GIM_Try, /*On fail goto*//*Label 13872*/ GIMT_Encode4(911583), // Rule ID 63305 //
     /*  911505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  911516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  911519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  911522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911529 */     // MIs[0] op1
     /*  911529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911545 */     // MIs[0] op4
     /*  911545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911560 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  911560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911565 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911567 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911569 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911571 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  911581 */     GIR_RootConstrainSelectedInstOperands,
     /*  911582 */     // GIR_Coverage, 63305,
     /*  911582 */     GIR_EraseRootFromParent_Done,
     /*  911583 */   // Label 13872: @911583
     /*  911583 */   GIM_Try, /*On fail goto*//*Label 13873*/ GIMT_Encode4(911666), // Rule ID 63306 //
     /*  911588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  911599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  911602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  911605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911612 */     // MIs[0] op1
     /*  911612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911628 */     // MIs[0] op4
     /*  911628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911631 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911643 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  911643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911648 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911650 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911652 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911654 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  911664 */     GIR_RootConstrainSelectedInstOperands,
     /*  911665 */     // GIR_Coverage, 63306,
     /*  911665 */     GIR_EraseRootFromParent_Done,
     /*  911666 */   // Label 13873: @911666
     /*  911666 */   GIM_Try, /*On fail goto*//*Label 13874*/ GIMT_Encode4(911749), // Rule ID 63361 //
     /*  911671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  911682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  911685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  911688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911695 */     // MIs[0] op1
     /*  911695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911711 */     // MIs[0] op4
     /*  911711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911726 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  911726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  911729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911731 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911733 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911735 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911737 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911747 */     GIR_RootConstrainSelectedInstOperands,
     /*  911748 */     // GIR_Coverage, 63361,
     /*  911748 */     GIR_EraseRootFromParent_Done,
     /*  911749 */   // Label 13874: @911749
     /*  911749 */   GIM_Try, /*On fail goto*//*Label 13875*/ GIMT_Encode4(911832), // Rule ID 63362 //
     /*  911754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  911765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  911768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  911771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911778 */     // MIs[0] op1
     /*  911778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911794 */     // MIs[0] op4
     /*  911794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911809 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  911809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  911812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911814 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911816 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911818 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911820 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911830 */     GIR_RootConstrainSelectedInstOperands,
     /*  911831 */     // GIR_Coverage, 63362,
     /*  911831 */     GIR_EraseRootFromParent_Done,
     /*  911832 */   // Label 13875: @911832
     /*  911832 */   GIM_Try, /*On fail goto*//*Label 13876*/ GIMT_Encode4(911915), // Rule ID 63405 //
     /*  911837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  911848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  911851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  911854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911861 */     // MIs[0] op1
     /*  911861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911877 */     // MIs[0] op4
     /*  911877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911892 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  911892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  911895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911897 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911899 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911901 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911903 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911913 */     GIR_RootConstrainSelectedInstOperands,
     /*  911914 */     // GIR_Coverage, 63405,
     /*  911914 */     GIR_EraseRootFromParent_Done,
     /*  911915 */   // Label 13876: @911915
     /*  911915 */   GIM_Try, /*On fail goto*//*Label 13877*/ GIMT_Encode4(911998), // Rule ID 63406 //
     /*  911920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  911931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  911934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  911937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911944 */     // MIs[0] op1
     /*  911944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911960 */     // MIs[0] op4
     /*  911960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911975 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  911975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  911978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911980 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911982 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911984 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911986 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911996 */     GIR_RootConstrainSelectedInstOperands,
     /*  911997 */     // GIR_Coverage, 63406,
     /*  911997 */     GIR_EraseRootFromParent_Done,
     /*  911998 */   // Label 13877: @911998
     /*  911998 */   GIM_Try, /*On fail goto*//*Label 13878*/ GIMT_Encode4(912081), // Rule ID 63449 //
     /*  912003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  912014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  912017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  912020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912027 */     // MIs[0] op1
     /*  912027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912043 */     // MIs[0] op4
     /*  912043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912058 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  912058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  912061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912063 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912065 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912067 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912069 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  912079 */     GIR_RootConstrainSelectedInstOperands,
     /*  912080 */     // GIR_Coverage, 63449,
     /*  912080 */     GIR_EraseRootFromParent_Done,
     /*  912081 */   // Label 13878: @912081
     /*  912081 */   GIM_Try, /*On fail goto*//*Label 13879*/ GIMT_Encode4(912164), // Rule ID 63450 //
     /*  912086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  912097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  912100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  912103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912110 */     // MIs[0] op1
     /*  912110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912126 */     // MIs[0] op4
     /*  912126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912141 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  912141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  912144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912146 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912148 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912150 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912152 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  912162 */     GIR_RootConstrainSelectedInstOperands,
     /*  912163 */     // GIR_Coverage, 63450,
     /*  912163 */     GIR_EraseRootFromParent_Done,
     /*  912164 */   // Label 13879: @912164
     /*  912164 */   GIM_Try, /*On fail goto*//*Label 13880*/ GIMT_Encode4(912247), // Rule ID 63493 //
     /*  912169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  912180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  912183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  912186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912193 */     // MIs[0] op1
     /*  912193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912209 */     // MIs[0] op4
     /*  912209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912212 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  912224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  912227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912229 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912231 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912233 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912235 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912245 */     GIR_RootConstrainSelectedInstOperands,
     /*  912246 */     // GIR_Coverage, 63493,
     /*  912246 */     GIR_EraseRootFromParent_Done,
     /*  912247 */   // Label 13880: @912247
     /*  912247 */   GIM_Try, /*On fail goto*//*Label 13881*/ GIMT_Encode4(912330), // Rule ID 63494 //
     /*  912252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  912263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  912266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  912269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912276 */     // MIs[0] op1
     /*  912276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912292 */     // MIs[0] op4
     /*  912292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912307 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  912307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  912310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912312 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912314 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912316 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912318 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912328 */     GIR_RootConstrainSelectedInstOperands,
     /*  912329 */     // GIR_Coverage, 63494,
     /*  912329 */     GIR_EraseRootFromParent_Done,
     /*  912330 */   // Label 13881: @912330
     /*  912330 */   GIM_Try, /*On fail goto*//*Label 13882*/ GIMT_Encode4(912413), // Rule ID 63549 //
     /*  912335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  912346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  912349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  912352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912359 */     // MIs[0] op1
     /*  912359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912375 */     // MIs[0] op4
     /*  912375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912390 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  912390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  912393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912395 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912397 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912399 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912401 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912411 */     GIR_RootConstrainSelectedInstOperands,
     /*  912412 */     // GIR_Coverage, 63549,
     /*  912412 */     GIR_EraseRootFromParent_Done,
     /*  912413 */   // Label 13882: @912413
     /*  912413 */   GIM_Try, /*On fail goto*//*Label 13883*/ GIMT_Encode4(912496), // Rule ID 63550 //
     /*  912418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  912429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  912432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  912435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912442 */     // MIs[0] op1
     /*  912442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912458 */     // MIs[0] op4
     /*  912458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912473 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  912473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  912476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912478 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912480 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912482 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912484 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912494 */     GIR_RootConstrainSelectedInstOperands,
     /*  912495 */     // GIR_Coverage, 63550,
     /*  912495 */     GIR_EraseRootFromParent_Done,
     /*  912496 */   // Label 13883: @912496
     /*  912496 */   GIM_Try, /*On fail goto*//*Label 13884*/ GIMT_Encode4(912579), // Rule ID 63605 //
     /*  912501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  912512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  912515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  912518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912525 */     // MIs[0] op1
     /*  912525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912541 */     // MIs[0] op4
     /*  912541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912556 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  912556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  912559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912561 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912563 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912565 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912567 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912577 */     GIR_RootConstrainSelectedInstOperands,
     /*  912578 */     // GIR_Coverage, 63605,
     /*  912578 */     GIR_EraseRootFromParent_Done,
     /*  912579 */   // Label 13884: @912579
     /*  912579 */   GIM_Try, /*On fail goto*//*Label 13885*/ GIMT_Encode4(912662), // Rule ID 63606 //
     /*  912584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  912595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  912598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  912601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912608 */     // MIs[0] op1
     /*  912608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912624 */     // MIs[0] op4
     /*  912624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912639 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  912639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  912642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912644 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912646 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912648 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912650 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912660 */     GIR_RootConstrainSelectedInstOperands,
     /*  912661 */     // GIR_Coverage, 63606,
     /*  912661 */     GIR_EraseRootFromParent_Done,
     /*  912662 */   // Label 13885: @912662
     /*  912662 */   GIM_Try, /*On fail goto*//*Label 13886*/ GIMT_Encode4(912745), // Rule ID 63661 //
     /*  912667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  912684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912691 */     // MIs[0] op1
     /*  912691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912707 */     // MIs[0] op4
     /*  912707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  912725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912727 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912729 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912731 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912733 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912743 */     GIR_RootConstrainSelectedInstOperands,
     /*  912744 */     // GIR_Coverage, 63661,
     /*  912744 */     GIR_EraseRootFromParent_Done,
     /*  912745 */   // Label 13886: @912745
     /*  912745 */   GIM_Try, /*On fail goto*//*Label 13887*/ GIMT_Encode4(912828), // Rule ID 63662 //
     /*  912750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  912767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912774 */     // MIs[0] op1
     /*  912774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912790 */     // MIs[0] op4
     /*  912790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  912808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912810 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912812 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912814 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912816 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912826 */     GIR_RootConstrainSelectedInstOperands,
     /*  912827 */     // GIR_Coverage, 63662,
     /*  912827 */     GIR_EraseRootFromParent_Done,
     /*  912828 */   // Label 13887: @912828
     /*  912828 */   GIM_Try, /*On fail goto*//*Label 13888*/ GIMT_Encode4(912911), // Rule ID 63717 //
     /*  912833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  912844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  912847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912857 */     // MIs[0] op1
     /*  912857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912873 */     // MIs[0] op4
     /*  912873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912888 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  912891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912893 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912895 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912897 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912899 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912909 */     GIR_RootConstrainSelectedInstOperands,
     /*  912910 */     // GIR_Coverage, 63717,
     /*  912910 */     GIR_EraseRootFromParent_Done,
     /*  912911 */   // Label 13888: @912911
     /*  912911 */   GIM_Try, /*On fail goto*//*Label 13889*/ GIMT_Encode4(912994), // Rule ID 63718 //
     /*  912916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  912927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  912930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912940 */     // MIs[0] op1
     /*  912940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912956 */     // MIs[0] op4
     /*  912956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912971 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  912974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912976 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912978 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912980 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912982 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912992 */     GIR_RootConstrainSelectedInstOperands,
     /*  912993 */     // GIR_Coverage, 63718,
     /*  912993 */     GIR_EraseRootFromParent_Done,
     /*  912994 */   // Label 13889: @912994
     /*  912994 */   GIM_Try, /*On fail goto*//*Label 13890*/ GIMT_Encode4(913077), // Rule ID 63773 //
     /*  912999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  913016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  913019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913023 */     // MIs[0] op1
     /*  913023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913039 */     // MIs[0] op4
     /*  913039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  913054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  913057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913059 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913061 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913063 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913065 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913075 */     GIR_RootConstrainSelectedInstOperands,
     /*  913076 */     // GIR_Coverage, 63773,
     /*  913076 */     GIR_EraseRootFromParent_Done,
     /*  913077 */   // Label 13890: @913077
     /*  913077 */   GIM_Try, /*On fail goto*//*Label 13891*/ GIMT_Encode4(913160), // Rule ID 63774 //
     /*  913082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  913085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  913099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  913102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913106 */     // MIs[0] op1
     /*  913106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913109 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913122 */     // MIs[0] op4
     /*  913122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913137 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  913137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  913140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913142 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913144 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913146 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913148 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913158 */     GIR_RootConstrainSelectedInstOperands,
     /*  913159 */     // GIR_Coverage, 63774,
     /*  913159 */     GIR_EraseRootFromParent_Done,
     /*  913160 */   // Label 13891: @913160
     /*  913160 */   GIM_Try, /*On fail goto*//*Label 13892*/ GIMT_Encode4(913243), // Rule ID 63829 //
     /*  913165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  913176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  913179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  913182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  913185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913189 */     // MIs[0] op1
     /*  913189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913205 */     // MIs[0] op4
     /*  913205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913208 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913220 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  913220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  913223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913225 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913227 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913229 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913231 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913241 */     GIR_RootConstrainSelectedInstOperands,
     /*  913242 */     // GIR_Coverage, 63829,
     /*  913242 */     GIR_EraseRootFromParent_Done,
     /*  913243 */   // Label 13892: @913243
     /*  913243 */   GIM_Try, /*On fail goto*//*Label 13893*/ GIMT_Encode4(913326), // Rule ID 63830 //
     /*  913248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  913251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  913259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  913262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  913265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  913268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913272 */     // MIs[0] op1
     /*  913272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913275 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913288 */     // MIs[0] op4
     /*  913288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  913303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  913306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913308 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913310 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913312 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913314 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913324 */     GIR_RootConstrainSelectedInstOperands,
     /*  913325 */     // GIR_Coverage, 63830,
     /*  913325 */     GIR_EraseRootFromParent_Done,
     /*  913326 */   // Label 13893: @913326
     /*  913326 */   GIM_Try, /*On fail goto*//*Label 13894*/ GIMT_Encode4(913409), // Rule ID 63885 //
     /*  913331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  913342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  913345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  913348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  913351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913355 */     // MIs[0] op1
     /*  913355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913371 */     // MIs[0] op4
     /*  913371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913374 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913386 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  913386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  913389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913391 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913393 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913395 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913397 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913407 */     GIR_RootConstrainSelectedInstOperands,
     /*  913408 */     // GIR_Coverage, 63885,
     /*  913408 */     GIR_EraseRootFromParent_Done,
     /*  913409 */   // Label 13894: @913409
     /*  913409 */   GIM_Try, /*On fail goto*//*Label 13895*/ GIMT_Encode4(913492), // Rule ID 63886 //
     /*  913414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  913417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  913425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  913428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  913431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  913434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913438 */     // MIs[0] op1
     /*  913438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913454 */     // MIs[0] op4
     /*  913454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913469 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  913469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  913472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913474 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913476 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913478 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913480 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913490 */     GIR_RootConstrainSelectedInstOperands,
     /*  913491 */     // GIR_Coverage, 63886,
     /*  913491 */     GIR_EraseRootFromParent_Done,
     /*  913492 */   // Label 13895: @913492
     /*  913492 */   GIM_Try, /*On fail goto*//*Label 13896*/ GIMT_Encode4(913575), // Rule ID 63941 //
     /*  913497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  913508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  913511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  913514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  913517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913521 */     // MIs[0] op1
     /*  913521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913537 */     // MIs[0] op4
     /*  913537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913540 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913552 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11048:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  913552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  913555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913557 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913559 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913561 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913563 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913573 */     GIR_RootConstrainSelectedInstOperands,
     /*  913574 */     // GIR_Coverage, 63941,
     /*  913574 */     GIR_EraseRootFromParent_Done,
     /*  913575 */   // Label 13896: @913575
     /*  913575 */   GIM_Try, /*On fail goto*//*Label 13897*/ GIMT_Encode4(913658), // Rule ID 63942 //
     /*  913580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  913583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  913591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  913594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  913597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  913600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913604 */     // MIs[0] op1
     /*  913604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913607 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913620 */     // MIs[0] op4
     /*  913620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913635 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11048:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  913635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  913638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913640 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913642 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913644 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913646 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913656 */     GIR_RootConstrainSelectedInstOperands,
     /*  913657 */     // GIR_Coverage, 63942,
     /*  913657 */     GIR_EraseRootFromParent_Done,
     /*  913658 */   // Label 13897: @913658
     /*  913658 */   GIM_Try, /*On fail goto*//*Label 13898*/ GIMT_Encode4(913741), // Rule ID 63971 //
     /*  913663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  913671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  913674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  913677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  913680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  913683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913687 */     // MIs[0] op1
     /*  913687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913690 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913703 */     // MIs[0] op4
     /*  913703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913718 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  913718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF8),
     /*  913721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913723 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913725 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913727 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913729 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913739 */     GIR_RootConstrainSelectedInstOperands,
     /*  913740 */     // GIR_Coverage, 63971,
     /*  913740 */     GIR_EraseRootFromParent_Done,
     /*  913741 */   // Label 13898: @913741
     /*  913741 */   GIM_Try, /*On fail goto*//*Label 13899*/ GIMT_Encode4(913824), // Rule ID 63972 //
     /*  913746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  913749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  913754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  913757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  913760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  913763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  913766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913770 */     // MIs[0] op1
     /*  913770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913786 */     // MIs[0] op4
     /*  913786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913801 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  913801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF8),
     /*  913804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913806 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913808 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913810 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913812 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913822 */     GIR_RootConstrainSelectedInstOperands,
     /*  913823 */     // GIR_Coverage, 63972,
     /*  913823 */     GIR_EraseRootFromParent_Done,
     /*  913824 */   // Label 13899: @913824
     /*  913824 */   GIM_Try, /*On fail goto*//*Label 13900*/ GIMT_Encode4(913907), // Rule ID 63989 //
     /*  913829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  913837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  913840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  913843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  913846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  913849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913853 */     // MIs[0] op1
     /*  913853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913869 */     // MIs[0] op4
     /*  913869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913872 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913884 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  913884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  913887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913889 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913891 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913893 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913895 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913905 */     GIR_RootConstrainSelectedInstOperands,
     /*  913906 */     // GIR_Coverage, 63989,
     /*  913906 */     GIR_EraseRootFromParent_Done,
     /*  913907 */   // Label 13900: @913907
     /*  913907 */   GIM_Try, /*On fail goto*//*Label 13901*/ GIMT_Encode4(913990), // Rule ID 63990 //
     /*  913912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  913915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  913920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  913923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  913926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  913929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  913932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913936 */     // MIs[0] op1
     /*  913936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913952 */     // MIs[0] op4
     /*  913952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913967 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  913967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  913970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913972 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913974 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913976 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913978 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913988 */     GIR_RootConstrainSelectedInstOperands,
     /*  913989 */     // GIR_Coverage, 63990,
     /*  913989 */     GIR_EraseRootFromParent_Done,
     /*  913990 */   // Label 13901: @913990
     /*  913990 */   GIM_Try, /*On fail goto*//*Label 13902*/ GIMT_Encode4(914073), // Rule ID 64007 //
     /*  913995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  914006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  914009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  914012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  914015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914019 */     // MIs[0] op1
     /*  914019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914035 */     // MIs[0] op4
     /*  914035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  914050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  914053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914055 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914057 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914059 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914061 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914071 */     GIR_RootConstrainSelectedInstOperands,
     /*  914072 */     // GIR_Coverage, 64007,
     /*  914072 */     GIR_EraseRootFromParent_Done,
     /*  914073 */   // Label 13902: @914073
     /*  914073 */   GIM_Try, /*On fail goto*//*Label 13903*/ GIMT_Encode4(914156), // Rule ID 64008 //
     /*  914078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  914081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  914089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  914092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  914095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  914098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914102 */     // MIs[0] op1
     /*  914102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914118 */     // MIs[0] op4
     /*  914118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914133 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  914133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  914136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914138 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914140 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914142 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914144 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914154 */     GIR_RootConstrainSelectedInstOperands,
     /*  914155 */     // GIR_Coverage, 64008,
     /*  914155 */     GIR_EraseRootFromParent_Done,
     /*  914156 */   // Label 13903: @914156
     /*  914156 */   GIM_Try, /*On fail goto*//*Label 13904*/ GIMT_Encode4(914239), // Rule ID 64025 //
     /*  914161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  914164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  914172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  914175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  914178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  914181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  914185 */     // MIs[0] op1
     /*  914185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  914197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914201 */     // MIs[0] op4
     /*  914201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  914216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  914219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914221 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914223 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914225 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914227 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914237 */     GIR_RootConstrainSelectedInstOperands,
     /*  914238 */     // GIR_Coverage, 64025,
     /*  914238 */     GIR_EraseRootFromParent_Done,
     /*  914239 */   // Label 13904: @914239
     /*  914239 */   GIM_Try, /*On fail goto*//*Label 13905*/ GIMT_Encode4(914322), // Rule ID 64026 //
     /*  914244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  914247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  914255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  914258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  914261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  914264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  914268 */     // MIs[0] op1
     /*  914268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  914280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914284 */     // MIs[0] op4
     /*  914284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914299 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  914299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  914302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914304 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914306 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914308 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914310 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914320 */     GIR_RootConstrainSelectedInstOperands,
     /*  914321 */     // GIR_Coverage, 64026,
     /*  914321 */     GIR_EraseRootFromParent_Done,
     /*  914322 */   // Label 13905: @914322
     /*  914322 */   GIM_Try, /*On fail goto*//*Label 13906*/ GIMT_Encode4(914405), // Rule ID 64043 //
     /*  914327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  914330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  914338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  914341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  914344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  914347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914351 */     // MIs[0] op1
     /*  914351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914354 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  914367 */     // MIs[0] op4
     /*  914367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914382 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  914382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  914385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914387 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914389 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914391 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914393 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914403 */     GIR_RootConstrainSelectedInstOperands,
     /*  914404 */     // GIR_Coverage, 64043,
     /*  914404 */     GIR_EraseRootFromParent_Done,
     /*  914405 */   // Label 13906: @914405
     /*  914405 */   GIM_Try, /*On fail goto*//*Label 13907*/ GIMT_Encode4(914488), // Rule ID 64044 //
     /*  914410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  914413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  914421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  914424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  914427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  914430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914434 */     // MIs[0] op1
     /*  914434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914437 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  914450 */     // MIs[0] op4
     /*  914450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914465 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  914465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  914468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914470 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914472 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914474 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914476 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914486 */     GIR_RootConstrainSelectedInstOperands,
     /*  914487 */     // GIR_Coverage, 64044,
     /*  914487 */     GIR_EraseRootFromParent_Done,
     /*  914488 */   // Label 13907: @914488
     /*  914488 */   GIM_Try, /*On fail goto*//*Label 13908*/ GIMT_Encode4(914571), // Rule ID 64061 //
     /*  914493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  914496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  914504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  914507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  914510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  914513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914517 */     // MIs[0] op1
     /*  914517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914533 */     // MIs[0] op4
     /*  914533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914548 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  914548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  914551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914553 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914555 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914557 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914559 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914569 */     GIR_RootConstrainSelectedInstOperands,
     /*  914570 */     // GIR_Coverage, 64061,
     /*  914570 */     GIR_EraseRootFromParent_Done,
     /*  914571 */   // Label 13908: @914571
     /*  914571 */   GIM_Try, /*On fail goto*//*Label 13909*/ GIMT_Encode4(914654), // Rule ID 64062 //
     /*  914576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  914579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  914587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  914590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  914593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  914596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914600 */     // MIs[0] op1
     /*  914600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914616 */     // MIs[0] op4
     /*  914616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914631 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  914631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  914634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914636 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914638 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914640 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914642 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914652 */     GIR_RootConstrainSelectedInstOperands,
     /*  914653 */     // GIR_Coverage, 64062,
     /*  914653 */     GIR_EraseRootFromParent_Done,
     /*  914654 */   // Label 13909: @914654
     /*  914654 */   GIM_Try, /*On fail goto*//*Label 13910*/ GIMT_Encode4(914737), // Rule ID 64079 //
     /*  914659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  914662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  914670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  914673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  914676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  914679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914683 */     // MIs[0] op1
     /*  914683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914699 */     // MIs[0] op4
     /*  914699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  914714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  914717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914719 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914721 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914723 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914725 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914735 */     GIR_RootConstrainSelectedInstOperands,
     /*  914736 */     // GIR_Coverage, 64079,
     /*  914736 */     GIR_EraseRootFromParent_Done,
     /*  914737 */   // Label 13910: @914737
     /*  914737 */   GIM_Try, /*On fail goto*//*Label 13911*/ GIMT_Encode4(914820), // Rule ID 64080 //
     /*  914742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  914745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  914753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  914756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  914759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  914762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914766 */     // MIs[0] op1
     /*  914766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914782 */     // MIs[0] op4
     /*  914782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914797 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  914797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  914800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914802 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914804 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914806 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914808 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914818 */     GIR_RootConstrainSelectedInstOperands,
     /*  914819 */     // GIR_Coverage, 64080,
     /*  914819 */     GIR_EraseRootFromParent_Done,
     /*  914820 */   // Label 13911: @914820
     /*  914820 */   GIM_Try, /*On fail goto*//*Label 13912*/ GIMT_Encode4(914903), // Rule ID 64103 //
     /*  914825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  914828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  914836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  914839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  914842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  914845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914849 */     // MIs[0] op1
     /*  914849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914865 */     // MIs[0] op4
     /*  914865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  914880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  914883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914885 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914887 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914889 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914891 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914901 */     GIR_RootConstrainSelectedInstOperands,
     /*  914902 */     // GIR_Coverage, 64103,
     /*  914902 */     GIR_EraseRootFromParent_Done,
     /*  914903 */   // Label 13912: @914903
     /*  914903 */   GIM_Try, /*On fail goto*//*Label 13913*/ GIMT_Encode4(914986), // Rule ID 64104 //
     /*  914908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  914911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  914919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  914922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  914925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  914928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914932 */     // MIs[0] op1
     /*  914932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914948 */     // MIs[0] op4
     /*  914948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914963 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  914963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  914966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914968 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914970 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914972 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914974 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914984 */     GIR_RootConstrainSelectedInstOperands,
     /*  914985 */     // GIR_Coverage, 64104,
     /*  914985 */     GIR_EraseRootFromParent_Done,
     /*  914986 */   // Label 13913: @914986
     /*  914986 */   GIM_Try, /*On fail goto*//*Label 13914*/ GIMT_Encode4(915069), // Rule ID 64127 //
     /*  914991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  914994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  915002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  915005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  915008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  915011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915015 */     // MIs[0] op1
     /*  915015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915031 */     // MIs[0] op4
     /*  915031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915046 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  915046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  915049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915051 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915053 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915055 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915057 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915067 */     GIR_RootConstrainSelectedInstOperands,
     /*  915068 */     // GIR_Coverage, 64127,
     /*  915068 */     GIR_EraseRootFromParent_Done,
     /*  915069 */   // Label 13914: @915069
     /*  915069 */   GIM_Try, /*On fail goto*//*Label 13915*/ GIMT_Encode4(915152), // Rule ID 64128 //
     /*  915074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  915077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  915085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  915088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  915091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  915094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915098 */     // MIs[0] op1
     /*  915098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915114 */     // MIs[0] op4
     /*  915114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915129 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  915129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  915132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915134 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915136 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915138 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915140 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915150 */     GIR_RootConstrainSelectedInstOperands,
     /*  915151 */     // GIR_Coverage, 64128,
     /*  915151 */     GIR_EraseRootFromParent_Done,
     /*  915152 */   // Label 13915: @915152
     /*  915152 */   GIM_Try, /*On fail goto*//*Label 13916*/ GIMT_Encode4(915235), // Rule ID 64151 //
     /*  915157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  915160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  915168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  915171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  915174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  915177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915181 */     // MIs[0] op1
     /*  915181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915197 */     // MIs[0] op4
     /*  915197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915200 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915212 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  915212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  915215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915217 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915219 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915221 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915223 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915233 */     GIR_RootConstrainSelectedInstOperands,
     /*  915234 */     // GIR_Coverage, 64151,
     /*  915234 */     GIR_EraseRootFromParent_Done,
     /*  915235 */   // Label 13916: @915235
     /*  915235 */   GIM_Try, /*On fail goto*//*Label 13917*/ GIMT_Encode4(915318), // Rule ID 64152 //
     /*  915240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  915243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  915251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  915254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  915257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  915260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915264 */     // MIs[0] op1
     /*  915264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915280 */     // MIs[0] op4
     /*  915280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915295 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  915295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  915298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915300 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915302 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915304 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915306 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915316 */     GIR_RootConstrainSelectedInstOperands,
     /*  915317 */     // GIR_Coverage, 64152,
     /*  915317 */     GIR_EraseRootFromParent_Done,
     /*  915318 */   // Label 13917: @915318
     /*  915318 */   GIM_Try, /*On fail goto*//*Label 13918*/ GIMT_Encode4(915401), // Rule ID 64175 //
     /*  915323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  915326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  915334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  915337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  915340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  915343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915347 */     // MIs[0] op1
     /*  915347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915363 */     // MIs[0] op4
     /*  915363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915378 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  915378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  915381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915383 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915385 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915387 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915389 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915399 */     GIR_RootConstrainSelectedInstOperands,
     /*  915400 */     // GIR_Coverage, 64175,
     /*  915400 */     GIR_EraseRootFromParent_Done,
     /*  915401 */   // Label 13918: @915401
     /*  915401 */   GIM_Try, /*On fail goto*//*Label 13919*/ GIMT_Encode4(915484), // Rule ID 64176 //
     /*  915406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  915409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  915417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  915420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  915423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  915426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915430 */     // MIs[0] op1
     /*  915430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915446 */     // MIs[0] op4
     /*  915446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915461 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  915461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  915464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915466 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915468 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915470 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915472 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915482 */     GIR_RootConstrainSelectedInstOperands,
     /*  915483 */     // GIR_Coverage, 64176,
     /*  915483 */     GIR_EraseRootFromParent_Done,
     /*  915484 */   // Label 13919: @915484
     /*  915484 */   GIM_Try, /*On fail goto*//*Label 13920*/ GIMT_Encode4(915567), // Rule ID 64199 //
     /*  915489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  915492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  915500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  915503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  915506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  915509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915513 */     // MIs[0] op1
     /*  915513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915529 */     // MIs[0] op4
     /*  915529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  915544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  915547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915549 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915551 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915553 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915555 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915565 */     GIR_RootConstrainSelectedInstOperands,
     /*  915566 */     // GIR_Coverage, 64199,
     /*  915566 */     GIR_EraseRootFromParent_Done,
     /*  915567 */   // Label 13920: @915567
     /*  915567 */   GIM_Try, /*On fail goto*//*Label 13921*/ GIMT_Encode4(915650), // Rule ID 64200 //
     /*  915572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  915575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  915583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  915586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  915589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  915592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915596 */     // MIs[0] op1
     /*  915596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915612 */     // MIs[0] op4
     /*  915612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915627 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  915627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  915630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915632 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915634 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915636 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915638 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915648 */     GIR_RootConstrainSelectedInstOperands,
     /*  915649 */     // GIR_Coverage, 64200,
     /*  915649 */     GIR_EraseRootFromParent_Done,
     /*  915650 */   // Label 13921: @915650
     /*  915650 */   GIM_Try, /*On fail goto*//*Label 13922*/ GIMT_Encode4(915733), // Rule ID 64223 //
     /*  915655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  915658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  915666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  915669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  915672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  915675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915679 */     // MIs[0] op1
     /*  915679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915695 */     // MIs[0] op4
     /*  915695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  915710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  915713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915715 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915717 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915719 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915721 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915731 */     GIR_RootConstrainSelectedInstOperands,
     /*  915732 */     // GIR_Coverage, 64223,
     /*  915732 */     GIR_EraseRootFromParent_Done,
     /*  915733 */   // Label 13922: @915733
     /*  915733 */   GIM_Try, /*On fail goto*//*Label 13923*/ GIMT_Encode4(915816), // Rule ID 64224 //
     /*  915738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  915741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  915749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  915752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  915755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  915758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915762 */     // MIs[0] op1
     /*  915762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915765 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915778 */     // MIs[0] op4
     /*  915778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915793 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  915793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  915796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915798 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915800 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915802 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915804 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915814 */     GIR_RootConstrainSelectedInstOperands,
     /*  915815 */     // GIR_Coverage, 64224,
     /*  915815 */     GIR_EraseRootFromParent_Done,
     /*  915816 */   // Label 13923: @915816
     /*  915816 */   GIM_Try, /*On fail goto*//*Label 13924*/ GIMT_Encode4(915899), // Rule ID 64247 //
     /*  915821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  915824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  915832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  915835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  915838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  915841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915845 */     // MIs[0] op1
     /*  915845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915861 */     // MIs[0] op4
     /*  915861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915876 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  915876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  915879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915881 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915883 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915885 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915887 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915897 */     GIR_RootConstrainSelectedInstOperands,
     /*  915898 */     // GIR_Coverage, 64247,
     /*  915898 */     GIR_EraseRootFromParent_Done,
     /*  915899 */   // Label 13924: @915899
     /*  915899 */   GIM_Try, /*On fail goto*//*Label 13925*/ GIMT_Encode4(915982), // Rule ID 64248 //
     /*  915904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  915907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  915915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  915918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  915921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  915924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915928 */     // MIs[0] op1
     /*  915928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915931 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915944 */     // MIs[0] op4
     /*  915944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915959 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  915959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  915962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915964 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915966 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915968 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915970 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915980 */     GIR_RootConstrainSelectedInstOperands,
     /*  915981 */     // GIR_Coverage, 64248,
     /*  915981 */     GIR_EraseRootFromParent_Done,
     /*  915982 */   // Label 13925: @915982
     /*  915982 */   GIM_Try, /*On fail goto*//*Label 13926*/ GIMT_Encode4(916065), // Rule ID 64271 //
     /*  915987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  915990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  915998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  916001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  916004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  916007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916011 */     // MIs[0] op1
     /*  916011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  916014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  916019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916027 */     // MIs[0] op4
     /*  916027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  916030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  916035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916042 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11050:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  916042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  916045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916047 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  916049 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  916051 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  916053 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  916055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916063 */     GIR_RootConstrainSelectedInstOperands,
     /*  916064 */     // GIR_Coverage, 64271,
     /*  916064 */     GIR_EraseRootFromParent_Done,
     /*  916065 */   // Label 13926: @916065
     /*  916065 */   GIM_Try, /*On fail goto*//*Label 13927*/ GIMT_Encode4(916148), // Rule ID 64272 //
     /*  916070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  916073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  916078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  916081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  916084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  916087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  916090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916094 */     // MIs[0] op1
     /*  916094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  916097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  916102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916110 */     // MIs[0] op4
     /*  916110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  916113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  916118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916125 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  916125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  916128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916130 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  916132 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  916134 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  916136 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  916138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916146 */     GIR_RootConstrainSelectedInstOperands,
     /*  916147 */     // GIR_Coverage, 64272,
     /*  916147 */     GIR_EraseRootFromParent_Done,
     /*  916148 */   // Label 13927: @916148
     /*  916148 */   GIM_Try, /*On fail goto*//*Label 13928*/ GIMT_Encode4(916226), // Rule ID 60600 //
     /*  916153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  916156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  916164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  916167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  916170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916185 */     // MIs[0] rs2
     /*  916185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916193 */     // MIs[0] policy
     /*  916193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916203 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  916206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916224 */     GIR_RootConstrainSelectedInstOperands,
     /*  916225 */     // GIR_Coverage, 60600,
     /*  916225 */     GIR_EraseRootFromParent_Done,
     /*  916226 */   // Label 13928: @916226
     /*  916226 */   GIM_Try, /*On fail goto*//*Label 13929*/ GIMT_Encode4(916304), // Rule ID 60601 //
     /*  916231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  916234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  916242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  916245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  916248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916263 */     // MIs[0] rs2
     /*  916263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916271 */     // MIs[0] policy
     /*  916271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916281 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  916284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916302 */     GIR_RootConstrainSelectedInstOperands,
     /*  916303 */     // GIR_Coverage, 60601,
     /*  916303 */     GIR_EraseRootFromParent_Done,
     /*  916304 */   // Label 13929: @916304
     /*  916304 */   GIM_Try, /*On fail goto*//*Label 13930*/ GIMT_Encode4(916382), // Rule ID 62256 //
     /*  916309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  916312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  916320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  916323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  916326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916341 */     // MIs[0] rs2
     /*  916341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916349 */     // MIs[0] policy
     /*  916349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916359 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  916362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916380 */     GIR_RootConstrainSelectedInstOperands,
     /*  916381 */     // GIR_Coverage, 62256,
     /*  916381 */     GIR_EraseRootFromParent_Done,
     /*  916382 */   // Label 13930: @916382
     /*  916382 */   GIM_Try, /*On fail goto*//*Label 13931*/ GIMT_Encode4(916460), // Rule ID 62257 //
     /*  916387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  916390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  916398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  916401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  916404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916419 */     // MIs[0] rs2
     /*  916419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916422 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916427 */     // MIs[0] policy
     /*  916427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916437 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  916440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916458 */     GIR_RootConstrainSelectedInstOperands,
     /*  916459 */     // GIR_Coverage, 62257,
     /*  916459 */     GIR_EraseRootFromParent_Done,
     /*  916460 */   // Label 13931: @916460
     /*  916460 */   GIM_Try, /*On fail goto*//*Label 13932*/ GIMT_Encode4(916538), // Rule ID 62258 //
     /*  916465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  916468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  916476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  916479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  916482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916497 */     // MIs[0] rs2
     /*  916497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916505 */     // MIs[0] policy
     /*  916505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  916518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916536 */     GIR_RootConstrainSelectedInstOperands,
     /*  916537 */     // GIR_Coverage, 62258,
     /*  916537 */     GIR_EraseRootFromParent_Done,
     /*  916538 */   // Label 13932: @916538
     /*  916538 */   GIM_Try, /*On fail goto*//*Label 13933*/ GIMT_Encode4(916616), // Rule ID 62259 //
     /*  916543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  916546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  916554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  916557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  916560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916575 */     // MIs[0] rs2
     /*  916575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916583 */     // MIs[0] policy
     /*  916583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916593 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  916596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916614 */     GIR_RootConstrainSelectedInstOperands,
     /*  916615 */     // GIR_Coverage, 62259,
     /*  916615 */     GIR_EraseRootFromParent_Done,
     /*  916616 */   // Label 13933: @916616
     /*  916616 */   GIM_Try, /*On fail goto*//*Label 13934*/ GIMT_Encode4(916694), // Rule ID 62260 //
     /*  916621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  916624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  916632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  916635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  916638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916653 */     // MIs[0] rs2
     /*  916653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916661 */     // MIs[0] policy
     /*  916661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916671 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  916674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916692 */     GIR_RootConstrainSelectedInstOperands,
     /*  916693 */     // GIR_Coverage, 62260,
     /*  916693 */     GIR_EraseRootFromParent_Done,
     /*  916694 */   // Label 13934: @916694
     /*  916694 */   GIM_Try, /*On fail goto*//*Label 13935*/ GIMT_Encode4(916772), // Rule ID 62261 //
     /*  916699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  916702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  916710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  916713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  916716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916731 */     // MIs[0] rs2
     /*  916731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916739 */     // MIs[0] policy
     /*  916739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916749 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  916752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916770 */     GIR_RootConstrainSelectedInstOperands,
     /*  916771 */     // GIR_Coverage, 62261,
     /*  916771 */     GIR_EraseRootFromParent_Done,
     /*  916772 */   // Label 13935: @916772
     /*  916772 */   GIM_Try, /*On fail goto*//*Label 13936*/ GIMT_Encode4(916850), // Rule ID 62262 //
     /*  916777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  916780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  916788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  916791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  916794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916809 */     // MIs[0] rs2
     /*  916809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916817 */     // MIs[0] policy
     /*  916817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916827 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  916830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916848 */     GIR_RootConstrainSelectedInstOperands,
     /*  916849 */     // GIR_Coverage, 62262,
     /*  916849 */     GIR_EraseRootFromParent_Done,
     /*  916850 */   // Label 13936: @916850
     /*  916850 */   GIM_Try, /*On fail goto*//*Label 13937*/ GIMT_Encode4(916928), // Rule ID 62263 //
     /*  916855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  916858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  916866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  916869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  916872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916887 */     // MIs[0] rs2
     /*  916887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916895 */     // MIs[0] policy
     /*  916895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916905 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  916908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916926 */     GIR_RootConstrainSelectedInstOperands,
     /*  916927 */     // GIR_Coverage, 62263,
     /*  916927 */     GIR_EraseRootFromParent_Done,
     /*  916928 */   // Label 13937: @916928
     /*  916928 */   GIM_Try, /*On fail goto*//*Label 13938*/ GIMT_Encode4(917006), // Rule ID 62424 //
     /*  916933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  916936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  916941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  916944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  916947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  916950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916965 */     // MIs[0] rs2
     /*  916965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916973 */     // MIs[0] policy
     /*  916973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916983 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  916986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917004 */     GIR_RootConstrainSelectedInstOperands,
     /*  917005 */     // GIR_Coverage, 62424,
     /*  917005 */     GIR_EraseRootFromParent_Done,
     /*  917006 */   // Label 13938: @917006
     /*  917006 */   GIM_Try, /*On fail goto*//*Label 13939*/ GIMT_Encode4(917084), // Rule ID 62425 //
     /*  917011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  917014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  917022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  917025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  917028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917043 */     // MIs[0] rs2
     /*  917043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917051 */     // MIs[0] policy
     /*  917051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917061 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  917064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917082 */     GIR_RootConstrainSelectedInstOperands,
     /*  917083 */     // GIR_Coverage, 62425,
     /*  917083 */     GIR_EraseRootFromParent_Done,
     /*  917084 */   // Label 13939: @917084
     /*  917084 */   GIM_Try, /*On fail goto*//*Label 13940*/ GIMT_Encode4(917162), // Rule ID 62426 //
     /*  917089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  917092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  917100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  917103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  917106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917121 */     // MIs[0] rs2
     /*  917121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917129 */     // MIs[0] policy
     /*  917129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917139 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  917142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917160 */     GIR_RootConstrainSelectedInstOperands,
     /*  917161 */     // GIR_Coverage, 62426,
     /*  917161 */     GIR_EraseRootFromParent_Done,
     /*  917162 */   // Label 13940: @917162
     /*  917162 */   GIM_Try, /*On fail goto*//*Label 13941*/ GIMT_Encode4(917240), // Rule ID 62427 //
     /*  917167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  917170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  917178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  917181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  917184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917199 */     // MIs[0] rs2
     /*  917199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917207 */     // MIs[0] policy
     /*  917207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917217 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  917220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917238 */     GIR_RootConstrainSelectedInstOperands,
     /*  917239 */     // GIR_Coverage, 62427,
     /*  917239 */     GIR_EraseRootFromParent_Done,
     /*  917240 */   // Label 13941: @917240
     /*  917240 */   GIM_Try, /*On fail goto*//*Label 13942*/ GIMT_Encode4(917318), // Rule ID 62428 //
     /*  917245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  917248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  917256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  917259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  917262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917277 */     // MIs[0] rs2
     /*  917277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917285 */     // MIs[0] policy
     /*  917285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917295 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  917298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917316 */     GIR_RootConstrainSelectedInstOperands,
     /*  917317 */     // GIR_Coverage, 62428,
     /*  917317 */     GIR_EraseRootFromParent_Done,
     /*  917318 */   // Label 13942: @917318
     /*  917318 */   GIM_Try, /*On fail goto*//*Label 13943*/ GIMT_Encode4(917396), // Rule ID 62429 //
     /*  917323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  917326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  917334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  917337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  917340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917355 */     // MIs[0] rs2
     /*  917355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917363 */     // MIs[0] policy
     /*  917363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  917376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917394 */     GIR_RootConstrainSelectedInstOperands,
     /*  917395 */     // GIR_Coverage, 62429,
     /*  917395 */     GIR_EraseRootFromParent_Done,
     /*  917396 */   // Label 13943: @917396
     /*  917396 */   GIM_Try, /*On fail goto*//*Label 13944*/ GIMT_Encode4(917474), // Rule ID 62430 //
     /*  917401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  917404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  917412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  917415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  917418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917433 */     // MIs[0] rs2
     /*  917433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917441 */     // MIs[0] policy
     /*  917441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917451 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  917454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917472 */     GIR_RootConstrainSelectedInstOperands,
     /*  917473 */     // GIR_Coverage, 62430,
     /*  917473 */     GIR_EraseRootFromParent_Done,
     /*  917474 */   // Label 13944: @917474
     /*  917474 */   GIM_Try, /*On fail goto*//*Label 13945*/ GIMT_Encode4(917552), // Rule ID 62431 //
     /*  917479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  917482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  917490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  917493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  917496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917511 */     // MIs[0] rs2
     /*  917511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917519 */     // MIs[0] policy
     /*  917519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917529 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  917532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917550 */     GIR_RootConstrainSelectedInstOperands,
     /*  917551 */     // GIR_Coverage, 62431,
     /*  917551 */     GIR_EraseRootFromParent_Done,
     /*  917552 */   // Label 13945: @917552
     /*  917552 */   GIM_Try, /*On fail goto*//*Label 13946*/ GIMT_Encode4(917630), // Rule ID 62432 //
     /*  917557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  917560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  917568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  917571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  917574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917589 */     // MIs[0] rs2
     /*  917589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917597 */     // MIs[0] policy
     /*  917597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917607 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  917610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917628 */     GIR_RootConstrainSelectedInstOperands,
     /*  917629 */     // GIR_Coverage, 62432,
     /*  917629 */     GIR_EraseRootFromParent_Done,
     /*  917630 */   // Label 13946: @917630
     /*  917630 */   GIM_Try, /*On fail goto*//*Label 13947*/ GIMT_Encode4(917708), // Rule ID 62433 //
     /*  917635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  917638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  917646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  917649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  917652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917667 */     // MIs[0] rs2
     /*  917667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917675 */     // MIs[0] policy
     /*  917675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917685 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  917688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917706 */     GIR_RootConstrainSelectedInstOperands,
     /*  917707 */     // GIR_Coverage, 62433,
     /*  917707 */     GIR_EraseRootFromParent_Done,
     /*  917708 */   // Label 13947: @917708
     /*  917708 */   GIM_Try, /*On fail goto*//*Label 13948*/ GIMT_Encode4(917796), // Rule ID 23690 //
     /*  917713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  917724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  917727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  917730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917760 */     // MIs[1] Operand 1
     /*  917760 */     // No operand predicates
     /*  917760 */     // MIs[0] policy
     /*  917760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917772 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  917775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917794 */     GIR_RootConstrainSelectedInstOperands,
     /*  917795 */     // GIR_Coverage, 23690,
     /*  917795 */     GIR_EraseRootFromParent_Done,
     /*  917796 */   // Label 13948: @917796
     /*  917796 */   GIM_Try, /*On fail goto*//*Label 13949*/ GIMT_Encode4(917884), // Rule ID 23691 //
     /*  917801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  917812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  917815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  917818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917848 */     // MIs[1] Operand 1
     /*  917848 */     // No operand predicates
     /*  917848 */     // MIs[0] policy
     /*  917848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917860 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  917863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917882 */     GIR_RootConstrainSelectedInstOperands,
     /*  917883 */     // GIR_Coverage, 23691,
     /*  917883 */     GIR_EraseRootFromParent_Done,
     /*  917884 */   // Label 13949: @917884
     /*  917884 */   GIM_Try, /*On fail goto*//*Label 13950*/ GIMT_Encode4(917972), // Rule ID 23694 //
     /*  917889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  917900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  917903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  917906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917936 */     // MIs[1] Operand 1
     /*  917936 */     // No operand predicates
     /*  917936 */     // MIs[0] policy
     /*  917936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917948 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  917951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917970 */     GIR_RootConstrainSelectedInstOperands,
     /*  917971 */     // GIR_Coverage, 23694,
     /*  917971 */     GIR_EraseRootFromParent_Done,
     /*  917972 */   // Label 13950: @917972
     /*  917972 */   GIM_Try, /*On fail goto*//*Label 13951*/ GIMT_Encode4(918060), // Rule ID 23695 //
     /*  917977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  917988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  917991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  917994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918024 */     // MIs[1] Operand 1
     /*  918024 */     // No operand predicates
     /*  918024 */     // MIs[0] policy
     /*  918024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918036 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  918039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918058 */     GIR_RootConstrainSelectedInstOperands,
     /*  918059 */     // GIR_Coverage, 23695,
     /*  918059 */     GIR_EraseRootFromParent_Done,
     /*  918060 */   // Label 13951: @918060
     /*  918060 */   GIM_Try, /*On fail goto*//*Label 13952*/ GIMT_Encode4(918148), // Rule ID 23698 //
     /*  918065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  918076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  918079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  918082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918112 */     // MIs[1] Operand 1
     /*  918112 */     // No operand predicates
     /*  918112 */     // MIs[0] policy
     /*  918112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918124 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  918127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918146 */     GIR_RootConstrainSelectedInstOperands,
     /*  918147 */     // GIR_Coverage, 23698,
     /*  918147 */     GIR_EraseRootFromParent_Done,
     /*  918148 */   // Label 13952: @918148
     /*  918148 */   GIM_Try, /*On fail goto*//*Label 13953*/ GIMT_Encode4(918236), // Rule ID 23699 //
     /*  918153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  918164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  918167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  918170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918200 */     // MIs[1] Operand 1
     /*  918200 */     // No operand predicates
     /*  918200 */     // MIs[0] policy
     /*  918200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918212 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  918215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918234 */     GIR_RootConstrainSelectedInstOperands,
     /*  918235 */     // GIR_Coverage, 23699,
     /*  918235 */     GIR_EraseRootFromParent_Done,
     /*  918236 */   // Label 13953: @918236
     /*  918236 */   GIM_Try, /*On fail goto*//*Label 13954*/ GIMT_Encode4(918324), // Rule ID 23702 //
     /*  918241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  918252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  918255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  918258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918288 */     // MIs[1] Operand 1
     /*  918288 */     // No operand predicates
     /*  918288 */     // MIs[0] policy
     /*  918288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918300 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  918303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918322 */     GIR_RootConstrainSelectedInstOperands,
     /*  918323 */     // GIR_Coverage, 23702,
     /*  918323 */     GIR_EraseRootFromParent_Done,
     /*  918324 */   // Label 13954: @918324
     /*  918324 */   GIM_Try, /*On fail goto*//*Label 13955*/ GIMT_Encode4(918412), // Rule ID 23703 //
     /*  918329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  918340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  918343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  918346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918376 */     // MIs[1] Operand 1
     /*  918376 */     // No operand predicates
     /*  918376 */     // MIs[0] policy
     /*  918376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918388 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  918391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918410 */     GIR_RootConstrainSelectedInstOperands,
     /*  918411 */     // GIR_Coverage, 23703,
     /*  918411 */     GIR_EraseRootFromParent_Done,
     /*  918412 */   // Label 13955: @918412
     /*  918412 */   GIM_Try, /*On fail goto*//*Label 13956*/ GIMT_Encode4(918500), // Rule ID 23706 //
     /*  918417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  918428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  918431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  918434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918464 */     // MIs[1] Operand 1
     /*  918464 */     // No operand predicates
     /*  918464 */     // MIs[0] policy
     /*  918464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918476 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  918479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918498 */     GIR_RootConstrainSelectedInstOperands,
     /*  918499 */     // GIR_Coverage, 23706,
     /*  918499 */     GIR_EraseRootFromParent_Done,
     /*  918500 */   // Label 13956: @918500
     /*  918500 */   GIM_Try, /*On fail goto*//*Label 13957*/ GIMT_Encode4(918588), // Rule ID 23707 //
     /*  918505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  918516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  918519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  918522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918552 */     // MIs[1] Operand 1
     /*  918552 */     // No operand predicates
     /*  918552 */     // MIs[0] policy
     /*  918552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  918567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918586 */     GIR_RootConstrainSelectedInstOperands,
     /*  918587 */     // GIR_Coverage, 23707,
     /*  918587 */     GIR_EraseRootFromParent_Done,
     /*  918588 */   // Label 13957: @918588
     /*  918588 */   GIM_Try, /*On fail goto*//*Label 13958*/ GIMT_Encode4(918676), // Rule ID 23710 //
     /*  918593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  918604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  918607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  918610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918640 */     // MIs[1] Operand 1
     /*  918640 */     // No operand predicates
     /*  918640 */     // MIs[0] policy
     /*  918640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  918655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918674 */     GIR_RootConstrainSelectedInstOperands,
     /*  918675 */     // GIR_Coverage, 23710,
     /*  918675 */     GIR_EraseRootFromParent_Done,
     /*  918676 */   // Label 13958: @918676
     /*  918676 */   GIM_Try, /*On fail goto*//*Label 13959*/ GIMT_Encode4(918764), // Rule ID 23711 //
     /*  918681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  918692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  918695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  918698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918728 */     // MIs[1] Operand 1
     /*  918728 */     // No operand predicates
     /*  918728 */     // MIs[0] policy
     /*  918728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918740 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  918743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918762 */     GIR_RootConstrainSelectedInstOperands,
     /*  918763 */     // GIR_Coverage, 23711,
     /*  918763 */     GIR_EraseRootFromParent_Done,
     /*  918764 */   // Label 13959: @918764
     /*  918764 */   GIM_Try, /*On fail goto*//*Label 13960*/ GIMT_Encode4(918852), // Rule ID 23714 //
     /*  918769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  918780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  918783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  918786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918816 */     // MIs[1] Operand 1
     /*  918816 */     // No operand predicates
     /*  918816 */     // MIs[0] policy
     /*  918816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918828 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  918831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918850 */     GIR_RootConstrainSelectedInstOperands,
     /*  918851 */     // GIR_Coverage, 23714,
     /*  918851 */     GIR_EraseRootFromParent_Done,
     /*  918852 */   // Label 13960: @918852
     /*  918852 */   GIM_Try, /*On fail goto*//*Label 13961*/ GIMT_Encode4(918940), // Rule ID 23715 //
     /*  918857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  918868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  918871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  918874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918904 */     // MIs[1] Operand 1
     /*  918904 */     // No operand predicates
     /*  918904 */     // MIs[0] policy
     /*  918904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918916 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  918919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918938 */     GIR_RootConstrainSelectedInstOperands,
     /*  918939 */     // GIR_Coverage, 23715,
     /*  918939 */     GIR_EraseRootFromParent_Done,
     /*  918940 */   // Label 13961: @918940
     /*  918940 */   GIM_Try, /*On fail goto*//*Label 13962*/ GIMT_Encode4(919028), // Rule ID 23718 //
     /*  918945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  918956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  918959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  918962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918992 */     // MIs[1] Operand 1
     /*  918992 */     // No operand predicates
     /*  918992 */     // MIs[0] policy
     /*  918992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919004 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  919007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919026 */     GIR_RootConstrainSelectedInstOperands,
     /*  919027 */     // GIR_Coverage, 23718,
     /*  919027 */     GIR_EraseRootFromParent_Done,
     /*  919028 */   // Label 13962: @919028
     /*  919028 */   GIM_Try, /*On fail goto*//*Label 13963*/ GIMT_Encode4(919116), // Rule ID 23719 //
     /*  919033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  919044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  919047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  919050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919080 */     // MIs[1] Operand 1
     /*  919080 */     // No operand predicates
     /*  919080 */     // MIs[0] policy
     /*  919080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919092 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  919095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919114 */     GIR_RootConstrainSelectedInstOperands,
     /*  919115 */     // GIR_Coverage, 23719,
     /*  919115 */     GIR_EraseRootFromParent_Done,
     /*  919116 */   // Label 13963: @919116
     /*  919116 */   GIM_Try, /*On fail goto*//*Label 13964*/ GIMT_Encode4(919204), // Rule ID 23722 //
     /*  919121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  919132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  919135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  919138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919168 */     // MIs[1] Operand 1
     /*  919168 */     // No operand predicates
     /*  919168 */     // MIs[0] policy
     /*  919168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919180 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  919183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919202 */     GIR_RootConstrainSelectedInstOperands,
     /*  919203 */     // GIR_Coverage, 23722,
     /*  919203 */     GIR_EraseRootFromParent_Done,
     /*  919204 */   // Label 13964: @919204
     /*  919204 */   GIM_Try, /*On fail goto*//*Label 13965*/ GIMT_Encode4(919292), // Rule ID 23723 //
     /*  919209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  919220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  919223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  919226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919256 */     // MIs[1] Operand 1
     /*  919256 */     // No operand predicates
     /*  919256 */     // MIs[0] policy
     /*  919256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919268 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  919271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919290 */     GIR_RootConstrainSelectedInstOperands,
     /*  919291 */     // GIR_Coverage, 23723,
     /*  919291 */     GIR_EraseRootFromParent_Done,
     /*  919292 */   // Label 13965: @919292
     /*  919292 */   GIM_Try, /*On fail goto*//*Label 13966*/ GIMT_Encode4(919380), // Rule ID 23726 //
     /*  919297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  919300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  919308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  919311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  919314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919344 */     // MIs[1] Operand 1
     /*  919344 */     // No operand predicates
     /*  919344 */     // MIs[0] policy
     /*  919344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  919359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  919376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919378 */     GIR_RootConstrainSelectedInstOperands,
     /*  919379 */     // GIR_Coverage, 23726,
     /*  919379 */     GIR_EraseRootFromParent_Done,
     /*  919380 */   // Label 13966: @919380
     /*  919380 */   GIM_Try, /*On fail goto*//*Label 13967*/ GIMT_Encode4(919468), // Rule ID 23727 //
     /*  919385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  919388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  919396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  919399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  919402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919432 */     // MIs[1] Operand 1
     /*  919432 */     // No operand predicates
     /*  919432 */     // MIs[0] policy
     /*  919432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919444 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  919447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  919464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919466 */     GIR_RootConstrainSelectedInstOperands,
     /*  919467 */     // GIR_Coverage, 23727,
     /*  919467 */     GIR_EraseRootFromParent_Done,
     /*  919468 */   // Label 13967: @919468
     /*  919468 */   GIM_Try, /*On fail goto*//*Label 13968*/ GIMT_Encode4(919556), // Rule ID 23730 //
     /*  919473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  919484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  919487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  919490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919520 */     // MIs[1] Operand 1
     /*  919520 */     // No operand predicates
     /*  919520 */     // MIs[0] policy
     /*  919520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919532 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  919535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919554 */     GIR_RootConstrainSelectedInstOperands,
     /*  919555 */     // GIR_Coverage, 23730,
     /*  919555 */     GIR_EraseRootFromParent_Done,
     /*  919556 */   // Label 13968: @919556
     /*  919556 */   GIM_Try, /*On fail goto*//*Label 13969*/ GIMT_Encode4(919644), // Rule ID 23731 //
     /*  919561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  919572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  919575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  919578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919608 */     // MIs[1] Operand 1
     /*  919608 */     // No operand predicates
     /*  919608 */     // MIs[0] policy
     /*  919608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919620 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  919623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919642 */     GIR_RootConstrainSelectedInstOperands,
     /*  919643 */     // GIR_Coverage, 23731,
     /*  919643 */     GIR_EraseRootFromParent_Done,
     /*  919644 */   // Label 13969: @919644
     /*  919644 */   GIM_Try, /*On fail goto*//*Label 13970*/ GIMT_Encode4(919732), // Rule ID 23734 //
     /*  919649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  919660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  919663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  919666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919696 */     // MIs[1] Operand 1
     /*  919696 */     // No operand predicates
     /*  919696 */     // MIs[0] policy
     /*  919696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919708 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  919711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919730 */     GIR_RootConstrainSelectedInstOperands,
     /*  919731 */     // GIR_Coverage, 23734,
     /*  919731 */     GIR_EraseRootFromParent_Done,
     /*  919732 */   // Label 13970: @919732
     /*  919732 */   GIM_Try, /*On fail goto*//*Label 13971*/ GIMT_Encode4(919820), // Rule ID 23735 //
     /*  919737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  919748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  919751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  919754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919784 */     // MIs[1] Operand 1
     /*  919784 */     // No operand predicates
     /*  919784 */     // MIs[0] policy
     /*  919784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919796 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  919799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919818 */     GIR_RootConstrainSelectedInstOperands,
     /*  919819 */     // GIR_Coverage, 23735,
     /*  919819 */     GIR_EraseRootFromParent_Done,
     /*  919820 */   // Label 13971: @919820
     /*  919820 */   GIM_Try, /*On fail goto*//*Label 13972*/ GIMT_Encode4(919908), // Rule ID 23738 //
     /*  919825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  919836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  919839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  919842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919872 */     // MIs[1] Operand 1
     /*  919872 */     // No operand predicates
     /*  919872 */     // MIs[0] policy
     /*  919872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919884 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  919887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919906 */     GIR_RootConstrainSelectedInstOperands,
     /*  919907 */     // GIR_Coverage, 23738,
     /*  919907 */     GIR_EraseRootFromParent_Done,
     /*  919908 */   // Label 13972: @919908
     /*  919908 */   GIM_Try, /*On fail goto*//*Label 13973*/ GIMT_Encode4(919996), // Rule ID 23739 //
     /*  919913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  919924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  919927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  919930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919960 */     // MIs[1] Operand 1
     /*  919960 */     // No operand predicates
     /*  919960 */     // MIs[0] policy
     /*  919960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919972 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  919975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919994 */     GIR_RootConstrainSelectedInstOperands,
     /*  919995 */     // GIR_Coverage, 23739,
     /*  919995 */     GIR_EraseRootFromParent_Done,
     /*  919996 */   // Label 13973: @919996
     /*  919996 */   GIM_Try, /*On fail goto*//*Label 13974*/ GIMT_Encode4(920084), // Rule ID 23742 //
     /*  920001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  920012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  920015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  920018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920048 */     // MIs[1] Operand 1
     /*  920048 */     // No operand predicates
     /*  920048 */     // MIs[0] policy
     /*  920048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  920063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920082 */     GIR_RootConstrainSelectedInstOperands,
     /*  920083 */     // GIR_Coverage, 23742,
     /*  920083 */     GIR_EraseRootFromParent_Done,
     /*  920084 */   // Label 13974: @920084
     /*  920084 */   GIM_Try, /*On fail goto*//*Label 13975*/ GIMT_Encode4(920172), // Rule ID 23743 //
     /*  920089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  920100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  920103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  920106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920136 */     // MIs[1] Operand 1
     /*  920136 */     // No operand predicates
     /*  920136 */     // MIs[0] policy
     /*  920136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920148 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  920151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920170 */     GIR_RootConstrainSelectedInstOperands,
     /*  920171 */     // GIR_Coverage, 23743,
     /*  920171 */     GIR_EraseRootFromParent_Done,
     /*  920172 */   // Label 13975: @920172
     /*  920172 */   GIM_Try, /*On fail goto*//*Label 13976*/ GIMT_Encode4(920260), // Rule ID 23746 //
     /*  920177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  920188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  920191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  920194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920224 */     // MIs[1] Operand 1
     /*  920224 */     // No operand predicates
     /*  920224 */     // MIs[0] policy
     /*  920224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920236 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  920239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920258 */     GIR_RootConstrainSelectedInstOperands,
     /*  920259 */     // GIR_Coverage, 23746,
     /*  920259 */     GIR_EraseRootFromParent_Done,
     /*  920260 */   // Label 13976: @920260
     /*  920260 */   GIM_Try, /*On fail goto*//*Label 13977*/ GIMT_Encode4(920348), // Rule ID 23747 //
     /*  920265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  920276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  920279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  920282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920312 */     // MIs[1] Operand 1
     /*  920312 */     // No operand predicates
     /*  920312 */     // MIs[0] policy
     /*  920312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920324 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  920327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920346 */     GIR_RootConstrainSelectedInstOperands,
     /*  920347 */     // GIR_Coverage, 23747,
     /*  920347 */     GIR_EraseRootFromParent_Done,
     /*  920348 */   // Label 13977: @920348
     /*  920348 */   GIM_Try, /*On fail goto*//*Label 13978*/ GIMT_Encode4(920436), // Rule ID 23750 //
     /*  920353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  920364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  920367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  920370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920400 */     // MIs[1] Operand 1
     /*  920400 */     // No operand predicates
     /*  920400 */     // MIs[0] policy
     /*  920400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920412 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  920415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920434 */     GIR_RootConstrainSelectedInstOperands,
     /*  920435 */     // GIR_Coverage, 23750,
     /*  920435 */     GIR_EraseRootFromParent_Done,
     /*  920436 */   // Label 13978: @920436
     /*  920436 */   GIM_Try, /*On fail goto*//*Label 13979*/ GIMT_Encode4(920524), // Rule ID 23751 //
     /*  920441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  920452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  920455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  920458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920488 */     // MIs[1] Operand 1
     /*  920488 */     // No operand predicates
     /*  920488 */     // MIs[0] policy
     /*  920488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920500 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  920503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920522 */     GIR_RootConstrainSelectedInstOperands,
     /*  920523 */     // GIR_Coverage, 23751,
     /*  920523 */     GIR_EraseRootFromParent_Done,
     /*  920524 */   // Label 13979: @920524
     /*  920524 */   GIM_Try, /*On fail goto*//*Label 13980*/ GIMT_Encode4(920612), // Rule ID 23754 //
     /*  920529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  920540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  920543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  920546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920576 */     // MIs[1] Operand 1
     /*  920576 */     // No operand predicates
     /*  920576 */     // MIs[0] policy
     /*  920576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  920591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920610 */     GIR_RootConstrainSelectedInstOperands,
     /*  920611 */     // GIR_Coverage, 23754,
     /*  920611 */     GIR_EraseRootFromParent_Done,
     /*  920612 */   // Label 13980: @920612
     /*  920612 */   GIM_Try, /*On fail goto*//*Label 13981*/ GIMT_Encode4(920700), // Rule ID 23755 //
     /*  920617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  920628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  920631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  920634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920664 */     // MIs[1] Operand 1
     /*  920664 */     // No operand predicates
     /*  920664 */     // MIs[0] policy
     /*  920664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  920679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920698 */     GIR_RootConstrainSelectedInstOperands,
     /*  920699 */     // GIR_Coverage, 23755,
     /*  920699 */     GIR_EraseRootFromParent_Done,
     /*  920700 */   // Label 13981: @920700
     /*  920700 */   GIM_Try, /*On fail goto*//*Label 13982*/ GIMT_Encode4(920788), // Rule ID 23758 //
     /*  920705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  920716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  920719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  920722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920752 */     // MIs[1] Operand 1
     /*  920752 */     // No operand predicates
     /*  920752 */     // MIs[0] policy
     /*  920752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920764 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  920767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920786 */     GIR_RootConstrainSelectedInstOperands,
     /*  920787 */     // GIR_Coverage, 23758,
     /*  920787 */     GIR_EraseRootFromParent_Done,
     /*  920788 */   // Label 13982: @920788
     /*  920788 */   GIM_Try, /*On fail goto*//*Label 13983*/ GIMT_Encode4(920876), // Rule ID 23759 //
     /*  920793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  920804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  920807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  920810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920840 */     // MIs[1] Operand 1
     /*  920840 */     // No operand predicates
     /*  920840 */     // MIs[0] policy
     /*  920840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  920855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920874 */     GIR_RootConstrainSelectedInstOperands,
     /*  920875 */     // GIR_Coverage, 23759,
     /*  920875 */     GIR_EraseRootFromParent_Done,
     /*  920876 */   // Label 13983: @920876
     /*  920876 */   GIM_Try, /*On fail goto*//*Label 13984*/ GIMT_Encode4(920964), // Rule ID 23762 //
     /*  920881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  920892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  920895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  920898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920928 */     // MIs[1] Operand 1
     /*  920928 */     // No operand predicates
     /*  920928 */     // MIs[0] policy
     /*  920928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920940 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  920943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920962 */     GIR_RootConstrainSelectedInstOperands,
     /*  920963 */     // GIR_Coverage, 23762,
     /*  920963 */     GIR_EraseRootFromParent_Done,
     /*  920964 */   // Label 13984: @920964
     /*  920964 */   GIM_Try, /*On fail goto*//*Label 13985*/ GIMT_Encode4(921052), // Rule ID 23763 //
     /*  920969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  920980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  920983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  920986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921016 */     // MIs[1] Operand 1
     /*  921016 */     // No operand predicates
     /*  921016 */     // MIs[0] policy
     /*  921016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921028 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  921031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921050 */     GIR_RootConstrainSelectedInstOperands,
     /*  921051 */     // GIR_Coverage, 23763,
     /*  921051 */     GIR_EraseRootFromParent_Done,
     /*  921052 */   // Label 13985: @921052
     /*  921052 */   GIM_Try, /*On fail goto*//*Label 13986*/ GIMT_Encode4(921140), // Rule ID 23766 //
     /*  921057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  921068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  921071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  921074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921104 */     // MIs[1] Operand 1
     /*  921104 */     // No operand predicates
     /*  921104 */     // MIs[0] policy
     /*  921104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921116 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  921119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921138 */     GIR_RootConstrainSelectedInstOperands,
     /*  921139 */     // GIR_Coverage, 23766,
     /*  921139 */     GIR_EraseRootFromParent_Done,
     /*  921140 */   // Label 13986: @921140
     /*  921140 */   GIM_Try, /*On fail goto*//*Label 13987*/ GIMT_Encode4(921228), // Rule ID 23767 //
     /*  921145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  921156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  921159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  921162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921192 */     // MIs[1] Operand 1
     /*  921192 */     // No operand predicates
     /*  921192 */     // MIs[0] policy
     /*  921192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921204 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  921207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921226 */     GIR_RootConstrainSelectedInstOperands,
     /*  921227 */     // GIR_Coverage, 23767,
     /*  921227 */     GIR_EraseRootFromParent_Done,
     /*  921228 */   // Label 13987: @921228
     /*  921228 */   GIM_Try, /*On fail goto*//*Label 13988*/ GIMT_Encode4(921316), // Rule ID 23770 //
     /*  921233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  921244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  921247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  921250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921280 */     // MIs[1] Operand 1
     /*  921280 */     // No operand predicates
     /*  921280 */     // MIs[0] policy
     /*  921280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921292 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  921295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921314 */     GIR_RootConstrainSelectedInstOperands,
     /*  921315 */     // GIR_Coverage, 23770,
     /*  921315 */     GIR_EraseRootFromParent_Done,
     /*  921316 */   // Label 13988: @921316
     /*  921316 */   GIM_Try, /*On fail goto*//*Label 13989*/ GIMT_Encode4(921404), // Rule ID 23771 //
     /*  921321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  921332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  921335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  921338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921368 */     // MIs[1] Operand 1
     /*  921368 */     // No operand predicates
     /*  921368 */     // MIs[0] policy
     /*  921368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921380 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  921383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921402 */     GIR_RootConstrainSelectedInstOperands,
     /*  921403 */     // GIR_Coverage, 23771,
     /*  921403 */     GIR_EraseRootFromParent_Done,
     /*  921404 */   // Label 13989: @921404
     /*  921404 */   GIM_Try, /*On fail goto*//*Label 13990*/ GIMT_Encode4(921492), // Rule ID 23774 //
     /*  921409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  921420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  921423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  921426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921456 */     // MIs[1] Operand 1
     /*  921456 */     // No operand predicates
     /*  921456 */     // MIs[0] policy
     /*  921456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  921471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921490 */     GIR_RootConstrainSelectedInstOperands,
     /*  921491 */     // GIR_Coverage, 23774,
     /*  921491 */     GIR_EraseRootFromParent_Done,
     /*  921492 */   // Label 13990: @921492
     /*  921492 */   GIM_Try, /*On fail goto*//*Label 13991*/ GIMT_Encode4(921580), // Rule ID 23775 //
     /*  921497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  921508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  921511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  921514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921544 */     // MIs[1] Operand 1
     /*  921544 */     // No operand predicates
     /*  921544 */     // MIs[0] policy
     /*  921544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921556 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  921559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921578 */     GIR_RootConstrainSelectedInstOperands,
     /*  921579 */     // GIR_Coverage, 23775,
     /*  921579 */     GIR_EraseRootFromParent_Done,
     /*  921580 */   // Label 13991: @921580
     /*  921580 */   GIM_Try, /*On fail goto*//*Label 13992*/ GIMT_Encode4(921668), // Rule ID 23866 //
     /*  921585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  921596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  921599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  921602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921632 */     // MIs[1] Operand 1
     /*  921632 */     // No operand predicates
     /*  921632 */     // MIs[0] policy
     /*  921632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921644 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  921647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  921664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921666 */     GIR_RootConstrainSelectedInstOperands,
     /*  921667 */     // GIR_Coverage, 23866,
     /*  921667 */     GIR_EraseRootFromParent_Done,
     /*  921668 */   // Label 13992: @921668
     /*  921668 */   GIM_Try, /*On fail goto*//*Label 13993*/ GIMT_Encode4(921756), // Rule ID 23867 //
     /*  921673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  921684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  921687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  921690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921720 */     // MIs[1] Operand 1
     /*  921720 */     // No operand predicates
     /*  921720 */     // MIs[0] policy
     /*  921720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921732 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  921735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  921752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921754 */     GIR_RootConstrainSelectedInstOperands,
     /*  921755 */     // GIR_Coverage, 23867,
     /*  921755 */     GIR_EraseRootFromParent_Done,
     /*  921756 */   // Label 13993: @921756
     /*  921756 */   GIM_Try, /*On fail goto*//*Label 13994*/ GIMT_Encode4(921844), // Rule ID 23870 //
     /*  921761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  921772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  921775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  921778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921808 */     // MIs[1] Operand 1
     /*  921808 */     // No operand predicates
     /*  921808 */     // MIs[0] policy
     /*  921808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921820 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  921823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  921840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921842 */     GIR_RootConstrainSelectedInstOperands,
     /*  921843 */     // GIR_Coverage, 23870,
     /*  921843 */     GIR_EraseRootFromParent_Done,
     /*  921844 */   // Label 13994: @921844
     /*  921844 */   GIM_Try, /*On fail goto*//*Label 13995*/ GIMT_Encode4(921932), // Rule ID 23871 //
     /*  921849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  921860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  921863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  921866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921896 */     // MIs[1] Operand 1
     /*  921896 */     // No operand predicates
     /*  921896 */     // MIs[0] policy
     /*  921896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921908 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  921911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  921928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921930 */     GIR_RootConstrainSelectedInstOperands,
     /*  921931 */     // GIR_Coverage, 23871,
     /*  921931 */     GIR_EraseRootFromParent_Done,
     /*  921932 */   // Label 13995: @921932
     /*  921932 */   GIM_Try, /*On fail goto*//*Label 13996*/ GIMT_Encode4(922020), // Rule ID 23874 //
     /*  921937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  921948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  921951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  921954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921984 */     // MIs[1] Operand 1
     /*  921984 */     // No operand predicates
     /*  921984 */     // MIs[0] policy
     /*  921984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921996 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  921999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922018 */     GIR_RootConstrainSelectedInstOperands,
     /*  922019 */     // GIR_Coverage, 23874,
     /*  922019 */     GIR_EraseRootFromParent_Done,
     /*  922020 */   // Label 13996: @922020
     /*  922020 */   GIM_Try, /*On fail goto*//*Label 13997*/ GIMT_Encode4(922108), // Rule ID 23875 //
     /*  922025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  922036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  922039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  922042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922072 */     // MIs[1] Operand 1
     /*  922072 */     // No operand predicates
     /*  922072 */     // MIs[0] policy
     /*  922072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922084 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  922087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922106 */     GIR_RootConstrainSelectedInstOperands,
     /*  922107 */     // GIR_Coverage, 23875,
     /*  922107 */     GIR_EraseRootFromParent_Done,
     /*  922108 */   // Label 13997: @922108
     /*  922108 */   GIM_Try, /*On fail goto*//*Label 13998*/ GIMT_Encode4(922196), // Rule ID 23878 //
     /*  922113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  922124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  922127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  922130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922160 */     // MIs[1] Operand 1
     /*  922160 */     // No operand predicates
     /*  922160 */     // MIs[0] policy
     /*  922160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922172 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  922175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922194 */     GIR_RootConstrainSelectedInstOperands,
     /*  922195 */     // GIR_Coverage, 23878,
     /*  922195 */     GIR_EraseRootFromParent_Done,
     /*  922196 */   // Label 13998: @922196
     /*  922196 */   GIM_Try, /*On fail goto*//*Label 13999*/ GIMT_Encode4(922284), // Rule ID 23879 //
     /*  922201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  922212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  922215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  922218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922244 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922248 */     // MIs[1] Operand 1
     /*  922248 */     // No operand predicates
     /*  922248 */     // MIs[0] policy
     /*  922248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922260 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  922263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922282 */     GIR_RootConstrainSelectedInstOperands,
     /*  922283 */     // GIR_Coverage, 23879,
     /*  922283 */     GIR_EraseRootFromParent_Done,
     /*  922284 */   // Label 13999: @922284
     /*  922284 */   GIM_Try, /*On fail goto*//*Label 14000*/ GIMT_Encode4(922372), // Rule ID 23882 //
     /*  922289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  922300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  922303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  922306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922336 */     // MIs[1] Operand 1
     /*  922336 */     // No operand predicates
     /*  922336 */     // MIs[0] policy
     /*  922336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922348 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  922351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922370 */     GIR_RootConstrainSelectedInstOperands,
     /*  922371 */     // GIR_Coverage, 23882,
     /*  922371 */     GIR_EraseRootFromParent_Done,
     /*  922372 */   // Label 14000: @922372
     /*  922372 */   GIM_Try, /*On fail goto*//*Label 14001*/ GIMT_Encode4(922460), // Rule ID 23883 //
     /*  922377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  922388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  922391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  922394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922424 */     // MIs[1] Operand 1
     /*  922424 */     // No operand predicates
     /*  922424 */     // MIs[0] policy
     /*  922424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922436 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  922439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922458 */     GIR_RootConstrainSelectedInstOperands,
     /*  922459 */     // GIR_Coverage, 23883,
     /*  922459 */     GIR_EraseRootFromParent_Done,
     /*  922460 */   // Label 14001: @922460
     /*  922460 */   GIM_Try, /*On fail goto*//*Label 14002*/ GIMT_Encode4(922548), // Rule ID 23886 //
     /*  922465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  922476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  922479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  922482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922512 */     // MIs[1] Operand 1
     /*  922512 */     // No operand predicates
     /*  922512 */     // MIs[0] policy
     /*  922512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922524 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  922527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922546 */     GIR_RootConstrainSelectedInstOperands,
     /*  922547 */     // GIR_Coverage, 23886,
     /*  922547 */     GIR_EraseRootFromParent_Done,
     /*  922548 */   // Label 14002: @922548
     /*  922548 */   GIM_Try, /*On fail goto*//*Label 14003*/ GIMT_Encode4(922636), // Rule ID 23887 //
     /*  922553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  922564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  922567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  922570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922600 */     // MIs[1] Operand 1
     /*  922600 */     // No operand predicates
     /*  922600 */     // MIs[0] policy
     /*  922600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922612 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  922615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922634 */     GIR_RootConstrainSelectedInstOperands,
     /*  922635 */     // GIR_Coverage, 23887,
     /*  922635 */     GIR_EraseRootFromParent_Done,
     /*  922636 */   // Label 14003: @922636
     /*  922636 */   GIM_Try, /*On fail goto*//*Label 14004*/ GIMT_Encode4(922724), // Rule ID 23890 //
     /*  922641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  922652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  922655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  922658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922688 */     // MIs[1] Operand 1
     /*  922688 */     // No operand predicates
     /*  922688 */     // MIs[0] policy
     /*  922688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922700 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  922703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922722 */     GIR_RootConstrainSelectedInstOperands,
     /*  922723 */     // GIR_Coverage, 23890,
     /*  922723 */     GIR_EraseRootFromParent_Done,
     /*  922724 */   // Label 14004: @922724
     /*  922724 */   GIM_Try, /*On fail goto*//*Label 14005*/ GIMT_Encode4(922812), // Rule ID 23891 //
     /*  922729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  922740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  922743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  922746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922776 */     // MIs[1] Operand 1
     /*  922776 */     // No operand predicates
     /*  922776 */     // MIs[0] policy
     /*  922776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922788 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  922791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922810 */     GIR_RootConstrainSelectedInstOperands,
     /*  922811 */     // GIR_Coverage, 23891,
     /*  922811 */     GIR_EraseRootFromParent_Done,
     /*  922812 */   // Label 14005: @922812
     /*  922812 */   GIM_Try, /*On fail goto*//*Label 14006*/ GIMT_Encode4(922900), // Rule ID 23894 //
     /*  922817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  922828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  922831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  922834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922864 */     // MIs[1] Operand 1
     /*  922864 */     // No operand predicates
     /*  922864 */     // MIs[0] policy
     /*  922864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  922879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922898 */     GIR_RootConstrainSelectedInstOperands,
     /*  922899 */     // GIR_Coverage, 23894,
     /*  922899 */     GIR_EraseRootFromParent_Done,
     /*  922900 */   // Label 14006: @922900
     /*  922900 */   GIM_Try, /*On fail goto*//*Label 14007*/ GIMT_Encode4(922988), // Rule ID 23895 //
     /*  922905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  922916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  922919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  922922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922952 */     // MIs[1] Operand 1
     /*  922952 */     // No operand predicates
     /*  922952 */     // MIs[0] policy
     /*  922952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922964 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  922967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922986 */     GIR_RootConstrainSelectedInstOperands,
     /*  922987 */     // GIR_Coverage, 23895,
     /*  922987 */     GIR_EraseRootFromParent_Done,
     /*  922988 */   // Label 14007: @922988
     /*  922988 */   GIM_Try, /*On fail goto*//*Label 14008*/ GIMT_Encode4(923076), // Rule ID 23898 //
     /*  922993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  923004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  923007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  923010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923040 */     // MIs[1] Operand 1
     /*  923040 */     // No operand predicates
     /*  923040 */     // MIs[0] policy
     /*  923040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  923055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923074 */     GIR_RootConstrainSelectedInstOperands,
     /*  923075 */     // GIR_Coverage, 23898,
     /*  923075 */     GIR_EraseRootFromParent_Done,
     /*  923076 */   // Label 14008: @923076
     /*  923076 */   GIM_Try, /*On fail goto*//*Label 14009*/ GIMT_Encode4(923164), // Rule ID 23899 //
     /*  923081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  923092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  923095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  923098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923128 */     // MIs[1] Operand 1
     /*  923128 */     // No operand predicates
     /*  923128 */     // MIs[0] policy
     /*  923128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923140 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  923143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923162 */     GIR_RootConstrainSelectedInstOperands,
     /*  923163 */     // GIR_Coverage, 23899,
     /*  923163 */     GIR_EraseRootFromParent_Done,
     /*  923164 */   // Label 14009: @923164
     /*  923164 */   GIM_Try, /*On fail goto*//*Label 14010*/ GIMT_Encode4(923252), // Rule ID 23902 //
     /*  923169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  923172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  923180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  923183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  923186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923216 */     // MIs[1] Operand 1
     /*  923216 */     // No operand predicates
     /*  923216 */     // MIs[0] policy
     /*  923216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923228 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  923231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923250 */     GIR_RootConstrainSelectedInstOperands,
     /*  923251 */     // GIR_Coverage, 23902,
     /*  923251 */     GIR_EraseRootFromParent_Done,
     /*  923252 */   // Label 14010: @923252
     /*  923252 */   GIM_Try, /*On fail goto*//*Label 14011*/ GIMT_Encode4(923340), // Rule ID 23903 //
     /*  923257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  923260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  923268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  923271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  923274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923304 */     // MIs[1] Operand 1
     /*  923304 */     // No operand predicates
     /*  923304 */     // MIs[0] policy
     /*  923304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  923319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923338 */     GIR_RootConstrainSelectedInstOperands,
     /*  923339 */     // GIR_Coverage, 23903,
     /*  923339 */     GIR_EraseRootFromParent_Done,
     /*  923340 */   // Label 14011: @923340
     /*  923340 */   GIM_Try, /*On fail goto*//*Label 14012*/ GIMT_Encode4(923428), // Rule ID 23906 //
     /*  923345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  923356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  923359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  923362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923392 */     // MIs[1] Operand 1
     /*  923392 */     // No operand predicates
     /*  923392 */     // MIs[0] policy
     /*  923392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923404 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  923407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923426 */     GIR_RootConstrainSelectedInstOperands,
     /*  923427 */     // GIR_Coverage, 23906,
     /*  923427 */     GIR_EraseRootFromParent_Done,
     /*  923428 */   // Label 14012: @923428
     /*  923428 */   GIM_Try, /*On fail goto*//*Label 14013*/ GIMT_Encode4(923516), // Rule ID 23907 //
     /*  923433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  923444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  923447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  923450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923480 */     // MIs[1] Operand 1
     /*  923480 */     // No operand predicates
     /*  923480 */     // MIs[0] policy
     /*  923480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923492 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  923495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923514 */     GIR_RootConstrainSelectedInstOperands,
     /*  923515 */     // GIR_Coverage, 23907,
     /*  923515 */     GIR_EraseRootFromParent_Done,
     /*  923516 */   // Label 14013: @923516
     /*  923516 */   GIM_Try, /*On fail goto*//*Label 14014*/ GIMT_Encode4(923604), // Rule ID 23910 //
     /*  923521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  923532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  923535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  923538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923568 */     // MIs[1] Operand 1
     /*  923568 */     // No operand predicates
     /*  923568 */     // MIs[0] policy
     /*  923568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923580 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  923583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923602 */     GIR_RootConstrainSelectedInstOperands,
     /*  923603 */     // GIR_Coverage, 23910,
     /*  923603 */     GIR_EraseRootFromParent_Done,
     /*  923604 */   // Label 14014: @923604
     /*  923604 */   GIM_Try, /*On fail goto*//*Label 14015*/ GIMT_Encode4(923692), // Rule ID 23911 //
     /*  923609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  923620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  923623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  923626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923656 */     // MIs[1] Operand 1
     /*  923656 */     // No operand predicates
     /*  923656 */     // MIs[0] policy
     /*  923656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923668 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  923671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923690 */     GIR_RootConstrainSelectedInstOperands,
     /*  923691 */     // GIR_Coverage, 23911,
     /*  923691 */     GIR_EraseRootFromParent_Done,
     /*  923692 */   // Label 14015: @923692
     /*  923692 */   GIM_Try, /*On fail goto*//*Label 14016*/ GIMT_Encode4(923780), // Rule ID 23914 //
     /*  923697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  923708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  923711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  923714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923744 */     // MIs[1] Operand 1
     /*  923744 */     // No operand predicates
     /*  923744 */     // MIs[0] policy
     /*  923744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923756 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  923759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923778 */     GIR_RootConstrainSelectedInstOperands,
     /*  923779 */     // GIR_Coverage, 23914,
     /*  923779 */     GIR_EraseRootFromParent_Done,
     /*  923780 */   // Label 14016: @923780
     /*  923780 */   GIM_Try, /*On fail goto*//*Label 14017*/ GIMT_Encode4(923868), // Rule ID 23915 //
     /*  923785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  923796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  923799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  923802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923832 */     // MIs[1] Operand 1
     /*  923832 */     // No operand predicates
     /*  923832 */     // MIs[0] policy
     /*  923832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923844 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  923847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923866 */     GIR_RootConstrainSelectedInstOperands,
     /*  923867 */     // GIR_Coverage, 23915,
     /*  923867 */     GIR_EraseRootFromParent_Done,
     /*  923868 */   // Label 14017: @923868
     /*  923868 */   GIM_Try, /*On fail goto*//*Label 14018*/ GIMT_Encode4(923956), // Rule ID 23918 //
     /*  923873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  923884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  923887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  923890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923920 */     // MIs[1] Operand 1
     /*  923920 */     // No operand predicates
     /*  923920 */     // MIs[0] policy
     /*  923920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923932 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  923935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923954 */     GIR_RootConstrainSelectedInstOperands,
     /*  923955 */     // GIR_Coverage, 23918,
     /*  923955 */     GIR_EraseRootFromParent_Done,
     /*  923956 */   // Label 14018: @923956
     /*  923956 */   GIM_Try, /*On fail goto*//*Label 14019*/ GIMT_Encode4(924044), // Rule ID 23919 //
     /*  923961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  923972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  923975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  923978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924008 */     // MIs[1] Operand 1
     /*  924008 */     // No operand predicates
     /*  924008 */     // MIs[0] policy
     /*  924008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  924023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924042 */     GIR_RootConstrainSelectedInstOperands,
     /*  924043 */     // GIR_Coverage, 23919,
     /*  924043 */     GIR_EraseRootFromParent_Done,
     /*  924044 */   // Label 14019: @924044
     /*  924044 */   GIM_Try, /*On fail goto*//*Label 14020*/ GIMT_Encode4(924132), // Rule ID 23922 //
     /*  924049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  924060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  924063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  924066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924096 */     // MIs[1] Operand 1
     /*  924096 */     // No operand predicates
     /*  924096 */     // MIs[0] policy
     /*  924096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924108 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  924111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924130 */     GIR_RootConstrainSelectedInstOperands,
     /*  924131 */     // GIR_Coverage, 23922,
     /*  924131 */     GIR_EraseRootFromParent_Done,
     /*  924132 */   // Label 14020: @924132
     /*  924132 */   GIM_Try, /*On fail goto*//*Label 14021*/ GIMT_Encode4(924220), // Rule ID 23923 //
     /*  924137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  924148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  924151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  924154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924184 */     // MIs[1] Operand 1
     /*  924184 */     // No operand predicates
     /*  924184 */     // MIs[0] policy
     /*  924184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924196 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  924199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924218 */     GIR_RootConstrainSelectedInstOperands,
     /*  924219 */     // GIR_Coverage, 23923,
     /*  924219 */     GIR_EraseRootFromParent_Done,
     /*  924220 */   // Label 14021: @924220
     /*  924220 */   GIM_Try, /*On fail goto*//*Label 14022*/ GIMT_Encode4(924308), // Rule ID 23926 //
     /*  924225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  924236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  924239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  924242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924272 */     // MIs[1] Operand 1
     /*  924272 */     // No operand predicates
     /*  924272 */     // MIs[0] policy
     /*  924272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924284 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  924287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924306 */     GIR_RootConstrainSelectedInstOperands,
     /*  924307 */     // GIR_Coverage, 23926,
     /*  924307 */     GIR_EraseRootFromParent_Done,
     /*  924308 */   // Label 14022: @924308
     /*  924308 */   GIM_Try, /*On fail goto*//*Label 14023*/ GIMT_Encode4(924396), // Rule ID 23927 //
     /*  924313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  924324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  924327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  924330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924360 */     // MIs[1] Operand 1
     /*  924360 */     // No operand predicates
     /*  924360 */     // MIs[0] policy
     /*  924360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924372 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  924375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924394 */     GIR_RootConstrainSelectedInstOperands,
     /*  924395 */     // GIR_Coverage, 23927,
     /*  924395 */     GIR_EraseRootFromParent_Done,
     /*  924396 */   // Label 14023: @924396
     /*  924396 */   GIM_Try, /*On fail goto*//*Label 14024*/ GIMT_Encode4(924484), // Rule ID 23930 //
     /*  924401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  924412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  924415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  924418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924448 */     // MIs[1] Operand 1
     /*  924448 */     // No operand predicates
     /*  924448 */     // MIs[0] policy
     /*  924448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924460 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  924463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924482 */     GIR_RootConstrainSelectedInstOperands,
     /*  924483 */     // GIR_Coverage, 23930,
     /*  924483 */     GIR_EraseRootFromParent_Done,
     /*  924484 */   // Label 14024: @924484
     /*  924484 */   GIM_Try, /*On fail goto*//*Label 14025*/ GIMT_Encode4(924572), // Rule ID 23931 //
     /*  924489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  924500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  924503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  924506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924536 */     // MIs[1] Operand 1
     /*  924536 */     // No operand predicates
     /*  924536 */     // MIs[0] policy
     /*  924536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924548 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  924551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924570 */     GIR_RootConstrainSelectedInstOperands,
     /*  924571 */     // GIR_Coverage, 23931,
     /*  924571 */     GIR_EraseRootFromParent_Done,
     /*  924572 */   // Label 14025: @924572
     /*  924572 */   GIM_Try, /*On fail goto*//*Label 14026*/ GIMT_Encode4(924660), // Rule ID 23934 //
     /*  924577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  924588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  924591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  924594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924624 */     // MIs[1] Operand 1
     /*  924624 */     // No operand predicates
     /*  924624 */     // MIs[0] policy
     /*  924624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924636 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  924639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924658 */     GIR_RootConstrainSelectedInstOperands,
     /*  924659 */     // GIR_Coverage, 23934,
     /*  924659 */     GIR_EraseRootFromParent_Done,
     /*  924660 */   // Label 14026: @924660
     /*  924660 */   GIM_Try, /*On fail goto*//*Label 14027*/ GIMT_Encode4(924748), // Rule ID 23935 //
     /*  924665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  924676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  924679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  924682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924712 */     // MIs[1] Operand 1
     /*  924712 */     // No operand predicates
     /*  924712 */     // MIs[0] policy
     /*  924712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924724 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  924727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924746 */     GIR_RootConstrainSelectedInstOperands,
     /*  924747 */     // GIR_Coverage, 23935,
     /*  924747 */     GIR_EraseRootFromParent_Done,
     /*  924748 */   // Label 14027: @924748
     /*  924748 */   GIM_Try, /*On fail goto*//*Label 14028*/ GIMT_Encode4(924836), // Rule ID 23938 //
     /*  924753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  924764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  924767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  924770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924800 */     // MIs[1] Operand 1
     /*  924800 */     // No operand predicates
     /*  924800 */     // MIs[0] policy
     /*  924800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924812 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  924815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924834 */     GIR_RootConstrainSelectedInstOperands,
     /*  924835 */     // GIR_Coverage, 23938,
     /*  924835 */     GIR_EraseRootFromParent_Done,
     /*  924836 */   // Label 14028: @924836
     /*  924836 */   GIM_Try, /*On fail goto*//*Label 14029*/ GIMT_Encode4(924924), // Rule ID 23939 //
     /*  924841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  924852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  924855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  924858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924888 */     // MIs[1] Operand 1
     /*  924888 */     // No operand predicates
     /*  924888 */     // MIs[0] policy
     /*  924888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924900 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  924903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924922 */     GIR_RootConstrainSelectedInstOperands,
     /*  924923 */     // GIR_Coverage, 23939,
     /*  924923 */     GIR_EraseRootFromParent_Done,
     /*  924924 */   // Label 14029: @924924
     /*  924924 */   GIM_Try, /*On fail goto*//*Label 14030*/ GIMT_Encode4(925012), // Rule ID 23942 //
     /*  924929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  924932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  924940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  924943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  924946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924976 */     // MIs[1] Operand 1
     /*  924976 */     // No operand predicates
     /*  924976 */     // MIs[0] policy
     /*  924976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924988 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  924991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925010 */     GIR_RootConstrainSelectedInstOperands,
     /*  925011 */     // GIR_Coverage, 23942,
     /*  925011 */     GIR_EraseRootFromParent_Done,
     /*  925012 */   // Label 14030: @925012
     /*  925012 */   GIM_Try, /*On fail goto*//*Label 14031*/ GIMT_Encode4(925100), // Rule ID 23943 //
     /*  925017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  925020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  925028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  925031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  925034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925064 */     // MIs[1] Operand 1
     /*  925064 */     // No operand predicates
     /*  925064 */     // MIs[0] policy
     /*  925064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925098 */     GIR_RootConstrainSelectedInstOperands,
     /*  925099 */     // GIR_Coverage, 23943,
     /*  925099 */     GIR_EraseRootFromParent_Done,
     /*  925100 */   // Label 14031: @925100
     /*  925100 */   GIM_Try, /*On fail goto*//*Label 14032*/ GIMT_Encode4(925188), // Rule ID 23946 //
     /*  925105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  925108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  925116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  925119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  925122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925152 */     // MIs[1] Operand 1
     /*  925152 */     // No operand predicates
     /*  925152 */     // MIs[0] policy
     /*  925152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925164 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  925167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925186 */     GIR_RootConstrainSelectedInstOperands,
     /*  925187 */     // GIR_Coverage, 23946,
     /*  925187 */     GIR_EraseRootFromParent_Done,
     /*  925188 */   // Label 14032: @925188
     /*  925188 */   GIM_Try, /*On fail goto*//*Label 14033*/ GIMT_Encode4(925276), // Rule ID 23947 //
     /*  925193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  925196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  925204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  925207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  925210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925240 */     // MIs[1] Operand 1
     /*  925240 */     // No operand predicates
     /*  925240 */     // MIs[0] policy
     /*  925240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925252 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  925255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925274 */     GIR_RootConstrainSelectedInstOperands,
     /*  925275 */     // GIR_Coverage, 23947,
     /*  925275 */     GIR_EraseRootFromParent_Done,
     /*  925276 */   // Label 14033: @925276
     /*  925276 */   GIM_Try, /*On fail goto*//*Label 14034*/ GIMT_Encode4(925364), // Rule ID 23950 //
     /*  925281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  925284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  925292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  925295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  925298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925328 */     // MIs[1] Operand 1
     /*  925328 */     // No operand predicates
     /*  925328 */     // MIs[0] policy
     /*  925328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925340 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  925343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925362 */     GIR_RootConstrainSelectedInstOperands,
     /*  925363 */     // GIR_Coverage, 23950,
     /*  925363 */     GIR_EraseRootFromParent_Done,
     /*  925364 */   // Label 14034: @925364
     /*  925364 */   GIM_Try, /*On fail goto*//*Label 14035*/ GIMT_Encode4(925452), // Rule ID 23951 //
     /*  925369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  925372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  925380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  925383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  925386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925416 */     // MIs[1] Operand 1
     /*  925416 */     // No operand predicates
     /*  925416 */     // MIs[0] policy
     /*  925416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925428 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  925431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925450 */     GIR_RootConstrainSelectedInstOperands,
     /*  925451 */     // GIR_Coverage, 23951,
     /*  925451 */     GIR_EraseRootFromParent_Done,
     /*  925452 */   // Label 14035: @925452
     /*  925452 */   GIM_Try, /*On fail goto*//*Label 14036*/ GIMT_Encode4(925540), // Rule ID 24190 //
     /*  925457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  925460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  925468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  925471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  925474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925504 */     // MIs[1] Operand 1
     /*  925504 */     // No operand predicates
     /*  925504 */     // MIs[0] policy
     /*  925504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925516 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  925519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925538 */     GIR_RootConstrainSelectedInstOperands,
     /*  925539 */     // GIR_Coverage, 24190,
     /*  925539 */     GIR_EraseRootFromParent_Done,
     /*  925540 */   // Label 14036: @925540
     /*  925540 */   GIM_Try, /*On fail goto*//*Label 14037*/ GIMT_Encode4(925628), // Rule ID 24191 //
     /*  925545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  925548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  925556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  925559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  925562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925592 */     // MIs[1] Operand 1
     /*  925592 */     // No operand predicates
     /*  925592 */     // MIs[0] policy
     /*  925592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925604 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  925607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925626 */     GIR_RootConstrainSelectedInstOperands,
     /*  925627 */     // GIR_Coverage, 24191,
     /*  925627 */     GIR_EraseRootFromParent_Done,
     /*  925628 */   // Label 14037: @925628
     /*  925628 */   GIM_Try, /*On fail goto*//*Label 14038*/ GIMT_Encode4(925716), // Rule ID 24194 //
     /*  925633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  925636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  925644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  925647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  925650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925680 */     // MIs[1] Operand 1
     /*  925680 */     // No operand predicates
     /*  925680 */     // MIs[0] policy
     /*  925680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925692 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  925695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925714 */     GIR_RootConstrainSelectedInstOperands,
     /*  925715 */     // GIR_Coverage, 24194,
     /*  925715 */     GIR_EraseRootFromParent_Done,
     /*  925716 */   // Label 14038: @925716
     /*  925716 */   GIM_Try, /*On fail goto*//*Label 14039*/ GIMT_Encode4(925804), // Rule ID 24195 //
     /*  925721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  925724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  925732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  925735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  925738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925768 */     // MIs[1] Operand 1
     /*  925768 */     // No operand predicates
     /*  925768 */     // MIs[0] policy
     /*  925768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925780 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  925783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925802 */     GIR_RootConstrainSelectedInstOperands,
     /*  925803 */     // GIR_Coverage, 24195,
     /*  925803 */     GIR_EraseRootFromParent_Done,
     /*  925804 */   // Label 14039: @925804
     /*  925804 */   GIM_Try, /*On fail goto*//*Label 14040*/ GIMT_Encode4(925892), // Rule ID 24198 //
     /*  925809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  925812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  925820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  925823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  925826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925856 */     // MIs[1] Operand 1
     /*  925856 */     // No operand predicates
     /*  925856 */     // MIs[0] policy
     /*  925856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925868 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  925871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925890 */     GIR_RootConstrainSelectedInstOperands,
     /*  925891 */     // GIR_Coverage, 24198,
     /*  925891 */     GIR_EraseRootFromParent_Done,
     /*  925892 */   // Label 14040: @925892
     /*  925892 */   GIM_Try, /*On fail goto*//*Label 14041*/ GIMT_Encode4(925980), // Rule ID 24199 //
     /*  925897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  925900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  925908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  925911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  925914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925944 */     // MIs[1] Operand 1
     /*  925944 */     // No operand predicates
     /*  925944 */     // MIs[0] policy
     /*  925944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925956 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  925959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925978 */     GIR_RootConstrainSelectedInstOperands,
     /*  925979 */     // GIR_Coverage, 24199,
     /*  925979 */     GIR_EraseRootFromParent_Done,
     /*  925980 */   // Label 14041: @925980
     /*  925980 */   GIM_Try, /*On fail goto*//*Label 14042*/ GIMT_Encode4(926068), // Rule ID 24202 //
     /*  925985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  925988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  925996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  925999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  926002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926032 */     // MIs[1] Operand 1
     /*  926032 */     // No operand predicates
     /*  926032 */     // MIs[0] policy
     /*  926032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926044 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  926047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926066 */     GIR_RootConstrainSelectedInstOperands,
     /*  926067 */     // GIR_Coverage, 24202,
     /*  926067 */     GIR_EraseRootFromParent_Done,
     /*  926068 */   // Label 14042: @926068
     /*  926068 */   GIM_Try, /*On fail goto*//*Label 14043*/ GIMT_Encode4(926156), // Rule ID 24203 //
     /*  926073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  926076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  926084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  926087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  926090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926120 */     // MIs[1] Operand 1
     /*  926120 */     // No operand predicates
     /*  926120 */     // MIs[0] policy
     /*  926120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926132 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  926135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926154 */     GIR_RootConstrainSelectedInstOperands,
     /*  926155 */     // GIR_Coverage, 24203,
     /*  926155 */     GIR_EraseRootFromParent_Done,
     /*  926156 */   // Label 14043: @926156
     /*  926156 */   GIM_Try, /*On fail goto*//*Label 14044*/ GIMT_Encode4(926244), // Rule ID 24206 //
     /*  926161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  926164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  926172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  926175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  926178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926208 */     // MIs[1] Operand 1
     /*  926208 */     // No operand predicates
     /*  926208 */     // MIs[0] policy
     /*  926208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926220 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  926223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926242 */     GIR_RootConstrainSelectedInstOperands,
     /*  926243 */     // GIR_Coverage, 24206,
     /*  926243 */     GIR_EraseRootFromParent_Done,
     /*  926244 */   // Label 14044: @926244
     /*  926244 */   GIM_Try, /*On fail goto*//*Label 14045*/ GIMT_Encode4(926332), // Rule ID 24207 //
     /*  926249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  926252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  926260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  926263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  926266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926296 */     // MIs[1] Operand 1
     /*  926296 */     // No operand predicates
     /*  926296 */     // MIs[0] policy
     /*  926296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926308 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  926311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926330 */     GIR_RootConstrainSelectedInstOperands,
     /*  926331 */     // GIR_Coverage, 24207,
     /*  926331 */     GIR_EraseRootFromParent_Done,
     /*  926332 */   // Label 14045: @926332
     /*  926332 */   GIM_Try, /*On fail goto*//*Label 14046*/ GIMT_Encode4(926420), // Rule ID 24210 //
     /*  926337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  926340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  926348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  926351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  926354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926384 */     // MIs[1] Operand 1
     /*  926384 */     // No operand predicates
     /*  926384 */     // MIs[0] policy
     /*  926384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926396 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  926399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926418 */     GIR_RootConstrainSelectedInstOperands,
     /*  926419 */     // GIR_Coverage, 24210,
     /*  926419 */     GIR_EraseRootFromParent_Done,
     /*  926420 */   // Label 14046: @926420
     /*  926420 */   GIM_Try, /*On fail goto*//*Label 14047*/ GIMT_Encode4(926508), // Rule ID 24211 //
     /*  926425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  926428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  926436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  926439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  926442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926472 */     // MIs[1] Operand 1
     /*  926472 */     // No operand predicates
     /*  926472 */     // MIs[0] policy
     /*  926472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926484 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  926487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926506 */     GIR_RootConstrainSelectedInstOperands,
     /*  926507 */     // GIR_Coverage, 24211,
     /*  926507 */     GIR_EraseRootFromParent_Done,
     /*  926508 */   // Label 14047: @926508
     /*  926508 */   GIM_Try, /*On fail goto*//*Label 14048*/ GIMT_Encode4(926596), // Rule ID 24214 //
     /*  926513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  926516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  926524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  926527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  926530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926560 */     // MIs[1] Operand 1
     /*  926560 */     // No operand predicates
     /*  926560 */     // MIs[0] policy
     /*  926560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926572 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  926575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926594 */     GIR_RootConstrainSelectedInstOperands,
     /*  926595 */     // GIR_Coverage, 24214,
     /*  926595 */     GIR_EraseRootFromParent_Done,
     /*  926596 */   // Label 14048: @926596
     /*  926596 */   GIM_Try, /*On fail goto*//*Label 14049*/ GIMT_Encode4(926684), // Rule ID 24215 //
     /*  926601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  926604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  926612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  926615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  926618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926648 */     // MIs[1] Operand 1
     /*  926648 */     // No operand predicates
     /*  926648 */     // MIs[0] policy
     /*  926648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926660 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  926663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926682 */     GIR_RootConstrainSelectedInstOperands,
     /*  926683 */     // GIR_Coverage, 24215,
     /*  926683 */     GIR_EraseRootFromParent_Done,
     /*  926684 */   // Label 14049: @926684
     /*  926684 */   GIM_Try, /*On fail goto*//*Label 14050*/ GIMT_Encode4(926772), // Rule ID 24218 //
     /*  926689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  926692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  926700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  926703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  926706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926736 */     // MIs[1] Operand 1
     /*  926736 */     // No operand predicates
     /*  926736 */     // MIs[0] policy
     /*  926736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926748 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  926751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926770 */     GIR_RootConstrainSelectedInstOperands,
     /*  926771 */     // GIR_Coverage, 24218,
     /*  926771 */     GIR_EraseRootFromParent_Done,
     /*  926772 */   // Label 14050: @926772
     /*  926772 */   GIM_Try, /*On fail goto*//*Label 14051*/ GIMT_Encode4(926860), // Rule ID 24219 //
     /*  926777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  926780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  926788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  926791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  926794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926824 */     // MIs[1] Operand 1
     /*  926824 */     // No operand predicates
     /*  926824 */     // MIs[0] policy
     /*  926824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926836 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  926839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926858 */     GIR_RootConstrainSelectedInstOperands,
     /*  926859 */     // GIR_Coverage, 24219,
     /*  926859 */     GIR_EraseRootFromParent_Done,
     /*  926860 */   // Label 14051: @926860
     /*  926860 */   GIM_Try, /*On fail goto*//*Label 14052*/ GIMT_Encode4(926948), // Rule ID 24222 //
     /*  926865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  926868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  926876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  926879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  926882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926912 */     // MIs[1] Operand 1
     /*  926912 */     // No operand predicates
     /*  926912 */     // MIs[0] policy
     /*  926912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926924 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  926927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926946 */     GIR_RootConstrainSelectedInstOperands,
     /*  926947 */     // GIR_Coverage, 24222,
     /*  926947 */     GIR_EraseRootFromParent_Done,
     /*  926948 */   // Label 14052: @926948
     /*  926948 */   GIM_Try, /*On fail goto*//*Label 14053*/ GIMT_Encode4(927036), // Rule ID 24223 //
     /*  926953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  926956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  926964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  926967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  926970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927000 */     // MIs[1] Operand 1
     /*  927000 */     // No operand predicates
     /*  927000 */     // MIs[0] policy
     /*  927000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927012 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  927015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927034 */     GIR_RootConstrainSelectedInstOperands,
     /*  927035 */     // GIR_Coverage, 24223,
     /*  927035 */     GIR_EraseRootFromParent_Done,
     /*  927036 */   // Label 14053: @927036
     /*  927036 */   GIM_Try, /*On fail goto*//*Label 14054*/ GIMT_Encode4(927124), // Rule ID 24226 //
     /*  927041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  927044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  927052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  927055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  927058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927088 */     // MIs[1] Operand 1
     /*  927088 */     // No operand predicates
     /*  927088 */     // MIs[0] policy
     /*  927088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927100 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  927103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927122 */     GIR_RootConstrainSelectedInstOperands,
     /*  927123 */     // GIR_Coverage, 24226,
     /*  927123 */     GIR_EraseRootFromParent_Done,
     /*  927124 */   // Label 14054: @927124
     /*  927124 */   GIM_Try, /*On fail goto*//*Label 14055*/ GIMT_Encode4(927212), // Rule ID 24227 //
     /*  927129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  927132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  927140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  927143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  927146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927176 */     // MIs[1] Operand 1
     /*  927176 */     // No operand predicates
     /*  927176 */     // MIs[0] policy
     /*  927176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927188 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  927191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927210 */     GIR_RootConstrainSelectedInstOperands,
     /*  927211 */     // GIR_Coverage, 24227,
     /*  927211 */     GIR_EraseRootFromParent_Done,
     /*  927212 */   // Label 14055: @927212
     /*  927212 */   GIM_Try, /*On fail goto*//*Label 14056*/ GIMT_Encode4(927300), // Rule ID 24230 //
     /*  927217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  927220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  927228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  927231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  927234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927264 */     // MIs[1] Operand 1
     /*  927264 */     // No operand predicates
     /*  927264 */     // MIs[0] policy
     /*  927264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927276 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  927279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927298 */     GIR_RootConstrainSelectedInstOperands,
     /*  927299 */     // GIR_Coverage, 24230,
     /*  927299 */     GIR_EraseRootFromParent_Done,
     /*  927300 */   // Label 14056: @927300
     /*  927300 */   GIM_Try, /*On fail goto*//*Label 14057*/ GIMT_Encode4(927388), // Rule ID 24231 //
     /*  927305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  927308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  927316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  927319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  927322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927352 */     // MIs[1] Operand 1
     /*  927352 */     // No operand predicates
     /*  927352 */     // MIs[0] policy
     /*  927352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927364 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  927367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927386 */     GIR_RootConstrainSelectedInstOperands,
     /*  927387 */     // GIR_Coverage, 24231,
     /*  927387 */     GIR_EraseRootFromParent_Done,
     /*  927388 */   // Label 14057: @927388
     /*  927388 */   GIM_Try, /*On fail goto*//*Label 14058*/ GIMT_Encode4(927476), // Rule ID 24234 //
     /*  927393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  927396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  927404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  927407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  927410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927440 */     // MIs[1] Operand 1
     /*  927440 */     // No operand predicates
     /*  927440 */     // MIs[0] policy
     /*  927440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927452 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  927455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927474 */     GIR_RootConstrainSelectedInstOperands,
     /*  927475 */     // GIR_Coverage, 24234,
     /*  927475 */     GIR_EraseRootFromParent_Done,
     /*  927476 */   // Label 14058: @927476
     /*  927476 */   GIM_Try, /*On fail goto*//*Label 14059*/ GIMT_Encode4(927564), // Rule ID 24235 //
     /*  927481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  927484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  927492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  927495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  927498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927528 */     // MIs[1] Operand 1
     /*  927528 */     // No operand predicates
     /*  927528 */     // MIs[0] policy
     /*  927528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927540 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  927543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927562 */     GIR_RootConstrainSelectedInstOperands,
     /*  927563 */     // GIR_Coverage, 24235,
     /*  927563 */     GIR_EraseRootFromParent_Done,
     /*  927564 */   // Label 14059: @927564
     /*  927564 */   GIM_Try, /*On fail goto*//*Label 14060*/ GIMT_Encode4(927652), // Rule ID 24238 //
     /*  927569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  927572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  927580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  927583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  927586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927616 */     // MIs[1] Operand 1
     /*  927616 */     // No operand predicates
     /*  927616 */     // MIs[0] policy
     /*  927616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927628 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  927631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927650 */     GIR_RootConstrainSelectedInstOperands,
     /*  927651 */     // GIR_Coverage, 24238,
     /*  927651 */     GIR_EraseRootFromParent_Done,
     /*  927652 */   // Label 14060: @927652
     /*  927652 */   GIM_Try, /*On fail goto*//*Label 14061*/ GIMT_Encode4(927740), // Rule ID 24239 //
     /*  927657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  927660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  927668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  927671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  927674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927704 */     // MIs[1] Operand 1
     /*  927704 */     // No operand predicates
     /*  927704 */     // MIs[0] policy
     /*  927704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927716 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  927719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927738 */     GIR_RootConstrainSelectedInstOperands,
     /*  927739 */     // GIR_Coverage, 24239,
     /*  927739 */     GIR_EraseRootFromParent_Done,
     /*  927740 */   // Label 14061: @927740
     /*  927740 */   GIM_Try, /*On fail goto*//*Label 14062*/ GIMT_Encode4(927828), // Rule ID 24242 //
     /*  927745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  927748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  927756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  927759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  927762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927792 */     // MIs[1] Operand 1
     /*  927792 */     // No operand predicates
     /*  927792 */     // MIs[0] policy
     /*  927792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927804 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  927807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927826 */     GIR_RootConstrainSelectedInstOperands,
     /*  927827 */     // GIR_Coverage, 24242,
     /*  927827 */     GIR_EraseRootFromParent_Done,
     /*  927828 */   // Label 14062: @927828
     /*  927828 */   GIM_Try, /*On fail goto*//*Label 14063*/ GIMT_Encode4(927916), // Rule ID 24243 //
     /*  927833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  927836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  927844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  927847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  927850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927880 */     // MIs[1] Operand 1
     /*  927880 */     // No operand predicates
     /*  927880 */     // MIs[0] policy
     /*  927880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927892 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  927895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927914 */     GIR_RootConstrainSelectedInstOperands,
     /*  927915 */     // GIR_Coverage, 24243,
     /*  927915 */     GIR_EraseRootFromParent_Done,
     /*  927916 */   // Label 14063: @927916
     /*  927916 */   GIM_Try, /*On fail goto*//*Label 14064*/ GIMT_Encode4(928004), // Rule ID 24246 //
     /*  927921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  927924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  927932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  927935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  927938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927968 */     // MIs[1] Operand 1
     /*  927968 */     // No operand predicates
     /*  927968 */     // MIs[0] policy
     /*  927968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927980 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  927983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  928000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928002 */     GIR_RootConstrainSelectedInstOperands,
     /*  928003 */     // GIR_Coverage, 24246,
     /*  928003 */     GIR_EraseRootFromParent_Done,
     /*  928004 */   // Label 14064: @928004
     /*  928004 */   GIM_Try, /*On fail goto*//*Label 14065*/ GIMT_Encode4(928092), // Rule ID 24247 //
     /*  928009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  928012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  928017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  928020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  928023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  928026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  928036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  928040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  928044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928056 */     // MIs[1] Operand 1
     /*  928056 */     // No operand predicates
     /*  928056 */     // MIs[0] policy
     /*  928056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928068 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  928071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  928088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928090 */     GIR_RootConstrainSelectedInstOperands,
     /*  928091 */     // GIR_Coverage, 24247,
     /*  928091 */     GIR_EraseRootFromParent_Done,
     /*  928092 */   // Label 14065: @928092
     /*  928092 */   GIM_Try, /*On fail goto*//*Label 14066*/ GIMT_Encode4(928180), // Rule ID 24310 //
     /*  928097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  928100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  928108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  928111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  928114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928144 */     // MIs[1] Operand 1
     /*  928144 */     // No operand predicates
     /*  928144 */     // MIs[0] policy
     /*  928144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928156 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  928159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928178 */     GIR_RootConstrainSelectedInstOperands,
     /*  928179 */     // GIR_Coverage, 24310,
     /*  928179 */     GIR_EraseRootFromParent_Done,
     /*  928180 */   // Label 14066: @928180
     /*  928180 */   GIM_Try, /*On fail goto*//*Label 14067*/ GIMT_Encode4(928268), // Rule ID 24311 //
     /*  928185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  928188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  928196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  928199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  928202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928232 */     // MIs[1] Operand 1
     /*  928232 */     // No operand predicates
     /*  928232 */     // MIs[0] policy
     /*  928232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928244 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  928247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928266 */     GIR_RootConstrainSelectedInstOperands,
     /*  928267 */     // GIR_Coverage, 24311,
     /*  928267 */     GIR_EraseRootFromParent_Done,
     /*  928268 */   // Label 14067: @928268
     /*  928268 */   GIM_Try, /*On fail goto*//*Label 14068*/ GIMT_Encode4(928356), // Rule ID 24314 //
     /*  928273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  928276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  928284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  928287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  928290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928320 */     // MIs[1] Operand 1
     /*  928320 */     // No operand predicates
     /*  928320 */     // MIs[0] policy
     /*  928320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928332 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  928335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928354 */     GIR_RootConstrainSelectedInstOperands,
     /*  928355 */     // GIR_Coverage, 24314,
     /*  928355 */     GIR_EraseRootFromParent_Done,
     /*  928356 */   // Label 14068: @928356
     /*  928356 */   GIM_Try, /*On fail goto*//*Label 14069*/ GIMT_Encode4(928444), // Rule ID 24315 //
     /*  928361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  928364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  928372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  928375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  928378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928408 */     // MIs[1] Operand 1
     /*  928408 */     // No operand predicates
     /*  928408 */     // MIs[0] policy
     /*  928408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928420 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  928423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928442 */     GIR_RootConstrainSelectedInstOperands,
     /*  928443 */     // GIR_Coverage, 24315,
     /*  928443 */     GIR_EraseRootFromParent_Done,
     /*  928444 */   // Label 14069: @928444
     /*  928444 */   GIM_Try, /*On fail goto*//*Label 14070*/ GIMT_Encode4(928532), // Rule ID 24318 //
     /*  928449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  928452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  928460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  928463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  928466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928496 */     // MIs[1] Operand 1
     /*  928496 */     // No operand predicates
     /*  928496 */     // MIs[0] policy
     /*  928496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928508 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  928511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928530 */     GIR_RootConstrainSelectedInstOperands,
     /*  928531 */     // GIR_Coverage, 24318,
     /*  928531 */     GIR_EraseRootFromParent_Done,
     /*  928532 */   // Label 14070: @928532
     /*  928532 */   GIM_Try, /*On fail goto*//*Label 14071*/ GIMT_Encode4(928620), // Rule ID 24319 //
     /*  928537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  928540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  928548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  928551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  928554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928584 */     // MIs[1] Operand 1
     /*  928584 */     // No operand predicates
     /*  928584 */     // MIs[0] policy
     /*  928584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928596 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  928599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928618 */     GIR_RootConstrainSelectedInstOperands,
     /*  928619 */     // GIR_Coverage, 24319,
     /*  928619 */     GIR_EraseRootFromParent_Done,
     /*  928620 */   // Label 14071: @928620
     /*  928620 */   GIM_Try, /*On fail goto*//*Label 14072*/ GIMT_Encode4(928708), // Rule ID 24322 //
     /*  928625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  928628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  928642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928672 */     // MIs[1] Operand 1
     /*  928672 */     // No operand predicates
     /*  928672 */     // MIs[0] policy
     /*  928672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928684 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  928687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928706 */     GIR_RootConstrainSelectedInstOperands,
     /*  928707 */     // GIR_Coverage, 24322,
     /*  928707 */     GIR_EraseRootFromParent_Done,
     /*  928708 */   // Label 14072: @928708
     /*  928708 */   GIM_Try, /*On fail goto*//*Label 14073*/ GIMT_Encode4(928796), // Rule ID 24323 //
     /*  928713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  928716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  928730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928760 */     // MIs[1] Operand 1
     /*  928760 */     // No operand predicates
     /*  928760 */     // MIs[0] policy
     /*  928760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928772 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  928775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928794 */     GIR_RootConstrainSelectedInstOperands,
     /*  928795 */     // GIR_Coverage, 24323,
     /*  928795 */     GIR_EraseRootFromParent_Done,
     /*  928796 */   // Label 14073: @928796
     /*  928796 */   GIM_Try, /*On fail goto*//*Label 14074*/ GIMT_Encode4(928884), // Rule ID 24326 //
     /*  928801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  928804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  928818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928848 */     // MIs[1] Operand 1
     /*  928848 */     // No operand predicates
     /*  928848 */     // MIs[0] policy
     /*  928848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928860 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  928863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928882 */     GIR_RootConstrainSelectedInstOperands,
     /*  928883 */     // GIR_Coverage, 24326,
     /*  928883 */     GIR_EraseRootFromParent_Done,
     /*  928884 */   // Label 14074: @928884
     /*  928884 */   GIM_Try, /*On fail goto*//*Label 14075*/ GIMT_Encode4(928972), // Rule ID 24327 //
     /*  928889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  928892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  928906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928936 */     // MIs[1] Operand 1
     /*  928936 */     // No operand predicates
     /*  928936 */     // MIs[0] policy
     /*  928936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928948 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  928951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928970 */     GIR_RootConstrainSelectedInstOperands,
     /*  928971 */     // GIR_Coverage, 24327,
     /*  928971 */     GIR_EraseRootFromParent_Done,
     /*  928972 */   // Label 14075: @928972
     /*  928972 */   GIM_Try, /*On fail goto*//*Label 14076*/ GIMT_Encode4(929060), // Rule ID 24330 //
     /*  928977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  928980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  928988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  928991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  928994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929024 */     // MIs[1] Operand 1
     /*  929024 */     // No operand predicates
     /*  929024 */     // MIs[0] policy
     /*  929024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929036 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  929039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  929056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929058 */     GIR_RootConstrainSelectedInstOperands,
     /*  929059 */     // GIR_Coverage, 24330,
     /*  929059 */     GIR_EraseRootFromParent_Done,
     /*  929060 */   // Label 14076: @929060
     /*  929060 */   GIM_Try, /*On fail goto*//*Label 14077*/ GIMT_Encode4(929148), // Rule ID 24331 //
     /*  929065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  929068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  929076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  929079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  929082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929112 */     // MIs[1] Operand 1
     /*  929112 */     // No operand predicates
     /*  929112 */     // MIs[0] policy
     /*  929112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929124 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  929127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  929144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929146 */     GIR_RootConstrainSelectedInstOperands,
     /*  929147 */     // GIR_Coverage, 24331,
     /*  929147 */     GIR_EraseRootFromParent_Done,
     /*  929148 */   // Label 14077: @929148
     /*  929148 */   GIM_Try, /*On fail goto*//*Label 14078*/ GIMT_Encode4(929236), // Rule ID 24334 //
     /*  929153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  929156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  929170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929200 */     // MIs[1] Operand 1
     /*  929200 */     // No operand predicates
     /*  929200 */     // MIs[0] policy
     /*  929200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929212 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  929215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929234 */     GIR_RootConstrainSelectedInstOperands,
     /*  929235 */     // GIR_Coverage, 24334,
     /*  929235 */     GIR_EraseRootFromParent_Done,
     /*  929236 */   // Label 14078: @929236
     /*  929236 */   GIM_Try, /*On fail goto*//*Label 14079*/ GIMT_Encode4(929324), // Rule ID 24335 //
     /*  929241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  929244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  929258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929288 */     // MIs[1] Operand 1
     /*  929288 */     // No operand predicates
     /*  929288 */     // MIs[0] policy
     /*  929288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929300 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  929303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929322 */     GIR_RootConstrainSelectedInstOperands,
     /*  929323 */     // GIR_Coverage, 24335,
     /*  929323 */     GIR_EraseRootFromParent_Done,
     /*  929324 */   // Label 14079: @929324
     /*  929324 */   GIM_Try, /*On fail goto*//*Label 14080*/ GIMT_Encode4(929412), // Rule ID 24338 //
     /*  929329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  929332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  929340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  929343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  929346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929376 */     // MIs[1] Operand 1
     /*  929376 */     // No operand predicates
     /*  929376 */     // MIs[0] policy
     /*  929376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929388 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  929391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929410 */     GIR_RootConstrainSelectedInstOperands,
     /*  929411 */     // GIR_Coverage, 24338,
     /*  929411 */     GIR_EraseRootFromParent_Done,
     /*  929412 */   // Label 14080: @929412
     /*  929412 */   GIM_Try, /*On fail goto*//*Label 14081*/ GIMT_Encode4(929500), // Rule ID 24339 //
     /*  929417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  929420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  929428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  929431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  929434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929464 */     // MIs[1] Operand 1
     /*  929464 */     // No operand predicates
     /*  929464 */     // MIs[0] policy
     /*  929464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929476 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  929479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929498 */     GIR_RootConstrainSelectedInstOperands,
     /*  929499 */     // GIR_Coverage, 24339,
     /*  929499 */     GIR_EraseRootFromParent_Done,
     /*  929500 */   // Label 14081: @929500
     /*  929500 */   GIM_Try, /*On fail goto*//*Label 14082*/ GIMT_Encode4(929588), // Rule ID 24342 //
     /*  929505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  929508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  929516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  929519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  929522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929552 */     // MIs[1] Operand 1
     /*  929552 */     // No operand predicates
     /*  929552 */     // MIs[0] policy
     /*  929552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929564 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  929567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929586 */     GIR_RootConstrainSelectedInstOperands,
     /*  929587 */     // GIR_Coverage, 24342,
     /*  929587 */     GIR_EraseRootFromParent_Done,
     /*  929588 */   // Label 14082: @929588
     /*  929588 */   GIM_Try, /*On fail goto*//*Label 14083*/ GIMT_Encode4(929676), // Rule ID 24343 //
     /*  929593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  929596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  929604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  929607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  929610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929640 */     // MIs[1] Operand 1
     /*  929640 */     // No operand predicates
     /*  929640 */     // MIs[0] policy
     /*  929640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929652 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  929655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929674 */     GIR_RootConstrainSelectedInstOperands,
     /*  929675 */     // GIR_Coverage, 24343,
     /*  929675 */     GIR_EraseRootFromParent_Done,
     /*  929676 */   // Label 14083: @929676
     /*  929676 */   GIM_Try, /*On fail goto*//*Label 14084*/ GIMT_Encode4(929764), // Rule ID 24346 //
     /*  929681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  929684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  929692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  929695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  929698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929728 */     // MIs[1] Operand 1
     /*  929728 */     // No operand predicates
     /*  929728 */     // MIs[0] policy
     /*  929728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929740 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  929743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929762 */     GIR_RootConstrainSelectedInstOperands,
     /*  929763 */     // GIR_Coverage, 24346,
     /*  929763 */     GIR_EraseRootFromParent_Done,
     /*  929764 */   // Label 14084: @929764
     /*  929764 */   GIM_Try, /*On fail goto*//*Label 14085*/ GIMT_Encode4(929852), // Rule ID 24347 //
     /*  929769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  929772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  929780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  929783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  929786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929816 */     // MIs[1] Operand 1
     /*  929816 */     // No operand predicates
     /*  929816 */     // MIs[0] policy
     /*  929816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929828 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  929831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929850 */     GIR_RootConstrainSelectedInstOperands,
     /*  929851 */     // GIR_Coverage, 24347,
     /*  929851 */     GIR_EraseRootFromParent_Done,
     /*  929852 */   // Label 14085: @929852
     /*  929852 */   GIM_Try, /*On fail goto*//*Label 14086*/ GIMT_Encode4(929940), // Rule ID 24350 //
     /*  929857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  929860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  929868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  929871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  929874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929904 */     // MIs[1] Operand 1
     /*  929904 */     // No operand predicates
     /*  929904 */     // MIs[0] policy
     /*  929904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929916 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  929919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929938 */     GIR_RootConstrainSelectedInstOperands,
     /*  929939 */     // GIR_Coverage, 24350,
     /*  929939 */     GIR_EraseRootFromParent_Done,
     /*  929940 */   // Label 14086: @929940
     /*  929940 */   GIM_Try, /*On fail goto*//*Label 14087*/ GIMT_Encode4(930028), // Rule ID 24351 //
     /*  929945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  929948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  929956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  929959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  929962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929992 */     // MIs[1] Operand 1
     /*  929992 */     // No operand predicates
     /*  929992 */     // MIs[0] policy
     /*  929992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930004 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  930007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930026 */     GIR_RootConstrainSelectedInstOperands,
     /*  930027 */     // GIR_Coverage, 24351,
     /*  930027 */     GIR_EraseRootFromParent_Done,
     /*  930028 */   // Label 14087: @930028
     /*  930028 */   GIM_Try, /*On fail goto*//*Label 14088*/ GIMT_Encode4(930116), // Rule ID 24354 //
     /*  930033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  930036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  930044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  930047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  930050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930080 */     // MIs[1] Operand 1
     /*  930080 */     // No operand predicates
     /*  930080 */     // MIs[0] policy
     /*  930080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930092 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  930095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930114 */     GIR_RootConstrainSelectedInstOperands,
     /*  930115 */     // GIR_Coverage, 24354,
     /*  930115 */     GIR_EraseRootFromParent_Done,
     /*  930116 */   // Label 14088: @930116
     /*  930116 */   GIM_Try, /*On fail goto*//*Label 14089*/ GIMT_Encode4(930204), // Rule ID 24355 //
     /*  930121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  930124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  930132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  930135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  930138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930168 */     // MIs[1] Operand 1
     /*  930168 */     // No operand predicates
     /*  930168 */     // MIs[0] policy
     /*  930168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930180 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  930183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930202 */     GIR_RootConstrainSelectedInstOperands,
     /*  930203 */     // GIR_Coverage, 24355,
     /*  930203 */     GIR_EraseRootFromParent_Done,
     /*  930204 */   // Label 14089: @930204
     /*  930204 */   GIM_Try, /*On fail goto*//*Label 14090*/ GIMT_Encode4(930292), // Rule ID 24358 //
     /*  930209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  930212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  930226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930256 */     // MIs[1] Operand 1
     /*  930256 */     // No operand predicates
     /*  930256 */     // MIs[0] policy
     /*  930256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930268 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  930271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930290 */     GIR_RootConstrainSelectedInstOperands,
     /*  930291 */     // GIR_Coverage, 24358,
     /*  930291 */     GIR_EraseRootFromParent_Done,
     /*  930292 */   // Label 14090: @930292
     /*  930292 */   GIM_Try, /*On fail goto*//*Label 14091*/ GIMT_Encode4(930380), // Rule ID 24359 //
     /*  930297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  930300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  930314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930344 */     // MIs[1] Operand 1
     /*  930344 */     // No operand predicates
     /*  930344 */     // MIs[0] policy
     /*  930344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930356 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  930359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930378 */     GIR_RootConstrainSelectedInstOperands,
     /*  930379 */     // GIR_Coverage, 24359,
     /*  930379 */     GIR_EraseRootFromParent_Done,
     /*  930380 */   // Label 14091: @930380
     /*  930380 */   GIM_Try, /*On fail goto*//*Label 14092*/ GIMT_Encode4(930468), // Rule ID 24362 //
     /*  930385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  930388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  930396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  930399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  930402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930432 */     // MIs[1] Operand 1
     /*  930432 */     // No operand predicates
     /*  930432 */     // MIs[0] policy
     /*  930432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930444 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  930447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930466 */     GIR_RootConstrainSelectedInstOperands,
     /*  930467 */     // GIR_Coverage, 24362,
     /*  930467 */     GIR_EraseRootFromParent_Done,
     /*  930468 */   // Label 14092: @930468
     /*  930468 */   GIM_Try, /*On fail goto*//*Label 14093*/ GIMT_Encode4(930556), // Rule ID 24363 //
     /*  930473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  930476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  930484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  930487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  930490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930520 */     // MIs[1] Operand 1
     /*  930520 */     // No operand predicates
     /*  930520 */     // MIs[0] policy
     /*  930520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930532 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  930535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930554 */     GIR_RootConstrainSelectedInstOperands,
     /*  930555 */     // GIR_Coverage, 24363,
     /*  930555 */     GIR_EraseRootFromParent_Done,
     /*  930556 */   // Label 14093: @930556
     /*  930556 */   GIM_Try, /*On fail goto*//*Label 14094*/ GIMT_Encode4(930644), // Rule ID 24366 //
     /*  930561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  930564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  930572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  930575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  930578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930608 */     // MIs[1] Operand 1
     /*  930608 */     // No operand predicates
     /*  930608 */     // MIs[0] policy
     /*  930608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930620 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  930623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930642 */     GIR_RootConstrainSelectedInstOperands,
     /*  930643 */     // GIR_Coverage, 24366,
     /*  930643 */     GIR_EraseRootFromParent_Done,
     /*  930644 */   // Label 14094: @930644
     /*  930644 */   GIM_Try, /*On fail goto*//*Label 14095*/ GIMT_Encode4(930732), // Rule ID 24367 //
     /*  930649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  930652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  930660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  930663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  930666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930696 */     // MIs[1] Operand 1
     /*  930696 */     // No operand predicates
     /*  930696 */     // MIs[0] policy
     /*  930696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930708 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  930711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930730 */     GIR_RootConstrainSelectedInstOperands,
     /*  930731 */     // GIR_Coverage, 24367,
     /*  930731 */     GIR_EraseRootFromParent_Done,
     /*  930732 */   // Label 14095: @930732
     /*  930732 */   GIM_Try, /*On fail goto*//*Label 14096*/ GIMT_Encode4(930823), // Rule ID 15978 //
     /*  930737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  930748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  930751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  930754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930784 */     // MIs[1] Operand 1
     /*  930784 */     // No operand predicates
     /*  930784 */     // MIs[0] round
     /*  930784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930796 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  930796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  930799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930808 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930821 */     GIR_RootConstrainSelectedInstOperands,
     /*  930822 */     // GIR_Coverage, 15978,
     /*  930822 */     GIR_EraseRootFromParent_Done,
     /*  930823 */   // Label 14096: @930823
     /*  930823 */   GIM_Try, /*On fail goto*//*Label 14097*/ GIMT_Encode4(930914), // Rule ID 15979 //
     /*  930828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  930839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  930842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  930845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930875 */     // MIs[1] Operand 1
     /*  930875 */     // No operand predicates
     /*  930875 */     // MIs[0] round
     /*  930875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930887 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  930887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  930890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930912 */     GIR_RootConstrainSelectedInstOperands,
     /*  930913 */     // GIR_Coverage, 15979,
     /*  930913 */     GIR_EraseRootFromParent_Done,
     /*  930914 */   // Label 14097: @930914
     /*  930914 */   GIM_Try, /*On fail goto*//*Label 14098*/ GIMT_Encode4(931005), // Rule ID 15982 //
     /*  930919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  930930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  930933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  930936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930966 */     // MIs[1] Operand 1
     /*  930966 */     // No operand predicates
     /*  930966 */     // MIs[0] round
     /*  930966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930978 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  930978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  930981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931003 */     GIR_RootConstrainSelectedInstOperands,
     /*  931004 */     // GIR_Coverage, 15982,
     /*  931004 */     GIR_EraseRootFromParent_Done,
     /*  931005 */   // Label 14098: @931005
     /*  931005 */   GIM_Try, /*On fail goto*//*Label 14099*/ GIMT_Encode4(931096), // Rule ID 15983 //
     /*  931010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  931021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  931024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  931027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931057 */     // MIs[1] Operand 1
     /*  931057 */     // No operand predicates
     /*  931057 */     // MIs[0] round
     /*  931057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931069 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  931072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931094 */     GIR_RootConstrainSelectedInstOperands,
     /*  931095 */     // GIR_Coverage, 15983,
     /*  931095 */     GIR_EraseRootFromParent_Done,
     /*  931096 */   // Label 14099: @931096
     /*  931096 */   GIM_Try, /*On fail goto*//*Label 14100*/ GIMT_Encode4(931187), // Rule ID 15986 //
     /*  931101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  931112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  931115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  931118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931148 */     // MIs[1] Operand 1
     /*  931148 */     // No operand predicates
     /*  931148 */     // MIs[0] round
     /*  931148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931160 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  931163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931172 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931185 */     GIR_RootConstrainSelectedInstOperands,
     /*  931186 */     // GIR_Coverage, 15986,
     /*  931186 */     GIR_EraseRootFromParent_Done,
     /*  931187 */   // Label 14100: @931187
     /*  931187 */   GIM_Try, /*On fail goto*//*Label 14101*/ GIMT_Encode4(931278), // Rule ID 15987 //
     /*  931192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  931203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  931206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  931209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931239 */     // MIs[1] Operand 1
     /*  931239 */     // No operand predicates
     /*  931239 */     // MIs[0] round
     /*  931239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931251 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  931254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931276 */     GIR_RootConstrainSelectedInstOperands,
     /*  931277 */     // GIR_Coverage, 15987,
     /*  931277 */     GIR_EraseRootFromParent_Done,
     /*  931278 */   // Label 14101: @931278
     /*  931278 */   GIM_Try, /*On fail goto*//*Label 14102*/ GIMT_Encode4(931369), // Rule ID 15990 //
     /*  931283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  931294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  931297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  931300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931330 */     // MIs[1] Operand 1
     /*  931330 */     // No operand predicates
     /*  931330 */     // MIs[0] round
     /*  931330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931342 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  931342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  931345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931354 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931367 */     GIR_RootConstrainSelectedInstOperands,
     /*  931368 */     // GIR_Coverage, 15990,
     /*  931368 */     GIR_EraseRootFromParent_Done,
     /*  931369 */   // Label 14102: @931369
     /*  931369 */   GIM_Try, /*On fail goto*//*Label 14103*/ GIMT_Encode4(931460), // Rule ID 15991 //
     /*  931374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  931385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  931388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  931391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931421 */     // MIs[1] Operand 1
     /*  931421 */     // No operand predicates
     /*  931421 */     // MIs[0] round
     /*  931421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931433 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  931433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  931436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931458 */     GIR_RootConstrainSelectedInstOperands,
     /*  931459 */     // GIR_Coverage, 15991,
     /*  931459 */     GIR_EraseRootFromParent_Done,
     /*  931460 */   // Label 14103: @931460
     /*  931460 */   GIM_Try, /*On fail goto*//*Label 14104*/ GIMT_Encode4(931551), // Rule ID 15994 //
     /*  931465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  931476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  931479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  931482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931512 */     // MIs[1] Operand 1
     /*  931512 */     // No operand predicates
     /*  931512 */     // MIs[0] round
     /*  931512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931524 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  931524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  931527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931536 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931549 */     GIR_RootConstrainSelectedInstOperands,
     /*  931550 */     // GIR_Coverage, 15994,
     /*  931550 */     GIR_EraseRootFromParent_Done,
     /*  931551 */   // Label 14104: @931551
     /*  931551 */   GIM_Try, /*On fail goto*//*Label 14105*/ GIMT_Encode4(931642), // Rule ID 15995 //
     /*  931556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  931567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  931570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  931573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931603 */     // MIs[1] Operand 1
     /*  931603 */     // No operand predicates
     /*  931603 */     // MIs[0] round
     /*  931603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931615 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  931615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  931618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931640 */     GIR_RootConstrainSelectedInstOperands,
     /*  931641 */     // GIR_Coverage, 15995,
     /*  931641 */     GIR_EraseRootFromParent_Done,
     /*  931642 */   // Label 14105: @931642
     /*  931642 */   GIM_Try, /*On fail goto*//*Label 14106*/ GIMT_Encode4(931733), // Rule ID 15998 //
     /*  931647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  931658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  931661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  931664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931694 */     // MIs[1] Operand 1
     /*  931694 */     // No operand predicates
     /*  931694 */     // MIs[0] round
     /*  931694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931706 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  931706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  931709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931718 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931731 */     GIR_RootConstrainSelectedInstOperands,
     /*  931732 */     // GIR_Coverage, 15998,
     /*  931732 */     GIR_EraseRootFromParent_Done,
     /*  931733 */   // Label 14106: @931733
     /*  931733 */   GIM_Try, /*On fail goto*//*Label 14107*/ GIMT_Encode4(931824), // Rule ID 15999 //
     /*  931738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  931749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  931752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  931755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931785 */     // MIs[1] Operand 1
     /*  931785 */     // No operand predicates
     /*  931785 */     // MIs[0] round
     /*  931785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931797 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  931797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  931800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931822 */     GIR_RootConstrainSelectedInstOperands,
     /*  931823 */     // GIR_Coverage, 15999,
     /*  931823 */     GIR_EraseRootFromParent_Done,
     /*  931824 */   // Label 14107: @931824
     /*  931824 */   GIM_Try, /*On fail goto*//*Label 14108*/ GIMT_Encode4(931915), // Rule ID 16002 //
     /*  931829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  931840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  931843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  931846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931876 */     // MIs[1] Operand 1
     /*  931876 */     // No operand predicates
     /*  931876 */     // MIs[0] round
     /*  931876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931888 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  931891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931900 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931913 */     GIR_RootConstrainSelectedInstOperands,
     /*  931914 */     // GIR_Coverage, 16002,
     /*  931914 */     GIR_EraseRootFromParent_Done,
     /*  931915 */   // Label 14108: @931915
     /*  931915 */   GIM_Try, /*On fail goto*//*Label 14109*/ GIMT_Encode4(932006), // Rule ID 16003 //
     /*  931920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  931931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  931934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  931937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931967 */     // MIs[1] Operand 1
     /*  931967 */     // No operand predicates
     /*  931967 */     // MIs[0] round
     /*  931967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931979 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  931982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932004 */     GIR_RootConstrainSelectedInstOperands,
     /*  932005 */     // GIR_Coverage, 16003,
     /*  932005 */     GIR_EraseRootFromParent_Done,
     /*  932006 */   // Label 14109: @932006
     /*  932006 */   GIM_Try, /*On fail goto*//*Label 14110*/ GIMT_Encode4(932097), // Rule ID 16006 //
     /*  932011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  932022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  932025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  932028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932058 */     // MIs[1] Operand 1
     /*  932058 */     // No operand predicates
     /*  932058 */     // MIs[0] round
     /*  932058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932070 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  932070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  932073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932082 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932095 */     GIR_RootConstrainSelectedInstOperands,
     /*  932096 */     // GIR_Coverage, 16006,
     /*  932096 */     GIR_EraseRootFromParent_Done,
     /*  932097 */   // Label 14110: @932097
     /*  932097 */   GIM_Try, /*On fail goto*//*Label 14111*/ GIMT_Encode4(932188), // Rule ID 16007 //
     /*  932102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  932113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  932116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  932119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932149 */     // MIs[1] Operand 1
     /*  932149 */     // No operand predicates
     /*  932149 */     // MIs[0] round
     /*  932149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932161 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  932161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  932164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932186 */     GIR_RootConstrainSelectedInstOperands,
     /*  932187 */     // GIR_Coverage, 16007,
     /*  932187 */     GIR_EraseRootFromParent_Done,
     /*  932188 */   // Label 14111: @932188
     /*  932188 */   GIM_Try, /*On fail goto*//*Label 14112*/ GIMT_Encode4(932279), // Rule ID 16010 //
     /*  932193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  932204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  932207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  932210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932240 */     // MIs[1] Operand 1
     /*  932240 */     // No operand predicates
     /*  932240 */     // MIs[0] round
     /*  932240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  932252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  932255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932264 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932277 */     GIR_RootConstrainSelectedInstOperands,
     /*  932278 */     // GIR_Coverage, 16010,
     /*  932278 */     GIR_EraseRootFromParent_Done,
     /*  932279 */   // Label 14112: @932279
     /*  932279 */   GIM_Try, /*On fail goto*//*Label 14113*/ GIMT_Encode4(932370), // Rule ID 16011 //
     /*  932284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  932295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  932298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  932301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932331 */     // MIs[1] Operand 1
     /*  932331 */     // No operand predicates
     /*  932331 */     // MIs[0] round
     /*  932331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932343 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  932343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  932346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932368 */     GIR_RootConstrainSelectedInstOperands,
     /*  932369 */     // GIR_Coverage, 16011,
     /*  932369 */     GIR_EraseRootFromParent_Done,
     /*  932370 */   // Label 14113: @932370
     /*  932370 */   GIM_Try, /*On fail goto*//*Label 14114*/ GIMT_Encode4(932461), // Rule ID 16014 //
     /*  932375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  932378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  932386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  932389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  932392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932422 */     // MIs[1] Operand 1
     /*  932422 */     // No operand predicates
     /*  932422 */     // MIs[0] round
     /*  932422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932434 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  932434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  932437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  932456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932459 */     GIR_RootConstrainSelectedInstOperands,
     /*  932460 */     // GIR_Coverage, 16014,
     /*  932460 */     GIR_EraseRootFromParent_Done,
     /*  932461 */   // Label 14114: @932461
     /*  932461 */   GIM_Try, /*On fail goto*//*Label 14115*/ GIMT_Encode4(932552), // Rule ID 16015 //
     /*  932466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  932469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  932477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  932480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  932483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932513 */     // MIs[1] Operand 1
     /*  932513 */     // No operand predicates
     /*  932513 */     // MIs[0] round
     /*  932513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932525 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  932525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  932528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  932547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932550 */     GIR_RootConstrainSelectedInstOperands,
     /*  932551 */     // GIR_Coverage, 16015,
     /*  932551 */     GIR_EraseRootFromParent_Done,
     /*  932552 */   // Label 14115: @932552
     /*  932552 */   GIM_Try, /*On fail goto*//*Label 14116*/ GIMT_Encode4(932643), // Rule ID 16018 //
     /*  932557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  932568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  932571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  932574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932604 */     // MIs[1] Operand 1
     /*  932604 */     // No operand predicates
     /*  932604 */     // MIs[0] round
     /*  932604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932616 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  932619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932628 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932641 */     GIR_RootConstrainSelectedInstOperands,
     /*  932642 */     // GIR_Coverage, 16018,
     /*  932642 */     GIR_EraseRootFromParent_Done,
     /*  932643 */   // Label 14116: @932643
     /*  932643 */   GIM_Try, /*On fail goto*//*Label 14117*/ GIMT_Encode4(932734), // Rule ID 16019 //
     /*  932648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  932659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  932662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  932665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932695 */     // MIs[1] Operand 1
     /*  932695 */     // No operand predicates
     /*  932695 */     // MIs[0] round
     /*  932695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932707 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  932707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  932710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932732 */     GIR_RootConstrainSelectedInstOperands,
     /*  932733 */     // GIR_Coverage, 16019,
     /*  932733 */     GIR_EraseRootFromParent_Done,
     /*  932734 */   // Label 14117: @932734
     /*  932734 */   GIM_Try, /*On fail goto*//*Label 14118*/ GIMT_Encode4(932825), // Rule ID 16022 //
     /*  932739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  932750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  932753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  932756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932782 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932786 */     // MIs[1] Operand 1
     /*  932786 */     // No operand predicates
     /*  932786 */     // MIs[0] round
     /*  932786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932798 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  932801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932810 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932823 */     GIR_RootConstrainSelectedInstOperands,
     /*  932824 */     // GIR_Coverage, 16022,
     /*  932824 */     GIR_EraseRootFromParent_Done,
     /*  932825 */   // Label 14118: @932825
     /*  932825 */   GIM_Try, /*On fail goto*//*Label 14119*/ GIMT_Encode4(932916), // Rule ID 16023 //
     /*  932830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  932841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  932844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  932847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932877 */     // MIs[1] Operand 1
     /*  932877 */     // No operand predicates
     /*  932877 */     // MIs[0] round
     /*  932877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932889 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  932889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  932892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932914 */     GIR_RootConstrainSelectedInstOperands,
     /*  932915 */     // GIR_Coverage, 16023,
     /*  932915 */     GIR_EraseRootFromParent_Done,
     /*  932916 */   // Label 14119: @932916
     /*  932916 */   GIM_Try, /*On fail goto*//*Label 14120*/ GIMT_Encode4(933007), // Rule ID 16026 //
     /*  932921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  932932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  932935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  932938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932968 */     // MIs[1] Operand 1
     /*  932968 */     // No operand predicates
     /*  932968 */     // MIs[0] round
     /*  932968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932980 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  932983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932992 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933005 */     GIR_RootConstrainSelectedInstOperands,
     /*  933006 */     // GIR_Coverage, 16026,
     /*  933006 */     GIR_EraseRootFromParent_Done,
     /*  933007 */   // Label 14120: @933007
     /*  933007 */   GIM_Try, /*On fail goto*//*Label 14121*/ GIMT_Encode4(933098), // Rule ID 16027 //
     /*  933012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  933023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  933026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  933029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933059 */     // MIs[1] Operand 1
     /*  933059 */     // No operand predicates
     /*  933059 */     // MIs[0] round
     /*  933059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933071 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  933071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  933074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933096 */     GIR_RootConstrainSelectedInstOperands,
     /*  933097 */     // GIR_Coverage, 16027,
     /*  933097 */     GIR_EraseRootFromParent_Done,
     /*  933098 */   // Label 14121: @933098
     /*  933098 */   GIM_Try, /*On fail goto*//*Label 14122*/ GIMT_Encode4(933189), // Rule ID 16030 //
     /*  933103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  933114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  933117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  933120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933150 */     // MIs[1] Operand 1
     /*  933150 */     // No operand predicates
     /*  933150 */     // MIs[0] round
     /*  933150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933162 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  933165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933174 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933187 */     GIR_RootConstrainSelectedInstOperands,
     /*  933188 */     // GIR_Coverage, 16030,
     /*  933188 */     GIR_EraseRootFromParent_Done,
     /*  933189 */   // Label 14122: @933189
     /*  933189 */   GIM_Try, /*On fail goto*//*Label 14123*/ GIMT_Encode4(933280), // Rule ID 16031 //
     /*  933194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  933205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  933208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  933211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933241 */     // MIs[1] Operand 1
     /*  933241 */     // No operand predicates
     /*  933241 */     // MIs[0] round
     /*  933241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933253 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  933256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933278 */     GIR_RootConstrainSelectedInstOperands,
     /*  933279 */     // GIR_Coverage, 16031,
     /*  933279 */     GIR_EraseRootFromParent_Done,
     /*  933280 */   // Label 14123: @933280
     /*  933280 */   GIM_Try, /*On fail goto*//*Label 14124*/ GIMT_Encode4(933371), // Rule ID 16034 //
     /*  933285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  933296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  933299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  933302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933332 */     // MIs[1] Operand 1
     /*  933332 */     // No operand predicates
     /*  933332 */     // MIs[0] round
     /*  933332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933344 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  933347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933356 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933369 */     GIR_RootConstrainSelectedInstOperands,
     /*  933370 */     // GIR_Coverage, 16034,
     /*  933370 */     GIR_EraseRootFromParent_Done,
     /*  933371 */   // Label 14124: @933371
     /*  933371 */   GIM_Try, /*On fail goto*//*Label 14125*/ GIMT_Encode4(933462), // Rule ID 16035 //
     /*  933376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  933387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  933390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  933393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933423 */     // MIs[1] Operand 1
     /*  933423 */     // No operand predicates
     /*  933423 */     // MIs[0] round
     /*  933423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933435 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  933438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933460 */     GIR_RootConstrainSelectedInstOperands,
     /*  933461 */     // GIR_Coverage, 16035,
     /*  933461 */     GIR_EraseRootFromParent_Done,
     /*  933462 */   // Label 14125: @933462
     /*  933462 */   GIM_Try, /*On fail goto*//*Label 14126*/ GIMT_Encode4(933553), // Rule ID 16038 //
     /*  933467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  933478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  933481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  933484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933514 */     // MIs[1] Operand 1
     /*  933514 */     // No operand predicates
     /*  933514 */     // MIs[0] round
     /*  933514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933526 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  933529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933538 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933551 */     GIR_RootConstrainSelectedInstOperands,
     /*  933552 */     // GIR_Coverage, 16038,
     /*  933552 */     GIR_EraseRootFromParent_Done,
     /*  933553 */   // Label 14126: @933553
     /*  933553 */   GIM_Try, /*On fail goto*//*Label 14127*/ GIMT_Encode4(933644), // Rule ID 16039 //
     /*  933558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  933569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  933572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  933575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933605 */     // MIs[1] Operand 1
     /*  933605 */     // No operand predicates
     /*  933605 */     // MIs[0] round
     /*  933605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933617 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  933620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933642 */     GIR_RootConstrainSelectedInstOperands,
     /*  933643 */     // GIR_Coverage, 16039,
     /*  933643 */     GIR_EraseRootFromParent_Done,
     /*  933644 */   // Label 14127: @933644
     /*  933644 */   GIM_Try, /*On fail goto*//*Label 14128*/ GIMT_Encode4(933735), // Rule ID 16042 //
     /*  933649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  933660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  933663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  933666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933696 */     // MIs[1] Operand 1
     /*  933696 */     // No operand predicates
     /*  933696 */     // MIs[0] round
     /*  933696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  933708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  933711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933720 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933733 */     GIR_RootConstrainSelectedInstOperands,
     /*  933734 */     // GIR_Coverage, 16042,
     /*  933734 */     GIR_EraseRootFromParent_Done,
     /*  933735 */   // Label 14128: @933735
     /*  933735 */   GIM_Try, /*On fail goto*//*Label 14129*/ GIMT_Encode4(933826), // Rule ID 16043 //
     /*  933740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  933751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  933754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  933757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933787 */     // MIs[1] Operand 1
     /*  933787 */     // No operand predicates
     /*  933787 */     // MIs[0] round
     /*  933787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  933799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  933802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933824 */     GIR_RootConstrainSelectedInstOperands,
     /*  933825 */     // GIR_Coverage, 16043,
     /*  933825 */     GIR_EraseRootFromParent_Done,
     /*  933826 */   // Label 14129: @933826
     /*  933826 */   GIM_Try, /*On fail goto*//*Label 14130*/ GIMT_Encode4(933917), // Rule ID 16046 //
     /*  933831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  933842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  933845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  933848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933874 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933878 */     // MIs[1] Operand 1
     /*  933878 */     // No operand predicates
     /*  933878 */     // MIs[0] round
     /*  933878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933890 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  933890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  933893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933902 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933915 */     GIR_RootConstrainSelectedInstOperands,
     /*  933916 */     // GIR_Coverage, 16046,
     /*  933916 */     GIR_EraseRootFromParent_Done,
     /*  933917 */   // Label 14130: @933917
     /*  933917 */   GIM_Try, /*On fail goto*//*Label 14131*/ GIMT_Encode4(934008), // Rule ID 16047 //
     /*  933922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  933933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  933936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  933939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933969 */     // MIs[1] Operand 1
     /*  933969 */     // No operand predicates
     /*  933969 */     // MIs[0] round
     /*  933969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933981 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  933981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  933984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934006 */     GIR_RootConstrainSelectedInstOperands,
     /*  934007 */     // GIR_Coverage, 16047,
     /*  934007 */     GIR_EraseRootFromParent_Done,
     /*  934008 */   // Label 14131: @934008
     /*  934008 */   GIM_Try, /*On fail goto*//*Label 14132*/ GIMT_Encode4(934099), // Rule ID 16050 //
     /*  934013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  934024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  934027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  934030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934060 */     // MIs[1] Operand 1
     /*  934060 */     // No operand predicates
     /*  934060 */     // MIs[0] round
     /*  934060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934072 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  934072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  934075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934084 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934097 */     GIR_RootConstrainSelectedInstOperands,
     /*  934098 */     // GIR_Coverage, 16050,
     /*  934098 */     GIR_EraseRootFromParent_Done,
     /*  934099 */   // Label 14132: @934099
     /*  934099 */   GIM_Try, /*On fail goto*//*Label 14133*/ GIMT_Encode4(934190), // Rule ID 16051 //
     /*  934104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  934115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  934118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  934121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934151 */     // MIs[1] Operand 1
     /*  934151 */     // No operand predicates
     /*  934151 */     // MIs[0] round
     /*  934151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934163 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  934163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  934166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934188 */     GIR_RootConstrainSelectedInstOperands,
     /*  934189 */     // GIR_Coverage, 16051,
     /*  934189 */     GIR_EraseRootFromParent_Done,
     /*  934190 */   // Label 14133: @934190
     /*  934190 */   GIM_Try, /*On fail goto*//*Label 14134*/ GIMT_Encode4(934281), // Rule ID 16054 //
     /*  934195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  934206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  934209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  934212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934242 */     // MIs[1] Operand 1
     /*  934242 */     // No operand predicates
     /*  934242 */     // MIs[0] round
     /*  934242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934254 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  934257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934266 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934279 */     GIR_RootConstrainSelectedInstOperands,
     /*  934280 */     // GIR_Coverage, 16054,
     /*  934280 */     GIR_EraseRootFromParent_Done,
     /*  934281 */   // Label 14134: @934281
     /*  934281 */   GIM_Try, /*On fail goto*//*Label 14135*/ GIMT_Encode4(934372), // Rule ID 16055 //
     /*  934286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  934297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  934300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  934303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934333 */     // MIs[1] Operand 1
     /*  934333 */     // No operand predicates
     /*  934333 */     // MIs[0] round
     /*  934333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934345 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  934348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934370 */     GIR_RootConstrainSelectedInstOperands,
     /*  934371 */     // GIR_Coverage, 16055,
     /*  934371 */     GIR_EraseRootFromParent_Done,
     /*  934372 */   // Label 14135: @934372
     /*  934372 */   GIM_Try, /*On fail goto*//*Label 14136*/ GIMT_Encode4(934463), // Rule ID 16058 //
     /*  934377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  934388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  934391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  934394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934424 */     // MIs[1] Operand 1
     /*  934424 */     // No operand predicates
     /*  934424 */     // MIs[0] round
     /*  934424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  934439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934448 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934461 */     GIR_RootConstrainSelectedInstOperands,
     /*  934462 */     // GIR_Coverage, 16058,
     /*  934462 */     GIR_EraseRootFromParent_Done,
     /*  934463 */   // Label 14136: @934463
     /*  934463 */   GIM_Try, /*On fail goto*//*Label 14137*/ GIMT_Encode4(934554), // Rule ID 16059 //
     /*  934468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  934479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  934482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  934485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934515 */     // MIs[1] Operand 1
     /*  934515 */     // No operand predicates
     /*  934515 */     // MIs[0] round
     /*  934515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934527 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  934530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934552 */     GIR_RootConstrainSelectedInstOperands,
     /*  934553 */     // GIR_Coverage, 16059,
     /*  934553 */     GIR_EraseRootFromParent_Done,
     /*  934554 */   // Label 14137: @934554
     /*  934554 */   GIM_Try, /*On fail goto*//*Label 14138*/ GIMT_Encode4(934645), // Rule ID 16062 //
     /*  934559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  934570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  934573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  934576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934606 */     // MIs[1] Operand 1
     /*  934606 */     // No operand predicates
     /*  934606 */     // MIs[0] round
     /*  934606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934618 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  934621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934643 */     GIR_RootConstrainSelectedInstOperands,
     /*  934644 */     // GIR_Coverage, 16062,
     /*  934644 */     GIR_EraseRootFromParent_Done,
     /*  934645 */   // Label 14138: @934645
     /*  934645 */   GIM_Try, /*On fail goto*//*Label 14139*/ GIMT_Encode4(934736), // Rule ID 16063 //
     /*  934650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  934661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  934664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  934667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934697 */     // MIs[1] Operand 1
     /*  934697 */     // No operand predicates
     /*  934697 */     // MIs[0] round
     /*  934697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934709 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  934712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934734 */     GIR_RootConstrainSelectedInstOperands,
     /*  934735 */     // GIR_Coverage, 16063,
     /*  934735 */     GIR_EraseRootFromParent_Done,
     /*  934736 */   // Label 14139: @934736
     /*  934736 */   GIM_Try, /*On fail goto*//*Label 14140*/ GIMT_Encode4(934827), // Rule ID 16242 //
     /*  934741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  934752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  934755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  934758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934788 */     // MIs[1] Operand 1
     /*  934788 */     // No operand predicates
     /*  934788 */     // MIs[0] round
     /*  934788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934800 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  934800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  934803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934812 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934825 */     GIR_RootConstrainSelectedInstOperands,
     /*  934826 */     // GIR_Coverage, 16242,
     /*  934826 */     GIR_EraseRootFromParent_Done,
     /*  934827 */   // Label 14140: @934827
     /*  934827 */   GIM_Try, /*On fail goto*//*Label 14141*/ GIMT_Encode4(934918), // Rule ID 16243 //
     /*  934832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  934843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  934846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  934849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934879 */     // MIs[1] Operand 1
     /*  934879 */     // No operand predicates
     /*  934879 */     // MIs[0] round
     /*  934879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934891 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  934891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  934894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934916 */     GIR_RootConstrainSelectedInstOperands,
     /*  934917 */     // GIR_Coverage, 16243,
     /*  934917 */     GIR_EraseRootFromParent_Done,
     /*  934918 */   // Label 14141: @934918
     /*  934918 */   GIM_Try, /*On fail goto*//*Label 14142*/ GIMT_Encode4(935009), // Rule ID 16246 //
     /*  934923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  934934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  934937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  934940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934970 */     // MIs[1] Operand 1
     /*  934970 */     // No operand predicates
     /*  934970 */     // MIs[0] round
     /*  934970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934982 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  934982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  934985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934994 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935007 */     GIR_RootConstrainSelectedInstOperands,
     /*  935008 */     // GIR_Coverage, 16246,
     /*  935008 */     GIR_EraseRootFromParent_Done,
     /*  935009 */   // Label 14142: @935009
     /*  935009 */   GIM_Try, /*On fail goto*//*Label 14143*/ GIMT_Encode4(935100), // Rule ID 16247 //
     /*  935014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  935025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  935028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  935031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935061 */     // MIs[1] Operand 1
     /*  935061 */     // No operand predicates
     /*  935061 */     // MIs[0] round
     /*  935061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935073 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  935076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935098 */     GIR_RootConstrainSelectedInstOperands,
     /*  935099 */     // GIR_Coverage, 16247,
     /*  935099 */     GIR_EraseRootFromParent_Done,
     /*  935100 */   // Label 14143: @935100
     /*  935100 */   GIM_Try, /*On fail goto*//*Label 14144*/ GIMT_Encode4(935191), // Rule ID 16250 //
     /*  935105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  935116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  935119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  935122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935152 */     // MIs[1] Operand 1
     /*  935152 */     // No operand predicates
     /*  935152 */     // MIs[0] round
     /*  935152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935164 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  935167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935176 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935189 */     GIR_RootConstrainSelectedInstOperands,
     /*  935190 */     // GIR_Coverage, 16250,
     /*  935190 */     GIR_EraseRootFromParent_Done,
     /*  935191 */   // Label 14144: @935191
     /*  935191 */   GIM_Try, /*On fail goto*//*Label 14145*/ GIMT_Encode4(935282), // Rule ID 16251 //
     /*  935196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  935207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  935210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  935213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935243 */     // MIs[1] Operand 1
     /*  935243 */     // No operand predicates
     /*  935243 */     // MIs[0] round
     /*  935243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935255 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  935258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935280 */     GIR_RootConstrainSelectedInstOperands,
     /*  935281 */     // GIR_Coverage, 16251,
     /*  935281 */     GIR_EraseRootFromParent_Done,
     /*  935282 */   // Label 14145: @935282
     /*  935282 */   GIM_Try, /*On fail goto*//*Label 14146*/ GIMT_Encode4(935373), // Rule ID 16254 //
     /*  935287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  935298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  935301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  935304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935334 */     // MIs[1] Operand 1
     /*  935334 */     // No operand predicates
     /*  935334 */     // MIs[0] round
     /*  935334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  935346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  935349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935358 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935371 */     GIR_RootConstrainSelectedInstOperands,
     /*  935372 */     // GIR_Coverage, 16254,
     /*  935372 */     GIR_EraseRootFromParent_Done,
     /*  935373 */   // Label 14146: @935373
     /*  935373 */   GIM_Try, /*On fail goto*//*Label 14147*/ GIMT_Encode4(935464), // Rule ID 16255 //
     /*  935378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  935389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  935392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  935395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935425 */     // MIs[1] Operand 1
     /*  935425 */     // No operand predicates
     /*  935425 */     // MIs[0] round
     /*  935425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935437 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  935437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  935440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935462 */     GIR_RootConstrainSelectedInstOperands,
     /*  935463 */     // GIR_Coverage, 16255,
     /*  935463 */     GIR_EraseRootFromParent_Done,
     /*  935464 */   // Label 14147: @935464
     /*  935464 */   GIM_Try, /*On fail goto*//*Label 14148*/ GIMT_Encode4(935555), // Rule ID 16258 //
     /*  935469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  935480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  935483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  935486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935516 */     // MIs[1] Operand 1
     /*  935516 */     // No operand predicates
     /*  935516 */     // MIs[0] round
     /*  935516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935528 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  935528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  935531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935540 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935553 */     GIR_RootConstrainSelectedInstOperands,
     /*  935554 */     // GIR_Coverage, 16258,
     /*  935554 */     GIR_EraseRootFromParent_Done,
     /*  935555 */   // Label 14148: @935555
     /*  935555 */   GIM_Try, /*On fail goto*//*Label 14149*/ GIMT_Encode4(935646), // Rule ID 16259 //
     /*  935560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  935571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  935574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  935577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935607 */     // MIs[1] Operand 1
     /*  935607 */     // No operand predicates
     /*  935607 */     // MIs[0] round
     /*  935607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935619 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  935619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  935622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935644 */     GIR_RootConstrainSelectedInstOperands,
     /*  935645 */     // GIR_Coverage, 16259,
     /*  935645 */     GIR_EraseRootFromParent_Done,
     /*  935646 */   // Label 14149: @935646
     /*  935646 */   GIM_Try, /*On fail goto*//*Label 14150*/ GIMT_Encode4(935737), // Rule ID 16262 //
     /*  935651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  935662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  935665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  935668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935698 */     // MIs[1] Operand 1
     /*  935698 */     // No operand predicates
     /*  935698 */     // MIs[0] round
     /*  935698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935710 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  935710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  935713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935722 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  935732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935735 */     GIR_RootConstrainSelectedInstOperands,
     /*  935736 */     // GIR_Coverage, 16262,
     /*  935736 */     GIR_EraseRootFromParent_Done,
     /*  935737 */   // Label 14150: @935737
     /*  935737 */   GIM_Try, /*On fail goto*//*Label 14151*/ GIMT_Encode4(935828), // Rule ID 16263 //
     /*  935742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  935753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  935756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  935759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935789 */     // MIs[1] Operand 1
     /*  935789 */     // No operand predicates
     /*  935789 */     // MIs[0] round
     /*  935789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935801 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  935801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  935804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  935823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935826 */     GIR_RootConstrainSelectedInstOperands,
     /*  935827 */     // GIR_Coverage, 16263,
     /*  935827 */     GIR_EraseRootFromParent_Done,
     /*  935828 */   // Label 14151: @935828
     /*  935828 */   GIM_Try, /*On fail goto*//*Label 14152*/ GIMT_Encode4(935919), // Rule ID 16266 //
     /*  935833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  935844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  935847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  935850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935880 */     // MIs[1] Operand 1
     /*  935880 */     // No operand predicates
     /*  935880 */     // MIs[0] round
     /*  935880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935892 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  935895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935904 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935917 */     GIR_RootConstrainSelectedInstOperands,
     /*  935918 */     // GIR_Coverage, 16266,
     /*  935918 */     GIR_EraseRootFromParent_Done,
     /*  935919 */   // Label 14152: @935919
     /*  935919 */   GIM_Try, /*On fail goto*//*Label 14153*/ GIMT_Encode4(936010), // Rule ID 16267 //
     /*  935924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  935935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  935938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  935941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935971 */     // MIs[1] Operand 1
     /*  935971 */     // No operand predicates
     /*  935971 */     // MIs[0] round
     /*  935971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935983 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  935986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936008 */     GIR_RootConstrainSelectedInstOperands,
     /*  936009 */     // GIR_Coverage, 16267,
     /*  936009 */     GIR_EraseRootFromParent_Done,
     /*  936010 */   // Label 14153: @936010
     /*  936010 */   GIM_Try, /*On fail goto*//*Label 14154*/ GIMT_Encode4(936101), // Rule ID 16270 //
     /*  936015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  936026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  936029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  936032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936062 */     // MIs[1] Operand 1
     /*  936062 */     // No operand predicates
     /*  936062 */     // MIs[0] round
     /*  936062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  936077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936099 */     GIR_RootConstrainSelectedInstOperands,
     /*  936100 */     // GIR_Coverage, 16270,
     /*  936100 */     GIR_EraseRootFromParent_Done,
     /*  936101 */   // Label 14154: @936101
     /*  936101 */   GIM_Try, /*On fail goto*//*Label 14155*/ GIMT_Encode4(936192), // Rule ID 16271 //
     /*  936106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  936117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  936120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  936123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936153 */     // MIs[1] Operand 1
     /*  936153 */     // No operand predicates
     /*  936153 */     // MIs[0] round
     /*  936153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936165 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  936168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936190 */     GIR_RootConstrainSelectedInstOperands,
     /*  936191 */     // GIR_Coverage, 16271,
     /*  936191 */     GIR_EraseRootFromParent_Done,
     /*  936192 */   // Label 14155: @936192
     /*  936192 */   GIM_Try, /*On fail goto*//*Label 14156*/ GIMT_Encode4(936283), // Rule ID 16274 //
     /*  936197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  936208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  936211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  936214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936244 */     // MIs[1] Operand 1
     /*  936244 */     // No operand predicates
     /*  936244 */     // MIs[0] round
     /*  936244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  936256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  936259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936268 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936281 */     GIR_RootConstrainSelectedInstOperands,
     /*  936282 */     // GIR_Coverage, 16274,
     /*  936282 */     GIR_EraseRootFromParent_Done,
     /*  936283 */   // Label 14156: @936283
     /*  936283 */   GIM_Try, /*On fail goto*//*Label 14157*/ GIMT_Encode4(936374), // Rule ID 16275 //
     /*  936288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  936299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  936302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  936305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936335 */     // MIs[1] Operand 1
     /*  936335 */     // No operand predicates
     /*  936335 */     // MIs[0] round
     /*  936335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936347 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  936347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  936350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936372 */     GIR_RootConstrainSelectedInstOperands,
     /*  936373 */     // GIR_Coverage, 16275,
     /*  936373 */     GIR_EraseRootFromParent_Done,
     /*  936374 */   // Label 14157: @936374
     /*  936374 */   GIM_Try, /*On fail goto*//*Label 14158*/ GIMT_Encode4(936465), // Rule ID 16278 //
     /*  936379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  936382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  936390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  936393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  936396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936426 */     // MIs[1] Operand 1
     /*  936426 */     // No operand predicates
     /*  936426 */     // MIs[0] round
     /*  936426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936438 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  936438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  936441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936450 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  936460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936463 */     GIR_RootConstrainSelectedInstOperands,
     /*  936464 */     // GIR_Coverage, 16278,
     /*  936464 */     GIR_EraseRootFromParent_Done,
     /*  936465 */   // Label 14158: @936465
     /*  936465 */   GIM_Try, /*On fail goto*//*Label 14159*/ GIMT_Encode4(936556), // Rule ID 16279 //
     /*  936470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  936473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  936481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  936484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  936487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936517 */     // MIs[1] Operand 1
     /*  936517 */     // No operand predicates
     /*  936517 */     // MIs[0] round
     /*  936517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936529 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  936529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  936532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  936551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936554 */     GIR_RootConstrainSelectedInstOperands,
     /*  936555 */     // GIR_Coverage, 16279,
     /*  936555 */     GIR_EraseRootFromParent_Done,
     /*  936556 */   // Label 14159: @936556
     /*  936556 */   GIM_Try, /*On fail goto*//*Label 14160*/ GIMT_Encode4(936647), // Rule ID 16282 //
     /*  936561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  936572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  936575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  936578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936608 */     // MIs[1] Operand 1
     /*  936608 */     // No operand predicates
     /*  936608 */     // MIs[0] round
     /*  936608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936620 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  936620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  936623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936632 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936645 */     GIR_RootConstrainSelectedInstOperands,
     /*  936646 */     // GIR_Coverage, 16282,
     /*  936646 */     GIR_EraseRootFromParent_Done,
     /*  936647 */   // Label 14160: @936647
     /*  936647 */   GIM_Try, /*On fail goto*//*Label 14161*/ GIMT_Encode4(936738), // Rule ID 16283 //
     /*  936652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  936663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  936666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  936669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936699 */     // MIs[1] Operand 1
     /*  936699 */     // No operand predicates
     /*  936699 */     // MIs[0] round
     /*  936699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936711 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  936711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  936714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936736 */     GIR_RootConstrainSelectedInstOperands,
     /*  936737 */     // GIR_Coverage, 16283,
     /*  936737 */     GIR_EraseRootFromParent_Done,
     /*  936738 */   // Label 14161: @936738
     /*  936738 */   GIM_Try, /*On fail goto*//*Label 14162*/ GIMT_Encode4(936829), // Rule ID 16286 //
     /*  936743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  936754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  936757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  936760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936790 */     // MIs[1] Operand 1
     /*  936790 */     // No operand predicates
     /*  936790 */     // MIs[0] round
     /*  936790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936802 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  936802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  936805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936814 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936827 */     GIR_RootConstrainSelectedInstOperands,
     /*  936828 */     // GIR_Coverage, 16286,
     /*  936828 */     GIR_EraseRootFromParent_Done,
     /*  936829 */   // Label 14162: @936829
     /*  936829 */   GIM_Try, /*On fail goto*//*Label 14163*/ GIMT_Encode4(936920), // Rule ID 16287 //
     /*  936834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  936845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  936848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  936851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936881 */     // MIs[1] Operand 1
     /*  936881 */     // No operand predicates
     /*  936881 */     // MIs[0] round
     /*  936881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936893 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  936893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  936896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936918 */     GIR_RootConstrainSelectedInstOperands,
     /*  936919 */     // GIR_Coverage, 16287,
     /*  936919 */     GIR_EraseRootFromParent_Done,
     /*  936920 */   // Label 14163: @936920
     /*  936920 */   GIM_Try, /*On fail goto*//*Label 14164*/ GIMT_Encode4(937011), // Rule ID 16290 //
     /*  936925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  936936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  936939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  936942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936972 */     // MIs[1] Operand 1
     /*  936972 */     // No operand predicates
     /*  936972 */     // MIs[0] round
     /*  936972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936984 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  936984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  936987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936996 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937009 */     GIR_RootConstrainSelectedInstOperands,
     /*  937010 */     // GIR_Coverage, 16290,
     /*  937010 */     GIR_EraseRootFromParent_Done,
     /*  937011 */   // Label 14164: @937011
     /*  937011 */   GIM_Try, /*On fail goto*//*Label 14165*/ GIMT_Encode4(937102), // Rule ID 16291 //
     /*  937016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  937027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  937030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  937033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937063 */     // MIs[1] Operand 1
     /*  937063 */     // No operand predicates
     /*  937063 */     // MIs[0] round
     /*  937063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937075 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  937075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  937078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937100 */     GIR_RootConstrainSelectedInstOperands,
     /*  937101 */     // GIR_Coverage, 16291,
     /*  937101 */     GIR_EraseRootFromParent_Done,
     /*  937102 */   // Label 14165: @937102
     /*  937102 */   GIM_Try, /*On fail goto*//*Label 14166*/ GIMT_Encode4(937193), // Rule ID 16294 //
     /*  937107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  937118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  937121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  937124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937154 */     // MIs[1] Operand 1
     /*  937154 */     // No operand predicates
     /*  937154 */     // MIs[0] round
     /*  937154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937166 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  937166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  937169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937178 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937191 */     GIR_RootConstrainSelectedInstOperands,
     /*  937192 */     // GIR_Coverage, 16294,
     /*  937192 */     GIR_EraseRootFromParent_Done,
     /*  937193 */   // Label 14166: @937193
     /*  937193 */   GIM_Try, /*On fail goto*//*Label 14167*/ GIMT_Encode4(937284), // Rule ID 16295 //
     /*  937198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  937209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  937212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  937215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937245 */     // MIs[1] Operand 1
     /*  937245 */     // No operand predicates
     /*  937245 */     // MIs[0] round
     /*  937245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937257 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  937257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  937260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937282 */     GIR_RootConstrainSelectedInstOperands,
     /*  937283 */     // GIR_Coverage, 16295,
     /*  937283 */     GIR_EraseRootFromParent_Done,
     /*  937284 */   // Label 14167: @937284
     /*  937284 */   GIM_Try, /*On fail goto*//*Label 14168*/ GIMT_Encode4(937375), // Rule ID 16298 //
     /*  937289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  937300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  937303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  937306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937336 */     // MIs[1] Operand 1
     /*  937336 */     // No operand predicates
     /*  937336 */     // MIs[0] round
     /*  937336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937348 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  937348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  937351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937360 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937373 */     GIR_RootConstrainSelectedInstOperands,
     /*  937374 */     // GIR_Coverage, 16298,
     /*  937374 */     GIR_EraseRootFromParent_Done,
     /*  937375 */   // Label 14168: @937375
     /*  937375 */   GIM_Try, /*On fail goto*//*Label 14169*/ GIMT_Encode4(937466), // Rule ID 16299 //
     /*  937380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  937391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  937394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  937397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937427 */     // MIs[1] Operand 1
     /*  937427 */     // No operand predicates
     /*  937427 */     // MIs[0] round
     /*  937427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937439 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  937439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  937442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937464 */     GIR_RootConstrainSelectedInstOperands,
     /*  937465 */     // GIR_Coverage, 16299,
     /*  937465 */     GIR_EraseRootFromParent_Done,
     /*  937466 */   // Label 14169: @937466
     /*  937466 */   GIM_Try, /*On fail goto*//*Label 14170*/ GIMT_Encode4(937557), // Rule ID 16302 //
     /*  937471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  937482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  937485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  937488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937518 */     // MIs[1] Operand 1
     /*  937518 */     // No operand predicates
     /*  937518 */     // MIs[0] round
     /*  937518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937530 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  937530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  937533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937542 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937555 */     GIR_RootConstrainSelectedInstOperands,
     /*  937556 */     // GIR_Coverage, 16302,
     /*  937556 */     GIR_EraseRootFromParent_Done,
     /*  937557 */   // Label 14170: @937557
     /*  937557 */   GIM_Try, /*On fail goto*//*Label 14171*/ GIMT_Encode4(937648), // Rule ID 16303 //
     /*  937562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  937573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  937576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  937579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937609 */     // MIs[1] Operand 1
     /*  937609 */     // No operand predicates
     /*  937609 */     // MIs[0] round
     /*  937609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937621 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  937621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  937624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937646 */     GIR_RootConstrainSelectedInstOperands,
     /*  937647 */     // GIR_Coverage, 16303,
     /*  937647 */     GIR_EraseRootFromParent_Done,
     /*  937648 */   // Label 14171: @937648
     /*  937648 */   GIM_Try, /*On fail goto*//*Label 14172*/ GIMT_Encode4(937739), // Rule ID 16306 //
     /*  937653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  937664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  937667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  937670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937700 */     // MIs[1] Operand 1
     /*  937700 */     // No operand predicates
     /*  937700 */     // MIs[0] round
     /*  937700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  937715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937724 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937737 */     GIR_RootConstrainSelectedInstOperands,
     /*  937738 */     // GIR_Coverage, 16306,
     /*  937738 */     GIR_EraseRootFromParent_Done,
     /*  937739 */   // Label 14172: @937739
     /*  937739 */   GIM_Try, /*On fail goto*//*Label 14173*/ GIMT_Encode4(937830), // Rule ID 16307 //
     /*  937744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  937755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  937758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  937761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937791 */     // MIs[1] Operand 1
     /*  937791 */     // No operand predicates
     /*  937791 */     // MIs[0] round
     /*  937791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  937806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937828 */     GIR_RootConstrainSelectedInstOperands,
     /*  937829 */     // GIR_Coverage, 16307,
     /*  937829 */     GIR_EraseRootFromParent_Done,
     /*  937830 */   // Label 14173: @937830
     /*  937830 */   GIM_Try, /*On fail goto*//*Label 14174*/ GIMT_Encode4(937921), // Rule ID 16310 //
     /*  937835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  937846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  937849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  937852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937882 */     // MIs[1] Operand 1
     /*  937882 */     // No operand predicates
     /*  937882 */     // MIs[0] round
     /*  937882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937894 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  937897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937906 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937919 */     GIR_RootConstrainSelectedInstOperands,
     /*  937920 */     // GIR_Coverage, 16310,
     /*  937920 */     GIR_EraseRootFromParent_Done,
     /*  937921 */   // Label 14174: @937921
     /*  937921 */   GIM_Try, /*On fail goto*//*Label 14175*/ GIMT_Encode4(938012), // Rule ID 16311 //
     /*  937926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  937937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  937940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  937943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937973 */     // MIs[1] Operand 1
     /*  937973 */     // No operand predicates
     /*  937973 */     // MIs[0] round
     /*  937973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937985 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  937988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  938007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938010 */     GIR_RootConstrainSelectedInstOperands,
     /*  938011 */     // GIR_Coverage, 16311,
     /*  938011 */     GIR_EraseRootFromParent_Done,
     /*  938012 */   // Label 14175: @938012
     /*  938012 */   GIM_Try, /*On fail goto*//*Label 14176*/ GIMT_Encode4(938103), // Rule ID 16314 //
     /*  938017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  938028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  938031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  938034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938064 */     // MIs[1] Operand 1
     /*  938064 */     // No operand predicates
     /*  938064 */     // MIs[0] round
     /*  938064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  938076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  938079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938088 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  938098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938101 */     GIR_RootConstrainSelectedInstOperands,
     /*  938102 */     // GIR_Coverage, 16314,
     /*  938102 */     GIR_EraseRootFromParent_Done,
     /*  938103 */   // Label 14176: @938103
     /*  938103 */   GIM_Try, /*On fail goto*//*Label 14177*/ GIMT_Encode4(938194), // Rule ID 16315 //
     /*  938108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  938119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  938122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  938125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938155 */     // MIs[1] Operand 1
     /*  938155 */     // No operand predicates
     /*  938155 */     // MIs[0] round
     /*  938155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938167 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  938167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  938170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  938189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938192 */     GIR_RootConstrainSelectedInstOperands,
     /*  938193 */     // GIR_Coverage, 16315,
     /*  938193 */     GIR_EraseRootFromParent_Done,
     /*  938194 */   // Label 14177: @938194
     /*  938194 */   GIM_Try, /*On fail goto*//*Label 14178*/ GIMT_Encode4(938285), // Rule ID 16318 //
     /*  938199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  938202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  938210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  938213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  938216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938246 */     // MIs[1] Operand 1
     /*  938246 */     // No operand predicates
     /*  938246 */     // MIs[0] round
     /*  938246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  938258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  938261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  938280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938283 */     GIR_RootConstrainSelectedInstOperands,
     /*  938284 */     // GIR_Coverage, 16318,
     /*  938284 */     GIR_EraseRootFromParent_Done,
     /*  938285 */   // Label 14178: @938285
     /*  938285 */   GIM_Try, /*On fail goto*//*Label 14179*/ GIMT_Encode4(938376), // Rule ID 16319 //
     /*  938290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  938293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  938301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  938304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  938307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938337 */     // MIs[1] Operand 1
     /*  938337 */     // No operand predicates
     /*  938337 */     // MIs[0] round
     /*  938337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  938349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  938352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  938371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938374 */     GIR_RootConstrainSelectedInstOperands,
     /*  938375 */     // GIR_Coverage, 16319,
     /*  938375 */     GIR_EraseRootFromParent_Done,
     /*  938376 */   // Label 14179: @938376
     /*  938376 */   GIM_Try, /*On fail goto*//*Label 14180*/ GIMT_Encode4(938467), // Rule ID 16322 //
     /*  938381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  938384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  938392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  938395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  938398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938424 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938428 */     // MIs[1] Operand 1
     /*  938428 */     // No operand predicates
     /*  938428 */     // MIs[0] round
     /*  938428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938440 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  938440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  938443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938452 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  938462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938465 */     GIR_RootConstrainSelectedInstOperands,
     /*  938466 */     // GIR_Coverage, 16322,
     /*  938466 */     GIR_EraseRootFromParent_Done,
     /*  938467 */   // Label 14180: @938467
     /*  938467 */   GIM_Try, /*On fail goto*//*Label 14181*/ GIMT_Encode4(938558), // Rule ID 16323 //
     /*  938472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  938475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  938483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  938486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  938489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938519 */     // MIs[1] Operand 1
     /*  938519 */     // No operand predicates
     /*  938519 */     // MIs[0] round
     /*  938519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938531 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  938531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  938534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  938553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938556 */     GIR_RootConstrainSelectedInstOperands,
     /*  938557 */     // GIR_Coverage, 16323,
     /*  938557 */     GIR_EraseRootFromParent_Done,
     /*  938558 */   // Label 14181: @938558
     /*  938558 */   GIM_Try, /*On fail goto*//*Label 14182*/ GIMT_Encode4(938649), // Rule ID 16326 //
     /*  938563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  938566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  938574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  938577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  938580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938610 */     // MIs[1] Operand 1
     /*  938610 */     // No operand predicates
     /*  938610 */     // MIs[0] round
     /*  938610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938622 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  938622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  938625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938634 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  938644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938647 */     GIR_RootConstrainSelectedInstOperands,
     /*  938648 */     // GIR_Coverage, 16326,
     /*  938648 */     GIR_EraseRootFromParent_Done,
     /*  938649 */   // Label 14182: @938649
     /*  938649 */   GIM_Try, /*On fail goto*//*Label 14183*/ GIMT_Encode4(938740), // Rule ID 16327 //
     /*  938654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  938657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  938665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  938668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  938671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938701 */     // MIs[1] Operand 1
     /*  938701 */     // No operand predicates
     /*  938701 */     // MIs[0] round
     /*  938701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938713 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  938713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  938716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  938735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938738 */     GIR_RootConstrainSelectedInstOperands,
     /*  938739 */     // GIR_Coverage, 16327,
     /*  938739 */     GIR_EraseRootFromParent_Done,
     /*  938740 */   // Label 14183: @938740
     /*  938740 */   GIM_Try, /*On fail goto*//*Label 14184*/ GIMT_Encode4(938834), // Rule ID 16450 //
     /*  938745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  938753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  938756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  938759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  938762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938792 */     // MIs[1] Operand 1
     /*  938792 */     // No operand predicates
     /*  938792 */     // MIs[0] round
     /*  938792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938804 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  938807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938816 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938832 */     GIR_RootConstrainSelectedInstOperands,
     /*  938833 */     // GIR_Coverage, 16450,
     /*  938833 */     GIR_EraseRootFromParent_Done,
     /*  938834 */   // Label 14184: @938834
     /*  938834 */   GIM_Try, /*On fail goto*//*Label 14185*/ GIMT_Encode4(938928), // Rule ID 16451 //
     /*  938839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  938847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  938850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  938853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  938856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938886 */     // MIs[1] Operand 1
     /*  938886 */     // No operand predicates
     /*  938886 */     // MIs[0] round
     /*  938886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938898 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  938901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938926 */     GIR_RootConstrainSelectedInstOperands,
     /*  938927 */     // GIR_Coverage, 16451,
     /*  938927 */     GIR_EraseRootFromParent_Done,
     /*  938928 */   // Label 14185: @938928
     /*  938928 */   GIM_Try, /*On fail goto*//*Label 14186*/ GIMT_Encode4(939022), // Rule ID 16454 //
     /*  938933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  938941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  938944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  938947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  938950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938980 */     // MIs[1] Operand 1
     /*  938980 */     // No operand predicates
     /*  938980 */     // MIs[0] round
     /*  938980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938992 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  938995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939004 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939020 */     GIR_RootConstrainSelectedInstOperands,
     /*  939021 */     // GIR_Coverage, 16454,
     /*  939021 */     GIR_EraseRootFromParent_Done,
     /*  939022 */   // Label 14186: @939022
     /*  939022 */   GIM_Try, /*On fail goto*//*Label 14187*/ GIMT_Encode4(939116), // Rule ID 16455 //
     /*  939027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  939038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  939041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  939044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939074 */     // MIs[1] Operand 1
     /*  939074 */     // No operand predicates
     /*  939074 */     // MIs[0] round
     /*  939074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939086 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  939089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939098 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939114 */     GIR_RootConstrainSelectedInstOperands,
     /*  939115 */     // GIR_Coverage, 16455,
     /*  939115 */     GIR_EraseRootFromParent_Done,
     /*  939116 */   // Label 14187: @939116
     /*  939116 */   GIM_Try, /*On fail goto*//*Label 14188*/ GIMT_Encode4(939210), // Rule ID 16458 //
     /*  939121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  939132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  939135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  939138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939168 */     // MIs[1] Operand 1
     /*  939168 */     // No operand predicates
     /*  939168 */     // MIs[0] round
     /*  939168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939180 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  939180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  939183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939192 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939208 */     GIR_RootConstrainSelectedInstOperands,
     /*  939209 */     // GIR_Coverage, 16458,
     /*  939209 */     GIR_EraseRootFromParent_Done,
     /*  939210 */   // Label 14188: @939210
     /*  939210 */   GIM_Try, /*On fail goto*//*Label 14189*/ GIMT_Encode4(939304), // Rule ID 16459 //
     /*  939215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  939226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  939229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  939232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939262 */     // MIs[1] Operand 1
     /*  939262 */     // No operand predicates
     /*  939262 */     // MIs[0] round
     /*  939262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939274 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  939277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939302 */     GIR_RootConstrainSelectedInstOperands,
     /*  939303 */     // GIR_Coverage, 16459,
     /*  939303 */     GIR_EraseRootFromParent_Done,
     /*  939304 */   // Label 14189: @939304
     /*  939304 */   GIM_Try, /*On fail goto*//*Label 14190*/ GIMT_Encode4(939398), // Rule ID 16462 //
     /*  939309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  939320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  939323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  939326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939356 */     // MIs[1] Operand 1
     /*  939356 */     // No operand predicates
     /*  939356 */     // MIs[0] round
     /*  939356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939368 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  939368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  939371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939380 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939393 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939396 */     GIR_RootConstrainSelectedInstOperands,
     /*  939397 */     // GIR_Coverage, 16462,
     /*  939397 */     GIR_EraseRootFromParent_Done,
     /*  939398 */   // Label 14190: @939398
     /*  939398 */   GIM_Try, /*On fail goto*//*Label 14191*/ GIMT_Encode4(939492), // Rule ID 16463 //
     /*  939403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  939414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  939417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  939420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939450 */     // MIs[1] Operand 1
     /*  939450 */     // No operand predicates
     /*  939450 */     // MIs[0] round
     /*  939450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939462 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  939465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939474 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939490 */     GIR_RootConstrainSelectedInstOperands,
     /*  939491 */     // GIR_Coverage, 16463,
     /*  939491 */     GIR_EraseRootFromParent_Done,
     /*  939492 */   // Label 14191: @939492
     /*  939492 */   GIM_Try, /*On fail goto*//*Label 14192*/ GIMT_Encode4(939586), // Rule ID 16466 //
     /*  939497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  939508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  939511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  939514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939544 */     // MIs[1] Operand 1
     /*  939544 */     // No operand predicates
     /*  939544 */     // MIs[0] round
     /*  939544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939556 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  939556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  939559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939568 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939584 */     GIR_RootConstrainSelectedInstOperands,
     /*  939585 */     // GIR_Coverage, 16466,
     /*  939585 */     GIR_EraseRootFromParent_Done,
     /*  939586 */   // Label 14192: @939586
     /*  939586 */   GIM_Try, /*On fail goto*//*Label 14193*/ GIMT_Encode4(939680), // Rule ID 16467 //
     /*  939591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  939602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  939605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  939608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939638 */     // MIs[1] Operand 1
     /*  939638 */     // No operand predicates
     /*  939638 */     // MIs[0] round
     /*  939638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939650 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  939653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939662 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939678 */     GIR_RootConstrainSelectedInstOperands,
     /*  939679 */     // GIR_Coverage, 16467,
     /*  939679 */     GIR_EraseRootFromParent_Done,
     /*  939680 */   // Label 14193: @939680
     /*  939680 */   GIM_Try, /*On fail goto*//*Label 14194*/ GIMT_Encode4(939774), // Rule ID 16470 //
     /*  939685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  939696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  939699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  939702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939732 */     // MIs[1] Operand 1
     /*  939732 */     // No operand predicates
     /*  939732 */     // MIs[0] round
     /*  939732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939744 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  939744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  939747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939756 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939772 */     GIR_RootConstrainSelectedInstOperands,
     /*  939773 */     // GIR_Coverage, 16470,
     /*  939773 */     GIR_EraseRootFromParent_Done,
     /*  939774 */   // Label 14194: @939774
     /*  939774 */   GIM_Try, /*On fail goto*//*Label 14195*/ GIMT_Encode4(939868), // Rule ID 16471 //
     /*  939779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  939790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  939793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  939796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939826 */     // MIs[1] Operand 1
     /*  939826 */     // No operand predicates
     /*  939826 */     // MIs[0] round
     /*  939826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939838 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  939841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939850 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939866 */     GIR_RootConstrainSelectedInstOperands,
     /*  939867 */     // GIR_Coverage, 16471,
     /*  939867 */     GIR_EraseRootFromParent_Done,
     /*  939868 */   // Label 14195: @939868
     /*  939868 */   GIM_Try, /*On fail goto*//*Label 14196*/ GIMT_Encode4(939962), // Rule ID 16474 //
     /*  939873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  939884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  939887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  939890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939920 */     // MIs[1] Operand 1
     /*  939920 */     // No operand predicates
     /*  939920 */     // MIs[0] round
     /*  939920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939932 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  939935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939944 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939960 */     GIR_RootConstrainSelectedInstOperands,
     /*  939961 */     // GIR_Coverage, 16474,
     /*  939961 */     GIR_EraseRootFromParent_Done,
     /*  939962 */   // Label 14196: @939962
     /*  939962 */   GIM_Try, /*On fail goto*//*Label 14197*/ GIMT_Encode4(940056), // Rule ID 16475 //
     /*  939967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  939978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  939981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  939984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940014 */     // MIs[1] Operand 1
     /*  940014 */     // No operand predicates
     /*  940014 */     // MIs[0] round
     /*  940014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  940029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940038 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940054 */     GIR_RootConstrainSelectedInstOperands,
     /*  940055 */     // GIR_Coverage, 16475,
     /*  940055 */     GIR_EraseRootFromParent_Done,
     /*  940056 */   // Label 14197: @940056
     /*  940056 */   GIM_Try, /*On fail goto*//*Label 14198*/ GIMT_Encode4(940150), // Rule ID 16478 //
     /*  940061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  940072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  940075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  940078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940108 */     // MIs[1] Operand 1
     /*  940108 */     // No operand predicates
     /*  940108 */     // MIs[0] round
     /*  940108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940120 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  940120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  940123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940132 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940148 */     GIR_RootConstrainSelectedInstOperands,
     /*  940149 */     // GIR_Coverage, 16478,
     /*  940149 */     GIR_EraseRootFromParent_Done,
     /*  940150 */   // Label 14198: @940150
     /*  940150 */   GIM_Try, /*On fail goto*//*Label 14199*/ GIMT_Encode4(940244), // Rule ID 16479 //
     /*  940155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  940166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  940169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  940172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940202 */     // MIs[1] Operand 1
     /*  940202 */     // No operand predicates
     /*  940202 */     // MIs[0] round
     /*  940202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940214 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  940217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940226 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940242 */     GIR_RootConstrainSelectedInstOperands,
     /*  940243 */     // GIR_Coverage, 16479,
     /*  940243 */     GIR_EraseRootFromParent_Done,
     /*  940244 */   // Label 14199: @940244
     /*  940244 */   GIM_Try, /*On fail goto*//*Label 14200*/ GIMT_Encode4(940338), // Rule ID 16482 //
     /*  940249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  940260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  940263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  940266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940296 */     // MIs[1] Operand 1
     /*  940296 */     // No operand predicates
     /*  940296 */     // MIs[0] round
     /*  940296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  940308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  940311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940320 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940336 */     GIR_RootConstrainSelectedInstOperands,
     /*  940337 */     // GIR_Coverage, 16482,
     /*  940337 */     GIR_EraseRootFromParent_Done,
     /*  940338 */   // Label 14200: @940338
     /*  940338 */   GIM_Try, /*On fail goto*//*Label 14201*/ GIMT_Encode4(940432), // Rule ID 16483 //
     /*  940343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  940354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  940357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  940360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940390 */     // MIs[1] Operand 1
     /*  940390 */     // No operand predicates
     /*  940390 */     // MIs[0] round
     /*  940390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  940405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940414 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940430 */     GIR_RootConstrainSelectedInstOperands,
     /*  940431 */     // GIR_Coverage, 16483,
     /*  940431 */     GIR_EraseRootFromParent_Done,
     /*  940432 */   // Label 14201: @940432
     /*  940432 */   GIM_Try, /*On fail goto*//*Label 14202*/ GIMT_Encode4(940526), // Rule ID 16486 //
     /*  940437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  940448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  940451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  940454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940484 */     // MIs[1] Operand 1
     /*  940484 */     // No operand predicates
     /*  940484 */     // MIs[0] round
     /*  940484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940496 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  940496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  940499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940508 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940521 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940524 */     GIR_RootConstrainSelectedInstOperands,
     /*  940525 */     // GIR_Coverage, 16486,
     /*  940525 */     GIR_EraseRootFromParent_Done,
     /*  940526 */   // Label 14202: @940526
     /*  940526 */   GIM_Try, /*On fail goto*//*Label 14203*/ GIMT_Encode4(940620), // Rule ID 16487 //
     /*  940531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  940542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  940545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  940548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940578 */     // MIs[1] Operand 1
     /*  940578 */     // No operand predicates
     /*  940578 */     // MIs[0] round
     /*  940578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  940593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940602 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940618 */     GIR_RootConstrainSelectedInstOperands,
     /*  940619 */     // GIR_Coverage, 16487,
     /*  940619 */     GIR_EraseRootFromParent_Done,
     /*  940620 */   // Label 14203: @940620
     /*  940620 */   GIM_Try, /*On fail goto*//*Label 14204*/ GIMT_Encode4(940714), // Rule ID 16490 //
     /*  940625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  940636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  940639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  940642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940672 */     // MIs[1] Operand 1
     /*  940672 */     // No operand predicates
     /*  940672 */     // MIs[0] round
     /*  940672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940684 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  940684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  940687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940696 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940712 */     GIR_RootConstrainSelectedInstOperands,
     /*  940713 */     // GIR_Coverage, 16490,
     /*  940713 */     GIR_EraseRootFromParent_Done,
     /*  940714 */   // Label 14204: @940714
     /*  940714 */   GIM_Try, /*On fail goto*//*Label 14205*/ GIMT_Encode4(940808), // Rule ID 16491 //
     /*  940719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  940730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  940733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  940736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940766 */     // MIs[1] Operand 1
     /*  940766 */     // No operand predicates
     /*  940766 */     // MIs[0] round
     /*  940766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940778 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  940781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940806 */     GIR_RootConstrainSelectedInstOperands,
     /*  940807 */     // GIR_Coverage, 16491,
     /*  940807 */     GIR_EraseRootFromParent_Done,
     /*  940808 */   // Label 14205: @940808
     /*  940808 */   GIM_Try, /*On fail goto*//*Label 14206*/ GIMT_Encode4(940902), // Rule ID 16494 //
     /*  940813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  940830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940860 */     // MIs[1] Operand 1
     /*  940860 */     // No operand predicates
     /*  940860 */     // MIs[0] round
     /*  940860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940872 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  940875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940884 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940900 */     GIR_RootConstrainSelectedInstOperands,
     /*  940901 */     // GIR_Coverage, 16494,
     /*  940901 */     GIR_EraseRootFromParent_Done,
     /*  940902 */   // Label 14206: @940902
     /*  940902 */   GIM_Try, /*On fail goto*//*Label 14207*/ GIMT_Encode4(940996), // Rule ID 16495 //
     /*  940907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  940924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940954 */     // MIs[1] Operand 1
     /*  940954 */     // No operand predicates
     /*  940954 */     // MIs[0] round
     /*  940954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940966 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  940969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940978 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940994 */     GIR_RootConstrainSelectedInstOperands,
     /*  940995 */     // GIR_Coverage, 16495,
     /*  940995 */     GIR_EraseRootFromParent_Done,
     /*  940996 */   // Label 14207: @940996
     /*  940996 */   GIM_Try, /*On fail goto*//*Label 14208*/ GIMT_Encode4(941090), // Rule ID 16498 //
     /*  941001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  941004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  941009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  941012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  941015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  941018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  941021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941048 */     // MIs[1] Operand 1
     /*  941048 */     // No operand predicates
     /*  941048 */     // MIs[0] round
     /*  941048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941060 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  941060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  941063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941072 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941088 */     GIR_RootConstrainSelectedInstOperands,
     /*  941089 */     // GIR_Coverage, 16498,
     /*  941089 */     GIR_EraseRootFromParent_Done,
     /*  941090 */   // Label 14208: @941090
     /*  941090 */   GIM_Try, /*On fail goto*//*Label 14209*/ GIMT_Encode4(941184), // Rule ID 16499 //
     /*  941095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  941098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  941103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  941106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  941109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  941112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  941115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941142 */     // MIs[1] Operand 1
     /*  941142 */     // No operand predicates
     /*  941142 */     // MIs[0] round
     /*  941142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941154 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  941154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  941157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941182 */     GIR_RootConstrainSelectedInstOperands,
     /*  941183 */     // GIR_Coverage, 16499,
     /*  941183 */     GIR_EraseRootFromParent_Done,
     /*  941184 */   // Label 14209: @941184
     /*  941184 */   GIM_Try, /*On fail goto*//*Label 14210*/ GIMT_Encode4(941278), // Rule ID 16502 //
     /*  941189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  941192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  941197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  941200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  941203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  941206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  941209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941236 */     // MIs[1] Operand 1
     /*  941236 */     // No operand predicates
     /*  941236 */     // MIs[0] round
     /*  941236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  941248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  941251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941260 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941276 */     GIR_RootConstrainSelectedInstOperands,
     /*  941277 */     // GIR_Coverage, 16502,
     /*  941277 */     GIR_EraseRootFromParent_Done,
     /*  941278 */   // Label 14210: @941278
     /*  941278 */   GIM_Try, /*On fail goto*//*Label 14211*/ GIMT_Encode4(941372), // Rule ID 16503 //
     /*  941283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  941286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  941291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  941294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  941297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  941300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  941303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941330 */     // MIs[1] Operand 1
     /*  941330 */     // No operand predicates
     /*  941330 */     // MIs[0] round
     /*  941330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  941342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  941345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941354 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941370 */     GIR_RootConstrainSelectedInstOperands,
     /*  941371 */     // GIR_Coverage, 16503,
     /*  941371 */     GIR_EraseRootFromParent_Done,
     /*  941372 */   // Label 14211: @941372
     /*  941372 */   GIM_Try, /*On fail goto*//*Label 14212*/ GIMT_Encode4(941466), // Rule ID 16506 //
     /*  941377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  941380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  941385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  941394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  941397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941424 */     // MIs[1] Operand 1
     /*  941424 */     // No operand predicates
     /*  941424 */     // MIs[0] round
     /*  941424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941436 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  941436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  941439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941448 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941464 */     GIR_RootConstrainSelectedInstOperands,
     /*  941465 */     // GIR_Coverage, 16506,
     /*  941465 */     GIR_EraseRootFromParent_Done,
     /*  941466 */   // Label 14212: @941466
     /*  941466 */   GIM_Try, /*On fail goto*//*Label 14213*/ GIMT_Encode4(941560), // Rule ID 16507 //
     /*  941471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  941474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  941479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  941488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  941491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941518 */     // MIs[1] Operand 1
     /*  941518 */     // No operand predicates
     /*  941518 */     // MIs[0] round
     /*  941518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941530 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  941530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  941533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941542 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941558 */     GIR_RootConstrainSelectedInstOperands,
     /*  941559 */     // GIR_Coverage, 16507,
     /*  941559 */     GIR_EraseRootFromParent_Done,
     /*  941560 */   // Label 14213: @941560
     /*  941560 */   GIM_Try, /*On fail goto*//*Label 14214*/ GIMT_Encode4(941654), // Rule ID 16630 //
     /*  941565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  941568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  941573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  941576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  941579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  941582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  941585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941612 */     // MIs[1] Operand 1
     /*  941612 */     // No operand predicates
     /*  941612 */     // MIs[0] round
     /*  941612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941624 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  941624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  941627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941636 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  941646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941652 */     GIR_RootConstrainSelectedInstOperands,
     /*  941653 */     // GIR_Coverage, 16630,
     /*  941653 */     GIR_EraseRootFromParent_Done,
     /*  941654 */   // Label 14214: @941654
     /*  941654 */   GIM_Try, /*On fail goto*//*Label 14215*/ GIMT_Encode4(941748), // Rule ID 16631 //
     /*  941659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  941662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  941667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  941670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  941673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  941676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  941679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941706 */     // MIs[1] Operand 1
     /*  941706 */     // No operand predicates
     /*  941706 */     // MIs[0] round
     /*  941706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941718 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  941718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  941721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941730 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  941740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941746 */     GIR_RootConstrainSelectedInstOperands,
     /*  941747 */     // GIR_Coverage, 16631,
     /*  941747 */     GIR_EraseRootFromParent_Done,
     /*  941748 */   // Label 14215: @941748
     /*  941748 */   GIM_Try, /*On fail goto*//*Label 14216*/ GIMT_Encode4(941842), // Rule ID 16634 //
     /*  941753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  941756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  941761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  941764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  941767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  941770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  941773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941800 */     // MIs[1] Operand 1
     /*  941800 */     // No operand predicates
     /*  941800 */     // MIs[0] round
     /*  941800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941812 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  941812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  941815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941824 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  941834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941840 */     GIR_RootConstrainSelectedInstOperands,
     /*  941841 */     // GIR_Coverage, 16634,
     /*  941841 */     GIR_EraseRootFromParent_Done,
     /*  941842 */   // Label 14216: @941842
     /*  941842 */   GIM_Try, /*On fail goto*//*Label 14217*/ GIMT_Encode4(941936), // Rule ID 16635 //
     /*  941847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  941850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  941855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  941858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  941861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  941864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  941867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941894 */     // MIs[1] Operand 1
     /*  941894 */     // No operand predicates
     /*  941894 */     // MIs[0] round
     /*  941894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941906 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  941906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  941909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941918 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  941928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941934 */     GIR_RootConstrainSelectedInstOperands,
     /*  941935 */     // GIR_Coverage, 16635,
     /*  941935 */     GIR_EraseRootFromParent_Done,
     /*  941936 */   // Label 14217: @941936
     /*  941936 */   GIM_Try, /*On fail goto*//*Label 14218*/ GIMT_Encode4(942030), // Rule ID 16638 //
     /*  941941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  941944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  941949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  941952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  941955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  941958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  941961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941988 */     // MIs[1] Operand 1
     /*  941988 */     // No operand predicates
     /*  941988 */     // MIs[0] round
     /*  941988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942000 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  942000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  942003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942012 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942028 */     GIR_RootConstrainSelectedInstOperands,
     /*  942029 */     // GIR_Coverage, 16638,
     /*  942029 */     GIR_EraseRootFromParent_Done,
     /*  942030 */   // Label 14218: @942030
     /*  942030 */   GIM_Try, /*On fail goto*//*Label 14219*/ GIMT_Encode4(942124), // Rule ID 16639 //
     /*  942035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  942046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  942049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  942052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  942055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942082 */     // MIs[1] Operand 1
     /*  942082 */     // No operand predicates
     /*  942082 */     // MIs[0] round
     /*  942082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942094 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  942094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  942097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942106 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942122 */     GIR_RootConstrainSelectedInstOperands,
     /*  942123 */     // GIR_Coverage, 16639,
     /*  942123 */     GIR_EraseRootFromParent_Done,
     /*  942124 */   // Label 14219: @942124
     /*  942124 */   GIM_Try, /*On fail goto*//*Label 14220*/ GIMT_Encode4(942218), // Rule ID 16642 //
     /*  942129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  942140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  942143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  942146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  942149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942176 */     // MIs[1] Operand 1
     /*  942176 */     // No operand predicates
     /*  942176 */     // MIs[0] round
     /*  942176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942188 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  942188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  942191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942200 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942216 */     GIR_RootConstrainSelectedInstOperands,
     /*  942217 */     // GIR_Coverage, 16642,
     /*  942217 */     GIR_EraseRootFromParent_Done,
     /*  942218 */   // Label 14220: @942218
     /*  942218 */   GIM_Try, /*On fail goto*//*Label 14221*/ GIMT_Encode4(942312), // Rule ID 16643 //
     /*  942223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  942234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  942237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  942240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  942243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942270 */     // MIs[1] Operand 1
     /*  942270 */     // No operand predicates
     /*  942270 */     // MIs[0] round
     /*  942270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942282 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  942282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  942285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942294 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942310 */     GIR_RootConstrainSelectedInstOperands,
     /*  942311 */     // GIR_Coverage, 16643,
     /*  942311 */     GIR_EraseRootFromParent_Done,
     /*  942312 */   // Label 14221: @942312
     /*  942312 */   GIM_Try, /*On fail goto*//*Label 14222*/ GIMT_Encode4(942406), // Rule ID 16646 //
     /*  942317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  942328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  942331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  942334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  942337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942364 */     // MIs[1] Operand 1
     /*  942364 */     // No operand predicates
     /*  942364 */     // MIs[0] round
     /*  942364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942376 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  942376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  942379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942388 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942404 */     GIR_RootConstrainSelectedInstOperands,
     /*  942405 */     // GIR_Coverage, 16646,
     /*  942405 */     GIR_EraseRootFromParent_Done,
     /*  942406 */   // Label 14222: @942406
     /*  942406 */   GIM_Try, /*On fail goto*//*Label 14223*/ GIMT_Encode4(942500), // Rule ID 16647 //
     /*  942411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  942422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  942425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  942428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  942431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942458 */     // MIs[1] Operand 1
     /*  942458 */     // No operand predicates
     /*  942458 */     // MIs[0] round
     /*  942458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942470 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  942470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  942473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942482 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942498 */     GIR_RootConstrainSelectedInstOperands,
     /*  942499 */     // GIR_Coverage, 16647,
     /*  942499 */     GIR_EraseRootFromParent_Done,
     /*  942500 */   // Label 14223: @942500
     /*  942500 */   GIM_Try, /*On fail goto*//*Label 14224*/ GIMT_Encode4(942594), // Rule ID 16650 //
     /*  942505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  942516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  942519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  942522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  942525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942552 */     // MIs[1] Operand 1
     /*  942552 */     // No operand predicates
     /*  942552 */     // MIs[0] round
     /*  942552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942564 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  942564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  942567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942576 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942592 */     GIR_RootConstrainSelectedInstOperands,
     /*  942593 */     // GIR_Coverage, 16650,
     /*  942593 */     GIR_EraseRootFromParent_Done,
     /*  942594 */   // Label 14224: @942594
     /*  942594 */   GIM_Try, /*On fail goto*//*Label 14225*/ GIMT_Encode4(942688), // Rule ID 16651 //
     /*  942599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  942610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  942613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  942616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  942619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942646 */     // MIs[1] Operand 1
     /*  942646 */     // No operand predicates
     /*  942646 */     // MIs[0] round
     /*  942646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942658 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  942658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  942661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942686 */     GIR_RootConstrainSelectedInstOperands,
     /*  942687 */     // GIR_Coverage, 16651,
     /*  942687 */     GIR_EraseRootFromParent_Done,
     /*  942688 */   // Label 14225: @942688
     /*  942688 */   GIM_Try, /*On fail goto*//*Label 14226*/ GIMT_Encode4(942782), // Rule ID 16654 //
     /*  942693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  942704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  942707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  942710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  942713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942740 */     // MIs[1] Operand 1
     /*  942740 */     // No operand predicates
     /*  942740 */     // MIs[0] round
     /*  942740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942752 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  942752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  942755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942764 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942780 */     GIR_RootConstrainSelectedInstOperands,
     /*  942781 */     // GIR_Coverage, 16654,
     /*  942781 */     GIR_EraseRootFromParent_Done,
     /*  942782 */   // Label 14226: @942782
     /*  942782 */   GIM_Try, /*On fail goto*//*Label 14227*/ GIMT_Encode4(942876), // Rule ID 16655 //
     /*  942787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  942798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  942801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  942804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  942807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942834 */     // MIs[1] Operand 1
     /*  942834 */     // No operand predicates
     /*  942834 */     // MIs[0] round
     /*  942834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  942846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  942849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942858 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942874 */     GIR_RootConstrainSelectedInstOperands,
     /*  942875 */     // GIR_Coverage, 16655,
     /*  942875 */     GIR_EraseRootFromParent_Done,
     /*  942876 */   // Label 14227: @942876
     /*  942876 */   GIM_Try, /*On fail goto*//*Label 14228*/ GIMT_Encode4(942970), // Rule ID 16658 //
     /*  942881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  942892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  942895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  942898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  942901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942928 */     // MIs[1] Operand 1
     /*  942928 */     // No operand predicates
     /*  942928 */     // MIs[0] round
     /*  942928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942940 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  942940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  942943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942952 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942968 */     GIR_RootConstrainSelectedInstOperands,
     /*  942969 */     // GIR_Coverage, 16658,
     /*  942969 */     GIR_EraseRootFromParent_Done,
     /*  942970 */   // Label 14228: @942970
     /*  942970 */   GIM_Try, /*On fail goto*//*Label 14229*/ GIMT_Encode4(943064), // Rule ID 16659 //
     /*  942975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  942986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  942989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  942992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  942995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943022 */     // MIs[1] Operand 1
     /*  943022 */     // No operand predicates
     /*  943022 */     // MIs[0] round
     /*  943022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943034 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  943034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  943037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943062 */     GIR_RootConstrainSelectedInstOperands,
     /*  943063 */     // GIR_Coverage, 16659,
     /*  943063 */     GIR_EraseRootFromParent_Done,
     /*  943064 */   // Label 14229: @943064
     /*  943064 */   GIM_Try, /*On fail goto*//*Label 14230*/ GIMT_Encode4(943158), // Rule ID 16662 //
     /*  943069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  943072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  943080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  943083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  943086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  943089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943116 */     // MIs[1] Operand 1
     /*  943116 */     // No operand predicates
     /*  943116 */     // MIs[0] round
     /*  943116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943128 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  943128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  943131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943140 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943156 */     GIR_RootConstrainSelectedInstOperands,
     /*  943157 */     // GIR_Coverage, 16662,
     /*  943157 */     GIR_EraseRootFromParent_Done,
     /*  943158 */   // Label 14230: @943158
     /*  943158 */   GIM_Try, /*On fail goto*//*Label 14231*/ GIMT_Encode4(943252), // Rule ID 16663 //
     /*  943163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  943166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  943174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  943177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  943180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  943183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943210 */     // MIs[1] Operand 1
     /*  943210 */     // No operand predicates
     /*  943210 */     // MIs[0] round
     /*  943210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943222 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  943222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  943225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943234 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943250 */     GIR_RootConstrainSelectedInstOperands,
     /*  943251 */     // GIR_Coverage, 16663,
     /*  943251 */     GIR_EraseRootFromParent_Done,
     /*  943252 */   // Label 14231: @943252
     /*  943252 */   GIM_Try, /*On fail goto*//*Label 14232*/ GIMT_Encode4(943346), // Rule ID 16666 //
     /*  943257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  943260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  943268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  943271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  943274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  943277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943304 */     // MIs[1] Operand 1
     /*  943304 */     // No operand predicates
     /*  943304 */     // MIs[0] round
     /*  943304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  943316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  943319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943328 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943344 */     GIR_RootConstrainSelectedInstOperands,
     /*  943345 */     // GIR_Coverage, 16666,
     /*  943345 */     GIR_EraseRootFromParent_Done,
     /*  943346 */   // Label 14232: @943346
     /*  943346 */   GIM_Try, /*On fail goto*//*Label 14233*/ GIMT_Encode4(943440), // Rule ID 16667 //
     /*  943351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  943354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  943362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  943365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  943368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  943371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943394 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943398 */     // MIs[1] Operand 1
     /*  943398 */     // No operand predicates
     /*  943398 */     // MIs[0] round
     /*  943398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943410 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  943410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  943413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943422 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943438 */     GIR_RootConstrainSelectedInstOperands,
     /*  943439 */     // GIR_Coverage, 16667,
     /*  943439 */     GIR_EraseRootFromParent_Done,
     /*  943440 */   // Label 14233: @943440
     /*  943440 */   GIM_Try, /*On fail goto*//*Label 14234*/ GIMT_Encode4(943534), // Rule ID 16670 //
     /*  943445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  943448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  943456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  943459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  943462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  943465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943492 */     // MIs[1] Operand 1
     /*  943492 */     // No operand predicates
     /*  943492 */     // MIs[0] round
     /*  943492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943504 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  943504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  943507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943516 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943532 */     GIR_RootConstrainSelectedInstOperands,
     /*  943533 */     // GIR_Coverage, 16670,
     /*  943533 */     GIR_EraseRootFromParent_Done,
     /*  943534 */   // Label 14234: @943534
     /*  943534 */   GIM_Try, /*On fail goto*//*Label 14235*/ GIMT_Encode4(943628), // Rule ID 16671 //
     /*  943539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  943542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  943550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  943553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  943556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  943559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943586 */     // MIs[1] Operand 1
     /*  943586 */     // No operand predicates
     /*  943586 */     // MIs[0] round
     /*  943586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943598 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  943598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  943601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943610 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943626 */     GIR_RootConstrainSelectedInstOperands,
     /*  943627 */     // GIR_Coverage, 16671,
     /*  943627 */     GIR_EraseRootFromParent_Done,
     /*  943628 */   // Label 14235: @943628
     /*  943628 */   GIM_Try, /*On fail goto*//*Label 14236*/ GIMT_Encode4(943722), // Rule ID 16674 //
     /*  943633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  943636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  943644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  943647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  943650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  943653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943680 */     // MIs[1] Operand 1
     /*  943680 */     // No operand predicates
     /*  943680 */     // MIs[0] round
     /*  943680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943692 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  943692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  943695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943704 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943720 */     GIR_RootConstrainSelectedInstOperands,
     /*  943721 */     // GIR_Coverage, 16674,
     /*  943721 */     GIR_EraseRootFromParent_Done,
     /*  943722 */   // Label 14236: @943722
     /*  943722 */   GIM_Try, /*On fail goto*//*Label 14237*/ GIMT_Encode4(943816), // Rule ID 16675 //
     /*  943727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  943730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  943738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  943741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  943744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  943747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943774 */     // MIs[1] Operand 1
     /*  943774 */     // No operand predicates
     /*  943774 */     // MIs[0] round
     /*  943774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943786 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  943786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  943789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943798 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943814 */     GIR_RootConstrainSelectedInstOperands,
     /*  943815 */     // GIR_Coverage, 16675,
     /*  943815 */     GIR_EraseRootFromParent_Done,
     /*  943816 */   // Label 14237: @943816
     /*  943816 */   GIM_Try, /*On fail goto*//*Label 14238*/ GIMT_Encode4(943910), // Rule ID 16678 //
     /*  943821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  943824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  943832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  943835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  943838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  943841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943868 */     // MIs[1] Operand 1
     /*  943868 */     // No operand predicates
     /*  943868 */     // MIs[0] round
     /*  943868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  943880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  943883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943892 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943908 */     GIR_RootConstrainSelectedInstOperands,
     /*  943909 */     // GIR_Coverage, 16678,
     /*  943909 */     GIR_EraseRootFromParent_Done,
     /*  943910 */   // Label 14238: @943910
     /*  943910 */   GIM_Try, /*On fail goto*//*Label 14239*/ GIMT_Encode4(944004), // Rule ID 16679 //
     /*  943915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  943918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  943926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  943929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  943932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  943935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943962 */     // MIs[1] Operand 1
     /*  943962 */     // No operand predicates
     /*  943962 */     // MIs[0] round
     /*  943962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  943974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  943977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943986 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  944002 */     GIR_RootConstrainSelectedInstOperands,
     /*  944003 */     // GIR_Coverage, 16679,
     /*  944003 */     GIR_EraseRootFromParent_Done,
     /*  944004 */   // Label 14239: @944004
     /*  944004 */   GIM_Try, /*On fail goto*//*Label 14240*/ GIMT_Encode4(944098), // Rule ID 16682 //
     /*  944009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  944012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  944017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  944020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  944023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  944026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  944029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  944048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  944052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  944056 */     // MIs[1] Operand 1
     /*  944056 */     // No operand predicates
     /*  944056 */     // MIs[0] round
     /*  944056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  944068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  944071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  944075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  944080 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  944093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  944096 */     GIR_RootConstrainSelectedInstOperands,
     /*  944097 */     // GIR_Coverage, 16682,
     /*  944097 */     GIR_EraseRootFromParent_Done,
     /*  944098 */   // Label 14240: @944098
     /*  944098 */   GIM_Try, /*On fail goto*//*Label 14241*/ GIMT_Encode4(944192), // Rule ID 16683 //
     /*  944103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  944106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  944111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  944114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  944117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  944120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  944123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  944142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  944146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  944150 */     // MIs[1] Operand 1
     /*  944150 */     // No operand predicates
     /*  944150 */     // MIs[0] round
     /*  944150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  944162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  944165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  944169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  944174 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  944187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  944190 */     GIR_RootConstrainSelectedInstOperands,
     /*  944191 */     // GIR_Coverage, 16683,
     /*  944191 */     GIR_EraseRootFromParent_Done,
     /*  944192 */   // Label 14241: @944192
     /*  944192 */   GIM_Try, /*On fail goto*//*Label 14242*/ GIMT_Encode4(944286), // Rule ID 16686 //
     /*  944197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  944200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  944205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  944208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  944211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  944214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  944217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  944232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  944236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  944240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  944244 */     // MIs[1] Operand 1
     /*  944244 */     // No operand predicates
     /*  944244 */     // MIs[0] round
     /*  944244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944256 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  944256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  944259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  944263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  944268 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  944281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  944284 */     GIR_RootConstrainSelectedInstOperands,
     /*  944285 */     // GIR_Coverage, 16686,
     /*  944285 */     GIR_EraseRootFromParent_Done,
     /*  944286 */   // Label 14242: @944286
     /*  944286 */   GIM_Try, /*On fail goto*//*Label 14243*/ GIMT_Encode4(944380), // Rule ID 16687 //
     /*  944291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  944294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  944299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  944302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  944305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  944308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  944311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  944326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  944330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  944334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  944338 */     // MIs[1] Operand 1
     /*  944338 */     // No operand predicates
     /*  944338 */     // MIs[0] round
     /*  944338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944350 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  944350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  944353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  944357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  944362 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  944375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  944378 */     GIR_RootConstrainSelectedInstOperands,
     /*  944379 */     // GIR_Coverage, 16687,
     /*  944379 */     GIR_EraseRootFromParent_Done,
     /*  944380 */   // Label 14243: @944380
     /*  944380 */   GIM_Try, /*On fail goto*//*Label 14244*/ GIMT_Encode4(944464), // Rule ID 2754 //
     /*  944385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  944388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  944396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  944399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  944402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944428 */     // MIs[0] round
     /*  944428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944440 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  944440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  944443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944462 */     GIR_RootConstrainSelectedInstOperands,
     /*  944463 */     // GIR_Coverage, 2754,
     /*  944463 */     GIR_EraseRootFromParent_Done,
     /*  944464 */   // Label 14244: @944464
     /*  944464 */   GIM_Try, /*On fail goto*//*Label 14245*/ GIMT_Encode4(944548), // Rule ID 2755 //
     /*  944469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  944472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  944480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  944483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  944486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944512 */     // MIs[0] round
     /*  944512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944524 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  944524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  944527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944546 */     GIR_RootConstrainSelectedInstOperands,
     /*  944547 */     // GIR_Coverage, 2755,
     /*  944547 */     GIR_EraseRootFromParent_Done,
     /*  944548 */   // Label 14245: @944548
     /*  944548 */   GIM_Try, /*On fail goto*//*Label 14246*/ GIMT_Encode4(944632), // Rule ID 17134 //
     /*  944553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  944556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  944564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  944567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  944570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  944573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944596 */     // MIs[0] round
     /*  944596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944608 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  944608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  944611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944630 */     GIR_RootConstrainSelectedInstOperands,
     /*  944631 */     // GIR_Coverage, 17134,
     /*  944631 */     GIR_EraseRootFromParent_Done,
     /*  944632 */   // Label 14246: @944632
     /*  944632 */   GIM_Try, /*On fail goto*//*Label 14247*/ GIMT_Encode4(944716), // Rule ID 17135 //
     /*  944637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  944640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  944648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  944651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  944654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  944657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944680 */     // MIs[0] round
     /*  944680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944692 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  944692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  944695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944714 */     GIR_RootConstrainSelectedInstOperands,
     /*  944715 */     // GIR_Coverage, 17135,
     /*  944715 */     GIR_EraseRootFromParent_Done,
     /*  944716 */   // Label 14247: @944716
     /*  944716 */   GIM_Try, /*On fail goto*//*Label 14248*/ GIMT_Encode4(944800), // Rule ID 17144 //
     /*  944721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  944724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  944732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  944735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  944738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  944741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944764 */     // MIs[0] round
     /*  944764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944776 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  944776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  944779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944798 */     GIR_RootConstrainSelectedInstOperands,
     /*  944799 */     // GIR_Coverage, 17144,
     /*  944799 */     GIR_EraseRootFromParent_Done,
     /*  944800 */   // Label 14248: @944800
     /*  944800 */   GIM_Try, /*On fail goto*//*Label 14249*/ GIMT_Encode4(944884), // Rule ID 17145 //
     /*  944805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  944808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  944816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  944819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  944822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  944825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944848 */     // MIs[0] round
     /*  944848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944860 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  944860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  944863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944882 */     GIR_RootConstrainSelectedInstOperands,
     /*  944883 */     // GIR_Coverage, 17145,
     /*  944883 */     GIR_EraseRootFromParent_Done,
     /*  944884 */   // Label 14249: @944884
     /*  944884 */   GIM_Try, /*On fail goto*//*Label 14250*/ GIMT_Encode4(944968), // Rule ID 17154 //
     /*  944889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  944892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  944900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  944903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  944906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  944909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944932 */     // MIs[0] round
     /*  944932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944944 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  944944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  944947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944966 */     GIR_RootConstrainSelectedInstOperands,
     /*  944967 */     // GIR_Coverage, 17154,
     /*  944967 */     GIR_EraseRootFromParent_Done,
     /*  944968 */   // Label 14250: @944968
     /*  944968 */   GIM_Try, /*On fail goto*//*Label 14251*/ GIMT_Encode4(945052), // Rule ID 17155 //
     /*  944973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  944976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  944984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  944987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  944990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  944993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945016 */     // MIs[0] round
     /*  945016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945028 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  945028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  945031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945050 */     GIR_RootConstrainSelectedInstOperands,
     /*  945051 */     // GIR_Coverage, 17155,
     /*  945051 */     GIR_EraseRootFromParent_Done,
     /*  945052 */   // Label 14251: @945052
     /*  945052 */   GIM_Try, /*On fail goto*//*Label 14252*/ GIMT_Encode4(945136), // Rule ID 17164 //
     /*  945057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  945060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  945068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  945071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  945074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  945077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945100 */     // MIs[0] round
     /*  945100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945112 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  945112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  945115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945134 */     GIR_RootConstrainSelectedInstOperands,
     /*  945135 */     // GIR_Coverage, 17164,
     /*  945135 */     GIR_EraseRootFromParent_Done,
     /*  945136 */   // Label 14252: @945136
     /*  945136 */   GIM_Try, /*On fail goto*//*Label 14253*/ GIMT_Encode4(945220), // Rule ID 17165 //
     /*  945141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  945144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  945152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  945155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  945158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  945161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945184 */     // MIs[0] round
     /*  945184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945196 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  945196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  945199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945218 */     GIR_RootConstrainSelectedInstOperands,
     /*  945219 */     // GIR_Coverage, 17165,
     /*  945219 */     GIR_EraseRootFromParent_Done,
     /*  945220 */   // Label 14253: @945220
     /*  945220 */   GIM_Try, /*On fail goto*//*Label 14254*/ GIMT_Encode4(945304), // Rule ID 17174 //
     /*  945225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  945228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  945236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  945239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  945242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945268 */     // MIs[0] round
     /*  945268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945280 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  945280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  945283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945302 */     GIR_RootConstrainSelectedInstOperands,
     /*  945303 */     // GIR_Coverage, 17174,
     /*  945303 */     GIR_EraseRootFromParent_Done,
     /*  945304 */   // Label 14254: @945304
     /*  945304 */   GIM_Try, /*On fail goto*//*Label 14255*/ GIMT_Encode4(945388), // Rule ID 17175 //
     /*  945309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  945312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  945320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  945323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  945326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945352 */     // MIs[0] round
     /*  945352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945364 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  945364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  945367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945386 */     GIR_RootConstrainSelectedInstOperands,
     /*  945387 */     // GIR_Coverage, 17175,
     /*  945387 */     GIR_EraseRootFromParent_Done,
     /*  945388 */   // Label 14255: @945388
     /*  945388 */   GIM_Try, /*On fail goto*//*Label 14256*/ GIMT_Encode4(945472), // Rule ID 17184 //
     /*  945393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  945396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  945404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  945407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  945410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  945413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945436 */     // MIs[0] round
     /*  945436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945448 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  945448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  945451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945470 */     GIR_RootConstrainSelectedInstOperands,
     /*  945471 */     // GIR_Coverage, 17184,
     /*  945471 */     GIR_EraseRootFromParent_Done,
     /*  945472 */   // Label 14256: @945472
     /*  945472 */   GIM_Try, /*On fail goto*//*Label 14257*/ GIMT_Encode4(945556), // Rule ID 17185 //
     /*  945477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  945480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  945488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  945491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  945494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  945497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945520 */     // MIs[0] round
     /*  945520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945532 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  945532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  945535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945554 */     GIR_RootConstrainSelectedInstOperands,
     /*  945555 */     // GIR_Coverage, 17185,
     /*  945555 */     GIR_EraseRootFromParent_Done,
     /*  945556 */   // Label 14257: @945556
     /*  945556 */   GIM_Try, /*On fail goto*//*Label 14258*/ GIMT_Encode4(945640), // Rule ID 17194 //
     /*  945561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  945564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  945572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  945575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  945578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  945581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945604 */     // MIs[0] round
     /*  945604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945616 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  945616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  945619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945638 */     GIR_RootConstrainSelectedInstOperands,
     /*  945639 */     // GIR_Coverage, 17194,
     /*  945639 */     GIR_EraseRootFromParent_Done,
     /*  945640 */   // Label 14258: @945640
     /*  945640 */   GIM_Try, /*On fail goto*//*Label 14259*/ GIMT_Encode4(945724), // Rule ID 17195 //
     /*  945645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  945648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  945656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  945659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  945662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  945665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945688 */     // MIs[0] round
     /*  945688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945700 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  945700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  945703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945722 */     GIR_RootConstrainSelectedInstOperands,
     /*  945723 */     // GIR_Coverage, 17195,
     /*  945723 */     GIR_EraseRootFromParent_Done,
     /*  945724 */   // Label 14259: @945724
     /*  945724 */   GIM_Try, /*On fail goto*//*Label 14260*/ GIMT_Encode4(945808), // Rule ID 17204 //
     /*  945729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  945732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  945740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  945743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  945746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  945749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945772 */     // MIs[0] round
     /*  945772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945784 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  945784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  945787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945806 */     GIR_RootConstrainSelectedInstOperands,
     /*  945807 */     // GIR_Coverage, 17204,
     /*  945807 */     GIR_EraseRootFromParent_Done,
     /*  945808 */   // Label 14260: @945808
     /*  945808 */   GIM_Try, /*On fail goto*//*Label 14261*/ GIMT_Encode4(945892), // Rule ID 17205 //
     /*  945813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  945816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  945824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  945827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  945830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  945833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945856 */     // MIs[0] round
     /*  945856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945868 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  945868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  945871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945890 */     GIR_RootConstrainSelectedInstOperands,
     /*  945891 */     // GIR_Coverage, 17205,
     /*  945891 */     GIR_EraseRootFromParent_Done,
     /*  945892 */   // Label 14261: @945892
     /*  945892 */   GIM_Try, /*On fail goto*//*Label 14262*/ GIMT_Encode4(945976), // Rule ID 17250 //
     /*  945897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  945900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  945905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  945911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945940 */     // MIs[0] round
     /*  945940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945952 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  945952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  945955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945974 */     GIR_RootConstrainSelectedInstOperands,
     /*  945975 */     // GIR_Coverage, 17250,
     /*  945975 */     GIR_EraseRootFromParent_Done,
     /*  945976 */   // Label 14262: @945976
     /*  945976 */   GIM_Try, /*On fail goto*//*Label 14263*/ GIMT_Encode4(946060), // Rule ID 17251 //
     /*  945981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  945984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  945989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  945995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  946001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946024 */     // MIs[0] round
     /*  946024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946036 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  946036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  946039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946058 */     GIR_RootConstrainSelectedInstOperands,
     /*  946059 */     // GIR_Coverage, 17251,
     /*  946059 */     GIR_EraseRootFromParent_Done,
     /*  946060 */   // Label 14263: @946060
     /*  946060 */   GIM_Try, /*On fail goto*//*Label 14264*/ GIMT_Encode4(946144), // Rule ID 17260 //
     /*  946065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  946068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  946079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  946085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946108 */     // MIs[0] round
     /*  946108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946120 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  946120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  946123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946142 */     GIR_RootConstrainSelectedInstOperands,
     /*  946143 */     // GIR_Coverage, 17260,
     /*  946143 */     GIR_EraseRootFromParent_Done,
     /*  946144 */   // Label 14264: @946144
     /*  946144 */   GIM_Try, /*On fail goto*//*Label 14265*/ GIMT_Encode4(946228), // Rule ID 17261 //
     /*  946149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  946152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  946163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  946169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946192 */     // MIs[0] round
     /*  946192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946204 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  946204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  946207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946226 */     GIR_RootConstrainSelectedInstOperands,
     /*  946227 */     // GIR_Coverage, 17261,
     /*  946227 */     GIR_EraseRootFromParent_Done,
     /*  946228 */   // Label 14265: @946228
     /*  946228 */   GIM_Try, /*On fail goto*//*Label 14266*/ GIMT_Encode4(946312), // Rule ID 17270 //
     /*  946233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  946236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  946244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  946247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  946250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946276 */     // MIs[0] round
     /*  946276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946288 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  946288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  946291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946310 */     GIR_RootConstrainSelectedInstOperands,
     /*  946311 */     // GIR_Coverage, 17270,
     /*  946311 */     GIR_EraseRootFromParent_Done,
     /*  946312 */   // Label 14266: @946312
     /*  946312 */   GIM_Try, /*On fail goto*//*Label 14267*/ GIMT_Encode4(946396), // Rule ID 17271 //
     /*  946317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  946320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  946328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  946331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  946334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946360 */     // MIs[0] round
     /*  946360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946372 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  946372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  946375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946394 */     GIR_RootConstrainSelectedInstOperands,
     /*  946395 */     // GIR_Coverage, 17271,
     /*  946395 */     GIR_EraseRootFromParent_Done,
     /*  946396 */   // Label 14267: @946396
     /*  946396 */   GIM_Try, /*On fail goto*//*Label 14268*/ GIMT_Encode4(946480), // Rule ID 17280 //
     /*  946401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  946404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  946412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  946415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  946418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  946421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946444 */     // MIs[0] round
     /*  946444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946456 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  946456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  946459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946478 */     GIR_RootConstrainSelectedInstOperands,
     /*  946479 */     // GIR_Coverage, 17280,
     /*  946479 */     GIR_EraseRootFromParent_Done,
     /*  946480 */   // Label 14268: @946480
     /*  946480 */   GIM_Try, /*On fail goto*//*Label 14269*/ GIMT_Encode4(946564), // Rule ID 17281 //
     /*  946485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  946488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  946496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  946499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  946502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  946505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946528 */     // MIs[0] round
     /*  946528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946540 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  946540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  946543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946562 */     GIR_RootConstrainSelectedInstOperands,
     /*  946563 */     // GIR_Coverage, 17281,
     /*  946563 */     GIR_EraseRootFromParent_Done,
     /*  946564 */   // Label 14269: @946564
     /*  946564 */   GIM_Try, /*On fail goto*//*Label 14270*/ GIMT_Encode4(946648), // Rule ID 17290 //
     /*  946569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  946572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  946580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  946583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  946586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  946589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  946596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  946608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946612 */     // MIs[0] round
     /*  946612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946624 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  946624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  946627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946646 */     GIR_RootConstrainSelectedInstOperands,
     /*  946647 */     // GIR_Coverage, 17290,
     /*  946647 */     GIR_EraseRootFromParent_Done,
     /*  946648 */   // Label 14270: @946648
     /*  946648 */   GIM_Try, /*On fail goto*//*Label 14271*/ GIMT_Encode4(946732), // Rule ID 17291 //
     /*  946653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  946656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  946664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  946667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  946670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  946673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  946680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  946692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946696 */     // MIs[0] round
     /*  946696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946708 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  946708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  946711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946730 */     GIR_RootConstrainSelectedInstOperands,
     /*  946731 */     // GIR_Coverage, 17291,
     /*  946731 */     GIR_EraseRootFromParent_Done,
     /*  946732 */   // Label 14271: @946732
     /*  946732 */   GIM_Try, /*On fail goto*//*Label 14272*/ GIMT_Encode4(946816), // Rule ID 17300 //
     /*  946737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  946740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  946748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  946751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  946754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946780 */     // MIs[0] round
     /*  946780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946792 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  946792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  946795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946814 */     GIR_RootConstrainSelectedInstOperands,
     /*  946815 */     // GIR_Coverage, 17300,
     /*  946815 */     GIR_EraseRootFromParent_Done,
     /*  946816 */   // Label 14272: @946816
     /*  946816 */   GIM_Try, /*On fail goto*//*Label 14273*/ GIMT_Encode4(946900), // Rule ID 17301 //
     /*  946821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  946824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  946832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  946835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  946838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946864 */     // MIs[0] round
     /*  946864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946876 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  946876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  946879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946898 */     GIR_RootConstrainSelectedInstOperands,
     /*  946899 */     // GIR_Coverage, 17301,
     /*  946899 */     GIR_EraseRootFromParent_Done,
     /*  946900 */   // Label 14273: @946900
     /*  946900 */   GIM_Try, /*On fail goto*//*Label 14274*/ GIMT_Encode4(946984), // Rule ID 17310 //
     /*  946905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  946908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  946916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  946919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  946922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946948 */     // MIs[0] round
     /*  946948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946960 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  946960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  946963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946982 */     GIR_RootConstrainSelectedInstOperands,
     /*  946983 */     // GIR_Coverage, 17310,
     /*  946983 */     GIR_EraseRootFromParent_Done,
     /*  946984 */   // Label 14274: @946984
     /*  946984 */   GIM_Try, /*On fail goto*//*Label 14275*/ GIMT_Encode4(947068), // Rule ID 17311 //
     /*  946989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  946992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  947000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  947003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  947006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  947020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  947024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947032 */     // MIs[0] round
     /*  947032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  947035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  947037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947044 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  947044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  947047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  947055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  947066 */     GIR_RootConstrainSelectedInstOperands,
     /*  947067 */     // GIR_Coverage, 17311,
     /*  947067 */     GIR_EraseRootFromParent_Done,
     /*  947068 */   // Label 14275: @947068
     /*  947068 */   GIM_Try, /*On fail goto*//*Label 14276*/ GIMT_Encode4(947152), // Rule ID 17320 //
     /*  947073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  947076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  947081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  947084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  947087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  947090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  947093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  947104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  947108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947116 */     // MIs[0] round
     /*  947116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  947119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  947121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947128 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  947128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  947131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  947139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  947150 */     GIR_RootConstrainSelectedInstOperands,
     /*  947151 */     // GIR_Coverage, 17320,
     /*  947151 */     GIR_EraseRootFromParent_Done,
     /*  947152 */   // Label 14276: @947152
     /*  947152 */   GIM_Try, /*On fail goto*//*Label 14277*/ GIMT_Encode4(947236), // Rule ID 17321 //
     /*  947157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  947160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  947165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  947168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  947171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  947174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  947177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  947188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  947192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947200 */     // MIs[0] round
     /*  947200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  947203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  947205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947212 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  947212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  947215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  947223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  947234 */     GIR_RootConstrainSelectedInstOperands,
     /*  947235 */     // GIR_Coverage, 17321,
     /*  947235 */     GIR_EraseRootFromParent_Done,
     /*  947236 */   // Label 14277: @947236
     /*  947236 */   GIM_Try, /*On fail goto*//*Label 14278*/ GIMT_Encode4(947320), // Rule ID 17330 //
     /*  947241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  947244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  947249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  947252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  947255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  947258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  947261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  947268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  947272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  947276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  947280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947284 */     // MIs[0] round
     /*  947284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  947287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  947289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947296 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  947296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  947299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  947307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  947318 */     GIR_RootConstrainSelectedInstOperands,
     /*  947319 */     // GIR_Coverage, 17330,
     /*  947319 */     GIR_EraseRootFromParent_Done,
     /*  947320 */   // Label 14278: @947320
     /*  947320 */   GIM_Try, /*On fail goto*//*Label 14279*/ GIMT_Encode4(947404), // Rule ID 17331 //
     /*  947325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  947328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  947333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  947336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  947339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  947342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  947345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  947352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  947356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  947360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  947364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947368 */     // MIs[0] round
     /*  947368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  947371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  947373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947380 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11294:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  947380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  947383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  947391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  947402 */     GIR_RootConstrainSelectedInstOperands,
     /*  947403 */     // GIR_Coverage, 17331,
     /*  947403 */     GIR_EraseRootFromParent_Done,
     /*  947404 */   // Label 14279: @947404
     /*  947404 */   GIM_Try, /*On fail goto*//*Label 14280*/ GIMT_Encode4(947486), // Rule ID 62825 //
     /*  947409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  947420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  947423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  947426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947436 */     // MIs[0] op1
     /*  947436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947463 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF8),
     /*  947466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947468 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947470 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947472 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947474 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947484 */     GIR_RootConstrainSelectedInstOperands,
     /*  947485 */     // GIR_Coverage, 62825,
     /*  947485 */     GIR_EraseRootFromParent_Done,
     /*  947486 */   // Label 14280: @947486
     /*  947486 */   GIM_Try, /*On fail goto*//*Label 14281*/ GIMT_Encode4(947568), // Rule ID 62826 //
     /*  947491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  947502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  947505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  947508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947518 */     // MIs[0] op1
     /*  947518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947521 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947545 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  947545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF8),
     /*  947548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947550 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947552 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947554 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947556 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947566 */     GIR_RootConstrainSelectedInstOperands,
     /*  947567 */     // GIR_Coverage, 62826,
     /*  947567 */     GIR_EraseRootFromParent_Done,
     /*  947568 */   // Label 14281: @947568
     /*  947568 */   GIM_Try, /*On fail goto*//*Label 14282*/ GIMT_Encode4(947650), // Rule ID 62855 //
     /*  947573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  947584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  947587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  947590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  947593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947600 */     // MIs[0] op1
     /*  947600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947627 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF8),
     /*  947630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947632 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947634 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947636 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947638 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947648 */     GIR_RootConstrainSelectedInstOperands,
     /*  947649 */     // GIR_Coverage, 62855,
     /*  947649 */     GIR_EraseRootFromParent_Done,
     /*  947650 */   // Label 14282: @947650
     /*  947650 */   GIM_Try, /*On fail goto*//*Label 14283*/ GIMT_Encode4(947732), // Rule ID 62856 //
     /*  947655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  947666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  947669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  947672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  947675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947682 */     // MIs[0] op1
     /*  947682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947709 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  947709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF8),
     /*  947712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947714 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947716 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947718 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947720 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947730 */     GIR_RootConstrainSelectedInstOperands,
     /*  947731 */     // GIR_Coverage, 62856,
     /*  947731 */     GIR_EraseRootFromParent_Done,
     /*  947732 */   // Label 14283: @947732
     /*  947732 */   GIM_Try, /*On fail goto*//*Label 14284*/ GIMT_Encode4(947814), // Rule ID 62887 //
     /*  947737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  947748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  947751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  947754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947764 */     // MIs[0] op1
     /*  947764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947767 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947791 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  947794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947796 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947798 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947800 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947802 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947812 */     GIR_RootConstrainSelectedInstOperands,
     /*  947813 */     // GIR_Coverage, 62887,
     /*  947813 */     GIR_EraseRootFromParent_Done,
     /*  947814 */   // Label 14284: @947814
     /*  947814 */   GIM_Try, /*On fail goto*//*Label 14285*/ GIMT_Encode4(947896), // Rule ID 62888 //
     /*  947819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  947830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  947833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  947836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947846 */     // MIs[0] op1
     /*  947846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947873 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  947873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  947876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947878 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947880 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947882 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947884 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947894 */     GIR_RootConstrainSelectedInstOperands,
     /*  947895 */     // GIR_Coverage, 62888,
     /*  947895 */     GIR_EraseRootFromParent_Done,
     /*  947896 */   // Label 14285: @947896
     /*  947896 */   GIM_Try, /*On fail goto*//*Label 14286*/ GIMT_Encode4(947978), // Rule ID 62899 //
     /*  947901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  947912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  947915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  947918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  947921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947928 */     // MIs[0] op1
     /*  947928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947931 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947955 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  947958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947960 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947962 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947964 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947966 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947976 */     GIR_RootConstrainSelectedInstOperands,
     /*  947977 */     // GIR_Coverage, 62899,
     /*  947977 */     GIR_EraseRootFromParent_Done,
     /*  947978 */   // Label 14286: @947978
     /*  947978 */   GIM_Try, /*On fail goto*//*Label 14287*/ GIMT_Encode4(948060), // Rule ID 62900 //
     /*  947983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  947994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  947997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  948000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  948003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948010 */     // MIs[0] op1
     /*  948010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948013 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948037 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  948040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948042 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948044 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948046 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948048 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948058 */     GIR_RootConstrainSelectedInstOperands,
     /*  948059 */     // GIR_Coverage, 62900,
     /*  948059 */     GIR_EraseRootFromParent_Done,
     /*  948060 */   // Label 14287: @948060
     /*  948060 */   GIM_Try, /*On fail goto*//*Label 14288*/ GIMT_Encode4(948142), // Rule ID 62931 //
     /*  948065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  948076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  948079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  948082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948092 */     // MIs[0] op1
     /*  948092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948119 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  948122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948124 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948126 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948128 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948130 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948140 */     GIR_RootConstrainSelectedInstOperands,
     /*  948141 */     // GIR_Coverage, 62931,
     /*  948141 */     GIR_EraseRootFromParent_Done,
     /*  948142 */   // Label 14288: @948142
     /*  948142 */   GIM_Try, /*On fail goto*//*Label 14289*/ GIMT_Encode4(948224), // Rule ID 62932 //
     /*  948147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  948158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  948161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  948164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948174 */     // MIs[0] op1
     /*  948174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948201 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  948204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948206 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948208 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948210 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948212 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948222 */     GIR_RootConstrainSelectedInstOperands,
     /*  948223 */     // GIR_Coverage, 62932,
     /*  948223 */     GIR_EraseRootFromParent_Done,
     /*  948224 */   // Label 14289: @948224
     /*  948224 */   GIM_Try, /*On fail goto*//*Label 14290*/ GIMT_Encode4(948306), // Rule ID 62943 //
     /*  948229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  948240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  948243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  948246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  948249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948256 */     // MIs[0] op1
     /*  948256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948283 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  948286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948288 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948290 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948292 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948294 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948304 */     GIR_RootConstrainSelectedInstOperands,
     /*  948305 */     // GIR_Coverage, 62943,
     /*  948305 */     GIR_EraseRootFromParent_Done,
     /*  948306 */   // Label 14290: @948306
     /*  948306 */   GIM_Try, /*On fail goto*//*Label 14291*/ GIMT_Encode4(948388), // Rule ID 62944 //
     /*  948311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  948322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  948325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  948328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  948331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948338 */     // MIs[0] op1
     /*  948338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948341 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948365 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  948368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948370 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948372 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948374 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948376 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948386 */     GIR_RootConstrainSelectedInstOperands,
     /*  948387 */     // GIR_Coverage, 62944,
     /*  948387 */     GIR_EraseRootFromParent_Done,
     /*  948388 */   // Label 14291: @948388
     /*  948388 */   GIM_Try, /*On fail goto*//*Label 14292*/ GIMT_Encode4(948470), // Rule ID 62975 //
     /*  948393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  948407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  948410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948420 */     // MIs[0] op1
     /*  948420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948447 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  948450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948452 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948454 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948456 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948458 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948468 */     GIR_RootConstrainSelectedInstOperands,
     /*  948469 */     // GIR_Coverage, 62975,
     /*  948469 */     GIR_EraseRootFromParent_Done,
     /*  948470 */   // Label 14292: @948470
     /*  948470 */   GIM_Try, /*On fail goto*//*Label 14293*/ GIMT_Encode4(948552), // Rule ID 62976 //
     /*  948475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  948489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  948492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948502 */     // MIs[0] op1
     /*  948502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948529 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  948529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  948532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948534 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948536 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948538 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948540 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948550 */     GIR_RootConstrainSelectedInstOperands,
     /*  948551 */     // GIR_Coverage, 62976,
     /*  948551 */     GIR_EraseRootFromParent_Done,
     /*  948552 */   // Label 14293: @948552
     /*  948552 */   GIM_Try, /*On fail goto*//*Label 14294*/ GIMT_Encode4(948634), // Rule ID 62987 //
     /*  948557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  948571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  948574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  948577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948584 */     // MIs[0] op1
     /*  948584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948611 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  948614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948616 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948618 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948620 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948622 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948632 */     GIR_RootConstrainSelectedInstOperands,
     /*  948633 */     // GIR_Coverage, 62987,
     /*  948633 */     GIR_EraseRootFromParent_Done,
     /*  948634 */   // Label 14294: @948634
     /*  948634 */   GIM_Try, /*On fail goto*//*Label 14295*/ GIMT_Encode4(948716), // Rule ID 62988 //
     /*  948639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  948653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  948656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  948659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948666 */     // MIs[0] op1
     /*  948666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948669 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948693 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  948693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  948696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948698 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948700 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948702 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948704 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948714 */     GIR_RootConstrainSelectedInstOperands,
     /*  948715 */     // GIR_Coverage, 62988,
     /*  948715 */     GIR_EraseRootFromParent_Done,
     /*  948716 */   // Label 14295: @948716
     /*  948716 */   GIM_Try, /*On fail goto*//*Label 14296*/ GIMT_Encode4(948798), // Rule ID 62999 //
     /*  948721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  948729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  948735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  948738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  948741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948748 */     // MIs[0] op1
     /*  948748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  948756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  948768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948775 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF4),
     /*  948778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948780 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948782 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948784 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948786 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948796 */     GIR_RootConstrainSelectedInstOperands,
     /*  948797 */     // GIR_Coverage, 62999,
     /*  948797 */     GIR_EraseRootFromParent_Done,
     /*  948798 */   // Label 14296: @948798
     /*  948798 */   GIM_Try, /*On fail goto*//*Label 14297*/ GIMT_Encode4(948880), // Rule ID 63000 //
     /*  948803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  948811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  948817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  948820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  948823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948830 */     // MIs[0] op1
     /*  948830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948833 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  948838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  948850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948857 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  948857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF4),
     /*  948860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948862 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948864 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948866 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948868 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948878 */     GIR_RootConstrainSelectedInstOperands,
     /*  948879 */     // GIR_Coverage, 63000,
     /*  948879 */     GIR_EraseRootFromParent_Done,
     /*  948880 */   // Label 14297: @948880
     /*  948880 */   GIM_Try, /*On fail goto*//*Label 14298*/ GIMT_Encode4(948962), // Rule ID 63031 //
     /*  948885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  948896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  948899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  948902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948912 */     // MIs[0] op1
     /*  948912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948939 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  948942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948944 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948946 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948948 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948950 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948960 */     GIR_RootConstrainSelectedInstOperands,
     /*  948961 */     // GIR_Coverage, 63031,
     /*  948961 */     GIR_EraseRootFromParent_Done,
     /*  948962 */   // Label 14298: @948962
     /*  948962 */   GIM_Try, /*On fail goto*//*Label 14299*/ GIMT_Encode4(949044), // Rule ID 63032 //
     /*  948967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  948978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  948981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  948984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948994 */     // MIs[0] op1
     /*  948994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948997 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949021 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  949024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949026 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949028 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949030 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949032 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949042 */     GIR_RootConstrainSelectedInstOperands,
     /*  949043 */     // GIR_Coverage, 63032,
     /*  949043 */     GIR_EraseRootFromParent_Done,
     /*  949044 */   // Label 14299: @949044
     /*  949044 */   GIM_Try, /*On fail goto*//*Label 14300*/ GIMT_Encode4(949126), // Rule ID 63043 //
     /*  949049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  949060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  949063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  949066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  949069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949076 */     // MIs[0] op1
     /*  949076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949079 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949103 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  949106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949108 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949110 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949112 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949114 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949124 */     GIR_RootConstrainSelectedInstOperands,
     /*  949125 */     // GIR_Coverage, 63043,
     /*  949125 */     GIR_EraseRootFromParent_Done,
     /*  949126 */   // Label 14300: @949126
     /*  949126 */   GIM_Try, /*On fail goto*//*Label 14301*/ GIMT_Encode4(949208), // Rule ID 63044 //
     /*  949131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  949142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  949145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  949148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  949151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949158 */     // MIs[0] op1
     /*  949158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949185 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  949188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949190 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949192 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949194 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949196 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949206 */     GIR_RootConstrainSelectedInstOperands,
     /*  949207 */     // GIR_Coverage, 63044,
     /*  949207 */     GIR_EraseRootFromParent_Done,
     /*  949208 */   // Label 14301: @949208
     /*  949208 */   GIM_Try, /*On fail goto*//*Label 14302*/ GIMT_Encode4(949290), // Rule ID 63055 //
     /*  949213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  949224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  949227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  949230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949240 */     // MIs[0] op1
     /*  949240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949267 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF2),
     /*  949270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949272 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949274 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949276 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949278 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949288 */     GIR_RootConstrainSelectedInstOperands,
     /*  949289 */     // GIR_Coverage, 63055,
     /*  949289 */     GIR_EraseRootFromParent_Done,
     /*  949290 */   // Label 14302: @949290
     /*  949290 */   GIM_Try, /*On fail goto*//*Label 14303*/ GIMT_Encode4(949372), // Rule ID 63056 //
     /*  949295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  949306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  949309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  949312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949322 */     // MIs[0] op1
     /*  949322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949325 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949349 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF2),
     /*  949352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949354 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949356 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949358 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949360 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949370 */     GIR_RootConstrainSelectedInstOperands,
     /*  949371 */     // GIR_Coverage, 63056,
     /*  949371 */     GIR_EraseRootFromParent_Done,
     /*  949372 */   // Label 14303: @949372
     /*  949372 */   GIM_Try, /*On fail goto*//*Label 14304*/ GIMT_Encode4(949454), // Rule ID 63087 //
     /*  949377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  949391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  949394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949404 */     // MIs[0] op1
     /*  949404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949431 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  949431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  949434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949436 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949438 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949440 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949442 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949452 */     GIR_RootConstrainSelectedInstOperands,
     /*  949453 */     // GIR_Coverage, 63087,
     /*  949453 */     GIR_EraseRootFromParent_Done,
     /*  949454 */   // Label 14304: @949454
     /*  949454 */   GIM_Try, /*On fail goto*//*Label 14305*/ GIMT_Encode4(949536), // Rule ID 63088 //
     /*  949459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  949473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  949476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949486 */     // MIs[0] op1
     /*  949486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949489 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949513 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  949513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  949516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949518 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949520 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949522 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949524 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949534 */     GIR_RootConstrainSelectedInstOperands,
     /*  949535 */     // GIR_Coverage, 63088,
     /*  949535 */     GIR_EraseRootFromParent_Done,
     /*  949536 */   // Label 14305: @949536
     /*  949536 */   GIM_Try, /*On fail goto*//*Label 14306*/ GIMT_Encode4(949618), // Rule ID 63099 //
     /*  949541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  949555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  949558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  949561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949568 */     // MIs[0] op1
     /*  949568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949595 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  949595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  949598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949600 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949602 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949604 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949606 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949616 */     GIR_RootConstrainSelectedInstOperands,
     /*  949617 */     // GIR_Coverage, 63099,
     /*  949617 */     GIR_EraseRootFromParent_Done,
     /*  949618 */   // Label 14306: @949618
     /*  949618 */   GIM_Try, /*On fail goto*//*Label 14307*/ GIMT_Encode4(949700), // Rule ID 63100 //
     /*  949623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  949637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  949640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  949643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949650 */     // MIs[0] op1
     /*  949650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949653 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949677 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  949677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  949680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949682 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949684 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949686 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949688 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949698 */     GIR_RootConstrainSelectedInstOperands,
     /*  949699 */     // GIR_Coverage, 63100,
     /*  949699 */     GIR_EraseRootFromParent_Done,
     /*  949700 */   // Label 14307: @949700
     /*  949700 */   GIM_Try, /*On fail goto*//*Label 14308*/ GIMT_Encode4(949782), // Rule ID 63111 //
     /*  949705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  949719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  949722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949732 */     // MIs[0] op1
     /*  949732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  949752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949759 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  949759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_MF2),
     /*  949762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949764 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949766 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949768 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949770 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949780 */     GIR_RootConstrainSelectedInstOperands,
     /*  949781 */     // GIR_Coverage, 63111,
     /*  949781 */     GIR_EraseRootFromParent_Done,
     /*  949782 */   // Label 14308: @949782
     /*  949782 */   GIM_Try, /*On fail goto*//*Label 14309*/ GIMT_Encode4(949864), // Rule ID 63112 //
     /*  949787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  949801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  949804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949814 */     // MIs[0] op1
     /*  949814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  949834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949841 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  949841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_MF2),
     /*  949844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949846 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949848 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949850 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949852 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949862 */     GIR_RootConstrainSelectedInstOperands,
     /*  949863 */     // GIR_Coverage, 63112,
     /*  949863 */     GIR_EraseRootFromParent_Done,
     /*  949864 */   // Label 14309: @949864
     /*  949864 */   GIM_Try, /*On fail goto*//*Label 14310*/ GIMT_Encode4(949946), // Rule ID 63143 //
     /*  949869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  949880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  949883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  949886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949896 */     // MIs[0] op1
     /*  949896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949899 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949923 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  949923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  949926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949928 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949930 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949932 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949934 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949944 */     GIR_RootConstrainSelectedInstOperands,
     /*  949945 */     // GIR_Coverage, 63143,
     /*  949945 */     GIR_EraseRootFromParent_Done,
     /*  949946 */   // Label 14310: @949946
     /*  949946 */   GIM_Try, /*On fail goto*//*Label 14311*/ GIMT_Encode4(950028), // Rule ID 63144 //
     /*  949951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  949962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  949965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  949968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949978 */     // MIs[0] op1
     /*  949978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949981 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950005 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  950005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  950008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950010 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950012 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950014 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950016 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  950026 */     GIR_RootConstrainSelectedInstOperands,
     /*  950027 */     // GIR_Coverage, 63144,
     /*  950027 */     GIR_EraseRootFromParent_Done,
     /*  950028 */   // Label 14311: @950028
     /*  950028 */   GIM_Try, /*On fail goto*//*Label 14312*/ GIMT_Encode4(950110), // Rule ID 63155 //
     /*  950033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  950044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  950047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  950050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  950053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950060 */     // MIs[0] op1
     /*  950060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950087 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  950087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  950090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950092 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950094 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950096 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950098 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  950108 */     GIR_RootConstrainSelectedInstOperands,
     /*  950109 */     // GIR_Coverage, 63155,
     /*  950109 */     GIR_EraseRootFromParent_Done,
     /*  950110 */   // Label 14312: @950110
     /*  950110 */   GIM_Try, /*On fail goto*//*Label 14313*/ GIMT_Encode4(950192), // Rule ID 63156 //
     /*  950115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  950126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  950129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  950132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  950135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950142 */     // MIs[0] op1
     /*  950142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950145 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950169 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  950169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  950172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950174 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950176 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950178 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950180 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  950190 */     GIR_RootConstrainSelectedInstOperands,
     /*  950191 */     // GIR_Coverage, 63156,
     /*  950191 */     GIR_EraseRootFromParent_Done,
     /*  950192 */   // Label 14313: @950192
     /*  950192 */   GIM_Try, /*On fail goto*//*Label 14314*/ GIMT_Encode4(950274), // Rule ID 63187 //
     /*  950197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  950208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  950211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950224 */     // MIs[0] op1
     /*  950224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950251 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  950254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950256 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950258 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950260 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950262 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950272 */     GIR_RootConstrainSelectedInstOperands,
     /*  950273 */     // GIR_Coverage, 63187,
     /*  950273 */     GIR_EraseRootFromParent_Done,
     /*  950274 */   // Label 14314: @950274
     /*  950274 */   GIM_Try, /*On fail goto*//*Label 14315*/ GIMT_Encode4(950356), // Rule ID 63188 //
     /*  950279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  950290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  950293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950306 */     // MIs[0] op1
     /*  950306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950309 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950333 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  950336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950338 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950340 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950342 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950344 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950354 */     GIR_RootConstrainSelectedInstOperands,
     /*  950355 */     // GIR_Coverage, 63188,
     /*  950355 */     GIR_EraseRootFromParent_Done,
     /*  950356 */   // Label 14315: @950356
     /*  950356 */   GIM_Try, /*On fail goto*//*Label 14316*/ GIMT_Encode4(950438), // Rule ID 63199 //
     /*  950361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  950372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  950375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  950381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950388 */     // MIs[0] op1
     /*  950388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950391 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950415 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  950418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950420 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950422 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950424 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950426 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950436 */     GIR_RootConstrainSelectedInstOperands,
     /*  950437 */     // GIR_Coverage, 63199,
     /*  950437 */     GIR_EraseRootFromParent_Done,
     /*  950438 */   // Label 14316: @950438
     /*  950438 */   GIM_Try, /*On fail goto*//*Label 14317*/ GIMT_Encode4(950520), // Rule ID 63200 //
     /*  950443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  950454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  950457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  950463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950470 */     // MIs[0] op1
     /*  950470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950497 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  950500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950502 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950504 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950506 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950508 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950518 */     GIR_RootConstrainSelectedInstOperands,
     /*  950519 */     // GIR_Coverage, 63200,
     /*  950519 */     GIR_EraseRootFromParent_Done,
     /*  950520 */   // Label 14317: @950520
     /*  950520 */   GIM_Try, /*On fail goto*//*Label 14318*/ GIMT_Encode4(950602), // Rule ID 63211 //
     /*  950525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  950536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  950539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950552 */     // MIs[0] op1
     /*  950552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950555 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950579 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M1),
     /*  950582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950584 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950586 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950588 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950590 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950600 */     GIR_RootConstrainSelectedInstOperands,
     /*  950601 */     // GIR_Coverage, 63211,
     /*  950601 */     GIR_EraseRootFromParent_Done,
     /*  950602 */   // Label 14318: @950602
     /*  950602 */   GIM_Try, /*On fail goto*//*Label 14319*/ GIMT_Encode4(950684), // Rule ID 63212 //
     /*  950607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  950618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  950621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950634 */     // MIs[0] op1
     /*  950634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950637 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950661 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M1),
     /*  950664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950666 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950668 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950670 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950672 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950682 */     GIR_RootConstrainSelectedInstOperands,
     /*  950683 */     // GIR_Coverage, 63212,
     /*  950683 */     GIR_EraseRootFromParent_Done,
     /*  950684 */   // Label 14319: @950684
     /*  950684 */   GIM_Try, /*On fail goto*//*Label 14320*/ GIMT_Encode4(950766), // Rule ID 63243 //
     /*  950689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  950700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  950703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  950706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950716 */     // MIs[0] op1
     /*  950716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950743 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  950746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950748 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950750 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950752 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950754 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950764 */     GIR_RootConstrainSelectedInstOperands,
     /*  950765 */     // GIR_Coverage, 63243,
     /*  950765 */     GIR_EraseRootFromParent_Done,
     /*  950766 */   // Label 14320: @950766
     /*  950766 */   GIM_Try, /*On fail goto*//*Label 14321*/ GIMT_Encode4(950848), // Rule ID 63244 //
     /*  950771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  950782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  950785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  950788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950798 */     // MIs[0] op1
     /*  950798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950825 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  950828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950830 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950832 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950834 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950836 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950846 */     GIR_RootConstrainSelectedInstOperands,
     /*  950847 */     // GIR_Coverage, 63244,
     /*  950847 */     GIR_EraseRootFromParent_Done,
     /*  950848 */   // Label 14321: @950848
     /*  950848 */   GIM_Try, /*On fail goto*//*Label 14322*/ GIMT_Encode4(950930), // Rule ID 63255 //
     /*  950853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  950864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  950867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  950870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  950873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950880 */     // MIs[0] op1
     /*  950880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950883 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950907 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  950910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950912 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950914 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950916 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950918 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950928 */     GIR_RootConstrainSelectedInstOperands,
     /*  950929 */     // GIR_Coverage, 63255,
     /*  950929 */     GIR_EraseRootFromParent_Done,
     /*  950930 */   // Label 14322: @950930
     /*  950930 */   GIM_Try, /*On fail goto*//*Label 14323*/ GIMT_Encode4(951012), // Rule ID 63256 //
     /*  950935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  950946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  950949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  950952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  950955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950962 */     // MIs[0] op1
     /*  950962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950965 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950989 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  950992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950994 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950996 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950998 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951000 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951010 */     GIR_RootConstrainSelectedInstOperands,
     /*  951011 */     // GIR_Coverage, 63256,
     /*  951011 */     GIR_EraseRootFromParent_Done,
     /*  951012 */   // Label 14323: @951012
     /*  951012 */   GIM_Try, /*On fail goto*//*Label 14324*/ GIMT_Encode4(951094), // Rule ID 63267 //
     /*  951017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  951028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  951031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  951034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951044 */     // MIs[0] op1
     /*  951044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951047 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M1),
     /*  951074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951076 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951078 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951080 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951082 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951092 */     GIR_RootConstrainSelectedInstOperands,
     /*  951093 */     // GIR_Coverage, 63267,
     /*  951093 */     GIR_EraseRootFromParent_Done,
     /*  951094 */   // Label 14324: @951094
     /*  951094 */   GIM_Try, /*On fail goto*//*Label 14325*/ GIMT_Encode4(951176), // Rule ID 63268 //
     /*  951099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  951110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  951113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  951116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951126 */     // MIs[0] op1
     /*  951126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951153 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M1),
     /*  951156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951158 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951160 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951162 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951164 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951174 */     GIR_RootConstrainSelectedInstOperands,
     /*  951175 */     // GIR_Coverage, 63268,
     /*  951175 */     GIR_EraseRootFromParent_Done,
     /*  951176 */   // Label 14325: @951176
     /*  951176 */   GIM_Try, /*On fail goto*//*Label 14326*/ GIMT_Encode4(951258), // Rule ID 63299 //
     /*  951181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  951192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  951195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  951198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951208 */     // MIs[0] op1
     /*  951208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951211 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951235 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  951238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951240 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951242 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951244 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951246 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951256 */     GIR_RootConstrainSelectedInstOperands,
     /*  951257 */     // GIR_Coverage, 63299,
     /*  951257 */     GIR_EraseRootFromParent_Done,
     /*  951258 */   // Label 14326: @951258
     /*  951258 */   GIM_Try, /*On fail goto*//*Label 14327*/ GIMT_Encode4(951340), // Rule ID 63300 //
     /*  951263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  951274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  951277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  951280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951290 */     // MIs[0] op1
     /*  951290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951317 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  951317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  951320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951322 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951324 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951326 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951328 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951338 */     GIR_RootConstrainSelectedInstOperands,
     /*  951339 */     // GIR_Coverage, 63300,
     /*  951339 */     GIR_EraseRootFromParent_Done,
     /*  951340 */   // Label 14327: @951340
     /*  951340 */   GIM_Try, /*On fail goto*//*Label 14328*/ GIMT_Encode4(951422), // Rule ID 63311 //
     /*  951345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  951356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  951359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  951362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  951365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951372 */     // MIs[0] op1
     /*  951372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951375 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951399 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  951402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951404 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951406 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951408 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951410 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951420 */     GIR_RootConstrainSelectedInstOperands,
     /*  951421 */     // GIR_Coverage, 63311,
     /*  951421 */     GIR_EraseRootFromParent_Done,
     /*  951422 */   // Label 14328: @951422
     /*  951422 */   GIM_Try, /*On fail goto*//*Label 14329*/ GIMT_Encode4(951504), // Rule ID 63312 //
     /*  951427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  951438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  951441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  951444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  951447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951454 */     // MIs[0] op1
     /*  951454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951481 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  951481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  951484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951486 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951488 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951490 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951492 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951502 */     GIR_RootConstrainSelectedInstOperands,
     /*  951503 */     // GIR_Coverage, 63312,
     /*  951503 */     GIR_EraseRootFromParent_Done,
     /*  951504 */   // Label 14329: @951504
     /*  951504 */   GIM_Try, /*On fail goto*//*Label 14330*/ GIMT_Encode4(951586), // Rule ID 63323 //
     /*  951509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  951520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  951523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  951526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951536 */     // MIs[0] op1
     /*  951536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  951556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951563 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M1),
     /*  951566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951568 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951570 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951572 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951574 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951584 */     GIR_RootConstrainSelectedInstOperands,
     /*  951585 */     // GIR_Coverage, 63323,
     /*  951585 */     GIR_EraseRootFromParent_Done,
     /*  951586 */   // Label 14330: @951586
     /*  951586 */   GIM_Try, /*On fail goto*//*Label 14331*/ GIMT_Encode4(951668), // Rule ID 63324 //
     /*  951591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  951602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  951605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  951608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951618 */     // MIs[0] op1
     /*  951618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  951638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951645 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  951645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M1),
     /*  951648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951650 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951652 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951654 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951656 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951666 */     GIR_RootConstrainSelectedInstOperands,
     /*  951667 */     // GIR_Coverage, 63324,
     /*  951667 */     GIR_EraseRootFromParent_Done,
     /*  951668 */   // Label 14331: @951668
     /*  951668 */   GIM_Try, /*On fail goto*//*Label 14332*/ GIMT_Encode4(951750), // Rule ID 63355 //
     /*  951673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  951684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  951687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  951690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951700 */     // MIs[0] op1
     /*  951700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951703 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951727 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  951727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  951730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951732 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951734 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951736 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951738 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951748 */     GIR_RootConstrainSelectedInstOperands,
     /*  951749 */     // GIR_Coverage, 63355,
     /*  951749 */     GIR_EraseRootFromParent_Done,
     /*  951750 */   // Label 14332: @951750
     /*  951750 */   GIM_Try, /*On fail goto*//*Label 14333*/ GIMT_Encode4(951832), // Rule ID 63356 //
     /*  951755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  951766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  951769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  951772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951782 */     // MIs[0] op1
     /*  951782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951809 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  951809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  951812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951814 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951816 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951818 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951820 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951830 */     GIR_RootConstrainSelectedInstOperands,
     /*  951831 */     // GIR_Coverage, 63356,
     /*  951831 */     GIR_EraseRootFromParent_Done,
     /*  951832 */   // Label 14333: @951832
     /*  951832 */   GIM_Try, /*On fail goto*//*Label 14334*/ GIMT_Encode4(951914), // Rule ID 63367 //
     /*  951837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  951848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  951851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  951854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  951857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951864 */     // MIs[0] op1
     /*  951864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951867 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951891 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  951891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  951894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951896 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951898 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951900 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951902 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951912 */     GIR_RootConstrainSelectedInstOperands,
     /*  951913 */     // GIR_Coverage, 63367,
     /*  951913 */     GIR_EraseRootFromParent_Done,
     /*  951914 */   // Label 14334: @951914
     /*  951914 */   GIM_Try, /*On fail goto*//*Label 14335*/ GIMT_Encode4(951996), // Rule ID 63368 //
     /*  951919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  951930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  951933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  951936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  951939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951946 */     // MIs[0] op1
     /*  951946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951949 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951973 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  951973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  951976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951978 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951980 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951982 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951984 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951994 */     GIR_RootConstrainSelectedInstOperands,
     /*  951995 */     // GIR_Coverage, 63368,
     /*  951995 */     GIR_EraseRootFromParent_Done,
     /*  951996 */   // Label 14335: @951996
     /*  951996 */   GIM_Try, /*On fail goto*//*Label 14336*/ GIMT_Encode4(952078), // Rule ID 63399 //
     /*  952001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  952012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  952015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  952018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952028 */     // MIs[0] op1
     /*  952028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952055 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  952055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  952058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952060 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952062 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952064 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952066 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952076 */     GIR_RootConstrainSelectedInstOperands,
     /*  952077 */     // GIR_Coverage, 63399,
     /*  952077 */     GIR_EraseRootFromParent_Done,
     /*  952078 */   // Label 14336: @952078
     /*  952078 */   GIM_Try, /*On fail goto*//*Label 14337*/ GIMT_Encode4(952160), // Rule ID 63400 //
     /*  952083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  952094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  952097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  952100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952110 */     // MIs[0] op1
     /*  952110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952137 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  952137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  952140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952142 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952144 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952146 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952148 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952158 */     GIR_RootConstrainSelectedInstOperands,
     /*  952159 */     // GIR_Coverage, 63400,
     /*  952159 */     GIR_EraseRootFromParent_Done,
     /*  952160 */   // Label 14337: @952160
     /*  952160 */   GIM_Try, /*On fail goto*//*Label 14338*/ GIMT_Encode4(952242), // Rule ID 63411 //
     /*  952165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  952176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  952179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  952182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  952185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952192 */     // MIs[0] op1
     /*  952192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952195 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952219 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  952219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  952222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952224 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952226 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952228 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952230 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952240 */     GIR_RootConstrainSelectedInstOperands,
     /*  952241 */     // GIR_Coverage, 63411,
     /*  952241 */     GIR_EraseRootFromParent_Done,
     /*  952242 */   // Label 14338: @952242
     /*  952242 */   GIM_Try, /*On fail goto*//*Label 14339*/ GIMT_Encode4(952324), // Rule ID 63412 //
     /*  952247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  952258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  952261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  952264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  952267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952274 */     // MIs[0] op1
     /*  952274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952301 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  952301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  952304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952306 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952308 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952310 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952312 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952322 */     GIR_RootConstrainSelectedInstOperands,
     /*  952323 */     // GIR_Coverage, 63412,
     /*  952323 */     GIR_EraseRootFromParent_Done,
     /*  952324 */   // Label 14339: @952324
     /*  952324 */   GIM_Try, /*On fail goto*//*Label 14340*/ GIMT_Encode4(952406), // Rule ID 63443 //
     /*  952329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  952340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  952343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  952346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952356 */     // MIs[0] op1
     /*  952356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952359 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952383 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  952383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  952386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952388 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952390 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952392 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952394 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952404 */     GIR_RootConstrainSelectedInstOperands,
     /*  952405 */     // GIR_Coverage, 63443,
     /*  952405 */     GIR_EraseRootFromParent_Done,
     /*  952406 */   // Label 14340: @952406
     /*  952406 */   GIM_Try, /*On fail goto*//*Label 14341*/ GIMT_Encode4(952488), // Rule ID 63444 //
     /*  952411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  952422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  952425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  952428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952438 */     // MIs[0] op1
     /*  952438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952465 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  952465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  952468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952470 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952472 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952474 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952476 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952486 */     GIR_RootConstrainSelectedInstOperands,
     /*  952487 */     // GIR_Coverage, 63444,
     /*  952487 */     GIR_EraseRootFromParent_Done,
     /*  952488 */   // Label 14341: @952488
     /*  952488 */   GIM_Try, /*On fail goto*//*Label 14342*/ GIMT_Encode4(952570), // Rule ID 63455 //
     /*  952493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  952504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  952507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  952510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  952513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952520 */     // MIs[0] op1
     /*  952520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952523 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952547 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  952547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  952550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952552 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952554 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952556 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952558 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952568 */     GIR_RootConstrainSelectedInstOperands,
     /*  952569 */     // GIR_Coverage, 63455,
     /*  952569 */     GIR_EraseRootFromParent_Done,
     /*  952570 */   // Label 14342: @952570
     /*  952570 */   GIM_Try, /*On fail goto*//*Label 14343*/ GIMT_Encode4(952652), // Rule ID 63456 //
     /*  952575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  952586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  952589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  952592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  952595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952602 */     // MIs[0] op1
     /*  952602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952605 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952629 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  952629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  952632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952634 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952636 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952638 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952640 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952650 */     GIR_RootConstrainSelectedInstOperands,
     /*  952651 */     // GIR_Coverage, 63456,
     /*  952651 */     GIR_EraseRootFromParent_Done,
     /*  952652 */   // Label 14343: @952652
     /*  952652 */   GIM_Try, /*On fail goto*//*Label 14344*/ GIMT_Encode4(952734), // Rule ID 63487 //
     /*  952657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  952668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  952671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  952674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952684 */     // MIs[0] op1
     /*  952684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952711 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  952711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  952714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952716 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952718 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952720 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952722 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952732 */     GIR_RootConstrainSelectedInstOperands,
     /*  952733 */     // GIR_Coverage, 63487,
     /*  952733 */     GIR_EraseRootFromParent_Done,
     /*  952734 */   // Label 14344: @952734
     /*  952734 */   GIM_Try, /*On fail goto*//*Label 14345*/ GIMT_Encode4(952816), // Rule ID 63488 //
     /*  952739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  952750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  952753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  952756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952766 */     // MIs[0] op1
     /*  952766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  952793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  952796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952798 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952800 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952802 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952804 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952814 */     GIR_RootConstrainSelectedInstOperands,
     /*  952815 */     // GIR_Coverage, 63488,
     /*  952815 */     GIR_EraseRootFromParent_Done,
     /*  952816 */   // Label 14345: @952816
     /*  952816 */   GIM_Try, /*On fail goto*//*Label 14346*/ GIMT_Encode4(952898), // Rule ID 63499 //
     /*  952821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  952832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  952835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  952838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  952841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952848 */     // MIs[0] op1
     /*  952848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952875 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  952875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  952878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952880 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952882 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952884 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952886 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952896 */     GIR_RootConstrainSelectedInstOperands,
     /*  952897 */     // GIR_Coverage, 63499,
     /*  952897 */     GIR_EraseRootFromParent_Done,
     /*  952898 */   // Label 14346: @952898
     /*  952898 */   GIM_Try, /*On fail goto*//*Label 14347*/ GIMT_Encode4(952980), // Rule ID 63500 //
     /*  952903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  952914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  952917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  952920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  952923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952930 */     // MIs[0] op1
     /*  952930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952957 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  952957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  952960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952962 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952964 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952966 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952968 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952978 */     GIR_RootConstrainSelectedInstOperands,
     /*  952979 */     // GIR_Coverage, 63500,
     /*  952979 */     GIR_EraseRootFromParent_Done,
     /*  952980 */   // Label 14347: @952980
     /*  952980 */   GIM_Try, /*On fail goto*//*Label 14348*/ GIMT_Encode4(953062), // Rule ID 63511 //
     /*  952985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  952996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  952999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  953002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  953005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953012 */     // MIs[0] op1
     /*  953012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  953032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953039 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  953039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M2),
     /*  953042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953044 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953046 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953048 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953050 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953060 */     GIR_RootConstrainSelectedInstOperands,
     /*  953061 */     // GIR_Coverage, 63511,
     /*  953061 */     GIR_EraseRootFromParent_Done,
     /*  953062 */   // Label 14348: @953062
     /*  953062 */   GIM_Try, /*On fail goto*//*Label 14349*/ GIMT_Encode4(953144), // Rule ID 63512 //
     /*  953067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  953078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  953081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  953084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  953087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953094 */     // MIs[0] op1
     /*  953094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  953114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953121 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  953121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M2),
     /*  953124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953126 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953128 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953130 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953132 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953142 */     GIR_RootConstrainSelectedInstOperands,
     /*  953143 */     // GIR_Coverage, 63512,
     /*  953143 */     GIR_EraseRootFromParent_Done,
     /*  953144 */   // Label 14349: @953144
     /*  953144 */   GIM_Try, /*On fail goto*//*Label 14350*/ GIMT_Encode4(953226), // Rule ID 63543 //
     /*  953149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  953157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  953160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  953163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  953166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953176 */     // MIs[0] op1
     /*  953176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953179 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953203 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  953203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  953206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953208 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953210 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953212 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953214 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953224 */     GIR_RootConstrainSelectedInstOperands,
     /*  953225 */     // GIR_Coverage, 63543,
     /*  953225 */     GIR_EraseRootFromParent_Done,
     /*  953226 */   // Label 14350: @953226
     /*  953226 */   GIM_Try, /*On fail goto*//*Label 14351*/ GIMT_Encode4(953308), // Rule ID 63544 //
     /*  953231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  953239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  953242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  953245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  953248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953258 */     // MIs[0] op1
     /*  953258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953261 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953285 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  953285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  953288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953290 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953292 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953294 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953296 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953306 */     GIR_RootConstrainSelectedInstOperands,
     /*  953307 */     // GIR_Coverage, 63544,
     /*  953307 */     GIR_EraseRootFromParent_Done,
     /*  953308 */   // Label 14351: @953308
     /*  953308 */   GIM_Try, /*On fail goto*//*Label 14352*/ GIMT_Encode4(953390), // Rule ID 63555 //
     /*  953313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  953324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  953327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  953330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  953333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953340 */     // MIs[0] op1
     /*  953340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953367 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  953367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  953370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953372 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953374 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953376 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953378 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953388 */     GIR_RootConstrainSelectedInstOperands,
     /*  953389 */     // GIR_Coverage, 63555,
     /*  953389 */     GIR_EraseRootFromParent_Done,
     /*  953390 */   // Label 14352: @953390
     /*  953390 */   GIM_Try, /*On fail goto*//*Label 14353*/ GIMT_Encode4(953472), // Rule ID 63556 //
     /*  953395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  953406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  953409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  953412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  953415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953422 */     // MIs[0] op1
     /*  953422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953425 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953449 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  953449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  953452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953454 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953456 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953458 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953460 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953470 */     GIR_RootConstrainSelectedInstOperands,
     /*  953471 */     // GIR_Coverage, 63556,
     /*  953471 */     GIR_EraseRootFromParent_Done,
     /*  953472 */   // Label 14353: @953472
     /*  953472 */   GIM_Try, /*On fail goto*//*Label 14354*/ GIMT_Encode4(953554), // Rule ID 63567 //
     /*  953477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  953488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  953491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  953494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  953497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953504 */     // MIs[0] op1
     /*  953504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953507 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  953524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953531 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  953531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M4),
     /*  953534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953536 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953538 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953540 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953542 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953552 */     GIR_RootConstrainSelectedInstOperands,
     /*  953553 */     // GIR_Coverage, 63567,
     /*  953553 */     GIR_EraseRootFromParent_Done,
     /*  953554 */   // Label 14354: @953554
     /*  953554 */   GIM_Try, /*On fail goto*//*Label 14355*/ GIMT_Encode4(953636), // Rule ID 63568 //
     /*  953559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  953570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  953573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  953576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  953579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953586 */     // MIs[0] op1
     /*  953586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  953606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953613 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  953613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M4),
     /*  953616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953618 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953620 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953622 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953624 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953634 */     GIR_RootConstrainSelectedInstOperands,
     /*  953635 */     // GIR_Coverage, 63568,
     /*  953635 */     GIR_EraseRootFromParent_Done,
     /*  953636 */   // Label 14355: @953636
     /*  953636 */   GIM_Try, /*On fail goto*//*Label 14356*/ GIMT_Encode4(953718), // Rule ID 63599 //
     /*  953641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  953649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  953652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  953655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  953658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953668 */     // MIs[0] op1
     /*  953668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953671 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953695 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  953695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  953698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953700 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953702 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953704 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953706 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953716 */     GIR_RootConstrainSelectedInstOperands,
     /*  953717 */     // GIR_Coverage, 63599,
     /*  953717 */     GIR_EraseRootFromParent_Done,
     /*  953718 */   // Label 14356: @953718
     /*  953718 */   GIM_Try, /*On fail goto*//*Label 14357*/ GIMT_Encode4(953800), // Rule ID 63600 //
     /*  953723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  953731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  953734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  953737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  953740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953750 */     // MIs[0] op1
     /*  953750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953777 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  953777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  953780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953782 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953784 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953786 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953788 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953798 */     GIR_RootConstrainSelectedInstOperands,
     /*  953799 */     // GIR_Coverage, 63600,
     /*  953799 */     GIR_EraseRootFromParent_Done,
     /*  953800 */   // Label 14357: @953800
     /*  953800 */   GIM_Try, /*On fail goto*//*Label 14358*/ GIMT_Encode4(953882), // Rule ID 63611 //
     /*  953805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  953816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  953819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  953822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  953825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953832 */     // MIs[0] op1
     /*  953832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953859 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  953859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  953862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953864 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953866 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953868 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953870 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953880 */     GIR_RootConstrainSelectedInstOperands,
     /*  953881 */     // GIR_Coverage, 63611,
     /*  953881 */     GIR_EraseRootFromParent_Done,
     /*  953882 */   // Label 14358: @953882
     /*  953882 */   GIM_Try, /*On fail goto*//*Label 14359*/ GIMT_Encode4(953964), // Rule ID 63612 //
     /*  953887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  953898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  953901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  953904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  953907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953914 */     // MIs[0] op1
     /*  953914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953917 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953941 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  953941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  953944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953946 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953948 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953950 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953952 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953962 */     GIR_RootConstrainSelectedInstOperands,
     /*  953963 */     // GIR_Coverage, 63612,
     /*  953963 */     GIR_EraseRootFromParent_Done,
     /*  953964 */   // Label 14359: @953964
     /*  953964 */   GIM_Try, /*On fail goto*//*Label 14360*/ GIMT_Encode4(954046), // Rule ID 63623 //
     /*  953969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  953980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  953983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  953986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  953989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953996 */     // MIs[0] op1
     /*  953996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953999 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  954004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  954016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954023 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  954023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M8),
     /*  954026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954028 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954030 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954032 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954034 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  954044 */     GIR_RootConstrainSelectedInstOperands,
     /*  954045 */     // GIR_Coverage, 63623,
     /*  954045 */     GIR_EraseRootFromParent_Done,
     /*  954046 */   // Label 14360: @954046
     /*  954046 */   GIM_Try, /*On fail goto*//*Label 14361*/ GIMT_Encode4(954128), // Rule ID 63624 //
     /*  954051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  954059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  954062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  954065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  954068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  954071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954078 */     // MIs[0] op1
     /*  954078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954081 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  954086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  954098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954105 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  954105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M8),
     /*  954108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954110 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954112 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954114 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954116 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  954126 */     GIR_RootConstrainSelectedInstOperands,
     /*  954127 */     // GIR_Coverage, 63624,
     /*  954127 */     GIR_EraseRootFromParent_Done,
     /*  954128 */   // Label 14361: @954128
     /*  954128 */   GIM_Try, /*On fail goto*//*Label 14362*/ GIMT_Encode4(954210), // Rule ID 63655 //
     /*  954133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  954141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  954150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954160 */     // MIs[0] op1
     /*  954160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954163 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954187 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  954187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  954190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954192 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954194 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954196 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954198 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954208 */     GIR_RootConstrainSelectedInstOperands,
     /*  954209 */     // GIR_Coverage, 63655,
     /*  954209 */     GIR_EraseRootFromParent_Done,
     /*  954210 */   // Label 14362: @954210
     /*  954210 */   GIM_Try, /*On fail goto*//*Label 14363*/ GIMT_Encode4(954292), // Rule ID 63656 //
     /*  954215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  954223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  954232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954242 */     // MIs[0] op1
     /*  954242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  954269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  954272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954274 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954276 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954278 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954280 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954290 */     GIR_RootConstrainSelectedInstOperands,
     /*  954291 */     // GIR_Coverage, 63656,
     /*  954291 */     GIR_EraseRootFromParent_Done,
     /*  954292 */   // Label 14363: @954292
     /*  954292 */   GIM_Try, /*On fail goto*//*Label 14364*/ GIMT_Encode4(954374), // Rule ID 63667 //
     /*  954297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  954305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  954314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  954317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954324 */     // MIs[0] op1
     /*  954324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954351 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  954351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  954354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954356 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954358 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954360 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954362 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954372 */     GIR_RootConstrainSelectedInstOperands,
     /*  954373 */     // GIR_Coverage, 63667,
     /*  954373 */     GIR_EraseRootFromParent_Done,
     /*  954374 */   // Label 14364: @954374
     /*  954374 */   GIM_Try, /*On fail goto*//*Label 14365*/ GIMT_Encode4(954456), // Rule ID 63668 //
     /*  954379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  954387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  954396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  954399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954406 */     // MIs[0] op1
     /*  954406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954409 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  954433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  954436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954438 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954440 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954442 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954444 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954454 */     GIR_RootConstrainSelectedInstOperands,
     /*  954455 */     // GIR_Coverage, 63668,
     /*  954455 */     GIR_EraseRootFromParent_Done,
     /*  954456 */   // Label 14365: @954456
     /*  954456 */   GIM_Try, /*On fail goto*//*Label 14366*/ GIMT_Encode4(954538), // Rule ID 63679 //
     /*  954461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  954469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  954478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954488 */     // MIs[0] op1
     /*  954488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954491 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  954496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  954508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  954515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M2),
     /*  954518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954520 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954522 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954524 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954526 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954536 */     GIR_RootConstrainSelectedInstOperands,
     /*  954537 */     // GIR_Coverage, 63679,
     /*  954537 */     GIR_EraseRootFromParent_Done,
     /*  954538 */   // Label 14366: @954538
     /*  954538 */   GIM_Try, /*On fail goto*//*Label 14367*/ GIMT_Encode4(954620), // Rule ID 63680 //
     /*  954543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  954551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  954560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954570 */     // MIs[0] op1
     /*  954570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954573 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  954578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  954590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954597 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  954597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M2),
     /*  954600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954602 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954604 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954606 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954608 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954618 */     GIR_RootConstrainSelectedInstOperands,
     /*  954619 */     // GIR_Coverage, 63680,
     /*  954619 */     GIR_EraseRootFromParent_Done,
     /*  954620 */   // Label 14367: @954620
     /*  954620 */   GIM_Try, /*On fail goto*//*Label 14368*/ GIMT_Encode4(954702), // Rule ID 63711 //
     /*  954625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  954633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  954636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  954639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  954642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954652 */     // MIs[0] op1
     /*  954652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954679 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  954679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  954682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954684 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954686 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954688 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954690 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954700 */     GIR_RootConstrainSelectedInstOperands,
     /*  954701 */     // GIR_Coverage, 63711,
     /*  954701 */     GIR_EraseRootFromParent_Done,
     /*  954702 */   // Label 14368: @954702
     /*  954702 */   GIM_Try, /*On fail goto*//*Label 14369*/ GIMT_Encode4(954784), // Rule ID 63712 //
     /*  954707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  954715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  954718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  954721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  954724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954734 */     // MIs[0] op1
     /*  954734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954761 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  954761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  954764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954766 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954768 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954770 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954772 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954782 */     GIR_RootConstrainSelectedInstOperands,
     /*  954783 */     // GIR_Coverage, 63712,
     /*  954783 */     GIR_EraseRootFromParent_Done,
     /*  954784 */   // Label 14369: @954784
     /*  954784 */   GIM_Try, /*On fail goto*//*Label 14370*/ GIMT_Encode4(954866), // Rule ID 63723 //
     /*  954789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  954797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  954800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  954803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  954806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  954809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954816 */     // MIs[0] op1
     /*  954816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954819 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954843 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  954843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  954846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954848 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954850 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954852 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954854 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954864 */     GIR_RootConstrainSelectedInstOperands,
     /*  954865 */     // GIR_Coverage, 63723,
     /*  954865 */     GIR_EraseRootFromParent_Done,
     /*  954866 */   // Label 14370: @954866
     /*  954866 */   GIM_Try, /*On fail goto*//*Label 14371*/ GIMT_Encode4(954948), // Rule ID 63724 //
     /*  954871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  954879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  954882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  954885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  954888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  954891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954898 */     // MIs[0] op1
     /*  954898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954925 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  954925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  954928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954930 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954932 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954934 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954936 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954946 */     GIR_RootConstrainSelectedInstOperands,
     /*  954947 */     // GIR_Coverage, 63724,
     /*  954947 */     GIR_EraseRootFromParent_Done,
     /*  954948 */   // Label 14371: @954948
     /*  954948 */   GIM_Try, /*On fail goto*//*Label 14372*/ GIMT_Encode4(955030), // Rule ID 63735 //
     /*  954953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  954961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  954964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  954967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  954970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954980 */     // MIs[0] op1
     /*  954980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954983 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  954988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  955000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955007 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  955007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M4),
     /*  955010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955012 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955014 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955016 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955018 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955028 */     GIR_RootConstrainSelectedInstOperands,
     /*  955029 */     // GIR_Coverage, 63735,
     /*  955029 */     GIR_EraseRootFromParent_Done,
     /*  955030 */   // Label 14372: @955030
     /*  955030 */   GIM_Try, /*On fail goto*//*Label 14373*/ GIMT_Encode4(955112), // Rule ID 63736 //
     /*  955035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  955043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  955046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  955049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  955052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955062 */     // MIs[0] op1
     /*  955062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  955082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955089 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  955089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M4),
     /*  955092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955094 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955096 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955098 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955100 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955110 */     GIR_RootConstrainSelectedInstOperands,
     /*  955111 */     // GIR_Coverage, 63736,
     /*  955111 */     GIR_EraseRootFromParent_Done,
     /*  955112 */   // Label 14373: @955112
     /*  955112 */   GIM_Try, /*On fail goto*//*Label 14374*/ GIMT_Encode4(955194), // Rule ID 63767 //
     /*  955117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  955125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  955134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955144 */     // MIs[0] op1
     /*  955144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955171 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  955171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  955174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955176 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955178 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955180 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955182 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955192 */     GIR_RootConstrainSelectedInstOperands,
     /*  955193 */     // GIR_Coverage, 63767,
     /*  955193 */     GIR_EraseRootFromParent_Done,
     /*  955194 */   // Label 14374: @955194
     /*  955194 */   GIM_Try, /*On fail goto*//*Label 14375*/ GIMT_Encode4(955276), // Rule ID 63768 //
     /*  955199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  955207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  955216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955226 */     // MIs[0] op1
     /*  955226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955229 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955253 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  955253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  955256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955258 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955260 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955262 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955264 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955274 */     GIR_RootConstrainSelectedInstOperands,
     /*  955275 */     // GIR_Coverage, 63768,
     /*  955275 */     GIR_EraseRootFromParent_Done,
     /*  955276 */   // Label 14375: @955276
     /*  955276 */   GIM_Try, /*On fail goto*//*Label 14376*/ GIMT_Encode4(955358), // Rule ID 63779 //
     /*  955281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  955289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  955298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  955301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955308 */     // MIs[0] op1
     /*  955308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955335 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  955335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  955338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955340 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955342 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955344 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955346 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955356 */     GIR_RootConstrainSelectedInstOperands,
     /*  955357 */     // GIR_Coverage, 63779,
     /*  955357 */     GIR_EraseRootFromParent_Done,
     /*  955358 */   // Label 14376: @955358
     /*  955358 */   GIM_Try, /*On fail goto*//*Label 14377*/ GIMT_Encode4(955440), // Rule ID 63780 //
     /*  955363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  955371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  955380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  955383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955390 */     // MIs[0] op1
     /*  955390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955417 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  955417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  955420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955422 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955424 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955426 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955428 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955438 */     GIR_RootConstrainSelectedInstOperands,
     /*  955439 */     // GIR_Coverage, 63780,
     /*  955439 */     GIR_EraseRootFromParent_Done,
     /*  955440 */   // Label 14377: @955440
     /*  955440 */   GIM_Try, /*On fail goto*//*Label 14378*/ GIMT_Encode4(955522), // Rule ID 63791 //
     /*  955445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  955453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  955462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955472 */     // MIs[0] op1
     /*  955472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  955492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955499 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  955499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M8),
     /*  955502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955504 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955506 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955508 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955510 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955520 */     GIR_RootConstrainSelectedInstOperands,
     /*  955521 */     // GIR_Coverage, 63791,
     /*  955521 */     GIR_EraseRootFromParent_Done,
     /*  955522 */   // Label 14378: @955522
     /*  955522 */   GIM_Try, /*On fail goto*//*Label 14379*/ GIMT_Encode4(955604), // Rule ID 63792 //
     /*  955527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  955535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  955544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955554 */     // MIs[0] op1
     /*  955554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955557 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  955574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955581 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  955581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M8),
     /*  955584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955586 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955588 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955590 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955592 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955602 */     GIR_RootConstrainSelectedInstOperands,
     /*  955603 */     // GIR_Coverage, 63792,
     /*  955603 */     GIR_EraseRootFromParent_Done,
     /*  955604 */   // Label 14379: @955604
     /*  955604 */   GIM_Try, /*On fail goto*//*Label 14380*/ GIMT_Encode4(955686), // Rule ID 63823 //
     /*  955609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  955617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  955620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  955623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  955626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955636 */     // MIs[0] op1
     /*  955636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955639 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955663 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  955663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  955666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955668 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955670 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955672 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955674 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955684 */     GIR_RootConstrainSelectedInstOperands,
     /*  955685 */     // GIR_Coverage, 63823,
     /*  955685 */     GIR_EraseRootFromParent_Done,
     /*  955686 */   // Label 14380: @955686
     /*  955686 */   GIM_Try, /*On fail goto*//*Label 14381*/ GIMT_Encode4(955768), // Rule ID 63824 //
     /*  955691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  955699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  955702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  955705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  955708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955718 */     // MIs[0] op1
     /*  955718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955745 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  955745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  955748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955750 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955752 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955754 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955756 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955766 */     GIR_RootConstrainSelectedInstOperands,
     /*  955767 */     // GIR_Coverage, 63824,
     /*  955767 */     GIR_EraseRootFromParent_Done,
     /*  955768 */   // Label 14381: @955768
     /*  955768 */   GIM_Try, /*On fail goto*//*Label 14382*/ GIMT_Encode4(955850), // Rule ID 63835 //
     /*  955773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  955781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  955784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  955787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  955790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  955793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955800 */     // MIs[0] op1
     /*  955800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955803 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955827 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  955827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  955830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955832 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955834 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955836 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955838 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955848 */     GIR_RootConstrainSelectedInstOperands,
     /*  955849 */     // GIR_Coverage, 63835,
     /*  955849 */     GIR_EraseRootFromParent_Done,
     /*  955850 */   // Label 14382: @955850
     /*  955850 */   GIM_Try, /*On fail goto*//*Label 14383*/ GIMT_Encode4(955932), // Rule ID 63836 //
     /*  955855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  955863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  955866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  955869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  955872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  955875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955882 */     // MIs[0] op1
     /*  955882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955885 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955909 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  955909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  955912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955914 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955916 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955918 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955920 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955930 */     GIR_RootConstrainSelectedInstOperands,
     /*  955931 */     // GIR_Coverage, 63836,
     /*  955931 */     GIR_EraseRootFromParent_Done,
     /*  955932 */   // Label 14383: @955932
     /*  955932 */   GIM_Try, /*On fail goto*//*Label 14384*/ GIMT_Encode4(956014), // Rule ID 63847 //
     /*  955937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  955945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  955948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  955951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  955954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955964 */     // MIs[0] op1
     /*  955964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  955984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955991 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  955991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M2),
     /*  955994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955996 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955998 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956000 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956002 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956012 */     GIR_RootConstrainSelectedInstOperands,
     /*  956013 */     // GIR_Coverage, 63847,
     /*  956013 */     GIR_EraseRootFromParent_Done,
     /*  956014 */   // Label 14384: @956014
     /*  956014 */   GIM_Try, /*On fail goto*//*Label 14385*/ GIMT_Encode4(956096), // Rule ID 63848 //
     /*  956019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  956027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  956030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  956033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  956036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956046 */     // MIs[0] op1
     /*  956046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956049 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  956066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956073 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  956073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M2),
     /*  956076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956078 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956080 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956082 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956084 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956094 */     GIR_RootConstrainSelectedInstOperands,
     /*  956095 */     // GIR_Coverage, 63848,
     /*  956095 */     GIR_EraseRootFromParent_Done,
     /*  956096 */   // Label 14385: @956096
     /*  956096 */   GIM_Try, /*On fail goto*//*Label 14386*/ GIMT_Encode4(956178), // Rule ID 63879 //
     /*  956101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  956109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  956112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  956115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  956118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956128 */     // MIs[0] op1
     /*  956128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956155 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  956155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  956158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956160 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956162 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956164 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956166 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956176 */     GIR_RootConstrainSelectedInstOperands,
     /*  956177 */     // GIR_Coverage, 63879,
     /*  956177 */     GIR_EraseRootFromParent_Done,
     /*  956178 */   // Label 14386: @956178
     /*  956178 */   GIM_Try, /*On fail goto*//*Label 14387*/ GIMT_Encode4(956260), // Rule ID 63880 //
     /*  956183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  956191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  956194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  956197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  956200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956210 */     // MIs[0] op1
     /*  956210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956213 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956237 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  956237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  956240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956242 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956244 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956246 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956248 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956258 */     GIR_RootConstrainSelectedInstOperands,
     /*  956259 */     // GIR_Coverage, 63880,
     /*  956259 */     GIR_EraseRootFromParent_Done,
     /*  956260 */   // Label 14387: @956260
     /*  956260 */   GIM_Try, /*On fail goto*//*Label 14388*/ GIMT_Encode4(956342), // Rule ID 63891 //
     /*  956265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  956273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  956276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  956279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  956282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  956285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956292 */     // MIs[0] op1
     /*  956292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956319 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  956319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  956322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956324 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956326 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956328 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956330 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956340 */     GIR_RootConstrainSelectedInstOperands,
     /*  956341 */     // GIR_Coverage, 63891,
     /*  956341 */     GIR_EraseRootFromParent_Done,
     /*  956342 */   // Label 14388: @956342
     /*  956342 */   GIM_Try, /*On fail goto*//*Label 14389*/ GIMT_Encode4(956424), // Rule ID 63892 //
     /*  956347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  956355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  956358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  956361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  956364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  956367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956374 */     // MIs[0] op1
     /*  956374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956377 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956401 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  956401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  956404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956406 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956408 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956410 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956412 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956422 */     GIR_RootConstrainSelectedInstOperands,
     /*  956423 */     // GIR_Coverage, 63892,
     /*  956423 */     GIR_EraseRootFromParent_Done,
     /*  956424 */   // Label 14389: @956424
     /*  956424 */   GIM_Try, /*On fail goto*//*Label 14390*/ GIMT_Encode4(956506), // Rule ID 63903 //
     /*  956429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  956437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  956440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  956443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  956446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956456 */     // MIs[0] op1
     /*  956456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  956476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956483 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  956483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M4),
     /*  956486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956488 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956490 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956492 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956494 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956504 */     GIR_RootConstrainSelectedInstOperands,
     /*  956505 */     // GIR_Coverage, 63903,
     /*  956505 */     GIR_EraseRootFromParent_Done,
     /*  956506 */   // Label 14390: @956506
     /*  956506 */   GIM_Try, /*On fail goto*//*Label 14391*/ GIMT_Encode4(956588), // Rule ID 63904 //
     /*  956511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  956519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  956522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  956525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  956528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956538 */     // MIs[0] op1
     /*  956538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956541 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  956558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956565 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  956565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M4),
     /*  956568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956570 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956572 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956574 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956576 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956586 */     GIR_RootConstrainSelectedInstOperands,
     /*  956587 */     // GIR_Coverage, 63904,
     /*  956587 */     GIR_EraseRootFromParent_Done,
     /*  956588 */   // Label 14391: @956588
     /*  956588 */   GIM_Try, /*On fail goto*//*Label 14392*/ GIMT_Encode4(956670), // Rule ID 63935 //
     /*  956593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  956601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  956604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  956607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  956610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956620 */     // MIs[0] op1
     /*  956620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956647 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11062:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  956647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  956650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956652 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956654 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956656 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956658 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956668 */     GIR_RootConstrainSelectedInstOperands,
     /*  956669 */     // GIR_Coverage, 63935,
     /*  956669 */     GIR_EraseRootFromParent_Done,
     /*  956670 */   // Label 14392: @956670
     /*  956670 */   GIM_Try, /*On fail goto*//*Label 14393*/ GIMT_Encode4(956752), // Rule ID 63936 //
     /*  956675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  956683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  956686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  956689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  956692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956702 */     // MIs[0] op1
     /*  956702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956705 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956729 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11062:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  956729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  956732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956734 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956736 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956738 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956740 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956750 */     GIR_RootConstrainSelectedInstOperands,
     /*  956751 */     // GIR_Coverage, 63936,
     /*  956751 */     GIR_EraseRootFromParent_Done,
     /*  956752 */   // Label 14393: @956752
     /*  956752 */   GIM_Try, /*On fail goto*//*Label 14394*/ GIMT_Encode4(956834), // Rule ID 63947 //
     /*  956757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  956765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  956768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  956771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  956774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  956777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956784 */     // MIs[0] op1
     /*  956784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956811 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11054:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  956811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  956814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956816 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956818 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956820 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956822 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956832 */     GIR_RootConstrainSelectedInstOperands,
     /*  956833 */     // GIR_Coverage, 63947,
     /*  956833 */     GIR_EraseRootFromParent_Done,
     /*  956834 */   // Label 14394: @956834
     /*  956834 */   GIM_Try, /*On fail goto*//*Label 14395*/ GIMT_Encode4(956916), // Rule ID 63948 //
     /*  956839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  956847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  956850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  956853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  956856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  956859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956866 */     // MIs[0] op1
     /*  956866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956869 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956893 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11054:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  956893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  956896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956898 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956900 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956902 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956904 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956914 */     GIR_RootConstrainSelectedInstOperands,
     /*  956915 */     // GIR_Coverage, 63948,
     /*  956915 */     GIR_EraseRootFromParent_Done,
     /*  956916 */   // Label 14395: @956916
     /*  956916 */   GIM_Try, /*On fail goto*//*Label 14396*/ GIMT_Encode4(956998), // Rule ID 63959 //
     /*  956921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  956929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  956932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  956935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  956938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956948 */     // MIs[0] op1
     /*  956948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  956968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956975 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11040:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  956975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M8),
     /*  956978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956980 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956982 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956984 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956986 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956996 */     GIR_RootConstrainSelectedInstOperands,
     /*  956997 */     // GIR_Coverage, 63959,
     /*  956997 */     GIR_EraseRootFromParent_Done,
     /*  956998 */   // Label 14396: @956998
     /*  956998 */   GIM_Try, /*On fail goto*//*Label 14397*/ GIMT_Encode4(957080), // Rule ID 63960 //
     /*  957003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  957011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  957014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  957017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  957020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957030 */     // MIs[0] op1
     /*  957030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957033 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  957050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957057 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  957057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M8),
     /*  957060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957062 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957064 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957066 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957068 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  957078 */     GIR_RootConstrainSelectedInstOperands,
     /*  957079 */     // GIR_Coverage, 63960,
     /*  957079 */     GIR_EraseRootFromParent_Done,
     /*  957080 */   // Label 14397: @957080
     /*  957080 */   GIM_Try, /*On fail goto*//*Label 14398*/ GIMT_Encode4(957162), // Rule ID 63965 //
     /*  957085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  957096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  957099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  957102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957112 */     // MIs[0] op1
     /*  957112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957139 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  957139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF8),
     /*  957142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957144 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957146 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957148 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957150 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957160 */     GIR_RootConstrainSelectedInstOperands,
     /*  957161 */     // GIR_Coverage, 63965,
     /*  957161 */     GIR_EraseRootFromParent_Done,
     /*  957162 */   // Label 14398: @957162
     /*  957162 */   GIM_Try, /*On fail goto*//*Label 14399*/ GIMT_Encode4(957244), // Rule ID 63966 //
     /*  957167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  957178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  957181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  957184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957194 */     // MIs[0] op1
     /*  957194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957197 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957221 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  957221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF8),
     /*  957224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957226 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957228 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957230 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957232 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957242 */     GIR_RootConstrainSelectedInstOperands,
     /*  957243 */     // GIR_Coverage, 63966,
     /*  957243 */     GIR_EraseRootFromParent_Done,
     /*  957244 */   // Label 14399: @957244
     /*  957244 */   GIM_Try, /*On fail goto*//*Label 14400*/ GIMT_Encode4(957326), // Rule ID 63977 //
     /*  957249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  957260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  957263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  957266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  957269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957276 */     // MIs[0] op1
     /*  957276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957303 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  957303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF8),
     /*  957306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957308 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957310 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957312 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957314 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957324 */     GIR_RootConstrainSelectedInstOperands,
     /*  957325 */     // GIR_Coverage, 63977,
     /*  957325 */     GIR_EraseRootFromParent_Done,
     /*  957326 */   // Label 14400: @957326
     /*  957326 */   GIM_Try, /*On fail goto*//*Label 14401*/ GIMT_Encode4(957408), // Rule ID 63978 //
     /*  957331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  957342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  957345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  957348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  957351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957358 */     // MIs[0] op1
     /*  957358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957385 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  957385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF8),
     /*  957388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957390 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957392 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957394 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957396 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957406 */     GIR_RootConstrainSelectedInstOperands,
     /*  957407 */     // GIR_Coverage, 63978,
     /*  957407 */     GIR_EraseRootFromParent_Done,
     /*  957408 */   // Label 14401: @957408
     /*  957408 */   GIM_Try, /*On fail goto*//*Label 14402*/ GIMT_Encode4(957490), // Rule ID 63983 //
     /*  957413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  957424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  957427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  957430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957440 */     // MIs[0] op1
     /*  957440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957467 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  957467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  957470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957472 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957474 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957476 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957478 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957488 */     GIR_RootConstrainSelectedInstOperands,
     /*  957489 */     // GIR_Coverage, 63983,
     /*  957489 */     GIR_EraseRootFromParent_Done,
     /*  957490 */   // Label 14402: @957490
     /*  957490 */   GIM_Try, /*On fail goto*//*Label 14403*/ GIMT_Encode4(957572), // Rule ID 63984 //
     /*  957495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  957506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  957509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  957512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957522 */     // MIs[0] op1
     /*  957522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957525 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957549 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  957549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  957552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957554 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957556 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957558 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957560 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957570 */     GIR_RootConstrainSelectedInstOperands,
     /*  957571 */     // GIR_Coverage, 63984,
     /*  957571 */     GIR_EraseRootFromParent_Done,
     /*  957572 */   // Label 14403: @957572
     /*  957572 */   GIM_Try, /*On fail goto*//*Label 14404*/ GIMT_Encode4(957654), // Rule ID 63995 //
     /*  957577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  957588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  957591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  957594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  957597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957604 */     // MIs[0] op1
     /*  957604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957607 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957631 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  957631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  957634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957636 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957638 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957640 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957642 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957652 */     GIR_RootConstrainSelectedInstOperands,
     /*  957653 */     // GIR_Coverage, 63995,
     /*  957653 */     GIR_EraseRootFromParent_Done,
     /*  957654 */   // Label 14404: @957654
     /*  957654 */   GIM_Try, /*On fail goto*//*Label 14405*/ GIMT_Encode4(957736), // Rule ID 63996 //
     /*  957659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  957670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  957673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  957676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  957679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957686 */     // MIs[0] op1
     /*  957686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957713 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  957713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  957716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957718 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957720 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957722 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957724 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957734 */     GIR_RootConstrainSelectedInstOperands,
     /*  957735 */     // GIR_Coverage, 63996,
     /*  957735 */     GIR_EraseRootFromParent_Done,
     /*  957736 */   // Label 14405: @957736
     /*  957736 */   GIM_Try, /*On fail goto*//*Label 14406*/ GIMT_Encode4(957818), // Rule ID 64001 //
     /*  957741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  957752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  957755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  957758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957768 */     // MIs[0] op1
     /*  957768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957795 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  957795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  957798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957800 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957802 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957804 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957806 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957816 */     GIR_RootConstrainSelectedInstOperands,
     /*  957817 */     // GIR_Coverage, 64001,
     /*  957817 */     GIR_EraseRootFromParent_Done,
     /*  957818 */   // Label 14406: @957818
     /*  957818 */   GIM_Try, /*On fail goto*//*Label 14407*/ GIMT_Encode4(957900), // Rule ID 64002 //
     /*  957823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  957834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  957837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  957840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957850 */     // MIs[0] op1
     /*  957850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957853 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957877 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  957877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  957880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957882 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957884 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957886 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957888 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957898 */     GIR_RootConstrainSelectedInstOperands,
     /*  957899 */     // GIR_Coverage, 64002,
     /*  957899 */     GIR_EraseRootFromParent_Done,
     /*  957900 */   // Label 14407: @957900
     /*  957900 */   GIM_Try, /*On fail goto*//*Label 14408*/ GIMT_Encode4(957982), // Rule ID 64013 //
     /*  957905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  957916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  957919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  957922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  957925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957932 */     // MIs[0] op1
     /*  957932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957959 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  957959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  957962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957964 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957966 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957968 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957970 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957980 */     GIR_RootConstrainSelectedInstOperands,
     /*  957981 */     // GIR_Coverage, 64013,
     /*  957981 */     GIR_EraseRootFromParent_Done,
     /*  957982 */   // Label 14408: @957982
     /*  957982 */   GIM_Try, /*On fail goto*//*Label 14409*/ GIMT_Encode4(958064), // Rule ID 64014 //
     /*  957987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  957998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  958001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  958004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  958007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958014 */     // MIs[0] op1
     /*  958014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958041 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  958041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  958044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958046 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958048 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958050 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958052 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958062 */     GIR_RootConstrainSelectedInstOperands,
     /*  958063 */     // GIR_Coverage, 64014,
     /*  958063 */     GIR_EraseRootFromParent_Done,
     /*  958064 */   // Label 14409: @958064
     /*  958064 */   GIM_Try, /*On fail goto*//*Label 14410*/ GIMT_Encode4(958146), // Rule ID 64019 //
     /*  958069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  958080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  958083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  958086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958096 */     // MIs[0] op1
     /*  958096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958123 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  958123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  958126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958128 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958130 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958132 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958134 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958144 */     GIR_RootConstrainSelectedInstOperands,
     /*  958145 */     // GIR_Coverage, 64019,
     /*  958145 */     GIR_EraseRootFromParent_Done,
     /*  958146 */   // Label 14410: @958146
     /*  958146 */   GIM_Try, /*On fail goto*//*Label 14411*/ GIMT_Encode4(958228), // Rule ID 64020 //
     /*  958151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  958162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  958165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  958168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958178 */     // MIs[0] op1
     /*  958178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958205 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  958205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  958208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958210 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958212 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958214 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958216 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958226 */     GIR_RootConstrainSelectedInstOperands,
     /*  958227 */     // GIR_Coverage, 64020,
     /*  958227 */     GIR_EraseRootFromParent_Done,
     /*  958228 */   // Label 14411: @958228
     /*  958228 */   GIM_Try, /*On fail goto*//*Label 14412*/ GIMT_Encode4(958310), // Rule ID 64031 //
     /*  958233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  958244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  958247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  958250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  958253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958260 */     // MIs[0] op1
     /*  958260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958287 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  958287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  958290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958292 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958294 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958296 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958298 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958308 */     GIR_RootConstrainSelectedInstOperands,
     /*  958309 */     // GIR_Coverage, 64031,
     /*  958309 */     GIR_EraseRootFromParent_Done,
     /*  958310 */   // Label 14412: @958310
     /*  958310 */   GIM_Try, /*On fail goto*//*Label 14413*/ GIMT_Encode4(958392), // Rule ID 64032 //
     /*  958315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  958326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  958329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  958332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  958335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958342 */     // MIs[0] op1
     /*  958342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  958369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  958372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958374 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958376 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958378 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958380 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958390 */     GIR_RootConstrainSelectedInstOperands,
     /*  958391 */     // GIR_Coverage, 64032,
     /*  958391 */     GIR_EraseRootFromParent_Done,
     /*  958392 */   // Label 14413: @958392
     /*  958392 */   GIM_Try, /*On fail goto*//*Label 14414*/ GIMT_Encode4(958474), // Rule ID 64037 //
     /*  958397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  958408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  958411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  958414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958424 */     // MIs[0] op1
     /*  958424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958451 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  958451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  958454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958456 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958458 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958460 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958462 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958472 */     GIR_RootConstrainSelectedInstOperands,
     /*  958473 */     // GIR_Coverage, 64037,
     /*  958473 */     GIR_EraseRootFromParent_Done,
     /*  958474 */   // Label 14414: @958474
     /*  958474 */   GIM_Try, /*On fail goto*//*Label 14415*/ GIMT_Encode4(958556), // Rule ID 64038 //
     /*  958479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  958490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  958493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  958496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958506 */     // MIs[0] op1
     /*  958506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958509 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958533 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  958533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  958536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958538 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958540 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958542 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958544 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958554 */     GIR_RootConstrainSelectedInstOperands,
     /*  958555 */     // GIR_Coverage, 64038,
     /*  958555 */     GIR_EraseRootFromParent_Done,
     /*  958556 */   // Label 14415: @958556
     /*  958556 */   GIM_Try, /*On fail goto*//*Label 14416*/ GIMT_Encode4(958638), // Rule ID 64049 //
     /*  958561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  958572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  958575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  958578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  958581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958588 */     // MIs[0] op1
     /*  958588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958591 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958615 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  958615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  958618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958620 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958622 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958624 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958626 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958636 */     GIR_RootConstrainSelectedInstOperands,
     /*  958637 */     // GIR_Coverage, 64049,
     /*  958637 */     GIR_EraseRootFromParent_Done,
     /*  958638 */   // Label 14416: @958638
     /*  958638 */   GIM_Try, /*On fail goto*//*Label 14417*/ GIMT_Encode4(958720), // Rule ID 64050 //
     /*  958643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  958654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  958657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  958660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  958663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958670 */     // MIs[0] op1
     /*  958670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958697 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  958697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  958700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958702 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958704 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958706 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958708 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958718 */     GIR_RootConstrainSelectedInstOperands,
     /*  958719 */     // GIR_Coverage, 64050,
     /*  958719 */     GIR_EraseRootFromParent_Done,
     /*  958720 */   // Label 14417: @958720
     /*  958720 */   GIM_Try, /*On fail goto*//*Label 14418*/ GIMT_Encode4(958802), // Rule ID 64055 //
     /*  958725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  958736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  958739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  958742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958752 */     // MIs[0] op1
     /*  958752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958755 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958779 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  958779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  958782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958784 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958786 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958788 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958790 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958800 */     GIR_RootConstrainSelectedInstOperands,
     /*  958801 */     // GIR_Coverage, 64055,
     /*  958801 */     GIR_EraseRootFromParent_Done,
     /*  958802 */   // Label 14418: @958802
     /*  958802 */   GIM_Try, /*On fail goto*//*Label 14419*/ GIMT_Encode4(958884), // Rule ID 64056 //
     /*  958807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  958818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  958821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  958824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958834 */     // MIs[0] op1
     /*  958834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958837 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958861 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  958861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  958864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958866 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958868 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958870 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958872 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958882 */     GIR_RootConstrainSelectedInstOperands,
     /*  958883 */     // GIR_Coverage, 64056,
     /*  958883 */     GIR_EraseRootFromParent_Done,
     /*  958884 */   // Label 14419: @958884
     /*  958884 */   GIM_Try, /*On fail goto*//*Label 14420*/ GIMT_Encode4(958966), // Rule ID 64067 //
     /*  958889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  958900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  958903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  958906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  958909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958916 */     // MIs[0] op1
     /*  958916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958943 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  958943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  958946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958948 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958950 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958952 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958954 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958964 */     GIR_RootConstrainSelectedInstOperands,
     /*  958965 */     // GIR_Coverage, 64067,
     /*  958965 */     GIR_EraseRootFromParent_Done,
     /*  958966 */   // Label 14420: @958966
     /*  958966 */   GIM_Try, /*On fail goto*//*Label 14421*/ GIMT_Encode4(959048), // Rule ID 64068 //
     /*  958971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  958982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  958985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  958988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  958991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958998 */     // MIs[0] op1
     /*  958998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959025 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  959025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  959028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959030 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959032 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959034 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959036 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959046 */     GIR_RootConstrainSelectedInstOperands,
     /*  959047 */     // GIR_Coverage, 64068,
     /*  959047 */     GIR_EraseRootFromParent_Done,
     /*  959048 */   // Label 14421: @959048
     /*  959048 */   GIM_Try, /*On fail goto*//*Label 14422*/ GIMT_Encode4(959130), // Rule ID 64073 //
     /*  959053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  959064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  959067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  959070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959080 */     // MIs[0] op1
     /*  959080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959107 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  959110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959112 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959114 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959116 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959118 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959128 */     GIR_RootConstrainSelectedInstOperands,
     /*  959129 */     // GIR_Coverage, 64073,
     /*  959129 */     GIR_EraseRootFromParent_Done,
     /*  959130 */   // Label 14422: @959130
     /*  959130 */   GIM_Try, /*On fail goto*//*Label 14423*/ GIMT_Encode4(959212), // Rule ID 64074 //
     /*  959135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  959146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  959149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  959152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959162 */     // MIs[0] op1
     /*  959162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959165 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959189 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  959189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  959192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959194 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959196 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959198 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959200 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959210 */     GIR_RootConstrainSelectedInstOperands,
     /*  959211 */     // GIR_Coverage, 64074,
     /*  959211 */     GIR_EraseRootFromParent_Done,
     /*  959212 */   // Label 14423: @959212
     /*  959212 */   GIM_Try, /*On fail goto*//*Label 14424*/ GIMT_Encode4(959294), // Rule ID 64085 //
     /*  959217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  959228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  959231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  959234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  959237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959244 */     // MIs[0] op1
     /*  959244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959247 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959271 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  959274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959276 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959278 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959280 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959282 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959292 */     GIR_RootConstrainSelectedInstOperands,
     /*  959293 */     // GIR_Coverage, 64085,
     /*  959293 */     GIR_EraseRootFromParent_Done,
     /*  959294 */   // Label 14424: @959294
     /*  959294 */   GIM_Try, /*On fail goto*//*Label 14425*/ GIMT_Encode4(959376), // Rule ID 64086 //
     /*  959299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  959310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  959313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  959316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  959319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959326 */     // MIs[0] op1
     /*  959326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959353 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  959353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  959356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959358 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959360 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959362 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959364 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959374 */     GIR_RootConstrainSelectedInstOperands,
     /*  959375 */     // GIR_Coverage, 64086,
     /*  959375 */     GIR_EraseRootFromParent_Done,
     /*  959376 */   // Label 14425: @959376
     /*  959376 */   GIM_Try, /*On fail goto*//*Label 14426*/ GIMT_Encode4(959458), // Rule ID 64091 //
     /*  959381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  959392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  959395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  959398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  959401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959408 */     // MIs[0] op1
     /*  959408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  959428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959435 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11042:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF4),
     /*  959438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959440 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959442 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959444 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959446 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959456 */     GIR_RootConstrainSelectedInstOperands,
     /*  959457 */     // GIR_Coverage, 64091,
     /*  959457 */     GIR_EraseRootFromParent_Done,
     /*  959458 */   // Label 14426: @959458
     /*  959458 */   GIM_Try, /*On fail goto*//*Label 14427*/ GIMT_Encode4(959540), // Rule ID 64092 //
     /*  959463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  959474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  959477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  959480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  959483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959490 */     // MIs[0] op1
     /*  959490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959493 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  959510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959517 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11042:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  959517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF4),
     /*  959520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959522 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959524 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959526 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959528 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959538 */     GIR_RootConstrainSelectedInstOperands,
     /*  959539 */     // GIR_Coverage, 64092,
     /*  959539 */     GIR_EraseRootFromParent_Done,
     /*  959540 */   // Label 14427: @959540
     /*  959540 */   GIM_Try, /*On fail goto*//*Label 14428*/ GIMT_Encode4(959622), // Rule ID 64097 //
     /*  959545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  959556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  959559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  959562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959572 */     // MIs[0] op1
     /*  959572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959599 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  959602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959604 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959606 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959608 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959610 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959620 */     GIR_RootConstrainSelectedInstOperands,
     /*  959621 */     // GIR_Coverage, 64097,
     /*  959621 */     GIR_EraseRootFromParent_Done,
     /*  959622 */   // Label 14428: @959622
     /*  959622 */   GIM_Try, /*On fail goto*//*Label 14429*/ GIMT_Encode4(959704), // Rule ID 64098 //
     /*  959627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  959638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  959641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  959644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959654 */     // MIs[0] op1
     /*  959654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959657 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959681 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  959681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  959684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959686 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959688 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959690 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959692 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959702 */     GIR_RootConstrainSelectedInstOperands,
     /*  959703 */     // GIR_Coverage, 64098,
     /*  959703 */     GIR_EraseRootFromParent_Done,
     /*  959704 */   // Label 14429: @959704
     /*  959704 */   GIM_Try, /*On fail goto*//*Label 14430*/ GIMT_Encode4(959786), // Rule ID 64109 //
     /*  959709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  959720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  959723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  959726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  959729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959736 */     // MIs[0] op1
     /*  959736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959763 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  959766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959768 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959770 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959772 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959774 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959784 */     GIR_RootConstrainSelectedInstOperands,
     /*  959785 */     // GIR_Coverage, 64109,
     /*  959785 */     GIR_EraseRootFromParent_Done,
     /*  959786 */   // Label 14430: @959786
     /*  959786 */   GIM_Try, /*On fail goto*//*Label 14431*/ GIMT_Encode4(959868), // Rule ID 64110 //
     /*  959791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  959802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  959805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  959808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  959811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959818 */     // MIs[0] op1
     /*  959818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959845 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  959845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  959848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959850 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959852 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959854 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959856 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959866 */     GIR_RootConstrainSelectedInstOperands,
     /*  959867 */     // GIR_Coverage, 64110,
     /*  959867 */     GIR_EraseRootFromParent_Done,
     /*  959868 */   // Label 14431: @959868
     /*  959868 */   GIM_Try, /*On fail goto*//*Label 14432*/ GIMT_Encode4(959950), // Rule ID 64115 //
     /*  959873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  959884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  959887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  959890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  959893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959900 */     // MIs[0] op1
     /*  959900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  959920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11042:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF2),
     /*  959930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959932 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959934 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959936 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959938 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959948 */     GIR_RootConstrainSelectedInstOperands,
     /*  959949 */     // GIR_Coverage, 64115,
     /*  959949 */     GIR_EraseRootFromParent_Done,
     /*  959950 */   // Label 14432: @959950
     /*  959950 */   GIM_Try, /*On fail goto*//*Label 14433*/ GIMT_Encode4(960032), // Rule ID 64116 //
     /*  959955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  959966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  959969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  959972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  959975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959982 */     // MIs[0] op1
     /*  959982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959985 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  960002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960009 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11042:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF2),
     /*  960012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960014 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960016 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960018 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960020 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960030 */     GIR_RootConstrainSelectedInstOperands,
     /*  960031 */     // GIR_Coverage, 64116,
     /*  960031 */     GIR_EraseRootFromParent_Done,
     /*  960032 */   // Label 14433: @960032
     /*  960032 */   GIM_Try, /*On fail goto*//*Label 14434*/ GIMT_Encode4(960114), // Rule ID 64121 //
     /*  960037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  960040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  960045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  960048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  960051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  960054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  960057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960064 */     // MIs[0] op1
     /*  960064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  960084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960091 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  960094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960096 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960098 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960100 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960102 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960112 */     GIR_RootConstrainSelectedInstOperands,
     /*  960113 */     // GIR_Coverage, 64121,
     /*  960113 */     GIR_EraseRootFromParent_Done,
     /*  960114 */   // Label 14434: @960114
     /*  960114 */   GIM_Try, /*On fail goto*//*Label 14435*/ GIMT_Encode4(960196), // Rule ID 64122 //
     /*  960119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  960127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  960130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  960133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  960136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  960139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960146 */     // MIs[0] op1
     /*  960146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  960166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960173 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  960176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960178 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960180 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960182 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960184 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960194 */     GIR_RootConstrainSelectedInstOperands,
     /*  960195 */     // GIR_Coverage, 64122,
     /*  960195 */     GIR_EraseRootFromParent_Done,
     /*  960196 */   // Label 14435: @960196
     /*  960196 */   GIM_Try, /*On fail goto*//*Label 14436*/ GIMT_Encode4(960278), // Rule ID 64133 //
     /*  960201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  960204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  960209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  960212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  960215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  960218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  960221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960228 */     // MIs[0] op1
     /*  960228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  960258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960260 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960262 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960264 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960266 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960276 */     GIR_RootConstrainSelectedInstOperands,
     /*  960277 */     // GIR_Coverage, 64133,
     /*  960277 */     GIR_EraseRootFromParent_Done,
     /*  960278 */   // Label 14436: @960278
     /*  960278 */   GIM_Try, /*On fail goto*//*Label 14437*/ GIMT_Encode4(960360), // Rule ID 64134 //
     /*  960283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  960291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  960294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  960297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  960300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  960303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960310 */     // MIs[0] op1
     /*  960310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960313 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960337 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  960340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960342 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960344 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960346 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960348 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960358 */     GIR_RootConstrainSelectedInstOperands,
     /*  960359 */     // GIR_Coverage, 64134,
     /*  960359 */     GIR_EraseRootFromParent_Done,
     /*  960360 */   // Label 14437: @960360
     /*  960360 */   GIM_Try, /*On fail goto*//*Label 14438*/ GIMT_Encode4(960442), // Rule ID 64139 //
     /*  960365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  960368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  960373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  960376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  960379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  960382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  960385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960392 */     // MIs[0] op1
     /*  960392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  960400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  960412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960419 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11042:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M1),
     /*  960422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960424 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960426 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960428 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960430 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960440 */     GIR_RootConstrainSelectedInstOperands,
     /*  960441 */     // GIR_Coverage, 64139,
     /*  960441 */     GIR_EraseRootFromParent_Done,
     /*  960442 */   // Label 14438: @960442
     /*  960442 */   GIM_Try, /*On fail goto*//*Label 14439*/ GIMT_Encode4(960524), // Rule ID 64140 //
     /*  960447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  960455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  960458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  960461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  960464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  960467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960474 */     // MIs[0] op1
     /*  960474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  960482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  960494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11042:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M1),
     /*  960504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960506 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960508 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960510 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960512 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960522 */     GIR_RootConstrainSelectedInstOperands,
     /*  960523 */     // GIR_Coverage, 64140,
     /*  960523 */     GIR_EraseRootFromParent_Done,
     /*  960524 */   // Label 14439: @960524
     /*  960524 */   GIM_Try, /*On fail goto*//*Label 14440*/ GIMT_Encode4(960606), // Rule ID 64145 //
     /*  960529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  960532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  960537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  960540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  960543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  960546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  960549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960556 */     // MIs[0] op1
     /*  960556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960559 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  960576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960583 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  960586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960588 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960590 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960592 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960594 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960604 */     GIR_RootConstrainSelectedInstOperands,
     /*  960605 */     // GIR_Coverage, 64145,
     /*  960605 */     GIR_EraseRootFromParent_Done,
     /*  960606 */   // Label 14440: @960606
     /*  960606 */   GIM_Try, /*On fail goto*//*Label 14441*/ GIMT_Encode4(960688), // Rule ID 64146 //
     /*  960611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  960619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  960622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  960625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  960628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  960631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960638 */     // MIs[0] op1
     /*  960638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960641 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  960658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960665 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  960668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960670 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960672 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960674 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960676 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960686 */     GIR_RootConstrainSelectedInstOperands,
     /*  960687 */     // GIR_Coverage, 64146,
     /*  960687 */     GIR_EraseRootFromParent_Done,
     /*  960688 */   // Label 14441: @960688
     /*  960688 */   GIM_Try, /*On fail goto*//*Label 14442*/ GIMT_Encode4(960770), // Rule ID 64157 //
     /*  960693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  960696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  960701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  960704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  960707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  960710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  960713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960720 */     // MIs[0] op1
     /*  960720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960747 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  960750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960752 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960754 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960756 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960758 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960768 */     GIR_RootConstrainSelectedInstOperands,
     /*  960769 */     // GIR_Coverage, 64157,
     /*  960769 */     GIR_EraseRootFromParent_Done,
     /*  960770 */   // Label 14442: @960770
     /*  960770 */   GIM_Try, /*On fail goto*//*Label 14443*/ GIMT_Encode4(960852), // Rule ID 64158 //
     /*  960775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  960783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  960786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  960789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  960792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  960795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960802 */     // MIs[0] op1
     /*  960802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960805 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960829 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  960832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960834 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960836 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960838 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960840 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960850 */     GIR_RootConstrainSelectedInstOperands,
     /*  960851 */     // GIR_Coverage, 64158,
     /*  960851 */     GIR_EraseRootFromParent_Done,
     /*  960852 */   // Label 14443: @960852
     /*  960852 */   GIM_Try, /*On fail goto*//*Label 14444*/ GIMT_Encode4(960934), // Rule ID 64163 //
     /*  960857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  960860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  960865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  960868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  960871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  960874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  960877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960884 */     // MIs[0] op1
     /*  960884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960887 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  960892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  960904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960911 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11042:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M2),
     /*  960914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960916 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960918 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960920 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960922 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960932 */     GIR_RootConstrainSelectedInstOperands,
     /*  960933 */     // GIR_Coverage, 64163,
     /*  960933 */     GIR_EraseRootFromParent_Done,
     /*  960934 */   // Label 14444: @960934
     /*  960934 */   GIM_Try, /*On fail goto*//*Label 14445*/ GIMT_Encode4(961016), // Rule ID 64164 //
     /*  960939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  960947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  960950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  960953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  960956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  960959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960966 */     // MIs[0] op1
     /*  960966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  960974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  960986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960993 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11042:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M2),
     /*  960996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960998 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961000 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961002 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961004 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961014 */     GIR_RootConstrainSelectedInstOperands,
     /*  961015 */     // GIR_Coverage, 64164,
     /*  961015 */     GIR_EraseRootFromParent_Done,
     /*  961016 */   // Label 14445: @961016
     /*  961016 */   GIM_Try, /*On fail goto*//*Label 14446*/ GIMT_Encode4(961098), // Rule ID 64169 //
     /*  961021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  961024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  961029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  961038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  961041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961048 */     // MIs[0] op1
     /*  961048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961051 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  961068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961075 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  961075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  961078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961080 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961082 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961084 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961086 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961096 */     GIR_RootConstrainSelectedInstOperands,
     /*  961097 */     // GIR_Coverage, 64169,
     /*  961097 */     GIR_EraseRootFromParent_Done,
     /*  961098 */   // Label 14446: @961098
     /*  961098 */   GIM_Try, /*On fail goto*//*Label 14447*/ GIMT_Encode4(961180), // Rule ID 64170 //
     /*  961103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  961106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  961111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  961120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961130 */     // MIs[0] op1
     /*  961130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  961150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961157 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  961157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  961160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961162 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961164 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961166 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961168 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961178 */     GIR_RootConstrainSelectedInstOperands,
     /*  961179 */     // GIR_Coverage, 64170,
     /*  961179 */     GIR_EraseRootFromParent_Done,
     /*  961180 */   // Label 14447: @961180
     /*  961180 */   GIM_Try, /*On fail goto*//*Label 14448*/ GIMT_Encode4(961262), // Rule ID 64181 //
     /*  961185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  961188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  961193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  961202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  961205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961212 */     // MIs[0] op1
     /*  961212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961215 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961239 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  961239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  961242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961244 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961246 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961248 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961250 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961260 */     GIR_RootConstrainSelectedInstOperands,
     /*  961261 */     // GIR_Coverage, 64181,
     /*  961261 */     GIR_EraseRootFromParent_Done,
     /*  961262 */   // Label 14448: @961262
     /*  961262 */   GIM_Try, /*On fail goto*//*Label 14449*/ GIMT_Encode4(961344), // Rule ID 64182 //
     /*  961267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  961270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  961275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  961284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  961287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961294 */     // MIs[0] op1
     /*  961294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961297 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961321 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  961321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  961324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961326 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961328 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961330 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961332 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961342 */     GIR_RootConstrainSelectedInstOperands,
     /*  961343 */     // GIR_Coverage, 64182,
     /*  961343 */     GIR_EraseRootFromParent_Done,
     /*  961344 */   // Label 14449: @961344
     /*  961344 */   GIM_Try, /*On fail goto*//*Label 14450*/ GIMT_Encode4(961426), // Rule ID 64187 //
     /*  961349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  961352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  961357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  961366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  961369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961376 */     // MIs[0] op1
     /*  961376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961379 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  961384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  961396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961403 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11042:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  961403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M4),
     /*  961406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961408 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961410 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961412 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961414 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961424 */     GIR_RootConstrainSelectedInstOperands,
     /*  961425 */     // GIR_Coverage, 64187,
     /*  961425 */     GIR_EraseRootFromParent_Done,
     /*  961426 */   // Label 14450: @961426
     /*  961426 */   GIM_Try, /*On fail goto*//*Label 14451*/ GIMT_Encode4(961508), // Rule ID 64188 //
     /*  961431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  961434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  961439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  961448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  961451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961458 */     // MIs[0] op1
     /*  961458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  961466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  961478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961485 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11042:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  961485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M4),
     /*  961488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961490 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961492 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961494 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961496 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961506 */     GIR_RootConstrainSelectedInstOperands,
     /*  961507 */     // GIR_Coverage, 64188,
     /*  961507 */     GIR_EraseRootFromParent_Done,
     /*  961508 */   // Label 14451: @961508
     /*  961508 */   GIM_Try, /*On fail goto*//*Label 14452*/ GIMT_Encode4(961590), // Rule ID 64193 //
     /*  961513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  961516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  961521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  961530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  961533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961540 */     // MIs[0] op1
     /*  961540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  961560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961567 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  961567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  961570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961572 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961574 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961576 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961578 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961588 */     GIR_RootConstrainSelectedInstOperands,
     /*  961589 */     // GIR_Coverage, 64193,
     /*  961589 */     GIR_EraseRootFromParent_Done,
     /*  961590 */   // Label 14452: @961590
     /*  961590 */   GIM_Try, /*On fail goto*//*Label 14453*/ GIMT_Encode4(961672), // Rule ID 64194 //
     /*  961595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  961598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  961603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  961612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961622 */     // MIs[0] op1
     /*  961622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  961642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961649 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  961649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  961652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961654 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961656 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961658 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961660 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961670 */     GIR_RootConstrainSelectedInstOperands,
     /*  961671 */     // GIR_Coverage, 64194,
     /*  961671 */     GIR_EraseRootFromParent_Done,
     /*  961672 */   // Label 14453: @961672
     /*  961672 */   GIM_Try, /*On fail goto*//*Label 14454*/ GIMT_Encode4(961754), // Rule ID 64205 //
     /*  961677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  961680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  961685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  961694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  961697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961704 */     // MIs[0] op1
     /*  961704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961731 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  961731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  961734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961736 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961738 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961740 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961742 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961752 */     GIR_RootConstrainSelectedInstOperands,
     /*  961753 */     // GIR_Coverage, 64205,
     /*  961753 */     GIR_EraseRootFromParent_Done,
     /*  961754 */   // Label 14454: @961754
     /*  961754 */   GIM_Try, /*On fail goto*//*Label 14455*/ GIMT_Encode4(961836), // Rule ID 64206 //
     /*  961759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  961762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  961767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  961776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  961779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961786 */     // MIs[0] op1
     /*  961786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961813 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  961813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  961816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961818 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961820 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961822 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961824 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961834 */     GIR_RootConstrainSelectedInstOperands,
     /*  961835 */     // GIR_Coverage, 64206,
     /*  961835 */     GIR_EraseRootFromParent_Done,
     /*  961836 */   // Label 14455: @961836
     /*  961836 */   GIM_Try, /*On fail goto*//*Label 14456*/ GIMT_Encode4(961918), // Rule ID 64211 //
     /*  961841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  961844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  961849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  961858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961868 */     // MIs[0] op1
     /*  961868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961871 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  961876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  961888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961895 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11042:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  961895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_MF2),
     /*  961898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961900 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961902 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961904 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961906 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961916 */     GIR_RootConstrainSelectedInstOperands,
     /*  961917 */     // GIR_Coverage, 64211,
     /*  961917 */     GIR_EraseRootFromParent_Done,
     /*  961918 */   // Label 14456: @961918
     /*  961918 */   GIM_Try, /*On fail goto*//*Label 14457*/ GIMT_Encode4(962000), // Rule ID 64212 //
     /*  961923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  961926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  961931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  961940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961950 */     // MIs[0] op1
     /*  961950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  961958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  961970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961977 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11042:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  961977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_MF2),
     /*  961980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961982 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961984 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961986 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961988 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961998 */     GIR_RootConstrainSelectedInstOperands,
     /*  961999 */     // GIR_Coverage, 64212,
     /*  961999 */     GIR_EraseRootFromParent_Done,
     /*  962000 */   // Label 14457: @962000
     /*  962000 */   GIM_Try, /*On fail goto*//*Label 14458*/ GIMT_Encode4(962082), // Rule ID 64217 //
     /*  962005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  962013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  962022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  962025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962032 */     // MIs[0] op1
     /*  962032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  962052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  962062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962064 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962066 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962068 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962070 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962080 */     GIR_RootConstrainSelectedInstOperands,
     /*  962081 */     // GIR_Coverage, 64217,
     /*  962081 */     GIR_EraseRootFromParent_Done,
     /*  962082 */   // Label 14458: @962082
     /*  962082 */   GIM_Try, /*On fail goto*//*Label 14459*/ GIMT_Encode4(962164), // Rule ID 64218 //
     /*  962087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  962090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  962095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  962104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962114 */     // MIs[0] op1
     /*  962114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  962134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962141 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  962144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962146 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962148 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962150 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962152 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962162 */     GIR_RootConstrainSelectedInstOperands,
     /*  962163 */     // GIR_Coverage, 64218,
     /*  962163 */     GIR_EraseRootFromParent_Done,
     /*  962164 */   // Label 14459: @962164
     /*  962164 */   GIM_Try, /*On fail goto*//*Label 14460*/ GIMT_Encode4(962246), // Rule ID 64229 //
     /*  962169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  962177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  962186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  962189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962196 */     // MIs[0] op1
     /*  962196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962199 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962223 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  962226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962228 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962230 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962232 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962234 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962244 */     GIR_RootConstrainSelectedInstOperands,
     /*  962245 */     // GIR_Coverage, 64229,
     /*  962245 */     GIR_EraseRootFromParent_Done,
     /*  962246 */   // Label 14460: @962246
     /*  962246 */   GIM_Try, /*On fail goto*//*Label 14461*/ GIMT_Encode4(962328), // Rule ID 64230 //
     /*  962251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  962254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  962259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  962268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  962271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962278 */     // MIs[0] op1
     /*  962278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962305 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  962308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962310 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962312 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962314 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962316 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962326 */     GIR_RootConstrainSelectedInstOperands,
     /*  962327 */     // GIR_Coverage, 64230,
     /*  962327 */     GIR_EraseRootFromParent_Done,
     /*  962328 */   // Label 14461: @962328
     /*  962328 */   GIM_Try, /*On fail goto*//*Label 14462*/ GIMT_Encode4(962410), // Rule ID 64235 //
     /*  962333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  962341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  962350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962360 */     // MIs[0] op1
     /*  962360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  962368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  962380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962387 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11042:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M1),
     /*  962390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962392 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962394 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962396 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962398 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962408 */     GIR_RootConstrainSelectedInstOperands,
     /*  962409 */     // GIR_Coverage, 64235,
     /*  962409 */     GIR_EraseRootFromParent_Done,
     /*  962410 */   // Label 14462: @962410
     /*  962410 */   GIM_Try, /*On fail goto*//*Label 14463*/ GIMT_Encode4(962492), // Rule ID 64236 //
     /*  962415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  962418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  962423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  962432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962442 */     // MIs[0] op1
     /*  962442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  962450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  962462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11042:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M1),
     /*  962472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962474 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962476 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962478 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962480 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962490 */     GIR_RootConstrainSelectedInstOperands,
     /*  962491 */     // GIR_Coverage, 64236,
     /*  962491 */     GIR_EraseRootFromParent_Done,
     /*  962492 */   // Label 14463: @962492
     /*  962492 */   GIM_Try, /*On fail goto*//*Label 14464*/ GIMT_Encode4(962574), // Rule ID 64241 //
     /*  962497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  962505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  962514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  962517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962524 */     // MIs[0] op1
     /*  962524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  962544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962551 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  962554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962556 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962558 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962560 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962562 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962572 */     GIR_RootConstrainSelectedInstOperands,
     /*  962573 */     // GIR_Coverage, 64241,
     /*  962573 */     GIR_EraseRootFromParent_Done,
     /*  962574 */   // Label 14464: @962574
     /*  962574 */   GIM_Try, /*On fail goto*//*Label 14465*/ GIMT_Encode4(962656), // Rule ID 64242 //
     /*  962579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  962582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  962587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  962596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962606 */     // MIs[0] op1
     /*  962606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  962626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962633 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  962636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962638 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962640 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962642 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962644 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962654 */     GIR_RootConstrainSelectedInstOperands,
     /*  962655 */     // GIR_Coverage, 64242,
     /*  962655 */     GIR_EraseRootFromParent_Done,
     /*  962656 */   // Label 14465: @962656
     /*  962656 */   GIM_Try, /*On fail goto*//*Label 14466*/ GIMT_Encode4(962738), // Rule ID 64253 //
     /*  962661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  962669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  962678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  962681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962688 */     // MIs[0] op1
     /*  962688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962691 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962715 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  962718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962720 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962722 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962724 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962726 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962736 */     GIR_RootConstrainSelectedInstOperands,
     /*  962737 */     // GIR_Coverage, 64253,
     /*  962737 */     GIR_EraseRootFromParent_Done,
     /*  962738 */   // Label 14466: @962738
     /*  962738 */   GIM_Try, /*On fail goto*//*Label 14467*/ GIMT_Encode4(962820), // Rule ID 64254 //
     /*  962743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  962746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  962751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  962760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  962763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962770 */     // MIs[0] op1
     /*  962770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962797 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  962800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962802 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962804 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962806 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962808 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962818 */     GIR_RootConstrainSelectedInstOperands,
     /*  962819 */     // GIR_Coverage, 64254,
     /*  962819 */     GIR_EraseRootFromParent_Done,
     /*  962820 */   // Label 14467: @962820
     /*  962820 */   GIM_Try, /*On fail goto*//*Label 14468*/ GIMT_Encode4(962902), // Rule ID 64259 //
     /*  962825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  962833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  962842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962852 */     // MIs[0] op1
     /*  962852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  962860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  962872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962879 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11042:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M2),
     /*  962882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962884 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962886 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962888 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962890 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962900 */     GIR_RootConstrainSelectedInstOperands,
     /*  962901 */     // GIR_Coverage, 64259,
     /*  962901 */     GIR_EraseRootFromParent_Done,
     /*  962902 */   // Label 14468: @962902
     /*  962902 */   GIM_Try, /*On fail goto*//*Label 14469*/ GIMT_Encode4(962984), // Rule ID 64260 //
     /*  962907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  962910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  962915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  962924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962934 */     // MIs[0] op1
     /*  962934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  962942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  962954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962961 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11042:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M2),
     /*  962964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962966 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962968 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962970 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962972 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962982 */     GIR_RootConstrainSelectedInstOperands,
     /*  962983 */     // GIR_Coverage, 64260,
     /*  962983 */     GIR_EraseRootFromParent_Done,
     /*  962984 */   // Label 14469: @962984
     /*  962984 */   GIM_Try, /*On fail goto*//*Label 14470*/ GIMT_Encode4(963066), // Rule ID 64265 //
     /*  962989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  962997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  963006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  963009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963016 */     // MIs[0] op1
     /*  963016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  963019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  963024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  963036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11064:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  963046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963048 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  963050 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  963052 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  963054 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  963056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963064 */     GIR_RootConstrainSelectedInstOperands,
     /*  963065 */     // GIR_Coverage, 64265,
     /*  963065 */     GIR_EraseRootFromParent_Done,
     /*  963066 */   // Label 14470: @963066
     /*  963066 */   GIM_Try, /*On fail goto*//*Label 14471*/ GIMT_Encode4(963148), // Rule ID 64266 //
     /*  963071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  963074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  963079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  963088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  963091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963098 */     // MIs[0] op1
     /*  963098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  963101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  963106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  963118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963125 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  963128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963130 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  963132 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  963134 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  963136 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  963138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963146 */     GIR_RootConstrainSelectedInstOperands,
     /*  963147 */     // GIR_Coverage, 64266,
     /*  963147 */     GIR_EraseRootFromParent_Done,
     /*  963148 */   // Label 14471: @963148
     /*  963148 */   GIM_Try, /*On fail goto*//*Label 14472*/ GIMT_Encode4(963230), // Rule ID 64277 //
     /*  963153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  963156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  963161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  963170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  963173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963180 */     // MIs[0] op1
     /*  963180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  963183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  963188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963207 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11056:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  963210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963212 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  963214 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  963216 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  963218 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  963220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963228 */     GIR_RootConstrainSelectedInstOperands,
     /*  963229 */     // GIR_Coverage, 64277,
     /*  963229 */     GIR_EraseRootFromParent_Done,
     /*  963230 */   // Label 14472: @963230
     /*  963230 */   GIM_Try, /*On fail goto*//*Label 14473*/ GIMT_Encode4(963312), // Rule ID 64278 //
     /*  963235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  963238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  963243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  963252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  963255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963262 */     // MIs[0] op1
     /*  963262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  963265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  963270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963289 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  963292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963294 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  963296 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  963298 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  963300 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  963302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963310 */     GIR_RootConstrainSelectedInstOperands,
     /*  963311 */     // GIR_Coverage, 64278,
     /*  963311 */     GIR_EraseRootFromParent_Done,
     /*  963312 */   // Label 14473: @963312
     /*  963312 */   GIM_Try, /*On fail goto*//*Label 14474*/ GIMT_Encode4(963394), // Rule ID 64283 //
     /*  963317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  963320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  963325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  963334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  963337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963344 */     // MIs[0] op1
     /*  963344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  963347 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  963352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  963364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963371 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11042:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M4),
     /*  963374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963376 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  963378 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  963380 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  963382 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  963384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963392 */     GIR_RootConstrainSelectedInstOperands,
     /*  963393 */     // GIR_Coverage, 64283,
     /*  963393 */     GIR_EraseRootFromParent_Done,
     /*  963394 */   // Label 14474: @963394
     /*  963394 */   GIM_Try, /*On fail goto*//*Label 14475*/ GIMT_Encode4(963476), // Rule ID 64284 //
     /*  963399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  963402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  963407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  963416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  963419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963426 */     // MIs[0] op1
     /*  963426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  963429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  963434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  963446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963453 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11042:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M4),
     /*  963456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963458 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  963460 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  963462 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  963464 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  963466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963474 */     GIR_RootConstrainSelectedInstOperands,
     /*  963475 */     // GIR_Coverage, 64284,
     /*  963475 */     GIR_EraseRootFromParent_Done,
     /*  963476 */   // Label 14475: @963476
     /*  963476 */   GIM_Try, /*On fail goto*//*Label 14476*/ GIMT_Encode4(963568), // Rule ID 5196 //
     /*  963481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  963492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  963495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  963498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  963504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963531 */     // MIs[1] Operand 1
     /*  963531 */     // No operand predicates
     /*  963531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  963544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  963547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963566 */     GIR_RootConstrainSelectedInstOperands,
     /*  963567 */     // GIR_Coverage, 5196,
     /*  963567 */     GIR_EraseRootFromParent_Done,
     /*  963568 */   // Label 14476: @963568
     /*  963568 */   GIM_Try, /*On fail goto*//*Label 14477*/ GIMT_Encode4(963660), // Rule ID 5197 //
     /*  963573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  963584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  963587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  963590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  963596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963623 */     // MIs[1] Operand 1
     /*  963623 */     // No operand predicates
     /*  963623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963636 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  963636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  963639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963658 */     GIR_RootConstrainSelectedInstOperands,
     /*  963659 */     // GIR_Coverage, 5197,
     /*  963659 */     GIR_EraseRootFromParent_Done,
     /*  963660 */   // Label 14477: @963660
     /*  963660 */   GIM_Try, /*On fail goto*//*Label 14478*/ GIMT_Encode4(963752), // Rule ID 5198 //
     /*  963665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  963676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  963679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  963682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963715 */     // MIs[1] Operand 1
     /*  963715 */     // No operand predicates
     /*  963715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963728 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  963728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  963731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963750 */     GIR_RootConstrainSelectedInstOperands,
     /*  963751 */     // GIR_Coverage, 5198,
     /*  963751 */     GIR_EraseRootFromParent_Done,
     /*  963752 */   // Label 14478: @963752
     /*  963752 */   GIM_Try, /*On fail goto*//*Label 14479*/ GIMT_Encode4(963844), // Rule ID 5199 //
     /*  963757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  963768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  963771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  963774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963807 */     // MIs[1] Operand 1
     /*  963807 */     // No operand predicates
     /*  963807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963820 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  963820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  963823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963842 */     GIR_RootConstrainSelectedInstOperands,
     /*  963843 */     // GIR_Coverage, 5199,
     /*  963843 */     GIR_EraseRootFromParent_Done,
     /*  963844 */   // Label 14479: @963844
     /*  963844 */   GIM_Try, /*On fail goto*//*Label 14480*/ GIMT_Encode4(963936), // Rule ID 5200 //
     /*  963849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  963860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  963863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  963866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963899 */     // MIs[1] Operand 1
     /*  963899 */     // No operand predicates
     /*  963899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963912 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  963912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  963915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963934 */     GIR_RootConstrainSelectedInstOperands,
     /*  963935 */     // GIR_Coverage, 5200,
     /*  963935 */     GIR_EraseRootFromParent_Done,
     /*  963936 */   // Label 14480: @963936
     /*  963936 */   GIM_Try, /*On fail goto*//*Label 14481*/ GIMT_Encode4(964028), // Rule ID 5201 //
     /*  963941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  963952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  963955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  963958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963991 */     // MIs[1] Operand 1
     /*  963991 */     // No operand predicates
     /*  963991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964004 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  964004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  964007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964026 */     GIR_RootConstrainSelectedInstOperands,
     /*  964027 */     // GIR_Coverage, 5201,
     /*  964027 */     GIR_EraseRootFromParent_Done,
     /*  964028 */   // Label 14481: @964028
     /*  964028 */   GIM_Try, /*On fail goto*//*Label 14482*/ GIMT_Encode4(964120), // Rule ID 5202 //
     /*  964033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  964044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  964047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  964050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964083 */     // MIs[1] Operand 1
     /*  964083 */     // No operand predicates
     /*  964083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964096 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  964096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  964099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964118 */     GIR_RootConstrainSelectedInstOperands,
     /*  964119 */     // GIR_Coverage, 5202,
     /*  964119 */     GIR_EraseRootFromParent_Done,
     /*  964120 */   // Label 14482: @964120
     /*  964120 */   GIM_Try, /*On fail goto*//*Label 14483*/ GIMT_Encode4(964212), // Rule ID 5203 //
     /*  964125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  964136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  964139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  964142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964175 */     // MIs[1] Operand 1
     /*  964175 */     // No operand predicates
     /*  964175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964188 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  964188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  964191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964210 */     GIR_RootConstrainSelectedInstOperands,
     /*  964211 */     // GIR_Coverage, 5203,
     /*  964211 */     GIR_EraseRootFromParent_Done,
     /*  964212 */   // Label 14483: @964212
     /*  964212 */   GIM_Try, /*On fail goto*//*Label 14484*/ GIMT_Encode4(964304), // Rule ID 5204 //
     /*  964217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  964228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  964231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  964234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964267 */     // MIs[1] Operand 1
     /*  964267 */     // No operand predicates
     /*  964267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964280 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  964280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  964283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964302 */     GIR_RootConstrainSelectedInstOperands,
     /*  964303 */     // GIR_Coverage, 5204,
     /*  964303 */     GIR_EraseRootFromParent_Done,
     /*  964304 */   // Label 14484: @964304
     /*  964304 */   GIM_Try, /*On fail goto*//*Label 14485*/ GIMT_Encode4(964396), // Rule ID 5205 //
     /*  964309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  964320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  964323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  964326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964359 */     // MIs[1] Operand 1
     /*  964359 */     // No operand predicates
     /*  964359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964372 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  964372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  964375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964394 */     GIR_RootConstrainSelectedInstOperands,
     /*  964395 */     // GIR_Coverage, 5205,
     /*  964395 */     GIR_EraseRootFromParent_Done,
     /*  964396 */   // Label 14485: @964396
     /*  964396 */   GIM_Try, /*On fail goto*//*Label 14486*/ GIMT_Encode4(964488), // Rule ID 5206 //
     /*  964401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  964412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  964415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  964418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964451 */     // MIs[1] Operand 1
     /*  964451 */     // No operand predicates
     /*  964451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964464 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  964464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  964467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964486 */     GIR_RootConstrainSelectedInstOperands,
     /*  964487 */     // GIR_Coverage, 5206,
     /*  964487 */     GIR_EraseRootFromParent_Done,
     /*  964488 */   // Label 14486: @964488
     /*  964488 */   GIM_Try, /*On fail goto*//*Label 14487*/ GIMT_Encode4(964580), // Rule ID 5207 //
     /*  964493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  964504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  964507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  964510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964543 */     // MIs[1] Operand 1
     /*  964543 */     // No operand predicates
     /*  964543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964556 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  964556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  964559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964578 */     GIR_RootConstrainSelectedInstOperands,
     /*  964579 */     // GIR_Coverage, 5207,
     /*  964579 */     GIR_EraseRootFromParent_Done,
     /*  964580 */   // Label 14487: @964580
     /*  964580 */   GIM_Try, /*On fail goto*//*Label 14488*/ GIMT_Encode4(964672), // Rule ID 5208 //
     /*  964585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  964596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  964599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  964602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  964608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964635 */     // MIs[1] Operand 1
     /*  964635 */     // No operand predicates
     /*  964635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964648 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  964648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  964651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964670 */     GIR_RootConstrainSelectedInstOperands,
     /*  964671 */     // GIR_Coverage, 5208,
     /*  964671 */     GIR_EraseRootFromParent_Done,
     /*  964672 */   // Label 14488: @964672
     /*  964672 */   GIM_Try, /*On fail goto*//*Label 14489*/ GIMT_Encode4(964764), // Rule ID 5209 //
     /*  964677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  964688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  964691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  964694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  964700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964727 */     // MIs[1] Operand 1
     /*  964727 */     // No operand predicates
     /*  964727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  964740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  964743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964762 */     GIR_RootConstrainSelectedInstOperands,
     /*  964763 */     // GIR_Coverage, 5209,
     /*  964763 */     GIR_EraseRootFromParent_Done,
     /*  964764 */   // Label 14489: @964764
     /*  964764 */   GIM_Try, /*On fail goto*//*Label 14490*/ GIMT_Encode4(964856), // Rule ID 5210 //
     /*  964769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  964780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  964783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  964786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964819 */     // MIs[1] Operand 1
     /*  964819 */     // No operand predicates
     /*  964819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964832 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  964832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  964835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964854 */     GIR_RootConstrainSelectedInstOperands,
     /*  964855 */     // GIR_Coverage, 5210,
     /*  964855 */     GIR_EraseRootFromParent_Done,
     /*  964856 */   // Label 14490: @964856
     /*  964856 */   GIM_Try, /*On fail goto*//*Label 14491*/ GIMT_Encode4(964948), // Rule ID 5211 //
     /*  964861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  964872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  964875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  964878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964911 */     // MIs[1] Operand 1
     /*  964911 */     // No operand predicates
     /*  964911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964924 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  964924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  964927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964946 */     GIR_RootConstrainSelectedInstOperands,
     /*  964947 */     // GIR_Coverage, 5211,
     /*  964947 */     GIR_EraseRootFromParent_Done,
     /*  964948 */   // Label 14491: @964948
     /*  964948 */   GIM_Try, /*On fail goto*//*Label 14492*/ GIMT_Encode4(965040), // Rule ID 5212 //
     /*  964953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  964964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  964967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  964970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965003 */     // MIs[1] Operand 1
     /*  965003 */     // No operand predicates
     /*  965003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965016 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  965016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  965019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965038 */     GIR_RootConstrainSelectedInstOperands,
     /*  965039 */     // GIR_Coverage, 5212,
     /*  965039 */     GIR_EraseRootFromParent_Done,
     /*  965040 */   // Label 14492: @965040
     /*  965040 */   GIM_Try, /*On fail goto*//*Label 14493*/ GIMT_Encode4(965132), // Rule ID 5213 //
     /*  965045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  965056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  965059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  965062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  965068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  965075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965095 */     // MIs[1] Operand 1
     /*  965095 */     // No operand predicates
     /*  965095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965108 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  965108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  965111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965130 */     GIR_RootConstrainSelectedInstOperands,
     /*  965131 */     // GIR_Coverage, 5213,
     /*  965131 */     GIR_EraseRootFromParent_Done,
     /*  965132 */   // Label 14493: @965132
     /*  965132 */   GIM_Try, /*On fail goto*//*Label 14494*/ GIMT_Encode4(965224), // Rule ID 5214 //
     /*  965137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  965140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  965148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  965151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  965154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  965167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965187 */     // MIs[1] Operand 1
     /*  965187 */     // No operand predicates
     /*  965187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965200 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  965200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  965203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  965222 */     GIR_RootConstrainSelectedInstOperands,
     /*  965223 */     // GIR_Coverage, 5214,
     /*  965223 */     GIR_EraseRootFromParent_Done,
     /*  965224 */   // Label 14494: @965224
     /*  965224 */   GIM_Try, /*On fail goto*//*Label 14495*/ GIMT_Encode4(965316), // Rule ID 5215 //
     /*  965229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  965232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  965240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  965243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  965246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  965259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965279 */     // MIs[1] Operand 1
     /*  965279 */     // No operand predicates
     /*  965279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965292 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  965292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  965295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  965314 */     GIR_RootConstrainSelectedInstOperands,
     /*  965315 */     // GIR_Coverage, 5215,
     /*  965315 */     GIR_EraseRootFromParent_Done,
     /*  965316 */   // Label 14495: @965316
     /*  965316 */   GIM_Try, /*On fail goto*//*Label 14496*/ GIMT_Encode4(965408), // Rule ID 5216 //
     /*  965321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  965332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  965335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  965338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  965344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  965351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965371 */     // MIs[1] Operand 1
     /*  965371 */     // No operand predicates
     /*  965371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965384 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  965384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  965387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965406 */     GIR_RootConstrainSelectedInstOperands,
     /*  965407 */     // GIR_Coverage, 5216,
     /*  965407 */     GIR_EraseRootFromParent_Done,
     /*  965408 */   // Label 14496: @965408
     /*  965408 */   GIM_Try, /*On fail goto*//*Label 14497*/ GIMT_Encode4(965500), // Rule ID 5217 //
     /*  965413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  965424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  965427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  965430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  965436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  965443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965463 */     // MIs[1] Operand 1
     /*  965463 */     // No operand predicates
     /*  965463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965476 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  965476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  965479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965498 */     GIR_RootConstrainSelectedInstOperands,
     /*  965499 */     // GIR_Coverage, 5217,
     /*  965499 */     GIR_EraseRootFromParent_Done,
     /*  965500 */   // Label 14497: @965500
     /*  965500 */   GIM_Try, /*On fail goto*//*Label 14498*/ GIMT_Encode4(965592), // Rule ID 5218 //
     /*  965505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  965516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  965519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  965522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  965528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  965535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965555 */     // MIs[1] Operand 1
     /*  965555 */     // No operand predicates
     /*  965555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965568 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  965568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  965571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965590 */     GIR_RootConstrainSelectedInstOperands,
     /*  965591 */     // GIR_Coverage, 5218,
     /*  965591 */     GIR_EraseRootFromParent_Done,
     /*  965592 */   // Label 14498: @965592
     /*  965592 */   GIM_Try, /*On fail goto*//*Label 14499*/ GIMT_Encode4(965684), // Rule ID 5219 //
     /*  965597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  965608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  965611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  965614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  965620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  965627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965647 */     // MIs[1] Operand 1
     /*  965647 */     // No operand predicates
     /*  965647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965660 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  965660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  965663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965682 */     GIR_RootConstrainSelectedInstOperands,
     /*  965683 */     // GIR_Coverage, 5219,
     /*  965683 */     GIR_EraseRootFromParent_Done,
     /*  965684 */   // Label 14499: @965684
     /*  965684 */   GIM_Try, /*On fail goto*//*Label 14500*/ GIMT_Encode4(965776), // Rule ID 5220 //
     /*  965689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  965700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  965703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  965706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  965712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  965719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  965723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  965727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965739 */     // MIs[1] Operand 1
     /*  965739 */     // No operand predicates
     /*  965739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965752 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  965752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  965755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965774 */     GIR_RootConstrainSelectedInstOperands,
     /*  965775 */     // GIR_Coverage, 5220,
     /*  965775 */     GIR_EraseRootFromParent_Done,
     /*  965776 */   // Label 14500: @965776
     /*  965776 */   GIM_Try, /*On fail goto*//*Label 14501*/ GIMT_Encode4(965868), // Rule ID 5221 //
     /*  965781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  965792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  965795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  965798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  965804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  965811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  965815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  965819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965831 */     // MIs[1] Operand 1
     /*  965831 */     // No operand predicates
     /*  965831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965844 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  965844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  965847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965866 */     GIR_RootConstrainSelectedInstOperands,
     /*  965867 */     // GIR_Coverage, 5221,
     /*  965867 */     GIR_EraseRootFromParent_Done,
     /*  965868 */   // Label 14501: @965868
     /*  965868 */   GIM_Try, /*On fail goto*//*Label 14502*/ GIMT_Encode4(965960), // Rule ID 5222 //
     /*  965873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  965884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  965887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  965890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  965896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  965903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965923 */     // MIs[1] Operand 1
     /*  965923 */     // No operand predicates
     /*  965923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965936 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  965936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  965939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965958 */     GIR_RootConstrainSelectedInstOperands,
     /*  965959 */     // GIR_Coverage, 5222,
     /*  965959 */     GIR_EraseRootFromParent_Done,
     /*  965960 */   // Label 14502: @965960
     /*  965960 */   GIM_Try, /*On fail goto*//*Label 14503*/ GIMT_Encode4(966052), // Rule ID 5223 //
     /*  965965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  965976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  965979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  965982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  965988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  965995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966015 */     // MIs[1] Operand 1
     /*  966015 */     // No operand predicates
     /*  966015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966028 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  966028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  966031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966050 */     GIR_RootConstrainSelectedInstOperands,
     /*  966051 */     // GIR_Coverage, 5223,
     /*  966051 */     GIR_EraseRootFromParent_Done,
     /*  966052 */   // Label 14503: @966052
     /*  966052 */   GIM_Try, /*On fail goto*//*Label 14504*/ GIMT_Encode4(966144), // Rule ID 5224 //
     /*  966057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  966068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  966071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  966087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966107 */     // MIs[1] Operand 1
     /*  966107 */     // No operand predicates
     /*  966107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966120 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  966120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  966123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966142 */     GIR_RootConstrainSelectedInstOperands,
     /*  966143 */     // GIR_Coverage, 5224,
     /*  966143 */     GIR_EraseRootFromParent_Done,
     /*  966144 */   // Label 14504: @966144
     /*  966144 */   GIM_Try, /*On fail goto*//*Label 14505*/ GIMT_Encode4(966236), // Rule ID 5225 //
     /*  966149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  966160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  966163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  966179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966199 */     // MIs[1] Operand 1
     /*  966199 */     // No operand predicates
     /*  966199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966212 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  966212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  966215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966234 */     GIR_RootConstrainSelectedInstOperands,
     /*  966235 */     // GIR_Coverage, 5225,
     /*  966235 */     GIR_EraseRootFromParent_Done,
     /*  966236 */   // Label 14505: @966236
     /*  966236 */   GIM_Try, /*On fail goto*//*Label 14506*/ GIMT_Encode4(966328), // Rule ID 5226 //
     /*  966241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  966252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  966255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  966258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  966271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966291 */     // MIs[1] Operand 1
     /*  966291 */     // No operand predicates
     /*  966291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966304 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  966304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  966307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966326 */     GIR_RootConstrainSelectedInstOperands,
     /*  966327 */     // GIR_Coverage, 5226,
     /*  966327 */     GIR_EraseRootFromParent_Done,
     /*  966328 */   // Label 14506: @966328
     /*  966328 */   GIM_Try, /*On fail goto*//*Label 14507*/ GIMT_Encode4(966420), // Rule ID 5227 //
     /*  966333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  966344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  966347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  966350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  966363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966383 */     // MIs[1] Operand 1
     /*  966383 */     // No operand predicates
     /*  966383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966396 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  966396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  966399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966418 */     GIR_RootConstrainSelectedInstOperands,
     /*  966419 */     // GIR_Coverage, 5227,
     /*  966419 */     GIR_EraseRootFromParent_Done,
     /*  966420 */   // Label 14507: @966420
     /*  966420 */   GIM_Try, /*On fail goto*//*Label 14508*/ GIMT_Encode4(966512), // Rule ID 5228 //
     /*  966425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  966436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  966439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  966442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  966448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  966455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966475 */     // MIs[1] Operand 1
     /*  966475 */     // No operand predicates
     /*  966475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966488 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  966488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  966491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966510 */     GIR_RootConstrainSelectedInstOperands,
     /*  966511 */     // GIR_Coverage, 5228,
     /*  966511 */     GIR_EraseRootFromParent_Done,
     /*  966512 */   // Label 14508: @966512
     /*  966512 */   GIM_Try, /*On fail goto*//*Label 14509*/ GIMT_Encode4(966604), // Rule ID 5229 //
     /*  966517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  966528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  966531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  966534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  966540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  966547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966567 */     // MIs[1] Operand 1
     /*  966567 */     // No operand predicates
     /*  966567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  966580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  966583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966602 */     GIR_RootConstrainSelectedInstOperands,
     /*  966603 */     // GIR_Coverage, 5229,
     /*  966603 */     GIR_EraseRootFromParent_Done,
     /*  966604 */   // Label 14509: @966604
     /*  966604 */   GIM_Try, /*On fail goto*//*Label 14510*/ GIMT_Encode4(966696), // Rule ID 5230 //
     /*  966609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  966620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  966623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  966626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  966639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966659 */     // MIs[1] Operand 1
     /*  966659 */     // No operand predicates
     /*  966659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966672 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  966672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  966675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966694 */     GIR_RootConstrainSelectedInstOperands,
     /*  966695 */     // GIR_Coverage, 5230,
     /*  966695 */     GIR_EraseRootFromParent_Done,
     /*  966696 */   // Label 14510: @966696
     /*  966696 */   GIM_Try, /*On fail goto*//*Label 14511*/ GIMT_Encode4(966788), // Rule ID 5231 //
     /*  966701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  966712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  966715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  966718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  966731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966751 */     // MIs[1] Operand 1
     /*  966751 */     // No operand predicates
     /*  966751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966764 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  966764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  966767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966786 */     GIR_RootConstrainSelectedInstOperands,
     /*  966787 */     // GIR_Coverage, 5231,
     /*  966787 */     GIR_EraseRootFromParent_Done,
     /*  966788 */   // Label 14511: @966788
     /*  966788 */   GIM_Try, /*On fail goto*//*Label 14512*/ GIMT_Encode4(966880), // Rule ID 5232 //
     /*  966793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  966804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  966807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  966810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  966823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966843 */     // MIs[1] Operand 1
     /*  966843 */     // No operand predicates
     /*  966843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966856 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  966856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  966859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966878 */     GIR_RootConstrainSelectedInstOperands,
     /*  966879 */     // GIR_Coverage, 5232,
     /*  966879 */     GIR_EraseRootFromParent_Done,
     /*  966880 */   // Label 14512: @966880
     /*  966880 */   GIM_Try, /*On fail goto*//*Label 14513*/ GIMT_Encode4(966972), // Rule ID 5233 //
     /*  966885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  966896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  966899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  966902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  966915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966935 */     // MIs[1] Operand 1
     /*  966935 */     // No operand predicates
     /*  966935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966948 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  966948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  966951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966970 */     GIR_RootConstrainSelectedInstOperands,
     /*  966971 */     // GIR_Coverage, 5233,
     /*  966971 */     GIR_EraseRootFromParent_Done,
     /*  966972 */   // Label 14513: @966972
     /*  966972 */   GIM_Try, /*On fail goto*//*Label 14514*/ GIMT_Encode4(967064), // Rule ID 5234 //
     /*  966977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  966980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  966988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  966991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  966994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  967007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967027 */     // MIs[1] Operand 1
     /*  967027 */     // No operand predicates
     /*  967027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  967040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  967043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967062 */     GIR_RootConstrainSelectedInstOperands,
     /*  967063 */     // GIR_Coverage, 5234,
     /*  967063 */     GIR_EraseRootFromParent_Done,
     /*  967064 */   // Label 14514: @967064
     /*  967064 */   GIM_Try, /*On fail goto*//*Label 14515*/ GIMT_Encode4(967156), // Rule ID 5235 //
     /*  967069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  967077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  967080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  967083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  967086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  967099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967119 */     // MIs[1] Operand 1
     /*  967119 */     // No operand predicates
     /*  967119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  967132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  967135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967154 */     GIR_RootConstrainSelectedInstOperands,
     /*  967155 */     // GIR_Coverage, 5235,
     /*  967155 */     GIR_EraseRootFromParent_Done,
     /*  967156 */   // Label 14515: @967156
     /*  967156 */   GIM_Try, /*On fail goto*//*Label 14516*/ GIMT_Encode4(967248), // Rule ID 5236 //
     /*  967161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  967169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  967172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  967175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  967178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  967191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967211 */     // MIs[1] Operand 1
     /*  967211 */     // No operand predicates
     /*  967211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967224 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  967224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  967227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967246 */     GIR_RootConstrainSelectedInstOperands,
     /*  967247 */     // GIR_Coverage, 5236,
     /*  967247 */     GIR_EraseRootFromParent_Done,
     /*  967248 */   // Label 14516: @967248
     /*  967248 */   GIM_Try, /*On fail goto*//*Label 14517*/ GIMT_Encode4(967340), // Rule ID 5237 //
     /*  967253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  967261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  967264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  967267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  967270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  967283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967303 */     // MIs[1] Operand 1
     /*  967303 */     // No operand predicates
     /*  967303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967316 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  967316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  967319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967338 */     GIR_RootConstrainSelectedInstOperands,
     /*  967339 */     // GIR_Coverage, 5237,
     /*  967339 */     GIR_EraseRootFromParent_Done,
     /*  967340 */   // Label 14517: @967340
     /*  967340 */   GIM_Try, /*On fail goto*//*Label 14518*/ GIMT_Encode4(967432), // Rule ID 5238 //
     /*  967345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  967353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  967356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  967359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  967362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  967375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967395 */     // MIs[1] Operand 1
     /*  967395 */     // No operand predicates
     /*  967395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  967408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  967411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967430 */     GIR_RootConstrainSelectedInstOperands,
     /*  967431 */     // GIR_Coverage, 5238,
     /*  967431 */     GIR_EraseRootFromParent_Done,
     /*  967432 */   // Label 14518: @967432
     /*  967432 */   GIM_Try, /*On fail goto*//*Label 14519*/ GIMT_Encode4(967524), // Rule ID 5239 //
     /*  967437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  967445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  967448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  967451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  967454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  967467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967487 */     // MIs[1] Operand 1
     /*  967487 */     // No operand predicates
     /*  967487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967500 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  967500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  967503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967522 */     GIR_RootConstrainSelectedInstOperands,
     /*  967523 */     // GIR_Coverage, 5239,
     /*  967523 */     GIR_EraseRootFromParent_Done,
     /*  967524 */   // Label 14519: @967524
     /*  967524 */   GIM_Try, /*On fail goto*//*Label 14520*/ GIMT_Encode4(967619), // Rule ID 7970 //
     /*  967529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  967540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  967543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  967546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  967552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967579 */     // MIs[1] Operand 1
     /*  967579 */     // No operand predicates
     /*  967579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967592 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  967592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  967595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967617 */     GIR_RootConstrainSelectedInstOperands,
     /*  967618 */     // GIR_Coverage, 7970,
     /*  967618 */     GIR_EraseRootFromParent_Done,
     /*  967619 */   // Label 14520: @967619
     /*  967619 */   GIM_Try, /*On fail goto*//*Label 14521*/ GIMT_Encode4(967714), // Rule ID 7971 //
     /*  967624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  967635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  967638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  967641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  967647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967674 */     // MIs[1] Operand 1
     /*  967674 */     // No operand predicates
     /*  967674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967687 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  967687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  967690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967712 */     GIR_RootConstrainSelectedInstOperands,
     /*  967713 */     // GIR_Coverage, 7971,
     /*  967713 */     GIR_EraseRootFromParent_Done,
     /*  967714 */   // Label 14521: @967714
     /*  967714 */   GIM_Try, /*On fail goto*//*Label 14522*/ GIMT_Encode4(967809), // Rule ID 7974 //
     /*  967719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  967736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967769 */     // MIs[1] Operand 1
     /*  967769 */     // No operand predicates
     /*  967769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967782 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  967782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  967785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967807 */     GIR_RootConstrainSelectedInstOperands,
     /*  967808 */     // GIR_Coverage, 7974,
     /*  967808 */     GIR_EraseRootFromParent_Done,
     /*  967809 */   // Label 14522: @967809
     /*  967809 */   GIM_Try, /*On fail goto*//*Label 14523*/ GIMT_Encode4(967904), // Rule ID 7975 //
     /*  967814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  967831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967864 */     // MIs[1] Operand 1
     /*  967864 */     // No operand predicates
     /*  967864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967877 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  967877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  967880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967902 */     GIR_RootConstrainSelectedInstOperands,
     /*  967903 */     // GIR_Coverage, 7975,
     /*  967903 */     GIR_EraseRootFromParent_Done,
     /*  967904 */   // Label 14523: @967904
     /*  967904 */   GIM_Try, /*On fail goto*//*Label 14524*/ GIMT_Encode4(967999), // Rule ID 7978 //
     /*  967909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  967926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967959 */     // MIs[1] Operand 1
     /*  967959 */     // No operand predicates
     /*  967959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967972 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  967972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  967975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967997 */     GIR_RootConstrainSelectedInstOperands,
     /*  967998 */     // GIR_Coverage, 7978,
     /*  967998 */     GIR_EraseRootFromParent_Done,
     /*  967999 */   // Label 14524: @967999
     /*  967999 */   GIM_Try, /*On fail goto*//*Label 14525*/ GIMT_Encode4(968094), // Rule ID 7979 //
     /*  968004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  968021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968054 */     // MIs[1] Operand 1
     /*  968054 */     // No operand predicates
     /*  968054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968067 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  968070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968092 */     GIR_RootConstrainSelectedInstOperands,
     /*  968093 */     // GIR_Coverage, 7979,
     /*  968093 */     GIR_EraseRootFromParent_Done,
     /*  968094 */   // Label 14525: @968094
     /*  968094 */   GIM_Try, /*On fail goto*//*Label 14526*/ GIMT_Encode4(968189), // Rule ID 7982 //
     /*  968099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  968116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968149 */     // MIs[1] Operand 1
     /*  968149 */     // No operand predicates
     /*  968149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968162 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  968165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968187 */     GIR_RootConstrainSelectedInstOperands,
     /*  968188 */     // GIR_Coverage, 7982,
     /*  968188 */     GIR_EraseRootFromParent_Done,
     /*  968189 */   // Label 14526: @968189
     /*  968189 */   GIM_Try, /*On fail goto*//*Label 14527*/ GIMT_Encode4(968284), // Rule ID 7983 //
     /*  968194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  968211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968244 */     // MIs[1] Operand 1
     /*  968244 */     // No operand predicates
     /*  968244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968257 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  968257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  968260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968282 */     GIR_RootConstrainSelectedInstOperands,
     /*  968283 */     // GIR_Coverage, 7983,
     /*  968283 */     GIR_EraseRootFromParent_Done,
     /*  968284 */   // Label 14527: @968284
     /*  968284 */   GIM_Try, /*On fail goto*//*Label 14528*/ GIMT_Encode4(968379), // Rule ID 7986 //
     /*  968289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  968306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968339 */     // MIs[1] Operand 1
     /*  968339 */     // No operand predicates
     /*  968339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968352 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  968355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968377 */     GIR_RootConstrainSelectedInstOperands,
     /*  968378 */     // GIR_Coverage, 7986,
     /*  968378 */     GIR_EraseRootFromParent_Done,
     /*  968379 */   // Label 14528: @968379
     /*  968379 */   GIM_Try, /*On fail goto*//*Label 14529*/ GIMT_Encode4(968474), // Rule ID 7987 //
     /*  968384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  968401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968434 */     // MIs[1] Operand 1
     /*  968434 */     // No operand predicates
     /*  968434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968447 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  968447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  968450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968472 */     GIR_RootConstrainSelectedInstOperands,
     /*  968473 */     // GIR_Coverage, 7987,
     /*  968473 */     GIR_EraseRootFromParent_Done,
     /*  968474 */   // Label 14529: @968474
     /*  968474 */   GIM_Try, /*On fail goto*//*Label 14530*/ GIMT_Encode4(968569), // Rule ID 7990 //
     /*  968479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  968496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968529 */     // MIs[1] Operand 1
     /*  968529 */     // No operand predicates
     /*  968529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968542 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  968542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  968545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  968564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968567 */     GIR_RootConstrainSelectedInstOperands,
     /*  968568 */     // GIR_Coverage, 7990,
     /*  968568 */     GIR_EraseRootFromParent_Done,
     /*  968569 */   // Label 14530: @968569
     /*  968569 */   GIM_Try, /*On fail goto*//*Label 14531*/ GIMT_Encode4(968664), // Rule ID 7991 //
     /*  968574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  968591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968624 */     // MIs[1] Operand 1
     /*  968624 */     // No operand predicates
     /*  968624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968637 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  968637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  968640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  968659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968662 */     GIR_RootConstrainSelectedInstOperands,
     /*  968663 */     // GIR_Coverage, 7991,
     /*  968663 */     GIR_EraseRootFromParent_Done,
     /*  968664 */   // Label 14531: @968664
     /*  968664 */   GIM_Try, /*On fail goto*//*Label 14532*/ GIMT_Encode4(968759), // Rule ID 7994 //
     /*  968669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  968680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  968683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  968686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  968692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968719 */     // MIs[1] Operand 1
     /*  968719 */     // No operand predicates
     /*  968719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968732 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  968732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  968735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968757 */     GIR_RootConstrainSelectedInstOperands,
     /*  968758 */     // GIR_Coverage, 7994,
     /*  968758 */     GIR_EraseRootFromParent_Done,
     /*  968759 */   // Label 14532: @968759
     /*  968759 */   GIM_Try, /*On fail goto*//*Label 14533*/ GIMT_Encode4(968854), // Rule ID 7995 //
     /*  968764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  968775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  968778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  968781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  968787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968814 */     // MIs[1] Operand 1
     /*  968814 */     // No operand predicates
     /*  968814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968827 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  968830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968852 */     GIR_RootConstrainSelectedInstOperands,
     /*  968853 */     // GIR_Coverage, 7995,
     /*  968853 */     GIR_EraseRootFromParent_Done,
     /*  968854 */   // Label 14533: @968854
     /*  968854 */   GIM_Try, /*On fail goto*//*Label 14534*/ GIMT_Encode4(968949), // Rule ID 7998 //
     /*  968859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  968876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968909 */     // MIs[1] Operand 1
     /*  968909 */     // No operand predicates
     /*  968909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968922 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  968925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968947 */     GIR_RootConstrainSelectedInstOperands,
     /*  968948 */     // GIR_Coverage, 7998,
     /*  968948 */     GIR_EraseRootFromParent_Done,
     /*  968949 */   // Label 14534: @968949
     /*  968949 */   GIM_Try, /*On fail goto*//*Label 14535*/ GIMT_Encode4(969044), // Rule ID 7999 //
     /*  968954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  968971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969004 */     // MIs[1] Operand 1
     /*  969004 */     // No operand predicates
     /*  969004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969017 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  969017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  969020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969042 */     GIR_RootConstrainSelectedInstOperands,
     /*  969043 */     // GIR_Coverage, 7999,
     /*  969043 */     GIR_EraseRootFromParent_Done,
     /*  969044 */   // Label 14535: @969044
     /*  969044 */   GIM_Try, /*On fail goto*//*Label 14536*/ GIMT_Encode4(969139), // Rule ID 8002 //
     /*  969049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969099 */     // MIs[1] Operand 1
     /*  969099 */     // No operand predicates
     /*  969099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969112 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  969112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  969115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969137 */     GIR_RootConstrainSelectedInstOperands,
     /*  969138 */     // GIR_Coverage, 8002,
     /*  969138 */     GIR_EraseRootFromParent_Done,
     /*  969139 */   // Label 14536: @969139
     /*  969139 */   GIM_Try, /*On fail goto*//*Label 14537*/ GIMT_Encode4(969234), // Rule ID 8003 //
     /*  969144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969194 */     // MIs[1] Operand 1
     /*  969194 */     // No operand predicates
     /*  969194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969207 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  969207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  969210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969232 */     GIR_RootConstrainSelectedInstOperands,
     /*  969233 */     // GIR_Coverage, 8003,
     /*  969233 */     GIR_EraseRootFromParent_Done,
     /*  969234 */   // Label 14537: @969234
     /*  969234 */   GIM_Try, /*On fail goto*//*Label 14538*/ GIMT_Encode4(969329), // Rule ID 8006 //
     /*  969239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  969242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  969256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969289 */     // MIs[1] Operand 1
     /*  969289 */     // No operand predicates
     /*  969289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969302 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  969302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  969305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  969324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969327 */     GIR_RootConstrainSelectedInstOperands,
     /*  969328 */     // GIR_Coverage, 8006,
     /*  969328 */     GIR_EraseRootFromParent_Done,
     /*  969329 */   // Label 14538: @969329
     /*  969329 */   GIM_Try, /*On fail goto*//*Label 14539*/ GIMT_Encode4(969424), // Rule ID 8007 //
     /*  969334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  969337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  969351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969384 */     // MIs[1] Operand 1
     /*  969384 */     // No operand predicates
     /*  969384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969397 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  969397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  969400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  969419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969422 */     GIR_RootConstrainSelectedInstOperands,
     /*  969423 */     // GIR_Coverage, 8007,
     /*  969423 */     GIR_EraseRootFromParent_Done,
     /*  969424 */   // Label 14539: @969424
     /*  969424 */   GIM_Try, /*On fail goto*//*Label 14540*/ GIMT_Encode4(969519), // Rule ID 8010 //
     /*  969429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  969440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  969443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  969446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  969452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969479 */     // MIs[1] Operand 1
     /*  969479 */     // No operand predicates
     /*  969479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969492 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  969495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969517 */     GIR_RootConstrainSelectedInstOperands,
     /*  969518 */     // GIR_Coverage, 8010,
     /*  969518 */     GIR_EraseRootFromParent_Done,
     /*  969519 */   // Label 14540: @969519
     /*  969519 */   GIM_Try, /*On fail goto*//*Label 14541*/ GIMT_Encode4(969614), // Rule ID 8011 //
     /*  969524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  969535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  969538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  969541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  969547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969574 */     // MIs[1] Operand 1
     /*  969574 */     // No operand predicates
     /*  969574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969587 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  969590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969612 */     GIR_RootConstrainSelectedInstOperands,
     /*  969613 */     // GIR_Coverage, 8011,
     /*  969613 */     GIR_EraseRootFromParent_Done,
     /*  969614 */   // Label 14541: @969614
     /*  969614 */   GIM_Try, /*On fail goto*//*Label 14542*/ GIMT_Encode4(969709), // Rule ID 8014 //
     /*  969619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  969630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  969633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  969636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  969642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969669 */     // MIs[1] Operand 1
     /*  969669 */     // No operand predicates
     /*  969669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969682 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  969685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969707 */     GIR_RootConstrainSelectedInstOperands,
     /*  969708 */     // GIR_Coverage, 8014,
     /*  969708 */     GIR_EraseRootFromParent_Done,
     /*  969709 */   // Label 14542: @969709
     /*  969709 */   GIM_Try, /*On fail goto*//*Label 14543*/ GIMT_Encode4(969804), // Rule ID 8015 //
     /*  969714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  969725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  969728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  969731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  969737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969764 */     // MIs[1] Operand 1
     /*  969764 */     // No operand predicates
     /*  969764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969777 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  969780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969802 */     GIR_RootConstrainSelectedInstOperands,
     /*  969803 */     // GIR_Coverage, 8015,
     /*  969803 */     GIR_EraseRootFromParent_Done,
     /*  969804 */   // Label 14543: @969804
     /*  969804 */   GIM_Try, /*On fail goto*//*Label 14544*/ GIMT_Encode4(969899), // Rule ID 8018 //
     /*  969809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  969820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  969823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  969826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  969832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  969847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969859 */     // MIs[1] Operand 1
     /*  969859 */     // No operand predicates
     /*  969859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969872 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  969875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969897 */     GIR_RootConstrainSelectedInstOperands,
     /*  969898 */     // GIR_Coverage, 8018,
     /*  969898 */     GIR_EraseRootFromParent_Done,
     /*  969899 */   // Label 14544: @969899
     /*  969899 */   GIM_Try, /*On fail goto*//*Label 14545*/ GIMT_Encode4(969994), // Rule ID 8019 //
     /*  969904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  969915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  969918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  969921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  969927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  969942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969954 */     // MIs[1] Operand 1
     /*  969954 */     // No operand predicates
     /*  969954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969967 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  969970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969992 */     GIR_RootConstrainSelectedInstOperands,
     /*  969993 */     // GIR_Coverage, 8019,
     /*  969993 */     GIR_EraseRootFromParent_Done,
     /*  969994 */   // Label 14545: @969994
     /*  969994 */   GIM_Try, /*On fail goto*//*Label 14546*/ GIMT_Encode4(970089), // Rule ID 8022 //
     /*  969999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970049 */     // MIs[1] Operand 1
     /*  970049 */     // No operand predicates
     /*  970049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970062 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  970065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970087 */     GIR_RootConstrainSelectedInstOperands,
     /*  970088 */     // GIR_Coverage, 8022,
     /*  970088 */     GIR_EraseRootFromParent_Done,
     /*  970089 */   // Label 14546: @970089
     /*  970089 */   GIM_Try, /*On fail goto*//*Label 14547*/ GIMT_Encode4(970184), // Rule ID 8023 //
     /*  970094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970144 */     // MIs[1] Operand 1
     /*  970144 */     // No operand predicates
     /*  970144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970157 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  970160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970182 */     GIR_RootConstrainSelectedInstOperands,
     /*  970183 */     // GIR_Coverage, 8023,
     /*  970183 */     GIR_EraseRootFromParent_Done,
     /*  970184 */   // Label 14547: @970184
     /*  970184 */   GIM_Try, /*On fail goto*//*Label 14548*/ GIMT_Encode4(970279), // Rule ID 8026 //
     /*  970189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  970206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970239 */     // MIs[1] Operand 1
     /*  970239 */     // No operand predicates
     /*  970239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970252 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  970255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970277 */     GIR_RootConstrainSelectedInstOperands,
     /*  970278 */     // GIR_Coverage, 8026,
     /*  970278 */     GIR_EraseRootFromParent_Done,
     /*  970279 */   // Label 14548: @970279
     /*  970279 */   GIM_Try, /*On fail goto*//*Label 14549*/ GIMT_Encode4(970374), // Rule ID 8027 //
     /*  970284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  970301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970334 */     // MIs[1] Operand 1
     /*  970334 */     // No operand predicates
     /*  970334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970347 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  970350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970372 */     GIR_RootConstrainSelectedInstOperands,
     /*  970373 */     // GIR_Coverage, 8027,
     /*  970373 */     GIR_EraseRootFromParent_Done,
     /*  970374 */   // Label 14549: @970374
     /*  970374 */   GIM_Try, /*On fail goto*//*Label 14550*/ GIMT_Encode4(970469), // Rule ID 8030 //
     /*  970379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  970396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970429 */     // MIs[1] Operand 1
     /*  970429 */     // No operand predicates
     /*  970429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970442 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  970445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970467 */     GIR_RootConstrainSelectedInstOperands,
     /*  970468 */     // GIR_Coverage, 8030,
     /*  970468 */     GIR_EraseRootFromParent_Done,
     /*  970469 */   // Label 14550: @970469
     /*  970469 */   GIM_Try, /*On fail goto*//*Label 14551*/ GIMT_Encode4(970564), // Rule ID 8031 //
     /*  970474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  970491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970524 */     // MIs[1] Operand 1
     /*  970524 */     // No operand predicates
     /*  970524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970537 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  970540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970562 */     GIR_RootConstrainSelectedInstOperands,
     /*  970563 */     // GIR_Coverage, 8031,
     /*  970563 */     GIR_EraseRootFromParent_Done,
     /*  970564 */   // Label 14551: @970564
     /*  970564 */   GIM_Try, /*On fail goto*//*Label 14552*/ GIMT_Encode4(970659), // Rule ID 8034 //
     /*  970569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  970580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  970583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  970586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  970592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970619 */     // MIs[1] Operand 1
     /*  970619 */     // No operand predicates
     /*  970619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970632 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  970632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  970635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970657 */     GIR_RootConstrainSelectedInstOperands,
     /*  970658 */     // GIR_Coverage, 8034,
     /*  970658 */     GIR_EraseRootFromParent_Done,
     /*  970659 */   // Label 14552: @970659
     /*  970659 */   GIM_Try, /*On fail goto*//*Label 14553*/ GIMT_Encode4(970754), // Rule ID 8035 //
     /*  970664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  970675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  970678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  970681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  970687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970714 */     // MIs[1] Operand 1
     /*  970714 */     // No operand predicates
     /*  970714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970727 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  970727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  970730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970752 */     GIR_RootConstrainSelectedInstOperands,
     /*  970753 */     // GIR_Coverage, 8035,
     /*  970753 */     GIR_EraseRootFromParent_Done,
     /*  970754 */   // Label 14553: @970754
     /*  970754 */   GIM_Try, /*On fail goto*//*Label 14554*/ GIMT_Encode4(970849), // Rule ID 8038 //
     /*  970759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  970776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970809 */     // MIs[1] Operand 1
     /*  970809 */     // No operand predicates
     /*  970809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970822 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  970822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  970825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970847 */     GIR_RootConstrainSelectedInstOperands,
     /*  970848 */     // GIR_Coverage, 8038,
     /*  970848 */     GIR_EraseRootFromParent_Done,
     /*  970849 */   // Label 14554: @970849
     /*  970849 */   GIM_Try, /*On fail goto*//*Label 14555*/ GIMT_Encode4(970944), // Rule ID 8039 //
     /*  970854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  970871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970904 */     // MIs[1] Operand 1
     /*  970904 */     // No operand predicates
     /*  970904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970917 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  970917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  970920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970942 */     GIR_RootConstrainSelectedInstOperands,
     /*  970943 */     // GIR_Coverage, 8039,
     /*  970943 */     GIR_EraseRootFromParent_Done,
     /*  970944 */   // Label 14555: @970944
     /*  970944 */   GIM_Try, /*On fail goto*//*Label 14556*/ GIMT_Encode4(971039), // Rule ID 8042 //
     /*  970949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  970966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970999 */     // MIs[1] Operand 1
     /*  970999 */     // No operand predicates
     /*  970999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971012 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  971012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  971015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971037 */     GIR_RootConstrainSelectedInstOperands,
     /*  971038 */     // GIR_Coverage, 8042,
     /*  971038 */     GIR_EraseRootFromParent_Done,
     /*  971039 */   // Label 14556: @971039
     /*  971039 */   GIM_Try, /*On fail goto*//*Label 14557*/ GIMT_Encode4(971134), // Rule ID 8043 //
     /*  971044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  971061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971094 */     // MIs[1] Operand 1
     /*  971094 */     // No operand predicates
     /*  971094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971107 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  971110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971132 */     GIR_RootConstrainSelectedInstOperands,
     /*  971133 */     // GIR_Coverage, 8043,
     /*  971133 */     GIR_EraseRootFromParent_Done,
     /*  971134 */   // Label 14557: @971134
     /*  971134 */   GIM_Try, /*On fail goto*//*Label 14558*/ GIMT_Encode4(971229), // Rule ID 8046 //
     /*  971139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  971156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971189 */     // MIs[1] Operand 1
     /*  971189 */     // No operand predicates
     /*  971189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971202 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  971205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971227 */     GIR_RootConstrainSelectedInstOperands,
     /*  971228 */     // GIR_Coverage, 8046,
     /*  971228 */     GIR_EraseRootFromParent_Done,
     /*  971229 */   // Label 14558: @971229
     /*  971229 */   GIM_Try, /*On fail goto*//*Label 14559*/ GIMT_Encode4(971324), // Rule ID 8047 //
     /*  971234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  971251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971284 */     // MIs[1] Operand 1
     /*  971284 */     // No operand predicates
     /*  971284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971297 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  971297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  971300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971322 */     GIR_RootConstrainSelectedInstOperands,
     /*  971323 */     // GIR_Coverage, 8047,
     /*  971323 */     GIR_EraseRootFromParent_Done,
     /*  971324 */   // Label 14559: @971324
     /*  971324 */   GIM_Try, /*On fail goto*//*Label 14560*/ GIMT_Encode4(971419), // Rule ID 8050 //
     /*  971329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  971346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971379 */     // MIs[1] Operand 1
     /*  971379 */     // No operand predicates
     /*  971379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971392 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  971395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971417 */     GIR_RootConstrainSelectedInstOperands,
     /*  971418 */     // GIR_Coverage, 8050,
     /*  971418 */     GIR_EraseRootFromParent_Done,
     /*  971419 */   // Label 14560: @971419
     /*  971419 */   GIM_Try, /*On fail goto*//*Label 14561*/ GIMT_Encode4(971514), // Rule ID 8051 //
     /*  971424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  971441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971474 */     // MIs[1] Operand 1
     /*  971474 */     // No operand predicates
     /*  971474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971487 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  971487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  971490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971512 */     GIR_RootConstrainSelectedInstOperands,
     /*  971513 */     // GIR_Coverage, 8051,
     /*  971513 */     GIR_EraseRootFromParent_Done,
     /*  971514 */   // Label 14561: @971514
     /*  971514 */   GIM_Try, /*On fail goto*//*Label 14562*/ GIMT_Encode4(971609), // Rule ID 8054 //
     /*  971519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  971536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971569 */     // MIs[1] Operand 1
     /*  971569 */     // No operand predicates
     /*  971569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971582 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  971585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971607 */     GIR_RootConstrainSelectedInstOperands,
     /*  971608 */     // GIR_Coverage, 8054,
     /*  971608 */     GIR_EraseRootFromParent_Done,
     /*  971609 */   // Label 14562: @971609
     /*  971609 */   GIM_Try, /*On fail goto*//*Label 14563*/ GIMT_Encode4(971704), // Rule ID 8055 //
     /*  971614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  971631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971664 */     // MIs[1] Operand 1
     /*  971664 */     // No operand predicates
     /*  971664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971677 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  971677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  971680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971702 */     GIR_RootConstrainSelectedInstOperands,
     /*  971703 */     // GIR_Coverage, 8055,
     /*  971703 */     GIR_EraseRootFromParent_Done,
     /*  971704 */   // Label 14563: @971704
     /*  971704 */   GIM_Try, /*On fail goto*//*Label 14564*/ GIMT_Encode4(971799), // Rule ID 8234 //
     /*  971709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  971720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  971723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  971726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  971732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971759 */     // MIs[1] Operand 1
     /*  971759 */     // No operand predicates
     /*  971759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971772 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  971772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  971775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971797 */     GIR_RootConstrainSelectedInstOperands,
     /*  971798 */     // GIR_Coverage, 8234,
     /*  971798 */     GIR_EraseRootFromParent_Done,
     /*  971799 */   // Label 14564: @971799
     /*  971799 */   GIM_Try, /*On fail goto*//*Label 14565*/ GIMT_Encode4(971894), // Rule ID 8235 //
     /*  971804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  971815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  971818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  971821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  971827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971854 */     // MIs[1] Operand 1
     /*  971854 */     // No operand predicates
     /*  971854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971867 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  971867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  971870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971892 */     GIR_RootConstrainSelectedInstOperands,
     /*  971893 */     // GIR_Coverage, 8235,
     /*  971893 */     GIR_EraseRootFromParent_Done,
     /*  971894 */   // Label 14565: @971894
     /*  971894 */   GIM_Try, /*On fail goto*//*Label 14566*/ GIMT_Encode4(971989), // Rule ID 8238 //
     /*  971899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  971916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971949 */     // MIs[1] Operand 1
     /*  971949 */     // No operand predicates
     /*  971949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971962 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  971962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  971965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971987 */     GIR_RootConstrainSelectedInstOperands,
     /*  971988 */     // GIR_Coverage, 8238,
     /*  971988 */     GIR_EraseRootFromParent_Done,
     /*  971989 */   // Label 14566: @971989
     /*  971989 */   GIM_Try, /*On fail goto*//*Label 14567*/ GIMT_Encode4(972084), // Rule ID 8239 //
     /*  971994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  972011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972044 */     // MIs[1] Operand 1
     /*  972044 */     // No operand predicates
     /*  972044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972057 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  972060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972082 */     GIR_RootConstrainSelectedInstOperands,
     /*  972083 */     // GIR_Coverage, 8239,
     /*  972083 */     GIR_EraseRootFromParent_Done,
     /*  972084 */   // Label 14567: @972084
     /*  972084 */   GIM_Try, /*On fail goto*//*Label 14568*/ GIMT_Encode4(972179), // Rule ID 8242 //
     /*  972089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  972106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972139 */     // MIs[1] Operand 1
     /*  972139 */     // No operand predicates
     /*  972139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972152 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  972155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972177 */     GIR_RootConstrainSelectedInstOperands,
     /*  972178 */     // GIR_Coverage, 8242,
     /*  972178 */     GIR_EraseRootFromParent_Done,
     /*  972179 */   // Label 14568: @972179
     /*  972179 */   GIM_Try, /*On fail goto*//*Label 14569*/ GIMT_Encode4(972274), // Rule ID 8243 //
     /*  972184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  972201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972234 */     // MIs[1] Operand 1
     /*  972234 */     // No operand predicates
     /*  972234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972247 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  972250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972272 */     GIR_RootConstrainSelectedInstOperands,
     /*  972273 */     // GIR_Coverage, 8243,
     /*  972273 */     GIR_EraseRootFromParent_Done,
     /*  972274 */   // Label 14569: @972274
     /*  972274 */   GIM_Try, /*On fail goto*//*Label 14570*/ GIMT_Encode4(972369), // Rule ID 8246 //
     /*  972279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  972296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972329 */     // MIs[1] Operand 1
     /*  972329 */     // No operand predicates
     /*  972329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972342 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  972342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  972345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972367 */     GIR_RootConstrainSelectedInstOperands,
     /*  972368 */     // GIR_Coverage, 8246,
     /*  972368 */     GIR_EraseRootFromParent_Done,
     /*  972369 */   // Label 14570: @972369
     /*  972369 */   GIM_Try, /*On fail goto*//*Label 14571*/ GIMT_Encode4(972464), // Rule ID 8247 //
     /*  972374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  972391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972424 */     // MIs[1] Operand 1
     /*  972424 */     // No operand predicates
     /*  972424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972437 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  972437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  972440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972462 */     GIR_RootConstrainSelectedInstOperands,
     /*  972463 */     // GIR_Coverage, 8247,
     /*  972463 */     GIR_EraseRootFromParent_Done,
     /*  972464 */   // Label 14571: @972464
     /*  972464 */   GIM_Try, /*On fail goto*//*Label 14572*/ GIMT_Encode4(972559), // Rule ID 8250 //
     /*  972469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  972486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972519 */     // MIs[1] Operand 1
     /*  972519 */     // No operand predicates
     /*  972519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972532 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  972532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  972535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972557 */     GIR_RootConstrainSelectedInstOperands,
     /*  972558 */     // GIR_Coverage, 8250,
     /*  972558 */     GIR_EraseRootFromParent_Done,
     /*  972559 */   // Label 14572: @972559
     /*  972559 */   GIM_Try, /*On fail goto*//*Label 14573*/ GIMT_Encode4(972654), // Rule ID 8251 //
     /*  972564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  972581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972614 */     // MIs[1] Operand 1
     /*  972614 */     // No operand predicates
     /*  972614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972627 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  972627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  972630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972652 */     GIR_RootConstrainSelectedInstOperands,
     /*  972653 */     // GIR_Coverage, 8251,
     /*  972653 */     GIR_EraseRootFromParent_Done,
     /*  972654 */   // Label 14573: @972654
     /*  972654 */   GIM_Try, /*On fail goto*//*Label 14574*/ GIMT_Encode4(972749), // Rule ID 8254 //
     /*  972659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  972676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972709 */     // MIs[1] Operand 1
     /*  972709 */     // No operand predicates
     /*  972709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972722 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  972722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  972725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  972744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972747 */     GIR_RootConstrainSelectedInstOperands,
     /*  972748 */     // GIR_Coverage, 8254,
     /*  972748 */     GIR_EraseRootFromParent_Done,
     /*  972749 */   // Label 14574: @972749
     /*  972749 */   GIM_Try, /*On fail goto*//*Label 14575*/ GIMT_Encode4(972844), // Rule ID 8255 //
     /*  972754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  972771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972804 */     // MIs[1] Operand 1
     /*  972804 */     // No operand predicates
     /*  972804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972817 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  972817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  972820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  972839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972842 */     GIR_RootConstrainSelectedInstOperands,
     /*  972843 */     // GIR_Coverage, 8255,
     /*  972843 */     GIR_EraseRootFromParent_Done,
     /*  972844 */   // Label 14575: @972844
     /*  972844 */   GIM_Try, /*On fail goto*//*Label 14576*/ GIMT_Encode4(972939), // Rule ID 8258 //
     /*  972849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  972860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  972863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  972866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  972872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972899 */     // MIs[1] Operand 1
     /*  972899 */     // No operand predicates
     /*  972899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  972915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972937 */     GIR_RootConstrainSelectedInstOperands,
     /*  972938 */     // GIR_Coverage, 8258,
     /*  972938 */     GIR_EraseRootFromParent_Done,
     /*  972939 */   // Label 14576: @972939
     /*  972939 */   GIM_Try, /*On fail goto*//*Label 14577*/ GIMT_Encode4(973034), // Rule ID 8259 //
     /*  972944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  972955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  972958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  972961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  972967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972994 */     // MIs[1] Operand 1
     /*  972994 */     // No operand predicates
     /*  972994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973007 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973032 */     GIR_RootConstrainSelectedInstOperands,
     /*  973033 */     // GIR_Coverage, 8259,
     /*  973033 */     GIR_EraseRootFromParent_Done,
     /*  973034 */   // Label 14577: @973034
     /*  973034 */   GIM_Try, /*On fail goto*//*Label 14578*/ GIMT_Encode4(973129), // Rule ID 8262 //
     /*  973039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  973050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973089 */     // MIs[1] Operand 1
     /*  973089 */     // No operand predicates
     /*  973089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973102 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  973102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973127 */     GIR_RootConstrainSelectedInstOperands,
     /*  973128 */     // GIR_Coverage, 8262,
     /*  973128 */     GIR_EraseRootFromParent_Done,
     /*  973129 */   // Label 14578: @973129
     /*  973129 */   GIM_Try, /*On fail goto*//*Label 14579*/ GIMT_Encode4(973224), // Rule ID 8263 //
     /*  973134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  973145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973184 */     // MIs[1] Operand 1
     /*  973184 */     // No operand predicates
     /*  973184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973197 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  973197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973222 */     GIR_RootConstrainSelectedInstOperands,
     /*  973223 */     // GIR_Coverage, 8263,
     /*  973223 */     GIR_EraseRootFromParent_Done,
     /*  973224 */   // Label 14579: @973224
     /*  973224 */   GIM_Try, /*On fail goto*//*Label 14580*/ GIMT_Encode4(973319), // Rule ID 8266 //
     /*  973229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  973246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973279 */     // MIs[1] Operand 1
     /*  973279 */     // No operand predicates
     /*  973279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973292 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  973292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973317 */     GIR_RootConstrainSelectedInstOperands,
     /*  973318 */     // GIR_Coverage, 8266,
     /*  973318 */     GIR_EraseRootFromParent_Done,
     /*  973319 */   // Label 14580: @973319
     /*  973319 */   GIM_Try, /*On fail goto*//*Label 14581*/ GIMT_Encode4(973414), // Rule ID 8267 //
     /*  973324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  973341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973374 */     // MIs[1] Operand 1
     /*  973374 */     // No operand predicates
     /*  973374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973387 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  973387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973412 */     GIR_RootConstrainSelectedInstOperands,
     /*  973413 */     // GIR_Coverage, 8267,
     /*  973413 */     GIR_EraseRootFromParent_Done,
     /*  973414 */   // Label 14581: @973414
     /*  973414 */   GIM_Try, /*On fail goto*//*Label 14582*/ GIMT_Encode4(973509), // Rule ID 8270 //
     /*  973419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  973422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  973436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973469 */     // MIs[1] Operand 1
     /*  973469 */     // No operand predicates
     /*  973469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973482 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  973482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  973504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973507 */     GIR_RootConstrainSelectedInstOperands,
     /*  973508 */     // GIR_Coverage, 8270,
     /*  973508 */     GIR_EraseRootFromParent_Done,
     /*  973509 */   // Label 14582: @973509
     /*  973509 */   GIM_Try, /*On fail goto*//*Label 14583*/ GIMT_Encode4(973604), // Rule ID 8271 //
     /*  973514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  973517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  973531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973564 */     // MIs[1] Operand 1
     /*  973564 */     // No operand predicates
     /*  973564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973577 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  973577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  973599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973602 */     GIR_RootConstrainSelectedInstOperands,
     /*  973603 */     // GIR_Coverage, 8271,
     /*  973603 */     GIR_EraseRootFromParent_Done,
     /*  973604 */   // Label 14583: @973604
     /*  973604 */   GIM_Try, /*On fail goto*//*Label 14584*/ GIMT_Encode4(973699), // Rule ID 8274 //
     /*  973609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  973620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  973623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  973626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  973632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  973647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973659 */     // MIs[1] Operand 1
     /*  973659 */     // No operand predicates
     /*  973659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973672 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  973672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  973675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973697 */     GIR_RootConstrainSelectedInstOperands,
     /*  973698 */     // GIR_Coverage, 8274,
     /*  973698 */     GIR_EraseRootFromParent_Done,
     /*  973699 */   // Label 14584: @973699
     /*  973699 */   GIM_Try, /*On fail goto*//*Label 14585*/ GIMT_Encode4(973794), // Rule ID 8275 //
     /*  973704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  973715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  973718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  973721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  973727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  973742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973754 */     // MIs[1] Operand 1
     /*  973754 */     // No operand predicates
     /*  973754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973767 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  973770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973792 */     GIR_RootConstrainSelectedInstOperands,
     /*  973793 */     // GIR_Coverage, 8275,
     /*  973793 */     GIR_EraseRootFromParent_Done,
     /*  973794 */   // Label 14585: @973794
     /*  973794 */   GIM_Try, /*On fail goto*//*Label 14586*/ GIMT_Encode4(973889), // Rule ID 8278 //
     /*  973799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  973810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  973813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  973816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  973822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  973837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973849 */     // MIs[1] Operand 1
     /*  973849 */     // No operand predicates
     /*  973849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973862 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  973862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  973865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973887 */     GIR_RootConstrainSelectedInstOperands,
     /*  973888 */     // GIR_Coverage, 8278,
     /*  973888 */     GIR_EraseRootFromParent_Done,
     /*  973889 */   // Label 14586: @973889
     /*  973889 */   GIM_Try, /*On fail goto*//*Label 14587*/ GIMT_Encode4(973984), // Rule ID 8279 //
     /*  973894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  973905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  973908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  973911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  973917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  973932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973944 */     // MIs[1] Operand 1
     /*  973944 */     // No operand predicates
     /*  973944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973957 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  973960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973982 */     GIR_RootConstrainSelectedInstOperands,
     /*  973983 */     // GIR_Coverage, 8279,
     /*  973983 */     GIR_EraseRootFromParent_Done,
     /*  973984 */   // Label 14587: @973984
     /*  973984 */   GIM_Try, /*On fail goto*//*Label 14588*/ GIMT_Encode4(974079), // Rule ID 8282 //
     /*  973989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  974000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  974003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  974006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  974012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974039 */     // MIs[1] Operand 1
     /*  974039 */     // No operand predicates
     /*  974039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974052 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  974055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974077 */     GIR_RootConstrainSelectedInstOperands,
     /*  974078 */     // GIR_Coverage, 8282,
     /*  974078 */     GIR_EraseRootFromParent_Done,
     /*  974079 */   // Label 14588: @974079
     /*  974079 */   GIM_Try, /*On fail goto*//*Label 14589*/ GIMT_Encode4(974174), // Rule ID 8283 //
     /*  974084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  974095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  974098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  974101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  974107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974134 */     // MIs[1] Operand 1
     /*  974134 */     // No operand predicates
     /*  974134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974147 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  974150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974172 */     GIR_RootConstrainSelectedInstOperands,
     /*  974173 */     // GIR_Coverage, 8283,
     /*  974173 */     GIR_EraseRootFromParent_Done,
     /*  974174 */   // Label 14589: @974174
     /*  974174 */   GIM_Try, /*On fail goto*//*Label 14590*/ GIMT_Encode4(974269), // Rule ID 8286 //
     /*  974179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  974196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974229 */     // MIs[1] Operand 1
     /*  974229 */     // No operand predicates
     /*  974229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974242 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  974245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974267 */     GIR_RootConstrainSelectedInstOperands,
     /*  974268 */     // GIR_Coverage, 8286,
     /*  974268 */     GIR_EraseRootFromParent_Done,
     /*  974269 */   // Label 14590: @974269
     /*  974269 */   GIM_Try, /*On fail goto*//*Label 14591*/ GIMT_Encode4(974364), // Rule ID 8287 //
     /*  974274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  974291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974324 */     // MIs[1] Operand 1
     /*  974324 */     // No operand predicates
     /*  974324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974337 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  974340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974362 */     GIR_RootConstrainSelectedInstOperands,
     /*  974363 */     // GIR_Coverage, 8287,
     /*  974363 */     GIR_EraseRootFromParent_Done,
     /*  974364 */   // Label 14591: @974364
     /*  974364 */   GIM_Try, /*On fail goto*//*Label 14592*/ GIMT_Encode4(974459), // Rule ID 8290 //
     /*  974369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  974386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974419 */     // MIs[1] Operand 1
     /*  974419 */     // No operand predicates
     /*  974419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974432 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  974435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974457 */     GIR_RootConstrainSelectedInstOperands,
     /*  974458 */     // GIR_Coverage, 8290,
     /*  974458 */     GIR_EraseRootFromParent_Done,
     /*  974459 */   // Label 14592: @974459
     /*  974459 */   GIM_Try, /*On fail goto*//*Label 14593*/ GIMT_Encode4(974554), // Rule ID 8291 //
     /*  974464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  974481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974514 */     // MIs[1] Operand 1
     /*  974514 */     // No operand predicates
     /*  974514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974527 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  974530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974552 */     GIR_RootConstrainSelectedInstOperands,
     /*  974553 */     // GIR_Coverage, 8291,
     /*  974553 */     GIR_EraseRootFromParent_Done,
     /*  974554 */   // Label 14593: @974554
     /*  974554 */   GIM_Try, /*On fail goto*//*Label 14594*/ GIMT_Encode4(974649), // Rule ID 8294 //
     /*  974559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  974576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974609 */     // MIs[1] Operand 1
     /*  974609 */     // No operand predicates
     /*  974609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974622 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  974625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974647 */     GIR_RootConstrainSelectedInstOperands,
     /*  974648 */     // GIR_Coverage, 8294,
     /*  974648 */     GIR_EraseRootFromParent_Done,
     /*  974649 */   // Label 14594: @974649
     /*  974649 */   GIM_Try, /*On fail goto*//*Label 14595*/ GIMT_Encode4(974744), // Rule ID 8295 //
     /*  974654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  974671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974704 */     // MIs[1] Operand 1
     /*  974704 */     // No operand predicates
     /*  974704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974717 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  974720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974742 */     GIR_RootConstrainSelectedInstOperands,
     /*  974743 */     // GIR_Coverage, 8295,
     /*  974743 */     GIR_EraseRootFromParent_Done,
     /*  974744 */   // Label 14595: @974744
     /*  974744 */   GIM_Try, /*On fail goto*//*Label 14596*/ GIMT_Encode4(974839), // Rule ID 8298 //
     /*  974749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  974760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  974763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  974766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  974772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974799 */     // MIs[1] Operand 1
     /*  974799 */     // No operand predicates
     /*  974799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974812 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  974812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  974815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  974834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974837 */     GIR_RootConstrainSelectedInstOperands,
     /*  974838 */     // GIR_Coverage, 8298,
     /*  974838 */     GIR_EraseRootFromParent_Done,
     /*  974839 */   // Label 14596: @974839
     /*  974839 */   GIM_Try, /*On fail goto*//*Label 14597*/ GIMT_Encode4(974934), // Rule ID 8299 //
     /*  974844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  974855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  974858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  974861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  974867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974894 */     // MIs[1] Operand 1
     /*  974894 */     // No operand predicates
     /*  974894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974907 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  974907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  974910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  974929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974932 */     GIR_RootConstrainSelectedInstOperands,
     /*  974933 */     // GIR_Coverage, 8299,
     /*  974933 */     GIR_EraseRootFromParent_Done,
     /*  974934 */   // Label 14597: @974934
     /*  974934 */   GIM_Try, /*On fail goto*//*Label 14598*/ GIMT_Encode4(975029), // Rule ID 8302 //
     /*  974939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  974956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974989 */     // MIs[1] Operand 1
     /*  974989 */     // No operand predicates
     /*  974989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975002 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  975005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975027 */     GIR_RootConstrainSelectedInstOperands,
     /*  975028 */     // GIR_Coverage, 8302,
     /*  975028 */     GIR_EraseRootFromParent_Done,
     /*  975029 */   // Label 14598: @975029
     /*  975029 */   GIM_Try, /*On fail goto*//*Label 14599*/ GIMT_Encode4(975124), // Rule ID 8303 //
     /*  975034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  975051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975084 */     // MIs[1] Operand 1
     /*  975084 */     // No operand predicates
     /*  975084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975097 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  975100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975122 */     GIR_RootConstrainSelectedInstOperands,
     /*  975123 */     // GIR_Coverage, 8303,
     /*  975123 */     GIR_EraseRootFromParent_Done,
     /*  975124 */   // Label 14599: @975124
     /*  975124 */   GIM_Try, /*On fail goto*//*Label 14600*/ GIMT_Encode4(975219), // Rule ID 8306 //
     /*  975129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  975146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975179 */     // MIs[1] Operand 1
     /*  975179 */     // No operand predicates
     /*  975179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975192 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  975195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975217 */     GIR_RootConstrainSelectedInstOperands,
     /*  975218 */     // GIR_Coverage, 8306,
     /*  975218 */     GIR_EraseRootFromParent_Done,
     /*  975219 */   // Label 14600: @975219
     /*  975219 */   GIM_Try, /*On fail goto*//*Label 14601*/ GIMT_Encode4(975314), // Rule ID 8307 //
     /*  975224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  975241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975274 */     // MIs[1] Operand 1
     /*  975274 */     // No operand predicates
     /*  975274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975287 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  975290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975312 */     GIR_RootConstrainSelectedInstOperands,
     /*  975313 */     // GIR_Coverage, 8307,
     /*  975313 */     GIR_EraseRootFromParent_Done,
     /*  975314 */   // Label 14601: @975314
     /*  975314 */   GIM_Try, /*On fail goto*//*Label 14602*/ GIMT_Encode4(975409), // Rule ID 8310 //
     /*  975319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  975322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  975330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  975333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  975336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  975342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975369 */     // MIs[1] Operand 1
     /*  975369 */     // No operand predicates
     /*  975369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975382 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  975382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  975385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975407 */     GIR_RootConstrainSelectedInstOperands,
     /*  975408 */     // GIR_Coverage, 8310,
     /*  975408 */     GIR_EraseRootFromParent_Done,
     /*  975409 */   // Label 14602: @975409
     /*  975409 */   GIM_Try, /*On fail goto*//*Label 14603*/ GIMT_Encode4(975504), // Rule ID 8311 //
     /*  975414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  975417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  975425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  975428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  975431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  975437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975464 */     // MIs[1] Operand 1
     /*  975464 */     // No operand predicates
     /*  975464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975477 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  975477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  975480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975502 */     GIR_RootConstrainSelectedInstOperands,
     /*  975503 */     // GIR_Coverage, 8311,
     /*  975503 */     GIR_EraseRootFromParent_Done,
     /*  975504 */   // Label 14603: @975504
     /*  975504 */   GIM_Try, /*On fail goto*//*Label 14604*/ GIMT_Encode4(975599), // Rule ID 8314 //
     /*  975509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  975512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  975526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975559 */     // MIs[1] Operand 1
     /*  975559 */     // No operand predicates
     /*  975559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  975572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  975575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975597 */     GIR_RootConstrainSelectedInstOperands,
     /*  975598 */     // GIR_Coverage, 8314,
     /*  975598 */     GIR_EraseRootFromParent_Done,
     /*  975599 */   // Label 14604: @975599
     /*  975599 */   GIM_Try, /*On fail goto*//*Label 14605*/ GIMT_Encode4(975694), // Rule ID 8315 //
     /*  975604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  975607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  975621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975654 */     // MIs[1] Operand 1
     /*  975654 */     // No operand predicates
     /*  975654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975667 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  975667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  975670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975692 */     GIR_RootConstrainSelectedInstOperands,
     /*  975693 */     // GIR_Coverage, 8315,
     /*  975693 */     GIR_EraseRootFromParent_Done,
     /*  975694 */   // Label 14605: @975694
     /*  975694 */   GIM_Try, /*On fail goto*//*Label 14606*/ GIMT_Encode4(975789), // Rule ID 8318 //
     /*  975699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  975702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  975716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975749 */     // MIs[1] Operand 1
     /*  975749 */     // No operand predicates
     /*  975749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975762 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  975762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  975765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975787 */     GIR_RootConstrainSelectedInstOperands,
     /*  975788 */     // GIR_Coverage, 8318,
     /*  975788 */     GIR_EraseRootFromParent_Done,
     /*  975789 */   // Label 14606: @975789
     /*  975789 */   GIM_Try, /*On fail goto*//*Label 14607*/ GIMT_Encode4(975884), // Rule ID 8319 //
     /*  975794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  975797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  975811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975844 */     // MIs[1] Operand 1
     /*  975844 */     // No operand predicates
     /*  975844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975857 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  975857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  975860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975882 */     GIR_RootConstrainSelectedInstOperands,
     /*  975883 */     // GIR_Coverage, 8319,
     /*  975883 */     GIR_EraseRootFromParent_Done,
     /*  975884 */   // Label 14607: @975884
     /*  975884 */   GIM_Try, /*On fail goto*//*Label 14608*/ GIMT_Encode4(975979), // Rule ID 8850 //
     /*  975889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  975900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  975903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  975906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  975912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975939 */     // MIs[1] Operand 1
     /*  975939 */     // No operand predicates
     /*  975939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975952 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  975952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  975955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  975974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975977 */     GIR_RootConstrainSelectedInstOperands,
     /*  975978 */     // GIR_Coverage, 8850,
     /*  975978 */     GIR_EraseRootFromParent_Done,
     /*  975979 */   // Label 14608: @975979
     /*  975979 */   GIM_Try, /*On fail goto*//*Label 14609*/ GIMT_Encode4(976074), // Rule ID 8851 //
     /*  975984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  975995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  975998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  976001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976034 */     // MIs[1] Operand 1
     /*  976034 */     // No operand predicates
     /*  976034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976047 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  976050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976072 */     GIR_RootConstrainSelectedInstOperands,
     /*  976073 */     // GIR_Coverage, 8851,
     /*  976073 */     GIR_EraseRootFromParent_Done,
     /*  976074 */   // Label 14609: @976074
     /*  976074 */   GIM_Try, /*On fail goto*//*Label 14610*/ GIMT_Encode4(976169), // Rule ID 8854 //
     /*  976079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  976096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976129 */     // MIs[1] Operand 1
     /*  976129 */     // No operand predicates
     /*  976129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976142 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  976145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976167 */     GIR_RootConstrainSelectedInstOperands,
     /*  976168 */     // GIR_Coverage, 8854,
     /*  976168 */     GIR_EraseRootFromParent_Done,
     /*  976169 */   // Label 14610: @976169
     /*  976169 */   GIM_Try, /*On fail goto*//*Label 14611*/ GIMT_Encode4(976264), // Rule ID 8855 //
     /*  976174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  976191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976224 */     // MIs[1] Operand 1
     /*  976224 */     // No operand predicates
     /*  976224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976237 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  976240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976262 */     GIR_RootConstrainSelectedInstOperands,
     /*  976263 */     // GIR_Coverage, 8855,
     /*  976263 */     GIR_EraseRootFromParent_Done,
     /*  976264 */   // Label 14611: @976264
     /*  976264 */   GIM_Try, /*On fail goto*//*Label 14612*/ GIMT_Encode4(976359), // Rule ID 8858 //
     /*  976269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  976286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976319 */     // MIs[1] Operand 1
     /*  976319 */     // No operand predicates
     /*  976319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976332 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  976335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976357 */     GIR_RootConstrainSelectedInstOperands,
     /*  976358 */     // GIR_Coverage, 8858,
     /*  976358 */     GIR_EraseRootFromParent_Done,
     /*  976359 */   // Label 14612: @976359
     /*  976359 */   GIM_Try, /*On fail goto*//*Label 14613*/ GIMT_Encode4(976454), // Rule ID 8859 //
     /*  976364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  976381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976414 */     // MIs[1] Operand 1
     /*  976414 */     // No operand predicates
     /*  976414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976427 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  976430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976452 */     GIR_RootConstrainSelectedInstOperands,
     /*  976453 */     // GIR_Coverage, 8859,
     /*  976453 */     GIR_EraseRootFromParent_Done,
     /*  976454 */   // Label 14613: @976454
     /*  976454 */   GIM_Try, /*On fail goto*//*Label 14614*/ GIMT_Encode4(976549), // Rule ID 8862 //
     /*  976459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  976476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976509 */     // MIs[1] Operand 1
     /*  976509 */     // No operand predicates
     /*  976509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976522 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  976522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  976525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976547 */     GIR_RootConstrainSelectedInstOperands,
     /*  976548 */     // GIR_Coverage, 8862,
     /*  976548 */     GIR_EraseRootFromParent_Done,
     /*  976549 */   // Label 14614: @976549
     /*  976549 */   GIM_Try, /*On fail goto*//*Label 14615*/ GIMT_Encode4(976644), // Rule ID 8863 //
     /*  976554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  976571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976604 */     // MIs[1] Operand 1
     /*  976604 */     // No operand predicates
     /*  976604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976617 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  976617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  976620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976642 */     GIR_RootConstrainSelectedInstOperands,
     /*  976643 */     // GIR_Coverage, 8863,
     /*  976643 */     GIR_EraseRootFromParent_Done,
     /*  976644 */   // Label 14615: @976644
     /*  976644 */   GIM_Try, /*On fail goto*//*Label 14616*/ GIMT_Encode4(976739), // Rule ID 8866 //
     /*  976649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  976666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976699 */     // MIs[1] Operand 1
     /*  976699 */     // No operand predicates
     /*  976699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976712 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  976712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  976715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976737 */     GIR_RootConstrainSelectedInstOperands,
     /*  976738 */     // GIR_Coverage, 8866,
     /*  976738 */     GIR_EraseRootFromParent_Done,
     /*  976739 */   // Label 14616: @976739
     /*  976739 */   GIM_Try, /*On fail goto*//*Label 14617*/ GIMT_Encode4(976834), // Rule ID 8867 //
     /*  976744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  976761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976794 */     // MIs[1] Operand 1
     /*  976794 */     // No operand predicates
     /*  976794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976807 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  976807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  976810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976832 */     GIR_RootConstrainSelectedInstOperands,
     /*  976833 */     // GIR_Coverage, 8867,
     /*  976833 */     GIR_EraseRootFromParent_Done,
     /*  976834 */   // Label 14617: @976834
     /*  976834 */   GIM_Try, /*On fail goto*//*Label 14618*/ GIMT_Encode4(976929), // Rule ID 8870 //
     /*  976839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  976856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976889 */     // MIs[1] Operand 1
     /*  976889 */     // No operand predicates
     /*  976889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976902 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  976902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  976905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  976924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976927 */     GIR_RootConstrainSelectedInstOperands,
     /*  976928 */     // GIR_Coverage, 8870,
     /*  976928 */     GIR_EraseRootFromParent_Done,
     /*  976929 */   // Label 14618: @976929
     /*  976929 */   GIM_Try, /*On fail goto*//*Label 14619*/ GIMT_Encode4(977024), // Rule ID 8871 //
     /*  976934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  976951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976984 */     // MIs[1] Operand 1
     /*  976984 */     // No operand predicates
     /*  976984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976997 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  976997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  977000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977022 */     GIR_RootConstrainSelectedInstOperands,
     /*  977023 */     // GIR_Coverage, 8871,
     /*  977023 */     GIR_EraseRootFromParent_Done,
     /*  977024 */   // Label 14619: @977024
     /*  977024 */   GIM_Try, /*On fail goto*//*Label 14620*/ GIMT_Encode4(977119), // Rule ID 8874 //
     /*  977029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  977040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  977043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  977046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  977052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977079 */     // MIs[1] Operand 1
     /*  977079 */     // No operand predicates
     /*  977079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977092 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  977092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977117 */     GIR_RootConstrainSelectedInstOperands,
     /*  977118 */     // GIR_Coverage, 8874,
     /*  977118 */     GIR_EraseRootFromParent_Done,
     /*  977119 */   // Label 14620: @977119
     /*  977119 */   GIM_Try, /*On fail goto*//*Label 14621*/ GIMT_Encode4(977214), // Rule ID 8875 //
     /*  977124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  977135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  977138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  977141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  977147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977174 */     // MIs[1] Operand 1
     /*  977174 */     // No operand predicates
     /*  977174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977187 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977212 */     GIR_RootConstrainSelectedInstOperands,
     /*  977213 */     // GIR_Coverage, 8875,
     /*  977213 */     GIR_EraseRootFromParent_Done,
     /*  977214 */   // Label 14621: @977214
     /*  977214 */   GIM_Try, /*On fail goto*//*Label 14622*/ GIMT_Encode4(977309), // Rule ID 8878 //
     /*  977219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  977236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977269 */     // MIs[1] Operand 1
     /*  977269 */     // No operand predicates
     /*  977269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977282 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  977282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977307 */     GIR_RootConstrainSelectedInstOperands,
     /*  977308 */     // GIR_Coverage, 8878,
     /*  977308 */     GIR_EraseRootFromParent_Done,
     /*  977309 */   // Label 14622: @977309
     /*  977309 */   GIM_Try, /*On fail goto*//*Label 14623*/ GIMT_Encode4(977404), // Rule ID 8879 //
     /*  977314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  977331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977364 */     // MIs[1] Operand 1
     /*  977364 */     // No operand predicates
     /*  977364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977377 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  977377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977402 */     GIR_RootConstrainSelectedInstOperands,
     /*  977403 */     // GIR_Coverage, 8879,
     /*  977403 */     GIR_EraseRootFromParent_Done,
     /*  977404 */   // Label 14623: @977404
     /*  977404 */   GIM_Try, /*On fail goto*//*Label 14624*/ GIMT_Encode4(977499), // Rule ID 8882 //
     /*  977409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  977426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977459 */     // MIs[1] Operand 1
     /*  977459 */     // No operand predicates
     /*  977459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977472 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  977472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977497 */     GIR_RootConstrainSelectedInstOperands,
     /*  977498 */     // GIR_Coverage, 8882,
     /*  977498 */     GIR_EraseRootFromParent_Done,
     /*  977499 */   // Label 14624: @977499
     /*  977499 */   GIM_Try, /*On fail goto*//*Label 14625*/ GIMT_Encode4(977594), // Rule ID 8883 //
     /*  977504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  977521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977554 */     // MIs[1] Operand 1
     /*  977554 */     // No operand predicates
     /*  977554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977567 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  977567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977592 */     GIR_RootConstrainSelectedInstOperands,
     /*  977593 */     // GIR_Coverage, 8883,
     /*  977593 */     GIR_EraseRootFromParent_Done,
     /*  977594 */   // Label 14625: @977594
     /*  977594 */   GIM_Try, /*On fail goto*//*Label 14626*/ GIMT_Encode4(977689), // Rule ID 8886 //
     /*  977599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  977602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  977616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977649 */     // MIs[1] Operand 1
     /*  977649 */     // No operand predicates
     /*  977649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977662 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  977662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  977684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977687 */     GIR_RootConstrainSelectedInstOperands,
     /*  977688 */     // GIR_Coverage, 8886,
     /*  977688 */     GIR_EraseRootFromParent_Done,
     /*  977689 */   // Label 14626: @977689
     /*  977689 */   GIM_Try, /*On fail goto*//*Label 14627*/ GIMT_Encode4(977784), // Rule ID 8887 //
     /*  977694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  977697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  977711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977744 */     // MIs[1] Operand 1
     /*  977744 */     // No operand predicates
     /*  977744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977757 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  977757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  977779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977782 */     GIR_RootConstrainSelectedInstOperands,
     /*  977783 */     // GIR_Coverage, 8887,
     /*  977783 */     GIR_EraseRootFromParent_Done,
     /*  977784 */   // Label 14627: @977784
     /*  977784 */   GIM_Try, /*On fail goto*//*Label 14628*/ GIMT_Encode4(977879), // Rule ID 8890 //
     /*  977789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  977800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  977803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  977806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  977812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  977827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977839 */     // MIs[1] Operand 1
     /*  977839 */     // No operand predicates
     /*  977839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977852 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  977852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  977855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977877 */     GIR_RootConstrainSelectedInstOperands,
     /*  977878 */     // GIR_Coverage, 8890,
     /*  977878 */     GIR_EraseRootFromParent_Done,
     /*  977879 */   // Label 14628: @977879
     /*  977879 */   GIM_Try, /*On fail goto*//*Label 14629*/ GIMT_Encode4(977974), // Rule ID 8891 //
     /*  977884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  977895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  977898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  977901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  977907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  977922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977934 */     // MIs[1] Operand 1
     /*  977934 */     // No operand predicates
     /*  977934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977947 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  977950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977972 */     GIR_RootConstrainSelectedInstOperands,
     /*  977973 */     // GIR_Coverage, 8891,
     /*  977973 */     GIR_EraseRootFromParent_Done,
     /*  977974 */   // Label 14629: @977974
     /*  977974 */   GIM_Try, /*On fail goto*//*Label 14630*/ GIMT_Encode4(978069), // Rule ID 8894 //
     /*  977979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  977990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  977993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  977996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978029 */     // MIs[1] Operand 1
     /*  978029 */     // No operand predicates
     /*  978029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978042 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  978045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978067 */     GIR_RootConstrainSelectedInstOperands,
     /*  978068 */     // GIR_Coverage, 8894,
     /*  978068 */     GIR_EraseRootFromParent_Done,
     /*  978069 */   // Label 14630: @978069
     /*  978069 */   GIM_Try, /*On fail goto*//*Label 14631*/ GIMT_Encode4(978164), // Rule ID 8895 //
     /*  978074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  978091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978124 */     // MIs[1] Operand 1
     /*  978124 */     // No operand predicates
     /*  978124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978137 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  978140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978162 */     GIR_RootConstrainSelectedInstOperands,
     /*  978163 */     // GIR_Coverage, 8895,
     /*  978163 */     GIR_EraseRootFromParent_Done,
     /*  978164 */   // Label 14631: @978164
     /*  978164 */   GIM_Try, /*On fail goto*//*Label 14632*/ GIMT_Encode4(978259), // Rule ID 8898 //
     /*  978169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  978180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  978183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  978186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  978192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978219 */     // MIs[1] Operand 1
     /*  978219 */     // No operand predicates
     /*  978219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978232 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  978235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978257 */     GIR_RootConstrainSelectedInstOperands,
     /*  978258 */     // GIR_Coverage, 8898,
     /*  978258 */     GIR_EraseRootFromParent_Done,
     /*  978259 */   // Label 14632: @978259
     /*  978259 */   GIM_Try, /*On fail goto*//*Label 14633*/ GIMT_Encode4(978354), // Rule ID 8899 //
     /*  978264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  978275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  978278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  978281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  978287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978314 */     // MIs[1] Operand 1
     /*  978314 */     // No operand predicates
     /*  978314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978327 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  978330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978352 */     GIR_RootConstrainSelectedInstOperands,
     /*  978353 */     // GIR_Coverage, 8899,
     /*  978353 */     GIR_EraseRootFromParent_Done,
     /*  978354 */   // Label 14633: @978354
     /*  978354 */   GIM_Try, /*On fail goto*//*Label 14634*/ GIMT_Encode4(978449), // Rule ID 8902 //
     /*  978359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  978370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  978373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  978376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  978382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978409 */     // MIs[1] Operand 1
     /*  978409 */     // No operand predicates
     /*  978409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978422 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  978425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978447 */     GIR_RootConstrainSelectedInstOperands,
     /*  978448 */     // GIR_Coverage, 8902,
     /*  978448 */     GIR_EraseRootFromParent_Done,
     /*  978449 */   // Label 14634: @978449
     /*  978449 */   GIM_Try, /*On fail goto*//*Label 14635*/ GIMT_Encode4(978544), // Rule ID 8903 //
     /*  978454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  978465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  978468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  978471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  978477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978504 */     // MIs[1] Operand 1
     /*  978504 */     // No operand predicates
     /*  978504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978517 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  978517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  978520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978542 */     GIR_RootConstrainSelectedInstOperands,
     /*  978543 */     // GIR_Coverage, 8903,
     /*  978543 */     GIR_EraseRootFromParent_Done,
     /*  978544 */   // Label 14635: @978544
     /*  978544 */   GIM_Try, /*On fail goto*//*Label 14636*/ GIMT_Encode4(978639), // Rule ID 8906 //
     /*  978549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  978566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978599 */     // MIs[1] Operand 1
     /*  978599 */     // No operand predicates
     /*  978599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978612 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  978615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978637 */     GIR_RootConstrainSelectedInstOperands,
     /*  978638 */     // GIR_Coverage, 8906,
     /*  978638 */     GIR_EraseRootFromParent_Done,
     /*  978639 */   // Label 14636: @978639
     /*  978639 */   GIM_Try, /*On fail goto*//*Label 14637*/ GIMT_Encode4(978734), // Rule ID 8907 //
     /*  978644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  978661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978694 */     // MIs[1] Operand 1
     /*  978694 */     // No operand predicates
     /*  978694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978707 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  978707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  978710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978732 */     GIR_RootConstrainSelectedInstOperands,
     /*  978733 */     // GIR_Coverage, 8907,
     /*  978733 */     GIR_EraseRootFromParent_Done,
     /*  978734 */   // Label 14637: @978734
     /*  978734 */   GIM_Try, /*On fail goto*//*Label 14638*/ GIMT_Encode4(978829), // Rule ID 8910 //
     /*  978739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  978756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978789 */     // MIs[1] Operand 1
     /*  978789 */     // No operand predicates
     /*  978789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978802 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  978805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978827 */     GIR_RootConstrainSelectedInstOperands,
     /*  978828 */     // GIR_Coverage, 8910,
     /*  978828 */     GIR_EraseRootFromParent_Done,
     /*  978829 */   // Label 14638: @978829
     /*  978829 */   GIM_Try, /*On fail goto*//*Label 14639*/ GIMT_Encode4(978924), // Rule ID 8911 //
     /*  978834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  978851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978884 */     // MIs[1] Operand 1
     /*  978884 */     // No operand predicates
     /*  978884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978897 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  978897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  978900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978922 */     GIR_RootConstrainSelectedInstOperands,
     /*  978923 */     // GIR_Coverage, 8911,
     /*  978923 */     GIR_EraseRootFromParent_Done,
     /*  978924 */   // Label 14639: @978924
     /*  978924 */   GIM_Try, /*On fail goto*//*Label 14640*/ GIMT_Encode4(979019), // Rule ID 8914 //
     /*  978929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  978940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  978943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  978946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  978952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978979 */     // MIs[1] Operand 1
     /*  978979 */     // No operand predicates
     /*  978979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978992 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  978992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  978995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979017 */     GIR_RootConstrainSelectedInstOperands,
     /*  979018 */     // GIR_Coverage, 8914,
     /*  979018 */     GIR_EraseRootFromParent_Done,
     /*  979019 */   // Label 14640: @979019
     /*  979019 */   GIM_Try, /*On fail goto*//*Label 14641*/ GIMT_Encode4(979114), // Rule ID 8915 //
     /*  979024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  979041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979074 */     // MIs[1] Operand 1
     /*  979074 */     // No operand predicates
     /*  979074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979087 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  979090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979112 */     GIR_RootConstrainSelectedInstOperands,
     /*  979113 */     // GIR_Coverage, 8915,
     /*  979113 */     GIR_EraseRootFromParent_Done,
     /*  979114 */   // Label 14641: @979114
     /*  979114 */   GIM_Try, /*On fail goto*//*Label 14642*/ GIMT_Encode4(979209), // Rule ID 8918 //
     /*  979119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  979136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979169 */     // MIs[1] Operand 1
     /*  979169 */     // No operand predicates
     /*  979169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979182 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  979185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979207 */     GIR_RootConstrainSelectedInstOperands,
     /*  979208 */     // GIR_Coverage, 8918,
     /*  979208 */     GIR_EraseRootFromParent_Done,
     /*  979209 */   // Label 14642: @979209
     /*  979209 */   GIM_Try, /*On fail goto*//*Label 14643*/ GIMT_Encode4(979304), // Rule ID 8919 //
     /*  979214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  979231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979264 */     // MIs[1] Operand 1
     /*  979264 */     // No operand predicates
     /*  979264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979277 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  979280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979302 */     GIR_RootConstrainSelectedInstOperands,
     /*  979303 */     // GIR_Coverage, 8919,
     /*  979303 */     GIR_EraseRootFromParent_Done,
     /*  979304 */   // Label 14643: @979304
     /*  979304 */   GIM_Try, /*On fail goto*//*Label 14644*/ GIMT_Encode4(979399), // Rule ID 8922 //
     /*  979309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  979326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979359 */     // MIs[1] Operand 1
     /*  979359 */     // No operand predicates
     /*  979359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979372 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  979375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979397 */     GIR_RootConstrainSelectedInstOperands,
     /*  979398 */     // GIR_Coverage, 8922,
     /*  979398 */     GIR_EraseRootFromParent_Done,
     /*  979399 */   // Label 14644: @979399
     /*  979399 */   GIM_Try, /*On fail goto*//*Label 14645*/ GIMT_Encode4(979494), // Rule ID 8923 //
     /*  979404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  979421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979454 */     // MIs[1] Operand 1
     /*  979454 */     // No operand predicates
     /*  979454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979467 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  979470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979492 */     GIR_RootConstrainSelectedInstOperands,
     /*  979493 */     // GIR_Coverage, 8923,
     /*  979493 */     GIR_EraseRootFromParent_Done,
     /*  979494 */   // Label 14645: @979494
     /*  979494 */   GIM_Try, /*On fail goto*//*Label 14646*/ GIMT_Encode4(979589), // Rule ID 8926 //
     /*  979499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  979502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  979510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  979513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  979516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  979522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979549 */     // MIs[1] Operand 1
     /*  979549 */     // No operand predicates
     /*  979549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979562 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  979562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  979565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979587 */     GIR_RootConstrainSelectedInstOperands,
     /*  979588 */     // GIR_Coverage, 8926,
     /*  979588 */     GIR_EraseRootFromParent_Done,
     /*  979589 */   // Label 14646: @979589
     /*  979589 */   GIM_Try, /*On fail goto*//*Label 14647*/ GIMT_Encode4(979684), // Rule ID 8927 //
     /*  979594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  979597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  979605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  979608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  979611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  979617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979644 */     // MIs[1] Operand 1
     /*  979644 */     // No operand predicates
     /*  979644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979657 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  979657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  979660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979682 */     GIR_RootConstrainSelectedInstOperands,
     /*  979683 */     // GIR_Coverage, 8927,
     /*  979683 */     GIR_EraseRootFromParent_Done,
     /*  979684 */   // Label 14647: @979684
     /*  979684 */   GIM_Try, /*On fail goto*//*Label 14648*/ GIMT_Encode4(979779), // Rule ID 8930 //
     /*  979689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  979692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  979706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979739 */     // MIs[1] Operand 1
     /*  979739 */     // No operand predicates
     /*  979739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979752 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  979752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  979755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979777 */     GIR_RootConstrainSelectedInstOperands,
     /*  979778 */     // GIR_Coverage, 8930,
     /*  979778 */     GIR_EraseRootFromParent_Done,
     /*  979779 */   // Label 14648: @979779
     /*  979779 */   GIM_Try, /*On fail goto*//*Label 14649*/ GIMT_Encode4(979874), // Rule ID 8931 //
     /*  979784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  979787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  979801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979834 */     // MIs[1] Operand 1
     /*  979834 */     // No operand predicates
     /*  979834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979847 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  979847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  979850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979872 */     GIR_RootConstrainSelectedInstOperands,
     /*  979873 */     // GIR_Coverage, 8931,
     /*  979873 */     GIR_EraseRootFromParent_Done,
     /*  979874 */   // Label 14649: @979874
     /*  979874 */   GIM_Try, /*On fail goto*//*Label 14650*/ GIMT_Encode4(979969), // Rule ID 8934 //
     /*  979879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  979882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  979896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979929 */     // MIs[1] Operand 1
     /*  979929 */     // No operand predicates
     /*  979929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979942 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  979942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  979945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979967 */     GIR_RootConstrainSelectedInstOperands,
     /*  979968 */     // GIR_Coverage, 8934,
     /*  979968 */     GIR_EraseRootFromParent_Done,
     /*  979969 */   // Label 14650: @979969
     /*  979969 */   GIM_Try, /*On fail goto*//*Label 14651*/ GIMT_Encode4(980064), // Rule ID 8935 //
     /*  979974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  979977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  979991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980024 */     // MIs[1] Operand 1
     /*  980024 */     // No operand predicates
     /*  980024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980037 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  980037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  980040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980062 */     GIR_RootConstrainSelectedInstOperands,
     /*  980063 */     // GIR_Coverage, 8935,
     /*  980063 */     GIR_EraseRootFromParent_Done,
     /*  980064 */   // Label 14651: @980064
     /*  980064 */   GIM_Try, /*On fail goto*//*Label 14652*/ GIMT_Encode4(980159), // Rule ID 9114 //
     /*  980069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980119 */     // MIs[1] Operand 1
     /*  980119 */     // No operand predicates
     /*  980119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980132 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  980135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980157 */     GIR_RootConstrainSelectedInstOperands,
     /*  980158 */     // GIR_Coverage, 9114,
     /*  980158 */     GIR_EraseRootFromParent_Done,
     /*  980159 */   // Label 14652: @980159
     /*  980159 */   GIM_Try, /*On fail goto*//*Label 14653*/ GIMT_Encode4(980254), // Rule ID 9115 //
     /*  980164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980214 */     // MIs[1] Operand 1
     /*  980214 */     // No operand predicates
     /*  980214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980227 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  980230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980252 */     GIR_RootConstrainSelectedInstOperands,
     /*  980253 */     // GIR_Coverage, 9115,
     /*  980253 */     GIR_EraseRootFromParent_Done,
     /*  980254 */   // Label 14653: @980254
     /*  980254 */   GIM_Try, /*On fail goto*//*Label 14654*/ GIMT_Encode4(980349), // Rule ID 9118 //
     /*  980259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  980276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980309 */     // MIs[1] Operand 1
     /*  980309 */     // No operand predicates
     /*  980309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980322 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  980325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980347 */     GIR_RootConstrainSelectedInstOperands,
     /*  980348 */     // GIR_Coverage, 9118,
     /*  980348 */     GIR_EraseRootFromParent_Done,
     /*  980349 */   // Label 14654: @980349
     /*  980349 */   GIM_Try, /*On fail goto*//*Label 14655*/ GIMT_Encode4(980444), // Rule ID 9119 //
     /*  980354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  980371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980404 */     // MIs[1] Operand 1
     /*  980404 */     // No operand predicates
     /*  980404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980417 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  980420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980442 */     GIR_RootConstrainSelectedInstOperands,
     /*  980443 */     // GIR_Coverage, 9119,
     /*  980443 */     GIR_EraseRootFromParent_Done,
     /*  980444 */   // Label 14655: @980444
     /*  980444 */   GIM_Try, /*On fail goto*//*Label 14656*/ GIMT_Encode4(980539), // Rule ID 9122 //
     /*  980449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  980466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980499 */     // MIs[1] Operand 1
     /*  980499 */     // No operand predicates
     /*  980499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  980515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980537 */     GIR_RootConstrainSelectedInstOperands,
     /*  980538 */     // GIR_Coverage, 9122,
     /*  980538 */     GIR_EraseRootFromParent_Done,
     /*  980539 */   // Label 14656: @980539
     /*  980539 */   GIM_Try, /*On fail goto*//*Label 14657*/ GIMT_Encode4(980634), // Rule ID 9123 //
     /*  980544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  980561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980594 */     // MIs[1] Operand 1
     /*  980594 */     // No operand predicates
     /*  980594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980607 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  980610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980632 */     GIR_RootConstrainSelectedInstOperands,
     /*  980633 */     // GIR_Coverage, 9123,
     /*  980633 */     GIR_EraseRootFromParent_Done,
     /*  980634 */   // Label 14657: @980634
     /*  980634 */   GIM_Try, /*On fail goto*//*Label 14658*/ GIMT_Encode4(980729), // Rule ID 9126 //
     /*  980639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  980656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980689 */     // MIs[1] Operand 1
     /*  980689 */     // No operand predicates
     /*  980689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980702 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  980702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  980705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  980724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980727 */     GIR_RootConstrainSelectedInstOperands,
     /*  980728 */     // GIR_Coverage, 9126,
     /*  980728 */     GIR_EraseRootFromParent_Done,
     /*  980729 */   // Label 14658: @980729
     /*  980729 */   GIM_Try, /*On fail goto*//*Label 14659*/ GIMT_Encode4(980824), // Rule ID 9127 //
     /*  980734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  980751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980784 */     // MIs[1] Operand 1
     /*  980784 */     // No operand predicates
     /*  980784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980797 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  980797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  980800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  980819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980822 */     GIR_RootConstrainSelectedInstOperands,
     /*  980823 */     // GIR_Coverage, 9127,
     /*  980823 */     GIR_EraseRootFromParent_Done,
     /*  980824 */   // Label 14659: @980824
     /*  980824 */   GIM_Try, /*On fail goto*//*Label 14660*/ GIMT_Encode4(980919), // Rule ID 9130 //
     /*  980829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  980846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980879 */     // MIs[1] Operand 1
     /*  980879 */     // No operand predicates
     /*  980879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980892 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  980892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  980895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  980914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980917 */     GIR_RootConstrainSelectedInstOperands,
     /*  980918 */     // GIR_Coverage, 9130,
     /*  980918 */     GIR_EraseRootFromParent_Done,
     /*  980919 */   // Label 14660: @980919
     /*  980919 */   GIM_Try, /*On fail goto*//*Label 14661*/ GIMT_Encode4(981014), // Rule ID 9131 //
     /*  980924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  980941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980974 */     // MIs[1] Operand 1
     /*  980974 */     // No operand predicates
     /*  980974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980987 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  980987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  980990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981012 */     GIR_RootConstrainSelectedInstOperands,
     /*  981013 */     // GIR_Coverage, 9131,
     /*  981013 */     GIR_EraseRootFromParent_Done,
     /*  981014 */   // Label 14661: @981014
     /*  981014 */   GIM_Try, /*On fail goto*//*Label 14662*/ GIMT_Encode4(981109), // Rule ID 9134 //
     /*  981019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981069 */     // MIs[1] Operand 1
     /*  981069 */     // No operand predicates
     /*  981069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981082 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  981082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  981085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981107 */     GIR_RootConstrainSelectedInstOperands,
     /*  981108 */     // GIR_Coverage, 9134,
     /*  981108 */     GIR_EraseRootFromParent_Done,
     /*  981109 */   // Label 14662: @981109
     /*  981109 */   GIM_Try, /*On fail goto*//*Label 14663*/ GIMT_Encode4(981204), // Rule ID 9135 //
     /*  981114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981164 */     // MIs[1] Operand 1
     /*  981164 */     // No operand predicates
     /*  981164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981177 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  981177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  981180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981202 */     GIR_RootConstrainSelectedInstOperands,
     /*  981203 */     // GIR_Coverage, 9135,
     /*  981203 */     GIR_EraseRootFromParent_Done,
     /*  981204 */   // Label 14663: @981204
     /*  981204 */   GIM_Try, /*On fail goto*//*Label 14664*/ GIMT_Encode4(981299), // Rule ID 9138 //
     /*  981209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  981220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  981223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  981226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  981232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981259 */     // MIs[1] Operand 1
     /*  981259 */     // No operand predicates
     /*  981259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981272 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  981272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981297 */     GIR_RootConstrainSelectedInstOperands,
     /*  981298 */     // GIR_Coverage, 9138,
     /*  981298 */     GIR_EraseRootFromParent_Done,
     /*  981299 */   // Label 14664: @981299
     /*  981299 */   GIM_Try, /*On fail goto*//*Label 14665*/ GIMT_Encode4(981394), // Rule ID 9139 //
     /*  981304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  981315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  981318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  981321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  981327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981354 */     // MIs[1] Operand 1
     /*  981354 */     // No operand predicates
     /*  981354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981367 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  981367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981392 */     GIR_RootConstrainSelectedInstOperands,
     /*  981393 */     // GIR_Coverage, 9139,
     /*  981393 */     GIR_EraseRootFromParent_Done,
     /*  981394 */   // Label 14665: @981394
     /*  981394 */   GIM_Try, /*On fail goto*//*Label 14666*/ GIMT_Encode4(981489), // Rule ID 9142 //
     /*  981399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  981416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981449 */     // MIs[1] Operand 1
     /*  981449 */     // No operand predicates
     /*  981449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981462 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  981462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981487 */     GIR_RootConstrainSelectedInstOperands,
     /*  981488 */     // GIR_Coverage, 9142,
     /*  981488 */     GIR_EraseRootFromParent_Done,
     /*  981489 */   // Label 14666: @981489
     /*  981489 */   GIM_Try, /*On fail goto*//*Label 14667*/ GIMT_Encode4(981584), // Rule ID 9143 //
     /*  981494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  981511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981544 */     // MIs[1] Operand 1
     /*  981544 */     // No operand predicates
     /*  981544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981557 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  981557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981582 */     GIR_RootConstrainSelectedInstOperands,
     /*  981583 */     // GIR_Coverage, 9143,
     /*  981583 */     GIR_EraseRootFromParent_Done,
     /*  981584 */   // Label 14667: @981584
     /*  981584 */   GIM_Try, /*On fail goto*//*Label 14668*/ GIMT_Encode4(981679), // Rule ID 9146 //
     /*  981589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  981606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981639 */     // MIs[1] Operand 1
     /*  981639 */     // No operand predicates
     /*  981639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981652 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  981652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981677 */     GIR_RootConstrainSelectedInstOperands,
     /*  981678 */     // GIR_Coverage, 9146,
     /*  981678 */     GIR_EraseRootFromParent_Done,
     /*  981679 */   // Label 14668: @981679
     /*  981679 */   GIM_Try, /*On fail goto*//*Label 14669*/ GIMT_Encode4(981774), // Rule ID 9147 //
     /*  981684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  981701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981734 */     // MIs[1] Operand 1
     /*  981734 */     // No operand predicates
     /*  981734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981747 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  981747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981772 */     GIR_RootConstrainSelectedInstOperands,
     /*  981773 */     // GIR_Coverage, 9147,
     /*  981773 */     GIR_EraseRootFromParent_Done,
     /*  981774 */   // Label 14669: @981774
     /*  981774 */   GIM_Try, /*On fail goto*//*Label 14670*/ GIMT_Encode4(981869), // Rule ID 9150 //
     /*  981779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  981782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  981796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981829 */     // MIs[1] Operand 1
     /*  981829 */     // No operand predicates
     /*  981829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981842 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  981842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  981864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981867 */     GIR_RootConstrainSelectedInstOperands,
     /*  981868 */     // GIR_Coverage, 9150,
     /*  981868 */     GIR_EraseRootFromParent_Done,
     /*  981869 */   // Label 14670: @981869
     /*  981869 */   GIM_Try, /*On fail goto*//*Label 14671*/ GIMT_Encode4(981964), // Rule ID 9151 //
     /*  981874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  981877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  981891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981924 */     // MIs[1] Operand 1
     /*  981924 */     // No operand predicates
     /*  981924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981937 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  981937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  981959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981962 */     GIR_RootConstrainSelectedInstOperands,
     /*  981963 */     // GIR_Coverage, 9151,
     /*  981963 */     GIR_EraseRootFromParent_Done,
     /*  981964 */   // Label 14671: @981964
     /*  981964 */   GIM_Try, /*On fail goto*//*Label 14672*/ GIMT_Encode4(982059), // Rule ID 9154 //
     /*  981969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  981980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  981983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  981986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  981992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982019 */     // MIs[1] Operand 1
     /*  982019 */     // No operand predicates
     /*  982019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982032 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  982035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982057 */     GIR_RootConstrainSelectedInstOperands,
     /*  982058 */     // GIR_Coverage, 9154,
     /*  982058 */     GIR_EraseRootFromParent_Done,
     /*  982059 */   // Label 14672: @982059
     /*  982059 */   GIM_Try, /*On fail goto*//*Label 14673*/ GIMT_Encode4(982154), // Rule ID 9155 //
     /*  982064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  982081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982114 */     // MIs[1] Operand 1
     /*  982114 */     // No operand predicates
     /*  982114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982127 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  982130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982152 */     GIR_RootConstrainSelectedInstOperands,
     /*  982153 */     // GIR_Coverage, 9155,
     /*  982153 */     GIR_EraseRootFromParent_Done,
     /*  982154 */   // Label 14673: @982154
     /*  982154 */   GIM_Try, /*On fail goto*//*Label 14674*/ GIMT_Encode4(982249), // Rule ID 9158 //
     /*  982159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982209 */     // MIs[1] Operand 1
     /*  982209 */     // No operand predicates
     /*  982209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982222 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  982225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982247 */     GIR_RootConstrainSelectedInstOperands,
     /*  982248 */     // GIR_Coverage, 9158,
     /*  982248 */     GIR_EraseRootFromParent_Done,
     /*  982249 */   // Label 14674: @982249
     /*  982249 */   GIM_Try, /*On fail goto*//*Label 14675*/ GIMT_Encode4(982344), // Rule ID 9159 //
     /*  982254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982304 */     // MIs[1] Operand 1
     /*  982304 */     // No operand predicates
     /*  982304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982317 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  982320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982342 */     GIR_RootConstrainSelectedInstOperands,
     /*  982343 */     // GIR_Coverage, 9159,
     /*  982343 */     GIR_EraseRootFromParent_Done,
     /*  982344 */   // Label 14675: @982344
     /*  982344 */   GIM_Try, /*On fail goto*//*Label 14676*/ GIMT_Encode4(982439), // Rule ID 9162 //
     /*  982349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  982360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  982363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  982366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  982372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982399 */     // MIs[1] Operand 1
     /*  982399 */     // No operand predicates
     /*  982399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982412 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  982415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982437 */     GIR_RootConstrainSelectedInstOperands,
     /*  982438 */     // GIR_Coverage, 9162,
     /*  982438 */     GIR_EraseRootFromParent_Done,
     /*  982439 */   // Label 14676: @982439
     /*  982439 */   GIM_Try, /*On fail goto*//*Label 14677*/ GIMT_Encode4(982534), // Rule ID 9163 //
     /*  982444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  982455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  982458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  982461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  982467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982494 */     // MIs[1] Operand 1
     /*  982494 */     // No operand predicates
     /*  982494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982507 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  982510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982532 */     GIR_RootConstrainSelectedInstOperands,
     /*  982533 */     // GIR_Coverage, 9163,
     /*  982533 */     GIR_EraseRootFromParent_Done,
     /*  982534 */   // Label 14677: @982534
     /*  982534 */   GIM_Try, /*On fail goto*//*Label 14678*/ GIMT_Encode4(982629), // Rule ID 9166 //
     /*  982539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  982556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  982562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982589 */     // MIs[1] Operand 1
     /*  982589 */     // No operand predicates
     /*  982589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982602 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  982602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  982605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982627 */     GIR_RootConstrainSelectedInstOperands,
     /*  982628 */     // GIR_Coverage, 9166,
     /*  982628 */     GIR_EraseRootFromParent_Done,
     /*  982629 */   // Label 14678: @982629
     /*  982629 */   GIM_Try, /*On fail goto*//*Label 14679*/ GIMT_Encode4(982724), // Rule ID 9167 //
     /*  982634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  982651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  982657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982684 */     // MIs[1] Operand 1
     /*  982684 */     // No operand predicates
     /*  982684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982697 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  982697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  982700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982722 */     GIR_RootConstrainSelectedInstOperands,
     /*  982723 */     // GIR_Coverage, 9167,
     /*  982723 */     GIR_EraseRootFromParent_Done,
     /*  982724 */   // Label 14679: @982724
     /*  982724 */   GIM_Try, /*On fail goto*//*Label 14680*/ GIMT_Encode4(982819), // Rule ID 9170 //
     /*  982729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  982746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982779 */     // MIs[1] Operand 1
     /*  982779 */     // No operand predicates
     /*  982779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982792 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  982792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  982795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982817 */     GIR_RootConstrainSelectedInstOperands,
     /*  982818 */     // GIR_Coverage, 9170,
     /*  982818 */     GIR_EraseRootFromParent_Done,
     /*  982819 */   // Label 14680: @982819
     /*  982819 */   GIM_Try, /*On fail goto*//*Label 14681*/ GIMT_Encode4(982914), // Rule ID 9171 //
     /*  982824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  982841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982874 */     // MIs[1] Operand 1
     /*  982874 */     // No operand predicates
     /*  982874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982887 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  982887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  982890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982912 */     GIR_RootConstrainSelectedInstOperands,
     /*  982913 */     // GIR_Coverage, 9171,
     /*  982913 */     GIR_EraseRootFromParent_Done,
     /*  982914 */   // Label 14681: @982914
     /*  982914 */   GIM_Try, /*On fail goto*//*Label 14682*/ GIMT_Encode4(983009), // Rule ID 9174 //
     /*  982919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  982936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982969 */     // MIs[1] Operand 1
     /*  982969 */     // No operand predicates
     /*  982969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982982 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  982982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  982985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983007 */     GIR_RootConstrainSelectedInstOperands,
     /*  983008 */     // GIR_Coverage, 9174,
     /*  983008 */     GIR_EraseRootFromParent_Done,
     /*  983009 */   // Label 14682: @983009
     /*  983009 */   GIM_Try, /*On fail goto*//*Label 14683*/ GIMT_Encode4(983104), // Rule ID 9175 //
     /*  983014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  983025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  983028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  983031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  983037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983064 */     // MIs[1] Operand 1
     /*  983064 */     // No operand predicates
     /*  983064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983077 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  983080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983102 */     GIR_RootConstrainSelectedInstOperands,
     /*  983103 */     // GIR_Coverage, 9175,
     /*  983103 */     GIR_EraseRootFromParent_Done,
     /*  983104 */   // Label 14683: @983104
     /*  983104 */   GIM_Try, /*On fail goto*//*Label 14684*/ GIMT_Encode4(983199), // Rule ID 9178 //
     /*  983109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  983126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983159 */     // MIs[1] Operand 1
     /*  983159 */     // No operand predicates
     /*  983159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983172 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  983175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983197 */     GIR_RootConstrainSelectedInstOperands,
     /*  983198 */     // GIR_Coverage, 9178,
     /*  983198 */     GIR_EraseRootFromParent_Done,
     /*  983199 */   // Label 14684: @983199
     /*  983199 */   GIM_Try, /*On fail goto*//*Label 14685*/ GIMT_Encode4(983294), // Rule ID 9179 //
     /*  983204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  983221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983254 */     // MIs[1] Operand 1
     /*  983254 */     // No operand predicates
     /*  983254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983267 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  983270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983292 */     GIR_RootConstrainSelectedInstOperands,
     /*  983293 */     // GIR_Coverage, 9179,
     /*  983293 */     GIR_EraseRootFromParent_Done,
     /*  983294 */   // Label 14685: @983294
     /*  983294 */   GIM_Try, /*On fail goto*//*Label 14686*/ GIMT_Encode4(983389), // Rule ID 9182 //
     /*  983299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  983316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983349 */     // MIs[1] Operand 1
     /*  983349 */     // No operand predicates
     /*  983349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983362 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  983365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983387 */     GIR_RootConstrainSelectedInstOperands,
     /*  983388 */     // GIR_Coverage, 9182,
     /*  983388 */     GIR_EraseRootFromParent_Done,
     /*  983389 */   // Label 14686: @983389
     /*  983389 */   GIM_Try, /*On fail goto*//*Label 14687*/ GIMT_Encode4(983484), // Rule ID 9183 //
     /*  983394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  983411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983444 */     // MIs[1] Operand 1
     /*  983444 */     // No operand predicates
     /*  983444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983457 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  983460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983482 */     GIR_RootConstrainSelectedInstOperands,
     /*  983483 */     // GIR_Coverage, 9183,
     /*  983483 */     GIR_EraseRootFromParent_Done,
     /*  983484 */   // Label 14687: @983484
     /*  983484 */   GIM_Try, /*On fail goto*//*Label 14688*/ GIMT_Encode4(983579), // Rule ID 9186 //
     /*  983489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  983506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983539 */     // MIs[1] Operand 1
     /*  983539 */     // No operand predicates
     /*  983539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983552 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  983555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983577 */     GIR_RootConstrainSelectedInstOperands,
     /*  983578 */     // GIR_Coverage, 9186,
     /*  983578 */     GIR_EraseRootFromParent_Done,
     /*  983579 */   // Label 14688: @983579
     /*  983579 */   GIM_Try, /*On fail goto*//*Label 14689*/ GIMT_Encode4(983674), // Rule ID 9187 //
     /*  983584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  983601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983634 */     // MIs[1] Operand 1
     /*  983634 */     // No operand predicates
     /*  983634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983647 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  983650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983672 */     GIR_RootConstrainSelectedInstOperands,
     /*  983673 */     // GIR_Coverage, 9187,
     /*  983673 */     GIR_EraseRootFromParent_Done,
     /*  983674 */   // Label 14689: @983674
     /*  983674 */   GIM_Try, /*On fail goto*//*Label 14690*/ GIMT_Encode4(983769), // Rule ID 9190 //
     /*  983679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  983682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  983690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  983693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  983696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  983702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983729 */     // MIs[1] Operand 1
     /*  983729 */     // No operand predicates
     /*  983729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983742 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  983742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  983745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983767 */     GIR_RootConstrainSelectedInstOperands,
     /*  983768 */     // GIR_Coverage, 9190,
     /*  983768 */     GIR_EraseRootFromParent_Done,
     /*  983769 */   // Label 14690: @983769
     /*  983769 */   GIM_Try, /*On fail goto*//*Label 14691*/ GIMT_Encode4(983864), // Rule ID 9191 //
     /*  983774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  983777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  983785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  983788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  983791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  983797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983824 */     // MIs[1] Operand 1
     /*  983824 */     // No operand predicates
     /*  983824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983837 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  983837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  983840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983862 */     GIR_RootConstrainSelectedInstOperands,
     /*  983863 */     // GIR_Coverage, 9191,
     /*  983863 */     GIR_EraseRootFromParent_Done,
     /*  983864 */   // Label 14691: @983864
     /*  983864 */   GIM_Try, /*On fail goto*//*Label 14692*/ GIMT_Encode4(983959), // Rule ID 9194 //
     /*  983869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  983872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  983886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983919 */     // MIs[1] Operand 1
     /*  983919 */     // No operand predicates
     /*  983919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983932 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  983932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  983935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983957 */     GIR_RootConstrainSelectedInstOperands,
     /*  983958 */     // GIR_Coverage, 9194,
     /*  983958 */     GIR_EraseRootFromParent_Done,
     /*  983959 */   // Label 14692: @983959
     /*  983959 */   GIM_Try, /*On fail goto*//*Label 14693*/ GIMT_Encode4(984054), // Rule ID 9195 //
     /*  983964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  983967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  983981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984014 */     // MIs[1] Operand 1
     /*  984014 */     // No operand predicates
     /*  984014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984027 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  984030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984052 */     GIR_RootConstrainSelectedInstOperands,
     /*  984053 */     // GIR_Coverage, 9195,
     /*  984053 */     GIR_EraseRootFromParent_Done,
     /*  984054 */   // Label 14693: @984054
     /*  984054 */   GIM_Try, /*On fail goto*//*Label 14694*/ GIMT_Encode4(984149), // Rule ID 9198 //
     /*  984059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  984067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  984076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984109 */     // MIs[1] Operand 1
     /*  984109 */     // No operand predicates
     /*  984109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984122 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  984125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984147 */     GIR_RootConstrainSelectedInstOperands,
     /*  984148 */     // GIR_Coverage, 9198,
     /*  984148 */     GIR_EraseRootFromParent_Done,
     /*  984149 */   // Label 14694: @984149
     /*  984149 */   GIM_Try, /*On fail goto*//*Label 14695*/ GIMT_Encode4(984244), // Rule ID 9199 //
     /*  984154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  984162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  984171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984204 */     // MIs[1] Operand 1
     /*  984204 */     // No operand predicates
     /*  984204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984217 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  984220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984242 */     GIR_RootConstrainSelectedInstOperands,
     /*  984243 */     // GIR_Coverage, 9199,
     /*  984243 */     GIR_EraseRootFromParent_Done,
     /*  984244 */   // Label 14695: @984244
     /*  984244 */   GIM_Try, /*On fail goto*//*Label 14696*/ GIMT_Encode4(984339), // Rule ID 9290 //
     /*  984249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  984266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984299 */     // MIs[1] Operand 1
     /*  984299 */     // No operand predicates
     /*  984299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984312 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  984312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  984315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984337 */     GIR_RootConstrainSelectedInstOperands,
     /*  984338 */     // GIR_Coverage, 9290,
     /*  984338 */     GIR_EraseRootFromParent_Done,
     /*  984339 */   // Label 14696: @984339
     /*  984339 */   GIM_Try, /*On fail goto*//*Label 14697*/ GIMT_Encode4(984434), // Rule ID 9291 //
     /*  984344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  984361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984394 */     // MIs[1] Operand 1
     /*  984394 */     // No operand predicates
     /*  984394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984407 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  984407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  984410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984432 */     GIR_RootConstrainSelectedInstOperands,
     /*  984433 */     // GIR_Coverage, 9291,
     /*  984433 */     GIR_EraseRootFromParent_Done,
     /*  984434 */   // Label 14697: @984434
     /*  984434 */   GIM_Try, /*On fail goto*//*Label 14698*/ GIMT_Encode4(984529), // Rule ID 9294 //
     /*  984439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  984456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984489 */     // MIs[1] Operand 1
     /*  984489 */     // No operand predicates
     /*  984489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984502 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  984502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  984505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984527 */     GIR_RootConstrainSelectedInstOperands,
     /*  984528 */     // GIR_Coverage, 9294,
     /*  984528 */     GIR_EraseRootFromParent_Done,
     /*  984529 */   // Label 14698: @984529
     /*  984529 */   GIM_Try, /*On fail goto*//*Label 14699*/ GIMT_Encode4(984624), // Rule ID 9295 //
     /*  984534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  984551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984584 */     // MIs[1] Operand 1
     /*  984584 */     // No operand predicates
     /*  984584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984597 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  984597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  984600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984622 */     GIR_RootConstrainSelectedInstOperands,
     /*  984623 */     // GIR_Coverage, 9295,
     /*  984623 */     GIR_EraseRootFromParent_Done,
     /*  984624 */   // Label 14699: @984624
     /*  984624 */   GIM_Try, /*On fail goto*//*Label 14700*/ GIMT_Encode4(984719), // Rule ID 9298 //
     /*  984629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  984646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984679 */     // MIs[1] Operand 1
     /*  984679 */     // No operand predicates
     /*  984679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984692 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  984692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  984695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984717 */     GIR_RootConstrainSelectedInstOperands,
     /*  984718 */     // GIR_Coverage, 9298,
     /*  984718 */     GIR_EraseRootFromParent_Done,
     /*  984719 */   // Label 14700: @984719
     /*  984719 */   GIM_Try, /*On fail goto*//*Label 14701*/ GIMT_Encode4(984814), // Rule ID 9299 //
     /*  984724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  984741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984774 */     // MIs[1] Operand 1
     /*  984774 */     // No operand predicates
     /*  984774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984787 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  984787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  984790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984812 */     GIR_RootConstrainSelectedInstOperands,
     /*  984813 */     // GIR_Coverage, 9299,
     /*  984813 */     GIR_EraseRootFromParent_Done,
     /*  984814 */   // Label 14701: @984814
     /*  984814 */   GIM_Try, /*On fail goto*//*Label 14702*/ GIMT_Encode4(984909), // Rule ID 9302 //
     /*  984819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  984836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984869 */     // MIs[1] Operand 1
     /*  984869 */     // No operand predicates
     /*  984869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984882 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  984882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  984885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  984904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984907 */     GIR_RootConstrainSelectedInstOperands,
     /*  984908 */     // GIR_Coverage, 9302,
     /*  984908 */     GIR_EraseRootFromParent_Done,
     /*  984909 */   // Label 14702: @984909
     /*  984909 */   GIM_Try, /*On fail goto*//*Label 14703*/ GIMT_Encode4(985004), // Rule ID 9303 //
     /*  984914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  984931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984964 */     // MIs[1] Operand 1
     /*  984964 */     // No operand predicates
     /*  984964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984977 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  984977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  984980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  984999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985002 */     GIR_RootConstrainSelectedInstOperands,
     /*  985003 */     // GIR_Coverage, 9303,
     /*  985003 */     GIR_EraseRootFromParent_Done,
     /*  985004 */   // Label 14703: @985004
     /*  985004 */   GIM_Try, /*On fail goto*//*Label 14704*/ GIMT_Encode4(985099), // Rule ID 9306 //
     /*  985009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  985026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985059 */     // MIs[1] Operand 1
     /*  985059 */     // No operand predicates
     /*  985059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985072 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  985075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985097 */     GIR_RootConstrainSelectedInstOperands,
     /*  985098 */     // GIR_Coverage, 9306,
     /*  985098 */     GIR_EraseRootFromParent_Done,
     /*  985099 */   // Label 14704: @985099
     /*  985099 */   GIM_Try, /*On fail goto*//*Label 14705*/ GIMT_Encode4(985194), // Rule ID 9307 //
     /*  985104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  985121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985154 */     // MIs[1] Operand 1
     /*  985154 */     // No operand predicates
     /*  985154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985167 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  985167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  985170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985192 */     GIR_RootConstrainSelectedInstOperands,
     /*  985193 */     // GIR_Coverage, 9307,
     /*  985193 */     GIR_EraseRootFromParent_Done,
     /*  985194 */   // Label 14705: @985194
     /*  985194 */   GIM_Try, /*On fail goto*//*Label 14706*/ GIMT_Encode4(985289), // Rule ID 9310 //
     /*  985199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  985216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985249 */     // MIs[1] Operand 1
     /*  985249 */     // No operand predicates
     /*  985249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985262 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  985262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  985265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985287 */     GIR_RootConstrainSelectedInstOperands,
     /*  985288 */     // GIR_Coverage, 9310,
     /*  985288 */     GIR_EraseRootFromParent_Done,
     /*  985289 */   // Label 14706: @985289
     /*  985289 */   GIM_Try, /*On fail goto*//*Label 14707*/ GIMT_Encode4(985384), // Rule ID 9311 //
     /*  985294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  985311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985344 */     // MIs[1] Operand 1
     /*  985344 */     // No operand predicates
     /*  985344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985357 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  985357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  985360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985382 */     GIR_RootConstrainSelectedInstOperands,
     /*  985383 */     // GIR_Coverage, 9311,
     /*  985383 */     GIR_EraseRootFromParent_Done,
     /*  985384 */   // Label 14707: @985384
     /*  985384 */   GIM_Try, /*On fail goto*//*Label 14708*/ GIMT_Encode4(985479), // Rule ID 9314 //
     /*  985389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  985400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  985403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  985406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  985412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985439 */     // MIs[1] Operand 1
     /*  985439 */     // No operand predicates
     /*  985439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  985452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  985455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985477 */     GIR_RootConstrainSelectedInstOperands,
     /*  985478 */     // GIR_Coverage, 9314,
     /*  985478 */     GIR_EraseRootFromParent_Done,
     /*  985479 */   // Label 14708: @985479
     /*  985479 */   GIM_Try, /*On fail goto*//*Label 14709*/ GIMT_Encode4(985574), // Rule ID 9315 //
     /*  985484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  985495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  985498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  985501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  985507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985534 */     // MIs[1] Operand 1
     /*  985534 */     // No operand predicates
     /*  985534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985547 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  985547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  985550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985572 */     GIR_RootConstrainSelectedInstOperands,
     /*  985573 */     // GIR_Coverage, 9315,
     /*  985573 */     GIR_EraseRootFromParent_Done,
     /*  985574 */   // Label 14709: @985574
     /*  985574 */   GIM_Try, /*On fail goto*//*Label 14710*/ GIMT_Encode4(985669), // Rule ID 9318 //
     /*  985579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  985596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985629 */     // MIs[1] Operand 1
     /*  985629 */     // No operand predicates
     /*  985629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985642 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  985645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985667 */     GIR_RootConstrainSelectedInstOperands,
     /*  985668 */     // GIR_Coverage, 9318,
     /*  985668 */     GIR_EraseRootFromParent_Done,
     /*  985669 */   // Label 14710: @985669
     /*  985669 */   GIM_Try, /*On fail goto*//*Label 14711*/ GIMT_Encode4(985764), // Rule ID 9319 //
     /*  985674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  985691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985724 */     // MIs[1] Operand 1
     /*  985724 */     // No operand predicates
     /*  985724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985737 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  985737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  985740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985762 */     GIR_RootConstrainSelectedInstOperands,
     /*  985763 */     // GIR_Coverage, 9319,
     /*  985763 */     GIR_EraseRootFromParent_Done,
     /*  985764 */   // Label 14711: @985764
     /*  985764 */   GIM_Try, /*On fail goto*//*Label 14712*/ GIMT_Encode4(985859), // Rule ID 9322 //
     /*  985769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  985786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985819 */     // MIs[1] Operand 1
     /*  985819 */     // No operand predicates
     /*  985819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985832 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  985832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  985835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985857 */     GIR_RootConstrainSelectedInstOperands,
     /*  985858 */     // GIR_Coverage, 9322,
     /*  985858 */     GIR_EraseRootFromParent_Done,
     /*  985859 */   // Label 14712: @985859
     /*  985859 */   GIM_Try, /*On fail goto*//*Label 14713*/ GIMT_Encode4(985954), // Rule ID 9323 //
     /*  985864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  985881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985914 */     // MIs[1] Operand 1
     /*  985914 */     // No operand predicates
     /*  985914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985927 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  985927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  985930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985952 */     GIR_RootConstrainSelectedInstOperands,
     /*  985953 */     // GIR_Coverage, 9323,
     /*  985953 */     GIR_EraseRootFromParent_Done,
     /*  985954 */   // Label 14713: @985954
     /*  985954 */   GIM_Try, /*On fail goto*//*Label 14714*/ GIMT_Encode4(986049), // Rule ID 9326 //
     /*  985959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  985962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  985976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986009 */     // MIs[1] Operand 1
     /*  986009 */     // No operand predicates
     /*  986009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986022 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  986022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  986025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986047 */     GIR_RootConstrainSelectedInstOperands,
     /*  986048 */     // GIR_Coverage, 9326,
     /*  986048 */     GIR_EraseRootFromParent_Done,
     /*  986049 */   // Label 14714: @986049
     /*  986049 */   GIM_Try, /*On fail goto*//*Label 14715*/ GIMT_Encode4(986144), // Rule ID 9327 //
     /*  986054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  986057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  986071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986104 */     // MIs[1] Operand 1
     /*  986104 */     // No operand predicates
     /*  986104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986117 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  986117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  986120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986142 */     GIR_RootConstrainSelectedInstOperands,
     /*  986143 */     // GIR_Coverage, 9327,
     /*  986143 */     GIR_EraseRootFromParent_Done,
     /*  986144 */   // Label 14715: @986144
     /*  986144 */   GIM_Try, /*On fail goto*//*Label 14716*/ GIMT_Encode4(986239), // Rule ID 9330 //
     /*  986149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  986166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986199 */     // MIs[1] Operand 1
     /*  986199 */     // No operand predicates
     /*  986199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986212 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  986215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986237 */     GIR_RootConstrainSelectedInstOperands,
     /*  986238 */     // GIR_Coverage, 9330,
     /*  986238 */     GIR_EraseRootFromParent_Done,
     /*  986239 */   // Label 14716: @986239
     /*  986239 */   GIM_Try, /*On fail goto*//*Label 14717*/ GIMT_Encode4(986334), // Rule ID 9331 //
     /*  986244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  986261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986294 */     // MIs[1] Operand 1
     /*  986294 */     // No operand predicates
     /*  986294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986307 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  986310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986332 */     GIR_RootConstrainSelectedInstOperands,
     /*  986333 */     // GIR_Coverage, 9331,
     /*  986333 */     GIR_EraseRootFromParent_Done,
     /*  986334 */   // Label 14717: @986334
     /*  986334 */   GIM_Try, /*On fail goto*//*Label 14718*/ GIMT_Encode4(986429), // Rule ID 9334 //
     /*  986339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  986350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  986353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  986356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  986362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986389 */     // MIs[1] Operand 1
     /*  986389 */     // No operand predicates
     /*  986389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986402 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  986405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986427 */     GIR_RootConstrainSelectedInstOperands,
     /*  986428 */     // GIR_Coverage, 9334,
     /*  986428 */     GIR_EraseRootFromParent_Done,
     /*  986429 */   // Label 14718: @986429
     /*  986429 */   GIM_Try, /*On fail goto*//*Label 14719*/ GIMT_Encode4(986524), // Rule ID 9335 //
     /*  986434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  986445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  986448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  986451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  986457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986484 */     // MIs[1] Operand 1
     /*  986484 */     // No operand predicates
     /*  986484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986497 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  986500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986522 */     GIR_RootConstrainSelectedInstOperands,
     /*  986523 */     // GIR_Coverage, 9335,
     /*  986523 */     GIR_EraseRootFromParent_Done,
     /*  986524 */   // Label 14719: @986524
     /*  986524 */   GIM_Try, /*On fail goto*//*Label 14720*/ GIMT_Encode4(986619), // Rule ID 9338 //
     /*  986529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  986540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  986543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  986546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  986552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986579 */     // MIs[1] Operand 1
     /*  986579 */     // No operand predicates
     /*  986579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986592 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  986595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986617 */     GIR_RootConstrainSelectedInstOperands,
     /*  986618 */     // GIR_Coverage, 9338,
     /*  986618 */     GIR_EraseRootFromParent_Done,
     /*  986619 */   // Label 14720: @986619
     /*  986619 */   GIM_Try, /*On fail goto*//*Label 14721*/ GIMT_Encode4(986714), // Rule ID 9339 //
     /*  986624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  986635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  986638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  986641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  986647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986674 */     // MIs[1] Operand 1
     /*  986674 */     // No operand predicates
     /*  986674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986687 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  986690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986712 */     GIR_RootConstrainSelectedInstOperands,
     /*  986713 */     // GIR_Coverage, 9339,
     /*  986713 */     GIR_EraseRootFromParent_Done,
     /*  986714 */   // Label 14721: @986714
     /*  986714 */   GIM_Try, /*On fail goto*//*Label 14722*/ GIMT_Encode4(986809), // Rule ID 9342 //
     /*  986719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  986730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  986733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  986736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  986742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986769 */     // MIs[1] Operand 1
     /*  986769 */     // No operand predicates
     /*  986769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  986782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  986785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986807 */     GIR_RootConstrainSelectedInstOperands,
     /*  986808 */     // GIR_Coverage, 9342,
     /*  986808 */     GIR_EraseRootFromParent_Done,
     /*  986809 */   // Label 14722: @986809
     /*  986809 */   GIM_Try, /*On fail goto*//*Label 14723*/ GIMT_Encode4(986904), // Rule ID 9343 //
     /*  986814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  986825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  986828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  986831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  986837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986864 */     // MIs[1] Operand 1
     /*  986864 */     // No operand predicates
     /*  986864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986877 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  986877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  986880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986902 */     GIR_RootConstrainSelectedInstOperands,
     /*  986903 */     // GIR_Coverage, 9343,
     /*  986903 */     GIR_EraseRootFromParent_Done,
     /*  986904 */   // Label 14723: @986904
     /*  986904 */   GIM_Try, /*On fail goto*//*Label 14724*/ GIMT_Encode4(986999), // Rule ID 9346 //
     /*  986909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  986926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986959 */     // MIs[1] Operand 1
     /*  986959 */     // No operand predicates
     /*  986959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986972 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  986972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  986975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986997 */     GIR_RootConstrainSelectedInstOperands,
     /*  986998 */     // GIR_Coverage, 9346,
     /*  986998 */     GIR_EraseRootFromParent_Done,
     /*  986999 */   // Label 14724: @986999
     /*  986999 */   GIM_Try, /*On fail goto*//*Label 14725*/ GIMT_Encode4(987094), // Rule ID 9347 //
     /*  987004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  987021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987054 */     // MIs[1] Operand 1
     /*  987054 */     // No operand predicates
     /*  987054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987067 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  987070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987092 */     GIR_RootConstrainSelectedInstOperands,
     /*  987093 */     // GIR_Coverage, 9347,
     /*  987093 */     GIR_EraseRootFromParent_Done,
     /*  987094 */   // Label 14725: @987094
     /*  987094 */   GIM_Try, /*On fail goto*//*Label 14726*/ GIMT_Encode4(987189), // Rule ID 9350 //
     /*  987099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  987116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987149 */     // MIs[1] Operand 1
     /*  987149 */     // No operand predicates
     /*  987149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987162 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  987165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987187 */     GIR_RootConstrainSelectedInstOperands,
     /*  987188 */     // GIR_Coverage, 9350,
     /*  987188 */     GIR_EraseRootFromParent_Done,
     /*  987189 */   // Label 14726: @987189
     /*  987189 */   GIM_Try, /*On fail goto*//*Label 14727*/ GIMT_Encode4(987284), // Rule ID 9351 //
     /*  987194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  987211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987244 */     // MIs[1] Operand 1
     /*  987244 */     // No operand predicates
     /*  987244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987257 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  987260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987282 */     GIR_RootConstrainSelectedInstOperands,
     /*  987283 */     // GIR_Coverage, 9351,
     /*  987283 */     GIR_EraseRootFromParent_Done,
     /*  987284 */   // Label 14727: @987284
     /*  987284 */   GIM_Try, /*On fail goto*//*Label 14728*/ GIMT_Encode4(987379), // Rule ID 9354 //
     /*  987289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  987300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  987303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  987306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  987312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987339 */     // MIs[1] Operand 1
     /*  987339 */     // No operand predicates
     /*  987339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987352 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  987352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  987355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987377 */     GIR_RootConstrainSelectedInstOperands,
     /*  987378 */     // GIR_Coverage, 9354,
     /*  987378 */     GIR_EraseRootFromParent_Done,
     /*  987379 */   // Label 14728: @987379
     /*  987379 */   GIM_Try, /*On fail goto*//*Label 14729*/ GIMT_Encode4(987474), // Rule ID 9355 //
     /*  987384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  987395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  987398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  987401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  987407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987434 */     // MIs[1] Operand 1
     /*  987434 */     // No operand predicates
     /*  987434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987447 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  987447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  987450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987472 */     GIR_RootConstrainSelectedInstOperands,
     /*  987473 */     // GIR_Coverage, 9355,
     /*  987473 */     GIR_EraseRootFromParent_Done,
     /*  987474 */   // Label 14729: @987474
     /*  987474 */   GIM_Try, /*On fail goto*//*Label 14730*/ GIMT_Encode4(987569), // Rule ID 9358 //
     /*  987479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  987496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987529 */     // MIs[1] Operand 1
     /*  987529 */     // No operand predicates
     /*  987529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987542 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  987542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  987545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987567 */     GIR_RootConstrainSelectedInstOperands,
     /*  987568 */     // GIR_Coverage, 9358,
     /*  987568 */     GIR_EraseRootFromParent_Done,
     /*  987569 */   // Label 14730: @987569
     /*  987569 */   GIM_Try, /*On fail goto*//*Label 14731*/ GIMT_Encode4(987664), // Rule ID 9359 //
     /*  987574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  987591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987624 */     // MIs[1] Operand 1
     /*  987624 */     // No operand predicates
     /*  987624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987637 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  987637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  987640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987662 */     GIR_RootConstrainSelectedInstOperands,
     /*  987663 */     // GIR_Coverage, 9359,
     /*  987663 */     GIR_EraseRootFromParent_Done,
     /*  987664 */   // Label 14731: @987664
     /*  987664 */   GIM_Try, /*On fail goto*//*Label 14732*/ GIMT_Encode4(987759), // Rule ID 9362 //
     /*  987669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  987686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987719 */     // MIs[1] Operand 1
     /*  987719 */     // No operand predicates
     /*  987719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987732 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  987732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  987735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987757 */     GIR_RootConstrainSelectedInstOperands,
     /*  987758 */     // GIR_Coverage, 9362,
     /*  987758 */     GIR_EraseRootFromParent_Done,
     /*  987759 */   // Label 14732: @987759
     /*  987759 */   GIM_Try, /*On fail goto*//*Label 14733*/ GIMT_Encode4(987854), // Rule ID 9363 //
     /*  987764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  987781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987814 */     // MIs[1] Operand 1
     /*  987814 */     // No operand predicates
     /*  987814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987827 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  987827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  987830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987852 */     GIR_RootConstrainSelectedInstOperands,
     /*  987853 */     // GIR_Coverage, 9363,
     /*  987853 */     GIR_EraseRootFromParent_Done,
     /*  987854 */   // Label 14733: @987854
     /*  987854 */   GIM_Try, /*On fail goto*//*Label 14734*/ GIMT_Encode4(987949), // Rule ID 9366 //
     /*  987859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  987862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  987870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  987873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  987876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  987882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987909 */     // MIs[1] Operand 1
     /*  987909 */     // No operand predicates
     /*  987909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987922 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  987922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  987925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  987944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987947 */     GIR_RootConstrainSelectedInstOperands,
     /*  987948 */     // GIR_Coverage, 9366,
     /*  987948 */     GIR_EraseRootFromParent_Done,
     /*  987949 */   // Label 14734: @987949
     /*  987949 */   GIM_Try, /*On fail goto*//*Label 14735*/ GIMT_Encode4(988044), // Rule ID 9367 //
     /*  987954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  987957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  987965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  987968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  987971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  987977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988004 */     // MIs[1] Operand 1
     /*  988004 */     // No operand predicates
     /*  988004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988017 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  988020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988042 */     GIR_RootConstrainSelectedInstOperands,
     /*  988043 */     // GIR_Coverage, 9367,
     /*  988043 */     GIR_EraseRootFromParent_Done,
     /*  988044 */   // Label 14735: @988044
     /*  988044 */   GIM_Try, /*On fail goto*//*Label 14736*/ GIMT_Encode4(988139), // Rule ID 9370 //
     /*  988049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  988057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  988066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988099 */     // MIs[1] Operand 1
     /*  988099 */     // No operand predicates
     /*  988099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988112 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  988115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988137 */     GIR_RootConstrainSelectedInstOperands,
     /*  988138 */     // GIR_Coverage, 9370,
     /*  988138 */     GIR_EraseRootFromParent_Done,
     /*  988139 */   // Label 14736: @988139
     /*  988139 */   GIM_Try, /*On fail goto*//*Label 14737*/ GIMT_Encode4(988234), // Rule ID 9371 //
     /*  988144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  988152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  988161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988194 */     // MIs[1] Operand 1
     /*  988194 */     // No operand predicates
     /*  988194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988207 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  988210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988232 */     GIR_RootConstrainSelectedInstOperands,
     /*  988233 */     // GIR_Coverage, 9371,
     /*  988233 */     GIR_EraseRootFromParent_Done,
     /*  988234 */   // Label 14737: @988234
     /*  988234 */   GIM_Try, /*On fail goto*//*Label 14738*/ GIMT_Encode4(988329), // Rule ID 9374 //
     /*  988239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  988247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  988256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988289 */     // MIs[1] Operand 1
     /*  988289 */     // No operand predicates
     /*  988289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988302 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  988305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988327 */     GIR_RootConstrainSelectedInstOperands,
     /*  988328 */     // GIR_Coverage, 9374,
     /*  988328 */     GIR_EraseRootFromParent_Done,
     /*  988329 */   // Label 14738: @988329
     /*  988329 */   GIM_Try, /*On fail goto*//*Label 14739*/ GIMT_Encode4(988424), // Rule ID 9375 //
     /*  988334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  988342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  988351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988384 */     // MIs[1] Operand 1
     /*  988384 */     // No operand predicates
     /*  988384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988397 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  988400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988422 */     GIR_RootConstrainSelectedInstOperands,
     /*  988423 */     // GIR_Coverage, 9375,
     /*  988423 */     GIR_EraseRootFromParent_Done,
     /*  988424 */   // Label 14739: @988424
     /*  988424 */   GIM_Try, /*On fail goto*//*Label 14740*/ GIMT_Encode4(988519), // Rule ID 9466 //
     /*  988429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  988440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  988443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  988446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  988452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988479 */     // MIs[1] Operand 1
     /*  988479 */     // No operand predicates
     /*  988479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988492 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  988492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  988495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988517 */     GIR_RootConstrainSelectedInstOperands,
     /*  988518 */     // GIR_Coverage, 9466,
     /*  988518 */     GIR_EraseRootFromParent_Done,
     /*  988519 */   // Label 14740: @988519
     /*  988519 */   GIM_Try, /*On fail goto*//*Label 14741*/ GIMT_Encode4(988614), // Rule ID 9467 //
     /*  988524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  988535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  988538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  988541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  988547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988574 */     // MIs[1] Operand 1
     /*  988574 */     // No operand predicates
     /*  988574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988587 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  988587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  988590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988612 */     GIR_RootConstrainSelectedInstOperands,
     /*  988613 */     // GIR_Coverage, 9467,
     /*  988613 */     GIR_EraseRootFromParent_Done,
     /*  988614 */   // Label 14741: @988614
     /*  988614 */   GIM_Try, /*On fail goto*//*Label 14742*/ GIMT_Encode4(988709), // Rule ID 9470 //
     /*  988619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  988630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  988633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  988636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988669 */     // MIs[1] Operand 1
     /*  988669 */     // No operand predicates
     /*  988669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988682 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  988682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  988685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988707 */     GIR_RootConstrainSelectedInstOperands,
     /*  988708 */     // GIR_Coverage, 9470,
     /*  988708 */     GIR_EraseRootFromParent_Done,
     /*  988709 */   // Label 14742: @988709
     /*  988709 */   GIM_Try, /*On fail goto*//*Label 14743*/ GIMT_Encode4(988804), // Rule ID 9471 //
     /*  988714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  988725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  988728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  988731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988764 */     // MIs[1] Operand 1
     /*  988764 */     // No operand predicates
     /*  988764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988777 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  988777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  988780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988802 */     GIR_RootConstrainSelectedInstOperands,
     /*  988803 */     // GIR_Coverage, 9471,
     /*  988803 */     GIR_EraseRootFromParent_Done,
     /*  988804 */   // Label 14743: @988804
     /*  988804 */   GIM_Try, /*On fail goto*//*Label 14744*/ GIMT_Encode4(988899), // Rule ID 9474 //
     /*  988809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  988826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988859 */     // MIs[1] Operand 1
     /*  988859 */     // No operand predicates
     /*  988859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988872 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  988872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  988875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988897 */     GIR_RootConstrainSelectedInstOperands,
     /*  988898 */     // GIR_Coverage, 9474,
     /*  988898 */     GIR_EraseRootFromParent_Done,
     /*  988899 */   // Label 14744: @988899
     /*  988899 */   GIM_Try, /*On fail goto*//*Label 14745*/ GIMT_Encode4(988994), // Rule ID 9475 //
     /*  988904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  988921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988954 */     // MIs[1] Operand 1
     /*  988954 */     // No operand predicates
     /*  988954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988967 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  988967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  988970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988992 */     GIR_RootConstrainSelectedInstOperands,
     /*  988993 */     // GIR_Coverage, 9475,
     /*  988993 */     GIR_EraseRootFromParent_Done,
     /*  988994 */   // Label 14745: @988994
     /*  988994 */   GIM_Try, /*On fail goto*//*Label 14746*/ GIMT_Encode4(989089), // Rule ID 9478 //
     /*  988999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  989010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  989013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989049 */     // MIs[1] Operand 1
     /*  989049 */     // No operand predicates
     /*  989049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989062 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  989062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  989065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989087 */     GIR_RootConstrainSelectedInstOperands,
     /*  989088 */     // GIR_Coverage, 9478,
     /*  989088 */     GIR_EraseRootFromParent_Done,
     /*  989089 */   // Label 14746: @989089
     /*  989089 */   GIM_Try, /*On fail goto*//*Label 14747*/ GIMT_Encode4(989184), // Rule ID 9479 //
     /*  989094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  989105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  989108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989144 */     // MIs[1] Operand 1
     /*  989144 */     // No operand predicates
     /*  989144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989157 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  989157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  989160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989182 */     GIR_RootConstrainSelectedInstOperands,
     /*  989183 */     // GIR_Coverage, 9479,
     /*  989183 */     GIR_EraseRootFromParent_Done,
     /*  989184 */   // Label 14747: @989184
     /*  989184 */   GIM_Try, /*On fail goto*//*Label 14748*/ GIMT_Encode4(989279), // Rule ID 9482 //
     /*  989189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  989200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  989203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989239 */     // MIs[1] Operand 1
     /*  989239 */     // No operand predicates
     /*  989239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989252 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  989252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  989255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989277 */     GIR_RootConstrainSelectedInstOperands,
     /*  989278 */     // GIR_Coverage, 9482,
     /*  989278 */     GIR_EraseRootFromParent_Done,
     /*  989279 */   // Label 14748: @989279
     /*  989279 */   GIM_Try, /*On fail goto*//*Label 14749*/ GIMT_Encode4(989374), // Rule ID 9483 //
     /*  989284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  989295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  989298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989334 */     // MIs[1] Operand 1
     /*  989334 */     // No operand predicates
     /*  989334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989347 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  989347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  989350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989372 */     GIR_RootConstrainSelectedInstOperands,
     /*  989373 */     // GIR_Coverage, 9483,
     /*  989373 */     GIR_EraseRootFromParent_Done,
     /*  989374 */   // Label 14749: @989374
     /*  989374 */   GIM_Try, /*On fail goto*//*Label 14750*/ GIMT_Encode4(989469), // Rule ID 9486 //
     /*  989379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  989390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  989393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  989396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989429 */     // MIs[1] Operand 1
     /*  989429 */     // No operand predicates
     /*  989429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989442 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  989442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  989445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989467 */     GIR_RootConstrainSelectedInstOperands,
     /*  989468 */     // GIR_Coverage, 9486,
     /*  989468 */     GIR_EraseRootFromParent_Done,
     /*  989469 */   // Label 14750: @989469
     /*  989469 */   GIM_Try, /*On fail goto*//*Label 14751*/ GIMT_Encode4(989564), // Rule ID 9487 //
     /*  989474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  989485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  989488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  989491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989524 */     // MIs[1] Operand 1
     /*  989524 */     // No operand predicates
     /*  989524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989537 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  989537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  989540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989562 */     GIR_RootConstrainSelectedInstOperands,
     /*  989563 */     // GIR_Coverage, 9487,
     /*  989563 */     GIR_EraseRootFromParent_Done,
     /*  989564 */   // Label 14751: @989564
     /*  989564 */   GIM_Try, /*On fail goto*//*Label 14752*/ GIMT_Encode4(989659), // Rule ID 9490 //
     /*  989569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  989580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  989583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  989586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989619 */     // MIs[1] Operand 1
     /*  989619 */     // No operand predicates
     /*  989619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989632 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  989632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  989635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989657 */     GIR_RootConstrainSelectedInstOperands,
     /*  989658 */     // GIR_Coverage, 9490,
     /*  989658 */     GIR_EraseRootFromParent_Done,
     /*  989659 */   // Label 14752: @989659
     /*  989659 */   GIM_Try, /*On fail goto*//*Label 14753*/ GIMT_Encode4(989754), // Rule ID 9491 //
     /*  989664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  989675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  989678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  989681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989714 */     // MIs[1] Operand 1
     /*  989714 */     // No operand predicates
     /*  989714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989727 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  989727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  989730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989752 */     GIR_RootConstrainSelectedInstOperands,
     /*  989753 */     // GIR_Coverage, 9491,
     /*  989753 */     GIR_EraseRootFromParent_Done,
     /*  989754 */   // Label 14753: @989754
     /*  989754 */   GIM_Try, /*On fail goto*//*Label 14754*/ GIMT_Encode4(989849), // Rule ID 9494 //
     /*  989759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  989770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  989773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  989776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989809 */     // MIs[1] Operand 1
     /*  989809 */     // No operand predicates
     /*  989809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989822 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  989822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  989825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989847 */     GIR_RootConstrainSelectedInstOperands,
     /*  989848 */     // GIR_Coverage, 9494,
     /*  989848 */     GIR_EraseRootFromParent_Done,
     /*  989849 */   // Label 14754: @989849
     /*  989849 */   GIM_Try, /*On fail goto*//*Label 14755*/ GIMT_Encode4(989944), // Rule ID 9495 //
     /*  989854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  989865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  989868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  989871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989904 */     // MIs[1] Operand 1
     /*  989904 */     // No operand predicates
     /*  989904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989917 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  989917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  989920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989942 */     GIR_RootConstrainSelectedInstOperands,
     /*  989943 */     // GIR_Coverage, 9495,
     /*  989943 */     GIR_EraseRootFromParent_Done,
     /*  989944 */   // Label 14755: @989944
     /*  989944 */   GIM_Try, /*On fail goto*//*Label 14756*/ GIMT_Encode4(990039), // Rule ID 9498 //
     /*  989949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  989960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  989963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  989966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989999 */     // MIs[1] Operand 1
     /*  989999 */     // No operand predicates
     /*  989999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990012 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  990012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  990015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990037 */     GIR_RootConstrainSelectedInstOperands,
     /*  990038 */     // GIR_Coverage, 9498,
     /*  990038 */     GIR_EraseRootFromParent_Done,
     /*  990039 */   // Label 14756: @990039
     /*  990039 */   GIM_Try, /*On fail goto*//*Label 14757*/ GIMT_Encode4(990134), // Rule ID 9499 //
     /*  990044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  990055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  990058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  990061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  990067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990094 */     // MIs[1] Operand 1
     /*  990094 */     // No operand predicates
     /*  990094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990107 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  990107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  990110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990132 */     GIR_RootConstrainSelectedInstOperands,
     /*  990133 */     // GIR_Coverage, 9499,
     /*  990133 */     GIR_EraseRootFromParent_Done,
     /*  990134 */   // Label 14757: @990134
     /*  990134 */   GIM_Try, /*On fail goto*//*Label 14758*/ GIMT_Encode4(990229), // Rule ID 9502 //
     /*  990139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  990142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  990150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  990153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990189 */     // MIs[1] Operand 1
     /*  990189 */     // No operand predicates
     /*  990189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990202 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  990202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  990205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  990224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990227 */     GIR_RootConstrainSelectedInstOperands,
     /*  990228 */     // GIR_Coverage, 9502,
     /*  990228 */     GIR_EraseRootFromParent_Done,
     /*  990229 */   // Label 14758: @990229
     /*  990229 */   GIM_Try, /*On fail goto*//*Label 14759*/ GIMT_Encode4(990324), // Rule ID 9503 //
     /*  990234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  990237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  990245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  990248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990284 */     // MIs[1] Operand 1
     /*  990284 */     // No operand predicates
     /*  990284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990297 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  990297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  990300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  990319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990322 */     GIR_RootConstrainSelectedInstOperands,
     /*  990323 */     // GIR_Coverage, 9503,
     /*  990323 */     GIR_EraseRootFromParent_Done,
     /*  990324 */   // Label 14759: @990324
     /*  990324 */   GIM_Try, /*On fail goto*//*Label 14760*/ GIMT_Encode4(990419), // Rule ID 9506 //
     /*  990329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  990340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  990343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  990346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  990352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990379 */     // MIs[1] Operand 1
     /*  990379 */     // No operand predicates
     /*  990379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990392 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  990392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  990395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990417 */     GIR_RootConstrainSelectedInstOperands,
     /*  990418 */     // GIR_Coverage, 9506,
     /*  990418 */     GIR_EraseRootFromParent_Done,
     /*  990419 */   // Label 14760: @990419
     /*  990419 */   GIM_Try, /*On fail goto*//*Label 14761*/ GIMT_Encode4(990514), // Rule ID 9507 //
     /*  990424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  990435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  990438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  990441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  990447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990474 */     // MIs[1] Operand 1
     /*  990474 */     // No operand predicates
     /*  990474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990487 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  990487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  990490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990512 */     GIR_RootConstrainSelectedInstOperands,
     /*  990513 */     // GIR_Coverage, 9507,
     /*  990513 */     GIR_EraseRootFromParent_Done,
     /*  990514 */   // Label 14761: @990514
     /*  990514 */   GIM_Try, /*On fail goto*//*Label 14762*/ GIMT_Encode4(990609), // Rule ID 9510 //
     /*  990519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  990530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  990533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  990536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  990542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990569 */     // MIs[1] Operand 1
     /*  990569 */     // No operand predicates
     /*  990569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990582 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  990582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  990585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990607 */     GIR_RootConstrainSelectedInstOperands,
     /*  990608 */     // GIR_Coverage, 9510,
     /*  990608 */     GIR_EraseRootFromParent_Done,
     /*  990609 */   // Label 14762: @990609
     /*  990609 */   GIM_Try, /*On fail goto*//*Label 14763*/ GIMT_Encode4(990704), // Rule ID 9511 //
     /*  990614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  990625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  990628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  990631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  990637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990664 */     // MIs[1] Operand 1
     /*  990664 */     // No operand predicates
     /*  990664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990677 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  990677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  990680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990702 */     GIR_RootConstrainSelectedInstOperands,
     /*  990703 */     // GIR_Coverage, 9511,
     /*  990703 */     GIR_EraseRootFromParent_Done,
     /*  990704 */   // Label 14763: @990704
     /*  990704 */   GIM_Try, /*On fail goto*//*Label 14764*/ GIMT_Encode4(990799), // Rule ID 9514 //
     /*  990709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  990720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  990723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  990726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  990732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990759 */     // MIs[1] Operand 1
     /*  990759 */     // No operand predicates
     /*  990759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990772 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  990772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  990775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990797 */     GIR_RootConstrainSelectedInstOperands,
     /*  990798 */     // GIR_Coverage, 9514,
     /*  990798 */     GIR_EraseRootFromParent_Done,
     /*  990799 */   // Label 14764: @990799
     /*  990799 */   GIM_Try, /*On fail goto*//*Label 14765*/ GIMT_Encode4(990894), // Rule ID 9515 //
     /*  990804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  990815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  990818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  990821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  990827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990854 */     // MIs[1] Operand 1
     /*  990854 */     // No operand predicates
     /*  990854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990867 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  990867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  990870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990892 */     GIR_RootConstrainSelectedInstOperands,
     /*  990893 */     // GIR_Coverage, 9515,
     /*  990893 */     GIR_EraseRootFromParent_Done,
     /*  990894 */   // Label 14765: @990894
     /*  990894 */   GIM_Try, /*On fail goto*//*Label 14766*/ GIMT_Encode4(990989), // Rule ID 9518 //
     /*  990899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  990910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  990913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  990916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  990922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990949 */     // MIs[1] Operand 1
     /*  990949 */     // No operand predicates
     /*  990949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990962 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  990962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  990965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990987 */     GIR_RootConstrainSelectedInstOperands,
     /*  990988 */     // GIR_Coverage, 9518,
     /*  990988 */     GIR_EraseRootFromParent_Done,
     /*  990989 */   // Label 14766: @990989
     /*  990989 */   GIM_Try, /*On fail goto*//*Label 14767*/ GIMT_Encode4(991084), // Rule ID 9519 //
     /*  990994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  991005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  991008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  991011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991044 */     // MIs[1] Operand 1
     /*  991044 */     // No operand predicates
     /*  991044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991057 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  991057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  991060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991082 */     GIR_RootConstrainSelectedInstOperands,
     /*  991083 */     // GIR_Coverage, 9519,
     /*  991083 */     GIR_EraseRootFromParent_Done,
     /*  991084 */   // Label 14767: @991084
     /*  991084 */   GIM_Try, /*On fail goto*//*Label 14768*/ GIMT_Encode4(991179), // Rule ID 9522 //
     /*  991089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  991100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  991103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  991106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991139 */     // MIs[1] Operand 1
     /*  991139 */     // No operand predicates
     /*  991139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991152 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  991152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  991155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991177 */     GIR_RootConstrainSelectedInstOperands,
     /*  991178 */     // GIR_Coverage, 9522,
     /*  991178 */     GIR_EraseRootFromParent_Done,
     /*  991179 */   // Label 14768: @991179
     /*  991179 */   GIM_Try, /*On fail goto*//*Label 14769*/ GIMT_Encode4(991274), // Rule ID 9523 //
     /*  991184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  991195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  991198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  991201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991234 */     // MIs[1] Operand 1
     /*  991234 */     // No operand predicates
     /*  991234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991247 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  991247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  991250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991272 */     GIR_RootConstrainSelectedInstOperands,
     /*  991273 */     // GIR_Coverage, 9523,
     /*  991273 */     GIR_EraseRootFromParent_Done,
     /*  991274 */   // Label 14769: @991274
     /*  991274 */   GIM_Try, /*On fail goto*//*Label 14770*/ GIMT_Encode4(991369), // Rule ID 9526 //
     /*  991279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  991290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  991293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  991296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991329 */     // MIs[1] Operand 1
     /*  991329 */     // No operand predicates
     /*  991329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991342 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  991342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  991345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991367 */     GIR_RootConstrainSelectedInstOperands,
     /*  991368 */     // GIR_Coverage, 9526,
     /*  991368 */     GIR_EraseRootFromParent_Done,
     /*  991369 */   // Label 14770: @991369
     /*  991369 */   GIM_Try, /*On fail goto*//*Label 14771*/ GIMT_Encode4(991464), // Rule ID 9527 //
     /*  991374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  991385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  991388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  991391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991424 */     // MIs[1] Operand 1
     /*  991424 */     // No operand predicates
     /*  991424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991437 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  991437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  991440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991462 */     GIR_RootConstrainSelectedInstOperands,
     /*  991463 */     // GIR_Coverage, 9527,
     /*  991463 */     GIR_EraseRootFromParent_Done,
     /*  991464 */   // Label 14771: @991464
     /*  991464 */   GIM_Try, /*On fail goto*//*Label 14772*/ GIMT_Encode4(991559), // Rule ID 9530 //
     /*  991469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  991480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  991483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  991486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  991492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991519 */     // MIs[1] Operand 1
     /*  991519 */     // No operand predicates
     /*  991519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991532 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  991532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  991535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991557 */     GIR_RootConstrainSelectedInstOperands,
     /*  991558 */     // GIR_Coverage, 9530,
     /*  991558 */     GIR_EraseRootFromParent_Done,
     /*  991559 */   // Label 14772: @991559
     /*  991559 */   GIM_Try, /*On fail goto*//*Label 14773*/ GIMT_Encode4(991654), // Rule ID 9531 //
     /*  991564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  991575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  991578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  991581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  991587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991614 */     // MIs[1] Operand 1
     /*  991614 */     // No operand predicates
     /*  991614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991627 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  991627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  991630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991652 */     GIR_RootConstrainSelectedInstOperands,
     /*  991653 */     // GIR_Coverage, 9531,
     /*  991653 */     GIR_EraseRootFromParent_Done,
     /*  991654 */   // Label 14773: @991654
     /*  991654 */   GIM_Try, /*On fail goto*//*Label 14774*/ GIMT_Encode4(991749), // Rule ID 9534 //
     /*  991659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  991670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  991673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  991676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991709 */     // MIs[1] Operand 1
     /*  991709 */     // No operand predicates
     /*  991709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991722 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  991722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  991725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991747 */     GIR_RootConstrainSelectedInstOperands,
     /*  991748 */     // GIR_Coverage, 9534,
     /*  991748 */     GIR_EraseRootFromParent_Done,
     /*  991749 */   // Label 14774: @991749
     /*  991749 */   GIM_Try, /*On fail goto*//*Label 14775*/ GIMT_Encode4(991844), // Rule ID 9535 //
     /*  991754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  991765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  991768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  991771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991804 */     // MIs[1] Operand 1
     /*  991804 */     // No operand predicates
     /*  991804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991817 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  991817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  991820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991842 */     GIR_RootConstrainSelectedInstOperands,
     /*  991843 */     // GIR_Coverage, 9535,
     /*  991843 */     GIR_EraseRootFromParent_Done,
     /*  991844 */   // Label 14775: @991844
     /*  991844 */   GIM_Try, /*On fail goto*//*Label 14776*/ GIMT_Encode4(991939), // Rule ID 9538 //
     /*  991849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  991860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  991863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  991866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991899 */     // MIs[1] Operand 1
     /*  991899 */     // No operand predicates
     /*  991899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991912 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  991912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  991915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991937 */     GIR_RootConstrainSelectedInstOperands,
     /*  991938 */     // GIR_Coverage, 9538,
     /*  991938 */     GIR_EraseRootFromParent_Done,
     /*  991939 */   // Label 14776: @991939
     /*  991939 */   GIM_Try, /*On fail goto*//*Label 14777*/ GIMT_Encode4(992034), // Rule ID 9539 //
     /*  991944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  991955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  991958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  991961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991994 */     // MIs[1] Operand 1
     /*  991994 */     // No operand predicates
     /*  991994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992007 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  992007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  992010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992032 */     GIR_RootConstrainSelectedInstOperands,
     /*  992033 */     // GIR_Coverage, 9539,
     /*  992033 */     GIR_EraseRootFromParent_Done,
     /*  992034 */   // Label 14777: @992034
     /*  992034 */   GIM_Try, /*On fail goto*//*Label 14778*/ GIMT_Encode4(992129), // Rule ID 9542 //
     /*  992039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  992047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  992050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  992053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  992056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992089 */     // MIs[1] Operand 1
     /*  992089 */     // No operand predicates
     /*  992089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992102 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  992102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  992105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992127 */     GIR_RootConstrainSelectedInstOperands,
     /*  992128 */     // GIR_Coverage, 9542,
     /*  992128 */     GIR_EraseRootFromParent_Done,
     /*  992129 */   // Label 14778: @992129
     /*  992129 */   GIM_Try, /*On fail goto*//*Label 14779*/ GIMT_Encode4(992224), // Rule ID 9543 //
     /*  992134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  992142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  992145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  992148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  992151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992184 */     // MIs[1] Operand 1
     /*  992184 */     // No operand predicates
     /*  992184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992197 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  992197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  992200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992222 */     GIR_RootConstrainSelectedInstOperands,
     /*  992223 */     // GIR_Coverage, 9543,
     /*  992223 */     GIR_EraseRootFromParent_Done,
     /*  992224 */   // Label 14779: @992224
     /*  992224 */   GIM_Try, /*On fail goto*//*Label 14780*/ GIMT_Encode4(992319), // Rule ID 9546 //
     /*  992229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  992237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  992240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  992243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  992246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992279 */     // MIs[1] Operand 1
     /*  992279 */     // No operand predicates
     /*  992279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992292 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  992292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  992295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992317 */     GIR_RootConstrainSelectedInstOperands,
     /*  992318 */     // GIR_Coverage, 9546,
     /*  992318 */     GIR_EraseRootFromParent_Done,
     /*  992319 */   // Label 14780: @992319
     /*  992319 */   GIM_Try, /*On fail goto*//*Label 14781*/ GIMT_Encode4(992414), // Rule ID 9547 //
     /*  992324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  992332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  992335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  992338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  992341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992374 */     // MIs[1] Operand 1
     /*  992374 */     // No operand predicates
     /*  992374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992387 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  992387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  992390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992412 */     GIR_RootConstrainSelectedInstOperands,
     /*  992413 */     // GIR_Coverage, 9547,
     /*  992413 */     GIR_EraseRootFromParent_Done,
     /*  992414 */   // Label 14781: @992414
     /*  992414 */   GIM_Try, /*On fail goto*//*Label 14782*/ GIMT_Encode4(992509), // Rule ID 9550 //
     /*  992419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  992427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  992430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  992433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  992436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992469 */     // MIs[1] Operand 1
     /*  992469 */     // No operand predicates
     /*  992469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992482 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  992482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  992485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992507 */     GIR_RootConstrainSelectedInstOperands,
     /*  992508 */     // GIR_Coverage, 9550,
     /*  992508 */     GIR_EraseRootFromParent_Done,
     /*  992509 */   // Label 14782: @992509
     /*  992509 */   GIM_Try, /*On fail goto*//*Label 14783*/ GIMT_Encode4(992604), // Rule ID 9551 //
     /*  992514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  992522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  992525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  992528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  992531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992564 */     // MIs[1] Operand 1
     /*  992564 */     // No operand predicates
     /*  992564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992577 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  992577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  992580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992602 */     GIR_RootConstrainSelectedInstOperands,
     /*  992603 */     // GIR_Coverage, 9551,
     /*  992603 */     GIR_EraseRootFromParent_Done,
     /*  992604 */   // Label 14783: @992604
     /*  992604 */   GIM_Try, /*On fail goto*//*Label 14784*/ GIMT_Encode4(992696), // Rule ID 13928 //
     /*  992609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  992620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  992623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  992626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  992632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992659 */     // MIs[1] Operand 1
     /*  992659 */     // No operand predicates
     /*  992659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992672 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  992672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  992675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992694 */     GIR_RootConstrainSelectedInstOperands,
     /*  992695 */     // GIR_Coverage, 13928,
     /*  992695 */     GIR_EraseRootFromParent_Done,
     /*  992696 */   // Label 14784: @992696
     /*  992696 */   GIM_Try, /*On fail goto*//*Label 14785*/ GIMT_Encode4(992788), // Rule ID 13929 //
     /*  992701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  992712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  992715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  992718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  992724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992751 */     // MIs[1] Operand 1
     /*  992751 */     // No operand predicates
     /*  992751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992764 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  992764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  992767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992786 */     GIR_RootConstrainSelectedInstOperands,
     /*  992787 */     // GIR_Coverage, 13929,
     /*  992787 */     GIR_EraseRootFromParent_Done,
     /*  992788 */   // Label 14785: @992788
     /*  992788 */   GIM_Try, /*On fail goto*//*Label 14786*/ GIMT_Encode4(992880), // Rule ID 13930 //
     /*  992793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  992804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  992807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  992810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992843 */     // MIs[1] Operand 1
     /*  992843 */     // No operand predicates
     /*  992843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992856 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  992856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  992859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992878 */     GIR_RootConstrainSelectedInstOperands,
     /*  992879 */     // GIR_Coverage, 13930,
     /*  992879 */     GIR_EraseRootFromParent_Done,
     /*  992880 */   // Label 14786: @992880
     /*  992880 */   GIM_Try, /*On fail goto*//*Label 14787*/ GIMT_Encode4(992972), // Rule ID 13931 //
     /*  992885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  992896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  992899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  992902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992935 */     // MIs[1] Operand 1
     /*  992935 */     // No operand predicates
     /*  992935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992948 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  992948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  992951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992970 */     GIR_RootConstrainSelectedInstOperands,
     /*  992971 */     // GIR_Coverage, 13931,
     /*  992971 */     GIR_EraseRootFromParent_Done,
     /*  992972 */   // Label 14787: @992972
     /*  992972 */   GIM_Try, /*On fail goto*//*Label 14788*/ GIMT_Encode4(993064), // Rule ID 13932 //
     /*  992977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  992988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  992991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  992994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  993000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993027 */     // MIs[1] Operand 1
     /*  993027 */     // No operand predicates
     /*  993027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993040 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  993040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  993043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993062 */     GIR_RootConstrainSelectedInstOperands,
     /*  993063 */     // GIR_Coverage, 13932,
     /*  993063 */     GIR_EraseRootFromParent_Done,
     /*  993064 */   // Label 14788: @993064
     /*  993064 */   GIM_Try, /*On fail goto*//*Label 14789*/ GIMT_Encode4(993156), // Rule ID 13933 //
     /*  993069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  993072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  993080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  993083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  993086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  993092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993119 */     // MIs[1] Operand 1
     /*  993119 */     // No operand predicates
     /*  993119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993132 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  993132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  993135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993154 */     GIR_RootConstrainSelectedInstOperands,
     /*  993155 */     // GIR_Coverage, 13933,
     /*  993155 */     GIR_EraseRootFromParent_Done,
     /*  993156 */   // Label 14789: @993156
     /*  993156 */   GIM_Try, /*On fail goto*//*Label 14790*/ GIMT_Encode4(993248), // Rule ID 13934 //
     /*  993161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  993164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  993172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  993175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  993178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  993181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  993184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993211 */     // MIs[1] Operand 1
     /*  993211 */     // No operand predicates
     /*  993211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993224 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  993224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  993227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993246 */     GIR_RootConstrainSelectedInstOperands,
     /*  993247 */     // GIR_Coverage, 13934,
     /*  993247 */     GIR_EraseRootFromParent_Done,
     /*  993248 */   // Label 14790: @993248
     /*  993248 */   GIM_Try, /*On fail goto*//*Label 14791*/ GIMT_Encode4(993340), // Rule ID 13935 //
     /*  993253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  993256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  993264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  993267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  993270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  993276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993303 */     // MIs[1] Operand 1
     /*  993303 */     // No operand predicates
     /*  993303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993316 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  993316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  993319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993338 */     GIR_RootConstrainSelectedInstOperands,
     /*  993339 */     // GIR_Coverage, 13935,
     /*  993339 */     GIR_EraseRootFromParent_Done,
     /*  993340 */   // Label 14791: @993340
     /*  993340 */   GIM_Try, /*On fail goto*//*Label 14792*/ GIMT_Encode4(993432), // Rule ID 13936 //
     /*  993345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  993348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  993356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  993359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  993362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  993365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  993368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993395 */     // MIs[1] Operand 1
     /*  993395 */     // No operand predicates
     /*  993395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993408 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  993408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  993411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993430 */     GIR_RootConstrainSelectedInstOperands,
     /*  993431 */     // GIR_Coverage, 13936,
     /*  993431 */     GIR_EraseRootFromParent_Done,
     /*  993432 */   // Label 14792: @993432
     /*  993432 */   GIM_Try, /*On fail goto*//*Label 14793*/ GIMT_Encode4(993524), // Rule ID 13937 //
     /*  993437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  993440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  993448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  993451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  993454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  993460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993487 */     // MIs[1] Operand 1
     /*  993487 */     // No operand predicates
     /*  993487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993500 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  993500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  993503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993522 */     GIR_RootConstrainSelectedInstOperands,
     /*  993523 */     // GIR_Coverage, 13937,
     /*  993523 */     GIR_EraseRootFromParent_Done,
     /*  993524 */   // Label 14793: @993524
     /*  993524 */   GIM_Try, /*On fail goto*//*Label 14794*/ GIMT_Encode4(993616), // Rule ID 13938 //
     /*  993529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  993532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  993540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  993543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  993546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  993549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  993552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993579 */     // MIs[1] Operand 1
     /*  993579 */     // No operand predicates
     /*  993579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993592 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  993592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  993595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993614 */     GIR_RootConstrainSelectedInstOperands,
     /*  993615 */     // GIR_Coverage, 13938,
     /*  993615 */     GIR_EraseRootFromParent_Done,
     /*  993616 */   // Label 14794: @993616
     /*  993616 */   GIM_Try, /*On fail goto*//*Label 14795*/ GIMT_Encode4(993708), // Rule ID 13939 //
     /*  993621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  993624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  993632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  993635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  993638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  993644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993671 */     // MIs[1] Operand 1
     /*  993671 */     // No operand predicates
     /*  993671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  993684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  993687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993706 */     GIR_RootConstrainSelectedInstOperands,
     /*  993707 */     // GIR_Coverage, 13939,
     /*  993707 */     GIR_EraseRootFromParent_Done,
     /*  993708 */   // Label 14795: @993708
     /*  993708 */   GIM_Try, /*On fail goto*//*Label 14796*/ GIMT_Encode4(993800), // Rule ID 13940 //
     /*  993713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  993716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  993724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  993727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  993730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  993733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  993736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993763 */     // MIs[1] Operand 1
     /*  993763 */     // No operand predicates
     /*  993763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993776 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  993776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  993779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993798 */     GIR_RootConstrainSelectedInstOperands,
     /*  993799 */     // GIR_Coverage, 13940,
     /*  993799 */     GIR_EraseRootFromParent_Done,
     /*  993800 */   // Label 14796: @993800
     /*  993800 */   GIM_Try, /*On fail goto*//*Label 14797*/ GIMT_Encode4(993892), // Rule ID 13941 //
     /*  993805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  993808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  993816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  993819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  993822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  993828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993855 */     // MIs[1] Operand 1
     /*  993855 */     // No operand predicates
     /*  993855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993868 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  993868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  993871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993890 */     GIR_RootConstrainSelectedInstOperands,
     /*  993891 */     // GIR_Coverage, 13941,
     /*  993891 */     GIR_EraseRootFromParent_Done,
     /*  993892 */   // Label 14797: @993892
     /*  993892 */   GIM_Try, /*On fail goto*//*Label 14798*/ GIMT_Encode4(993984), // Rule ID 13942 //
     /*  993897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  993900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  993908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  993911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  993914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  993917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  993920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993947 */     // MIs[1] Operand 1
     /*  993947 */     // No operand predicates
     /*  993947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  993960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  993963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993982 */     GIR_RootConstrainSelectedInstOperands,
     /*  993983 */     // GIR_Coverage, 13942,
     /*  993983 */     GIR_EraseRootFromParent_Done,
     /*  993984 */   // Label 14798: @993984
     /*  993984 */   GIM_Try, /*On fail goto*//*Label 14799*/ GIMT_Encode4(994076), // Rule ID 13943 //
     /*  993989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  993992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  994000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  994003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  994006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  994009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  994012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  994019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994039 */     // MIs[1] Operand 1
     /*  994039 */     // No operand predicates
     /*  994039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  994052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  994055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994074 */     GIR_RootConstrainSelectedInstOperands,
     /*  994075 */     // GIR_Coverage, 13943,
     /*  994075 */     GIR_EraseRootFromParent_Done,
     /*  994076 */   // Label 14799: @994076
     /*  994076 */   GIM_Try, /*On fail goto*//*Label 14800*/ GIMT_Encode4(994168), // Rule ID 13944 //
     /*  994081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  994084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  994092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  994095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  994098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  994101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  994104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  994111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994131 */     // MIs[1] Operand 1
     /*  994131 */     // No operand predicates
     /*  994131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  994144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  994147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994166 */     GIR_RootConstrainSelectedInstOperands,
     /*  994167 */     // GIR_Coverage, 13944,
     /*  994167 */     GIR_EraseRootFromParent_Done,
     /*  994168 */   // Label 14800: @994168
     /*  994168 */   GIM_Try, /*On fail goto*//*Label 14801*/ GIMT_Encode4(994260), // Rule ID 13945 //
     /*  994173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  994176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  994184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  994187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  994190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  994193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  994196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  994203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994223 */     // MIs[1] Operand 1
     /*  994223 */     // No operand predicates
     /*  994223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  994236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  994239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994258 */     GIR_RootConstrainSelectedInstOperands,
     /*  994259 */     // GIR_Coverage, 13945,
     /*  994259 */     GIR_EraseRootFromParent_Done,
     /*  994260 */   // Label 14801: @994260
     /*  994260 */   GIM_Try, /*On fail goto*//*Label 14802*/ GIMT_Encode4(994352), // Rule ID 13946 //
     /*  994265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  994268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  994276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  994279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  994282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  994285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  994288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  994295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994315 */     // MIs[1] Operand 1
     /*  994315 */     // No operand predicates
     /*  994315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  994328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  994331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  994350 */     GIR_RootConstrainSelectedInstOperands,
     /*  994351 */     // GIR_Coverage, 13946,
     /*  994351 */     GIR_EraseRootFromParent_Done,
     /*  994352 */   // Label 14802: @994352
     /*  994352 */   GIM_Try, /*On fail goto*//*Label 14803*/ GIMT_Encode4(994444), // Rule ID 13947 //
     /*  994357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  994360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  994368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  994371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  994374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  994377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  994380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  994387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994407 */     // MIs[1] Operand 1
     /*  994407 */     // No operand predicates
     /*  994407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  994420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  994423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  994442 */     GIR_RootConstrainSelectedInstOperands,
     /*  994443 */     // GIR_Coverage, 13947,
     /*  994443 */     GIR_EraseRootFromParent_Done,
     /*  994444 */   // Label 14803: @994444
     /*  994444 */   GIM_Try, /*On fail goto*//*Label 14804*/ GIMT_Encode4(994536), // Rule ID 13948 //
     /*  994449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  994452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  994460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  994463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  994466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  994469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  994472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  994479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994499 */     // MIs[1] Operand 1
     /*  994499 */     // No operand predicates
     /*  994499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994512 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  994512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  994515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  994534 */     GIR_RootConstrainSelectedInstOperands,
     /*  994535 */     // GIR_Coverage, 13948,
     /*  994535 */     GIR_EraseRootFromParent_Done,
     /*  994536 */   // Label 14804: @994536
     /*  994536 */   GIM_Try, /*On fail goto*//*Label 14805*/ GIMT_Encode4(994628), // Rule ID 13949 //
     /*  994541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  994544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  994552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  994555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  994558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  994561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  994564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  994571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994591 */     // MIs[1] Operand 1
     /*  994591 */     // No operand predicates
     /*  994591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994604 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  994604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  994607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  994626 */     GIR_RootConstrainSelectedInstOperands,
     /*  994627 */     // GIR_Coverage, 13949,
     /*  994627 */     GIR_EraseRootFromParent_Done,
     /*  994628 */   // Label 14805: @994628
     /*  994628 */   GIM_Try, /*On fail goto*//*Label 14806*/ GIMT_Encode4(994720), // Rule ID 13950 //
     /*  994633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  994636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  994644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  994647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  994650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  994653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  994656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  994663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994683 */     // MIs[1] Operand 1
     /*  994683 */     // No operand predicates
     /*  994683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994696 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  994696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  994699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  994718 */     GIR_RootConstrainSelectedInstOperands,
     /*  994719 */     // GIR_Coverage, 13950,
     /*  994719 */     GIR_EraseRootFromParent_Done,
     /*  994720 */   // Label 14806: @994720
     /*  994720 */   GIM_Try, /*On fail goto*//*Label 14807*/ GIMT_Encode4(994812), // Rule ID 13951 //
     /*  994725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  994728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  994736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  994739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  994742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  994745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  994748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  994755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994775 */     // MIs[1] Operand 1
     /*  994775 */     // No operand predicates
     /*  994775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994788 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  994788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  994791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  994810 */     GIR_RootConstrainSelectedInstOperands,
     /*  994811 */     // GIR_Coverage, 13951,
     /*  994811 */     GIR_EraseRootFromParent_Done,
     /*  994812 */   // Label 14807: @994812
     /*  994812 */   GIM_Try, /*On fail goto*//*Label 14808*/ GIMT_Encode4(994904), // Rule ID 13952 //
     /*  994817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  994820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  994828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  994831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  994834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  994837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  994840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  994847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994867 */     // MIs[1] Operand 1
     /*  994867 */     // No operand predicates
     /*  994867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994880 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  994880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  994883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  994902 */     GIR_RootConstrainSelectedInstOperands,
     /*  994903 */     // GIR_Coverage, 13952,
     /*  994903 */     GIR_EraseRootFromParent_Done,
     /*  994904 */   // Label 14808: @994904
     /*  994904 */   GIM_Try, /*On fail goto*//*Label 14809*/ GIMT_Encode4(994996), // Rule ID 13953 //
     /*  994909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  994912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  994920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  994923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  994926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  994929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  994932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  994939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994959 */     // MIs[1] Operand 1
     /*  994959 */     // No operand predicates
     /*  994959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994972 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  994972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  994975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  994994 */     GIR_RootConstrainSelectedInstOperands,
     /*  994995 */     // GIR_Coverage, 13953,
     /*  994995 */     GIR_EraseRootFromParent_Done,
     /*  994996 */   // Label 14809: @994996
     /*  994996 */   GIM_Try, /*On fail goto*//*Label 14810*/ GIMT_Encode4(995088), // Rule ID 13954 //
     /*  995001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  995012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  995015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  995018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  995021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  995024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  995031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995051 */     // MIs[1] Operand 1
     /*  995051 */     // No operand predicates
     /*  995051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  995064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  995067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995086 */     GIR_RootConstrainSelectedInstOperands,
     /*  995087 */     // GIR_Coverage, 13954,
     /*  995087 */     GIR_EraseRootFromParent_Done,
     /*  995088 */   // Label 14810: @995088
     /*  995088 */   GIM_Try, /*On fail goto*//*Label 14811*/ GIMT_Encode4(995180), // Rule ID 13955 //
     /*  995093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  995104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  995107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  995110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  995113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  995116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  995123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995143 */     // MIs[1] Operand 1
     /*  995143 */     // No operand predicates
     /*  995143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  995156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  995159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995178 */     GIR_RootConstrainSelectedInstOperands,
     /*  995179 */     // GIR_Coverage, 13955,
     /*  995179 */     GIR_EraseRootFromParent_Done,
     /*  995180 */   // Label 14811: @995180
     /*  995180 */   GIM_Try, /*On fail goto*//*Label 14812*/ GIMT_Encode4(995272), // Rule ID 13956 //
     /*  995185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  995196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  995199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  995202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  995205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  995208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  995215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995235 */     // MIs[1] Operand 1
     /*  995235 */     // No operand predicates
     /*  995235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995248 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  995248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  995251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995270 */     GIR_RootConstrainSelectedInstOperands,
     /*  995271 */     // GIR_Coverage, 13956,
     /*  995271 */     GIR_EraseRootFromParent_Done,
     /*  995272 */   // Label 14812: @995272
     /*  995272 */   GIM_Try, /*On fail goto*//*Label 14813*/ GIMT_Encode4(995364), // Rule ID 13957 //
     /*  995277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  995288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  995291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  995294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  995297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  995300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  995307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995327 */     // MIs[1] Operand 1
     /*  995327 */     // No operand predicates
     /*  995327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995340 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  995340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  995343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995362 */     GIR_RootConstrainSelectedInstOperands,
     /*  995363 */     // GIR_Coverage, 13957,
     /*  995363 */     GIR_EraseRootFromParent_Done,
     /*  995364 */   // Label 14813: @995364
     /*  995364 */   GIM_Try, /*On fail goto*//*Label 14814*/ GIMT_Encode4(995456), // Rule ID 13958 //
     /*  995369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  995380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  995383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  995386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  995389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  995392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  995399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995419 */     // MIs[1] Operand 1
     /*  995419 */     // No operand predicates
     /*  995419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995432 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  995432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  995435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995454 */     GIR_RootConstrainSelectedInstOperands,
     /*  995455 */     // GIR_Coverage, 13958,
     /*  995455 */     GIR_EraseRootFromParent_Done,
     /*  995456 */   // Label 14814: @995456
     /*  995456 */   GIM_Try, /*On fail goto*//*Label 14815*/ GIMT_Encode4(995548), // Rule ID 13959 //
     /*  995461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  995472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  995475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  995478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  995481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  995484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  995491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995511 */     // MIs[1] Operand 1
     /*  995511 */     // No operand predicates
     /*  995511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995524 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  995524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  995527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995546 */     GIR_RootConstrainSelectedInstOperands,
     /*  995547 */     // GIR_Coverage, 13959,
     /*  995547 */     GIR_EraseRootFromParent_Done,
     /*  995548 */   // Label 14815: @995548
     /*  995548 */   GIM_Try, /*On fail goto*//*Label 14816*/ GIMT_Encode4(995640), // Rule ID 13960 //
     /*  995553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  995564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  995567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  995570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  995573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  995576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  995583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995603 */     // MIs[1] Operand 1
     /*  995603 */     // No operand predicates
     /*  995603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  995616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  995619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995638 */     GIR_RootConstrainSelectedInstOperands,
     /*  995639 */     // GIR_Coverage, 13960,
     /*  995639 */     GIR_EraseRootFromParent_Done,
     /*  995640 */   // Label 14816: @995640
     /*  995640 */   GIM_Try, /*On fail goto*//*Label 14817*/ GIMT_Encode4(995732), // Rule ID 13961 //
     /*  995645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  995656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  995659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  995662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  995665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  995668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  995675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995695 */     // MIs[1] Operand 1
     /*  995695 */     // No operand predicates
     /*  995695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  995708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  995711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995730 */     GIR_RootConstrainSelectedInstOperands,
     /*  995731 */     // GIR_Coverage, 13961,
     /*  995731 */     GIR_EraseRootFromParent_Done,
     /*  995732 */   // Label 14817: @995732
     /*  995732 */   GIM_Try, /*On fail goto*//*Label 14818*/ GIMT_Encode4(995824), // Rule ID 13962 //
     /*  995737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  995748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  995751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  995754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  995757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  995760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  995767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995787 */     // MIs[1] Operand 1
     /*  995787 */     // No operand predicates
     /*  995787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995800 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  995800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  995803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995822 */     GIR_RootConstrainSelectedInstOperands,
     /*  995823 */     // GIR_Coverage, 13962,
     /*  995823 */     GIR_EraseRootFromParent_Done,
     /*  995824 */   // Label 14818: @995824
     /*  995824 */   GIM_Try, /*On fail goto*//*Label 14819*/ GIMT_Encode4(995916), // Rule ID 13963 //
     /*  995829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  995840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  995843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  995846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  995849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  995852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  995859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995879 */     // MIs[1] Operand 1
     /*  995879 */     // No operand predicates
     /*  995879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995892 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  995892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  995895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995914 */     GIR_RootConstrainSelectedInstOperands,
     /*  995915 */     // GIR_Coverage, 13963,
     /*  995915 */     GIR_EraseRootFromParent_Done,
     /*  995916 */   // Label 14819: @995916
     /*  995916 */   GIM_Try, /*On fail goto*//*Label 14820*/ GIMT_Encode4(996008), // Rule ID 13964 //
     /*  995921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  995932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  995935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  995938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  995941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  995944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  995951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995971 */     // MIs[1] Operand 1
     /*  995971 */     // No operand predicates
     /*  995971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995984 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  995984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  995987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996006 */     GIR_RootConstrainSelectedInstOperands,
     /*  996007 */     // GIR_Coverage, 13964,
     /*  996007 */     GIR_EraseRootFromParent_Done,
     /*  996008 */   // Label 14820: @996008
     /*  996008 */   GIM_Try, /*On fail goto*//*Label 14821*/ GIMT_Encode4(996100), // Rule ID 13965 //
     /*  996013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  996024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  996027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  996030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  996033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  996036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  996039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  996043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996063 */     // MIs[1] Operand 1
     /*  996063 */     // No operand predicates
     /*  996063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  996076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  996079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996098 */     GIR_RootConstrainSelectedInstOperands,
     /*  996099 */     // GIR_Coverage, 13965,
     /*  996099 */     GIR_EraseRootFromParent_Done,
     /*  996100 */   // Label 14821: @996100
     /*  996100 */   GIM_Try, /*On fail goto*//*Label 14822*/ GIMT_Encode4(996192), // Rule ID 13966 //
     /*  996105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  996108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  996116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  996119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  996122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  996125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  996128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  996131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  996135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996155 */     // MIs[1] Operand 1
     /*  996155 */     // No operand predicates
     /*  996155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  996168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  996171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996190 */     GIR_RootConstrainSelectedInstOperands,
     /*  996191 */     // GIR_Coverage, 13966,
     /*  996191 */     GIR_EraseRootFromParent_Done,
     /*  996192 */   // Label 14822: @996192
     /*  996192 */   GIM_Try, /*On fail goto*//*Label 14823*/ GIMT_Encode4(996284), // Rule ID 13967 //
     /*  996197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  996200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  996208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  996211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  996214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  996217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  996220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  996223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  996227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996247 */     // MIs[1] Operand 1
     /*  996247 */     // No operand predicates
     /*  996247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996260 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  996260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  996263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996282 */     GIR_RootConstrainSelectedInstOperands,
     /*  996283 */     // GIR_Coverage, 13967,
     /*  996283 */     GIR_EraseRootFromParent_Done,
     /*  996284 */   // Label 14823: @996284
     /*  996284 */   GIM_Try, /*On fail goto*//*Label 14824*/ GIMT_Encode4(996376), // Rule ID 13968 //
     /*  996289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  996292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  996300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  996303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  996306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  996309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  996312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  996315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  996319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996339 */     // MIs[1] Operand 1
     /*  996339 */     // No operand predicates
     /*  996339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  996352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  996355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996374 */     GIR_RootConstrainSelectedInstOperands,
     /*  996375 */     // GIR_Coverage, 13968,
     /*  996375 */     GIR_EraseRootFromParent_Done,
     /*  996376 */   // Label 14824: @996376
     /*  996376 */   GIM_Try, /*On fail goto*//*Label 14825*/ GIMT_Encode4(996468), // Rule ID 13969 //
     /*  996381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  996384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  996392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  996395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  996398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  996401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  996404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  996407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  996411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996431 */     // MIs[1] Operand 1
     /*  996431 */     // No operand predicates
     /*  996431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996444 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  996444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  996447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996466 */     GIR_RootConstrainSelectedInstOperands,
     /*  996467 */     // GIR_Coverage, 13969,
     /*  996467 */     GIR_EraseRootFromParent_Done,
     /*  996468 */   // Label 14825: @996468
     /*  996468 */   GIM_Try, /*On fail goto*//*Label 14826*/ GIMT_Encode4(996560), // Rule ID 13970 //
     /*  996473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  996476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  996484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  996487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  996490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  996493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  996496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  996499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  996503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996523 */     // MIs[1] Operand 1
     /*  996523 */     // No operand predicates
     /*  996523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  996536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  996539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996558 */     GIR_RootConstrainSelectedInstOperands,
     /*  996559 */     // GIR_Coverage, 13970,
     /*  996559 */     GIR_EraseRootFromParent_Done,
     /*  996560 */   // Label 14826: @996560
     /*  996560 */   GIM_Try, /*On fail goto*//*Label 14827*/ GIMT_Encode4(996652), // Rule ID 13971 //
     /*  996565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  996568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  996576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  996579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  996582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  996585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  996588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  996591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  996595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996615 */     // MIs[1] Operand 1
     /*  996615 */     // No operand predicates
     /*  996615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996628 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  996628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  996631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996650 */     GIR_RootConstrainSelectedInstOperands,
     /*  996651 */     // GIR_Coverage, 13971,
     /*  996651 */     GIR_EraseRootFromParent_Done,
     /*  996652 */   // Label 14827: @996652
     /*  996652 */   GIM_Try, /*On fail goto*//*Label 14828*/ GIMT_Encode4(996728), // Rule ID 2758 //
     /*  996657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  996660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  996665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  996668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  996671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  996674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  996677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996685 */     // MIs[0] passthru
     /*  996685 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  996690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996694 */     // MIs[0] round
     /*  996694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  996697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996704 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  996704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  996707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  996715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  996726 */     GIR_RootConstrainSelectedInstOperands,
     /*  996727 */     // GIR_Coverage, 2758,
     /*  996727 */     GIR_EraseRootFromParent_Done,
     /*  996728 */   // Label 14828: @996728
     /*  996728 */   GIM_Try, /*On fail goto*//*Label 14829*/ GIMT_Encode4(996804), // Rule ID 2759 //
     /*  996733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  996736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  996741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  996744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  996747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  996750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  996753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996761 */     // MIs[0] passthru
     /*  996761 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  996766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996770 */     // MIs[0] round
     /*  996770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  996773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996780 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  996780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  996783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  996791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  996802 */     GIR_RootConstrainSelectedInstOperands,
     /*  996803 */     // GIR_Coverage, 2759,
     /*  996803 */     GIR_EraseRootFromParent_Done,
     /*  996804 */   // Label 14829: @996804
     /*  996804 */   GIM_Try, /*On fail goto*//*Label 14830*/ GIMT_Encode4(996880), // Rule ID 17138 //
     /*  996809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  996812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  996817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  996820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  996823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  996826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  996829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996837 */     // MIs[0] passthru
     /*  996837 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  996842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996846 */     // MIs[0] round
     /*  996846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  996849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996856 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  996856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  996859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  996867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  996878 */     GIR_RootConstrainSelectedInstOperands,
     /*  996879 */     // GIR_Coverage, 17138,
     /*  996879 */     GIR_EraseRootFromParent_Done,
     /*  996880 */   // Label 14830: @996880
     /*  996880 */   GIM_Try, /*On fail goto*//*Label 14831*/ GIMT_Encode4(996956), // Rule ID 17139 //
     /*  996885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  996888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  996893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  996896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  996899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  996902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  996905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996913 */     // MIs[0] passthru
     /*  996913 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  996918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996922 */     // MIs[0] round
     /*  996922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  996925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996932 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  996932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  996935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  996943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  996954 */     GIR_RootConstrainSelectedInstOperands,
     /*  996955 */     // GIR_Coverage, 17139,
     /*  996955 */     GIR_EraseRootFromParent_Done,
     /*  996956 */   // Label 14831: @996956
     /*  996956 */   GIM_Try, /*On fail goto*//*Label 14832*/ GIMT_Encode4(997032), // Rule ID 17148 //
     /*  996961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  996964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  996969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  996972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  996975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  996978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  996981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996989 */     // MIs[0] passthru
     /*  996989 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  996994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996998 */     // MIs[0] round
     /*  996998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997008 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  997008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  997011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997030 */     GIR_RootConstrainSelectedInstOperands,
     /*  997031 */     // GIR_Coverage, 17148,
     /*  997031 */     GIR_EraseRootFromParent_Done,
     /*  997032 */   // Label 14832: @997032
     /*  997032 */   GIM_Try, /*On fail goto*//*Label 14833*/ GIMT_Encode4(997108), // Rule ID 17149 //
     /*  997037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  997040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  997048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  997051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  997054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997065 */     // MIs[0] passthru
     /*  997065 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997074 */     // MIs[0] round
     /*  997074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997084 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  997084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  997087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997106 */     GIR_RootConstrainSelectedInstOperands,
     /*  997107 */     // GIR_Coverage, 17149,
     /*  997107 */     GIR_EraseRootFromParent_Done,
     /*  997108 */   // Label 14833: @997108
     /*  997108 */   GIM_Try, /*On fail goto*//*Label 14834*/ GIMT_Encode4(997184), // Rule ID 17158 //
     /*  997113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  997116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  997124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  997127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  997130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  997133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997141 */     // MIs[0] passthru
     /*  997141 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997150 */     // MIs[0] round
     /*  997150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997160 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  997160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  997163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997182 */     GIR_RootConstrainSelectedInstOperands,
     /*  997183 */     // GIR_Coverage, 17158,
     /*  997183 */     GIR_EraseRootFromParent_Done,
     /*  997184 */   // Label 14834: @997184
     /*  997184 */   GIM_Try, /*On fail goto*//*Label 14835*/ GIMT_Encode4(997260), // Rule ID 17159 //
     /*  997189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  997192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  997200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  997203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  997206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997217 */     // MIs[0] passthru
     /*  997217 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997226 */     // MIs[0] round
     /*  997226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997236 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  997236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  997239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997258 */     GIR_RootConstrainSelectedInstOperands,
     /*  997259 */     // GIR_Coverage, 17159,
     /*  997259 */     GIR_EraseRootFromParent_Done,
     /*  997260 */   // Label 14835: @997260
     /*  997260 */   GIM_Try, /*On fail goto*//*Label 14836*/ GIMT_Encode4(997336), // Rule ID 17168 //
     /*  997265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  997268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  997276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  997279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  997282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  997285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997293 */     // MIs[0] passthru
     /*  997293 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997302 */     // MIs[0] round
     /*  997302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997312 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  997312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  997315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997334 */     GIR_RootConstrainSelectedInstOperands,
     /*  997335 */     // GIR_Coverage, 17168,
     /*  997335 */     GIR_EraseRootFromParent_Done,
     /*  997336 */   // Label 14836: @997336
     /*  997336 */   GIM_Try, /*On fail goto*//*Label 14837*/ GIMT_Encode4(997412), // Rule ID 17169 //
     /*  997341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  997344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  997352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  997355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  997358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997369 */     // MIs[0] passthru
     /*  997369 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997378 */     // MIs[0] round
     /*  997378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997388 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  997388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  997391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997410 */     GIR_RootConstrainSelectedInstOperands,
     /*  997411 */     // GIR_Coverage, 17169,
     /*  997411 */     GIR_EraseRootFromParent_Done,
     /*  997412 */   // Label 14837: @997412
     /*  997412 */   GIM_Try, /*On fail goto*//*Label 14838*/ GIMT_Encode4(997488), // Rule ID 17178 //
     /*  997417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  997420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  997428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  997431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  997434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  997437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997445 */     // MIs[0] passthru
     /*  997445 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997454 */     // MIs[0] round
     /*  997454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997464 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  997464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  997467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997486 */     GIR_RootConstrainSelectedInstOperands,
     /*  997487 */     // GIR_Coverage, 17178,
     /*  997487 */     GIR_EraseRootFromParent_Done,
     /*  997488 */   // Label 14838: @997488
     /*  997488 */   GIM_Try, /*On fail goto*//*Label 14839*/ GIMT_Encode4(997564), // Rule ID 17179 //
     /*  997493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  997496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  997504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  997507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  997510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997521 */     // MIs[0] passthru
     /*  997521 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997530 */     // MIs[0] round
     /*  997530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997540 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  997540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  997543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997562 */     GIR_RootConstrainSelectedInstOperands,
     /*  997563 */     // GIR_Coverage, 17179,
     /*  997563 */     GIR_EraseRootFromParent_Done,
     /*  997564 */   // Label 14839: @997564
     /*  997564 */   GIM_Try, /*On fail goto*//*Label 14840*/ GIMT_Encode4(997640), // Rule ID 17188 //
     /*  997569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  997572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  997580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  997583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  997586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  997589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997597 */     // MIs[0] passthru
     /*  997597 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997606 */     // MIs[0] round
     /*  997606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997616 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  997616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  997619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997638 */     GIR_RootConstrainSelectedInstOperands,
     /*  997639 */     // GIR_Coverage, 17188,
     /*  997639 */     GIR_EraseRootFromParent_Done,
     /*  997640 */   // Label 14840: @997640
     /*  997640 */   GIM_Try, /*On fail goto*//*Label 14841*/ GIMT_Encode4(997716), // Rule ID 17189 //
     /*  997645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  997648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  997656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  997659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  997662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997673 */     // MIs[0] passthru
     /*  997673 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997682 */     // MIs[0] round
     /*  997682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997692 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  997692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  997695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997714 */     GIR_RootConstrainSelectedInstOperands,
     /*  997715 */     // GIR_Coverage, 17189,
     /*  997715 */     GIR_EraseRootFromParent_Done,
     /*  997716 */   // Label 14841: @997716
     /*  997716 */   GIM_Try, /*On fail goto*//*Label 14842*/ GIMT_Encode4(997792), // Rule ID 17198 //
     /*  997721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  997724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  997732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  997735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  997738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  997741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997749 */     // MIs[0] passthru
     /*  997749 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997758 */     // MIs[0] round
     /*  997758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997768 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  997768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  997771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997790 */     GIR_RootConstrainSelectedInstOperands,
     /*  997791 */     // GIR_Coverage, 17198,
     /*  997791 */     GIR_EraseRootFromParent_Done,
     /*  997792 */   // Label 14842: @997792
     /*  997792 */   GIM_Try, /*On fail goto*//*Label 14843*/ GIMT_Encode4(997868), // Rule ID 17199 //
     /*  997797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  997800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  997808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  997811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  997814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997825 */     // MIs[0] passthru
     /*  997825 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997834 */     // MIs[0] round
     /*  997834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997844 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  997844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  997847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997866 */     GIR_RootConstrainSelectedInstOperands,
     /*  997867 */     // GIR_Coverage, 17199,
     /*  997867 */     GIR_EraseRootFromParent_Done,
     /*  997868 */   // Label 14843: @997868
     /*  997868 */   GIM_Try, /*On fail goto*//*Label 14844*/ GIMT_Encode4(997944), // Rule ID 17208 //
     /*  997873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  997876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  997884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  997887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  997890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  997893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997901 */     // MIs[0] passthru
     /*  997901 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997910 */     // MIs[0] round
     /*  997910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997920 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  997920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  997923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997942 */     GIR_RootConstrainSelectedInstOperands,
     /*  997943 */     // GIR_Coverage, 17208,
     /*  997943 */     GIR_EraseRootFromParent_Done,
     /*  997944 */   // Label 14844: @997944
     /*  997944 */   GIM_Try, /*On fail goto*//*Label 14845*/ GIMT_Encode4(998020), // Rule ID 17209 //
     /*  997949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  997952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  997960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  997963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  997966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997977 */     // MIs[0] passthru
     /*  997977 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997986 */     // MIs[0] round
     /*  997986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997996 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  997996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  997999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998018 */     GIR_RootConstrainSelectedInstOperands,
     /*  998019 */     // GIR_Coverage, 17209,
     /*  998019 */     GIR_EraseRootFromParent_Done,
     /*  998020 */   // Label 14845: @998020
     /*  998020 */   GIM_Try, /*On fail goto*//*Label 14846*/ GIMT_Encode4(998096), // Rule ID 17254 //
     /*  998025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  998028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  998036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  998039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  998042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998053 */     // MIs[0] passthru
     /*  998053 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998062 */     // MIs[0] round
     /*  998062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998072 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  998072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  998075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998094 */     GIR_RootConstrainSelectedInstOperands,
     /*  998095 */     // GIR_Coverage, 17254,
     /*  998095 */     GIR_EraseRootFromParent_Done,
     /*  998096 */   // Label 14846: @998096
     /*  998096 */   GIM_Try, /*On fail goto*//*Label 14847*/ GIMT_Encode4(998172), // Rule ID 17255 //
     /*  998101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  998104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  998112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  998115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  998118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  998121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998129 */     // MIs[0] passthru
     /*  998129 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998138 */     // MIs[0] round
     /*  998138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998148 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  998148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  998151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998170 */     GIR_RootConstrainSelectedInstOperands,
     /*  998171 */     // GIR_Coverage, 17255,
     /*  998171 */     GIR_EraseRootFromParent_Done,
     /*  998172 */   // Label 14847: @998172
     /*  998172 */   GIM_Try, /*On fail goto*//*Label 14848*/ GIMT_Encode4(998248), // Rule ID 17264 //
     /*  998177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  998180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  998188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  998191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  998194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998205 */     // MIs[0] passthru
     /*  998205 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998214 */     // MIs[0] round
     /*  998214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998224 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  998224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  998227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998246 */     GIR_RootConstrainSelectedInstOperands,
     /*  998247 */     // GIR_Coverage, 17264,
     /*  998247 */     GIR_EraseRootFromParent_Done,
     /*  998248 */   // Label 14848: @998248
     /*  998248 */   GIM_Try, /*On fail goto*//*Label 14849*/ GIMT_Encode4(998324), // Rule ID 17265 //
     /*  998253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  998256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  998264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  998267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  998270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  998273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998281 */     // MIs[0] passthru
     /*  998281 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998290 */     // MIs[0] round
     /*  998290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998300 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  998300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  998303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998322 */     GIR_RootConstrainSelectedInstOperands,
     /*  998323 */     // GIR_Coverage, 17265,
     /*  998323 */     GIR_EraseRootFromParent_Done,
     /*  998324 */   // Label 14849: @998324
     /*  998324 */   GIM_Try, /*On fail goto*//*Label 14850*/ GIMT_Encode4(998400), // Rule ID 17274 //
     /*  998329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  998332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  998340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  998343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  998346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998357 */     // MIs[0] passthru
     /*  998357 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998366 */     // MIs[0] round
     /*  998366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998376 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  998376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  998379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998398 */     GIR_RootConstrainSelectedInstOperands,
     /*  998399 */     // GIR_Coverage, 17274,
     /*  998399 */     GIR_EraseRootFromParent_Done,
     /*  998400 */   // Label 14850: @998400
     /*  998400 */   GIM_Try, /*On fail goto*//*Label 14851*/ GIMT_Encode4(998476), // Rule ID 17275 //
     /*  998405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  998408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  998416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  998419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  998422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  998425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998433 */     // MIs[0] passthru
     /*  998433 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998442 */     // MIs[0] round
     /*  998442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998452 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  998452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  998455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998474 */     GIR_RootConstrainSelectedInstOperands,
     /*  998475 */     // GIR_Coverage, 17275,
     /*  998475 */     GIR_EraseRootFromParent_Done,
     /*  998476 */   // Label 14851: @998476
     /*  998476 */   GIM_Try, /*On fail goto*//*Label 14852*/ GIMT_Encode4(998552), // Rule ID 17284 //
     /*  998481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  998484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  998498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998509 */     // MIs[0] passthru
     /*  998509 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998518 */     // MIs[0] round
     /*  998518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998528 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  998528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  998531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998550 */     GIR_RootConstrainSelectedInstOperands,
     /*  998551 */     // GIR_Coverage, 17284,
     /*  998551 */     GIR_EraseRootFromParent_Done,
     /*  998552 */   // Label 14852: @998552
     /*  998552 */   GIM_Try, /*On fail goto*//*Label 14853*/ GIMT_Encode4(998628), // Rule ID 17285 //
     /*  998557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  998560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  998574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  998577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998585 */     // MIs[0] passthru
     /*  998585 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998594 */     // MIs[0] round
     /*  998594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998604 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  998604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  998607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998626 */     GIR_RootConstrainSelectedInstOperands,
     /*  998627 */     // GIR_Coverage, 17285,
     /*  998627 */     GIR_EraseRootFromParent_Done,
     /*  998628 */   // Label 14853: @998628
     /*  998628 */   GIM_Try, /*On fail goto*//*Label 14854*/ GIMT_Encode4(998704), // Rule ID 17294 //
     /*  998633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  998636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  998644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  998647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  998650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998661 */     // MIs[0] passthru
     /*  998661 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998670 */     // MIs[0] round
     /*  998670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998680 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  998680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  998683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998702 */     GIR_RootConstrainSelectedInstOperands,
     /*  998703 */     // GIR_Coverage, 17294,
     /*  998703 */     GIR_EraseRootFromParent_Done,
     /*  998704 */   // Label 14854: @998704
     /*  998704 */   GIM_Try, /*On fail goto*//*Label 14855*/ GIMT_Encode4(998780), // Rule ID 17295 //
     /*  998709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  998712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  998720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  998723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  998726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  998729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998737 */     // MIs[0] passthru
     /*  998737 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998746 */     // MIs[0] round
     /*  998746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998756 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  998756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  998759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998778 */     GIR_RootConstrainSelectedInstOperands,
     /*  998779 */     // GIR_Coverage, 17295,
     /*  998779 */     GIR_EraseRootFromParent_Done,
     /*  998780 */   // Label 14855: @998780
     /*  998780 */   GIM_Try, /*On fail goto*//*Label 14856*/ GIMT_Encode4(998856), // Rule ID 17304 //
     /*  998785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  998788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  998796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  998799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  998802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998813 */     // MIs[0] passthru
     /*  998813 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998822 */     // MIs[0] round
     /*  998822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998832 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  998832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  998835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998854 */     GIR_RootConstrainSelectedInstOperands,
     /*  998855 */     // GIR_Coverage, 17304,
     /*  998855 */     GIR_EraseRootFromParent_Done,
     /*  998856 */   // Label 14856: @998856
     /*  998856 */   GIM_Try, /*On fail goto*//*Label 14857*/ GIMT_Encode4(998932), // Rule ID 17305 //
     /*  998861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  998864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  998872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  998875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  998878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  998881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998889 */     // MIs[0] passthru
     /*  998889 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998898 */     // MIs[0] round
     /*  998898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998908 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  998908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  998911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998930 */     GIR_RootConstrainSelectedInstOperands,
     /*  998931 */     // GIR_Coverage, 17305,
     /*  998931 */     GIR_EraseRootFromParent_Done,
     /*  998932 */   // Label 14857: @998932
     /*  998932 */   GIM_Try, /*On fail goto*//*Label 14858*/ GIMT_Encode4(999008), // Rule ID 17314 //
     /*  998937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  998940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  998954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998965 */     // MIs[0] passthru
     /*  998965 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998974 */     // MIs[0] round
     /*  998974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998984 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  998984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  998987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  999006 */     GIR_RootConstrainSelectedInstOperands,
     /*  999007 */     // GIR_Coverage, 17314,
     /*  999007 */     GIR_EraseRootFromParent_Done,
     /*  999008 */   // Label 14858: @999008
     /*  999008 */   GIM_Try, /*On fail goto*//*Label 14859*/ GIMT_Encode4(999084), // Rule ID 17315 //
     /*  999013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  999016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  999021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  999024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  999027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  999030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  999033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999041 */     // MIs[0] passthru
     /*  999041 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  999046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999050 */     // MIs[0] round
     /*  999050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  999053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999060 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  999060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  999063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  999069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  999071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  999082 */     GIR_RootConstrainSelectedInstOperands,
     /*  999083 */     // GIR_Coverage, 17315,
     /*  999083 */     GIR_EraseRootFromParent_Done,
     /*  999084 */   // Label 14859: @999084
     /*  999084 */   GIM_Try, /*On fail goto*//*Label 14860*/ GIMT_Encode4(999160), // Rule ID 17324 //
     /*  999089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  999092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  999097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  999100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  999103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  999106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  999109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999117 */     // MIs[0] passthru
     /*  999117 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  999122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999126 */     // MIs[0] round
     /*  999126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  999129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999136 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  999136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  999139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  999145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  999147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  999158 */     GIR_RootConstrainSelectedInstOperands,
     /*  999159 */     // GIR_Coverage, 17324,
     /*  999159 */     GIR_EraseRootFromParent_Done,
     /*  999160 */   // Label 14860: @999160
     /*  999160 */   GIM_Try, /*On fail goto*//*Label 14861*/ GIMT_Encode4(999236), // Rule ID 17325 //
     /*  999165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  999168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  999173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  999176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  999179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  999182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  999185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999193 */     // MIs[0] passthru
     /*  999193 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  999198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999202 */     // MIs[0] round
     /*  999202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  999205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999212 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  999212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  999215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  999221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  999223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  999234 */     GIR_RootConstrainSelectedInstOperands,
     /*  999235 */     // GIR_Coverage, 17325,
     /*  999235 */     GIR_EraseRootFromParent_Done,
     /*  999236 */   // Label 14861: @999236
     /*  999236 */   GIM_Try, /*On fail goto*//*Label 14862*/ GIMT_Encode4(999312), // Rule ID 17334 //
     /*  999241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  999244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  999249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  999252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  999255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  999258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  999261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999269 */     // MIs[0] passthru
     /*  999269 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  999274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999278 */     // MIs[0] round
     /*  999278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  999281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999288 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  999288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  999291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  999297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  999299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  999310 */     GIR_RootConstrainSelectedInstOperands,
     /*  999311 */     // GIR_Coverage, 17334,
     /*  999311 */     GIR_EraseRootFromParent_Done,
     /*  999312 */   // Label 14862: @999312
     /*  999312 */   GIM_Try, /*On fail goto*//*Label 14863*/ GIMT_Encode4(999388), // Rule ID 17335 //
     /*  999317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  999320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  999325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  999328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  999331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  999334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  999337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999345 */     // MIs[0] passthru
     /*  999345 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  999350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999354 */     // MIs[0] round
     /*  999354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  999357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999364 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  999364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  999367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  999373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  999375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  999386 */     GIR_RootConstrainSelectedInstOperands,
     /*  999387 */     // GIR_Coverage, 17335,
     /*  999387 */     GIR_EraseRootFromParent_Done,
     /*  999388 */   // Label 14863: @999388
     /*  999388 */   GIM_Try, /*On fail goto*//*Label 14864*/ GIMT_Encode4(999465), // Rule ID 2688 //
     /*  999393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  999401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  999404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  999407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  999410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999432 */     // MIs[0] policy
     /*  999432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999442 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  999445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  999461 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999463 */     GIR_RootConstrainSelectedInstOperands,
     /*  999464 */     // GIR_Coverage, 2688,
     /*  999464 */     GIR_EraseRootFromParent_Done,
     /*  999465 */   // Label 14864: @999465
     /*  999465 */   GIM_Try, /*On fail goto*//*Label 14865*/ GIMT_Encode4(999542), // Rule ID 2689 //
     /*  999470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  999478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  999481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  999484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  999487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999509 */     // MIs[0] policy
     /*  999509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999519 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  999522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  999538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999540 */     GIR_RootConstrainSelectedInstOperands,
     /*  999541 */     // GIR_Coverage, 2689,
     /*  999541 */     GIR_EraseRootFromParent_Done,
     /*  999542 */   // Label 14865: @999542
     /*  999542 */   GIM_Try, /*On fail goto*//*Label 14866*/ GIMT_Encode4(999619), // Rule ID 2692 //
     /*  999547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  999564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999586 */     // MIs[0] policy
     /*  999586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999596 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  999599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999617 */     GIR_RootConstrainSelectedInstOperands,
     /*  999618 */     // GIR_Coverage, 2692,
     /*  999618 */     GIR_EraseRootFromParent_Done,
     /*  999619 */   // Label 14866: @999619
     /*  999619 */   GIM_Try, /*On fail goto*//*Label 14867*/ GIMT_Encode4(999696), // Rule ID 2693 //
     /*  999624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  999641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999663 */     // MIs[0] policy
     /*  999663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999673 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  999676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999694 */     GIR_RootConstrainSelectedInstOperands,
     /*  999695 */     // GIR_Coverage, 2693,
     /*  999695 */     GIR_EraseRootFromParent_Done,
     /*  999696 */   // Label 14867: @999696
     /*  999696 */   GIM_Try, /*On fail goto*//*Label 14868*/ GIMT_Encode4(999773), // Rule ID 2696 //
     /*  999701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  999704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  999709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999740 */     // MIs[0] policy
     /*  999740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999750 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  999753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999769 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999771 */     GIR_RootConstrainSelectedInstOperands,
     /*  999772 */     // GIR_Coverage, 2696,
     /*  999772 */     GIR_EraseRootFromParent_Done,
     /*  999773 */   // Label 14868: @999773
     /*  999773 */   GIM_Try, /*On fail goto*//*Label 14869*/ GIMT_Encode4(999850), // Rule ID 2697 //
     /*  999778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  999781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  999786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999817 */     // MIs[0] policy
     /*  999817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999827 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  999830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999848 */     GIR_RootConstrainSelectedInstOperands,
     /*  999849 */     // GIR_Coverage, 2697,
     /*  999849 */     GIR_EraseRootFromParent_Done,
     /*  999850 */   // Label 14869: @999850
     /*  999850 */   GIM_Try, /*On fail goto*//*Label 14870*/ GIMT_Encode4(999927), // Rule ID 2732 //
     /*  999855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  999858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  999863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999894 */     // MIs[0] policy
     /*  999894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999904 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  999907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999925 */     GIR_RootConstrainSelectedInstOperands,
     /*  999926 */     // GIR_Coverage, 2732,
     /*  999926 */     GIR_EraseRootFromParent_Done,
     /*  999927 */   // Label 14870: @999927
     /*  999927 */   GIM_Try, /*On fail goto*//*Label 14871*/ GIMT_Encode4(1000004), // Rule ID 2733 //
     /*  999932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  999935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  999940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999971 */     // MIs[0] policy
     /*  999971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999981 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  999984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999990 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000003 */     // GIR_Coverage, 2733,
     /* 1000003 */     GIR_EraseRootFromParent_Done,
     /* 1000004 */   // Label 14871: @1000004
     /* 1000004 */   GIM_Try, /*On fail goto*//*Label 14872*/ GIMT_Encode4(1000081), // Rule ID 2764 //
     /* 1000009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1000017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1000020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1000023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1000029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000048 */     // MIs[0] policy
     /* 1000048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000058 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /* 1000061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1000065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1000067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1000069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1000077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000080 */     // GIR_Coverage, 2764,
     /* 1000080 */     GIR_EraseRootFromParent_Done,
     /* 1000081 */   // Label 14872: @1000081
     /* 1000081 */   GIM_Try, /*On fail goto*//*Label 14873*/ GIMT_Encode4(1000158), // Rule ID 2765 //
     /* 1000086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1000094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1000097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1000100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1000106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000125 */     // MIs[0] policy
     /* 1000125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000135 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /* 1000138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1000142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1000144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1000146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1000154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000157 */     // GIR_Coverage, 2765,
     /* 1000157 */     GIR_EraseRootFromParent_Done,
     /* 1000158 */   // Label 14873: @1000158
     /* 1000158 */   GIM_Try, /*On fail goto*//*Label 14874*/ GIMT_Encode4(1000235), // Rule ID 4892 //
     /* 1000163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1000174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1000177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000202 */     // MIs[0] policy
     /* 1000202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000212 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /* 1000215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000231 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000234 */     // GIR_Coverage, 4892,
     /* 1000234 */     GIR_EraseRootFromParent_Done,
     /* 1000235 */   // Label 14874: @1000235
     /* 1000235 */   GIM_Try, /*On fail goto*//*Label 14875*/ GIMT_Encode4(1000312), // Rule ID 4893 //
     /* 1000240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1000251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1000254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000279 */     // MIs[0] policy
     /* 1000279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000289 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /* 1000292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000298 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000311 */     // GIR_Coverage, 4893,
     /* 1000311 */     GIR_EraseRootFromParent_Done,
     /* 1000312 */   // Label 14875: @1000312
     /* 1000312 */   GIM_Try, /*On fail goto*//*Label 14876*/ GIMT_Encode4(1000389), // Rule ID 4896 //
     /* 1000317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1000328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1000331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000356 */     // MIs[0] policy
     /* 1000356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /* 1000369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000388 */     // GIR_Coverage, 4896,
     /* 1000388 */     GIR_EraseRootFromParent_Done,
     /* 1000389 */   // Label 14876: @1000389
     /* 1000389 */   GIM_Try, /*On fail goto*//*Label 14877*/ GIMT_Encode4(1000466), // Rule ID 4897 //
     /* 1000394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1000405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1000408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000433 */     // MIs[0] policy
     /* 1000433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000443 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /* 1000446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000465 */     // GIR_Coverage, 4897,
     /* 1000465 */     GIR_EraseRootFromParent_Done,
     /* 1000466 */   // Label 14877: @1000466
     /* 1000466 */   GIM_Try, /*On fail goto*//*Label 14878*/ GIMT_Encode4(1000543), // Rule ID 4900 //
     /* 1000471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1000482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1000485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000510 */     // MIs[0] policy
     /* 1000510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000520 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /* 1000523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000542 */     // GIR_Coverage, 4900,
     /* 1000542 */     GIR_EraseRootFromParent_Done,
     /* 1000543 */   // Label 14878: @1000543
     /* 1000543 */   GIM_Try, /*On fail goto*//*Label 14879*/ GIMT_Encode4(1000620), // Rule ID 4901 //
     /* 1000548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1000559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1000562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000587 */     // MIs[0] policy
     /* 1000587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /* 1000600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000606 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000619 */     // GIR_Coverage, 4901,
     /* 1000619 */     GIR_EraseRootFromParent_Done,
     /* 1000620 */   // Label 14879: @1000620
     /* 1000620 */   GIM_Try, /*On fail goto*//*Label 14880*/ GIMT_Encode4(1000697), // Rule ID 4904 //
     /* 1000625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1000636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1000639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1000642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1000645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000664 */     // MIs[0] policy
     /* 1000664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000674 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /* 1000677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000696 */     // GIR_Coverage, 4904,
     /* 1000696 */     GIR_EraseRootFromParent_Done,
     /* 1000697 */   // Label 14880: @1000697
     /* 1000697 */   GIM_Try, /*On fail goto*//*Label 14881*/ GIMT_Encode4(1000774), // Rule ID 4905 //
     /* 1000702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1000713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1000716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1000719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1000722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000741 */     // MIs[0] policy
     /* 1000741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000751 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /* 1000754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000760 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000773 */     // GIR_Coverage, 4905,
     /* 1000773 */     GIR_EraseRootFromParent_Done,
     /* 1000774 */   // Label 14881: @1000774
     /* 1000774 */   GIM_Try, /*On fail goto*//*Label 14882*/ GIMT_Encode4(1000851), // Rule ID 4908 //
     /* 1000779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1000790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1000793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1000796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1000799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000818 */     // MIs[0] policy
     /* 1000818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000828 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /* 1000831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000847 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000850 */     // GIR_Coverage, 4908,
     /* 1000850 */     GIR_EraseRootFromParent_Done,
     /* 1000851 */   // Label 14882: @1000851
     /* 1000851 */   GIM_Try, /*On fail goto*//*Label 14883*/ GIMT_Encode4(1000928), // Rule ID 4909 //
     /* 1000856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1000867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1000870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1000873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1000876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000895 */     // MIs[0] policy
     /* 1000895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000905 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /* 1000908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000914 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000927 */     // GIR_Coverage, 4909,
     /* 1000927 */     GIR_EraseRootFromParent_Done,
     /* 1000928 */   // Label 14883: @1000928
     /* 1000928 */   GIM_Try, /*On fail goto*//*Label 14884*/ GIMT_Encode4(1001005), // Rule ID 4912 //
     /* 1000933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1000944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1000947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1000950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000972 */     // MIs[0] policy
     /* 1000972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000982 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /* 1000985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001004 */     // GIR_Coverage, 4912,
     /* 1001004 */     GIR_EraseRootFromParent_Done,
     /* 1001005 */   // Label 14884: @1001005
     /* 1001005 */   GIM_Try, /*On fail goto*//*Label 14885*/ GIMT_Encode4(1001082), // Rule ID 4913 //
     /* 1001010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1001021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1001024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1001027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001049 */     // MIs[0] policy
     /* 1001049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001059 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /* 1001062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001081 */     // GIR_Coverage, 4913,
     /* 1001081 */     GIR_EraseRootFromParent_Done,
     /* 1001082 */   // Label 14885: @1001082
     /* 1001082 */   GIM_Try, /*On fail goto*//*Label 14886*/ GIMT_Encode4(1001159), // Rule ID 4916 //
     /* 1001087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1001098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1001101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1001104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001126 */     // MIs[0] policy
     /* 1001126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001136 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /* 1001139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001158 */     // GIR_Coverage, 4916,
     /* 1001158 */     GIR_EraseRootFromParent_Done,
     /* 1001159 */   // Label 14886: @1001159
     /* 1001159 */   GIM_Try, /*On fail goto*//*Label 14887*/ GIMT_Encode4(1001236), // Rule ID 4917 //
     /* 1001164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1001175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1001178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1001181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001203 */     // MIs[0] policy
     /* 1001203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001213 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /* 1001216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001222 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001235 */     // GIR_Coverage, 4917,
     /* 1001235 */     GIR_EraseRootFromParent_Done,
     /* 1001236 */   // Label 14887: @1001236
     /* 1001236 */   GIM_Try, /*On fail goto*//*Label 14888*/ GIMT_Encode4(1001313), // Rule ID 4920 //
     /* 1001241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1001252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1001255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1001258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001280 */     // MIs[0] policy
     /* 1001280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /* 1001293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001312 */     // GIR_Coverage, 4920,
     /* 1001312 */     GIR_EraseRootFromParent_Done,
     /* 1001313 */   // Label 14888: @1001313
     /* 1001313 */   GIM_Try, /*On fail goto*//*Label 14889*/ GIMT_Encode4(1001390), // Rule ID 4921 //
     /* 1001318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1001329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1001332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1001335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001357 */     // MIs[0] policy
     /* 1001357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001367 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /* 1001370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001376 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001389 */     // GIR_Coverage, 4921,
     /* 1001389 */     GIR_EraseRootFromParent_Done,
     /* 1001390 */   // Label 14889: @1001390
     /* 1001390 */   GIM_Try, /*On fail goto*//*Label 14890*/ GIMT_Encode4(1001467), // Rule ID 4924 //
     /* 1001395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1001406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1001409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1001412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001434 */     // MIs[0] policy
     /* 1001434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001444 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /* 1001447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001466 */     // GIR_Coverage, 4924,
     /* 1001466 */     GIR_EraseRootFromParent_Done,
     /* 1001467 */   // Label 14890: @1001467
     /* 1001467 */   GIM_Try, /*On fail goto*//*Label 14891*/ GIMT_Encode4(1001544), // Rule ID 4925 //
     /* 1001472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1001483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1001486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1001489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001511 */     // MIs[0] policy
     /* 1001511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /* 1001524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001543 */     // GIR_Coverage, 4925,
     /* 1001543 */     GIR_EraseRootFromParent_Done,
     /* 1001544 */   // Label 14891: @1001544
     /* 1001544 */   GIM_Try, /*On fail goto*//*Label 14892*/ GIMT_Encode4(1001621), // Rule ID 4928 //
     /* 1001549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1001560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1001563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1001566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001588 */     // MIs[0] policy
     /* 1001588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001598 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /* 1001601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001620 */     // GIR_Coverage, 4928,
     /* 1001620 */     GIR_EraseRootFromParent_Done,
     /* 1001621 */   // Label 14892: @1001621
     /* 1001621 */   GIM_Try, /*On fail goto*//*Label 14893*/ GIMT_Encode4(1001698), // Rule ID 4929 //
     /* 1001626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1001637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1001640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1001643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001665 */     // MIs[0] policy
     /* 1001665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001675 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /* 1001678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001697 */     // GIR_Coverage, 4929,
     /* 1001697 */     GIR_EraseRootFromParent_Done,
     /* 1001698 */   // Label 14893: @1001698
     /* 1001698 */   GIM_Try, /*On fail goto*//*Label 14894*/ GIMT_Encode4(1001775), // Rule ID 4932 //
     /* 1001703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1001706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1001714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1001717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1001720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001742 */     // MIs[0] policy
     /* 1001742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /* 1001755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1001771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001774 */     // GIR_Coverage, 4932,
     /* 1001774 */     GIR_EraseRootFromParent_Done,
     /* 1001775 */   // Label 14894: @1001775
     /* 1001775 */   GIM_Try, /*On fail goto*//*Label 14895*/ GIMT_Encode4(1001852), // Rule ID 4933 //
     /* 1001780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1001783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1001791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1001794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1001797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001819 */     // MIs[0] policy
     /* 1001819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001829 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /* 1001832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001838 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1001848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001851 */     // GIR_Coverage, 4933,
     /* 1001851 */     GIR_EraseRootFromParent_Done,
     /* 1001852 */   // Label 14895: @1001852
     /* 1001852 */   GIM_Try, /*On fail goto*//*Label 14896*/ GIMT_Encode4(1001929), // Rule ID 4936 //
     /* 1001857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1001860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1001868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1001871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1001874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001896 */     // MIs[0] policy
     /* 1001896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /* 1001909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1001925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001928 */     // GIR_Coverage, 4936,
     /* 1001928 */     GIR_EraseRootFromParent_Done,
     /* 1001929 */   // Label 14896: @1001929
     /* 1001929 */   GIM_Try, /*On fail goto*//*Label 14897*/ GIMT_Encode4(1002006), // Rule ID 4937 //
     /* 1001934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1001937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1001945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1001948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1001951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001973 */     // MIs[0] policy
     /* 1001973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001983 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /* 1001986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002005 */     // GIR_Coverage, 4937,
     /* 1002005 */     GIR_EraseRootFromParent_Done,
     /* 1002006 */   // Label 14897: @1002006
     /* 1002006 */   GIM_Try, /*On fail goto*//*Label 14898*/ GIMT_Encode4(1002083), // Rule ID 4940 //
     /* 1002011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1002022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1002025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1002028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002050 */     // MIs[0] policy
     /* 1002050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002060 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /* 1002063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002082 */     // GIR_Coverage, 4940,
     /* 1002082 */     GIR_EraseRootFromParent_Done,
     /* 1002083 */   // Label 14898: @1002083
     /* 1002083 */   GIM_Try, /*On fail goto*//*Label 14899*/ GIMT_Encode4(1002160), // Rule ID 4941 //
     /* 1002088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1002099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1002102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1002105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002127 */     // MIs[0] policy
     /* 1002127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002137 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /* 1002140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002146 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002159 */     // GIR_Coverage, 4941,
     /* 1002159 */     GIR_EraseRootFromParent_Done,
     /* 1002160 */   // Label 14899: @1002160
     /* 1002160 */   GIM_Try, /*On fail goto*//*Label 14900*/ GIMT_Encode4(1002237), // Rule ID 4944 //
     /* 1002165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1002176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1002179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1002182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002204 */     // MIs[0] policy
     /* 1002204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /* 1002217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002236 */     // GIR_Coverage, 4944,
     /* 1002236 */     GIR_EraseRootFromParent_Done,
     /* 1002237 */   // Label 14900: @1002237
     /* 1002237 */   GIM_Try, /*On fail goto*//*Label 14901*/ GIMT_Encode4(1002314), // Rule ID 4945 //
     /* 1002242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1002253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1002256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1002259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002281 */     // MIs[0] policy
     /* 1002281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002291 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /* 1002294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002300 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002313 */     // GIR_Coverage, 4945,
     /* 1002313 */     GIR_EraseRootFromParent_Done,
     /* 1002314 */   // Label 14901: @1002314
     /* 1002314 */   GIM_Try, /*On fail goto*//*Label 14902*/ GIMT_Encode4(1002391), // Rule ID 4948 //
     /* 1002319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1002330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1002333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1002336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002358 */     // MIs[0] policy
     /* 1002358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002368 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /* 1002371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002390 */     // GIR_Coverage, 4948,
     /* 1002390 */     GIR_EraseRootFromParent_Done,
     /* 1002391 */   // Label 14902: @1002391
     /* 1002391 */   GIM_Try, /*On fail goto*//*Label 14903*/ GIMT_Encode4(1002468), // Rule ID 4949 //
     /* 1002396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1002407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1002410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1002413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002435 */     // MIs[0] policy
     /* 1002435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002445 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /* 1002448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002454 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002467 */     // GIR_Coverage, 4949,
     /* 1002467 */     GIR_EraseRootFromParent_Done,
     /* 1002468 */   // Label 14903: @1002468
     /* 1002468 */   GIM_Try, /*On fail goto*//*Label 14904*/ GIMT_Encode4(1002545), // Rule ID 4952 //
     /* 1002473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1002484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1002487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1002490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002512 */     // MIs[0] policy
     /* 1002512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002522 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /* 1002525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002531 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002544 */     // GIR_Coverage, 4952,
     /* 1002544 */     GIR_EraseRootFromParent_Done,
     /* 1002545 */   // Label 14904: @1002545
     /* 1002545 */   GIM_Try, /*On fail goto*//*Label 14905*/ GIMT_Encode4(1002622), // Rule ID 4953 //
     /* 1002550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1002561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1002564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1002567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002589 */     // MIs[0] policy
     /* 1002589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002599 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /* 1002602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002608 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002621 */     // GIR_Coverage, 4953,
     /* 1002621 */     GIR_EraseRootFromParent_Done,
     /* 1002622 */   // Label 14905: @1002622
     /* 1002622 */   GIM_Try, /*On fail goto*//*Label 14906*/ GIMT_Encode4(1002699), // Rule ID 4956 //
     /* 1002627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1002638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1002641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1002644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002666 */     // MIs[0] policy
     /* 1002666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /* 1002679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002698 */     // GIR_Coverage, 4956,
     /* 1002698 */     GIR_EraseRootFromParent_Done,
     /* 1002699 */   // Label 14906: @1002699
     /* 1002699 */   GIM_Try, /*On fail goto*//*Label 14907*/ GIMT_Encode4(1002776), // Rule ID 4957 //
     /* 1002704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1002715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1002718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1002721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002743 */     // MIs[0] policy
     /* 1002743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002753 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /* 1002756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002762 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002775 */     // GIR_Coverage, 4957,
     /* 1002775 */     GIR_EraseRootFromParent_Done,
     /* 1002776 */   // Label 14907: @1002776
     /* 1002776 */   GIM_Try, /*On fail goto*//*Label 14908*/ GIMT_Encode4(1002853), // Rule ID 4960 //
     /* 1002781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1002792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1002795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1002798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002820 */     // MIs[0] policy
     /* 1002820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002830 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /* 1002833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002852 */     // GIR_Coverage, 4960,
     /* 1002852 */     GIR_EraseRootFromParent_Done,
     /* 1002853 */   // Label 14908: @1002853
     /* 1002853 */   GIM_Try, /*On fail goto*//*Label 14909*/ GIMT_Encode4(1002930), // Rule ID 4961 //
     /* 1002858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1002869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1002872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1002875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002897 */     // MIs[0] policy
     /* 1002897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002907 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /* 1002910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002916 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002929 */     // GIR_Coverage, 4961,
     /* 1002929 */     GIR_EraseRootFromParent_Done,
     /* 1002930 */   // Label 14909: @1002930
     /* 1002930 */   GIM_Try, /*On fail goto*//*Label 14910*/ GIMT_Encode4(1003007), // Rule ID 4964 //
     /* 1002935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1002946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1002949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1002952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1002955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002974 */     // MIs[0] policy
     /* 1002974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002984 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /* 1002987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003006 */     // GIR_Coverage, 4964,
     /* 1003006 */     GIR_EraseRootFromParent_Done,
     /* 1003007 */   // Label 14910: @1003007
     /* 1003007 */   GIM_Try, /*On fail goto*//*Label 14911*/ GIMT_Encode4(1003084), // Rule ID 4965 //
     /* 1003012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1003023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1003026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1003029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1003032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003051 */     // MIs[0] policy
     /* 1003051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003061 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /* 1003064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003070 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003083 */     // GIR_Coverage, 4965,
     /* 1003083 */     GIR_EraseRootFromParent_Done,
     /* 1003084 */   // Label 14911: @1003084
     /* 1003084 */   GIM_Try, /*On fail goto*//*Label 14912*/ GIMT_Encode4(1003161), // Rule ID 4968 //
     /* 1003089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1003106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003128 */     // MIs[0] policy
     /* 1003128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003138 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /* 1003141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003160 */     // GIR_Coverage, 4968,
     /* 1003160 */     GIR_EraseRootFromParent_Done,
     /* 1003161 */   // Label 14912: @1003161
     /* 1003161 */   GIM_Try, /*On fail goto*//*Label 14913*/ GIMT_Encode4(1003238), // Rule ID 4969 //
     /* 1003166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1003183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003205 */     // MIs[0] policy
     /* 1003205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003215 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /* 1003218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003224 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003237 */     // GIR_Coverage, 4969,
     /* 1003237 */     GIR_EraseRootFromParent_Done,
     /* 1003238 */   // Label 14913: @1003238
     /* 1003238 */   GIM_Try, /*On fail goto*//*Label 14914*/ GIMT_Encode4(1003315), // Rule ID 4972 //
     /* 1003243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1003260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003282 */     // MIs[0] policy
     /* 1003282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /* 1003295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003314 */     // GIR_Coverage, 4972,
     /* 1003314 */     GIR_EraseRootFromParent_Done,
     /* 1003315 */   // Label 14914: @1003315
     /* 1003315 */   GIM_Try, /*On fail goto*//*Label 14915*/ GIMT_Encode4(1003392), // Rule ID 4973 //
     /* 1003320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1003337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003359 */     // MIs[0] policy
     /* 1003359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003369 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /* 1003372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003378 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003391 */     // GIR_Coverage, 4973,
     /* 1003391 */     GIR_EraseRootFromParent_Done,
     /* 1003392 */   // Label 14915: @1003392
     /* 1003392 */   GIM_Try, /*On fail goto*//*Label 14916*/ GIMT_Encode4(1003469), // Rule ID 4976 //
     /* 1003397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1003408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1003411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1003414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003436 */     // MIs[0] policy
     /* 1003436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003446 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /* 1003449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003468 */     // GIR_Coverage, 4976,
     /* 1003468 */     GIR_EraseRootFromParent_Done,
     /* 1003469 */   // Label 14916: @1003469
     /* 1003469 */   GIM_Try, /*On fail goto*//*Label 14917*/ GIMT_Encode4(1003546), // Rule ID 4977 //
     /* 1003474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1003485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1003488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1003491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003513 */     // MIs[0] policy
     /* 1003513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003523 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /* 1003526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003545 */     // GIR_Coverage, 4977,
     /* 1003545 */     GIR_EraseRootFromParent_Done,
     /* 1003546 */   // Label 14917: @1003546
     /* 1003546 */   GIM_Try, /*On fail goto*//*Label 14918*/ GIMT_Encode4(1003623), // Rule ID 4980 //
     /* 1003551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1003562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1003565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1003568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003590 */     // MIs[0] policy
     /* 1003590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003600 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /* 1003603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003622 */     // GIR_Coverage, 4980,
     /* 1003622 */     GIR_EraseRootFromParent_Done,
     /* 1003623 */   // Label 14918: @1003623
     /* 1003623 */   GIM_Try, /*On fail goto*//*Label 14919*/ GIMT_Encode4(1003700), // Rule ID 4981 //
     /* 1003628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1003639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1003642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1003645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003667 */     // MIs[0] policy
     /* 1003667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003677 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /* 1003680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003686 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003699 */     // GIR_Coverage, 4981,
     /* 1003699 */     GIR_EraseRootFromParent_Done,
     /* 1003700 */   // Label 14919: @1003700
     /* 1003700 */   GIM_Try, /*On fail goto*//*Label 14920*/ GIMT_Encode4(1003777), // Rule ID 4984 //
     /* 1003705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1003722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003744 */     // MIs[0] policy
     /* 1003744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003754 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /* 1003757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003776 */     // GIR_Coverage, 4984,
     /* 1003776 */     GIR_EraseRootFromParent_Done,
     /* 1003777 */   // Label 14920: @1003777
     /* 1003777 */   GIM_Try, /*On fail goto*//*Label 14921*/ GIMT_Encode4(1003854), // Rule ID 4985 //
     /* 1003782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1003799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003821 */     // MIs[0] policy
     /* 1003821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003831 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /* 1003834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003840 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003853 */     // GIR_Coverage, 4985,
     /* 1003853 */     GIR_EraseRootFromParent_Done,
     /* 1003854 */   // Label 14921: @1003854
     /* 1003854 */   GIM_Try, /*On fail goto*//*Label 14922*/ GIMT_Encode4(1003931), // Rule ID 4988 //
     /* 1003859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1003876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003898 */     // MIs[0] policy
     /* 1003898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /* 1003911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003930 */     // GIR_Coverage, 4988,
     /* 1003930 */     GIR_EraseRootFromParent_Done,
     /* 1003931 */   // Label 14922: @1003931
     /* 1003931 */   GIM_Try, /*On fail goto*//*Label 14923*/ GIMT_Encode4(1004008), // Rule ID 4989 //
     /* 1003936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1003953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003975 */     // MIs[0] policy
     /* 1003975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003985 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /* 1003988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003994 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004007 */     // GIR_Coverage, 4989,
     /* 1004007 */     GIR_EraseRootFromParent_Done,
     /* 1004008 */   // Label 14923: @1004008
     /* 1004008 */   GIM_Try, /*On fail goto*//*Label 14924*/ GIMT_Encode4(1004085), // Rule ID 4992 //
     /* 1004013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1004021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004052 */     // MIs[0] policy
     /* 1004052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004062 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /* 1004065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004084 */     // GIR_Coverage, 4992,
     /* 1004084 */     GIR_EraseRootFromParent_Done,
     /* 1004085 */   // Label 14924: @1004085
     /* 1004085 */   GIM_Try, /*On fail goto*//*Label 14925*/ GIMT_Encode4(1004162), // Rule ID 4993 //
     /* 1004090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1004098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004129 */     // MIs[0] policy
     /* 1004129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004139 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /* 1004142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004148 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004161 */     // GIR_Coverage, 4993,
     /* 1004161 */     GIR_EraseRootFromParent_Done,
     /* 1004162 */   // Label 14925: @1004162
     /* 1004162 */   GIM_Try, /*On fail goto*//*Label 14926*/ GIMT_Encode4(1004239), // Rule ID 4996 //
     /* 1004167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1004175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004206 */     // MIs[0] policy
     /* 1004206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004216 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /* 1004219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004238 */     // GIR_Coverage, 4996,
     /* 1004238 */     GIR_EraseRootFromParent_Done,
     /* 1004239 */   // Label 14926: @1004239
     /* 1004239 */   GIM_Try, /*On fail goto*//*Label 14927*/ GIMT_Encode4(1004316), // Rule ID 4997 //
     /* 1004244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1004252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004283 */     // MIs[0] policy
     /* 1004283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004293 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /* 1004296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004302 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004315 */     // GIR_Coverage, 4997,
     /* 1004315 */     GIR_EraseRootFromParent_Done,
     /* 1004316 */   // Label 14927: @1004316
     /* 1004316 */   GIM_Try, /*On fail goto*//*Label 14928*/ GIMT_Encode4(1004393), // Rule ID 5000 //
     /* 1004321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1004332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1004335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1004338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004360 */     // MIs[0] policy
     /* 1004360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004370 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1004373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004392 */     // GIR_Coverage, 5000,
     /* 1004392 */     GIR_EraseRootFromParent_Done,
     /* 1004393 */   // Label 14928: @1004393
     /* 1004393 */   GIM_Try, /*On fail goto*//*Label 14929*/ GIMT_Encode4(1004470), // Rule ID 5001 //
     /* 1004398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1004409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1004412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1004415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004437 */     // MIs[0] policy
     /* 1004437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004447 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1004450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004456 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004469 */     // GIR_Coverage, 5001,
     /* 1004469 */     GIR_EraseRootFromParent_Done,
     /* 1004470 */   // Label 14929: @1004470
     /* 1004470 */   GIM_Try, /*On fail goto*//*Label 14930*/ GIMT_Encode4(1004547), // Rule ID 5004 //
     /* 1004475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1004486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1004489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004514 */     // MIs[0] policy
     /* 1004514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004524 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1004527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004546 */     // GIR_Coverage, 5004,
     /* 1004546 */     GIR_EraseRootFromParent_Done,
     /* 1004547 */   // Label 14930: @1004547
     /* 1004547 */   GIM_Try, /*On fail goto*//*Label 14931*/ GIMT_Encode4(1004624), // Rule ID 5005 //
     /* 1004552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1004563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1004566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004591 */     // MIs[0] policy
     /* 1004591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004601 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1004604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004610 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004623 */     // GIR_Coverage, 5005,
     /* 1004623 */     GIR_EraseRootFromParent_Done,
     /* 1004624 */   // Label 14931: @1004624
     /* 1004624 */   GIM_Try, /*On fail goto*//*Label 14932*/ GIMT_Encode4(1004701), // Rule ID 5008 //
     /* 1004629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1004640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1004643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004668 */     // MIs[0] policy
     /* 1004668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004678 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1004681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004700 */     // GIR_Coverage, 5008,
     /* 1004700 */     GIR_EraseRootFromParent_Done,
     /* 1004701 */   // Label 14932: @1004701
     /* 1004701 */   GIM_Try, /*On fail goto*//*Label 14933*/ GIMT_Encode4(1004778), // Rule ID 5009 //
     /* 1004706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1004717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1004720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004745 */     // MIs[0] policy
     /* 1004745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004755 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1004758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004764 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004777 */     // GIR_Coverage, 5009,
     /* 1004777 */     GIR_EraseRootFromParent_Done,
     /* 1004778 */   // Label 14933: @1004778
     /* 1004778 */   GIM_Try, /*On fail goto*//*Label 14934*/ GIMT_Encode4(1004855), // Rule ID 5012 //
     /* 1004783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1004794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1004797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004822 */     // MIs[0] policy
     /* 1004822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004832 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1004835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004854 */     // GIR_Coverage, 5012,
     /* 1004854 */     GIR_EraseRootFromParent_Done,
     /* 1004855 */   // Label 14934: @1004855
     /* 1004855 */   GIM_Try, /*On fail goto*//*Label 14935*/ GIMT_Encode4(1004932), // Rule ID 5013 //
     /* 1004860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1004871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1004874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004899 */     // MIs[0] policy
     /* 1004899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1004912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004918 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004931 */     // GIR_Coverage, 5013,
     /* 1004931 */     GIR_EraseRootFromParent_Done,
     /* 1004932 */   // Label 14935: @1004932
     /* 1004932 */   GIM_Try, /*On fail goto*//*Label 14936*/ GIMT_Encode4(1005009), // Rule ID 5016 //
     /* 1004937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1004948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1004951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1004954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1004957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004976 */     // MIs[0] policy
     /* 1004976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004986 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1004989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005008 */     // GIR_Coverage, 5016,
     /* 1005008 */     GIR_EraseRootFromParent_Done,
     /* 1005009 */   // Label 14936: @1005009
     /* 1005009 */   GIM_Try, /*On fail goto*//*Label 14937*/ GIMT_Encode4(1005086), // Rule ID 5017 //
     /* 1005014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1005025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1005028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1005031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1005034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1005041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005053 */     // MIs[0] policy
     /* 1005053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005063 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1005066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005072 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005085 */     // GIR_Coverage, 5017,
     /* 1005085 */     GIR_EraseRootFromParent_Done,
     /* 1005086 */   // Label 14937: @1005086
     /* 1005086 */   GIM_Try, /*On fail goto*//*Label 14938*/ GIMT_Encode4(1005163), // Rule ID 5020 //
     /* 1005091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1005102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1005105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1005108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1005111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005130 */     // MIs[0] policy
     /* 1005130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005140 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1005143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005159 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005162 */     // GIR_Coverage, 5020,
     /* 1005162 */     GIR_EraseRootFromParent_Done,
     /* 1005163 */   // Label 14938: @1005163
     /* 1005163 */   GIM_Try, /*On fail goto*//*Label 14939*/ GIMT_Encode4(1005240), // Rule ID 5021 //
     /* 1005168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1005179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1005182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1005185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1005188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005207 */     // MIs[0] policy
     /* 1005207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005217 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1005220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005226 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005239 */     // GIR_Coverage, 5021,
     /* 1005239 */     GIR_EraseRootFromParent_Done,
     /* 1005240 */   // Label 14939: @1005240
     /* 1005240 */   GIM_Try, /*On fail goto*//*Label 14940*/ GIMT_Encode4(1005317), // Rule ID 5024 //
     /* 1005245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1005256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1005259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1005262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1005265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005284 */     // MIs[0] policy
     /* 1005284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1005297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005316 */     // GIR_Coverage, 5024,
     /* 1005316 */     GIR_EraseRootFromParent_Done,
     /* 1005317 */   // Label 14940: @1005317
     /* 1005317 */   GIM_Try, /*On fail goto*//*Label 14941*/ GIMT_Encode4(1005394), // Rule ID 5025 //
     /* 1005322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1005333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1005336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1005339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1005342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005361 */     // MIs[0] policy
     /* 1005361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005371 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1005374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005393 */     // GIR_Coverage, 5025,
     /* 1005393 */     GIR_EraseRootFromParent_Done,
     /* 1005394 */   // Label 14941: @1005394
     /* 1005394 */   GIM_Try, /*On fail goto*//*Label 14942*/ GIMT_Encode4(1005471), // Rule ID 5028 //
     /* 1005399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1005410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1005413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1005416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1005419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005438 */     // MIs[0] policy
     /* 1005438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1005451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005470 */     // GIR_Coverage, 5028,
     /* 1005470 */     GIR_EraseRootFromParent_Done,
     /* 1005471 */   // Label 14942: @1005471
     /* 1005471 */   GIM_Try, /*On fail goto*//*Label 14943*/ GIMT_Encode4(1005548), // Rule ID 5029 //
     /* 1005476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1005487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1005490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1005493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1005496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005515 */     // MIs[0] policy
     /* 1005515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005525 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1005528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005534 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005547 */     // GIR_Coverage, 5029,
     /* 1005547 */     GIR_EraseRootFromParent_Done,
     /* 1005548 */   // Label 14943: @1005548
     /* 1005548 */   GIM_Try, /*On fail goto*//*Label 14944*/ GIMT_Encode4(1005625), // Rule ID 5032 //
     /* 1005553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1005564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1005567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1005570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1005573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1005580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005592 */     // MIs[0] policy
     /* 1005592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005602 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1005605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005624 */     // GIR_Coverage, 5032,
     /* 1005624 */     GIR_EraseRootFromParent_Done,
     /* 1005625 */   // Label 14944: @1005625
     /* 1005625 */   GIM_Try, /*On fail goto*//*Label 14945*/ GIMT_Encode4(1005702), // Rule ID 5033 //
     /* 1005630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1005641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1005644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1005647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1005650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1005657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005669 */     // MIs[0] policy
     /* 1005669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1005682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005688 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005701 */     // GIR_Coverage, 5033,
     /* 1005701 */     GIR_EraseRootFromParent_Done,
     /* 1005702 */   // Label 14945: @1005702
     /* 1005702 */   GIM_Try, /*On fail goto*//*Label 14946*/ GIMT_Encode4(1005779), // Rule ID 5036 //
     /* 1005707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1005718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1005721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1005724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1005727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1005734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005746 */     // MIs[0] policy
     /* 1005746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005756 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1005759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005778 */     // GIR_Coverage, 5036,
     /* 1005778 */     GIR_EraseRootFromParent_Done,
     /* 1005779 */   // Label 14946: @1005779
     /* 1005779 */   GIM_Try, /*On fail goto*//*Label 14947*/ GIMT_Encode4(1005856), // Rule ID 5037 //
     /* 1005784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1005795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1005798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1005801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1005804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1005811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005823 */     // MIs[0] policy
     /* 1005823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005833 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1005836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005842 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005855 */     // GIR_Coverage, 5037,
     /* 1005855 */     GIR_EraseRootFromParent_Done,
     /* 1005856 */   // Label 14947: @1005856
     /* 1005856 */   GIM_Try, /*On fail goto*//*Label 14948*/ GIMT_Encode4(1005933), // Rule ID 5040 //
     /* 1005861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1005872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1005875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1005878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1005881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005900 */     // MIs[0] policy
     /* 1005900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005910 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1005913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005932 */     // GIR_Coverage, 5040,
     /* 1005932 */     GIR_EraseRootFromParent_Done,
     /* 1005933 */   // Label 14948: @1005933
     /* 1005933 */   GIM_Try, /*On fail goto*//*Label 14949*/ GIMT_Encode4(1006010), // Rule ID 5041 //
     /* 1005938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1005949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1005952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1005955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1005958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005977 */     // MIs[0] policy
     /* 1005977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005987 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1005990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005996 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006009 */     // GIR_Coverage, 5041,
     /* 1006009 */     GIR_EraseRootFromParent_Done,
     /* 1006010 */   // Label 14949: @1006010
     /* 1006010 */   GIM_Try, /*On fail goto*//*Label 14950*/ GIMT_Encode4(1006087), // Rule ID 5044 //
     /* 1006015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1006018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1006026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1006029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1006032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1006035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006054 */     // MIs[0] policy
     /* 1006054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006064 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1006067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006086 */     // GIR_Coverage, 5044,
     /* 1006086 */     GIR_EraseRootFromParent_Done,
     /* 1006087 */   // Label 14950: @1006087
     /* 1006087 */   GIM_Try, /*On fail goto*//*Label 14951*/ GIMT_Encode4(1006164), // Rule ID 5045 //
     /* 1006092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1006095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1006103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1006106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1006109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1006112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006131 */     // MIs[0] policy
     /* 1006131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006141 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1006144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006150 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006163 */     // GIR_Coverage, 5045,
     /* 1006163 */     GIR_EraseRootFromParent_Done,
     /* 1006164 */   // Label 14951: @1006164
     /* 1006164 */   GIM_Try, /*On fail goto*//*Label 14952*/ GIMT_Encode4(1006241), // Rule ID 5048 //
     /* 1006169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1006172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1006180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1006183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1006186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1006189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1006196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006208 */     // MIs[0] policy
     /* 1006208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1006221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006240 */     // GIR_Coverage, 5048,
     /* 1006240 */     GIR_EraseRootFromParent_Done,
     /* 1006241 */   // Label 14952: @1006241
     /* 1006241 */   GIM_Try, /*On fail goto*//*Label 14953*/ GIMT_Encode4(1006318), // Rule ID 5049 //
     /* 1006246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1006249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1006257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1006260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1006263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1006266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1006273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006285 */     // MIs[0] policy
     /* 1006285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006295 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1006298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006304 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006317 */     // GIR_Coverage, 5049,
     /* 1006317 */     GIR_EraseRootFromParent_Done,
     /* 1006318 */   // Label 14953: @1006318
     /* 1006318 */   GIM_Try, /*On fail goto*//*Label 14954*/ GIMT_Encode4(1006395), // Rule ID 5052 //
     /* 1006323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1006326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1006334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1006337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1006340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1006343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1006350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006362 */     // MIs[0] policy
     /* 1006362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006372 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1006375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006394 */     // GIR_Coverage, 5052,
     /* 1006394 */     GIR_EraseRootFromParent_Done,
     /* 1006395 */   // Label 14954: @1006395
     /* 1006395 */   GIM_Try, /*On fail goto*//*Label 14955*/ GIMT_Encode4(1006472), // Rule ID 5053 //
     /* 1006400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1006403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1006411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1006414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1006417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1006420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1006427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006439 */     // MIs[0] policy
     /* 1006439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006449 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1006452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006458 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006471 */     // GIR_Coverage, 5053,
     /* 1006471 */     GIR_EraseRootFromParent_Done,
     /* 1006472 */   // Label 14955: @1006472
     /* 1006472 */   GIM_Try, /*On fail goto*//*Label 14956*/ GIMT_Encode4(1006549), // Rule ID 5056 //
     /* 1006477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1006480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1006488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1006491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1006494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1006497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1006504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006516 */     // MIs[0] policy
     /* 1006516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006526 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1006529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006548 */     // GIR_Coverage, 5056,
     /* 1006548 */     GIR_EraseRootFromParent_Done,
     /* 1006549 */   // Label 14956: @1006549
     /* 1006549 */   GIM_Try, /*On fail goto*//*Label 14957*/ GIMT_Encode4(1006626), // Rule ID 5057 //
     /* 1006554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1006557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1006565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1006568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1006571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1006574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1006581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006593 */     // MIs[0] policy
     /* 1006593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006603 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1006606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006612 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006625 */     // GIR_Coverage, 5057,
     /* 1006625 */     GIR_EraseRootFromParent_Done,
     /* 1006626 */   // Label 14957: @1006626
     /* 1006626 */   GIM_Try, /*On fail goto*//*Label 14958*/ GIMT_Encode4(1006703), // Rule ID 5060 //
     /* 1006631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1006642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1006645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1006648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1006651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006670 */     // MIs[0] policy
     /* 1006670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006680 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1006683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006702 */     // GIR_Coverage, 5060,
     /* 1006702 */     GIR_EraseRootFromParent_Done,
     /* 1006703 */   // Label 14958: @1006703
     /* 1006703 */   GIM_Try, /*On fail goto*//*Label 14959*/ GIMT_Encode4(1006780), // Rule ID 5061 //
     /* 1006708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1006719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1006722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1006725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1006728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006747 */     // MIs[0] policy
     /* 1006747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006757 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1006760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006766 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006779 */     // GIR_Coverage, 5061,
     /* 1006779 */     GIR_EraseRootFromParent_Done,
     /* 1006780 */   // Label 14959: @1006780
     /* 1006780 */   GIM_Try, /*On fail goto*//*Label 14960*/ GIMT_Encode4(1006857), // Rule ID 5064 //
     /* 1006785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1006796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1006799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1006802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1006805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006824 */     // MIs[0] policy
     /* 1006824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1006837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006856 */     // GIR_Coverage, 5064,
     /* 1006856 */     GIR_EraseRootFromParent_Done,
     /* 1006857 */   // Label 14960: @1006857
     /* 1006857 */   GIM_Try, /*On fail goto*//*Label 14961*/ GIMT_Encode4(1006934), // Rule ID 5065 //
     /* 1006862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1006873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1006876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1006879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1006882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006901 */     // MIs[0] policy
     /* 1006901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006911 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1006914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006920 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006933 */     // GIR_Coverage, 5065,
     /* 1006933 */     GIR_EraseRootFromParent_Done,
     /* 1006934 */   // Label 14961: @1006934
     /* 1006934 */   GIM_Try, /*On fail goto*//*Label 14962*/ GIMT_Encode4(1007011), // Rule ID 5068 //
     /* 1006939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1006950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1006953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1006956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1006959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1006966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006978 */     // MIs[0] policy
     /* 1006978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006988 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1006991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007010 */     // GIR_Coverage, 5068,
     /* 1007010 */     GIR_EraseRootFromParent_Done,
     /* 1007011 */   // Label 14962: @1007011
     /* 1007011 */   GIM_Try, /*On fail goto*//*Label 14963*/ GIMT_Encode4(1007088), // Rule ID 5069 //
     /* 1007016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1007027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1007030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1007033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1007036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1007043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007055 */     // MIs[0] policy
     /* 1007055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007065 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1007068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007074 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007087 */     // GIR_Coverage, 5069,
     /* 1007087 */     GIR_EraseRootFromParent_Done,
     /* 1007088 */   // Label 14963: @1007088
     /* 1007088 */   GIM_Try, /*On fail goto*//*Label 14964*/ GIMT_Encode4(1007165), // Rule ID 5072 //
     /* 1007093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1007104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1007107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1007110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1007113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1007120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007132 */     // MIs[0] policy
     /* 1007132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007142 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1007145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007164 */     // GIR_Coverage, 5072,
     /* 1007164 */     GIR_EraseRootFromParent_Done,
     /* 1007165 */   // Label 14964: @1007165
     /* 1007165 */   GIM_Try, /*On fail goto*//*Label 14965*/ GIMT_Encode4(1007242), // Rule ID 5073 //
     /* 1007170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1007181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1007184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1007187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1007190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1007197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007209 */     // MIs[0] policy
     /* 1007209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007219 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1007222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007228 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007241 */     // GIR_Coverage, 5073,
     /* 1007241 */     GIR_EraseRootFromParent_Done,
     /* 1007242 */   // Label 14965: @1007242
     /* 1007242 */   GIM_Try, /*On fail goto*//*Label 14966*/ GIMT_Encode4(1007319), // Rule ID 5076 //
     /* 1007247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1007258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1007261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1007264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1007267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1007274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007286 */     // MIs[0] policy
     /* 1007286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007296 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1007299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007318 */     // GIR_Coverage, 5076,
     /* 1007318 */     GIR_EraseRootFromParent_Done,
     /* 1007319 */   // Label 14966: @1007319
     /* 1007319 */   GIM_Try, /*On fail goto*//*Label 14967*/ GIMT_Encode4(1007396), // Rule ID 5077 //
     /* 1007324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1007335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1007338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1007341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1007344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1007351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007363 */     // MIs[0] policy
     /* 1007363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007373 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1007376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007382 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007395 */     // GIR_Coverage, 5077,
     /* 1007395 */     GIR_EraseRootFromParent_Done,
     /* 1007396 */   // Label 14967: @1007396
     /* 1007396 */   GIM_Try, /*On fail goto*//*Label 14968*/ GIMT_Encode4(1007473), // Rule ID 5080 //
     /* 1007401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1007404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1007412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1007415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1007418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1007421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1007428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007440 */     // MIs[0] policy
     /* 1007440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007450 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1007453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007472 */     // GIR_Coverage, 5080,
     /* 1007472 */     GIR_EraseRootFromParent_Done,
     /* 1007473 */   // Label 14968: @1007473
     /* 1007473 */   GIM_Try, /*On fail goto*//*Label 14969*/ GIMT_Encode4(1007550), // Rule ID 5081 //
     /* 1007478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1007481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1007489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1007492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1007495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1007498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1007505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007517 */     // MIs[0] policy
     /* 1007517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007527 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1007530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007549 */     // GIR_Coverage, 5081,
     /* 1007549 */     GIR_EraseRootFromParent_Done,
     /* 1007550 */   // Label 14969: @1007550
     /* 1007550 */   GIM_Try, /*On fail goto*//*Label 14970*/ GIMT_Encode4(1007627), // Rule ID 5084 //
     /* 1007555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1007558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1007566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1007569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1007572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1007575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1007582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007594 */     // MIs[0] policy
     /* 1007594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007604 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1007607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007626 */     // GIR_Coverage, 5084,
     /* 1007626 */     GIR_EraseRootFromParent_Done,
     /* 1007627 */   // Label 14970: @1007627
     /* 1007627 */   GIM_Try, /*On fail goto*//*Label 14971*/ GIMT_Encode4(1007704), // Rule ID 5085 //
     /* 1007632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1007635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1007643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1007646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1007649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1007652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1007659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007671 */     // MIs[0] policy
     /* 1007671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1007684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007690 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007703 */     // GIR_Coverage, 5085,
     /* 1007703 */     GIR_EraseRootFromParent_Done,
     /* 1007704 */   // Label 14971: @1007704
     /* 1007704 */   GIM_Try, /*On fail goto*//*Label 14972*/ GIMT_Encode4(1007781), // Rule ID 5088 //
     /* 1007709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1007712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1007720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1007723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1007726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1007729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1007736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007748 */     // MIs[0] policy
     /* 1007748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007758 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1007761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007777 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007780 */     // GIR_Coverage, 5088,
     /* 1007780 */     GIR_EraseRootFromParent_Done,
     /* 1007781 */   // Label 14972: @1007781
     /* 1007781 */   GIM_Try, /*On fail goto*//*Label 14973*/ GIMT_Encode4(1007858), // Rule ID 5089 //
     /* 1007786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1007789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1007797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1007800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1007803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1007806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1007813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007825 */     // MIs[0] policy
     /* 1007825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007835 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1007838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007857 */     // GIR_Coverage, 5089,
     /* 1007857 */     GIR_EraseRootFromParent_Done,
     /* 1007858 */   // Label 14973: @1007858
     /* 1007858 */   GIM_Try, /*On fail goto*//*Label 14974*/ GIMT_Encode4(1007935), // Rule ID 5092 //
     /* 1007863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1007866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1007874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1007877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1007880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1007883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1007890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007902 */     // MIs[0] policy
     /* 1007902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007912 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1007915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007934 */     // GIR_Coverage, 5092,
     /* 1007934 */     GIR_EraseRootFromParent_Done,
     /* 1007935 */   // Label 14974: @1007935
     /* 1007935 */   GIM_Try, /*On fail goto*//*Label 14975*/ GIMT_Encode4(1008012), // Rule ID 5093 //
     /* 1007940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1007943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1007951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1007954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1007957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1007960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1007967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007979 */     // MIs[0] policy
     /* 1007979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007989 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1007992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007998 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008011 */     // GIR_Coverage, 5093,
     /* 1008011 */     GIR_EraseRootFromParent_Done,
     /* 1008012 */   // Label 14975: @1008012
     /* 1008012 */   GIM_Try, /*On fail goto*//*Label 14976*/ GIMT_Encode4(1008089), // Rule ID 5096 //
     /* 1008017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1008020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1008028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1008031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1008034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1008037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1008044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008056 */     // MIs[0] policy
     /* 1008056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008066 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1008069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008088 */     // GIR_Coverage, 5096,
     /* 1008088 */     GIR_EraseRootFromParent_Done,
     /* 1008089 */   // Label 14976: @1008089
     /* 1008089 */   GIM_Try, /*On fail goto*//*Label 14977*/ GIMT_Encode4(1008166), // Rule ID 5097 //
     /* 1008094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1008097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1008105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1008108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1008111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1008114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1008121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008133 */     // MIs[0] policy
     /* 1008133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008143 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1008146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008152 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008165 */     // GIR_Coverage, 5097,
     /* 1008165 */     GIR_EraseRootFromParent_Done,
     /* 1008166 */   // Label 14977: @1008166
     /* 1008166 */   GIM_Try, /*On fail goto*//*Label 14978*/ GIMT_Encode4(1008243), // Rule ID 5100 //
     /* 1008171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1008174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1008182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1008185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1008188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1008191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1008198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008210 */     // MIs[0] policy
     /* 1008210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008220 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1008223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008239 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008242 */     // GIR_Coverage, 5100,
     /* 1008242 */     GIR_EraseRootFromParent_Done,
     /* 1008243 */   // Label 14978: @1008243
     /* 1008243 */   GIM_Try, /*On fail goto*//*Label 14979*/ GIMT_Encode4(1008320), // Rule ID 5101 //
     /* 1008248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1008251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1008259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1008262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1008265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1008268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1008275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008287 */     // MIs[0] policy
     /* 1008287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008297 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1008300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008306 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008319 */     // GIR_Coverage, 5101,
     /* 1008319 */     GIR_EraseRootFromParent_Done,
     /* 1008320 */   // Label 14979: @1008320
     /* 1008320 */   GIM_Try, /*On fail goto*//*Label 14980*/ GIMT_Encode4(1008397), // Rule ID 5104 //
     /* 1008325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1008328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1008336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1008339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1008342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1008345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1008352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008364 */     // MIs[0] policy
     /* 1008364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008374 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1008377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008396 */     // GIR_Coverage, 5104,
     /* 1008396 */     GIR_EraseRootFromParent_Done,
     /* 1008397 */   // Label 14980: @1008397
     /* 1008397 */   GIM_Try, /*On fail goto*//*Label 14981*/ GIMT_Encode4(1008474), // Rule ID 5105 //
     /* 1008402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1008405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1008413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1008416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1008419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1008422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1008429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008441 */     // MIs[0] policy
     /* 1008441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008451 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1008454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008473 */     // GIR_Coverage, 5105,
     /* 1008473 */     GIR_EraseRootFromParent_Done,
     /* 1008474 */   // Label 14981: @1008474
     /* 1008474 */   GIM_Try, /*On fail goto*//*Label 14982*/ GIMT_Encode4(1008551), // Rule ID 5108 //
     /* 1008479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1008482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1008490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1008493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1008496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1008499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1008506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008518 */     // MIs[0] policy
     /* 1008518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008528 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1008531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008550 */     // GIR_Coverage, 5108,
     /* 1008550 */     GIR_EraseRootFromParent_Done,
     /* 1008551 */   // Label 14982: @1008551
     /* 1008551 */   GIM_Try, /*On fail goto*//*Label 14983*/ GIMT_Encode4(1008628), // Rule ID 5109 //
     /* 1008556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1008559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1008567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1008570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1008573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1008576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1008583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008595 */     // MIs[0] policy
     /* 1008595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008605 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1008608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008614 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008627 */     // GIR_Coverage, 5109,
     /* 1008627 */     GIR_EraseRootFromParent_Done,
     /* 1008628 */   // Label 14983: @1008628
     /* 1008628 */   GIM_Try, /*On fail goto*//*Label 14984*/ GIMT_Encode4(1008705), // Rule ID 12720 //
     /* 1008633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1008644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1008647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1008650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1008653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008672 */     // MIs[0] policy
     /* 1008672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1008685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008704 */     // GIR_Coverage, 12720,
     /* 1008704 */     GIR_EraseRootFromParent_Done,
     /* 1008705 */   // Label 14984: @1008705
     /* 1008705 */   GIM_Try, /*On fail goto*//*Label 14985*/ GIMT_Encode4(1008782), // Rule ID 12721 //
     /* 1008710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1008721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1008724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1008727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1008730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008749 */     // MIs[0] policy
     /* 1008749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008759 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1008762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008781 */     // GIR_Coverage, 12721,
     /* 1008781 */     GIR_EraseRootFromParent_Done,
     /* 1008782 */   // Label 14985: @1008782
     /* 1008782 */   GIM_Try, /*On fail goto*//*Label 14986*/ GIMT_Encode4(1008859), // Rule ID 12724 //
     /* 1008787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1008798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1008801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1008804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1008807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008826 */     // MIs[0] policy
     /* 1008826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008836 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1008839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008858 */     // GIR_Coverage, 12724,
     /* 1008858 */     GIR_EraseRootFromParent_Done,
     /* 1008859 */   // Label 14986: @1008859
     /* 1008859 */   GIM_Try, /*On fail goto*//*Label 14987*/ GIMT_Encode4(1008936), // Rule ID 12725 //
     /* 1008864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1008875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1008878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1008881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1008884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008903 */     // MIs[0] policy
     /* 1008903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008913 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1008916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008935 */     // GIR_Coverage, 12725,
     /* 1008935 */     GIR_EraseRootFromParent_Done,
     /* 1008936 */   // Label 14987: @1008936
     /* 1008936 */   GIM_Try, /*On fail goto*//*Label 14988*/ GIMT_Encode4(1009013), // Rule ID 12728 //
     /* 1008941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1008952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1008955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1008958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1008961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008980 */     // MIs[0] policy
     /* 1008980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008990 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1008993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009012 */     // GIR_Coverage, 12728,
     /* 1009012 */     GIR_EraseRootFromParent_Done,
     /* 1009013 */   // Label 14988: @1009013
     /* 1009013 */   GIM_Try, /*On fail goto*//*Label 14989*/ GIMT_Encode4(1009090), // Rule ID 12729 //
     /* 1009018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1009029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1009032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1009035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1009038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009057 */     // MIs[0] policy
     /* 1009057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009067 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1009070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009089 */     // GIR_Coverage, 12729,
     /* 1009089 */     GIR_EraseRootFromParent_Done,
     /* 1009090 */   // Label 14989: @1009090
     /* 1009090 */   GIM_Try, /*On fail goto*//*Label 14990*/ GIMT_Encode4(1009167), // Rule ID 12732 //
     /* 1009095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1009106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1009109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1009112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1009115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009134 */     // MIs[0] policy
     /* 1009134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1009147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009166 */     // GIR_Coverage, 12732,
     /* 1009166 */     GIR_EraseRootFromParent_Done,
     /* 1009167 */   // Label 14990: @1009167
     /* 1009167 */   GIM_Try, /*On fail goto*//*Label 14991*/ GIMT_Encode4(1009244), // Rule ID 12733 //
     /* 1009172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1009183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1009186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1009189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1009192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009211 */     // MIs[0] policy
     /* 1009211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009221 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1009224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009243 */     // GIR_Coverage, 12733,
     /* 1009243 */     GIR_EraseRootFromParent_Done,
     /* 1009244 */   // Label 14991: @1009244
     /* 1009244 */   GIM_Try, /*On fail goto*//*Label 14992*/ GIMT_Encode4(1009321), // Rule ID 12736 //
     /* 1009249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1009260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1009263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1009266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1009269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009288 */     // MIs[0] policy
     /* 1009288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009298 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1009301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009320 */     // GIR_Coverage, 12736,
     /* 1009320 */     GIR_EraseRootFromParent_Done,
     /* 1009321 */   // Label 14992: @1009321
     /* 1009321 */   GIM_Try, /*On fail goto*//*Label 14993*/ GIMT_Encode4(1009398), // Rule ID 12737 //
     /* 1009326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1009337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1009340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1009343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1009346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009365 */     // MIs[0] policy
     /* 1009365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009375 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1009378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009397 */     // GIR_Coverage, 12737,
     /* 1009397 */     GIR_EraseRootFromParent_Done,
     /* 1009398 */   // Label 14993: @1009398
     /* 1009398 */   GIM_Try, /*On fail goto*//*Label 14994*/ GIMT_Encode4(1009475), // Rule ID 12740 //
     /* 1009403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1009414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1009417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1009420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1009423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009442 */     // MIs[0] policy
     /* 1009442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009474 */     // GIR_Coverage, 12740,
     /* 1009474 */     GIR_EraseRootFromParent_Done,
     /* 1009475 */   // Label 14994: @1009475
     /* 1009475 */   GIM_Try, /*On fail goto*//*Label 14995*/ GIMT_Encode4(1009552), // Rule ID 12741 //
     /* 1009480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1009491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1009494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1009497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1009500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009519 */     // MIs[0] policy
     /* 1009519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009529 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009551 */     // GIR_Coverage, 12741,
     /* 1009551 */     GIR_EraseRootFromParent_Done,
     /* 1009552 */   // Label 14995: @1009552
     /* 1009552 */   GIM_Try, /*On fail goto*//*Label 14996*/ GIMT_Encode4(1009629), // Rule ID 12744 //
     /* 1009557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1009568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1009571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1009574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1009577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009596 */     // MIs[0] policy
     /* 1009596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009606 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009628 */     // GIR_Coverage, 12744,
     /* 1009628 */     GIR_EraseRootFromParent_Done,
     /* 1009629 */   // Label 14996: @1009629
     /* 1009629 */   GIM_Try, /*On fail goto*//*Label 14997*/ GIMT_Encode4(1009706), // Rule ID 12745 //
     /* 1009634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1009645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1009648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1009651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1009654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009673 */     // MIs[0] policy
     /* 1009673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009683 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009705 */     // GIR_Coverage, 12745,
     /* 1009705 */     GIR_EraseRootFromParent_Done,
     /* 1009706 */   // Label 14997: @1009706
     /* 1009706 */   GIM_Try, /*On fail goto*//*Label 14998*/ GIMT_Encode4(1009783), // Rule ID 12748 //
     /* 1009711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1009722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1009725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1009728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1009731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009750 */     // MIs[0] policy
     /* 1009750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009760 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009782 */     // GIR_Coverage, 12748,
     /* 1009782 */     GIR_EraseRootFromParent_Done,
     /* 1009783 */   // Label 14998: @1009783
     /* 1009783 */   GIM_Try, /*On fail goto*//*Label 14999*/ GIMT_Encode4(1009860), // Rule ID 12749 //
     /* 1009788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1009799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1009802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1009805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1009808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009827 */     // MIs[0] policy
     /* 1009827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009837 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009859 */     // GIR_Coverage, 12749,
     /* 1009859 */     GIR_EraseRootFromParent_Done,
     /* 1009860 */   // Label 14999: @1009860
     /* 1009860 */   GIM_Try, /*On fail goto*//*Label 15000*/ GIMT_Encode4(1009937), // Rule ID 12752 //
     /* 1009865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1009868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1009876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1009879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1009882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1009885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009904 */     // MIs[0] policy
     /* 1009904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009914 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1009933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009936 */     // GIR_Coverage, 12752,
     /* 1009936 */     GIR_EraseRootFromParent_Done,
     /* 1009937 */   // Label 15000: @1009937
     /* 1009937 */   GIM_Try, /*On fail goto*//*Label 15001*/ GIMT_Encode4(1010014), // Rule ID 12753 //
     /* 1009942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1009945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1009953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1009956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1009959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1009962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009981 */     // MIs[0] policy
     /* 1009981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009991 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1010010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010013 */     // GIR_Coverage, 12753,
     /* 1010013 */     GIR_EraseRootFromParent_Done,
     /* 1010014 */   // Label 15001: @1010014
     /* 1010014 */   GIM_Try, /*On fail goto*//*Label 15002*/ GIMT_Encode4(1010091), // Rule ID 12756 //
     /* 1010019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1010030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1010033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1010036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1010039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010058 */     // MIs[0] policy
     /* 1010058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010068 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1010071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010090 */     // GIR_Coverage, 12756,
     /* 1010090 */     GIR_EraseRootFromParent_Done,
     /* 1010091 */   // Label 15002: @1010091
     /* 1010091 */   GIM_Try, /*On fail goto*//*Label 15003*/ GIMT_Encode4(1010168), // Rule ID 12757 //
     /* 1010096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1010107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1010110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1010113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1010116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010135 */     // MIs[0] policy
     /* 1010135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010145 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1010148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010167 */     // GIR_Coverage, 12757,
     /* 1010167 */     GIR_EraseRootFromParent_Done,
     /* 1010168 */   // Label 15003: @1010168
     /* 1010168 */   GIM_Try, /*On fail goto*//*Label 15004*/ GIMT_Encode4(1010245), // Rule ID 12760 //
     /* 1010173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1010184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1010187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1010190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1010193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010212 */     // MIs[0] policy
     /* 1010212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010222 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1010225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010244 */     // GIR_Coverage, 12760,
     /* 1010244 */     GIR_EraseRootFromParent_Done,
     /* 1010245 */   // Label 15004: @1010245
     /* 1010245 */   GIM_Try, /*On fail goto*//*Label 15005*/ GIMT_Encode4(1010322), // Rule ID 12761 //
     /* 1010250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1010261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1010264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1010267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1010270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010289 */     // MIs[0] policy
     /* 1010289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010299 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1010302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010321 */     // GIR_Coverage, 12761,
     /* 1010321 */     GIR_EraseRootFromParent_Done,
     /* 1010322 */   // Label 15005: @1010322
     /* 1010322 */   GIM_Try, /*On fail goto*//*Label 15006*/ GIMT_Encode4(1010399), // Rule ID 12764 //
     /* 1010327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1010338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1010341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1010344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1010347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010366 */     // MIs[0] policy
     /* 1010366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010376 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1010379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010398 */     // GIR_Coverage, 12764,
     /* 1010398 */     GIR_EraseRootFromParent_Done,
     /* 1010399 */   // Label 15006: @1010399
     /* 1010399 */   GIM_Try, /*On fail goto*//*Label 15007*/ GIMT_Encode4(1010476), // Rule ID 12765 //
     /* 1010404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1010415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1010418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1010421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1010424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010443 */     // MIs[0] policy
     /* 1010443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010453 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1010456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010475 */     // GIR_Coverage, 12765,
     /* 1010475 */     GIR_EraseRootFromParent_Done,
     /* 1010476 */   // Label 15007: @1010476
     /* 1010476 */   GIM_Try, /*On fail goto*//*Label 15008*/ GIMT_Encode4(1010553), // Rule ID 12768 //
     /* 1010481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1010492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1010495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1010498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1010501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010520 */     // MIs[0] policy
     /* 1010520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010530 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1010533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010552 */     // GIR_Coverage, 12768,
     /* 1010552 */     GIR_EraseRootFromParent_Done,
     /* 1010553 */   // Label 15008: @1010553
     /* 1010553 */   GIM_Try, /*On fail goto*//*Label 15009*/ GIMT_Encode4(1010630), // Rule ID 12769 //
     /* 1010558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1010569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1010572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1010575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1010578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010597 */     // MIs[0] policy
     /* 1010597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010607 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1010610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010629 */     // GIR_Coverage, 12769,
     /* 1010629 */     GIR_EraseRootFromParent_Done,
     /* 1010630 */   // Label 15009: @1010630
     /* 1010630 */   GIM_Try, /*On fail goto*//*Label 15010*/ GIMT_Encode4(1010707), // Rule ID 12772 //
     /* 1010635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1010646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1010649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1010652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1010655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010674 */     // MIs[0] policy
     /* 1010674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010684 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1010687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010706 */     // GIR_Coverage, 12772,
     /* 1010706 */     GIR_EraseRootFromParent_Done,
     /* 1010707 */   // Label 15010: @1010707
     /* 1010707 */   GIM_Try, /*On fail goto*//*Label 15011*/ GIMT_Encode4(1010784), // Rule ID 12773 //
     /* 1010712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1010723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1010726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1010729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1010732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010751 */     // MIs[0] policy
     /* 1010751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010761 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1010764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010783 */     // GIR_Coverage, 12773,
     /* 1010783 */     GIR_EraseRootFromParent_Done,
     /* 1010784 */   // Label 15011: @1010784
     /* 1010784 */   GIM_Try, /*On fail goto*//*Label 15012*/ GIMT_Encode4(1010861), // Rule ID 12776 //
     /* 1010789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1010800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1010803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1010806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1010809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010828 */     // MIs[0] policy
     /* 1010828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010838 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1010841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010860 */     // GIR_Coverage, 12776,
     /* 1010860 */     GIR_EraseRootFromParent_Done,
     /* 1010861 */   // Label 15012: @1010861
     /* 1010861 */   GIM_Try, /*On fail goto*//*Label 15013*/ GIMT_Encode4(1010938), // Rule ID 12777 //
     /* 1010866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1010877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1010880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1010883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1010886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010905 */     // MIs[0] policy
     /* 1010905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010915 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1010918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010937 */     // GIR_Coverage, 12777,
     /* 1010937 */     GIR_EraseRootFromParent_Done,
     /* 1010938 */   // Label 15013: @1010938
     /* 1010938 */   GIM_Try, /*On fail goto*//*Label 15014*/ GIMT_Encode4(1011015), // Rule ID 12780 //
     /* 1010943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1010954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1010957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1010960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1010963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010982 */     // MIs[0] policy
     /* 1010982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1010995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011014 */     // GIR_Coverage, 12780,
     /* 1011014 */     GIR_EraseRootFromParent_Done,
     /* 1011015 */   // Label 15014: @1011015
     /* 1011015 */   GIM_Try, /*On fail goto*//*Label 15015*/ GIMT_Encode4(1011092), // Rule ID 12781 //
     /* 1011020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1011031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1011034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1011037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1011040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011059 */     // MIs[0] policy
     /* 1011059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011069 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1011072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011091 */     // GIR_Coverage, 12781,
     /* 1011091 */     GIR_EraseRootFromParent_Done,
     /* 1011092 */   // Label 15015: @1011092
     /* 1011092 */   GIM_Try, /*On fail goto*//*Label 15016*/ GIMT_Encode4(1011169), // Rule ID 12784 //
     /* 1011097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1011108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1011111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1011114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1011117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011136 */     // MIs[0] policy
     /* 1011136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1011149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011168 */     // GIR_Coverage, 12784,
     /* 1011168 */     GIR_EraseRootFromParent_Done,
     /* 1011169 */   // Label 15016: @1011169
     /* 1011169 */   GIM_Try, /*On fail goto*//*Label 15017*/ GIMT_Encode4(1011246), // Rule ID 12785 //
     /* 1011174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1011185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1011188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1011191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1011194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011213 */     // MIs[0] policy
     /* 1011213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011223 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1011226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011245 */     // GIR_Coverage, 12785,
     /* 1011245 */     GIR_EraseRootFromParent_Done,
     /* 1011246 */   // Label 15017: @1011246
     /* 1011246 */   GIM_Try, /*On fail goto*//*Label 15018*/ GIMT_Encode4(1011323), // Rule ID 12788 //
     /* 1011251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1011262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1011265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1011268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1011271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011290 */     // MIs[0] policy
     /* 1011290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011300 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1011303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011322 */     // GIR_Coverage, 12788,
     /* 1011322 */     GIR_EraseRootFromParent_Done,
     /* 1011323 */   // Label 15018: @1011323
     /* 1011323 */   GIM_Try, /*On fail goto*//*Label 15019*/ GIMT_Encode4(1011400), // Rule ID 12789 //
     /* 1011328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1011339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1011342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1011345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1011348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011367 */     // MIs[0] policy
     /* 1011367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011377 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1011380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011399 */     // GIR_Coverage, 12789,
     /* 1011399 */     GIR_EraseRootFromParent_Done,
     /* 1011400 */   // Label 15019: @1011400
     /* 1011400 */   GIM_Try, /*On fail goto*//*Label 15020*/ GIMT_Encode4(1011477), // Rule ID 12792 //
     /* 1011405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1011416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1011419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1011422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1011425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011444 */     // MIs[0] policy
     /* 1011444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011454 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1011457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011476 */     // GIR_Coverage, 12792,
     /* 1011476 */     GIR_EraseRootFromParent_Done,
     /* 1011477 */   // Label 15020: @1011477
     /* 1011477 */   GIM_Try, /*On fail goto*//*Label 15021*/ GIMT_Encode4(1011554), // Rule ID 12793 //
     /* 1011482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1011493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1011496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1011499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1011502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011521 */     // MIs[0] policy
     /* 1011521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1011534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011553 */     // GIR_Coverage, 12793,
     /* 1011553 */     GIR_EraseRootFromParent_Done,
     /* 1011554 */   // Label 15021: @1011554
     /* 1011554 */   GIM_Try, /*On fail goto*//*Label 15022*/ GIMT_Encode4(1011631), // Rule ID 12796 //
     /* 1011559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1011570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1011573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1011576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1011579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011598 */     // MIs[0] policy
     /* 1011598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011608 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1011611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011630 */     // GIR_Coverage, 12796,
     /* 1011630 */     GIR_EraseRootFromParent_Done,
     /* 1011631 */   // Label 15022: @1011631
     /* 1011631 */   GIM_Try, /*On fail goto*//*Label 15023*/ GIMT_Encode4(1011708), // Rule ID 12797 //
     /* 1011636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1011647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1011650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1011653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1011656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011675 */     // MIs[0] policy
     /* 1011675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011685 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1011688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011707 */     // GIR_Coverage, 12797,
     /* 1011707 */     GIR_EraseRootFromParent_Done,
     /* 1011708 */   // Label 15023: @1011708
     /* 1011708 */   GIM_Try, /*On fail goto*//*Label 15024*/ GIMT_Encode4(1011785), // Rule ID 12800 //
     /* 1011713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1011724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1011727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1011730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1011733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011752 */     // MIs[0] policy
     /* 1011752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011762 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1011765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011784 */     // GIR_Coverage, 12800,
     /* 1011784 */     GIR_EraseRootFromParent_Done,
     /* 1011785 */   // Label 15024: @1011785
     /* 1011785 */   GIM_Try, /*On fail goto*//*Label 15025*/ GIMT_Encode4(1011862), // Rule ID 12801 //
     /* 1011790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1011801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1011804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1011807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1011810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011829 */     // MIs[0] policy
     /* 1011829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011839 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1011842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011861 */     // GIR_Coverage, 12801,
     /* 1011861 */     GIR_EraseRootFromParent_Done,
     /* 1011862 */   // Label 15025: @1011862
     /* 1011862 */   GIM_Try, /*On fail goto*//*Label 15026*/ GIMT_Encode4(1011939), // Rule ID 12804 //
     /* 1011867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1011878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1011881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1011887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011906 */     // MIs[0] policy
     /* 1011906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011916 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1011919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011938 */     // GIR_Coverage, 12804,
     /* 1011938 */     GIR_EraseRootFromParent_Done,
     /* 1011939 */   // Label 15026: @1011939
     /* 1011939 */   GIM_Try, /*On fail goto*//*Label 15027*/ GIMT_Encode4(1012016), // Rule ID 12805 //
     /* 1011944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1011955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1011958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1011964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011983 */     // MIs[0] policy
     /* 1011983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011993 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1011996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012015 */     // GIR_Coverage, 12805,
     /* 1012015 */     GIR_EraseRootFromParent_Done,
     /* 1012016 */   // Label 15027: @1012016
     /* 1012016 */   GIM_Try, /*On fail goto*//*Label 15028*/ GIMT_Encode4(1012093), // Rule ID 12808 //
     /* 1012021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1012032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1012035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1012041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012060 */     // MIs[0] policy
     /* 1012060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012070 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1012073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012092 */     // GIR_Coverage, 12808,
     /* 1012092 */     GIR_EraseRootFromParent_Done,
     /* 1012093 */   // Label 15028: @1012093
     /* 1012093 */   GIM_Try, /*On fail goto*//*Label 15029*/ GIMT_Encode4(1012170), // Rule ID 12809 //
     /* 1012098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1012109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1012112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1012115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1012118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012137 */     // MIs[0] policy
     /* 1012137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012147 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1012150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012169 */     // GIR_Coverage, 12809,
     /* 1012169 */     GIR_EraseRootFromParent_Done,
     /* 1012170 */   // Label 15029: @1012170
     /* 1012170 */   GIM_Try, /*On fail goto*//*Label 15030*/ GIMT_Encode4(1012247), // Rule ID 12812 //
     /* 1012175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1012186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1012189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1012195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012214 */     // MIs[0] policy
     /* 1012214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012224 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1012227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012246 */     // GIR_Coverage, 12812,
     /* 1012246 */     GIR_EraseRootFromParent_Done,
     /* 1012247 */   // Label 15030: @1012247
     /* 1012247 */   GIM_Try, /*On fail goto*//*Label 15031*/ GIMT_Encode4(1012324), // Rule ID 12813 //
     /* 1012252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1012263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1012266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1012269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1012272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012291 */     // MIs[0] policy
     /* 1012291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012301 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1012304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012323 */     // GIR_Coverage, 12813,
     /* 1012323 */     GIR_EraseRootFromParent_Done,
     /* 1012324 */   // Label 15031: @1012324
     /* 1012324 */   GIM_Try, /*On fail goto*//*Label 15032*/ GIMT_Encode4(1012401), // Rule ID 12816 //
     /* 1012329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1012340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1012343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1012349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012368 */     // MIs[0] policy
     /* 1012368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012378 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1012381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012400 */     // GIR_Coverage, 12816,
     /* 1012400 */     GIR_EraseRootFromParent_Done,
     /* 1012401 */   // Label 15032: @1012401
     /* 1012401 */   GIM_Try, /*On fail goto*//*Label 15033*/ GIMT_Encode4(1012478), // Rule ID 12817 //
     /* 1012406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1012417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1012420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1012423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1012426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012445 */     // MIs[0] policy
     /* 1012445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012455 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1012458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012477 */     // GIR_Coverage, 12817,
     /* 1012477 */     GIR_EraseRootFromParent_Done,
     /* 1012478 */   // Label 15033: @1012478
     /* 1012478 */   GIM_Try, /*On fail goto*//*Label 15034*/ GIMT_Encode4(1012555), // Rule ID 12820 //
     /* 1012483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1012494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1012497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1012503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012522 */     // MIs[0] policy
     /* 1012522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012532 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1012535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012554 */     // GIR_Coverage, 12820,
     /* 1012554 */     GIR_EraseRootFromParent_Done,
     /* 1012555 */   // Label 15034: @1012555
     /* 1012555 */   GIM_Try, /*On fail goto*//*Label 15035*/ GIMT_Encode4(1012632), // Rule ID 12821 //
     /* 1012560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1012571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1012574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1012577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1012580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012599 */     // MIs[0] policy
     /* 1012599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012609 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1012612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012631 */     // GIR_Coverage, 12821,
     /* 1012631 */     GIR_EraseRootFromParent_Done,
     /* 1012632 */   // Label 15035: @1012632
     /* 1012632 */   GIM_Try, /*On fail goto*//*Label 15036*/ GIMT_Encode4(1012709), // Rule ID 12824 //
     /* 1012637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1012648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1012651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1012657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012676 */     // MIs[0] policy
     /* 1012676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012686 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1012689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012708 */     // GIR_Coverage, 12824,
     /* 1012708 */     GIR_EraseRootFromParent_Done,
     /* 1012709 */   // Label 15036: @1012709
     /* 1012709 */   GIM_Try, /*On fail goto*//*Label 15037*/ GIMT_Encode4(1012786), // Rule ID 12825 //
     /* 1012714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1012725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1012728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1012731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1012734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012753 */     // MIs[0] policy
     /* 1012753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012763 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1012766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012785 */     // GIR_Coverage, 12825,
     /* 1012785 */     GIR_EraseRootFromParent_Done,
     /* 1012786 */   // Label 15037: @1012786
     /* 1012786 */   GIM_Try, /*On fail goto*//*Label 15038*/ GIMT_Encode4(1012863), // Rule ID 12828 //
     /* 1012791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1012802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1012805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1012811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012830 */     // MIs[0] policy
     /* 1012830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1012843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012862 */     // GIR_Coverage, 12828,
     /* 1012862 */     GIR_EraseRootFromParent_Done,
     /* 1012863 */   // Label 15038: @1012863
     /* 1012863 */   GIM_Try, /*On fail goto*//*Label 15039*/ GIMT_Encode4(1012940), // Rule ID 12829 //
     /* 1012868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1012879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1012882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1012885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1012888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012907 */     // MIs[0] policy
     /* 1012907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012917 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1012920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012939 */     // GIR_Coverage, 12829,
     /* 1012939 */     GIR_EraseRootFromParent_Done,
     /* 1012940 */   // Label 15039: @1012940
     /* 1012940 */   GIM_Try, /*On fail goto*//*Label 15040*/ GIMT_Encode4(1013017), // Rule ID 12832 //
     /* 1012945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1012956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1012959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1012965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012984 */     // MIs[0] policy
     /* 1012984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012994 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1012997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013016 */     // GIR_Coverage, 12832,
     /* 1013016 */     GIR_EraseRootFromParent_Done,
     /* 1013017 */   // Label 15040: @1013017
     /* 1013017 */   GIM_Try, /*On fail goto*//*Label 15041*/ GIMT_Encode4(1013094), // Rule ID 12833 //
     /* 1013022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1013033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1013036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1013042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013061 */     // MIs[0] policy
     /* 1013061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013071 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1013074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013093 */     // GIR_Coverage, 12833,
     /* 1013093 */     GIR_EraseRootFromParent_Done,
     /* 1013094 */   // Label 15041: @1013094
     /* 1013094 */   GIM_Try, /*On fail goto*//*Label 15042*/ GIMT_Encode4(1013171), // Rule ID 12836 //
     /* 1013099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1013110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1013113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1013116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1013119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013138 */     // MIs[0] policy
     /* 1013138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013148 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1013151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013170 */     // GIR_Coverage, 12836,
     /* 1013170 */     GIR_EraseRootFromParent_Done,
     /* 1013171 */   // Label 15042: @1013171
     /* 1013171 */   GIM_Try, /*On fail goto*//*Label 15043*/ GIMT_Encode4(1013248), // Rule ID 12837 //
     /* 1013176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1013187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1013190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1013196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013215 */     // MIs[0] policy
     /* 1013215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013225 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1013228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013247 */     // GIR_Coverage, 12837,
     /* 1013247 */     GIR_EraseRootFromParent_Done,
     /* 1013248 */   // Label 15043: @1013248
     /* 1013248 */   GIM_Try, /*On fail goto*//*Label 15044*/ GIMT_Encode4(1013325), // Rule ID 12840 //
     /* 1013253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1013256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1013264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1013267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1013270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1013273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013292 */     // MIs[0] policy
     /* 1013292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013302 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1013305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1013321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013324 */     // GIR_Coverage, 12840,
     /* 1013324 */     GIR_EraseRootFromParent_Done,
     /* 1013325 */   // Label 15044: @1013325
     /* 1013325 */   GIM_Try, /*On fail goto*//*Label 15045*/ GIMT_Encode4(1013402), // Rule ID 12841 //
     /* 1013330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1013333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1013341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1013344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1013350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013369 */     // MIs[0] policy
     /* 1013369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013379 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1013382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1013398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013401 */     // GIR_Coverage, 12841,
     /* 1013401 */     GIR_EraseRootFromParent_Done,
     /* 1013402 */   // Label 15045: @1013402
     /* 1013402 */   GIM_Try, /*On fail goto*//*Label 15046*/ GIMT_Encode4(1013479), // Rule ID 12844 //
     /* 1013407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1013418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1013421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1013424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1013427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013446 */     // MIs[0] policy
     /* 1013446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013456 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1013459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013478 */     // GIR_Coverage, 12844,
     /* 1013478 */     GIR_EraseRootFromParent_Done,
     /* 1013479 */   // Label 15046: @1013479
     /* 1013479 */   GIM_Try, /*On fail goto*//*Label 15047*/ GIMT_Encode4(1013556), // Rule ID 12845 //
     /* 1013484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1013495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1013498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1013504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013523 */     // MIs[0] policy
     /* 1013523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013533 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1013536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013555 */     // GIR_Coverage, 12845,
     /* 1013555 */     GIR_EraseRootFromParent_Done,
     /* 1013556 */   // Label 15047: @1013556
     /* 1013556 */   GIM_Try, /*On fail goto*//*Label 15048*/ GIMT_Encode4(1013633), // Rule ID 12848 //
     /* 1013561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1013572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1013575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1013578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1013581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013600 */     // MIs[0] policy
     /* 1013600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013610 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1013613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013632 */     // GIR_Coverage, 12848,
     /* 1013632 */     GIR_EraseRootFromParent_Done,
     /* 1013633 */   // Label 15048: @1013633
     /* 1013633 */   GIM_Try, /*On fail goto*//*Label 15049*/ GIMT_Encode4(1013710), // Rule ID 12849 //
     /* 1013638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1013649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1013652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1013658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013677 */     // MIs[0] policy
     /* 1013677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013687 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1013690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013709 */     // GIR_Coverage, 12849,
     /* 1013709 */     GIR_EraseRootFromParent_Done,
     /* 1013710 */   // Label 15049: @1013710
     /* 1013710 */   GIM_Try, /*On fail goto*//*Label 15050*/ GIMT_Encode4(1013787), // Rule ID 12852 //
     /* 1013715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1013726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1013729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1013732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1013735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013754 */     // MIs[0] policy
     /* 1013754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013764 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1013767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013786 */     // GIR_Coverage, 12852,
     /* 1013786 */     GIR_EraseRootFromParent_Done,
     /* 1013787 */   // Label 15050: @1013787
     /* 1013787 */   GIM_Try, /*On fail goto*//*Label 15051*/ GIMT_Encode4(1013864), // Rule ID 12853 //
     /* 1013792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1013803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1013806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1013812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013831 */     // MIs[0] policy
     /* 1013831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013841 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1013844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013863 */     // GIR_Coverage, 12853,
     /* 1013863 */     GIR_EraseRootFromParent_Done,
     /* 1013864 */   // Label 15051: @1013864
     /* 1013864 */   GIM_Try, /*On fail goto*//*Label 15052*/ GIMT_Encode4(1013941), // Rule ID 12856 //
     /* 1013869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1013880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1013883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1013886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1013889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013908 */     // MIs[0] policy
     /* 1013908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1013921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013940 */     // GIR_Coverage, 12856,
     /* 1013940 */     GIR_EraseRootFromParent_Done,
     /* 1013941 */   // Label 15052: @1013941
     /* 1013941 */   GIM_Try, /*On fail goto*//*Label 15053*/ GIMT_Encode4(1014018), // Rule ID 12857 //
     /* 1013946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1013957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1013960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1013966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013985 */     // MIs[0] policy
     /* 1013985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013995 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1013998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014017 */     // GIR_Coverage, 12857,
     /* 1014017 */     GIR_EraseRootFromParent_Done,
     /* 1014018 */   // Label 15053: @1014018
     /* 1014018 */   GIM_Try, /*On fail goto*//*Label 15054*/ GIMT_Encode4(1014095), // Rule ID 12860 //
     /* 1014023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1014034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1014037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1014043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014062 */     // MIs[0] policy
     /* 1014062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014072 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1014075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014094 */     // GIR_Coverage, 12860,
     /* 1014094 */     GIR_EraseRootFromParent_Done,
     /* 1014095 */   // Label 15054: @1014095
     /* 1014095 */   GIM_Try, /*On fail goto*//*Label 15055*/ GIMT_Encode4(1014172), // Rule ID 12861 //
     /* 1014100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1014111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1014114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1014120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014139 */     // MIs[0] policy
     /* 1014139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014149 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1014152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014171 */     // GIR_Coverage, 12861,
     /* 1014171 */     GIR_EraseRootFromParent_Done,
     /* 1014172 */   // Label 15055: @1014172
     /* 1014172 */   GIM_Try, /*On fail goto*//*Label 15056*/ GIMT_Encode4(1014249), // Rule ID 12864 //
     /* 1014177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1014188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1014191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1014197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014216 */     // MIs[0] policy
     /* 1014216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014226 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1014229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014248 */     // GIR_Coverage, 12864,
     /* 1014248 */     GIR_EraseRootFromParent_Done,
     /* 1014249 */   // Label 15056: @1014249
     /* 1014249 */   GIM_Try, /*On fail goto*//*Label 15057*/ GIMT_Encode4(1014326), // Rule ID 12865 //
     /* 1014254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1014265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1014268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1014274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014293 */     // MIs[0] policy
     /* 1014293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014303 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1014306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014325 */     // GIR_Coverage, 12865,
     /* 1014325 */     GIR_EraseRootFromParent_Done,
     /* 1014326 */   // Label 15057: @1014326
     /* 1014326 */   GIM_Try, /*On fail goto*//*Label 15058*/ GIMT_Encode4(1014403), // Rule ID 12868 //
     /* 1014331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1014342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1014345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1014351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014370 */     // MIs[0] policy
     /* 1014370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014380 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1014383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014402 */     // GIR_Coverage, 12868,
     /* 1014402 */     GIR_EraseRootFromParent_Done,
     /* 1014403 */   // Label 15058: @1014403
     /* 1014403 */   GIM_Try, /*On fail goto*//*Label 15059*/ GIMT_Encode4(1014480), // Rule ID 12869 //
     /* 1014408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1014419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1014422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1014428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014447 */     // MIs[0] policy
     /* 1014447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1014460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014479 */     // GIR_Coverage, 12869,
     /* 1014479 */     GIR_EraseRootFromParent_Done,
     /* 1014480 */   // Label 15059: @1014480
     /* 1014480 */   GIM_Try, /*On fail goto*//*Label 15060*/ GIMT_Encode4(1014557), // Rule ID 12872 //
     /* 1014485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014524 */     // MIs[0] policy
     /* 1014524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014534 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1014537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014556 */     // GIR_Coverage, 12872,
     /* 1014556 */     GIR_EraseRootFromParent_Done,
     /* 1014557 */   // Label 15060: @1014557
     /* 1014557 */   GIM_Try, /*On fail goto*//*Label 15061*/ GIMT_Encode4(1014634), // Rule ID 12873 //
     /* 1014562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014601 */     // MIs[0] policy
     /* 1014601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014611 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1014614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014633 */     // GIR_Coverage, 12873,
     /* 1014633 */     GIR_EraseRootFromParent_Done,
     /* 1014634 */   // Label 15061: @1014634
     /* 1014634 */   GIM_Try, /*On fail goto*//*Label 15062*/ GIMT_Encode4(1014711), // Rule ID 12876 //
     /* 1014639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014678 */     // MIs[0] policy
     /* 1014678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014688 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1014691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014710 */     // GIR_Coverage, 12876,
     /* 1014710 */     GIR_EraseRootFromParent_Done,
     /* 1014711 */   // Label 15062: @1014711
     /* 1014711 */   GIM_Try, /*On fail goto*//*Label 15063*/ GIMT_Encode4(1014788), // Rule ID 12877 //
     /* 1014716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014755 */     // MIs[0] policy
     /* 1014755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014765 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1014768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014787 */     // GIR_Coverage, 12877,
     /* 1014787 */     GIR_EraseRootFromParent_Done,
     /* 1014788 */   // Label 15063: @1014788
     /* 1014788 */   GIM_Try, /*On fail goto*//*Label 15064*/ GIMT_Encode4(1014865), // Rule ID 12880 //
     /* 1014793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1014804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1014807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1014813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014832 */     // MIs[0] policy
     /* 1014832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014842 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1014845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014864 */     // GIR_Coverage, 12880,
     /* 1014864 */     GIR_EraseRootFromParent_Done,
     /* 1014865 */   // Label 15064: @1014865
     /* 1014865 */   GIM_Try, /*On fail goto*//*Label 15065*/ GIMT_Encode4(1014942), // Rule ID 12881 //
     /* 1014870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1014873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1014881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1014884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1014890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014909 */     // MIs[0] policy
     /* 1014909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014919 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11387:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1014922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014941 */     // GIR_Coverage, 12881,
     /* 1014941 */     GIR_EraseRootFromParent_Done,
     /* 1014942 */   // Label 15065: @1014942
     /* 1014942 */   GIM_Try, /*On fail goto*//*Label 15066*/ GIMT_Encode4(1015019), // Rule ID 12884 //
     /* 1014947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1014958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1014961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1014967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014986 */     // MIs[0] policy
     /* 1014986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1014999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015018 */     // GIR_Coverage, 12884,
     /* 1015018 */     GIR_EraseRootFromParent_Done,
     /* 1015019 */   // Label 15066: @1015019
     /* 1015019 */   GIM_Try, /*On fail goto*//*Label 15067*/ GIMT_Encode4(1015096), // Rule ID 12885 //
     /* 1015024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1015027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1015032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1015035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1015038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1015044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015063 */     // MIs[0] policy
     /* 1015063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015073 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11387:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1015076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015095 */     // GIR_Coverage, 12885,
     /* 1015095 */     GIR_EraseRootFromParent_Done,
     /* 1015096 */   // Label 15067: @1015096
     /* 1015096 */   GIM_Try, /*On fail goto*//*Label 15068*/ GIMT_Encode4(1015173), // Rule ID 12888 //
     /* 1015101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1015104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1015109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1015112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1015115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1015121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015140 */     // MIs[0] policy
     /* 1015140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015150 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1015153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015172 */     // GIR_Coverage, 12888,
     /* 1015172 */     GIR_EraseRootFromParent_Done,
     /* 1015173 */   // Label 15068: @1015173
     /* 1015173 */   GIM_Try, /*On fail goto*//*Label 15069*/ GIMT_Encode4(1015250), // Rule ID 12889 //
     /* 1015178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1015181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1015186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1015189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1015192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1015198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015217 */     // MIs[0] policy
     /* 1015217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015227 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11387:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1015230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015249 */     // GIR_Coverage, 12889,
     /* 1015249 */     GIR_EraseRootFromParent_Done,
     /* 1015250 */   // Label 15069: @1015250
     /* 1015250 */   GIM_Try, /*On fail goto*//*Label 15070*/ GIMT_Encode4(1015327), // Rule ID 12892 //
     /* 1015255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1015266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1015269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1015272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1015275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015294 */     // MIs[0] policy
     /* 1015294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015304 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1015307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015326 */     // GIR_Coverage, 12892,
     /* 1015326 */     GIR_EraseRootFromParent_Done,
     /* 1015327 */   // Label 15070: @1015327
     /* 1015327 */   GIM_Try, /*On fail goto*//*Label 15071*/ GIMT_Encode4(1015404), // Rule ID 12893 //
     /* 1015332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1015343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1015346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1015349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1015352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015371 */     // MIs[0] policy
     /* 1015371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015381 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1015384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015403 */     // GIR_Coverage, 12893,
     /* 1015403 */     GIR_EraseRootFromParent_Done,
     /* 1015404 */   // Label 15071: @1015404
     /* 1015404 */   GIM_Try, /*On fail goto*//*Label 15072*/ GIMT_Encode4(1015481), // Rule ID 12896 //
     /* 1015409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1015420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1015423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1015426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1015429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015448 */     // MIs[0] policy
     /* 1015448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015458 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1015461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015480 */     // GIR_Coverage, 12896,
     /* 1015480 */     GIR_EraseRootFromParent_Done,
     /* 1015481 */   // Label 15072: @1015481
     /* 1015481 */   GIM_Try, /*On fail goto*//*Label 15073*/ GIMT_Encode4(1015558), // Rule ID 12897 //
     /* 1015486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1015497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1015500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1015503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1015506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015525 */     // MIs[0] policy
     /* 1015525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015535 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1015538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015557 */     // GIR_Coverage, 12897,
     /* 1015557 */     GIR_EraseRootFromParent_Done,
     /* 1015558 */   // Label 15073: @1015558
     /* 1015558 */   GIM_Try, /*On fail goto*//*Label 15074*/ GIMT_Encode4(1015635), // Rule ID 12900 //
     /* 1015563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1015574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1015577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1015580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1015583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015602 */     // MIs[0] policy
     /* 1015602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015612 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1015615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015634 */     // GIR_Coverage, 12900,
     /* 1015634 */     GIR_EraseRootFromParent_Done,
     /* 1015635 */   // Label 15074: @1015635
     /* 1015635 */   GIM_Try, /*On fail goto*//*Label 15075*/ GIMT_Encode4(1015712), // Rule ID 12901 //
     /* 1015640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1015651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1015654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1015657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1015660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015679 */     // MIs[0] policy
     /* 1015679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015689 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1015692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015711 */     // GIR_Coverage, 12901,
     /* 1015711 */     GIR_EraseRootFromParent_Done,
     /* 1015712 */   // Label 15075: @1015712
     /* 1015712 */   GIM_Try, /*On fail goto*//*Label 15076*/ GIMT_Encode4(1015789), // Rule ID 12904 //
     /* 1015717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1015728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1015731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1015734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1015737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015756 */     // MIs[0] policy
     /* 1015756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015766 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1015769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015788 */     // GIR_Coverage, 12904,
     /* 1015788 */     GIR_EraseRootFromParent_Done,
     /* 1015789 */   // Label 15076: @1015789
     /* 1015789 */   GIM_Try, /*On fail goto*//*Label 15077*/ GIMT_Encode4(1015866), // Rule ID 12905 //
     /* 1015794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1015805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1015808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1015811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1015814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015833 */     // MIs[0] policy
     /* 1015833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1015846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015865 */     // GIR_Coverage, 12905,
     /* 1015865 */     GIR_EraseRootFromParent_Done,
     /* 1015866 */   // Label 15077: @1015866
     /* 1015866 */   GIM_Try, /*On fail goto*//*Label 15078*/ GIMT_Encode4(1015943), // Rule ID 12908 //
     /* 1015871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1015882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1015885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1015888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1015891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015910 */     // MIs[0] policy
     /* 1015910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015920 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1015923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015942 */     // GIR_Coverage, 12908,
     /* 1015942 */     GIR_EraseRootFromParent_Done,
     /* 1015943 */   // Label 15078: @1015943
     /* 1015943 */   GIM_Try, /*On fail goto*//*Label 15079*/ GIMT_Encode4(1016020), // Rule ID 12909 //
     /* 1015948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1015959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1015962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1015965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1015968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015987 */     // MIs[0] policy
     /* 1015987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015997 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1016000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016019 */     // GIR_Coverage, 12909,
     /* 1016019 */     GIR_EraseRootFromParent_Done,
     /* 1016020 */   // Label 15079: @1016020
     /* 1016020 */   GIM_Try, /*On fail goto*//*Label 15080*/ GIMT_Encode4(1016097), // Rule ID 12912 //
     /* 1016025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1016036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1016039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1016042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1016045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016064 */     // MIs[0] policy
     /* 1016064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016074 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1016077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016096 */     // GIR_Coverage, 12912,
     /* 1016096 */     GIR_EraseRootFromParent_Done,
     /* 1016097 */   // Label 15080: @1016097
     /* 1016097 */   GIM_Try, /*On fail goto*//*Label 15081*/ GIMT_Encode4(1016174), // Rule ID 12913 //
     /* 1016102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1016113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1016116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1016119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1016122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016141 */     // MIs[0] policy
     /* 1016141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016151 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1016154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016173 */     // GIR_Coverage, 12913,
     /* 1016173 */     GIR_EraseRootFromParent_Done,
     /* 1016174 */   // Label 15081: @1016174
     /* 1016174 */   GIM_Try, /*On fail goto*//*Label 15082*/ GIMT_Encode4(1016251), // Rule ID 12916 //
     /* 1016179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1016190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1016193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1016196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1016199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016218 */     // MIs[0] policy
     /* 1016218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016228 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016250 */     // GIR_Coverage, 12916,
     /* 1016250 */     GIR_EraseRootFromParent_Done,
     /* 1016251 */   // Label 15082: @1016251
     /* 1016251 */   GIM_Try, /*On fail goto*//*Label 15083*/ GIMT_Encode4(1016328), // Rule ID 12917 //
     /* 1016256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1016267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1016270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1016273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1016276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016295 */     // MIs[0] policy
     /* 1016295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016305 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016327 */     // GIR_Coverage, 12917,
     /* 1016327 */     GIR_EraseRootFromParent_Done,
     /* 1016328 */   // Label 15083: @1016328
     /* 1016328 */   GIM_Try, /*On fail goto*//*Label 15084*/ GIMT_Encode4(1016405), // Rule ID 12920 //
     /* 1016333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1016344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1016347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1016350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1016353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016372 */     // MIs[0] policy
     /* 1016372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016382 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016404 */     // GIR_Coverage, 12920,
     /* 1016404 */     GIR_EraseRootFromParent_Done,
     /* 1016405 */   // Label 15084: @1016405
     /* 1016405 */   GIM_Try, /*On fail goto*//*Label 15085*/ GIMT_Encode4(1016482), // Rule ID 12921 //
     /* 1016410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1016421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1016424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1016427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1016430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016449 */     // MIs[0] policy
     /* 1016449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016459 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016481 */     // GIR_Coverage, 12921,
     /* 1016481 */     GIR_EraseRootFromParent_Done,
     /* 1016482 */   // Label 15085: @1016482
     /* 1016482 */   GIM_Try, /*On fail goto*//*Label 15086*/ GIMT_Encode4(1016559), // Rule ID 12924 //
     /* 1016487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1016504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016526 */     // MIs[0] policy
     /* 1016526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016558 */     // GIR_Coverage, 12924,
     /* 1016558 */     GIR_EraseRootFromParent_Done,
     /* 1016559 */   // Label 15086: @1016559
     /* 1016559 */   GIM_Try, /*On fail goto*//*Label 15087*/ GIMT_Encode4(1016636), // Rule ID 12925 //
     /* 1016564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1016581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016603 */     // MIs[0] policy
     /* 1016603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016613 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016635 */     // GIR_Coverage, 12925,
     /* 1016635 */     GIR_EraseRootFromParent_Done,
     /* 1016636 */   // Label 15087: @1016636
     /* 1016636 */   GIM_Try, /*On fail goto*//*Label 15088*/ GIMT_Encode4(1016713), // Rule ID 12928 //
     /* 1016641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1016644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1016652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1016655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1016658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1016661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016680 */     // MIs[0] policy
     /* 1016680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016690 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016712 */     // GIR_Coverage, 12928,
     /* 1016712 */     GIR_EraseRootFromParent_Done,
     /* 1016713 */   // Label 15088: @1016713
     /* 1016713 */   GIM_Try, /*On fail goto*//*Label 15089*/ GIMT_Encode4(1016790), // Rule ID 12929 //
     /* 1016718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1016721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1016729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1016732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1016735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1016738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016757 */     // MIs[0] policy
     /* 1016757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016767 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016789 */     // GIR_Coverage, 12929,
     /* 1016789 */     GIR_EraseRootFromParent_Done,
     /* 1016790 */   // Label 15089: @1016790
     /* 1016790 */   GIM_Try, /*On fail goto*//*Label 15090*/ GIMT_Encode4(1016867), // Rule ID 12932 //
     /* 1016795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1016806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1016809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1016812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1016815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016834 */     // MIs[0] policy
     /* 1016834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016844 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1016847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016866 */     // GIR_Coverage, 12932,
     /* 1016866 */     GIR_EraseRootFromParent_Done,
     /* 1016867 */   // Label 15090: @1016867
     /* 1016867 */   GIM_Try, /*On fail goto*//*Label 15091*/ GIMT_Encode4(1016944), // Rule ID 12933 //
     /* 1016872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1016883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1016886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1016889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1016892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016911 */     // MIs[0] policy
     /* 1016911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016921 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1016924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016943 */     // GIR_Coverage, 12933,
     /* 1016943 */     GIR_EraseRootFromParent_Done,
     /* 1016944 */   // Label 15091: @1016944
     /* 1016944 */   GIM_Try, /*On fail goto*//*Label 15092*/ GIMT_Encode4(1017021), // Rule ID 12936 //
     /* 1016949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1016960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1016963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1016966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1016969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016988 */     // MIs[0] policy
     /* 1016988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016998 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1017001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017020 */     // GIR_Coverage, 12936,
     /* 1017020 */     GIR_EraseRootFromParent_Done,
     /* 1017021 */   // Label 15092: @1017021
     /* 1017021 */   GIM_Try, /*On fail goto*//*Label 15093*/ GIMT_Encode4(1017098), // Rule ID 12937 //
     /* 1017026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1017037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1017040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1017043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1017046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017065 */     // MIs[0] policy
     /* 1017065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017075 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1017078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017097 */     // GIR_Coverage, 12937,
     /* 1017097 */     GIR_EraseRootFromParent_Done,
     /* 1017098 */   // Label 15093: @1017098
     /* 1017098 */   GIM_Try, /*On fail goto*//*Label 15094*/ GIMT_Encode4(1017175), // Rule ID 12940 //
     /* 1017103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1017114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1017117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1017120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1017123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017142 */     // MIs[0] policy
     /* 1017142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017152 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1017155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017174 */     // GIR_Coverage, 12940,
     /* 1017174 */     GIR_EraseRootFromParent_Done,
     /* 1017175 */   // Label 15094: @1017175
     /* 1017175 */   GIM_Try, /*On fail goto*//*Label 15095*/ GIMT_Encode4(1017252), // Rule ID 12941 //
     /* 1017180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1017191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1017194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1017197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1017200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017219 */     // MIs[0] policy
     /* 1017219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017229 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1017232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017251 */     // GIR_Coverage, 12941,
     /* 1017251 */     GIR_EraseRootFromParent_Done,
     /* 1017252 */   // Label 15095: @1017252
     /* 1017252 */   GIM_Try, /*On fail goto*//*Label 15096*/ GIMT_Encode4(1017329), // Rule ID 12944 //
     /* 1017257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1017268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1017271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1017274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1017277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017296 */     // MIs[0] policy
     /* 1017296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1017309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017328 */     // GIR_Coverage, 12944,
     /* 1017328 */     GIR_EraseRootFromParent_Done,
     /* 1017329 */   // Label 15096: @1017329
     /* 1017329 */   GIM_Try, /*On fail goto*//*Label 15097*/ GIMT_Encode4(1017406), // Rule ID 12945 //
     /* 1017334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1017345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1017348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1017351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1017354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017373 */     // MIs[0] policy
     /* 1017373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017383 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1017386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017405 */     // GIR_Coverage, 12945,
     /* 1017405 */     GIR_EraseRootFromParent_Done,
     /* 1017406 */   // Label 15097: @1017406
     /* 1017406 */   GIM_Try, /*On fail goto*//*Label 15098*/ GIMT_Encode4(1017483), // Rule ID 12948 //
     /* 1017411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1017422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1017425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1017428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1017431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017450 */     // MIs[0] policy
     /* 1017450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1017463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017482 */     // GIR_Coverage, 12948,
     /* 1017482 */     GIR_EraseRootFromParent_Done,
     /* 1017483 */   // Label 15098: @1017483
     /* 1017483 */   GIM_Try, /*On fail goto*//*Label 15099*/ GIMT_Encode4(1017560), // Rule ID 12949 //
     /* 1017488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1017499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1017502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1017505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1017508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017527 */     // MIs[0] policy
     /* 1017527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017537 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1017540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017559 */     // GIR_Coverage, 12949,
     /* 1017559 */     GIR_EraseRootFromParent_Done,
     /* 1017560 */   // Label 15099: @1017560
     /* 1017560 */   GIM_Try, /*On fail goto*//*Label 15100*/ GIMT_Encode4(1017637), // Rule ID 12952 //
     /* 1017565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1017576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1017579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1017582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1017585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017604 */     // MIs[0] policy
     /* 1017604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1017617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017636 */     // GIR_Coverage, 12952,
     /* 1017636 */     GIR_EraseRootFromParent_Done,
     /* 1017637 */   // Label 15100: @1017637
     /* 1017637 */   GIM_Try, /*On fail goto*//*Label 15101*/ GIMT_Encode4(1017714), // Rule ID 12953 //
     /* 1017642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1017653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1017656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1017659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1017662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017681 */     // MIs[0] policy
     /* 1017681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017691 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1017694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017713 */     // GIR_Coverage, 12953,
     /* 1017713 */     GIR_EraseRootFromParent_Done,
     /* 1017714 */   // Label 15101: @1017714
     /* 1017714 */   GIM_Try, /*On fail goto*//*Label 15102*/ GIMT_Encode4(1017791), // Rule ID 12956 //
     /* 1017719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1017736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017758 */     // MIs[0] policy
     /* 1017758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1017771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017790 */     // GIR_Coverage, 12956,
     /* 1017790 */     GIR_EraseRootFromParent_Done,
     /* 1017791 */   // Label 15102: @1017791
     /* 1017791 */   GIM_Try, /*On fail goto*//*Label 15103*/ GIMT_Encode4(1017868), // Rule ID 12957 //
     /* 1017796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1017813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017835 */     // MIs[0] policy
     /* 1017835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017845 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1017848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017867 */     // GIR_Coverage, 12957,
     /* 1017867 */     GIR_EraseRootFromParent_Done,
     /* 1017868 */   // Label 15103: @1017868
     /* 1017868 */   GIM_Try, /*On fail goto*//*Label 15104*/ GIMT_Encode4(1017945), // Rule ID 12960 //
     /* 1017873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1017890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017912 */     // MIs[0] policy
     /* 1017912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017922 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1017925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017944 */     // GIR_Coverage, 12960,
     /* 1017944 */     GIR_EraseRootFromParent_Done,
     /* 1017945 */   // Label 15104: @1017945
     /* 1017945 */   GIM_Try, /*On fail goto*//*Label 15105*/ GIMT_Encode4(1018022), // Rule ID 12961 //
     /* 1017950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1017967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017989 */     // MIs[0] policy
     /* 1017989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017999 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1018002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018021 */     // GIR_Coverage, 12961,
     /* 1018021 */     GIR_EraseRootFromParent_Done,
     /* 1018022 */   // Label 15105: @1018022
     /* 1018022 */   GIM_Try, /*On fail goto*//*Label 15106*/ GIMT_Encode4(1018099), // Rule ID 12964 //
     /* 1018027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1018038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1018041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1018044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1018047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018066 */     // MIs[0] policy
     /* 1018066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1018079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018098 */     // GIR_Coverage, 12964,
     /* 1018098 */     GIR_EraseRootFromParent_Done,
     /* 1018099 */   // Label 15106: @1018099
     /* 1018099 */   GIM_Try, /*On fail goto*//*Label 15107*/ GIMT_Encode4(1018176), // Rule ID 12965 //
     /* 1018104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1018115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1018118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1018121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1018124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018143 */     // MIs[0] policy
     /* 1018143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018153 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1018156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018175 */     // GIR_Coverage, 12965,
     /* 1018175 */     GIR_EraseRootFromParent_Done,
     /* 1018176 */   // Label 15107: @1018176
     /* 1018176 */   GIM_Try, /*On fail goto*//*Label 15108*/ GIMT_Encode4(1018253), // Rule ID 12968 //
     /* 1018181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1018192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1018195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1018198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1018201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018220 */     // MIs[0] policy
     /* 1018220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018230 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1018233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018252 */     // GIR_Coverage, 12968,
     /* 1018252 */     GIR_EraseRootFromParent_Done,
     /* 1018253 */   // Label 15108: @1018253
     /* 1018253 */   GIM_Try, /*On fail goto*//*Label 15109*/ GIMT_Encode4(1018330), // Rule ID 12969 //
     /* 1018258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1018269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1018272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1018275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1018278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018297 */     // MIs[0] policy
     /* 1018297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018307 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1018310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018329 */     // GIR_Coverage, 12969,
     /* 1018329 */     GIR_EraseRootFromParent_Done,
     /* 1018330 */   // Label 15109: @1018330
     /* 1018330 */   GIM_Try, /*On fail goto*//*Label 15110*/ GIMT_Encode4(1018407), // Rule ID 12972 //
     /* 1018335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1018346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1018349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1018352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1018355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018374 */     // MIs[0] policy
     /* 1018374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018384 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1018387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018406 */     // GIR_Coverage, 12972,
     /* 1018406 */     GIR_EraseRootFromParent_Done,
     /* 1018407 */   // Label 15110: @1018407
     /* 1018407 */   GIM_Try, /*On fail goto*//*Label 15111*/ GIMT_Encode4(1018484), // Rule ID 12973 //
     /* 1018412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1018423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1018426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1018429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1018432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018451 */     // MIs[0] policy
     /* 1018451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018461 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1018464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018483 */     // GIR_Coverage, 12973,
     /* 1018483 */     GIR_EraseRootFromParent_Done,
     /* 1018484 */   // Label 15111: @1018484
     /* 1018484 */   GIM_Try, /*On fail goto*//*Label 15112*/ GIMT_Encode4(1018561), // Rule ID 12976 //
     /* 1018489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1018500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1018503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1018506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1018509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018528 */     // MIs[0] policy
     /* 1018528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018538 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1018541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018560 */     // GIR_Coverage, 12976,
     /* 1018560 */     GIR_EraseRootFromParent_Done,
     /* 1018561 */   // Label 15112: @1018561
     /* 1018561 */   GIM_Try, /*On fail goto*//*Label 15113*/ GIMT_Encode4(1018638), // Rule ID 12977 //
     /* 1018566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1018577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1018580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1018583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1018586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018605 */     // MIs[0] policy
     /* 1018605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018615 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1018618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018637 */     // GIR_Coverage, 12977,
     /* 1018637 */     GIR_EraseRootFromParent_Done,
     /* 1018638 */   // Label 15113: @1018638
     /* 1018638 */   GIM_Try, /*On fail goto*//*Label 15114*/ GIMT_Encode4(1018715), // Rule ID 12980 //
     /* 1018643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1018654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1018657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1018663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018682 */     // MIs[0] policy
     /* 1018682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018692 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1018695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018714 */     // GIR_Coverage, 12980,
     /* 1018714 */     GIR_EraseRootFromParent_Done,
     /* 1018715 */   // Label 15114: @1018715
     /* 1018715 */   GIM_Try, /*On fail goto*//*Label 15115*/ GIMT_Encode4(1018792), // Rule ID 12981 //
     /* 1018720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1018731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1018734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1018740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018759 */     // MIs[0] policy
     /* 1018759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018769 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1018772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018791 */     // GIR_Coverage, 12981,
     /* 1018791 */     GIR_EraseRootFromParent_Done,
     /* 1018792 */   // Label 15115: @1018792
     /* 1018792 */   GIM_Try, /*On fail goto*//*Label 15116*/ GIMT_Encode4(1018869), // Rule ID 12984 //
     /* 1018797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1018808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1018811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1018817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018836 */     // MIs[0] policy
     /* 1018836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018846 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1018849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018868 */     // GIR_Coverage, 12984,
     /* 1018868 */     GIR_EraseRootFromParent_Done,
     /* 1018869 */   // Label 15116: @1018869
     /* 1018869 */   GIM_Try, /*On fail goto*//*Label 15117*/ GIMT_Encode4(1018946), // Rule ID 12985 //
     /* 1018874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1018885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1018888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1018894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018913 */     // MIs[0] policy
     /* 1018913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018923 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1018926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018945 */     // GIR_Coverage, 12985,
     /* 1018945 */     GIR_EraseRootFromParent_Done,
     /* 1018946 */   // Label 15117: @1018946
     /* 1018946 */   GIM_Try, /*On fail goto*//*Label 15118*/ GIMT_Encode4(1019023), // Rule ID 12988 //
     /* 1018951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1018962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1018965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1018971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018990 */     // MIs[0] policy
     /* 1018990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019000 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1019003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019022 */     // GIR_Coverage, 12988,
     /* 1019022 */     GIR_EraseRootFromParent_Done,
     /* 1019023 */   // Label 15118: @1019023
     /* 1019023 */   GIM_Try, /*On fail goto*//*Label 15119*/ GIMT_Encode4(1019100), // Rule ID 12989 //
     /* 1019028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1019039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1019042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1019048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019067 */     // MIs[0] policy
     /* 1019067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019077 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1019080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019099 */     // GIR_Coverage, 12989,
     /* 1019099 */     GIR_EraseRootFromParent_Done,
     /* 1019100 */   // Label 15119: @1019100
     /* 1019100 */   GIM_Try, /*On fail goto*//*Label 15120*/ GIMT_Encode4(1019177), // Rule ID 12992 //
     /* 1019105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1019116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1019119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1019122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1019125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019144 */     // MIs[0] policy
     /* 1019144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019154 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1019157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019176 */     // GIR_Coverage, 12992,
     /* 1019176 */     GIR_EraseRootFromParent_Done,
     /* 1019177 */   // Label 15120: @1019177
     /* 1019177 */   GIM_Try, /*On fail goto*//*Label 15121*/ GIMT_Encode4(1019254), // Rule ID 12993 //
     /* 1019182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1019193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1019196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1019202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019221 */     // MIs[0] policy
     /* 1019221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019231 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1019234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019253 */     // GIR_Coverage, 12993,
     /* 1019253 */     GIR_EraseRootFromParent_Done,
     /* 1019254 */   // Label 15121: @1019254
     /* 1019254 */   GIM_Try, /*On fail goto*//*Label 15122*/ GIMT_Encode4(1019331), // Rule ID 12996 //
     /* 1019259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1019270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1019273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1019276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1019279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019298 */     // MIs[0] policy
     /* 1019298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019308 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1019311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019330 */     // GIR_Coverage, 12996,
     /* 1019330 */     GIR_EraseRootFromParent_Done,
     /* 1019331 */   // Label 15122: @1019331
     /* 1019331 */   GIM_Try, /*On fail goto*//*Label 15123*/ GIMT_Encode4(1019408), // Rule ID 12997 //
     /* 1019336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1019347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1019350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1019356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019375 */     // MIs[0] policy
     /* 1019375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019385 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1019388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019407 */     // GIR_Coverage, 12997,
     /* 1019407 */     GIR_EraseRootFromParent_Done,
     /* 1019408 */   // Label 15123: @1019408
     /* 1019408 */   GIM_Try, /*On fail goto*//*Label 15124*/ GIMT_Encode4(1019485), // Rule ID 13000 //
     /* 1019413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1019424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1019427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1019430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1019433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019452 */     // MIs[0] policy
     /* 1019452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019462 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1019465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019484 */     // GIR_Coverage, 13000,
     /* 1019484 */     GIR_EraseRootFromParent_Done,
     /* 1019485 */   // Label 15124: @1019485
     /* 1019485 */   GIM_Try, /*On fail goto*//*Label 15125*/ GIMT_Encode4(1019562), // Rule ID 13001 //
     /* 1019490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1019501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1019504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1019510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019529 */     // MIs[0] policy
     /* 1019529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019539 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1019542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019561 */     // GIR_Coverage, 13001,
     /* 1019561 */     GIR_EraseRootFromParent_Done,
     /* 1019562 */   // Label 15125: @1019562
     /* 1019562 */   GIM_Try, /*On fail goto*//*Label 15126*/ GIMT_Encode4(1019639), // Rule ID 13004 //
     /* 1019567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1019578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1019581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1019584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019606 */     // MIs[0] policy
     /* 1019606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019616 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1019619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019638 */     // GIR_Coverage, 13004,
     /* 1019638 */     GIR_EraseRootFromParent_Done,
     /* 1019639 */   // Label 15126: @1019639
     /* 1019639 */   GIM_Try, /*On fail goto*//*Label 15127*/ GIMT_Encode4(1019716), // Rule ID 13005 //
     /* 1019644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1019655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1019658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019683 */     // MIs[0] policy
     /* 1019683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019693 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1019696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019715 */     // GIR_Coverage, 13005,
     /* 1019715 */     GIR_EraseRootFromParent_Done,
     /* 1019716 */   // Label 15127: @1019716
     /* 1019716 */   GIM_Try, /*On fail goto*//*Label 15128*/ GIMT_Encode4(1019793), // Rule ID 13008 //
     /* 1019721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1019732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1019735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1019738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1019741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019760 */     // MIs[0] policy
     /* 1019760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1019773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019792 */     // GIR_Coverage, 13008,
     /* 1019792 */     GIR_EraseRootFromParent_Done,
     /* 1019793 */   // Label 15128: @1019793
     /* 1019793 */   GIM_Try, /*On fail goto*//*Label 15129*/ GIMT_Encode4(1019870), // Rule ID 13009 //
     /* 1019798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1019809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1019812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1019818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019837 */     // MIs[0] policy
     /* 1019837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019847 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1019850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019869 */     // GIR_Coverage, 13009,
     /* 1019869 */     GIR_EraseRootFromParent_Done,
     /* 1019870 */   // Label 15129: @1019870
     /* 1019870 */   GIM_Try, /*On fail goto*//*Label 15130*/ GIMT_Encode4(1019947), // Rule ID 13012 //
     /* 1019875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1019892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1019895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019914 */     // MIs[0] policy
     /* 1019914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019924 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1019927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019946 */     // GIR_Coverage, 13012,
     /* 1019946 */     GIR_EraseRootFromParent_Done,
     /* 1019947 */   // Label 15130: @1019947
     /* 1019947 */   GIM_Try, /*On fail goto*//*Label 15131*/ GIMT_Encode4(1020024), // Rule ID 13013 //
     /* 1019952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1019972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019991 */     // MIs[0] policy
     /* 1019991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020001 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1020004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020023 */     // GIR_Coverage, 13013,
     /* 1020023 */     GIR_EraseRootFromParent_Done,
     /* 1020024 */   // Label 15131: @1020024
     /* 1020024 */   GIM_Try, /*On fail goto*//*Label 15132*/ GIMT_Encode4(1020101), // Rule ID 13016 //
     /* 1020029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1020032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1020040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1020043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1020049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020068 */     // MIs[0] policy
     /* 1020068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020078 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1020081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1020097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020100 */     // GIR_Coverage, 13016,
     /* 1020100 */     GIR_EraseRootFromParent_Done,
     /* 1020101 */   // Label 15132: @1020101
     /* 1020101 */   GIM_Try, /*On fail goto*//*Label 15133*/ GIMT_Encode4(1020178), // Rule ID 13017 //
     /* 1020106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1020109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1020117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1020120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1020126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020145 */     // MIs[0] policy
     /* 1020145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020155 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1020158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1020174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020177 */     // GIR_Coverage, 13017,
     /* 1020177 */     GIR_EraseRootFromParent_Done,
     /* 1020178 */   // Label 15133: @1020178
     /* 1020178 */   GIM_Try, /*On fail goto*//*Label 15134*/ GIMT_Encode4(1020255), // Rule ID 13020 //
     /* 1020183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1020194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1020197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1020203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020222 */     // MIs[0] policy
     /* 1020222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020232 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1020235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020254 */     // GIR_Coverage, 13020,
     /* 1020254 */     GIR_EraseRootFromParent_Done,
     /* 1020255 */   // Label 15134: @1020255
     /* 1020255 */   GIM_Try, /*On fail goto*//*Label 15135*/ GIMT_Encode4(1020332), // Rule ID 13021 //
     /* 1020260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1020271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1020274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1020280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020299 */     // MIs[0] policy
     /* 1020299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020309 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1020312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020331 */     // GIR_Coverage, 13021,
     /* 1020331 */     GIR_EraseRootFromParent_Done,
     /* 1020332 */   // Label 15135: @1020332
     /* 1020332 */   GIM_Try, /*On fail goto*//*Label 15136*/ GIMT_Encode4(1020409), // Rule ID 13024 //
     /* 1020337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1020348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1020351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1020357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020376 */     // MIs[0] policy
     /* 1020376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020386 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1020389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020408 */     // GIR_Coverage, 13024,
     /* 1020408 */     GIR_EraseRootFromParent_Done,
     /* 1020409 */   // Label 15136: @1020409
     /* 1020409 */   GIM_Try, /*On fail goto*//*Label 15137*/ GIMT_Encode4(1020486), // Rule ID 13025 //
     /* 1020414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1020425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1020428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1020434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020453 */     // MIs[0] policy
     /* 1020453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020463 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1020466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020485 */     // GIR_Coverage, 13025,
     /* 1020485 */     GIR_EraseRootFromParent_Done,
     /* 1020486 */   // Label 15137: @1020486
     /* 1020486 */   GIM_Try, /*On fail goto*//*Label 15138*/ GIMT_Encode4(1020563), // Rule ID 13028 //
     /* 1020491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1020502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1020505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020530 */     // MIs[0] policy
     /* 1020530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020540 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1020543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020562 */     // GIR_Coverage, 13028,
     /* 1020562 */     GIR_EraseRootFromParent_Done,
     /* 1020563 */   // Label 15138: @1020563
     /* 1020563 */   GIM_Try, /*On fail goto*//*Label 15139*/ GIMT_Encode4(1020640), // Rule ID 13029 //
     /* 1020568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1020579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1020582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020607 */     // MIs[0] policy
     /* 1020607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020617 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1020620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020639 */     // GIR_Coverage, 13029,
     /* 1020639 */     GIR_EraseRootFromParent_Done,
     /* 1020640 */   // Label 15139: @1020640
     /* 1020640 */   GIM_Try, /*On fail goto*//*Label 15140*/ GIMT_Encode4(1020717), // Rule ID 13032 //
     /* 1020645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1020656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1020659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1020665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020684 */     // MIs[0] policy
     /* 1020684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1020697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020716 */     // GIR_Coverage, 13032,
     /* 1020716 */     GIR_EraseRootFromParent_Done,
     /* 1020717 */   // Label 15140: @1020717
     /* 1020717 */   GIM_Try, /*On fail goto*//*Label 15141*/ GIMT_Encode4(1020794), // Rule ID 13033 //
     /* 1020722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1020733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1020736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1020742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020761 */     // MIs[0] policy
     /* 1020761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020771 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1020774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020793 */     // GIR_Coverage, 13033,
     /* 1020793 */     GIR_EraseRootFromParent_Done,
     /* 1020794 */   // Label 15141: @1020794
     /* 1020794 */   GIM_Try, /*On fail goto*//*Label 15142*/ GIMT_Encode4(1020871), // Rule ID 13036 //
     /* 1020799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1020810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1020813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1020819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020838 */     // MIs[0] policy
     /* 1020838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1020851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020870 */     // GIR_Coverage, 13036,
     /* 1020870 */     GIR_EraseRootFromParent_Done,
     /* 1020871 */   // Label 15142: @1020871
     /* 1020871 */   GIM_Try, /*On fail goto*//*Label 15143*/ GIMT_Encode4(1020948), // Rule ID 13037 //
     /* 1020876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1020887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1020890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1020896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020915 */     // MIs[0] policy
     /* 1020915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020925 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1020928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020947 */     // GIR_Coverage, 13037,
     /* 1020947 */     GIR_EraseRootFromParent_Done,
     /* 1020948 */   // Label 15143: @1020948
     /* 1020948 */   GIM_Try, /*On fail goto*//*Label 15144*/ GIMT_Encode4(1021025), // Rule ID 13040 //
     /* 1020953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1020964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1020967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1020973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020992 */     // MIs[0] policy
     /* 1020992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021002 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1021005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1021021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021024 */     // GIR_Coverage, 13040,
     /* 1021024 */     GIR_EraseRootFromParent_Done,
     /* 1021025 */   // Label 15144: @1021025
     /* 1021025 */   GIM_Try, /*On fail goto*//*Label 15145*/ GIMT_Encode4(1021102), // Rule ID 13041 //
     /* 1021030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1021041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1021044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1021050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021069 */     // MIs[0] policy
     /* 1021069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021079 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1021082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1021098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021101 */     // GIR_Coverage, 13041,
     /* 1021101 */     GIR_EraseRootFromParent_Done,
     /* 1021102 */   // Label 15145: @1021102
     /* 1021102 */   GIM_Try, /*On fail goto*//*Label 15146*/ GIMT_Encode4(1021179), // Rule ID 13044 //
     /* 1021107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1021118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1021121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1021127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021146 */     // MIs[0] policy
     /* 1021146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1021159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021178 */     // GIR_Coverage, 13044,
     /* 1021178 */     GIR_EraseRootFromParent_Done,
     /* 1021179 */   // Label 15146: @1021179
     /* 1021179 */   GIM_Try, /*On fail goto*//*Label 15147*/ GIMT_Encode4(1021256), // Rule ID 13045 //
     /* 1021184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1021195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1021198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1021204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021223 */     // MIs[0] policy
     /* 1021223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021233 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1021236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021255 */     // GIR_Coverage, 13045,
     /* 1021255 */     GIR_EraseRootFromParent_Done,
     /* 1021256 */   // Label 15147: @1021256
     /* 1021256 */   GIM_Try, /*On fail goto*//*Label 15148*/ GIMT_Encode4(1021333), // Rule ID 13048 //
     /* 1021261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1021272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1021275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1021281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021300 */     // MIs[0] policy
     /* 1021300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021310 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1021313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021332 */     // GIR_Coverage, 13048,
     /* 1021332 */     GIR_EraseRootFromParent_Done,
     /* 1021333 */   // Label 15148: @1021333
     /* 1021333 */   GIM_Try, /*On fail goto*//*Label 15149*/ GIMT_Encode4(1021410), // Rule ID 13049 //
     /* 1021338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1021349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1021352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1021358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021377 */     // MIs[0] policy
     /* 1021377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021387 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1021390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021409 */     // GIR_Coverage, 13049,
     /* 1021409 */     GIR_EraseRootFromParent_Done,
     /* 1021410 */   // Label 15149: @1021410
     /* 1021410 */   GIM_Try, /*On fail goto*//*Label 15150*/ GIMT_Encode4(1021487), // Rule ID 13052 //
     /* 1021415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1021426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1021429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1021435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021454 */     // MIs[0] policy
     /* 1021454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1021467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021486 */     // GIR_Coverage, 13052,
     /* 1021486 */     GIR_EraseRootFromParent_Done,
     /* 1021487 */   // Label 15150: @1021487
     /* 1021487 */   GIM_Try, /*On fail goto*//*Label 15151*/ GIMT_Encode4(1021564), // Rule ID 13053 //
     /* 1021492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1021503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1021506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1021512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021531 */     // MIs[0] policy
     /* 1021531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021541 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1021544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021563 */     // GIR_Coverage, 13053,
     /* 1021563 */     GIR_EraseRootFromParent_Done,
     /* 1021564 */   // Label 15151: @1021564
     /* 1021564 */   GIM_Try, /*On fail goto*//*Label 15152*/ GIMT_Encode4(1021641), // Rule ID 13056 //
     /* 1021569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1021580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1021583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1021589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021608 */     // MIs[0] policy
     /* 1021608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1021621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021640 */     // GIR_Coverage, 13056,
     /* 1021640 */     GIR_EraseRootFromParent_Done,
     /* 1021641 */   // Label 15152: @1021641
     /* 1021641 */   GIM_Try, /*On fail goto*//*Label 15153*/ GIMT_Encode4(1021718), // Rule ID 13057 //
     /* 1021646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1021657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1021660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1021666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021685 */     // MIs[0] policy
     /* 1021685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021695 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1021698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021717 */     // GIR_Coverage, 13057,
     /* 1021717 */     GIR_EraseRootFromParent_Done,
     /* 1021718 */   // Label 15153: @1021718
     /* 1021718 */   GIM_Try, /*On fail goto*//*Label 15154*/ GIMT_Encode4(1021795), // Rule ID 13060 //
     /* 1021723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1021734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1021737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1021743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021762 */     // MIs[0] policy
     /* 1021762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021772 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1021775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021794 */     // GIR_Coverage, 13060,
     /* 1021794 */     GIR_EraseRootFromParent_Done,
     /* 1021795 */   // Label 15154: @1021795
     /* 1021795 */   GIM_Try, /*On fail goto*//*Label 15155*/ GIMT_Encode4(1021872), // Rule ID 13061 //
     /* 1021800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1021811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1021814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1021820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021839 */     // MIs[0] policy
     /* 1021839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021849 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1021852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021871 */     // GIR_Coverage, 13061,
     /* 1021871 */     GIR_EraseRootFromParent_Done,
     /* 1021872 */   // Label 15155: @1021872
     /* 1021872 */   GIM_Try, /*On fail goto*//*Label 15156*/ GIMT_Encode4(1021949), // Rule ID 13064 //
     /* 1021877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1021888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1021891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1021897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021916 */     // MIs[0] policy
     /* 1021916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021926 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1021929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021948 */     // GIR_Coverage, 13064,
     /* 1021948 */     GIR_EraseRootFromParent_Done,
     /* 1021949 */   // Label 15156: @1021949
     /* 1021949 */   GIM_Try, /*On fail goto*//*Label 15157*/ GIMT_Encode4(1022026), // Rule ID 13065 //
     /* 1021954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1021965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1021968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1021974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021993 */     // MIs[0] policy
     /* 1021993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022003 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1022006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1022022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022025 */     // GIR_Coverage, 13065,
     /* 1022025 */     GIR_EraseRootFromParent_Done,
     /* 1022026 */   // Label 15157: @1022026
     /* 1022026 */   GIM_Try, /*On fail goto*//*Label 15158*/ GIMT_Encode4(1022103), // Rule ID 13068 //
     /* 1022031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1022042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1022045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1022048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1022051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022070 */     // MIs[0] policy
     /* 1022070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022080 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1022083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022102 */     // GIR_Coverage, 13068,
     /* 1022102 */     GIR_EraseRootFromParent_Done,
     /* 1022103 */   // Label 15158: @1022103
     /* 1022103 */   GIM_Try, /*On fail goto*//*Label 15159*/ GIMT_Encode4(1022180), // Rule ID 13069 //
     /* 1022108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1022119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1022122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1022125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1022128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022147 */     // MIs[0] policy
     /* 1022147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022157 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1022160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022179 */     // GIR_Coverage, 13069,
     /* 1022179 */     GIR_EraseRootFromParent_Done,
     /* 1022180 */   // Label 15159: @1022180
     /* 1022180 */   GIM_Try, /*On fail goto*//*Label 15160*/ GIMT_Encode4(1022257), // Rule ID 13072 //
     /* 1022185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1022196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1022199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1022202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1022205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022224 */     // MIs[0] policy
     /* 1022224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022234 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1022237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022256 */     // GIR_Coverage, 13072,
     /* 1022256 */     GIR_EraseRootFromParent_Done,
     /* 1022257 */   // Label 15160: @1022257
     /* 1022257 */   GIM_Try, /*On fail goto*//*Label 15161*/ GIMT_Encode4(1022334), // Rule ID 13073 //
     /* 1022262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1022273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1022276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1022279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1022282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022301 */     // MIs[0] policy
     /* 1022301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022311 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1022314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022333 */     // GIR_Coverage, 13073,
     /* 1022333 */     GIR_EraseRootFromParent_Done,
     /* 1022334 */   // Label 15161: @1022334
     /* 1022334 */   GIM_Try, /*On fail goto*//*Label 15162*/ GIMT_Encode4(1022411), // Rule ID 13076 //
     /* 1022339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1022350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1022353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1022356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1022359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022378 */     // MIs[0] policy
     /* 1022378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022388 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1022391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022410 */     // GIR_Coverage, 13076,
     /* 1022410 */     GIR_EraseRootFromParent_Done,
     /* 1022411 */   // Label 15162: @1022411
     /* 1022411 */   GIM_Try, /*On fail goto*//*Label 15163*/ GIMT_Encode4(1022488), // Rule ID 13077 //
     /* 1022416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1022427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1022430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1022433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1022436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022455 */     // MIs[0] policy
     /* 1022455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022465 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1022468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022487 */     // GIR_Coverage, 13077,
     /* 1022487 */     GIR_EraseRootFromParent_Done,
     /* 1022488 */   // Label 15163: @1022488
     /* 1022488 */   GIM_Try, /*On fail goto*//*Label 15164*/ GIMT_Encode4(1022565), // Rule ID 13080 //
     /* 1022493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1022504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1022507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1022510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1022513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022532 */     // MIs[0] policy
     /* 1022532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022542 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1022545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022564 */     // GIR_Coverage, 13080,
     /* 1022564 */     GIR_EraseRootFromParent_Done,
     /* 1022565 */   // Label 15164: @1022565
     /* 1022565 */   GIM_Try, /*On fail goto*//*Label 15165*/ GIMT_Encode4(1022642), // Rule ID 13081 //
     /* 1022570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1022581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1022584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1022587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1022590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022609 */     // MIs[0] policy
     /* 1022609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022619 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1022622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022641 */     // GIR_Coverage, 13081,
     /* 1022641 */     GIR_EraseRootFromParent_Done,
     /* 1022642 */   // Label 15165: @1022642
     /* 1022642 */   GIM_Try, /*On fail goto*//*Label 15166*/ GIMT_Encode4(1022719), // Rule ID 13084 //
     /* 1022647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1022658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1022661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1022664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1022667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022686 */     // MIs[0] policy
     /* 1022686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1022699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022718 */     // GIR_Coverage, 13084,
     /* 1022718 */     GIR_EraseRootFromParent_Done,
     /* 1022719 */   // Label 15166: @1022719
     /* 1022719 */   GIM_Try, /*On fail goto*//*Label 15167*/ GIMT_Encode4(1022796), // Rule ID 13085 //
     /* 1022724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1022735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1022738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1022741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1022744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022763 */     // MIs[0] policy
     /* 1022763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022773 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1022776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022795 */     // GIR_Coverage, 13085,
     /* 1022795 */     GIR_EraseRootFromParent_Done,
     /* 1022796 */   // Label 15167: @1022796
     /* 1022796 */   GIM_Try, /*On fail goto*//*Label 15168*/ GIMT_Encode4(1022873), // Rule ID 13088 //
     /* 1022801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1022818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1022821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022840 */     // MIs[0] policy
     /* 1022840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022850 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1022853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022872 */     // GIR_Coverage, 13088,
     /* 1022872 */     GIR_EraseRootFromParent_Done,
     /* 1022873 */   // Label 15168: @1022873
     /* 1022873 */   GIM_Try, /*On fail goto*//*Label 15169*/ GIMT_Encode4(1022950), // Rule ID 13089 //
     /* 1022878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1022895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1022898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022917 */     // MIs[0] policy
     /* 1022917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022927 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1022930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022949 */     // GIR_Coverage, 13089,
     /* 1022949 */     GIR_EraseRootFromParent_Done,
     /* 1022950 */   // Label 15169: @1022950
     /* 1022950 */   GIM_Try, /*On fail goto*//*Label 15170*/ GIMT_Encode4(1023027), // Rule ID 13092 //
     /* 1022955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1022966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1022969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1022972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1022975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022994 */     // MIs[0] policy
     /* 1022994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023004 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023026 */     // GIR_Coverage, 13092,
     /* 1023026 */     GIR_EraseRootFromParent_Done,
     /* 1023027 */   // Label 15170: @1023027
     /* 1023027 */   GIM_Try, /*On fail goto*//*Label 15171*/ GIMT_Encode4(1023104), // Rule ID 13093 //
     /* 1023032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1023043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1023046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1023049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1023052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023071 */     // MIs[0] policy
     /* 1023071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023081 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023103 */     // GIR_Coverage, 13093,
     /* 1023103 */     GIR_EraseRootFromParent_Done,
     /* 1023104 */   // Label 15171: @1023104
     /* 1023104 */   GIM_Try, /*On fail goto*//*Label 15172*/ GIMT_Encode4(1023181), // Rule ID 13096 //
     /* 1023109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1023120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1023123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1023126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1023129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023148 */     // MIs[0] policy
     /* 1023148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023180 */     // GIR_Coverage, 13096,
     /* 1023180 */     GIR_EraseRootFromParent_Done,
     /* 1023181 */   // Label 15172: @1023181
     /* 1023181 */   GIM_Try, /*On fail goto*//*Label 15173*/ GIMT_Encode4(1023258), // Rule ID 13097 //
     /* 1023186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1023197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1023200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1023203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1023206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023225 */     // MIs[0] policy
     /* 1023225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023235 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023257 */     // GIR_Coverage, 13097,
     /* 1023257 */     GIR_EraseRootFromParent_Done,
     /* 1023258 */   // Label 15173: @1023258
     /* 1023258 */   GIM_Try, /*On fail goto*//*Label 15174*/ GIMT_Encode4(1023335), // Rule ID 13100 //
     /* 1023263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1023274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1023277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1023280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1023283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023302 */     // MIs[0] policy
     /* 1023302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023312 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023334 */     // GIR_Coverage, 13100,
     /* 1023334 */     GIR_EraseRootFromParent_Done,
     /* 1023335 */   // Label 15174: @1023335
     /* 1023335 */   GIM_Try, /*On fail goto*//*Label 15175*/ GIMT_Encode4(1023412), // Rule ID 13101 //
     /* 1023340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1023351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1023354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1023357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1023360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023379 */     // MIs[0] policy
     /* 1023379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023389 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023411 */     // GIR_Coverage, 13101,
     /* 1023411 */     GIR_EraseRootFromParent_Done,
     /* 1023412 */   // Label 15175: @1023412
     /* 1023412 */   GIM_Try, /*On fail goto*//*Label 15176*/ GIMT_Encode4(1023489), // Rule ID 13104 //
     /* 1023417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1023420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1023428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1023431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1023434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1023437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023456 */     // MIs[0] policy
     /* 1023456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023466 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1023485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023488 */     // GIR_Coverage, 13104,
     /* 1023488 */     GIR_EraseRootFromParent_Done,
     /* 1023489 */   // Label 15176: @1023489
     /* 1023489 */   GIM_Try, /*On fail goto*//*Label 15177*/ GIMT_Encode4(1023566), // Rule ID 13105 //
     /* 1023494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1023497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1023505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1023508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1023511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1023514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023533 */     // MIs[0] policy
     /* 1023533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023543 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1023562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023565 */     // GIR_Coverage, 13105,
     /* 1023565 */     GIR_EraseRootFromParent_Done,
     /* 1023566 */   // Label 15177: @1023566
     /* 1023566 */   GIM_Try, /*On fail goto*//*Label 15178*/ GIMT_Encode4(1023643), // Rule ID 13108 //
     /* 1023571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1023582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1023585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1023588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023610 */     // MIs[0] policy
     /* 1023610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023620 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1023623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023642 */     // GIR_Coverage, 13108,
     /* 1023642 */     GIR_EraseRootFromParent_Done,
     /* 1023643 */   // Label 15178: @1023643
     /* 1023643 */   GIM_Try, /*On fail goto*//*Label 15179*/ GIMT_Encode4(1023720), // Rule ID 13109 //
     /* 1023648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1023659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1023662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1023665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023687 */     // MIs[0] policy
     /* 1023687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023697 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1023700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023719 */     // GIR_Coverage, 13109,
     /* 1023719 */     GIR_EraseRootFromParent_Done,
     /* 1023720 */   // Label 15179: @1023720
     /* 1023720 */   GIM_Try, /*On fail goto*//*Label 15180*/ GIMT_Encode4(1023797), // Rule ID 13112 //
     /* 1023725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1023736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1023739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1023742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023764 */     // MIs[0] policy
     /* 1023764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023774 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1023777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023796 */     // GIR_Coverage, 13112,
     /* 1023796 */     GIR_EraseRootFromParent_Done,
     /* 1023797 */   // Label 15180: @1023797
     /* 1023797 */   GIM_Try, /*On fail goto*//*Label 15181*/ GIMT_Encode4(1023874), // Rule ID 13113 //
     /* 1023802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1023813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1023816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1023819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023841 */     // MIs[0] policy
     /* 1023841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023851 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1023854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023873 */     // GIR_Coverage, 13113,
     /* 1023873 */     GIR_EraseRootFromParent_Done,
     /* 1023874 */   // Label 15181: @1023874
     /* 1023874 */   GIM_Try, /*On fail goto*//*Label 15182*/ GIMT_Encode4(1023951), // Rule ID 13116 //
     /* 1023879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1023890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1023893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1023896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023918 */     // MIs[0] policy
     /* 1023918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023928 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1023931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023950 */     // GIR_Coverage, 13116,
     /* 1023950 */     GIR_EraseRootFromParent_Done,
     /* 1023951 */   // Label 15182: @1023951
     /* 1023951 */   GIM_Try, /*On fail goto*//*Label 15183*/ GIMT_Encode4(1024028), // Rule ID 13117 //
     /* 1023956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1023967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1023970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1023973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023995 */     // MIs[0] policy
     /* 1023995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024005 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1024008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1024024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024027 */     // GIR_Coverage, 13117,
     /* 1024027 */     GIR_EraseRootFromParent_Done,
     /* 1024028 */   // Label 15183: @1024028
     /* 1024028 */   GIM_Try, /*On fail goto*//*Label 15184*/ GIMT_Encode4(1024105), // Rule ID 13120 //
     /* 1024033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1024044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1024047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1024050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1024053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024072 */     // MIs[0] policy
     /* 1024072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024082 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1024085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024104 */     // GIR_Coverage, 13120,
     /* 1024104 */     GIR_EraseRootFromParent_Done,
     /* 1024105 */   // Label 15184: @1024105
     /* 1024105 */   GIM_Try, /*On fail goto*//*Label 15185*/ GIMT_Encode4(1024182), // Rule ID 13121 //
     /* 1024110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1024121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1024124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1024127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1024130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024149 */     // MIs[0] policy
     /* 1024149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024159 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1024162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024181 */     // GIR_Coverage, 13121,
     /* 1024181 */     GIR_EraseRootFromParent_Done,
     /* 1024182 */   // Label 15185: @1024182
     /* 1024182 */   GIM_Try, /*On fail goto*//*Label 15186*/ GIMT_Encode4(1024259), // Rule ID 13124 //
     /* 1024187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1024198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1024201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1024204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1024207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024226 */     // MIs[0] policy
     /* 1024226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024236 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1024239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024258 */     // GIR_Coverage, 13124,
     /* 1024258 */     GIR_EraseRootFromParent_Done,
     /* 1024259 */   // Label 15186: @1024259
     /* 1024259 */   GIM_Try, /*On fail goto*//*Label 15187*/ GIMT_Encode4(1024336), // Rule ID 13125 //
     /* 1024264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1024275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1024278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1024281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1024284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024303 */     // MIs[0] policy
     /* 1024303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024313 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1024316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024335 */     // GIR_Coverage, 13125,
     /* 1024335 */     GIR_EraseRootFromParent_Done,
     /* 1024336 */   // Label 15187: @1024336
     /* 1024336 */   GIM_Try, /*On fail goto*//*Label 15188*/ GIMT_Encode4(1024413), // Rule ID 13128 //
     /* 1024341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1024352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1024355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1024358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1024361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024380 */     // MIs[0] policy
     /* 1024380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024390 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1024393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024412 */     // GIR_Coverage, 13128,
     /* 1024412 */     GIR_EraseRootFromParent_Done,
     /* 1024413 */   // Label 15188: @1024413
     /* 1024413 */   GIM_Try, /*On fail goto*//*Label 15189*/ GIMT_Encode4(1024490), // Rule ID 13129 //
     /* 1024418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1024429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1024432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1024435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1024438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024457 */     // MIs[0] policy
     /* 1024457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024467 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1024470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024489 */     // GIR_Coverage, 13129,
     /* 1024489 */     GIR_EraseRootFromParent_Done,
     /* 1024490 */   // Label 15189: @1024490
     /* 1024490 */   GIM_Try, /*On fail goto*//*Label 15190*/ GIMT_Encode4(1024567), // Rule ID 13132 //
     /* 1024495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1024512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1024515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024534 */     // MIs[0] policy
     /* 1024534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1024547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024566 */     // GIR_Coverage, 13132,
     /* 1024566 */     GIR_EraseRootFromParent_Done,
     /* 1024567 */   // Label 15190: @1024567
     /* 1024567 */   GIM_Try, /*On fail goto*//*Label 15191*/ GIMT_Encode4(1024644), // Rule ID 13133 //
     /* 1024572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1024589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1024592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024611 */     // MIs[0] policy
     /* 1024611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024621 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1024624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024643 */     // GIR_Coverage, 13133,
     /* 1024643 */     GIR_EraseRootFromParent_Done,
     /* 1024644 */   // Label 15191: @1024644
     /* 1024644 */   GIM_Try, /*On fail goto*//*Label 15192*/ GIMT_Encode4(1024721), // Rule ID 13136 //
     /* 1024649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1024666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1024669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024688 */     // MIs[0] policy
     /* 1024688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024698 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1024701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024720 */     // GIR_Coverage, 13136,
     /* 1024720 */     GIR_EraseRootFromParent_Done,
     /* 1024721 */   // Label 15192: @1024721
     /* 1024721 */   GIM_Try, /*On fail goto*//*Label 15193*/ GIMT_Encode4(1024798), // Rule ID 13137 //
     /* 1024726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1024743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1024746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024765 */     // MIs[0] policy
     /* 1024765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024775 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1024778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024797 */     // GIR_Coverage, 13137,
     /* 1024797 */     GIR_EraseRootFromParent_Done,
     /* 1024798 */   // Label 15193: @1024798
     /* 1024798 */   GIM_Try, /*On fail goto*//*Label 15194*/ GIMT_Encode4(1024875), // Rule ID 13140 //
     /* 1024803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1024820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1024823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024842 */     // MIs[0] policy
     /* 1024842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024852 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1024855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024874 */     // GIR_Coverage, 13140,
     /* 1024874 */     GIR_EraseRootFromParent_Done,
     /* 1024875 */   // Label 15194: @1024875
     /* 1024875 */   GIM_Try, /*On fail goto*//*Label 15195*/ GIMT_Encode4(1024952), // Rule ID 13141 //
     /* 1024880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1024897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1024900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024919 */     // MIs[0] policy
     /* 1024919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024929 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1024932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024951 */     // GIR_Coverage, 13141,
     /* 1024951 */     GIR_EraseRootFromParent_Done,
     /* 1024952 */   // Label 15195: @1024952
     /* 1024952 */   GIM_Try, /*On fail goto*//*Label 15196*/ GIMT_Encode4(1025029), // Rule ID 13144 //
     /* 1024957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1024960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1024968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1024971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1024974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1024977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024996 */     // MIs[0] policy
     /* 1024996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1025009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025028 */     // GIR_Coverage, 13144,
     /* 1025028 */     GIR_EraseRootFromParent_Done,
     /* 1025029 */   // Label 15196: @1025029
     /* 1025029 */   GIM_Try, /*On fail goto*//*Label 15197*/ GIMT_Encode4(1025106), // Rule ID 13145 //
     /* 1025034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1025037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1025045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1025048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1025051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1025054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025073 */     // MIs[0] policy
     /* 1025073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025083 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1025086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025105 */     // GIR_Coverage, 13145,
     /* 1025105 */     GIR_EraseRootFromParent_Done,
     /* 1025106 */   // Label 15197: @1025106
     /* 1025106 */   GIM_Try, /*On fail goto*//*Label 15198*/ GIMT_Encode4(1025183), // Rule ID 13148 //
     /* 1025111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1025114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1025122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1025125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1025128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1025131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025150 */     // MIs[0] policy
     /* 1025150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025160 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1025163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025182 */     // GIR_Coverage, 13148,
     /* 1025182 */     GIR_EraseRootFromParent_Done,
     /* 1025183 */   // Label 15198: @1025183
     /* 1025183 */   GIM_Try, /*On fail goto*//*Label 15199*/ GIMT_Encode4(1025260), // Rule ID 13149 //
     /* 1025188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1025191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1025199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1025202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1025205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1025208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025227 */     // MIs[0] policy
     /* 1025227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025237 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1025240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025259 */     // GIR_Coverage, 13149,
     /* 1025259 */     GIR_EraseRootFromParent_Done,
     /* 1025260 */   // Label 15199: @1025260
     /* 1025260 */   GIM_Try, /*On fail goto*//*Label 15200*/ GIMT_Encode4(1025337), // Rule ID 13152 //
     /* 1025265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1025268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1025276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1025279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1025282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1025285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025304 */     // MIs[0] policy
     /* 1025304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025314 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1025317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025336 */     // GIR_Coverage, 13152,
     /* 1025336 */     GIR_EraseRootFromParent_Done,
     /* 1025337 */   // Label 15200: @1025337
     /* 1025337 */   GIM_Try, /*On fail goto*//*Label 15201*/ GIMT_Encode4(1025414), // Rule ID 13153 //
     /* 1025342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1025345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1025353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1025356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1025359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1025362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025381 */     // MIs[0] policy
     /* 1025381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025391 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1025394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025413 */     // GIR_Coverage, 13153,
     /* 1025413 */     GIR_EraseRootFromParent_Done,
     /* 1025414 */   // Label 15201: @1025414
     /* 1025414 */   GIM_Try, /*On fail goto*//*Label 15202*/ GIMT_Encode4(1025491), // Rule ID 13156 //
     /* 1025419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1025430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1025433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1025436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1025439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025458 */     // MIs[0] policy
     /* 1025458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025468 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1025471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025490 */     // GIR_Coverage, 13156,
     /* 1025490 */     GIR_EraseRootFromParent_Done,
     /* 1025491 */   // Label 15202: @1025491
     /* 1025491 */   GIM_Try, /*On fail goto*//*Label 15203*/ GIMT_Encode4(1025568), // Rule ID 13157 //
     /* 1025496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1025507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1025510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1025516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025535 */     // MIs[0] policy
     /* 1025535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025545 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1025548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025567 */     // GIR_Coverage, 13157,
     /* 1025567 */     GIR_EraseRootFromParent_Done,
     /* 1025568 */   // Label 15203: @1025568
     /* 1025568 */   GIM_Try, /*On fail goto*//*Label 15204*/ GIMT_Encode4(1025645), // Rule ID 13160 //
     /* 1025573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1025584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1025587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1025590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1025593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025612 */     // MIs[0] policy
     /* 1025612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025622 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1025625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025644 */     // GIR_Coverage, 13160,
     /* 1025644 */     GIR_EraseRootFromParent_Done,
     /* 1025645 */   // Label 15204: @1025645
     /* 1025645 */   GIM_Try, /*On fail goto*//*Label 15205*/ GIMT_Encode4(1025722), // Rule ID 13161 //
     /* 1025650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1025661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1025664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1025670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025689 */     // MIs[0] policy
     /* 1025689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025699 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1025702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025721 */     // GIR_Coverage, 13161,
     /* 1025721 */     GIR_EraseRootFromParent_Done,
     /* 1025722 */   // Label 15205: @1025722
     /* 1025722 */   GIM_Try, /*On fail goto*//*Label 15206*/ GIMT_Encode4(1025799), // Rule ID 13164 //
     /* 1025727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1025738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1025741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1025744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1025747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025766 */     // MIs[0] policy
     /* 1025766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025776 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1025779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025798 */     // GIR_Coverage, 13164,
     /* 1025798 */     GIR_EraseRootFromParent_Done,
     /* 1025799 */   // Label 15206: @1025799
     /* 1025799 */   GIM_Try, /*On fail goto*//*Label 15207*/ GIMT_Encode4(1025876), // Rule ID 13165 //
     /* 1025804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1025815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1025818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1025824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025843 */     // MIs[0] policy
     /* 1025843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025853 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1025856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025875 */     // GIR_Coverage, 13165,
     /* 1025875 */     GIR_EraseRootFromParent_Done,
     /* 1025876 */   // Label 15207: @1025876
     /* 1025876 */   GIM_Try, /*On fail goto*//*Label 15208*/ GIMT_Encode4(1025953), // Rule ID 13168 //
     /* 1025881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1025892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1025895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1025898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1025901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025920 */     // MIs[0] policy
     /* 1025920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025930 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1025933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025952 */     // GIR_Coverage, 13168,
     /* 1025952 */     GIR_EraseRootFromParent_Done,
     /* 1025953 */   // Label 15208: @1025953
     /* 1025953 */   GIM_Try, /*On fail goto*//*Label 15209*/ GIMT_Encode4(1026030), // Rule ID 13169 //
     /* 1025958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1025969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1025972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1025978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025997 */     // MIs[0] policy
     /* 1025997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026007 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1026010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026029 */     // GIR_Coverage, 13169,
     /* 1026029 */     GIR_EraseRootFromParent_Done,
     /* 1026030 */   // Label 15209: @1026030
     /* 1026030 */   GIM_Try, /*On fail goto*//*Label 15210*/ GIMT_Encode4(1026107), // Rule ID 13172 //
     /* 1026035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1026046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1026049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1026055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026074 */     // MIs[0] policy
     /* 1026074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026084 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1026087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026106 */     // GIR_Coverage, 13172,
     /* 1026106 */     GIR_EraseRootFromParent_Done,
     /* 1026107 */   // Label 15210: @1026107
     /* 1026107 */   GIM_Try, /*On fail goto*//*Label 15211*/ GIMT_Encode4(1026184), // Rule ID 13173 //
     /* 1026112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1026123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1026126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1026129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1026132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026151 */     // MIs[0] policy
     /* 1026151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026161 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1026164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026183 */     // GIR_Coverage, 13173,
     /* 1026183 */     GIR_EraseRootFromParent_Done,
     /* 1026184 */   // Label 15211: @1026184
     /* 1026184 */   GIM_Try, /*On fail goto*//*Label 15212*/ GIMT_Encode4(1026261), // Rule ID 13176 //
     /* 1026189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1026200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1026203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1026209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026228 */     // MIs[0] policy
     /* 1026228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026238 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1026241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026260 */     // GIR_Coverage, 13176,
     /* 1026260 */     GIR_EraseRootFromParent_Done,
     /* 1026261 */   // Label 15212: @1026261
     /* 1026261 */   GIM_Try, /*On fail goto*//*Label 15213*/ GIMT_Encode4(1026338), // Rule ID 13177 //
     /* 1026266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1026277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1026280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1026283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1026286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026305 */     // MIs[0] policy
     /* 1026305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026315 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1026318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026337 */     // GIR_Coverage, 13177,
     /* 1026337 */     GIR_EraseRootFromParent_Done,
     /* 1026338 */   // Label 15213: @1026338
     /* 1026338 */   GIM_Try, /*On fail goto*//*Label 15214*/ GIMT_Encode4(1026415), // Rule ID 13180 //
     /* 1026343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1026354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1026357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1026363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026382 */     // MIs[0] policy
     /* 1026382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026392 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026414 */     // GIR_Coverage, 13180,
     /* 1026414 */     GIR_EraseRootFromParent_Done,
     /* 1026415 */   // Label 15214: @1026415
     /* 1026415 */   GIM_Try, /*On fail goto*//*Label 15215*/ GIMT_Encode4(1026492), // Rule ID 13181 //
     /* 1026420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1026431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1026434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1026437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1026440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026459 */     // MIs[0] policy
     /* 1026459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026469 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026491 */     // GIR_Coverage, 13181,
     /* 1026491 */     GIR_EraseRootFromParent_Done,
     /* 1026492 */   // Label 15215: @1026492
     /* 1026492 */   GIM_Try, /*On fail goto*//*Label 15216*/ GIMT_Encode4(1026569), // Rule ID 13184 //
     /* 1026497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1026508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1026511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1026517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026536 */     // MIs[0] policy
     /* 1026536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026568 */     // GIR_Coverage, 13184,
     /* 1026568 */     GIR_EraseRootFromParent_Done,
     /* 1026569 */   // Label 15216: @1026569
     /* 1026569 */   GIM_Try, /*On fail goto*//*Label 15217*/ GIMT_Encode4(1026646), // Rule ID 13185 //
     /* 1026574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1026585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1026588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1026591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1026594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026613 */     // MIs[0] policy
     /* 1026613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026623 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026645 */     // GIR_Coverage, 13185,
     /* 1026645 */     GIR_EraseRootFromParent_Done,
     /* 1026646 */   // Label 15217: @1026646
     /* 1026646 */   GIM_Try, /*On fail goto*//*Label 15218*/ GIMT_Encode4(1026723), // Rule ID 13188 //
     /* 1026651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1026671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026690 */     // MIs[0] policy
     /* 1026690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026722 */     // GIR_Coverage, 13188,
     /* 1026722 */     GIR_EraseRootFromParent_Done,
     /* 1026723 */   // Label 15218: @1026723
     /* 1026723 */   GIM_Try, /*On fail goto*//*Label 15219*/ GIMT_Encode4(1026800), // Rule ID 13189 //
     /* 1026728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1026745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1026748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026767 */     // MIs[0] policy
     /* 1026767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026777 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026799 */     // GIR_Coverage, 13189,
     /* 1026799 */     GIR_EraseRootFromParent_Done,
     /* 1026800 */   // Label 15219: @1026800
     /* 1026800 */   GIM_Try, /*On fail goto*//*Label 15220*/ GIMT_Encode4(1026877), // Rule ID 13192 //
     /* 1026805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1026808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1026816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1026819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1026825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026844 */     // MIs[0] policy
     /* 1026844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026854 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1026873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026876 */     // GIR_Coverage, 13192,
     /* 1026876 */     GIR_EraseRootFromParent_Done,
     /* 1026877 */   // Label 15220: @1026877
     /* 1026877 */   GIM_Try, /*On fail goto*//*Label 15221*/ GIMT_Encode4(1026954), // Rule ID 13193 //
     /* 1026882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1026885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1026893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1026896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1026899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1026902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026921 */     // MIs[0] policy
     /* 1026921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026931 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1026950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026953 */     // GIR_Coverage, 13193,
     /* 1026953 */     GIR_EraseRootFromParent_Done,
     /* 1026954 */   // Label 15221: @1026954
     /* 1026954 */   GIM_Try, /*On fail goto*//*Label 15222*/ GIMT_Encode4(1027031), // Rule ID 13196 //
     /* 1026959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1026970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1026973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026998 */     // MIs[0] policy
     /* 1026998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027008 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1027011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027030 */     // GIR_Coverage, 13196,
     /* 1027030 */     GIR_EraseRootFromParent_Done,
     /* 1027031 */   // Label 15222: @1027031
     /* 1027031 */   GIM_Try, /*On fail goto*//*Label 15223*/ GIMT_Encode4(1027108), // Rule ID 13197 //
     /* 1027036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1027047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1027050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1027056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027075 */     // MIs[0] policy
     /* 1027075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027085 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1027088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027107 */     // GIR_Coverage, 13197,
     /* 1027107 */     GIR_EraseRootFromParent_Done,
     /* 1027108 */   // Label 15223: @1027108
     /* 1027108 */   GIM_Try, /*On fail goto*//*Label 15224*/ GIMT_Encode4(1027185), // Rule ID 13200 //
     /* 1027113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1027124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1027127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1027130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1027133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027152 */     // MIs[0] policy
     /* 1027152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027162 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1027165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027184 */     // GIR_Coverage, 13200,
     /* 1027184 */     GIR_EraseRootFromParent_Done,
     /* 1027185 */   // Label 15224: @1027185
     /* 1027185 */   GIM_Try, /*On fail goto*//*Label 15225*/ GIMT_Encode4(1027262), // Rule ID 13201 //
     /* 1027190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1027201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1027204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1027210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027229 */     // MIs[0] policy
     /* 1027229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027239 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1027242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027261 */     // GIR_Coverage, 13201,
     /* 1027261 */     GIR_EraseRootFromParent_Done,
     /* 1027262 */   // Label 15225: @1027262
     /* 1027262 */   GIM_Try, /*On fail goto*//*Label 15226*/ GIMT_Encode4(1027339), // Rule ID 13204 //
     /* 1027267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1027278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1027281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1027284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1027287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027306 */     // MIs[0] policy
     /* 1027306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027316 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1027319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027338 */     // GIR_Coverage, 13204,
     /* 1027338 */     GIR_EraseRootFromParent_Done,
     /* 1027339 */   // Label 15226: @1027339
     /* 1027339 */   GIM_Try, /*On fail goto*//*Label 15227*/ GIMT_Encode4(1027416), // Rule ID 13205 //
     /* 1027344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1027355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1027358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1027364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027383 */     // MIs[0] policy
     /* 1027383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027393 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1027396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027415 */     // GIR_Coverage, 13205,
     /* 1027415 */     GIR_EraseRootFromParent_Done,
     /* 1027416 */   // Label 15227: @1027416
     /* 1027416 */   GIM_Try, /*On fail goto*//*Label 15228*/ GIMT_Encode4(1027493), // Rule ID 13208 //
     /* 1027421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1027432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1027435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1027438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1027441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027460 */     // MIs[0] policy
     /* 1027460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1027473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027492 */     // GIR_Coverage, 13208,
     /* 1027492 */     GIR_EraseRootFromParent_Done,
     /* 1027493 */   // Label 15228: @1027493
     /* 1027493 */   GIM_Try, /*On fail goto*//*Label 15229*/ GIMT_Encode4(1027570), // Rule ID 13209 //
     /* 1027498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1027509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1027512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1027518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027537 */     // MIs[0] policy
     /* 1027537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027547 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1027550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027569 */     // GIR_Coverage, 13209,
     /* 1027569 */     GIR_EraseRootFromParent_Done,
     /* 1027570 */   // Label 15229: @1027570
     /* 1027570 */   GIM_Try, /*On fail goto*//*Label 15230*/ GIMT_Encode4(1027647), // Rule ID 13212 //
     /* 1027575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1027586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1027589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1027592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1027595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027614 */     // MIs[0] policy
     /* 1027614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027624 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1027627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027646 */     // GIR_Coverage, 13212,
     /* 1027646 */     GIR_EraseRootFromParent_Done,
     /* 1027647 */   // Label 15230: @1027647
     /* 1027647 */   GIM_Try, /*On fail goto*//*Label 15231*/ GIMT_Encode4(1027724), // Rule ID 13213 //
     /* 1027652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1027663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1027666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1027672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027691 */     // MIs[0] policy
     /* 1027691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027701 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1027704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027723 */     // GIR_Coverage, 13213,
     /* 1027723 */     GIR_EraseRootFromParent_Done,
     /* 1027724 */   // Label 15231: @1027724
     /* 1027724 */   GIM_Try, /*On fail goto*//*Label 15232*/ GIMT_Encode4(1027801), // Rule ID 13216 //
     /* 1027729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1027740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1027743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1027746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1027749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027768 */     // MIs[0] policy
     /* 1027768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027778 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1027781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027800 */     // GIR_Coverage, 13216,
     /* 1027800 */     GIR_EraseRootFromParent_Done,
     /* 1027801 */   // Label 15232: @1027801
     /* 1027801 */   GIM_Try, /*On fail goto*//*Label 15233*/ GIMT_Encode4(1027878), // Rule ID 13217 //
     /* 1027806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1027817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1027820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1027826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027845 */     // MIs[0] policy
     /* 1027845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027855 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1027858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027877 */     // GIR_Coverage, 13217,
     /* 1027877 */     GIR_EraseRootFromParent_Done,
     /* 1027878 */   // Label 15233: @1027878
     /* 1027878 */   GIM_Try, /*On fail goto*//*Label 15234*/ GIMT_Encode4(1027955), // Rule ID 13220 //
     /* 1027883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1027900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1027903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027922 */     // MIs[0] policy
     /* 1027922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027932 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1027935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027954 */     // GIR_Coverage, 13220,
     /* 1027954 */     GIR_EraseRootFromParent_Done,
     /* 1027955 */   // Label 15234: @1027955
     /* 1027955 */   GIM_Try, /*On fail goto*//*Label 15235*/ GIMT_Encode4(1028032), // Rule ID 13221 //
     /* 1027960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1027980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027999 */     // MIs[0] policy
     /* 1027999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028009 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1028012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028031 */     // GIR_Coverage, 13221,
     /* 1028031 */     GIR_EraseRootFromParent_Done,
     /* 1028032 */   // Label 15235: @1028032
     /* 1028032 */   GIM_Try, /*On fail goto*//*Label 15236*/ GIMT_Encode4(1028109), // Rule ID 13224 //
     /* 1028037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1028048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1028051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1028057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028076 */     // MIs[0] policy
     /* 1028076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028086 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1028089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028108 */     // GIR_Coverage, 13224,
     /* 1028108 */     GIR_EraseRootFromParent_Done,
     /* 1028109 */   // Label 15236: @1028109
     /* 1028109 */   GIM_Try, /*On fail goto*//*Label 15237*/ GIMT_Encode4(1028186), // Rule ID 13225 //
     /* 1028114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1028125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1028128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1028134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028153 */     // MIs[0] policy
     /* 1028153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028163 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1028166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028185 */     // GIR_Coverage, 13225,
     /* 1028185 */     GIR_EraseRootFromParent_Done,
     /* 1028186 */   // Label 15237: @1028186
     /* 1028186 */   GIM_Try, /*On fail goto*//*Label 15238*/ GIMT_Encode4(1028263), // Rule ID 13228 //
     /* 1028191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1028202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1028205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1028211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028230 */     // MIs[0] policy
     /* 1028230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028240 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1028243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028262 */     // GIR_Coverage, 13228,
     /* 1028262 */     GIR_EraseRootFromParent_Done,
     /* 1028263 */   // Label 15238: @1028263
     /* 1028263 */   GIM_Try, /*On fail goto*//*Label 15239*/ GIMT_Encode4(1028340), // Rule ID 13229 //
     /* 1028268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1028279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1028282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1028288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028307 */     // MIs[0] policy
     /* 1028307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028317 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1028320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028339 */     // GIR_Coverage, 13229,
     /* 1028339 */     GIR_EraseRootFromParent_Done,
     /* 1028340 */   // Label 15239: @1028340
     /* 1028340 */   GIM_Try, /*On fail goto*//*Label 15240*/ GIMT_Encode4(1028417), // Rule ID 13232 //
     /* 1028345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1028356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1028359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1028365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028384 */     // MIs[0] policy
     /* 1028384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1028397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028416 */     // GIR_Coverage, 13232,
     /* 1028416 */     GIR_EraseRootFromParent_Done,
     /* 1028417 */   // Label 15240: @1028417
     /* 1028417 */   GIM_Try, /*On fail goto*//*Label 15241*/ GIMT_Encode4(1028494), // Rule ID 13233 //
     /* 1028422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1028433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1028436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1028442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028461 */     // MIs[0] policy
     /* 1028461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028471 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1028474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028493 */     // GIR_Coverage, 13233,
     /* 1028493 */     GIR_EraseRootFromParent_Done,
     /* 1028494 */   // Label 15241: @1028494
     /* 1028494 */   GIM_Try, /*On fail goto*//*Label 15242*/ GIMT_Encode4(1028571), // Rule ID 13236 //
     /* 1028499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1028510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1028513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1028519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028538 */     // MIs[0] policy
     /* 1028538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028548 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1028551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028570 */     // GIR_Coverage, 13236,
     /* 1028570 */     GIR_EraseRootFromParent_Done,
     /* 1028571 */   // Label 15242: @1028571
     /* 1028571 */   GIM_Try, /*On fail goto*//*Label 15243*/ GIMT_Encode4(1028648), // Rule ID 13237 //
     /* 1028576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1028587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1028590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1028596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028615 */     // MIs[0] policy
     /* 1028615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028625 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1028628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028647 */     // GIR_Coverage, 13237,
     /* 1028647 */     GIR_EraseRootFromParent_Done,
     /* 1028648 */   // Label 15243: @1028648
     /* 1028648 */   GIM_Try, /*On fail goto*//*Label 15244*/ GIMT_Encode4(1028725), // Rule ID 13240 //
     /* 1028653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1028664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1028667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1028673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028692 */     // MIs[0] policy
     /* 1028692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028702 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1028705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028724 */     // GIR_Coverage, 13240,
     /* 1028724 */     GIR_EraseRootFromParent_Done,
     /* 1028725 */   // Label 15244: @1028725
     /* 1028725 */   GIM_Try, /*On fail goto*//*Label 15245*/ GIMT_Encode4(1028802), // Rule ID 13241 //
     /* 1028730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1028741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1028744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1028750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028769 */     // MIs[0] policy
     /* 1028769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028779 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1028782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028801 */     // GIR_Coverage, 13241,
     /* 1028801 */     GIR_EraseRootFromParent_Done,
     /* 1028802 */   // Label 15245: @1028802
     /* 1028802 */   GIM_Try, /*On fail goto*//*Label 15246*/ GIMT_Encode4(1028879), // Rule ID 13244 //
     /* 1028807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1028818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1028821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1028824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1028827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028846 */     // MIs[0] policy
     /* 1028846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028856 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1028859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028878 */     // GIR_Coverage, 13244,
     /* 1028878 */     GIR_EraseRootFromParent_Done,
     /* 1028879 */   // Label 15246: @1028879
     /* 1028879 */   GIM_Try, /*On fail goto*//*Label 15247*/ GIMT_Encode4(1028956), // Rule ID 13245 //
     /* 1028884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1028895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1028898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1028901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1028904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028923 */     // MIs[0] policy
     /* 1028923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028933 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1028936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028955 */     // GIR_Coverage, 13245,
     /* 1028955 */     GIR_EraseRootFromParent_Done,
     /* 1028956 */   // Label 15247: @1028956
     /* 1028956 */   GIM_Try, /*On fail goto*//*Label 15248*/ GIMT_Encode4(1029033), // Rule ID 13248 //
     /* 1028961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1028972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1028975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1028978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1028981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029000 */     // MIs[0] policy
     /* 1029000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029010 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1029013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029032 */     // GIR_Coverage, 13248,
     /* 1029032 */     GIR_EraseRootFromParent_Done,
     /* 1029033 */   // Label 15248: @1029033
     /* 1029033 */   GIM_Try, /*On fail goto*//*Label 15249*/ GIMT_Encode4(1029110), // Rule ID 13249 //
     /* 1029038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1029049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1029052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1029055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1029058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029077 */     // MIs[0] policy
     /* 1029077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029087 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1029090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029109 */     // GIR_Coverage, 13249,
     /* 1029109 */     GIR_EraseRootFromParent_Done,
     /* 1029110 */   // Label 15249: @1029110
     /* 1029110 */   GIM_Try, /*On fail goto*//*Label 15250*/ GIMT_Encode4(1029187), // Rule ID 13252 //
     /* 1029115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1029126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1029129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1029132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1029135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029154 */     // MIs[0] policy
     /* 1029154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029164 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1029167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029186 */     // GIR_Coverage, 13252,
     /* 1029186 */     GIR_EraseRootFromParent_Done,
     /* 1029187 */   // Label 15250: @1029187
     /* 1029187 */   GIM_Try, /*On fail goto*//*Label 15251*/ GIMT_Encode4(1029264), // Rule ID 13253 //
     /* 1029192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1029203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1029206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1029209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1029212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029231 */     // MIs[0] policy
     /* 1029231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029241 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1029244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029263 */     // GIR_Coverage, 13253,
     /* 1029263 */     GIR_EraseRootFromParent_Done,
     /* 1029264 */   // Label 15251: @1029264
     /* 1029264 */   GIM_Try, /*On fail goto*//*Label 15252*/ GIMT_Encode4(1029341), // Rule ID 13256 //
     /* 1029269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1029280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1029283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1029286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1029289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029308 */     // MIs[0] policy
     /* 1029308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029318 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1029321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029340 */     // GIR_Coverage, 13256,
     /* 1029340 */     GIR_EraseRootFromParent_Done,
     /* 1029341 */   // Label 15252: @1029341
     /* 1029341 */   GIM_Try, /*On fail goto*//*Label 15253*/ GIMT_Encode4(1029418), // Rule ID 13257 //
     /* 1029346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1029357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1029360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1029363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1029366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029385 */     // MIs[0] policy
     /* 1029385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029395 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1029398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029417 */     // GIR_Coverage, 13257,
     /* 1029417 */     GIR_EraseRootFromParent_Done,
     /* 1029418 */   // Label 15253: @1029418
     /* 1029418 */   GIM_Try, /*On fail goto*//*Label 15254*/ GIMT_Encode4(1029495), // Rule ID 13260 //
     /* 1029423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1029434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1029437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1029440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1029443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029462 */     // MIs[0] policy
     /* 1029462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029472 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1029475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029494 */     // GIR_Coverage, 13260,
     /* 1029494 */     GIR_EraseRootFromParent_Done,
     /* 1029495 */   // Label 15254: @1029495
     /* 1029495 */   GIM_Try, /*On fail goto*//*Label 15255*/ GIMT_Encode4(1029572), // Rule ID 13261 //
     /* 1029500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1029511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1029514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1029517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1029520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029539 */     // MIs[0] policy
     /* 1029539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029549 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1029552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029571 */     // GIR_Coverage, 13261,
     /* 1029571 */     GIR_EraseRootFromParent_Done,
     /* 1029572 */   // Label 15255: @1029572
     /* 1029572 */   GIM_Try, /*On fail goto*//*Label 15256*/ GIMT_Encode4(1029649), // Rule ID 13264 //
     /* 1029577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1029591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1029594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1029597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029616 */     // MIs[0] policy
     /* 1029616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029626 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1029629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029648 */     // GIR_Coverage, 13264,
     /* 1029648 */     GIR_EraseRootFromParent_Done,
     /* 1029649 */   // Label 15256: @1029649
     /* 1029649 */   GIM_Try, /*On fail goto*//*Label 15257*/ GIMT_Encode4(1029726), // Rule ID 13265 //
     /* 1029654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1029668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1029671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1029674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029693 */     // MIs[0] policy
     /* 1029693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029703 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1029706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029725 */     // GIR_Coverage, 13265,
     /* 1029725 */     GIR_EraseRootFromParent_Done,
     /* 1029726 */   // Label 15257: @1029726
     /* 1029726 */   GIM_Try, /*On fail goto*//*Label 15258*/ GIMT_Encode4(1029803), // Rule ID 13268 //
     /* 1029731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1029742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1029745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1029748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029770 */     // MIs[0] policy
     /* 1029770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029780 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1029783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029802 */     // GIR_Coverage, 13268,
     /* 1029802 */     GIR_EraseRootFromParent_Done,
     /* 1029803 */   // Label 15258: @1029803
     /* 1029803 */   GIM_Try, /*On fail goto*//*Label 15259*/ GIMT_Encode4(1029880), // Rule ID 13269 //
     /* 1029808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1029819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1029822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1029825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029847 */     // MIs[0] policy
     /* 1029847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029857 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1029860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029879 */     // GIR_Coverage, 13269,
     /* 1029879 */     GIR_EraseRootFromParent_Done,
     /* 1029880 */   // Label 15259: @1029880
     /* 1029880 */   GIM_Try, /*On fail goto*//*Label 15260*/ GIMT_Encode4(1029957), // Rule ID 13272 //
     /* 1029885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1029896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1029899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1029902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1029905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029924 */     // MIs[0] policy
     /* 1029924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029934 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1029937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029956 */     // GIR_Coverage, 13272,
     /* 1029956 */     GIR_EraseRootFromParent_Done,
     /* 1029957 */   // Label 15260: @1029957
     /* 1029957 */   GIM_Try, /*On fail goto*//*Label 15261*/ GIMT_Encode4(1030034), // Rule ID 13273 //
     /* 1029962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1029973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1029976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1029979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1029982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030001 */     // MIs[0] policy
     /* 1030001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030011 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1030014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030033 */     // GIR_Coverage, 13273,
     /* 1030033 */     GIR_EraseRootFromParent_Done,
     /* 1030034 */   // Label 15261: @1030034
     /* 1030034 */   GIM_Try, /*On fail goto*//*Label 15262*/ GIMT_Encode4(1030111), // Rule ID 13276 //
     /* 1030039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1030050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1030053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1030056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1030059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030078 */     // MIs[0] policy
     /* 1030078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030088 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1030091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030110 */     // GIR_Coverage, 13276,
     /* 1030110 */     GIR_EraseRootFromParent_Done,
     /* 1030111 */   // Label 15262: @1030111
     /* 1030111 */   GIM_Try, /*On fail goto*//*Label 15263*/ GIMT_Encode4(1030188), // Rule ID 13277 //
     /* 1030116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1030127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1030130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1030133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1030136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030155 */     // MIs[0] policy
     /* 1030155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030165 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1030168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030187 */     // GIR_Coverage, 13277,
     /* 1030187 */     GIR_EraseRootFromParent_Done,
     /* 1030188 */   // Label 15263: @1030188
     /* 1030188 */   GIM_Try, /*On fail goto*//*Label 15264*/ GIMT_Encode4(1030265), // Rule ID 13280 //
     /* 1030193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1030196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1030204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1030207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1030210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1030213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030232 */     // MIs[0] policy
     /* 1030232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030242 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1030245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1030261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030264 */     // GIR_Coverage, 13280,
     /* 1030264 */     GIR_EraseRootFromParent_Done,
     /* 1030265 */   // Label 15264: @1030265
     /* 1030265 */   GIM_Try, /*On fail goto*//*Label 15265*/ GIMT_Encode4(1030342), // Rule ID 13281 //
     /* 1030270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1030273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1030281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1030284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1030287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1030290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030309 */     // MIs[0] policy
     /* 1030309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030319 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1030322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1030338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030341 */     // GIR_Coverage, 13281,
     /* 1030341 */     GIR_EraseRootFromParent_Done,
     /* 1030342 */   // Label 15265: @1030342
     /* 1030342 */   GIM_Try, /*On fail goto*//*Label 15266*/ GIMT_Encode4(1030419), // Rule ID 13284 //
     /* 1030347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1030358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1030361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1030364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1030367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030386 */     // MIs[0] policy
     /* 1030386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1030399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030418 */     // GIR_Coverage, 13284,
     /* 1030418 */     GIR_EraseRootFromParent_Done,
     /* 1030419 */   // Label 15266: @1030419
     /* 1030419 */   GIM_Try, /*On fail goto*//*Label 15267*/ GIMT_Encode4(1030496), // Rule ID 13285 //
     /* 1030424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1030435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1030438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1030441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1030444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030463 */     // MIs[0] policy
     /* 1030463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030473 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1030476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030495 */     // GIR_Coverage, 13285,
     /* 1030495 */     GIR_EraseRootFromParent_Done,
     /* 1030496 */   // Label 15267: @1030496
     /* 1030496 */   GIM_Try, /*On fail goto*//*Label 15268*/ GIMT_Encode4(1030573), // Rule ID 13288 //
     /* 1030501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1030512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1030515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1030518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1030521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030540 */     // MIs[0] policy
     /* 1030540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030550 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1030553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030572 */     // GIR_Coverage, 13288,
     /* 1030572 */     GIR_EraseRootFromParent_Done,
     /* 1030573 */   // Label 15268: @1030573
     /* 1030573 */   GIM_Try, /*On fail goto*//*Label 15269*/ GIMT_Encode4(1030650), // Rule ID 13289 //
     /* 1030578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1030589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1030592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1030595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1030598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030617 */     // MIs[0] policy
     /* 1030617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030627 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1030630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030649 */     // GIR_Coverage, 13289,
     /* 1030649 */     GIR_EraseRootFromParent_Done,
     /* 1030650 */   // Label 15269: @1030650
     /* 1030650 */   GIM_Try, /*On fail goto*//*Label 15270*/ GIMT_Encode4(1030727), // Rule ID 13292 //
     /* 1030655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1030666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1030669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1030672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1030675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030694 */     // MIs[0] policy
     /* 1030694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030704 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1030707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030726 */     // GIR_Coverage, 13292,
     /* 1030726 */     GIR_EraseRootFromParent_Done,
     /* 1030727 */   // Label 15270: @1030727
     /* 1030727 */   GIM_Try, /*On fail goto*//*Label 15271*/ GIMT_Encode4(1030804), // Rule ID 13293 //
     /* 1030732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1030743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1030746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1030749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1030752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030771 */     // MIs[0] policy
     /* 1030771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030781 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1030784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030803 */     // GIR_Coverage, 13293,
     /* 1030803 */     GIR_EraseRootFromParent_Done,
     /* 1030804 */   // Label 15271: @1030804
     /* 1030804 */   GIM_Try, /*On fail goto*//*Label 15272*/ GIMT_Encode4(1030881), // Rule ID 13296 //
     /* 1030809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1030820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1030823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1030826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1030829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030848 */     // MIs[0] policy
     /* 1030848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1030861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030880 */     // GIR_Coverage, 13296,
     /* 1030880 */     GIR_EraseRootFromParent_Done,
     /* 1030881 */   // Label 15272: @1030881
     /* 1030881 */   GIM_Try, /*On fail goto*//*Label 15273*/ GIMT_Encode4(1030958), // Rule ID 13297 //
     /* 1030886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1030897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1030900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1030903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1030906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030925 */     // MIs[0] policy
     /* 1030925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030935 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1030938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030957 */     // GIR_Coverage, 13297,
     /* 1030957 */     GIR_EraseRootFromParent_Done,
     /* 1030958 */   // Label 15273: @1030958
     /* 1030958 */   GIM_Try, /*On fail goto*//*Label 15274*/ GIMT_Encode4(1031035), // Rule ID 13300 //
     /* 1030963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1030974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1030977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1030980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1030983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031002 */     // MIs[0] policy
     /* 1031002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031012 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1031015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031034 */     // GIR_Coverage, 13300,
     /* 1031034 */     GIR_EraseRootFromParent_Done,
     /* 1031035 */   // Label 15274: @1031035
     /* 1031035 */   GIM_Try, /*On fail goto*//*Label 15275*/ GIMT_Encode4(1031112), // Rule ID 13301 //
     /* 1031040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1031051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1031054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1031057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1031060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031079 */     // MIs[0] policy
     /* 1031079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031089 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1031092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031111 */     // GIR_Coverage, 13301,
     /* 1031111 */     GIR_EraseRootFromParent_Done,
     /* 1031112 */   // Label 15275: @1031112
     /* 1031112 */   GIM_Try, /*On fail goto*//*Label 15276*/ GIMT_Encode4(1031189), // Rule ID 13304 //
     /* 1031117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1031128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1031131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1031134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1031137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031156 */     // MIs[0] policy
     /* 1031156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031166 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1031169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031188 */     // GIR_Coverage, 13304,
     /* 1031188 */     GIR_EraseRootFromParent_Done,
     /* 1031189 */   // Label 15276: @1031189
     /* 1031189 */   GIM_Try, /*On fail goto*//*Label 15277*/ GIMT_Encode4(1031266), // Rule ID 13305 //
     /* 1031194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1031205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1031208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1031211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1031214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031233 */     // MIs[0] policy
     /* 1031233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031243 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1031246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031265 */     // GIR_Coverage, 13305,
     /* 1031265 */     GIR_EraseRootFromParent_Done,
     /* 1031266 */   // Label 15277: @1031266
     /* 1031266 */   GIM_Try, /*On fail goto*//*Label 15278*/ GIMT_Encode4(1031343), // Rule ID 13308 //
     /* 1031271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1031282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1031285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1031288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1031291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031310 */     // MIs[0] policy
     /* 1031310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031320 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1031323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031342 */     // GIR_Coverage, 13308,
     /* 1031342 */     GIR_EraseRootFromParent_Done,
     /* 1031343 */   // Label 15278: @1031343
     /* 1031343 */   GIM_Try, /*On fail goto*//*Label 15279*/ GIMT_Encode4(1031420), // Rule ID 13309 //
     /* 1031348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1031359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1031362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1031365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1031368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031387 */     // MIs[0] policy
     /* 1031387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031397 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1031400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031419 */     // GIR_Coverage, 13309,
     /* 1031419 */     GIR_EraseRootFromParent_Done,
     /* 1031420 */   // Label 15279: @1031420
     /* 1031420 */   GIM_Try, /*On fail goto*//*Label 15280*/ GIMT_Encode4(1031497), // Rule ID 13312 //
     /* 1031425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1031436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1031439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1031442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1031445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031464 */     // MIs[0] policy
     /* 1031464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031474 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1031477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031496 */     // GIR_Coverage, 13312,
     /* 1031496 */     GIR_EraseRootFromParent_Done,
     /* 1031497 */   // Label 15280: @1031497
     /* 1031497 */   GIM_Try, /*On fail goto*//*Label 15281*/ GIMT_Encode4(1031574), // Rule ID 13313 //
     /* 1031502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1031513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1031516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1031519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1031522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031541 */     // MIs[0] policy
     /* 1031541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1031554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031573 */     // GIR_Coverage, 13313,
     /* 1031573 */     GIR_EraseRootFromParent_Done,
     /* 1031574 */   // Label 15281: @1031574
     /* 1031574 */   GIM_Try, /*On fail goto*//*Label 15282*/ GIMT_Encode4(1031651), // Rule ID 13316 //
     /* 1031579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1031590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1031593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1031596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1031599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031618 */     // MIs[0] policy
     /* 1031618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031628 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1031631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031650 */     // GIR_Coverage, 13316,
     /* 1031650 */     GIR_EraseRootFromParent_Done,
     /* 1031651 */   // Label 15282: @1031651
     /* 1031651 */   GIM_Try, /*On fail goto*//*Label 15283*/ GIMT_Encode4(1031728), // Rule ID 13317 //
     /* 1031656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1031667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1031670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1031673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1031676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031695 */     // MIs[0] policy
     /* 1031695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031705 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1031708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031727 */     // GIR_Coverage, 13317,
     /* 1031727 */     GIR_EraseRootFromParent_Done,
     /* 1031728 */   // Label 15283: @1031728
     /* 1031728 */   GIM_Try, /*On fail goto*//*Label 15284*/ GIMT_Encode4(1031805), // Rule ID 13320 //
     /* 1031733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1031744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1031747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1031750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1031753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031772 */     // MIs[0] policy
     /* 1031772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031782 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1031785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031804 */     // GIR_Coverage, 13320,
     /* 1031804 */     GIR_EraseRootFromParent_Done,
     /* 1031805 */   // Label 15284: @1031805
     /* 1031805 */   GIM_Try, /*On fail goto*//*Label 15285*/ GIMT_Encode4(1031882), // Rule ID 13321 //
     /* 1031810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1031821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1031824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1031827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1031830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031849 */     // MIs[0] policy
     /* 1031849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031859 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1031862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031881 */     // GIR_Coverage, 13321,
     /* 1031881 */     GIR_EraseRootFromParent_Done,
     /* 1031882 */   // Label 15285: @1031882
     /* 1031882 */   GIM_Try, /*On fail goto*//*Label 15286*/ GIMT_Encode4(1031959), // Rule ID 13324 //
     /* 1031887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1031898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1031901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1031904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1031907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031926 */     // MIs[0] policy
     /* 1031926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031936 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1031939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031958 */     // GIR_Coverage, 13324,
     /* 1031958 */     GIR_EraseRootFromParent_Done,
     /* 1031959 */   // Label 15286: @1031959
     /* 1031959 */   GIM_Try, /*On fail goto*//*Label 15287*/ GIMT_Encode4(1032036), // Rule ID 13325 //
     /* 1031964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1031975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1031978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1031981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1031984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032003 */     // MIs[0] policy
     /* 1032003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032013 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1032016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1032032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032035 */     // GIR_Coverage, 13325,
     /* 1032035 */     GIR_EraseRootFromParent_Done,
     /* 1032036 */   // Label 15287: @1032036
     /* 1032036 */   GIM_Try, /*On fail goto*//*Label 15288*/ GIMT_Encode4(1032113), // Rule ID 13328 //
     /* 1032041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1032044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1032052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1032055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1032058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1032061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032080 */     // MIs[0] policy
     /* 1032080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1032093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1032109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032112 */     // GIR_Coverage, 13328,
     /* 1032112 */     GIR_EraseRootFromParent_Done,
     /* 1032113 */   // Label 15288: @1032113
     /* 1032113 */   GIM_Try, /*On fail goto*//*Label 15289*/ GIMT_Encode4(1032190), // Rule ID 13329 //
     /* 1032118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1032121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1032129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1032132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1032135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1032138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032157 */     // MIs[0] policy
     /* 1032157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032167 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1032170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1032186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032189 */     // GIR_Coverage, 13329,
     /* 1032189 */     GIR_EraseRootFromParent_Done,
     /* 1032190 */   // Label 15289: @1032190
     /* 1032190 */   GIM_Try, /*On fail goto*//*Label 15290*/ GIMT_Encode4(1032267), // Rule ID 13332 //
     /* 1032195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1032206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1032209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1032215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032234 */     // MIs[0] policy
     /* 1032234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032244 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1032247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032266 */     // GIR_Coverage, 13332,
     /* 1032266 */     GIR_EraseRootFromParent_Done,
     /* 1032267 */   // Label 15290: @1032267
     /* 1032267 */   GIM_Try, /*On fail goto*//*Label 15291*/ GIMT_Encode4(1032344), // Rule ID 13333 //
     /* 1032272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1032283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1032286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1032289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1032292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032311 */     // MIs[0] policy
     /* 1032311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032321 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1032324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032343 */     // GIR_Coverage, 13333,
     /* 1032343 */     GIR_EraseRootFromParent_Done,
     /* 1032344 */   // Label 15291: @1032344
     /* 1032344 */   GIM_Try, /*On fail goto*//*Label 15292*/ GIMT_Encode4(1032421), // Rule ID 13336 //
     /* 1032349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1032360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1032363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1032369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032388 */     // MIs[0] policy
     /* 1032388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032398 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1032401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032420 */     // GIR_Coverage, 13336,
     /* 1032420 */     GIR_EraseRootFromParent_Done,
     /* 1032421 */   // Label 15292: @1032421
     /* 1032421 */   GIM_Try, /*On fail goto*//*Label 15293*/ GIMT_Encode4(1032498), // Rule ID 13337 //
     /* 1032426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1032437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1032440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1032443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1032446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032465 */     // MIs[0] policy
     /* 1032465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032475 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1032478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032497 */     // GIR_Coverage, 13337,
     /* 1032497 */     GIR_EraseRootFromParent_Done,
     /* 1032498 */   // Label 15293: @1032498
     /* 1032498 */   GIM_Try, /*On fail goto*//*Label 15294*/ GIMT_Encode4(1032575), // Rule ID 13340 //
     /* 1032503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1032514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1032517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1032523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032542 */     // MIs[0] policy
     /* 1032542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032552 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1032555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032574 */     // GIR_Coverage, 13340,
     /* 1032574 */     GIR_EraseRootFromParent_Done,
     /* 1032575 */   // Label 15294: @1032575
     /* 1032575 */   GIM_Try, /*On fail goto*//*Label 15295*/ GIMT_Encode4(1032652), // Rule ID 13341 //
     /* 1032580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1032591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1032594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1032597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1032600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032619 */     // MIs[0] policy
     /* 1032619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032629 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1032632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032651 */     // GIR_Coverage, 13341,
     /* 1032651 */     GIR_EraseRootFromParent_Done,
     /* 1032652 */   // Label 15295: @1032652
     /* 1032652 */   GIM_Try, /*On fail goto*//*Label 15296*/ GIMT_Encode4(1032729), // Rule ID 13344 //
     /* 1032657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1032668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1032671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1032677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032696 */     // MIs[0] policy
     /* 1032696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1032709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032728 */     // GIR_Coverage, 13344,
     /* 1032728 */     GIR_EraseRootFromParent_Done,
     /* 1032729 */   // Label 15296: @1032729
     /* 1032729 */   GIM_Try, /*On fail goto*//*Label 15297*/ GIMT_Encode4(1032806), // Rule ID 13345 //
     /* 1032734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1032745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1032748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1032751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1032754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032773 */     // MIs[0] policy
     /* 1032773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032783 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1032786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032805 */     // GIR_Coverage, 13345,
     /* 1032805 */     GIR_EraseRootFromParent_Done,
     /* 1032806 */   // Label 15297: @1032806
     /* 1032806 */   GIM_Try, /*On fail goto*//*Label 15298*/ GIMT_Encode4(1032883), // Rule ID 13348 //
     /* 1032811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1032822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1032825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1032831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032850 */     // MIs[0] policy
     /* 1032850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1032863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032882 */     // GIR_Coverage, 13348,
     /* 1032882 */     GIR_EraseRootFromParent_Done,
     /* 1032883 */   // Label 15298: @1032883
     /* 1032883 */   GIM_Try, /*On fail goto*//*Label 15299*/ GIMT_Encode4(1032960), // Rule ID 13349 //
     /* 1032888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1032899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1032902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1032905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1032908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032927 */     // MIs[0] policy
     /* 1032927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032937 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1032940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032959 */     // GIR_Coverage, 13349,
     /* 1032959 */     GIR_EraseRootFromParent_Done,
     /* 1032960 */   // Label 15299: @1032960
     /* 1032960 */   GIM_Try, /*On fail goto*//*Label 15300*/ GIMT_Encode4(1033037), // Rule ID 13352 //
     /* 1032965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1032976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1032979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1032985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033004 */     // MIs[0] policy
     /* 1033004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1033017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033036 */     // GIR_Coverage, 13352,
     /* 1033036 */     GIR_EraseRootFromParent_Done,
     /* 1033037 */   // Label 15300: @1033037
     /* 1033037 */   GIM_Try, /*On fail goto*//*Label 15301*/ GIMT_Encode4(1033114), // Rule ID 13353 //
     /* 1033042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1033053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1033056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1033062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033081 */     // MIs[0] policy
     /* 1033081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033091 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1033094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033113 */     // GIR_Coverage, 13353,
     /* 1033113 */     GIR_EraseRootFromParent_Done,
     /* 1033114 */   // Label 15301: @1033114
     /* 1033114 */   GIM_Try, /*On fail goto*//*Label 15302*/ GIMT_Encode4(1033191), // Rule ID 13356 //
     /* 1033119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1033130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1033133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1033139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033158 */     // MIs[0] policy
     /* 1033158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033168 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033190 */     // GIR_Coverage, 13356,
     /* 1033190 */     GIR_EraseRootFromParent_Done,
     /* 1033191 */   // Label 15302: @1033191
     /* 1033191 */   GIM_Try, /*On fail goto*//*Label 15303*/ GIMT_Encode4(1033268), // Rule ID 13357 //
     /* 1033196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1033207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1033210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1033216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033235 */     // MIs[0] policy
     /* 1033235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033245 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033267 */     // GIR_Coverage, 13357,
     /* 1033267 */     GIR_EraseRootFromParent_Done,
     /* 1033268 */   // Label 15303: @1033268
     /* 1033268 */   GIM_Try, /*On fail goto*//*Label 15304*/ GIMT_Encode4(1033345), // Rule ID 13360 //
     /* 1033273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1033284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1033287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1033293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033312 */     // MIs[0] policy
     /* 1033312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033322 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033344 */     // GIR_Coverage, 13360,
     /* 1033344 */     GIR_EraseRootFromParent_Done,
     /* 1033345 */   // Label 15304: @1033345
     /* 1033345 */   GIM_Try, /*On fail goto*//*Label 15305*/ GIMT_Encode4(1033422), // Rule ID 13361 //
     /* 1033350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1033361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1033364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1033370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033389 */     // MIs[0] policy
     /* 1033389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033399 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033421 */     // GIR_Coverage, 13361,
     /* 1033421 */     GIR_EraseRootFromParent_Done,
     /* 1033422 */   // Label 15305: @1033422
     /* 1033422 */   GIM_Try, /*On fail goto*//*Label 15306*/ GIMT_Encode4(1033499), // Rule ID 13364 //
     /* 1033427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1033438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1033441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1033447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033466 */     // MIs[0] policy
     /* 1033466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033476 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033498 */     // GIR_Coverage, 13364,
     /* 1033498 */     GIR_EraseRootFromParent_Done,
     /* 1033499 */   // Label 15306: @1033499
     /* 1033499 */   GIM_Try, /*On fail goto*//*Label 15307*/ GIMT_Encode4(1033576), // Rule ID 13365 //
     /* 1033504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1033515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1033518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1033524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033543 */     // MIs[0] policy
     /* 1033543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033553 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033575 */     // GIR_Coverage, 13365,
     /* 1033575 */     GIR_EraseRootFromParent_Done,
     /* 1033576 */   // Label 15307: @1033576
     /* 1033576 */   GIM_Try, /*On fail goto*//*Label 15308*/ GIMT_Encode4(1033653), // Rule ID 13368 //
     /* 1033581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1033584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1033592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1033595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1033601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033620 */     // MIs[0] policy
     /* 1033620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033630 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1033649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033652 */     // GIR_Coverage, 13368,
     /* 1033652 */     GIR_EraseRootFromParent_Done,
     /* 1033653 */   // Label 15308: @1033653
     /* 1033653 */   GIM_Try, /*On fail goto*//*Label 15309*/ GIMT_Encode4(1033730), // Rule ID 13369 //
     /* 1033658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1033661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1033669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1033672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1033678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033697 */     // MIs[0] policy
     /* 1033697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033707 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1033726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033729 */     // GIR_Coverage, 13369,
     /* 1033729 */     GIR_EraseRootFromParent_Done,
     /* 1033730 */   // Label 15309: @1033730
     /* 1033730 */   GIM_Try, /*On fail goto*//*Label 15310*/ GIMT_Encode4(1033807), // Rule ID 13372 //
     /* 1033735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1033746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1033749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1033755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033774 */     // MIs[0] policy
     /* 1033774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1033787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033806 */     // GIR_Coverage, 13372,
     /* 1033806 */     GIR_EraseRootFromParent_Done,
     /* 1033807 */   // Label 15310: @1033807
     /* 1033807 */   GIM_Try, /*On fail goto*//*Label 15311*/ GIMT_Encode4(1033884), // Rule ID 13373 //
     /* 1033812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1033823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1033826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1033832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033851 */     // MIs[0] policy
     /* 1033851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033861 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1033864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033883 */     // GIR_Coverage, 13373,
     /* 1033883 */     GIR_EraseRootFromParent_Done,
     /* 1033884 */   // Label 15311: @1033884
     /* 1033884 */   GIM_Try, /*On fail goto*//*Label 15312*/ GIMT_Encode4(1033961), // Rule ID 13376 //
     /* 1033889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1033900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1033903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1033909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033928 */     // MIs[0] policy
     /* 1033928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033938 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1033941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033960 */     // GIR_Coverage, 13376,
     /* 1033960 */     GIR_EraseRootFromParent_Done,
     /* 1033961 */   // Label 15312: @1033961
     /* 1033961 */   GIM_Try, /*On fail goto*//*Label 15313*/ GIMT_Encode4(1034038), // Rule ID 13377 //
     /* 1033966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1033977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1033980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1033986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034005 */     // MIs[0] policy
     /* 1034005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034015 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1034018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034037 */     // GIR_Coverage, 13377,
     /* 1034037 */     GIR_EraseRootFromParent_Done,
     /* 1034038 */   // Label 15313: @1034038
     /* 1034038 */   GIM_Try, /*On fail goto*//*Label 15314*/ GIMT_Encode4(1034115), // Rule ID 13380 //
     /* 1034043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1034054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1034057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1034063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034082 */     // MIs[0] policy
     /* 1034082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1034095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034114 */     // GIR_Coverage, 13380,
     /* 1034114 */     GIR_EraseRootFromParent_Done,
     /* 1034115 */   // Label 15314: @1034115
     /* 1034115 */   GIM_Try, /*On fail goto*//*Label 15315*/ GIMT_Encode4(1034192), // Rule ID 13381 //
     /* 1034120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1034131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1034134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1034140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034159 */     // MIs[0] policy
     /* 1034159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034169 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1034172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034191 */     // GIR_Coverage, 13381,
     /* 1034191 */     GIR_EraseRootFromParent_Done,
     /* 1034192 */   // Label 15315: @1034192
     /* 1034192 */   GIM_Try, /*On fail goto*//*Label 15316*/ GIMT_Encode4(1034269), // Rule ID 13384 //
     /* 1034197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1034208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1034211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1034217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034236 */     // MIs[0] policy
     /* 1034236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1034249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034268 */     // GIR_Coverage, 13384,
     /* 1034268 */     GIR_EraseRootFromParent_Done,
     /* 1034269 */   // Label 15316: @1034269
     /* 1034269 */   GIM_Try, /*On fail goto*//*Label 15317*/ GIMT_Encode4(1034346), // Rule ID 13385 //
     /* 1034274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1034285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1034288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1034294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034313 */     // MIs[0] policy
     /* 1034313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034323 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1034326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034345 */     // GIR_Coverage, 13385,
     /* 1034345 */     GIR_EraseRootFromParent_Done,
     /* 1034346 */   // Label 15317: @1034346
     /* 1034346 */   GIM_Try, /*On fail goto*//*Label 15318*/ GIMT_Encode4(1034423), // Rule ID 13388 //
     /* 1034351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1034362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1034365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1034371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034390 */     // MIs[0] policy
     /* 1034390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1034403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034422 */     // GIR_Coverage, 13388,
     /* 1034422 */     GIR_EraseRootFromParent_Done,
     /* 1034423 */   // Label 15318: @1034423
     /* 1034423 */   GIM_Try, /*On fail goto*//*Label 15319*/ GIMT_Encode4(1034500), // Rule ID 13389 //
     /* 1034428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1034439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1034442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1034448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034467 */     // MIs[0] policy
     /* 1034467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034477 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1034480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034499 */     // GIR_Coverage, 13389,
     /* 1034499 */     GIR_EraseRootFromParent_Done,
     /* 1034500 */   // Label 15319: @1034500
     /* 1034500 */   GIM_Try, /*On fail goto*//*Label 15320*/ GIMT_Encode4(1034577), // Rule ID 13392 //
     /* 1034505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1034516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1034519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1034525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034544 */     // MIs[0] policy
     /* 1034544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034554 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1034557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034576 */     // GIR_Coverage, 13392,
     /* 1034576 */     GIR_EraseRootFromParent_Done,
     /* 1034577 */   // Label 15320: @1034577
     /* 1034577 */   GIM_Try, /*On fail goto*//*Label 15321*/ GIMT_Encode4(1034654), // Rule ID 13393 //
     /* 1034582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1034593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1034596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1034602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034621 */     // MIs[0] policy
     /* 1034621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034631 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1034634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034653 */     // GIR_Coverage, 13393,
     /* 1034653 */     GIR_EraseRootFromParent_Done,
     /* 1034654 */   // Label 15321: @1034654
     /* 1034654 */   GIM_Try, /*On fail goto*//*Label 15322*/ GIMT_Encode4(1034731), // Rule ID 13396 //
     /* 1034659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1034670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1034673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1034679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034698 */     // MIs[0] policy
     /* 1034698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1034711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034730 */     // GIR_Coverage, 13396,
     /* 1034730 */     GIR_EraseRootFromParent_Done,
     /* 1034731 */   // Label 15322: @1034731
     /* 1034731 */   GIM_Try, /*On fail goto*//*Label 15323*/ GIMT_Encode4(1034808), // Rule ID 13397 //
     /* 1034736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1034747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1034750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1034756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034775 */     // MIs[0] policy
     /* 1034775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034785 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1034788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034807 */     // GIR_Coverage, 13397,
     /* 1034807 */     GIR_EraseRootFromParent_Done,
     /* 1034808 */   // Label 15323: @1034808
     /* 1034808 */   GIM_Try, /*On fail goto*//*Label 15324*/ GIMT_Encode4(1034885), // Rule ID 13400 //
     /* 1034813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1034824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1034827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1034833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034852 */     // MIs[0] policy
     /* 1034852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034862 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1034865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034884 */     // GIR_Coverage, 13400,
     /* 1034884 */     GIR_EraseRootFromParent_Done,
     /* 1034885 */   // Label 15324: @1034885
     /* 1034885 */   GIM_Try, /*On fail goto*//*Label 15325*/ GIMT_Encode4(1034962), // Rule ID 13401 //
     /* 1034890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1034901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1034904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1034910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034929 */     // MIs[0] policy
     /* 1034929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034939 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1034942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034961 */     // GIR_Coverage, 13401,
     /* 1034961 */     GIR_EraseRootFromParent_Done,
     /* 1034962 */   // Label 15325: @1034962
     /* 1034962 */   GIM_Try, /*On fail goto*//*Label 15326*/ GIMT_Encode4(1035039), // Rule ID 13404 //
     /* 1034967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1034978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1034981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1034987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035006 */     // MIs[0] policy
     /* 1035006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1035019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035038 */     // GIR_Coverage, 13404,
     /* 1035038 */     GIR_EraseRootFromParent_Done,
     /* 1035039 */   // Label 15326: @1035039
     /* 1035039 */   GIM_Try, /*On fail goto*//*Label 15327*/ GIMT_Encode4(1035116), // Rule ID 13405 //
     /* 1035044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1035055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1035058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1035064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035083 */     // MIs[0] policy
     /* 1035083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035093 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1035096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035115 */     // GIR_Coverage, 13405,
     /* 1035115 */     GIR_EraseRootFromParent_Done,
     /* 1035116 */   // Label 15327: @1035116
     /* 1035116 */   GIM_Try, /*On fail goto*//*Label 15328*/ GIMT_Encode4(1035193), // Rule ID 13408 //
     /* 1035121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1035124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1035132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1035135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1035141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035160 */     // MIs[0] policy
     /* 1035160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1035173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035192 */     // GIR_Coverage, 13408,
     /* 1035192 */     GIR_EraseRootFromParent_Done,
     /* 1035193 */   // Label 15328: @1035193
     /* 1035193 */   GIM_Try, /*On fail goto*//*Label 15329*/ GIMT_Encode4(1035270), // Rule ID 13409 //
     /* 1035198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1035201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1035209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1035212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1035218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035237 */     // MIs[0] policy
     /* 1035237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035247 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1035250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035269 */     // GIR_Coverage, 13409,
     /* 1035269 */     GIR_EraseRootFromParent_Done,
     /* 1035270 */   // Label 15329: @1035270
     /* 1035270 */   GIM_Try, /*On fail goto*//*Label 15330*/ GIMT_Encode4(1035347), // Rule ID 13412 //
     /* 1035275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1035278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1035286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1035289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1035295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035314 */     // MIs[0] policy
     /* 1035314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035324 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1035327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035346 */     // GIR_Coverage, 13412,
     /* 1035346 */     GIR_EraseRootFromParent_Done,
     /* 1035347 */   // Label 15330: @1035347
     /* 1035347 */   GIM_Try, /*On fail goto*//*Label 15331*/ GIMT_Encode4(1035424), // Rule ID 13413 //
     /* 1035352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1035355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1035363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1035366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1035372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035391 */     // MIs[0] policy
     /* 1035391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035401 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1035404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035423 */     // GIR_Coverage, 13413,
     /* 1035423 */     GIR_EraseRootFromParent_Done,
     /* 1035424 */   // Label 15331: @1035424
     /* 1035424 */   GIM_Try, /*On fail goto*//*Label 15332*/ GIMT_Encode4(1035501), // Rule ID 13416 //
     /* 1035429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1035432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1035440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1035443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1035449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035468 */     // MIs[0] policy
     /* 1035468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035478 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1035481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035500 */     // GIR_Coverage, 13416,
     /* 1035500 */     GIR_EraseRootFromParent_Done,
     /* 1035501 */   // Label 15332: @1035501
     /* 1035501 */   GIM_Try, /*On fail goto*//*Label 15333*/ GIMT_Encode4(1035578), // Rule ID 13417 //
     /* 1035506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1035509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1035517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1035520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1035526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035545 */     // MIs[0] policy
     /* 1035545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035555 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1035558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035577 */     // GIR_Coverage, 13417,
     /* 1035577 */     GIR_EraseRootFromParent_Done,
     /* 1035578 */   // Label 15333: @1035578
     /* 1035578 */   GIM_Try, /*On fail goto*//*Label 15334*/ GIMT_Encode4(1035655), // Rule ID 13420 //
     /* 1035583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1035594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1035597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1035600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1035603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035622 */     // MIs[0] policy
     /* 1035622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035632 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11628:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1035635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035654 */     // GIR_Coverage, 13420,
     /* 1035654 */     GIR_EraseRootFromParent_Done,
     /* 1035655 */   // Label 15334: @1035655
     /* 1035655 */   GIM_Try, /*On fail goto*//*Label 15335*/ GIMT_Encode4(1035732), // Rule ID 13421 //
     /* 1035660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1035671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1035674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1035677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1035680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035699 */     // MIs[0] policy
     /* 1035699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035709 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11628:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1035712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035731 */     // GIR_Coverage, 13421,
     /* 1035731 */     GIR_EraseRootFromParent_Done,
     /* 1035732 */   // Label 15335: @1035732
     /* 1035732 */   GIM_Try, /*On fail goto*//*Label 15336*/ GIMT_Encode4(1035809), // Rule ID 13424 //
     /* 1035737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1035748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1035751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1035754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1035757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035776 */     // MIs[0] policy
     /* 1035776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035786 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11628:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1035789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035808 */     // GIR_Coverage, 13424,
     /* 1035808 */     GIR_EraseRootFromParent_Done,
     /* 1035809 */   // Label 15336: @1035809
     /* 1035809 */   GIM_Try, /*On fail goto*//*Label 15337*/ GIMT_Encode4(1035886), // Rule ID 13425 //
     /* 1035814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1035825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1035828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1035831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1035834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035853 */     // MIs[0] policy
     /* 1035853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035863 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11628:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1035866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035885 */     // GIR_Coverage, 13425,
     /* 1035885 */     GIR_EraseRootFromParent_Done,
     /* 1035886 */   // Label 15337: @1035886
     /* 1035886 */   GIM_Try, /*On fail goto*//*Label 15338*/ GIMT_Encode4(1035963), // Rule ID 13428 //
     /* 1035891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1035902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1035905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1035908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1035911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035930 */     // MIs[0] policy
     /* 1035930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11628:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1035943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035962 */     // GIR_Coverage, 13428,
     /* 1035962 */     GIR_EraseRootFromParent_Done,
     /* 1035963 */   // Label 15338: @1035963
     /* 1035963 */   GIM_Try, /*On fail goto*//*Label 15339*/ GIMT_Encode4(1036040), // Rule ID 13429 //
     /* 1035968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1035979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1035982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1035985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1035988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036007 */     // MIs[0] policy
     /* 1036007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036017 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11628:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1036020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036039 */     // GIR_Coverage, 13429,
     /* 1036039 */     GIR_EraseRootFromParent_Done,
     /* 1036040 */   // Label 15339: @1036040
     /* 1036040 */   GIM_Try, /*On fail goto*//*Label 15340*/ GIMT_Encode4(1036117), // Rule ID 13432 //
     /* 1036045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1036056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1036059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1036062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1036065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036084 */     // MIs[0] policy
     /* 1036084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036094 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11628:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1036097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036116 */     // GIR_Coverage, 13432,
     /* 1036116 */     GIR_EraseRootFromParent_Done,
     /* 1036117 */   // Label 15340: @1036117
     /* 1036117 */   GIM_Try, /*On fail goto*//*Label 15341*/ GIMT_Encode4(1036194), // Rule ID 13433 //
     /* 1036122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1036133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1036136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1036139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1036142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036161 */     // MIs[0] policy
     /* 1036161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036171 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11628:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1036174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036193 */     // GIR_Coverage, 13433,
     /* 1036193 */     GIR_EraseRootFromParent_Done,
     /* 1036194 */   // Label 15341: @1036194
     /* 1036194 */   GIM_Try, /*On fail goto*//*Label 15342*/ GIMT_Encode4(1036271), // Rule ID 13436 //
     /* 1036199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1036210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1036213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1036216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1036219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036238 */     // MIs[0] policy
     /* 1036238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036248 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11628:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1036251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036270 */     // GIR_Coverage, 13436,
     /* 1036270 */     GIR_EraseRootFromParent_Done,
     /* 1036271 */   // Label 15342: @1036271
     /* 1036271 */   GIM_Try, /*On fail goto*//*Label 15343*/ GIMT_Encode4(1036348), // Rule ID 13437 //
     /* 1036276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1036287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1036290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1036293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1036296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036315 */     // MIs[0] policy
     /* 1036315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036325 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11628:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1036328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036347 */     // GIR_Coverage, 13437,
     /* 1036347 */     GIR_EraseRootFromParent_Done,
     /* 1036348 */   // Label 15343: @1036348
     /* 1036348 */   GIM_Try, /*On fail goto*//*Label 15344*/ GIMT_Encode4(1036425), // Rule ID 13440 //
     /* 1036353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1036364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1036367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1036370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1036373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036392 */     // MIs[0] policy
     /* 1036392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036402 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11628:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1036405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036424 */     // GIR_Coverage, 13440,
     /* 1036424 */     GIR_EraseRootFromParent_Done,
     /* 1036425 */   // Label 15344: @1036425
     /* 1036425 */   GIM_Try, /*On fail goto*//*Label 15345*/ GIMT_Encode4(1036502), // Rule ID 13441 //
     /* 1036430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1036441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1036444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1036447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1036450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036469 */     // MIs[0] policy
     /* 1036469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036479 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11628:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1036482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036501 */     // GIR_Coverage, 13441,
     /* 1036501 */     GIR_EraseRootFromParent_Done,
     /* 1036502 */   // Label 15345: @1036502
     /* 1036502 */   GIM_Try, /*On fail goto*//*Label 15346*/ GIMT_Encode4(1036579), // Rule ID 13444 //
     /* 1036507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1036518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1036521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1036524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1036527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036546 */     // MIs[0] policy
     /* 1036546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036556 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11628:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1036559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036578 */     // GIR_Coverage, 13444,
     /* 1036578 */     GIR_EraseRootFromParent_Done,
     /* 1036579 */   // Label 15346: @1036579
     /* 1036579 */   GIM_Try, /*On fail goto*//*Label 15347*/ GIMT_Encode4(1036656), // Rule ID 13445 //
     /* 1036584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1036595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1036598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1036601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1036604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036623 */     // MIs[0] policy
     /* 1036623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036633 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11628:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1036636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036655 */     // GIR_Coverage, 13445,
     /* 1036655 */     GIR_EraseRootFromParent_Done,
     /* 1036656 */   // Label 15347: @1036656
     /* 1036656 */   GIM_Try, /*On fail goto*//*Label 15348*/ GIMT_Encode4(1036733), // Rule ID 13448 //
     /* 1036661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1036672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1036675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1036678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1036681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036700 */     // MIs[0] policy
     /* 1036700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036710 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11628:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1036713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036732 */     // GIR_Coverage, 13448,
     /* 1036732 */     GIR_EraseRootFromParent_Done,
     /* 1036733 */   // Label 15348: @1036733
     /* 1036733 */   GIM_Try, /*On fail goto*//*Label 15349*/ GIMT_Encode4(1036810), // Rule ID 13449 //
     /* 1036738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1036749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1036752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1036755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1036758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036777 */     // MIs[0] policy
     /* 1036777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036787 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11628:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1036790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036809 */     // GIR_Coverage, 13449,
     /* 1036809 */     GIR_EraseRootFromParent_Done,
     /* 1036810 */   // Label 15349: @1036810
     /* 1036810 */   GIM_Try, /*On fail goto*//*Label 15350*/ GIMT_Encode4(1036887), // Rule ID 13452 //
     /* 1036815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1036826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1036829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1036832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1036835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036854 */     // MIs[0] policy
     /* 1036854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11628:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1036867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036886 */     // GIR_Coverage, 13452,
     /* 1036886 */     GIR_EraseRootFromParent_Done,
     /* 1036887 */   // Label 15350: @1036887
     /* 1036887 */   GIM_Try, /*On fail goto*//*Label 15351*/ GIMT_Encode4(1036964), // Rule ID 13453 //
     /* 1036892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1036903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1036906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1036909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1036912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036931 */     // MIs[0] policy
     /* 1036931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036941 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11628:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1036944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036963 */     // GIR_Coverage, 13453,
     /* 1036963 */     GIR_EraseRootFromParent_Done,
     /* 1036964 */   // Label 15351: @1036964
     /* 1036964 */   GIM_Try, /*On fail goto*//*Label 15352*/ GIMT_Encode4(1037041), // Rule ID 13456 //
     /* 1036969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1036980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1036983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1036986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1036989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037008 */     // MIs[0] policy
     /* 1037008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037018 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11628:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1037021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037040 */     // GIR_Coverage, 13456,
     /* 1037040 */     GIR_EraseRootFromParent_Done,
     /* 1037041 */   // Label 15352: @1037041
     /* 1037041 */   GIM_Try, /*On fail goto*//*Label 15353*/ GIMT_Encode4(1037118), // Rule ID 13457 //
     /* 1037046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1037057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1037060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1037063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1037066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037085 */     // MIs[0] policy
     /* 1037085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037095 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11628:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1037098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037117 */     // GIR_Coverage, 13457,
     /* 1037117 */     GIR_EraseRootFromParent_Done,
     /* 1037118 */   // Label 15353: @1037118
     /* 1037118 */   GIM_Try, /*On fail goto*//*Label 15354*/ GIMT_Encode4(1037195), // Rule ID 13460 //
     /* 1037123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1037134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1037137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1037140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1037143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037162 */     // MIs[0] policy
     /* 1037162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037172 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11628:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1037175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037194 */     // GIR_Coverage, 13460,
     /* 1037194 */     GIR_EraseRootFromParent_Done,
     /* 1037195 */   // Label 15354: @1037195
     /* 1037195 */   GIM_Try, /*On fail goto*//*Label 15355*/ GIMT_Encode4(1037272), // Rule ID 13461 //
     /* 1037200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1037211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1037214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1037217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1037220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037239 */     // MIs[0] policy
     /* 1037239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037249 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11628:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1037252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037271 */     // GIR_Coverage, 13461,
     /* 1037271 */     GIR_EraseRootFromParent_Done,
     /* 1037272 */   // Label 15355: @1037272
     /* 1037272 */   GIM_Try, /*On fail goto*//*Label 15356*/ GIMT_Encode4(1037349), // Rule ID 13464 //
     /* 1037277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1037280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1037288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1037291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1037294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1037297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037316 */     // MIs[0] policy
     /* 1037316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037326 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11628:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1037329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037348 */     // GIR_Coverage, 13464,
     /* 1037348 */     GIR_EraseRootFromParent_Done,
     /* 1037349 */   // Label 15356: @1037349
     /* 1037349 */   GIM_Try, /*On fail goto*//*Label 15357*/ GIMT_Encode4(1037426), // Rule ID 13465 //
     /* 1037354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1037357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1037365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1037368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1037371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1037374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037393 */     // MIs[0] policy
     /* 1037393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037403 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11628:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1037406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037425 */     // GIR_Coverage, 13465,
     /* 1037425 */     GIR_EraseRootFromParent_Done,
     /* 1037426 */   // Label 15357: @1037426
     /* 1037426 */   GIM_Try, /*On fail goto*//*Label 15358*/ GIMT_Encode4(1037503), // Rule ID 13468 //
     /* 1037431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1037434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1037442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1037445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1037448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1037451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037470 */     // MIs[0] policy
     /* 1037470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037480 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11628:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1037483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037502 */     // GIR_Coverage, 13468,
     /* 1037502 */     GIR_EraseRootFromParent_Done,
     /* 1037503 */   // Label 15358: @1037503
     /* 1037503 */   GIM_Try, /*On fail goto*//*Label 15359*/ GIMT_Encode4(1037580), // Rule ID 13469 //
     /* 1037508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1037511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1037519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1037522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1037525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1037528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037547 */     // MIs[0] policy
     /* 1037547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037557 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11628:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1037560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037579 */     // GIR_Coverage, 13469,
     /* 1037579 */     GIR_EraseRootFromParent_Done,
     /* 1037580 */   // Label 15359: @1037580
     /* 1037580 */   GIM_Try, /*On fail goto*//*Label 15360*/ GIMT_Encode4(1037657), // Rule ID 13472 //
     /* 1037585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1037588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1037596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1037599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1037602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1037605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037624 */     // MIs[0] policy
     /* 1037624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11628:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1037637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037656 */     // GIR_Coverage, 13472,
     /* 1037656 */     GIR_EraseRootFromParent_Done,
     /* 1037657 */   // Label 15360: @1037657
     /* 1037657 */   GIM_Try, /*On fail goto*//*Label 15361*/ GIMT_Encode4(1037734), // Rule ID 13473 //
     /* 1037662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1037665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1037673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1037676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1037679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1037682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037701 */     // MIs[0] policy
     /* 1037701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037711 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11628:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1037714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037733 */     // GIR_Coverage, 13473,
     /* 1037733 */     GIR_EraseRootFromParent_Done,
     /* 1037734 */   // Label 15361: @1037734
     /* 1037734 */   GIM_Try, /*On fail goto*//*Label 15362*/ GIMT_Encode4(1037811), // Rule ID 13476 //
     /* 1037739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1037742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1037750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1037753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1037756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1037759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037778 */     // MIs[0] policy
     /* 1037778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037788 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11628:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1037791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037810 */     // GIR_Coverage, 13476,
     /* 1037810 */     GIR_EraseRootFromParent_Done,
     /* 1037811 */   // Label 15362: @1037811
     /* 1037811 */   GIM_Try, /*On fail goto*//*Label 15363*/ GIMT_Encode4(1037888), // Rule ID 13477 //
     /* 1037816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1037819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1037827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1037830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1037833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1037836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037855 */     // MIs[0] policy
     /* 1037855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037865 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11628:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1037868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037887 */     // GIR_Coverage, 13477,
     /* 1037887 */     GIR_EraseRootFromParent_Done,
     /* 1037888 */   // Label 15363: @1037888
     /* 1037888 */   GIM_Try, /*On fail goto*//*Label 15364*/ GIMT_Encode4(1037965), // Rule ID 13480 //
     /* 1037893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1037904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1037907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1037910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1037913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1037928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037932 */     // MIs[0] policy
     /* 1037932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037942 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11628:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1037945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037964 */     // GIR_Coverage, 13480,
     /* 1037964 */     GIR_EraseRootFromParent_Done,
     /* 1037965 */   // Label 15364: @1037965
     /* 1037965 */   GIM_Try, /*On fail goto*//*Label 15365*/ GIMT_Encode4(1038042), // Rule ID 13481 //
     /* 1037970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1037981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1037984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1037987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1037990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038009 */     // MIs[0] policy
     /* 1038009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038019 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11628:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1038022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038041 */     // GIR_Coverage, 13481,
     /* 1038041 */     GIR_EraseRootFromParent_Done,
     /* 1038042 */   // Label 15365: @1038042
     /* 1038042 */   GIM_Try, /*On fail goto*//*Label 15366*/ GIMT_Encode4(1038119), // Rule ID 13484 //
     /* 1038047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1038058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1038061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1038067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038086 */     // MIs[0] policy
     /* 1038086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11628:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1038099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038118 */     // GIR_Coverage, 13484,
     /* 1038118 */     GIR_EraseRootFromParent_Done,
     /* 1038119 */   // Label 15366: @1038119
     /* 1038119 */   GIM_Try, /*On fail goto*//*Label 15367*/ GIMT_Encode4(1038196), // Rule ID 13485 //
     /* 1038124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1038135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1038138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1038144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038163 */     // MIs[0] policy
     /* 1038163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038173 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11628:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1038176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038195 */     // GIR_Coverage, 13485,
     /* 1038195 */     GIR_EraseRootFromParent_Done,
     /* 1038196 */   // Label 15367: @1038196
     /* 1038196 */   GIM_Try, /*On fail goto*//*Label 15368*/ GIMT_Encode4(1038273), // Rule ID 13488 //
     /* 1038201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1038212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1038215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1038221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038240 */     // MIs[0] policy
     /* 1038240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11628:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1038253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038272 */     // GIR_Coverage, 13488,
     /* 1038272 */     GIR_EraseRootFromParent_Done,
     /* 1038273 */   // Label 15368: @1038273
     /* 1038273 */   GIM_Try, /*On fail goto*//*Label 15369*/ GIMT_Encode4(1038350), // Rule ID 13489 //
     /* 1038278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1038289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1038292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1038298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038317 */     // MIs[0] policy
     /* 1038317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11628:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1038330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038349 */     // GIR_Coverage, 13489,
     /* 1038349 */     GIR_EraseRootFromParent_Done,
     /* 1038350 */   // Label 15369: @1038350
     /* 1038350 */   GIM_Try, /*On fail goto*//*Label 15370*/ GIMT_Encode4(1038427), // Rule ID 13492 //
     /* 1038355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1038366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1038369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1038375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038394 */     // MIs[0] policy
     /* 1038394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11628:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1038407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038426 */     // GIR_Coverage, 13492,
     /* 1038426 */     GIR_EraseRootFromParent_Done,
     /* 1038427 */   // Label 15370: @1038427
     /* 1038427 */   GIM_Try, /*On fail goto*//*Label 15371*/ GIMT_Encode4(1038504), // Rule ID 13493 //
     /* 1038432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1038443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1038446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1038452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038471 */     // MIs[0] policy
     /* 1038471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038481 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11628:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1038484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038503 */     // GIR_Coverage, 13493,
     /* 1038503 */     GIR_EraseRootFromParent_Done,
     /* 1038504 */   // Label 15371: @1038504
     /* 1038504 */   GIM_Try, /*On fail goto*//*Label 15372*/ GIMT_Encode4(1038581), // Rule ID 13496 //
     /* 1038509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1038520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1038523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1038529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038548 */     // MIs[0] policy
     /* 1038548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038558 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11628:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1038561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038580 */     // GIR_Coverage, 13496,
     /* 1038580 */     GIR_EraseRootFromParent_Done,
     /* 1038581 */   // Label 15372: @1038581
     /* 1038581 */   GIM_Try, /*On fail goto*//*Label 15373*/ GIMT_Encode4(1038658), // Rule ID 13497 //
     /* 1038586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1038597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1038600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1038606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038625 */     // MIs[0] policy
     /* 1038625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038635 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11628:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1038638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038657 */     // GIR_Coverage, 13497,
     /* 1038657 */     GIR_EraseRootFromParent_Done,
     /* 1038658 */   // Label 15373: @1038658
     /* 1038658 */   GIM_Try, /*On fail goto*//*Label 15374*/ GIMT_Encode4(1038735), // Rule ID 13500 //
     /* 1038663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1038674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1038677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1038683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038702 */     // MIs[0] policy
     /* 1038702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038712 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11628:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1038715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038734 */     // GIR_Coverage, 13500,
     /* 1038734 */     GIR_EraseRootFromParent_Done,
     /* 1038735 */   // Label 15374: @1038735
     /* 1038735 */   GIM_Try, /*On fail goto*//*Label 15375*/ GIMT_Encode4(1038812), // Rule ID 13501 //
     /* 1038740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1038751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1038754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1038760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038779 */     // MIs[0] policy
     /* 1038779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038789 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11628:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1038792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038811 */     // GIR_Coverage, 13501,
     /* 1038811 */     GIR_EraseRootFromParent_Done,
     /* 1038812 */   // Label 15375: @1038812
     /* 1038812 */   GIM_Try, /*On fail goto*//*Label 15376*/ GIMT_Encode4(1038889), // Rule ID 13504 //
     /* 1038817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1038828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1038831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1038837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038856 */     // MIs[0] policy
     /* 1038856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038866 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11628:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1038869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038888 */     // GIR_Coverage, 13504,
     /* 1038888 */     GIR_EraseRootFromParent_Done,
     /* 1038889 */   // Label 15376: @1038889
     /* 1038889 */   GIM_Try, /*On fail goto*//*Label 15377*/ GIMT_Encode4(1038966), // Rule ID 13505 //
     /* 1038894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1038905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1038908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1038914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038933 */     // MIs[0] policy
     /* 1038933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038943 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11628:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1038946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038965 */     // GIR_Coverage, 13505,
     /* 1038965 */     GIR_EraseRootFromParent_Done,
     /* 1038966 */   // Label 15377: @1038966
     /* 1038966 */   GIM_Try, /*On fail goto*//*Label 15378*/ GIMT_Encode4(1039043), // Rule ID 13508 //
     /* 1038971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1038982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1038985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1038991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039010 */     // MIs[0] policy
     /* 1039010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11628:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1039023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039042 */     // GIR_Coverage, 13508,
     /* 1039042 */     GIR_EraseRootFromParent_Done,
     /* 1039043 */   // Label 15378: @1039043
     /* 1039043 */   GIM_Try, /*On fail goto*//*Label 15379*/ GIMT_Encode4(1039120), // Rule ID 13509 //
     /* 1039048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1039059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1039062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1039068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039087 */     // MIs[0] policy
     /* 1039087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039097 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11628:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1039100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039119 */     // GIR_Coverage, 13509,
     /* 1039119 */     GIR_EraseRootFromParent_Done,
     /* 1039120 */   // Label 15379: @1039120
     /* 1039120 */   GIM_Try, /*On fail goto*//*Label 15380*/ GIMT_Encode4(1039197), // Rule ID 13512 //
     /* 1039125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1039136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1039139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1039145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039164 */     // MIs[0] policy
     /* 1039164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11628:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1039177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039196 */     // GIR_Coverage, 13512,
     /* 1039196 */     GIR_EraseRootFromParent_Done,
     /* 1039197 */   // Label 15380: @1039197
     /* 1039197 */   GIM_Try, /*On fail goto*//*Label 15381*/ GIMT_Encode4(1039274), // Rule ID 13513 //
     /* 1039202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1039213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1039216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1039222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039241 */     // MIs[0] policy
     /* 1039241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039251 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11628:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1039254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039273 */     // GIR_Coverage, 13513,
     /* 1039273 */     GIR_EraseRootFromParent_Done,
     /* 1039274 */   // Label 15381: @1039274
     /* 1039274 */   GIM_Try, /*On fail goto*//*Label 15382*/ GIMT_Encode4(1039351), // Rule ID 13516 //
     /* 1039279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1039290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1039293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1039299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039318 */     // MIs[0] policy
     /* 1039318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11628:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1039331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039350 */     // GIR_Coverage, 13516,
     /* 1039350 */     GIR_EraseRootFromParent_Done,
     /* 1039351 */   // Label 15382: @1039351
     /* 1039351 */   GIM_Try, /*On fail goto*//*Label 15383*/ GIMT_Encode4(1039428), // Rule ID 13517 //
     /* 1039356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1039367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1039370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1039376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039395 */     // MIs[0] policy
     /* 1039395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039405 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11628:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1039408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039427 */     // GIR_Coverage, 13517,
     /* 1039427 */     GIR_EraseRootFromParent_Done,
     /* 1039428 */   // Label 15383: @1039428
     /* 1039428 */   GIM_Try, /*On fail goto*//*Label 15384*/ GIMT_Encode4(1039505), // Rule ID 13520 //
     /* 1039433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1039444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1039447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1039453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039472 */     // MIs[0] policy
     /* 1039472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039482 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11628:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1039485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039504 */     // GIR_Coverage, 13520,
     /* 1039504 */     GIR_EraseRootFromParent_Done,
     /* 1039505 */   // Label 15384: @1039505
     /* 1039505 */   GIM_Try, /*On fail goto*//*Label 15385*/ GIMT_Encode4(1039582), // Rule ID 13521 //
     /* 1039510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1039521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1039524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1039530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039549 */     // MIs[0] policy
     /* 1039549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039559 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11628:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1039562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039581 */     // GIR_Coverage, 13521,
     /* 1039581 */     GIR_EraseRootFromParent_Done,
     /* 1039582 */   // Label 15385: @1039582
     /* 1039582 */   GIM_Try, /*On fail goto*//*Label 15386*/ GIMT_Encode4(1039659), // Rule ID 13524 //
     /* 1039587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1039590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1039598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1039601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1039607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039626 */     // MIs[0] policy
     /* 1039626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11628:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1039639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039658 */     // GIR_Coverage, 13524,
     /* 1039658 */     GIR_EraseRootFromParent_Done,
     /* 1039659 */   // Label 15386: @1039659
     /* 1039659 */   GIM_Try, /*On fail goto*//*Label 15387*/ GIMT_Encode4(1039736), // Rule ID 13525 //
     /* 1039664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1039667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1039675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1039678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1039684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039703 */     // MIs[0] policy
     /* 1039703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039713 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11628:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1039716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039735 */     // GIR_Coverage, 13525,
     /* 1039735 */     GIR_EraseRootFromParent_Done,
     /* 1039736 */   // Label 15387: @1039736
     /* 1039736 */   GIM_Try, /*On fail goto*//*Label 15388*/ GIMT_Encode4(1039813), // Rule ID 13528 //
     /* 1039741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1039744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1039752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1039755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1039761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039780 */     // MIs[0] policy
     /* 1039780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11628:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1039793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039812 */     // GIR_Coverage, 13528,
     /* 1039812 */     GIR_EraseRootFromParent_Done,
     /* 1039813 */   // Label 15388: @1039813
     /* 1039813 */   GIM_Try, /*On fail goto*//*Label 15389*/ GIMT_Encode4(1039890), // Rule ID 13529 //
     /* 1039818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1039821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1039829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1039832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1039838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039857 */     // MIs[0] policy
     /* 1039857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039867 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11628:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1039870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039889 */     // GIR_Coverage, 13529,
     /* 1039889 */     GIR_EraseRootFromParent_Done,
     /* 1039890 */   // Label 15389: @1039890
     /* 1039890 */   GIM_Try, /*On fail goto*//*Label 15390*/ GIMT_Encode4(1039967), // Rule ID 13532 //
     /* 1039895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1039898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1039906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1039909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1039915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039934 */     // MIs[0] policy
     /* 1039934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039944 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11628:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1039947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039966 */     // GIR_Coverage, 13532,
     /* 1039966 */     GIR_EraseRootFromParent_Done,
     /* 1039967 */   // Label 15390: @1039967
     /* 1039967 */   GIM_Try, /*On fail goto*//*Label 15391*/ GIMT_Encode4(1040044), // Rule ID 13533 //
     /* 1039972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1039975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1039983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1039986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1039992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040011 */     // MIs[0] policy
     /* 1040011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040021 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11628:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1040024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040043 */     // GIR_Coverage, 13533,
     /* 1040043 */     GIR_EraseRootFromParent_Done,
     /* 1040044 */   // Label 15391: @1040044
     /* 1040044 */   GIM_Try, /*On fail goto*//*Label 15392*/ GIMT_Encode4(1040121), // Rule ID 13536 //
     /* 1040049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1040057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1040060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1040063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1040069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040088 */     // MIs[0] policy
     /* 1040088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040098 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11628:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1040101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040120 */     // GIR_Coverage, 13536,
     /* 1040120 */     GIR_EraseRootFromParent_Done,
     /* 1040121 */   // Label 15392: @1040121
     /* 1040121 */   GIM_Try, /*On fail goto*//*Label 15393*/ GIMT_Encode4(1040198), // Rule ID 13537 //
     /* 1040126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1040134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1040137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1040140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1040146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040165 */     // MIs[0] policy
     /* 1040165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040175 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11628:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1040178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040197 */     // GIR_Coverage, 13537,
     /* 1040197 */     GIR_EraseRootFromParent_Done,
     /* 1040198 */   // Label 15393: @1040198
     /* 1040198 */   GIM_Try, /*On fail goto*//*Label 15394*/ GIMT_Encode4(1040275), // Rule ID 13540 //
     /* 1040203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1040214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1040217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1040220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1040223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040242 */     // MIs[0] policy
     /* 1040242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040252 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11624:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1040255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040274 */     // GIR_Coverage, 13540,
     /* 1040274 */     GIR_EraseRootFromParent_Done,
     /* 1040275 */   // Label 15394: @1040275
     /* 1040275 */   GIM_Try, /*On fail goto*//*Label 15395*/ GIMT_Encode4(1040352), // Rule ID 13541 //
     /* 1040280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1040291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1040294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1040297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1040300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040319 */     // MIs[0] policy
     /* 1040319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040329 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11624:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1040332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040351 */     // GIR_Coverage, 13541,
     /* 1040351 */     GIR_EraseRootFromParent_Done,
     /* 1040352 */   // Label 15395: @1040352
     /* 1040352 */   GIM_Try, /*On fail goto*//*Label 15396*/ GIMT_Encode4(1040429), // Rule ID 13544 //
     /* 1040357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1040368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1040371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1040374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1040377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040396 */     // MIs[0] policy
     /* 1040396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040406 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11624:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1040409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040428 */     // GIR_Coverage, 13544,
     /* 1040428 */     GIR_EraseRootFromParent_Done,
     /* 1040429 */   // Label 15396: @1040429
     /* 1040429 */   GIM_Try, /*On fail goto*//*Label 15397*/ GIMT_Encode4(1040506), // Rule ID 13545 //
     /* 1040434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1040445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1040448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1040451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1040454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040473 */     // MIs[0] policy
     /* 1040473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040483 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11624:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1040486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040505 */     // GIR_Coverage, 13545,
     /* 1040505 */     GIR_EraseRootFromParent_Done,
     /* 1040506 */   // Label 15397: @1040506
     /* 1040506 */   GIM_Try, /*On fail goto*//*Label 15398*/ GIMT_Encode4(1040583), // Rule ID 13548 //
     /* 1040511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1040522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1040525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1040528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1040531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040550 */     // MIs[0] policy
     /* 1040550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040560 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11624:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1040563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040582 */     // GIR_Coverage, 13548,
     /* 1040582 */     GIR_EraseRootFromParent_Done,
     /* 1040583 */   // Label 15398: @1040583
     /* 1040583 */   GIM_Try, /*On fail goto*//*Label 15399*/ GIMT_Encode4(1040660), // Rule ID 13549 //
     /* 1040588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1040599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1040602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1040605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1040608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040627 */     // MIs[0] policy
     /* 1040627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040637 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11624:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1040640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040659 */     // GIR_Coverage, 13549,
     /* 1040659 */     GIR_EraseRootFromParent_Done,
     /* 1040660 */   // Label 15399: @1040660
     /* 1040660 */   GIM_Try, /*On fail goto*//*Label 15400*/ GIMT_Encode4(1040737), // Rule ID 13552 //
     /* 1040665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1040676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1040679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1040682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1040685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040704 */     // MIs[0] policy
     /* 1040704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11624:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1040717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040736 */     // GIR_Coverage, 13552,
     /* 1040736 */     GIR_EraseRootFromParent_Done,
     /* 1040737 */   // Label 15400: @1040737
     /* 1040737 */   GIM_Try, /*On fail goto*//*Label 15401*/ GIMT_Encode4(1040814), // Rule ID 13553 //
     /* 1040742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1040753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1040756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1040759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1040762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040781 */     // MIs[0] policy
     /* 1040781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040791 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11624:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1040794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040813 */     // GIR_Coverage, 13553,
     /* 1040813 */     GIR_EraseRootFromParent_Done,
     /* 1040814 */   // Label 15401: @1040814
     /* 1040814 */   GIM_Try, /*On fail goto*//*Label 15402*/ GIMT_Encode4(1040891), // Rule ID 13556 //
     /* 1040819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1040830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1040833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1040836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1040839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040858 */     // MIs[0] policy
     /* 1040858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040868 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11624:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1040871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040890 */     // GIR_Coverage, 13556,
     /* 1040890 */     GIR_EraseRootFromParent_Done,
     /* 1040891 */   // Label 15402: @1040891
     /* 1040891 */   GIM_Try, /*On fail goto*//*Label 15403*/ GIMT_Encode4(1040968), // Rule ID 13557 //
     /* 1040896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1040907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1040910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1040913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1040916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040935 */     // MIs[0] policy
     /* 1040935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040945 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11624:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1040948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040967 */     // GIR_Coverage, 13557,
     /* 1040967 */     GIR_EraseRootFromParent_Done,
     /* 1040968 */   // Label 15403: @1040968
     /* 1040968 */   GIM_Try, /*On fail goto*//*Label 15404*/ GIMT_Encode4(1041045), // Rule ID 13560 //
     /* 1040973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1040984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1040987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1040990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1040993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041012 */     // MIs[0] policy
     /* 1041012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041022 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11624:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1041025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041044 */     // GIR_Coverage, 13560,
     /* 1041044 */     GIR_EraseRootFromParent_Done,
     /* 1041045 */   // Label 15404: @1041045
     /* 1041045 */   GIM_Try, /*On fail goto*//*Label 15405*/ GIMT_Encode4(1041122), // Rule ID 13561 //
     /* 1041050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1041061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1041064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1041067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1041070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041089 */     // MIs[0] policy
     /* 1041089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041099 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11624:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1041102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041121 */     // GIR_Coverage, 13561,
     /* 1041121 */     GIR_EraseRootFromParent_Done,
     /* 1041122 */   // Label 15405: @1041122
     /* 1041122 */   GIM_Try, /*On fail goto*//*Label 15406*/ GIMT_Encode4(1041199), // Rule ID 13564 //
     /* 1041127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1041138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1041141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1041144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1041147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041166 */     // MIs[0] policy
     /* 1041166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11624:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1041179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041198 */     // GIR_Coverage, 13564,
     /* 1041198 */     GIR_EraseRootFromParent_Done,
     /* 1041199 */   // Label 15406: @1041199
     /* 1041199 */   GIM_Try, /*On fail goto*//*Label 15407*/ GIMT_Encode4(1041276), // Rule ID 13565 //
     /* 1041204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1041215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1041218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1041221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1041224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041243 */     // MIs[0] policy
     /* 1041243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041253 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11624:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1041256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041275 */     // GIR_Coverage, 13565,
     /* 1041275 */     GIR_EraseRootFromParent_Done,
     /* 1041276 */   // Label 15407: @1041276
     /* 1041276 */   GIM_Try, /*On fail goto*//*Label 15408*/ GIMT_Encode4(1041353), // Rule ID 13568 //
     /* 1041281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1041292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1041295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1041298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1041301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041320 */     // MIs[0] policy
     /* 1041320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041330 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11624:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1041333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041352 */     // GIR_Coverage, 13568,
     /* 1041352 */     GIR_EraseRootFromParent_Done,
     /* 1041353 */   // Label 15408: @1041353
     /* 1041353 */   GIM_Try, /*On fail goto*//*Label 15409*/ GIMT_Encode4(1041430), // Rule ID 13569 //
     /* 1041358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1041369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1041372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1041375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1041378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041397 */     // MIs[0] policy
     /* 1041397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041407 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11624:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1041410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041429 */     // GIR_Coverage, 13569,
     /* 1041429 */     GIR_EraseRootFromParent_Done,
     /* 1041430 */   // Label 15409: @1041430
     /* 1041430 */   GIM_Try, /*On fail goto*//*Label 15410*/ GIMT_Encode4(1041507), // Rule ID 13572 //
     /* 1041435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1041446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1041449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1041452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1041455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041474 */     // MIs[0] policy
     /* 1041474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11624:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1041487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041506 */     // GIR_Coverage, 13572,
     /* 1041506 */     GIR_EraseRootFromParent_Done,
     /* 1041507 */   // Label 15410: @1041507
     /* 1041507 */   GIM_Try, /*On fail goto*//*Label 15411*/ GIMT_Encode4(1041584), // Rule ID 13573 //
     /* 1041512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1041523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1041526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1041529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1041532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041551 */     // MIs[0] policy
     /* 1041551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041561 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11624:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1041564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041583 */     // GIR_Coverage, 13573,
     /* 1041583 */     GIR_EraseRootFromParent_Done,
     /* 1041584 */   // Label 15411: @1041584
     /* 1041584 */   GIM_Try, /*On fail goto*//*Label 15412*/ GIMT_Encode4(1041661), // Rule ID 13576 //
     /* 1041589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1041600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1041603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1041606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1041609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041628 */     // MIs[0] policy
     /* 1041628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041638 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11624:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1041641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041660 */     // GIR_Coverage, 13576,
     /* 1041660 */     GIR_EraseRootFromParent_Done,
     /* 1041661 */   // Label 15412: @1041661
     /* 1041661 */   GIM_Try, /*On fail goto*//*Label 15413*/ GIMT_Encode4(1041738), // Rule ID 13577 //
     /* 1041666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1041677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1041680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1041683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1041686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041705 */     // MIs[0] policy
     /* 1041705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041715 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11624:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1041718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041737 */     // GIR_Coverage, 13577,
     /* 1041737 */     GIR_EraseRootFromParent_Done,
     /* 1041738 */   // Label 15413: @1041738
     /* 1041738 */   GIM_Try, /*On fail goto*//*Label 15414*/ GIMT_Encode4(1041815), // Rule ID 13580 //
     /* 1041743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1041754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1041757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1041760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1041763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041782 */     // MIs[0] policy
     /* 1041782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041792 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11624:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1041795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041814 */     // GIR_Coverage, 13580,
     /* 1041814 */     GIR_EraseRootFromParent_Done,
     /* 1041815 */   // Label 15414: @1041815
     /* 1041815 */   GIM_Try, /*On fail goto*//*Label 15415*/ GIMT_Encode4(1041892), // Rule ID 13581 //
     /* 1041820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1041831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1041834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1041837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1041840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041859 */     // MIs[0] policy
     /* 1041859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041869 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11624:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1041872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041891 */     // GIR_Coverage, 13581,
     /* 1041891 */     GIR_EraseRootFromParent_Done,
     /* 1041892 */   // Label 15415: @1041892
     /* 1041892 */   GIM_Try, /*On fail goto*//*Label 15416*/ GIMT_Encode4(1041969), // Rule ID 13584 //
     /* 1041897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1041900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1041908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1041911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1041914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1041917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041936 */     // MIs[0] policy
     /* 1041936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11624:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1041949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041968 */     // GIR_Coverage, 13584,
     /* 1041968 */     GIR_EraseRootFromParent_Done,
     /* 1041969 */   // Label 15416: @1041969
     /* 1041969 */   GIM_Try, /*On fail goto*//*Label 15417*/ GIMT_Encode4(1042046), // Rule ID 13585 //
     /* 1041974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1041977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1041985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1041988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1041991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1041994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042013 */     // MIs[0] policy
     /* 1042013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042023 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11624:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1042026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042045 */     // GIR_Coverage, 13585,
     /* 1042045 */     GIR_EraseRootFromParent_Done,
     /* 1042046 */   // Label 15417: @1042046
     /* 1042046 */   GIM_Try, /*On fail goto*//*Label 15418*/ GIMT_Encode4(1042123), // Rule ID 13588 //
     /* 1042051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1042062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1042065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1042068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1042071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042090 */     // MIs[0] policy
     /* 1042090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042100 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11624:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1042103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042122 */     // GIR_Coverage, 13588,
     /* 1042122 */     GIR_EraseRootFromParent_Done,
     /* 1042123 */   // Label 15418: @1042123
     /* 1042123 */   GIM_Try, /*On fail goto*//*Label 15419*/ GIMT_Encode4(1042200), // Rule ID 13589 //
     /* 1042128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1042139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1042142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1042145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1042148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042167 */     // MIs[0] policy
     /* 1042167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11624:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1042180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042199 */     // GIR_Coverage, 13589,
     /* 1042199 */     GIR_EraseRootFromParent_Done,
     /* 1042200 */   // Label 15419: @1042200
     /* 1042200 */   GIM_Try, /*On fail goto*//*Label 15420*/ GIMT_Encode4(1042277), // Rule ID 13592 //
     /* 1042205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1042216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1042219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1042222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1042225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042244 */     // MIs[0] policy
     /* 1042244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042254 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11624:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1042257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042276 */     // GIR_Coverage, 13592,
     /* 1042276 */     GIR_EraseRootFromParent_Done,
     /* 1042277 */   // Label 15420: @1042277
     /* 1042277 */   GIM_Try, /*On fail goto*//*Label 15421*/ GIMT_Encode4(1042354), // Rule ID 13593 //
     /* 1042282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1042293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1042296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1042299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1042302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042321 */     // MIs[0] policy
     /* 1042321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042331 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11624:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1042334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042353 */     // GIR_Coverage, 13593,
     /* 1042353 */     GIR_EraseRootFromParent_Done,
     /* 1042354 */   // Label 15421: @1042354
     /* 1042354 */   GIM_Try, /*On fail goto*//*Label 15422*/ GIMT_Encode4(1042431), // Rule ID 13596 //
     /* 1042359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1042370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1042373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1042376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1042379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042398 */     // MIs[0] policy
     /* 1042398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11624:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1042411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042430 */     // GIR_Coverage, 13596,
     /* 1042430 */     GIR_EraseRootFromParent_Done,
     /* 1042431 */   // Label 15422: @1042431
     /* 1042431 */   GIM_Try, /*On fail goto*//*Label 15423*/ GIMT_Encode4(1042508), // Rule ID 13597 //
     /* 1042436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1042447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1042450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1042453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1042456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042475 */     // MIs[0] policy
     /* 1042475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042485 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11624:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1042488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042507 */     // GIR_Coverage, 13597,
     /* 1042507 */     GIR_EraseRootFromParent_Done,
     /* 1042508 */   // Label 15423: @1042508
     /* 1042508 */   GIM_Try, /*On fail goto*//*Label 15424*/ GIMT_Encode4(1042585), // Rule ID 13600 //
     /* 1042513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1042524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1042527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1042530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1042533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042552 */     // MIs[0] policy
     /* 1042552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042562 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11624:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1042565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042584 */     // GIR_Coverage, 13600,
     /* 1042584 */     GIR_EraseRootFromParent_Done,
     /* 1042585 */   // Label 15424: @1042585
     /* 1042585 */   GIM_Try, /*On fail goto*//*Label 15425*/ GIMT_Encode4(1042662), // Rule ID 13601 //
     /* 1042590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1042601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1042604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1042607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1042610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042629 */     // MIs[0] policy
     /* 1042629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042639 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11624:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1042642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042661 */     // GIR_Coverage, 13601,
     /* 1042661 */     GIR_EraseRootFromParent_Done,
     /* 1042662 */   // Label 15425: @1042662
     /* 1042662 */   GIM_Try, /*On fail goto*//*Label 15426*/ GIMT_Encode4(1042739), // Rule ID 13604 //
     /* 1042667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1042678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1042681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1042684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1042687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042706 */     // MIs[0] policy
     /* 1042706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042716 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11624:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1042719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042738 */     // GIR_Coverage, 13604,
     /* 1042738 */     GIR_EraseRootFromParent_Done,
     /* 1042739 */   // Label 15426: @1042739
     /* 1042739 */   GIM_Try, /*On fail goto*//*Label 15427*/ GIMT_Encode4(1042816), // Rule ID 13605 //
     /* 1042744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1042755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1042758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1042761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1042764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042783 */     // MIs[0] policy
     /* 1042783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042793 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11624:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1042796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042815 */     // GIR_Coverage, 13605,
     /* 1042815 */     GIR_EraseRootFromParent_Done,
     /* 1042816 */   // Label 15427: @1042816
     /* 1042816 */   GIM_Try, /*On fail goto*//*Label 15428*/ GIMT_Encode4(1042893), // Rule ID 13608 //
     /* 1042821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1042832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1042835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1042838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1042841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042860 */     // MIs[0] policy
     /* 1042860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042870 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11624:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1042873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042892 */     // GIR_Coverage, 13608,
     /* 1042892 */     GIR_EraseRootFromParent_Done,
     /* 1042893 */   // Label 15428: @1042893
     /* 1042893 */   GIM_Try, /*On fail goto*//*Label 15429*/ GIMT_Encode4(1042970), // Rule ID 13609 //
     /* 1042898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1042909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1042912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1042915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1042918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042937 */     // MIs[0] policy
     /* 1042937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042947 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11624:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1042950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042969 */     // GIR_Coverage, 13609,
     /* 1042969 */     GIR_EraseRootFromParent_Done,
     /* 1042970 */   // Label 15429: @1042970
     /* 1042970 */   GIM_Try, /*On fail goto*//*Label 15430*/ GIMT_Encode4(1043047), // Rule ID 13612 //
     /* 1042975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1042986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1042989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1042992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1042995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043014 */     // MIs[0] policy
     /* 1043014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11624:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1043027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043046 */     // GIR_Coverage, 13612,
     /* 1043046 */     GIR_EraseRootFromParent_Done,
     /* 1043047 */   // Label 15430: @1043047
     /* 1043047 */   GIM_Try, /*On fail goto*//*Label 15431*/ GIMT_Encode4(1043124), // Rule ID 13613 //
     /* 1043052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1043063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1043066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1043072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043091 */     // MIs[0] policy
     /* 1043091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11624:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1043104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043123 */     // GIR_Coverage, 13613,
     /* 1043123 */     GIR_EraseRootFromParent_Done,
     /* 1043124 */   // Label 15431: @1043124
     /* 1043124 */   GIM_Try, /*On fail goto*//*Label 15432*/ GIMT_Encode4(1043201), // Rule ID 13616 //
     /* 1043129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1043140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1043143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1043149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043168 */     // MIs[0] policy
     /* 1043168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043178 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11624:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1043181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043200 */     // GIR_Coverage, 13616,
     /* 1043200 */     GIR_EraseRootFromParent_Done,
     /* 1043201 */   // Label 15432: @1043201
     /* 1043201 */   GIM_Try, /*On fail goto*//*Label 15433*/ GIMT_Encode4(1043278), // Rule ID 13617 //
     /* 1043206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1043217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1043220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1043226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043245 */     // MIs[0] policy
     /* 1043245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043255 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11624:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1043258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043277 */     // GIR_Coverage, 13617,
     /* 1043277 */     GIR_EraseRootFromParent_Done,
     /* 1043278 */   // Label 15433: @1043278
     /* 1043278 */   GIM_Try, /*On fail goto*//*Label 15434*/ GIMT_Encode4(1043355), // Rule ID 13620 //
     /* 1043283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1043294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1043297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1043303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043322 */     // MIs[0] policy
     /* 1043322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043332 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11624:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1043335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043354 */     // GIR_Coverage, 13620,
     /* 1043354 */     GIR_EraseRootFromParent_Done,
     /* 1043355 */   // Label 15434: @1043355
     /* 1043355 */   GIM_Try, /*On fail goto*//*Label 15435*/ GIMT_Encode4(1043432), // Rule ID 13621 //
     /* 1043360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1043371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1043374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1043380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043399 */     // MIs[0] policy
     /* 1043399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043409 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11624:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1043412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043431 */     // GIR_Coverage, 13621,
     /* 1043431 */     GIR_EraseRootFromParent_Done,
     /* 1043432 */   // Label 15435: @1043432
     /* 1043432 */   GIM_Try, /*On fail goto*//*Label 15436*/ GIMT_Encode4(1043509), // Rule ID 13624 //
     /* 1043437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1043448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1043451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1043457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043476 */     // MIs[0] policy
     /* 1043476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11624:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1043489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043508 */     // GIR_Coverage, 13624,
     /* 1043508 */     GIR_EraseRootFromParent_Done,
     /* 1043509 */   // Label 15436: @1043509
     /* 1043509 */   GIM_Try, /*On fail goto*//*Label 15437*/ GIMT_Encode4(1043586), // Rule ID 13625 //
     /* 1043514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1043525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1043528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1043534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043553 */     // MIs[0] policy
     /* 1043553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043563 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11624:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1043566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043585 */     // GIR_Coverage, 13625,
     /* 1043585 */     GIR_EraseRootFromParent_Done,
     /* 1043586 */   // Label 15437: @1043586
     /* 1043586 */   GIM_Try, /*On fail goto*//*Label 15438*/ GIMT_Encode4(1043663), // Rule ID 13628 //
     /* 1043591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1043602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1043605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1043611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043630 */     // MIs[0] policy
     /* 1043630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043640 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11624:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1043643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043662 */     // GIR_Coverage, 13628,
     /* 1043662 */     GIR_EraseRootFromParent_Done,
     /* 1043663 */   // Label 15438: @1043663
     /* 1043663 */   GIM_Try, /*On fail goto*//*Label 15439*/ GIMT_Encode4(1043740), // Rule ID 13629 //
     /* 1043668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1043679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1043682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1043688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043707 */     // MIs[0] policy
     /* 1043707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043717 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11624:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1043720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043739 */     // GIR_Coverage, 13629,
     /* 1043739 */     GIR_EraseRootFromParent_Done,
     /* 1043740 */   // Label 15439: @1043740
     /* 1043740 */   GIM_Try, /*On fail goto*//*Label 15440*/ GIMT_Encode4(1043817), // Rule ID 13632 //
     /* 1043745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1043756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1043759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1043765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043784 */     // MIs[0] policy
     /* 1043784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11624:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1043797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043816 */     // GIR_Coverage, 13632,
     /* 1043816 */     GIR_EraseRootFromParent_Done,
     /* 1043817 */   // Label 15440: @1043817
     /* 1043817 */   GIM_Try, /*On fail goto*//*Label 15441*/ GIMT_Encode4(1043894), // Rule ID 13633 //
     /* 1043822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1043833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1043836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1043842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043861 */     // MIs[0] policy
     /* 1043861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11624:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1043874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043893 */     // GIR_Coverage, 13633,
     /* 1043893 */     GIR_EraseRootFromParent_Done,
     /* 1043894 */   // Label 15441: @1043894
     /* 1043894 */   GIM_Try, /*On fail goto*//*Label 15442*/ GIMT_Encode4(1043971), // Rule ID 13636 //
     /* 1043899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1043910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1043913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1043919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043938 */     // MIs[0] policy
     /* 1043938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043948 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11624:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1043951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043970 */     // GIR_Coverage, 13636,
     /* 1043970 */     GIR_EraseRootFromParent_Done,
     /* 1043971 */   // Label 15442: @1043971
     /* 1043971 */   GIM_Try, /*On fail goto*//*Label 15443*/ GIMT_Encode4(1044048), // Rule ID 13637 //
     /* 1043976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1043987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1043990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1043996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044015 */     // MIs[0] policy
     /* 1044015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044025 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11624:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1044028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044047 */     // GIR_Coverage, 13637,
     /* 1044047 */     GIR_EraseRootFromParent_Done,
     /* 1044048 */   // Label 15443: @1044048
     /* 1044048 */   GIM_Try, /*On fail goto*//*Label 15444*/ GIMT_Encode4(1044125), // Rule ID 13640 //
     /* 1044053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1044064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1044067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1044073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044092 */     // MIs[0] policy
     /* 1044092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11624:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1044105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044124 */     // GIR_Coverage, 13640,
     /* 1044124 */     GIR_EraseRootFromParent_Done,
     /* 1044125 */   // Label 15444: @1044125
     /* 1044125 */   GIM_Try, /*On fail goto*//*Label 15445*/ GIMT_Encode4(1044202), // Rule ID 13641 //
     /* 1044130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1044141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1044144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1044150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044169 */     // MIs[0] policy
     /* 1044169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044179 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11624:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1044182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044201 */     // GIR_Coverage, 13641,
     /* 1044201 */     GIR_EraseRootFromParent_Done,
     /* 1044202 */   // Label 15445: @1044202
     /* 1044202 */   GIM_Try, /*On fail goto*//*Label 15446*/ GIMT_Encode4(1044279), // Rule ID 13644 //
     /* 1044207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1044218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1044221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1044227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044246 */     // MIs[0] policy
     /* 1044246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044256 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11624:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1044259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044278 */     // GIR_Coverage, 13644,
     /* 1044278 */     GIR_EraseRootFromParent_Done,
     /* 1044279 */   // Label 15446: @1044279
     /* 1044279 */   GIM_Try, /*On fail goto*//*Label 15447*/ GIMT_Encode4(1044356), // Rule ID 13645 //
     /* 1044284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1044287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1044295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1044298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1044304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044323 */     // MIs[0] policy
     /* 1044323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044333 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11624:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1044336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044355 */     // GIR_Coverage, 13645,
     /* 1044355 */     GIR_EraseRootFromParent_Done,
     /* 1044356 */   // Label 15447: @1044356
     /* 1044356 */   GIM_Try, /*On fail goto*//*Label 15448*/ GIMT_Encode4(1044433), // Rule ID 13648 //
     /* 1044361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1044372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1044375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1044381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044400 */     // MIs[0] policy
     /* 1044400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11624:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1044413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044432 */     // GIR_Coverage, 13648,
     /* 1044432 */     GIR_EraseRootFromParent_Done,
     /* 1044433 */   // Label 15448: @1044433
     /* 1044433 */   GIM_Try, /*On fail goto*//*Label 15449*/ GIMT_Encode4(1044510), // Rule ID 13649 //
     /* 1044438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1044441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1044449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1044452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1044458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044477 */     // MIs[0] policy
     /* 1044477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044487 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11624:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1044490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044509 */     // GIR_Coverage, 13649,
     /* 1044509 */     GIR_EraseRootFromParent_Done,
     /* 1044510 */   // Label 15449: @1044510
     /* 1044510 */   GIM_Try, /*On fail goto*//*Label 15450*/ GIMT_Encode4(1044587), // Rule ID 13652 //
     /* 1044515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1044526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1044529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1044535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044554 */     // MIs[0] policy
     /* 1044554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044564 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11624:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1044567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044586 */     // GIR_Coverage, 13652,
     /* 1044586 */     GIR_EraseRootFromParent_Done,
     /* 1044587 */   // Label 15450: @1044587
     /* 1044587 */   GIM_Try, /*On fail goto*//*Label 15451*/ GIMT_Encode4(1044664), // Rule ID 13653 //
     /* 1044592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1044595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1044603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1044606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1044612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044631 */     // MIs[0] policy
     /* 1044631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044641 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11624:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1044644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044663 */     // GIR_Coverage, 13653,
     /* 1044663 */     GIR_EraseRootFromParent_Done,
     /* 1044664 */   // Label 15451: @1044664
     /* 1044664 */   GIM_Try, /*On fail goto*//*Label 15452*/ GIMT_Encode4(1044741), // Rule ID 13656 //
     /* 1044669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1044680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1044683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1044689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044708 */     // MIs[0] policy
     /* 1044708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11624:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1044721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044740 */     // GIR_Coverage, 13656,
     /* 1044740 */     GIR_EraseRootFromParent_Done,
     /* 1044741 */   // Label 15452: @1044741
     /* 1044741 */   GIM_Try, /*On fail goto*//*Label 15453*/ GIMT_Encode4(1044818), // Rule ID 13657 //
     /* 1044746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1044749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1044757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1044760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1044766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044785 */     // MIs[0] policy
     /* 1044785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044795 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11624:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1044798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044817 */     // GIR_Coverage, 13657,
     /* 1044817 */     GIR_EraseRootFromParent_Done,
     /* 1044818 */   // Label 15453: @1044818
     /* 1044818 */   GIM_Try, /*On fail goto*//*Label 15454*/ GIMT_Encode4(1044895), // Rule ID 13660 //
     /* 1044823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1044834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1044837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1044840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1044843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044862 */     // MIs[0] policy
     /* 1044862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044872 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11626:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1044875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044894 */     // GIR_Coverage, 13660,
     /* 1044894 */     GIR_EraseRootFromParent_Done,
     /* 1044895 */   // Label 15454: @1044895
     /* 1044895 */   GIM_Try, /*On fail goto*//*Label 15455*/ GIMT_Encode4(1044972), // Rule ID 13661 //
     /* 1044900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1044911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1044914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1044917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1044920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044939 */     // MIs[0] policy
     /* 1044939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044949 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11626:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1044952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044971 */     // GIR_Coverage, 13661,
     /* 1044971 */     GIR_EraseRootFromParent_Done,
     /* 1044972 */   // Label 15455: @1044972
     /* 1044972 */   GIM_Try, /*On fail goto*//*Label 15456*/ GIMT_Encode4(1045049), // Rule ID 13664 //
     /* 1044977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1044988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1044991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1044994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1044997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045016 */     // MIs[0] policy
     /* 1045016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045026 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11626:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1045029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045048 */     // GIR_Coverage, 13664,
     /* 1045048 */     GIR_EraseRootFromParent_Done,
     /* 1045049 */   // Label 15456: @1045049
     /* 1045049 */   GIM_Try, /*On fail goto*//*Label 15457*/ GIMT_Encode4(1045126), // Rule ID 13665 //
     /* 1045054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1045065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1045068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1045071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1045074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045093 */     // MIs[0] policy
     /* 1045093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045103 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11626:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1045106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045125 */     // GIR_Coverage, 13665,
     /* 1045125 */     GIR_EraseRootFromParent_Done,
     /* 1045126 */   // Label 15457: @1045126
     /* 1045126 */   GIM_Try, /*On fail goto*//*Label 15458*/ GIMT_Encode4(1045203), // Rule ID 13668 //
     /* 1045131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1045142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1045145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1045148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1045151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045170 */     // MIs[0] policy
     /* 1045170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11626:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1045183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045202 */     // GIR_Coverage, 13668,
     /* 1045202 */     GIR_EraseRootFromParent_Done,
     /* 1045203 */   // Label 15458: @1045203
     /* 1045203 */   GIM_Try, /*On fail goto*//*Label 15459*/ GIMT_Encode4(1045280), // Rule ID 13669 //
     /* 1045208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1045219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1045222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1045225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1045228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045247 */     // MIs[0] policy
     /* 1045247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045257 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11626:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1045260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045279 */     // GIR_Coverage, 13669,
     /* 1045279 */     GIR_EraseRootFromParent_Done,
     /* 1045280 */   // Label 15459: @1045280
     /* 1045280 */   GIM_Try, /*On fail goto*//*Label 15460*/ GIMT_Encode4(1045357), // Rule ID 13672 //
     /* 1045285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1045296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1045299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1045302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1045305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045324 */     // MIs[0] policy
     /* 1045324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11626:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1045337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045356 */     // GIR_Coverage, 13672,
     /* 1045356 */     GIR_EraseRootFromParent_Done,
     /* 1045357 */   // Label 15460: @1045357
     /* 1045357 */   GIM_Try, /*On fail goto*//*Label 15461*/ GIMT_Encode4(1045434), // Rule ID 13673 //
     /* 1045362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1045373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1045376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1045379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1045382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045401 */     // MIs[0] policy
     /* 1045401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045411 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11626:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1045414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045433 */     // GIR_Coverage, 13673,
     /* 1045433 */     GIR_EraseRootFromParent_Done,
     /* 1045434 */   // Label 15461: @1045434
     /* 1045434 */   GIM_Try, /*On fail goto*//*Label 15462*/ GIMT_Encode4(1045511), // Rule ID 13676 //
     /* 1045439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1045450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1045453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1045456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1045459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045478 */     // MIs[0] policy
     /* 1045478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045488 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11626:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1045491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045510 */     // GIR_Coverage, 13676,
     /* 1045510 */     GIR_EraseRootFromParent_Done,
     /* 1045511 */   // Label 15462: @1045511
     /* 1045511 */   GIM_Try, /*On fail goto*//*Label 15463*/ GIMT_Encode4(1045588), // Rule ID 13677 //
     /* 1045516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1045527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1045530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1045533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1045536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045555 */     // MIs[0] policy
     /* 1045555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045565 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11626:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1045568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045587 */     // GIR_Coverage, 13677,
     /* 1045587 */     GIR_EraseRootFromParent_Done,
     /* 1045588 */   // Label 15463: @1045588
     /* 1045588 */   GIM_Try, /*On fail goto*//*Label 15464*/ GIMT_Encode4(1045665), // Rule ID 13680 //
     /* 1045593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1045604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1045607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1045610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1045613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045632 */     // MIs[0] policy
     /* 1045632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045642 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11626:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1045645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045664 */     // GIR_Coverage, 13680,
     /* 1045664 */     GIR_EraseRootFromParent_Done,
     /* 1045665 */   // Label 15464: @1045665
     /* 1045665 */   GIM_Try, /*On fail goto*//*Label 15465*/ GIMT_Encode4(1045742), // Rule ID 13681 //
     /* 1045670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1045681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1045684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1045687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1045690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045709 */     // MIs[0] policy
     /* 1045709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045719 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11626:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1045722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045741 */     // GIR_Coverage, 13681,
     /* 1045741 */     GIR_EraseRootFromParent_Done,
     /* 1045742 */   // Label 15465: @1045742
     /* 1045742 */   GIM_Try, /*On fail goto*//*Label 15466*/ GIMT_Encode4(1045819), // Rule ID 13684 //
     /* 1045747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1045758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1045761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1045764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1045767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045786 */     // MIs[0] policy
     /* 1045786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045796 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11626:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1045799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045818 */     // GIR_Coverage, 13684,
     /* 1045818 */     GIR_EraseRootFromParent_Done,
     /* 1045819 */   // Label 15466: @1045819
     /* 1045819 */   GIM_Try, /*On fail goto*//*Label 15467*/ GIMT_Encode4(1045896), // Rule ID 13685 //
     /* 1045824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1045835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1045838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1045841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1045844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045863 */     // MIs[0] policy
     /* 1045863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045873 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11626:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1045876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045895 */     // GIR_Coverage, 13685,
     /* 1045895 */     GIR_EraseRootFromParent_Done,
     /* 1045896 */   // Label 15467: @1045896
     /* 1045896 */   GIM_Try, /*On fail goto*//*Label 15468*/ GIMT_Encode4(1045973), // Rule ID 13688 //
     /* 1045901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1045912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1045915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1045918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1045921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045940 */     // MIs[0] policy
     /* 1045940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045950 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11626:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1045953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045972 */     // GIR_Coverage, 13688,
     /* 1045972 */     GIR_EraseRootFromParent_Done,
     /* 1045973 */   // Label 15468: @1045973
     /* 1045973 */   GIM_Try, /*On fail goto*//*Label 15469*/ GIMT_Encode4(1046050), // Rule ID 13689 //
     /* 1045978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1045989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1045992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1045995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1045998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046017 */     // MIs[0] policy
     /* 1046017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046027 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11626:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1046030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046049 */     // GIR_Coverage, 13689,
     /* 1046049 */     GIR_EraseRootFromParent_Done,
     /* 1046050 */   // Label 15469: @1046050
     /* 1046050 */   GIM_Try, /*On fail goto*//*Label 15470*/ GIMT_Encode4(1046127), // Rule ID 13692 //
     /* 1046055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1046066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1046069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1046072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1046075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046094 */     // MIs[0] policy
     /* 1046094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046104 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11626:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1046107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046126 */     // GIR_Coverage, 13692,
     /* 1046126 */     GIR_EraseRootFromParent_Done,
     /* 1046127 */   // Label 15470: @1046127
     /* 1046127 */   GIM_Try, /*On fail goto*//*Label 15471*/ GIMT_Encode4(1046204), // Rule ID 13693 //
     /* 1046132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1046143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1046146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1046149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1046152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046171 */     // MIs[0] policy
     /* 1046171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046181 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11626:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1046184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046203 */     // GIR_Coverage, 13693,
     /* 1046203 */     GIR_EraseRootFromParent_Done,
     /* 1046204 */   // Label 15471: @1046204
     /* 1046204 */   GIM_Try, /*On fail goto*//*Label 15472*/ GIMT_Encode4(1046281), // Rule ID 13696 //
     /* 1046209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1046220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1046223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1046226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1046229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046248 */     // MIs[0] policy
     /* 1046248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046258 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11626:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1046261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046280 */     // GIR_Coverage, 13696,
     /* 1046280 */     GIR_EraseRootFromParent_Done,
     /* 1046281 */   // Label 15472: @1046281
     /* 1046281 */   GIM_Try, /*On fail goto*//*Label 15473*/ GIMT_Encode4(1046358), // Rule ID 13697 //
     /* 1046286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1046297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1046300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1046303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1046306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046325 */     // MIs[0] policy
     /* 1046325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046335 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11626:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1046338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046357 */     // GIR_Coverage, 13697,
     /* 1046357 */     GIR_EraseRootFromParent_Done,
     /* 1046358 */   // Label 15473: @1046358
     /* 1046358 */   GIM_Try, /*On fail goto*//*Label 15474*/ GIMT_Encode4(1046435), // Rule ID 13700 //
     /* 1046363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1046374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1046377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1046380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1046383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046402 */     // MIs[0] policy
     /* 1046402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046412 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11626:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1046415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046434 */     // GIR_Coverage, 13700,
     /* 1046434 */     GIR_EraseRootFromParent_Done,
     /* 1046435 */   // Label 15474: @1046435
     /* 1046435 */   GIM_Try, /*On fail goto*//*Label 15475*/ GIMT_Encode4(1046512), // Rule ID 13701 //
     /* 1046440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1046451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1046454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1046457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1046460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046479 */     // MIs[0] policy
     /* 1046479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046489 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11626:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1046492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046511 */     // GIR_Coverage, 13701,
     /* 1046511 */     GIR_EraseRootFromParent_Done,
     /* 1046512 */   // Label 15475: @1046512
     /* 1046512 */   GIM_Try, /*On fail goto*//*Label 15476*/ GIMT_Encode4(1046589), // Rule ID 13704 //
     /* 1046517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1046520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1046528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1046531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1046534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1046537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046556 */     // MIs[0] policy
     /* 1046556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11626:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1046569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046588 */     // GIR_Coverage, 13704,
     /* 1046588 */     GIR_EraseRootFromParent_Done,
     /* 1046589 */   // Label 15476: @1046589
     /* 1046589 */   GIM_Try, /*On fail goto*//*Label 15477*/ GIMT_Encode4(1046666), // Rule ID 13705 //
     /* 1046594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1046597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1046605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1046608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1046611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1046614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046633 */     // MIs[0] policy
     /* 1046633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046643 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11626:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1046646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046665 */     // GIR_Coverage, 13705,
     /* 1046665 */     GIR_EraseRootFromParent_Done,
     /* 1046666 */   // Label 15477: @1046666
     /* 1046666 */   GIM_Try, /*On fail goto*//*Label 15478*/ GIMT_Encode4(1046743), // Rule ID 13708 //
     /* 1046671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1046674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1046682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1046685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1046688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1046691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046710 */     // MIs[0] policy
     /* 1046710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046720 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11626:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1046723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046742 */     // GIR_Coverage, 13708,
     /* 1046742 */     GIR_EraseRootFromParent_Done,
     /* 1046743 */   // Label 15478: @1046743
     /* 1046743 */   GIM_Try, /*On fail goto*//*Label 15479*/ GIMT_Encode4(1046820), // Rule ID 13709 //
     /* 1046748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1046751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1046759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1046762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1046765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1046768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046787 */     // MIs[0] policy
     /* 1046787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046797 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11626:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1046800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046819 */     // GIR_Coverage, 13709,
     /* 1046819 */     GIR_EraseRootFromParent_Done,
     /* 1046820 */   // Label 15479: @1046820
     /* 1046820 */   GIM_Try, /*On fail goto*//*Label 15480*/ GIMT_Encode4(1046897), // Rule ID 13712 //
     /* 1046825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1046828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1046836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1046839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1046842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1046845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046864 */     // MIs[0] policy
     /* 1046864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11626:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1046877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046896 */     // GIR_Coverage, 13712,
     /* 1046896 */     GIR_EraseRootFromParent_Done,
     /* 1046897 */   // Label 15480: @1046897
     /* 1046897 */   GIM_Try, /*On fail goto*//*Label 15481*/ GIMT_Encode4(1046974), // Rule ID 13713 //
     /* 1046902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1046905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1046913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1046916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1046919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1046922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046941 */     // MIs[0] policy
     /* 1046941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046951 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11626:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1046954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046973 */     // GIR_Coverage, 13713,
     /* 1046973 */     GIR_EraseRootFromParent_Done,
     /* 1046974 */   // Label 15481: @1046974
     /* 1046974 */   GIM_Try, /*On fail goto*//*Label 15482*/ GIMT_Encode4(1047051), // Rule ID 13716 //
     /* 1046979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1046982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1046990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1046993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1046996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1046999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047018 */     // MIs[0] policy
     /* 1047018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047028 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11626:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1047031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047050 */     // GIR_Coverage, 13716,
     /* 1047050 */     GIR_EraseRootFromParent_Done,
     /* 1047051 */   // Label 15482: @1047051
     /* 1047051 */   GIM_Try, /*On fail goto*//*Label 15483*/ GIMT_Encode4(1047128), // Rule ID 13717 //
     /* 1047056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1047067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1047070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1047073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1047076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047095 */     // MIs[0] policy
     /* 1047095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047105 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11626:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1047108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047127 */     // GIR_Coverage, 13717,
     /* 1047127 */     GIR_EraseRootFromParent_Done,
     /* 1047128 */   // Label 15483: @1047128
     /* 1047128 */   GIM_Try, /*On fail goto*//*Label 15484*/ GIMT_Encode4(1047205), // Rule ID 13720 //
     /* 1047133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1047144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1047147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1047153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047172 */     // MIs[0] policy
     /* 1047172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047182 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11626:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1047185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047204 */     // GIR_Coverage, 13720,
     /* 1047204 */     GIR_EraseRootFromParent_Done,
     /* 1047205 */   // Label 15484: @1047205
     /* 1047205 */   GIM_Try, /*On fail goto*//*Label 15485*/ GIMT_Encode4(1047282), // Rule ID 13721 //
     /* 1047210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1047221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1047224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1047230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047249 */     // MIs[0] policy
     /* 1047249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047259 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11626:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1047262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047281 */     // GIR_Coverage, 13721,
     /* 1047281 */     GIR_EraseRootFromParent_Done,
     /* 1047282 */   // Label 15485: @1047282
     /* 1047282 */   GIM_Try, /*On fail goto*//*Label 15486*/ GIMT_Encode4(1047359), // Rule ID 13724 //
     /* 1047287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1047298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1047301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1047307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047326 */     // MIs[0] policy
     /* 1047326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047336 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11626:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1047339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047358 */     // GIR_Coverage, 13724,
     /* 1047358 */     GIR_EraseRootFromParent_Done,
     /* 1047359 */   // Label 15486: @1047359
     /* 1047359 */   GIM_Try, /*On fail goto*//*Label 15487*/ GIMT_Encode4(1047436), // Rule ID 13725 //
     /* 1047364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1047375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1047378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1047384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047403 */     // MIs[0] policy
     /* 1047403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047413 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11626:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1047416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047435 */     // GIR_Coverage, 13725,
     /* 1047435 */     GIR_EraseRootFromParent_Done,
     /* 1047436 */   // Label 15487: @1047436
     /* 1047436 */   GIM_Try, /*On fail goto*//*Label 15488*/ GIMT_Encode4(1047513), // Rule ID 13728 //
     /* 1047441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1047452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1047455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1047461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047480 */     // MIs[0] policy
     /* 1047480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11626:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1047493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047512 */     // GIR_Coverage, 13728,
     /* 1047512 */     GIR_EraseRootFromParent_Done,
     /* 1047513 */   // Label 15488: @1047513
     /* 1047513 */   GIM_Try, /*On fail goto*//*Label 15489*/ GIMT_Encode4(1047590), // Rule ID 13729 //
     /* 1047518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1047529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1047532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1047538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047557 */     // MIs[0] policy
     /* 1047557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047567 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11626:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1047570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047589 */     // GIR_Coverage, 13729,
     /* 1047589 */     GIR_EraseRootFromParent_Done,
     /* 1047590 */   // Label 15489: @1047590
     /* 1047590 */   GIM_Try, /*On fail goto*//*Label 15490*/ GIMT_Encode4(1047667), // Rule ID 13732 //
     /* 1047595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1047606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1047609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1047615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047634 */     // MIs[0] policy
     /* 1047634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11626:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1047647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047666 */     // GIR_Coverage, 13732,
     /* 1047666 */     GIR_EraseRootFromParent_Done,
     /* 1047667 */   // Label 15490: @1047667
     /* 1047667 */   GIM_Try, /*On fail goto*//*Label 15491*/ GIMT_Encode4(1047744), // Rule ID 13733 //
     /* 1047672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1047683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1047686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1047692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047711 */     // MIs[0] policy
     /* 1047711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047721 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11626:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1047724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047743 */     // GIR_Coverage, 13733,
     /* 1047743 */     GIR_EraseRootFromParent_Done,
     /* 1047744 */   // Label 15491: @1047744
     /* 1047744 */   GIM_Try, /*On fail goto*//*Label 15492*/ GIMT_Encode4(1047821), // Rule ID 13736 //
     /* 1047749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1047760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1047763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1047769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047788 */     // MIs[0] policy
     /* 1047788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047798 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11626:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1047801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047820 */     // GIR_Coverage, 13736,
     /* 1047820 */     GIR_EraseRootFromParent_Done,
     /* 1047821 */   // Label 15492: @1047821
     /* 1047821 */   GIM_Try, /*On fail goto*//*Label 15493*/ GIMT_Encode4(1047898), // Rule ID 13737 //
     /* 1047826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1047837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1047840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1047846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047865 */     // MIs[0] policy
     /* 1047865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047875 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11626:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1047878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047897 */     // GIR_Coverage, 13737,
     /* 1047897 */     GIR_EraseRootFromParent_Done,
     /* 1047898 */   // Label 15493: @1047898
     /* 1047898 */   GIM_Try, /*On fail goto*//*Label 15494*/ GIMT_Encode4(1047975), // Rule ID 13740 //
     /* 1047903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1047914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1047917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1047923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047942 */     // MIs[0] policy
     /* 1047942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047952 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11626:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1047955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047974 */     // GIR_Coverage, 13740,
     /* 1047974 */     GIR_EraseRootFromParent_Done,
     /* 1047975 */   // Label 15494: @1047975
     /* 1047975 */   GIM_Try, /*On fail goto*//*Label 15495*/ GIMT_Encode4(1048052), // Rule ID 13741 //
     /* 1047980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1047991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1047994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1048000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048019 */     // MIs[0] policy
     /* 1048019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048029 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11626:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1048032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1048048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048051 */     // GIR_Coverage, 13741,
     /* 1048051 */     GIR_EraseRootFromParent_Done,
     /* 1048052 */   // Label 15495: @1048052
     /* 1048052 */   GIM_Try, /*On fail goto*//*Label 15496*/ GIMT_Encode4(1048129), // Rule ID 13744 //
     /* 1048057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1048077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048096 */     // MIs[0] policy
     /* 1048096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048106 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11626:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1048109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048128 */     // GIR_Coverage, 13744,
     /* 1048128 */     GIR_EraseRootFromParent_Done,
     /* 1048129 */   // Label 15496: @1048129
     /* 1048129 */   GIM_Try, /*On fail goto*//*Label 15497*/ GIMT_Encode4(1048206), // Rule ID 13745 //
     /* 1048134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1048154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048173 */     // MIs[0] policy
     /* 1048173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048183 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11626:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1048186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048205 */     // GIR_Coverage, 13745,
     /* 1048205 */     GIR_EraseRootFromParent_Done,
     /* 1048206 */   // Label 15497: @1048206
     /* 1048206 */   GIM_Try, /*On fail goto*//*Label 15498*/ GIMT_Encode4(1048283), // Rule ID 13748 //
     /* 1048211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1048222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1048225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1048231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048250 */     // MIs[0] policy
     /* 1048250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048260 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11626:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1048263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048282 */     // GIR_Coverage, 13748,
     /* 1048282 */     GIR_EraseRootFromParent_Done,
     /* 1048283 */   // Label 15498: @1048283
     /* 1048283 */   GIM_Try, /*On fail goto*//*Label 15499*/ GIMT_Encode4(1048360), // Rule ID 13749 //
     /* 1048288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1048299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1048302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1048308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048327 */     // MIs[0] policy
     /* 1048327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048337 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11626:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1048340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048359 */     // GIR_Coverage, 13749,
     /* 1048359 */     GIR_EraseRootFromParent_Done,
     /* 1048360 */   // Label 15499: @1048360
     /* 1048360 */   GIM_Try, /*On fail goto*//*Label 15500*/ GIMT_Encode4(1048437), // Rule ID 13752 //
     /* 1048365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1048376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1048379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1048385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048404 */     // MIs[0] policy
     /* 1048404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11626:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1048417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048436 */     // GIR_Coverage, 13752,
     /* 1048436 */     GIR_EraseRootFromParent_Done,
     /* 1048437 */   // Label 15500: @1048437
     /* 1048437 */   GIM_Try, /*On fail goto*//*Label 15501*/ GIMT_Encode4(1048514), // Rule ID 13753 //
     /* 1048442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1048453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1048456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1048462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048481 */     // MIs[0] policy
     /* 1048481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048491 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11626:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1048494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048513 */     // GIR_Coverage, 13753,
     /* 1048513 */     GIR_EraseRootFromParent_Done,
     /* 1048514 */   // Label 15501: @1048514
     /* 1048514 */   GIM_Try, /*On fail goto*//*Label 15502*/ GIMT_Encode4(1048591), // Rule ID 13756 //
     /* 1048519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1048530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1048533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1048539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048558 */     // MIs[0] policy
     /* 1048558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11626:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1048571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048590 */     // GIR_Coverage, 13756,
     /* 1048590 */     GIR_EraseRootFromParent_Done,
     /* 1048591 */   // Label 15502: @1048591
     /* 1048591 */   GIM_Try, /*On fail goto*//*Label 15503*/ GIMT_Encode4(1048668), // Rule ID 13757 //
     /* 1048596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1048607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1048610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1048616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048635 */     // MIs[0] policy
     /* 1048635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048645 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11626:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1048648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048667 */     // GIR_Coverage, 13757,
     /* 1048667 */     GIR_EraseRootFromParent_Done,
     /* 1048668 */   // Label 15503: @1048668
     /* 1048668 */   GIM_Try, /*On fail goto*//*Label 15504*/ GIMT_Encode4(1048745), // Rule ID 13760 //
     /* 1048673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1048684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1048687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1048693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048712 */     // MIs[0] policy
     /* 1048712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11626:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1048725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048744 */     // GIR_Coverage, 13760,
     /* 1048744 */     GIR_EraseRootFromParent_Done,
     /* 1048745 */   // Label 15504: @1048745
     /* 1048745 */   GIM_Try, /*On fail goto*//*Label 15505*/ GIMT_Encode4(1048822), // Rule ID 13761 //
     /* 1048750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1048761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1048764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1048770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048789 */     // MIs[0] policy
     /* 1048789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048799 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11626:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1048802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048821 */     // GIR_Coverage, 13761,
     /* 1048821 */     GIR_EraseRootFromParent_Done,
     /* 1048822 */   // Label 15505: @1048822
     /* 1048822 */   GIM_Try, /*On fail goto*//*Label 15506*/ GIMT_Encode4(1048899), // Rule ID 13764 //
     /* 1048827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1048830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1048838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1048841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1048847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048866 */     // MIs[0] policy
     /* 1048866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11626:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1048879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048898 */     // GIR_Coverage, 13764,
     /* 1048898 */     GIR_EraseRootFromParent_Done,
     /* 1048899 */   // Label 15506: @1048899
     /* 1048899 */   GIM_Try, /*On fail goto*//*Label 15507*/ GIMT_Encode4(1048976), // Rule ID 13765 //
     /* 1048904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1048907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1048915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1048918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1048924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048943 */     // MIs[0] policy
     /* 1048943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048953 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11626:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1048956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048975 */     // GIR_Coverage, 13765,
     /* 1048975 */     GIR_EraseRootFromParent_Done,
     /* 1048976 */   // Label 15507: @1048976
     /* 1048976 */   GIM_Try, /*On fail goto*//*Label 15508*/ GIMT_Encode4(1049053), // Rule ID 13768 //
     /* 1048981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1048984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1048992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1048995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1049001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049020 */     // MIs[0] policy
     /* 1049020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049030 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11626:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1049033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049052 */     // GIR_Coverage, 13768,
     /* 1049052 */     GIR_EraseRootFromParent_Done,
     /* 1049053 */   // Label 15508: @1049053
     /* 1049053 */   GIM_Try, /*On fail goto*//*Label 15509*/ GIMT_Encode4(1049130), // Rule ID 13769 //
     /* 1049058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1049061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1049066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1049069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1049072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1049078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049097 */     // MIs[0] policy
     /* 1049097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049107 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11626:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1049110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049129 */     // GIR_Coverage, 13769,
     /* 1049129 */     GIR_EraseRootFromParent_Done,
     /* 1049130 */   // Label 15509: @1049130
     /* 1049130 */   GIM_Try, /*On fail goto*//*Label 15510*/ GIMT_Encode4(1049207), // Rule ID 13772 //
     /* 1049135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1049138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1049143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1049146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1049149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1049152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1049155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049174 */     // MIs[0] policy
     /* 1049174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049184 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11626:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1049187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049206 */     // GIR_Coverage, 13772,
     /* 1049206 */     GIR_EraseRootFromParent_Done,
     /* 1049207 */   // Label 15510: @1049207
     /* 1049207 */   GIM_Try, /*On fail goto*//*Label 15511*/ GIMT_Encode4(1049284), // Rule ID 13773 //
     /* 1049212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1049215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1049220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1049223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1049226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1049232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049251 */     // MIs[0] policy
     /* 1049251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049261 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11626:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1049264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049283 */     // GIR_Coverage, 13773,
     /* 1049283 */     GIR_EraseRootFromParent_Done,
     /* 1049284 */   // Label 15511: @1049284
     /* 1049284 */   GIM_Try, /*On fail goto*//*Label 15512*/ GIMT_Encode4(1049361), // Rule ID 13776 //
     /* 1049289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1049292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1049297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1049300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1049303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1049306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1049309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049328 */     // MIs[0] policy
     /* 1049328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049338 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11626:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1049341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049360 */     // GIR_Coverage, 13776,
     /* 1049360 */     GIR_EraseRootFromParent_Done,
     /* 1049361 */   // Label 15512: @1049361
     /* 1049361 */   GIM_Try, /*On fail goto*//*Label 15513*/ GIMT_Encode4(1049438), // Rule ID 13777 //
     /* 1049366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1049369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1049374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1049377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1049380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1049386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049405 */     // MIs[0] policy
     /* 1049405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049415 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11626:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1049418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049437 */     // GIR_Coverage, 13777,
     /* 1049437 */     GIR_EraseRootFromParent_Done,
     /* 1049438 */   // Label 15513: @1049438
     /* 1049438 */   GIM_Try, /*On fail goto*//*Label 15514*/ GIMT_Encode4(1049515), // Rule ID 13780 //
     /* 1049443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1049446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1049454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1049457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1049460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1049463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049482 */     // MIs[0] policy
     /* 1049482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049492 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11630:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1049495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049514 */     // GIR_Coverage, 13780,
     /* 1049514 */     GIR_EraseRootFromParent_Done,
     /* 1049515 */   // Label 15514: @1049515
     /* 1049515 */   GIM_Try, /*On fail goto*//*Label 15515*/ GIMT_Encode4(1049592), // Rule ID 13781 //
     /* 1049520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1049531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1049534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1049540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049559 */     // MIs[0] policy
     /* 1049559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049569 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11630:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1049572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049591 */     // GIR_Coverage, 13781,
     /* 1049591 */     GIR_EraseRootFromParent_Done,
     /* 1049592 */   // Label 15515: @1049592
     /* 1049592 */   GIM_Try, /*On fail goto*//*Label 15516*/ GIMT_Encode4(1049669), // Rule ID 13784 //
     /* 1049597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1049600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1049608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1049611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1049614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1049617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049636 */     // MIs[0] policy
     /* 1049636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049646 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11630:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1049649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049668 */     // GIR_Coverage, 13784,
     /* 1049668 */     GIR_EraseRootFromParent_Done,
     /* 1049669 */   // Label 15516: @1049669
     /* 1049669 */   GIM_Try, /*On fail goto*//*Label 15517*/ GIMT_Encode4(1049746), // Rule ID 13785 //
     /* 1049674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1049685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1049688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1049694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049713 */     // MIs[0] policy
     /* 1049713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049723 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11630:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1049726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049745 */     // GIR_Coverage, 13785,
     /* 1049745 */     GIR_EraseRootFromParent_Done,
     /* 1049746 */   // Label 15517: @1049746
     /* 1049746 */   GIM_Try, /*On fail goto*//*Label 15518*/ GIMT_Encode4(1049823), // Rule ID 13788 //
     /* 1049751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1049754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1049762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1049765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1049768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1049771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049790 */     // MIs[0] policy
     /* 1049790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11630:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1049803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049822 */     // GIR_Coverage, 13788,
     /* 1049822 */     GIR_EraseRootFromParent_Done,
     /* 1049823 */   // Label 15518: @1049823
     /* 1049823 */   GIM_Try, /*On fail goto*//*Label 15519*/ GIMT_Encode4(1049900), // Rule ID 13789 //
     /* 1049828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1049839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1049842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1049848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049867 */     // MIs[0] policy
     /* 1049867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049877 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11630:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1049880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049899 */     // GIR_Coverage, 13789,
     /* 1049899 */     GIR_EraseRootFromParent_Done,
     /* 1049900 */   // Label 15519: @1049900
     /* 1049900 */   GIM_Try, /*On fail goto*//*Label 15520*/ GIMT_Encode4(1049977), // Rule ID 13792 //
     /* 1049905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1049908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1049916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1049919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1049922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1049925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049944 */     // MIs[0] policy
     /* 1049944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049954 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11630:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1049957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049976 */     // GIR_Coverage, 13792,
     /* 1049976 */     GIR_EraseRootFromParent_Done,
     /* 1049977 */   // Label 15520: @1049977
     /* 1049977 */   GIM_Try, /*On fail goto*//*Label 15521*/ GIMT_Encode4(1050054), // Rule ID 13793 //
     /* 1049982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1049993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1049996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1050002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050021 */     // MIs[0] policy
     /* 1050021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050031 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11630:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1050034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1050050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050053 */     // GIR_Coverage, 13793,
     /* 1050053 */     GIR_EraseRootFromParent_Done,
     /* 1050054 */   // Label 15521: @1050054
     /* 1050054 */   GIM_Try, /*On fail goto*//*Label 15522*/ GIMT_Encode4(1050131), // Rule ID 13796 //
     /* 1050059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1050070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1050073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1050076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1050079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050098 */     // MIs[0] policy
     /* 1050098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050108 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11630:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1050111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1050127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050130 */     // GIR_Coverage, 13796,
     /* 1050130 */     GIR_EraseRootFromParent_Done,
     /* 1050131 */   // Label 15522: @1050131
     /* 1050131 */   GIM_Try, /*On fail goto*//*Label 15523*/ GIMT_Encode4(1050208), // Rule ID 13797 //
     /* 1050136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1050147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1050150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1050153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1050156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050175 */     // MIs[0] policy
     /* 1050175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050185 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11630:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1050188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1050204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050207 */     // GIR_Coverage, 13797,
     /* 1050207 */     GIR_EraseRootFromParent_Done,
     /* 1050208 */   // Label 15523: @1050208
     /* 1050208 */   GIM_Try, /*On fail goto*//*Label 15524*/ GIMT_Encode4(1050285), // Rule ID 13800 //
     /* 1050213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1050224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1050227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1050230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1050233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050252 */     // MIs[0] policy
     /* 1050252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050262 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11630:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1050265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1050281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050284 */     // GIR_Coverage, 13800,
     /* 1050284 */     GIR_EraseRootFromParent_Done,
     /* 1050285 */   // Label 15524: @1050285
     /* 1050285 */   GIM_Try, /*On fail goto*//*Label 15525*/ GIMT_Encode4(1050362), // Rule ID 13801 //
     /* 1050290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1050301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1050304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1050307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1050310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050329 */     // MIs[0] policy
     /* 1050329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050339 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11630:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1050342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1050358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050361 */     // GIR_Coverage, 13801,
     /* 1050361 */     GIR_EraseRootFromParent_Done,
     /* 1050362 */   // Label 15525: @1050362
     /* 1050362 */   GIM_Try, /*On fail goto*//*Label 15526*/ GIMT_Encode4(1050439), // Rule ID 13804 //
     /* 1050367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1050378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1050381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1050384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1050387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050406 */     // MIs[0] policy
     /* 1050406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11630:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1050419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050438 */     // GIR_Coverage, 13804,
     /* 1050438 */     GIR_EraseRootFromParent_Done,
     /* 1050439 */   // Label 15526: @1050439
     /* 1050439 */   GIM_Try, /*On fail goto*//*Label 15527*/ GIMT_Encode4(1050516), // Rule ID 13805 //
     /* 1050444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1050455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1050458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1050461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1050464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050483 */     // MIs[0] policy
     /* 1050483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050493 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11630:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1050496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050515 */     // GIR_Coverage, 13805,
     /* 1050515 */     GIR_EraseRootFromParent_Done,
     /* 1050516 */   // Label 15527: @1050516
     /* 1050516 */   GIM_Try, /*On fail goto*//*Label 15528*/ GIMT_Encode4(1050593), // Rule ID 13808 //
     /* 1050521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1050532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1050535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1050538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1050541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050560 */     // MIs[0] policy
     /* 1050560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11630:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1050573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050592 */     // GIR_Coverage, 13808,
     /* 1050592 */     GIR_EraseRootFromParent_Done,
     /* 1050593 */   // Label 15528: @1050593
     /* 1050593 */   GIM_Try, /*On fail goto*//*Label 15529*/ GIMT_Encode4(1050670), // Rule ID 13809 //
     /* 1050598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1050609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1050612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1050615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1050618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050637 */     // MIs[0] policy
     /* 1050637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050647 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11630:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1050650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050669 */     // GIR_Coverage, 13809,
     /* 1050669 */     GIR_EraseRootFromParent_Done,
     /* 1050670 */   // Label 15529: @1050670
     /* 1050670 */   GIM_Try, /*On fail goto*//*Label 15530*/ GIMT_Encode4(1050747), // Rule ID 13812 //
     /* 1050675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1050686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1050689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1050692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1050695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050714 */     // MIs[0] policy
     /* 1050714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11630:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1050727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050746 */     // GIR_Coverage, 13812,
     /* 1050746 */     GIR_EraseRootFromParent_Done,
     /* 1050747 */   // Label 15530: @1050747
     /* 1050747 */   GIM_Try, /*On fail goto*//*Label 15531*/ GIMT_Encode4(1050824), // Rule ID 13813 //
     /* 1050752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1050763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1050766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1050769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1050772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050791 */     // MIs[0] policy
     /* 1050791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11630:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1050804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050823 */     // GIR_Coverage, 13813,
     /* 1050823 */     GIR_EraseRootFromParent_Done,
     /* 1050824 */   // Label 15531: @1050824
     /* 1050824 */   GIM_Try, /*On fail goto*//*Label 15532*/ GIMT_Encode4(1050901), // Rule ID 13816 //
     /* 1050829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1050840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1050843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1050846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1050849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050868 */     // MIs[0] policy
     /* 1050868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11630:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1050881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050900 */     // GIR_Coverage, 13816,
     /* 1050900 */     GIR_EraseRootFromParent_Done,
     /* 1050901 */   // Label 15532: @1050901
     /* 1050901 */   GIM_Try, /*On fail goto*//*Label 15533*/ GIMT_Encode4(1050978), // Rule ID 13817 //
     /* 1050906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1050917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1050920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1050923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1050926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050945 */     // MIs[0] policy
     /* 1050945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050955 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11630:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1050958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050977 */     // GIR_Coverage, 13817,
     /* 1050977 */     GIR_EraseRootFromParent_Done,
     /* 1050978 */   // Label 15533: @1050978
     /* 1050978 */   GIM_Try, /*On fail goto*//*Label 15534*/ GIMT_Encode4(1051055), // Rule ID 13820 //
     /* 1050983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1050994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1050997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1051000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1051003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051022 */     // MIs[0] policy
     /* 1051022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051032 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11630:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1051035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051054 */     // GIR_Coverage, 13820,
     /* 1051054 */     GIR_EraseRootFromParent_Done,
     /* 1051055 */   // Label 15534: @1051055
     /* 1051055 */   GIM_Try, /*On fail goto*//*Label 15535*/ GIMT_Encode4(1051132), // Rule ID 13821 //
     /* 1051060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1051063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1051071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1051074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1051077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1051080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051099 */     // MIs[0] policy
     /* 1051099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051109 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11630:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1051112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051131 */     // GIR_Coverage, 13821,
     /* 1051131 */     GIR_EraseRootFromParent_Done,
     /* 1051132 */   // Label 15535: @1051132
     /* 1051132 */   GIM_Try, /*On fail goto*//*Label 15536*/ GIMT_Encode4(1051209), // Rule ID 13824 //
     /* 1051137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1051140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1051148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1051151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1051154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1051157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051176 */     // MIs[0] policy
     /* 1051176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11630:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1051189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051208 */     // GIR_Coverage, 13824,
     /* 1051208 */     GIR_EraseRootFromParent_Done,
     /* 1051209 */   // Label 15536: @1051209
     /* 1051209 */   GIM_Try, /*On fail goto*//*Label 15537*/ GIMT_Encode4(1051286), // Rule ID 13825 //
     /* 1051214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1051217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1051225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1051228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1051231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1051234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051253 */     // MIs[0] policy
     /* 1051253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051263 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11630:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1051266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051285 */     // GIR_Coverage, 13825,
     /* 1051285 */     GIR_EraseRootFromParent_Done,
     /* 1051286 */   // Label 15537: @1051286
     /* 1051286 */   GIM_Try, /*On fail goto*//*Label 15538*/ GIMT_Encode4(1051363), // Rule ID 13828 //
     /* 1051291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1051294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1051302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1051305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1051308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1051311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051330 */     // MIs[0] policy
     /* 1051330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11630:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1051343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051362 */     // GIR_Coverage, 13828,
     /* 1051362 */     GIR_EraseRootFromParent_Done,
     /* 1051363 */   // Label 15538: @1051363
     /* 1051363 */   GIM_Try, /*On fail goto*//*Label 15539*/ GIMT_Encode4(1051440), // Rule ID 13829 //
     /* 1051368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1051371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1051379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1051382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1051385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1051388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051407 */     // MIs[0] policy
     /* 1051407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051417 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11630:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1051420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051439 */     // GIR_Coverage, 13829,
     /* 1051439 */     GIR_EraseRootFromParent_Done,
     /* 1051440 */   // Label 15539: @1051440
     /* 1051440 */   GIM_Try, /*On fail goto*//*Label 15540*/ GIMT_Encode4(1051517), // Rule ID 13832 //
     /* 1051445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1051448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1051456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1051459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1051462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1051465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051484 */     // MIs[0] policy
     /* 1051484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051494 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11630:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1051497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051516 */     // GIR_Coverage, 13832,
     /* 1051516 */     GIR_EraseRootFromParent_Done,
     /* 1051517 */   // Label 15540: @1051517
     /* 1051517 */   GIM_Try, /*On fail goto*//*Label 15541*/ GIMT_Encode4(1051594), // Rule ID 13833 //
     /* 1051522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1051525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1051533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1051536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1051539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1051542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051561 */     // MIs[0] policy
     /* 1051561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051571 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11630:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1051574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051593 */     // GIR_Coverage, 13833,
     /* 1051593 */     GIR_EraseRootFromParent_Done,
     /* 1051594 */   // Label 15541: @1051594
     /* 1051594 */   GIM_Try, /*On fail goto*//*Label 15542*/ GIMT_Encode4(1051671), // Rule ID 13836 //
     /* 1051599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1051602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1051610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1051613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1051616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1051619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051638 */     // MIs[0] policy
     /* 1051638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051648 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11630:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1051651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051670 */     // GIR_Coverage, 13836,
     /* 1051670 */     GIR_EraseRootFromParent_Done,
     /* 1051671 */   // Label 15542: @1051671
     /* 1051671 */   GIM_Try, /*On fail goto*//*Label 15543*/ GIMT_Encode4(1051748), // Rule ID 13837 //
     /* 1051676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1051679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1051687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1051690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1051693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1051696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051715 */     // MIs[0] policy
     /* 1051715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051725 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11630:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1051728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051747 */     // GIR_Coverage, 13837,
     /* 1051747 */     GIR_EraseRootFromParent_Done,
     /* 1051748 */   // Label 15543: @1051748
     /* 1051748 */   GIM_Try, /*On fail goto*//*Label 15544*/ GIMT_Encode4(1051825), // Rule ID 19050 //
     /* 1051753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1051756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1051761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1051764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1051767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1051770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051792 */     // MIs[0] policy
     /* 1051792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051802 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1051805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051824 */     // GIR_Coverage, 19050,
     /* 1051824 */     GIR_EraseRootFromParent_Done,
     /* 1051825 */   // Label 15544: @1051825
     /* 1051825 */   GIM_Try, /*On fail goto*//*Label 15545*/ GIMT_Encode4(1051902), // Rule ID 19051 //
     /* 1051830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1051833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1051838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1051841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1051844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1051847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051869 */     // MIs[0] policy
     /* 1051869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051879 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1051882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051888 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051901 */     // GIR_Coverage, 19051,
     /* 1051901 */     GIR_EraseRootFromParent_Done,
     /* 1051902 */   // Label 15545: @1051902
     /* 1051902 */   GIM_Try, /*On fail goto*//*Label 15546*/ GIMT_Encode4(1051979), // Rule ID 19054 //
     /* 1051907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1051910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1051915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1051918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1051921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1051924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1051927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051946 */     // MIs[0] policy
     /* 1051946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051956 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1051959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051978 */     // GIR_Coverage, 19054,
     /* 1051978 */     GIR_EraseRootFromParent_Done,
     /* 1051979 */   // Label 15546: @1051979
     /* 1051979 */   GIM_Try, /*On fail goto*//*Label 15547*/ GIMT_Encode4(1052056), // Rule ID 19055 //
     /* 1051984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1051987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1051992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1051995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1051998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1052001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052023 */     // MIs[0] policy
     /* 1052023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052033 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1052036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052042 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052055 */     // GIR_Coverage, 19055,
     /* 1052055 */     GIR_EraseRootFromParent_Done,
     /* 1052056 */   // Label 15547: @1052056
     /* 1052056 */   GIM_Try, /*On fail goto*//*Label 15548*/ GIMT_Encode4(1052133), // Rule ID 19058 //
     /* 1052061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1052064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1052072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1052075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1052078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052100 */     // MIs[0] policy
     /* 1052100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052110 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1052113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052132 */     // GIR_Coverage, 19058,
     /* 1052132 */     GIR_EraseRootFromParent_Done,
     /* 1052133 */   // Label 15548: @1052133
     /* 1052133 */   GIM_Try, /*On fail goto*//*Label 15549*/ GIMT_Encode4(1052210), // Rule ID 19059 //
     /* 1052138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1052141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1052149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1052152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1052155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052177 */     // MIs[0] policy
     /* 1052177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052187 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1052190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052196 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052209 */     // GIR_Coverage, 19059,
     /* 1052209 */     GIR_EraseRootFromParent_Done,
     /* 1052210 */   // Label 15549: @1052210
     /* 1052210 */   GIM_Try, /*On fail goto*//*Label 15550*/ GIMT_Encode4(1052287), // Rule ID 19062 //
     /* 1052215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1052218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1052226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1052229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1052232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052254 */     // MIs[0] policy
     /* 1052254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052264 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1052267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052286 */     // GIR_Coverage, 19062,
     /* 1052286 */     GIR_EraseRootFromParent_Done,
     /* 1052287 */   // Label 15550: @1052287
     /* 1052287 */   GIM_Try, /*On fail goto*//*Label 15551*/ GIMT_Encode4(1052364), // Rule ID 19063 //
     /* 1052292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1052295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1052303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1052306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1052309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052331 */     // MIs[0] policy
     /* 1052331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052341 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1052344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052350 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052363 */     // GIR_Coverage, 19063,
     /* 1052363 */     GIR_EraseRootFromParent_Done,
     /* 1052364 */   // Label 15551: @1052364
     /* 1052364 */   GIM_Try, /*On fail goto*//*Label 15552*/ GIMT_Encode4(1052441), // Rule ID 19066 //
     /* 1052369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1052372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1052380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1052383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1052386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052408 */     // MIs[0] policy
     /* 1052408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052418 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1052421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052427 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052440 */     // GIR_Coverage, 19066,
     /* 1052440 */     GIR_EraseRootFromParent_Done,
     /* 1052441 */   // Label 15552: @1052441
     /* 1052441 */   GIM_Try, /*On fail goto*//*Label 15553*/ GIMT_Encode4(1052518), // Rule ID 19067 //
     /* 1052446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1052449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1052457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1052460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1052463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052485 */     // MIs[0] policy
     /* 1052485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052495 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1052498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052504 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052517 */     // GIR_Coverage, 19067,
     /* 1052517 */     GIR_EraseRootFromParent_Done,
     /* 1052518 */   // Label 15553: @1052518
     /* 1052518 */   GIM_Try, /*On fail goto*//*Label 15554*/ GIMT_Encode4(1052595), // Rule ID 19070 //
     /* 1052523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1052526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1052534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1052537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1052540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1052550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052562 */     // MIs[0] policy
     /* 1052562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052572 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1052575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052581 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052594 */     // GIR_Coverage, 19070,
     /* 1052594 */     GIR_EraseRootFromParent_Done,
     /* 1052595 */   // Label 15554: @1052595
     /* 1052595 */   GIM_Try, /*On fail goto*//*Label 15555*/ GIMT_Encode4(1052672), // Rule ID 19071 //
     /* 1052600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1052603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1052611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1052614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1052617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1052627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052639 */     // MIs[0] policy
     /* 1052639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052649 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1052652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052658 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052671 */     // GIR_Coverage, 19071,
     /* 1052671 */     GIR_EraseRootFromParent_Done,
     /* 1052672 */   // Label 15555: @1052672
     /* 1052672 */   GIM_Try, /*On fail goto*//*Label 15556*/ GIMT_Encode4(1052749), // Rule ID 19074 //
     /* 1052677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1052680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1052688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1052691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1052694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1052697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052716 */     // MIs[0] policy
     /* 1052716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052726 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1052729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052748 */     // GIR_Coverage, 19074,
     /* 1052748 */     GIR_EraseRootFromParent_Done,
     /* 1052749 */   // Label 15556: @1052749
     /* 1052749 */   GIM_Try, /*On fail goto*//*Label 15557*/ GIMT_Encode4(1052826), // Rule ID 19075 //
     /* 1052754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1052757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1052765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1052768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1052771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1052774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052793 */     // MIs[0] policy
     /* 1052793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052803 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1052806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052812 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052825 */     // GIR_Coverage, 19075,
     /* 1052825 */     GIR_EraseRootFromParent_Done,
     /* 1052826 */   // Label 15557: @1052826
     /* 1052826 */   GIM_Try, /*On fail goto*//*Label 15558*/ GIMT_Encode4(1052903), // Rule ID 19078 //
     /* 1052831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1052834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1052842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1052845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1052848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1052851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052870 */     // MIs[0] policy
     /* 1052870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052880 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1052883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052902 */     // GIR_Coverage, 19078,
     /* 1052902 */     GIR_EraseRootFromParent_Done,
     /* 1052903 */   // Label 15558: @1052903
     /* 1052903 */   GIM_Try, /*On fail goto*//*Label 15559*/ GIMT_Encode4(1052980), // Rule ID 19079 //
     /* 1052908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1052911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1052919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1052922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1052925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1052928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052947 */     // MIs[0] policy
     /* 1052947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052957 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1052960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052966 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052979 */     // GIR_Coverage, 19079,
     /* 1052979 */     GIR_EraseRootFromParent_Done,
     /* 1052980 */   // Label 15559: @1052980
     /* 1052980 */   GIM_Try, /*On fail goto*//*Label 15560*/ GIMT_Encode4(1053057), // Rule ID 19082 //
     /* 1052985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1052988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1052996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1052999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1053002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053024 */     // MIs[0] policy
     /* 1053024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053034 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1053037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053056 */     // GIR_Coverage, 19082,
     /* 1053056 */     GIR_EraseRootFromParent_Done,
     /* 1053057 */   // Label 15560: @1053057
     /* 1053057 */   GIM_Try, /*On fail goto*//*Label 15561*/ GIMT_Encode4(1053134), // Rule ID 19083 //
     /* 1053062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1053065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1053073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1053076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1053079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053101 */     // MIs[0] policy
     /* 1053101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053111 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1053114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053120 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053133 */     // GIR_Coverage, 19083,
     /* 1053133 */     GIR_EraseRootFromParent_Done,
     /* 1053134 */   // Label 15561: @1053134
     /* 1053134 */   GIM_Try, /*On fail goto*//*Label 15562*/ GIMT_Encode4(1053211), // Rule ID 19086 //
     /* 1053139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1053142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1053150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1053153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1053156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053178 */     // MIs[0] policy
     /* 1053178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053188 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1053191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053210 */     // GIR_Coverage, 19086,
     /* 1053210 */     GIR_EraseRootFromParent_Done,
     /* 1053211 */   // Label 15562: @1053211
     /* 1053211 */   GIM_Try, /*On fail goto*//*Label 15563*/ GIMT_Encode4(1053288), // Rule ID 19087 //
     /* 1053216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1053219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1053227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1053230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1053233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053255 */     // MIs[0] policy
     /* 1053255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053265 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1053268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053274 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053287 */     // GIR_Coverage, 19087,
     /* 1053287 */     GIR_EraseRootFromParent_Done,
     /* 1053288 */   // Label 15563: @1053288
     /* 1053288 */   GIM_Try, /*On fail goto*//*Label 15564*/ GIMT_Encode4(1053365), // Rule ID 19090 //
     /* 1053293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1053296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1053304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1053307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1053310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053332 */     // MIs[0] policy
     /* 1053332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053342 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1053345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053364 */     // GIR_Coverage, 19090,
     /* 1053364 */     GIR_EraseRootFromParent_Done,
     /* 1053365 */   // Label 15564: @1053365
     /* 1053365 */   GIM_Try, /*On fail goto*//*Label 15565*/ GIMT_Encode4(1053442), // Rule ID 19091 //
     /* 1053370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1053373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1053381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1053384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1053387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053409 */     // MIs[0] policy
     /* 1053409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053419 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1053422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053428 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053441 */     // GIR_Coverage, 19091,
     /* 1053441 */     GIR_EraseRootFromParent_Done,
     /* 1053442 */   // Label 15565: @1053442
     /* 1053442 */   GIM_Try, /*On fail goto*//*Label 15566*/ GIMT_Encode4(1053519), // Rule ID 19094 //
     /* 1053447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1053450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1053458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1053461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1053464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1053467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053486 */     // MIs[0] policy
     /* 1053486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053496 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1053499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053518 */     // GIR_Coverage, 19094,
     /* 1053518 */     GIR_EraseRootFromParent_Done,
     /* 1053519 */   // Label 15566: @1053519
     /* 1053519 */   GIM_Try, /*On fail goto*//*Label 15567*/ GIMT_Encode4(1053596), // Rule ID 19095 //
     /* 1053524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1053527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1053535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1053538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1053541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1053544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053563 */     // MIs[0] policy
     /* 1053563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053573 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1053576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053582 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053595 */     // GIR_Coverage, 19095,
     /* 1053595 */     GIR_EraseRootFromParent_Done,
     /* 1053596 */   // Label 15567: @1053596
     /* 1053596 */   GIM_Try, /*On fail goto*//*Label 15568*/ GIMT_Encode4(1053673), // Rule ID 19098 //
     /* 1053601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1053604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1053612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1053615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1053618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053640 */     // MIs[0] policy
     /* 1053640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053650 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1053653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053672 */     // GIR_Coverage, 19098,
     /* 1053672 */     GIR_EraseRootFromParent_Done,
     /* 1053673 */   // Label 15568: @1053673
     /* 1053673 */   GIM_Try, /*On fail goto*//*Label 15569*/ GIMT_Encode4(1053750), // Rule ID 19099 //
     /* 1053678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1053681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1053689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1053692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1053695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053717 */     // MIs[0] policy
     /* 1053717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053727 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1053730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053736 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053749 */     // GIR_Coverage, 19099,
     /* 1053749 */     GIR_EraseRootFromParent_Done,
     /* 1053750 */   // Label 15569: @1053750
     /* 1053750 */   GIM_Try, /*On fail goto*//*Label 15570*/ GIMT_Encode4(1053827), // Rule ID 19102 //
     /* 1053755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1053758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1053766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1053769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1053772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053794 */     // MIs[0] policy
     /* 1053794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053804 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1053807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053813 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053826 */     // GIR_Coverage, 19102,
     /* 1053826 */     GIR_EraseRootFromParent_Done,
     /* 1053827 */   // Label 15570: @1053827
     /* 1053827 */   GIM_Try, /*On fail goto*//*Label 15571*/ GIMT_Encode4(1053904), // Rule ID 19103 //
     /* 1053832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1053835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1053843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1053846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1053849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053871 */     // MIs[0] policy
     /* 1053871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053881 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1053884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053890 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053903 */     // GIR_Coverage, 19103,
     /* 1053903 */     GIR_EraseRootFromParent_Done,
     /* 1053904 */   // Label 15571: @1053904
     /* 1053904 */   GIM_Try, /*On fail goto*//*Label 15572*/ GIMT_Encode4(1053981), // Rule ID 20486 //
     /* 1053909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1053917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1053920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1053923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1053926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1053929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053948 */     // MIs[0] policy
     /* 1053948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1053961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053980 */     // GIR_Coverage, 20486,
     /* 1053980 */     GIR_EraseRootFromParent_Done,
     /* 1053981 */   // Label 15572: @1053981
     /* 1053981 */   GIM_Try, /*On fail goto*//*Label 15573*/ GIMT_Encode4(1054058), // Rule ID 20487 //
     /* 1053986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1053994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1053997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1054000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1054003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054025 */     // MIs[0] policy
     /* 1054025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054035 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1054038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054044 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054057 */     // GIR_Coverage, 20487,
     /* 1054057 */     GIR_EraseRootFromParent_Done,
     /* 1054058 */   // Label 15573: @1054058
     /* 1054058 */   GIM_Try, /*On fail goto*//*Label 15574*/ GIMT_Encode4(1054135), // Rule ID 20490 //
     /* 1054063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1054074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1054077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1054080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054102 */     // MIs[0] policy
     /* 1054102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054112 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1054115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054134 */     // GIR_Coverage, 20490,
     /* 1054134 */     GIR_EraseRootFromParent_Done,
     /* 1054135 */   // Label 15574: @1054135
     /* 1054135 */   GIM_Try, /*On fail goto*//*Label 15575*/ GIMT_Encode4(1054212), // Rule ID 20491 //
     /* 1054140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1054151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1054154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1054157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054179 */     // MIs[0] policy
     /* 1054179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054189 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1054192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054198 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054211 */     // GIR_Coverage, 20491,
     /* 1054211 */     GIR_EraseRootFromParent_Done,
     /* 1054212 */   // Label 15575: @1054212
     /* 1054212 */   GIM_Try, /*On fail goto*//*Label 15576*/ GIMT_Encode4(1054289), // Rule ID 20494 //
     /* 1054217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1054228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1054231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1054234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054256 */     // MIs[0] policy
     /* 1054256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054266 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1054269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054288 */     // GIR_Coverage, 20494,
     /* 1054288 */     GIR_EraseRootFromParent_Done,
     /* 1054289 */   // Label 15576: @1054289
     /* 1054289 */   GIM_Try, /*On fail goto*//*Label 15577*/ GIMT_Encode4(1054366), // Rule ID 20495 //
     /* 1054294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1054305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1054308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1054311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054333 */     // MIs[0] policy
     /* 1054333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054343 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1054346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054352 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054365 */     // GIR_Coverage, 20495,
     /* 1054365 */     GIR_EraseRootFromParent_Done,
     /* 1054366 */   // Label 15577: @1054366
     /* 1054366 */   GIM_Try, /*On fail goto*//*Label 15578*/ GIMT_Encode4(1054443), // Rule ID 20498 //
     /* 1054371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1054382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1054385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1054388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054410 */     // MIs[0] policy
     /* 1054410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054420 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1054423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054442 */     // GIR_Coverage, 20498,
     /* 1054442 */     GIR_EraseRootFromParent_Done,
     /* 1054443 */   // Label 15578: @1054443
     /* 1054443 */   GIM_Try, /*On fail goto*//*Label 15579*/ GIMT_Encode4(1054520), // Rule ID 20499 //
     /* 1054448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1054459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1054462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1054465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054487 */     // MIs[0] policy
     /* 1054487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054497 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1054500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054506 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054519 */     // GIR_Coverage, 20499,
     /* 1054519 */     GIR_EraseRootFromParent_Done,
     /* 1054520 */   // Label 15579: @1054520
     /* 1054520 */   GIM_Try, /*On fail goto*//*Label 15580*/ GIMT_Encode4(1054597), // Rule ID 20502 //
     /* 1054525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1054536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1054539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1054542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054564 */     // MIs[0] policy
     /* 1054564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1054577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054596 */     // GIR_Coverage, 20502,
     /* 1054596 */     GIR_EraseRootFromParent_Done,
     /* 1054597 */   // Label 15580: @1054597
     /* 1054597 */   GIM_Try, /*On fail goto*//*Label 15581*/ GIMT_Encode4(1054674), // Rule ID 20503 //
     /* 1054602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1054613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1054616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1054619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054641 */     // MIs[0] policy
     /* 1054641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054651 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1054654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054673 */     // GIR_Coverage, 20503,
     /* 1054673 */     GIR_EraseRootFromParent_Done,
     /* 1054674 */   // Label 15581: @1054674
     /* 1054674 */   GIM_Try, /*On fail goto*//*Label 15582*/ GIMT_Encode4(1054751), // Rule ID 20506 //
     /* 1054679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1054690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1054693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1054696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054718 */     // MIs[0] policy
     /* 1054718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1054731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054750 */     // GIR_Coverage, 20506,
     /* 1054750 */     GIR_EraseRootFromParent_Done,
     /* 1054751 */   // Label 15582: @1054751
     /* 1054751 */   GIM_Try, /*On fail goto*//*Label 15583*/ GIMT_Encode4(1054828), // Rule ID 20507 //
     /* 1054756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1054767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1054770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1054773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054795 */     // MIs[0] policy
     /* 1054795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054805 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1054808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054814 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054827 */     // GIR_Coverage, 20507,
     /* 1054827 */     GIR_EraseRootFromParent_Done,
     /* 1054828 */   // Label 15583: @1054828
     /* 1054828 */   GIM_Try, /*On fail goto*//*Label 15584*/ GIMT_Encode4(1054905), // Rule ID 20510 //
     /* 1054833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1054844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1054847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1054850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1054853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054872 */     // MIs[0] policy
     /* 1054872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054882 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1054885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054904 */     // GIR_Coverage, 20510,
     /* 1054904 */     GIR_EraseRootFromParent_Done,
     /* 1054905 */   // Label 15584: @1054905
     /* 1054905 */   GIM_Try, /*On fail goto*//*Label 15585*/ GIMT_Encode4(1054982), // Rule ID 20511 //
     /* 1054910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1054921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1054924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1054927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1054930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054949 */     // MIs[0] policy
     /* 1054949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054959 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1054962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054968 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054981 */     // GIR_Coverage, 20511,
     /* 1054981 */     GIR_EraseRootFromParent_Done,
     /* 1054982 */   // Label 15585: @1054982
     /* 1054982 */   GIM_Try, /*On fail goto*//*Label 15586*/ GIMT_Encode4(1055059), // Rule ID 20514 //
     /* 1054987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1054998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1055001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1055004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1055007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055026 */     // MIs[0] policy
     /* 1055026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055036 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1055039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055058 */     // GIR_Coverage, 20514,
     /* 1055058 */     GIR_EraseRootFromParent_Done,
     /* 1055059 */   // Label 15586: @1055059
     /* 1055059 */   GIM_Try, /*On fail goto*//*Label 15587*/ GIMT_Encode4(1055136), // Rule ID 20515 //
     /* 1055064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1055075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1055078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1055081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1055084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055103 */     // MIs[0] policy
     /* 1055103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055113 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1055116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055122 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055135 */     // GIR_Coverage, 20515,
     /* 1055135 */     GIR_EraseRootFromParent_Done,
     /* 1055136 */   // Label 15587: @1055136
     /* 1055136 */   GIM_Try, /*On fail goto*//*Label 15588*/ GIMT_Encode4(1055213), // Rule ID 20518 //
     /* 1055141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1055152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1055155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1055158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055180 */     // MIs[0] policy
     /* 1055180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1055193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055212 */     // GIR_Coverage, 20518,
     /* 1055212 */     GIR_EraseRootFromParent_Done,
     /* 1055213 */   // Label 15588: @1055213
     /* 1055213 */   GIM_Try, /*On fail goto*//*Label 15589*/ GIMT_Encode4(1055290), // Rule ID 20519 //
     /* 1055218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1055229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1055232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1055235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055257 */     // MIs[0] policy
     /* 1055257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055267 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1055270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055276 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055289 */     // GIR_Coverage, 20519,
     /* 1055289 */     GIR_EraseRootFromParent_Done,
     /* 1055290 */   // Label 15589: @1055290
     /* 1055290 */   GIM_Try, /*On fail goto*//*Label 15590*/ GIMT_Encode4(1055367), // Rule ID 20522 //
     /* 1055295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1055306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1055309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1055312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055334 */     // MIs[0] policy
     /* 1055334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055344 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1055347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055366 */     // GIR_Coverage, 20522,
     /* 1055366 */     GIR_EraseRootFromParent_Done,
     /* 1055367 */   // Label 15590: @1055367
     /* 1055367 */   GIM_Try, /*On fail goto*//*Label 15591*/ GIMT_Encode4(1055444), // Rule ID 20523 //
     /* 1055372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1055383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1055386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1055389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055411 */     // MIs[0] policy
     /* 1055411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1055424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055430 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055443 */     // GIR_Coverage, 20523,
     /* 1055443 */     GIR_EraseRootFromParent_Done,
     /* 1055444 */   // Label 15591: @1055444
     /* 1055444 */   GIM_Try, /*On fail goto*//*Label 15592*/ GIMT_Encode4(1055521), // Rule ID 20526 //
     /* 1055449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1055460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1055463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1055466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1055469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055488 */     // MIs[0] policy
     /* 1055488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055498 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1055501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055520 */     // GIR_Coverage, 20526,
     /* 1055520 */     GIR_EraseRootFromParent_Done,
     /* 1055521 */   // Label 15592: @1055521
     /* 1055521 */   GIM_Try, /*On fail goto*//*Label 15593*/ GIMT_Encode4(1055598), // Rule ID 20527 //
     /* 1055526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1055537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1055540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1055543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1055546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055565 */     // MIs[0] policy
     /* 1055565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055575 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1055578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055584 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055597 */     // GIR_Coverage, 20527,
     /* 1055597 */     GIR_EraseRootFromParent_Done,
     /* 1055598 */   // Label 15593: @1055598
     /* 1055598 */   GIM_Try, /*On fail goto*//*Label 15594*/ GIMT_Encode4(1055675), // Rule ID 20530 //
     /* 1055603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1055606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1055614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1055617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1055620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055642 */     // MIs[0] policy
     /* 1055642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1055655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055674 */     // GIR_Coverage, 20530,
     /* 1055674 */     GIR_EraseRootFromParent_Done,
     /* 1055675 */   // Label 15594: @1055675
     /* 1055675 */   GIM_Try, /*On fail goto*//*Label 15595*/ GIMT_Encode4(1055752), // Rule ID 20531 //
     /* 1055680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1055683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1055691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1055694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1055697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055719 */     // MIs[0] policy
     /* 1055719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055729 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1055732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055738 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055751 */     // GIR_Coverage, 20531,
     /* 1055751 */     GIR_EraseRootFromParent_Done,
     /* 1055752 */   // Label 15595: @1055752
     /* 1055752 */   GIM_Try, /*On fail goto*//*Label 15596*/ GIMT_Encode4(1055829), // Rule ID 20534 //
     /* 1055757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1055760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1055768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1055771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1055774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055796 */     // MIs[0] policy
     /* 1055796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055806 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1055809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055828 */     // GIR_Coverage, 20534,
     /* 1055828 */     GIR_EraseRootFromParent_Done,
     /* 1055829 */   // Label 15596: @1055829
     /* 1055829 */   GIM_Try, /*On fail goto*//*Label 15597*/ GIMT_Encode4(1055906), // Rule ID 20535 //
     /* 1055834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1055837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1055845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1055848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1055851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055873 */     // MIs[0] policy
     /* 1055873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055883 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1055886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055905 */     // GIR_Coverage, 20535,
     /* 1055905 */     GIR_EraseRootFromParent_Done,
     /* 1055906 */   // Label 15597: @1055906
     /* 1055906 */   GIM_Try, /*On fail goto*//*Label 15598*/ GIMT_Encode4(1055983), // Rule ID 20538 //
     /* 1055911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1055914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1055922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1055925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1055928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055950 */     // MIs[0] policy
     /* 1055950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1055963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055982 */     // GIR_Coverage, 20538,
     /* 1055982 */     GIR_EraseRootFromParent_Done,
     /* 1055983 */   // Label 15598: @1055983
     /* 1055983 */   GIM_Try, /*On fail goto*//*Label 15599*/ GIMT_Encode4(1056060), // Rule ID 20539 //
     /* 1055988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1055991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1055999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1056002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1056005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056027 */     // MIs[0] policy
     /* 1056027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056037 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1056040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056046 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056059 */     // GIR_Coverage, 20539,
     /* 1056059 */     GIR_EraseRootFromParent_Done,
     /* 1056060 */   // Label 15599: @1056060
     /* 1056060 */   GIM_Try, /*On fail goto*//*Label 15600*/ GIMT_Encode4(1056137), // Rule ID 20864 //
     /* 1056065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1056076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1056079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1056082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056104 */     // MIs[0] policy
     /* 1056104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1056117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056136 */     // GIR_Coverage, 20864,
     /* 1056136 */     GIR_EraseRootFromParent_Done,
     /* 1056137 */   // Label 15600: @1056137
     /* 1056137 */   GIM_Try, /*On fail goto*//*Label 15601*/ GIMT_Encode4(1056214), // Rule ID 20865 //
     /* 1056142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1056153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1056156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1056159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056181 */     // MIs[0] policy
     /* 1056181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056191 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1056194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056200 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056213 */     // GIR_Coverage, 20865,
     /* 1056213 */     GIR_EraseRootFromParent_Done,
     /* 1056214 */   // Label 15601: @1056214
     /* 1056214 */   GIM_Try, /*On fail goto*//*Label 15602*/ GIMT_Encode4(1056291), // Rule ID 20868 //
     /* 1056219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1056230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1056233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1056236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056258 */     // MIs[0] policy
     /* 1056258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056268 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1056271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056290 */     // GIR_Coverage, 20868,
     /* 1056290 */     GIR_EraseRootFromParent_Done,
     /* 1056291 */   // Label 15602: @1056291
     /* 1056291 */   GIM_Try, /*On fail goto*//*Label 15603*/ GIMT_Encode4(1056368), // Rule ID 20869 //
     /* 1056296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1056307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1056310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1056313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056335 */     // MIs[0] policy
     /* 1056335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056345 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1056348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056354 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056367 */     // GIR_Coverage, 20869,
     /* 1056367 */     GIR_EraseRootFromParent_Done,
     /* 1056368 */   // Label 15603: @1056368
     /* 1056368 */   GIM_Try, /*On fail goto*//*Label 15604*/ GIMT_Encode4(1056445), // Rule ID 20872 //
     /* 1056373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1056384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1056387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1056390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056412 */     // MIs[0] policy
     /* 1056412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056422 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1056425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056444 */     // GIR_Coverage, 20872,
     /* 1056444 */     GIR_EraseRootFromParent_Done,
     /* 1056445 */   // Label 15604: @1056445
     /* 1056445 */   GIM_Try, /*On fail goto*//*Label 15605*/ GIMT_Encode4(1056522), // Rule ID 20873 //
     /* 1056450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1056461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1056464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1056467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056489 */     // MIs[0] policy
     /* 1056489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056499 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1056502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056508 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056521 */     // GIR_Coverage, 20873,
     /* 1056521 */     GIR_EraseRootFromParent_Done,
     /* 1056522 */   // Label 15605: @1056522
     /* 1056522 */   GIM_Try, /*On fail goto*//*Label 15606*/ GIMT_Encode4(1056599), // Rule ID 20876 //
     /* 1056527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1056538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1056541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1056544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056566 */     // MIs[0] policy
     /* 1056566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056598 */     // GIR_Coverage, 20876,
     /* 1056598 */     GIR_EraseRootFromParent_Done,
     /* 1056599 */   // Label 15606: @1056599
     /* 1056599 */   GIM_Try, /*On fail goto*//*Label 15607*/ GIMT_Encode4(1056676), // Rule ID 20877 //
     /* 1056604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1056615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1056618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1056621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056643 */     // MIs[0] policy
     /* 1056643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056653 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056662 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056675 */     // GIR_Coverage, 20877,
     /* 1056675 */     GIR_EraseRootFromParent_Done,
     /* 1056676 */   // Label 15607: @1056676
     /* 1056676 */   GIM_Try, /*On fail goto*//*Label 15608*/ GIMT_Encode4(1056753), // Rule ID 20880 //
     /* 1056681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1056692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1056695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1056698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056720 */     // MIs[0] policy
     /* 1056720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056730 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056752 */     // GIR_Coverage, 20880,
     /* 1056752 */     GIR_EraseRootFromParent_Done,
     /* 1056753 */   // Label 15608: @1056753
     /* 1056753 */   GIM_Try, /*On fail goto*//*Label 15609*/ GIMT_Encode4(1056830), // Rule ID 20881 //
     /* 1056758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1056769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1056772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1056775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056797 */     // MIs[0] policy
     /* 1056797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056807 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056816 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056829 */     // GIR_Coverage, 20881,
     /* 1056829 */     GIR_EraseRootFromParent_Done,
     /* 1056830 */   // Label 15609: @1056830
     /* 1056830 */   GIM_Try, /*On fail goto*//*Label 15610*/ GIMT_Encode4(1056907), // Rule ID 20884 //
     /* 1056835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1056838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1056846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1056849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1056852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056874 */     // MIs[0] policy
     /* 1056874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056884 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056906 */     // GIR_Coverage, 20884,
     /* 1056906 */     GIR_EraseRootFromParent_Done,
     /* 1056907 */   // Label 15610: @1056907
     /* 1056907 */   GIM_Try, /*On fail goto*//*Label 15611*/ GIMT_Encode4(1056984), // Rule ID 20885 //
     /* 1056912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1056915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1056923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1056926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1056929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056951 */     // MIs[0] policy
     /* 1056951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056961 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056970 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056983 */     // GIR_Coverage, 20885,
     /* 1056983 */     GIR_EraseRootFromParent_Done,
     /* 1056984 */   // Label 15611: @1056984
     /* 1056984 */   GIM_Try, /*On fail goto*//*Label 15612*/ GIMT_Encode4(1057061), // Rule ID 20888 //
     /* 1056989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1057000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1057003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1057006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057028 */     // MIs[0] policy
     /* 1057028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057038 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057060 */     // GIR_Coverage, 20888,
     /* 1057060 */     GIR_EraseRootFromParent_Done,
     /* 1057061 */   // Label 15612: @1057061
     /* 1057061 */   GIM_Try, /*On fail goto*//*Label 15613*/ GIMT_Encode4(1057138), // Rule ID 20889 //
     /* 1057066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1057077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1057080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1057083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057105 */     // MIs[0] policy
     /* 1057105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057115 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057124 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057137 */     // GIR_Coverage, 20889,
     /* 1057137 */     GIR_EraseRootFromParent_Done,
     /* 1057138 */   // Label 15613: @1057138
     /* 1057138 */   GIM_Try, /*On fail goto*//*Label 15614*/ GIMT_Encode4(1057215), // Rule ID 20892 //
     /* 1057143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1057154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1057157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1057160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057182 */     // MIs[0] policy
     /* 1057182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057192 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057214 */     // GIR_Coverage, 20892,
     /* 1057214 */     GIR_EraseRootFromParent_Done,
     /* 1057215 */   // Label 15614: @1057215
     /* 1057215 */   GIM_Try, /*On fail goto*//*Label 15615*/ GIMT_Encode4(1057292), // Rule ID 20893 //
     /* 1057220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1057231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1057234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1057237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057259 */     // MIs[0] policy
     /* 1057259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057269 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057278 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057291 */     // GIR_Coverage, 20893,
     /* 1057291 */     GIR_EraseRootFromParent_Done,
     /* 1057292 */   // Label 15615: @1057292
     /* 1057292 */   GIM_Try, /*On fail goto*//*Label 15616*/ GIMT_Encode4(1057369), // Rule ID 20896 //
     /* 1057297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1057308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1057311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1057314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1057317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057336 */     // MIs[0] policy
     /* 1057336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057346 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1057349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057368 */     // GIR_Coverage, 20896,
     /* 1057368 */     GIR_EraseRootFromParent_Done,
     /* 1057369 */   // Label 15616: @1057369
     /* 1057369 */   GIM_Try, /*On fail goto*//*Label 15617*/ GIMT_Encode4(1057446), // Rule ID 20897 //
     /* 1057374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1057385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1057388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1057391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1057394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057413 */     // MIs[0] policy
     /* 1057413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057423 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1057426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057432 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057445 */     // GIR_Coverage, 20897,
     /* 1057445 */     GIR_EraseRootFromParent_Done,
     /* 1057446 */   // Label 15617: @1057446
     /* 1057446 */   GIM_Try, /*On fail goto*//*Label 15618*/ GIMT_Encode4(1057523), // Rule ID 20900 //
     /* 1057451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1057454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1057468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057490 */     // MIs[0] policy
     /* 1057490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057522 */     // GIR_Coverage, 20900,
     /* 1057522 */     GIR_EraseRootFromParent_Done,
     /* 1057523 */   // Label 15618: @1057523
     /* 1057523 */   GIM_Try, /*On fail goto*//*Label 15619*/ GIMT_Encode4(1057600), // Rule ID 20901 //
     /* 1057528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1057531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1057545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057567 */     // MIs[0] policy
     /* 1057567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057577 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057586 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057599 */     // GIR_Coverage, 20901,
     /* 1057599 */     GIR_EraseRootFromParent_Done,
     /* 1057600 */   // Label 15619: @1057600
     /* 1057600 */   GIM_Try, /*On fail goto*//*Label 15620*/ GIMT_Encode4(1057677), // Rule ID 20904 //
     /* 1057605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1057608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1057622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057644 */     // MIs[0] policy
     /* 1057644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057654 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057676 */     // GIR_Coverage, 20904,
     /* 1057676 */     GIR_EraseRootFromParent_Done,
     /* 1057677 */   // Label 15620: @1057677
     /* 1057677 */   GIM_Try, /*On fail goto*//*Label 15621*/ GIMT_Encode4(1057754), // Rule ID 20905 //
     /* 1057682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1057685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1057699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057721 */     // MIs[0] policy
     /* 1057721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057731 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057740 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057753 */     // GIR_Coverage, 20905,
     /* 1057753 */     GIR_EraseRootFromParent_Done,
     /* 1057754 */   // Label 15621: @1057754
     /* 1057754 */   GIM_Try, /*On fail goto*//*Label 15622*/ GIMT_Encode4(1057831), // Rule ID 20908 //
     /* 1057759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1057762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1057770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1057773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1057776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057798 */     // MIs[0] policy
     /* 1057798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057808 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1057811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057830 */     // GIR_Coverage, 20908,
     /* 1057830 */     GIR_EraseRootFromParent_Done,
     /* 1057831 */   // Label 15622: @1057831
     /* 1057831 */   GIM_Try, /*On fail goto*//*Label 15623*/ GIMT_Encode4(1057908), // Rule ID 20909 //
     /* 1057836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1057839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1057847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1057850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1057853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057875 */     // MIs[0] policy
     /* 1057875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057885 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1057888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057894 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057907 */     // GIR_Coverage, 20909,
     /* 1057907 */     GIR_EraseRootFromParent_Done,
     /* 1057908 */   // Label 15623: @1057908
     /* 1057908 */   GIM_Try, /*On fail goto*//*Label 15624*/ GIMT_Encode4(1057985), // Rule ID 20912 //
     /* 1057913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1057916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1057924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1057927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1057930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057952 */     // MIs[0] policy
     /* 1057952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057962 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1057981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057984 */     // GIR_Coverage, 20912,
     /* 1057984 */     GIR_EraseRootFromParent_Done,
     /* 1057985 */   // Label 15624: @1057985
     /* 1057985 */   GIM_Try, /*On fail goto*//*Label 15625*/ GIMT_Encode4(1058062), // Rule ID 20913 //
     /* 1057990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1057993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1058001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1058004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1058007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058029 */     // MIs[0] policy
     /* 1058029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058039 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1058042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058048 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1058058 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058061 */     // GIR_Coverage, 20913,
     /* 1058061 */     GIR_EraseRootFromParent_Done,
     /* 1058062 */   // Label 15625: @1058062
     /* 1058062 */   GIM_Try, /*On fail goto*//*Label 15626*/ GIMT_Encode4(1058139), // Rule ID 20916 //
     /* 1058067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1058070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1058075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1058078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1058081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1058084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058106 */     // MIs[0] policy
     /* 1058106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058116 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1058135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058138 */     // GIR_Coverage, 20916,
     /* 1058138 */     GIR_EraseRootFromParent_Done,
     /* 1058139 */   // Label 15626: @1058139
     /* 1058139 */   GIM_Try, /*On fail goto*//*Label 15627*/ GIMT_Encode4(1058216), // Rule ID 20917 //
     /* 1058144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1058147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1058152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1058155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1058158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1058161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058183 */     // MIs[0] policy
     /* 1058183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058193 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058202 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1058212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058215 */     // GIR_Coverage, 20917,
     /* 1058215 */     GIR_EraseRootFromParent_Done,
     /* 1058216 */   // Label 15627: @1058216
     /* 1058216 */   GIM_Try, /*On fail goto*//*Label 15628*/ GIMT_Encode4(1058293), // Rule ID 20920 //
     /* 1058221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1058224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1058229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1058238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058260 */     // MIs[0] policy
     /* 1058260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058270 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1058273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1058289 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058292 */     // GIR_Coverage, 20920,
     /* 1058292 */     GIR_EraseRootFromParent_Done,
     /* 1058293 */   // Label 15628: @1058293
     /* 1058293 */   GIM_Try, /*On fail goto*//*Label 15629*/ GIMT_Encode4(1058370), // Rule ID 20921 //
     /* 1058298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1058301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1058306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1058315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058337 */     // MIs[0] policy
     /* 1058337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058347 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1058350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058356 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1058366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058369 */     // GIR_Coverage, 20921,
     /* 1058369 */     GIR_EraseRootFromParent_Done,
     /* 1058370 */   // Label 15629: @1058370
     /* 1058370 */   GIM_Try, /*On fail goto*//*Label 15630*/ GIMT_Encode4(1058447), // Rule ID 20924 //
     /* 1058375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1058386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1058389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058414 */     // MIs[0] policy
     /* 1058414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058424 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1058427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058446 */     // GIR_Coverage, 20924,
     /* 1058446 */     GIR_EraseRootFromParent_Done,
     /* 1058447 */   // Label 15630: @1058447
     /* 1058447 */   GIM_Try, /*On fail goto*//*Label 15631*/ GIMT_Encode4(1058524), // Rule ID 20925 //
     /* 1058452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1058463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1058466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058491 */     // MIs[0] policy
     /* 1058491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058501 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1058504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058510 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058523 */     // GIR_Coverage, 20925,
     /* 1058523 */     GIR_EraseRootFromParent_Done,
     /* 1058524 */   // Label 15631: @1058524
     /* 1058524 */   GIM_Try, /*On fail goto*//*Label 15632*/ GIMT_Encode4(1058601), // Rule ID 20928 //
     /* 1058529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1058540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1058543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058568 */     // MIs[0] policy
     /* 1058568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058578 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058600 */     // GIR_Coverage, 20928,
     /* 1058600 */     GIR_EraseRootFromParent_Done,
     /* 1058601 */   // Label 15632: @1058601
     /* 1058601 */   GIM_Try, /*On fail goto*//*Label 15633*/ GIMT_Encode4(1058678), // Rule ID 20929 //
     /* 1058606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1058617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1058620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058645 */     // MIs[0] policy
     /* 1058645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058655 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058664 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058674 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058677 */     // GIR_Coverage, 20929,
     /* 1058677 */     GIR_EraseRootFromParent_Done,
     /* 1058678 */   // Label 15633: @1058678
     /* 1058678 */   GIM_Try, /*On fail goto*//*Label 15634*/ GIMT_Encode4(1058755), // Rule ID 20932 //
     /* 1058683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1058686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1058694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1058697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1058700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058722 */     // MIs[0] policy
     /* 1058722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058751 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058754 */     // GIR_Coverage, 20932,
     /* 1058754 */     GIR_EraseRootFromParent_Done,
     /* 1058755 */   // Label 15634: @1058755
     /* 1058755 */   GIM_Try, /*On fail goto*//*Label 15635*/ GIMT_Encode4(1058832), // Rule ID 20933 //
     /* 1058760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1058763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1058771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1058774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1058777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058799 */     // MIs[0] policy
     /* 1058799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058809 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058818 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058831 */     // GIR_Coverage, 20933,
     /* 1058831 */     GIR_EraseRootFromParent_Done,
     /* 1058832 */   // Label 15635: @1058832
     /* 1058832 */   GIM_Try, /*On fail goto*//*Label 15636*/ GIMT_Encode4(1058909), // Rule ID 20936 //
     /* 1058837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1058848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1058851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1058854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058876 */     // MIs[0] policy
     /* 1058876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058886 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1058889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058905 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058908 */     // GIR_Coverage, 20936,
     /* 1058908 */     GIR_EraseRootFromParent_Done,
     /* 1058909 */   // Label 15636: @1058909
     /* 1058909 */   GIM_Try, /*On fail goto*//*Label 15637*/ GIMT_Encode4(1058986), // Rule ID 20937 //
     /* 1058914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1058925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1058928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1058931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058953 */     // MIs[0] policy
     /* 1058953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058963 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1058966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058972 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058985 */     // GIR_Coverage, 20937,
     /* 1058985 */     GIR_EraseRootFromParent_Done,
     /* 1058986 */   // Label 15637: @1058986
     /* 1058986 */   GIM_Try, /*On fail goto*//*Label 15638*/ GIMT_Encode4(1059063), // Rule ID 20940 //
     /* 1058991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1058994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1059002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1059005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059030 */     // MIs[0] policy
     /* 1059030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1059043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059062 */     // GIR_Coverage, 20940,
     /* 1059062 */     GIR_EraseRootFromParent_Done,
     /* 1059063 */   // Label 15638: @1059063
     /* 1059063 */   GIM_Try, /*On fail goto*//*Label 15639*/ GIMT_Encode4(1059140), // Rule ID 20941 //
     /* 1059068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1059071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1059079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1059082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059107 */     // MIs[0] policy
     /* 1059107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059117 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1059120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059126 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059139 */     // GIR_Coverage, 20941,
     /* 1059139 */     GIR_EraseRootFromParent_Done,
     /* 1059140 */   // Label 15639: @1059140
     /* 1059140 */   GIM_Try, /*On fail goto*//*Label 15640*/ GIMT_Encode4(1059217), // Rule ID 20944 //
     /* 1059145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1059148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1059156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1059159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1059162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059184 */     // MIs[0] policy
     /* 1059184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059194 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1059197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059203 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1059213 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059216 */     // GIR_Coverage, 20944,
     /* 1059216 */     GIR_EraseRootFromParent_Done,
     /* 1059217 */   // Label 15640: @1059217
     /* 1059217 */   GIM_Try, /*On fail goto*//*Label 15641*/ GIMT_Encode4(1059294), // Rule ID 20945 //
     /* 1059222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1059225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1059233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1059236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1059239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059261 */     // MIs[0] policy
     /* 1059261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059271 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1059274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059280 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1059290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059293 */     // GIR_Coverage, 20945,
     /* 1059293 */     GIR_EraseRootFromParent_Done,
     /* 1059294 */   // Label 15641: @1059294
     /* 1059294 */   GIM_Try, /*On fail goto*//*Label 15642*/ GIMT_Encode4(1059371), // Rule ID 20948 //
     /* 1059299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1059310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1059313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1059316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059338 */     // MIs[0] policy
     /* 1059338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1059351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059370 */     // GIR_Coverage, 20948,
     /* 1059370 */     GIR_EraseRootFromParent_Done,
     /* 1059371 */   // Label 15642: @1059371
     /* 1059371 */   GIM_Try, /*On fail goto*//*Label 15643*/ GIMT_Encode4(1059448), // Rule ID 20949 //
     /* 1059376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1059387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1059390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1059393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059415 */     // MIs[0] policy
     /* 1059415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059425 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1059428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059434 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059447 */     // GIR_Coverage, 20949,
     /* 1059447 */     GIR_EraseRootFromParent_Done,
     /* 1059448 */   // Label 15643: @1059448
     /* 1059448 */   GIM_Try, /*On fail goto*//*Label 15644*/ GIMT_Encode4(1059525), // Rule ID 20952 //
     /* 1059453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1059464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1059467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1059470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1059473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059492 */     // MIs[0] policy
     /* 1059492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059502 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1059505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059524 */     // GIR_Coverage, 20952,
     /* 1059524 */     GIR_EraseRootFromParent_Done,
     /* 1059525 */   // Label 15644: @1059525
     /* 1059525 */   GIM_Try, /*On fail goto*//*Label 15645*/ GIMT_Encode4(1059602), // Rule ID 20953 //
     /* 1059530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1059541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1059544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1059547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1059550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059569 */     // MIs[0] policy
     /* 1059569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059579 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1059582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059588 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059601 */     // GIR_Coverage, 20953,
     /* 1059601 */     GIR_EraseRootFromParent_Done,
     /* 1059602 */   // Label 15645: @1059602
     /* 1059602 */   GIM_Try, /*On fail goto*//*Label 15646*/ GIMT_Encode4(1059679), // Rule ID 20956 //
     /* 1059607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1059618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1059621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1059624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1059627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059646 */     // MIs[0] policy
     /* 1059646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059656 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1059659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059675 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059678 */     // GIR_Coverage, 20956,
     /* 1059678 */     GIR_EraseRootFromParent_Done,
     /* 1059679 */   // Label 15646: @1059679
     /* 1059679 */   GIM_Try, /*On fail goto*//*Label 15647*/ GIMT_Encode4(1059756), // Rule ID 20957 //
     /* 1059684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1059695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1059698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1059701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1059704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059723 */     // MIs[0] policy
     /* 1059723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059733 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1059736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059742 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059755 */     // GIR_Coverage, 20957,
     /* 1059755 */     GIR_EraseRootFromParent_Done,
     /* 1059756 */   // Label 15647: @1059756
     /* 1059756 */   GIM_Try, /*On fail goto*//*Label 15648*/ GIMT_Encode4(1059833), // Rule ID 20960 //
     /* 1059761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1059764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1059772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1059775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1059778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059800 */     // MIs[0] policy
     /* 1059800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059810 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1059813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059832 */     // GIR_Coverage, 20960,
     /* 1059832 */     GIR_EraseRootFromParent_Done,
     /* 1059833 */   // Label 15648: @1059833
     /* 1059833 */   GIM_Try, /*On fail goto*//*Label 15649*/ GIMT_Encode4(1059910), // Rule ID 20961 //
     /* 1059838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1059841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1059849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1059852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1059855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059877 */     // MIs[0] policy
     /* 1059877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1059890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059896 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059909 */     // GIR_Coverage, 20961,
     /* 1059909 */     GIR_EraseRootFromParent_Done,
     /* 1059910 */   // Label 15649: @1059910
     /* 1059910 */   GIM_Try, /*On fail goto*//*Label 15650*/ GIMT_Encode4(1059987), // Rule ID 20964 //
     /* 1059915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1059918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1059926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1059929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1059932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059954 */     // MIs[0] policy
     /* 1059954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059964 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1059967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059986 */     // GIR_Coverage, 20964,
     /* 1059986 */     GIR_EraseRootFromParent_Done,
     /* 1059987 */   // Label 15650: @1059987
     /* 1059987 */   GIM_Try, /*On fail goto*//*Label 15651*/ GIMT_Encode4(1060064), // Rule ID 20965 //
     /* 1059992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1059995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1060003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1060006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1060009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060031 */     // MIs[0] policy
     /* 1060031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060041 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1060044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060050 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060063 */     // GIR_Coverage, 20965,
     /* 1060063 */     GIR_EraseRootFromParent_Done,
     /* 1060064 */   // Label 15651: @1060064
     /* 1060064 */   GIM_Try, /*On fail goto*//*Label 15652*/ GIMT_Encode4(1060141), // Rule ID 20968 //
     /* 1060069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1060072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1060080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1060083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1060086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060108 */     // MIs[0] policy
     /* 1060108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1060121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060140 */     // GIR_Coverage, 20968,
     /* 1060140 */     GIR_EraseRootFromParent_Done,
     /* 1060141 */   // Label 15652: @1060141
     /* 1060141 */   GIM_Try, /*On fail goto*//*Label 15653*/ GIMT_Encode4(1060218), // Rule ID 20969 //
     /* 1060146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1060149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1060157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1060160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1060163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060185 */     // MIs[0] policy
     /* 1060185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060195 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1060198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060204 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060217 */     // GIR_Coverage, 20969,
     /* 1060217 */     GIR_EraseRootFromParent_Done,
     /* 1060218 */   // Label 15653: @1060218
     /* 1060218 */   GIM_Try, /*On fail goto*//*Label 15654*/ GIMT_Encode4(1060295), // Rule ID 20972 //
     /* 1060223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1060226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1060234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1060237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1060240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060262 */     // MIs[0] policy
     /* 1060262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060272 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1060275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1060291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060294 */     // GIR_Coverage, 20972,
     /* 1060294 */     GIR_EraseRootFromParent_Done,
     /* 1060295 */   // Label 15654: @1060295
     /* 1060295 */   GIM_Try, /*On fail goto*//*Label 15655*/ GIMT_Encode4(1060372), // Rule ID 20973 //
     /* 1060300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1060303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1060311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1060314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1060317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060339 */     // MIs[0] policy
     /* 1060339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1060352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060358 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1060368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060371 */     // GIR_Coverage, 20973,
     /* 1060371 */     GIR_EraseRootFromParent_Done,
     /* 1060372 */   // Label 15655: @1060372
     /* 1060372 */   GIM_Try, /*On fail goto*//*Label 15656*/ GIMT_Encode4(1060449), // Rule ID 20976 //
     /* 1060377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1060380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1060388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1060391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1060394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060416 */     // MIs[0] policy
     /* 1060416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060426 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1060429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1060445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060448 */     // GIR_Coverage, 20976,
     /* 1060448 */     GIR_EraseRootFromParent_Done,
     /* 1060449 */   // Label 15656: @1060449
     /* 1060449 */   GIM_Try, /*On fail goto*//*Label 15657*/ GIMT_Encode4(1060526), // Rule ID 20977 //
     /* 1060454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1060457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1060465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1060468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1060471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060493 */     // MIs[0] policy
     /* 1060493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060503 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1060506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060512 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1060522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060525 */     // GIR_Coverage, 20977,
     /* 1060525 */     GIR_EraseRootFromParent_Done,
     /* 1060526 */   // Label 15657: @1060526
     /* 1060526 */   GIM_Try, /*On fail goto*//*Label 15658*/ GIMT_Encode4(1060603), // Rule ID 20980 //
     /* 1060531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1060534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1060542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1060545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1060548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060570 */     // MIs[0] policy
     /* 1060570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060580 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1060583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1060599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060602 */     // GIR_Coverage, 20980,
     /* 1060602 */     GIR_EraseRootFromParent_Done,
     /* 1060603 */   // Label 15658: @1060603
     /* 1060603 */   GIM_Try, /*On fail goto*//*Label 15659*/ GIMT_Encode4(1060680), // Rule ID 20981 //
     /* 1060608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1060611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1060619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1060622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1060625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060647 */     // MIs[0] policy
     /* 1060647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060657 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1060660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060666 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1060676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060679 */     // GIR_Coverage, 20981,
     /* 1060679 */     GIR_EraseRootFromParent_Done,
     /* 1060680 */   // Label 15659: @1060680
     /* 1060680 */   GIM_Try, /*On fail goto*//*Label 15660*/ GIMT_Encode4(1060757), // Rule ID 21248 //
     /* 1060685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1060693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1060696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1060699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1060702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060724 */     // MIs[0] policy
     /* 1060724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060734 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1060737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060756 */     // GIR_Coverage, 21248,
     /* 1060756 */     GIR_EraseRootFromParent_Done,
     /* 1060757 */   // Label 15660: @1060757
     /* 1060757 */   GIM_Try, /*On fail goto*//*Label 15661*/ GIMT_Encode4(1060834), // Rule ID 21249 //
     /* 1060762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1060770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1060773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1060776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1060779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060801 */     // MIs[0] policy
     /* 1060801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060811 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1060814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060820 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060833 */     // GIR_Coverage, 21249,
     /* 1060833 */     GIR_EraseRootFromParent_Done,
     /* 1060834 */   // Label 15661: @1060834
     /* 1060834 */   GIM_Try, /*On fail goto*//*Label 15662*/ GIMT_Encode4(1060911), // Rule ID 21252 //
     /* 1060839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1060847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1060850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1060853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1060856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060878 */     // MIs[0] policy
     /* 1060878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1060891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060910 */     // GIR_Coverage, 21252,
     /* 1060910 */     GIR_EraseRootFromParent_Done,
     /* 1060911 */   // Label 15662: @1060911
     /* 1060911 */   GIM_Try, /*On fail goto*//*Label 15663*/ GIMT_Encode4(1060988), // Rule ID 21253 //
     /* 1060916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1060924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1060927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1060930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1060933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060955 */     // MIs[0] policy
     /* 1060955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060965 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1060968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060974 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060987 */     // GIR_Coverage, 21253,
     /* 1060987 */     GIR_EraseRootFromParent_Done,
     /* 1060988 */   // Label 15663: @1060988
     /* 1060988 */   GIM_Try, /*On fail goto*//*Label 15664*/ GIMT_Encode4(1061065), // Rule ID 21256 //
     /* 1060993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1061004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1061007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1061010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061032 */     // MIs[0] policy
     /* 1061032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1061045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061064 */     // GIR_Coverage, 21256,
     /* 1061064 */     GIR_EraseRootFromParent_Done,
     /* 1061065 */   // Label 15664: @1061065
     /* 1061065 */   GIM_Try, /*On fail goto*//*Label 15665*/ GIMT_Encode4(1061142), // Rule ID 21257 //
     /* 1061070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1061073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1061081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1061084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1061087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061109 */     // MIs[0] policy
     /* 1061109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1061122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061128 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061138 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061141 */     // GIR_Coverage, 21257,
     /* 1061141 */     GIR_EraseRootFromParent_Done,
     /* 1061142 */   // Label 15665: @1061142
     /* 1061142 */   GIM_Try, /*On fail goto*//*Label 15666*/ GIMT_Encode4(1061219), // Rule ID 21260 //
     /* 1061147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1061150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1061158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1061161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1061164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061186 */     // MIs[0] policy
     /* 1061186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061196 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1061199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061218 */     // GIR_Coverage, 21260,
     /* 1061218 */     GIR_EraseRootFromParent_Done,
     /* 1061219 */   // Label 15666: @1061219
     /* 1061219 */   GIM_Try, /*On fail goto*//*Label 15667*/ GIMT_Encode4(1061296), // Rule ID 21261 //
     /* 1061224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1061227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1061235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1061238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1061241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061263 */     // MIs[0] policy
     /* 1061263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061273 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1061276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061282 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061295 */     // GIR_Coverage, 21261,
     /* 1061295 */     GIR_EraseRootFromParent_Done,
     /* 1061296 */   // Label 15667: @1061296
     /* 1061296 */   GIM_Try, /*On fail goto*//*Label 15668*/ GIMT_Encode4(1061373), // Rule ID 21264 //
     /* 1061301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1061304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1061318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1061321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061340 */     // MIs[0] policy
     /* 1061340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061350 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1061353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061372 */     // GIR_Coverage, 21264,
     /* 1061372 */     GIR_EraseRootFromParent_Done,
     /* 1061373 */   // Label 15668: @1061373
     /* 1061373 */   GIM_Try, /*On fail goto*//*Label 15669*/ GIMT_Encode4(1061450), // Rule ID 21265 //
     /* 1061378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1061381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1061395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1061398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061417 */     // MIs[0] policy
     /* 1061417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061427 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1061430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061436 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061449 */     // GIR_Coverage, 21265,
     /* 1061449 */     GIR_EraseRootFromParent_Done,
     /* 1061450 */   // Label 15669: @1061450
     /* 1061450 */   GIM_Try, /*On fail goto*//*Label 15670*/ GIMT_Encode4(1061527), // Rule ID 21268 //
     /* 1061455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1061458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1061466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1061469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1061472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061494 */     // MIs[0] policy
     /* 1061494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061504 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1061507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061526 */     // GIR_Coverage, 21268,
     /* 1061526 */     GIR_EraseRootFromParent_Done,
     /* 1061527 */   // Label 15670: @1061527
     /* 1061527 */   GIM_Try, /*On fail goto*//*Label 15671*/ GIMT_Encode4(1061604), // Rule ID 21269 //
     /* 1061532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1061535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1061543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1061546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1061549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061571 */     // MIs[0] policy
     /* 1061571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061581 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1061584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061590 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061603 */     // GIR_Coverage, 21269,
     /* 1061603 */     GIR_EraseRootFromParent_Done,
     /* 1061604 */   // Label 15671: @1061604
     /* 1061604 */   GIM_Try, /*On fail goto*//*Label 15672*/ GIMT_Encode4(1061681), // Rule ID 21272 //
     /* 1061609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1061612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1061620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1061623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1061626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061648 */     // MIs[0] policy
     /* 1061648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061658 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1061661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061677 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061680 */     // GIR_Coverage, 21272,
     /* 1061680 */     GIR_EraseRootFromParent_Done,
     /* 1061681 */   // Label 15672: @1061681
     /* 1061681 */   GIM_Try, /*On fail goto*//*Label 15673*/ GIMT_Encode4(1061758), // Rule ID 21273 //
     /* 1061686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1061689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1061697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1061700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1061703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061725 */     // MIs[0] policy
     /* 1061725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061735 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1061738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061744 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061757 */     // GIR_Coverage, 21273,
     /* 1061757 */     GIR_EraseRootFromParent_Done,
     /* 1061758 */   // Label 15673: @1061758
     /* 1061758 */   GIM_Try, /*On fail goto*//*Label 15674*/ GIMT_Encode4(1061835), // Rule ID 21276 //
     /* 1061763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1061766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1061774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1061777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1061780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061802 */     // MIs[0] policy
     /* 1061802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061812 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1061815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061834 */     // GIR_Coverage, 21276,
     /* 1061834 */     GIR_EraseRootFromParent_Done,
     /* 1061835 */   // Label 15674: @1061835
     /* 1061835 */   GIM_Try, /*On fail goto*//*Label 15675*/ GIMT_Encode4(1061912), // Rule ID 21277 //
     /* 1061840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1061843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1061851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1061854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1061857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061879 */     // MIs[0] policy
     /* 1061879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061889 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1061892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061898 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061911 */     // GIR_Coverage, 21277,
     /* 1061911 */     GIR_EraseRootFromParent_Done,
     /* 1061912 */   // Label 15675: @1061912
     /* 1061912 */   GIM_Try, /*On fail goto*//*Label 15676*/ GIMT_Encode4(1061989), // Rule ID 21280 //
     /* 1061917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1061920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1061928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1061931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1061934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061956 */     // MIs[0] policy
     /* 1061956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061966 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1061969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061988 */     // GIR_Coverage, 21280,
     /* 1061988 */     GIR_EraseRootFromParent_Done,
     /* 1061989 */   // Label 15676: @1061989
     /* 1061989 */   GIM_Try, /*On fail goto*//*Label 15677*/ GIMT_Encode4(1062066), // Rule ID 21281 //
     /* 1061994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1061997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1062002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1062005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1062008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1062011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062033 */     // MIs[0] policy
     /* 1062033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1062046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062052 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062065 */     // GIR_Coverage, 21281,
     /* 1062065 */     GIR_EraseRootFromParent_Done,
     /* 1062066 */   // Label 15677: @1062066
     /* 1062066 */   GIM_Try, /*On fail goto*//*Label 15678*/ GIMT_Encode4(1062143), // Rule ID 21284 //
     /* 1062071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1062082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1062085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1062088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062110 */     // MIs[0] policy
     /* 1062110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062120 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1062123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062142 */     // GIR_Coverage, 21284,
     /* 1062142 */     GIR_EraseRootFromParent_Done,
     /* 1062143 */   // Label 15678: @1062143
     /* 1062143 */   GIM_Try, /*On fail goto*//*Label 15679*/ GIMT_Encode4(1062220), // Rule ID 21285 //
     /* 1062148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1062159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1062162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1062165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062187 */     // MIs[0] policy
     /* 1062187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062197 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1062200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062206 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062219 */     // GIR_Coverage, 21285,
     /* 1062219 */     GIR_EraseRootFromParent_Done,
     /* 1062220 */   // Label 15679: @1062220
     /* 1062220 */   GIM_Try, /*On fail goto*//*Label 15680*/ GIMT_Encode4(1062297), // Rule ID 21288 //
     /* 1062225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1062236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1062239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1062242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062264 */     // MIs[0] policy
     /* 1062264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062274 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1062277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062293 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062296 */     // GIR_Coverage, 21288,
     /* 1062296 */     GIR_EraseRootFromParent_Done,
     /* 1062297 */   // Label 15680: @1062297
     /* 1062297 */   GIM_Try, /*On fail goto*//*Label 15681*/ GIMT_Encode4(1062374), // Rule ID 21289 //
     /* 1062302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1062313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1062316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1062319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062341 */     // MIs[0] policy
     /* 1062341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062351 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1062354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062360 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062373 */     // GIR_Coverage, 21289,
     /* 1062373 */     GIR_EraseRootFromParent_Done,
     /* 1062374 */   // Label 15681: @1062374
     /* 1062374 */   GIM_Try, /*On fail goto*//*Label 15682*/ GIMT_Encode4(1062451), // Rule ID 21292 //
     /* 1062379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1062390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1062393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1062396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062418 */     // MIs[0] policy
     /* 1062418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062428 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1062431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062450 */     // GIR_Coverage, 21292,
     /* 1062450 */     GIR_EraseRootFromParent_Done,
     /* 1062451 */   // Label 15682: @1062451
     /* 1062451 */   GIM_Try, /*On fail goto*//*Label 15683*/ GIMT_Encode4(1062528), // Rule ID 21293 //
     /* 1062456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1062467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1062470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1062473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062495 */     // MIs[0] policy
     /* 1062495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062505 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1062508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062514 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062527 */     // GIR_Coverage, 21293,
     /* 1062527 */     GIR_EraseRootFromParent_Done,
     /* 1062528 */   // Label 15683: @1062528
     /* 1062528 */   GIM_Try, /*On fail goto*//*Label 15684*/ GIMT_Encode4(1062605), // Rule ID 21296 //
     /* 1062533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1062544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1062547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1062550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062572 */     // MIs[0] policy
     /* 1062572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062582 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1062585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062601 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062604 */     // GIR_Coverage, 21296,
     /* 1062604 */     GIR_EraseRootFromParent_Done,
     /* 1062605 */   // Label 15684: @1062605
     /* 1062605 */   GIM_Try, /*On fail goto*//*Label 15685*/ GIMT_Encode4(1062682), // Rule ID 21297 //
     /* 1062610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1062621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1062624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1062627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062649 */     // MIs[0] policy
     /* 1062649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062659 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1062662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062668 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062681 */     // GIR_Coverage, 21297,
     /* 1062681 */     GIR_EraseRootFromParent_Done,
     /* 1062682 */   // Label 15685: @1062682
     /* 1062682 */   GIM_Try, /*On fail goto*//*Label 15686*/ GIMT_Encode4(1062759), // Rule ID 21300 //
     /* 1062687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1062698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1062701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1062704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1062707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062726 */     // MIs[0] policy
     /* 1062726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062736 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1062739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062755 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062758 */     // GIR_Coverage, 21300,
     /* 1062758 */     GIR_EraseRootFromParent_Done,
     /* 1062759 */   // Label 15686: @1062759
     /* 1062759 */   GIM_Try, /*On fail goto*//*Label 15687*/ GIMT_Encode4(1062836), // Rule ID 21301 //
     /* 1062764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1062775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1062778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1062781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1062784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062803 */     // MIs[0] policy
     /* 1062803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062813 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1062816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062822 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062835 */     // GIR_Coverage, 21301,
     /* 1062835 */     GIR_EraseRootFromParent_Done,
     /* 1062836 */   // Label 15687: @1062836
     /* 1062836 */   GIM_Try, /*On fail goto*//*Label 15688*/ GIMT_Encode4(1062913), // Rule ID 21304 //
     /* 1062841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1062844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1062852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1062855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1062858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062880 */     // MIs[0] policy
     /* 1062880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1062893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062909 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062912 */     // GIR_Coverage, 21304,
     /* 1062912 */     GIR_EraseRootFromParent_Done,
     /* 1062913 */   // Label 15688: @1062913
     /* 1062913 */   GIM_Try, /*On fail goto*//*Label 15689*/ GIMT_Encode4(1062990), // Rule ID 21305 //
     /* 1062918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1062921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1062929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1062932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1062935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062957 */     // MIs[0] policy
     /* 1062957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062967 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1062970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062976 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062986 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062989 */     // GIR_Coverage, 21305,
     /* 1062989 */     GIR_EraseRootFromParent_Done,
     /* 1062990 */   // Label 15689: @1062990
     /* 1062990 */   GIM_Try, /*On fail goto*//*Label 15690*/ GIMT_Encode4(1063067), // Rule ID 21308 //
     /* 1062995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1062998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1063003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1063006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1063009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1063012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063034 */     // MIs[0] policy
     /* 1063034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063044 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1063047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063063 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063066 */     // GIR_Coverage, 21308,
     /* 1063066 */     GIR_EraseRootFromParent_Done,
     /* 1063067 */   // Label 15690: @1063067
     /* 1063067 */   GIM_Try, /*On fail goto*//*Label 15691*/ GIMT_Encode4(1063144), // Rule ID 21309 //
     /* 1063072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1063075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1063080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1063083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1063086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1063089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063111 */     // MIs[0] policy
     /* 1063111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1063124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063130 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063143 */     // GIR_Coverage, 21309,
     /* 1063143 */     GIR_EraseRootFromParent_Done,
     /* 1063144 */   // Label 15691: @1063144
     /* 1063144 */   GIM_Try, /*On fail goto*//*Label 15692*/ GIMT_Encode4(1063221), // Rule ID 21312 //
     /* 1063149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1063152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1063157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1063160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1063163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1063166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063188 */     // MIs[0] policy
     /* 1063188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063198 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1063201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063217 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063220 */     // GIR_Coverage, 21312,
     /* 1063220 */     GIR_EraseRootFromParent_Done,
     /* 1063221 */   // Label 15692: @1063221
     /* 1063221 */   GIM_Try, /*On fail goto*//*Label 15693*/ GIMT_Encode4(1063298), // Rule ID 21313 //
     /* 1063226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1063229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1063234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1063237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1063240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1063243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063265 */     // MIs[0] policy
     /* 1063265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063275 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1063278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063297 */     // GIR_Coverage, 21313,
     /* 1063297 */     GIR_EraseRootFromParent_Done,
     /* 1063298 */   // Label 15693: @1063298
     /* 1063298 */   GIM_Try, /*On fail goto*//*Label 15694*/ GIMT_Encode4(1063375), // Rule ID 21316 //
     /* 1063303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1063306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1063311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1063314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1063317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1063320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063342 */     // MIs[0] policy
     /* 1063342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063352 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1063355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063374 */     // GIR_Coverage, 21316,
     /* 1063374 */     GIR_EraseRootFromParent_Done,
     /* 1063375 */   // Label 15694: @1063375
     /* 1063375 */   GIM_Try, /*On fail goto*//*Label 15695*/ GIMT_Encode4(1063452), // Rule ID 21317 //
     /* 1063380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1063383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1063388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1063391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1063394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1063397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063419 */     // MIs[0] policy
     /* 1063419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063429 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1063432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063438 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063451 */     // GIR_Coverage, 21317,
     /* 1063451 */     GIR_EraseRootFromParent_Done,
     /* 1063452 */   // Label 15695: @1063452
     /* 1063452 */   GIM_Try, /*On fail goto*//*Label 15696*/ GIMT_Encode4(1063529), // Rule ID 21320 //
     /* 1063457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1063460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1063468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1063471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1063474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063496 */     // MIs[0] policy
     /* 1063496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063506 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1063509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063515 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063528 */     // GIR_Coverage, 21320,
     /* 1063528 */     GIR_EraseRootFromParent_Done,
     /* 1063529 */   // Label 15696: @1063529
     /* 1063529 */   GIM_Try, /*On fail goto*//*Label 15697*/ GIMT_Encode4(1063606), // Rule ID 21321 //
     /* 1063534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1063537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1063545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1063548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1063551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063573 */     // MIs[0] policy
     /* 1063573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063583 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1063586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063592 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063602 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063605 */     // GIR_Coverage, 21321,
     /* 1063605 */     GIR_EraseRootFromParent_Done,
     /* 1063606 */   // Label 15697: @1063606
     /* 1063606 */   GIM_Try, /*On fail goto*//*Label 15698*/ GIMT_Encode4(1063683), // Rule ID 21324 //
     /* 1063611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1063614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1063622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1063625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1063628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063650 */     // MIs[0] policy
     /* 1063650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063660 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1063663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063682 */     // GIR_Coverage, 21324,
     /* 1063682 */     GIR_EraseRootFromParent_Done,
     /* 1063683 */   // Label 15698: @1063683
     /* 1063683 */   GIM_Try, /*On fail goto*//*Label 15699*/ GIMT_Encode4(1063760), // Rule ID 21325 //
     /* 1063688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1063691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1063699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1063702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1063705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063727 */     // MIs[0] policy
     /* 1063727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063737 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1063740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063746 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063759 */     // GIR_Coverage, 21325,
     /* 1063759 */     GIR_EraseRootFromParent_Done,
     /* 1063760 */   // Label 15699: @1063760
     /* 1063760 */   GIM_Try, /*On fail goto*//*Label 15700*/ GIMT_Encode4(1063837), // Rule ID 21328 //
     /* 1063765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1063768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1063776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1063779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1063782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063804 */     // MIs[0] policy
     /* 1063804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063814 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1063817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063833 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063836 */     // GIR_Coverage, 21328,
     /* 1063836 */     GIR_EraseRootFromParent_Done,
     /* 1063837 */   // Label 15700: @1063837
     /* 1063837 */   GIM_Try, /*On fail goto*//*Label 15701*/ GIMT_Encode4(1063914), // Rule ID 21329 //
     /* 1063842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1063845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1063853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1063856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1063859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063881 */     // MIs[0] policy
     /* 1063881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063891 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1063894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063900 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063913 */     // GIR_Coverage, 21329,
     /* 1063913 */     GIR_EraseRootFromParent_Done,
     /* 1063914 */   // Label 15701: @1063914
     /* 1063914 */   GIM_Try, /*On fail goto*//*Label 15702*/ GIMT_Encode4(1063991), // Rule ID 21332 //
     /* 1063919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1063922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1063930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1063933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1063936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063958 */     // MIs[0] policy
     /* 1063958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063968 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1063971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063987 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063990 */     // GIR_Coverage, 21332,
     /* 1063990 */     GIR_EraseRootFromParent_Done,
     /* 1063991 */   // Label 15702: @1063991
     /* 1063991 */   GIM_Try, /*On fail goto*//*Label 15703*/ GIMT_Encode4(1064068), // Rule ID 21333 //
     /* 1063996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1063999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1064007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1064010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1064013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064035 */     // MIs[0] policy
     /* 1064035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064045 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1064048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064054 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1064064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064067 */     // GIR_Coverage, 21333,
     /* 1064067 */     GIR_EraseRootFromParent_Done,
     /* 1064068 */   // Label 15703: @1064068
     /* 1064068 */   GIM_Try, /*On fail goto*//*Label 15704*/ GIMT_Encode4(1064145), // Rule ID 21336 //
     /* 1064073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1064076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1064084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1064087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1064090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1064093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064112 */     // MIs[0] policy
     /* 1064112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064122 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1064125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064131 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1064141 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064144 */     // GIR_Coverage, 21336,
     /* 1064144 */     GIR_EraseRootFromParent_Done,
     /* 1064145 */   // Label 15704: @1064145
     /* 1064145 */   GIM_Try, /*On fail goto*//*Label 15705*/ GIMT_Encode4(1064222), // Rule ID 21337 //
     /* 1064150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1064153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1064161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1064164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1064167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1064170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064189 */     // MIs[0] policy
     /* 1064189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064199 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1064202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064208 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1064218 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064221 */     // GIR_Coverage, 21337,
     /* 1064221 */     GIR_EraseRootFromParent_Done,
     /* 1064222 */   // Label 15705: @1064222
     /* 1064222 */   GIM_Try, /*On fail goto*//*Label 15706*/ GIMT_Encode4(1064299), // Rule ID 21340 //
     /* 1064227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1064230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1064238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1064241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1064244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1064247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064266 */     // MIs[0] policy
     /* 1064266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064276 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1064279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1064295 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064298 */     // GIR_Coverage, 21340,
     /* 1064298 */     GIR_EraseRootFromParent_Done,
     /* 1064299 */   // Label 15706: @1064299
     /* 1064299 */   GIM_Try, /*On fail goto*//*Label 15707*/ GIMT_Encode4(1064376), // Rule ID 21341 //
     /* 1064304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1064307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1064315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1064318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1064321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1064324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064343 */     // MIs[0] policy
     /* 1064343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064353 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1064356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064362 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1064372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064375 */     // GIR_Coverage, 21341,
     /* 1064375 */     GIR_EraseRootFromParent_Done,
     /* 1064376 */   // Label 15707: @1064376
     /* 1064376 */   GIM_Try, /*On fail goto*//*Label 15708*/ GIMT_Encode4(1064453), // Rule ID 21344 //
     /* 1064381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1064384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1064392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1064395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1064398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064420 */     // MIs[0] policy
     /* 1064420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064430 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1064433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064452 */     // GIR_Coverage, 21344,
     /* 1064452 */     GIR_EraseRootFromParent_Done,
     /* 1064453 */   // Label 15708: @1064453
     /* 1064453 */   GIM_Try, /*On fail goto*//*Label 15709*/ GIMT_Encode4(1064530), // Rule ID 21345 //
     /* 1064458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1064461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1064469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1064472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1064475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064497 */     // MIs[0] policy
     /* 1064497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064507 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1064510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064529 */     // GIR_Coverage, 21345,
     /* 1064529 */     GIR_EraseRootFromParent_Done,
     /* 1064530 */   // Label 15709: @1064530
     /* 1064530 */   GIM_Try, /*On fail goto*//*Label 15710*/ GIMT_Encode4(1064607), // Rule ID 21348 //
     /* 1064535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1064538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1064546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1064549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1064552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064574 */     // MIs[0] policy
     /* 1064574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064584 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1064587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064606 */     // GIR_Coverage, 21348,
     /* 1064606 */     GIR_EraseRootFromParent_Done,
     /* 1064607 */   // Label 15710: @1064607
     /* 1064607 */   GIM_Try, /*On fail goto*//*Label 15711*/ GIMT_Encode4(1064684), // Rule ID 21349 //
     /* 1064612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1064615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1064623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1064626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1064629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064651 */     // MIs[0] policy
     /* 1064651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064661 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1064664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064670 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064683 */     // GIR_Coverage, 21349,
     /* 1064683 */     GIR_EraseRootFromParent_Done,
     /* 1064684 */   // Label 15711: @1064684
     /* 1064684 */   GIM_Try, /*On fail goto*//*Label 15712*/ GIMT_Encode4(1064761), // Rule ID 21352 //
     /* 1064689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1064692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1064700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1064703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1064706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064728 */     // MIs[0] policy
     /* 1064728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064738 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1064741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064760 */     // GIR_Coverage, 21352,
     /* 1064760 */     GIR_EraseRootFromParent_Done,
     /* 1064761 */   // Label 15712: @1064761
     /* 1064761 */   GIM_Try, /*On fail goto*//*Label 15713*/ GIMT_Encode4(1064838), // Rule ID 21353 //
     /* 1064766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1064769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1064777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1064780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1064783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064805 */     // MIs[0] policy
     /* 1064805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064815 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1064818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064824 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064837 */     // GIR_Coverage, 21353,
     /* 1064837 */     GIR_EraseRootFromParent_Done,
     /* 1064838 */   // Label 15713: @1064838
     /* 1064838 */   GIM_Try, /*On fail goto*//*Label 15714*/ GIMT_Encode4(1064915), // Rule ID 21356 //
     /* 1064843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1064846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1064854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1064857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1064860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064882 */     // MIs[0] policy
     /* 1064882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064892 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1064895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064914 */     // GIR_Coverage, 21356,
     /* 1064914 */     GIR_EraseRootFromParent_Done,
     /* 1064915 */   // Label 15714: @1064915
     /* 1064915 */   GIM_Try, /*On fail goto*//*Label 15715*/ GIMT_Encode4(1064992), // Rule ID 21357 //
     /* 1064920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1064923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1064931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1064934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1064937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064959 */     // MIs[0] policy
     /* 1064959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064969 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1064972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064978 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064988 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064991 */     // GIR_Coverage, 21357,
     /* 1064991 */     GIR_EraseRootFromParent_Done,
     /* 1064992 */   // Label 15715: @1064992
     /* 1064992 */   GIM_Try, /*On fail goto*//*Label 15716*/ GIMT_Encode4(1065069), // Rule ID 21360 //
     /* 1064997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1065000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1065008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1065011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1065014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1065017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065036 */     // MIs[0] policy
     /* 1065036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065046 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1065049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065068 */     // GIR_Coverage, 21360,
     /* 1065068 */     GIR_EraseRootFromParent_Done,
     /* 1065069 */   // Label 15716: @1065069
     /* 1065069 */   GIM_Try, /*On fail goto*//*Label 15717*/ GIMT_Encode4(1065146), // Rule ID 21361 //
     /* 1065074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1065077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1065085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1065088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1065091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1065094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065113 */     // MIs[0] policy
     /* 1065113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065123 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1065126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065132 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065145 */     // GIR_Coverage, 21361,
     /* 1065145 */     GIR_EraseRootFromParent_Done,
     /* 1065146 */   // Label 15717: @1065146
     /* 1065146 */   GIM_Try, /*On fail goto*//*Label 15718*/ GIMT_Encode4(1065223), // Rule ID 21364 //
     /* 1065151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1065154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1065162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1065165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1065168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065190 */     // MIs[0] policy
     /* 1065190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065200 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1065203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065222 */     // GIR_Coverage, 21364,
     /* 1065222 */     GIR_EraseRootFromParent_Done,
     /* 1065223 */   // Label 15718: @1065223
     /* 1065223 */   GIM_Try, /*On fail goto*//*Label 15719*/ GIMT_Encode4(1065300), // Rule ID 21365 //
     /* 1065228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1065231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1065239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1065242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1065245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065267 */     // MIs[0] policy
     /* 1065267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065277 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1065280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065286 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065299 */     // GIR_Coverage, 21365,
     /* 1065299 */     GIR_EraseRootFromParent_Done,
     /* 1065300 */   // Label 15719: @1065300
     /* 1065300 */   GIM_Try, /*On fail goto*//*Label 15720*/ GIMT_Encode4(1065377), // Rule ID 21368 //
     /* 1065305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1065308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1065322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065344 */     // MIs[0] policy
     /* 1065344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065354 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1065357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065363 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065373 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065376 */     // GIR_Coverage, 21368,
     /* 1065376 */     GIR_EraseRootFromParent_Done,
     /* 1065377 */   // Label 15720: @1065377
     /* 1065377 */   GIM_Try, /*On fail goto*//*Label 15721*/ GIMT_Encode4(1065454), // Rule ID 21369 //
     /* 1065382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1065385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1065399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065421 */     // MIs[0] policy
     /* 1065421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065431 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1065434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065440 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065450 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065453 */     // GIR_Coverage, 21369,
     /* 1065453 */     GIR_EraseRootFromParent_Done,
     /* 1065454 */   // Label 15721: @1065454
     /* 1065454 */   GIM_Try, /*On fail goto*//*Label 15722*/ GIMT_Encode4(1065531), // Rule ID 21372 //
     /* 1065459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1065462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1065476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065498 */     // MIs[0] policy
     /* 1065498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065508 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1065511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065527 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065530 */     // GIR_Coverage, 21372,
     /* 1065530 */     GIR_EraseRootFromParent_Done,
     /* 1065531 */   // Label 15722: @1065531
     /* 1065531 */   GIM_Try, /*On fail goto*//*Label 15723*/ GIMT_Encode4(1065608), // Rule ID 21373 //
     /* 1065536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1065539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1065553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065575 */     // MIs[0] policy
     /* 1065575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065585 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1065588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065594 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065604 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065607 */     // GIR_Coverage, 21373,
     /* 1065607 */     GIR_EraseRootFromParent_Done,
     /* 1065608 */   // Label 15723: @1065608
     /* 1065608 */   GIM_Try, /*On fail goto*//*Label 15724*/ GIMT_Encode4(1065685), // Rule ID 21376 //
     /* 1065613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1065616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1065624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1065627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1065630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065652 */     // MIs[0] policy
     /* 1065652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065662 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1065665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065681 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065684 */     // GIR_Coverage, 21376,
     /* 1065684 */     GIR_EraseRootFromParent_Done,
     /* 1065685 */   // Label 15724: @1065685
     /* 1065685 */   GIM_Try, /*On fail goto*//*Label 15725*/ GIMT_Encode4(1065762), // Rule ID 21377 //
     /* 1065690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1065693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1065701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1065704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1065707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065729 */     // MIs[0] policy
     /* 1065729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065739 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1065742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065748 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065761 */     // GIR_Coverage, 21377,
     /* 1065761 */     GIR_EraseRootFromParent_Done,
     /* 1065762 */   // Label 15725: @1065762
     /* 1065762 */   GIM_Try, /*On fail goto*//*Label 15726*/ GIMT_Encode4(1065839), // Rule ID 21380 //
     /* 1065767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1065775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1065778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1065781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1065784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065806 */     // MIs[0] policy
     /* 1065806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065816 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1065819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065838 */     // GIR_Coverage, 21380,
     /* 1065838 */     GIR_EraseRootFromParent_Done,
     /* 1065839 */   // Label 15726: @1065839
     /* 1065839 */   GIM_Try, /*On fail goto*//*Label 15727*/ GIMT_Encode4(1065916), // Rule ID 21381 //
     /* 1065844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1065847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1065852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1065855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1065858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1065861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065883 */     // MIs[0] policy
     /* 1065883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065893 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1065896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065902 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065915 */     // GIR_Coverage, 21381,
     /* 1065915 */     GIR_EraseRootFromParent_Done,
     /* 1065916 */   // Label 15727: @1065916
     /* 1065916 */   GIM_Try, /*On fail goto*//*Label 15728*/ GIMT_Encode4(1065993), // Rule ID 21384 //
     /* 1065921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1065929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1065932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1065935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1065938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065960 */     // MIs[0] policy
     /* 1065960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065970 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1065973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065989 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065992 */     // GIR_Coverage, 21384,
     /* 1065992 */     GIR_EraseRootFromParent_Done,
     /* 1065993 */   // Label 15728: @1065993
     /* 1065993 */   GIM_Try, /*On fail goto*//*Label 15729*/ GIMT_Encode4(1066070), // Rule ID 21385 //
     /* 1065998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1066009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1066012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1066015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066037 */     // MIs[0] policy
     /* 1066037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066047 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1066050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066056 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066069 */     // GIR_Coverage, 21385,
     /* 1066069 */     GIR_EraseRootFromParent_Done,
     /* 1066070 */   // Label 15729: @1066070
     /* 1066070 */   GIM_Try, /*On fail goto*//*Label 15730*/ GIMT_Encode4(1066147), // Rule ID 21388 //
     /* 1066075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1066086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1066089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1066092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066114 */     // MIs[0] policy
     /* 1066114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066124 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1066127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066146 */     // GIR_Coverage, 21388,
     /* 1066146 */     GIR_EraseRootFromParent_Done,
     /* 1066147 */   // Label 15730: @1066147
     /* 1066147 */   GIM_Try, /*On fail goto*//*Label 15731*/ GIMT_Encode4(1066224), // Rule ID 21389 //
     /* 1066152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1066163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1066166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1066169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066191 */     // MIs[0] policy
     /* 1066191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066201 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1066204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066210 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066223 */     // GIR_Coverage, 21389,
     /* 1066223 */     GIR_EraseRootFromParent_Done,
     /* 1066224 */   // Label 15731: @1066224
     /* 1066224 */   GIM_Try, /*On fail goto*//*Label 15732*/ GIMT_Encode4(1066301), // Rule ID 21392 //
     /* 1066229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1066240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1066243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1066246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066268 */     // MIs[0] policy
     /* 1066268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066278 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1066281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066300 */     // GIR_Coverage, 21392,
     /* 1066300 */     GIR_EraseRootFromParent_Done,
     /* 1066301 */   // Label 15732: @1066301
     /* 1066301 */   GIM_Try, /*On fail goto*//*Label 15733*/ GIMT_Encode4(1066378), // Rule ID 21393 //
     /* 1066306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1066317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1066320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1066323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066345 */     // MIs[0] policy
     /* 1066345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066355 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1066358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066377 */     // GIR_Coverage, 21393,
     /* 1066377 */     GIR_EraseRootFromParent_Done,
     /* 1066378 */   // Label 15733: @1066378
     /* 1066378 */   GIM_Try, /*On fail goto*//*Label 15734*/ GIMT_Encode4(1066455), // Rule ID 21396 //
     /* 1066383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1066394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1066397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1066400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066422 */     // MIs[0] policy
     /* 1066422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066432 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1066435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066454 */     // GIR_Coverage, 21396,
     /* 1066454 */     GIR_EraseRootFromParent_Done,
     /* 1066455 */   // Label 15734: @1066455
     /* 1066455 */   GIM_Try, /*On fail goto*//*Label 15735*/ GIMT_Encode4(1066532), // Rule ID 21397 //
     /* 1066460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1066471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1066474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1066477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066499 */     // MIs[0] policy
     /* 1066499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066509 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1066512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066518 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066531 */     // GIR_Coverage, 21397,
     /* 1066531 */     GIR_EraseRootFromParent_Done,
     /* 1066532 */   // Label 15735: @1066532
     /* 1066532 */   GIM_Try, /*On fail goto*//*Label 15736*/ GIMT_Encode4(1066609), // Rule ID 21400 //
     /* 1066537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1066548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1066551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1066554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1066557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1066564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066576 */     // MIs[0] policy
     /* 1066576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066586 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1066589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066605 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066608 */     // GIR_Coverage, 21400,
     /* 1066608 */     GIR_EraseRootFromParent_Done,
     /* 1066609 */   // Label 15736: @1066609
     /* 1066609 */   GIM_Try, /*On fail goto*//*Label 15737*/ GIMT_Encode4(1066686), // Rule ID 21401 //
     /* 1066614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1066625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1066628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1066631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1066634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1066641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066653 */     // MIs[0] policy
     /* 1066653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066663 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1066666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066672 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066682 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066685 */     // GIR_Coverage, 21401,
     /* 1066685 */     GIR_EraseRootFromParent_Done,
     /* 1066686 */   // Label 15737: @1066686
     /* 1066686 */   GIM_Try, /*On fail goto*//*Label 15738*/ GIMT_Encode4(1066763), // Rule ID 21404 //
     /* 1066691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1066702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1066705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1066708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066730 */     // MIs[0] policy
     /* 1066730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066740 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1066743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066759 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066762 */     // GIR_Coverage, 21404,
     /* 1066762 */     GIR_EraseRootFromParent_Done,
     /* 1066763 */   // Label 15738: @1066763
     /* 1066763 */   GIM_Try, /*On fail goto*//*Label 15739*/ GIMT_Encode4(1066840), // Rule ID 21405 //
     /* 1066768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1066779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1066782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1066785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066807 */     // MIs[0] policy
     /* 1066807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066817 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1066820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066826 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066836 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066839 */     // GIR_Coverage, 21405,
     /* 1066839 */     GIR_EraseRootFromParent_Done,
     /* 1066840 */   // Label 15739: @1066840
     /* 1066840 */   GIM_Try, /*On fail goto*//*Label 15740*/ GIMT_Encode4(1066917), // Rule ID 21408 //
     /* 1066845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1066856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1066859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1066862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066884 */     // MIs[0] policy
     /* 1066884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066894 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1066897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066916 */     // GIR_Coverage, 21408,
     /* 1066916 */     GIR_EraseRootFromParent_Done,
     /* 1066917 */   // Label 15740: @1066917
     /* 1066917 */   GIM_Try, /*On fail goto*//*Label 15741*/ GIMT_Encode4(1066994), // Rule ID 21409 //
     /* 1066922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1066933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1066936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1066939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066961 */     // MIs[0] policy
     /* 1066961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066971 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1066974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066980 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066993 */     // GIR_Coverage, 21409,
     /* 1066993 */     GIR_EraseRootFromParent_Done,
     /* 1066994 */   // Label 15741: @1066994
     /* 1066994 */   GIM_Try, /*On fail goto*//*Label 15742*/ GIMT_Encode4(1067071), // Rule ID 21412 //
     /* 1066999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1067010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1067013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1067016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067038 */     // MIs[0] policy
     /* 1067038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067048 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1067051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067070 */     // GIR_Coverage, 21412,
     /* 1067070 */     GIR_EraseRootFromParent_Done,
     /* 1067071 */   // Label 15742: @1067071
     /* 1067071 */   GIM_Try, /*On fail goto*//*Label 15743*/ GIMT_Encode4(1067148), // Rule ID 21413 //
     /* 1067076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1067087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1067090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1067093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067115 */     // MIs[0] policy
     /* 1067115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067125 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1067128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067134 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067147 */     // GIR_Coverage, 21413,
     /* 1067147 */     GIR_EraseRootFromParent_Done,
     /* 1067148 */   // Label 15743: @1067148
     /* 1067148 */   GIM_Try, /*On fail goto*//*Label 15744*/ GIMT_Encode4(1067225), // Rule ID 21416 //
     /* 1067153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1067164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1067167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1067170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067192 */     // MIs[0] policy
     /* 1067192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067202 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1067205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067221 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067224 */     // GIR_Coverage, 21416,
     /* 1067224 */     GIR_EraseRootFromParent_Done,
     /* 1067225 */   // Label 15744: @1067225
     /* 1067225 */   GIM_Try, /*On fail goto*//*Label 15745*/ GIMT_Encode4(1067302), // Rule ID 21417 //
     /* 1067230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1067241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1067244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1067247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067269 */     // MIs[0] policy
     /* 1067269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067279 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1067282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067301 */     // GIR_Coverage, 21417,
     /* 1067301 */     GIR_EraseRootFromParent_Done,
     /* 1067302 */   // Label 15745: @1067302
     /* 1067302 */   GIM_Try, /*On fail goto*//*Label 15746*/ GIMT_Encode4(1067379), // Rule ID 21420 //
     /* 1067307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1067318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1067321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1067324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1067327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1067334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067346 */     // MIs[0] policy
     /* 1067346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067356 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1067359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067378 */     // GIR_Coverage, 21420,
     /* 1067378 */     GIR_EraseRootFromParent_Done,
     /* 1067379 */   // Label 15746: @1067379
     /* 1067379 */   GIM_Try, /*On fail goto*//*Label 15747*/ GIMT_Encode4(1067456), // Rule ID 21421 //
     /* 1067384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1067395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1067398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1067401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1067404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1067411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067423 */     // MIs[0] policy
     /* 1067423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067433 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1067436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067442 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067455 */     // GIR_Coverage, 21421,
     /* 1067455 */     GIR_EraseRootFromParent_Done,
     /* 1067456 */   // Label 15747: @1067456
     /* 1067456 */   GIM_Try, /*On fail goto*//*Label 15748*/ GIMT_Encode4(1067533), // Rule ID 21424 //
     /* 1067461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1067472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1067475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1067478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067500 */     // MIs[0] policy
     /* 1067500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067510 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1067513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067529 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067532 */     // GIR_Coverage, 21424,
     /* 1067532 */     GIR_EraseRootFromParent_Done,
     /* 1067533 */   // Label 15748: @1067533
     /* 1067533 */   GIM_Try, /*On fail goto*//*Label 15749*/ GIMT_Encode4(1067610), // Rule ID 21425 //
     /* 1067538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1067549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1067552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1067555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067577 */     // MIs[0] policy
     /* 1067577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067587 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1067590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067609 */     // GIR_Coverage, 21425,
     /* 1067609 */     GIR_EraseRootFromParent_Done,
     /* 1067610 */   // Label 15749: @1067610
     /* 1067610 */   GIM_Try, /*On fail goto*//*Label 15750*/ GIMT_Encode4(1067687), // Rule ID 21428 //
     /* 1067615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1067626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1067629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1067632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067654 */     // MIs[0] policy
     /* 1067654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067664 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1067667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067683 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067686 */     // GIR_Coverage, 21428,
     /* 1067686 */     GIR_EraseRootFromParent_Done,
     /* 1067687 */   // Label 15750: @1067687
     /* 1067687 */   GIM_Try, /*On fail goto*//*Label 15751*/ GIMT_Encode4(1067764), // Rule ID 21429 //
     /* 1067692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1067703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1067706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1067709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067731 */     // MIs[0] policy
     /* 1067731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067741 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1067744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067750 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067763 */     // GIR_Coverage, 21429,
     /* 1067763 */     GIR_EraseRootFromParent_Done,
     /* 1067764 */   // Label 15751: @1067764
     /* 1067764 */   GIM_Try, /*On fail goto*//*Label 15752*/ GIMT_Encode4(1067841), // Rule ID 21432 //
     /* 1067769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1067780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1067783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1067786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067808 */     // MIs[0] policy
     /* 1067808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067818 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1067821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067840 */     // GIR_Coverage, 21432,
     /* 1067840 */     GIR_EraseRootFromParent_Done,
     /* 1067841 */   // Label 15752: @1067841
     /* 1067841 */   GIM_Try, /*On fail goto*//*Label 15753*/ GIMT_Encode4(1067918), // Rule ID 21433 //
     /* 1067846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1067857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1067860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1067863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067885 */     // MIs[0] policy
     /* 1067885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067895 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1067898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067904 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067917 */     // GIR_Coverage, 21433,
     /* 1067917 */     GIR_EraseRootFromParent_Done,
     /* 1067918 */   // Label 15753: @1067918
     /* 1067918 */   GIM_Try, /*On fail goto*//*Label 15754*/ GIMT_Encode4(1067995), // Rule ID 21436 //
     /* 1067923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1067934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1067937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1067940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1067950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067962 */     // MIs[0] policy
     /* 1067962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067972 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1067975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067991 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067994 */     // GIR_Coverage, 21436,
     /* 1067994 */     GIR_EraseRootFromParent_Done,
     /* 1067995 */   // Label 15754: @1067995
     /* 1067995 */   GIM_Try, /*On fail goto*//*Label 15755*/ GIMT_Encode4(1068072), // Rule ID 21437 //
     /* 1068000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1068003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1068008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1068011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1068014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1068017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1068027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068039 */     // MIs[0] policy
     /* 1068039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068049 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1068052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068058 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068068 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068071 */     // GIR_Coverage, 21437,
     /* 1068071 */     GIR_EraseRootFromParent_Done,
     /* 1068072 */   // Label 15755: @1068072
     /* 1068072 */   GIM_Try, /*On fail goto*//*Label 15756*/ GIMT_Encode4(1068149), // Rule ID 21440 //
     /* 1068077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1068080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1068088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1068091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1068094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068116 */     // MIs[0] policy
     /* 1068116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068126 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1068129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068145 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068148 */     // GIR_Coverage, 21440,
     /* 1068148 */     GIR_EraseRootFromParent_Done,
     /* 1068149 */   // Label 15756: @1068149
     /* 1068149 */   GIM_Try, /*On fail goto*//*Label 15757*/ GIMT_Encode4(1068226), // Rule ID 21441 //
     /* 1068154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1068157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1068165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1068168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1068171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068193 */     // MIs[0] policy
     /* 1068193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068203 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1068206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068225 */     // GIR_Coverage, 21441,
     /* 1068225 */     GIR_EraseRootFromParent_Done,
     /* 1068226 */   // Label 15757: @1068226
     /* 1068226 */   GIM_Try, /*On fail goto*//*Label 15758*/ GIMT_Encode4(1068303), // Rule ID 21444 //
     /* 1068231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1068234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1068242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1068245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1068248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068270 */     // MIs[0] policy
     /* 1068270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068280 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1068283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068302 */     // GIR_Coverage, 21444,
     /* 1068302 */     GIR_EraseRootFromParent_Done,
     /* 1068303 */   // Label 15758: @1068303
     /* 1068303 */   GIM_Try, /*On fail goto*//*Label 15759*/ GIMT_Encode4(1068380), // Rule ID 21445 //
     /* 1068308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1068311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1068319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1068322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1068325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068347 */     // MIs[0] policy
     /* 1068347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068357 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1068360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068379 */     // GIR_Coverage, 21445,
     /* 1068379 */     GIR_EraseRootFromParent_Done,
     /* 1068380 */   // Label 15759: @1068380
     /* 1068380 */   GIM_Try, /*On fail goto*//*Label 15760*/ GIMT_Encode4(1068457), // Rule ID 21448 //
     /* 1068385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1068388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1068396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1068399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1068402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068424 */     // MIs[0] policy
     /* 1068424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068434 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1068437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068456 */     // GIR_Coverage, 21448,
     /* 1068456 */     GIR_EraseRootFromParent_Done,
     /* 1068457 */   // Label 15760: @1068457
     /* 1068457 */   GIM_Try, /*On fail goto*//*Label 15761*/ GIMT_Encode4(1068534), // Rule ID 21449 //
     /* 1068462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1068465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1068473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1068476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1068479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068501 */     // MIs[0] policy
     /* 1068501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068511 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1068514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068520 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068530 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068533 */     // GIR_Coverage, 21449,
     /* 1068533 */     GIR_EraseRootFromParent_Done,
     /* 1068534 */   // Label 15761: @1068534
     /* 1068534 */   GIM_Try, /*On fail goto*//*Label 15762*/ GIMT_Encode4(1068611), // Rule ID 21452 //
     /* 1068539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1068542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1068550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1068553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1068556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068578 */     // MIs[0] policy
     /* 1068578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068588 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1068591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068610 */     // GIR_Coverage, 21452,
     /* 1068610 */     GIR_EraseRootFromParent_Done,
     /* 1068611 */   // Label 15762: @1068611
     /* 1068611 */   GIM_Try, /*On fail goto*//*Label 15763*/ GIMT_Encode4(1068688), // Rule ID 21453 //
     /* 1068616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1068619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1068627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1068630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1068633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068655 */     // MIs[0] policy
     /* 1068655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068665 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1068668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068687 */     // GIR_Coverage, 21453,
     /* 1068687 */     GIR_EraseRootFromParent_Done,
     /* 1068688 */   // Label 15763: @1068688
     /* 1068688 */   GIM_Try, /*On fail goto*//*Label 15764*/ GIMT_Encode4(1068765), // Rule ID 21456 //
     /* 1068693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1068696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1068704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1068707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1068710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1068713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1068720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068732 */     // MIs[0] policy
     /* 1068732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068742 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1068745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068764 */     // GIR_Coverage, 21456,
     /* 1068764 */     GIR_EraseRootFromParent_Done,
     /* 1068765 */   // Label 15764: @1068765
     /* 1068765 */   GIM_Try, /*On fail goto*//*Label 15765*/ GIMT_Encode4(1068842), // Rule ID 21457 //
     /* 1068770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1068773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1068781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1068784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1068787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1068790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1068797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068809 */     // MIs[0] policy
     /* 1068809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068819 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1068822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068828 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068841 */     // GIR_Coverage, 21457,
     /* 1068841 */     GIR_EraseRootFromParent_Done,
     /* 1068842 */   // Label 15765: @1068842
     /* 1068842 */   GIM_Try, /*On fail goto*//*Label 15766*/ GIMT_Encode4(1068919), // Rule ID 21460 //
     /* 1068847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1068850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1068858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1068861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1068864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068886 */     // MIs[0] policy
     /* 1068886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068896 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1068899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068918 */     // GIR_Coverage, 21460,
     /* 1068918 */     GIR_EraseRootFromParent_Done,
     /* 1068919 */   // Label 15766: @1068919
     /* 1068919 */   GIM_Try, /*On fail goto*//*Label 15767*/ GIMT_Encode4(1068996), // Rule ID 21461 //
     /* 1068924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1068927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1068935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1068938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1068941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068963 */     // MIs[0] policy
     /* 1068963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068973 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1068976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068982 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068995 */     // GIR_Coverage, 21461,
     /* 1068995 */     GIR_EraseRootFromParent_Done,
     /* 1068996 */   // Label 15767: @1068996
     /* 1068996 */   GIM_Try, /*On fail goto*//*Label 15768*/ GIMT_Encode4(1069073), // Rule ID 21464 //
     /* 1069001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1069004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1069009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1069012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1069015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069040 */     // MIs[0] policy
     /* 1069040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069050 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1069053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069069 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069072 */     // GIR_Coverage, 21464,
     /* 1069072 */     GIR_EraseRootFromParent_Done,
     /* 1069073 */   // Label 15768: @1069073
     /* 1069073 */   GIM_Try, /*On fail goto*//*Label 15769*/ GIMT_Encode4(1069150), // Rule ID 21465 //
     /* 1069078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1069081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1069086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1069089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1069092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069117 */     // MIs[0] policy
     /* 1069117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069127 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1069130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069136 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069146 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069149 */     // GIR_Coverage, 21465,
     /* 1069149 */     GIR_EraseRootFromParent_Done,
     /* 1069150 */   // Label 15769: @1069150
     /* 1069150 */   GIM_Try, /*On fail goto*//*Label 15770*/ GIMT_Encode4(1069227), // Rule ID 21468 //
     /* 1069155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1069158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1069163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1069166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1069169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1069172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069194 */     // MIs[0] policy
     /* 1069194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069204 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1069207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069223 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069226 */     // GIR_Coverage, 21468,
     /* 1069226 */     GIR_EraseRootFromParent_Done,
     /* 1069227 */   // Label 15770: @1069227
     /* 1069227 */   GIM_Try, /*On fail goto*//*Label 15771*/ GIMT_Encode4(1069304), // Rule ID 21469 //
     /* 1069232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1069235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1069240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1069243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1069246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1069249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069271 */     // MIs[0] policy
     /* 1069271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069281 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1069284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069290 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069303 */     // GIR_Coverage, 21469,
     /* 1069303 */     GIR_EraseRootFromParent_Done,
     /* 1069304 */   // Label 15771: @1069304
     /* 1069304 */   GIM_Try, /*On fail goto*//*Label 15772*/ GIMT_Encode4(1069381), // Rule ID 21472 //
     /* 1069309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1069312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1069317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1069320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1069323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1069326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1069336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069348 */     // MIs[0] policy
     /* 1069348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069358 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1069361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069377 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069380 */     // GIR_Coverage, 21472,
     /* 1069380 */     GIR_EraseRootFromParent_Done,
     /* 1069381 */   // Label 15772: @1069381
     /* 1069381 */   GIM_Try, /*On fail goto*//*Label 15773*/ GIMT_Encode4(1069458), // Rule ID 21473 //
     /* 1069386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1069389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1069394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1069397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1069400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1069403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1069413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069425 */     // MIs[0] policy
     /* 1069425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069435 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1069438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069457 */     // GIR_Coverage, 21473,
     /* 1069457 */     GIR_EraseRootFromParent_Done,
     /* 1069458 */   // Label 15773: @1069458
     /* 1069458 */   GIM_Try, /*On fail goto*//*Label 15774*/ GIMT_Encode4(1069535), // Rule ID 21716 //
     /* 1069463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1069466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1069474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1069477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1069480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069502 */     // MIs[0] policy
     /* 1069502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069512 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1069515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069534 */     // GIR_Coverage, 21716,
     /* 1069534 */     GIR_EraseRootFromParent_Done,
     /* 1069535 */   // Label 15774: @1069535
     /* 1069535 */   GIM_Try, /*On fail goto*//*Label 15775*/ GIMT_Encode4(1069612), // Rule ID 21717 //
     /* 1069540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1069543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1069551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1069554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1069557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069579 */     // MIs[0] policy
     /* 1069579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069589 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1069592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069598 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069611 */     // GIR_Coverage, 21717,
     /* 1069611 */     GIR_EraseRootFromParent_Done,
     /* 1069612 */   // Label 15775: @1069612
     /* 1069612 */   GIM_Try, /*On fail goto*//*Label 15776*/ GIMT_Encode4(1069689), // Rule ID 21720 //
     /* 1069617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1069620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1069628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1069631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1069634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069656 */     // MIs[0] policy
     /* 1069656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069666 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1069669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069688 */     // GIR_Coverage, 21720,
     /* 1069688 */     GIR_EraseRootFromParent_Done,
     /* 1069689 */   // Label 15776: @1069689
     /* 1069689 */   GIM_Try, /*On fail goto*//*Label 15777*/ GIMT_Encode4(1069766), // Rule ID 21721 //
     /* 1069694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1069697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1069705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1069708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1069711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069733 */     // MIs[0] policy
     /* 1069733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069743 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1069746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069752 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069765 */     // GIR_Coverage, 21721,
     /* 1069765 */     GIR_EraseRootFromParent_Done,
     /* 1069766 */   // Label 15777: @1069766
     /* 1069766 */   GIM_Try, /*On fail goto*//*Label 15778*/ GIMT_Encode4(1069843), // Rule ID 21724 //
     /* 1069771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1069774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1069782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1069785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1069788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069810 */     // MIs[0] policy
     /* 1069810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069820 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1069823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069839 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069842 */     // GIR_Coverage, 21724,
     /* 1069842 */     GIR_EraseRootFromParent_Done,
     /* 1069843 */   // Label 15778: @1069843
     /* 1069843 */   GIM_Try, /*On fail goto*//*Label 15779*/ GIMT_Encode4(1069920), // Rule ID 21725 //
     /* 1069848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1069851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1069859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1069862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1069865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069887 */     // MIs[0] policy
     /* 1069887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069897 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1069900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069906 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069916 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069919 */     // GIR_Coverage, 21725,
     /* 1069919 */     GIR_EraseRootFromParent_Done,
     /* 1069920 */   // Label 15779: @1069920
     /* 1069920 */   GIM_Try, /*On fail goto*//*Label 15780*/ GIMT_Encode4(1069997), // Rule ID 21728 //
     /* 1069925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1069928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1069936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1069939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1069942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069964 */     // MIs[0] policy
     /* 1069964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1069977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069993 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069996 */     // GIR_Coverage, 21728,
     /* 1069996 */     GIR_EraseRootFromParent_Done,
     /* 1069997 */   // Label 15780: @1069997
     /* 1069997 */   GIM_Try, /*On fail goto*//*Label 15781*/ GIMT_Encode4(1070074), // Rule ID 21729 //
     /* 1070002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1070005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1070013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1070016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1070019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070041 */     // MIs[0] policy
     /* 1070041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070051 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11211:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1070054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070060 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070070 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070073 */     // GIR_Coverage, 21729,
     /* 1070073 */     GIR_EraseRootFromParent_Done,
     /* 1070074 */   // Label 15781: @1070074
     /* 1070074 */   GIM_Try, /*On fail goto*//*Label 15782*/ GIMT_Encode4(1070151), // Rule ID 21732 //
     /* 1070079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1070082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1070090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1070093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1070096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1070099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070118 */     // MIs[0] policy
     /* 1070118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070128 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1070131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070147 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070150 */     // GIR_Coverage, 21732,
     /* 1070150 */     GIR_EraseRootFromParent_Done,
     /* 1070151 */   // Label 15782: @1070151
     /* 1070151 */   GIM_Try, /*On fail goto*//*Label 15783*/ GIMT_Encode4(1070228), // Rule ID 21733 //
     /* 1070156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1070159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1070167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1070170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1070173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1070176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070195 */     // MIs[0] policy
     /* 1070195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070205 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1070208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070214 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070227 */     // GIR_Coverage, 21733,
     /* 1070227 */     GIR_EraseRootFromParent_Done,
     /* 1070228 */   // Label 15783: @1070228
     /* 1070228 */   GIM_Try, /*On fail goto*//*Label 15784*/ GIMT_Encode4(1070305), // Rule ID 21736 //
     /* 1070233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1070236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1070244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1070247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1070250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1070253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070272 */     // MIs[0] policy
     /* 1070272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070282 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1070285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070301 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070304 */     // GIR_Coverage, 21736,
     /* 1070304 */     GIR_EraseRootFromParent_Done,
     /* 1070305 */   // Label 15784: @1070305
     /* 1070305 */   GIM_Try, /*On fail goto*//*Label 15785*/ GIMT_Encode4(1070382), // Rule ID 21737 //
     /* 1070310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1070313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1070321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1070324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1070327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1070330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070349 */     // MIs[0] policy
     /* 1070349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070359 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1070362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070368 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070381 */     // GIR_Coverage, 21737,
     /* 1070381 */     GIR_EraseRootFromParent_Done,
     /* 1070382 */   // Label 15785: @1070382
     /* 1070382 */   GIM_Try, /*On fail goto*//*Label 15786*/ GIMT_Encode4(1070459), // Rule ID 21740 //
     /* 1070387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1070390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1070398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1070401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1070404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070426 */     // MIs[0] policy
     /* 1070426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070436 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1070439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070455 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070458 */     // GIR_Coverage, 21740,
     /* 1070458 */     GIR_EraseRootFromParent_Done,
     /* 1070459 */   // Label 15786: @1070459
     /* 1070459 */   GIM_Try, /*On fail goto*//*Label 15787*/ GIMT_Encode4(1070536), // Rule ID 21741 //
     /* 1070464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1070467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1070475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1070478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1070481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070503 */     // MIs[0] policy
     /* 1070503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070513 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1070516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070522 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070535 */     // GIR_Coverage, 21741,
     /* 1070535 */     GIR_EraseRootFromParent_Done,
     /* 1070536 */   // Label 15787: @1070536
     /* 1070536 */   GIM_Try, /*On fail goto*//*Label 15788*/ GIMT_Encode4(1070613), // Rule ID 21744 //
     /* 1070541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1070544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1070552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1070555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070580 */     // MIs[0] policy
     /* 1070580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070590 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1070593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070612 */     // GIR_Coverage, 21744,
     /* 1070612 */     GIR_EraseRootFromParent_Done,
     /* 1070613 */   // Label 15788: @1070613
     /* 1070613 */   GIM_Try, /*On fail goto*//*Label 15789*/ GIMT_Encode4(1070690), // Rule ID 21745 //
     /* 1070618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1070621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1070629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1070632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070657 */     // MIs[0] policy
     /* 1070657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070667 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1070670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070676 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070689 */     // GIR_Coverage, 21745,
     /* 1070689 */     GIR_EraseRootFromParent_Done,
     /* 1070690 */   // Label 15789: @1070690
     /* 1070690 */   GIM_Try, /*On fail goto*//*Label 15790*/ GIMT_Encode4(1070767), // Rule ID 21748 //
     /* 1070695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1070698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1070706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1070709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1070712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070734 */     // MIs[0] policy
     /* 1070734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070744 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1070747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070763 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070766 */     // GIR_Coverage, 21748,
     /* 1070766 */     GIR_EraseRootFromParent_Done,
     /* 1070767 */   // Label 15790: @1070767
     /* 1070767 */   GIM_Try, /*On fail goto*//*Label 15791*/ GIMT_Encode4(1070844), // Rule ID 21749 //
     /* 1070772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1070775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1070783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1070786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1070789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070811 */     // MIs[0] policy
     /* 1070811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070821 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1070824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070830 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070843 */     // GIR_Coverage, 21749,
     /* 1070843 */     GIR_EraseRootFromParent_Done,
     /* 1070844 */   // Label 15791: @1070844
     /* 1070844 */   GIM_Try, /*On fail goto*//*Label 15792*/ GIMT_Encode4(1070921), // Rule ID 21752 //
     /* 1070849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1070852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1070860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1070863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1070866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070888 */     // MIs[0] policy
     /* 1070888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070898 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1070901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070917 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070920 */     // GIR_Coverage, 21752,
     /* 1070920 */     GIR_EraseRootFromParent_Done,
     /* 1070921 */   // Label 15792: @1070921
     /* 1070921 */   GIM_Try, /*On fail goto*//*Label 15793*/ GIMT_Encode4(1070998), // Rule ID 21753 //
     /* 1070926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1070929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1070937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1070940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1070943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070965 */     // MIs[0] policy
     /* 1070965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1070978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070984 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070994 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070997 */     // GIR_Coverage, 21753,
     /* 1070997 */     GIR_EraseRootFromParent_Done,
     /* 1070998 */   // Label 15793: @1070998
     /* 1070998 */   GIM_Try, /*On fail goto*//*Label 15794*/ GIMT_Encode4(1071075), // Rule ID 21756 //
     /* 1071003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1071006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1071014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1071017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1071020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1071023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071042 */     // MIs[0] policy
     /* 1071042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071052 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1071055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071071 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071074 */     // GIR_Coverage, 21756,
     /* 1071074 */     GIR_EraseRootFromParent_Done,
     /* 1071075 */   // Label 15794: @1071075
     /* 1071075 */   GIM_Try, /*On fail goto*//*Label 15795*/ GIMT_Encode4(1071152), // Rule ID 21757 //
     /* 1071080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1071083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1071091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1071094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1071097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1071100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071119 */     // MIs[0] policy
     /* 1071119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071129 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1071132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071151 */     // GIR_Coverage, 21757,
     /* 1071151 */     GIR_EraseRootFromParent_Done,
     /* 1071152 */   // Label 15795: @1071152
     /* 1071152 */   GIM_Try, /*On fail goto*//*Label 15796*/ GIMT_Encode4(1071229), // Rule ID 21760 //
     /* 1071157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1071160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1071174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071196 */     // MIs[0] policy
     /* 1071196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071206 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1071209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071228 */     // GIR_Coverage, 21760,
     /* 1071228 */     GIR_EraseRootFromParent_Done,
     /* 1071229 */   // Label 15796: @1071229
     /* 1071229 */   GIM_Try, /*On fail goto*//*Label 15797*/ GIMT_Encode4(1071306), // Rule ID 21761 //
     /* 1071234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1071237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1071251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071273 */     // MIs[0] policy
     /* 1071273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071283 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1071286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071305 */     // GIR_Coverage, 21761,
     /* 1071305 */     GIR_EraseRootFromParent_Done,
     /* 1071306 */   // Label 15797: @1071306
     /* 1071306 */   GIM_Try, /*On fail goto*//*Label 15798*/ GIMT_Encode4(1071383), // Rule ID 21764 //
     /* 1071311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1071314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1071322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1071325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1071328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071350 */     // MIs[0] policy
     /* 1071350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071360 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1071363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071379 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071382 */     // GIR_Coverage, 21764,
     /* 1071382 */     GIR_EraseRootFromParent_Done,
     /* 1071383 */   // Label 15798: @1071383
     /* 1071383 */   GIM_Try, /*On fail goto*//*Label 15799*/ GIMT_Encode4(1071460), // Rule ID 21765 //
     /* 1071388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1071391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1071399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1071402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1071405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071427 */     // MIs[0] policy
     /* 1071427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071437 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1071440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071446 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071459 */     // GIR_Coverage, 21765,
     /* 1071459 */     GIR_EraseRootFromParent_Done,
     /* 1071460 */   // Label 15799: @1071460
     /* 1071460 */   GIM_Try, /*On fail goto*//*Label 15800*/ GIMT_Encode4(1071537), // Rule ID 21768 //
     /* 1071465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1071468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1071482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071504 */     // MIs[0] policy
     /* 1071504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071514 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1071517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071533 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071536 */     // GIR_Coverage, 21768,
     /* 1071536 */     GIR_EraseRootFromParent_Done,
     /* 1071537 */   // Label 15800: @1071537
     /* 1071537 */   GIM_Try, /*On fail goto*//*Label 15801*/ GIMT_Encode4(1071614), // Rule ID 21769 //
     /* 1071542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1071545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1071559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071581 */     // MIs[0] policy
     /* 1071581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071591 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1071594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071600 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071610 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071613 */     // GIR_Coverage, 21769,
     /* 1071613 */     GIR_EraseRootFromParent_Done,
     /* 1071614 */   // Label 15801: @1071614
     /* 1071614 */   GIM_Try, /*On fail goto*//*Label 15802*/ GIMT_Encode4(1071691), // Rule ID 21772 //
     /* 1071619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1071622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1071630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1071633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1071636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071658 */     // MIs[0] policy
     /* 1071658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1071671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071687 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071690 */     // GIR_Coverage, 21772,
     /* 1071690 */     GIR_EraseRootFromParent_Done,
     /* 1071691 */   // Label 15802: @1071691
     /* 1071691 */   GIM_Try, /*On fail goto*//*Label 15803*/ GIMT_Encode4(1071768), // Rule ID 21773 //
     /* 1071696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1071699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1071707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1071710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1071713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071735 */     // MIs[0] policy
     /* 1071735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071745 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1071748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071754 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071764 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071767 */     // GIR_Coverage, 21773,
     /* 1071767 */     GIR_EraseRootFromParent_Done,
     /* 1071768 */   // Label 15803: @1071768
     /* 1071768 */   GIM_Try, /*On fail goto*//*Label 15804*/ GIMT_Encode4(1071845), // Rule ID 21776 //
     /* 1071773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1071776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1071781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1071784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1071787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1071790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071812 */     // MIs[0] policy
     /* 1071812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071822 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1071825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071841 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071844 */     // GIR_Coverage, 21776,
     /* 1071844 */     GIR_EraseRootFromParent_Done,
     /* 1071845 */   // Label 15804: @1071845
     /* 1071845 */   GIM_Try, /*On fail goto*//*Label 15805*/ GIMT_Encode4(1071922), // Rule ID 21777 //
     /* 1071850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1071853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1071858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1071861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1071864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1071867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071889 */     // MIs[0] policy
     /* 1071889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071899 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1071902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071921 */     // GIR_Coverage, 21777,
     /* 1071921 */     GIR_EraseRootFromParent_Done,
     /* 1071922 */   // Label 15805: @1071922
     /* 1071922 */   GIM_Try, /*On fail goto*//*Label 15806*/ GIMT_Encode4(1071999), // Rule ID 21780 //
     /* 1071927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1071930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1071935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1071938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1071941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1071944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071966 */     // MIs[0] policy
     /* 1071966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071976 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1071979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071998 */     // GIR_Coverage, 21780,
     /* 1071998 */     GIR_EraseRootFromParent_Done,
     /* 1071999 */   // Label 15806: @1071999
     /* 1071999 */   GIM_Try, /*On fail goto*//*Label 15807*/ GIMT_Encode4(1072076), // Rule ID 21781 //
     /* 1072004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1072007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1072015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1072018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1072021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072043 */     // MIs[0] policy
     /* 1072043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072053 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1072056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072062 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072075 */     // GIR_Coverage, 21781,
     /* 1072075 */     GIR_EraseRootFromParent_Done,
     /* 1072076 */   // Label 15807: @1072076
     /* 1072076 */   GIM_Try, /*On fail goto*//*Label 15808*/ GIMT_Encode4(1072153), // Rule ID 21784 //
     /* 1072081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1072084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1072092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1072095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1072098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072120 */     // MIs[0] policy
     /* 1072120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072130 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1072133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072152 */     // GIR_Coverage, 21784,
     /* 1072152 */     GIR_EraseRootFromParent_Done,
     /* 1072153 */   // Label 15808: @1072153
     /* 1072153 */   GIM_Try, /*On fail goto*//*Label 15809*/ GIMT_Encode4(1072230), // Rule ID 21785 //
     /* 1072158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1072161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1072169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1072172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1072175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072197 */     // MIs[0] policy
     /* 1072197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072207 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1072210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072229 */     // GIR_Coverage, 21785,
     /* 1072229 */     GIR_EraseRootFromParent_Done,
     /* 1072230 */   // Label 15809: @1072230
     /* 1072230 */   GIM_Try, /*On fail goto*//*Label 15810*/ GIMT_Encode4(1072307), // Rule ID 21788 //
     /* 1072235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1072238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1072246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1072249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1072252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072274 */     // MIs[0] policy
     /* 1072274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072284 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1072287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072306 */     // GIR_Coverage, 21788,
     /* 1072306 */     GIR_EraseRootFromParent_Done,
     /* 1072307 */   // Label 15810: @1072307
     /* 1072307 */   GIM_Try, /*On fail goto*//*Label 15811*/ GIMT_Encode4(1072384), // Rule ID 21789 //
     /* 1072312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1072315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1072323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1072326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1072329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072351 */     // MIs[0] policy
     /* 1072351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072361 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1072364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072370 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072380 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072383 */     // GIR_Coverage, 21789,
     /* 1072383 */     GIR_EraseRootFromParent_Done,
     /* 1072384 */   // Label 15811: @1072384
     /* 1072384 */   GIM_Try, /*On fail goto*//*Label 15812*/ GIMT_Encode4(1072461), // Rule ID 21792 //
     /* 1072389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1072392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1072400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1072403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1072406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1072409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1072416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072428 */     // MIs[0] policy
     /* 1072428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072438 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1072441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072457 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072460 */     // GIR_Coverage, 21792,
     /* 1072460 */     GIR_EraseRootFromParent_Done,
     /* 1072461 */   // Label 15812: @1072461
     /* 1072461 */   GIM_Try, /*On fail goto*//*Label 15813*/ GIMT_Encode4(1072538), // Rule ID 21793 //
     /* 1072466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1072469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1072477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1072480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1072483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1072486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1072493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072505 */     // MIs[0] policy
     /* 1072505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072515 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1072518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072537 */     // GIR_Coverage, 21793,
     /* 1072537 */     GIR_EraseRootFromParent_Done,
     /* 1072538 */   // Label 15813: @1072538
     /* 1072538 */   GIM_Try, /*On fail goto*//*Label 15814*/ GIMT_Encode4(1072615), // Rule ID 21796 //
     /* 1072543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1072546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1072554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1072557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1072560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1072563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1072570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072582 */     // MIs[0] policy
     /* 1072582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072592 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1072595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072614 */     // GIR_Coverage, 21796,
     /* 1072614 */     GIR_EraseRootFromParent_Done,
     /* 1072615 */   // Label 15814: @1072615
     /* 1072615 */   GIM_Try, /*On fail goto*//*Label 15815*/ GIMT_Encode4(1072692), // Rule ID 21797 //
     /* 1072620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1072623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1072631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1072634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1072637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1072640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1072647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072659 */     // MIs[0] policy
     /* 1072659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072669 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1072672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072678 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072691 */     // GIR_Coverage, 21797,
     /* 1072691 */     GIR_EraseRootFromParent_Done,
     /* 1072692 */   // Label 15815: @1072692
     /* 1072692 */   GIM_Try, /*On fail goto*//*Label 15816*/ GIMT_Encode4(1072769), // Rule ID 21800 //
     /* 1072697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1072700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1072708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1072711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1072714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072736 */     // MIs[0] policy
     /* 1072736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1072749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072765 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072768 */     // GIR_Coverage, 21800,
     /* 1072768 */     GIR_EraseRootFromParent_Done,
     /* 1072769 */   // Label 15816: @1072769
     /* 1072769 */   GIM_Try, /*On fail goto*//*Label 15817*/ GIMT_Encode4(1072846), // Rule ID 21801 //
     /* 1072774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1072777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1072785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1072788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1072791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072813 */     // MIs[0] policy
     /* 1072813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072823 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1072826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072832 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072842 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072845 */     // GIR_Coverage, 21801,
     /* 1072845 */     GIR_EraseRootFromParent_Done,
     /* 1072846 */   // Label 15817: @1072846
     /* 1072846 */   GIM_Try, /*On fail goto*//*Label 15818*/ GIMT_Encode4(1072923), // Rule ID 21804 //
     /* 1072851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1072854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1072862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1072865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1072868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072890 */     // MIs[0] policy
     /* 1072890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072900 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1072903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072919 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072922 */     // GIR_Coverage, 21804,
     /* 1072922 */     GIR_EraseRootFromParent_Done,
     /* 1072923 */   // Label 15818: @1072923
     /* 1072923 */   GIM_Try, /*On fail goto*//*Label 15819*/ GIMT_Encode4(1073000), // Rule ID 21805 //
     /* 1072928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1072931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1072939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1072942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1072945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072967 */     // MIs[0] policy
     /* 1072967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072977 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1072980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072986 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072996 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072999 */     // GIR_Coverage, 21805,
     /* 1072999 */     GIR_EraseRootFromParent_Done,
     /* 1073000 */   // Label 15819: @1073000
     /* 1073000 */   GIM_Try, /*On fail goto*//*Label 15820*/ GIMT_Encode4(1073077), // Rule ID 21808 //
     /* 1073005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1073008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1073016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1073019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1073022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073044 */     // MIs[0] policy
     /* 1073044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073054 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1073057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073073 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073076 */     // GIR_Coverage, 21808,
     /* 1073076 */     GIR_EraseRootFromParent_Done,
     /* 1073077 */   // Label 15820: @1073077
     /* 1073077 */   GIM_Try, /*On fail goto*//*Label 15821*/ GIMT_Encode4(1073154), // Rule ID 21809 //
     /* 1073082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1073085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1073093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1073096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1073099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073121 */     // MIs[0] policy
     /* 1073121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073131 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1073134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073153 */     // GIR_Coverage, 21809,
     /* 1073153 */     GIR_EraseRootFromParent_Done,
     /* 1073154 */   // Label 15821: @1073154
     /* 1073154 */   GIM_Try, /*On fail goto*//*Label 15822*/ GIMT_Encode4(1073231), // Rule ID 21812 //
     /* 1073159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1073162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1073170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1073173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1073176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073198 */     // MIs[0] policy
     /* 1073198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073208 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1073211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073230 */     // GIR_Coverage, 21812,
     /* 1073230 */     GIR_EraseRootFromParent_Done,
     /* 1073231 */   // Label 15822: @1073231
     /* 1073231 */   GIM_Try, /*On fail goto*//*Label 15823*/ GIMT_Encode4(1073308), // Rule ID 21813 //
     /* 1073236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1073239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1073247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1073250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1073253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073275 */     // MIs[0] policy
     /* 1073275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073285 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1073288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073294 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073307 */     // GIR_Coverage, 21813,
     /* 1073307 */     GIR_EraseRootFromParent_Done,
     /* 1073308 */   // Label 15823: @1073308
     /* 1073308 */   GIM_Try, /*On fail goto*//*Label 15824*/ GIMT_Encode4(1073385), // Rule ID 21816 //
     /* 1073313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1073316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1073324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1073327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1073330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073352 */     // MIs[0] policy
     /* 1073352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073362 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1073365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073381 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073384 */     // GIR_Coverage, 21816,
     /* 1073384 */     GIR_EraseRootFromParent_Done,
     /* 1073385 */   // Label 15824: @1073385
     /* 1073385 */   GIM_Try, /*On fail goto*//*Label 15825*/ GIMT_Encode4(1073462), // Rule ID 21817 //
     /* 1073390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1073393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1073401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1073404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1073407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073429 */     // MIs[0] policy
     /* 1073429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073439 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1073442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073448 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073458 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073461 */     // GIR_Coverage, 21817,
     /* 1073461 */     GIR_EraseRootFromParent_Done,
     /* 1073462 */   // Label 15825: @1073462
     /* 1073462 */   GIM_Try, /*On fail goto*//*Label 15826*/ GIMT_Encode4(1073539), // Rule ID 21820 //
     /* 1073467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1073470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1073478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1073481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1073484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1073487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073506 */     // MIs[0] policy
     /* 1073506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073516 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1073519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073535 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073538 */     // GIR_Coverage, 21820,
     /* 1073538 */     GIR_EraseRootFromParent_Done,
     /* 1073539 */   // Label 15826: @1073539
     /* 1073539 */   GIM_Try, /*On fail goto*//*Label 15827*/ GIMT_Encode4(1073616), // Rule ID 21821 //
     /* 1073544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1073547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1073555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1073558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1073561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1073564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073583 */     // MIs[0] policy
     /* 1073583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073593 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1073596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073602 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073615 */     // GIR_Coverage, 21821,
     /* 1073615 */     GIR_EraseRootFromParent_Done,
     /* 1073616 */   // Label 15827: @1073616
     /* 1073616 */   GIM_Try, /*On fail goto*//*Label 15828*/ GIMT_Encode4(1073693), // Rule ID 21824 //
     /* 1073621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1073624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1073632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1073635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1073638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1073641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073660 */     // MIs[0] policy
     /* 1073660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1073673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073692 */     // GIR_Coverage, 21824,
     /* 1073692 */     GIR_EraseRootFromParent_Done,
     /* 1073693 */   // Label 15828: @1073693
     /* 1073693 */   GIM_Try, /*On fail goto*//*Label 15829*/ GIMT_Encode4(1073770), // Rule ID 21825 //
     /* 1073698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1073701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1073709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1073712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1073715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1073718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073737 */     // MIs[0] policy
     /* 1073737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073747 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1073750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073756 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073769 */     // GIR_Coverage, 21825,
     /* 1073769 */     GIR_EraseRootFromParent_Done,
     /* 1073770 */   // Label 15829: @1073770
     /* 1073770 */   GIM_Try, /*On fail goto*//*Label 15830*/ GIMT_Encode4(1073847), // Rule ID 21828 //
     /* 1073775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1073778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1073786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1073789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1073792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073814 */     // MIs[0] policy
     /* 1073814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1073827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073846 */     // GIR_Coverage, 21828,
     /* 1073846 */     GIR_EraseRootFromParent_Done,
     /* 1073847 */   // Label 15830: @1073847
     /* 1073847 */   GIM_Try, /*On fail goto*//*Label 15831*/ GIMT_Encode4(1073924), // Rule ID 21829 //
     /* 1073852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1073855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1073863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1073866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1073869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073891 */     // MIs[0] policy
     /* 1073891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073901 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1073904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073910 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073923 */     // GIR_Coverage, 21829,
     /* 1073923 */     GIR_EraseRootFromParent_Done,
     /* 1073924 */   // Label 15831: @1073924
     /* 1073924 */   GIM_Try, /*On fail goto*//*Label 15832*/ GIMT_Encode4(1074001), // Rule ID 21832 //
     /* 1073929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1073932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1073940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1073943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1073946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073968 */     // MIs[0] policy
     /* 1073968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073978 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1073981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074000 */     // GIR_Coverage, 21832,
     /* 1074000 */     GIR_EraseRootFromParent_Done,
     /* 1074001 */   // Label 15832: @1074001
     /* 1074001 */   GIM_Try, /*On fail goto*//*Label 15833*/ GIMT_Encode4(1074078), // Rule ID 21833 //
     /* 1074006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1074009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1074014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1074017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1074020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1074023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074045 */     // MIs[0] policy
     /* 1074045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074055 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1074058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074064 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074077 */     // GIR_Coverage, 21833,
     /* 1074077 */     GIR_EraseRootFromParent_Done,
     /* 1074078 */   // Label 15833: @1074078
     /* 1074078 */   GIM_Try, /*On fail goto*//*Label 15834*/ GIMT_Encode4(1074155), // Rule ID 21944 //
     /* 1074083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1074086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1074094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1074097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1074100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1074103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074122 */     // MIs[0] policy
     /* 1074122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074132 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1074135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074151 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074154 */     // GIR_Coverage, 21944,
     /* 1074154 */     GIR_EraseRootFromParent_Done,
     /* 1074155 */   // Label 15834: @1074155
     /* 1074155 */   GIM_Try, /*On fail goto*//*Label 15835*/ GIMT_Encode4(1074232), // Rule ID 21945 //
     /* 1074160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1074163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1074171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1074174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1074177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1074180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074199 */     // MIs[0] policy
     /* 1074199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074209 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1074212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074218 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074228 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074231 */     // GIR_Coverage, 21945,
     /* 1074231 */     GIR_EraseRootFromParent_Done,
     /* 1074232 */   // Label 15835: @1074232
     /* 1074232 */   GIM_Try, /*On fail goto*//*Label 15836*/ GIMT_Encode4(1074309), // Rule ID 21948 //
     /* 1074237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1074240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1074248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1074251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1074254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1074257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074276 */     // MIs[0] policy
     /* 1074276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074286 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1074289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074305 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074308 */     // GIR_Coverage, 21948,
     /* 1074308 */     GIR_EraseRootFromParent_Done,
     /* 1074309 */   // Label 15836: @1074309
     /* 1074309 */   GIM_Try, /*On fail goto*//*Label 15837*/ GIMT_Encode4(1074386), // Rule ID 21949 //
     /* 1074314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1074317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1074325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1074328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1074331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1074334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074353 */     // MIs[0] policy
     /* 1074353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074363 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1074366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074372 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074385 */     // GIR_Coverage, 21949,
     /* 1074385 */     GIR_EraseRootFromParent_Done,
     /* 1074386 */   // Label 15837: @1074386
     /* 1074386 */   GIM_Try, /*On fail goto*//*Label 15838*/ GIMT_Encode4(1074463), // Rule ID 21952 //
     /* 1074391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1074394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1074402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1074405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1074408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074430 */     // MIs[0] policy
     /* 1074430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074440 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1074443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074459 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074462 */     // GIR_Coverage, 21952,
     /* 1074462 */     GIR_EraseRootFromParent_Done,
     /* 1074463 */   // Label 15838: @1074463
     /* 1074463 */   GIM_Try, /*On fail goto*//*Label 15839*/ GIMT_Encode4(1074540), // Rule ID 21953 //
     /* 1074468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1074471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1074479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1074482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1074485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074507 */     // MIs[0] policy
     /* 1074507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074517 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1074520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074526 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074539 */     // GIR_Coverage, 21953,
     /* 1074539 */     GIR_EraseRootFromParent_Done,
     /* 1074540 */   // Label 15839: @1074540
     /* 1074540 */   GIM_Try, /*On fail goto*//*Label 15840*/ GIMT_Encode4(1074617), // Rule ID 21956 //
     /* 1074545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1074548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1074556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1074559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1074562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074584 */     // MIs[0] policy
     /* 1074584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074594 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1074597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074613 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074616 */     // GIR_Coverage, 21956,
     /* 1074616 */     GIR_EraseRootFromParent_Done,
     /* 1074617 */   // Label 15840: @1074617
     /* 1074617 */   GIM_Try, /*On fail goto*//*Label 15841*/ GIMT_Encode4(1074694), // Rule ID 21957 //
     /* 1074622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1074625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1074633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1074636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1074639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074661 */     // MIs[0] policy
     /* 1074661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074671 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1074674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074680 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074693 */     // GIR_Coverage, 21957,
     /* 1074693 */     GIR_EraseRootFromParent_Done,
     /* 1074694 */   // Label 15841: @1074694
     /* 1074694 */   GIM_Try, /*On fail goto*//*Label 15842*/ GIMT_Encode4(1074771), // Rule ID 21960 //
     /* 1074699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1074702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1074710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1074713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1074716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074738 */     // MIs[0] policy
     /* 1074738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074748 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1074751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074767 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074770 */     // GIR_Coverage, 21960,
     /* 1074770 */     GIR_EraseRootFromParent_Done,
     /* 1074771 */   // Label 15842: @1074771
     /* 1074771 */   GIM_Try, /*On fail goto*//*Label 15843*/ GIMT_Encode4(1074848), // Rule ID 21961 //
     /* 1074776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1074779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1074787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1074790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1074793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074815 */     // MIs[0] policy
     /* 1074815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074825 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1074828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074834 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074847 */     // GIR_Coverage, 21961,
     /* 1074847 */     GIR_EraseRootFromParent_Done,
     /* 1074848 */   // Label 15843: @1074848
     /* 1074848 */   GIM_Try, /*On fail goto*//*Label 15844*/ GIMT_Encode4(1074925), // Rule ID 21964 //
     /* 1074853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1074856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1074864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1074867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1074870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1074873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074892 */     // MIs[0] policy
     /* 1074892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074902 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1074905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074924 */     // GIR_Coverage, 21964,
     /* 1074924 */     GIR_EraseRootFromParent_Done,
     /* 1074925 */   // Label 15844: @1074925
     /* 1074925 */   GIM_Try, /*On fail goto*//*Label 15845*/ GIMT_Encode4(1075002), // Rule ID 21965 //
     /* 1074930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1074933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1074941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1074944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1074947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1074950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074969 */     // MIs[0] policy
     /* 1074969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074979 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1074982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075001 */     // GIR_Coverage, 21965,
     /* 1075001 */     GIR_EraseRootFromParent_Done,
     /* 1075002 */   // Label 15845: @1075002
     /* 1075002 */   GIM_Try, /*On fail goto*//*Label 15846*/ GIMT_Encode4(1075079), // Rule ID 21968 //
     /* 1075007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1075010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1075015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1075018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1075021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1075024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1075027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075046 */     // MIs[0] policy
     /* 1075046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075056 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1075059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075078 */     // GIR_Coverage, 21968,
     /* 1075078 */     GIR_EraseRootFromParent_Done,
     /* 1075079 */   // Label 15846: @1075079
     /* 1075079 */   GIM_Try, /*On fail goto*//*Label 15847*/ GIMT_Encode4(1075156), // Rule ID 21969 //
     /* 1075084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1075087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1075092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1075095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1075098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1075101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1075104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075123 */     // MIs[0] policy
     /* 1075123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075133 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1075136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075142 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075155 */     // GIR_Coverage, 21969,
     /* 1075155 */     GIR_EraseRootFromParent_Done,
     /* 1075156 */   // Label 15847: @1075156
     /* 1075156 */   GIM_Try, /*On fail goto*//*Label 15848*/ GIMT_Encode4(1075233), // Rule ID 21972 //
     /* 1075161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1075164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1075169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1075172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1075175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1075178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1075181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1075188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075200 */     // MIs[0] policy
     /* 1075200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075210 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1075213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075229 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075232 */     // GIR_Coverage, 21972,
     /* 1075232 */     GIR_EraseRootFromParent_Done,
     /* 1075233 */   // Label 15848: @1075233
     /* 1075233 */   GIM_Try, /*On fail goto*//*Label 15849*/ GIMT_Encode4(1075310), // Rule ID 21973 //
     /* 1075238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1075241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1075246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1075249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1075252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1075255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1075258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1075265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075277 */     // MIs[0] policy
     /* 1075277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075287 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1075290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075296 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075306 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075309 */     // GIR_Coverage, 21973,
     /* 1075309 */     GIR_EraseRootFromParent_Done,
     /* 1075310 */   // Label 15849: @1075310
     /* 1075310 */   GIM_Try, /*On fail goto*//*Label 15850*/ GIMT_Encode4(1075387), // Rule ID 21976 //
     /* 1075315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1075318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1075323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1075326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1075329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1075332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1075335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1075342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075354 */     // MIs[0] policy
     /* 1075354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075364 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1075367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075383 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075386 */     // GIR_Coverage, 21976,
     /* 1075386 */     GIR_EraseRootFromParent_Done,
     /* 1075387 */   // Label 15850: @1075387
     /* 1075387 */   GIM_Try, /*On fail goto*//*Label 15851*/ GIMT_Encode4(1075464), // Rule ID 21977 //
     /* 1075392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1075395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1075400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1075403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1075406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1075409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1075412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1075419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075431 */     // MIs[0] policy
     /* 1075431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075441 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1075444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075450 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075460 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075463 */     // GIR_Coverage, 21977,
     /* 1075463 */     GIR_EraseRootFromParent_Done,
     /* 1075464 */   // Label 15851: @1075464
     /* 1075464 */   GIM_Try, /*On fail goto*//*Label 15852*/ GIMT_Encode4(1075541), // Rule ID 23416 //
     /* 1075469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1075480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1075483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1075486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1075489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075508 */     // MIs[0] policy
     /* 1075508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075518 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1075521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075537 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075540 */     // GIR_Coverage, 23416,
     /* 1075540 */     GIR_EraseRootFromParent_Done,
     /* 1075541 */   // Label 15852: @1075541
     /* 1075541 */   GIM_Try, /*On fail goto*//*Label 15853*/ GIMT_Encode4(1075618), // Rule ID 23417 //
     /* 1075546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1075557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1075560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1075563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1075566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075585 */     // MIs[0] policy
     /* 1075585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075595 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1075598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075604 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075614 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075617 */     // GIR_Coverage, 23417,
     /* 1075617 */     GIR_EraseRootFromParent_Done,
     /* 1075618 */   // Label 15853: @1075618
     /* 1075618 */   GIM_Try, /*On fail goto*//*Label 15854*/ GIMT_Encode4(1075695), // Rule ID 23420 //
     /* 1075623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1075634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1075637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1075640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1075643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075662 */     // MIs[0] policy
     /* 1075662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075672 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1075675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075691 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075694 */     // GIR_Coverage, 23420,
     /* 1075694 */     GIR_EraseRootFromParent_Done,
     /* 1075695 */   // Label 15854: @1075695
     /* 1075695 */   GIM_Try, /*On fail goto*//*Label 15855*/ GIMT_Encode4(1075772), // Rule ID 23421 //
     /* 1075700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1075711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1075714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1075717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1075720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075739 */     // MIs[0] policy
     /* 1075739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075749 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1075752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075758 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075771 */     // GIR_Coverage, 23421,
     /* 1075771 */     GIR_EraseRootFromParent_Done,
     /* 1075772 */   // Label 15855: @1075772
     /* 1075772 */   GIM_Try, /*On fail goto*//*Label 15856*/ GIMT_Encode4(1075849), // Rule ID 23424 //
     /* 1075777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1075788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1075791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1075794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1075797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075816 */     // MIs[0] policy
     /* 1075816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075826 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1075829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075845 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075848 */     // GIR_Coverage, 23424,
     /* 1075848 */     GIR_EraseRootFromParent_Done,
     /* 1075849 */   // Label 15856: @1075849
     /* 1075849 */   GIM_Try, /*On fail goto*//*Label 15857*/ GIMT_Encode4(1075926), // Rule ID 23425 //
     /* 1075854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1075865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1075868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1075871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1075874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075893 */     // MIs[0] policy
     /* 1075893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075903 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1075906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075912 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075922 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075925 */     // GIR_Coverage, 23425,
     /* 1075925 */     GIR_EraseRootFromParent_Done,
     /* 1075926 */   // Label 15857: @1075926
     /* 1075926 */   GIM_Try, /*On fail goto*//*Label 15858*/ GIMT_Encode4(1076003), // Rule ID 23428 //
     /* 1075931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1075942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1075945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1075948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1075951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075970 */     // MIs[0] policy
     /* 1075970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075980 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1075983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076002 */     // GIR_Coverage, 23428,
     /* 1076002 */     GIR_EraseRootFromParent_Done,
     /* 1076003 */   // Label 15858: @1076003
     /* 1076003 */   GIM_Try, /*On fail goto*//*Label 15859*/ GIMT_Encode4(1076080), // Rule ID 23429 //
     /* 1076008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1076019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1076022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1076025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1076028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076047 */     // MIs[0] policy
     /* 1076047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076057 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1076060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076066 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076079 */     // GIR_Coverage, 23429,
     /* 1076079 */     GIR_EraseRootFromParent_Done,
     /* 1076080 */   // Label 15859: @1076080
     /* 1076080 */   GIM_Try, /*On fail goto*//*Label 15860*/ GIMT_Encode4(1076157), // Rule ID 23432 //
     /* 1076085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1076096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1076099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1076102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1076105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076124 */     // MIs[0] policy
     /* 1076124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076134 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1076137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076156 */     // GIR_Coverage, 23432,
     /* 1076156 */     GIR_EraseRootFromParent_Done,
     /* 1076157 */   // Label 15860: @1076157
     /* 1076157 */   GIM_Try, /*On fail goto*//*Label 15861*/ GIMT_Encode4(1076234), // Rule ID 23433 //
     /* 1076162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1076173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1076176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1076179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1076182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076201 */     // MIs[0] policy
     /* 1076201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076211 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1076214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076220 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076233 */     // GIR_Coverage, 23433,
     /* 1076233 */     GIR_EraseRootFromParent_Done,
     /* 1076234 */   // Label 15861: @1076234
     /* 1076234 */   GIM_Try, /*On fail goto*//*Label 15862*/ GIMT_Encode4(1076311), // Rule ID 23436 //
     /* 1076239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1076250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1076253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1076256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1076259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076278 */     // MIs[0] policy
     /* 1076278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076288 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11301:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076307 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076310 */     // GIR_Coverage, 23436,
     /* 1076310 */     GIR_EraseRootFromParent_Done,
     /* 1076311 */   // Label 15862: @1076311
     /* 1076311 */   GIM_Try, /*On fail goto*//*Label 15863*/ GIMT_Encode4(1076388), // Rule ID 23437 //
     /* 1076316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1076327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1076330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1076333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1076336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076355 */     // MIs[0] policy
     /* 1076355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076365 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11301:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076374 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076387 */     // GIR_Coverage, 23437,
     /* 1076387 */     GIR_EraseRootFromParent_Done,
     /* 1076388 */   // Label 15863: @1076388
     /* 1076388 */   GIM_Try, /*On fail goto*//*Label 15864*/ GIMT_Encode4(1076465), // Rule ID 23440 //
     /* 1076393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1076404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1076407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1076410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1076413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076432 */     // MIs[0] policy
     /* 1076432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076442 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076461 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076464 */     // GIR_Coverage, 23440,
     /* 1076464 */     GIR_EraseRootFromParent_Done,
     /* 1076465 */   // Label 15864: @1076465
     /* 1076465 */   GIM_Try, /*On fail goto*//*Label 15865*/ GIMT_Encode4(1076542), // Rule ID 23441 //
     /* 1076470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1076481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1076484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1076487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1076490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076509 */     // MIs[0] policy
     /* 1076509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076519 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076541 */     // GIR_Coverage, 23441,
     /* 1076541 */     GIR_EraseRootFromParent_Done,
     /* 1076542 */   // Label 15865: @1076542
     /* 1076542 */   GIM_Try, /*On fail goto*//*Label 15866*/ GIMT_Encode4(1076619), // Rule ID 23444 //
     /* 1076547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1076558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1076561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1076564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1076567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076586 */     // MIs[0] policy
     /* 1076586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076618 */     // GIR_Coverage, 23444,
     /* 1076618 */     GIR_EraseRootFromParent_Done,
     /* 1076619 */   // Label 15866: @1076619
     /* 1076619 */   GIM_Try, /*On fail goto*//*Label 15867*/ GIMT_Encode4(1076696), // Rule ID 23445 //
     /* 1076624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1076635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1076638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1076641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1076644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076663 */     // MIs[0] policy
     /* 1076663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076673 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076695 */     // GIR_Coverage, 23445,
     /* 1076695 */     GIR_EraseRootFromParent_Done,
     /* 1076696 */   // Label 15867: @1076696
     /* 1076696 */   GIM_Try, /*On fail goto*//*Label 15868*/ GIMT_Encode4(1076773), // Rule ID 23448 //
     /* 1076701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1076704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1076712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1076715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1076718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1076721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076740 */     // MIs[0] policy
     /* 1076740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076750 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076769 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076772 */     // GIR_Coverage, 23448,
     /* 1076772 */     GIR_EraseRootFromParent_Done,
     /* 1076773 */   // Label 15868: @1076773
     /* 1076773 */   GIM_Try, /*On fail goto*//*Label 15869*/ GIMT_Encode4(1076850), // Rule ID 23449 //
     /* 1076778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1076781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1076789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1076792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1076795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1076798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076817 */     // MIs[0] policy
     /* 1076817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076849 */     // GIR_Coverage, 23449,
     /* 1076849 */     GIR_EraseRootFromParent_Done,
     /* 1076850 */   // Label 15869: @1076850
     /* 1076850 */   GIM_Try, /*On fail goto*//*Label 15870*/ GIMT_Encode4(1076927), // Rule ID 23452 //
     /* 1076855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1076866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1076869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1076872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1076875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1076882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076894 */     // MIs[0] policy
     /* 1076894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076904 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1076907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076926 */     // GIR_Coverage, 23452,
     /* 1076926 */     GIR_EraseRootFromParent_Done,
     /* 1076927 */   // Label 15870: @1076927
     /* 1076927 */   GIM_Try, /*On fail goto*//*Label 15871*/ GIMT_Encode4(1077004), // Rule ID 23453 //
     /* 1076932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1076943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1076946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1076949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1076952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1076959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076971 */     // MIs[0] policy
     /* 1076971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076981 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1076984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076990 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077003 */     // GIR_Coverage, 23453,
     /* 1077003 */     GIR_EraseRootFromParent_Done,
     /* 1077004 */   // Label 15871: @1077004
     /* 1077004 */   GIM_Try, /*On fail goto*//*Label 15872*/ GIMT_Encode4(1077081), // Rule ID 23456 //
     /* 1077009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1077020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1077023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1077026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1077029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1077036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077048 */     // MIs[0] policy
     /* 1077048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077058 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1077061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077080 */     // GIR_Coverage, 23456,
     /* 1077080 */     GIR_EraseRootFromParent_Done,
     /* 1077081 */   // Label 15872: @1077081
     /* 1077081 */   GIM_Try, /*On fail goto*//*Label 15873*/ GIMT_Encode4(1077158), // Rule ID 23457 //
     /* 1077086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1077097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1077100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1077103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1077106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1077113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077125 */     // MIs[0] policy
     /* 1077125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077135 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1077138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077144 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077157 */     // GIR_Coverage, 23457,
     /* 1077157 */     GIR_EraseRootFromParent_Done,
     /* 1077158 */   // Label 15873: @1077158
     /* 1077158 */   GIM_Try, /*On fail goto*//*Label 15874*/ GIMT_Encode4(1077235), // Rule ID 23460 //
     /* 1077163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1077174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1077177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1077180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1077183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1077190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077202 */     // MIs[0] policy
     /* 1077202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077212 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1077215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077231 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077234 */     // GIR_Coverage, 23460,
     /* 1077234 */     GIR_EraseRootFromParent_Done,
     /* 1077235 */   // Label 15874: @1077235
     /* 1077235 */   GIM_Try, /*On fail goto*//*Label 15875*/ GIMT_Encode4(1077312), // Rule ID 23461 //
     /* 1077240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1077251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1077254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1077257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1077260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1077267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077279 */     // MIs[0] policy
     /* 1077279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077289 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1077292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077298 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077311 */     // GIR_Coverage, 23461,
     /* 1077311 */     GIR_EraseRootFromParent_Done,
     /* 1077312 */   // Label 15875: @1077312
     /* 1077312 */   GIM_Try, /*On fail goto*//*Label 15876*/ GIMT_Encode4(1077389), // Rule ID 23464 //
     /* 1077317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1077328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1077331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1077334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1077337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1077344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077356 */     // MIs[0] policy
     /* 1077356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077366 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1077369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077388 */     // GIR_Coverage, 23464,
     /* 1077388 */     GIR_EraseRootFromParent_Done,
     /* 1077389 */   // Label 15876: @1077389
     /* 1077389 */   GIM_Try, /*On fail goto*//*Label 15877*/ GIMT_Encode4(1077466), // Rule ID 23465 //
     /* 1077394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1077405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1077408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1077411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1077414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1077421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077433 */     // MIs[0] policy
     /* 1077433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077443 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1077446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077465 */     // GIR_Coverage, 23465,
     /* 1077465 */     GIR_EraseRootFromParent_Done,
     /* 1077466 */   // Label 15877: @1077466
     /* 1077466 */   GIM_Try, /*On fail goto*//*Label 15878*/ GIMT_Encode4(1077543), // Rule ID 23468 //
     /* 1077471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1077482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1077485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1077488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1077491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1077498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077510 */     // MIs[0] policy
     /* 1077510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077520 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1077523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077542 */     // GIR_Coverage, 23468,
     /* 1077542 */     GIR_EraseRootFromParent_Done,
     /* 1077543 */   // Label 15878: @1077543
     /* 1077543 */   GIM_Try, /*On fail goto*//*Label 15879*/ GIMT_Encode4(1077620), // Rule ID 23469 //
     /* 1077548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1077559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1077562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1077565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1077568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1077575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077587 */     // MIs[0] policy
     /* 1077587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077597 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1077600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077606 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077619 */     // GIR_Coverage, 23469,
     /* 1077619 */     GIR_EraseRootFromParent_Done,
     /* 1077620 */   // Label 15879: @1077620
     /* 1077620 */   GIM_Try, /*On fail goto*//*Label 15880*/ GIMT_Encode4(1077697), // Rule ID 23472 //
     /* 1077625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1077636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1077639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1077642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1077645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1077652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077664 */     // MIs[0] policy
     /* 1077664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077674 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1077677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077696 */     // GIR_Coverage, 23472,
     /* 1077696 */     GIR_EraseRootFromParent_Done,
     /* 1077697 */   // Label 15880: @1077697
     /* 1077697 */   GIM_Try, /*On fail goto*//*Label 15881*/ GIMT_Encode4(1077774), // Rule ID 23473 //
     /* 1077702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1077713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1077716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1077719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1077722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1077729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077741 */     // MIs[0] policy
     /* 1077741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077751 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1077754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077760 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077773 */     // GIR_Coverage, 23473,
     /* 1077773 */     GIR_EraseRootFromParent_Done,
     /* 1077774 */   // Label 15881: @1077774
     /* 1077774 */   GIM_Try, /*On fail goto*//*Label 15882*/ GIMT_Encode4(1077851), // Rule ID 23476 //
     /* 1077779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1077790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1077793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1077796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1077799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1077806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077818 */     // MIs[0] policy
     /* 1077818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1077831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077847 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077850 */     // GIR_Coverage, 23476,
     /* 1077850 */     GIR_EraseRootFromParent_Done,
     /* 1077851 */   // Label 15882: @1077851
     /* 1077851 */   GIM_Try, /*On fail goto*//*Label 15883*/ GIMT_Encode4(1077928), // Rule ID 23477 //
     /* 1077856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1077867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1077870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1077873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1077876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1077883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077895 */     // MIs[0] policy
     /* 1077895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077905 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1077908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077914 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077927 */     // GIR_Coverage, 23477,
     /* 1077927 */     GIR_EraseRootFromParent_Done,
     /* 1077928 */   // Label 15883: @1077928
     /* 1077928 */   GIM_Try, /*On fail goto*//*Label 15884*/ GIMT_Encode4(1078005), // Rule ID 23480 //
     /* 1077933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1077944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1077947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1077950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1077953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1077960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077972 */     // MIs[0] policy
     /* 1077972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077982 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1077985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078004 */     // GIR_Coverage, 23480,
     /* 1078004 */     GIR_EraseRootFromParent_Done,
     /* 1078005 */   // Label 15884: @1078005
     /* 1078005 */   GIM_Try, /*On fail goto*//*Label 15885*/ GIMT_Encode4(1078082), // Rule ID 23481 //
     /* 1078010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1078021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1078024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1078027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1078030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1078037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078049 */     // MIs[0] policy
     /* 1078049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078059 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1078062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078081 */     // GIR_Coverage, 23481,
     /* 1078081 */     GIR_EraseRootFromParent_Done,
     /* 1078082 */   // Label 15885: @1078082
     /* 1078082 */   GIM_Try, /*On fail goto*//*Label 15886*/ GIMT_Encode4(1078159), // Rule ID 23484 //
     /* 1078087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1078098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1078101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1078104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1078107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1078114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078126 */     // MIs[0] policy
     /* 1078126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078136 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1078139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078158 */     // GIR_Coverage, 23484,
     /* 1078158 */     GIR_EraseRootFromParent_Done,
     /* 1078159 */   // Label 15886: @1078159
     /* 1078159 */   GIM_Try, /*On fail goto*//*Label 15887*/ GIMT_Encode4(1078236), // Rule ID 23485 //
     /* 1078164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1078175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1078178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1078181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1078184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1078191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078203 */     // MIs[0] policy
     /* 1078203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078213 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1078216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078222 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078235 */     // GIR_Coverage, 23485,
     /* 1078235 */     GIR_EraseRootFromParent_Done,
     /* 1078236 */   // Label 15887: @1078236
     /* 1078236 */   GIM_Try, /*On fail goto*//*Label 15888*/ GIMT_Encode4(1078313), // Rule ID 23488 //
     /* 1078241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1078252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1078255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1078258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1078261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1078268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078280 */     // MIs[0] policy
     /* 1078280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1078293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078312 */     // GIR_Coverage, 23488,
     /* 1078312 */     GIR_EraseRootFromParent_Done,
     /* 1078313 */   // Label 15888: @1078313
     /* 1078313 */   GIM_Try, /*On fail goto*//*Label 15889*/ GIMT_Encode4(1078390), // Rule ID 23489 //
     /* 1078318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1078329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1078332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1078335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1078338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1078345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078357 */     // MIs[0] policy
     /* 1078357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078367 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1078370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078376 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078389 */     // GIR_Coverage, 23489,
     /* 1078389 */     GIR_EraseRootFromParent_Done,
     /* 1078390 */   // Label 15889: @1078390
     /* 1078390 */   GIM_Try, /*On fail goto*//*Label 15890*/ GIMT_Encode4(1078467), // Rule ID 23492 //
     /* 1078395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1078406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1078409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1078412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1078415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1078422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078434 */     // MIs[0] policy
     /* 1078434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078444 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1078447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078466 */     // GIR_Coverage, 23492,
     /* 1078466 */     GIR_EraseRootFromParent_Done,
     /* 1078467 */   // Label 15890: @1078467
     /* 1078467 */   GIM_Try, /*On fail goto*//*Label 15891*/ GIMT_Encode4(1078544), // Rule ID 23493 //
     /* 1078472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1078483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1078486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1078489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1078492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1078499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078511 */     // MIs[0] policy
     /* 1078511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078521 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1078524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078543 */     // GIR_Coverage, 23493,
     /* 1078543 */     GIR_EraseRootFromParent_Done,
     /* 1078544 */   // Label 15891: @1078544
     /* 1078544 */   GIM_Try, /*On fail goto*//*Label 15892*/ GIMT_Encode4(1078621), // Rule ID 23496 //
     /* 1078549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1078560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1078563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1078566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1078569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1078576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078588 */     // MIs[0] policy
     /* 1078588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078598 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1078601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078620 */     // GIR_Coverage, 23496,
     /* 1078620 */     GIR_EraseRootFromParent_Done,
     /* 1078621 */   // Label 15892: @1078621
     /* 1078621 */   GIM_Try, /*On fail goto*//*Label 15893*/ GIMT_Encode4(1078698), // Rule ID 23497 //
     /* 1078626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1078637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1078640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1078643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1078646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1078653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078665 */     // MIs[0] policy
     /* 1078665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078675 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1078678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078697 */     // GIR_Coverage, 23497,
     /* 1078697 */     GIR_EraseRootFromParent_Done,
     /* 1078698 */   // Label 15893: @1078698
     /* 1078698 */   GIM_Try, /*On fail goto*//*Label 15894*/ GIMT_Encode4(1078775), // Rule ID 23602 //
     /* 1078703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1078714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1078717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1078720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078742 */     // MIs[0] policy
     /* 1078742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078752 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1078755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078774 */     // GIR_Coverage, 23602,
     /* 1078774 */     GIR_EraseRootFromParent_Done,
     /* 1078775 */   // Label 15894: @1078775
     /* 1078775 */   GIM_Try, /*On fail goto*//*Label 15895*/ GIMT_Encode4(1078852), // Rule ID 23603 //
     /* 1078780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1078791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1078794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1078797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078819 */     // MIs[0] policy
     /* 1078819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078829 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1078832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078851 */     // GIR_Coverage, 23603,
     /* 1078851 */     GIR_EraseRootFromParent_Done,
     /* 1078852 */   // Label 15895: @1078852
     /* 1078852 */   GIM_Try, /*On fail goto*//*Label 15896*/ GIMT_Encode4(1078929), // Rule ID 23606 //
     /* 1078857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1078868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1078871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1078874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078896 */     // MIs[0] policy
     /* 1078896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078906 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1078909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078928 */     // GIR_Coverage, 23606,
     /* 1078928 */     GIR_EraseRootFromParent_Done,
     /* 1078929 */   // Label 15896: @1078929
     /* 1078929 */   GIM_Try, /*On fail goto*//*Label 15897*/ GIMT_Encode4(1079006), // Rule ID 23607 //
     /* 1078934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1078945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1078948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1078951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078973 */     // MIs[0] policy
     /* 1078973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078983 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1078986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079005 */     // GIR_Coverage, 23607,
     /* 1079005 */     GIR_EraseRootFromParent_Done,
     /* 1079006 */   // Label 15897: @1079006
     /* 1079006 */   GIM_Try, /*On fail goto*//*Label 15898*/ GIMT_Encode4(1079083), // Rule ID 23610 //
     /* 1079011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1079022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1079025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1079028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079050 */     // MIs[0] policy
     /* 1079050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079060 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1079063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079082 */     // GIR_Coverage, 23610,
     /* 1079082 */     GIR_EraseRootFromParent_Done,
     /* 1079083 */   // Label 15898: @1079083
     /* 1079083 */   GIM_Try, /*On fail goto*//*Label 15899*/ GIMT_Encode4(1079160), // Rule ID 23611 //
     /* 1079088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1079099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1079102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1079105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079127 */     // MIs[0] policy
     /* 1079127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079137 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1079140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079159 */     // GIR_Coverage, 23611,
     /* 1079159 */     GIR_EraseRootFromParent_Done,
     /* 1079160 */   // Label 15899: @1079160
     /* 1079160 */   GIM_Try, /*On fail goto*//*Label 15900*/ GIMT_Encode4(1079237), // Rule ID 23614 //
     /* 1079165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1079176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1079179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1079182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079204 */     // MIs[0] policy
     /* 1079204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1079217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079236 */     // GIR_Coverage, 23614,
     /* 1079236 */     GIR_EraseRootFromParent_Done,
     /* 1079237 */   // Label 15900: @1079237
     /* 1079237 */   GIM_Try, /*On fail goto*//*Label 15901*/ GIMT_Encode4(1079314), // Rule ID 23615 //
     /* 1079242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1079253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1079256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1079259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079281 */     // MIs[0] policy
     /* 1079281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079291 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1079294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079313 */     // GIR_Coverage, 23615,
     /* 1079313 */     GIR_EraseRootFromParent_Done,
     /* 1079314 */   // Label 15901: @1079314
     /* 1079314 */   GIM_Try, /*On fail goto*//*Label 15902*/ GIMT_Encode4(1079391), // Rule ID 23618 //
     /* 1079319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1079330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1079333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1079336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079358 */     // MIs[0] policy
     /* 1079358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079368 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1079371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079390 */     // GIR_Coverage, 23618,
     /* 1079390 */     GIR_EraseRootFromParent_Done,
     /* 1079391 */   // Label 15902: @1079391
     /* 1079391 */   GIM_Try, /*On fail goto*//*Label 15903*/ GIMT_Encode4(1079468), // Rule ID 23619 //
     /* 1079396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1079407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1079410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1079413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079435 */     // MIs[0] policy
     /* 1079435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079445 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1079448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079467 */     // GIR_Coverage, 23619,
     /* 1079467 */     GIR_EraseRootFromParent_Done,
     /* 1079468 */   // Label 15903: @1079468
     /* 1079468 */   GIM_Try, /*On fail goto*//*Label 15904*/ GIMT_Encode4(1079545), // Rule ID 23622 //
     /* 1079473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1079484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1079487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1079490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079512 */     // MIs[0] policy
     /* 1079512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079522 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1079525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079544 */     // GIR_Coverage, 23622,
     /* 1079544 */     GIR_EraseRootFromParent_Done,
     /* 1079545 */   // Label 15904: @1079545
     /* 1079545 */   GIM_Try, /*On fail goto*//*Label 15905*/ GIMT_Encode4(1079622), // Rule ID 23623 //
     /* 1079550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1079561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1079564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1079567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079589 */     // MIs[0] policy
     /* 1079589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079599 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1079602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079621 */     // GIR_Coverage, 23623,
     /* 1079621 */     GIR_EraseRootFromParent_Done,
     /* 1079622 */   // Label 15905: @1079622
     /* 1079622 */   GIM_Try, /*On fail goto*//*Label 15906*/ GIMT_Encode4(1079699), // Rule ID 23626 //
     /* 1079627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1079638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1079641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1079644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079666 */     // MIs[0] policy
     /* 1079666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079676 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1079679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079698 */     // GIR_Coverage, 23626,
     /* 1079698 */     GIR_EraseRootFromParent_Done,
     /* 1079699 */   // Label 15906: @1079699
     /* 1079699 */   GIM_Try, /*On fail goto*//*Label 15907*/ GIMT_Encode4(1079776), // Rule ID 23627 //
     /* 1079704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1079715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1079718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1079721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079743 */     // MIs[0] policy
     /* 1079743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079753 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1079756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079775 */     // GIR_Coverage, 23627,
     /* 1079775 */     GIR_EraseRootFromParent_Done,
     /* 1079776 */   // Label 15907: @1079776
     /* 1079776 */   GIM_Try, /*On fail goto*//*Label 15908*/ GIMT_Encode4(1079853), // Rule ID 23630 //
     /* 1079781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1079792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1079795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1079798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079820 */     // MIs[0] policy
     /* 1079820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079830 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1079833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079852 */     // GIR_Coverage, 23630,
     /* 1079852 */     GIR_EraseRootFromParent_Done,
     /* 1079853 */   // Label 15908: @1079853
     /* 1079853 */   GIM_Try, /*On fail goto*//*Label 15909*/ GIMT_Encode4(1079930), // Rule ID 23631 //
     /* 1079858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1079869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1079872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1079875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079897 */     // MIs[0] policy
     /* 1079897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079907 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1079910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079929 */     // GIR_Coverage, 23631,
     /* 1079929 */     GIR_EraseRootFromParent_Done,
     /* 1079930 */   // Label 15909: @1079930
     /* 1079930 */   GIM_Try, /*On fail goto*//*Label 15910*/ GIMT_Encode4(1080007), // Rule ID 23634 //
     /* 1079935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1079946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1079949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1079952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079974 */     // MIs[0] policy
     /* 1079974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1079987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080006 */     // GIR_Coverage, 23634,
     /* 1080006 */     GIR_EraseRootFromParent_Done,
     /* 1080007 */   // Label 15910: @1080007
     /* 1080007 */   GIM_Try, /*On fail goto*//*Label 15911*/ GIMT_Encode4(1080084), // Rule ID 23635 //
     /* 1080012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1080023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1080026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1080029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080051 */     // MIs[0] policy
     /* 1080051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080061 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1080064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080083 */     // GIR_Coverage, 23635,
     /* 1080083 */     GIR_EraseRootFromParent_Done,
     /* 1080084 */   // Label 15911: @1080084
     /* 1080084 */   GIM_Try, /*On fail goto*//*Label 15912*/ GIMT_Encode4(1080161), // Rule ID 23638 //
     /* 1080089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1080092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1080100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1080103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1080106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080128 */     // MIs[0] policy
     /* 1080128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080138 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1080141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1080157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080160 */     // GIR_Coverage, 23638,
     /* 1080160 */     GIR_EraseRootFromParent_Done,
     /* 1080161 */   // Label 15912: @1080161
     /* 1080161 */   GIM_Try, /*On fail goto*//*Label 15913*/ GIMT_Encode4(1080238), // Rule ID 23639 //
     /* 1080166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1080169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1080177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1080180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1080183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080205 */     // MIs[0] policy
     /* 1080205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080215 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1080218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1080234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080237 */     // GIR_Coverage, 23639,
     /* 1080237 */     GIR_EraseRootFromParent_Done,
     /* 1080238 */   // Label 15913: @1080238
     /* 1080238 */   GIM_Try, /*On fail goto*//*Label 15914*/ GIMT_Encode4(1080315), // Rule ID 23642 //
     /* 1080243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1080254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1080257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1080260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080282 */     // MIs[0] policy
     /* 1080282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080292 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1080295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080314 */     // GIR_Coverage, 23642,
     /* 1080314 */     GIR_EraseRootFromParent_Done,
     /* 1080315 */   // Label 15914: @1080315
     /* 1080315 */   GIM_Try, /*On fail goto*//*Label 15915*/ GIMT_Encode4(1080392), // Rule ID 23643 //
     /* 1080320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1080331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1080334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1080337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080359 */     // MIs[0] policy
     /* 1080359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080369 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1080372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080391 */     // GIR_Coverage, 23643,
     /* 1080391 */     GIR_EraseRootFromParent_Done,
     /* 1080392 */   // Label 15915: @1080392
     /* 1080392 */   GIM_Try, /*On fail goto*//*Label 15916*/ GIMT_Encode4(1080469), // Rule ID 23646 //
     /* 1080397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1080408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1080411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1080414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080436 */     // MIs[0] policy
     /* 1080436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080446 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1080449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080468 */     // GIR_Coverage, 23646,
     /* 1080468 */     GIR_EraseRootFromParent_Done,
     /* 1080469 */   // Label 15916: @1080469
     /* 1080469 */   GIM_Try, /*On fail goto*//*Label 15917*/ GIMT_Encode4(1080546), // Rule ID 23647 //
     /* 1080474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1080485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1080488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1080491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080513 */     // MIs[0] policy
     /* 1080513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080523 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1080526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080545 */     // GIR_Coverage, 23647,
     /* 1080545 */     GIR_EraseRootFromParent_Done,
     /* 1080546 */   // Label 15917: @1080546
     /* 1080546 */   GIM_Try, /*On fail goto*//*Label 15918*/ GIMT_Encode4(1080623), // Rule ID 23650 //
     /* 1080551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1080562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1080565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1080568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080590 */     // MIs[0] policy
     /* 1080590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080600 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1080603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080622 */     // GIR_Coverage, 23650,
     /* 1080622 */     GIR_EraseRootFromParent_Done,
     /* 1080623 */   // Label 15918: @1080623
     /* 1080623 */   GIM_Try, /*On fail goto*//*Label 15919*/ GIMT_Encode4(1080700), // Rule ID 23651 //
     /* 1080628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1080639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1080642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1080645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080667 */     // MIs[0] policy
     /* 1080667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080677 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1080680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080699 */     // GIR_Coverage, 23651,
     /* 1080699 */     GIR_EraseRootFromParent_Done,
     /* 1080700 */   // Label 15919: @1080700
     /* 1080700 */   GIM_Try, /*On fail goto*//*Label 15920*/ GIMT_Encode4(1080777), // Rule ID 23654 //
     /* 1080705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1080716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1080719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080744 */     // MIs[0] policy
     /* 1080744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1080757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080776 */     // GIR_Coverage, 23654,
     /* 1080776 */     GIR_EraseRootFromParent_Done,
     /* 1080777 */   // Label 15920: @1080777
     /* 1080777 */   GIM_Try, /*On fail goto*//*Label 15921*/ GIMT_Encode4(1080854), // Rule ID 23655 //
     /* 1080782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1080793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1080796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080821 */     // MIs[0] policy
     /* 1080821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080831 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1080834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080853 */     // GIR_Coverage, 23655,
     /* 1080853 */     GIR_EraseRootFromParent_Done,
     /* 1080854 */   // Label 15921: @1080854
     /* 1080854 */   GIM_Try, /*On fail goto*//*Label 15922*/ GIMT_Encode4(1080931), // Rule ID 23658 //
     /* 1080859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1080870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1080873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080898 */     // MIs[0] policy
     /* 1080898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080908 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1080911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080930 */     // GIR_Coverage, 23658,
     /* 1080930 */     GIR_EraseRootFromParent_Done,
     /* 1080931 */   // Label 15922: @1080931
     /* 1080931 */   GIM_Try, /*On fail goto*//*Label 15923*/ GIMT_Encode4(1081008), // Rule ID 23659 //
     /* 1080936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1080947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1080950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080975 */     // MIs[0] policy
     /* 1080975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080985 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1080988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081007 */     // GIR_Coverage, 23659,
     /* 1081007 */     GIR_EraseRootFromParent_Done,
     /* 1081008 */   // Label 15923: @1081008
     /* 1081008 */   GIM_Try, /*On fail goto*//*Label 15924*/ GIMT_Encode4(1081085), // Rule ID 23662 //
     /* 1081013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1081024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1081027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1081030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081052 */     // MIs[0] policy
     /* 1081052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081062 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1081065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081084 */     // GIR_Coverage, 23662,
     /* 1081084 */     GIR_EraseRootFromParent_Done,
     /* 1081085 */   // Label 15924: @1081085
     /* 1081085 */   GIM_Try, /*On fail goto*//*Label 15925*/ GIMT_Encode4(1081162), // Rule ID 23663 //
     /* 1081090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1081101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1081104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1081107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081129 */     // MIs[0] policy
     /* 1081129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081139 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1081142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081161 */     // GIR_Coverage, 23663,
     /* 1081161 */     GIR_EraseRootFromParent_Done,
     /* 1081162 */   // Label 15925: @1081162
     /* 1081162 */   GIM_Try, /*On fail goto*//*Label 15926*/ GIMT_Encode4(1081239), // Rule ID 23666 //
     /* 1081167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1081178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1081181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1081184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081206 */     // MIs[0] policy
     /* 1081206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1081219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081238 */     // GIR_Coverage, 23666,
     /* 1081238 */     GIR_EraseRootFromParent_Done,
     /* 1081239 */   // Label 15926: @1081239
     /* 1081239 */   GIM_Try, /*On fail goto*//*Label 15927*/ GIMT_Encode4(1081316), // Rule ID 23667 //
     /* 1081244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1081255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1081258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1081261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081283 */     // MIs[0] policy
     /* 1081283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1081296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081315 */     // GIR_Coverage, 23667,
     /* 1081315 */     GIR_EraseRootFromParent_Done,
     /* 1081316 */   // Label 15927: @1081316
     /* 1081316 */   GIM_Try, /*On fail goto*//*Label 15928*/ GIMT_Encode4(1081393), // Rule ID 23670 //
     /* 1081321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1081332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1081335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1081338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081360 */     // MIs[0] policy
     /* 1081360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081370 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1081373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081392 */     // GIR_Coverage, 23670,
     /* 1081392 */     GIR_EraseRootFromParent_Done,
     /* 1081393 */   // Label 15928: @1081393
     /* 1081393 */   GIM_Try, /*On fail goto*//*Label 15929*/ GIMT_Encode4(1081470), // Rule ID 23671 //
     /* 1081398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1081409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1081412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1081415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081437 */     // MIs[0] policy
     /* 1081437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081447 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1081450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081469 */     // GIR_Coverage, 23671,
     /* 1081469 */     GIR_EraseRootFromParent_Done,
     /* 1081470 */   // Label 15929: @1081470
     /* 1081470 */   GIM_Try, /*On fail goto*//*Label 15930*/ GIMT_Encode4(1081547), // Rule ID 23674 //
     /* 1081475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1081486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1081489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081514 */     // MIs[0] policy
     /* 1081514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081524 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1081527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081546 */     // GIR_Coverage, 23674,
     /* 1081546 */     GIR_EraseRootFromParent_Done,
     /* 1081547 */   // Label 15930: @1081547
     /* 1081547 */   GIM_Try, /*On fail goto*//*Label 15931*/ GIMT_Encode4(1081624), // Rule ID 23675 //
     /* 1081552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1081563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1081566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081591 */     // MIs[0] policy
     /* 1081591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081601 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1081604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081623 */     // GIR_Coverage, 23675,
     /* 1081623 */     GIR_EraseRootFromParent_Done,
     /* 1081624 */   // Label 15931: @1081624
     /* 1081624 */   GIM_Try, /*On fail goto*//*Label 15932*/ GIMT_Encode4(1081701), // Rule ID 23678 //
     /* 1081629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1081640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1081643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081668 */     // MIs[0] policy
     /* 1081668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1081681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081700 */     // GIR_Coverage, 23678,
     /* 1081700 */     GIR_EraseRootFromParent_Done,
     /* 1081701 */   // Label 15932: @1081701
     /* 1081701 */   GIM_Try, /*On fail goto*//*Label 15933*/ GIMT_Encode4(1081778), // Rule ID 23679 //
     /* 1081706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1081717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1081720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081745 */     // MIs[0] policy
     /* 1081745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081755 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1081758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081777 */     // GIR_Coverage, 23679,
     /* 1081777 */     GIR_EraseRootFromParent_Done,
     /* 1081778 */   // Label 15933: @1081778
     /* 1081778 */   GIM_Try, /*On fail goto*//*Label 15934*/ GIMT_Encode4(1081855), // Rule ID 23682 //
     /* 1081783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1081794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1081797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081822 */     // MIs[0] policy
     /* 1081822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081832 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1081835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081854 */     // GIR_Coverage, 23682,
     /* 1081854 */     GIR_EraseRootFromParent_Done,
     /* 1081855 */   // Label 15934: @1081855
     /* 1081855 */   GIM_Try, /*On fail goto*//*Label 15935*/ GIMT_Encode4(1081932), // Rule ID 23683 //
     /* 1081860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1081871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1081874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081899 */     // MIs[0] policy
     /* 1081899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081909 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1081912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081931 */     // GIR_Coverage, 23683,
     /* 1081931 */     GIR_EraseRootFromParent_Done,
     /* 1081932 */   // Label 15935: @1081932
     /* 1081932 */   GIM_Try, /*On fail goto*//*Label 15936*/ GIMT_Encode4(1082009), // Rule ID 23686 //
     /* 1081937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1081948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1081951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1081954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081976 */     // MIs[0] policy
     /* 1081976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081986 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1081989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082008 */     // GIR_Coverage, 23686,
     /* 1082008 */     GIR_EraseRootFromParent_Done,
     /* 1082009 */   // Label 15936: @1082009
     /* 1082009 */   GIM_Try, /*On fail goto*//*Label 15937*/ GIMT_Encode4(1082086), // Rule ID 23687 //
     /* 1082014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1082017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1082025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1082028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1082031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082053 */     // MIs[0] policy
     /* 1082053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082063 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1082066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082085 */     // GIR_Coverage, 23687,
     /* 1082085 */     GIR_EraseRootFromParent_Done,
     /* 1082086 */   // Label 15937: @1082086
     /* 1082086 */   GIM_Try, /*On fail goto*//*Label 15938*/ GIMT_Encode4(1082163), // Rule ID 23778 //
     /* 1082091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1082102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1082105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1082108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082130 */     // MIs[0] policy
     /* 1082130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082140 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1082143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082159 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082162 */     // GIR_Coverage, 23778,
     /* 1082162 */     GIR_EraseRootFromParent_Done,
     /* 1082163 */   // Label 15938: @1082163
     /* 1082163 */   GIM_Try, /*On fail goto*//*Label 15939*/ GIMT_Encode4(1082240), // Rule ID 23779 //
     /* 1082168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1082179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1082182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1082185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082207 */     // MIs[0] policy
     /* 1082207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082217 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1082220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082239 */     // GIR_Coverage, 23779,
     /* 1082239 */     GIR_EraseRootFromParent_Done,
     /* 1082240 */   // Label 15939: @1082240
     /* 1082240 */   GIM_Try, /*On fail goto*//*Label 15940*/ GIMT_Encode4(1082317), // Rule ID 23782 //
     /* 1082245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1082256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1082259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1082262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082284 */     // MIs[0] policy
     /* 1082284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082294 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1082297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082316 */     // GIR_Coverage, 23782,
     /* 1082316 */     GIR_EraseRootFromParent_Done,
     /* 1082317 */   // Label 15940: @1082317
     /* 1082317 */   GIM_Try, /*On fail goto*//*Label 15941*/ GIMT_Encode4(1082394), // Rule ID 23783 //
     /* 1082322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1082333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1082336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1082339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082361 */     // MIs[0] policy
     /* 1082361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082371 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1082374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082393 */     // GIR_Coverage, 23783,
     /* 1082393 */     GIR_EraseRootFromParent_Done,
     /* 1082394 */   // Label 15941: @1082394
     /* 1082394 */   GIM_Try, /*On fail goto*//*Label 15942*/ GIMT_Encode4(1082471), // Rule ID 23786 //
     /* 1082399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1082410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1082413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1082416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082438 */     // MIs[0] policy
     /* 1082438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082448 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1082451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082470 */     // GIR_Coverage, 23786,
     /* 1082470 */     GIR_EraseRootFromParent_Done,
     /* 1082471 */   // Label 15942: @1082471
     /* 1082471 */   GIM_Try, /*On fail goto*//*Label 15943*/ GIMT_Encode4(1082548), // Rule ID 23787 //
     /* 1082476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1082487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1082490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1082493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082515 */     // MIs[0] policy
     /* 1082515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082525 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1082528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082547 */     // GIR_Coverage, 23787,
     /* 1082547 */     GIR_EraseRootFromParent_Done,
     /* 1082548 */   // Label 15943: @1082548
     /* 1082548 */   GIM_Try, /*On fail goto*//*Label 15944*/ GIMT_Encode4(1082625), // Rule ID 23790 //
     /* 1082553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1082564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1082567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1082570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082592 */     // MIs[0] policy
     /* 1082592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082602 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1082605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082624 */     // GIR_Coverage, 23790,
     /* 1082624 */     GIR_EraseRootFromParent_Done,
     /* 1082625 */   // Label 15944: @1082625
     /* 1082625 */   GIM_Try, /*On fail goto*//*Label 15945*/ GIMT_Encode4(1082702), // Rule ID 23791 //
     /* 1082630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1082641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1082644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1082647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082669 */     // MIs[0] policy
     /* 1082669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082679 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1082682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082701 */     // GIR_Coverage, 23791,
     /* 1082701 */     GIR_EraseRootFromParent_Done,
     /* 1082702 */   // Label 15945: @1082702
     /* 1082702 */   GIM_Try, /*On fail goto*//*Label 15946*/ GIMT_Encode4(1082779), // Rule ID 23794 //
     /* 1082707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1082718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1082721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1082724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082746 */     // MIs[0] policy
     /* 1082746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082756 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1082759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082778 */     // GIR_Coverage, 23794,
     /* 1082778 */     GIR_EraseRootFromParent_Done,
     /* 1082779 */   // Label 15946: @1082779
     /* 1082779 */   GIM_Try, /*On fail goto*//*Label 15947*/ GIMT_Encode4(1082856), // Rule ID 23795 //
     /* 1082784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1082795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1082798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1082801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082823 */     // MIs[0] policy
     /* 1082823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082833 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1082836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082855 */     // GIR_Coverage, 23795,
     /* 1082855 */     GIR_EraseRootFromParent_Done,
     /* 1082856 */   // Label 15947: @1082856
     /* 1082856 */   GIM_Try, /*On fail goto*//*Label 15948*/ GIMT_Encode4(1082933), // Rule ID 23798 //
     /* 1082861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1082872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1082875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1082878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082900 */     // MIs[0] policy
     /* 1082900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082910 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1082913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082932 */     // GIR_Coverage, 23798,
     /* 1082932 */     GIR_EraseRootFromParent_Done,
     /* 1082933 */   // Label 15948: @1082933
     /* 1082933 */   GIM_Try, /*On fail goto*//*Label 15949*/ GIMT_Encode4(1083010), // Rule ID 23799 //
     /* 1082938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1082949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1082952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1082955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082977 */     // MIs[0] policy
     /* 1082977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082987 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1082990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083009 */     // GIR_Coverage, 23799,
     /* 1083009 */     GIR_EraseRootFromParent_Done,
     /* 1083010 */   // Label 15949: @1083010
     /* 1083010 */   GIM_Try, /*On fail goto*//*Label 15950*/ GIMT_Encode4(1083087), // Rule ID 23802 //
     /* 1083015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1083026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1083029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1083032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083054 */     // MIs[0] policy
     /* 1083054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083064 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083086 */     // GIR_Coverage, 23802,
     /* 1083086 */     GIR_EraseRootFromParent_Done,
     /* 1083087 */   // Label 15950: @1083087
     /* 1083087 */   GIM_Try, /*On fail goto*//*Label 15951*/ GIMT_Encode4(1083164), // Rule ID 23803 //
     /* 1083092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1083103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1083106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1083109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083131 */     // MIs[0] policy
     /* 1083131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083141 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083163 */     // GIR_Coverage, 23803,
     /* 1083163 */     GIR_EraseRootFromParent_Done,
     /* 1083164 */   // Label 15951: @1083164
     /* 1083164 */   GIM_Try, /*On fail goto*//*Label 15952*/ GIMT_Encode4(1083241), // Rule ID 23806 //
     /* 1083169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1083180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1083183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1083186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083208 */     // MIs[0] policy
     /* 1083208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083218 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083240 */     // GIR_Coverage, 23806,
     /* 1083240 */     GIR_EraseRootFromParent_Done,
     /* 1083241 */   // Label 15952: @1083241
     /* 1083241 */   GIM_Try, /*On fail goto*//*Label 15953*/ GIMT_Encode4(1083318), // Rule ID 23807 //
     /* 1083246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1083257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1083260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1083263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083285 */     // MIs[0] policy
     /* 1083285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083295 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083317 */     // GIR_Coverage, 23807,
     /* 1083317 */     GIR_EraseRootFromParent_Done,
     /* 1083318 */   // Label 15953: @1083318
     /* 1083318 */   GIM_Try, /*On fail goto*//*Label 15954*/ GIMT_Encode4(1083395), // Rule ID 23810 //
     /* 1083323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1083334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1083337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1083340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083362 */     // MIs[0] policy
     /* 1083362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083372 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083394 */     // GIR_Coverage, 23810,
     /* 1083394 */     GIR_EraseRootFromParent_Done,
     /* 1083395 */   // Label 15954: @1083395
     /* 1083395 */   GIM_Try, /*On fail goto*//*Label 15955*/ GIMT_Encode4(1083472), // Rule ID 23811 //
     /* 1083400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1083411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1083414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1083417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083439 */     // MIs[0] policy
     /* 1083439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083449 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083471 */     // GIR_Coverage, 23811,
     /* 1083471 */     GIR_EraseRootFromParent_Done,
     /* 1083472 */   // Label 15955: @1083472
     /* 1083472 */   GIM_Try, /*On fail goto*//*Label 15956*/ GIMT_Encode4(1083549), // Rule ID 23814 //
     /* 1083477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1083480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1083488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1083491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1083494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083516 */     // MIs[0] policy
     /* 1083516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083548 */     // GIR_Coverage, 23814,
     /* 1083548 */     GIR_EraseRootFromParent_Done,
     /* 1083549 */   // Label 15956: @1083549
     /* 1083549 */   GIM_Try, /*On fail goto*//*Label 15957*/ GIMT_Encode4(1083626), // Rule ID 23815 //
     /* 1083554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1083557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1083565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1083568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1083571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083593 */     // MIs[0] policy
     /* 1083593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083603 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083625 */     // GIR_Coverage, 23815,
     /* 1083625 */     GIR_EraseRootFromParent_Done,
     /* 1083626 */   // Label 15957: @1083626
     /* 1083626 */   GIM_Try, /*On fail goto*//*Label 15958*/ GIMT_Encode4(1083703), // Rule ID 23818 //
     /* 1083631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1083642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1083645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1083648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083670 */     // MIs[0] policy
     /* 1083670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083680 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1083683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083702 */     // GIR_Coverage, 23818,
     /* 1083702 */     GIR_EraseRootFromParent_Done,
     /* 1083703 */   // Label 15958: @1083703
     /* 1083703 */   GIM_Try, /*On fail goto*//*Label 15959*/ GIMT_Encode4(1083780), // Rule ID 23819 //
     /* 1083708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1083719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1083722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1083725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083747 */     // MIs[0] policy
     /* 1083747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083757 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1083760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083779 */     // GIR_Coverage, 23819,
     /* 1083779 */     GIR_EraseRootFromParent_Done,
     /* 1083780 */   // Label 15959: @1083780
     /* 1083780 */   GIM_Try, /*On fail goto*//*Label 15960*/ GIMT_Encode4(1083857), // Rule ID 23822 //
     /* 1083785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1083796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1083799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1083802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083824 */     // MIs[0] policy
     /* 1083824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083834 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1083837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083856 */     // GIR_Coverage, 23822,
     /* 1083856 */     GIR_EraseRootFromParent_Done,
     /* 1083857 */   // Label 15960: @1083857
     /* 1083857 */   GIM_Try, /*On fail goto*//*Label 15961*/ GIMT_Encode4(1083934), // Rule ID 23823 //
     /* 1083862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1083873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1083876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1083879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083901 */     // MIs[0] policy
     /* 1083901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083911 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1083914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083933 */     // GIR_Coverage, 23823,
     /* 1083933 */     GIR_EraseRootFromParent_Done,
     /* 1083934 */   // Label 15961: @1083934
     /* 1083934 */   GIM_Try, /*On fail goto*//*Label 15962*/ GIMT_Encode4(1084011), // Rule ID 23826 //
     /* 1083939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1083950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1083953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1083956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083978 */     // MIs[0] policy
     /* 1083978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083988 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1083991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1084007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084010 */     // GIR_Coverage, 23826,
     /* 1084010 */     GIR_EraseRootFromParent_Done,
     /* 1084011 */   // Label 15962: @1084011
     /* 1084011 */   GIM_Try, /*On fail goto*//*Label 15963*/ GIMT_Encode4(1084088), // Rule ID 23827 //
     /* 1084016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1084027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1084030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1084033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084055 */     // MIs[0] policy
     /* 1084055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084065 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1084068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1084084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084087 */     // GIR_Coverage, 23827,
     /* 1084087 */     GIR_EraseRootFromParent_Done,
     /* 1084088 */   // Label 15963: @1084088
     /* 1084088 */   GIM_Try, /*On fail goto*//*Label 15964*/ GIMT_Encode4(1084165), // Rule ID 23830 //
     /* 1084093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1084104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1084107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1084110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084132 */     // MIs[0] policy
     /* 1084132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084142 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084164 */     // GIR_Coverage, 23830,
     /* 1084164 */     GIR_EraseRootFromParent_Done,
     /* 1084165 */   // Label 15964: @1084165
     /* 1084165 */   GIM_Try, /*On fail goto*//*Label 15965*/ GIMT_Encode4(1084242), // Rule ID 23831 //
     /* 1084170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1084181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1084184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1084187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084209 */     // MIs[0] policy
     /* 1084209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084219 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084241 */     // GIR_Coverage, 23831,
     /* 1084241 */     GIR_EraseRootFromParent_Done,
     /* 1084242 */   // Label 15965: @1084242
     /* 1084242 */   GIM_Try, /*On fail goto*//*Label 15966*/ GIMT_Encode4(1084319), // Rule ID 23834 //
     /* 1084247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1084258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1084261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1084264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084286 */     // MIs[0] policy
     /* 1084286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1084299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084318 */     // GIR_Coverage, 23834,
     /* 1084318 */     GIR_EraseRootFromParent_Done,
     /* 1084319 */   // Label 15966: @1084319
     /* 1084319 */   GIM_Try, /*On fail goto*//*Label 15967*/ GIMT_Encode4(1084396), // Rule ID 23835 //
     /* 1084324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1084335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1084338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1084341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084363 */     // MIs[0] policy
     /* 1084363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084373 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1084376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084395 */     // GIR_Coverage, 23835,
     /* 1084395 */     GIR_EraseRootFromParent_Done,
     /* 1084396 */   // Label 15967: @1084396
     /* 1084396 */   GIM_Try, /*On fail goto*//*Label 15968*/ GIMT_Encode4(1084473), // Rule ID 23838 //
     /* 1084401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1084412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1084415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1084418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084440 */     // MIs[0] policy
     /* 1084440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084450 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1084453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084472 */     // GIR_Coverage, 23838,
     /* 1084472 */     GIR_EraseRootFromParent_Done,
     /* 1084473 */   // Label 15968: @1084473
     /* 1084473 */   GIM_Try, /*On fail goto*//*Label 15969*/ GIMT_Encode4(1084550), // Rule ID 23839 //
     /* 1084478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1084489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1084492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1084495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084517 */     // MIs[0] policy
     /* 1084517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084527 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1084530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084549 */     // GIR_Coverage, 23839,
     /* 1084549 */     GIR_EraseRootFromParent_Done,
     /* 1084550 */   // Label 15969: @1084550
     /* 1084550 */   GIM_Try, /*On fail goto*//*Label 15970*/ GIMT_Encode4(1084627), // Rule ID 23842 //
     /* 1084555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1084566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1084569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1084572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084594 */     // MIs[0] policy
     /* 1084594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084626 */     // GIR_Coverage, 23842,
     /* 1084626 */     GIR_EraseRootFromParent_Done,
     /* 1084627 */   // Label 15970: @1084627
     /* 1084627 */   GIM_Try, /*On fail goto*//*Label 15971*/ GIMT_Encode4(1084704), // Rule ID 23843 //
     /* 1084632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1084643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1084646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1084649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084671 */     // MIs[0] policy
     /* 1084671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084703 */     // GIR_Coverage, 23843,
     /* 1084703 */     GIR_EraseRootFromParent_Done,
     /* 1084704 */   // Label 15971: @1084704
     /* 1084704 */   GIM_Try, /*On fail goto*//*Label 15972*/ GIMT_Encode4(1084781), // Rule ID 23846 //
     /* 1084709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1084720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1084723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1084726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084748 */     // MIs[0] policy
     /* 1084748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084758 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1084761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084777 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084780 */     // GIR_Coverage, 23846,
     /* 1084780 */     GIR_EraseRootFromParent_Done,
     /* 1084781 */   // Label 15972: @1084781
     /* 1084781 */   GIM_Try, /*On fail goto*//*Label 15973*/ GIMT_Encode4(1084858), // Rule ID 23847 //
     /* 1084786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1084797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1084800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1084803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084825 */     // MIs[0] policy
     /* 1084825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084835 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1084838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084857 */     // GIR_Coverage, 23847,
     /* 1084857 */     GIR_EraseRootFromParent_Done,
     /* 1084858 */   // Label 15973: @1084858
     /* 1084858 */   GIM_Try, /*On fail goto*//*Label 15974*/ GIMT_Encode4(1084935), // Rule ID 23850 //
     /* 1084863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1084874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1084877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1084880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084902 */     // MIs[0] policy
     /* 1084902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084912 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1084915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084934 */     // GIR_Coverage, 23850,
     /* 1084934 */     GIR_EraseRootFromParent_Done,
     /* 1084935 */   // Label 15974: @1084935
     /* 1084935 */   GIM_Try, /*On fail goto*//*Label 15975*/ GIMT_Encode4(1085012), // Rule ID 23851 //
     /* 1084940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1084951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1084954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1084957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084979 */     // MIs[0] policy
     /* 1084979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084989 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1084992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085011 */     // GIR_Coverage, 23851,
     /* 1085011 */     GIR_EraseRootFromParent_Done,
     /* 1085012 */   // Label 15975: @1085012
     /* 1085012 */   GIM_Try, /*On fail goto*//*Label 15976*/ GIMT_Encode4(1085089), // Rule ID 23854 //
     /* 1085017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1085020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1085028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1085031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1085034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085056 */     // MIs[0] policy
     /* 1085056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085066 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085088 */     // GIR_Coverage, 23854,
     /* 1085088 */     GIR_EraseRootFromParent_Done,
     /* 1085089 */   // Label 15976: @1085089
     /* 1085089 */   GIM_Try, /*On fail goto*//*Label 15977*/ GIMT_Encode4(1085166), // Rule ID 23855 //
     /* 1085094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1085097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1085105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1085108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1085111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085133 */     // MIs[0] policy
     /* 1085133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085165 */     // GIR_Coverage, 23855,
     /* 1085165 */     GIR_EraseRootFromParent_Done,
     /* 1085166 */   // Label 15977: @1085166
     /* 1085166 */   GIM_Try, /*On fail goto*//*Label 15978*/ GIMT_Encode4(1085243), // Rule ID 23858 //
     /* 1085171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1085174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1085182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1085185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1085188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085210 */     // MIs[0] policy
     /* 1085210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085220 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085239 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085242 */     // GIR_Coverage, 23858,
     /* 1085242 */     GIR_EraseRootFromParent_Done,
     /* 1085243 */   // Label 15978: @1085243
     /* 1085243 */   GIM_Try, /*On fail goto*//*Label 15979*/ GIMT_Encode4(1085320), // Rule ID 23859 //
     /* 1085248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1085251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1085259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1085262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1085265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085287 */     // MIs[0] policy
     /* 1085287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085297 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085319 */     // GIR_Coverage, 23859,
     /* 1085319 */     GIR_EraseRootFromParent_Done,
     /* 1085320 */   // Label 15979: @1085320
     /* 1085320 */   GIM_Try, /*On fail goto*//*Label 15980*/ GIMT_Encode4(1085397), // Rule ID 23862 //
     /* 1085325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1085328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1085336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1085339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1085342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085364 */     // MIs[0] policy
     /* 1085364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085374 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085396 */     // GIR_Coverage, 23862,
     /* 1085396 */     GIR_EraseRootFromParent_Done,
     /* 1085397 */   // Label 15980: @1085397
     /* 1085397 */   GIM_Try, /*On fail goto*//*Label 15981*/ GIMT_Encode4(1085474), // Rule ID 23863 //
     /* 1085402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1085405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1085413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1085416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1085419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085441 */     // MIs[0] policy
     /* 1085441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085451 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085473 */     // GIR_Coverage, 23863,
     /* 1085473 */     GIR_EraseRootFromParent_Done,
     /* 1085474 */   // Label 15981: @1085474
     /* 1085474 */   GIM_Try, /*On fail goto*//*Label 15982*/ GIMT_Encode4(1085551), // Rule ID 24130 //
     /* 1085479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1085482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1085490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1085493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1085496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085518 */     // MIs[0] policy
     /* 1085518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085528 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1085531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085550 */     // GIR_Coverage, 24130,
     /* 1085550 */     GIR_EraseRootFromParent_Done,
     /* 1085551 */   // Label 15982: @1085551
     /* 1085551 */   GIM_Try, /*On fail goto*//*Label 15983*/ GIMT_Encode4(1085628), // Rule ID 24131 //
     /* 1085556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1085559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1085567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1085570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1085573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085595 */     // MIs[0] policy
     /* 1085595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085605 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1085608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085627 */     // GIR_Coverage, 24131,
     /* 1085627 */     GIR_EraseRootFromParent_Done,
     /* 1085628 */   // Label 15983: @1085628
     /* 1085628 */   GIM_Try, /*On fail goto*//*Label 15984*/ GIMT_Encode4(1085705), // Rule ID 24134 //
     /* 1085633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1085636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1085644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1085647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1085650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085672 */     // MIs[0] policy
     /* 1085672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085682 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1085685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085704 */     // GIR_Coverage, 24134,
     /* 1085704 */     GIR_EraseRootFromParent_Done,
     /* 1085705 */   // Label 15984: @1085705
     /* 1085705 */   GIM_Try, /*On fail goto*//*Label 15985*/ GIMT_Encode4(1085782), // Rule ID 24135 //
     /* 1085710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1085713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1085721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1085724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1085727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085749 */     // MIs[0] policy
     /* 1085749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085759 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1085762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085781 */     // GIR_Coverage, 24135,
     /* 1085781 */     GIR_EraseRootFromParent_Done,
     /* 1085782 */   // Label 15985: @1085782
     /* 1085782 */   GIM_Try, /*On fail goto*//*Label 15986*/ GIMT_Encode4(1085859), // Rule ID 24138 //
     /* 1085787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1085790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1085798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1085801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1085804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085826 */     // MIs[0] policy
     /* 1085826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085836 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1085839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085858 */     // GIR_Coverage, 24138,
     /* 1085858 */     GIR_EraseRootFromParent_Done,
     /* 1085859 */   // Label 15986: @1085859
     /* 1085859 */   GIM_Try, /*On fail goto*//*Label 15987*/ GIMT_Encode4(1085936), // Rule ID 24139 //
     /* 1085864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1085867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1085875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1085878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1085881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085903 */     // MIs[0] policy
     /* 1085903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085913 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1085916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085935 */     // GIR_Coverage, 24139,
     /* 1085935 */     GIR_EraseRootFromParent_Done,
     /* 1085936 */   // Label 15987: @1085936
     /* 1085936 */   GIM_Try, /*On fail goto*//*Label 15988*/ GIMT_Encode4(1086013), // Rule ID 24142 //
     /* 1085941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1085944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1085952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1085955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1085958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085980 */     // MIs[0] policy
     /* 1085980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085990 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1085993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086012 */     // GIR_Coverage, 24142,
     /* 1086012 */     GIR_EraseRootFromParent_Done,
     /* 1086013 */   // Label 15988: @1086013
     /* 1086013 */   GIM_Try, /*On fail goto*//*Label 15989*/ GIMT_Encode4(1086090), // Rule ID 24143 //
     /* 1086018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1086021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1086029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1086032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1086035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086057 */     // MIs[0] policy
     /* 1086057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086067 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1086070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086089 */     // GIR_Coverage, 24143,
     /* 1086089 */     GIR_EraseRootFromParent_Done,
     /* 1086090 */   // Label 15989: @1086090
     /* 1086090 */   GIM_Try, /*On fail goto*//*Label 15990*/ GIMT_Encode4(1086167), // Rule ID 24146 //
     /* 1086095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1086098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1086106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1086109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1086112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086134 */     // MIs[0] policy
     /* 1086134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086144 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1086147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086166 */     // GIR_Coverage, 24146,
     /* 1086166 */     GIR_EraseRootFromParent_Done,
     /* 1086167 */   // Label 15990: @1086167
     /* 1086167 */   GIM_Try, /*On fail goto*//*Label 15991*/ GIMT_Encode4(1086244), // Rule ID 24147 //
     /* 1086172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1086175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1086183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1086186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1086189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086211 */     // MIs[0] policy
     /* 1086211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086221 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1086224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086243 */     // GIR_Coverage, 24147,
     /* 1086243 */     GIR_EraseRootFromParent_Done,
     /* 1086244 */   // Label 15991: @1086244
     /* 1086244 */   GIM_Try, /*On fail goto*//*Label 15992*/ GIMT_Encode4(1086321), // Rule ID 24150 //
     /* 1086249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1086252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1086260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1086263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1086266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086288 */     // MIs[0] policy
     /* 1086288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086298 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1086301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086320 */     // GIR_Coverage, 24150,
     /* 1086320 */     GIR_EraseRootFromParent_Done,
     /* 1086321 */   // Label 15992: @1086321
     /* 1086321 */   GIM_Try, /*On fail goto*//*Label 15993*/ GIMT_Encode4(1086398), // Rule ID 24151 //
     /* 1086326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1086329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1086337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1086340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1086343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086365 */     // MIs[0] policy
     /* 1086365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086375 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1086378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086397 */     // GIR_Coverage, 24151,
     /* 1086397 */     GIR_EraseRootFromParent_Done,
     /* 1086398 */   // Label 15993: @1086398
     /* 1086398 */   GIM_Try, /*On fail goto*//*Label 15994*/ GIMT_Encode4(1086475), // Rule ID 24154 //
     /* 1086403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1086406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1086414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1086417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1086420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086442 */     // MIs[0] policy
     /* 1086442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086452 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1086455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086474 */     // GIR_Coverage, 24154,
     /* 1086474 */     GIR_EraseRootFromParent_Done,
     /* 1086475 */   // Label 15994: @1086475
     /* 1086475 */   GIM_Try, /*On fail goto*//*Label 15995*/ GIMT_Encode4(1086552), // Rule ID 24155 //
     /* 1086480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1086483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1086491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1086494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1086497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086519 */     // MIs[0] policy
     /* 1086519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086529 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1086532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086551 */     // GIR_Coverage, 24155,
     /* 1086551 */     GIR_EraseRootFromParent_Done,
     /* 1086552 */   // Label 15995: @1086552
     /* 1086552 */   GIM_Try, /*On fail goto*//*Label 15996*/ GIMT_Encode4(1086629), // Rule ID 24158 //
     /* 1086557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1086560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1086568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1086571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1086574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086596 */     // MIs[0] policy
     /* 1086596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086606 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1086609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086628 */     // GIR_Coverage, 24158,
     /* 1086628 */     GIR_EraseRootFromParent_Done,
     /* 1086629 */   // Label 15996: @1086629
     /* 1086629 */   GIM_Try, /*On fail goto*//*Label 15997*/ GIMT_Encode4(1086706), // Rule ID 24159 //
     /* 1086634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1086637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1086645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1086648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1086651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086673 */     // MIs[0] policy
     /* 1086673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086683 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1086686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086705 */     // GIR_Coverage, 24159,
     /* 1086705 */     GIR_EraseRootFromParent_Done,
     /* 1086706 */   // Label 15997: @1086706
     /* 1086706 */   GIM_Try, /*On fail goto*//*Label 15998*/ GIMT_Encode4(1086783), // Rule ID 24162 //
     /* 1086711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1086714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1086722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1086725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1086728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086750 */     // MIs[0] policy
     /* 1086750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086760 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1086763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086782 */     // GIR_Coverage, 24162,
     /* 1086782 */     GIR_EraseRootFromParent_Done,
     /* 1086783 */   // Label 15998: @1086783
     /* 1086783 */   GIM_Try, /*On fail goto*//*Label 15999*/ GIMT_Encode4(1086860), // Rule ID 24163 //
     /* 1086788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1086791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1086799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1086802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1086805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086827 */     // MIs[0] policy
     /* 1086827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086837 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1086840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086859 */     // GIR_Coverage, 24163,
     /* 1086859 */     GIR_EraseRootFromParent_Done,
     /* 1086860 */   // Label 15999: @1086860
     /* 1086860 */   GIM_Try, /*On fail goto*//*Label 16000*/ GIMT_Encode4(1086937), // Rule ID 24166 //
     /* 1086865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1086868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1086876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1086879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1086882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086904 */     // MIs[0] policy
     /* 1086904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086914 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1086917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086936 */     // GIR_Coverage, 24166,
     /* 1086936 */     GIR_EraseRootFromParent_Done,
     /* 1086937 */   // Label 16000: @1086937
     /* 1086937 */   GIM_Try, /*On fail goto*//*Label 16001*/ GIMT_Encode4(1087014), // Rule ID 24167 //
     /* 1086942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1086945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1086953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1086956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1086959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086981 */     // MIs[0] policy
     /* 1086981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086991 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1086994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087013 */     // GIR_Coverage, 24167,
     /* 1087013 */     GIR_EraseRootFromParent_Done,
     /* 1087014 */   // Label 16001: @1087014
     /* 1087014 */   GIM_Try, /*On fail goto*//*Label 16002*/ GIMT_Encode4(1087091), // Rule ID 24170 //
     /* 1087019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1087022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1087030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1087033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1087036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087058 */     // MIs[0] policy
     /* 1087058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087068 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1087071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087090 */     // GIR_Coverage, 24170,
     /* 1087090 */     GIR_EraseRootFromParent_Done,
     /* 1087091 */   // Label 16002: @1087091
     /* 1087091 */   GIM_Try, /*On fail goto*//*Label 16003*/ GIMT_Encode4(1087168), // Rule ID 24171 //
     /* 1087096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1087099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1087107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1087110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1087113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087135 */     // MIs[0] policy
     /* 1087135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087145 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1087148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087167 */     // GIR_Coverage, 24171,
     /* 1087167 */     GIR_EraseRootFromParent_Done,
     /* 1087168 */   // Label 16003: @1087168
     /* 1087168 */   GIM_Try, /*On fail goto*//*Label 16004*/ GIMT_Encode4(1087245), // Rule ID 24174 //
     /* 1087173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1087176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1087184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1087187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1087190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087212 */     // MIs[0] policy
     /* 1087212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087222 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1087225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087244 */     // GIR_Coverage, 24174,
     /* 1087244 */     GIR_EraseRootFromParent_Done,
     /* 1087245 */   // Label 16004: @1087245
     /* 1087245 */   GIM_Try, /*On fail goto*//*Label 16005*/ GIMT_Encode4(1087322), // Rule ID 24175 //
     /* 1087250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1087253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1087261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1087264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1087267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087289 */     // MIs[0] policy
     /* 1087289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087299 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1087302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087321 */     // GIR_Coverage, 24175,
     /* 1087321 */     GIR_EraseRootFromParent_Done,
     /* 1087322 */   // Label 16005: @1087322
     /* 1087322 */   GIM_Try, /*On fail goto*//*Label 16006*/ GIMT_Encode4(1087399), // Rule ID 24178 //
     /* 1087327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1087330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1087338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1087341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1087344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087366 */     // MIs[0] policy
     /* 1087366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087376 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1087379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087398 */     // GIR_Coverage, 24178,
     /* 1087398 */     GIR_EraseRootFromParent_Done,
     /* 1087399 */   // Label 16006: @1087399
     /* 1087399 */   GIM_Try, /*On fail goto*//*Label 16007*/ GIMT_Encode4(1087476), // Rule ID 24179 //
     /* 1087404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1087407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1087415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1087418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1087421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087443 */     // MIs[0] policy
     /* 1087443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087453 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1087456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087475 */     // GIR_Coverage, 24179,
     /* 1087475 */     GIR_EraseRootFromParent_Done,
     /* 1087476 */   // Label 16007: @1087476
     /* 1087476 */   GIM_Try, /*On fail goto*//*Label 16008*/ GIMT_Encode4(1087553), // Rule ID 24182 //
     /* 1087481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1087484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1087492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1087495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1087498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087520 */     // MIs[0] policy
     /* 1087520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087530 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1087533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087552 */     // GIR_Coverage, 24182,
     /* 1087552 */     GIR_EraseRootFromParent_Done,
     /* 1087553 */   // Label 16008: @1087553
     /* 1087553 */   GIM_Try, /*On fail goto*//*Label 16009*/ GIMT_Encode4(1087630), // Rule ID 24183 //
     /* 1087558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1087561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1087569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1087572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1087575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087597 */     // MIs[0] policy
     /* 1087597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087607 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1087610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087629 */     // GIR_Coverage, 24183,
     /* 1087629 */     GIR_EraseRootFromParent_Done,
     /* 1087630 */   // Label 16009: @1087630
     /* 1087630 */   GIM_Try, /*On fail goto*//*Label 16010*/ GIMT_Encode4(1087707), // Rule ID 24186 //
     /* 1087635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1087638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1087646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1087649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1087652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087674 */     // MIs[0] policy
     /* 1087674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087684 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1087687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087706 */     // GIR_Coverage, 24186,
     /* 1087706 */     GIR_EraseRootFromParent_Done,
     /* 1087707 */   // Label 16010: @1087707
     /* 1087707 */   GIM_Try, /*On fail goto*//*Label 16011*/ GIMT_Encode4(1087784), // Rule ID 24187 //
     /* 1087712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1087715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1087723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1087726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1087729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087751 */     // MIs[0] policy
     /* 1087751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087761 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1087764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087783 */     // GIR_Coverage, 24187,
     /* 1087783 */     GIR_EraseRootFromParent_Done,
     /* 1087784 */   // Label 16011: @1087784
     /* 1087784 */   GIM_Try, /*On fail goto*//*Label 16012*/ GIMT_Encode4(1087861), // Rule ID 24250 //
     /* 1087789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1087792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1087797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1087800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1087803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1087806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087828 */     // MIs[0] policy
     /* 1087828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087838 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1087841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087860 */     // GIR_Coverage, 24250,
     /* 1087860 */     GIR_EraseRootFromParent_Done,
     /* 1087861 */   // Label 16012: @1087861
     /* 1087861 */   GIM_Try, /*On fail goto*//*Label 16013*/ GIMT_Encode4(1087938), // Rule ID 24251 //
     /* 1087866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1087869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1087874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1087877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1087880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1087883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087905 */     // MIs[0] policy
     /* 1087905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087915 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1087918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087937 */     // GIR_Coverage, 24251,
     /* 1087937 */     GIR_EraseRootFromParent_Done,
     /* 1087938 */   // Label 16013: @1087938
     /* 1087938 */   GIM_Try, /*On fail goto*//*Label 16014*/ GIMT_Encode4(1088015), // Rule ID 24254 //
     /* 1087943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1087946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1087951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1087954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1087957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1087960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087982 */     // MIs[0] policy
     /* 1087982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087992 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1087995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088014 */     // GIR_Coverage, 24254,
     /* 1088014 */     GIR_EraseRootFromParent_Done,
     /* 1088015 */   // Label 16014: @1088015
     /* 1088015 */   GIM_Try, /*On fail goto*//*Label 16015*/ GIMT_Encode4(1088092), // Rule ID 24255 //
     /* 1088020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1088023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1088031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1088034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1088037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088059 */     // MIs[0] policy
     /* 1088059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088069 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1088072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088091 */     // GIR_Coverage, 24255,
     /* 1088091 */     GIR_EraseRootFromParent_Done,
     /* 1088092 */   // Label 16015: @1088092
     /* 1088092 */   GIM_Try, /*On fail goto*//*Label 16016*/ GIMT_Encode4(1088169), // Rule ID 24258 //
     /* 1088097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1088100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1088108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1088111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1088114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088136 */     // MIs[0] policy
     /* 1088136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088146 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1088149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088168 */     // GIR_Coverage, 24258,
     /* 1088168 */     GIR_EraseRootFromParent_Done,
     /* 1088169 */   // Label 16016: @1088169
     /* 1088169 */   GIM_Try, /*On fail goto*//*Label 16017*/ GIMT_Encode4(1088246), // Rule ID 24259 //
     /* 1088174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1088177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1088185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1088188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1088191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088213 */     // MIs[0] policy
     /* 1088213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088223 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1088226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088245 */     // GIR_Coverage, 24259,
     /* 1088245 */     GIR_EraseRootFromParent_Done,
     /* 1088246 */   // Label 16017: @1088246
     /* 1088246 */   GIM_Try, /*On fail goto*//*Label 16018*/ GIMT_Encode4(1088323), // Rule ID 24262 //
     /* 1088251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1088254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1088262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1088265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1088268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088290 */     // MIs[0] policy
     /* 1088290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088300 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1088303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088322 */     // GIR_Coverage, 24262,
     /* 1088322 */     GIR_EraseRootFromParent_Done,
     /* 1088323 */   // Label 16018: @1088323
     /* 1088323 */   GIM_Try, /*On fail goto*//*Label 16019*/ GIMT_Encode4(1088400), // Rule ID 24263 //
     /* 1088328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1088331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1088339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1088342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1088345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088367 */     // MIs[0] policy
     /* 1088367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088377 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1088380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088399 */     // GIR_Coverage, 24263,
     /* 1088399 */     GIR_EraseRootFromParent_Done,
     /* 1088400 */   // Label 16019: @1088400
     /* 1088400 */   GIM_Try, /*On fail goto*//*Label 16020*/ GIMT_Encode4(1088477), // Rule ID 24266 //
     /* 1088405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1088408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1088416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1088419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1088422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088444 */     // MIs[0] policy
     /* 1088444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088454 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1088457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088476 */     // GIR_Coverage, 24266,
     /* 1088476 */     GIR_EraseRootFromParent_Done,
     /* 1088477 */   // Label 16020: @1088477
     /* 1088477 */   GIM_Try, /*On fail goto*//*Label 16021*/ GIMT_Encode4(1088554), // Rule ID 24267 //
     /* 1088482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1088485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1088493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1088496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1088499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088521 */     // MIs[0] policy
     /* 1088521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088531 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1088534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088553 */     // GIR_Coverage, 24267,
     /* 1088553 */     GIR_EraseRootFromParent_Done,
     /* 1088554 */   // Label 16021: @1088554
     /* 1088554 */   GIM_Try, /*On fail goto*//*Label 16022*/ GIMT_Encode4(1088631), // Rule ID 24270 //
     /* 1088559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1088562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1088570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1088573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1088576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088598 */     // MIs[0] policy
     /* 1088598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088608 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1088611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1088627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088630 */     // GIR_Coverage, 24270,
     /* 1088630 */     GIR_EraseRootFromParent_Done,
     /* 1088631 */   // Label 16022: @1088631
     /* 1088631 */   GIM_Try, /*On fail goto*//*Label 16023*/ GIMT_Encode4(1088708), // Rule ID 24271 //
     /* 1088636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1088639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1088647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1088650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1088653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088675 */     // MIs[0] policy
     /* 1088675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088685 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1088688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1088704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088707 */     // GIR_Coverage, 24271,
     /* 1088707 */     GIR_EraseRootFromParent_Done,
     /* 1088708 */   // Label 16023: @1088708
     /* 1088708 */   GIM_Try, /*On fail goto*//*Label 16024*/ GIMT_Encode4(1088785), // Rule ID 24274 //
     /* 1088713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1088716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1088730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088752 */     // MIs[0] policy
     /* 1088752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088762 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1088765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088784 */     // GIR_Coverage, 24274,
     /* 1088784 */     GIR_EraseRootFromParent_Done,
     /* 1088785 */   // Label 16024: @1088785
     /* 1088785 */   GIM_Try, /*On fail goto*//*Label 16025*/ GIMT_Encode4(1088862), // Rule ID 24275 //
     /* 1088790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1088793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1088807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088829 */     // MIs[0] policy
     /* 1088829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088839 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1088842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088861 */     // GIR_Coverage, 24275,
     /* 1088861 */     GIR_EraseRootFromParent_Done,
     /* 1088862 */   // Label 16025: @1088862
     /* 1088862 */   GIM_Try, /*On fail goto*//*Label 16026*/ GIMT_Encode4(1088939), // Rule ID 24278 //
     /* 1088867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1088870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1088878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1088881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1088884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088906 */     // MIs[0] policy
     /* 1088906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088916 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1088919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088938 */     // GIR_Coverage, 24278,
     /* 1088938 */     GIR_EraseRootFromParent_Done,
     /* 1088939 */   // Label 16026: @1088939
     /* 1088939 */   GIM_Try, /*On fail goto*//*Label 16027*/ GIMT_Encode4(1089016), // Rule ID 24279 //
     /* 1088944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1088947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1088955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1088958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1088961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088983 */     // MIs[0] policy
     /* 1088983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088993 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1088996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089015 */     // GIR_Coverage, 24279,
     /* 1089015 */     GIR_EraseRootFromParent_Done,
     /* 1089016 */   // Label 16027: @1089016
     /* 1089016 */   GIM_Try, /*On fail goto*//*Label 16028*/ GIMT_Encode4(1089093), // Rule ID 24282 //
     /* 1089021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1089024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1089032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1089035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1089038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089060 */     // MIs[0] policy
     /* 1089060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089070 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1089073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089092 */     // GIR_Coverage, 24282,
     /* 1089092 */     GIR_EraseRootFromParent_Done,
     /* 1089093 */   // Label 16028: @1089093
     /* 1089093 */   GIM_Try, /*On fail goto*//*Label 16029*/ GIMT_Encode4(1089170), // Rule ID 24283 //
     /* 1089098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1089101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1089109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1089112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1089115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089137 */     // MIs[0] policy
     /* 1089137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089147 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1089150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089169 */     // GIR_Coverage, 24283,
     /* 1089169 */     GIR_EraseRootFromParent_Done,
     /* 1089170 */   // Label 16029: @1089170
     /* 1089170 */   GIM_Try, /*On fail goto*//*Label 16030*/ GIMT_Encode4(1089247), // Rule ID 24286 //
     /* 1089175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1089178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1089186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1089189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1089192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089214 */     // MIs[0] policy
     /* 1089214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089224 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1089227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089246 */     // GIR_Coverage, 24286,
     /* 1089246 */     GIR_EraseRootFromParent_Done,
     /* 1089247 */   // Label 16030: @1089247
     /* 1089247 */   GIM_Try, /*On fail goto*//*Label 16031*/ GIMT_Encode4(1089324), // Rule ID 24287 //
     /* 1089252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1089255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1089263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1089266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1089269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089291 */     // MIs[0] policy
     /* 1089291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089301 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1089304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089323 */     // GIR_Coverage, 24287,
     /* 1089323 */     GIR_EraseRootFromParent_Done,
     /* 1089324 */   // Label 16031: @1089324
     /* 1089324 */   GIM_Try, /*On fail goto*//*Label 16032*/ GIMT_Encode4(1089401), // Rule ID 24290 //
     /* 1089329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1089332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1089346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089368 */     // MIs[0] policy
     /* 1089368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089378 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1089381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089400 */     // GIR_Coverage, 24290,
     /* 1089400 */     GIR_EraseRootFromParent_Done,
     /* 1089401 */   // Label 16032: @1089401
     /* 1089401 */   GIM_Try, /*On fail goto*//*Label 16033*/ GIMT_Encode4(1089478), // Rule ID 24291 //
     /* 1089406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1089409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1089423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089445 */     // MIs[0] policy
     /* 1089445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089455 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1089458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089477 */     // GIR_Coverage, 24291,
     /* 1089477 */     GIR_EraseRootFromParent_Done,
     /* 1089478 */   // Label 16033: @1089478
     /* 1089478 */   GIM_Try, /*On fail goto*//*Label 16034*/ GIMT_Encode4(1089555), // Rule ID 24294 //
     /* 1089483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1089486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1089494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1089497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1089500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089522 */     // MIs[0] policy
     /* 1089522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089532 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1089535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089554 */     // GIR_Coverage, 24294,
     /* 1089554 */     GIR_EraseRootFromParent_Done,
     /* 1089555 */   // Label 16034: @1089555
     /* 1089555 */   GIM_Try, /*On fail goto*//*Label 16035*/ GIMT_Encode4(1089632), // Rule ID 24295 //
     /* 1089560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1089563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1089571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1089574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1089577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089599 */     // MIs[0] policy
     /* 1089599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089609 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1089612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089631 */     // GIR_Coverage, 24295,
     /* 1089631 */     GIR_EraseRootFromParent_Done,
     /* 1089632 */   // Label 16035: @1089632
     /* 1089632 */   GIM_Try, /*On fail goto*//*Label 16036*/ GIMT_Encode4(1089709), // Rule ID 24298 //
     /* 1089637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1089640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1089648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1089651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089676 */     // MIs[0] policy
     /* 1089676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089686 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1089689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089708 */     // GIR_Coverage, 24298,
     /* 1089708 */     GIR_EraseRootFromParent_Done,
     /* 1089709 */   // Label 16036: @1089709
     /* 1089709 */   GIM_Try, /*On fail goto*//*Label 16037*/ GIMT_Encode4(1089786), // Rule ID 24299 //
     /* 1089714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1089717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1089725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1089728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089753 */     // MIs[0] policy
     /* 1089753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089763 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1089766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089785 */     // GIR_Coverage, 24299,
     /* 1089785 */     GIR_EraseRootFromParent_Done,
     /* 1089786 */   // Label 16037: @1089786
     /* 1089786 */   GIM_Try, /*On fail goto*//*Label 16038*/ GIMT_Encode4(1089863), // Rule ID 24302 //
     /* 1089791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1089794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1089802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1089805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1089808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089830 */     // MIs[0] policy
     /* 1089830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089840 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1089843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089862 */     // GIR_Coverage, 24302,
     /* 1089862 */     GIR_EraseRootFromParent_Done,
     /* 1089863 */   // Label 16038: @1089863
     /* 1089863 */   GIM_Try, /*On fail goto*//*Label 16039*/ GIMT_Encode4(1089940), // Rule ID 24303 //
     /* 1089868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1089871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1089879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1089882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1089885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089907 */     // MIs[0] policy
     /* 1089907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089917 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1089920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089939 */     // GIR_Coverage, 24303,
     /* 1089939 */     GIR_EraseRootFromParent_Done,
     /* 1089940 */   // Label 16039: @1089940
     /* 1089940 */   GIM_Try, /*On fail goto*//*Label 16040*/ GIMT_Encode4(1090017), // Rule ID 24306 //
     /* 1089945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1089948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1089956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1089959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1089962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089984 */     // MIs[0] policy
     /* 1089984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089994 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1089997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1090001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090016 */     // GIR_Coverage, 24306,
     /* 1090016 */     GIR_EraseRootFromParent_Done,
     /* 1090017 */   // Label 16040: @1090017
     /* 1090017 */   GIM_Try, /*On fail goto*//*Label 16041*/ GIMT_Encode4(1090094), // Rule ID 24307 //
     /* 1090022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1090025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1090030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1090033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1090036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1090039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1090042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1090061 */     // MIs[0] policy
     /* 1090061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090071 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1090074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1090078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090093 */     // GIR_Coverage, 24307,
     /* 1090093 */     GIR_EraseRootFromParent_Done,
     /* 1090094 */   // Label 16041: @1090094
     /* 1090094 */   GIM_Try, /*On fail goto*//*Label 16042*/ GIMT_Encode4(1090171), // Rule ID 60598 //
     /* 1090099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1090102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1090107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1090110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1090113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1090116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1090119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090138 */     // MIs[0] policy
     /* 1090138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090148 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1090151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1090153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1090155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090170 */     // GIR_Coverage, 60598,
     /* 1090170 */     GIR_EraseRootFromParent_Done,
     /* 1090171 */   // Label 16042: @1090171
     /* 1090171 */   GIM_Try, /*On fail goto*//*Label 16043*/ GIMT_Encode4(1090248), // Rule ID 60599 //
     /* 1090176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1090179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1090184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1090187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1090190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1090193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1090196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090215 */     // MIs[0] policy
     /* 1090215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090225 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1090228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1090230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1090232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090247 */     // GIR_Coverage, 60599,
     /* 1090247 */     GIR_EraseRootFromParent_Done,
     /* 1090248 */   // Label 16043: @1090248
     /* 1090248 */   GIM_Try, /*On fail goto*//*Label 16044*/ GIMT_Encode4(1090325), // Rule ID 60612 //
     /* 1090253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1090264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1090267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1090270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090292 */     // MIs[0] policy
     /* 1090292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090302 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1090305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090324 */     // GIR_Coverage, 60612,
     /* 1090324 */     GIR_EraseRootFromParent_Done,
     /* 1090325 */   // Label 16044: @1090325
     /* 1090325 */   GIM_Try, /*On fail goto*//*Label 16045*/ GIMT_Encode4(1090402), // Rule ID 60613 //
     /* 1090330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1090341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1090344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1090347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090369 */     // MIs[0] policy
     /* 1090369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090379 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1090382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090388 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090401 */     // GIR_Coverage, 60613,
     /* 1090401 */     GIR_EraseRootFromParent_Done,
     /* 1090402 */   // Label 16045: @1090402
     /* 1090402 */   GIM_Try, /*On fail goto*//*Label 16046*/ GIMT_Encode4(1090479), // Rule ID 60616 //
     /* 1090407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1090418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1090421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1090424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090446 */     // MIs[0] policy
     /* 1090446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090456 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1090459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090478 */     // GIR_Coverage, 60616,
     /* 1090478 */     GIR_EraseRootFromParent_Done,
     /* 1090479 */   // Label 16046: @1090479
     /* 1090479 */   GIM_Try, /*On fail goto*//*Label 16047*/ GIMT_Encode4(1090556), // Rule ID 60617 //
     /* 1090484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1090495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1090498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1090501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090523 */     // MIs[0] policy
     /* 1090523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090533 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1090536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090542 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090555 */     // GIR_Coverage, 60617,
     /* 1090555 */     GIR_EraseRootFromParent_Done,
     /* 1090556 */   // Label 16047: @1090556
     /* 1090556 */   GIM_Try, /*On fail goto*//*Label 16048*/ GIMT_Encode4(1090633), // Rule ID 60620 //
     /* 1090561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1090572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1090575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1090578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090600 */     // MIs[0] policy
     /* 1090600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090610 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1090613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090632 */     // GIR_Coverage, 60620,
     /* 1090632 */     GIR_EraseRootFromParent_Done,
     /* 1090633 */   // Label 16048: @1090633
     /* 1090633 */   GIM_Try, /*On fail goto*//*Label 16049*/ GIMT_Encode4(1090710), // Rule ID 60621 //
     /* 1090638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1090649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1090652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1090655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090677 */     // MIs[0] policy
     /* 1090677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090687 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1090690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090696 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090709 */     // GIR_Coverage, 60621,
     /* 1090709 */     GIR_EraseRootFromParent_Done,
     /* 1090710 */   // Label 16049: @1090710
     /* 1090710 */   GIM_Try, /*On fail goto*//*Label 16050*/ GIMT_Encode4(1090787), // Rule ID 60624 //
     /* 1090715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1090726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1090729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1090732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090754 */     // MIs[0] policy
     /* 1090754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090764 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1090767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090786 */     // GIR_Coverage, 60624,
     /* 1090786 */     GIR_EraseRootFromParent_Done,
     /* 1090787 */   // Label 16050: @1090787
     /* 1090787 */   GIM_Try, /*On fail goto*//*Label 16051*/ GIMT_Encode4(1090864), // Rule ID 60625 //
     /* 1090792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1090803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1090806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1090809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090831 */     // MIs[0] policy
     /* 1090831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090841 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1090844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090850 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090863 */     // GIR_Coverage, 60625,
     /* 1090863 */     GIR_EraseRootFromParent_Done,
     /* 1090864 */   // Label 16051: @1090864
     /* 1090864 */   GIM_Try, /*On fail goto*//*Label 16052*/ GIMT_Encode4(1090941), // Rule ID 60628 //
     /* 1090869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1090880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1090883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1090886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090908 */     // MIs[0] policy
     /* 1090908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1090921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090940 */     // GIR_Coverage, 60628,
     /* 1090940 */     GIR_EraseRootFromParent_Done,
     /* 1090941 */   // Label 16052: @1090941
     /* 1090941 */   GIM_Try, /*On fail goto*//*Label 16053*/ GIMT_Encode4(1091018), // Rule ID 60629 //
     /* 1090946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1090957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1090960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1090963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090985 */     // MIs[0] policy
     /* 1090985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090995 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1090998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091017 */     // GIR_Coverage, 60629,
     /* 1091017 */     GIR_EraseRootFromParent_Done,
     /* 1091018 */   // Label 16053: @1091018
     /* 1091018 */   GIM_Try, /*On fail goto*//*Label 16054*/ GIMT_Encode4(1091095), // Rule ID 60632 //
     /* 1091023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1091034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1091037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1091040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091062 */     // MIs[0] policy
     /* 1091062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091072 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1091075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091094 */     // GIR_Coverage, 60632,
     /* 1091094 */     GIR_EraseRootFromParent_Done,
     /* 1091095 */   // Label 16054: @1091095
     /* 1091095 */   GIM_Try, /*On fail goto*//*Label 16055*/ GIMT_Encode4(1091172), // Rule ID 60633 //
     /* 1091100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1091111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1091114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1091117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091139 */     // MIs[0] policy
     /* 1091139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091149 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1091152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091171 */     // GIR_Coverage, 60633,
     /* 1091171 */     GIR_EraseRootFromParent_Done,
     /* 1091172 */   // Label 16055: @1091172
     /* 1091172 */   GIM_Try, /*On fail goto*//*Label 16056*/ GIMT_Encode4(1091249), // Rule ID 60636 //
     /* 1091177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1091188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1091191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1091194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091216 */     // MIs[0] policy
     /* 1091216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091248 */     // GIR_Coverage, 60636,
     /* 1091248 */     GIR_EraseRootFromParent_Done,
     /* 1091249 */   // Label 16056: @1091249
     /* 1091249 */   GIM_Try, /*On fail goto*//*Label 16057*/ GIMT_Encode4(1091326), // Rule ID 60637 //
     /* 1091254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1091265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1091268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1091271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091293 */     // MIs[0] policy
     /* 1091293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091303 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091312 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091325 */     // GIR_Coverage, 60637,
     /* 1091325 */     GIR_EraseRootFromParent_Done,
     /* 1091326 */   // Label 16057: @1091326
     /* 1091326 */   GIM_Try, /*On fail goto*//*Label 16058*/ GIMT_Encode4(1091403), // Rule ID 60640 //
     /* 1091331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1091342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1091345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1091348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1091351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091370 */     // MIs[0] policy
     /* 1091370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091380 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091402 */     // GIR_Coverage, 60640,
     /* 1091402 */     GIR_EraseRootFromParent_Done,
     /* 1091403 */   // Label 16058: @1091403
     /* 1091403 */   GIM_Try, /*On fail goto*//*Label 16059*/ GIMT_Encode4(1091480), // Rule ID 60641 //
     /* 1091408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1091419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1091422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1091425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1091428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091447 */     // MIs[0] policy
     /* 1091447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091457 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091479 */     // GIR_Coverage, 60641,
     /* 1091479 */     GIR_EraseRootFromParent_Done,
     /* 1091480 */   // Label 16059: @1091480
     /* 1091480 */   GIM_Try, /*On fail goto*//*Label 16060*/ GIMT_Encode4(1091557), // Rule ID 60644 //
     /* 1091485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1091496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1091499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1091502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1091505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091524 */     // MIs[0] policy
     /* 1091524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091556 */     // GIR_Coverage, 60644,
     /* 1091556 */     GIR_EraseRootFromParent_Done,
     /* 1091557 */   // Label 16060: @1091557
     /* 1091557 */   GIM_Try, /*On fail goto*//*Label 16061*/ GIMT_Encode4(1091634), // Rule ID 60645 //
     /* 1091562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1091573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1091576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1091579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1091582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091601 */     // MIs[0] policy
     /* 1091601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091611 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091633 */     // GIR_Coverage, 60645,
     /* 1091633 */     GIR_EraseRootFromParent_Done,
     /* 1091634 */   // Label 16061: @1091634
     /* 1091634 */   GIM_Try, /*On fail goto*//*Label 16062*/ GIMT_Encode4(1091711), // Rule ID 60648 //
     /* 1091639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1091650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1091653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1091656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091678 */     // MIs[0] policy
     /* 1091678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091688 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091710 */     // GIR_Coverage, 60648,
     /* 1091710 */     GIR_EraseRootFromParent_Done,
     /* 1091711 */   // Label 16062: @1091711
     /* 1091711 */   GIM_Try, /*On fail goto*//*Label 16063*/ GIMT_Encode4(1091788), // Rule ID 60649 //
     /* 1091716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1091727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1091730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1091733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091755 */     // MIs[0] policy
     /* 1091755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091765 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091774 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091787 */     // GIR_Coverage, 60649,
     /* 1091787 */     GIR_EraseRootFromParent_Done,
     /* 1091788 */   // Label 16063: @1091788
     /* 1091788 */   GIM_Try, /*On fail goto*//*Label 16064*/ GIMT_Encode4(1091865), // Rule ID 60652 //
     /* 1091793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1091804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1091807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1091810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091832 */     // MIs[0] policy
     /* 1091832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091842 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1091845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091864 */     // GIR_Coverage, 60652,
     /* 1091864 */     GIR_EraseRootFromParent_Done,
     /* 1091865 */   // Label 16064: @1091865
     /* 1091865 */   GIM_Try, /*On fail goto*//*Label 16065*/ GIMT_Encode4(1091942), // Rule ID 60653 //
     /* 1091870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1091881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1091884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1091887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091909 */     // MIs[0] policy
     /* 1091909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091919 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1091922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091928 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091941 */     // GIR_Coverage, 60653,
     /* 1091941 */     GIR_EraseRootFromParent_Done,
     /* 1091942 */   // Label 16065: @1091942
     /* 1091942 */   GIM_Try, /*On fail goto*//*Label 16066*/ GIMT_Encode4(1092019), // Rule ID 60656 //
     /* 1091947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1091958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1091961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1091964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1091967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091986 */     // MIs[0] policy
     /* 1091986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091996 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1091999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092018 */     // GIR_Coverage, 60656,
     /* 1092018 */     GIR_EraseRootFromParent_Done,
     /* 1092019 */   // Label 16066: @1092019
     /* 1092019 */   GIM_Try, /*On fail goto*//*Label 16067*/ GIMT_Encode4(1092096), // Rule ID 60657 //
     /* 1092024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1092035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1092038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1092041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092063 */     // MIs[0] policy
     /* 1092063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092073 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1092076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092082 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092095 */     // GIR_Coverage, 60657,
     /* 1092095 */     GIR_EraseRootFromParent_Done,
     /* 1092096 */   // Label 16067: @1092096
     /* 1092096 */   GIM_Try, /*On fail goto*//*Label 16068*/ GIMT_Encode4(1092173), // Rule ID 60660 //
     /* 1092101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1092112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1092115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1092118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1092121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092140 */     // MIs[0] policy
     /* 1092140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092150 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1092153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092172 */     // GIR_Coverage, 60660,
     /* 1092172 */     GIR_EraseRootFromParent_Done,
     /* 1092173 */   // Label 16068: @1092173
     /* 1092173 */   GIM_Try, /*On fail goto*//*Label 16069*/ GIMT_Encode4(1092250), // Rule ID 60661 //
     /* 1092178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1092189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1092192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1092195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1092198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092217 */     // MIs[0] policy
     /* 1092217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092227 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1092230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092249 */     // GIR_Coverage, 60661,
     /* 1092249 */     GIR_EraseRootFromParent_Done,
     /* 1092250 */   // Label 16069: @1092250
     /* 1092250 */   GIM_Try, /*On fail goto*//*Label 16070*/ GIMT_Encode4(1092327), // Rule ID 60664 //
     /* 1092255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1092266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1092269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1092272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092294 */     // MIs[0] policy
     /* 1092294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092304 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1092307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092326 */     // GIR_Coverage, 60664,
     /* 1092326 */     GIR_EraseRootFromParent_Done,
     /* 1092327 */   // Label 16070: @1092327
     /* 1092327 */   GIM_Try, /*On fail goto*//*Label 16071*/ GIMT_Encode4(1092404), // Rule ID 60665 //
     /* 1092332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1092343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1092346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1092349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092371 */     // MIs[0] policy
     /* 1092371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092381 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1092384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092390 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092403 */     // GIR_Coverage, 60665,
     /* 1092403 */     GIR_EraseRootFromParent_Done,
     /* 1092404 */   // Label 16071: @1092404
     /* 1092404 */   GIM_Try, /*On fail goto*//*Label 16072*/ GIMT_Encode4(1092481), // Rule ID 60668 //
     /* 1092409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1092420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1092423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1092426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092448 */     // MIs[0] policy
     /* 1092448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092458 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1092461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092480 */     // GIR_Coverage, 60668,
     /* 1092480 */     GIR_EraseRootFromParent_Done,
     /* 1092481 */   // Label 16072: @1092481
     /* 1092481 */   GIM_Try, /*On fail goto*//*Label 16073*/ GIMT_Encode4(1092558), // Rule ID 60669 //
     /* 1092486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1092497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1092500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1092503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092525 */     // MIs[0] policy
     /* 1092525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092535 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1092538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092557 */     // GIR_Coverage, 60669,
     /* 1092557 */     GIR_EraseRootFromParent_Done,
     /* 1092558 */   // Label 16073: @1092558
     /* 1092558 */   GIM_Try, /*On fail goto*//*Label 16074*/ GIMT_Encode4(1092635), // Rule ID 60672 //
     /* 1092563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1092574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1092577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1092580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092602 */     // MIs[0] policy
     /* 1092602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092612 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1092615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092634 */     // GIR_Coverage, 60672,
     /* 1092634 */     GIR_EraseRootFromParent_Done,
     /* 1092635 */   // Label 16074: @1092635
     /* 1092635 */   GIM_Try, /*On fail goto*//*Label 16075*/ GIMT_Encode4(1092712), // Rule ID 60673 //
     /* 1092640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1092651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1092654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1092657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092679 */     // MIs[0] policy
     /* 1092679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092689 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1092692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092711 */     // GIR_Coverage, 60673,
     /* 1092711 */     GIR_EraseRootFromParent_Done,
     /* 1092712 */   // Label 16075: @1092712
     /* 1092712 */   GIM_Try, /*On fail goto*//*Label 16076*/ GIMT_Encode4(1092789), // Rule ID 60676 //
     /* 1092717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1092728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1092731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1092734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092756 */     // MIs[0] policy
     /* 1092756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1092769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092788 */     // GIR_Coverage, 60676,
     /* 1092788 */     GIR_EraseRootFromParent_Done,
     /* 1092789 */   // Label 16076: @1092789
     /* 1092789 */   GIM_Try, /*On fail goto*//*Label 16077*/ GIMT_Encode4(1092866), // Rule ID 60677 //
     /* 1092794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1092805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1092808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1092811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092833 */     // MIs[0] policy
     /* 1092833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092843 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1092846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092865 */     // GIR_Coverage, 60677,
     /* 1092865 */     GIR_EraseRootFromParent_Done,
     /* 1092866 */   // Label 16077: @1092866
     /* 1092866 */   GIM_Try, /*On fail goto*//*Label 16078*/ GIMT_Encode4(1092943), // Rule ID 60680 //
     /* 1092871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1092882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1092885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1092888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092910 */     // MIs[0] policy
     /* 1092910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092920 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1092923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092942 */     // GIR_Coverage, 60680,
     /* 1092942 */     GIR_EraseRootFromParent_Done,
     /* 1092943 */   // Label 16078: @1092943
     /* 1092943 */   GIM_Try, /*On fail goto*//*Label 16079*/ GIMT_Encode4(1093020), // Rule ID 60681 //
     /* 1092948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1092959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1092962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1092965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092987 */     // MIs[0] policy
     /* 1092987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092997 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1093000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093006 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093019 */     // GIR_Coverage, 60681,
     /* 1093019 */     GIR_EraseRootFromParent_Done,
     /* 1093020 */   // Label 16079: @1093020
     /* 1093020 */   GIM_Try, /*On fail goto*//*Label 16080*/ GIMT_Encode4(1093097), // Rule ID 60684 //
     /* 1093025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1093036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1093039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1093042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1093045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093064 */     // MIs[0] policy
     /* 1093064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093074 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1093077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093096 */     // GIR_Coverage, 60684,
     /* 1093096 */     GIR_EraseRootFromParent_Done,
     /* 1093097 */   // Label 16080: @1093097
     /* 1093097 */   GIM_Try, /*On fail goto*//*Label 16081*/ GIMT_Encode4(1093174), // Rule ID 60685 //
     /* 1093102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1093113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1093116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1093119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1093122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093141 */     // MIs[0] policy
     /* 1093141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093151 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1093154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093160 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093173 */     // GIR_Coverage, 60685,
     /* 1093173 */     GIR_EraseRootFromParent_Done,
     /* 1093174 */   // Label 16081: @1093174
     /* 1093174 */   GIM_Try, /*On fail goto*//*Label 16082*/ GIMT_Encode4(1093251), // Rule ID 60688 //
     /* 1093179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1093190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1093193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1093196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1093206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093218 */     // MIs[0] policy
     /* 1093218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093228 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1093231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093250 */     // GIR_Coverage, 60688,
     /* 1093250 */     GIR_EraseRootFromParent_Done,
     /* 1093251 */   // Label 16082: @1093251
     /* 1093251 */   GIM_Try, /*On fail goto*//*Label 16083*/ GIMT_Encode4(1093328), // Rule ID 60689 //
     /* 1093256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1093267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1093270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1093273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1093283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093295 */     // MIs[0] policy
     /* 1093295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093305 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1093308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093314 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093327 */     // GIR_Coverage, 60689,
     /* 1093327 */     GIR_EraseRootFromParent_Done,
     /* 1093328 */   // Label 16083: @1093328
     /* 1093328 */   GIM_Try, /*On fail goto*//*Label 16084*/ GIMT_Encode4(1093405), // Rule ID 60692 //
     /* 1093333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1093344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1093347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1093350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1093360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093372 */     // MIs[0] policy
     /* 1093372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093382 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1093385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093404 */     // GIR_Coverage, 60692,
     /* 1093404 */     GIR_EraseRootFromParent_Done,
     /* 1093405 */   // Label 16084: @1093405
     /* 1093405 */   GIM_Try, /*On fail goto*//*Label 16085*/ GIMT_Encode4(1093482), // Rule ID 60693 //
     /* 1093410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1093421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1093424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1093427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1093437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093449 */     // MIs[0] policy
     /* 1093449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093459 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1093462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093468 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093481 */     // GIR_Coverage, 60693,
     /* 1093481 */     GIR_EraseRootFromParent_Done,
     /* 1093482 */   // Label 16085: @1093482
     /* 1093482 */   GIM_Try, /*On fail goto*//*Label 16086*/ GIMT_Encode4(1093559), // Rule ID 60696 //
     /* 1093487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1093498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1093501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1093504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093526 */     // MIs[0] policy
     /* 1093526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1093539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093558 */     // GIR_Coverage, 60696,
     /* 1093558 */     GIR_EraseRootFromParent_Done,
     /* 1093559 */   // Label 16086: @1093559
     /* 1093559 */   GIM_Try, /*On fail goto*//*Label 16087*/ GIMT_Encode4(1093636), // Rule ID 60697 //
     /* 1093564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1093575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1093578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1093581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093603 */     // MIs[0] policy
     /* 1093603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093613 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1093616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093622 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093635 */     // GIR_Coverage, 60697,
     /* 1093635 */     GIR_EraseRootFromParent_Done,
     /* 1093636 */   // Label 16087: @1093636
     /* 1093636 */   GIM_Try, /*On fail goto*//*Label 16088*/ GIMT_Encode4(1093713), // Rule ID 60700 //
     /* 1093641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1093652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1093655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1093658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093680 */     // MIs[0] policy
     /* 1093680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093690 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1093693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093712 */     // GIR_Coverage, 60700,
     /* 1093712 */     GIR_EraseRootFromParent_Done,
     /* 1093713 */   // Label 16088: @1093713
     /* 1093713 */   GIM_Try, /*On fail goto*//*Label 16089*/ GIMT_Encode4(1093790), // Rule ID 60701 //
     /* 1093718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1093729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1093732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1093735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093757 */     // MIs[0] policy
     /* 1093757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093767 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1093770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093776 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093789 */     // GIR_Coverage, 60701,
     /* 1093789 */     GIR_EraseRootFromParent_Done,
     /* 1093790 */   // Label 16089: @1093790
     /* 1093790 */   GIM_Try, /*On fail goto*//*Label 16090*/ GIMT_Encode4(1093867), // Rule ID 60704 //
     /* 1093795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1093806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1093809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1093812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093834 */     // MIs[0] policy
     /* 1093834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093844 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1093847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093866 */     // GIR_Coverage, 60704,
     /* 1093866 */     GIR_EraseRootFromParent_Done,
     /* 1093867 */   // Label 16090: @1093867
     /* 1093867 */   GIM_Try, /*On fail goto*//*Label 16091*/ GIMT_Encode4(1093944), // Rule ID 60705 //
     /* 1093872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1093883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1093886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1093889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093911 */     // MIs[0] policy
     /* 1093911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093921 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1093924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093930 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093943 */     // GIR_Coverage, 60705,
     /* 1093943 */     GIR_EraseRootFromParent_Done,
     /* 1093944 */   // Label 16091: @1093944
     /* 1093944 */   GIM_Try, /*On fail goto*//*Label 16092*/ GIMT_Encode4(1094021), // Rule ID 60708 //
     /* 1093949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1093960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1093963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1093966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093988 */     // MIs[0] policy
     /* 1093988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093998 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1094001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094020 */     // GIR_Coverage, 60708,
     /* 1094020 */     GIR_EraseRootFromParent_Done,
     /* 1094021 */   // Label 16092: @1094021
     /* 1094021 */   GIM_Try, /*On fail goto*//*Label 16093*/ GIMT_Encode4(1094098), // Rule ID 60709 //
     /* 1094026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1094037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1094040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1094043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094065 */     // MIs[0] policy
     /* 1094065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094075 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1094078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094084 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094097 */     // GIR_Coverage, 60709,
     /* 1094097 */     GIR_EraseRootFromParent_Done,
     /* 1094098 */   // Label 16093: @1094098
     /* 1094098 */   GIM_Try, /*On fail goto*//*Label 16094*/ GIMT_Encode4(1094175), // Rule ID 60712 //
     /* 1094103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1094114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1094117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1094120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094142 */     // MIs[0] policy
     /* 1094142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094152 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1094155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094174 */     // GIR_Coverage, 60712,
     /* 1094174 */     GIR_EraseRootFromParent_Done,
     /* 1094175 */   // Label 16094: @1094175
     /* 1094175 */   GIM_Try, /*On fail goto*//*Label 16095*/ GIMT_Encode4(1094252), // Rule ID 60713 //
     /* 1094180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1094191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1094194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1094197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094219 */     // MIs[0] policy
     /* 1094219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094229 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1094232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094238 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094251 */     // GIR_Coverage, 60713,
     /* 1094251 */     GIR_EraseRootFromParent_Done,
     /* 1094252 */   // Label 16095: @1094252
     /* 1094252 */   GIM_Try, /*On fail goto*//*Label 16096*/ GIMT_Encode4(1094329), // Rule ID 60716 //
     /* 1094257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1094268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1094271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1094274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094296 */     // MIs[0] policy
     /* 1094296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094306 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1094309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094328 */     // GIR_Coverage, 60716,
     /* 1094328 */     GIR_EraseRootFromParent_Done,
     /* 1094329 */   // Label 16096: @1094329
     /* 1094329 */   GIM_Try, /*On fail goto*//*Label 16097*/ GIMT_Encode4(1094406), // Rule ID 60717 //
     /* 1094334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1094345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1094348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1094351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094373 */     // MIs[0] policy
     /* 1094373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094383 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1094386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094392 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094405 */     // GIR_Coverage, 60717,
     /* 1094405 */     GIR_EraseRootFromParent_Done,
     /* 1094406 */   // Label 16097: @1094406
     /* 1094406 */   GIM_Try, /*On fail goto*//*Label 16098*/ GIMT_Encode4(1094483), // Rule ID 60720 //
     /* 1094411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1094422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1094425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1094428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094450 */     // MIs[0] policy
     /* 1094450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094460 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1094463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094482 */     // GIR_Coverage, 60720,
     /* 1094482 */     GIR_EraseRootFromParent_Done,
     /* 1094483 */   // Label 16098: @1094483
     /* 1094483 */   GIM_Try, /*On fail goto*//*Label 16099*/ GIMT_Encode4(1094560), // Rule ID 60721 //
     /* 1094488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1094499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1094502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1094505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094527 */     // MIs[0] policy
     /* 1094527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094537 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1094540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094546 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094559 */     // GIR_Coverage, 60721,
     /* 1094559 */     GIR_EraseRootFromParent_Done,
     /* 1094560 */   // Label 16099: @1094560
     /* 1094560 */   GIM_Try, /*On fail goto*//*Label 16100*/ GIMT_Encode4(1094637), // Rule ID 60724 //
     /* 1094565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1094576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1094579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1094582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094604 */     // MIs[0] policy
     /* 1094604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094614 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11150:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1094617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094636 */     // GIR_Coverage, 60724,
     /* 1094636 */     GIR_EraseRootFromParent_Done,
     /* 1094637 */   // Label 16100: @1094637
     /* 1094637 */   GIM_Try, /*On fail goto*//*Label 16101*/ GIMT_Encode4(1094714), // Rule ID 60725 //
     /* 1094642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1094653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1094656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1094659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094681 */     // MIs[0] policy
     /* 1094681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094691 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11150:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1094694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094700 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094713 */     // GIR_Coverage, 60725,
     /* 1094713 */     GIR_EraseRootFromParent_Done,
     /* 1094714 */   // Label 16101: @1094714
     /* 1094714 */   GIM_Try, /*On fail goto*//*Label 16102*/ GIMT_Encode4(1094791), // Rule ID 60728 //
     /* 1094719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094758 */     // MIs[0] policy
     /* 1094758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094768 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1094771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094790 */     // GIR_Coverage, 60728,
     /* 1094790 */     GIR_EraseRootFromParent_Done,
     /* 1094791 */   // Label 16102: @1094791
     /* 1094791 */   GIM_Try, /*On fail goto*//*Label 16103*/ GIMT_Encode4(1094868), // Rule ID 60729 //
     /* 1094796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094835 */     // MIs[0] policy
     /* 1094835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094845 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1094848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094854 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094867 */     // GIR_Coverage, 60729,
     /* 1094867 */     GIR_EraseRootFromParent_Done,
     /* 1094868 */   // Label 16103: @1094868
     /* 1094868 */   GIM_Try, /*On fail goto*//*Label 16104*/ GIMT_Encode4(1094945), // Rule ID 60732 //
     /* 1094873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1094884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1094887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1094890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094912 */     // MIs[0] policy
     /* 1094912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094922 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1094925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094944 */     // GIR_Coverage, 60732,
     /* 1094944 */     GIR_EraseRootFromParent_Done,
     /* 1094945 */   // Label 16104: @1094945
     /* 1094945 */   GIM_Try, /*On fail goto*//*Label 16105*/ GIMT_Encode4(1095022), // Rule ID 60733 //
     /* 1094950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1094961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1094964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1094967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094989 */     // MIs[0] policy
     /* 1094989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094999 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1095002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095021 */     // GIR_Coverage, 60733,
     /* 1095021 */     GIR_EraseRootFromParent_Done,
     /* 1095022 */   // Label 16105: @1095022
     /* 1095022 */   GIM_Try, /*On fail goto*//*Label 16106*/ GIMT_Encode4(1095099), // Rule ID 60736 //
     /* 1095027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1095038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1095041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1095044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1095047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1095054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095066 */     // MIs[0] policy
     /* 1095066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095076 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1095079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095098 */     // GIR_Coverage, 60736,
     /* 1095098 */     GIR_EraseRootFromParent_Done,
     /* 1095099 */   // Label 16106: @1095099
     /* 1095099 */   GIM_Try, /*On fail goto*//*Label 16107*/ GIMT_Encode4(1095176), // Rule ID 60737 //
     /* 1095104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1095115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1095118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1095121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1095124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1095131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095143 */     // MIs[0] policy
     /* 1095143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095153 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1095156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095162 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095175 */     // GIR_Coverage, 60737,
     /* 1095175 */     GIR_EraseRootFromParent_Done,
     /* 1095176 */   // Label 16107: @1095176
     /* 1095176 */   GIM_Try, /*On fail goto*//*Label 16108*/ GIMT_Encode4(1095253), // Rule ID 60740 //
     /* 1095181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1095192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1095195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1095198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095220 */     // MIs[0] policy
     /* 1095220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1095233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095252 */     // GIR_Coverage, 60740,
     /* 1095252 */     GIR_EraseRootFromParent_Done,
     /* 1095253 */   // Label 16108: @1095253
     /* 1095253 */   GIM_Try, /*On fail goto*//*Label 16109*/ GIMT_Encode4(1095330), // Rule ID 60741 //
     /* 1095258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1095269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1095272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1095275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095297 */     // MIs[0] policy
     /* 1095297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095307 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1095310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095329 */     // GIR_Coverage, 60741,
     /* 1095329 */     GIR_EraseRootFromParent_Done,
     /* 1095330 */   // Label 16109: @1095330
     /* 1095330 */   GIM_Try, /*On fail goto*//*Label 16110*/ GIMT_Encode4(1095407), // Rule ID 60744 //
     /* 1095335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1095346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1095349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1095352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095374 */     // MIs[0] policy
     /* 1095374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1095387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095406 */     // GIR_Coverage, 60744,
     /* 1095406 */     GIR_EraseRootFromParent_Done,
     /* 1095407 */   // Label 16110: @1095407
     /* 1095407 */   GIM_Try, /*On fail goto*//*Label 16111*/ GIMT_Encode4(1095484), // Rule ID 60745 //
     /* 1095412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1095423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1095426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1095429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095451 */     // MIs[0] policy
     /* 1095451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095461 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1095464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095470 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095483 */     // GIR_Coverage, 60745,
     /* 1095483 */     GIR_EraseRootFromParent_Done,
     /* 1095484 */   // Label 16111: @1095484
     /* 1095484 */   GIM_Try, /*On fail goto*//*Label 16112*/ GIMT_Encode4(1095561), // Rule ID 60748 //
     /* 1095489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1095500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1095503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1095506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1095509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095528 */     // MIs[0] policy
     /* 1095528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095538 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1095541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095547 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095560 */     // GIR_Coverage, 60748,
     /* 1095560 */     GIR_EraseRootFromParent_Done,
     /* 1095561 */   // Label 16112: @1095561
     /* 1095561 */   GIM_Try, /*On fail goto*//*Label 16113*/ GIMT_Encode4(1095638), // Rule ID 60749 //
     /* 1095566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1095577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1095580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1095583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1095586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095605 */     // MIs[0] policy
     /* 1095605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095615 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1095618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095624 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095637 */     // GIR_Coverage, 60749,
     /* 1095637 */     GIR_EraseRootFromParent_Done,
     /* 1095638 */   // Label 16113: @1095638
     /* 1095638 */   GIM_Try, /*On fail goto*//*Label 16114*/ GIMT_Encode4(1095715), // Rule ID 60752 //
     /* 1095643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095682 */     // MIs[0] policy
     /* 1095682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095692 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1095695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095714 */     // GIR_Coverage, 60752,
     /* 1095714 */     GIR_EraseRootFromParent_Done,
     /* 1095715 */   // Label 16114: @1095715
     /* 1095715 */   GIM_Try, /*On fail goto*//*Label 16115*/ GIMT_Encode4(1095792), // Rule ID 60753 //
     /* 1095720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095759 */     // MIs[0] policy
     /* 1095759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095769 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1095772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095778 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095791 */     // GIR_Coverage, 60753,
     /* 1095791 */     GIR_EraseRootFromParent_Done,
     /* 1095792 */   // Label 16115: @1095792
     /* 1095792 */   GIM_Try, /*On fail goto*//*Label 16116*/ GIMT_Encode4(1095869), // Rule ID 60756 //
     /* 1095797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095836 */     // MIs[0] policy
     /* 1095836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095846 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1095849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095868 */     // GIR_Coverage, 60756,
     /* 1095868 */     GIR_EraseRootFromParent_Done,
     /* 1095869 */   // Label 16116: @1095869
     /* 1095869 */   GIM_Try, /*On fail goto*//*Label 16117*/ GIMT_Encode4(1095946), // Rule ID 60757 //
     /* 1095874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095913 */     // MIs[0] policy
     /* 1095913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095923 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1095926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095932 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095945 */     // GIR_Coverage, 60757,
     /* 1095945 */     GIR_EraseRootFromParent_Done,
     /* 1095946 */   // Label 16117: @1095946
     /* 1095946 */   GIM_Try, /*On fail goto*//*Label 16118*/ GIMT_Encode4(1096023), // Rule ID 60760 //
     /* 1095951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1095962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1095965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1095968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095990 */     // MIs[0] policy
     /* 1095990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096000 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1096003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096022 */     // GIR_Coverage, 60760,
     /* 1096022 */     GIR_EraseRootFromParent_Done,
     /* 1096023 */   // Label 16118: @1096023
     /* 1096023 */   GIM_Try, /*On fail goto*//*Label 16119*/ GIMT_Encode4(1096100), // Rule ID 60761 //
     /* 1096028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1096039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1096042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1096045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1096048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096067 */     // MIs[0] policy
     /* 1096067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096077 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1096080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096099 */     // GIR_Coverage, 60761,
     /* 1096099 */     GIR_EraseRootFromParent_Done,
     /* 1096100 */   // Label 16119: @1096100
     /* 1096100 */   GIM_Try, /*On fail goto*//*Label 16120*/ GIMT_Encode4(1096177), // Rule ID 60764 //
     /* 1096105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1096116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1096119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1096122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096144 */     // MIs[0] policy
     /* 1096144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096154 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1096157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096176 */     // GIR_Coverage, 60764,
     /* 1096176 */     GIR_EraseRootFromParent_Done,
     /* 1096177 */   // Label 16120: @1096177
     /* 1096177 */   GIM_Try, /*On fail goto*//*Label 16121*/ GIMT_Encode4(1096254), // Rule ID 60765 //
     /* 1096182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1096193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1096196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1096199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096221 */     // MIs[0] policy
     /* 1096221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096231 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1096234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096240 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096253 */     // GIR_Coverage, 60765,
     /* 1096253 */     GIR_EraseRootFromParent_Done,
     /* 1096254 */   // Label 16121: @1096254
     /* 1096254 */   GIM_Try, /*On fail goto*//*Label 16122*/ GIMT_Encode4(1096331), // Rule ID 60768 //
     /* 1096259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1096270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1096273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1096276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096298 */     // MIs[0] policy
     /* 1096298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096308 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1096311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096330 */     // GIR_Coverage, 60768,
     /* 1096330 */     GIR_EraseRootFromParent_Done,
     /* 1096331 */   // Label 16122: @1096331
     /* 1096331 */   GIM_Try, /*On fail goto*//*Label 16123*/ GIMT_Encode4(1096408), // Rule ID 60769 //
     /* 1096336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1096347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1096350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1096353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096375 */     // MIs[0] policy
     /* 1096375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096385 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1096388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096394 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096407 */     // GIR_Coverage, 60769,
     /* 1096407 */     GIR_EraseRootFromParent_Done,
     /* 1096408 */   // Label 16123: @1096408
     /* 1096408 */   GIM_Try, /*On fail goto*//*Label 16124*/ GIMT_Encode4(1096485), // Rule ID 60772 //
     /* 1096413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1096424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1096427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1096430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1096433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096452 */     // MIs[0] policy
     /* 1096452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096462 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1096465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096484 */     // GIR_Coverage, 60772,
     /* 1096484 */     GIR_EraseRootFromParent_Done,
     /* 1096485 */   // Label 16124: @1096485
     /* 1096485 */   GIM_Try, /*On fail goto*//*Label 16125*/ GIMT_Encode4(1096562), // Rule ID 60773 //
     /* 1096490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1096501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1096504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1096507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1096510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096529 */     // MIs[0] policy
     /* 1096529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096539 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1096542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096561 */     // GIR_Coverage, 60773,
     /* 1096561 */     GIR_EraseRootFromParent_Done,
     /* 1096562 */   // Label 16125: @1096562
     /* 1096562 */   GIM_Try, /*On fail goto*//*Label 16126*/ GIMT_Encode4(1096639), // Rule ID 60776 //
     /* 1096567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096606 */     // MIs[0] policy
     /* 1096606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1096619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096638 */     // GIR_Coverage, 60776,
     /* 1096638 */     GIR_EraseRootFromParent_Done,
     /* 1096639 */   // Label 16126: @1096639
     /* 1096639 */   GIM_Try, /*On fail goto*//*Label 16127*/ GIMT_Encode4(1096716), // Rule ID 60777 //
     /* 1096644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096683 */     // MIs[0] policy
     /* 1096683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096693 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1096696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096702 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096715 */     // GIR_Coverage, 60777,
     /* 1096715 */     GIR_EraseRootFromParent_Done,
     /* 1096716 */   // Label 16127: @1096716
     /* 1096716 */   GIM_Try, /*On fail goto*//*Label 16128*/ GIMT_Encode4(1096793), // Rule ID 60780 //
     /* 1096721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096760 */     // MIs[0] policy
     /* 1096760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096770 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1096773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096792 */     // GIR_Coverage, 60780,
     /* 1096792 */     GIR_EraseRootFromParent_Done,
     /* 1096793 */   // Label 16128: @1096793
     /* 1096793 */   GIM_Try, /*On fail goto*//*Label 16129*/ GIMT_Encode4(1096870), // Rule ID 60781 //
     /* 1096798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096837 */     // MIs[0] policy
     /* 1096837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096847 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1096850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096856 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096869 */     // GIR_Coverage, 60781,
     /* 1096869 */     GIR_EraseRootFromParent_Done,
     /* 1096870 */   // Label 16129: @1096870
     /* 1096870 */   GIM_Try, /*On fail goto*//*Label 16130*/ GIMT_Encode4(1096947), // Rule ID 60784 //
     /* 1096875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096914 */     // MIs[0] policy
     /* 1096914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096924 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1096927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096946 */     // GIR_Coverage, 60784,
     /* 1096946 */     GIR_EraseRootFromParent_Done,
     /* 1096947 */   // Label 16130: @1096947
     /* 1096947 */   GIM_Try, /*On fail goto*//*Label 16131*/ GIMT_Encode4(1097024), // Rule ID 60785 //
     /* 1096952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096991 */     // MIs[0] policy
     /* 1096991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097001 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1097004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097010 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1097020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097023 */     // GIR_Coverage, 60785,
     /* 1097023 */     GIR_EraseRootFromParent_Done,
     /* 1097024 */   // Label 16131: @1097024
     /* 1097024 */   GIM_Try, /*On fail goto*//*Label 16132*/ GIMT_Encode4(1097101), // Rule ID 60788 //
     /* 1097029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1097040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1097043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1097046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097068 */     // MIs[0] policy
     /* 1097068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097078 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1097081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097100 */     // GIR_Coverage, 60788,
     /* 1097100 */     GIR_EraseRootFromParent_Done,
     /* 1097101 */   // Label 16132: @1097101
     /* 1097101 */   GIM_Try, /*On fail goto*//*Label 16133*/ GIMT_Encode4(1097178), // Rule ID 60789 //
     /* 1097106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1097117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1097120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1097123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097145 */     // MIs[0] policy
     /* 1097145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097155 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1097158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097164 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097177 */     // GIR_Coverage, 60789,
     /* 1097177 */     GIR_EraseRootFromParent_Done,
     /* 1097178 */   // Label 16133: @1097178
     /* 1097178 */   GIM_Try, /*On fail goto*//*Label 16134*/ GIMT_Encode4(1097255), // Rule ID 60792 //
     /* 1097183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1097194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1097197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1097200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097222 */     // MIs[0] policy
     /* 1097222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097232 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1097235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097254 */     // GIR_Coverage, 60792,
     /* 1097254 */     GIR_EraseRootFromParent_Done,
     /* 1097255 */   // Label 16134: @1097255
     /* 1097255 */   GIM_Try, /*On fail goto*//*Label 16135*/ GIMT_Encode4(1097332), // Rule ID 60793 //
     /* 1097260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1097271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1097274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1097277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097299 */     // MIs[0] policy
     /* 1097299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097309 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1097312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097318 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097331 */     // GIR_Coverage, 60793,
     /* 1097331 */     GIR_EraseRootFromParent_Done,
     /* 1097332 */   // Label 16135: @1097332
     /* 1097332 */   GIM_Try, /*On fail goto*//*Label 16136*/ GIMT_Encode4(1097409), // Rule ID 60796 //
     /* 1097337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1097348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1097351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1097354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097376 */     // MIs[0] policy
     /* 1097376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097386 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1097389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097408 */     // GIR_Coverage, 60796,
     /* 1097408 */     GIR_EraseRootFromParent_Done,
     /* 1097409 */   // Label 16136: @1097409
     /* 1097409 */   GIM_Try, /*On fail goto*//*Label 16137*/ GIMT_Encode4(1097486), // Rule ID 60797 //
     /* 1097414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1097425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1097428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1097431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097453 */     // MIs[0] policy
     /* 1097453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097463 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1097466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097472 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097485 */     // GIR_Coverage, 60797,
     /* 1097485 */     GIR_EraseRootFromParent_Done,
     /* 1097486 */   // Label 16137: @1097486
     /* 1097486 */   GIM_Try, /*On fail goto*//*Label 16138*/ GIMT_Encode4(1097563), // Rule ID 60800 //
     /* 1097491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1097502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1097505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1097508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097530 */     // MIs[0] policy
     /* 1097530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097540 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1097543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097562 */     // GIR_Coverage, 60800,
     /* 1097562 */     GIR_EraseRootFromParent_Done,
     /* 1097563 */   // Label 16138: @1097563
     /* 1097563 */   GIM_Try, /*On fail goto*//*Label 16139*/ GIMT_Encode4(1097640), // Rule ID 60801 //
     /* 1097568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1097579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1097582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1097585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097607 */     // MIs[0] policy
     /* 1097607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097617 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1097620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097639 */     // GIR_Coverage, 60801,
     /* 1097639 */     GIR_EraseRootFromParent_Done,
     /* 1097640 */   // Label 16139: @1097640
     /* 1097640 */   GIM_Try, /*On fail goto*//*Label 16140*/ GIMT_Encode4(1097717), // Rule ID 60804 //
     /* 1097645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1097656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1097659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1097662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097684 */     // MIs[0] policy
     /* 1097684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097694 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1097697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097716 */     // GIR_Coverage, 60804,
     /* 1097716 */     GIR_EraseRootFromParent_Done,
     /* 1097717 */   // Label 16140: @1097717
     /* 1097717 */   GIM_Try, /*On fail goto*//*Label 16141*/ GIMT_Encode4(1097794), // Rule ID 60805 //
     /* 1097722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1097733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1097736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1097739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097761 */     // MIs[0] policy
     /* 1097761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097771 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1097774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097793 */     // GIR_Coverage, 60805,
     /* 1097793 */     GIR_EraseRootFromParent_Done,
     /* 1097794 */   // Label 16141: @1097794
     /* 1097794 */   GIM_Try, /*On fail goto*//*Label 16142*/ GIMT_Encode4(1097871), // Rule ID 60808 //
     /* 1097799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097838 */     // MIs[0] policy
     /* 1097838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097848 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1097851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097870 */     // GIR_Coverage, 60808,
     /* 1097870 */     GIR_EraseRootFromParent_Done,
     /* 1097871 */   // Label 16142: @1097871
     /* 1097871 */   GIM_Try, /*On fail goto*//*Label 16143*/ GIMT_Encode4(1097948), // Rule ID 60809 //
     /* 1097876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097915 */     // MIs[0] policy
     /* 1097915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097925 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1097928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097934 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097947 */     // GIR_Coverage, 60809,
     /* 1097947 */     GIR_EraseRootFromParent_Done,
     /* 1097948 */   // Label 16143: @1097948
     /* 1097948 */   GIM_Try, /*On fail goto*//*Label 16144*/ GIMT_Encode4(1098025), // Rule ID 60812 //
     /* 1097953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1097964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1097967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1097970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1097973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097992 */     // MIs[0] policy
     /* 1097992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098002 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098024 */     // GIR_Coverage, 60812,
     /* 1098024 */     GIR_EraseRootFromParent_Done,
     /* 1098025 */   // Label 16144: @1098025
     /* 1098025 */   GIM_Try, /*On fail goto*//*Label 16145*/ GIMT_Encode4(1098102), // Rule ID 60813 //
     /* 1098030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1098041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1098044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1098047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1098050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098069 */     // MIs[0] policy
     /* 1098069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098079 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098088 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098101 */     // GIR_Coverage, 60813,
     /* 1098101 */     GIR_EraseRootFromParent_Done,
     /* 1098102 */   // Label 16145: @1098102
     /* 1098102 */   GIM_Try, /*On fail goto*//*Label 16146*/ GIMT_Encode4(1098179), // Rule ID 60816 //
     /* 1098107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1098118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1098121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1098124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1098127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098146 */     // MIs[0] policy
     /* 1098146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098178 */     // GIR_Coverage, 60816,
     /* 1098178 */     GIR_EraseRootFromParent_Done,
     /* 1098179 */   // Label 16146: @1098179
     /* 1098179 */   GIM_Try, /*On fail goto*//*Label 16147*/ GIMT_Encode4(1098256), // Rule ID 60817 //
     /* 1098184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1098195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1098198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1098201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1098204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098223 */     // MIs[0] policy
     /* 1098223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098233 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098242 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098255 */     // GIR_Coverage, 60817,
     /* 1098255 */     GIR_EraseRootFromParent_Done,
     /* 1098256 */   // Label 16147: @1098256
     /* 1098256 */   GIM_Try, /*On fail goto*//*Label 16148*/ GIMT_Encode4(1098333), // Rule ID 60820 //
     /* 1098261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1098272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1098275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1098278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1098281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098300 */     // MIs[0] policy
     /* 1098300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098310 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098332 */     // GIR_Coverage, 60820,
     /* 1098332 */     GIR_EraseRootFromParent_Done,
     /* 1098333 */   // Label 16148: @1098333
     /* 1098333 */   GIM_Try, /*On fail goto*//*Label 16149*/ GIMT_Encode4(1098410), // Rule ID 60821 //
     /* 1098338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1098349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1098352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1098355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1098358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098377 */     // MIs[0] policy
     /* 1098377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098387 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098396 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098409 */     // GIR_Coverage, 60821,
     /* 1098409 */     GIR_EraseRootFromParent_Done,
     /* 1098410 */   // Label 16149: @1098410
     /* 1098410 */   GIM_Try, /*On fail goto*//*Label 16150*/ GIMT_Encode4(1098487), // Rule ID 60824 //
     /* 1098415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1098426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1098429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1098432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1098435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098454 */     // MIs[0] policy
     /* 1098454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098464 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098486 */     // GIR_Coverage, 60824,
     /* 1098486 */     GIR_EraseRootFromParent_Done,
     /* 1098487 */   // Label 16150: @1098487
     /* 1098487 */   GIM_Try, /*On fail goto*//*Label 16151*/ GIMT_Encode4(1098564), // Rule ID 60825 //
     /* 1098492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1098503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1098506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1098509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1098512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098531 */     // MIs[0] policy
     /* 1098531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098541 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098550 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098563 */     // GIR_Coverage, 60825,
     /* 1098563 */     GIR_EraseRootFromParent_Done,
     /* 1098564 */   // Label 16151: @1098564
     /* 1098564 */   GIM_Try, /*On fail goto*//*Label 16152*/ GIMT_Encode4(1098641), // Rule ID 60828 //
     /* 1098569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1098580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1098583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1098586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098608 */     // MIs[0] policy
     /* 1098608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098618 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1098621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098640 */     // GIR_Coverage, 60828,
     /* 1098640 */     GIR_EraseRootFromParent_Done,
     /* 1098641 */   // Label 16152: @1098641
     /* 1098641 */   GIM_Try, /*On fail goto*//*Label 16153*/ GIMT_Encode4(1098718), // Rule ID 60829 //
     /* 1098646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1098657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1098660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1098663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098685 */     // MIs[0] policy
     /* 1098685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098695 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1098698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098717 */     // GIR_Coverage, 60829,
     /* 1098717 */     GIR_EraseRootFromParent_Done,
     /* 1098718 */   // Label 16153: @1098718
     /* 1098718 */   GIM_Try, /*On fail goto*//*Label 16154*/ GIMT_Encode4(1098795), // Rule ID 60832 //
     /* 1098723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1098734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1098737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1098740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098762 */     // MIs[0] policy
     /* 1098762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098772 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1098775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098794 */     // GIR_Coverage, 60832,
     /* 1098794 */     GIR_EraseRootFromParent_Done,
     /* 1098795 */   // Label 16154: @1098795
     /* 1098795 */   GIM_Try, /*On fail goto*//*Label 16155*/ GIMT_Encode4(1098872), // Rule ID 60833 //
     /* 1098800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1098811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1098814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1098817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098839 */     // MIs[0] policy
     /* 1098839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098849 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1098852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098858 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098871 */     // GIR_Coverage, 60833,
     /* 1098871 */     GIR_EraseRootFromParent_Done,
     /* 1098872 */   // Label 16155: @1098872
     /* 1098872 */   GIM_Try, /*On fail goto*//*Label 16156*/ GIMT_Encode4(1098949), // Rule ID 60836 //
     /* 1098877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1098888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1098891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1098894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1098897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098916 */     // MIs[0] policy
     /* 1098916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098926 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1098929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098948 */     // GIR_Coverage, 60836,
     /* 1098948 */     GIR_EraseRootFromParent_Done,
     /* 1098949 */   // Label 16156: @1098949
     /* 1098949 */   GIM_Try, /*On fail goto*//*Label 16157*/ GIMT_Encode4(1099026), // Rule ID 60837 //
     /* 1098954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1098965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1098968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1098971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1098974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098993 */     // MIs[0] policy
     /* 1098993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099003 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1099006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099012 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1099022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099025 */     // GIR_Coverage, 60837,
     /* 1099025 */     GIR_EraseRootFromParent_Done,
     /* 1099026 */   // Label 16157: @1099026
     /* 1099026 */   GIM_Try, /*On fail goto*//*Label 16158*/ GIMT_Encode4(1099103), // Rule ID 60840 //
     /* 1099031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1099042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1099045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1099048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099070 */     // MIs[0] policy
     /* 1099070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099080 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1099083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099102 */     // GIR_Coverage, 60840,
     /* 1099102 */     GIR_EraseRootFromParent_Done,
     /* 1099103 */   // Label 16158: @1099103
     /* 1099103 */   GIM_Try, /*On fail goto*//*Label 16159*/ GIMT_Encode4(1099180), // Rule ID 60841 //
     /* 1099108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1099119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1099122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1099125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099147 */     // MIs[0] policy
     /* 1099147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099157 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1099160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099179 */     // GIR_Coverage, 60841,
     /* 1099179 */     GIR_EraseRootFromParent_Done,
     /* 1099180 */   // Label 16159: @1099180
     /* 1099180 */   GIM_Try, /*On fail goto*//*Label 16160*/ GIMT_Encode4(1099257), // Rule ID 60844 //
     /* 1099185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1099196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1099199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1099202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099224 */     // MIs[0] policy
     /* 1099224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099234 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1099237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099256 */     // GIR_Coverage, 60844,
     /* 1099256 */     GIR_EraseRootFromParent_Done,
     /* 1099257 */   // Label 16160: @1099257
     /* 1099257 */   GIM_Try, /*On fail goto*//*Label 16161*/ GIMT_Encode4(1099334), // Rule ID 60845 //
     /* 1099262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1099273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1099276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1099279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099301 */     // MIs[0] policy
     /* 1099301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099311 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1099314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099320 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099333 */     // GIR_Coverage, 60845,
     /* 1099333 */     GIR_EraseRootFromParent_Done,
     /* 1099334 */   // Label 16161: @1099334
     /* 1099334 */   GIM_Try, /*On fail goto*//*Label 16162*/ GIMT_Encode4(1099411), // Rule ID 60848 //
     /* 1099339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1099350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1099353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1099356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1099359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099378 */     // MIs[0] policy
     /* 1099378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099388 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1099391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099410 */     // GIR_Coverage, 60848,
     /* 1099410 */     GIR_EraseRootFromParent_Done,
     /* 1099411 */   // Label 16162: @1099411
     /* 1099411 */   GIM_Try, /*On fail goto*//*Label 16163*/ GIMT_Encode4(1099488), // Rule ID 60849 //
     /* 1099416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1099427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1099430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1099433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1099436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099455 */     // MIs[0] policy
     /* 1099455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099465 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1099468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099474 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099487 */     // GIR_Coverage, 60849,
     /* 1099487 */     GIR_EraseRootFromParent_Done,
     /* 1099488 */   // Label 16163: @1099488
     /* 1099488 */   GIM_Try, /*On fail goto*//*Label 16164*/ GIMT_Encode4(1099565), // Rule ID 60852 //
     /* 1099493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1099504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1099507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1099510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099532 */     // MIs[0] policy
     /* 1099532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099542 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1099545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099564 */     // GIR_Coverage, 60852,
     /* 1099564 */     GIR_EraseRootFromParent_Done,
     /* 1099565 */   // Label 16164: @1099565
     /* 1099565 */   GIM_Try, /*On fail goto*//*Label 16165*/ GIMT_Encode4(1099642), // Rule ID 60853 //
     /* 1099570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1099581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1099584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1099587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099609 */     // MIs[0] policy
     /* 1099609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099619 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1099622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099641 */     // GIR_Coverage, 60853,
     /* 1099641 */     GIR_EraseRootFromParent_Done,
     /* 1099642 */   // Label 16165: @1099642
     /* 1099642 */   GIM_Try, /*On fail goto*//*Label 16166*/ GIMT_Encode4(1099719), // Rule ID 60856 //
     /* 1099647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1099658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1099661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1099664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099686 */     // MIs[0] policy
     /* 1099686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099696 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1099699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099718 */     // GIR_Coverage, 60856,
     /* 1099718 */     GIR_EraseRootFromParent_Done,
     /* 1099719 */   // Label 16166: @1099719
     /* 1099719 */   GIM_Try, /*On fail goto*//*Label 16167*/ GIMT_Encode4(1099796), // Rule ID 60857 //
     /* 1099724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1099735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1099738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1099741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099763 */     // MIs[0] policy
     /* 1099763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099773 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1099776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099782 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099795 */     // GIR_Coverage, 60857,
     /* 1099795 */     GIR_EraseRootFromParent_Done,
     /* 1099796 */   // Label 16167: @1099796
     /* 1099796 */   GIM_Try, /*On fail goto*//*Label 16168*/ GIMT_Encode4(1099873), // Rule ID 60860 //
     /* 1099801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1099812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1099815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1099818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099840 */     // MIs[0] policy
     /* 1099840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099850 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1099853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099872 */     // GIR_Coverage, 60860,
     /* 1099872 */     GIR_EraseRootFromParent_Done,
     /* 1099873 */   // Label 16168: @1099873
     /* 1099873 */   GIM_Try, /*On fail goto*//*Label 16169*/ GIMT_Encode4(1099950), // Rule ID 60861 //
     /* 1099878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1099889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1099892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1099895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099917 */     // MIs[0] policy
     /* 1099917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099927 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1099930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099936 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099949 */     // GIR_Coverage, 60861,
     /* 1099949 */     GIR_EraseRootFromParent_Done,
     /* 1099950 */   // Label 16169: @1099950
     /* 1099950 */   GIM_Try, /*On fail goto*//*Label 16170*/ GIMT_Encode4(1100027), // Rule ID 60864 //
     /* 1099955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1099966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1099969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1099972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1099975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099994 */     // MIs[0] policy
     /* 1099994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100004 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1100007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100026 */     // GIR_Coverage, 60864,
     /* 1100026 */     GIR_EraseRootFromParent_Done,
     /* 1100027 */   // Label 16170: @1100027
     /* 1100027 */   GIM_Try, /*On fail goto*//*Label 16171*/ GIMT_Encode4(1100104), // Rule ID 60865 //
     /* 1100032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1100040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1100043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1100046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1100049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1100059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100071 */     // MIs[0] policy
     /* 1100071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100081 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1100084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100090 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100103 */     // GIR_Coverage, 60865,
     /* 1100103 */     GIR_EraseRootFromParent_Done,
     /* 1100104 */   // Label 16171: @1100104
     /* 1100104 */   GIM_Try, /*On fail goto*//*Label 16172*/ GIMT_Encode4(1100181), // Rule ID 60868 //
     /* 1100109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1100117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1100120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1100123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1100126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1100136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100148 */     // MIs[0] policy
     /* 1100148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100158 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1100161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100180 */     // GIR_Coverage, 60868,
     /* 1100180 */     GIR_EraseRootFromParent_Done,
     /* 1100181 */   // Label 16172: @1100181
     /* 1100181 */   GIM_Try, /*On fail goto*//*Label 16173*/ GIMT_Encode4(1100258), // Rule ID 60869 //
     /* 1100186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1100194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1100197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1100200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1100203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1100213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100225 */     // MIs[0] policy
     /* 1100225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100235 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1100238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100244 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100257 */     // GIR_Coverage, 60869,
     /* 1100257 */     GIR_EraseRootFromParent_Done,
     /* 1100258 */   // Label 16173: @1100258
     /* 1100258 */   GIM_Try, /*On fail goto*//*Label 16174*/ GIMT_Encode4(1100335), // Rule ID 60872 //
     /* 1100263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1100271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1100274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1100277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1100280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1100290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100302 */     // MIs[0] policy
     /* 1100302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100312 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1100315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100334 */     // GIR_Coverage, 60872,
     /* 1100334 */     GIR_EraseRootFromParent_Done,
     /* 1100335 */   // Label 16174: @1100335
     /* 1100335 */   GIM_Try, /*On fail goto*//*Label 16175*/ GIMT_Encode4(1100412), // Rule ID 60873 //
     /* 1100340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1100348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1100351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1100354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1100357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1100367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100379 */     // MIs[0] policy
     /* 1100379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100389 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1100392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100398 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100411 */     // GIR_Coverage, 60873,
     /* 1100411 */     GIR_EraseRootFromParent_Done,
     /* 1100412 */   // Label 16175: @1100412
     /* 1100412 */   GIM_Try, /*On fail goto*//*Label 16176*/ GIMT_Encode4(1100489), // Rule ID 60876 //
     /* 1100417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1100428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1100431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1100434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100456 */     // MIs[0] policy
     /* 1100456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100466 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1100469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100488 */     // GIR_Coverage, 60876,
     /* 1100488 */     GIR_EraseRootFromParent_Done,
     /* 1100489 */   // Label 16176: @1100489
     /* 1100489 */   GIM_Try, /*On fail goto*//*Label 16177*/ GIMT_Encode4(1100566), // Rule ID 60877 //
     /* 1100494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1100505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1100508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1100511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100533 */     // MIs[0] policy
     /* 1100533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100543 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1100546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100552 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100565 */     // GIR_Coverage, 60877,
     /* 1100565 */     GIR_EraseRootFromParent_Done,
     /* 1100566 */   // Label 16177: @1100566
     /* 1100566 */   GIM_Try, /*On fail goto*//*Label 16178*/ GIMT_Encode4(1100643), // Rule ID 60880 //
     /* 1100571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1100582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1100585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1100588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100610 */     // MIs[0] policy
     /* 1100610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100620 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1100623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100642 */     // GIR_Coverage, 60880,
     /* 1100642 */     GIR_EraseRootFromParent_Done,
     /* 1100643 */   // Label 16178: @1100643
     /* 1100643 */   GIM_Try, /*On fail goto*//*Label 16179*/ GIMT_Encode4(1100720), // Rule ID 60881 //
     /* 1100648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1100659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1100662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1100665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100687 */     // MIs[0] policy
     /* 1100687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100697 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1100700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100706 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100719 */     // GIR_Coverage, 60881,
     /* 1100719 */     GIR_EraseRootFromParent_Done,
     /* 1100720 */   // Label 16179: @1100720
     /* 1100720 */   GIM_Try, /*On fail goto*//*Label 16180*/ GIMT_Encode4(1100797), // Rule ID 60884 //
     /* 1100725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1100736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1100739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1100742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100764 */     // MIs[0] policy
     /* 1100764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100774 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1100777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100796 */     // GIR_Coverage, 60884,
     /* 1100796 */     GIR_EraseRootFromParent_Done,
     /* 1100797 */   // Label 16180: @1100797
     /* 1100797 */   GIM_Try, /*On fail goto*//*Label 16181*/ GIMT_Encode4(1100874), // Rule ID 60885 //
     /* 1100802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1100813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1100816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1100819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100841 */     // MIs[0] policy
     /* 1100841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100851 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1100854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100873 */     // GIR_Coverage, 60885,
     /* 1100873 */     GIR_EraseRootFromParent_Done,
     /* 1100874 */   // Label 16181: @1100874
     /* 1100874 */   GIM_Try, /*On fail goto*//*Label 16182*/ GIMT_Encode4(1100951), // Rule ID 60888 //
     /* 1100879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1100890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1100893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1100896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100918 */     // MIs[0] policy
     /* 1100918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100928 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1100931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100950 */     // GIR_Coverage, 60888,
     /* 1100950 */     GIR_EraseRootFromParent_Done,
     /* 1100951 */   // Label 16182: @1100951
     /* 1100951 */   GIM_Try, /*On fail goto*//*Label 16183*/ GIMT_Encode4(1101028), // Rule ID 60889 //
     /* 1100956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1100967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1100970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1100973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100995 */     // MIs[0] policy
     /* 1100995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101005 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1101008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101014 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101027 */     // GIR_Coverage, 60889,
     /* 1101027 */     GIR_EraseRootFromParent_Done,
     /* 1101028 */   // Label 16183: @1101028
     /* 1101028 */   GIM_Try, /*On fail goto*//*Label 16184*/ GIMT_Encode4(1101105), // Rule ID 60892 //
     /* 1101033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1101044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1101047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1101050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101072 */     // MIs[0] policy
     /* 1101072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101082 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1101085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101104 */     // GIR_Coverage, 60892,
     /* 1101104 */     GIR_EraseRootFromParent_Done,
     /* 1101105 */   // Label 16184: @1101105
     /* 1101105 */   GIM_Try, /*On fail goto*//*Label 16185*/ GIMT_Encode4(1101182), // Rule ID 60893 //
     /* 1101110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1101113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1101121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1101124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1101127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101149 */     // MIs[0] policy
     /* 1101149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101159 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1101162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101168 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101181 */     // GIR_Coverage, 60893,
     /* 1101181 */     GIR_EraseRootFromParent_Done,
     /* 1101182 */   // Label 16185: @1101182
     /* 1101182 */   GIM_Try, /*On fail goto*//*Label 16186*/ GIMT_Encode4(1101259), // Rule ID 60896 //
     /* 1101187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1101198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1101201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1101204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101226 */     // MIs[0] policy
     /* 1101226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101236 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1101239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101258 */     // GIR_Coverage, 60896,
     /* 1101258 */     GIR_EraseRootFromParent_Done,
     /* 1101259 */   // Label 16186: @1101259
     /* 1101259 */   GIM_Try, /*On fail goto*//*Label 16187*/ GIMT_Encode4(1101336), // Rule ID 60897 //
     /* 1101264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1101267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1101275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1101278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1101281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101303 */     // MIs[0] policy
     /* 1101303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101313 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1101316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101322 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101335 */     // GIR_Coverage, 60897,
     /* 1101335 */     GIR_EraseRootFromParent_Done,
     /* 1101336 */   // Label 16187: @1101336
     /* 1101336 */   GIM_Try, /*On fail goto*//*Label 16188*/ GIMT_Encode4(1101413), // Rule ID 60900 //
     /* 1101341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1101352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1101355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1101358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1101361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101380 */     // MIs[0] policy
     /* 1101380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101390 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101412 */     // GIR_Coverage, 60900,
     /* 1101412 */     GIR_EraseRootFromParent_Done,
     /* 1101413 */   // Label 16188: @1101413
     /* 1101413 */   GIM_Try, /*On fail goto*//*Label 16189*/ GIMT_Encode4(1101490), // Rule ID 60901 //
     /* 1101418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1101421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1101429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1101432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1101435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1101438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101457 */     // MIs[0] policy
     /* 1101457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101467 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101476 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101489 */     // GIR_Coverage, 60901,
     /* 1101489 */     GIR_EraseRootFromParent_Done,
     /* 1101490 */   // Label 16189: @1101490
     /* 1101490 */   GIM_Try, /*On fail goto*//*Label 16190*/ GIMT_Encode4(1101567), // Rule ID 60904 //
     /* 1101495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1101506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1101509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1101515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101534 */     // MIs[0] policy
     /* 1101534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101544 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101566 */     // GIR_Coverage, 60904,
     /* 1101566 */     GIR_EraseRootFromParent_Done,
     /* 1101567 */   // Label 16190: @1101567
     /* 1101567 */   GIM_Try, /*On fail goto*//*Label 16191*/ GIMT_Encode4(1101644), // Rule ID 60905 //
     /* 1101572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1101575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1101583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1101586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1101592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101611 */     // MIs[0] policy
     /* 1101611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101630 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101643 */     // GIR_Coverage, 60905,
     /* 1101643 */     GIR_EraseRootFromParent_Done,
     /* 1101644 */   // Label 16191: @1101644
     /* 1101644 */   GIM_Try, /*On fail goto*//*Label 16192*/ GIMT_Encode4(1101721), // Rule ID 60908 //
     /* 1101649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1101666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101688 */     // MIs[0] policy
     /* 1101688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101698 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101720 */     // GIR_Coverage, 60908,
     /* 1101720 */     GIR_EraseRootFromParent_Done,
     /* 1101721 */   // Label 16192: @1101721
     /* 1101721 */   GIM_Try, /*On fail goto*//*Label 16193*/ GIMT_Encode4(1101798), // Rule ID 60909 //
     /* 1101726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1101729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1101743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101765 */     // MIs[0] policy
     /* 1101765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101775 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101784 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101797 */     // GIR_Coverage, 60909,
     /* 1101797 */     GIR_EraseRootFromParent_Done,
     /* 1101798 */   // Label 16193: @1101798
     /* 1101798 */   GIM_Try, /*On fail goto*//*Label 16194*/ GIMT_Encode4(1101875), // Rule ID 60912 //
     /* 1101803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1101814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1101817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1101820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101842 */     // MIs[0] policy
     /* 1101842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101874 */     // GIR_Coverage, 60912,
     /* 1101874 */     GIR_EraseRootFromParent_Done,
     /* 1101875 */   // Label 16194: @1101875
     /* 1101875 */   GIM_Try, /*On fail goto*//*Label 16195*/ GIMT_Encode4(1101952), // Rule ID 60913 //
     /* 1101880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1101883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1101891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1101894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1101897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101919 */     // MIs[0] policy
     /* 1101919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101929 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101938 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101951 */     // GIR_Coverage, 60913,
     /* 1101951 */     GIR_EraseRootFromParent_Done,
     /* 1101952 */   // Label 16195: @1101952
     /* 1101952 */   GIM_Try, /*On fail goto*//*Label 16196*/ GIMT_Encode4(1102029), // Rule ID 60916 //
     /* 1101957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1101968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1101971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1101974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1101977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1101984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101996 */     // MIs[0] policy
     /* 1101996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1102009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102028 */     // GIR_Coverage, 60916,
     /* 1102028 */     GIR_EraseRootFromParent_Done,
     /* 1102029 */   // Label 16196: @1102029
     /* 1102029 */   GIM_Try, /*On fail goto*//*Label 16197*/ GIMT_Encode4(1102106), // Rule ID 60917 //
     /* 1102034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1102045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1102048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1102051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102073 */     // MIs[0] policy
     /* 1102073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102083 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1102086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102105 */     // GIR_Coverage, 60917,
     /* 1102105 */     GIR_EraseRootFromParent_Done,
     /* 1102106 */   // Label 16197: @1102106
     /* 1102106 */   GIM_Try, /*On fail goto*//*Label 16198*/ GIMT_Encode4(1102183), // Rule ID 60920 //
     /* 1102111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1102114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1102122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1102125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1102128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102150 */     // MIs[0] policy
     /* 1102150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102160 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1102163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102182 */     // GIR_Coverage, 60920,
     /* 1102182 */     GIR_EraseRootFromParent_Done,
     /* 1102183 */   // Label 16198: @1102183
     /* 1102183 */   GIM_Try, /*On fail goto*//*Label 16199*/ GIMT_Encode4(1102260), // Rule ID 60921 //
     /* 1102188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1102199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1102202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1102205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102227 */     // MIs[0] policy
     /* 1102227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102237 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1102240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102246 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102259 */     // GIR_Coverage, 60921,
     /* 1102259 */     GIR_EraseRootFromParent_Done,
     /* 1102260 */   // Label 16199: @1102260
     /* 1102260 */   GIM_Try, /*On fail goto*//*Label 16200*/ GIMT_Encode4(1102337), // Rule ID 60924 //
     /* 1102265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1102268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1102276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1102279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1102282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1102285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102304 */     // MIs[0] policy
     /* 1102304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102314 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1102317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102323 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102336 */     // GIR_Coverage, 60924,
     /* 1102336 */     GIR_EraseRootFromParent_Done,
     /* 1102337 */   // Label 16200: @1102337
     /* 1102337 */   GIM_Try, /*On fail goto*//*Label 16201*/ GIMT_Encode4(1102414), // Rule ID 60925 //
     /* 1102342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1102353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1102356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1102359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1102362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102381 */     // MIs[0] policy
     /* 1102381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102391 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1102394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102400 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102413 */     // GIR_Coverage, 60925,
     /* 1102413 */     GIR_EraseRootFromParent_Done,
     /* 1102414 */   // Label 16201: @1102414
     /* 1102414 */   GIM_Try, /*On fail goto*//*Label 16202*/ GIMT_Encode4(1102491), // Rule ID 60928 //
     /* 1102419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1102422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1102430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1102433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1102436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102458 */     // MIs[0] policy
     /* 1102458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1102471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102490 */     // GIR_Coverage, 60928,
     /* 1102490 */     GIR_EraseRootFromParent_Done,
     /* 1102491 */   // Label 16202: @1102491
     /* 1102491 */   GIM_Try, /*On fail goto*//*Label 16203*/ GIMT_Encode4(1102568), // Rule ID 60929 //
     /* 1102496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1102507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1102510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1102513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102535 */     // MIs[0] policy
     /* 1102535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102545 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1102548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102554 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102567 */     // GIR_Coverage, 60929,
     /* 1102567 */     GIR_EraseRootFromParent_Done,
     /* 1102568 */   // Label 16203: @1102568
     /* 1102568 */   GIM_Try, /*On fail goto*//*Label 16204*/ GIMT_Encode4(1102645), // Rule ID 60932 //
     /* 1102573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1102576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1102584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1102587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102612 */     // MIs[0] policy
     /* 1102612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102622 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1102625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102644 */     // GIR_Coverage, 60932,
     /* 1102644 */     GIR_EraseRootFromParent_Done,
     /* 1102645 */   // Label 16204: @1102645
     /* 1102645 */   GIM_Try, /*On fail goto*//*Label 16205*/ GIMT_Encode4(1102722), // Rule ID 60933 //
     /* 1102650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1102661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1102664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102689 */     // MIs[0] policy
     /* 1102689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102699 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1102702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102708 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102721 */     // GIR_Coverage, 60933,
     /* 1102721 */     GIR_EraseRootFromParent_Done,
     /* 1102722 */   // Label 16205: @1102722
     /* 1102722 */   GIM_Try, /*On fail goto*//*Label 16206*/ GIMT_Encode4(1102799), // Rule ID 60936 //
     /* 1102727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1102730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1102738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1102741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1102744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102766 */     // MIs[0] policy
     /* 1102766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1102779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102798 */     // GIR_Coverage, 60936,
     /* 1102798 */     GIR_EraseRootFromParent_Done,
     /* 1102799 */   // Label 16206: @1102799
     /* 1102799 */   GIM_Try, /*On fail goto*//*Label 16207*/ GIMT_Encode4(1102876), // Rule ID 60937 //
     /* 1102804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1102815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1102818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1102821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102843 */     // MIs[0] policy
     /* 1102843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102853 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1102856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102862 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102875 */     // GIR_Coverage, 60937,
     /* 1102875 */     GIR_EraseRootFromParent_Done,
     /* 1102876 */   // Label 16207: @1102876
     /* 1102876 */   GIM_Try, /*On fail goto*//*Label 16208*/ GIMT_Encode4(1102953), // Rule ID 60940 //
     /* 1102881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1102884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1102892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1102895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102920 */     // MIs[0] policy
     /* 1102920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1102933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102952 */     // GIR_Coverage, 60940,
     /* 1102952 */     GIR_EraseRootFromParent_Done,
     /* 1102953 */   // Label 16208: @1102953
     /* 1102953 */   GIM_Try, /*On fail goto*//*Label 16209*/ GIMT_Encode4(1103030), // Rule ID 60941 //
     /* 1102958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1102969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1102972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102997 */     // MIs[0] policy
     /* 1102997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103007 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1103010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103016 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103029 */     // GIR_Coverage, 60941,
     /* 1103029 */     GIR_EraseRootFromParent_Done,
     /* 1103030 */   // Label 16209: @1103030
     /* 1103030 */   GIM_Try, /*On fail goto*//*Label 16210*/ GIMT_Encode4(1103107), // Rule ID 60944 //
     /* 1103035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1103038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1103046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1103049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1103052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103074 */     // MIs[0] policy
     /* 1103074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103084 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1103087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103106 */     // GIR_Coverage, 60944,
     /* 1103106 */     GIR_EraseRootFromParent_Done,
     /* 1103107 */   // Label 16210: @1103107
     /* 1103107 */   GIM_Try, /*On fail goto*//*Label 16211*/ GIMT_Encode4(1103184), // Rule ID 60945 //
     /* 1103112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1103115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1103123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1103126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1103129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103151 */     // MIs[0] policy
     /* 1103151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103161 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1103164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103170 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103183 */     // GIR_Coverage, 60945,
     /* 1103183 */     GIR_EraseRootFromParent_Done,
     /* 1103184 */   // Label 16211: @1103184
     /* 1103184 */   GIM_Try, /*On fail goto*//*Label 16212*/ GIMT_Encode4(1103261), // Rule ID 60948 //
     /* 1103189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1103192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1103200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1103203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1103206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1103209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103228 */     // MIs[0] policy
     /* 1103228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103238 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1103241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103260 */     // GIR_Coverage, 60948,
     /* 1103260 */     GIR_EraseRootFromParent_Done,
     /* 1103261 */   // Label 16212: @1103261
     /* 1103261 */   GIM_Try, /*On fail goto*//*Label 16213*/ GIMT_Encode4(1103338), // Rule ID 60949 //
     /* 1103266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1103269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1103277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1103280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1103283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1103286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103305 */     // MIs[0] policy
     /* 1103305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103315 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1103318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103324 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103337 */     // GIR_Coverage, 60949,
     /* 1103337 */     GIR_EraseRootFromParent_Done,
     /* 1103338 */   // Label 16213: @1103338
     /* 1103338 */   GIM_Try, /*On fail goto*//*Label 16214*/ GIMT_Encode4(1103415), // Rule ID 60952 //
     /* 1103343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1103346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1103354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1103357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1103360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1103370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103382 */     // MIs[0] policy
     /* 1103382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103392 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1103395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103414 */     // GIR_Coverage, 60952,
     /* 1103414 */     GIR_EraseRootFromParent_Done,
     /* 1103415 */   // Label 16214: @1103415
     /* 1103415 */   GIM_Try, /*On fail goto*//*Label 16215*/ GIMT_Encode4(1103492), // Rule ID 60953 //
     /* 1103420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1103423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1103431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1103434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1103437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1103447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103459 */     // MIs[0] policy
     /* 1103459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1103472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103478 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103491 */     // GIR_Coverage, 60953,
     /* 1103491 */     GIR_EraseRootFromParent_Done,
     /* 1103492 */   // Label 16215: @1103492
     /* 1103492 */   GIM_Try, /*On fail goto*//*Label 16216*/ GIMT_Encode4(1103569), // Rule ID 60956 //
     /* 1103497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1103500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1103508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1103511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1103514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103536 */     // MIs[0] policy
     /* 1103536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103546 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1103549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103568 */     // GIR_Coverage, 60956,
     /* 1103568 */     GIR_EraseRootFromParent_Done,
     /* 1103569 */   // Label 16216: @1103569
     /* 1103569 */   GIM_Try, /*On fail goto*//*Label 16217*/ GIMT_Encode4(1103646), // Rule ID 60957 //
     /* 1103574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1103577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1103585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1103588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1103591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103613 */     // MIs[0] policy
     /* 1103613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103623 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1103626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103632 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103645 */     // GIR_Coverage, 60957,
     /* 1103645 */     GIR_EraseRootFromParent_Done,
     /* 1103646 */   // Label 16217: @1103646
     /* 1103646 */   GIM_Try, /*On fail goto*//*Label 16218*/ GIMT_Encode4(1103723), // Rule ID 60960 //
     /* 1103651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1103654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1103662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1103665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1103668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103690 */     // MIs[0] policy
     /* 1103690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103700 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1103703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103722 */     // GIR_Coverage, 60960,
     /* 1103722 */     GIR_EraseRootFromParent_Done,
     /* 1103723 */   // Label 16218: @1103723
     /* 1103723 */   GIM_Try, /*On fail goto*//*Label 16219*/ GIMT_Encode4(1103800), // Rule ID 60961 //
     /* 1103728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1103731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1103739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1103742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1103745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103767 */     // MIs[0] policy
     /* 1103767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103777 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1103780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103786 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103799 */     // GIR_Coverage, 60961,
     /* 1103799 */     GIR_EraseRootFromParent_Done,
     /* 1103800 */   // Label 16219: @1103800
     /* 1103800 */   GIM_Try, /*On fail goto*//*Label 16220*/ GIMT_Encode4(1103877), // Rule ID 61384 //
     /* 1103805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1103816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1103819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1103822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103844 */     // MIs[0] policy
     /* 1103844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103854 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1103857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103876 */     // GIR_Coverage, 61384,
     /* 1103876 */     GIR_EraseRootFromParent_Done,
     /* 1103877 */   // Label 16220: @1103877
     /* 1103877 */   GIM_Try, /*On fail goto*//*Label 16221*/ GIMT_Encode4(1103954), // Rule ID 61385 //
     /* 1103882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1103893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1103896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1103899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103921 */     // MIs[0] policy
     /* 1103921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103931 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1103934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103953 */     // GIR_Coverage, 61385,
     /* 1103953 */     GIR_EraseRootFromParent_Done,
     /* 1103954 */   // Label 16221: @1103954
     /* 1103954 */   GIM_Try, /*On fail goto*//*Label 16222*/ GIMT_Encode4(1104031), // Rule ID 61388 //
     /* 1103959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1103970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1103973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1103976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103998 */     // MIs[0] policy
     /* 1103998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104008 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1104011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104030 */     // GIR_Coverage, 61388,
     /* 1104030 */     GIR_EraseRootFromParent_Done,
     /* 1104031 */   // Label 16222: @1104031
     /* 1104031 */   GIM_Try, /*On fail goto*//*Label 16223*/ GIMT_Encode4(1104108), // Rule ID 61389 //
     /* 1104036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1104047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1104050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1104053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104075 */     // MIs[0] policy
     /* 1104075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104085 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1104088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104094 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104107 */     // GIR_Coverage, 61389,
     /* 1104107 */     GIR_EraseRootFromParent_Done,
     /* 1104108 */   // Label 16223: @1104108
     /* 1104108 */   GIM_Try, /*On fail goto*//*Label 16224*/ GIMT_Encode4(1104185), // Rule ID 61392 //
     /* 1104113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1104124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1104127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1104130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104152 */     // MIs[0] policy
     /* 1104152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104162 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1104165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104171 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104184 */     // GIR_Coverage, 61392,
     /* 1104184 */     GIR_EraseRootFromParent_Done,
     /* 1104185 */   // Label 16224: @1104185
     /* 1104185 */   GIM_Try, /*On fail goto*//*Label 16225*/ GIMT_Encode4(1104262), // Rule ID 61393 //
     /* 1104190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1104201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1104204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1104207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104229 */     // MIs[0] policy
     /* 1104229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104239 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1104242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104248 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104261 */     // GIR_Coverage, 61393,
     /* 1104261 */     GIR_EraseRootFromParent_Done,
     /* 1104262 */   // Label 16225: @1104262
     /* 1104262 */   GIM_Try, /*On fail goto*//*Label 16226*/ GIMT_Encode4(1104339), // Rule ID 61396 //
     /* 1104267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1104278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1104281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1104284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104306 */     // MIs[0] policy
     /* 1104306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104316 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1104319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104338 */     // GIR_Coverage, 61396,
     /* 1104338 */     GIR_EraseRootFromParent_Done,
     /* 1104339 */   // Label 16226: @1104339
     /* 1104339 */   GIM_Try, /*On fail goto*//*Label 16227*/ GIMT_Encode4(1104416), // Rule ID 61397 //
     /* 1104344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1104355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1104358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1104361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104383 */     // MIs[0] policy
     /* 1104383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104393 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1104396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104402 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104415 */     // GIR_Coverage, 61397,
     /* 1104415 */     GIR_EraseRootFromParent_Done,
     /* 1104416 */   // Label 16227: @1104416
     /* 1104416 */   GIM_Try, /*On fail goto*//*Label 16228*/ GIMT_Encode4(1104493), // Rule ID 61400 //
     /* 1104421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1104432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1104435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1104438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104460 */     // MIs[0] policy
     /* 1104460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104470 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1104473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104492 */     // GIR_Coverage, 61400,
     /* 1104492 */     GIR_EraseRootFromParent_Done,
     /* 1104493 */   // Label 16228: @1104493
     /* 1104493 */   GIM_Try, /*On fail goto*//*Label 16229*/ GIMT_Encode4(1104570), // Rule ID 61401 //
     /* 1104498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1104509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1104512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1104515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104537 */     // MIs[0] policy
     /* 1104537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104547 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1104550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104556 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104569 */     // GIR_Coverage, 61401,
     /* 1104569 */     GIR_EraseRootFromParent_Done,
     /* 1104570 */   // Label 16229: @1104570
     /* 1104570 */   GIM_Try, /*On fail goto*//*Label 16230*/ GIMT_Encode4(1104647), // Rule ID 61404 //
     /* 1104575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1104592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104614 */     // MIs[0] policy
     /* 1104614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104624 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1104627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104646 */     // GIR_Coverage, 61404,
     /* 1104646 */     GIR_EraseRootFromParent_Done,
     /* 1104647 */   // Label 16230: @1104647
     /* 1104647 */   GIM_Try, /*On fail goto*//*Label 16231*/ GIMT_Encode4(1104724), // Rule ID 61405 //
     /* 1104652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1104669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104691 */     // MIs[0] policy
     /* 1104691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104701 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1104704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104710 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104723 */     // GIR_Coverage, 61405,
     /* 1104723 */     GIR_EraseRootFromParent_Done,
     /* 1104724 */   // Label 16231: @1104724
     /* 1104724 */   GIM_Try, /*On fail goto*//*Label 16232*/ GIMT_Encode4(1104801), // Rule ID 61408 //
     /* 1104729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1104740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1104743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1104746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104768 */     // MIs[0] policy
     /* 1104768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104778 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1104781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104787 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104800 */     // GIR_Coverage, 61408,
     /* 1104800 */     GIR_EraseRootFromParent_Done,
     /* 1104801 */   // Label 16232: @1104801
     /* 1104801 */   GIM_Try, /*On fail goto*//*Label 16233*/ GIMT_Encode4(1104878), // Rule ID 61409 //
     /* 1104806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1104817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1104820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1104823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104845 */     // MIs[0] policy
     /* 1104845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104855 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1104858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104864 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104877 */     // GIR_Coverage, 61409,
     /* 1104877 */     GIR_EraseRootFromParent_Done,
     /* 1104878 */   // Label 16233: @1104878
     /* 1104878 */   GIM_Try, /*On fail goto*//*Label 16234*/ GIMT_Encode4(1104955), // Rule ID 61412 //
     /* 1104883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1104894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1104897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104922 */     // MIs[0] policy
     /* 1104922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104932 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1104935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104954 */     // GIR_Coverage, 61412,
     /* 1104954 */     GIR_EraseRootFromParent_Done,
     /* 1104955 */   // Label 16234: @1104955
     /* 1104955 */   GIM_Try, /*On fail goto*//*Label 16235*/ GIMT_Encode4(1105032), // Rule ID 61413 //
     /* 1104960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1104971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1104974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104999 */     // MIs[0] policy
     /* 1104999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105009 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1105012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105018 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105031 */     // GIR_Coverage, 61413,
     /* 1105031 */     GIR_EraseRootFromParent_Done,
     /* 1105032 */   // Label 16235: @1105032
     /* 1105032 */   GIM_Try, /*On fail goto*//*Label 16236*/ GIMT_Encode4(1105109), // Rule ID 61416 //
     /* 1105037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1105048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1105051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1105054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1105057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105076 */     // MIs[0] policy
     /* 1105076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105086 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1105089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105108 */     // GIR_Coverage, 61416,
     /* 1105108 */     GIR_EraseRootFromParent_Done,
     /* 1105109 */   // Label 16236: @1105109
     /* 1105109 */   GIM_Try, /*On fail goto*//*Label 16237*/ GIMT_Encode4(1105186), // Rule ID 61417 //
     /* 1105114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1105125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1105128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1105131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1105134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105153 */     // MIs[0] policy
     /* 1105153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105163 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1105166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105185 */     // GIR_Coverage, 61417,
     /* 1105185 */     GIR_EraseRootFromParent_Done,
     /* 1105186 */   // Label 16237: @1105186
     /* 1105186 */   GIM_Try, /*On fail goto*//*Label 16238*/ GIMT_Encode4(1105263), // Rule ID 61420 //
     /* 1105191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1105202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1105205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1105208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1105211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105230 */     // MIs[0] policy
     /* 1105230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105240 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1105243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1105259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105262 */     // GIR_Coverage, 61420,
     /* 1105262 */     GIR_EraseRootFromParent_Done,
     /* 1105263 */   // Label 16238: @1105263
     /* 1105263 */   GIM_Try, /*On fail goto*//*Label 16239*/ GIMT_Encode4(1105340), // Rule ID 61421 //
     /* 1105268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1105279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1105282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1105285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1105288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105307 */     // MIs[0] policy
     /* 1105307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105317 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1105320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105326 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1105336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105339 */     // GIR_Coverage, 61421,
     /* 1105339 */     GIR_EraseRootFromParent_Done,
     /* 1105340 */   // Label 16239: @1105340
     /* 1105340 */   GIM_Try, /*On fail goto*//*Label 16240*/ GIMT_Encode4(1105417), // Rule ID 61424 //
     /* 1105345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1105356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1105359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1105362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105384 */     // MIs[0] policy
     /* 1105384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105394 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1105397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105416 */     // GIR_Coverage, 61424,
     /* 1105416 */     GIR_EraseRootFromParent_Done,
     /* 1105417 */   // Label 16240: @1105417
     /* 1105417 */   GIM_Try, /*On fail goto*//*Label 16241*/ GIMT_Encode4(1105494), // Rule ID 61425 //
     /* 1105422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1105433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1105436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1105439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105461 */     // MIs[0] policy
     /* 1105461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1105474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105480 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105493 */     // GIR_Coverage, 61425,
     /* 1105493 */     GIR_EraseRootFromParent_Done,
     /* 1105494 */   // Label 16241: @1105494
     /* 1105494 */   GIM_Try, /*On fail goto*//*Label 16242*/ GIMT_Encode4(1105571), // Rule ID 61428 //
     /* 1105499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1105510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1105513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1105516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105538 */     // MIs[0] policy
     /* 1105538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105548 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1105551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105570 */     // GIR_Coverage, 61428,
     /* 1105570 */     GIR_EraseRootFromParent_Done,
     /* 1105571 */   // Label 16242: @1105571
     /* 1105571 */   GIM_Try, /*On fail goto*//*Label 16243*/ GIMT_Encode4(1105648), // Rule ID 61429 //
     /* 1105576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1105587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1105590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1105593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105615 */     // MIs[0] policy
     /* 1105615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105625 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1105628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105634 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105647 */     // GIR_Coverage, 61429,
     /* 1105647 */     GIR_EraseRootFromParent_Done,
     /* 1105648 */   // Label 16243: @1105648
     /* 1105648 */   GIM_Try, /*On fail goto*//*Label 16244*/ GIMT_Encode4(1105725), // Rule ID 61432 //
     /* 1105653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1105664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1105667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1105670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1105673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105692 */     // MIs[0] policy
     /* 1105692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105702 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1105705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105724 */     // GIR_Coverage, 61432,
     /* 1105724 */     GIR_EraseRootFromParent_Done,
     /* 1105725 */   // Label 16244: @1105725
     /* 1105725 */   GIM_Try, /*On fail goto*//*Label 16245*/ GIMT_Encode4(1105802), // Rule ID 61433 //
     /* 1105730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1105741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1105744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1105747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1105750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105769 */     // MIs[0] policy
     /* 1105769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105779 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1105782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105801 */     // GIR_Coverage, 61433,
     /* 1105801 */     GIR_EraseRootFromParent_Done,
     /* 1105802 */   // Label 16245: @1105802
     /* 1105802 */   GIM_Try, /*On fail goto*//*Label 16246*/ GIMT_Encode4(1105879), // Rule ID 61436 //
     /* 1105807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1105818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1105821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1105824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105846 */     // MIs[0] policy
     /* 1105846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105856 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1105859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105878 */     // GIR_Coverage, 61436,
     /* 1105878 */     GIR_EraseRootFromParent_Done,
     /* 1105879 */   // Label 16246: @1105879
     /* 1105879 */   GIM_Try, /*On fail goto*//*Label 16247*/ GIMT_Encode4(1105956), // Rule ID 61437 //
     /* 1105884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1105895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1105898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1105901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105923 */     // MIs[0] policy
     /* 1105923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105933 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1105936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105942 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105955 */     // GIR_Coverage, 61437,
     /* 1105955 */     GIR_EraseRootFromParent_Done,
     /* 1105956 */   // Label 16247: @1105956
     /* 1105956 */   GIM_Try, /*On fail goto*//*Label 16248*/ GIMT_Encode4(1106033), // Rule ID 61440 //
     /* 1105961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1105972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1105975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1105978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106000 */     // MIs[0] policy
     /* 1106000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106010 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1106013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106019 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106032 */     // GIR_Coverage, 61440,
     /* 1106032 */     GIR_EraseRootFromParent_Done,
     /* 1106033 */   // Label 16248: @1106033
     /* 1106033 */   GIM_Try, /*On fail goto*//*Label 16249*/ GIMT_Encode4(1106110), // Rule ID 61441 //
     /* 1106038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1106049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1106052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1106055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106077 */     // MIs[0] policy
     /* 1106077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106087 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1106090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106096 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106109 */     // GIR_Coverage, 61441,
     /* 1106109 */     GIR_EraseRootFromParent_Done,
     /* 1106110 */   // Label 16249: @1106110
     /* 1106110 */   GIM_Try, /*On fail goto*//*Label 16250*/ GIMT_Encode4(1106187), // Rule ID 61444 //
     /* 1106115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1106126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1106129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1106132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1106135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106154 */     // MIs[0] policy
     /* 1106154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106164 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1106167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106186 */     // GIR_Coverage, 61444,
     /* 1106186 */     GIR_EraseRootFromParent_Done,
     /* 1106187 */   // Label 16250: @1106187
     /* 1106187 */   GIM_Try, /*On fail goto*//*Label 16251*/ GIMT_Encode4(1106264), // Rule ID 61445 //
     /* 1106192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1106203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1106206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1106209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1106212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106231 */     // MIs[0] policy
     /* 1106231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106241 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1106244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106250 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106263 */     // GIR_Coverage, 61445,
     /* 1106263 */     GIR_EraseRootFromParent_Done,
     /* 1106264 */   // Label 16251: @1106264
     /* 1106264 */   GIM_Try, /*On fail goto*//*Label 16252*/ GIMT_Encode4(1106341), // Rule ID 61448 //
     /* 1106269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106308 */     // MIs[0] policy
     /* 1106308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1106321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106340 */     // GIR_Coverage, 61448,
     /* 1106340 */     GIR_EraseRootFromParent_Done,
     /* 1106341 */   // Label 16252: @1106341
     /* 1106341 */   GIM_Try, /*On fail goto*//*Label 16253*/ GIMT_Encode4(1106418), // Rule ID 61449 //
     /* 1106346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106385 */     // MIs[0] policy
     /* 1106385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1106398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106417 */     // GIR_Coverage, 61449,
     /* 1106417 */     GIR_EraseRootFromParent_Done,
     /* 1106418 */   // Label 16253: @1106418
     /* 1106418 */   GIM_Try, /*On fail goto*//*Label 16254*/ GIMT_Encode4(1106495), // Rule ID 61452 //
     /* 1106423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1106440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106462 */     // MIs[0] policy
     /* 1106462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106472 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1106475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106494 */     // GIR_Coverage, 61452,
     /* 1106494 */     GIR_EraseRootFromParent_Done,
     /* 1106495 */   // Label 16254: @1106495
     /* 1106495 */   GIM_Try, /*On fail goto*//*Label 16255*/ GIMT_Encode4(1106572), // Rule ID 61453 //
     /* 1106500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1106517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106539 */     // MIs[0] policy
     /* 1106539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106549 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1106552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106558 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106571 */     // GIR_Coverage, 61453,
     /* 1106571 */     GIR_EraseRootFromParent_Done,
     /* 1106572 */   // Label 16255: @1106572
     /* 1106572 */   GIM_Try, /*On fail goto*//*Label 16256*/ GIMT_Encode4(1106649), // Rule ID 61456 //
     /* 1106577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106616 */     // MIs[0] policy
     /* 1106616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1106629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106648 */     // GIR_Coverage, 61456,
     /* 1106648 */     GIR_EraseRootFromParent_Done,
     /* 1106649 */   // Label 16256: @1106649
     /* 1106649 */   GIM_Try, /*On fail goto*//*Label 16257*/ GIMT_Encode4(1106726), // Rule ID 61457 //
     /* 1106654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106693 */     // MIs[0] policy
     /* 1106693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106703 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1106706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106712 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106725 */     // GIR_Coverage, 61457,
     /* 1106725 */     GIR_EraseRootFromParent_Done,
     /* 1106726 */   // Label 16257: @1106726
     /* 1106726 */   GIM_Try, /*On fail goto*//*Label 16258*/ GIMT_Encode4(1106803), // Rule ID 61460 //
     /* 1106731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1106748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1106751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106770 */     // MIs[0] policy
     /* 1106770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1106783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106802 */     // GIR_Coverage, 61460,
     /* 1106802 */     GIR_EraseRootFromParent_Done,
     /* 1106803 */   // Label 16258: @1106803
     /* 1106803 */   GIM_Try, /*On fail goto*//*Label 16259*/ GIMT_Encode4(1106880), // Rule ID 61461 //
     /* 1106808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1106825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1106828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106847 */     // MIs[0] policy
     /* 1106847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106857 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1106860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106866 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106879 */     // GIR_Coverage, 61461,
     /* 1106879 */     GIR_EraseRootFromParent_Done,
     /* 1106880 */   // Label 16259: @1106880
     /* 1106880 */   GIM_Try, /*On fail goto*//*Label 16260*/ GIMT_Encode4(1106957), // Rule ID 61464 //
     /* 1106885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1106896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1106899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1106902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106924 */     // MIs[0] policy
     /* 1106924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106934 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1106937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106956 */     // GIR_Coverage, 61464,
     /* 1106956 */     GIR_EraseRootFromParent_Done,
     /* 1106957 */   // Label 16260: @1106957
     /* 1106957 */   GIM_Try, /*On fail goto*//*Label 16261*/ GIMT_Encode4(1107034), // Rule ID 61465 //
     /* 1106962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1106973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1106976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1106979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107001 */     // MIs[0] policy
     /* 1107001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107011 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1107014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1107030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107033 */     // GIR_Coverage, 61465,
     /* 1107033 */     GIR_EraseRootFromParent_Done,
     /* 1107034 */   // Label 16261: @1107034
     /* 1107034 */   GIM_Try, /*On fail goto*//*Label 16262*/ GIMT_Encode4(1107111), // Rule ID 61468 //
     /* 1107039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1107047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1107050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1107053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1107056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1107059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1107066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107078 */     // MIs[0] policy
     /* 1107078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107088 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1107091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1107107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107110 */     // GIR_Coverage, 61468,
     /* 1107110 */     GIR_EraseRootFromParent_Done,
     /* 1107111 */   // Label 16262: @1107111
     /* 1107111 */   GIM_Try, /*On fail goto*//*Label 16263*/ GIMT_Encode4(1107188), // Rule ID 61469 //
     /* 1107116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1107124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1107127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1107130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1107133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1107136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1107143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107155 */     // MIs[0] policy
     /* 1107155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107165 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1107168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107174 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1107184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107187 */     // GIR_Coverage, 61469,
     /* 1107187 */     GIR_EraseRootFromParent_Done,
     /* 1107188 */   // Label 16263: @1107188
     /* 1107188 */   GIM_Try, /*On fail goto*//*Label 16264*/ GIMT_Encode4(1107265), // Rule ID 61472 //
     /* 1107193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1107204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1107207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1107210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1107213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107232 */     // MIs[0] policy
     /* 1107232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107242 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1107245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1107261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107264 */     // GIR_Coverage, 61472,
     /* 1107264 */     GIR_EraseRootFromParent_Done,
     /* 1107265 */   // Label 16264: @1107265
     /* 1107265 */   GIM_Try, /*On fail goto*//*Label 16265*/ GIMT_Encode4(1107342), // Rule ID 61473 //
     /* 1107270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1107281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1107284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1107287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1107290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107309 */     // MIs[0] policy
     /* 1107309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107319 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1107322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107328 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1107338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107341 */     // GIR_Coverage, 61473,
     /* 1107341 */     GIR_EraseRootFromParent_Done,
     /* 1107342 */   // Label 16265: @1107342
     /* 1107342 */   GIM_Try, /*On fail goto*//*Label 16266*/ GIMT_Encode4(1107419), // Rule ID 61476 //
     /* 1107347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1107358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1107361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1107364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1107367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107386 */     // MIs[0] policy
     /* 1107386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107396 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1107399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1107415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107418 */     // GIR_Coverage, 61476,
     /* 1107418 */     GIR_EraseRootFromParent_Done,
     /* 1107419 */   // Label 16266: @1107419
     /* 1107419 */   GIM_Try, /*On fail goto*//*Label 16267*/ GIMT_Encode4(1107496), // Rule ID 61477 //
     /* 1107424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1107435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1107438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1107441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1107444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107463 */     // MIs[0] policy
     /* 1107463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107473 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1107476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1107492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107495 */     // GIR_Coverage, 61477,
     /* 1107495 */     GIR_EraseRootFromParent_Done,
     /* 1107496 */   // Label 16267: @1107496
     /* 1107496 */   GIM_Try, /*On fail goto*//*Label 16268*/ GIMT_Encode4(1107573), // Rule ID 61480 //
     /* 1107501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1107512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1107515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1107518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1107521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107540 */     // MIs[0] policy
     /* 1107540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107550 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1107553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1107569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107572 */     // GIR_Coverage, 61480,
     /* 1107572 */     GIR_EraseRootFromParent_Done,
     /* 1107573 */   // Label 16268: @1107573
     /* 1107573 */   GIM_Try, /*On fail goto*//*Label 16269*/ GIMT_Encode4(1107650), // Rule ID 61481 //
     /* 1107578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1107589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1107592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1107595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1107598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107617 */     // MIs[0] policy
     /* 1107617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107627 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1107630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107636 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1107646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107649 */     // GIR_Coverage, 61481,
     /* 1107649 */     GIR_EraseRootFromParent_Done,
     /* 1107650 */   // Label 16269: @1107650
     /* 1107650 */   GIM_Try, /*On fail goto*//*Label 16270*/ GIMT_Encode4(1107727), // Rule ID 61484 //
     /* 1107655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1107666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1107669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1107672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1107675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107694 */     // MIs[0] policy
     /* 1107694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107704 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1107707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107726 */     // GIR_Coverage, 61484,
     /* 1107726 */     GIR_EraseRootFromParent_Done,
     /* 1107727 */   // Label 16270: @1107727
     /* 1107727 */   GIM_Try, /*On fail goto*//*Label 16271*/ GIMT_Encode4(1107804), // Rule ID 61485 //
     /* 1107732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1107743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1107746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1107749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1107752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107771 */     // MIs[0] policy
     /* 1107771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107781 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1107784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107790 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107803 */     // GIR_Coverage, 61485,
     /* 1107803 */     GIR_EraseRootFromParent_Done,
     /* 1107804 */   // Label 16271: @1107804
     /* 1107804 */   GIM_Try, /*On fail goto*//*Label 16272*/ GIMT_Encode4(1107881), // Rule ID 61488 //
     /* 1107809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1107820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1107823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1107826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1107829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107848 */     // MIs[0] policy
     /* 1107848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107858 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1107861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107880 */     // GIR_Coverage, 61488,
     /* 1107880 */     GIR_EraseRootFromParent_Done,
     /* 1107881 */   // Label 16272: @1107881
     /* 1107881 */   GIM_Try, /*On fail goto*//*Label 16273*/ GIMT_Encode4(1107958), // Rule ID 61489 //
     /* 1107886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1107897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1107900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1107903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1107906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107925 */     // MIs[0] policy
     /* 1107925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107935 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1107938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107944 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107957 */     // GIR_Coverage, 61489,
     /* 1107957 */     GIR_EraseRootFromParent_Done,
     /* 1107958 */   // Label 16273: @1107958
     /* 1107958 */   GIM_Try, /*On fail goto*//*Label 16274*/ GIMT_Encode4(1108035), // Rule ID 61492 //
     /* 1107963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1107974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1107977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1107980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1107983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108002 */     // MIs[0] policy
     /* 1108002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108012 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1108015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108034 */     // GIR_Coverage, 61492,
     /* 1108034 */     GIR_EraseRootFromParent_Done,
     /* 1108035 */   // Label 16274: @1108035
     /* 1108035 */   GIM_Try, /*On fail goto*//*Label 16275*/ GIMT_Encode4(1108112), // Rule ID 61493 //
     /* 1108040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1108060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108079 */     // MIs[0] policy
     /* 1108079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108089 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1108092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108098 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108111 */     // GIR_Coverage, 61493,
     /* 1108111 */     GIR_EraseRootFromParent_Done,
     /* 1108112 */   // Label 16275: @1108112
     /* 1108112 */   GIM_Try, /*On fail goto*//*Label 16276*/ GIMT_Encode4(1108189), // Rule ID 61496 //
     /* 1108117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1108120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1108128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1108131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1108134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1108137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108156 */     // MIs[0] policy
     /* 1108156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108166 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1108185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108188 */     // GIR_Coverage, 61496,
     /* 1108188 */     GIR_EraseRootFromParent_Done,
     /* 1108189 */   // Label 16276: @1108189
     /* 1108189 */   GIM_Try, /*On fail goto*//*Label 16277*/ GIMT_Encode4(1108266), // Rule ID 61497 //
     /* 1108194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1108205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1108208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1108211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1108214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108233 */     // MIs[0] policy
     /* 1108233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108243 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108252 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1108262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108265 */     // GIR_Coverage, 61497,
     /* 1108265 */     GIR_EraseRootFromParent_Done,
     /* 1108266 */   // Label 16277: @1108266
     /* 1108266 */   GIM_Try, /*On fail goto*//*Label 16278*/ GIMT_Encode4(1108343), // Rule ID 61500 //
     /* 1108271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1108274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1108282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1108285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1108288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1108291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108310 */     // MIs[0] policy
     /* 1108310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108320 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1108339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108342 */     // GIR_Coverage, 61500,
     /* 1108342 */     GIR_EraseRootFromParent_Done,
     /* 1108343 */   // Label 16278: @1108343
     /* 1108343 */   GIM_Try, /*On fail goto*//*Label 16279*/ GIMT_Encode4(1108420), // Rule ID 61501 //
     /* 1108348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1108359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1108362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1108365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1108368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108387 */     // MIs[0] policy
     /* 1108387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108397 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108406 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1108416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108419 */     // GIR_Coverage, 61501,
     /* 1108419 */     GIR_EraseRootFromParent_Done,
     /* 1108420 */   // Label 16279: @1108420
     /* 1108420 */   GIM_Try, /*On fail goto*//*Label 16280*/ GIMT_Encode4(1108497), // Rule ID 61504 //
     /* 1108425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1108428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1108445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108464 */     // MIs[0] policy
     /* 1108464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108496 */     // GIR_Coverage, 61504,
     /* 1108496 */     GIR_EraseRootFromParent_Done,
     /* 1108497 */   // Label 16280: @1108497
     /* 1108497 */   GIM_Try, /*On fail goto*//*Label 16281*/ GIMT_Encode4(1108574), // Rule ID 61505 //
     /* 1108502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1108522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108541 */     // MIs[0] policy
     /* 1108541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108551 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108560 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108573 */     // GIR_Coverage, 61505,
     /* 1108573 */     GIR_EraseRootFromParent_Done,
     /* 1108574 */   // Label 16281: @1108574
     /* 1108574 */   GIM_Try, /*On fail goto*//*Label 16282*/ GIMT_Encode4(1108651), // Rule ID 61508 //
     /* 1108579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1108582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1108590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1108593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1108596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1108599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108618 */     // MIs[0] policy
     /* 1108618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108628 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1108647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108650 */     // GIR_Coverage, 61508,
     /* 1108650 */     GIR_EraseRootFromParent_Done,
     /* 1108651 */   // Label 16282: @1108651
     /* 1108651 */   GIM_Try, /*On fail goto*//*Label 16283*/ GIMT_Encode4(1108728), // Rule ID 61509 //
     /* 1108656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1108667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1108670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1108673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1108676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108695 */     // MIs[0] policy
     /* 1108695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108705 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108714 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1108724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108727 */     // GIR_Coverage, 61509,
     /* 1108727 */     GIR_EraseRootFromParent_Done,
     /* 1108728 */   // Label 16283: @1108728
     /* 1108728 */   GIM_Try, /*On fail goto*//*Label 16284*/ GIMT_Encode4(1108805), // Rule ID 61512 //
     /* 1108733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1108736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1108744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1108747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1108750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1108753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1108760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108772 */     // MIs[0] policy
     /* 1108772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108782 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1108785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1108801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108804 */     // GIR_Coverage, 61512,
     /* 1108804 */     GIR_EraseRootFromParent_Done,
     /* 1108805 */   // Label 16284: @1108805
     /* 1108805 */   GIM_Try, /*On fail goto*//*Label 16285*/ GIMT_Encode4(1108882), // Rule ID 61513 //
     /* 1108810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1108821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1108824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1108827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1108830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1108837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108849 */     // MIs[0] policy
     /* 1108849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108859 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1108862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1108878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108881 */     // GIR_Coverage, 61513,
     /* 1108881 */     GIR_EraseRootFromParent_Done,
     /* 1108882 */   // Label 16285: @1108882
     /* 1108882 */   GIM_Try, /*On fail goto*//*Label 16286*/ GIMT_Encode4(1108959), // Rule ID 61516 //
     /* 1108887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1108890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1108898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1108901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1108904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1108907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1108914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108926 */     // MIs[0] policy
     /* 1108926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108936 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1108939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1108955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108958 */     // GIR_Coverage, 61516,
     /* 1108958 */     GIR_EraseRootFromParent_Done,
     /* 1108959 */   // Label 16286: @1108959
     /* 1108959 */   GIM_Try, /*On fail goto*//*Label 16287*/ GIMT_Encode4(1109036), // Rule ID 61517 //
     /* 1108964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1108975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1108978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1108981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1108984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1108991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109003 */     // MIs[0] policy
     /* 1109003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109013 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1109016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109022 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1109032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109035 */     // GIR_Coverage, 61517,
     /* 1109035 */     GIR_EraseRootFromParent_Done,
     /* 1109036 */   // Label 16287: @1109036
     /* 1109036 */   GIM_Try, /*On fail goto*//*Label 16288*/ GIMT_Encode4(1109113), // Rule ID 61520 //
     /* 1109041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1109052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1109055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1109058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1109061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1109068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109080 */     // MIs[0] policy
     /* 1109080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109090 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1109093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1109109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109112 */     // GIR_Coverage, 61520,
     /* 1109112 */     GIR_EraseRootFromParent_Done,
     /* 1109113 */   // Label 16288: @1109113
     /* 1109113 */   GIM_Try, /*On fail goto*//*Label 16289*/ GIMT_Encode4(1109190), // Rule ID 61521 //
     /* 1109118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1109121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1109129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1109132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1109135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1109138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1109145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109157 */     // MIs[0] policy
     /* 1109157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109167 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1109170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109176 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1109186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109189 */     // GIR_Coverage, 61521,
     /* 1109189 */     GIR_EraseRootFromParent_Done,
     /* 1109190 */   // Label 16289: @1109190
     /* 1109190 */   GIM_Try, /*On fail goto*//*Label 16290*/ GIMT_Encode4(1109267), // Rule ID 61524 //
     /* 1109195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1109206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1109209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1109212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1109215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1109222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109234 */     // MIs[0] policy
     /* 1109234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109244 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1109247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109266 */     // GIR_Coverage, 61524,
     /* 1109266 */     GIR_EraseRootFromParent_Done,
     /* 1109267 */   // Label 16290: @1109267
     /* 1109267 */   GIM_Try, /*On fail goto*//*Label 16291*/ GIMT_Encode4(1109344), // Rule ID 61525 //
     /* 1109272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1109275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1109283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1109286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1109289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1109292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1109299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109311 */     // MIs[0] policy
     /* 1109311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1109324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109330 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109343 */     // GIR_Coverage, 61525,
     /* 1109343 */     GIR_EraseRootFromParent_Done,
     /* 1109344 */   // Label 16291: @1109344
     /* 1109344 */   GIM_Try, /*On fail goto*//*Label 16292*/ GIMT_Encode4(1109421), // Rule ID 61528 //
     /* 1109349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1109360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1109363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1109366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1109369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1109376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109388 */     // MIs[0] policy
     /* 1109388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109398 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1109401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109420 */     // GIR_Coverage, 61528,
     /* 1109420 */     GIR_EraseRootFromParent_Done,
     /* 1109421 */   // Label 16292: @1109421
     /* 1109421 */   GIM_Try, /*On fail goto*//*Label 16293*/ GIMT_Encode4(1109498), // Rule ID 61529 //
     /* 1109426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1109429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1109437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1109440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1109443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1109446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1109453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109465 */     // MIs[0] policy
     /* 1109465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109475 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1109478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109484 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109497 */     // GIR_Coverage, 61529,
     /* 1109497 */     GIR_EraseRootFromParent_Done,
     /* 1109498 */   // Label 16293: @1109498
     /* 1109498 */   GIM_Try, /*On fail goto*//*Label 16294*/ GIMT_Encode4(1109575), // Rule ID 61532 //
     /* 1109503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1109514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1109517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1109520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1109523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1109530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109542 */     // MIs[0] policy
     /* 1109542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109552 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1109555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109574 */     // GIR_Coverage, 61532,
     /* 1109574 */     GIR_EraseRootFromParent_Done,
     /* 1109575 */   // Label 16294: @1109575
     /* 1109575 */   GIM_Try, /*On fail goto*//*Label 16295*/ GIMT_Encode4(1109652), // Rule ID 61533 //
     /* 1109580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1109583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1109591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1109594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1109597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1109600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1109607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109619 */     // MIs[0] policy
     /* 1109619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109629 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1109632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109638 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109651 */     // GIR_Coverage, 61533,
     /* 1109651 */     GIR_EraseRootFromParent_Done,
     /* 1109652 */   // Label 16295: @1109652
     /* 1109652 */   GIM_Try, /*On fail goto*//*Label 16296*/ GIMT_Encode4(1109729), // Rule ID 61536 //
     /* 1109657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1109677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1109684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109696 */     // MIs[0] policy
     /* 1109696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1109709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109728 */     // GIR_Coverage, 61536,
     /* 1109728 */     GIR_EraseRootFromParent_Done,
     /* 1109729 */   // Label 16296: @1109729
     /* 1109729 */   GIM_Try, /*On fail goto*//*Label 16297*/ GIMT_Encode4(1109806), // Rule ID 61537 //
     /* 1109734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1109737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1109754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1109761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109773 */     // MIs[0] policy
     /* 1109773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1109786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109792 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109805 */     // GIR_Coverage, 61537,
     /* 1109805 */     GIR_EraseRootFromParent_Done,
     /* 1109806 */   // Label 16297: @1109806
     /* 1109806 */   GIM_Try, /*On fail goto*//*Label 16298*/ GIMT_Encode4(1109883), // Rule ID 61540 //
     /* 1109811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1109831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1109838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109850 */     // MIs[0] policy
     /* 1109850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109860 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1109863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109882 */     // GIR_Coverage, 61540,
     /* 1109882 */     GIR_EraseRootFromParent_Done,
     /* 1109883 */   // Label 16298: @1109883
     /* 1109883 */   GIM_Try, /*On fail goto*//*Label 16299*/ GIMT_Encode4(1109960), // Rule ID 61541 //
     /* 1109888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1109891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1109908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1109915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109927 */     // MIs[0] policy
     /* 1109927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109937 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1109940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109946 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109959 */     // GIR_Coverage, 61541,
     /* 1109959 */     GIR_EraseRootFromParent_Done,
     /* 1109960 */   // Label 16299: @1109960
     /* 1109960 */   GIM_Try, /*On fail goto*//*Label 16300*/ GIMT_Encode4(1110037), // Rule ID 61544 //
     /* 1109965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1109985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1109992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110004 */     // MIs[0] policy
     /* 1110004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110014 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1110017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110036 */     // GIR_Coverage, 61544,
     /* 1110036 */     GIR_EraseRootFromParent_Done,
     /* 1110037 */   // Label 16300: @1110037
     /* 1110037 */   GIM_Try, /*On fail goto*//*Label 16301*/ GIMT_Encode4(1110114), // Rule ID 61545 //
     /* 1110042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1110045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1110062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1110069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110081 */     // MIs[0] policy
     /* 1110081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110091 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1110094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110113 */     // GIR_Coverage, 61545,
     /* 1110113 */     GIR_EraseRootFromParent_Done,
     /* 1110114 */   // Label 16301: @1110114
     /* 1110114 */   GIM_Try, /*On fail goto*//*Label 16302*/ GIMT_Encode4(1110191), // Rule ID 61548 //
     /* 1110119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1110122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1110130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1110133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1110136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1110139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1110146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110158 */     // MIs[0] policy
     /* 1110158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1110171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110190 */     // GIR_Coverage, 61548,
     /* 1110190 */     GIR_EraseRootFromParent_Done,
     /* 1110191 */   // Label 16302: @1110191
     /* 1110191 */   GIM_Try, /*On fail goto*//*Label 16303*/ GIMT_Encode4(1110268), // Rule ID 61549 //
     /* 1110196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1110199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1110207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1110210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1110213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1110216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1110223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110235 */     // MIs[0] policy
     /* 1110235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110245 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1110248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110254 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110267 */     // GIR_Coverage, 61549,
     /* 1110267 */     GIR_EraseRootFromParent_Done,
     /* 1110268 */   // Label 16303: @1110268
     /* 1110268 */   GIM_Try, /*On fail goto*//*Label 16304*/ GIMT_Encode4(1110345), // Rule ID 61552 //
     /* 1110273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1110276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1110284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1110287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1110290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1110293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1110300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110312 */     // MIs[0] policy
     /* 1110312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110322 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1110325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110344 */     // GIR_Coverage, 61552,
     /* 1110344 */     GIR_EraseRootFromParent_Done,
     /* 1110345 */   // Label 16304: @1110345
     /* 1110345 */   GIM_Try, /*On fail goto*//*Label 16305*/ GIMT_Encode4(1110422), // Rule ID 61553 //
     /* 1110350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1110353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1110361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1110364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1110367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1110370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1110377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110389 */     // MIs[0] policy
     /* 1110389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110399 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1110402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110421 */     // GIR_Coverage, 61553,
     /* 1110421 */     GIR_EraseRootFromParent_Done,
     /* 1110422 */   // Label 16305: @1110422
     /* 1110422 */   GIM_Try, /*On fail goto*//*Label 16306*/ GIMT_Encode4(1110499), // Rule ID 61556 //
     /* 1110427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1110430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1110438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1110441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1110444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1110447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1110454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110466 */     // MIs[0] policy
     /* 1110466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1110479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110498 */     // GIR_Coverage, 61556,
     /* 1110498 */     GIR_EraseRootFromParent_Done,
     /* 1110499 */   // Label 16306: @1110499
     /* 1110499 */   GIM_Try, /*On fail goto*//*Label 16307*/ GIMT_Encode4(1110576), // Rule ID 61557 //
     /* 1110504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1110507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1110515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1110518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1110521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1110524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1110531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110543 */     // MIs[0] policy
     /* 1110543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110553 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1110556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110562 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110575 */     // GIR_Coverage, 61557,
     /* 1110575 */     GIR_EraseRootFromParent_Done,
     /* 1110576 */   // Label 16307: @1110576
     /* 1110576 */   GIM_Try, /*On fail goto*//*Label 16308*/ GIMT_Encode4(1110653), // Rule ID 62082 //
     /* 1110581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1110584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1110589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1110592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1110595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1110598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1110601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110620 */     // MIs[0] policy
     /* 1110620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110630 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1110633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110652 */     // GIR_Coverage, 62082,
     /* 1110652 */     GIR_EraseRootFromParent_Done,
     /* 1110653 */   // Label 16308: @1110653
     /* 1110653 */   GIM_Try, /*On fail goto*//*Label 16309*/ GIMT_Encode4(1110730), // Rule ID 62083 //
     /* 1110658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1110661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1110666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1110669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1110672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1110675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1110678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110697 */     // MIs[0] policy
     /* 1110697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110707 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1110710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110729 */     // GIR_Coverage, 62083,
     /* 1110729 */     GIR_EraseRootFromParent_Done,
     /* 1110730 */   // Label 16309: @1110730
     /* 1110730 */   GIM_Try, /*On fail goto*//*Label 16310*/ GIMT_Encode4(1110807), // Rule ID 62084 //
     /* 1110735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1110738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1110743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1110755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110774 */     // MIs[0] policy
     /* 1110774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1110787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110806 */     // GIR_Coverage, 62084,
     /* 1110806 */     GIR_EraseRootFromParent_Done,
     /* 1110807 */   // Label 16310: @1110807
     /* 1110807 */   GIM_Try, /*On fail goto*//*Label 16311*/ GIMT_Encode4(1110884), // Rule ID 62085 //
     /* 1110812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1110815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1110820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1110832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110851 */     // MIs[0] policy
     /* 1110851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110861 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1110864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110883 */     // GIR_Coverage, 62085,
     /* 1110883 */     GIR_EraseRootFromParent_Done,
     /* 1110884 */   // Label 16311: @1110884
     /* 1110884 */   GIM_Try, /*On fail goto*//*Label 16312*/ GIMT_Encode4(1110961), // Rule ID 62086 //
     /* 1110889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1110892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1110897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1110909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110928 */     // MIs[0] policy
     /* 1110928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110938 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1110941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110960 */     // GIR_Coverage, 62086,
     /* 1110960 */     GIR_EraseRootFromParent_Done,
     /* 1110961 */   // Label 16312: @1110961
     /* 1110961 */   GIM_Try, /*On fail goto*//*Label 16313*/ GIMT_Encode4(1111038), // Rule ID 62087 //
     /* 1110966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1110969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1110974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1110986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111005 */     // MIs[0] policy
     /* 1111005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111015 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1111018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111037 */     // GIR_Coverage, 62087,
     /* 1111037 */     GIR_EraseRootFromParent_Done,
     /* 1111038 */   // Label 16313: @1111038
     /* 1111038 */   GIM_Try, /*On fail goto*//*Label 16314*/ GIMT_Encode4(1111115), // Rule ID 62088 //
     /* 1111043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1111046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1111051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111082 */     // MIs[0] policy
     /* 1111082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111092 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1111095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111114 */     // GIR_Coverage, 62088,
     /* 1111114 */     GIR_EraseRootFromParent_Done,
     /* 1111115 */   // Label 16314: @1111115
     /* 1111115 */   GIM_Try, /*On fail goto*//*Label 16315*/ GIMT_Encode4(1111192), // Rule ID 62089 //
     /* 1111120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1111123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1111128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111159 */     // MIs[0] policy
     /* 1111159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111169 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1111172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111191 */     // GIR_Coverage, 62089,
     /* 1111191 */     GIR_EraseRootFromParent_Done,
     /* 1111192 */   // Label 16315: @1111192
     /* 1111192 */   GIM_Try, /*On fail goto*//*Label 16316*/ GIMT_Encode4(1111269), // Rule ID 62292 //
     /* 1111197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1111200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111236 */     // MIs[0] policy
     /* 1111236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1111249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111268 */     // GIR_Coverage, 62292,
     /* 1111268 */     GIR_EraseRootFromParent_Done,
     /* 1111269 */   // Label 16316: @1111269
     /* 1111269 */   GIM_Try, /*On fail goto*//*Label 16317*/ GIMT_Encode4(1111346), // Rule ID 62293 //
     /* 1111274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1111277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111313 */     // MIs[0] policy
     /* 1111313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111323 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1111326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111345 */     // GIR_Coverage, 62293,
     /* 1111345 */     GIR_EraseRootFromParent_Done,
     /* 1111346 */   // Label 16317: @1111346
     /* 1111346 */   GIM_Try, /*On fail goto*//*Label 16318*/ GIMT_Encode4(1111423), // Rule ID 62294 //
     /* 1111351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1111354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111390 */     // MIs[0] policy
     /* 1111390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111422 */     // GIR_Coverage, 62294,
     /* 1111422 */     GIR_EraseRootFromParent_Done,
     /* 1111423 */   // Label 16318: @1111423
     /* 1111423 */   GIM_Try, /*On fail goto*//*Label 16319*/ GIMT_Encode4(1111500), // Rule ID 62295 //
     /* 1111428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1111431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111467 */     // MIs[0] policy
     /* 1111467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111477 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111499 */     // GIR_Coverage, 62295,
     /* 1111499 */     GIR_EraseRootFromParent_Done,
     /* 1111500 */   // Label 16319: @1111500
     /* 1111500 */   GIM_Try, /*On fail goto*//*Label 16320*/ GIMT_Encode4(1111577), // Rule ID 62296 //
     /* 1111505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1111508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1111522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1111525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111544 */     // MIs[0] policy
     /* 1111544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111576 */     // GIR_Coverage, 62296,
     /* 1111576 */     GIR_EraseRootFromParent_Done,
     /* 1111577 */   // Label 16320: @1111577
     /* 1111577 */   GIM_Try, /*On fail goto*//*Label 16321*/ GIMT_Encode4(1111654), // Rule ID 62297 //
     /* 1111582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1111585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1111599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1111602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111621 */     // MIs[0] policy
     /* 1111621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111631 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111653 */     // GIR_Coverage, 62297,
     /* 1111653 */     GIR_EraseRootFromParent_Done,
     /* 1111654 */   // Label 16321: @1111654
     /* 1111654 */   GIM_Try, /*On fail goto*//*Label 16322*/ GIMT_Encode4(1111731), // Rule ID 62298 //
     /* 1111659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1111662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1111670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1111673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1111676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1111679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111698 */     // MIs[0] policy
     /* 1111698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111708 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111730 */     // GIR_Coverage, 62298,
     /* 1111730 */     GIR_EraseRootFromParent_Done,
     /* 1111731 */   // Label 16322: @1111731
     /* 1111731 */   GIM_Try, /*On fail goto*//*Label 16323*/ GIMT_Encode4(1111808), // Rule ID 62299 //
     /* 1111736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1111739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1111747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1111750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1111753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1111756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111775 */     // MIs[0] policy
     /* 1111775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111785 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111807 */     // GIR_Coverage, 62299,
     /* 1111807 */     GIR_EraseRootFromParent_Done,
     /* 1111808 */   // Label 16323: @1111808
     /* 1111808 */   GIM_Try, /*On fail goto*//*Label 16324*/ GIMT_Encode4(1111885), // Rule ID 62300 //
     /* 1111813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1111816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111852 */     // MIs[0] policy
     /* 1111852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111862 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111884 */     // GIR_Coverage, 62300,
     /* 1111884 */     GIR_EraseRootFromParent_Done,
     /* 1111885 */   // Label 16324: @1111885
     /* 1111885 */   GIM_Try, /*On fail goto*//*Label 16325*/ GIMT_Encode4(1111962), // Rule ID 62301 //
     /* 1111890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1111893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111929 */     // MIs[0] policy
     /* 1111929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111939 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111961 */     // GIR_Coverage, 62301,
     /* 1111961 */     GIR_EraseRootFromParent_Done,
     /* 1111962 */   // Label 16325: @1111962
     /* 1111962 */   GIM_Try, /*On fail goto*//*Label 16326*/ GIMT_Encode4(1112039), // Rule ID 62302 //
     /* 1111967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1111970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112006 */     // MIs[0] policy
     /* 1112006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1112019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112038 */     // GIR_Coverage, 62302,
     /* 1112038 */     GIR_EraseRootFromParent_Done,
     /* 1112039 */   // Label 16326: @1112039
     /* 1112039 */   GIM_Try, /*On fail goto*//*Label 16327*/ GIMT_Encode4(1112116), // Rule ID 62303 //
     /* 1112044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112083 */     // MIs[0] policy
     /* 1112083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112093 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1112096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112115 */     // GIR_Coverage, 62303,
     /* 1112115 */     GIR_EraseRootFromParent_Done,
     /* 1112116 */   // Label 16327: @1112116
     /* 1112116 */   GIM_Try, /*On fail goto*//*Label 16328*/ GIMT_Encode4(1112193), // Rule ID 62304 //
     /* 1112121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1112124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112160 */     // MIs[0] policy
     /* 1112160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1112173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112192 */     // GIR_Coverage, 62304,
     /* 1112192 */     GIR_EraseRootFromParent_Done,
     /* 1112193 */   // Label 16328: @1112193
     /* 1112193 */   GIM_Try, /*On fail goto*//*Label 16329*/ GIMT_Encode4(1112270), // Rule ID 62305 //
     /* 1112198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112237 */     // MIs[0] policy
     /* 1112237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112247 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1112250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112269 */     // GIR_Coverage, 62305,
     /* 1112269 */     GIR_EraseRootFromParent_Done,
     /* 1112270 */   // Label 16329: @1112270
     /* 1112270 */   GIM_Try, /*On fail goto*//*Label 16330*/ GIMT_Encode4(1112347), // Rule ID 62306 //
     /* 1112275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1112278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1112286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1112289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1112292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1112295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112314 */     // MIs[0] policy
     /* 1112314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112346 */     // GIR_Coverage, 62306,
     /* 1112346 */     GIR_EraseRootFromParent_Done,
     /* 1112347 */   // Label 16330: @1112347
     /* 1112347 */   GIM_Try, /*On fail goto*//*Label 16331*/ GIMT_Encode4(1112424), // Rule ID 62307 //
     /* 1112352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1112363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1112366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1112369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1112372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112391 */     // MIs[0] policy
     /* 1112391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112423 */     // GIR_Coverage, 62307,
     /* 1112423 */     GIR_EraseRootFromParent_Done,
     /* 1112424 */   // Label 16331: @1112424
     /* 1112424 */   GIM_Try, /*On fail goto*//*Label 16332*/ GIMT_Encode4(1112501), // Rule ID 62308 //
     /* 1112429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1112432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1112440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1112443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1112446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1112449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112468 */     // MIs[0] policy
     /* 1112468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112500 */     // GIR_Coverage, 62308,
     /* 1112500 */     GIR_EraseRootFromParent_Done,
     /* 1112501 */   // Label 16332: @1112501
     /* 1112501 */   GIM_Try, /*On fail goto*//*Label 16333*/ GIMT_Encode4(1112578), // Rule ID 62309 //
     /* 1112506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1112517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1112520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1112523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1112526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112545 */     // MIs[0] policy
     /* 1112545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112555 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112577 */     // GIR_Coverage, 62309,
     /* 1112577 */     GIR_EraseRootFromParent_Done,
     /* 1112578 */   // Label 16333: @1112578
     /* 1112578 */   GIM_Try, /*On fail goto*//*Label 16334*/ GIMT_Encode4(1112655), // Rule ID 62310 //
     /* 1112583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1112586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1112594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1112597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1112600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1112603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112622 */     // MIs[0] policy
     /* 1112622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112654 */     // GIR_Coverage, 62310,
     /* 1112654 */     GIR_EraseRootFromParent_Done,
     /* 1112655 */   // Label 16334: @1112655
     /* 1112655 */   GIM_Try, /*On fail goto*//*Label 16335*/ GIMT_Encode4(1112732), // Rule ID 62311 //
     /* 1112660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1112671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1112674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1112677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1112680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112699 */     // MIs[0] policy
     /* 1112699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112709 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112731 */     // GIR_Coverage, 62311,
     /* 1112731 */     GIR_EraseRootFromParent_Done,
     /* 1112732 */   // Label 16335: @1112732
     /* 1112732 */   GIM_Try, /*On fail goto*//*Label 16336*/ GIMT_Encode4(1112809), // Rule ID 62312 //
     /* 1112737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1112740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112776 */     // MIs[0] policy
     /* 1112776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112786 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1112789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112808 */     // GIR_Coverage, 62312,
     /* 1112808 */     GIR_EraseRootFromParent_Done,
     /* 1112809 */   // Label 16336: @1112809
     /* 1112809 */   GIM_Try, /*On fail goto*//*Label 16337*/ GIMT_Encode4(1112886), // Rule ID 62313 //
     /* 1112814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112853 */     // MIs[0] policy
     /* 1112853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112863 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1112866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112885 */     // GIR_Coverage, 62313,
     /* 1112885 */     GIR_EraseRootFromParent_Done,
     /* 1112886 */   // Label 16337: @1112886
     /* 1112886 */   GIM_Try, /*On fail goto*//*Label 16338*/ GIMT_Encode4(1112963), // Rule ID 62314 //
     /* 1112891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1112894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112930 */     // MIs[0] policy
     /* 1112930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1112943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112962 */     // GIR_Coverage, 62314,
     /* 1112962 */     GIR_EraseRootFromParent_Done,
     /* 1112963 */   // Label 16338: @1112963
     /* 1112963 */   GIM_Try, /*On fail goto*//*Label 16339*/ GIMT_Encode4(1113040), // Rule ID 62315 //
     /* 1112968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113007 */     // MIs[0] policy
     /* 1113007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113017 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1113020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113039 */     // GIR_Coverage, 62315,
     /* 1113039 */     GIR_EraseRootFromParent_Done,
     /* 1113040 */   // Label 16339: @1113040
     /* 1113040 */   GIM_Try, /*On fail goto*//*Label 16340*/ GIMT_Encode4(1113117), // Rule ID 62316 //
     /* 1113045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1113048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1113056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1113059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1113062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1113065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113084 */     // MIs[0] policy
     /* 1113084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1113097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113116 */     // GIR_Coverage, 62316,
     /* 1113116 */     GIR_EraseRootFromParent_Done,
     /* 1113117 */   // Label 16340: @1113117
     /* 1113117 */   GIM_Try, /*On fail goto*//*Label 16341*/ GIMT_Encode4(1113194), // Rule ID 62317 //
     /* 1113122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1113125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1113133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1113136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1113139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1113142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113161 */     // MIs[0] policy
     /* 1113161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113171 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1113174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113193 */     // GIR_Coverage, 62317,
     /* 1113193 */     GIR_EraseRootFromParent_Done,
     /* 1113194 */   // Label 16341: @1113194
     /* 1113194 */   GIM_Try, /*On fail goto*//*Label 16342*/ GIMT_Encode4(1113271), // Rule ID 62318 //
     /* 1113199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1113202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1113216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1113219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113238 */     // MIs[0] policy
     /* 1113238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1113251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113270 */     // GIR_Coverage, 62318,
     /* 1113270 */     GIR_EraseRootFromParent_Done,
     /* 1113271 */   // Label 16342: @1113271
     /* 1113271 */   GIM_Try, /*On fail goto*//*Label 16343*/ GIMT_Encode4(1113348), // Rule ID 62319 //
     /* 1113276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1113279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1113293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1113296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113315 */     // MIs[0] policy
     /* 1113315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113325 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1113328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113347 */     // GIR_Coverage, 62319,
     /* 1113347 */     GIR_EraseRootFromParent_Done,
     /* 1113348 */   // Label 16343: @1113348
     /* 1113348 */   GIM_Try, /*On fail goto*//*Label 16344*/ GIMT_Encode4(1113425), // Rule ID 62320 //
     /* 1113353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1113356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1113364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1113367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1113370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1113373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113392 */     // MIs[0] policy
     /* 1113392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113402 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1113405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113424 */     // GIR_Coverage, 62320,
     /* 1113424 */     GIR_EraseRootFromParent_Done,
     /* 1113425 */   // Label 16344: @1113425
     /* 1113425 */   GIM_Try, /*On fail goto*//*Label 16345*/ GIMT_Encode4(1113502), // Rule ID 62321 //
     /* 1113430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1113433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1113441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1113444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1113447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1113450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113469 */     // MIs[0] policy
     /* 1113469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113479 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1113482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113501 */     // GIR_Coverage, 62321,
     /* 1113501 */     GIR_EraseRootFromParent_Done,
     /* 1113502 */   // Label 16345: @1113502
     /* 1113502 */   GIM_Try, /*On fail goto*//*Label 16346*/ GIMT_Encode4(1113579), // Rule ID 62322 //
     /* 1113507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1113518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1113521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1113524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1113527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113546 */     // MIs[0] policy
     /* 1113546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113556 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1113559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113578 */     // GIR_Coverage, 62322,
     /* 1113578 */     GIR_EraseRootFromParent_Done,
     /* 1113579 */   // Label 16346: @1113579
     /* 1113579 */   GIM_Try, /*On fail goto*//*Label 16347*/ GIMT_Encode4(1113656), // Rule ID 62323 //
     /* 1113584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1113595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1113598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1113601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1113604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113623 */     // MIs[0] policy
     /* 1113623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113633 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1113636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113655 */     // GIR_Coverage, 62323,
     /* 1113655 */     GIR_EraseRootFromParent_Done,
     /* 1113656 */   // Label 16347: @1113656
     /* 1113656 */   GIM_Try, /*On fail goto*//*Label 16348*/ GIMT_Encode4(1113733), // Rule ID 62324 //
     /* 1113661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1113675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1113678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1113681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113700 */     // MIs[0] policy
     /* 1113700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113710 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1113713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113732 */     // GIR_Coverage, 62324,
     /* 1113732 */     GIR_EraseRootFromParent_Done,
     /* 1113733 */   // Label 16348: @1113733
     /* 1113733 */   GIM_Try, /*On fail goto*//*Label 16349*/ GIMT_Encode4(1113810), // Rule ID 62325 //
     /* 1113738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1113752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1113755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1113758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113777 */     // MIs[0] policy
     /* 1113777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113787 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1113790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113809 */     // GIR_Coverage, 62325,
     /* 1113809 */     GIR_EraseRootFromParent_Done,
     /* 1113810 */   // Label 16349: @1113810
     /* 1113810 */   GIM_Try, /*On fail goto*//*Label 16350*/ GIMT_Encode4(1113887), // Rule ID 62326 //
     /* 1113815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1113826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1113829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1113832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1113835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113854 */     // MIs[0] policy
     /* 1113854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113864 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1113867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113886 */     // GIR_Coverage, 62326,
     /* 1113886 */     GIR_EraseRootFromParent_Done,
     /* 1113887 */   // Label 16350: @1113887
     /* 1113887 */   GIM_Try, /*On fail goto*//*Label 16351*/ GIMT_Encode4(1113964), // Rule ID 62327 //
     /* 1113892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1113903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1113906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1113909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1113912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113931 */     // MIs[0] policy
     /* 1113931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113941 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1113944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113963 */     // GIR_Coverage, 62327,
     /* 1113963 */     GIR_EraseRootFromParent_Done,
     /* 1113964 */   // Label 16351: @1113964
     /* 1113964 */   GIM_Try, /*On fail goto*//*Label 16352*/ GIMT_Encode4(1114041), // Rule ID 62328 //
     /* 1113969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1113980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1113983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1113986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1113989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114008 */     // MIs[0] policy
     /* 1114008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114018 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1114021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114040 */     // GIR_Coverage, 62328,
     /* 1114040 */     GIR_EraseRootFromParent_Done,
     /* 1114041 */   // Label 16352: @1114041
     /* 1114041 */   GIM_Try, /*On fail goto*//*Label 16353*/ GIMT_Encode4(1114118), // Rule ID 62329 //
     /* 1114046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1114063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1114066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114085 */     // MIs[0] policy
     /* 1114085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114095 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1114098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114117 */     // GIR_Coverage, 62329,
     /* 1114117 */     GIR_EraseRootFromParent_Done,
     /* 1114118 */   // Label 16353: @1114118
     /* 1114118 */   GIM_Try, /*On fail goto*//*Label 16354*/ GIMT_Encode4(1114195), // Rule ID 62330 //
     /* 1114123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1114140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1114143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114162 */     // MIs[0] policy
     /* 1114162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114172 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1114175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114194 */     // GIR_Coverage, 62330,
     /* 1114194 */     GIR_EraseRootFromParent_Done,
     /* 1114195 */   // Label 16354: @1114195
     /* 1114195 */   GIM_Try, /*On fail goto*//*Label 16355*/ GIMT_Encode4(1114272), // Rule ID 62331 //
     /* 1114200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1114217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1114220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114239 */     // MIs[0] policy
     /* 1114239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114249 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1114252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114271 */     // GIR_Coverage, 62331,
     /* 1114271 */     GIR_EraseRootFromParent_Done,
     /* 1114272 */   // Label 16355: @1114272
     /* 1114272 */   GIM_Try, /*On fail goto*//*Label 16356*/ GIMT_Encode4(1114349), // Rule ID 62332 //
     /* 1114277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1114294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1114297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114316 */     // MIs[0] policy
     /* 1114316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114326 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1114329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114348 */     // GIR_Coverage, 62332,
     /* 1114348 */     GIR_EraseRootFromParent_Done,
     /* 1114349 */   // Label 16356: @1114349
     /* 1114349 */   GIM_Try, /*On fail goto*//*Label 16357*/ GIMT_Encode4(1114426), // Rule ID 62333 //
     /* 1114354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1114371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1114374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114393 */     // MIs[0] policy
     /* 1114393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114403 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1114406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114425 */     // GIR_Coverage, 62333,
     /* 1114425 */     GIR_EraseRootFromParent_Done,
     /* 1114426 */   // Label 16357: @1114426
     /* 1114426 */   GIM_Try, /*On fail goto*//*Label 16358*/ GIMT_Encode4(1114503), // Rule ID 62334 //
     /* 1114431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1114442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1114445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1114448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1114451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114470 */     // MIs[0] policy
     /* 1114470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114480 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1114483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114502 */     // GIR_Coverage, 62334,
     /* 1114502 */     GIR_EraseRootFromParent_Done,
     /* 1114503 */   // Label 16358: @1114503
     /* 1114503 */   GIM_Try, /*On fail goto*//*Label 16359*/ GIMT_Encode4(1114580), // Rule ID 62335 //
     /* 1114508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1114519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1114522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1114525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1114528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114547 */     // MIs[0] policy
     /* 1114547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114557 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1114560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114579 */     // GIR_Coverage, 62335,
     /* 1114579 */     GIR_EraseRootFromParent_Done,
     /* 1114580 */   // Label 16359: @1114580
     /* 1114580 */   GIM_Try, /*On fail goto*//*Label 16360*/ GIMT_Encode4(1114657), // Rule ID 62336 //
     /* 1114585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1114596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1114599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1114602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1114605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114624 */     // MIs[0] policy
     /* 1114624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1114637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114656 */     // GIR_Coverage, 62336,
     /* 1114656 */     GIR_EraseRootFromParent_Done,
     /* 1114657 */   // Label 16360: @1114657
     /* 1114657 */   GIM_Try, /*On fail goto*//*Label 16361*/ GIMT_Encode4(1114734), // Rule ID 62337 //
     /* 1114662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1114673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1114676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1114679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1114682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114701 */     // MIs[0] policy
     /* 1114701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114711 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1114714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114733 */     // GIR_Coverage, 62337,
     /* 1114733 */     GIR_EraseRootFromParent_Done,
     /* 1114734 */   // Label 16361: @1114734
     /* 1114734 */   GIM_Try, /*On fail goto*//*Label 16362*/ GIMT_Encode4(1114811), // Rule ID 62338 //
     /* 1114739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1114750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1114753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1114756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1114759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114778 */     // MIs[0] policy
     /* 1114778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114788 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1114791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114810 */     // GIR_Coverage, 62338,
     /* 1114810 */     GIR_EraseRootFromParent_Done,
     /* 1114811 */   // Label 16362: @1114811
     /* 1114811 */   GIM_Try, /*On fail goto*//*Label 16363*/ GIMT_Encode4(1114888), // Rule ID 62339 //
     /* 1114816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1114827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1114830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1114833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1114836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114855 */     // MIs[0] policy
     /* 1114855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114865 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1114868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114887 */     // GIR_Coverage, 62339,
     /* 1114887 */     GIR_EraseRootFromParent_Done,
     /* 1114888 */   // Label 16363: @1114888
     /* 1114888 */   GIM_Try, /*On fail goto*//*Label 16364*/ GIMT_Encode4(1114965), // Rule ID 62340 //
     /* 1114893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1114901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1114910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1114913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114932 */     // MIs[0] policy
     /* 1114932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114942 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1114945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114964 */     // GIR_Coverage, 62340,
     /* 1114964 */     GIR_EraseRootFromParent_Done,
     /* 1114965 */   // Label 16364: @1114965
     /* 1114965 */   GIM_Try, /*On fail goto*//*Label 16365*/ GIMT_Encode4(1115042), // Rule ID 62341 //
     /* 1114970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1114978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1114987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1114990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115009 */     // MIs[0] policy
     /* 1115009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115019 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1115022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115041 */     // GIR_Coverage, 62341,
     /* 1115041 */     GIR_EraseRootFromParent_Done,
     /* 1115042 */   // Label 16365: @1115042
     /* 1115042 */   GIM_Try, /*On fail goto*//*Label 16366*/ GIMT_Encode4(1115119), // Rule ID 62342 //
     /* 1115047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1115064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1115067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115086 */     // MIs[0] policy
     /* 1115086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1115099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115118 */     // GIR_Coverage, 62342,
     /* 1115118 */     GIR_EraseRootFromParent_Done,
     /* 1115119 */   // Label 16366: @1115119
     /* 1115119 */   GIM_Try, /*On fail goto*//*Label 16367*/ GIMT_Encode4(1115196), // Rule ID 62343 //
     /* 1115124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1115127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1115141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1115144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115163 */     // MIs[0] policy
     /* 1115163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115173 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1115176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115195 */     // GIR_Coverage, 62343,
     /* 1115195 */     GIR_EraseRootFromParent_Done,
     /* 1115196 */   // Label 16367: @1115196
     /* 1115196 */   GIM_Try, /*On fail goto*//*Label 16368*/ GIMT_Encode4(1115273), // Rule ID 62344 //
     /* 1115201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1115212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1115215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1115218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1115221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115240 */     // MIs[0] policy
     /* 1115240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115250 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1115253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1115269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115272 */     // GIR_Coverage, 62344,
     /* 1115272 */     GIR_EraseRootFromParent_Done,
     /* 1115273 */   // Label 16368: @1115273
     /* 1115273 */   GIM_Try, /*On fail goto*//*Label 16369*/ GIMT_Encode4(1115350), // Rule ID 62345 //
     /* 1115278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1115281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1115289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1115292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1115295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1115298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115317 */     // MIs[0] policy
     /* 1115317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115327 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1115330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1115346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115349 */     // GIR_Coverage, 62345,
     /* 1115349 */     GIR_EraseRootFromParent_Done,
     /* 1115350 */   // Label 16369: @1115350
     /* 1115350 */   GIM_Try, /*On fail goto*//*Label 16370*/ GIMT_Encode4(1115427), // Rule ID 62346 //
     /* 1115355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1115372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1115375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115394 */     // MIs[0] policy
     /* 1115394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1115407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115426 */     // GIR_Coverage, 62346,
     /* 1115426 */     GIR_EraseRootFromParent_Done,
     /* 1115427 */   // Label 16370: @1115427
     /* 1115427 */   GIM_Try, /*On fail goto*//*Label 16371*/ GIMT_Encode4(1115504), // Rule ID 62347 //
     /* 1115432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1115435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1115449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1115452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115471 */     // MIs[0] policy
     /* 1115471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115481 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1115484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115503 */     // GIR_Coverage, 62347,
     /* 1115503 */     GIR_EraseRootFromParent_Done,
     /* 1115504 */   // Label 16371: @1115504
     /* 1115504 */   GIM_Try, /*On fail goto*//*Label 16372*/ GIMT_Encode4(1115581), // Rule ID 62348 //
     /* 1115509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1115526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1115529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115548 */     // MIs[0] policy
     /* 1115548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115558 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1115561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115580 */     // GIR_Coverage, 62348,
     /* 1115580 */     GIR_EraseRootFromParent_Done,
     /* 1115581 */   // Label 16372: @1115581
     /* 1115581 */   GIM_Try, /*On fail goto*//*Label 16373*/ GIMT_Encode4(1115658), // Rule ID 62349 //
     /* 1115586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1115589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1115603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1115606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115625 */     // MIs[0] policy
     /* 1115625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115635 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1115638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115657 */     // GIR_Coverage, 62349,
     /* 1115657 */     GIR_EraseRootFromParent_Done,
     /* 1115658 */   // Label 16373: @1115658
     /* 1115658 */   GIM_Try, /*On fail goto*//*Label 16374*/ GIMT_Encode4(1115735), // Rule ID 62350 //
     /* 1115663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1115680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1115683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115702 */     // MIs[0] policy
     /* 1115702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115712 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1115715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115734 */     // GIR_Coverage, 62350,
     /* 1115734 */     GIR_EraseRootFromParent_Done,
     /* 1115735 */   // Label 16374: @1115735
     /* 1115735 */   GIM_Try, /*On fail goto*//*Label 16375*/ GIMT_Encode4(1115812), // Rule ID 62351 //
     /* 1115740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1115743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1115757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1115760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115779 */     // MIs[0] policy
     /* 1115779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115789 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1115792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115811 */     // GIR_Coverage, 62351,
     /* 1115811 */     GIR_EraseRootFromParent_Done,
     /* 1115812 */   // Label 16375: @1115812
     /* 1115812 */   GIM_Try, /*On fail goto*//*Label 16376*/ GIMT_Encode4(1115889), // Rule ID 62352 //
     /* 1115817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1115828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1115831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1115834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1115837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115856 */     // MIs[0] policy
     /* 1115856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1115869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1115885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115888 */     // GIR_Coverage, 62352,
     /* 1115888 */     GIR_EraseRootFromParent_Done,
     /* 1115889 */   // Label 16376: @1115889
     /* 1115889 */   GIM_Try, /*On fail goto*//*Label 16377*/ GIMT_Encode4(1115966), // Rule ID 62353 //
     /* 1115894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1115897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1115905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1115908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1115911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1115914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115933 */     // MIs[0] policy
     /* 1115933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1115946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1115962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115965 */     // GIR_Coverage, 62353,
     /* 1115965 */     GIR_EraseRootFromParent_Done,
     /* 1115966 */   // Label 16377: @1115966
     /* 1115966 */   GIM_Try, /*On fail goto*//*Label 16378*/ GIMT_Encode4(1116043), // Rule ID 62354 //
     /* 1115971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1115982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1115985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1115988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1115991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116010 */     // MIs[0] policy
     /* 1116010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116020 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1116023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116042 */     // GIR_Coverage, 62354,
     /* 1116042 */     GIR_EraseRootFromParent_Done,
     /* 1116043 */   // Label 16378: @1116043
     /* 1116043 */   GIM_Try, /*On fail goto*//*Label 16379*/ GIMT_Encode4(1116120), // Rule ID 62355 //
     /* 1116048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1116056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1116059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1116062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1116065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1116068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116087 */     // MIs[0] policy
     /* 1116087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116097 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1116100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116119 */     // GIR_Coverage, 62355,
     /* 1116119 */     GIR_EraseRootFromParent_Done,
     /* 1116120 */   // Label 16379: @1116120
     /* 1116120 */   GIM_Try, /*On fail goto*//*Label 16380*/ GIMT_Encode4(1116197), // Rule ID 62356 //
     /* 1116125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1116128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1116133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1116136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1116139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1116142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1116145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116164 */     // MIs[0] policy
     /* 1116164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116174 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1116177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116196 */     // GIR_Coverage, 62356,
     /* 1116196 */     GIR_EraseRootFromParent_Done,
     /* 1116197 */   // Label 16380: @1116197
     /* 1116197 */   GIM_Try, /*On fail goto*//*Label 16381*/ GIMT_Encode4(1116274), // Rule ID 62357 //
     /* 1116202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1116210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1116213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1116216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1116219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1116222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116241 */     // MIs[0] policy
     /* 1116241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116251 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1116254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116273 */     // GIR_Coverage, 62357,
     /* 1116273 */     GIR_EraseRootFromParent_Done,
     /* 1116274 */   // Label 16381: @1116274
     /* 1116274 */   GIM_Try, /*On fail goto*//*Label 16382*/ GIMT_Encode4(1116351), // Rule ID 62358 //
     /* 1116279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1116282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1116296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1116299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116318 */     // MIs[0] policy
     /* 1116318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116328 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1116331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116350 */     // GIR_Coverage, 62358,
     /* 1116350 */     GIR_EraseRootFromParent_Done,
     /* 1116351 */   // Label 16382: @1116351
     /* 1116351 */   GIM_Try, /*On fail goto*//*Label 16383*/ GIMT_Encode4(1116428), // Rule ID 62359 //
     /* 1116356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1116373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1116376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116395 */     // MIs[0] policy
     /* 1116395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116405 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1116408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116427 */     // GIR_Coverage, 62359,
     /* 1116427 */     GIR_EraseRootFromParent_Done,
     /* 1116428 */   // Label 16383: @1116428
     /* 1116428 */   GIM_Try, /*On fail goto*//*Label 16384*/ GIMT_Encode4(1116505), // Rule ID 62360 //
     /* 1116433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1116436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1116450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1116453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116472 */     // MIs[0] policy
     /* 1116472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116482 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1116485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116504 */     // GIR_Coverage, 62360,
     /* 1116504 */     GIR_EraseRootFromParent_Done,
     /* 1116505 */   // Label 16384: @1116505
     /* 1116505 */   GIM_Try, /*On fail goto*//*Label 16385*/ GIMT_Encode4(1116582), // Rule ID 62361 //
     /* 1116510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1116527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1116530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116549 */     // MIs[0] policy
     /* 1116549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116559 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1116562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116581 */     // GIR_Coverage, 62361,
     /* 1116581 */     GIR_EraseRootFromParent_Done,
     /* 1116582 */   // Label 16385: @1116582
     /* 1116582 */   GIM_Try, /*On fail goto*//*Label 16386*/ GIMT_Encode4(1116659), // Rule ID 62362 //
     /* 1116587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1116590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1116598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1116601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1116604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1116607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116626 */     // MIs[0] policy
     /* 1116626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1116639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116658 */     // GIR_Coverage, 62362,
     /* 1116658 */     GIR_EraseRootFromParent_Done,
     /* 1116659 */   // Label 16386: @1116659
     /* 1116659 */   GIM_Try, /*On fail goto*//*Label 16387*/ GIMT_Encode4(1116736), // Rule ID 62363 //
     /* 1116664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1116675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1116678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1116681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1116684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116703 */     // MIs[0] policy
     /* 1116703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116713 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1116716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116735 */     // GIR_Coverage, 62363,
     /* 1116735 */     GIR_EraseRootFromParent_Done,
     /* 1116736 */   // Label 16387: @1116736
     /* 1116736 */   GIM_Try, /*On fail goto*//*Label 16388*/ GIMT_Encode4(1116813), // Rule ID 62364 //
     /* 1116741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1116744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1116758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1116761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116780 */     // MIs[0] policy
     /* 1116780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1116793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116812 */     // GIR_Coverage, 62364,
     /* 1116812 */     GIR_EraseRootFromParent_Done,
     /* 1116813 */   // Label 16388: @1116813
     /* 1116813 */   GIM_Try, /*On fail goto*//*Label 16389*/ GIMT_Encode4(1116890), // Rule ID 62365 //
     /* 1116818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1116835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1116838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116857 */     // MIs[0] policy
     /* 1116857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116867 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1116870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116889 */     // GIR_Coverage, 62365,
     /* 1116889 */     GIR_EraseRootFromParent_Done,
     /* 1116890 */   // Label 16389: @1116890
     /* 1116890 */   GIM_Try, /*On fail goto*//*Label 16390*/ GIMT_Encode4(1116967), // Rule ID 62366 //
     /* 1116895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1116898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1116912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1116915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116934 */     // MIs[0] policy
     /* 1116934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116944 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1116947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116966 */     // GIR_Coverage, 62366,
     /* 1116966 */     GIR_EraseRootFromParent_Done,
     /* 1116967 */   // Label 16390: @1116967
     /* 1116967 */   GIM_Try, /*On fail goto*//*Label 16391*/ GIMT_Encode4(1117044), // Rule ID 62367 //
     /* 1116972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1116989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1116992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117011 */     // MIs[0] policy
     /* 1117011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1117024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117043 */     // GIR_Coverage, 62367,
     /* 1117043 */     GIR_EraseRootFromParent_Done,
     /* 1117044 */   // Label 16391: @1117044
     /* 1117044 */   GIM_Try, /*On fail goto*//*Label 16392*/ GIMT_Encode4(1117121), // Rule ID 62368 //
     /* 1117049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1117052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1117066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1117069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117088 */     // MIs[0] policy
     /* 1117088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117098 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1117101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117120 */     // GIR_Coverage, 62368,
     /* 1117120 */     GIR_EraseRootFromParent_Done,
     /* 1117121 */   // Label 16392: @1117121
     /* 1117121 */   GIM_Try, /*On fail goto*//*Label 16393*/ GIMT_Encode4(1117198), // Rule ID 62369 //
     /* 1117126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1117129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1117143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1117146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117165 */     // MIs[0] policy
     /* 1117165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117175 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1117178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117197 */     // GIR_Coverage, 62369,
     /* 1117197 */     GIR_EraseRootFromParent_Done,
     /* 1117198 */   // Label 16393: @1117198
     /* 1117198 */   GIM_Try, /*On fail goto*//*Label 16394*/ GIMT_Encode4(1117275), // Rule ID 62370 //
     /* 1117203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1117206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1117214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1117217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1117220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1117223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117242 */     // MIs[0] policy
     /* 1117242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1117255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117274 */     // GIR_Coverage, 62370,
     /* 1117274 */     GIR_EraseRootFromParent_Done,
     /* 1117275 */   // Label 16394: @1117275
     /* 1117275 */   GIM_Try, /*On fail goto*//*Label 16395*/ GIMT_Encode4(1117352), // Rule ID 62371 //
     /* 1117280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1117283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1117291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1117294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1117297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1117300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117319 */     // MIs[0] policy
     /* 1117319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117329 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1117332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117351 */     // GIR_Coverage, 62371,
     /* 1117351 */     GIR_EraseRootFromParent_Done,
     /* 1117352 */   // Label 16395: @1117352
     /* 1117352 */   GIM_Try, /*On fail goto*//*Label 16396*/ GIMT_Encode4(1117429), // Rule ID 62372 //
     /* 1117357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1117360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1117368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1117371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1117374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1117377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117396 */     // MIs[0] policy
     /* 1117396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117406 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1117409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117428 */     // GIR_Coverage, 62372,
     /* 1117428 */     GIR_EraseRootFromParent_Done,
     /* 1117429 */   // Label 16396: @1117429
     /* 1117429 */   GIM_Try, /*On fail goto*//*Label 16397*/ GIMT_Encode4(1117506), // Rule ID 62373 //
     /* 1117434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1117437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1117445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1117448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1117451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1117454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117473 */     // MIs[0] policy
     /* 1117473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117483 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1117486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117505 */     // GIR_Coverage, 62373,
     /* 1117505 */     GIR_EraseRootFromParent_Done,
     /* 1117506 */   // Label 16397: @1117506
     /* 1117506 */   GIM_Try, /*On fail goto*//*Label 16398*/ GIMT_Encode4(1117583), // Rule ID 62374 //
     /* 1117511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1117514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1117522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1117525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1117528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1117531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117550 */     // MIs[0] policy
     /* 1117550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117560 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1117563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117582 */     // GIR_Coverage, 62374,
     /* 1117582 */     GIR_EraseRootFromParent_Done,
     /* 1117583 */   // Label 16398: @1117583
     /* 1117583 */   GIM_Try, /*On fail goto*//*Label 16399*/ GIMT_Encode4(1117660), // Rule ID 62375 //
     /* 1117588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1117591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1117599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1117602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1117605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1117608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117627 */     // MIs[0] policy
     /* 1117627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117637 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1117640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117659 */     // GIR_Coverage, 62375,
     /* 1117659 */     GIR_EraseRootFromParent_Done,
     /* 1117660 */   // Label 16399: @1117660
     /* 1117660 */   GIM_Try, /*On fail goto*//*Label 16400*/ GIMT_Encode4(1117737), // Rule ID 62596 //
     /* 1117665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1117673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1117682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117704 */     // MIs[0] policy
     /* 1117704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2),
     /* 1117717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117736 */     // GIR_Coverage, 62596,
     /* 1117736 */     GIR_EraseRootFromParent_Done,
     /* 1117737 */   // Label 16400: @1117737
     /* 1117737 */   GIM_Try, /*On fail goto*//*Label 16401*/ GIMT_Encode4(1117814), // Rule ID 62597 //
     /* 1117742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1117750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1117759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117781 */     // MIs[0] policy
     /* 1117781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117791 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2),
     /* 1117794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117813 */     // GIR_Coverage, 62597,
     /* 1117813 */     GIR_EraseRootFromParent_Done,
     /* 1117814 */   // Label 16401: @1117814
     /* 1117814 */   GIM_Try, /*On fail goto*//*Label 16402*/ GIMT_Encode4(1117891), // Rule ID 62600 //
     /* 1117819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1117827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1117836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117858 */     // MIs[0] policy
     /* 1117858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117868 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1),
     /* 1117871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117890 */     // GIR_Coverage, 62600,
     /* 1117890 */     GIR_EraseRootFromParent_Done,
     /* 1117891 */   // Label 16402: @1117891
     /* 1117891 */   GIM_Try, /*On fail goto*//*Label 16403*/ GIMT_Encode4(1117968), // Rule ID 62601 //
     /* 1117896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1117904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1117913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117935 */     // MIs[0] policy
     /* 1117935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117945 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1),
     /* 1117948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117967 */     // GIR_Coverage, 62601,
     /* 1117967 */     GIR_EraseRootFromParent_Done,
     /* 1117968 */   // Label 16403: @1117968
     /* 1117968 */   GIM_Try, /*On fail goto*//*Label 16404*/ GIMT_Encode4(1118045), // Rule ID 62604 //
     /* 1117973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1117981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1117990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118012 */     // MIs[0] policy
     /* 1118012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118022 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2),
     /* 1118025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118044 */     // GIR_Coverage, 62604,
     /* 1118044 */     GIR_EraseRootFromParent_Done,
     /* 1118045 */   // Label 16404: @1118045
     /* 1118045 */   GIM_Try, /*On fail goto*//*Label 16405*/ GIMT_Encode4(1118122), // Rule ID 62605 //
     /* 1118050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1118067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118089 */     // MIs[0] policy
     /* 1118089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118099 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2),
     /* 1118102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118121 */     // GIR_Coverage, 62605,
     /* 1118121 */     GIR_EraseRootFromParent_Done,
     /* 1118122 */   // Label 16405: @1118122
     /* 1118122 */   GIM_Try, /*On fail goto*//*Label 16406*/ GIMT_Encode4(1118199), // Rule ID 62608 //
     /* 1118127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1118144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118166 */     // MIs[0] policy
     /* 1118166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118176 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4),
     /* 1118179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118198 */     // GIR_Coverage, 62608,
     /* 1118198 */     GIR_EraseRootFromParent_Done,
     /* 1118199 */   // Label 16406: @1118199
     /* 1118199 */   GIM_Try, /*On fail goto*//*Label 16407*/ GIMT_Encode4(1118276), // Rule ID 62609 //
     /* 1118204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1118221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118243 */     // MIs[0] policy
     /* 1118243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118253 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4),
     /* 1118256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118275 */     // GIR_Coverage, 62609,
     /* 1118275 */     GIR_EraseRootFromParent_Done,
     /* 1118276 */   // Label 16407: @1118276
     /* 1118276 */   GIM_Try, /*On fail goto*//*Label 16408*/ GIMT_Encode4(1118353), // Rule ID 62612 //
     /* 1118281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1118298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118320 */     // MIs[0] policy
     /* 1118320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118330 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8),
     /* 1118333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118352 */     // GIR_Coverage, 62612,
     /* 1118352 */     GIR_EraseRootFromParent_Done,
     /* 1118353 */   // Label 16408: @1118353
     /* 1118353 */   GIM_Try, /*On fail goto*//*Label 16409*/ GIMT_Encode4(1118430), // Rule ID 62613 //
     /* 1118358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1118375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118397 */     // MIs[0] policy
     /* 1118397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118407 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8),
     /* 1118410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118429 */     // GIR_Coverage, 62613,
     /* 1118429 */     GIR_EraseRootFromParent_Done,
     /* 1118430 */   // Label 16409: @1118430
     /* 1118430 */   GIM_Try, /*On fail goto*//*Label 16410*/ GIMT_Encode4(1118507), // Rule ID 62616 //
     /* 1118435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118474 */     // MIs[0] policy
     /* 1118474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2),
     /* 1118487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118506 */     // GIR_Coverage, 62616,
     /* 1118506 */     GIR_EraseRootFromParent_Done,
     /* 1118507 */   // Label 16410: @1118507
     /* 1118507 */   GIM_Try, /*On fail goto*//*Label 16411*/ GIMT_Encode4(1118584), // Rule ID 62617 //
     /* 1118512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118551 */     // MIs[0] policy
     /* 1118551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118561 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2),
     /* 1118564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118583 */     // GIR_Coverage, 62617,
     /* 1118583 */     GIR_EraseRootFromParent_Done,
     /* 1118584 */   // Label 16411: @1118584
     /* 1118584 */   GIM_Try, /*On fail goto*//*Label 16412*/ GIMT_Encode4(1118661), // Rule ID 62620 //
     /* 1118589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118628 */     // MIs[0] policy
     /* 1118628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1),
     /* 1118641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118660 */     // GIR_Coverage, 62620,
     /* 1118660 */     GIR_EraseRootFromParent_Done,
     /* 1118661 */   // Label 16412: @1118661
     /* 1118661 */   GIM_Try, /*On fail goto*//*Label 16413*/ GIMT_Encode4(1118738), // Rule ID 62621 //
     /* 1118666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118705 */     // MIs[0] policy
     /* 1118705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118715 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1),
     /* 1118718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118737 */     // GIR_Coverage, 62621,
     /* 1118737 */     GIR_EraseRootFromParent_Done,
     /* 1118738 */   // Label 16413: @1118738
     /* 1118738 */   GIM_Try, /*On fail goto*//*Label 16414*/ GIMT_Encode4(1118815), // Rule ID 62624 //
     /* 1118743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118782 */     // MIs[0] policy
     /* 1118782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118792 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2),
     /* 1118795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118814 */     // GIR_Coverage, 62624,
     /* 1118814 */     GIR_EraseRootFromParent_Done,
     /* 1118815 */   // Label 16414: @1118815
     /* 1118815 */   GIM_Try, /*On fail goto*//*Label 16415*/ GIMT_Encode4(1118892), // Rule ID 62625 //
     /* 1118820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118859 */     // MIs[0] policy
     /* 1118859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118869 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2),
     /* 1118872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118891 */     // GIR_Coverage, 62625,
     /* 1118891 */     GIR_EraseRootFromParent_Done,
     /* 1118892 */   // Label 16415: @1118892
     /* 1118892 */   GIM_Try, /*On fail goto*//*Label 16416*/ GIMT_Encode4(1118969), // Rule ID 62628 //
     /* 1118897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118936 */     // MIs[0] policy
     /* 1118936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4),
     /* 1118949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118968 */     // GIR_Coverage, 62628,
     /* 1118968 */     GIR_EraseRootFromParent_Done,
     /* 1118969 */   // Label 16416: @1118969
     /* 1118969 */   GIM_Try, /*On fail goto*//*Label 16417*/ GIMT_Encode4(1119046), // Rule ID 62629 //
     /* 1118974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119013 */     // MIs[0] policy
     /* 1119013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119023 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4),
     /* 1119026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119045 */     // GIR_Coverage, 62629,
     /* 1119045 */     GIR_EraseRootFromParent_Done,
     /* 1119046 */   // Label 16417: @1119046
     /* 1119046 */   GIM_Try, /*On fail goto*//*Label 16418*/ GIMT_Encode4(1119123), // Rule ID 62632 //
     /* 1119051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1119059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119090 */     // MIs[0] policy
     /* 1119090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8),
     /* 1119103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119122 */     // GIR_Coverage, 62632,
     /* 1119122 */     GIR_EraseRootFromParent_Done,
     /* 1119123 */   // Label 16418: @1119123
     /* 1119123 */   GIM_Try, /*On fail goto*//*Label 16419*/ GIMT_Encode4(1119200), // Rule ID 62633 //
     /* 1119128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1119136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119167 */     // MIs[0] policy
     /* 1119167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119177 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8),
     /* 1119180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119199 */     // GIR_Coverage, 62633,
     /* 1119199 */     GIR_EraseRootFromParent_Done,
     /* 1119200 */   // Label 16419: @1119200
     /* 1119200 */   GIM_Try, /*On fail goto*//*Label 16420*/ GIMT_Encode4(1119277), // Rule ID 62636 //
     /* 1119205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1119216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1119219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1119222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1119225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119244 */     // MIs[0] policy
     /* 1119244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119254 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2),
     /* 1119257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119276 */     // GIR_Coverage, 62636,
     /* 1119276 */     GIR_EraseRootFromParent_Done,
     /* 1119277 */   // Label 16420: @1119277
     /* 1119277 */   GIM_Try, /*On fail goto*//*Label 16421*/ GIMT_Encode4(1119354), // Rule ID 62637 //
     /* 1119282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1119293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1119296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1119299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1119302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119321 */     // MIs[0] policy
     /* 1119321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119331 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2),
     /* 1119334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119353 */     // GIR_Coverage, 62637,
     /* 1119353 */     GIR_EraseRootFromParent_Done,
     /* 1119354 */   // Label 16421: @1119354
     /* 1119354 */   GIM_Try, /*On fail goto*//*Label 16422*/ GIMT_Encode4(1119431), // Rule ID 62640 //
     /* 1119359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119398 */     // MIs[0] policy
     /* 1119398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1),
     /* 1119411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119430 */     // GIR_Coverage, 62640,
     /* 1119430 */     GIR_EraseRootFromParent_Done,
     /* 1119431 */   // Label 16422: @1119431
     /* 1119431 */   GIM_Try, /*On fail goto*//*Label 16423*/ GIMT_Encode4(1119508), // Rule ID 62641 //
     /* 1119436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119475 */     // MIs[0] policy
     /* 1119475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119485 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1),
     /* 1119488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119507 */     // GIR_Coverage, 62641,
     /* 1119507 */     GIR_EraseRootFromParent_Done,
     /* 1119508 */   // Label 16423: @1119508
     /* 1119508 */   GIM_Try, /*On fail goto*//*Label 16424*/ GIMT_Encode4(1119585), // Rule ID 62644 //
     /* 1119513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1119530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119552 */     // MIs[0] policy
     /* 1119552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2),
     /* 1119565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119584 */     // GIR_Coverage, 62644,
     /* 1119584 */     GIR_EraseRootFromParent_Done,
     /* 1119585 */   // Label 16424: @1119585
     /* 1119585 */   GIM_Try, /*On fail goto*//*Label 16425*/ GIMT_Encode4(1119662), // Rule ID 62645 //
     /* 1119590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1119607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119629 */     // MIs[0] policy
     /* 1119629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2),
     /* 1119642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119661 */     // GIR_Coverage, 62645,
     /* 1119661 */     GIR_EraseRootFromParent_Done,
     /* 1119662 */   // Label 16425: @1119662
     /* 1119662 */   GIM_Try, /*On fail goto*//*Label 16426*/ GIMT_Encode4(1119739), // Rule ID 62648 //
     /* 1119667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1119684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119706 */     // MIs[0] policy
     /* 1119706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4),
     /* 1119719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119738 */     // GIR_Coverage, 62648,
     /* 1119738 */     GIR_EraseRootFromParent_Done,
     /* 1119739 */   // Label 16426: @1119739
     /* 1119739 */   GIM_Try, /*On fail goto*//*Label 16427*/ GIMT_Encode4(1119816), // Rule ID 62649 //
     /* 1119744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1119761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119783 */     // MIs[0] policy
     /* 1119783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119793 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4),
     /* 1119796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119815 */     // GIR_Coverage, 62649,
     /* 1119815 */     GIR_EraseRootFromParent_Done,
     /* 1119816 */   // Label 16427: @1119816
     /* 1119816 */   GIM_Try, /*On fail goto*//*Label 16428*/ GIMT_Encode4(1119893), // Rule ID 62652 //
     /* 1119821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1119838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119860 */     // MIs[0] policy
     /* 1119860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119870 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8),
     /* 1119873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119892 */     // GIR_Coverage, 62652,
     /* 1119892 */     GIR_EraseRootFromParent_Done,
     /* 1119893 */   // Label 16428: @1119893
     /* 1119893 */   GIM_Try, /*On fail goto*//*Label 16429*/ GIMT_Encode4(1119970), // Rule ID 62653 //
     /* 1119898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1119915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119937 */     // MIs[0] policy
     /* 1119937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119947 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8),
     /* 1119950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119969 */     // GIR_Coverage, 62653,
     /* 1119969 */     GIR_EraseRootFromParent_Done,
     /* 1119970 */   // Label 16429: @1119970
     /* 1119970 */   GIM_Try, /*On fail goto*//*Label 16430*/ GIMT_Encode4(1120047), // Rule ID 62656 //
     /* 1119975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1119986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1119989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1119995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120014 */     // MIs[0] policy
     /* 1120014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120024 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2),
     /* 1120027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120046 */     // GIR_Coverage, 62656,
     /* 1120046 */     GIR_EraseRootFromParent_Done,
     /* 1120047 */   // Label 16430: @1120047
     /* 1120047 */   GIM_Try, /*On fail goto*//*Label 16431*/ GIMT_Encode4(1120124), // Rule ID 62657 //
     /* 1120052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1120063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1120066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1120069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1120072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120091 */     // MIs[0] policy
     /* 1120091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120101 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2),
     /* 1120104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120123 */     // GIR_Coverage, 62657,
     /* 1120123 */     GIR_EraseRootFromParent_Done,
     /* 1120124 */   // Label 16431: @1120124
     /* 1120124 */   GIM_Try, /*On fail goto*//*Label 16432*/ GIMT_Encode4(1120201), // Rule ID 62660 //
     /* 1120129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1120132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1120146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120168 */     // MIs[0] policy
     /* 1120168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120178 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1),
     /* 1120181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120200 */     // GIR_Coverage, 62660,
     /* 1120200 */     GIR_EraseRootFromParent_Done,
     /* 1120201 */   // Label 16432: @1120201
     /* 1120201 */   GIM_Try, /*On fail goto*//*Label 16433*/ GIMT_Encode4(1120278), // Rule ID 62661 //
     /* 1120206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1120223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120245 */     // MIs[0] policy
     /* 1120245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120255 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1),
     /* 1120258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120277 */     // GIR_Coverage, 62661,
     /* 1120277 */     GIR_EraseRootFromParent_Done,
     /* 1120278 */   // Label 16433: @1120278
     /* 1120278 */   GIM_Try, /*On fail goto*//*Label 16434*/ GIMT_Encode4(1120355), // Rule ID 62664 //
     /* 1120283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1120286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1120300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120322 */     // MIs[0] policy
     /* 1120322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2),
     /* 1120335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120354 */     // GIR_Coverage, 62664,
     /* 1120354 */     GIR_EraseRootFromParent_Done,
     /* 1120355 */   // Label 16434: @1120355
     /* 1120355 */   GIM_Try, /*On fail goto*//*Label 16435*/ GIMT_Encode4(1120432), // Rule ID 62665 //
     /* 1120360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1120377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120399 */     // MIs[0] policy
     /* 1120399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120409 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2),
     /* 1120412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120431 */     // GIR_Coverage, 62665,
     /* 1120431 */     GIR_EraseRootFromParent_Done,
     /* 1120432 */   // Label 16435: @1120432
     /* 1120432 */   GIM_Try, /*On fail goto*//*Label 16436*/ GIMT_Encode4(1120509), // Rule ID 62668 //
     /* 1120437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1120440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1120454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120476 */     // MIs[0] policy
     /* 1120476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120486 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4),
     /* 1120489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120508 */     // GIR_Coverage, 62668,
     /* 1120508 */     GIR_EraseRootFromParent_Done,
     /* 1120509 */   // Label 16436: @1120509
     /* 1120509 */   GIM_Try, /*On fail goto*//*Label 16437*/ GIMT_Encode4(1120586), // Rule ID 62669 //
     /* 1120514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1120531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120553 */     // MIs[0] policy
     /* 1120553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120563 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4),
     /* 1120566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120585 */     // GIR_Coverage, 62669,
     /* 1120585 */     GIR_EraseRootFromParent_Done,
     /* 1120586 */   // Label 16437: @1120586
     /* 1120586 */   GIM_Try, /*On fail goto*//*Label 16438*/ GIMT_Encode4(1120663), // Rule ID 62672 //
     /* 1120591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1120594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1120608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120630 */     // MIs[0] policy
     /* 1120630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8),
     /* 1120643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120662 */     // GIR_Coverage, 62672,
     /* 1120662 */     GIR_EraseRootFromParent_Done,
     /* 1120663 */   // Label 16438: @1120663
     /* 1120663 */   GIM_Try, /*On fail goto*//*Label 16439*/ GIMT_Encode4(1120740), // Rule ID 62673 //
     /* 1120668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1120685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120707 */     // MIs[0] policy
     /* 1120707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120717 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8),
     /* 1120720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120739 */     // GIR_Coverage, 62673,
     /* 1120739 */     GIR_EraseRootFromParent_Done,
     /* 1120740 */   // Label 16439: @1120740
     /* 1120740 */   GIM_Try, /*On fail goto*//*Label 16440*/ GIMT_Encode4(1120817), // Rule ID 62676 //
     /* 1120745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1120748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1120753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1120756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1120759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1120762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1120765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120784 */     // MIs[0] policy
     /* 1120784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120794 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2),
     /* 1120797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120816 */     // GIR_Coverage, 62676,
     /* 1120816 */     GIR_EraseRootFromParent_Done,
     /* 1120817 */   // Label 16440: @1120817
     /* 1120817 */   GIM_Try, /*On fail goto*//*Label 16441*/ GIMT_Encode4(1120894), // Rule ID 62677 //
     /* 1120822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1120830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1120833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1120836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1120839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1120842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120861 */     // MIs[0] policy
     /* 1120861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120871 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2),
     /* 1120874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120893 */     // GIR_Coverage, 62677,
     /* 1120893 */     GIR_EraseRootFromParent_Done,
     /* 1120894 */   // Label 16441: @1120894
     /* 1120894 */   GIM_Try, /*On fail goto*//*Label 16442*/ GIMT_Encode4(1120971), // Rule ID 62680 //
     /* 1120899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1120902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1120907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120938 */     // MIs[0] policy
     /* 1120938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120948 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1),
     /* 1120951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120970 */     // GIR_Coverage, 62680,
     /* 1120970 */     GIR_EraseRootFromParent_Done,
     /* 1120971 */   // Label 16442: @1120971
     /* 1120971 */   GIM_Try, /*On fail goto*//*Label 16443*/ GIMT_Encode4(1121048), // Rule ID 62681 //
     /* 1120976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1120984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121015 */     // MIs[0] policy
     /* 1121015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121025 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1),
     /* 1121028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121047 */     // GIR_Coverage, 62681,
     /* 1121047 */     GIR_EraseRootFromParent_Done,
     /* 1121048 */   // Label 16443: @1121048
     /* 1121048 */   GIM_Try, /*On fail goto*//*Label 16444*/ GIMT_Encode4(1121125), // Rule ID 62684 //
     /* 1121053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1121070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121092 */     // MIs[0] policy
     /* 1121092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2),
     /* 1121105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121124 */     // GIR_Coverage, 62684,
     /* 1121124 */     GIR_EraseRootFromParent_Done,
     /* 1121125 */   // Label 16444: @1121125
     /* 1121125 */   GIM_Try, /*On fail goto*//*Label 16445*/ GIMT_Encode4(1121202), // Rule ID 62685 //
     /* 1121130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1121133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1121147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121169 */     // MIs[0] policy
     /* 1121169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121179 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2),
     /* 1121182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121201 */     // GIR_Coverage, 62685,
     /* 1121201 */     GIR_EraseRootFromParent_Done,
     /* 1121202 */   // Label 16445: @1121202
     /* 1121202 */   GIM_Try, /*On fail goto*//*Label 16446*/ GIMT_Encode4(1121279), // Rule ID 62688 //
     /* 1121207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1121224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121246 */     // MIs[0] policy
     /* 1121246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121256 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4),
     /* 1121259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121278 */     // GIR_Coverage, 62688,
     /* 1121278 */     GIR_EraseRootFromParent_Done,
     /* 1121279 */   // Label 16446: @1121279
     /* 1121279 */   GIM_Try, /*On fail goto*//*Label 16447*/ GIMT_Encode4(1121356), // Rule ID 62689 //
     /* 1121284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1121287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1121301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121323 */     // MIs[0] policy
     /* 1121323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121333 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4),
     /* 1121336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121355 */     // GIR_Coverage, 62689,
     /* 1121355 */     GIR_EraseRootFromParent_Done,
     /* 1121356 */   // Label 16447: @1121356
     /* 1121356 */   GIM_Try, /*On fail goto*//*Label 16448*/ GIMT_Encode4(1121433), // Rule ID 62692 //
     /* 1121361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1121378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121400 */     // MIs[0] policy
     /* 1121400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121410 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8),
     /* 1121413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121432 */     // GIR_Coverage, 62692,
     /* 1121432 */     GIR_EraseRootFromParent_Done,
     /* 1121433 */   // Label 16448: @1121433
     /* 1121433 */   GIM_Try, /*On fail goto*//*Label 16449*/ GIMT_Encode4(1121510), // Rule ID 62693 //
     /* 1121438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1121441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1121455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121477 */     // MIs[0] policy
     /* 1121477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121487 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8),
     /* 1121490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121509 */     // GIR_Coverage, 62693,
     /* 1121509 */     GIR_EraseRootFromParent_Done,
     /* 1121510 */   // Label 16449: @1121510
     /* 1121510 */   GIM_Try, /*On fail goto*//*Label 16450*/ GIMT_Encode4(1121587), // Rule ID 62696 //
     /* 1121515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1121526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1121529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1121532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1121535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1121550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121554 */     // MIs[0] policy
     /* 1121554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121564 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2),
     /* 1121567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121586 */     // GIR_Coverage, 62696,
     /* 1121586 */     GIR_EraseRootFromParent_Done,
     /* 1121587 */   // Label 16450: @1121587
     /* 1121587 */   GIM_Try, /*On fail goto*//*Label 16451*/ GIMT_Encode4(1121664), // Rule ID 62697 //
     /* 1121592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1121595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1121603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1121606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1121609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1121612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1121627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121631 */     // MIs[0] policy
     /* 1121631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121641 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2),
     /* 1121644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121663 */     // GIR_Coverage, 62697,
     /* 1121663 */     GIR_EraseRootFromParent_Done,
     /* 1121664 */   // Label 16451: @1121664
     /* 1121664 */   GIM_Try, /*On fail goto*//*Label 16452*/ GIMT_Encode4(1121741), // Rule ID 62700 //
     /* 1121669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1121686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1121704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121708 */     // MIs[0] policy
     /* 1121708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1),
     /* 1121721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121740 */     // GIR_Coverage, 62700,
     /* 1121740 */     GIR_EraseRootFromParent_Done,
     /* 1121741 */   // Label 16452: @1121741
     /* 1121741 */   GIM_Try, /*On fail goto*//*Label 16453*/ GIMT_Encode4(1121818), // Rule ID 62701 //
     /* 1121746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1121749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1121763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1121781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121785 */     // MIs[0] policy
     /* 1121785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121795 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1),
     /* 1121798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121817 */     // GIR_Coverage, 62701,
     /* 1121817 */     GIR_EraseRootFromParent_Done,
     /* 1121818 */   // Label 16453: @1121818
     /* 1121818 */   GIM_Try, /*On fail goto*//*Label 16454*/ GIMT_Encode4(1121895), // Rule ID 62704 //
     /* 1121823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1121840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1121858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121862 */     // MIs[0] policy
     /* 1121862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2),
     /* 1121875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121894 */     // GIR_Coverage, 62704,
     /* 1121894 */     GIR_EraseRootFromParent_Done,
     /* 1121895 */   // Label 16454: @1121895
     /* 1121895 */   GIM_Try, /*On fail goto*//*Label 16455*/ GIMT_Encode4(1121972), // Rule ID 62705 //
     /* 1121900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1121903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1121917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1121935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121939 */     // MIs[0] policy
     /* 1121939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121949 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2),
     /* 1121952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121971 */     // GIR_Coverage, 62705,
     /* 1121971 */     GIR_EraseRootFromParent_Done,
     /* 1121972 */   // Label 16455: @1121972
     /* 1121972 */   GIM_Try, /*On fail goto*//*Label 16456*/ GIMT_Encode4(1122049), // Rule ID 62708 //
     /* 1121977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1121994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122016 */     // MIs[0] policy
     /* 1122016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122026 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4),
     /* 1122029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122048 */     // GIR_Coverage, 62708,
     /* 1122048 */     GIR_EraseRootFromParent_Done,
     /* 1122049 */   // Label 16456: @1122049
     /* 1122049 */   GIM_Try, /*On fail goto*//*Label 16457*/ GIMT_Encode4(1122126), // Rule ID 62709 //
     /* 1122054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1122062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122093 */     // MIs[0] policy
     /* 1122093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122103 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4),
     /* 1122106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122125 */     // GIR_Coverage, 62709,
     /* 1122125 */     GIR_EraseRootFromParent_Done,
     /* 1122126 */   // Label 16457: @1122126
     /* 1122126 */   GIM_Try, /*On fail goto*//*Label 16458*/ GIMT_Encode4(1122203), // Rule ID 62712 //
     /* 1122131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1122134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1122139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1122148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1122151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122170 */     // MIs[0] policy
     /* 1122170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122180 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8),
     /* 1122183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122202 */     // GIR_Coverage, 62712,
     /* 1122202 */     GIR_EraseRootFromParent_Done,
     /* 1122203 */   // Label 16458: @1122203
     /* 1122203 */   GIM_Try, /*On fail goto*//*Label 16459*/ GIMT_Encode4(1122280), // Rule ID 62713 //
     /* 1122208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1122216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1122228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122247 */     // MIs[0] policy
     /* 1122247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122257 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8),
     /* 1122260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122279 */     // GIR_Coverage, 62713,
     /* 1122279 */     GIR_EraseRootFromParent_Done,
     /* 1122280 */   // Label 16459: @1122280
     /* 1122280 */   GIM_Try, /*On fail goto*//*Label 16460*/ GIMT_Encode4(1122357), // Rule ID 62716 //
     /* 1122285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1122288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1122296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1122299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1122302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122324 */     // MIs[0] policy
     /* 1122324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122334 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2),
     /* 1122337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122356 */     // GIR_Coverage, 62716,
     /* 1122356 */     GIR_EraseRootFromParent_Done,
     /* 1122357 */   // Label 16460: @1122357
     /* 1122357 */   GIM_Try, /*On fail goto*//*Label 16461*/ GIMT_Encode4(1122434), // Rule ID 62717 //
     /* 1122362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1122373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1122376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122401 */     // MIs[0] policy
     /* 1122401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122411 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2),
     /* 1122414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122433 */     // GIR_Coverage, 62717,
     /* 1122433 */     GIR_EraseRootFromParent_Done,
     /* 1122434 */   // Label 16461: @1122434
     /* 1122434 */   GIM_Try, /*On fail goto*//*Label 16462*/ GIMT_Encode4(1122511), // Rule ID 62720 //
     /* 1122439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1122442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1122456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122478 */     // MIs[0] policy
     /* 1122478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122488 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1),
     /* 1122491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122510 */     // GIR_Coverage, 62720,
     /* 1122510 */     GIR_EraseRootFromParent_Done,
     /* 1122511 */   // Label 16462: @1122511
     /* 1122511 */   GIM_Try, /*On fail goto*//*Label 16463*/ GIMT_Encode4(1122588), // Rule ID 62721 //
     /* 1122516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122555 */     // MIs[0] policy
     /* 1122555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122565 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1),
     /* 1122568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122587 */     // GIR_Coverage, 62721,
     /* 1122587 */     GIR_EraseRootFromParent_Done,
     /* 1122588 */   // Label 16463: @1122588
     /* 1122588 */   GIM_Try, /*On fail goto*//*Label 16464*/ GIMT_Encode4(1122665), // Rule ID 62724 //
     /* 1122593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1122596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1122610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122632 */     // MIs[0] policy
     /* 1122632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122642 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2),
     /* 1122645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122664 */     // GIR_Coverage, 62724,
     /* 1122664 */     GIR_EraseRootFromParent_Done,
     /* 1122665 */   // Label 16464: @1122665
     /* 1122665 */   GIM_Try, /*On fail goto*//*Label 16465*/ GIMT_Encode4(1122742), // Rule ID 62725 //
     /* 1122670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122709 */     // MIs[0] policy
     /* 1122709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2),
     /* 1122722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122741 */     // GIR_Coverage, 62725,
     /* 1122741 */     GIR_EraseRootFromParent_Done,
     /* 1122742 */   // Label 16465: @1122742
     /* 1122742 */   GIM_Try, /*On fail goto*//*Label 16466*/ GIMT_Encode4(1122819), // Rule ID 62728 //
     /* 1122747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1122750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1122764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122786 */     // MIs[0] policy
     /* 1122786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122796 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4),
     /* 1122799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122818 */     // GIR_Coverage, 62728,
     /* 1122818 */     GIR_EraseRootFromParent_Done,
     /* 1122819 */   // Label 16466: @1122819
     /* 1122819 */   GIM_Try, /*On fail goto*//*Label 16467*/ GIMT_Encode4(1122896), // Rule ID 62729 //
     /* 1122824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122863 */     // MIs[0] policy
     /* 1122863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122873 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4),
     /* 1122876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122895 */     // GIR_Coverage, 62729,
     /* 1122895 */     GIR_EraseRootFromParent_Done,
     /* 1122896 */   // Label 16467: @1122896
     /* 1122896 */   GIM_Try, /*On fail goto*//*Label 16468*/ GIMT_Encode4(1122973), // Rule ID 62732 //
     /* 1122901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1122904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1122918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1122921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122940 */     // MIs[0] policy
     /* 1122940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122950 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8),
     /* 1122953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122972 */     // GIR_Coverage, 62732,
     /* 1122972 */     GIR_EraseRootFromParent_Done,
     /* 1122973 */   // Label 16468: @1122973
     /* 1122973 */   GIM_Try, /*On fail goto*//*Label 16469*/ GIMT_Encode4(1123050), // Rule ID 62733 //
     /* 1122978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1122998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1123013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123017 */     // MIs[0] policy
     /* 1123017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123027 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8),
     /* 1123030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1123046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123049 */     // GIR_Coverage, 62733,
     /* 1123049 */     GIR_EraseRootFromParent_Done,
     /* 1123050 */   // Label 16469: @1123050
     /* 1123050 */   GIM_Try, /*On fail goto*//*Label 16470*/ GIMT_Encode4(1123127), // Rule ID 62827 //
     /* 1123055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123094 */     // MIs[0] policy
     /* 1123094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M1),
     /* 1123107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123126 */     // GIR_Coverage, 62827,
     /* 1123126 */     GIR_EraseRootFromParent_Done,
     /* 1123127 */   // Label 16470: @1123127
     /* 1123127 */   GIM_Try, /*On fail goto*//*Label 16471*/ GIMT_Encode4(1123204), // Rule ID 62828 //
     /* 1123132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1123135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123171 */     // MIs[0] policy
     /* 1123171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123181 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M1),
     /* 1123184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123203 */     // GIR_Coverage, 62828,
     /* 1123203 */     GIR_EraseRootFromParent_Done,
     /* 1123204 */   // Label 16471: @1123204
     /* 1123204 */   GIM_Try, /*On fail goto*//*Label 16472*/ GIMT_Encode4(1123281), // Rule ID 64285 //
     /* 1123209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123248 */     // MIs[0] policy
     /* 1123248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M2),
     /* 1123261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123280 */     // GIR_Coverage, 64285,
     /* 1123280 */     GIR_EraseRootFromParent_Done,
     /* 1123281 */   // Label 16472: @1123281
     /* 1123281 */   GIM_Try, /*On fail goto*//*Label 16473*/ GIMT_Encode4(1123358), // Rule ID 64286 //
     /* 1123286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1123289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123325 */     // MIs[0] policy
     /* 1123325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123335 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M2),
     /* 1123338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123357 */     // GIR_Coverage, 64286,
     /* 1123357 */     GIR_EraseRootFromParent_Done,
     /* 1123358 */   // Label 16473: @1123358
     /* 1123358 */   GIM_Try, /*On fail goto*//*Label 16474*/ GIMT_Encode4(1123435), // Rule ID 64287 //
     /* 1123363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123402 */     // MIs[0] policy
     /* 1123402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123412 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M4),
     /* 1123415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123434 */     // GIR_Coverage, 64287,
     /* 1123434 */     GIR_EraseRootFromParent_Done,
     /* 1123435 */   // Label 16474: @1123435
     /* 1123435 */   GIM_Try, /*On fail goto*//*Label 16475*/ GIMT_Encode4(1123512), // Rule ID 64288 //
     /* 1123440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1123443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123479 */     // MIs[0] policy
     /* 1123479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123489 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M4),
     /* 1123492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123511 */     // GIR_Coverage, 64288,
     /* 1123511 */     GIR_EraseRootFromParent_Done,
     /* 1123512 */   // Label 16475: @1123512
     /* 1123512 */   GIM_Try, /*On fail goto*//*Label 16476*/ GIMT_Encode4(1123589), // Rule ID 64289 //
     /* 1123517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1123537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123556 */     // MIs[0] policy
     /* 1123556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123566 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M8),
     /* 1123569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123588 */     // GIR_Coverage, 64289,
     /* 1123588 */     GIR_EraseRootFromParent_Done,
     /* 1123589 */   // Label 16476: @1123589
     /* 1123589 */   GIM_Try, /*On fail goto*//*Label 16477*/ GIMT_Encode4(1123666), // Rule ID 64290 //
     /* 1123594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1123597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1123614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123633 */     // MIs[0] policy
     /* 1123633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123643 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M8),
     /* 1123646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123665 */     // GIR_Coverage, 64290,
     /* 1123665 */     GIR_EraseRootFromParent_Done,
     /* 1123666 */   // Label 16477: @1123666
     /* 1123666 */   GIM_Try, /*On fail goto*//*Label 16478*/ GIMT_Encode4(1123743), // Rule ID 64291 //
     /* 1123671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1123679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123710 */     // MIs[0] policy
     /* 1123710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123720 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M1),
     /* 1123723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123742 */     // GIR_Coverage, 64291,
     /* 1123742 */     GIR_EraseRootFromParent_Done,
     /* 1123743 */   // Label 16478: @1123743
     /* 1123743 */   GIM_Try, /*On fail goto*//*Label 16479*/ GIMT_Encode4(1123820), // Rule ID 64292 //
     /* 1123748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1123751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1123756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123787 */     // MIs[0] policy
     /* 1123787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123797 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M1),
     /* 1123800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123819 */     // GIR_Coverage, 64292,
     /* 1123819 */     GIR_EraseRootFromParent_Done,
     /* 1123820 */   // Label 16479: @1123820
     /* 1123820 */   GIM_Try, /*On fail goto*//*Label 16480*/ GIMT_Encode4(1123897), // Rule ID 64293 //
     /* 1123825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1123833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123864 */     // MIs[0] policy
     /* 1123864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M2),
     /* 1123877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123896 */     // GIR_Coverage, 64293,
     /* 1123896 */     GIR_EraseRootFromParent_Done,
     /* 1123897 */   // Label 16480: @1123897
     /* 1123897 */   GIM_Try, /*On fail goto*//*Label 16481*/ GIMT_Encode4(1123974), // Rule ID 64294 //
     /* 1123902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1123905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1123910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123941 */     // MIs[0] policy
     /* 1123941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M2),
     /* 1123954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123973 */     // GIR_Coverage, 64294,
     /* 1123973 */     GIR_EraseRootFromParent_Done,
     /* 1123974 */   // Label 16481: @1123974
     /* 1123974 */   GIM_Try, /*On fail goto*//*Label 16482*/ GIMT_Encode4(1124051), // Rule ID 64295 //
     /* 1123979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1123987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124018 */     // MIs[0] policy
     /* 1124018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124028 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M4),
     /* 1124031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124050 */     // GIR_Coverage, 64295,
     /* 1124050 */     GIR_EraseRootFromParent_Done,
     /* 1124051 */   // Label 16482: @1124051
     /* 1124051 */   GIM_Try, /*On fail goto*//*Label 16483*/ GIMT_Encode4(1124128), // Rule ID 64296 //
     /* 1124056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1124064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124095 */     // MIs[0] policy
     /* 1124095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124105 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M4),
     /* 1124108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124127 */     // GIR_Coverage, 64296,
     /* 1124127 */     GIR_EraseRootFromParent_Done,
     /* 1124128 */   // Label 16483: @1124128
     /* 1124128 */   GIM_Try, /*On fail goto*//*Label 16484*/ GIMT_Encode4(1124205), // Rule ID 64297 //
     /* 1124133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1124136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1124141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1124153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124172 */     // MIs[0] policy
     /* 1124172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124182 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M8),
     /* 1124185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124204 */     // GIR_Coverage, 64297,
     /* 1124204 */     GIR_EraseRootFromParent_Done,
     /* 1124205 */   // Label 16484: @1124205
     /* 1124205 */   GIM_Try, /*On fail goto*//*Label 16485*/ GIMT_Encode4(1124282), // Rule ID 64298 //
     /* 1124210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1124218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1124230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124249 */     // MIs[0] policy
     /* 1124249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124259 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M8),
     /* 1124262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124281 */     // GIR_Coverage, 64298,
     /* 1124281 */     GIR_EraseRootFromParent_Done,
     /* 1124282 */   // Label 16485: @1124282
     /* 1124282 */   GIM_Try, /*On fail goto*//*Label 16486*/ GIMT_Encode4(1124359), // Rule ID 64299 //
     /* 1124287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1124290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124326 */     // MIs[0] policy
     /* 1124326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11084:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M1),
     /* 1124339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124358 */     // GIR_Coverage, 64299,
     /* 1124358 */     GIR_EraseRootFromParent_Done,
     /* 1124359 */   // Label 16486: @1124359
     /* 1124359 */   GIM_Try, /*On fail goto*//*Label 16487*/ GIMT_Encode4(1124436), // Rule ID 64300 //
     /* 1124364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124403 */     // MIs[0] policy
     /* 1124403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124413 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11084:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M1),
     /* 1124416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124435 */     // GIR_Coverage, 64300,
     /* 1124435 */     GIR_EraseRootFromParent_Done,
     /* 1124436 */   // Label 16487: @1124436
     /* 1124436 */   GIM_Try, /*On fail goto*//*Label 16488*/ GIMT_Encode4(1124513), // Rule ID 64301 //
     /* 1124441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1124444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124480 */     // MIs[0] policy
     /* 1124480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124490 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11084:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M2),
     /* 1124493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124512 */     // GIR_Coverage, 64301,
     /* 1124512 */     GIR_EraseRootFromParent_Done,
     /* 1124513 */   // Label 16488: @1124513
     /* 1124513 */   GIM_Try, /*On fail goto*//*Label 16489*/ GIMT_Encode4(1124590), // Rule ID 64302 //
     /* 1124518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124557 */     // MIs[0] policy
     /* 1124557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124567 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11084:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M2),
     /* 1124570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124589 */     // GIR_Coverage, 64302,
     /* 1124589 */     GIR_EraseRootFromParent_Done,
     /* 1124590 */   // Label 16489: @1124590
     /* 1124590 */   GIM_Try, /*On fail goto*//*Label 16490*/ GIMT_Encode4(1124667), // Rule ID 64303 //
     /* 1124595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1124598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124634 */     // MIs[0] policy
     /* 1124634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124644 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M4),
     /* 1124647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124666 */     // GIR_Coverage, 64303,
     /* 1124666 */     GIR_EraseRootFromParent_Done,
     /* 1124667 */   // Label 16490: @1124667
     /* 1124667 */   GIM_Try, /*On fail goto*//*Label 16491*/ GIMT_Encode4(1124744), // Rule ID 64304 //
     /* 1124672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124711 */     // MIs[0] policy
     /* 1124711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124721 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M4),
     /* 1124724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124743 */     // GIR_Coverage, 64304,
     /* 1124743 */     GIR_EraseRootFromParent_Done,
     /* 1124744 */   // Label 16491: @1124744
     /* 1124744 */   GIM_Try, /*On fail goto*//*Label 16492*/ GIMT_Encode4(1124821), // Rule ID 64305 //
     /* 1124749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1124752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1124769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124788 */     // MIs[0] policy
     /* 1124788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124798 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M8),
     /* 1124801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124820 */     // GIR_Coverage, 64305,
     /* 1124820 */     GIR_EraseRootFromParent_Done,
     /* 1124821 */   // Label 16492: @1124821
     /* 1124821 */   GIM_Try, /*On fail goto*//*Label 16493*/ GIMT_Encode4(1124898), // Rule ID 64306 //
     /* 1124826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1124846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124865 */     // MIs[0] policy
     /* 1124865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124875 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M8),
     /* 1124878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124897 */     // GIR_Coverage, 64306,
     /* 1124897 */     GIR_EraseRootFromParent_Done,
     /* 1124898 */   // Label 16493: @1124898
     /* 1124898 */   GIM_Try, /*On fail goto*//*Label 16494*/ GIMT_Encode4(1124975), // Rule ID 64307 //
     /* 1124903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1124906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1124911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124942 */     // MIs[0] policy
     /* 1124942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M1),
     /* 1124955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124974 */     // GIR_Coverage, 64307,
     /* 1124974 */     GIR_EraseRootFromParent_Done,
     /* 1124975 */   // Label 16494: @1124975
     /* 1124975 */   GIM_Try, /*On fail goto*//*Label 16495*/ GIMT_Encode4(1125052), // Rule ID 64308 //
     /* 1124980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1124988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1125000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125019 */     // MIs[0] policy
     /* 1125019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125029 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M1),
     /* 1125032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125051 */     // GIR_Coverage, 64308,
     /* 1125051 */     GIR_EraseRootFromParent_Done,
     /* 1125052 */   // Label 16495: @1125052
     /* 1125052 */   GIM_Try, /*On fail goto*//*Label 16496*/ GIMT_Encode4(1125129), // Rule ID 64309 //
     /* 1125057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1125060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1125065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125096 */     // MIs[0] policy
     /* 1125096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M2),
     /* 1125109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125128 */     // GIR_Coverage, 64309,
     /* 1125128 */     GIR_EraseRootFromParent_Done,
     /* 1125129 */   // Label 16496: @1125129
     /* 1125129 */   GIM_Try, /*On fail goto*//*Label 16497*/ GIMT_Encode4(1125206), // Rule ID 64310 //
     /* 1125134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1125137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1125142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125173 */     // MIs[0] policy
     /* 1125173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125183 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M2),
     /* 1125186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125205 */     // GIR_Coverage, 64310,
     /* 1125205 */     GIR_EraseRootFromParent_Done,
     /* 1125206 */   // Label 16497: @1125206
     /* 1125206 */   GIM_Try, /*On fail goto*//*Label 16498*/ GIMT_Encode4(1125283), // Rule ID 64311 //
     /* 1125211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1125214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1125219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1125231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125250 */     // MIs[0] policy
     /* 1125250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125260 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M4),
     /* 1125263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125282 */     // GIR_Coverage, 64311,
     /* 1125282 */     GIR_EraseRootFromParent_Done,
     /* 1125283 */   // Label 16498: @1125283
     /* 1125283 */   GIM_Try, /*On fail goto*//*Label 16499*/ GIMT_Encode4(1125360), // Rule ID 64312 //
     /* 1125288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1125291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1125296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1125308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125327 */     // MIs[0] policy
     /* 1125327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125337 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M4),
     /* 1125340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125359 */     // GIR_Coverage, 64312,
     /* 1125359 */     GIR_EraseRootFromParent_Done,
     /* 1125360 */   // Label 16499: @1125360
     /* 1125360 */   GIM_Try, /*On fail goto*//*Label 16500*/ GIMT_Encode4(1125437), // Rule ID 64313 //
     /* 1125365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1125368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1125373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1125376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1125379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1125385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125404 */     // MIs[0] policy
     /* 1125404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125414 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M8),
     /* 1125417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125436 */     // GIR_Coverage, 64313,
     /* 1125436 */     GIR_EraseRootFromParent_Done,
     /* 1125437 */   // Label 16500: @1125437
     /* 1125437 */   GIM_Try, /*On fail goto*//*Label 16501*/ GIMT_Encode4(1125514), // Rule ID 64314 //
     /* 1125442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1125445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1125450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1125453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1125456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1125462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125481 */     // MIs[0] policy
     /* 1125481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125491 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M8),
     /* 1125494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125513 */     // GIR_Coverage, 64314,
     /* 1125513 */     GIR_EraseRootFromParent_Done,
     /* 1125514 */   // Label 16501: @1125514
     /* 1125514 */   GIM_Try, /*On fail goto*//*Label 16502*/ GIMT_Encode4(1125591), // Rule ID 64315 //
     /* 1125519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1125522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1125530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1125533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1125539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125558 */     // MIs[0] policy
     /* 1125558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125568 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_MF2),
     /* 1125571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125590 */     // GIR_Coverage, 64315,
     /* 1125590 */     GIR_EraseRootFromParent_Done,
     /* 1125591 */   // Label 16502: @1125591
     /* 1125591 */   GIM_Try, /*On fail goto*//*Label 16503*/ GIMT_Encode4(1125668), // Rule ID 64316 //
     /* 1125596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1125599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1125607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1125610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1125616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125635 */     // MIs[0] policy
     /* 1125635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125645 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_MF2),
     /* 1125648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125667 */     // GIR_Coverage, 64316,
     /* 1125667 */     GIR_EraseRootFromParent_Done,
     /* 1125668 */   // Label 16503: @1125668
     /* 1125668 */   GIM_Try, /*On fail goto*//*Label 16504*/ GIMT_Encode4(1125745), // Rule ID 64317 //
     /* 1125673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1125676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1125693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125712 */     // MIs[0] policy
     /* 1125712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M1),
     /* 1125725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125744 */     // GIR_Coverage, 64317,
     /* 1125744 */     GIR_EraseRootFromParent_Done,
     /* 1125745 */   // Label 16504: @1125745
     /* 1125745 */   GIM_Try, /*On fail goto*//*Label 16505*/ GIMT_Encode4(1125822), // Rule ID 64318 //
     /* 1125750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1125753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1125770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125789 */     // MIs[0] policy
     /* 1125789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M1),
     /* 1125802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125821 */     // GIR_Coverage, 64318,
     /* 1125821 */     GIR_EraseRootFromParent_Done,
     /* 1125822 */   // Label 16505: @1125822
     /* 1125822 */   GIM_Try, /*On fail goto*//*Label 16506*/ GIMT_Encode4(1125899), // Rule ID 64319 //
     /* 1125827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1125830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125866 */     // MIs[0] policy
     /* 1125866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125876 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M2),
     /* 1125879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125898 */     // GIR_Coverage, 64319,
     /* 1125898 */     GIR_EraseRootFromParent_Done,
     /* 1125899 */   // Label 16506: @1125899
     /* 1125899 */   GIM_Try, /*On fail goto*//*Label 16507*/ GIMT_Encode4(1125976), // Rule ID 64320 //
     /* 1125904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1125907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125943 */     // MIs[0] policy
     /* 1125943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125953 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M2),
     /* 1125956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125975 */     // GIR_Coverage, 64320,
     /* 1125975 */     GIR_EraseRootFromParent_Done,
     /* 1125976 */   // Label 16507: @1125976
     /* 1125976 */   GIM_Try, /*On fail goto*//*Label 16508*/ GIMT_Encode4(1126053), // Rule ID 64321 //
     /* 1125981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1125984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1125992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1125995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126020 */     // MIs[0] policy
     /* 1126020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M4),
     /* 1126033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126052 */     // GIR_Coverage, 64321,
     /* 1126052 */     GIR_EraseRootFromParent_Done,
     /* 1126053 */   // Label 16508: @1126053
     /* 1126053 */   GIM_Try, /*On fail goto*//*Label 16509*/ GIMT_Encode4(1126130), // Rule ID 64322 //
     /* 1126058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1126066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126097 */     // MIs[0] policy
     /* 1126097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126107 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M4),
     /* 1126110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126129 */     // GIR_Coverage, 64322,
     /* 1126129 */     GIR_EraseRootFromParent_Done,
     /* 1126130 */   // Label 16509: @1126130
     /* 1126130 */   GIM_Try, /*On fail goto*//*Label 16510*/ GIMT_Encode4(1126207), // Rule ID 64323 //
     /* 1126135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1126138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126174 */     // MIs[0] policy
     /* 1126174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126184 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_MF2),
     /* 1126187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126206 */     // GIR_Coverage, 64323,
     /* 1126206 */     GIR_EraseRootFromParent_Done,
     /* 1126207 */   // Label 16510: @1126207
     /* 1126207 */   GIM_Try, /*On fail goto*//*Label 16511*/ GIMT_Encode4(1126284), // Rule ID 64324 //
     /* 1126212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126251 */     // MIs[0] policy
     /* 1126251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126261 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_MF2),
     /* 1126264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126283 */     // GIR_Coverage, 64324,
     /* 1126283 */     GIR_EraseRootFromParent_Done,
     /* 1126284 */   // Label 16511: @1126284
     /* 1126284 */   GIM_Try, /*On fail goto*//*Label 16512*/ GIMT_Encode4(1126361), // Rule ID 64325 //
     /* 1126289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1126292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1126309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126328 */     // MIs[0] policy
     /* 1126328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126338 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M1),
     /* 1126341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126360 */     // GIR_Coverage, 64325,
     /* 1126360 */     GIR_EraseRootFromParent_Done,
     /* 1126361 */   // Label 16512: @1126361
     /* 1126361 */   GIM_Try, /*On fail goto*//*Label 16513*/ GIMT_Encode4(1126438), // Rule ID 64326 //
     /* 1126366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1126386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126405 */     // MIs[0] policy
     /* 1126405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M1),
     /* 1126418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126437 */     // GIR_Coverage, 64326,
     /* 1126437 */     GIR_EraseRootFromParent_Done,
     /* 1126438 */   // Label 16513: @1126438
     /* 1126438 */   GIM_Try, /*On fail goto*//*Label 16514*/ GIMT_Encode4(1126515), // Rule ID 64327 //
     /* 1126443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1126446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1126463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126482 */     // MIs[0] policy
     /* 1126482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126492 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M2),
     /* 1126495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126514 */     // GIR_Coverage, 64327,
     /* 1126514 */     GIR_EraseRootFromParent_Done,
     /* 1126515 */   // Label 16514: @1126515
     /* 1126515 */   GIM_Try, /*On fail goto*//*Label 16515*/ GIMT_Encode4(1126592), // Rule ID 64328 //
     /* 1126520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1126540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126559 */     // MIs[0] policy
     /* 1126559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126569 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M2),
     /* 1126572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126591 */     // GIR_Coverage, 64328,
     /* 1126591 */     GIR_EraseRootFromParent_Done,
     /* 1126592 */   // Label 16515: @1126592
     /* 1126592 */   GIM_Try, /*On fail goto*//*Label 16516*/ GIMT_Encode4(1126669), // Rule ID 64329 //
     /* 1126597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1126600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126636 */     // MIs[0] policy
     /* 1126636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126646 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M4),
     /* 1126649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126668 */     // GIR_Coverage, 64329,
     /* 1126668 */     GIR_EraseRootFromParent_Done,
     /* 1126669 */   // Label 16516: @1126669
     /* 1126669 */   GIM_Try, /*On fail goto*//*Label 16517*/ GIMT_Encode4(1126746), // Rule ID 64330 //
     /* 1126674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126713 */     // MIs[0] policy
     /* 1126713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126723 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M4),
     /* 1126726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126745 */     // GIR_Coverage, 64330,
     /* 1126745 */     GIR_EraseRootFromParent_Done,
     /* 1126746 */   // Label 16517: @1126746
     /* 1126746 */   GIM_Try, /*On fail goto*//*Label 16518*/ GIMT_Encode4(1126823), // Rule ID 64331 //
     /* 1126751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1126754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1126759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126790 */     // MIs[0] policy
     /* 1126790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_MF2),
     /* 1126803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126822 */     // GIR_Coverage, 64331,
     /* 1126822 */     GIR_EraseRootFromParent_Done,
     /* 1126823 */   // Label 16518: @1126823
     /* 1126823 */   GIM_Try, /*On fail goto*//*Label 16519*/ GIMT_Encode4(1126900), // Rule ID 64332 //
     /* 1126828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1126836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126867 */     // MIs[0] policy
     /* 1126867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_MF2),
     /* 1126880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126899 */     // GIR_Coverage, 64332,
     /* 1126899 */     GIR_EraseRootFromParent_Done,
     /* 1126900 */   // Label 16519: @1126900
     /* 1126900 */   GIM_Try, /*On fail goto*//*Label 16520*/ GIMT_Encode4(1126977), // Rule ID 64333 //
     /* 1126905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1126908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1126913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1126925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126944 */     // MIs[0] policy
     /* 1126944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126954 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M1),
     /* 1126957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126976 */     // GIR_Coverage, 64333,
     /* 1126976 */     GIR_EraseRootFromParent_Done,
     /* 1126977 */   // Label 16520: @1126977
     /* 1126977 */   GIM_Try, /*On fail goto*//*Label 16521*/ GIMT_Encode4(1127054), // Rule ID 64334 //
     /* 1126982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1126990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127021 */     // MIs[0] policy
     /* 1127021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127031 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M1),
     /* 1127034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127053 */     // GIR_Coverage, 64334,
     /* 1127053 */     GIR_EraseRootFromParent_Done,
     /* 1127054 */   // Label 16521: @1127054
     /* 1127054 */   GIM_Try, /*On fail goto*//*Label 16522*/ GIMT_Encode4(1127131), // Rule ID 64335 //
     /* 1127059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1127062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1127067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127098 */     // MIs[0] policy
     /* 1127098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127108 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M2),
     /* 1127111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127130 */     // GIR_Coverage, 64335,
     /* 1127130 */     GIR_EraseRootFromParent_Done,
     /* 1127131 */   // Label 16522: @1127131
     /* 1127131 */   GIM_Try, /*On fail goto*//*Label 16523*/ GIMT_Encode4(1127208), // Rule ID 64336 //
     /* 1127136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1127139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1127144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127175 */     // MIs[0] policy
     /* 1127175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127185 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M2),
     /* 1127188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127207 */     // GIR_Coverage, 64336,
     /* 1127207 */     GIR_EraseRootFromParent_Done,
     /* 1127208 */   // Label 16523: @1127208
     /* 1127208 */   GIM_Try, /*On fail goto*//*Label 16524*/ GIMT_Encode4(1127285), // Rule ID 64337 //
     /* 1127213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1127216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1127221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127252 */     // MIs[0] policy
     /* 1127252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M4),
     /* 1127265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127284 */     // GIR_Coverage, 64337,
     /* 1127284 */     GIR_EraseRootFromParent_Done,
     /* 1127285 */   // Label 16524: @1127285
     /* 1127285 */   GIM_Try, /*On fail goto*//*Label 16525*/ GIMT_Encode4(1127362), // Rule ID 64338 //
     /* 1127290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1127293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1127298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127329 */     // MIs[0] policy
     /* 1127329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127339 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M4),
     /* 1127342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127361 */     // GIR_Coverage, 64338,
     /* 1127361 */     GIR_EraseRootFromParent_Done,
     /* 1127362 */   // Label 16525: @1127362
     /* 1127362 */   GIM_Try, /*On fail goto*//*Label 16526*/ GIMT_Encode4(1127439), // Rule ID 64339 //
     /* 1127367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1127370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1127378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1127381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1127387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127406 */     // MIs[0] policy
     /* 1127406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127416 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_MF2),
     /* 1127419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127438 */     // GIR_Coverage, 64339,
     /* 1127438 */     GIR_EraseRootFromParent_Done,
     /* 1127439 */   // Label 16526: @1127439
     /* 1127439 */   GIM_Try, /*On fail goto*//*Label 16527*/ GIMT_Encode4(1127516), // Rule ID 64340 //
     /* 1127444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1127447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1127455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1127458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1127464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127483 */     // MIs[0] policy
     /* 1127483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_MF2),
     /* 1127496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127515 */     // GIR_Coverage, 64340,
     /* 1127515 */     GIR_EraseRootFromParent_Done,
     /* 1127516 */   // Label 16527: @1127516
     /* 1127516 */   GIM_Try, /*On fail goto*//*Label 16528*/ GIMT_Encode4(1127593), // Rule ID 64341 //
     /* 1127521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1127524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1127532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1127535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127560 */     // MIs[0] policy
     /* 1127560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M1),
     /* 1127573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127592 */     // GIR_Coverage, 64341,
     /* 1127592 */     GIR_EraseRootFromParent_Done,
     /* 1127593 */   // Label 16528: @1127593
     /* 1127593 */   GIM_Try, /*On fail goto*//*Label 16529*/ GIMT_Encode4(1127670), // Rule ID 64342 //
     /* 1127598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1127601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1127609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1127612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127637 */     // MIs[0] policy
     /* 1127637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M1),
     /* 1127650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127669 */     // GIR_Coverage, 64342,
     /* 1127669 */     GIR_EraseRootFromParent_Done,
     /* 1127670 */   // Label 16529: @1127670
     /* 1127670 */   GIM_Try, /*On fail goto*//*Label 16530*/ GIMT_Encode4(1127747), // Rule ID 64343 //
     /* 1127675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1127678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127714 */     // MIs[0] policy
     /* 1127714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127724 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M2),
     /* 1127727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127746 */     // GIR_Coverage, 64343,
     /* 1127746 */     GIR_EraseRootFromParent_Done,
     /* 1127747 */   // Label 16530: @1127747
     /* 1127747 */   GIM_Try, /*On fail goto*//*Label 16531*/ GIMT_Encode4(1127824), // Rule ID 64344 //
     /* 1127752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1127755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127791 */     // MIs[0] policy
     /* 1127791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127801 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M2),
     /* 1127804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127823 */     // GIR_Coverage, 64344,
     /* 1127823 */     GIR_EraseRootFromParent_Done,
     /* 1127824 */   // Label 16531: @1127824
     /* 1127824 */   GIM_Try, /*On fail goto*//*Label 16532*/ GIMT_Encode4(1127901), // Rule ID 64345 //
     /* 1127829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1127832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127868 */     // MIs[0] policy
     /* 1127868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127878 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M4),
     /* 1127881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127900 */     // GIR_Coverage, 64345,
     /* 1127900 */     GIR_EraseRootFromParent_Done,
     /* 1127901 */   // Label 16532: @1127901
     /* 1127901 */   GIM_Try, /*On fail goto*//*Label 16533*/ GIMT_Encode4(1127978), // Rule ID 64346 //
     /* 1127906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1127909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127945 */     // MIs[0] policy
     /* 1127945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127955 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M4),
     /* 1127958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127977 */     // GIR_Coverage, 64346,
     /* 1127977 */     GIR_EraseRootFromParent_Done,
     /* 1127978 */   // Label 16533: @1127978
     /* 1127978 */   GIM_Try, /*On fail goto*//*Label 16534*/ GIMT_Encode4(1128055), // Rule ID 65109 //
     /* 1127983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1127991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1127994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1127997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1128000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1128003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128022 */     // MIs[0] policy
     /* 1128022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128032 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2),
     /* 1128035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128054 */     // GIR_Coverage, 65109,
     /* 1128054 */     GIR_EraseRootFromParent_Done,
     /* 1128055 */   // Label 16534: @1128055
     /* 1128055 */   GIM_Try, /*On fail goto*//*Label 16535*/ GIMT_Encode4(1128132), // Rule ID 65110 //
     /* 1128060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1128068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1128071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1128074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1128077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1128080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128099 */     // MIs[0] policy
     /* 1128099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128109 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2),
     /* 1128112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128131 */     // GIR_Coverage, 65110,
     /* 1128131 */     GIR_EraseRootFromParent_Done,
     /* 1128132 */   // Label 16535: @1128132
     /* 1128132 */   GIM_Try, /*On fail goto*//*Label 16536*/ GIMT_Encode4(1128209), // Rule ID 65113 //
     /* 1128137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1128145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1128148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1128151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1128154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1128157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128176 */     // MIs[0] policy
     /* 1128176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128186 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1128189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128208 */     // GIR_Coverage, 65113,
     /* 1128208 */     GIR_EraseRootFromParent_Done,
     /* 1128209 */   // Label 16536: @1128209
     /* 1128209 */   GIM_Try, /*On fail goto*//*Label 16537*/ GIMT_Encode4(1128286), // Rule ID 65114 //
     /* 1128214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1128222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1128225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1128228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1128231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1128234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128253 */     // MIs[0] policy
     /* 1128253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128263 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11005:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1128266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128285 */     // GIR_Coverage, 65114,
     /* 1128285 */     GIR_EraseRootFromParent_Done,
     /* 1128286 */   // Label 16537: @1128286
     /* 1128286 */   GIM_Try, /*On fail goto*//*Label 16538*/ GIMT_Encode4(1128363), // Rule ID 65117 //
     /* 1128291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1128299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1128302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1128305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1128308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1128311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128330 */     // MIs[0] policy
     /* 1128330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11005:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1128343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128362 */     // GIR_Coverage, 65117,
     /* 1128362 */     GIR_EraseRootFromParent_Done,
     /* 1128363 */   // Label 16538: @1128363
     /* 1128363 */   GIM_Try, /*On fail goto*//*Label 16539*/ GIMT_Encode4(1128440), // Rule ID 65118 //
     /* 1128368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1128376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1128379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1128382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1128385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1128388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128407 */     // MIs[0] policy
     /* 1128407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128417 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11005:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1128420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128439 */     // GIR_Coverage, 65118,
     /* 1128439 */     GIR_EraseRootFromParent_Done,
     /* 1128440 */   // Label 16539: @1128440
     /* 1128440 */   GIM_Try, /*On fail goto*//*Label 16540*/ GIMT_Encode4(1128517), // Rule ID 65121 //
     /* 1128445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1128453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1128456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1128459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1128462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1128465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128484 */     // MIs[0] policy
     /* 1128484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11005:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1128497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128516 */     // GIR_Coverage, 65121,
     /* 1128516 */     GIR_EraseRootFromParent_Done,
     /* 1128517 */   // Label 16540: @1128517
     /* 1128517 */   GIM_Try, /*On fail goto*//*Label 16541*/ GIMT_Encode4(1128594), // Rule ID 65122 //
     /* 1128522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1128530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1128533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1128536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1128539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1128542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128561 */     // MIs[0] policy
     /* 1128561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128571 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11005:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1128574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128593 */     // GIR_Coverage, 65122,
     /* 1128593 */     GIR_EraseRootFromParent_Done,
     /* 1128594 */   // Label 16541: @1128594
     /* 1128594 */   GIM_Try, /*On fail goto*//*Label 16542*/ GIMT_Encode4(1128671), // Rule ID 65125 //
     /* 1128599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1128607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1128610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1128613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1128616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1128619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128638 */     // MIs[0] policy
     /* 1128638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128648 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11005:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1128651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128670 */     // GIR_Coverage, 65125,
     /* 1128670 */     GIR_EraseRootFromParent_Done,
     /* 1128671 */   // Label 16542: @1128671
     /* 1128671 */   GIM_Try, /*On fail goto*//*Label 16543*/ GIMT_Encode4(1128748), // Rule ID 65126 //
     /* 1128676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1128684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1128687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1128690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1128693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1128696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128715 */     // MIs[0] policy
     /* 1128715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128725 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11005:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1128728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128747 */     // GIR_Coverage, 65126,
     /* 1128747 */     GIR_EraseRootFromParent_Done,
     /* 1128748 */   // Label 16543: @1128748
     /* 1128748 */   GIM_Try, /*On fail goto*//*Label 16544*/ GIMT_Encode4(1128825), // Rule ID 65129 //
     /* 1128753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1128761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1128764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1128767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1128770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128792 */     // MIs[0] policy
     /* 1128792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1128805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128824 */     // GIR_Coverage, 65129,
     /* 1128824 */     GIR_EraseRootFromParent_Done,
     /* 1128825 */   // Label 16544: @1128825
     /* 1128825 */   GIM_Try, /*On fail goto*//*Label 16545*/ GIMT_Encode4(1128902), // Rule ID 65130 //
     /* 1128830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1128838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1128841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1128844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1128847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128869 */     // MIs[0] policy
     /* 1128869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128879 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11005:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1128882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128901 */     // GIR_Coverage, 65130,
     /* 1128901 */     GIR_EraseRootFromParent_Done,
     /* 1128902 */   // Label 16545: @1128902
     /* 1128902 */   GIM_Try, /*On fail goto*//*Label 16546*/ GIMT_Encode4(1128979), // Rule ID 65133 //
     /* 1128907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1128915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1128918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1128921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1128924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1128927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128946 */     // MIs[0] policy
     /* 1128946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128956 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11005:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1128959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128978 */     // GIR_Coverage, 65133,
     /* 1128978 */     GIR_EraseRootFromParent_Done,
     /* 1128979 */   // Label 16546: @1128979
     /* 1128979 */   GIM_Try, /*On fail goto*//*Label 16547*/ GIMT_Encode4(1129056), // Rule ID 65134 //
     /* 1128984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1128992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1128995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1128998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1129001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1129004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1129007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129023 */     // MIs[0] policy
     /* 1129023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1129026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129033 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11005:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1129033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1129036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1129052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1129054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129055 */     // GIR_Coverage, 65134,
     /* 1129055 */     GIR_EraseRootFromParent_Done,
     /* 1129056 */   // Label 16547: @1129056
     /* 1129056 */   GIM_Try, /*On fail goto*//*Label 16548*/ GIMT_Encode4(1129133), // Rule ID 65137 //
     /* 1129061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1129064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1129069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1129072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1129075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1129078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1129081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1129084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129100 */     // MIs[0] policy
     /* 1129100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1129103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129110 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11005:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1129110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1129113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1129129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1129131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129132 */     // GIR_Coverage, 65137,
     /* 1129132 */     GIR_EraseRootFromParent_Done,
     /* 1129133 */   // Label 16548: @1129133
     /* 1129133 */   GIM_Try, /*On fail goto*//*Label 16549*/ GIMT_Encode4(1129210), // Rule ID 65138 //
     /* 1129138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1129141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1129146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1129149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1129152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1129155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1129158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1129161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129177 */     // MIs[0] policy
     /* 1129177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1129180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129187 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11005:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1129187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1129190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1129206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1129208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129209 */     // GIR_Coverage, 65138,
     /* 1129209 */     GIR_EraseRootFromParent_Done,
     /* 1129210 */   // Label 16549: @1129210
     /* 1129210 */   GIM_Try, /*On fail goto*//*Label 16550*/ GIMT_Encode4(1129287), // Rule ID 65141 //
     /* 1129215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1129218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1129223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1129226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1129229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1129232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1129235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1129238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129254 */     // MIs[0] policy
     /* 1129254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1129257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129264 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11005:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1129264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1129267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1129283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1129285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129286 */     // GIR_Coverage, 65141,
     /* 1129286 */     GIR_EraseRootFromParent_Done,
     /* 1129287 */   // Label 16550: @1129287
     /* 1129287 */   GIM_Try, /*On fail goto*//*Label 16551*/ GIMT_Encode4(1129364), // Rule ID 65142 //
     /* 1129292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1129295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1129300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1129303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1129306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1129309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1129312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1129315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129331 */     // MIs[0] policy
     /* 1129331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1129334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129341 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11005:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1129341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1129344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1129360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1129362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129363 */     // GIR_Coverage, 65142,
     /* 1129363 */     GIR_EraseRootFromParent_Done,
     /* 1129364 */   // Label 16551: @1129364
     /* 1129364 */   GIM_Try, /*On fail goto*//*Label 16552*/ GIMT_Encode4(1129441), // Rule ID 65145 //
     /* 1129369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1129377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1129386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1129389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1129392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129408 */     // MIs[0] policy
     /* 1129408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1129411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129418 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1129418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2),
     /* 1129421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1129439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129440 */     // GIR_Coverage, 65145,
     /* 1129440 */     GIR_EraseRootFromParent_Done,
     /* 1129441 */   // Label 16552: @1129441
     /* 1129441 */   GIM_Try, /*On fail goto*//*Label 16553*/ GIMT_Encode4(1129518), // Rule ID 65146 //
     /* 1129446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1129454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1129463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1129466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1129469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129485 */     // MIs[0] policy
     /* 1129485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1129488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129495 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1129495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2),
     /* 1129498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1129516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129517 */     // GIR_Coverage, 65146,
     /* 1129517 */     GIR_EraseRootFromParent_Done,
     /* 1129518 */   // Label 16553: @1129518
     /* 1129518 */   GIM_Try, /*On fail goto*//*Label 16554*/ GIMT_Encode4(1129595), // Rule ID 65149 //
     /* 1129523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1129531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1129534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1129537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1129540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1129543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1129546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129562 */     // MIs[0] policy
     /* 1129562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1129565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129572 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1129572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1129575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1129593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129594 */     // GIR_Coverage, 65149,
     /* 1129594 */     GIR_EraseRootFromParent_Done,
     /* 1129595 */   // Label 16554: @1129595
     /* 1129595 */   GIM_Try, /*On fail goto*//*Label 16555*/ GIMT_Encode4(1129672), // Rule ID 65150 //
     /* 1129600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1129608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1129611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1129614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1129617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1129620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1129623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129639 */     // MIs[0] policy
     /* 1129639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1129642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129649 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11009:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1129649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1129652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1129670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129671 */     // GIR_Coverage, 65150,
     /* 1129671 */     GIR_EraseRootFromParent_Done,
     /* 1129672 */   // Label 16555: @1129672
     /* 1129672 */   GIM_Try, /*On fail goto*//*Label 16556*/ GIMT_Encode4(1129749), // Rule ID 65153 //
     /* 1129677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1129685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1129688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1129691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1129694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1129697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1129700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129716 */     // MIs[0] policy
     /* 1129716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1129719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1129726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1129729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1129747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129748 */     // GIR_Coverage, 65153,
     /* 1129748 */     GIR_EraseRootFromParent_Done,
     /* 1129749 */   // Label 16556: @1129749
     /* 1129749 */   GIM_Try, /*On fail goto*//*Label 16557*/ GIMT_Encode4(1129826), // Rule ID 65154 //
     /* 1129754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1129762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1129765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1129768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1129771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1129774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1129777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129793 */     // MIs[0] policy
     /* 1129793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1129796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1129803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1129806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1129824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129825 */     // GIR_Coverage, 65154,
     /* 1129825 */     GIR_EraseRootFromParent_Done,
     /* 1129826 */   // Label 16557: @1129826
     /* 1129826 */   GIM_Try, /*On fail goto*//*Label 16558*/ GIMT_Encode4(1129903), // Rule ID 65157 //
     /* 1129831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1129839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1129842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1129845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1129848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1129851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1129854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129870 */     // MIs[0] policy
     /* 1129870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1129873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129880 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1129880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1129883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1129901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129902 */     // GIR_Coverage, 65157,
     /* 1129902 */     GIR_EraseRootFromParent_Done,
     /* 1129903 */   // Label 16558: @1129903
     /* 1129903 */   GIM_Try, /*On fail goto*//*Label 16559*/ GIMT_Encode4(1129980), // Rule ID 65158 //
     /* 1129908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1129916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1129919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1129922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1129925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1129928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1129931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129947 */     // MIs[0] policy
     /* 1129947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1129950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129957 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1129957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1129960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1129978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129979 */     // GIR_Coverage, 65158,
     /* 1129979 */     GIR_EraseRootFromParent_Done,
     /* 1129980 */   // Label 16559: @1129980
     /* 1129980 */   GIM_Try, /*On fail goto*//*Label 16560*/ GIMT_Encode4(1130057), // Rule ID 65161 //
     /* 1129985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1129993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1129996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1129999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1130002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1130005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1130008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130024 */     // MIs[0] policy
     /* 1130024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1130027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1130034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1130037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1130055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130056 */     // GIR_Coverage, 65161,
     /* 1130056 */     GIR_EraseRootFromParent_Done,
     /* 1130057 */   // Label 16560: @1130057
     /* 1130057 */   GIM_Try, /*On fail goto*//*Label 16561*/ GIMT_Encode4(1130134), // Rule ID 65162 //
     /* 1130062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1130070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1130073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1130076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1130079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1130082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1130085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130101 */     // MIs[0] policy
     /* 1130101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1130104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130111 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1130111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1130114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1130132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130133 */     // GIR_Coverage, 65162,
     /* 1130133 */     GIR_EraseRootFromParent_Done,
     /* 1130134 */   // Label 16561: @1130134
     /* 1130134 */   GIM_Try, /*On fail goto*//*Label 16562*/ GIMT_Encode4(1130211), // Rule ID 65165 //
     /* 1130139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1130142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1130147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1130150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1130153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1130156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1130159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1130162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130178 */     // MIs[0] policy
     /* 1130178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1130181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130188 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1130188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1130191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1130209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130210 */     // GIR_Coverage, 65165,
     /* 1130210 */     GIR_EraseRootFromParent_Done,
     /* 1130211 */   // Label 16562: @1130211
     /* 1130211 */   GIM_Try, /*On fail goto*//*Label 16563*/ GIMT_Encode4(1130288), // Rule ID 65166 //
     /* 1130216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1130219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1130224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1130227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1130230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1130233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1130236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1130239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130255 */     // MIs[0] policy
     /* 1130255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1130258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130265 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11009:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1130265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1130268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1130286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130287 */     // GIR_Coverage, 65166,
     /* 1130287 */     GIR_EraseRootFromParent_Done,
     /* 1130288 */   // Label 16563: @1130288
     /* 1130288 */   GIM_Try, /*On fail goto*//*Label 16564*/ GIMT_Encode4(1130365), // Rule ID 65169 //
     /* 1130293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1130296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1130301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1130304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1130307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1130310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1130313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1130316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130332 */     // MIs[0] policy
     /* 1130332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1130335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130342 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1130342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1130345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1130363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130364 */     // GIR_Coverage, 65169,
     /* 1130364 */     GIR_EraseRootFromParent_Done,
     /* 1130365 */   // Label 16564: @1130365
     /* 1130365 */   GIM_Try, /*On fail goto*//*Label 16565*/ GIMT_Encode4(1130442), // Rule ID 65170 //
     /* 1130370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1130373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1130378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1130381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1130384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1130387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1130390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1130393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130409 */     // MIs[0] policy
     /* 1130409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1130412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130419 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11009:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1130419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1130422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1130440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130441 */     // GIR_Coverage, 65170,
     /* 1130441 */     GIR_EraseRootFromParent_Done,
     /* 1130442 */   // Label 16565: @1130442
     /* 1130442 */   GIM_Try, /*On fail goto*//*Label 16566*/ GIMT_Encode4(1130519), // Rule ID 65173 //
     /* 1130447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1130450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1130455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1130458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1130461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1130464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1130467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1130470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130486 */     // MIs[0] policy
     /* 1130486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1130489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1130496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1130499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1130517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130518 */     // GIR_Coverage, 65173,
     /* 1130518 */     GIR_EraseRootFromParent_Done,
     /* 1130519 */   // Label 16566: @1130519
     /* 1130519 */   GIM_Try, /*On fail goto*//*Label 16567*/ GIMT_Encode4(1130596), // Rule ID 65174 //
     /* 1130524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1130527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1130532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1130535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1130538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1130541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1130544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1130547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130563 */     // MIs[0] policy
     /* 1130563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1130566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130573 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11009:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1130573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1130576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1130594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130595 */     // GIR_Coverage, 65174,
     /* 1130595 */     GIR_EraseRootFromParent_Done,
     /* 1130596 */   // Label 16567: @1130596
     /* 1130596 */   GIM_Try, /*On fail goto*//*Label 16568*/ GIMT_Encode4(1130673), // Rule ID 65177 //
     /* 1130601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1130604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1130609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1130612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1130615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1130618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1130621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1130624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130640 */     // MIs[0] policy
     /* 1130640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1130643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130650 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1130650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1130653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1130671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130672 */     // GIR_Coverage, 65177,
     /* 1130672 */     GIR_EraseRootFromParent_Done,
     /* 1130673 */   // Label 16568: @1130673
     /* 1130673 */   GIM_Try, /*On fail goto*//*Label 16569*/ GIMT_Encode4(1130750), // Rule ID 65178 //
     /* 1130678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1130681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1130686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1130689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1130692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1130695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1130698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1130701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130717 */     // MIs[0] policy
     /* 1130717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1130720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130727 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11009:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1130727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1130730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1130748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130749 */     // GIR_Coverage, 65178,
     /* 1130749 */     GIR_EraseRootFromParent_Done,
     /* 1130750 */   // Label 16569: @1130750
     /* 1130750 */   GIM_Try, /*On fail goto*//*Label 16570*/ GIMT_Encode4(1130827), // Rule ID 65181 //
     /* 1130755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1130763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1130766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1130769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1130772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1130775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1130778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130794 */     // MIs[0] policy
     /* 1130794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1130797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130804 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11007:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1130804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2),
     /* 1130807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1130825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130826 */     // GIR_Coverage, 65181,
     /* 1130826 */     GIR_EraseRootFromParent_Done,
     /* 1130827 */   // Label 16570: @1130827
     /* 1130827 */   GIM_Try, /*On fail goto*//*Label 16571*/ GIMT_Encode4(1130904), // Rule ID 65182 //
     /* 1130832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1130840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1130843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1130846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1130849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1130852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1130855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130871 */     // MIs[0] policy
     /* 1130871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1130874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130881 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11007:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1130881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2),
     /* 1130884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1130902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130903 */     // GIR_Coverage, 65182,
     /* 1130903 */     GIR_EraseRootFromParent_Done,
     /* 1130904 */   // Label 16571: @1130904
     /* 1130904 */   GIM_Try, /*On fail goto*//*Label 16572*/ GIMT_Encode4(1130981), // Rule ID 65185 //
     /* 1130909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1130917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1130920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1130923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1130926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1130929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1130932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130948 */     // MIs[0] policy
     /* 1130948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1130951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11007:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1130958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1130961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1130965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1130979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130980 */     // GIR_Coverage, 65185,
     /* 1130980 */     GIR_EraseRootFromParent_Done,
     /* 1130981 */   // Label 16572: @1130981
     /* 1130981 */   GIM_Try, /*On fail goto*//*Label 16573*/ GIMT_Encode4(1131058), // Rule ID 65186 //
     /* 1130986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1130994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1130997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1131000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1131003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1131006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1131009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131025 */     // MIs[0] policy
     /* 1131025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1131028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131035 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11007:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1131035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1131038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1131056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131057 */     // GIR_Coverage, 65186,
     /* 1131057 */     GIR_EraseRootFromParent_Done,
     /* 1131058 */   // Label 16573: @1131058
     /* 1131058 */   GIM_Try, /*On fail goto*//*Label 16574*/ GIMT_Encode4(1131135), // Rule ID 65189 //
     /* 1131063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1131071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1131074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1131077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1131080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1131083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1131086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131102 */     // MIs[0] policy
     /* 1131102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1131105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131112 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11007:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1131112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1131115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1131133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131134 */     // GIR_Coverage, 65189,
     /* 1131134 */     GIR_EraseRootFromParent_Done,
     /* 1131135 */   // Label 16574: @1131135
     /* 1131135 */   GIM_Try, /*On fail goto*//*Label 16575*/ GIMT_Encode4(1131212), // Rule ID 65190 //
     /* 1131140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1131148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1131151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1131154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1131157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1131160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1131163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131179 */     // MIs[0] policy
     /* 1131179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1131182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131189 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11007:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1131189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1131192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1131210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131211 */     // GIR_Coverage, 65190,
     /* 1131211 */     GIR_EraseRootFromParent_Done,
     /* 1131212 */   // Label 16575: @1131212
     /* 1131212 */   GIM_Try, /*On fail goto*//*Label 16576*/ GIMT_Encode4(1131289), // Rule ID 65193 //
     /* 1131217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1131225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1131228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1131231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1131234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1131237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1131240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131256 */     // MIs[0] policy
     /* 1131256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1131259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131266 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11007:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1131266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1131269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1131287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131288 */     // GIR_Coverage, 65193,
     /* 1131288 */     GIR_EraseRootFromParent_Done,
     /* 1131289 */   // Label 16576: @1131289
     /* 1131289 */   GIM_Try, /*On fail goto*//*Label 16577*/ GIMT_Encode4(1131366), // Rule ID 65194 //
     /* 1131294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1131302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1131305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1131308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1131311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1131314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1131317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131333 */     // MIs[0] policy
     /* 1131333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1131336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131343 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11007:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1131343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1131346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1131364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131365 */     // GIR_Coverage, 65194,
     /* 1131365 */     GIR_EraseRootFromParent_Done,
     /* 1131366 */   // Label 16577: @1131366
     /* 1131366 */   GIM_Try, /*On fail goto*//*Label 16578*/ GIMT_Encode4(1131443), // Rule ID 65197 //
     /* 1131371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1131379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1131382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1131385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1131388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1131391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1131394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131410 */     // MIs[0] policy
     /* 1131410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1131413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131420 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11007:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1131420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1131423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1131441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131442 */     // GIR_Coverage, 65197,
     /* 1131442 */     GIR_EraseRootFromParent_Done,
     /* 1131443 */   // Label 16578: @1131443
     /* 1131443 */   GIM_Try, /*On fail goto*//*Label 16579*/ GIMT_Encode4(1131520), // Rule ID 65198 //
     /* 1131448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1131456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1131459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1131462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1131465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1131468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1131471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131487 */     // MIs[0] policy
     /* 1131487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1131490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131497 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11007:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1131497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1131500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1131518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131519 */     // GIR_Coverage, 65198,
     /* 1131519 */     GIR_EraseRootFromParent_Done,
     /* 1131520 */   // Label 16579: @1131520
     /* 1131520 */   GIM_Try, /*On fail goto*//*Label 16580*/ GIMT_Encode4(1131597), // Rule ID 65201 //
     /* 1131525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1131528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1131533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1131536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1131539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1131542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1131545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1131548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131564 */     // MIs[0] policy
     /* 1131564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1131567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11007:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1131574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1131577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1131595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131596 */     // GIR_Coverage, 65201,
     /* 1131596 */     GIR_EraseRootFromParent_Done,
     /* 1131597 */   // Label 16580: @1131597
     /* 1131597 */   GIM_Try, /*On fail goto*//*Label 16581*/ GIMT_Encode4(1131674), // Rule ID 65202 //
     /* 1131602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1131605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1131610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1131613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1131616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1131619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1131622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1131625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131641 */     // MIs[0] policy
     /* 1131641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1131644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131651 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11007:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1131651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1131654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1131672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131673 */     // GIR_Coverage, 65202,
     /* 1131673 */     GIR_EraseRootFromParent_Done,
     /* 1131674 */   // Label 16581: @1131674
     /* 1131674 */   GIM_Try, /*On fail goto*//*Label 16582*/ GIMT_Encode4(1131751), // Rule ID 65205 //
     /* 1131679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1131682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1131687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1131690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1131693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1131696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1131699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1131702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131718 */     // MIs[0] policy
     /* 1131718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1131721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131728 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11007:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1131728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1131731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1131749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131750 */     // GIR_Coverage, 65205,
     /* 1131750 */     GIR_EraseRootFromParent_Done,
     /* 1131751 */   // Label 16582: @1131751
     /* 1131751 */   GIM_Try, /*On fail goto*//*Label 16583*/ GIMT_Encode4(1131828), // Rule ID 65206 //
     /* 1131756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1131759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1131764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1131767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1131770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1131773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1131776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1131779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131795 */     // MIs[0] policy
     /* 1131795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1131798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131805 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11007:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1131805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1131808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1131826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131827 */     // GIR_Coverage, 65206,
     /* 1131827 */     GIR_EraseRootFromParent_Done,
     /* 1131828 */   // Label 16583: @1131828
     /* 1131828 */   GIM_Try, /*On fail goto*//*Label 16584*/ GIMT_Encode4(1131905), // Rule ID 65209 //
     /* 1131833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1131836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1131841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1131844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1131847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1131850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1131853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1131856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131872 */     // MIs[0] policy
     /* 1131872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1131875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131882 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11007:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1131882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1131885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1131903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131904 */     // GIR_Coverage, 65209,
     /* 1131904 */     GIR_EraseRootFromParent_Done,
     /* 1131905 */   // Label 16584: @1131905
     /* 1131905 */   GIM_Try, /*On fail goto*//*Label 16585*/ GIMT_Encode4(1131982), // Rule ID 65210 //
     /* 1131910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1131913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1131918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1131921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1131924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1131927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1131930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1131933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131949 */     // MIs[0] policy
     /* 1131949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1131952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131959 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11007:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1131959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1131962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1131966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1131980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131981 */     // GIR_Coverage, 65210,
     /* 1131981 */     GIR_EraseRootFromParent_Done,
     /* 1131982 */   // Label 16585: @1131982
     /* 1131982 */   GIM_Try, /*On fail goto*//*Label 16586*/ GIMT_Encode4(1132059), // Rule ID 65213 //
     /* 1131987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1131990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1131995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1131998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1132001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1132004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1132007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1132010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132026 */     // MIs[0] policy
     /* 1132026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1132029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132036 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11007:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1132036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1132039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1132057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132058 */     // GIR_Coverage, 65213,
     /* 1132058 */     GIR_EraseRootFromParent_Done,
     /* 1132059 */   // Label 16586: @1132059
     /* 1132059 */   GIM_Try, /*On fail goto*//*Label 16587*/ GIMT_Encode4(1132136), // Rule ID 65214 //
     /* 1132064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1132067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1132072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1132075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1132078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1132081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1132084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1132087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132103 */     // MIs[0] policy
     /* 1132103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1132106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132113 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11007:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1132113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1132116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1132134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132135 */     // GIR_Coverage, 65214,
     /* 1132135 */     GIR_EraseRootFromParent_Done,
     /* 1132136 */   // Label 16587: @1132136
     /* 1132136 */   GIM_Try, /*On fail goto*//*Label 16588*/ GIMT_Encode4(1132216), // Rule ID 2716 //
     /* 1132141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1132152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1132155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1132158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1132161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132180 */     // MIs[0] round
     /* 1132180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132190 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1132193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132215 */     // GIR_Coverage, 2716,
     /* 1132215 */     GIR_EraseRootFromParent_Done,
     /* 1132216 */   // Label 16588: @1132216
     /* 1132216 */   GIM_Try, /*On fail goto*//*Label 16589*/ GIMT_Encode4(1132296), // Rule ID 2717 //
     /* 1132221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1132232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1132235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1132238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1132241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132260 */     // MIs[0] round
     /* 1132260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132270 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1132273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132295 */     // GIR_Coverage, 2717,
     /* 1132295 */     GIR_EraseRootFromParent_Done,
     /* 1132296 */   // Label 16589: @1132296
     /* 1132296 */   GIM_Try, /*On fail goto*//*Label 16590*/ GIMT_Encode4(1132376), // Rule ID 2756 //
     /* 1132301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1132304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1132309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1132312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1132315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1132318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1132321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132340 */     // MIs[0] round
     /* 1132340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132350 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1132353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132375 */     // GIR_Coverage, 2756,
     /* 1132375 */     GIR_EraseRootFromParent_Done,
     /* 1132376 */   // Label 16590: @1132376
     /* 1132376 */   GIM_Try, /*On fail goto*//*Label 16591*/ GIMT_Encode4(1132456), // Rule ID 2757 //
     /* 1132381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1132384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1132389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1132392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1132395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1132398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1132401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132420 */     // MIs[0] round
     /* 1132420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132430 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1132433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132455 */     // GIR_Coverage, 2757,
     /* 1132455 */     GIR_EraseRootFromParent_Done,
     /* 1132456 */   // Label 16591: @1132456
     /* 1132456 */   GIM_Try, /*On fail goto*//*Label 16592*/ GIMT_Encode4(1132536), // Rule ID 2776 //
     /* 1132461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1132464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1132469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1132472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1132475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1132478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1132481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132500 */     // MIs[0] round
     /* 1132500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132510 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1132513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132535 */     // GIR_Coverage, 2776,
     /* 1132535 */     GIR_EraseRootFromParent_Done,
     /* 1132536 */   // Label 16592: @1132536
     /* 1132536 */   GIM_Try, /*On fail goto*//*Label 16593*/ GIMT_Encode4(1132616), // Rule ID 2777 //
     /* 1132541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1132544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1132549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1132552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1132555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1132558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1132561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132580 */     // MIs[0] round
     /* 1132580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132590 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1132593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1132597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132615 */     // GIR_Coverage, 2777,
     /* 1132615 */     GIR_EraseRootFromParent_Done,
     /* 1132616 */   // Label 16593: @1132616
     /* 1132616 */   GIM_Try, /*On fail goto*//*Label 16594*/ GIMT_Encode4(1132696), // Rule ID 14926 //
     /* 1132621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1132632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1132635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1132638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1132641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132660 */     // MIs[0] round
     /* 1132660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132670 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1132673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132695 */     // GIR_Coverage, 14926,
     /* 1132695 */     GIR_EraseRootFromParent_Done,
     /* 1132696 */   // Label 16594: @1132696
     /* 1132696 */   GIM_Try, /*On fail goto*//*Label 16595*/ GIMT_Encode4(1132776), // Rule ID 14927 //
     /* 1132701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1132712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1132715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1132718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1132721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132740 */     // MIs[0] round
     /* 1132740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132750 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1132753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132775 */     // GIR_Coverage, 14927,
     /* 1132775 */     GIR_EraseRootFromParent_Done,
     /* 1132776 */   // Label 16595: @1132776
     /* 1132776 */   GIM_Try, /*On fail goto*//*Label 16596*/ GIMT_Encode4(1132856), // Rule ID 14930 //
     /* 1132781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1132792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1132795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1132798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1132801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132820 */     // MIs[0] round
     /* 1132820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132830 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1132833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132855 */     // GIR_Coverage, 14930,
     /* 1132855 */     GIR_EraseRootFromParent_Done,
     /* 1132856 */   // Label 16596: @1132856
     /* 1132856 */   GIM_Try, /*On fail goto*//*Label 16597*/ GIMT_Encode4(1132936), // Rule ID 14931 //
     /* 1132861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1132872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1132875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1132878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1132881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132900 */     // MIs[0] round
     /* 1132900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132910 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1132913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132935 */     // GIR_Coverage, 14931,
     /* 1132935 */     GIR_EraseRootFromParent_Done,
     /* 1132936 */   // Label 16597: @1132936
     /* 1132936 */   GIM_Try, /*On fail goto*//*Label 16598*/ GIMT_Encode4(1133016), // Rule ID 14934 //
     /* 1132941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1132952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1132955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1132958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1132961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132980 */     // MIs[0] round
     /* 1132980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132990 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1132993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133015 */     // GIR_Coverage, 14934,
     /* 1133015 */     GIR_EraseRootFromParent_Done,
     /* 1133016 */   // Label 16598: @1133016
     /* 1133016 */   GIM_Try, /*On fail goto*//*Label 16599*/ GIMT_Encode4(1133096), // Rule ID 14935 //
     /* 1133021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1133032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1133035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1133038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1133041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133060 */     // MIs[0] round
     /* 1133060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133070 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1133073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133095 */     // GIR_Coverage, 14935,
     /* 1133095 */     GIR_EraseRootFromParent_Done,
     /* 1133096 */   // Label 16599: @1133096
     /* 1133096 */   GIM_Try, /*On fail goto*//*Label 16600*/ GIMT_Encode4(1133176), // Rule ID 14938 //
     /* 1133101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1133112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1133115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1133118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1133121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133140 */     // MIs[0] round
     /* 1133140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133150 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1133153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133175 */     // GIR_Coverage, 14938,
     /* 1133175 */     GIR_EraseRootFromParent_Done,
     /* 1133176 */   // Label 16600: @1133176
     /* 1133176 */   GIM_Try, /*On fail goto*//*Label 16601*/ GIMT_Encode4(1133256), // Rule ID 14939 //
     /* 1133181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1133192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1133195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1133198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1133201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133220 */     // MIs[0] round
     /* 1133220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133230 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1133233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133255 */     // GIR_Coverage, 14939,
     /* 1133255 */     GIR_EraseRootFromParent_Done,
     /* 1133256 */   // Label 16601: @1133256
     /* 1133256 */   GIM_Try, /*On fail goto*//*Label 16602*/ GIMT_Encode4(1133336), // Rule ID 14942 //
     /* 1133261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1133272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1133275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1133278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1133281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133300 */     // MIs[0] round
     /* 1133300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133310 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1133313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133335 */     // GIR_Coverage, 14942,
     /* 1133335 */     GIR_EraseRootFromParent_Done,
     /* 1133336 */   // Label 16602: @1133336
     /* 1133336 */   GIM_Try, /*On fail goto*//*Label 16603*/ GIMT_Encode4(1133416), // Rule ID 14943 //
     /* 1133341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1133352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1133355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1133358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1133361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133380 */     // MIs[0] round
     /* 1133380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133390 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1133393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133415 */     // GIR_Coverage, 14943,
     /* 1133415 */     GIR_EraseRootFromParent_Done,
     /* 1133416 */   // Label 16603: @1133416
     /* 1133416 */   GIM_Try, /*On fail goto*//*Label 16604*/ GIMT_Encode4(1133496), // Rule ID 14946 //
     /* 1133421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1133432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1133435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1133438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1133441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133460 */     // MIs[0] round
     /* 1133460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133470 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1133473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133495 */     // GIR_Coverage, 14946,
     /* 1133495 */     GIR_EraseRootFromParent_Done,
     /* 1133496 */   // Label 16604: @1133496
     /* 1133496 */   GIM_Try, /*On fail goto*//*Label 16605*/ GIMT_Encode4(1133576), // Rule ID 14947 //
     /* 1133501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1133512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1133515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1133518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1133521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133540 */     // MIs[0] round
     /* 1133540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133550 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1133553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133575 */     // GIR_Coverage, 14947,
     /* 1133575 */     GIR_EraseRootFromParent_Done,
     /* 1133576 */   // Label 16605: @1133576
     /* 1133576 */   GIM_Try, /*On fail goto*//*Label 16606*/ GIMT_Encode4(1133656), // Rule ID 14950 //
     /* 1133581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1133592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1133595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1133598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1133601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133620 */     // MIs[0] round
     /* 1133620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133630 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1133633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133655 */     // GIR_Coverage, 14950,
     /* 1133655 */     GIR_EraseRootFromParent_Done,
     /* 1133656 */   // Label 16606: @1133656
     /* 1133656 */   GIM_Try, /*On fail goto*//*Label 16607*/ GIMT_Encode4(1133736), // Rule ID 14951 //
     /* 1133661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1133672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1133675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1133678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1133681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133700 */     // MIs[0] round
     /* 1133700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1133713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133735 */     // GIR_Coverage, 14951,
     /* 1133735 */     GIR_EraseRootFromParent_Done,
     /* 1133736 */   // Label 16607: @1133736
     /* 1133736 */   GIM_Try, /*On fail goto*//*Label 16608*/ GIMT_Encode4(1133816), // Rule ID 14954 //
     /* 1133741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1133761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133780 */     // MIs[0] round
     /* 1133780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133790 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1133793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133815 */     // GIR_Coverage, 14954,
     /* 1133815 */     GIR_EraseRootFromParent_Done,
     /* 1133816 */   // Label 16608: @1133816
     /* 1133816 */   GIM_Try, /*On fail goto*//*Label 16609*/ GIMT_Encode4(1133896), // Rule ID 14955 //
     /* 1133821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1133841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133860 */     // MIs[0] round
     /* 1133860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133870 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1133873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133895 */     // GIR_Coverage, 14955,
     /* 1133895 */     GIR_EraseRootFromParent_Done,
     /* 1133896 */   // Label 16609: @1133896
     /* 1133896 */   GIM_Try, /*On fail goto*//*Label 16610*/ GIMT_Encode4(1133976), // Rule ID 14958 //
     /* 1133901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1133904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1133918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1133921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133940 */     // MIs[0] round
     /* 1133940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133950 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1133953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1133971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133975 */     // GIR_Coverage, 14958,
     /* 1133975 */     GIR_EraseRootFromParent_Done,
     /* 1133976 */   // Label 16610: @1133976
     /* 1133976 */   GIM_Try, /*On fail goto*//*Label 16611*/ GIMT_Encode4(1134056), // Rule ID 14959 //
     /* 1133981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1133984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1133998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1134001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134020 */     // MIs[0] round
     /* 1134020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134030 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1134033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1134051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134055 */     // GIR_Coverage, 14959,
     /* 1134055 */     GIR_EraseRootFromParent_Done,
     /* 1134056 */   // Label 16611: @1134056
     /* 1134056 */   GIM_Try, /*On fail goto*//*Label 16612*/ GIMT_Encode4(1134136), // Rule ID 14962 //
     /* 1134061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1134072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1134075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1134078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1134081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134100 */     // MIs[0] round
     /* 1134100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134110 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1134113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134135 */     // GIR_Coverage, 14962,
     /* 1134135 */     GIR_EraseRootFromParent_Done,
     /* 1134136 */   // Label 16612: @1134136
     /* 1134136 */   GIM_Try, /*On fail goto*//*Label 16613*/ GIMT_Encode4(1134216), // Rule ID 14963 //
     /* 1134141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1134152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1134155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1134158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1134161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134180 */     // MIs[0] round
     /* 1134180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134190 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1134193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134215 */     // GIR_Coverage, 14963,
     /* 1134215 */     GIR_EraseRootFromParent_Done,
     /* 1134216 */   // Label 16613: @1134216
     /* 1134216 */   GIM_Try, /*On fail goto*//*Label 16614*/ GIMT_Encode4(1134296), // Rule ID 14966 //
     /* 1134221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1134232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1134235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1134238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1134241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134260 */     // MIs[0] round
     /* 1134260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134270 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1134273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134295 */     // GIR_Coverage, 14966,
     /* 1134295 */     GIR_EraseRootFromParent_Done,
     /* 1134296 */   // Label 16614: @1134296
     /* 1134296 */   GIM_Try, /*On fail goto*//*Label 16615*/ GIMT_Encode4(1134376), // Rule ID 14967 //
     /* 1134301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1134312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1134315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1134318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1134321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134340 */     // MIs[0] round
     /* 1134340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134350 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1134353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134375 */     // GIR_Coverage, 14967,
     /* 1134375 */     GIR_EraseRootFromParent_Done,
     /* 1134376 */   // Label 16615: @1134376
     /* 1134376 */   GIM_Try, /*On fail goto*//*Label 16616*/ GIMT_Encode4(1134456), // Rule ID 14970 //
     /* 1134381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1134392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1134395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1134398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1134401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134420 */     // MIs[0] round
     /* 1134420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134430 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1134433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134455 */     // GIR_Coverage, 14970,
     /* 1134455 */     GIR_EraseRootFromParent_Done,
     /* 1134456 */   // Label 16616: @1134456
     /* 1134456 */   GIM_Try, /*On fail goto*//*Label 16617*/ GIMT_Encode4(1134536), // Rule ID 14971 //
     /* 1134461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1134472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1134475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1134478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1134481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134500 */     // MIs[0] round
     /* 1134500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134510 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1134513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134535 */     // GIR_Coverage, 14971,
     /* 1134535 */     GIR_EraseRootFromParent_Done,
     /* 1134536 */   // Label 16617: @1134536
     /* 1134536 */   GIM_Try, /*On fail goto*//*Label 16618*/ GIMT_Encode4(1134616), // Rule ID 14974 //
     /* 1134541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1134552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1134555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1134558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1134561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134580 */     // MIs[0] round
     /* 1134580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1134593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134615 */     // GIR_Coverage, 14974,
     /* 1134615 */     GIR_EraseRootFromParent_Done,
     /* 1134616 */   // Label 16618: @1134616
     /* 1134616 */   GIM_Try, /*On fail goto*//*Label 16619*/ GIMT_Encode4(1134696), // Rule ID 14975 //
     /* 1134621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1134632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1134635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1134638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1134641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134660 */     // MIs[0] round
     /* 1134660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1134673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134695 */     // GIR_Coverage, 14975,
     /* 1134695 */     GIR_EraseRootFromParent_Done,
     /* 1134696 */   // Label 16619: @1134696
     /* 1134696 */   GIM_Try, /*On fail goto*//*Label 16620*/ GIMT_Encode4(1134776), // Rule ID 14978 //
     /* 1134701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1134712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1134715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1134718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1134721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134740 */     // MIs[0] round
     /* 1134740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134750 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1134753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134775 */     // GIR_Coverage, 14978,
     /* 1134775 */     GIR_EraseRootFromParent_Done,
     /* 1134776 */   // Label 16620: @1134776
     /* 1134776 */   GIM_Try, /*On fail goto*//*Label 16621*/ GIMT_Encode4(1134856), // Rule ID 14979 //
     /* 1134781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1134792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1134795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1134798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1134801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134820 */     // MIs[0] round
     /* 1134820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134830 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1134833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134855 */     // GIR_Coverage, 14979,
     /* 1134855 */     GIR_EraseRootFromParent_Done,
     /* 1134856 */   // Label 16621: @1134856
     /* 1134856 */   GIM_Try, /*On fail goto*//*Label 16622*/ GIMT_Encode4(1134936), // Rule ID 14982 //
     /* 1134861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1134872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1134875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1134878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1134881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134900 */     // MIs[0] round
     /* 1134900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134910 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1134913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134935 */     // GIR_Coverage, 14982,
     /* 1134935 */     GIR_EraseRootFromParent_Done,
     /* 1134936 */   // Label 16622: @1134936
     /* 1134936 */   GIM_Try, /*On fail goto*//*Label 16623*/ GIMT_Encode4(1135016), // Rule ID 14983 //
     /* 1134941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1134952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1134955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1134958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1134961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134980 */     // MIs[0] round
     /* 1134980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134990 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1134993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135015 */     // GIR_Coverage, 14983,
     /* 1135015 */     GIR_EraseRootFromParent_Done,
     /* 1135016 */   // Label 16623: @1135016
     /* 1135016 */   GIM_Try, /*On fail goto*//*Label 16624*/ GIMT_Encode4(1135096), // Rule ID 14986 //
     /* 1135021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1135032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1135035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1135038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1135041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135060 */     // MIs[0] round
     /* 1135060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135070 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1135073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135095 */     // GIR_Coverage, 14986,
     /* 1135095 */     GIR_EraseRootFromParent_Done,
     /* 1135096 */   // Label 16624: @1135096
     /* 1135096 */   GIM_Try, /*On fail goto*//*Label 16625*/ GIMT_Encode4(1135176), // Rule ID 14987 //
     /* 1135101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1135112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1135115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1135118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1135121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135140 */     // MIs[0] round
     /* 1135140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1135153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135175 */     // GIR_Coverage, 14987,
     /* 1135175 */     GIR_EraseRootFromParent_Done,
     /* 1135176 */   // Label 16625: @1135176
     /* 1135176 */   GIM_Try, /*On fail goto*//*Label 16626*/ GIMT_Encode4(1135256), // Rule ID 14990 //
     /* 1135181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1135192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1135195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1135198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1135201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135220 */     // MIs[0] round
     /* 1135220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135230 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1135233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135255 */     // GIR_Coverage, 14990,
     /* 1135255 */     GIR_EraseRootFromParent_Done,
     /* 1135256 */   // Label 16626: @1135256
     /* 1135256 */   GIM_Try, /*On fail goto*//*Label 16627*/ GIMT_Encode4(1135336), // Rule ID 14991 //
     /* 1135261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1135272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1135275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1135278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1135281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135300 */     // MIs[0] round
     /* 1135300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135310 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1135313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135335 */     // GIR_Coverage, 14991,
     /* 1135335 */     GIR_EraseRootFromParent_Done,
     /* 1135336 */   // Label 16627: @1135336
     /* 1135336 */   GIM_Try, /*On fail goto*//*Label 16628*/ GIMT_Encode4(1135416), // Rule ID 14994 //
     /* 1135341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1135352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1135355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1135358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1135361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135380 */     // MIs[0] round
     /* 1135380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135390 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1135393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135415 */     // GIR_Coverage, 14994,
     /* 1135415 */     GIR_EraseRootFromParent_Done,
     /* 1135416 */   // Label 16628: @1135416
     /* 1135416 */   GIM_Try, /*On fail goto*//*Label 16629*/ GIMT_Encode4(1135496), // Rule ID 14995 //
     /* 1135421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1135432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1135435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1135438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1135441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135460 */     // MIs[0] round
     /* 1135460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135470 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1135473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135495 */     // GIR_Coverage, 14995,
     /* 1135495 */     GIR_EraseRootFromParent_Done,
     /* 1135496 */   // Label 16629: @1135496
     /* 1135496 */   GIM_Try, /*On fail goto*//*Label 16630*/ GIMT_Encode4(1135576), // Rule ID 14998 //
     /* 1135501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1135512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1135515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1135518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1135521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135540 */     // MIs[0] round
     /* 1135540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135550 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1135553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135575 */     // GIR_Coverage, 14998,
     /* 1135575 */     GIR_EraseRootFromParent_Done,
     /* 1135576 */   // Label 16630: @1135576
     /* 1135576 */   GIM_Try, /*On fail goto*//*Label 16631*/ GIMT_Encode4(1135656), // Rule ID 14999 //
     /* 1135581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1135592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1135595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1135598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1135601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135620 */     // MIs[0] round
     /* 1135620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1135633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135655 */     // GIR_Coverage, 14999,
     /* 1135655 */     GIR_EraseRootFromParent_Done,
     /* 1135656 */   // Label 16631: @1135656
     /* 1135656 */   GIM_Try, /*On fail goto*//*Label 16632*/ GIMT_Encode4(1135736), // Rule ID 15002 //
     /* 1135661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1135672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1135675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1135678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1135681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135700 */     // MIs[0] round
     /* 1135700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135710 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1135713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135735 */     // GIR_Coverage, 15002,
     /* 1135735 */     GIR_EraseRootFromParent_Done,
     /* 1135736 */   // Label 16632: @1135736
     /* 1135736 */   GIM_Try, /*On fail goto*//*Label 16633*/ GIMT_Encode4(1135816), // Rule ID 15003 //
     /* 1135741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1135752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1135755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1135758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1135761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135780 */     // MIs[0] round
     /* 1135780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135790 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1135793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135815 */     // GIR_Coverage, 15003,
     /* 1135815 */     GIR_EraseRootFromParent_Done,
     /* 1135816 */   // Label 16633: @1135816
     /* 1135816 */   GIM_Try, /*On fail goto*//*Label 16634*/ GIMT_Encode4(1135896), // Rule ID 15006 //
     /* 1135821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1135832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1135835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1135838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1135841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135860 */     // MIs[0] round
     /* 1135860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135870 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1135873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135895 */     // GIR_Coverage, 15006,
     /* 1135895 */     GIR_EraseRootFromParent_Done,
     /* 1135896 */   // Label 16634: @1135896
     /* 1135896 */   GIM_Try, /*On fail goto*//*Label 16635*/ GIMT_Encode4(1135976), // Rule ID 15007 //
     /* 1135901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1135912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1135915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1135918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1135921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135940 */     // MIs[0] round
     /* 1135940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135950 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1135953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135975 */     // GIR_Coverage, 15007,
     /* 1135975 */     GIR_EraseRootFromParent_Done,
     /* 1135976 */   // Label 16635: @1135976
     /* 1135976 */   GIM_Try, /*On fail goto*//*Label 16636*/ GIMT_Encode4(1136056), // Rule ID 15010 //
     /* 1135981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1135992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1135995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1135998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1136001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136020 */     // MIs[0] round
     /* 1136020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136030 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1136033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136055 */     // GIR_Coverage, 15010,
     /* 1136055 */     GIR_EraseRootFromParent_Done,
     /* 1136056 */   // Label 16636: @1136056
     /* 1136056 */   GIM_Try, /*On fail goto*//*Label 16637*/ GIMT_Encode4(1136136), // Rule ID 15011 //
     /* 1136061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1136072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1136075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1136078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136100 */     // MIs[0] round
     /* 1136100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136110 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1136113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136135 */     // GIR_Coverage, 15011,
     /* 1136135 */     GIR_EraseRootFromParent_Done,
     /* 1136136 */   // Label 16637: @1136136
     /* 1136136 */   GIM_Try, /*On fail goto*//*Label 16638*/ GIMT_Encode4(1136216), // Rule ID 15014 //
     /* 1136141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1136152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1136155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1136158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1136161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136180 */     // MIs[0] round
     /* 1136180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136190 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1136193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136215 */     // GIR_Coverage, 15014,
     /* 1136215 */     GIR_EraseRootFromParent_Done,
     /* 1136216 */   // Label 16638: @1136216
     /* 1136216 */   GIM_Try, /*On fail goto*//*Label 16639*/ GIMT_Encode4(1136296), // Rule ID 15015 //
     /* 1136221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1136232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1136235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1136238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136260 */     // MIs[0] round
     /* 1136260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136270 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1136273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136295 */     // GIR_Coverage, 15015,
     /* 1136295 */     GIR_EraseRootFromParent_Done,
     /* 1136296 */   // Label 16639: @1136296
     /* 1136296 */   GIM_Try, /*On fail goto*//*Label 16640*/ GIMT_Encode4(1136376), // Rule ID 15018 //
     /* 1136301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1136312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1136315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1136318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1136321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136340 */     // MIs[0] round
     /* 1136340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136350 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1136353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136375 */     // GIR_Coverage, 15018,
     /* 1136375 */     GIR_EraseRootFromParent_Done,
     /* 1136376 */   // Label 16640: @1136376
     /* 1136376 */   GIM_Try, /*On fail goto*//*Label 16641*/ GIMT_Encode4(1136456), // Rule ID 15019 //
     /* 1136381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1136392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1136395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1136398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136420 */     // MIs[0] round
     /* 1136420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136430 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1136433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136455 */     // GIR_Coverage, 15019,
     /* 1136455 */     GIR_EraseRootFromParent_Done,
     /* 1136456 */   // Label 16641: @1136456
     /* 1136456 */   GIM_Try, /*On fail goto*//*Label 16642*/ GIMT_Encode4(1136536), // Rule ID 15022 //
     /* 1136461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1136472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1136475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1136478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1136481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136500 */     // MIs[0] round
     /* 1136500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136510 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1136513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136535 */     // GIR_Coverage, 15022,
     /* 1136535 */     GIR_EraseRootFromParent_Done,
     /* 1136536 */   // Label 16642: @1136536
     /* 1136536 */   GIM_Try, /*On fail goto*//*Label 16643*/ GIMT_Encode4(1136616), // Rule ID 15023 //
     /* 1136541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1136552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1136555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1136558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136580 */     // MIs[0] round
     /* 1136580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136590 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1136593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136615 */     // GIR_Coverage, 15023,
     /* 1136615 */     GIR_EraseRootFromParent_Done,
     /* 1136616 */   // Label 16643: @1136616
     /* 1136616 */   GIM_Try, /*On fail goto*//*Label 16644*/ GIMT_Encode4(1136696), // Rule ID 15026 //
     /* 1136621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1136632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1136635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1136638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1136641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136660 */     // MIs[0] round
     /* 1136660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136670 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1136673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136695 */     // GIR_Coverage, 15026,
     /* 1136695 */     GIR_EraseRootFromParent_Done,
     /* 1136696 */   // Label 16644: @1136696
     /* 1136696 */   GIM_Try, /*On fail goto*//*Label 16645*/ GIMT_Encode4(1136776), // Rule ID 15027 //
     /* 1136701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1136712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1136715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1136718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136740 */     // MIs[0] round
     /* 1136740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136750 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1136753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136775 */     // GIR_Coverage, 15027,
     /* 1136775 */     GIR_EraseRootFromParent_Done,
     /* 1136776 */   // Label 16645: @1136776
     /* 1136776 */   GIM_Try, /*On fail goto*//*Label 16646*/ GIMT_Encode4(1136856), // Rule ID 15030 //
     /* 1136781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1136792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1136795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1136798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1136801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136820 */     // MIs[0] round
     /* 1136820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136830 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1136833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1136851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136855 */     // GIR_Coverage, 15030,
     /* 1136855 */     GIR_EraseRootFromParent_Done,
     /* 1136856 */   // Label 16646: @1136856
     /* 1136856 */   GIM_Try, /*On fail goto*//*Label 16647*/ GIMT_Encode4(1136936), // Rule ID 15031 //
     /* 1136861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1136872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1136875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1136878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136900 */     // MIs[0] round
     /* 1136900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136910 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1136913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1136931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136935 */     // GIR_Coverage, 15031,
     /* 1136935 */     GIR_EraseRootFromParent_Done,
     /* 1136936 */   // Label 16647: @1136936
     /* 1136936 */   GIM_Try, /*On fail goto*//*Label 16648*/ GIMT_Encode4(1137016), // Rule ID 15034 //
     /* 1136941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1136952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1136955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1136958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1136961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136980 */     // MIs[0] round
     /* 1136980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136990 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1136993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137015 */     // GIR_Coverage, 15034,
     /* 1137015 */     GIR_EraseRootFromParent_Done,
     /* 1137016 */   // Label 16648: @1137016
     /* 1137016 */   GIM_Try, /*On fail goto*//*Label 16649*/ GIMT_Encode4(1137096), // Rule ID 15035 //
     /* 1137021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1137029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1137032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1137035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1137038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137060 */     // MIs[0] round
     /* 1137060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1137073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137095 */     // GIR_Coverage, 15035,
     /* 1137095 */     GIR_EraseRootFromParent_Done,
     /* 1137096 */   // Label 16649: @1137096
     /* 1137096 */   GIM_Try, /*On fail goto*//*Label 16650*/ GIMT_Encode4(1137176), // Rule ID 15038 //
     /* 1137101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1137109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1137112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1137115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1137118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1137121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137140 */     // MIs[0] round
     /* 1137140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137150 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1137153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137175 */     // GIR_Coverage, 15038,
     /* 1137175 */     GIR_EraseRootFromParent_Done,
     /* 1137176 */   // Label 16650: @1137176
     /* 1137176 */   GIM_Try, /*On fail goto*//*Label 16651*/ GIMT_Encode4(1137256), // Rule ID 15039 //
     /* 1137181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1137189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1137192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1137195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1137198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137220 */     // MIs[0] round
     /* 1137220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137230 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1137233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137255 */     // GIR_Coverage, 15039,
     /* 1137255 */     GIR_EraseRootFromParent_Done,
     /* 1137256 */   // Label 16651: @1137256
     /* 1137256 */   GIM_Try, /*On fail goto*//*Label 16652*/ GIMT_Encode4(1137336), // Rule ID 15042 //
     /* 1137261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1137269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1137272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1137275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1137278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1137281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137300 */     // MIs[0] round
     /* 1137300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137310 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1137313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137335 */     // GIR_Coverage, 15042,
     /* 1137335 */     GIR_EraseRootFromParent_Done,
     /* 1137336 */   // Label 16652: @1137336
     /* 1137336 */   GIM_Try, /*On fail goto*//*Label 16653*/ GIMT_Encode4(1137416), // Rule ID 15043 //
     /* 1137341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1137349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1137352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1137355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1137358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137380 */     // MIs[0] round
     /* 1137380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1137393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137415 */     // GIR_Coverage, 15043,
     /* 1137415 */     GIR_EraseRootFromParent_Done,
     /* 1137416 */   // Label 16653: @1137416
     /* 1137416 */   GIM_Try, /*On fail goto*//*Label 16654*/ GIMT_Encode4(1137496), // Rule ID 15046 //
     /* 1137421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1137424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1137429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1137432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1137435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1137438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1137441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137460 */     // MIs[0] round
     /* 1137460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1137473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137495 */     // GIR_Coverage, 15046,
     /* 1137495 */     GIR_EraseRootFromParent_Done,
     /* 1137496 */   // Label 16654: @1137496
     /* 1137496 */   GIM_Try, /*On fail goto*//*Label 16655*/ GIMT_Encode4(1137576), // Rule ID 15047 //
     /* 1137501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1137504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1137509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1137512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1137515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1137518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137540 */     // MIs[0] round
     /* 1137540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137550 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1137553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137575 */     // GIR_Coverage, 15047,
     /* 1137575 */     GIR_EraseRootFromParent_Done,
     /* 1137576 */   // Label 16655: @1137576
     /* 1137576 */   GIM_Try, /*On fail goto*//*Label 16656*/ GIMT_Encode4(1137656), // Rule ID 15050 //
     /* 1137581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1137589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1137592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1137595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1137598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1137601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137620 */     // MIs[0] round
     /* 1137620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137630 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1137633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137655 */     // GIR_Coverage, 15050,
     /* 1137655 */     GIR_EraseRootFromParent_Done,
     /* 1137656 */   // Label 16656: @1137656
     /* 1137656 */   GIM_Try, /*On fail goto*//*Label 16657*/ GIMT_Encode4(1137736), // Rule ID 15051 //
     /* 1137661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1137669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1137672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1137675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1137678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137700 */     // MIs[0] round
     /* 1137700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137710 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1137713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137735 */     // GIR_Coverage, 15051,
     /* 1137735 */     GIR_EraseRootFromParent_Done,
     /* 1137736 */   // Label 16657: @1137736
     /* 1137736 */   GIM_Try, /*On fail goto*//*Label 16658*/ GIMT_Encode4(1137816), // Rule ID 15054 //
     /* 1137741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1137749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1137752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1137755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1137758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1137761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137780 */     // MIs[0] round
     /* 1137780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137790 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1137793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137815 */     // GIR_Coverage, 15054,
     /* 1137815 */     GIR_EraseRootFromParent_Done,
     /* 1137816 */   // Label 16658: @1137816
     /* 1137816 */   GIM_Try, /*On fail goto*//*Label 16659*/ GIMT_Encode4(1137896), // Rule ID 15055 //
     /* 1137821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1137829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1137832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1137835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1137838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137860 */     // MIs[0] round
     /* 1137860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1137873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137895 */     // GIR_Coverage, 15055,
     /* 1137895 */     GIR_EraseRootFromParent_Done,
     /* 1137896 */   // Label 16659: @1137896
     /* 1137896 */   GIM_Try, /*On fail goto*//*Label 16660*/ GIMT_Encode4(1137976), // Rule ID 15058 //
     /* 1137901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1137909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1137912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1137915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1137918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1137921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137940 */     // MIs[0] round
     /* 1137940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137950 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1137953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137975 */     // GIR_Coverage, 15058,
     /* 1137975 */     GIR_EraseRootFromParent_Done,
     /* 1137976 */   // Label 16660: @1137976
     /* 1137976 */   GIM_Try, /*On fail goto*//*Label 16661*/ GIMT_Encode4(1138056), // Rule ID 15059 //
     /* 1137981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1137989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1137992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1137995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1137998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1138001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138020 */     // MIs[0] round
     /* 1138020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138030 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1138033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138055 */     // GIR_Coverage, 15059,
     /* 1138055 */     GIR_EraseRootFromParent_Done,
     /* 1138056 */   // Label 16661: @1138056
     /* 1138056 */   GIM_Try, /*On fail goto*//*Label 16662*/ GIMT_Encode4(1138136), // Rule ID 15062 //
     /* 1138061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1138069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1138072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1138075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1138078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1138081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138100 */     // MIs[0] round
     /* 1138100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138110 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1138113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138135 */     // GIR_Coverage, 15062,
     /* 1138135 */     GIR_EraseRootFromParent_Done,
     /* 1138136 */   // Label 16662: @1138136
     /* 1138136 */   GIM_Try, /*On fail goto*//*Label 16663*/ GIMT_Encode4(1138216), // Rule ID 15063 //
     /* 1138141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1138149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1138152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1138155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1138158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1138161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138180 */     // MIs[0] round
     /* 1138180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1138193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138215 */     // GIR_Coverage, 15063,
     /* 1138215 */     GIR_EraseRootFromParent_Done,
     /* 1138216 */   // Label 16663: @1138216
     /* 1138216 */   GIM_Try, /*On fail goto*//*Label 16664*/ GIMT_Encode4(1138296), // Rule ID 15066 //
     /* 1138221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1138229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1138232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1138235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1138238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1138241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138260 */     // MIs[0] round
     /* 1138260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138270 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1138273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138295 */     // GIR_Coverage, 15066,
     /* 1138295 */     GIR_EraseRootFromParent_Done,
     /* 1138296 */   // Label 16664: @1138296
     /* 1138296 */   GIM_Try, /*On fail goto*//*Label 16665*/ GIMT_Encode4(1138376), // Rule ID 15067 //
     /* 1138301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1138309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1138312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1138315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1138318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1138321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138340 */     // MIs[0] round
     /* 1138340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1138353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138375 */     // GIR_Coverage, 15067,
     /* 1138375 */     GIR_EraseRootFromParent_Done,
     /* 1138376 */   // Label 16665: @1138376
     /* 1138376 */   GIM_Try, /*On fail goto*//*Label 16666*/ GIMT_Encode4(1138456), // Rule ID 15070 //
     /* 1138381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1138389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1138392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1138395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1138398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1138401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138420 */     // MIs[0] round
     /* 1138420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138430 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1138433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138455 */     // GIR_Coverage, 15070,
     /* 1138455 */     GIR_EraseRootFromParent_Done,
     /* 1138456 */   // Label 16666: @1138456
     /* 1138456 */   GIM_Try, /*On fail goto*//*Label 16667*/ GIMT_Encode4(1138536), // Rule ID 15071 //
     /* 1138461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1138469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1138472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1138475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1138478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1138481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138500 */     // MIs[0] round
     /* 1138500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138510 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1138513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138535 */     // GIR_Coverage, 15071,
     /* 1138535 */     GIR_EraseRootFromParent_Done,
     /* 1138536 */   // Label 16667: @1138536
     /* 1138536 */   GIM_Try, /*On fail goto*//*Label 16668*/ GIMT_Encode4(1138616), // Rule ID 15074 //
     /* 1138541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1138549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1138552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1138555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1138558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1138561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138580 */     // MIs[0] round
     /* 1138580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138590 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1138593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138615 */     // GIR_Coverage, 15074,
     /* 1138615 */     GIR_EraseRootFromParent_Done,
     /* 1138616 */   // Label 16668: @1138616
     /* 1138616 */   GIM_Try, /*On fail goto*//*Label 16669*/ GIMT_Encode4(1138696), // Rule ID 15075 //
     /* 1138621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1138629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1138632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1138635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1138638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1138641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138660 */     // MIs[0] round
     /* 1138660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1138673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138695 */     // GIR_Coverage, 15075,
     /* 1138695 */     GIR_EraseRootFromParent_Done,
     /* 1138696 */   // Label 16669: @1138696
     /* 1138696 */   GIM_Try, /*On fail goto*//*Label 16670*/ GIMT_Encode4(1138776), // Rule ID 15078 //
     /* 1138701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1138709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1138712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1138715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1138718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1138721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138740 */     // MIs[0] round
     /* 1138740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138750 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1138753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138775 */     // GIR_Coverage, 15078,
     /* 1138775 */     GIR_EraseRootFromParent_Done,
     /* 1138776 */   // Label 16670: @1138776
     /* 1138776 */   GIM_Try, /*On fail goto*//*Label 16671*/ GIMT_Encode4(1138856), // Rule ID 15079 //
     /* 1138781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1138789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1138792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1138795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1138798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1138801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138820 */     // MIs[0] round
     /* 1138820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138830 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1138833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138855 */     // GIR_Coverage, 15079,
     /* 1138855 */     GIR_EraseRootFromParent_Done,
     /* 1138856 */   // Label 16671: @1138856
     /* 1138856 */   GIM_Try, /*On fail goto*//*Label 16672*/ GIMT_Encode4(1138936), // Rule ID 15082 //
     /* 1138861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1138869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1138872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1138875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1138878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1138881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138900 */     // MIs[0] round
     /* 1138900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138910 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1138913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138935 */     // GIR_Coverage, 15082,
     /* 1138935 */     GIR_EraseRootFromParent_Done,
     /* 1138936 */   // Label 16672: @1138936
     /* 1138936 */   GIM_Try, /*On fail goto*//*Label 16673*/ GIMT_Encode4(1139016), // Rule ID 15083 //
     /* 1138941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1138949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1138952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1138955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1138958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1138961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138980 */     // MIs[0] round
     /* 1138980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138990 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1138993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1139011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139015 */     // GIR_Coverage, 15083,
     /* 1139015 */     GIR_EraseRootFromParent_Done,
     /* 1139016 */   // Label 16673: @1139016
     /* 1139016 */   GIM_Try, /*On fail goto*//*Label 16674*/ GIMT_Encode4(1139096), // Rule ID 15086 //
     /* 1139021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1139024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1139029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1139032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1139035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1139038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139060 */     // MIs[0] round
     /* 1139060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139070 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1139073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139095 */     // GIR_Coverage, 15086,
     /* 1139095 */     GIR_EraseRootFromParent_Done,
     /* 1139096 */   // Label 16674: @1139096
     /* 1139096 */   GIM_Try, /*On fail goto*//*Label 16675*/ GIMT_Encode4(1139176), // Rule ID 15087 //
     /* 1139101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1139104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1139109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1139112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1139115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1139118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139140 */     // MIs[0] round
     /* 1139140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139150 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1139153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139175 */     // GIR_Coverage, 15087,
     /* 1139175 */     GIR_EraseRootFromParent_Done,
     /* 1139176 */   // Label 16675: @1139176
     /* 1139176 */   GIM_Try, /*On fail goto*//*Label 16676*/ GIMT_Encode4(1139256), // Rule ID 15090 //
     /* 1139181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1139184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1139189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1139192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1139195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1139198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139220 */     // MIs[0] round
     /* 1139220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139230 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1139233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139255 */     // GIR_Coverage, 15090,
     /* 1139255 */     GIR_EraseRootFromParent_Done,
     /* 1139256 */   // Label 16676: @1139256
     /* 1139256 */   GIM_Try, /*On fail goto*//*Label 16677*/ GIMT_Encode4(1139336), // Rule ID 15091 //
     /* 1139261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1139264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1139269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1139272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1139275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1139278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139300 */     // MIs[0] round
     /* 1139300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139310 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1139313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139335 */     // GIR_Coverage, 15091,
     /* 1139335 */     GIR_EraseRootFromParent_Done,
     /* 1139336 */   // Label 16677: @1139336
     /* 1139336 */   GIM_Try, /*On fail goto*//*Label 16678*/ GIMT_Encode4(1139416), // Rule ID 15094 //
     /* 1139341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1139344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1139349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1139352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1139355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1139358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139380 */     // MIs[0] round
     /* 1139380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139390 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1139393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139415 */     // GIR_Coverage, 15094,
     /* 1139415 */     GIR_EraseRootFromParent_Done,
     /* 1139416 */   // Label 16678: @1139416
     /* 1139416 */   GIM_Try, /*On fail goto*//*Label 16679*/ GIMT_Encode4(1139496), // Rule ID 15095 //
     /* 1139421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1139424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1139429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1139432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1139435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1139438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139460 */     // MIs[0] round
     /* 1139460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139470 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1139473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139495 */     // GIR_Coverage, 15095,
     /* 1139495 */     GIR_EraseRootFromParent_Done,
     /* 1139496 */   // Label 16679: @1139496
     /* 1139496 */   GIM_Try, /*On fail goto*//*Label 16680*/ GIMT_Encode4(1139576), // Rule ID 15098 //
     /* 1139501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1139512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1139515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1139518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1139521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139540 */     // MIs[0] round
     /* 1139540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139550 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1139553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139575 */     // GIR_Coverage, 15098,
     /* 1139575 */     GIR_EraseRootFromParent_Done,
     /* 1139576 */   // Label 16680: @1139576
     /* 1139576 */   GIM_Try, /*On fail goto*//*Label 16681*/ GIMT_Encode4(1139656), // Rule ID 15099 //
     /* 1139581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1139592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1139595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1139598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1139601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139620 */     // MIs[0] round
     /* 1139620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139630 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1139633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139655 */     // GIR_Coverage, 15099,
     /* 1139655 */     GIR_EraseRootFromParent_Done,
     /* 1139656 */   // Label 16681: @1139656
     /* 1139656 */   GIM_Try, /*On fail goto*//*Label 16682*/ GIMT_Encode4(1139736), // Rule ID 15102 //
     /* 1139661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1139672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1139675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1139678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1139681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139700 */     // MIs[0] round
     /* 1139700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139710 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1139713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139735 */     // GIR_Coverage, 15102,
     /* 1139735 */     GIR_EraseRootFromParent_Done,
     /* 1139736 */   // Label 16682: @1139736
     /* 1139736 */   GIM_Try, /*On fail goto*//*Label 16683*/ GIMT_Encode4(1139816), // Rule ID 15103 //
     /* 1139741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1139752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1139755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1139758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1139761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139780 */     // MIs[0] round
     /* 1139780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139790 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1139793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139815 */     // GIR_Coverage, 15103,
     /* 1139815 */     GIR_EraseRootFromParent_Done,
     /* 1139816 */   // Label 16683: @1139816
     /* 1139816 */   GIM_Try, /*On fail goto*//*Label 16684*/ GIMT_Encode4(1139896), // Rule ID 15106 //
     /* 1139821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1139832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1139835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1139838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1139841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139860 */     // MIs[0] round
     /* 1139860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139870 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1139873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139895 */     // GIR_Coverage, 15106,
     /* 1139895 */     GIR_EraseRootFromParent_Done,
     /* 1139896 */   // Label 16684: @1139896
     /* 1139896 */   GIM_Try, /*On fail goto*//*Label 16685*/ GIMT_Encode4(1139976), // Rule ID 15107 //
     /* 1139901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1139912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1139915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1139918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1139921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139940 */     // MIs[0] round
     /* 1139940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139950 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1139953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139975 */     // GIR_Coverage, 15107,
     /* 1139975 */     GIR_EraseRootFromParent_Done,
     /* 1139976 */   // Label 16685: @1139976
     /* 1139976 */   GIM_Try, /*On fail goto*//*Label 16686*/ GIMT_Encode4(1140056), // Rule ID 15110 //
     /* 1139981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1139992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1139995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1139998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1140001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140020 */     // MIs[0] round
     /* 1140020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140030 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1140033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140055 */     // GIR_Coverage, 15110,
     /* 1140055 */     GIR_EraseRootFromParent_Done,
     /* 1140056 */   // Label 16686: @1140056
     /* 1140056 */   GIM_Try, /*On fail goto*//*Label 16687*/ GIMT_Encode4(1140136), // Rule ID 15111 //
     /* 1140061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1140072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1140075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1140078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1140081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140100 */     // MIs[0] round
     /* 1140100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140110 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1140113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140135 */     // GIR_Coverage, 15111,
     /* 1140135 */     GIR_EraseRootFromParent_Done,
     /* 1140136 */   // Label 16687: @1140136
     /* 1140136 */   GIM_Try, /*On fail goto*//*Label 16688*/ GIMT_Encode4(1140216), // Rule ID 15114 //
     /* 1140141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1140152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1140155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1140158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1140161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140180 */     // MIs[0] round
     /* 1140180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140190 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1140193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140215 */     // GIR_Coverage, 15114,
     /* 1140215 */     GIR_EraseRootFromParent_Done,
     /* 1140216 */   // Label 16688: @1140216
     /* 1140216 */   GIM_Try, /*On fail goto*//*Label 16689*/ GIMT_Encode4(1140296), // Rule ID 15115 //
     /* 1140221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1140232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1140235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1140238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1140241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140260 */     // MIs[0] round
     /* 1140260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140270 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1140273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140295 */     // GIR_Coverage, 15115,
     /* 1140295 */     GIR_EraseRootFromParent_Done,
     /* 1140296 */   // Label 16689: @1140296
     /* 1140296 */   GIM_Try, /*On fail goto*//*Label 16690*/ GIMT_Encode4(1140376), // Rule ID 15118 //
     /* 1140301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1140312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1140315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1140318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1140321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140340 */     // MIs[0] round
     /* 1140340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140350 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1140353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140375 */     // GIR_Coverage, 15118,
     /* 1140375 */     GIR_EraseRootFromParent_Done,
     /* 1140376 */   // Label 16690: @1140376
     /* 1140376 */   GIM_Try, /*On fail goto*//*Label 16691*/ GIMT_Encode4(1140456), // Rule ID 15119 //
     /* 1140381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1140392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1140395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1140398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1140401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140420 */     // MIs[0] round
     /* 1140420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140430 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1140433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140455 */     // GIR_Coverage, 15119,
     /* 1140455 */     GIR_EraseRootFromParent_Done,
     /* 1140456 */   // Label 16691: @1140456
     /* 1140456 */   GIM_Try, /*On fail goto*//*Label 16692*/ GIMT_Encode4(1140536), // Rule ID 15122 //
     /* 1140461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1140472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1140475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1140478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1140481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140500 */     // MIs[0] round
     /* 1140500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140510 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1140513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140535 */     // GIR_Coverage, 15122,
     /* 1140535 */     GIR_EraseRootFromParent_Done,
     /* 1140536 */   // Label 16692: @1140536
     /* 1140536 */   GIM_Try, /*On fail goto*//*Label 16693*/ GIMT_Encode4(1140616), // Rule ID 15123 //
     /* 1140541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1140552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1140555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1140558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1140561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140580 */     // MIs[0] round
     /* 1140580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140590 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1140593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140615 */     // GIR_Coverage, 15123,
     /* 1140615 */     GIR_EraseRootFromParent_Done,
     /* 1140616 */   // Label 16693: @1140616
     /* 1140616 */   GIM_Try, /*On fail goto*//*Label 16694*/ GIMT_Encode4(1140696), // Rule ID 15126 //
     /* 1140621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1140632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1140635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1140638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1140641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140660 */     // MIs[0] round
     /* 1140660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140670 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1140673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140695 */     // GIR_Coverage, 15126,
     /* 1140695 */     GIR_EraseRootFromParent_Done,
     /* 1140696 */   // Label 16694: @1140696
     /* 1140696 */   GIM_Try, /*On fail goto*//*Label 16695*/ GIMT_Encode4(1140776), // Rule ID 15127 //
     /* 1140701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1140712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1140715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1140718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1140721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140740 */     // MIs[0] round
     /* 1140740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1140753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140775 */     // GIR_Coverage, 15127,
     /* 1140775 */     GIR_EraseRootFromParent_Done,
     /* 1140776 */   // Label 16695: @1140776
     /* 1140776 */   GIM_Try, /*On fail goto*//*Label 16696*/ GIMT_Encode4(1140856), // Rule ID 15130 //
     /* 1140781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1140792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1140795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1140798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1140801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140820 */     // MIs[0] round
     /* 1140820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1140833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140855 */     // GIR_Coverage, 15130,
     /* 1140855 */     GIR_EraseRootFromParent_Done,
     /* 1140856 */   // Label 16696: @1140856
     /* 1140856 */   GIM_Try, /*On fail goto*//*Label 16697*/ GIMT_Encode4(1140936), // Rule ID 15131 //
     /* 1140861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1140872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1140875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1140878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1140881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140900 */     // MIs[0] round
     /* 1140900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140910 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1140913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140935 */     // GIR_Coverage, 15131,
     /* 1140935 */     GIR_EraseRootFromParent_Done,
     /* 1140936 */   // Label 16697: @1140936
     /* 1140936 */   GIM_Try, /*On fail goto*//*Label 16698*/ GIMT_Encode4(1141016), // Rule ID 15134 //
     /* 1140941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1140944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1140952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1140955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1140958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1140961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140980 */     // MIs[0] round
     /* 1140980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140990 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1140993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141015 */     // GIR_Coverage, 15134,
     /* 1141015 */     GIR_EraseRootFromParent_Done,
     /* 1141016 */   // Label 16698: @1141016
     /* 1141016 */   GIM_Try, /*On fail goto*//*Label 16699*/ GIMT_Encode4(1141096), // Rule ID 15135 //
     /* 1141021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1141024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1141032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1141035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1141038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1141041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141060 */     // MIs[0] round
     /* 1141060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141070 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1141073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141095 */     // GIR_Coverage, 15135,
     /* 1141095 */     GIR_EraseRootFromParent_Done,
     /* 1141096 */   // Label 16699: @1141096
     /* 1141096 */   GIM_Try, /*On fail goto*//*Label 16700*/ GIMT_Encode4(1141176), // Rule ID 15138 //
     /* 1141101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1141112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1141115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1141118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1141121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141140 */     // MIs[0] round
     /* 1141140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141150 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1141153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141175 */     // GIR_Coverage, 15138,
     /* 1141175 */     GIR_EraseRootFromParent_Done,
     /* 1141176 */   // Label 16700: @1141176
     /* 1141176 */   GIM_Try, /*On fail goto*//*Label 16701*/ GIMT_Encode4(1141256), // Rule ID 15139 //
     /* 1141181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1141192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1141195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1141198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1141201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141220 */     // MIs[0] round
     /* 1141220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1141233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141255 */     // GIR_Coverage, 15139,
     /* 1141255 */     GIR_EraseRootFromParent_Done,
     /* 1141256 */   // Label 16701: @1141256
     /* 1141256 */   GIM_Try, /*On fail goto*//*Label 16702*/ GIMT_Encode4(1141336), // Rule ID 15142 //
     /* 1141261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1141272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1141275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1141278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1141281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141300 */     // MIs[0] round
     /* 1141300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141310 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1141313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141335 */     // GIR_Coverage, 15142,
     /* 1141335 */     GIR_EraseRootFromParent_Done,
     /* 1141336 */   // Label 16702: @1141336
     /* 1141336 */   GIM_Try, /*On fail goto*//*Label 16703*/ GIMT_Encode4(1141416), // Rule ID 15143 //
     /* 1141341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1141352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1141355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1141358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1141361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141380 */     // MIs[0] round
     /* 1141380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141390 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1141393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141415 */     // GIR_Coverage, 15143,
     /* 1141415 */     GIR_EraseRootFromParent_Done,
     /* 1141416 */   // Label 16703: @1141416
     /* 1141416 */   GIM_Try, /*On fail goto*//*Label 16704*/ GIMT_Encode4(1141496), // Rule ID 15146 //
     /* 1141421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1141432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1141435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1141438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1141441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141460 */     // MIs[0] round
     /* 1141460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141470 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1141473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141495 */     // GIR_Coverage, 15146,
     /* 1141495 */     GIR_EraseRootFromParent_Done,
     /* 1141496 */   // Label 16704: @1141496
     /* 1141496 */   GIM_Try, /*On fail goto*//*Label 16705*/ GIMT_Encode4(1141576), // Rule ID 15147 //
     /* 1141501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1141512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1141515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1141518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1141521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141540 */     // MIs[0] round
     /* 1141540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141550 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1141553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141575 */     // GIR_Coverage, 15147,
     /* 1141575 */     GIR_EraseRootFromParent_Done,
     /* 1141576 */   // Label 16705: @1141576
     /* 1141576 */   GIM_Try, /*On fail goto*//*Label 16706*/ GIMT_Encode4(1141656), // Rule ID 15150 //
     /* 1141581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1141592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1141595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1141598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1141601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141620 */     // MIs[0] round
     /* 1141620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1141633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141655 */     // GIR_Coverage, 15150,
     /* 1141655 */     GIR_EraseRootFromParent_Done,
     /* 1141656 */   // Label 16706: @1141656
     /* 1141656 */   GIM_Try, /*On fail goto*//*Label 16707*/ GIMT_Encode4(1141736), // Rule ID 15151 //
     /* 1141661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1141672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1141675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1141678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1141681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141700 */     // MIs[0] round
     /* 1141700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141710 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1141713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141735 */     // GIR_Coverage, 15151,
     /* 1141735 */     GIR_EraseRootFromParent_Done,
     /* 1141736 */   // Label 16707: @1141736
     /* 1141736 */   GIM_Try, /*On fail goto*//*Label 16708*/ GIMT_Encode4(1141816), // Rule ID 15154 //
     /* 1141741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1141752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1141755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1141758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1141761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141780 */     // MIs[0] round
     /* 1141780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141790 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1141793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141815 */     // GIR_Coverage, 15154,
     /* 1141815 */     GIR_EraseRootFromParent_Done,
     /* 1141816 */   // Label 16708: @1141816
     /* 1141816 */   GIM_Try, /*On fail goto*//*Label 16709*/ GIMT_Encode4(1141896), // Rule ID 15155 //
     /* 1141821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1141832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1141835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1141838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1141841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141860 */     // MIs[0] round
     /* 1141860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141870 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1141873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141895 */     // GIR_Coverage, 15155,
     /* 1141895 */     GIR_EraseRootFromParent_Done,
     /* 1141896 */   // Label 16709: @1141896
     /* 1141896 */   GIM_Try, /*On fail goto*//*Label 16710*/ GIMT_Encode4(1141976), // Rule ID 15158 //
     /* 1141901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1141912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1141915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1141918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1141921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141940 */     // MIs[0] round
     /* 1141940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141950 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1141953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141975 */     // GIR_Coverage, 15158,
     /* 1141975 */     GIR_EraseRootFromParent_Done,
     /* 1141976 */   // Label 16710: @1141976
     /* 1141976 */   GIM_Try, /*On fail goto*//*Label 16711*/ GIMT_Encode4(1142056), // Rule ID 15159 //
     /* 1141981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1141992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1141995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1141998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1142001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142020 */     // MIs[0] round
     /* 1142020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142030 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1142033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142055 */     // GIR_Coverage, 15159,
     /* 1142055 */     GIR_EraseRootFromParent_Done,
     /* 1142056 */   // Label 16711: @1142056
     /* 1142056 */   GIM_Try, /*On fail goto*//*Label 16712*/ GIMT_Encode4(1142136), // Rule ID 15162 //
     /* 1142061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1142072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1142075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1142078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1142081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142100 */     // MIs[0] round
     /* 1142100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1142113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142135 */     // GIR_Coverage, 15162,
     /* 1142135 */     GIR_EraseRootFromParent_Done,
     /* 1142136 */   // Label 16712: @1142136
     /* 1142136 */   GIM_Try, /*On fail goto*//*Label 16713*/ GIMT_Encode4(1142216), // Rule ID 15163 //
     /* 1142141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1142152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1142155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1142158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1142161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142180 */     // MIs[0] round
     /* 1142180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1142193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142215 */     // GIR_Coverage, 15163,
     /* 1142215 */     GIR_EraseRootFromParent_Done,
     /* 1142216 */   // Label 16713: @1142216
     /* 1142216 */   GIM_Try, /*On fail goto*//*Label 16714*/ GIMT_Encode4(1142296), // Rule ID 15166 //
     /* 1142221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1142232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1142235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1142238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1142241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142260 */     // MIs[0] round
     /* 1142260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142270 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1142273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142295 */     // GIR_Coverage, 15166,
     /* 1142295 */     GIR_EraseRootFromParent_Done,
     /* 1142296 */   // Label 16714: @1142296
     /* 1142296 */   GIM_Try, /*On fail goto*//*Label 16715*/ GIMT_Encode4(1142376), // Rule ID 15167 //
     /* 1142301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1142312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1142315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1142318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1142321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142340 */     // MIs[0] round
     /* 1142340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142350 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1142353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142375 */     // GIR_Coverage, 15167,
     /* 1142375 */     GIR_EraseRootFromParent_Done,
     /* 1142376 */   // Label 16715: @1142376
     /* 1142376 */   GIM_Try, /*On fail goto*//*Label 16716*/ GIMT_Encode4(1142456), // Rule ID 15170 //
     /* 1142381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1142392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1142395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1142398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1142401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142420 */     // MIs[0] round
     /* 1142420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142430 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1142433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142455 */     // GIR_Coverage, 15170,
     /* 1142455 */     GIR_EraseRootFromParent_Done,
     /* 1142456 */   // Label 16716: @1142456
     /* 1142456 */   GIM_Try, /*On fail goto*//*Label 16717*/ GIMT_Encode4(1142536), // Rule ID 15171 //
     /* 1142461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1142472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1142475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1142478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1142481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142500 */     // MIs[0] round
     /* 1142500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142510 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1142513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142535 */     // GIR_Coverage, 15171,
     /* 1142535 */     GIR_EraseRootFromParent_Done,
     /* 1142536 */   // Label 16717: @1142536
     /* 1142536 */   GIM_Try, /*On fail goto*//*Label 16718*/ GIMT_Encode4(1142616), // Rule ID 15174 //
     /* 1142541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1142552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1142555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1142558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1142561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142580 */     // MIs[0] round
     /* 1142580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1142593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142615 */     // GIR_Coverage, 15174,
     /* 1142615 */     GIR_EraseRootFromParent_Done,
     /* 1142616 */   // Label 16718: @1142616
     /* 1142616 */   GIM_Try, /*On fail goto*//*Label 16719*/ GIMT_Encode4(1142696), // Rule ID 15175 //
     /* 1142621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1142632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1142635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1142638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1142641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142660 */     // MIs[0] round
     /* 1142660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1142673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142695 */     // GIR_Coverage, 15175,
     /* 1142695 */     GIR_EraseRootFromParent_Done,
     /* 1142696 */   // Label 16719: @1142696
     /* 1142696 */   GIM_Try, /*On fail goto*//*Label 16720*/ GIMT_Encode4(1142776), // Rule ID 15178 //
     /* 1142701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1142712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1142715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1142718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1142721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142740 */     // MIs[0] round
     /* 1142740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142750 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1142753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142775 */     // GIR_Coverage, 15178,
     /* 1142775 */     GIR_EraseRootFromParent_Done,
     /* 1142776 */   // Label 16720: @1142776
     /* 1142776 */   GIM_Try, /*On fail goto*//*Label 16721*/ GIMT_Encode4(1142856), // Rule ID 15179 //
     /* 1142781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1142792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1142795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1142798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1142801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142820 */     // MIs[0] round
     /* 1142820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142830 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1142833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142855 */     // GIR_Coverage, 15179,
     /* 1142855 */     GIR_EraseRootFromParent_Done,
     /* 1142856 */   // Label 16721: @1142856
     /* 1142856 */   GIM_Try, /*On fail goto*//*Label 16722*/ GIMT_Encode4(1142936), // Rule ID 15182 //
     /* 1142861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1142872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1142875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1142878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1142881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142900 */     // MIs[0] round
     /* 1142900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142910 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1142913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142935 */     // GIR_Coverage, 15182,
     /* 1142935 */     GIR_EraseRootFromParent_Done,
     /* 1142936 */   // Label 16722: @1142936
     /* 1142936 */   GIM_Try, /*On fail goto*//*Label 16723*/ GIMT_Encode4(1143016), // Rule ID 15183 //
     /* 1142941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1142952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1142955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1142958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1142961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142980 */     // MIs[0] round
     /* 1142980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142990 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1142993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1143011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143015 */     // GIR_Coverage, 15183,
     /* 1143015 */     GIR_EraseRootFromParent_Done,
     /* 1143016 */   // Label 16723: @1143016
     /* 1143016 */   GIM_Try, /*On fail goto*//*Label 16724*/ GIMT_Encode4(1143096), // Rule ID 15186 //
     /* 1143021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1143032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1143035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1143038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143060 */     // MIs[0] round
     /* 1143060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143070 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1143073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143095 */     // GIR_Coverage, 15186,
     /* 1143095 */     GIR_EraseRootFromParent_Done,
     /* 1143096 */   // Label 16724: @1143096
     /* 1143096 */   GIM_Try, /*On fail goto*//*Label 16725*/ GIMT_Encode4(1143176), // Rule ID 15187 //
     /* 1143101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1143112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1143115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1143118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143140 */     // MIs[0] round
     /* 1143140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143150 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1143153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143175 */     // GIR_Coverage, 15187,
     /* 1143175 */     GIR_EraseRootFromParent_Done,
     /* 1143176 */   // Label 16725: @1143176
     /* 1143176 */   GIM_Try, /*On fail goto*//*Label 16726*/ GIMT_Encode4(1143256), // Rule ID 15190 //
     /* 1143181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1143192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1143195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1143198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143220 */     // MIs[0] round
     /* 1143220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143230 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1143233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143255 */     // GIR_Coverage, 15190,
     /* 1143255 */     GIR_EraseRootFromParent_Done,
     /* 1143256 */   // Label 16726: @1143256
     /* 1143256 */   GIM_Try, /*On fail goto*//*Label 16727*/ GIMT_Encode4(1143336), // Rule ID 15191 //
     /* 1143261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1143272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1143275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1143278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143300 */     // MIs[0] round
     /* 1143300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143310 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1143313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143335 */     // GIR_Coverage, 15191,
     /* 1143335 */     GIR_EraseRootFromParent_Done,
     /* 1143336 */   // Label 16727: @1143336
     /* 1143336 */   GIM_Try, /*On fail goto*//*Label 16728*/ GIMT_Encode4(1143416), // Rule ID 15194 //
     /* 1143341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1143352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1143355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1143358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143380 */     // MIs[0] round
     /* 1143380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143390 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1143393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143415 */     // GIR_Coverage, 15194,
     /* 1143415 */     GIR_EraseRootFromParent_Done,
     /* 1143416 */   // Label 16728: @1143416
     /* 1143416 */   GIM_Try, /*On fail goto*//*Label 16729*/ GIMT_Encode4(1143496), // Rule ID 15195 //
     /* 1143421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1143432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1143435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1143438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143460 */     // MIs[0] round
     /* 1143460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143470 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1143473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143495 */     // GIR_Coverage, 15195,
     /* 1143495 */     GIR_EraseRootFromParent_Done,
     /* 1143496 */   // Label 16729: @1143496
     /* 1143496 */   GIM_Try, /*On fail goto*//*Label 16730*/ GIMT_Encode4(1143576), // Rule ID 15198 //
     /* 1143501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1143512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1143515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1143518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143540 */     // MIs[0] round
     /* 1143540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143550 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1143553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143575 */     // GIR_Coverage, 15198,
     /* 1143575 */     GIR_EraseRootFromParent_Done,
     /* 1143576 */   // Label 16730: @1143576
     /* 1143576 */   GIM_Try, /*On fail goto*//*Label 16731*/ GIMT_Encode4(1143656), // Rule ID 15199 //
     /* 1143581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1143592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1143595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1143598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143620 */     // MIs[0] round
     /* 1143620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1143633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143655 */     // GIR_Coverage, 15199,
     /* 1143655 */     GIR_EraseRootFromParent_Done,
     /* 1143656 */   // Label 16731: @1143656
     /* 1143656 */   GIM_Try, /*On fail goto*//*Label 16732*/ GIMT_Encode4(1143736), // Rule ID 15202 //
     /* 1143661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1143672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1143675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1143678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143700 */     // MIs[0] round
     /* 1143700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143710 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1143713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143735 */     // GIR_Coverage, 15202,
     /* 1143735 */     GIR_EraseRootFromParent_Done,
     /* 1143736 */   // Label 16732: @1143736
     /* 1143736 */   GIM_Try, /*On fail goto*//*Label 16733*/ GIMT_Encode4(1143816), // Rule ID 15203 //
     /* 1143741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1143752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1143755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1143758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143780 */     // MIs[0] round
     /* 1143780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143790 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1143793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143815 */     // GIR_Coverage, 15203,
     /* 1143815 */     GIR_EraseRootFromParent_Done,
     /* 1143816 */   // Label 16733: @1143816
     /* 1143816 */   GIM_Try, /*On fail goto*//*Label 16734*/ GIMT_Encode4(1143896), // Rule ID 15206 //
     /* 1143821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1143832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1143835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1143838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143860 */     // MIs[0] round
     /* 1143860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143870 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1143873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1143891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143895 */     // GIR_Coverage, 15206,
     /* 1143895 */     GIR_EraseRootFromParent_Done,
     /* 1143896 */   // Label 16734: @1143896
     /* 1143896 */   GIM_Try, /*On fail goto*//*Label 16735*/ GIMT_Encode4(1143976), // Rule ID 15207 //
     /* 1143901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1143912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1143915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1143918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143940 */     // MIs[0] round
     /* 1143940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143950 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1143953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1143971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143975 */     // GIR_Coverage, 15207,
     /* 1143975 */     GIR_EraseRootFromParent_Done,
     /* 1143976 */   // Label 16735: @1143976
     /* 1143976 */   GIM_Try, /*On fail goto*//*Label 16736*/ GIMT_Encode4(1144056), // Rule ID 15210 //
     /* 1143981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1143992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1143995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1143998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144020 */     // MIs[0] round
     /* 1144020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144030 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1144033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144055 */     // GIR_Coverage, 15210,
     /* 1144055 */     GIR_EraseRootFromParent_Done,
     /* 1144056 */   // Label 16736: @1144056
     /* 1144056 */   GIM_Try, /*On fail goto*//*Label 16737*/ GIMT_Encode4(1144136), // Rule ID 15211 //
     /* 1144061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1144069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1144072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1144075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1144078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144100 */     // MIs[0] round
     /* 1144100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144110 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1144113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144135 */     // GIR_Coverage, 15211,
     /* 1144135 */     GIR_EraseRootFromParent_Done,
     /* 1144136 */   // Label 16737: @1144136
     /* 1144136 */   GIM_Try, /*On fail goto*//*Label 16738*/ GIMT_Encode4(1144216), // Rule ID 15214 //
     /* 1144141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1144149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1144152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1144155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1144158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144180 */     // MIs[0] round
     /* 1144180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144190 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1144193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144215 */     // GIR_Coverage, 15214,
     /* 1144215 */     GIR_EraseRootFromParent_Done,
     /* 1144216 */   // Label 16738: @1144216
     /* 1144216 */   GIM_Try, /*On fail goto*//*Label 16739*/ GIMT_Encode4(1144296), // Rule ID 15215 //
     /* 1144221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1144229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1144232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1144235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1144238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144260 */     // MIs[0] round
     /* 1144260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144270 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1144273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144295 */     // GIR_Coverage, 15215,
     /* 1144295 */     GIR_EraseRootFromParent_Done,
     /* 1144296 */   // Label 16739: @1144296
     /* 1144296 */   GIM_Try, /*On fail goto*//*Label 16740*/ GIMT_Encode4(1144376), // Rule ID 15218 //
     /* 1144301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1144309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1144312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1144315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1144318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144340 */     // MIs[0] round
     /* 1144340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144350 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1144353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144375 */     // GIR_Coverage, 15218,
     /* 1144375 */     GIR_EraseRootFromParent_Done,
     /* 1144376 */   // Label 16740: @1144376
     /* 1144376 */   GIM_Try, /*On fail goto*//*Label 16741*/ GIMT_Encode4(1144456), // Rule ID 15219 //
     /* 1144381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1144389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1144392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1144395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1144398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144420 */     // MIs[0] round
     /* 1144420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144430 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1144433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144455 */     // GIR_Coverage, 15219,
     /* 1144455 */     GIR_EraseRootFromParent_Done,
     /* 1144456 */   // Label 16741: @1144456
     /* 1144456 */   GIM_Try, /*On fail goto*//*Label 16742*/ GIMT_Encode4(1144536), // Rule ID 15222 //
     /* 1144461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1144464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1144469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1144472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1144475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1144478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144500 */     // MIs[0] round
     /* 1144500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144510 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1144513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144535 */     // GIR_Coverage, 15222,
     /* 1144535 */     GIR_EraseRootFromParent_Done,
     /* 1144536 */   // Label 16742: @1144536
     /* 1144536 */   GIM_Try, /*On fail goto*//*Label 16743*/ GIMT_Encode4(1144616), // Rule ID 15223 //
     /* 1144541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1144544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1144549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1144552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1144555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1144558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144580 */     // MIs[0] round
     /* 1144580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144590 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1144593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144615 */     // GIR_Coverage, 15223,
     /* 1144615 */     GIR_EraseRootFromParent_Done,
     /* 1144616 */   // Label 16743: @1144616
     /* 1144616 */   GIM_Try, /*On fail goto*//*Label 16744*/ GIMT_Encode4(1144696), // Rule ID 15226 //
     /* 1144621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1144629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1144632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1144635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1144638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144660 */     // MIs[0] round
     /* 1144660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144670 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1144673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144695 */     // GIR_Coverage, 15226,
     /* 1144695 */     GIR_EraseRootFromParent_Done,
     /* 1144696 */   // Label 16744: @1144696
     /* 1144696 */   GIM_Try, /*On fail goto*//*Label 16745*/ GIMT_Encode4(1144776), // Rule ID 15227 //
     /* 1144701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1144709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1144712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1144715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1144718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144740 */     // MIs[0] round
     /* 1144740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144750 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1144753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144775 */     // GIR_Coverage, 15227,
     /* 1144775 */     GIR_EraseRootFromParent_Done,
     /* 1144776 */   // Label 16745: @1144776
     /* 1144776 */   GIM_Try, /*On fail goto*//*Label 16746*/ GIMT_Encode4(1144856), // Rule ID 15230 //
     /* 1144781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1144789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1144792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1144795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1144798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144820 */     // MIs[0] round
     /* 1144820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144830 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1144833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144855 */     // GIR_Coverage, 15230,
     /* 1144855 */     GIR_EraseRootFromParent_Done,
     /* 1144856 */   // Label 16746: @1144856
     /* 1144856 */   GIM_Try, /*On fail goto*//*Label 16747*/ GIMT_Encode4(1144936), // Rule ID 15231 //
     /* 1144861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1144869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1144872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1144875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1144878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144900 */     // MIs[0] round
     /* 1144900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144910 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1144913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144935 */     // GIR_Coverage, 15231,
     /* 1144935 */     GIR_EraseRootFromParent_Done,
     /* 1144936 */   // Label 16747: @1144936
     /* 1144936 */   GIM_Try, /*On fail goto*//*Label 16748*/ GIMT_Encode4(1145016), // Rule ID 15234 //
     /* 1144941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1144949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1144952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1144955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1144958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144980 */     // MIs[0] round
     /* 1144980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144990 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1144993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145015 */     // GIR_Coverage, 15234,
     /* 1145015 */     GIR_EraseRootFromParent_Done,
     /* 1145016 */   // Label 16748: @1145016
     /* 1145016 */   GIM_Try, /*On fail goto*//*Label 16749*/ GIMT_Encode4(1145096), // Rule ID 15235 //
     /* 1145021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1145029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1145032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1145035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1145038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1145041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145060 */     // MIs[0] round
     /* 1145060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145070 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1145073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145095 */     // GIR_Coverage, 15235,
     /* 1145095 */     GIR_EraseRootFromParent_Done,
     /* 1145096 */   // Label 16749: @1145096
     /* 1145096 */   GIM_Try, /*On fail goto*//*Label 16750*/ GIMT_Encode4(1145176), // Rule ID 15238 //
     /* 1145101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1145109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1145112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1145115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1145118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1145121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145140 */     // MIs[0] round
     /* 1145140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145150 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1145153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145175 */     // GIR_Coverage, 15238,
     /* 1145175 */     GIR_EraseRootFromParent_Done,
     /* 1145176 */   // Label 16750: @1145176
     /* 1145176 */   GIM_Try, /*On fail goto*//*Label 16751*/ GIMT_Encode4(1145256), // Rule ID 15239 //
     /* 1145181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1145189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1145192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1145195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1145198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1145201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145220 */     // MIs[0] round
     /* 1145220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145230 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1145233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145255 */     // GIR_Coverage, 15239,
     /* 1145255 */     GIR_EraseRootFromParent_Done,
     /* 1145256 */   // Label 16751: @1145256
     /* 1145256 */   GIM_Try, /*On fail goto*//*Label 16752*/ GIMT_Encode4(1145336), // Rule ID 15242 //
     /* 1145261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1145269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1145272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1145275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1145278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1145281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145300 */     // MIs[0] round
     /* 1145300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145310 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1145313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145335 */     // GIR_Coverage, 15242,
     /* 1145335 */     GIR_EraseRootFromParent_Done,
     /* 1145336 */   // Label 16752: @1145336
     /* 1145336 */   GIM_Try, /*On fail goto*//*Label 16753*/ GIMT_Encode4(1145416), // Rule ID 15243 //
     /* 1145341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1145349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1145352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1145355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1145358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1145361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145380 */     // MIs[0] round
     /* 1145380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145390 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1145393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145415 */     // GIR_Coverage, 15243,
     /* 1145415 */     GIR_EraseRootFromParent_Done,
     /* 1145416 */   // Label 16753: @1145416
     /* 1145416 */   GIM_Try, /*On fail goto*//*Label 16754*/ GIMT_Encode4(1145496), // Rule ID 15246 //
     /* 1145421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1145429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1145432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1145435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1145438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1145441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145460 */     // MIs[0] round
     /* 1145460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145470 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1145473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145495 */     // GIR_Coverage, 15246,
     /* 1145495 */     GIR_EraseRootFromParent_Done,
     /* 1145496 */   // Label 16754: @1145496
     /* 1145496 */   GIM_Try, /*On fail goto*//*Label 16755*/ GIMT_Encode4(1145576), // Rule ID 15247 //
     /* 1145501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1145509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1145512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1145515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1145518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1145521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145540 */     // MIs[0] round
     /* 1145540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145550 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1145553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145575 */     // GIR_Coverage, 15247,
     /* 1145575 */     GIR_EraseRootFromParent_Done,
     /* 1145576 */   // Label 16755: @1145576
     /* 1145576 */   GIM_Try, /*On fail goto*//*Label 16756*/ GIMT_Encode4(1145656), // Rule ID 15250 //
     /* 1145581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1145589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1145592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1145595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1145598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1145601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145620 */     // MIs[0] round
     /* 1145620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1145633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145655 */     // GIR_Coverage, 15250,
     /* 1145655 */     GIR_EraseRootFromParent_Done,
     /* 1145656 */   // Label 16756: @1145656
     /* 1145656 */   GIM_Try, /*On fail goto*//*Label 16757*/ GIMT_Encode4(1145736), // Rule ID 15251 //
     /* 1145661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1145669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1145672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1145675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1145678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1145681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145700 */     // MIs[0] round
     /* 1145700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1145713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145735 */     // GIR_Coverage, 15251,
     /* 1145735 */     GIR_EraseRootFromParent_Done,
     /* 1145736 */   // Label 16757: @1145736
     /* 1145736 */   GIM_Try, /*On fail goto*//*Label 16758*/ GIMT_Encode4(1145816), // Rule ID 15254 //
     /* 1145741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1145749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1145752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1145755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1145758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1145761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145780 */     // MIs[0] round
     /* 1145780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145790 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1145793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145815 */     // GIR_Coverage, 15254,
     /* 1145815 */     GIR_EraseRootFromParent_Done,
     /* 1145816 */   // Label 16758: @1145816
     /* 1145816 */   GIM_Try, /*On fail goto*//*Label 16759*/ GIMT_Encode4(1145896), // Rule ID 15255 //
     /* 1145821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1145829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1145832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1145835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1145838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1145841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145860 */     // MIs[0] round
     /* 1145860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145870 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1145873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145895 */     // GIR_Coverage, 15255,
     /* 1145895 */     GIR_EraseRootFromParent_Done,
     /* 1145896 */   // Label 16759: @1145896
     /* 1145896 */   GIM_Try, /*On fail goto*//*Label 16760*/ GIMT_Encode4(1145976), // Rule ID 15258 //
     /* 1145901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1145909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1145912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1145915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1145918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1145921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145940 */     // MIs[0] round
     /* 1145940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145950 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1145953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145975 */     // GIR_Coverage, 15258,
     /* 1145975 */     GIR_EraseRootFromParent_Done,
     /* 1145976 */   // Label 16760: @1145976
     /* 1145976 */   GIM_Try, /*On fail goto*//*Label 16761*/ GIMT_Encode4(1146056), // Rule ID 15259 //
     /* 1145981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1145989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1145992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1145995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1145998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146020 */     // MIs[0] round
     /* 1146020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1146033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146055 */     // GIR_Coverage, 15259,
     /* 1146055 */     GIR_EraseRootFromParent_Done,
     /* 1146056 */   // Label 16761: @1146056
     /* 1146056 */   GIM_Try, /*On fail goto*//*Label 16762*/ GIMT_Encode4(1146136), // Rule ID 15262 //
     /* 1146061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1146064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1146069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1146072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1146075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1146078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146100 */     // MIs[0] round
     /* 1146100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1146113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146135 */     // GIR_Coverage, 15262,
     /* 1146135 */     GIR_EraseRootFromParent_Done,
     /* 1146136 */   // Label 16762: @1146136
     /* 1146136 */   GIM_Try, /*On fail goto*//*Label 16763*/ GIMT_Encode4(1146216), // Rule ID 15263 //
     /* 1146141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1146144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1146149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1146152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1146155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1146158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146180 */     // MIs[0] round
     /* 1146180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1146193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146215 */     // GIR_Coverage, 15263,
     /* 1146215 */     GIR_EraseRootFromParent_Done,
     /* 1146216 */   // Label 16763: @1146216
     /* 1146216 */   GIM_Try, /*On fail goto*//*Label 16764*/ GIMT_Encode4(1146296), // Rule ID 15266 //
     /* 1146221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1146224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1146229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1146232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1146235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1146238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146260 */     // MIs[0] round
     /* 1146260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146270 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1146273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146295 */     // GIR_Coverage, 15266,
     /* 1146295 */     GIR_EraseRootFromParent_Done,
     /* 1146296 */   // Label 16764: @1146296
     /* 1146296 */   GIM_Try, /*On fail goto*//*Label 16765*/ GIMT_Encode4(1146376), // Rule ID 15267 //
     /* 1146301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1146304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1146309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1146312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1146315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1146318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146340 */     // MIs[0] round
     /* 1146340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146350 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1146353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146375 */     // GIR_Coverage, 15267,
     /* 1146375 */     GIR_EraseRootFromParent_Done,
     /* 1146376 */   // Label 16765: @1146376
     /* 1146376 */   GIM_Try, /*On fail goto*//*Label 16766*/ GIMT_Encode4(1146456), // Rule ID 15270 //
     /* 1146381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1146384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1146389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1146392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1146395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1146398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146420 */     // MIs[0] round
     /* 1146420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146430 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1146433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146455 */     // GIR_Coverage, 15270,
     /* 1146455 */     GIR_EraseRootFromParent_Done,
     /* 1146456 */   // Label 16766: @1146456
     /* 1146456 */   GIM_Try, /*On fail goto*//*Label 16767*/ GIMT_Encode4(1146536), // Rule ID 15271 //
     /* 1146461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1146464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1146469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1146472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1146475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1146478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146500 */     // MIs[0] round
     /* 1146500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146510 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1146513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146535 */     // GIR_Coverage, 15271,
     /* 1146535 */     GIR_EraseRootFromParent_Done,
     /* 1146536 */   // Label 16767: @1146536
     /* 1146536 */   GIM_Try, /*On fail goto*//*Label 16768*/ GIMT_Encode4(1146616), // Rule ID 15274 //
     /* 1146541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1146552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1146555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1146558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1146561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146580 */     // MIs[0] round
     /* 1146580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146590 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1146593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146615 */     // GIR_Coverage, 15274,
     /* 1146615 */     GIR_EraseRootFromParent_Done,
     /* 1146616 */   // Label 16768: @1146616
     /* 1146616 */   GIM_Try, /*On fail goto*//*Label 16769*/ GIMT_Encode4(1146696), // Rule ID 15275 //
     /* 1146621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1146632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1146635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1146638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1146641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146660 */     // MIs[0] round
     /* 1146660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146670 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1146673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146695 */     // GIR_Coverage, 15275,
     /* 1146695 */     GIR_EraseRootFromParent_Done,
     /* 1146696 */   // Label 16769: @1146696
     /* 1146696 */   GIM_Try, /*On fail goto*//*Label 16770*/ GIMT_Encode4(1146776), // Rule ID 15278 //
     /* 1146701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1146712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1146715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1146718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1146721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146740 */     // MIs[0] round
     /* 1146740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146750 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1146753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146775 */     // GIR_Coverage, 15278,
     /* 1146775 */     GIR_EraseRootFromParent_Done,
     /* 1146776 */   // Label 16770: @1146776
     /* 1146776 */   GIM_Try, /*On fail goto*//*Label 16771*/ GIMT_Encode4(1146856), // Rule ID 15279 //
     /* 1146781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1146792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1146795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1146798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1146801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146820 */     // MIs[0] round
     /* 1146820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146830 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1146833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146855 */     // GIR_Coverage, 15279,
     /* 1146855 */     GIR_EraseRootFromParent_Done,
     /* 1146856 */   // Label 16771: @1146856
     /* 1146856 */   GIM_Try, /*On fail goto*//*Label 16772*/ GIMT_Encode4(1146936), // Rule ID 15282 //
     /* 1146861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1146872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1146875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1146878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1146881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146900 */     // MIs[0] round
     /* 1146900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146910 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1146913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146935 */     // GIR_Coverage, 15282,
     /* 1146935 */     GIR_EraseRootFromParent_Done,
     /* 1146936 */   // Label 16772: @1146936
     /* 1146936 */   GIM_Try, /*On fail goto*//*Label 16773*/ GIMT_Encode4(1147016), // Rule ID 15283 //
     /* 1146941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1146952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1146955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1146958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1146961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146980 */     // MIs[0] round
     /* 1146980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146990 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1146993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147015 */     // GIR_Coverage, 15283,
     /* 1147015 */     GIR_EraseRootFromParent_Done,
     /* 1147016 */   // Label 16773: @1147016
     /* 1147016 */   GIM_Try, /*On fail goto*//*Label 16774*/ GIMT_Encode4(1147096), // Rule ID 15286 //
     /* 1147021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1147032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1147035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1147038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1147041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147060 */     // MIs[0] round
     /* 1147060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147070 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1147073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147095 */     // GIR_Coverage, 15286,
     /* 1147095 */     GIR_EraseRootFromParent_Done,
     /* 1147096 */   // Label 16774: @1147096
     /* 1147096 */   GIM_Try, /*On fail goto*//*Label 16775*/ GIMT_Encode4(1147176), // Rule ID 15287 //
     /* 1147101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1147112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1147115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1147118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1147121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147140 */     // MIs[0] round
     /* 1147140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147150 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1147153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147175 */     // GIR_Coverage, 15287,
     /* 1147175 */     GIR_EraseRootFromParent_Done,
     /* 1147176 */   // Label 16775: @1147176
     /* 1147176 */   GIM_Try, /*On fail goto*//*Label 16776*/ GIMT_Encode4(1147256), // Rule ID 15290 //
     /* 1147181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1147192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1147195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1147198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1147201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147220 */     // MIs[0] round
     /* 1147220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147230 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1147233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147255 */     // GIR_Coverage, 15290,
     /* 1147255 */     GIR_EraseRootFromParent_Done,
     /* 1147256 */   // Label 16776: @1147256
     /* 1147256 */   GIM_Try, /*On fail goto*//*Label 16777*/ GIMT_Encode4(1147336), // Rule ID 15291 //
     /* 1147261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1147272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1147275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1147278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1147281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147300 */     // MIs[0] round
     /* 1147300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147310 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1147313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147335 */     // GIR_Coverage, 15291,
     /* 1147335 */     GIR_EraseRootFromParent_Done,
     /* 1147336 */   // Label 16777: @1147336
     /* 1147336 */   GIM_Try, /*On fail goto*//*Label 16778*/ GIMT_Encode4(1147416), // Rule ID 15294 //
     /* 1147341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1147352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1147355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1147358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1147361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147380 */     // MIs[0] round
     /* 1147380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147390 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1147393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147415 */     // GIR_Coverage, 15294,
     /* 1147415 */     GIR_EraseRootFromParent_Done,
     /* 1147416 */   // Label 16778: @1147416
     /* 1147416 */   GIM_Try, /*On fail goto*//*Label 16779*/ GIMT_Encode4(1147496), // Rule ID 15295 //
     /* 1147421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1147432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1147435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1147438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1147441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147460 */     // MIs[0] round
     /* 1147460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147470 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1147473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147495 */     // GIR_Coverage, 15295,
     /* 1147495 */     GIR_EraseRootFromParent_Done,
     /* 1147496 */   // Label 16779: @1147496
     /* 1147496 */   GIM_Try, /*On fail goto*//*Label 16780*/ GIMT_Encode4(1147576), // Rule ID 15298 //
     /* 1147501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1147512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1147515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1147518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1147521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147540 */     // MIs[0] round
     /* 1147540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147550 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1147553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147575 */     // GIR_Coverage, 15298,
     /* 1147575 */     GIR_EraseRootFromParent_Done,
     /* 1147576 */   // Label 16780: @1147576
     /* 1147576 */   GIM_Try, /*On fail goto*//*Label 16781*/ GIMT_Encode4(1147656), // Rule ID 15299 //
     /* 1147581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1147592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1147595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1147598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1147601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147620 */     // MIs[0] round
     /* 1147620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147630 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1147633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147655 */     // GIR_Coverage, 15299,
     /* 1147655 */     GIR_EraseRootFromParent_Done,
     /* 1147656 */   // Label 16781: @1147656
     /* 1147656 */   GIM_Try, /*On fail goto*//*Label 16782*/ GIMT_Encode4(1147736), // Rule ID 15302 //
     /* 1147661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1147672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1147675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1147678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1147681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147700 */     // MIs[0] round
     /* 1147700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1147713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147735 */     // GIR_Coverage, 15302,
     /* 1147735 */     GIR_EraseRootFromParent_Done,
     /* 1147736 */   // Label 16782: @1147736
     /* 1147736 */   GIM_Try, /*On fail goto*//*Label 16783*/ GIMT_Encode4(1147816), // Rule ID 15303 //
     /* 1147741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1147752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1147755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1147758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1147761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147780 */     // MIs[0] round
     /* 1147780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1147793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147815 */     // GIR_Coverage, 15303,
     /* 1147815 */     GIR_EraseRootFromParent_Done,
     /* 1147816 */   // Label 16783: @1147816
     /* 1147816 */   GIM_Try, /*On fail goto*//*Label 16784*/ GIMT_Encode4(1147896), // Rule ID 15306 //
     /* 1147821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1147832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1147835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1147838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1147841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147860 */     // MIs[0] round
     /* 1147860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147870 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1147873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147895 */     // GIR_Coverage, 15306,
     /* 1147895 */     GIR_EraseRootFromParent_Done,
     /* 1147896 */   // Label 16784: @1147896
     /* 1147896 */   GIM_Try, /*On fail goto*//*Label 16785*/ GIMT_Encode4(1147976), // Rule ID 15307 //
     /* 1147901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1147912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1147915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1147918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1147921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147940 */     // MIs[0] round
     /* 1147940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147950 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1147953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147975 */     // GIR_Coverage, 15307,
     /* 1147975 */     GIR_EraseRootFromParent_Done,
     /* 1147976 */   // Label 16785: @1147976
     /* 1147976 */   GIM_Try, /*On fail goto*//*Label 16786*/ GIMT_Encode4(1148056), // Rule ID 15310 //
     /* 1147981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1147984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1147992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1147995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1147998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1148001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148020 */     // MIs[0] round
     /* 1148020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148030 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1148033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148055 */     // GIR_Coverage, 15310,
     /* 1148055 */     GIR_EraseRootFromParent_Done,
     /* 1148056 */   // Label 16786: @1148056
     /* 1148056 */   GIM_Try, /*On fail goto*//*Label 16787*/ GIMT_Encode4(1148136), // Rule ID 15311 //
     /* 1148061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1148064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1148072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1148075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1148078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1148081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148100 */     // MIs[0] round
     /* 1148100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148110 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1148113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148135 */     // GIR_Coverage, 15311,
     /* 1148135 */     GIR_EraseRootFromParent_Done,
     /* 1148136 */   // Label 16787: @1148136
     /* 1148136 */   GIM_Try, /*On fail goto*//*Label 16788*/ GIMT_Encode4(1148216), // Rule ID 15314 //
     /* 1148141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1148152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1148155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1148158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1148161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148180 */     // MIs[0] round
     /* 1148180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148190 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1148193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148215 */     // GIR_Coverage, 15314,
     /* 1148215 */     GIR_EraseRootFromParent_Done,
     /* 1148216 */   // Label 16788: @1148216
     /* 1148216 */   GIM_Try, /*On fail goto*//*Label 16789*/ GIMT_Encode4(1148296), // Rule ID 15315 //
     /* 1148221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1148232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1148235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1148238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1148241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148260 */     // MIs[0] round
     /* 1148260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148270 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1148273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148295 */     // GIR_Coverage, 15315,
     /* 1148295 */     GIR_EraseRootFromParent_Done,
     /* 1148296 */   // Label 16789: @1148296
     /* 1148296 */   GIM_Try, /*On fail goto*//*Label 16790*/ GIMT_Encode4(1148376), // Rule ID 15318 //
     /* 1148301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1148312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1148315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1148318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1148321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148340 */     // MIs[0] round
     /* 1148340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148350 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1148353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148375 */     // GIR_Coverage, 15318,
     /* 1148375 */     GIR_EraseRootFromParent_Done,
     /* 1148376 */   // Label 16790: @1148376
     /* 1148376 */   GIM_Try, /*On fail goto*//*Label 16791*/ GIMT_Encode4(1148456), // Rule ID 15319 //
     /* 1148381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1148392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1148395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1148398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1148401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148420 */     // MIs[0] round
     /* 1148420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148430 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1148433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148455 */     // GIR_Coverage, 15319,
     /* 1148455 */     GIR_EraseRootFromParent_Done,
     /* 1148456 */   // Label 16791: @1148456
     /* 1148456 */   GIM_Try, /*On fail goto*//*Label 16792*/ GIMT_Encode4(1148536), // Rule ID 15322 //
     /* 1148461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1148472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1148475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1148478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1148481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148500 */     // MIs[0] round
     /* 1148500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148510 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1148513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148535 */     // GIR_Coverage, 15322,
     /* 1148535 */     GIR_EraseRootFromParent_Done,
     /* 1148536 */   // Label 16792: @1148536
     /* 1148536 */   GIM_Try, /*On fail goto*//*Label 16793*/ GIMT_Encode4(1148616), // Rule ID 15323 //
     /* 1148541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1148552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1148555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1148558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1148561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148580 */     // MIs[0] round
     /* 1148580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148590 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1148593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148615 */     // GIR_Coverage, 15323,
     /* 1148615 */     GIR_EraseRootFromParent_Done,
     /* 1148616 */   // Label 16793: @1148616
     /* 1148616 */   GIM_Try, /*On fail goto*//*Label 16794*/ GIMT_Encode4(1148696), // Rule ID 15326 //
     /* 1148621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1148632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1148635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1148638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1148641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148660 */     // MIs[0] round
     /* 1148660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1148673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148695 */     // GIR_Coverage, 15326,
     /* 1148695 */     GIR_EraseRootFromParent_Done,
     /* 1148696 */   // Label 16794: @1148696
     /* 1148696 */   GIM_Try, /*On fail goto*//*Label 16795*/ GIMT_Encode4(1148776), // Rule ID 15327 //
     /* 1148701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1148712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1148715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1148718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1148721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148740 */     // MIs[0] round
     /* 1148740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148750 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1148753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148775 */     // GIR_Coverage, 15327,
     /* 1148775 */     GIR_EraseRootFromParent_Done,
     /* 1148776 */   // Label 16795: @1148776
     /* 1148776 */   GIM_Try, /*On fail goto*//*Label 16796*/ GIMT_Encode4(1148856), // Rule ID 15330 //
     /* 1148781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1148792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1148795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1148798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1148801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148820 */     // MIs[0] round
     /* 1148820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148830 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1148833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148855 */     // GIR_Coverage, 15330,
     /* 1148855 */     GIR_EraseRootFromParent_Done,
     /* 1148856 */   // Label 16796: @1148856
     /* 1148856 */   GIM_Try, /*On fail goto*//*Label 16797*/ GIMT_Encode4(1148936), // Rule ID 15331 //
     /* 1148861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1148872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1148875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1148878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1148881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148900 */     // MIs[0] round
     /* 1148900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148910 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1148913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148935 */     // GIR_Coverage, 15331,
     /* 1148935 */     GIR_EraseRootFromParent_Done,
     /* 1148936 */   // Label 16797: @1148936
     /* 1148936 */   GIM_Try, /*On fail goto*//*Label 16798*/ GIMT_Encode4(1149016), // Rule ID 15334 //
     /* 1148941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1148952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1148955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1148958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1148961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148980 */     // MIs[0] round
     /* 1148980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148990 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1148993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149015 */     // GIR_Coverage, 15334,
     /* 1149015 */     GIR_EraseRootFromParent_Done,
     /* 1149016 */   // Label 16798: @1149016
     /* 1149016 */   GIM_Try, /*On fail goto*//*Label 16799*/ GIMT_Encode4(1149096), // Rule ID 15335 //
     /* 1149021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1149032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1149035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1149038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1149041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149060 */     // MIs[0] round
     /* 1149060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149070 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1149073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149095 */     // GIR_Coverage, 15335,
     /* 1149095 */     GIR_EraseRootFromParent_Done,
     /* 1149096 */   // Label 16799: @1149096
     /* 1149096 */   GIM_Try, /*On fail goto*//*Label 16800*/ GIMT_Encode4(1149176), // Rule ID 15338 //
     /* 1149101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1149112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1149115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1149118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1149121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149140 */     // MIs[0] round
     /* 1149140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1149153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149175 */     // GIR_Coverage, 15338,
     /* 1149175 */     GIR_EraseRootFromParent_Done,
     /* 1149176 */   // Label 16800: @1149176
     /* 1149176 */   GIM_Try, /*On fail goto*//*Label 16801*/ GIMT_Encode4(1149256), // Rule ID 15339 //
     /* 1149181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1149192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1149195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1149198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1149201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149220 */     // MIs[0] round
     /* 1149220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1149233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149255 */     // GIR_Coverage, 15339,
     /* 1149255 */     GIR_EraseRootFromParent_Done,
     /* 1149256 */   // Label 16801: @1149256
     /* 1149256 */   GIM_Try, /*On fail goto*//*Label 16802*/ GIMT_Encode4(1149336), // Rule ID 15342 //
     /* 1149261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1149272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1149275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1149278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1149281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149300 */     // MIs[0] round
     /* 1149300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149310 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1149313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149335 */     // GIR_Coverage, 15342,
     /* 1149335 */     GIR_EraseRootFromParent_Done,
     /* 1149336 */   // Label 16802: @1149336
     /* 1149336 */   GIM_Try, /*On fail goto*//*Label 16803*/ GIMT_Encode4(1149416), // Rule ID 15343 //
     /* 1149341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1149352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1149355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1149358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1149361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149380 */     // MIs[0] round
     /* 1149380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149390 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1149393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149415 */     // GIR_Coverage, 15343,
     /* 1149415 */     GIR_EraseRootFromParent_Done,
     /* 1149416 */   // Label 16803: @1149416
     /* 1149416 */   GIM_Try, /*On fail goto*//*Label 16804*/ GIMT_Encode4(1149496), // Rule ID 15346 //
     /* 1149421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1149432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1149435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1149438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1149441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149460 */     // MIs[0] round
     /* 1149460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149470 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1149473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149495 */     // GIR_Coverage, 15346,
     /* 1149495 */     GIR_EraseRootFromParent_Done,
     /* 1149496 */   // Label 16804: @1149496
     /* 1149496 */   GIM_Try, /*On fail goto*//*Label 16805*/ GIMT_Encode4(1149576), // Rule ID 15347 //
     /* 1149501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1149512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1149515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1149518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1149521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149540 */     // MIs[0] round
     /* 1149540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149550 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1149553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149575 */     // GIR_Coverage, 15347,
     /* 1149575 */     GIR_EraseRootFromParent_Done,
     /* 1149576 */   // Label 16805: @1149576
     /* 1149576 */   GIM_Try, /*On fail goto*//*Label 16806*/ GIMT_Encode4(1149656), // Rule ID 15350 //
     /* 1149581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1149592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1149595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1149598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1149601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149620 */     // MIs[0] round
     /* 1149620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1149633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149655 */     // GIR_Coverage, 15350,
     /* 1149655 */     GIR_EraseRootFromParent_Done,
     /* 1149656 */   // Label 16806: @1149656
     /* 1149656 */   GIM_Try, /*On fail goto*//*Label 16807*/ GIMT_Encode4(1149736), // Rule ID 15351 //
     /* 1149661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1149672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1149675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1149678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1149681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149700 */     // MIs[0] round
     /* 1149700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1149713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149735 */     // GIR_Coverage, 15351,
     /* 1149735 */     GIR_EraseRootFromParent_Done,
     /* 1149736 */   // Label 16807: @1149736
     /* 1149736 */   GIM_Try, /*On fail goto*//*Label 16808*/ GIMT_Encode4(1149816), // Rule ID 15354 //
     /* 1149741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1149752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1149755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1149758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1149761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149780 */     // MIs[0] round
     /* 1149780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149790 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1149793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149815 */     // GIR_Coverage, 15354,
     /* 1149815 */     GIR_EraseRootFromParent_Done,
     /* 1149816 */   // Label 16808: @1149816
     /* 1149816 */   GIM_Try, /*On fail goto*//*Label 16809*/ GIMT_Encode4(1149896), // Rule ID 15355 //
     /* 1149821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1149832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1149835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1149838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1149841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149860 */     // MIs[0] round
     /* 1149860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149870 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1149873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149895 */     // GIR_Coverage, 15355,
     /* 1149895 */     GIR_EraseRootFromParent_Done,
     /* 1149896 */   // Label 16809: @1149896
     /* 1149896 */   GIM_Try, /*On fail goto*//*Label 16810*/ GIMT_Encode4(1149976), // Rule ID 15358 //
     /* 1149901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1149912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1149915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1149918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1149921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149940 */     // MIs[0] round
     /* 1149940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149950 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1149953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149975 */     // GIR_Coverage, 15358,
     /* 1149975 */     GIR_EraseRootFromParent_Done,
     /* 1149976 */   // Label 16810: @1149976
     /* 1149976 */   GIM_Try, /*On fail goto*//*Label 16811*/ GIMT_Encode4(1150056), // Rule ID 15359 //
     /* 1149981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1149992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1149995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1149998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1150001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150020 */     // MIs[0] round
     /* 1150020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150030 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1150033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1150051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150055 */     // GIR_Coverage, 15359,
     /* 1150055 */     GIR_EraseRootFromParent_Done,
     /* 1150056 */   // Label 16811: @1150056
     /* 1150056 */   GIM_Try, /*On fail goto*//*Label 16812*/ GIMT_Encode4(1150136), // Rule ID 15362 //
     /* 1150061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1150072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1150075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1150078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150100 */     // MIs[0] round
     /* 1150100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150110 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1150113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150135 */     // GIR_Coverage, 15362,
     /* 1150135 */     GIR_EraseRootFromParent_Done,
     /* 1150136 */   // Label 16812: @1150136
     /* 1150136 */   GIM_Try, /*On fail goto*//*Label 16813*/ GIMT_Encode4(1150216), // Rule ID 15363 //
     /* 1150141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1150152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1150155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1150158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150180 */     // MIs[0] round
     /* 1150180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150190 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1150193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150215 */     // GIR_Coverage, 15363,
     /* 1150215 */     GIR_EraseRootFromParent_Done,
     /* 1150216 */   // Label 16813: @1150216
     /* 1150216 */   GIM_Try, /*On fail goto*//*Label 16814*/ GIMT_Encode4(1150296), // Rule ID 15366 //
     /* 1150221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1150232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1150235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1150238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150260 */     // MIs[0] round
     /* 1150260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150270 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1150273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150295 */     // GIR_Coverage, 15366,
     /* 1150295 */     GIR_EraseRootFromParent_Done,
     /* 1150296 */   // Label 16814: @1150296
     /* 1150296 */   GIM_Try, /*On fail goto*//*Label 16815*/ GIMT_Encode4(1150376), // Rule ID 15367 //
     /* 1150301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1150312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1150315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1150318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150340 */     // MIs[0] round
     /* 1150340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150350 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1150353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150375 */     // GIR_Coverage, 15367,
     /* 1150375 */     GIR_EraseRootFromParent_Done,
     /* 1150376 */   // Label 16815: @1150376
     /* 1150376 */   GIM_Try, /*On fail goto*//*Label 16816*/ GIMT_Encode4(1150456), // Rule ID 15370 //
     /* 1150381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1150392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1150395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1150398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150420 */     // MIs[0] round
     /* 1150420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150430 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1150433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150455 */     // GIR_Coverage, 15370,
     /* 1150455 */     GIR_EraseRootFromParent_Done,
     /* 1150456 */   // Label 16816: @1150456
     /* 1150456 */   GIM_Try, /*On fail goto*//*Label 16817*/ GIMT_Encode4(1150536), // Rule ID 15371 //
     /* 1150461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1150472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1150475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1150478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150500 */     // MIs[0] round
     /* 1150500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150510 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1150513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150535 */     // GIR_Coverage, 15371,
     /* 1150535 */     GIR_EraseRootFromParent_Done,
     /* 1150536 */   // Label 16817: @1150536
     /* 1150536 */   GIM_Try, /*On fail goto*//*Label 16818*/ GIMT_Encode4(1150616), // Rule ID 15374 //
     /* 1150541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1150552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1150555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1150558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150580 */     // MIs[0] round
     /* 1150580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150590 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1150593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150615 */     // GIR_Coverage, 15374,
     /* 1150615 */     GIR_EraseRootFromParent_Done,
     /* 1150616 */   // Label 16818: @1150616
     /* 1150616 */   GIM_Try, /*On fail goto*//*Label 16819*/ GIMT_Encode4(1150696), // Rule ID 15375 //
     /* 1150621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1150632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1150635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1150638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150660 */     // MIs[0] round
     /* 1150660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150670 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1150673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150695 */     // GIR_Coverage, 15375,
     /* 1150695 */     GIR_EraseRootFromParent_Done,
     /* 1150696 */   // Label 16819: @1150696
     /* 1150696 */   GIM_Try, /*On fail goto*//*Label 16820*/ GIMT_Encode4(1150776), // Rule ID 15378 //
     /* 1150701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1150712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1150715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1150718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150740 */     // MIs[0] round
     /* 1150740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150750 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1150753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150775 */     // GIR_Coverage, 15378,
     /* 1150775 */     GIR_EraseRootFromParent_Done,
     /* 1150776 */   // Label 16820: @1150776
     /* 1150776 */   GIM_Try, /*On fail goto*//*Label 16821*/ GIMT_Encode4(1150856), // Rule ID 15379 //
     /* 1150781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1150792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1150795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1150798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150820 */     // MIs[0] round
     /* 1150820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150830 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1150833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150855 */     // GIR_Coverage, 15379,
     /* 1150855 */     GIR_EraseRootFromParent_Done,
     /* 1150856 */   // Label 16821: @1150856
     /* 1150856 */   GIM_Try, /*On fail goto*//*Label 16822*/ GIMT_Encode4(1150936), // Rule ID 15382 //
     /* 1150861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1150872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1150875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1150878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150900 */     // MIs[0] round
     /* 1150900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150910 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1150913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1150931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150935 */     // GIR_Coverage, 15382,
     /* 1150935 */     GIR_EraseRootFromParent_Done,
     /* 1150936 */   // Label 16822: @1150936
     /* 1150936 */   GIM_Try, /*On fail goto*//*Label 16823*/ GIMT_Encode4(1151016), // Rule ID 15383 //
     /* 1150941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1150952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1150955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1150958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150980 */     // MIs[0] round
     /* 1150980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150990 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1150993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151015 */     // GIR_Coverage, 15383,
     /* 1151015 */     GIR_EraseRootFromParent_Done,
     /* 1151016 */   // Label 16823: @1151016
     /* 1151016 */   GIM_Try, /*On fail goto*//*Label 16824*/ GIMT_Encode4(1151096), // Rule ID 15386 //
     /* 1151021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1151029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1151032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1151035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1151038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151060 */     // MIs[0] round
     /* 1151060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1151073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151095 */     // GIR_Coverage, 15386,
     /* 1151095 */     GIR_EraseRootFromParent_Done,
     /* 1151096 */   // Label 16824: @1151096
     /* 1151096 */   GIM_Try, /*On fail goto*//*Label 16825*/ GIMT_Encode4(1151176), // Rule ID 15387 //
     /* 1151101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1151109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1151112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1151115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1151118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151140 */     // MIs[0] round
     /* 1151140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151150 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1151153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151175 */     // GIR_Coverage, 15387,
     /* 1151175 */     GIR_EraseRootFromParent_Done,
     /* 1151176 */   // Label 16825: @1151176
     /* 1151176 */   GIM_Try, /*On fail goto*//*Label 16826*/ GIMT_Encode4(1151256), // Rule ID 15390 //
     /* 1151181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1151189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1151192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1151195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1151198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151220 */     // MIs[0] round
     /* 1151220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151230 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1151233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151255 */     // GIR_Coverage, 15390,
     /* 1151255 */     GIR_EraseRootFromParent_Done,
     /* 1151256 */   // Label 16826: @1151256
     /* 1151256 */   GIM_Try, /*On fail goto*//*Label 16827*/ GIMT_Encode4(1151336), // Rule ID 15391 //
     /* 1151261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1151269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1151272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1151275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1151278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151300 */     // MIs[0] round
     /* 1151300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151310 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1151313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151335 */     // GIR_Coverage, 15391,
     /* 1151335 */     GIR_EraseRootFromParent_Done,
     /* 1151336 */   // Label 16827: @1151336
     /* 1151336 */   GIM_Try, /*On fail goto*//*Label 16828*/ GIMT_Encode4(1151416), // Rule ID 15394 //
     /* 1151341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1151349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1151352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1151355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1151358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151380 */     // MIs[0] round
     /* 1151380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1151393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151415 */     // GIR_Coverage, 15394,
     /* 1151415 */     GIR_EraseRootFromParent_Done,
     /* 1151416 */   // Label 16828: @1151416
     /* 1151416 */   GIM_Try, /*On fail goto*//*Label 16829*/ GIMT_Encode4(1151496), // Rule ID 15395 //
     /* 1151421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1151429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1151432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1151435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1151438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151460 */     // MIs[0] round
     /* 1151460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151470 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1151473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151495 */     // GIR_Coverage, 15395,
     /* 1151495 */     GIR_EraseRootFromParent_Done,
     /* 1151496 */   // Label 16829: @1151496
     /* 1151496 */   GIM_Try, /*On fail goto*//*Label 16830*/ GIMT_Encode4(1151576), // Rule ID 15398 //
     /* 1151501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1151504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1151509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1151512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1151515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1151518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151540 */     // MIs[0] round
     /* 1151540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151550 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1151553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151575 */     // GIR_Coverage, 15398,
     /* 1151575 */     GIR_EraseRootFromParent_Done,
     /* 1151576 */   // Label 16830: @1151576
     /* 1151576 */   GIM_Try, /*On fail goto*//*Label 16831*/ GIMT_Encode4(1151656), // Rule ID 15399 //
     /* 1151581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1151584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1151589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1151592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1151595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1151598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151620 */     // MIs[0] round
     /* 1151620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151630 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1151633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151655 */     // GIR_Coverage, 15399,
     /* 1151655 */     GIR_EraseRootFromParent_Done,
     /* 1151656 */   // Label 16831: @1151656
     /* 1151656 */   GIM_Try, /*On fail goto*//*Label 16832*/ GIMT_Encode4(1151736), // Rule ID 15402 //
     /* 1151661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1151669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1151672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1151675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1151678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151700 */     // MIs[0] round
     /* 1151700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151710 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1151713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151735 */     // GIR_Coverage, 15402,
     /* 1151735 */     GIR_EraseRootFromParent_Done,
     /* 1151736 */   // Label 16832: @1151736
     /* 1151736 */   GIM_Try, /*On fail goto*//*Label 16833*/ GIMT_Encode4(1151816), // Rule ID 15403 //
     /* 1151741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1151749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1151752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1151755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1151758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151780 */     // MIs[0] round
     /* 1151780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151790 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1151793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151815 */     // GIR_Coverage, 15403,
     /* 1151815 */     GIR_EraseRootFromParent_Done,
     /* 1151816 */   // Label 16833: @1151816
     /* 1151816 */   GIM_Try, /*On fail goto*//*Label 16834*/ GIMT_Encode4(1151896), // Rule ID 15406 //
     /* 1151821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1151829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1151832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1151835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1151838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151860 */     // MIs[0] round
     /* 1151860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1151873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151895 */     // GIR_Coverage, 15406,
     /* 1151895 */     GIR_EraseRootFromParent_Done,
     /* 1151896 */   // Label 16834: @1151896
     /* 1151896 */   GIM_Try, /*On fail goto*//*Label 16835*/ GIMT_Encode4(1151976), // Rule ID 15407 //
     /* 1151901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1151909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1151912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1151915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1151918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151940 */     // MIs[0] round
     /* 1151940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151950 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1151953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151975 */     // GIR_Coverage, 15407,
     /* 1151975 */     GIR_EraseRootFromParent_Done,
     /* 1151976 */   // Label 16835: @1151976
     /* 1151976 */   GIM_Try, /*On fail goto*//*Label 16836*/ GIMT_Encode4(1152056), // Rule ID 15410 //
     /* 1151981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1151989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1151992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1151995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1151998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1152001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152020 */     // MIs[0] round
     /* 1152020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152030 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1152033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152055 */     // GIR_Coverage, 15410,
     /* 1152055 */     GIR_EraseRootFromParent_Done,
     /* 1152056 */   // Label 16836: @1152056
     /* 1152056 */   GIM_Try, /*On fail goto*//*Label 16837*/ GIMT_Encode4(1152136), // Rule ID 15411 //
     /* 1152061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1152069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1152072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1152075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1152078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1152081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152100 */     // MIs[0] round
     /* 1152100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152110 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1152113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152135 */     // GIR_Coverage, 15411,
     /* 1152135 */     GIR_EraseRootFromParent_Done,
     /* 1152136 */   // Label 16837: @1152136
     /* 1152136 */   GIM_Try, /*On fail goto*//*Label 16838*/ GIMT_Encode4(1152216), // Rule ID 15414 //
     /* 1152141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1152149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1152152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1152155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1152158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1152161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152180 */     // MIs[0] round
     /* 1152180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1152193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152215 */     // GIR_Coverage, 15414,
     /* 1152215 */     GIR_EraseRootFromParent_Done,
     /* 1152216 */   // Label 16838: @1152216
     /* 1152216 */   GIM_Try, /*On fail goto*//*Label 16839*/ GIMT_Encode4(1152296), // Rule ID 15415 //
     /* 1152221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1152229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1152232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1152235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1152238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1152241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152260 */     // MIs[0] round
     /* 1152260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152270 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1152273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152295 */     // GIR_Coverage, 15415,
     /* 1152295 */     GIR_EraseRootFromParent_Done,
     /* 1152296 */   // Label 16839: @1152296
     /* 1152296 */   GIM_Try, /*On fail goto*//*Label 16840*/ GIMT_Encode4(1152376), // Rule ID 15418 //
     /* 1152301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1152309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1152312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1152315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1152318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1152321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152340 */     // MIs[0] round
     /* 1152340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1152353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152375 */     // GIR_Coverage, 15418,
     /* 1152375 */     GIR_EraseRootFromParent_Done,
     /* 1152376 */   // Label 16840: @1152376
     /* 1152376 */   GIM_Try, /*On fail goto*//*Label 16841*/ GIMT_Encode4(1152456), // Rule ID 15419 //
     /* 1152381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1152389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1152392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1152395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1152398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1152401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152420 */     // MIs[0] round
     /* 1152420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152430 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1152433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152455 */     // GIR_Coverage, 15419,
     /* 1152455 */     GIR_EraseRootFromParent_Done,
     /* 1152456 */   // Label 16841: @1152456
     /* 1152456 */   GIM_Try, /*On fail goto*//*Label 16842*/ GIMT_Encode4(1152536), // Rule ID 15422 //
     /* 1152461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1152469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1152472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1152475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1152478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1152481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152500 */     // MIs[0] round
     /* 1152500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152510 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1152513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152535 */     // GIR_Coverage, 15422,
     /* 1152535 */     GIR_EraseRootFromParent_Done,
     /* 1152536 */   // Label 16842: @1152536
     /* 1152536 */   GIM_Try, /*On fail goto*//*Label 16843*/ GIMT_Encode4(1152616), // Rule ID 15423 //
     /* 1152541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1152549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1152552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1152555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1152558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1152561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152580 */     // MIs[0] round
     /* 1152580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152590 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1152593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152615 */     // GIR_Coverage, 15423,
     /* 1152615 */     GIR_EraseRootFromParent_Done,
     /* 1152616 */   // Label 16843: @1152616
     /* 1152616 */   GIM_Try, /*On fail goto*//*Label 16844*/ GIMT_Encode4(1152696), // Rule ID 15426 //
     /* 1152621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1152629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1152632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1152635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1152638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1152641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152660 */     // MIs[0] round
     /* 1152660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1152673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152695 */     // GIR_Coverage, 15426,
     /* 1152695 */     GIR_EraseRootFromParent_Done,
     /* 1152696 */   // Label 16844: @1152696
     /* 1152696 */   GIM_Try, /*On fail goto*//*Label 16845*/ GIMT_Encode4(1152776), // Rule ID 15427 //
     /* 1152701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1152709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1152712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1152715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1152718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1152721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152740 */     // MIs[0] round
     /* 1152740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152750 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1152753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152775 */     // GIR_Coverage, 15427,
     /* 1152775 */     GIR_EraseRootFromParent_Done,
     /* 1152776 */   // Label 16845: @1152776
     /* 1152776 */   GIM_Try, /*On fail goto*//*Label 16846*/ GIMT_Encode4(1152856), // Rule ID 15430 //
     /* 1152781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1152789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1152792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1152795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1152798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1152801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152820 */     // MIs[0] round
     /* 1152820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152830 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1152833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152855 */     // GIR_Coverage, 15430,
     /* 1152855 */     GIR_EraseRootFromParent_Done,
     /* 1152856 */   // Label 16846: @1152856
     /* 1152856 */   GIM_Try, /*On fail goto*//*Label 16847*/ GIMT_Encode4(1152936), // Rule ID 15431 //
     /* 1152861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1152869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1152872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1152875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1152878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1152881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152900 */     // MIs[0] round
     /* 1152900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152910 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1152913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152935 */     // GIR_Coverage, 15431,
     /* 1152935 */     GIR_EraseRootFromParent_Done,
     /* 1152936 */   // Label 16847: @1152936
     /* 1152936 */   GIM_Try, /*On fail goto*//*Label 16848*/ GIMT_Encode4(1153016), // Rule ID 15434 //
     /* 1152941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1152949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1152952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1152955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1152958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1152961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152980 */     // MIs[0] round
     /* 1152980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152990 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1152993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153015 */     // GIR_Coverage, 15434,
     /* 1153015 */     GIR_EraseRootFromParent_Done,
     /* 1153016 */   // Label 16848: @1153016
     /* 1153016 */   GIM_Try, /*On fail goto*//*Label 16849*/ GIMT_Encode4(1153096), // Rule ID 15435 //
     /* 1153021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1153029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1153032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1153035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1153038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153060 */     // MIs[0] round
     /* 1153060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153070 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1153073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153095 */     // GIR_Coverage, 15435,
     /* 1153095 */     GIR_EraseRootFromParent_Done,
     /* 1153096 */   // Label 16849: @1153096
     /* 1153096 */   GIM_Try, /*On fail goto*//*Label 16850*/ GIMT_Encode4(1153176), // Rule ID 15438 //
     /* 1153101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1153104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1153109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1153112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1153115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1153118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153140 */     // MIs[0] round
     /* 1153140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153150 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1153153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153175 */     // GIR_Coverage, 15438,
     /* 1153175 */     GIR_EraseRootFromParent_Done,
     /* 1153176 */   // Label 16850: @1153176
     /* 1153176 */   GIM_Try, /*On fail goto*//*Label 16851*/ GIMT_Encode4(1153256), // Rule ID 15439 //
     /* 1153181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1153189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1153192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1153195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1153198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153220 */     // MIs[0] round
     /* 1153220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153230 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1153233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153255 */     // GIR_Coverage, 15439,
     /* 1153255 */     GIR_EraseRootFromParent_Done,
     /* 1153256 */   // Label 16851: @1153256
     /* 1153256 */   GIM_Try, /*On fail goto*//*Label 16852*/ GIMT_Encode4(1153336), // Rule ID 15442 //
     /* 1153261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1153264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1153269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1153272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1153275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1153278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153300 */     // MIs[0] round
     /* 1153300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153310 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1153313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153335 */     // GIR_Coverage, 15442,
     /* 1153335 */     GIR_EraseRootFromParent_Done,
     /* 1153336 */   // Label 16852: @1153336
     /* 1153336 */   GIM_Try, /*On fail goto*//*Label 16853*/ GIMT_Encode4(1153416), // Rule ID 15443 //
     /* 1153341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1153349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1153352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1153355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1153358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153380 */     // MIs[0] round
     /* 1153380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153390 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1153393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153415 */     // GIR_Coverage, 15443,
     /* 1153415 */     GIR_EraseRootFromParent_Done,
     /* 1153416 */   // Label 16853: @1153416
     /* 1153416 */   GIM_Try, /*On fail goto*//*Label 16854*/ GIMT_Encode4(1153496), // Rule ID 15446 //
     /* 1153421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1153424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1153429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1153432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1153435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1153438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153460 */     // MIs[0] round
     /* 1153460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153470 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1153473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153495 */     // GIR_Coverage, 15446,
     /* 1153495 */     GIR_EraseRootFromParent_Done,
     /* 1153496 */   // Label 16854: @1153496
     /* 1153496 */   GIM_Try, /*On fail goto*//*Label 16855*/ GIMT_Encode4(1153576), // Rule ID 15447 //
     /* 1153501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1153509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1153512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1153515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1153518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153540 */     // MIs[0] round
     /* 1153540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153550 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1153553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153575 */     // GIR_Coverage, 15447,
     /* 1153575 */     GIR_EraseRootFromParent_Done,
     /* 1153576 */   // Label 16855: @1153576
     /* 1153576 */   GIM_Try, /*On fail goto*//*Label 16856*/ GIMT_Encode4(1153656), // Rule ID 15450 //
     /* 1153581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1153592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1153595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1153598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1153601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153620 */     // MIs[0] round
     /* 1153620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153630 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1153633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153655 */     // GIR_Coverage, 15450,
     /* 1153655 */     GIR_EraseRootFromParent_Done,
     /* 1153656 */   // Label 16856: @1153656
     /* 1153656 */   GIM_Try, /*On fail goto*//*Label 16857*/ GIMT_Encode4(1153736), // Rule ID 15451 //
     /* 1153661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1153672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1153675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1153678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1153681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153700 */     // MIs[0] round
     /* 1153700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153710 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1153713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153735 */     // GIR_Coverage, 15451,
     /* 1153735 */     GIR_EraseRootFromParent_Done,
     /* 1153736 */   // Label 16857: @1153736
     /* 1153736 */   GIM_Try, /*On fail goto*//*Label 16858*/ GIMT_Encode4(1153816), // Rule ID 15454 //
     /* 1153741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1153752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1153755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1153758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1153761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153780 */     // MIs[0] round
     /* 1153780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153790 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1153793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153815 */     // GIR_Coverage, 15454,
     /* 1153815 */     GIR_EraseRootFromParent_Done,
     /* 1153816 */   // Label 16858: @1153816
     /* 1153816 */   GIM_Try, /*On fail goto*//*Label 16859*/ GIMT_Encode4(1153896), // Rule ID 15455 //
     /* 1153821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1153832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1153835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1153838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1153841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153860 */     // MIs[0] round
     /* 1153860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153870 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1153873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153895 */     // GIR_Coverage, 15455,
     /* 1153895 */     GIR_EraseRootFromParent_Done,
     /* 1153896 */   // Label 16859: @1153896
     /* 1153896 */   GIM_Try, /*On fail goto*//*Label 16860*/ GIMT_Encode4(1153976), // Rule ID 15458 //
     /* 1153901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1153912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1153915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1153918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1153921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153940 */     // MIs[0] round
     /* 1153940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153950 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1153953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153975 */     // GIR_Coverage, 15458,
     /* 1153975 */     GIR_EraseRootFromParent_Done,
     /* 1153976 */   // Label 16860: @1153976
     /* 1153976 */   GIM_Try, /*On fail goto*//*Label 16861*/ GIMT_Encode4(1154056), // Rule ID 15459 //
     /* 1153981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1153992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1153995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1153998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1154001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154020 */     // MIs[0] round
     /* 1154020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154030 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1154033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154055 */     // GIR_Coverage, 15459,
     /* 1154055 */     GIR_EraseRootFromParent_Done,
     /* 1154056 */   // Label 16861: @1154056
     /* 1154056 */   GIM_Try, /*On fail goto*//*Label 16862*/ GIMT_Encode4(1154136), // Rule ID 15462 //
     /* 1154061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1154072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1154075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1154078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1154081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154100 */     // MIs[0] round
     /* 1154100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154110 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1154113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154135 */     // GIR_Coverage, 15462,
     /* 1154135 */     GIR_EraseRootFromParent_Done,
     /* 1154136 */   // Label 16862: @1154136
     /* 1154136 */   GIM_Try, /*On fail goto*//*Label 16863*/ GIMT_Encode4(1154216), // Rule ID 15463 //
     /* 1154141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1154152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1154155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1154158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1154161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154180 */     // MIs[0] round
     /* 1154180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1154193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154215 */     // GIR_Coverage, 15463,
     /* 1154215 */     GIR_EraseRootFromParent_Done,
     /* 1154216 */   // Label 16863: @1154216
     /* 1154216 */   GIM_Try, /*On fail goto*//*Label 16864*/ GIMT_Encode4(1154296), // Rule ID 15466 //
     /* 1154221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1154232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1154235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1154238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1154241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154260 */     // MIs[0] round
     /* 1154260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154270 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1154273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154295 */     // GIR_Coverage, 15466,
     /* 1154295 */     GIR_EraseRootFromParent_Done,
     /* 1154296 */   // Label 16864: @1154296
     /* 1154296 */   GIM_Try, /*On fail goto*//*Label 16865*/ GIMT_Encode4(1154376), // Rule ID 15467 //
     /* 1154301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1154312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1154315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1154318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1154321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154340 */     // MIs[0] round
     /* 1154340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154350 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1154353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154375 */     // GIR_Coverage, 15467,
     /* 1154375 */     GIR_EraseRootFromParent_Done,
     /* 1154376 */   // Label 16865: @1154376
     /* 1154376 */   GIM_Try, /*On fail goto*//*Label 16866*/ GIMT_Encode4(1154456), // Rule ID 15470 //
     /* 1154381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1154392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1154395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1154398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1154401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154420 */     // MIs[0] round
     /* 1154420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154430 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1154433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154455 */     // GIR_Coverage, 15470,
     /* 1154455 */     GIR_EraseRootFromParent_Done,
     /* 1154456 */   // Label 16866: @1154456
     /* 1154456 */   GIM_Try, /*On fail goto*//*Label 16867*/ GIMT_Encode4(1154536), // Rule ID 15471 //
     /* 1154461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1154472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1154475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1154478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1154481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154500 */     // MIs[0] round
     /* 1154500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154510 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1154513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154535 */     // GIR_Coverage, 15471,
     /* 1154535 */     GIR_EraseRootFromParent_Done,
     /* 1154536 */   // Label 16867: @1154536
     /* 1154536 */   GIM_Try, /*On fail goto*//*Label 16868*/ GIMT_Encode4(1154616), // Rule ID 15474 //
     /* 1154541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1154552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1154555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1154558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1154561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154580 */     // MIs[0] round
     /* 1154580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154590 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1154593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154615 */     // GIR_Coverage, 15474,
     /* 1154615 */     GIR_EraseRootFromParent_Done,
     /* 1154616 */   // Label 16868: @1154616
     /* 1154616 */   GIM_Try, /*On fail goto*//*Label 16869*/ GIMT_Encode4(1154696), // Rule ID 15475 //
     /* 1154621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1154632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1154635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1154638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1154641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154660 */     // MIs[0] round
     /* 1154660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154670 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1154673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154695 */     // GIR_Coverage, 15475,
     /* 1154695 */     GIR_EraseRootFromParent_Done,
     /* 1154696 */   // Label 16869: @1154696
     /* 1154696 */   GIM_Try, /*On fail goto*//*Label 16870*/ GIMT_Encode4(1154776), // Rule ID 15478 //
     /* 1154701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1154712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1154715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1154718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1154721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154740 */     // MIs[0] round
     /* 1154740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1154753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154775 */     // GIR_Coverage, 15478,
     /* 1154775 */     GIR_EraseRootFromParent_Done,
     /* 1154776 */   // Label 16870: @1154776
     /* 1154776 */   GIM_Try, /*On fail goto*//*Label 16871*/ GIMT_Encode4(1154856), // Rule ID 15479 //
     /* 1154781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1154792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1154795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1154798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1154801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154820 */     // MIs[0] round
     /* 1154820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154830 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1154833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154855 */     // GIR_Coverage, 15479,
     /* 1154855 */     GIR_EraseRootFromParent_Done,
     /* 1154856 */   // Label 16871: @1154856
     /* 1154856 */   GIM_Try, /*On fail goto*//*Label 16872*/ GIMT_Encode4(1154936), // Rule ID 15482 //
     /* 1154861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1154872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1154875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1154878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1154881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154900 */     // MIs[0] round
     /* 1154900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154910 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1154913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154935 */     // GIR_Coverage, 15482,
     /* 1154935 */     GIR_EraseRootFromParent_Done,
     /* 1154936 */   // Label 16872: @1154936
     /* 1154936 */   GIM_Try, /*On fail goto*//*Label 16873*/ GIMT_Encode4(1155016), // Rule ID 15483 //
     /* 1154941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1154952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1154955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1154958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1154961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154980 */     // MIs[0] round
     /* 1154980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1154993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155015 */     // GIR_Coverage, 15483,
     /* 1155015 */     GIR_EraseRootFromParent_Done,
     /* 1155016 */   // Label 16873: @1155016
     /* 1155016 */   GIM_Try, /*On fail goto*//*Label 16874*/ GIMT_Encode4(1155096), // Rule ID 15486 //
     /* 1155021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1155024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1155032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1155035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1155038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1155041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155060 */     // MIs[0] round
     /* 1155060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155070 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1155073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1155091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155095 */     // GIR_Coverage, 15486,
     /* 1155095 */     GIR_EraseRootFromParent_Done,
     /* 1155096 */   // Label 16874: @1155096
     /* 1155096 */   GIM_Try, /*On fail goto*//*Label 16875*/ GIMT_Encode4(1155176), // Rule ID 15487 //
     /* 1155101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1155104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1155112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1155115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1155118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1155121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155140 */     // MIs[0] round
     /* 1155140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155150 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1155153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1155171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155175 */     // GIR_Coverage, 15487,
     /* 1155175 */     GIR_EraseRootFromParent_Done,
     /* 1155176 */   // Label 16875: @1155176
     /* 1155176 */   GIM_Try, /*On fail goto*//*Label 16876*/ GIMT_Encode4(1155256), // Rule ID 15490 //
     /* 1155181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1155192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1155195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1155198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1155201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155220 */     // MIs[0] round
     /* 1155220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1155233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155255 */     // GIR_Coverage, 15490,
     /* 1155255 */     GIR_EraseRootFromParent_Done,
     /* 1155256 */   // Label 16876: @1155256
     /* 1155256 */   GIM_Try, /*On fail goto*//*Label 16877*/ GIMT_Encode4(1155336), // Rule ID 15491 //
     /* 1155261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1155272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1155275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1155278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1155281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155300 */     // MIs[0] round
     /* 1155300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155310 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1155313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155335 */     // GIR_Coverage, 15491,
     /* 1155335 */     GIR_EraseRootFromParent_Done,
     /* 1155336 */   // Label 16877: @1155336
     /* 1155336 */   GIM_Try, /*On fail goto*//*Label 16878*/ GIMT_Encode4(1155416), // Rule ID 15494 //
     /* 1155341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1155352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1155355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1155358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1155361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155380 */     // MIs[0] round
     /* 1155380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155390 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1155393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155415 */     // GIR_Coverage, 15494,
     /* 1155415 */     GIR_EraseRootFromParent_Done,
     /* 1155416 */   // Label 16878: @1155416
     /* 1155416 */   GIM_Try, /*On fail goto*//*Label 16879*/ GIMT_Encode4(1155496), // Rule ID 15495 //
     /* 1155421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1155432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1155435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1155438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1155441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155460 */     // MIs[0] round
     /* 1155460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155470 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1155473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155495 */     // GIR_Coverage, 15495,
     /* 1155495 */     GIR_EraseRootFromParent_Done,
     /* 1155496 */   // Label 16879: @1155496
     /* 1155496 */   GIM_Try, /*On fail goto*//*Label 16880*/ GIMT_Encode4(1155576), // Rule ID 15498 //
     /* 1155501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1155512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1155515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1155518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1155521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155540 */     // MIs[0] round
     /* 1155540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155550 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1155553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155575 */     // GIR_Coverage, 15498,
     /* 1155575 */     GIR_EraseRootFromParent_Done,
     /* 1155576 */   // Label 16880: @1155576
     /* 1155576 */   GIM_Try, /*On fail goto*//*Label 16881*/ GIMT_Encode4(1155656), // Rule ID 15499 //
     /* 1155581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1155592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1155595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1155598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1155601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155620 */     // MIs[0] round
     /* 1155620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155630 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1155633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155655 */     // GIR_Coverage, 15499,
     /* 1155655 */     GIR_EraseRootFromParent_Done,
     /* 1155656 */   // Label 16881: @1155656
     /* 1155656 */   GIM_Try, /*On fail goto*//*Label 16882*/ GIMT_Encode4(1155736), // Rule ID 15502 //
     /* 1155661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1155672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1155675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1155678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1155681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155700 */     // MIs[0] round
     /* 1155700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155710 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1155713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155735 */     // GIR_Coverage, 15502,
     /* 1155735 */     GIR_EraseRootFromParent_Done,
     /* 1155736 */   // Label 16882: @1155736
     /* 1155736 */   GIM_Try, /*On fail goto*//*Label 16883*/ GIMT_Encode4(1155816), // Rule ID 15503 //
     /* 1155741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1155752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1155755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1155758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1155761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155780 */     // MIs[0] round
     /* 1155780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1155793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155815 */     // GIR_Coverage, 15503,
     /* 1155815 */     GIR_EraseRootFromParent_Done,
     /* 1155816 */   // Label 16883: @1155816
     /* 1155816 */   GIM_Try, /*On fail goto*//*Label 16884*/ GIMT_Encode4(1155896), // Rule ID 15506 //
     /* 1155821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1155832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1155835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1155838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1155841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155860 */     // MIs[0] round
     /* 1155860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155870 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1155873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155895 */     // GIR_Coverage, 15506,
     /* 1155895 */     GIR_EraseRootFromParent_Done,
     /* 1155896 */   // Label 16884: @1155896
     /* 1155896 */   GIM_Try, /*On fail goto*//*Label 16885*/ GIMT_Encode4(1155976), // Rule ID 15507 //
     /* 1155901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1155912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1155915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1155918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1155921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155940 */     // MIs[0] round
     /* 1155940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155950 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1155953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155975 */     // GIR_Coverage, 15507,
     /* 1155975 */     GIR_EraseRootFromParent_Done,
     /* 1155976 */   // Label 16885: @1155976
     /* 1155976 */   GIM_Try, /*On fail goto*//*Label 16886*/ GIMT_Encode4(1156056), // Rule ID 15510 //
     /* 1155981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1155992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1155995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1155998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1156001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156020 */     // MIs[0] round
     /* 1156020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156030 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1156033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156055 */     // GIR_Coverage, 15510,
     /* 1156055 */     GIR_EraseRootFromParent_Done,
     /* 1156056 */   // Label 16886: @1156056
     /* 1156056 */   GIM_Try, /*On fail goto*//*Label 16887*/ GIMT_Encode4(1156136), // Rule ID 15511 //
     /* 1156061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1156072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1156075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1156078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1156081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156100 */     // MIs[0] round
     /* 1156100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156110 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1156113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156135 */     // GIR_Coverage, 15511,
     /* 1156135 */     GIR_EraseRootFromParent_Done,
     /* 1156136 */   // Label 16887: @1156136
     /* 1156136 */   GIM_Try, /*On fail goto*//*Label 16888*/ GIMT_Encode4(1156216), // Rule ID 15514 //
     /* 1156141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1156152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1156155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1156158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1156161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156180 */     // MIs[0] round
     /* 1156180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1156193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156215 */     // GIR_Coverage, 15514,
     /* 1156215 */     GIR_EraseRootFromParent_Done,
     /* 1156216 */   // Label 16888: @1156216
     /* 1156216 */   GIM_Try, /*On fail goto*//*Label 16889*/ GIMT_Encode4(1156296), // Rule ID 15515 //
     /* 1156221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1156232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1156235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1156238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1156241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156260 */     // MIs[0] round
     /* 1156260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1156273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156295 */     // GIR_Coverage, 15515,
     /* 1156295 */     GIR_EraseRootFromParent_Done,
     /* 1156296 */   // Label 16889: @1156296
     /* 1156296 */   GIM_Try, /*On fail goto*//*Label 16890*/ GIMT_Encode4(1156376), // Rule ID 15518 //
     /* 1156301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1156312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1156315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1156318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1156321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156340 */     // MIs[0] round
     /* 1156340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156350 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1156353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156375 */     // GIR_Coverage, 15518,
     /* 1156375 */     GIR_EraseRootFromParent_Done,
     /* 1156376 */   // Label 16890: @1156376
     /* 1156376 */   GIM_Try, /*On fail goto*//*Label 16891*/ GIMT_Encode4(1156456), // Rule ID 15519 //
     /* 1156381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1156392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1156395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1156398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1156401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156420 */     // MIs[0] round
     /* 1156420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1156433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156455 */     // GIR_Coverage, 15519,
     /* 1156455 */     GIR_EraseRootFromParent_Done,
     /* 1156456 */   // Label 16891: @1156456
     /* 1156456 */   GIM_Try, /*On fail goto*//*Label 16892*/ GIMT_Encode4(1156536), // Rule ID 15522 //
     /* 1156461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1156472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1156475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1156478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1156481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156500 */     // MIs[0] round
     /* 1156500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156510 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1156513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156535 */     // GIR_Coverage, 15522,
     /* 1156535 */     GIR_EraseRootFromParent_Done,
     /* 1156536 */   // Label 16892: @1156536
     /* 1156536 */   GIM_Try, /*On fail goto*//*Label 16893*/ GIMT_Encode4(1156616), // Rule ID 15523 //
     /* 1156541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1156552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1156555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1156558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1156561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156580 */     // MIs[0] round
     /* 1156580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156590 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1156593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156615 */     // GIR_Coverage, 15523,
     /* 1156615 */     GIR_EraseRootFromParent_Done,
     /* 1156616 */   // Label 16893: @1156616
     /* 1156616 */   GIM_Try, /*On fail goto*//*Label 16894*/ GIMT_Encode4(1156696), // Rule ID 15526 //
     /* 1156621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1156632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1156635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1156638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1156641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156660 */     // MIs[0] round
     /* 1156660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1156673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156695 */     // GIR_Coverage, 15526,
     /* 1156695 */     GIR_EraseRootFromParent_Done,
     /* 1156696 */   // Label 16894: @1156696
     /* 1156696 */   GIM_Try, /*On fail goto*//*Label 16895*/ GIMT_Encode4(1156776), // Rule ID 15527 //
     /* 1156701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1156704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1156712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1156715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1156718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1156721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156740 */     // MIs[0] round
     /* 1156740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156750 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1156753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156775 */     // GIR_Coverage, 15527,
     /* 1156775 */     GIR_EraseRootFromParent_Done,
     /* 1156776 */   // Label 16895: @1156776
     /* 1156776 */   GIM_Try, /*On fail goto*//*Label 16896*/ GIMT_Encode4(1156856), // Rule ID 15530 //
     /* 1156781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1156792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1156795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1156798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1156801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156820 */     // MIs[0] round
     /* 1156820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156830 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1156833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156855 */     // GIR_Coverage, 15530,
     /* 1156855 */     GIR_EraseRootFromParent_Done,
     /* 1156856 */   // Label 16896: @1156856
     /* 1156856 */   GIM_Try, /*On fail goto*//*Label 16897*/ GIMT_Encode4(1156936), // Rule ID 15531 //
     /* 1156861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1156864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1156872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1156875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1156878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1156881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156900 */     // MIs[0] round
     /* 1156900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156910 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1156913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156935 */     // GIR_Coverage, 15531,
     /* 1156935 */     GIR_EraseRootFromParent_Done,
     /* 1156936 */   // Label 16897: @1156936
     /* 1156936 */   GIM_Try, /*On fail goto*//*Label 16898*/ GIMT_Encode4(1157016), // Rule ID 15534 //
     /* 1156941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1156952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1156955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1156958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1156961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156980 */     // MIs[0] round
     /* 1156980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156990 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1156993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1157011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157015 */     // GIR_Coverage, 15534,
     /* 1157015 */     GIR_EraseRootFromParent_Done,
     /* 1157016 */   // Label 16898: @1157016
     /* 1157016 */   GIM_Try, /*On fail goto*//*Label 16899*/ GIMT_Encode4(1157096), // Rule ID 15535 //
     /* 1157021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1157024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1157032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1157035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1157038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1157041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157060 */     // MIs[0] round
     /* 1157060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157070 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1157073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1157091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157095 */     // GIR_Coverage, 15535,
     /* 1157095 */     GIR_EraseRootFromParent_Done,
     /* 1157096 */   // Label 16899: @1157096
     /* 1157096 */   GIM_Try, /*On fail goto*//*Label 16900*/ GIMT_Encode4(1157176), // Rule ID 15538 //
     /* 1157101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1157112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1157115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1157118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157140 */     // MIs[0] round
     /* 1157140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157150 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1157153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157175 */     // GIR_Coverage, 15538,
     /* 1157175 */     GIR_EraseRootFromParent_Done,
     /* 1157176 */   // Label 16900: @1157176
     /* 1157176 */   GIM_Try, /*On fail goto*//*Label 16901*/ GIMT_Encode4(1157256), // Rule ID 15539 //
     /* 1157181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1157192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1157195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1157198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157220 */     // MIs[0] round
     /* 1157220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157230 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1157233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157255 */     // GIR_Coverage, 15539,
     /* 1157255 */     GIR_EraseRootFromParent_Done,
     /* 1157256 */   // Label 16901: @1157256
     /* 1157256 */   GIM_Try, /*On fail goto*//*Label 16902*/ GIMT_Encode4(1157336), // Rule ID 15542 //
     /* 1157261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1157272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1157275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1157278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157300 */     // MIs[0] round
     /* 1157300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157310 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1157313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157335 */     // GIR_Coverage, 15542,
     /* 1157335 */     GIR_EraseRootFromParent_Done,
     /* 1157336 */   // Label 16902: @1157336
     /* 1157336 */   GIM_Try, /*On fail goto*//*Label 16903*/ GIMT_Encode4(1157416), // Rule ID 15543 //
     /* 1157341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1157352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1157355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1157358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157380 */     // MIs[0] round
     /* 1157380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157390 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1157393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157415 */     // GIR_Coverage, 15543,
     /* 1157415 */     GIR_EraseRootFromParent_Done,
     /* 1157416 */   // Label 16903: @1157416
     /* 1157416 */   GIM_Try, /*On fail goto*//*Label 16904*/ GIMT_Encode4(1157496), // Rule ID 15546 //
     /* 1157421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1157432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1157435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1157438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157460 */     // MIs[0] round
     /* 1157460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157470 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1157473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157495 */     // GIR_Coverage, 15546,
     /* 1157495 */     GIR_EraseRootFromParent_Done,
     /* 1157496 */   // Label 16904: @1157496
     /* 1157496 */   GIM_Try, /*On fail goto*//*Label 16905*/ GIMT_Encode4(1157576), // Rule ID 15547 //
     /* 1157501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1157512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1157515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1157518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157540 */     // MIs[0] round
     /* 1157540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157550 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1157553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157575 */     // GIR_Coverage, 15547,
     /* 1157575 */     GIR_EraseRootFromParent_Done,
     /* 1157576 */   // Label 16905: @1157576
     /* 1157576 */   GIM_Try, /*On fail goto*//*Label 16906*/ GIMT_Encode4(1157656), // Rule ID 15550 //
     /* 1157581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1157592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1157595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1157598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157620 */     // MIs[0] round
     /* 1157620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1157633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157655 */     // GIR_Coverage, 15550,
     /* 1157655 */     GIR_EraseRootFromParent_Done,
     /* 1157656 */   // Label 16906: @1157656
     /* 1157656 */   GIM_Try, /*On fail goto*//*Label 16907*/ GIMT_Encode4(1157736), // Rule ID 15551 //
     /* 1157661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1157672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1157675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1157678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157700 */     // MIs[0] round
     /* 1157700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157710 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1157713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157735 */     // GIR_Coverage, 15551,
     /* 1157735 */     GIR_EraseRootFromParent_Done,
     /* 1157736 */   // Label 16907: @1157736
     /* 1157736 */   GIM_Try, /*On fail goto*//*Label 16908*/ GIMT_Encode4(1157816), // Rule ID 15554 //
     /* 1157741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1157752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1157755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1157758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157780 */     // MIs[0] round
     /* 1157780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157790 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1157793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157815 */     // GIR_Coverage, 15554,
     /* 1157815 */     GIR_EraseRootFromParent_Done,
     /* 1157816 */   // Label 16908: @1157816
     /* 1157816 */   GIM_Try, /*On fail goto*//*Label 16909*/ GIMT_Encode4(1157896), // Rule ID 15555 //
     /* 1157821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1157832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1157835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1157838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157860 */     // MIs[0] round
     /* 1157860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157870 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1157873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157895 */     // GIR_Coverage, 15555,
     /* 1157895 */     GIR_EraseRootFromParent_Done,
     /* 1157896 */   // Label 16909: @1157896
     /* 1157896 */   GIM_Try, /*On fail goto*//*Label 16910*/ GIMT_Encode4(1157976), // Rule ID 15558 //
     /* 1157901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1157912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1157915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1157918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157940 */     // MIs[0] round
     /* 1157940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157950 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1157953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157975 */     // GIR_Coverage, 15558,
     /* 1157975 */     GIR_EraseRootFromParent_Done,
     /* 1157976 */   // Label 16910: @1157976
     /* 1157976 */   GIM_Try, /*On fail goto*//*Label 16911*/ GIMT_Encode4(1158056), // Rule ID 15559 //
     /* 1157981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1157992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1157995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1157998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158020 */     // MIs[0] round
     /* 1158020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158030 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1158033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158055 */     // GIR_Coverage, 15559,
     /* 1158055 */     GIR_EraseRootFromParent_Done,
     /* 1158056 */   // Label 16911: @1158056
     /* 1158056 */   GIM_Try, /*On fail goto*//*Label 16912*/ GIMT_Encode4(1158136), // Rule ID 15562 //
     /* 1158061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1158069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1158072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1158075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1158078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158100 */     // MIs[0] round
     /* 1158100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158110 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1158113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158135 */     // GIR_Coverage, 15562,
     /* 1158135 */     GIR_EraseRootFromParent_Done,
     /* 1158136 */   // Label 16912: @1158136
     /* 1158136 */   GIM_Try, /*On fail goto*//*Label 16913*/ GIMT_Encode4(1158216), // Rule ID 15563 //
     /* 1158141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1158149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1158152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1158155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1158158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158180 */     // MIs[0] round
     /* 1158180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158190 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1158193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158215 */     // GIR_Coverage, 15563,
     /* 1158215 */     GIR_EraseRootFromParent_Done,
     /* 1158216 */   // Label 16913: @1158216
     /* 1158216 */   GIM_Try, /*On fail goto*//*Label 16914*/ GIMT_Encode4(1158296), // Rule ID 15566 //
     /* 1158221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1158229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1158232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1158235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1158238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158260 */     // MIs[0] round
     /* 1158260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158270 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1158273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158295 */     // GIR_Coverage, 15566,
     /* 1158295 */     GIR_EraseRootFromParent_Done,
     /* 1158296 */   // Label 16914: @1158296
     /* 1158296 */   GIM_Try, /*On fail goto*//*Label 16915*/ GIMT_Encode4(1158376), // Rule ID 15567 //
     /* 1158301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1158309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1158312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1158315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1158318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158340 */     // MIs[0] round
     /* 1158340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158350 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1158353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158375 */     // GIR_Coverage, 15567,
     /* 1158375 */     GIR_EraseRootFromParent_Done,
     /* 1158376 */   // Label 16915: @1158376
     /* 1158376 */   GIM_Try, /*On fail goto*//*Label 16916*/ GIMT_Encode4(1158456), // Rule ID 15570 //
     /* 1158381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1158389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1158392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1158395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1158398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158420 */     // MIs[0] round
     /* 1158420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158430 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1158433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158455 */     // GIR_Coverage, 15570,
     /* 1158455 */     GIR_EraseRootFromParent_Done,
     /* 1158456 */   // Label 16916: @1158456
     /* 1158456 */   GIM_Try, /*On fail goto*//*Label 16917*/ GIMT_Encode4(1158536), // Rule ID 15571 //
     /* 1158461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1158469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1158472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1158475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1158478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158500 */     // MIs[0] round
     /* 1158500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158510 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1158513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158535 */     // GIR_Coverage, 15571,
     /* 1158535 */     GIR_EraseRootFromParent_Done,
     /* 1158536 */   // Label 16917: @1158536
     /* 1158536 */   GIM_Try, /*On fail goto*//*Label 16918*/ GIMT_Encode4(1158616), // Rule ID 15574 //
     /* 1158541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1158544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1158549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1158552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1158555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1158558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158580 */     // MIs[0] round
     /* 1158580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158590 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1158593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1158611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158615 */     // GIR_Coverage, 15574,
     /* 1158615 */     GIR_EraseRootFromParent_Done,
     /* 1158616 */   // Label 16918: @1158616
     /* 1158616 */   GIM_Try, /*On fail goto*//*Label 16919*/ GIMT_Encode4(1158696), // Rule ID 15575 //
     /* 1158621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1158624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1158629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1158632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1158635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1158638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158660 */     // MIs[0] round
     /* 1158660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158670 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1158673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1158691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158695 */     // GIR_Coverage, 15575,
     /* 1158695 */     GIR_EraseRootFromParent_Done,
     /* 1158696 */   // Label 16919: @1158696
     /* 1158696 */   GIM_Try, /*On fail goto*//*Label 16920*/ GIMT_Encode4(1158776), // Rule ID 15578 //
     /* 1158701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1158709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1158712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1158715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1158718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158740 */     // MIs[0] round
     /* 1158740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158750 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1158753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158775 */     // GIR_Coverage, 15578,
     /* 1158775 */     GIR_EraseRootFromParent_Done,
     /* 1158776 */   // Label 16920: @1158776
     /* 1158776 */   GIM_Try, /*On fail goto*//*Label 16921*/ GIMT_Encode4(1158856), // Rule ID 15579 //
     /* 1158781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1158789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1158792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1158795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1158798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158820 */     // MIs[0] round
     /* 1158820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158830 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1158833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158855 */     // GIR_Coverage, 15579,
     /* 1158855 */     GIR_EraseRootFromParent_Done,
     /* 1158856 */   // Label 16921: @1158856
     /* 1158856 */   GIM_Try, /*On fail goto*//*Label 16922*/ GIMT_Encode4(1158936), // Rule ID 15582 //
     /* 1158861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1158869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1158872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1158875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1158878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158900 */     // MIs[0] round
     /* 1158900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158910 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1158913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158935 */     // GIR_Coverage, 15582,
     /* 1158935 */     GIR_EraseRootFromParent_Done,
     /* 1158936 */   // Label 16922: @1158936
     /* 1158936 */   GIM_Try, /*On fail goto*//*Label 16923*/ GIMT_Encode4(1159016), // Rule ID 15583 //
     /* 1158941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1158949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1158952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1158955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1158958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158980 */     // MIs[0] round
     /* 1158980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158990 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1158993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159015 */     // GIR_Coverage, 15583,
     /* 1159015 */     GIR_EraseRootFromParent_Done,
     /* 1159016 */   // Label 16923: @1159016
     /* 1159016 */   GIM_Try, /*On fail goto*//*Label 16924*/ GIMT_Encode4(1159096), // Rule ID 15586 //
     /* 1159021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1159029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1159032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1159035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1159038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159060 */     // MIs[0] round
     /* 1159060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159070 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1159073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159095 */     // GIR_Coverage, 15586,
     /* 1159095 */     GIR_EraseRootFromParent_Done,
     /* 1159096 */   // Label 16924: @1159096
     /* 1159096 */   GIM_Try, /*On fail goto*//*Label 16925*/ GIMT_Encode4(1159176), // Rule ID 15587 //
     /* 1159101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1159109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1159112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1159115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1159118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159140 */     // MIs[0] round
     /* 1159140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159150 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1159153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159175 */     // GIR_Coverage, 15587,
     /* 1159175 */     GIR_EraseRootFromParent_Done,
     /* 1159176 */   // Label 16925: @1159176
     /* 1159176 */   GIM_Try, /*On fail goto*//*Label 16926*/ GIMT_Encode4(1159256), // Rule ID 15590 //
     /* 1159181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1159189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1159192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1159195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1159198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159220 */     // MIs[0] round
     /* 1159220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159230 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1159233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159255 */     // GIR_Coverage, 15590,
     /* 1159255 */     GIR_EraseRootFromParent_Done,
     /* 1159256 */   // Label 16926: @1159256
     /* 1159256 */   GIM_Try, /*On fail goto*//*Label 16927*/ GIMT_Encode4(1159336), // Rule ID 15591 //
     /* 1159261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1159269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1159272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1159275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1159278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159300 */     // MIs[0] round
     /* 1159300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159310 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1159313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159335 */     // GIR_Coverage, 15591,
     /* 1159335 */     GIR_EraseRootFromParent_Done,
     /* 1159336 */   // Label 16927: @1159336
     /* 1159336 */   GIM_Try, /*On fail goto*//*Label 16928*/ GIMT_Encode4(1159416), // Rule ID 15594 //
     /* 1159341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1159349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1159352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1159355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1159358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159380 */     // MIs[0] round
     /* 1159380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159390 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1159393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159415 */     // GIR_Coverage, 15594,
     /* 1159415 */     GIR_EraseRootFromParent_Done,
     /* 1159416 */   // Label 16928: @1159416
     /* 1159416 */   GIM_Try, /*On fail goto*//*Label 16929*/ GIMT_Encode4(1159496), // Rule ID 15595 //
     /* 1159421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1159429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1159432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1159435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1159438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159460 */     // MIs[0] round
     /* 1159460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159470 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1159473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159495 */     // GIR_Coverage, 15595,
     /* 1159495 */     GIR_EraseRootFromParent_Done,
     /* 1159496 */   // Label 16929: @1159496
     /* 1159496 */   GIM_Try, /*On fail goto*//*Label 16930*/ GIMT_Encode4(1159576), // Rule ID 15598 //
     /* 1159501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1159509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1159512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1159515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1159518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159540 */     // MIs[0] round
     /* 1159540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159550 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1159553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159575 */     // GIR_Coverage, 15598,
     /* 1159575 */     GIR_EraseRootFromParent_Done,
     /* 1159576 */   // Label 16930: @1159576
     /* 1159576 */   GIM_Try, /*On fail goto*//*Label 16931*/ GIMT_Encode4(1159656), // Rule ID 15599 //
     /* 1159581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1159589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1159592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1159595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1159598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159620 */     // MIs[0] round
     /* 1159620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159630 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1159633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159655 */     // GIR_Coverage, 15599,
     /* 1159655 */     GIR_EraseRootFromParent_Done,
     /* 1159656 */   // Label 16931: @1159656
     /* 1159656 */   GIM_Try, /*On fail goto*//*Label 16932*/ GIMT_Encode4(1159736), // Rule ID 15602 //
     /* 1159661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1159669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1159672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1159675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1159678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159700 */     // MIs[0] round
     /* 1159700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1159713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159735 */     // GIR_Coverage, 15602,
     /* 1159735 */     GIR_EraseRootFromParent_Done,
     /* 1159736 */   // Label 16932: @1159736
     /* 1159736 */   GIM_Try, /*On fail goto*//*Label 16933*/ GIMT_Encode4(1159816), // Rule ID 15603 //
     /* 1159741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1159749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1159752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1159755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1159758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159780 */     // MIs[0] round
     /* 1159780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1159793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159815 */     // GIR_Coverage, 15603,
     /* 1159815 */     GIR_EraseRootFromParent_Done,
     /* 1159816 */   // Label 16933: @1159816
     /* 1159816 */   GIM_Try, /*On fail goto*//*Label 16934*/ GIMT_Encode4(1159896), // Rule ID 15606 //
     /* 1159821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1159829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1159832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1159835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1159838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159860 */     // MIs[0] round
     /* 1159860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159870 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1159873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159895 */     // GIR_Coverage, 15606,
     /* 1159895 */     GIR_EraseRootFromParent_Done,
     /* 1159896 */   // Label 16934: @1159896
     /* 1159896 */   GIM_Try, /*On fail goto*//*Label 16935*/ GIMT_Encode4(1159976), // Rule ID 15607 //
     /* 1159901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1159909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1159912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1159915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1159918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159940 */     // MIs[0] round
     /* 1159940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159950 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1159953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159975 */     // GIR_Coverage, 15607,
     /* 1159975 */     GIR_EraseRootFromParent_Done,
     /* 1159976 */   // Label 16935: @1159976
     /* 1159976 */   GIM_Try, /*On fail goto*//*Label 16936*/ GIMT_Encode4(1160056), // Rule ID 15610 //
     /* 1159981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1159989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1159992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1159995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1159998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160020 */     // MIs[0] round
     /* 1160020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1160033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160055 */     // GIR_Coverage, 15610,
     /* 1160055 */     GIR_EraseRootFromParent_Done,
     /* 1160056 */   // Label 16936: @1160056
     /* 1160056 */   GIM_Try, /*On fail goto*//*Label 16937*/ GIMT_Encode4(1160136), // Rule ID 15611 //
     /* 1160061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1160069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1160072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1160075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1160078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160100 */     // MIs[0] round
     /* 1160100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160110 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1160113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160135 */     // GIR_Coverage, 15611,
     /* 1160135 */     GIR_EraseRootFromParent_Done,
     /* 1160136 */   // Label 16937: @1160136
     /* 1160136 */   GIM_Try, /*On fail goto*//*Label 16938*/ GIMT_Encode4(1160216), // Rule ID 15614 //
     /* 1160141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1160144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1160149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1160152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1160155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1160158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1160168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1160172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1160176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160180 */     // MIs[0] round
     /* 1160180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1160193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1160211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160215 */     // GIR_Coverage, 15614,
     /* 1160215 */     GIR_EraseRootFromParent_Done,
     /* 1160216 */   // Label 16938: @1160216
     /* 1160216 */   GIM_Try, /*On fail goto*//*Label 16939*/ GIMT_Encode4(1160296), // Rule ID 15615 //
     /* 1160221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1160224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1160229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1160232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1160235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1160238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1160248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1160252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1160256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160260 */     // MIs[0] round
     /* 1160260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160270 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1160273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1160291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160295 */     // GIR_Coverage, 15615,
     /* 1160295 */     GIR_EraseRootFromParent_Done,
     /* 1160296 */   // Label 16939: @1160296
     /* 1160296 */   GIM_Try, /*On fail goto*//*Label 16940*/ GIMT_Encode4(1160376), // Rule ID 15618 //
     /* 1160301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1160304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1160309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1160312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1160315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1160318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160340 */     // MIs[0] round
     /* 1160340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160350 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1160353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1160371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160375 */     // GIR_Coverage, 15618,
     /* 1160375 */     GIR_EraseRootFromParent_Done,
     /* 1160376 */   // Label 16940: @1160376
     /* 1160376 */   GIM_Try, /*On fail goto*//*Label 16941*/ GIMT_Encode4(1160456), // Rule ID 15619 //
     /* 1160381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1160384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1160389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1160392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1160395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1160398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160420 */     // MIs[0] round
     /* 1160420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160430 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1160433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1160451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160455 */     // GIR_Coverage, 15619,
     /* 1160455 */     GIR_EraseRootFromParent_Done,
     /* 1160456 */   // Label 16941: @1160456
     /* 1160456 */   GIM_Try, /*On fail goto*//*Label 16942*/ GIMT_Encode4(1160536), // Rule ID 15622 //
     /* 1160461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1160464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1160469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1160472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1160475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1160478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160500 */     // MIs[0] round
     /* 1160500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160510 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1160513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1160531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160535 */     // GIR_Coverage, 15622,
     /* 1160535 */     GIR_EraseRootFromParent_Done,
     /* 1160536 */   // Label 16942: @1160536
     /* 1160536 */   GIM_Try, /*On fail goto*//*Label 16943*/ GIMT_Encode4(1160616), // Rule ID 15623 //
     /* 1160541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1160544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1160549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1160552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1160555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1160558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160580 */     // MIs[0] round
     /* 1160580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1160593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1160611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160615 */     // GIR_Coverage, 15623,
     /* 1160615 */     GIR_EraseRootFromParent_Done,
     /* 1160616 */   // Label 16943: @1160616
     /* 1160616 */   GIM_Try, /*On fail goto*//*Label 16944*/ GIMT_Encode4(1160699), // Rule ID 15626 //
     /* 1160621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1160632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1160635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1160638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1160641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160660 */     // MIs[0] round
     /* 1160660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160670 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1160673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160698 */     // GIR_Coverage, 15626,
     /* 1160698 */     GIR_EraseRootFromParent_Done,
     /* 1160699 */   // Label 16944: @1160699
     /* 1160699 */   GIM_Try, /*On fail goto*//*Label 16945*/ GIMT_Encode4(1160782), // Rule ID 15627 //
     /* 1160704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1160715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1160718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1160721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1160724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160743 */     // MIs[0] round
     /* 1160743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160753 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1160756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160764 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160781 */     // GIR_Coverage, 15627,
     /* 1160781 */     GIR_EraseRootFromParent_Done,
     /* 1160782 */   // Label 16945: @1160782
     /* 1160782 */   GIM_Try, /*On fail goto*//*Label 16946*/ GIMT_Encode4(1160865), // Rule ID 15630 //
     /* 1160787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1160798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1160801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1160804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1160807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160826 */     // MIs[0] round
     /* 1160826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160836 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1160839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160864 */     // GIR_Coverage, 15630,
     /* 1160864 */     GIR_EraseRootFromParent_Done,
     /* 1160865 */   // Label 16946: @1160865
     /* 1160865 */   GIM_Try, /*On fail goto*//*Label 16947*/ GIMT_Encode4(1160948), // Rule ID 15631 //
     /* 1160870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1160881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1160884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1160887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1160890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160909 */     // MIs[0] round
     /* 1160909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160919 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1160922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160930 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160947 */     // GIR_Coverage, 15631,
     /* 1160947 */     GIR_EraseRootFromParent_Done,
     /* 1160948 */   // Label 16947: @1160948
     /* 1160948 */   GIM_Try, /*On fail goto*//*Label 16948*/ GIMT_Encode4(1161031), // Rule ID 15634 //
     /* 1160953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1160964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1160967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1160970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1160973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160992 */     // MIs[0] round
     /* 1160992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161002 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1161005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161030 */     // GIR_Coverage, 15634,
     /* 1161030 */     GIR_EraseRootFromParent_Done,
     /* 1161031 */   // Label 16948: @1161031
     /* 1161031 */   GIM_Try, /*On fail goto*//*Label 16949*/ GIMT_Encode4(1161114), // Rule ID 15635 //
     /* 1161036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1161047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1161050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1161053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1161056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161075 */     // MIs[0] round
     /* 1161075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161085 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1161088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161096 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161113 */     // GIR_Coverage, 15635,
     /* 1161113 */     GIR_EraseRootFromParent_Done,
     /* 1161114 */   // Label 16949: @1161114
     /* 1161114 */   GIM_Try, /*On fail goto*//*Label 16950*/ GIMT_Encode4(1161197), // Rule ID 15638 //
     /* 1161119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1161130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1161133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1161136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1161139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161158 */     // MIs[0] round
     /* 1161158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161168 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1161171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161196 */     // GIR_Coverage, 15638,
     /* 1161196 */     GIR_EraseRootFromParent_Done,
     /* 1161197 */   // Label 16950: @1161197
     /* 1161197 */   GIM_Try, /*On fail goto*//*Label 16951*/ GIMT_Encode4(1161280), // Rule ID 15639 //
     /* 1161202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1161213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1161216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1161219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1161222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161241 */     // MIs[0] round
     /* 1161241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161251 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1161254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161262 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161279 */     // GIR_Coverage, 15639,
     /* 1161279 */     GIR_EraseRootFromParent_Done,
     /* 1161280 */   // Label 16951: @1161280
     /* 1161280 */   GIM_Try, /*On fail goto*//*Label 16952*/ GIMT_Encode4(1161363), // Rule ID 15642 //
     /* 1161285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1161296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1161299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1161302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1161305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161324 */     // MIs[0] round
     /* 1161324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161334 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1161337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161362 */     // GIR_Coverage, 15642,
     /* 1161362 */     GIR_EraseRootFromParent_Done,
     /* 1161363 */   // Label 16952: @1161363
     /* 1161363 */   GIM_Try, /*On fail goto*//*Label 16953*/ GIMT_Encode4(1161446), // Rule ID 15643 //
     /* 1161368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1161379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1161382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1161385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1161388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161407 */     // MIs[0] round
     /* 1161407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161417 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1161420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161428 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161445 */     // GIR_Coverage, 15643,
     /* 1161445 */     GIR_EraseRootFromParent_Done,
     /* 1161446 */   // Label 16953: @1161446
     /* 1161446 */   GIM_Try, /*On fail goto*//*Label 16954*/ GIMT_Encode4(1161529), // Rule ID 15646 //
     /* 1161451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1161462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1161465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1161468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1161471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161490 */     // MIs[0] round
     /* 1161490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161500 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1161503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161528 */     // GIR_Coverage, 15646,
     /* 1161528 */     GIR_EraseRootFromParent_Done,
     /* 1161529 */   // Label 16954: @1161529
     /* 1161529 */   GIM_Try, /*On fail goto*//*Label 16955*/ GIMT_Encode4(1161612), // Rule ID 15647 //
     /* 1161534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1161545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1161548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1161551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1161554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161573 */     // MIs[0] round
     /* 1161573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161583 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1161586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161594 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161611 */     // GIR_Coverage, 15647,
     /* 1161611 */     GIR_EraseRootFromParent_Done,
     /* 1161612 */   // Label 16955: @1161612
     /* 1161612 */   GIM_Try, /*On fail goto*//*Label 16956*/ GIMT_Encode4(1161695), // Rule ID 15650 //
     /* 1161617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1161628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1161631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1161634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1161637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161656 */     // MIs[0] round
     /* 1161656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161666 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1161669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161694 */     // GIR_Coverage, 15650,
     /* 1161694 */     GIR_EraseRootFromParent_Done,
     /* 1161695 */   // Label 16956: @1161695
     /* 1161695 */   GIM_Try, /*On fail goto*//*Label 16957*/ GIMT_Encode4(1161778), // Rule ID 15651 //
     /* 1161700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1161711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1161714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1161717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1161720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161739 */     // MIs[0] round
     /* 1161739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161749 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1161752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161760 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161777 */     // GIR_Coverage, 15651,
     /* 1161777 */     GIR_EraseRootFromParent_Done,
     /* 1161778 */   // Label 16957: @1161778
     /* 1161778 */   GIM_Try, /*On fail goto*//*Label 16958*/ GIMT_Encode4(1161861), // Rule ID 15654 //
     /* 1161783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1161794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1161797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1161800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1161803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161822 */     // MIs[0] round
     /* 1161822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161832 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1161835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161860 */     // GIR_Coverage, 15654,
     /* 1161860 */     GIR_EraseRootFromParent_Done,
     /* 1161861 */   // Label 16958: @1161861
     /* 1161861 */   GIM_Try, /*On fail goto*//*Label 16959*/ GIMT_Encode4(1161944), // Rule ID 15655 //
     /* 1161866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1161877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1161880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1161883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1161886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161905 */     // MIs[0] round
     /* 1161905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161915 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1161918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161943 */     // GIR_Coverage, 15655,
     /* 1161943 */     GIR_EraseRootFromParent_Done,
     /* 1161944 */   // Label 16959: @1161944
     /* 1161944 */   GIM_Try, /*On fail goto*//*Label 16960*/ GIMT_Encode4(1162027), // Rule ID 15658 //
     /* 1161949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1161960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1161963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1161966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1161969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161988 */     // MIs[0] round
     /* 1161988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161998 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1162001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162026 */     // GIR_Coverage, 15658,
     /* 1162026 */     GIR_EraseRootFromParent_Done,
     /* 1162027 */   // Label 16960: @1162027
     /* 1162027 */   GIM_Try, /*On fail goto*//*Label 16961*/ GIMT_Encode4(1162110), // Rule ID 15659 //
     /* 1162032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1162043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1162046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1162049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1162052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162071 */     // MIs[0] round
     /* 1162071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162081 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1162084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162092 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162109 */     // GIR_Coverage, 15659,
     /* 1162109 */     GIR_EraseRootFromParent_Done,
     /* 1162110 */   // Label 16961: @1162110
     /* 1162110 */   GIM_Try, /*On fail goto*//*Label 16962*/ GIMT_Encode4(1162193), // Rule ID 15662 //
     /* 1162115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1162126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1162129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1162132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1162135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162154 */     // MIs[0] round
     /* 1162154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1162167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1162185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162192 */     // GIR_Coverage, 15662,
     /* 1162192 */     GIR_EraseRootFromParent_Done,
     /* 1162193 */   // Label 16962: @1162193
     /* 1162193 */   GIM_Try, /*On fail goto*//*Label 16963*/ GIMT_Encode4(1162276), // Rule ID 15663 //
     /* 1162198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1162209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1162212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1162215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1162218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162237 */     // MIs[0] round
     /* 1162237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162247 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1162250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162258 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1162268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162275 */     // GIR_Coverage, 15663,
     /* 1162275 */     GIR_EraseRootFromParent_Done,
     /* 1162276 */   // Label 16963: @1162276
     /* 1162276 */   GIM_Try, /*On fail goto*//*Label 16964*/ GIMT_Encode4(1162359), // Rule ID 15666 //
     /* 1162281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1162292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1162295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1162298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1162301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162320 */     // MIs[0] round
     /* 1162320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162330 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1162333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1162351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162358 */     // GIR_Coverage, 15666,
     /* 1162358 */     GIR_EraseRootFromParent_Done,
     /* 1162359 */   // Label 16964: @1162359
     /* 1162359 */   GIM_Try, /*On fail goto*//*Label 16965*/ GIMT_Encode4(1162442), // Rule ID 15667 //
     /* 1162364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1162375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1162378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1162381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1162384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162403 */     // MIs[0] round
     /* 1162403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162413 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1162416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162424 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1162434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162441 */     // GIR_Coverage, 15667,
     /* 1162441 */     GIR_EraseRootFromParent_Done,
     /* 1162442 */   // Label 16965: @1162442
     /* 1162442 */   GIM_Try, /*On fail goto*//*Label 16966*/ GIMT_Encode4(1162525), // Rule ID 15670 //
     /* 1162447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1162458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1162461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1162464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1162467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162486 */     // MIs[0] round
     /* 1162486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162496 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1162499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1162517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162524 */     // GIR_Coverage, 15670,
     /* 1162524 */     GIR_EraseRootFromParent_Done,
     /* 1162525 */   // Label 16966: @1162525
     /* 1162525 */   GIM_Try, /*On fail goto*//*Label 16967*/ GIMT_Encode4(1162608), // Rule ID 15671 //
     /* 1162530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1162541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1162544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1162547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1162550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162569 */     // MIs[0] round
     /* 1162569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162579 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1162582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1162600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162607 */     // GIR_Coverage, 15671,
     /* 1162607 */     GIR_EraseRootFromParent_Done,
     /* 1162608 */   // Label 16967: @1162608
     /* 1162608 */   GIM_Try, /*On fail goto*//*Label 16968*/ GIMT_Encode4(1162691), // Rule ID 15674 //
     /* 1162613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1162624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1162627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1162630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1162633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162652 */     // MIs[0] round
     /* 1162652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162662 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1162665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162690 */     // GIR_Coverage, 15674,
     /* 1162690 */     GIR_EraseRootFromParent_Done,
     /* 1162691 */   // Label 16968: @1162691
     /* 1162691 */   GIM_Try, /*On fail goto*//*Label 16969*/ GIMT_Encode4(1162774), // Rule ID 15675 //
     /* 1162696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1162707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1162710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1162713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1162716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162735 */     // MIs[0] round
     /* 1162735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162745 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1162748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162756 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162773 */     // GIR_Coverage, 15675,
     /* 1162773 */     GIR_EraseRootFromParent_Done,
     /* 1162774 */   // Label 16969: @1162774
     /* 1162774 */   GIM_Try, /*On fail goto*//*Label 16970*/ GIMT_Encode4(1162857), // Rule ID 15678 //
     /* 1162779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1162790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1162793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1162796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1162799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162818 */     // MIs[0] round
     /* 1162818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162828 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1162831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162856 */     // GIR_Coverage, 15678,
     /* 1162856 */     GIR_EraseRootFromParent_Done,
     /* 1162857 */   // Label 16970: @1162857
     /* 1162857 */   GIM_Try, /*On fail goto*//*Label 16971*/ GIMT_Encode4(1162940), // Rule ID 15679 //
     /* 1162862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1162873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1162876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1162879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1162882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162901 */     // MIs[0] round
     /* 1162901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162911 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1162914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162922 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162939 */     // GIR_Coverage, 15679,
     /* 1162939 */     GIR_EraseRootFromParent_Done,
     /* 1162940 */   // Label 16971: @1162940
     /* 1162940 */   GIM_Try, /*On fail goto*//*Label 16972*/ GIMT_Encode4(1163023), // Rule ID 15682 //
     /* 1162945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1162956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1162959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1162962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1162965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162984 */     // MIs[0] round
     /* 1162984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162994 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1162997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1163015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163022 */     // GIR_Coverage, 15682,
     /* 1163022 */     GIR_EraseRootFromParent_Done,
     /* 1163023 */   // Label 16972: @1163023
     /* 1163023 */   GIM_Try, /*On fail goto*//*Label 16973*/ GIMT_Encode4(1163106), // Rule ID 15683 //
     /* 1163028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1163039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1163042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1163045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1163048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163067 */     // MIs[0] round
     /* 1163067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163077 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1163080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163088 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1163098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163105 */     // GIR_Coverage, 15683,
     /* 1163105 */     GIR_EraseRootFromParent_Done,
     /* 1163106 */   // Label 16973: @1163106
     /* 1163106 */   GIM_Try, /*On fail goto*//*Label 16974*/ GIMT_Encode4(1163189), // Rule ID 15686 //
     /* 1163111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1163122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1163125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1163128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1163131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163150 */     // MIs[0] round
     /* 1163150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1163163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163188 */     // GIR_Coverage, 15686,
     /* 1163188 */     GIR_EraseRootFromParent_Done,
     /* 1163189 */   // Label 16974: @1163189
     /* 1163189 */   GIM_Try, /*On fail goto*//*Label 16975*/ GIMT_Encode4(1163272), // Rule ID 15687 //
     /* 1163194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1163205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1163208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1163211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1163214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163233 */     // MIs[0] round
     /* 1163233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163243 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1163246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163254 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163271 */     // GIR_Coverage, 15687,
     /* 1163271 */     GIR_EraseRootFromParent_Done,
     /* 1163272 */   // Label 16975: @1163272
     /* 1163272 */   GIM_Try, /*On fail goto*//*Label 16976*/ GIMT_Encode4(1163355), // Rule ID 15690 //
     /* 1163277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1163288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1163291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1163294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1163297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163316 */     // MIs[0] round
     /* 1163316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163326 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1163329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163354 */     // GIR_Coverage, 15690,
     /* 1163354 */     GIR_EraseRootFromParent_Done,
     /* 1163355 */   // Label 16976: @1163355
     /* 1163355 */   GIM_Try, /*On fail goto*//*Label 16977*/ GIMT_Encode4(1163438), // Rule ID 15691 //
     /* 1163360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1163371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1163374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1163377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1163380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163399 */     // MIs[0] round
     /* 1163399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163409 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1163412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163420 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163437 */     // GIR_Coverage, 15691,
     /* 1163437 */     GIR_EraseRootFromParent_Done,
     /* 1163438 */   // Label 16977: @1163438
     /* 1163438 */   GIM_Try, /*On fail goto*//*Label 16978*/ GIMT_Encode4(1163521), // Rule ID 15694 //
     /* 1163443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1163454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1163457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1163460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1163463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163482 */     // MIs[0] round
     /* 1163482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163492 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1163495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163520 */     // GIR_Coverage, 15694,
     /* 1163520 */     GIR_EraseRootFromParent_Done,
     /* 1163521 */   // Label 16978: @1163521
     /* 1163521 */   GIM_Try, /*On fail goto*//*Label 16979*/ GIMT_Encode4(1163604), // Rule ID 15695 //
     /* 1163526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1163537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1163540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1163543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1163546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163565 */     // MIs[0] round
     /* 1163565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163575 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1163578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163586 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163603 */     // GIR_Coverage, 15695,
     /* 1163603 */     GIR_EraseRootFromParent_Done,
     /* 1163604 */   // Label 16979: @1163604
     /* 1163604 */   GIM_Try, /*On fail goto*//*Label 16980*/ GIMT_Encode4(1163687), // Rule ID 15698 //
     /* 1163609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1163620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1163623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1163626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163648 */     // MIs[0] round
     /* 1163648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163658 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1163661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163686 */     // GIR_Coverage, 15698,
     /* 1163686 */     GIR_EraseRootFromParent_Done,
     /* 1163687 */   // Label 16980: @1163687
     /* 1163687 */   GIM_Try, /*On fail goto*//*Label 16981*/ GIMT_Encode4(1163770), // Rule ID 15699 //
     /* 1163692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1163703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1163706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1163709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163731 */     // MIs[0] round
     /* 1163731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163741 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1163744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163752 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163769 */     // GIR_Coverage, 15699,
     /* 1163769 */     GIR_EraseRootFromParent_Done,
     /* 1163770 */   // Label 16981: @1163770
     /* 1163770 */   GIM_Try, /*On fail goto*//*Label 16982*/ GIMT_Encode4(1163853), // Rule ID 15702 //
     /* 1163775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1163786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1163789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1163792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163814 */     // MIs[0] round
     /* 1163814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163824 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1163827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163852 */     // GIR_Coverage, 15702,
     /* 1163852 */     GIR_EraseRootFromParent_Done,
     /* 1163853 */   // Label 16982: @1163853
     /* 1163853 */   GIM_Try, /*On fail goto*//*Label 16983*/ GIMT_Encode4(1163936), // Rule ID 15703 //
     /* 1163858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1163869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1163872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1163875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163897 */     // MIs[0] round
     /* 1163897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163907 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1163910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163918 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163935 */     // GIR_Coverage, 15703,
     /* 1163935 */     GIR_EraseRootFromParent_Done,
     /* 1163936 */   // Label 16983: @1163936
     /* 1163936 */   GIM_Try, /*On fail goto*//*Label 16984*/ GIMT_Encode4(1164019), // Rule ID 15706 //
     /* 1163941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1163952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1163955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1163958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163980 */     // MIs[0] round
     /* 1163980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163990 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1163993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164018 */     // GIR_Coverage, 15706,
     /* 1164018 */     GIR_EraseRootFromParent_Done,
     /* 1164019 */   // Label 16984: @1164019
     /* 1164019 */   GIM_Try, /*On fail goto*//*Label 16985*/ GIMT_Encode4(1164102), // Rule ID 15707 //
     /* 1164024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1164035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1164038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1164041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164063 */     // MIs[0] round
     /* 1164063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164073 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1164076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164084 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164101 */     // GIR_Coverage, 15707,
     /* 1164101 */     GIR_EraseRootFromParent_Done,
     /* 1164102 */   // Label 16985: @1164102
     /* 1164102 */   GIM_Try, /*On fail goto*//*Label 16986*/ GIMT_Encode4(1164185), // Rule ID 15710 //
     /* 1164107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1164118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1164121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1164124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164146 */     // MIs[0] round
     /* 1164146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164156 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1164159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164184 */     // GIR_Coverage, 15710,
     /* 1164184 */     GIR_EraseRootFromParent_Done,
     /* 1164185 */   // Label 16986: @1164185
     /* 1164185 */   GIM_Try, /*On fail goto*//*Label 16987*/ GIMT_Encode4(1164268), // Rule ID 15711 //
     /* 1164190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1164201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1164204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1164207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164229 */     // MIs[0] round
     /* 1164229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164239 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1164242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164250 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164263 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164267 */     // GIR_Coverage, 15711,
     /* 1164267 */     GIR_EraseRootFromParent_Done,
     /* 1164268 */   // Label 16987: @1164268
     /* 1164268 */   GIM_Try, /*On fail goto*//*Label 16988*/ GIMT_Encode4(1164351), // Rule ID 15714 //
     /* 1164273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1164284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1164287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1164290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164312 */     // MIs[0] round
     /* 1164312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164322 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1164325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164350 */     // GIR_Coverage, 15714,
     /* 1164350 */     GIR_EraseRootFromParent_Done,
     /* 1164351 */   // Label 16988: @1164351
     /* 1164351 */   GIM_Try, /*On fail goto*//*Label 16989*/ GIMT_Encode4(1164434), // Rule ID 15715 //
     /* 1164356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1164367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1164370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1164373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164395 */     // MIs[0] round
     /* 1164395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164405 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1164408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164416 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164433 */     // GIR_Coverage, 15715,
     /* 1164433 */     GIR_EraseRootFromParent_Done,
     /* 1164434 */   // Label 16989: @1164434
     /* 1164434 */   GIM_Try, /*On fail goto*//*Label 16990*/ GIMT_Encode4(1164517), // Rule ID 15718 //
     /* 1164439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1164450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1164453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1164456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164478 */     // MIs[0] round
     /* 1164478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164488 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1164491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1164509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164516 */     // GIR_Coverage, 15718,
     /* 1164516 */     GIR_EraseRootFromParent_Done,
     /* 1164517 */   // Label 16990: @1164517
     /* 1164517 */   GIM_Try, /*On fail goto*//*Label 16991*/ GIMT_Encode4(1164600), // Rule ID 15719 //
     /* 1164522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1164533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1164536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1164539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164561 */     // MIs[0] round
     /* 1164561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164571 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1164574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164582 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1164592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164599 */     // GIR_Coverage, 15719,
     /* 1164599 */     GIR_EraseRootFromParent_Done,
     /* 1164600 */   // Label 16991: @1164600
     /* 1164600 */   GIM_Try, /*On fail goto*//*Label 16992*/ GIMT_Encode4(1164683), // Rule ID 15722 //
     /* 1164605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1164616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1164619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1164622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164644 */     // MIs[0] round
     /* 1164644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164654 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1164657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164682 */     // GIR_Coverage, 15722,
     /* 1164682 */     GIR_EraseRootFromParent_Done,
     /* 1164683 */   // Label 16992: @1164683
     /* 1164683 */   GIM_Try, /*On fail goto*//*Label 16993*/ GIMT_Encode4(1164766), // Rule ID 15723 //
     /* 1164688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1164699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1164702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1164705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164727 */     // MIs[0] round
     /* 1164727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164737 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1164740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164748 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164765 */     // GIR_Coverage, 15723,
     /* 1164765 */     GIR_EraseRootFromParent_Done,
     /* 1164766 */   // Label 16993: @1164766
     /* 1164766 */   GIM_Try, /*On fail goto*//*Label 16994*/ GIMT_Encode4(1164849), // Rule ID 15726 //
     /* 1164771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1164782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1164785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1164788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164810 */     // MIs[0] round
     /* 1164810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164820 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1164823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164848 */     // GIR_Coverage, 15726,
     /* 1164848 */     GIR_EraseRootFromParent_Done,
     /* 1164849 */   // Label 16994: @1164849
     /* 1164849 */   GIM_Try, /*On fail goto*//*Label 16995*/ GIMT_Encode4(1164932), // Rule ID 15727 //
     /* 1164854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1164865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1164868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1164871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164893 */     // MIs[0] round
     /* 1164893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164903 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1164906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164914 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164931 */     // GIR_Coverage, 15727,
     /* 1164931 */     GIR_EraseRootFromParent_Done,
     /* 1164932 */   // Label 16995: @1164932
     /* 1164932 */   GIM_Try, /*On fail goto*//*Label 16996*/ GIMT_Encode4(1165015), // Rule ID 15730 //
     /* 1164937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1164948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1164951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1164954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164976 */     // MIs[0] round
     /* 1164976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164986 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1164989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1165013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165014 */     // GIR_Coverage, 15730,
     /* 1165014 */     GIR_EraseRootFromParent_Done,
     /* 1165015 */   // Label 16996: @1165015
     /* 1165015 */   GIM_Try, /*On fail goto*//*Label 16997*/ GIMT_Encode4(1165098), // Rule ID 15731 //
     /* 1165020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1165028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1165031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1165034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1165037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165059 */     // MIs[0] round
     /* 1165059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165069 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1165072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165080 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1165096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165097 */     // GIR_Coverage, 15731,
     /* 1165097 */     GIR_EraseRootFromParent_Done,
     /* 1165098 */   // Label 16997: @1165098
     /* 1165098 */   GIM_Try, /*On fail goto*//*Label 16998*/ GIMT_Encode4(1165181), // Rule ID 15734 //
     /* 1165103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1165111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1165114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1165117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1165120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165142 */     // MIs[0] round
     /* 1165142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165152 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1165155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1165179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165180 */     // GIR_Coverage, 15734,
     /* 1165180 */     GIR_EraseRootFromParent_Done,
     /* 1165181 */   // Label 16998: @1165181
     /* 1165181 */   GIM_Try, /*On fail goto*//*Label 16999*/ GIMT_Encode4(1165264), // Rule ID 15735 //
     /* 1165186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1165194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1165197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1165200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1165203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165225 */     // MIs[0] round
     /* 1165225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165235 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1165238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1165262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165263 */     // GIR_Coverage, 15735,
     /* 1165263 */     GIR_EraseRootFromParent_Done,
     /* 1165264 */   // Label 16999: @1165264
     /* 1165264 */   GIM_Try, /*On fail goto*//*Label 17000*/ GIMT_Encode4(1165347), // Rule ID 15738 //
     /* 1165269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1165277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1165280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1165283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1165286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165308 */     // MIs[0] round
     /* 1165308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165318 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1165321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1165345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165346 */     // GIR_Coverage, 15738,
     /* 1165346 */     GIR_EraseRootFromParent_Done,
     /* 1165347 */   // Label 17000: @1165347
     /* 1165347 */   GIM_Try, /*On fail goto*//*Label 17001*/ GIMT_Encode4(1165430), // Rule ID 15739 //
     /* 1165352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1165360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1165363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1165366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1165369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165391 */     // MIs[0] round
     /* 1165391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165401 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1165404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165412 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1165428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165429 */     // GIR_Coverage, 15739,
     /* 1165429 */     GIR_EraseRootFromParent_Done,
     /* 1165430 */   // Label 17001: @1165430
     /* 1165430 */   GIM_Try, /*On fail goto*//*Label 17002*/ GIMT_Encode4(1165513), // Rule ID 15742 //
     /* 1165435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1165443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1165446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1165449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1165452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165474 */     // MIs[0] round
     /* 1165474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165484 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1165487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1165511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165512 */     // GIR_Coverage, 15742,
     /* 1165512 */     GIR_EraseRootFromParent_Done,
     /* 1165513 */   // Label 17002: @1165513
     /* 1165513 */   GIM_Try, /*On fail goto*//*Label 17003*/ GIMT_Encode4(1165596), // Rule ID 15743 //
     /* 1165518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1165526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1165529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1165532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1165535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165557 */     // MIs[0] round
     /* 1165557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165567 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1165570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165578 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1165594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165595 */     // GIR_Coverage, 15743,
     /* 1165595 */     GIR_EraseRootFromParent_Done,
     /* 1165596 */   // Label 17003: @1165596
     /* 1165596 */   GIM_Try, /*On fail goto*//*Label 17004*/ GIMT_Encode4(1165679), // Rule ID 15746 //
     /* 1165601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1165609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1165612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1165615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1165618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165640 */     // MIs[0] round
     /* 1165640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165650 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1165653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1165677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165678 */     // GIR_Coverage, 15746,
     /* 1165678 */     GIR_EraseRootFromParent_Done,
     /* 1165679 */   // Label 17004: @1165679
     /* 1165679 */   GIM_Try, /*On fail goto*//*Label 17005*/ GIMT_Encode4(1165762), // Rule ID 15747 //
     /* 1165684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1165692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1165695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1165698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1165701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165723 */     // MIs[0] round
     /* 1165723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165733 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1165736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165744 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1165760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165761 */     // GIR_Coverage, 15747,
     /* 1165761 */     GIR_EraseRootFromParent_Done,
     /* 1165762 */   // Label 17005: @1165762
     /* 1165762 */   GIM_Try, /*On fail goto*//*Label 17006*/ GIMT_Encode4(1165845), // Rule ID 15750 //
     /* 1165767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1165775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1165778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1165781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1165784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165806 */     // MIs[0] round
     /* 1165806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165816 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1165819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1165843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165844 */     // GIR_Coverage, 15750,
     /* 1165844 */     GIR_EraseRootFromParent_Done,
     /* 1165845 */   // Label 17006: @1165845
     /* 1165845 */   GIM_Try, /*On fail goto*//*Label 17007*/ GIMT_Encode4(1165928), // Rule ID 15751 //
     /* 1165850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1165858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1165861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1165864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1165867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165889 */     // MIs[0] round
     /* 1165889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165899 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1165902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1165926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165927 */     // GIR_Coverage, 15751,
     /* 1165927 */     GIR_EraseRootFromParent_Done,
     /* 1165928 */   // Label 17007: @1165928
     /* 1165928 */   GIM_Try, /*On fail goto*//*Label 17008*/ GIMT_Encode4(1166011), // Rule ID 15754 //
     /* 1165933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1165941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1165944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1165947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1165950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165972 */     // MIs[0] round
     /* 1165972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165982 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1165985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1166009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166010 */     // GIR_Coverage, 15754,
     /* 1166010 */     GIR_EraseRootFromParent_Done,
     /* 1166011 */   // Label 17008: @1166011
     /* 1166011 */   GIM_Try, /*On fail goto*//*Label 17009*/ GIMT_Encode4(1166094), // Rule ID 15755 //
     /* 1166016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1166024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1166027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1166030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1166033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1166036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166055 */     // MIs[0] round
     /* 1166055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166065 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1166068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166076 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1166092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166093 */     // GIR_Coverage, 15755,
     /* 1166093 */     GIR_EraseRootFromParent_Done,
     /* 1166094 */   // Label 17009: @1166094
     /* 1166094 */   GIM_Try, /*On fail goto*//*Label 17010*/ GIMT_Encode4(1166177), // Rule ID 15758 //
     /* 1166099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1166107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1166110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1166113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1166116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1166119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166138 */     // MIs[0] round
     /* 1166138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166148 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1166151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1166175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166176 */     // GIR_Coverage, 15758,
     /* 1166176 */     GIR_EraseRootFromParent_Done,
     /* 1166177 */   // Label 17010: @1166177
     /* 1166177 */   GIM_Try, /*On fail goto*//*Label 17011*/ GIMT_Encode4(1166260), // Rule ID 15759 //
     /* 1166182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1166190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1166193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1166196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1166199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1166202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166221 */     // MIs[0] round
     /* 1166221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166231 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1166234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166242 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1166258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166259 */     // GIR_Coverage, 15759,
     /* 1166259 */     GIR_EraseRootFromParent_Done,
     /* 1166260 */   // Label 17011: @1166260
     /* 1166260 */   GIM_Try, /*On fail goto*//*Label 17012*/ GIMT_Encode4(1166343), // Rule ID 15762 //
     /* 1166265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1166273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1166276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1166279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1166282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1166285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166304 */     // MIs[0] round
     /* 1166304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1166317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166338 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1166341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166342 */     // GIR_Coverage, 15762,
     /* 1166342 */     GIR_EraseRootFromParent_Done,
     /* 1166343 */   // Label 17012: @1166343
     /* 1166343 */   GIM_Try, /*On fail goto*//*Label 17013*/ GIMT_Encode4(1166426), // Rule ID 15763 //
     /* 1166348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1166356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1166359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1166362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1166365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1166368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166387 */     // MIs[0] round
     /* 1166387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166397 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1166400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166408 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1166424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166425 */     // GIR_Coverage, 15763,
     /* 1166425 */     GIR_EraseRootFromParent_Done,
     /* 1166426 */   // Label 17013: @1166426
     /* 1166426 */   GIM_Try, /*On fail goto*//*Label 17014*/ GIMT_Encode4(1166509), // Rule ID 15766 //
     /* 1166431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1166439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1166442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1166445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1166448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1166451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166470 */     // MIs[0] round
     /* 1166470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166480 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1166483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1166507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166508 */     // GIR_Coverage, 15766,
     /* 1166508 */     GIR_EraseRootFromParent_Done,
     /* 1166509 */   // Label 17014: @1166509
     /* 1166509 */   GIM_Try, /*On fail goto*//*Label 17015*/ GIMT_Encode4(1166592), // Rule ID 15767 //
     /* 1166514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1166522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1166525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1166528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1166531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1166534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166553 */     // MIs[0] round
     /* 1166553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166563 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1166566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166574 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1166590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166591 */     // GIR_Coverage, 15767,
     /* 1166591 */     GIR_EraseRootFromParent_Done,
     /* 1166592 */   // Label 17015: @1166592
     /* 1166592 */   GIM_Try, /*On fail goto*//*Label 17016*/ GIMT_Encode4(1166675), // Rule ID 15770 //
     /* 1166597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1166600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1166605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1166608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1166611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1166614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1166617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166636 */     // MIs[0] round
     /* 1166636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166646 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1166649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1166673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166674 */     // GIR_Coverage, 15770,
     /* 1166674 */     GIR_EraseRootFromParent_Done,
     /* 1166675 */   // Label 17016: @1166675
     /* 1166675 */   GIM_Try, /*On fail goto*//*Label 17017*/ GIMT_Encode4(1166758), // Rule ID 15771 //
     /* 1166680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1166683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1166688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1166691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1166694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1166697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1166700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166719 */     // MIs[0] round
     /* 1166719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166729 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1166732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166740 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1166756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166757 */     // GIR_Coverage, 15771,
     /* 1166757 */     GIR_EraseRootFromParent_Done,
     /* 1166758 */   // Label 17017: @1166758
     /* 1166758 */   GIM_Try, /*On fail goto*//*Label 17018*/ GIMT_Encode4(1166841), // Rule ID 15774 //
     /* 1166763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1166766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1166771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1166774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1166777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1166780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1166783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166802 */     // MIs[0] round
     /* 1166802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1166815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1166839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166840 */     // GIR_Coverage, 15774,
     /* 1166840 */     GIR_EraseRootFromParent_Done,
     /* 1166841 */   // Label 17018: @1166841
     /* 1166841 */   GIM_Try, /*On fail goto*//*Label 17019*/ GIMT_Encode4(1166924), // Rule ID 15775 //
     /* 1166846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1166849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1166854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1166857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1166860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1166863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1166866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166885 */     // MIs[0] round
     /* 1166885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166895 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1166898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166906 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1166922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166923 */     // GIR_Coverage, 15775,
     /* 1166923 */     GIR_EraseRootFromParent_Done,
     /* 1166924 */   // Label 17019: @1166924
     /* 1166924 */   GIM_Try, /*On fail goto*//*Label 17020*/ GIMT_Encode4(1167007), // Rule ID 15778 //
     /* 1166929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1166932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1166937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1166940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1166943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1166946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1166949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166968 */     // MIs[0] round
     /* 1166968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166978 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1166981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1167005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167006 */     // GIR_Coverage, 15778,
     /* 1167006 */     GIR_EraseRootFromParent_Done,
     /* 1167007 */   // Label 17020: @1167007
     /* 1167007 */   GIM_Try, /*On fail goto*//*Label 17021*/ GIMT_Encode4(1167090), // Rule ID 15779 //
     /* 1167012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1167015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1167020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1167023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1167026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1167029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1167032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167051 */     // MIs[0] round
     /* 1167051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167061 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1167064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167072 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1167088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167089 */     // GIR_Coverage, 15779,
     /* 1167089 */     GIR_EraseRootFromParent_Done,
     /* 1167090 */   // Label 17021: @1167090
     /* 1167090 */   GIM_Try, /*On fail goto*//*Label 17022*/ GIMT_Encode4(1167173), // Rule ID 15782 //
     /* 1167095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1167098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1167103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1167106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1167109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1167112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1167115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167134 */     // MIs[0] round
     /* 1167134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167144 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1167147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1167171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167172 */     // GIR_Coverage, 15782,
     /* 1167172 */     GIR_EraseRootFromParent_Done,
     /* 1167173 */   // Label 17022: @1167173
     /* 1167173 */   GIM_Try, /*On fail goto*//*Label 17023*/ GIMT_Encode4(1167256), // Rule ID 15783 //
     /* 1167178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1167181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1167186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1167189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1167192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1167195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1167198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167217 */     // MIs[0] round
     /* 1167217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167227 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1167230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167238 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1167254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167255 */     // GIR_Coverage, 15783,
     /* 1167255 */     GIR_EraseRootFromParent_Done,
     /* 1167256 */   // Label 17023: @1167256
     /* 1167256 */   GIM_Try, /*On fail goto*//*Label 17024*/ GIMT_Encode4(1167339), // Rule ID 15786 //
     /* 1167261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1167264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1167269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1167272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1167275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1167278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167300 */     // MIs[0] round
     /* 1167300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167310 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1167313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1167337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167338 */     // GIR_Coverage, 15786,
     /* 1167338 */     GIR_EraseRootFromParent_Done,
     /* 1167339 */   // Label 17024: @1167339
     /* 1167339 */   GIM_Try, /*On fail goto*//*Label 17025*/ GIMT_Encode4(1167422), // Rule ID 15787 //
     /* 1167344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1167347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1167352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1167355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1167358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1167361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1167364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167383 */     // MIs[0] round
     /* 1167383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167393 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1167396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167404 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1167420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167421 */     // GIR_Coverage, 15787,
     /* 1167421 */     GIR_EraseRootFromParent_Done,
     /* 1167422 */   // Label 17025: @1167422
     /* 1167422 */   GIM_Try, /*On fail goto*//*Label 17026*/ GIMT_Encode4(1167505), // Rule ID 15790 //
     /* 1167427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1167430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1167435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1167438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1167441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1167444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167466 */     // MIs[0] round
     /* 1167466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1167479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167500 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1167503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167504 */     // GIR_Coverage, 15790,
     /* 1167504 */     GIR_EraseRootFromParent_Done,
     /* 1167505 */   // Label 17026: @1167505
     /* 1167505 */   GIM_Try, /*On fail goto*//*Label 17027*/ GIMT_Encode4(1167588), // Rule ID 15791 //
     /* 1167510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1167513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1167518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1167521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1167524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1167527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1167530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167549 */     // MIs[0] round
     /* 1167549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167559 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1167562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167570 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1167586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167587 */     // GIR_Coverage, 15791,
     /* 1167587 */     GIR_EraseRootFromParent_Done,
     /* 1167588 */   // Label 17027: @1167588
     /* 1167588 */   GIM_Try, /*On fail goto*//*Label 17028*/ GIMT_Encode4(1167671), // Rule ID 15794 //
     /* 1167593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1167596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1167601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1167604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1167607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1167610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167632 */     // MIs[0] round
     /* 1167632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167642 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1167645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1167669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167670 */     // GIR_Coverage, 15794,
     /* 1167670 */     GIR_EraseRootFromParent_Done,
     /* 1167671 */   // Label 17028: @1167671
     /* 1167671 */   GIM_Try, /*On fail goto*//*Label 17029*/ GIMT_Encode4(1167754), // Rule ID 15795 //
     /* 1167676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1167679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1167684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1167687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1167690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1167693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1167696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167715 */     // MIs[0] round
     /* 1167715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167725 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1167728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167736 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1167752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167753 */     // GIR_Coverage, 15795,
     /* 1167753 */     GIR_EraseRootFromParent_Done,
     /* 1167754 */   // Label 17029: @1167754
     /* 1167754 */   GIM_Try, /*On fail goto*//*Label 17030*/ GIMT_Encode4(1167837), // Rule ID 15798 //
     /* 1167759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1167762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1167767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1167770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1167773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1167776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167798 */     // MIs[0] round
     /* 1167798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167808 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1167811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1167835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167836 */     // GIR_Coverage, 15798,
     /* 1167836 */     GIR_EraseRootFromParent_Done,
     /* 1167837 */   // Label 17030: @1167837
     /* 1167837 */   GIM_Try, /*On fail goto*//*Label 17031*/ GIMT_Encode4(1167920), // Rule ID 15799 //
     /* 1167842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1167845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1167850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1167853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1167856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1167859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1167862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167881 */     // MIs[0] round
     /* 1167881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167891 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1167894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167902 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1167918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167919 */     // GIR_Coverage, 15799,
     /* 1167919 */     GIR_EraseRootFromParent_Done,
     /* 1167920 */   // Label 17031: @1167920
     /* 1167920 */   GIM_Try, /*On fail goto*//*Label 17032*/ GIMT_Encode4(1168000), // Rule ID 15802 //
     /* 1167925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1167936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1167939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1167942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1167945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167964 */     // MIs[0] round
     /* 1167964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167974 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1167977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167999 */     // GIR_Coverage, 15802,
     /* 1167999 */     GIR_EraseRootFromParent_Done,
     /* 1168000 */   // Label 17032: @1168000
     /* 1168000 */   GIM_Try, /*On fail goto*//*Label 17033*/ GIMT_Encode4(1168080), // Rule ID 15803 //
     /* 1168005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1168016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1168019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1168022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1168025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168044 */     // MIs[0] round
     /* 1168044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168054 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1168057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168079 */     // GIR_Coverage, 15803,
     /* 1168079 */     GIR_EraseRootFromParent_Done,
     /* 1168080 */   // Label 17033: @1168080
     /* 1168080 */   GIM_Try, /*On fail goto*//*Label 17034*/ GIMT_Encode4(1168160), // Rule ID 15806 //
     /* 1168085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1168096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1168099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1168102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1168105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168124 */     // MIs[0] round
     /* 1168124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168134 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1168137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168159 */     // GIR_Coverage, 15806,
     /* 1168159 */     GIR_EraseRootFromParent_Done,
     /* 1168160 */   // Label 17034: @1168160
     /* 1168160 */   GIM_Try, /*On fail goto*//*Label 17035*/ GIMT_Encode4(1168240), // Rule ID 15807 //
     /* 1168165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1168176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1168179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1168182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1168185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168204 */     // MIs[0] round
     /* 1168204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168214 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1168217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168239 */     // GIR_Coverage, 15807,
     /* 1168239 */     GIR_EraseRootFromParent_Done,
     /* 1168240 */   // Label 17035: @1168240
     /* 1168240 */   GIM_Try, /*On fail goto*//*Label 17036*/ GIMT_Encode4(1168320), // Rule ID 15810 //
     /* 1168245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1168256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1168259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1168262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1168265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168284 */     // MIs[0] round
     /* 1168284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168294 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1168297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168319 */     // GIR_Coverage, 15810,
     /* 1168319 */     GIR_EraseRootFromParent_Done,
     /* 1168320 */   // Label 17036: @1168320
     /* 1168320 */   GIM_Try, /*On fail goto*//*Label 17037*/ GIMT_Encode4(1168400), // Rule ID 15811 //
     /* 1168325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1168336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1168339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1168342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1168345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168364 */     // MIs[0] round
     /* 1168364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168374 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1168377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168399 */     // GIR_Coverage, 15811,
     /* 1168399 */     GIR_EraseRootFromParent_Done,
     /* 1168400 */   // Label 17037: @1168400
     /* 1168400 */   GIM_Try, /*On fail goto*//*Label 17038*/ GIMT_Encode4(1168480), // Rule ID 15814 //
     /* 1168405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1168416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1168419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1168422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1168425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168444 */     // MIs[0] round
     /* 1168444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168454 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1168457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168479 */     // GIR_Coverage, 15814,
     /* 1168479 */     GIR_EraseRootFromParent_Done,
     /* 1168480 */   // Label 17038: @1168480
     /* 1168480 */   GIM_Try, /*On fail goto*//*Label 17039*/ GIMT_Encode4(1168560), // Rule ID 15815 //
     /* 1168485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1168496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1168499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1168502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1168505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168524 */     // MIs[0] round
     /* 1168524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168534 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1168537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168559 */     // GIR_Coverage, 15815,
     /* 1168559 */     GIR_EraseRootFromParent_Done,
     /* 1168560 */   // Label 17039: @1168560
     /* 1168560 */   GIM_Try, /*On fail goto*//*Label 17040*/ GIMT_Encode4(1168640), // Rule ID 15818 //
     /* 1168565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1168576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1168579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1168582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1168585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168604 */     // MIs[0] round
     /* 1168604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168614 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1168617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168639 */     // GIR_Coverage, 15818,
     /* 1168639 */     GIR_EraseRootFromParent_Done,
     /* 1168640 */   // Label 17040: @1168640
     /* 1168640 */   GIM_Try, /*On fail goto*//*Label 17041*/ GIMT_Encode4(1168720), // Rule ID 15819 //
     /* 1168645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1168656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1168659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1168662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1168665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168684 */     // MIs[0] round
     /* 1168684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168694 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1168697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168719 */     // GIR_Coverage, 15819,
     /* 1168719 */     GIR_EraseRootFromParent_Done,
     /* 1168720 */   // Label 17041: @1168720
     /* 1168720 */   GIM_Try, /*On fail goto*//*Label 17042*/ GIMT_Encode4(1168800), // Rule ID 15822 //
     /* 1168725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1168736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1168739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1168742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1168745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168764 */     // MIs[0] round
     /* 1168764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168774 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1168777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168799 */     // GIR_Coverage, 15822,
     /* 1168799 */     GIR_EraseRootFromParent_Done,
     /* 1168800 */   // Label 17042: @1168800
     /* 1168800 */   GIM_Try, /*On fail goto*//*Label 17043*/ GIMT_Encode4(1168880), // Rule ID 15823 //
     /* 1168805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1168816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1168819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1168822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1168825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168844 */     // MIs[0] round
     /* 1168844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168854 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1168857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168879 */     // GIR_Coverage, 15823,
     /* 1168879 */     GIR_EraseRootFromParent_Done,
     /* 1168880 */   // Label 17043: @1168880
     /* 1168880 */   GIM_Try, /*On fail goto*//*Label 17044*/ GIMT_Encode4(1168960), // Rule ID 15826 //
     /* 1168885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1168896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1168899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1168902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1168905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168924 */     // MIs[0] round
     /* 1168924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168934 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1168937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168959 */     // GIR_Coverage, 15826,
     /* 1168959 */     GIR_EraseRootFromParent_Done,
     /* 1168960 */   // Label 17044: @1168960
     /* 1168960 */   GIM_Try, /*On fail goto*//*Label 17045*/ GIMT_Encode4(1169040), // Rule ID 15827 //
     /* 1168965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1168976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1168979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1168982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1168985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169004 */     // MIs[0] round
     /* 1169004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169014 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1169017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169039 */     // GIR_Coverage, 15827,
     /* 1169039 */     GIR_EraseRootFromParent_Done,
     /* 1169040 */   // Label 17045: @1169040
     /* 1169040 */   GIM_Try, /*On fail goto*//*Label 17046*/ GIMT_Encode4(1169120), // Rule ID 15830 //
     /* 1169045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1169056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1169059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1169062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1169065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169084 */     // MIs[0] round
     /* 1169084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1169097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169119 */     // GIR_Coverage, 15830,
     /* 1169119 */     GIR_EraseRootFromParent_Done,
     /* 1169120 */   // Label 17046: @1169120
     /* 1169120 */   GIM_Try, /*On fail goto*//*Label 17047*/ GIMT_Encode4(1169200), // Rule ID 15831 //
     /* 1169125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1169136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1169139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1169142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1169145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169164 */     // MIs[0] round
     /* 1169164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1169177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169199 */     // GIR_Coverage, 15831,
     /* 1169199 */     GIR_EraseRootFromParent_Done,
     /* 1169200 */   // Label 17047: @1169200
     /* 1169200 */   GIM_Try, /*On fail goto*//*Label 17048*/ GIMT_Encode4(1169280), // Rule ID 15834 //
     /* 1169205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1169216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1169219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1169222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1169225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169244 */     // MIs[0] round
     /* 1169244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169254 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1169257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169279 */     // GIR_Coverage, 15834,
     /* 1169279 */     GIR_EraseRootFromParent_Done,
     /* 1169280 */   // Label 17048: @1169280
     /* 1169280 */   GIM_Try, /*On fail goto*//*Label 17049*/ GIMT_Encode4(1169360), // Rule ID 15835 //
     /* 1169285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1169296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1169299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1169302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1169305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169324 */     // MIs[0] round
     /* 1169324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1169337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169359 */     // GIR_Coverage, 15835,
     /* 1169359 */     GIR_EraseRootFromParent_Done,
     /* 1169360 */   // Label 17049: @1169360
     /* 1169360 */   GIM_Try, /*On fail goto*//*Label 17050*/ GIMT_Encode4(1169440), // Rule ID 15838 //
     /* 1169365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1169368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1169376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1169379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1169382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1169385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169404 */     // MIs[0] round
     /* 1169404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1169417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169439 */     // GIR_Coverage, 15838,
     /* 1169439 */     GIR_EraseRootFromParent_Done,
     /* 1169440 */   // Label 17050: @1169440
     /* 1169440 */   GIM_Try, /*On fail goto*//*Label 17051*/ GIMT_Encode4(1169520), // Rule ID 15839 //
     /* 1169445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1169448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1169456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1169459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1169462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1169465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169484 */     // MIs[0] round
     /* 1169484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1169497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169519 */     // GIR_Coverage, 15839,
     /* 1169519 */     GIR_EraseRootFromParent_Done,
     /* 1169520 */   // Label 17051: @1169520
     /* 1169520 */   GIM_Try, /*On fail goto*//*Label 17052*/ GIMT_Encode4(1169600), // Rule ID 15842 //
     /* 1169525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1169536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1169539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1169542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1169545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169564 */     // MIs[0] round
     /* 1169564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169574 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1169577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169599 */     // GIR_Coverage, 15842,
     /* 1169599 */     GIR_EraseRootFromParent_Done,
     /* 1169600 */   // Label 17052: @1169600
     /* 1169600 */   GIM_Try, /*On fail goto*//*Label 17053*/ GIMT_Encode4(1169680), // Rule ID 15843 //
     /* 1169605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1169616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1169619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1169622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1169625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169644 */     // MIs[0] round
     /* 1169644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169654 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1169657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169679 */     // GIR_Coverage, 15843,
     /* 1169679 */     GIR_EraseRootFromParent_Done,
     /* 1169680 */   // Label 17053: @1169680
     /* 1169680 */   GIM_Try, /*On fail goto*//*Label 17054*/ GIMT_Encode4(1169760), // Rule ID 15846 //
     /* 1169685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1169696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1169699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1169702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1169705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169724 */     // MIs[0] round
     /* 1169724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169734 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1169737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169759 */     // GIR_Coverage, 15846,
     /* 1169759 */     GIR_EraseRootFromParent_Done,
     /* 1169760 */   // Label 17054: @1169760
     /* 1169760 */   GIM_Try, /*On fail goto*//*Label 17055*/ GIMT_Encode4(1169840), // Rule ID 15847 //
     /* 1169765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1169776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1169779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1169782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1169785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169804 */     // MIs[0] round
     /* 1169804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169814 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1169817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169839 */     // GIR_Coverage, 15847,
     /* 1169839 */     GIR_EraseRootFromParent_Done,
     /* 1169840 */   // Label 17055: @1169840
     /* 1169840 */   GIM_Try, /*On fail goto*//*Label 17056*/ GIMT_Encode4(1169920), // Rule ID 15850 //
     /* 1169845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1169856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1169859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1169862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1169865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169884 */     // MIs[0] round
     /* 1169884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169894 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1169897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169919 */     // GIR_Coverage, 15850,
     /* 1169919 */     GIR_EraseRootFromParent_Done,
     /* 1169920 */   // Label 17056: @1169920
     /* 1169920 */   GIM_Try, /*On fail goto*//*Label 17057*/ GIMT_Encode4(1170000), // Rule ID 15851 //
     /* 1169925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1169936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1169939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1169942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1169945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169964 */     // MIs[0] round
     /* 1169964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169974 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1169977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169999 */     // GIR_Coverage, 15851,
     /* 1169999 */     GIR_EraseRootFromParent_Done,
     /* 1170000 */   // Label 17057: @1170000
     /* 1170000 */   GIM_Try, /*On fail goto*//*Label 17058*/ GIMT_Encode4(1170080), // Rule ID 15854 //
     /* 1170005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1170016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1170019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1170022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1170025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170044 */     // MIs[0] round
     /* 1170044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170054 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1170057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170079 */     // GIR_Coverage, 15854,
     /* 1170079 */     GIR_EraseRootFromParent_Done,
     /* 1170080 */   // Label 17058: @1170080
     /* 1170080 */   GIM_Try, /*On fail goto*//*Label 17059*/ GIMT_Encode4(1170160), // Rule ID 15855 //
     /* 1170085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1170096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1170099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1170102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1170105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170124 */     // MIs[0] round
     /* 1170124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170134 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1170137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170159 */     // GIR_Coverage, 15855,
     /* 1170159 */     GIR_EraseRootFromParent_Done,
     /* 1170160 */   // Label 17059: @1170160
     /* 1170160 */   GIM_Try, /*On fail goto*//*Label 17060*/ GIMT_Encode4(1170240), // Rule ID 15858 //
     /* 1170165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1170176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1170179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1170182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1170185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170204 */     // MIs[0] round
     /* 1170204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170214 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1170217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170239 */     // GIR_Coverage, 15858,
     /* 1170239 */     GIR_EraseRootFromParent_Done,
     /* 1170240 */   // Label 17060: @1170240
     /* 1170240 */   GIM_Try, /*On fail goto*//*Label 17061*/ GIMT_Encode4(1170320), // Rule ID 15859 //
     /* 1170245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1170256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1170259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1170262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1170265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170284 */     // MIs[0] round
     /* 1170284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170294 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1170297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170319 */     // GIR_Coverage, 15859,
     /* 1170319 */     GIR_EraseRootFromParent_Done,
     /* 1170320 */   // Label 17061: @1170320
     /* 1170320 */   GIM_Try, /*On fail goto*//*Label 17062*/ GIMT_Encode4(1170400), // Rule ID 15862 //
     /* 1170325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1170336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1170339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1170342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1170345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170364 */     // MIs[0] round
     /* 1170364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170374 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1170377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170399 */     // GIR_Coverage, 15862,
     /* 1170399 */     GIR_EraseRootFromParent_Done,
     /* 1170400 */   // Label 17062: @1170400
     /* 1170400 */   GIM_Try, /*On fail goto*//*Label 17063*/ GIMT_Encode4(1170480), // Rule ID 15863 //
     /* 1170405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1170416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1170419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1170422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1170425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170444 */     // MIs[0] round
     /* 1170444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170454 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1170457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170479 */     // GIR_Coverage, 15863,
     /* 1170479 */     GIR_EraseRootFromParent_Done,
     /* 1170480 */   // Label 17063: @1170480
     /* 1170480 */   GIM_Try, /*On fail goto*//*Label 17064*/ GIMT_Encode4(1170560), // Rule ID 15866 //
     /* 1170485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1170496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1170499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1170502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1170505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170524 */     // MIs[0] round
     /* 1170524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170534 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1170537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170559 */     // GIR_Coverage, 15866,
     /* 1170559 */     GIR_EraseRootFromParent_Done,
     /* 1170560 */   // Label 17064: @1170560
     /* 1170560 */   GIM_Try, /*On fail goto*//*Label 17065*/ GIMT_Encode4(1170640), // Rule ID 15867 //
     /* 1170565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1170576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1170579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1170582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1170585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170604 */     // MIs[0] round
     /* 1170604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1170617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170639 */     // GIR_Coverage, 15867,
     /* 1170639 */     GIR_EraseRootFromParent_Done,
     /* 1170640 */   // Label 17065: @1170640
     /* 1170640 */   GIM_Try, /*On fail goto*//*Label 17066*/ GIMT_Encode4(1170720), // Rule ID 15870 //
     /* 1170645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1170656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1170659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1170662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1170665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170684 */     // MIs[0] round
     /* 1170684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170694 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1170697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170719 */     // GIR_Coverage, 15870,
     /* 1170719 */     GIR_EraseRootFromParent_Done,
     /* 1170720 */   // Label 17066: @1170720
     /* 1170720 */   GIM_Try, /*On fail goto*//*Label 17067*/ GIMT_Encode4(1170800), // Rule ID 15871 //
     /* 1170725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1170736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1170739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1170742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1170745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170764 */     // MIs[0] round
     /* 1170764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170774 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1170777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170799 */     // GIR_Coverage, 15871,
     /* 1170799 */     GIR_EraseRootFromParent_Done,
     /* 1170800 */   // Label 17067: @1170800
     /* 1170800 */   GIM_Try, /*On fail goto*//*Label 17068*/ GIMT_Encode4(1170880), // Rule ID 15874 //
     /* 1170805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1170816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1170819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1170822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1170825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170844 */     // MIs[0] round
     /* 1170844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170854 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1170857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170879 */     // GIR_Coverage, 15874,
     /* 1170879 */     GIR_EraseRootFromParent_Done,
     /* 1170880 */   // Label 17068: @1170880
     /* 1170880 */   GIM_Try, /*On fail goto*//*Label 17069*/ GIMT_Encode4(1170960), // Rule ID 15875 //
     /* 1170885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1170896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1170899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1170902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1170905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170924 */     // MIs[0] round
     /* 1170924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170934 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1170937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170959 */     // GIR_Coverage, 15875,
     /* 1170959 */     GIR_EraseRootFromParent_Done,
     /* 1170960 */   // Label 17069: @1170960
     /* 1170960 */   GIM_Try, /*On fail goto*//*Label 17070*/ GIMT_Encode4(1171040), // Rule ID 15878 //
     /* 1170965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1170968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1170976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1170979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1170982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1170985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171004 */     // MIs[0] round
     /* 1171004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1171017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171039 */     // GIR_Coverage, 15878,
     /* 1171039 */     GIR_EraseRootFromParent_Done,
     /* 1171040 */   // Label 17070: @1171040
     /* 1171040 */   GIM_Try, /*On fail goto*//*Label 17071*/ GIMT_Encode4(1171120), // Rule ID 15879 //
     /* 1171045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1171048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1171056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1171059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1171062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1171065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171084 */     // MIs[0] round
     /* 1171084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171094 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1171097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171119 */     // GIR_Coverage, 15879,
     /* 1171119 */     GIR_EraseRootFromParent_Done,
     /* 1171120 */   // Label 17071: @1171120
     /* 1171120 */   GIM_Try, /*On fail goto*//*Label 17072*/ GIMT_Encode4(1171200), // Rule ID 15882 //
     /* 1171125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1171128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1171136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1171139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1171142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1171145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171164 */     // MIs[0] round
     /* 1171164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171174 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1171177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171199 */     // GIR_Coverage, 15882,
     /* 1171199 */     GIR_EraseRootFromParent_Done,
     /* 1171200 */   // Label 17072: @1171200
     /* 1171200 */   GIM_Try, /*On fail goto*//*Label 17073*/ GIMT_Encode4(1171280), // Rule ID 15883 //
     /* 1171205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1171208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1171216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1171219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1171222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1171225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171244 */     // MIs[0] round
     /* 1171244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171254 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1171257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171279 */     // GIR_Coverage, 15883,
     /* 1171279 */     GIR_EraseRootFromParent_Done,
     /* 1171280 */   // Label 17073: @1171280
     /* 1171280 */   GIM_Try, /*On fail goto*//*Label 17074*/ GIMT_Encode4(1171360), // Rule ID 15886 //
     /* 1171285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1171288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1171296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1171299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1171302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1171305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171324 */     // MIs[0] round
     /* 1171324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171334 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1171337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171359 */     // GIR_Coverage, 15886,
     /* 1171359 */     GIR_EraseRootFromParent_Done,
     /* 1171360 */   // Label 17074: @1171360
     /* 1171360 */   GIM_Try, /*On fail goto*//*Label 17075*/ GIMT_Encode4(1171440), // Rule ID 15887 //
     /* 1171365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1171368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1171376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1171379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1171382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1171385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171404 */     // MIs[0] round
     /* 1171404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171414 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1171417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171439 */     // GIR_Coverage, 15887,
     /* 1171439 */     GIR_EraseRootFromParent_Done,
     /* 1171440 */   // Label 17075: @1171440
     /* 1171440 */   GIM_Try, /*On fail goto*//*Label 17076*/ GIMT_Encode4(1171520), // Rule ID 15890 //
     /* 1171445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1171456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1171459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1171462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171484 */     // MIs[0] round
     /* 1171484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171494 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1171497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171519 */     // GIR_Coverage, 15890,
     /* 1171519 */     GIR_EraseRootFromParent_Done,
     /* 1171520 */   // Label 17076: @1171520
     /* 1171520 */   GIM_Try, /*On fail goto*//*Label 17077*/ GIMT_Encode4(1171600), // Rule ID 15891 //
     /* 1171525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1171536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1171539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1171542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171564 */     // MIs[0] round
     /* 1171564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171574 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1171577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171599 */     // GIR_Coverage, 15891,
     /* 1171599 */     GIR_EraseRootFromParent_Done,
     /* 1171600 */   // Label 17077: @1171600
     /* 1171600 */   GIM_Try, /*On fail goto*//*Label 17078*/ GIMT_Encode4(1171680), // Rule ID 15894 //
     /* 1171605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1171616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1171619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1171622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171644 */     // MIs[0] round
     /* 1171644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171654 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1171657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171679 */     // GIR_Coverage, 15894,
     /* 1171679 */     GIR_EraseRootFromParent_Done,
     /* 1171680 */   // Label 17078: @1171680
     /* 1171680 */   GIM_Try, /*On fail goto*//*Label 17079*/ GIMT_Encode4(1171760), // Rule ID 15895 //
     /* 1171685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1171696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1171699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1171702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171724 */     // MIs[0] round
     /* 1171724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171734 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1171737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171759 */     // GIR_Coverage, 15895,
     /* 1171759 */     GIR_EraseRootFromParent_Done,
     /* 1171760 */   // Label 17079: @1171760
     /* 1171760 */   GIM_Try, /*On fail goto*//*Label 17080*/ GIMT_Encode4(1171840), // Rule ID 15898 //
     /* 1171765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1171776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1171779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1171782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171804 */     // MIs[0] round
     /* 1171804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171814 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1171817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171839 */     // GIR_Coverage, 15898,
     /* 1171839 */     GIR_EraseRootFromParent_Done,
     /* 1171840 */   // Label 17080: @1171840
     /* 1171840 */   GIM_Try, /*On fail goto*//*Label 17081*/ GIMT_Encode4(1171920), // Rule ID 15899 //
     /* 1171845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1171856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1171859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1171862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171884 */     // MIs[0] round
     /* 1171884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171894 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1171897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171919 */     // GIR_Coverage, 15899,
     /* 1171919 */     GIR_EraseRootFromParent_Done,
     /* 1171920 */   // Label 17081: @1171920
     /* 1171920 */   GIM_Try, /*On fail goto*//*Label 17082*/ GIMT_Encode4(1172000), // Rule ID 15902 //
     /* 1171925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1171936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1171939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1171942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171964 */     // MIs[0] round
     /* 1171964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171974 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1171977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171999 */     // GIR_Coverage, 15902,
     /* 1171999 */     GIR_EraseRootFromParent_Done,
     /* 1172000 */   // Label 17082: @1172000
     /* 1172000 */   GIM_Try, /*On fail goto*//*Label 17083*/ GIMT_Encode4(1172080), // Rule ID 15903 //
     /* 1172005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1172013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1172016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1172019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1172022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172044 */     // MIs[0] round
     /* 1172044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172054 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1172057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172079 */     // GIR_Coverage, 15903,
     /* 1172079 */     GIR_EraseRootFromParent_Done,
     /* 1172080 */   // Label 17083: @1172080
     /* 1172080 */   GIM_Try, /*On fail goto*//*Label 17084*/ GIMT_Encode4(1172160), // Rule ID 15906 //
     /* 1172085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1172093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1172096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1172099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1172102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172124 */     // MIs[0] round
     /* 1172124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172134 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1172137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172159 */     // GIR_Coverage, 15906,
     /* 1172159 */     GIR_EraseRootFromParent_Done,
     /* 1172160 */   // Label 17084: @1172160
     /* 1172160 */   GIM_Try, /*On fail goto*//*Label 17085*/ GIMT_Encode4(1172240), // Rule ID 15907 //
     /* 1172165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1172173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1172176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1172179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1172182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172204 */     // MIs[0] round
     /* 1172204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172214 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1172217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172239 */     // GIR_Coverage, 15907,
     /* 1172239 */     GIR_EraseRootFromParent_Done,
     /* 1172240 */   // Label 17085: @1172240
     /* 1172240 */   GIM_Try, /*On fail goto*//*Label 17086*/ GIMT_Encode4(1172320), // Rule ID 15910 //
     /* 1172245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1172253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1172256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1172259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1172262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172284 */     // MIs[0] round
     /* 1172284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1172297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172319 */     // GIR_Coverage, 15910,
     /* 1172319 */     GIR_EraseRootFromParent_Done,
     /* 1172320 */   // Label 17086: @1172320
     /* 1172320 */   GIM_Try, /*On fail goto*//*Label 17087*/ GIMT_Encode4(1172400), // Rule ID 15911 //
     /* 1172325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1172333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1172336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1172339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1172342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172364 */     // MIs[0] round
     /* 1172364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172374 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1172377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172399 */     // GIR_Coverage, 15911,
     /* 1172399 */     GIR_EraseRootFromParent_Done,
     /* 1172400 */   // Label 17087: @1172400
     /* 1172400 */   GIM_Try, /*On fail goto*//*Label 17088*/ GIMT_Encode4(1172480), // Rule ID 15914 //
     /* 1172405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1172413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1172416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1172419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1172422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172444 */     // MIs[0] round
     /* 1172444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172454 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1172457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172479 */     // GIR_Coverage, 15914,
     /* 1172479 */     GIR_EraseRootFromParent_Done,
     /* 1172480 */   // Label 17088: @1172480
     /* 1172480 */   GIM_Try, /*On fail goto*//*Label 17089*/ GIMT_Encode4(1172560), // Rule ID 15915 //
     /* 1172485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1172493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1172496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1172499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1172502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172524 */     // MIs[0] round
     /* 1172524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172534 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1172537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172559 */     // GIR_Coverage, 15915,
     /* 1172559 */     GIR_EraseRootFromParent_Done,
     /* 1172560 */   // Label 17089: @1172560
     /* 1172560 */   GIM_Try, /*On fail goto*//*Label 17090*/ GIMT_Encode4(1172640), // Rule ID 15918 //
     /* 1172565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1172573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1172576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1172579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1172582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172604 */     // MIs[0] round
     /* 1172604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172614 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1172617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172639 */     // GIR_Coverage, 15918,
     /* 1172639 */     GIR_EraseRootFromParent_Done,
     /* 1172640 */   // Label 17090: @1172640
     /* 1172640 */   GIM_Try, /*On fail goto*//*Label 17091*/ GIMT_Encode4(1172720), // Rule ID 15919 //
     /* 1172645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1172653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1172656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1172659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1172662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172684 */     // MIs[0] round
     /* 1172684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1172697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172719 */     // GIR_Coverage, 15919,
     /* 1172719 */     GIR_EraseRootFromParent_Done,
     /* 1172720 */   // Label 17091: @1172720
     /* 1172720 */   GIM_Try, /*On fail goto*//*Label 17092*/ GIMT_Encode4(1172800), // Rule ID 15922 //
     /* 1172725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1172733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1172736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1172739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172764 */     // MIs[0] round
     /* 1172764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1172777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172799 */     // GIR_Coverage, 15922,
     /* 1172799 */     GIR_EraseRootFromParent_Done,
     /* 1172800 */   // Label 17092: @1172800
     /* 1172800 */   GIM_Try, /*On fail goto*//*Label 17093*/ GIMT_Encode4(1172880), // Rule ID 15923 //
     /* 1172805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1172813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1172816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1172819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172844 */     // MIs[0] round
     /* 1172844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172854 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1172857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172879 */     // GIR_Coverage, 15923,
     /* 1172879 */     GIR_EraseRootFromParent_Done,
     /* 1172880 */   // Label 17093: @1172880
     /* 1172880 */   GIM_Try, /*On fail goto*//*Label 17094*/ GIMT_Encode4(1172960), // Rule ID 15926 //
     /* 1172885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1172888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1172893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1172896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1172899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1172902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172924 */     // MIs[0] round
     /* 1172924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172934 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1172937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1172955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172959 */     // GIR_Coverage, 15926,
     /* 1172959 */     GIR_EraseRootFromParent_Done,
     /* 1172960 */   // Label 17094: @1172960
     /* 1172960 */   GIM_Try, /*On fail goto*//*Label 17095*/ GIMT_Encode4(1173040), // Rule ID 15927 //
     /* 1172965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1172968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1172973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1172976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1172979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1172982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173004 */     // MIs[0] round
     /* 1173004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1173017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173039 */     // GIR_Coverage, 15927,
     /* 1173039 */     GIR_EraseRootFromParent_Done,
     /* 1173040 */   // Label 17095: @1173040
     /* 1173040 */   GIM_Try, /*On fail goto*//*Label 17096*/ GIMT_Encode4(1173120), // Rule ID 15930 //
     /* 1173045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1173053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1173056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1173059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1173062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173084 */     // MIs[0] round
     /* 1173084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173094 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1173097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173119 */     // GIR_Coverage, 15930,
     /* 1173119 */     GIR_EraseRootFromParent_Done,
     /* 1173120 */   // Label 17096: @1173120
     /* 1173120 */   GIM_Try, /*On fail goto*//*Label 17097*/ GIMT_Encode4(1173200), // Rule ID 15931 //
     /* 1173125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1173133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1173136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1173139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1173142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173164 */     // MIs[0] round
     /* 1173164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173174 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1173177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173199 */     // GIR_Coverage, 15931,
     /* 1173199 */     GIR_EraseRootFromParent_Done,
     /* 1173200 */   // Label 17097: @1173200
     /* 1173200 */   GIM_Try, /*On fail goto*//*Label 17098*/ GIMT_Encode4(1173280), // Rule ID 15934 //
     /* 1173205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1173213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1173216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1173219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1173222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173244 */     // MIs[0] round
     /* 1173244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173254 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1173257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173279 */     // GIR_Coverage, 15934,
     /* 1173279 */     GIR_EraseRootFromParent_Done,
     /* 1173280 */   // Label 17098: @1173280
     /* 1173280 */   GIM_Try, /*On fail goto*//*Label 17099*/ GIMT_Encode4(1173360), // Rule ID 15935 //
     /* 1173285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1173293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1173296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1173299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1173302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173324 */     // MIs[0] round
     /* 1173324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173334 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1173337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173359 */     // GIR_Coverage, 15935,
     /* 1173359 */     GIR_EraseRootFromParent_Done,
     /* 1173360 */   // Label 17099: @1173360
     /* 1173360 */   GIM_Try, /*On fail goto*//*Label 17100*/ GIMT_Encode4(1173440), // Rule ID 15938 //
     /* 1173365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1173373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1173376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1173379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1173382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173404 */     // MIs[0] round
     /* 1173404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173414 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1173417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173439 */     // GIR_Coverage, 15938,
     /* 1173439 */     GIR_EraseRootFromParent_Done,
     /* 1173440 */   // Label 17100: @1173440
     /* 1173440 */   GIM_Try, /*On fail goto*//*Label 17101*/ GIMT_Encode4(1173520), // Rule ID 15939 //
     /* 1173445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1173453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1173456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1173459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1173462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173484 */     // MIs[0] round
     /* 1173484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173494 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1173497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173519 */     // GIR_Coverage, 15939,
     /* 1173519 */     GIR_EraseRootFromParent_Done,
     /* 1173520 */   // Label 17101: @1173520
     /* 1173520 */   GIM_Try, /*On fail goto*//*Label 17102*/ GIMT_Encode4(1173600), // Rule ID 15942 //
     /* 1173525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1173533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1173536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1173539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1173542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173564 */     // MIs[0] round
     /* 1173564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173574 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1173577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173599 */     // GIR_Coverage, 15942,
     /* 1173599 */     GIR_EraseRootFromParent_Done,
     /* 1173600 */   // Label 17102: @1173600
     /* 1173600 */   GIM_Try, /*On fail goto*//*Label 17103*/ GIMT_Encode4(1173680), // Rule ID 15943 //
     /* 1173605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1173613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1173616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1173619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1173622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173644 */     // MIs[0] round
     /* 1173644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173654 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1173657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173679 */     // GIR_Coverage, 15943,
     /* 1173679 */     GIR_EraseRootFromParent_Done,
     /* 1173680 */   // Label 17103: @1173680
     /* 1173680 */   GIM_Try, /*On fail goto*//*Label 17104*/ GIMT_Encode4(1173760), // Rule ID 15946 //
     /* 1173685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1173693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1173696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1173699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173724 */     // MIs[0] round
     /* 1173724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173734 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1173737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173759 */     // GIR_Coverage, 15946,
     /* 1173759 */     GIR_EraseRootFromParent_Done,
     /* 1173760 */   // Label 17104: @1173760
     /* 1173760 */   GIM_Try, /*On fail goto*//*Label 17105*/ GIMT_Encode4(1173840), // Rule ID 15947 //
     /* 1173765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1173773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1173776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1173779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173804 */     // MIs[0] round
     /* 1173804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173814 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1173817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173839 */     // GIR_Coverage, 15947,
     /* 1173839 */     GIR_EraseRootFromParent_Done,
     /* 1173840 */   // Label 17105: @1173840
     /* 1173840 */   GIM_Try, /*On fail goto*//*Label 17106*/ GIMT_Encode4(1173920), // Rule ID 15950 //
     /* 1173845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1173853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1173856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1173859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1173862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173884 */     // MIs[0] round
     /* 1173884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173894 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1173897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173919 */     // GIR_Coverage, 15950,
     /* 1173919 */     GIR_EraseRootFromParent_Done,
     /* 1173920 */   // Label 17106: @1173920
     /* 1173920 */   GIM_Try, /*On fail goto*//*Label 17107*/ GIMT_Encode4(1174000), // Rule ID 15951 //
     /* 1173925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1173933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1173936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1173939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1173942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173964 */     // MIs[0] round
     /* 1173964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173974 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1173977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173999 */     // GIR_Coverage, 15951,
     /* 1173999 */     GIR_EraseRootFromParent_Done,
     /* 1174000 */   // Label 17107: @1174000
     /* 1174000 */   GIM_Try, /*On fail goto*//*Label 17108*/ GIMT_Encode4(1174080), // Rule ID 15954 //
     /* 1174005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1174013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1174016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1174019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1174022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174044 */     // MIs[0] round
     /* 1174044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174054 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1174057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174079 */     // GIR_Coverage, 15954,
     /* 1174079 */     GIR_EraseRootFromParent_Done,
     /* 1174080 */   // Label 17108: @1174080
     /* 1174080 */   GIM_Try, /*On fail goto*//*Label 17109*/ GIMT_Encode4(1174160), // Rule ID 15955 //
     /* 1174085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1174093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1174096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1174099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1174102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174124 */     // MIs[0] round
     /* 1174124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1174137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174159 */     // GIR_Coverage, 15955,
     /* 1174159 */     GIR_EraseRootFromParent_Done,
     /* 1174160 */   // Label 17109: @1174160
     /* 1174160 */   GIM_Try, /*On fail goto*//*Label 17110*/ GIMT_Encode4(1174240), // Rule ID 15958 //
     /* 1174165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1174173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1174176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1174179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1174182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174204 */     // MIs[0] round
     /* 1174204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1174217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174239 */     // GIR_Coverage, 15958,
     /* 1174239 */     GIR_EraseRootFromParent_Done,
     /* 1174240 */   // Label 17110: @1174240
     /* 1174240 */   GIM_Try, /*On fail goto*//*Label 17111*/ GIMT_Encode4(1174320), // Rule ID 15959 //
     /* 1174245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1174253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1174256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1174259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1174262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174284 */     // MIs[0] round
     /* 1174284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174294 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1174297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174319 */     // GIR_Coverage, 15959,
     /* 1174319 */     GIR_EraseRootFromParent_Done,
     /* 1174320 */   // Label 17111: @1174320
     /* 1174320 */   GIM_Try, /*On fail goto*//*Label 17112*/ GIMT_Encode4(1174400), // Rule ID 15962 //
     /* 1174325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1174333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1174336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1174339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1174342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174364 */     // MIs[0] round
     /* 1174364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174374 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1174377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174399 */     // GIR_Coverage, 15962,
     /* 1174399 */     GIR_EraseRootFromParent_Done,
     /* 1174400 */   // Label 17112: @1174400
     /* 1174400 */   GIM_Try, /*On fail goto*//*Label 17113*/ GIMT_Encode4(1174480), // Rule ID 15963 //
     /* 1174405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1174413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1174416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1174419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1174422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174444 */     // MIs[0] round
     /* 1174444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174454 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1174457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174479 */     // GIR_Coverage, 15963,
     /* 1174479 */     GIR_EraseRootFromParent_Done,
     /* 1174480 */   // Label 17113: @1174480
     /* 1174480 */   GIM_Try, /*On fail goto*//*Label 17114*/ GIMT_Encode4(1174560), // Rule ID 15966 //
     /* 1174485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1174493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1174496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1174499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1174502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174524 */     // MIs[0] round
     /* 1174524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1174537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174559 */     // GIR_Coverage, 15966,
     /* 1174559 */     GIR_EraseRootFromParent_Done,
     /* 1174560 */   // Label 17114: @1174560
     /* 1174560 */   GIM_Try, /*On fail goto*//*Label 17115*/ GIMT_Encode4(1174640), // Rule ID 15967 //
     /* 1174565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1174573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1174576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1174579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1174582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174604 */     // MIs[0] round
     /* 1174604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174614 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1174617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174639 */     // GIR_Coverage, 15967,
     /* 1174639 */     GIR_EraseRootFromParent_Done,
     /* 1174640 */   // Label 17115: @1174640
     /* 1174640 */   GIM_Try, /*On fail goto*//*Label 17116*/ GIMT_Encode4(1174720), // Rule ID 15970 //
     /* 1174645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1174653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1174656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1174659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174684 */     // MIs[0] round
     /* 1174684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174694 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1174697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174719 */     // GIR_Coverage, 15970,
     /* 1174719 */     GIR_EraseRootFromParent_Done,
     /* 1174720 */   // Label 17116: @1174720
     /* 1174720 */   GIM_Try, /*On fail goto*//*Label 17117*/ GIMT_Encode4(1174800), // Rule ID 15971 //
     /* 1174725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1174733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1174736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1174739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174764 */     // MIs[0] round
     /* 1174764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174774 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1174777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174799 */     // GIR_Coverage, 15971,
     /* 1174799 */     GIR_EraseRootFromParent_Done,
     /* 1174800 */   // Label 17117: @1174800
     /* 1174800 */   GIM_Try, /*On fail goto*//*Label 17118*/ GIMT_Encode4(1174880), // Rule ID 15974 //
     /* 1174805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1174813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1174816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1174819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1174822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174844 */     // MIs[0] round
     /* 1174844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174854 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1174857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174879 */     // GIR_Coverage, 15974,
     /* 1174879 */     GIR_EraseRootFromParent_Done,
     /* 1174880 */   // Label 17118: @1174880
     /* 1174880 */   GIM_Try, /*On fail goto*//*Label 17119*/ GIMT_Encode4(1174960), // Rule ID 15975 //
     /* 1174885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1174893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1174896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1174899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1174902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174924 */     // MIs[0] round
     /* 1174924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174934 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1174937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174959 */     // GIR_Coverage, 15975,
     /* 1174959 */     GIR_EraseRootFromParent_Done,
     /* 1174960 */   // Label 17119: @1174960
     /* 1174960 */   GIM_Try, /*On fail goto*//*Label 17120*/ GIMT_Encode4(1175040), // Rule ID 16066 //
     /* 1174965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1174976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1174979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1174982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1174985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175004 */     // MIs[0] round
     /* 1175004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175014 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1175017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175039 */     // GIR_Coverage, 16066,
     /* 1175039 */     GIR_EraseRootFromParent_Done,
     /* 1175040 */   // Label 17120: @1175040
     /* 1175040 */   GIM_Try, /*On fail goto*//*Label 17121*/ GIMT_Encode4(1175120), // Rule ID 16067 //
     /* 1175045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1175056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1175059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1175062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1175065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175084 */     // MIs[0] round
     /* 1175084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175094 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1175097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175119 */     // GIR_Coverage, 16067,
     /* 1175119 */     GIR_EraseRootFromParent_Done,
     /* 1175120 */   // Label 17121: @1175120
     /* 1175120 */   GIM_Try, /*On fail goto*//*Label 17122*/ GIMT_Encode4(1175200), // Rule ID 16070 //
     /* 1175125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1175136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1175139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1175142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1175145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175164 */     // MIs[0] round
     /* 1175164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175174 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1175177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175199 */     // GIR_Coverage, 16070,
     /* 1175199 */     GIR_EraseRootFromParent_Done,
     /* 1175200 */   // Label 17122: @1175200
     /* 1175200 */   GIM_Try, /*On fail goto*//*Label 17123*/ GIMT_Encode4(1175280), // Rule ID 16071 //
     /* 1175205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1175216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1175219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1175222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1175225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175244 */     // MIs[0] round
     /* 1175244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175254 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1175257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175279 */     // GIR_Coverage, 16071,
     /* 1175279 */     GIR_EraseRootFromParent_Done,
     /* 1175280 */   // Label 17123: @1175280
     /* 1175280 */   GIM_Try, /*On fail goto*//*Label 17124*/ GIMT_Encode4(1175360), // Rule ID 16074 //
     /* 1175285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1175296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1175299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1175302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1175305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175324 */     // MIs[0] round
     /* 1175324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175334 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1175337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175359 */     // GIR_Coverage, 16074,
     /* 1175359 */     GIR_EraseRootFromParent_Done,
     /* 1175360 */   // Label 17124: @1175360
     /* 1175360 */   GIM_Try, /*On fail goto*//*Label 17125*/ GIMT_Encode4(1175440), // Rule ID 16075 //
     /* 1175365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1175376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1175379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1175382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1175385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175404 */     // MIs[0] round
     /* 1175404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175414 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1175417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175439 */     // GIR_Coverage, 16075,
     /* 1175439 */     GIR_EraseRootFromParent_Done,
     /* 1175440 */   // Label 17125: @1175440
     /* 1175440 */   GIM_Try, /*On fail goto*//*Label 17126*/ GIMT_Encode4(1175520), // Rule ID 16078 //
     /* 1175445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1175456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1175459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1175462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1175465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175484 */     // MIs[0] round
     /* 1175484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1175497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175519 */     // GIR_Coverage, 16078,
     /* 1175519 */     GIR_EraseRootFromParent_Done,
     /* 1175520 */   // Label 17126: @1175520
     /* 1175520 */   GIM_Try, /*On fail goto*//*Label 17127*/ GIMT_Encode4(1175600), // Rule ID 16079 //
     /* 1175525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1175536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1175539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1175542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1175545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175564 */     // MIs[0] round
     /* 1175564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175574 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1175577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175599 */     // GIR_Coverage, 16079,
     /* 1175599 */     GIR_EraseRootFromParent_Done,
     /* 1175600 */   // Label 17127: @1175600
     /* 1175600 */   GIM_Try, /*On fail goto*//*Label 17128*/ GIMT_Encode4(1175680), // Rule ID 16082 //
     /* 1175605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1175616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1175619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1175622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1175625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175644 */     // MIs[0] round
     /* 1175644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175654 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1175657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175679 */     // GIR_Coverage, 16082,
     /* 1175679 */     GIR_EraseRootFromParent_Done,
     /* 1175680 */   // Label 17128: @1175680
     /* 1175680 */   GIM_Try, /*On fail goto*//*Label 17129*/ GIMT_Encode4(1175760), // Rule ID 16083 //
     /* 1175685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1175696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1175699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1175702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1175705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175724 */     // MIs[0] round
     /* 1175724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175734 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1175737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175759 */     // GIR_Coverage, 16083,
     /* 1175759 */     GIR_EraseRootFromParent_Done,
     /* 1175760 */   // Label 17129: @1175760
     /* 1175760 */   GIM_Try, /*On fail goto*//*Label 17130*/ GIMT_Encode4(1175840), // Rule ID 16086 //
     /* 1175765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1175776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1175779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1175782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1175785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175804 */     // MIs[0] round
     /* 1175804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1175817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175839 */     // GIR_Coverage, 16086,
     /* 1175839 */     GIR_EraseRootFromParent_Done,
     /* 1175840 */   // Label 17130: @1175840
     /* 1175840 */   GIM_Try, /*On fail goto*//*Label 17131*/ GIMT_Encode4(1175920), // Rule ID 16087 //
     /* 1175845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1175856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1175859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1175862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1175865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175884 */     // MIs[0] round
     /* 1175884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175894 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1175897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175919 */     // GIR_Coverage, 16087,
     /* 1175919 */     GIR_EraseRootFromParent_Done,
     /* 1175920 */   // Label 17131: @1175920
     /* 1175920 */   GIM_Try, /*On fail goto*//*Label 17132*/ GIMT_Encode4(1176000), // Rule ID 16090 //
     /* 1175925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1175936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1175939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1175942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1175945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175964 */     // MIs[0] round
     /* 1175964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1175977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175999 */     // GIR_Coverage, 16090,
     /* 1175999 */     GIR_EraseRootFromParent_Done,
     /* 1176000 */   // Label 17132: @1176000
     /* 1176000 */   GIM_Try, /*On fail goto*//*Label 17133*/ GIMT_Encode4(1176080), // Rule ID 16091 //
     /* 1176005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1176016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1176019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1176022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1176025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176044 */     // MIs[0] round
     /* 1176044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176054 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1176057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176079 */     // GIR_Coverage, 16091,
     /* 1176079 */     GIR_EraseRootFromParent_Done,
     /* 1176080 */   // Label 17133: @1176080
     /* 1176080 */   GIM_Try, /*On fail goto*//*Label 17134*/ GIMT_Encode4(1176160), // Rule ID 16094 //
     /* 1176085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1176096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1176099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1176102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1176105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176124 */     // MIs[0] round
     /* 1176124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176134 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1176137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176159 */     // GIR_Coverage, 16094,
     /* 1176159 */     GIR_EraseRootFromParent_Done,
     /* 1176160 */   // Label 17134: @1176160
     /* 1176160 */   GIM_Try, /*On fail goto*//*Label 17135*/ GIMT_Encode4(1176240), // Rule ID 16095 //
     /* 1176165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1176176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1176179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1176182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1176185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176204 */     // MIs[0] round
     /* 1176204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176214 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1176217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176239 */     // GIR_Coverage, 16095,
     /* 1176239 */     GIR_EraseRootFromParent_Done,
     /* 1176240 */   // Label 17135: @1176240
     /* 1176240 */   GIM_Try, /*On fail goto*//*Label 17136*/ GIMT_Encode4(1176320), // Rule ID 16098 //
     /* 1176245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1176256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1176259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1176262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1176265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176284 */     // MIs[0] round
     /* 1176284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176294 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1176297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1176315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176319 */     // GIR_Coverage, 16098,
     /* 1176319 */     GIR_EraseRootFromParent_Done,
     /* 1176320 */   // Label 17136: @1176320
     /* 1176320 */   GIM_Try, /*On fail goto*//*Label 17137*/ GIMT_Encode4(1176400), // Rule ID 16099 //
     /* 1176325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1176336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1176339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1176342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1176345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176364 */     // MIs[0] round
     /* 1176364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176374 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1176377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1176395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176399 */     // GIR_Coverage, 16099,
     /* 1176399 */     GIR_EraseRootFromParent_Done,
     /* 1176400 */   // Label 17137: @1176400
     /* 1176400 */   GIM_Try, /*On fail goto*//*Label 17138*/ GIMT_Encode4(1176480), // Rule ID 16102 //
     /* 1176405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1176408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1176416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1176419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1176422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1176425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176444 */     // MIs[0] round
     /* 1176444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176454 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1176457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1176475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176479 */     // GIR_Coverage, 16102,
     /* 1176479 */     GIR_EraseRootFromParent_Done,
     /* 1176480 */   // Label 17138: @1176480
     /* 1176480 */   GIM_Try, /*On fail goto*//*Label 17139*/ GIMT_Encode4(1176560), // Rule ID 16103 //
     /* 1176485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1176488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1176496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1176499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1176502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1176505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176524 */     // MIs[0] round
     /* 1176524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176534 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1176537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1176555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176559 */     // GIR_Coverage, 16103,
     /* 1176559 */     GIR_EraseRootFromParent_Done,
     /* 1176560 */   // Label 17139: @1176560
     /* 1176560 */   GIM_Try, /*On fail goto*//*Label 17140*/ GIMT_Encode4(1176640), // Rule ID 16106 //
     /* 1176565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1176576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1176579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1176582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1176585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176604 */     // MIs[0] round
     /* 1176604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176614 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1176617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176639 */     // GIR_Coverage, 16106,
     /* 1176639 */     GIR_EraseRootFromParent_Done,
     /* 1176640 */   // Label 17140: @1176640
     /* 1176640 */   GIM_Try, /*On fail goto*//*Label 17141*/ GIMT_Encode4(1176720), // Rule ID 16107 //
     /* 1176645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1176656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1176659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1176662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1176665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176684 */     // MIs[0] round
     /* 1176684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176694 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1176697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176719 */     // GIR_Coverage, 16107,
     /* 1176719 */     GIR_EraseRootFromParent_Done,
     /* 1176720 */   // Label 17141: @1176720
     /* 1176720 */   GIM_Try, /*On fail goto*//*Label 17142*/ GIMT_Encode4(1176800), // Rule ID 16110 //
     /* 1176725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1176745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176764 */     // MIs[0] round
     /* 1176764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176774 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1176777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176799 */     // GIR_Coverage, 16110,
     /* 1176799 */     GIR_EraseRootFromParent_Done,
     /* 1176800 */   // Label 17142: @1176800
     /* 1176800 */   GIM_Try, /*On fail goto*//*Label 17143*/ GIMT_Encode4(1176880), // Rule ID 16111 //
     /* 1176805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1176825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176844 */     // MIs[0] round
     /* 1176844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176854 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1176857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176879 */     // GIR_Coverage, 16111,
     /* 1176879 */     GIR_EraseRootFromParent_Done,
     /* 1176880 */   // Label 17143: @1176880
     /* 1176880 */   GIM_Try, /*On fail goto*//*Label 17144*/ GIMT_Encode4(1176960), // Rule ID 16114 //
     /* 1176885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1176896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1176899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1176902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1176905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176924 */     // MIs[0] round
     /* 1176924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176934 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1176937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176959 */     // GIR_Coverage, 16114,
     /* 1176959 */     GIR_EraseRootFromParent_Done,
     /* 1176960 */   // Label 17144: @1176960
     /* 1176960 */   GIM_Try, /*On fail goto*//*Label 17145*/ GIMT_Encode4(1177040), // Rule ID 16115 //
     /* 1176965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1176976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1176979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1176982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1176985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177004 */     // MIs[0] round
     /* 1177004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177014 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1177017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1177035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177039 */     // GIR_Coverage, 16115,
     /* 1177039 */     GIR_EraseRootFromParent_Done,
     /* 1177040 */   // Label 17145: @1177040
     /* 1177040 */   GIM_Try, /*On fail goto*//*Label 17146*/ GIMT_Encode4(1177120), // Rule ID 16118 //
     /* 1177045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1177056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1177059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1177062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1177065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177084 */     // MIs[0] round
     /* 1177084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177094 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1177097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177119 */     // GIR_Coverage, 16118,
     /* 1177119 */     GIR_EraseRootFromParent_Done,
     /* 1177120 */   // Label 17146: @1177120
     /* 1177120 */   GIM_Try, /*On fail goto*//*Label 17147*/ GIMT_Encode4(1177200), // Rule ID 16119 //
     /* 1177125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1177136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1177139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1177142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1177145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177164 */     // MIs[0] round
     /* 1177164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177174 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1177177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177199 */     // GIR_Coverage, 16119,
     /* 1177199 */     GIR_EraseRootFromParent_Done,
     /* 1177200 */   // Label 17147: @1177200
     /* 1177200 */   GIM_Try, /*On fail goto*//*Label 17148*/ GIMT_Encode4(1177280), // Rule ID 16122 //
     /* 1177205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1177216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1177219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1177222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1177225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177244 */     // MIs[0] round
     /* 1177244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177254 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1177257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177279 */     // GIR_Coverage, 16122,
     /* 1177279 */     GIR_EraseRootFromParent_Done,
     /* 1177280 */   // Label 17148: @1177280
     /* 1177280 */   GIM_Try, /*On fail goto*//*Label 17149*/ GIMT_Encode4(1177360), // Rule ID 16123 //
     /* 1177285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1177296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1177299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1177302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1177305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177324 */     // MIs[0] round
     /* 1177324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177334 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1177337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177359 */     // GIR_Coverage, 16123,
     /* 1177359 */     GIR_EraseRootFromParent_Done,
     /* 1177360 */   // Label 17149: @1177360
     /* 1177360 */   GIM_Try, /*On fail goto*//*Label 17150*/ GIMT_Encode4(1177440), // Rule ID 16126 //
     /* 1177365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1177376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1177379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1177382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1177385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177404 */     // MIs[0] round
     /* 1177404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177414 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1177417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177439 */     // GIR_Coverage, 16126,
     /* 1177439 */     GIR_EraseRootFromParent_Done,
     /* 1177440 */   // Label 17150: @1177440
     /* 1177440 */   GIM_Try, /*On fail goto*//*Label 17151*/ GIMT_Encode4(1177520), // Rule ID 16127 //
     /* 1177445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1177456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1177459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1177462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1177465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177484 */     // MIs[0] round
     /* 1177484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177494 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1177497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177519 */     // GIR_Coverage, 16127,
     /* 1177519 */     GIR_EraseRootFromParent_Done,
     /* 1177520 */   // Label 17151: @1177520
     /* 1177520 */   GIM_Try, /*On fail goto*//*Label 17152*/ GIMT_Encode4(1177600), // Rule ID 16130 //
     /* 1177525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1177536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1177539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1177545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177564 */     // MIs[0] round
     /* 1177564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177574 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1177577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177599 */     // GIR_Coverage, 16130,
     /* 1177599 */     GIR_EraseRootFromParent_Done,
     /* 1177600 */   // Label 17152: @1177600
     /* 1177600 */   GIM_Try, /*On fail goto*//*Label 17153*/ GIMT_Encode4(1177680), // Rule ID 16131 //
     /* 1177605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1177616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1177619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1177625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177644 */     // MIs[0] round
     /* 1177644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1177657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177679 */     // GIR_Coverage, 16131,
     /* 1177679 */     GIR_EraseRootFromParent_Done,
     /* 1177680 */   // Label 17153: @1177680
     /* 1177680 */   GIM_Try, /*On fail goto*//*Label 17154*/ GIMT_Encode4(1177760), // Rule ID 16134 //
     /* 1177685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1177696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1177699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1177705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177724 */     // MIs[0] round
     /* 1177724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177734 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1177737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177759 */     // GIR_Coverage, 16134,
     /* 1177759 */     GIR_EraseRootFromParent_Done,
     /* 1177760 */   // Label 17154: @1177760
     /* 1177760 */   GIM_Try, /*On fail goto*//*Label 17155*/ GIMT_Encode4(1177840), // Rule ID 16135 //
     /* 1177765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1177776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1177779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1177785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177804 */     // MIs[0] round
     /* 1177804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177814 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1177817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177839 */     // GIR_Coverage, 16135,
     /* 1177839 */     GIR_EraseRootFromParent_Done,
     /* 1177840 */   // Label 17155: @1177840
     /* 1177840 */   GIM_Try, /*On fail goto*//*Label 17156*/ GIMT_Encode4(1177920), // Rule ID 16138 //
     /* 1177845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1177856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1177859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1177862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1177865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177884 */     // MIs[0] round
     /* 1177884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177894 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1177897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177919 */     // GIR_Coverage, 16138,
     /* 1177919 */     GIR_EraseRootFromParent_Done,
     /* 1177920 */   // Label 17156: @1177920
     /* 1177920 */   GIM_Try, /*On fail goto*//*Label 17157*/ GIMT_Encode4(1178000), // Rule ID 16139 //
     /* 1177925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1177936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1177939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1177942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1177945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177964 */     // MIs[0] round
     /* 1177964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177974 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1177977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177999 */     // GIR_Coverage, 16139,
     /* 1177999 */     GIR_EraseRootFromParent_Done,
     /* 1178000 */   // Label 17157: @1178000
     /* 1178000 */   GIM_Try, /*On fail goto*//*Label 17158*/ GIMT_Encode4(1178080), // Rule ID 16142 //
     /* 1178005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1178008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1178016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1178019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1178022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1178025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178044 */     // MIs[0] round
     /* 1178044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178054 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1178057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178079 */     // GIR_Coverage, 16142,
     /* 1178079 */     GIR_EraseRootFromParent_Done,
     /* 1178080 */   // Label 17158: @1178080
     /* 1178080 */   GIM_Try, /*On fail goto*//*Label 17159*/ GIMT_Encode4(1178160), // Rule ID 16143 //
     /* 1178085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1178088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1178096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1178099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1178102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1178105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178124 */     // MIs[0] round
     /* 1178124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178134 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1178137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178159 */     // GIR_Coverage, 16143,
     /* 1178159 */     GIR_EraseRootFromParent_Done,
     /* 1178160 */   // Label 17159: @1178160
     /* 1178160 */   GIM_Try, /*On fail goto*//*Label 17160*/ GIMT_Encode4(1178240), // Rule ID 16146 //
     /* 1178165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1178168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1178176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1178179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1178182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1178185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178204 */     // MIs[0] round
     /* 1178204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178214 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1178217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178239 */     // GIR_Coverage, 16146,
     /* 1178239 */     GIR_EraseRootFromParent_Done,
     /* 1178240 */   // Label 17160: @1178240
     /* 1178240 */   GIM_Try, /*On fail goto*//*Label 17161*/ GIMT_Encode4(1178320), // Rule ID 16147 //
     /* 1178245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1178248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1178256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1178259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1178262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1178265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178284 */     // MIs[0] round
     /* 1178284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178294 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1178297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178319 */     // GIR_Coverage, 16147,
     /* 1178319 */     GIR_EraseRootFromParent_Done,
     /* 1178320 */   // Label 17161: @1178320
     /* 1178320 */   GIM_Try, /*On fail goto*//*Label 17162*/ GIMT_Encode4(1178400), // Rule ID 16150 //
     /* 1178325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1178328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1178336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1178339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1178342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1178345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178364 */     // MIs[0] round
     /* 1178364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178374 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1178377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178399 */     // GIR_Coverage, 16150,
     /* 1178399 */     GIR_EraseRootFromParent_Done,
     /* 1178400 */   // Label 17162: @1178400
     /* 1178400 */   GIM_Try, /*On fail goto*//*Label 17163*/ GIMT_Encode4(1178480), // Rule ID 16151 //
     /* 1178405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1178408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1178416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1178419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1178422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1178425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178444 */     // MIs[0] round
     /* 1178444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1178457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178479 */     // GIR_Coverage, 16151,
     /* 1178479 */     GIR_EraseRootFromParent_Done,
     /* 1178480 */   // Label 17163: @1178480
     /* 1178480 */   GIM_Try, /*On fail goto*//*Label 17164*/ GIMT_Encode4(1178560), // Rule ID 16154 //
     /* 1178485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1178496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1178499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1178502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178524 */     // MIs[0] round
     /* 1178524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178534 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1178537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178559 */     // GIR_Coverage, 16154,
     /* 1178559 */     GIR_EraseRootFromParent_Done,
     /* 1178560 */   // Label 17164: @1178560
     /* 1178560 */   GIM_Try, /*On fail goto*//*Label 17165*/ GIMT_Encode4(1178640), // Rule ID 16155 //
     /* 1178565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1178576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1178579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1178582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178604 */     // MIs[0] round
     /* 1178604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178614 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1178617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178639 */     // GIR_Coverage, 16155,
     /* 1178639 */     GIR_EraseRootFromParent_Done,
     /* 1178640 */   // Label 17165: @1178640
     /* 1178640 */   GIM_Try, /*On fail goto*//*Label 17166*/ GIMT_Encode4(1178720), // Rule ID 16158 //
     /* 1178645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1178662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178684 */     // MIs[0] round
     /* 1178684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178694 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1178697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178719 */     // GIR_Coverage, 16158,
     /* 1178719 */     GIR_EraseRootFromParent_Done,
     /* 1178720 */   // Label 17166: @1178720
     /* 1178720 */   GIM_Try, /*On fail goto*//*Label 17167*/ GIMT_Encode4(1178800), // Rule ID 16159 //
     /* 1178725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1178742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178764 */     // MIs[0] round
     /* 1178764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178774 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1178777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178799 */     // GIR_Coverage, 16159,
     /* 1178799 */     GIR_EraseRootFromParent_Done,
     /* 1178800 */   // Label 17167: @1178800
     /* 1178800 */   GIM_Try, /*On fail goto*//*Label 17168*/ GIMT_Encode4(1178880), // Rule ID 16162 //
     /* 1178805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1178816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1178819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1178822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178844 */     // MIs[0] round
     /* 1178844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178854 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1178857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178879 */     // GIR_Coverage, 16162,
     /* 1178879 */     GIR_EraseRootFromParent_Done,
     /* 1178880 */   // Label 17168: @1178880
     /* 1178880 */   GIM_Try, /*On fail goto*//*Label 17169*/ GIMT_Encode4(1178960), // Rule ID 16163 //
     /* 1178885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1178896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1178899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1178902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178924 */     // MIs[0] round
     /* 1178924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178934 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1178937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178959 */     // GIR_Coverage, 16163,
     /* 1178959 */     GIR_EraseRootFromParent_Done,
     /* 1178960 */   // Label 17169: @1178960
     /* 1178960 */   GIM_Try, /*On fail goto*//*Label 17170*/ GIMT_Encode4(1179040), // Rule ID 16166 //
     /* 1178965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1178976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1178979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1178982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179004 */     // MIs[0] round
     /* 1179004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179014 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1179017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179039 */     // GIR_Coverage, 16166,
     /* 1179039 */     GIR_EraseRootFromParent_Done,
     /* 1179040 */   // Label 17170: @1179040
     /* 1179040 */   GIM_Try, /*On fail goto*//*Label 17171*/ GIMT_Encode4(1179120), // Rule ID 16167 //
     /* 1179045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1179053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1179056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1179059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1179062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1179065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179084 */     // MIs[0] round
     /* 1179084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179094 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1179097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179119 */     // GIR_Coverage, 16167,
     /* 1179119 */     GIR_EraseRootFromParent_Done,
     /* 1179120 */   // Label 17171: @1179120
     /* 1179120 */   GIM_Try, /*On fail goto*//*Label 17172*/ GIMT_Encode4(1179200), // Rule ID 16170 //
     /* 1179125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1179133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1179142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1179145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179164 */     // MIs[0] round
     /* 1179164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179174 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1179177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179199 */     // GIR_Coverage, 16170,
     /* 1179199 */     GIR_EraseRootFromParent_Done,
     /* 1179200 */   // Label 17172: @1179200
     /* 1179200 */   GIM_Try, /*On fail goto*//*Label 17173*/ GIMT_Encode4(1179280), // Rule ID 16171 //
     /* 1179205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1179213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1179222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1179225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179244 */     // MIs[0] round
     /* 1179244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179254 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1179257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179279 */     // GIR_Coverage, 16171,
     /* 1179279 */     GIR_EraseRootFromParent_Done,
     /* 1179280 */   // Label 17173: @1179280
     /* 1179280 */   GIM_Try, /*On fail goto*//*Label 17174*/ GIMT_Encode4(1179360), // Rule ID 16174 //
     /* 1179285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1179293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1179296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1179299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1179302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1179305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179324 */     // MIs[0] round
     /* 1179324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179334 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1179337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1179355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179359 */     // GIR_Coverage, 16174,
     /* 1179359 */     GIR_EraseRootFromParent_Done,
     /* 1179360 */   // Label 17174: @1179360
     /* 1179360 */   GIM_Try, /*On fail goto*//*Label 17175*/ GIMT_Encode4(1179440), // Rule ID 16175 //
     /* 1179365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1179373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1179376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1179379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1179382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1179385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179404 */     // MIs[0] round
     /* 1179404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179414 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1179417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1179435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179439 */     // GIR_Coverage, 16175,
     /* 1179439 */     GIR_EraseRootFromParent_Done,
     /* 1179440 */   // Label 17175: @1179440
     /* 1179440 */   GIM_Try, /*On fail goto*//*Label 17176*/ GIMT_Encode4(1179520), // Rule ID 16178 //
     /* 1179445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1179453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1179456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1179459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1179462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1179465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179484 */     // MIs[0] round
     /* 1179484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179494 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1179497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179519 */     // GIR_Coverage, 16178,
     /* 1179519 */     GIR_EraseRootFromParent_Done,
     /* 1179520 */   // Label 17176: @1179520
     /* 1179520 */   GIM_Try, /*On fail goto*//*Label 17177*/ GIMT_Encode4(1179600), // Rule ID 16179 //
     /* 1179525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1179533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1179536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1179539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1179542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1179545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179564 */     // MIs[0] round
     /* 1179564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179574 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1179577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179599 */     // GIR_Coverage, 16179,
     /* 1179599 */     GIR_EraseRootFromParent_Done,
     /* 1179600 */   // Label 17177: @1179600
     /* 1179600 */   GIM_Try, /*On fail goto*//*Label 17178*/ GIMT_Encode4(1179680), // Rule ID 16182 //
     /* 1179605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1179613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1179616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1179619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1179622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1179625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179644 */     // MIs[0] round
     /* 1179644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179654 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1179657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179679 */     // GIR_Coverage, 16182,
     /* 1179679 */     GIR_EraseRootFromParent_Done,
     /* 1179680 */   // Label 17178: @1179680
     /* 1179680 */   GIM_Try, /*On fail goto*//*Label 17179*/ GIMT_Encode4(1179760), // Rule ID 16183 //
     /* 1179685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1179693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1179696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1179699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1179702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1179705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179724 */     // MIs[0] round
     /* 1179724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179734 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1179737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179759 */     // GIR_Coverage, 16183,
     /* 1179759 */     GIR_EraseRootFromParent_Done,
     /* 1179760 */   // Label 17179: @1179760
     /* 1179760 */   GIM_Try, /*On fail goto*//*Label 17180*/ GIMT_Encode4(1179840), // Rule ID 16186 //
     /* 1179765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1179773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1179776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1179779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1179785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179804 */     // MIs[0] round
     /* 1179804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179814 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1179817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1179835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179839 */     // GIR_Coverage, 16186,
     /* 1179839 */     GIR_EraseRootFromParent_Done,
     /* 1179840 */   // Label 17180: @1179840
     /* 1179840 */   GIM_Try, /*On fail goto*//*Label 17181*/ GIMT_Encode4(1179920), // Rule ID 16187 //
     /* 1179845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1179853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1179856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1179859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1179865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179884 */     // MIs[0] round
     /* 1179884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179894 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1179897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1179915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179919 */     // GIR_Coverage, 16187,
     /* 1179919 */     GIR_EraseRootFromParent_Done,
     /* 1179920 */   // Label 17181: @1179920
     /* 1179920 */   GIM_Try, /*On fail goto*//*Label 17182*/ GIMT_Encode4(1180000), // Rule ID 16190 //
     /* 1179925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1179928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1179933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1179936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1179939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1179942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1179945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1179964 */     // MIs[0] round
     /* 1179964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179974 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1179977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1179995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179999 */     // GIR_Coverage, 16190,
     /* 1179999 */     GIR_EraseRootFromParent_Done,
     /* 1180000 */   // Label 17182: @1180000
     /* 1180000 */   GIM_Try, /*On fail goto*//*Label 17183*/ GIMT_Encode4(1180080), // Rule ID 16191 //
     /* 1180005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1180008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1180013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1180016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1180019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1180022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180044 */     // MIs[0] round
     /* 1180044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180054 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1180057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1180075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180079 */     // GIR_Coverage, 16191,
     /* 1180079 */     GIR_EraseRootFromParent_Done,
     /* 1180080 */   // Label 17183: @1180080
     /* 1180080 */   GIM_Try, /*On fail goto*//*Label 17184*/ GIMT_Encode4(1180160), // Rule ID 16194 //
     /* 1180085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1180093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1180096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1180099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1180102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180124 */     // MIs[0] round
     /* 1180124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180134 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1180137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180159 */     // GIR_Coverage, 16194,
     /* 1180159 */     GIR_EraseRootFromParent_Done,
     /* 1180160 */   // Label 17184: @1180160
     /* 1180160 */   GIM_Try, /*On fail goto*//*Label 17185*/ GIMT_Encode4(1180240), // Rule ID 16195 //
     /* 1180165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1180173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1180176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1180179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1180182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180204 */     // MIs[0] round
     /* 1180204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180214 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1180217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180239 */     // GIR_Coverage, 16195,
     /* 1180239 */     GIR_EraseRootFromParent_Done,
     /* 1180240 */   // Label 17185: @1180240
     /* 1180240 */   GIM_Try, /*On fail goto*//*Label 17186*/ GIMT_Encode4(1180320), // Rule ID 16198 //
     /* 1180245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1180253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1180256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1180259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1180262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180284 */     // MIs[0] round
     /* 1180284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180294 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1180297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180319 */     // GIR_Coverage, 16198,
     /* 1180319 */     GIR_EraseRootFromParent_Done,
     /* 1180320 */   // Label 17186: @1180320
     /* 1180320 */   GIM_Try, /*On fail goto*//*Label 17187*/ GIMT_Encode4(1180400), // Rule ID 16199 //
     /* 1180325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1180333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1180336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1180339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1180342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180364 */     // MIs[0] round
     /* 1180364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180374 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1180377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180399 */     // GIR_Coverage, 16199,
     /* 1180399 */     GIR_EraseRootFromParent_Done,
     /* 1180400 */   // Label 17187: @1180400
     /* 1180400 */   GIM_Try, /*On fail goto*//*Label 17188*/ GIMT_Encode4(1180480), // Rule ID 16202 //
     /* 1180405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1180413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1180416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1180419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1180422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180444 */     // MIs[0] round
     /* 1180444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180454 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1180457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180479 */     // GIR_Coverage, 16202,
     /* 1180479 */     GIR_EraseRootFromParent_Done,
     /* 1180480 */   // Label 17188: @1180480
     /* 1180480 */   GIM_Try, /*On fail goto*//*Label 17189*/ GIMT_Encode4(1180560), // Rule ID 16203 //
     /* 1180485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1180493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1180496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1180499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1180502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180524 */     // MIs[0] round
     /* 1180524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180534 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1180537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180559 */     // GIR_Coverage, 16203,
     /* 1180559 */     GIR_EraseRootFromParent_Done,
     /* 1180560 */   // Label 17189: @1180560
     /* 1180560 */   GIM_Try, /*On fail goto*//*Label 17190*/ GIMT_Encode4(1180640), // Rule ID 16206 //
     /* 1180565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1180573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1180576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1180579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1180582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180604 */     // MIs[0] round
     /* 1180604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180614 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1180617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180639 */     // GIR_Coverage, 16206,
     /* 1180639 */     GIR_EraseRootFromParent_Done,
     /* 1180640 */   // Label 17190: @1180640
     /* 1180640 */   GIM_Try, /*On fail goto*//*Label 17191*/ GIMT_Encode4(1180720), // Rule ID 16207 //
     /* 1180645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1180653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1180656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1180659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1180662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180684 */     // MIs[0] round
     /* 1180684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1180697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180719 */     // GIR_Coverage, 16207,
     /* 1180719 */     GIR_EraseRootFromParent_Done,
     /* 1180720 */   // Label 17191: @1180720
     /* 1180720 */   GIM_Try, /*On fail goto*//*Label 17192*/ GIMT_Encode4(1180800), // Rule ID 16210 //
     /* 1180725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1180733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1180736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1180739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1180742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180764 */     // MIs[0] round
     /* 1180764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180774 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1180777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180799 */     // GIR_Coverage, 16210,
     /* 1180799 */     GIR_EraseRootFromParent_Done,
     /* 1180800 */   // Label 17192: @1180800
     /* 1180800 */   GIM_Try, /*On fail goto*//*Label 17193*/ GIMT_Encode4(1180880), // Rule ID 16211 //
     /* 1180805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1180813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1180816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1180819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1180822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180844 */     // MIs[0] round
     /* 1180844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180854 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1180857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180879 */     // GIR_Coverage, 16211,
     /* 1180879 */     GIR_EraseRootFromParent_Done,
     /* 1180880 */   // Label 17193: @1180880
     /* 1180880 */   GIM_Try, /*On fail goto*//*Label 17194*/ GIMT_Encode4(1180960), // Rule ID 16214 //
     /* 1180885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1180893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1180896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1180899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1180902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180924 */     // MIs[0] round
     /* 1180924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180934 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1180937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180959 */     // GIR_Coverage, 16214,
     /* 1180959 */     GIR_EraseRootFromParent_Done,
     /* 1180960 */   // Label 17194: @1180960
     /* 1180960 */   GIM_Try, /*On fail goto*//*Label 17195*/ GIMT_Encode4(1181040), // Rule ID 16215 //
     /* 1180965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1180973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1180976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1180979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1180982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181004 */     // MIs[0] round
     /* 1181004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181014 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1181017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181039 */     // GIR_Coverage, 16215,
     /* 1181039 */     GIR_EraseRootFromParent_Done,
     /* 1181040 */   // Label 17195: @1181040
     /* 1181040 */   GIM_Try, /*On fail goto*//*Label 17196*/ GIMT_Encode4(1181120), // Rule ID 16218 //
     /* 1181045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1181053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1181056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1181059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1181062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181084 */     // MIs[0] round
     /* 1181084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1181097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1181115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181119 */     // GIR_Coverage, 16218,
     /* 1181119 */     GIR_EraseRootFromParent_Done,
     /* 1181120 */   // Label 17196: @1181120
     /* 1181120 */   GIM_Try, /*On fail goto*//*Label 17197*/ GIMT_Encode4(1181200), // Rule ID 16219 //
     /* 1181125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1181133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1181136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1181139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1181142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181164 */     // MIs[0] round
     /* 1181164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1181177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1181195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181199 */     // GIR_Coverage, 16219,
     /* 1181199 */     GIR_EraseRootFromParent_Done,
     /* 1181200 */   // Label 17197: @1181200
     /* 1181200 */   GIM_Try, /*On fail goto*//*Label 17198*/ GIMT_Encode4(1181280), // Rule ID 16222 //
     /* 1181205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1181213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1181216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1181219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1181222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181244 */     // MIs[0] round
     /* 1181244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1181257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1181275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181279 */     // GIR_Coverage, 16222,
     /* 1181279 */     GIR_EraseRootFromParent_Done,
     /* 1181280 */   // Label 17198: @1181280
     /* 1181280 */   GIM_Try, /*On fail goto*//*Label 17199*/ GIMT_Encode4(1181360), // Rule ID 16223 //
     /* 1181285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1181293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1181296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1181299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1181302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181324 */     // MIs[0] round
     /* 1181324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1181337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1181355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181359 */     // GIR_Coverage, 16223,
     /* 1181359 */     GIR_EraseRootFromParent_Done,
     /* 1181360 */   // Label 17199: @1181360
     /* 1181360 */   GIM_Try, /*On fail goto*//*Label 17200*/ GIMT_Encode4(1181440), // Rule ID 16226 //
     /* 1181365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1181373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1181376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1181379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1181382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181404 */     // MIs[0] round
     /* 1181404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181414 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1181417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1181435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181439 */     // GIR_Coverage, 16226,
     /* 1181439 */     GIR_EraseRootFromParent_Done,
     /* 1181440 */   // Label 17200: @1181440
     /* 1181440 */   GIM_Try, /*On fail goto*//*Label 17201*/ GIMT_Encode4(1181520), // Rule ID 16227 //
     /* 1181445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1181453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1181456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1181459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1181462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181484 */     // MIs[0] round
     /* 1181484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181494 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1181497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1181515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181519 */     // GIR_Coverage, 16227,
     /* 1181519 */     GIR_EraseRootFromParent_Done,
     /* 1181520 */   // Label 17201: @1181520
     /* 1181520 */   GIM_Try, /*On fail goto*//*Label 17202*/ GIMT_Encode4(1181600), // Rule ID 16230 //
     /* 1181525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1181528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1181533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1181536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1181539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1181542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181564 */     // MIs[0] round
     /* 1181564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181574 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1181577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1181595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181599 */     // GIR_Coverage, 16230,
     /* 1181599 */     GIR_EraseRootFromParent_Done,
     /* 1181600 */   // Label 17202: @1181600
     /* 1181600 */   GIM_Try, /*On fail goto*//*Label 17203*/ GIMT_Encode4(1181680), // Rule ID 16231 //
     /* 1181605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1181608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1181613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1181616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1181619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1181622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181644 */     // MIs[0] round
     /* 1181644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1181657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1181675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181679 */     // GIR_Coverage, 16231,
     /* 1181679 */     GIR_EraseRootFromParent_Done,
     /* 1181680 */   // Label 17203: @1181680
     /* 1181680 */   GIM_Try, /*On fail goto*//*Label 17204*/ GIMT_Encode4(1181760), // Rule ID 16234 //
     /* 1181685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1181688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1181693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1181696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1181699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1181702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181724 */     // MIs[0] round
     /* 1181724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1181737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1181755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181759 */     // GIR_Coverage, 16234,
     /* 1181759 */     GIR_EraseRootFromParent_Done,
     /* 1181760 */   // Label 17204: @1181760
     /* 1181760 */   GIM_Try, /*On fail goto*//*Label 17205*/ GIMT_Encode4(1181840), // Rule ID 16235 //
     /* 1181765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1181768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1181773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1181776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1181779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1181782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181804 */     // MIs[0] round
     /* 1181804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181814 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1181817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1181835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181839 */     // GIR_Coverage, 16235,
     /* 1181839 */     GIR_EraseRootFromParent_Done,
     /* 1181840 */   // Label 17205: @1181840
     /* 1181840 */   GIM_Try, /*On fail goto*//*Label 17206*/ GIMT_Encode4(1181920), // Rule ID 16238 //
     /* 1181845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1181848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1181853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1181856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1181859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1181862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181884 */     // MIs[0] round
     /* 1181884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181894 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1181897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1181915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181919 */     // GIR_Coverage, 16238,
     /* 1181919 */     GIR_EraseRootFromParent_Done,
     /* 1181920 */   // Label 17206: @1181920
     /* 1181920 */   GIM_Try, /*On fail goto*//*Label 17207*/ GIMT_Encode4(1182000), // Rule ID 16239 //
     /* 1181925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1181928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1181933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1181936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1181939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1181942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181964 */     // MIs[0] round
     /* 1181964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181974 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1181977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1181995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181999 */     // GIR_Coverage, 16239,
     /* 1181999 */     GIR_EraseRootFromParent_Done,
     /* 1182000 */   // Label 17207: @1182000
     /* 1182000 */   GIM_Try, /*On fail goto*//*Label 17208*/ GIMT_Encode4(1182083), // Rule ID 16330 //
     /* 1182005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1182016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1182019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1182022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1182025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182044 */     // MIs[0] round
     /* 1182044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182054 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1182057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182082 */     // GIR_Coverage, 16330,
     /* 1182082 */     GIR_EraseRootFromParent_Done,
     /* 1182083 */   // Label 17208: @1182083
     /* 1182083 */   GIM_Try, /*On fail goto*//*Label 17209*/ GIMT_Encode4(1182166), // Rule ID 16331 //
     /* 1182088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1182099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1182102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1182105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1182108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182127 */     // MIs[0] round
     /* 1182127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182137 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1182140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182148 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182165 */     // GIR_Coverage, 16331,
     /* 1182165 */     GIR_EraseRootFromParent_Done,
     /* 1182166 */   // Label 17209: @1182166
     /* 1182166 */   GIM_Try, /*On fail goto*//*Label 17210*/ GIMT_Encode4(1182249), // Rule ID 16334 //
     /* 1182171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1182182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1182185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1182188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1182191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182210 */     // MIs[0] round
     /* 1182210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182220 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1182223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182248 */     // GIR_Coverage, 16334,
     /* 1182248 */     GIR_EraseRootFromParent_Done,
     /* 1182249 */   // Label 17210: @1182249
     /* 1182249 */   GIM_Try, /*On fail goto*//*Label 17211*/ GIMT_Encode4(1182332), // Rule ID 16335 //
     /* 1182254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1182265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1182268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1182271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1182274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182293 */     // MIs[0] round
     /* 1182293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182303 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1182306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182314 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182331 */     // GIR_Coverage, 16335,
     /* 1182331 */     GIR_EraseRootFromParent_Done,
     /* 1182332 */   // Label 17211: @1182332
     /* 1182332 */   GIM_Try, /*On fail goto*//*Label 17212*/ GIMT_Encode4(1182415), // Rule ID 16338 //
     /* 1182337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1182348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1182351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1182354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1182357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182376 */     // MIs[0] round
     /* 1182376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182386 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1182389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182414 */     // GIR_Coverage, 16338,
     /* 1182414 */     GIR_EraseRootFromParent_Done,
     /* 1182415 */   // Label 17212: @1182415
     /* 1182415 */   GIM_Try, /*On fail goto*//*Label 17213*/ GIMT_Encode4(1182498), // Rule ID 16339 //
     /* 1182420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1182431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1182434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1182437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1182440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182459 */     // MIs[0] round
     /* 1182459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182469 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1182472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182480 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182497 */     // GIR_Coverage, 16339,
     /* 1182497 */     GIR_EraseRootFromParent_Done,
     /* 1182498 */   // Label 17213: @1182498
     /* 1182498 */   GIM_Try, /*On fail goto*//*Label 17214*/ GIMT_Encode4(1182581), // Rule ID 16342 //
     /* 1182503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1182514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1182517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1182520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1182523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182542 */     // MIs[0] round
     /* 1182542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182552 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1182555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182580 */     // GIR_Coverage, 16342,
     /* 1182580 */     GIR_EraseRootFromParent_Done,
     /* 1182581 */   // Label 17214: @1182581
     /* 1182581 */   GIM_Try, /*On fail goto*//*Label 17215*/ GIMT_Encode4(1182664), // Rule ID 16343 //
     /* 1182586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1182597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1182600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1182603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1182606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182625 */     // MIs[0] round
     /* 1182625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182635 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1182638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182663 */     // GIR_Coverage, 16343,
     /* 1182663 */     GIR_EraseRootFromParent_Done,
     /* 1182664 */   // Label 17215: @1182664
     /* 1182664 */   GIM_Try, /*On fail goto*//*Label 17216*/ GIMT_Encode4(1182747), // Rule ID 16346 //
     /* 1182669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1182680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1182683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1182686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1182689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182708 */     // MIs[0] round
     /* 1182708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182718 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1182721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182746 */     // GIR_Coverage, 16346,
     /* 1182746 */     GIR_EraseRootFromParent_Done,
     /* 1182747 */   // Label 17216: @1182747
     /* 1182747 */   GIM_Try, /*On fail goto*//*Label 17217*/ GIMT_Encode4(1182830), // Rule ID 16347 //
     /* 1182752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1182763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1182766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1182769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1182772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182791 */     // MIs[0] round
     /* 1182791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182801 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1182804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182812 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182829 */     // GIR_Coverage, 16347,
     /* 1182829 */     GIR_EraseRootFromParent_Done,
     /* 1182830 */   // Label 17217: @1182830
     /* 1182830 */   GIM_Try, /*On fail goto*//*Label 17218*/ GIMT_Encode4(1182913), // Rule ID 16350 //
     /* 1182835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1182846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1182849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1182852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1182855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182874 */     // MIs[0] round
     /* 1182874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182884 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1182887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182912 */     // GIR_Coverage, 16350,
     /* 1182912 */     GIR_EraseRootFromParent_Done,
     /* 1182913 */   // Label 17218: @1182913
     /* 1182913 */   GIM_Try, /*On fail goto*//*Label 17219*/ GIMT_Encode4(1182996), // Rule ID 16351 //
     /* 1182918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1182929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1182932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1182935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1182938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182957 */     // MIs[0] round
     /* 1182957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182967 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1182970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182978 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182995 */     // GIR_Coverage, 16351,
     /* 1182995 */     GIR_EraseRootFromParent_Done,
     /* 1182996 */   // Label 17219: @1182996
     /* 1182996 */   GIM_Try, /*On fail goto*//*Label 17220*/ GIMT_Encode4(1183079), // Rule ID 16354 //
     /* 1183001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1183012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1183015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1183018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1183021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183040 */     // MIs[0] round
     /* 1183040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183050 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1183053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183078 */     // GIR_Coverage, 16354,
     /* 1183078 */     GIR_EraseRootFromParent_Done,
     /* 1183079 */   // Label 17220: @1183079
     /* 1183079 */   GIM_Try, /*On fail goto*//*Label 17221*/ GIMT_Encode4(1183162), // Rule ID 16355 //
     /* 1183084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1183095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1183098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1183101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1183104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183123 */     // MIs[0] round
     /* 1183123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183133 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1183136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183144 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183161 */     // GIR_Coverage, 16355,
     /* 1183161 */     GIR_EraseRootFromParent_Done,
     /* 1183162 */   // Label 17221: @1183162
     /* 1183162 */   GIM_Try, /*On fail goto*//*Label 17222*/ GIMT_Encode4(1183245), // Rule ID 16358 //
     /* 1183167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1183178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1183181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1183184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1183187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183206 */     // MIs[0] round
     /* 1183206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183216 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1183219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183244 */     // GIR_Coverage, 16358,
     /* 1183244 */     GIR_EraseRootFromParent_Done,
     /* 1183245 */   // Label 17222: @1183245
     /* 1183245 */   GIM_Try, /*On fail goto*//*Label 17223*/ GIMT_Encode4(1183328), // Rule ID 16359 //
     /* 1183250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1183261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1183264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1183267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1183270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183289 */     // MIs[0] round
     /* 1183289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183299 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1183302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183327 */     // GIR_Coverage, 16359,
     /* 1183327 */     GIR_EraseRootFromParent_Done,
     /* 1183328 */   // Label 17223: @1183328
     /* 1183328 */   GIM_Try, /*On fail goto*//*Label 17224*/ GIMT_Encode4(1183411), // Rule ID 16362 //
     /* 1183333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1183344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1183347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1183350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1183353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183372 */     // MIs[0] round
     /* 1183372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183382 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1183385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183410 */     // GIR_Coverage, 16362,
     /* 1183410 */     GIR_EraseRootFromParent_Done,
     /* 1183411 */   // Label 17224: @1183411
     /* 1183411 */   GIM_Try, /*On fail goto*//*Label 17225*/ GIMT_Encode4(1183494), // Rule ID 16363 //
     /* 1183416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1183427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1183430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1183433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1183436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183455 */     // MIs[0] round
     /* 1183455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183465 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1183468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183476 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183493 */     // GIR_Coverage, 16363,
     /* 1183493 */     GIR_EraseRootFromParent_Done,
     /* 1183494 */   // Label 17225: @1183494
     /* 1183494 */   GIM_Try, /*On fail goto*//*Label 17226*/ GIMT_Encode4(1183577), // Rule ID 16366 //
     /* 1183499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1183510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1183513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1183516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1183519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183538 */     // MIs[0] round
     /* 1183538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183548 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1183551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183576 */     // GIR_Coverage, 16366,
     /* 1183576 */     GIR_EraseRootFromParent_Done,
     /* 1183577 */   // Label 17226: @1183577
     /* 1183577 */   GIM_Try, /*On fail goto*//*Label 17227*/ GIMT_Encode4(1183660), // Rule ID 16367 //
     /* 1183582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1183593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1183596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1183599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1183602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183621 */     // MIs[0] round
     /* 1183621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183631 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1183634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183642 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183659 */     // GIR_Coverage, 16367,
     /* 1183659 */     GIR_EraseRootFromParent_Done,
     /* 1183660 */   // Label 17227: @1183660
     /* 1183660 */   GIM_Try, /*On fail goto*//*Label 17228*/ GIMT_Encode4(1183743), // Rule ID 16370 //
     /* 1183665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1183676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1183679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1183682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1183685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183704 */     // MIs[0] round
     /* 1183704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183714 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1183717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183742 */     // GIR_Coverage, 16370,
     /* 1183742 */     GIR_EraseRootFromParent_Done,
     /* 1183743 */   // Label 17228: @1183743
     /* 1183743 */   GIM_Try, /*On fail goto*//*Label 17229*/ GIMT_Encode4(1183826), // Rule ID 16371 //
     /* 1183748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1183759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1183762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1183765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1183768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183787 */     // MIs[0] round
     /* 1183787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183797 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1183800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183808 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183825 */     // GIR_Coverage, 16371,
     /* 1183825 */     GIR_EraseRootFromParent_Done,
     /* 1183826 */   // Label 17229: @1183826
     /* 1183826 */   GIM_Try, /*On fail goto*//*Label 17230*/ GIMT_Encode4(1183909), // Rule ID 16374 //
     /* 1183831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1183834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1183842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1183845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1183848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1183851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183870 */     // MIs[0] round
     /* 1183870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183880 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1183883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183908 */     // GIR_Coverage, 16374,
     /* 1183908 */     GIR_EraseRootFromParent_Done,
     /* 1183909 */   // Label 17230: @1183909
     /* 1183909 */   GIM_Try, /*On fail goto*//*Label 17231*/ GIMT_Encode4(1183992), // Rule ID 16375 //
     /* 1183914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1183925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1183928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1183931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1183934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183953 */     // MIs[0] round
     /* 1183953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183963 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1183966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183974 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183991 */     // GIR_Coverage, 16375,
     /* 1183991 */     GIR_EraseRootFromParent_Done,
     /* 1183992 */   // Label 17231: @1183992
     /* 1183992 */   GIM_Try, /*On fail goto*//*Label 17232*/ GIMT_Encode4(1184075), // Rule ID 16378 //
     /* 1183997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1184000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1184005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1184008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1184011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1184014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1184017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184036 */     // MIs[0] round
     /* 1184036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184046 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1184049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184074 */     // GIR_Coverage, 16378,
     /* 1184074 */     GIR_EraseRootFromParent_Done,
     /* 1184075 */   // Label 17232: @1184075
     /* 1184075 */   GIM_Try, /*On fail goto*//*Label 17233*/ GIMT_Encode4(1184158), // Rule ID 16379 //
     /* 1184080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1184083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1184088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1184091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1184094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1184097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1184100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184119 */     // MIs[0] round
     /* 1184119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184129 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1184132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184140 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184157 */     // GIR_Coverage, 16379,
     /* 1184157 */     GIR_EraseRootFromParent_Done,
     /* 1184158 */   // Label 17233: @1184158
     /* 1184158 */   GIM_Try, /*On fail goto*//*Label 17234*/ GIMT_Encode4(1184241), // Rule ID 16382 //
     /* 1184163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1184166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1184171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1184174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1184177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1184180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1184183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184202 */     // MIs[0] round
     /* 1184202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184212 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1184215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184240 */     // GIR_Coverage, 16382,
     /* 1184240 */     GIR_EraseRootFromParent_Done,
     /* 1184241 */   // Label 17234: @1184241
     /* 1184241 */   GIM_Try, /*On fail goto*//*Label 17235*/ GIMT_Encode4(1184324), // Rule ID 16383 //
     /* 1184246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1184249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1184254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1184257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1184260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1184263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1184266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184285 */     // MIs[0] round
     /* 1184285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184295 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1184298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184306 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184323 */     // GIR_Coverage, 16383,
     /* 1184323 */     GIR_EraseRootFromParent_Done,
     /* 1184324 */   // Label 17235: @1184324
     /* 1184324 */   GIM_Try, /*On fail goto*//*Label 17236*/ GIMT_Encode4(1184407), // Rule ID 16386 //
     /* 1184329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1184332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1184337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1184340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1184343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1184346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1184349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184368 */     // MIs[0] round
     /* 1184368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184378 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1184381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184406 */     // GIR_Coverage, 16386,
     /* 1184406 */     GIR_EraseRootFromParent_Done,
     /* 1184407 */   // Label 17236: @1184407
     /* 1184407 */   GIM_Try, /*On fail goto*//*Label 17237*/ GIMT_Encode4(1184490), // Rule ID 16387 //
     /* 1184412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1184415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1184420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1184423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1184426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1184429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1184432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184451 */     // MIs[0] round
     /* 1184451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184461 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1184464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184472 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184489 */     // GIR_Coverage, 16387,
     /* 1184489 */     GIR_EraseRootFromParent_Done,
     /* 1184490 */   // Label 17237: @1184490
     /* 1184490 */   GIM_Try, /*On fail goto*//*Label 17238*/ GIMT_Encode4(1184573), // Rule ID 16390 //
     /* 1184495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1184503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1184506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1184509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1184512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1184515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1184534 */     // MIs[0] round
     /* 1184534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1184547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184572 */     // GIR_Coverage, 16390,
     /* 1184572 */     GIR_EraseRootFromParent_Done,
     /* 1184573 */   // Label 17238: @1184573
     /* 1184573 */   GIM_Try, /*On fail goto*//*Label 17239*/ GIMT_Encode4(1184656), // Rule ID 16391 //
     /* 1184578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1184586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1184589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1184592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1184595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1184598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1184617 */     // MIs[0] round
     /* 1184617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184627 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1184630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184638 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184655 */     // GIR_Coverage, 16391,
     /* 1184655 */     GIR_EraseRootFromParent_Done,
     /* 1184656 */   // Label 17239: @1184656
     /* 1184656 */   GIM_Try, /*On fail goto*//*Label 17240*/ GIMT_Encode4(1184739), // Rule ID 16394 //
     /* 1184661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1184669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1184672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1184675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1184678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1184681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1184700 */     // MIs[0] round
     /* 1184700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184710 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1184713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184738 */     // GIR_Coverage, 16394,
     /* 1184738 */     GIR_EraseRootFromParent_Done,
     /* 1184739 */   // Label 17240: @1184739
     /* 1184739 */   GIM_Try, /*On fail goto*//*Label 17241*/ GIMT_Encode4(1184822), // Rule ID 16395 //
     /* 1184744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1184752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1184755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1184758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1184761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1184764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1184783 */     // MIs[0] round
     /* 1184783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184793 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1184796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184804 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184821 */     // GIR_Coverage, 16395,
     /* 1184821 */     GIR_EraseRootFromParent_Done,
     /* 1184822 */   // Label 17241: @1184822
     /* 1184822 */   GIM_Try, /*On fail goto*//*Label 17242*/ GIMT_Encode4(1184905), // Rule ID 16398 //
     /* 1184827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1184835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1184838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1184841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1184844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1184847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1184866 */     // MIs[0] round
     /* 1184866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184876 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1184879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184904 */     // GIR_Coverage, 16398,
     /* 1184904 */     GIR_EraseRootFromParent_Done,
     /* 1184905 */   // Label 17242: @1184905
     /* 1184905 */   GIM_Try, /*On fail goto*//*Label 17243*/ GIMT_Encode4(1184988), // Rule ID 16399 //
     /* 1184910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1184918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1184921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1184924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1184927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1184930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1184949 */     // MIs[0] round
     /* 1184949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184959 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1184962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184970 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184987 */     // GIR_Coverage, 16399,
     /* 1184987 */     GIR_EraseRootFromParent_Done,
     /* 1184988 */   // Label 17243: @1184988
     /* 1184988 */   GIM_Try, /*On fail goto*//*Label 17244*/ GIMT_Encode4(1185071), // Rule ID 16402 //
     /* 1184993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1185001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1185004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1185007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1185010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185032 */     // MIs[0] round
     /* 1185032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185042 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1185045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185070 */     // GIR_Coverage, 16402,
     /* 1185070 */     GIR_EraseRootFromParent_Done,
     /* 1185071 */   // Label 17244: @1185071
     /* 1185071 */   GIM_Try, /*On fail goto*//*Label 17245*/ GIMT_Encode4(1185154), // Rule ID 16403 //
     /* 1185076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1185084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1185087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1185090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1185093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185115 */     // MIs[0] round
     /* 1185115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185125 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1185128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185136 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185153 */     // GIR_Coverage, 16403,
     /* 1185153 */     GIR_EraseRootFromParent_Done,
     /* 1185154 */   // Label 17245: @1185154
     /* 1185154 */   GIM_Try, /*On fail goto*//*Label 17246*/ GIMT_Encode4(1185237), // Rule ID 16406 //
     /* 1185159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1185167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1185170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1185173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1185176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185198 */     // MIs[0] round
     /* 1185198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185208 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1185211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185236 */     // GIR_Coverage, 16406,
     /* 1185236 */     GIR_EraseRootFromParent_Done,
     /* 1185237 */   // Label 17246: @1185237
     /* 1185237 */   GIM_Try, /*On fail goto*//*Label 17247*/ GIMT_Encode4(1185320), // Rule ID 16407 //
     /* 1185242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1185250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1185253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1185256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1185259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185281 */     // MIs[0] round
     /* 1185281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185291 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1185294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185302 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185319 */     // GIR_Coverage, 16407,
     /* 1185319 */     GIR_EraseRootFromParent_Done,
     /* 1185320 */   // Label 17247: @1185320
     /* 1185320 */   GIM_Try, /*On fail goto*//*Label 17248*/ GIMT_Encode4(1185403), // Rule ID 16410 //
     /* 1185325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1185333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1185336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1185339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1185342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185364 */     // MIs[0] round
     /* 1185364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185374 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1185377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185402 */     // GIR_Coverage, 16410,
     /* 1185402 */     GIR_EraseRootFromParent_Done,
     /* 1185403 */   // Label 17248: @1185403
     /* 1185403 */   GIM_Try, /*On fail goto*//*Label 17249*/ GIMT_Encode4(1185486), // Rule ID 16411 //
     /* 1185408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1185416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1185419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1185422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1185425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185447 */     // MIs[0] round
     /* 1185447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185457 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1185460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185468 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185485 */     // GIR_Coverage, 16411,
     /* 1185485 */     GIR_EraseRootFromParent_Done,
     /* 1185486 */   // Label 17249: @1185486
     /* 1185486 */   GIM_Try, /*On fail goto*//*Label 17250*/ GIMT_Encode4(1185569), // Rule ID 16414 //
     /* 1185491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1185499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1185502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1185505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1185508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185530 */     // MIs[0] round
     /* 1185530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185540 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1185543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185568 */     // GIR_Coverage, 16414,
     /* 1185568 */     GIR_EraseRootFromParent_Done,
     /* 1185569 */   // Label 17250: @1185569
     /* 1185569 */   GIM_Try, /*On fail goto*//*Label 17251*/ GIMT_Encode4(1185652), // Rule ID 16415 //
     /* 1185574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1185582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1185585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1185588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1185591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185613 */     // MIs[0] round
     /* 1185613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185623 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1185626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185634 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185651 */     // GIR_Coverage, 16415,
     /* 1185651 */     GIR_EraseRootFromParent_Done,
     /* 1185652 */   // Label 17251: @1185652
     /* 1185652 */   GIM_Try, /*On fail goto*//*Label 17252*/ GIMT_Encode4(1185735), // Rule ID 16418 //
     /* 1185657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1185665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1185668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1185671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1185674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185696 */     // MIs[0] round
     /* 1185696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1185709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185734 */     // GIR_Coverage, 16418,
     /* 1185734 */     GIR_EraseRootFromParent_Done,
     /* 1185735 */   // Label 17252: @1185735
     /* 1185735 */   GIM_Try, /*On fail goto*//*Label 17253*/ GIMT_Encode4(1185818), // Rule ID 16419 //
     /* 1185740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1185748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1185751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1185754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1185757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185779 */     // MIs[0] round
     /* 1185779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185789 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1185792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185800 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185817 */     // GIR_Coverage, 16419,
     /* 1185817 */     GIR_EraseRootFromParent_Done,
     /* 1185818 */   // Label 17253: @1185818
     /* 1185818 */   GIM_Try, /*On fail goto*//*Label 17254*/ GIMT_Encode4(1185901), // Rule ID 16422 //
     /* 1185823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1185831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1185834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1185837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1185840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185862 */     // MIs[0] round
     /* 1185862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185872 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1185875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185900 */     // GIR_Coverage, 16422,
     /* 1185900 */     GIR_EraseRootFromParent_Done,
     /* 1185901 */   // Label 17254: @1185901
     /* 1185901 */   GIM_Try, /*On fail goto*//*Label 17255*/ GIMT_Encode4(1185984), // Rule ID 16423 //
     /* 1185906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1185914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1185917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1185920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1185923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185945 */     // MIs[0] round
     /* 1185945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185955 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1185958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185983 */     // GIR_Coverage, 16423,
     /* 1185983 */     GIR_EraseRootFromParent_Done,
     /* 1185984 */   // Label 17255: @1185984
     /* 1185984 */   GIM_Try, /*On fail goto*//*Label 17256*/ GIMT_Encode4(1186067), // Rule ID 16426 //
     /* 1185989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1185997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1186000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1186003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1186006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186028 */     // MIs[0] round
     /* 1186028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186038 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1186041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186066 */     // GIR_Coverage, 16426,
     /* 1186066 */     GIR_EraseRootFromParent_Done,
     /* 1186067 */   // Label 17256: @1186067
     /* 1186067 */   GIM_Try, /*On fail goto*//*Label 17257*/ GIMT_Encode4(1186150), // Rule ID 16427 //
     /* 1186072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1186080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1186083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1186086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1186089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186111 */     // MIs[0] round
     /* 1186111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186121 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1186124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186132 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186149 */     // GIR_Coverage, 16427,
     /* 1186149 */     GIR_EraseRootFromParent_Done,
     /* 1186150 */   // Label 17257: @1186150
     /* 1186150 */   GIM_Try, /*On fail goto*//*Label 17258*/ GIMT_Encode4(1186233), // Rule ID 16430 //
     /* 1186155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1186163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1186166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1186169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1186172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186194 */     // MIs[0] round
     /* 1186194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186204 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1186207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186232 */     // GIR_Coverage, 16430,
     /* 1186232 */     GIR_EraseRootFromParent_Done,
     /* 1186233 */   // Label 17258: @1186233
     /* 1186233 */   GIM_Try, /*On fail goto*//*Label 17259*/ GIMT_Encode4(1186316), // Rule ID 16431 //
     /* 1186238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1186246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1186249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1186252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1186255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186277 */     // MIs[0] round
     /* 1186277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186287 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1186290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186298 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186315 */     // GIR_Coverage, 16431,
     /* 1186315 */     GIR_EraseRootFromParent_Done,
     /* 1186316 */   // Label 17259: @1186316
     /* 1186316 */   GIM_Try, /*On fail goto*//*Label 17260*/ GIMT_Encode4(1186399), // Rule ID 16434 //
     /* 1186321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1186324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1186329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1186332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1186335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1186338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186360 */     // MIs[0] round
     /* 1186360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1186373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186398 */     // GIR_Coverage, 16434,
     /* 1186398 */     GIR_EraseRootFromParent_Done,
     /* 1186399 */   // Label 17260: @1186399
     /* 1186399 */   GIM_Try, /*On fail goto*//*Label 17261*/ GIMT_Encode4(1186482), // Rule ID 16435 //
     /* 1186404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1186407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1186412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1186415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1186418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1186421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186443 */     // MIs[0] round
     /* 1186443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186453 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1186456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186464 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186481 */     // GIR_Coverage, 16435,
     /* 1186481 */     GIR_EraseRootFromParent_Done,
     /* 1186482 */   // Label 17261: @1186482
     /* 1186482 */   GIM_Try, /*On fail goto*//*Label 17262*/ GIMT_Encode4(1186565), // Rule ID 16438 //
     /* 1186487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1186490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1186495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1186498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1186501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1186504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186526 */     // MIs[0] round
     /* 1186526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1186539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186564 */     // GIR_Coverage, 16438,
     /* 1186564 */     GIR_EraseRootFromParent_Done,
     /* 1186565 */   // Label 17262: @1186565
     /* 1186565 */   GIM_Try, /*On fail goto*//*Label 17263*/ GIMT_Encode4(1186648), // Rule ID 16439 //
     /* 1186570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1186573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1186578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1186581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1186584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1186587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186609 */     // MIs[0] round
     /* 1186609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186619 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1186622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186647 */     // GIR_Coverage, 16439,
     /* 1186647 */     GIR_EraseRootFromParent_Done,
     /* 1186648 */   // Label 17263: @1186648
     /* 1186648 */   GIM_Try, /*On fail goto*//*Label 17264*/ GIMT_Encode4(1186731), // Rule ID 16442 //
     /* 1186653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1186656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1186661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1186664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1186667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1186670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186692 */     // MIs[0] round
     /* 1186692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1186705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186730 */     // GIR_Coverage, 16442,
     /* 1186730 */     GIR_EraseRootFromParent_Done,
     /* 1186731 */   // Label 17264: @1186731
     /* 1186731 */   GIM_Try, /*On fail goto*//*Label 17265*/ GIMT_Encode4(1186814), // Rule ID 16443 //
     /* 1186736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1186739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1186744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1186747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1186750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1186753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186775 */     // MIs[0] round
     /* 1186775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186785 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1186788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186796 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186813 */     // GIR_Coverage, 16443,
     /* 1186813 */     GIR_EraseRootFromParent_Done,
     /* 1186814 */   // Label 17265: @1186814
     /* 1186814 */   GIM_Try, /*On fail goto*//*Label 17266*/ GIMT_Encode4(1186897), // Rule ID 16446 //
     /* 1186819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1186822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1186827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1186830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1186833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1186836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186858 */     // MIs[0] round
     /* 1186858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1186871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186896 */     // GIR_Coverage, 16446,
     /* 1186896 */     GIR_EraseRootFromParent_Done,
     /* 1186897 */   // Label 17266: @1186897
     /* 1186897 */   GIM_Try, /*On fail goto*//*Label 17267*/ GIMT_Encode4(1186980), // Rule ID 16447 //
     /* 1186902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1186905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1186910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1186913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1186916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1186919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186941 */     // MIs[0] round
     /* 1186941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186951 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1186954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186962 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186979 */     // GIR_Coverage, 16447,
     /* 1186979 */     GIR_EraseRootFromParent_Done,
     /* 1186980 */   // Label 17267: @1186980
     /* 1186980 */   GIM_Try, /*On fail goto*//*Label 17268*/ GIMT_Encode4(1187063), // Rule ID 16510 //
     /* 1186985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1186996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1186999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1187002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1187005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187024 */     // MIs[0] round
     /* 1187024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187034 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1187037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187062 */     // GIR_Coverage, 16510,
     /* 1187062 */     GIR_EraseRootFromParent_Done,
     /* 1187063 */   // Label 17268: @1187063
     /* 1187063 */   GIM_Try, /*On fail goto*//*Label 17269*/ GIMT_Encode4(1187146), // Rule ID 16511 //
     /* 1187068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1187079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1187082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1187085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1187088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187107 */     // MIs[0] round
     /* 1187107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187117 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1187120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187128 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187145 */     // GIR_Coverage, 16511,
     /* 1187145 */     GIR_EraseRootFromParent_Done,
     /* 1187146 */   // Label 17269: @1187146
     /* 1187146 */   GIM_Try, /*On fail goto*//*Label 17270*/ GIMT_Encode4(1187229), // Rule ID 16514 //
     /* 1187151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1187162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1187165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1187168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1187171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187190 */     // MIs[0] round
     /* 1187190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187200 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1187203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187228 */     // GIR_Coverage, 16514,
     /* 1187228 */     GIR_EraseRootFromParent_Done,
     /* 1187229 */   // Label 17270: @1187229
     /* 1187229 */   GIM_Try, /*On fail goto*//*Label 17271*/ GIMT_Encode4(1187312), // Rule ID 16515 //
     /* 1187234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1187245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1187248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1187251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1187254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187273 */     // MIs[0] round
     /* 1187273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187283 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1187286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187294 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187311 */     // GIR_Coverage, 16515,
     /* 1187311 */     GIR_EraseRootFromParent_Done,
     /* 1187312 */   // Label 17271: @1187312
     /* 1187312 */   GIM_Try, /*On fail goto*//*Label 17272*/ GIMT_Encode4(1187395), // Rule ID 16518 //
     /* 1187317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1187328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1187331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1187334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1187337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187356 */     // MIs[0] round
     /* 1187356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187366 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1187369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187394 */     // GIR_Coverage, 16518,
     /* 1187394 */     GIR_EraseRootFromParent_Done,
     /* 1187395 */   // Label 17272: @1187395
     /* 1187395 */   GIM_Try, /*On fail goto*//*Label 17273*/ GIMT_Encode4(1187478), // Rule ID 16519 //
     /* 1187400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1187411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1187414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1187417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1187420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187439 */     // MIs[0] round
     /* 1187439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187449 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1187452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187460 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187477 */     // GIR_Coverage, 16519,
     /* 1187477 */     GIR_EraseRootFromParent_Done,
     /* 1187478 */   // Label 17273: @1187478
     /* 1187478 */   GIM_Try, /*On fail goto*//*Label 17274*/ GIMT_Encode4(1187561), // Rule ID 16522 //
     /* 1187483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1187494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1187497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1187500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1187503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187522 */     // MIs[0] round
     /* 1187522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187532 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1187535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187560 */     // GIR_Coverage, 16522,
     /* 1187560 */     GIR_EraseRootFromParent_Done,
     /* 1187561 */   // Label 17274: @1187561
     /* 1187561 */   GIM_Try, /*On fail goto*//*Label 17275*/ GIMT_Encode4(1187644), // Rule ID 16523 //
     /* 1187566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1187577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1187580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1187583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1187586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187605 */     // MIs[0] round
     /* 1187605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187615 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1187618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187626 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187643 */     // GIR_Coverage, 16523,
     /* 1187643 */     GIR_EraseRootFromParent_Done,
     /* 1187644 */   // Label 17275: @1187644
     /* 1187644 */   GIM_Try, /*On fail goto*//*Label 17276*/ GIMT_Encode4(1187727), // Rule ID 16526 //
     /* 1187649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1187660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1187663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1187666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1187669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187688 */     // MIs[0] round
     /* 1187688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1187701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187726 */     // GIR_Coverage, 16526,
     /* 1187726 */     GIR_EraseRootFromParent_Done,
     /* 1187727 */   // Label 17276: @1187727
     /* 1187727 */   GIM_Try, /*On fail goto*//*Label 17277*/ GIMT_Encode4(1187810), // Rule ID 16527 //
     /* 1187732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1187743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1187746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1187749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1187752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187771 */     // MIs[0] round
     /* 1187771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187781 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1187784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187792 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187809 */     // GIR_Coverage, 16527,
     /* 1187809 */     GIR_EraseRootFromParent_Done,
     /* 1187810 */   // Label 17277: @1187810
     /* 1187810 */   GIM_Try, /*On fail goto*//*Label 17278*/ GIMT_Encode4(1187893), // Rule ID 16530 //
     /* 1187815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1187826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1187829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1187832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1187835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187854 */     // MIs[0] round
     /* 1187854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187864 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1187867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187892 */     // GIR_Coverage, 16530,
     /* 1187892 */     GIR_EraseRootFromParent_Done,
     /* 1187893 */   // Label 17278: @1187893
     /* 1187893 */   GIM_Try, /*On fail goto*//*Label 17279*/ GIMT_Encode4(1187976), // Rule ID 16531 //
     /* 1187898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1187909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1187912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1187915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1187918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187937 */     // MIs[0] round
     /* 1187937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187947 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1187950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187958 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187975 */     // GIR_Coverage, 16531,
     /* 1187975 */     GIR_EraseRootFromParent_Done,
     /* 1187976 */   // Label 17279: @1187976
     /* 1187976 */   GIM_Try, /*On fail goto*//*Label 17280*/ GIMT_Encode4(1188059), // Rule ID 16534 //
     /* 1187981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1187992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1187995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1187998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1188001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188020 */     // MIs[0] round
     /* 1188020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188030 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1188033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188058 */     // GIR_Coverage, 16534,
     /* 1188058 */     GIR_EraseRootFromParent_Done,
     /* 1188059 */   // Label 17280: @1188059
     /* 1188059 */   GIM_Try, /*On fail goto*//*Label 17281*/ GIMT_Encode4(1188142), // Rule ID 16535 //
     /* 1188064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1188067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1188075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1188078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1188081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1188084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188103 */     // MIs[0] round
     /* 1188103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188113 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1188116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188124 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188141 */     // GIR_Coverage, 16535,
     /* 1188141 */     GIR_EraseRootFromParent_Done,
     /* 1188142 */   // Label 17281: @1188142
     /* 1188142 */   GIM_Try, /*On fail goto*//*Label 17282*/ GIMT_Encode4(1188225), // Rule ID 16538 //
     /* 1188147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1188150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1188158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1188161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1188164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1188167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188186 */     // MIs[0] round
     /* 1188186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1188199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188224 */     // GIR_Coverage, 16538,
     /* 1188224 */     GIR_EraseRootFromParent_Done,
     /* 1188225 */   // Label 17282: @1188225
     /* 1188225 */   GIM_Try, /*On fail goto*//*Label 17283*/ GIMT_Encode4(1188308), // Rule ID 16539 //
     /* 1188230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1188233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1188241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1188244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1188247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1188250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188269 */     // MIs[0] round
     /* 1188269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188279 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1188282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188290 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188307 */     // GIR_Coverage, 16539,
     /* 1188307 */     GIR_EraseRootFromParent_Done,
     /* 1188308 */   // Label 17283: @1188308
     /* 1188308 */   GIM_Try, /*On fail goto*//*Label 17284*/ GIMT_Encode4(1188391), // Rule ID 16542 //
     /* 1188313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1188316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1188324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1188327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1188330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1188333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188352 */     // MIs[0] round
     /* 1188352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188362 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1188365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188390 */     // GIR_Coverage, 16542,
     /* 1188390 */     GIR_EraseRootFromParent_Done,
     /* 1188391 */   // Label 17284: @1188391
     /* 1188391 */   GIM_Try, /*On fail goto*//*Label 17285*/ GIMT_Encode4(1188474), // Rule ID 16543 //
     /* 1188396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1188399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1188407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1188410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1188413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1188416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188435 */     // MIs[0] round
     /* 1188435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188445 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1188448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188456 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188473 */     // GIR_Coverage, 16543,
     /* 1188473 */     GIR_EraseRootFromParent_Done,
     /* 1188474 */   // Label 17285: @1188474
     /* 1188474 */   GIM_Try, /*On fail goto*//*Label 17286*/ GIMT_Encode4(1188557), // Rule ID 16546 //
     /* 1188479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1188482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1188490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1188493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1188496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1188499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188518 */     // MIs[0] round
     /* 1188518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188528 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1188531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188556 */     // GIR_Coverage, 16546,
     /* 1188556 */     GIR_EraseRootFromParent_Done,
     /* 1188557 */   // Label 17286: @1188557
     /* 1188557 */   GIM_Try, /*On fail goto*//*Label 17287*/ GIMT_Encode4(1188640), // Rule ID 16547 //
     /* 1188562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1188565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1188573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1188576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1188579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1188582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188601 */     // MIs[0] round
     /* 1188601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188611 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1188614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188622 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188639 */     // GIR_Coverage, 16547,
     /* 1188639 */     GIR_EraseRootFromParent_Done,
     /* 1188640 */   // Label 17287: @1188640
     /* 1188640 */   GIM_Try, /*On fail goto*//*Label 17288*/ GIMT_Encode4(1188723), // Rule ID 16550 //
     /* 1188645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1188648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1188656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1188659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1188662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1188665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188684 */     // MIs[0] round
     /* 1188684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188694 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1188697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188722 */     // GIR_Coverage, 16550,
     /* 1188722 */     GIR_EraseRootFromParent_Done,
     /* 1188723 */   // Label 17288: @1188723
     /* 1188723 */   GIM_Try, /*On fail goto*//*Label 17289*/ GIMT_Encode4(1188806), // Rule ID 16551 //
     /* 1188728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1188731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1188739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1188742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1188745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1188748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188767 */     // MIs[0] round
     /* 1188767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188777 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1188780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188788 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188805 */     // GIR_Coverage, 16551,
     /* 1188805 */     GIR_EraseRootFromParent_Done,
     /* 1188806 */   // Label 17289: @1188806
     /* 1188806 */   GIM_Try, /*On fail goto*//*Label 17290*/ GIMT_Encode4(1188889), // Rule ID 16554 //
     /* 1188811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1188814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1188828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1188831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188850 */     // MIs[0] round
     /* 1188850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188860 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1188863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188888 */     // GIR_Coverage, 16554,
     /* 1188888 */     GIR_EraseRootFromParent_Done,
     /* 1188889 */   // Label 17290: @1188889
     /* 1188889 */   GIM_Try, /*On fail goto*//*Label 17291*/ GIMT_Encode4(1188972), // Rule ID 16555 //
     /* 1188894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1188897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1188911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1188914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188933 */     // MIs[0] round
     /* 1188933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188943 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1188946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188954 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188971 */     // GIR_Coverage, 16555,
     /* 1188971 */     GIR_EraseRootFromParent_Done,
     /* 1188972 */   // Label 17291: @1188972
     /* 1188972 */   GIM_Try, /*On fail goto*//*Label 17292*/ GIMT_Encode4(1189055), // Rule ID 16558 //
     /* 1188977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1188980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1188988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1188991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1188994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1188997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189016 */     // MIs[0] round
     /* 1189016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189026 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1189029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1189053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189054 */     // GIR_Coverage, 16558,
     /* 1189054 */     GIR_EraseRootFromParent_Done,
     /* 1189055 */   // Label 17292: @1189055
     /* 1189055 */   GIM_Try, /*On fail goto*//*Label 17293*/ GIMT_Encode4(1189138), // Rule ID 16559 //
     /* 1189060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1189063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1189068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1189071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1189074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1189077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1189080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189099 */     // MIs[0] round
     /* 1189099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189109 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1189112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189120 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1189136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189137 */     // GIR_Coverage, 16559,
     /* 1189137 */     GIR_EraseRootFromParent_Done,
     /* 1189138 */   // Label 17293: @1189138
     /* 1189138 */   GIM_Try, /*On fail goto*//*Label 17294*/ GIMT_Encode4(1189221), // Rule ID 16562 //
     /* 1189143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1189146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1189151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1189154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1189157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1189160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1189163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189182 */     // MIs[0] round
     /* 1189182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1189195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1189219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189220 */     // GIR_Coverage, 16562,
     /* 1189220 */     GIR_EraseRootFromParent_Done,
     /* 1189221 */   // Label 17294: @1189221
     /* 1189221 */   GIM_Try, /*On fail goto*//*Label 17295*/ GIMT_Encode4(1189304), // Rule ID 16563 //
     /* 1189226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1189229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1189234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1189237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1189240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1189243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1189246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189265 */     // MIs[0] round
     /* 1189265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189275 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1189278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1189302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189303 */     // GIR_Coverage, 16563,
     /* 1189303 */     GIR_EraseRootFromParent_Done,
     /* 1189304 */   // Label 17295: @1189304
     /* 1189304 */   GIM_Try, /*On fail goto*//*Label 17296*/ GIMT_Encode4(1189387), // Rule ID 16566 //
     /* 1189309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1189312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1189317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1189320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1189323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1189326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1189329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189348 */     // MIs[0] round
     /* 1189348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189358 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1189361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1189385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189386 */     // GIR_Coverage, 16566,
     /* 1189386 */     GIR_EraseRootFromParent_Done,
     /* 1189387 */   // Label 17296: @1189387
     /* 1189387 */   GIM_Try, /*On fail goto*//*Label 17297*/ GIMT_Encode4(1189470), // Rule ID 16567 //
     /* 1189392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1189395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1189400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1189403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1189406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1189409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1189412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189431 */     // MIs[0] round
     /* 1189431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189441 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1189444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189452 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1189468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189469 */     // GIR_Coverage, 16567,
     /* 1189469 */     GIR_EraseRootFromParent_Done,
     /* 1189470 */   // Label 17297: @1189470
     /* 1189470 */   GIM_Try, /*On fail goto*//*Label 17298*/ GIMT_Encode4(1189553), // Rule ID 16570 //
     /* 1189475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1189478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1189483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1189486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1189489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1189492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1189495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1189514 */     // MIs[0] round
     /* 1189514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189524 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1189527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1189545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1189551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189552 */     // GIR_Coverage, 16570,
     /* 1189552 */     GIR_EraseRootFromParent_Done,
     /* 1189553 */   // Label 17298: @1189553
     /* 1189553 */   GIM_Try, /*On fail goto*//*Label 17299*/ GIMT_Encode4(1189636), // Rule ID 16571 //
     /* 1189558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1189561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1189566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1189569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1189572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1189575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1189578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1189597 */     // MIs[0] round
     /* 1189597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189607 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1189610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189618 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1189628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1189634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189635 */     // GIR_Coverage, 16571,
     /* 1189635 */     GIR_EraseRootFromParent_Done,
     /* 1189636 */   // Label 17299: @1189636
     /* 1189636 */   GIM_Try, /*On fail goto*//*Label 17300*/ GIMT_Encode4(1189719), // Rule ID 16574 //
     /* 1189641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1189644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1189649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1189652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1189655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1189658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1189661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1189680 */     // MIs[0] round
     /* 1189680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189690 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1189693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1189711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1189717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189718 */     // GIR_Coverage, 16574,
     /* 1189718 */     GIR_EraseRootFromParent_Done,
     /* 1189719 */   // Label 17300: @1189719
     /* 1189719 */   GIM_Try, /*On fail goto*//*Label 17301*/ GIMT_Encode4(1189802), // Rule ID 16575 //
     /* 1189724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1189727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1189732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1189735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1189738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1189741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1189744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1189763 */     // MIs[0] round
     /* 1189763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189773 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1189776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189784 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1189794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1189800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189801 */     // GIR_Coverage, 16575,
     /* 1189801 */     GIR_EraseRootFromParent_Done,
     /* 1189802 */   // Label 17301: @1189802
     /* 1189802 */   GIM_Try, /*On fail goto*//*Label 17302*/ GIMT_Encode4(1189885), // Rule ID 16578 //
     /* 1189807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1189810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1189815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1189818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1189821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1189824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1189827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1189846 */     // MIs[0] round
     /* 1189846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189856 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1189859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1189877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1189883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189884 */     // GIR_Coverage, 16578,
     /* 1189884 */     GIR_EraseRootFromParent_Done,
     /* 1189885 */   // Label 17302: @1189885
     /* 1189885 */   GIM_Try, /*On fail goto*//*Label 17303*/ GIMT_Encode4(1189968), // Rule ID 16579 //
     /* 1189890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1189893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1189898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1189901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1189904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1189907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1189910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1189929 */     // MIs[0] round
     /* 1189929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189939 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1189942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1189960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1189966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189967 */     // GIR_Coverage, 16579,
     /* 1189967 */     GIR_EraseRootFromParent_Done,
     /* 1189968 */   // Label 17303: @1189968
     /* 1189968 */   GIM_Try, /*On fail goto*//*Label 17304*/ GIMT_Encode4(1190051), // Rule ID 16582 //
     /* 1189973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1189976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1189981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1189984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1189987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1189990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1189993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1190012 */     // MIs[0] round
     /* 1190012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190022 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1190025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1190043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1190049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190050 */     // GIR_Coverage, 16582,
     /* 1190050 */     GIR_EraseRootFromParent_Done,
     /* 1190051 */   // Label 17304: @1190051
     /* 1190051 */   GIM_Try, /*On fail goto*//*Label 17305*/ GIMT_Encode4(1190134), // Rule ID 16583 //
     /* 1190056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1190059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1190064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1190067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1190070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1190073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1190095 */     // MIs[0] round
     /* 1190095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190105 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1190108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190116 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1190126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1190132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190133 */     // GIR_Coverage, 16583,
     /* 1190133 */     GIR_EraseRootFromParent_Done,
     /* 1190134 */   // Label 17305: @1190134
     /* 1190134 */   GIM_Try, /*On fail goto*//*Label 17306*/ GIMT_Encode4(1190217), // Rule ID 16586 //
     /* 1190139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1190142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1190147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1190150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1190153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1190156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1190159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1190178 */     // MIs[0] round
     /* 1190178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190188 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1190191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1190209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1190215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190216 */     // GIR_Coverage, 16586,
     /* 1190216 */     GIR_EraseRootFromParent_Done,
     /* 1190217 */   // Label 17306: @1190217
     /* 1190217 */   GIM_Try, /*On fail goto*//*Label 17307*/ GIMT_Encode4(1190300), // Rule ID 16587 //
     /* 1190222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1190225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1190230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1190233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1190236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1190239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1190261 */     // MIs[0] round
     /* 1190261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190271 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1190274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190282 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1190292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1190298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190299 */     // GIR_Coverage, 16587,
     /* 1190299 */     GIR_EraseRootFromParent_Done,
     /* 1190300 */   // Label 17307: @1190300
     /* 1190300 */   GIM_Try, /*On fail goto*//*Label 17308*/ GIMT_Encode4(1190383), // Rule ID 16590 //
     /* 1190305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1190308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1190313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1190316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1190319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1190322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1190325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1190344 */     // MIs[0] round
     /* 1190344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190354 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1190357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1190375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1190381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190382 */     // GIR_Coverage, 16590,
     /* 1190382 */     GIR_EraseRootFromParent_Done,
     /* 1190383 */   // Label 17308: @1190383
     /* 1190383 */   GIM_Try, /*On fail goto*//*Label 17309*/ GIMT_Encode4(1190466), // Rule ID 16591 //
     /* 1190388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1190391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1190396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1190399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1190402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1190405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1190427 */     // MIs[0] round
     /* 1190427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190437 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1190440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190448 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1190458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1190464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190465 */     // GIR_Coverage, 16591,
     /* 1190465 */     GIR_EraseRootFromParent_Done,
     /* 1190466 */   // Label 17309: @1190466
     /* 1190466 */   GIM_Try, /*On fail goto*//*Label 17310*/ GIMT_Encode4(1190549), // Rule ID 16594 //
     /* 1190471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1190474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1190479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1190482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1190485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1190488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1190491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1190510 */     // MIs[0] round
     /* 1190510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190520 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1190523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1190547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190548 */     // GIR_Coverage, 16594,
     /* 1190548 */     GIR_EraseRootFromParent_Done,
     /* 1190549 */   // Label 17310: @1190549
     /* 1190549 */   GIM_Try, /*On fail goto*//*Label 17311*/ GIMT_Encode4(1190632), // Rule ID 16595 //
     /* 1190554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1190557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1190562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1190565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1190568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1190571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1190593 */     // MIs[0] round
     /* 1190593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190603 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1190606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190614 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1190630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190631 */     // GIR_Coverage, 16595,
     /* 1190631 */     GIR_EraseRootFromParent_Done,
     /* 1190632 */   // Label 17311: @1190632
     /* 1190632 */   GIM_Try, /*On fail goto*//*Label 17312*/ GIMT_Encode4(1190715), // Rule ID 16598 //
     /* 1190637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1190640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1190645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1190648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1190651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1190654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1190657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1190676 */     // MIs[0] round
     /* 1190676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190686 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1190689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1190713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190714 */     // GIR_Coverage, 16598,
     /* 1190714 */     GIR_EraseRootFromParent_Done,
     /* 1190715 */   // Label 17312: @1190715
     /* 1190715 */   GIM_Try, /*On fail goto*//*Label 17313*/ GIMT_Encode4(1190798), // Rule ID 16599 //
     /* 1190720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1190723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1190728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1190731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1190734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1190737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1190759 */     // MIs[0] round
     /* 1190759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190769 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1190772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190780 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1190796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190797 */     // GIR_Coverage, 16599,
     /* 1190797 */     GIR_EraseRootFromParent_Done,
     /* 1190798 */   // Label 17313: @1190798
     /* 1190798 */   GIM_Try, /*On fail goto*//*Label 17314*/ GIMT_Encode4(1190881), // Rule ID 16602 //
     /* 1190803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1190806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1190811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1190814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1190817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1190820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1190823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1190842 */     // MIs[0] round
     /* 1190842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1190855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1190879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190880 */     // GIR_Coverage, 16602,
     /* 1190880 */     GIR_EraseRootFromParent_Done,
     /* 1190881 */   // Label 17314: @1190881
     /* 1190881 */   GIM_Try, /*On fail goto*//*Label 17315*/ GIMT_Encode4(1190964), // Rule ID 16603 //
     /* 1190886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1190889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1190894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1190897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1190900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1190903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1190925 */     // MIs[0] round
     /* 1190925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190935 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1190938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190946 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1190962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190963 */     // GIR_Coverage, 16603,
     /* 1190963 */     GIR_EraseRootFromParent_Done,
     /* 1190964 */   // Label 17315: @1190964
     /* 1190964 */   GIM_Try, /*On fail goto*//*Label 17316*/ GIMT_Encode4(1191047), // Rule ID 16606 //
     /* 1190969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1190972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1190977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1190980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1190983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1190986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1190989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1191008 */     // MIs[0] round
     /* 1191008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1191021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1191045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191046 */     // GIR_Coverage, 16606,
     /* 1191046 */     GIR_EraseRootFromParent_Done,
     /* 1191047 */   // Label 17316: @1191047
     /* 1191047 */   GIM_Try, /*On fail goto*//*Label 17317*/ GIMT_Encode4(1191130), // Rule ID 16607 //
     /* 1191052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1191055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1191060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1191063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1191066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1191069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1191091 */     // MIs[0] round
     /* 1191091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1191104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191112 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1191128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191129 */     // GIR_Coverage, 16607,
     /* 1191129 */     GIR_EraseRootFromParent_Done,
     /* 1191130 */   // Label 17317: @1191130
     /* 1191130 */   GIM_Try, /*On fail goto*//*Label 17318*/ GIMT_Encode4(1191213), // Rule ID 16610 //
     /* 1191135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1191138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1191143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1191146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1191149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1191152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1191174 */     // MIs[0] round
     /* 1191174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191184 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1191187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1191211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191212 */     // GIR_Coverage, 16610,
     /* 1191212 */     GIR_EraseRootFromParent_Done,
     /* 1191213 */   // Label 17318: @1191213
     /* 1191213 */   GIM_Try, /*On fail goto*//*Label 17319*/ GIMT_Encode4(1191296), // Rule ID 16611 //
     /* 1191218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1191221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1191226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1191229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1191232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1191235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1191257 */     // MIs[0] round
     /* 1191257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191267 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1191270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191278 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1191294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191295 */     // GIR_Coverage, 16611,
     /* 1191295 */     GIR_EraseRootFromParent_Done,
     /* 1191296 */   // Label 17319: @1191296
     /* 1191296 */   GIM_Try, /*On fail goto*//*Label 17320*/ GIMT_Encode4(1191379), // Rule ID 16614 //
     /* 1191301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1191304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1191309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1191312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1191315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1191340 */     // MIs[0] round
     /* 1191340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191350 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1191353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1191377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191378 */     // GIR_Coverage, 16614,
     /* 1191378 */     GIR_EraseRootFromParent_Done,
     /* 1191379 */   // Label 17320: @1191379
     /* 1191379 */   GIM_Try, /*On fail goto*//*Label 17321*/ GIMT_Encode4(1191462), // Rule ID 16615 //
     /* 1191384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1191387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1191392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1191395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1191398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1191423 */     // MIs[0] round
     /* 1191423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191433 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1191436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191444 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191457 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1191460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191461 */     // GIR_Coverage, 16615,
     /* 1191461 */     GIR_EraseRootFromParent_Done,
     /* 1191462 */   // Label 17321: @1191462
     /* 1191462 */   GIM_Try, /*On fail goto*//*Label 17322*/ GIMT_Encode4(1191545), // Rule ID 16618 //
     /* 1191467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1191470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1191475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1191478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1191481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1191484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1191506 */     // MIs[0] round
     /* 1191506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1191519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1191543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191544 */     // GIR_Coverage, 16618,
     /* 1191544 */     GIR_EraseRootFromParent_Done,
     /* 1191545 */   // Label 17322: @1191545
     /* 1191545 */   GIM_Try, /*On fail goto*//*Label 17323*/ GIMT_Encode4(1191628), // Rule ID 16619 //
     /* 1191550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1191553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1191558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1191561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1191564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1191567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1191589 */     // MIs[0] round
     /* 1191589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191599 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1191602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191610 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1191626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191627 */     // GIR_Coverage, 16619,
     /* 1191627 */     GIR_EraseRootFromParent_Done,
     /* 1191628 */   // Label 17323: @1191628
     /* 1191628 */   GIM_Try, /*On fail goto*//*Label 17324*/ GIMT_Encode4(1191711), // Rule ID 16622 //
     /* 1191633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1191636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1191641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1191644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1191647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1191650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1191672 */     // MIs[0] round
     /* 1191672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1191685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1191709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191710 */     // GIR_Coverage, 16622,
     /* 1191710 */     GIR_EraseRootFromParent_Done,
     /* 1191711 */   // Label 17324: @1191711
     /* 1191711 */   GIM_Try, /*On fail goto*//*Label 17325*/ GIMT_Encode4(1191794), // Rule ID 16623 //
     /* 1191716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1191719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1191724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1191727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1191730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1191733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1191755 */     // MIs[0] round
     /* 1191755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1191768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191776 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1191792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191793 */     // GIR_Coverage, 16623,
     /* 1191793 */     GIR_EraseRootFromParent_Done,
     /* 1191794 */   // Label 17325: @1191794
     /* 1191794 */   GIM_Try, /*On fail goto*//*Label 17326*/ GIMT_Encode4(1191877), // Rule ID 16626 //
     /* 1191799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1191802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1191807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1191810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1191813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1191816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1191838 */     // MIs[0] round
     /* 1191838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191848 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1191851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1191875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191876 */     // GIR_Coverage, 16626,
     /* 1191876 */     GIR_EraseRootFromParent_Done,
     /* 1191877 */   // Label 17326: @1191877
     /* 1191877 */   GIM_Try, /*On fail goto*//*Label 17327*/ GIMT_Encode4(1191960), // Rule ID 16627 //
     /* 1191882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1191885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1191890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1191893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1191896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1191899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1191921 */     // MIs[0] round
     /* 1191921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191931 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1191934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191942 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1191958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191959 */     // GIR_Coverage, 16627,
     /* 1191959 */     GIR_EraseRootFromParent_Done,
     /* 1191960 */   // Label 17327: @1191960
     /* 1191960 */   GIM_Try, /*On fail goto*//*Label 17328*/ GIMT_Encode4(1192040), // Rule ID 16690 //
     /* 1191965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1191976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1191979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1191982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1191985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192004 */     // MIs[0] round
     /* 1192004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192014 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1192017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192039 */     // GIR_Coverage, 16690,
     /* 1192039 */     GIR_EraseRootFromParent_Done,
     /* 1192040 */   // Label 17328: @1192040
     /* 1192040 */   GIM_Try, /*On fail goto*//*Label 17329*/ GIMT_Encode4(1192120), // Rule ID 16691 //
     /* 1192045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1192048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1192056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1192059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1192062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1192065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192084 */     // MIs[0] round
     /* 1192084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192094 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1192097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192119 */     // GIR_Coverage, 16691,
     /* 1192119 */     GIR_EraseRootFromParent_Done,
     /* 1192120 */   // Label 17329: @1192120
     /* 1192120 */   GIM_Try, /*On fail goto*//*Label 17330*/ GIMT_Encode4(1192200), // Rule ID 16694 //
     /* 1192125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1192128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1192136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1192139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1192142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1192145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192164 */     // MIs[0] round
     /* 1192164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192174 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1192177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192199 */     // GIR_Coverage, 16694,
     /* 1192199 */     GIR_EraseRootFromParent_Done,
     /* 1192200 */   // Label 17330: @1192200
     /* 1192200 */   GIM_Try, /*On fail goto*//*Label 17331*/ GIMT_Encode4(1192280), // Rule ID 16695 //
     /* 1192205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1192208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1192216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1192219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1192222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1192225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192244 */     // MIs[0] round
     /* 1192244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192254 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1192257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192279 */     // GIR_Coverage, 16695,
     /* 1192279 */     GIR_EraseRootFromParent_Done,
     /* 1192280 */   // Label 17331: @1192280
     /* 1192280 */   GIM_Try, /*On fail goto*//*Label 17332*/ GIMT_Encode4(1192360), // Rule ID 16698 //
     /* 1192285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1192296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1192299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1192302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1192305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192324 */     // MIs[0] round
     /* 1192324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192334 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1192337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192359 */     // GIR_Coverage, 16698,
     /* 1192359 */     GIR_EraseRootFromParent_Done,
     /* 1192360 */   // Label 17332: @1192360
     /* 1192360 */   GIM_Try, /*On fail goto*//*Label 17333*/ GIMT_Encode4(1192440), // Rule ID 16699 //
     /* 1192365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1192376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1192379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1192382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1192385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192404 */     // MIs[0] round
     /* 1192404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192414 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1192417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192439 */     // GIR_Coverage, 16699,
     /* 1192439 */     GIR_EraseRootFromParent_Done,
     /* 1192440 */   // Label 17333: @1192440
     /* 1192440 */   GIM_Try, /*On fail goto*//*Label 17334*/ GIMT_Encode4(1192520), // Rule ID 16702 //
     /* 1192445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1192448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1192456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1192459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1192462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1192465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192484 */     // MIs[0] round
     /* 1192484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192494 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1192497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192519 */     // GIR_Coverage, 16702,
     /* 1192519 */     GIR_EraseRootFromParent_Done,
     /* 1192520 */   // Label 17334: @1192520
     /* 1192520 */   GIM_Try, /*On fail goto*//*Label 17335*/ GIMT_Encode4(1192600), // Rule ID 16703 //
     /* 1192525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1192528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1192536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1192539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1192542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1192545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192564 */     // MIs[0] round
     /* 1192564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192574 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1192577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192599 */     // GIR_Coverage, 16703,
     /* 1192599 */     GIR_EraseRootFromParent_Done,
     /* 1192600 */   // Label 17335: @1192600
     /* 1192600 */   GIM_Try, /*On fail goto*//*Label 17336*/ GIMT_Encode4(1192680), // Rule ID 16706 //
     /* 1192605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1192616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1192619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1192622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1192625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192644 */     // MIs[0] round
     /* 1192644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192654 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1192657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192679 */     // GIR_Coverage, 16706,
     /* 1192679 */     GIR_EraseRootFromParent_Done,
     /* 1192680 */   // Label 17336: @1192680
     /* 1192680 */   GIM_Try, /*On fail goto*//*Label 17337*/ GIMT_Encode4(1192760), // Rule ID 16707 //
     /* 1192685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1192696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1192699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1192702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1192705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192724 */     // MIs[0] round
     /* 1192724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192734 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1192737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192759 */     // GIR_Coverage, 16707,
     /* 1192759 */     GIR_EraseRootFromParent_Done,
     /* 1192760 */   // Label 17337: @1192760
     /* 1192760 */   GIM_Try, /*On fail goto*//*Label 17338*/ GIMT_Encode4(1192840), // Rule ID 16710 //
     /* 1192765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1192776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1192779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1192782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1192785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192804 */     // MIs[0] round
     /* 1192804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192814 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1192817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192839 */     // GIR_Coverage, 16710,
     /* 1192839 */     GIR_EraseRootFromParent_Done,
     /* 1192840 */   // Label 17338: @1192840
     /* 1192840 */   GIM_Try, /*On fail goto*//*Label 17339*/ GIMT_Encode4(1192920), // Rule ID 16711 //
     /* 1192845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1192856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1192859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1192862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1192865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192884 */     // MIs[0] round
     /* 1192884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192894 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1192897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192919 */     // GIR_Coverage, 16711,
     /* 1192919 */     GIR_EraseRootFromParent_Done,
     /* 1192920 */   // Label 17339: @1192920
     /* 1192920 */   GIM_Try, /*On fail goto*//*Label 17340*/ GIMT_Encode4(1193000), // Rule ID 16714 //
     /* 1192925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1192928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1192936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1192939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1192942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1192945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192964 */     // MIs[0] round
     /* 1192964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192974 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1192977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192999 */     // GIR_Coverage, 16714,
     /* 1192999 */     GIR_EraseRootFromParent_Done,
     /* 1193000 */   // Label 17340: @1193000
     /* 1193000 */   GIM_Try, /*On fail goto*//*Label 17341*/ GIMT_Encode4(1193080), // Rule ID 16715 //
     /* 1193005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1193016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1193019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1193022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1193025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193044 */     // MIs[0] round
     /* 1193044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193054 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1193057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193079 */     // GIR_Coverage, 16715,
     /* 1193079 */     GIR_EraseRootFromParent_Done,
     /* 1193080 */   // Label 17341: @1193080
     /* 1193080 */   GIM_Try, /*On fail goto*//*Label 17342*/ GIMT_Encode4(1193160), // Rule ID 16718 //
     /* 1193085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1193096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1193099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1193102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1193105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193124 */     // MIs[0] round
     /* 1193124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193134 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1193137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193159 */     // GIR_Coverage, 16718,
     /* 1193159 */     GIR_EraseRootFromParent_Done,
     /* 1193160 */   // Label 17342: @1193160
     /* 1193160 */   GIM_Try, /*On fail goto*//*Label 17343*/ GIMT_Encode4(1193240), // Rule ID 16719 //
     /* 1193165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1193176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1193179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1193182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1193185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193204 */     // MIs[0] round
     /* 1193204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193214 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1193217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193239 */     // GIR_Coverage, 16719,
     /* 1193239 */     GIR_EraseRootFromParent_Done,
     /* 1193240 */   // Label 17343: @1193240
     /* 1193240 */   GIM_Try, /*On fail goto*//*Label 17344*/ GIMT_Encode4(1193320), // Rule ID 16722 //
     /* 1193245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1193256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1193259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1193262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1193265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193284 */     // MIs[0] round
     /* 1193284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193294 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1193297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193319 */     // GIR_Coverage, 16722,
     /* 1193319 */     GIR_EraseRootFromParent_Done,
     /* 1193320 */   // Label 17344: @1193320
     /* 1193320 */   GIM_Try, /*On fail goto*//*Label 17345*/ GIMT_Encode4(1193400), // Rule ID 16723 //
     /* 1193325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1193336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1193339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1193342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1193345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193364 */     // MIs[0] round
     /* 1193364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193374 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1193377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193399 */     // GIR_Coverage, 16723,
     /* 1193399 */     GIR_EraseRootFromParent_Done,
     /* 1193400 */   // Label 17345: @1193400
     /* 1193400 */   GIM_Try, /*On fail goto*//*Label 17346*/ GIMT_Encode4(1193480), // Rule ID 16726 //
     /* 1193405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1193408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1193416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1193419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1193422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1193425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193444 */     // MIs[0] round
     /* 1193444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193454 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1193457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193479 */     // GIR_Coverage, 16726,
     /* 1193479 */     GIR_EraseRootFromParent_Done,
     /* 1193480 */   // Label 17346: @1193480
     /* 1193480 */   GIM_Try, /*On fail goto*//*Label 17347*/ GIMT_Encode4(1193560), // Rule ID 16727 //
     /* 1193485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1193488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1193496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1193499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1193502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1193505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193524 */     // MIs[0] round
     /* 1193524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193534 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1193537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193559 */     // GIR_Coverage, 16727,
     /* 1193559 */     GIR_EraseRootFromParent_Done,
     /* 1193560 */   // Label 17347: @1193560
     /* 1193560 */   GIM_Try, /*On fail goto*//*Label 17348*/ GIMT_Encode4(1193640), // Rule ID 16730 //
     /* 1193565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1193568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1193576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1193579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1193582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1193585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193604 */     // MIs[0] round
     /* 1193604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193614 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1193617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193639 */     // GIR_Coverage, 16730,
     /* 1193639 */     GIR_EraseRootFromParent_Done,
     /* 1193640 */   // Label 17348: @1193640
     /* 1193640 */   GIM_Try, /*On fail goto*//*Label 17349*/ GIMT_Encode4(1193720), // Rule ID 16731 //
     /* 1193645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1193648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1193656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1193659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1193662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1193665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193684 */     // MIs[0] round
     /* 1193684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193694 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1193697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193719 */     // GIR_Coverage, 16731,
     /* 1193719 */     GIR_EraseRootFromParent_Done,
     /* 1193720 */   // Label 17349: @1193720
     /* 1193720 */   GIM_Try, /*On fail goto*//*Label 17350*/ GIMT_Encode4(1193800), // Rule ID 16734 //
     /* 1193725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1193728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1193736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1193739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1193742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1193745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193764 */     // MIs[0] round
     /* 1193764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193774 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1193777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193799 */     // GIR_Coverage, 16734,
     /* 1193799 */     GIR_EraseRootFromParent_Done,
     /* 1193800 */   // Label 17350: @1193800
     /* 1193800 */   GIM_Try, /*On fail goto*//*Label 17351*/ GIMT_Encode4(1193880), // Rule ID 16735 //
     /* 1193805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1193808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1193816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1193819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1193822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1193825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193844 */     // MIs[0] round
     /* 1193844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193854 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1193857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193879 */     // GIR_Coverage, 16735,
     /* 1193879 */     GIR_EraseRootFromParent_Done,
     /* 1193880 */   // Label 17351: @1193880
     /* 1193880 */   GIM_Try, /*On fail goto*//*Label 17352*/ GIMT_Encode4(1193960), // Rule ID 16738 //
     /* 1193885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1193888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1193896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1193899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1193902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1193905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193924 */     // MIs[0] round
     /* 1193924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193934 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1193937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193959 */     // GIR_Coverage, 16738,
     /* 1193959 */     GIR_EraseRootFromParent_Done,
     /* 1193960 */   // Label 17352: @1193960
     /* 1193960 */   GIM_Try, /*On fail goto*//*Label 17353*/ GIMT_Encode4(1194040), // Rule ID 16739 //
     /* 1193965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1193968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1193976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1193979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1193982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1193985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194004 */     // MIs[0] round
     /* 1194004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194014 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1194017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194039 */     // GIR_Coverage, 16739,
     /* 1194039 */     GIR_EraseRootFromParent_Done,
     /* 1194040 */   // Label 17353: @1194040
     /* 1194040 */   GIM_Try, /*On fail goto*//*Label 17354*/ GIMT_Encode4(1194120), // Rule ID 16742 //
     /* 1194045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1194048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1194053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1194056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1194059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1194062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1194065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194084 */     // MIs[0] round
     /* 1194084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194094 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1194097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194119 */     // GIR_Coverage, 16742,
     /* 1194119 */     GIR_EraseRootFromParent_Done,
     /* 1194120 */   // Label 17354: @1194120
     /* 1194120 */   GIM_Try, /*On fail goto*//*Label 17355*/ GIMT_Encode4(1194200), // Rule ID 16743 //
     /* 1194125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1194128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1194133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1194136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1194139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1194142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1194145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194164 */     // MIs[0] round
     /* 1194164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194174 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1194177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194199 */     // GIR_Coverage, 16743,
     /* 1194199 */     GIR_EraseRootFromParent_Done,
     /* 1194200 */   // Label 17355: @1194200
     /* 1194200 */   GIM_Try, /*On fail goto*//*Label 17356*/ GIMT_Encode4(1194280), // Rule ID 16746 //
     /* 1194205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1194208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1194213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1194216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1194219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1194222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1194225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194244 */     // MIs[0] round
     /* 1194244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194254 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1194257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194279 */     // GIR_Coverage, 16746,
     /* 1194279 */     GIR_EraseRootFromParent_Done,
     /* 1194280 */   // Label 17356: @1194280
     /* 1194280 */   GIM_Try, /*On fail goto*//*Label 17357*/ GIMT_Encode4(1194360), // Rule ID 16747 //
     /* 1194285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1194288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1194293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1194296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1194299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1194302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1194305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194324 */     // MIs[0] round
     /* 1194324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194334 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1194337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194359 */     // GIR_Coverage, 16747,
     /* 1194359 */     GIR_EraseRootFromParent_Done,
     /* 1194360 */   // Label 17357: @1194360
     /* 1194360 */   GIM_Try, /*On fail goto*//*Label 17358*/ GIMT_Encode4(1194440), // Rule ID 16750 //
     /* 1194365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1194373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1194376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1194379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1194382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1194385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1194404 */     // MIs[0] round
     /* 1194404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194414 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1194417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194439 */     // GIR_Coverage, 16750,
     /* 1194439 */     GIR_EraseRootFromParent_Done,
     /* 1194440 */   // Label 17358: @1194440
     /* 1194440 */   GIM_Try, /*On fail goto*//*Label 17359*/ GIMT_Encode4(1194520), // Rule ID 16751 //
     /* 1194445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1194453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1194456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1194459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1194462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1194465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1194484 */     // MIs[0] round
     /* 1194484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194494 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1194497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194519 */     // GIR_Coverage, 16751,
     /* 1194519 */     GIR_EraseRootFromParent_Done,
     /* 1194520 */   // Label 17359: @1194520
     /* 1194520 */   GIM_Try, /*On fail goto*//*Label 17360*/ GIMT_Encode4(1194600), // Rule ID 16754 //
     /* 1194525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1194533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1194536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1194539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1194542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1194545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1194564 */     // MIs[0] round
     /* 1194564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194574 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1194577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194599 */     // GIR_Coverage, 16754,
     /* 1194599 */     GIR_EraseRootFromParent_Done,
     /* 1194600 */   // Label 17360: @1194600
     /* 1194600 */   GIM_Try, /*On fail goto*//*Label 17361*/ GIMT_Encode4(1194680), // Rule ID 16755 //
     /* 1194605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1194613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1194616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1194619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1194622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1194625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1194644 */     // MIs[0] round
     /* 1194644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194654 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1194657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194679 */     // GIR_Coverage, 16755,
     /* 1194679 */     GIR_EraseRootFromParent_Done,
     /* 1194680 */   // Label 17361: @1194680
     /* 1194680 */   GIM_Try, /*On fail goto*//*Label 17362*/ GIMT_Encode4(1194760), // Rule ID 16758 //
     /* 1194685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1194693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1194696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1194699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1194702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1194724 */     // MIs[0] round
     /* 1194724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194734 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1194737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194759 */     // GIR_Coverage, 16758,
     /* 1194759 */     GIR_EraseRootFromParent_Done,
     /* 1194760 */   // Label 17362: @1194760
     /* 1194760 */   GIM_Try, /*On fail goto*//*Label 17363*/ GIMT_Encode4(1194840), // Rule ID 16759 //
     /* 1194765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1194773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1194776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1194779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1194782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1194804 */     // MIs[0] round
     /* 1194804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194814 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1194817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194839 */     // GIR_Coverage, 16759,
     /* 1194839 */     GIR_EraseRootFromParent_Done,
     /* 1194840 */   // Label 17363: @1194840
     /* 1194840 */   GIM_Try, /*On fail goto*//*Label 17364*/ GIMT_Encode4(1194920), // Rule ID 16762 //
     /* 1194845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1194853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1194856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1194859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1194862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1194865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1194884 */     // MIs[0] round
     /* 1194884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194894 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1194897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194919 */     // GIR_Coverage, 16762,
     /* 1194919 */     GIR_EraseRootFromParent_Done,
     /* 1194920 */   // Label 17364: @1194920
     /* 1194920 */   GIM_Try, /*On fail goto*//*Label 17365*/ GIMT_Encode4(1195000), // Rule ID 16763 //
     /* 1194925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1194933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1194936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1194939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1194942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1194945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1194964 */     // MIs[0] round
     /* 1194964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194974 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1194977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194999 */     // GIR_Coverage, 16763,
     /* 1194999 */     GIR_EraseRootFromParent_Done,
     /* 1195000 */   // Label 17365: @1195000
     /* 1195000 */   GIM_Try, /*On fail goto*//*Label 17366*/ GIMT_Encode4(1195080), // Rule ID 16766 //
     /* 1195005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1195008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1195013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1195016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1195019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1195022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1195044 */     // MIs[0] round
     /* 1195044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195054 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1195057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195079 */     // GIR_Coverage, 16766,
     /* 1195079 */     GIR_EraseRootFromParent_Done,
     /* 1195080 */   // Label 17366: @1195080
     /* 1195080 */   GIM_Try, /*On fail goto*//*Label 17367*/ GIMT_Encode4(1195160), // Rule ID 16767 //
     /* 1195085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1195088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1195093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1195096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1195099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1195102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1195124 */     // MIs[0] round
     /* 1195124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195134 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1195137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195159 */     // GIR_Coverage, 16767,
     /* 1195159 */     GIR_EraseRootFromParent_Done,
     /* 1195160 */   // Label 17367: @1195160
     /* 1195160 */   GIM_Try, /*On fail goto*//*Label 17368*/ GIMT_Encode4(1195240), // Rule ID 16770 //
     /* 1195165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1195173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1195176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1195179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1195182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1195204 */     // MIs[0] round
     /* 1195204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195214 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1195217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195239 */     // GIR_Coverage, 16770,
     /* 1195239 */     GIR_EraseRootFromParent_Done,
     /* 1195240 */   // Label 17368: @1195240
     /* 1195240 */   GIM_Try, /*On fail goto*//*Label 17369*/ GIMT_Encode4(1195320), // Rule ID 16771 //
     /* 1195245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1195253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1195256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1195259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1195262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1195284 */     // MIs[0] round
     /* 1195284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195294 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1195297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195319 */     // GIR_Coverage, 16771,
     /* 1195319 */     GIR_EraseRootFromParent_Done,
     /* 1195320 */   // Label 17369: @1195320
     /* 1195320 */   GIM_Try, /*On fail goto*//*Label 17370*/ GIMT_Encode4(1195400), // Rule ID 16774 //
     /* 1195325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1195333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1195336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1195339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1195342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195364 */     // MIs[0] round
     /* 1195364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195374 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1195377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195399 */     // GIR_Coverage, 16774,
     /* 1195399 */     GIR_EraseRootFromParent_Done,
     /* 1195400 */   // Label 17370: @1195400
     /* 1195400 */   GIM_Try, /*On fail goto*//*Label 17371*/ GIMT_Encode4(1195480), // Rule ID 16775 //
     /* 1195405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1195413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1195416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1195419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1195422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195444 */     // MIs[0] round
     /* 1195444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195454 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1195457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195479 */     // GIR_Coverage, 16775,
     /* 1195479 */     GIR_EraseRootFromParent_Done,
     /* 1195480 */   // Label 17371: @1195480
     /* 1195480 */   GIM_Try, /*On fail goto*//*Label 17372*/ GIMT_Encode4(1195560), // Rule ID 16778 //
     /* 1195485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1195493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1195496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1195499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1195502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195524 */     // MIs[0] round
     /* 1195524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195534 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1195537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195559 */     // GIR_Coverage, 16778,
     /* 1195559 */     GIR_EraseRootFromParent_Done,
     /* 1195560 */   // Label 17372: @1195560
     /* 1195560 */   GIM_Try, /*On fail goto*//*Label 17373*/ GIMT_Encode4(1195640), // Rule ID 16779 //
     /* 1195565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1195573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1195576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1195579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1195582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195604 */     // MIs[0] round
     /* 1195604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195614 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1195617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195639 */     // GIR_Coverage, 16779,
     /* 1195639 */     GIR_EraseRootFromParent_Done,
     /* 1195640 */   // Label 17373: @1195640
     /* 1195640 */   GIM_Try, /*On fail goto*//*Label 17374*/ GIMT_Encode4(1195720), // Rule ID 16782 //
     /* 1195645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1195653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1195656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1195659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1195662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195684 */     // MIs[0] round
     /* 1195684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195694 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1195697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195719 */     // GIR_Coverage, 16782,
     /* 1195719 */     GIR_EraseRootFromParent_Done,
     /* 1195720 */   // Label 17374: @1195720
     /* 1195720 */   GIM_Try, /*On fail goto*//*Label 17375*/ GIMT_Encode4(1195800), // Rule ID 16783 //
     /* 1195725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1195733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1195736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1195739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1195742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195764 */     // MIs[0] round
     /* 1195764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195774 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1195777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195799 */     // GIR_Coverage, 16783,
     /* 1195799 */     GIR_EraseRootFromParent_Done,
     /* 1195800 */   // Label 17375: @1195800
     /* 1195800 */   GIM_Try, /*On fail goto*//*Label 17376*/ GIMT_Encode4(1195880), // Rule ID 16786 //
     /* 1195805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1195808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1195813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1195816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1195819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1195822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1195844 */     // MIs[0] round
     /* 1195844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195854 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1195857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195879 */     // GIR_Coverage, 16786,
     /* 1195879 */     GIR_EraseRootFromParent_Done,
     /* 1195880 */   // Label 17376: @1195880
     /* 1195880 */   GIM_Try, /*On fail goto*//*Label 17377*/ GIMT_Encode4(1195960), // Rule ID 16787 //
     /* 1195885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1195888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1195893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1195896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1195899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1195902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1195924 */     // MIs[0] round
     /* 1195924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195934 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1195937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195959 */     // GIR_Coverage, 16787,
     /* 1195959 */     GIR_EraseRootFromParent_Done,
     /* 1195960 */   // Label 17377: @1195960
     /* 1195960 */   GIM_Try, /*On fail goto*//*Label 17378*/ GIMT_Encode4(1196040), // Rule ID 16790 //
     /* 1195965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1195968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1195973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1195976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1195979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1195982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196004 */     // MIs[0] round
     /* 1196004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196014 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1196017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196039 */     // GIR_Coverage, 16790,
     /* 1196039 */     GIR_EraseRootFromParent_Done,
     /* 1196040 */   // Label 17378: @1196040
     /* 1196040 */   GIM_Try, /*On fail goto*//*Label 17379*/ GIMT_Encode4(1196120), // Rule ID 16791 //
     /* 1196045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1196048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1196053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1196056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1196059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1196062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196084 */     // MIs[0] round
     /* 1196084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196094 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1196097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196119 */     // GIR_Coverage, 16791,
     /* 1196119 */     GIR_EraseRootFromParent_Done,
     /* 1196120 */   // Label 17379: @1196120
     /* 1196120 */   GIM_Try, /*On fail goto*//*Label 17380*/ GIMT_Encode4(1196200), // Rule ID 16794 //
     /* 1196125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1196128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1196133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1196136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1196139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1196142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196164 */     // MIs[0] round
     /* 1196164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196174 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1196177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196199 */     // GIR_Coverage, 16794,
     /* 1196199 */     GIR_EraseRootFromParent_Done,
     /* 1196200 */   // Label 17380: @1196200
     /* 1196200 */   GIM_Try, /*On fail goto*//*Label 17381*/ GIMT_Encode4(1196280), // Rule ID 16795 //
     /* 1196205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1196208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1196213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1196216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1196219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1196222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196244 */     // MIs[0] round
     /* 1196244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196254 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1196257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196279 */     // GIR_Coverage, 16795,
     /* 1196279 */     GIR_EraseRootFromParent_Done,
     /* 1196280 */   // Label 17381: @1196280
     /* 1196280 */   GIM_Try, /*On fail goto*//*Label 17382*/ GIMT_Encode4(1196360), // Rule ID 16798 //
     /* 1196285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1196288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1196293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1196296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1196299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1196302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196324 */     // MIs[0] round
     /* 1196324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196334 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1196337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196359 */     // GIR_Coverage, 16798,
     /* 1196359 */     GIR_EraseRootFromParent_Done,
     /* 1196360 */   // Label 17382: @1196360
     /* 1196360 */   GIM_Try, /*On fail goto*//*Label 17383*/ GIMT_Encode4(1196440), // Rule ID 16799 //
     /* 1196365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1196368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1196373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1196376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1196379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1196382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196404 */     // MIs[0] round
     /* 1196404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196414 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1196417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196439 */     // GIR_Coverage, 16799,
     /* 1196439 */     GIR_EraseRootFromParent_Done,
     /* 1196440 */   // Label 17383: @1196440
     /* 1196440 */   GIM_Try, /*On fail goto*//*Label 17384*/ GIMT_Encode4(1196520), // Rule ID 16802 //
     /* 1196445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1196448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1196453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1196456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1196459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1196462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196484 */     // MIs[0] round
     /* 1196484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196494 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1196497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196519 */     // GIR_Coverage, 16802,
     /* 1196519 */     GIR_EraseRootFromParent_Done,
     /* 1196520 */   // Label 17384: @1196520
     /* 1196520 */   GIM_Try, /*On fail goto*//*Label 17385*/ GIMT_Encode4(1196600), // Rule ID 16803 //
     /* 1196525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1196528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1196533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1196536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1196539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1196542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196564 */     // MIs[0] round
     /* 1196564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196574 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1196577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196599 */     // GIR_Coverage, 16803,
     /* 1196599 */     GIR_EraseRootFromParent_Done,
     /* 1196600 */   // Label 17385: @1196600
     /* 1196600 */   GIM_Try, /*On fail goto*//*Label 17386*/ GIMT_Encode4(1196680), // Rule ID 16806 //
     /* 1196605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1196608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1196613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1196616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1196619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1196622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196644 */     // MIs[0] round
     /* 1196644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196654 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1196657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196679 */     // GIR_Coverage, 16806,
     /* 1196679 */     GIR_EraseRootFromParent_Done,
     /* 1196680 */   // Label 17386: @1196680
     /* 1196680 */   GIM_Try, /*On fail goto*//*Label 17387*/ GIMT_Encode4(1196760), // Rule ID 16807 //
     /* 1196685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1196688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1196693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1196696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1196699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1196702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196724 */     // MIs[0] round
     /* 1196724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196734 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1196737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196759 */     // GIR_Coverage, 16807,
     /* 1196759 */     GIR_EraseRootFromParent_Done,
     /* 1196760 */   // Label 17387: @1196760
     /* 1196760 */   GIM_Try, /*On fail goto*//*Label 17388*/ GIMT_Encode4(1196840), // Rule ID 16810 //
     /* 1196765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1196776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1196779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1196782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1196785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196804 */     // MIs[0] round
     /* 1196804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196814 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1196817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196839 */     // GIR_Coverage, 16810,
     /* 1196839 */     GIR_EraseRootFromParent_Done,
     /* 1196840 */   // Label 17388: @1196840
     /* 1196840 */   GIM_Try, /*On fail goto*//*Label 17389*/ GIMT_Encode4(1196920), // Rule ID 16811 //
     /* 1196845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1196856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1196859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1196862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1196865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196884 */     // MIs[0] round
     /* 1196884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196894 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1196897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196919 */     // GIR_Coverage, 16811,
     /* 1196919 */     GIR_EraseRootFromParent_Done,
     /* 1196920 */   // Label 17389: @1196920
     /* 1196920 */   GIM_Try, /*On fail goto*//*Label 17390*/ GIMT_Encode4(1197000), // Rule ID 16814 //
     /* 1196925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1196936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1196939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1196942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1196945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196964 */     // MIs[0] round
     /* 1196964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196974 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1196977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196999 */     // GIR_Coverage, 16814,
     /* 1196999 */     GIR_EraseRootFromParent_Done,
     /* 1197000 */   // Label 17390: @1197000
     /* 1197000 */   GIM_Try, /*On fail goto*//*Label 17391*/ GIMT_Encode4(1197080), // Rule ID 16815 //
     /* 1197005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1197008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1197016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1197019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1197022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1197025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197044 */     // MIs[0] round
     /* 1197044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197054 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1197057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197079 */     // GIR_Coverage, 16815,
     /* 1197079 */     GIR_EraseRootFromParent_Done,
     /* 1197080 */   // Label 17391: @1197080
     /* 1197080 */   GIM_Try, /*On fail goto*//*Label 17392*/ GIMT_Encode4(1197160), // Rule ID 16818 //
     /* 1197085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1197088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1197096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1197099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1197102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1197105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197124 */     // MIs[0] round
     /* 1197124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197134 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1197137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197159 */     // GIR_Coverage, 16818,
     /* 1197159 */     GIR_EraseRootFromParent_Done,
     /* 1197160 */   // Label 17392: @1197160
     /* 1197160 */   GIM_Try, /*On fail goto*//*Label 17393*/ GIMT_Encode4(1197240), // Rule ID 16819 //
     /* 1197165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1197168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1197176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1197179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1197182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1197185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197204 */     // MIs[0] round
     /* 1197204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197214 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1197217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197239 */     // GIR_Coverage, 16819,
     /* 1197239 */     GIR_EraseRootFromParent_Done,
     /* 1197240 */   // Label 17393: @1197240
     /* 1197240 */   GIM_Try, /*On fail goto*//*Label 17394*/ GIMT_Encode4(1197320), // Rule ID 16822 //
     /* 1197245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1197248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1197256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1197259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1197262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1197265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197284 */     // MIs[0] round
     /* 1197284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197294 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1197297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197319 */     // GIR_Coverage, 16822,
     /* 1197319 */     GIR_EraseRootFromParent_Done,
     /* 1197320 */   // Label 17394: @1197320
     /* 1197320 */   GIM_Try, /*On fail goto*//*Label 17395*/ GIMT_Encode4(1197400), // Rule ID 16823 //
     /* 1197325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1197328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1197336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1197339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1197342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1197345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197364 */     // MIs[0] round
     /* 1197364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197374 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1197377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197399 */     // GIR_Coverage, 16823,
     /* 1197399 */     GIR_EraseRootFromParent_Done,
     /* 1197400 */   // Label 17395: @1197400
     /* 1197400 */   GIM_Try, /*On fail goto*//*Label 17396*/ GIMT_Encode4(1197480), // Rule ID 16826 //
     /* 1197405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1197408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1197416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1197419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1197422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1197425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197444 */     // MIs[0] round
     /* 1197444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197454 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1197457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197479 */     // GIR_Coverage, 16826,
     /* 1197479 */     GIR_EraseRootFromParent_Done,
     /* 1197480 */   // Label 17396: @1197480
     /* 1197480 */   GIM_Try, /*On fail goto*//*Label 17397*/ GIMT_Encode4(1197560), // Rule ID 16827 //
     /* 1197485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1197488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1197496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1197499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1197502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1197505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197524 */     // MIs[0] round
     /* 1197524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197534 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1197537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197559 */     // GIR_Coverage, 16827,
     /* 1197559 */     GIR_EraseRootFromParent_Done,
     /* 1197560 */   // Label 17397: @1197560
     /* 1197560 */   GIM_Try, /*On fail goto*//*Label 17398*/ GIMT_Encode4(1197640), // Rule ID 16830 //
     /* 1197565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1197568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1197576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1197579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1197582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1197585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197604 */     // MIs[0] round
     /* 1197604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197614 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1197617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197639 */     // GIR_Coverage, 16830,
     /* 1197639 */     GIR_EraseRootFromParent_Done,
     /* 1197640 */   // Label 17398: @1197640
     /* 1197640 */   GIM_Try, /*On fail goto*//*Label 17399*/ GIMT_Encode4(1197720), // Rule ID 16831 //
     /* 1197645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1197656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1197659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1197662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1197665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197684 */     // MIs[0] round
     /* 1197684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197694 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1197697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197719 */     // GIR_Coverage, 16831,
     /* 1197719 */     GIR_EraseRootFromParent_Done,
     /* 1197720 */   // Label 17399: @1197720
     /* 1197720 */   GIM_Try, /*On fail goto*//*Label 17400*/ GIMT_Encode4(1197800), // Rule ID 16834 //
     /* 1197725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1197728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1197736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1197739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1197742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1197745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197764 */     // MIs[0] round
     /* 1197764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197774 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1197777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197799 */     // GIR_Coverage, 16834,
     /* 1197799 */     GIR_EraseRootFromParent_Done,
     /* 1197800 */   // Label 17400: @1197800
     /* 1197800 */   GIM_Try, /*On fail goto*//*Label 17401*/ GIMT_Encode4(1197880), // Rule ID 16835 //
     /* 1197805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1197808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1197816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1197819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1197822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1197825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197844 */     // MIs[0] round
     /* 1197844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197854 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1197857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197879 */     // GIR_Coverage, 16835,
     /* 1197879 */     GIR_EraseRootFromParent_Done,
     /* 1197880 */   // Label 17401: @1197880
     /* 1197880 */   GIM_Try, /*On fail goto*//*Label 17402*/ GIMT_Encode4(1197960), // Rule ID 16838 //
     /* 1197885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1197888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1197896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1197899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1197902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1197905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197924 */     // MIs[0] round
     /* 1197924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197934 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1197937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197959 */     // GIR_Coverage, 16838,
     /* 1197959 */     GIR_EraseRootFromParent_Done,
     /* 1197960 */   // Label 17402: @1197960
     /* 1197960 */   GIM_Try, /*On fail goto*//*Label 17403*/ GIMT_Encode4(1198040), // Rule ID 16839 //
     /* 1197965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1197968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1197976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1197979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1197982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1197985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198004 */     // MIs[0] round
     /* 1198004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198014 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1198017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198039 */     // GIR_Coverage, 16839,
     /* 1198039 */     GIR_EraseRootFromParent_Done,
     /* 1198040 */   // Label 17403: @1198040
     /* 1198040 */   GIM_Try, /*On fail goto*//*Label 17404*/ GIMT_Encode4(1198120), // Rule ID 16842 //
     /* 1198045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1198056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1198059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1198062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1198065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198084 */     // MIs[0] round
     /* 1198084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198094 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1198097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198119 */     // GIR_Coverage, 16842,
     /* 1198119 */     GIR_EraseRootFromParent_Done,
     /* 1198120 */   // Label 17404: @1198120
     /* 1198120 */   GIM_Try, /*On fail goto*//*Label 17405*/ GIMT_Encode4(1198200), // Rule ID 16843 //
     /* 1198125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1198136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1198139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1198142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1198145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198164 */     // MIs[0] round
     /* 1198164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198174 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1198177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198199 */     // GIR_Coverage, 16843,
     /* 1198199 */     GIR_EraseRootFromParent_Done,
     /* 1198200 */   // Label 17405: @1198200
     /* 1198200 */   GIM_Try, /*On fail goto*//*Label 17406*/ GIMT_Encode4(1198280), // Rule ID 16846 //
     /* 1198205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1198208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1198216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1198219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1198222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1198225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198244 */     // MIs[0] round
     /* 1198244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198254 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1198257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198279 */     // GIR_Coverage, 16846,
     /* 1198279 */     GIR_EraseRootFromParent_Done,
     /* 1198280 */   // Label 17406: @1198280
     /* 1198280 */   GIM_Try, /*On fail goto*//*Label 17407*/ GIMT_Encode4(1198360), // Rule ID 16847 //
     /* 1198285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1198288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1198296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1198299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1198302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1198305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198324 */     // MIs[0] round
     /* 1198324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198334 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1198337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198359 */     // GIR_Coverage, 16847,
     /* 1198359 */     GIR_EraseRootFromParent_Done,
     /* 1198360 */   // Label 17407: @1198360
     /* 1198360 */   GIM_Try, /*On fail goto*//*Label 17408*/ GIMT_Encode4(1198440), // Rule ID 16850 //
     /* 1198365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1198368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1198376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1198379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1198382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1198385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198404 */     // MIs[0] round
     /* 1198404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198414 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1198417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198439 */     // GIR_Coverage, 16850,
     /* 1198439 */     GIR_EraseRootFromParent_Done,
     /* 1198440 */   // Label 17408: @1198440
     /* 1198440 */   GIM_Try, /*On fail goto*//*Label 17409*/ GIMT_Encode4(1198520), // Rule ID 16851 //
     /* 1198445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1198448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1198456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1198459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1198462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1198465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198484 */     // MIs[0] round
     /* 1198484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198494 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1198497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198519 */     // GIR_Coverage, 16851,
     /* 1198519 */     GIR_EraseRootFromParent_Done,
     /* 1198520 */   // Label 17409: @1198520
     /* 1198520 */   GIM_Try, /*On fail goto*//*Label 17410*/ GIMT_Encode4(1198600), // Rule ID 16854 //
     /* 1198525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1198528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1198536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1198539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1198542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1198545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198564 */     // MIs[0] round
     /* 1198564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198574 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1198577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198599 */     // GIR_Coverage, 16854,
     /* 1198599 */     GIR_EraseRootFromParent_Done,
     /* 1198600 */   // Label 17410: @1198600
     /* 1198600 */   GIM_Try, /*On fail goto*//*Label 17411*/ GIMT_Encode4(1198680), // Rule ID 16855 //
     /* 1198605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1198608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1198616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1198619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1198622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1198625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198644 */     // MIs[0] round
     /* 1198644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198654 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1198657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198679 */     // GIR_Coverage, 16855,
     /* 1198679 */     GIR_EraseRootFromParent_Done,
     /* 1198680 */   // Label 17411: @1198680
     /* 1198680 */   GIM_Try, /*On fail goto*//*Label 17412*/ GIMT_Encode4(1198760), // Rule ID 16858 //
     /* 1198685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1198688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1198696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1198699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1198702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1198705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198724 */     // MIs[0] round
     /* 1198724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198734 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1198737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198759 */     // GIR_Coverage, 16858,
     /* 1198759 */     GIR_EraseRootFromParent_Done,
     /* 1198760 */   // Label 17412: @1198760
     /* 1198760 */   GIM_Try, /*On fail goto*//*Label 17413*/ GIMT_Encode4(1198840), // Rule ID 16859 //
     /* 1198765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1198768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1198776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1198779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1198782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1198785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198804 */     // MIs[0] round
     /* 1198804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198814 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1198817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198839 */     // GIR_Coverage, 16859,
     /* 1198839 */     GIR_EraseRootFromParent_Done,
     /* 1198840 */   // Label 17413: @1198840
     /* 1198840 */   GIM_Try, /*On fail goto*//*Label 17414*/ GIMT_Encode4(1198920), // Rule ID 16862 //
     /* 1198845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1198848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1198856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1198859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1198862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1198865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198884 */     // MIs[0] round
     /* 1198884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198894 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1198897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198919 */     // GIR_Coverage, 16862,
     /* 1198919 */     GIR_EraseRootFromParent_Done,
     /* 1198920 */   // Label 17414: @1198920
     /* 1198920 */   GIM_Try, /*On fail goto*//*Label 17415*/ GIMT_Encode4(1199000), // Rule ID 16863 //
     /* 1198925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1198928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1198936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1198939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1198942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1198945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198964 */     // MIs[0] round
     /* 1198964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198974 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1198977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198999 */     // GIR_Coverage, 16863,
     /* 1198999 */     GIR_EraseRootFromParent_Done,
     /* 1199000 */   // Label 17415: @1199000
     /* 1199000 */   GIM_Try, /*On fail goto*//*Label 17416*/ GIMT_Encode4(1199080), // Rule ID 16866 //
     /* 1199005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1199008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1199013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1199016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1199019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1199022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1199025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199044 */     // MIs[0] round
     /* 1199044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199054 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1199057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199079 */     // GIR_Coverage, 16866,
     /* 1199079 */     GIR_EraseRootFromParent_Done,
     /* 1199080 */   // Label 17416: @1199080
     /* 1199080 */   GIM_Try, /*On fail goto*//*Label 17417*/ GIMT_Encode4(1199160), // Rule ID 16867 //
     /* 1199085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1199088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1199093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1199096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1199099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1199102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1199105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199124 */     // MIs[0] round
     /* 1199124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199134 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1199137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199159 */     // GIR_Coverage, 16867,
     /* 1199159 */     GIR_EraseRootFromParent_Done,
     /* 1199160 */   // Label 17417: @1199160
     /* 1199160 */   GIM_Try, /*On fail goto*//*Label 17418*/ GIMT_Encode4(1199240), // Rule ID 16870 //
     /* 1199165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1199168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1199173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1199176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1199179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1199182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199204 */     // MIs[0] round
     /* 1199204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199214 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1199217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199239 */     // GIR_Coverage, 16870,
     /* 1199239 */     GIR_EraseRootFromParent_Done,
     /* 1199240 */   // Label 17418: @1199240
     /* 1199240 */   GIM_Try, /*On fail goto*//*Label 17419*/ GIMT_Encode4(1199320), // Rule ID 16871 //
     /* 1199245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1199248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1199253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1199256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1199259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1199262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199284 */     // MIs[0] round
     /* 1199284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199294 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1199297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199319 */     // GIR_Coverage, 16871,
     /* 1199319 */     GIR_EraseRootFromParent_Done,
     /* 1199320 */   // Label 17419: @1199320
     /* 1199320 */   GIM_Try, /*On fail goto*//*Label 17420*/ GIMT_Encode4(1199400), // Rule ID 16874 //
     /* 1199325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1199328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1199333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1199336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1199339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1199342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199364 */     // MIs[0] round
     /* 1199364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199374 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1199377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199399 */     // GIR_Coverage, 16874,
     /* 1199399 */     GIR_EraseRootFromParent_Done,
     /* 1199400 */   // Label 17420: @1199400
     /* 1199400 */   GIM_Try, /*On fail goto*//*Label 17421*/ GIMT_Encode4(1199480), // Rule ID 16875 //
     /* 1199405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1199408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1199413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1199416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1199419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1199422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199444 */     // MIs[0] round
     /* 1199444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199454 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1199457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199479 */     // GIR_Coverage, 16875,
     /* 1199479 */     GIR_EraseRootFromParent_Done,
     /* 1199480 */   // Label 17421: @1199480
     /* 1199480 */   GIM_Try, /*On fail goto*//*Label 17422*/ GIMT_Encode4(1199560), // Rule ID 16878 //
     /* 1199485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1199493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1199496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1199499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1199502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199524 */     // MIs[0] round
     /* 1199524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199534 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1199537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199559 */     // GIR_Coverage, 16878,
     /* 1199559 */     GIR_EraseRootFromParent_Done,
     /* 1199560 */   // Label 17422: @1199560
     /* 1199560 */   GIM_Try, /*On fail goto*//*Label 17423*/ GIMT_Encode4(1199640), // Rule ID 16879 //
     /* 1199565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1199573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1199576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1199579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1199582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199604 */     // MIs[0] round
     /* 1199604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199614 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1199617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199639 */     // GIR_Coverage, 16879,
     /* 1199639 */     GIR_EraseRootFromParent_Done,
     /* 1199640 */   // Label 17423: @1199640
     /* 1199640 */   GIM_Try, /*On fail goto*//*Label 17424*/ GIMT_Encode4(1199720), // Rule ID 16882 //
     /* 1199645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1199648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1199653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1199656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1199659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1199662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199684 */     // MIs[0] round
     /* 1199684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199694 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1199697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199719 */     // GIR_Coverage, 16882,
     /* 1199719 */     GIR_EraseRootFromParent_Done,
     /* 1199720 */   // Label 17424: @1199720
     /* 1199720 */   GIM_Try, /*On fail goto*//*Label 17425*/ GIMT_Encode4(1199800), // Rule ID 16883 //
     /* 1199725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1199728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1199733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1199736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1199739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1199742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199764 */     // MIs[0] round
     /* 1199764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199774 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1199777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199799 */     // GIR_Coverage, 16883,
     /* 1199799 */     GIR_EraseRootFromParent_Done,
     /* 1199800 */   // Label 17425: @1199800
     /* 1199800 */   GIM_Try, /*On fail goto*//*Label 17426*/ GIMT_Encode4(1199880), // Rule ID 16886 //
     /* 1199805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1199813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1199816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1199819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1199822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199844 */     // MIs[0] round
     /* 1199844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199854 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1199857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199879 */     // GIR_Coverage, 16886,
     /* 1199879 */     GIR_EraseRootFromParent_Done,
     /* 1199880 */   // Label 17426: @1199880
     /* 1199880 */   GIM_Try, /*On fail goto*//*Label 17427*/ GIMT_Encode4(1199960), // Rule ID 16887 //
     /* 1199885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1199893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1199896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1199899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1199902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199924 */     // MIs[0] round
     /* 1199924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199934 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1199937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199959 */     // GIR_Coverage, 16887,
     /* 1199959 */     GIR_EraseRootFromParent_Done,
     /* 1199960 */   // Label 17427: @1199960
     /* 1199960 */   GIM_Try, /*On fail goto*//*Label 17428*/ GIMT_Encode4(1200040), // Rule ID 16890 //
     /* 1199965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1199968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1199973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1199976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1199979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1199982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200004 */     // MIs[0] round
     /* 1200004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200014 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1200017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200039 */     // GIR_Coverage, 16890,
     /* 1200039 */     GIR_EraseRootFromParent_Done,
     /* 1200040 */   // Label 17428: @1200040
     /* 1200040 */   GIM_Try, /*On fail goto*//*Label 17429*/ GIMT_Encode4(1200120), // Rule ID 16891 //
     /* 1200045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1200048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1200053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1200056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1200059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1200062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200084 */     // MIs[0] round
     /* 1200084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200094 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1200097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200119 */     // GIR_Coverage, 16891,
     /* 1200119 */     GIR_EraseRootFromParent_Done,
     /* 1200120 */   // Label 17429: @1200120
     /* 1200120 */   GIM_Try, /*On fail goto*//*Label 17430*/ GIMT_Encode4(1200200), // Rule ID 16894 //
     /* 1200125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1200128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1200133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1200136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1200139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1200142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1200145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1200164 */     // MIs[0] round
     /* 1200164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200174 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1200177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200199 */     // GIR_Coverage, 16894,
     /* 1200199 */     GIR_EraseRootFromParent_Done,
     /* 1200200 */   // Label 17430: @1200200
     /* 1200200 */   GIM_Try, /*On fail goto*//*Label 17431*/ GIMT_Encode4(1200280), // Rule ID 16895 //
     /* 1200205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1200208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1200213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1200216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1200219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1200222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1200225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1200244 */     // MIs[0] round
     /* 1200244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200254 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1200257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200279 */     // GIR_Coverage, 16895,
     /* 1200279 */     GIR_EraseRootFromParent_Done,
     /* 1200280 */   // Label 17431: @1200280
     /* 1200280 */   GIM_Try, /*On fail goto*//*Label 17432*/ GIMT_Encode4(1200360), // Rule ID 16898 //
     /* 1200285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1200288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1200293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1200296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1200299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1200302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1200305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1200324 */     // MIs[0] round
     /* 1200324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200334 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1200337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200359 */     // GIR_Coverage, 16898,
     /* 1200359 */     GIR_EraseRootFromParent_Done,
     /* 1200360 */   // Label 17432: @1200360
     /* 1200360 */   GIM_Try, /*On fail goto*//*Label 17433*/ GIMT_Encode4(1200440), // Rule ID 16899 //
     /* 1200365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1200368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1200373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1200376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1200379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1200382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1200385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1200404 */     // MIs[0] round
     /* 1200404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200414 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1200417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200439 */     // GIR_Coverage, 16899,
     /* 1200439 */     GIR_EraseRootFromParent_Done,
     /* 1200440 */   // Label 17433: @1200440
     /* 1200440 */   GIM_Try, /*On fail goto*//*Label 17434*/ GIMT_Encode4(1200520), // Rule ID 16902 //
     /* 1200445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1200448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1200453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1200456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1200459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1200462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1200465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1200484 */     // MIs[0] round
     /* 1200484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200494 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1200497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200519 */     // GIR_Coverage, 16902,
     /* 1200519 */     GIR_EraseRootFromParent_Done,
     /* 1200520 */   // Label 17434: @1200520
     /* 1200520 */   GIM_Try, /*On fail goto*//*Label 17435*/ GIMT_Encode4(1200600), // Rule ID 16903 //
     /* 1200525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1200528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1200533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1200536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1200539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1200542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1200545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1200564 */     // MIs[0] round
     /* 1200564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200574 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1200577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200599 */     // GIR_Coverage, 16903,
     /* 1200599 */     GIR_EraseRootFromParent_Done,
     /* 1200600 */   // Label 17435: @1200600
     /* 1200600 */   GIM_Try, /*On fail goto*//*Label 17436*/ GIMT_Encode4(1200680), // Rule ID 16906 //
     /* 1200605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1200608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1200613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1200616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1200619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1200622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1200644 */     // MIs[0] round
     /* 1200644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200654 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1200657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200679 */     // GIR_Coverage, 16906,
     /* 1200679 */     GIR_EraseRootFromParent_Done,
     /* 1200680 */   // Label 17436: @1200680
     /* 1200680 */   GIM_Try, /*On fail goto*//*Label 17437*/ GIMT_Encode4(1200760), // Rule ID 16907 //
     /* 1200685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1200688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1200693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1200696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1200699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1200702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1200724 */     // MIs[0] round
     /* 1200724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200734 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1200737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200759 */     // GIR_Coverage, 16907,
     /* 1200759 */     GIR_EraseRootFromParent_Done,
     /* 1200760 */   // Label 17437: @1200760
     /* 1200760 */   GIM_Try, /*On fail goto*//*Label 17438*/ GIMT_Encode4(1200840), // Rule ID 16910 //
     /* 1200765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1200768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1200773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1200776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1200779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1200782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1200804 */     // MIs[0] round
     /* 1200804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200814 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1200817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200839 */     // GIR_Coverage, 16910,
     /* 1200839 */     GIR_EraseRootFromParent_Done,
     /* 1200840 */   // Label 17438: @1200840
     /* 1200840 */   GIM_Try, /*On fail goto*//*Label 17439*/ GIMT_Encode4(1200920), // Rule ID 16911 //
     /* 1200845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1200848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1200853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1200856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1200859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1200862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1200884 */     // MIs[0] round
     /* 1200884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200894 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1200897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200919 */     // GIR_Coverage, 16911,
     /* 1200919 */     GIR_EraseRootFromParent_Done,
     /* 1200920 */   // Label 17439: @1200920
     /* 1200920 */   GIM_Try, /*On fail goto*//*Label 17440*/ GIMT_Encode4(1201000), // Rule ID 16914 //
     /* 1200925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1200928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1200933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1200936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1200939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1200942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1200964 */     // MIs[0] round
     /* 1200964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200974 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1200977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200999 */     // GIR_Coverage, 16914,
     /* 1200999 */     GIR_EraseRootFromParent_Done,
     /* 1201000 */   // Label 17440: @1201000
     /* 1201000 */   GIM_Try, /*On fail goto*//*Label 17441*/ GIMT_Encode4(1201080), // Rule ID 16915 //
     /* 1201005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1201008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1201013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1201016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1201019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1201022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1201025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1201044 */     // MIs[0] round
     /* 1201044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201054 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1201057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201079 */     // GIR_Coverage, 16915,
     /* 1201079 */     GIR_EraseRootFromParent_Done,
     /* 1201080 */   // Label 17441: @1201080
     /* 1201080 */   GIM_Try, /*On fail goto*//*Label 17442*/ GIMT_Encode4(1201160), // Rule ID 16918 //
     /* 1201085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1201088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1201093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1201096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1201099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1201102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1201105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1201124 */     // MIs[0] round
     /* 1201124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201134 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1201137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1201155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201159 */     // GIR_Coverage, 16918,
     /* 1201159 */     GIR_EraseRootFromParent_Done,
     /* 1201160 */   // Label 17442: @1201160
     /* 1201160 */   GIM_Try, /*On fail goto*//*Label 17443*/ GIMT_Encode4(1201240), // Rule ID 16919 //
     /* 1201165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1201168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1201173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1201176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1201179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1201182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1201185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1201204 */     // MIs[0] round
     /* 1201204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201214 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1201217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1201235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201239 */     // GIR_Coverage, 16919,
     /* 1201239 */     GIR_EraseRootFromParent_Done,
     /* 1201240 */   // Label 17443: @1201240
     /* 1201240 */   GIM_Try, /*On fail goto*//*Label 17444*/ GIMT_Encode4(1201320), // Rule ID 16922 //
     /* 1201245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1201248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1201253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1201256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1201259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1201262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1201265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1201284 */     // MIs[0] round
     /* 1201284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201294 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1201297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1201315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201319 */     // GIR_Coverage, 16922,
     /* 1201319 */     GIR_EraseRootFromParent_Done,
     /* 1201320 */   // Label 17444: @1201320
     /* 1201320 */   GIM_Try, /*On fail goto*//*Label 17445*/ GIMT_Encode4(1201400), // Rule ID 16923 //
     /* 1201325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1201328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1201333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1201336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1201339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1201342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1201345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1201364 */     // MIs[0] round
     /* 1201364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201374 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1201377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1201395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201399 */     // GIR_Coverage, 16923,
     /* 1201399 */     GIR_EraseRootFromParent_Done,
     /* 1201400 */   // Label 17445: @1201400
     /* 1201400 */   GIM_Try, /*On fail goto*//*Label 17446*/ GIMT_Encode4(1201480), // Rule ID 16926 //
     /* 1201405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1201408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1201413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1201422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1201425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1201444 */     // MIs[0] round
     /* 1201444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201454 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1201457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1201475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201479 */     // GIR_Coverage, 16926,
     /* 1201479 */     GIR_EraseRootFromParent_Done,
     /* 1201480 */   // Label 17446: @1201480
     /* 1201480 */   GIM_Try, /*On fail goto*//*Label 17447*/ GIMT_Encode4(1201560), // Rule ID 16927 //
     /* 1201485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1201488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1201493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1201502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1201505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1201524 */     // MIs[0] round
     /* 1201524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201534 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1201537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1201555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201559 */     // GIR_Coverage, 16927,
     /* 1201559 */     GIR_EraseRootFromParent_Done,
     /* 1201560 */   // Label 17447: @1201560
     /* 1201560 */   GIM_Try, /*On fail goto*//*Label 17448*/ GIMT_Encode4(1201640), // Rule ID 16930 //
     /* 1201565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1201568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1201573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1201576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1201579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1201582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201604 */     // MIs[0] round
     /* 1201604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201614 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1201617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201639 */     // GIR_Coverage, 16930,
     /* 1201639 */     GIR_EraseRootFromParent_Done,
     /* 1201640 */   // Label 17448: @1201640
     /* 1201640 */   GIM_Try, /*On fail goto*//*Label 17449*/ GIMT_Encode4(1201720), // Rule ID 16931 //
     /* 1201645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1201648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1201653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1201656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1201659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1201662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201684 */     // MIs[0] round
     /* 1201684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201694 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1201697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201719 */     // GIR_Coverage, 16931,
     /* 1201719 */     GIR_EraseRootFromParent_Done,
     /* 1201720 */   // Label 17449: @1201720
     /* 1201720 */   GIM_Try, /*On fail goto*//*Label 17450*/ GIMT_Encode4(1201800), // Rule ID 16934 //
     /* 1201725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1201728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1201733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1201736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1201739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1201742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201764 */     // MIs[0] round
     /* 1201764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201774 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1201777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201799 */     // GIR_Coverage, 16934,
     /* 1201799 */     GIR_EraseRootFromParent_Done,
     /* 1201800 */   // Label 17450: @1201800
     /* 1201800 */   GIM_Try, /*On fail goto*//*Label 17451*/ GIMT_Encode4(1201880), // Rule ID 16935 //
     /* 1201805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1201808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1201813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1201816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1201819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1201822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201844 */     // MIs[0] round
     /* 1201844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201854 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1201857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201879 */     // GIR_Coverage, 16935,
     /* 1201879 */     GIR_EraseRootFromParent_Done,
     /* 1201880 */   // Label 17451: @1201880
     /* 1201880 */   GIM_Try, /*On fail goto*//*Label 17452*/ GIMT_Encode4(1201960), // Rule ID 16938 //
     /* 1201885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1201888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1201893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1201896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1201899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1201902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1201905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1201924 */     // MIs[0] round
     /* 1201924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201934 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1201937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201959 */     // GIR_Coverage, 16938,
     /* 1201959 */     GIR_EraseRootFromParent_Done,
     /* 1201960 */   // Label 17452: @1201960
     /* 1201960 */   GIM_Try, /*On fail goto*//*Label 17453*/ GIMT_Encode4(1202040), // Rule ID 16939 //
     /* 1201965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1201968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1201973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1201976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1201979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1201982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1201985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202004 */     // MIs[0] round
     /* 1202004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202014 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1202017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202039 */     // GIR_Coverage, 16939,
     /* 1202039 */     GIR_EraseRootFromParent_Done,
     /* 1202040 */   // Label 17453: @1202040
     /* 1202040 */   GIM_Try, /*On fail goto*//*Label 17454*/ GIMT_Encode4(1202120), // Rule ID 16942 //
     /* 1202045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1202048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1202053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1202056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1202059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1202062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202084 */     // MIs[0] round
     /* 1202084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202094 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1202097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202119 */     // GIR_Coverage, 16942,
     /* 1202119 */     GIR_EraseRootFromParent_Done,
     /* 1202120 */   // Label 17454: @1202120
     /* 1202120 */   GIM_Try, /*On fail goto*//*Label 17455*/ GIMT_Encode4(1202200), // Rule ID 16943 //
     /* 1202125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1202128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1202133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1202136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1202139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1202142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202164 */     // MIs[0] round
     /* 1202164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202174 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1202177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202199 */     // GIR_Coverage, 16943,
     /* 1202199 */     GIR_EraseRootFromParent_Done,
     /* 1202200 */   // Label 17455: @1202200
     /* 1202200 */   GIM_Try, /*On fail goto*//*Label 17456*/ GIMT_Encode4(1202280), // Rule ID 16946 //
     /* 1202205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1202208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1202213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1202216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1202219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1202222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202244 */     // MIs[0] round
     /* 1202244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202254 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1202257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202279 */     // GIR_Coverage, 16946,
     /* 1202279 */     GIR_EraseRootFromParent_Done,
     /* 1202280 */   // Label 17456: @1202280
     /* 1202280 */   GIM_Try, /*On fail goto*//*Label 17457*/ GIMT_Encode4(1202360), // Rule ID 16947 //
     /* 1202285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1202288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1202293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1202296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1202299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1202302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202324 */     // MIs[0] round
     /* 1202324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202334 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1202337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202359 */     // GIR_Coverage, 16947,
     /* 1202359 */     GIR_EraseRootFromParent_Done,
     /* 1202360 */   // Label 17457: @1202360
     /* 1202360 */   GIM_Try, /*On fail goto*//*Label 17458*/ GIMT_Encode4(1202440), // Rule ID 16950 //
     /* 1202365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1202368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1202373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1202376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1202379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1202382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1202385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1202404 */     // MIs[0] round
     /* 1202404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202414 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1202417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1202435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202439 */     // GIR_Coverage, 16950,
     /* 1202439 */     GIR_EraseRootFromParent_Done,
     /* 1202440 */   // Label 17458: @1202440
     /* 1202440 */   GIM_Try, /*On fail goto*//*Label 17459*/ GIMT_Encode4(1202520), // Rule ID 16951 //
     /* 1202445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1202448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1202453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1202456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1202459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1202462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1202465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1202484 */     // MIs[0] round
     /* 1202484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202494 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1202497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1202515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202519 */     // GIR_Coverage, 16951,
     /* 1202519 */     GIR_EraseRootFromParent_Done,
     /* 1202520 */   // Label 17459: @1202520
     /* 1202520 */   GIM_Try, /*On fail goto*//*Label 17460*/ GIMT_Encode4(1202600), // Rule ID 16954 //
     /* 1202525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1202528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1202533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1202536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1202539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1202542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202564 */     // MIs[0] round
     /* 1202564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202574 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1202577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202599 */     // GIR_Coverage, 16954,
     /* 1202599 */     GIR_EraseRootFromParent_Done,
     /* 1202600 */   // Label 17460: @1202600
     /* 1202600 */   GIM_Try, /*On fail goto*//*Label 17461*/ GIMT_Encode4(1202680), // Rule ID 16955 //
     /* 1202605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1202608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1202613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1202616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1202619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1202622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202644 */     // MIs[0] round
     /* 1202644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202654 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1202657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202679 */     // GIR_Coverage, 16955,
     /* 1202679 */     GIR_EraseRootFromParent_Done,
     /* 1202680 */   // Label 17461: @1202680
     /* 1202680 */   GIM_Try, /*On fail goto*//*Label 17462*/ GIMT_Encode4(1202760), // Rule ID 16958 //
     /* 1202685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1202688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1202693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1202696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1202699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1202702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202724 */     // MIs[0] round
     /* 1202724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202734 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1202737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202759 */     // GIR_Coverage, 16958,
     /* 1202759 */     GIR_EraseRootFromParent_Done,
     /* 1202760 */   // Label 17462: @1202760
     /* 1202760 */   GIM_Try, /*On fail goto*//*Label 17463*/ GIMT_Encode4(1202840), // Rule ID 16959 //
     /* 1202765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1202768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1202773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1202776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1202779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1202782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202804 */     // MIs[0] round
     /* 1202804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202814 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1202817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202839 */     // GIR_Coverage, 16959,
     /* 1202839 */     GIR_EraseRootFromParent_Done,
     /* 1202840 */   // Label 17463: @1202840
     /* 1202840 */   GIM_Try, /*On fail goto*//*Label 17464*/ GIMT_Encode4(1202920), // Rule ID 16962 //
     /* 1202845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1202848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1202853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1202856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1202859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1202862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202884 */     // MIs[0] round
     /* 1202884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202894 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1202897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202919 */     // GIR_Coverage, 16962,
     /* 1202919 */     GIR_EraseRootFromParent_Done,
     /* 1202920 */   // Label 17464: @1202920
     /* 1202920 */   GIM_Try, /*On fail goto*//*Label 17465*/ GIMT_Encode4(1203000), // Rule ID 16963 //
     /* 1202925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1202928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1202933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1202936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1202939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1202942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202964 */     // MIs[0] round
     /* 1202964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202974 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1202977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202999 */     // GIR_Coverage, 16963,
     /* 1202999 */     GIR_EraseRootFromParent_Done,
     /* 1203000 */   // Label 17465: @1203000
     /* 1203000 */   GIM_Try, /*On fail goto*//*Label 17466*/ GIMT_Encode4(1203080), // Rule ID 16966 //
     /* 1203005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1203008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1203013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1203016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1203019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1203022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203044 */     // MIs[0] round
     /* 1203044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203054 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1203057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203079 */     // GIR_Coverage, 16966,
     /* 1203079 */     GIR_EraseRootFromParent_Done,
     /* 1203080 */   // Label 17466: @1203080
     /* 1203080 */   GIM_Try, /*On fail goto*//*Label 17467*/ GIMT_Encode4(1203160), // Rule ID 16967 //
     /* 1203085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1203088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1203093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1203096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1203099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1203102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203124 */     // MIs[0] round
     /* 1203124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203134 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1203137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203159 */     // GIR_Coverage, 16967,
     /* 1203159 */     GIR_EraseRootFromParent_Done,
     /* 1203160 */   // Label 17467: @1203160
     /* 1203160 */   GIM_Try, /*On fail goto*//*Label 17468*/ GIMT_Encode4(1203240), // Rule ID 16970 //
     /* 1203165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1203168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1203173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1203176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1203179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1203182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203204 */     // MIs[0] round
     /* 1203204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203214 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1203217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203239 */     // GIR_Coverage, 16970,
     /* 1203239 */     GIR_EraseRootFromParent_Done,
     /* 1203240 */   // Label 17468: @1203240
     /* 1203240 */   GIM_Try, /*On fail goto*//*Label 17469*/ GIMT_Encode4(1203320), // Rule ID 16971 //
     /* 1203245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1203248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1203253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1203256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1203259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1203262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203284 */     // MIs[0] round
     /* 1203284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203294 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1203297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203319 */     // GIR_Coverage, 16971,
     /* 1203319 */     GIR_EraseRootFromParent_Done,
     /* 1203320 */   // Label 17469: @1203320
     /* 1203320 */   GIM_Try, /*On fail goto*//*Label 17470*/ GIMT_Encode4(1203400), // Rule ID 16974 //
     /* 1203325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1203328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1203333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1203336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1203339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1203342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203364 */     // MIs[0] round
     /* 1203364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203374 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1203377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203399 */     // GIR_Coverage, 16974,
     /* 1203399 */     GIR_EraseRootFromParent_Done,
     /* 1203400 */   // Label 17470: @1203400
     /* 1203400 */   GIM_Try, /*On fail goto*//*Label 17471*/ GIMT_Encode4(1203480), // Rule ID 16975 //
     /* 1203405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1203408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1203413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1203416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1203419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1203422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203444 */     // MIs[0] round
     /* 1203444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203454 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1203457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203479 */     // GIR_Coverage, 16975,
     /* 1203479 */     GIR_EraseRootFromParent_Done,
     /* 1203480 */   // Label 17471: @1203480
     /* 1203480 */   GIM_Try, /*On fail goto*//*Label 17472*/ GIMT_Encode4(1203560), // Rule ID 16978 //
     /* 1203485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1203488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1203493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1203496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1203499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1203502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1203505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1203524 */     // MIs[0] round
     /* 1203524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203534 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1203537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1203555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203559 */     // GIR_Coverage, 16978,
     /* 1203559 */     GIR_EraseRootFromParent_Done,
     /* 1203560 */   // Label 17472: @1203560
     /* 1203560 */   GIM_Try, /*On fail goto*//*Label 17473*/ GIMT_Encode4(1203640), // Rule ID 16979 //
     /* 1203565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1203568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1203573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1203576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1203579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1203582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1203585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1203604 */     // MIs[0] round
     /* 1203604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203614 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1203617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1203635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203639 */     // GIR_Coverage, 16979,
     /* 1203639 */     GIR_EraseRootFromParent_Done,
     /* 1203640 */   // Label 17473: @1203640
     /* 1203640 */   GIM_Try, /*On fail goto*//*Label 17474*/ GIMT_Encode4(1203720), // Rule ID 16982 //
     /* 1203645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1203648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1203653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1203656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1203659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1203662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1203665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1203684 */     // MIs[0] round
     /* 1203684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203694 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1203697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1203715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203719 */     // GIR_Coverage, 16982,
     /* 1203719 */     GIR_EraseRootFromParent_Done,
     /* 1203720 */   // Label 17474: @1203720
     /* 1203720 */   GIM_Try, /*On fail goto*//*Label 17475*/ GIMT_Encode4(1203800), // Rule ID 16983 //
     /* 1203725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1203728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1203733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1203736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1203739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1203742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1203745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1203764 */     // MIs[0] round
     /* 1203764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203774 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1203777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1203795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203799 */     // GIR_Coverage, 16983,
     /* 1203799 */     GIR_EraseRootFromParent_Done,
     /* 1203800 */   // Label 17475: @1203800
     /* 1203800 */   GIM_Try, /*On fail goto*//*Label 17476*/ GIMT_Encode4(1203880), // Rule ID 16986 //
     /* 1203805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1203808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1203813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1203816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1203819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1203822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1203825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1203844 */     // MIs[0] round
     /* 1203844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203854 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1203857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1203875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203879 */     // GIR_Coverage, 16986,
     /* 1203879 */     GIR_EraseRootFromParent_Done,
     /* 1203880 */   // Label 17476: @1203880
     /* 1203880 */   GIM_Try, /*On fail goto*//*Label 17477*/ GIMT_Encode4(1203960), // Rule ID 16987 //
     /* 1203885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1203888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1203893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1203896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1203899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1203902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1203905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1203924 */     // MIs[0] round
     /* 1203924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203934 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1203937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1203955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203959 */     // GIR_Coverage, 16987,
     /* 1203959 */     GIR_EraseRootFromParent_Done,
     /* 1203960 */   // Label 17477: @1203960
     /* 1203960 */   GIM_Try, /*On fail goto*//*Label 17478*/ GIMT_Encode4(1204040), // Rule ID 16990 //
     /* 1203965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1203973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1203976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1203979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1203982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1203985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204004 */     // MIs[0] round
     /* 1204004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204014 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1204017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204039 */     // GIR_Coverage, 16990,
     /* 1204039 */     GIR_EraseRootFromParent_Done,
     /* 1204040 */   // Label 17478: @1204040
     /* 1204040 */   GIM_Try, /*On fail goto*//*Label 17479*/ GIMT_Encode4(1204120), // Rule ID 16991 //
     /* 1204045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1204053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1204056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1204059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1204062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1204065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204084 */     // MIs[0] round
     /* 1204084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204094 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1204097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204119 */     // GIR_Coverage, 16991,
     /* 1204119 */     GIR_EraseRootFromParent_Done,
     /* 1204120 */   // Label 17479: @1204120
     /* 1204120 */   GIM_Try, /*On fail goto*//*Label 17480*/ GIMT_Encode4(1204200), // Rule ID 16994 //
     /* 1204125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1204133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1204136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1204139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1204142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1204145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204164 */     // MIs[0] round
     /* 1204164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204174 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1204177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204199 */     // GIR_Coverage, 16994,
     /* 1204199 */     GIR_EraseRootFromParent_Done,
     /* 1204200 */   // Label 17480: @1204200
     /* 1204200 */   GIM_Try, /*On fail goto*//*Label 17481*/ GIMT_Encode4(1204280), // Rule ID 16995 //
     /* 1204205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1204213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1204216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1204219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1204222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1204225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204244 */     // MIs[0] round
     /* 1204244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204254 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1204257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204279 */     // GIR_Coverage, 16995,
     /* 1204279 */     GIR_EraseRootFromParent_Done,
     /* 1204280 */   // Label 17481: @1204280
     /* 1204280 */   GIM_Try, /*On fail goto*//*Label 17482*/ GIMT_Encode4(1204360), // Rule ID 16998 //
     /* 1204285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1204293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1204296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1204299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1204302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1204305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204324 */     // MIs[0] round
     /* 1204324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204334 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1204337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204359 */     // GIR_Coverage, 16998,
     /* 1204359 */     GIR_EraseRootFromParent_Done,
     /* 1204360 */   // Label 17482: @1204360
     /* 1204360 */   GIM_Try, /*On fail goto*//*Label 17483*/ GIMT_Encode4(1204440), // Rule ID 16999 //
     /* 1204365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1204373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1204376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1204379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1204382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1204385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204404 */     // MIs[0] round
     /* 1204404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204414 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1204417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204439 */     // GIR_Coverage, 16999,
     /* 1204439 */     GIR_EraseRootFromParent_Done,
     /* 1204440 */   // Label 17483: @1204440
     /* 1204440 */   GIM_Try, /*On fail goto*//*Label 17484*/ GIMT_Encode4(1204520), // Rule ID 17002 //
     /* 1204445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1204453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1204456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1204459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1204462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1204465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204484 */     // MIs[0] round
     /* 1204484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204494 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1204497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204519 */     // GIR_Coverage, 17002,
     /* 1204519 */     GIR_EraseRootFromParent_Done,
     /* 1204520 */   // Label 17484: @1204520
     /* 1204520 */   GIM_Try, /*On fail goto*//*Label 17485*/ GIMT_Encode4(1204600), // Rule ID 17003 //
     /* 1204525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1204533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1204536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1204539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1204542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1204545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204564 */     // MIs[0] round
     /* 1204564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204574 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1204577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204599 */     // GIR_Coverage, 17003,
     /* 1204599 */     GIR_EraseRootFromParent_Done,
     /* 1204600 */   // Label 17485: @1204600
     /* 1204600 */   GIM_Try, /*On fail goto*//*Label 17486*/ GIMT_Encode4(1204680), // Rule ID 17006 //
     /* 1204605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1204613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1204616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1204619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1204622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1204625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204644 */     // MIs[0] round
     /* 1204644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204654 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1204657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204679 */     // GIR_Coverage, 17006,
     /* 1204679 */     GIR_EraseRootFromParent_Done,
     /* 1204680 */   // Label 17486: @1204680
     /* 1204680 */   GIM_Try, /*On fail goto*//*Label 17487*/ GIMT_Encode4(1204760), // Rule ID 17007 //
     /* 1204685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1204693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1204696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1204699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1204702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1204705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204724 */     // MIs[0] round
     /* 1204724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204734 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1204737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204759 */     // GIR_Coverage, 17007,
     /* 1204759 */     GIR_EraseRootFromParent_Done,
     /* 1204760 */   // Label 17487: @1204760
     /* 1204760 */   GIM_Try, /*On fail goto*//*Label 17488*/ GIMT_Encode4(1204840), // Rule ID 17010 //
     /* 1204765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1204773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1204776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1204779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1204782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1204785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204804 */     // MIs[0] round
     /* 1204804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204814 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1204817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204839 */     // GIR_Coverage, 17010,
     /* 1204839 */     GIR_EraseRootFromParent_Done,
     /* 1204840 */   // Label 17488: @1204840
     /* 1204840 */   GIM_Try, /*On fail goto*//*Label 17489*/ GIMT_Encode4(1204920), // Rule ID 17011 //
     /* 1204845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1204853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1204856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1204859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1204862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1204865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204884 */     // MIs[0] round
     /* 1204884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204894 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1204897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204919 */     // GIR_Coverage, 17011,
     /* 1204919 */     GIR_EraseRootFromParent_Done,
     /* 1204920 */   // Label 17489: @1204920
     /* 1204920 */   GIM_Try, /*On fail goto*//*Label 17490*/ GIMT_Encode4(1205000), // Rule ID 17014 //
     /* 1204925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1204933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1204936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1204939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1204942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1204945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204964 */     // MIs[0] round
     /* 1204964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204974 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1204977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204999 */     // GIR_Coverage, 17014,
     /* 1204999 */     GIR_EraseRootFromParent_Done,
     /* 1205000 */   // Label 17490: @1205000
     /* 1205000 */   GIM_Try, /*On fail goto*//*Label 17491*/ GIMT_Encode4(1205080), // Rule ID 17015 //
     /* 1205005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1205013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1205016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1205019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1205025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205044 */     // MIs[0] round
     /* 1205044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205054 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1205057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205079 */     // GIR_Coverage, 17015,
     /* 1205079 */     GIR_EraseRootFromParent_Done,
     /* 1205080 */   // Label 17491: @1205080
     /* 1205080 */   GIM_Try, /*On fail goto*//*Label 17492*/ GIMT_Encode4(1205160), // Rule ID 17018 //
     /* 1205085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1205093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1205096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1205099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1205102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1205105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205124 */     // MIs[0] round
     /* 1205124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205134 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1205137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205159 */     // GIR_Coverage, 17018,
     /* 1205159 */     GIR_EraseRootFromParent_Done,
     /* 1205160 */   // Label 17492: @1205160
     /* 1205160 */   GIM_Try, /*On fail goto*//*Label 17493*/ GIMT_Encode4(1205240), // Rule ID 17019 //
     /* 1205165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1205173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1205176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1205179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1205182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1205185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205204 */     // MIs[0] round
     /* 1205204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205214 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1205217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205239 */     // GIR_Coverage, 17019,
     /* 1205239 */     GIR_EraseRootFromParent_Done,
     /* 1205240 */   // Label 17493: @1205240
     /* 1205240 */   GIM_Try, /*On fail goto*//*Label 17494*/ GIMT_Encode4(1205320), // Rule ID 17022 //
     /* 1205245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1205253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1205256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1205259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1205262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1205265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205284 */     // MIs[0] round
     /* 1205284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205294 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1205297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205319 */     // GIR_Coverage, 17022,
     /* 1205319 */     GIR_EraseRootFromParent_Done,
     /* 1205320 */   // Label 17494: @1205320
     /* 1205320 */   GIM_Try, /*On fail goto*//*Label 17495*/ GIMT_Encode4(1205400), // Rule ID 17023 //
     /* 1205325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1205333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1205336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1205339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1205342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1205345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205364 */     // MIs[0] round
     /* 1205364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205374 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1205377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205399 */     // GIR_Coverage, 17023,
     /* 1205399 */     GIR_EraseRootFromParent_Done,
     /* 1205400 */   // Label 17495: @1205400
     /* 1205400 */   GIM_Try, /*On fail goto*//*Label 17496*/ GIMT_Encode4(1205480), // Rule ID 17026 //
     /* 1205405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1205413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1205416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1205419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1205422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205444 */     // MIs[0] round
     /* 1205444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205454 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1205457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205479 */     // GIR_Coverage, 17026,
     /* 1205479 */     GIR_EraseRootFromParent_Done,
     /* 1205480 */   // Label 17496: @1205480
     /* 1205480 */   GIM_Try, /*On fail goto*//*Label 17497*/ GIMT_Encode4(1205560), // Rule ID 17027 //
     /* 1205485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1205493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1205496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1205499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1205502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205524 */     // MIs[0] round
     /* 1205524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205534 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1205537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205559 */     // GIR_Coverage, 17027,
     /* 1205559 */     GIR_EraseRootFromParent_Done,
     /* 1205560 */   // Label 17497: @1205560
     /* 1205560 */   GIM_Try, /*On fail goto*//*Label 17498*/ GIMT_Encode4(1205640), // Rule ID 17030 //
     /* 1205565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1205573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1205582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205604 */     // MIs[0] round
     /* 1205604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205614 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1205617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205639 */     // GIR_Coverage, 17030,
     /* 1205639 */     GIR_EraseRootFromParent_Done,
     /* 1205640 */   // Label 17498: @1205640
     /* 1205640 */   GIM_Try, /*On fail goto*//*Label 17499*/ GIMT_Encode4(1205720), // Rule ID 17031 //
     /* 1205645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1205653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1205662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205684 */     // MIs[0] round
     /* 1205684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205694 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1205697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205719 */     // GIR_Coverage, 17031,
     /* 1205719 */     GIR_EraseRootFromParent_Done,
     /* 1205720 */   // Label 17499: @1205720
     /* 1205720 */   GIM_Try, /*On fail goto*//*Label 17500*/ GIMT_Encode4(1205800), // Rule ID 17034 //
     /* 1205725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1205733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1205736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1205739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1205742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205764 */     // MIs[0] round
     /* 1205764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205774 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1205777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205799 */     // GIR_Coverage, 17034,
     /* 1205799 */     GIR_EraseRootFromParent_Done,
     /* 1205800 */   // Label 17500: @1205800
     /* 1205800 */   GIM_Try, /*On fail goto*//*Label 17501*/ GIMT_Encode4(1205880), // Rule ID 17035 //
     /* 1205805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1205813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1205816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1205819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1205822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205844 */     // MIs[0] round
     /* 1205844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205854 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1205857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205879 */     // GIR_Coverage, 17035,
     /* 1205879 */     GIR_EraseRootFromParent_Done,
     /* 1205880 */   // Label 17501: @1205880
     /* 1205880 */   GIM_Try, /*On fail goto*//*Label 17502*/ GIMT_Encode4(1205960), // Rule ID 17038 //
     /* 1205885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1205893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1205896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1205899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1205902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205924 */     // MIs[0] round
     /* 1205924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205934 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1205937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205959 */     // GIR_Coverage, 17038,
     /* 1205959 */     GIR_EraseRootFromParent_Done,
     /* 1205960 */   // Label 17502: @1205960
     /* 1205960 */   GIM_Try, /*On fail goto*//*Label 17503*/ GIMT_Encode4(1206040), // Rule ID 17039 //
     /* 1205965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1205973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1205976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1205979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1205982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1206004 */     // MIs[0] round
     /* 1206004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206014 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1206017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206039 */     // GIR_Coverage, 17039,
     /* 1206039 */     GIR_EraseRootFromParent_Done,
     /* 1206040 */   // Label 17503: @1206040
     /* 1206040 */   GIM_Try, /*On fail goto*//*Label 17504*/ GIMT_Encode4(1206120), // Rule ID 17042 //
     /* 1206045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1206053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1206062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1206065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1206084 */     // MIs[0] round
     /* 1206084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206094 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1206097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206119 */     // GIR_Coverage, 17042,
     /* 1206119 */     GIR_EraseRootFromParent_Done,
     /* 1206120 */   // Label 17504: @1206120
     /* 1206120 */   GIM_Try, /*On fail goto*//*Label 17505*/ GIMT_Encode4(1206200), // Rule ID 17043 //
     /* 1206125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1206133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1206142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1206145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1206164 */     // MIs[0] round
     /* 1206164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206174 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1206177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206199 */     // GIR_Coverage, 17043,
     /* 1206199 */     GIR_EraseRootFromParent_Done,
     /* 1206200 */   // Label 17505: @1206200
     /* 1206200 */   GIM_Try, /*On fail goto*//*Label 17506*/ GIMT_Encode4(1206280), // Rule ID 17046 //
     /* 1206205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1206213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1206216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1206219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1206222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206244 */     // MIs[0] round
     /* 1206244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206254 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1206257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206279 */     // GIR_Coverage, 17046,
     /* 1206279 */     GIR_EraseRootFromParent_Done,
     /* 1206280 */   // Label 17506: @1206280
     /* 1206280 */   GIM_Try, /*On fail goto*//*Label 17507*/ GIMT_Encode4(1206360), // Rule ID 17047 //
     /* 1206285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1206293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1206296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1206299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1206302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206324 */     // MIs[0] round
     /* 1206324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206334 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1206337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206359 */     // GIR_Coverage, 17047,
     /* 1206359 */     GIR_EraseRootFromParent_Done,
     /* 1206360 */   // Label 17507: @1206360
     /* 1206360 */   GIM_Try, /*On fail goto*//*Label 17508*/ GIMT_Encode4(1206440), // Rule ID 17050 //
     /* 1206365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1206373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1206376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1206379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1206382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206404 */     // MIs[0] round
     /* 1206404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206414 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1206417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206439 */     // GIR_Coverage, 17050,
     /* 1206439 */     GIR_EraseRootFromParent_Done,
     /* 1206440 */   // Label 17508: @1206440
     /* 1206440 */   GIM_Try, /*On fail goto*//*Label 17509*/ GIMT_Encode4(1206520), // Rule ID 17051 //
     /* 1206445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1206453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1206456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1206459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1206462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206484 */     // MIs[0] round
     /* 1206484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206494 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1206497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206519 */     // GIR_Coverage, 17051,
     /* 1206519 */     GIR_EraseRootFromParent_Done,
     /* 1206520 */   // Label 17509: @1206520
     /* 1206520 */   GIM_Try, /*On fail goto*//*Label 17510*/ GIMT_Encode4(1206600), // Rule ID 17054 //
     /* 1206525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1206533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206564 */     // MIs[0] round
     /* 1206564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206574 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1206577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206599 */     // GIR_Coverage, 17054,
     /* 1206599 */     GIR_EraseRootFromParent_Done,
     /* 1206600 */   // Label 17510: @1206600
     /* 1206600 */   GIM_Try, /*On fail goto*//*Label 17511*/ GIMT_Encode4(1206680), // Rule ID 17055 //
     /* 1206605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1206613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206644 */     // MIs[0] round
     /* 1206644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206654 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1206657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206679 */     // GIR_Coverage, 17055,
     /* 1206679 */     GIR_EraseRootFromParent_Done,
     /* 1206680 */   // Label 17511: @1206680
     /* 1206680 */   GIM_Try, /*On fail goto*//*Label 17512*/ GIMT_Encode4(1206760), // Rule ID 17058 //
     /* 1206685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1206693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1206696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1206699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206724 */     // MIs[0] round
     /* 1206724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206734 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1206737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206759 */     // GIR_Coverage, 17058,
     /* 1206759 */     GIR_EraseRootFromParent_Done,
     /* 1206760 */   // Label 17512: @1206760
     /* 1206760 */   GIM_Try, /*On fail goto*//*Label 17513*/ GIMT_Encode4(1206840), // Rule ID 17059 //
     /* 1206765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1206773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1206776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1206779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206804 */     // MIs[0] round
     /* 1206804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206814 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1206817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206839 */     // GIR_Coverage, 17059,
     /* 1206839 */     GIR_EraseRootFromParent_Done,
     /* 1206840 */   // Label 17513: @1206840
     /* 1206840 */   GIM_Try, /*On fail goto*//*Label 17514*/ GIMT_Encode4(1206920), // Rule ID 17062 //
     /* 1206845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1206853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1206856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1206859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1206862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1206865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206884 */     // MIs[0] round
     /* 1206884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206894 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1206897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206919 */     // GIR_Coverage, 17062,
     /* 1206919 */     GIR_EraseRootFromParent_Done,
     /* 1206920 */   // Label 17514: @1206920
     /* 1206920 */   GIM_Try, /*On fail goto*//*Label 17515*/ GIMT_Encode4(1207000), // Rule ID 17063 //
     /* 1206925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1206933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1206936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1206939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1206942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1206945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206964 */     // MIs[0] round
     /* 1206964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206974 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1206977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206999 */     // GIR_Coverage, 17063,
     /* 1206999 */     GIR_EraseRootFromParent_Done,
     /* 1207000 */   // Label 17515: @1207000
     /* 1207000 */   GIM_Try, /*On fail goto*//*Label 17516*/ GIMT_Encode4(1207080), // Rule ID 17066 //
     /* 1207005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1207013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1207022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1207025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207044 */     // MIs[0] round
     /* 1207044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207054 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1207057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207079 */     // GIR_Coverage, 17066,
     /* 1207079 */     GIR_EraseRootFromParent_Done,
     /* 1207080 */   // Label 17516: @1207080
     /* 1207080 */   GIM_Try, /*On fail goto*//*Label 17517*/ GIMT_Encode4(1207160), // Rule ID 17067 //
     /* 1207085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1207093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1207102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1207105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207124 */     // MIs[0] round
     /* 1207124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207134 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1207137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207159 */     // GIR_Coverage, 17067,
     /* 1207159 */     GIR_EraseRootFromParent_Done,
     /* 1207160 */   // Label 17517: @1207160
     /* 1207160 */   GIM_Try, /*On fail goto*//*Label 17518*/ GIMT_Encode4(1207240), // Rule ID 17070 //
     /* 1207165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1207173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1207176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1207179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1207182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1207185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207204 */     // MIs[0] round
     /* 1207204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207214 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1207217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207239 */     // GIR_Coverage, 17070,
     /* 1207239 */     GIR_EraseRootFromParent_Done,
     /* 1207240 */   // Label 17518: @1207240
     /* 1207240 */   GIM_Try, /*On fail goto*//*Label 17519*/ GIMT_Encode4(1207320), // Rule ID 17071 //
     /* 1207245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1207253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1207256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1207259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1207262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1207265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207284 */     // MIs[0] round
     /* 1207284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207294 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1207297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207319 */     // GIR_Coverage, 17071,
     /* 1207319 */     GIR_EraseRootFromParent_Done,
     /* 1207320 */   // Label 17519: @1207320
     /* 1207320 */   GIM_Try, /*On fail goto*//*Label 17520*/ GIMT_Encode4(1207400), // Rule ID 17074 //
     /* 1207325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1207333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1207336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1207339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1207342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1207345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207364 */     // MIs[0] round
     /* 1207364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207374 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1207377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207399 */     // GIR_Coverage, 17074,
     /* 1207399 */     GIR_EraseRootFromParent_Done,
     /* 1207400 */   // Label 17520: @1207400
     /* 1207400 */   GIM_Try, /*On fail goto*//*Label 17521*/ GIMT_Encode4(1207480), // Rule ID 17075 //
     /* 1207405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1207413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1207416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1207419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1207422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1207425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207444 */     // MIs[0] round
     /* 1207444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207454 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1207457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207479 */     // GIR_Coverage, 17075,
     /* 1207479 */     GIR_EraseRootFromParent_Done,
     /* 1207480 */   // Label 17521: @1207480
     /* 1207480 */   GIM_Try, /*On fail goto*//*Label 17522*/ GIMT_Encode4(1207560), // Rule ID 17078 //
     /* 1207485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1207493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1207496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1207499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1207502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1207505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207524 */     // MIs[0] round
     /* 1207524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207534 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1207537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207559 */     // GIR_Coverage, 17078,
     /* 1207559 */     GIR_EraseRootFromParent_Done,
     /* 1207560 */   // Label 17522: @1207560
     /* 1207560 */   GIM_Try, /*On fail goto*//*Label 17523*/ GIMT_Encode4(1207640), // Rule ID 17079 //
     /* 1207565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1207573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1207576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1207579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1207582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1207585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207604 */     // MIs[0] round
     /* 1207604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207614 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1207617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207639 */     // GIR_Coverage, 17079,
     /* 1207639 */     GIR_EraseRootFromParent_Done,
     /* 1207640 */   // Label 17523: @1207640
     /* 1207640 */   GIM_Try, /*On fail goto*//*Label 17524*/ GIMT_Encode4(1207720), // Rule ID 17082 //
     /* 1207645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1207653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1207656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1207659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1207662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1207665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207684 */     // MIs[0] round
     /* 1207684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207694 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1207697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207719 */     // GIR_Coverage, 17082,
     /* 1207719 */     GIR_EraseRootFromParent_Done,
     /* 1207720 */   // Label 17524: @1207720
     /* 1207720 */   GIM_Try, /*On fail goto*//*Label 17525*/ GIMT_Encode4(1207800), // Rule ID 17083 //
     /* 1207725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1207733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1207736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1207739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1207742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1207745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207764 */     // MIs[0] round
     /* 1207764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207774 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1207777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207799 */     // GIR_Coverage, 17083,
     /* 1207799 */     GIR_EraseRootFromParent_Done,
     /* 1207800 */   // Label 17525: @1207800
     /* 1207800 */   GIM_Try, /*On fail goto*//*Label 17526*/ GIMT_Encode4(1207880), // Rule ID 17086 //
     /* 1207805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1207813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1207816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1207819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1207825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207844 */     // MIs[0] round
     /* 1207844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207854 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1207857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207879 */     // GIR_Coverage, 17086,
     /* 1207879 */     GIR_EraseRootFromParent_Done,
     /* 1207880 */   // Label 17526: @1207880
     /* 1207880 */   GIM_Try, /*On fail goto*//*Label 17527*/ GIMT_Encode4(1207960), // Rule ID 17087 //
     /* 1207885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1207893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1207896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1207899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1207905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207924 */     // MIs[0] round
     /* 1207924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207934 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1207937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207959 */     // GIR_Coverage, 17087,
     /* 1207959 */     GIR_EraseRootFromParent_Done,
     /* 1207960 */   // Label 17527: @1207960
     /* 1207960 */   GIM_Try, /*On fail goto*//*Label 17528*/ GIMT_Encode4(1208040), // Rule ID 17090 //
     /* 1207965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1207973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1207976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1207979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1207982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1207985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208004 */     // MIs[0] round
     /* 1208004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208014 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1208017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208039 */     // GIR_Coverage, 17090,
     /* 1208039 */     GIR_EraseRootFromParent_Done,
     /* 1208040 */   // Label 17528: @1208040
     /* 1208040 */   GIM_Try, /*On fail goto*//*Label 17529*/ GIMT_Encode4(1208120), // Rule ID 17091 //
     /* 1208045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1208053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1208056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1208059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1208062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1208065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208084 */     // MIs[0] round
     /* 1208084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208094 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1208097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208119 */     // GIR_Coverage, 17091,
     /* 1208119 */     GIR_EraseRootFromParent_Done,
     /* 1208120 */   // Label 17529: @1208120
     /* 1208120 */   GIM_Try, /*On fail goto*//*Label 17530*/ GIMT_Encode4(1208200), // Rule ID 17094 //
     /* 1208125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1208133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1208136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1208139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1208142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1208145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208164 */     // MIs[0] round
     /* 1208164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208174 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1208177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208199 */     // GIR_Coverage, 17094,
     /* 1208199 */     GIR_EraseRootFromParent_Done,
     /* 1208200 */   // Label 17530: @1208200
     /* 1208200 */   GIM_Try, /*On fail goto*//*Label 17531*/ GIMT_Encode4(1208280), // Rule ID 17095 //
     /* 1208205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1208213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1208216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1208219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1208222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1208225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208244 */     // MIs[0] round
     /* 1208244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208254 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1208257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208279 */     // GIR_Coverage, 17095,
     /* 1208279 */     GIR_EraseRootFromParent_Done,
     /* 1208280 */   // Label 17531: @1208280
     /* 1208280 */   GIM_Try, /*On fail goto*//*Label 17532*/ GIMT_Encode4(1208360), // Rule ID 17098 //
     /* 1208285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1208293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1208296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1208299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1208302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208324 */     // MIs[0] round
     /* 1208324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208334 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1208337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208359 */     // GIR_Coverage, 17098,
     /* 1208359 */     GIR_EraseRootFromParent_Done,
     /* 1208360 */   // Label 17532: @1208360
     /* 1208360 */   GIM_Try, /*On fail goto*//*Label 17533*/ GIMT_Encode4(1208440), // Rule ID 17099 //
     /* 1208365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1208373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1208376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1208379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1208382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208404 */     // MIs[0] round
     /* 1208404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208414 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1208417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208439 */     // GIR_Coverage, 17099,
     /* 1208439 */     GIR_EraseRootFromParent_Done,
     /* 1208440 */   // Label 17533: @1208440
     /* 1208440 */   GIM_Try, /*On fail goto*//*Label 17534*/ GIMT_Encode4(1208520), // Rule ID 17102 //
     /* 1208445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1208453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1208456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1208459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1208462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208484 */     // MIs[0] round
     /* 1208484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208494 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1208497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208519 */     // GIR_Coverage, 17102,
     /* 1208519 */     GIR_EraseRootFromParent_Done,
     /* 1208520 */   // Label 17534: @1208520
     /* 1208520 */   GIM_Try, /*On fail goto*//*Label 17535*/ GIMT_Encode4(1208600), // Rule ID 17103 //
     /* 1208525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1208533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1208536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1208539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1208542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208564 */     // MIs[0] round
     /* 1208564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208574 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1208577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208599 */     // GIR_Coverage, 17103,
     /* 1208599 */     GIR_EraseRootFromParent_Done,
     /* 1208600 */   // Label 17535: @1208600
     /* 1208600 */   GIM_Try, /*On fail goto*//*Label 17536*/ GIMT_Encode4(1208680), // Rule ID 17106 //
     /* 1208605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1208613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1208616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1208619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1208622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208644 */     // MIs[0] round
     /* 1208644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208654 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1208657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208679 */     // GIR_Coverage, 17106,
     /* 1208679 */     GIR_EraseRootFromParent_Done,
     /* 1208680 */   // Label 17536: @1208680
     /* 1208680 */   GIM_Try, /*On fail goto*//*Label 17537*/ GIMT_Encode4(1208760), // Rule ID 17107 //
     /* 1208685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1208693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1208696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1208699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1208702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208724 */     // MIs[0] round
     /* 1208724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208734 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1208737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208759 */     // GIR_Coverage, 17107,
     /* 1208759 */     GIR_EraseRootFromParent_Done,
     /* 1208760 */   // Label 17537: @1208760
     /* 1208760 */   GIM_Try, /*On fail goto*//*Label 17538*/ GIMT_Encode4(1208840), // Rule ID 17110 //
     /* 1208765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1208773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1208776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1208779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1208782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208804 */     // MIs[0] round
     /* 1208804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208814 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1208817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208839 */     // GIR_Coverage, 17110,
     /* 1208839 */     GIR_EraseRootFromParent_Done,
     /* 1208840 */   // Label 17538: @1208840
     /* 1208840 */   GIM_Try, /*On fail goto*//*Label 17539*/ GIMT_Encode4(1208920), // Rule ID 17111 //
     /* 1208845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1208853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1208856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1208859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1208862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208884 */     // MIs[0] round
     /* 1208884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208894 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1208897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208919 */     // GIR_Coverage, 17111,
     /* 1208919 */     GIR_EraseRootFromParent_Done,
     /* 1208920 */   // Label 17539: @1208920
     /* 1208920 */   GIM_Try, /*On fail goto*//*Label 17540*/ GIMT_Encode4(1209000), // Rule ID 17114 //
     /* 1208925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1208933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1208936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1208939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1208942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208964 */     // MIs[0] round
     /* 1208964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208974 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1208977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208999 */     // GIR_Coverage, 17114,
     /* 1208999 */     GIR_EraseRootFromParent_Done,
     /* 1209000 */   // Label 17540: @1209000
     /* 1209000 */   GIM_Try, /*On fail goto*//*Label 17541*/ GIMT_Encode4(1209080), // Rule ID 17115 //
     /* 1209005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1209013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1209016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1209019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1209022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1209025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1209044 */     // MIs[0] round
     /* 1209044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209054 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1209057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209079 */     // GIR_Coverage, 17115,
     /* 1209079 */     GIR_EraseRootFromParent_Done,
     /* 1209080 */   // Label 17541: @1209080
     /* 1209080 */   GIM_Try, /*On fail goto*//*Label 17542*/ GIMT_Encode4(1209160), // Rule ID 17118 //
     /* 1209085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1209093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1209096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1209099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1209102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209124 */     // MIs[0] round
     /* 1209124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209134 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1209137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209159 */     // GIR_Coverage, 17118,
     /* 1209159 */     GIR_EraseRootFromParent_Done,
     /* 1209160 */   // Label 17542: @1209160
     /* 1209160 */   GIM_Try, /*On fail goto*//*Label 17543*/ GIMT_Encode4(1209240), // Rule ID 17119 //
     /* 1209165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1209173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1209176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1209179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1209182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209204 */     // MIs[0] round
     /* 1209204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209214 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1209217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209239 */     // GIR_Coverage, 17119,
     /* 1209239 */     GIR_EraseRootFromParent_Done,
     /* 1209240 */   // Label 17543: @1209240
     /* 1209240 */   GIM_Try, /*On fail goto*//*Label 17544*/ GIMT_Encode4(1209320), // Rule ID 17122 //
     /* 1209245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1209253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1209256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1209259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1209262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209284 */     // MIs[0] round
     /* 1209284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209294 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1209297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209319 */     // GIR_Coverage, 17122,
     /* 1209319 */     GIR_EraseRootFromParent_Done,
     /* 1209320 */   // Label 17544: @1209320
     /* 1209320 */   GIM_Try, /*On fail goto*//*Label 17545*/ GIMT_Encode4(1209400), // Rule ID 17123 //
     /* 1209325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1209333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1209336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1209339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1209342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209364 */     // MIs[0] round
     /* 1209364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209374 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1209377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209399 */     // GIR_Coverage, 17123,
     /* 1209399 */     GIR_EraseRootFromParent_Done,
     /* 1209400 */   // Label 17545: @1209400
     /* 1209400 */   GIM_Try, /*On fail goto*//*Label 17546*/ GIMT_Encode4(1209480), // Rule ID 17126 //
     /* 1209405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1209413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1209416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1209419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1209422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209444 */     // MIs[0] round
     /* 1209444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209454 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1209457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209479 */     // GIR_Coverage, 17126,
     /* 1209479 */     GIR_EraseRootFromParent_Done,
     /* 1209480 */   // Label 17546: @1209480
     /* 1209480 */   GIM_Try, /*On fail goto*//*Label 17547*/ GIMT_Encode4(1209560), // Rule ID 17127 //
     /* 1209485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1209493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1209496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1209499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1209502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209524 */     // MIs[0] round
     /* 1209524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209534 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1209537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209559 */     // GIR_Coverage, 17127,
     /* 1209559 */     GIR_EraseRootFromParent_Done,
     /* 1209560 */   // Label 17547: @1209560
     /* 1209560 */   GIM_Try, /*On fail goto*//*Label 17548*/ GIMT_Encode4(1209640), // Rule ID 17130 //
     /* 1209565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1209573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1209576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1209579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1209582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209604 */     // MIs[0] round
     /* 1209604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209614 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1209617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209639 */     // GIR_Coverage, 17130,
     /* 1209639 */     GIR_EraseRootFromParent_Done,
     /* 1209640 */   // Label 17548: @1209640
     /* 1209640 */   GIM_Try, /*On fail goto*//*Label 17549*/ GIMT_Encode4(1209720), // Rule ID 17131 //
     /* 1209645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1209653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1209656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1209659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1209662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209684 */     // MIs[0] round
     /* 1209684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209694 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1209697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209719 */     // GIR_Coverage, 17131,
     /* 1209719 */     GIR_EraseRootFromParent_Done,
     /* 1209720 */   // Label 17549: @1209720
     /* 1209720 */   GIM_Try, /*On fail goto*//*Label 17550*/ GIMT_Encode4(1209800), // Rule ID 17136 //
     /* 1209725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1209733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1209736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1209739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1209742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1209745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209764 */     // MIs[0] round
     /* 1209764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209774 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1209777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209799 */     // GIR_Coverage, 17136,
     /* 1209799 */     GIR_EraseRootFromParent_Done,
     /* 1209800 */   // Label 17550: @1209800
     /* 1209800 */   GIM_Try, /*On fail goto*//*Label 17551*/ GIMT_Encode4(1209880), // Rule ID 17137 //
     /* 1209805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1209813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1209816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1209819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1209822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1209825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209844 */     // MIs[0] round
     /* 1209844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209854 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1209857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209879 */     // GIR_Coverage, 17137,
     /* 1209879 */     GIR_EraseRootFromParent_Done,
     /* 1209880 */   // Label 17551: @1209880
     /* 1209880 */   GIM_Try, /*On fail goto*//*Label 17552*/ GIMT_Encode4(1209960), // Rule ID 17146 //
     /* 1209885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1209893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1209896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1209899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1209902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1209905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209924 */     // MIs[0] round
     /* 1209924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209934 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1209937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209959 */     // GIR_Coverage, 17146,
     /* 1209959 */     GIR_EraseRootFromParent_Done,
     /* 1209960 */   // Label 17552: @1209960
     /* 1209960 */   GIM_Try, /*On fail goto*//*Label 17553*/ GIMT_Encode4(1210040), // Rule ID 17147 //
     /* 1209965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1209973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1209976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1209979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1209982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1209985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210004 */     // MIs[0] round
     /* 1210004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210014 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1210017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210039 */     // GIR_Coverage, 17147,
     /* 1210039 */     GIR_EraseRootFromParent_Done,
     /* 1210040 */   // Label 17553: @1210040
     /* 1210040 */   GIM_Try, /*On fail goto*//*Label 17554*/ GIMT_Encode4(1210120), // Rule ID 17156 //
     /* 1210045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1210053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1210056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1210059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1210062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1210065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210084 */     // MIs[0] round
     /* 1210084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210094 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1210097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210119 */     // GIR_Coverage, 17156,
     /* 1210119 */     GIR_EraseRootFromParent_Done,
     /* 1210120 */   // Label 17554: @1210120
     /* 1210120 */   GIM_Try, /*On fail goto*//*Label 17555*/ GIMT_Encode4(1210200), // Rule ID 17157 //
     /* 1210125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1210133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1210136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1210139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1210142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1210145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210164 */     // MIs[0] round
     /* 1210164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210174 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1210177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210199 */     // GIR_Coverage, 17157,
     /* 1210199 */     GIR_EraseRootFromParent_Done,
     /* 1210200 */   // Label 17555: @1210200
     /* 1210200 */   GIM_Try, /*On fail goto*//*Label 17556*/ GIMT_Encode4(1210280), // Rule ID 17166 //
     /* 1210205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1210213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1210216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1210219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1210222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1210225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210244 */     // MIs[0] round
     /* 1210244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210254 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1210257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210279 */     // GIR_Coverage, 17166,
     /* 1210279 */     GIR_EraseRootFromParent_Done,
     /* 1210280 */   // Label 17556: @1210280
     /* 1210280 */   GIM_Try, /*On fail goto*//*Label 17557*/ GIMT_Encode4(1210360), // Rule ID 17167 //
     /* 1210285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1210293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1210296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1210299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1210302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1210305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210324 */     // MIs[0] round
     /* 1210324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210334 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1210337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210359 */     // GIR_Coverage, 17167,
     /* 1210359 */     GIR_EraseRootFromParent_Done,
     /* 1210360 */   // Label 17557: @1210360
     /* 1210360 */   GIM_Try, /*On fail goto*//*Label 17558*/ GIMT_Encode4(1210440), // Rule ID 17176 //
     /* 1210365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1210373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1210376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1210379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1210382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1210385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210404 */     // MIs[0] round
     /* 1210404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210414 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1210417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210439 */     // GIR_Coverage, 17176,
     /* 1210439 */     GIR_EraseRootFromParent_Done,
     /* 1210440 */   // Label 17558: @1210440
     /* 1210440 */   GIM_Try, /*On fail goto*//*Label 17559*/ GIMT_Encode4(1210520), // Rule ID 17177 //
     /* 1210445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1210453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1210456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1210459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1210462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1210465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210484 */     // MIs[0] round
     /* 1210484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210494 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1210497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210519 */     // GIR_Coverage, 17177,
     /* 1210519 */     GIR_EraseRootFromParent_Done,
     /* 1210520 */   // Label 17559: @1210520
     /* 1210520 */   GIM_Try, /*On fail goto*//*Label 17560*/ GIMT_Encode4(1210600), // Rule ID 17186 //
     /* 1210525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1210533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1210536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1210539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1210542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1210545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210564 */     // MIs[0] round
     /* 1210564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210574 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1210577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210599 */     // GIR_Coverage, 17186,
     /* 1210599 */     GIR_EraseRootFromParent_Done,
     /* 1210600 */   // Label 17560: @1210600
     /* 1210600 */   GIM_Try, /*On fail goto*//*Label 17561*/ GIMT_Encode4(1210680), // Rule ID 17187 //
     /* 1210605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1210613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1210616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1210619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1210622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1210625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210644 */     // MIs[0] round
     /* 1210644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210654 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1210657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210679 */     // GIR_Coverage, 17187,
     /* 1210679 */     GIR_EraseRootFromParent_Done,
     /* 1210680 */   // Label 17561: @1210680
     /* 1210680 */   GIM_Try, /*On fail goto*//*Label 17562*/ GIMT_Encode4(1210760), // Rule ID 17196 //
     /* 1210685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1210693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1210696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1210699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1210702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1210705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210724 */     // MIs[0] round
     /* 1210724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210734 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1210737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210759 */     // GIR_Coverage, 17196,
     /* 1210759 */     GIR_EraseRootFromParent_Done,
     /* 1210760 */   // Label 17562: @1210760
     /* 1210760 */   GIM_Try, /*On fail goto*//*Label 17563*/ GIMT_Encode4(1210840), // Rule ID 17197 //
     /* 1210765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1210773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1210776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1210779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1210782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1210785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210804 */     // MIs[0] round
     /* 1210804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210814 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1210817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210839 */     // GIR_Coverage, 17197,
     /* 1210839 */     GIR_EraseRootFromParent_Done,
     /* 1210840 */   // Label 17563: @1210840
     /* 1210840 */   GIM_Try, /*On fail goto*//*Label 17564*/ GIMT_Encode4(1210920), // Rule ID 17206 //
     /* 1210845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1210853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1210856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1210859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1210862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1210865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210884 */     // MIs[0] round
     /* 1210884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210894 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1210897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210919 */     // GIR_Coverage, 17206,
     /* 1210919 */     GIR_EraseRootFromParent_Done,
     /* 1210920 */   // Label 17564: @1210920
     /* 1210920 */   GIM_Try, /*On fail goto*//*Label 17565*/ GIMT_Encode4(1211000), // Rule ID 17207 //
     /* 1210925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1210933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1210936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1210939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1210942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1210945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210964 */     // MIs[0] round
     /* 1210964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210974 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1210977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210999 */     // GIR_Coverage, 17207,
     /* 1210999 */     GIR_EraseRootFromParent_Done,
     /* 1211000 */   // Label 17565: @1211000
     /* 1211000 */   GIM_Try, /*On fail goto*//*Label 17566*/ GIMT_Encode4(1211080), // Rule ID 17214 //
     /* 1211005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1211008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1211013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1211016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1211019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1211022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211044 */     // MIs[0] round
     /* 1211044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211054 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1211057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211079 */     // GIR_Coverage, 17214,
     /* 1211079 */     GIR_EraseRootFromParent_Done,
     /* 1211080 */   // Label 17566: @1211080
     /* 1211080 */   GIM_Try, /*On fail goto*//*Label 17567*/ GIMT_Encode4(1211160), // Rule ID 17215 //
     /* 1211085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1211088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1211093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1211096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1211099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1211102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211124 */     // MIs[0] round
     /* 1211124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211134 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1211137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211159 */     // GIR_Coverage, 17215,
     /* 1211159 */     GIR_EraseRootFromParent_Done,
     /* 1211160 */   // Label 17567: @1211160
     /* 1211160 */   GIM_Try, /*On fail goto*//*Label 17568*/ GIMT_Encode4(1211240), // Rule ID 17218 //
     /* 1211165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1211168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1211173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1211176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1211179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1211182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211204 */     // MIs[0] round
     /* 1211204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211214 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1211217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211239 */     // GIR_Coverage, 17218,
     /* 1211239 */     GIR_EraseRootFromParent_Done,
     /* 1211240 */   // Label 17568: @1211240
     /* 1211240 */   GIM_Try, /*On fail goto*//*Label 17569*/ GIMT_Encode4(1211320), // Rule ID 17219 //
     /* 1211245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1211248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1211253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1211256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1211259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1211262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211284 */     // MIs[0] round
     /* 1211284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211294 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1211297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211319 */     // GIR_Coverage, 17219,
     /* 1211319 */     GIR_EraseRootFromParent_Done,
     /* 1211320 */   // Label 17569: @1211320
     /* 1211320 */   GIM_Try, /*On fail goto*//*Label 17570*/ GIMT_Encode4(1211400), // Rule ID 17222 //
     /* 1211325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1211328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1211333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1211336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1211339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1211342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211364 */     // MIs[0] round
     /* 1211364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211374 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1211377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211399 */     // GIR_Coverage, 17222,
     /* 1211399 */     GIR_EraseRootFromParent_Done,
     /* 1211400 */   // Label 17570: @1211400
     /* 1211400 */   GIM_Try, /*On fail goto*//*Label 17571*/ GIMT_Encode4(1211480), // Rule ID 17223 //
     /* 1211405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1211408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1211413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1211416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1211419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1211422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211444 */     // MIs[0] round
     /* 1211444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211454 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1211457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211479 */     // GIR_Coverage, 17223,
     /* 1211479 */     GIR_EraseRootFromParent_Done,
     /* 1211480 */   // Label 17571: @1211480
     /* 1211480 */   GIM_Try, /*On fail goto*//*Label 17572*/ GIMT_Encode4(1211560), // Rule ID 17226 //
     /* 1211485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1211488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1211493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1211496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1211499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1211502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211524 */     // MIs[0] round
     /* 1211524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211534 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1211537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211559 */     // GIR_Coverage, 17226,
     /* 1211559 */     GIR_EraseRootFromParent_Done,
     /* 1211560 */   // Label 17572: @1211560
     /* 1211560 */   GIM_Try, /*On fail goto*//*Label 17573*/ GIMT_Encode4(1211640), // Rule ID 17227 //
     /* 1211565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1211568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1211573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1211576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1211579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1211582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211604 */     // MIs[0] round
     /* 1211604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211614 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1211617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211639 */     // GIR_Coverage, 17227,
     /* 1211639 */     GIR_EraseRootFromParent_Done,
     /* 1211640 */   // Label 17573: @1211640
     /* 1211640 */   GIM_Try, /*On fail goto*//*Label 17574*/ GIMT_Encode4(1211720), // Rule ID 17230 //
     /* 1211645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1211648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1211653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1211656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1211659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1211662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211684 */     // MIs[0] round
     /* 1211684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211694 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1211697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211719 */     // GIR_Coverage, 17230,
     /* 1211719 */     GIR_EraseRootFromParent_Done,
     /* 1211720 */   // Label 17574: @1211720
     /* 1211720 */   GIM_Try, /*On fail goto*//*Label 17575*/ GIMT_Encode4(1211800), // Rule ID 17231 //
     /* 1211725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1211728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1211733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1211736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1211739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1211742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211764 */     // MIs[0] round
     /* 1211764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211774 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1211777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211799 */     // GIR_Coverage, 17231,
     /* 1211799 */     GIR_EraseRootFromParent_Done,
     /* 1211800 */   // Label 17575: @1211800
     /* 1211800 */   GIM_Try, /*On fail goto*//*Label 17576*/ GIMT_Encode4(1211880), // Rule ID 17234 //
     /* 1211805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1211813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1211816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1211819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1211822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211844 */     // MIs[0] round
     /* 1211844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211854 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1211857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211879 */     // GIR_Coverage, 17234,
     /* 1211879 */     GIR_EraseRootFromParent_Done,
     /* 1211880 */   // Label 17576: @1211880
     /* 1211880 */   GIM_Try, /*On fail goto*//*Label 17577*/ GIMT_Encode4(1211960), // Rule ID 17235 //
     /* 1211885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1211893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1211896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1211899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1211902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211924 */     // MIs[0] round
     /* 1211924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211934 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1211937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211959 */     // GIR_Coverage, 17235,
     /* 1211959 */     GIR_EraseRootFromParent_Done,
     /* 1211960 */   // Label 17577: @1211960
     /* 1211960 */   GIM_Try, /*On fail goto*//*Label 17578*/ GIMT_Encode4(1212040), // Rule ID 17238 //
     /* 1211965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1211973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1211976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1211979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1211982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1212004 */     // MIs[0] round
     /* 1212004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212014 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1212017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212039 */     // GIR_Coverage, 17238,
     /* 1212039 */     GIR_EraseRootFromParent_Done,
     /* 1212040 */   // Label 17578: @1212040
     /* 1212040 */   GIM_Try, /*On fail goto*//*Label 17579*/ GIMT_Encode4(1212120), // Rule ID 17239 //
     /* 1212045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1212048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1212053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1212056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1212059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1212062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1212065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1212084 */     // MIs[0] round
     /* 1212084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212094 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1212097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212119 */     // GIR_Coverage, 17239,
     /* 1212119 */     GIR_EraseRootFromParent_Done,
     /* 1212120 */   // Label 17579: @1212120
     /* 1212120 */   GIM_Try, /*On fail goto*//*Label 17580*/ GIMT_Encode4(1212200), // Rule ID 17242 //
     /* 1212125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1212128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1212133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1212136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1212139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1212142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1212145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1212164 */     // MIs[0] round
     /* 1212164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212174 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1212177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212199 */     // GIR_Coverage, 17242,
     /* 1212199 */     GIR_EraseRootFromParent_Done,
     /* 1212200 */   // Label 17580: @1212200
     /* 1212200 */   GIM_Try, /*On fail goto*//*Label 17581*/ GIMT_Encode4(1212280), // Rule ID 17243 //
     /* 1212205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1212208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1212213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1212216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1212219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1212222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1212225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1212244 */     // MIs[0] round
     /* 1212244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212254 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1212257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212279 */     // GIR_Coverage, 17243,
     /* 1212279 */     GIR_EraseRootFromParent_Done,
     /* 1212280 */   // Label 17581: @1212280
     /* 1212280 */   GIM_Try, /*On fail goto*//*Label 17582*/ GIMT_Encode4(1212360), // Rule ID 17246 //
     /* 1212285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1212288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1212293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1212296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1212299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1212302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1212305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1212324 */     // MIs[0] round
     /* 1212324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212334 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1212337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212359 */     // GIR_Coverage, 17246,
     /* 1212359 */     GIR_EraseRootFromParent_Done,
     /* 1212360 */   // Label 17582: @1212360
     /* 1212360 */   GIM_Try, /*On fail goto*//*Label 17583*/ GIMT_Encode4(1212440), // Rule ID 17247 //
     /* 1212365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1212368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1212373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1212376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1212379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1212382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1212385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1212404 */     // MIs[0] round
     /* 1212404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212414 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1212417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212439 */     // GIR_Coverage, 17247,
     /* 1212439 */     GIR_EraseRootFromParent_Done,
     /* 1212440 */   // Label 17583: @1212440
     /* 1212440 */   GIM_Try, /*On fail goto*//*Label 17584*/ GIMT_Encode4(1212520), // Rule ID 17252 //
     /* 1212445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1212448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1212453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1212456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1212459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1212462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1212465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212484 */     // MIs[0] round
     /* 1212484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212494 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1212497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212519 */     // GIR_Coverage, 17252,
     /* 1212519 */     GIR_EraseRootFromParent_Done,
     /* 1212520 */   // Label 17584: @1212520
     /* 1212520 */   GIM_Try, /*On fail goto*//*Label 17585*/ GIMT_Encode4(1212600), // Rule ID 17253 //
     /* 1212525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1212528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1212533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1212536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1212539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1212542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1212545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212564 */     // MIs[0] round
     /* 1212564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212574 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1212577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212599 */     // GIR_Coverage, 17253,
     /* 1212599 */     GIR_EraseRootFromParent_Done,
     /* 1212600 */   // Label 17585: @1212600
     /* 1212600 */   GIM_Try, /*On fail goto*//*Label 17586*/ GIMT_Encode4(1212680), // Rule ID 17262 //
     /* 1212605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1212608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1212613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1212616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1212619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1212625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212644 */     // MIs[0] round
     /* 1212644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212654 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1212657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212679 */     // GIR_Coverage, 17262,
     /* 1212679 */     GIR_EraseRootFromParent_Done,
     /* 1212680 */   // Label 17586: @1212680
     /* 1212680 */   GIM_Try, /*On fail goto*//*Label 17587*/ GIMT_Encode4(1212760), // Rule ID 17263 //
     /* 1212685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1212688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1212693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1212696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1212699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1212705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212724 */     // MIs[0] round
     /* 1212724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212734 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1212737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212759 */     // GIR_Coverage, 17263,
     /* 1212759 */     GIR_EraseRootFromParent_Done,
     /* 1212760 */   // Label 17587: @1212760
     /* 1212760 */   GIM_Try, /*On fail goto*//*Label 17588*/ GIMT_Encode4(1212840), // Rule ID 17272 //
     /* 1212765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1212768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1212773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1212776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1212779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1212782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1212785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212804 */     // MIs[0] round
     /* 1212804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212814 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1212817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212839 */     // GIR_Coverage, 17272,
     /* 1212839 */     GIR_EraseRootFromParent_Done,
     /* 1212840 */   // Label 17588: @1212840
     /* 1212840 */   GIM_Try, /*On fail goto*//*Label 17589*/ GIMT_Encode4(1212920), // Rule ID 17273 //
     /* 1212845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1212848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1212853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1212856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1212859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1212862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1212865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212884 */     // MIs[0] round
     /* 1212884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212894 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1212897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212919 */     // GIR_Coverage, 17273,
     /* 1212919 */     GIR_EraseRootFromParent_Done,
     /* 1212920 */   // Label 17589: @1212920
     /* 1212920 */   GIM_Try, /*On fail goto*//*Label 17590*/ GIMT_Encode4(1213000), // Rule ID 17282 //
     /* 1212925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1212928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1212933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1212936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1212939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1212942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1212945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212964 */     // MIs[0] round
     /* 1212964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212974 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1212977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212999 */     // GIR_Coverage, 17282,
     /* 1212999 */     GIR_EraseRootFromParent_Done,
     /* 1213000 */   // Label 17590: @1213000
     /* 1213000 */   GIM_Try, /*On fail goto*//*Label 17591*/ GIMT_Encode4(1213080), // Rule ID 17283 //
     /* 1213005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1213008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1213013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1213016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1213019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1213022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1213025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213044 */     // MIs[0] round
     /* 1213044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213054 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1213057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213079 */     // GIR_Coverage, 17283,
     /* 1213079 */     GIR_EraseRootFromParent_Done,
     /* 1213080 */   // Label 17591: @1213080
     /* 1213080 */   GIM_Try, /*On fail goto*//*Label 17592*/ GIMT_Encode4(1213160), // Rule ID 17292 //
     /* 1213085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1213088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1213093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1213096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1213099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1213102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1213105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213124 */     // MIs[0] round
     /* 1213124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213134 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1213137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213159 */     // GIR_Coverage, 17292,
     /* 1213159 */     GIR_EraseRootFromParent_Done,
     /* 1213160 */   // Label 17592: @1213160
     /* 1213160 */   GIM_Try, /*On fail goto*//*Label 17593*/ GIMT_Encode4(1213240), // Rule ID 17293 //
     /* 1213165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1213168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1213173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1213176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1213179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1213182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1213185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213204 */     // MIs[0] round
     /* 1213204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213214 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1213217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213239 */     // GIR_Coverage, 17293,
     /* 1213239 */     GIR_EraseRootFromParent_Done,
     /* 1213240 */   // Label 17593: @1213240
     /* 1213240 */   GIM_Try, /*On fail goto*//*Label 17594*/ GIMT_Encode4(1213320), // Rule ID 17302 //
     /* 1213245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1213248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1213253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1213256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1213259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1213262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1213265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213284 */     // MIs[0] round
     /* 1213284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213294 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1213297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213319 */     // GIR_Coverage, 17302,
     /* 1213319 */     GIR_EraseRootFromParent_Done,
     /* 1213320 */   // Label 17594: @1213320
     /* 1213320 */   GIM_Try, /*On fail goto*//*Label 17595*/ GIMT_Encode4(1213400), // Rule ID 17303 //
     /* 1213325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1213328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1213333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1213336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1213339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1213342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1213345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213364 */     // MIs[0] round
     /* 1213364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213374 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1213377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213399 */     // GIR_Coverage, 17303,
     /* 1213399 */     GIR_EraseRootFromParent_Done,
     /* 1213400 */   // Label 17595: @1213400
     /* 1213400 */   GIM_Try, /*On fail goto*//*Label 17596*/ GIMT_Encode4(1213480), // Rule ID 17312 //
     /* 1213405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1213408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1213413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1213425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213444 */     // MIs[0] round
     /* 1213444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213454 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1213457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213479 */     // GIR_Coverage, 17312,
     /* 1213479 */     GIR_EraseRootFromParent_Done,
     /* 1213480 */   // Label 17596: @1213480
     /* 1213480 */   GIM_Try, /*On fail goto*//*Label 17597*/ GIMT_Encode4(1213560), // Rule ID 17313 //
     /* 1213485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1213488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1213493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1213505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213524 */     // MIs[0] round
     /* 1213524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213534 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1213537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213559 */     // GIR_Coverage, 17313,
     /* 1213559 */     GIR_EraseRootFromParent_Done,
     /* 1213560 */   // Label 17597: @1213560
     /* 1213560 */   GIM_Try, /*On fail goto*//*Label 17598*/ GIMT_Encode4(1213640), // Rule ID 17322 //
     /* 1213565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1213568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1213573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1213576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1213579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1213582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1213585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213604 */     // MIs[0] round
     /* 1213604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213614 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1213617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213639 */     // GIR_Coverage, 17322,
     /* 1213639 */     GIR_EraseRootFromParent_Done,
     /* 1213640 */   // Label 17598: @1213640
     /* 1213640 */   GIM_Try, /*On fail goto*//*Label 17599*/ GIMT_Encode4(1213720), // Rule ID 17323 //
     /* 1213645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1213648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1213653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1213656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1213659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1213662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1213665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213684 */     // MIs[0] round
     /* 1213684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213694 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1213697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213719 */     // GIR_Coverage, 17323,
     /* 1213719 */     GIR_EraseRootFromParent_Done,
     /* 1213720 */   // Label 17599: @1213720
     /* 1213720 */   GIM_Try, /*On fail goto*//*Label 17600*/ GIMT_Encode4(1213800), // Rule ID 17332 //
     /* 1213725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1213728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1213733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1213736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1213739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1213742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1213745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213764 */     // MIs[0] round
     /* 1213764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213774 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1213777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213799 */     // GIR_Coverage, 17332,
     /* 1213799 */     GIR_EraseRootFromParent_Done,
     /* 1213800 */   // Label 17600: @1213800
     /* 1213800 */   GIM_Try, /*On fail goto*//*Label 17601*/ GIMT_Encode4(1213880), // Rule ID 17333 //
     /* 1213805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1213808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1213813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1213816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1213819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1213822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1213825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213844 */     // MIs[0] round
     /* 1213844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213854 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1213857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213879 */     // GIR_Coverage, 17333,
     /* 1213879 */     GIR_EraseRootFromParent_Done,
     /* 1213880 */   // Label 17601: @1213880
     /* 1213880 */   GIM_Try, /*On fail goto*//*Label 17602*/ GIMT_Encode4(1213960), // Rule ID 17340 //
     /* 1213885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1213888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1213893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1213896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1213899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1213902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1213905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1213924 */     // MIs[0] round
     /* 1213924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213934 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1213937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213959 */     // GIR_Coverage, 17340,
     /* 1213959 */     GIR_EraseRootFromParent_Done,
     /* 1213960 */   // Label 17602: @1213960
     /* 1213960 */   GIM_Try, /*On fail goto*//*Label 17603*/ GIMT_Encode4(1214040), // Rule ID 17341 //
     /* 1213965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1213968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1213973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1213976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1213979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1213982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1213985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214004 */     // MIs[0] round
     /* 1214004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214014 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1214017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214039 */     // GIR_Coverage, 17341,
     /* 1214039 */     GIR_EraseRootFromParent_Done,
     /* 1214040 */   // Label 17603: @1214040
     /* 1214040 */   GIM_Try, /*On fail goto*//*Label 17604*/ GIMT_Encode4(1214120), // Rule ID 17344 //
     /* 1214045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1214048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1214053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1214056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1214059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1214062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214084 */     // MIs[0] round
     /* 1214084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214094 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1214097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214119 */     // GIR_Coverage, 17344,
     /* 1214119 */     GIR_EraseRootFromParent_Done,
     /* 1214120 */   // Label 17604: @1214120
     /* 1214120 */   GIM_Try, /*On fail goto*//*Label 17605*/ GIMT_Encode4(1214200), // Rule ID 17345 //
     /* 1214125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1214128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1214133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1214136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1214139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1214142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214164 */     // MIs[0] round
     /* 1214164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214174 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1214177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214199 */     // GIR_Coverage, 17345,
     /* 1214199 */     GIR_EraseRootFromParent_Done,
     /* 1214200 */   // Label 17605: @1214200
     /* 1214200 */   GIM_Try, /*On fail goto*//*Label 17606*/ GIMT_Encode4(1214280), // Rule ID 17348 //
     /* 1214205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1214208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1214213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1214216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1214219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1214222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214244 */     // MIs[0] round
     /* 1214244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214254 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1214257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214279 */     // GIR_Coverage, 17348,
     /* 1214279 */     GIR_EraseRootFromParent_Done,
     /* 1214280 */   // Label 17606: @1214280
     /* 1214280 */   GIM_Try, /*On fail goto*//*Label 17607*/ GIMT_Encode4(1214360), // Rule ID 17349 //
     /* 1214285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1214288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1214293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1214296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1214299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1214302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214324 */     // MIs[0] round
     /* 1214324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214334 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1214337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214359 */     // GIR_Coverage, 17349,
     /* 1214359 */     GIR_EraseRootFromParent_Done,
     /* 1214360 */   // Label 17607: @1214360
     /* 1214360 */   GIM_Try, /*On fail goto*//*Label 17608*/ GIMT_Encode4(1214440), // Rule ID 17352 //
     /* 1214365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1214368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1214373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1214376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1214379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1214382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214404 */     // MIs[0] round
     /* 1214404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214414 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1214417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214439 */     // GIR_Coverage, 17352,
     /* 1214439 */     GIR_EraseRootFromParent_Done,
     /* 1214440 */   // Label 17608: @1214440
     /* 1214440 */   GIM_Try, /*On fail goto*//*Label 17609*/ GIMT_Encode4(1214520), // Rule ID 17353 //
     /* 1214445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1214448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1214453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1214456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1214459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1214462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214484 */     // MIs[0] round
     /* 1214484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214494 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1214497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214519 */     // GIR_Coverage, 17353,
     /* 1214519 */     GIR_EraseRootFromParent_Done,
     /* 1214520 */   // Label 17609: @1214520
     /* 1214520 */   GIM_Try, /*On fail goto*//*Label 17610*/ GIMT_Encode4(1214600), // Rule ID 17356 //
     /* 1214525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1214528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1214533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1214536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1214539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1214542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214564 */     // MIs[0] round
     /* 1214564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214574 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1214577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214599 */     // GIR_Coverage, 17356,
     /* 1214599 */     GIR_EraseRootFromParent_Done,
     /* 1214600 */   // Label 17610: @1214600
     /* 1214600 */   GIM_Try, /*On fail goto*//*Label 17611*/ GIMT_Encode4(1214680), // Rule ID 17357 //
     /* 1214605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1214608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1214613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1214616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1214619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1214622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214644 */     // MIs[0] round
     /* 1214644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214654 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1214657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214679 */     // GIR_Coverage, 17357,
     /* 1214679 */     GIR_EraseRootFromParent_Done,
     /* 1214680 */   // Label 17611: @1214680
     /* 1214680 */   GIM_Try, /*On fail goto*//*Label 17612*/ GIMT_Encode4(1214760), // Rule ID 17360 //
     /* 1214685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1214688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1214693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1214696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1214699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1214702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214724 */     // MIs[0] round
     /* 1214724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214734 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1214737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214759 */     // GIR_Coverage, 17360,
     /* 1214759 */     GIR_EraseRootFromParent_Done,
     /* 1214760 */   // Label 17612: @1214760
     /* 1214760 */   GIM_Try, /*On fail goto*//*Label 17613*/ GIMT_Encode4(1214840), // Rule ID 17361 //
     /* 1214765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1214768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1214773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1214776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1214779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1214782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214804 */     // MIs[0] round
     /* 1214804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214814 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1214817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214839 */     // GIR_Coverage, 17361,
     /* 1214839 */     GIR_EraseRootFromParent_Done,
     /* 1214840 */   // Label 17613: @1214840
     /* 1214840 */   GIM_Try, /*On fail goto*//*Label 17614*/ GIMT_Encode4(1214920), // Rule ID 17364 //
     /* 1214845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1214848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1214853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1214856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1214859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1214862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214884 */     // MIs[0] round
     /* 1214884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214894 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1214897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214919 */     // GIR_Coverage, 17364,
     /* 1214919 */     GIR_EraseRootFromParent_Done,
     /* 1214920 */   // Label 17614: @1214920
     /* 1214920 */   GIM_Try, /*On fail goto*//*Label 17615*/ GIMT_Encode4(1215000), // Rule ID 17365 //
     /* 1214925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1214928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1214933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1214936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1214939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1214942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214964 */     // MIs[0] round
     /* 1214964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214974 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1214977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214999 */     // GIR_Coverage, 17365,
     /* 1214999 */     GIR_EraseRootFromParent_Done,
     /* 1215000 */   // Label 17615: @1215000
     /* 1215000 */   GIM_Try, /*On fail goto*//*Label 17616*/ GIMT_Encode4(1215080), // Rule ID 17368 //
     /* 1215005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1215008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1215013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1215016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1215019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1215022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215044 */     // MIs[0] round
     /* 1215044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215054 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1215057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215079 */     // GIR_Coverage, 17368,
     /* 1215079 */     GIR_EraseRootFromParent_Done,
     /* 1215080 */   // Label 17616: @1215080
     /* 1215080 */   GIM_Try, /*On fail goto*//*Label 17617*/ GIMT_Encode4(1215160), // Rule ID 17369 //
     /* 1215085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1215088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1215093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1215096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1215099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1215102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215124 */     // MIs[0] round
     /* 1215124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215134 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1215137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215159 */     // GIR_Coverage, 17369,
     /* 1215159 */     GIR_EraseRootFromParent_Done,
     /* 1215160 */   // Label 17617: @1215160
     /* 1215160 */   GIM_Try, /*On fail goto*//*Label 17618*/ GIMT_Encode4(1215240), // Rule ID 17372 //
     /* 1215165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1215168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1215173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1215176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1215179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1215182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215204 */     // MIs[0] round
     /* 1215204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215214 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1215217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215239 */     // GIR_Coverage, 17372,
     /* 1215239 */     GIR_EraseRootFromParent_Done,
     /* 1215240 */   // Label 17618: @1215240
     /* 1215240 */   GIM_Try, /*On fail goto*//*Label 17619*/ GIMT_Encode4(1215320), // Rule ID 17373 //
     /* 1215245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1215248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1215253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1215256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1215259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1215262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215284 */     // MIs[0] round
     /* 1215284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215294 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1215297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215319 */     // GIR_Coverage, 17373,
     /* 1215319 */     GIR_EraseRootFromParent_Done,
     /* 1215320 */   // Label 17619: @1215320
     /* 1215320 */   GIM_Try, /*On fail goto*//*Label 17620*/ GIMT_Encode4(1215400), // Rule ID 17376 //
     /* 1215325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1215336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1215339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1215342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1215345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215364 */     // MIs[0] round
     /* 1215364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215374 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1215377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215399 */     // GIR_Coverage, 17376,
     /* 1215399 */     GIR_EraseRootFromParent_Done,
     /* 1215400 */   // Label 17620: @1215400
     /* 1215400 */   GIM_Try, /*On fail goto*//*Label 17621*/ GIMT_Encode4(1215480), // Rule ID 17377 //
     /* 1215405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1215416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1215419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1215422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1215425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215444 */     // MIs[0] round
     /* 1215444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215454 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1215457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215479 */     // GIR_Coverage, 17377,
     /* 1215479 */     GIR_EraseRootFromParent_Done,
     /* 1215480 */   // Label 17621: @1215480
     /* 1215480 */   GIM_Try, /*On fail goto*//*Label 17622*/ GIMT_Encode4(1215560), // Rule ID 17380 //
     /* 1215485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1215496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1215499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1215502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1215505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215524 */     // MIs[0] round
     /* 1215524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215534 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1215537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215559 */     // GIR_Coverage, 17380,
     /* 1215559 */     GIR_EraseRootFromParent_Done,
     /* 1215560 */   // Label 17622: @1215560
     /* 1215560 */   GIM_Try, /*On fail goto*//*Label 17623*/ GIMT_Encode4(1215640), // Rule ID 17381 //
     /* 1215565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1215576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1215579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1215582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1215585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215604 */     // MIs[0] round
     /* 1215604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215614 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1215617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215639 */     // GIR_Coverage, 17381,
     /* 1215639 */     GIR_EraseRootFromParent_Done,
     /* 1215640 */   // Label 17623: @1215640
     /* 1215640 */   GIM_Try, /*On fail goto*//*Label 17624*/ GIMT_Encode4(1215720), // Rule ID 17384 //
     /* 1215645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1215656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1215659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1215662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1215665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215684 */     // MIs[0] round
     /* 1215684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215694 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1215697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215719 */     // GIR_Coverage, 17384,
     /* 1215719 */     GIR_EraseRootFromParent_Done,
     /* 1215720 */   // Label 17624: @1215720
     /* 1215720 */   GIM_Try, /*On fail goto*//*Label 17625*/ GIMT_Encode4(1215800), // Rule ID 17385 //
     /* 1215725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1215736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1215739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1215742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1215745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215764 */     // MIs[0] round
     /* 1215764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215774 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1215777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215799 */     // GIR_Coverage, 17385,
     /* 1215799 */     GIR_EraseRootFromParent_Done,
     /* 1215800 */   // Label 17625: @1215800
     /* 1215800 */   GIM_Try, /*On fail goto*//*Label 17626*/ GIMT_Encode4(1215880), // Rule ID 17388 //
     /* 1215805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1215816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1215819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1215822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1215825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215844 */     // MIs[0] round
     /* 1215844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215854 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1215857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215879 */     // GIR_Coverage, 17388,
     /* 1215879 */     GIR_EraseRootFromParent_Done,
     /* 1215880 */   // Label 17626: @1215880
     /* 1215880 */   GIM_Try, /*On fail goto*//*Label 17627*/ GIMT_Encode4(1215960), // Rule ID 17389 //
     /* 1215885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1215896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1215899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1215902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1215905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215924 */     // MIs[0] round
     /* 1215924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215934 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1215937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215959 */     // GIR_Coverage, 17389,
     /* 1215959 */     GIR_EraseRootFromParent_Done,
     /* 1215960 */   // Label 17627: @1215960
     /* 1215960 */   GIM_Try, /*On fail goto*//*Label 17628*/ GIMT_Encode4(1216040), // Rule ID 17392 //
     /* 1215965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1215976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1215979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1215982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1215985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216004 */     // MIs[0] round
     /* 1216004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216014 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1216017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216039 */     // GIR_Coverage, 17392,
     /* 1216039 */     GIR_EraseRootFromParent_Done,
     /* 1216040 */   // Label 17628: @1216040
     /* 1216040 */   GIM_Try, /*On fail goto*//*Label 17629*/ GIMT_Encode4(1216120), // Rule ID 17393 //
     /* 1216045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1216048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1216056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1216059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1216062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1216065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216084 */     // MIs[0] round
     /* 1216084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216094 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1216097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216119 */     // GIR_Coverage, 17393,
     /* 1216119 */     GIR_EraseRootFromParent_Done,
     /* 1216120 */   // Label 17629: @1216120
     /* 1216120 */   GIM_Try, /*On fail goto*//*Label 17630*/ GIMT_Encode4(1216200), // Rule ID 17396 //
     /* 1216125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1216128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1216136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1216139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1216142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1216145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216164 */     // MIs[0] round
     /* 1216164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216174 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1216177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216199 */     // GIR_Coverage, 17396,
     /* 1216199 */     GIR_EraseRootFromParent_Done,
     /* 1216200 */   // Label 17630: @1216200
     /* 1216200 */   GIM_Try, /*On fail goto*//*Label 17631*/ GIMT_Encode4(1216280), // Rule ID 17397 //
     /* 1216205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1216216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1216219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1216222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1216225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216244 */     // MIs[0] round
     /* 1216244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216254 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1216257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216279 */     // GIR_Coverage, 17397,
     /* 1216279 */     GIR_EraseRootFromParent_Done,
     /* 1216280 */   // Label 17631: @1216280
     /* 1216280 */   GIM_Try, /*On fail goto*//*Label 17632*/ GIMT_Encode4(1216360), // Rule ID 17400 //
     /* 1216285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1216296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1216299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1216302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1216305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216324 */     // MIs[0] round
     /* 1216324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216334 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1216337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216359 */     // GIR_Coverage, 17400,
     /* 1216359 */     GIR_EraseRootFromParent_Done,
     /* 1216360 */   // Label 17632: @1216360
     /* 1216360 */   GIM_Try, /*On fail goto*//*Label 17633*/ GIMT_Encode4(1216440), // Rule ID 17401 //
     /* 1216365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1216376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1216379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1216382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1216385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216404 */     // MIs[0] round
     /* 1216404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216414 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1216417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216439 */     // GIR_Coverage, 17401,
     /* 1216439 */     GIR_EraseRootFromParent_Done,
     /* 1216440 */   // Label 17633: @1216440
     /* 1216440 */   GIM_Try, /*On fail goto*//*Label 17634*/ GIMT_Encode4(1216520), // Rule ID 17404 //
     /* 1216445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1216456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1216459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1216462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1216465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216484 */     // MIs[0] round
     /* 1216484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216494 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1216497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216519 */     // GIR_Coverage, 17404,
     /* 1216519 */     GIR_EraseRootFromParent_Done,
     /* 1216520 */   // Label 17634: @1216520
     /* 1216520 */   GIM_Try, /*On fail goto*//*Label 17635*/ GIMT_Encode4(1216600), // Rule ID 17405 //
     /* 1216525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1216536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1216539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1216542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1216545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216564 */     // MIs[0] round
     /* 1216564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216574 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1216577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216599 */     // GIR_Coverage, 17405,
     /* 1216599 */     GIR_EraseRootFromParent_Done,
     /* 1216600 */   // Label 17635: @1216600
     /* 1216600 */   GIM_Try, /*On fail goto*//*Label 17636*/ GIMT_Encode4(1216680), // Rule ID 17408 //
     /* 1216605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1216616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1216619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1216622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1216625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216644 */     // MIs[0] round
     /* 1216644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216654 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1216657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216679 */     // GIR_Coverage, 17408,
     /* 1216679 */     GIR_EraseRootFromParent_Done,
     /* 1216680 */   // Label 17636: @1216680
     /* 1216680 */   GIM_Try, /*On fail goto*//*Label 17637*/ GIMT_Encode4(1216760), // Rule ID 17409 //
     /* 1216685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1216696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1216699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1216702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1216705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216724 */     // MIs[0] round
     /* 1216724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216734 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1216737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216759 */     // GIR_Coverage, 17409,
     /* 1216759 */     GIR_EraseRootFromParent_Done,
     /* 1216760 */   // Label 17637: @1216760
     /* 1216760 */   GIM_Try, /*On fail goto*//*Label 17638*/ GIMT_Encode4(1216840), // Rule ID 17412 //
     /* 1216765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1216768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1216776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1216779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1216782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1216785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216804 */     // MIs[0] round
     /* 1216804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216814 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1216817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216839 */     // GIR_Coverage, 17412,
     /* 1216839 */     GIR_EraseRootFromParent_Done,
     /* 1216840 */   // Label 17638: @1216840
     /* 1216840 */   GIM_Try, /*On fail goto*//*Label 17639*/ GIMT_Encode4(1216920), // Rule ID 17413 //
     /* 1216845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1216848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1216856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1216859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1216862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1216865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216884 */     // MIs[0] round
     /* 1216884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216894 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1216897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216919 */     // GIR_Coverage, 17413,
     /* 1216919 */     GIR_EraseRootFromParent_Done,
     /* 1216920 */   // Label 17639: @1216920
     /* 1216920 */   GIM_Try, /*On fail goto*//*Label 17640*/ GIMT_Encode4(1217000), // Rule ID 17416 //
     /* 1216925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1216928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1216936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1216939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1216942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1216945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216964 */     // MIs[0] round
     /* 1216964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216974 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1216977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216999 */     // GIR_Coverage, 17416,
     /* 1216999 */     GIR_EraseRootFromParent_Done,
     /* 1217000 */   // Label 17640: @1217000
     /* 1217000 */   GIM_Try, /*On fail goto*//*Label 17641*/ GIMT_Encode4(1217080), // Rule ID 17417 //
     /* 1217005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1217013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1217016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1217019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1217022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1217025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217044 */     // MIs[0] round
     /* 1217044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217054 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1217057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217079 */     // GIR_Coverage, 17417,
     /* 1217079 */     GIR_EraseRootFromParent_Done,
     /* 1217080 */   // Label 17641: @1217080
     /* 1217080 */   GIM_Try, /*On fail goto*//*Label 17642*/ GIMT_Encode4(1217160), // Rule ID 17420 //
     /* 1217085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1217093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1217096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1217099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1217102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1217105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217124 */     // MIs[0] round
     /* 1217124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217134 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1217137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217159 */     // GIR_Coverage, 17420,
     /* 1217159 */     GIR_EraseRootFromParent_Done,
     /* 1217160 */   // Label 17642: @1217160
     /* 1217160 */   GIM_Try, /*On fail goto*//*Label 17643*/ GIMT_Encode4(1217240), // Rule ID 17421 //
     /* 1217165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1217173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1217176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1217179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1217182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1217185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217204 */     // MIs[0] round
     /* 1217204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217214 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1217217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217239 */     // GIR_Coverage, 17421,
     /* 1217239 */     GIR_EraseRootFromParent_Done,
     /* 1217240 */   // Label 17643: @1217240
     /* 1217240 */   GIM_Try, /*On fail goto*//*Label 17644*/ GIMT_Encode4(1217320), // Rule ID 17424 //
     /* 1217245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1217248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1217253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1217256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1217259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1217262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1217265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217284 */     // MIs[0] round
     /* 1217284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217294 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1217297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217319 */     // GIR_Coverage, 17424,
     /* 1217319 */     GIR_EraseRootFromParent_Done,
     /* 1217320 */   // Label 17644: @1217320
     /* 1217320 */   GIM_Try, /*On fail goto*//*Label 17645*/ GIMT_Encode4(1217400), // Rule ID 17425 //
     /* 1217325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1217328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1217333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1217336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1217339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1217342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1217345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217364 */     // MIs[0] round
     /* 1217364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217374 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1217377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217399 */     // GIR_Coverage, 17425,
     /* 1217399 */     GIR_EraseRootFromParent_Done,
     /* 1217400 */   // Label 17645: @1217400
     /* 1217400 */   GIM_Try, /*On fail goto*//*Label 17646*/ GIMT_Encode4(1217480), // Rule ID 17428 //
     /* 1217405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1217408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1217413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1217416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1217419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1217422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1217425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217444 */     // MIs[0] round
     /* 1217444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217454 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1217457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217479 */     // GIR_Coverage, 17428,
     /* 1217479 */     GIR_EraseRootFromParent_Done,
     /* 1217480 */   // Label 17646: @1217480
     /* 1217480 */   GIM_Try, /*On fail goto*//*Label 17647*/ GIMT_Encode4(1217560), // Rule ID 17429 //
     /* 1217485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1217488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1217493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1217496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1217499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1217502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1217505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217524 */     // MIs[0] round
     /* 1217524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217534 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1217537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217559 */     // GIR_Coverage, 17429,
     /* 1217559 */     GIR_EraseRootFromParent_Done,
     /* 1217560 */   // Label 17647: @1217560
     /* 1217560 */   GIM_Try, /*On fail goto*//*Label 17648*/ GIMT_Encode4(1217640), // Rule ID 17432 //
     /* 1217565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1217568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1217573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1217576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1217579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1217582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1217585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217604 */     // MIs[0] round
     /* 1217604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217614 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1217617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217639 */     // GIR_Coverage, 17432,
     /* 1217639 */     GIR_EraseRootFromParent_Done,
     /* 1217640 */   // Label 17648: @1217640
     /* 1217640 */   GIM_Try, /*On fail goto*//*Label 17649*/ GIMT_Encode4(1217720), // Rule ID 17433 //
     /* 1217645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1217648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1217653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1217656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1217659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1217662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1217665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217684 */     // MIs[0] round
     /* 1217684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217694 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1217697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217719 */     // GIR_Coverage, 17433,
     /* 1217719 */     GIR_EraseRootFromParent_Done,
     /* 1217720 */   // Label 17649: @1217720
     /* 1217720 */   GIM_Try, /*On fail goto*//*Label 17650*/ GIMT_Encode4(1217800), // Rule ID 17436 //
     /* 1217725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1217733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1217736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1217739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1217742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1217745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1217764 */     // MIs[0] round
     /* 1217764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217774 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1217777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217799 */     // GIR_Coverage, 17436,
     /* 1217799 */     GIR_EraseRootFromParent_Done,
     /* 1217800 */   // Label 17650: @1217800
     /* 1217800 */   GIM_Try, /*On fail goto*//*Label 17651*/ GIMT_Encode4(1217880), // Rule ID 17437 //
     /* 1217805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1217813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1217816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1217819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1217822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1217825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1217844 */     // MIs[0] round
     /* 1217844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217854 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1217857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217879 */     // GIR_Coverage, 17437,
     /* 1217879 */     GIR_EraseRootFromParent_Done,
     /* 1217880 */   // Label 17651: @1217880
     /* 1217880 */   GIM_Try, /*On fail goto*//*Label 17652*/ GIMT_Encode4(1217960), // Rule ID 17440 //
     /* 1217885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1217893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1217896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1217899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1217902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1217905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1217924 */     // MIs[0] round
     /* 1217924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217934 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1217937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217959 */     // GIR_Coverage, 17440,
     /* 1217959 */     GIR_EraseRootFromParent_Done,
     /* 1217960 */   // Label 17652: @1217960
     /* 1217960 */   GIM_Try, /*On fail goto*//*Label 17653*/ GIMT_Encode4(1218040), // Rule ID 17441 //
     /* 1217965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1217973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1217976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1217979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1217982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1217985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218004 */     // MIs[0] round
     /* 1218004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218014 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1218017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218039 */     // GIR_Coverage, 17441,
     /* 1218039 */     GIR_EraseRootFromParent_Done,
     /* 1218040 */   // Label 17653: @1218040
     /* 1218040 */   GIM_Try, /*On fail goto*//*Label 17654*/ GIMT_Encode4(1218120), // Rule ID 17444 //
     /* 1218045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1218048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1218053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1218056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1218059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1218062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1218065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1218084 */     // MIs[0] round
     /* 1218084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218094 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1218097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218119 */     // GIR_Coverage, 17444,
     /* 1218119 */     GIR_EraseRootFromParent_Done,
     /* 1218120 */   // Label 17654: @1218120
     /* 1218120 */   GIM_Try, /*On fail goto*//*Label 17655*/ GIMT_Encode4(1218200), // Rule ID 17445 //
     /* 1218125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1218128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1218133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1218136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1218139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1218142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1218145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1218164 */     // MIs[0] round
     /* 1218164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218174 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1218177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218199 */     // GIR_Coverage, 17445,
     /* 1218199 */     GIR_EraseRootFromParent_Done,
     /* 1218200 */   // Label 17655: @1218200
     /* 1218200 */   GIM_Try, /*On fail goto*//*Label 17656*/ GIMT_Encode4(1218280), // Rule ID 17448 //
     /* 1218205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1218208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1218213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1218216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1218219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1218222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218244 */     // MIs[0] round
     /* 1218244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218254 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1218257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218279 */     // GIR_Coverage, 17448,
     /* 1218279 */     GIR_EraseRootFromParent_Done,
     /* 1218280 */   // Label 17656: @1218280
     /* 1218280 */   GIM_Try, /*On fail goto*//*Label 17657*/ GIMT_Encode4(1218360), // Rule ID 17449 //
     /* 1218285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1218288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1218293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1218296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1218299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1218302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218324 */     // MIs[0] round
     /* 1218324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218334 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1218337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218359 */     // GIR_Coverage, 17449,
     /* 1218359 */     GIR_EraseRootFromParent_Done,
     /* 1218360 */   // Label 17657: @1218360
     /* 1218360 */   GIM_Try, /*On fail goto*//*Label 17658*/ GIMT_Encode4(1218440), // Rule ID 17452 //
     /* 1218365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1218368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1218373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1218376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1218379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1218382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1218385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1218404 */     // MIs[0] round
     /* 1218404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218414 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1218417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218439 */     // GIR_Coverage, 17452,
     /* 1218439 */     GIR_EraseRootFromParent_Done,
     /* 1218440 */   // Label 17658: @1218440
     /* 1218440 */   GIM_Try, /*On fail goto*//*Label 17659*/ GIMT_Encode4(1218520), // Rule ID 17453 //
     /* 1218445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1218448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1218453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1218456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1218459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1218462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1218465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1218484 */     // MIs[0] round
     /* 1218484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218494 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1218497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218519 */     // GIR_Coverage, 17453,
     /* 1218519 */     GIR_EraseRootFromParent_Done,
     /* 1218520 */   // Label 17659: @1218520
     /* 1218520 */   GIM_Try, /*On fail goto*//*Label 17660*/ GIMT_Encode4(1218600), // Rule ID 17456 //
     /* 1218525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1218533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1218536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1218539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1218542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1218545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1218564 */     // MIs[0] round
     /* 1218564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218574 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1218577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218599 */     // GIR_Coverage, 17456,
     /* 1218599 */     GIR_EraseRootFromParent_Done,
     /* 1218600 */   // Label 17660: @1218600
     /* 1218600 */   GIM_Try, /*On fail goto*//*Label 17661*/ GIMT_Encode4(1218680), // Rule ID 17457 //
     /* 1218605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1218613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1218616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1218619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1218622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1218625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1218644 */     // MIs[0] round
     /* 1218644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218654 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1218657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218679 */     // GIR_Coverage, 17457,
     /* 1218679 */     GIR_EraseRootFromParent_Done,
     /* 1218680 */   // Label 17661: @1218680
     /* 1218680 */   GIM_Try, /*On fail goto*//*Label 17662*/ GIMT_Encode4(1218760), // Rule ID 17460 //
     /* 1218685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1218688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1218693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1218696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1218699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1218702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218724 */     // MIs[0] round
     /* 1218724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218734 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1218737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218759 */     // GIR_Coverage, 17460,
     /* 1218759 */     GIR_EraseRootFromParent_Done,
     /* 1218760 */   // Label 17662: @1218760
     /* 1218760 */   GIM_Try, /*On fail goto*//*Label 17663*/ GIMT_Encode4(1218840), // Rule ID 17461 //
     /* 1218765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1218768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1218773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1218776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1218779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1218782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218804 */     // MIs[0] round
     /* 1218804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218814 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1218817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218839 */     // GIR_Coverage, 17461,
     /* 1218839 */     GIR_EraseRootFromParent_Done,
     /* 1218840 */   // Label 17663: @1218840
     /* 1218840 */   GIM_Try, /*On fail goto*//*Label 17664*/ GIMT_Encode4(1218920), // Rule ID 17464 //
     /* 1218845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1218848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1218853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1218856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1218859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1218862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218884 */     // MIs[0] round
     /* 1218884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218894 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1218897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218919 */     // GIR_Coverage, 17464,
     /* 1218919 */     GIR_EraseRootFromParent_Done,
     /* 1218920 */   // Label 17664: @1218920
     /* 1218920 */   GIM_Try, /*On fail goto*//*Label 17665*/ GIMT_Encode4(1219000), // Rule ID 17465 //
     /* 1218925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1218928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1218933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1218936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1218939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1218942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218964 */     // MIs[0] round
     /* 1218964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218974 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1218977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218999 */     // GIR_Coverage, 17465,
     /* 1218999 */     GIR_EraseRootFromParent_Done,
     /* 1219000 */   // Label 17665: @1219000
     /* 1219000 */   GIM_Try, /*On fail goto*//*Label 17666*/ GIMT_Encode4(1219080), // Rule ID 17468 //
     /* 1219005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1219013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1219016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1219019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1219022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219044 */     // MIs[0] round
     /* 1219044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219054 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1219057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219079 */     // GIR_Coverage, 17468,
     /* 1219079 */     GIR_EraseRootFromParent_Done,
     /* 1219080 */   // Label 17666: @1219080
     /* 1219080 */   GIM_Try, /*On fail goto*//*Label 17667*/ GIMT_Encode4(1219160), // Rule ID 17469 //
     /* 1219085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1219093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1219096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1219099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1219102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219124 */     // MIs[0] round
     /* 1219124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219134 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1219137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219159 */     // GIR_Coverage, 17469,
     /* 1219159 */     GIR_EraseRootFromParent_Done,
     /* 1219160 */   // Label 17667: @1219160
     /* 1219160 */   GIM_Try, /*On fail goto*//*Label 17668*/ GIMT_Encode4(1219240), // Rule ID 17472 //
     /* 1219165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1219173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1219176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1219179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1219182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219204 */     // MIs[0] round
     /* 1219204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219214 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1219217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219239 */     // GIR_Coverage, 17472,
     /* 1219239 */     GIR_EraseRootFromParent_Done,
     /* 1219240 */   // Label 17668: @1219240
     /* 1219240 */   GIM_Try, /*On fail goto*//*Label 17669*/ GIMT_Encode4(1219320), // Rule ID 17473 //
     /* 1219245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1219248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1219253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1219256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1219259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1219262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219284 */     // MIs[0] round
     /* 1219284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219294 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1219297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219319 */     // GIR_Coverage, 17473,
     /* 1219319 */     GIR_EraseRootFromParent_Done,
     /* 1219320 */   // Label 17669: @1219320
     /* 1219320 */   GIM_Try, /*On fail goto*//*Label 17670*/ GIMT_Encode4(1219400), // Rule ID 17476 //
     /* 1219325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1219333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1219336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1219339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1219342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219364 */     // MIs[0] round
     /* 1219364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219374 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1219377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219399 */     // GIR_Coverage, 17476,
     /* 1219399 */     GIR_EraseRootFromParent_Done,
     /* 1219400 */   // Label 17670: @1219400
     /* 1219400 */   GIM_Try, /*On fail goto*//*Label 17671*/ GIMT_Encode4(1219480), // Rule ID 17477 //
     /* 1219405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1219408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1219413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1219416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1219419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1219422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219444 */     // MIs[0] round
     /* 1219444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219454 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1219457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219479 */     // GIR_Coverage, 17477,
     /* 1219479 */     GIR_EraseRootFromParent_Done,
     /* 1219480 */   // Label 17671: @1219480
     /* 1219480 */   GIM_Try, /*On fail goto*//*Label 17672*/ GIMT_Encode4(1219560), // Rule ID 17480 //
     /* 1219485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1219493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1219496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1219499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1219502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219524 */     // MIs[0] round
     /* 1219524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219534 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1219537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219559 */     // GIR_Coverage, 17480,
     /* 1219559 */     GIR_EraseRootFromParent_Done,
     /* 1219560 */   // Label 17672: @1219560
     /* 1219560 */   GIM_Try, /*On fail goto*//*Label 17673*/ GIMT_Encode4(1219640), // Rule ID 17481 //
     /* 1219565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1219568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1219573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1219576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1219579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1219582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219604 */     // MIs[0] round
     /* 1219604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219614 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1219617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219639 */     // GIR_Coverage, 17481,
     /* 1219639 */     GIR_EraseRootFromParent_Done,
     /* 1219640 */   // Label 17673: @1219640
     /* 1219640 */   GIM_Try, /*On fail goto*//*Label 17674*/ GIMT_Encode4(1219720), // Rule ID 17484 //
     /* 1219645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1219648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1219653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1219656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1219659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1219662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1219665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1219684 */     // MIs[0] round
     /* 1219684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219694 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1219697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219719 */     // GIR_Coverage, 17484,
     /* 1219719 */     GIR_EraseRootFromParent_Done,
     /* 1219720 */   // Label 17674: @1219720
     /* 1219720 */   GIM_Try, /*On fail goto*//*Label 17675*/ GIMT_Encode4(1219800), // Rule ID 17485 //
     /* 1219725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1219728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1219733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1219736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1219739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1219742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1219745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1219764 */     // MIs[0] round
     /* 1219764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219774 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1219777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219799 */     // GIR_Coverage, 17485,
     /* 1219799 */     GIR_EraseRootFromParent_Done,
     /* 1219800 */   // Label 17675: @1219800
     /* 1219800 */   GIM_Try, /*On fail goto*//*Label 17676*/ GIMT_Encode4(1219880), // Rule ID 17488 //
     /* 1219805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1219808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1219813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1219816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1219819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1219822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1219825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1219844 */     // MIs[0] round
     /* 1219844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219854 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1219857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219879 */     // GIR_Coverage, 17488,
     /* 1219879 */     GIR_EraseRootFromParent_Done,
     /* 1219880 */   // Label 17676: @1219880
     /* 1219880 */   GIM_Try, /*On fail goto*//*Label 17677*/ GIMT_Encode4(1219960), // Rule ID 17489 //
     /* 1219885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1219888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1219893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1219896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1219899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1219902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1219905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1219924 */     // MIs[0] round
     /* 1219924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219934 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1219937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219959 */     // GIR_Coverage, 17489,
     /* 1219959 */     GIR_EraseRootFromParent_Done,
     /* 1219960 */   // Label 17677: @1219960
     /* 1219960 */   GIM_Try, /*On fail goto*//*Label 17678*/ GIMT_Encode4(1220040), // Rule ID 17492 //
     /* 1219965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1219968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1219973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1219976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1219979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1219982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1219985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220004 */     // MIs[0] round
     /* 1220004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220014 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1220017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220039 */     // GIR_Coverage, 17492,
     /* 1220039 */     GIR_EraseRootFromParent_Done,
     /* 1220040 */   // Label 17678: @1220040
     /* 1220040 */   GIM_Try, /*On fail goto*//*Label 17679*/ GIMT_Encode4(1220120), // Rule ID 17493 //
     /* 1220045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1220048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1220053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1220056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1220059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1220062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220084 */     // MIs[0] round
     /* 1220084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220094 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1220097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220119 */     // GIR_Coverage, 17493,
     /* 1220119 */     GIR_EraseRootFromParent_Done,
     /* 1220120 */   // Label 17679: @1220120
     /* 1220120 */   GIM_Try, /*On fail goto*//*Label 17680*/ GIMT_Encode4(1220200), // Rule ID 17496 //
     /* 1220125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1220128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1220136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1220139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1220142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1220145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220164 */     // MIs[0] round
     /* 1220164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220174 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1220177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220199 */     // GIR_Coverage, 17496,
     /* 1220199 */     GIR_EraseRootFromParent_Done,
     /* 1220200 */   // Label 17680: @1220200
     /* 1220200 */   GIM_Try, /*On fail goto*//*Label 17681*/ GIMT_Encode4(1220280), // Rule ID 17497 //
     /* 1220205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1220208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1220216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1220219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1220222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1220225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220244 */     // MIs[0] round
     /* 1220244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220254 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1220257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220279 */     // GIR_Coverage, 17497,
     /* 1220279 */     GIR_EraseRootFromParent_Done,
     /* 1220280 */   // Label 17681: @1220280
     /* 1220280 */   GIM_Try, /*On fail goto*//*Label 17682*/ GIMT_Encode4(1220360), // Rule ID 17500 //
     /* 1220285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1220288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1220296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1220299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1220302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1220305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220324 */     // MIs[0] round
     /* 1220324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220334 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1220337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220359 */     // GIR_Coverage, 17500,
     /* 1220359 */     GIR_EraseRootFromParent_Done,
     /* 1220360 */   // Label 17682: @1220360
     /* 1220360 */   GIM_Try, /*On fail goto*//*Label 17683*/ GIMT_Encode4(1220440), // Rule ID 17501 //
     /* 1220365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1220368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1220376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1220379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1220382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1220385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220404 */     // MIs[0] round
     /* 1220404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220414 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1220417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220439 */     // GIR_Coverage, 17501,
     /* 1220439 */     GIR_EraseRootFromParent_Done,
     /* 1220440 */   // Label 17683: @1220440
     /* 1220440 */   GIM_Try, /*On fail goto*//*Label 17684*/ GIMT_Encode4(1220520), // Rule ID 17504 //
     /* 1220445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1220456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1220459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1220462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1220465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220484 */     // MIs[0] round
     /* 1220484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220494 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1220497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220519 */     // GIR_Coverage, 17504,
     /* 1220519 */     GIR_EraseRootFromParent_Done,
     /* 1220520 */   // Label 17684: @1220520
     /* 1220520 */   GIM_Try, /*On fail goto*//*Label 17685*/ GIMT_Encode4(1220600), // Rule ID 17505 //
     /* 1220525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1220536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1220539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1220542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1220545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220564 */     // MIs[0] round
     /* 1220564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220574 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1220577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220599 */     // GIR_Coverage, 17505,
     /* 1220599 */     GIR_EraseRootFromParent_Done,
     /* 1220600 */   // Label 17685: @1220600
     /* 1220600 */   GIM_Try, /*On fail goto*//*Label 17686*/ GIMT_Encode4(1220680), // Rule ID 17508 //
     /* 1220605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1220608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1220616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1220619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1220622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1220625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220644 */     // MIs[0] round
     /* 1220644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220654 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1220657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220679 */     // GIR_Coverage, 17508,
     /* 1220679 */     GIR_EraseRootFromParent_Done,
     /* 1220680 */   // Label 17686: @1220680
     /* 1220680 */   GIM_Try, /*On fail goto*//*Label 17687*/ GIMT_Encode4(1220760), // Rule ID 17509 //
     /* 1220685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1220688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1220696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1220699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1220702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1220705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220724 */     // MIs[0] round
     /* 1220724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220734 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1220737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220759 */     // GIR_Coverage, 17509,
     /* 1220759 */     GIR_EraseRootFromParent_Done,
     /* 1220760 */   // Label 17687: @1220760
     /* 1220760 */   GIM_Try, /*On fail goto*//*Label 17688*/ GIMT_Encode4(1220840), // Rule ID 17512 //
     /* 1220765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1220776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1220779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1220782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1220785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220804 */     // MIs[0] round
     /* 1220804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220814 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1220817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220839 */     // GIR_Coverage, 17512,
     /* 1220839 */     GIR_EraseRootFromParent_Done,
     /* 1220840 */   // Label 17688: @1220840
     /* 1220840 */   GIM_Try, /*On fail goto*//*Label 17689*/ GIMT_Encode4(1220920), // Rule ID 17513 //
     /* 1220845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1220856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1220859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1220862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1220865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220884 */     // MIs[0] round
     /* 1220884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220894 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1220897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220919 */     // GIR_Coverage, 17513,
     /* 1220919 */     GIR_EraseRootFromParent_Done,
     /* 1220920 */   // Label 17689: @1220920
     /* 1220920 */   GIM_Try, /*On fail goto*//*Label 17690*/ GIMT_Encode4(1221000), // Rule ID 17516 //
     /* 1220925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1220928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1220936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1220939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1220942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1220945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220964 */     // MIs[0] round
     /* 1220964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220974 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1220977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220999 */     // GIR_Coverage, 17516,
     /* 1220999 */     GIR_EraseRootFromParent_Done,
     /* 1221000 */   // Label 17690: @1221000
     /* 1221000 */   GIM_Try, /*On fail goto*//*Label 17691*/ GIMT_Encode4(1221080), // Rule ID 17517 //
     /* 1221005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1221008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1221016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1221019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1221022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1221025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221044 */     // MIs[0] round
     /* 1221044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221054 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1221057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221079 */     // GIR_Coverage, 17517,
     /* 1221079 */     GIR_EraseRootFromParent_Done,
     /* 1221080 */   // Label 17691: @1221080
     /* 1221080 */   GIM_Try, /*On fail goto*//*Label 17692*/ GIMT_Encode4(1221160), // Rule ID 17520 //
     /* 1221085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1221096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1221099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1221102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1221105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221124 */     // MIs[0] round
     /* 1221124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221134 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1221137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221159 */     // GIR_Coverage, 17520,
     /* 1221159 */     GIR_EraseRootFromParent_Done,
     /* 1221160 */   // Label 17692: @1221160
     /* 1221160 */   GIM_Try, /*On fail goto*//*Label 17693*/ GIMT_Encode4(1221240), // Rule ID 17521 //
     /* 1221165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1221176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1221179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1221182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1221185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221204 */     // MIs[0] round
     /* 1221204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221214 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1221217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221239 */     // GIR_Coverage, 17521,
     /* 1221239 */     GIR_EraseRootFromParent_Done,
     /* 1221240 */   // Label 17693: @1221240
     /* 1221240 */   GIM_Try, /*On fail goto*//*Label 17694*/ GIMT_Encode4(1221320), // Rule ID 17524 //
     /* 1221245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1221256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1221259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1221262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1221265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221284 */     // MIs[0] round
     /* 1221284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221294 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1221297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221319 */     // GIR_Coverage, 17524,
     /* 1221319 */     GIR_EraseRootFromParent_Done,
     /* 1221320 */   // Label 17694: @1221320
     /* 1221320 */   GIM_Try, /*On fail goto*//*Label 17695*/ GIMT_Encode4(1221400), // Rule ID 17525 //
     /* 1221325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1221336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1221339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1221342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1221345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221364 */     // MIs[0] round
     /* 1221364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221374 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1221377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221399 */     // GIR_Coverage, 17525,
     /* 1221399 */     GIR_EraseRootFromParent_Done,
     /* 1221400 */   // Label 17695: @1221400
     /* 1221400 */   GIM_Try, /*On fail goto*//*Label 17696*/ GIMT_Encode4(1221480), // Rule ID 17528 //
     /* 1221405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1221416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1221419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1221422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1221425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221444 */     // MIs[0] round
     /* 1221444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221454 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1221457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221479 */     // GIR_Coverage, 17528,
     /* 1221479 */     GIR_EraseRootFromParent_Done,
     /* 1221480 */   // Label 17696: @1221480
     /* 1221480 */   GIM_Try, /*On fail goto*//*Label 17697*/ GIMT_Encode4(1221560), // Rule ID 17529 //
     /* 1221485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1221496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1221499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1221502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1221505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221524 */     // MIs[0] round
     /* 1221524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221534 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1221537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221559 */     // GIR_Coverage, 17529,
     /* 1221559 */     GIR_EraseRootFromParent_Done,
     /* 1221560 */   // Label 17697: @1221560
     /* 1221560 */   GIM_Try, /*On fail goto*//*Label 17698*/ GIMT_Encode4(1221640), // Rule ID 17532 //
     /* 1221565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1221568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1221576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1221579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1221582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1221585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221604 */     // MIs[0] round
     /* 1221604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221614 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1221617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221639 */     // GIR_Coverage, 17532,
     /* 1221639 */     GIR_EraseRootFromParent_Done,
     /* 1221640 */   // Label 17698: @1221640
     /* 1221640 */   GIM_Try, /*On fail goto*//*Label 17699*/ GIMT_Encode4(1221720), // Rule ID 17533 //
     /* 1221645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1221648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1221656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1221659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1221662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1221665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221684 */     // MIs[0] round
     /* 1221684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221694 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1221697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221719 */     // GIR_Coverage, 17533,
     /* 1221719 */     GIR_EraseRootFromParent_Done,
     /* 1221720 */   // Label 17699: @1221720
     /* 1221720 */   GIM_Try, /*On fail goto*//*Label 17700*/ GIMT_Encode4(1221800), // Rule ID 17536 //
     /* 1221725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1221728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1221736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1221739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1221742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1221745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221764 */     // MIs[0] round
     /* 1221764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221774 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1221777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221799 */     // GIR_Coverage, 17536,
     /* 1221799 */     GIR_EraseRootFromParent_Done,
     /* 1221800 */   // Label 17700: @1221800
     /* 1221800 */   GIM_Try, /*On fail goto*//*Label 17701*/ GIMT_Encode4(1221880), // Rule ID 17537 //
     /* 1221805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1221808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1221816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1221819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1221822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1221825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221844 */     // MIs[0] round
     /* 1221844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221854 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1221857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221879 */     // GIR_Coverage, 17537,
     /* 1221879 */     GIR_EraseRootFromParent_Done,
     /* 1221880 */   // Label 17701: @1221880
     /* 1221880 */   GIM_Try, /*On fail goto*//*Label 17702*/ GIMT_Encode4(1221960), // Rule ID 17540 //
     /* 1221885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1221888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1221896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1221899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1221902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1221905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221924 */     // MIs[0] round
     /* 1221924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221934 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1221937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221959 */     // GIR_Coverage, 17540,
     /* 1221959 */     GIR_EraseRootFromParent_Done,
     /* 1221960 */   // Label 17702: @1221960
     /* 1221960 */   GIM_Try, /*On fail goto*//*Label 17703*/ GIMT_Encode4(1222040), // Rule ID 17541 //
     /* 1221965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1221968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1221976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1221979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1221982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1221985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222004 */     // MIs[0] round
     /* 1222004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222014 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1222017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222039 */     // GIR_Coverage, 17541,
     /* 1222039 */     GIR_EraseRootFromParent_Done,
     /* 1222040 */   // Label 17703: @1222040
     /* 1222040 */   GIM_Try, /*On fail goto*//*Label 17704*/ GIMT_Encode4(1222120), // Rule ID 17544 //
     /* 1222045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1222048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1222053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1222056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1222059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1222062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1222065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222084 */     // MIs[0] round
     /* 1222084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222094 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1222097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222119 */     // GIR_Coverage, 17544,
     /* 1222119 */     GIR_EraseRootFromParent_Done,
     /* 1222120 */   // Label 17704: @1222120
     /* 1222120 */   GIM_Try, /*On fail goto*//*Label 17705*/ GIMT_Encode4(1222200), // Rule ID 17545 //
     /* 1222125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1222128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1222133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1222136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1222139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1222142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1222145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222164 */     // MIs[0] round
     /* 1222164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222174 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1222177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222199 */     // GIR_Coverage, 17545,
     /* 1222199 */     GIR_EraseRootFromParent_Done,
     /* 1222200 */   // Label 17705: @1222200
     /* 1222200 */   GIM_Try, /*On fail goto*//*Label 17706*/ GIMT_Encode4(1222280), // Rule ID 17548 //
     /* 1222205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1222208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1222213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1222216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1222219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1222222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1222225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222244 */     // MIs[0] round
     /* 1222244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222254 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1222257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222279 */     // GIR_Coverage, 17548,
     /* 1222279 */     GIR_EraseRootFromParent_Done,
     /* 1222280 */   // Label 17706: @1222280
     /* 1222280 */   GIM_Try, /*On fail goto*//*Label 17707*/ GIMT_Encode4(1222360), // Rule ID 17549 //
     /* 1222285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1222288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1222293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1222296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1222299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1222302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1222305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222324 */     // MIs[0] round
     /* 1222324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222334 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1222337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222359 */     // GIR_Coverage, 17549,
     /* 1222359 */     GIR_EraseRootFromParent_Done,
     /* 1222360 */   // Label 17707: @1222360
     /* 1222360 */   GIM_Try, /*On fail goto*//*Label 17708*/ GIMT_Encode4(1222440), // Rule ID 17552 //
     /* 1222365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1222368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1222373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1222376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1222379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1222382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1222385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222404 */     // MIs[0] round
     /* 1222404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222414 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1222417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222439 */     // GIR_Coverage, 17552,
     /* 1222439 */     GIR_EraseRootFromParent_Done,
     /* 1222440 */   // Label 17708: @1222440
     /* 1222440 */   GIM_Try, /*On fail goto*//*Label 17709*/ GIMT_Encode4(1222520), // Rule ID 17553 //
     /* 1222445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1222448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1222453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1222456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1222459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1222462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1222465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222484 */     // MIs[0] round
     /* 1222484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222494 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1222497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222519 */     // GIR_Coverage, 17553,
     /* 1222519 */     GIR_EraseRootFromParent_Done,
     /* 1222520 */   // Label 17709: @1222520
     /* 1222520 */   GIM_Try, /*On fail goto*//*Label 17710*/ GIMT_Encode4(1222600), // Rule ID 17556 //
     /* 1222525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1222533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1222536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1222539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1222542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222564 */     // MIs[0] round
     /* 1222564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222574 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1222577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222599 */     // GIR_Coverage, 17556,
     /* 1222599 */     GIR_EraseRootFromParent_Done,
     /* 1222600 */   // Label 17710: @1222600
     /* 1222600 */   GIM_Try, /*On fail goto*//*Label 17711*/ GIMT_Encode4(1222680), // Rule ID 17557 //
     /* 1222605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1222613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1222616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1222619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1222622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222644 */     // MIs[0] round
     /* 1222644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222654 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1222657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222679 */     // GIR_Coverage, 17557,
     /* 1222679 */     GIR_EraseRootFromParent_Done,
     /* 1222680 */   // Label 17711: @1222680
     /* 1222680 */   GIM_Try, /*On fail goto*//*Label 17712*/ GIMT_Encode4(1222760), // Rule ID 17560 //
     /* 1222685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1222693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1222696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1222699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1222702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222724 */     // MIs[0] round
     /* 1222724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222734 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1222737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222759 */     // GIR_Coverage, 17560,
     /* 1222759 */     GIR_EraseRootFromParent_Done,
     /* 1222760 */   // Label 17712: @1222760
     /* 1222760 */   GIM_Try, /*On fail goto*//*Label 17713*/ GIMT_Encode4(1222840), // Rule ID 17561 //
     /* 1222765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1222773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1222776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1222779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1222782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222804 */     // MIs[0] round
     /* 1222804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222814 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1222817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222839 */     // GIR_Coverage, 17561,
     /* 1222839 */     GIR_EraseRootFromParent_Done,
     /* 1222840 */   // Label 17713: @1222840
     /* 1222840 */   GIM_Try, /*On fail goto*//*Label 17714*/ GIMT_Encode4(1222920), // Rule ID 17564 //
     /* 1222845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1222853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1222856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1222859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1222862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222884 */     // MIs[0] round
     /* 1222884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222894 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1222897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222919 */     // GIR_Coverage, 17564,
     /* 1222919 */     GIR_EraseRootFromParent_Done,
     /* 1222920 */   // Label 17714: @1222920
     /* 1222920 */   GIM_Try, /*On fail goto*//*Label 17715*/ GIMT_Encode4(1223000), // Rule ID 17565 //
     /* 1222925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1222928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1222933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1222936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1222939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1222942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222964 */     // MIs[0] round
     /* 1222964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222974 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1222977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222999 */     // GIR_Coverage, 17565,
     /* 1222999 */     GIR_EraseRootFromParent_Done,
     /* 1223000 */   // Label 17715: @1223000
     /* 1223000 */   GIM_Try, /*On fail goto*//*Label 17716*/ GIMT_Encode4(1223080), // Rule ID 17568 //
     /* 1223005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1223008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1223013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1223016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1223019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1223022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1223025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1223044 */     // MIs[0] round
     /* 1223044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223054 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1223057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223079 */     // GIR_Coverage, 17568,
     /* 1223079 */     GIR_EraseRootFromParent_Done,
     /* 1223080 */   // Label 17716: @1223080
     /* 1223080 */   GIM_Try, /*On fail goto*//*Label 17717*/ GIMT_Encode4(1223160), // Rule ID 17569 //
     /* 1223085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1223088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1223093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1223096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1223099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1223102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1223105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1223124 */     // MIs[0] round
     /* 1223124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223134 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1223137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223159 */     // GIR_Coverage, 17569,
     /* 1223159 */     GIR_EraseRootFromParent_Done,
     /* 1223160 */   // Label 17717: @1223160
     /* 1223160 */   GIM_Try, /*On fail goto*//*Label 17718*/ GIMT_Encode4(1223240), // Rule ID 17572 //
     /* 1223165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1223168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1223173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1223182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223204 */     // MIs[0] round
     /* 1223204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223214 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1223217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223239 */     // GIR_Coverage, 17572,
     /* 1223239 */     GIR_EraseRootFromParent_Done,
     /* 1223240 */   // Label 17718: @1223240
     /* 1223240 */   GIM_Try, /*On fail goto*//*Label 17719*/ GIMT_Encode4(1223320), // Rule ID 17573 //
     /* 1223245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1223248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1223253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1223262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223284 */     // MIs[0] round
     /* 1223284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223294 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1223297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223319 */     // GIR_Coverage, 17573,
     /* 1223319 */     GIR_EraseRootFromParent_Done,
     /* 1223320 */   // Label 17719: @1223320
     /* 1223320 */   GIM_Try, /*On fail goto*//*Label 17720*/ GIMT_Encode4(1223400), // Rule ID 17576 //
     /* 1223325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1223333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1223336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1223339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1223342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223364 */     // MIs[0] round
     /* 1223364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223374 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1223377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223399 */     // GIR_Coverage, 17576,
     /* 1223399 */     GIR_EraseRootFromParent_Done,
     /* 1223400 */   // Label 17720: @1223400
     /* 1223400 */   GIM_Try, /*On fail goto*//*Label 17721*/ GIMT_Encode4(1223480), // Rule ID 17577 //
     /* 1223405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1223413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1223416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1223419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1223422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223444 */     // MIs[0] round
     /* 1223444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223454 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1223457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223479 */     // GIR_Coverage, 17577,
     /* 1223479 */     GIR_EraseRootFromParent_Done,
     /* 1223480 */   // Label 17721: @1223480
     /* 1223480 */   GIM_Try, /*On fail goto*//*Label 17722*/ GIMT_Encode4(1223560), // Rule ID 17580 //
     /* 1223485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1223488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1223493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1223496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1223499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1223502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1223505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1223524 */     // MIs[0] round
     /* 1223524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223534 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1223537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223559 */     // GIR_Coverage, 17580,
     /* 1223559 */     GIR_EraseRootFromParent_Done,
     /* 1223560 */   // Label 17722: @1223560
     /* 1223560 */   GIM_Try, /*On fail goto*//*Label 17723*/ GIMT_Encode4(1223640), // Rule ID 17581 //
     /* 1223565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1223568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1223573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1223576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1223579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1223582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1223585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1223604 */     // MIs[0] round
     /* 1223604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223614 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1223617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223639 */     // GIR_Coverage, 17581,
     /* 1223639 */     GIR_EraseRootFromParent_Done,
     /* 1223640 */   // Label 17723: @1223640
     /* 1223640 */   GIM_Try, /*On fail goto*//*Label 17724*/ GIMT_Encode4(1223720), // Rule ID 17584 //
     /* 1223645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1223648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1223653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1223656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1223659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1223662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1223665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1223684 */     // MIs[0] round
     /* 1223684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223694 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1223697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223719 */     // GIR_Coverage, 17584,
     /* 1223719 */     GIR_EraseRootFromParent_Done,
     /* 1223720 */   // Label 17724: @1223720
     /* 1223720 */   GIM_Try, /*On fail goto*//*Label 17725*/ GIMT_Encode4(1223800), // Rule ID 17585 //
     /* 1223725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1223728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1223733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1223736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1223739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1223742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1223745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1223764 */     // MIs[0] round
     /* 1223764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223774 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1223777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223799 */     // GIR_Coverage, 17585,
     /* 1223799 */     GIR_EraseRootFromParent_Done,
     /* 1223800 */   // Label 17725: @1223800
     /* 1223800 */   GIM_Try, /*On fail goto*//*Label 17726*/ GIMT_Encode4(1223880), // Rule ID 17588 //
     /* 1223805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1223808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1223813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1223816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1223819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1223822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1223825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1223844 */     // MIs[0] round
     /* 1223844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223854 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1223857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223879 */     // GIR_Coverage, 17588,
     /* 1223879 */     GIR_EraseRootFromParent_Done,
     /* 1223880 */   // Label 17726: @1223880
     /* 1223880 */   GIM_Try, /*On fail goto*//*Label 17727*/ GIMT_Encode4(1223960), // Rule ID 17589 //
     /* 1223885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1223888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1223893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1223896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1223899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1223902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1223905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1223924 */     // MIs[0] round
     /* 1223924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223934 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1223937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223959 */     // GIR_Coverage, 17589,
     /* 1223959 */     GIR_EraseRootFromParent_Done,
     /* 1223960 */   // Label 17727: @1223960
     /* 1223960 */   GIM_Try, /*On fail goto*//*Label 17728*/ GIMT_Encode4(1224040), // Rule ID 17592 //
     /* 1223965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1223968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1223973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1223976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1223979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1223982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1224004 */     // MIs[0] round
     /* 1224004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224014 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1224017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224039 */     // GIR_Coverage, 17592,
     /* 1224039 */     GIR_EraseRootFromParent_Done,
     /* 1224040 */   // Label 17728: @1224040
     /* 1224040 */   GIM_Try, /*On fail goto*//*Label 17729*/ GIMT_Encode4(1224120), // Rule ID 17593 //
     /* 1224045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1224048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1224053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1224056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1224059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1224062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1224065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1224084 */     // MIs[0] round
     /* 1224084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224094 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1224097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224119 */     // GIR_Coverage, 17593,
     /* 1224119 */     GIR_EraseRootFromParent_Done,
     /* 1224120 */   // Label 17729: @1224120
     /* 1224120 */   GIM_Try, /*On fail goto*//*Label 17730*/ GIMT_Encode4(1224200), // Rule ID 17596 //
     /* 1224125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1224128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1224133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1224136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1224139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1224142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1224145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1224164 */     // MIs[0] round
     /* 1224164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224174 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1224177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224199 */     // GIR_Coverage, 17596,
     /* 1224199 */     GIR_EraseRootFromParent_Done,
     /* 1224200 */   // Label 17730: @1224200
     /* 1224200 */   GIM_Try, /*On fail goto*//*Label 17731*/ GIMT_Encode4(1224280), // Rule ID 17597 //
     /* 1224205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1224208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1224213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1224216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1224219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1224222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1224225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1224244 */     // MIs[0] round
     /* 1224244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224254 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1224257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224279 */     // GIR_Coverage, 17597,
     /* 1224279 */     GIR_EraseRootFromParent_Done,
     /* 1224280 */   // Label 17731: @1224280
     /* 1224280 */   GIM_Try, /*On fail goto*//*Label 17732*/ GIMT_Encode4(1224360), // Rule ID 17600 //
     /* 1224285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1224288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1224293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1224296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1224299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1224302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1224305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1224324 */     // MIs[0] round
     /* 1224324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224334 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1224337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224359 */     // GIR_Coverage, 17600,
     /* 1224359 */     GIR_EraseRootFromParent_Done,
     /* 1224360 */   // Label 17732: @1224360
     /* 1224360 */   GIM_Try, /*On fail goto*//*Label 17733*/ GIMT_Encode4(1224440), // Rule ID 17601 //
     /* 1224365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1224368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1224373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1224376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1224379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1224382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1224385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1224404 */     // MIs[0] round
     /* 1224404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224414 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1224417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224439 */     // GIR_Coverage, 17601,
     /* 1224439 */     GIR_EraseRootFromParent_Done,
     /* 1224440 */   // Label 17733: @1224440
     /* 1224440 */   GIM_Try, /*On fail goto*//*Label 17734*/ GIMT_Encode4(1224520), // Rule ID 17604 //
     /* 1224445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1224448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1224453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1224456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1224459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1224462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1224465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1224484 */     // MIs[0] round
     /* 1224484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224494 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1224497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1224515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224519 */     // GIR_Coverage, 17604,
     /* 1224519 */     GIR_EraseRootFromParent_Done,
     /* 1224520 */   // Label 17734: @1224520
     /* 1224520 */   GIM_Try, /*On fail goto*//*Label 17735*/ GIMT_Encode4(1224600), // Rule ID 17605 //
     /* 1224525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1224528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1224533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1224536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1224539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1224542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1224545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1224564 */     // MIs[0] round
     /* 1224564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224574 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1224577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1224595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224599 */     // GIR_Coverage, 17605,
     /* 1224599 */     GIR_EraseRootFromParent_Done,
     /* 1224600 */   // Label 17735: @1224600
     /* 1224600 */   GIM_Try, /*On fail goto*//*Label 17736*/ GIMT_Encode4(1224680), // Rule ID 17608 //
     /* 1224605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1224608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1224613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1224616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1224619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1224622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1224625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1224644 */     // MIs[0] round
     /* 1224644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224654 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1224657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1224675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224679 */     // GIR_Coverage, 17608,
     /* 1224679 */     GIR_EraseRootFromParent_Done,
     /* 1224680 */   // Label 17736: @1224680
     /* 1224680 */   GIM_Try, /*On fail goto*//*Label 17737*/ GIMT_Encode4(1224760), // Rule ID 17609 //
     /* 1224685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1224688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1224693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1224696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1224699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1224702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1224705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1224724 */     // MIs[0] round
     /* 1224724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224734 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1224737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1224755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224759 */     // GIR_Coverage, 17609,
     /* 1224759 */     GIR_EraseRootFromParent_Done,
     /* 1224760 */   // Label 17737: @1224760
     /* 1224760 */   GIM_Try, /*On fail goto*//*Label 17738*/ GIMT_Encode4(1224840), // Rule ID 17612 //
     /* 1224765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1224768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1224773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1224776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1224779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1224782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1224785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1224804 */     // MIs[0] round
     /* 1224804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224814 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1224817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1224835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224839 */     // GIR_Coverage, 17612,
     /* 1224839 */     GIR_EraseRootFromParent_Done,
     /* 1224840 */   // Label 17738: @1224840
     /* 1224840 */   GIM_Try, /*On fail goto*//*Label 17739*/ GIMT_Encode4(1224920), // Rule ID 17613 //
     /* 1224845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1224848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1224853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1224856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1224859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1224862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1224865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1224884 */     // MIs[0] round
     /* 1224884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224894 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1224897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1224915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224919 */     // GIR_Coverage, 17613,
     /* 1224919 */     GIR_EraseRootFromParent_Done,
     /* 1224920 */   // Label 17739: @1224920
     /* 1224920 */   GIM_Try, /*On fail goto*//*Label 17740*/ GIMT_Encode4(1225000), // Rule ID 17616 //
     /* 1224925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1224928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1224933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1224936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1224939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1224942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1224945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1224964 */     // MIs[0] round
     /* 1224964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224974 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1224977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224999 */     // GIR_Coverage, 17616,
     /* 1224999 */     GIR_EraseRootFromParent_Done,
     /* 1225000 */   // Label 17740: @1225000
     /* 1225000 */   GIM_Try, /*On fail goto*//*Label 17741*/ GIMT_Encode4(1225080), // Rule ID 17617 //
     /* 1225005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1225008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1225013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1225016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1225019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1225022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225044 */     // MIs[0] round
     /* 1225044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225054 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1225057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225079 */     // GIR_Coverage, 17617,
     /* 1225079 */     GIR_EraseRootFromParent_Done,
     /* 1225080 */   // Label 17741: @1225080
     /* 1225080 */   GIM_Try, /*On fail goto*//*Label 17742*/ GIMT_Encode4(1225160), // Rule ID 17620 //
     /* 1225085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1225088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1225093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1225096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1225099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1225102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225124 */     // MIs[0] round
     /* 1225124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225134 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1225137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225159 */     // GIR_Coverage, 17620,
     /* 1225159 */     GIR_EraseRootFromParent_Done,
     /* 1225160 */   // Label 17742: @1225160
     /* 1225160 */   GIM_Try, /*On fail goto*//*Label 17743*/ GIMT_Encode4(1225240), // Rule ID 17621 //
     /* 1225165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1225168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1225173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1225176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1225179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1225182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225204 */     // MIs[0] round
     /* 1225204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225214 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1225217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225239 */     // GIR_Coverage, 17621,
     /* 1225239 */     GIR_EraseRootFromParent_Done,
     /* 1225240 */   // Label 17743: @1225240
     /* 1225240 */   GIM_Try, /*On fail goto*//*Label 17744*/ GIMT_Encode4(1225320), // Rule ID 17624 //
     /* 1225245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1225248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1225253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1225256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1225259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1225262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225284 */     // MIs[0] round
     /* 1225284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225294 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1225297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225319 */     // GIR_Coverage, 17624,
     /* 1225319 */     GIR_EraseRootFromParent_Done,
     /* 1225320 */   // Label 17744: @1225320
     /* 1225320 */   GIM_Try, /*On fail goto*//*Label 17745*/ GIMT_Encode4(1225400), // Rule ID 17625 //
     /* 1225325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1225328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1225333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1225336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1225339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1225342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225364 */     // MIs[0] round
     /* 1225364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225374 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1225377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225399 */     // GIR_Coverage, 17625,
     /* 1225399 */     GIR_EraseRootFromParent_Done,
     /* 1225400 */   // Label 17745: @1225400
     /* 1225400 */   GIM_Try, /*On fail goto*//*Label 17746*/ GIMT_Encode4(1225480), // Rule ID 17628 //
     /* 1225405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1225408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1225413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1225416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1225419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1225422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225444 */     // MIs[0] round
     /* 1225444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225454 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1225457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225479 */     // GIR_Coverage, 17628,
     /* 1225479 */     GIR_EraseRootFromParent_Done,
     /* 1225480 */   // Label 17746: @1225480
     /* 1225480 */   GIM_Try, /*On fail goto*//*Label 17747*/ GIMT_Encode4(1225560), // Rule ID 17629 //
     /* 1225485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1225488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1225493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1225496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1225499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1225502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225524 */     // MIs[0] round
     /* 1225524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225534 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1225537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225559 */     // GIR_Coverage, 17629,
     /* 1225559 */     GIR_EraseRootFromParent_Done,
     /* 1225560 */   // Label 17747: @1225560
     /* 1225560 */   GIM_Try, /*On fail goto*//*Label 17748*/ GIMT_Encode4(1225640), // Rule ID 17632 //
     /* 1225565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1225568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1225573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1225582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225604 */     // MIs[0] round
     /* 1225604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225614 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1225617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225639 */     // GIR_Coverage, 17632,
     /* 1225639 */     GIR_EraseRootFromParent_Done,
     /* 1225640 */   // Label 17748: @1225640
     /* 1225640 */   GIM_Try, /*On fail goto*//*Label 17749*/ GIMT_Encode4(1225720), // Rule ID 17633 //
     /* 1225645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1225648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1225653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1225662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225684 */     // MIs[0] round
     /* 1225684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225694 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1225697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225719 */     // GIR_Coverage, 17633,
     /* 1225719 */     GIR_EraseRootFromParent_Done,
     /* 1225720 */   // Label 17749: @1225720
     /* 1225720 */   GIM_Try, /*On fail goto*//*Label 17750*/ GIMT_Encode4(1225800), // Rule ID 17636 //
     /* 1225725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1225728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1225733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1225736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1225739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1225742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1225745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1225764 */     // MIs[0] round
     /* 1225764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225774 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1225777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1225795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225799 */     // GIR_Coverage, 17636,
     /* 1225799 */     GIR_EraseRootFromParent_Done,
     /* 1225800 */   // Label 17750: @1225800
     /* 1225800 */   GIM_Try, /*On fail goto*//*Label 17751*/ GIMT_Encode4(1225880), // Rule ID 17637 //
     /* 1225805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1225808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1225813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1225816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1225819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1225822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1225825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1225844 */     // MIs[0] round
     /* 1225844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225854 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1225857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1225875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225879 */     // GIR_Coverage, 17637,
     /* 1225879 */     GIR_EraseRootFromParent_Done,
     /* 1225880 */   // Label 17751: @1225880
     /* 1225880 */   GIM_Try, /*On fail goto*//*Label 17752*/ GIMT_Encode4(1225960), // Rule ID 17640 //
     /* 1225885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1225888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1225893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1225896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1225899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1225902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225924 */     // MIs[0] round
     /* 1225924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225934 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1225937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225959 */     // GIR_Coverage, 17640,
     /* 1225959 */     GIR_EraseRootFromParent_Done,
     /* 1225960 */   // Label 17752: @1225960
     /* 1225960 */   GIM_Try, /*On fail goto*//*Label 17753*/ GIMT_Encode4(1226040), // Rule ID 17641 //
     /* 1225965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1225968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1225973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1225976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1225979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1225982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1226004 */     // MIs[0] round
     /* 1226004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226014 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1226017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226039 */     // GIR_Coverage, 17641,
     /* 1226039 */     GIR_EraseRootFromParent_Done,
     /* 1226040 */   // Label 17753: @1226040
     /* 1226040 */   GIM_Try, /*On fail goto*//*Label 17754*/ GIMT_Encode4(1226120), // Rule ID 17644 //
     /* 1226045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1226053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1226056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1226059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1226062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1226065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1226084 */     // MIs[0] round
     /* 1226084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226094 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1226097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226119 */     // GIR_Coverage, 17644,
     /* 1226119 */     GIR_EraseRootFromParent_Done,
     /* 1226120 */   // Label 17754: @1226120
     /* 1226120 */   GIM_Try, /*On fail goto*//*Label 17755*/ GIMT_Encode4(1226200), // Rule ID 17645 //
     /* 1226125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1226133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1226136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1226139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1226142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1226145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1226164 */     // MIs[0] round
     /* 1226164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226174 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1226177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226199 */     // GIR_Coverage, 17645,
     /* 1226199 */     GIR_EraseRootFromParent_Done,
     /* 1226200 */   // Label 17755: @1226200
     /* 1226200 */   GIM_Try, /*On fail goto*//*Label 17756*/ GIMT_Encode4(1226280), // Rule ID 17648 //
     /* 1226205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1226213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1226216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1226219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1226222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1226225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1226244 */     // MIs[0] round
     /* 1226244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226254 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1226257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226279 */     // GIR_Coverage, 17648,
     /* 1226279 */     GIR_EraseRootFromParent_Done,
     /* 1226280 */   // Label 17756: @1226280
     /* 1226280 */   GIM_Try, /*On fail goto*//*Label 17757*/ GIMT_Encode4(1226360), // Rule ID 17649 //
     /* 1226285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1226293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1226296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1226299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1226302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1226305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1226324 */     // MIs[0] round
     /* 1226324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226334 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1226337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226359 */     // GIR_Coverage, 17649,
     /* 1226359 */     GIR_EraseRootFromParent_Done,
     /* 1226360 */   // Label 17757: @1226360
     /* 1226360 */   GIM_Try, /*On fail goto*//*Label 17758*/ GIMT_Encode4(1226440), // Rule ID 17652 //
     /* 1226365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1226373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1226376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1226379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1226382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226404 */     // MIs[0] round
     /* 1226404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226414 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1226417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226439 */     // GIR_Coverage, 17652,
     /* 1226439 */     GIR_EraseRootFromParent_Done,
     /* 1226440 */   // Label 17758: @1226440
     /* 1226440 */   GIM_Try, /*On fail goto*//*Label 17759*/ GIMT_Encode4(1226520), // Rule ID 17653 //
     /* 1226445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1226448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1226453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1226456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1226459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1226462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226484 */     // MIs[0] round
     /* 1226484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226494 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1226497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226519 */     // GIR_Coverage, 17653,
     /* 1226519 */     GIR_EraseRootFromParent_Done,
     /* 1226520 */   // Label 17759: @1226520
     /* 1226520 */   GIM_Try, /*On fail goto*//*Label 17760*/ GIMT_Encode4(1226600), // Rule ID 17656 //
     /* 1226525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1226533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1226536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1226539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1226542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226564 */     // MIs[0] round
     /* 1226564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226574 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1226577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226599 */     // GIR_Coverage, 17656,
     /* 1226599 */     GIR_EraseRootFromParent_Done,
     /* 1226600 */   // Label 17760: @1226600
     /* 1226600 */   GIM_Try, /*On fail goto*//*Label 17761*/ GIMT_Encode4(1226680), // Rule ID 17657 //
     /* 1226605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1226608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1226613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1226616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1226619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1226622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226644 */     // MIs[0] round
     /* 1226644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226654 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1226657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226679 */     // GIR_Coverage, 17657,
     /* 1226679 */     GIR_EraseRootFromParent_Done,
     /* 1226680 */   // Label 17761: @1226680
     /* 1226680 */   GIM_Try, /*On fail goto*//*Label 17762*/ GIMT_Encode4(1226760), // Rule ID 17660 //
     /* 1226685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1226693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1226696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1226699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1226702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226724 */     // MIs[0] round
     /* 1226724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226734 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1226737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226759 */     // GIR_Coverage, 17660,
     /* 1226759 */     GIR_EraseRootFromParent_Done,
     /* 1226760 */   // Label 17762: @1226760
     /* 1226760 */   GIM_Try, /*On fail goto*//*Label 17763*/ GIMT_Encode4(1226840), // Rule ID 17661 //
     /* 1226765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1226768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1226773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1226776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1226779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1226782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226804 */     // MIs[0] round
     /* 1226804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226814 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1226817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226839 */     // GIR_Coverage, 17661,
     /* 1226839 */     GIR_EraseRootFromParent_Done,
     /* 1226840 */   // Label 17763: @1226840
     /* 1226840 */   GIM_Try, /*On fail goto*//*Label 17764*/ GIMT_Encode4(1226920), // Rule ID 17664 //
     /* 1226845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1226848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1226853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1226856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1226859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1226862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1226865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1226884 */     // MIs[0] round
     /* 1226884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226894 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1226897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1226915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226919 */     // GIR_Coverage, 17664,
     /* 1226919 */     GIR_EraseRootFromParent_Done,
     /* 1226920 */   // Label 17764: @1226920
     /* 1226920 */   GIM_Try, /*On fail goto*//*Label 17765*/ GIMT_Encode4(1227000), // Rule ID 17665 //
     /* 1226925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1226928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1226933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1226936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1226939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1226942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1226945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1226964 */     // MIs[0] round
     /* 1226964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226974 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1226977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1226995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226999 */     // GIR_Coverage, 17665,
     /* 1226999 */     GIR_EraseRootFromParent_Done,
     /* 1227000 */   // Label 17765: @1227000
     /* 1227000 */   GIM_Try, /*On fail goto*//*Label 17766*/ GIMT_Encode4(1227080), // Rule ID 17668 //
     /* 1227005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1227008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1227013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1227016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1227019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1227022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1227025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1227044 */     // MIs[0] round
     /* 1227044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227054 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1227057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227079 */     // GIR_Coverage, 17668,
     /* 1227079 */     GIR_EraseRootFromParent_Done,
     /* 1227080 */   // Label 17766: @1227080
     /* 1227080 */   GIM_Try, /*On fail goto*//*Label 17767*/ GIMT_Encode4(1227160), // Rule ID 17669 //
     /* 1227085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1227088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1227093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1227096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1227099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1227102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1227105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1227124 */     // MIs[0] round
     /* 1227124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227134 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1227137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227159 */     // GIR_Coverage, 17669,
     /* 1227159 */     GIR_EraseRootFromParent_Done,
     /* 1227160 */   // Label 17767: @1227160
     /* 1227160 */   GIM_Try, /*On fail goto*//*Label 17768*/ GIMT_Encode4(1227240), // Rule ID 17672 //
     /* 1227165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1227168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1227173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1227176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1227179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1227182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1227185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1227204 */     // MIs[0] round
     /* 1227204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227214 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1227217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227239 */     // GIR_Coverage, 17672,
     /* 1227239 */     GIR_EraseRootFromParent_Done,
     /* 1227240 */   // Label 17768: @1227240
     /* 1227240 */   GIM_Try, /*On fail goto*//*Label 17769*/ GIMT_Encode4(1227320), // Rule ID 17673 //
     /* 1227245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1227248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1227253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1227256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1227259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1227262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1227265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1227284 */     // MIs[0] round
     /* 1227284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227294 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1227297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227319 */     // GIR_Coverage, 17673,
     /* 1227319 */     GIR_EraseRootFromParent_Done,
     /* 1227320 */   // Label 17769: @1227320
     /* 1227320 */   GIM_Try, /*On fail goto*//*Label 17770*/ GIMT_Encode4(1227400), // Rule ID 17676 //
     /* 1227325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1227328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1227333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1227336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1227339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1227342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1227345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227364 */     // MIs[0] round
     /* 1227364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227374 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1227377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227399 */     // GIR_Coverage, 17676,
     /* 1227399 */     GIR_EraseRootFromParent_Done,
     /* 1227400 */   // Label 17770: @1227400
     /* 1227400 */   GIM_Try, /*On fail goto*//*Label 17771*/ GIMT_Encode4(1227480), // Rule ID 17677 //
     /* 1227405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1227408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1227413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1227416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1227419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1227422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1227425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227444 */     // MIs[0] round
     /* 1227444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227454 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1227457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227479 */     // GIR_Coverage, 17677,
     /* 1227479 */     GIR_EraseRootFromParent_Done,
     /* 1227480 */   // Label 17771: @1227480
     /* 1227480 */   GIM_Try, /*On fail goto*//*Label 17772*/ GIMT_Encode4(1227560), // Rule ID 17680 //
     /* 1227485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1227488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1227493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1227502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1227505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227524 */     // MIs[0] round
     /* 1227524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227534 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1227537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227559 */     // GIR_Coverage, 17680,
     /* 1227559 */     GIR_EraseRootFromParent_Done,
     /* 1227560 */   // Label 17772: @1227560
     /* 1227560 */   GIM_Try, /*On fail goto*//*Label 17773*/ GIMT_Encode4(1227640), // Rule ID 17681 //
     /* 1227565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1227568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1227573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1227582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1227585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227604 */     // MIs[0] round
     /* 1227604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227614 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1227617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227639 */     // GIR_Coverage, 17681,
     /* 1227639 */     GIR_EraseRootFromParent_Done,
     /* 1227640 */   // Label 17773: @1227640
     /* 1227640 */   GIM_Try, /*On fail goto*//*Label 17774*/ GIMT_Encode4(1227720), // Rule ID 17684 //
     /* 1227645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1227648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1227653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1227656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1227659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1227662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227684 */     // MIs[0] round
     /* 1227684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227694 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1227697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227719 */     // GIR_Coverage, 17684,
     /* 1227719 */     GIR_EraseRootFromParent_Done,
     /* 1227720 */   // Label 17774: @1227720
     /* 1227720 */   GIM_Try, /*On fail goto*//*Label 17775*/ GIMT_Encode4(1227800), // Rule ID 17685 //
     /* 1227725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1227728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1227733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1227736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1227739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1227742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227764 */     // MIs[0] round
     /* 1227764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227774 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1227777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227799 */     // GIR_Coverage, 17685,
     /* 1227799 */     GIR_EraseRootFromParent_Done,
     /* 1227800 */   // Label 17775: @1227800
     /* 1227800 */   GIM_Try, /*On fail goto*//*Label 17776*/ GIMT_Encode4(1227880), // Rule ID 17688 //
     /* 1227805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1227808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1227813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1227816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1227819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1227822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1227825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227844 */     // MIs[0] round
     /* 1227844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227854 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1227857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227879 */     // GIR_Coverage, 17688,
     /* 1227879 */     GIR_EraseRootFromParent_Done,
     /* 1227880 */   // Label 17776: @1227880
     /* 1227880 */   GIM_Try, /*On fail goto*//*Label 17777*/ GIMT_Encode4(1227960), // Rule ID 17689 //
     /* 1227885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1227888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1227893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1227896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1227899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1227902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1227905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227924 */     // MIs[0] round
     /* 1227924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227934 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1227937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1227941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227959 */     // GIR_Coverage, 17689,
     /* 1227959 */     GIR_EraseRootFromParent_Done,
     /* 1227960 */   // Label 17777: @1227960
     /* 1227960 */   GIM_Try, /*On fail goto*//*Label 17778*/ GIMT_Encode4(1228040), // Rule ID 17692 //
     /* 1227965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1227968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1227973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1227976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1227979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1227982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1227985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228004 */     // MIs[0] round
     /* 1228004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228014 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1228017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228039 */     // GIR_Coverage, 17692,
     /* 1228039 */     GIR_EraseRootFromParent_Done,
     /* 1228040 */   // Label 17778: @1228040
     /* 1228040 */   GIM_Try, /*On fail goto*//*Label 17779*/ GIMT_Encode4(1228120), // Rule ID 17693 //
     /* 1228045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1228048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1228053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1228056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1228059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1228062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1228065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228084 */     // MIs[0] round
     /* 1228084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228094 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1228097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228119 */     // GIR_Coverage, 17693,
     /* 1228119 */     GIR_EraseRootFromParent_Done,
     /* 1228120 */   // Label 17779: @1228120
     /* 1228120 */   GIM_Try, /*On fail goto*//*Label 17780*/ GIMT_Encode4(1228200), // Rule ID 17696 //
     /* 1228125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1228128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1228133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1228142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1228145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228164 */     // MIs[0] round
     /* 1228164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228174 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1228177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228199 */     // GIR_Coverage, 17696,
     /* 1228199 */     GIR_EraseRootFromParent_Done,
     /* 1228200 */   // Label 17780: @1228200
     /* 1228200 */   GIM_Try, /*On fail goto*//*Label 17781*/ GIMT_Encode4(1228280), // Rule ID 17697 //
     /* 1228205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1228208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1228213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1228222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1228225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228244 */     // MIs[0] round
     /* 1228244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228254 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1228257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228279 */     // GIR_Coverage, 17697,
     /* 1228279 */     GIR_EraseRootFromParent_Done,
     /* 1228280 */   // Label 17781: @1228280
     /* 1228280 */   GIM_Try, /*On fail goto*//*Label 17782*/ GIMT_Encode4(1228360), // Rule ID 17700 //
     /* 1228285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1228288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1228293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1228296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1228299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1228302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228324 */     // MIs[0] round
     /* 1228324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228334 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1228337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228359 */     // GIR_Coverage, 17700,
     /* 1228359 */     GIR_EraseRootFromParent_Done,
     /* 1228360 */   // Label 17782: @1228360
     /* 1228360 */   GIM_Try, /*On fail goto*//*Label 17783*/ GIMT_Encode4(1228440), // Rule ID 17701 //
     /* 1228365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1228368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1228373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1228376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1228379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1228382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228404 */     // MIs[0] round
     /* 1228404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228414 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1228417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228439 */     // GIR_Coverage, 17701,
     /* 1228439 */     GIR_EraseRootFromParent_Done,
     /* 1228440 */   // Label 17783: @1228440
     /* 1228440 */   GIM_Try, /*On fail goto*//*Label 17784*/ GIMT_Encode4(1228520), // Rule ID 17704 //
     /* 1228445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1228448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1228453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1228456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1228459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1228462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1228465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228484 */     // MIs[0] round
     /* 1228484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228494 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1228497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228519 */     // GIR_Coverage, 17704,
     /* 1228519 */     GIR_EraseRootFromParent_Done,
     /* 1228520 */   // Label 17784: @1228520
     /* 1228520 */   GIM_Try, /*On fail goto*//*Label 17785*/ GIMT_Encode4(1228600), // Rule ID 17705 //
     /* 1228525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1228528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1228533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1228536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1228539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1228542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1228545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228564 */     // MIs[0] round
     /* 1228564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228574 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1228577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228599 */     // GIR_Coverage, 17705,
     /* 1228599 */     GIR_EraseRootFromParent_Done,
     /* 1228600 */   // Label 17785: @1228600
     /* 1228600 */   GIM_Try, /*On fail goto*//*Label 17786*/ GIMT_Encode4(1228680), // Rule ID 17708 //
     /* 1228605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1228608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1228613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1228616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1228619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1228622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1228625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228644 */     // MIs[0] round
     /* 1228644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228654 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1228657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228679 */     // GIR_Coverage, 17708,
     /* 1228679 */     GIR_EraseRootFromParent_Done,
     /* 1228680 */   // Label 17786: @1228680
     /* 1228680 */   GIM_Try, /*On fail goto*//*Label 17787*/ GIMT_Encode4(1228760), // Rule ID 17709 //
     /* 1228685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1228688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1228693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1228696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1228699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1228702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1228705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228724 */     // MIs[0] round
     /* 1228724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228734 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1228737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228759 */     // GIR_Coverage, 17709,
     /* 1228759 */     GIR_EraseRootFromParent_Done,
     /* 1228760 */   // Label 17787: @1228760
     /* 1228760 */   GIM_Try, /*On fail goto*//*Label 17788*/ GIMT_Encode4(1228840), // Rule ID 17712 //
     /* 1228765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1228768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1228773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1228776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1228779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1228782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1228785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1228804 */     // MIs[0] round
     /* 1228804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228814 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1228817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228839 */     // GIR_Coverage, 17712,
     /* 1228839 */     GIR_EraseRootFromParent_Done,
     /* 1228840 */   // Label 17788: @1228840
     /* 1228840 */   GIM_Try, /*On fail goto*//*Label 17789*/ GIMT_Encode4(1228920), // Rule ID 17713 //
     /* 1228845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1228848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1228853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1228856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1228859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1228862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1228865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1228884 */     // MIs[0] round
     /* 1228884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228894 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1228897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228919 */     // GIR_Coverage, 17713,
     /* 1228919 */     GIR_EraseRootFromParent_Done,
     /* 1228920 */   // Label 17789: @1228920
     /* 1228920 */   GIM_Try, /*On fail goto*//*Label 17790*/ GIMT_Encode4(1229000), // Rule ID 17716 //
     /* 1228925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1228928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1228933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1228942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1228945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1228964 */     // MIs[0] round
     /* 1228964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228974 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1228977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1228981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228999 */     // GIR_Coverage, 17716,
     /* 1228999 */     GIR_EraseRootFromParent_Done,
     /* 1229000 */   // Label 17790: @1229000
     /* 1229000 */   GIM_Try, /*On fail goto*//*Label 17791*/ GIMT_Encode4(1229080), // Rule ID 17717 //
     /* 1229005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1229008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1229013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1229022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1229025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1229044 */     // MIs[0] round
     /* 1229044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229054 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1229057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229079 */     // GIR_Coverage, 17717,
     /* 1229079 */     GIR_EraseRootFromParent_Done,
     /* 1229080 */   // Label 17791: @1229080
     /* 1229080 */   GIM_Try, /*On fail goto*//*Label 17792*/ GIMT_Encode4(1229160), // Rule ID 17720 //
     /* 1229085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1229088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1229093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1229096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1229099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1229102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1229105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1229124 */     // MIs[0] round
     /* 1229124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229134 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1229137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229159 */     // GIR_Coverage, 17720,
     /* 1229159 */     GIR_EraseRootFromParent_Done,
     /* 1229160 */   // Label 17792: @1229160
     /* 1229160 */   GIM_Try, /*On fail goto*//*Label 17793*/ GIMT_Encode4(1229240), // Rule ID 17721 //
     /* 1229165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1229168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1229173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1229176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1229179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1229182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1229185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1229204 */     // MIs[0] round
     /* 1229204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229214 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1229217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229239 */     // GIR_Coverage, 17721,
     /* 1229239 */     GIR_EraseRootFromParent_Done,
     /* 1229240 */   // Label 17793: @1229240
     /* 1229240 */   GIM_Try, /*On fail goto*//*Label 17794*/ GIMT_Encode4(1229320), // Rule ID 17724 //
     /* 1229245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1229248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1229253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1229256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1229259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1229262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1229265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1229284 */     // MIs[0] round
     /* 1229284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229294 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1229297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229319 */     // GIR_Coverage, 17724,
     /* 1229319 */     GIR_EraseRootFromParent_Done,
     /* 1229320 */   // Label 17794: @1229320
     /* 1229320 */   GIM_Try, /*On fail goto*//*Label 17795*/ GIMT_Encode4(1229400), // Rule ID 17725 //
     /* 1229325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1229328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1229333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1229336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1229339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1229342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1229345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1229364 */     // MIs[0] round
     /* 1229364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229374 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1229377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229399 */     // GIR_Coverage, 17725,
     /* 1229399 */     GIR_EraseRootFromParent_Done,
     /* 1229400 */   // Label 17795: @1229400
     /* 1229400 */   GIM_Try, /*On fail goto*//*Label 17796*/ GIMT_Encode4(1229480), // Rule ID 17728 //
     /* 1229405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1229408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1229413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1229416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1229419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1229422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1229425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1229444 */     // MIs[0] round
     /* 1229444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229454 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1229457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229479 */     // GIR_Coverage, 17728,
     /* 1229479 */     GIR_EraseRootFromParent_Done,
     /* 1229480 */   // Label 17796: @1229480
     /* 1229480 */   GIM_Try, /*On fail goto*//*Label 17797*/ GIMT_Encode4(1229560), // Rule ID 17729 //
     /* 1229485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1229488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1229493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1229496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1229499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1229502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1229505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1229524 */     // MIs[0] round
     /* 1229524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229534 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1229537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229559 */     // GIR_Coverage, 17729,
     /* 1229559 */     GIR_EraseRootFromParent_Done,
     /* 1229560 */   // Label 17797: @1229560
     /* 1229560 */   GIM_Try, /*On fail goto*//*Label 17798*/ GIMT_Encode4(1229640), // Rule ID 17732 //
     /* 1229565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1229568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1229573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1229582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1229585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1229604 */     // MIs[0] round
     /* 1229604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229614 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1229617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229639 */     // GIR_Coverage, 17732,
     /* 1229639 */     GIR_EraseRootFromParent_Done,
     /* 1229640 */   // Label 17798: @1229640
     /* 1229640 */   GIM_Try, /*On fail goto*//*Label 17799*/ GIMT_Encode4(1229720), // Rule ID 17733 //
     /* 1229645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1229648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1229653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1229662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1229665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1229684 */     // MIs[0] round
     /* 1229684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229694 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1229697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229719 */     // GIR_Coverage, 17733,
     /* 1229719 */     GIR_EraseRootFromParent_Done,
     /* 1229720 */   // Label 17799: @1229720
     /* 1229720 */   GIM_Try, /*On fail goto*//*Label 17800*/ GIMT_Encode4(1229800), // Rule ID 17736 //
     /* 1229725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1229728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1229733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1229736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1229739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1229742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1229745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1229764 */     // MIs[0] round
     /* 1229764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229774 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1229777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229799 */     // GIR_Coverage, 17736,
     /* 1229799 */     GIR_EraseRootFromParent_Done,
     /* 1229800 */   // Label 17800: @1229800
     /* 1229800 */   GIM_Try, /*On fail goto*//*Label 17801*/ GIMT_Encode4(1229880), // Rule ID 17737 //
     /* 1229805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1229808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1229813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1229816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1229819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1229822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1229825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1229844 */     // MIs[0] round
     /* 1229844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229854 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1229857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229879 */     // GIR_Coverage, 17737,
     /* 1229879 */     GIR_EraseRootFromParent_Done,
     /* 1229880 */   // Label 17801: @1229880
     /* 1229880 */   GIM_Try, /*On fail goto*//*Label 17802*/ GIMT_Encode4(1229960), // Rule ID 17740 //
     /* 1229885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1229888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1229893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1229896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1229899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1229902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1229905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1229924 */     // MIs[0] round
     /* 1229924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229934 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1229937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229959 */     // GIR_Coverage, 17740,
     /* 1229959 */     GIR_EraseRootFromParent_Done,
     /* 1229960 */   // Label 17802: @1229960
     /* 1229960 */   GIM_Try, /*On fail goto*//*Label 17803*/ GIMT_Encode4(1230040), // Rule ID 17741 //
     /* 1229965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1229968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1229973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1229976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1229979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1229982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1229985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230004 */     // MIs[0] round
     /* 1230004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230014 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1230017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230039 */     // GIR_Coverage, 17741,
     /* 1230039 */     GIR_EraseRootFromParent_Done,
     /* 1230040 */   // Label 17803: @1230040
     /* 1230040 */   GIM_Try, /*On fail goto*//*Label 17804*/ GIMT_Encode4(1230120), // Rule ID 17744 //
     /* 1230045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1230048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1230053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1230056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1230059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1230062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230084 */     // MIs[0] round
     /* 1230084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230094 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1230097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230119 */     // GIR_Coverage, 17744,
     /* 1230119 */     GIR_EraseRootFromParent_Done,
     /* 1230120 */   // Label 17804: @1230120
     /* 1230120 */   GIM_Try, /*On fail goto*//*Label 17805*/ GIMT_Encode4(1230200), // Rule ID 17745 //
     /* 1230125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1230128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1230133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1230136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1230139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1230142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230164 */     // MIs[0] round
     /* 1230164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230174 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1230177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230199 */     // GIR_Coverage, 17745,
     /* 1230199 */     GIR_EraseRootFromParent_Done,
     /* 1230200 */   // Label 17805: @1230200
     /* 1230200 */   GIM_Try, /*On fail goto*//*Label 17806*/ GIMT_Encode4(1230280), // Rule ID 22822 //
     /* 1230205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1230208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1230213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1230222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230244 */     // MIs[0] round
     /* 1230244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230254 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1230257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230279 */     // GIR_Coverage, 22822,
     /* 1230279 */     GIR_EraseRootFromParent_Done,
     /* 1230280 */   // Label 17806: @1230280
     /* 1230280 */   GIM_Try, /*On fail goto*//*Label 17807*/ GIMT_Encode4(1230360), // Rule ID 22823 //
     /* 1230285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1230288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1230293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1230302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230324 */     // MIs[0] round
     /* 1230324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230334 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1230337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230359 */     // GIR_Coverage, 22823,
     /* 1230359 */     GIR_EraseRootFromParent_Done,
     /* 1230360 */   // Label 17807: @1230360
     /* 1230360 */   GIM_Try, /*On fail goto*//*Label 17808*/ GIMT_Encode4(1230440), // Rule ID 22826 //
     /* 1230365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1230373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1230382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230404 */     // MIs[0] round
     /* 1230404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230414 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1230417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230439 */     // GIR_Coverage, 22826,
     /* 1230439 */     GIR_EraseRootFromParent_Done,
     /* 1230440 */   // Label 17808: @1230440
     /* 1230440 */   GIM_Try, /*On fail goto*//*Label 17809*/ GIMT_Encode4(1230520), // Rule ID 22827 //
     /* 1230445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1230453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1230462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230484 */     // MIs[0] round
     /* 1230484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230494 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1230497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230519 */     // GIR_Coverage, 22827,
     /* 1230519 */     GIR_EraseRootFromParent_Done,
     /* 1230520 */   // Label 17809: @1230520
     /* 1230520 */   GIM_Try, /*On fail goto*//*Label 17810*/ GIMT_Encode4(1230600), // Rule ID 22830 //
     /* 1230525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1230528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1230533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1230542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230564 */     // MIs[0] round
     /* 1230564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230574 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1230577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230599 */     // GIR_Coverage, 22830,
     /* 1230599 */     GIR_EraseRootFromParent_Done,
     /* 1230600 */   // Label 17810: @1230600
     /* 1230600 */   GIM_Try, /*On fail goto*//*Label 17811*/ GIMT_Encode4(1230680), // Rule ID 22831 //
     /* 1230605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1230608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1230613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1230622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230644 */     // MIs[0] round
     /* 1230644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230654 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1230657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230679 */     // GIR_Coverage, 22831,
     /* 1230679 */     GIR_EraseRootFromParent_Done,
     /* 1230680 */   // Label 17811: @1230680
     /* 1230680 */   GIM_Try, /*On fail goto*//*Label 17812*/ GIMT_Encode4(1230760), // Rule ID 22834 //
     /* 1230685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1230693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1230702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230724 */     // MIs[0] round
     /* 1230724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230734 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1230737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230759 */     // GIR_Coverage, 22834,
     /* 1230759 */     GIR_EraseRootFromParent_Done,
     /* 1230760 */   // Label 17812: @1230760
     /* 1230760 */   GIM_Try, /*On fail goto*//*Label 17813*/ GIMT_Encode4(1230840), // Rule ID 22835 //
     /* 1230765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1230773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1230782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230804 */     // MIs[0] round
     /* 1230804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230814 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1230817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230839 */     // GIR_Coverage, 22835,
     /* 1230839 */     GIR_EraseRootFromParent_Done,
     /* 1230840 */   // Label 17813: @1230840
     /* 1230840 */   GIM_Try, /*On fail goto*//*Label 17814*/ GIMT_Encode4(1230920), // Rule ID 22838 //
     /* 1230845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1230853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1230862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230884 */     // MIs[0] round
     /* 1230884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230894 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1230897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230919 */     // GIR_Coverage, 22838,
     /* 1230919 */     GIR_EraseRootFromParent_Done,
     /* 1230920 */   // Label 17814: @1230920
     /* 1230920 */   GIM_Try, /*On fail goto*//*Label 17815*/ GIMT_Encode4(1231000), // Rule ID 22839 //
     /* 1230925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1230928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1230933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1230942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230964 */     // MIs[0] round
     /* 1230964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230974 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1230977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230999 */     // GIR_Coverage, 22839,
     /* 1230999 */     GIR_EraseRootFromParent_Done,
     /* 1231000 */   // Label 17815: @1231000
     /* 1231000 */   GIM_Try, /*On fail goto*//*Label 17816*/ GIMT_Encode4(1231080), // Rule ID 22842 //
     /* 1231005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1231013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1231016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1231019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1231022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1231025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231044 */     // MIs[0] round
     /* 1231044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231054 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1231057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231079 */     // GIR_Coverage, 22842,
     /* 1231079 */     GIR_EraseRootFromParent_Done,
     /* 1231080 */   // Label 17816: @1231080
     /* 1231080 */   GIM_Try, /*On fail goto*//*Label 17817*/ GIMT_Encode4(1231160), // Rule ID 22843 //
     /* 1231085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1231093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1231096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1231099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1231102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1231105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231124 */     // MIs[0] round
     /* 1231124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231134 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1231137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231159 */     // GIR_Coverage, 22843,
     /* 1231159 */     GIR_EraseRootFromParent_Done,
     /* 1231160 */   // Label 17817: @1231160
     /* 1231160 */   GIM_Try, /*On fail goto*//*Label 17818*/ GIMT_Encode4(1231240), // Rule ID 22846 //
     /* 1231165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1231173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1231176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1231179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1231182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1231185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231204 */     // MIs[0] round
     /* 1231204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231214 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1231217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231239 */     // GIR_Coverage, 22846,
     /* 1231239 */     GIR_EraseRootFromParent_Done,
     /* 1231240 */   // Label 17818: @1231240
     /* 1231240 */   GIM_Try, /*On fail goto*//*Label 17819*/ GIMT_Encode4(1231320), // Rule ID 22847 //
     /* 1231245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1231253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1231256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1231259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1231262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1231265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231284 */     // MIs[0] round
     /* 1231284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231294 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1231297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231319 */     // GIR_Coverage, 22847,
     /* 1231319 */     GIR_EraseRootFromParent_Done,
     /* 1231320 */   // Label 17819: @1231320
     /* 1231320 */   GIM_Try, /*On fail goto*//*Label 17820*/ GIMT_Encode4(1231400), // Rule ID 22850 //
     /* 1231325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1231333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1231336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1231339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1231342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1231345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1231360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231364 */     // MIs[0] round
     /* 1231364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231374 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1231377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231399 */     // GIR_Coverage, 22850,
     /* 1231399 */     GIR_EraseRootFromParent_Done,
     /* 1231400 */   // Label 17820: @1231400
     /* 1231400 */   GIM_Try, /*On fail goto*//*Label 17821*/ GIMT_Encode4(1231480), // Rule ID 22851 //
     /* 1231405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1231413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1231416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1231419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1231422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1231425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1231440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231444 */     // MIs[0] round
     /* 1231444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231454 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1231457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231479 */     // GIR_Coverage, 22851,
     /* 1231479 */     GIR_EraseRootFromParent_Done,
     /* 1231480 */   // Label 17821: @1231480
     /* 1231480 */   GIM_Try, /*On fail goto*//*Label 17822*/ GIMT_Encode4(1231560), // Rule ID 22854 //
     /* 1231485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1231493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1231502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231524 */     // MIs[0] round
     /* 1231524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231534 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1231537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231559 */     // GIR_Coverage, 22854,
     /* 1231559 */     GIR_EraseRootFromParent_Done,
     /* 1231560 */   // Label 17822: @1231560
     /* 1231560 */   GIM_Try, /*On fail goto*//*Label 17823*/ GIMT_Encode4(1231640), // Rule ID 22855 //
     /* 1231565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1231568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1231573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1231582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231604 */     // MIs[0] round
     /* 1231604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231614 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1231617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231639 */     // GIR_Coverage, 22855,
     /* 1231639 */     GIR_EraseRootFromParent_Done,
     /* 1231640 */   // Label 17823: @1231640
     /* 1231640 */   GIM_Try, /*On fail goto*//*Label 17824*/ GIMT_Encode4(1231720), // Rule ID 22858 //
     /* 1231645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1231653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1231662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231684 */     // MIs[0] round
     /* 1231684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231694 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1231697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231719 */     // GIR_Coverage, 22858,
     /* 1231719 */     GIR_EraseRootFromParent_Done,
     /* 1231720 */   // Label 17824: @1231720
     /* 1231720 */   GIM_Try, /*On fail goto*//*Label 17825*/ GIMT_Encode4(1231800), // Rule ID 22859 //
     /* 1231725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1231728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1231733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1231742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231764 */     // MIs[0] round
     /* 1231764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231774 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1231777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231799 */     // GIR_Coverage, 22859,
     /* 1231799 */     GIR_EraseRootFromParent_Done,
     /* 1231800 */   // Label 17825: @1231800
     /* 1231800 */   GIM_Try, /*On fail goto*//*Label 17826*/ GIMT_Encode4(1231880), // Rule ID 22862 //
     /* 1231805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1231813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1231822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1231840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231844 */     // MIs[0] round
     /* 1231844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231854 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1231857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231879 */     // GIR_Coverage, 22862,
     /* 1231879 */     GIR_EraseRootFromParent_Done,
     /* 1231880 */   // Label 17826: @1231880
     /* 1231880 */   GIM_Try, /*On fail goto*//*Label 17827*/ GIMT_Encode4(1231960), // Rule ID 22863 //
     /* 1231885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1231888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1231893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1231902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1231920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231924 */     // MIs[0] round
     /* 1231924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231934 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1231937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231959 */     // GIR_Coverage, 22863,
     /* 1231959 */     GIR_EraseRootFromParent_Done,
     /* 1231960 */   // Label 17827: @1231960
     /* 1231960 */   GIM_Try, /*On fail goto*//*Label 17828*/ GIMT_Encode4(1232040), // Rule ID 22866 //
     /* 1231965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1231968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1231973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1231982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232004 */     // MIs[0] round
     /* 1232004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232014 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1232017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1232035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232039 */     // GIR_Coverage, 22866,
     /* 1232039 */     GIR_EraseRootFromParent_Done,
     /* 1232040 */   // Label 17828: @1232040
     /* 1232040 */   GIM_Try, /*On fail goto*//*Label 17829*/ GIMT_Encode4(1232120), // Rule ID 22867 //
     /* 1232045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1232048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1232053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1232062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232084 */     // MIs[0] round
     /* 1232084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232094 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1232097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1232115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232119 */     // GIR_Coverage, 22867,
     /* 1232119 */     GIR_EraseRootFromParent_Done,
     /* 1232120 */   // Label 17829: @1232120
     /* 1232120 */   GIM_Try, /*On fail goto*//*Label 17830*/ GIMT_Encode4(1232200), // Rule ID 22870 //
     /* 1232125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1232128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1232133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1232142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232164 */     // MIs[0] round
     /* 1232164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232174 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1232177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1232195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232199 */     // GIR_Coverage, 22870,
     /* 1232199 */     GIR_EraseRootFromParent_Done,
     /* 1232200 */   // Label 17830: @1232200
     /* 1232200 */   GIM_Try, /*On fail goto*//*Label 17831*/ GIMT_Encode4(1232280), // Rule ID 22871 //
     /* 1232205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1232208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1232213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1232222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232244 */     // MIs[0] round
     /* 1232244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232254 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1232257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1232275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232279 */     // GIR_Coverage, 22871,
     /* 1232279 */     GIR_EraseRootFromParent_Done,
     /* 1232280 */   // Label 17831: @1232280
     /* 1232280 */   GIM_Try, /*On fail goto*//*Label 17832*/ GIMT_Encode4(1232360), // Rule ID 22874 //
     /* 1232285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1232288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1232293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1232302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232324 */     // MIs[0] round
     /* 1232324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232334 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1232337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1232355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232359 */     // GIR_Coverage, 22874,
     /* 1232359 */     GIR_EraseRootFromParent_Done,
     /* 1232360 */   // Label 17832: @1232360
     /* 1232360 */   GIM_Try, /*On fail goto*//*Label 17833*/ GIMT_Encode4(1232440), // Rule ID 22875 //
     /* 1232365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1232368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1232373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1232382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232404 */     // MIs[0] round
     /* 1232404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232414 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1232417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1232435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232439 */     // GIR_Coverage, 22875,
     /* 1232439 */     GIR_EraseRootFromParent_Done,
     /* 1232440 */   // Label 17833: @1232440
     /* 1232440 */   GIM_Try, /*On fail goto*//*Label 17834*/ GIMT_Encode4(1232520), // Rule ID 22878 //
     /* 1232445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1232453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1232456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1232459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1232462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1232465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232484 */     // MIs[0] round
     /* 1232484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232494 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1232497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232519 */     // GIR_Coverage, 22878,
     /* 1232519 */     GIR_EraseRootFromParent_Done,
     /* 1232520 */   // Label 17834: @1232520
     /* 1232520 */   GIM_Try, /*On fail goto*//*Label 17835*/ GIMT_Encode4(1232600), // Rule ID 22879 //
     /* 1232525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1232533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1232536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1232539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1232542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1232545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232564 */     // MIs[0] round
     /* 1232564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232574 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1232577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232599 */     // GIR_Coverage, 22879,
     /* 1232599 */     GIR_EraseRootFromParent_Done,
     /* 1232600 */   // Label 17835: @1232600
     /* 1232600 */   GIM_Try, /*On fail goto*//*Label 17836*/ GIMT_Encode4(1232680), // Rule ID 22882 //
     /* 1232605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1232613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1232616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1232619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1232622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1232625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232644 */     // MIs[0] round
     /* 1232644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232654 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1232657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232679 */     // GIR_Coverage, 22882,
     /* 1232679 */     GIR_EraseRootFromParent_Done,
     /* 1232680 */   // Label 17836: @1232680
     /* 1232680 */   GIM_Try, /*On fail goto*//*Label 17837*/ GIMT_Encode4(1232760), // Rule ID 22883 //
     /* 1232685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1232693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1232696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1232699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1232702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1232705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232724 */     // MIs[0] round
     /* 1232724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232734 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1232737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232759 */     // GIR_Coverage, 22883,
     /* 1232759 */     GIR_EraseRootFromParent_Done,
     /* 1232760 */   // Label 17837: @1232760
     /* 1232760 */   GIM_Try, /*On fail goto*//*Label 17838*/ GIMT_Encode4(1232840), // Rule ID 22886 //
     /* 1232765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1232773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1232782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232804 */     // MIs[0] round
     /* 1232804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232814 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1232817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232839 */     // GIR_Coverage, 22886,
     /* 1232839 */     GIR_EraseRootFromParent_Done,
     /* 1232840 */   // Label 17838: @1232840
     /* 1232840 */   GIM_Try, /*On fail goto*//*Label 17839*/ GIMT_Encode4(1232920), // Rule ID 22887 //
     /* 1232845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1232853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1232862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232884 */     // MIs[0] round
     /* 1232884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232894 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1232897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232919 */     // GIR_Coverage, 22887,
     /* 1232919 */     GIR_EraseRootFromParent_Done,
     /* 1232920 */   // Label 17839: @1232920
     /* 1232920 */   GIM_Try, /*On fail goto*//*Label 17840*/ GIMT_Encode4(1233000), // Rule ID 22890 //
     /* 1232925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1232933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1232936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1232939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1232942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1232945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232964 */     // MIs[0] round
     /* 1232964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232974 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1232977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232999 */     // GIR_Coverage, 22890,
     /* 1232999 */     GIR_EraseRootFromParent_Done,
     /* 1233000 */   // Label 17840: @1233000
     /* 1233000 */   GIM_Try, /*On fail goto*//*Label 17841*/ GIMT_Encode4(1233080), // Rule ID 22891 //
     /* 1233005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1233013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1233016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1233019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1233025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233044 */     // MIs[0] round
     /* 1233044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233054 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1233057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233079 */     // GIR_Coverage, 22891,
     /* 1233079 */     GIR_EraseRootFromParent_Done,
     /* 1233080 */   // Label 17841: @1233080
     /* 1233080 */   GIM_Try, /*On fail goto*//*Label 17842*/ GIMT_Encode4(1233160), // Rule ID 22894 //
     /* 1233085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1233093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233124 */     // MIs[0] round
     /* 1233124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233134 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1233137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233159 */     // GIR_Coverage, 22894,
     /* 1233159 */     GIR_EraseRootFromParent_Done,
     /* 1233160 */   // Label 17842: @1233160
     /* 1233160 */   GIM_Try, /*On fail goto*//*Label 17843*/ GIMT_Encode4(1233240), // Rule ID 22895 //
     /* 1233165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1233173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233204 */     // MIs[0] round
     /* 1233204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233214 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1233217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233239 */     // GIR_Coverage, 22895,
     /* 1233239 */     GIR_EraseRootFromParent_Done,
     /* 1233240 */   // Label 17843: @1233240
     /* 1233240 */   GIM_Try, /*On fail goto*//*Label 17844*/ GIMT_Encode4(1233320), // Rule ID 22898 //
     /* 1233245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1233248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1233253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1233262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233284 */     // MIs[0] round
     /* 1233284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233294 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1233297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1233315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233319 */     // GIR_Coverage, 22898,
     /* 1233319 */     GIR_EraseRootFromParent_Done,
     /* 1233320 */   // Label 17844: @1233320
     /* 1233320 */   GIM_Try, /*On fail goto*//*Label 17845*/ GIMT_Encode4(1233400), // Rule ID 22899 //
     /* 1233325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1233328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1233333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1233342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233364 */     // MIs[0] round
     /* 1233364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233374 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1233377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1233395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233399 */     // GIR_Coverage, 22899,
     /* 1233399 */     GIR_EraseRootFromParent_Done,
     /* 1233400 */   // Label 17845: @1233400
     /* 1233400 */   GIM_Try, /*On fail goto*//*Label 17846*/ GIMT_Encode4(1233480), // Rule ID 22902 //
     /* 1233405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1233413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1233416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1233419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1233422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1233425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233444 */     // MIs[0] round
     /* 1233444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233454 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1233457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233479 */     // GIR_Coverage, 22902,
     /* 1233479 */     GIR_EraseRootFromParent_Done,
     /* 1233480 */   // Label 17846: @1233480
     /* 1233480 */   GIM_Try, /*On fail goto*//*Label 17847*/ GIMT_Encode4(1233560), // Rule ID 22903 //
     /* 1233485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1233493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1233496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1233499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1233502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1233505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233524 */     // MIs[0] round
     /* 1233524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233534 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1233537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233559 */     // GIR_Coverage, 22903,
     /* 1233559 */     GIR_EraseRootFromParent_Done,
     /* 1233560 */   // Label 17847: @1233560
     /* 1233560 */   GIM_Try, /*On fail goto*//*Label 17848*/ GIMT_Encode4(1233640), // Rule ID 22906 //
     /* 1233565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1233573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1233576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1233579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1233582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1233585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233604 */     // MIs[0] round
     /* 1233604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233614 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1233617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233639 */     // GIR_Coverage, 22906,
     /* 1233639 */     GIR_EraseRootFromParent_Done,
     /* 1233640 */   // Label 17848: @1233640
     /* 1233640 */   GIM_Try, /*On fail goto*//*Label 17849*/ GIMT_Encode4(1233720), // Rule ID 22907 //
     /* 1233645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1233653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1233656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1233659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1233662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1233665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233684 */     // MIs[0] round
     /* 1233684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233694 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1233697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233719 */     // GIR_Coverage, 22907,
     /* 1233719 */     GIR_EraseRootFromParent_Done,
     /* 1233720 */   // Label 17849: @1233720
     /* 1233720 */   GIM_Try, /*On fail goto*//*Label 17850*/ GIMT_Encode4(1233800), // Rule ID 22910 //
     /* 1233725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1233733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1233736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1233739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1233742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1233745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233764 */     // MIs[0] round
     /* 1233764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233774 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1233777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233799 */     // GIR_Coverage, 22910,
     /* 1233799 */     GIR_EraseRootFromParent_Done,
     /* 1233800 */   // Label 17850: @1233800
     /* 1233800 */   GIM_Try, /*On fail goto*//*Label 17851*/ GIMT_Encode4(1233880), // Rule ID 22911 //
     /* 1233805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1233813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1233816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1233819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1233822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1233825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233844 */     // MIs[0] round
     /* 1233844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233854 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1233857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233879 */     // GIR_Coverage, 22911,
     /* 1233879 */     GIR_EraseRootFromParent_Done,
     /* 1233880 */   // Label 17851: @1233880
     /* 1233880 */   GIM_Try, /*On fail goto*//*Label 17852*/ GIMT_Encode4(1233960), // Rule ID 22914 //
     /* 1233885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1233893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1233902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233924 */     // MIs[0] round
     /* 1233924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233934 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1233937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233959 */     // GIR_Coverage, 22914,
     /* 1233959 */     GIR_EraseRootFromParent_Done,
     /* 1233960 */   // Label 17852: @1233960
     /* 1233960 */   GIM_Try, /*On fail goto*//*Label 17853*/ GIMT_Encode4(1234040), // Rule ID 22915 //
     /* 1233965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1233973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1233982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234004 */     // MIs[0] round
     /* 1234004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234014 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1234017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234039 */     // GIR_Coverage, 22915,
     /* 1234039 */     GIR_EraseRootFromParent_Done,
     /* 1234040 */   // Label 17853: @1234040
     /* 1234040 */   GIM_Try, /*On fail goto*//*Label 17854*/ GIMT_Encode4(1234120), // Rule ID 22918 //
     /* 1234045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1234053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234084 */     // MIs[0] round
     /* 1234084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234094 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1234097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234119 */     // GIR_Coverage, 22918,
     /* 1234119 */     GIR_EraseRootFromParent_Done,
     /* 1234120 */   // Label 17854: @1234120
     /* 1234120 */   GIM_Try, /*On fail goto*//*Label 17855*/ GIMT_Encode4(1234200), // Rule ID 22919 //
     /* 1234125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1234133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234164 */     // MIs[0] round
     /* 1234164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234174 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1234177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234199 */     // GIR_Coverage, 22919,
     /* 1234199 */     GIR_EraseRootFromParent_Done,
     /* 1234200 */   // Label 17855: @1234200
     /* 1234200 */   GIM_Try, /*On fail goto*//*Label 17856*/ GIMT_Encode4(1234280), // Rule ID 22922 //
     /* 1234205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1234213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234244 */     // MIs[0] round
     /* 1234244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234254 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1234257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234279 */     // GIR_Coverage, 22922,
     /* 1234279 */     GIR_EraseRootFromParent_Done,
     /* 1234280 */   // Label 17856: @1234280
     /* 1234280 */   GIM_Try, /*On fail goto*//*Label 17857*/ GIMT_Encode4(1234360), // Rule ID 22923 //
     /* 1234285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1234293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234324 */     // MIs[0] round
     /* 1234324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234334 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1234337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234359 */     // GIR_Coverage, 22923,
     /* 1234359 */     GIR_EraseRootFromParent_Done,
     /* 1234360 */   // Label 17857: @1234360
     /* 1234360 */   GIM_Try, /*On fail goto*//*Label 17858*/ GIMT_Encode4(1234440), // Rule ID 22926 //
     /* 1234365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1234368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1234373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1234382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234404 */     // MIs[0] round
     /* 1234404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234414 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1234417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1234435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234439 */     // GIR_Coverage, 22926,
     /* 1234439 */     GIR_EraseRootFromParent_Done,
     /* 1234440 */   // Label 17858: @1234440
     /* 1234440 */   GIM_Try, /*On fail goto*//*Label 17859*/ GIMT_Encode4(1234520), // Rule ID 22927 //
     /* 1234445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1234448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1234453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1234462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234484 */     // MIs[0] round
     /* 1234484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234494 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1234497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1234515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234519 */     // GIR_Coverage, 22927,
     /* 1234519 */     GIR_EraseRootFromParent_Done,
     /* 1234520 */   // Label 17859: @1234520
     /* 1234520 */   GIM_Try, /*On fail goto*//*Label 17860*/ GIMT_Encode4(1234600), // Rule ID 22930 //
     /* 1234525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1234528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1234533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1234542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234564 */     // MIs[0] round
     /* 1234564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234574 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1234577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1234595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234599 */     // GIR_Coverage, 22930,
     /* 1234599 */     GIR_EraseRootFromParent_Done,
     /* 1234600 */   // Label 17860: @1234600
     /* 1234600 */   GIM_Try, /*On fail goto*//*Label 17861*/ GIMT_Encode4(1234680), // Rule ID 22931 //
     /* 1234605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1234608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1234613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1234622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234644 */     // MIs[0] round
     /* 1234644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234654 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1234657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1234675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234679 */     // GIR_Coverage, 22931,
     /* 1234679 */     GIR_EraseRootFromParent_Done,
     /* 1234680 */   // Label 17861: @1234680
     /* 1234680 */   GIM_Try, /*On fail goto*//*Label 17862*/ GIMT_Encode4(1234760), // Rule ID 22934 //
     /* 1234685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1234688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1234693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1234702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234724 */     // MIs[0] round
     /* 1234724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234734 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1234737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1234755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234759 */     // GIR_Coverage, 22934,
     /* 1234759 */     GIR_EraseRootFromParent_Done,
     /* 1234760 */   // Label 17862: @1234760
     /* 1234760 */   GIM_Try, /*On fail goto*//*Label 17863*/ GIMT_Encode4(1234840), // Rule ID 22935 //
     /* 1234765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1234768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1234773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1234782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234804 */     // MIs[0] round
     /* 1234804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234814 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1234817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1234835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234839 */     // GIR_Coverage, 22935,
     /* 1234839 */     GIR_EraseRootFromParent_Done,
     /* 1234840 */   // Label 17863: @1234840
     /* 1234840 */   GIM_Try, /*On fail goto*//*Label 17864*/ GIMT_Encode4(1234920), // Rule ID 23058 //
     /* 1234845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1234848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1234853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1234862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234884 */     // MIs[0] round
     /* 1234884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234894 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1234897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234919 */     // GIR_Coverage, 23058,
     /* 1234919 */     GIR_EraseRootFromParent_Done,
     /* 1234920 */   // Label 17864: @1234920
     /* 1234920 */   GIM_Try, /*On fail goto*//*Label 17865*/ GIMT_Encode4(1235000), // Rule ID 23059 //
     /* 1234925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1234928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1234933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1234942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234964 */     // MIs[0] round
     /* 1234964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234974 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1234977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234999 */     // GIR_Coverage, 23059,
     /* 1234999 */     GIR_EraseRootFromParent_Done,
     /* 1235000 */   // Label 17865: @1235000
     /* 1235000 */   GIM_Try, /*On fail goto*//*Label 17866*/ GIMT_Encode4(1235080), // Rule ID 23062 //
     /* 1235005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1235008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1235013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1235016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1235019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1235022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1235025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235044 */     // MIs[0] round
     /* 1235044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235054 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1235057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1235061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1235075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235079 */     // GIR_Coverage, 23062,
     /* 1235079 */     GIR_EraseRootFromParent_Done,
     /* 1235080 */   // Label 17866: @1235080
     /* 1235080 */   GIM_Try, /*On fail goto*//*Label 17867*/ GIMT_Encode4(1235160), // Rule ID 23063 //
     /* 1235085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1235088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1235093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1235096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1235099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1235102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1235105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235124 */     // MIs[0] round
     /* 1235124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235134 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1235137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1235141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1235155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235159 */     // GIR_Coverage, 23063,
     /* 1235159 */     GIR_EraseRootFromParent_Done,
     /* 1235160 */   // Label 17867: @1235160
     /* 1235160 */   GIM_Try, /*On fail goto*//*Label 17868*/ GIMT_Encode4(1235240), // Rule ID 23066 //
     /* 1235165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1235168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1235173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1235176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1235179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1235185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235204 */     // MIs[0] round
     /* 1235204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235214 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1235217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1235221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1235235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235239 */     // GIR_Coverage, 23066,
     /* 1235239 */     GIR_EraseRootFromParent_Done,
     /* 1235240 */   // Label 17868: @1235240
     /* 1235240 */   GIM_Try, /*On fail goto*//*Label 17869*/ GIMT_Encode4(1235320), // Rule ID 23067 //
     /* 1235245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1235248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1235253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1235256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1235259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1235265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235284 */     // MIs[0] round
     /* 1235284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235294 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1235297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1235301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1235315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235319 */     // GIR_Coverage, 23067,
     /* 1235319 */     GIR_EraseRootFromParent_Done,
     /* 1235320 */   // Label 17869: @1235320
     /* 1235320 */   GIM_Try, /*On fail goto*//*Label 17870*/ GIMT_Encode4(1235400), // Rule ID 23070 //
     /* 1235325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1235328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1235333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1235336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1235339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1235342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1235345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235364 */     // MIs[0] round
     /* 1235364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235374 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1235377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1235381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1235395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235399 */     // GIR_Coverage, 23070,
     /* 1235399 */     GIR_EraseRootFromParent_Done,
     /* 1235400 */   // Label 17870: @1235400
     /* 1235400 */   GIM_Try, /*On fail goto*//*Label 17871*/ GIMT_Encode4(1235480), // Rule ID 23071 //
     /* 1235405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1235408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1235413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1235416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1235419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1235422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1235425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235444 */     // MIs[0] round
     /* 1235444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235454 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1235457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1235461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1235475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235479 */     // GIR_Coverage, 23071,
     /* 1235479 */     GIR_EraseRootFromParent_Done,
     /* 1235480 */   // Label 17871: @1235480
     /* 1235480 */   GIM_Try, /*On fail goto*//*Label 17872*/ GIMT_Encode4(1235560), // Rule ID 23074 //
     /* 1235485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1235488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1235493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1235496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1235499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1235505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235524 */     // MIs[0] round
     /* 1235524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235534 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1235537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1235541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1235555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235559 */     // GIR_Coverage, 23074,
     /* 1235559 */     GIR_EraseRootFromParent_Done,
     /* 1235560 */   // Label 17872: @1235560
     /* 1235560 */   GIM_Try, /*On fail goto*//*Label 17873*/ GIMT_Encode4(1235640), // Rule ID 23075 //
     /* 1235565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1235568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1235573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1235576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1235579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1235585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235604 */     // MIs[0] round
     /* 1235604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235614 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1235617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1235621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1235635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235639 */     // GIR_Coverage, 23075,
     /* 1235639 */     GIR_EraseRootFromParent_Done,
     /* 1235640 */   // Label 17873: @1235640
     /* 1235640 */   GIM_Try, /*On fail goto*//*Label 17874*/ GIMT_Encode4(1235720), // Rule ID 23078 //
     /* 1235645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1235648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1235653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1235656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1235659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1235662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1235665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235684 */     // MIs[0] round
     /* 1235684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235694 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1235697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1235701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1235715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235719 */     // GIR_Coverage, 23078,
     /* 1235719 */     GIR_EraseRootFromParent_Done,
     /* 1235720 */   // Label 17874: @1235720
     /* 1235720 */   GIM_Try, /*On fail goto*//*Label 17875*/ GIMT_Encode4(1235800), // Rule ID 23079 //
     /* 1235725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1235728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1235733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1235736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1235739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1235742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1235745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235764 */     // MIs[0] round
     /* 1235764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235774 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1235777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1235781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1235795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235799 */     // GIR_Coverage, 23079,
     /* 1235799 */     GIR_EraseRootFromParent_Done,
     /* 1235800 */   // Label 17875: @1235800
     /* 1235800 */   GIM_Try, /*On fail goto*//*Label 17876*/ GIMT_Encode4(1235880), // Rule ID 23082 //
     /* 1235805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1235808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1235813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1235816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1235819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1235822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1235825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235844 */     // MIs[0] round
     /* 1235844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235854 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1235857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1235861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1235875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235879 */     // GIR_Coverage, 23082,
     /* 1235879 */     GIR_EraseRootFromParent_Done,
     /* 1235880 */   // Label 17876: @1235880
     /* 1235880 */   GIM_Try, /*On fail goto*//*Label 17877*/ GIMT_Encode4(1235960), // Rule ID 23083 //
     /* 1235885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1235888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1235893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1235896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1235899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1235902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1235905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235924 */     // MIs[0] round
     /* 1235924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235934 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1235937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1235941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1235955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235959 */     // GIR_Coverage, 23083,
     /* 1235959 */     GIR_EraseRootFromParent_Done,
     /* 1235960 */   // Label 17877: @1235960
     /* 1235960 */   GIM_Try, /*On fail goto*//*Label 17878*/ GIMT_Encode4(1236040), // Rule ID 23086 //
     /* 1235965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1235968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1235973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1235976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1235979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1235982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1235985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236004 */     // MIs[0] round
     /* 1236004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236014 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1236017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236039 */     // GIR_Coverage, 23086,
     /* 1236039 */     GIR_EraseRootFromParent_Done,
     /* 1236040 */   // Label 17878: @1236040
     /* 1236040 */   GIM_Try, /*On fail goto*//*Label 17879*/ GIMT_Encode4(1236120), // Rule ID 23087 //
     /* 1236045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1236048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1236053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1236056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1236059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1236062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1236065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236084 */     // MIs[0] round
     /* 1236084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236094 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1236097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236119 */     // GIR_Coverage, 23087,
     /* 1236119 */     GIR_EraseRootFromParent_Done,
     /* 1236120 */   // Label 17879: @1236120
     /* 1236120 */   GIM_Try, /*On fail goto*//*Label 17880*/ GIMT_Encode4(1236200), // Rule ID 23090 //
     /* 1236125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1236128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1236133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1236136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1236139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1236142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1236145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236164 */     // MIs[0] round
     /* 1236164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236174 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1236177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236199 */     // GIR_Coverage, 23090,
     /* 1236199 */     GIR_EraseRootFromParent_Done,
     /* 1236200 */   // Label 17880: @1236200
     /* 1236200 */   GIM_Try, /*On fail goto*//*Label 17881*/ GIMT_Encode4(1236280), // Rule ID 23091 //
     /* 1236205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1236208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1236213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1236216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1236219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1236222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1236225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236244 */     // MIs[0] round
     /* 1236244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236254 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1236257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236279 */     // GIR_Coverage, 23091,
     /* 1236279 */     GIR_EraseRootFromParent_Done,
     /* 1236280 */   // Label 17881: @1236280
     /* 1236280 */   GIM_Try, /*On fail goto*//*Label 17882*/ GIMT_Encode4(1236360), // Rule ID 23094 //
     /* 1236285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1236288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1236293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1236296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1236299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1236302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1236305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236324 */     // MIs[0] round
     /* 1236324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236334 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1236337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236359 */     // GIR_Coverage, 23094,
     /* 1236359 */     GIR_EraseRootFromParent_Done,
     /* 1236360 */   // Label 17882: @1236360
     /* 1236360 */   GIM_Try, /*On fail goto*//*Label 17883*/ GIMT_Encode4(1236440), // Rule ID 23095 //
     /* 1236365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1236368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1236373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1236376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1236379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1236382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1236385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236404 */     // MIs[0] round
     /* 1236404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236414 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1236417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236439 */     // GIR_Coverage, 23095,
     /* 1236439 */     GIR_EraseRootFromParent_Done,
     /* 1236440 */   // Label 17883: @1236440
     /* 1236440 */   GIM_Try, /*On fail goto*//*Label 17884*/ GIMT_Encode4(1236520), // Rule ID 23098 //
     /* 1236445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1236448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1236453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1236456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1236459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1236462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1236465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236484 */     // MIs[0] round
     /* 1236484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236494 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1236497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236519 */     // GIR_Coverage, 23098,
     /* 1236519 */     GIR_EraseRootFromParent_Done,
     /* 1236520 */   // Label 17884: @1236520
     /* 1236520 */   GIM_Try, /*On fail goto*//*Label 17885*/ GIMT_Encode4(1236600), // Rule ID 23099 //
     /* 1236525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1236528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1236533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1236536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1236539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1236542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1236545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236564 */     // MIs[0] round
     /* 1236564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236574 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1236577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236599 */     // GIR_Coverage, 23099,
     /* 1236599 */     GIR_EraseRootFromParent_Done,
     /* 1236600 */   // Label 17885: @1236600
     /* 1236600 */   GIM_Try, /*On fail goto*//*Label 17886*/ GIMT_Encode4(1236680), // Rule ID 23102 //
     /* 1236605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1236608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1236613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1236616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1236619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1236625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236644 */     // MIs[0] round
     /* 1236644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236654 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1236657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236679 */     // GIR_Coverage, 23102,
     /* 1236679 */     GIR_EraseRootFromParent_Done,
     /* 1236680 */   // Label 17886: @1236680
     /* 1236680 */   GIM_Try, /*On fail goto*//*Label 17887*/ GIMT_Encode4(1236760), // Rule ID 23103 //
     /* 1236685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1236688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1236693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1236696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1236699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1236705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236724 */     // MIs[0] round
     /* 1236724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236734 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1236737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236759 */     // GIR_Coverage, 23103,
     /* 1236759 */     GIR_EraseRootFromParent_Done,
     /* 1236760 */   // Label 17887: @1236760
     /* 1236760 */   GIM_Try, /*On fail goto*//*Label 17888*/ GIMT_Encode4(1236840), // Rule ID 23106 //
     /* 1236765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1236768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1236773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1236776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1236779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1236782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1236785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236804 */     // MIs[0] round
     /* 1236804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236814 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1236817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236839 */     // GIR_Coverage, 23106,
     /* 1236839 */     GIR_EraseRootFromParent_Done,
     /* 1236840 */   // Label 17888: @1236840
     /* 1236840 */   GIM_Try, /*On fail goto*//*Label 17889*/ GIMT_Encode4(1236920), // Rule ID 23107 //
     /* 1236845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1236848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1236853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1236856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1236859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1236862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1236865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236884 */     // MIs[0] round
     /* 1236884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236894 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1236897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236919 */     // GIR_Coverage, 23107,
     /* 1236919 */     GIR_EraseRootFromParent_Done,
     /* 1236920 */   // Label 17889: @1236920
     /* 1236920 */   GIM_Try, /*On fail goto*//*Label 17890*/ GIMT_Encode4(1237000), // Rule ID 23110 //
     /* 1236925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1236928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1236933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1236936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1236939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1236942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1236945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236964 */     // MIs[0] round
     /* 1236964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236974 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1236977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236999 */     // GIR_Coverage, 23110,
     /* 1236999 */     GIR_EraseRootFromParent_Done,
     /* 1237000 */   // Label 17890: @1237000
     /* 1237000 */   GIM_Try, /*On fail goto*//*Label 17891*/ GIMT_Encode4(1237080), // Rule ID 23111 //
     /* 1237005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1237008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1237013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1237016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1237019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1237022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1237025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237044 */     // MIs[0] round
     /* 1237044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237054 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1237057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1237061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237079 */     // GIR_Coverage, 23111,
     /* 1237079 */     GIR_EraseRootFromParent_Done,
     /* 1237080 */   // Label 17891: @1237080
     /* 1237080 */   GIM_Try, /*On fail goto*//*Label 17892*/ GIMT_Encode4(1237160), // Rule ID 23114 //
     /* 1237085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1237088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1237093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1237096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1237099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1237105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237124 */     // MIs[0] round
     /* 1237124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237134 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1237137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1237141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237159 */     // GIR_Coverage, 23114,
     /* 1237159 */     GIR_EraseRootFromParent_Done,
     /* 1237160 */   // Label 17892: @1237160
     /* 1237160 */   GIM_Try, /*On fail goto*//*Label 17893*/ GIMT_Encode4(1237240), // Rule ID 23115 //
     /* 1237165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1237168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1237173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1237176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1237179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1237185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237204 */     // MIs[0] round
     /* 1237204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237214 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1237217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1237221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237239 */     // GIR_Coverage, 23115,
     /* 1237239 */     GIR_EraseRootFromParent_Done,
     /* 1237240 */   // Label 17893: @1237240
     /* 1237240 */   GIM_Try, /*On fail goto*//*Label 17894*/ GIMT_Encode4(1237320), // Rule ID 23118 //
     /* 1237245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1237248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1237253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1237256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1237259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1237262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1237265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237284 */     // MIs[0] round
     /* 1237284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237294 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1237297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1237301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237319 */     // GIR_Coverage, 23118,
     /* 1237319 */     GIR_EraseRootFromParent_Done,
     /* 1237320 */   // Label 17894: @1237320
     /* 1237320 */   GIM_Try, /*On fail goto*//*Label 17895*/ GIMT_Encode4(1237400), // Rule ID 23119 //
     /* 1237325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1237328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1237333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1237336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1237339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1237342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1237345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237364 */     // MIs[0] round
     /* 1237364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237374 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1237377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1237381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237399 */     // GIR_Coverage, 23119,
     /* 1237399 */     GIR_EraseRootFromParent_Done,
     /* 1237400 */   // Label 17895: @1237400
     /* 1237400 */   GIM_Try, /*On fail goto*//*Label 17896*/ GIMT_Encode4(1237480), // Rule ID 23122 //
     /* 1237405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1237408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1237413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1237416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1237419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1237422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1237425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237444 */     // MIs[0] round
     /* 1237444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237454 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1237457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1237461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237479 */     // GIR_Coverage, 23122,
     /* 1237479 */     GIR_EraseRootFromParent_Done,
     /* 1237480 */   // Label 17896: @1237480
     /* 1237480 */   GIM_Try, /*On fail goto*//*Label 17897*/ GIMT_Encode4(1237560), // Rule ID 23123 //
     /* 1237485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1237488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1237493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1237496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1237499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1237502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1237505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237524 */     // MIs[0] round
     /* 1237524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237534 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1237537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1237541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237559 */     // GIR_Coverage, 23123,
     /* 1237559 */     GIR_EraseRootFromParent_Done,
     /* 1237560 */   // Label 17897: @1237560
     /* 1237560 */   GIM_Try, /*On fail goto*//*Label 17898*/ GIMT_Encode4(1237640), // Rule ID 23126 //
     /* 1237565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1237568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1237573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1237576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1237579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1237582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1237585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237604 */     // MIs[0] round
     /* 1237604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237614 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1237617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1237621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237639 */     // GIR_Coverage, 23126,
     /* 1237639 */     GIR_EraseRootFromParent_Done,
     /* 1237640 */   // Label 17898: @1237640
     /* 1237640 */   GIM_Try, /*On fail goto*//*Label 17899*/ GIMT_Encode4(1237720), // Rule ID 23127 //
     /* 1237645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1237648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1237653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1237656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1237659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1237662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1237665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237684 */     // MIs[0] round
     /* 1237684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237694 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1237697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1237701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237719 */     // GIR_Coverage, 23127,
     /* 1237719 */     GIR_EraseRootFromParent_Done,
     /* 1237720 */   // Label 17899: @1237720
     /* 1237720 */   GIM_Try, /*On fail goto*//*Label 17900*/ GIMT_Encode4(1237800), // Rule ID 23130 //
     /* 1237725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1237728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1237733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1237736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1237739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1237745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237764 */     // MIs[0] round
     /* 1237764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237774 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1237777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1237781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237799 */     // GIR_Coverage, 23130,
     /* 1237799 */     GIR_EraseRootFromParent_Done,
     /* 1237800 */   // Label 17900: @1237800
     /* 1237800 */   GIM_Try, /*On fail goto*//*Label 17901*/ GIMT_Encode4(1237880), // Rule ID 23131 //
     /* 1237805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1237808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1237813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1237816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1237819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1237825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237844 */     // MIs[0] round
     /* 1237844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237854 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1237857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1237861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237879 */     // GIR_Coverage, 23131,
     /* 1237879 */     GIR_EraseRootFromParent_Done,
     /* 1237880 */   // Label 17901: @1237880
     /* 1237880 */   GIM_Try, /*On fail goto*//*Label 17902*/ GIMT_Encode4(1237960), // Rule ID 23134 //
     /* 1237885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1237888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1237893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1237896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1237899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1237902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1237905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237924 */     // MIs[0] round
     /* 1237924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237934 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1237937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1237941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237959 */     // GIR_Coverage, 23134,
     /* 1237959 */     GIR_EraseRootFromParent_Done,
     /* 1237960 */   // Label 17902: @1237960
     /* 1237960 */   GIM_Try, /*On fail goto*//*Label 17903*/ GIMT_Encode4(1238040), // Rule ID 23135 //
     /* 1237965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1237968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1237973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1237976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1237979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1237982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1237985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238004 */     // MIs[0] round
     /* 1238004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238014 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1238017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1238021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238039 */     // GIR_Coverage, 23135,
     /* 1238039 */     GIR_EraseRootFromParent_Done,
     /* 1238040 */   // Label 17903: @1238040
     /* 1238040 */   GIM_Try, /*On fail goto*//*Label 17904*/ GIMT_Encode4(1238120), // Rule ID 23138 //
     /* 1238045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1238048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1238053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1238056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1238059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1238062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1238065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238084 */     // MIs[0] round
     /* 1238084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238094 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1238097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1238101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238119 */     // GIR_Coverage, 23138,
     /* 1238119 */     GIR_EraseRootFromParent_Done,
     /* 1238120 */   // Label 17904: @1238120
     /* 1238120 */   GIM_Try, /*On fail goto*//*Label 17905*/ GIMT_Encode4(1238200), // Rule ID 23139 //
     /* 1238125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1238128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1238133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1238136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1238139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1238142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1238145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238164 */     // MIs[0] round
     /* 1238164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238174 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1238177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1238181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238199 */     // GIR_Coverage, 23139,
     /* 1238199 */     GIR_EraseRootFromParent_Done,
     /* 1238200 */   // Label 17905: @1238200
     /* 1238200 */   GIM_Try, /*On fail goto*//*Label 17906*/ GIMT_Encode4(1238280), // Rule ID 23142 //
     /* 1238205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1238208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1238213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1238216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1238219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1238222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1238225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238244 */     // MIs[0] round
     /* 1238244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238254 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1238257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1238261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238279 */     // GIR_Coverage, 23142,
     /* 1238279 */     GIR_EraseRootFromParent_Done,
     /* 1238280 */   // Label 17906: @1238280
     /* 1238280 */   GIM_Try, /*On fail goto*//*Label 17907*/ GIMT_Encode4(1238360), // Rule ID 23143 //
     /* 1238285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1238288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1238293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1238296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1238299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1238302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1238305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238324 */     // MIs[0] round
     /* 1238324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238334 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1238337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1238341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238359 */     // GIR_Coverage, 23143,
     /* 1238359 */     GIR_EraseRootFromParent_Done,
     /* 1238360 */   // Label 17907: @1238360
     /* 1238360 */   GIM_Try, /*On fail goto*//*Label 17908*/ GIMT_Encode4(1238440), // Rule ID 64347 //
     /* 1238365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1238368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1238373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1238376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1238379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1238382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238404 */     // MIs[0] round
     /* 1238404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238414 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8),
     /* 1238417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238439 */     // GIR_Coverage, 64347,
     /* 1238439 */     GIR_EraseRootFromParent_Done,
     /* 1238440 */   // Label 17908: @1238440
     /* 1238440 */   GIM_Try, /*On fail goto*//*Label 17909*/ GIMT_Encode4(1238520), // Rule ID 64348 //
     /* 1238445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1238448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1238453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1238456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1238459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1238462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238484 */     // MIs[0] round
     /* 1238484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238494 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8),
     /* 1238497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238519 */     // GIR_Coverage, 64348,
     /* 1238519 */     GIR_EraseRootFromParent_Done,
     /* 1238520 */   // Label 17909: @1238520
     /* 1238520 */   GIM_Try, /*On fail goto*//*Label 17910*/ GIMT_Encode4(1238600), // Rule ID 64351 //
     /* 1238525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1238528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1238533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1238536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1238539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1238542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238564 */     // MIs[0] round
     /* 1238564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238574 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4),
     /* 1238577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238599 */     // GIR_Coverage, 64351,
     /* 1238599 */     GIR_EraseRootFromParent_Done,
     /* 1238600 */   // Label 17910: @1238600
     /* 1238600 */   GIM_Try, /*On fail goto*//*Label 17911*/ GIMT_Encode4(1238680), // Rule ID 64352 //
     /* 1238605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1238608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1238613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1238616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1238619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1238622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238644 */     // MIs[0] round
     /* 1238644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238654 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4),
     /* 1238657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238679 */     // GIR_Coverage, 64352,
     /* 1238679 */     GIR_EraseRootFromParent_Done,
     /* 1238680 */   // Label 17911: @1238680
     /* 1238680 */   GIM_Try, /*On fail goto*//*Label 17912*/ GIMT_Encode4(1238760), // Rule ID 64355 //
     /* 1238685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1238688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1238693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1238696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1238699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1238702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238724 */     // MIs[0] round
     /* 1238724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238734 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2),
     /* 1238737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238759 */     // GIR_Coverage, 64355,
     /* 1238759 */     GIR_EraseRootFromParent_Done,
     /* 1238760 */   // Label 17912: @1238760
     /* 1238760 */   GIM_Try, /*On fail goto*//*Label 17913*/ GIMT_Encode4(1238840), // Rule ID 64356 //
     /* 1238765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1238768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1238773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1238776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1238779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1238782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238804 */     // MIs[0] round
     /* 1238804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238814 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2),
     /* 1238817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238839 */     // GIR_Coverage, 64356,
     /* 1238839 */     GIR_EraseRootFromParent_Done,
     /* 1238840 */   // Label 17913: @1238840
     /* 1238840 */   GIM_Try, /*On fail goto*//*Label 17914*/ GIMT_Encode4(1238920), // Rule ID 64359 //
     /* 1238845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1238848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1238853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1238856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1238859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1238862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238884 */     // MIs[0] round
     /* 1238884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238894 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1),
     /* 1238897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238919 */     // GIR_Coverage, 64359,
     /* 1238919 */     GIR_EraseRootFromParent_Done,
     /* 1238920 */   // Label 17914: @1238920
     /* 1238920 */   GIM_Try, /*On fail goto*//*Label 17915*/ GIMT_Encode4(1239000), // Rule ID 64360 //
     /* 1238925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1238928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1238933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1238936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1238939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1238942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238964 */     // MIs[0] round
     /* 1238964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1),
     /* 1238977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238999 */     // GIR_Coverage, 64360,
     /* 1238999 */     GIR_EraseRootFromParent_Done,
     /* 1239000 */   // Label 17915: @1239000
     /* 1239000 */   GIM_Try, /*On fail goto*//*Label 17916*/ GIMT_Encode4(1239080), // Rule ID 64363 //
     /* 1239005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1239008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1239013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1239016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1239019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1239022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239044 */     // MIs[0] round
     /* 1239044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1239047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239054 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1239054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2),
     /* 1239057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1239067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239079 */     // GIR_Coverage, 64363,
     /* 1239079 */     GIR_EraseRootFromParent_Done,
     /* 1239080 */   // Label 17916: @1239080
     /* 1239080 */   GIM_Try, /*On fail goto*//*Label 17917*/ GIMT_Encode4(1239160), // Rule ID 64364 //
     /* 1239085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1239088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1239093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1239096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1239099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1239102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239124 */     // MIs[0] round
     /* 1239124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1239127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239134 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1239134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2),
     /* 1239137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1239147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239159 */     // GIR_Coverage, 64364,
     /* 1239159 */     GIR_EraseRootFromParent_Done,
     /* 1239160 */   // Label 17917: @1239160
     /* 1239160 */   GIM_Try, /*On fail goto*//*Label 17918*/ GIMT_Encode4(1239240), // Rule ID 64367 //
     /* 1239165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1239168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1239173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1239176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1239179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1239182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239204 */     // MIs[0] round
     /* 1239204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1239207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239214 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1239214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8),
     /* 1239217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1239227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239239 */     // GIR_Coverage, 64367,
     /* 1239239 */     GIR_EraseRootFromParent_Done,
     /* 1239240 */   // Label 17918: @1239240
     /* 1239240 */   GIM_Try, /*On fail goto*//*Label 17919*/ GIMT_Encode4(1239320), // Rule ID 64368 //
     /* 1239245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1239248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1239253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1239256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1239259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1239262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239284 */     // MIs[0] round
     /* 1239284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1239287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239294 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1239294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8),
     /* 1239297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1239307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239319 */     // GIR_Coverage, 64368,
     /* 1239319 */     GIR_EraseRootFromParent_Done,
     /* 1239320 */   // Label 17919: @1239320
     /* 1239320 */   GIM_Try, /*On fail goto*//*Label 17920*/ GIMT_Encode4(1239400), // Rule ID 64371 //
     /* 1239325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1239328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1239333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1239336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1239339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1239342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239364 */     // MIs[0] round
     /* 1239364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1239367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239374 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1239374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4),
     /* 1239377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1239387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239399 */     // GIR_Coverage, 64371,
     /* 1239399 */     GIR_EraseRootFromParent_Done,
     /* 1239400 */   // Label 17920: @1239400
     /* 1239400 */   GIM_Try, /*On fail goto*//*Label 17921*/ GIMT_Encode4(1239480), // Rule ID 64372 //
     /* 1239405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1239408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1239413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1239416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1239419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1239422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239444 */     // MIs[0] round
     /* 1239444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1239447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239454 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1239454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4),
     /* 1239457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1239467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239479 */     // GIR_Coverage, 64372,
     /* 1239479 */     GIR_EraseRootFromParent_Done,
     /* 1239480 */   // Label 17921: @1239480
     /* 1239480 */   GIM_Try, /*On fail goto*//*Label 17922*/ GIMT_Encode4(1239560), // Rule ID 64375 //
     /* 1239485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1239488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1239493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1239496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1239499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1239502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239524 */     // MIs[0] round
     /* 1239524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1239527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239534 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1239534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2),
     /* 1239537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1239547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239559 */     // GIR_Coverage, 64375,
     /* 1239559 */     GIR_EraseRootFromParent_Done,
     /* 1239560 */   // Label 17922: @1239560
     /* 1239560 */   GIM_Try, /*On fail goto*//*Label 17923*/ GIMT_Encode4(1239640), // Rule ID 64376 //
     /* 1239565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1239568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1239573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1239576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1239579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1239582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239604 */     // MIs[0] round
     /* 1239604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1239607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239614 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1239614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2),
     /* 1239617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1239627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239639 */     // GIR_Coverage, 64376,
     /* 1239639 */     GIR_EraseRootFromParent_Done,
     /* 1239640 */   // Label 17923: @1239640
     /* 1239640 */   GIM_Try, /*On fail goto*//*Label 17924*/ GIMT_Encode4(1239720), // Rule ID 64379 //
     /* 1239645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1239648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1239653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1239656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1239659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1239662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239684 */     // MIs[0] round
     /* 1239684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1239687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239694 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1239694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1),
     /* 1239697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1239707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239719 */     // GIR_Coverage, 64379,
     /* 1239719 */     GIR_EraseRootFromParent_Done,
     /* 1239720 */   // Label 17924: @1239720
     /* 1239720 */   GIM_Try, /*On fail goto*//*Label 17925*/ GIMT_Encode4(1239800), // Rule ID 64380 //
     /* 1239725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1239728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1239733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1239736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1239739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1239742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239764 */     // MIs[0] round
     /* 1239764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1239767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239774 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1239774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1),
     /* 1239777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1239787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239799 */     // GIR_Coverage, 64380,
     /* 1239799 */     GIR_EraseRootFromParent_Done,
     /* 1239800 */   // Label 17925: @1239800
     /* 1239800 */   GIM_Try, /*On fail goto*//*Label 17926*/ GIMT_Encode4(1239880), // Rule ID 64383 //
     /* 1239805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1239808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1239813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1239816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1239819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1239822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239844 */     // MIs[0] round
     /* 1239844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1239847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239854 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1239854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2),
     /* 1239857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1239867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239879 */     // GIR_Coverage, 64383,
     /* 1239879 */     GIR_EraseRootFromParent_Done,
     /* 1239880 */   // Label 17926: @1239880
     /* 1239880 */   GIM_Try, /*On fail goto*//*Label 17927*/ GIMT_Encode4(1239960), // Rule ID 64384 //
     /* 1239885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1239888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1239893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1239896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1239899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1239902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1239924 */     // MIs[0] round
     /* 1239924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1239927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239934 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1239934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2),
     /* 1239937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1239947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239959 */     // GIR_Coverage, 64384,
     /* 1239959 */     GIR_EraseRootFromParent_Done,
     /* 1239960 */   // Label 17927: @1239960
     /* 1239960 */   GIM_Try, /*On fail goto*//*Label 17928*/ GIMT_Encode4(1240040), // Rule ID 65061 //
     /* 1239965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1239968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1239973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1239976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1239979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1239982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240004 */     // MIs[0] round
     /* 1240004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1240007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240014 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1240014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4),
     /* 1240017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1240027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1240038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240039 */     // GIR_Coverage, 65061,
     /* 1240039 */     GIR_EraseRootFromParent_Done,
     /* 1240040 */   // Label 17928: @1240040
     /* 1240040 */   GIM_Try, /*On fail goto*//*Label 17929*/ GIMT_Encode4(1240120), // Rule ID 65062 //
     /* 1240045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1240048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1240053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1240056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1240059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1240062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240084 */     // MIs[0] round
     /* 1240084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1240087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240094 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1240094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4),
     /* 1240097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1240107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1240118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240119 */     // GIR_Coverage, 65062,
     /* 1240119 */     GIR_EraseRootFromParent_Done,
     /* 1240120 */   // Label 17929: @1240120
     /* 1240120 */   GIM_Try, /*On fail goto*//*Label 17930*/ GIMT_Encode4(1240200), // Rule ID 65065 //
     /* 1240125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1240128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1240133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1240136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1240139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1240142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240164 */     // MIs[0] round
     /* 1240164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1240167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240174 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1240174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2),
     /* 1240177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1240187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1240198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240199 */     // GIR_Coverage, 65065,
     /* 1240199 */     GIR_EraseRootFromParent_Done,
     /* 1240200 */   // Label 17930: @1240200
     /* 1240200 */   GIM_Try, /*On fail goto*//*Label 17931*/ GIMT_Encode4(1240280), // Rule ID 65066 //
     /* 1240205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1240208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1240213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1240216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1240219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1240222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240244 */     // MIs[0] round
     /* 1240244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1240247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240254 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1240254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2),
     /* 1240257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1240267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1240278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240279 */     // GIR_Coverage, 65066,
     /* 1240279 */     GIR_EraseRootFromParent_Done,
     /* 1240280 */   // Label 17931: @1240280
     /* 1240280 */   GIM_Try, /*On fail goto*//*Label 17932*/ GIMT_Encode4(1240360), // Rule ID 65069 //
     /* 1240285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1240288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1240293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1240296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1240299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1240302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240324 */     // MIs[0] round
     /* 1240324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1240327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240334 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1240334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1),
     /* 1240337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1240347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1240358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240359 */     // GIR_Coverage, 65069,
     /* 1240359 */     GIR_EraseRootFromParent_Done,
     /* 1240360 */   // Label 17932: @1240360
     /* 1240360 */   GIM_Try, /*On fail goto*//*Label 17933*/ GIMT_Encode4(1240440), // Rule ID 65070 //
     /* 1240365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1240368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1240373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1240376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1240379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1240382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240404 */     // MIs[0] round
     /* 1240404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1240407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240414 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1240414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1),
     /* 1240417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1240427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1240438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240439 */     // GIR_Coverage, 65070,
     /* 1240439 */     GIR_EraseRootFromParent_Done,
     /* 1240440 */   // Label 17933: @1240440
     /* 1240440 */   GIM_Try, /*On fail goto*//*Label 17934*/ GIMT_Encode4(1240520), // Rule ID 65073 //
     /* 1240445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1240448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1240453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1240456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1240459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1240462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240484 */     // MIs[0] round
     /* 1240484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1240487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240494 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1240494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2),
     /* 1240497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1240507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1240518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240519 */     // GIR_Coverage, 65073,
     /* 1240519 */     GIR_EraseRootFromParent_Done,
     /* 1240520 */   // Label 17934: @1240520
     /* 1240520 */   GIM_Try, /*On fail goto*//*Label 17935*/ GIMT_Encode4(1240600), // Rule ID 65074 //
     /* 1240525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1240528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1240533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1240536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1240539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1240542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240564 */     // MIs[0] round
     /* 1240564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1240567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240574 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1240574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2),
     /* 1240577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1240587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1240598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240599 */     // GIR_Coverage, 65074,
     /* 1240599 */     GIR_EraseRootFromParent_Done,
     /* 1240600 */   // Label 17935: @1240600
     /* 1240600 */   GIM_Try, /*On fail goto*//*Label 17936*/ GIMT_Encode4(1240680), // Rule ID 65077 //
     /* 1240605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1240608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1240613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1240616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1240619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1240622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240644 */     // MIs[0] round
     /* 1240644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1240647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240654 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1240654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4),
     /* 1240657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1240667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1240678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240679 */     // GIR_Coverage, 65077,
     /* 1240679 */     GIR_EraseRootFromParent_Done,
     /* 1240680 */   // Label 17936: @1240680
     /* 1240680 */   GIM_Try, /*On fail goto*//*Label 17937*/ GIMT_Encode4(1240760), // Rule ID 65078 //
     /* 1240685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1240688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1240693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1240696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1240699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1240702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240724 */     // MIs[0] round
     /* 1240724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1240727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240734 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1240734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4),
     /* 1240737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1240747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1240758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240759 */     // GIR_Coverage, 65078,
     /* 1240759 */     GIR_EraseRootFromParent_Done,
     /* 1240760 */   // Label 17937: @1240760
     /* 1240760 */   GIM_Try, /*On fail goto*//*Label 17938*/ GIMT_Encode4(1240840), // Rule ID 65081 //
     /* 1240765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1240768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1240773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1240776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1240779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1240782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240804 */     // MIs[0] round
     /* 1240804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1240807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240814 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1240814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8),
     /* 1240817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1240827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1240838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240839 */     // GIR_Coverage, 65081,
     /* 1240839 */     GIR_EraseRootFromParent_Done,
     /* 1240840 */   // Label 17938: @1240840
     /* 1240840 */   GIM_Try, /*On fail goto*//*Label 17939*/ GIMT_Encode4(1240920), // Rule ID 65082 //
     /* 1240845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1240848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1240853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1240856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1240859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1240862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240884 */     // MIs[0] round
     /* 1240884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1240887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240894 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1240894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8),
     /* 1240897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1240907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1240918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240919 */     // GIR_Coverage, 65082,
     /* 1240919 */     GIR_EraseRootFromParent_Done,
     /* 1240920 */   // Label 17939: @1240920
     /* 1240920 */   GIM_Try, /*On fail goto*//*Label 17940*/ GIMT_Encode4(1241000), // Rule ID 65085 //
     /* 1240925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1240928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1240933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1240936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1240939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1240942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1240964 */     // MIs[0] round
     /* 1240964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1240967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240974 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11011:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1240974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4),
     /* 1240977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1240987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1240998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240999 */     // GIR_Coverage, 65085,
     /* 1240999 */     GIR_EraseRootFromParent_Done,
     /* 1241000 */   // Label 17940: @1241000
     /* 1241000 */   GIM_Try, /*On fail goto*//*Label 17941*/ GIMT_Encode4(1241080), // Rule ID 65086 //
     /* 1241005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1241008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1241013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1241016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1241019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1241022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1241044 */     // MIs[0] round
     /* 1241044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1241047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241054 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11011:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1241054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4),
     /* 1241057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1241067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1241078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241079 */     // GIR_Coverage, 65086,
     /* 1241079 */     GIR_EraseRootFromParent_Done,
     /* 1241080 */   // Label 17941: @1241080
     /* 1241080 */   GIM_Try, /*On fail goto*//*Label 17942*/ GIMT_Encode4(1241160), // Rule ID 65089 //
     /* 1241085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1241088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1241093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1241096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1241099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1241102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1241124 */     // MIs[0] round
     /* 1241124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1241127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241134 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11011:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1241134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2),
     /* 1241137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1241147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1241158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241159 */     // GIR_Coverage, 65089,
     /* 1241159 */     GIR_EraseRootFromParent_Done,
     /* 1241160 */   // Label 17942: @1241160
     /* 1241160 */   GIM_Try, /*On fail goto*//*Label 17943*/ GIMT_Encode4(1241240), // Rule ID 65090 //
     /* 1241165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1241168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1241173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1241176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1241179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1241182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1241204 */     // MIs[0] round
     /* 1241204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1241207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241214 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11011:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1241214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2),
     /* 1241217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1241227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1241238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241239 */     // GIR_Coverage, 65090,
     /* 1241239 */     GIR_EraseRootFromParent_Done,
     /* 1241240 */   // Label 17943: @1241240
     /* 1241240 */   GIM_Try, /*On fail goto*//*Label 17944*/ GIMT_Encode4(1241320), // Rule ID 65093 //
     /* 1241245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1241248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1241253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1241256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1241259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1241262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1241284 */     // MIs[0] round
     /* 1241284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1241287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241294 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11011:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1241294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1),
     /* 1241297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1241307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1241318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241319 */     // GIR_Coverage, 65093,
     /* 1241319 */     GIR_EraseRootFromParent_Done,
     /* 1241320 */   // Label 17944: @1241320
     /* 1241320 */   GIM_Try, /*On fail goto*//*Label 17945*/ GIMT_Encode4(1241400), // Rule ID 65094 //
     /* 1241325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1241328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1241333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1241336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1241339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1241342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1241364 */     // MIs[0] round
     /* 1241364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1241367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241374 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11011:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1241374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1),
     /* 1241377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1241387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1241398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241399 */     // GIR_Coverage, 65094,
     /* 1241399 */     GIR_EraseRootFromParent_Done,
     /* 1241400 */   // Label 17945: @1241400
     /* 1241400 */   GIM_Try, /*On fail goto*//*Label 17946*/ GIMT_Encode4(1241480), // Rule ID 65097 //
     /* 1241405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1241408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1241413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1241416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1241419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1241422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1241444 */     // MIs[0] round
     /* 1241444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1241447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241454 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11011:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1241454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2),
     /* 1241457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1241467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1241478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241479 */     // GIR_Coverage, 65097,
     /* 1241479 */     GIR_EraseRootFromParent_Done,
     /* 1241480 */   // Label 17946: @1241480
     /* 1241480 */   GIM_Try, /*On fail goto*//*Label 17947*/ GIMT_Encode4(1241560), // Rule ID 65098 //
     /* 1241485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1241488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1241493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1241496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1241499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1241502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1241524 */     // MIs[0] round
     /* 1241524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1241527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241534 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11011:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1241534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2),
     /* 1241537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1241547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1241558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241559 */     // GIR_Coverage, 65098,
     /* 1241559 */     GIR_EraseRootFromParent_Done,
     /* 1241560 */   // Label 17947: @1241560
     /* 1241560 */   GIM_Try, /*On fail goto*//*Label 17948*/ GIMT_Encode4(1241640), // Rule ID 65101 //
     /* 1241565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1241568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1241573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1241576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1241579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1241582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1241604 */     // MIs[0] round
     /* 1241604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1241607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241614 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11011:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1241614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4),
     /* 1241617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1241627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1241638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241639 */     // GIR_Coverage, 65101,
     /* 1241639 */     GIR_EraseRootFromParent_Done,
     /* 1241640 */   // Label 17948: @1241640
     /* 1241640 */   GIM_Try, /*On fail goto*//*Label 17949*/ GIMT_Encode4(1241720), // Rule ID 65102 //
     /* 1241645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1241648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1241653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1241656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1241659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1241662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1241684 */     // MIs[0] round
     /* 1241684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1241687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241694 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11011:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1241694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4),
     /* 1241697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1241707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1241718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241719 */     // GIR_Coverage, 65102,
     /* 1241719 */     GIR_EraseRootFromParent_Done,
     /* 1241720 */   // Label 17949: @1241720
     /* 1241720 */   GIM_Try, /*On fail goto*//*Label 17950*/ GIMT_Encode4(1241800), // Rule ID 65105 //
     /* 1241725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1241728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1241733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1241736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1241739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1241742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1241764 */     // MIs[0] round
     /* 1241764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1241767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241774 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11011:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1241774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8),
     /* 1241777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1241787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1241798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241799 */     // GIR_Coverage, 65105,
     /* 1241799 */     GIR_EraseRootFromParent_Done,
     /* 1241800 */   // Label 17950: @1241800
     /* 1241800 */   GIM_Try, /*On fail goto*//*Label 17951*/ GIMT_Encode4(1241880), // Rule ID 65106 //
     /* 1241805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1241808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1241813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1241816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1241819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1241822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1241844 */     // MIs[0] round
     /* 1241844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1241847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241854 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11011:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1241854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8),
     /* 1241857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1241867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1241878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241879 */     // GIR_Coverage, 65106,
     /* 1241879 */     GIR_EraseRootFromParent_Done,
     /* 1241880 */   // Label 17951: @1241880
     /* 1241880 */   GIM_Try, /*On fail goto*//*Label 17952*/ GIMT_Encode4(1241964), // Rule ID 2710 //
     /* 1241885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1241893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1241896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1241899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1241902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1241905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1241908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241938 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1241938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1241941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1241962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241963 */     // GIR_Coverage, 2710,
     /* 1241963 */     GIR_EraseRootFromParent_Done,
     /* 1241964 */   // Label 17952: @1241964
     /* 1241964 */   GIM_Try, /*On fail goto*//*Label 17953*/ GIMT_Encode4(1242048), // Rule ID 2711 //
     /* 1241969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1241977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1241980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1241983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1241986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1241989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1241992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242022 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1242022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1242025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242047 */     // GIR_Coverage, 2711,
     /* 1242047 */     GIR_EraseRootFromParent_Done,
     /* 1242048 */   // Label 17953: @1242048
     /* 1242048 */   GIM_Try, /*On fail goto*//*Label 17954*/ GIMT_Encode4(1242132), // Rule ID 2722 //
     /* 1242053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1242061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1242064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1242067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1242073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242106 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1242106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1242109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1242115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1242117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242131 */     // GIR_Coverage, 2722,
     /* 1242131 */     GIR_EraseRootFromParent_Done,
     /* 1242132 */   // Label 17954: @1242132
     /* 1242132 */   GIM_Try, /*On fail goto*//*Label 17955*/ GIMT_Encode4(1242216), // Rule ID 2723 //
     /* 1242137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1242145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1242148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1242151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1242157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1242190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1242193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1242199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1242201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1242214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242215 */     // GIR_Coverage, 2723,
     /* 1242215 */     GIR_EraseRootFromParent_Done,
     /* 1242216 */   // Label 17955: @1242216
     /* 1242216 */   GIM_Try, /*On fail goto*//*Label 17956*/ GIMT_Encode4(1242297), // Rule ID 2724 //
     /* 1242221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1242232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1242235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1242241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242274 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1242277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242296 */     // GIR_Coverage, 2724,
     /* 1242296 */     GIR_EraseRootFromParent_Done,
     /* 1242297 */   // Label 17956: @1242297
     /* 1242297 */   GIM_Try, /*On fail goto*//*Label 17957*/ GIMT_Encode4(1242378), // Rule ID 2725 //
     /* 1242302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1242313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1242316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1242322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242355 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1242358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242377 */     // GIR_Coverage, 2725,
     /* 1242377 */     GIR_EraseRootFromParent_Done,
     /* 1242378 */   // Label 17957: @1242378
     /* 1242378 */   GIM_Try, /*On fail goto*//*Label 17958*/ GIMT_Encode4(1242462), // Rule ID 2774 //
     /* 1242383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1242391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1242394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1242397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1242403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242436 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1242436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1242439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1242443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1242460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242461 */     // GIR_Coverage, 2774,
     /* 1242461 */     GIR_EraseRootFromParent_Done,
     /* 1242462 */   // Label 17958: @1242462
     /* 1242462 */   GIM_Try, /*On fail goto*//*Label 17959*/ GIMT_Encode4(1242546), // Rule ID 2775 //
     /* 1242467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1242475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1242478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1242481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1242487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242520 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1242520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1242523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1242527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1242544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242545 */     // GIR_Coverage, 2775,
     /* 1242545 */     GIR_EraseRootFromParent_Done,
     /* 1242546 */   // Label 17959: @1242546
     /* 1242546 */   GIM_Try, /*On fail goto*//*Label 17960*/ GIMT_Encode4(1242627), // Rule ID 5110 //
     /* 1242551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1242562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1242565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1242568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1242571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242604 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1242607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242626 */     // GIR_Coverage, 5110,
     /* 1242626 */     GIR_EraseRootFromParent_Done,
     /* 1242627 */   // Label 17960: @1242627
     /* 1242627 */   GIM_Try, /*On fail goto*//*Label 17961*/ GIMT_Encode4(1242708), // Rule ID 5111 //
     /* 1242632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1242643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1242646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1242649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1242652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242685 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1242688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242707 */     // GIR_Coverage, 5111,
     /* 1242707 */     GIR_EraseRootFromParent_Done,
     /* 1242708 */   // Label 17961: @1242708
     /* 1242708 */   GIM_Try, /*On fail goto*//*Label 17962*/ GIMT_Encode4(1242789), // Rule ID 5112 //
     /* 1242713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1242724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1242727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1242730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1242733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242766 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1242769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242788 */     // GIR_Coverage, 5112,
     /* 1242788 */     GIR_EraseRootFromParent_Done,
     /* 1242789 */   // Label 17962: @1242789
     /* 1242789 */   GIM_Try, /*On fail goto*//*Label 17963*/ GIMT_Encode4(1242870), // Rule ID 5113 //
     /* 1242794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1242805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1242808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1242811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1242814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242847 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1242850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242869 */     // GIR_Coverage, 5113,
     /* 1242869 */     GIR_EraseRootFromParent_Done,
     /* 1242870 */   // Label 17963: @1242870
     /* 1242870 */   GIM_Try, /*On fail goto*//*Label 17964*/ GIMT_Encode4(1242951), // Rule ID 5114 //
     /* 1242875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1242886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1242889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1242892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1242895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242928 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1242928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1242931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242950 */     // GIR_Coverage, 5114,
     /* 1242950 */     GIR_EraseRootFromParent_Done,
     /* 1242951 */   // Label 17964: @1242951
     /* 1242951 */   GIM_Try, /*On fail goto*//*Label 17965*/ GIMT_Encode4(1243032), // Rule ID 5115 //
     /* 1242956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1242967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1242970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1242973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1242976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243009 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1243012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243031 */     // GIR_Coverage, 5115,
     /* 1243031 */     GIR_EraseRootFromParent_Done,
     /* 1243032 */   // Label 17965: @1243032
     /* 1243032 */   GIM_Try, /*On fail goto*//*Label 17966*/ GIMT_Encode4(1243113), // Rule ID 5116 //
     /* 1243037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1243048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1243051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1243054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1243057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243090 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1243093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243112 */     // GIR_Coverage, 5116,
     /* 1243112 */     GIR_EraseRootFromParent_Done,
     /* 1243113 */   // Label 17966: @1243113
     /* 1243113 */   GIM_Try, /*On fail goto*//*Label 17967*/ GIMT_Encode4(1243194), // Rule ID 5117 //
     /* 1243118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1243129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1243132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1243135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1243138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1243174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243193 */     // GIR_Coverage, 5117,
     /* 1243193 */     GIR_EraseRootFromParent_Done,
     /* 1243194 */   // Label 17967: @1243194
     /* 1243194 */   GIM_Try, /*On fail goto*//*Label 17968*/ GIMT_Encode4(1243275), // Rule ID 5118 //
     /* 1243199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1243210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1243213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1243216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1243219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243252 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1243252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1243255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243274 */     // GIR_Coverage, 5118,
     /* 1243274 */     GIR_EraseRootFromParent_Done,
     /* 1243275 */   // Label 17968: @1243275
     /* 1243275 */   GIM_Try, /*On fail goto*//*Label 17969*/ GIMT_Encode4(1243356), // Rule ID 5119 //
     /* 1243280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1243291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1243294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1243297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1243300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243333 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1243333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1243336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243355 */     // GIR_Coverage, 5119,
     /* 1243355 */     GIR_EraseRootFromParent_Done,
     /* 1243356 */   // Label 17969: @1243356
     /* 1243356 */   GIM_Try, /*On fail goto*//*Label 17970*/ GIMT_Encode4(1243437), // Rule ID 5120 //
     /* 1243361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1243372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1243375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1243378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1243381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243414 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1243417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243436 */     // GIR_Coverage, 5120,
     /* 1243436 */     GIR_EraseRootFromParent_Done,
     /* 1243437 */   // Label 17970: @1243437
     /* 1243437 */   GIM_Try, /*On fail goto*//*Label 17971*/ GIMT_Encode4(1243518), // Rule ID 5121 //
     /* 1243442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1243453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1243456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1243459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1243462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243495 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1243498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243517 */     // GIR_Coverage, 5121,
     /* 1243517 */     GIR_EraseRootFromParent_Done,
     /* 1243518 */   // Label 17971: @1243518
     /* 1243518 */   GIM_Try, /*On fail goto*//*Label 17972*/ GIMT_Encode4(1243599), // Rule ID 5122 //
     /* 1243523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1243534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1243537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1243543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1243579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243598 */     // GIR_Coverage, 5122,
     /* 1243598 */     GIR_EraseRootFromParent_Done,
     /* 1243599 */   // Label 17972: @1243599
     /* 1243599 */   GIM_Try, /*On fail goto*//*Label 17973*/ GIMT_Encode4(1243680), // Rule ID 5123 //
     /* 1243604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1243615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1243618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1243624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243657 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1243660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243679 */     // GIR_Coverage, 5123,
     /* 1243679 */     GIR_EraseRootFromParent_Done,
     /* 1243680 */   // Label 17973: @1243680
     /* 1243680 */   GIM_Try, /*On fail goto*//*Label 17974*/ GIMT_Encode4(1243761), // Rule ID 5124 //
     /* 1243685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1243696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1243699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1243702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1243705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243738 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1243738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1243741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243760 */     // GIR_Coverage, 5124,
     /* 1243760 */     GIR_EraseRootFromParent_Done,
     /* 1243761 */   // Label 17974: @1243761
     /* 1243761 */   GIM_Try, /*On fail goto*//*Label 17975*/ GIMT_Encode4(1243842), // Rule ID 5125 //
     /* 1243766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1243777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1243780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1243783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1243786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243819 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1243819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1243822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243841 */     // GIR_Coverage, 5125,
     /* 1243841 */     GIR_EraseRootFromParent_Done,
     /* 1243842 */   // Label 17975: @1243842
     /* 1243842 */   GIM_Try, /*On fail goto*//*Label 17976*/ GIMT_Encode4(1243923), // Rule ID 5126 //
     /* 1243847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1243850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1243858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1243861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1243864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1243867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243900 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1243900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1243903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243922 */     // GIR_Coverage, 5126,
     /* 1243922 */     GIR_EraseRootFromParent_Done,
     /* 1243923 */   // Label 17976: @1243923
     /* 1243923 */   GIM_Try, /*On fail goto*//*Label 17977*/ GIMT_Encode4(1244004), // Rule ID 5127 //
     /* 1243928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1243931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1243939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1243942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1243945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1243948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243981 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1243981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1243984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1244002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244003 */     // GIR_Coverage, 5127,
     /* 1244003 */     GIR_EraseRootFromParent_Done,
     /* 1244004 */   // Label 17977: @1244004
     /* 1244004 */   GIM_Try, /*On fail goto*//*Label 17978*/ GIMT_Encode4(1244085), // Rule ID 5128 //
     /* 1244009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1244020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1244023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1244026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1244029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244062 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1244065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244084 */     // GIR_Coverage, 5128,
     /* 1244084 */     GIR_EraseRootFromParent_Done,
     /* 1244085 */   // Label 17978: @1244085
     /* 1244085 */   GIM_Try, /*On fail goto*//*Label 17979*/ GIMT_Encode4(1244166), // Rule ID 5129 //
     /* 1244090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1244101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1244104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1244107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1244110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244143 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1244146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244165 */     // GIR_Coverage, 5129,
     /* 1244165 */     GIR_EraseRootFromParent_Done,
     /* 1244166 */   // Label 17979: @1244166
     /* 1244166 */   GIM_Try, /*On fail goto*//*Label 17980*/ GIMT_Encode4(1244247), // Rule ID 5130 //
     /* 1244171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1244182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1244185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1244188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1244191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244224 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1244227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244246 */     // GIR_Coverage, 5130,
     /* 1244246 */     GIR_EraseRootFromParent_Done,
     /* 1244247 */   // Label 17980: @1244247
     /* 1244247 */   GIM_Try, /*On fail goto*//*Label 17981*/ GIMT_Encode4(1244328), // Rule ID 5131 //
     /* 1244252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1244263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1244266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1244269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1244272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244305 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1244308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244327 */     // GIR_Coverage, 5131,
     /* 1244327 */     GIR_EraseRootFromParent_Done,
     /* 1244328 */   // Label 17981: @1244328
     /* 1244328 */   GIM_Try, /*On fail goto*//*Label 17982*/ GIMT_Encode4(1244409), // Rule ID 5132 //
     /* 1244333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1244344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1244347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1244350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1244353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1244356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244386 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1244389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244408 */     // GIR_Coverage, 5132,
     /* 1244408 */     GIR_EraseRootFromParent_Done,
     /* 1244409 */   // Label 17982: @1244409
     /* 1244409 */   GIM_Try, /*On fail goto*//*Label 17983*/ GIMT_Encode4(1244490), // Rule ID 5133 //
     /* 1244414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1244425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1244428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1244431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1244434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1244437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244467 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1244470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244489 */     // GIR_Coverage, 5133,
     /* 1244489 */     GIR_EraseRootFromParent_Done,
     /* 1244490 */   // Label 17983: @1244490
     /* 1244490 */   GIM_Try, /*On fail goto*//*Label 17984*/ GIMT_Encode4(1244571), // Rule ID 5134 //
     /* 1244495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1244506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1244509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1244515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244548 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1244551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244570 */     // GIR_Coverage, 5134,
     /* 1244570 */     GIR_EraseRootFromParent_Done,
     /* 1244571 */   // Label 17984: @1244571
     /* 1244571 */   GIM_Try, /*On fail goto*//*Label 17985*/ GIMT_Encode4(1244652), // Rule ID 5135 //
     /* 1244576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1244587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1244590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1244596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244629 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1244632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244651 */     // GIR_Coverage, 5135,
     /* 1244651 */     GIR_EraseRootFromParent_Done,
     /* 1244652 */   // Label 17985: @1244652
     /* 1244652 */   GIM_Try, /*On fail goto*//*Label 17986*/ GIMT_Encode4(1244733), // Rule ID 5136 //
     /* 1244657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1244668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1244671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1244674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1244677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244710 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1244713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244732 */     // GIR_Coverage, 5136,
     /* 1244732 */     GIR_EraseRootFromParent_Done,
     /* 1244733 */   // Label 17986: @1244733
     /* 1244733 */   GIM_Try, /*On fail goto*//*Label 17987*/ GIMT_Encode4(1244814), // Rule ID 5137 //
     /* 1244738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1244749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1244752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1244755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1244758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244791 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1244794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244813 */     // GIR_Coverage, 5137,
     /* 1244813 */     GIR_EraseRootFromParent_Done,
     /* 1244814 */   // Label 17987: @1244814
     /* 1244814 */   GIM_Try, /*On fail goto*//*Label 17988*/ GIMT_Encode4(1244895), // Rule ID 5138 //
     /* 1244819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1244830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1244833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1244836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1244839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244872 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1244875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244894 */     // GIR_Coverage, 5138,
     /* 1244894 */     GIR_EraseRootFromParent_Done,
     /* 1244895 */   // Label 17988: @1244895
     /* 1244895 */   GIM_Try, /*On fail goto*//*Label 17989*/ GIMT_Encode4(1244976), // Rule ID 5139 //
     /* 1244900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1244911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1244914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1244917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1244920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244953 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1244956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244975 */     // GIR_Coverage, 5139,
     /* 1244975 */     GIR_EraseRootFromParent_Done,
     /* 1244976 */   // Label 17989: @1244976
     /* 1244976 */   GIM_Try, /*On fail goto*//*Label 17990*/ GIMT_Encode4(1245057), // Rule ID 5140 //
     /* 1244981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1244992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1244995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1244998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1245001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1245037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245056 */     // GIR_Coverage, 5140,
     /* 1245056 */     GIR_EraseRootFromParent_Done,
     /* 1245057 */   // Label 17990: @1245057
     /* 1245057 */   GIM_Try, /*On fail goto*//*Label 17991*/ GIMT_Encode4(1245138), // Rule ID 5141 //
     /* 1245062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1245073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1245076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1245079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1245082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245115 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1245118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245137 */     // GIR_Coverage, 5141,
     /* 1245137 */     GIR_EraseRootFromParent_Done,
     /* 1245138 */   // Label 17991: @1245138
     /* 1245138 */   GIM_Try, /*On fail goto*//*Label 17992*/ GIMT_Encode4(1245219), // Rule ID 5142 //
     /* 1245143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1245154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1245157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1245160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1245163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245196 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1245199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245218 */     // GIR_Coverage, 5142,
     /* 1245218 */     GIR_EraseRootFromParent_Done,
     /* 1245219 */   // Label 17992: @1245219
     /* 1245219 */   GIM_Try, /*On fail goto*//*Label 17993*/ GIMT_Encode4(1245300), // Rule ID 5143 //
     /* 1245224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1245235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1245238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1245241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1245244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245277 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1245280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245299 */     // GIR_Coverage, 5143,
     /* 1245299 */     GIR_EraseRootFromParent_Done,
     /* 1245300 */   // Label 17993: @1245300
     /* 1245300 */   GIM_Try, /*On fail goto*//*Label 17994*/ GIMT_Encode4(1245381), // Rule ID 5144 //
     /* 1245305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1245316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1245319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1245325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245358 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1245361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245380 */     // GIR_Coverage, 5144,
     /* 1245380 */     GIR_EraseRootFromParent_Done,
     /* 1245381 */   // Label 17994: @1245381
     /* 1245381 */   GIM_Try, /*On fail goto*//*Label 17995*/ GIMT_Encode4(1245462), // Rule ID 5145 //
     /* 1245386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1245397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1245400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1245406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245439 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1245442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245461 */     // GIR_Coverage, 5145,
     /* 1245461 */     GIR_EraseRootFromParent_Done,
     /* 1245462 */   // Label 17995: @1245462
     /* 1245462 */   GIM_Try, /*On fail goto*//*Label 17996*/ GIMT_Encode4(1245543), // Rule ID 5146 //
     /* 1245467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1245478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1245481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1245487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245520 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1245523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245542 */     // GIR_Coverage, 5146,
     /* 1245542 */     GIR_EraseRootFromParent_Done,
     /* 1245543 */   // Label 17996: @1245543
     /* 1245543 */   GIM_Try, /*On fail goto*//*Label 17997*/ GIMT_Encode4(1245624), // Rule ID 5147 //
     /* 1245548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1245559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1245562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1245568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245601 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1245604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245623 */     // GIR_Coverage, 5147,
     /* 1245623 */     GIR_EraseRootFromParent_Done,
     /* 1245624 */   // Label 17997: @1245624
     /* 1245624 */   GIM_Try, /*On fail goto*//*Label 17998*/ GIMT_Encode4(1245705), // Rule ID 5148 //
     /* 1245629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1245640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1245643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1245649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245682 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1245685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245704 */     // GIR_Coverage, 5148,
     /* 1245704 */     GIR_EraseRootFromParent_Done,
     /* 1245705 */   // Label 17998: @1245705
     /* 1245705 */   GIM_Try, /*On fail goto*//*Label 17999*/ GIMT_Encode4(1245786), // Rule ID 5149 //
     /* 1245710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1245721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1245724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1245730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245763 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1245766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245785 */     // GIR_Coverage, 5149,
     /* 1245785 */     GIR_EraseRootFromParent_Done,
     /* 1245786 */   // Label 17999: @1245786
     /* 1245786 */   GIM_Try, /*On fail goto*//*Label 18000*/ GIMT_Encode4(1245867), // Rule ID 5150 //
     /* 1245791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1245802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1245805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1245808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1245811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245844 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1245847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245866 */     // GIR_Coverage, 5150,
     /* 1245866 */     GIR_EraseRootFromParent_Done,
     /* 1245867 */   // Label 18000: @1245867
     /* 1245867 */   GIM_Try, /*On fail goto*//*Label 18001*/ GIMT_Encode4(1245948), // Rule ID 5151 //
     /* 1245872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1245883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1245886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1245889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1245892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245925 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1245928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245947 */     // GIR_Coverage, 5151,
     /* 1245947 */     GIR_EraseRootFromParent_Done,
     /* 1245948 */   // Label 18001: @1245948
     /* 1245948 */   GIM_Try, /*On fail goto*//*Label 18002*/ GIMT_Encode4(1246029), // Rule ID 5152 //
     /* 1245953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1245964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1245967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1245970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1245976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1245983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246006 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1246009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246028 */     // GIR_Coverage, 5152,
     /* 1246028 */     GIR_EraseRootFromParent_Done,
     /* 1246029 */   // Label 18002: @1246029
     /* 1246029 */   GIM_Try, /*On fail goto*//*Label 18003*/ GIMT_Encode4(1246110), // Rule ID 5153 //
     /* 1246034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1246045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1246048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1246051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1246054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246087 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1246087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1246090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246109 */     // GIR_Coverage, 5153,
     /* 1246109 */     GIR_EraseRootFromParent_Done,
     /* 1246110 */   // Label 18003: @1246110
     /* 1246110 */   GIM_Try, /*On fail goto*//*Label 18004*/ GIMT_Encode4(1246191), // Rule ID 5154 //
     /* 1246115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1246126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1246129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1246132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1246135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246168 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1246171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246190 */     // GIR_Coverage, 5154,
     /* 1246190 */     GIR_EraseRootFromParent_Done,
     /* 1246191 */   // Label 18004: @1246191
     /* 1246191 */   GIM_Try, /*On fail goto*//*Label 18005*/ GIMT_Encode4(1246272), // Rule ID 5155 //
     /* 1246196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1246207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1246210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1246213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1246216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246249 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1246249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1246252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246271 */     // GIR_Coverage, 5155,
     /* 1246271 */     GIR_EraseRootFromParent_Done,
     /* 1246272 */   // Label 18005: @1246272
     /* 1246272 */   GIM_Try, /*On fail goto*//*Label 18006*/ GIMT_Encode4(1246353), // Rule ID 5156 //
     /* 1246277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1246288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1246291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1246294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1246297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246330 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1246333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246352 */     // GIR_Coverage, 5156,
     /* 1246352 */     GIR_EraseRootFromParent_Done,
     /* 1246353 */   // Label 18006: @1246353
     /* 1246353 */   GIM_Try, /*On fail goto*//*Label 18007*/ GIMT_Encode4(1246434), // Rule ID 5157 //
     /* 1246358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1246369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1246372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1246375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1246378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246411 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1246411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1246414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246433 */     // GIR_Coverage, 5157,
     /* 1246433 */     GIR_EraseRootFromParent_Done,
     /* 1246434 */   // Label 18007: @1246434
     /* 1246434 */   GIM_Try, /*On fail goto*//*Label 18008*/ GIMT_Encode4(1246515), // Rule ID 5158 //
     /* 1246439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1246450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1246453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1246456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1246459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246492 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1246492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1246495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246514 */     // GIR_Coverage, 5158,
     /* 1246514 */     GIR_EraseRootFromParent_Done,
     /* 1246515 */   // Label 18008: @1246515
     /* 1246515 */   GIM_Try, /*On fail goto*//*Label 18009*/ GIMT_Encode4(1246596), // Rule ID 5159 //
     /* 1246520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1246531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1246534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1246537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1246540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246573 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1246573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1246576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246595 */     // GIR_Coverage, 5159,
     /* 1246595 */     GIR_EraseRootFromParent_Done,
     /* 1246596 */   // Label 18009: @1246596
     /* 1246596 */   GIM_Try, /*On fail goto*//*Label 18010*/ GIMT_Encode4(1246677), // Rule ID 5160 //
     /* 1246601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1246612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1246615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1246618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1246621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246654 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1246654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1246657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246676 */     // GIR_Coverage, 5160,
     /* 1246676 */     GIR_EraseRootFromParent_Done,
     /* 1246677 */   // Label 18010: @1246677
     /* 1246677 */   GIM_Try, /*On fail goto*//*Label 18011*/ GIMT_Encode4(1246758), // Rule ID 5161 //
     /* 1246682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1246693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1246696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1246699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1246702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246735 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1246735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1246738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246757 */     // GIR_Coverage, 5161,
     /* 1246757 */     GIR_EraseRootFromParent_Done,
     /* 1246758 */   // Label 18011: @1246758
     /* 1246758 */   GIM_Try, /*On fail goto*//*Label 18012*/ GIMT_Encode4(1246839), // Rule ID 5162 //
     /* 1246763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1246774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1246777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1246780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1246783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246816 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1246816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1246819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246838 */     // GIR_Coverage, 5162,
     /* 1246838 */     GIR_EraseRootFromParent_Done,
     /* 1246839 */   // Label 18012: @1246839
     /* 1246839 */   GIM_Try, /*On fail goto*//*Label 18013*/ GIMT_Encode4(1246920), // Rule ID 5163 //
     /* 1246844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1246855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1246858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1246861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1246864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246897 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1246897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1246900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246919 */     // GIR_Coverage, 5163,
     /* 1246919 */     GIR_EraseRootFromParent_Done,
     /* 1246920 */   // Label 18013: @1246920
     /* 1246920 */   GIM_Try, /*On fail goto*//*Label 18014*/ GIMT_Encode4(1247001), // Rule ID 5164 //
     /* 1246925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1246936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1246939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1246942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1246945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246978 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1246981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247000 */     // GIR_Coverage, 5164,
     /* 1247000 */     GIR_EraseRootFromParent_Done,
     /* 1247001 */   // Label 18014: @1247001
     /* 1247001 */   GIM_Try, /*On fail goto*//*Label 18015*/ GIMT_Encode4(1247082), // Rule ID 5165 //
     /* 1247006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1247014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1247017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1247020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1247023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247059 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1247062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247081 */     // GIR_Coverage, 5165,
     /* 1247081 */     GIR_EraseRootFromParent_Done,
     /* 1247082 */   // Label 18015: @1247082
     /* 1247082 */   GIM_Try, /*On fail goto*//*Label 18016*/ GIMT_Encode4(1247163), // Rule ID 5166 //
     /* 1247087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1247095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1247098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1247101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1247104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1247110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247140 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1247140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1247143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247162 */     // GIR_Coverage, 5166,
     /* 1247162 */     GIR_EraseRootFromParent_Done,
     /* 1247163 */   // Label 18016: @1247163
     /* 1247163 */   GIM_Try, /*On fail goto*//*Label 18017*/ GIMT_Encode4(1247244), // Rule ID 5167 //
     /* 1247168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1247176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1247179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1247182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1247185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1247191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247221 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1247221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1247224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247243 */     // GIR_Coverage, 5167,
     /* 1247243 */     GIR_EraseRootFromParent_Done,
     /* 1247244 */   // Label 18017: @1247244
     /* 1247244 */   GIM_Try, /*On fail goto*//*Label 18018*/ GIMT_Encode4(1247325), // Rule ID 5168 //
     /* 1247249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1247257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1247260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1247263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1247266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247302 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1247302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1247305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247324 */     // GIR_Coverage, 5168,
     /* 1247324 */     GIR_EraseRootFromParent_Done,
     /* 1247325 */   // Label 18018: @1247325
     /* 1247325 */   GIM_Try, /*On fail goto*//*Label 18019*/ GIMT_Encode4(1247406), // Rule ID 5169 //
     /* 1247330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1247338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1247341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1247344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1247347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247383 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1247383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1247386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247405 */     // GIR_Coverage, 5169,
     /* 1247405 */     GIR_EraseRootFromParent_Done,
     /* 1247406 */   // Label 18019: @1247406
     /* 1247406 */   GIM_Try, /*On fail goto*//*Label 18020*/ GIMT_Encode4(1247487), // Rule ID 5170 //
     /* 1247411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1247414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1247419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1247422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1247425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1247428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247464 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1247464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1247467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247486 */     // GIR_Coverage, 5170,
     /* 1247486 */     GIR_EraseRootFromParent_Done,
     /* 1247487 */   // Label 18020: @1247487
     /* 1247487 */   GIM_Try, /*On fail goto*//*Label 18021*/ GIMT_Encode4(1247568), // Rule ID 5171 //
     /* 1247492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1247495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1247500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1247503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1247506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1247509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247545 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1247545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1247548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247567 */     // GIR_Coverage, 5171,
     /* 1247567 */     GIR_EraseRootFromParent_Done,
     /* 1247568 */   // Label 18021: @1247568
     /* 1247568 */   GIM_Try, /*On fail goto*//*Label 18022*/ GIMT_Encode4(1247649), // Rule ID 5172 //
     /* 1247573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1247581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1247584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1247587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1247590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247626 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1247629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247648 */     // GIR_Coverage, 5172,
     /* 1247648 */     GIR_EraseRootFromParent_Done,
     /* 1247649 */   // Label 18022: @1247649
     /* 1247649 */   GIM_Try, /*On fail goto*//*Label 18023*/ GIMT_Encode4(1247730), // Rule ID 5173 //
     /* 1247654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1247662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1247665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1247668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1247671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247707 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1247710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247729 */     // GIR_Coverage, 5173,
     /* 1247729 */     GIR_EraseRootFromParent_Done,
     /* 1247730 */   // Label 18023: @1247730
     /* 1247730 */   GIM_Try, /*On fail goto*//*Label 18024*/ GIMT_Encode4(1247811), // Rule ID 5174 //
     /* 1247735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1247743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1247746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1247749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1247752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1247758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1247765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247788 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1247791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247810 */     // GIR_Coverage, 5174,
     /* 1247810 */     GIR_EraseRootFromParent_Done,
     /* 1247811 */   // Label 18024: @1247811
     /* 1247811 */   GIM_Try, /*On fail goto*//*Label 18025*/ GIMT_Encode4(1247892), // Rule ID 5175 //
     /* 1247816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1247824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1247827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1247830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1247833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1247839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1247846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247869 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1247872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247891 */     // GIR_Coverage, 5175,
     /* 1247891 */     GIR_EraseRootFromParent_Done,
     /* 1247892 */   // Label 18025: @1247892
     /* 1247892 */   GIM_Try, /*On fail goto*//*Label 18026*/ GIMT_Encode4(1247973), // Rule ID 5176 //
     /* 1247897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1247905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1247908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1247911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1247914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1247920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1247927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247950 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1247953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247972 */     // GIR_Coverage, 5176,
     /* 1247972 */     GIR_EraseRootFromParent_Done,
     /* 1247973 */   // Label 18026: @1247973
     /* 1247973 */   GIM_Try, /*On fail goto*//*Label 18027*/ GIMT_Encode4(1248054), // Rule ID 5177 //
     /* 1247978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1247986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1247989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1247992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1247995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1248001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248031 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1248031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1248034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248053 */     // GIR_Coverage, 5177,
     /* 1248053 */     GIR_EraseRootFromParent_Done,
     /* 1248054 */   // Label 18027: @1248054
     /* 1248054 */   GIM_Try, /*On fail goto*//*Label 18028*/ GIMT_Encode4(1248135), // Rule ID 5178 //
     /* 1248059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1248067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1248070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1248073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1248076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248112 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1248112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1248115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248134 */     // GIR_Coverage, 5178,
     /* 1248134 */     GIR_EraseRootFromParent_Done,
     /* 1248135 */   // Label 18028: @1248135
     /* 1248135 */   GIM_Try, /*On fail goto*//*Label 18029*/ GIMT_Encode4(1248216), // Rule ID 5179 //
     /* 1248140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1248148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1248151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1248154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1248157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1248196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248215 */     // GIR_Coverage, 5179,
     /* 1248215 */     GIR_EraseRootFromParent_Done,
     /* 1248216 */   // Label 18029: @1248216
     /* 1248216 */   GIM_Try, /*On fail goto*//*Label 18030*/ GIMT_Encode4(1248297), // Rule ID 5180 //
     /* 1248221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1248229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1248232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1248235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1248238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248274 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1248274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1248277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248296 */     // GIR_Coverage, 5180,
     /* 1248296 */     GIR_EraseRootFromParent_Done,
     /* 1248297 */   // Label 18030: @1248297
     /* 1248297 */   GIM_Try, /*On fail goto*//*Label 18031*/ GIMT_Encode4(1248378), // Rule ID 5181 //
     /* 1248302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1248310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1248313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1248316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1248319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248355 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1248358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248377 */     // GIR_Coverage, 5181,
     /* 1248377 */     GIR_EraseRootFromParent_Done,
     /* 1248378 */   // Label 18031: @1248378
     /* 1248378 */   GIM_Try, /*On fail goto*//*Label 18032*/ GIMT_Encode4(1248459), // Rule ID 5182 //
     /* 1248383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1248391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1248394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1248397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1248400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248436 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1248436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1248439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248458 */     // GIR_Coverage, 5182,
     /* 1248458 */     GIR_EraseRootFromParent_Done,
     /* 1248459 */   // Label 18032: @1248459
     /* 1248459 */   GIM_Try, /*On fail goto*//*Label 18033*/ GIMT_Encode4(1248540), // Rule ID 5183 //
     /* 1248464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1248472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1248475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1248478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1248481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248517 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1248520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248539 */     // GIR_Coverage, 5183,
     /* 1248539 */     GIR_EraseRootFromParent_Done,
     /* 1248540 */   // Label 18033: @1248540
     /* 1248540 */   GIM_Try, /*On fail goto*//*Label 18034*/ GIMT_Encode4(1248621), // Rule ID 5184 //
     /* 1248545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1248553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1248556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1248559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1248562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1248601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248620 */     // GIR_Coverage, 5184,
     /* 1248620 */     GIR_EraseRootFromParent_Done,
     /* 1248621 */   // Label 18034: @1248621
     /* 1248621 */   GIM_Try, /*On fail goto*//*Label 18035*/ GIMT_Encode4(1248702), // Rule ID 5185 //
     /* 1248626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1248634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1248637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1248640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1248643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1248679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1248682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248701 */     // GIR_Coverage, 5185,
     /* 1248701 */     GIR_EraseRootFromParent_Done,
     /* 1248702 */   // Label 18035: @1248702
     /* 1248702 */   GIM_Try, /*On fail goto*//*Label 18036*/ GIMT_Encode4(1248783), // Rule ID 5186 //
     /* 1248707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1248715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1248718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1248721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1248724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248760 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1248763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248782 */     // GIR_Coverage, 5186,
     /* 1248782 */     GIR_EraseRootFromParent_Done,
     /* 1248783 */   // Label 18036: @1248783
     /* 1248783 */   GIM_Try, /*On fail goto*//*Label 18037*/ GIMT_Encode4(1248864), // Rule ID 5187 //
     /* 1248788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1248796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1248799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1248802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1248805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248841 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1248841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1248844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248863 */     // GIR_Coverage, 5187,
     /* 1248863 */     GIR_EraseRootFromParent_Done,
     /* 1248864 */   // Label 18037: @1248864
     /* 1248864 */   GIM_Try, /*On fail goto*//*Label 18038*/ GIMT_Encode4(1248945), // Rule ID 5188 //
     /* 1248869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1248877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1248880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1248883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1248886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248922 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1248925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248944 */     // GIR_Coverage, 5188,
     /* 1248944 */     GIR_EraseRootFromParent_Done,
     /* 1248945 */   // Label 18038: @1248945
     /* 1248945 */   GIM_Try, /*On fail goto*//*Label 18039*/ GIMT_Encode4(1249026), // Rule ID 5189 //
     /* 1248950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1248958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1248961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1248964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1248967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249003 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1249003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1249006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249025 */     // GIR_Coverage, 5189,
     /* 1249025 */     GIR_EraseRootFromParent_Done,
     /* 1249026 */   // Label 18039: @1249026
     /* 1249026 */   GIM_Try, /*On fail goto*//*Label 18040*/ GIMT_Encode4(1249107), // Rule ID 5190 //
     /* 1249031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1249039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1249042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1249045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1249048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1249061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1249084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1249087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249106 */     // GIR_Coverage, 5190,
     /* 1249106 */     GIR_EraseRootFromParent_Done,
     /* 1249107 */   // Label 18040: @1249107
     /* 1249107 */   GIM_Try, /*On fail goto*//*Label 18041*/ GIMT_Encode4(1249188), // Rule ID 5191 //
     /* 1249112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1249120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1249123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1249126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1249129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1249142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249165 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1249165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1249168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249187 */     // GIR_Coverage, 5191,
     /* 1249187 */     GIR_EraseRootFromParent_Done,
     /* 1249188 */   // Label 18041: @1249188
     /* 1249188 */   GIM_Try, /*On fail goto*//*Label 18042*/ GIMT_Encode4(1249269), // Rule ID 5192 //
     /* 1249193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1249201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1249204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1249207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1249210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249246 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1249246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1249249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249268 */     // GIR_Coverage, 5192,
     /* 1249268 */     GIR_EraseRootFromParent_Done,
     /* 1249269 */   // Label 18042: @1249269
     /* 1249269 */   GIM_Try, /*On fail goto*//*Label 18043*/ GIMT_Encode4(1249350), // Rule ID 5193 //
     /* 1249274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1249282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1249285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1249288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1249291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249327 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1249327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1249330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249349 */     // GIR_Coverage, 5193,
     /* 1249349 */     GIR_EraseRootFromParent_Done,
     /* 1249350 */   // Label 18043: @1249350
     /* 1249350 */   GIM_Try, /*On fail goto*//*Label 18044*/ GIMT_Encode4(1249431), // Rule ID 5194 //
     /* 1249355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1249363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1249366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1249369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1249372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1249408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1249411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249430 */     // GIR_Coverage, 5194,
     /* 1249430 */     GIR_EraseRootFromParent_Done,
     /* 1249431 */   // Label 18044: @1249431
     /* 1249431 */   GIM_Try, /*On fail goto*//*Label 18045*/ GIMT_Encode4(1249512), // Rule ID 5195 //
     /* 1249436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1249444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1249447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1249450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1249453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249489 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1249489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1249492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249511 */     // GIR_Coverage, 5195,
     /* 1249511 */     GIR_EraseRootFromParent_Done,
     /* 1249512 */   // Label 18045: @1249512
     /* 1249512 */   GIM_Try, /*On fail goto*//*Label 18046*/ GIMT_Encode4(1249593), // Rule ID 5500 //
     /* 1249517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1249528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1249531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1249534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1249537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249570 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1249573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249592 */     // GIR_Coverage, 5500,
     /* 1249592 */     GIR_EraseRootFromParent_Done,
     /* 1249593 */   // Label 18046: @1249593
     /* 1249593 */   GIM_Try, /*On fail goto*//*Label 18047*/ GIMT_Encode4(1249674), // Rule ID 5501 //
     /* 1249598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1249609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1249612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1249615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1249618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249651 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1249651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1249654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249673 */     // GIR_Coverage, 5501,
     /* 1249673 */     GIR_EraseRootFromParent_Done,
     /* 1249674 */   // Label 18047: @1249674
     /* 1249674 */   GIM_Try, /*On fail goto*//*Label 18048*/ GIMT_Encode4(1249755), // Rule ID 5502 //
     /* 1249679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1249690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1249693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1249696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1249699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249732 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1249735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249754 */     // GIR_Coverage, 5502,
     /* 1249754 */     GIR_EraseRootFromParent_Done,
     /* 1249755 */   // Label 18048: @1249755
     /* 1249755 */   GIM_Try, /*On fail goto*//*Label 18049*/ GIMT_Encode4(1249836), // Rule ID 5503 //
     /* 1249760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1249771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1249774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1249777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1249780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249813 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1249813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1249816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249835 */     // GIR_Coverage, 5503,
     /* 1249835 */     GIR_EraseRootFromParent_Done,
     /* 1249836 */   // Label 18049: @1249836
     /* 1249836 */   GIM_Try, /*On fail goto*//*Label 18050*/ GIMT_Encode4(1249917), // Rule ID 5504 //
     /* 1249841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1249852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1249855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1249858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1249861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249894 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1249897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249916 */     // GIR_Coverage, 5504,
     /* 1249916 */     GIR_EraseRootFromParent_Done,
     /* 1249917 */   // Label 18050: @1249917
     /* 1249917 */   GIM_Try, /*On fail goto*//*Label 18051*/ GIMT_Encode4(1249998), // Rule ID 5505 //
     /* 1249922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1249933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1249936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1249939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1249942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249975 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1249975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1249978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249997 */     // GIR_Coverage, 5505,
     /* 1249997 */     GIR_EraseRootFromParent_Done,
     /* 1249998 */   // Label 18051: @1249998
     /* 1249998 */   GIM_Try, /*On fail goto*//*Label 18052*/ GIMT_Encode4(1250079), // Rule ID 5506 //
     /* 1250003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1250014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1250017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1250020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1250023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250056 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1250056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1250059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250078 */     // GIR_Coverage, 5506,
     /* 1250078 */     GIR_EraseRootFromParent_Done,
     /* 1250079 */   // Label 18052: @1250079
     /* 1250079 */   GIM_Try, /*On fail goto*//*Label 18053*/ GIMT_Encode4(1250160), // Rule ID 5507 //
     /* 1250084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1250095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1250098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1250101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1250104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250137 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1250137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1250140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250159 */     // GIR_Coverage, 5507,
     /* 1250159 */     GIR_EraseRootFromParent_Done,
     /* 1250160 */   // Label 18053: @1250160
     /* 1250160 */   GIM_Try, /*On fail goto*//*Label 18054*/ GIMT_Encode4(1250241), // Rule ID 5508 //
     /* 1250165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1250176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1250179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1250182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1250185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1250218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1250221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250240 */     // GIR_Coverage, 5508,
     /* 1250240 */     GIR_EraseRootFromParent_Done,
     /* 1250241 */   // Label 18054: @1250241
     /* 1250241 */   GIM_Try, /*On fail goto*//*Label 18055*/ GIMT_Encode4(1250322), // Rule ID 5509 //
     /* 1250246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1250257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1250260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1250263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1250266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250299 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1250299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1250302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250321 */     // GIR_Coverage, 5509,
     /* 1250321 */     GIR_EraseRootFromParent_Done,
     /* 1250322 */   // Label 18055: @1250322
     /* 1250322 */   GIM_Try, /*On fail goto*//*Label 18056*/ GIMT_Encode4(1250403), // Rule ID 5510 //
     /* 1250327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1250338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1250341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1250344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1250347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250380 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1250380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1250383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250402 */     // GIR_Coverage, 5510,
     /* 1250402 */     GIR_EraseRootFromParent_Done,
     /* 1250403 */   // Label 18056: @1250403
     /* 1250403 */   GIM_Try, /*On fail goto*//*Label 18057*/ GIMT_Encode4(1250484), // Rule ID 5511 //
     /* 1250408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1250419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1250422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1250425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1250428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250461 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1250461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1250464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250483 */     // GIR_Coverage, 5511,
     /* 1250483 */     GIR_EraseRootFromParent_Done,
     /* 1250484 */   // Label 18057: @1250484
     /* 1250484 */   GIM_Try, /*On fail goto*//*Label 18058*/ GIMT_Encode4(1250565), // Rule ID 5512 //
     /* 1250489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1250500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1250503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1250506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1250509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250542 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1250542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1250545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250564 */     // GIR_Coverage, 5512,
     /* 1250564 */     GIR_EraseRootFromParent_Done,
     /* 1250565 */   // Label 18058: @1250565
     /* 1250565 */   GIM_Try, /*On fail goto*//*Label 18059*/ GIMT_Encode4(1250646), // Rule ID 5513 //
     /* 1250570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1250581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1250584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1250587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1250590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250623 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1250623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1250626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250645 */     // GIR_Coverage, 5513,
     /* 1250645 */     GIR_EraseRootFromParent_Done,
     /* 1250646 */   // Label 18059: @1250646
     /* 1250646 */   GIM_Try, /*On fail goto*//*Label 18060*/ GIMT_Encode4(1250727), // Rule ID 5514 //
     /* 1250651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1250662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1250665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1250668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1250671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250704 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1250704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1250707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250726 */     // GIR_Coverage, 5514,
     /* 1250726 */     GIR_EraseRootFromParent_Done,
     /* 1250727 */   // Label 18060: @1250727
     /* 1250727 */   GIM_Try, /*On fail goto*//*Label 18061*/ GIMT_Encode4(1250808), // Rule ID 5515 //
     /* 1250732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1250743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1250746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1250749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1250752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250785 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1250785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1250788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250807 */     // GIR_Coverage, 5515,
     /* 1250807 */     GIR_EraseRootFromParent_Done,
     /* 1250808 */   // Label 18061: @1250808
     /* 1250808 */   GIM_Try, /*On fail goto*//*Label 18062*/ GIMT_Encode4(1250889), // Rule ID 5516 //
     /* 1250813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1250824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1250827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1250830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1250833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250866 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1250866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1250869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250888 */     // GIR_Coverage, 5516,
     /* 1250888 */     GIR_EraseRootFromParent_Done,
     /* 1250889 */   // Label 18062: @1250889
     /* 1250889 */   GIM_Try, /*On fail goto*//*Label 18063*/ GIMT_Encode4(1250970), // Rule ID 5517 //
     /* 1250894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1250905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1250908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1250911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1250914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250947 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1250947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1250950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250969 */     // GIR_Coverage, 5517,
     /* 1250969 */     GIR_EraseRootFromParent_Done,
     /* 1250970 */   // Label 18063: @1250970
     /* 1250970 */   GIM_Try, /*On fail goto*//*Label 18064*/ GIMT_Encode4(1251051), // Rule ID 5518 //
     /* 1250975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1250978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1250986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1250989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1250992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1250995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1251005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251028 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1251028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1251031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1251049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251050 */     // GIR_Coverage, 5518,
     /* 1251050 */     GIR_EraseRootFromParent_Done,
     /* 1251051 */   // Label 18064: @1251051
     /* 1251051 */   GIM_Try, /*On fail goto*//*Label 18065*/ GIMT_Encode4(1251132), // Rule ID 5519 //
     /* 1251056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1251059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1251067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1251070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1251073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1251076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1251086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251109 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1251109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1251112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1251130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251131 */     // GIR_Coverage, 5519,
     /* 1251131 */     GIR_EraseRootFromParent_Done,
     /* 1251132 */   // Label 18065: @1251132
     /* 1251132 */   GIM_Try, /*On fail goto*//*Label 18066*/ GIMT_Encode4(1251213), // Rule ID 5520 //
     /* 1251137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1251148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1251151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1251154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1251157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251190 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1251190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1251193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251212 */     // GIR_Coverage, 5520,
     /* 1251212 */     GIR_EraseRootFromParent_Done,
     /* 1251213 */   // Label 18066: @1251213
     /* 1251213 */   GIM_Try, /*On fail goto*//*Label 18067*/ GIMT_Encode4(1251294), // Rule ID 5521 //
     /* 1251218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1251229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1251232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1251235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1251238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251271 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1251274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251293 */     // GIR_Coverage, 5521,
     /* 1251293 */     GIR_EraseRootFromParent_Done,
     /* 1251294 */   // Label 18067: @1251294
     /* 1251294 */   GIM_Try, /*On fail goto*//*Label 18068*/ GIMT_Encode4(1251375), // Rule ID 5522 //
     /* 1251299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1251310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1251313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1251316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1251319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251352 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1251352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1251355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251374 */     // GIR_Coverage, 5522,
     /* 1251374 */     GIR_EraseRootFromParent_Done,
     /* 1251375 */   // Label 18068: @1251375
     /* 1251375 */   GIM_Try, /*On fail goto*//*Label 18069*/ GIMT_Encode4(1251456), // Rule ID 5523 //
     /* 1251380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1251391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1251394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1251397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1251400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251433 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1251436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251455 */     // GIR_Coverage, 5523,
     /* 1251455 */     GIR_EraseRootFromParent_Done,
     /* 1251456 */   // Label 18069: @1251456
     /* 1251456 */   GIM_Try, /*On fail goto*//*Label 18070*/ GIMT_Encode4(1251537), // Rule ID 5524 //
     /* 1251461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1251472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1251475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1251478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1251481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1251484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251514 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1251514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1251517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251536 */     // GIR_Coverage, 5524,
     /* 1251536 */     GIR_EraseRootFromParent_Done,
     /* 1251537 */   // Label 18070: @1251537
     /* 1251537 */   GIM_Try, /*On fail goto*//*Label 18071*/ GIMT_Encode4(1251618), // Rule ID 5525 //
     /* 1251542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1251553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1251556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1251559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1251562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1251565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251595 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1251598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251617 */     // GIR_Coverage, 5525,
     /* 1251617 */     GIR_EraseRootFromParent_Done,
     /* 1251618 */   // Label 18071: @1251618
     /* 1251618 */   GIM_Try, /*On fail goto*//*Label 18072*/ GIMT_Encode4(1251699), // Rule ID 5526 //
     /* 1251623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1251634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1251637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1251640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1251643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1251676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1251679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251698 */     // GIR_Coverage, 5526,
     /* 1251698 */     GIR_EraseRootFromParent_Done,
     /* 1251699 */   // Label 18072: @1251699
     /* 1251699 */   GIM_Try, /*On fail goto*//*Label 18073*/ GIMT_Encode4(1251780), // Rule ID 5527 //
     /* 1251704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1251715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1251718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1251721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1251724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251757 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1251757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1251760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251779 */     // GIR_Coverage, 5527,
     /* 1251779 */     GIR_EraseRootFromParent_Done,
     /* 1251780 */   // Label 18073: @1251780
     /* 1251780 */   GIM_Try, /*On fail goto*//*Label 18074*/ GIMT_Encode4(1251861), // Rule ID 5528 //
     /* 1251785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1251796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1251799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1251802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1251805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251838 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1251838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1251841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251860 */     // GIR_Coverage, 5528,
     /* 1251860 */     GIR_EraseRootFromParent_Done,
     /* 1251861 */   // Label 18074: @1251861
     /* 1251861 */   GIM_Try, /*On fail goto*//*Label 18075*/ GIMT_Encode4(1251942), // Rule ID 5529 //
     /* 1251866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1251877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1251880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1251883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1251886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251919 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1251919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1251922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251941 */     // GIR_Coverage, 5529,
     /* 1251941 */     GIR_EraseRootFromParent_Done,
     /* 1251942 */   // Label 18075: @1251942
     /* 1251942 */   GIM_Try, /*On fail goto*//*Label 18076*/ GIMT_Encode4(1252023), // Rule ID 5530 //
     /* 1251947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1251958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1251961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1251964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1251967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252000 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1252000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1252003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252022 */     // GIR_Coverage, 5530,
     /* 1252022 */     GIR_EraseRootFromParent_Done,
     /* 1252023 */   // Label 18076: @1252023
     /* 1252023 */   GIM_Try, /*On fail goto*//*Label 18077*/ GIMT_Encode4(1252104), // Rule ID 5531 //
     /* 1252028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1252039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1252042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1252045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1252048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1252051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252081 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1252081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1252084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252103 */     // GIR_Coverage, 5531,
     /* 1252103 */     GIR_EraseRootFromParent_Done,
     /* 1252104 */   // Label 18077: @1252104
     /* 1252104 */   GIM_Try, /*On fail goto*//*Label 18078*/ GIMT_Encode4(1252185), // Rule ID 5532 //
     /* 1252109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1252120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1252123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1252126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1252129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1252162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1252165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252184 */     // GIR_Coverage, 5532,
     /* 1252184 */     GIR_EraseRootFromParent_Done,
     /* 1252185 */   // Label 18078: @1252185
     /* 1252185 */   GIM_Try, /*On fail goto*//*Label 18079*/ GIMT_Encode4(1252266), // Rule ID 5533 //
     /* 1252190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1252201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1252204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1252207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1252210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252243 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1252243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1252246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252265 */     // GIR_Coverage, 5533,
     /* 1252265 */     GIR_EraseRootFromParent_Done,
     /* 1252266 */   // Label 18079: @1252266
     /* 1252266 */   GIM_Try, /*On fail goto*//*Label 18080*/ GIMT_Encode4(1252347), // Rule ID 5534 //
     /* 1252271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1252282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1252285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1252291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252324 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1252324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1252327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252346 */     // GIR_Coverage, 5534,
     /* 1252346 */     GIR_EraseRootFromParent_Done,
     /* 1252347 */   // Label 18080: @1252347
     /* 1252347 */   GIM_Try, /*On fail goto*//*Label 18081*/ GIMT_Encode4(1252428), // Rule ID 5535 //
     /* 1252352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1252363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1252366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1252372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252405 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1252405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1252408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252427 */     // GIR_Coverage, 5535,
     /* 1252427 */     GIR_EraseRootFromParent_Done,
     /* 1252428 */   // Label 18081: @1252428
     /* 1252428 */   GIM_Try, /*On fail goto*//*Label 18082*/ GIMT_Encode4(1252509), // Rule ID 5536 //
     /* 1252433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1252444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1252447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1252453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1252486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1252489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252508 */     // GIR_Coverage, 5536,
     /* 1252508 */     GIR_EraseRootFromParent_Done,
     /* 1252509 */   // Label 18082: @1252509
     /* 1252509 */   GIM_Try, /*On fail goto*//*Label 18083*/ GIMT_Encode4(1252590), // Rule ID 5537 //
     /* 1252514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1252525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1252528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1252534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252567 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1252567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1252570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252589 */     // GIR_Coverage, 5537,
     /* 1252589 */     GIR_EraseRootFromParent_Done,
     /* 1252590 */   // Label 18083: @1252590
     /* 1252590 */   GIM_Try, /*On fail goto*//*Label 18084*/ GIMT_Encode4(1252671), // Rule ID 5538 //
     /* 1252595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1252606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1252609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1252612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1252615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252648 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1252648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1252651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252670 */     // GIR_Coverage, 5538,
     /* 1252670 */     GIR_EraseRootFromParent_Done,
     /* 1252671 */   // Label 18084: @1252671
     /* 1252671 */   GIM_Try, /*On fail goto*//*Label 18085*/ GIMT_Encode4(1252752), // Rule ID 5539 //
     /* 1252676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1252679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1252687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1252690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1252693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1252696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252729 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1252729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1252732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252751 */     // GIR_Coverage, 5539,
     /* 1252751 */     GIR_EraseRootFromParent_Done,
     /* 1252752 */   // Label 18085: @1252752
     /* 1252752 */   GIM_Try, /*On fail goto*//*Label 18086*/ GIMT_Encode4(1252833), // Rule ID 5540 //
     /* 1252757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1252768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1252771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1252774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1252777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252810 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1252810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1252813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252832 */     // GIR_Coverage, 5540,
     /* 1252832 */     GIR_EraseRootFromParent_Done,
     /* 1252833 */   // Label 18086: @1252833
     /* 1252833 */   GIM_Try, /*On fail goto*//*Label 18087*/ GIMT_Encode4(1252914), // Rule ID 5541 //
     /* 1252838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1252841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1252849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1252852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1252855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1252858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252891 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1252891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1252894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252913 */     // GIR_Coverage, 5541,
     /* 1252913 */     GIR_EraseRootFromParent_Done,
     /* 1252914 */   // Label 18087: @1252914
     /* 1252914 */   GIM_Try, /*On fail goto*//*Label 18088*/ GIMT_Encode4(1252995), // Rule ID 5542 //
     /* 1252919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1252930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1252933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1252936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1252939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252972 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1252972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1252975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252994 */     // GIR_Coverage, 5542,
     /* 1252994 */     GIR_EraseRootFromParent_Done,
     /* 1252995 */   // Label 18088: @1252995
     /* 1252995 */   GIM_Try, /*On fail goto*//*Label 18089*/ GIMT_Encode4(1253076), // Rule ID 5543 //
     /* 1253000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1253003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1253011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1253014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1253017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1253020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1253030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253053 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1253053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1253056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253075 */     // GIR_Coverage, 5543,
     /* 1253075 */     GIR_EraseRootFromParent_Done,
     /* 1253076 */   // Label 18089: @1253076
     /* 1253076 */   GIM_Try, /*On fail goto*//*Label 18090*/ GIMT_Encode4(1253157), // Rule ID 5544 //
     /* 1253081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1253092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1253095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1253098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1253101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1253111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253134 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1253134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1253137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253156 */     // GIR_Coverage, 5544,
     /* 1253156 */     GIR_EraseRootFromParent_Done,
     /* 1253157 */   // Label 18090: @1253157
     /* 1253157 */   GIM_Try, /*On fail goto*//*Label 18091*/ GIMT_Encode4(1253238), // Rule ID 5545 //
     /* 1253162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1253173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1253176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1253179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1253182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1253192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253215 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1253215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1253218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253237 */     // GIR_Coverage, 5545,
     /* 1253237 */     GIR_EraseRootFromParent_Done,
     /* 1253238 */   // Label 18091: @1253238
     /* 1253238 */   GIM_Try, /*On fail goto*//*Label 18092*/ GIMT_Encode4(1253319), // Rule ID 5546 //
     /* 1253243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1253254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1253257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1253260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1253263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1253273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253296 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1253296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1253299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253318 */     // GIR_Coverage, 5546,
     /* 1253318 */     GIR_EraseRootFromParent_Done,
     /* 1253319 */   // Label 18092: @1253319
     /* 1253319 */   GIM_Try, /*On fail goto*//*Label 18093*/ GIMT_Encode4(1253400), // Rule ID 5547 //
     /* 1253324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1253335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1253338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1253341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1253344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1253354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253377 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1253377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1253380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253399 */     // GIR_Coverage, 5547,
     /* 1253399 */     GIR_EraseRootFromParent_Done,
     /* 1253400 */   // Label 18093: @1253400
     /* 1253400 */   GIM_Try, /*On fail goto*//*Label 18094*/ GIMT_Encode4(1253481), // Rule ID 5548 //
     /* 1253405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1253416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1253419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1253422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1253425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1253435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253458 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1253458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1253461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253480 */     // GIR_Coverage, 5548,
     /* 1253480 */     GIR_EraseRootFromParent_Done,
     /* 1253481 */   // Label 18094: @1253481
     /* 1253481 */   GIM_Try, /*On fail goto*//*Label 18095*/ GIMT_Encode4(1253562), // Rule ID 5549 //
     /* 1253486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1253497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1253500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1253503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1253506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1253516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253539 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1253539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1253542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253561 */     // GIR_Coverage, 5549,
     /* 1253561 */     GIR_EraseRootFromParent_Done,
     /* 1253562 */   // Label 18095: @1253562
     /* 1253562 */   GIM_Try, /*On fail goto*//*Label 18096*/ GIMT_Encode4(1253643), // Rule ID 5550 //
     /* 1253567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1253578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1253581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1253584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1253587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1253597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253620 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1253620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1253623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253642 */     // GIR_Coverage, 5550,
     /* 1253642 */     GIR_EraseRootFromParent_Done,
     /* 1253643 */   // Label 18096: @1253643
     /* 1253643 */   GIM_Try, /*On fail goto*//*Label 18097*/ GIMT_Encode4(1253724), // Rule ID 5551 //
     /* 1253648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1253659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1253662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1253665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1253668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1253678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253701 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1253701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1253704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253723 */     // GIR_Coverage, 5551,
     /* 1253723 */     GIR_EraseRootFromParent_Done,
     /* 1253724 */   // Label 18097: @1253724
     /* 1253724 */   GIM_Try, /*On fail goto*//*Label 18098*/ GIMT_Encode4(1253805), // Rule ID 5552 //
     /* 1253729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1253740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1253743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1253746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1253749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1253759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253782 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1253782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1253785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253804 */     // GIR_Coverage, 5552,
     /* 1253804 */     GIR_EraseRootFromParent_Done,
     /* 1253805 */   // Label 18098: @1253805
     /* 1253805 */   GIM_Try, /*On fail goto*//*Label 18099*/ GIMT_Encode4(1253886), // Rule ID 5553 //
     /* 1253810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1253821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1253824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1253827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1253830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1253840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253863 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1253863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1253866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253885 */     // GIR_Coverage, 5553,
     /* 1253885 */     GIR_EraseRootFromParent_Done,
     /* 1253886 */   // Label 18099: @1253886
     /* 1253886 */   GIM_Try, /*On fail goto*//*Label 18100*/ GIMT_Encode4(1253967), // Rule ID 5554 //
     /* 1253891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1253902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1253905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1253908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1253911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1253921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253944 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1253944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1253947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1253965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253966 */     // GIR_Coverage, 5554,
     /* 1253966 */     GIR_EraseRootFromParent_Done,
     /* 1253967 */   // Label 18100: @1253967
     /* 1253967 */   GIM_Try, /*On fail goto*//*Label 18101*/ GIMT_Encode4(1254048), // Rule ID 5555 //
     /* 1253972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1253983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1253986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1253989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1253992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1254002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254025 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1254025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1254028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254047 */     // GIR_Coverage, 5555,
     /* 1254047 */     GIR_EraseRootFromParent_Done,
     /* 1254048 */   // Label 18101: @1254048
     /* 1254048 */   GIM_Try, /*On fail goto*//*Label 18102*/ GIMT_Encode4(1254129), // Rule ID 5556 //
     /* 1254053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1254061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1254064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1254067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1254070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1254073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1254083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254106 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1254106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1254109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254128 */     // GIR_Coverage, 5556,
     /* 1254128 */     GIR_EraseRootFromParent_Done,
     /* 1254129 */   // Label 18102: @1254129
     /* 1254129 */   GIM_Try, /*On fail goto*//*Label 18103*/ GIMT_Encode4(1254210), // Rule ID 5557 //
     /* 1254134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1254142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1254145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1254148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1254151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1254154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1254164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254187 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1254187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1254190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254209 */     // GIR_Coverage, 5557,
     /* 1254209 */     GIR_EraseRootFromParent_Done,
     /* 1254210 */   // Label 18103: @1254210
     /* 1254210 */   GIM_Try, /*On fail goto*//*Label 18104*/ GIMT_Encode4(1254291), // Rule ID 5558 //
     /* 1254215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1254223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1254226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1254229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1254232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1254235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1254238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1254245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1254268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1254271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254290 */     // GIR_Coverage, 5558,
     /* 1254290 */     GIR_EraseRootFromParent_Done,
     /* 1254291 */   // Label 18104: @1254291
     /* 1254291 */   GIM_Try, /*On fail goto*//*Label 18105*/ GIMT_Encode4(1254372), // Rule ID 5559 //
     /* 1254296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1254304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1254307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1254310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1254313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1254316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1254319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1254326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254349 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1254349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1254352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254371 */     // GIR_Coverage, 5559,
     /* 1254371 */     GIR_EraseRootFromParent_Done,
     /* 1254372 */   // Label 18105: @1254372
     /* 1254372 */   GIM_Try, /*On fail goto*//*Label 18106*/ GIMT_Encode4(1254453), // Rule ID 5560 //
     /* 1254377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1254385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1254388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1254391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1254394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1254397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1254407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254430 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1254430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1254433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254452 */     // GIR_Coverage, 5560,
     /* 1254452 */     GIR_EraseRootFromParent_Done,
     /* 1254453 */   // Label 18106: @1254453
     /* 1254453 */   GIM_Try, /*On fail goto*//*Label 18107*/ GIMT_Encode4(1254534), // Rule ID 5561 //
     /* 1254458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1254466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1254469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1254472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1254475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1254478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1254488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254511 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1254511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1254514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254533 */     // GIR_Coverage, 5561,
     /* 1254533 */     GIR_EraseRootFromParent_Done,
     /* 1254534 */   // Label 18107: @1254534
     /* 1254534 */   GIM_Try, /*On fail goto*//*Label 18108*/ GIMT_Encode4(1254615), // Rule ID 5562 //
     /* 1254539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1254542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1254547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1254550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1254553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1254556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1254559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1254569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254592 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1254592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1254595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254614 */     // GIR_Coverage, 5562,
     /* 1254614 */     GIR_EraseRootFromParent_Done,
     /* 1254615 */   // Label 18108: @1254615
     /* 1254615 */   GIM_Try, /*On fail goto*//*Label 18109*/ GIMT_Encode4(1254696), // Rule ID 5563 //
     /* 1254620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1254623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1254628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1254631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1254634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1254637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1254640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1254650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254673 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1254673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1254676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254695 */     // GIR_Coverage, 5563,
     /* 1254695 */     GIR_EraseRootFromParent_Done,
     /* 1254696 */   // Label 18109: @1254696
     /* 1254696 */   GIM_Try, /*On fail goto*//*Label 18110*/ GIMT_Encode4(1254777), // Rule ID 5564 //
     /* 1254701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1254709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1254712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1254715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1254718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1254721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1254724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1254731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254754 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1254754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1254757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254776 */     // GIR_Coverage, 5564,
     /* 1254776 */     GIR_EraseRootFromParent_Done,
     /* 1254777 */   // Label 18110: @1254777
     /* 1254777 */   GIM_Try, /*On fail goto*//*Label 18111*/ GIMT_Encode4(1254858), // Rule ID 5565 //
     /* 1254782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1254790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1254793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1254796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1254799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1254802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1254805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1254812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254835 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1254835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1254838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254857 */     // GIR_Coverage, 5565,
     /* 1254857 */     GIR_EraseRootFromParent_Done,
     /* 1254858 */   // Label 18111: @1254858
     /* 1254858 */   GIM_Try, /*On fail goto*//*Label 18112*/ GIMT_Encode4(1254939), // Rule ID 5566 //
     /* 1254863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1254871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1254874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1254877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1254880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1254883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1254886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1254893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254916 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1254916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1254919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254938 */     // GIR_Coverage, 5566,
     /* 1254938 */     GIR_EraseRootFromParent_Done,
     /* 1254939 */   // Label 18112: @1254939
     /* 1254939 */   GIM_Try, /*On fail goto*//*Label 18113*/ GIMT_Encode4(1255020), // Rule ID 5567 //
     /* 1254944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1254952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1254955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1254958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1254961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1254964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1254967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1254974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254997 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1254997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1255000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255019 */     // GIR_Coverage, 5567,
     /* 1255019 */     GIR_EraseRootFromParent_Done,
     /* 1255020 */   // Label 18113: @1255020
     /* 1255020 */   GIM_Try, /*On fail goto*//*Label 18114*/ GIMT_Encode4(1255101), // Rule ID 5568 //
     /* 1255025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1255033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1255036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1255039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1255042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1255045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1255048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1255055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255078 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1255078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1255081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255100 */     // GIR_Coverage, 5568,
     /* 1255100 */     GIR_EraseRootFromParent_Done,
     /* 1255101 */   // Label 18114: @1255101
     /* 1255101 */   GIM_Try, /*On fail goto*//*Label 18115*/ GIMT_Encode4(1255182), // Rule ID 5569 //
     /* 1255106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1255114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1255117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1255120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1255123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1255126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1255129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1255136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255159 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1255159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1255162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255181 */     // GIR_Coverage, 5569,
     /* 1255181 */     GIR_EraseRootFromParent_Done,
     /* 1255182 */   // Label 18115: @1255182
     /* 1255182 */   GIM_Try, /*On fail goto*//*Label 18116*/ GIMT_Encode4(1255263), // Rule ID 5570 //
     /* 1255187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1255195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1255198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1255201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1255204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1255207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1255217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255240 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1255240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1255243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255262 */     // GIR_Coverage, 5570,
     /* 1255262 */     GIR_EraseRootFromParent_Done,
     /* 1255263 */   // Label 18116: @1255263
     /* 1255263 */   GIM_Try, /*On fail goto*//*Label 18117*/ GIMT_Encode4(1255344), // Rule ID 5571 //
     /* 1255268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1255276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1255279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1255282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1255285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1255288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1255298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1255321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1255324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255343 */     // GIR_Coverage, 5571,
     /* 1255343 */     GIR_EraseRootFromParent_Done,
     /* 1255344 */   // Label 18117: @1255344
     /* 1255344 */   GIM_Try, /*On fail goto*//*Label 18118*/ GIMT_Encode4(1255425), // Rule ID 5572 //
     /* 1255349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1255357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1255360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1255363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1255366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1255369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1255379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255402 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1255402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1255405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255424 */     // GIR_Coverage, 5572,
     /* 1255424 */     GIR_EraseRootFromParent_Done,
     /* 1255425 */   // Label 18118: @1255425
     /* 1255425 */   GIM_Try, /*On fail goto*//*Label 18119*/ GIMT_Encode4(1255506), // Rule ID 5573 //
     /* 1255430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1255438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1255441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1255444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1255447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1255450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1255460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255483 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1255483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1255486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255505 */     // GIR_Coverage, 5573,
     /* 1255505 */     GIR_EraseRootFromParent_Done,
     /* 1255506 */   // Label 18119: @1255506
     /* 1255506 */   GIM_Try, /*On fail goto*//*Label 18120*/ GIMT_Encode4(1255587), // Rule ID 5574 //
     /* 1255511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1255519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1255522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1255525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1255528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1255531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1255541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255564 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1255564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1255567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255586 */     // GIR_Coverage, 5574,
     /* 1255586 */     GIR_EraseRootFromParent_Done,
     /* 1255587 */   // Label 18120: @1255587
     /* 1255587 */   GIM_Try, /*On fail goto*//*Label 18121*/ GIMT_Encode4(1255668), // Rule ID 5575 //
     /* 1255592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1255600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1255603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1255606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1255609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1255612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1255622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255645 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1255645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1255648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255667 */     // GIR_Coverage, 5575,
     /* 1255667 */     GIR_EraseRootFromParent_Done,
     /* 1255668 */   // Label 18121: @1255668
     /* 1255668 */   GIM_Try, /*On fail goto*//*Label 18122*/ GIMT_Encode4(1255749), // Rule ID 5576 //
     /* 1255673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1255681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1255684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1255687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1255690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1255693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1255703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1255726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1255729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255748 */     // GIR_Coverage, 5576,
     /* 1255748 */     GIR_EraseRootFromParent_Done,
     /* 1255749 */   // Label 18122: @1255749
     /* 1255749 */   GIM_Try, /*On fail goto*//*Label 18123*/ GIMT_Encode4(1255830), // Rule ID 5577 //
     /* 1255754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1255762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1255765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1255768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1255771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1255774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1255784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255807 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1255807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1255810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255829 */     // GIR_Coverage, 5577,
     /* 1255829 */     GIR_EraseRootFromParent_Done,
     /* 1255830 */   // Label 18123: @1255830
     /* 1255830 */   GIM_Try, /*On fail goto*//*Label 18124*/ GIMT_Encode4(1255911), // Rule ID 5578 //
     /* 1255835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1255843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1255846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1255849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1255852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1255855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1255865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255888 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1255888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1255891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255910 */     // GIR_Coverage, 5578,
     /* 1255910 */     GIR_EraseRootFromParent_Done,
     /* 1255911 */   // Label 18124: @1255911
     /* 1255911 */   GIM_Try, /*On fail goto*//*Label 18125*/ GIMT_Encode4(1255992), // Rule ID 5579 //
     /* 1255916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1255924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1255927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1255930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1255933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1255936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1255946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255969 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1255969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1255972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255991 */     // GIR_Coverage, 5579,
     /* 1255991 */     GIR_EraseRootFromParent_Done,
     /* 1255992 */   // Label 18125: @1255992
     /* 1255992 */   GIM_Try, /*On fail goto*//*Label 18126*/ GIMT_Encode4(1256073), // Rule ID 5580 //
     /* 1255997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1256005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1256008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1256011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1256014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1256020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1256027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256050 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1256050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1256053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256072 */     // GIR_Coverage, 5580,
     /* 1256072 */     GIR_EraseRootFromParent_Done,
     /* 1256073 */   // Label 18126: @1256073
     /* 1256073 */   GIM_Try, /*On fail goto*//*Label 18127*/ GIMT_Encode4(1256154), // Rule ID 5581 //
     /* 1256078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1256086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1256089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1256092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1256095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1256101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1256108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256131 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1256131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1256134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256153 */     // GIR_Coverage, 5581,
     /* 1256153 */     GIR_EraseRootFromParent_Done,
     /* 1256154 */   // Label 18127: @1256154
     /* 1256154 */   GIM_Try, /*On fail goto*//*Label 18128*/ GIMT_Encode4(1256235), // Rule ID 5582 //
     /* 1256159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1256167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1256170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1256173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1256176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1256189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256212 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1256212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1256215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256234 */     // GIR_Coverage, 5582,
     /* 1256234 */     GIR_EraseRootFromParent_Done,
     /* 1256235 */   // Label 18128: @1256235
     /* 1256235 */   GIM_Try, /*On fail goto*//*Label 18129*/ GIMT_Encode4(1256316), // Rule ID 5583 //
     /* 1256240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1256248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1256251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1256254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1256257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1256270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256293 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1256293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1256296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256315 */     // GIR_Coverage, 5583,
     /* 1256315 */     GIR_EraseRootFromParent_Done,
     /* 1256316 */   // Label 18129: @1256316
     /* 1256316 */   GIM_Try, /*On fail goto*//*Label 18130*/ GIMT_Encode4(1256397), // Rule ID 5584 //
     /* 1256321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1256329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1256332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1256335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1256338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1256351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256374 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1256374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1256377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256396 */     // GIR_Coverage, 5584,
     /* 1256396 */     GIR_EraseRootFromParent_Done,
     /* 1256397 */   // Label 18130: @1256397
     /* 1256397 */   GIM_Try, /*On fail goto*//*Label 18131*/ GIMT_Encode4(1256478), // Rule ID 5585 //
     /* 1256402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1256410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1256413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1256416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1256419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1256432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256455 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1256455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1256458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256477 */     // GIR_Coverage, 5585,
     /* 1256477 */     GIR_EraseRootFromParent_Done,
     /* 1256478 */   // Label 18131: @1256478
     /* 1256478 */   GIM_Try, /*On fail goto*//*Label 18132*/ GIMT_Encode4(1256559), // Rule ID 5586 //
     /* 1256483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1256491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1256494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1256497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1256500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1256513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1256536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1256539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256558 */     // GIR_Coverage, 5586,
     /* 1256558 */     GIR_EraseRootFromParent_Done,
     /* 1256559 */   // Label 18132: @1256559
     /* 1256559 */   GIM_Try, /*On fail goto*//*Label 18133*/ GIMT_Encode4(1256640), // Rule ID 5587 //
     /* 1256564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1256572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1256575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1256578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1256581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1256594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256617 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1256617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1256620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256639 */     // GIR_Coverage, 5587,
     /* 1256639 */     GIR_EraseRootFromParent_Done,
     /* 1256640 */   // Label 18133: @1256640
     /* 1256640 */   GIM_Try, /*On fail goto*//*Label 18134*/ GIMT_Encode4(1256724), // Rule ID 7798 //
     /* 1256645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1256662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1256665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256698 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1256701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256723 */     // GIR_Coverage, 7798,
     /* 1256723 */     GIR_EraseRootFromParent_Done,
     /* 1256724 */   // Label 18134: @1256724
     /* 1256724 */   GIM_Try, /*On fail goto*//*Label 18135*/ GIMT_Encode4(1256808), // Rule ID 7799 //
     /* 1256729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1256746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1256749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256782 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1256785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256807 */     // GIR_Coverage, 7799,
     /* 1256807 */     GIR_EraseRootFromParent_Done,
     /* 1256808 */   // Label 18135: @1256808
     /* 1256808 */   GIM_Try, /*On fail goto*//*Label 18136*/ GIMT_Encode4(1256892), // Rule ID 7802 //
     /* 1256813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1256830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1256833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256866 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1256869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256891 */     // GIR_Coverage, 7802,
     /* 1256891 */     GIR_EraseRootFromParent_Done,
     /* 1256892 */   // Label 18136: @1256892
     /* 1256892 */   GIM_Try, /*On fail goto*//*Label 18137*/ GIMT_Encode4(1256976), // Rule ID 7803 //
     /* 1256897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1256914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1256917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256950 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1256953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256975 */     // GIR_Coverage, 7803,
     /* 1256975 */     GIR_EraseRootFromParent_Done,
     /* 1256976 */   // Label 18137: @1256976
     /* 1256976 */   GIM_Try, /*On fail goto*//*Label 18138*/ GIMT_Encode4(1257060), // Rule ID 7806 //
     /* 1256981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1256992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1256995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1256998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1257001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257034 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1257037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257059 */     // GIR_Coverage, 7806,
     /* 1257059 */     GIR_EraseRootFromParent_Done,
     /* 1257060 */   // Label 18138: @1257060
     /* 1257060 */   GIM_Try, /*On fail goto*//*Label 18139*/ GIMT_Encode4(1257144), // Rule ID 7807 //
     /* 1257065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1257082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1257085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257118 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1257121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257143 */     // GIR_Coverage, 7807,
     /* 1257143 */     GIR_EraseRootFromParent_Done,
     /* 1257144 */   // Label 18139: @1257144
     /* 1257144 */   GIM_Try, /*On fail goto*//*Label 18140*/ GIMT_Encode4(1257228), // Rule ID 7810 //
     /* 1257149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1257166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1257169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257202 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1257205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257227 */     // GIR_Coverage, 7810,
     /* 1257227 */     GIR_EraseRootFromParent_Done,
     /* 1257228 */   // Label 18140: @1257228
     /* 1257228 */   GIM_Try, /*On fail goto*//*Label 18141*/ GIMT_Encode4(1257312), // Rule ID 7811 //
     /* 1257233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1257250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1257253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257286 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1257289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257311 */     // GIR_Coverage, 7811,
     /* 1257311 */     GIR_EraseRootFromParent_Done,
     /* 1257312 */   // Label 18141: @1257312
     /* 1257312 */   GIM_Try, /*On fail goto*//*Label 18142*/ GIMT_Encode4(1257396), // Rule ID 7814 //
     /* 1257317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1257334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1257337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257370 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1257373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257395 */     // GIR_Coverage, 7814,
     /* 1257395 */     GIR_EraseRootFromParent_Done,
     /* 1257396 */   // Label 18142: @1257396
     /* 1257396 */   GIM_Try, /*On fail goto*//*Label 18143*/ GIMT_Encode4(1257480), // Rule ID 7815 //
     /* 1257401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1257418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1257421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257454 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1257457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257479 */     // GIR_Coverage, 7815,
     /* 1257479 */     GIR_EraseRootFromParent_Done,
     /* 1257480 */   // Label 18143: @1257480
     /* 1257480 */   GIM_Try, /*On fail goto*//*Label 18144*/ GIMT_Encode4(1257564), // Rule ID 7818 //
     /* 1257485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1257502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1257505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257538 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1257541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257563 */     // GIR_Coverage, 7818,
     /* 1257563 */     GIR_EraseRootFromParent_Done,
     /* 1257564 */   // Label 18144: @1257564
     /* 1257564 */   GIM_Try, /*On fail goto*//*Label 18145*/ GIMT_Encode4(1257648), // Rule ID 7819 //
     /* 1257569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1257586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1257589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257622 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1257625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257647 */     // GIR_Coverage, 7819,
     /* 1257647 */     GIR_EraseRootFromParent_Done,
     /* 1257648 */   // Label 18145: @1257648
     /* 1257648 */   GIM_Try, /*On fail goto*//*Label 18146*/ GIMT_Encode4(1257732), // Rule ID 7822 //
     /* 1257653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1257670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1257673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257706 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1257709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257731 */     // GIR_Coverage, 7822,
     /* 1257731 */     GIR_EraseRootFromParent_Done,
     /* 1257732 */   // Label 18146: @1257732
     /* 1257732 */   GIM_Try, /*On fail goto*//*Label 18147*/ GIMT_Encode4(1257816), // Rule ID 7823 //
     /* 1257737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1257754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1257757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257790 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1257793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257815 */     // GIR_Coverage, 7823,
     /* 1257815 */     GIR_EraseRootFromParent_Done,
     /* 1257816 */   // Label 18147: @1257816
     /* 1257816 */   GIM_Try, /*On fail goto*//*Label 18148*/ GIMT_Encode4(1257900), // Rule ID 7826 //
     /* 1257821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1257838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1257841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257874 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1257877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257899 */     // GIR_Coverage, 7826,
     /* 1257899 */     GIR_EraseRootFromParent_Done,
     /* 1257900 */   // Label 18148: @1257900
     /* 1257900 */   GIM_Try, /*On fail goto*//*Label 18149*/ GIMT_Encode4(1257984), // Rule ID 7827 //
     /* 1257905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1257922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1257925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257958 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1257961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257983 */     // GIR_Coverage, 7827,
     /* 1257983 */     GIR_EraseRootFromParent_Done,
     /* 1257984 */   // Label 18149: @1257984
     /* 1257984 */   GIM_Try, /*On fail goto*//*Label 18150*/ GIMT_Encode4(1258068), // Rule ID 7830 //
     /* 1257989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1257992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1258000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1258003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1258006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1258009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1258012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258042 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1258045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1258063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258067 */     // GIR_Coverage, 7830,
     /* 1258067 */     GIR_EraseRootFromParent_Done,
     /* 1258068 */   // Label 18150: @1258068
     /* 1258068 */   GIM_Try, /*On fail goto*//*Label 18151*/ GIMT_Encode4(1258152), // Rule ID 7831 //
     /* 1258073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1258076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1258084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1258087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1258090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1258093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1258096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258126 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1258129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1258147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258151 */     // GIR_Coverage, 7831,
     /* 1258151 */     GIR_EraseRootFromParent_Done,
     /* 1258152 */   // Label 18151: @1258152
     /* 1258152 */   GIM_Try, /*On fail goto*//*Label 18152*/ GIMT_Encode4(1258236), // Rule ID 7834 //
     /* 1258157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1258174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1258177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258210 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1258213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258235 */     // GIR_Coverage, 7834,
     /* 1258235 */     GIR_EraseRootFromParent_Done,
     /* 1258236 */   // Label 18152: @1258236
     /* 1258236 */   GIM_Try, /*On fail goto*//*Label 18153*/ GIMT_Encode4(1258320), // Rule ID 7835 //
     /* 1258241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1258258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1258261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258294 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1258297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258319 */     // GIR_Coverage, 7835,
     /* 1258319 */     GIR_EraseRootFromParent_Done,
     /* 1258320 */   // Label 18153: @1258320
     /* 1258320 */   GIM_Try, /*On fail goto*//*Label 18154*/ GIMT_Encode4(1258404), // Rule ID 7838 //
     /* 1258325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1258342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1258345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258378 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1258381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258403 */     // GIR_Coverage, 7838,
     /* 1258403 */     GIR_EraseRootFromParent_Done,
     /* 1258404 */   // Label 18154: @1258404
     /* 1258404 */   GIM_Try, /*On fail goto*//*Label 18155*/ GIMT_Encode4(1258488), // Rule ID 7839 //
     /* 1258409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1258426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1258429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258462 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1258465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258487 */     // GIR_Coverage, 7839,
     /* 1258487 */     GIR_EraseRootFromParent_Done,
     /* 1258488 */   // Label 18155: @1258488
     /* 1258488 */   GIM_Try, /*On fail goto*//*Label 18156*/ GIMT_Encode4(1258572), // Rule ID 7842 //
     /* 1258493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1258504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1258507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1258510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1258513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1258516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258546 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1258549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258571 */     // GIR_Coverage, 7842,
     /* 1258571 */     GIR_EraseRootFromParent_Done,
     /* 1258572 */   // Label 18156: @1258572
     /* 1258572 */   GIM_Try, /*On fail goto*//*Label 18157*/ GIMT_Encode4(1258656), // Rule ID 7843 //
     /* 1258577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1258588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1258591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1258594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1258597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1258600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258630 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1258633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258655 */     // GIR_Coverage, 7843,
     /* 1258655 */     GIR_EraseRootFromParent_Done,
     /* 1258656 */   // Label 18157: @1258656
     /* 1258656 */   GIM_Try, /*On fail goto*//*Label 18158*/ GIMT_Encode4(1258740), // Rule ID 7846 //
     /* 1258661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1258672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1258675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1258678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1258681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1258684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258714 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1258717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258739 */     // GIR_Coverage, 7846,
     /* 1258739 */     GIR_EraseRootFromParent_Done,
     /* 1258740 */   // Label 18158: @1258740
     /* 1258740 */   GIM_Try, /*On fail goto*//*Label 18159*/ GIMT_Encode4(1258824), // Rule ID 7847 //
     /* 1258745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1258756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1258759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1258762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1258765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1258768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258798 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1258801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258823 */     // GIR_Coverage, 7847,
     /* 1258823 */     GIR_EraseRootFromParent_Done,
     /* 1258824 */   // Label 18159: @1258824
     /* 1258824 */   GIM_Try, /*On fail goto*//*Label 18160*/ GIMT_Encode4(1258908), // Rule ID 7850 //
     /* 1258829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1258846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1258849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258882 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1258885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258907 */     // GIR_Coverage, 7850,
     /* 1258907 */     GIR_EraseRootFromParent_Done,
     /* 1258908 */   // Label 18160: @1258908
     /* 1258908 */   GIM_Try, /*On fail goto*//*Label 18161*/ GIMT_Encode4(1258992), // Rule ID 7851 //
     /* 1258913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1258930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1258933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258966 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1258969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258991 */     // GIR_Coverage, 7851,
     /* 1258991 */     GIR_EraseRootFromParent_Done,
     /* 1258992 */   // Label 18161: @1258992
     /* 1258992 */   GIM_Try, /*On fail goto*//*Label 18162*/ GIMT_Encode4(1259076), // Rule ID 7854 //
     /* 1258997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1259008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1259011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1259014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1259017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1259020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259050 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1259053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259075 */     // GIR_Coverage, 7854,
     /* 1259075 */     GIR_EraseRootFromParent_Done,
     /* 1259076 */   // Label 18162: @1259076
     /* 1259076 */   GIM_Try, /*On fail goto*//*Label 18163*/ GIMT_Encode4(1259160), // Rule ID 7855 //
     /* 1259081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1259092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1259095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1259098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1259101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1259104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259134 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1259137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259159 */     // GIR_Coverage, 7855,
     /* 1259159 */     GIR_EraseRootFromParent_Done,
     /* 1259160 */   // Label 18163: @1259160
     /* 1259160 */   GIM_Try, /*On fail goto*//*Label 18164*/ GIMT_Encode4(1259244), // Rule ID 7858 //
     /* 1259165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1259182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1259185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259218 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1259221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259243 */     // GIR_Coverage, 7858,
     /* 1259243 */     GIR_EraseRootFromParent_Done,
     /* 1259244 */   // Label 18164: @1259244
     /* 1259244 */   GIM_Try, /*On fail goto*//*Label 18165*/ GIMT_Encode4(1259328), // Rule ID 7859 //
     /* 1259249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1259266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1259269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259302 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1259305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259327 */     // GIR_Coverage, 7859,
     /* 1259327 */     GIR_EraseRootFromParent_Done,
     /* 1259328 */   // Label 18165: @1259328
     /* 1259328 */   GIM_Try, /*On fail goto*//*Label 18166*/ GIMT_Encode4(1259412), // Rule ID 7862 //
     /* 1259333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1259353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259386 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1259389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259411 */     // GIR_Coverage, 7862,
     /* 1259411 */     GIR_EraseRootFromParent_Done,
     /* 1259412 */   // Label 18166: @1259412
     /* 1259412 */   GIM_Try, /*On fail goto*//*Label 18167*/ GIMT_Encode4(1259496), // Rule ID 7863 //
     /* 1259417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1259437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259470 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1259473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259495 */     // GIR_Coverage, 7863,
     /* 1259495 */     GIR_EraseRootFromParent_Done,
     /* 1259496 */   // Label 18167: @1259496
     /* 1259496 */   GIM_Try, /*On fail goto*//*Label 18168*/ GIMT_Encode4(1259580), // Rule ID 7866 //
     /* 1259501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1259521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259554 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1259557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259579 */     // GIR_Coverage, 7866,
     /* 1259579 */     GIR_EraseRootFromParent_Done,
     /* 1259580 */   // Label 18168: @1259580
     /* 1259580 */   GIM_Try, /*On fail goto*//*Label 18169*/ GIMT_Encode4(1259664), // Rule ID 7867 //
     /* 1259585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1259605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259638 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1259641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259663 */     // GIR_Coverage, 7867,
     /* 1259663 */     GIR_EraseRootFromParent_Done,
     /* 1259664 */   // Label 18169: @1259664
     /* 1259664 */   GIM_Try, /*On fail goto*//*Label 18170*/ GIMT_Encode4(1259748), // Rule ID 7870 //
     /* 1259669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1259672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1259680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1259683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1259686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1259689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1259692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259722 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1259725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259747 */     // GIR_Coverage, 7870,
     /* 1259747 */     GIR_EraseRootFromParent_Done,
     /* 1259748 */   // Label 18170: @1259748
     /* 1259748 */   GIM_Try, /*On fail goto*//*Label 18171*/ GIMT_Encode4(1259832), // Rule ID 7871 //
     /* 1259753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1259756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1259764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1259767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1259770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1259773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1259776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259806 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1259809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259831 */     // GIR_Coverage, 7871,
     /* 1259831 */     GIR_EraseRootFromParent_Done,
     /* 1259832 */   // Label 18171: @1259832
     /* 1259832 */   GIM_Try, /*On fail goto*//*Label 18172*/ GIMT_Encode4(1259916), // Rule ID 7874 //
     /* 1259837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1259840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1259854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1259857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259890 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1259893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259915 */     // GIR_Coverage, 7874,
     /* 1259915 */     GIR_EraseRootFromParent_Done,
     /* 1259916 */   // Label 18172: @1259916
     /* 1259916 */   GIM_Try, /*On fail goto*//*Label 18173*/ GIMT_Encode4(1260000), // Rule ID 7875 //
     /* 1259921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1259924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1259938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1259941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259974 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1259977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259999 */     // GIR_Coverage, 7875,
     /* 1259999 */     GIR_EraseRootFromParent_Done,
     /* 1260000 */   // Label 18173: @1260000
     /* 1260000 */   GIM_Try, /*On fail goto*//*Label 18174*/ GIMT_Encode4(1260084), // Rule ID 7878 //
     /* 1260005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1260008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1260016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1260019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1260022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1260025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260058 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1260061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260083 */     // GIR_Coverage, 7878,
     /* 1260083 */     GIR_EraseRootFromParent_Done,
     /* 1260084 */   // Label 18174: @1260084
     /* 1260084 */   GIM_Try, /*On fail goto*//*Label 18175*/ GIMT_Encode4(1260168), // Rule ID 7879 //
     /* 1260089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1260092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1260100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1260103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1260106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1260109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260142 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1260145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260167 */     // GIR_Coverage, 7879,
     /* 1260167 */     GIR_EraseRootFromParent_Done,
     /* 1260168 */   // Label 18175: @1260168
     /* 1260168 */   GIM_Try, /*On fail goto*//*Label 18176*/ GIMT_Encode4(1260252), // Rule ID 7882 //
     /* 1260173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1260190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260226 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1260229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260251 */     // GIR_Coverage, 7882,
     /* 1260251 */     GIR_EraseRootFromParent_Done,
     /* 1260252 */   // Label 18176: @1260252
     /* 1260252 */   GIM_Try, /*On fail goto*//*Label 18177*/ GIMT_Encode4(1260336), // Rule ID 7883 //
     /* 1260257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1260274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260310 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1260313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260335 */     // GIR_Coverage, 7883,
     /* 1260335 */     GIR_EraseRootFromParent_Done,
     /* 1260336 */   // Label 18177: @1260336
     /* 1260336 */   GIM_Try, /*On fail goto*//*Label 18178*/ GIMT_Encode4(1260420), // Rule ID 7886 //
     /* 1260341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1260358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260394 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1260397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260419 */     // GIR_Coverage, 7886,
     /* 1260419 */     GIR_EraseRootFromParent_Done,
     /* 1260420 */   // Label 18178: @1260420
     /* 1260420 */   GIM_Try, /*On fail goto*//*Label 18179*/ GIMT_Encode4(1260504), // Rule ID 7887 //
     /* 1260425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1260442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260478 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1260481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260503 */     // GIR_Coverage, 7887,
     /* 1260503 */     GIR_EraseRootFromParent_Done,
     /* 1260504 */   // Label 18179: @1260504
     /* 1260504 */   GIM_Try, /*On fail goto*//*Label 18180*/ GIMT_Encode4(1260588), // Rule ID 7890 //
     /* 1260509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1260526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260562 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1260565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260587 */     // GIR_Coverage, 7890,
     /* 1260587 */     GIR_EraseRootFromParent_Done,
     /* 1260588 */   // Label 18180: @1260588
     /* 1260588 */   GIM_Try, /*On fail goto*//*Label 18181*/ GIMT_Encode4(1260672), // Rule ID 7891 //
     /* 1260593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1260610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260646 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1260649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260671 */     // GIR_Coverage, 7891,
     /* 1260671 */     GIR_EraseRootFromParent_Done,
     /* 1260672 */   // Label 18181: @1260672
     /* 1260672 */   GIM_Try, /*On fail goto*//*Label 18182*/ GIMT_Encode4(1260756), // Rule ID 7894 //
     /* 1260677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1260694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260730 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1260733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260755 */     // GIR_Coverage, 7894,
     /* 1260755 */     GIR_EraseRootFromParent_Done,
     /* 1260756 */   // Label 18182: @1260756
     /* 1260756 */   GIM_Try, /*On fail goto*//*Label 18183*/ GIMT_Encode4(1260840), // Rule ID 7895 //
     /* 1260761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1260778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260814 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1260817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260839 */     // GIR_Coverage, 7895,
     /* 1260839 */     GIR_EraseRootFromParent_Done,
     /* 1260840 */   // Label 18183: @1260840
     /* 1260840 */   GIM_Try, /*On fail goto*//*Label 18184*/ GIMT_Encode4(1260924), // Rule ID 7898 //
     /* 1260845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1260862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260898 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1260901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260923 */     // GIR_Coverage, 7898,
     /* 1260923 */     GIR_EraseRootFromParent_Done,
     /* 1260924 */   // Label 18184: @1260924
     /* 1260924 */   GIM_Try, /*On fail goto*//*Label 18185*/ GIMT_Encode4(1261008), // Rule ID 7899 //
     /* 1260929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1260946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260982 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1260985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261007 */     // GIR_Coverage, 7899,
     /* 1261007 */     GIR_EraseRootFromParent_Done,
     /* 1261008 */   // Label 18185: @1261008
     /* 1261008 */   GIM_Try, /*On fail goto*//*Label 18186*/ GIMT_Encode4(1261092), // Rule ID 7902 //
     /* 1261013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1261021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1261030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1261033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261066 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1261069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261091 */     // GIR_Coverage, 7902,
     /* 1261091 */     GIR_EraseRootFromParent_Done,
     /* 1261092 */   // Label 18186: @1261092
     /* 1261092 */   GIM_Try, /*On fail goto*//*Label 18187*/ GIMT_Encode4(1261176), // Rule ID 7903 //
     /* 1261097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1261105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1261114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1261117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261150 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1261153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261175 */     // GIR_Coverage, 7903,
     /* 1261175 */     GIR_EraseRootFromParent_Done,
     /* 1261176 */   // Label 18187: @1261176
     /* 1261176 */   GIM_Try, /*On fail goto*//*Label 18188*/ GIMT_Encode4(1261260), // Rule ID 7906 //
     /* 1261181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1261189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1261201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261234 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1261237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261259 */     // GIR_Coverage, 7906,
     /* 1261259 */     GIR_EraseRootFromParent_Done,
     /* 1261260 */   // Label 18188: @1261260
     /* 1261260 */   GIM_Try, /*On fail goto*//*Label 18189*/ GIMT_Encode4(1261344), // Rule ID 7907 //
     /* 1261265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1261273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1261285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261318 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1261321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261343 */     // GIR_Coverage, 7907,
     /* 1261343 */     GIR_EraseRootFromParent_Done,
     /* 1261344 */   // Label 18189: @1261344
     /* 1261344 */   GIM_Try, /*On fail goto*//*Label 18190*/ GIMT_Encode4(1261428), // Rule ID 7910 //
     /* 1261349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1261357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1261366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1261369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261402 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1261405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261427 */     // GIR_Coverage, 7910,
     /* 1261427 */     GIR_EraseRootFromParent_Done,
     /* 1261428 */   // Label 18190: @1261428
     /* 1261428 */   GIM_Try, /*On fail goto*//*Label 18191*/ GIMT_Encode4(1261512), // Rule ID 7911 //
     /* 1261433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1261441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1261450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1261453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261486 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1261489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261511 */     // GIR_Coverage, 7911,
     /* 1261511 */     GIR_EraseRootFromParent_Done,
     /* 1261512 */   // Label 18191: @1261512
     /* 1261512 */   GIM_Try, /*On fail goto*//*Label 18192*/ GIMT_Encode4(1261596), // Rule ID 7914 //
     /* 1261517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1261525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1261534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1261537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261570 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1261573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261595 */     // GIR_Coverage, 7914,
     /* 1261595 */     GIR_EraseRootFromParent_Done,
     /* 1261596 */   // Label 18192: @1261596
     /* 1261596 */   GIM_Try, /*On fail goto*//*Label 18193*/ GIMT_Encode4(1261680), // Rule ID 7915 //
     /* 1261601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1261609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1261618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1261621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261654 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1261657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261679 */     // GIR_Coverage, 7915,
     /* 1261679 */     GIR_EraseRootFromParent_Done,
     /* 1261680 */   // Label 18193: @1261680
     /* 1261680 */   GIM_Try, /*On fail goto*//*Label 18194*/ GIMT_Encode4(1261764), // Rule ID 7918 //
     /* 1261685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1261688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1261693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1261702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1261705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261738 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1261741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1261759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261763 */     // GIR_Coverage, 7918,
     /* 1261763 */     GIR_EraseRootFromParent_Done,
     /* 1261764 */   // Label 18194: @1261764
     /* 1261764 */   GIM_Try, /*On fail goto*//*Label 18195*/ GIMT_Encode4(1261848), // Rule ID 7919 //
     /* 1261769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1261772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1261777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1261786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1261789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261822 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1261825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1261843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261847 */     // GIR_Coverage, 7919,
     /* 1261847 */     GIR_EraseRootFromParent_Done,
     /* 1261848 */   // Label 18195: @1261848
     /* 1261848 */   GIM_Try, /*On fail goto*//*Label 18196*/ GIMT_Encode4(1261932), // Rule ID 7922 //
     /* 1261853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1261861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1261864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1261867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1261870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1261873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1261876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261906 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1261909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261931 */     // GIR_Coverage, 7922,
     /* 1261931 */     GIR_EraseRootFromParent_Done,
     /* 1261932 */   // Label 18196: @1261932
     /* 1261932 */   GIM_Try, /*On fail goto*//*Label 18197*/ GIMT_Encode4(1262016), // Rule ID 7923 //
     /* 1261937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1261945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1261948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1261951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1261954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1261957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1261960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261990 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1261993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262015 */     // GIR_Coverage, 7923,
     /* 1262015 */     GIR_EraseRootFromParent_Done,
     /* 1262016 */   // Label 18197: @1262016
     /* 1262016 */   GIM_Try, /*On fail goto*//*Label 18198*/ GIMT_Encode4(1262100), // Rule ID 7926 //
     /* 1262021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1262029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1262038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1262041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262074 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1262077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262099 */     // GIR_Coverage, 7926,
     /* 1262099 */     GIR_EraseRootFromParent_Done,
     /* 1262100 */   // Label 18198: @1262100
     /* 1262100 */   GIM_Try, /*On fail goto*//*Label 18199*/ GIMT_Encode4(1262184), // Rule ID 7927 //
     /* 1262105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1262113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1262122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1262125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262158 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1262161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262183 */     // GIR_Coverage, 7927,
     /* 1262183 */     GIR_EraseRootFromParent_Done,
     /* 1262184 */   // Label 18199: @1262184
     /* 1262184 */   GIM_Try, /*On fail goto*//*Label 18200*/ GIMT_Encode4(1262268), // Rule ID 7930 //
     /* 1262189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1262197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1262200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1262203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1262209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262242 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1262245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262267 */     // GIR_Coverage, 7930,
     /* 1262267 */     GIR_EraseRootFromParent_Done,
     /* 1262268 */   // Label 18200: @1262268
     /* 1262268 */   GIM_Try, /*On fail goto*//*Label 18201*/ GIMT_Encode4(1262352), // Rule ID 7931 //
     /* 1262273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1262281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1262284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1262287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1262293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262326 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1262329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262351 */     // GIR_Coverage, 7931,
     /* 1262351 */     GIR_EraseRootFromParent_Done,
     /* 1262352 */   // Label 18201: @1262352
     /* 1262352 */   GIM_Try, /*On fail goto*//*Label 18202*/ GIMT_Encode4(1262436), // Rule ID 7934 //
     /* 1262357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1262365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1262374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1262377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262410 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1262413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262435 */     // GIR_Coverage, 7934,
     /* 1262435 */     GIR_EraseRootFromParent_Done,
     /* 1262436 */   // Label 18202: @1262436
     /* 1262436 */   GIM_Try, /*On fail goto*//*Label 18203*/ GIMT_Encode4(1262520), // Rule ID 7935 //
     /* 1262441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1262449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1262458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1262461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262494 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1262497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262519 */     // GIR_Coverage, 7935,
     /* 1262519 */     GIR_EraseRootFromParent_Done,
     /* 1262520 */   // Label 18203: @1262520
     /* 1262520 */   GIM_Try, /*On fail goto*//*Label 18204*/ GIMT_Encode4(1262604), // Rule ID 7938 //
     /* 1262525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1262533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1262542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1262545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262578 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1262581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262603 */     // GIR_Coverage, 7938,
     /* 1262603 */     GIR_EraseRootFromParent_Done,
     /* 1262604 */   // Label 18204: @1262604
     /* 1262604 */   GIM_Try, /*On fail goto*//*Label 18205*/ GIMT_Encode4(1262688), // Rule ID 7939 //
     /* 1262609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1262617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1262626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1262629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262662 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1262665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262687 */     // GIR_Coverage, 7939,
     /* 1262687 */     GIR_EraseRootFromParent_Done,
     /* 1262688 */   // Label 18205: @1262688
     /* 1262688 */   GIM_Try, /*On fail goto*//*Label 18206*/ GIMT_Encode4(1262772), // Rule ID 7942 //
     /* 1262693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1262701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1262710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1262713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262746 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1262749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262771 */     // GIR_Coverage, 7942,
     /* 1262771 */     GIR_EraseRootFromParent_Done,
     /* 1262772 */   // Label 18206: @1262772
     /* 1262772 */   GIM_Try, /*On fail goto*//*Label 18207*/ GIMT_Encode4(1262856), // Rule ID 7943 //
     /* 1262777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1262785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1262794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1262797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262830 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1262833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262855 */     // GIR_Coverage, 7943,
     /* 1262855 */     GIR_EraseRootFromParent_Done,
     /* 1262856 */   // Label 18207: @1262856
     /* 1262856 */   GIM_Try, /*On fail goto*//*Label 18208*/ GIMT_Encode4(1262940), // Rule ID 7946 //
     /* 1262861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1262869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1262872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1262875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1262878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1262881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1262884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262914 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1262917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262939 */     // GIR_Coverage, 7946,
     /* 1262939 */     GIR_EraseRootFromParent_Done,
     /* 1262940 */   // Label 18208: @1262940
     /* 1262940 */   GIM_Try, /*On fail goto*//*Label 18209*/ GIMT_Encode4(1263024), // Rule ID 7947 //
     /* 1262945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1262953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1262956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1262959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1262962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1262965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1262968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262998 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1263001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263023 */     // GIR_Coverage, 7947,
     /* 1263023 */     GIR_EraseRootFromParent_Done,
     /* 1263024 */   // Label 18209: @1263024
     /* 1263024 */   GIM_Try, /*On fail goto*//*Label 18210*/ GIMT_Encode4(1263108), // Rule ID 7950 //
     /* 1263029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1263037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1263046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263082 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1263085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263107 */     // GIR_Coverage, 7950,
     /* 1263107 */     GIR_EraseRootFromParent_Done,
     /* 1263108 */   // Label 18210: @1263108
     /* 1263108 */   GIM_Try, /*On fail goto*//*Label 18211*/ GIMT_Encode4(1263192), // Rule ID 7951 //
     /* 1263113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1263121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1263130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263166 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1263169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263191 */     // GIR_Coverage, 7951,
     /* 1263191 */     GIR_EraseRootFromParent_Done,
     /* 1263192 */   // Label 18211: @1263192
     /* 1263192 */   GIM_Try, /*On fail goto*//*Label 18212*/ GIMT_Encode4(1263276), // Rule ID 7954 //
     /* 1263197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1263205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263250 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1263253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263275 */     // GIR_Coverage, 7954,
     /* 1263275 */     GIR_EraseRootFromParent_Done,
     /* 1263276 */   // Label 18212: @1263276
     /* 1263276 */   GIM_Try, /*On fail goto*//*Label 18213*/ GIMT_Encode4(1263360), // Rule ID 7955 //
     /* 1263281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1263289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263334 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1263337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263359 */     // GIR_Coverage, 7955,
     /* 1263359 */     GIR_EraseRootFromParent_Done,
     /* 1263360 */   // Label 18213: @1263360
     /* 1263360 */   GIM_Try, /*On fail goto*//*Label 18214*/ GIMT_Encode4(1263444), // Rule ID 7958 //
     /* 1263365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1263373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1263382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263418 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1263421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263443 */     // GIR_Coverage, 7958,
     /* 1263443 */     GIR_EraseRootFromParent_Done,
     /* 1263444 */   // Label 18214: @1263444
     /* 1263444 */   GIM_Try, /*On fail goto*//*Label 18215*/ GIMT_Encode4(1263528), // Rule ID 7959 //
     /* 1263449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1263457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1263466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263502 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1263505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263527 */     // GIR_Coverage, 7959,
     /* 1263527 */     GIR_EraseRootFromParent_Done,
     /* 1263528 */   // Label 18215: @1263528
     /* 1263528 */   GIM_Try, /*On fail goto*//*Label 18216*/ GIMT_Encode4(1263612), // Rule ID 7962 //
     /* 1263533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1263541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1263550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263586 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1263589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263611 */     // GIR_Coverage, 7962,
     /* 1263611 */     GIR_EraseRootFromParent_Done,
     /* 1263612 */   // Label 18216: @1263612
     /* 1263612 */   GIM_Try, /*On fail goto*//*Label 18217*/ GIMT_Encode4(1263696), // Rule ID 7963 //
     /* 1263617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1263625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1263634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263670 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1263673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263695 */     // GIR_Coverage, 7963,
     /* 1263695 */     GIR_EraseRootFromParent_Done,
     /* 1263696 */   // Label 18217: @1263696
     /* 1263696 */   GIM_Try, /*On fail goto*//*Label 18218*/ GIMT_Encode4(1263780), // Rule ID 7966 //
     /* 1263701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1263709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1263718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263754 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1263757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263779 */     // GIR_Coverage, 7966,
     /* 1263779 */     GIR_EraseRootFromParent_Done,
     /* 1263780 */   // Label 18218: @1263780
     /* 1263780 */   GIM_Try, /*On fail goto*//*Label 18219*/ GIMT_Encode4(1263864), // Rule ID 7967 //
     /* 1263785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1263793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1263802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263838 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1263841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263863 */     // GIR_Coverage, 7967,
     /* 1263863 */     GIR_EraseRootFromParent_Done,
     /* 1263864 */   // Label 18219: @1263864
     /* 1263864 */   GIM_Try, /*On fail goto*//*Label 18220*/ GIMT_Encode4(1263948), // Rule ID 8058 //
     /* 1263869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1263880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1263883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1263886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1263889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1263892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263922 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1263925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263947 */     // GIR_Coverage, 8058,
     /* 1263947 */     GIR_EraseRootFromParent_Done,
     /* 1263948 */   // Label 18220: @1263948
     /* 1263948 */   GIM_Try, /*On fail goto*//*Label 18221*/ GIMT_Encode4(1264032), // Rule ID 8059 //
     /* 1263953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1263964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1263967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1263970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1263973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1263976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264006 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1264009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264031 */     // GIR_Coverage, 8059,
     /* 1264031 */     GIR_EraseRootFromParent_Done,
     /* 1264032 */   // Label 18221: @1264032
     /* 1264032 */   GIM_Try, /*On fail goto*//*Label 18222*/ GIMT_Encode4(1264116), // Rule ID 8062 //
     /* 1264037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1264054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1264057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264090 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1264093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264115 */     // GIR_Coverage, 8062,
     /* 1264115 */     GIR_EraseRootFromParent_Done,
     /* 1264116 */   // Label 18222: @1264116
     /* 1264116 */   GIM_Try, /*On fail goto*//*Label 18223*/ GIMT_Encode4(1264200), // Rule ID 8063 //
     /* 1264121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1264138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1264141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264174 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1264177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264199 */     // GIR_Coverage, 8063,
     /* 1264199 */     GIR_EraseRootFromParent_Done,
     /* 1264200 */   // Label 18223: @1264200
     /* 1264200 */   GIM_Try, /*On fail goto*//*Label 18224*/ GIMT_Encode4(1264284), // Rule ID 8066 //
     /* 1264205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1264225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264258 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1264261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264283 */     // GIR_Coverage, 8066,
     /* 1264283 */     GIR_EraseRootFromParent_Done,
     /* 1264284 */   // Label 18224: @1264284
     /* 1264284 */   GIM_Try, /*On fail goto*//*Label 18225*/ GIMT_Encode4(1264368), // Rule ID 8067 //
     /* 1264289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1264309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264342 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1264345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264367 */     // GIR_Coverage, 8067,
     /* 1264367 */     GIR_EraseRootFromParent_Done,
     /* 1264368 */   // Label 18225: @1264368
     /* 1264368 */   GIM_Try, /*On fail goto*//*Label 18226*/ GIMT_Encode4(1264452), // Rule ID 8070 //
     /* 1264373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1264390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1264393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264426 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1264429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264451 */     // GIR_Coverage, 8070,
     /* 1264451 */     GIR_EraseRootFromParent_Done,
     /* 1264452 */   // Label 18226: @1264452
     /* 1264452 */   GIM_Try, /*On fail goto*//*Label 18227*/ GIMT_Encode4(1264536), // Rule ID 8071 //
     /* 1264457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1264474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1264477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264510 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1264513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264535 */     // GIR_Coverage, 8071,
     /* 1264535 */     GIR_EraseRootFromParent_Done,
     /* 1264536 */   // Label 18227: @1264536
     /* 1264536 */   GIM_Try, /*On fail goto*//*Label 18228*/ GIMT_Encode4(1264620), // Rule ID 8074 //
     /* 1264541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1264558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1264561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264594 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1264597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264619 */     // GIR_Coverage, 8074,
     /* 1264619 */     GIR_EraseRootFromParent_Done,
     /* 1264620 */   // Label 18228: @1264620
     /* 1264620 */   GIM_Try, /*On fail goto*//*Label 18229*/ GIMT_Encode4(1264704), // Rule ID 8075 //
     /* 1264625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1264642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1264645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264678 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1264681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264703 */     // GIR_Coverage, 8075,
     /* 1264703 */     GIR_EraseRootFromParent_Done,
     /* 1264704 */   // Label 18229: @1264704
     /* 1264704 */   GIM_Try, /*On fail goto*//*Label 18230*/ GIMT_Encode4(1264788), // Rule ID 8078 //
     /* 1264709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1264726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1264729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264762 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1264765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1264783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264787 */     // GIR_Coverage, 8078,
     /* 1264787 */     GIR_EraseRootFromParent_Done,
     /* 1264788 */   // Label 18230: @1264788
     /* 1264788 */   GIM_Try, /*On fail goto*//*Label 18231*/ GIMT_Encode4(1264872), // Rule ID 8079 //
     /* 1264793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1264810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1264813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264846 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1264849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1264867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264871 */     // GIR_Coverage, 8079,
     /* 1264871 */     GIR_EraseRootFromParent_Done,
     /* 1264872 */   // Label 18231: @1264872
     /* 1264872 */   GIM_Try, /*On fail goto*//*Label 18232*/ GIMT_Encode4(1264956), // Rule ID 8082 //
     /* 1264877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1264894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1264897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264930 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1264933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264955 */     // GIR_Coverage, 8082,
     /* 1264955 */     GIR_EraseRootFromParent_Done,
     /* 1264956 */   // Label 18232: @1264956
     /* 1264956 */   GIM_Try, /*On fail goto*//*Label 18233*/ GIMT_Encode4(1265040), // Rule ID 8083 //
     /* 1264961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1264978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1264981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265014 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1265017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265039 */     // GIR_Coverage, 8083,
     /* 1265039 */     GIR_EraseRootFromParent_Done,
     /* 1265040 */   // Label 18233: @1265040
     /* 1265040 */   GIM_Try, /*On fail goto*//*Label 18234*/ GIMT_Encode4(1265124), // Rule ID 8086 //
     /* 1265045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1265056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1265059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1265062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1265065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265098 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1265101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265123 */     // GIR_Coverage, 8086,
     /* 1265123 */     GIR_EraseRootFromParent_Done,
     /* 1265124 */   // Label 18234: @1265124
     /* 1265124 */   GIM_Try, /*On fail goto*//*Label 18235*/ GIMT_Encode4(1265208), // Rule ID 8087 //
     /* 1265129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1265140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1265143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1265146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1265149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265182 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1265185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265207 */     // GIR_Coverage, 8087,
     /* 1265207 */     GIR_EraseRootFromParent_Done,
     /* 1265208 */   // Label 18235: @1265208
     /* 1265208 */   GIM_Try, /*On fail goto*//*Label 18236*/ GIMT_Encode4(1265292), // Rule ID 8090 //
     /* 1265213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1265233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265266 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1265269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265291 */     // GIR_Coverage, 8090,
     /* 1265291 */     GIR_EraseRootFromParent_Done,
     /* 1265292 */   // Label 18236: @1265292
     /* 1265292 */   GIM_Try, /*On fail goto*//*Label 18237*/ GIMT_Encode4(1265376), // Rule ID 8091 //
     /* 1265297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1265317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265350 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1265353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265375 */     // GIR_Coverage, 8091,
     /* 1265375 */     GIR_EraseRootFromParent_Done,
     /* 1265376 */   // Label 18237: @1265376
     /* 1265376 */   GIM_Try, /*On fail goto*//*Label 18238*/ GIMT_Encode4(1265460), // Rule ID 8094 //
     /* 1265381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1265384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1265398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1265401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265434 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1265437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265459 */     // GIR_Coverage, 8094,
     /* 1265459 */     GIR_EraseRootFromParent_Done,
     /* 1265460 */   // Label 18238: @1265460
     /* 1265460 */   GIM_Try, /*On fail goto*//*Label 18239*/ GIMT_Encode4(1265544), // Rule ID 8095 //
     /* 1265465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1265468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1265482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1265485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265518 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1265521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265543 */     // GIR_Coverage, 8095,
     /* 1265543 */     GIR_EraseRootFromParent_Done,
     /* 1265544 */   // Label 18239: @1265544
     /* 1265544 */   GIM_Try, /*On fail goto*//*Label 18240*/ GIMT_Encode4(1265628), // Rule ID 8098 //
     /* 1265549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1265560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1265563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1265566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1265569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1265572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265602 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1265605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265627 */     // GIR_Coverage, 8098,
     /* 1265627 */     GIR_EraseRootFromParent_Done,
     /* 1265628 */   // Label 18240: @1265628
     /* 1265628 */   GIM_Try, /*On fail goto*//*Label 18241*/ GIMT_Encode4(1265712), // Rule ID 8099 //
     /* 1265633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1265644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1265647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1265650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1265653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1265656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265686 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1265689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265711 */     // GIR_Coverage, 8099,
     /* 1265711 */     GIR_EraseRootFromParent_Done,
     /* 1265712 */   // Label 18241: @1265712
     /* 1265712 */   GIM_Try, /*On fail goto*//*Label 18242*/ GIMT_Encode4(1265796), // Rule ID 8102 //
     /* 1265717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1265728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1265731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1265734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1265737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1265740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1265755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1265759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265770 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1265773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265795 */     // GIR_Coverage, 8102,
     /* 1265795 */     GIR_EraseRootFromParent_Done,
     /* 1265796 */   // Label 18242: @1265796
     /* 1265796 */   GIM_Try, /*On fail goto*//*Label 18243*/ GIMT_Encode4(1265880), // Rule ID 8103 //
     /* 1265801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1265812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1265815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1265818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1265821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1265824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1265839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1265843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265854 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1265857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265879 */     // GIR_Coverage, 8103,
     /* 1265879 */     GIR_EraseRootFromParent_Done,
     /* 1265880 */   // Label 18243: @1265880
     /* 1265880 */   GIM_Try, /*On fail goto*//*Label 18244*/ GIMT_Encode4(1265964), // Rule ID 8106 //
     /* 1265885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1265896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1265899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1265902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1265905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1265908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1265923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1265927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265938 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1265941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265963 */     // GIR_Coverage, 8106,
     /* 1265963 */     GIR_EraseRootFromParent_Done,
     /* 1265964 */   // Label 18244: @1265964
     /* 1265964 */   GIM_Try, /*On fail goto*//*Label 18245*/ GIMT_Encode4(1266048), // Rule ID 8107 //
     /* 1265969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1265980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1265983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1265986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1265989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1265992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266022 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1266025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266047 */     // GIR_Coverage, 8107,
     /* 1266047 */     GIR_EraseRootFromParent_Done,
     /* 1266048 */   // Label 18245: @1266048
     /* 1266048 */   GIM_Try, /*On fail goto*//*Label 18246*/ GIMT_Encode4(1266132), // Rule ID 8110 //
     /* 1266053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1266070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1266073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266106 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1266109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266131 */     // GIR_Coverage, 8110,
     /* 1266131 */     GIR_EraseRootFromParent_Done,
     /* 1266132 */   // Label 18246: @1266132
     /* 1266132 */   GIM_Try, /*On fail goto*//*Label 18247*/ GIMT_Encode4(1266216), // Rule ID 8111 //
     /* 1266137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1266154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1266157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266190 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1266193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266215 */     // GIR_Coverage, 8111,
     /* 1266215 */     GIR_EraseRootFromParent_Done,
     /* 1266216 */   // Label 18247: @1266216
     /* 1266216 */   GIM_Try, /*On fail goto*//*Label 18248*/ GIMT_Encode4(1266300), // Rule ID 8114 //
     /* 1266221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1266241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266274 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1266277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266299 */     // GIR_Coverage, 8114,
     /* 1266299 */     GIR_EraseRootFromParent_Done,
     /* 1266300 */   // Label 18248: @1266300
     /* 1266300 */   GIM_Try, /*On fail goto*//*Label 18249*/ GIMT_Encode4(1266384), // Rule ID 8115 //
     /* 1266305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1266325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266358 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1266361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266383 */     // GIR_Coverage, 8115,
     /* 1266383 */     GIR_EraseRootFromParent_Done,
     /* 1266384 */   // Label 18249: @1266384
     /* 1266384 */   GIM_Try, /*On fail goto*//*Label 18250*/ GIMT_Encode4(1266468), // Rule ID 8118 //
     /* 1266389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1266406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1266409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266442 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1266445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266467 */     // GIR_Coverage, 8118,
     /* 1266467 */     GIR_EraseRootFromParent_Done,
     /* 1266468 */   // Label 18250: @1266468
     /* 1266468 */   GIM_Try, /*On fail goto*//*Label 18251*/ GIMT_Encode4(1266552), // Rule ID 8119 //
     /* 1266473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1266490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1266493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266526 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1266529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266551 */     // GIR_Coverage, 8119,
     /* 1266551 */     GIR_EraseRootFromParent_Done,
     /* 1266552 */   // Label 18251: @1266552
     /* 1266552 */   GIM_Try, /*On fail goto*//*Label 18252*/ GIMT_Encode4(1266636), // Rule ID 8122 //
     /* 1266557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1266568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1266571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1266574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1266577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1266580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1266613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266635 */     // GIR_Coverage, 8122,
     /* 1266635 */     GIR_EraseRootFromParent_Done,
     /* 1266636 */   // Label 18252: @1266636
     /* 1266636 */   GIM_Try, /*On fail goto*//*Label 18253*/ GIMT_Encode4(1266720), // Rule ID 8123 //
     /* 1266641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1266652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1266655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1266658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1266661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1266664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266694 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1266697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266719 */     // GIR_Coverage, 8123,
     /* 1266719 */     GIR_EraseRootFromParent_Done,
     /* 1266720 */   // Label 18253: @1266720
     /* 1266720 */   GIM_Try, /*On fail goto*//*Label 18254*/ GIMT_Encode4(1266804), // Rule ID 8126 //
     /* 1266725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1266742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1266745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266778 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1266781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266803 */     // GIR_Coverage, 8126,
     /* 1266803 */     GIR_EraseRootFromParent_Done,
     /* 1266804 */   // Label 18254: @1266804
     /* 1266804 */   GIM_Try, /*On fail goto*//*Label 18255*/ GIMT_Encode4(1266888), // Rule ID 8127 //
     /* 1266809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1266826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1266829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266862 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1266865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266887 */     // GIR_Coverage, 8127,
     /* 1266887 */     GIR_EraseRootFromParent_Done,
     /* 1266888 */   // Label 18255: @1266888
     /* 1266888 */   GIM_Try, /*On fail goto*//*Label 18256*/ GIMT_Encode4(1266972), // Rule ID 8130 //
     /* 1266893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1266910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1266913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266946 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1266949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266971 */     // GIR_Coverage, 8130,
     /* 1266971 */     GIR_EraseRootFromParent_Done,
     /* 1266972 */   // Label 18256: @1266972
     /* 1266972 */   GIM_Try, /*On fail goto*//*Label 18257*/ GIMT_Encode4(1267056), // Rule ID 8131 //
     /* 1266977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1266994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1266997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1267000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267030 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1267033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267055 */     // GIR_Coverage, 8131,
     /* 1267055 */     GIR_EraseRootFromParent_Done,
     /* 1267056 */   // Label 18257: @1267056
     /* 1267056 */   GIM_Try, /*On fail goto*//*Label 18258*/ GIMT_Encode4(1267140), // Rule ID 8134 //
     /* 1267061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1267078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1267081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267114 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1267117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267139 */     // GIR_Coverage, 8134,
     /* 1267139 */     GIR_EraseRootFromParent_Done,
     /* 1267140 */   // Label 18258: @1267140
     /* 1267140 */   GIM_Try, /*On fail goto*//*Label 18259*/ GIMT_Encode4(1267224), // Rule ID 8135 //
     /* 1267145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1267162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1267165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267198 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1267201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267223 */     // GIR_Coverage, 8135,
     /* 1267223 */     GIR_EraseRootFromParent_Done,
     /* 1267224 */   // Label 18259: @1267224
     /* 1267224 */   GIM_Try, /*On fail goto*//*Label 18260*/ GIMT_Encode4(1267308), // Rule ID 8138 //
     /* 1267229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1267249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267282 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1267285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267307 */     // GIR_Coverage, 8138,
     /* 1267307 */     GIR_EraseRootFromParent_Done,
     /* 1267308 */   // Label 18260: @1267308
     /* 1267308 */   GIM_Try, /*On fail goto*//*Label 18261*/ GIMT_Encode4(1267392), // Rule ID 8139 //
     /* 1267313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1267333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267366 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1267369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267391 */     // GIR_Coverage, 8139,
     /* 1267391 */     GIR_EraseRootFromParent_Done,
     /* 1267392 */   // Label 18261: @1267392
     /* 1267392 */   GIM_Try, /*On fail goto*//*Label 18262*/ GIMT_Encode4(1267476), // Rule ID 8142 //
     /* 1267397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1267414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1267417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267450 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1267453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267475 */     // GIR_Coverage, 8142,
     /* 1267475 */     GIR_EraseRootFromParent_Done,
     /* 1267476 */   // Label 18262: @1267476
     /* 1267476 */   GIM_Try, /*On fail goto*//*Label 18263*/ GIMT_Encode4(1267560), // Rule ID 8143 //
     /* 1267481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1267498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1267501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267534 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1267537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267559 */     // GIR_Coverage, 8143,
     /* 1267559 */     GIR_EraseRootFromParent_Done,
     /* 1267560 */   // Label 18263: @1267560
     /* 1267560 */   GIM_Try, /*On fail goto*//*Label 18264*/ GIMT_Encode4(1267644), // Rule ID 8146 //
     /* 1267565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1267576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1267579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1267582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1267588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267618 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1267621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267643 */     // GIR_Coverage, 8146,
     /* 1267643 */     GIR_EraseRootFromParent_Done,
     /* 1267644 */   // Label 18264: @1267644
     /* 1267644 */   GIM_Try, /*On fail goto*//*Label 18265*/ GIMT_Encode4(1267728), // Rule ID 8147 //
     /* 1267649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1267660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1267663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1267666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1267672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267702 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1267705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267727 */     // GIR_Coverage, 8147,
     /* 1267727 */     GIR_EraseRootFromParent_Done,
     /* 1267728 */   // Label 18265: @1267728
     /* 1267728 */   GIM_Try, /*On fail goto*//*Label 18266*/ GIMT_Encode4(1267812), // Rule ID 8150 //
     /* 1267733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1267750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267786 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1267789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267811 */     // GIR_Coverage, 8150,
     /* 1267811 */     GIR_EraseRootFromParent_Done,
     /* 1267812 */   // Label 18266: @1267812
     /* 1267812 */   GIM_Try, /*On fail goto*//*Label 18267*/ GIMT_Encode4(1267896), // Rule ID 8151 //
     /* 1267817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1267834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267870 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1267873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267895 */     // GIR_Coverage, 8151,
     /* 1267895 */     GIR_EraseRootFromParent_Done,
     /* 1267896 */   // Label 18267: @1267896
     /* 1267896 */   GIM_Try, /*On fail goto*//*Label 18268*/ GIMT_Encode4(1267980), // Rule ID 8154 //
     /* 1267901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1267918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267954 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1267957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267979 */     // GIR_Coverage, 8154,
     /* 1267979 */     GIR_EraseRootFromParent_Done,
     /* 1267980 */   // Label 18268: @1267980
     /* 1267980 */   GIM_Try, /*On fail goto*//*Label 18269*/ GIMT_Encode4(1268064), // Rule ID 8155 //
     /* 1267985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1268002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1268005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268038 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1268041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268063 */     // GIR_Coverage, 8155,
     /* 1268063 */     GIR_EraseRootFromParent_Done,
     /* 1268064 */   // Label 18269: @1268064
     /* 1268064 */   GIM_Try, /*On fail goto*//*Label 18270*/ GIMT_Encode4(1268148), // Rule ID 8158 //
     /* 1268069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1268077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1268086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1268089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268122 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1268125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268147 */     // GIR_Coverage, 8158,
     /* 1268147 */     GIR_EraseRootFromParent_Done,
     /* 1268148 */   // Label 18270: @1268148
     /* 1268148 */   GIM_Try, /*On fail goto*//*Label 18271*/ GIMT_Encode4(1268232), // Rule ID 8159 //
     /* 1268153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1268161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1268170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1268173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268206 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1268209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268231 */     // GIR_Coverage, 8159,
     /* 1268231 */     GIR_EraseRootFromParent_Done,
     /* 1268232 */   // Label 18271: @1268232
     /* 1268232 */   GIM_Try, /*On fail goto*//*Label 18272*/ GIMT_Encode4(1268316), // Rule ID 8162 //
     /* 1268237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1268245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1268257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268290 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1268293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268315 */     // GIR_Coverage, 8162,
     /* 1268315 */     GIR_EraseRootFromParent_Done,
     /* 1268316 */   // Label 18272: @1268316
     /* 1268316 */   GIM_Try, /*On fail goto*//*Label 18273*/ GIMT_Encode4(1268400), // Rule ID 8163 //
     /* 1268321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1268329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1268341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268374 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1268377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268399 */     // GIR_Coverage, 8163,
     /* 1268399 */     GIR_EraseRootFromParent_Done,
     /* 1268400 */   // Label 18273: @1268400
     /* 1268400 */   GIM_Try, /*On fail goto*//*Label 18274*/ GIMT_Encode4(1268484), // Rule ID 8166 //
     /* 1268405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1268413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1268422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1268425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268458 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1268461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268483 */     // GIR_Coverage, 8166,
     /* 1268483 */     GIR_EraseRootFromParent_Done,
     /* 1268484 */   // Label 18274: @1268484
     /* 1268484 */   GIM_Try, /*On fail goto*//*Label 18275*/ GIMT_Encode4(1268568), // Rule ID 8167 //
     /* 1268489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1268497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1268506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1268509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268542 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1268545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268567 */     // GIR_Coverage, 8167,
     /* 1268567 */     GIR_EraseRootFromParent_Done,
     /* 1268568 */   // Label 18275: @1268568
     /* 1268568 */   GIM_Try, /*On fail goto*//*Label 18276*/ GIMT_Encode4(1268652), // Rule ID 8170 //
     /* 1268573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1268581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1268590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1268593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268626 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1268629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268651 */     // GIR_Coverage, 8170,
     /* 1268651 */     GIR_EraseRootFromParent_Done,
     /* 1268652 */   // Label 18276: @1268652
     /* 1268652 */   GIM_Try, /*On fail goto*//*Label 18277*/ GIMT_Encode4(1268736), // Rule ID 8171 //
     /* 1268657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1268665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1268674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1268677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268710 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1268713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268735 */     // GIR_Coverage, 8171,
     /* 1268735 */     GIR_EraseRootFromParent_Done,
     /* 1268736 */   // Label 18277: @1268736
     /* 1268736 */   GIM_Try, /*On fail goto*//*Label 18278*/ GIMT_Encode4(1268820), // Rule ID 8174 //
     /* 1268741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1268749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1268758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1268761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268794 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1268797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268819 */     // GIR_Coverage, 8174,
     /* 1268819 */     GIR_EraseRootFromParent_Done,
     /* 1268820 */   // Label 18278: @1268820
     /* 1268820 */   GIM_Try, /*On fail goto*//*Label 18279*/ GIMT_Encode4(1268904), // Rule ID 8175 //
     /* 1268825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1268833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1268842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1268845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268878 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1268881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268903 */     // GIR_Coverage, 8175,
     /* 1268903 */     GIR_EraseRootFromParent_Done,
     /* 1268904 */   // Label 18279: @1268904
     /* 1268904 */   GIM_Try, /*On fail goto*//*Label 18280*/ GIMT_Encode4(1268988), // Rule ID 8178 //
     /* 1268909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1268917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1268926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1268929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268962 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1268965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268987 */     // GIR_Coverage, 8178,
     /* 1268987 */     GIR_EraseRootFromParent_Done,
     /* 1268988 */   // Label 18280: @1268988
     /* 1268988 */   GIM_Try, /*On fail goto*//*Label 18281*/ GIMT_Encode4(1269072), // Rule ID 8179 //
     /* 1268993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1269001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1269004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1269007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1269010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1269013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269046 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1269049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1269067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269071 */     // GIR_Coverage, 8179,
     /* 1269071 */     GIR_EraseRootFromParent_Done,
     /* 1269072 */   // Label 18281: @1269072
     /* 1269072 */   GIM_Try, /*On fail goto*//*Label 18282*/ GIMT_Encode4(1269156), // Rule ID 8182 //
     /* 1269077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1269080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1269085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1269094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1269097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269130 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1269133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269155 */     // GIR_Coverage, 8182,
     /* 1269155 */     GIR_EraseRootFromParent_Done,
     /* 1269156 */   // Label 18282: @1269156
     /* 1269156 */   GIM_Try, /*On fail goto*//*Label 18283*/ GIMT_Encode4(1269240), // Rule ID 8183 //
     /* 1269161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1269164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1269169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1269178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1269181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269214 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1269217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269239 */     // GIR_Coverage, 8183,
     /* 1269239 */     GIR_EraseRootFromParent_Done,
     /* 1269240 */   // Label 18283: @1269240
     /* 1269240 */   GIM_Try, /*On fail goto*//*Label 18284*/ GIMT_Encode4(1269324), // Rule ID 8186 //
     /* 1269245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1269253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1269262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1269265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269298 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1269301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269323 */     // GIR_Coverage, 8186,
     /* 1269323 */     GIR_EraseRootFromParent_Done,
     /* 1269324 */   // Label 18284: @1269324
     /* 1269324 */   GIM_Try, /*On fail goto*//*Label 18285*/ GIMT_Encode4(1269408), // Rule ID 8187 //
     /* 1269329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1269337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1269346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1269349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269382 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1269385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269407 */     // GIR_Coverage, 8187,
     /* 1269407 */     GIR_EraseRootFromParent_Done,
     /* 1269408 */   // Label 18285: @1269408
     /* 1269408 */   GIM_Try, /*On fail goto*//*Label 18286*/ GIMT_Encode4(1269492), // Rule ID 8190 //
     /* 1269413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1269421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1269424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1269427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1269430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1269433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269466 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1269469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269491 */     // GIR_Coverage, 8190,
     /* 1269491 */     GIR_EraseRootFromParent_Done,
     /* 1269492 */   // Label 18286: @1269492
     /* 1269492 */   GIM_Try, /*On fail goto*//*Label 18287*/ GIMT_Encode4(1269576), // Rule ID 8191 //
     /* 1269497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1269505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1269508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1269511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1269514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1269517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269550 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1269553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269575 */     // GIR_Coverage, 8191,
     /* 1269575 */     GIR_EraseRootFromParent_Done,
     /* 1269576 */   // Label 18287: @1269576
     /* 1269576 */   GIM_Try, /*On fail goto*//*Label 18288*/ GIMT_Encode4(1269660), // Rule ID 8194 //
     /* 1269581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1269589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1269592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1269595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1269598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1269601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1269604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269634 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1269637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269659 */     // GIR_Coverage, 8194,
     /* 1269659 */     GIR_EraseRootFromParent_Done,
     /* 1269660 */   // Label 18288: @1269660
     /* 1269660 */   GIM_Try, /*On fail goto*//*Label 18289*/ GIMT_Encode4(1269744), // Rule ID 8195 //
     /* 1269665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1269673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1269676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1269679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1269682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1269685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1269688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269718 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1269721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269743 */     // GIR_Coverage, 8195,
     /* 1269743 */     GIR_EraseRootFromParent_Done,
     /* 1269744 */   // Label 18289: @1269744
     /* 1269744 */   GIM_Try, /*On fail goto*//*Label 18290*/ GIMT_Encode4(1269828), // Rule ID 8198 //
     /* 1269749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1269757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1269760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1269763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1269766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1269769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1269772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269802 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1269805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269827 */     // GIR_Coverage, 8198,
     /* 1269827 */     GIR_EraseRootFromParent_Done,
     /* 1269828 */   // Label 18290: @1269828
     /* 1269828 */   GIM_Try, /*On fail goto*//*Label 18291*/ GIMT_Encode4(1269912), // Rule ID 8199 //
     /* 1269833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1269841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1269844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1269847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1269850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1269853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1269856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269886 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1269889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269911 */     // GIR_Coverage, 8199,
     /* 1269911 */     GIR_EraseRootFromParent_Done,
     /* 1269912 */   // Label 18291: @1269912
     /* 1269912 */   GIM_Try, /*On fail goto*//*Label 18292*/ GIMT_Encode4(1269996), // Rule ID 8202 //
     /* 1269917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1269925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1269934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1269937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269970 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1269973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269995 */     // GIR_Coverage, 8202,
     /* 1269995 */     GIR_EraseRootFromParent_Done,
     /* 1269996 */   // Label 18292: @1269996
     /* 1269996 */   GIM_Try, /*On fail goto*//*Label 18293*/ GIMT_Encode4(1270080), // Rule ID 8203 //
     /* 1270001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1270009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1270018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1270021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270054 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1270057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270079 */     // GIR_Coverage, 8203,
     /* 1270079 */     GIR_EraseRootFromParent_Done,
     /* 1270080 */   // Label 18293: @1270080
     /* 1270080 */   GIM_Try, /*On fail goto*//*Label 18294*/ GIMT_Encode4(1270164), // Rule ID 8206 //
     /* 1270085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1270093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1270102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1270105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270138 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1270141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270163 */     // GIR_Coverage, 8206,
     /* 1270163 */     GIR_EraseRootFromParent_Done,
     /* 1270164 */   // Label 18294: @1270164
     /* 1270164 */   GIM_Try, /*On fail goto*//*Label 18295*/ GIMT_Encode4(1270248), // Rule ID 8207 //
     /* 1270169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1270177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1270186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1270189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270222 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1270225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270247 */     // GIR_Coverage, 8207,
     /* 1270247 */     GIR_EraseRootFromParent_Done,
     /* 1270248 */   // Label 18295: @1270248
     /* 1270248 */   GIM_Try, /*On fail goto*//*Label 18296*/ GIMT_Encode4(1270332), // Rule ID 8210 //
     /* 1270253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1270261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1270270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1270273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270306 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1270309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270331 */     // GIR_Coverage, 8210,
     /* 1270331 */     GIR_EraseRootFromParent_Done,
     /* 1270332 */   // Label 18296: @1270332
     /* 1270332 */   GIM_Try, /*On fail goto*//*Label 18297*/ GIMT_Encode4(1270416), // Rule ID 8211 //
     /* 1270337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1270345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1270354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1270357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270390 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1270393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270415 */     // GIR_Coverage, 8211,
     /* 1270415 */     GIR_EraseRootFromParent_Done,
     /* 1270416 */   // Label 18297: @1270416
     /* 1270416 */   GIM_Try, /*On fail goto*//*Label 18298*/ GIMT_Encode4(1270500), // Rule ID 8214 //
     /* 1270421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1270429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1270438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1270441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270474 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1270477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270499 */     // GIR_Coverage, 8214,
     /* 1270499 */     GIR_EraseRootFromParent_Done,
     /* 1270500 */   // Label 18298: @1270500
     /* 1270500 */   GIM_Try, /*On fail goto*//*Label 18299*/ GIMT_Encode4(1270584), // Rule ID 8215 //
     /* 1270505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1270513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1270522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1270525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270558 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1270561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270583 */     // GIR_Coverage, 8215,
     /* 1270583 */     GIR_EraseRootFromParent_Done,
     /* 1270584 */   // Label 18299: @1270584
     /* 1270584 */   GIM_Try, /*On fail goto*//*Label 18300*/ GIMT_Encode4(1270668), // Rule ID 8218 //
     /* 1270589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1270597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1270606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1270609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270642 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1270645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270667 */     // GIR_Coverage, 8218,
     /* 1270667 */     GIR_EraseRootFromParent_Done,
     /* 1270668 */   // Label 18300: @1270668
     /* 1270668 */   GIM_Try, /*On fail goto*//*Label 18301*/ GIMT_Encode4(1270752), // Rule ID 8219 //
     /* 1270673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1270681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1270690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1270693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270726 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1270729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270751 */     // GIR_Coverage, 8219,
     /* 1270751 */     GIR_EraseRootFromParent_Done,
     /* 1270752 */   // Label 18301: @1270752
     /* 1270752 */   GIM_Try, /*On fail goto*//*Label 18302*/ GIMT_Encode4(1270836), // Rule ID 8222 //
     /* 1270757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1270760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1270765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1270768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1270771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1270774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1270777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1270780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270810 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1270813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1270831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270835 */     // GIR_Coverage, 8222,
     /* 1270835 */     GIR_EraseRootFromParent_Done,
     /* 1270836 */   // Label 18302: @1270836
     /* 1270836 */   GIM_Try, /*On fail goto*//*Label 18303*/ GIMT_Encode4(1270920), // Rule ID 8223 //
     /* 1270841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1270844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1270849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1270852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1270855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1270858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1270861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1270864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270894 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1270897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1270915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270919 */     // GIR_Coverage, 8223,
     /* 1270919 */     GIR_EraseRootFromParent_Done,
     /* 1270920 */   // Label 18303: @1270920
     /* 1270920 */   GIM_Try, /*On fail goto*//*Label 18304*/ GIMT_Encode4(1271004), // Rule ID 8226 //
     /* 1270925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1270928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1270933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1270942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1270945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270978 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1270981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1270999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271003 */     // GIR_Coverage, 8226,
     /* 1271003 */     GIR_EraseRootFromParent_Done,
     /* 1271004 */   // Label 18304: @1271004
     /* 1271004 */   GIM_Try, /*On fail goto*//*Label 18305*/ GIMT_Encode4(1271088), // Rule ID 8227 //
     /* 1271009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1271017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1271026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271062 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1271065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271087 */     // GIR_Coverage, 8227,
     /* 1271087 */     GIR_EraseRootFromParent_Done,
     /* 1271088 */   // Label 18305: @1271088
     /* 1271088 */   GIM_Try, /*On fail goto*//*Label 18306*/ GIMT_Encode4(1271172), // Rule ID 8230 //
     /* 1271093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1271096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1271101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1271110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271146 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1271149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271171 */     // GIR_Coverage, 8230,
     /* 1271171 */     GIR_EraseRootFromParent_Done,
     /* 1271172 */   // Label 18306: @1271172
     /* 1271172 */   GIM_Try, /*On fail goto*//*Label 18307*/ GIMT_Encode4(1271256), // Rule ID 8231 //
     /* 1271177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1271185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1271194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271230 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1271233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271255 */     // GIR_Coverage, 8231,
     /* 1271255 */     GIR_EraseRootFromParent_Done,
     /* 1271256 */   // Label 18307: @1271256
     /* 1271256 */   GIM_Try, /*On fail goto*//*Label 18308*/ GIMT_Encode4(1271340), // Rule ID 8322 //
     /* 1271261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1271278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1271281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271314 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1271317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271339 */     // GIR_Coverage, 8322,
     /* 1271339 */     GIR_EraseRootFromParent_Done,
     /* 1271340 */   // Label 18308: @1271340
     /* 1271340 */   GIM_Try, /*On fail goto*//*Label 18309*/ GIMT_Encode4(1271424), // Rule ID 8323 //
     /* 1271345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1271362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1271365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271398 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1271401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271423 */     // GIR_Coverage, 8323,
     /* 1271423 */     GIR_EraseRootFromParent_Done,
     /* 1271424 */   // Label 18309: @1271424
     /* 1271424 */   GIM_Try, /*On fail goto*//*Label 18310*/ GIMT_Encode4(1271508), // Rule ID 8326 //
     /* 1271429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1271446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1271449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271482 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1271485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271507 */     // GIR_Coverage, 8326,
     /* 1271507 */     GIR_EraseRootFromParent_Done,
     /* 1271508 */   // Label 18310: @1271508
     /* 1271508 */   GIM_Try, /*On fail goto*//*Label 18311*/ GIMT_Encode4(1271592), // Rule ID 8327 //
     /* 1271513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1271530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1271533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271566 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1271569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271591 */     // GIR_Coverage, 8327,
     /* 1271591 */     GIR_EraseRootFromParent_Done,
     /* 1271592 */   // Label 18311: @1271592
     /* 1271592 */   GIM_Try, /*On fail goto*//*Label 18312*/ GIMT_Encode4(1271676), // Rule ID 8330 //
     /* 1271597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1271614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1271617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271650 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1271653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271675 */     // GIR_Coverage, 8330,
     /* 1271675 */     GIR_EraseRootFromParent_Done,
     /* 1271676 */   // Label 18312: @1271676
     /* 1271676 */   GIM_Try, /*On fail goto*//*Label 18313*/ GIMT_Encode4(1271760), // Rule ID 8331 //
     /* 1271681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1271698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1271701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271734 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1271737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271759 */     // GIR_Coverage, 8331,
     /* 1271759 */     GIR_EraseRootFromParent_Done,
     /* 1271760 */   // Label 18313: @1271760
     /* 1271760 */   GIM_Try, /*On fail goto*//*Label 18314*/ GIMT_Encode4(1271844), // Rule ID 8334 //
     /* 1271765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1271782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1271785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271818 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1271821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271843 */     // GIR_Coverage, 8334,
     /* 1271843 */     GIR_EraseRootFromParent_Done,
     /* 1271844 */   // Label 18314: @1271844
     /* 1271844 */   GIM_Try, /*On fail goto*//*Label 18315*/ GIMT_Encode4(1271928), // Rule ID 8335 //
     /* 1271849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1271866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1271869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271902 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1271905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271927 */     // GIR_Coverage, 8335,
     /* 1271927 */     GIR_EraseRootFromParent_Done,
     /* 1271928 */   // Label 18315: @1271928
     /* 1271928 */   GIM_Try, /*On fail goto*//*Label 18316*/ GIMT_Encode4(1272012), // Rule ID 8338 //
     /* 1271933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1271950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1271953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271986 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1271989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272011 */     // GIR_Coverage, 8338,
     /* 1272011 */     GIR_EraseRootFromParent_Done,
     /* 1272012 */   // Label 18316: @1272012
     /* 1272012 */   GIM_Try, /*On fail goto*//*Label 18317*/ GIMT_Encode4(1272096), // Rule ID 8339 //
     /* 1272017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1272034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1272037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272070 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1272073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272095 */     // GIR_Coverage, 8339,
     /* 1272095 */     GIR_EraseRootFromParent_Done,
     /* 1272096 */   // Label 18317: @1272096
     /* 1272096 */   GIM_Try, /*On fail goto*//*Label 18318*/ GIMT_Encode4(1272180), // Rule ID 8342 //
     /* 1272101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1272118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1272121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272154 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1272157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272179 */     // GIR_Coverage, 8342,
     /* 1272179 */     GIR_EraseRootFromParent_Done,
     /* 1272180 */   // Label 18318: @1272180
     /* 1272180 */   GIM_Try, /*On fail goto*//*Label 18319*/ GIMT_Encode4(1272264), // Rule ID 8343 //
     /* 1272185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1272202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1272205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272238 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1272241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272263 */     // GIR_Coverage, 8343,
     /* 1272263 */     GIR_EraseRootFromParent_Done,
     /* 1272264 */   // Label 18319: @1272264
     /* 1272264 */   GIM_Try, /*On fail goto*//*Label 18320*/ GIMT_Encode4(1272348), // Rule ID 8346 //
     /* 1272269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1272280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1272283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1272286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1272289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272322 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1272325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272347 */     // GIR_Coverage, 8346,
     /* 1272347 */     GIR_EraseRootFromParent_Done,
     /* 1272348 */   // Label 18320: @1272348
     /* 1272348 */   GIM_Try, /*On fail goto*//*Label 18321*/ GIMT_Encode4(1272432), // Rule ID 8347 //
     /* 1272353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1272364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1272367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1272370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1272373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272406 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1272409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272431 */     // GIR_Coverage, 8347,
     /* 1272431 */     GIR_EraseRootFromParent_Done,
     /* 1272432 */   // Label 18321: @1272432
     /* 1272432 */   GIM_Try, /*On fail goto*//*Label 18322*/ GIMT_Encode4(1272516), // Rule ID 8350 //
     /* 1272437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1272454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1272457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272490 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1272493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272515 */     // GIR_Coverage, 8350,
     /* 1272515 */     GIR_EraseRootFromParent_Done,
     /* 1272516 */   // Label 18322: @1272516
     /* 1272516 */   GIM_Try, /*On fail goto*//*Label 18323*/ GIMT_Encode4(1272600), // Rule ID 8351 //
     /* 1272521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1272538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1272541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272574 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1272577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272599 */     // GIR_Coverage, 8351,
     /* 1272599 */     GIR_EraseRootFromParent_Done,
     /* 1272600 */   // Label 18323: @1272600
     /* 1272600 */   GIM_Try, /*On fail goto*//*Label 18324*/ GIMT_Encode4(1272684), // Rule ID 8354 //
     /* 1272605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1272622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1272625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272658 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1272661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272683 */     // GIR_Coverage, 8354,
     /* 1272683 */     GIR_EraseRootFromParent_Done,
     /* 1272684 */   // Label 18324: @1272684
     /* 1272684 */   GIM_Try, /*On fail goto*//*Label 18325*/ GIMT_Encode4(1272768), // Rule ID 8355 //
     /* 1272689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1272706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1272709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272742 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1272745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272767 */     // GIR_Coverage, 8355,
     /* 1272767 */     GIR_EraseRootFromParent_Done,
     /* 1272768 */   // Label 18325: @1272768
     /* 1272768 */   GIM_Try, /*On fail goto*//*Label 18326*/ GIMT_Encode4(1272852), // Rule ID 8358 //
     /* 1272773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1272776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1272790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1272793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272826 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1272829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1272847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272851 */     // GIR_Coverage, 8358,
     /* 1272851 */     GIR_EraseRootFromParent_Done,
     /* 1272852 */   // Label 18326: @1272852
     /* 1272852 */   GIM_Try, /*On fail goto*//*Label 18327*/ GIMT_Encode4(1272936), // Rule ID 8359 //
     /* 1272857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1272860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1272874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1272877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272910 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1272913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1272931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272935 */     // GIR_Coverage, 8359,
     /* 1272935 */     GIR_EraseRootFromParent_Done,
     /* 1272936 */   // Label 18327: @1272936
     /* 1272936 */   GIM_Try, /*On fail goto*//*Label 18328*/ GIMT_Encode4(1273020), // Rule ID 8362 //
     /* 1272941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1272952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1272955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1272958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1272961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1272964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1272979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1272983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272994 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1272997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273019 */     // GIR_Coverage, 8362,
     /* 1273019 */     GIR_EraseRootFromParent_Done,
     /* 1273020 */   // Label 18328: @1273020
     /* 1273020 */   GIM_Try, /*On fail goto*//*Label 18329*/ GIMT_Encode4(1273104), // Rule ID 8363 //
     /* 1273025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1273042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1273045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273078 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1273081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273103 */     // GIR_Coverage, 8363,
     /* 1273103 */     GIR_EraseRootFromParent_Done,
     /* 1273104 */   // Label 18329: @1273104
     /* 1273104 */   GIM_Try, /*On fail goto*//*Label 18330*/ GIMT_Encode4(1273188), // Rule ID 8366 //
     /* 1273109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1273126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1273129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273162 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1273165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273187 */     // GIR_Coverage, 8366,
     /* 1273187 */     GIR_EraseRootFromParent_Done,
     /* 1273188 */   // Label 18330: @1273188
     /* 1273188 */   GIM_Try, /*On fail goto*//*Label 18331*/ GIMT_Encode4(1273272), // Rule ID 8367 //
     /* 1273193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1273210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1273213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273246 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1273249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273271 */     // GIR_Coverage, 8367,
     /* 1273271 */     GIR_EraseRootFromParent_Done,
     /* 1273272 */   // Label 18331: @1273272
     /* 1273272 */   GIM_Try, /*On fail goto*//*Label 18332*/ GIMT_Encode4(1273356), // Rule ID 8370 //
     /* 1273277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1273288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1273291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1273294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1273297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1273300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273330 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1273333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273355 */     // GIR_Coverage, 8370,
     /* 1273355 */     GIR_EraseRootFromParent_Done,
     /* 1273356 */   // Label 18332: @1273356
     /* 1273356 */   GIM_Try, /*On fail goto*//*Label 18333*/ GIMT_Encode4(1273440), // Rule ID 8371 //
     /* 1273361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1273372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1273375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1273378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1273381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1273384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273414 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1273417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273439 */     // GIR_Coverage, 8371,
     /* 1273439 */     GIR_EraseRootFromParent_Done,
     /* 1273440 */   // Label 18333: @1273440
     /* 1273440 */   GIM_Try, /*On fail goto*//*Label 18334*/ GIMT_Encode4(1273524), // Rule ID 8374 //
     /* 1273445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1273462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1273465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273498 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1273501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273523 */     // GIR_Coverage, 8374,
     /* 1273523 */     GIR_EraseRootFromParent_Done,
     /* 1273524 */   // Label 18334: @1273524
     /* 1273524 */   GIM_Try, /*On fail goto*//*Label 18335*/ GIMT_Encode4(1273608), // Rule ID 8375 //
     /* 1273529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1273546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1273549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273582 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1273585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273607 */     // GIR_Coverage, 8375,
     /* 1273607 */     GIR_EraseRootFromParent_Done,
     /* 1273608 */   // Label 18335: @1273608
     /* 1273608 */   GIM_Try, /*On fail goto*//*Label 18336*/ GIMT_Encode4(1273692), // Rule ID 8378 //
     /* 1273613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1273630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1273633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273666 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1273669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273691 */     // GIR_Coverage, 8378,
     /* 1273691 */     GIR_EraseRootFromParent_Done,
     /* 1273692 */   // Label 18336: @1273692
     /* 1273692 */   GIM_Try, /*On fail goto*//*Label 18337*/ GIMT_Encode4(1273776), // Rule ID 8379 //
     /* 1273697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1273714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1273717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273750 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1273753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273775 */     // GIR_Coverage, 8379,
     /* 1273775 */     GIR_EraseRootFromParent_Done,
     /* 1273776 */   // Label 18337: @1273776
     /* 1273776 */   GIM_Try, /*On fail goto*//*Label 18338*/ GIMT_Encode4(1273860), // Rule ID 8382 //
     /* 1273781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1273798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1273801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273834 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1273837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273859 */     // GIR_Coverage, 8382,
     /* 1273859 */     GIR_EraseRootFromParent_Done,
     /* 1273860 */   // Label 18338: @1273860
     /* 1273860 */   GIM_Try, /*On fail goto*//*Label 18339*/ GIMT_Encode4(1273944), // Rule ID 8383 //
     /* 1273865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1273882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1273885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273918 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1273921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273943 */     // GIR_Coverage, 8383,
     /* 1273943 */     GIR_EraseRootFromParent_Done,
     /* 1273944 */   // Label 18339: @1273944
     /* 1273944 */   GIM_Try, /*On fail goto*//*Label 18340*/ GIMT_Encode4(1274028), // Rule ID 8386 //
     /* 1273949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1273960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1273963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1273966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1273969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1273972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274002 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1274005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274027 */     // GIR_Coverage, 8386,
     /* 1274027 */     GIR_EraseRootFromParent_Done,
     /* 1274028 */   // Label 18340: @1274028
     /* 1274028 */   GIM_Try, /*On fail goto*//*Label 18341*/ GIMT_Encode4(1274112), // Rule ID 8387 //
     /* 1274033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1274050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1274053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274086 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1274089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274111 */     // GIR_Coverage, 8387,
     /* 1274111 */     GIR_EraseRootFromParent_Done,
     /* 1274112 */   // Label 18341: @1274112
     /* 1274112 */   GIM_Try, /*On fail goto*//*Label 18342*/ GIMT_Encode4(1274196), // Rule ID 8390 //
     /* 1274117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1274134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1274137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274170 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1274173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274195 */     // GIR_Coverage, 8390,
     /* 1274195 */     GIR_EraseRootFromParent_Done,
     /* 1274196 */   // Label 18342: @1274196
     /* 1274196 */   GIM_Try, /*On fail goto*//*Label 18343*/ GIMT_Encode4(1274280), // Rule ID 8391 //
     /* 1274201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1274218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1274221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274254 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1274257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274279 */     // GIR_Coverage, 8391,
     /* 1274279 */     GIR_EraseRootFromParent_Done,
     /* 1274280 */   // Label 18343: @1274280
     /* 1274280 */   GIM_Try, /*On fail goto*//*Label 18344*/ GIMT_Encode4(1274364), // Rule ID 8394 //
     /* 1274285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1274302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1274305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274338 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1274341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274363 */     // GIR_Coverage, 8394,
     /* 1274363 */     GIR_EraseRootFromParent_Done,
     /* 1274364 */   // Label 18344: @1274364
     /* 1274364 */   GIM_Try, /*On fail goto*//*Label 18345*/ GIMT_Encode4(1274448), // Rule ID 8395 //
     /* 1274369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1274386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1274389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274422 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1274425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274447 */     // GIR_Coverage, 8395,
     /* 1274447 */     GIR_EraseRootFromParent_Done,
     /* 1274448 */   // Label 18345: @1274448
     /* 1274448 */   GIM_Try, /*On fail goto*//*Label 18346*/ GIMT_Encode4(1274532), // Rule ID 8398 //
     /* 1274453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1274464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1274467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1274470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1274473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1274476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274506 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1274509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274531 */     // GIR_Coverage, 8398,
     /* 1274531 */     GIR_EraseRootFromParent_Done,
     /* 1274532 */   // Label 18346: @1274532
     /* 1274532 */   GIM_Try, /*On fail goto*//*Label 18347*/ GIMT_Encode4(1274616), // Rule ID 8399 //
     /* 1274537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1274540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1274548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1274551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1274554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1274557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1274560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274590 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1274593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274615 */     // GIR_Coverage, 8399,
     /* 1274615 */     GIR_EraseRootFromParent_Done,
     /* 1274616 */   // Label 18347: @1274616
     /* 1274616 */   GIM_Try, /*On fail goto*//*Label 18348*/ GIMT_Encode4(1274700), // Rule ID 8402 //
     /* 1274621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1274638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1274641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274674 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1274677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274699 */     // GIR_Coverage, 8402,
     /* 1274699 */     GIR_EraseRootFromParent_Done,
     /* 1274700 */   // Label 18348: @1274700
     /* 1274700 */   GIM_Try, /*On fail goto*//*Label 18349*/ GIMT_Encode4(1274784), // Rule ID 8403 //
     /* 1274705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1274708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1274722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1274725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274758 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1274761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274783 */     // GIR_Coverage, 8403,
     /* 1274783 */     GIR_EraseRootFromParent_Done,
     /* 1274784 */   // Label 18349: @1274784
     /* 1274784 */   GIM_Try, /*On fail goto*//*Label 18350*/ GIMT_Encode4(1274868), // Rule ID 8406 //
     /* 1274789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1274806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1274809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274842 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1274845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274867 */     // GIR_Coverage, 8406,
     /* 1274867 */     GIR_EraseRootFromParent_Done,
     /* 1274868 */   // Label 18350: @1274868
     /* 1274868 */   GIM_Try, /*On fail goto*//*Label 18351*/ GIMT_Encode4(1274952), // Rule ID 8407 //
     /* 1274873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1274876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1274890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1274893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274926 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1274929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274951 */     // GIR_Coverage, 8407,
     /* 1274951 */     GIR_EraseRootFromParent_Done,
     /* 1274952 */   // Label 18351: @1274952
     /* 1274952 */   GIM_Try, /*On fail goto*//*Label 18352*/ GIMT_Encode4(1275036), // Rule ID 8410 //
     /* 1274957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1274968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1274971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1274974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1274980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275010 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1275013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275035 */     // GIR_Coverage, 8410,
     /* 1275035 */     GIR_EraseRootFromParent_Done,
     /* 1275036 */   // Label 18352: @1275036
     /* 1275036 */   GIM_Try, /*On fail goto*//*Label 18353*/ GIMT_Encode4(1275120), // Rule ID 8411 //
     /* 1275041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1275058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275094 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1275097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275119 */     // GIR_Coverage, 8411,
     /* 1275119 */     GIR_EraseRootFromParent_Done,
     /* 1275120 */   // Label 18353: @1275120
     /* 1275120 */   GIM_Try, /*On fail goto*//*Label 18354*/ GIMT_Encode4(1275204), // Rule ID 8414 //
     /* 1275125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1275142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1275145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275178 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1275181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275203 */     // GIR_Coverage, 8414,
     /* 1275203 */     GIR_EraseRootFromParent_Done,
     /* 1275204 */   // Label 18354: @1275204
     /* 1275204 */   GIM_Try, /*On fail goto*//*Label 18355*/ GIMT_Encode4(1275288), // Rule ID 8415 //
     /* 1275209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1275226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275262 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1275265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275287 */     // GIR_Coverage, 8415,
     /* 1275287 */     GIR_EraseRootFromParent_Done,
     /* 1275288 */   // Label 18355: @1275288
     /* 1275288 */   GIM_Try, /*On fail goto*//*Label 18356*/ GIMT_Encode4(1275372), // Rule ID 8418 //
     /* 1275293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1275310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1275313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275346 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1275349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275371 */     // GIR_Coverage, 8418,
     /* 1275371 */     GIR_EraseRootFromParent_Done,
     /* 1275372 */   // Label 18356: @1275372
     /* 1275372 */   GIM_Try, /*On fail goto*//*Label 18357*/ GIMT_Encode4(1275456), // Rule ID 8419 //
     /* 1275377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1275394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275430 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1275433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275455 */     // GIR_Coverage, 8419,
     /* 1275455 */     GIR_EraseRootFromParent_Done,
     /* 1275456 */   // Label 18357: @1275456
     /* 1275456 */   GIM_Try, /*On fail goto*//*Label 18358*/ GIMT_Encode4(1275540), // Rule ID 8422 //
     /* 1275461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1275478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1275481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275514 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1275517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275539 */     // GIR_Coverage, 8422,
     /* 1275539 */     GIR_EraseRootFromParent_Done,
     /* 1275540 */   // Label 18358: @1275540
     /* 1275540 */   GIM_Try, /*On fail goto*//*Label 18359*/ GIMT_Encode4(1275624), // Rule ID 8423 //
     /* 1275545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1275562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275598 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1275601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275623 */     // GIR_Coverage, 8423,
     /* 1275623 */     GIR_EraseRootFromParent_Done,
     /* 1275624 */   // Label 18359: @1275624
     /* 1275624 */   GIM_Try, /*On fail goto*//*Label 18360*/ GIMT_Encode4(1275708), // Rule ID 8426 //
     /* 1275629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1275646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1275649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275682 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1275685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275707 */     // GIR_Coverage, 8426,
     /* 1275707 */     GIR_EraseRootFromParent_Done,
     /* 1275708 */   // Label 18360: @1275708
     /* 1275708 */   GIM_Try, /*On fail goto*//*Label 18361*/ GIMT_Encode4(1275792), // Rule ID 8427 //
     /* 1275713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1275730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275766 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1275769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275791 */     // GIR_Coverage, 8427,
     /* 1275791 */     GIR_EraseRootFromParent_Done,
     /* 1275792 */   // Label 18361: @1275792
     /* 1275792 */   GIM_Try, /*On fail goto*//*Label 18362*/ GIMT_Encode4(1275876), // Rule ID 8430 //
     /* 1275797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1275814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1275817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275850 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1275853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275875 */     // GIR_Coverage, 8430,
     /* 1275875 */     GIR_EraseRootFromParent_Done,
     /* 1275876 */   // Label 18362: @1275876
     /* 1275876 */   GIM_Try, /*On fail goto*//*Label 18363*/ GIMT_Encode4(1275960), // Rule ID 8431 //
     /* 1275881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1275898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275934 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1275937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275959 */     // GIR_Coverage, 8431,
     /* 1275959 */     GIR_EraseRootFromParent_Done,
     /* 1275960 */   // Label 18363: @1275960
     /* 1275960 */   GIM_Try, /*On fail goto*//*Label 18364*/ GIMT_Encode4(1276044), // Rule ID 8434 //
     /* 1275965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1275976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1275979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1275982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1275985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276018 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1276021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276043 */     // GIR_Coverage, 8434,
     /* 1276043 */     GIR_EraseRootFromParent_Done,
     /* 1276044 */   // Label 18364: @1276044
     /* 1276044 */   GIM_Try, /*On fail goto*//*Label 18365*/ GIMT_Encode4(1276128), // Rule ID 8435 //
     /* 1276049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1276057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1276060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1276063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1276066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1276069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1276072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276102 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1276105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276127 */     // GIR_Coverage, 8435,
     /* 1276127 */     GIR_EraseRootFromParent_Done,
     /* 1276128 */   // Label 18365: @1276128
     /* 1276128 */   GIM_Try, /*On fail goto*//*Label 18366*/ GIMT_Encode4(1276212), // Rule ID 8438 //
     /* 1276133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1276141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1276153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276186 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1276189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276211 */     // GIR_Coverage, 8438,
     /* 1276211 */     GIR_EraseRootFromParent_Done,
     /* 1276212 */   // Label 18366: @1276212
     /* 1276212 */   GIM_Try, /*On fail goto*//*Label 18367*/ GIMT_Encode4(1276296), // Rule ID 8439 //
     /* 1276217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1276225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1276237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276270 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1276273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276295 */     // GIR_Coverage, 8439,
     /* 1276295 */     GIR_EraseRootFromParent_Done,
     /* 1276296 */   // Label 18367: @1276296
     /* 1276296 */   GIM_Try, /*On fail goto*//*Label 18368*/ GIMT_Encode4(1276380), // Rule ID 8442 //
     /* 1276301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1276309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1276318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1276321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276354 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1276357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276379 */     // GIR_Coverage, 8442,
     /* 1276379 */     GIR_EraseRootFromParent_Done,
     /* 1276380 */   // Label 18368: @1276380
     /* 1276380 */   GIM_Try, /*On fail goto*//*Label 18369*/ GIMT_Encode4(1276464), // Rule ID 8443 //
     /* 1276385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1276393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1276402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1276405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276438 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1276441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276463 */     // GIR_Coverage, 8443,
     /* 1276463 */     GIR_EraseRootFromParent_Done,
     /* 1276464 */   // Label 18369: @1276464
     /* 1276464 */   GIM_Try, /*On fail goto*//*Label 18370*/ GIMT_Encode4(1276548), // Rule ID 8446 //
     /* 1276469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1276472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1276477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1276486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1276489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276522 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1276525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276547 */     // GIR_Coverage, 8446,
     /* 1276547 */     GIR_EraseRootFromParent_Done,
     /* 1276548 */   // Label 18370: @1276548
     /* 1276548 */   GIM_Try, /*On fail goto*//*Label 18371*/ GIMT_Encode4(1276632), // Rule ID 8447 //
     /* 1276553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1276556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1276561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1276570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1276573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276606 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1276609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276631 */     // GIR_Coverage, 8447,
     /* 1276631 */     GIR_EraseRootFromParent_Done,
     /* 1276632 */   // Label 18371: @1276632
     /* 1276632 */   GIM_Try, /*On fail goto*//*Label 18372*/ GIMT_Encode4(1276716), // Rule ID 8450 //
     /* 1276637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1276645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1276648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1276651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1276654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1276657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1276660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1276675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276690 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1276693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276715 */     // GIR_Coverage, 8450,
     /* 1276715 */     GIR_EraseRootFromParent_Done,
     /* 1276716 */   // Label 18372: @1276716
     /* 1276716 */   GIM_Try, /*On fail goto*//*Label 18373*/ GIMT_Encode4(1276800), // Rule ID 8451 //
     /* 1276721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1276729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1276732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1276735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1276738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1276741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1276744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1276759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276774 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1276777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276799 */     // GIR_Coverage, 8451,
     /* 1276799 */     GIR_EraseRootFromParent_Done,
     /* 1276800 */   // Label 18373: @1276800
     /* 1276800 */   GIM_Try, /*On fail goto*//*Label 18374*/ GIMT_Encode4(1276884), // Rule ID 8454 //
     /* 1276805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1276813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1276816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1276819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1276822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1276825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1276828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1276843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276858 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1276861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276883 */     // GIR_Coverage, 8454,
     /* 1276883 */     GIR_EraseRootFromParent_Done,
     /* 1276884 */   // Label 18374: @1276884
     /* 1276884 */   GIM_Try, /*On fail goto*//*Label 18375*/ GIMT_Encode4(1276968), // Rule ID 8455 //
     /* 1276889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1276897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1276900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1276903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1276906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1276909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1276912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1276927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276942 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1276945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276967 */     // GIR_Coverage, 8455,
     /* 1276967 */     GIR_EraseRootFromParent_Done,
     /* 1276968 */   // Label 18375: @1276968
     /* 1276968 */   GIM_Try, /*On fail goto*//*Label 18376*/ GIMT_Encode4(1277052), // Rule ID 8458 //
     /* 1276973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1276981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1276984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1276987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1276990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1276993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1276996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277026 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1277029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277051 */     // GIR_Coverage, 8458,
     /* 1277051 */     GIR_EraseRootFromParent_Done,
     /* 1277052 */   // Label 18376: @1277052
     /* 1277052 */   GIM_Try, /*On fail goto*//*Label 18377*/ GIMT_Encode4(1277136), // Rule ID 8459 //
     /* 1277057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1277065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1277068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1277071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1277074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1277077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1277080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277110 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1277113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277135 */     // GIR_Coverage, 8459,
     /* 1277135 */     GIR_EraseRootFromParent_Done,
     /* 1277136 */   // Label 18377: @1277136
     /* 1277136 */   GIM_Try, /*On fail goto*//*Label 18378*/ GIMT_Encode4(1277220), // Rule ID 8462 //
     /* 1277141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1277149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1277161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277194 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1277197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277219 */     // GIR_Coverage, 8462,
     /* 1277219 */     GIR_EraseRootFromParent_Done,
     /* 1277220 */   // Label 18378: @1277220
     /* 1277220 */   GIM_Try, /*On fail goto*//*Label 18379*/ GIMT_Encode4(1277304), // Rule ID 8463 //
     /* 1277225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1277233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1277245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277278 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1277281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277303 */     // GIR_Coverage, 8463,
     /* 1277303 */     GIR_EraseRootFromParent_Done,
     /* 1277304 */   // Label 18379: @1277304
     /* 1277304 */   GIM_Try, /*On fail goto*//*Label 18380*/ GIMT_Encode4(1277388), // Rule ID 8466 //
     /* 1277309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1277317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1277326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1277329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277362 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1277365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277387 */     // GIR_Coverage, 8466,
     /* 1277387 */     GIR_EraseRootFromParent_Done,
     /* 1277388 */   // Label 18380: @1277388
     /* 1277388 */   GIM_Try, /*On fail goto*//*Label 18381*/ GIMT_Encode4(1277472), // Rule ID 8467 //
     /* 1277393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1277401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1277410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1277413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277446 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1277449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277471 */     // GIR_Coverage, 8467,
     /* 1277471 */     GIR_EraseRootFromParent_Done,
     /* 1277472 */   // Label 18381: @1277472
     /* 1277472 */   GIM_Try, /*On fail goto*//*Label 18382*/ GIMT_Encode4(1277556), // Rule ID 8470 //
     /* 1277477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1277485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1277494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1277497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277530 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1277533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277555 */     // GIR_Coverage, 8470,
     /* 1277555 */     GIR_EraseRootFromParent_Done,
     /* 1277556 */   // Label 18382: @1277556
     /* 1277556 */   GIM_Try, /*On fail goto*//*Label 18383*/ GIMT_Encode4(1277640), // Rule ID 8471 //
     /* 1277561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1277569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1277578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1277581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277614 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1277617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277639 */     // GIR_Coverage, 8471,
     /* 1277639 */     GIR_EraseRootFromParent_Done,
     /* 1277640 */   // Label 18383: @1277640
     /* 1277640 */   GIM_Try, /*On fail goto*//*Label 18384*/ GIMT_Encode4(1277724), // Rule ID 8474 //
     /* 1277645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1277653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1277656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1277659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1277662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1277665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1277668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277698 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1277701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277723 */     // GIR_Coverage, 8474,
     /* 1277723 */     GIR_EraseRootFromParent_Done,
     /* 1277724 */   // Label 18384: @1277724
     /* 1277724 */   GIM_Try, /*On fail goto*//*Label 18385*/ GIMT_Encode4(1277808), // Rule ID 8475 //
     /* 1277729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1277737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1277740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1277743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1277746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1277749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1277752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277782 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1277785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277807 */     // GIR_Coverage, 8475,
     /* 1277807 */     GIR_EraseRootFromParent_Done,
     /* 1277808 */   // Label 18385: @1277808
     /* 1277808 */   GIM_Try, /*On fail goto*//*Label 18386*/ GIMT_Encode4(1277892), // Rule ID 8478 //
     /* 1277813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1277821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1277830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1277833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277866 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1277869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277891 */     // GIR_Coverage, 8478,
     /* 1277891 */     GIR_EraseRootFromParent_Done,
     /* 1277892 */   // Label 18386: @1277892
     /* 1277892 */   GIM_Try, /*On fail goto*//*Label 18387*/ GIMT_Encode4(1277976), // Rule ID 8479 //
     /* 1277897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1277905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1277914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1277917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277950 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1277953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277975 */     // GIR_Coverage, 8479,
     /* 1277975 */     GIR_EraseRootFromParent_Done,
     /* 1277976 */   // Label 18387: @1277976
     /* 1277976 */   GIM_Try, /*On fail goto*//*Label 18388*/ GIMT_Encode4(1278060), // Rule ID 8482 //
     /* 1277981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1277989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1277998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278034 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1278037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278059 */     // GIR_Coverage, 8482,
     /* 1278059 */     GIR_EraseRootFromParent_Done,
     /* 1278060 */   // Label 18388: @1278060
     /* 1278060 */   GIM_Try, /*On fail goto*//*Label 18389*/ GIMT_Encode4(1278144), // Rule ID 8483 //
     /* 1278065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1278073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1278076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1278079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1278082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278118 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1278121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278143 */     // GIR_Coverage, 8483,
     /* 1278143 */     GIR_EraseRootFromParent_Done,
     /* 1278144 */   // Label 18389: @1278144
     /* 1278144 */   GIM_Try, /*On fail goto*//*Label 18390*/ GIMT_Encode4(1278228), // Rule ID 8486 //
     /* 1278149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1278157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278202 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1278205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278227 */     // GIR_Coverage, 8486,
     /* 1278227 */     GIR_EraseRootFromParent_Done,
     /* 1278228 */   // Label 18390: @1278228
     /* 1278228 */   GIM_Try, /*On fail goto*//*Label 18391*/ GIMT_Encode4(1278312), // Rule ID 8487 //
     /* 1278233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1278241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278286 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1278289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278311 */     // GIR_Coverage, 8487,
     /* 1278311 */     GIR_EraseRootFromParent_Done,
     /* 1278312 */   // Label 18391: @1278312
     /* 1278312 */   GIM_Try, /*On fail goto*//*Label 18392*/ GIMT_Encode4(1278396), // Rule ID 8490 //
     /* 1278317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1278325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1278334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278370 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1278373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278395 */     // GIR_Coverage, 8490,
     /* 1278395 */     GIR_EraseRootFromParent_Done,
     /* 1278396 */   // Label 18392: @1278396
     /* 1278396 */   GIM_Try, /*On fail goto*//*Label 18393*/ GIMT_Encode4(1278480), // Rule ID 8491 //
     /* 1278401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1278409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1278418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278454 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1278457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278479 */     // GIR_Coverage, 8491,
     /* 1278479 */     GIR_EraseRootFromParent_Done,
     /* 1278480 */   // Label 18393: @1278480
     /* 1278480 */   GIM_Try, /*On fail goto*//*Label 18394*/ GIMT_Encode4(1278564), // Rule ID 8494 //
     /* 1278485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1278493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1278502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278538 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1278541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278563 */     // GIR_Coverage, 8494,
     /* 1278563 */     GIR_EraseRootFromParent_Done,
     /* 1278564 */   // Label 18394: @1278564
     /* 1278564 */   GIM_Try, /*On fail goto*//*Label 18395*/ GIMT_Encode4(1278648), // Rule ID 8495 //
     /* 1278569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1278577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1278586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278622 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1278625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278647 */     // GIR_Coverage, 8495,
     /* 1278647 */     GIR_EraseRootFromParent_Done,
     /* 1278648 */   // Label 18395: @1278648
     /* 1278648 */   GIM_Try, /*On fail goto*//*Label 18396*/ GIMT_Encode4(1278732), // Rule ID 8498 //
     /* 1278653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1278664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1278667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1278670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1278673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1278676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278706 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1278709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278731 */     // GIR_Coverage, 8498,
     /* 1278731 */     GIR_EraseRootFromParent_Done,
     /* 1278732 */   // Label 18396: @1278732
     /* 1278732 */   GIM_Try, /*On fail goto*//*Label 18397*/ GIMT_Encode4(1278816), // Rule ID 8499 //
     /* 1278737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1278748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1278751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1278754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1278757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1278760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278790 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1278793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278815 */     // GIR_Coverage, 8499,
     /* 1278815 */     GIR_EraseRootFromParent_Done,
     /* 1278816 */   // Label 18397: @1278816
     /* 1278816 */   GIM_Try, /*On fail goto*//*Label 18398*/ GIMT_Encode4(1278900), // Rule ID 8502 //
     /* 1278821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1278838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1278841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278874 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1278877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278899 */     // GIR_Coverage, 8502,
     /* 1278899 */     GIR_EraseRootFromParent_Done,
     /* 1278900 */   // Label 18398: @1278900
     /* 1278900 */   GIM_Try, /*On fail goto*//*Label 18399*/ GIMT_Encode4(1278984), // Rule ID 8503 //
     /* 1278905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1278922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1278925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278958 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1278961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278983 */     // GIR_Coverage, 8503,
     /* 1278983 */     GIR_EraseRootFromParent_Done,
     /* 1278984 */   // Label 18399: @1278984
     /* 1278984 */   GIM_Try, /*On fail goto*//*Label 18400*/ GIMT_Encode4(1279068), // Rule ID 8506 //
     /* 1278989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1279006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1279009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279042 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1279045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279067 */     // GIR_Coverage, 8506,
     /* 1279067 */     GIR_EraseRootFromParent_Done,
     /* 1279068 */   // Label 18400: @1279068
     /* 1279068 */   GIM_Try, /*On fail goto*//*Label 18401*/ GIMT_Encode4(1279152), // Rule ID 8507 //
     /* 1279073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1279090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1279093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279126 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1279129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279151 */     // GIR_Coverage, 8507,
     /* 1279151 */     GIR_EraseRootFromParent_Done,
     /* 1279152 */   // Label 18401: @1279152
     /* 1279152 */   GIM_Try, /*On fail goto*//*Label 18402*/ GIMT_Encode4(1279236), // Rule ID 8510 //
     /* 1279157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1279177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279210 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1279213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279235 */     // GIR_Coverage, 8510,
     /* 1279235 */     GIR_EraseRootFromParent_Done,
     /* 1279236 */   // Label 18402: @1279236
     /* 1279236 */   GIM_Try, /*On fail goto*//*Label 18403*/ GIMT_Encode4(1279320), // Rule ID 8511 //
     /* 1279241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1279261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279294 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1279297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279319 */     // GIR_Coverage, 8511,
     /* 1279319 */     GIR_EraseRootFromParent_Done,
     /* 1279320 */   // Label 18403: @1279320
     /* 1279320 */   GIM_Try, /*On fail goto*//*Label 18404*/ GIMT_Encode4(1279404), // Rule ID 8514 //
     /* 1279325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1279342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1279345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279378 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1279381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279403 */     // GIR_Coverage, 8514,
     /* 1279403 */     GIR_EraseRootFromParent_Done,
     /* 1279404 */   // Label 18404: @1279404
     /* 1279404 */   GIM_Try, /*On fail goto*//*Label 18405*/ GIMT_Encode4(1279488), // Rule ID 8515 //
     /* 1279409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1279426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1279429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279462 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1279465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279487 */     // GIR_Coverage, 8515,
     /* 1279487 */     GIR_EraseRootFromParent_Done,
     /* 1279488 */   // Label 18405: @1279488
     /* 1279488 */   GIM_Try, /*On fail goto*//*Label 18406*/ GIMT_Encode4(1279572), // Rule ID 8518 //
     /* 1279493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1279510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1279513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279546 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1279549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279571 */     // GIR_Coverage, 8518,
     /* 1279571 */     GIR_EraseRootFromParent_Done,
     /* 1279572 */   // Label 18406: @1279572
     /* 1279572 */   GIM_Try, /*On fail goto*//*Label 18407*/ GIMT_Encode4(1279656), // Rule ID 8519 //
     /* 1279577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1279594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1279597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279630 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1279633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279655 */     // GIR_Coverage, 8519,
     /* 1279655 */     GIR_EraseRootFromParent_Done,
     /* 1279656 */   // Label 18407: @1279656
     /* 1279656 */   GIM_Try, /*On fail goto*//*Label 18408*/ GIMT_Encode4(1279740), // Rule ID 8522 //
     /* 1279661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1279675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1279678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1279681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1279684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279714 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1279717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279739 */     // GIR_Coverage, 8522,
     /* 1279739 */     GIR_EraseRootFromParent_Done,
     /* 1279740 */   // Label 18408: @1279740
     /* 1279740 */   GIM_Try, /*On fail goto*//*Label 18409*/ GIMT_Encode4(1279824), // Rule ID 8523 //
     /* 1279745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1279759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1279762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1279765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1279768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279798 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1279801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279823 */     // GIR_Coverage, 8523,
     /* 1279823 */     GIR_EraseRootFromParent_Done,
     /* 1279824 */   // Label 18409: @1279824
     /* 1279824 */   GIM_Try, /*On fail goto*//*Label 18410*/ GIMT_Encode4(1279908), // Rule ID 8526 //
     /* 1279829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1279846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1279849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279882 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1279885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279907 */     // GIR_Coverage, 8526,
     /* 1279907 */     GIR_EraseRootFromParent_Done,
     /* 1279908 */   // Label 18410: @1279908
     /* 1279908 */   GIM_Try, /*On fail goto*//*Label 18411*/ GIMT_Encode4(1279992), // Rule ID 8527 //
     /* 1279913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1279930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1279933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279966 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1279969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279991 */     // GIR_Coverage, 8527,
     /* 1279991 */     GIR_EraseRootFromParent_Done,
     /* 1279992 */   // Label 18411: @1279992
     /* 1279992 */   GIM_Try, /*On fail goto*//*Label 18412*/ GIMT_Encode4(1280076), // Rule ID 8530 //
     /* 1279997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1280008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1280011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1280014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1280017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280050 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1280053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280075 */     // GIR_Coverage, 8530,
     /* 1280075 */     GIR_EraseRootFromParent_Done,
     /* 1280076 */   // Label 18412: @1280076
     /* 1280076 */   GIM_Try, /*On fail goto*//*Label 18413*/ GIMT_Encode4(1280160), // Rule ID 8531 //
     /* 1280081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1280092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1280095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1280098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1280101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280134 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1280137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280159 */     // GIR_Coverage, 8531,
     /* 1280159 */     GIR_EraseRootFromParent_Done,
     /* 1280160 */   // Label 18413: @1280160
     /* 1280160 */   GIM_Try, /*On fail goto*//*Label 18414*/ GIMT_Encode4(1280244), // Rule ID 8534 //
     /* 1280165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1280168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1280185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280218 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1280221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280243 */     // GIR_Coverage, 8534,
     /* 1280243 */     GIR_EraseRootFromParent_Done,
     /* 1280244 */   // Label 18414: @1280244
     /* 1280244 */   GIM_Try, /*On fail goto*//*Label 18415*/ GIMT_Encode4(1280328), // Rule ID 8535 //
     /* 1280249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1280252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1280269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280302 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1280305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280327 */     // GIR_Coverage, 8535,
     /* 1280327 */     GIR_EraseRootFromParent_Done,
     /* 1280328 */   // Label 18415: @1280328
     /* 1280328 */   GIM_Try, /*On fail goto*//*Label 18416*/ GIMT_Encode4(1280412), // Rule ID 8538 //
     /* 1280333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1280350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1280353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280386 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1280389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280411 */     // GIR_Coverage, 8538,
     /* 1280411 */     GIR_EraseRootFromParent_Done,
     /* 1280412 */   // Label 18416: @1280412
     /* 1280412 */   GIM_Try, /*On fail goto*//*Label 18417*/ GIMT_Encode4(1280496), // Rule ID 8539 //
     /* 1280417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1280434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1280437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280470 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1280473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280495 */     // GIR_Coverage, 8539,
     /* 1280495 */     GIR_EraseRootFromParent_Done,
     /* 1280496 */   // Label 18417: @1280496
     /* 1280496 */   GIM_Try, /*On fail goto*//*Label 18418*/ GIMT_Encode4(1280580), // Rule ID 8542 //
     /* 1280501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1280512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1280515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1280518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1280521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1280524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280554 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1280557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280579 */     // GIR_Coverage, 8542,
     /* 1280579 */     GIR_EraseRootFromParent_Done,
     /* 1280580 */   // Label 18418: @1280580
     /* 1280580 */   GIM_Try, /*On fail goto*//*Label 18419*/ GIMT_Encode4(1280664), // Rule ID 8543 //
     /* 1280585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1280596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1280599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1280602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1280605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1280608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280638 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1280641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280663 */     // GIR_Coverage, 8543,
     /* 1280663 */     GIR_EraseRootFromParent_Done,
     /* 1280664 */   // Label 18419: @1280664
     /* 1280664 */   GIM_Try, /*On fail goto*//*Label 18420*/ GIMT_Encode4(1280748), // Rule ID 8546 //
     /* 1280669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1280680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1280683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1280686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1280689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1280692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1280707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1280711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280722 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1280725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280747 */     // GIR_Coverage, 8546,
     /* 1280747 */     GIR_EraseRootFromParent_Done,
     /* 1280748 */   // Label 18420: @1280748
     /* 1280748 */   GIM_Try, /*On fail goto*//*Label 18421*/ GIMT_Encode4(1280832), // Rule ID 8547 //
     /* 1280753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1280764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1280767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1280770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1280773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1280776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1280791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1280795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280806 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1280809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280831 */     // GIR_Coverage, 8547,
     /* 1280831 */     GIR_EraseRootFromParent_Done,
     /* 1280832 */   // Label 18421: @1280832
     /* 1280832 */   GIM_Try, /*On fail goto*//*Label 18422*/ GIMT_Encode4(1280916), // Rule ID 8550 //
     /* 1280837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1280848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1280851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1280854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1280857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280890 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1280893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280915 */     // GIR_Coverage, 8550,
     /* 1280915 */     GIR_EraseRootFromParent_Done,
     /* 1280916 */   // Label 18422: @1280916
     /* 1280916 */   GIM_Try, /*On fail goto*//*Label 18423*/ GIMT_Encode4(1281000), // Rule ID 8551 //
     /* 1280921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1280932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1280935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1280938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1280941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280974 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1280977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280999 */     // GIR_Coverage, 8551,
     /* 1280999 */     GIR_EraseRootFromParent_Done,
     /* 1281000 */   // Label 18423: @1281000
     /* 1281000 */   GIM_Try, /*On fail goto*//*Label 18424*/ GIMT_Encode4(1281084), // Rule ID 8554 //
     /* 1281005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1281022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1281025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281058 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1281061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281083 */     // GIR_Coverage, 8554,
     /* 1281083 */     GIR_EraseRootFromParent_Done,
     /* 1281084 */   // Label 18424: @1281084
     /* 1281084 */   GIM_Try, /*On fail goto*//*Label 18425*/ GIMT_Encode4(1281168), // Rule ID 8555 //
     /* 1281089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1281106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1281109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281142 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1281145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281167 */     // GIR_Coverage, 8555,
     /* 1281167 */     GIR_EraseRootFromParent_Done,
     /* 1281168 */   // Label 18425: @1281168
     /* 1281168 */   GIM_Try, /*On fail goto*//*Label 18426*/ GIMT_Encode4(1281252), // Rule ID 8558 //
     /* 1281173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1281193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281226 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1281229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281251 */     // GIR_Coverage, 8558,
     /* 1281251 */     GIR_EraseRootFromParent_Done,
     /* 1281252 */   // Label 18426: @1281252
     /* 1281252 */   GIM_Try, /*On fail goto*//*Label 18427*/ GIMT_Encode4(1281336), // Rule ID 8559 //
     /* 1281257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1281277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281310 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1281313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281335 */     // GIR_Coverage, 8559,
     /* 1281335 */     GIR_EraseRootFromParent_Done,
     /* 1281336 */   // Label 18427: @1281336
     /* 1281336 */   GIM_Try, /*On fail goto*//*Label 18428*/ GIMT_Encode4(1281420), // Rule ID 8562 //
     /* 1281341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1281358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1281361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281394 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1281397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281419 */     // GIR_Coverage, 8562,
     /* 1281419 */     GIR_EraseRootFromParent_Done,
     /* 1281420 */   // Label 18428: @1281420
     /* 1281420 */   GIM_Try, /*On fail goto*//*Label 18429*/ GIMT_Encode4(1281504), // Rule ID 8563 //
     /* 1281425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1281442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1281445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281478 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1281481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281503 */     // GIR_Coverage, 8563,
     /* 1281503 */     GIR_EraseRootFromParent_Done,
     /* 1281504 */   // Label 18429: @1281504
     /* 1281504 */   GIM_Try, /*On fail goto*//*Label 18430*/ GIMT_Encode4(1281588), // Rule ID 8566 //
     /* 1281509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1281526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1281529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281562 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1281565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281587 */     // GIR_Coverage, 8566,
     /* 1281587 */     GIR_EraseRootFromParent_Done,
     /* 1281588 */   // Label 18430: @1281588
     /* 1281588 */   GIM_Try, /*On fail goto*//*Label 18431*/ GIMT_Encode4(1281672), // Rule ID 8567 //
     /* 1281593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1281610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1281613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281646 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1281649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281671 */     // GIR_Coverage, 8567,
     /* 1281671 */     GIR_EraseRootFromParent_Done,
     /* 1281672 */   // Label 18431: @1281672
     /* 1281672 */   GIM_Try, /*On fail goto*//*Label 18432*/ GIMT_Encode4(1281756), // Rule ID 8570 //
     /* 1281677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1281694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1281697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281730 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1281733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281755 */     // GIR_Coverage, 8570,
     /* 1281755 */     GIR_EraseRootFromParent_Done,
     /* 1281756 */   // Label 18432: @1281756
     /* 1281756 */   GIM_Try, /*On fail goto*//*Label 18433*/ GIMT_Encode4(1281840), // Rule ID 8571 //
     /* 1281761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1281778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1281781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281814 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1281817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281839 */     // GIR_Coverage, 8571,
     /* 1281839 */     GIR_EraseRootFromParent_Done,
     /* 1281840 */   // Label 18433: @1281840
     /* 1281840 */   GIM_Try, /*On fail goto*//*Label 18434*/ GIMT_Encode4(1281924), // Rule ID 8574 //
     /* 1281845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1281848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1281856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1281859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1281862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1281865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1281868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281898 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1281901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1281919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281923 */     // GIR_Coverage, 8574,
     /* 1281923 */     GIR_EraseRootFromParent_Done,
     /* 1281924 */   // Label 18434: @1281924
     /* 1281924 */   GIM_Try, /*On fail goto*//*Label 18435*/ GIMT_Encode4(1282008), // Rule ID 8575 //
     /* 1281929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1281932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1281940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1281943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1281946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1281949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1281952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281982 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1281985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282007 */     // GIR_Coverage, 8575,
     /* 1282007 */     GIR_EraseRootFromParent_Done,
     /* 1282008 */   // Label 18435: @1282008
     /* 1282008 */   GIM_Try, /*On fail goto*//*Label 18436*/ GIMT_Encode4(1282092), // Rule ID 8578 //
     /* 1282013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1282030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1282033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282066 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1282069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282091 */     // GIR_Coverage, 8578,
     /* 1282091 */     GIR_EraseRootFromParent_Done,
     /* 1282092 */   // Label 18436: @1282092
     /* 1282092 */   GIM_Try, /*On fail goto*//*Label 18437*/ GIMT_Encode4(1282176), // Rule ID 8579 //
     /* 1282097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1282114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1282117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282150 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1282153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282175 */     // GIR_Coverage, 8579,
     /* 1282175 */     GIR_EraseRootFromParent_Done,
     /* 1282176 */   // Label 18437: @1282176
     /* 1282176 */   GIM_Try, /*On fail goto*//*Label 18438*/ GIMT_Encode4(1282260), // Rule ID 8582 //
     /* 1282181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1282201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282234 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1282237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282259 */     // GIR_Coverage, 8582,
     /* 1282259 */     GIR_EraseRootFromParent_Done,
     /* 1282260 */   // Label 18438: @1282260
     /* 1282260 */   GIM_Try, /*On fail goto*//*Label 18439*/ GIMT_Encode4(1282344), // Rule ID 8583 //
     /* 1282265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1282285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282318 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1282321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282343 */     // GIR_Coverage, 8583,
     /* 1282343 */     GIR_EraseRootFromParent_Done,
     /* 1282344 */   // Label 18439: @1282344
     /* 1282344 */   GIM_Try, /*On fail goto*//*Label 18440*/ GIMT_Encode4(1282428), // Rule ID 8586 //
     /* 1282349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1282366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282402 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1282405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282427 */     // GIR_Coverage, 8586,
     /* 1282427 */     GIR_EraseRootFromParent_Done,
     /* 1282428 */   // Label 18440: @1282428
     /* 1282428 */   GIM_Try, /*On fail goto*//*Label 18441*/ GIMT_Encode4(1282512), // Rule ID 8587 //
     /* 1282433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1282450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282486 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1282489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282511 */     // GIR_Coverage, 8587,
     /* 1282511 */     GIR_EraseRootFromParent_Done,
     /* 1282512 */   // Label 18441: @1282512
     /* 1282512 */   GIM_Try, /*On fail goto*//*Label 18442*/ GIMT_Encode4(1282596), // Rule ID 8590 //
     /* 1282517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1282534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282570 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1282573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282595 */     // GIR_Coverage, 8590,
     /* 1282595 */     GIR_EraseRootFromParent_Done,
     /* 1282596 */   // Label 18442: @1282596
     /* 1282596 */   GIM_Try, /*On fail goto*//*Label 18443*/ GIMT_Encode4(1282680), // Rule ID 8591 //
     /* 1282601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1282618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282654 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1282657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282679 */     // GIR_Coverage, 8591,
     /* 1282679 */     GIR_EraseRootFromParent_Done,
     /* 1282680 */   // Label 18443: @1282680
     /* 1282680 */   GIM_Try, /*On fail goto*//*Label 18444*/ GIMT_Encode4(1282764), // Rule ID 8594 //
     /* 1282685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1282702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282738 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1282741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282763 */     // GIR_Coverage, 8594,
     /* 1282763 */     GIR_EraseRootFromParent_Done,
     /* 1282764 */   // Label 18444: @1282764
     /* 1282764 */   GIM_Try, /*On fail goto*//*Label 18445*/ GIMT_Encode4(1282848), // Rule ID 8595 //
     /* 1282769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1282786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282822 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1282825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282847 */     // GIR_Coverage, 8595,
     /* 1282847 */     GIR_EraseRootFromParent_Done,
     /* 1282848 */   // Label 18445: @1282848
     /* 1282848 */   GIM_Try, /*On fail goto*//*Label 18446*/ GIMT_Encode4(1282932), // Rule ID 8598 //
     /* 1282853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1282870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282906 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1282909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1282927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282931 */     // GIR_Coverage, 8598,
     /* 1282931 */     GIR_EraseRootFromParent_Done,
     /* 1282932 */   // Label 18446: @1282932
     /* 1282932 */   GIM_Try, /*On fail goto*//*Label 18447*/ GIMT_Encode4(1283016), // Rule ID 8599 //
     /* 1282937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1282954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282990 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1282993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283015 */     // GIR_Coverage, 8599,
     /* 1283015 */     GIR_EraseRootFromParent_Done,
     /* 1283016 */   // Label 18447: @1283016
     /* 1283016 */   GIM_Try, /*On fail goto*//*Label 18448*/ GIMT_Encode4(1283100), // Rule ID 8602 //
     /* 1283021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1283029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1283038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1283041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283074 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1283077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283099 */     // GIR_Coverage, 8602,
     /* 1283099 */     GIR_EraseRootFromParent_Done,
     /* 1283100 */   // Label 18448: @1283100
     /* 1283100 */   GIM_Try, /*On fail goto*//*Label 18449*/ GIMT_Encode4(1283184), // Rule ID 8603 //
     /* 1283105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1283113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1283122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1283125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283158 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1283161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283183 */     // GIR_Coverage, 8603,
     /* 1283183 */     GIR_EraseRootFromParent_Done,
     /* 1283184 */   // Label 18449: @1283184
     /* 1283184 */   GIM_Try, /*On fail goto*//*Label 18450*/ GIMT_Encode4(1283268), // Rule ID 8606 //
     /* 1283189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1283197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1283209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283242 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1283245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283267 */     // GIR_Coverage, 8606,
     /* 1283267 */     GIR_EraseRootFromParent_Done,
     /* 1283268 */   // Label 18450: @1283268
     /* 1283268 */   GIM_Try, /*On fail goto*//*Label 18451*/ GIMT_Encode4(1283352), // Rule ID 8607 //
     /* 1283273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1283281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1283293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283326 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1283329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283351 */     // GIR_Coverage, 8607,
     /* 1283351 */     GIR_EraseRootFromParent_Done,
     /* 1283352 */   // Label 18451: @1283352
     /* 1283352 */   GIM_Try, /*On fail goto*//*Label 18452*/ GIMT_Encode4(1283436), // Rule ID 8610 //
     /* 1283357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1283365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1283368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1283371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1283374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1283377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283410 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1283413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283435 */     // GIR_Coverage, 8610,
     /* 1283435 */     GIR_EraseRootFromParent_Done,
     /* 1283436 */   // Label 18452: @1283436
     /* 1283436 */   GIM_Try, /*On fail goto*//*Label 18453*/ GIMT_Encode4(1283520), // Rule ID 8611 //
     /* 1283441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1283449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1283452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1283455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1283458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1283461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283494 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1283497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283519 */     // GIR_Coverage, 8611,
     /* 1283519 */     GIR_EraseRootFromParent_Done,
     /* 1283520 */   // Label 18453: @1283520
     /* 1283520 */   GIM_Try, /*On fail goto*//*Label 18454*/ GIMT_Encode4(1283604), // Rule ID 8614 //
     /* 1283525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1283533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1283542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1283545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283578 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1283581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283603 */     // GIR_Coverage, 8614,
     /* 1283603 */     GIR_EraseRootFromParent_Done,
     /* 1283604 */   // Label 18454: @1283604
     /* 1283604 */   GIM_Try, /*On fail goto*//*Label 18455*/ GIMT_Encode4(1283688), // Rule ID 8615 //
     /* 1283609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1283617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1283626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1283629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283662 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1283665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283687 */     // GIR_Coverage, 8615,
     /* 1283687 */     GIR_EraseRootFromParent_Done,
     /* 1283688 */   // Label 18455: @1283688
     /* 1283688 */   GIM_Try, /*On fail goto*//*Label 18456*/ GIMT_Encode4(1283772), // Rule ID 8618 //
     /* 1283693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1283701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1283710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1283713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283746 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1283749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283771 */     // GIR_Coverage, 8618,
     /* 1283771 */     GIR_EraseRootFromParent_Done,
     /* 1283772 */   // Label 18456: @1283772
     /* 1283772 */   GIM_Try, /*On fail goto*//*Label 18457*/ GIMT_Encode4(1283856), // Rule ID 8619 //
     /* 1283777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1283785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1283794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1283797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283830 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1283833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283855 */     // GIR_Coverage, 8619,
     /* 1283855 */     GIR_EraseRootFromParent_Done,
     /* 1283856 */   // Label 18457: @1283856
     /* 1283856 */   GIM_Try, /*On fail goto*//*Label 18458*/ GIMT_Encode4(1283940), // Rule ID 8622 //
     /* 1283861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1283864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1283869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1283878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1283881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283914 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1283917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1283935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283939 */     // GIR_Coverage, 8622,
     /* 1283939 */     GIR_EraseRootFromParent_Done,
     /* 1283940 */   // Label 18458: @1283940
     /* 1283940 */   GIM_Try, /*On fail goto*//*Label 18459*/ GIMT_Encode4(1284024), // Rule ID 8623 //
     /* 1283945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1283948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1283953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1283962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1283965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283998 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1284001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1284019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284023 */     // GIR_Coverage, 8623,
     /* 1284023 */     GIR_EraseRootFromParent_Done,
     /* 1284024 */   // Label 18459: @1284024
     /* 1284024 */   GIM_Try, /*On fail goto*//*Label 18460*/ GIMT_Encode4(1284108), // Rule ID 8626 //
     /* 1284029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1284037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1284046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1284049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284082 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1284085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284107 */     // GIR_Coverage, 8626,
     /* 1284107 */     GIR_EraseRootFromParent_Done,
     /* 1284108 */   // Label 18460: @1284108
     /* 1284108 */   GIM_Try, /*On fail goto*//*Label 18461*/ GIMT_Encode4(1284192), // Rule ID 8627 //
     /* 1284113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1284121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1284130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1284133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284166 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1284169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284191 */     // GIR_Coverage, 8627,
     /* 1284191 */     GIR_EraseRootFromParent_Done,
     /* 1284192 */   // Label 18461: @1284192
     /* 1284192 */   GIM_Try, /*On fail goto*//*Label 18462*/ GIMT_Encode4(1284276), // Rule ID 8630 //
     /* 1284197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1284205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1284217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284250 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1284253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284275 */     // GIR_Coverage, 8630,
     /* 1284275 */     GIR_EraseRootFromParent_Done,
     /* 1284276 */   // Label 18462: @1284276
     /* 1284276 */   GIM_Try, /*On fail goto*//*Label 18463*/ GIMT_Encode4(1284360), // Rule ID 8631 //
     /* 1284281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1284289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1284301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284334 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1284337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284359 */     // GIR_Coverage, 8631,
     /* 1284359 */     GIR_EraseRootFromParent_Done,
     /* 1284360 */   // Label 18463: @1284360
     /* 1284360 */   GIM_Try, /*On fail goto*//*Label 18464*/ GIMT_Encode4(1284444), // Rule ID 8634 //
     /* 1284365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1284373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1284376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1284379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1284382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1284385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1284388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284418 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1284421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284443 */     // GIR_Coverage, 8634,
     /* 1284443 */     GIR_EraseRootFromParent_Done,
     /* 1284444 */   // Label 18464: @1284444
     /* 1284444 */   GIM_Try, /*On fail goto*//*Label 18465*/ GIMT_Encode4(1284528), // Rule ID 8635 //
     /* 1284449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1284457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1284460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1284463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1284466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1284469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1284472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284502 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1284505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284527 */     // GIR_Coverage, 8635,
     /* 1284527 */     GIR_EraseRootFromParent_Done,
     /* 1284528 */   // Label 18465: @1284528
     /* 1284528 */   GIM_Try, /*On fail goto*//*Label 18466*/ GIMT_Encode4(1284612), // Rule ID 8638 //
     /* 1284533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1284541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1284550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1284553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284586 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1284589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284611 */     // GIR_Coverage, 8638,
     /* 1284611 */     GIR_EraseRootFromParent_Done,
     /* 1284612 */   // Label 18466: @1284612
     /* 1284612 */   GIM_Try, /*On fail goto*//*Label 18467*/ GIMT_Encode4(1284696), // Rule ID 8639 //
     /* 1284617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1284625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1284634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1284637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284670 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1284673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284695 */     // GIR_Coverage, 8639,
     /* 1284695 */     GIR_EraseRootFromParent_Done,
     /* 1284696 */   // Label 18467: @1284696
     /* 1284696 */   GIM_Try, /*On fail goto*//*Label 18468*/ GIMT_Encode4(1284780), // Rule ID 8642 //
     /* 1284701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1284709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1284718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1284721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284754 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1284757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284779 */     // GIR_Coverage, 8642,
     /* 1284779 */     GIR_EraseRootFromParent_Done,
     /* 1284780 */   // Label 18468: @1284780
     /* 1284780 */   GIM_Try, /*On fail goto*//*Label 18469*/ GIMT_Encode4(1284864), // Rule ID 8643 //
     /* 1284785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1284793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1284802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1284805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284838 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1284841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284863 */     // GIR_Coverage, 8643,
     /* 1284863 */     GIR_EraseRootFromParent_Done,
     /* 1284864 */   // Label 18469: @1284864
     /* 1284864 */   GIM_Try, /*On fail goto*//*Label 18470*/ GIMT_Encode4(1284948), // Rule ID 8646 //
     /* 1284869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1284877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1284886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1284889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284922 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1284925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284947 */     // GIR_Coverage, 8646,
     /* 1284947 */     GIR_EraseRootFromParent_Done,
     /* 1284948 */   // Label 18470: @1284948
     /* 1284948 */   GIM_Try, /*On fail goto*//*Label 18471*/ GIMT_Encode4(1285032), // Rule ID 8647 //
     /* 1284953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1284961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1284970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1284973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285006 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1285009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285031 */     // GIR_Coverage, 8647,
     /* 1285031 */     GIR_EraseRootFromParent_Done,
     /* 1285032 */   // Label 18471: @1285032
     /* 1285032 */   GIM_Try, /*On fail goto*//*Label 18472*/ GIMT_Encode4(1285116), // Rule ID 8650 //
     /* 1285037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1285045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1285054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285090 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1285093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285115 */     // GIR_Coverage, 8650,
     /* 1285115 */     GIR_EraseRootFromParent_Done,
     /* 1285116 */   // Label 18472: @1285116
     /* 1285116 */   GIM_Try, /*On fail goto*//*Label 18473*/ GIMT_Encode4(1285200), // Rule ID 8651 //
     /* 1285121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1285129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1285138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1285141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285174 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1285177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285199 */     // GIR_Coverage, 8651,
     /* 1285199 */     GIR_EraseRootFromParent_Done,
     /* 1285200 */   // Label 18473: @1285200
     /* 1285200 */   GIM_Try, /*On fail goto*//*Label 18474*/ GIMT_Encode4(1285284), // Rule ID 8654 //
     /* 1285205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1285213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285258 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1285261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285283 */     // GIR_Coverage, 8654,
     /* 1285283 */     GIR_EraseRootFromParent_Done,
     /* 1285284 */   // Label 18474: @1285284
     /* 1285284 */   GIM_Try, /*On fail goto*//*Label 18475*/ GIMT_Encode4(1285368), // Rule ID 8655 //
     /* 1285289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1285297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1285309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285342 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1285345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285367 */     // GIR_Coverage, 8655,
     /* 1285367 */     GIR_EraseRootFromParent_Done,
     /* 1285368 */   // Label 18475: @1285368
     /* 1285368 */   GIM_Try, /*On fail goto*//*Label 18476*/ GIMT_Encode4(1285452), // Rule ID 8658 //
     /* 1285373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1285381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1285390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285426 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1285429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285451 */     // GIR_Coverage, 8658,
     /* 1285451 */     GIR_EraseRootFromParent_Done,
     /* 1285452 */   // Label 18476: @1285452
     /* 1285452 */   GIM_Try, /*On fail goto*//*Label 18477*/ GIMT_Encode4(1285536), // Rule ID 8659 //
     /* 1285457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1285465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1285474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1285477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285510 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1285513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285535 */     // GIR_Coverage, 8659,
     /* 1285535 */     GIR_EraseRootFromParent_Done,
     /* 1285536 */   // Label 18477: @1285536
     /* 1285536 */   GIM_Try, /*On fail goto*//*Label 18478*/ GIMT_Encode4(1285620), // Rule ID 8662 //
     /* 1285541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1285544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1285549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1285552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1285555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1285558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1285564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285594 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1285597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285619 */     // GIR_Coverage, 8662,
     /* 1285619 */     GIR_EraseRootFromParent_Done,
     /* 1285620 */   // Label 18478: @1285620
     /* 1285620 */   GIM_Try, /*On fail goto*//*Label 18479*/ GIMT_Encode4(1285704), // Rule ID 8663 //
     /* 1285625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1285628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1285633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1285636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1285639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1285642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1285645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1285648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285678 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1285681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285703 */     // GIR_Coverage, 8663,
     /* 1285703 */     GIR_EraseRootFromParent_Done,
     /* 1285704 */   // Label 18479: @1285704
     /* 1285704 */   GIM_Try, /*On fail goto*//*Label 18480*/ GIMT_Encode4(1285788), // Rule ID 8666 //
     /* 1285709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1285712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1285717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1285726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285762 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1285765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285787 */     // GIR_Coverage, 8666,
     /* 1285787 */     GIR_EraseRootFromParent_Done,
     /* 1285788 */   // Label 18480: @1285788
     /* 1285788 */   GIM_Try, /*On fail goto*//*Label 18481*/ GIMT_Encode4(1285872), // Rule ID 8667 //
     /* 1285793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1285796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1285801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1285810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1285813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285846 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1285849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285871 */     // GIR_Coverage, 8667,
     /* 1285871 */     GIR_EraseRootFromParent_Done,
     /* 1285872 */   // Label 18481: @1285872
     /* 1285872 */   GIM_Try, /*On fail goto*//*Label 18482*/ GIMT_Encode4(1285956), // Rule ID 8670 //
     /* 1285877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1285880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1285885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1285894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285930 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1285933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285955 */     // GIR_Coverage, 8670,
     /* 1285955 */     GIR_EraseRootFromParent_Done,
     /* 1285956 */   // Label 18482: @1285956
     /* 1285956 */   GIM_Try, /*On fail goto*//*Label 18483*/ GIMT_Encode4(1286040), // Rule ID 8671 //
     /* 1285961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1285964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1285969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1285978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1285981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286014 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1286017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286039 */     // GIR_Coverage, 8671,
     /* 1286039 */     GIR_EraseRootFromParent_Done,
     /* 1286040 */   // Label 18483: @1286040
     /* 1286040 */   GIM_Try, /*On fail goto*//*Label 18484*/ GIMT_Encode4(1286124), // Rule ID 8674 //
     /* 1286045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1286062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1286065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286098 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1286101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286123 */     // GIR_Coverage, 8674,
     /* 1286123 */     GIR_EraseRootFromParent_Done,
     /* 1286124 */   // Label 18484: @1286124
     /* 1286124 */   GIM_Try, /*On fail goto*//*Label 18485*/ GIMT_Encode4(1286208), // Rule ID 8675 //
     /* 1286129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1286146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1286149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286182 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1286185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286207 */     // GIR_Coverage, 8675,
     /* 1286207 */     GIR_EraseRootFromParent_Done,
     /* 1286208 */   // Label 18485: @1286208
     /* 1286208 */   GIM_Try, /*On fail goto*//*Label 18486*/ GIMT_Encode4(1286292), // Rule ID 8678 //
     /* 1286213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1286233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286266 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1286269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286291 */     // GIR_Coverage, 8678,
     /* 1286291 */     GIR_EraseRootFromParent_Done,
     /* 1286292 */   // Label 18486: @1286292
     /* 1286292 */   GIM_Try, /*On fail goto*//*Label 18487*/ GIMT_Encode4(1286376), // Rule ID 8679 //
     /* 1286297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1286317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286350 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1286353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286375 */     // GIR_Coverage, 8679,
     /* 1286375 */     GIR_EraseRootFromParent_Done,
     /* 1286376 */   // Label 18487: @1286376
     /* 1286376 */   GIM_Try, /*On fail goto*//*Label 18488*/ GIMT_Encode4(1286460), // Rule ID 8682 //
     /* 1286381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1286398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1286401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286434 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1286437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286459 */     // GIR_Coverage, 8682,
     /* 1286459 */     GIR_EraseRootFromParent_Done,
     /* 1286460 */   // Label 18488: @1286460
     /* 1286460 */   GIM_Try, /*On fail goto*//*Label 18489*/ GIMT_Encode4(1286544), // Rule ID 8683 //
     /* 1286465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1286482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1286485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286518 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1286521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286543 */     // GIR_Coverage, 8683,
     /* 1286543 */     GIR_EraseRootFromParent_Done,
     /* 1286544 */   // Label 18489: @1286544
     /* 1286544 */   GIM_Try, /*On fail goto*//*Label 18490*/ GIMT_Encode4(1286628), // Rule ID 8686 //
     /* 1286549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1286566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1286569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286602 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1286605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286627 */     // GIR_Coverage, 8686,
     /* 1286627 */     GIR_EraseRootFromParent_Done,
     /* 1286628 */   // Label 18490: @1286628
     /* 1286628 */   GIM_Try, /*On fail goto*//*Label 18491*/ GIMT_Encode4(1286712), // Rule ID 8687 //
     /* 1286633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1286650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1286653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286686 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1286689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286711 */     // GIR_Coverage, 8687,
     /* 1286711 */     GIR_EraseRootFromParent_Done,
     /* 1286712 */   // Label 18491: @1286712
     /* 1286712 */   GIM_Try, /*On fail goto*//*Label 18492*/ GIMT_Encode4(1286796), // Rule ID 8690 //
     /* 1286717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1286734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1286737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286770 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1286773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286795 */     // GIR_Coverage, 8690,
     /* 1286795 */     GIR_EraseRootFromParent_Done,
     /* 1286796 */   // Label 18492: @1286796
     /* 1286796 */   GIM_Try, /*On fail goto*//*Label 18493*/ GIMT_Encode4(1286880), // Rule ID 8691 //
     /* 1286801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1286818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1286821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286854 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1286857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286879 */     // GIR_Coverage, 8691,
     /* 1286879 */     GIR_EraseRootFromParent_Done,
     /* 1286880 */   // Label 18493: @1286880
     /* 1286880 */   GIM_Try, /*On fail goto*//*Label 18494*/ GIMT_Encode4(1286964), // Rule ID 8694 //
     /* 1286885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1286902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1286905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286938 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1286941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286963 */     // GIR_Coverage, 8694,
     /* 1286963 */     GIR_EraseRootFromParent_Done,
     /* 1286964 */   // Label 18494: @1286964
     /* 1286964 */   GIM_Try, /*On fail goto*//*Label 18495*/ GIMT_Encode4(1287048), // Rule ID 8695 //
     /* 1286969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1286986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1286989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287022 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1287025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287047 */     // GIR_Coverage, 8695,
     /* 1287047 */     GIR_EraseRootFromParent_Done,
     /* 1287048 */   // Label 18495: @1287048
     /* 1287048 */   GIM_Try, /*On fail goto*//*Label 18496*/ GIMT_Encode4(1287132), // Rule ID 8698 //
     /* 1287053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1287064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1287067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1287070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1287073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287106 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1287109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287131 */     // GIR_Coverage, 8698,
     /* 1287131 */     GIR_EraseRootFromParent_Done,
     /* 1287132 */   // Label 18496: @1287132
     /* 1287132 */   GIM_Try, /*On fail goto*//*Label 18497*/ GIMT_Encode4(1287216), // Rule ID 8699 //
     /* 1287137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1287148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1287151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1287154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1287157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287190 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1287193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287215 */     // GIR_Coverage, 8699,
     /* 1287215 */     GIR_EraseRootFromParent_Done,
     /* 1287216 */   // Label 18497: @1287216
     /* 1287216 */   GIM_Try, /*On fail goto*//*Label 18498*/ GIMT_Encode4(1287300), // Rule ID 8702 //
     /* 1287221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1287241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287274 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1287277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287299 */     // GIR_Coverage, 8702,
     /* 1287299 */     GIR_EraseRootFromParent_Done,
     /* 1287300 */   // Label 18498: @1287300
     /* 1287300 */   GIM_Try, /*On fail goto*//*Label 18499*/ GIMT_Encode4(1287384), // Rule ID 8703 //
     /* 1287305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1287325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287358 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1287361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287383 */     // GIR_Coverage, 8703,
     /* 1287383 */     GIR_EraseRootFromParent_Done,
     /* 1287384 */   // Label 18499: @1287384
     /* 1287384 */   GIM_Try, /*On fail goto*//*Label 18500*/ GIMT_Encode4(1287468), // Rule ID 8706 //
     /* 1287389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1287406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1287409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287442 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1287445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287467 */     // GIR_Coverage, 8706,
     /* 1287467 */     GIR_EraseRootFromParent_Done,
     /* 1287468 */   // Label 18500: @1287468
     /* 1287468 */   GIM_Try, /*On fail goto*//*Label 18501*/ GIMT_Encode4(1287552), // Rule ID 8707 //
     /* 1287473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1287490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1287493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287526 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1287529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287551 */     // GIR_Coverage, 8707,
     /* 1287551 */     GIR_EraseRootFromParent_Done,
     /* 1287552 */   // Label 18501: @1287552
     /* 1287552 */   GIM_Try, /*On fail goto*//*Label 18502*/ GIMT_Encode4(1287636), // Rule ID 8710 //
     /* 1287557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1287560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1287574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1287577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287610 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1287613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1287631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287635 */     // GIR_Coverage, 8710,
     /* 1287635 */     GIR_EraseRootFromParent_Done,
     /* 1287636 */   // Label 18502: @1287636
     /* 1287636 */   GIM_Try, /*On fail goto*//*Label 18503*/ GIMT_Encode4(1287720), // Rule ID 8711 //
     /* 1287641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1287644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1287658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1287661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287694 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1287697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1287715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287719 */     // GIR_Coverage, 8711,
     /* 1287719 */     GIR_EraseRootFromParent_Done,
     /* 1287720 */   // Label 18503: @1287720
     /* 1287720 */   GIM_Try, /*On fail goto*//*Label 18504*/ GIMT_Encode4(1287804), // Rule ID 8714 //
     /* 1287725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1287736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1287739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1287742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1287745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1287748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1287763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1287767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287778 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1287781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287803 */     // GIR_Coverage, 8714,
     /* 1287803 */     GIR_EraseRootFromParent_Done,
     /* 1287804 */   // Label 18504: @1287804
     /* 1287804 */   GIM_Try, /*On fail goto*//*Label 18505*/ GIMT_Encode4(1287888), // Rule ID 8715 //
     /* 1287809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1287820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1287823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1287826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1287829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1287832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1287847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1287851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287862 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1287865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287887 */     // GIR_Coverage, 8715,
     /* 1287887 */     GIR_EraseRootFromParent_Done,
     /* 1287888 */   // Label 18505: @1287888
     /* 1287888 */   GIM_Try, /*On fail goto*//*Label 18506*/ GIMT_Encode4(1287972), // Rule ID 8718 //
     /* 1287893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1287904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1287907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1287910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1287913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1287916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1287931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1287935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287946 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1287949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287971 */     // GIR_Coverage, 8718,
     /* 1287971 */     GIR_EraseRootFromParent_Done,
     /* 1287972 */   // Label 18506: @1287972
     /* 1287972 */   GIM_Try, /*On fail goto*//*Label 18507*/ GIMT_Encode4(1288056), // Rule ID 8719 //
     /* 1287977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1287988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1287991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1287994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1287997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288030 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1288033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288055 */     // GIR_Coverage, 8719,
     /* 1288055 */     GIR_EraseRootFromParent_Done,
     /* 1288056 */   // Label 18507: @1288056
     /* 1288056 */   GIM_Try, /*On fail goto*//*Label 18508*/ GIMT_Encode4(1288140), // Rule ID 8722 //
     /* 1288061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1288072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1288075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1288078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1288081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1288084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288114 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1288117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288139 */     // GIR_Coverage, 8722,
     /* 1288139 */     GIR_EraseRootFromParent_Done,
     /* 1288140 */   // Label 18508: @1288140
     /* 1288140 */   GIM_Try, /*On fail goto*//*Label 18509*/ GIMT_Encode4(1288224), // Rule ID 8723 //
     /* 1288145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1288156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1288159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1288162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1288165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1288168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288198 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1288201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288223 */     // GIR_Coverage, 8723,
     /* 1288223 */     GIR_EraseRootFromParent_Done,
     /* 1288224 */   // Label 18509: @1288224
     /* 1288224 */   GIM_Try, /*On fail goto*//*Label 18510*/ GIMT_Encode4(1288308), // Rule ID 8726 //
     /* 1288229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1288249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288282 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1288285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288307 */     // GIR_Coverage, 8726,
     /* 1288307 */     GIR_EraseRootFromParent_Done,
     /* 1288308 */   // Label 18510: @1288308
     /* 1288308 */   GIM_Try, /*On fail goto*//*Label 18511*/ GIMT_Encode4(1288392), // Rule ID 8727 //
     /* 1288313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1288333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288366 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1288369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288391 */     // GIR_Coverage, 8727,
     /* 1288391 */     GIR_EraseRootFromParent_Done,
     /* 1288392 */   // Label 18511: @1288392
     /* 1288392 */   GIM_Try, /*On fail goto*//*Label 18512*/ GIMT_Encode4(1288476), // Rule ID 8730 //
     /* 1288397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1288414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1288417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288450 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1288453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288475 */     // GIR_Coverage, 8730,
     /* 1288475 */     GIR_EraseRootFromParent_Done,
     /* 1288476 */   // Label 18512: @1288476
     /* 1288476 */   GIM_Try, /*On fail goto*//*Label 18513*/ GIMT_Encode4(1288560), // Rule ID 8731 //
     /* 1288481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1288498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1288501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288534 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1288537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288559 */     // GIR_Coverage, 8731,
     /* 1288559 */     GIR_EraseRootFromParent_Done,
     /* 1288560 */   // Label 18513: @1288560
     /* 1288560 */   GIM_Try, /*On fail goto*//*Label 18514*/ GIMT_Encode4(1288644), // Rule ID 8734 //
     /* 1288565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1288582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1288585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288618 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1288621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288643 */     // GIR_Coverage, 8734,
     /* 1288643 */     GIR_EraseRootFromParent_Done,
     /* 1288644 */   // Label 18514: @1288644
     /* 1288644 */   GIM_Try, /*On fail goto*//*Label 18515*/ GIMT_Encode4(1288728), // Rule ID 8735 //
     /* 1288649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1288666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1288669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288702 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1288705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288727 */     // GIR_Coverage, 8735,
     /* 1288727 */     GIR_EraseRootFromParent_Done,
     /* 1288728 */   // Label 18515: @1288728
     /* 1288728 */   GIM_Try, /*On fail goto*//*Label 18516*/ GIMT_Encode4(1288812), // Rule ID 8738 //
     /* 1288733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1288744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1288747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1288750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1288753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1288756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288786 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1288789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288811 */     // GIR_Coverage, 8738,
     /* 1288811 */     GIR_EraseRootFromParent_Done,
     /* 1288812 */   // Label 18516: @1288812
     /* 1288812 */   GIM_Try, /*On fail goto*//*Label 18517*/ GIMT_Encode4(1288896), // Rule ID 8739 //
     /* 1288817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1288828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1288831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1288834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1288837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1288840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288870 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1288873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288895 */     // GIR_Coverage, 8739,
     /* 1288895 */     GIR_EraseRootFromParent_Done,
     /* 1288896 */   // Label 18517: @1288896
     /* 1288896 */   GIM_Try, /*On fail goto*//*Label 18518*/ GIMT_Encode4(1288980), // Rule ID 8742 //
     /* 1288901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1288918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1288921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288954 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1288957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288979 */     // GIR_Coverage, 8742,
     /* 1288979 */     GIR_EraseRootFromParent_Done,
     /* 1288980 */   // Label 18518: @1288980
     /* 1288980 */   GIM_Try, /*On fail goto*//*Label 18519*/ GIMT_Encode4(1289064), // Rule ID 8743 //
     /* 1288985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1289002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1289005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289038 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1289041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289063 */     // GIR_Coverage, 8743,
     /* 1289063 */     GIR_EraseRootFromParent_Done,
     /* 1289064 */   // Label 18519: @1289064
     /* 1289064 */   GIM_Try, /*On fail goto*//*Label 18520*/ GIMT_Encode4(1289148), // Rule ID 8746 //
     /* 1289069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1289086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1289089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289122 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1289125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289147 */     // GIR_Coverage, 8746,
     /* 1289147 */     GIR_EraseRootFromParent_Done,
     /* 1289148 */   // Label 18520: @1289148
     /* 1289148 */   GIM_Try, /*On fail goto*//*Label 18521*/ GIMT_Encode4(1289232), // Rule ID 8747 //
     /* 1289153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1289170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1289173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289206 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1289209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289231 */     // GIR_Coverage, 8747,
     /* 1289231 */     GIR_EraseRootFromParent_Done,
     /* 1289232 */   // Label 18521: @1289232
     /* 1289232 */   GIM_Try, /*On fail goto*//*Label 18522*/ GIMT_Encode4(1289316), // Rule ID 8750 //
     /* 1289237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1289257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289290 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1289293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289315 */     // GIR_Coverage, 8750,
     /* 1289315 */     GIR_EraseRootFromParent_Done,
     /* 1289316 */   // Label 18522: @1289316
     /* 1289316 */   GIM_Try, /*On fail goto*//*Label 18523*/ GIMT_Encode4(1289400), // Rule ID 8751 //
     /* 1289321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1289341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289374 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1289377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289399 */     // GIR_Coverage, 8751,
     /* 1289399 */     GIR_EraseRootFromParent_Done,
     /* 1289400 */   // Label 18523: @1289400
     /* 1289400 */   GIM_Try, /*On fail goto*//*Label 18524*/ GIMT_Encode4(1289484), // Rule ID 8754 //
     /* 1289405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1289422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1289425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289458 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1289461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289483 */     // GIR_Coverage, 8754,
     /* 1289483 */     GIR_EraseRootFromParent_Done,
     /* 1289484 */   // Label 18524: @1289484
     /* 1289484 */   GIM_Try, /*On fail goto*//*Label 18525*/ GIMT_Encode4(1289568), // Rule ID 8755 //
     /* 1289489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1289506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1289509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289542 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1289545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289567 */     // GIR_Coverage, 8755,
     /* 1289567 */     GIR_EraseRootFromParent_Done,
     /* 1289568 */   // Label 18525: @1289568
     /* 1289568 */   GIM_Try, /*On fail goto*//*Label 18526*/ GIMT_Encode4(1289652), // Rule ID 8758 //
     /* 1289573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1289590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1289593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289626 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1289629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289651 */     // GIR_Coverage, 8758,
     /* 1289651 */     GIR_EraseRootFromParent_Done,
     /* 1289652 */   // Label 18526: @1289652
     /* 1289652 */   GIM_Try, /*On fail goto*//*Label 18527*/ GIMT_Encode4(1289736), // Rule ID 8759 //
     /* 1289657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1289674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1289677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289710 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1289713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289735 */     // GIR_Coverage, 8759,
     /* 1289735 */     GIR_EraseRootFromParent_Done,
     /* 1289736 */   // Label 18527: @1289736
     /* 1289736 */   GIM_Try, /*On fail goto*//*Label 18528*/ GIMT_Encode4(1289820), // Rule ID 8762 //
     /* 1289741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1289752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1289755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1289758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1289764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289794 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1289797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289819 */     // GIR_Coverage, 8762,
     /* 1289819 */     GIR_EraseRootFromParent_Done,
     /* 1289820 */   // Label 18528: @1289820
     /* 1289820 */   GIM_Try, /*On fail goto*//*Label 18529*/ GIMT_Encode4(1289904), // Rule ID 8763 //
     /* 1289825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1289836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1289839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1289842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1289848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289878 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1289881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289903 */     // GIR_Coverage, 8763,
     /* 1289903 */     GIR_EraseRootFromParent_Done,
     /* 1289904 */   // Label 18529: @1289904
     /* 1289904 */   GIM_Try, /*On fail goto*//*Label 18530*/ GIMT_Encode4(1289988), // Rule ID 8766 //
     /* 1289909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1289926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289962 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1289965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289987 */     // GIR_Coverage, 8766,
     /* 1289987 */     GIR_EraseRootFromParent_Done,
     /* 1289988 */   // Label 18530: @1289988
     /* 1289988 */   GIM_Try, /*On fail goto*//*Label 18531*/ GIMT_Encode4(1290072), // Rule ID 8767 //
     /* 1289993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1290001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1290010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1290013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290046 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1290049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290071 */     // GIR_Coverage, 8767,
     /* 1290071 */     GIR_EraseRootFromParent_Done,
     /* 1290072 */   // Label 18531: @1290072
     /* 1290072 */   GIM_Try, /*On fail goto*//*Label 18532*/ GIMT_Encode4(1290156), // Rule ID 8770 //
     /* 1290077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1290085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1290094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1290097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290130 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1290133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290155 */     // GIR_Coverage, 8770,
     /* 1290155 */     GIR_EraseRootFromParent_Done,
     /* 1290156 */   // Label 18532: @1290156
     /* 1290156 */   GIM_Try, /*On fail goto*//*Label 18533*/ GIMT_Encode4(1290240), // Rule ID 8771 //
     /* 1290161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1290169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1290178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1290181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290214 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1290217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290239 */     // GIR_Coverage, 8771,
     /* 1290239 */     GIR_EraseRootFromParent_Done,
     /* 1290240 */   // Label 18533: @1290240
     /* 1290240 */   GIM_Try, /*On fail goto*//*Label 18534*/ GIMT_Encode4(1290324), // Rule ID 8774 //
     /* 1290245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1290253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1290262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1290265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290298 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1290301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290323 */     // GIR_Coverage, 8774,
     /* 1290323 */     GIR_EraseRootFromParent_Done,
     /* 1290324 */   // Label 18534: @1290324
     /* 1290324 */   GIM_Try, /*On fail goto*//*Label 18535*/ GIMT_Encode4(1290408), // Rule ID 8775 //
     /* 1290329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1290337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1290346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1290349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290382 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1290385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290407 */     // GIR_Coverage, 8775,
     /* 1290407 */     GIR_EraseRootFromParent_Done,
     /* 1290408 */   // Label 18535: @1290408
     /* 1290408 */   GIM_Try, /*On fail goto*//*Label 18536*/ GIMT_Encode4(1290492), // Rule ID 8778 //
     /* 1290413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1290421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1290430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1290433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290466 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1290469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290491 */     // GIR_Coverage, 8778,
     /* 1290491 */     GIR_EraseRootFromParent_Done,
     /* 1290492 */   // Label 18536: @1290492
     /* 1290492 */   GIM_Try, /*On fail goto*//*Label 18537*/ GIMT_Encode4(1290576), // Rule ID 8779 //
     /* 1290497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1290505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1290514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1290517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290550 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1290553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290575 */     // GIR_Coverage, 8779,
     /* 1290575 */     GIR_EraseRootFromParent_Done,
     /* 1290576 */   // Label 18537: @1290576
     /* 1290576 */   GIM_Try, /*On fail goto*//*Label 18538*/ GIMT_Encode4(1290660), // Rule ID 8782 //
     /* 1290581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1290589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1290598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1290601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290634 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1290637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290659 */     // GIR_Coverage, 8782,
     /* 1290659 */     GIR_EraseRootFromParent_Done,
     /* 1290660 */   // Label 18538: @1290660
     /* 1290660 */   GIM_Try, /*On fail goto*//*Label 18539*/ GIMT_Encode4(1290744), // Rule ID 8783 //
     /* 1290665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1290673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1290682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1290685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290718 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1290721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290743 */     // GIR_Coverage, 8783,
     /* 1290743 */     GIR_EraseRootFromParent_Done,
     /* 1290744 */   // Label 18539: @1290744
     /* 1290744 */   GIM_Try, /*On fail goto*//*Label 18540*/ GIMT_Encode4(1290828), // Rule ID 8786 //
     /* 1290749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1290757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1290760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1290763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1290766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1290769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290802 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1290805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290827 */     // GIR_Coverage, 8786,
     /* 1290827 */     GIR_EraseRootFromParent_Done,
     /* 1290828 */   // Label 18540: @1290828
     /* 1290828 */   GIM_Try, /*On fail goto*//*Label 18541*/ GIMT_Encode4(1290912), // Rule ID 8787 //
     /* 1290833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1290841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1290844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1290847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1290850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1290853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290886 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1290889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290911 */     // GIR_Coverage, 8787,
     /* 1290911 */     GIR_EraseRootFromParent_Done,
     /* 1290912 */   // Label 18541: @1290912
     /* 1290912 */   GIM_Try, /*On fail goto*//*Label 18542*/ GIMT_Encode4(1290996), // Rule ID 8790 //
     /* 1290917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1290925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1290934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1290937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290970 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1290973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290995 */     // GIR_Coverage, 8790,
     /* 1290995 */     GIR_EraseRootFromParent_Done,
     /* 1290996 */   // Label 18542: @1290996
     /* 1290996 */   GIM_Try, /*On fail goto*//*Label 18543*/ GIMT_Encode4(1291080), // Rule ID 8791 //
     /* 1291001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1291009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1291012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1291015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1291018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1291024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291054 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1291057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291079 */     // GIR_Coverage, 8791,
     /* 1291079 */     GIR_EraseRootFromParent_Done,
     /* 1291080 */   // Label 18543: @1291080
     /* 1291080 */   GIM_Try, /*On fail goto*//*Label 18544*/ GIMT_Encode4(1291164), // Rule ID 8794 //
     /* 1291085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1291093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1291102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291138 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1291141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291163 */     // GIR_Coverage, 8794,
     /* 1291163 */     GIR_EraseRootFromParent_Done,
     /* 1291164 */   // Label 18544: @1291164
     /* 1291164 */   GIM_Try, /*On fail goto*//*Label 18545*/ GIMT_Encode4(1291248), // Rule ID 8795 //
     /* 1291169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1291177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1291186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291222 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1291225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291247 */     // GIR_Coverage, 8795,
     /* 1291247 */     GIR_EraseRootFromParent_Done,
     /* 1291248 */   // Label 18545: @1291248
     /* 1291248 */   GIM_Try, /*On fail goto*//*Label 18546*/ GIMT_Encode4(1291332), // Rule ID 8798 //
     /* 1291253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1291256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1291261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1291270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291306 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1291309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1291327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291331 */     // GIR_Coverage, 8798,
     /* 1291331 */     GIR_EraseRootFromParent_Done,
     /* 1291332 */   // Label 18546: @1291332
     /* 1291332 */   GIM_Try, /*On fail goto*//*Label 18547*/ GIMT_Encode4(1291416), // Rule ID 8799 //
     /* 1291337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1291340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1291345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1291354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291390 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1291393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1291411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291415 */     // GIR_Coverage, 8799,
     /* 1291415 */     GIR_EraseRootFromParent_Done,
     /* 1291416 */   // Label 18547: @1291416
     /* 1291416 */   GIM_Try, /*On fail goto*//*Label 18548*/ GIMT_Encode4(1291500), // Rule ID 8802 //
     /* 1291421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1291429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1291432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1291435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1291438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291474 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1291477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291499 */     // GIR_Coverage, 8802,
     /* 1291499 */     GIR_EraseRootFromParent_Done,
     /* 1291500 */   // Label 18548: @1291500
     /* 1291500 */   GIM_Try, /*On fail goto*//*Label 18549*/ GIMT_Encode4(1291584), // Rule ID 8803 //
     /* 1291505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1291513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1291516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1291519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1291522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291558 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1291561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291583 */     // GIR_Coverage, 8803,
     /* 1291583 */     GIR_EraseRootFromParent_Done,
     /* 1291584 */   // Label 18549: @1291584
     /* 1291584 */   GIM_Try, /*On fail goto*//*Label 18550*/ GIMT_Encode4(1291668), // Rule ID 8806 //
     /* 1291589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1291597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1291600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1291603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1291606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1291612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291642 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1291645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291667 */     // GIR_Coverage, 8806,
     /* 1291667 */     GIR_EraseRootFromParent_Done,
     /* 1291668 */   // Label 18550: @1291668
     /* 1291668 */   GIM_Try, /*On fail goto*//*Label 18551*/ GIMT_Encode4(1291752), // Rule ID 8807 //
     /* 1291673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1291681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1291684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1291687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1291690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1291696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291726 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1291729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291751 */     // GIR_Coverage, 8807,
     /* 1291751 */     GIR_EraseRootFromParent_Done,
     /* 1291752 */   // Label 18551: @1291752
     /* 1291752 */   GIM_Try, /*On fail goto*//*Label 18552*/ GIMT_Encode4(1291836), // Rule ID 8810 //
     /* 1291757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1291765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1291768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1291771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1291774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1291780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1291795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291810 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1291813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291835 */     // GIR_Coverage, 8810,
     /* 1291835 */     GIR_EraseRootFromParent_Done,
     /* 1291836 */   // Label 18552: @1291836
     /* 1291836 */   GIM_Try, /*On fail goto*//*Label 18553*/ GIMT_Encode4(1291920), // Rule ID 8811 //
     /* 1291841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1291849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1291852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1291855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1291858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1291864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1291879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291894 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1291897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291919 */     // GIR_Coverage, 8811,
     /* 1291919 */     GIR_EraseRootFromParent_Done,
     /* 1291920 */   // Label 18553: @1291920
     /* 1291920 */   GIM_Try, /*On fail goto*//*Label 18554*/ GIMT_Encode4(1292004), // Rule ID 8814 //
     /* 1291925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1291933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1291936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1291939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1291942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1291948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291978 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1291981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292003 */     // GIR_Coverage, 8814,
     /* 1292003 */     GIR_EraseRootFromParent_Done,
     /* 1292004 */   // Label 18554: @1292004
     /* 1292004 */   GIM_Try, /*On fail goto*//*Label 18555*/ GIMT_Encode4(1292088), // Rule ID 8815 //
     /* 1292009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1292017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1292026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292062 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1292065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292087 */     // GIR_Coverage, 8815,
     /* 1292087 */     GIR_EraseRootFromParent_Done,
     /* 1292088 */   // Label 18555: @1292088
     /* 1292088 */   GIM_Try, /*On fail goto*//*Label 18556*/ GIMT_Encode4(1292172), // Rule ID 8818 //
     /* 1292093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1292101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1292110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292146 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1292149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292171 */     // GIR_Coverage, 8818,
     /* 1292171 */     GIR_EraseRootFromParent_Done,
     /* 1292172 */   // Label 18556: @1292172
     /* 1292172 */   GIM_Try, /*On fail goto*//*Label 18557*/ GIMT_Encode4(1292256), // Rule ID 8819 //
     /* 1292177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1292185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1292194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292230 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1292233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292255 */     // GIR_Coverage, 8819,
     /* 1292255 */     GIR_EraseRootFromParent_Done,
     /* 1292256 */   // Label 18557: @1292256
     /* 1292256 */   GIM_Try, /*On fail goto*//*Label 18558*/ GIMT_Encode4(1292340), // Rule ID 8822 //
     /* 1292261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1292269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1292278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292314 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1292317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292339 */     // GIR_Coverage, 8822,
     /* 1292339 */     GIR_EraseRootFromParent_Done,
     /* 1292340 */   // Label 18558: @1292340
     /* 1292340 */   GIM_Try, /*On fail goto*//*Label 18559*/ GIMT_Encode4(1292424), // Rule ID 8823 //
     /* 1292345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1292353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1292362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292398 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1292401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292423 */     // GIR_Coverage, 8823,
     /* 1292423 */     GIR_EraseRootFromParent_Done,
     /* 1292424 */   // Label 18559: @1292424
     /* 1292424 */   GIM_Try, /*On fail goto*//*Label 18560*/ GIMT_Encode4(1292508), // Rule ID 8826 //
     /* 1292429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1292437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1292446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292482 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1292485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292507 */     // GIR_Coverage, 8826,
     /* 1292507 */     GIR_EraseRootFromParent_Done,
     /* 1292508 */   // Label 18560: @1292508
     /* 1292508 */   GIM_Try, /*On fail goto*//*Label 18561*/ GIMT_Encode4(1292592), // Rule ID 8827 //
     /* 1292513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1292521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1292530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292566 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1292569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292591 */     // GIR_Coverage, 8827,
     /* 1292591 */     GIR_EraseRootFromParent_Done,
     /* 1292592 */   // Label 18561: @1292592
     /* 1292592 */   GIM_Try, /*On fail goto*//*Label 18562*/ GIMT_Encode4(1292676), // Rule ID 8830 //
     /* 1292597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1292605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1292614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292650 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1292653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292675 */     // GIR_Coverage, 8830,
     /* 1292675 */     GIR_EraseRootFromParent_Done,
     /* 1292676 */   // Label 18562: @1292676
     /* 1292676 */   GIM_Try, /*On fail goto*//*Label 18563*/ GIMT_Encode4(1292760), // Rule ID 8831 //
     /* 1292681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1292689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1292698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292734 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1292737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292759 */     // GIR_Coverage, 8831,
     /* 1292759 */     GIR_EraseRootFromParent_Done,
     /* 1292760 */   // Label 18563: @1292760
     /* 1292760 */   GIM_Try, /*On fail goto*//*Label 18564*/ GIMT_Encode4(1292844), // Rule ID 8834 //
     /* 1292765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1292773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1292782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292818 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1292821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292843 */     // GIR_Coverage, 8834,
     /* 1292843 */     GIR_EraseRootFromParent_Done,
     /* 1292844 */   // Label 18564: @1292844
     /* 1292844 */   GIM_Try, /*On fail goto*//*Label 18565*/ GIMT_Encode4(1292928), // Rule ID 8835 //
     /* 1292849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1292857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1292866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292902 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1292905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292927 */     // GIR_Coverage, 8835,
     /* 1292927 */     GIR_EraseRootFromParent_Done,
     /* 1292928 */   // Label 18565: @1292928
     /* 1292928 */   GIM_Try, /*On fail goto*//*Label 18566*/ GIMT_Encode4(1293012), // Rule ID 8838 //
     /* 1292933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1292936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1292941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1292944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1292947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1292950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1292956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292986 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1292989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293011 */     // GIR_Coverage, 8838,
     /* 1293011 */     GIR_EraseRootFromParent_Done,
     /* 1293012 */   // Label 18566: @1293012
     /* 1293012 */   GIM_Try, /*On fail goto*//*Label 18567*/ GIMT_Encode4(1293096), // Rule ID 8839 //
     /* 1293017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1293025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1293034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293070 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1293073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293095 */     // GIR_Coverage, 8839,
     /* 1293095 */     GIR_EraseRootFromParent_Done,
     /* 1293096 */   // Label 18567: @1293096
     /* 1293096 */   GIM_Try, /*On fail goto*//*Label 18568*/ GIMT_Encode4(1293180), // Rule ID 8842 //
     /* 1293101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1293104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1293109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1293118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293154 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1293157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293179 */     // GIR_Coverage, 8842,
     /* 1293179 */     GIR_EraseRootFromParent_Done,
     /* 1293180 */   // Label 18568: @1293180
     /* 1293180 */   GIM_Try, /*On fail goto*//*Label 18569*/ GIMT_Encode4(1293264), // Rule ID 8843 //
     /* 1293185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1293193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1293202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293238 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1293241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293263 */     // GIR_Coverage, 8843,
     /* 1293263 */     GIR_EraseRootFromParent_Done,
     /* 1293264 */   // Label 18569: @1293264
     /* 1293264 */   GIM_Try, /*On fail goto*//*Label 18570*/ GIMT_Encode4(1293348), // Rule ID 8846 //
     /* 1293269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1293272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1293277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1293286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293322 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1293325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293347 */     // GIR_Coverage, 8846,
     /* 1293347 */     GIR_EraseRootFromParent_Done,
     /* 1293348 */   // Label 18570: @1293348
     /* 1293348 */   GIM_Try, /*On fail goto*//*Label 18571*/ GIMT_Encode4(1293432), // Rule ID 8847 //
     /* 1293353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1293361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1293370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293406 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1293409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293431 */     // GIR_Coverage, 8847,
     /* 1293431 */     GIR_EraseRootFromParent_Done,
     /* 1293432 */   // Label 18571: @1293432
     /* 1293432 */   GIM_Try, /*On fail goto*//*Label 18572*/ GIMT_Encode4(1293516), // Rule ID 8938 //
     /* 1293437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1293454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1293457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293490 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1293493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293515 */     // GIR_Coverage, 8938,
     /* 1293515 */     GIR_EraseRootFromParent_Done,
     /* 1293516 */   // Label 18572: @1293516
     /* 1293516 */   GIM_Try, /*On fail goto*//*Label 18573*/ GIMT_Encode4(1293600), // Rule ID 8939 //
     /* 1293521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1293538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1293541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293574 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1293577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293599 */     // GIR_Coverage, 8939,
     /* 1293599 */     GIR_EraseRootFromParent_Done,
     /* 1293600 */   // Label 18573: @1293600
     /* 1293600 */   GIM_Try, /*On fail goto*//*Label 18574*/ GIMT_Encode4(1293684), // Rule ID 8942 //
     /* 1293605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1293622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1293625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293658 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1293661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293683 */     // GIR_Coverage, 8942,
     /* 1293683 */     GIR_EraseRootFromParent_Done,
     /* 1293684 */   // Label 18574: @1293684
     /* 1293684 */   GIM_Try, /*On fail goto*//*Label 18575*/ GIMT_Encode4(1293768), // Rule ID 8943 //
     /* 1293689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1293706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1293709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293742 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1293745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293767 */     // GIR_Coverage, 8943,
     /* 1293767 */     GIR_EraseRootFromParent_Done,
     /* 1293768 */   // Label 18575: @1293768
     /* 1293768 */   GIM_Try, /*On fail goto*//*Label 18576*/ GIMT_Encode4(1293852), // Rule ID 8946 //
     /* 1293773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1293790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1293793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293826 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1293829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293851 */     // GIR_Coverage, 8946,
     /* 1293851 */     GIR_EraseRootFromParent_Done,
     /* 1293852 */   // Label 18576: @1293852
     /* 1293852 */   GIM_Try, /*On fail goto*//*Label 18577*/ GIMT_Encode4(1293936), // Rule ID 8947 //
     /* 1293857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1293874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1293877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293910 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1293913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293935 */     // GIR_Coverage, 8947,
     /* 1293935 */     GIR_EraseRootFromParent_Done,
     /* 1293936 */   // Label 18577: @1293936
     /* 1293936 */   GIM_Try, /*On fail goto*//*Label 18578*/ GIMT_Encode4(1294020), // Rule ID 8950 //
     /* 1293941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1293958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1293961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293994 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1293997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294019 */     // GIR_Coverage, 8950,
     /* 1294019 */     GIR_EraseRootFromParent_Done,
     /* 1294020 */   // Label 18578: @1294020
     /* 1294020 */   GIM_Try, /*On fail goto*//*Label 18579*/ GIMT_Encode4(1294104), // Rule ID 8951 //
     /* 1294025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1294042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1294045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294078 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1294081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294103 */     // GIR_Coverage, 8951,
     /* 1294103 */     GIR_EraseRootFromParent_Done,
     /* 1294104 */   // Label 18579: @1294104
     /* 1294104 */   GIM_Try, /*On fail goto*//*Label 18580*/ GIMT_Encode4(1294188), // Rule ID 8954 //
     /* 1294109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1294126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1294129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294162 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1294165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294187 */     // GIR_Coverage, 8954,
     /* 1294187 */     GIR_EraseRootFromParent_Done,
     /* 1294188 */   // Label 18580: @1294188
     /* 1294188 */   GIM_Try, /*On fail goto*//*Label 18581*/ GIMT_Encode4(1294272), // Rule ID 8955 //
     /* 1294193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1294210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1294213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294246 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1294249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294271 */     // GIR_Coverage, 8955,
     /* 1294271 */     GIR_EraseRootFromParent_Done,
     /* 1294272 */   // Label 18581: @1294272
     /* 1294272 */   GIM_Try, /*On fail goto*//*Label 18582*/ GIMT_Encode4(1294356), // Rule ID 8958 //
     /* 1294277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1294294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1294297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294330 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1294333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294355 */     // GIR_Coverage, 8958,
     /* 1294355 */     GIR_EraseRootFromParent_Done,
     /* 1294356 */   // Label 18582: @1294356
     /* 1294356 */   GIM_Try, /*On fail goto*//*Label 18583*/ GIMT_Encode4(1294440), // Rule ID 8959 //
     /* 1294361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1294378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1294381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294414 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1294417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294439 */     // GIR_Coverage, 8959,
     /* 1294439 */     GIR_EraseRootFromParent_Done,
     /* 1294440 */   // Label 18583: @1294440
     /* 1294440 */   GIM_Try, /*On fail goto*//*Label 18584*/ GIMT_Encode4(1294524), // Rule ID 8962 //
     /* 1294445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1294462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1294465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294498 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1294501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294523 */     // GIR_Coverage, 8962,
     /* 1294523 */     GIR_EraseRootFromParent_Done,
     /* 1294524 */   // Label 18584: @1294524
     /* 1294524 */   GIM_Try, /*On fail goto*//*Label 18585*/ GIMT_Encode4(1294608), // Rule ID 8963 //
     /* 1294529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1294546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1294549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294582 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1294585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294607 */     // GIR_Coverage, 8963,
     /* 1294607 */     GIR_EraseRootFromParent_Done,
     /* 1294608 */   // Label 18585: @1294608
     /* 1294608 */   GIM_Try, /*On fail goto*//*Label 18586*/ GIMT_Encode4(1294692), // Rule ID 8966 //
     /* 1294613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1294630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1294633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294666 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1294669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294691 */     // GIR_Coverage, 8966,
     /* 1294691 */     GIR_EraseRootFromParent_Done,
     /* 1294692 */   // Label 18586: @1294692
     /* 1294692 */   GIM_Try, /*On fail goto*//*Label 18587*/ GIMT_Encode4(1294776), // Rule ID 8967 //
     /* 1294697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1294714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1294717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294750 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1294753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294775 */     // GIR_Coverage, 8967,
     /* 1294775 */     GIR_EraseRootFromParent_Done,
     /* 1294776 */   // Label 18587: @1294776
     /* 1294776 */   GIM_Try, /*On fail goto*//*Label 18588*/ GIMT_Encode4(1294860), // Rule ID 8970 //
     /* 1294781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1294798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1294801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294834 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1294837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294859 */     // GIR_Coverage, 8970,
     /* 1294859 */     GIR_EraseRootFromParent_Done,
     /* 1294860 */   // Label 18588: @1294860
     /* 1294860 */   GIM_Try, /*On fail goto*//*Label 18589*/ GIMT_Encode4(1294944), // Rule ID 8971 //
     /* 1294865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1294882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1294885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294918 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1294921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294943 */     // GIR_Coverage, 8971,
     /* 1294943 */     GIR_EraseRootFromParent_Done,
     /* 1294944 */   // Label 18589: @1294944
     /* 1294944 */   GIM_Try, /*On fail goto*//*Label 18590*/ GIMT_Encode4(1295028), // Rule ID 8974 //
     /* 1294949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1294952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1294966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1294969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295002 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1295005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1295023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295027 */     // GIR_Coverage, 8974,
     /* 1295027 */     GIR_EraseRootFromParent_Done,
     /* 1295028 */   // Label 18590: @1295028
     /* 1295028 */   GIM_Try, /*On fail goto*//*Label 18591*/ GIMT_Encode4(1295112), // Rule ID 8975 //
     /* 1295033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1295036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1295044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1295047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1295050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1295053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1295056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295086 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1295089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1295107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295111 */     // GIR_Coverage, 8975,
     /* 1295111 */     GIR_EraseRootFromParent_Done,
     /* 1295112 */   // Label 18591: @1295112
     /* 1295112 */   GIM_Try, /*On fail goto*//*Label 18592*/ GIMT_Encode4(1295196), // Rule ID 8978 //
     /* 1295117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1295134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1295137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295170 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1295173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295195 */     // GIR_Coverage, 8978,
     /* 1295195 */     GIR_EraseRootFromParent_Done,
     /* 1295196 */   // Label 18592: @1295196
     /* 1295196 */   GIM_Try, /*On fail goto*//*Label 18593*/ GIMT_Encode4(1295280), // Rule ID 8979 //
     /* 1295201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1295218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1295221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295254 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1295257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295279 */     // GIR_Coverage, 8979,
     /* 1295279 */     GIR_EraseRootFromParent_Done,
     /* 1295280 */   // Label 18593: @1295280
     /* 1295280 */   GIM_Try, /*On fail goto*//*Label 18594*/ GIMT_Encode4(1295364), // Rule ID 8982 //
     /* 1295285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1295302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1295305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295338 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1295341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295363 */     // GIR_Coverage, 8982,
     /* 1295363 */     GIR_EraseRootFromParent_Done,
     /* 1295364 */   // Label 18594: @1295364
     /* 1295364 */   GIM_Try, /*On fail goto*//*Label 18595*/ GIMT_Encode4(1295448), // Rule ID 8983 //
     /* 1295369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1295386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1295389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295422 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1295425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295447 */     // GIR_Coverage, 8983,
     /* 1295447 */     GIR_EraseRootFromParent_Done,
     /* 1295448 */   // Label 18595: @1295448
     /* 1295448 */   GIM_Try, /*On fail goto*//*Label 18596*/ GIMT_Encode4(1295532), // Rule ID 8986 //
     /* 1295453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1295464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1295467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1295470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1295473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1295476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295506 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1295509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295531 */     // GIR_Coverage, 8986,
     /* 1295531 */     GIR_EraseRootFromParent_Done,
     /* 1295532 */   // Label 18596: @1295532
     /* 1295532 */   GIM_Try, /*On fail goto*//*Label 18597*/ GIMT_Encode4(1295616), // Rule ID 8987 //
     /* 1295537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1295548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1295551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1295554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1295557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1295560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295590 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1295593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295615 */     // GIR_Coverage, 8987,
     /* 1295615 */     GIR_EraseRootFromParent_Done,
     /* 1295616 */   // Label 18597: @1295616
     /* 1295616 */   GIM_Try, /*On fail goto*//*Label 18598*/ GIMT_Encode4(1295700), // Rule ID 8990 //
     /* 1295621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1295632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1295635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1295638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1295641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295674 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1295677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295699 */     // GIR_Coverage, 8990,
     /* 1295699 */     GIR_EraseRootFromParent_Done,
     /* 1295700 */   // Label 18598: @1295700
     /* 1295700 */   GIM_Try, /*On fail goto*//*Label 18599*/ GIMT_Encode4(1295784), // Rule ID 8991 //
     /* 1295705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1295716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1295719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1295722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1295725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295758 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1295761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295783 */     // GIR_Coverage, 8991,
     /* 1295783 */     GIR_EraseRootFromParent_Done,
     /* 1295784 */   // Label 18599: @1295784
     /* 1295784 */   GIM_Try, /*On fail goto*//*Label 18600*/ GIMT_Encode4(1295868), // Rule ID 8994 //
     /* 1295789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1295806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1295809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295842 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1295845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295867 */     // GIR_Coverage, 8994,
     /* 1295867 */     GIR_EraseRootFromParent_Done,
     /* 1295868 */   // Label 18600: @1295868
     /* 1295868 */   GIM_Try, /*On fail goto*//*Label 18601*/ GIMT_Encode4(1295952), // Rule ID 8995 //
     /* 1295873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1295890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1295893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295926 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1295929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295951 */     // GIR_Coverage, 8995,
     /* 1295951 */     GIR_EraseRootFromParent_Done,
     /* 1295952 */   // Label 18601: @1295952
     /* 1295952 */   GIM_Try, /*On fail goto*//*Label 18602*/ GIMT_Encode4(1296036), // Rule ID 8998 //
     /* 1295957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1295974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1295977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296010 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1296013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296035 */     // GIR_Coverage, 8998,
     /* 1296035 */     GIR_EraseRootFromParent_Done,
     /* 1296036 */   // Label 18602: @1296036
     /* 1296036 */   GIM_Try, /*On fail goto*//*Label 18603*/ GIMT_Encode4(1296120), // Rule ID 8999 //
     /* 1296041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1296052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1296055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1296058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1296061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1296064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296094 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1296097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296119 */     // GIR_Coverage, 8999,
     /* 1296119 */     GIR_EraseRootFromParent_Done,
     /* 1296120 */   // Label 18603: @1296120
     /* 1296120 */   GIM_Try, /*On fail goto*//*Label 18604*/ GIMT_Encode4(1296204), // Rule ID 9002 //
     /* 1296125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1296142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1296145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296178 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1296181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296203 */     // GIR_Coverage, 9002,
     /* 1296203 */     GIR_EraseRootFromParent_Done,
     /* 1296204 */   // Label 18604: @1296204
     /* 1296204 */   GIM_Try, /*On fail goto*//*Label 18605*/ GIMT_Encode4(1296288), // Rule ID 9003 //
     /* 1296209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1296226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1296229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296262 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1296265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296287 */     // GIR_Coverage, 9003,
     /* 1296287 */     GIR_EraseRootFromParent_Done,
     /* 1296288 */   // Label 18605: @1296288
     /* 1296288 */   GIM_Try, /*On fail goto*//*Label 18606*/ GIMT_Encode4(1296372), // Rule ID 9006 //
     /* 1296293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1296310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1296313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296346 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1296349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296371 */     // GIR_Coverage, 9006,
     /* 1296371 */     GIR_EraseRootFromParent_Done,
     /* 1296372 */   // Label 18606: @1296372
     /* 1296372 */   GIM_Try, /*On fail goto*//*Label 18607*/ GIMT_Encode4(1296456), // Rule ID 9007 //
     /* 1296377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1296394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1296397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296430 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1296433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296455 */     // GIR_Coverage, 9007,
     /* 1296455 */     GIR_EraseRootFromParent_Done,
     /* 1296456 */   // Label 18607: @1296456
     /* 1296456 */   GIM_Try, /*On fail goto*//*Label 18608*/ GIMT_Encode4(1296540), // Rule ID 9010 //
     /* 1296461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1296478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1296481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296514 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1296517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296539 */     // GIR_Coverage, 9010,
     /* 1296539 */     GIR_EraseRootFromParent_Done,
     /* 1296540 */   // Label 18608: @1296540
     /* 1296540 */   GIM_Try, /*On fail goto*//*Label 18609*/ GIMT_Encode4(1296624), // Rule ID 9011 //
     /* 1296545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1296562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1296565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296598 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1296601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296623 */     // GIR_Coverage, 9011,
     /* 1296623 */     GIR_EraseRootFromParent_Done,
     /* 1296624 */   // Label 18609: @1296624
     /* 1296624 */   GIM_Try, /*On fail goto*//*Label 18610*/ GIMT_Encode4(1296708), // Rule ID 9014 //
     /* 1296629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1296632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1296640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1296643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1296646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1296649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296682 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1296685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296707 */     // GIR_Coverage, 9014,
     /* 1296707 */     GIR_EraseRootFromParent_Done,
     /* 1296708 */   // Label 18610: @1296708
     /* 1296708 */   GIM_Try, /*On fail goto*//*Label 18611*/ GIMT_Encode4(1296792), // Rule ID 9015 //
     /* 1296713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1296716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1296724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1296727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1296730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1296733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296766 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1296769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296791 */     // GIR_Coverage, 9015,
     /* 1296791 */     GIR_EraseRootFromParent_Done,
     /* 1296792 */   // Label 18611: @1296792
     /* 1296792 */   GIM_Try, /*On fail goto*//*Label 18612*/ GIMT_Encode4(1296876), // Rule ID 9018 //
     /* 1296797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1296800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1296814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1296817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296850 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1296853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296875 */     // GIR_Coverage, 9018,
     /* 1296875 */     GIR_EraseRootFromParent_Done,
     /* 1296876 */   // Label 18612: @1296876
     /* 1296876 */   GIM_Try, /*On fail goto*//*Label 18613*/ GIMT_Encode4(1296960), // Rule ID 9019 //
     /* 1296881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1296884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1296898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1296901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296934 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1296937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296959 */     // GIR_Coverage, 9019,
     /* 1296959 */     GIR_EraseRootFromParent_Done,
     /* 1296960 */   // Label 18613: @1296960
     /* 1296960 */   GIM_Try, /*On fail goto*//*Label 18614*/ GIMT_Encode4(1297044), // Rule ID 9022 //
     /* 1296965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1296968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1296982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1296985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297018 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1297021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297043 */     // GIR_Coverage, 9022,
     /* 1297043 */     GIR_EraseRootFromParent_Done,
     /* 1297044 */   // Label 18614: @1297044
     /* 1297044 */   GIM_Try, /*On fail goto*//*Label 18615*/ GIMT_Encode4(1297128), // Rule ID 9023 //
     /* 1297049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1297052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1297060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1297063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1297066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1297069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297102 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1297105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297127 */     // GIR_Coverage, 9023,
     /* 1297127 */     GIR_EraseRootFromParent_Done,
     /* 1297128 */   // Label 18615: @1297128
     /* 1297128 */   GIM_Try, /*On fail goto*//*Label 18616*/ GIMT_Encode4(1297212), // Rule ID 9026 //
     /* 1297133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1297150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297186 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1297189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297211 */     // GIR_Coverage, 9026,
     /* 1297211 */     GIR_EraseRootFromParent_Done,
     /* 1297212 */   // Label 18616: @1297212
     /* 1297212 */   GIM_Try, /*On fail goto*//*Label 18617*/ GIMT_Encode4(1297296), // Rule ID 9027 //
     /* 1297217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1297234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297270 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1297273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297295 */     // GIR_Coverage, 9027,
     /* 1297295 */     GIR_EraseRootFromParent_Done,
     /* 1297296 */   // Label 18617: @1297296
     /* 1297296 */   GIM_Try, /*On fail goto*//*Label 18618*/ GIMT_Encode4(1297380), // Rule ID 9030 //
     /* 1297301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1297318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297354 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1297357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297379 */     // GIR_Coverage, 9030,
     /* 1297379 */     GIR_EraseRootFromParent_Done,
     /* 1297380 */   // Label 18618: @1297380
     /* 1297380 */   GIM_Try, /*On fail goto*//*Label 18619*/ GIMT_Encode4(1297464), // Rule ID 9031 //
     /* 1297385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1297402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297438 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1297441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297463 */     // GIR_Coverage, 9031,
     /* 1297463 */     GIR_EraseRootFromParent_Done,
     /* 1297464 */   // Label 18619: @1297464
     /* 1297464 */   GIM_Try, /*On fail goto*//*Label 18620*/ GIMT_Encode4(1297548), // Rule ID 9034 //
     /* 1297469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1297486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297522 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1297525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297547 */     // GIR_Coverage, 9034,
     /* 1297547 */     GIR_EraseRootFromParent_Done,
     /* 1297548 */   // Label 18620: @1297548
     /* 1297548 */   GIM_Try, /*On fail goto*//*Label 18621*/ GIMT_Encode4(1297632), // Rule ID 9035 //
     /* 1297553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1297570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297606 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1297609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297631 */     // GIR_Coverage, 9035,
     /* 1297631 */     GIR_EraseRootFromParent_Done,
     /* 1297632 */   // Label 18621: @1297632
     /* 1297632 */   GIM_Try, /*On fail goto*//*Label 18622*/ GIMT_Encode4(1297716), // Rule ID 9038 //
     /* 1297637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1297654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297690 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1297693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297715 */     // GIR_Coverage, 9038,
     /* 1297715 */     GIR_EraseRootFromParent_Done,
     /* 1297716 */   // Label 18622: @1297716
     /* 1297716 */   GIM_Try, /*On fail goto*//*Label 18623*/ GIMT_Encode4(1297800), // Rule ID 9039 //
     /* 1297721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1297738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297774 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1297777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297799 */     // GIR_Coverage, 9039,
     /* 1297799 */     GIR_EraseRootFromParent_Done,
     /* 1297800 */   // Label 18623: @1297800
     /* 1297800 */   GIM_Try, /*On fail goto*//*Label 18624*/ GIMT_Encode4(1297884), // Rule ID 9042 //
     /* 1297805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1297822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297858 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1297861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297883 */     // GIR_Coverage, 9042,
     /* 1297883 */     GIR_EraseRootFromParent_Done,
     /* 1297884 */   // Label 18624: @1297884
     /* 1297884 */   GIM_Try, /*On fail goto*//*Label 18625*/ GIMT_Encode4(1297968), // Rule ID 9043 //
     /* 1297889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1297906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297942 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1297945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297967 */     // GIR_Coverage, 9043,
     /* 1297967 */     GIR_EraseRootFromParent_Done,
     /* 1297968 */   // Label 18625: @1297968
     /* 1297968 */   GIM_Try, /*On fail goto*//*Label 18626*/ GIMT_Encode4(1298052), // Rule ID 9046 //
     /* 1297973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1297990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298026 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1298029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298051 */     // GIR_Coverage, 9046,
     /* 1298051 */     GIR_EraseRootFromParent_Done,
     /* 1298052 */   // Label 18626: @1298052
     /* 1298052 */   GIM_Try, /*On fail goto*//*Label 18627*/ GIMT_Encode4(1298136), // Rule ID 9047 //
     /* 1298057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1298065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1298074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298110 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1298113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298135 */     // GIR_Coverage, 9047,
     /* 1298135 */     GIR_EraseRootFromParent_Done,
     /* 1298136 */   // Label 18627: @1298136
     /* 1298136 */   GIM_Try, /*On fail goto*//*Label 18628*/ GIMT_Encode4(1298220), // Rule ID 9050 //
     /* 1298141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1298149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1298158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298194 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1298197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298219 */     // GIR_Coverage, 9050,
     /* 1298219 */     GIR_EraseRootFromParent_Done,
     /* 1298220 */   // Label 18628: @1298220
     /* 1298220 */   GIM_Try, /*On fail goto*//*Label 18629*/ GIMT_Encode4(1298304), // Rule ID 9051 //
     /* 1298225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1298233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1298242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298278 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1298281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298303 */     // GIR_Coverage, 9051,
     /* 1298303 */     GIR_EraseRootFromParent_Done,
     /* 1298304 */   // Label 18629: @1298304
     /* 1298304 */   GIM_Try, /*On fail goto*//*Label 18630*/ GIMT_Encode4(1298388), // Rule ID 9054 //
     /* 1298309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1298317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1298326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298362 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1298365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298387 */     // GIR_Coverage, 9054,
     /* 1298387 */     GIR_EraseRootFromParent_Done,
     /* 1298388 */   // Label 18630: @1298388
     /* 1298388 */   GIM_Try, /*On fail goto*//*Label 18631*/ GIMT_Encode4(1298472), // Rule ID 9055 //
     /* 1298393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1298401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1298410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298446 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1298449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298471 */     // GIR_Coverage, 9055,
     /* 1298471 */     GIR_EraseRootFromParent_Done,
     /* 1298472 */   // Label 18631: @1298472
     /* 1298472 */   GIM_Try, /*On fail goto*//*Label 18632*/ GIMT_Encode4(1298556), // Rule ID 9058 //
     /* 1298477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1298485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1298494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298530 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1298533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298555 */     // GIR_Coverage, 9058,
     /* 1298555 */     GIR_EraseRootFromParent_Done,
     /* 1298556 */   // Label 18632: @1298556
     /* 1298556 */   GIM_Try, /*On fail goto*//*Label 18633*/ GIMT_Encode4(1298640), // Rule ID 9059 //
     /* 1298561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1298569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1298578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298614 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1298617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298639 */     // GIR_Coverage, 9059,
     /* 1298639 */     GIR_EraseRootFromParent_Done,
     /* 1298640 */   // Label 18633: @1298640
     /* 1298640 */   GIM_Try, /*On fail goto*//*Label 18634*/ GIMT_Encode4(1298724), // Rule ID 9062 //
     /* 1298645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1298648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1298653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1298662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298698 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1298701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298723 */     // GIR_Coverage, 9062,
     /* 1298723 */     GIR_EraseRootFromParent_Done,
     /* 1298724 */   // Label 18634: @1298724
     /* 1298724 */   GIM_Try, /*On fail goto*//*Label 18635*/ GIMT_Encode4(1298808), // Rule ID 9063 //
     /* 1298729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1298732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1298737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1298746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298782 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1298785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298807 */     // GIR_Coverage, 9063,
     /* 1298807 */     GIR_EraseRootFromParent_Done,
     /* 1298808 */   // Label 18635: @1298808
     /* 1298808 */   GIM_Try, /*On fail goto*//*Label 18636*/ GIMT_Encode4(1298892), // Rule ID 9066 //
     /* 1298813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1298821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1298824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1298827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1298830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1298836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1298851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298866 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1298869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298891 */     // GIR_Coverage, 9066,
     /* 1298891 */     GIR_EraseRootFromParent_Done,
     /* 1298892 */   // Label 18636: @1298892
     /* 1298892 */   GIM_Try, /*On fail goto*//*Label 18637*/ GIMT_Encode4(1298976), // Rule ID 9067 //
     /* 1298897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1298905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1298908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1298911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1298914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1298920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1298935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298950 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1298953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298975 */     // GIR_Coverage, 9067,
     /* 1298975 */     GIR_EraseRootFromParent_Done,
     /* 1298976 */   // Label 18637: @1298976
     /* 1298976 */   GIM_Try, /*On fail goto*//*Label 18638*/ GIMT_Encode4(1299060), // Rule ID 9070 //
     /* 1298981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1298989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1298992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1298995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1298998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299034 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1299037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299059 */     // GIR_Coverage, 9070,
     /* 1299059 */     GIR_EraseRootFromParent_Done,
     /* 1299060 */   // Label 18638: @1299060
     /* 1299060 */   GIM_Try, /*On fail goto*//*Label 18639*/ GIMT_Encode4(1299144), // Rule ID 9071 //
     /* 1299065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1299073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1299082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299118 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1299121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299143 */     // GIR_Coverage, 9071,
     /* 1299143 */     GIR_EraseRootFromParent_Done,
     /* 1299144 */   // Label 18639: @1299144
     /* 1299144 */   GIM_Try, /*On fail goto*//*Label 18640*/ GIMT_Encode4(1299228), // Rule ID 9074 //
     /* 1299149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1299157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1299160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1299163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1299166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1299172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299202 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1299205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299227 */     // GIR_Coverage, 9074,
     /* 1299227 */     GIR_EraseRootFromParent_Done,
     /* 1299228 */   // Label 18640: @1299228
     /* 1299228 */   GIM_Try, /*On fail goto*//*Label 18641*/ GIMT_Encode4(1299312), // Rule ID 9075 //
     /* 1299233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1299241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1299244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1299247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1299250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1299256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299286 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1299289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299311 */     // GIR_Coverage, 9075,
     /* 1299311 */     GIR_EraseRootFromParent_Done,
     /* 1299312 */   // Label 18641: @1299312
     /* 1299312 */   GIM_Try, /*On fail goto*//*Label 18642*/ GIMT_Encode4(1299396), // Rule ID 9078 //
     /* 1299317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1299325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299370 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1299373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299395 */     // GIR_Coverage, 9078,
     /* 1299395 */     GIR_EraseRootFromParent_Done,
     /* 1299396 */   // Label 18642: @1299396
     /* 1299396 */   GIM_Try, /*On fail goto*//*Label 18643*/ GIMT_Encode4(1299480), // Rule ID 9079 //
     /* 1299401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1299409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299454 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1299457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299479 */     // GIR_Coverage, 9079,
     /* 1299479 */     GIR_EraseRootFromParent_Done,
     /* 1299480 */   // Label 18643: @1299480
     /* 1299480 */   GIM_Try, /*On fail goto*//*Label 18644*/ GIMT_Encode4(1299564), // Rule ID 9082 //
     /* 1299485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1299493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1299502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299538 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1299541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299563 */     // GIR_Coverage, 9082,
     /* 1299563 */     GIR_EraseRootFromParent_Done,
     /* 1299564 */   // Label 18644: @1299564
     /* 1299564 */   GIM_Try, /*On fail goto*//*Label 18645*/ GIMT_Encode4(1299648), // Rule ID 9083 //
     /* 1299569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1299577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1299586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299622 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1299625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299647 */     // GIR_Coverage, 9083,
     /* 1299647 */     GIR_EraseRootFromParent_Done,
     /* 1299648 */   // Label 18645: @1299648
     /* 1299648 */   GIM_Try, /*On fail goto*//*Label 18646*/ GIMT_Encode4(1299732), // Rule ID 9086 //
     /* 1299653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1299661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1299670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299706 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1299709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299731 */     // GIR_Coverage, 9086,
     /* 1299731 */     GIR_EraseRootFromParent_Done,
     /* 1299732 */   // Label 18646: @1299732
     /* 1299732 */   GIM_Try, /*On fail goto*//*Label 18647*/ GIMT_Encode4(1299816), // Rule ID 9087 //
     /* 1299737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1299745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1299754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299790 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1299793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299815 */     // GIR_Coverage, 9087,
     /* 1299815 */     GIR_EraseRootFromParent_Done,
     /* 1299816 */   // Label 18647: @1299816
     /* 1299816 */   GIM_Try, /*On fail goto*//*Label 18648*/ GIMT_Encode4(1299900), // Rule ID 9090 //
     /* 1299821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1299829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1299832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1299835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1299838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1299844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299874 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1299877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299899 */     // GIR_Coverage, 9090,
     /* 1299899 */     GIR_EraseRootFromParent_Done,
     /* 1299900 */   // Label 18648: @1299900
     /* 1299900 */   GIM_Try, /*On fail goto*//*Label 18649*/ GIMT_Encode4(1299984), // Rule ID 9091 //
     /* 1299905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1299913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1299916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1299919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1299922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1299928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299958 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1299961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299983 */     // GIR_Coverage, 9091,
     /* 1299983 */     GIR_EraseRootFromParent_Done,
     /* 1299984 */   // Label 18649: @1299984
     /* 1299984 */   GIM_Try, /*On fail goto*//*Label 18650*/ GIMT_Encode4(1300068), // Rule ID 9094 //
     /* 1299989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1299997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1300006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300042 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1300045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300067 */     // GIR_Coverage, 9094,
     /* 1300067 */     GIR_EraseRootFromParent_Done,
     /* 1300068 */   // Label 18650: @1300068
     /* 1300068 */   GIM_Try, /*On fail goto*//*Label 18651*/ GIMT_Encode4(1300152), // Rule ID 9095 //
     /* 1300073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1300081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1300090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300126 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1300129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300151 */     // GIR_Coverage, 9095,
     /* 1300151 */     GIR_EraseRootFromParent_Done,
     /* 1300152 */   // Label 18651: @1300152
     /* 1300152 */   GIM_Try, /*On fail goto*//*Label 18652*/ GIMT_Encode4(1300236), // Rule ID 9098 //
     /* 1300157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1300165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300210 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1300213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300235 */     // GIR_Coverage, 9098,
     /* 1300235 */     GIR_EraseRootFromParent_Done,
     /* 1300236 */   // Label 18652: @1300236
     /* 1300236 */   GIM_Try, /*On fail goto*//*Label 18653*/ GIMT_Encode4(1300320), // Rule ID 9099 //
     /* 1300241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1300249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300294 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1300297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300319 */     // GIR_Coverage, 9099,
     /* 1300319 */     GIR_EraseRootFromParent_Done,
     /* 1300320 */   // Label 18653: @1300320
     /* 1300320 */   GIM_Try, /*On fail goto*//*Label 18654*/ GIMT_Encode4(1300404), // Rule ID 9102 //
     /* 1300325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1300333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300378 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1300381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300403 */     // GIR_Coverage, 9102,
     /* 1300403 */     GIR_EraseRootFromParent_Done,
     /* 1300404 */   // Label 18654: @1300404
     /* 1300404 */   GIM_Try, /*On fail goto*//*Label 18655*/ GIMT_Encode4(1300488), // Rule ID 9103 //
     /* 1300409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1300417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300462 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1300465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300487 */     // GIR_Coverage, 9103,
     /* 1300487 */     GIR_EraseRootFromParent_Done,
     /* 1300488 */   // Label 18655: @1300488
     /* 1300488 */   GIM_Try, /*On fail goto*//*Label 18656*/ GIMT_Encode4(1300572), // Rule ID 9106 //
     /* 1300493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1300501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1300510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300546 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1300549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300571 */     // GIR_Coverage, 9106,
     /* 1300571 */     GIR_EraseRootFromParent_Done,
     /* 1300572 */   // Label 18656: @1300572
     /* 1300572 */   GIM_Try, /*On fail goto*//*Label 18657*/ GIMT_Encode4(1300656), // Rule ID 9107 //
     /* 1300577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1300585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1300594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300630 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1300633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300655 */     // GIR_Coverage, 9107,
     /* 1300655 */     GIR_EraseRootFromParent_Done,
     /* 1300656 */   // Label 18657: @1300656
     /* 1300656 */   GIM_Try, /*On fail goto*//*Label 18658*/ GIMT_Encode4(1300740), // Rule ID 9110 //
     /* 1300661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1300669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1300678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300714 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1300717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300739 */     // GIR_Coverage, 9110,
     /* 1300739 */     GIR_EraseRootFromParent_Done,
     /* 1300740 */   // Label 18658: @1300740
     /* 1300740 */   GIM_Try, /*On fail goto*//*Label 18659*/ GIMT_Encode4(1300824), // Rule ID 9111 //
     /* 1300745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1300753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1300762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300798 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1300801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300823 */     // GIR_Coverage, 9111,
     /* 1300823 */     GIR_EraseRootFromParent_Done,
     /* 1300824 */   // Label 18659: @1300824
     /* 1300824 */   GIM_Try, /*On fail goto*//*Label 18660*/ GIMT_Encode4(1300908), // Rule ID 9202 //
     /* 1300829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1300840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1300843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1300846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1300852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300882 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1300885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300907 */     // GIR_Coverage, 9202,
     /* 1300907 */     GIR_EraseRootFromParent_Done,
     /* 1300908 */   // Label 18660: @1300908
     /* 1300908 */   GIM_Try, /*On fail goto*//*Label 18661*/ GIMT_Encode4(1300992), // Rule ID 9203 //
     /* 1300913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1300924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1300927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1300930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1300936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300966 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1300969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300991 */     // GIR_Coverage, 9203,
     /* 1300991 */     GIR_EraseRootFromParent_Done,
     /* 1300992 */   // Label 18661: @1300992
     /* 1300992 */   GIM_Try, /*On fail goto*//*Label 18662*/ GIMT_Encode4(1301076), // Rule ID 9206 //
     /* 1300997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1301014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301050 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1301053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301075 */     // GIR_Coverage, 9206,
     /* 1301075 */     GIR_EraseRootFromParent_Done,
     /* 1301076 */   // Label 18662: @1301076
     /* 1301076 */   GIM_Try, /*On fail goto*//*Label 18663*/ GIMT_Encode4(1301160), // Rule ID 9207 //
     /* 1301081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1301098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301134 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1301137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301159 */     // GIR_Coverage, 9207,
     /* 1301159 */     GIR_EraseRootFromParent_Done,
     /* 1301160 */   // Label 18663: @1301160
     /* 1301160 */   GIM_Try, /*On fail goto*//*Label 18664*/ GIMT_Encode4(1301244), // Rule ID 9210 //
     /* 1301165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301218 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1301221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301243 */     // GIR_Coverage, 9210,
     /* 1301243 */     GIR_EraseRootFromParent_Done,
     /* 1301244 */   // Label 18664: @1301244
     /* 1301244 */   GIM_Try, /*On fail goto*//*Label 18665*/ GIMT_Encode4(1301328), // Rule ID 9211 //
     /* 1301249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301302 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1301305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301327 */     // GIR_Coverage, 9211,
     /* 1301327 */     GIR_EraseRootFromParent_Done,
     /* 1301328 */   // Label 18665: @1301328
     /* 1301328 */   GIM_Try, /*On fail goto*//*Label 18666*/ GIMT_Encode4(1301412), // Rule ID 9214 //
     /* 1301333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301386 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1301389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301411 */     // GIR_Coverage, 9214,
     /* 1301411 */     GIR_EraseRootFromParent_Done,
     /* 1301412 */   // Label 18666: @1301412
     /* 1301412 */   GIM_Try, /*On fail goto*//*Label 18667*/ GIMT_Encode4(1301496), // Rule ID 9215 //
     /* 1301417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301470 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1301473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301495 */     // GIR_Coverage, 9215,
     /* 1301495 */     GIR_EraseRootFromParent_Done,
     /* 1301496 */   // Label 18667: @1301496
     /* 1301496 */   GIM_Try, /*On fail goto*//*Label 18668*/ GIMT_Encode4(1301580), // Rule ID 9218 //
     /* 1301501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1301518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301554 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1301557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301579 */     // GIR_Coverage, 9218,
     /* 1301579 */     GIR_EraseRootFromParent_Done,
     /* 1301580 */   // Label 18668: @1301580
     /* 1301580 */   GIM_Try, /*On fail goto*//*Label 18669*/ GIMT_Encode4(1301664), // Rule ID 9219 //
     /* 1301585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1301602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301638 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1301641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301663 */     // GIR_Coverage, 9219,
     /* 1301663 */     GIR_EraseRootFromParent_Done,
     /* 1301664 */   // Label 18669: @1301664
     /* 1301664 */   GIM_Try, /*On fail goto*//*Label 18670*/ GIMT_Encode4(1301748), // Rule ID 9222 //
     /* 1301669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1301686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301722 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1301725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1301743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301747 */     // GIR_Coverage, 9222,
     /* 1301747 */     GIR_EraseRootFromParent_Done,
     /* 1301748 */   // Label 18670: @1301748
     /* 1301748 */   GIM_Try, /*On fail goto*//*Label 18671*/ GIMT_Encode4(1301832), // Rule ID 9223 //
     /* 1301753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1301770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301806 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1301809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1301827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301831 */     // GIR_Coverage, 9223,
     /* 1301831 */     GIR_EraseRootFromParent_Done,
     /* 1301832 */   // Label 18671: @1301832
     /* 1301832 */   GIM_Try, /*On fail goto*//*Label 18672*/ GIMT_Encode4(1301916), // Rule ID 9226 //
     /* 1301837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1301848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1301854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301890 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1301893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301915 */     // GIR_Coverage, 9226,
     /* 1301915 */     GIR_EraseRootFromParent_Done,
     /* 1301916 */   // Label 18672: @1301916
     /* 1301916 */   GIM_Try, /*On fail goto*//*Label 18673*/ GIMT_Encode4(1302000), // Rule ID 9227 //
     /* 1301921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1301932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1301938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301974 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1301977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301999 */     // GIR_Coverage, 9227,
     /* 1301999 */     GIR_EraseRootFromParent_Done,
     /* 1302000 */   // Label 18673: @1302000
     /* 1302000 */   GIM_Try, /*On fail goto*//*Label 18674*/ GIMT_Encode4(1302084), // Rule ID 9230 //
     /* 1302005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1302016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1302019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1302022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1302028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302058 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1302061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302083 */     // GIR_Coverage, 9230,
     /* 1302083 */     GIR_EraseRootFromParent_Done,
     /* 1302084 */   // Label 18674: @1302084
     /* 1302084 */   GIM_Try, /*On fail goto*//*Label 18675*/ GIMT_Encode4(1302168), // Rule ID 9231 //
     /* 1302089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1302100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1302103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1302106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1302112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302142 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1302145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302167 */     // GIR_Coverage, 9231,
     /* 1302167 */     GIR_EraseRootFromParent_Done,
     /* 1302168 */   // Label 18675: @1302168
     /* 1302168 */   GIM_Try, /*On fail goto*//*Label 18676*/ GIMT_Encode4(1302252), // Rule ID 9234 //
     /* 1302173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302226 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1302229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302251 */     // GIR_Coverage, 9234,
     /* 1302251 */     GIR_EraseRootFromParent_Done,
     /* 1302252 */   // Label 18676: @1302252
     /* 1302252 */   GIM_Try, /*On fail goto*//*Label 18677*/ GIMT_Encode4(1302336), // Rule ID 9235 //
     /* 1302257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302310 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1302313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302335 */     // GIR_Coverage, 9235,
     /* 1302335 */     GIR_EraseRootFromParent_Done,
     /* 1302336 */   // Label 18677: @1302336
     /* 1302336 */   GIM_Try, /*On fail goto*//*Label 18678*/ GIMT_Encode4(1302420), // Rule ID 9238 //
     /* 1302341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1302344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302394 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1302397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302419 */     // GIR_Coverage, 9238,
     /* 1302419 */     GIR_EraseRootFromParent_Done,
     /* 1302420 */   // Label 18678: @1302420
     /* 1302420 */   GIM_Try, /*On fail goto*//*Label 18679*/ GIMT_Encode4(1302504), // Rule ID 9239 //
     /* 1302425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1302428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302478 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1302481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302503 */     // GIR_Coverage, 9239,
     /* 1302503 */     GIR_EraseRootFromParent_Done,
     /* 1302504 */   // Label 18679: @1302504
     /* 1302504 */   GIM_Try, /*On fail goto*//*Label 18680*/ GIMT_Encode4(1302588), // Rule ID 9242 //
     /* 1302509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1302520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1302523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1302526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1302532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302562 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1302565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302587 */     // GIR_Coverage, 9242,
     /* 1302587 */     GIR_EraseRootFromParent_Done,
     /* 1302588 */   // Label 18680: @1302588
     /* 1302588 */   GIM_Try, /*On fail goto*//*Label 18681*/ GIMT_Encode4(1302672), // Rule ID 9243 //
     /* 1302593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1302604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1302607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1302610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1302616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302646 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1302649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302671 */     // GIR_Coverage, 9243,
     /* 1302671 */     GIR_EraseRootFromParent_Done,
     /* 1302672 */   // Label 18681: @1302672
     /* 1302672 */   GIM_Try, /*On fail goto*//*Label 18682*/ GIMT_Encode4(1302756), // Rule ID 9246 //
     /* 1302677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1302688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1302691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1302694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1302700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1302715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302730 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1302733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302755 */     // GIR_Coverage, 9246,
     /* 1302755 */     GIR_EraseRootFromParent_Done,
     /* 1302756 */   // Label 18682: @1302756
     /* 1302756 */   GIM_Try, /*On fail goto*//*Label 18683*/ GIMT_Encode4(1302840), // Rule ID 9247 //
     /* 1302761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1302772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1302775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1302778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1302784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1302799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302814 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1302817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302839 */     // GIR_Coverage, 9247,
     /* 1302839 */     GIR_EraseRootFromParent_Done,
     /* 1302840 */   // Label 18683: @1302840
     /* 1302840 */   GIM_Try, /*On fail goto*//*Label 18684*/ GIMT_Encode4(1302924), // Rule ID 9250 //
     /* 1302845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1302856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1302859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1302862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1302868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1302883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302898 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1302901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302923 */     // GIR_Coverage, 9250,
     /* 1302923 */     GIR_EraseRootFromParent_Done,
     /* 1302924 */   // Label 18684: @1302924
     /* 1302924 */   GIM_Try, /*On fail goto*//*Label 18685*/ GIMT_Encode4(1303008), // Rule ID 9251 //
     /* 1302929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1302940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1302943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1302946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1302952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1302967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302982 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1302985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303007 */     // GIR_Coverage, 9251,
     /* 1303007 */     GIR_EraseRootFromParent_Done,
     /* 1303008 */   // Label 18685: @1303008
     /* 1303008 */   GIM_Try, /*On fail goto*//*Label 18686*/ GIMT_Encode4(1303092), // Rule ID 9254 //
     /* 1303013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1303030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303066 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1303069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303091 */     // GIR_Coverage, 9254,
     /* 1303091 */     GIR_EraseRootFromParent_Done,
     /* 1303092 */   // Label 18686: @1303092
     /* 1303092 */   GIM_Try, /*On fail goto*//*Label 18687*/ GIMT_Encode4(1303176), // Rule ID 9255 //
     /* 1303097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1303114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303150 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1303153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303175 */     // GIR_Coverage, 9255,
     /* 1303175 */     GIR_EraseRootFromParent_Done,
     /* 1303176 */   // Label 18687: @1303176
     /* 1303176 */   GIM_Try, /*On fail goto*//*Label 18688*/ GIMT_Encode4(1303260), // Rule ID 9258 //
     /* 1303181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303234 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1303237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303259 */     // GIR_Coverage, 9258,
     /* 1303259 */     GIR_EraseRootFromParent_Done,
     /* 1303260 */   // Label 18688: @1303260
     /* 1303260 */   GIM_Try, /*On fail goto*//*Label 18689*/ GIMT_Encode4(1303344), // Rule ID 9259 //
     /* 1303265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303318 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1303321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303343 */     // GIR_Coverage, 9259,
     /* 1303343 */     GIR_EraseRootFromParent_Done,
     /* 1303344 */   // Label 18689: @1303344
     /* 1303344 */   GIM_Try, /*On fail goto*//*Label 18690*/ GIMT_Encode4(1303428), // Rule ID 9262 //
     /* 1303349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303402 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1303405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303427 */     // GIR_Coverage, 9262,
     /* 1303427 */     GIR_EraseRootFromParent_Done,
     /* 1303428 */   // Label 18690: @1303428
     /* 1303428 */   GIM_Try, /*On fail goto*//*Label 18691*/ GIMT_Encode4(1303512), // Rule ID 9263 //
     /* 1303433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303486 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1303489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303511 */     // GIR_Coverage, 9263,
     /* 1303511 */     GIR_EraseRootFromParent_Done,
     /* 1303512 */   // Label 18691: @1303512
     /* 1303512 */   GIM_Try, /*On fail goto*//*Label 18692*/ GIMT_Encode4(1303596), // Rule ID 9266 //
     /* 1303517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1303528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1303531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1303534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1303540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303570 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1303573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303595 */     // GIR_Coverage, 9266,
     /* 1303595 */     GIR_EraseRootFromParent_Done,
     /* 1303596 */   // Label 18692: @1303596
     /* 1303596 */   GIM_Try, /*On fail goto*//*Label 18693*/ GIMT_Encode4(1303680), // Rule ID 9267 //
     /* 1303601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1303612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1303615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1303618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1303624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303654 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1303657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303679 */     // GIR_Coverage, 9267,
     /* 1303679 */     GIR_EraseRootFromParent_Done,
     /* 1303680 */   // Label 18693: @1303680
     /* 1303680 */   GIM_Try, /*On fail goto*//*Label 18694*/ GIMT_Encode4(1303764), // Rule ID 9270 //
     /* 1303685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1303702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1303741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303763 */     // GIR_Coverage, 9270,
     /* 1303763 */     GIR_EraseRootFromParent_Done,
     /* 1303764 */   // Label 18694: @1303764
     /* 1303764 */   GIM_Try, /*On fail goto*//*Label 18695*/ GIMT_Encode4(1303848), // Rule ID 9271 //
     /* 1303769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1303786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303822 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1303825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303847 */     // GIR_Coverage, 9271,
     /* 1303847 */     GIR_EraseRootFromParent_Done,
     /* 1303848 */   // Label 18695: @1303848
     /* 1303848 */   GIM_Try, /*On fail goto*//*Label 18696*/ GIMT_Encode4(1303932), // Rule ID 9274 //
     /* 1303853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1303870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303906 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1303909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303931 */     // GIR_Coverage, 9274,
     /* 1303931 */     GIR_EraseRootFromParent_Done,
     /* 1303932 */   // Label 18696: @1303932
     /* 1303932 */   GIM_Try, /*On fail goto*//*Label 18697*/ GIMT_Encode4(1304016), // Rule ID 9275 //
     /* 1303937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1303954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303990 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1303993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304015 */     // GIR_Coverage, 9275,
     /* 1304015 */     GIR_EraseRootFromParent_Done,
     /* 1304016 */   // Label 18697: @1304016
     /* 1304016 */   GIM_Try, /*On fail goto*//*Label 18698*/ GIMT_Encode4(1304100), // Rule ID 9278 //
     /* 1304021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1304038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304074 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1304077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304099 */     // GIR_Coverage, 9278,
     /* 1304099 */     GIR_EraseRootFromParent_Done,
     /* 1304100 */   // Label 18698: @1304100
     /* 1304100 */   GIM_Try, /*On fail goto*//*Label 18699*/ GIMT_Encode4(1304184), // Rule ID 9279 //
     /* 1304105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1304122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304158 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1304161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304183 */     // GIR_Coverage, 9279,
     /* 1304183 */     GIR_EraseRootFromParent_Done,
     /* 1304184 */   // Label 18699: @1304184
     /* 1304184 */   GIM_Try, /*On fail goto*//*Label 18700*/ GIMT_Encode4(1304268), // Rule ID 9282 //
     /* 1304189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304242 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1304245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304267 */     // GIR_Coverage, 9282,
     /* 1304267 */     GIR_EraseRootFromParent_Done,
     /* 1304268 */   // Label 18700: @1304268
     /* 1304268 */   GIM_Try, /*On fail goto*//*Label 18701*/ GIMT_Encode4(1304352), // Rule ID 9283 //
     /* 1304273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304326 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1304329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304351 */     // GIR_Coverage, 9283,
     /* 1304351 */     GIR_EraseRootFromParent_Done,
     /* 1304352 */   // Label 18701: @1304352
     /* 1304352 */   GIM_Try, /*On fail goto*//*Label 18702*/ GIMT_Encode4(1304436), // Rule ID 9286 //
     /* 1304357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304410 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1304413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304435 */     // GIR_Coverage, 9286,
     /* 1304435 */     GIR_EraseRootFromParent_Done,
     /* 1304436 */   // Label 18702: @1304436
     /* 1304436 */   GIM_Try, /*On fail goto*//*Label 18703*/ GIMT_Encode4(1304520), // Rule ID 9287 //
     /* 1304441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304494 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1304497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304519 */     // GIR_Coverage, 9287,
     /* 1304519 */     GIR_EraseRootFromParent_Done,
     /* 1304520 */   // Label 18703: @1304520
     /* 1304520 */   GIM_Try, /*On fail goto*//*Label 18704*/ GIMT_Encode4(1304604), // Rule ID 9378 //
     /* 1304525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1304536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1304539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1304542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1304548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304578 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1304581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304603 */     // GIR_Coverage, 9378,
     /* 1304603 */     GIR_EraseRootFromParent_Done,
     /* 1304604 */   // Label 18704: @1304604
     /* 1304604 */   GIM_Try, /*On fail goto*//*Label 18705*/ GIMT_Encode4(1304688), // Rule ID 9379 //
     /* 1304609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1304620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1304623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1304626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1304632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304662 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1304665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304687 */     // GIR_Coverage, 9379,
     /* 1304687 */     GIR_EraseRootFromParent_Done,
     /* 1304688 */   // Label 18705: @1304688
     /* 1304688 */   GIM_Try, /*On fail goto*//*Label 18706*/ GIMT_Encode4(1304772), // Rule ID 9382 //
     /* 1304693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1304710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304746 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1304749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304771 */     // GIR_Coverage, 9382,
     /* 1304771 */     GIR_EraseRootFromParent_Done,
     /* 1304772 */   // Label 18706: @1304772
     /* 1304772 */   GIM_Try, /*On fail goto*//*Label 18707*/ GIMT_Encode4(1304856), // Rule ID 9383 //
     /* 1304777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1304794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304830 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1304833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304855 */     // GIR_Coverage, 9383,
     /* 1304855 */     GIR_EraseRootFromParent_Done,
     /* 1304856 */   // Label 18707: @1304856
     /* 1304856 */   GIM_Try, /*On fail goto*//*Label 18708*/ GIMT_Encode4(1304940), // Rule ID 9386 //
     /* 1304861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1304878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304914 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1304917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304939 */     // GIR_Coverage, 9386,
     /* 1304939 */     GIR_EraseRootFromParent_Done,
     /* 1304940 */   // Label 18708: @1304940
     /* 1304940 */   GIM_Try, /*On fail goto*//*Label 18709*/ GIMT_Encode4(1305024), // Rule ID 9387 //
     /* 1304945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1304962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304998 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1305001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1305009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305023 */     // GIR_Coverage, 9387,
     /* 1305023 */     GIR_EraseRootFromParent_Done,
     /* 1305024 */   // Label 18709: @1305024
     /* 1305024 */   GIM_Try, /*On fail goto*//*Label 18710*/ GIMT_Encode4(1305108), // Rule ID 9390 //
     /* 1305029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1305046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1305049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1305071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305082 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1305085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1305093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305107 */     // GIR_Coverage, 9390,
     /* 1305107 */     GIR_EraseRootFromParent_Done,
     /* 1305108 */   // Label 18710: @1305108
     /* 1305108 */   GIM_Try, /*On fail goto*//*Label 18711*/ GIMT_Encode4(1305192), // Rule ID 9391 //
     /* 1305113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1305130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1305133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1305155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305166 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1305169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1305177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305191 */     // GIR_Coverage, 9391,
     /* 1305191 */     GIR_EraseRootFromParent_Done,
     /* 1305192 */   // Label 18711: @1305192
     /* 1305192 */   GIM_Try, /*On fail goto*//*Label 18712*/ GIMT_Encode4(1305276), // Rule ID 9394 //
     /* 1305197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1305214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1305217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1305239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305250 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1305253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1305261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305275 */     // GIR_Coverage, 9394,
     /* 1305275 */     GIR_EraseRootFromParent_Done,
     /* 1305276 */   // Label 18712: @1305276
     /* 1305276 */   GIM_Try, /*On fail goto*//*Label 18713*/ GIMT_Encode4(1305360), // Rule ID 9395 //
     /* 1305281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1305298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1305301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1305323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305334 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1305337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1305345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305359 */     // GIR_Coverage, 9395,
     /* 1305359 */     GIR_EraseRootFromParent_Done,
     /* 1305360 */   // Label 18713: @1305360
     /* 1305360 */   GIM_Try, /*On fail goto*//*Label 18714*/ GIMT_Encode4(1305444), // Rule ID 9398 //
     /* 1305365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1305385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1305407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305418 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1305421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1305429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305443 */     // GIR_Coverage, 9398,
     /* 1305443 */     GIR_EraseRootFromParent_Done,
     /* 1305444 */   // Label 18714: @1305444
     /* 1305444 */   GIM_Try, /*On fail goto*//*Label 18715*/ GIMT_Encode4(1305528), // Rule ID 9399 //
     /* 1305449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1305469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1305491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305502 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1305505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1305513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305527 */     // GIR_Coverage, 9399,
     /* 1305527 */     GIR_EraseRootFromParent_Done,
     /* 1305528 */   // Label 18715: @1305528
     /* 1305528 */   GIM_Try, /*On fail goto*//*Label 18716*/ GIMT_Encode4(1305612), // Rule ID 9402 //
     /* 1305533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1305544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1305547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1305550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1305553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1305556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1305575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305586 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1305589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1305597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305611 */     // GIR_Coverage, 9402,
     /* 1305611 */     GIR_EraseRootFromParent_Done,
     /* 1305612 */   // Label 18716: @1305612
     /* 1305612 */   GIM_Try, /*On fail goto*//*Label 18717*/ GIMT_Encode4(1305696), // Rule ID 9403 //
     /* 1305617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1305628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1305631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1305634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1305637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1305640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1305659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305670 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1305673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1305681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305695 */     // GIR_Coverage, 9403,
     /* 1305695 */     GIR_EraseRootFromParent_Done,
     /* 1305696 */   // Label 18717: @1305696
     /* 1305696 */   GIM_Try, /*On fail goto*//*Label 18718*/ GIMT_Encode4(1305780), // Rule ID 9406 //
     /* 1305701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1305718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1305721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1305743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305754 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1305757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1305765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305779 */     // GIR_Coverage, 9406,
     /* 1305779 */     GIR_EraseRootFromParent_Done,
     /* 1305780 */   // Label 18718: @1305780
     /* 1305780 */   GIM_Try, /*On fail goto*//*Label 18719*/ GIMT_Encode4(1305864), // Rule ID 9407 //
     /* 1305785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1305802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1305805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1305827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305838 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1305841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1305849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305863 */     // GIR_Coverage, 9407,
     /* 1305863 */     GIR_EraseRootFromParent_Done,
     /* 1305864 */   // Label 18719: @1305864
     /* 1305864 */   GIM_Try, /*On fail goto*//*Label 18720*/ GIMT_Encode4(1305948), // Rule ID 9410 //
     /* 1305869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1305886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1305889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1305911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305922 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1305925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1305931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1305933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305947 */     // GIR_Coverage, 9410,
     /* 1305947 */     GIR_EraseRootFromParent_Done,
     /* 1305948 */   // Label 18720: @1305948
     /* 1305948 */   GIM_Try, /*On fail goto*//*Label 18721*/ GIMT_Encode4(1306032), // Rule ID 9411 //
     /* 1305953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1305970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1305973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1305995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306006 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1306009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1306015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1306017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306031 */     // GIR_Coverage, 9411,
     /* 1306031 */     GIR_EraseRootFromParent_Done,
     /* 1306032 */   // Label 18721: @1306032
     /* 1306032 */   GIM_Try, /*On fail goto*//*Label 18722*/ GIMT_Encode4(1306116), // Rule ID 9414 //
     /* 1306037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1306040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1306048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1306051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1306054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1306057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1306060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1306079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306090 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1306093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1306099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1306101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1306111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306115 */     // GIR_Coverage, 9414,
     /* 1306115 */     GIR_EraseRootFromParent_Done,
     /* 1306116 */   // Label 18722: @1306116
     /* 1306116 */   GIM_Try, /*On fail goto*//*Label 18723*/ GIMT_Encode4(1306200), // Rule ID 9415 //
     /* 1306121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1306124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1306132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1306135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1306138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1306141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1306144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1306163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306174 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1306177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1306183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1306185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1306195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306199 */     // GIR_Coverage, 9415,
     /* 1306199 */     GIR_EraseRootFromParent_Done,
     /* 1306200 */   // Label 18723: @1306200
     /* 1306200 */   GIM_Try, /*On fail goto*//*Label 18724*/ GIMT_Encode4(1306284), // Rule ID 9418 //
     /* 1306205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1306222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1306225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1306247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306258 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1306261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1306267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1306269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306283 */     // GIR_Coverage, 9418,
     /* 1306283 */     GIR_EraseRootFromParent_Done,
     /* 1306284 */   // Label 18724: @1306284
     /* 1306284 */   GIM_Try, /*On fail goto*//*Label 18725*/ GIMT_Encode4(1306368), // Rule ID 9419 //
     /* 1306289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1306306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1306309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1306331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306342 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1306345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1306351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1306353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306367 */     // GIR_Coverage, 9419,
     /* 1306367 */     GIR_EraseRootFromParent_Done,
     /* 1306368 */   // Label 18725: @1306368
     /* 1306368 */   GIM_Try, /*On fail goto*//*Label 18726*/ GIMT_Encode4(1306452), // Rule ID 9422 //
     /* 1306373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1306390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1306393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1306415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306426 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1306429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1306435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1306437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306451 */     // GIR_Coverage, 9422,
     /* 1306451 */     GIR_EraseRootFromParent_Done,
     /* 1306452 */   // Label 18726: @1306452
     /* 1306452 */   GIM_Try, /*On fail goto*//*Label 18727*/ GIMT_Encode4(1306536), // Rule ID 9423 //
     /* 1306457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1306474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1306477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1306499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306510 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1306513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1306519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1306521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306535 */     // GIR_Coverage, 9423,
     /* 1306535 */     GIR_EraseRootFromParent_Done,
     /* 1306536 */   // Label 18727: @1306536
     /* 1306536 */   GIM_Try, /*On fail goto*//*Label 18728*/ GIMT_Encode4(1306620), // Rule ID 9426 //
     /* 1306541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1306552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1306555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1306558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1306561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1306564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1306583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306594 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1306597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1306603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1306605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306619 */     // GIR_Coverage, 9426,
     /* 1306619 */     GIR_EraseRootFromParent_Done,
     /* 1306620 */   // Label 18728: @1306620
     /* 1306620 */   GIM_Try, /*On fail goto*//*Label 18729*/ GIMT_Encode4(1306704), // Rule ID 9427 //
     /* 1306625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1306636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1306639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1306642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1306645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1306648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1306667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306678 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1306681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1306687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1306689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306703 */     // GIR_Coverage, 9427,
     /* 1306703 */     GIR_EraseRootFromParent_Done,
     /* 1306704 */   // Label 18729: @1306704
     /* 1306704 */   GIM_Try, /*On fail goto*//*Label 18730*/ GIMT_Encode4(1306788), // Rule ID 9430 //
     /* 1306709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1306726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1306729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1306751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306762 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1306765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1306771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1306773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306787 */     // GIR_Coverage, 9430,
     /* 1306787 */     GIR_EraseRootFromParent_Done,
     /* 1306788 */   // Label 18730: @1306788
     /* 1306788 */   GIM_Try, /*On fail goto*//*Label 18731*/ GIMT_Encode4(1306872), // Rule ID 9431 //
     /* 1306793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1306810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1306813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1306835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306846 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1306849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1306855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1306857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306871 */     // GIR_Coverage, 9431,
     /* 1306871 */     GIR_EraseRootFromParent_Done,
     /* 1306872 */   // Label 18731: @1306872
     /* 1306872 */   GIM_Try, /*On fail goto*//*Label 18732*/ GIMT_Encode4(1306956), // Rule ID 9434 //
     /* 1306877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1306894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1306897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1306919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306930 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1306933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1306939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1306941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306955 */     // GIR_Coverage, 9434,
     /* 1306955 */     GIR_EraseRootFromParent_Done,
     /* 1306956 */   // Label 18732: @1306956
     /* 1306956 */   GIM_Try, /*On fail goto*//*Label 18733*/ GIMT_Encode4(1307040), // Rule ID 9435 //
     /* 1306961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1306978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1306981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1307003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307014 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1307017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1307023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1307025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307039 */     // GIR_Coverage, 9435,
     /* 1307039 */     GIR_EraseRootFromParent_Done,
     /* 1307040 */   // Label 18733: @1307040
     /* 1307040 */   GIM_Try, /*On fail goto*//*Label 18734*/ GIMT_Encode4(1307124), // Rule ID 9438 //
     /* 1307045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1307056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1307059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1307062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1307065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1307068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1307087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307098 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1307101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1307107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1307109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307123 */     // GIR_Coverage, 9438,
     /* 1307123 */     GIR_EraseRootFromParent_Done,
     /* 1307124 */   // Label 18734: @1307124
     /* 1307124 */   GIM_Try, /*On fail goto*//*Label 18735*/ GIMT_Encode4(1307208), // Rule ID 9439 //
     /* 1307129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1307140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1307143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1307146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1307149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1307152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1307171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307182 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1307185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1307191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1307193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307207 */     // GIR_Coverage, 9439,
     /* 1307207 */     GIR_EraseRootFromParent_Done,
     /* 1307208 */   // Label 18735: @1307208
     /* 1307208 */   GIM_Try, /*On fail goto*//*Label 18736*/ GIMT_Encode4(1307292), // Rule ID 9442 //
     /* 1307213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1307230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1307233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1307255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307266 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1307269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1307275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1307277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307291 */     // GIR_Coverage, 9442,
     /* 1307291 */     GIR_EraseRootFromParent_Done,
     /* 1307292 */   // Label 18736: @1307292
     /* 1307292 */   GIM_Try, /*On fail goto*//*Label 18737*/ GIMT_Encode4(1307376), // Rule ID 9443 //
     /* 1307297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1307314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1307317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1307339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307350 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1307353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1307359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1307361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307375 */     // GIR_Coverage, 9443,
     /* 1307375 */     GIR_EraseRootFromParent_Done,
     /* 1307376 */   // Label 18737: @1307376
     /* 1307376 */   GIM_Try, /*On fail goto*//*Label 18738*/ GIMT_Encode4(1307460), // Rule ID 9446 //
     /* 1307381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1307398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1307401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1307423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307434 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1307437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1307443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1307445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307459 */     // GIR_Coverage, 9446,
     /* 1307459 */     GIR_EraseRootFromParent_Done,
     /* 1307460 */   // Label 18738: @1307460
     /* 1307460 */   GIM_Try, /*On fail goto*//*Label 18739*/ GIMT_Encode4(1307544), // Rule ID 9447 //
     /* 1307465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1307482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1307485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1307507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307518 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1307521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1307527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1307529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307543 */     // GIR_Coverage, 9447,
     /* 1307543 */     GIR_EraseRootFromParent_Done,
     /* 1307544 */   // Label 18739: @1307544
     /* 1307544 */   GIM_Try, /*On fail goto*//*Label 18740*/ GIMT_Encode4(1307628), // Rule ID 9450 //
     /* 1307549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1307566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1307569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1307591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307602 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1307605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1307611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1307613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307627 */     // GIR_Coverage, 9450,
     /* 1307627 */     GIR_EraseRootFromParent_Done,
     /* 1307628 */   // Label 18740: @1307628
     /* 1307628 */   GIM_Try, /*On fail goto*//*Label 18741*/ GIMT_Encode4(1307712), // Rule ID 9451 //
     /* 1307633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1307650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1307653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1307675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307686 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1307689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1307695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1307697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307711 */     // GIR_Coverage, 9451,
     /* 1307711 */     GIR_EraseRootFromParent_Done,
     /* 1307712 */   // Label 18741: @1307712
     /* 1307712 */   GIM_Try, /*On fail goto*//*Label 18742*/ GIMT_Encode4(1307796), // Rule ID 9454 //
     /* 1307717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1307720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1307728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1307731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1307734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1307737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1307740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1307759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307770 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1307773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1307779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1307781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307795 */     // GIR_Coverage, 9454,
     /* 1307795 */     GIR_EraseRootFromParent_Done,
     /* 1307796 */   // Label 18742: @1307796
     /* 1307796 */   GIM_Try, /*On fail goto*//*Label 18743*/ GIMT_Encode4(1307880), // Rule ID 9455 //
     /* 1307801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1307804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1307812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1307815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1307818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1307821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1307824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1307843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307854 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1307857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1307863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1307865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307879 */     // GIR_Coverage, 9455,
     /* 1307879 */     GIR_EraseRootFromParent_Done,
     /* 1307880 */   // Label 18743: @1307880
     /* 1307880 */   GIM_Try, /*On fail goto*//*Label 18744*/ GIMT_Encode4(1307964), // Rule ID 9458 //
     /* 1307885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1307888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1307902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1307905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1307927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307938 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1307941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1307947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1307949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307963 */     // GIR_Coverage, 9458,
     /* 1307963 */     GIR_EraseRootFromParent_Done,
     /* 1307964 */   // Label 18744: @1307964
     /* 1307964 */   GIM_Try, /*On fail goto*//*Label 18745*/ GIMT_Encode4(1308048), // Rule ID 9459 //
     /* 1307969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1307972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1307986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1307989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1308011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308022 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1308025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1308031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1308033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308047 */     // GIR_Coverage, 9459,
     /* 1308047 */     GIR_EraseRootFromParent_Done,
     /* 1308048 */   // Label 18745: @1308048
     /* 1308048 */   GIM_Try, /*On fail goto*//*Label 18746*/ GIMT_Encode4(1308132), // Rule ID 9462 //
     /* 1308053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1308056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1308064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1308067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1308070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1308073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1308076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1308095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308106 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1308109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1308115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1308117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308131 */     // GIR_Coverage, 9462,
     /* 1308131 */     GIR_EraseRootFromParent_Done,
     /* 1308132 */   // Label 18746: @1308132
     /* 1308132 */   GIM_Try, /*On fail goto*//*Label 18747*/ GIMT_Encode4(1308216), // Rule ID 9463 //
     /* 1308137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1308140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1308148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1308151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1308154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1308157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1308160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1308179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308190 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1308193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1308199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1308201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308215 */     // GIR_Coverage, 9463,
     /* 1308215 */     GIR_EraseRootFromParent_Done,
     /* 1308216 */   // Label 18747: @1308216
     /* 1308216 */   GIM_Try, /*On fail goto*//*Label 18748*/ GIMT_Encode4(1308300), // Rule ID 9554 //
     /* 1308221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1308238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1308241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308274 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1308277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308299 */     // GIR_Coverage, 9554,
     /* 1308299 */     GIR_EraseRootFromParent_Done,
     /* 1308300 */   // Label 18748: @1308300
     /* 1308300 */   GIM_Try, /*On fail goto*//*Label 18749*/ GIMT_Encode4(1308384), // Rule ID 9555 //
     /* 1308305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1308322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1308325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308358 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1308361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308383 */     // GIR_Coverage, 9555,
     /* 1308383 */     GIR_EraseRootFromParent_Done,
     /* 1308384 */   // Label 18749: @1308384
     /* 1308384 */   GIM_Try, /*On fail goto*//*Label 18750*/ GIMT_Encode4(1308468), // Rule ID 9558 //
     /* 1308389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1308406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1308409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308442 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1308445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308467 */     // GIR_Coverage, 9558,
     /* 1308467 */     GIR_EraseRootFromParent_Done,
     /* 1308468 */   // Label 18750: @1308468
     /* 1308468 */   GIM_Try, /*On fail goto*//*Label 18751*/ GIMT_Encode4(1308552), // Rule ID 9559 //
     /* 1308473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1308490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1308493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308526 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1308529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308551 */     // GIR_Coverage, 9559,
     /* 1308551 */     GIR_EraseRootFromParent_Done,
     /* 1308552 */   // Label 18751: @1308552
     /* 1308552 */   GIM_Try, /*On fail goto*//*Label 18752*/ GIMT_Encode4(1308636), // Rule ID 9562 //
     /* 1308557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1308574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1308577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308610 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1308613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308635 */     // GIR_Coverage, 9562,
     /* 1308635 */     GIR_EraseRootFromParent_Done,
     /* 1308636 */   // Label 18752: @1308636
     /* 1308636 */   GIM_Try, /*On fail goto*//*Label 18753*/ GIMT_Encode4(1308720), // Rule ID 9563 //
     /* 1308641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1308658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1308661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308694 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1308697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308719 */     // GIR_Coverage, 9563,
     /* 1308719 */     GIR_EraseRootFromParent_Done,
     /* 1308720 */   // Label 18753: @1308720
     /* 1308720 */   GIM_Try, /*On fail goto*//*Label 18754*/ GIMT_Encode4(1308804), // Rule ID 9566 //
     /* 1308725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1308742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1308745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308778 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1308781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308803 */     // GIR_Coverage, 9566,
     /* 1308803 */     GIR_EraseRootFromParent_Done,
     /* 1308804 */   // Label 18754: @1308804
     /* 1308804 */   GIM_Try, /*On fail goto*//*Label 18755*/ GIMT_Encode4(1308888), // Rule ID 9567 //
     /* 1308809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1308826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1308829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308862 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1308865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308887 */     // GIR_Coverage, 9567,
     /* 1308887 */     GIR_EraseRootFromParent_Done,
     /* 1308888 */   // Label 18755: @1308888
     /* 1308888 */   GIM_Try, /*On fail goto*//*Label 18756*/ GIMT_Encode4(1308972), // Rule ID 9570 //
     /* 1308893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1308910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1308913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308946 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1308949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308971 */     // GIR_Coverage, 9570,
     /* 1308971 */     GIR_EraseRootFromParent_Done,
     /* 1308972 */   // Label 18756: @1308972
     /* 1308972 */   GIM_Try, /*On fail goto*//*Label 18757*/ GIMT_Encode4(1309056), // Rule ID 9571 //
     /* 1308977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1308994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1308997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309030 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1309033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309055 */     // GIR_Coverage, 9571,
     /* 1309055 */     GIR_EraseRootFromParent_Done,
     /* 1309056 */   // Label 18757: @1309056
     /* 1309056 */   GIM_Try, /*On fail goto*//*Label 18758*/ GIMT_Encode4(1309140), // Rule ID 9574 //
     /* 1309061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1309069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1309072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1309075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1309078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1309081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1309084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309114 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1309117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309139 */     // GIR_Coverage, 9574,
     /* 1309139 */     GIR_EraseRootFromParent_Done,
     /* 1309140 */   // Label 18758: @1309140
     /* 1309140 */   GIM_Try, /*On fail goto*//*Label 18759*/ GIMT_Encode4(1309224), // Rule ID 9575 //
     /* 1309145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1309153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1309156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1309159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1309162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1309165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1309168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309198 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1309201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309223 */     // GIR_Coverage, 9575,
     /* 1309223 */     GIR_EraseRootFromParent_Done,
     /* 1309224 */   // Label 18759: @1309224
     /* 1309224 */   GIM_Try, /*On fail goto*//*Label 18760*/ GIMT_Encode4(1309308), // Rule ID 9578 //
     /* 1309229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1309237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1309246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1309249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309282 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1309285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309307 */     // GIR_Coverage, 9578,
     /* 1309307 */     GIR_EraseRootFromParent_Done,
     /* 1309308 */   // Label 18760: @1309308
     /* 1309308 */   GIM_Try, /*On fail goto*//*Label 18761*/ GIMT_Encode4(1309392), // Rule ID 9579 //
     /* 1309313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1309321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1309330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1309333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309366 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1309369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309391 */     // GIR_Coverage, 9579,
     /* 1309391 */     GIR_EraseRootFromParent_Done,
     /* 1309392 */   // Label 18761: @1309392
     /* 1309392 */   GIM_Try, /*On fail goto*//*Label 18762*/ GIMT_Encode4(1309476), // Rule ID 9582 //
     /* 1309397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1309405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1309414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1309417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309450 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1309453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309475 */     // GIR_Coverage, 9582,
     /* 1309475 */     GIR_EraseRootFromParent_Done,
     /* 1309476 */   // Label 18762: @1309476
     /* 1309476 */   GIM_Try, /*On fail goto*//*Label 18763*/ GIMT_Encode4(1309560), // Rule ID 9583 //
     /* 1309481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1309489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1309498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1309501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309534 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1309537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309559 */     // GIR_Coverage, 9583,
     /* 1309559 */     GIR_EraseRootFromParent_Done,
     /* 1309560 */   // Label 18763: @1309560
     /* 1309560 */   GIM_Try, /*On fail goto*//*Label 18764*/ GIMT_Encode4(1309644), // Rule ID 9586 //
     /* 1309565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1309568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1309573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1309582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1309585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309618 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1309621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309643 */     // GIR_Coverage, 9586,
     /* 1309643 */     GIR_EraseRootFromParent_Done,
     /* 1309644 */   // Label 18764: @1309644
     /* 1309644 */   GIM_Try, /*On fail goto*//*Label 18765*/ GIMT_Encode4(1309728), // Rule ID 9587 //
     /* 1309649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1309652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1309657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1309666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1309669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309702 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1309705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309727 */     // GIR_Coverage, 9587,
     /* 1309727 */     GIR_EraseRootFromParent_Done,
     /* 1309728 */   // Label 18765: @1309728
     /* 1309728 */   GIM_Try, /*On fail goto*//*Label 18766*/ GIMT_Encode4(1309812), // Rule ID 9590 //
     /* 1309733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1309741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1309744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1309747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1309750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1309753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1309756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309786 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1309789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309811 */     // GIR_Coverage, 9590,
     /* 1309811 */     GIR_EraseRootFromParent_Done,
     /* 1309812 */   // Label 18766: @1309812
     /* 1309812 */   GIM_Try, /*On fail goto*//*Label 18767*/ GIMT_Encode4(1309896), // Rule ID 9591 //
     /* 1309817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1309825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1309828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1309831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1309834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1309837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1309840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309870 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1309873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309895 */     // GIR_Coverage, 9591,
     /* 1309895 */     GIR_EraseRootFromParent_Done,
     /* 1309896 */   // Label 18767: @1309896
     /* 1309896 */   GIM_Try, /*On fail goto*//*Label 18768*/ GIMT_Encode4(1309980), // Rule ID 9594 //
     /* 1309901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1309909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1309912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1309915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1309918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1309921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1309924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309954 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1309957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309979 */     // GIR_Coverage, 9594,
     /* 1309979 */     GIR_EraseRootFromParent_Done,
     /* 1309980 */   // Label 18768: @1309980
     /* 1309980 */   GIM_Try, /*On fail goto*//*Label 18769*/ GIMT_Encode4(1310064), // Rule ID 9595 //
     /* 1309985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1309993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1309996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1309999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1310002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1310005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310038 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1310041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310063 */     // GIR_Coverage, 9595,
     /* 1310063 */     GIR_EraseRootFromParent_Done,
     /* 1310064 */   // Label 18769: @1310064
     /* 1310064 */   GIM_Try, /*On fail goto*//*Label 18770*/ GIMT_Encode4(1310148), // Rule ID 9598 //
     /* 1310069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1310077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1310080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1310083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1310086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1310089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1310092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310122 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1310125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310147 */     // GIR_Coverage, 9598,
     /* 1310147 */     GIR_EraseRootFromParent_Done,
     /* 1310148 */   // Label 18770: @1310148
     /* 1310148 */   GIM_Try, /*On fail goto*//*Label 18771*/ GIMT_Encode4(1310232), // Rule ID 9599 //
     /* 1310153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1310161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1310164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1310167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1310170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1310173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1310176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310206 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1310209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310231 */     // GIR_Coverage, 9599,
     /* 1310231 */     GIR_EraseRootFromParent_Done,
     /* 1310232 */   // Label 18771: @1310232
     /* 1310232 */   GIM_Try, /*On fail goto*//*Label 18772*/ GIMT_Encode4(1310316), // Rule ID 9602 //
     /* 1310237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1310245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1310257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310290 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1310293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310315 */     // GIR_Coverage, 9602,
     /* 1310315 */     GIR_EraseRootFromParent_Done,
     /* 1310316 */   // Label 18772: @1310316
     /* 1310316 */   GIM_Try, /*On fail goto*//*Label 18773*/ GIMT_Encode4(1310400), // Rule ID 9603 //
     /* 1310321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1310329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1310341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310374 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1310377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310399 */     // GIR_Coverage, 9603,
     /* 1310399 */     GIR_EraseRootFromParent_Done,
     /* 1310400 */   // Label 18773: @1310400
     /* 1310400 */   GIM_Try, /*On fail goto*//*Label 18774*/ GIMT_Encode4(1310484), // Rule ID 9606 //
     /* 1310405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1310413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1310422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1310425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310458 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1310461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310483 */     // GIR_Coverage, 9606,
     /* 1310483 */     GIR_EraseRootFromParent_Done,
     /* 1310484 */   // Label 18774: @1310484
     /* 1310484 */   GIM_Try, /*On fail goto*//*Label 18775*/ GIMT_Encode4(1310568), // Rule ID 9607 //
     /* 1310489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1310497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1310506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1310509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310542 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1310545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310567 */     // GIR_Coverage, 9607,
     /* 1310567 */     GIR_EraseRootFromParent_Done,
     /* 1310568 */   // Label 18775: @1310568
     /* 1310568 */   GIM_Try, /*On fail goto*//*Label 18776*/ GIMT_Encode4(1310652), // Rule ID 9610 //
     /* 1310573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1310581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1310590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1310593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310626 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1310629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310651 */     // GIR_Coverage, 9610,
     /* 1310651 */     GIR_EraseRootFromParent_Done,
     /* 1310652 */   // Label 18776: @1310652
     /* 1310652 */   GIM_Try, /*On fail goto*//*Label 18777*/ GIMT_Encode4(1310736), // Rule ID 9611 //
     /* 1310657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1310665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1310674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1310677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310710 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1310713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310735 */     // GIR_Coverage, 9611,
     /* 1310735 */     GIR_EraseRootFromParent_Done,
     /* 1310736 */   // Label 18777: @1310736
     /* 1310736 */   GIM_Try, /*On fail goto*//*Label 18778*/ GIMT_Encode4(1310820), // Rule ID 9614 //
     /* 1310741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1310749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1310752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1310755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1310758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1310761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1310764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310794 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1310797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310819 */     // GIR_Coverage, 9614,
     /* 1310819 */     GIR_EraseRootFromParent_Done,
     /* 1310820 */   // Label 18778: @1310820
     /* 1310820 */   GIM_Try, /*On fail goto*//*Label 18779*/ GIMT_Encode4(1310904), // Rule ID 9615 //
     /* 1310825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1310833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1310836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1310839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1310842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1310845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1310848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310878 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1310881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310903 */     // GIR_Coverage, 9615,
     /* 1310903 */     GIR_EraseRootFromParent_Done,
     /* 1310904 */   // Label 18779: @1310904
     /* 1310904 */   GIM_Try, /*On fail goto*//*Label 18780*/ GIMT_Encode4(1310988), // Rule ID 9618 //
     /* 1310909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1310917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1310926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1310929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310962 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1310965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310987 */     // GIR_Coverage, 9618,
     /* 1310987 */     GIR_EraseRootFromParent_Done,
     /* 1310988 */   // Label 18780: @1310988
     /* 1310988 */   GIM_Try, /*On fail goto*//*Label 18781*/ GIMT_Encode4(1311072), // Rule ID 9619 //
     /* 1310993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1311001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1311010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1311013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311046 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1311049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311071 */     // GIR_Coverage, 9619,
     /* 1311071 */     GIR_EraseRootFromParent_Done,
     /* 1311072 */   // Label 18781: @1311072
     /* 1311072 */   GIM_Try, /*On fail goto*//*Label 18782*/ GIMT_Encode4(1311156), // Rule ID 9622 //
     /* 1311077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1311085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1311094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1311097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311130 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1311133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311155 */     // GIR_Coverage, 9622,
     /* 1311155 */     GIR_EraseRootFromParent_Done,
     /* 1311156 */   // Label 18782: @1311156
     /* 1311156 */   GIM_Try, /*On fail goto*//*Label 18783*/ GIMT_Encode4(1311240), // Rule ID 9623 //
     /* 1311161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1311169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1311178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1311181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311214 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1311217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311239 */     // GIR_Coverage, 9623,
     /* 1311239 */     GIR_EraseRootFromParent_Done,
     /* 1311240 */   // Label 18783: @1311240
     /* 1311240 */   GIM_Try, /*On fail goto*//*Label 18784*/ GIMT_Encode4(1311324), // Rule ID 9626 //
     /* 1311245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1311253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1311262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1311265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311298 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1311301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311323 */     // GIR_Coverage, 9626,
     /* 1311323 */     GIR_EraseRootFromParent_Done,
     /* 1311324 */   // Label 18784: @1311324
     /* 1311324 */   GIM_Try, /*On fail goto*//*Label 18785*/ GIMT_Encode4(1311408), // Rule ID 9627 //
     /* 1311329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1311337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1311346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1311349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311382 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1311385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311407 */     // GIR_Coverage, 9627,
     /* 1311407 */     GIR_EraseRootFromParent_Done,
     /* 1311408 */   // Label 18785: @1311408
     /* 1311408 */   GIM_Try, /*On fail goto*//*Label 18786*/ GIMT_Encode4(1311492), // Rule ID 9630 //
     /* 1311413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1311421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1311430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1311433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311466 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1311469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311491 */     // GIR_Coverage, 9630,
     /* 1311491 */     GIR_EraseRootFromParent_Done,
     /* 1311492 */   // Label 18786: @1311492
     /* 1311492 */   GIM_Try, /*On fail goto*//*Label 18787*/ GIMT_Encode4(1311576), // Rule ID 9631 //
     /* 1311497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1311505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1311514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1311517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311550 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1311553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311575 */     // GIR_Coverage, 9631,
     /* 1311575 */     GIR_EraseRootFromParent_Done,
     /* 1311576 */   // Label 18787: @1311576
     /* 1311576 */   GIM_Try, /*On fail goto*//*Label 18788*/ GIMT_Encode4(1311660), // Rule ID 9634 //
     /* 1311581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1311589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1311598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1311601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311634 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1311637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311659 */     // GIR_Coverage, 9634,
     /* 1311659 */     GIR_EraseRootFromParent_Done,
     /* 1311660 */   // Label 18788: @1311660
     /* 1311660 */   GIM_Try, /*On fail goto*//*Label 18789*/ GIMT_Encode4(1311744), // Rule ID 9635 //
     /* 1311665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1311673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1311682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1311685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311718 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1311721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311743 */     // GIR_Coverage, 9635,
     /* 1311743 */     GIR_EraseRootFromParent_Done,
     /* 1311744 */   // Label 18789: @1311744
     /* 1311744 */   GIM_Try, /*On fail goto*//*Label 18790*/ GIMT_Encode4(1311828), // Rule ID 9638 //
     /* 1311749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1311760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1311763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1311766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1311769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1311772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311802 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1311805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311827 */     // GIR_Coverage, 9638,
     /* 1311827 */     GIR_EraseRootFromParent_Done,
     /* 1311828 */   // Label 18790: @1311828
     /* 1311828 */   GIM_Try, /*On fail goto*//*Label 18791*/ GIMT_Encode4(1311912), // Rule ID 9639 //
     /* 1311833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1311844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1311847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1311850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1311853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1311856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311886 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1311889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311911 */     // GIR_Coverage, 9639,
     /* 1311911 */     GIR_EraseRootFromParent_Done,
     /* 1311912 */   // Label 18791: @1311912
     /* 1311912 */   GIM_Try, /*On fail goto*//*Label 18792*/ GIMT_Encode4(1311996), // Rule ID 9642 //
     /* 1311917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1311934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1311937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311970 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1311973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311995 */     // GIR_Coverage, 9642,
     /* 1311995 */     GIR_EraseRootFromParent_Done,
     /* 1311996 */   // Label 18792: @1311996
     /* 1311996 */   GIM_Try, /*On fail goto*//*Label 18793*/ GIMT_Encode4(1312080), // Rule ID 9643 //
     /* 1312001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1312009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1312018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1312021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312054 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1312057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312079 */     // GIR_Coverage, 9643,
     /* 1312079 */     GIR_EraseRootFromParent_Done,
     /* 1312080 */   // Label 18793: @1312080
     /* 1312080 */   GIM_Try, /*On fail goto*//*Label 18794*/ GIMT_Encode4(1312164), // Rule ID 9646 //
     /* 1312085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1312093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1312102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1312105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312138 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1312141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312163 */     // GIR_Coverage, 9646,
     /* 1312163 */     GIR_EraseRootFromParent_Done,
     /* 1312164 */   // Label 18794: @1312164
     /* 1312164 */   GIM_Try, /*On fail goto*//*Label 18795*/ GIMT_Encode4(1312248), // Rule ID 9647 //
     /* 1312169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1312177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1312186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1312189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312222 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1312225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312247 */     // GIR_Coverage, 9647,
     /* 1312247 */     GIR_EraseRootFromParent_Done,
     /* 1312248 */   // Label 18795: @1312248
     /* 1312248 */   GIM_Try, /*On fail goto*//*Label 18796*/ GIMT_Encode4(1312332), // Rule ID 9650 //
     /* 1312253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1312261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1312270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1312273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312306 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1312309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312331 */     // GIR_Coverage, 9650,
     /* 1312331 */     GIR_EraseRootFromParent_Done,
     /* 1312332 */   // Label 18796: @1312332
     /* 1312332 */   GIM_Try, /*On fail goto*//*Label 18797*/ GIMT_Encode4(1312416), // Rule ID 9651 //
     /* 1312337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1312345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1312354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1312357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312390 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1312393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312415 */     // GIR_Coverage, 9651,
     /* 1312415 */     GIR_EraseRootFromParent_Done,
     /* 1312416 */   // Label 18797: @1312416
     /* 1312416 */   GIM_Try, /*On fail goto*//*Label 18798*/ GIMT_Encode4(1312500), // Rule ID 9654 //
     /* 1312421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1312429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1312438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1312441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312474 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1312477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312499 */     // GIR_Coverage, 9654,
     /* 1312499 */     GIR_EraseRootFromParent_Done,
     /* 1312500 */   // Label 18798: @1312500
     /* 1312500 */   GIM_Try, /*On fail goto*//*Label 18799*/ GIMT_Encode4(1312584), // Rule ID 9655 //
     /* 1312505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1312513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1312522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1312525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312558 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1312561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312583 */     // GIR_Coverage, 9655,
     /* 1312583 */     GIR_EraseRootFromParent_Done,
     /* 1312584 */   // Label 18799: @1312584
     /* 1312584 */   GIM_Try, /*On fail goto*//*Label 18800*/ GIMT_Encode4(1312668), // Rule ID 9658 //
     /* 1312589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1312597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1312606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1312609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312642 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1312645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312667 */     // GIR_Coverage, 9658,
     /* 1312667 */     GIR_EraseRootFromParent_Done,
     /* 1312668 */   // Label 18800: @1312668
     /* 1312668 */   GIM_Try, /*On fail goto*//*Label 18801*/ GIMT_Encode4(1312752), // Rule ID 9659 //
     /* 1312673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1312681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1312690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1312693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312726 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1312729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312751 */     // GIR_Coverage, 9659,
     /* 1312751 */     GIR_EraseRootFromParent_Done,
     /* 1312752 */   // Label 18801: @1312752
     /* 1312752 */   GIM_Try, /*On fail goto*//*Label 18802*/ GIMT_Encode4(1312836), // Rule ID 9662 //
     /* 1312757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1312765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1312768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1312771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1312774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1312777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1312780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312810 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1312813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312835 */     // GIR_Coverage, 9662,
     /* 1312835 */     GIR_EraseRootFromParent_Done,
     /* 1312836 */   // Label 18802: @1312836
     /* 1312836 */   GIM_Try, /*On fail goto*//*Label 18803*/ GIMT_Encode4(1312920), // Rule ID 9663 //
     /* 1312841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1312849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1312852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1312855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1312858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1312861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1312864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312894 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1312897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312919 */     // GIR_Coverage, 9663,
     /* 1312919 */     GIR_EraseRootFromParent_Done,
     /* 1312920 */   // Label 18803: @1312920
     /* 1312920 */   GIM_Try, /*On fail goto*//*Label 18804*/ GIMT_Encode4(1313004), // Rule ID 9666 //
     /* 1312925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1312933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1312942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1312945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312978 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1312981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313003 */     // GIR_Coverage, 9666,
     /* 1313003 */     GIR_EraseRootFromParent_Done,
     /* 1313004 */   // Label 18804: @1313004
     /* 1313004 */   GIM_Try, /*On fail goto*//*Label 18805*/ GIMT_Encode4(1313088), // Rule ID 9667 //
     /* 1313009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1313017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1313020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1313023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1313026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1313029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1313032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313062 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1313065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313087 */     // GIR_Coverage, 9667,
     /* 1313087 */     GIR_EraseRootFromParent_Done,
     /* 1313088 */   // Label 18805: @1313088
     /* 1313088 */   GIM_Try, /*On fail goto*//*Label 18806*/ GIMT_Encode4(1313172), // Rule ID 9670 //
     /* 1313093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1313101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1313104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1313107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1313110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1313113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313146 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1313149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313171 */     // GIR_Coverage, 9670,
     /* 1313171 */     GIR_EraseRootFromParent_Done,
     /* 1313172 */   // Label 18806: @1313172
     /* 1313172 */   GIM_Try, /*On fail goto*//*Label 18807*/ GIMT_Encode4(1313256), // Rule ID 9671 //
     /* 1313177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1313185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1313188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1313191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1313194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1313197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313230 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1313233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313255 */     // GIR_Coverage, 9671,
     /* 1313255 */     GIR_EraseRootFromParent_Done,
     /* 1313256 */   // Label 18807: @1313256
     /* 1313256 */   GIM_Try, /*On fail goto*//*Label 18808*/ GIMT_Encode4(1313340), // Rule ID 9674 //
     /* 1313261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1313264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1313269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1313278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1313281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313314 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1313317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1313335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313339 */     // GIR_Coverage, 9674,
     /* 1313339 */     GIR_EraseRootFromParent_Done,
     /* 1313340 */   // Label 18808: @1313340
     /* 1313340 */   GIM_Try, /*On fail goto*//*Label 18809*/ GIMT_Encode4(1313424), // Rule ID 9675 //
     /* 1313345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1313348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1313353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1313362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1313365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313398 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1313401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1313419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313423 */     // GIR_Coverage, 9675,
     /* 1313423 */     GIR_EraseRootFromParent_Done,
     /* 1313424 */   // Label 18809: @1313424
     /* 1313424 */   GIM_Try, /*On fail goto*//*Label 18810*/ GIMT_Encode4(1313508), // Rule ID 9678 //
     /* 1313429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1313437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1313440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1313443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1313446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1313449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1313452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313482 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1313485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313507 */     // GIR_Coverage, 9678,
     /* 1313507 */     GIR_EraseRootFromParent_Done,
     /* 1313508 */   // Label 18810: @1313508
     /* 1313508 */   GIM_Try, /*On fail goto*//*Label 18811*/ GIMT_Encode4(1313592), // Rule ID 9679 //
     /* 1313513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1313521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1313524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1313527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1313530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1313533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1313536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313566 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1313569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313591 */     // GIR_Coverage, 9679,
     /* 1313591 */     GIR_EraseRootFromParent_Done,
     /* 1313592 */   // Label 18811: @1313592
     /* 1313592 */   GIM_Try, /*On fail goto*//*Label 18812*/ GIMT_Encode4(1313676), // Rule ID 9682 //
     /* 1313597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1313605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1313608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1313611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1313614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1313617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1313620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313650 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1313653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313675 */     // GIR_Coverage, 9682,
     /* 1313675 */     GIR_EraseRootFromParent_Done,
     /* 1313676 */   // Label 18812: @1313676
     /* 1313676 */   GIM_Try, /*On fail goto*//*Label 18813*/ GIMT_Encode4(1313760), // Rule ID 9683 //
     /* 1313681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1313689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1313692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1313695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1313698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1313701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1313704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313734 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1313737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313759 */     // GIR_Coverage, 9683,
     /* 1313759 */     GIR_EraseRootFromParent_Done,
     /* 1313760 */   // Label 18813: @1313760
     /* 1313760 */   GIM_Try, /*On fail goto*//*Label 18814*/ GIMT_Encode4(1313844), // Rule ID 9686 //
     /* 1313765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1313773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1313776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1313779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1313782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1313785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1313788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313818 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1313821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313843 */     // GIR_Coverage, 9686,
     /* 1313843 */     GIR_EraseRootFromParent_Done,
     /* 1313844 */   // Label 18814: @1313844
     /* 1313844 */   GIM_Try, /*On fail goto*//*Label 18815*/ GIMT_Encode4(1313928), // Rule ID 9687 //
     /* 1313849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1313857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1313860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1313863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1313866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1313869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1313872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313902 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1313905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313927 */     // GIR_Coverage, 9687,
     /* 1313927 */     GIR_EraseRootFromParent_Done,
     /* 1313928 */   // Label 18815: @1313928
     /* 1313928 */   GIM_Try, /*On fail goto*//*Label 18816*/ GIMT_Encode4(1314012), // Rule ID 9690 //
     /* 1313933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1313941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1313944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1313947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1313950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1313953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1313956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313986 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1313989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314011 */     // GIR_Coverage, 9690,
     /* 1314011 */     GIR_EraseRootFromParent_Done,
     /* 1314012 */   // Label 18816: @1314012
     /* 1314012 */   GIM_Try, /*On fail goto*//*Label 18817*/ GIMT_Encode4(1314096), // Rule ID 9691 //
     /* 1314017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1314025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1314034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1314037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314070 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1314073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314095 */     // GIR_Coverage, 9691,
     /* 1314095 */     GIR_EraseRootFromParent_Done,
     /* 1314096 */   // Label 18817: @1314096
     /* 1314096 */   GIM_Try, /*On fail goto*//*Label 18818*/ GIMT_Encode4(1314180), // Rule ID 9694 //
     /* 1314101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1314109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1314118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1314121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314154 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1314157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314179 */     // GIR_Coverage, 9694,
     /* 1314179 */     GIR_EraseRootFromParent_Done,
     /* 1314180 */   // Label 18818: @1314180
     /* 1314180 */   GIM_Try, /*On fail goto*//*Label 18819*/ GIMT_Encode4(1314264), // Rule ID 9695 //
     /* 1314185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1314193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1314202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1314205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314238 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1314241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314263 */     // GIR_Coverage, 9695,
     /* 1314263 */     GIR_EraseRootFromParent_Done,
     /* 1314264 */   // Label 18819: @1314264
     /* 1314264 */   GIM_Try, /*On fail goto*//*Label 18820*/ GIMT_Encode4(1314348), // Rule ID 9698 //
     /* 1314269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1314277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1314280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1314283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1314289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314322 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1314325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314347 */     // GIR_Coverage, 9698,
     /* 1314347 */     GIR_EraseRootFromParent_Done,
     /* 1314348 */   // Label 18820: @1314348
     /* 1314348 */   GIM_Try, /*On fail goto*//*Label 18821*/ GIMT_Encode4(1314432), // Rule ID 9699 //
     /* 1314353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1314361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1314364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1314367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1314373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314406 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1314409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314431 */     // GIR_Coverage, 9699,
     /* 1314431 */     GIR_EraseRootFromParent_Done,
     /* 1314432 */   // Label 18821: @1314432
     /* 1314432 */   GIM_Try, /*On fail goto*//*Label 18822*/ GIMT_Encode4(1314516), // Rule ID 9702 //
     /* 1314437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1314445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1314454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1314457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314490 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1314493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314515 */     // GIR_Coverage, 9702,
     /* 1314515 */     GIR_EraseRootFromParent_Done,
     /* 1314516 */   // Label 18822: @1314516
     /* 1314516 */   GIM_Try, /*On fail goto*//*Label 18823*/ GIMT_Encode4(1314600), // Rule ID 9703 //
     /* 1314521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1314529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1314538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1314541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314574 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1314577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314599 */     // GIR_Coverage, 9703,
     /* 1314599 */     GIR_EraseRootFromParent_Done,
     /* 1314600 */   // Label 18823: @1314600
     /* 1314600 */   GIM_Try, /*On fail goto*//*Label 18824*/ GIMT_Encode4(1314684), // Rule ID 9706 //
     /* 1314605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1314613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1314622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1314625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314658 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1314661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314683 */     // GIR_Coverage, 9706,
     /* 1314683 */     GIR_EraseRootFromParent_Done,
     /* 1314684 */   // Label 18824: @1314684
     /* 1314684 */   GIM_Try, /*On fail goto*//*Label 18825*/ GIMT_Encode4(1314768), // Rule ID 9707 //
     /* 1314689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1314697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1314706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1314709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314742 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1314745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314767 */     // GIR_Coverage, 9707,
     /* 1314767 */     GIR_EraseRootFromParent_Done,
     /* 1314768 */   // Label 18825: @1314768
     /* 1314768 */   GIM_Try, /*On fail goto*//*Label 18826*/ GIMT_Encode4(1314852), // Rule ID 9710 //
     /* 1314773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1314781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1314790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1314793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314826 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1314829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314851 */     // GIR_Coverage, 9710,
     /* 1314851 */     GIR_EraseRootFromParent_Done,
     /* 1314852 */   // Label 18826: @1314852
     /* 1314852 */   GIM_Try, /*On fail goto*//*Label 18827*/ GIMT_Encode4(1314936), // Rule ID 9711 //
     /* 1314857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1314865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1314874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1314877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314910 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1314913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314935 */     // GIR_Coverage, 9711,
     /* 1314935 */     GIR_EraseRootFromParent_Done,
     /* 1314936 */   // Label 18827: @1314936
     /* 1314936 */   GIM_Try, /*On fail goto*//*Label 18828*/ GIMT_Encode4(1315020), // Rule ID 9714 //
     /* 1314941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1314944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1314949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1314952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1314955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1314958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1314961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1314964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314994 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1314997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315019 */     // GIR_Coverage, 9714,
     /* 1315019 */     GIR_EraseRootFromParent_Done,
     /* 1315020 */   // Label 18828: @1315020
     /* 1315020 */   GIM_Try, /*On fail goto*//*Label 18829*/ GIMT_Encode4(1315104), // Rule ID 9715 //
     /* 1315025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1315033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1315042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1315045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315078 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1315081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315103 */     // GIR_Coverage, 9715,
     /* 1315103 */     GIR_EraseRootFromParent_Done,
     /* 1315104 */   // Label 18829: @1315104
     /* 1315104 */   GIM_Try, /*On fail goto*//*Label 18830*/ GIMT_Encode4(1315188), // Rule ID 9718 //
     /* 1315109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1315112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1315117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1315126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1315129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315162 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1315165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315187 */     // GIR_Coverage, 9718,
     /* 1315187 */     GIR_EraseRootFromParent_Done,
     /* 1315188 */   // Label 18830: @1315188
     /* 1315188 */   GIM_Try, /*On fail goto*//*Label 18831*/ GIMT_Encode4(1315272), // Rule ID 9719 //
     /* 1315193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1315201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1315210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1315213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315246 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1315249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315271 */     // GIR_Coverage, 9719,
     /* 1315271 */     GIR_EraseRootFromParent_Done,
     /* 1315272 */   // Label 18831: @1315272
     /* 1315272 */   GIM_Try, /*On fail goto*//*Label 18832*/ GIMT_Encode4(1315356), // Rule ID 9722 //
     /* 1315277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1315280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1315285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1315294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1315297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315330 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1315333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315355 */     // GIR_Coverage, 9722,
     /* 1315355 */     GIR_EraseRootFromParent_Done,
     /* 1315356 */   // Label 18832: @1315356
     /* 1315356 */   GIM_Try, /*On fail goto*//*Label 18833*/ GIMT_Encode4(1315440), // Rule ID 9723 //
     /* 1315361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1315369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1315378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1315381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315414 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1315417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315439 */     // GIR_Coverage, 9723,
     /* 1315439 */     GIR_EraseRootFromParent_Done,
     /* 1315440 */   // Label 18833: @1315440
     /* 1315440 */   GIM_Try, /*On fail goto*//*Label 18834*/ GIMT_Encode4(1315524), // Rule ID 9726 //
     /* 1315445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1315462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1315465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315498 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1315501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315523 */     // GIR_Coverage, 9726,
     /* 1315523 */     GIR_EraseRootFromParent_Done,
     /* 1315524 */   // Label 18834: @1315524
     /* 1315524 */   GIM_Try, /*On fail goto*//*Label 18835*/ GIMT_Encode4(1315608), // Rule ID 9727 //
     /* 1315529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1315546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1315549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315582 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1315585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315607 */     // GIR_Coverage, 9727,
     /* 1315607 */     GIR_EraseRootFromParent_Done,
     /* 1315608 */   // Label 18835: @1315608
     /* 1315608 */   GIM_Try, /*On fail goto*//*Label 18836*/ GIMT_Encode4(1315692), // Rule ID 9730 //
     /* 1315613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1315630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1315633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315666 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1315669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315691 */     // GIR_Coverage, 9730,
     /* 1315691 */     GIR_EraseRootFromParent_Done,
     /* 1315692 */   // Label 18836: @1315692
     /* 1315692 */   GIM_Try, /*On fail goto*//*Label 18837*/ GIMT_Encode4(1315776), // Rule ID 9731 //
     /* 1315697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1315714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1315717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315750 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1315753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315775 */     // GIR_Coverage, 9731,
     /* 1315775 */     GIR_EraseRootFromParent_Done,
     /* 1315776 */   // Label 18837: @1315776
     /* 1315776 */   GIM_Try, /*On fail goto*//*Label 18838*/ GIMT_Encode4(1315860), // Rule ID 9734 //
     /* 1315781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1315798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1315801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315834 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1315837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315859 */     // GIR_Coverage, 9734,
     /* 1315859 */     GIR_EraseRootFromParent_Done,
     /* 1315860 */   // Label 18838: @1315860
     /* 1315860 */   GIM_Try, /*On fail goto*//*Label 18839*/ GIMT_Encode4(1315944), // Rule ID 9735 //
     /* 1315865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1315882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1315885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315918 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1315921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315943 */     // GIR_Coverage, 9735,
     /* 1315943 */     GIR_EraseRootFromParent_Done,
     /* 1315944 */   // Label 18839: @1315944
     /* 1315944 */   GIM_Try, /*On fail goto*//*Label 18840*/ GIMT_Encode4(1316028), // Rule ID 9738 //
     /* 1315949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1315966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1315969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316002 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1316005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316027 */     // GIR_Coverage, 9738,
     /* 1316027 */     GIR_EraseRootFromParent_Done,
     /* 1316028 */   // Label 18840: @1316028
     /* 1316028 */   GIM_Try, /*On fail goto*//*Label 18841*/ GIMT_Encode4(1316112), // Rule ID 9739 //
     /* 1316033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1316041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1316050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1316053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316086 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1316089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316111 */     // GIR_Coverage, 9739,
     /* 1316111 */     GIR_EraseRootFromParent_Done,
     /* 1316112 */   // Label 18841: @1316112
     /* 1316112 */   GIM_Try, /*On fail goto*//*Label 18842*/ GIMT_Encode4(1316196), // Rule ID 9742 //
     /* 1316117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1316125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1316134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1316137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316170 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1316173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316195 */     // GIR_Coverage, 9742,
     /* 1316195 */     GIR_EraseRootFromParent_Done,
     /* 1316196 */   // Label 18842: @1316196
     /* 1316196 */   GIM_Try, /*On fail goto*//*Label 18843*/ GIMT_Encode4(1316280), // Rule ID 9743 //
     /* 1316201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1316209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1316218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1316221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316254 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1316257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316279 */     // GIR_Coverage, 9743,
     /* 1316279 */     GIR_EraseRootFromParent_Done,
     /* 1316280 */   // Label 18843: @1316280
     /* 1316280 */   GIM_Try, /*On fail goto*//*Label 18844*/ GIMT_Encode4(1316364), // Rule ID 9746 //
     /* 1316285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1316293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1316302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1316305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316338 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1316341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316363 */     // GIR_Coverage, 9746,
     /* 1316363 */     GIR_EraseRootFromParent_Done,
     /* 1316364 */   // Label 18844: @1316364
     /* 1316364 */   GIM_Try, /*On fail goto*//*Label 18845*/ GIMT_Encode4(1316448), // Rule ID 9747 //
     /* 1316369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1316377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1316386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1316389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316422 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1316425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316447 */     // GIR_Coverage, 9747,
     /* 1316447 */     GIR_EraseRootFromParent_Done,
     /* 1316448 */   // Label 18845: @1316448
     /* 1316448 */   GIM_Try, /*On fail goto*//*Label 18846*/ GIMT_Encode4(1316532), // Rule ID 9750 //
     /* 1316453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1316461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1316464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1316467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1316470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1316473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316506 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1316509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316531 */     // GIR_Coverage, 9750,
     /* 1316531 */     GIR_EraseRootFromParent_Done,
     /* 1316532 */   // Label 18846: @1316532
     /* 1316532 */   GIM_Try, /*On fail goto*//*Label 18847*/ GIMT_Encode4(1316616), // Rule ID 9751 //
     /* 1316537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1316545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1316548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1316551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1316554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1316557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316590 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1316593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316615 */     // GIR_Coverage, 9751,
     /* 1316615 */     GIR_EraseRootFromParent_Done,
     /* 1316616 */   // Label 18847: @1316616
     /* 1316616 */   GIM_Try, /*On fail goto*//*Label 18848*/ GIMT_Encode4(1316700), // Rule ID 9754 //
     /* 1316621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1316629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1316638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1316641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316674 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1316677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316699 */     // GIR_Coverage, 9754,
     /* 1316699 */     GIR_EraseRootFromParent_Done,
     /* 1316700 */   // Label 18848: @1316700
     /* 1316700 */   GIM_Try, /*On fail goto*//*Label 18849*/ GIMT_Encode4(1316784), // Rule ID 9755 //
     /* 1316705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1316713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1316722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1316725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316758 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1316761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316783 */     // GIR_Coverage, 9755,
     /* 1316783 */     GIR_EraseRootFromParent_Done,
     /* 1316784 */   // Label 18849: @1316784
     /* 1316784 */   GIM_Try, /*On fail goto*//*Label 18850*/ GIMT_Encode4(1316868), // Rule ID 9758 //
     /* 1316789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1316797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1316806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1316809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316842 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1316845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316867 */     // GIR_Coverage, 9758,
     /* 1316867 */     GIR_EraseRootFromParent_Done,
     /* 1316868 */   // Label 18850: @1316868
     /* 1316868 */   GIM_Try, /*On fail goto*//*Label 18851*/ GIMT_Encode4(1316952), // Rule ID 9759 //
     /* 1316873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1316881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1316890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1316893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316926 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1316929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316951 */     // GIR_Coverage, 9759,
     /* 1316951 */     GIR_EraseRootFromParent_Done,
     /* 1316952 */   // Label 18851: @1316952
     /* 1316952 */   GIM_Try, /*On fail goto*//*Label 18852*/ GIMT_Encode4(1317036), // Rule ID 9762 //
     /* 1316957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1316960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1316965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1316974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1316977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317010 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1317013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1317031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317035 */     // GIR_Coverage, 9762,
     /* 1317035 */     GIR_EraseRootFromParent_Done,
     /* 1317036 */   // Label 18852: @1317036
     /* 1317036 */   GIM_Try, /*On fail goto*//*Label 18853*/ GIMT_Encode4(1317120), // Rule ID 9763 //
     /* 1317041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1317044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1317049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1317052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1317055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1317058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1317061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1317064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317094 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1317097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1317115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317119 */     // GIR_Coverage, 9763,
     /* 1317119 */     GIR_EraseRootFromParent_Done,
     /* 1317120 */   // Label 18853: @1317120
     /* 1317120 */   GIM_Try, /*On fail goto*//*Label 18854*/ GIMT_Encode4(1317204), // Rule ID 9766 //
     /* 1317125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1317133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1317142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1317145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317178 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1317181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317203 */     // GIR_Coverage, 9766,
     /* 1317203 */     GIR_EraseRootFromParent_Done,
     /* 1317204 */   // Label 18854: @1317204
     /* 1317204 */   GIM_Try, /*On fail goto*//*Label 18855*/ GIMT_Encode4(1317288), // Rule ID 9767 //
     /* 1317209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1317217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1317226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1317229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317262 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1317265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317287 */     // GIR_Coverage, 9767,
     /* 1317287 */     GIR_EraseRootFromParent_Done,
     /* 1317288 */   // Label 18855: @1317288
     /* 1317288 */   GIM_Try, /*On fail goto*//*Label 18856*/ GIMT_Encode4(1317372), // Rule ID 9770 //
     /* 1317293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1317301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1317310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1317313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317346 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1317349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317371 */     // GIR_Coverage, 9770,
     /* 1317371 */     GIR_EraseRootFromParent_Done,
     /* 1317372 */   // Label 18856: @1317372
     /* 1317372 */   GIM_Try, /*On fail goto*//*Label 18857*/ GIMT_Encode4(1317456), // Rule ID 9771 //
     /* 1317377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1317385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1317394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1317397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317430 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1317433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317455 */     // GIR_Coverage, 9771,
     /* 1317455 */     GIR_EraseRootFromParent_Done,
     /* 1317456 */   // Label 18857: @1317456
     /* 1317456 */   GIM_Try, /*On fail goto*//*Label 18858*/ GIMT_Encode4(1317540), // Rule ID 9774 //
     /* 1317461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1317469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1317472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1317475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1317478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1317481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1317484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317514 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1317517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317539 */     // GIR_Coverage, 9774,
     /* 1317539 */     GIR_EraseRootFromParent_Done,
     /* 1317540 */   // Label 18858: @1317540
     /* 1317540 */   GIM_Try, /*On fail goto*//*Label 18859*/ GIMT_Encode4(1317624), // Rule ID 9775 //
     /* 1317545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1317553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1317556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1317559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1317562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1317565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1317568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317598 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1317601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317623 */     // GIR_Coverage, 9775,
     /* 1317623 */     GIR_EraseRootFromParent_Done,
     /* 1317624 */   // Label 18859: @1317624
     /* 1317624 */   GIM_Try, /*On fail goto*//*Label 18860*/ GIMT_Encode4(1317708), // Rule ID 9778 //
     /* 1317629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1317637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1317640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1317643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1317646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1317649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1317652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317682 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1317685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317707 */     // GIR_Coverage, 9778,
     /* 1317707 */     GIR_EraseRootFromParent_Done,
     /* 1317708 */   // Label 18860: @1317708
     /* 1317708 */   GIM_Try, /*On fail goto*//*Label 18861*/ GIMT_Encode4(1317792), // Rule ID 9779 //
     /* 1317713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1317721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1317724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1317727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1317730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1317733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1317736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317766 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1317769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317791 */     // GIR_Coverage, 9779,
     /* 1317791 */     GIR_EraseRootFromParent_Done,
     /* 1317792 */   // Label 18861: @1317792
     /* 1317792 */   GIM_Try, /*On fail goto*//*Label 18862*/ GIMT_Encode4(1317876), // Rule ID 9782 //
     /* 1317797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1317805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1317814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1317817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317850 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1317853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317875 */     // GIR_Coverage, 9782,
     /* 1317875 */     GIR_EraseRootFromParent_Done,
     /* 1317876 */   // Label 18862: @1317876
     /* 1317876 */   GIM_Try, /*On fail goto*//*Label 18863*/ GIMT_Encode4(1317960), // Rule ID 9783 //
     /* 1317881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1317889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1317898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1317901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317934 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1317937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317959 */     // GIR_Coverage, 9783,
     /* 1317959 */     GIR_EraseRootFromParent_Done,
     /* 1317960 */   // Label 18863: @1317960
     /* 1317960 */   GIM_Try, /*On fail goto*//*Label 18864*/ GIMT_Encode4(1318044), // Rule ID 9786 //
     /* 1317965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1317973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1317982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1317985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318018 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1318021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318043 */     // GIR_Coverage, 9786,
     /* 1318043 */     GIR_EraseRootFromParent_Done,
     /* 1318044 */   // Label 18864: @1318044
     /* 1318044 */   GIM_Try, /*On fail goto*//*Label 18865*/ GIMT_Encode4(1318128), // Rule ID 9787 //
     /* 1318049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1318057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1318060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1318063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1318066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1318069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1318072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318102 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1318105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318127 */     // GIR_Coverage, 9787,
     /* 1318127 */     GIR_EraseRootFromParent_Done,
     /* 1318128 */   // Label 18865: @1318128
     /* 1318128 */   GIM_Try, /*On fail goto*//*Label 18866*/ GIMT_Encode4(1318212), // Rule ID 9790 //
     /* 1318133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1318141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1318150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1318153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318186 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1318189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318211 */     // GIR_Coverage, 9790,
     /* 1318211 */     GIR_EraseRootFromParent_Done,
     /* 1318212 */   // Label 18866: @1318212
     /* 1318212 */   GIM_Try, /*On fail goto*//*Label 18867*/ GIMT_Encode4(1318296), // Rule ID 9791 //
     /* 1318217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1318225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1318234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1318237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318270 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1318273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318295 */     // GIR_Coverage, 9791,
     /* 1318295 */     GIR_EraseRootFromParent_Done,
     /* 1318296 */   // Label 18867: @1318296
     /* 1318296 */   GIM_Try, /*On fail goto*//*Label 18868*/ GIMT_Encode4(1318380), // Rule ID 9794 //
     /* 1318301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1318309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1318318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1318321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318354 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1318357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318379 */     // GIR_Coverage, 9794,
     /* 1318379 */     GIR_EraseRootFromParent_Done,
     /* 1318380 */   // Label 18868: @1318380
     /* 1318380 */   GIM_Try, /*On fail goto*//*Label 18869*/ GIMT_Encode4(1318464), // Rule ID 9795 //
     /* 1318385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1318393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1318402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1318405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318438 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1318441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318463 */     // GIR_Coverage, 9795,
     /* 1318463 */     GIR_EraseRootFromParent_Done,
     /* 1318464 */   // Label 18869: @1318464
     /* 1318464 */   GIM_Try, /*On fail goto*//*Label 18870*/ GIMT_Encode4(1318548), // Rule ID 9798 //
     /* 1318469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1318477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1318486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1318489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318522 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1318525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318547 */     // GIR_Coverage, 9798,
     /* 1318547 */     GIR_EraseRootFromParent_Done,
     /* 1318548 */   // Label 18870: @1318548
     /* 1318548 */   GIM_Try, /*On fail goto*//*Label 18871*/ GIMT_Encode4(1318632), // Rule ID 9799 //
     /* 1318553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1318561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1318570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1318573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318606 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1318609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318631 */     // GIR_Coverage, 9799,
     /* 1318631 */     GIR_EraseRootFromParent_Done,
     /* 1318632 */   // Label 18871: @1318632
     /* 1318632 */   GIM_Try, /*On fail goto*//*Label 18872*/ GIMT_Encode4(1318716), // Rule ID 9802 //
     /* 1318637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1318640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1318645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1318648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1318651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1318654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1318657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1318660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318690 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1318693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318715 */     // GIR_Coverage, 9802,
     /* 1318715 */     GIR_EraseRootFromParent_Done,
     /* 1318716 */   // Label 18872: @1318716
     /* 1318716 */   GIM_Try, /*On fail goto*//*Label 18873*/ GIMT_Encode4(1318800), // Rule ID 9803 //
     /* 1318721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1318724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1318729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1318732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1318735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1318738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1318741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1318744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318774 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1318777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318799 */     // GIR_Coverage, 9803,
     /* 1318799 */     GIR_EraseRootFromParent_Done,
     /* 1318800 */   // Label 18873: @1318800
     /* 1318800 */   GIM_Try, /*On fail goto*//*Label 18874*/ GIMT_Encode4(1318884), // Rule ID 9806 //
     /* 1318805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1318808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1318813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1318822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1318825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318858 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1318861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318883 */     // GIR_Coverage, 9806,
     /* 1318883 */     GIR_EraseRootFromParent_Done,
     /* 1318884 */   // Label 18874: @1318884
     /* 1318884 */   GIM_Try, /*On fail goto*//*Label 18875*/ GIMT_Encode4(1318968), // Rule ID 9807 //
     /* 1318889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1318892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1318897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1318906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1318909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318942 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1318945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318967 */     // GIR_Coverage, 9807,
     /* 1318967 */     GIR_EraseRootFromParent_Done,
     /* 1318968 */   // Label 18875: @1318968
     /* 1318968 */   GIM_Try, /*On fail goto*//*Label 18876*/ GIMT_Encode4(1319052), // Rule ID 9810 //
     /* 1318973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1318976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1318981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1318990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1318993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319026 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1319029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319051 */     // GIR_Coverage, 9810,
     /* 1319051 */     GIR_EraseRootFromParent_Done,
     /* 1319052 */   // Label 18876: @1319052
     /* 1319052 */   GIM_Try, /*On fail goto*//*Label 18877*/ GIMT_Encode4(1319136), // Rule ID 9811 //
     /* 1319057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1319060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1319065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1319068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1319071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1319074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1319077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1319080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319110 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1319113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319135 */     // GIR_Coverage, 9811,
     /* 1319135 */     GIR_EraseRootFromParent_Done,
     /* 1319136 */   // Label 18877: @1319136
     /* 1319136 */   GIM_Try, /*On fail goto*//*Label 18878*/ GIMT_Encode4(1319220), // Rule ID 9814 //
     /* 1319141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1319152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1319155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1319158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1319161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319194 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1319197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319219 */     // GIR_Coverage, 9814,
     /* 1319219 */     GIR_EraseRootFromParent_Done,
     /* 1319220 */   // Label 18878: @1319220
     /* 1319220 */   GIM_Try, /*On fail goto*//*Label 18879*/ GIMT_Encode4(1319304), // Rule ID 9815 //
     /* 1319225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1319236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1319239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1319242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1319245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319278 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1319281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319303 */     // GIR_Coverage, 9815,
     /* 1319303 */     GIR_EraseRootFromParent_Done,
     /* 1319304 */   // Label 18879: @1319304
     /* 1319304 */   GIM_Try, /*On fail goto*//*Label 18880*/ GIMT_Encode4(1319388), // Rule ID 9818 //
     /* 1319309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1319320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1319323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1319326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1319329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319362 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1319365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319387 */     // GIR_Coverage, 9818,
     /* 1319387 */     GIR_EraseRootFromParent_Done,
     /* 1319388 */   // Label 18880: @1319388
     /* 1319388 */   GIM_Try, /*On fail goto*//*Label 18881*/ GIMT_Encode4(1319472), // Rule ID 9819 //
     /* 1319393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1319404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1319407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1319410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1319413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1319449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319471 */     // GIR_Coverage, 9819,
     /* 1319471 */     GIR_EraseRootFromParent_Done,
     /* 1319472 */   // Label 18881: @1319472
     /* 1319472 */   GIM_Try, /*On fail goto*//*Label 18882*/ GIMT_Encode4(1319556), // Rule ID 9822 //
     /* 1319477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1319488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1319491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1319494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1319497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319530 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1319533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319555 */     // GIR_Coverage, 9822,
     /* 1319555 */     GIR_EraseRootFromParent_Done,
     /* 1319556 */   // Label 18882: @1319556
     /* 1319556 */   GIM_Try, /*On fail goto*//*Label 18883*/ GIMT_Encode4(1319640), // Rule ID 9823 //
     /* 1319561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1319572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1319575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1319578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1319581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319614 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1319617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319639 */     // GIR_Coverage, 9823,
     /* 1319639 */     GIR_EraseRootFromParent_Done,
     /* 1319640 */   // Label 18883: @1319640
     /* 1319640 */   GIM_Try, /*On fail goto*//*Label 18884*/ GIMT_Encode4(1319724), // Rule ID 9826 //
     /* 1319645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1319656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1319659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1319662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1319665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319698 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1319701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319723 */     // GIR_Coverage, 9826,
     /* 1319723 */     GIR_EraseRootFromParent_Done,
     /* 1319724 */   // Label 18884: @1319724
     /* 1319724 */   GIM_Try, /*On fail goto*//*Label 18885*/ GIMT_Encode4(1319808), // Rule ID 9827 //
     /* 1319729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1319740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1319743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1319746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1319749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319782 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1319785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319807 */     // GIR_Coverage, 9827,
     /* 1319807 */     GIR_EraseRootFromParent_Done,
     /* 1319808 */   // Label 18885: @1319808
     /* 1319808 */   GIM_Try, /*On fail goto*//*Label 18886*/ GIMT_Encode4(1319892), // Rule ID 9830 //
     /* 1319813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1319824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1319827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1319830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1319833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319866 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1319869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319891 */     // GIR_Coverage, 9830,
     /* 1319891 */     GIR_EraseRootFromParent_Done,
     /* 1319892 */   // Label 18886: @1319892
     /* 1319892 */   GIM_Try, /*On fail goto*//*Label 18887*/ GIMT_Encode4(1319976), // Rule ID 9831 //
     /* 1319897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1319908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1319911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1319914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1319917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319950 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1319953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319975 */     // GIR_Coverage, 9831,
     /* 1319975 */     GIR_EraseRootFromParent_Done,
     /* 1319976 */   // Label 18887: @1319976
     /* 1319976 */   GIM_Try, /*On fail goto*//*Label 18888*/ GIMT_Encode4(1320060), // Rule ID 9834 //
     /* 1319981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1319992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1319995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1319998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1320001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320034 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1320034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1320037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1320043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1320045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320059 */     // GIR_Coverage, 9834,
     /* 1320059 */     GIR_EraseRootFromParent_Done,
     /* 1320060 */   // Label 18888: @1320060
     /* 1320060 */   GIM_Try, /*On fail goto*//*Label 18889*/ GIMT_Encode4(1320144), // Rule ID 9835 //
     /* 1320065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1320073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1320076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1320079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1320082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1320085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320118 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1320118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1320121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1320127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1320129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320143 */     // GIR_Coverage, 9835,
     /* 1320143 */     GIR_EraseRootFromParent_Done,
     /* 1320144 */   // Label 18889: @1320144
     /* 1320144 */   GIM_Try, /*On fail goto*//*Label 18890*/ GIMT_Encode4(1320228), // Rule ID 9838 //
     /* 1320149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1320157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1320160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1320163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1320166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1320169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320202 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1320202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1320205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1320211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1320213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320227 */     // GIR_Coverage, 9838,
     /* 1320227 */     GIR_EraseRootFromParent_Done,
     /* 1320228 */   // Label 18890: @1320228
     /* 1320228 */   GIM_Try, /*On fail goto*//*Label 18891*/ GIMT_Encode4(1320312), // Rule ID 9839 //
     /* 1320233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1320241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1320244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1320247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1320250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1320253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320286 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1320286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1320289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1320295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1320297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320311 */     // GIR_Coverage, 9839,
     /* 1320311 */     GIR_EraseRootFromParent_Done,
     /* 1320312 */   // Label 18891: @1320312
     /* 1320312 */   GIM_Try, /*On fail goto*//*Label 18892*/ GIMT_Encode4(1320396), // Rule ID 9842 //
     /* 1320317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1320325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1320328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1320331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1320337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320370 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1320370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1320373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1320379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1320381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320395 */     // GIR_Coverage, 9842,
     /* 1320395 */     GIR_EraseRootFromParent_Done,
     /* 1320396 */   // Label 18892: @1320396
     /* 1320396 */   GIM_Try, /*On fail goto*//*Label 18893*/ GIMT_Encode4(1320480), // Rule ID 9843 //
     /* 1320401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1320409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1320412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1320415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1320421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320454 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1320454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1320457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1320463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1320465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320479 */     // GIR_Coverage, 9843,
     /* 1320479 */     GIR_EraseRootFromParent_Done,
     /* 1320480 */   // Label 18893: @1320480
     /* 1320480 */   GIM_Try, /*On fail goto*//*Label 18894*/ GIMT_Encode4(1320564), // Rule ID 9846 //
     /* 1320485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1320493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1320496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1320499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1320505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320538 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1320538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1320541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1320547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1320549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320563 */     // GIR_Coverage, 9846,
     /* 1320563 */     GIR_EraseRootFromParent_Done,
     /* 1320564 */   // Label 18894: @1320564
     /* 1320564 */   GIM_Try, /*On fail goto*//*Label 18895*/ GIMT_Encode4(1320648), // Rule ID 9847 //
     /* 1320569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1320577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1320580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1320583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1320589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320622 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1320622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1320625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1320631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1320633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320647 */     // GIR_Coverage, 9847,
     /* 1320647 */     GIR_EraseRootFromParent_Done,
     /* 1320648 */   // Label 18895: @1320648
     /* 1320648 */   GIM_Try, /*On fail goto*//*Label 18896*/ GIMT_Encode4(1320732), // Rule ID 9850 //
     /* 1320653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1320656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1320661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1320664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1320667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1320670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1320673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320706 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1320706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1320709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1320715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1320717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320731 */     // GIR_Coverage, 9850,
     /* 1320731 */     GIR_EraseRootFromParent_Done,
     /* 1320732 */   // Label 18896: @1320732
     /* 1320732 */   GIM_Try, /*On fail goto*//*Label 18897*/ GIMT_Encode4(1320816), // Rule ID 9851 //
     /* 1320737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1320740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1320745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1320748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1320751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1320754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1320757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320790 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1320790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1320793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1320799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1320801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320815 */     // GIR_Coverage, 9851,
     /* 1320815 */     GIR_EraseRootFromParent_Done,
     /* 1320816 */   // Label 18897: @1320816
     /* 1320816 */   GIM_Try, /*On fail goto*//*Label 18898*/ GIMT_Encode4(1320900), // Rule ID 9854 //
     /* 1320821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1320829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1320832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1320835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1320838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1320841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1320844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320874 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1320874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1320877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1320883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1320885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320899 */     // GIR_Coverage, 9854,
     /* 1320899 */     GIR_EraseRootFromParent_Done,
     /* 1320900 */   // Label 18898: @1320900
     /* 1320900 */   GIM_Try, /*On fail goto*//*Label 18899*/ GIMT_Encode4(1320984), // Rule ID 9855 //
     /* 1320905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1320913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1320916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1320919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1320922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1320925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1320928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320958 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1320958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1320961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1320967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1320969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320983 */     // GIR_Coverage, 9855,
     /* 1320983 */     GIR_EraseRootFromParent_Done,
     /* 1320984 */   // Label 18899: @1320984
     /* 1320984 */   GIM_Try, /*On fail goto*//*Label 18900*/ GIMT_Encode4(1321068), // Rule ID 9858 //
     /* 1320989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1320997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1321000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1321003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1321006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1321009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321042 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1321042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1321045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1321051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1321053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321067 */     // GIR_Coverage, 9858,
     /* 1321067 */     GIR_EraseRootFromParent_Done,
     /* 1321068 */   // Label 18900: @1321068
     /* 1321068 */   GIM_Try, /*On fail goto*//*Label 18901*/ GIMT_Encode4(1321152), // Rule ID 9859 //
     /* 1321073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1321081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1321084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1321087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1321090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1321093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321126 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1321126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1321129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1321135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1321137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321151 */     // GIR_Coverage, 9859,
     /* 1321151 */     GIR_EraseRootFromParent_Done,
     /* 1321152 */   // Label 18901: @1321152
     /* 1321152 */   GIM_Try, /*On fail goto*//*Label 18902*/ GIMT_Encode4(1321236), // Rule ID 9862 //
     /* 1321157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1321165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1321168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1321171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1321174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1321177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1321180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321210 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1321210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1321213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1321219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1321221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321235 */     // GIR_Coverage, 9862,
     /* 1321235 */     GIR_EraseRootFromParent_Done,
     /* 1321236 */   // Label 18902: @1321236
     /* 1321236 */   GIM_Try, /*On fail goto*//*Label 18903*/ GIMT_Encode4(1321320), // Rule ID 9863 //
     /* 1321241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1321249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1321252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1321255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1321258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1321261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1321264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321294 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1321294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1321297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1321303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1321305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321319 */     // GIR_Coverage, 9863,
     /* 1321319 */     GIR_EraseRootFromParent_Done,
     /* 1321320 */   // Label 18903: @1321320
     /* 1321320 */   GIM_Try, /*On fail goto*//*Label 18904*/ GIMT_Encode4(1321404), // Rule ID 9866 //
     /* 1321325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1321333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1321336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1321339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1321342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1321345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321378 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1321378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1321381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1321387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1321389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321403 */     // GIR_Coverage, 9866,
     /* 1321403 */     GIR_EraseRootFromParent_Done,
     /* 1321404 */   // Label 18904: @1321404
     /* 1321404 */   GIM_Try, /*On fail goto*//*Label 18905*/ GIMT_Encode4(1321488), // Rule ID 9867 //
     /* 1321409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1321417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1321420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1321423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1321426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1321429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321462 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1321462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1321465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1321471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1321473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321487 */     // GIR_Coverage, 9867,
     /* 1321487 */     GIR_EraseRootFromParent_Done,
     /* 1321488 */   // Label 18905: @1321488
     /* 1321488 */   GIM_Try, /*On fail goto*//*Label 18906*/ GIMT_Encode4(1321572), // Rule ID 9870 //
     /* 1321493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1321501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1321504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1321507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1321510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1321513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321546 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1321546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1321549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1321555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1321557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321571 */     // GIR_Coverage, 9870,
     /* 1321571 */     GIR_EraseRootFromParent_Done,
     /* 1321572 */   // Label 18906: @1321572
     /* 1321572 */   GIM_Try, /*On fail goto*//*Label 18907*/ GIMT_Encode4(1321656), // Rule ID 9871 //
     /* 1321577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1321585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1321588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1321591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1321594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1321597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321630 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1321630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1321633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1321639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1321641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321655 */     // GIR_Coverage, 9871,
     /* 1321655 */     GIR_EraseRootFromParent_Done,
     /* 1321656 */   // Label 18907: @1321656
     /* 1321656 */   GIM_Try, /*On fail goto*//*Label 18908*/ GIMT_Encode4(1321740), // Rule ID 9874 //
     /* 1321661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1321669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1321672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1321675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1321678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1321681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321714 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1321714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1321717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1321723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1321725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321739 */     // GIR_Coverage, 9874,
     /* 1321739 */     GIR_EraseRootFromParent_Done,
     /* 1321740 */   // Label 18908: @1321740
     /* 1321740 */   GIM_Try, /*On fail goto*//*Label 18909*/ GIMT_Encode4(1321824), // Rule ID 9875 //
     /* 1321745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1321753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1321756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1321759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1321762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1321765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321798 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1321798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1321801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1321807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1321809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321823 */     // GIR_Coverage, 9875,
     /* 1321823 */     GIR_EraseRootFromParent_Done,
     /* 1321824 */   // Label 18909: @1321824
     /* 1321824 */   GIM_Try, /*On fail goto*//*Label 18910*/ GIMT_Encode4(1321908), // Rule ID 9878 //
     /* 1321829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1321837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1321840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1321843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1321846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1321849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1321852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321882 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1321882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1321885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1321891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1321893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321907 */     // GIR_Coverage, 9878,
     /* 1321907 */     GIR_EraseRootFromParent_Done,
     /* 1321908 */   // Label 18910: @1321908
     /* 1321908 */   GIM_Try, /*On fail goto*//*Label 18911*/ GIMT_Encode4(1321992), // Rule ID 9879 //
     /* 1321913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1321921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1321924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1321927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1321930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1321933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1321936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321966 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1321966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1321969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1321975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1321977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321991 */     // GIR_Coverage, 9879,
     /* 1321991 */     GIR_EraseRootFromParent_Done,
     /* 1321992 */   // Label 18911: @1321992
     /* 1321992 */   GIM_Try, /*On fail goto*//*Label 18912*/ GIMT_Encode4(1322076), // Rule ID 9882 //
     /* 1321997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1322005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1322008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1322011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1322014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1322017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322050 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1322050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1322053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1322059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1322061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322075 */     // GIR_Coverage, 9882,
     /* 1322075 */     GIR_EraseRootFromParent_Done,
     /* 1322076 */   // Label 18912: @1322076
     /* 1322076 */   GIM_Try, /*On fail goto*//*Label 18913*/ GIMT_Encode4(1322160), // Rule ID 9883 //
     /* 1322081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1322089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1322092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1322095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1322098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1322101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322134 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1322134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1322137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1322143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1322145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322159 */     // GIR_Coverage, 9883,
     /* 1322159 */     GIR_EraseRootFromParent_Done,
     /* 1322160 */   // Label 18913: @1322160
     /* 1322160 */   GIM_Try, /*On fail goto*//*Label 18914*/ GIMT_Encode4(1322244), // Rule ID 9886 //
     /* 1322165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1322173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1322176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1322179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1322182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1322185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1322188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322218 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1322218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1322221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1322227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1322229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322243 */     // GIR_Coverage, 9886,
     /* 1322243 */     GIR_EraseRootFromParent_Done,
     /* 1322244 */   // Label 18914: @1322244
     /* 1322244 */   GIM_Try, /*On fail goto*//*Label 18915*/ GIMT_Encode4(1322328), // Rule ID 9887 //
     /* 1322249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1322257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1322260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1322263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1322266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1322269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1322272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322302 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1322302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1322305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1322311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1322313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322327 */     // GIR_Coverage, 9887,
     /* 1322327 */     GIR_EraseRootFromParent_Done,
     /* 1322328 */   // Label 18915: @1322328
     /* 1322328 */   GIM_Try, /*On fail goto*//*Label 18916*/ GIMT_Encode4(1322412), // Rule ID 9890 //
     /* 1322333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1322341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1322344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1322347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1322350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1322353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322386 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1322386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1322389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1322395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1322397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322411 */     // GIR_Coverage, 9890,
     /* 1322411 */     GIR_EraseRootFromParent_Done,
     /* 1322412 */   // Label 18916: @1322412
     /* 1322412 */   GIM_Try, /*On fail goto*//*Label 18917*/ GIMT_Encode4(1322496), // Rule ID 9891 //
     /* 1322417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1322425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1322428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1322431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1322434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1322437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322470 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1322470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1322473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1322479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1322481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322495 */     // GIR_Coverage, 9891,
     /* 1322495 */     GIR_EraseRootFromParent_Done,
     /* 1322496 */   // Label 18917: @1322496
     /* 1322496 */   GIM_Try, /*On fail goto*//*Label 18918*/ GIMT_Encode4(1322580), // Rule ID 9894 //
     /* 1322501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1322509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1322512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1322515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1322518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1322521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322554 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1322554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1322557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1322563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1322565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322579 */     // GIR_Coverage, 9894,
     /* 1322579 */     GIR_EraseRootFromParent_Done,
     /* 1322580 */   // Label 18918: @1322580
     /* 1322580 */   GIM_Try, /*On fail goto*//*Label 18919*/ GIMT_Encode4(1322664), // Rule ID 9895 //
     /* 1322585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1322593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1322596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1322599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1322602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1322605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322638 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1322638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1322641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1322647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1322649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322663 */     // GIR_Coverage, 9895,
     /* 1322663 */     GIR_EraseRootFromParent_Done,
     /* 1322664 */   // Label 18919: @1322664
     /* 1322664 */   GIM_Try, /*On fail goto*//*Label 18920*/ GIMT_Encode4(1322748), // Rule ID 9898 //
     /* 1322669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1322677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1322680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1322683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1322686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1322689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322722 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1322722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1322725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1322731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1322733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322747 */     // GIR_Coverage, 9898,
     /* 1322747 */     GIR_EraseRootFromParent_Done,
     /* 1322748 */   // Label 18920: @1322748
     /* 1322748 */   GIM_Try, /*On fail goto*//*Label 18921*/ GIMT_Encode4(1322832), // Rule ID 9899 //
     /* 1322753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1322761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1322764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1322767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1322770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1322773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322806 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1322806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1322809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1322815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1322817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322831 */     // GIR_Coverage, 9899,
     /* 1322831 */     GIR_EraseRootFromParent_Done,
     /* 1322832 */   // Label 18921: @1322832
     /* 1322832 */   GIM_Try, /*On fail goto*//*Label 18922*/ GIMT_Encode4(1322913), // Rule ID 13840 //
     /* 1322837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1322848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1322851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1322854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1322857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1322860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1322867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322890 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1322890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1322893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322912 */     // GIR_Coverage, 13840,
     /* 1322912 */     GIR_EraseRootFromParent_Done,
     /* 1322913 */   // Label 18922: @1322913
     /* 1322913 */   GIM_Try, /*On fail goto*//*Label 18923*/ GIMT_Encode4(1322994), // Rule ID 13841 //
     /* 1322918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1322929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1322932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1322935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1322938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1322941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1322948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1322971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1322974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322993 */     // GIR_Coverage, 13841,
     /* 1322993 */     GIR_EraseRootFromParent_Done,
     /* 1322994 */   // Label 18923: @1322994
     /* 1322994 */   GIM_Try, /*On fail goto*//*Label 18924*/ GIMT_Encode4(1323075), // Rule ID 13842 //
     /* 1322999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1323010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1323013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1323016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1323019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323052 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1323052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1323055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323074 */     // GIR_Coverage, 13842,
     /* 1323074 */     GIR_EraseRootFromParent_Done,
     /* 1323075 */   // Label 18924: @1323075
     /* 1323075 */   GIM_Try, /*On fail goto*//*Label 18925*/ GIMT_Encode4(1323156), // Rule ID 13843 //
     /* 1323080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1323091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1323094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1323097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1323100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323133 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1323133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1323136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323155 */     // GIR_Coverage, 13843,
     /* 1323155 */     GIR_EraseRootFromParent_Done,
     /* 1323156 */   // Label 18925: @1323156
     /* 1323156 */   GIM_Try, /*On fail goto*//*Label 18926*/ GIMT_Encode4(1323237), // Rule ID 13844 //
     /* 1323161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1323172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1323175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1323178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1323181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323214 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1323214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1323217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323236 */     // GIR_Coverage, 13844,
     /* 1323236 */     GIR_EraseRootFromParent_Done,
     /* 1323237 */   // Label 18926: @1323237
     /* 1323237 */   GIM_Try, /*On fail goto*//*Label 18927*/ GIMT_Encode4(1323318), // Rule ID 13845 //
     /* 1323242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1323253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1323256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1323259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1323262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323295 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1323295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1323298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323317 */     // GIR_Coverage, 13845,
     /* 1323317 */     GIR_EraseRootFromParent_Done,
     /* 1323318 */   // Label 18927: @1323318
     /* 1323318 */   GIM_Try, /*On fail goto*//*Label 18928*/ GIMT_Encode4(1323399), // Rule ID 13846 //
     /* 1323323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1323334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1323337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1323343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1323376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1323379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323398 */     // GIR_Coverage, 13846,
     /* 1323398 */     GIR_EraseRootFromParent_Done,
     /* 1323399 */   // Label 18928: @1323399
     /* 1323399 */   GIM_Try, /*On fail goto*//*Label 18929*/ GIMT_Encode4(1323480), // Rule ID 13847 //
     /* 1323404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1323415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1323418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1323424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323457 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1323457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1323460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323479 */     // GIR_Coverage, 13847,
     /* 1323479 */     GIR_EraseRootFromParent_Done,
     /* 1323480 */   // Label 18929: @1323480
     /* 1323480 */   GIM_Try, /*On fail goto*//*Label 18930*/ GIMT_Encode4(1323561), // Rule ID 13848 //
     /* 1323485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1323496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1323499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1323502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1323505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323538 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1323538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1323541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323560 */     // GIR_Coverage, 13848,
     /* 1323560 */     GIR_EraseRootFromParent_Done,
     /* 1323561 */   // Label 18930: @1323561
     /* 1323561 */   GIM_Try, /*On fail goto*//*Label 18931*/ GIMT_Encode4(1323642), // Rule ID 13849 //
     /* 1323566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1323577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1323580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1323583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1323586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323619 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1323619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1323622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323641 */     // GIR_Coverage, 13849,
     /* 1323641 */     GIR_EraseRootFromParent_Done,
     /* 1323642 */   // Label 18931: @1323642
     /* 1323642 */   GIM_Try, /*On fail goto*//*Label 18932*/ GIMT_Encode4(1323723), // Rule ID 13850 //
     /* 1323647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1323658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1323661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1323664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1323667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323700 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1323700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1323703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323722 */     // GIR_Coverage, 13850,
     /* 1323722 */     GIR_EraseRootFromParent_Done,
     /* 1323723 */   // Label 18932: @1323723
     /* 1323723 */   GIM_Try, /*On fail goto*//*Label 18933*/ GIMT_Encode4(1323804), // Rule ID 13851 //
     /* 1323728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1323739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1323742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1323745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1323748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323781 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1323781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1323784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323803 */     // GIR_Coverage, 13851,
     /* 1323803 */     GIR_EraseRootFromParent_Done,
     /* 1323804 */   // Label 18933: @1323804
     /* 1323804 */   GIM_Try, /*On fail goto*//*Label 18934*/ GIMT_Encode4(1323885), // Rule ID 13852 //
     /* 1323809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1323820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1323823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1323826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1323829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323862 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1323862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1323865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323884 */     // GIR_Coverage, 13852,
     /* 1323884 */     GIR_EraseRootFromParent_Done,
     /* 1323885 */   // Label 18934: @1323885
     /* 1323885 */   GIM_Try, /*On fail goto*//*Label 18935*/ GIMT_Encode4(1323966), // Rule ID 13853 //
     /* 1323890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1323901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1323904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1323907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1323910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323943 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1323943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1323946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323965 */     // GIR_Coverage, 13853,
     /* 1323965 */     GIR_EraseRootFromParent_Done,
     /* 1323966 */   // Label 18935: @1323966
     /* 1323966 */   GIM_Try, /*On fail goto*//*Label 18936*/ GIMT_Encode4(1324047), // Rule ID 13854 //
     /* 1323971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1323982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1323985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1323988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1323991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1324024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1324027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324046 */     // GIR_Coverage, 13854,
     /* 1324046 */     GIR_EraseRootFromParent_Done,
     /* 1324047 */   // Label 18936: @1324047
     /* 1324047 */   GIM_Try, /*On fail goto*//*Label 18937*/ GIMT_Encode4(1324128), // Rule ID 13855 //
     /* 1324052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1324063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1324066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1324069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1324072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1324075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324105 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1324105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1324108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324127 */     // GIR_Coverage, 13855,
     /* 1324127 */     GIR_EraseRootFromParent_Done,
     /* 1324128 */   // Label 18937: @1324128
     /* 1324128 */   GIM_Try, /*On fail goto*//*Label 18938*/ GIMT_Encode4(1324209), // Rule ID 13856 //
     /* 1324133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1324144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1324147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1324150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1324153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324186 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1324186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1324189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324208 */     // GIR_Coverage, 13856,
     /* 1324208 */     GIR_EraseRootFromParent_Done,
     /* 1324209 */   // Label 18938: @1324209
     /* 1324209 */   GIM_Try, /*On fail goto*//*Label 18939*/ GIMT_Encode4(1324290), // Rule ID 13857 //
     /* 1324214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1324225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1324228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1324231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1324234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324267 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1324267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1324270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324289 */     // GIR_Coverage, 13857,
     /* 1324289 */     GIR_EraseRootFromParent_Done,
     /* 1324290 */   // Label 18939: @1324290
     /* 1324290 */   GIM_Try, /*On fail goto*//*Label 18940*/ GIMT_Encode4(1324371), // Rule ID 13858 //
     /* 1324295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1324298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1324306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1324309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1324315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324348 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1324348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1324351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324370 */     // GIR_Coverage, 13858,
     /* 1324370 */     GIR_EraseRootFromParent_Done,
     /* 1324371 */   // Label 18940: @1324371
     /* 1324371 */   GIM_Try, /*On fail goto*//*Label 18941*/ GIMT_Encode4(1324452), // Rule ID 13859 //
     /* 1324376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1324379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1324387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1324390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1324396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324429 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1324429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1324432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324451 */     // GIR_Coverage, 13859,
     /* 1324451 */     GIR_EraseRootFromParent_Done,
     /* 1324452 */   // Label 18941: @1324452
     /* 1324452 */   GIM_Try, /*On fail goto*//*Label 18942*/ GIMT_Encode4(1324533), // Rule ID 13860 //
     /* 1324457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1324468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1324471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1324474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1324477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324510 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1324513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324532 */     // GIR_Coverage, 13860,
     /* 1324532 */     GIR_EraseRootFromParent_Done,
     /* 1324533 */   // Label 18942: @1324533
     /* 1324533 */   GIM_Try, /*On fail goto*//*Label 18943*/ GIMT_Encode4(1324614), // Rule ID 13861 //
     /* 1324538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1324549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1324552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1324555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1324558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324591 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1324594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324613 */     // GIR_Coverage, 13861,
     /* 1324613 */     GIR_EraseRootFromParent_Done,
     /* 1324614 */   // Label 18943: @1324614
     /* 1324614 */   GIM_Try, /*On fail goto*//*Label 18944*/ GIMT_Encode4(1324695), // Rule ID 13862 //
     /* 1324619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1324630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1324633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1324636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1324639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1324642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324672 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1324675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324694 */     // GIR_Coverage, 13862,
     /* 1324694 */     GIR_EraseRootFromParent_Done,
     /* 1324695 */   // Label 18944: @1324695
     /* 1324695 */   GIM_Try, /*On fail goto*//*Label 18945*/ GIMT_Encode4(1324776), // Rule ID 13863 //
     /* 1324700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1324711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1324714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1324717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1324720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1324723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324753 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1324756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324775 */     // GIR_Coverage, 13863,
     /* 1324775 */     GIR_EraseRootFromParent_Done,
     /* 1324776 */   // Label 18945: @1324776
     /* 1324776 */   GIM_Try, /*On fail goto*//*Label 18946*/ GIMT_Encode4(1324857), // Rule ID 13864 //
     /* 1324781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1324792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1324795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1324798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1324801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1324804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1324811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324834 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1324837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324856 */     // GIR_Coverage, 13864,
     /* 1324856 */     GIR_EraseRootFromParent_Done,
     /* 1324857 */   // Label 18946: @1324857
     /* 1324857 */   GIM_Try, /*On fail goto*//*Label 18947*/ GIMT_Encode4(1324938), // Rule ID 13865 //
     /* 1324862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1324873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1324876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1324879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1324882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1324885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1324892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324915 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1324918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324937 */     // GIR_Coverage, 13865,
     /* 1324937 */     GIR_EraseRootFromParent_Done,
     /* 1324938 */   // Label 18947: @1324938
     /* 1324938 */   GIM_Try, /*On fail goto*//*Label 18948*/ GIMT_Encode4(1325019), // Rule ID 13866 //
     /* 1324943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1324954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1324957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1324960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1324963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1324996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1324999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325018 */     // GIR_Coverage, 13866,
     /* 1325018 */     GIR_EraseRootFromParent_Done,
     /* 1325019 */   // Label 18948: @1325019
     /* 1325019 */   GIM_Try, /*On fail goto*//*Label 18949*/ GIMT_Encode4(1325100), // Rule ID 13867 //
     /* 1325024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1325035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1325038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1325041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1325044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1325077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1325080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325099 */     // GIR_Coverage, 13867,
     /* 1325099 */     GIR_EraseRootFromParent_Done,
     /* 1325100 */   // Label 18949: @1325100
     /* 1325100 */   GIM_Try, /*On fail goto*//*Label 18950*/ GIMT_Encode4(1325181), // Rule ID 13868 //
     /* 1325105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1325116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1325119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1325122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1325125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325158 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1325158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1325161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325180 */     // GIR_Coverage, 13868,
     /* 1325180 */     GIR_EraseRootFromParent_Done,
     /* 1325181 */   // Label 18950: @1325181
     /* 1325181 */   GIM_Try, /*On fail goto*//*Label 18951*/ GIMT_Encode4(1325262), // Rule ID 13869 //
     /* 1325186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1325197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1325200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1325203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1325206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325239 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1325239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1325242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325261 */     // GIR_Coverage, 13869,
     /* 1325261 */     GIR_EraseRootFromParent_Done,
     /* 1325262 */   // Label 18951: @1325262
     /* 1325262 */   GIM_Try, /*On fail goto*//*Label 18952*/ GIMT_Encode4(1325343), // Rule ID 13870 //
     /* 1325267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1325278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1325281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1325284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1325287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325320 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1325320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1325323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325342 */     // GIR_Coverage, 13870,
     /* 1325342 */     GIR_EraseRootFromParent_Done,
     /* 1325343 */   // Label 18952: @1325343
     /* 1325343 */   GIM_Try, /*On fail goto*//*Label 18953*/ GIMT_Encode4(1325424), // Rule ID 13871 //
     /* 1325348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1325359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1325362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1325365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1325368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325401 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1325401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1325404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325423 */     // GIR_Coverage, 13871,
     /* 1325423 */     GIR_EraseRootFromParent_Done,
     /* 1325424 */   // Label 18953: @1325424
     /* 1325424 */   GIM_Try, /*On fail goto*//*Label 18954*/ GIMT_Encode4(1325505), // Rule ID 13872 //
     /* 1325429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1325440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1325443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1325446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1325449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325482 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1325485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325504 */     // GIR_Coverage, 13872,
     /* 1325504 */     GIR_EraseRootFromParent_Done,
     /* 1325505 */   // Label 18954: @1325505
     /* 1325505 */   GIM_Try, /*On fail goto*//*Label 18955*/ GIMT_Encode4(1325586), // Rule ID 13873 //
     /* 1325510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1325521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1325524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1325527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1325530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1325563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1325566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325585 */     // GIR_Coverage, 13873,
     /* 1325585 */     GIR_EraseRootFromParent_Done,
     /* 1325586 */   // Label 18955: @1325586
     /* 1325586 */   GIM_Try, /*On fail goto*//*Label 18956*/ GIMT_Encode4(1325667), // Rule ID 13874 //
     /* 1325591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1325602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1325605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1325608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1325611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325644 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1325647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325666 */     // GIR_Coverage, 13874,
     /* 1325666 */     GIR_EraseRootFromParent_Done,
     /* 1325667 */   // Label 18956: @1325667
     /* 1325667 */   GIM_Try, /*On fail goto*//*Label 18957*/ GIMT_Encode4(1325748), // Rule ID 13875 //
     /* 1325672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1325683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1325686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1325689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1325692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325725 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1325725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1325728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325747 */     // GIR_Coverage, 13875,
     /* 1325747 */     GIR_EraseRootFromParent_Done,
     /* 1325748 */   // Label 18957: @1325748
     /* 1325748 */   GIM_Try, /*On fail goto*//*Label 18958*/ GIMT_Encode4(1325829), // Rule ID 13876 //
     /* 1325753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1325764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1325767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1325770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1325773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325806 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1325809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325828 */     // GIR_Coverage, 13876,
     /* 1325828 */     GIR_EraseRootFromParent_Done,
     /* 1325829 */   // Label 18958: @1325829
     /* 1325829 */   GIM_Try, /*On fail goto*//*Label 18959*/ GIMT_Encode4(1325910), // Rule ID 13877 //
     /* 1325834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1325845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1325848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1325851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1325854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325887 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1325887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1325890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325909 */     // GIR_Coverage, 13877,
     /* 1325909 */     GIR_EraseRootFromParent_Done,
     /* 1325910 */   // Label 18959: @1325910
     /* 1325910 */   GIM_Try, /*On fail goto*//*Label 18960*/ GIMT_Encode4(1325991), // Rule ID 13878 //
     /* 1325915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1325918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1325926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1325929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1325932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1325935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1325938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1325968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1325971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1325989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325990 */     // GIR_Coverage, 13878,
     /* 1325990 */     GIR_EraseRootFromParent_Done,
     /* 1325991 */   // Label 18960: @1325991
     /* 1325991 */   GIM_Try, /*On fail goto*//*Label 18961*/ GIMT_Encode4(1326072), // Rule ID 13879 //
     /* 1325996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1325999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1326007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1326010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1326013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1326016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1326026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326049 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1326049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1326052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326071 */     // GIR_Coverage, 13879,
     /* 1326071 */     GIR_EraseRootFromParent_Done,
     /* 1326072 */   // Label 18961: @1326072
     /* 1326072 */   GIM_Try, /*On fail goto*//*Label 18962*/ GIMT_Encode4(1326153), // Rule ID 13880 //
     /* 1326077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1326080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1326088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1326091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1326094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1326097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1326107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326130 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1326130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1326133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326152 */     // GIR_Coverage, 13880,
     /* 1326152 */     GIR_EraseRootFromParent_Done,
     /* 1326153 */   // Label 18962: @1326153
     /* 1326153 */   GIM_Try, /*On fail goto*//*Label 18963*/ GIMT_Encode4(1326234), // Rule ID 13881 //
     /* 1326158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1326161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1326169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1326172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1326175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1326178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1326188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326211 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1326211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1326214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326233 */     // GIR_Coverage, 13881,
     /* 1326233 */     GIR_EraseRootFromParent_Done,
     /* 1326234 */   // Label 18963: @1326234
     /* 1326234 */   GIM_Try, /*On fail goto*//*Label 18964*/ GIMT_Encode4(1326315), // Rule ID 13882 //
     /* 1326239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1326242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1326250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1326253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1326256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1326259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326292 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1326292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1326295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326314 */     // GIR_Coverage, 13882,
     /* 1326314 */     GIR_EraseRootFromParent_Done,
     /* 1326315 */   // Label 18964: @1326315
     /* 1326315 */   GIM_Try, /*On fail goto*//*Label 18965*/ GIMT_Encode4(1326396), // Rule ID 13883 //
     /* 1326320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1326323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1326331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1326334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1326337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1326340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326373 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1326373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1326376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326395 */     // GIR_Coverage, 13883,
     /* 1326395 */     GIR_EraseRootFromParent_Done,
     /* 1326396 */   // Label 18965: @1326396
     /* 1326396 */   GIM_Try, /*On fail goto*//*Label 18966*/ GIMT_Encode4(1326477), // Rule ID 13884 //
     /* 1326401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1326404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1326412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1326415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1326418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1326431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326454 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1326454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1326457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1326475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326476 */     // GIR_Coverage, 13884,
     /* 1326476 */     GIR_EraseRootFromParent_Done,
     /* 1326477 */   // Label 18966: @1326477
     /* 1326477 */   GIM_Try, /*On fail goto*//*Label 18967*/ GIMT_Encode4(1326558), // Rule ID 13885 //
     /* 1326482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1326485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1326493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1326496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1326499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1326512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326535 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1326535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1326538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1326556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326557 */     // GIR_Coverage, 13885,
     /* 1326557 */     GIR_EraseRootFromParent_Done,
     /* 1326558 */   // Label 18967: @1326558
     /* 1326558 */   GIM_Try, /*On fail goto*//*Label 18968*/ GIMT_Encode4(1326639), // Rule ID 13886 //
     /* 1326563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1326566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1326574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1326577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1326580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1326593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326616 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1326616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1326619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1326637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326638 */     // GIR_Coverage, 13886,
     /* 1326638 */     GIR_EraseRootFromParent_Done,
     /* 1326639 */   // Label 18968: @1326639
     /* 1326639 */   GIM_Try, /*On fail goto*//*Label 18969*/ GIMT_Encode4(1326720), // Rule ID 13887 //
     /* 1326644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1326647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1326655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1326658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1326661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1326674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326697 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1326697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1326700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1326718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326719 */     // GIR_Coverage, 13887,
     /* 1326719 */     GIR_EraseRootFromParent_Done,
     /* 1326720 */   // Label 18969: @1326720
     /* 1326720 */   GIM_Try, /*On fail goto*//*Label 18970*/ GIMT_Encode4(1326801), // Rule ID 13888 //
     /* 1326725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1326728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1326736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1326739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1326742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1326755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326778 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1326778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1326781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1326799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326800 */     // GIR_Coverage, 13888,
     /* 1326800 */     GIR_EraseRootFromParent_Done,
     /* 1326801 */   // Label 18970: @1326801
     /* 1326801 */   GIM_Try, /*On fail goto*//*Label 18971*/ GIMT_Encode4(1326882), // Rule ID 13889 //
     /* 1326806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1326809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1326817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1326820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1326823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1326836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326859 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1326859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1326862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1326880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326881 */     // GIR_Coverage, 13889,
     /* 1326881 */     GIR_EraseRootFromParent_Done,
     /* 1326882 */   // Label 18971: @1326882
     /* 1326882 */   GIM_Try, /*On fail goto*//*Label 18972*/ GIMT_Encode4(1326963), // Rule ID 13890 //
     /* 1326887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1326890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1326898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1326901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1326904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1326917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326940 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1326940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1326943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326962 */     // GIR_Coverage, 13890,
     /* 1326962 */     GIR_EraseRootFromParent_Done,
     /* 1326963 */   // Label 18972: @1326963
     /* 1326963 */   GIM_Try, /*On fail goto*//*Label 18973*/ GIMT_Encode4(1327044), // Rule ID 13891 //
     /* 1326968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1326971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1326979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1326982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1326985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1326998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1327010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327021 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1327021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1327024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327043 */     // GIR_Coverage, 13891,
     /* 1327043 */     GIR_EraseRootFromParent_Done,
     /* 1327044 */   // Label 18973: @1327044
     /* 1327044 */   GIM_Try, /*On fail goto*//*Label 18974*/ GIMT_Encode4(1327125), // Rule ID 13892 //
     /* 1327049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1327052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1327057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1327060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1327063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1327066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1327091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327102 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1327102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1327105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327124 */     // GIR_Coverage, 13892,
     /* 1327124 */     GIR_EraseRootFromParent_Done,
     /* 1327125 */   // Label 18974: @1327125
     /* 1327125 */   GIM_Try, /*On fail goto*//*Label 18975*/ GIMT_Encode4(1327206), // Rule ID 13893 //
     /* 1327130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1327133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1327138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1327141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1327144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1327147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1327172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327183 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1327183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1327186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327205 */     // GIR_Coverage, 13893,
     /* 1327205 */     GIR_EraseRootFromParent_Done,
     /* 1327206 */   // Label 18975: @1327206
     /* 1327206 */   GIM_Try, /*On fail goto*//*Label 18976*/ GIMT_Encode4(1327287), // Rule ID 13894 //
     /* 1327211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1327214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1327219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1327222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1327225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1327228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1327253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1327264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1327267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327286 */     // GIR_Coverage, 13894,
     /* 1327286 */     GIR_EraseRootFromParent_Done,
     /* 1327287 */   // Label 18976: @1327287
     /* 1327287 */   GIM_Try, /*On fail goto*//*Label 18977*/ GIMT_Encode4(1327368), // Rule ID 13895 //
     /* 1327292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1327295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1327300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1327303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1327306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1327309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1327334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327345 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1327345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1327348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327367 */     // GIR_Coverage, 13895,
     /* 1327367 */     GIR_EraseRootFromParent_Done,
     /* 1327368 */   // Label 18977: @1327368
     /* 1327368 */   GIM_Try, /*On fail goto*//*Label 18978*/ GIMT_Encode4(1327449), // Rule ID 13896 //
     /* 1327373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1327376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1327381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1327384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1327387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1327390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1327415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1327426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1327429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1327447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327448 */     // GIR_Coverage, 13896,
     /* 1327448 */     GIR_EraseRootFromParent_Done,
     /* 1327449 */   // Label 18978: @1327449
     /* 1327449 */   GIM_Try, /*On fail goto*//*Label 18979*/ GIMT_Encode4(1327530), // Rule ID 13897 //
     /* 1327454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1327457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1327462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1327465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1327468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1327471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1327496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327507 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1327507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1327510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1327528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327529 */     // GIR_Coverage, 13897,
     /* 1327529 */     GIR_EraseRootFromParent_Done,
     /* 1327530 */   // Label 18979: @1327530
     /* 1327530 */   GIM_Try, /*On fail goto*//*Label 18980*/ GIMT_Encode4(1327611), // Rule ID 13898 //
     /* 1327535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1327538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1327543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1327546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1327549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1327552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1327577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327588 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1327588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1327591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327610 */     // GIR_Coverage, 13898,
     /* 1327610 */     GIR_EraseRootFromParent_Done,
     /* 1327611 */   // Label 18980: @1327611
     /* 1327611 */   GIM_Try, /*On fail goto*//*Label 18981*/ GIMT_Encode4(1327692), // Rule ID 13899 //
     /* 1327616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1327619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1327624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1327627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1327630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1327633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1327658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327669 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1327669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1327672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327691 */     // GIR_Coverage, 13899,
     /* 1327691 */     GIR_EraseRootFromParent_Done,
     /* 1327692 */   // Label 18981: @1327692
     /* 1327692 */   GIM_Try, /*On fail goto*//*Label 18982*/ GIMT_Encode4(1327773), // Rule ID 13900 //
     /* 1327697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1327700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1327705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1327708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1327711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1327714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1327739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327750 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1327750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1327753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327772 */     // GIR_Coverage, 13900,
     /* 1327772 */     GIR_EraseRootFromParent_Done,
     /* 1327773 */   // Label 18982: @1327773
     /* 1327773 */   GIM_Try, /*On fail goto*//*Label 18983*/ GIMT_Encode4(1327854), // Rule ID 13901 //
     /* 1327778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1327781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1327786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1327789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1327792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1327795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1327820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327831 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1327831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1327834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327853 */     // GIR_Coverage, 13901,
     /* 1327853 */     GIR_EraseRootFromParent_Done,
     /* 1327854 */   // Label 18983: @1327854
     /* 1327854 */   GIM_Try, /*On fail goto*//*Label 18984*/ GIMT_Encode4(1327935), // Rule ID 13902 //
     /* 1327859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1327862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1327867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1327870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1327873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1327876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1327901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327912 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1327912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1327915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327934 */     // GIR_Coverage, 13902,
     /* 1327934 */     GIR_EraseRootFromParent_Done,
     /* 1327935 */   // Label 18984: @1327935
     /* 1327935 */   GIM_Try, /*On fail goto*//*Label 18985*/ GIMT_Encode4(1328016), // Rule ID 13903 //
     /* 1327940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1327943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1327948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1327951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1327954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1327957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1327970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1327982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327993 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1327993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1327996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328015 */     // GIR_Coverage, 13903,
     /* 1328015 */     GIR_EraseRootFromParent_Done,
     /* 1328016 */   // Label 18985: @1328016
     /* 1328016 */   GIM_Try, /*On fail goto*//*Label 18986*/ GIMT_Encode4(1328097), // Rule ID 13904 //
     /* 1328021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1328024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1328029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1328032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1328035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1328038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1328051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1328063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328074 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1328074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1328077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1328095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328096 */     // GIR_Coverage, 13904,
     /* 1328096 */     GIR_EraseRootFromParent_Done,
     /* 1328097 */   // Label 18986: @1328097
     /* 1328097 */   GIM_Try, /*On fail goto*//*Label 18987*/ GIMT_Encode4(1328178), // Rule ID 13905 //
     /* 1328102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1328105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1328110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1328113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1328116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1328119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1328132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1328144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328155 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1328155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1328158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1328176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328177 */     // GIR_Coverage, 13905,
     /* 1328177 */     GIR_EraseRootFromParent_Done,
     /* 1328178 */   // Label 18987: @1328178
     /* 1328178 */   GIM_Try, /*On fail goto*//*Label 18988*/ GIMT_Encode4(1328259), // Rule ID 13906 //
     /* 1328183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1328186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1328191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1328194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1328197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1328200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1328206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1328213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1328225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328236 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1328236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1328239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1328257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328258 */     // GIR_Coverage, 13906,
     /* 1328258 */     GIR_EraseRootFromParent_Done,
     /* 1328259 */   // Label 18988: @1328259
     /* 1328259 */   GIM_Try, /*On fail goto*//*Label 18989*/ GIMT_Encode4(1328340), // Rule ID 13907 //
     /* 1328264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1328267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1328272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1328275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1328278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1328281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1328287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1328294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1328306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328317 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1328317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1328320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1328338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328339 */     // GIR_Coverage, 13907,
     /* 1328339 */     GIR_EraseRootFromParent_Done,
     /* 1328340 */   // Label 18989: @1328340
     /* 1328340 */   GIM_Try, /*On fail goto*//*Label 18990*/ GIMT_Encode4(1328421), // Rule ID 13908 //
     /* 1328345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1328348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1328353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1328356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1328359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1328362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1328368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1328375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1328387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328398 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1328398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1328401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1328419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328420 */     // GIR_Coverage, 13908,
     /* 1328420 */     GIR_EraseRootFromParent_Done,
     /* 1328421 */   // Label 18990: @1328421
     /* 1328421 */   GIM_Try, /*On fail goto*//*Label 18991*/ GIMT_Encode4(1328502), // Rule ID 13909 //
     /* 1328426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1328429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1328434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1328437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1328440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1328443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1328449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1328456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1328468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328479 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1328479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1328482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1328500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328501 */     // GIR_Coverage, 13909,
     /* 1328501 */     GIR_EraseRootFromParent_Done,
     /* 1328502 */   // Label 18991: @1328502
     /* 1328502 */   GIM_Try, /*On fail goto*//*Label 18992*/ GIMT_Encode4(1328583), // Rule ID 13910 //
     /* 1328507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1328510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1328515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1328518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1328521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1328524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1328537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1328549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328560 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1328560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1328563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328582 */     // GIR_Coverage, 13910,
     /* 1328582 */     GIR_EraseRootFromParent_Done,
     /* 1328583 */   // Label 18992: @1328583
     /* 1328583 */   GIM_Try, /*On fail goto*//*Label 18993*/ GIMT_Encode4(1328664), // Rule ID 13911 //
     /* 1328588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1328591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1328596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1328599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1328602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1328605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1328618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1328630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328641 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1328641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1328644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328663 */     // GIR_Coverage, 13911,
     /* 1328663 */     GIR_EraseRootFromParent_Done,
     /* 1328664 */   // Label 18993: @1328664
     /* 1328664 */   GIM_Try, /*On fail goto*//*Label 18994*/ GIMT_Encode4(1328745), // Rule ID 13912 //
     /* 1328669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1328672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1328677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1328680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1328683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1328686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1328699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1328711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328722 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1328722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1328725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328744 */     // GIR_Coverage, 13912,
     /* 1328744 */     GIR_EraseRootFromParent_Done,
     /* 1328745 */   // Label 18994: @1328745
     /* 1328745 */   GIM_Try, /*On fail goto*//*Label 18995*/ GIMT_Encode4(1328826), // Rule ID 13913 //
     /* 1328750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1328753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1328758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1328761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1328764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1328767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1328780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1328792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328803 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1328803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1328806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328825 */     // GIR_Coverage, 13913,
     /* 1328825 */     GIR_EraseRootFromParent_Done,
     /* 1328826 */   // Label 18995: @1328826
     /* 1328826 */   GIM_Try, /*On fail goto*//*Label 18996*/ GIMT_Encode4(1328907), // Rule ID 13914 //
     /* 1328831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1328834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1328839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1328842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1328845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1328848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1328854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1328861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1328873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328884 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1328884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1328887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328906 */     // GIR_Coverage, 13914,
     /* 1328906 */     GIR_EraseRootFromParent_Done,
     /* 1328907 */   // Label 18996: @1328907
     /* 1328907 */   GIM_Try, /*On fail goto*//*Label 18997*/ GIMT_Encode4(1328988), // Rule ID 13915 //
     /* 1328912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1328915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1328920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1328923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1328926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1328929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1328935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1328942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1328954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328965 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1328965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1328968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328987 */     // GIR_Coverage, 13915,
     /* 1328987 */     GIR_EraseRootFromParent_Done,
     /* 1328988 */   // Label 18997: @1328988
     /* 1328988 */   GIM_Try, /*On fail goto*//*Label 18998*/ GIMT_Encode4(1329069), // Rule ID 13916 //
     /* 1328993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1328996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1329001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1329004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1329007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1329010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1329023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1329035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329046 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1329046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1329049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329068 */     // GIR_Coverage, 13916,
     /* 1329068 */     GIR_EraseRootFromParent_Done,
     /* 1329069 */   // Label 18998: @1329069
     /* 1329069 */   GIM_Try, /*On fail goto*//*Label 18999*/ GIMT_Encode4(1329150), // Rule ID 13917 //
     /* 1329074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1329077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1329082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1329085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1329088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1329091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1329104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1329116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1329127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1329130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329149 */     // GIR_Coverage, 13917,
     /* 1329149 */     GIR_EraseRootFromParent_Done,
     /* 1329150 */   // Label 18999: @1329150
     /* 1329150 */   GIM_Try, /*On fail goto*//*Label 19000*/ GIMT_Encode4(1329231), // Rule ID 13918 //
     /* 1329155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1329158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1329163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1329166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1329169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1329172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1329185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1329197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329208 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1329208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1329211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329230 */     // GIR_Coverage, 13918,
     /* 1329230 */     GIR_EraseRootFromParent_Done,
     /* 1329231 */   // Label 19000: @1329231
     /* 1329231 */   GIM_Try, /*On fail goto*//*Label 19001*/ GIMT_Encode4(1329312), // Rule ID 13919 //
     /* 1329236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1329239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1329244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1329247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1329250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1329253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1329266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1329278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329289 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1329289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1329292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329311 */     // GIR_Coverage, 13919,
     /* 1329311 */     GIR_EraseRootFromParent_Done,
     /* 1329312 */   // Label 19001: @1329312
     /* 1329312 */   GIM_Try, /*On fail goto*//*Label 19002*/ GIMT_Encode4(1329393), // Rule ID 13920 //
     /* 1329317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1329320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1329325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1329328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1329331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1329334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1329340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1329347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1329359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329370 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1329370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1329373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329392 */     // GIR_Coverage, 13920,
     /* 1329392 */     GIR_EraseRootFromParent_Done,
     /* 1329393 */   // Label 19002: @1329393
     /* 1329393 */   GIM_Try, /*On fail goto*//*Label 19003*/ GIMT_Encode4(1329474), // Rule ID 13921 //
     /* 1329398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1329401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1329406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1329409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1329412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1329415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1329421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1329428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1329440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329451 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1329451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1329454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329473 */     // GIR_Coverage, 13921,
     /* 1329473 */     GIR_EraseRootFromParent_Done,
     /* 1329474 */   // Label 19003: @1329474
     /* 1329474 */   GIM_Try, /*On fail goto*//*Label 19004*/ GIMT_Encode4(1329555), // Rule ID 13922 //
     /* 1329479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1329482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1329487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1329490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1329493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1329496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1329509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1329521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329532 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1329532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1329535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329554 */     // GIR_Coverage, 13922,
     /* 1329554 */     GIR_EraseRootFromParent_Done,
     /* 1329555 */   // Label 19004: @1329555
     /* 1329555 */   GIM_Try, /*On fail goto*//*Label 19005*/ GIMT_Encode4(1329636), // Rule ID 13923 //
     /* 1329560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1329563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1329568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1329571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1329574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1329577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1329590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1329602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329613 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1329613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1329616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329635 */     // GIR_Coverage, 13923,
     /* 1329635 */     GIR_EraseRootFromParent_Done,
     /* 1329636 */   // Label 19005: @1329636
     /* 1329636 */   GIM_Try, /*On fail goto*//*Label 19006*/ GIMT_Encode4(1329717), // Rule ID 13924 //
     /* 1329641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1329644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1329649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1329652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1329655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1329658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1329671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1329683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329694 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1329694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1329697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329716 */     // GIR_Coverage, 13924,
     /* 1329716 */     GIR_EraseRootFromParent_Done,
     /* 1329717 */   // Label 19006: @1329717
     /* 1329717 */   GIM_Try, /*On fail goto*//*Label 19007*/ GIMT_Encode4(1329798), // Rule ID 13925 //
     /* 1329722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1329725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1329730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1329733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1329736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1329739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1329752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1329764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329775 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1329775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1329778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329797 */     // GIR_Coverage, 13925,
     /* 1329797 */     GIR_EraseRootFromParent_Done,
     /* 1329798 */   // Label 19007: @1329798
     /* 1329798 */   GIM_Try, /*On fail goto*//*Label 19008*/ GIMT_Encode4(1329879), // Rule ID 13926 //
     /* 1329803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1329806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1329811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1329814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1329817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1329820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1329833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1329845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329856 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1329856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1329859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329878 */     // GIR_Coverage, 13926,
     /* 1329878 */     GIR_EraseRootFromParent_Done,
     /* 1329879 */   // Label 19008: @1329879
     /* 1329879 */   GIM_Try, /*On fail goto*//*Label 19009*/ GIMT_Encode4(1329960), // Rule ID 13927 //
     /* 1329884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1329887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1329892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1329895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1329898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1329901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1329914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1329926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329937 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1329937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1329940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329959 */     // GIR_Coverage, 13927,
     /* 1329959 */     GIR_EraseRootFromParent_Done,
     /* 1329960 */   // Label 19009: @1329960
     /* 1329960 */   GIM_Try, /*On fail goto*//*Label 19010*/ GIMT_Encode4(1330044), // Rule ID 19766 //
     /* 1329965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1329982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1329985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330018 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1330021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330043 */     // GIR_Coverage, 19766,
     /* 1330043 */     GIR_EraseRootFromParent_Done,
     /* 1330044 */   // Label 19010: @1330044
     /* 1330044 */   GIM_Try, /*On fail goto*//*Label 19011*/ GIMT_Encode4(1330128), // Rule ID 19767 //
     /* 1330049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1330060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1330063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1330066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1330069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1330072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330102 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1330105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330127 */     // GIR_Coverage, 19767,
     /* 1330127 */     GIR_EraseRootFromParent_Done,
     /* 1330128 */   // Label 19011: @1330128
     /* 1330128 */   GIM_Try, /*On fail goto*//*Label 19012*/ GIMT_Encode4(1330212), // Rule ID 19770 //
     /* 1330133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1330144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1330147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1330150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1330153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1330156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330186 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1330189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330211 */     // GIR_Coverage, 19770,
     /* 1330211 */     GIR_EraseRootFromParent_Done,
     /* 1330212 */   // Label 19012: @1330212
     /* 1330212 */   GIM_Try, /*On fail goto*//*Label 19013*/ GIMT_Encode4(1330296), // Rule ID 19771 //
     /* 1330217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1330228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1330231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1330234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1330237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1330240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330270 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1330273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330295 */     // GIR_Coverage, 19771,
     /* 1330295 */     GIR_EraseRootFromParent_Done,
     /* 1330296 */   // Label 19013: @1330296
     /* 1330296 */   GIM_Try, /*On fail goto*//*Label 19014*/ GIMT_Encode4(1330380), // Rule ID 19774 //
     /* 1330301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1330312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1330315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1330318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1330321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1330324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330354 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1330357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330379 */     // GIR_Coverage, 19774,
     /* 1330379 */     GIR_EraseRootFromParent_Done,
     /* 1330380 */   // Label 19014: @1330380
     /* 1330380 */   GIM_Try, /*On fail goto*//*Label 19015*/ GIMT_Encode4(1330464), // Rule ID 19775 //
     /* 1330385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1330396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1330399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1330402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1330405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1330408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330438 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1330441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330463 */     // GIR_Coverage, 19775,
     /* 1330463 */     GIR_EraseRootFromParent_Done,
     /* 1330464 */   // Label 19015: @1330464
     /* 1330464 */   GIM_Try, /*On fail goto*//*Label 19016*/ GIMT_Encode4(1330548), // Rule ID 19778 //
     /* 1330469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1330486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1330489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330522 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1330525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330547 */     // GIR_Coverage, 19778,
     /* 1330547 */     GIR_EraseRootFromParent_Done,
     /* 1330548 */   // Label 19016: @1330548
     /* 1330548 */   GIM_Try, /*On fail goto*//*Label 19017*/ GIMT_Encode4(1330632), // Rule ID 19779 //
     /* 1330553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1330570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1330573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330606 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1330609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330631 */     // GIR_Coverage, 19779,
     /* 1330631 */     GIR_EraseRootFromParent_Done,
     /* 1330632 */   // Label 19017: @1330632
     /* 1330632 */   GIM_Try, /*On fail goto*//*Label 19018*/ GIMT_Encode4(1330716), // Rule ID 19782 //
     /* 1330637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1330648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1330651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1330654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1330657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1330660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330690 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1330693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330715 */     // GIR_Coverage, 19782,
     /* 1330715 */     GIR_EraseRootFromParent_Done,
     /* 1330716 */   // Label 19018: @1330716
     /* 1330716 */   GIM_Try, /*On fail goto*//*Label 19019*/ GIMT_Encode4(1330800), // Rule ID 19783 //
     /* 1330721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1330732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1330735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1330738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1330741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1330744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330774 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1330777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330799 */     // GIR_Coverage, 19783,
     /* 1330799 */     GIR_EraseRootFromParent_Done,
     /* 1330800 */   // Label 19019: @1330800
     /* 1330800 */   GIM_Try, /*On fail goto*//*Label 19020*/ GIMT_Encode4(1330884), // Rule ID 19786 //
     /* 1330805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1330808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1330816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1330819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1330822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1330825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1330828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330858 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1330861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330883 */     // GIR_Coverage, 19786,
     /* 1330883 */     GIR_EraseRootFromParent_Done,
     /* 1330884 */   // Label 19020: @1330884
     /* 1330884 */   GIM_Try, /*On fail goto*//*Label 19021*/ GIMT_Encode4(1330968), // Rule ID 19787 //
     /* 1330889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1330892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1330900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1330903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1330906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1330909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1330912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330942 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1330945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330967 */     // GIR_Coverage, 19787,
     /* 1330967 */     GIR_EraseRootFromParent_Done,
     /* 1330968 */   // Label 19021: @1330968
     /* 1330968 */   GIM_Try, /*On fail goto*//*Label 19022*/ GIMT_Encode4(1331052), // Rule ID 19790 //
     /* 1330973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1330990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1330993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331026 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1331029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331051 */     // GIR_Coverage, 19790,
     /* 1331051 */     GIR_EraseRootFromParent_Done,
     /* 1331052 */   // Label 19022: @1331052
     /* 1331052 */   GIM_Try, /*On fail goto*//*Label 19023*/ GIMT_Encode4(1331136), // Rule ID 19791 //
     /* 1331057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1331074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1331077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331110 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1331113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331135 */     // GIR_Coverage, 19791,
     /* 1331135 */     GIR_EraseRootFromParent_Done,
     /* 1331136 */   // Label 19023: @1331136
     /* 1331136 */   GIM_Try, /*On fail goto*//*Label 19024*/ GIMT_Encode4(1331220), // Rule ID 19794 //
     /* 1331141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1331152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1331155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1331158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1331161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1331164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331194 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1331197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331219 */     // GIR_Coverage, 19794,
     /* 1331219 */     GIR_EraseRootFromParent_Done,
     /* 1331220 */   // Label 19024: @1331220
     /* 1331220 */   GIM_Try, /*On fail goto*//*Label 19025*/ GIMT_Encode4(1331304), // Rule ID 19795 //
     /* 1331225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1331236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1331239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1331242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1331245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1331248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331278 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1331281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331303 */     // GIR_Coverage, 19795,
     /* 1331303 */     GIR_EraseRootFromParent_Done,
     /* 1331304 */   // Label 19025: @1331304
     /* 1331304 */   GIM_Try, /*On fail goto*//*Label 19026*/ GIMT_Encode4(1331388), // Rule ID 19798 //
     /* 1331309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1331320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1331323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1331326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1331329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1331332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331362 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1331365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331387 */     // GIR_Coverage, 19798,
     /* 1331387 */     GIR_EraseRootFromParent_Done,
     /* 1331388 */   // Label 19026: @1331388
     /* 1331388 */   GIM_Try, /*On fail goto*//*Label 19027*/ GIMT_Encode4(1331472), // Rule ID 19799 //
     /* 1331393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1331404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1331407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1331410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1331413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1331416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331446 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1331449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331471 */     // GIR_Coverage, 19799,
     /* 1331471 */     GIR_EraseRootFromParent_Done,
     /* 1331472 */   // Label 19027: @1331472
     /* 1331472 */   GIM_Try, /*On fail goto*//*Label 19028*/ GIMT_Encode4(1331556), // Rule ID 19802 //
     /* 1331477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1331480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1331494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1331497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331530 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1331533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331555 */     // GIR_Coverage, 19802,
     /* 1331555 */     GIR_EraseRootFromParent_Done,
     /* 1331556 */   // Label 19028: @1331556
     /* 1331556 */   GIM_Try, /*On fail goto*//*Label 19029*/ GIMT_Encode4(1331640), // Rule ID 19803 //
     /* 1331561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1331564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1331578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1331581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331614 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1331617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331639 */     // GIR_Coverage, 19803,
     /* 1331639 */     GIR_EraseRootFromParent_Done,
     /* 1331640 */   // Label 19029: @1331640
     /* 1331640 */   GIM_Try, /*On fail goto*//*Label 19030*/ GIMT_Encode4(1331724), // Rule ID 19806 //
     /* 1331645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1331648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1331662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1331665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331698 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1331701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331723 */     // GIR_Coverage, 19806,
     /* 1331723 */     GIR_EraseRootFromParent_Done,
     /* 1331724 */   // Label 19030: @1331724
     /* 1331724 */   GIM_Try, /*On fail goto*//*Label 19031*/ GIMT_Encode4(1331808), // Rule ID 19807 //
     /* 1331729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1331732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1331746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1331749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1331785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331807 */     // GIR_Coverage, 19807,
     /* 1331807 */     GIR_EraseRootFromParent_Done,
     /* 1331808 */   // Label 19031: @1331808
     /* 1331808 */   GIM_Try, /*On fail goto*//*Label 19032*/ GIMT_Encode4(1331892), // Rule ID 19810 //
     /* 1331813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1331816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1331824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1331827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1331830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1331833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1331836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331866 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1331869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331891 */     // GIR_Coverage, 19810,
     /* 1331891 */     GIR_EraseRootFromParent_Done,
     /* 1331892 */   // Label 19032: @1331892
     /* 1331892 */   GIM_Try, /*On fail goto*//*Label 19033*/ GIMT_Encode4(1331976), // Rule ID 19811 //
     /* 1331897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1331900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1331908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1331911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1331914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1331917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1331920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331950 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1331953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331975 */     // GIR_Coverage, 19811,
     /* 1331975 */     GIR_EraseRootFromParent_Done,
     /* 1331976 */   // Label 19033: @1331976
     /* 1331976 */   GIM_Try, /*On fail goto*//*Label 19034*/ GIMT_Encode4(1332060), // Rule ID 19814 //
     /* 1331981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1331984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1331998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1332001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332034 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1332037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332059 */     // GIR_Coverage, 19814,
     /* 1332059 */     GIR_EraseRootFromParent_Done,
     /* 1332060 */   // Label 19034: @1332060
     /* 1332060 */   GIM_Try, /*On fail goto*//*Label 19035*/ GIMT_Encode4(1332144), // Rule ID 19815 //
     /* 1332065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1332068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1332073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1332076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1332079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1332082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1332085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332118 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1332121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332143 */     // GIR_Coverage, 19815,
     /* 1332143 */     GIR_EraseRootFromParent_Done,
     /* 1332144 */   // Label 19035: @1332144
     /* 1332144 */   GIM_Try, /*On fail goto*//*Label 19036*/ GIMT_Encode4(1332228), // Rule ID 19818 //
     /* 1332149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1332152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1332157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1332166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1332169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332202 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1332205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332227 */     // GIR_Coverage, 19818,
     /* 1332227 */     GIR_EraseRootFromParent_Done,
     /* 1332228 */   // Label 19036: @1332228
     /* 1332228 */   GIM_Try, /*On fail goto*//*Label 19037*/ GIMT_Encode4(1332312), // Rule ID 19819 //
     /* 1332233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1332236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1332241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1332250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1332253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332286 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1332289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332311 */     // GIR_Coverage, 19819,
     /* 1332311 */     GIR_EraseRootFromParent_Done,
     /* 1332312 */   // Label 19037: @1332312
     /* 1332312 */   GIM_Try, /*On fail goto*//*Label 19038*/ GIMT_Encode4(1332396), // Rule ID 19822 //
     /* 1332317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1332320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1332325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1332334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1332337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332370 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1332373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332395 */     // GIR_Coverage, 19822,
     /* 1332395 */     GIR_EraseRootFromParent_Done,
     /* 1332396 */   // Label 19038: @1332396
     /* 1332396 */   GIM_Try, /*On fail goto*//*Label 19039*/ GIMT_Encode4(1332480), // Rule ID 19823 //
     /* 1332401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1332404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1332409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1332418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1332421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332454 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1332457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332479 */     // GIR_Coverage, 19823,
     /* 1332479 */     GIR_EraseRootFromParent_Done,
     /* 1332480 */   // Label 19039: @1332480
     /* 1332480 */   GIM_Try, /*On fail goto*//*Label 19040*/ GIMT_Encode4(1332564), // Rule ID 19826 //
     /* 1332485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1332493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1332502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332538 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1332541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332563 */     // GIR_Coverage, 19826,
     /* 1332563 */     GIR_EraseRootFromParent_Done,
     /* 1332564 */   // Label 19040: @1332564
     /* 1332564 */   GIM_Try, /*On fail goto*//*Label 19041*/ GIMT_Encode4(1332648), // Rule ID 19827 //
     /* 1332569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1332577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1332586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332622 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1332625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332647 */     // GIR_Coverage, 19827,
     /* 1332647 */     GIR_EraseRootFromParent_Done,
     /* 1332648 */   // Label 19041: @1332648
     /* 1332648 */   GIM_Try, /*On fail goto*//*Label 19042*/ GIMT_Encode4(1332732), // Rule ID 19830 //
     /* 1332653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1332661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1332664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1332667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1332670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332706 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1332709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332731 */     // GIR_Coverage, 19830,
     /* 1332731 */     GIR_EraseRootFromParent_Done,
     /* 1332732 */   // Label 19042: @1332732
     /* 1332732 */   GIM_Try, /*On fail goto*//*Label 19043*/ GIMT_Encode4(1332816), // Rule ID 19831 //
     /* 1332737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1332745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1332748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1332751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1332754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332790 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1332793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332815 */     // GIR_Coverage, 19831,
     /* 1332815 */     GIR_EraseRootFromParent_Done,
     /* 1332816 */   // Label 19043: @1332816
     /* 1332816 */   GIM_Try, /*On fail goto*//*Label 19044*/ GIMT_Encode4(1332900), // Rule ID 19834 //
     /* 1332821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1332824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1332829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1332838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1332863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332874 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1332877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332899 */     // GIR_Coverage, 19834,
     /* 1332899 */     GIR_EraseRootFromParent_Done,
     /* 1332900 */   // Label 19044: @1332900
     /* 1332900 */   GIM_Try, /*On fail goto*//*Label 19045*/ GIMT_Encode4(1332984), // Rule ID 19835 //
     /* 1332905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1332908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1332913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1332922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1332947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332958 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1332961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332983 */     // GIR_Coverage, 19835,
     /* 1332983 */     GIR_EraseRootFromParent_Done,
     /* 1332984 */   // Label 19045: @1332984
     /* 1332984 */   GIM_Try, /*On fail goto*//*Label 19046*/ GIMT_Encode4(1333068), // Rule ID 19838 //
     /* 1332989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1332997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1333006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333042 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1333045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333067 */     // GIR_Coverage, 19838,
     /* 1333067 */     GIR_EraseRootFromParent_Done,
     /* 1333068 */   // Label 19046: @1333068
     /* 1333068 */   GIM_Try, /*On fail goto*//*Label 19047*/ GIMT_Encode4(1333152), // Rule ID 19839 //
     /* 1333073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1333076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1333081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1333090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333126 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1333129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333151 */     // GIR_Coverage, 19839,
     /* 1333151 */     GIR_EraseRootFromParent_Done,
     /* 1333152 */   // Label 19047: @1333152
     /* 1333152 */   GIM_Try, /*On fail goto*//*Label 19048*/ GIMT_Encode4(1333236), // Rule ID 19842 //
     /* 1333157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1333165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1333174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1333199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333210 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1333213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333235 */     // GIR_Coverage, 19842,
     /* 1333235 */     GIR_EraseRootFromParent_Done,
     /* 1333236 */   // Label 19048: @1333236
     /* 1333236 */   GIM_Try, /*On fail goto*//*Label 19049*/ GIMT_Encode4(1333320), // Rule ID 19843 //
     /* 1333241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1333249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1333258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1333283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333294 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1333297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333319 */     // GIR_Coverage, 19843,
     /* 1333319 */     GIR_EraseRootFromParent_Done,
     /* 1333320 */   // Label 19049: @1333320
     /* 1333320 */   GIM_Try, /*On fail goto*//*Label 19050*/ GIMT_Encode4(1333404), // Rule ID 19846 //
     /* 1333325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1333333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1333336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1333339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1333342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1333348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1333367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333378 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1333381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333403 */     // GIR_Coverage, 19846,
     /* 1333403 */     GIR_EraseRootFromParent_Done,
     /* 1333404 */   // Label 19050: @1333404
     /* 1333404 */   GIM_Try, /*On fail goto*//*Label 19051*/ GIMT_Encode4(1333488), // Rule ID 19847 //
     /* 1333409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1333417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1333420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1333423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1333426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1333432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1333451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333462 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1333465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333487 */     // GIR_Coverage, 19847,
     /* 1333487 */     GIR_EraseRootFromParent_Done,
     /* 1333488 */   // Label 19051: @1333488
     /* 1333488 */   GIM_Try, /*On fail goto*//*Label 19052*/ GIMT_Encode4(1333572), // Rule ID 19850 //
     /* 1333493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1333496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1333501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1333510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333546 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1333549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333571 */     // GIR_Coverage, 19850,
     /* 1333571 */     GIR_EraseRootFromParent_Done,
     /* 1333572 */   // Label 19052: @1333572
     /* 1333572 */   GIM_Try, /*On fail goto*//*Label 19053*/ GIMT_Encode4(1333656), // Rule ID 19851 //
     /* 1333577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1333580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1333585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1333594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333630 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1333633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333655 */     // GIR_Coverage, 19851,
     /* 1333655 */     GIR_EraseRootFromParent_Done,
     /* 1333656 */   // Label 19053: @1333656
     /* 1333656 */   GIM_Try, /*On fail goto*//*Label 19054*/ GIMT_Encode4(1333740), // Rule ID 19854 //
     /* 1333661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1333664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1333669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1333678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333714 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1333717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333739 */     // GIR_Coverage, 19854,
     /* 1333739 */     GIR_EraseRootFromParent_Done,
     /* 1333740 */   // Label 19054: @1333740
     /* 1333740 */   GIM_Try, /*On fail goto*//*Label 19055*/ GIMT_Encode4(1333824), // Rule ID 19855 //
     /* 1333745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1333748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1333753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1333762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333798 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1333801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333823 */     // GIR_Coverage, 19855,
     /* 1333823 */     GIR_EraseRootFromParent_Done,
     /* 1333824 */   // Label 19055: @1333824
     /* 1333824 */   GIM_Try, /*On fail goto*//*Label 19056*/ GIMT_Encode4(1333908), // Rule ID 19858 //
     /* 1333829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1333832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1333837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1333840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1333843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1333846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1333852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333882 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1333885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333907 */     // GIR_Coverage, 19858,
     /* 1333907 */     GIR_EraseRootFromParent_Done,
     /* 1333908 */   // Label 19056: @1333908
     /* 1333908 */   GIM_Try, /*On fail goto*//*Label 19057*/ GIMT_Encode4(1333992), // Rule ID 19859 //
     /* 1333913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1333916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1333921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1333924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1333927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1333930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1333936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333966 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1333969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333991 */     // GIR_Coverage, 19859,
     /* 1333991 */     GIR_EraseRootFromParent_Done,
     /* 1333992 */   // Label 19057: @1333992
     /* 1333992 */   GIM_Try, /*On fail goto*//*Label 19058*/ GIMT_Encode4(1334076), // Rule ID 19862 //
     /* 1333997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1334005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1334014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334050 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1334053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334075 */     // GIR_Coverage, 19862,
     /* 1334075 */     GIR_EraseRootFromParent_Done,
     /* 1334076 */   // Label 19058: @1334076
     /* 1334076 */   GIM_Try, /*On fail goto*//*Label 19059*/ GIMT_Encode4(1334160), // Rule ID 19863 //
     /* 1334081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1334089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1334098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334134 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1334137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334159 */     // GIR_Coverage, 19863,
     /* 1334159 */     GIR_EraseRootFromParent_Done,
     /* 1334160 */   // Label 19059: @1334160
     /* 1334160 */   GIM_Try, /*On fail goto*//*Label 19060*/ GIMT_Encode4(1334244), // Rule ID 19866 //
     /* 1334165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1334173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1334176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1334182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334218 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1334221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334243 */     // GIR_Coverage, 19866,
     /* 1334243 */     GIR_EraseRootFromParent_Done,
     /* 1334244 */   // Label 19060: @1334244
     /* 1334244 */   GIM_Try, /*On fail goto*//*Label 19061*/ GIMT_Encode4(1334328), // Rule ID 19867 //
     /* 1334249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1334257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1334260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1334266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334302 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1334305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334327 */     // GIR_Coverage, 19867,
     /* 1334327 */     GIR_EraseRootFromParent_Done,
     /* 1334328 */   // Label 19061: @1334328
     /* 1334328 */   GIM_Try, /*On fail goto*//*Label 19062*/ GIMT_Encode4(1334412), // Rule ID 19870 //
     /* 1334333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1334341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1334344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1334347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1334350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1334356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334386 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1334389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334411 */     // GIR_Coverage, 19870,
     /* 1334411 */     GIR_EraseRootFromParent_Done,
     /* 1334412 */   // Label 19062: @1334412
     /* 1334412 */   GIM_Try, /*On fail goto*//*Label 19063*/ GIMT_Encode4(1334496), // Rule ID 19871 //
     /* 1334417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1334425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1334428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1334431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1334434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1334440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334470 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1334473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334495 */     // GIR_Coverage, 19871,
     /* 1334495 */     GIR_EraseRootFromParent_Done,
     /* 1334496 */   // Label 19063: @1334496
     /* 1334496 */   GIM_Try, /*On fail goto*//*Label 19064*/ GIMT_Encode4(1334580), // Rule ID 19874 //
     /* 1334501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1334504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1334509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1334518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334554 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1334557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334579 */     // GIR_Coverage, 19874,
     /* 1334579 */     GIR_EraseRootFromParent_Done,
     /* 1334580 */   // Label 19064: @1334580
     /* 1334580 */   GIM_Try, /*On fail goto*//*Label 19065*/ GIMT_Encode4(1334664), // Rule ID 19875 //
     /* 1334585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1334588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1334593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1334602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334638 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1334641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334663 */     // GIR_Coverage, 19875,
     /* 1334663 */     GIR_EraseRootFromParent_Done,
     /* 1334664 */   // Label 19065: @1334664
     /* 1334664 */   GIM_Try, /*On fail goto*//*Label 19066*/ GIMT_Encode4(1334748), // Rule ID 19878 //
     /* 1334669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1334672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1334677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1334686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334722 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1334725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334747 */     // GIR_Coverage, 19878,
     /* 1334747 */     GIR_EraseRootFromParent_Done,
     /* 1334748 */   // Label 19066: @1334748
     /* 1334748 */   GIM_Try, /*On fail goto*//*Label 19067*/ GIMT_Encode4(1334832), // Rule ID 19879 //
     /* 1334753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1334756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1334761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1334770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334806 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1334809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334831 */     // GIR_Coverage, 19879,
     /* 1334831 */     GIR_EraseRootFromParent_Done,
     /* 1334832 */   // Label 19067: @1334832
     /* 1334832 */   GIM_Try, /*On fail goto*//*Label 19068*/ GIMT_Encode4(1334916), // Rule ID 19882 //
     /* 1334837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1334840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1334845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1334848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1334854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334890 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1334893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334915 */     // GIR_Coverage, 19882,
     /* 1334915 */     GIR_EraseRootFromParent_Done,
     /* 1334916 */   // Label 19068: @1334916
     /* 1334916 */   GIM_Try, /*On fail goto*//*Label 19069*/ GIMT_Encode4(1335000), // Rule ID 19883 //
     /* 1334921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1334924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1334929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1334932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1334938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334974 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1334977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334999 */     // GIR_Coverage, 19883,
     /* 1334999 */     GIR_EraseRootFromParent_Done,
     /* 1335000 */   // Label 19069: @1335000
     /* 1335000 */   GIM_Try, /*On fail goto*//*Label 19070*/ GIMT_Encode4(1335084), // Rule ID 19886 //
     /* 1335005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1335016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1335022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1335025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335058 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1335061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335083 */     // GIR_Coverage, 19886,
     /* 1335083 */     GIR_EraseRootFromParent_Done,
     /* 1335084 */   // Label 19070: @1335084
     /* 1335084 */   GIM_Try, /*On fail goto*//*Label 19071*/ GIMT_Encode4(1335168), // Rule ID 19887 //
     /* 1335089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1335100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1335106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1335109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335142 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1335145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335167 */     // GIR_Coverage, 19887,
     /* 1335167 */     GIR_EraseRootFromParent_Done,
     /* 1335168 */   // Label 19071: @1335168
     /* 1335168 */   GIM_Try, /*On fail goto*//*Label 19072*/ GIMT_Encode4(1335252), // Rule ID 19890 //
     /* 1335173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1335184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1335187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1335190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1335193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1335196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335226 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1335229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335251 */     // GIR_Coverage, 19890,
     /* 1335251 */     GIR_EraseRootFromParent_Done,
     /* 1335252 */   // Label 19072: @1335252
     /* 1335252 */   GIM_Try, /*On fail goto*//*Label 19073*/ GIMT_Encode4(1335336), // Rule ID 19891 //
     /* 1335257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1335268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1335271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1335274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1335277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1335280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335310 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1335313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335335 */     // GIR_Coverage, 19891,
     /* 1335335 */     GIR_EraseRootFromParent_Done,
     /* 1335336 */   // Label 19073: @1335336
     /* 1335336 */   GIM_Try, /*On fail goto*//*Label 19074*/ GIMT_Encode4(1335420), // Rule ID 19894 //
     /* 1335341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1335352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1335358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1335361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335394 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1335397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335419 */     // GIR_Coverage, 19894,
     /* 1335419 */     GIR_EraseRootFromParent_Done,
     /* 1335420 */   // Label 19074: @1335420
     /* 1335420 */   GIM_Try, /*On fail goto*//*Label 19075*/ GIMT_Encode4(1335504), // Rule ID 19895 //
     /* 1335425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1335436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1335442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1335445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335478 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1335481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335503 */     // GIR_Coverage, 19895,
     /* 1335503 */     GIR_EraseRootFromParent_Done,
     /* 1335504 */   // Label 19075: @1335504
     /* 1335504 */   GIM_Try, /*On fail goto*//*Label 19076*/ GIMT_Encode4(1335588), // Rule ID 19898 //
     /* 1335509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1335526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1335529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335562 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1335565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335587 */     // GIR_Coverage, 19898,
     /* 1335587 */     GIR_EraseRootFromParent_Done,
     /* 1335588 */   // Label 19076: @1335588
     /* 1335588 */   GIM_Try, /*On fail goto*//*Label 19077*/ GIMT_Encode4(1335672), // Rule ID 19899 //
     /* 1335593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1335610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1335613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335646 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1335649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335671 */     // GIR_Coverage, 19899,
     /* 1335671 */     GIR_EraseRootFromParent_Done,
     /* 1335672 */   // Label 19077: @1335672
     /* 1335672 */   GIM_Try, /*On fail goto*//*Label 19078*/ GIMT_Encode4(1335756), // Rule ID 19902 //
     /* 1335677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1335688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1335691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1335694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1335697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1335700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335730 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1335733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335755 */     // GIR_Coverage, 19902,
     /* 1335755 */     GIR_EraseRootFromParent_Done,
     /* 1335756 */   // Label 19078: @1335756
     /* 1335756 */   GIM_Try, /*On fail goto*//*Label 19079*/ GIMT_Encode4(1335840), // Rule ID 19903 //
     /* 1335761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1335772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1335775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1335778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1335781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1335784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335814 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1335817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335839 */     // GIR_Coverage, 19903,
     /* 1335839 */     GIR_EraseRootFromParent_Done,
     /* 1335840 */   // Label 19079: @1335840
     /* 1335840 */   GIM_Try, /*On fail goto*//*Label 19080*/ GIMT_Encode4(1335924), // Rule ID 19906 //
     /* 1335845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1335848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1335856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1335862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1335865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335898 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1335901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335923 */     // GIR_Coverage, 19906,
     /* 1335923 */     GIR_EraseRootFromParent_Done,
     /* 1335924 */   // Label 19080: @1335924
     /* 1335924 */   GIM_Try, /*On fail goto*//*Label 19081*/ GIMT_Encode4(1336008), // Rule ID 19907 //
     /* 1335929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1335932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1335940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1335946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1335949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335982 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1335985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336007 */     // GIR_Coverage, 19907,
     /* 1336007 */     GIR_EraseRootFromParent_Done,
     /* 1336008 */   // Label 19081: @1336008
     /* 1336008 */   GIM_Try, /*On fail goto*//*Label 19082*/ GIMT_Encode4(1336092), // Rule ID 19910 //
     /* 1336013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1336030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1336033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336066 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1336069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336091 */     // GIR_Coverage, 19910,
     /* 1336091 */     GIR_EraseRootFromParent_Done,
     /* 1336092 */   // Label 19082: @1336092
     /* 1336092 */   GIM_Try, /*On fail goto*//*Label 19083*/ GIMT_Encode4(1336176), // Rule ID 19911 //
     /* 1336097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1336114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1336117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336150 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1336153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336175 */     // GIR_Coverage, 19911,
     /* 1336175 */     GIR_EraseRootFromParent_Done,
     /* 1336176 */   // Label 19083: @1336176
     /* 1336176 */   GIM_Try, /*On fail goto*//*Label 19084*/ GIMT_Encode4(1336260), // Rule ID 19914 //
     /* 1336181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1336192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1336195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1336198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1336201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1336204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336234 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1336237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336259 */     // GIR_Coverage, 19914,
     /* 1336259 */     GIR_EraseRootFromParent_Done,
     /* 1336260 */   // Label 19084: @1336260
     /* 1336260 */   GIM_Try, /*On fail goto*//*Label 19085*/ GIMT_Encode4(1336344), // Rule ID 19915 //
     /* 1336265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1336276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1336279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1336282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1336285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1336288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336318 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1336321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336343 */     // GIR_Coverage, 19915,
     /* 1336343 */     GIR_EraseRootFromParent_Done,
     /* 1336344 */   // Label 19085: @1336344
     /* 1336344 */   GIM_Try, /*On fail goto*//*Label 19086*/ GIMT_Encode4(1336428), // Rule ID 19918 //
     /* 1336349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1336360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1336363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1336366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1336369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1336372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336402 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1336405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336427 */     // GIR_Coverage, 19918,
     /* 1336427 */     GIR_EraseRootFromParent_Done,
     /* 1336428 */   // Label 19086: @1336428
     /* 1336428 */   GIM_Try, /*On fail goto*//*Label 19087*/ GIMT_Encode4(1336512), // Rule ID 19919 //
     /* 1336433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1336444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1336447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1336450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1336453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1336456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336486 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1336489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336511 */     // GIR_Coverage, 19919,
     /* 1336511 */     GIR_EraseRootFromParent_Done,
     /* 1336512 */   // Label 19087: @1336512
     /* 1336512 */   GIM_Try, /*On fail goto*//*Label 19088*/ GIMT_Encode4(1336596), // Rule ID 19922 //
     /* 1336517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1336520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1336534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1336537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336570 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1336573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336595 */     // GIR_Coverage, 19922,
     /* 1336595 */     GIR_EraseRootFromParent_Done,
     /* 1336596 */   // Label 19088: @1336596
     /* 1336596 */   GIM_Try, /*On fail goto*//*Label 19089*/ GIMT_Encode4(1336680), // Rule ID 19923 //
     /* 1336601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1336604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1336618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1336621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336654 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1336657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336679 */     // GIR_Coverage, 19923,
     /* 1336679 */     GIR_EraseRootFromParent_Done,
     /* 1336680 */   // Label 19089: @1336680
     /* 1336680 */   GIM_Try, /*On fail goto*//*Label 19090*/ GIMT_Encode4(1336764), // Rule ID 19926 //
     /* 1336685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1336688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1336702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1336705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1336741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336763 */     // GIR_Coverage, 19926,
     /* 1336763 */     GIR_EraseRootFromParent_Done,
     /* 1336764 */   // Label 19090: @1336764
     /* 1336764 */   GIM_Try, /*On fail goto*//*Label 19091*/ GIMT_Encode4(1336848), // Rule ID 19927 //
     /* 1336769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1336772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1336786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1336789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336822 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1336825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336847 */     // GIR_Coverage, 19927,
     /* 1336847 */     GIR_EraseRootFromParent_Done,
     /* 1336848 */   // Label 19091: @1336848
     /* 1336848 */   GIM_Try, /*On fail goto*//*Label 19092*/ GIMT_Encode4(1336932), // Rule ID 19930 //
     /* 1336853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1336856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1336864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1336867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1336870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1336873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1336876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336906 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1336909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336931 */     // GIR_Coverage, 19930,
     /* 1336931 */     GIR_EraseRootFromParent_Done,
     /* 1336932 */   // Label 19092: @1336932
     /* 1336932 */   GIM_Try, /*On fail goto*//*Label 19093*/ GIMT_Encode4(1337016), // Rule ID 19931 //
     /* 1336937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1336940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1336948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1336951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1336954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1336957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1336960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336990 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1336993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337015 */     // GIR_Coverage, 19931,
     /* 1337015 */     GIR_EraseRootFromParent_Done,
     /* 1337016 */   // Label 19093: @1337016
     /* 1337016 */   GIM_Try, /*On fail goto*//*Label 19094*/ GIMT_Encode4(1337100), // Rule ID 19934 //
     /* 1337021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1337024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1337029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1337038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1337041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337074 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1337077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337099 */     // GIR_Coverage, 19934,
     /* 1337099 */     GIR_EraseRootFromParent_Done,
     /* 1337100 */   // Label 19094: @1337100
     /* 1337100 */   GIM_Try, /*On fail goto*//*Label 19095*/ GIMT_Encode4(1337184), // Rule ID 19935 //
     /* 1337105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1337108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1337113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1337122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1337125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337158 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1337161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337183 */     // GIR_Coverage, 19935,
     /* 1337183 */     GIR_EraseRootFromParent_Done,
     /* 1337184 */   // Label 19095: @1337184
     /* 1337184 */   GIM_Try, /*On fail goto*//*Label 19096*/ GIMT_Encode4(1337268), // Rule ID 19938 //
     /* 1337189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1337192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1337197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1337206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1337209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337242 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1337245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337267 */     // GIR_Coverage, 19938,
     /* 1337267 */     GIR_EraseRootFromParent_Done,
     /* 1337268 */   // Label 19096: @1337268
     /* 1337268 */   GIM_Try, /*On fail goto*//*Label 19097*/ GIMT_Encode4(1337352), // Rule ID 19939 //
     /* 1337273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1337276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1337281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1337290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1337293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337326 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1337329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337351 */     // GIR_Coverage, 19939,
     /* 1337351 */     GIR_EraseRootFromParent_Done,
     /* 1337352 */   // Label 19097: @1337352
     /* 1337352 */   GIM_Try, /*On fail goto*//*Label 19098*/ GIMT_Encode4(1337436), // Rule ID 19942 //
     /* 1337357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1337360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1337365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1337374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1337377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337410 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1337413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337435 */     // GIR_Coverage, 19942,
     /* 1337435 */     GIR_EraseRootFromParent_Done,
     /* 1337436 */   // Label 19098: @1337436
     /* 1337436 */   GIM_Try, /*On fail goto*//*Label 19099*/ GIMT_Encode4(1337520), // Rule ID 19943 //
     /* 1337441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1337444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1337449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1337458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1337461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337494 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1337497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337519 */     // GIR_Coverage, 19943,
     /* 1337519 */     GIR_EraseRootFromParent_Done,
     /* 1337520 */   // Label 19099: @1337520
     /* 1337520 */   GIM_Try, /*On fail goto*//*Label 19100*/ GIMT_Encode4(1337604), // Rule ID 19946 //
     /* 1337525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1337533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1337542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337578 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1337581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337603 */     // GIR_Coverage, 19946,
     /* 1337603 */     GIR_EraseRootFromParent_Done,
     /* 1337604 */   // Label 19100: @1337604
     /* 1337604 */   GIM_Try, /*On fail goto*//*Label 19101*/ GIMT_Encode4(1337688), // Rule ID 19947 //
     /* 1337609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1337617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1337626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337662 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1337665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337687 */     // GIR_Coverage, 19947,
     /* 1337687 */     GIR_EraseRootFromParent_Done,
     /* 1337688 */   // Label 19101: @1337688
     /* 1337688 */   GIM_Try, /*On fail goto*//*Label 19102*/ GIMT_Encode4(1337772), // Rule ID 19950 //
     /* 1337693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1337701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1337710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337746 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1337749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337771 */     // GIR_Coverage, 19950,
     /* 1337771 */     GIR_EraseRootFromParent_Done,
     /* 1337772 */   // Label 19102: @1337772
     /* 1337772 */   GIM_Try, /*On fail goto*//*Label 19103*/ GIMT_Encode4(1337856), // Rule ID 19951 //
     /* 1337777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1337785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1337794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337830 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1337833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337855 */     // GIR_Coverage, 19951,
     /* 1337855 */     GIR_EraseRootFromParent_Done,
     /* 1337856 */   // Label 19103: @1337856
     /* 1337856 */   GIM_Try, /*On fail goto*//*Label 19104*/ GIMT_Encode4(1337940), // Rule ID 19954 //
     /* 1337861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1337864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1337869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1337878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1337903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337914 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1337917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337939 */     // GIR_Coverage, 19954,
     /* 1337939 */     GIR_EraseRootFromParent_Done,
     /* 1337940 */   // Label 19104: @1337940
     /* 1337940 */   GIM_Try, /*On fail goto*//*Label 19105*/ GIMT_Encode4(1338024), // Rule ID 19955 //
     /* 1337945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1337948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1337953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1337962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1337987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337998 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1338001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338023 */     // GIR_Coverage, 19955,
     /* 1338023 */     GIR_EraseRootFromParent_Done,
     /* 1338024 */   // Label 19105: @1338024
     /* 1338024 */   GIM_Try, /*On fail goto*//*Label 19106*/ GIMT_Encode4(1338108), // Rule ID 19958 //
     /* 1338029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1338032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1338037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1338046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338082 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1338085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338107 */     // GIR_Coverage, 19958,
     /* 1338107 */     GIR_EraseRootFromParent_Done,
     /* 1338108 */   // Label 19106: @1338108
     /* 1338108 */   GIM_Try, /*On fail goto*//*Label 19107*/ GIMT_Encode4(1338192), // Rule ID 19959 //
     /* 1338113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1338116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1338121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1338130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338166 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1338169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338191 */     // GIR_Coverage, 19959,
     /* 1338191 */     GIR_EraseRootFromParent_Done,
     /* 1338192 */   // Label 19107: @1338192
     /* 1338192 */   GIM_Try, /*On fail goto*//*Label 19108*/ GIMT_Encode4(1338276), // Rule ID 19962 //
     /* 1338197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1338205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1338214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1338239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338250 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1338253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338275 */     // GIR_Coverage, 19962,
     /* 1338275 */     GIR_EraseRootFromParent_Done,
     /* 1338276 */   // Label 19108: @1338276
     /* 1338276 */   GIM_Try, /*On fail goto*//*Label 19109*/ GIMT_Encode4(1338360), // Rule ID 19963 //
     /* 1338281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1338289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1338298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1338323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338334 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1338337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338359 */     // GIR_Coverage, 19963,
     /* 1338359 */     GIR_EraseRootFromParent_Done,
     /* 1338360 */   // Label 19109: @1338360
     /* 1338360 */   GIM_Try, /*On fail goto*//*Label 19110*/ GIMT_Encode4(1338444), // Rule ID 19966 //
     /* 1338365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1338373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1338376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1338379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1338382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1338388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1338407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338418 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1338421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338443 */     // GIR_Coverage, 19966,
     /* 1338443 */     GIR_EraseRootFromParent_Done,
     /* 1338444 */   // Label 19110: @1338444
     /* 1338444 */   GIM_Try, /*On fail goto*//*Label 19111*/ GIMT_Encode4(1338528), // Rule ID 19967 //
     /* 1338449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1338457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1338460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1338463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1338466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1338472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1338491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338502 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1338505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338527 */     // GIR_Coverage, 19967,
     /* 1338527 */     GIR_EraseRootFromParent_Done,
     /* 1338528 */   // Label 19111: @1338528
     /* 1338528 */   GIM_Try, /*On fail goto*//*Label 19112*/ GIMT_Encode4(1338612), // Rule ID 19970 //
     /* 1338533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1338536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1338541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1338550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338586 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1338589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338611 */     // GIR_Coverage, 19970,
     /* 1338611 */     GIR_EraseRootFromParent_Done,
     /* 1338612 */   // Label 19112: @1338612
     /* 1338612 */   GIM_Try, /*On fail goto*//*Label 19113*/ GIMT_Encode4(1338696), // Rule ID 19971 //
     /* 1338617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1338620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1338625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1338634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338670 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1338673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338695 */     // GIR_Coverage, 19971,
     /* 1338695 */     GIR_EraseRootFromParent_Done,
     /* 1338696 */   // Label 19113: @1338696
     /* 1338696 */   GIM_Try, /*On fail goto*//*Label 19114*/ GIMT_Encode4(1338780), // Rule ID 19974 //
     /* 1338701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1338704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1338709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1338718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338754 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1338757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338779 */     // GIR_Coverage, 19974,
     /* 1338779 */     GIR_EraseRootFromParent_Done,
     /* 1338780 */   // Label 19114: @1338780
     /* 1338780 */   GIM_Try, /*On fail goto*//*Label 19115*/ GIMT_Encode4(1338864), // Rule ID 19975 //
     /* 1338785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1338788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1338793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1338802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338838 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1338841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338863 */     // GIR_Coverage, 19975,
     /* 1338863 */     GIR_EraseRootFromParent_Done,
     /* 1338864 */   // Label 19115: @1338864
     /* 1338864 */   GIM_Try, /*On fail goto*//*Label 19116*/ GIMT_Encode4(1338948), // Rule ID 19978 //
     /* 1338869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1338872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1338877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1338880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1338883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1338886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1338892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338922 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1338925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338947 */     // GIR_Coverage, 19978,
     /* 1338947 */     GIR_EraseRootFromParent_Done,
     /* 1338948 */   // Label 19116: @1338948
     /* 1338948 */   GIM_Try, /*On fail goto*//*Label 19117*/ GIMT_Encode4(1339032), // Rule ID 19979 //
     /* 1338953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1338956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1338961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1338964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1338967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1338970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1338976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339006 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1339009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339031 */     // GIR_Coverage, 19979,
     /* 1339031 */     GIR_EraseRootFromParent_Done,
     /* 1339032 */   // Label 19117: @1339032
     /* 1339032 */   GIM_Try, /*On fail goto*//*Label 19118*/ GIMT_Encode4(1339116), // Rule ID 19982 //
     /* 1339037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1339045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1339054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339090 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1339093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339115 */     // GIR_Coverage, 19982,
     /* 1339115 */     GIR_EraseRootFromParent_Done,
     /* 1339116 */   // Label 19118: @1339116
     /* 1339116 */   GIM_Try, /*On fail goto*//*Label 19119*/ GIMT_Encode4(1339200), // Rule ID 19983 //
     /* 1339121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1339129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1339138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339174 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1339177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339199 */     // GIR_Coverage, 19983,
     /* 1339199 */     GIR_EraseRootFromParent_Done,
     /* 1339200 */   // Label 19119: @1339200
     /* 1339200 */   GIM_Try, /*On fail goto*//*Label 19120*/ GIMT_Encode4(1339284), // Rule ID 19986 //
     /* 1339205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1339213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1339222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339258 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1339261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339283 */     // GIR_Coverage, 19986,
     /* 1339283 */     GIR_EraseRootFromParent_Done,
     /* 1339284 */   // Label 19120: @1339284
     /* 1339284 */   GIM_Try, /*On fail goto*//*Label 19121*/ GIMT_Encode4(1339368), // Rule ID 19987 //
     /* 1339289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1339297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1339306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339342 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1339345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339367 */     // GIR_Coverage, 19987,
     /* 1339367 */     GIR_EraseRootFromParent_Done,
     /* 1339368 */   // Label 19121: @1339368
     /* 1339368 */   GIM_Try, /*On fail goto*//*Label 19122*/ GIMT_Encode4(1339452), // Rule ID 19990 //
     /* 1339373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1339381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1339384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1339387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1339390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1339396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339426 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1339429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339451 */     // GIR_Coverage, 19990,
     /* 1339451 */     GIR_EraseRootFromParent_Done,
     /* 1339452 */   // Label 19122: @1339452
     /* 1339452 */   GIM_Try, /*On fail goto*//*Label 19123*/ GIMT_Encode4(1339536), // Rule ID 19991 //
     /* 1339457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1339465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1339468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1339471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1339474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1339480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339510 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1339513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339535 */     // GIR_Coverage, 19991,
     /* 1339535 */     GIR_EraseRootFromParent_Done,
     /* 1339536 */   // Label 19123: @1339536
     /* 1339536 */   GIM_Try, /*On fail goto*//*Label 19124*/ GIMT_Encode4(1339620), // Rule ID 19994 //
     /* 1339541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1339544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1339549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1339558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339594 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1339597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339619 */     // GIR_Coverage, 19994,
     /* 1339619 */     GIR_EraseRootFromParent_Done,
     /* 1339620 */   // Label 19124: @1339620
     /* 1339620 */   GIM_Try, /*On fail goto*//*Label 19125*/ GIMT_Encode4(1339704), // Rule ID 19995 //
     /* 1339625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1339628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1339633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1339642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339678 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1339681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339703 */     // GIR_Coverage, 19995,
     /* 1339703 */     GIR_EraseRootFromParent_Done,
     /* 1339704 */   // Label 19125: @1339704
     /* 1339704 */   GIM_Try, /*On fail goto*//*Label 19126*/ GIMT_Encode4(1339788), // Rule ID 19998 //
     /* 1339709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1339712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1339717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1339726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339762 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1339765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339787 */     // GIR_Coverage, 19998,
     /* 1339787 */     GIR_EraseRootFromParent_Done,
     /* 1339788 */   // Label 19126: @1339788
     /* 1339788 */   GIM_Try, /*On fail goto*//*Label 19127*/ GIMT_Encode4(1339872), // Rule ID 19999 //
     /* 1339793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1339796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1339801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1339810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339846 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1339849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339871 */     // GIR_Coverage, 19999,
     /* 1339871 */     GIR_EraseRootFromParent_Done,
     /* 1339872 */   // Label 19127: @1339872
     /* 1339872 */   GIM_Try, /*On fail goto*//*Label 19128*/ GIMT_Encode4(1339956), // Rule ID 20002 //
     /* 1339877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1339880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1339885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1339894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339930 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1339933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339955 */     // GIR_Coverage, 20002,
     /* 1339955 */     GIR_EraseRootFromParent_Done,
     /* 1339956 */   // Label 19128: @1339956
     /* 1339956 */   GIM_Try, /*On fail goto*//*Label 19129*/ GIMT_Encode4(1340040), // Rule ID 20003 //
     /* 1339961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1339964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1339969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1339978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1340003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340014 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1340017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340039 */     // GIR_Coverage, 20003,
     /* 1340039 */     GIR_EraseRootFromParent_Done,
     /* 1340040 */   // Label 19129: @1340040
     /* 1340040 */   GIM_Try, /*On fail goto*//*Label 19130*/ GIMT_Encode4(1340124), // Rule ID 20006 //
     /* 1340045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1340062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1340065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340098 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1340101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340123 */     // GIR_Coverage, 20006,
     /* 1340123 */     GIR_EraseRootFromParent_Done,
     /* 1340124 */   // Label 19130: @1340124
     /* 1340124 */   GIM_Try, /*On fail goto*//*Label 19131*/ GIMT_Encode4(1340208), // Rule ID 20007 //
     /* 1340129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1340146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1340149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340182 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1340185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340207 */     // GIR_Coverage, 20007,
     /* 1340207 */     GIR_EraseRootFromParent_Done,
     /* 1340208 */   // Label 19131: @1340208
     /* 1340208 */   GIM_Try, /*On fail goto*//*Label 19132*/ GIMT_Encode4(1340292), // Rule ID 20010 //
     /* 1340213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1340224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1340227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1340230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1340233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1340236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340266 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1340269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340291 */     // GIR_Coverage, 20010,
     /* 1340291 */     GIR_EraseRootFromParent_Done,
     /* 1340292 */   // Label 19132: @1340292
     /* 1340292 */   GIM_Try, /*On fail goto*//*Label 19133*/ GIMT_Encode4(1340376), // Rule ID 20011 //
     /* 1340297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1340308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1340311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1340314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1340317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1340320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340350 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1340353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340375 */     // GIR_Coverage, 20011,
     /* 1340375 */     GIR_EraseRootFromParent_Done,
     /* 1340376 */   // Label 19133: @1340376
     /* 1340376 */   GIM_Try, /*On fail goto*//*Label 19134*/ GIMT_Encode4(1340460), // Rule ID 20014 //
     /* 1340381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1340398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1340401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340434 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1340437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340459 */     // GIR_Coverage, 20014,
     /* 1340459 */     GIR_EraseRootFromParent_Done,
     /* 1340460 */   // Label 19134: @1340460
     /* 1340460 */   GIM_Try, /*On fail goto*//*Label 19135*/ GIMT_Encode4(1340544), // Rule ID 20015 //
     /* 1340465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1340482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1340485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340518 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1340521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340543 */     // GIR_Coverage, 20015,
     /* 1340543 */     GIR_EraseRootFromParent_Done,
     /* 1340544 */   // Label 19135: @1340544
     /* 1340544 */   GIM_Try, /*On fail goto*//*Label 19136*/ GIMT_Encode4(1340628), // Rule ID 20018 //
     /* 1340549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1340566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1340569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340602 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1340605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340627 */     // GIR_Coverage, 20018,
     /* 1340627 */     GIR_EraseRootFromParent_Done,
     /* 1340628 */   // Label 19136: @1340628
     /* 1340628 */   GIM_Try, /*On fail goto*//*Label 19137*/ GIMT_Encode4(1340712), // Rule ID 20019 //
     /* 1340633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1340650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1340653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340686 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1340689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340711 */     // GIR_Coverage, 20019,
     /* 1340711 */     GIR_EraseRootFromParent_Done,
     /* 1340712 */   // Label 19137: @1340712
     /* 1340712 */   GIM_Try, /*On fail goto*//*Label 19138*/ GIMT_Encode4(1340796), // Rule ID 20022 //
     /* 1340717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1340728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1340731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1340734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1340737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1340740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340770 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1340773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340795 */     // GIR_Coverage, 20022,
     /* 1340795 */     GIR_EraseRootFromParent_Done,
     /* 1340796 */   // Label 19138: @1340796
     /* 1340796 */   GIM_Try, /*On fail goto*//*Label 19139*/ GIMT_Encode4(1340880), // Rule ID 20023 //
     /* 1340801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1340812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1340815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1340818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1340821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1340824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340854 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1340857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340879 */     // GIR_Coverage, 20023,
     /* 1340879 */     GIR_EraseRootFromParent_Done,
     /* 1340880 */   // Label 19139: @1340880
     /* 1340880 */   GIM_Try, /*On fail goto*//*Label 19140*/ GIMT_Encode4(1340964), // Rule ID 20026 //
     /* 1340885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1340888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1340902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1340905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340938 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1340941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340963 */     // GIR_Coverage, 20026,
     /* 1340963 */     GIR_EraseRootFromParent_Done,
     /* 1340964 */   // Label 19140: @1340964
     /* 1340964 */   GIM_Try, /*On fail goto*//*Label 19141*/ GIMT_Encode4(1341048), // Rule ID 20027 //
     /* 1340969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1340972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1340986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1340989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341022 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1341025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341047 */     // GIR_Coverage, 20027,
     /* 1341047 */     GIR_EraseRootFromParent_Done,
     /* 1341048 */   // Label 19141: @1341048
     /* 1341048 */   GIM_Try, /*On fail goto*//*Label 19142*/ GIMT_Encode4(1341132), // Rule ID 20030 //
     /* 1341053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1341070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1341073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341106 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1341109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341131 */     // GIR_Coverage, 20030,
     /* 1341131 */     GIR_EraseRootFromParent_Done,
     /* 1341132 */   // Label 19142: @1341132
     /* 1341132 */   GIM_Try, /*On fail goto*//*Label 19143*/ GIMT_Encode4(1341216), // Rule ID 20031 //
     /* 1341137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1341154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1341157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341190 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1341193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341215 */     // GIR_Coverage, 20031,
     /* 1341215 */     GIR_EraseRootFromParent_Done,
     /* 1341216 */   // Label 19143: @1341216
     /* 1341216 */   GIM_Try, /*On fail goto*//*Label 19144*/ GIMT_Encode4(1341300), // Rule ID 20034 //
     /* 1341221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1341232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1341235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1341238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1341241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1341244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341274 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1341277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341299 */     // GIR_Coverage, 20034,
     /* 1341299 */     GIR_EraseRootFromParent_Done,
     /* 1341300 */   // Label 19144: @1341300
     /* 1341300 */   GIM_Try, /*On fail goto*//*Label 19145*/ GIMT_Encode4(1341384), // Rule ID 20035 //
     /* 1341305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1341316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1341319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1341322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1341325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1341328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341358 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1341361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341383 */     // GIR_Coverage, 20035,
     /* 1341383 */     GIR_EraseRootFromParent_Done,
     /* 1341384 */   // Label 19145: @1341384
     /* 1341384 */   GIM_Try, /*On fail goto*//*Label 19146*/ GIMT_Encode4(1341468), // Rule ID 20038 //
     /* 1341389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1341400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1341403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1341406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1341409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1341412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341442 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1341445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341467 */     // GIR_Coverage, 20038,
     /* 1341467 */     GIR_EraseRootFromParent_Done,
     /* 1341468 */   // Label 19146: @1341468
     /* 1341468 */   GIM_Try, /*On fail goto*//*Label 19147*/ GIMT_Encode4(1341552), // Rule ID 20039 //
     /* 1341473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1341484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1341487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1341490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1341493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1341496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341526 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1341529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341551 */     // GIR_Coverage, 20039,
     /* 1341551 */     GIR_EraseRootFromParent_Done,
     /* 1341552 */   // Label 19147: @1341552
     /* 1341552 */   GIM_Try, /*On fail goto*//*Label 19148*/ GIMT_Encode4(1341636), // Rule ID 20042 //
     /* 1341557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1341560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1341574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1341577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1341613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341635 */     // GIR_Coverage, 20042,
     /* 1341635 */     GIR_EraseRootFromParent_Done,
     /* 1341636 */   // Label 19148: @1341636
     /* 1341636 */   GIM_Try, /*On fail goto*//*Label 19149*/ GIMT_Encode4(1341720), // Rule ID 20043 //
     /* 1341641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1341644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1341658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1341661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341694 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1341697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341719 */     // GIR_Coverage, 20043,
     /* 1341719 */     GIR_EraseRootFromParent_Done,
     /* 1341720 */   // Label 19149: @1341720
     /* 1341720 */   GIM_Try, /*On fail goto*//*Label 19150*/ GIMT_Encode4(1341804), // Rule ID 20046 //
     /* 1341725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1341728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1341742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1341745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341778 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1341781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341803 */     // GIR_Coverage, 20046,
     /* 1341803 */     GIR_EraseRootFromParent_Done,
     /* 1341804 */   // Label 19150: @1341804
     /* 1341804 */   GIM_Try, /*On fail goto*//*Label 19151*/ GIMT_Encode4(1341888), // Rule ID 20047 //
     /* 1341809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1341812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1341826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1341829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341862 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1341865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341887 */     // GIR_Coverage, 20047,
     /* 1341887 */     GIR_EraseRootFromParent_Done,
     /* 1341888 */   // Label 19151: @1341888
     /* 1341888 */   GIM_Try, /*On fail goto*//*Label 19152*/ GIMT_Encode4(1341972), // Rule ID 20050 //
     /* 1341893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1341896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1341904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1341907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1341910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1341913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1341916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341946 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1341949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341971 */     // GIR_Coverage, 20050,
     /* 1341971 */     GIR_EraseRootFromParent_Done,
     /* 1341972 */   // Label 19152: @1341972
     /* 1341972 */   GIM_Try, /*On fail goto*//*Label 19153*/ GIMT_Encode4(1342056), // Rule ID 20051 //
     /* 1341977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1341980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1341988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1341991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1341994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1341997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342030 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1342033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342055 */     // GIR_Coverage, 20051,
     /* 1342055 */     GIR_EraseRootFromParent_Done,
     /* 1342056 */   // Label 19153: @1342056
     /* 1342056 */   GIM_Try, /*On fail goto*//*Label 19154*/ GIMT_Encode4(1342140), // Rule ID 20054 //
     /* 1342061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1342064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1342069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1342078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1342081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342114 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1342117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342139 */     // GIR_Coverage, 20054,
     /* 1342139 */     GIR_EraseRootFromParent_Done,
     /* 1342140 */   // Label 19154: @1342140
     /* 1342140 */   GIM_Try, /*On fail goto*//*Label 19155*/ GIMT_Encode4(1342224), // Rule ID 20055 //
     /* 1342145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1342148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1342153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1342162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1342165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342198 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1342201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342223 */     // GIR_Coverage, 20055,
     /* 1342223 */     GIR_EraseRootFromParent_Done,
     /* 1342224 */   // Label 19155: @1342224
     /* 1342224 */   GIM_Try, /*On fail goto*//*Label 19156*/ GIMT_Encode4(1342308), // Rule ID 20058 //
     /* 1342229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1342232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1342237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1342246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1342249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342282 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1342285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342307 */     // GIR_Coverage, 20058,
     /* 1342307 */     GIR_EraseRootFromParent_Done,
     /* 1342308 */   // Label 19156: @1342308
     /* 1342308 */   GIM_Try, /*On fail goto*//*Label 19157*/ GIMT_Encode4(1342392), // Rule ID 20059 //
     /* 1342313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1342316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1342321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1342330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1342333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342366 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1342369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342391 */     // GIR_Coverage, 20059,
     /* 1342391 */     GIR_EraseRootFromParent_Done,
     /* 1342392 */   // Label 19157: @1342392
     /* 1342392 */   GIM_Try, /*On fail goto*//*Label 19158*/ GIMT_Encode4(1342476), // Rule ID 20062 //
     /* 1342397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1342400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1342405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1342414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1342417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342450 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1342453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342475 */     // GIR_Coverage, 20062,
     /* 1342475 */     GIR_EraseRootFromParent_Done,
     /* 1342476 */   // Label 19158: @1342476
     /* 1342476 */   GIM_Try, /*On fail goto*//*Label 19159*/ GIMT_Encode4(1342560), // Rule ID 20063 //
     /* 1342481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1342484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1342489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1342498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1342501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342534 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1342537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342559 */     // GIR_Coverage, 20063,
     /* 1342559 */     GIR_EraseRootFromParent_Done,
     /* 1342560 */   // Label 19159: @1342560
     /* 1342560 */   GIM_Try, /*On fail goto*//*Label 19160*/ GIMT_Encode4(1342644), // Rule ID 20066 //
     /* 1342565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1342573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1342582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342618 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1342621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342643 */     // GIR_Coverage, 20066,
     /* 1342643 */     GIR_EraseRootFromParent_Done,
     /* 1342644 */   // Label 19160: @1342644
     /* 1342644 */   GIM_Try, /*On fail goto*//*Label 19161*/ GIMT_Encode4(1342728), // Rule ID 20067 //
     /* 1342649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1342657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1342666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342702 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1342705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342727 */     // GIR_Coverage, 20067,
     /* 1342727 */     GIR_EraseRootFromParent_Done,
     /* 1342728 */   // Label 19161: @1342728
     /* 1342728 */   GIM_Try, /*On fail goto*//*Label 19162*/ GIMT_Encode4(1342812), // Rule ID 20070 //
     /* 1342733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1342741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1342750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342786 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1342789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342811 */     // GIR_Coverage, 20070,
     /* 1342811 */     GIR_EraseRootFromParent_Done,
     /* 1342812 */   // Label 19162: @1342812
     /* 1342812 */   GIM_Try, /*On fail goto*//*Label 19163*/ GIMT_Encode4(1342896), // Rule ID 20071 //
     /* 1342817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1342825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1342834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342870 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1342873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342895 */     // GIR_Coverage, 20071,
     /* 1342895 */     GIR_EraseRootFromParent_Done,
     /* 1342896 */   // Label 19163: @1342896
     /* 1342896 */   GIM_Try, /*On fail goto*//*Label 19164*/ GIMT_Encode4(1342980), // Rule ID 20074 //
     /* 1342901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1342904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1342909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1342918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1342921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1342943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342954 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1342957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342979 */     // GIR_Coverage, 20074,
     /* 1342979 */     GIR_EraseRootFromParent_Done,
     /* 1342980 */   // Label 19164: @1342980
     /* 1342980 */   GIM_Try, /*On fail goto*//*Label 19165*/ GIMT_Encode4(1343064), // Rule ID 20075 //
     /* 1342985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1342988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1342993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1343002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1343008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1343027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343038 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1343041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343063 */     // GIR_Coverage, 20075,
     /* 1343063 */     GIR_EraseRootFromParent_Done,
     /* 1343064 */   // Label 19165: @1343064
     /* 1343064 */   GIM_Try, /*On fail goto*//*Label 19166*/ GIMT_Encode4(1343148), // Rule ID 20078 //
     /* 1343069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1343072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1343077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1343086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343122 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1343125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343147 */     // GIR_Coverage, 20078,
     /* 1343147 */     GIR_EraseRootFromParent_Done,
     /* 1343148 */   // Label 19166: @1343148
     /* 1343148 */   GIM_Try, /*On fail goto*//*Label 19167*/ GIMT_Encode4(1343232), // Rule ID 20079 //
     /* 1343153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1343156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1343161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1343170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343206 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1343209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343231 */     // GIR_Coverage, 20079,
     /* 1343231 */     GIR_EraseRootFromParent_Done,
     /* 1343232 */   // Label 19167: @1343232
     /* 1343232 */   GIM_Try, /*On fail goto*//*Label 19168*/ GIMT_Encode4(1343316), // Rule ID 20082 //
     /* 1343237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1343245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1343254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1343279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343290 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1343293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343315 */     // GIR_Coverage, 20082,
     /* 1343315 */     GIR_EraseRootFromParent_Done,
     /* 1343316 */   // Label 19168: @1343316
     /* 1343316 */   GIM_Try, /*On fail goto*//*Label 19169*/ GIMT_Encode4(1343400), // Rule ID 20083 //
     /* 1343321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1343329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1343338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1343363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343374 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1343377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343399 */     // GIR_Coverage, 20083,
     /* 1343399 */     GIR_EraseRootFromParent_Done,
     /* 1343400 */   // Label 19169: @1343400
     /* 1343400 */   GIM_Try, /*On fail goto*//*Label 19170*/ GIMT_Encode4(1343484), // Rule ID 20086 //
     /* 1343405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1343413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1343416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1343419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1343422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1343428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1343447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343458 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1343461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343483 */     // GIR_Coverage, 20086,
     /* 1343483 */     GIR_EraseRootFromParent_Done,
     /* 1343484 */   // Label 19170: @1343484
     /* 1343484 */   GIM_Try, /*On fail goto*//*Label 19171*/ GIMT_Encode4(1343568), // Rule ID 20087 //
     /* 1343489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1343497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1343500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1343503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1343506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1343512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1343531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343542 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1343545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343567 */     // GIR_Coverage, 20087,
     /* 1343567 */     GIR_EraseRootFromParent_Done,
     /* 1343568 */   // Label 19171: @1343568
     /* 1343568 */   GIM_Try, /*On fail goto*//*Label 19172*/ GIMT_Encode4(1343652), // Rule ID 20090 //
     /* 1343573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1343576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1343581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1343590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343626 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1343629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343651 */     // GIR_Coverage, 20090,
     /* 1343651 */     GIR_EraseRootFromParent_Done,
     /* 1343652 */   // Label 19172: @1343652
     /* 1343652 */   GIM_Try, /*On fail goto*//*Label 19173*/ GIMT_Encode4(1343736), // Rule ID 20091 //
     /* 1343657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1343660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1343665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1343674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343710 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1343713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343735 */     // GIR_Coverage, 20091,
     /* 1343735 */     GIR_EraseRootFromParent_Done,
     /* 1343736 */   // Label 19173: @1343736
     /* 1343736 */   GIM_Try, /*On fail goto*//*Label 19174*/ GIMT_Encode4(1343820), // Rule ID 20094 //
     /* 1343741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1343744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1343749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1343758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343794 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1343797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343819 */     // GIR_Coverage, 20094,
     /* 1343819 */     GIR_EraseRootFromParent_Done,
     /* 1343820 */   // Label 19174: @1343820
     /* 1343820 */   GIM_Try, /*On fail goto*//*Label 19175*/ GIMT_Encode4(1343904), // Rule ID 20095 //
     /* 1343825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1343828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1343833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1343842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343878 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1343881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343903 */     // GIR_Coverage, 20095,
     /* 1343903 */     GIR_EraseRootFromParent_Done,
     /* 1343904 */   // Label 19175: @1343904
     /* 1343904 */   GIM_Try, /*On fail goto*//*Label 19176*/ GIMT_Encode4(1343988), // Rule ID 20098 //
     /* 1343909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1343912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1343917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1343920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1343923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1343926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1343932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343962 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1343965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343987 */     // GIR_Coverage, 20098,
     /* 1343987 */     GIR_EraseRootFromParent_Done,
     /* 1343988 */   // Label 19176: @1343988
     /* 1343988 */   GIM_Try, /*On fail goto*//*Label 19177*/ GIMT_Encode4(1344072), // Rule ID 20099 //
     /* 1343993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1343996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1344001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1344004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1344007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1344010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1344016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344046 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1344049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344071 */     // GIR_Coverage, 20099,
     /* 1344071 */     GIR_EraseRootFromParent_Done,
     /* 1344072 */   // Label 19177: @1344072
     /* 1344072 */   GIM_Try, /*On fail goto*//*Label 19178*/ GIMT_Encode4(1344156), // Rule ID 20102 //
     /* 1344077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1344085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1344094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1344115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344130 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1344133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344155 */     // GIR_Coverage, 20102,
     /* 1344155 */     GIR_EraseRootFromParent_Done,
     /* 1344156 */   // Label 19178: @1344156
     /* 1344156 */   GIM_Try, /*On fail goto*//*Label 19179*/ GIMT_Encode4(1344240), // Rule ID 20103 //
     /* 1344161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1344169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1344178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1344199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344214 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1344217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344239 */     // GIR_Coverage, 20103,
     /* 1344239 */     GIR_EraseRootFromParent_Done,
     /* 1344240 */   // Label 19179: @1344240
     /* 1344240 */   GIM_Try, /*On fail goto*//*Label 19180*/ GIMT_Encode4(1344324), // Rule ID 20106 //
     /* 1344245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1344253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1344256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1344259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1344262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344298 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1344301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344323 */     // GIR_Coverage, 20106,
     /* 1344323 */     GIR_EraseRootFromParent_Done,
     /* 1344324 */   // Label 19180: @1344324
     /* 1344324 */   GIM_Try, /*On fail goto*//*Label 19181*/ GIMT_Encode4(1344408), // Rule ID 20107 //
     /* 1344329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1344337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1344340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1344343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1344346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344382 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1344385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344407 */     // GIR_Coverage, 20107,
     /* 1344407 */     GIR_EraseRootFromParent_Done,
     /* 1344408 */   // Label 19181: @1344408
     /* 1344408 */   GIM_Try, /*On fail goto*//*Label 19182*/ GIMT_Encode4(1344492), // Rule ID 20110 //
     /* 1344413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1344421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1344424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1344427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1344430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1344436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344466 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1344469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344491 */     // GIR_Coverage, 20110,
     /* 1344491 */     GIR_EraseRootFromParent_Done,
     /* 1344492 */   // Label 19182: @1344492
     /* 1344492 */   GIM_Try, /*On fail goto*//*Label 19183*/ GIMT_Encode4(1344576), // Rule ID 20111 //
     /* 1344497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1344505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1344508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1344511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1344514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1344520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344550 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1344553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344575 */     // GIR_Coverage, 20111,
     /* 1344575 */     GIR_EraseRootFromParent_Done,
     /* 1344576 */   // Label 19183: @1344576
     /* 1344576 */   GIM_Try, /*On fail goto*//*Label 19184*/ GIMT_Encode4(1344660), // Rule ID 20114 //
     /* 1344581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1344584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1344589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1344598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1344619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344634 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1344637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344659 */     // GIR_Coverage, 20114,
     /* 1344659 */     GIR_EraseRootFromParent_Done,
     /* 1344660 */   // Label 19184: @1344660
     /* 1344660 */   GIM_Try, /*On fail goto*//*Label 19185*/ GIMT_Encode4(1344744), // Rule ID 20115 //
     /* 1344665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1344668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1344673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1344682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1344703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344718 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1344721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344743 */     // GIR_Coverage, 20115,
     /* 1344743 */     GIR_EraseRootFromParent_Done,
     /* 1344744 */   // Label 19185: @1344744
     /* 1344744 */   GIM_Try, /*On fail goto*//*Label 19186*/ GIMT_Encode4(1344828), // Rule ID 20118 //
     /* 1344749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1344752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1344757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1344766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344802 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1344805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344827 */     // GIR_Coverage, 20118,
     /* 1344827 */     GIR_EraseRootFromParent_Done,
     /* 1344828 */   // Label 19186: @1344828
     /* 1344828 */   GIM_Try, /*On fail goto*//*Label 19187*/ GIMT_Encode4(1344912), // Rule ID 20119 //
     /* 1344833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1344836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1344841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1344850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344886 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1344889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344911 */     // GIR_Coverage, 20119,
     /* 1344911 */     GIR_EraseRootFromParent_Done,
     /* 1344912 */   // Label 19187: @1344912
     /* 1344912 */   GIM_Try, /*On fail goto*//*Label 19188*/ GIMT_Encode4(1344996), // Rule ID 20122 //
     /* 1344917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1344920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1344925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1344928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1344931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1344934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344970 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1344973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344995 */     // GIR_Coverage, 20122,
     /* 1344995 */     GIR_EraseRootFromParent_Done,
     /* 1344996 */   // Label 19188: @1344996
     /* 1344996 */   GIM_Try, /*On fail goto*//*Label 19189*/ GIMT_Encode4(1345080), // Rule ID 20123 //
     /* 1345001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1345004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1345009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1345018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1345043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345054 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1345057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1345075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345079 */     // GIR_Coverage, 20123,
     /* 1345079 */     GIR_EraseRootFromParent_Done,
     /* 1345080 */   // Label 19189: @1345080
     /* 1345080 */   GIM_Try, /*On fail goto*//*Label 19190*/ GIMT_Encode4(1345164), // Rule ID 20126 //
     /* 1345085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1345096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1345099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1345102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1345105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345138 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1345141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345163 */     // GIR_Coverage, 20126,
     /* 1345163 */     GIR_EraseRootFromParent_Done,
     /* 1345164 */   // Label 19190: @1345164
     /* 1345164 */   GIM_Try, /*On fail goto*//*Label 19191*/ GIMT_Encode4(1345248), // Rule ID 20127 //
     /* 1345169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1345180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1345183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1345186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1345189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345222 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1345225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345247 */     // GIR_Coverage, 20127,
     /* 1345247 */     GIR_EraseRootFromParent_Done,
     /* 1345248 */   // Label 19191: @1345248
     /* 1345248 */   GIM_Try, /*On fail goto*//*Label 19192*/ GIMT_Encode4(1345332), // Rule ID 20130 //
     /* 1345253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1345264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1345267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1345270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1345273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345306 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1345309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345331 */     // GIR_Coverage, 20130,
     /* 1345331 */     GIR_EraseRootFromParent_Done,
     /* 1345332 */   // Label 19192: @1345332
     /* 1345332 */   GIM_Try, /*On fail goto*//*Label 19193*/ GIMT_Encode4(1345416), // Rule ID 20131 //
     /* 1345337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1345348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1345351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1345354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1345357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345390 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1345393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345415 */     // GIR_Coverage, 20131,
     /* 1345415 */     GIR_EraseRootFromParent_Done,
     /* 1345416 */   // Label 19193: @1345416
     /* 1345416 */   GIM_Try, /*On fail goto*//*Label 19194*/ GIMT_Encode4(1345500), // Rule ID 20134 //
     /* 1345421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1345432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1345435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1345438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1345441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345474 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1345477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345499 */     // GIR_Coverage, 20134,
     /* 1345499 */     GIR_EraseRootFromParent_Done,
     /* 1345500 */   // Label 19194: @1345500
     /* 1345500 */   GIM_Try, /*On fail goto*//*Label 19195*/ GIMT_Encode4(1345584), // Rule ID 20135 //
     /* 1345505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1345516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1345519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1345522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1345525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345558 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1345561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345583 */     // GIR_Coverage, 20135,
     /* 1345583 */     GIR_EraseRootFromParent_Done,
     /* 1345584 */   // Label 19195: @1345584
     /* 1345584 */   GIM_Try, /*On fail goto*//*Label 19196*/ GIMT_Encode4(1345668), // Rule ID 20138 //
     /* 1345589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1345606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1345609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345642 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1345645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345667 */     // GIR_Coverage, 20138,
     /* 1345667 */     GIR_EraseRootFromParent_Done,
     /* 1345668 */   // Label 19196: @1345668
     /* 1345668 */   GIM_Try, /*On fail goto*//*Label 19197*/ GIMT_Encode4(1345752), // Rule ID 20139 //
     /* 1345673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1345690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1345693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345726 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1345729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345751 */     // GIR_Coverage, 20139,
     /* 1345751 */     GIR_EraseRootFromParent_Done,
     /* 1345752 */   // Label 19197: @1345752
     /* 1345752 */   GIM_Try, /*On fail goto*//*Label 19198*/ GIMT_Encode4(1345836), // Rule ID 20142 //
     /* 1345757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1345768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1345771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1345774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1345777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345810 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1345813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345835 */     // GIR_Coverage, 20142,
     /* 1345835 */     GIR_EraseRootFromParent_Done,
     /* 1345836 */   // Label 19198: @1345836
     /* 1345836 */   GIM_Try, /*On fail goto*//*Label 19199*/ GIMT_Encode4(1345920), // Rule ID 20143 //
     /* 1345841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1345852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1345855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1345858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1345861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345894 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1345897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345919 */     // GIR_Coverage, 20143,
     /* 1345919 */     GIR_EraseRootFromParent_Done,
     /* 1345920 */   // Label 19199: @1345920
     /* 1345920 */   GIM_Try, /*On fail goto*//*Label 19200*/ GIMT_Encode4(1346004), // Rule ID 20146 //
     /* 1345925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1345928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1345936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1345939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1345942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1345945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345978 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1345981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1345999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346003 */     // GIR_Coverage, 20146,
     /* 1346003 */     GIR_EraseRootFromParent_Done,
     /* 1346004 */   // Label 19200: @1346004
     /* 1346004 */   GIM_Try, /*On fail goto*//*Label 19201*/ GIMT_Encode4(1346088), // Rule ID 20147 //
     /* 1346009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1346026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1346029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346062 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1346065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346087 */     // GIR_Coverage, 20147,
     /* 1346087 */     GIR_EraseRootFromParent_Done,
     /* 1346088 */   // Label 19201: @1346088
     /* 1346088 */   GIM_Try, /*On fail goto*//*Label 19202*/ GIMT_Encode4(1346172), // Rule ID 20150 //
     /* 1346093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1346110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1346113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346146 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1346149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346171 */     // GIR_Coverage, 20150,
     /* 1346171 */     GIR_EraseRootFromParent_Done,
     /* 1346172 */   // Label 19202: @1346172
     /* 1346172 */   GIM_Try, /*On fail goto*//*Label 19203*/ GIMT_Encode4(1346256), // Rule ID 20151 //
     /* 1346177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1346194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1346197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346230 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1346233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346255 */     // GIR_Coverage, 20151,
     /* 1346255 */     GIR_EraseRootFromParent_Done,
     /* 1346256 */   // Label 19203: @1346256
     /* 1346256 */   GIM_Try, /*On fail goto*//*Label 19204*/ GIMT_Encode4(1346340), // Rule ID 20154 //
     /* 1346261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1346272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1346275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1346278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1346281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1346284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346314 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1346317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346339 */     // GIR_Coverage, 20154,
     /* 1346339 */     GIR_EraseRootFromParent_Done,
     /* 1346340 */   // Label 19204: @1346340
     /* 1346340 */   GIM_Try, /*On fail goto*//*Label 19205*/ GIMT_Encode4(1346424), // Rule ID 20155 //
     /* 1346345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1346356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1346359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1346362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1346365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1346368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346398 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1346401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346423 */     // GIR_Coverage, 20155,
     /* 1346423 */     GIR_EraseRootFromParent_Done,
     /* 1346424 */   // Label 19205: @1346424
     /* 1346424 */   GIM_Try, /*On fail goto*//*Label 19206*/ GIMT_Encode4(1346508), // Rule ID 20158 //
     /* 1346429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1346440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1346443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1346446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1346449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1346452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346482 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1346485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346507 */     // GIR_Coverage, 20158,
     /* 1346507 */     GIR_EraseRootFromParent_Done,
     /* 1346508 */   // Label 19206: @1346508
     /* 1346508 */   GIM_Try, /*On fail goto*//*Label 19207*/ GIMT_Encode4(1346592), // Rule ID 20159 //
     /* 1346513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1346524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1346527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1346530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1346533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1346536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346566 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1346569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346591 */     // GIR_Coverage, 20159,
     /* 1346591 */     GIR_EraseRootFromParent_Done,
     /* 1346592 */   // Label 19207: @1346592
     /* 1346592 */   GIM_Try, /*On fail goto*//*Label 19208*/ GIMT_Encode4(1346676), // Rule ID 20162 //
     /* 1346597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1346600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1346614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1346617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346650 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1346653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346675 */     // GIR_Coverage, 20162,
     /* 1346675 */     GIR_EraseRootFromParent_Done,
     /* 1346676 */   // Label 19208: @1346676
     /* 1346676 */   GIM_Try, /*On fail goto*//*Label 19209*/ GIMT_Encode4(1346760), // Rule ID 20163 //
     /* 1346681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1346684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1346698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1346701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346734 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1346737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346759 */     // GIR_Coverage, 20163,
     /* 1346759 */     GIR_EraseRootFromParent_Done,
     /* 1346760 */   // Label 19209: @1346760
     /* 1346760 */   GIM_Try, /*On fail goto*//*Label 19210*/ GIMT_Encode4(1346844), // Rule ID 20166 //
     /* 1346765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1346768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1346782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1346785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346818 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1346821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346843 */     // GIR_Coverage, 20166,
     /* 1346843 */     GIR_EraseRootFromParent_Done,
     /* 1346844 */   // Label 19210: @1346844
     /* 1346844 */   GIM_Try, /*On fail goto*//*Label 19211*/ GIMT_Encode4(1346928), // Rule ID 20167 //
     /* 1346849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1346852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1346866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1346869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346902 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1346905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346927 */     // GIR_Coverage, 20167,
     /* 1346927 */     GIR_EraseRootFromParent_Done,
     /* 1346928 */   // Label 19211: @1346928
     /* 1346928 */   GIM_Try, /*On fail goto*//*Label 19212*/ GIMT_Encode4(1347012), // Rule ID 20170 //
     /* 1346933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1346936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1346944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1346947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1346950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1346953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1346956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346986 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1346989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347011 */     // GIR_Coverage, 20170,
     /* 1347011 */     GIR_EraseRootFromParent_Done,
     /* 1347012 */   // Label 19212: @1347012
     /* 1347012 */   GIM_Try, /*On fail goto*//*Label 19213*/ GIMT_Encode4(1347096), // Rule ID 20171 //
     /* 1347017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1347020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1347025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1347028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1347031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1347034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1347037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1347040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347070 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1347073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347095 */     // GIR_Coverage, 20171,
     /* 1347095 */     GIR_EraseRootFromParent_Done,
     /* 1347096 */   // Label 19213: @1347096
     /* 1347096 */   GIM_Try, /*On fail goto*//*Label 19214*/ GIMT_Encode4(1347180), // Rule ID 20174 //
     /* 1347101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1347104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1347109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1347118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1347121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347154 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1347157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347179 */     // GIR_Coverage, 20174,
     /* 1347179 */     GIR_EraseRootFromParent_Done,
     /* 1347180 */   // Label 19214: @1347180
     /* 1347180 */   GIM_Try, /*On fail goto*//*Label 19215*/ GIMT_Encode4(1347264), // Rule ID 20175 //
     /* 1347185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1347188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1347193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1347202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1347205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347238 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1347241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347263 */     // GIR_Coverage, 20175,
     /* 1347263 */     GIR_EraseRootFromParent_Done,
     /* 1347264 */   // Label 19215: @1347264
     /* 1347264 */   GIM_Try, /*On fail goto*//*Label 19216*/ GIMT_Encode4(1347348), // Rule ID 20178 //
     /* 1347269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1347272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1347277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1347286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1347289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347322 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1347325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347347 */     // GIR_Coverage, 20178,
     /* 1347347 */     GIR_EraseRootFromParent_Done,
     /* 1347348 */   // Label 19216: @1347348
     /* 1347348 */   GIM_Try, /*On fail goto*//*Label 19217*/ GIMT_Encode4(1347432), // Rule ID 20179 //
     /* 1347353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1347356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1347361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1347370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1347373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347406 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1347409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347431 */     // GIR_Coverage, 20179,
     /* 1347431 */     GIR_EraseRootFromParent_Done,
     /* 1347432 */   // Label 19217: @1347432
     /* 1347432 */   GIM_Try, /*On fail goto*//*Label 19218*/ GIMT_Encode4(1347516), // Rule ID 20182 //
     /* 1347437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1347440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1347445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1347454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1347457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347490 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1347493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347515 */     // GIR_Coverage, 20182,
     /* 1347515 */     GIR_EraseRootFromParent_Done,
     /* 1347516 */   // Label 19218: @1347516
     /* 1347516 */   GIM_Try, /*On fail goto*//*Label 19219*/ GIMT_Encode4(1347600), // Rule ID 20183 //
     /* 1347521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1347524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1347529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1347538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1347541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347574 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1347577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347599 */     // GIR_Coverage, 20183,
     /* 1347599 */     GIR_EraseRootFromParent_Done,
     /* 1347600 */   // Label 19219: @1347600
     /* 1347600 */   GIM_Try, /*On fail goto*//*Label 19220*/ GIMT_Encode4(1347684), // Rule ID 20186 //
     /* 1347605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1347613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1347622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347658 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1347661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347683 */     // GIR_Coverage, 20186,
     /* 1347683 */     GIR_EraseRootFromParent_Done,
     /* 1347684 */   // Label 19220: @1347684
     /* 1347684 */   GIM_Try, /*On fail goto*//*Label 19221*/ GIMT_Encode4(1347768), // Rule ID 20187 //
     /* 1347689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1347697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1347706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347742 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1347745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347767 */     // GIR_Coverage, 20187,
     /* 1347767 */     GIR_EraseRootFromParent_Done,
     /* 1347768 */   // Label 19221: @1347768
     /* 1347768 */   GIM_Try, /*On fail goto*//*Label 19222*/ GIMT_Encode4(1347852), // Rule ID 20190 //
     /* 1347773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1347781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1347790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347826 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1347829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347851 */     // GIR_Coverage, 20190,
     /* 1347851 */     GIR_EraseRootFromParent_Done,
     /* 1347852 */   // Label 19222: @1347852
     /* 1347852 */   GIM_Try, /*On fail goto*//*Label 19223*/ GIMT_Encode4(1347936), // Rule ID 20191 //
     /* 1347857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1347865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1347874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347910 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1347913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347935 */     // GIR_Coverage, 20191,
     /* 1347935 */     GIR_EraseRootFromParent_Done,
     /* 1347936 */   // Label 19223: @1347936
     /* 1347936 */   GIM_Try, /*On fail goto*//*Label 19224*/ GIMT_Encode4(1348020), // Rule ID 20194 //
     /* 1347941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1347944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1347949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1347958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347994 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1347997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348019 */     // GIR_Coverage, 20194,
     /* 1348019 */     GIR_EraseRootFromParent_Done,
     /* 1348020 */   // Label 19224: @1348020
     /* 1348020 */   GIM_Try, /*On fail goto*//*Label 19225*/ GIMT_Encode4(1348104), // Rule ID 20195 //
     /* 1348025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1348033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1348036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1348039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1348042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1348048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348078 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1348081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348103 */     // GIR_Coverage, 20195,
     /* 1348103 */     GIR_EraseRootFromParent_Done,
     /* 1348104 */   // Label 19225: @1348104
     /* 1348104 */   GIM_Try, /*On fail goto*//*Label 19226*/ GIMT_Encode4(1348188), // Rule ID 20198 //
     /* 1348109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1348112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1348117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1348126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348162 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1348165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348187 */     // GIR_Coverage, 20198,
     /* 1348187 */     GIR_EraseRootFromParent_Done,
     /* 1348188 */   // Label 19226: @1348188
     /* 1348188 */   GIM_Try, /*On fail goto*//*Label 19227*/ GIMT_Encode4(1348272), // Rule ID 20199 //
     /* 1348193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1348196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1348201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1348210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348246 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1348249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348271 */     // GIR_Coverage, 20199,
     /* 1348271 */     GIR_EraseRootFromParent_Done,
     /* 1348272 */   // Label 19227: @1348272
     /* 1348272 */   GIM_Try, /*On fail goto*//*Label 19228*/ GIMT_Encode4(1348356), // Rule ID 20202 //
     /* 1348277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1348285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1348294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348330 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1348333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348355 */     // GIR_Coverage, 20202,
     /* 1348355 */     GIR_EraseRootFromParent_Done,
     /* 1348356 */   // Label 19228: @1348356
     /* 1348356 */   GIM_Try, /*On fail goto*//*Label 19229*/ GIMT_Encode4(1348440), // Rule ID 20203 //
     /* 1348361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1348369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1348378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348414 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1348417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348439 */     // GIR_Coverage, 20203,
     /* 1348439 */     GIR_EraseRootFromParent_Done,
     /* 1348440 */   // Label 19229: @1348440
     /* 1348440 */   GIM_Try, /*On fail goto*//*Label 19230*/ GIMT_Encode4(1348524), // Rule ID 20206 //
     /* 1348445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1348453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1348456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1348459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1348462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1348468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348498 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1348501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348523 */     // GIR_Coverage, 20206,
     /* 1348523 */     GIR_EraseRootFromParent_Done,
     /* 1348524 */   // Label 19230: @1348524
     /* 1348524 */   GIM_Try, /*On fail goto*//*Label 19231*/ GIMT_Encode4(1348608), // Rule ID 20207 //
     /* 1348529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1348532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1348537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1348540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1348543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1348546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1348552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348582 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1348585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348607 */     // GIR_Coverage, 20207,
     /* 1348607 */     GIR_EraseRootFromParent_Done,
     /* 1348608 */   // Label 19231: @1348608
     /* 1348608 */   GIM_Try, /*On fail goto*//*Label 19232*/ GIMT_Encode4(1348692), // Rule ID 20210 //
     /* 1348613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1348616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1348621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1348630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348666 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1348669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348691 */     // GIR_Coverage, 20210,
     /* 1348691 */     GIR_EraseRootFromParent_Done,
     /* 1348692 */   // Label 19232: @1348692
     /* 1348692 */   GIM_Try, /*On fail goto*//*Label 19233*/ GIMT_Encode4(1348776), // Rule ID 20211 //
     /* 1348697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1348700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1348705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1348714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348750 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1348753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348775 */     // GIR_Coverage, 20211,
     /* 1348775 */     GIR_EraseRootFromParent_Done,
     /* 1348776 */   // Label 19233: @1348776
     /* 1348776 */   GIM_Try, /*On fail goto*//*Label 19234*/ GIMT_Encode4(1348860), // Rule ID 20214 //
     /* 1348781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1348784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1348789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1348798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348834 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1348837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348859 */     // GIR_Coverage, 20214,
     /* 1348859 */     GIR_EraseRootFromParent_Done,
     /* 1348860 */   // Label 19234: @1348860
     /* 1348860 */   GIM_Try, /*On fail goto*//*Label 19235*/ GIMT_Encode4(1348944), // Rule ID 20215 //
     /* 1348865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1348868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1348873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1348882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348918 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1348921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348943 */     // GIR_Coverage, 20215,
     /* 1348943 */     GIR_EraseRootFromParent_Done,
     /* 1348944 */   // Label 19235: @1348944
     /* 1348944 */   GIM_Try, /*On fail goto*//*Label 19236*/ GIMT_Encode4(1349028), // Rule ID 20218 //
     /* 1348949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1348952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1348957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1348960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1348963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1348966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1348972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349002 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1349005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349027 */     // GIR_Coverage, 20218,
     /* 1349027 */     GIR_EraseRootFromParent_Done,
     /* 1349028 */   // Label 19236: @1349028
     /* 1349028 */   GIM_Try, /*On fail goto*//*Label 19237*/ GIMT_Encode4(1349112), // Rule ID 20219 //
     /* 1349033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1349041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1349044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1349047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1349050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1349056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349086 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1349089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349111 */     // GIR_Coverage, 20219,
     /* 1349111 */     GIR_EraseRootFromParent_Done,
     /* 1349112 */   // Label 19237: @1349112
     /* 1349112 */   GIM_Try, /*On fail goto*//*Label 19238*/ GIMT_Encode4(1349196), // Rule ID 20222 //
     /* 1349117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1349125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1349134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1349155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349170 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1349173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349195 */     // GIR_Coverage, 20222,
     /* 1349195 */     GIR_EraseRootFromParent_Done,
     /* 1349196 */   // Label 19238: @1349196
     /* 1349196 */   GIM_Try, /*On fail goto*//*Label 19239*/ GIMT_Encode4(1349280), // Rule ID 20223 //
     /* 1349201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1349204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1349209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1349218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1349239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349254 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1349257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349279 */     // GIR_Coverage, 20223,
     /* 1349279 */     GIR_EraseRootFromParent_Done,
     /* 1349280 */   // Label 19239: @1349280
     /* 1349280 */   GIM_Try, /*On fail goto*//*Label 19240*/ GIMT_Encode4(1349364), // Rule ID 20226 //
     /* 1349285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1349293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1349302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1349323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349338 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1349341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349363 */     // GIR_Coverage, 20226,
     /* 1349363 */     GIR_EraseRootFromParent_Done,
     /* 1349364 */   // Label 19240: @1349364
     /* 1349364 */   GIM_Try, /*On fail goto*//*Label 19241*/ GIMT_Encode4(1349448), // Rule ID 20227 //
     /* 1349369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1349372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1349377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1349386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1349407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349422 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1349425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349447 */     // GIR_Coverage, 20227,
     /* 1349447 */     GIR_EraseRootFromParent_Done,
     /* 1349448 */   // Label 19241: @1349448
     /* 1349448 */   GIM_Try, /*On fail goto*//*Label 19242*/ GIMT_Encode4(1349532), // Rule ID 20230 //
     /* 1349453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1349461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1349464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1349467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1349470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1349476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349506 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1349509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349531 */     // GIR_Coverage, 20230,
     /* 1349531 */     GIR_EraseRootFromParent_Done,
     /* 1349532 */   // Label 19242: @1349532
     /* 1349532 */   GIM_Try, /*On fail goto*//*Label 19243*/ GIMT_Encode4(1349616), // Rule ID 20231 //
     /* 1349537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1349540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1349545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1349548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1349551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1349554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1349560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349590 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1349593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349615 */     // GIR_Coverage, 20231,
     /* 1349615 */     GIR_EraseRootFromParent_Done,
     /* 1349616 */   // Label 19243: @1349616
     /* 1349616 */   GIM_Try, /*On fail goto*//*Label 19244*/ GIMT_Encode4(1349700), // Rule ID 20234 //
     /* 1349621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1349624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1349629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1349638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1349659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349674 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1349677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349699 */     // GIR_Coverage, 20234,
     /* 1349699 */     GIR_EraseRootFromParent_Done,
     /* 1349700 */   // Label 19244: @1349700
     /* 1349700 */   GIM_Try, /*On fail goto*//*Label 19245*/ GIMT_Encode4(1349784), // Rule ID 20235 //
     /* 1349705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1349708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1349713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1349722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1349743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349758 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1349761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349783 */     // GIR_Coverage, 20235,
     /* 1349783 */     GIR_EraseRootFromParent_Done,
     /* 1349784 */   // Label 19245: @1349784
     /* 1349784 */   GIM_Try, /*On fail goto*//*Label 19246*/ GIMT_Encode4(1349868), // Rule ID 20238 //
     /* 1349789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1349792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1349797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1349806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1349827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349842 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1349845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349867 */     // GIR_Coverage, 20238,
     /* 1349867 */     GIR_EraseRootFromParent_Done,
     /* 1349868 */   // Label 19246: @1349868
     /* 1349868 */   GIM_Try, /*On fail goto*//*Label 19247*/ GIMT_Encode4(1349952), // Rule ID 20239 //
     /* 1349873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1349876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1349881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1349890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1349911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349926 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1349929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349951 */     // GIR_Coverage, 20239,
     /* 1349951 */     GIR_EraseRootFromParent_Done,
     /* 1349952 */   // Label 19247: @1349952
     /* 1349952 */   GIM_Try, /*On fail goto*//*Label 19248*/ GIMT_Encode4(1350036), // Rule ID 20242 //
     /* 1349957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1349960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1349965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1349974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350010 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1350013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350035 */     // GIR_Coverage, 20242,
     /* 1350035 */     GIR_EraseRootFromParent_Done,
     /* 1350036 */   // Label 19248: @1350036
     /* 1350036 */   GIM_Try, /*On fail goto*//*Label 19249*/ GIMT_Encode4(1350120), // Rule ID 20243 //
     /* 1350041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1350044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1350049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1350058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1350083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350094 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1350097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350119 */     // GIR_Coverage, 20243,
     /* 1350119 */     GIR_EraseRootFromParent_Done,
     /* 1350120 */   // Label 19249: @1350120
     /* 1350120 */   GIM_Try, /*On fail goto*//*Label 19250*/ GIMT_Encode4(1350204), // Rule ID 20246 //
     /* 1350125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1350136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1350139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1350142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350178 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1350181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350203 */     // GIR_Coverage, 20246,
     /* 1350203 */     GIR_EraseRootFromParent_Done,
     /* 1350204 */   // Label 19250: @1350204
     /* 1350204 */   GIM_Try, /*On fail goto*//*Label 19251*/ GIMT_Encode4(1350288), // Rule ID 20247 //
     /* 1350209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1350220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1350223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1350226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350262 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1350265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350287 */     // GIR_Coverage, 20247,
     /* 1350287 */     GIR_EraseRootFromParent_Done,
     /* 1350288 */   // Label 19251: @1350288
     /* 1350288 */   GIM_Try, /*On fail goto*//*Label 19252*/ GIMT_Encode4(1350372), // Rule ID 20250 //
     /* 1350293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1350304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1350307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1350310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350346 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1350349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350371 */     // GIR_Coverage, 20250,
     /* 1350371 */     GIR_EraseRootFromParent_Done,
     /* 1350372 */   // Label 19252: @1350372
     /* 1350372 */   GIM_Try, /*On fail goto*//*Label 19253*/ GIMT_Encode4(1350456), // Rule ID 20251 //
     /* 1350377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1350388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1350391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1350394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350430 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1350433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350455 */     // GIR_Coverage, 20251,
     /* 1350455 */     GIR_EraseRootFromParent_Done,
     /* 1350456 */   // Label 19253: @1350456
     /* 1350456 */   GIM_Try, /*On fail goto*//*Label 19254*/ GIMT_Encode4(1350540), // Rule ID 20254 //
     /* 1350461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1350472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1350475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1350478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350514 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1350517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350539 */     // GIR_Coverage, 20254,
     /* 1350539 */     GIR_EraseRootFromParent_Done,
     /* 1350540 */   // Label 19254: @1350540
     /* 1350540 */   GIM_Try, /*On fail goto*//*Label 19255*/ GIMT_Encode4(1350624), // Rule ID 20255 //
     /* 1350545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1350556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1350559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1350562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350598 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1350601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350623 */     // GIR_Coverage, 20255,
     /* 1350623 */     GIR_EraseRootFromParent_Done,
     /* 1350624 */   // Label 19255: @1350624
     /* 1350624 */   GIM_Try, /*On fail goto*//*Label 19256*/ GIMT_Encode4(1350708), // Rule ID 20258 //
     /* 1350629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1350640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1350643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1350646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350682 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1350685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350707 */     // GIR_Coverage, 20258,
     /* 1350707 */     GIR_EraseRootFromParent_Done,
     /* 1350708 */   // Label 19256: @1350708
     /* 1350708 */   GIM_Try, /*On fail goto*//*Label 19257*/ GIMT_Encode4(1350792), // Rule ID 20259 //
     /* 1350713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1350724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1350727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1350730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350766 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1350769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350791 */     // GIR_Coverage, 20259,
     /* 1350791 */     GIR_EraseRootFromParent_Done,
     /* 1350792 */   // Label 19257: @1350792
     /* 1350792 */   GIM_Try, /*On fail goto*//*Label 19258*/ GIMT_Encode4(1350876), // Rule ID 20262 //
     /* 1350797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1350808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1350811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1350814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350850 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1350853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350875 */     // GIR_Coverage, 20262,
     /* 1350875 */     GIR_EraseRootFromParent_Done,
     /* 1350876 */   // Label 19258: @1350876
     /* 1350876 */   GIM_Try, /*On fail goto*//*Label 19259*/ GIMT_Encode4(1350960), // Rule ID 20263 //
     /* 1350881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1350892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1350895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1350898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350934 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1350937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350959 */     // GIR_Coverage, 20263,
     /* 1350959 */     GIR_EraseRootFromParent_Done,
     /* 1350960 */   // Label 19259: @1350960
     /* 1350960 */   GIM_Try, /*On fail goto*//*Label 19260*/ GIMT_Encode4(1351044), // Rule ID 20266 //
     /* 1350965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1350968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1350976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1350979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1350982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351018 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1351021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351043 */     // GIR_Coverage, 20266,
     /* 1351043 */     GIR_EraseRootFromParent_Done,
     /* 1351044 */   // Label 19260: @1351044
     /* 1351044 */   GIM_Try, /*On fail goto*//*Label 19261*/ GIMT_Encode4(1351128), // Rule ID 20267 //
     /* 1351049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1351066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351102 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1351105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351127 */     // GIR_Coverage, 20267,
     /* 1351127 */     GIR_EraseRootFromParent_Done,
     /* 1351128 */   // Label 19261: @1351128
     /* 1351128 */   GIM_Try, /*On fail goto*//*Label 19262*/ GIMT_Encode4(1351212), // Rule ID 20270 //
     /* 1351133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1351150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1351153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1351175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351186 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1351189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351211 */     // GIR_Coverage, 20270,
     /* 1351211 */     GIR_EraseRootFromParent_Done,
     /* 1351212 */   // Label 19262: @1351212
     /* 1351212 */   GIM_Try, /*On fail goto*//*Label 19263*/ GIMT_Encode4(1351296), // Rule ID 20271 //
     /* 1351217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1351234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1351237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1351259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351270 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1351273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351295 */     // GIR_Coverage, 20271,
     /* 1351295 */     GIR_EraseRootFromParent_Done,
     /* 1351296 */   // Label 19263: @1351296
     /* 1351296 */   GIM_Try, /*On fail goto*//*Label 19264*/ GIMT_Encode4(1351380), // Rule ID 20274 //
     /* 1351301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1351312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1351315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1351318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1351321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1351324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1351343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351354 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1351357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351379 */     // GIR_Coverage, 20274,
     /* 1351379 */     GIR_EraseRootFromParent_Done,
     /* 1351380 */   // Label 19264: @1351380
     /* 1351380 */   GIM_Try, /*On fail goto*//*Label 19265*/ GIMT_Encode4(1351464), // Rule ID 20275 //
     /* 1351385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1351396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1351399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1351402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1351405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1351408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1351427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351438 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1351441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351463 */     // GIR_Coverage, 20275,
     /* 1351463 */     GIR_EraseRootFromParent_Done,
     /* 1351464 */   // Label 19265: @1351464
     /* 1351464 */   GIM_Try, /*On fail goto*//*Label 19266*/ GIMT_Encode4(1351548), // Rule ID 20278 //
     /* 1351469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1351480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1351483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1351486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1351489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1351492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1351511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351522 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1351525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351547 */     // GIR_Coverage, 20278,
     /* 1351547 */     GIR_EraseRootFromParent_Done,
     /* 1351548 */   // Label 19266: @1351548
     /* 1351548 */   GIM_Try, /*On fail goto*//*Label 19267*/ GIMT_Encode4(1351632), // Rule ID 20279 //
     /* 1351553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1351564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1351567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1351570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1351573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1351576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1351595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351606 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1351609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351631 */     // GIR_Coverage, 20279,
     /* 1351631 */     GIR_EraseRootFromParent_Done,
     /* 1351632 */   // Label 19267: @1351632
     /* 1351632 */   GIM_Try, /*On fail goto*//*Label 19268*/ GIMT_Encode4(1351716), // Rule ID 20282 //
     /* 1351637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1351640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1351654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1351679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351690 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1351693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351715 */     // GIR_Coverage, 20282,
     /* 1351715 */     GIR_EraseRootFromParent_Done,
     /* 1351716 */   // Label 19268: @1351716
     /* 1351716 */   GIM_Try, /*On fail goto*//*Label 19269*/ GIMT_Encode4(1351800), // Rule ID 20283 //
     /* 1351721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1351724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1351738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1351763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351774 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1351777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351799 */     // GIR_Coverage, 20283,
     /* 1351799 */     GIR_EraseRootFromParent_Done,
     /* 1351800 */   // Label 19269: @1351800
     /* 1351800 */   GIM_Try, /*On fail goto*//*Label 19270*/ GIMT_Encode4(1351884), // Rule ID 20286 //
     /* 1351805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1351808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1351822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1351847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351858 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1351861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351883 */     // GIR_Coverage, 20286,
     /* 1351883 */     GIR_EraseRootFromParent_Done,
     /* 1351884 */   // Label 19270: @1351884
     /* 1351884 */   GIM_Try, /*On fail goto*//*Label 19271*/ GIMT_Encode4(1351968), // Rule ID 20287 //
     /* 1351889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1351892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1351906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1351931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351942 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1351945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351967 */     // GIR_Coverage, 20287,
     /* 1351967 */     GIR_EraseRootFromParent_Done,
     /* 1351968 */   // Label 19271: @1351968
     /* 1351968 */   GIM_Try, /*On fail goto*//*Label 19272*/ GIMT_Encode4(1352052), // Rule ID 20290 //
     /* 1351973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1351976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1351984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1351987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1351990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1351996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1352015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352026 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1352029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352051 */     // GIR_Coverage, 20290,
     /* 1352051 */     GIR_EraseRootFromParent_Done,
     /* 1352052 */   // Label 19272: @1352052
     /* 1352052 */   GIM_Try, /*On fail goto*//*Label 19273*/ GIMT_Encode4(1352136), // Rule ID 20291 //
     /* 1352057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1352060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1352068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1352071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1352074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1352077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1352099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352110 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1352113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352135 */     // GIR_Coverage, 20291,
     /* 1352135 */     GIR_EraseRootFromParent_Done,
     /* 1352136 */   // Label 19273: @1352136
     /* 1352136 */   GIM_Try, /*On fail goto*//*Label 19274*/ GIMT_Encode4(1352220), // Rule ID 20294 //
     /* 1352141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1352144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1352158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1352161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1352183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352194 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1352197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352219 */     // GIR_Coverage, 20294,
     /* 1352219 */     GIR_EraseRootFromParent_Done,
     /* 1352220 */   // Label 19274: @1352220
     /* 1352220 */   GIM_Try, /*On fail goto*//*Label 19275*/ GIMT_Encode4(1352304), // Rule ID 20295 //
     /* 1352225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1352228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1352242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1352245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1352267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352278 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1352281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352303 */     // GIR_Coverage, 20295,
     /* 1352303 */     GIR_EraseRootFromParent_Done,
     /* 1352304 */   // Label 19275: @1352304
     /* 1352304 */   GIM_Try, /*On fail goto*//*Label 19276*/ GIMT_Encode4(1352388), // Rule ID 20298 //
     /* 1352309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1352312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1352320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1352323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1352326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1352329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1352351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352362 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1352365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352387 */     // GIR_Coverage, 20298,
     /* 1352387 */     GIR_EraseRootFromParent_Done,
     /* 1352388 */   // Label 19276: @1352388
     /* 1352388 */   GIM_Try, /*On fail goto*//*Label 19277*/ GIMT_Encode4(1352472), // Rule ID 20299 //
     /* 1352393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1352396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1352404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1352407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1352410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1352413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1352435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352446 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1352449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352471 */     // GIR_Coverage, 20299,
     /* 1352471 */     GIR_EraseRootFromParent_Done,
     /* 1352472 */   // Label 19277: @1352472
     /* 1352472 */   GIM_Try, /*On fail goto*//*Label 19278*/ GIMT_Encode4(1352556), // Rule ID 20302 //
     /* 1352477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1352480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1352488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1352491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1352494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1352497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1352519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352530 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1352533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352555 */     // GIR_Coverage, 20302,
     /* 1352555 */     GIR_EraseRootFromParent_Done,
     /* 1352556 */   // Label 19278: @1352556
     /* 1352556 */   GIM_Try, /*On fail goto*//*Label 19279*/ GIMT_Encode4(1352640), // Rule ID 20303 //
     /* 1352561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1352564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1352572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1352575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1352578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1352581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1352603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352614 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1352617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352639 */     // GIR_Coverage, 20303,
     /* 1352639 */     GIR_EraseRootFromParent_Done,
     /* 1352640 */   // Label 19279: @1352640
     /* 1352640 */   GIM_Try, /*On fail goto*//*Label 19280*/ GIMT_Encode4(1352724), // Rule ID 20306 //
     /* 1352645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1352662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1352665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1352687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352698 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1352701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352723 */     // GIR_Coverage, 20306,
     /* 1352723 */     GIR_EraseRootFromParent_Done,
     /* 1352724 */   // Label 19280: @1352724
     /* 1352724 */   GIM_Try, /*On fail goto*//*Label 19281*/ GIMT_Encode4(1352808), // Rule ID 20307 //
     /* 1352729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1352746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1352749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1352771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352782 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1352785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352807 */     // GIR_Coverage, 20307,
     /* 1352807 */     GIR_EraseRootFromParent_Done,
     /* 1352808 */   // Label 19281: @1352808
     /* 1352808 */   GIM_Try, /*On fail goto*//*Label 19282*/ GIMT_Encode4(1352892), // Rule ID 20310 //
     /* 1352813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1352830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1352833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1352855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352866 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1352869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352891 */     // GIR_Coverage, 20310,
     /* 1352891 */     GIR_EraseRootFromParent_Done,
     /* 1352892 */   // Label 19282: @1352892
     /* 1352892 */   GIM_Try, /*On fail goto*//*Label 19283*/ GIMT_Encode4(1352976), // Rule ID 20311 //
     /* 1352897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1352914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1352917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1352939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352950 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1352953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352975 */     // GIR_Coverage, 20311,
     /* 1352975 */     GIR_EraseRootFromParent_Done,
     /* 1352976 */   // Label 19283: @1352976
     /* 1352976 */   GIM_Try, /*On fail goto*//*Label 19284*/ GIMT_Encode4(1353060), // Rule ID 20314 //
     /* 1352981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1352984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1352998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1353001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1353004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1353023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353034 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1353037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353059 */     // GIR_Coverage, 20314,
     /* 1353059 */     GIR_EraseRootFromParent_Done,
     /* 1353060 */   // Label 19284: @1353060
     /* 1353060 */   GIM_Try, /*On fail goto*//*Label 19285*/ GIMT_Encode4(1353144), // Rule ID 20315 //
     /* 1353065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1353076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1353079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1353082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1353085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1353088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1353107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353118 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1353121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353143 */     // GIR_Coverage, 20315,
     /* 1353143 */     GIR_EraseRootFromParent_Done,
     /* 1353144 */   // Label 19285: @1353144
     /* 1353144 */   GIM_Try, /*On fail goto*//*Label 19286*/ GIMT_Encode4(1353228), // Rule ID 20318 //
     /* 1353149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1353152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1353166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1353169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1353191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353202 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1353205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353227 */     // GIR_Coverage, 20318,
     /* 1353227 */     GIR_EraseRootFromParent_Done,
     /* 1353228 */   // Label 19286: @1353228
     /* 1353228 */   GIM_Try, /*On fail goto*//*Label 19287*/ GIMT_Encode4(1353312), // Rule ID 20319 //
     /* 1353233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1353236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1353250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1353253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1353275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353286 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1353289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353311 */     // GIR_Coverage, 20319,
     /* 1353311 */     GIR_EraseRootFromParent_Done,
     /* 1353312 */   // Label 19287: @1353312
     /* 1353312 */   GIM_Try, /*On fail goto*//*Label 19288*/ GIMT_Encode4(1353396), // Rule ID 20322 //
     /* 1353317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1353328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1353331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1353334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1353337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1353359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353370 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1353373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353395 */     // GIR_Coverage, 20322,
     /* 1353395 */     GIR_EraseRootFromParent_Done,
     /* 1353396 */   // Label 19288: @1353396
     /* 1353396 */   GIM_Try, /*On fail goto*//*Label 19289*/ GIMT_Encode4(1353480), // Rule ID 20323 //
     /* 1353401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1353412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1353415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1353418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1353421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1353443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353454 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1353457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353479 */     // GIR_Coverage, 20323,
     /* 1353479 */     GIR_EraseRootFromParent_Done,
     /* 1353480 */   // Label 19289: @1353480
     /* 1353480 */   GIM_Try, /*On fail goto*//*Label 19290*/ GIMT_Encode4(1353564), // Rule ID 20326 //
     /* 1353485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1353496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1353499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1353502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1353505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1353508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1353527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353538 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1353541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353563 */     // GIR_Coverage, 20326,
     /* 1353563 */     GIR_EraseRootFromParent_Done,
     /* 1353564 */   // Label 19290: @1353564
     /* 1353564 */   GIM_Try, /*On fail goto*//*Label 19291*/ GIMT_Encode4(1353648), // Rule ID 20327 //
     /* 1353569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1353572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1353580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1353583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1353586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1353589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1353592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1353611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353622 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1353625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353647 */     // GIR_Coverage, 20327,
     /* 1353647 */     GIR_EraseRootFromParent_Done,
     /* 1353648 */   // Label 19291: @1353648
     /* 1353648 */   GIM_Try, /*On fail goto*//*Label 19292*/ GIMT_Encode4(1353732), // Rule ID 20330 //
     /* 1353653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1353656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1353670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1353673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1353695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353706 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1353709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353731 */     // GIR_Coverage, 20330,
     /* 1353731 */     GIR_EraseRootFromParent_Done,
     /* 1353732 */   // Label 19292: @1353732
     /* 1353732 */   GIM_Try, /*On fail goto*//*Label 19293*/ GIMT_Encode4(1353816), // Rule ID 20331 //
     /* 1353737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1353740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1353754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1353757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1353779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353790 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1353793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353815 */     // GIR_Coverage, 20331,
     /* 1353815 */     GIR_EraseRootFromParent_Done,
     /* 1353816 */   // Label 19293: @1353816
     /* 1353816 */   GIM_Try, /*On fail goto*//*Label 19294*/ GIMT_Encode4(1353900), // Rule ID 20334 //
     /* 1353821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1353824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1353838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1353841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1353863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353874 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1353877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353899 */     // GIR_Coverage, 20334,
     /* 1353899 */     GIR_EraseRootFromParent_Done,
     /* 1353900 */   // Label 19294: @1353900
     /* 1353900 */   GIM_Try, /*On fail goto*//*Label 19295*/ GIMT_Encode4(1353984), // Rule ID 20335 //
     /* 1353905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1353908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1353922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1353925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1353947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353958 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1353961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353983 */     // GIR_Coverage, 20335,
     /* 1353983 */     GIR_EraseRootFromParent_Done,
     /* 1353984 */   // Label 19295: @1353984
     /* 1353984 */   GIM_Try, /*On fail goto*//*Label 19296*/ GIMT_Encode4(1354068), // Rule ID 20338 //
     /* 1353989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1353992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1354000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1354003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1354006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1354009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1354012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1354031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354042 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1354045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354067 */     // GIR_Coverage, 20338,
     /* 1354067 */     GIR_EraseRootFromParent_Done,
     /* 1354068 */   // Label 19296: @1354068
     /* 1354068 */   GIM_Try, /*On fail goto*//*Label 19297*/ GIMT_Encode4(1354152), // Rule ID 20339 //
     /* 1354073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1354084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1354087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1354090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1354093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1354096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1354115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354126 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1354129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354151 */     // GIR_Coverage, 20339,
     /* 1354151 */     GIR_EraseRootFromParent_Done,
     /* 1354152 */   // Label 19297: @1354152
     /* 1354152 */   GIM_Try, /*On fail goto*//*Label 19298*/ GIMT_Encode4(1354236), // Rule ID 20342 //
     /* 1354157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1354160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1354174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1354177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1354199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354210 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1354213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354235 */     // GIR_Coverage, 20342,
     /* 1354235 */     GIR_EraseRootFromParent_Done,
     /* 1354236 */   // Label 19298: @1354236
     /* 1354236 */   GIM_Try, /*On fail goto*//*Label 19299*/ GIMT_Encode4(1354320), // Rule ID 20343 //
     /* 1354241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1354244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1354258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1354261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1354283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354294 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1354297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354319 */     // GIR_Coverage, 20343,
     /* 1354319 */     GIR_EraseRootFromParent_Done,
     /* 1354320 */   // Label 19299: @1354320
     /* 1354320 */   GIM_Try, /*On fail goto*//*Label 19300*/ GIMT_Encode4(1354404), // Rule ID 20346 //
     /* 1354325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1354328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1354336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1354339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1354342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1354345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1354367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354378 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1354381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354403 */     // GIR_Coverage, 20346,
     /* 1354403 */     GIR_EraseRootFromParent_Done,
     /* 1354404 */   // Label 19300: @1354404
     /* 1354404 */   GIM_Try, /*On fail goto*//*Label 19301*/ GIMT_Encode4(1354488), // Rule ID 20347 //
     /* 1354409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1354412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1354420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1354423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1354426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1354429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1354451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354462 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1354465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354487 */     // GIR_Coverage, 20347,
     /* 1354487 */     GIR_EraseRootFromParent_Done,
     /* 1354488 */   // Label 19301: @1354488
     /* 1354488 */   GIM_Try, /*On fail goto*//*Label 19302*/ GIMT_Encode4(1354572), // Rule ID 20350 //
     /* 1354493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1354496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1354504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1354507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1354510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1354513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1354516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1354535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354546 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1354549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354571 */     // GIR_Coverage, 20350,
     /* 1354571 */     GIR_EraseRootFromParent_Done,
     /* 1354572 */   // Label 19302: @1354572
     /* 1354572 */   GIM_Try, /*On fail goto*//*Label 19303*/ GIMT_Encode4(1354656), // Rule ID 20351 //
     /* 1354577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1354580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1354588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1354591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1354594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1354597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1354600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1354619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354630 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1354633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354655 */     // GIR_Coverage, 20351,
     /* 1354655 */     GIR_EraseRootFromParent_Done,
     /* 1354656 */   // Label 19303: @1354656
     /* 1354656 */   GIM_Try, /*On fail goto*//*Label 19304*/ GIMT_Encode4(1354740), // Rule ID 20354 //
     /* 1354661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1354664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1354678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1354681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1354703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354714 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1354717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354739 */     // GIR_Coverage, 20354,
     /* 1354739 */     GIR_EraseRootFromParent_Done,
     /* 1354740 */   // Label 19304: @1354740
     /* 1354740 */   GIM_Try, /*On fail goto*//*Label 19305*/ GIMT_Encode4(1354824), // Rule ID 20355 //
     /* 1354745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1354748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1354762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1354765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1354787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354798 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1354801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354823 */     // GIR_Coverage, 20355,
     /* 1354823 */     GIR_EraseRootFromParent_Done,
     /* 1354824 */   // Label 19305: @1354824
     /* 1354824 */   GIM_Try, /*On fail goto*//*Label 19306*/ GIMT_Encode4(1354908), // Rule ID 20358 //
     /* 1354829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1354832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1354846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1354849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1354871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354882 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1354885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354907 */     // GIR_Coverage, 20358,
     /* 1354907 */     GIR_EraseRootFromParent_Done,
     /* 1354908 */   // Label 19306: @1354908
     /* 1354908 */   GIM_Try, /*On fail goto*//*Label 19307*/ GIMT_Encode4(1354992), // Rule ID 20359 //
     /* 1354913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1354916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1354930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1354933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1354955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354966 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1354969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354991 */     // GIR_Coverage, 20359,
     /* 1354991 */     GIR_EraseRootFromParent_Done,
     /* 1354992 */   // Label 19307: @1354992
     /* 1354992 */   GIM_Try, /*On fail goto*//*Label 19308*/ GIMT_Encode4(1355076), // Rule ID 20362 //
     /* 1354997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1355000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1355008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1355011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1355014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1355017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1355039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355050 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1355053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1355071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355075 */     // GIR_Coverage, 20362,
     /* 1355075 */     GIR_EraseRootFromParent_Done,
     /* 1355076 */   // Label 19308: @1355076
     /* 1355076 */   GIM_Try, /*On fail goto*//*Label 19309*/ GIMT_Encode4(1355160), // Rule ID 20363 //
     /* 1355081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1355084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1355092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1355095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1355098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1355101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1355123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355134 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1355137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1355155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355159 */     // GIR_Coverage, 20363,
     /* 1355159 */     GIR_EraseRootFromParent_Done,
     /* 1355160 */   // Label 19309: @1355160
     /* 1355160 */   GIM_Try, /*On fail goto*//*Label 19310*/ GIMT_Encode4(1355244), // Rule ID 20366 //
     /* 1355165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1355173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1355176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1355179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1355182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1355185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355218 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1355221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355243 */     // GIR_Coverage, 20366,
     /* 1355243 */     GIR_EraseRootFromParent_Done,
     /* 1355244 */   // Label 19310: @1355244
     /* 1355244 */   GIM_Try, /*On fail goto*//*Label 19311*/ GIMT_Encode4(1355328), // Rule ID 20367 //
     /* 1355249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1355257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1355260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1355263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1355266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1355269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355302 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1355305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355327 */     // GIR_Coverage, 20367,
     /* 1355327 */     GIR_EraseRootFromParent_Done,
     /* 1355328 */   // Label 19311: @1355328
     /* 1355328 */   GIM_Try, /*On fail goto*//*Label 19312*/ GIMT_Encode4(1355412), // Rule ID 20370 //
     /* 1355333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1355341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1355344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1355347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1355350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1355353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355386 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1355389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355411 */     // GIR_Coverage, 20370,
     /* 1355411 */     GIR_EraseRootFromParent_Done,
     /* 1355412 */   // Label 19312: @1355412
     /* 1355412 */   GIM_Try, /*On fail goto*//*Label 19313*/ GIMT_Encode4(1355496), // Rule ID 20371 //
     /* 1355417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1355425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1355428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1355431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1355434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1355437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355470 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1355473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355495 */     // GIR_Coverage, 20371,
     /* 1355495 */     GIR_EraseRootFromParent_Done,
     /* 1355496 */   // Label 19313: @1355496
     /* 1355496 */   GIM_Try, /*On fail goto*//*Label 19314*/ GIMT_Encode4(1355580), // Rule ID 20374 //
     /* 1355501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1355509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1355512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1355515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1355518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1355521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355554 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1355557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355579 */     // GIR_Coverage, 20374,
     /* 1355579 */     GIR_EraseRootFromParent_Done,
     /* 1355580 */   // Label 19314: @1355580
     /* 1355580 */   GIM_Try, /*On fail goto*//*Label 19315*/ GIMT_Encode4(1355664), // Rule ID 20375 //
     /* 1355585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1355593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1355596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1355599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1355602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1355605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355638 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1355641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355663 */     // GIR_Coverage, 20375,
     /* 1355663 */     GIR_EraseRootFromParent_Done,
     /* 1355664 */   // Label 19315: @1355664
     /* 1355664 */   GIM_Try, /*On fail goto*//*Label 19316*/ GIMT_Encode4(1355748), // Rule ID 20378 //
     /* 1355669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1355677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1355680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1355683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1355686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1355689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355722 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1355725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355747 */     // GIR_Coverage, 20378,
     /* 1355747 */     GIR_EraseRootFromParent_Done,
     /* 1355748 */   // Label 19316: @1355748
     /* 1355748 */   GIM_Try, /*On fail goto*//*Label 19317*/ GIMT_Encode4(1355832), // Rule ID 20379 //
     /* 1355753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1355761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1355764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1355767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1355770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1355773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355806 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1355809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355831 */     // GIR_Coverage, 20379,
     /* 1355831 */     GIR_EraseRootFromParent_Done,
     /* 1355832 */   // Label 19317: @1355832
     /* 1355832 */   GIM_Try, /*On fail goto*//*Label 19318*/ GIMT_Encode4(1355916), // Rule ID 20382 //
     /* 1355837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1355845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1355848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1355851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1355854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1355857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355890 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1355893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355915 */     // GIR_Coverage, 20382,
     /* 1355915 */     GIR_EraseRootFromParent_Done,
     /* 1355916 */   // Label 19318: @1355916
     /* 1355916 */   GIM_Try, /*On fail goto*//*Label 19319*/ GIMT_Encode4(1356000), // Rule ID 20383 //
     /* 1355921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1355929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1355932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1355935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1355938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1355941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355974 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1355977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355999 */     // GIR_Coverage, 20383,
     /* 1355999 */     GIR_EraseRootFromParent_Done,
     /* 1356000 */   // Label 19319: @1356000
     /* 1356000 */   GIM_Try, /*On fail goto*//*Label 19320*/ GIMT_Encode4(1356084), // Rule ID 20386 //
     /* 1356005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1356008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1356013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1356016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1356019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1356022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1356025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356058 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1356061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356083 */     // GIR_Coverage, 20386,
     /* 1356083 */     GIR_EraseRootFromParent_Done,
     /* 1356084 */   // Label 19320: @1356084
     /* 1356084 */   GIM_Try, /*On fail goto*//*Label 19321*/ GIMT_Encode4(1356168), // Rule ID 20387 //
     /* 1356089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1356092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1356097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1356100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1356103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1356106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1356109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356142 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1356145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356167 */     // GIR_Coverage, 20387,
     /* 1356167 */     GIR_EraseRootFromParent_Done,
     /* 1356168 */   // Label 19321: @1356168
     /* 1356168 */   GIM_Try, /*On fail goto*//*Label 19322*/ GIMT_Encode4(1356252), // Rule ID 20390 //
     /* 1356173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1356176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1356181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1356190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1356193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356226 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1356229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356251 */     // GIR_Coverage, 20390,
     /* 1356251 */     GIR_EraseRootFromParent_Done,
     /* 1356252 */   // Label 19322: @1356252
     /* 1356252 */   GIM_Try, /*On fail goto*//*Label 19323*/ GIMT_Encode4(1356336), // Rule ID 20391 //
     /* 1356257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1356260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1356265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1356274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1356277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356310 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1356313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356335 */     // GIR_Coverage, 20391,
     /* 1356335 */     GIR_EraseRootFromParent_Done,
     /* 1356336 */   // Label 19323: @1356336
     /* 1356336 */   GIM_Try, /*On fail goto*//*Label 19324*/ GIMT_Encode4(1356420), // Rule ID 20394 //
     /* 1356341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1356344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1356349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1356352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1356355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1356358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1356361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356394 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1356397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356419 */     // GIR_Coverage, 20394,
     /* 1356419 */     GIR_EraseRootFromParent_Done,
     /* 1356420 */   // Label 19324: @1356420
     /* 1356420 */   GIM_Try, /*On fail goto*//*Label 19325*/ GIMT_Encode4(1356504), // Rule ID 20395 //
     /* 1356425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1356428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1356433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1356436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1356439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1356442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1356445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356478 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1356481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356503 */     // GIR_Coverage, 20395,
     /* 1356503 */     GIR_EraseRootFromParent_Done,
     /* 1356504 */   // Label 19325: @1356504
     /* 1356504 */   GIM_Try, /*On fail goto*//*Label 19326*/ GIMT_Encode4(1356588), // Rule ID 20398 //
     /* 1356509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1356512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1356517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1356520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1356523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1356526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1356529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1356532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356562 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1356565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356587 */     // GIR_Coverage, 20398,
     /* 1356587 */     GIR_EraseRootFromParent_Done,
     /* 1356588 */   // Label 19326: @1356588
     /* 1356588 */   GIM_Try, /*On fail goto*//*Label 19327*/ GIMT_Encode4(1356672), // Rule ID 20399 //
     /* 1356593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1356596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1356601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1356604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1356607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1356610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1356613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1356616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356646 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1356649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356671 */     // GIR_Coverage, 20399,
     /* 1356671 */     GIR_EraseRootFromParent_Done,
     /* 1356672 */   // Label 19327: @1356672
     /* 1356672 */   GIM_Try, /*On fail goto*//*Label 19328*/ GIMT_Encode4(1356756), // Rule ID 20402 //
     /* 1356677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1356680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1356685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1356688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1356691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1356694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1356697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356730 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1356733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356755 */     // GIR_Coverage, 20402,
     /* 1356755 */     GIR_EraseRootFromParent_Done,
     /* 1356756 */   // Label 19328: @1356756
     /* 1356756 */   GIM_Try, /*On fail goto*//*Label 19329*/ GIMT_Encode4(1356840), // Rule ID 20403 //
     /* 1356761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1356764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1356769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1356772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1356775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1356778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1356781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356814 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1356817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356839 */     // GIR_Coverage, 20403,
     /* 1356839 */     GIR_EraseRootFromParent_Done,
     /* 1356840 */   // Label 19329: @1356840
     /* 1356840 */   GIM_Try, /*On fail goto*//*Label 19330*/ GIMT_Encode4(1356924), // Rule ID 20406 //
     /* 1356845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1356848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1356853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1356862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1356865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356898 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1356901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356923 */     // GIR_Coverage, 20406,
     /* 1356923 */     GIR_EraseRootFromParent_Done,
     /* 1356924 */   // Label 19330: @1356924
     /* 1356924 */   GIM_Try, /*On fail goto*//*Label 19331*/ GIMT_Encode4(1357008), // Rule ID 20407 //
     /* 1356929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1356932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1356937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1356946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1356949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356982 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1356985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1357006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357007 */     // GIR_Coverage, 20407,
     /* 1357007 */     GIR_EraseRootFromParent_Done,
     /* 1357008 */   // Label 19331: @1357008
     /* 1357008 */   GIM_Try, /*On fail goto*//*Label 19332*/ GIMT_Encode4(1357092), // Rule ID 20410 //
     /* 1357013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1357021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1357024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1357027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1357030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1357033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1357036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357066 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1357066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1357069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1357075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1357077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1357090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357091 */     // GIR_Coverage, 20410,
     /* 1357091 */     GIR_EraseRootFromParent_Done,
     /* 1357092 */   // Label 19332: @1357092
     /* 1357092 */   GIM_Try, /*On fail goto*//*Label 19333*/ GIMT_Encode4(1357176), // Rule ID 20411 //
     /* 1357097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1357105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1357108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1357111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1357114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1357117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1357120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357150 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1357150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1357153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1357159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1357161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1357174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357175 */     // GIR_Coverage, 20411,
     /* 1357175 */     GIR_EraseRootFromParent_Done,
     /* 1357176 */   // Label 19333: @1357176
     /* 1357176 */   GIM_Try, /*On fail goto*//*Label 19334*/ GIMT_Encode4(1357260), // Rule ID 20414 //
     /* 1357181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1357184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1357189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1357192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1357195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1357198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1357201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357234 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1357234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1357237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1357243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1357245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1357255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1357258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357259 */     // GIR_Coverage, 20414,
     /* 1357259 */     GIR_EraseRootFromParent_Done,
     /* 1357260 */   // Label 19334: @1357260
     /* 1357260 */   GIM_Try, /*On fail goto*//*Label 19335*/ GIMT_Encode4(1357344), // Rule ID 20415 //
     /* 1357265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1357268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1357273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1357276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1357279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1357282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1357285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357318 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1357318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1357321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1357327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1357329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1357339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1357342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357343 */     // GIR_Coverage, 20415,
     /* 1357343 */     GIR_EraseRootFromParent_Done,
     /* 1357344 */   // Label 19335: @1357344
     /* 1357344 */   GIM_Try, /*On fail goto*//*Label 19336*/ GIMT_Encode4(1357428), // Rule ID 20418 //
     /* 1357349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1357352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1357357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1357360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1357363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1357366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1357369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357402 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1357402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1357405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1357411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1357413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1357423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1357426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357427 */     // GIR_Coverage, 20418,
     /* 1357427 */     GIR_EraseRootFromParent_Done,
     /* 1357428 */   // Label 19336: @1357428
     /* 1357428 */   GIM_Try, /*On fail goto*//*Label 19337*/ GIMT_Encode4(1357512), // Rule ID 20419 //
     /* 1357433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1357436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1357441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1357444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1357447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1357450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1357453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357486 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1357486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1357489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1357495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1357497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1357507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1357510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357511 */     // GIR_Coverage, 20419,
     /* 1357511 */     GIR_EraseRootFromParent_Done,
     /* 1357512 */   // Label 19337: @1357512
     /* 1357512 */   GIM_Try, /*On fail goto*//*Label 19338*/ GIMT_Encode4(1357596), // Rule ID 20422 //
     /* 1357517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1357520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1357525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1357528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1357531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1357534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1357537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1357540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357570 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1357570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1357573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1357579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1357581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1357591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1357594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357595 */     // GIR_Coverage, 20422,
     /* 1357595 */     GIR_EraseRootFromParent_Done,
     /* 1357596 */   // Label 19338: @1357596
     /* 1357596 */   GIM_Try, /*On fail goto*//*Label 19339*/ GIMT_Encode4(1357680), // Rule ID 20423 //
     /* 1357601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1357604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1357609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1357612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1357615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1357618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1357621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1357624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357654 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1357654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1357657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1357663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1357665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1357675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1357678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357679 */     // GIR_Coverage, 20423,
     /* 1357679 */     GIR_EraseRootFromParent_Done,
     /* 1357680 */   // Label 19339: @1357680
     /* 1357680 */   GIM_Try, /*On fail goto*//*Label 19340*/ GIMT_Encode4(1357764), // Rule ID 20426 //
     /* 1357685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1357688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1357693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1357696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1357699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1357702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1357705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357738 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1357738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1357741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1357747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1357749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1357762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357763 */     // GIR_Coverage, 20426,
     /* 1357763 */     GIR_EraseRootFromParent_Done,
     /* 1357764 */   // Label 19340: @1357764
     /* 1357764 */   GIM_Try, /*On fail goto*//*Label 19341*/ GIMT_Encode4(1357848), // Rule ID 20427 //
     /* 1357769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1357772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1357777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1357780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1357783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1357786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1357789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357822 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1357822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1357825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1357831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1357833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1357846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357847 */     // GIR_Coverage, 20427,
     /* 1357847 */     GIR_EraseRootFromParent_Done,
     /* 1357848 */   // Label 19341: @1357848
     /* 1357848 */   GIM_Try, /*On fail goto*//*Label 19342*/ GIMT_Encode4(1357932), // Rule ID 20430 //
     /* 1357853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1357856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1357861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1357864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1357867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1357870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1357873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357906 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1357906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1357909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1357915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1357917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1357930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357931 */     // GIR_Coverage, 20430,
     /* 1357931 */     GIR_EraseRootFromParent_Done,
     /* 1357932 */   // Label 19342: @1357932
     /* 1357932 */   GIM_Try, /*On fail goto*//*Label 19343*/ GIMT_Encode4(1358016), // Rule ID 20431 //
     /* 1357937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1357940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1357945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1357948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1357951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1357954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1357957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357990 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1357990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1357993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1357999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1358001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1358014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358015 */     // GIR_Coverage, 20431,
     /* 1358015 */     GIR_EraseRootFromParent_Done,
     /* 1358016 */   // Label 19343: @1358016
     /* 1358016 */   GIM_Try, /*On fail goto*//*Label 19344*/ GIMT_Encode4(1358100), // Rule ID 20434 //
     /* 1358021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1358024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1358029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1358032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1358035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1358038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1358041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358074 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1358074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1358077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1358083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1358085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1358095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1358098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358099 */     // GIR_Coverage, 20434,
     /* 1358099 */     GIR_EraseRootFromParent_Done,
     /* 1358100 */   // Label 19344: @1358100
     /* 1358100 */   GIM_Try, /*On fail goto*//*Label 19345*/ GIMT_Encode4(1358184), // Rule ID 20435 //
     /* 1358105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1358108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1358113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1358116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1358119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1358122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1358125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358158 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1358158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1358161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1358167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1358169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1358179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1358182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358183 */     // GIR_Coverage, 20435,
     /* 1358183 */     GIR_EraseRootFromParent_Done,
     /* 1358184 */   // Label 19345: @1358184
     /* 1358184 */   GIM_Try, /*On fail goto*//*Label 19346*/ GIMT_Encode4(1358268), // Rule ID 20438 //
     /* 1358189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1358192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1358197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1358200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1358203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1358206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1358209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1358212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358242 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1358242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1358245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1358251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1358253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1358266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358267 */     // GIR_Coverage, 20438,
     /* 1358267 */     GIR_EraseRootFromParent_Done,
     /* 1358268 */   // Label 19346: @1358268
     /* 1358268 */   GIM_Try, /*On fail goto*//*Label 19347*/ GIMT_Encode4(1358352), // Rule ID 20439 //
     /* 1358273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1358276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1358281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1358284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1358287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1358290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1358293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1358296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358326 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1358326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1358329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1358335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1358337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1358350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358351 */     // GIR_Coverage, 20439,
     /* 1358351 */     GIR_EraseRootFromParent_Done,
     /* 1358352 */   // Label 19347: @1358352
     /* 1358352 */   GIM_Try, /*On fail goto*//*Label 19348*/ GIMT_Encode4(1358436), // Rule ID 20442 //
     /* 1358357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1358360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1358365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1358368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1358371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1358374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1358377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358410 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1358410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1358413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1358419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1358421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1358431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1358434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358435 */     // GIR_Coverage, 20442,
     /* 1358435 */     GIR_EraseRootFromParent_Done,
     /* 1358436 */   // Label 19348: @1358436
     /* 1358436 */   GIM_Try, /*On fail goto*//*Label 19349*/ GIMT_Encode4(1358520), // Rule ID 20443 //
     /* 1358441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1358444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1358449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1358452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1358455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1358458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1358461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358494 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1358494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1358497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1358503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1358505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1358515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1358518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358519 */     // GIR_Coverage, 20443,
     /* 1358519 */     GIR_EraseRootFromParent_Done,
     /* 1358520 */   // Label 19349: @1358520
     /* 1358520 */   GIM_Try, /*On fail goto*//*Label 19350*/ GIMT_Encode4(1358604), // Rule ID 20446 //
     /* 1358525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1358528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1358533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1358536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1358539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1358545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358578 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1358578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1358581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1358587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1358589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1358602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358603 */     // GIR_Coverage, 20446,
     /* 1358603 */     GIR_EraseRootFromParent_Done,
     /* 1358604 */   // Label 19350: @1358604
     /* 1358604 */   GIM_Try, /*On fail goto*//*Label 19351*/ GIMT_Encode4(1358688), // Rule ID 20447 //
     /* 1358609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1358617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1358620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1358623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1358629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358662 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1358662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1358665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1358671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1358673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1358686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358687 */     // GIR_Coverage, 20447,
     /* 1358687 */     GIR_EraseRootFromParent_Done,
     /* 1358688 */   // Label 19351: @1358688
     /* 1358688 */   GIM_Try, /*On fail goto*//*Label 19352*/ GIMT_Encode4(1358772), // Rule ID 20450 //
     /* 1358693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1358696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1358701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1358704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1358707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1358713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358746 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1358746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1358749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1358755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1358757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1358770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358771 */     // GIR_Coverage, 20450,
     /* 1358771 */     GIR_EraseRootFromParent_Done,
     /* 1358772 */   // Label 19352: @1358772
     /* 1358772 */   GIM_Try, /*On fail goto*//*Label 19353*/ GIMT_Encode4(1358856), // Rule ID 20451 //
     /* 1358777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1358780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1358785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1358788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1358791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1358797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358830 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1358830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1358833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1358839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1358841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1358854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358855 */     // GIR_Coverage, 20451,
     /* 1358855 */     GIR_EraseRootFromParent_Done,
     /* 1358856 */   // Label 19353: @1358856
     /* 1358856 */   GIM_Try, /*On fail goto*//*Label 19354*/ GIMT_Encode4(1358940), // Rule ID 20454 //
     /* 1358861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1358864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1358869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1358872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1358875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1358878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1358881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1358884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358914 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1358914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1358917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1358923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1358925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1358938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358939 */     // GIR_Coverage, 20454,
     /* 1358939 */     GIR_EraseRootFromParent_Done,
     /* 1358940 */   // Label 19354: @1358940
     /* 1358940 */   GIM_Try, /*On fail goto*//*Label 19355*/ GIMT_Encode4(1359024), // Rule ID 20455 //
     /* 1358945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1358948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1358953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1358956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1358959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1358962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1358965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1358968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358998 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1358998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1359001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1359007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1359009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1359022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359023 */     // GIR_Coverage, 20455,
     /* 1359023 */     GIR_EraseRootFromParent_Done,
     /* 1359024 */   // Label 19355: @1359024
     /* 1359024 */   GIM_Try, /*On fail goto*//*Label 19356*/ GIMT_Encode4(1359108), // Rule ID 20458 //
     /* 1359029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1359032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1359037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1359040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1359043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1359049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359082 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1359082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1359085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1359091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1359093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1359106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359107 */     // GIR_Coverage, 20458,
     /* 1359107 */     GIR_EraseRootFromParent_Done,
     /* 1359108 */   // Label 19356: @1359108
     /* 1359108 */   GIM_Try, /*On fail goto*//*Label 19357*/ GIMT_Encode4(1359192), // Rule ID 20459 //
     /* 1359113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1359116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1359121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1359124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1359127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1359133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359166 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1359166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1359169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1359175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1359177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1359190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359191 */     // GIR_Coverage, 20459,
     /* 1359191 */     GIR_EraseRootFromParent_Done,
     /* 1359192 */   // Label 19357: @1359192
     /* 1359192 */   GIM_Try, /*On fail goto*//*Label 19358*/ GIMT_Encode4(1359276), // Rule ID 20462 //
     /* 1359197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1359205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1359208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1359211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1359217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359250 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1359250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1359253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1359259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1359261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1359274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359275 */     // GIR_Coverage, 20462,
     /* 1359275 */     GIR_EraseRootFromParent_Done,
     /* 1359276 */   // Label 19358: @1359276
     /* 1359276 */   GIM_Try, /*On fail goto*//*Label 19359*/ GIMT_Encode4(1359360), // Rule ID 20463 //
     /* 1359281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1359289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1359292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1359295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1359301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359334 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1359334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1359337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1359343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1359345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1359358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359359 */     // GIR_Coverage, 20463,
     /* 1359359 */     GIR_EraseRootFromParent_Done,
     /* 1359360 */   // Label 19359: @1359360
     /* 1359360 */   GIM_Try, /*On fail goto*//*Label 19360*/ GIMT_Encode4(1359444), // Rule ID 20466 //
     /* 1359365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1359373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1359376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1359379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1359382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1359385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359418 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1359418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1359421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1359427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1359429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1359442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359443 */     // GIR_Coverage, 20466,
     /* 1359443 */     GIR_EraseRootFromParent_Done,
     /* 1359444 */   // Label 19360: @1359444
     /* 1359444 */   GIM_Try, /*On fail goto*//*Label 19361*/ GIMT_Encode4(1359528), // Rule ID 20467 //
     /* 1359449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1359457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1359460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1359463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1359466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1359469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359502 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1359502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1359505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1359511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1359513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1359526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359527 */     // GIR_Coverage, 20467,
     /* 1359527 */     GIR_EraseRootFromParent_Done,
     /* 1359528 */   // Label 19361: @1359528
     /* 1359528 */   GIM_Try, /*On fail goto*//*Label 19362*/ GIMT_Encode4(1359612), // Rule ID 20470 //
     /* 1359533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1359541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1359544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1359547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1359550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1359553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359586 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1359586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1359589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1359595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1359597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1359610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359611 */     // GIR_Coverage, 20470,
     /* 1359611 */     GIR_EraseRootFromParent_Done,
     /* 1359612 */   // Label 19362: @1359612
     /* 1359612 */   GIM_Try, /*On fail goto*//*Label 19363*/ GIMT_Encode4(1359696), // Rule ID 20471 //
     /* 1359617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1359625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1359628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1359631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1359634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1359637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359670 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1359670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1359673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1359679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1359681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1359694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359695 */     // GIR_Coverage, 20471,
     /* 1359695 */     GIR_EraseRootFromParent_Done,
     /* 1359696 */   // Label 19363: @1359696
     /* 1359696 */   GIM_Try, /*On fail goto*//*Label 19364*/ GIMT_Encode4(1359780), // Rule ID 20474 //
     /* 1359701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1359704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1359709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1359712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1359715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1359718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1359721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1359724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359754 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1359754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1359757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1359763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1359765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1359775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1359778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359779 */     // GIR_Coverage, 20474,
     /* 1359779 */     GIR_EraseRootFromParent_Done,
     /* 1359780 */   // Label 19364: @1359780
     /* 1359780 */   GIM_Try, /*On fail goto*//*Label 19365*/ GIMT_Encode4(1359864), // Rule ID 20475 //
     /* 1359785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1359788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1359793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1359796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1359799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1359802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1359805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1359808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359838 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1359838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1359841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1359847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1359849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1359859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1359862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359863 */     // GIR_Coverage, 20475,
     /* 1359863 */     GIR_EraseRootFromParent_Done,
     /* 1359864 */   // Label 19365: @1359864
     /* 1359864 */   GIM_Try, /*On fail goto*//*Label 19366*/ GIMT_Encode4(1359948), // Rule ID 20478 //
     /* 1359869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1359872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1359877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1359880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1359883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1359886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1359889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359922 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1359922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1359925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1359931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1359933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1359943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1359946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359947 */     // GIR_Coverage, 20478,
     /* 1359947 */     GIR_EraseRootFromParent_Done,
     /* 1359948 */   // Label 19366: @1359948
     /* 1359948 */   GIM_Try, /*On fail goto*//*Label 19367*/ GIMT_Encode4(1360032), // Rule ID 20479 //
     /* 1359953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1359956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1359961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1359964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1359967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1359970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1359973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360006 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1360006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1360009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1360015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1360017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1360030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360031 */     // GIR_Coverage, 20479,
     /* 1360031 */     GIR_EraseRootFromParent_Done,
     /* 1360032 */   // Label 19367: @1360032
     /* 1360032 */   GIM_Try, /*On fail goto*//*Label 19368*/ GIMT_Encode4(1360116), // Rule ID 20482 //
     /* 1360037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1360045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1360048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1360051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1360054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1360057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360090 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1360090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1360093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1360099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1360101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1360114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360115 */     // GIR_Coverage, 20482,
     /* 1360115 */     GIR_EraseRootFromParent_Done,
     /* 1360116 */   // Label 19368: @1360116
     /* 1360116 */   GIM_Try, /*On fail goto*//*Label 19369*/ GIMT_Encode4(1360200), // Rule ID 20483 //
     /* 1360121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1360129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1360132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1360135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1360138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1360141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360174 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1360174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1360177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1360183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1360185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1360198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360199 */     // GIR_Coverage, 20483,
     /* 1360199 */     GIR_EraseRootFromParent_Done,
     /* 1360200 */   // Label 19369: @1360200
     /* 1360200 */   GIM_Try, /*On fail goto*//*Label 19370*/ GIMT_Encode4(1360281), // Rule ID 20540 //
     /* 1360205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1360208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1360216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1360219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1360222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1360225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1360228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360258 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1360258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1360261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360280 */     // GIR_Coverage, 20540,
     /* 1360280 */     GIR_EraseRootFromParent_Done,
     /* 1360281 */   // Label 19370: @1360281
     /* 1360281 */   GIM_Try, /*On fail goto*//*Label 19371*/ GIMT_Encode4(1360362), // Rule ID 20541 //
     /* 1360286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1360289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1360297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1360300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1360303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1360306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1360309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360339 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1360339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1360342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360361 */     // GIR_Coverage, 20541,
     /* 1360361 */     GIR_EraseRootFromParent_Done,
     /* 1360362 */   // Label 19371: @1360362
     /* 1360362 */   GIM_Try, /*On fail goto*//*Label 19372*/ GIMT_Encode4(1360443), // Rule ID 20542 //
     /* 1360367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1360370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1360378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1360381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1360384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1360387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1360390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1360409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360420 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1360420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1360423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360442 */     // GIR_Coverage, 20542,
     /* 1360442 */     GIR_EraseRootFromParent_Done,
     /* 1360443 */   // Label 19372: @1360443
     /* 1360443 */   GIM_Try, /*On fail goto*//*Label 19373*/ GIMT_Encode4(1360524), // Rule ID 20543 //
     /* 1360448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1360451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1360459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1360462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1360465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1360468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1360471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1360490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360501 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1360501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1360504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360523 */     // GIR_Coverage, 20543,
     /* 1360523 */     GIR_EraseRootFromParent_Done,
     /* 1360524 */   // Label 19373: @1360524
     /* 1360524 */   GIM_Try, /*On fail goto*//*Label 19374*/ GIMT_Encode4(1360605), // Rule ID 20544 //
     /* 1360529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1360532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1360540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1360543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1360546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1360549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360582 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1360582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1360585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360604 */     // GIR_Coverage, 20544,
     /* 1360604 */     GIR_EraseRootFromParent_Done,
     /* 1360605 */   // Label 19374: @1360605
     /* 1360605 */   GIM_Try, /*On fail goto*//*Label 19375*/ GIMT_Encode4(1360686), // Rule ID 20545 //
     /* 1360610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1360613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1360621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1360624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1360627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1360630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360663 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1360663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1360666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360685 */     // GIR_Coverage, 20545,
     /* 1360685 */     GIR_EraseRootFromParent_Done,
     /* 1360686 */   // Label 19375: @1360686
     /* 1360686 */   GIM_Try, /*On fail goto*//*Label 19376*/ GIMT_Encode4(1360767), // Rule ID 20546 //
     /* 1360691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1360694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1360702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1360705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1360708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1360711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1360733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360744 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1360744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1360747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360766 */     // GIR_Coverage, 20546,
     /* 1360766 */     GIR_EraseRootFromParent_Done,
     /* 1360767 */   // Label 19376: @1360767
     /* 1360767 */   GIM_Try, /*On fail goto*//*Label 19377*/ GIMT_Encode4(1360848), // Rule ID 20547 //
     /* 1360772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1360775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1360783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1360786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1360789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1360792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1360814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360825 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1360825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1360828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360847 */     // GIR_Coverage, 20547,
     /* 1360847 */     GIR_EraseRootFromParent_Done,
     /* 1360848 */   // Label 19377: @1360848
     /* 1360848 */   GIM_Try, /*On fail goto*//*Label 19378*/ GIMT_Encode4(1360929), // Rule ID 20548 //
     /* 1360853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1360856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1360864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1360867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1360870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1360873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1360876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360906 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1360906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1360909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360928 */     // GIR_Coverage, 20548,
     /* 1360928 */     GIR_EraseRootFromParent_Done,
     /* 1360929 */   // Label 19378: @1360929
     /* 1360929 */   GIM_Try, /*On fail goto*//*Label 19379*/ GIMT_Encode4(1361010), // Rule ID 20549 //
     /* 1360934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1360937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1360945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1360948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1360951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1360954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1360957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360987 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1360990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361009 */     // GIR_Coverage, 20549,
     /* 1361009 */     GIR_EraseRootFromParent_Done,
     /* 1361010 */   // Label 19379: @1361010
     /* 1361010 */   GIM_Try, /*On fail goto*//*Label 19380*/ GIMT_Encode4(1361091), // Rule ID 20550 //
     /* 1361015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1361018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1361026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1361029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1361032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1361035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1361057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361068 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1361068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1361071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361090 */     // GIR_Coverage, 20550,
     /* 1361090 */     GIR_EraseRootFromParent_Done,
     /* 1361091 */   // Label 19380: @1361091
     /* 1361091 */   GIM_Try, /*On fail goto*//*Label 19381*/ GIMT_Encode4(1361172), // Rule ID 20551 //
     /* 1361096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1361099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1361107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1361110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1361113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1361116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1361138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361149 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1361149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1361152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361171 */     // GIR_Coverage, 20551,
     /* 1361171 */     GIR_EraseRootFromParent_Done,
     /* 1361172 */   // Label 19381: @1361172
     /* 1361172 */   GIM_Try, /*On fail goto*//*Label 19382*/ GIMT_Encode4(1361253), // Rule ID 20552 //
     /* 1361177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1361180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1361194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361230 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1361230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1361233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361252 */     // GIR_Coverage, 20552,
     /* 1361252 */     GIR_EraseRootFromParent_Done,
     /* 1361253 */   // Label 19382: @1361253
     /* 1361253 */   GIM_Try, /*On fail goto*//*Label 19383*/ GIMT_Encode4(1361334), // Rule ID 20553 //
     /* 1361258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1361261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1361275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361311 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1361311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1361314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361333 */     // GIR_Coverage, 20553,
     /* 1361333 */     GIR_EraseRootFromParent_Done,
     /* 1361334 */   // Label 19383: @1361334
     /* 1361334 */   GIM_Try, /*On fail goto*//*Label 19384*/ GIMT_Encode4(1361415), // Rule ID 20554 //
     /* 1361339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1361342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1361356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1361359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1361381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361392 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1361392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1361395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361414 */     // GIR_Coverage, 20554,
     /* 1361414 */     GIR_EraseRootFromParent_Done,
     /* 1361415 */   // Label 19384: @1361415
     /* 1361415 */   GIM_Try, /*On fail goto*//*Label 19385*/ GIMT_Encode4(1361496), // Rule ID 20555 //
     /* 1361420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1361423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1361437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1361440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1361462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361473 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1361473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1361476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361495 */     // GIR_Coverage, 20555,
     /* 1361495 */     GIR_EraseRootFromParent_Done,
     /* 1361496 */   // Label 19385: @1361496
     /* 1361496 */   GIM_Try, /*On fail goto*//*Label 19386*/ GIMT_Encode4(1361577), // Rule ID 20556 //
     /* 1361501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1361504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1361518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361554 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1361554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1361557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361576 */     // GIR_Coverage, 20556,
     /* 1361576 */     GIR_EraseRootFromParent_Done,
     /* 1361577 */   // Label 19386: @1361577
     /* 1361577 */   GIM_Try, /*On fail goto*//*Label 19387*/ GIMT_Encode4(1361658), // Rule ID 20557 //
     /* 1361582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1361585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1361599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361635 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1361635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1361638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361657 */     // GIR_Coverage, 20557,
     /* 1361657 */     GIR_EraseRootFromParent_Done,
     /* 1361658 */   // Label 19387: @1361658
     /* 1361658 */   GIM_Try, /*On fail goto*//*Label 19388*/ GIMT_Encode4(1361739), // Rule ID 20558 //
     /* 1361663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1361666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1361680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1361683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1361705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361716 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1361716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1361719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361738 */     // GIR_Coverage, 20558,
     /* 1361738 */     GIR_EraseRootFromParent_Done,
     /* 1361739 */   // Label 19388: @1361739
     /* 1361739 */   GIM_Try, /*On fail goto*//*Label 19389*/ GIMT_Encode4(1361820), // Rule ID 20559 //
     /* 1361744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1361747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1361761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1361764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1361786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361797 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1361797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1361800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361819 */     // GIR_Coverage, 20559,
     /* 1361819 */     GIR_EraseRootFromParent_Done,
     /* 1361820 */   // Label 19389: @1361820
     /* 1361820 */   GIM_Try, /*On fail goto*//*Label 19390*/ GIMT_Encode4(1361901), // Rule ID 20560 //
     /* 1361825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1361828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1361836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1361839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1361842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1361845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361878 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1361878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1361881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361900 */     // GIR_Coverage, 20560,
     /* 1361900 */     GIR_EraseRootFromParent_Done,
     /* 1361901 */   // Label 19390: @1361901
     /* 1361901 */   GIM_Try, /*On fail goto*//*Label 19391*/ GIMT_Encode4(1361982), // Rule ID 20561 //
     /* 1361906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1361909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1361917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1361920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1361923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1361926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361959 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1361962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361981 */     // GIR_Coverage, 20561,
     /* 1361981 */     GIR_EraseRootFromParent_Done,
     /* 1361982 */   // Label 19391: @1361982
     /* 1361982 */   GIM_Try, /*On fail goto*//*Label 19392*/ GIMT_Encode4(1362063), // Rule ID 20562 //
     /* 1361987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1361990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1361998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1362001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1362004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1362007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1362029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362040 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1362040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1362043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1362061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362062 */     // GIR_Coverage, 20562,
     /* 1362062 */     GIR_EraseRootFromParent_Done,
     /* 1362063 */   // Label 19392: @1362063
     /* 1362063 */   GIM_Try, /*On fail goto*//*Label 19393*/ GIMT_Encode4(1362144), // Rule ID 20563 //
     /* 1362068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1362071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1362076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1362079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1362082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1362085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1362088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1362110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362121 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1362121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1362124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1362142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362143 */     // GIR_Coverage, 20563,
     /* 1362143 */     GIR_EraseRootFromParent_Done,
     /* 1362144 */   // Label 19393: @1362144
     /* 1362144 */   GIM_Try, /*On fail goto*//*Label 19394*/ GIMT_Encode4(1362225), // Rule ID 20564 //
     /* 1362149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1362152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1362157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1362160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1362163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1362166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1362169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1362179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362202 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1362202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1362205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362224 */     // GIR_Coverage, 20564,
     /* 1362224 */     GIR_EraseRootFromParent_Done,
     /* 1362225 */   // Label 19394: @1362225
     /* 1362225 */   GIM_Try, /*On fail goto*//*Label 19395*/ GIMT_Encode4(1362306), // Rule ID 20565 //
     /* 1362230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1362233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1362238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1362241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1362244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1362247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1362250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1362260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362283 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1362283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1362286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362305 */     // GIR_Coverage, 20565,
     /* 1362305 */     GIR_EraseRootFromParent_Done,
     /* 1362306 */   // Label 19395: @1362306
     /* 1362306 */   GIM_Try, /*On fail goto*//*Label 19396*/ GIMT_Encode4(1362387), // Rule ID 20566 //
     /* 1362311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1362314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1362319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1362322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1362325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1362328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1362331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1362341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1362353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362364 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1362364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1362367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362386 */     // GIR_Coverage, 20566,
     /* 1362386 */     GIR_EraseRootFromParent_Done,
     /* 1362387 */   // Label 19396: @1362387
     /* 1362387 */   GIM_Try, /*On fail goto*//*Label 19397*/ GIMT_Encode4(1362468), // Rule ID 20567 //
     /* 1362392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1362395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1362400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1362403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1362406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1362409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1362412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1362422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1362434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362445 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1362445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1362448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362467 */     // GIR_Coverage, 20567,
     /* 1362467 */     GIR_EraseRootFromParent_Done,
     /* 1362468 */   // Label 19397: @1362468
     /* 1362468 */   GIM_Try, /*On fail goto*//*Label 19398*/ GIMT_Encode4(1362549), // Rule ID 20568 //
     /* 1362473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1362476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1362481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1362484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1362487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1362490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1362493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1362496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1362503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362526 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1362526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1362529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362548 */     // GIR_Coverage, 20568,
     /* 1362548 */     GIR_EraseRootFromParent_Done,
     /* 1362549 */   // Label 19398: @1362549
     /* 1362549 */   GIM_Try, /*On fail goto*//*Label 19399*/ GIMT_Encode4(1362630), // Rule ID 20569 //
     /* 1362554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1362557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1362562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1362565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1362568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1362571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1362574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1362577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1362584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362607 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1362607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1362610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362629 */     // GIR_Coverage, 20569,
     /* 1362629 */     GIR_EraseRootFromParent_Done,
     /* 1362630 */   // Label 19399: @1362630
     /* 1362630 */   GIM_Try, /*On fail goto*//*Label 19400*/ GIMT_Encode4(1362711), // Rule ID 20570 //
     /* 1362635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1362638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1362643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1362646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1362649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1362652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1362655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1362658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1362665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1362677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362688 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1362688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1362691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362710 */     // GIR_Coverage, 20570,
     /* 1362710 */     GIR_EraseRootFromParent_Done,
     /* 1362711 */   // Label 19400: @1362711
     /* 1362711 */   GIM_Try, /*On fail goto*//*Label 19401*/ GIMT_Encode4(1362792), // Rule ID 20571 //
     /* 1362716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1362719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1362724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1362727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1362730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1362733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1362736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1362739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1362746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1362758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362769 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1362769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1362772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362791 */     // GIR_Coverage, 20571,
     /* 1362791 */     GIR_EraseRootFromParent_Done,
     /* 1362792 */   // Label 19401: @1362792
     /* 1362792 */   GIM_Try, /*On fail goto*//*Label 19402*/ GIMT_Encode4(1362873), // Rule ID 20572 //
     /* 1362797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1362800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1362805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1362808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1362811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1362814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1362817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1362820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1362827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1362831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1362835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1362839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362850 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1362850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1362853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362872 */     // GIR_Coverage, 20572,
     /* 1362872 */     GIR_EraseRootFromParent_Done,
     /* 1362873 */   // Label 19402: @1362873
     /* 1362873 */   GIM_Try, /*On fail goto*//*Label 19403*/ GIMT_Encode4(1362954), // Rule ID 20573 //
     /* 1362878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1362881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1362886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1362889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1362892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1362895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1362898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1362901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1362908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1362912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1362916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1362920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362931 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1362931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1362934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1362938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362953 */     // GIR_Coverage, 20573,
     /* 1362953 */     GIR_EraseRootFromParent_Done,
     /* 1362954 */   // Label 19403: @1362954
     /* 1362954 */   GIM_Try, /*On fail goto*//*Label 19404*/ GIMT_Encode4(1363035), // Rule ID 20574 //
     /* 1362959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1362962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1362967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1362970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1362973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1362976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1362979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1362982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1362989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1362993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1362997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1363001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363012 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1363012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1363015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363034 */     // GIR_Coverage, 20574,
     /* 1363034 */     GIR_EraseRootFromParent_Done,
     /* 1363035 */   // Label 19404: @1363035
     /* 1363035 */   GIM_Try, /*On fail goto*//*Label 19405*/ GIMT_Encode4(1363116), // Rule ID 20575 //
     /* 1363040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1363043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1363048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1363051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1363054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1363057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1363060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1363063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1363070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1363082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363093 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1363093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1363096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363115 */     // GIR_Coverage, 20575,
     /* 1363115 */     GIR_EraseRootFromParent_Done,
     /* 1363116 */   // Label 19405: @1363116
     /* 1363116 */   GIM_Try, /*On fail goto*//*Label 19406*/ GIMT_Encode4(1363197), // Rule ID 20576 //
     /* 1363121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1363124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1363129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1363132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1363135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1363138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1363141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1363151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363174 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1363174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1363177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363196 */     // GIR_Coverage, 20576,
     /* 1363196 */     GIR_EraseRootFromParent_Done,
     /* 1363197 */   // Label 19406: @1363197
     /* 1363197 */   GIM_Try, /*On fail goto*//*Label 19407*/ GIMT_Encode4(1363278), // Rule ID 20577 //
     /* 1363202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1363205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1363210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1363213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1363216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1363219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1363222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1363232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363255 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1363255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1363258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363277 */     // GIR_Coverage, 20577,
     /* 1363277 */     GIR_EraseRootFromParent_Done,
     /* 1363278 */   // Label 19407: @1363278
     /* 1363278 */   GIM_Try, /*On fail goto*//*Label 19408*/ GIMT_Encode4(1363359), // Rule ID 20578 //
     /* 1363283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1363286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1363291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1363294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1363297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1363300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1363303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1363313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1363325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363336 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1363336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1363339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363358 */     // GIR_Coverage, 20578,
     /* 1363358 */     GIR_EraseRootFromParent_Done,
     /* 1363359 */   // Label 19408: @1363359
     /* 1363359 */   GIM_Try, /*On fail goto*//*Label 19409*/ GIMT_Encode4(1363440), // Rule ID 20579 //
     /* 1363364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1363367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1363372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1363375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1363378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1363381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1363384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1363394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1363406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363417 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1363417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1363420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363439 */     // GIR_Coverage, 20579,
     /* 1363439 */     GIR_EraseRootFromParent_Done,
     /* 1363440 */   // Label 19409: @1363440
     /* 1363440 */   GIM_Try, /*On fail goto*//*Label 19410*/ GIMT_Encode4(1363521), // Rule ID 20580 //
     /* 1363445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1363448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1363453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1363456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1363459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1363462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1363465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1363475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363498 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1363498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1363501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363520 */     // GIR_Coverage, 20580,
     /* 1363520 */     GIR_EraseRootFromParent_Done,
     /* 1363521 */   // Label 19410: @1363521
     /* 1363521 */   GIM_Try, /*On fail goto*//*Label 19411*/ GIMT_Encode4(1363602), // Rule ID 20581 //
     /* 1363526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1363529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1363534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1363537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1363540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1363543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1363546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1363556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363579 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1363579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1363582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363601 */     // GIR_Coverage, 20581,
     /* 1363601 */     GIR_EraseRootFromParent_Done,
     /* 1363602 */   // Label 19411: @1363602
     /* 1363602 */   GIM_Try, /*On fail goto*//*Label 19412*/ GIMT_Encode4(1363683), // Rule ID 20582 //
     /* 1363607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1363610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1363615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1363618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1363621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1363624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1363627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1363637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1363649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363660 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1363660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1363663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363682 */     // GIR_Coverage, 20582,
     /* 1363682 */     GIR_EraseRootFromParent_Done,
     /* 1363683 */   // Label 19412: @1363683
     /* 1363683 */   GIM_Try, /*On fail goto*//*Label 19413*/ GIMT_Encode4(1363764), // Rule ID 20583 //
     /* 1363688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1363691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1363696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1363699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1363702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1363705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1363708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1363718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1363730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363741 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1363741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1363744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363763 */     // GIR_Coverage, 20583,
     /* 1363763 */     GIR_EraseRootFromParent_Done,
     /* 1363764 */   // Label 19413: @1363764
     /* 1363764 */   GIM_Try, /*On fail goto*//*Label 19414*/ GIMT_Encode4(1363845), // Rule ID 20584 //
     /* 1363769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1363772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1363777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1363780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1363783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1363786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1363789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1363799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363822 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1363822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1363825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363844 */     // GIR_Coverage, 20584,
     /* 1363844 */     GIR_EraseRootFromParent_Done,
     /* 1363845 */   // Label 19414: @1363845
     /* 1363845 */   GIM_Try, /*On fail goto*//*Label 19415*/ GIMT_Encode4(1363926), // Rule ID 20585 //
     /* 1363850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1363853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1363858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1363861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1363864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1363867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1363870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1363880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363903 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1363903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1363906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363925 */     // GIR_Coverage, 20585,
     /* 1363925 */     GIR_EraseRootFromParent_Done,
     /* 1363926 */   // Label 19415: @1363926
     /* 1363926 */   GIM_Try, /*On fail goto*//*Label 19416*/ GIMT_Encode4(1364007), // Rule ID 20586 //
     /* 1363931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1363934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1363939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1363942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1363945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1363948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1363951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1363961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1363973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363984 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1363984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1363987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1363991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364006 */     // GIR_Coverage, 20586,
     /* 1364006 */     GIR_EraseRootFromParent_Done,
     /* 1364007 */   // Label 19416: @1364007
     /* 1364007 */   GIM_Try, /*On fail goto*//*Label 19417*/ GIMT_Encode4(1364088), // Rule ID 20587 //
     /* 1364012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1364015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1364020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1364023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1364026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1364029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1364032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1364042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1364054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364065 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1364065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1364068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364087 */     // GIR_Coverage, 20587,
     /* 1364087 */     GIR_EraseRootFromParent_Done,
     /* 1364088 */   // Label 19417: @1364088
     /* 1364088 */   GIM_Try, /*On fail goto*//*Label 19418*/ GIMT_Encode4(1364169), // Rule ID 20588 //
     /* 1364093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1364096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1364101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1364104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1364107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1364110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1364113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1364123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364146 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1364146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1364149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364168 */     // GIR_Coverage, 20588,
     /* 1364168 */     GIR_EraseRootFromParent_Done,
     /* 1364169 */   // Label 19418: @1364169
     /* 1364169 */   GIM_Try, /*On fail goto*//*Label 19419*/ GIMT_Encode4(1364250), // Rule ID 20589 //
     /* 1364174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1364177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1364182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1364185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1364188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1364191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1364194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1364204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364227 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1364227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1364230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364249 */     // GIR_Coverage, 20589,
     /* 1364249 */     GIR_EraseRootFromParent_Done,
     /* 1364250 */   // Label 19419: @1364250
     /* 1364250 */   GIM_Try, /*On fail goto*//*Label 19420*/ GIMT_Encode4(1364331), // Rule ID 20590 //
     /* 1364255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1364258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1364263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1364266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1364269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1364272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1364275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1364285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1364297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364308 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1364308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1364311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364330 */     // GIR_Coverage, 20590,
     /* 1364330 */     GIR_EraseRootFromParent_Done,
     /* 1364331 */   // Label 19420: @1364331
     /* 1364331 */   GIM_Try, /*On fail goto*//*Label 19421*/ GIMT_Encode4(1364412), // Rule ID 20591 //
     /* 1364336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1364339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1364344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1364347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1364350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1364353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1364356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1364366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1364378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364389 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1364389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1364392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364411 */     // GIR_Coverage, 20591,
     /* 1364411 */     GIR_EraseRootFromParent_Done,
     /* 1364412 */   // Label 19421: @1364412
     /* 1364412 */   GIM_Try, /*On fail goto*//*Label 19422*/ GIMT_Encode4(1364493), // Rule ID 20592 //
     /* 1364417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1364420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1364425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1364428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1364431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1364434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1364437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1364447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364470 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1364470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1364473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364492 */     // GIR_Coverage, 20592,
     /* 1364492 */     GIR_EraseRootFromParent_Done,
     /* 1364493 */   // Label 19422: @1364493
     /* 1364493 */   GIM_Try, /*On fail goto*//*Label 19423*/ GIMT_Encode4(1364574), // Rule ID 20593 //
     /* 1364498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1364501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1364506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1364509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1364512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1364515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1364518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1364528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364551 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1364551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1364554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364573 */     // GIR_Coverage, 20593,
     /* 1364573 */     GIR_EraseRootFromParent_Done,
     /* 1364574 */   // Label 19423: @1364574
     /* 1364574 */   GIM_Try, /*On fail goto*//*Label 19424*/ GIMT_Encode4(1364655), // Rule ID 20594 //
     /* 1364579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1364582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1364587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1364590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1364593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1364596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1364599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1364609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1364621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364632 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1364632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1364635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364654 */     // GIR_Coverage, 20594,
     /* 1364654 */     GIR_EraseRootFromParent_Done,
     /* 1364655 */   // Label 19424: @1364655
     /* 1364655 */   GIM_Try, /*On fail goto*//*Label 19425*/ GIMT_Encode4(1364736), // Rule ID 20595 //
     /* 1364660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1364663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1364668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1364671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1364674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1364677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1364680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1364690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1364702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364713 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1364713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1364716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364735 */     // GIR_Coverage, 20595,
     /* 1364735 */     GIR_EraseRootFromParent_Done,
     /* 1364736 */   // Label 19425: @1364736
     /* 1364736 */   GIM_Try, /*On fail goto*//*Label 19426*/ GIMT_Encode4(1364817), // Rule ID 20596 //
     /* 1364741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1364744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1364749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1364752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1364755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1364758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1364761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1364771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364794 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1364794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1364797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364816 */     // GIR_Coverage, 20596,
     /* 1364816 */     GIR_EraseRootFromParent_Done,
     /* 1364817 */   // Label 19426: @1364817
     /* 1364817 */   GIM_Try, /*On fail goto*//*Label 19427*/ GIMT_Encode4(1364898), // Rule ID 20597 //
     /* 1364822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1364825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1364830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1364833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1364836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1364839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1364842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1364852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364875 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1364875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1364878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364897 */     // GIR_Coverage, 20597,
     /* 1364897 */     GIR_EraseRootFromParent_Done,
     /* 1364898 */   // Label 19427: @1364898
     /* 1364898 */   GIM_Try, /*On fail goto*//*Label 19428*/ GIMT_Encode4(1364979), // Rule ID 20598 //
     /* 1364903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1364906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1364911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1364914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1364917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1364920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1364923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1364933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1364945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364956 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1364956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1364959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1364963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364978 */     // GIR_Coverage, 20598,
     /* 1364978 */     GIR_EraseRootFromParent_Done,
     /* 1364979 */   // Label 19428: @1364979
     /* 1364979 */   GIM_Try, /*On fail goto*//*Label 19429*/ GIMT_Encode4(1365060), // Rule ID 20599 //
     /* 1364984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1364987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1364992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1364995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1364998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1365001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1365004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1365014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1365026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365037 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1365037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1365040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1365044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365059 */     // GIR_Coverage, 20599,
     /* 1365059 */     GIR_EraseRootFromParent_Done,
     /* 1365060 */   // Label 19429: @1365060
     /* 1365060 */   GIM_Try, /*On fail goto*//*Label 19430*/ GIMT_Encode4(1365144), // Rule ID 21980 //
     /* 1365065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1365082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365118 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1365121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365143 */     // GIR_Coverage, 21980,
     /* 1365143 */     GIR_EraseRootFromParent_Done,
     /* 1365144 */   // Label 19430: @1365144
     /* 1365144 */   GIM_Try, /*On fail goto*//*Label 19431*/ GIMT_Encode4(1365228), // Rule ID 21981 //
     /* 1365149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1365166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365202 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1365205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365227 */     // GIR_Coverage, 21981,
     /* 1365227 */     GIR_EraseRootFromParent_Done,
     /* 1365228 */   // Label 19431: @1365228
     /* 1365228 */   GIM_Try, /*On fail goto*//*Label 19432*/ GIMT_Encode4(1365312), // Rule ID 21984 //
     /* 1365233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1365250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365286 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1365289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365311 */     // GIR_Coverage, 21984,
     /* 1365311 */     GIR_EraseRootFromParent_Done,
     /* 1365312 */   // Label 19432: @1365312
     /* 1365312 */   GIM_Try, /*On fail goto*//*Label 19433*/ GIMT_Encode4(1365396), // Rule ID 21985 //
     /* 1365317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1365334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365370 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1365373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365395 */     // GIR_Coverage, 21985,
     /* 1365395 */     GIR_EraseRootFromParent_Done,
     /* 1365396 */   // Label 19433: @1365396
     /* 1365396 */   GIM_Try, /*On fail goto*//*Label 19434*/ GIMT_Encode4(1365480), // Rule ID 21988 //
     /* 1365401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1365418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365454 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1365457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365479 */     // GIR_Coverage, 21988,
     /* 1365479 */     GIR_EraseRootFromParent_Done,
     /* 1365480 */   // Label 19434: @1365480
     /* 1365480 */   GIM_Try, /*On fail goto*//*Label 19435*/ GIMT_Encode4(1365564), // Rule ID 21989 //
     /* 1365485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1365502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365538 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1365541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365563 */     // GIR_Coverage, 21989,
     /* 1365563 */     GIR_EraseRootFromParent_Done,
     /* 1365564 */   // Label 19435: @1365564
     /* 1365564 */   GIM_Try, /*On fail goto*//*Label 19436*/ GIMT_Encode4(1365648), // Rule ID 21992 //
     /* 1365569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1365586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365622 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1365625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365647 */     // GIR_Coverage, 21992,
     /* 1365647 */     GIR_EraseRootFromParent_Done,
     /* 1365648 */   // Label 19436: @1365648
     /* 1365648 */   GIM_Try, /*On fail goto*//*Label 19437*/ GIMT_Encode4(1365732), // Rule ID 21993 //
     /* 1365653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1365670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365706 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1365709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365731 */     // GIR_Coverage, 21993,
     /* 1365731 */     GIR_EraseRootFromParent_Done,
     /* 1365732 */   // Label 19437: @1365732
     /* 1365732 */   GIM_Try, /*On fail goto*//*Label 19438*/ GIMT_Encode4(1365816), // Rule ID 21996 //
     /* 1365737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1365748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1365751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1365754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1365757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365790 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1365793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1365811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365815 */     // GIR_Coverage, 21996,
     /* 1365815 */     GIR_EraseRootFromParent_Done,
     /* 1365816 */   // Label 19438: @1365816
     /* 1365816 */   GIM_Try, /*On fail goto*//*Label 19439*/ GIMT_Encode4(1365900), // Rule ID 21997 //
     /* 1365821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1365832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1365835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1365838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1365841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365874 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1365877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1365895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365899 */     // GIR_Coverage, 21997,
     /* 1365899 */     GIR_EraseRootFromParent_Done,
     /* 1365900 */   // Label 19439: @1365900
     /* 1365900 */   GIM_Try, /*On fail goto*//*Label 19440*/ GIMT_Encode4(1365984), // Rule ID 22000 //
     /* 1365905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1365922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365958 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1365961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365983 */     // GIR_Coverage, 22000,
     /* 1365983 */     GIR_EraseRootFromParent_Done,
     /* 1365984 */   // Label 19440: @1365984
     /* 1365984 */   GIM_Try, /*On fail goto*//*Label 19441*/ GIMT_Encode4(1366068), // Rule ID 22001 //
     /* 1365989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1366006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1366012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366042 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1366045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366067 */     // GIR_Coverage, 22001,
     /* 1366067 */     GIR_EraseRootFromParent_Done,
     /* 1366068 */   // Label 19441: @1366068
     /* 1366068 */   GIM_Try, /*On fail goto*//*Label 19442*/ GIMT_Encode4(1366152), // Rule ID 22004 //
     /* 1366073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1366081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1366090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366126 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1366129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366151 */     // GIR_Coverage, 22004,
     /* 1366151 */     GIR_EraseRootFromParent_Done,
     /* 1366152 */   // Label 19442: @1366152
     /* 1366152 */   GIM_Try, /*On fail goto*//*Label 19443*/ GIMT_Encode4(1366236), // Rule ID 22005 //
     /* 1366157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1366165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1366174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366210 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1366213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366235 */     // GIR_Coverage, 22005,
     /* 1366235 */     GIR_EraseRootFromParent_Done,
     /* 1366236 */   // Label 19443: @1366236
     /* 1366236 */   GIM_Try, /*On fail goto*//*Label 19444*/ GIMT_Encode4(1366320), // Rule ID 22008 //
     /* 1366241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1366249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1366258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366294 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1366297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366319 */     // GIR_Coverage, 22008,
     /* 1366319 */     GIR_EraseRootFromParent_Done,
     /* 1366320 */   // Label 19444: @1366320
     /* 1366320 */   GIM_Try, /*On fail goto*//*Label 19445*/ GIMT_Encode4(1366404), // Rule ID 22009 //
     /* 1366325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1366333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1366342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366378 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1366381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366403 */     // GIR_Coverage, 22009,
     /* 1366403 */     GIR_EraseRootFromParent_Done,
     /* 1366404 */   // Label 19445: @1366404
     /* 1366404 */   GIM_Try, /*On fail goto*//*Label 19446*/ GIMT_Encode4(1366488), // Rule ID 22012 //
     /* 1366409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1366412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1366417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1366420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1366423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1366426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1366429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366462 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1366465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366487 */     // GIR_Coverage, 22012,
     /* 1366487 */     GIR_EraseRootFromParent_Done,
     /* 1366488 */   // Label 19446: @1366488
     /* 1366488 */   GIM_Try, /*On fail goto*//*Label 19447*/ GIMT_Encode4(1366572), // Rule ID 22013 //
     /* 1366493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1366496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1366501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1366504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1366507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1366510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1366513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366546 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1366549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366571 */     // GIR_Coverage, 22013,
     /* 1366571 */     GIR_EraseRootFromParent_Done,
     /* 1366572 */   // Label 19447: @1366572
     /* 1366572 */   GIM_Try, /*On fail goto*//*Label 19448*/ GIMT_Encode4(1366656), // Rule ID 22016 //
     /* 1366577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1366585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1366594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1366600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366630 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1366633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366655 */     // GIR_Coverage, 22016,
     /* 1366655 */     GIR_EraseRootFromParent_Done,
     /* 1366656 */   // Label 19448: @1366656
     /* 1366656 */   GIM_Try, /*On fail goto*//*Label 19449*/ GIMT_Encode4(1366740), // Rule ID 22017 //
     /* 1366661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1366669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1366678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1366684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366714 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1366717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366739 */     // GIR_Coverage, 22017,
     /* 1366739 */     GIR_EraseRootFromParent_Done,
     /* 1366740 */   // Label 19449: @1366740
     /* 1366740 */   GIM_Try, /*On fail goto*//*Label 19450*/ GIMT_Encode4(1366824), // Rule ID 22020 //
     /* 1366745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1366753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1366762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1366768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1366783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366798 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1366801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366823 */     // GIR_Coverage, 22020,
     /* 1366823 */     GIR_EraseRootFromParent_Done,
     /* 1366824 */   // Label 19450: @1366824
     /* 1366824 */   GIM_Try, /*On fail goto*//*Label 19451*/ GIMT_Encode4(1366908), // Rule ID 22021 //
     /* 1366829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1366837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1366846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1366852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1366867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366882 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1366885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366907 */     // GIR_Coverage, 22021,
     /* 1366907 */     GIR_EraseRootFromParent_Done,
     /* 1366908 */   // Label 19451: @1366908
     /* 1366908 */   GIM_Try, /*On fail goto*//*Label 19452*/ GIMT_Encode4(1366992), // Rule ID 22024 //
     /* 1366913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1366921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1366930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1366936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366966 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1366969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366991 */     // GIR_Coverage, 22024,
     /* 1366991 */     GIR_EraseRootFromParent_Done,
     /* 1366992 */   // Label 19452: @1366992
     /* 1366992 */   GIM_Try, /*On fail goto*//*Label 19453*/ GIMT_Encode4(1367076), // Rule ID 22025 //
     /* 1366997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1367005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1367014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1367020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367050 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1367053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367075 */     // GIR_Coverage, 22025,
     /* 1367075 */     GIR_EraseRootFromParent_Done,
     /* 1367076 */   // Label 19453: @1367076
     /* 1367076 */   GIM_Try, /*On fail goto*//*Label 19454*/ GIMT_Encode4(1367160), // Rule ID 22028 //
     /* 1367081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1367089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1367098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367134 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1367137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367159 */     // GIR_Coverage, 22028,
     /* 1367159 */     GIR_EraseRootFromParent_Done,
     /* 1367160 */   // Label 19454: @1367160
     /* 1367160 */   GIM_Try, /*On fail goto*//*Label 19455*/ GIMT_Encode4(1367244), // Rule ID 22029 //
     /* 1367165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1367173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1367182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367218 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1367221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367243 */     // GIR_Coverage, 22029,
     /* 1367243 */     GIR_EraseRootFromParent_Done,
     /* 1367244 */   // Label 19455: @1367244
     /* 1367244 */   GIM_Try, /*On fail goto*//*Label 19456*/ GIMT_Encode4(1367328), // Rule ID 22032 //
     /* 1367249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1367257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1367266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1367305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367327 */     // GIR_Coverage, 22032,
     /* 1367327 */     GIR_EraseRootFromParent_Done,
     /* 1367328 */   // Label 19456: @1367328
     /* 1367328 */   GIM_Try, /*On fail goto*//*Label 19457*/ GIMT_Encode4(1367412), // Rule ID 22033 //
     /* 1367333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1367341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1367350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1367389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367411 */     // GIR_Coverage, 22033,
     /* 1367411 */     GIR_EraseRootFromParent_Done,
     /* 1367412 */   // Label 19457: @1367412
     /* 1367412 */   GIM_Try, /*On fail goto*//*Label 19458*/ GIMT_Encode4(1367496), // Rule ID 22036 //
     /* 1367417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1367425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1367434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367470 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1367473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367495 */     // GIR_Coverage, 22036,
     /* 1367495 */     GIR_EraseRootFromParent_Done,
     /* 1367496 */   // Label 19458: @1367496
     /* 1367496 */   GIM_Try, /*On fail goto*//*Label 19459*/ GIMT_Encode4(1367580), // Rule ID 22037 //
     /* 1367501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1367509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1367518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367554 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1367557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367579 */     // GIR_Coverage, 22037,
     /* 1367579 */     GIR_EraseRootFromParent_Done,
     /* 1367580 */   // Label 19459: @1367580
     /* 1367580 */   GIM_Try, /*On fail goto*//*Label 19460*/ GIMT_Encode4(1367664), // Rule ID 22040 //
     /* 1367585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1367593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1367602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1367608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1367641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367663 */     // GIR_Coverage, 22040,
     /* 1367663 */     GIR_EraseRootFromParent_Done,
     /* 1367664 */   // Label 19460: @1367664
     /* 1367664 */   GIM_Try, /*On fail goto*//*Label 19461*/ GIMT_Encode4(1367748), // Rule ID 22041 //
     /* 1367669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1367677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1367686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1367692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367722 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1367725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367747 */     // GIR_Coverage, 22041,
     /* 1367747 */     GIR_EraseRootFromParent_Done,
     /* 1367748 */   // Label 19461: @1367748
     /* 1367748 */   GIM_Try, /*On fail goto*//*Label 19462*/ GIMT_Encode4(1367832), // Rule ID 22044 //
     /* 1367753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1367761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1367770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367806 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1367809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367831 */     // GIR_Coverage, 22044,
     /* 1367831 */     GIR_EraseRootFromParent_Done,
     /* 1367832 */   // Label 19462: @1367832
     /* 1367832 */   GIM_Try, /*On fail goto*//*Label 19463*/ GIMT_Encode4(1367916), // Rule ID 22045 //
     /* 1367837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1367845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1367854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367890 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1367893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367915 */     // GIR_Coverage, 22045,
     /* 1367915 */     GIR_EraseRootFromParent_Done,
     /* 1367916 */   // Label 19463: @1367916
     /* 1367916 */   GIM_Try, /*On fail goto*//*Label 19464*/ GIMT_Encode4(1368000), // Rule ID 22048 //
     /* 1367921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1367929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1367938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1367977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367999 */     // GIR_Coverage, 22048,
     /* 1367999 */     GIR_EraseRootFromParent_Done,
     /* 1368000 */   // Label 19464: @1368000
     /* 1368000 */   GIM_Try, /*On fail goto*//*Label 19465*/ GIMT_Encode4(1368084), // Rule ID 22049 //
     /* 1368005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1368013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1368022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1368028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368058 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1368061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368083 */     // GIR_Coverage, 22049,
     /* 1368083 */     GIR_EraseRootFromParent_Done,
     /* 1368084 */   // Label 19465: @1368084
     /* 1368084 */   GIM_Try, /*On fail goto*//*Label 19466*/ GIMT_Encode4(1368168), // Rule ID 22052 //
     /* 1368089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1368097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1368106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368142 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1368145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368167 */     // GIR_Coverage, 22052,
     /* 1368167 */     GIR_EraseRootFromParent_Done,
     /* 1368168 */   // Label 19466: @1368168
     /* 1368168 */   GIM_Try, /*On fail goto*//*Label 19467*/ GIMT_Encode4(1368252), // Rule ID 22053 //
     /* 1368173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1368181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1368190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368226 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1368229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368251 */     // GIR_Coverage, 22053,
     /* 1368251 */     GIR_EraseRootFromParent_Done,
     /* 1368252 */   // Label 19467: @1368252
     /* 1368252 */   GIM_Try, /*On fail goto*//*Label 19468*/ GIMT_Encode4(1368336), // Rule ID 22056 //
     /* 1368257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1368265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1368274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368310 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1368313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368335 */     // GIR_Coverage, 22056,
     /* 1368335 */     GIR_EraseRootFromParent_Done,
     /* 1368336 */   // Label 19468: @1368336
     /* 1368336 */   GIM_Try, /*On fail goto*//*Label 19469*/ GIMT_Encode4(1368420), // Rule ID 22057 //
     /* 1368341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1368349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1368358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368394 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1368397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368419 */     // GIR_Coverage, 22057,
     /* 1368419 */     GIR_EraseRootFromParent_Done,
     /* 1368420 */   // Label 19469: @1368420
     /* 1368420 */   GIM_Try, /*On fail goto*//*Label 19470*/ GIMT_Encode4(1368504), // Rule ID 22060 //
     /* 1368425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1368433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1368442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368478 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1368481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368503 */     // GIR_Coverage, 22060,
     /* 1368503 */     GIR_EraseRootFromParent_Done,
     /* 1368504 */   // Label 19470: @1368504
     /* 1368504 */   GIM_Try, /*On fail goto*//*Label 19471*/ GIMT_Encode4(1368588), // Rule ID 22061 //
     /* 1368509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1368517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1368526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368562 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1368565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368587 */     // GIR_Coverage, 22061,
     /* 1368587 */     GIR_EraseRootFromParent_Done,
     /* 1368588 */   // Label 19471: @1368588
     /* 1368588 */   GIM_Try, /*On fail goto*//*Label 19472*/ GIMT_Encode4(1368672), // Rule ID 22064 //
     /* 1368593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1368610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368646 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1368649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368671 */     // GIR_Coverage, 22064,
     /* 1368671 */     GIR_EraseRootFromParent_Done,
     /* 1368672 */   // Label 19472: @1368672
     /* 1368672 */   GIM_Try, /*On fail goto*//*Label 19473*/ GIMT_Encode4(1368756), // Rule ID 22065 //
     /* 1368677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1368694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368730 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1368733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368755 */     // GIR_Coverage, 22065,
     /* 1368755 */     GIR_EraseRootFromParent_Done,
     /* 1368756 */   // Label 19473: @1368756
     /* 1368756 */   GIM_Try, /*On fail goto*//*Label 19474*/ GIMT_Encode4(1368840), // Rule ID 22068 //
     /* 1368761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1368778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368814 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1368817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368839 */     // GIR_Coverage, 22068,
     /* 1368839 */     GIR_EraseRootFromParent_Done,
     /* 1368840 */   // Label 19474: @1368840
     /* 1368840 */   GIM_Try, /*On fail goto*//*Label 19475*/ GIMT_Encode4(1368924), // Rule ID 22069 //
     /* 1368845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1368862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368898 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1368901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368923 */     // GIR_Coverage, 22069,
     /* 1368923 */     GIR_EraseRootFromParent_Done,
     /* 1368924 */   // Label 19475: @1368924
     /* 1368924 */   GIM_Try, /*On fail goto*//*Label 19476*/ GIMT_Encode4(1369008), // Rule ID 22072 //
     /* 1368929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1368946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1368985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369007 */     // GIR_Coverage, 22072,
     /* 1369007 */     GIR_EraseRootFromParent_Done,
     /* 1369008 */   // Label 19476: @1369008
     /* 1369008 */   GIM_Try, /*On fail goto*//*Label 19477*/ GIMT_Encode4(1369092), // Rule ID 22073 //
     /* 1369013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1369021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1369030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369066 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1369069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369091 */     // GIR_Coverage, 22073,
     /* 1369091 */     GIR_EraseRootFromParent_Done,
     /* 1369092 */   // Label 19477: @1369092
     /* 1369092 */   GIM_Try, /*On fail goto*//*Label 19478*/ GIMT_Encode4(1369176), // Rule ID 22076 //
     /* 1369097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1369105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1369114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369150 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1369153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369175 */     // GIR_Coverage, 22076,
     /* 1369175 */     GIR_EraseRootFromParent_Done,
     /* 1369176 */   // Label 19478: @1369176
     /* 1369176 */   GIM_Try, /*On fail goto*//*Label 19479*/ GIMT_Encode4(1369260), // Rule ID 22077 //
     /* 1369181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1369189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1369198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369234 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1369237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369259 */     // GIR_Coverage, 22077,
     /* 1369259 */     GIR_EraseRootFromParent_Done,
     /* 1369260 */   // Label 19479: @1369260
     /* 1369260 */   GIM_Try, /*On fail goto*//*Label 19480*/ GIMT_Encode4(1369344), // Rule ID 22080 //
     /* 1369265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1369273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1369282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1369321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369343 */     // GIR_Coverage, 22080,
     /* 1369343 */     GIR_EraseRootFromParent_Done,
     /* 1369344 */   // Label 19480: @1369344
     /* 1369344 */   GIM_Try, /*On fail goto*//*Label 19481*/ GIMT_Encode4(1369428), // Rule ID 22081 //
     /* 1369349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1369357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1369366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1369405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369427 */     // GIR_Coverage, 22081,
     /* 1369427 */     GIR_EraseRootFromParent_Done,
     /* 1369428 */   // Label 19481: @1369428
     /* 1369428 */   GIM_Try, /*On fail goto*//*Label 19482*/ GIMT_Encode4(1369512), // Rule ID 22084 //
     /* 1369433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1369441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1369450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369486 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1369489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369511 */     // GIR_Coverage, 22084,
     /* 1369511 */     GIR_EraseRootFromParent_Done,
     /* 1369512 */   // Label 19482: @1369512
     /* 1369512 */   GIM_Try, /*On fail goto*//*Label 19483*/ GIMT_Encode4(1369596), // Rule ID 22085 //
     /* 1369517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1369525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1369534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1369573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369595 */     // GIR_Coverage, 22085,
     /* 1369595 */     GIR_EraseRootFromParent_Done,
     /* 1369596 */   // Label 19483: @1369596
     /* 1369596 */   GIM_Try, /*On fail goto*//*Label 19484*/ GIMT_Encode4(1369680), // Rule ID 22088 //
     /* 1369601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1369609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1369618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369654 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1369657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369679 */     // GIR_Coverage, 22088,
     /* 1369679 */     GIR_EraseRootFromParent_Done,
     /* 1369680 */   // Label 19484: @1369680
     /* 1369680 */   GIM_Try, /*On fail goto*//*Label 19485*/ GIMT_Encode4(1369764), // Rule ID 22089 //
     /* 1369685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1369693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1369702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369738 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1369741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369763 */     // GIR_Coverage, 22089,
     /* 1369763 */     GIR_EraseRootFromParent_Done,
     /* 1369764 */   // Label 19485: @1369764
     /* 1369764 */   GIM_Try, /*On fail goto*//*Label 19486*/ GIMT_Encode4(1369848), // Rule ID 22092 //
     /* 1369769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1369777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1369786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369822 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1369825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369847 */     // GIR_Coverage, 22092,
     /* 1369847 */     GIR_EraseRootFromParent_Done,
     /* 1369848 */   // Label 19486: @1369848
     /* 1369848 */   GIM_Try, /*On fail goto*//*Label 19487*/ GIMT_Encode4(1369932), // Rule ID 22093 //
     /* 1369853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1369861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1369870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369906 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1369909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369931 */     // GIR_Coverage, 22093,
     /* 1369931 */     GIR_EraseRootFromParent_Done,
     /* 1369932 */   // Label 19487: @1369932
     /* 1369932 */   GIM_Try, /*On fail goto*//*Label 19488*/ GIMT_Encode4(1370016), // Rule ID 22096 //
     /* 1369937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1369945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1369954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1369993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370015 */     // GIR_Coverage, 22096,
     /* 1370015 */     GIR_EraseRootFromParent_Done,
     /* 1370016 */   // Label 19488: @1370016
     /* 1370016 */   GIM_Try, /*On fail goto*//*Label 19489*/ GIMT_Encode4(1370100), // Rule ID 22097 //
     /* 1370021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1370029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1370032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1370035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1370038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1370041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1370044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1370077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370099 */     // GIR_Coverage, 22097,
     /* 1370099 */     GIR_EraseRootFromParent_Done,
     /* 1370100 */   // Label 19489: @1370100
     /* 1370100 */   GIM_Try, /*On fail goto*//*Label 19490*/ GIMT_Encode4(1370184), // Rule ID 22100 //
     /* 1370105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1370108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1370113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1370116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1370119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1370122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1370125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370158 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1370161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1370179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370183 */     // GIR_Coverage, 22100,
     /* 1370183 */     GIR_EraseRootFromParent_Done,
     /* 1370184 */   // Label 19490: @1370184
     /* 1370184 */   GIM_Try, /*On fail goto*//*Label 19491*/ GIMT_Encode4(1370268), // Rule ID 22101 //
     /* 1370189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1370192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1370197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1370200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1370203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1370206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1370209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370242 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1370245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1370263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370267 */     // GIR_Coverage, 22101,
     /* 1370267 */     GIR_EraseRootFromParent_Done,
     /* 1370268 */   // Label 19491: @1370268
     /* 1370268 */   GIM_Try, /*On fail goto*//*Label 19492*/ GIMT_Encode4(1370352), // Rule ID 22104 //
     /* 1370273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1370281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1370290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370326 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1370329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370351 */     // GIR_Coverage, 22104,
     /* 1370351 */     GIR_EraseRootFromParent_Done,
     /* 1370352 */   // Label 19492: @1370352
     /* 1370352 */   GIM_Try, /*On fail goto*//*Label 19493*/ GIMT_Encode4(1370436), // Rule ID 22105 //
     /* 1370357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1370365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1370374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370410 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1370413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370435 */     // GIR_Coverage, 22105,
     /* 1370435 */     GIR_EraseRootFromParent_Done,
     /* 1370436 */   // Label 19493: @1370436
     /* 1370436 */   GIM_Try, /*On fail goto*//*Label 19494*/ GIMT_Encode4(1370520), // Rule ID 22108 //
     /* 1370441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1370449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1370458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1370464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370494 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1370497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370519 */     // GIR_Coverage, 22108,
     /* 1370519 */     GIR_EraseRootFromParent_Done,
     /* 1370520 */   // Label 19494: @1370520
     /* 1370520 */   GIM_Try, /*On fail goto*//*Label 19495*/ GIMT_Encode4(1370604), // Rule ID 22109 //
     /* 1370525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1370533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1370542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1370548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370578 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1370581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370603 */     // GIR_Coverage, 22109,
     /* 1370603 */     GIR_EraseRootFromParent_Done,
     /* 1370604 */   // Label 19495: @1370604
     /* 1370604 */   GIM_Try, /*On fail goto*//*Label 19496*/ GIMT_Encode4(1370688), // Rule ID 22112 //
     /* 1370609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1370617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1370626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1370632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370662 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1370665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370687 */     // GIR_Coverage, 22112,
     /* 1370687 */     GIR_EraseRootFromParent_Done,
     /* 1370688 */   // Label 19496: @1370688
     /* 1370688 */   GIM_Try, /*On fail goto*//*Label 19497*/ GIMT_Encode4(1370772), // Rule ID 22113 //
     /* 1370693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1370701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1370710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1370716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370746 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1370749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370771 */     // GIR_Coverage, 22113,
     /* 1370771 */     GIR_EraseRootFromParent_Done,
     /* 1370772 */   // Label 19497: @1370772
     /* 1370772 */   GIM_Try, /*On fail goto*//*Label 19498*/ GIMT_Encode4(1370856), // Rule ID 22116 //
     /* 1370777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1370785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1370794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370830 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1370833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370855 */     // GIR_Coverage, 22116,
     /* 1370855 */     GIR_EraseRootFromParent_Done,
     /* 1370856 */   // Label 19498: @1370856
     /* 1370856 */   GIM_Try, /*On fail goto*//*Label 19499*/ GIMT_Encode4(1370940), // Rule ID 22117 //
     /* 1370861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1370869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1370878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370914 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1370917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370939 */     // GIR_Coverage, 22117,
     /* 1370939 */     GIR_EraseRootFromParent_Done,
     /* 1370940 */   // Label 19499: @1370940
     /* 1370940 */   GIM_Try, /*On fail goto*//*Label 19500*/ GIMT_Encode4(1371024), // Rule ID 22120 //
     /* 1370945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1370953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1370962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370998 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1371001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371023 */     // GIR_Coverage, 22120,
     /* 1371023 */     GIR_EraseRootFromParent_Done,
     /* 1371024 */   // Label 19500: @1371024
     /* 1371024 */   GIM_Try, /*On fail goto*//*Label 19501*/ GIMT_Encode4(1371108), // Rule ID 22121 //
     /* 1371029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1371037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1371046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371082 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1371085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371107 */     // GIR_Coverage, 22121,
     /* 1371107 */     GIR_EraseRootFromParent_Done,
     /* 1371108 */   // Label 19501: @1371108
     /* 1371108 */   GIM_Try, /*On fail goto*//*Label 19502*/ GIMT_Encode4(1371192), // Rule ID 22124 //
     /* 1371113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1371121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1371130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371166 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1371169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371191 */     // GIR_Coverage, 22124,
     /* 1371191 */     GIR_EraseRootFromParent_Done,
     /* 1371192 */   // Label 19502: @1371192
     /* 1371192 */   GIM_Try, /*On fail goto*//*Label 19503*/ GIMT_Encode4(1371276), // Rule ID 22125 //
     /* 1371197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1371205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1371214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1371253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371275 */     // GIR_Coverage, 22125,
     /* 1371275 */     GIR_EraseRootFromParent_Done,
     /* 1371276 */   // Label 19503: @1371276
     /* 1371276 */   GIM_Try, /*On fail goto*//*Label 19504*/ GIMT_Encode4(1371360), // Rule ID 22128 //
     /* 1371281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1371289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1371298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1371337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371359 */     // GIR_Coverage, 22128,
     /* 1371359 */     GIR_EraseRootFromParent_Done,
     /* 1371360 */   // Label 19504: @1371360
     /* 1371360 */   GIM_Try, /*On fail goto*//*Label 19505*/ GIMT_Encode4(1371444), // Rule ID 22129 //
     /* 1371365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1371373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1371382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1371421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371443 */     // GIR_Coverage, 22129,
     /* 1371443 */     GIR_EraseRootFromParent_Done,
     /* 1371444 */   // Label 19505: @1371444
     /* 1371444 */   GIM_Try, /*On fail goto*//*Label 19506*/ GIMT_Encode4(1371528), // Rule ID 22132 //
     /* 1371449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1371457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1371466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1371505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371527 */     // GIR_Coverage, 22132,
     /* 1371527 */     GIR_EraseRootFromParent_Done,
     /* 1371528 */   // Label 19506: @1371528
     /* 1371528 */   GIM_Try, /*On fail goto*//*Label 19507*/ GIMT_Encode4(1371612), // Rule ID 22133 //
     /* 1371533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1371541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1371550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371586 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1371589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371611 */     // GIR_Coverage, 22133,
     /* 1371611 */     GIR_EraseRootFromParent_Done,
     /* 1371612 */   // Label 19507: @1371612
     /* 1371612 */   GIM_Try, /*On fail goto*//*Label 19508*/ GIMT_Encode4(1371696), // Rule ID 22136 //
     /* 1371617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1371625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1371634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1371673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371695 */     // GIR_Coverage, 22136,
     /* 1371695 */     GIR_EraseRootFromParent_Done,
     /* 1371696 */   // Label 19508: @1371696
     /* 1371696 */   GIM_Try, /*On fail goto*//*Label 19509*/ GIMT_Encode4(1371780), // Rule ID 22137 //
     /* 1371701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1371709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1371718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371754 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1371757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371779 */     // GIR_Coverage, 22137,
     /* 1371779 */     GIR_EraseRootFromParent_Done,
     /* 1371780 */   // Label 19509: @1371780
     /* 1371780 */   GIM_Try, /*On fail goto*//*Label 19510*/ GIMT_Encode4(1371864), // Rule ID 22140 //
     /* 1371785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1371788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1371793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1371802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1371808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371838 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1371841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371863 */     // GIR_Coverage, 22140,
     /* 1371863 */     GIR_EraseRootFromParent_Done,
     /* 1371864 */   // Label 19510: @1371864
     /* 1371864 */   GIM_Try, /*On fail goto*//*Label 19511*/ GIMT_Encode4(1371948), // Rule ID 22141 //
     /* 1371869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1371872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1371877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1371886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1371892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371922 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1371925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371947 */     // GIR_Coverage, 22141,
     /* 1371947 */     GIR_EraseRootFromParent_Done,
     /* 1371948 */   // Label 19511: @1371948
     /* 1371948 */   GIM_Try, /*On fail goto*//*Label 19512*/ GIMT_Encode4(1372032), // Rule ID 22144 //
     /* 1371953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1371956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1371961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1371970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372006 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1372009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372031 */     // GIR_Coverage, 22144,
     /* 1372031 */     GIR_EraseRootFromParent_Done,
     /* 1372032 */   // Label 19512: @1372032
     /* 1372032 */   GIM_Try, /*On fail goto*//*Label 19513*/ GIMT_Encode4(1372116), // Rule ID 22145 //
     /* 1372037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1372040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1372045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1372054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1372075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372090 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1372093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372115 */     // GIR_Coverage, 22145,
     /* 1372115 */     GIR_EraseRootFromParent_Done,
     /* 1372116 */   // Label 19513: @1372116
     /* 1372116 */   GIM_Try, /*On fail goto*//*Label 19514*/ GIMT_Encode4(1372200), // Rule ID 22148 //
     /* 1372121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1372124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1372129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1372138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1372177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372199 */     // GIR_Coverage, 22148,
     /* 1372199 */     GIR_EraseRootFromParent_Done,
     /* 1372200 */   // Label 19514: @1372200
     /* 1372200 */   GIM_Try, /*On fail goto*//*Label 19515*/ GIMT_Encode4(1372284), // Rule ID 22149 //
     /* 1372205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1372208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1372213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1372222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372258 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1372261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372283 */     // GIR_Coverage, 22149,
     /* 1372283 */     GIR_EraseRootFromParent_Done,
     /* 1372284 */   // Label 19515: @1372284
     /* 1372284 */   GIM_Try, /*On fail goto*//*Label 19516*/ GIMT_Encode4(1372368), // Rule ID 22152 //
     /* 1372289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1372306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372342 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1372345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372367 */     // GIR_Coverage, 22152,
     /* 1372367 */     GIR_EraseRootFromParent_Done,
     /* 1372368 */   // Label 19516: @1372368
     /* 1372368 */   GIM_Try, /*On fail goto*//*Label 19517*/ GIMT_Encode4(1372452), // Rule ID 22153 //
     /* 1372373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1372390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1372429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372451 */     // GIR_Coverage, 22153,
     /* 1372451 */     GIR_EraseRootFromParent_Done,
     /* 1372452 */   // Label 19517: @1372452
     /* 1372452 */   GIM_Try, /*On fail goto*//*Label 19518*/ GIMT_Encode4(1372536), // Rule ID 22156 //
     /* 1372457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1372474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372510 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1372513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372535 */     // GIR_Coverage, 22156,
     /* 1372535 */     GIR_EraseRootFromParent_Done,
     /* 1372536 */   // Label 19518: @1372536
     /* 1372536 */   GIM_Try, /*On fail goto*//*Label 19519*/ GIMT_Encode4(1372620), // Rule ID 22157 //
     /* 1372541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1372558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372594 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1372597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372619 */     // GIR_Coverage, 22157,
     /* 1372619 */     GIR_EraseRootFromParent_Done,
     /* 1372620 */   // Label 19519: @1372620
     /* 1372620 */   GIM_Try, /*On fail goto*//*Label 19520*/ GIMT_Encode4(1372704), // Rule ID 22160 //
     /* 1372625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1372642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372678 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1372681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372703 */     // GIR_Coverage, 22160,
     /* 1372703 */     GIR_EraseRootFromParent_Done,
     /* 1372704 */   // Label 19520: @1372704
     /* 1372704 */   GIM_Try, /*On fail goto*//*Label 19521*/ GIMT_Encode4(1372788), // Rule ID 22161 //
     /* 1372709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1372726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372762 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1372765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372787 */     // GIR_Coverage, 22161,
     /* 1372787 */     GIR_EraseRootFromParent_Done,
     /* 1372788 */   // Label 19521: @1372788
     /* 1372788 */   GIM_Try, /*On fail goto*//*Label 19522*/ GIMT_Encode4(1372872), // Rule ID 22164 //
     /* 1372793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1372810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372846 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1372849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372871 */     // GIR_Coverage, 22164,
     /* 1372871 */     GIR_EraseRootFromParent_Done,
     /* 1372872 */   // Label 19522: @1372872
     /* 1372872 */   GIM_Try, /*On fail goto*//*Label 19523*/ GIMT_Encode4(1372956), // Rule ID 22165 //
     /* 1372877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1372894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372930 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1372933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372955 */     // GIR_Coverage, 22165,
     /* 1372955 */     GIR_EraseRootFromParent_Done,
     /* 1372956 */   // Label 19523: @1372956
     /* 1372956 */   GIM_Try, /*On fail goto*//*Label 19524*/ GIMT_Encode4(1373040), // Rule ID 22168 //
     /* 1372961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1372978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373014 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1373017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373039 */     // GIR_Coverage, 22168,
     /* 1373039 */     GIR_EraseRootFromParent_Done,
     /* 1373040 */   // Label 19524: @1373040
     /* 1373040 */   GIM_Try, /*On fail goto*//*Label 19525*/ GIMT_Encode4(1373124), // Rule ID 22169 //
     /* 1373045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1373053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1373062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373098 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1373101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373123 */     // GIR_Coverage, 22169,
     /* 1373123 */     GIR_EraseRootFromParent_Done,
     /* 1373124 */   // Label 19525: @1373124
     /* 1373124 */   GIM_Try, /*On fail goto*//*Label 19526*/ GIMT_Encode4(1373208), // Rule ID 22172 //
     /* 1373129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1373137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1373146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373182 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1373185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373207 */     // GIR_Coverage, 22172,
     /* 1373207 */     GIR_EraseRootFromParent_Done,
     /* 1373208 */   // Label 19526: @1373208
     /* 1373208 */   GIM_Try, /*On fail goto*//*Label 19527*/ GIMT_Encode4(1373292), // Rule ID 22173 //
     /* 1373213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1373221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1373230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373266 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1373269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373291 */     // GIR_Coverage, 22173,
     /* 1373291 */     GIR_EraseRootFromParent_Done,
     /* 1373292 */   // Label 19527: @1373292
     /* 1373292 */   GIM_Try, /*On fail goto*//*Label 19528*/ GIMT_Encode4(1373376), // Rule ID 22176 //
     /* 1373297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1373305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1373314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373350 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1373353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373375 */     // GIR_Coverage, 22176,
     /* 1373375 */     GIR_EraseRootFromParent_Done,
     /* 1373376 */   // Label 19528: @1373376
     /* 1373376 */   GIM_Try, /*On fail goto*//*Label 19529*/ GIMT_Encode4(1373460), // Rule ID 22177 //
     /* 1373381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1373389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1373398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373434 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1373437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373459 */     // GIR_Coverage, 22177,
     /* 1373459 */     GIR_EraseRootFromParent_Done,
     /* 1373460 */   // Label 19529: @1373460
     /* 1373460 */   GIM_Try, /*On fail goto*//*Label 19530*/ GIMT_Encode4(1373544), // Rule ID 22180 //
     /* 1373465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1373473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1373482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1373521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373543 */     // GIR_Coverage, 22180,
     /* 1373543 */     GIR_EraseRootFromParent_Done,
     /* 1373544 */   // Label 19530: @1373544
     /* 1373544 */   GIM_Try, /*On fail goto*//*Label 19531*/ GIMT_Encode4(1373628), // Rule ID 22181 //
     /* 1373549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1373557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1373566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1373605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373627 */     // GIR_Coverage, 22181,
     /* 1373627 */     GIR_EraseRootFromParent_Done,
     /* 1373628 */   // Label 19531: @1373628
     /* 1373628 */   GIM_Try, /*On fail goto*//*Label 19532*/ GIMT_Encode4(1373712), // Rule ID 22184 //
     /* 1373633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1373641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1373650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373686 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1373689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373711 */     // GIR_Coverage, 22184,
     /* 1373711 */     GIR_EraseRootFromParent_Done,
     /* 1373712 */   // Label 19532: @1373712
     /* 1373712 */   GIM_Try, /*On fail goto*//*Label 19533*/ GIMT_Encode4(1373796), // Rule ID 22185 //
     /* 1373717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1373725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1373734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1373773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373795 */     // GIR_Coverage, 22185,
     /* 1373795 */     GIR_EraseRootFromParent_Done,
     /* 1373796 */   // Label 19533: @1373796
     /* 1373796 */   GIM_Try, /*On fail goto*//*Label 19534*/ GIMT_Encode4(1373880), // Rule ID 22188 //
     /* 1373801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1373804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1373809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1373818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1373821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373854 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1373857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373879 */     // GIR_Coverage, 22188,
     /* 1373879 */     GIR_EraseRootFromParent_Done,
     /* 1373880 */   // Label 19534: @1373880
     /* 1373880 */   GIM_Try, /*On fail goto*//*Label 19535*/ GIMT_Encode4(1373964), // Rule ID 22189 //
     /* 1373885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1373888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1373893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1373902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1373905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373938 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1373941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373963 */     // GIR_Coverage, 22189,
     /* 1373963 */     GIR_EraseRootFromParent_Done,
     /* 1373964 */   // Label 19535: @1373964
     /* 1373964 */   GIM_Try, /*On fail goto*//*Label 19536*/ GIMT_Encode4(1374048), // Rule ID 22192 //
     /* 1373969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1373977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1373986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1373992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374022 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1374025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374047 */     // GIR_Coverage, 22192,
     /* 1374047 */     GIR_EraseRootFromParent_Done,
     /* 1374048 */   // Label 19536: @1374048
     /* 1374048 */   GIM_Try, /*On fail goto*//*Label 19537*/ GIMT_Encode4(1374132), // Rule ID 22193 //
     /* 1374053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1374061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1374070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374106 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1374109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374131 */     // GIR_Coverage, 22193,
     /* 1374131 */     GIR_EraseRootFromParent_Done,
     /* 1374132 */   // Label 19537: @1374132
     /* 1374132 */   GIM_Try, /*On fail goto*//*Label 19538*/ GIMT_Encode4(1374216), // Rule ID 22196 //
     /* 1374137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1374145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374190 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1374193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374215 */     // GIR_Coverage, 22196,
     /* 1374215 */     GIR_EraseRootFromParent_Done,
     /* 1374216 */   // Label 19538: @1374216
     /* 1374216 */   GIM_Try, /*On fail goto*//*Label 19539*/ GIMT_Encode4(1374300), // Rule ID 22197 //
     /* 1374221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1374229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374274 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1374277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374299 */     // GIR_Coverage, 22197,
     /* 1374299 */     GIR_EraseRootFromParent_Done,
     /* 1374300 */   // Label 19539: @1374300
     /* 1374300 */   GIM_Try, /*On fail goto*//*Label 19540*/ GIMT_Encode4(1374384), // Rule ID 22200 //
     /* 1374305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1374313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1374322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1374328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1374361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374383 */     // GIR_Coverage, 22200,
     /* 1374383 */     GIR_EraseRootFromParent_Done,
     /* 1374384 */   // Label 19540: @1374384
     /* 1374384 */   GIM_Try, /*On fail goto*//*Label 19541*/ GIMT_Encode4(1374468), // Rule ID 22201 //
     /* 1374389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1374397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1374406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1374412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1374445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374467 */     // GIR_Coverage, 22201,
     /* 1374467 */     GIR_EraseRootFromParent_Done,
     /* 1374468 */   // Label 19541: @1374468
     /* 1374468 */   GIM_Try, /*On fail goto*//*Label 19542*/ GIMT_Encode4(1374552), // Rule ID 22204 //
     /* 1374473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1374481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1374490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374526 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1374529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374551 */     // GIR_Coverage, 22204,
     /* 1374551 */     GIR_EraseRootFromParent_Done,
     /* 1374552 */   // Label 19542: @1374552
     /* 1374552 */   GIM_Try, /*On fail goto*//*Label 19543*/ GIMT_Encode4(1374636), // Rule ID 22205 //
     /* 1374557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1374565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1374574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374610 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1374613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374635 */     // GIR_Coverage, 22205,
     /* 1374635 */     GIR_EraseRootFromParent_Done,
     /* 1374636 */   // Label 19543: @1374636
     /* 1374636 */   GIM_Try, /*On fail goto*//*Label 19544*/ GIMT_Encode4(1374720), // Rule ID 22208 //
     /* 1374641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1374649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1374658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1374697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374719 */     // GIR_Coverage, 22208,
     /* 1374719 */     GIR_EraseRootFromParent_Done,
     /* 1374720 */   // Label 19544: @1374720
     /* 1374720 */   GIM_Try, /*On fail goto*//*Label 19545*/ GIMT_Encode4(1374804), // Rule ID 22209 //
     /* 1374725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1374733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1374742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374778 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1374781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374803 */     // GIR_Coverage, 22209,
     /* 1374803 */     GIR_EraseRootFromParent_Done,
     /* 1374804 */   // Label 19545: @1374804
     /* 1374804 */   GIM_Try, /*On fail goto*//*Label 19546*/ GIMT_Encode4(1374888), // Rule ID 22212 //
     /* 1374809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1374817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1374826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374862 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1374865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374887 */     // GIR_Coverage, 22212,
     /* 1374887 */     GIR_EraseRootFromParent_Done,
     /* 1374888 */   // Label 19546: @1374888
     /* 1374888 */   GIM_Try, /*On fail goto*//*Label 19547*/ GIMT_Encode4(1374972), // Rule ID 22213 //
     /* 1374893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1374901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1374910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1374949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374971 */     // GIR_Coverage, 22213,
     /* 1374971 */     GIR_EraseRootFromParent_Done,
     /* 1374972 */   // Label 19547: @1374972
     /* 1374972 */   GIM_Try, /*On fail goto*//*Label 19548*/ GIMT_Encode4(1375056), // Rule ID 22216 //
     /* 1374977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1374985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1374988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1374991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1374994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1374997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1375033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375055 */     // GIR_Coverage, 22216,
     /* 1375055 */     GIR_EraseRootFromParent_Done,
     /* 1375056 */   // Label 19548: @1375056
     /* 1375056 */   GIM_Try, /*On fail goto*//*Label 19549*/ GIMT_Encode4(1375140), // Rule ID 22217 //
     /* 1375061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1375069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1375078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1375117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375139 */     // GIR_Coverage, 22217,
     /* 1375139 */     GIR_EraseRootFromParent_Done,
     /* 1375140 */   // Label 19549: @1375140
     /* 1375140 */   GIM_Try, /*On fail goto*//*Label 19550*/ GIMT_Encode4(1375224), // Rule ID 22220 //
     /* 1375145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1375153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375198 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1375201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375223 */     // GIR_Coverage, 22220,
     /* 1375223 */     GIR_EraseRootFromParent_Done,
     /* 1375224 */   // Label 19550: @1375224
     /* 1375224 */   GIM_Try, /*On fail goto*//*Label 19551*/ GIMT_Encode4(1375308), // Rule ID 22221 //
     /* 1375229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1375237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375282 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1375285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375307 */     // GIR_Coverage, 22221,
     /* 1375307 */     GIR_EraseRootFromParent_Done,
     /* 1375308 */   // Label 19551: @1375308
     /* 1375308 */   GIM_Try, /*On fail goto*//*Label 19552*/ GIMT_Encode4(1375392), // Rule ID 22224 //
     /* 1375313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1375321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1375330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375366 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1375369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375391 */     // GIR_Coverage, 22224,
     /* 1375391 */     GIR_EraseRootFromParent_Done,
     /* 1375392 */   // Label 19552: @1375392
     /* 1375392 */   GIM_Try, /*On fail goto*//*Label 19553*/ GIMT_Encode4(1375476), // Rule ID 22225 //
     /* 1375397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1375405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1375414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375450 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1375453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375475 */     // GIR_Coverage, 22225,
     /* 1375475 */     GIR_EraseRootFromParent_Done,
     /* 1375476 */   // Label 19553: @1375476
     /* 1375476 */   GIM_Try, /*On fail goto*//*Label 19554*/ GIMT_Encode4(1375560), // Rule ID 22228 //
     /* 1375481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1375489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1375498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1375504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375534 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1375537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375559 */     // GIR_Coverage, 22228,
     /* 1375559 */     GIR_EraseRootFromParent_Done,
     /* 1375560 */   // Label 19554: @1375560
     /* 1375560 */   GIM_Try, /*On fail goto*//*Label 19555*/ GIMT_Encode4(1375644), // Rule ID 22229 //
     /* 1375565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1375573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1375582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1375588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375618 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1375621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375643 */     // GIR_Coverage, 22229,
     /* 1375643 */     GIR_EraseRootFromParent_Done,
     /* 1375644 */   // Label 19555: @1375644
     /* 1375644 */   GIM_Try, /*On fail goto*//*Label 19556*/ GIMT_Encode4(1375728), // Rule ID 22232 //
     /* 1375649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1375657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1375666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1375705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375727 */     // GIR_Coverage, 22232,
     /* 1375727 */     GIR_EraseRootFromParent_Done,
     /* 1375728 */   // Label 19556: @1375728
     /* 1375728 */   GIM_Try, /*On fail goto*//*Label 19557*/ GIMT_Encode4(1375812), // Rule ID 22233 //
     /* 1375733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1375741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1375750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1375789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375811 */     // GIR_Coverage, 22233,
     /* 1375811 */     GIR_EraseRootFromParent_Done,
     /* 1375812 */   // Label 19557: @1375812
     /* 1375812 */   GIM_Try, /*On fail goto*//*Label 19558*/ GIMT_Encode4(1375896), // Rule ID 22236 //
     /* 1375817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1375825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1375834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375870 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1375873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375895 */     // GIR_Coverage, 22236,
     /* 1375895 */     GIR_EraseRootFromParent_Done,
     /* 1375896 */   // Label 19558: @1375896
     /* 1375896 */   GIM_Try, /*On fail goto*//*Label 19559*/ GIMT_Encode4(1375980), // Rule ID 22237 //
     /* 1375901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1375909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1375918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375954 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1375957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375979 */     // GIR_Coverage, 22237,
     /* 1375979 */     GIR_EraseRootFromParent_Done,
     /* 1375980 */   // Label 19559: @1375980
     /* 1375980 */   GIM_Try, /*On fail goto*//*Label 19560*/ GIMT_Encode4(1376064), // Rule ID 22240 //
     /* 1375985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1375996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1375999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1376002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376038 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1376041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376063 */     // GIR_Coverage, 22240,
     /* 1376063 */     GIR_EraseRootFromParent_Done,
     /* 1376064 */   // Label 19560: @1376064
     /* 1376064 */   GIM_Try, /*On fail goto*//*Label 19561*/ GIMT_Encode4(1376148), // Rule ID 22241 //
     /* 1376069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1376086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376122 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1376125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376147 */     // GIR_Coverage, 22241,
     /* 1376147 */     GIR_EraseRootFromParent_Done,
     /* 1376148 */   // Label 19561: @1376148
     /* 1376148 */   GIM_Try, /*On fail goto*//*Label 19562*/ GIMT_Encode4(1376232), // Rule ID 22244 //
     /* 1376153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376206 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1376209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376231 */     // GIR_Coverage, 22244,
     /* 1376231 */     GIR_EraseRootFromParent_Done,
     /* 1376232 */   // Label 19562: @1376232
     /* 1376232 */   GIM_Try, /*On fail goto*//*Label 19563*/ GIMT_Encode4(1376316), // Rule ID 22245 //
     /* 1376237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376290 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1376293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376315 */     // GIR_Coverage, 22245,
     /* 1376315 */     GIR_EraseRootFromParent_Done,
     /* 1376316 */   // Label 19563: @1376316
     /* 1376316 */   GIM_Try, /*On fail goto*//*Label 19564*/ GIMT_Encode4(1376400), // Rule ID 22248 //
     /* 1376321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1376338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376374 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1376377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376399 */     // GIR_Coverage, 22248,
     /* 1376399 */     GIR_EraseRootFromParent_Done,
     /* 1376400 */   // Label 19564: @1376400
     /* 1376400 */   GIM_Try, /*On fail goto*//*Label 19565*/ GIMT_Encode4(1376484), // Rule ID 22249 //
     /* 1376405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1376422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376458 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1376461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376483 */     // GIR_Coverage, 22249,
     /* 1376483 */     GIR_EraseRootFromParent_Done,
     /* 1376484 */   // Label 19565: @1376484
     /* 1376484 */   GIM_Try, /*On fail goto*//*Label 19566*/ GIMT_Encode4(1376568), // Rule ID 22252 //
     /* 1376489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1376506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376542 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1376545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376567 */     // GIR_Coverage, 22252,
     /* 1376567 */     GIR_EraseRootFromParent_Done,
     /* 1376568 */   // Label 19566: @1376568
     /* 1376568 */   GIM_Try, /*On fail goto*//*Label 19567*/ GIMT_Encode4(1376652), // Rule ID 22253 //
     /* 1376573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1376590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1376629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376651 */     // GIR_Coverage, 22253,
     /* 1376651 */     GIR_EraseRootFromParent_Done,
     /* 1376652 */   // Label 19567: @1376652
     /* 1376652 */   GIM_Try, /*On fail goto*//*Label 19568*/ GIMT_Encode4(1376736), // Rule ID 22256 //
     /* 1376657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1376674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1376713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376735 */     // GIR_Coverage, 22256,
     /* 1376735 */     GIR_EraseRootFromParent_Done,
     /* 1376736 */   // Label 19568: @1376736
     /* 1376736 */   GIM_Try, /*On fail goto*//*Label 19569*/ GIMT_Encode4(1376820), // Rule ID 22257 //
     /* 1376741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1376758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376794 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1376797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376819 */     // GIR_Coverage, 22257,
     /* 1376819 */     GIR_EraseRootFromParent_Done,
     /* 1376820 */   // Label 19569: @1376820
     /* 1376820 */   GIM_Try, /*On fail goto*//*Label 19570*/ GIMT_Encode4(1376904), // Rule ID 22260 //
     /* 1376825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1376836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1376839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1376842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1376845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376878 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1376881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376903 */     // GIR_Coverage, 22260,
     /* 1376903 */     GIR_EraseRootFromParent_Done,
     /* 1376904 */   // Label 19570: @1376904
     /* 1376904 */   GIM_Try, /*On fail goto*//*Label 19571*/ GIMT_Encode4(1376988), // Rule ID 22261 //
     /* 1376909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1376920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1376923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1376926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1376929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376962 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1376965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376987 */     // GIR_Coverage, 22261,
     /* 1376987 */     GIR_EraseRootFromParent_Done,
     /* 1376988 */   // Label 19571: @1376988
     /* 1376988 */   GIM_Try, /*On fail goto*//*Label 19572*/ GIMT_Encode4(1377072), // Rule ID 22264 //
     /* 1376993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1377001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1377010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1377016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377046 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1377049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377071 */     // GIR_Coverage, 22264,
     /* 1377071 */     GIR_EraseRootFromParent_Done,
     /* 1377072 */   // Label 19572: @1377072
     /* 1377072 */   GIM_Try, /*On fail goto*//*Label 19573*/ GIMT_Encode4(1377156), // Rule ID 22265 //
     /* 1377077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1377085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1377094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1377100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377130 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1377133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377155 */     // GIR_Coverage, 22265,
     /* 1377155 */     GIR_EraseRootFromParent_Done,
     /* 1377156 */   // Label 19573: @1377156
     /* 1377156 */   GIM_Try, /*On fail goto*//*Label 19574*/ GIMT_Encode4(1377240), // Rule ID 22268 //
     /* 1377161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1377169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377214 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1377217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377239 */     // GIR_Coverage, 22268,
     /* 1377239 */     GIR_EraseRootFromParent_Done,
     /* 1377240 */   // Label 19574: @1377240
     /* 1377240 */   GIM_Try, /*On fail goto*//*Label 19575*/ GIMT_Encode4(1377324), // Rule ID 22269 //
     /* 1377245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1377253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377298 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1377301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377323 */     // GIR_Coverage, 22269,
     /* 1377323 */     GIR_EraseRootFromParent_Done,
     /* 1377324 */   // Label 19575: @1377324
     /* 1377324 */   GIM_Try, /*On fail goto*//*Label 19576*/ GIMT_Encode4(1377408), // Rule ID 22272 //
     /* 1377329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1377337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1377346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377382 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1377385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377407 */     // GIR_Coverage, 22272,
     /* 1377407 */     GIR_EraseRootFromParent_Done,
     /* 1377408 */   // Label 19576: @1377408
     /* 1377408 */   GIM_Try, /*On fail goto*//*Label 19577*/ GIMT_Encode4(1377492), // Rule ID 22273 //
     /* 1377413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1377421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1377430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377466 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1377469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377491 */     // GIR_Coverage, 22273,
     /* 1377491 */     GIR_EraseRootFromParent_Done,
     /* 1377492 */   // Label 19577: @1377492
     /* 1377492 */   GIM_Try, /*On fail goto*//*Label 19578*/ GIMT_Encode4(1377576), // Rule ID 22276 //
     /* 1377497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1377500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1377505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1377514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1377517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377550 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1377553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377575 */     // GIR_Coverage, 22276,
     /* 1377575 */     GIR_EraseRootFromParent_Done,
     /* 1377576 */   // Label 19578: @1377576
     /* 1377576 */   GIM_Try, /*On fail goto*//*Label 19579*/ GIMT_Encode4(1377660), // Rule ID 22277 //
     /* 1377581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1377584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1377589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1377598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1377601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377634 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1377637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377659 */     // GIR_Coverage, 22277,
     /* 1377659 */     GIR_EraseRootFromParent_Done,
     /* 1377660 */   // Label 19579: @1377660
     /* 1377660 */   GIM_Try, /*On fail goto*//*Label 19580*/ GIMT_Encode4(1377744), // Rule ID 22280 //
     /* 1377665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1377673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1377682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1377688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1377703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1377721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377743 */     // GIR_Coverage, 22280,
     /* 1377743 */     GIR_EraseRootFromParent_Done,
     /* 1377744 */   // Label 19580: @1377744
     /* 1377744 */   GIM_Try, /*On fail goto*//*Label 19581*/ GIMT_Encode4(1377828), // Rule ID 22281 //
     /* 1377749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1377757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1377766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1377772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1377787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1377805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377827 */     // GIR_Coverage, 22281,
     /* 1377827 */     GIR_EraseRootFromParent_Done,
     /* 1377828 */   // Label 19581: @1377828
     /* 1377828 */   GIM_Try, /*On fail goto*//*Label 19582*/ GIMT_Encode4(1377912), // Rule ID 22284 //
     /* 1377833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1377841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1377850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1377856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1377871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377886 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1377889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377911 */     // GIR_Coverage, 22284,
     /* 1377911 */     GIR_EraseRootFromParent_Done,
     /* 1377912 */   // Label 19582: @1377912
     /* 1377912 */   GIM_Try, /*On fail goto*//*Label 19583*/ GIMT_Encode4(1377996), // Rule ID 22285 //
     /* 1377917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1377925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1377934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1377940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1377955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377970 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1377973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377995 */     // GIR_Coverage, 22285,
     /* 1377995 */     GIR_EraseRootFromParent_Done,
     /* 1377996 */   // Label 19583: @1377996
     /* 1377996 */   GIM_Try, /*On fail goto*//*Label 19584*/ GIMT_Encode4(1378080), // Rule ID 22288 //
     /* 1378001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1378009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1378018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1378024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378054 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1378057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378079 */     // GIR_Coverage, 22288,
     /* 1378079 */     GIR_EraseRootFromParent_Done,
     /* 1378080 */   // Label 19584: @1378080
     /* 1378080 */   GIM_Try, /*On fail goto*//*Label 19585*/ GIMT_Encode4(1378164), // Rule ID 22289 //
     /* 1378085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1378093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1378102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1378108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378138 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1378141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378163 */     // GIR_Coverage, 22289,
     /* 1378163 */     GIR_EraseRootFromParent_Done,
     /* 1378164 */   // Label 19585: @1378164
     /* 1378164 */   GIM_Try, /*On fail goto*//*Label 19586*/ GIMT_Encode4(1378248), // Rule ID 22292 //
     /* 1378169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1378177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378222 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1378225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378247 */     // GIR_Coverage, 22292,
     /* 1378247 */     GIR_EraseRootFromParent_Done,
     /* 1378248 */   // Label 19586: @1378248
     /* 1378248 */   GIM_Try, /*On fail goto*//*Label 19587*/ GIMT_Encode4(1378332), // Rule ID 22293 //
     /* 1378253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1378261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378306 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1378309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378331 */     // GIR_Coverage, 22293,
     /* 1378331 */     GIR_EraseRootFromParent_Done,
     /* 1378332 */   // Label 19587: @1378332
     /* 1378332 */   GIM_Try, /*On fail goto*//*Label 19588*/ GIMT_Encode4(1378416), // Rule ID 22296 //
     /* 1378337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1378345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1378354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1378393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378415 */     // GIR_Coverage, 22296,
     /* 1378415 */     GIR_EraseRootFromParent_Done,
     /* 1378416 */   // Label 19588: @1378416
     /* 1378416 */   GIM_Try, /*On fail goto*//*Label 19589*/ GIMT_Encode4(1378500), // Rule ID 22297 //
     /* 1378421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1378429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1378438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378474 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1378477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378499 */     // GIR_Coverage, 22297,
     /* 1378499 */     GIR_EraseRootFromParent_Done,
     /* 1378500 */   // Label 19589: @1378500
     /* 1378500 */   GIM_Try, /*On fail goto*//*Label 19590*/ GIMT_Encode4(1378584), // Rule ID 22300 //
     /* 1378505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1378513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1378522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1378561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378583 */     // GIR_Coverage, 22300,
     /* 1378583 */     GIR_EraseRootFromParent_Done,
     /* 1378584 */   // Label 19590: @1378584
     /* 1378584 */   GIM_Try, /*On fail goto*//*Label 19591*/ GIMT_Encode4(1378668), // Rule ID 22301 //
     /* 1378589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1378597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1378606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378642 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1378645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378667 */     // GIR_Coverage, 22301,
     /* 1378667 */     GIR_EraseRootFromParent_Done,
     /* 1378668 */   // Label 19591: @1378668
     /* 1378668 */   GIM_Try, /*On fail goto*//*Label 19592*/ GIMT_Encode4(1378752), // Rule ID 22304 //
     /* 1378673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1378681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1378690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1378696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1378729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378751 */     // GIR_Coverage, 22304,
     /* 1378751 */     GIR_EraseRootFromParent_Done,
     /* 1378752 */   // Label 19592: @1378752
     /* 1378752 */   GIM_Try, /*On fail goto*//*Label 19593*/ GIMT_Encode4(1378836), // Rule ID 22305 //
     /* 1378757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1378765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1378774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1378780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1378813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378835 */     // GIR_Coverage, 22305,
     /* 1378835 */     GIR_EraseRootFromParent_Done,
     /* 1378836 */   // Label 19593: @1378836
     /* 1378836 */   GIM_Try, /*On fail goto*//*Label 19594*/ GIMT_Encode4(1378920), // Rule ID 22308 //
     /* 1378841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1378849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1378858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378894 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1378897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378919 */     // GIR_Coverage, 22308,
     /* 1378919 */     GIR_EraseRootFromParent_Done,
     /* 1378920 */   // Label 19594: @1378920
     /* 1378920 */   GIM_Try, /*On fail goto*//*Label 19595*/ GIMT_Encode4(1379004), // Rule ID 22309 //
     /* 1378925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1378933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1378942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378978 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1378981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379003 */     // GIR_Coverage, 22309,
     /* 1379003 */     GIR_EraseRootFromParent_Done,
     /* 1379004 */   // Label 19595: @1379004
     /* 1379004 */   GIM_Try, /*On fail goto*//*Label 19596*/ GIMT_Encode4(1379088), // Rule ID 22312 //
     /* 1379009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1379017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1379026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379062 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1379065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379087 */     // GIR_Coverage, 22312,
     /* 1379087 */     GIR_EraseRootFromParent_Done,
     /* 1379088 */   // Label 19596: @1379088
     /* 1379088 */   GIM_Try, /*On fail goto*//*Label 19597*/ GIMT_Encode4(1379172), // Rule ID 22313 //
     /* 1379093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1379101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1379110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379146 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1379149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379171 */     // GIR_Coverage, 22313,
     /* 1379171 */     GIR_EraseRootFromParent_Done,
     /* 1379172 */   // Label 19597: @1379172
     /* 1379172 */   GIM_Try, /*On fail goto*//*Label 19598*/ GIMT_Encode4(1379256), // Rule ID 22316 //
     /* 1379177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1379185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379230 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1379233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379255 */     // GIR_Coverage, 22316,
     /* 1379255 */     GIR_EraseRootFromParent_Done,
     /* 1379256 */   // Label 19598: @1379256
     /* 1379256 */   GIM_Try, /*On fail goto*//*Label 19599*/ GIMT_Encode4(1379340), // Rule ID 22317 //
     /* 1379261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1379269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379314 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1379317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379339 */     // GIR_Coverage, 22317,
     /* 1379339 */     GIR_EraseRootFromParent_Done,
     /* 1379340 */   // Label 19599: @1379340
     /* 1379340 */   GIM_Try, /*On fail goto*//*Label 19600*/ GIMT_Encode4(1379424), // Rule ID 22320 //
     /* 1379345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1379353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1379362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379398 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1379401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379423 */     // GIR_Coverage, 22320,
     /* 1379423 */     GIR_EraseRootFromParent_Done,
     /* 1379424 */   // Label 19600: @1379424
     /* 1379424 */   GIM_Try, /*On fail goto*//*Label 19601*/ GIMT_Encode4(1379508), // Rule ID 22321 //
     /* 1379429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1379437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1379446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1379485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379507 */     // GIR_Coverage, 22321,
     /* 1379507 */     GIR_EraseRootFromParent_Done,
     /* 1379508 */   // Label 19601: @1379508
     /* 1379508 */   GIM_Try, /*On fail goto*//*Label 19602*/ GIMT_Encode4(1379592), // Rule ID 22324 //
     /* 1379513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1379521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1379530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1379569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379591 */     // GIR_Coverage, 22324,
     /* 1379591 */     GIR_EraseRootFromParent_Done,
     /* 1379592 */   // Label 19602: @1379592
     /* 1379592 */   GIM_Try, /*On fail goto*//*Label 19603*/ GIMT_Encode4(1379676), // Rule ID 22325 //
     /* 1379597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1379605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1379614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379650 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1379653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379675 */     // GIR_Coverage, 22325,
     /* 1379675 */     GIR_EraseRootFromParent_Done,
     /* 1379676 */   // Label 19603: @1379676
     /* 1379676 */   GIM_Try, /*On fail goto*//*Label 19604*/ GIMT_Encode4(1379760), // Rule ID 22328 //
     /* 1379681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1379698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1379704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379734 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1379737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379759 */     // GIR_Coverage, 22328,
     /* 1379759 */     GIR_EraseRootFromParent_Done,
     /* 1379760 */   // Label 19604: @1379760
     /* 1379760 */   GIM_Try, /*On fail goto*//*Label 19605*/ GIMT_Encode4(1379844), // Rule ID 22329 //
     /* 1379765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1379782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1379788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1379821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379843 */     // GIR_Coverage, 22329,
     /* 1379843 */     GIR_EraseRootFromParent_Done,
     /* 1379844 */   // Label 19605: @1379844
     /* 1379844 */   GIM_Try, /*On fail goto*//*Label 19606*/ GIMT_Encode4(1379928), // Rule ID 22332 //
     /* 1379849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1379866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1379905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379927 */     // GIR_Coverage, 22332,
     /* 1379927 */     GIR_EraseRootFromParent_Done,
     /* 1379928 */   // Label 19606: @1379928
     /* 1379928 */   GIM_Try, /*On fail goto*//*Label 19607*/ GIMT_Encode4(1380012), // Rule ID 22333 //
     /* 1379933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1379950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379986 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1379989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380011 */     // GIR_Coverage, 22333,
     /* 1380011 */     GIR_EraseRootFromParent_Done,
     /* 1380012 */   // Label 19607: @1380012
     /* 1380012 */   GIM_Try, /*On fail goto*//*Label 19608*/ GIMT_Encode4(1380096), // Rule ID 22336 //
     /* 1380017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1380025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1380034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1380073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380095 */     // GIR_Coverage, 22336,
     /* 1380095 */     GIR_EraseRootFromParent_Done,
     /* 1380096 */   // Label 19608: @1380096
     /* 1380096 */   GIM_Try, /*On fail goto*//*Label 19609*/ GIMT_Encode4(1380180), // Rule ID 22337 //
     /* 1380101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1380109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1380118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380154 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1380157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380179 */     // GIR_Coverage, 22337,
     /* 1380179 */     GIR_EraseRootFromParent_Done,
     /* 1380180 */   // Label 19609: @1380180
     /* 1380180 */   GIM_Try, /*On fail goto*//*Label 19610*/ GIMT_Encode4(1380264), // Rule ID 22340 //
     /* 1380185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1380193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380238 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1380241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380263 */     // GIR_Coverage, 22340,
     /* 1380263 */     GIR_EraseRootFromParent_Done,
     /* 1380264 */   // Label 19610: @1380264
     /* 1380264 */   GIM_Try, /*On fail goto*//*Label 19611*/ GIMT_Encode4(1380348), // Rule ID 22341 //
     /* 1380269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1380277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380322 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1380325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380347 */     // GIR_Coverage, 22341,
     /* 1380347 */     GIR_EraseRootFromParent_Done,
     /* 1380348 */   // Label 19611: @1380348
     /* 1380348 */   GIM_Try, /*On fail goto*//*Label 19612*/ GIMT_Encode4(1380432), // Rule ID 22344 //
     /* 1380353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1380361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1380370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380406 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1380409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380431 */     // GIR_Coverage, 22344,
     /* 1380431 */     GIR_EraseRootFromParent_Done,
     /* 1380432 */   // Label 19612: @1380432
     /* 1380432 */   GIM_Try, /*On fail goto*//*Label 19613*/ GIMT_Encode4(1380516), // Rule ID 22345 //
     /* 1380437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1380445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1380454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1380493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380515 */     // GIR_Coverage, 22345,
     /* 1380515 */     GIR_EraseRootFromParent_Done,
     /* 1380516 */   // Label 19613: @1380516
     /* 1380516 */   GIM_Try, /*On fail goto*//*Label 19614*/ GIMT_Encode4(1380600), // Rule ID 22348 //
     /* 1380521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1380529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1380538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380574 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1380577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380599 */     // GIR_Coverage, 22348,
     /* 1380599 */     GIR_EraseRootFromParent_Done,
     /* 1380600 */   // Label 19614: @1380600
     /* 1380600 */   GIM_Try, /*On fail goto*//*Label 19615*/ GIMT_Encode4(1380684), // Rule ID 22349 //
     /* 1380605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1380613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1380622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1380661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380683 */     // GIR_Coverage, 22349,
     /* 1380683 */     GIR_EraseRootFromParent_Done,
     /* 1380684 */   // Label 19615: @1380684
     /* 1380684 */   GIM_Try, /*On fail goto*//*Label 19616*/ GIMT_Encode4(1380768), // Rule ID 22352 //
     /* 1380689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1380697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1380706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380742 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1380745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380767 */     // GIR_Coverage, 22352,
     /* 1380767 */     GIR_EraseRootFromParent_Done,
     /* 1380768 */   // Label 19616: @1380768
     /* 1380768 */   GIM_Try, /*On fail goto*//*Label 19617*/ GIMT_Encode4(1380852), // Rule ID 22353 //
     /* 1380773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1380781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1380790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380826 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1380829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380851 */     // GIR_Coverage, 22353,
     /* 1380851 */     GIR_EraseRootFromParent_Done,
     /* 1380852 */   // Label 19617: @1380852
     /* 1380852 */   GIM_Try, /*On fail goto*//*Label 19618*/ GIMT_Encode4(1380936), // Rule ID 22356 //
     /* 1380857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1380865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1380874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380910 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1380913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380935 */     // GIR_Coverage, 22356,
     /* 1380935 */     GIR_EraseRootFromParent_Done,
     /* 1380936 */   // Label 19618: @1380936
     /* 1380936 */   GIM_Try, /*On fail goto*//*Label 19619*/ GIMT_Encode4(1381020), // Rule ID 22357 //
     /* 1380941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1380949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1380958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380994 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1380997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381019 */     // GIR_Coverage, 22357,
     /* 1381019 */     GIR_EraseRootFromParent_Done,
     /* 1381020 */   // Label 19619: @1381020
     /* 1381020 */   GIM_Try, /*On fail goto*//*Label 19620*/ GIMT_Encode4(1381104), // Rule ID 22360 //
     /* 1381025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1381033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1381042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1381045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381078 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1381081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381103 */     // GIR_Coverage, 22360,
     /* 1381103 */     GIR_EraseRootFromParent_Done,
     /* 1381104 */   // Label 19620: @1381104
     /* 1381104 */   GIM_Try, /*On fail goto*//*Label 19621*/ GIMT_Encode4(1381188), // Rule ID 22361 //
     /* 1381109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1381117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1381126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1381129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381162 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1381165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381187 */     // GIR_Coverage, 22361,
     /* 1381187 */     GIR_EraseRootFromParent_Done,
     /* 1381188 */   // Label 19621: @1381188
     /* 1381188 */   GIM_Try, /*On fail goto*//*Label 19622*/ GIMT_Encode4(1381272), // Rule ID 22364 //
     /* 1381193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1381196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1381201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1381213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1381249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1381267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381271 */     // GIR_Coverage, 22364,
     /* 1381271 */     GIR_EraseRootFromParent_Done,
     /* 1381272 */   // Label 19622: @1381272
     /* 1381272 */   GIM_Try, /*On fail goto*//*Label 19623*/ GIMT_Encode4(1381356), // Rule ID 22365 //
     /* 1381277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1381280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1381285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1381297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381330 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1381333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1381351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381355 */     // GIR_Coverage, 22365,
     /* 1381355 */     GIR_EraseRootFromParent_Done,
     /* 1381356 */   // Label 19623: @1381356
     /* 1381356 */   GIM_Try, /*On fail goto*//*Label 19624*/ GIMT_Encode4(1381440), // Rule ID 22368 //
     /* 1381361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1381369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1381378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381414 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1381417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381439 */     // GIR_Coverage, 22368,
     /* 1381439 */     GIR_EraseRootFromParent_Done,
     /* 1381440 */   // Label 19624: @1381440
     /* 1381440 */   GIM_Try, /*On fail goto*//*Label 19625*/ GIMT_Encode4(1381524), // Rule ID 22369 //
     /* 1381445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1381453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1381462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381498 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1381501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381523 */     // GIR_Coverage, 22369,
     /* 1381523 */     GIR_EraseRootFromParent_Done,
     /* 1381524 */   // Label 19625: @1381524
     /* 1381524 */   GIM_Try, /*On fail goto*//*Label 19626*/ GIMT_Encode4(1381608), // Rule ID 22372 //
     /* 1381529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1381537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1381546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1381552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1381585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381607 */     // GIR_Coverage, 22372,
     /* 1381607 */     GIR_EraseRootFromParent_Done,
     /* 1381608 */   // Label 19626: @1381608
     /* 1381608 */   GIM_Try, /*On fail goto*//*Label 19627*/ GIMT_Encode4(1381692), // Rule ID 22373 //
     /* 1381613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1381621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1381630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1381636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381666 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1381669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381691 */     // GIR_Coverage, 22373,
     /* 1381691 */     GIR_EraseRootFromParent_Done,
     /* 1381692 */   // Label 19627: @1381692
     /* 1381692 */   GIM_Try, /*On fail goto*//*Label 19628*/ GIMT_Encode4(1381776), // Rule ID 22376 //
     /* 1381697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1381705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1381714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1381720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1381735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381750 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1381753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381775 */     // GIR_Coverage, 22376,
     /* 1381775 */     GIR_EraseRootFromParent_Done,
     /* 1381776 */   // Label 19628: @1381776
     /* 1381776 */   GIM_Try, /*On fail goto*//*Label 19629*/ GIMT_Encode4(1381860), // Rule ID 22377 //
     /* 1381781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1381789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1381798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1381804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1381819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381834 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1381837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381859 */     // GIR_Coverage, 22377,
     /* 1381859 */     GIR_EraseRootFromParent_Done,
     /* 1381860 */   // Label 19629: @1381860
     /* 1381860 */   GIM_Try, /*On fail goto*//*Label 19630*/ GIMT_Encode4(1381944), // Rule ID 22380 //
     /* 1381865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1381873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1381882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1381921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381943 */     // GIR_Coverage, 22380,
     /* 1381943 */     GIR_EraseRootFromParent_Done,
     /* 1381944 */   // Label 19630: @1381944
     /* 1381944 */   GIM_Try, /*On fail goto*//*Label 19631*/ GIMT_Encode4(1382028), // Rule ID 22381 //
     /* 1381949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1381957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1381966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1382005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382027 */     // GIR_Coverage, 22381,
     /* 1382027 */     GIR_EraseRootFromParent_Done,
     /* 1382028 */   // Label 19631: @1382028
     /* 1382028 */   GIM_Try, /*On fail goto*//*Label 19632*/ GIMT_Encode4(1382112), // Rule ID 22384 //
     /* 1382033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1382041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1382050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1382089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382111 */     // GIR_Coverage, 22384,
     /* 1382111 */     GIR_EraseRootFromParent_Done,
     /* 1382112 */   // Label 19632: @1382112
     /* 1382112 */   GIM_Try, /*On fail goto*//*Label 19633*/ GIMT_Encode4(1382196), // Rule ID 22385 //
     /* 1382117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1382125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1382134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382170 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1382173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382195 */     // GIR_Coverage, 22385,
     /* 1382195 */     GIR_EraseRootFromParent_Done,
     /* 1382196 */   // Label 19633: @1382196
     /* 1382196 */   GIM_Try, /*On fail goto*//*Label 19634*/ GIMT_Encode4(1382280), // Rule ID 22388 //
     /* 1382201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1382209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1382218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382254 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1382257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382279 */     // GIR_Coverage, 22388,
     /* 1382279 */     GIR_EraseRootFromParent_Done,
     /* 1382280 */   // Label 19634: @1382280
     /* 1382280 */   GIM_Try, /*On fail goto*//*Label 19635*/ GIMT_Encode4(1382364), // Rule ID 22389 //
     /* 1382285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1382293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1382302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382338 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1382341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382363 */     // GIR_Coverage, 22389,
     /* 1382363 */     GIR_EraseRootFromParent_Done,
     /* 1382364 */   // Label 19635: @1382364
     /* 1382364 */   GIM_Try, /*On fail goto*//*Label 19636*/ GIMT_Encode4(1382448), // Rule ID 22392 //
     /* 1382369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1382377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1382386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1382425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382447 */     // GIR_Coverage, 22392,
     /* 1382447 */     GIR_EraseRootFromParent_Done,
     /* 1382448 */   // Label 19636: @1382448
     /* 1382448 */   GIM_Try, /*On fail goto*//*Label 19637*/ GIMT_Encode4(1382532), // Rule ID 22393 //
     /* 1382453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1382461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1382470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382506 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1382509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382531 */     // GIR_Coverage, 22393,
     /* 1382531 */     GIR_EraseRootFromParent_Done,
     /* 1382532 */   // Label 19637: @1382532
     /* 1382532 */   GIM_Try, /*On fail goto*//*Label 19638*/ GIMT_Encode4(1382616), // Rule ID 22396 //
     /* 1382537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1382545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1382554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382590 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1382593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382615 */     // GIR_Coverage, 22396,
     /* 1382615 */     GIR_EraseRootFromParent_Done,
     /* 1382616 */   // Label 19638: @1382616
     /* 1382616 */   GIM_Try, /*On fail goto*//*Label 19639*/ GIMT_Encode4(1382700), // Rule ID 22397 //
     /* 1382621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1382629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1382638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1382677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382699 */     // GIR_Coverage, 22397,
     /* 1382699 */     GIR_EraseRootFromParent_Done,
     /* 1382700 */   // Label 19639: @1382700
     /* 1382700 */   GIM_Try, /*On fail goto*//*Label 19640*/ GIMT_Encode4(1382784), // Rule ID 22400 //
     /* 1382705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1382713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1382722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382758 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1382761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382783 */     // GIR_Coverage, 22400,
     /* 1382783 */     GIR_EraseRootFromParent_Done,
     /* 1382784 */   // Label 19640: @1382784
     /* 1382784 */   GIM_Try, /*On fail goto*//*Label 19641*/ GIMT_Encode4(1382868), // Rule ID 22401 //
     /* 1382789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1382797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1382806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1382845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382867 */     // GIR_Coverage, 22401,
     /* 1382867 */     GIR_EraseRootFromParent_Done,
     /* 1382868 */   // Label 19641: @1382868
     /* 1382868 */   GIM_Try, /*On fail goto*//*Label 19642*/ GIMT_Encode4(1382952), // Rule ID 22404 //
     /* 1382873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1382876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1382881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1382884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1382887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1382890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1382893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1382896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382926 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1382929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1382947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382951 */     // GIR_Coverage, 22404,
     /* 1382951 */     GIR_EraseRootFromParent_Done,
     /* 1382952 */   // Label 19642: @1382952
     /* 1382952 */   GIM_Try, /*On fail goto*//*Label 19643*/ GIMT_Encode4(1383036), // Rule ID 22405 //
     /* 1382957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1382960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1382965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1382968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1382971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1382974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1382977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1382980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383010 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1383013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383035 */     // GIR_Coverage, 22405,
     /* 1383035 */     GIR_EraseRootFromParent_Done,
     /* 1383036 */   // Label 19643: @1383036
     /* 1383036 */   GIM_Try, /*On fail goto*//*Label 19644*/ GIMT_Encode4(1383120), // Rule ID 22408 //
     /* 1383041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1383044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1383049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1383058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1383097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383119 */     // GIR_Coverage, 22408,
     /* 1383119 */     GIR_EraseRootFromParent_Done,
     /* 1383120 */   // Label 19644: @1383120
     /* 1383120 */   GIM_Try, /*On fail goto*//*Label 19645*/ GIMT_Encode4(1383204), // Rule ID 22409 //
     /* 1383125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1383128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1383133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1383142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383178 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1383181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383203 */     // GIR_Coverage, 22409,
     /* 1383203 */     GIR_EraseRootFromParent_Done,
     /* 1383204 */   // Label 19645: @1383204
     /* 1383204 */   GIM_Try, /*On fail goto*//*Label 19646*/ GIMT_Encode4(1383288), // Rule ID 22412 //
     /* 1383209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1383212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1383217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383262 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1383265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383287 */     // GIR_Coverage, 22412,
     /* 1383287 */     GIR_EraseRootFromParent_Done,
     /* 1383288 */   // Label 19646: @1383288
     /* 1383288 */   GIM_Try, /*On fail goto*//*Label 19647*/ GIMT_Encode4(1383372), // Rule ID 22413 //
     /* 1383293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1383296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1383301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383346 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1383349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383371 */     // GIR_Coverage, 22413,
     /* 1383371 */     GIR_EraseRootFromParent_Done,
     /* 1383372 */   // Label 19647: @1383372
     /* 1383372 */   GIM_Try, /*On fail goto*//*Label 19648*/ GIMT_Encode4(1383456), // Rule ID 22416 //
     /* 1383377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1383394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383430 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1383433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383455 */     // GIR_Coverage, 22416,
     /* 1383455 */     GIR_EraseRootFromParent_Done,
     /* 1383456 */   // Label 19648: @1383456
     /* 1383456 */   GIM_Try, /*On fail goto*//*Label 19649*/ GIMT_Encode4(1383540), // Rule ID 22417 //
     /* 1383461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1383478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383514 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1383517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383539 */     // GIR_Coverage, 22417,
     /* 1383539 */     GIR_EraseRootFromParent_Done,
     /* 1383540 */   // Label 19649: @1383540
     /* 1383540 */   GIM_Try, /*On fail goto*//*Label 19650*/ GIMT_Encode4(1383624), // Rule ID 22420 //
     /* 1383545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1383562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383598 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1383601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383623 */     // GIR_Coverage, 22420,
     /* 1383623 */     GIR_EraseRootFromParent_Done,
     /* 1383624 */   // Label 19650: @1383624
     /* 1383624 */   GIM_Try, /*On fail goto*//*Label 19651*/ GIMT_Encode4(1383708), // Rule ID 22421 //
     /* 1383629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1383646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383682 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1383685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383707 */     // GIR_Coverage, 22421,
     /* 1383707 */     GIR_EraseRootFromParent_Done,
     /* 1383708 */   // Label 19651: @1383708
     /* 1383708 */   GIM_Try, /*On fail goto*//*Label 19652*/ GIMT_Encode4(1383792), // Rule ID 22424 //
     /* 1383713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1383730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383766 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1383769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383791 */     // GIR_Coverage, 22424,
     /* 1383791 */     GIR_EraseRootFromParent_Done,
     /* 1383792 */   // Label 19652: @1383792
     /* 1383792 */   GIM_Try, /*On fail goto*//*Label 19653*/ GIMT_Encode4(1383876), // Rule ID 22425 //
     /* 1383797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1383814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1383853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383875 */     // GIR_Coverage, 22425,
     /* 1383875 */     GIR_EraseRootFromParent_Done,
     /* 1383876 */   // Label 19653: @1383876
     /* 1383876 */   GIM_Try, /*On fail goto*//*Label 19654*/ GIMT_Encode4(1383960), // Rule ID 22428 //
     /* 1383881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1383898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383934 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1383937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383959 */     // GIR_Coverage, 22428,
     /* 1383959 */     GIR_EraseRootFromParent_Done,
     /* 1383960 */   // Label 19654: @1383960
     /* 1383960 */   GIM_Try, /*On fail goto*//*Label 19655*/ GIMT_Encode4(1384044), // Rule ID 22429 //
     /* 1383965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1383982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384018 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1384021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384043 */     // GIR_Coverage, 22429,
     /* 1384043 */     GIR_EraseRootFromParent_Done,
     /* 1384044 */   // Label 19655: @1384044
     /* 1384044 */   GIM_Try, /*On fail goto*//*Label 19656*/ GIMT_Encode4(1384128), // Rule ID 22432 //
     /* 1384049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1384057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1384066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1384105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384127 */     // GIR_Coverage, 22432,
     /* 1384127 */     GIR_EraseRootFromParent_Done,
     /* 1384128 */   // Label 19656: @1384128
     /* 1384128 */   GIM_Try, /*On fail goto*//*Label 19657*/ GIMT_Encode4(1384212), // Rule ID 22433 //
     /* 1384133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1384141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1384150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384186 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1384189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384211 */     // GIR_Coverage, 22433,
     /* 1384211 */     GIR_EraseRootFromParent_Done,
     /* 1384212 */   // Label 19657: @1384212
     /* 1384212 */   GIM_Try, /*On fail goto*//*Label 19658*/ GIMT_Encode4(1384296), // Rule ID 22436 //
     /* 1384217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1384225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1384234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1384273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384295 */     // GIR_Coverage, 22436,
     /* 1384295 */     GIR_EraseRootFromParent_Done,
     /* 1384296 */   // Label 19658: @1384296
     /* 1384296 */   GIM_Try, /*On fail goto*//*Label 19659*/ GIMT_Encode4(1384380), // Rule ID 22437 //
     /* 1384301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1384309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1384318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1384357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384379 */     // GIR_Coverage, 22437,
     /* 1384379 */     GIR_EraseRootFromParent_Done,
     /* 1384380 */   // Label 19659: @1384380
     /* 1384380 */   GIM_Try, /*On fail goto*//*Label 19660*/ GIMT_Encode4(1384464), // Rule ID 22440 //
     /* 1384385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1384393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1384402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384438 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1384441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384463 */     // GIR_Coverage, 22440,
     /* 1384463 */     GIR_EraseRootFromParent_Done,
     /* 1384464 */   // Label 19660: @1384464
     /* 1384464 */   GIM_Try, /*On fail goto*//*Label 19661*/ GIMT_Encode4(1384548), // Rule ID 22441 //
     /* 1384469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1384477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1384486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384522 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1384525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384547 */     // GIR_Coverage, 22441,
     /* 1384547 */     GIR_EraseRootFromParent_Done,
     /* 1384548 */   // Label 19661: @1384548
     /* 1384548 */   GIM_Try, /*On fail goto*//*Label 19662*/ GIMT_Encode4(1384632), // Rule ID 22444 //
     /* 1384553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1384561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1384570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384606 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1384609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384631 */     // GIR_Coverage, 22444,
     /* 1384631 */     GIR_EraseRootFromParent_Done,
     /* 1384632 */   // Label 19662: @1384632
     /* 1384632 */   GIM_Try, /*On fail goto*//*Label 19663*/ GIMT_Encode4(1384716), // Rule ID 22445 //
     /* 1384637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1384645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1384654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384690 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1384693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384715 */     // GIR_Coverage, 22445,
     /* 1384715 */     GIR_EraseRootFromParent_Done,
     /* 1384716 */   // Label 19663: @1384716
     /* 1384716 */   GIM_Try, /*On fail goto*//*Label 19664*/ GIMT_Encode4(1384800), // Rule ID 22448 //
     /* 1384721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1384729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1384738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1384777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384799 */     // GIR_Coverage, 22448,
     /* 1384799 */     GIR_EraseRootFromParent_Done,
     /* 1384800 */   // Label 19664: @1384800
     /* 1384800 */   GIM_Try, /*On fail goto*//*Label 19665*/ GIMT_Encode4(1384884), // Rule ID 22449 //
     /* 1384805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1384813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1384822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384858 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1384861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384883 */     // GIR_Coverage, 22449,
     /* 1384883 */     GIR_EraseRootFromParent_Done,
     /* 1384884 */   // Label 19665: @1384884
     /* 1384884 */   GIM_Try, /*On fail goto*//*Label 19666*/ GIMT_Encode4(1384968), // Rule ID 22452 //
     /* 1384889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1384892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1384897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1384906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384942 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1384945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384967 */     // GIR_Coverage, 22452,
     /* 1384967 */     GIR_EraseRootFromParent_Done,
     /* 1384968 */   // Label 19666: @1384968
     /* 1384968 */   GIM_Try, /*On fail goto*//*Label 19667*/ GIMT_Encode4(1385052), // Rule ID 22453 //
     /* 1384973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1384976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1384981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1384990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385026 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1385029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1385047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385051 */     // GIR_Coverage, 22453,
     /* 1385051 */     GIR_EraseRootFromParent_Done,
     /* 1385052 */   // Label 19667: @1385052
     /* 1385052 */   GIM_Try, /*On fail goto*//*Label 19668*/ GIMT_Encode4(1385136), // Rule ID 22456 //
     /* 1385057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1385065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1385074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385110 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1385113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385135 */     // GIR_Coverage, 22456,
     /* 1385135 */     GIR_EraseRootFromParent_Done,
     /* 1385136 */   // Label 19668: @1385136
     /* 1385136 */   GIM_Try, /*On fail goto*//*Label 19669*/ GIMT_Encode4(1385220), // Rule ID 22457 //
     /* 1385141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1385149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1385158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385194 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1385197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385219 */     // GIR_Coverage, 22457,
     /* 1385219 */     GIR_EraseRootFromParent_Done,
     /* 1385220 */   // Label 19669: @1385220
     /* 1385220 */   GIM_Try, /*On fail goto*//*Label 19670*/ GIMT_Encode4(1385304), // Rule ID 22460 //
     /* 1385225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1385233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1385242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385278 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1385281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385303 */     // GIR_Coverage, 22460,
     /* 1385303 */     GIR_EraseRootFromParent_Done,
     /* 1385304 */   // Label 19670: @1385304
     /* 1385304 */   GIM_Try, /*On fail goto*//*Label 19671*/ GIMT_Encode4(1385388), // Rule ID 22461 //
     /* 1385309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1385317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1385326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385362 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1385365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385387 */     // GIR_Coverage, 22461,
     /* 1385387 */     GIR_EraseRootFromParent_Done,
     /* 1385388 */   // Label 19671: @1385388
     /* 1385388 */   GIM_Try, /*On fail goto*//*Label 19672*/ GIMT_Encode4(1385472), // Rule ID 22464 //
     /* 1385393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1385401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1385410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1385416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385446 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1385449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385471 */     // GIR_Coverage, 22464,
     /* 1385471 */     GIR_EraseRootFromParent_Done,
     /* 1385472 */   // Label 19672: @1385472
     /* 1385472 */   GIM_Try, /*On fail goto*//*Label 19673*/ GIMT_Encode4(1385556), // Rule ID 22465 //
     /* 1385477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1385485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1385494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1385500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385530 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1385533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385555 */     // GIR_Coverage, 22465,
     /* 1385555 */     GIR_EraseRootFromParent_Done,
     /* 1385556 */   // Label 19673: @1385556
     /* 1385556 */   GIM_Try, /*On fail goto*//*Label 19674*/ GIMT_Encode4(1385640), // Rule ID 22468 //
     /* 1385561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1385569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1385578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385614 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1385617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385639 */     // GIR_Coverage, 22468,
     /* 1385639 */     GIR_EraseRootFromParent_Done,
     /* 1385640 */   // Label 19674: @1385640
     /* 1385640 */   GIM_Try, /*On fail goto*//*Label 19675*/ GIMT_Encode4(1385724), // Rule ID 22469 //
     /* 1385645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1385653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1385662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385698 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1385701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385723 */     // GIR_Coverage, 22469,
     /* 1385723 */     GIR_EraseRootFromParent_Done,
     /* 1385724 */   // Label 19675: @1385724
     /* 1385724 */   GIM_Try, /*On fail goto*//*Label 19676*/ GIMT_Encode4(1385808), // Rule ID 22472 //
     /* 1385729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1385737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1385746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1385785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385807 */     // GIR_Coverage, 22472,
     /* 1385807 */     GIR_EraseRootFromParent_Done,
     /* 1385808 */   // Label 19676: @1385808
     /* 1385808 */   GIM_Try, /*On fail goto*//*Label 19677*/ GIMT_Encode4(1385892), // Rule ID 22473 //
     /* 1385813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1385821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1385830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385866 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1385869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385891 */     // GIR_Coverage, 22473,
     /* 1385891 */     GIR_EraseRootFromParent_Done,
     /* 1385892 */   // Label 19677: @1385892
     /* 1385892 */   GIM_Try, /*On fail goto*//*Label 19678*/ GIMT_Encode4(1385976), // Rule ID 22476 //
     /* 1385897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1385905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1385914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385950 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1385953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385975 */     // GIR_Coverage, 22476,
     /* 1385975 */     GIR_EraseRootFromParent_Done,
     /* 1385976 */   // Label 19678: @1385976
     /* 1385976 */   GIM_Try, /*On fail goto*//*Label 19679*/ GIMT_Encode4(1386060), // Rule ID 22477 //
     /* 1385981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1385989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1385998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1386001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1386004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386034 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1386037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386059 */     // GIR_Coverage, 22477,
     /* 1386059 */     GIR_EraseRootFromParent_Done,
     /* 1386060 */   // Label 19679: @1386060
     /* 1386060 */   GIM_Try, /*On fail goto*//*Label 19680*/ GIMT_Encode4(1386144), // Rule ID 22480 //
     /* 1386065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1386073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1386082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1386121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386143 */     // GIR_Coverage, 22480,
     /* 1386143 */     GIR_EraseRootFromParent_Done,
     /* 1386144 */   // Label 19680: @1386144
     /* 1386144 */   GIM_Try, /*On fail goto*//*Label 19681*/ GIMT_Encode4(1386228), // Rule ID 22481 //
     /* 1386149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1386157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1386166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1386205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386227 */     // GIR_Coverage, 22481,
     /* 1386227 */     GIR_EraseRootFromParent_Done,
     /* 1386228 */   // Label 19681: @1386228
     /* 1386228 */   GIM_Try, /*On fail goto*//*Label 19682*/ GIMT_Encode4(1386312), // Rule ID 22484 //
     /* 1386233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1386241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1386250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1386289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386311 */     // GIR_Coverage, 22484,
     /* 1386311 */     GIR_EraseRootFromParent_Done,
     /* 1386312 */   // Label 19682: @1386312
     /* 1386312 */   GIM_Try, /*On fail goto*//*Label 19683*/ GIMT_Encode4(1386396), // Rule ID 22485 //
     /* 1386317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1386325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1386334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386370 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1386373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386395 */     // GIR_Coverage, 22485,
     /* 1386395 */     GIR_EraseRootFromParent_Done,
     /* 1386396 */   // Label 19683: @1386396
     /* 1386396 */   GIM_Try, /*On fail goto*//*Label 19684*/ GIMT_Encode4(1386480), // Rule ID 22488 //
     /* 1386401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1386409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1386418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386454 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1386457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386479 */     // GIR_Coverage, 22488,
     /* 1386479 */     GIR_EraseRootFromParent_Done,
     /* 1386480 */   // Label 19684: @1386480
     /* 1386480 */   GIM_Try, /*On fail goto*//*Label 19685*/ GIMT_Encode4(1386564), // Rule ID 22489 //
     /* 1386485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1386493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1386502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386538 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1386541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386563 */     // GIR_Coverage, 22489,
     /* 1386563 */     GIR_EraseRootFromParent_Done,
     /* 1386564 */   // Label 19685: @1386564
     /* 1386564 */   GIM_Try, /*On fail goto*//*Label 19686*/ GIMT_Encode4(1386648), // Rule ID 22492 //
     /* 1386569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1386572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1386577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1386586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1386592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386622 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1386625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386647 */     // GIR_Coverage, 22492,
     /* 1386647 */     GIR_EraseRootFromParent_Done,
     /* 1386648 */   // Label 19686: @1386648
     /* 1386648 */   GIM_Try, /*On fail goto*//*Label 19687*/ GIMT_Encode4(1386732), // Rule ID 22493 //
     /* 1386653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1386656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1386661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1386670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1386676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1386709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386731 */     // GIR_Coverage, 22493,
     /* 1386731 */     GIR_EraseRootFromParent_Done,
     /* 1386732 */   // Label 19687: @1386732
     /* 1386732 */   GIM_Try, /*On fail goto*//*Label 19688*/ GIMT_Encode4(1386816), // Rule ID 22496 //
     /* 1386737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1386740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1386745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1386754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1386793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386815 */     // GIR_Coverage, 22496,
     /* 1386815 */     GIR_EraseRootFromParent_Done,
     /* 1386816 */   // Label 19688: @1386816
     /* 1386816 */   GIM_Try, /*On fail goto*//*Label 19689*/ GIMT_Encode4(1386900), // Rule ID 22497 //
     /* 1386821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1386824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1386829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1386838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386874 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1386877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386899 */     // GIR_Coverage, 22497,
     /* 1386899 */     GIR_EraseRootFromParent_Done,
     /* 1386900 */   // Label 19689: @1386900
     /* 1386900 */   GIM_Try, /*On fail goto*//*Label 19690*/ GIMT_Encode4(1386984), // Rule ID 22500 //
     /* 1386905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1386908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1386913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1386922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386958 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1386961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386983 */     // GIR_Coverage, 22500,
     /* 1386983 */     GIR_EraseRootFromParent_Done,
     /* 1386984 */   // Label 19690: @1386984
     /* 1386984 */   GIM_Try, /*On fail goto*//*Label 19691*/ GIMT_Encode4(1387068), // Rule ID 22501 //
     /* 1386989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1386992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1386997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1387006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1387009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1387012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1387027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387042 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1387045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1387063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387067 */     // GIR_Coverage, 22501,
     /* 1387067 */     GIR_EraseRootFromParent_Done,
     /* 1387068 */   // Label 19691: @1387068
     /* 1387068 */   GIM_Try, /*On fail goto*//*Label 19692*/ GIMT_Encode4(1387152), // Rule ID 22504 //
     /* 1387073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1387090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387126 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1387129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387151 */     // GIR_Coverage, 22504,
     /* 1387151 */     GIR_EraseRootFromParent_Done,
     /* 1387152 */   // Label 19692: @1387152
     /* 1387152 */   GIM_Try, /*On fail goto*//*Label 19693*/ GIMT_Encode4(1387236), // Rule ID 22505 //
     /* 1387157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1387174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387210 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1387213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387235 */     // GIR_Coverage, 22505,
     /* 1387235 */     GIR_EraseRootFromParent_Done,
     /* 1387236 */   // Label 19693: @1387236
     /* 1387236 */   GIM_Try, /*On fail goto*//*Label 19694*/ GIMT_Encode4(1387320), // Rule ID 22508 //
     /* 1387241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1387258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387294 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1387297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387319 */     // GIR_Coverage, 22508,
     /* 1387319 */     GIR_EraseRootFromParent_Done,
     /* 1387320 */   // Label 19694: @1387320
     /* 1387320 */   GIM_Try, /*On fail goto*//*Label 19695*/ GIMT_Encode4(1387404), // Rule ID 22509 //
     /* 1387325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1387342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387378 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1387381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387403 */     // GIR_Coverage, 22509,
     /* 1387403 */     GIR_EraseRootFromParent_Done,
     /* 1387404 */   // Label 19695: @1387404
     /* 1387404 */   GIM_Try, /*On fail goto*//*Label 19696*/ GIMT_Encode4(1387488), // Rule ID 22512 //
     /* 1387409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1387426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387462 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1387465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387487 */     // GIR_Coverage, 22512,
     /* 1387487 */     GIR_EraseRootFromParent_Done,
     /* 1387488 */   // Label 19696: @1387488
     /* 1387488 */   GIM_Try, /*On fail goto*//*Label 19697*/ GIMT_Encode4(1387572), // Rule ID 22513 //
     /* 1387493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1387510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387546 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1387549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387571 */     // GIR_Coverage, 22513,
     /* 1387571 */     GIR_EraseRootFromParent_Done,
     /* 1387572 */   // Label 19697: @1387572
     /* 1387572 */   GIM_Try, /*On fail goto*//*Label 19698*/ GIMT_Encode4(1387656), // Rule ID 22516 //
     /* 1387577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1387594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387630 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1387633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387655 */     // GIR_Coverage, 22516,
     /* 1387655 */     GIR_EraseRootFromParent_Done,
     /* 1387656 */   // Label 19698: @1387656
     /* 1387656 */   GIM_Try, /*On fail goto*//*Label 19699*/ GIMT_Encode4(1387740), // Rule ID 22517 //
     /* 1387661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1387678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1387717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387739 */     // GIR_Coverage, 22517,
     /* 1387739 */     GIR_EraseRootFromParent_Done,
     /* 1387740 */   // Label 19699: @1387740
     /* 1387740 */   GIM_Try, /*On fail goto*//*Label 19700*/ GIMT_Encode4(1387824), // Rule ID 22520 //
     /* 1387745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1387762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387798 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1387801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387823 */     // GIR_Coverage, 22520,
     /* 1387823 */     GIR_EraseRootFromParent_Done,
     /* 1387824 */   // Label 19700: @1387824
     /* 1387824 */   GIM_Try, /*On fail goto*//*Label 19701*/ GIMT_Encode4(1387908), // Rule ID 22521 //
     /* 1387829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1387846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1387885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387907 */     // GIR_Coverage, 22521,
     /* 1387907 */     GIR_EraseRootFromParent_Done,
     /* 1387908 */   // Label 19701: @1387908
     /* 1387908 */   GIM_Try, /*On fail goto*//*Label 19702*/ GIMT_Encode4(1387992), // Rule ID 22524 //
     /* 1387913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1387930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1387969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387991 */     // GIR_Coverage, 22524,
     /* 1387991 */     GIR_EraseRootFromParent_Done,
     /* 1387992 */   // Label 19702: @1387992
     /* 1387992 */   GIM_Try, /*On fail goto*//*Label 19703*/ GIMT_Encode4(1388076), // Rule ID 22525 //
     /* 1387997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1388005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1388014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1388053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388075 */     // GIR_Coverage, 22525,
     /* 1388075 */     GIR_EraseRootFromParent_Done,
     /* 1388076 */   // Label 19703: @1388076
     /* 1388076 */   GIM_Try, /*On fail goto*//*Label 19704*/ GIMT_Encode4(1388160), // Rule ID 22528 //
     /* 1388081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1388089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1388098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388134 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1388137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388159 */     // GIR_Coverage, 22528,
     /* 1388159 */     GIR_EraseRootFromParent_Done,
     /* 1388160 */   // Label 19704: @1388160
     /* 1388160 */   GIM_Try, /*On fail goto*//*Label 19705*/ GIMT_Encode4(1388244), // Rule ID 22529 //
     /* 1388165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1388173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1388182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388218 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1388221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388243 */     // GIR_Coverage, 22529,
     /* 1388243 */     GIR_EraseRootFromParent_Done,
     /* 1388244 */   // Label 19705: @1388244
     /* 1388244 */   GIM_Try, /*On fail goto*//*Label 19706*/ GIMT_Encode4(1388328), // Rule ID 22532 //
     /* 1388249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1388257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1388266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1388305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388327 */     // GIR_Coverage, 22532,
     /* 1388327 */     GIR_EraseRootFromParent_Done,
     /* 1388328 */   // Label 19706: @1388328
     /* 1388328 */   GIM_Try, /*On fail goto*//*Label 19707*/ GIMT_Encode4(1388412), // Rule ID 22533 //
     /* 1388333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1388341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1388350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1388389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388411 */     // GIR_Coverage, 22533,
     /* 1388411 */     GIR_EraseRootFromParent_Done,
     /* 1388412 */   // Label 19707: @1388412
     /* 1388412 */   GIM_Try, /*On fail goto*//*Label 19708*/ GIMT_Encode4(1388496), // Rule ID 22536 //
     /* 1388417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1388425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1388434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388470 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1388473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388495 */     // GIR_Coverage, 22536,
     /* 1388495 */     GIR_EraseRootFromParent_Done,
     /* 1388496 */   // Label 19708: @1388496
     /* 1388496 */   GIM_Try, /*On fail goto*//*Label 19709*/ GIMT_Encode4(1388580), // Rule ID 22537 //
     /* 1388501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1388509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1388518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388554 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1388557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388579 */     // GIR_Coverage, 22537,
     /* 1388579 */     GIR_EraseRootFromParent_Done,
     /* 1388580 */   // Label 19709: @1388580
     /* 1388580 */   GIM_Try, /*On fail goto*//*Label 19710*/ GIMT_Encode4(1388664), // Rule ID 22540 //
     /* 1388585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1388588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1388593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1388602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388638 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1388641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388663 */     // GIR_Coverage, 22540,
     /* 1388663 */     GIR_EraseRootFromParent_Done,
     /* 1388664 */   // Label 19710: @1388664
     /* 1388664 */   GIM_Try, /*On fail goto*//*Label 19711*/ GIMT_Encode4(1388748), // Rule ID 22541 //
     /* 1388669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1388672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1388677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1388686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388722 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1388725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388747 */     // GIR_Coverage, 22541,
     /* 1388747 */     GIR_EraseRootFromParent_Done,
     /* 1388748 */   // Label 19711: @1388748
     /* 1388748 */   GIM_Try, /*On fail goto*//*Label 19712*/ GIMT_Encode4(1388832), // Rule ID 22544 //
     /* 1388753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1388761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1388770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1388776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388806 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1388809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388831 */     // GIR_Coverage, 22544,
     /* 1388831 */     GIR_EraseRootFromParent_Done,
     /* 1388832 */   // Label 19712: @1388832
     /* 1388832 */   GIM_Try, /*On fail goto*//*Label 19713*/ GIMT_Encode4(1388916), // Rule ID 22545 //
     /* 1388837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1388845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1388854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1388860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388890 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1388893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388915 */     // GIR_Coverage, 22545,
     /* 1388915 */     GIR_EraseRootFromParent_Done,
     /* 1388916 */   // Label 19713: @1388916
     /* 1388916 */   GIM_Try, /*On fail goto*//*Label 19714*/ GIMT_Encode4(1389000), // Rule ID 22548 //
     /* 1388921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1388929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1388938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1388944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1388977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388999 */     // GIR_Coverage, 22548,
     /* 1388999 */     GIR_EraseRootFromParent_Done,
     /* 1389000 */   // Label 19714: @1389000
     /* 1389000 */   GIM_Try, /*On fail goto*//*Label 19715*/ GIMT_Encode4(1389084), // Rule ID 22549 //
     /* 1389005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1389013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1389022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389058 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1389061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389083 */     // GIR_Coverage, 22549,
     /* 1389083 */     GIR_EraseRootFromParent_Done,
     /* 1389084 */   // Label 19715: @1389084
     /* 1389084 */   GIM_Try, /*On fail goto*//*Label 19716*/ GIMT_Encode4(1389168), // Rule ID 22552 //
     /* 1389089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1389097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1389106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1389112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389142 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1389145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389167 */     // GIR_Coverage, 22552,
     /* 1389167 */     GIR_EraseRootFromParent_Done,
     /* 1389168 */   // Label 19716: @1389168
     /* 1389168 */   GIM_Try, /*On fail goto*//*Label 19717*/ GIMT_Encode4(1389252), // Rule ID 22553 //
     /* 1389173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1389181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1389190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1389196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1389229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389251 */     // GIR_Coverage, 22553,
     /* 1389251 */     GIR_EraseRootFromParent_Done,
     /* 1389252 */   // Label 19717: @1389252
     /* 1389252 */   GIM_Try, /*On fail goto*//*Label 19718*/ GIMT_Encode4(1389336), // Rule ID 22556 //
     /* 1389257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1389265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1389274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389310 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1389313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389335 */     // GIR_Coverage, 22556,
     /* 1389335 */     GIR_EraseRootFromParent_Done,
     /* 1389336 */   // Label 19718: @1389336
     /* 1389336 */   GIM_Try, /*On fail goto*//*Label 19719*/ GIMT_Encode4(1389420), // Rule ID 22557 //
     /* 1389341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1389349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1389358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389394 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1389397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389419 */     // GIR_Coverage, 22557,
     /* 1389419 */     GIR_EraseRootFromParent_Done,
     /* 1389420 */   // Label 19719: @1389420
     /* 1389420 */   GIM_Try, /*On fail goto*//*Label 19720*/ GIMT_Encode4(1389504), // Rule ID 22560 //
     /* 1389425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1389433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1389442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389478 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1389481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389503 */     // GIR_Coverage, 22560,
     /* 1389503 */     GIR_EraseRootFromParent_Done,
     /* 1389504 */   // Label 19720: @1389504
     /* 1389504 */   GIM_Try, /*On fail goto*//*Label 19721*/ GIMT_Encode4(1389588), // Rule ID 22561 //
     /* 1389509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1389517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1389526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389562 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1389565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389587 */     // GIR_Coverage, 22561,
     /* 1389587 */     GIR_EraseRootFromParent_Done,
     /* 1389588 */   // Label 19721: @1389588
     /* 1389588 */   GIM_Try, /*On fail goto*//*Label 19722*/ GIMT_Encode4(1389672), // Rule ID 22564 //
     /* 1389593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1389601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1389610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1389649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389671 */     // GIR_Coverage, 22564,
     /* 1389671 */     GIR_EraseRootFromParent_Done,
     /* 1389672 */   // Label 19722: @1389672
     /* 1389672 */   GIM_Try, /*On fail goto*//*Label 19723*/ GIMT_Encode4(1389756), // Rule ID 22565 //
     /* 1389677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1389685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1389694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389730 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1389733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389755 */     // GIR_Coverage, 22565,
     /* 1389755 */     GIR_EraseRootFromParent_Done,
     /* 1389756 */   // Label 19723: @1389756
     /* 1389756 */   GIM_Try, /*On fail goto*//*Label 19724*/ GIMT_Encode4(1389840), // Rule ID 22568 //
     /* 1389761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1389769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1389778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1389784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389814 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1389817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389839 */     // GIR_Coverage, 22568,
     /* 1389839 */     GIR_EraseRootFromParent_Done,
     /* 1389840 */   // Label 19724: @1389840
     /* 1389840 */   GIM_Try, /*On fail goto*//*Label 19725*/ GIMT_Encode4(1389924), // Rule ID 22569 //
     /* 1389845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1389853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1389862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1389868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389898 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1389901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389923 */     // GIR_Coverage, 22569,
     /* 1389923 */     GIR_EraseRootFromParent_Done,
     /* 1389924 */   // Label 19725: @1389924
     /* 1389924 */   GIM_Try, /*On fail goto*//*Label 19726*/ GIMT_Encode4(1390008), // Rule ID 22572 //
     /* 1389929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1389937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1389946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389982 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1389985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390007 */     // GIR_Coverage, 22572,
     /* 1390007 */     GIR_EraseRootFromParent_Done,
     /* 1390008 */   // Label 19726: @1390008
     /* 1390008 */   GIM_Try, /*On fail goto*//*Label 19727*/ GIMT_Encode4(1390092), // Rule ID 22573 //
     /* 1390013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1390021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1390030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390066 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1390069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390091 */     // GIR_Coverage, 22573,
     /* 1390091 */     GIR_EraseRootFromParent_Done,
     /* 1390092 */   // Label 19727: @1390092
     /* 1390092 */   GIM_Try, /*On fail goto*//*Label 19728*/ GIMT_Encode4(1390176), // Rule ID 22576 //
     /* 1390097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1390105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1390114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1390120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1390153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390175 */     // GIR_Coverage, 22576,
     /* 1390175 */     GIR_EraseRootFromParent_Done,
     /* 1390176 */   // Label 19728: @1390176
     /* 1390176 */   GIM_Try, /*On fail goto*//*Label 19729*/ GIMT_Encode4(1390260), // Rule ID 22577 //
     /* 1390181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1390189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1390198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1390204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1390237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390259 */     // GIR_Coverage, 22577,
     /* 1390259 */     GIR_EraseRootFromParent_Done,
     /* 1390260 */   // Label 19729: @1390260
     /* 1390260 */   GIM_Try, /*On fail goto*//*Label 19730*/ GIMT_Encode4(1390344), // Rule ID 22580 //
     /* 1390265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1390273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1390282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390318 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1390321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390343 */     // GIR_Coverage, 22580,
     /* 1390343 */     GIR_EraseRootFromParent_Done,
     /* 1390344 */   // Label 19730: @1390344
     /* 1390344 */   GIM_Try, /*On fail goto*//*Label 19731*/ GIMT_Encode4(1390428), // Rule ID 22581 //
     /* 1390349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1390357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1390366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390402 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1390405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390427 */     // GIR_Coverage, 22581,
     /* 1390427 */     GIR_EraseRootFromParent_Done,
     /* 1390428 */   // Label 19731: @1390428
     /* 1390428 */   GIM_Try, /*On fail goto*//*Label 19732*/ GIMT_Encode4(1390512), // Rule ID 22584 //
     /* 1390433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1390441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1390450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390486 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1390489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390511 */     // GIR_Coverage, 22584,
     /* 1390511 */     GIR_EraseRootFromParent_Done,
     /* 1390512 */   // Label 19732: @1390512
     /* 1390512 */   GIM_Try, /*On fail goto*//*Label 19733*/ GIMT_Encode4(1390596), // Rule ID 22585 //
     /* 1390517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1390525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1390534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390570 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1390573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390595 */     // GIR_Coverage, 22585,
     /* 1390595 */     GIR_EraseRootFromParent_Done,
     /* 1390596 */   // Label 19733: @1390596
     /* 1390596 */   GIM_Try, /*On fail goto*//*Label 19734*/ GIMT_Encode4(1390680), // Rule ID 22588 //
     /* 1390601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1390609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1390618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390654 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1390657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390679 */     // GIR_Coverage, 22588,
     /* 1390679 */     GIR_EraseRootFromParent_Done,
     /* 1390680 */   // Label 19734: @1390680
     /* 1390680 */   GIM_Try, /*On fail goto*//*Label 19735*/ GIMT_Encode4(1390764), // Rule ID 22589 //
     /* 1390685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1390693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1390702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390738 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1390741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390763 */     // GIR_Coverage, 22589,
     /* 1390763 */     GIR_EraseRootFromParent_Done,
     /* 1390764 */   // Label 19735: @1390764
     /* 1390764 */   GIM_Try, /*On fail goto*//*Label 19736*/ GIMT_Encode4(1390848), // Rule ID 22592 //
     /* 1390769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1390780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1390783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1390786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1390789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390822 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1390825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390847 */     // GIR_Coverage, 22592,
     /* 1390847 */     GIR_EraseRootFromParent_Done,
     /* 1390848 */   // Label 19736: @1390848
     /* 1390848 */   GIM_Try, /*On fail goto*//*Label 19737*/ GIMT_Encode4(1390932), // Rule ID 22593 //
     /* 1390853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1390864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1390867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1390870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1390873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390906 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1390909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390931 */     // GIR_Coverage, 22593,
     /* 1390931 */     GIR_EraseRootFromParent_Done,
     /* 1390932 */   // Label 19737: @1390932
     /* 1390932 */   GIM_Try, /*On fail goto*//*Label 19738*/ GIMT_Encode4(1391016), // Rule ID 22596 //
     /* 1390937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1390948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1390951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1390954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1390957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390990 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1390993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391015 */     // GIR_Coverage, 22596,
     /* 1391015 */     GIR_EraseRootFromParent_Done,
     /* 1391016 */   // Label 19738: @1391016
     /* 1391016 */   GIM_Try, /*On fail goto*//*Label 19739*/ GIMT_Encode4(1391100), // Rule ID 22597 //
     /* 1391021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1391032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1391035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1391038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1391041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391074 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1391077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391099 */     // GIR_Coverage, 22597,
     /* 1391099 */     GIR_EraseRootFromParent_Done,
     /* 1391100 */   // Label 19739: @1391100
     /* 1391100 */   GIM_Try, /*On fail goto*//*Label 19740*/ GIMT_Encode4(1391184), // Rule ID 22600 //
     /* 1391105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1391116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1391119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1391122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1391125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391158 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1391161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391183 */     // GIR_Coverage, 22600,
     /* 1391183 */     GIR_EraseRootFromParent_Done,
     /* 1391184 */   // Label 19740: @1391184
     /* 1391184 */   GIM_Try, /*On fail goto*//*Label 19741*/ GIMT_Encode4(1391268), // Rule ID 22601 //
     /* 1391189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1391200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1391203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1391206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1391209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391242 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1391245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391267 */     // GIR_Coverage, 22601,
     /* 1391267 */     GIR_EraseRootFromParent_Done,
     /* 1391268 */   // Label 19741: @1391268
     /* 1391268 */   GIM_Try, /*On fail goto*//*Label 19742*/ GIMT_Encode4(1391352), // Rule ID 22604 //
     /* 1391273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1391290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391326 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1391329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391351 */     // GIR_Coverage, 22604,
     /* 1391351 */     GIR_EraseRootFromParent_Done,
     /* 1391352 */   // Label 19742: @1391352
     /* 1391352 */   GIM_Try, /*On fail goto*//*Label 19743*/ GIMT_Encode4(1391436), // Rule ID 22605 //
     /* 1391357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1391374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391410 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1391413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391435 */     // GIR_Coverage, 22605,
     /* 1391435 */     GIR_EraseRootFromParent_Done,
     /* 1391436 */   // Label 19743: @1391436
     /* 1391436 */   GIM_Try, /*On fail goto*//*Label 19744*/ GIMT_Encode4(1391520), // Rule ID 22608 //
     /* 1391441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1391458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391494 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1391497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391519 */     // GIR_Coverage, 22608,
     /* 1391519 */     GIR_EraseRootFromParent_Done,
     /* 1391520 */   // Label 19744: @1391520
     /* 1391520 */   GIM_Try, /*On fail goto*//*Label 19745*/ GIMT_Encode4(1391604), // Rule ID 22609 //
     /* 1391525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1391542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391578 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1391581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391603 */     // GIR_Coverage, 22609,
     /* 1391603 */     GIR_EraseRootFromParent_Done,
     /* 1391604 */   // Label 19745: @1391604
     /* 1391604 */   GIM_Try, /*On fail goto*//*Label 19746*/ GIMT_Encode4(1391688), // Rule ID 22612 //
     /* 1391609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1391626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391662 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1391665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391687 */     // GIR_Coverage, 22612,
     /* 1391687 */     GIR_EraseRootFromParent_Done,
     /* 1391688 */   // Label 19746: @1391688
     /* 1391688 */   GIM_Try, /*On fail goto*//*Label 19747*/ GIMT_Encode4(1391772), // Rule ID 22613 //
     /* 1391693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1391710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391746 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1391749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391771 */     // GIR_Coverage, 22613,
     /* 1391771 */     GIR_EraseRootFromParent_Done,
     /* 1391772 */   // Label 19747: @1391772
     /* 1391772 */   GIM_Try, /*On fail goto*//*Label 19748*/ GIMT_Encode4(1391856), // Rule ID 22616 //
     /* 1391777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1391788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1391791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1391794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1391797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391830 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1391833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391855 */     // GIR_Coverage, 22616,
     /* 1391855 */     GIR_EraseRootFromParent_Done,
     /* 1391856 */   // Label 19748: @1391856
     /* 1391856 */   GIM_Try, /*On fail goto*//*Label 19749*/ GIMT_Encode4(1391940), // Rule ID 22617 //
     /* 1391861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1391872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1391875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1391878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1391881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391914 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1391917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391939 */     // GIR_Coverage, 22617,
     /* 1391939 */     GIR_EraseRootFromParent_Done,
     /* 1391940 */   // Label 19749: @1391940
     /* 1391940 */   GIM_Try, /*On fail goto*//*Label 19750*/ GIMT_Encode4(1392024), // Rule ID 22620 //
     /* 1391945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1391962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391998 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1392001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392023 */     // GIR_Coverage, 22620,
     /* 1392023 */     GIR_EraseRootFromParent_Done,
     /* 1392024 */   // Label 19750: @1392024
     /* 1392024 */   GIM_Try, /*On fail goto*//*Label 19751*/ GIMT_Encode4(1392108), // Rule ID 22621 //
     /* 1392029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1392037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1392046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1392052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392082 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1392085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392107 */     // GIR_Coverage, 22621,
     /* 1392107 */     GIR_EraseRootFromParent_Done,
     /* 1392108 */   // Label 19751: @1392108
     /* 1392108 */   GIM_Try, /*On fail goto*//*Label 19752*/ GIMT_Encode4(1392192), // Rule ID 22624 //
     /* 1392113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1392121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1392130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1392169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392191 */     // GIR_Coverage, 22624,
     /* 1392191 */     GIR_EraseRootFromParent_Done,
     /* 1392192 */   // Label 19752: @1392192
     /* 1392192 */   GIM_Try, /*On fail goto*//*Label 19753*/ GIMT_Encode4(1392276), // Rule ID 22625 //
     /* 1392197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1392205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1392214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1392253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392275 */     // GIR_Coverage, 22625,
     /* 1392275 */     GIR_EraseRootFromParent_Done,
     /* 1392276 */   // Label 19753: @1392276
     /* 1392276 */   GIM_Try, /*On fail goto*//*Label 19754*/ GIMT_Encode4(1392360), // Rule ID 22628 //
     /* 1392281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1392284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1392289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1392298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1392304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392334 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1392337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1392355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392359 */     // GIR_Coverage, 22628,
     /* 1392359 */     GIR_EraseRootFromParent_Done,
     /* 1392360 */   // Label 19754: @1392360
     /* 1392360 */   GIM_Try, /*On fail goto*//*Label 19755*/ GIMT_Encode4(1392444), // Rule ID 22629 //
     /* 1392365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1392368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1392373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1392382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1392388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392418 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1392421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1392439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392443 */     // GIR_Coverage, 22629,
     /* 1392443 */     GIR_EraseRootFromParent_Done,
     /* 1392444 */   // Label 19755: @1392444
     /* 1392444 */   GIM_Try, /*On fail goto*//*Label 19756*/ GIMT_Encode4(1392528), // Rule ID 22632 //
     /* 1392449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1392457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1392460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1392463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1392466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1392469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1392505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392527 */     // GIR_Coverage, 22632,
     /* 1392527 */     GIR_EraseRootFromParent_Done,
     /* 1392528 */   // Label 19756: @1392528
     /* 1392528 */   GIM_Try, /*On fail goto*//*Label 19757*/ GIMT_Encode4(1392612), // Rule ID 22633 //
     /* 1392533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1392541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1392544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1392547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1392550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1392553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392586 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1392589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392611 */     // GIR_Coverage, 22633,
     /* 1392611 */     GIR_EraseRootFromParent_Done,
     /* 1392612 */   // Label 19757: @1392612
     /* 1392612 */   GIM_Try, /*On fail goto*//*Label 19758*/ GIMT_Encode4(1392696), // Rule ID 22636 //
     /* 1392617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1392625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1392628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1392631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1392634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1392637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1392640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392670 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1392673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392695 */     // GIR_Coverage, 22636,
     /* 1392695 */     GIR_EraseRootFromParent_Done,
     /* 1392696 */   // Label 19758: @1392696
     /* 1392696 */   GIM_Try, /*On fail goto*//*Label 19759*/ GIMT_Encode4(1392780), // Rule ID 22637 //
     /* 1392701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1392709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1392712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1392715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1392718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1392721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1392724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392754 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1392757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392779 */     // GIR_Coverage, 22637,
     /* 1392779 */     GIR_EraseRootFromParent_Done,
     /* 1392780 */   // Label 19759: @1392780
     /* 1392780 */   GIM_Try, /*On fail goto*//*Label 19760*/ GIMT_Encode4(1392864), // Rule ID 22640 //
     /* 1392785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1392793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1392796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1392799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1392802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1392805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1392808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392838 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1392841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392863 */     // GIR_Coverage, 22640,
     /* 1392863 */     GIR_EraseRootFromParent_Done,
     /* 1392864 */   // Label 19760: @1392864
     /* 1392864 */   GIM_Try, /*On fail goto*//*Label 19761*/ GIMT_Encode4(1392948), // Rule ID 22641 //
     /* 1392869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1392877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1392880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1392883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1392886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1392889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1392892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392922 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1392925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392947 */     // GIR_Coverage, 22641,
     /* 1392947 */     GIR_EraseRootFromParent_Done,
     /* 1392948 */   // Label 19761: @1392948
     /* 1392948 */   GIM_Try, /*On fail goto*//*Label 19762*/ GIMT_Encode4(1393032), // Rule ID 22644 //
     /* 1392953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1392961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1392970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393006 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1393009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393031 */     // GIR_Coverage, 22644,
     /* 1393031 */     GIR_EraseRootFromParent_Done,
     /* 1393032 */   // Label 19762: @1393032
     /* 1393032 */   GIM_Try, /*On fail goto*//*Label 19763*/ GIMT_Encode4(1393116), // Rule ID 22645 //
     /* 1393037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1393045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1393054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393090 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1393093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393115 */     // GIR_Coverage, 22645,
     /* 1393115 */     GIR_EraseRootFromParent_Done,
     /* 1393116 */   // Label 19763: @1393116
     /* 1393116 */   GIM_Try, /*On fail goto*//*Label 19764*/ GIMT_Encode4(1393200), // Rule ID 22648 //
     /* 1393121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1393129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1393138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1393177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393199 */     // GIR_Coverage, 22648,
     /* 1393199 */     GIR_EraseRootFromParent_Done,
     /* 1393200 */   // Label 19764: @1393200
     /* 1393200 */   GIM_Try, /*On fail goto*//*Label 19765*/ GIMT_Encode4(1393284), // Rule ID 22649 //
     /* 1393205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1393213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1393222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393258 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1393261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393283 */     // GIR_Coverage, 22649,
     /* 1393283 */     GIR_EraseRootFromParent_Done,
     /* 1393284 */   // Label 19765: @1393284
     /* 1393284 */   GIM_Try, /*On fail goto*//*Label 19766*/ GIMT_Encode4(1393368), // Rule ID 22652 //
     /* 1393289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1393297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1393345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393367 */     // GIR_Coverage, 22652,
     /* 1393367 */     GIR_EraseRootFromParent_Done,
     /* 1393368 */   // Label 19766: @1393368
     /* 1393368 */   GIM_Try, /*On fail goto*//*Label 19767*/ GIMT_Encode4(1393452), // Rule ID 22653 //
     /* 1393373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1393381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393426 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1393429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393451 */     // GIR_Coverage, 22653,
     /* 1393451 */     GIR_EraseRootFromParent_Done,
     /* 1393452 */   // Label 19767: @1393452
     /* 1393452 */   GIM_Try, /*On fail goto*//*Label 19768*/ GIMT_Encode4(1393536), // Rule ID 22656 //
     /* 1393457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1393465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1393474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393510 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1393513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393535 */     // GIR_Coverage, 22656,
     /* 1393535 */     GIR_EraseRootFromParent_Done,
     /* 1393536 */   // Label 19768: @1393536
     /* 1393536 */   GIM_Try, /*On fail goto*//*Label 19769*/ GIMT_Encode4(1393620), // Rule ID 22657 //
     /* 1393541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1393549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1393558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393594 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1393597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393619 */     // GIR_Coverage, 22657,
     /* 1393619 */     GIR_EraseRootFromParent_Done,
     /* 1393620 */   // Label 19769: @1393620
     /* 1393620 */   GIM_Try, /*On fail goto*//*Label 19770*/ GIMT_Encode4(1393704), // Rule ID 22660 //
     /* 1393625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1393633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1393642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1393681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393703 */     // GIR_Coverage, 22660,
     /* 1393703 */     GIR_EraseRootFromParent_Done,
     /* 1393704 */   // Label 19770: @1393704
     /* 1393704 */   GIM_Try, /*On fail goto*//*Label 19771*/ GIMT_Encode4(1393788), // Rule ID 22661 //
     /* 1393709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1393717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1393726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393762 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1393765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393787 */     // GIR_Coverage, 22661,
     /* 1393787 */     GIR_EraseRootFromParent_Done,
     /* 1393788 */   // Label 19771: @1393788
     /* 1393788 */   GIM_Try, /*On fail goto*//*Label 19772*/ GIMT_Encode4(1393872), // Rule ID 22664 //
     /* 1393793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1393801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1393810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393846 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1393849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393871 */     // GIR_Coverage, 22664,
     /* 1393871 */     GIR_EraseRootFromParent_Done,
     /* 1393872 */   // Label 19772: @1393872
     /* 1393872 */   GIM_Try, /*On fail goto*//*Label 19773*/ GIMT_Encode4(1393956), // Rule ID 22665 //
     /* 1393877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1393885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1393894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393930 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1393933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393955 */     // GIR_Coverage, 22665,
     /* 1393955 */     GIR_EraseRootFromParent_Done,
     /* 1393956 */   // Label 19773: @1393956
     /* 1393956 */   GIM_Try, /*On fail goto*//*Label 19774*/ GIMT_Encode4(1394040), // Rule ID 22668 //
     /* 1393961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1393964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1393969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1393978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1393984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1394017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1394035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394039 */     // GIR_Coverage, 22668,
     /* 1394039 */     GIR_EraseRootFromParent_Done,
     /* 1394040 */   // Label 19774: @1394040
     /* 1394040 */   GIM_Try, /*On fail goto*//*Label 19775*/ GIMT_Encode4(1394124), // Rule ID 22669 //
     /* 1394045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1394048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1394053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1394062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1394083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394098 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1394101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1394119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394123 */     // GIR_Coverage, 22669,
     /* 1394123 */     GIR_EraseRootFromParent_Done,
     /* 1394124 */   // Label 19775: @1394124
     /* 1394124 */   GIM_Try, /*On fail goto*//*Label 19776*/ GIMT_Encode4(1394208), // Rule ID 22672 //
     /* 1394129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1394132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1394137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1394146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1394167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394182 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1394185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1394203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394207 */     // GIR_Coverage, 22672,
     /* 1394207 */     GIR_EraseRootFromParent_Done,
     /* 1394208 */   // Label 19776: @1394208
     /* 1394208 */   GIM_Try, /*On fail goto*//*Label 19777*/ GIMT_Encode4(1394292), // Rule ID 22673 //
     /* 1394213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1394216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1394221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1394230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1394251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394266 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1394269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1394287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394291 */     // GIR_Coverage, 22673,
     /* 1394291 */     GIR_EraseRootFromParent_Done,
     /* 1394292 */   // Label 19777: @1394292
     /* 1394292 */   GIM_Try, /*On fail goto*//*Label 19778*/ GIMT_Encode4(1394376), // Rule ID 22676 //
     /* 1394297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1394300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1394305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1394314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1394320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1394335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394350 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1394353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1394371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394375 */     // GIR_Coverage, 22676,
     /* 1394375 */     GIR_EraseRootFromParent_Done,
     /* 1394376 */   // Label 19778: @1394376
     /* 1394376 */   GIM_Try, /*On fail goto*//*Label 19779*/ GIMT_Encode4(1394460), // Rule ID 22677 //
     /* 1394381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1394384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1394389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1394398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1394404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1394419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394434 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1394437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1394455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394459 */     // GIR_Coverage, 22677,
     /* 1394459 */     GIR_EraseRootFromParent_Done,
     /* 1394460 */   // Label 19779: @1394460
     /* 1394460 */   GIM_Try, /*On fail goto*//*Label 19780*/ GIMT_Encode4(1394544), // Rule ID 22680 //
     /* 1394465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1394473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1394482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1394521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394543 */     // GIR_Coverage, 22680,
     /* 1394543 */     GIR_EraseRootFromParent_Done,
     /* 1394544 */   // Label 19780: @1394544
     /* 1394544 */   GIM_Try, /*On fail goto*//*Label 19781*/ GIMT_Encode4(1394628), // Rule ID 22681 //
     /* 1394549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1394557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1394566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1394605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394627 */     // GIR_Coverage, 22681,
     /* 1394627 */     GIR_EraseRootFromParent_Done,
     /* 1394628 */   // Label 19781: @1394628
     /* 1394628 */   GIM_Try, /*On fail goto*//*Label 19782*/ GIMT_Encode4(1394712), // Rule ID 22684 //
     /* 1394633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1394641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1394650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394686 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1394689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394711 */     // GIR_Coverage, 22684,
     /* 1394711 */     GIR_EraseRootFromParent_Done,
     /* 1394712 */   // Label 19782: @1394712
     /* 1394712 */   GIM_Try, /*On fail goto*//*Label 19783*/ GIMT_Encode4(1394796), // Rule ID 22685 //
     /* 1394717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1394725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1394734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1394773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394795 */     // GIR_Coverage, 22685,
     /* 1394795 */     GIR_EraseRootFromParent_Done,
     /* 1394796 */   // Label 19783: @1394796
     /* 1394796 */   GIM_Try, /*On fail goto*//*Label 19784*/ GIMT_Encode4(1394880), // Rule ID 22688 //
     /* 1394801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1394809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1394818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394854 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1394857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394879 */     // GIR_Coverage, 22688,
     /* 1394879 */     GIR_EraseRootFromParent_Done,
     /* 1394880 */   // Label 19784: @1394880
     /* 1394880 */   GIM_Try, /*On fail goto*//*Label 19785*/ GIMT_Encode4(1394964), // Rule ID 22689 //
     /* 1394885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1394893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1394902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394938 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1394941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394963 */     // GIR_Coverage, 22689,
     /* 1394963 */     GIR_EraseRootFromParent_Done,
     /* 1394964 */   // Label 19785: @1394964
     /* 1394964 */   GIM_Try, /*On fail goto*//*Label 19786*/ GIMT_Encode4(1395048), // Rule ID 22692 //
     /* 1394969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1394977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1394986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395022 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1395025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395047 */     // GIR_Coverage, 22692,
     /* 1395047 */     GIR_EraseRootFromParent_Done,
     /* 1395048 */   // Label 19786: @1395048
     /* 1395048 */   GIM_Try, /*On fail goto*//*Label 19787*/ GIMT_Encode4(1395132), // Rule ID 22693 //
     /* 1395053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1395061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1395070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1395076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395106 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1395109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395131 */     // GIR_Coverage, 22693,
     /* 1395131 */     GIR_EraseRootFromParent_Done,
     /* 1395132 */   // Label 19787: @1395132
     /* 1395132 */   GIM_Try, /*On fail goto*//*Label 19788*/ GIMT_Encode4(1395216), // Rule ID 22696 //
     /* 1395137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1395145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1395154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1395193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395215 */     // GIR_Coverage, 22696,
     /* 1395215 */     GIR_EraseRootFromParent_Done,
     /* 1395216 */   // Label 19788: @1395216
     /* 1395216 */   GIM_Try, /*On fail goto*//*Label 19789*/ GIMT_Encode4(1395300), // Rule ID 22697 //
     /* 1395221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1395229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1395238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395274 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1395277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395299 */     // GIR_Coverage, 22697,
     /* 1395299 */     GIR_EraseRootFromParent_Done,
     /* 1395300 */   // Label 19789: @1395300
     /* 1395300 */   GIM_Try, /*On fail goto*//*Label 19790*/ GIMT_Encode4(1395384), // Rule ID 22700 //
     /* 1395305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1395313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1395322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1395328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395358 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1395361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395383 */     // GIR_Coverage, 22700,
     /* 1395383 */     GIR_EraseRootFromParent_Done,
     /* 1395384 */   // Label 19790: @1395384
     /* 1395384 */   GIM_Try, /*On fail goto*//*Label 19791*/ GIMT_Encode4(1395468), // Rule ID 22701 //
     /* 1395389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1395397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1395406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1395412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395442 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1395445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395467 */     // GIR_Coverage, 22701,
     /* 1395467 */     GIR_EraseRootFromParent_Done,
     /* 1395468 */   // Label 19791: @1395468
     /* 1395468 */   GIM_Try, /*On fail goto*//*Label 19792*/ GIMT_Encode4(1395552), // Rule ID 22704 //
     /* 1395473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1395481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1395490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395526 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1395529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395551 */     // GIR_Coverage, 22704,
     /* 1395551 */     GIR_EraseRootFromParent_Done,
     /* 1395552 */   // Label 19792: @1395552
     /* 1395552 */   GIM_Try, /*On fail goto*//*Label 19793*/ GIMT_Encode4(1395636), // Rule ID 22705 //
     /* 1395557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1395565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1395574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395610 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1395613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395635 */     // GIR_Coverage, 22705,
     /* 1395635 */     GIR_EraseRootFromParent_Done,
     /* 1395636 */   // Label 19793: @1395636
     /* 1395636 */   GIM_Try, /*On fail goto*//*Label 19794*/ GIMT_Encode4(1395720), // Rule ID 22708 //
     /* 1395641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1395649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1395658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1395664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395694 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1395697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395719 */     // GIR_Coverage, 22708,
     /* 1395719 */     GIR_EraseRootFromParent_Done,
     /* 1395720 */   // Label 19794: @1395720
     /* 1395720 */   GIM_Try, /*On fail goto*//*Label 19795*/ GIMT_Encode4(1395804), // Rule ID 22709 //
     /* 1395725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1395733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1395742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1395748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395778 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1395781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395803 */     // GIR_Coverage, 22709,
     /* 1395803 */     GIR_EraseRootFromParent_Done,
     /* 1395804 */   // Label 19795: @1395804
     /* 1395804 */   GIM_Try, /*On fail goto*//*Label 19796*/ GIMT_Encode4(1395888), // Rule ID 22712 //
     /* 1395809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1395817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395862 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1395865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395887 */     // GIR_Coverage, 22712,
     /* 1395887 */     GIR_EraseRootFromParent_Done,
     /* 1395888 */   // Label 19796: @1395888
     /* 1395888 */   GIM_Try, /*On fail goto*//*Label 19797*/ GIMT_Encode4(1395972), // Rule ID 22713 //
     /* 1395893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1395901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1395949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395971 */     // GIR_Coverage, 22713,
     /* 1395971 */     GIR_EraseRootFromParent_Done,
     /* 1395972 */   // Label 19797: @1395972
     /* 1395972 */   GIM_Try, /*On fail goto*//*Label 19798*/ GIMT_Encode4(1396056), // Rule ID 22716 //
     /* 1395977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1395985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1395994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396030 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1396033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396055 */     // GIR_Coverage, 22716,
     /* 1396055 */     GIR_EraseRootFromParent_Done,
     /* 1396056 */   // Label 19798: @1396056
     /* 1396056 */   GIM_Try, /*On fail goto*//*Label 19799*/ GIMT_Encode4(1396140), // Rule ID 22717 //
     /* 1396061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1396069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1396078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1396117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396139 */     // GIR_Coverage, 22717,
     /* 1396139 */     GIR_EraseRootFromParent_Done,
     /* 1396140 */   // Label 19799: @1396140
     /* 1396140 */   GIM_Try, /*On fail goto*//*Label 19800*/ GIMT_Encode4(1396224), // Rule ID 22720 //
     /* 1396145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1396153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1396162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1396168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396198 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1396201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396223 */     // GIR_Coverage, 22720,
     /* 1396223 */     GIR_EraseRootFromParent_Done,
     /* 1396224 */   // Label 19800: @1396224
     /* 1396224 */   GIM_Try, /*On fail goto*//*Label 19801*/ GIMT_Encode4(1396308), // Rule ID 22721 //
     /* 1396229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1396237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1396246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1396252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396282 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1396285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396307 */     // GIR_Coverage, 22721,
     /* 1396307 */     GIR_EraseRootFromParent_Done,
     /* 1396308 */   // Label 19801: @1396308
     /* 1396308 */   GIM_Try, /*On fail goto*//*Label 19802*/ GIMT_Encode4(1396392), // Rule ID 22724 //
     /* 1396313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1396321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1396330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1396336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1396369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396391 */     // GIR_Coverage, 22724,
     /* 1396391 */     GIR_EraseRootFromParent_Done,
     /* 1396392 */   // Label 19802: @1396392
     /* 1396392 */   GIM_Try, /*On fail goto*//*Label 19803*/ GIMT_Encode4(1396476), // Rule ID 22725 //
     /* 1396397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1396405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1396414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1396420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396450 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1396453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396475 */     // GIR_Coverage, 22725,
     /* 1396475 */     GIR_EraseRootFromParent_Done,
     /* 1396476 */   // Label 19803: @1396476
     /* 1396476 */   GIM_Try, /*On fail goto*//*Label 19804*/ GIMT_Encode4(1396560), // Rule ID 22728 //
     /* 1396481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1396489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1396498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1396537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396559 */     // GIR_Coverage, 22728,
     /* 1396559 */     GIR_EraseRootFromParent_Done,
     /* 1396560 */   // Label 19804: @1396560
     /* 1396560 */   GIM_Try, /*On fail goto*//*Label 19805*/ GIMT_Encode4(1396644), // Rule ID 22729 //
     /* 1396565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1396573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1396582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1396621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396643 */     // GIR_Coverage, 22729,
     /* 1396643 */     GIR_EraseRootFromParent_Done,
     /* 1396644 */   // Label 19805: @1396644
     /* 1396644 */   GIM_Try, /*On fail goto*//*Label 19806*/ GIMT_Encode4(1396728), // Rule ID 22732 //
     /* 1396649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1396657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1396666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1396705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396727 */     // GIR_Coverage, 22732,
     /* 1396727 */     GIR_EraseRootFromParent_Done,
     /* 1396728 */   // Label 19806: @1396728
     /* 1396728 */   GIM_Try, /*On fail goto*//*Label 19807*/ GIMT_Encode4(1396812), // Rule ID 22733 //
     /* 1396733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1396741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1396750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396786 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1396789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396811 */     // GIR_Coverage, 22733,
     /* 1396811 */     GIR_EraseRootFromParent_Done,
     /* 1396812 */   // Label 19807: @1396812
     /* 1396812 */   GIM_Try, /*On fail goto*//*Label 19808*/ GIMT_Encode4(1396896), // Rule ID 22736 //
     /* 1396817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1396825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1396834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1396840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396870 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1396873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396895 */     // GIR_Coverage, 22736,
     /* 1396895 */     GIR_EraseRootFromParent_Done,
     /* 1396896 */   // Label 19808: @1396896
     /* 1396896 */   GIM_Try, /*On fail goto*//*Label 19809*/ GIMT_Encode4(1396980), // Rule ID 22737 //
     /* 1396901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1396909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1396918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1396924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396954 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1396957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396979 */     // GIR_Coverage, 22737,
     /* 1396979 */     GIR_EraseRootFromParent_Done,
     /* 1396980 */   // Label 19809: @1396980
     /* 1396980 */   GIM_Try, /*On fail goto*//*Label 19810*/ GIMT_Encode4(1397064), // Rule ID 22740 //
     /* 1396985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1396993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1397002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1397023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397038 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1397041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397063 */     // GIR_Coverage, 22740,
     /* 1397063 */     GIR_EraseRootFromParent_Done,
     /* 1397064 */   // Label 19810: @1397064
     /* 1397064 */   GIM_Try, /*On fail goto*//*Label 19811*/ GIMT_Encode4(1397148), // Rule ID 22741 //
     /* 1397069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1397077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1397086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1397107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397122 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1397125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397147 */     // GIR_Coverage, 22741,
     /* 1397147 */     GIR_EraseRootFromParent_Done,
     /* 1397148 */   // Label 19811: @1397148
     /* 1397148 */   GIM_Try, /*On fail goto*//*Label 19812*/ GIMT_Encode4(1397232), // Rule ID 22744 //
     /* 1397153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1397156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1397161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1397170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1397176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397206 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1397209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397231 */     // GIR_Coverage, 22744,
     /* 1397231 */     GIR_EraseRootFromParent_Done,
     /* 1397232 */   // Label 19812: @1397232
     /* 1397232 */   GIM_Try, /*On fail goto*//*Label 19813*/ GIMT_Encode4(1397316), // Rule ID 22745 //
     /* 1397237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1397245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1397254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1397260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1397293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397315 */     // GIR_Coverage, 22745,
     /* 1397315 */     GIR_EraseRootFromParent_Done,
     /* 1397316 */   // Label 19813: @1397316
     /* 1397316 */   GIM_Try, /*On fail goto*//*Label 19814*/ GIMT_Encode4(1397400), // Rule ID 22748 //
     /* 1397321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1397324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1397329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1397338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1397344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1397377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397399 */     // GIR_Coverage, 22748,
     /* 1397399 */     GIR_EraseRootFromParent_Done,
     /* 1397400 */   // Label 19814: @1397400
     /* 1397400 */   GIM_Try, /*On fail goto*//*Label 19815*/ GIMT_Encode4(1397484), // Rule ID 22749 //
     /* 1397405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1397413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1397422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1397428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397458 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1397461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397483 */     // GIR_Coverage, 22749,
     /* 1397483 */     GIR_EraseRootFromParent_Done,
     /* 1397484 */   // Label 19815: @1397484
     /* 1397484 */   GIM_Try, /*On fail goto*//*Label 19816*/ GIMT_Encode4(1397568), // Rule ID 22752 //
     /* 1397489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1397492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1397497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1397506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397542 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1397545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1397563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397567 */     // GIR_Coverage, 22752,
     /* 1397567 */     GIR_EraseRootFromParent_Done,
     /* 1397568 */   // Label 19816: @1397568
     /* 1397568 */   GIM_Try, /*On fail goto*//*Label 19817*/ GIMT_Encode4(1397652), // Rule ID 22753 //
     /* 1397573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1397581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1397590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1397629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1397647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397651 */     // GIR_Coverage, 22753,
     /* 1397651 */     GIR_EraseRootFromParent_Done,
     /* 1397652 */   // Label 19817: @1397652
     /* 1397652 */   GIM_Try, /*On fail goto*//*Label 19818*/ GIMT_Encode4(1397736), // Rule ID 22756 //
     /* 1397657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1397660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1397665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1397674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1397713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1397731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397735 */     // GIR_Coverage, 22756,
     /* 1397735 */     GIR_EraseRootFromParent_Done,
     /* 1397736 */   // Label 19818: @1397736
     /* 1397736 */   GIM_Try, /*On fail goto*//*Label 19819*/ GIMT_Encode4(1397820), // Rule ID 22757 //
     /* 1397741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1397749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1397758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397794 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1397797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1397815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397819 */     // GIR_Coverage, 22757,
     /* 1397819 */     GIR_EraseRootFromParent_Done,
     /* 1397820 */   // Label 19819: @1397820
     /* 1397820 */   GIM_Try, /*On fail goto*//*Label 19820*/ GIMT_Encode4(1397904), // Rule ID 22760 //
     /* 1397825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1397828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1397833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1397842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397878 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1397881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1397899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397903 */     // GIR_Coverage, 22760,
     /* 1397903 */     GIR_EraseRootFromParent_Done,
     /* 1397904 */   // Label 19820: @1397904
     /* 1397904 */   GIM_Try, /*On fail goto*//*Label 19821*/ GIMT_Encode4(1397988), // Rule ID 22761 //
     /* 1397909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1397917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1397926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397962 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1397965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1397983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397987 */     // GIR_Coverage, 22761,
     /* 1397987 */     GIR_EraseRootFromParent_Done,
     /* 1397988 */   // Label 19821: @1397988
     /* 1397988 */   GIM_Try, /*On fail goto*//*Label 19822*/ GIMT_Encode4(1398072), // Rule ID 22764 //
     /* 1397993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1397996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1398001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1398010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1398016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398046 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1398049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398071 */     // GIR_Coverage, 22764,
     /* 1398071 */     GIR_EraseRootFromParent_Done,
     /* 1398072 */   // Label 19822: @1398072
     /* 1398072 */   GIM_Try, /*On fail goto*//*Label 19823*/ GIMT_Encode4(1398156), // Rule ID 22765 //
     /* 1398077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1398080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1398085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1398094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1398100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1398133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398155 */     // GIR_Coverage, 22765,
     /* 1398155 */     GIR_EraseRootFromParent_Done,
     /* 1398156 */   // Label 19823: @1398156
     /* 1398156 */   GIM_Try, /*On fail goto*//*Label 19824*/ GIMT_Encode4(1398240), // Rule ID 22768 //
     /* 1398161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1398164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1398169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1398178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1398184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398214 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1398217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398239 */     // GIR_Coverage, 22768,
     /* 1398239 */     GIR_EraseRootFromParent_Done,
     /* 1398240 */   // Label 19824: @1398240
     /* 1398240 */   GIM_Try, /*On fail goto*//*Label 19825*/ GIMT_Encode4(1398324), // Rule ID 22769 //
     /* 1398245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1398248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1398253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1398262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1398268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398298 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1398301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398323 */     // GIR_Coverage, 22769,
     /* 1398323 */     GIR_EraseRootFromParent_Done,
     /* 1398324 */   // Label 19825: @1398324
     /* 1398324 */   GIM_Try, /*On fail goto*//*Label 19826*/ GIMT_Encode4(1398408), // Rule ID 22772 //
     /* 1398329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1398332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1398337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1398346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1398352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398382 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1398385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398407 */     // GIR_Coverage, 22772,
     /* 1398407 */     GIR_EraseRootFromParent_Done,
     /* 1398408 */   // Label 19826: @1398408
     /* 1398408 */   GIM_Try, /*On fail goto*//*Label 19827*/ GIMT_Encode4(1398492), // Rule ID 22773 //
     /* 1398413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1398416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1398421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1398430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1398436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398466 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1398469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398491 */     // GIR_Coverage, 22773,
     /* 1398491 */     GIR_EraseRootFromParent_Done,
     /* 1398492 */   // Label 19827: @1398492
     /* 1398492 */   GIM_Try, /*On fail goto*//*Label 19828*/ GIMT_Encode4(1398576), // Rule ID 22776 //
     /* 1398497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1398500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1398505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1398514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398550 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1398553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1398571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398575 */     // GIR_Coverage, 22776,
     /* 1398575 */     GIR_EraseRootFromParent_Done,
     /* 1398576 */   // Label 19828: @1398576
     /* 1398576 */   GIM_Try, /*On fail goto*//*Label 19829*/ GIMT_Encode4(1398660), // Rule ID 22777 //
     /* 1398581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1398584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1398589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1398598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398634 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1398637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1398655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398659 */     // GIR_Coverage, 22777,
     /* 1398659 */     GIR_EraseRootFromParent_Done,
     /* 1398660 */   // Label 19829: @1398660
     /* 1398660 */   GIM_Try, /*On fail goto*//*Label 19830*/ GIMT_Encode4(1398744), // Rule ID 22780 //
     /* 1398665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1398668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1398673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1398682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1398721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398743 */     // GIR_Coverage, 22780,
     /* 1398743 */     GIR_EraseRootFromParent_Done,
     /* 1398744 */   // Label 19830: @1398744
     /* 1398744 */   GIM_Try, /*On fail goto*//*Label 19831*/ GIMT_Encode4(1398828), // Rule ID 22781 //
     /* 1398749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1398752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1398757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1398766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1398805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398827 */     // GIR_Coverage, 22781,
     /* 1398827 */     GIR_EraseRootFromParent_Done,
     /* 1398828 */   // Label 19831: @1398828
     /* 1398828 */   GIM_Try, /*On fail goto*//*Label 19832*/ GIMT_Encode4(1398912), // Rule ID 22784 //
     /* 1398833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1398836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1398841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1398850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1398856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398886 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1398889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398911 */     // GIR_Coverage, 22784,
     /* 1398911 */     GIR_EraseRootFromParent_Done,
     /* 1398912 */   // Label 19832: @1398912
     /* 1398912 */   GIM_Try, /*On fail goto*//*Label 19833*/ GIMT_Encode4(1398996), // Rule ID 22785 //
     /* 1398917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1398920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1398925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1398934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1398940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398970 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1398973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398995 */     // GIR_Coverage, 22785,
     /* 1398995 */     GIR_EraseRootFromParent_Done,
     /* 1398996 */   // Label 19833: @1398996
     /* 1398996 */   GIM_Try, /*On fail goto*//*Label 19834*/ GIMT_Encode4(1399080), // Rule ID 22788 //
     /* 1399001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1399004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1399009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1399018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1399024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399054 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1399057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1399075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399079 */     // GIR_Coverage, 22788,
     /* 1399079 */     GIR_EraseRootFromParent_Done,
     /* 1399080 */   // Label 19834: @1399080
     /* 1399080 */   GIM_Try, /*On fail goto*//*Label 19835*/ GIMT_Encode4(1399164), // Rule ID 22789 //
     /* 1399085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1399088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1399093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1399102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1399108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399138 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1399141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1399159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399163 */     // GIR_Coverage, 22789,
     /* 1399163 */     GIR_EraseRootFromParent_Done,
     /* 1399164 */   // Label 19835: @1399164
     /* 1399164 */   GIM_Try, /*On fail goto*//*Label 19836*/ GIMT_Encode4(1399248), // Rule ID 22792 //
     /* 1399169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1399172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1399177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1399186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1399192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399222 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1399225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1399243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399247 */     // GIR_Coverage, 22792,
     /* 1399247 */     GIR_EraseRootFromParent_Done,
     /* 1399248 */   // Label 19836: @1399248
     /* 1399248 */   GIM_Try, /*On fail goto*//*Label 19837*/ GIMT_Encode4(1399332), // Rule ID 22793 //
     /* 1399253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1399256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1399261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1399270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1399276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399306 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1399309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1399327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399331 */     // GIR_Coverage, 22793,
     /* 1399331 */     GIR_EraseRootFromParent_Done,
     /* 1399332 */   // Label 19837: @1399332
     /* 1399332 */   GIM_Try, /*On fail goto*//*Label 19838*/ GIMT_Encode4(1399416), // Rule ID 22796 //
     /* 1399337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1399340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1399345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1399354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1399360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1399393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1399411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399415 */     // GIR_Coverage, 22796,
     /* 1399415 */     GIR_EraseRootFromParent_Done,
     /* 1399416 */   // Label 19838: @1399416
     /* 1399416 */   GIM_Try, /*On fail goto*//*Label 19839*/ GIMT_Encode4(1399500), // Rule ID 22797 //
     /* 1399421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1399424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1399429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1399438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1399444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399474 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1399477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1399495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399499 */     // GIR_Coverage, 22797,
     /* 1399499 */     GIR_EraseRootFromParent_Done,
     /* 1399500 */   // Label 19839: @1399500
     /* 1399500 */   GIM_Try, /*On fail goto*//*Label 19840*/ GIMT_Encode4(1399584), // Rule ID 22800 //
     /* 1399505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1399508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1399513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1399522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1399561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399583 */     // GIR_Coverage, 22800,
     /* 1399583 */     GIR_EraseRootFromParent_Done,
     /* 1399584 */   // Label 19840: @1399584
     /* 1399584 */   GIM_Try, /*On fail goto*//*Label 19841*/ GIMT_Encode4(1399668), // Rule ID 22801 //
     /* 1399589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1399592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1399597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1399606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399642 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1399645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399667 */     // GIR_Coverage, 22801,
     /* 1399667 */     GIR_EraseRootFromParent_Done,
     /* 1399668 */   // Label 19841: @1399668
     /* 1399668 */   GIM_Try, /*On fail goto*//*Label 19842*/ GIMT_Encode4(1399752), // Rule ID 22804 //
     /* 1399673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1399676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1399681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1399690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1399696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1399729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399751 */     // GIR_Coverage, 22804,
     /* 1399751 */     GIR_EraseRootFromParent_Done,
     /* 1399752 */   // Label 19842: @1399752
     /* 1399752 */   GIM_Try, /*On fail goto*//*Label 19843*/ GIMT_Encode4(1399836), // Rule ID 22805 //
     /* 1399757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1399760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1399765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1399774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1399780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1399813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399835 */     // GIR_Coverage, 22805,
     /* 1399835 */     GIR_EraseRootFromParent_Done,
     /* 1399836 */   // Label 19843: @1399836
     /* 1399836 */   GIM_Try, /*On fail goto*//*Label 19844*/ GIMT_Encode4(1399920), // Rule ID 22808 //
     /* 1399841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1399844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1399849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1399858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1399864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399894 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1399897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399919 */     // GIR_Coverage, 22808,
     /* 1399919 */     GIR_EraseRootFromParent_Done,
     /* 1399920 */   // Label 19844: @1399920
     /* 1399920 */   GIM_Try, /*On fail goto*//*Label 19845*/ GIMT_Encode4(1400004), // Rule ID 22809 //
     /* 1399925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1399928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1399933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1399942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1399948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399978 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1399981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400003 */     // GIR_Coverage, 22809,
     /* 1400003 */     GIR_EraseRootFromParent_Done,
     /* 1400004 */   // Label 19845: @1400004
     /* 1400004 */   GIM_Try, /*On fail goto*//*Label 19846*/ GIMT_Encode4(1400088), // Rule ID 22812 //
     /* 1400009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1400012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1400017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1400026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400062 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1400065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400087 */     // GIR_Coverage, 22812,
     /* 1400087 */     GIR_EraseRootFromParent_Done,
     /* 1400088 */   // Label 19846: @1400088
     /* 1400088 */   GIM_Try, /*On fail goto*//*Label 19847*/ GIMT_Encode4(1400172), // Rule ID 22813 //
     /* 1400093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1400096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1400101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1400110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400146 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1400149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400171 */     // GIR_Coverage, 22813,
     /* 1400171 */     GIR_EraseRootFromParent_Done,
     /* 1400172 */   // Label 19847: @1400172
     /* 1400172 */   GIM_Try, /*On fail goto*//*Label 19848*/ GIMT_Encode4(1400256), // Rule ID 22816 //
     /* 1400177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1400180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1400185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1400194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400230 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1400233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400255 */     // GIR_Coverage, 22816,
     /* 1400255 */     GIR_EraseRootFromParent_Done,
     /* 1400256 */   // Label 19848: @1400256
     /* 1400256 */   GIM_Try, /*On fail goto*//*Label 19849*/ GIMT_Encode4(1400340), // Rule ID 22817 //
     /* 1400261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1400264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1400269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1400278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400314 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1400317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400339 */     // GIR_Coverage, 22817,
     /* 1400339 */     GIR_EraseRootFromParent_Done,
     /* 1400340 */   // Label 19849: @1400340
     /* 1400340 */   GIM_Try, /*On fail goto*//*Label 19850*/ GIMT_Encode4(1400424), // Rule ID 22820 //
     /* 1400345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1400348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1400353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1400362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1400368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400398 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1400401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400423 */     // GIR_Coverage, 22820,
     /* 1400423 */     GIR_EraseRootFromParent_Done,
     /* 1400424 */   // Label 19850: @1400424
     /* 1400424 */   GIM_Try, /*On fail goto*//*Label 19851*/ GIMT_Encode4(1400508), // Rule ID 22821 //
     /* 1400429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1400432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1400437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1400446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1400452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1400485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400507 */     // GIR_Coverage, 22821,
     /* 1400507 */     GIR_EraseRootFromParent_Done,
     /* 1400508 */   // Label 19851: @1400508
     /* 1400508 */   GIM_Try, /*On fail goto*//*Label 19852*/ GIMT_Encode4(1400592), // Rule ID 22940 //
     /* 1400513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1400521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1400530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400566 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1400569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400591 */     // GIR_Coverage, 22940,
     /* 1400591 */     GIR_EraseRootFromParent_Done,
     /* 1400592 */   // Label 19852: @1400592
     /* 1400592 */   GIM_Try, /*On fail goto*//*Label 19853*/ GIMT_Encode4(1400676), // Rule ID 22941 //
     /* 1400597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1400605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1400614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400650 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1400653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400675 */     // GIR_Coverage, 22941,
     /* 1400675 */     GIR_EraseRootFromParent_Done,
     /* 1400676 */   // Label 19853: @1400676
     /* 1400676 */   GIM_Try, /*On fail goto*//*Label 19854*/ GIMT_Encode4(1400760), // Rule ID 22944 //
     /* 1400681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1400689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1400698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1400704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400734 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1400737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400759 */     // GIR_Coverage, 22944,
     /* 1400759 */     GIR_EraseRootFromParent_Done,
     /* 1400760 */   // Label 19854: @1400760
     /* 1400760 */   GIM_Try, /*On fail goto*//*Label 19855*/ GIMT_Encode4(1400844), // Rule ID 22945 //
     /* 1400765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1400773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1400782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1400788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400818 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1400821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400843 */     // GIR_Coverage, 22945,
     /* 1400843 */     GIR_EraseRootFromParent_Done,
     /* 1400844 */   // Label 19855: @1400844
     /* 1400844 */   GIM_Try, /*On fail goto*//*Label 19856*/ GIMT_Encode4(1400928), // Rule ID 22948 //
     /* 1400849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1400852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1400857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1400866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400902 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1400905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400927 */     // GIR_Coverage, 22948,
     /* 1400927 */     GIR_EraseRootFromParent_Done,
     /* 1400928 */   // Label 19856: @1400928
     /* 1400928 */   GIM_Try, /*On fail goto*//*Label 19857*/ GIMT_Encode4(1401012), // Rule ID 22949 //
     /* 1400933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1400936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1400941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1400950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400986 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1400989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401011 */     // GIR_Coverage, 22949,
     /* 1401011 */     GIR_EraseRootFromParent_Done,
     /* 1401012 */   // Label 19857: @1401012
     /* 1401012 */   GIM_Try, /*On fail goto*//*Label 19858*/ GIMT_Encode4(1401096), // Rule ID 22952 //
     /* 1401017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1401020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1401025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1401034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401070 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1401073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401095 */     // GIR_Coverage, 22952,
     /* 1401095 */     GIR_EraseRootFromParent_Done,
     /* 1401096 */   // Label 19858: @1401096
     /* 1401096 */   GIM_Try, /*On fail goto*//*Label 19859*/ GIMT_Encode4(1401180), // Rule ID 22953 //
     /* 1401101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1401104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1401109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1401118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401154 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1401157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401179 */     // GIR_Coverage, 22953,
     /* 1401179 */     GIR_EraseRootFromParent_Done,
     /* 1401180 */   // Label 19859: @1401180
     /* 1401180 */   GIM_Try, /*On fail goto*//*Label 19860*/ GIMT_Encode4(1401264), // Rule ID 22956 //
     /* 1401185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1401188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1401193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1401202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1401208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401238 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1401241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401263 */     // GIR_Coverage, 22956,
     /* 1401263 */     GIR_EraseRootFromParent_Done,
     /* 1401264 */   // Label 19860: @1401264
     /* 1401264 */   GIM_Try, /*On fail goto*//*Label 19861*/ GIMT_Encode4(1401348), // Rule ID 22957 //
     /* 1401269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1401272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1401277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1401286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1401292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401322 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1401325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401347 */     // GIR_Coverage, 22957,
     /* 1401347 */     GIR_EraseRootFromParent_Done,
     /* 1401348 */   // Label 19861: @1401348
     /* 1401348 */   GIM_Try, /*On fail goto*//*Label 19862*/ GIMT_Encode4(1401432), // Rule ID 22960 //
     /* 1401353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1401356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1401361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1401370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1401376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401406 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1401409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401431 */     // GIR_Coverage, 22960,
     /* 1401431 */     GIR_EraseRootFromParent_Done,
     /* 1401432 */   // Label 19862: @1401432
     /* 1401432 */   GIM_Try, /*On fail goto*//*Label 19863*/ GIMT_Encode4(1401516), // Rule ID 22961 //
     /* 1401437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1401440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1401445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1401454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1401460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1401493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401515 */     // GIR_Coverage, 22961,
     /* 1401515 */     GIR_EraseRootFromParent_Done,
     /* 1401516 */   // Label 19863: @1401516
     /* 1401516 */   GIM_Try, /*On fail goto*//*Label 19864*/ GIMT_Encode4(1401600), // Rule ID 22964 //
     /* 1401521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1401524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1401529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1401538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1401544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401574 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1401577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401599 */     // GIR_Coverage, 22964,
     /* 1401599 */     GIR_EraseRootFromParent_Done,
     /* 1401600 */   // Label 19864: @1401600
     /* 1401600 */   GIM_Try, /*On fail goto*//*Label 19865*/ GIMT_Encode4(1401684), // Rule ID 22965 //
     /* 1401605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1401608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1401613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1401622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1401628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401658 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1401661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401683 */     // GIR_Coverage, 22965,
     /* 1401683 */     GIR_EraseRootFromParent_Done,
     /* 1401684 */   // Label 19865: @1401684
     /* 1401684 */   GIM_Try, /*On fail goto*//*Label 19866*/ GIMT_Encode4(1401768), // Rule ID 22968 //
     /* 1401689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1401692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1401697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1401706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1401712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401742 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1401745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401767 */     // GIR_Coverage, 22968,
     /* 1401767 */     GIR_EraseRootFromParent_Done,
     /* 1401768 */   // Label 19866: @1401768
     /* 1401768 */   GIM_Try, /*On fail goto*//*Label 19867*/ GIMT_Encode4(1401852), // Rule ID 22969 //
     /* 1401773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1401776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1401781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1401790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1401796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401826 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1401829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401851 */     // GIR_Coverage, 22969,
     /* 1401851 */     GIR_EraseRootFromParent_Done,
     /* 1401852 */   // Label 19867: @1401852
     /* 1401852 */   GIM_Try, /*On fail goto*//*Label 19868*/ GIMT_Encode4(1401936), // Rule ID 22972 //
     /* 1401857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1401860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1401865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1401874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1401880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401910 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1401913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401935 */     // GIR_Coverage, 22972,
     /* 1401935 */     GIR_EraseRootFromParent_Done,
     /* 1401936 */   // Label 19868: @1401936
     /* 1401936 */   GIM_Try, /*On fail goto*//*Label 19869*/ GIMT_Encode4(1402020), // Rule ID 22973 //
     /* 1401941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1401944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1401949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1401958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1401964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401994 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1401997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402019 */     // GIR_Coverage, 22973,
     /* 1402019 */     GIR_EraseRootFromParent_Done,
     /* 1402020 */   // Label 19869: @1402020
     /* 1402020 */   GIM_Try, /*On fail goto*//*Label 19870*/ GIMT_Encode4(1402104), // Rule ID 22976 //
     /* 1402025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1402028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1402033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1402036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1402039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1402042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1402045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402078 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1402078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1402081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402103 */     // GIR_Coverage, 22976,
     /* 1402103 */     GIR_EraseRootFromParent_Done,
     /* 1402104 */   // Label 19870: @1402104
     /* 1402104 */   GIM_Try, /*On fail goto*//*Label 19871*/ GIMT_Encode4(1402188), // Rule ID 22977 //
     /* 1402109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1402112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1402117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1402120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1402123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1402126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1402129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402162 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1402162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1402165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402187 */     // GIR_Coverage, 22977,
     /* 1402187 */     GIR_EraseRootFromParent_Done,
     /* 1402188 */   // Label 19871: @1402188
     /* 1402188 */   GIM_Try, /*On fail goto*//*Label 19872*/ GIMT_Encode4(1402272), // Rule ID 22980 //
     /* 1402193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1402196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1402201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1402204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1402207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1402210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1402213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402246 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1402246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1402249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402271 */     // GIR_Coverage, 22980,
     /* 1402271 */     GIR_EraseRootFromParent_Done,
     /* 1402272 */   // Label 19872: @1402272
     /* 1402272 */   GIM_Try, /*On fail goto*//*Label 19873*/ GIMT_Encode4(1402356), // Rule ID 22981 //
     /* 1402277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1402280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1402285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1402288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1402291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1402294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1402297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402330 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1402330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1402333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402355 */     // GIR_Coverage, 22981,
     /* 1402355 */     GIR_EraseRootFromParent_Done,
     /* 1402356 */   // Label 19873: @1402356
     /* 1402356 */   GIM_Try, /*On fail goto*//*Label 19874*/ GIMT_Encode4(1402440), // Rule ID 22984 //
     /* 1402361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1402364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1402369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1402372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1402375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1402378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1402381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1402384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402414 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1402414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1402417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402439 */     // GIR_Coverage, 22984,
     /* 1402439 */     GIR_EraseRootFromParent_Done,
     /* 1402440 */   // Label 19874: @1402440
     /* 1402440 */   GIM_Try, /*On fail goto*//*Label 19875*/ GIMT_Encode4(1402524), // Rule ID 22985 //
     /* 1402445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1402448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1402453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1402456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1402459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1402462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1402465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1402468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402498 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1402498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1402501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402523 */     // GIR_Coverage, 22985,
     /* 1402523 */     GIR_EraseRootFromParent_Done,
     /* 1402524 */   // Label 19875: @1402524
     /* 1402524 */   GIM_Try, /*On fail goto*//*Label 19876*/ GIMT_Encode4(1402608), // Rule ID 22988 //
     /* 1402529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1402532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1402537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1402540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1402543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1402546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1402549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402582 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1402582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1402585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402607 */     // GIR_Coverage, 22988,
     /* 1402607 */     GIR_EraseRootFromParent_Done,
     /* 1402608 */   // Label 19876: @1402608
     /* 1402608 */   GIM_Try, /*On fail goto*//*Label 19877*/ GIMT_Encode4(1402692), // Rule ID 22989 //
     /* 1402613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1402616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1402621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1402624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1402627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1402630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1402633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402666 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1402666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1402669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402691 */     // GIR_Coverage, 22989,
     /* 1402691 */     GIR_EraseRootFromParent_Done,
     /* 1402692 */   // Label 19877: @1402692
     /* 1402692 */   GIM_Try, /*On fail goto*//*Label 19878*/ GIMT_Encode4(1402776), // Rule ID 22992 //
     /* 1402697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1402700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1402705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1402708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1402711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1402714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1402717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402750 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1402750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1402753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402775 */     // GIR_Coverage, 22992,
     /* 1402775 */     GIR_EraseRootFromParent_Done,
     /* 1402776 */   // Label 19878: @1402776
     /* 1402776 */   GIM_Try, /*On fail goto*//*Label 19879*/ GIMT_Encode4(1402860), // Rule ID 22993 //
     /* 1402781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1402784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1402789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1402792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1402795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1402798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1402801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402834 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1402834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1402837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402859 */     // GIR_Coverage, 22993,
     /* 1402859 */     GIR_EraseRootFromParent_Done,
     /* 1402860 */   // Label 19879: @1402860
     /* 1402860 */   GIM_Try, /*On fail goto*//*Label 19880*/ GIMT_Encode4(1402944), // Rule ID 22996 //
     /* 1402865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1402868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1402873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1402876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1402879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1402882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1402885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402918 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1402918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1402921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402943 */     // GIR_Coverage, 22996,
     /* 1402943 */     GIR_EraseRootFromParent_Done,
     /* 1402944 */   // Label 19880: @1402944
     /* 1402944 */   GIM_Try, /*On fail goto*//*Label 19881*/ GIMT_Encode4(1403028), // Rule ID 22997 //
     /* 1402949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1402952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1402957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1402960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1402963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1402966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1402969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403002 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1403002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1403005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1403026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403027 */     // GIR_Coverage, 22997,
     /* 1403027 */     GIR_EraseRootFromParent_Done,
     /* 1403028 */   // Label 19881: @1403028
     /* 1403028 */   GIM_Try, /*On fail goto*//*Label 19882*/ GIMT_Encode4(1403112), // Rule ID 23000 //
     /* 1403033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1403036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1403041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1403050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1403053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403086 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1403086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1403089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1403110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403111 */     // GIR_Coverage, 23000,
     /* 1403111 */     GIR_EraseRootFromParent_Done,
     /* 1403112 */   // Label 19882: @1403112
     /* 1403112 */   GIM_Try, /*On fail goto*//*Label 19883*/ GIMT_Encode4(1403196), // Rule ID 23001 //
     /* 1403117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1403120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1403125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1403134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1403137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403170 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1403170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1403173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1403194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403195 */     // GIR_Coverage, 23001,
     /* 1403195 */     GIR_EraseRootFromParent_Done,
     /* 1403196 */   // Label 19883: @1403196
     /* 1403196 */   GIM_Try, /*On fail goto*//*Label 19884*/ GIMT_Encode4(1403280), // Rule ID 23004 //
     /* 1403201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1403204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1403209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1403218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1403221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1403224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403254 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1403254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1403257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1403278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403279 */     // GIR_Coverage, 23004,
     /* 1403279 */     GIR_EraseRootFromParent_Done,
     /* 1403280 */   // Label 19884: @1403280
     /* 1403280 */   GIM_Try, /*On fail goto*//*Label 19885*/ GIMT_Encode4(1403364), // Rule ID 23005 //
     /* 1403285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1403288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1403293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1403302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1403305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1403308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403338 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1403338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1403341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1403362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403363 */     // GIR_Coverage, 23005,
     /* 1403363 */     GIR_EraseRootFromParent_Done,
     /* 1403364 */   // Label 19885: @1403364
     /* 1403364 */   GIM_Try, /*On fail goto*//*Label 19886*/ GIMT_Encode4(1403448), // Rule ID 23008 //
     /* 1403369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1403372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1403377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1403380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1403383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1403386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1403389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403422 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1403422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1403425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1403446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403447 */     // GIR_Coverage, 23008,
     /* 1403447 */     GIR_EraseRootFromParent_Done,
     /* 1403448 */   // Label 19886: @1403448
     /* 1403448 */   GIM_Try, /*On fail goto*//*Label 19887*/ GIMT_Encode4(1403532), // Rule ID 23009 //
     /* 1403453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1403456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1403461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1403464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1403467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1403470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1403473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403506 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1403506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1403509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1403530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403531 */     // GIR_Coverage, 23009,
     /* 1403531 */     GIR_EraseRootFromParent_Done,
     /* 1403532 */   // Label 19887: @1403532
     /* 1403532 */   GIM_Try, /*On fail goto*//*Label 19888*/ GIMT_Encode4(1403616), // Rule ID 23012 //
     /* 1403537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1403540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1403545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1403554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1403557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1403560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403590 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1403590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1403593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1403614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403615 */     // GIR_Coverage, 23012,
     /* 1403615 */     GIR_EraseRootFromParent_Done,
     /* 1403616 */   // Label 19888: @1403616
     /* 1403616 */   GIM_Try, /*On fail goto*//*Label 19889*/ GIMT_Encode4(1403700), // Rule ID 23013 //
     /* 1403621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1403624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1403629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1403638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1403641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1403644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403674 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1403674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1403677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1403698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403699 */     // GIR_Coverage, 23013,
     /* 1403699 */     GIR_EraseRootFromParent_Done,
     /* 1403700 */   // Label 19889: @1403700
     /* 1403700 */   GIM_Try, /*On fail goto*//*Label 19890*/ GIMT_Encode4(1403784), // Rule ID 23016 //
     /* 1403705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1403708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1403713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1403716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1403719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1403722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1403725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1403728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403758 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1403758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1403761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1403782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403783 */     // GIR_Coverage, 23016,
     /* 1403783 */     GIR_EraseRootFromParent_Done,
     /* 1403784 */   // Label 19890: @1403784
     /* 1403784 */   GIM_Try, /*On fail goto*//*Label 19891*/ GIMT_Encode4(1403868), // Rule ID 23017 //
     /* 1403789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1403792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1403797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1403800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1403803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1403806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1403809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1403812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403842 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1403842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1403845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1403866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403867 */     // GIR_Coverage, 23017,
     /* 1403867 */     GIR_EraseRootFromParent_Done,
     /* 1403868 */   // Label 19891: @1403868
     /* 1403868 */   GIM_Try, /*On fail goto*//*Label 19892*/ GIMT_Encode4(1403952), // Rule ID 23020 //
     /* 1403873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1403876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1403881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1403884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1403887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1403890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1403893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403926 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1403926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1403929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1403933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1403937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1403950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403951 */     // GIR_Coverage, 23020,
     /* 1403951 */     GIR_EraseRootFromParent_Done,
     /* 1403952 */   // Label 19892: @1403952
     /* 1403952 */   GIM_Try, /*On fail goto*//*Label 19893*/ GIMT_Encode4(1404036), // Rule ID 23021 //
     /* 1403957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1403960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1403965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1403968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1403971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1403974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1403977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404010 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1404010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1404013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1404031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1404034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404035 */     // GIR_Coverage, 23021,
     /* 1404035 */     GIR_EraseRootFromParent_Done,
     /* 1404036 */   // Label 19893: @1404036
     /* 1404036 */   GIM_Try, /*On fail goto*//*Label 19894*/ GIMT_Encode4(1404120), // Rule ID 23024 //
     /* 1404041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1404044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1404049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1404052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1404055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1404058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1404061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404094 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1404094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1404097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1404118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404119 */     // GIR_Coverage, 23024,
     /* 1404119 */     GIR_EraseRootFromParent_Done,
     /* 1404120 */   // Label 19894: @1404120
     /* 1404120 */   GIM_Try, /*On fail goto*//*Label 19895*/ GIMT_Encode4(1404204), // Rule ID 23025 //
     /* 1404125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1404128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1404133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1404136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1404139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1404142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1404145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404178 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1404178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1404181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1404202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404203 */     // GIR_Coverage, 23025,
     /* 1404203 */     GIR_EraseRootFromParent_Done,
     /* 1404204 */   // Label 19895: @1404204
     /* 1404204 */   GIM_Try, /*On fail goto*//*Label 19896*/ GIMT_Encode4(1404288), // Rule ID 23028 //
     /* 1404209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1404212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1404217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1404220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1404223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1404226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1404229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404262 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1404262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1404265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1404286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404287 */     // GIR_Coverage, 23028,
     /* 1404287 */     GIR_EraseRootFromParent_Done,
     /* 1404288 */   // Label 19896: @1404288
     /* 1404288 */   GIM_Try, /*On fail goto*//*Label 19897*/ GIMT_Encode4(1404372), // Rule ID 23029 //
     /* 1404293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1404296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1404301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1404304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1404307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1404310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1404313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404346 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1404346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1404349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1404370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404371 */     // GIR_Coverage, 23029,
     /* 1404371 */     GIR_EraseRootFromParent_Done,
     /* 1404372 */   // Label 19897: @1404372
     /* 1404372 */   GIM_Try, /*On fail goto*//*Label 19898*/ GIMT_Encode4(1404456), // Rule ID 23032 //
     /* 1404377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1404380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1404385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1404388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1404391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1404394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1404397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404430 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1404430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1404433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1404454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404455 */     // GIR_Coverage, 23032,
     /* 1404455 */     GIR_EraseRootFromParent_Done,
     /* 1404456 */   // Label 19898: @1404456
     /* 1404456 */   GIM_Try, /*On fail goto*//*Label 19899*/ GIMT_Encode4(1404540), // Rule ID 23033 //
     /* 1404461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1404464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1404469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1404472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1404475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1404478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1404481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404514 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1404514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1404517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1404538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404539 */     // GIR_Coverage, 23033,
     /* 1404539 */     GIR_EraseRootFromParent_Done,
     /* 1404540 */   // Label 19899: @1404540
     /* 1404540 */   GIM_Try, /*On fail goto*//*Label 19900*/ GIMT_Encode4(1404624), // Rule ID 23036 //
     /* 1404545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1404548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1404553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1404556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1404559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1404562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1404565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1404568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404598 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1404598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1404601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1404622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404623 */     // GIR_Coverage, 23036,
     /* 1404623 */     GIR_EraseRootFromParent_Done,
     /* 1404624 */   // Label 19900: @1404624
     /* 1404624 */   GIM_Try, /*On fail goto*//*Label 19901*/ GIMT_Encode4(1404708), // Rule ID 23037 //
     /* 1404629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1404632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1404637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1404640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1404643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1404646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1404649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1404652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404682 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1404682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1404685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1404706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404707 */     // GIR_Coverage, 23037,
     /* 1404707 */     GIR_EraseRootFromParent_Done,
     /* 1404708 */   // Label 19901: @1404708
     /* 1404708 */   GIM_Try, /*On fail goto*//*Label 19902*/ GIMT_Encode4(1404792), // Rule ID 23040 //
     /* 1404713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1404716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1404721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1404724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1404727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1404730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1404733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404766 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1404766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1404769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1404790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404791 */     // GIR_Coverage, 23040,
     /* 1404791 */     GIR_EraseRootFromParent_Done,
     /* 1404792 */   // Label 19902: @1404792
     /* 1404792 */   GIM_Try, /*On fail goto*//*Label 19903*/ GIMT_Encode4(1404876), // Rule ID 23041 //
     /* 1404797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1404800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1404805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1404808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1404811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1404814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1404817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404850 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1404850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1404853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1404874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404875 */     // GIR_Coverage, 23041,
     /* 1404875 */     GIR_EraseRootFromParent_Done,
     /* 1404876 */   // Label 19903: @1404876
     /* 1404876 */   GIM_Try, /*On fail goto*//*Label 19904*/ GIMT_Encode4(1404960), // Rule ID 23044 //
     /* 1404881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1404884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1404889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1404892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1404895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1404898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1404901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404934 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1404934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1404937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1404941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1404945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1404958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404959 */     // GIR_Coverage, 23044,
     /* 1404959 */     GIR_EraseRootFromParent_Done,
     /* 1404960 */   // Label 19904: @1404960
     /* 1404960 */   GIM_Try, /*On fail goto*//*Label 19905*/ GIMT_Encode4(1405044), // Rule ID 23045 //
     /* 1404965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1404968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1404973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1404976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1404979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1404982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1404985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405018 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1405018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1405021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1405042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405043 */     // GIR_Coverage, 23045,
     /* 1405043 */     GIR_EraseRootFromParent_Done,
     /* 1405044 */   // Label 19905: @1405044
     /* 1405044 */   GIM_Try, /*On fail goto*//*Label 19906*/ GIMT_Encode4(1405128), // Rule ID 23048 //
     /* 1405049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1405052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1405057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1405060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1405063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1405066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1405069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1405072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405102 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1405102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1405105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1405126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405127 */     // GIR_Coverage, 23048,
     /* 1405127 */     GIR_EraseRootFromParent_Done,
     /* 1405128 */   // Label 19906: @1405128
     /* 1405128 */   GIM_Try, /*On fail goto*//*Label 19907*/ GIMT_Encode4(1405212), // Rule ID 23049 //
     /* 1405133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1405136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1405141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1405144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1405147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1405150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1405153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1405156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405186 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1405186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1405189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1405210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405211 */     // GIR_Coverage, 23049,
     /* 1405211 */     GIR_EraseRootFromParent_Done,
     /* 1405212 */   // Label 19907: @1405212
     /* 1405212 */   GIM_Try, /*On fail goto*//*Label 19908*/ GIMT_Encode4(1405296), // Rule ID 23052 //
     /* 1405217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1405220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1405225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1405228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1405231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1405234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1405237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1405240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405270 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1405270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1405273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1405294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405295 */     // GIR_Coverage, 23052,
     /* 1405295 */     GIR_EraseRootFromParent_Done,
     /* 1405296 */   // Label 19908: @1405296
     /* 1405296 */   GIM_Try, /*On fail goto*//*Label 19909*/ GIMT_Encode4(1405380), // Rule ID 23053 //
     /* 1405301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1405304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1405309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1405312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1405315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1405318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1405321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1405324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405354 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1405354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1405357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1405378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405379 */     // GIR_Coverage, 23053,
     /* 1405379 */     GIR_EraseRootFromParent_Done,
     /* 1405380 */   // Label 19909: @1405380
     /* 1405380 */   GIM_Try, /*On fail goto*//*Label 19910*/ GIMT_Encode4(1405464), // Rule ID 23056 //
     /* 1405385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1405388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1405393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1405396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1405399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1405402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1405405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405438 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1405438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1405441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1405462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405463 */     // GIR_Coverage, 23056,
     /* 1405463 */     GIR_EraseRootFromParent_Done,
     /* 1405464 */   // Label 19910: @1405464
     /* 1405464 */   GIM_Try, /*On fail goto*//*Label 19911*/ GIMT_Encode4(1405548), // Rule ID 23057 //
     /* 1405469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1405472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1405477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1405480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1405483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1405486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1405489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405522 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1405522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1405525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1405529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1405533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1405546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405547 */     // GIR_Coverage, 23057,
     /* 1405547 */     GIR_EraseRootFromParent_Done,
     /* 1405548 */   // Label 19911: @1405548
     /* 1405548 */   GIM_Reject,
     /* 1405549 */ // Label 13853: @1405549
     /* 1405549 */ GIM_Try, /*On fail goto*//*Label 19912*/ GIMT_Encode4(2019350),
     /* 1405554 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 1405557 */   GIM_Try, /*On fail goto*//*Label 19913*/ GIMT_Encode4(1405643), // Rule ID 7350 //
     /* 1405562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1405565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1405573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1405576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1405579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1405585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405608 */     // MIs[0] policy
     /* 1405608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405618 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1405621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1405639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405642 */     // GIR_Coverage, 7350,
     /* 1405642 */     GIR_EraseRootFromParent_Done,
     /* 1405643 */   // Label 19913: @1405643
     /* 1405643 */   GIM_Try, /*On fail goto*//*Label 19914*/ GIMT_Encode4(1405729), // Rule ID 7351 //
     /* 1405648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1405651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1405659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1405662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1405665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1405671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405694 */     // MIs[0] policy
     /* 1405694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405704 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1405707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1405725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405728 */     // GIR_Coverage, 7351,
     /* 1405728 */     GIR_EraseRootFromParent_Done,
     /* 1405729 */   // Label 19914: @1405729
     /* 1405729 */   GIM_Try, /*On fail goto*//*Label 19915*/ GIMT_Encode4(1405815), // Rule ID 7354 //
     /* 1405734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1405737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1405745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1405748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1405751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1405757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405780 */     // MIs[0] policy
     /* 1405780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405790 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1405793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1405811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405814 */     // GIR_Coverage, 7354,
     /* 1405814 */     GIR_EraseRootFromParent_Done,
     /* 1405815 */   // Label 19915: @1405815
     /* 1405815 */   GIM_Try, /*On fail goto*//*Label 19916*/ GIMT_Encode4(1405901), // Rule ID 7355 //
     /* 1405820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1405823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1405831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1405834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1405837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1405843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405866 */     // MIs[0] policy
     /* 1405866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405876 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1405879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1405897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405900 */     // GIR_Coverage, 7355,
     /* 1405900 */     GIR_EraseRootFromParent_Done,
     /* 1405901 */   // Label 19916: @1405901
     /* 1405901 */   GIM_Try, /*On fail goto*//*Label 19917*/ GIMT_Encode4(1405987), // Rule ID 7358 //
     /* 1405906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1405909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1405917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1405920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1405923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1405929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405952 */     // MIs[0] policy
     /* 1405952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405962 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1405965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1405983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405986 */     // GIR_Coverage, 7358,
     /* 1405986 */     GIR_EraseRootFromParent_Done,
     /* 1405987 */   // Label 19917: @1405987
     /* 1405987 */   GIM_Try, /*On fail goto*//*Label 19918*/ GIMT_Encode4(1406073), // Rule ID 7359 //
     /* 1405992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1405995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1406000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1406003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1406006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1406009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1406012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1406015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1406034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406038 */     // MIs[0] policy
     /* 1406038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406048 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1406051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1406061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1406069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406072 */     // GIR_Coverage, 7359,
     /* 1406072 */     GIR_EraseRootFromParent_Done,
     /* 1406073 */   // Label 19918: @1406073
     /* 1406073 */   GIM_Try, /*On fail goto*//*Label 19919*/ GIMT_Encode4(1406159), // Rule ID 7362 //
     /* 1406078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1406081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1406086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1406089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1406092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1406095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1406098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1406101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1406120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406124 */     // MIs[0] policy
     /* 1406124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406134 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1406137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1406147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406158 */     // GIR_Coverage, 7362,
     /* 1406158 */     GIR_EraseRootFromParent_Done,
     /* 1406159 */   // Label 19919: @1406159
     /* 1406159 */   GIM_Try, /*On fail goto*//*Label 19920*/ GIMT_Encode4(1406245), // Rule ID 7363 //
     /* 1406164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1406167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1406172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1406175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1406178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1406181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1406184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1406187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1406206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406210 */     // MIs[0] policy
     /* 1406210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406220 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1406223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1406233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406244 */     // GIR_Coverage, 7363,
     /* 1406244 */     GIR_EraseRootFromParent_Done,
     /* 1406245 */   // Label 19920: @1406245
     /* 1406245 */   GIM_Try, /*On fail goto*//*Label 19921*/ GIMT_Encode4(1406331), // Rule ID 7366 //
     /* 1406250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1406253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1406258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1406261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1406264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1406267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1406270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1406273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1406292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406296 */     // MIs[0] policy
     /* 1406296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406306 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1406309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1406319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406330 */     // GIR_Coverage, 7366,
     /* 1406330 */     GIR_EraseRootFromParent_Done,
     /* 1406331 */   // Label 19921: @1406331
     /* 1406331 */   GIM_Try, /*On fail goto*//*Label 19922*/ GIMT_Encode4(1406417), // Rule ID 7367 //
     /* 1406336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1406339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1406344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1406347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1406350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1406353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1406356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1406359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1406378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406382 */     // MIs[0] policy
     /* 1406382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406392 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1406395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1406405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406416 */     // GIR_Coverage, 7367,
     /* 1406416 */     GIR_EraseRootFromParent_Done,
     /* 1406417 */   // Label 19922: @1406417
     /* 1406417 */   GIM_Try, /*On fail goto*//*Label 19923*/ GIMT_Encode4(1406503), // Rule ID 7370 //
     /* 1406422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1406425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1406430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1406433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1406436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1406439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1406442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1406445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1406464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406468 */     // MIs[0] policy
     /* 1406468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1406481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1406491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406502 */     // GIR_Coverage, 7370,
     /* 1406502 */     GIR_EraseRootFromParent_Done,
     /* 1406503 */   // Label 19923: @1406503
     /* 1406503 */   GIM_Try, /*On fail goto*//*Label 19924*/ GIMT_Encode4(1406589), // Rule ID 7371 //
     /* 1406508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1406511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1406516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1406519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1406522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1406525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1406528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1406531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1406550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406554 */     // MIs[0] policy
     /* 1406554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406564 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1406567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1406577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406588 */     // GIR_Coverage, 7371,
     /* 1406588 */     GIR_EraseRootFromParent_Done,
     /* 1406589 */   // Label 19924: @1406589
     /* 1406589 */   GIM_Try, /*On fail goto*//*Label 19925*/ GIMT_Encode4(1406675), // Rule ID 7374 //
     /* 1406594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1406597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1406602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1406605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1406608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1406611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1406614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1406617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1406636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406640 */     // MIs[0] policy
     /* 1406640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406650 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1406653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1406663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1406671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406674 */     // GIR_Coverage, 7374,
     /* 1406674 */     GIR_EraseRootFromParent_Done,
     /* 1406675 */   // Label 19925: @1406675
     /* 1406675 */   GIM_Try, /*On fail goto*//*Label 19926*/ GIMT_Encode4(1406761), // Rule ID 7375 //
     /* 1406680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1406683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1406688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1406691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1406694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1406697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1406700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1406703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1406722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406726 */     // MIs[0] policy
     /* 1406726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406736 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1406739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1406749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1406757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406760 */     // GIR_Coverage, 7375,
     /* 1406760 */     GIR_EraseRootFromParent_Done,
     /* 1406761 */   // Label 19926: @1406761
     /* 1406761 */   GIM_Try, /*On fail goto*//*Label 19927*/ GIMT_Encode4(1406847), // Rule ID 7378 //
     /* 1406766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1406769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1406774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1406786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1406789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1406808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406812 */     // MIs[0] policy
     /* 1406812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406822 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1406825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1406835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406846 */     // GIR_Coverage, 7378,
     /* 1406846 */     GIR_EraseRootFromParent_Done,
     /* 1406847 */   // Label 19927: @1406847
     /* 1406847 */   GIM_Try, /*On fail goto*//*Label 19928*/ GIMT_Encode4(1406933), // Rule ID 7379 //
     /* 1406852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1406855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1406860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1406872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1406875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1406894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406898 */     // MIs[0] policy
     /* 1406898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406908 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1406911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1406919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1406921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406932 */     // GIR_Coverage, 7379,
     /* 1406932 */     GIR_EraseRootFromParent_Done,
     /* 1406933 */   // Label 19928: @1406933
     /* 1406933 */   GIM_Try, /*On fail goto*//*Label 19929*/ GIMT_Encode4(1407019), // Rule ID 7382 //
     /* 1406938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1406941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1406946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1406958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1406961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1406980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406984 */     // MIs[0] policy
     /* 1406984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406994 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1406997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1407007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407018 */     // GIR_Coverage, 7382,
     /* 1407018 */     GIR_EraseRootFromParent_Done,
     /* 1407019 */   // Label 19929: @1407019
     /* 1407019 */   GIM_Try, /*On fail goto*//*Label 19930*/ GIMT_Encode4(1407105), // Rule ID 7383 //
     /* 1407024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1407027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1407032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1407035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1407038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1407041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1407044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1407047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1407054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1407066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407070 */     // MIs[0] policy
     /* 1407070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407080 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1407083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1407093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407104 */     // GIR_Coverage, 7383,
     /* 1407104 */     GIR_EraseRootFromParent_Done,
     /* 1407105 */   // Label 19930: @1407105
     /* 1407105 */   GIM_Try, /*On fail goto*//*Label 19931*/ GIMT_Encode4(1407191), // Rule ID 7386 //
     /* 1407110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1407113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1407118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1407121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1407124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1407127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1407130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1407133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1407140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1407152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407156 */     // MIs[0] policy
     /* 1407156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407166 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1407169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1407179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407190 */     // GIR_Coverage, 7386,
     /* 1407190 */     GIR_EraseRootFromParent_Done,
     /* 1407191 */   // Label 19931: @1407191
     /* 1407191 */   GIM_Try, /*On fail goto*//*Label 19932*/ GIMT_Encode4(1407277), // Rule ID 7387 //
     /* 1407196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1407199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1407204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1407207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1407210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1407213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1407216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1407219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1407226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1407238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407242 */     // MIs[0] policy
     /* 1407242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1407255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1407265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407276 */     // GIR_Coverage, 7387,
     /* 1407276 */     GIR_EraseRootFromParent_Done,
     /* 1407277 */   // Label 19932: @1407277
     /* 1407277 */   GIM_Try, /*On fail goto*//*Label 19933*/ GIMT_Encode4(1407363), // Rule ID 7390 //
     /* 1407282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1407285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1407290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1407293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1407296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1407299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1407302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1407305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1407324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407328 */     // MIs[0] policy
     /* 1407328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407338 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1407341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1407351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1407359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407362 */     // GIR_Coverage, 7390,
     /* 1407362 */     GIR_EraseRootFromParent_Done,
     /* 1407363 */   // Label 19933: @1407363
     /* 1407363 */   GIM_Try, /*On fail goto*//*Label 19934*/ GIMT_Encode4(1407449), // Rule ID 7391 //
     /* 1407368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1407371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1407376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1407379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1407382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1407385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1407388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1407391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1407410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407414 */     // MIs[0] policy
     /* 1407414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407424 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1407427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1407437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1407445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407448 */     // GIR_Coverage, 7391,
     /* 1407448 */     GIR_EraseRootFromParent_Done,
     /* 1407449 */   // Label 19934: @1407449
     /* 1407449 */   GIM_Try, /*On fail goto*//*Label 19935*/ GIMT_Encode4(1407535), // Rule ID 7394 //
     /* 1407454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1407457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1407462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1407465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1407468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1407471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1407474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1407477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1407496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407500 */     // MIs[0] policy
     /* 1407500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407510 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1407513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1407523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1407531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407534 */     // GIR_Coverage, 7394,
     /* 1407534 */     GIR_EraseRootFromParent_Done,
     /* 1407535 */   // Label 19935: @1407535
     /* 1407535 */   GIM_Try, /*On fail goto*//*Label 19936*/ GIMT_Encode4(1407621), // Rule ID 7395 //
     /* 1407540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1407543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1407548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1407551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1407554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1407557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1407560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1407563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1407582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407586 */     // MIs[0] policy
     /* 1407586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407596 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1407599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1407609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1407617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407620 */     // GIR_Coverage, 7395,
     /* 1407620 */     GIR_EraseRootFromParent_Done,
     /* 1407621 */   // Label 19936: @1407621
     /* 1407621 */   GIM_Try, /*On fail goto*//*Label 19937*/ GIMT_Encode4(1407707), // Rule ID 7398 //
     /* 1407626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1407629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1407634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1407637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1407640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1407643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1407646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1407649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1407668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407672 */     // MIs[0] policy
     /* 1407672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407682 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1407685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1407695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1407703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407706 */     // GIR_Coverage, 7398,
     /* 1407706 */     GIR_EraseRootFromParent_Done,
     /* 1407707 */   // Label 19937: @1407707
     /* 1407707 */   GIM_Try, /*On fail goto*//*Label 19938*/ GIMT_Encode4(1407793), // Rule ID 7399 //
     /* 1407712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1407715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1407720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1407723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1407726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1407729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1407732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1407735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1407754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407758 */     // MIs[0] policy
     /* 1407758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407768 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1407771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1407781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1407789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407792 */     // GIR_Coverage, 7399,
     /* 1407792 */     GIR_EraseRootFromParent_Done,
     /* 1407793 */   // Label 19938: @1407793
     /* 1407793 */   GIM_Try, /*On fail goto*//*Label 19939*/ GIMT_Encode4(1407879), // Rule ID 7402 //
     /* 1407798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1407801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1407806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1407809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1407812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1407815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1407818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1407821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1407840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407844 */     // MIs[0] policy
     /* 1407844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407854 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1407857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1407867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407878 */     // GIR_Coverage, 7402,
     /* 1407878 */     GIR_EraseRootFromParent_Done,
     /* 1407879 */   // Label 19939: @1407879
     /* 1407879 */   GIM_Try, /*On fail goto*//*Label 19940*/ GIMT_Encode4(1407965), // Rule ID 7403 //
     /* 1407884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1407887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1407892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1407895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1407898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1407901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1407904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1407907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1407926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407930 */     // MIs[0] policy
     /* 1407930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407940 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1407943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1407951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1407953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407964 */     // GIR_Coverage, 7403,
     /* 1407964 */     GIR_EraseRootFromParent_Done,
     /* 1407965 */   // Label 19940: @1407965
     /* 1407965 */   GIM_Try, /*On fail goto*//*Label 19941*/ GIMT_Encode4(1408051), // Rule ID 7406 //
     /* 1407970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1407973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1407978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1407981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1407984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1407987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1407990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1407993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1408000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1408012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408016 */     // MIs[0] policy
     /* 1408016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1408029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1408039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408050 */     // GIR_Coverage, 7406,
     /* 1408050 */     GIR_EraseRootFromParent_Done,
     /* 1408051 */   // Label 19941: @1408051
     /* 1408051 */   GIM_Try, /*On fail goto*//*Label 19942*/ GIMT_Encode4(1408137), // Rule ID 7407 //
     /* 1408056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1408059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1408064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1408067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1408070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1408073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1408076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1408079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1408086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1408098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408102 */     // MIs[0] policy
     /* 1408102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408112 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1408115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1408125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408136 */     // GIR_Coverage, 7407,
     /* 1408136 */     GIR_EraseRootFromParent_Done,
     /* 1408137 */   // Label 19942: @1408137
     /* 1408137 */   GIM_Try, /*On fail goto*//*Label 19943*/ GIMT_Encode4(1408223), // Rule ID 7410 //
     /* 1408142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1408145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1408150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1408153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1408156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1408159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1408162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1408165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1408184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408188 */     // MIs[0] policy
     /* 1408188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408198 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1408201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1408211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408222 */     // GIR_Coverage, 7410,
     /* 1408222 */     GIR_EraseRootFromParent_Done,
     /* 1408223 */   // Label 19943: @1408223
     /* 1408223 */   GIM_Try, /*On fail goto*//*Label 19944*/ GIMT_Encode4(1408309), // Rule ID 7411 //
     /* 1408228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1408231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1408236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1408239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1408242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1408245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1408248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1408251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1408270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408274 */     // MIs[0] policy
     /* 1408274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408284 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1408287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1408297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408308 */     // GIR_Coverage, 7411,
     /* 1408308 */     GIR_EraseRootFromParent_Done,
     /* 1408309 */   // Label 19944: @1408309
     /* 1408309 */   GIM_Try, /*On fail goto*//*Label 19945*/ GIMT_Encode4(1408395), // Rule ID 7414 //
     /* 1408314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1408317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1408322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1408325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1408328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1408331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1408334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1408337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1408356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408360 */     // MIs[0] policy
     /* 1408360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408370 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1408373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1408383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408394 */     // GIR_Coverage, 7414,
     /* 1408394 */     GIR_EraseRootFromParent_Done,
     /* 1408395 */   // Label 19945: @1408395
     /* 1408395 */   GIM_Try, /*On fail goto*//*Label 19946*/ GIMT_Encode4(1408481), // Rule ID 7415 //
     /* 1408400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1408403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1408408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1408411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1408414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1408417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1408420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1408423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1408442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408446 */     // MIs[0] policy
     /* 1408446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408456 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1408459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1408469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408480 */     // GIR_Coverage, 7415,
     /* 1408480 */     GIR_EraseRootFromParent_Done,
     /* 1408481 */   // Label 19946: @1408481
     /* 1408481 */   GIM_Try, /*On fail goto*//*Label 19947*/ GIMT_Encode4(1408567), // Rule ID 7418 //
     /* 1408486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1408489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1408494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1408497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1408500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1408503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1408506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1408509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1408516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1408528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408532 */     // MIs[0] policy
     /* 1408532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408542 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1408545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1408555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408566 */     // GIR_Coverage, 7418,
     /* 1408566 */     GIR_EraseRootFromParent_Done,
     /* 1408567 */   // Label 19947: @1408567
     /* 1408567 */   GIM_Try, /*On fail goto*//*Label 19948*/ GIMT_Encode4(1408653), // Rule ID 7419 //
     /* 1408572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1408575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1408580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1408583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1408586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1408589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1408592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1408595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1408602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1408614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408618 */     // MIs[0] policy
     /* 1408618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408628 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1408631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1408641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408652 */     // GIR_Coverage, 7419,
     /* 1408652 */     GIR_EraseRootFromParent_Done,
     /* 1408653 */   // Label 19948: @1408653
     /* 1408653 */   GIM_Try, /*On fail goto*//*Label 19949*/ GIMT_Encode4(1408739), // Rule ID 7422 //
     /* 1408658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1408661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1408666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1408669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1408672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1408675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1408678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1408681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1408700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408704 */     // MIs[0] policy
     /* 1408704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408714 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1408717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1408727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408738 */     // GIR_Coverage, 7422,
     /* 1408738 */     GIR_EraseRootFromParent_Done,
     /* 1408739 */   // Label 19949: @1408739
     /* 1408739 */   GIM_Try, /*On fail goto*//*Label 19950*/ GIMT_Encode4(1408825), // Rule ID 7423 //
     /* 1408744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1408747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1408752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1408755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1408758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1408761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1408764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1408767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1408786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408790 */     // MIs[0] policy
     /* 1408790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408800 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1408803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1408813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408824 */     // GIR_Coverage, 7423,
     /* 1408824 */     GIR_EraseRootFromParent_Done,
     /* 1408825 */   // Label 19950: @1408825
     /* 1408825 */   GIM_Try, /*On fail goto*//*Label 19951*/ GIMT_Encode4(1408911), // Rule ID 7426 //
     /* 1408830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1408833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1408838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1408841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1408844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1408847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1408850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1408853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1408872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408876 */     // MIs[0] policy
     /* 1408876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1408889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1408899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408910 */     // GIR_Coverage, 7426,
     /* 1408910 */     GIR_EraseRootFromParent_Done,
     /* 1408911 */   // Label 19951: @1408911
     /* 1408911 */   GIM_Try, /*On fail goto*//*Label 19952*/ GIMT_Encode4(1408997), // Rule ID 7427 //
     /* 1408916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1408919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1408924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1408927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1408930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1408933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1408936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1408939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1408958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408962 */     // MIs[0] policy
     /* 1408962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408972 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1408975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1408983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1408985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408996 */     // GIR_Coverage, 7427,
     /* 1408996 */     GIR_EraseRootFromParent_Done,
     /* 1408997 */   // Label 19952: @1408997
     /* 1408997 */   GIM_Try, /*On fail goto*//*Label 19953*/ GIMT_Encode4(1409083), // Rule ID 7430 //
     /* 1409002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1409005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1409010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1409013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1409016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1409019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1409022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1409025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1409044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409048 */     // MIs[0] policy
     /* 1409048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409058 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1409061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1409071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409082 */     // GIR_Coverage, 7430,
     /* 1409082 */     GIR_EraseRootFromParent_Done,
     /* 1409083 */   // Label 19953: @1409083
     /* 1409083 */   GIM_Try, /*On fail goto*//*Label 19954*/ GIMT_Encode4(1409169), // Rule ID 7431 //
     /* 1409088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1409091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1409096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1409099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1409102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1409105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1409108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1409111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1409130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409134 */     // MIs[0] policy
     /* 1409134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409144 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1409147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1409157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409168 */     // GIR_Coverage, 7431,
     /* 1409168 */     GIR_EraseRootFromParent_Done,
     /* 1409169 */   // Label 19954: @1409169
     /* 1409169 */   GIM_Try, /*On fail goto*//*Label 19955*/ GIMT_Encode4(1409255), // Rule ID 7434 //
     /* 1409174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1409177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1409182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1409185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1409188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1409191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1409194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1409197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1409204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1409216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409220 */     // MIs[0] policy
     /* 1409220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409230 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1409233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1409243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409254 */     // GIR_Coverage, 7434,
     /* 1409254 */     GIR_EraseRootFromParent_Done,
     /* 1409255 */   // Label 19955: @1409255
     /* 1409255 */   GIM_Try, /*On fail goto*//*Label 19956*/ GIMT_Encode4(1409341), // Rule ID 7435 //
     /* 1409260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1409263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1409268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1409271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1409274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1409277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1409280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1409283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1409290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1409302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409306 */     // MIs[0] policy
     /* 1409306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409316 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1409319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1409327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1409329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409340 */     // GIR_Coverage, 7435,
     /* 1409340 */     GIR_EraseRootFromParent_Done,
     /* 1409341 */   // Label 19956: @1409341
     /* 1409341 */   GIM_Try, /*On fail goto*//*Label 19957*/ GIMT_Encode4(1409429), // Rule ID 2740 //
     /* 1409346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1409354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1409357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1409360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1409363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409385 */     // MIs[0] Operand 5
     /* 1409385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409396 */     // MIs[0] policy
     /* 1409396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409406 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1409409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409428 */     // GIR_Coverage, 2740,
     /* 1409428 */     GIR_EraseRootFromParent_Done,
     /* 1409429 */   // Label 19957: @1409429
     /* 1409429 */   GIM_Try, /*On fail goto*//*Label 19958*/ GIMT_Encode4(1409517), // Rule ID 2741 //
     /* 1409434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1409442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1409445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1409448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1409451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409473 */     // MIs[0] Operand 5
     /* 1409473 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409484 */     // MIs[0] policy
     /* 1409484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1409497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409516 */     // GIR_Coverage, 2741,
     /* 1409516 */     GIR_EraseRootFromParent_Done,
     /* 1409517 */   // Label 19958: @1409517
     /* 1409517 */   GIM_Try, /*On fail goto*//*Label 19959*/ GIMT_Encode4(1409605), // Rule ID 20632 //
     /* 1409522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1409530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1409533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1409536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1409539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1409542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409561 */     // MIs[0] Operand 5
     /* 1409561 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409572 */     // MIs[0] policy
     /* 1409572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409582 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1409585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409604 */     // GIR_Coverage, 20632,
     /* 1409604 */     GIR_EraseRootFromParent_Done,
     /* 1409605 */   // Label 19959: @1409605
     /* 1409605 */   GIM_Try, /*On fail goto*//*Label 19960*/ GIMT_Encode4(1409693), // Rule ID 20633 //
     /* 1409610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1409618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1409621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1409624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1409627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1409630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409649 */     // MIs[0] Operand 5
     /* 1409649 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409660 */     // MIs[0] policy
     /* 1409660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409670 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1409673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409692 */     // GIR_Coverage, 20633,
     /* 1409692 */     GIR_EraseRootFromParent_Done,
     /* 1409693 */   // Label 19960: @1409693
     /* 1409693 */   GIM_Try, /*On fail goto*//*Label 19961*/ GIMT_Encode4(1409781), // Rule ID 20636 //
     /* 1409698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1409701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1409706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1409709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1409712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1409715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409737 */     // MIs[0] Operand 5
     /* 1409737 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409748 */     // MIs[0] policy
     /* 1409748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409758 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1409761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409780 */     // GIR_Coverage, 20636,
     /* 1409780 */     GIR_EraseRootFromParent_Done,
     /* 1409781 */   // Label 19961: @1409781
     /* 1409781 */   GIM_Try, /*On fail goto*//*Label 19962*/ GIMT_Encode4(1409869), // Rule ID 20637 //
     /* 1409786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1409789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1409794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1409797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1409800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1409803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409825 */     // MIs[0] Operand 5
     /* 1409825 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409836 */     // MIs[0] policy
     /* 1409836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1409849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409868 */     // GIR_Coverage, 20637,
     /* 1409868 */     GIR_EraseRootFromParent_Done,
     /* 1409869 */   // Label 19962: @1409869
     /* 1409869 */   GIM_Try, /*On fail goto*//*Label 19963*/ GIMT_Encode4(1409957), // Rule ID 20640 //
     /* 1409874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1409882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1409885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1409888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1409891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409913 */     // MIs[0] Operand 5
     /* 1409913 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409924 */     // MIs[0] policy
     /* 1409924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409934 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1409937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409956 */     // GIR_Coverage, 20640,
     /* 1409956 */     GIR_EraseRootFromParent_Done,
     /* 1409957 */   // Label 19963: @1409957
     /* 1409957 */   GIM_Try, /*On fail goto*//*Label 19964*/ GIMT_Encode4(1410045), // Rule ID 20641 //
     /* 1409962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1409970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1409973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1409976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1409979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410001 */     // MIs[0] Operand 5
     /* 1410001 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410012 */     // MIs[0] policy
     /* 1410012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410022 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1410025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410044 */     // GIR_Coverage, 20641,
     /* 1410044 */     GIR_EraseRootFromParent_Done,
     /* 1410045 */   // Label 19964: @1410045
     /* 1410045 */   GIM_Try, /*On fail goto*//*Label 19965*/ GIMT_Encode4(1410133), // Rule ID 20644 //
     /* 1410050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1410053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1410058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1410061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1410064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1410067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410089 */     // MIs[0] Operand 5
     /* 1410089 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410100 */     // MIs[0] policy
     /* 1410100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410110 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1410113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410132 */     // GIR_Coverage, 20644,
     /* 1410132 */     GIR_EraseRootFromParent_Done,
     /* 1410133 */   // Label 19965: @1410133
     /* 1410133 */   GIM_Try, /*On fail goto*//*Label 19966*/ GIMT_Encode4(1410221), // Rule ID 20645 //
     /* 1410138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1410141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1410146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1410149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1410152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1410155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410177 */     // MIs[0] Operand 5
     /* 1410177 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410188 */     // MIs[0] policy
     /* 1410188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410198 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1410201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410220 */     // GIR_Coverage, 20645,
     /* 1410220 */     GIR_EraseRootFromParent_Done,
     /* 1410221 */   // Label 19966: @1410221
     /* 1410221 */   GIM_Try, /*On fail goto*//*Label 19967*/ GIMT_Encode4(1410309), // Rule ID 20648 //
     /* 1410226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1410229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1410234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1410237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1410240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1410243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1410246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410265 */     // MIs[0] Operand 5
     /* 1410265 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410276 */     // MIs[0] policy
     /* 1410276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410286 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1410289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410308 */     // GIR_Coverage, 20648,
     /* 1410308 */     GIR_EraseRootFromParent_Done,
     /* 1410309 */   // Label 19967: @1410309
     /* 1410309 */   GIM_Try, /*On fail goto*//*Label 19968*/ GIMT_Encode4(1410397), // Rule ID 20649 //
     /* 1410314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1410317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1410322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1410325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1410328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1410331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1410334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410353 */     // MIs[0] Operand 5
     /* 1410353 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410364 */     // MIs[0] policy
     /* 1410364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1410377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410396 */     // GIR_Coverage, 20649,
     /* 1410396 */     GIR_EraseRootFromParent_Done,
     /* 1410397 */   // Label 19968: @1410397
     /* 1410397 */   GIM_Try, /*On fail goto*//*Label 19969*/ GIMT_Encode4(1410485), // Rule ID 20652 //
     /* 1410402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1410410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1410413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1410416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1410419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410441 */     // MIs[0] Operand 5
     /* 1410441 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410452 */     // MIs[0] policy
     /* 1410452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410462 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1410465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410484 */     // GIR_Coverage, 20652,
     /* 1410484 */     GIR_EraseRootFromParent_Done,
     /* 1410485 */   // Label 19969: @1410485
     /* 1410485 */   GIM_Try, /*On fail goto*//*Label 19970*/ GIMT_Encode4(1410573), // Rule ID 20653 //
     /* 1410490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1410498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1410501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1410504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1410507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410529 */     // MIs[0] Operand 5
     /* 1410529 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410540 */     // MIs[0] policy
     /* 1410540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410550 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1410553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410572 */     // GIR_Coverage, 20653,
     /* 1410572 */     GIR_EraseRootFromParent_Done,
     /* 1410573 */   // Label 19970: @1410573
     /* 1410573 */   GIM_Try, /*On fail goto*//*Label 19971*/ GIMT_Encode4(1410661), // Rule ID 20656 //
     /* 1410578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1410586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1410589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1410592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1410595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410617 */     // MIs[0] Operand 5
     /* 1410617 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410628 */     // MIs[0] policy
     /* 1410628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410638 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1410641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410647 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410660 */     // GIR_Coverage, 20656,
     /* 1410660 */     GIR_EraseRootFromParent_Done,
     /* 1410661 */   // Label 19971: @1410661
     /* 1410661 */   GIM_Try, /*On fail goto*//*Label 19972*/ GIMT_Encode4(1410749), // Rule ID 20657 //
     /* 1410666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1410674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1410677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1410680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1410683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410705 */     // MIs[0] Operand 5
     /* 1410705 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410716 */     // MIs[0] policy
     /* 1410716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410726 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1410729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410748 */     // GIR_Coverage, 20657,
     /* 1410748 */     GIR_EraseRootFromParent_Done,
     /* 1410749 */   // Label 19972: @1410749
     /* 1410749 */   GIM_Try, /*On fail goto*//*Label 19973*/ GIMT_Encode4(1410837), // Rule ID 20660 //
     /* 1410754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1410762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1410765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1410768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1410771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1410774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410793 */     // MIs[0] Operand 5
     /* 1410793 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410804 */     // MIs[0] policy
     /* 1410804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410814 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1410817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410836 */     // GIR_Coverage, 20660,
     /* 1410836 */     GIR_EraseRootFromParent_Done,
     /* 1410837 */   // Label 19973: @1410837
     /* 1410837 */   GIM_Try, /*On fail goto*//*Label 19974*/ GIMT_Encode4(1410925), // Rule ID 20661 //
     /* 1410842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1410850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1410853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1410856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1410859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1410862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410881 */     // MIs[0] Operand 5
     /* 1410881 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410892 */     // MIs[0] policy
     /* 1410892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410902 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1410905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410924 */     // GIR_Coverage, 20661,
     /* 1410924 */     GIR_EraseRootFromParent_Done,
     /* 1410925 */   // Label 19974: @1410925
     /* 1410925 */   GIM_Try, /*On fail goto*//*Label 19975*/ GIMT_Encode4(1411013), // Rule ID 20664 //
     /* 1410930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1410933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1410938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1410941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1410944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1410947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410969 */     // MIs[0] Operand 5
     /* 1410969 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410980 */     // MIs[0] policy
     /* 1410980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1410993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411012 */     // GIR_Coverage, 20664,
     /* 1411012 */     GIR_EraseRootFromParent_Done,
     /* 1411013 */   // Label 19975: @1411013
     /* 1411013 */   GIM_Try, /*On fail goto*//*Label 19976*/ GIMT_Encode4(1411101), // Rule ID 20665 //
     /* 1411018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1411021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1411026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1411029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1411032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1411035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411057 */     // MIs[0] Operand 5
     /* 1411057 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411068 */     // MIs[0] policy
     /* 1411068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411078 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1411081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411100 */     // GIR_Coverage, 20665,
     /* 1411100 */     GIR_EraseRootFromParent_Done,
     /* 1411101 */   // Label 19976: @1411101
     /* 1411101 */   GIM_Try, /*On fail goto*//*Label 19977*/ GIMT_Encode4(1411189), // Rule ID 20668 //
     /* 1411106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1411109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1411114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1411117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1411120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1411123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411145 */     // MIs[0] Operand 5
     /* 1411145 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411156 */     // MIs[0] policy
     /* 1411156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411166 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1411169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411188 */     // GIR_Coverage, 20668,
     /* 1411188 */     GIR_EraseRootFromParent_Done,
     /* 1411189 */   // Label 19977: @1411189
     /* 1411189 */   GIM_Try, /*On fail goto*//*Label 19978*/ GIMT_Encode4(1411277), // Rule ID 20669 //
     /* 1411194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1411197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1411202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1411205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1411208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1411211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411233 */     // MIs[0] Operand 5
     /* 1411233 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411244 */     // MIs[0] policy
     /* 1411244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1411257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411276 */     // GIR_Coverage, 20669,
     /* 1411276 */     GIR_EraseRootFromParent_Done,
     /* 1411277 */   // Label 19978: @1411277
     /* 1411277 */   GIM_Try, /*On fail goto*//*Label 19979*/ GIMT_Encode4(1411365), // Rule ID 20672 //
     /* 1411282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1411285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1411290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1411293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1411296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1411299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1411302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411321 */     // MIs[0] Operand 5
     /* 1411321 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411332 */     // MIs[0] policy
     /* 1411332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411342 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1411345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411364 */     // GIR_Coverage, 20672,
     /* 1411364 */     GIR_EraseRootFromParent_Done,
     /* 1411365 */   // Label 19979: @1411365
     /* 1411365 */   GIM_Try, /*On fail goto*//*Label 19980*/ GIMT_Encode4(1411453), // Rule ID 20673 //
     /* 1411370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1411373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1411378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1411381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1411384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1411387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1411390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411409 */     // MIs[0] Operand 5
     /* 1411409 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411420 */     // MIs[0] policy
     /* 1411420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411430 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1411433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411452 */     // GIR_Coverage, 20673,
     /* 1411452 */     GIR_EraseRootFromParent_Done,
     /* 1411453 */   // Label 19980: @1411453
     /* 1411453 */   GIM_Try, /*On fail goto*//*Label 19981*/ GIMT_Encode4(1411541), // Rule ID 20676 //
     /* 1411458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1411461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1411466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1411469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1411472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1411475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411497 */     // MIs[0] Operand 5
     /* 1411497 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411508 */     // MIs[0] policy
     /* 1411508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411518 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1411521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411540 */     // GIR_Coverage, 20676,
     /* 1411540 */     GIR_EraseRootFromParent_Done,
     /* 1411541 */   // Label 19981: @1411541
     /* 1411541 */   GIM_Try, /*On fail goto*//*Label 19982*/ GIMT_Encode4(1411629), // Rule ID 20677 //
     /* 1411546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1411549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1411554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1411557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1411560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1411563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411585 */     // MIs[0] Operand 5
     /* 1411585 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411596 */     // MIs[0] policy
     /* 1411596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411606 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1411609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411628 */     // GIR_Coverage, 20677,
     /* 1411628 */     GIR_EraseRootFromParent_Done,
     /* 1411629 */   // Label 19982: @1411629
     /* 1411629 */   GIM_Try, /*On fail goto*//*Label 19983*/ GIMT_Encode4(1411717), // Rule ID 20680 //
     /* 1411634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1411637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1411642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1411645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1411648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1411651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411673 */     // MIs[0] Operand 5
     /* 1411673 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411684 */     // MIs[0] policy
     /* 1411684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411694 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1411697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411716 */     // GIR_Coverage, 20680,
     /* 1411716 */     GIR_EraseRootFromParent_Done,
     /* 1411717 */   // Label 19983: @1411717
     /* 1411717 */   GIM_Try, /*On fail goto*//*Label 19984*/ GIMT_Encode4(1411805), // Rule ID 20681 //
     /* 1411722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1411725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1411730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1411733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1411736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1411739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411761 */     // MIs[0] Operand 5
     /* 1411761 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411772 */     // MIs[0] policy
     /* 1411772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411782 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1411785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411804 */     // GIR_Coverage, 20681,
     /* 1411804 */     GIR_EraseRootFromParent_Done,
     /* 1411805 */   // Label 19984: @1411805
     /* 1411805 */   GIM_Try, /*On fail goto*//*Label 19985*/ GIMT_Encode4(1411893), // Rule ID 20684 //
     /* 1411810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1411813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1411818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1411821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1411824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1411827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411849 */     // MIs[0] Operand 5
     /* 1411849 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411860 */     // MIs[0] policy
     /* 1411860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411870 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1411873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411892 */     // GIR_Coverage, 20684,
     /* 1411892 */     GIR_EraseRootFromParent_Done,
     /* 1411893 */   // Label 19985: @1411893
     /* 1411893 */   GIM_Try, /*On fail goto*//*Label 19986*/ GIMT_Encode4(1411981), // Rule ID 20685 //
     /* 1411898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1411901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1411906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1411909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1411912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1411915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411937 */     // MIs[0] Operand 5
     /* 1411937 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411948 */     // MIs[0] policy
     /* 1411948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411958 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1411961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411980 */     // GIR_Coverage, 20685,
     /* 1411980 */     GIR_EraseRootFromParent_Done,
     /* 1411981 */   // Label 19986: @1411981
     /* 1411981 */   GIM_Try, /*On fail goto*//*Label 19987*/ GIMT_Encode4(1412069), // Rule ID 20688 //
     /* 1411986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1411994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1411997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1412000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1412003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412025 */     // MIs[0] Operand 5
     /* 1412025 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412036 */     // MIs[0] policy
     /* 1412036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1412049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412068 */     // GIR_Coverage, 20688,
     /* 1412068 */     GIR_EraseRootFromParent_Done,
     /* 1412069 */   // Label 19987: @1412069
     /* 1412069 */   GIM_Try, /*On fail goto*//*Label 19988*/ GIMT_Encode4(1412157), // Rule ID 20689 //
     /* 1412074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1412082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1412085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1412088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1412091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412113 */     // MIs[0] Operand 5
     /* 1412113 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412124 */     // MIs[0] policy
     /* 1412124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412134 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1412137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412156 */     // GIR_Coverage, 20689,
     /* 1412156 */     GIR_EraseRootFromParent_Done,
     /* 1412157 */   // Label 19988: @1412157
     /* 1412157 */   GIM_Try, /*On fail goto*//*Label 19989*/ GIMT_Encode4(1412245), // Rule ID 20692 //
     /* 1412162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1412170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1412173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1412176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1412179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412201 */     // MIs[0] Operand 5
     /* 1412201 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412212 */     // MIs[0] policy
     /* 1412212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412222 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1412225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412244 */     // GIR_Coverage, 20692,
     /* 1412244 */     GIR_EraseRootFromParent_Done,
     /* 1412245 */   // Label 19989: @1412245
     /* 1412245 */   GIM_Try, /*On fail goto*//*Label 19990*/ GIMT_Encode4(1412333), // Rule ID 20693 //
     /* 1412250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1412258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1412261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1412264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1412267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412289 */     // MIs[0] Operand 5
     /* 1412289 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412300 */     // MIs[0] policy
     /* 1412300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412310 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1412313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412332 */     // GIR_Coverage, 20693,
     /* 1412332 */     GIR_EraseRootFromParent_Done,
     /* 1412333 */   // Label 19990: @1412333
     /* 1412333 */   GIM_Try, /*On fail goto*//*Label 19991*/ GIMT_Encode4(1412421), // Rule ID 20696 //
     /* 1412338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1412341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1412346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1412349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1412352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1412355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412377 */     // MIs[0] Operand 5
     /* 1412377 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412388 */     // MIs[0] policy
     /* 1412388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412398 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1412401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412420 */     // GIR_Coverage, 20696,
     /* 1412420 */     GIR_EraseRootFromParent_Done,
     /* 1412421 */   // Label 19991: @1412421
     /* 1412421 */   GIM_Try, /*On fail goto*//*Label 19992*/ GIMT_Encode4(1412509), // Rule ID 20697 //
     /* 1412426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1412429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1412434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1412437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1412440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1412443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412465 */     // MIs[0] Operand 5
     /* 1412465 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412476 */     // MIs[0] policy
     /* 1412476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1412489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412495 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412508 */     // GIR_Coverage, 20697,
     /* 1412508 */     GIR_EraseRootFromParent_Done,
     /* 1412509 */   // Label 19992: @1412509
     /* 1412509 */   GIM_Try, /*On fail goto*//*Label 19993*/ GIMT_Encode4(1412597), // Rule ID 20700 //
     /* 1412514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1412522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1412525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1412528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1412531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412553 */     // MIs[0] Operand 5
     /* 1412553 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412564 */     // MIs[0] policy
     /* 1412564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412574 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1412577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412596 */     // GIR_Coverage, 20700,
     /* 1412596 */     GIR_EraseRootFromParent_Done,
     /* 1412597 */   // Label 19993: @1412597
     /* 1412597 */   GIM_Try, /*On fail goto*//*Label 19994*/ GIMT_Encode4(1412685), // Rule ID 20701 //
     /* 1412602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1412610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1412613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1412616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1412619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412641 */     // MIs[0] Operand 5
     /* 1412641 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412652 */     // MIs[0] policy
     /* 1412652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412662 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1412665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412684 */     // GIR_Coverage, 20701,
     /* 1412684 */     GIR_EraseRootFromParent_Done,
     /* 1412685 */   // Label 19994: @1412685
     /* 1412685 */   GIM_Try, /*On fail goto*//*Label 19995*/ GIMT_Encode4(1412773), // Rule ID 20704 //
     /* 1412690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1412693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1412698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1412701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1412704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1412707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412729 */     // MIs[0] Operand 5
     /* 1412729 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412740 */     // MIs[0] policy
     /* 1412740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412750 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1412753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412772 */     // GIR_Coverage, 20704,
     /* 1412772 */     GIR_EraseRootFromParent_Done,
     /* 1412773 */   // Label 19995: @1412773
     /* 1412773 */   GIM_Try, /*On fail goto*//*Label 19996*/ GIMT_Encode4(1412861), // Rule ID 20705 //
     /* 1412778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1412781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1412786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1412789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1412792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1412795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412817 */     // MIs[0] Operand 5
     /* 1412817 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412828 */     // MIs[0] policy
     /* 1412828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1412841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412860 */     // GIR_Coverage, 20705,
     /* 1412860 */     GIR_EraseRootFromParent_Done,
     /* 1412861 */   // Label 19996: @1412861
     /* 1412861 */   GIM_Try, /*On fail goto*//*Label 19997*/ GIMT_Encode4(1412949), // Rule ID 20708 //
     /* 1412866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1412869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1412874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1412877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1412880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1412883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412905 */     // MIs[0] Operand 5
     /* 1412905 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412916 */     // MIs[0] policy
     /* 1412916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412926 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1412929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1412945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412948 */     // GIR_Coverage, 20708,
     /* 1412948 */     GIR_EraseRootFromParent_Done,
     /* 1412949 */   // Label 19997: @1412949
     /* 1412949 */   GIM_Try, /*On fail goto*//*Label 19998*/ GIMT_Encode4(1413037), // Rule ID 20709 //
     /* 1412954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1412957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1412962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1412965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1412968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1412971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412993 */     // MIs[0] Operand 5
     /* 1412993 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413004 */     // MIs[0] policy
     /* 1413004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1413017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1413033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413036 */     // GIR_Coverage, 20709,
     /* 1413036 */     GIR_EraseRootFromParent_Done,
     /* 1413037 */   // Label 19998: @1413037
     /* 1413037 */   GIM_Try, /*On fail goto*//*Label 19999*/ GIMT_Encode4(1413125), // Rule ID 20712 //
     /* 1413042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1413050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1413053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1413056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1413059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413081 */     // MIs[0] Operand 5
     /* 1413081 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413092 */     // MIs[0] policy
     /* 1413092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413102 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1413105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413124 */     // GIR_Coverage, 20712,
     /* 1413124 */     GIR_EraseRootFromParent_Done,
     /* 1413125 */   // Label 19999: @1413125
     /* 1413125 */   GIM_Try, /*On fail goto*//*Label 20000*/ GIMT_Encode4(1413213), // Rule ID 20713 //
     /* 1413130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1413133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1413138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1413141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1413144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1413147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413169 */     // MIs[0] Operand 5
     /* 1413169 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413180 */     // MIs[0] policy
     /* 1413180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1413193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413212 */     // GIR_Coverage, 20713,
     /* 1413212 */     GIR_EraseRootFromParent_Done,
     /* 1413213 */   // Label 20000: @1413213
     /* 1413213 */   GIM_Try, /*On fail goto*//*Label 20001*/ GIMT_Encode4(1413301), // Rule ID 20716 //
     /* 1413218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1413226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1413229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1413232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1413235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1413238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413257 */     // MIs[0] Operand 5
     /* 1413257 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413268 */     // MIs[0] policy
     /* 1413268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413278 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1413281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413300 */     // GIR_Coverage, 20716,
     /* 1413300 */     GIR_EraseRootFromParent_Done,
     /* 1413301 */   // Label 20001: @1413301
     /* 1413301 */   GIM_Try, /*On fail goto*//*Label 20002*/ GIMT_Encode4(1413389), // Rule ID 20717 //
     /* 1413306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1413309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1413314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1413317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1413320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1413323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1413326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413345 */     // MIs[0] Operand 5
     /* 1413345 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413356 */     // MIs[0] policy
     /* 1413356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413366 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1413369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413388 */     // GIR_Coverage, 20717,
     /* 1413388 */     GIR_EraseRootFromParent_Done,
     /* 1413389 */   // Label 20002: @1413389
     /* 1413389 */   GIM_Try, /*On fail goto*//*Label 20003*/ GIMT_Encode4(1413477), // Rule ID 20720 //
     /* 1413394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1413402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1413405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1413408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1413411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1413414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413433 */     // MIs[0] Operand 5
     /* 1413433 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413444 */     // MIs[0] policy
     /* 1413444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413454 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1413457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413476 */     // GIR_Coverage, 20720,
     /* 1413476 */     GIR_EraseRootFromParent_Done,
     /* 1413477 */   // Label 20003: @1413477
     /* 1413477 */   GIM_Try, /*On fail goto*//*Label 20004*/ GIMT_Encode4(1413565), // Rule ID 20721 //
     /* 1413482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1413485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1413490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1413493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1413496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1413499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1413502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413521 */     // MIs[0] Operand 5
     /* 1413521 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413532 */     // MIs[0] policy
     /* 1413532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413542 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1413545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413564 */     // GIR_Coverage, 20721,
     /* 1413564 */     GIR_EraseRootFromParent_Done,
     /* 1413565 */   // Label 20004: @1413565
     /* 1413565 */   GIM_Try, /*On fail goto*//*Label 20005*/ GIMT_Encode4(1413653), // Rule ID 20724 //
     /* 1413570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1413573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1413578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1413581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1413584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1413587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1413590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413609 */     // MIs[0] Operand 5
     /* 1413609 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413620 */     // MIs[0] policy
     /* 1413620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1413633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413652 */     // GIR_Coverage, 20724,
     /* 1413652 */     GIR_EraseRootFromParent_Done,
     /* 1413653 */   // Label 20005: @1413653
     /* 1413653 */   GIM_Try, /*On fail goto*//*Label 20006*/ GIMT_Encode4(1413741), // Rule ID 20725 //
     /* 1413658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1413661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1413666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1413669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1413672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1413675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1413678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413697 */     // MIs[0] Operand 5
     /* 1413697 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413708 */     // MIs[0] policy
     /* 1413708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1413721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413740 */     // GIR_Coverage, 20725,
     /* 1413740 */     GIR_EraseRootFromParent_Done,
     /* 1413741 */   // Label 20006: @1413741
     /* 1413741 */   GIM_Try, /*On fail goto*//*Label 20007*/ GIMT_Encode4(1413829), // Rule ID 20728 //
     /* 1413746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1413749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1413754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1413757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1413760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1413763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413785 */     // MIs[0] Operand 5
     /* 1413785 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413796 */     // MIs[0] policy
     /* 1413796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413806 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1413809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413828 */     // GIR_Coverage, 20728,
     /* 1413828 */     GIR_EraseRootFromParent_Done,
     /* 1413829 */   // Label 20007: @1413829
     /* 1413829 */   GIM_Try, /*On fail goto*//*Label 20008*/ GIMT_Encode4(1413917), // Rule ID 20729 //
     /* 1413834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1413837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1413842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1413845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1413848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1413851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413873 */     // MIs[0] Operand 5
     /* 1413873 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413884 */     // MIs[0] policy
     /* 1413884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413894 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1413897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413916 */     // GIR_Coverage, 20729,
     /* 1413916 */     GIR_EraseRootFromParent_Done,
     /* 1413917 */   // Label 20008: @1413917
     /* 1413917 */   GIM_Try, /*On fail goto*//*Label 20009*/ GIMT_Encode4(1414005), // Rule ID 20732 //
     /* 1413922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1413925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1413930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1413933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1413936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1413939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1413942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413961 */     // MIs[0] Operand 5
     /* 1413961 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413972 */     // MIs[0] policy
     /* 1413972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413982 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1413985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414004 */     // GIR_Coverage, 20732,
     /* 1414004 */     GIR_EraseRootFromParent_Done,
     /* 1414005 */   // Label 20009: @1414005
     /* 1414005 */   GIM_Try, /*On fail goto*//*Label 20010*/ GIMT_Encode4(1414093), // Rule ID 20733 //
     /* 1414010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1414013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1414018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1414021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1414024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1414027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1414030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1414037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414049 */     // MIs[0] Operand 5
     /* 1414049 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414060 */     // MIs[0] policy
     /* 1414060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414070 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1414073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414092 */     // GIR_Coverage, 20733,
     /* 1414092 */     GIR_EraseRootFromParent_Done,
     /* 1414093 */   // Label 20010: @1414093
     /* 1414093 */   GIM_Try, /*On fail goto*//*Label 20011*/ GIMT_Encode4(1414181), // Rule ID 20736 //
     /* 1414098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1414101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1414106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1414109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1414112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1414115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1414125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414137 */     // MIs[0] Operand 5
     /* 1414137 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414148 */     // MIs[0] policy
     /* 1414148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414158 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1414161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1414177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414180 */     // GIR_Coverage, 20736,
     /* 1414180 */     GIR_EraseRootFromParent_Done,
     /* 1414181 */   // Label 20011: @1414181
     /* 1414181 */   GIM_Try, /*On fail goto*//*Label 20012*/ GIMT_Encode4(1414269), // Rule ID 20737 //
     /* 1414186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1414189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1414194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1414197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1414200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1414203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1414213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414225 */     // MIs[0] Operand 5
     /* 1414225 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414236 */     // MIs[0] policy
     /* 1414236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1414249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1414265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414268 */     // GIR_Coverage, 20737,
     /* 1414268 */     GIR_EraseRootFromParent_Done,
     /* 1414269 */   // Label 20012: @1414269
     /* 1414269 */   GIM_Try, /*On fail goto*//*Label 20013*/ GIMT_Encode4(1414357), // Rule ID 20740 //
     /* 1414274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1414277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1414282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1414285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1414288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1414291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414313 */     // MIs[0] Operand 5
     /* 1414313 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414324 */     // MIs[0] policy
     /* 1414324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414334 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1414337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414343 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1414353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414356 */     // GIR_Coverage, 20740,
     /* 1414356 */     GIR_EraseRootFromParent_Done,
     /* 1414357 */   // Label 20013: @1414357
     /* 1414357 */   GIM_Try, /*On fail goto*//*Label 20014*/ GIMT_Encode4(1414445), // Rule ID 20741 //
     /* 1414362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1414365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1414370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1414373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1414376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1414379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414401 */     // MIs[0] Operand 5
     /* 1414401 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414412 */     // MIs[0] policy
     /* 1414412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414422 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1414425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1414441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414444 */     // GIR_Coverage, 20741,
     /* 1414444 */     GIR_EraseRootFromParent_Done,
     /* 1414445 */   // Label 20014: @1414445
     /* 1414445 */   GIM_Try, /*On fail goto*//*Label 20015*/ GIMT_Encode4(1414533), // Rule ID 20744 //
     /* 1414450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1414453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1414458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1414461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1414464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1414467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1414477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414489 */     // MIs[0] Operand 5
     /* 1414489 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414500 */     // MIs[0] policy
     /* 1414500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414510 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1414513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1414529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414532 */     // GIR_Coverage, 20744,
     /* 1414532 */     GIR_EraseRootFromParent_Done,
     /* 1414533 */   // Label 20015: @1414533
     /* 1414533 */   GIM_Try, /*On fail goto*//*Label 20016*/ GIMT_Encode4(1414621), // Rule ID 20745 //
     /* 1414538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1414541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1414546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1414549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1414552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1414555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1414565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414577 */     // MIs[0] Operand 5
     /* 1414577 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414588 */     // MIs[0] policy
     /* 1414588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414598 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1414601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1414617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414620 */     // GIR_Coverage, 20745,
     /* 1414620 */     GIR_EraseRootFromParent_Done,
     /* 1414621 */   // Label 20016: @1414621
     /* 1414621 */   GIM_Try, /*On fail goto*//*Label 20017*/ GIMT_Encode4(1414709), // Rule ID 21104 //
     /* 1414626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1414634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1414637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1414640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1414643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1414646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414665 */     // MIs[0] Operand 5
     /* 1414665 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414676 */     // MIs[0] policy
     /* 1414676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414686 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1414689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1414705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414708 */     // GIR_Coverage, 21104,
     /* 1414708 */     GIR_EraseRootFromParent_Done,
     /* 1414709 */   // Label 20017: @1414709
     /* 1414709 */   GIM_Try, /*On fail goto*//*Label 20018*/ GIMT_Encode4(1414797), // Rule ID 21105 //
     /* 1414714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1414722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1414725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1414728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1414731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1414734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414753 */     // MIs[0] Operand 5
     /* 1414753 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414764 */     // MIs[0] policy
     /* 1414764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414774 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1414777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1414793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414796 */     // GIR_Coverage, 21105,
     /* 1414796 */     GIR_EraseRootFromParent_Done,
     /* 1414797 */   // Label 20018: @1414797
     /* 1414797 */   GIM_Try, /*On fail goto*//*Label 20019*/ GIMT_Encode4(1414885), // Rule ID 21108 //
     /* 1414802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1414810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1414813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1414816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1414819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414841 */     // MIs[0] Operand 5
     /* 1414841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414852 */     // MIs[0] policy
     /* 1414852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414862 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1414865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1414881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414884 */     // GIR_Coverage, 21108,
     /* 1414884 */     GIR_EraseRootFromParent_Done,
     /* 1414885 */   // Label 20019: @1414885
     /* 1414885 */   GIM_Try, /*On fail goto*//*Label 20020*/ GIMT_Encode4(1414973), // Rule ID 21109 //
     /* 1414890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1414898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1414901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1414904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1414907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414929 */     // MIs[0] Operand 5
     /* 1414929 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414940 */     // MIs[0] policy
     /* 1414940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414950 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1414953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1414969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414972 */     // GIR_Coverage, 21109,
     /* 1414972 */     GIR_EraseRootFromParent_Done,
     /* 1414973 */   // Label 20020: @1414973
     /* 1414973 */   GIM_Try, /*On fail goto*//*Label 20021*/ GIMT_Encode4(1415061), // Rule ID 21112 //
     /* 1414978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1414986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1414989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1414992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1414995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415017 */     // MIs[0] Operand 5
     /* 1415017 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415028 */     // MIs[0] policy
     /* 1415028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415038 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1415041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415060 */     // GIR_Coverage, 21112,
     /* 1415060 */     GIR_EraseRootFromParent_Done,
     /* 1415061 */   // Label 20021: @1415061
     /* 1415061 */   GIM_Try, /*On fail goto*//*Label 20022*/ GIMT_Encode4(1415149), // Rule ID 21113 //
     /* 1415066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1415069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1415074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1415077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1415080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1415083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1415086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415105 */     // MIs[0] Operand 5
     /* 1415105 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415116 */     // MIs[0] policy
     /* 1415116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415126 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1415129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415148 */     // GIR_Coverage, 21113,
     /* 1415148 */     GIR_EraseRootFromParent_Done,
     /* 1415149 */   // Label 20022: @1415149
     /* 1415149 */   GIM_Try, /*On fail goto*//*Label 20023*/ GIMT_Encode4(1415237), // Rule ID 21116 //
     /* 1415154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1415157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1415162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1415165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1415168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1415171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1415174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415193 */     // MIs[0] Operand 5
     /* 1415193 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415204 */     // MIs[0] policy
     /* 1415204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1415217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415236 */     // GIR_Coverage, 21116,
     /* 1415236 */     GIR_EraseRootFromParent_Done,
     /* 1415237 */   // Label 20023: @1415237
     /* 1415237 */   GIM_Try, /*On fail goto*//*Label 20024*/ GIMT_Encode4(1415325), // Rule ID 21117 //
     /* 1415242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1415245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1415250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1415253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1415256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1415259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1415262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415281 */     // MIs[0] Operand 5
     /* 1415281 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415292 */     // MIs[0] policy
     /* 1415292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1415305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415324 */     // GIR_Coverage, 21117,
     /* 1415324 */     GIR_EraseRootFromParent_Done,
     /* 1415325 */   // Label 20024: @1415325
     /* 1415325 */   GIM_Try, /*On fail goto*//*Label 20025*/ GIMT_Encode4(1415413), // Rule ID 21120 //
     /* 1415330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1415333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1415338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1415341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1415344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1415347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1415350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1415357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415369 */     // MIs[0] Operand 5
     /* 1415369 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415380 */     // MIs[0] policy
     /* 1415380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415390 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1415393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415412 */     // GIR_Coverage, 21120,
     /* 1415412 */     GIR_EraseRootFromParent_Done,
     /* 1415413 */   // Label 20025: @1415413
     /* 1415413 */   GIM_Try, /*On fail goto*//*Label 20026*/ GIMT_Encode4(1415501), // Rule ID 21121 //
     /* 1415418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1415421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1415426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1415429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1415432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1415435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1415438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1415445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415457 */     // MIs[0] Operand 5
     /* 1415457 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415468 */     // MIs[0] policy
     /* 1415468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1415481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415500 */     // GIR_Coverage, 21121,
     /* 1415500 */     GIR_EraseRootFromParent_Done,
     /* 1415501 */   // Label 20026: @1415501
     /* 1415501 */   GIM_Try, /*On fail goto*//*Label 20027*/ GIMT_Encode4(1415589), // Rule ID 21124 //
     /* 1415506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1415509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1415514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1415517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1415520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1415523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415545 */     // MIs[0] Operand 5
     /* 1415545 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415556 */     // MIs[0] policy
     /* 1415556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1415569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1415585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415588 */     // GIR_Coverage, 21124,
     /* 1415588 */     GIR_EraseRootFromParent_Done,
     /* 1415589 */   // Label 20027: @1415589
     /* 1415589 */   GIM_Try, /*On fail goto*//*Label 20028*/ GIMT_Encode4(1415677), // Rule ID 21125 //
     /* 1415594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1415597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1415602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1415605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1415608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1415611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415633 */     // MIs[0] Operand 5
     /* 1415633 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415644 */     // MIs[0] policy
     /* 1415644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415654 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1415657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1415673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415676 */     // GIR_Coverage, 21125,
     /* 1415676 */     GIR_EraseRootFromParent_Done,
     /* 1415677 */   // Label 20028: @1415677
     /* 1415677 */   GIM_Try, /*On fail goto*//*Label 20029*/ GIMT_Encode4(1415765), // Rule ID 21128 //
     /* 1415682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1415685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1415690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1415693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1415696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1415699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1415702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415721 */     // MIs[0] Operand 5
     /* 1415721 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415732 */     // MIs[0] policy
     /* 1415732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415742 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1415745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1415761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415764 */     // GIR_Coverage, 21128,
     /* 1415764 */     GIR_EraseRootFromParent_Done,
     /* 1415765 */   // Label 20029: @1415765
     /* 1415765 */   GIM_Try, /*On fail goto*//*Label 20030*/ GIMT_Encode4(1415853), // Rule ID 21129 //
     /* 1415770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1415773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1415778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1415781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1415784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1415787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1415790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415809 */     // MIs[0] Operand 5
     /* 1415809 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415820 */     // MIs[0] policy
     /* 1415820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415830 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1415833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1415849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415852 */     // GIR_Coverage, 21129,
     /* 1415852 */     GIR_EraseRootFromParent_Done,
     /* 1415853 */   // Label 20030: @1415853
     /* 1415853 */   GIM_Try, /*On fail goto*//*Label 20031*/ GIMT_Encode4(1415941), // Rule ID 21132 //
     /* 1415858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1415861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1415866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1415869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1415872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1415878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415897 */     // MIs[0] Operand 5
     /* 1415897 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415908 */     // MIs[0] policy
     /* 1415908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415918 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1415921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1415937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415940 */     // GIR_Coverage, 21132,
     /* 1415940 */     GIR_EraseRootFromParent_Done,
     /* 1415941 */   // Label 20031: @1415941
     /* 1415941 */   GIM_Try, /*On fail goto*//*Label 20032*/ GIMT_Encode4(1416029), // Rule ID 21133 //
     /* 1415946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1415949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1415954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1415957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1415960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1415966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415985 */     // MIs[0] Operand 5
     /* 1415985 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415996 */     // MIs[0] policy
     /* 1415996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416006 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1416009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416028 */     // GIR_Coverage, 21133,
     /* 1416028 */     GIR_EraseRootFromParent_Done,
     /* 1416029 */   // Label 20032: @1416029
     /* 1416029 */   GIM_Try, /*On fail goto*//*Label 20033*/ GIMT_Encode4(1416117), // Rule ID 21136 //
     /* 1416034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1416037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1416042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1416045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1416048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1416051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1416061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416073 */     // MIs[0] Operand 5
     /* 1416073 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416084 */     // MIs[0] policy
     /* 1416084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416094 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1416097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416116 */     // GIR_Coverage, 21136,
     /* 1416116 */     GIR_EraseRootFromParent_Done,
     /* 1416117 */   // Label 20033: @1416117
     /* 1416117 */   GIM_Try, /*On fail goto*//*Label 20034*/ GIMT_Encode4(1416205), // Rule ID 21137 //
     /* 1416122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1416125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1416130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1416133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1416136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1416139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1416149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416161 */     // MIs[0] Operand 5
     /* 1416161 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416172 */     // MIs[0] policy
     /* 1416172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416182 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1416185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416204 */     // GIR_Coverage, 21137,
     /* 1416204 */     GIR_EraseRootFromParent_Done,
     /* 1416205 */   // Label 20034: @1416205
     /* 1416205 */   GIM_Try, /*On fail goto*//*Label 20035*/ GIMT_Encode4(1416293), // Rule ID 21140 //
     /* 1416210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1416213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1416218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1416221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1416224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1416227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1416230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416249 */     // MIs[0] Operand 5
     /* 1416249 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416260 */     // MIs[0] policy
     /* 1416260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416270 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1416273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416292 */     // GIR_Coverage, 21140,
     /* 1416292 */     GIR_EraseRootFromParent_Done,
     /* 1416293 */   // Label 20035: @1416293
     /* 1416293 */   GIM_Try, /*On fail goto*//*Label 20036*/ GIMT_Encode4(1416381), // Rule ID 21141 //
     /* 1416298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1416301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1416306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1416309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1416312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1416315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1416318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416337 */     // MIs[0] Operand 5
     /* 1416337 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416348 */     // MIs[0] policy
     /* 1416348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416358 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1416361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416380 */     // GIR_Coverage, 21141,
     /* 1416380 */     GIR_EraseRootFromParent_Done,
     /* 1416381 */   // Label 20036: @1416381
     /* 1416381 */   GIM_Try, /*On fail goto*//*Label 20037*/ GIMT_Encode4(1416469), // Rule ID 21144 //
     /* 1416386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1416389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1416394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1416403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416425 */     // MIs[0] Operand 5
     /* 1416425 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416436 */     // MIs[0] policy
     /* 1416436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416446 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1416449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416468 */     // GIR_Coverage, 21144,
     /* 1416468 */     GIR_EraseRootFromParent_Done,
     /* 1416469 */   // Label 20037: @1416469
     /* 1416469 */   GIM_Try, /*On fail goto*//*Label 20038*/ GIMT_Encode4(1416557), // Rule ID 21145 //
     /* 1416474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1416477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1416482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1416491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416513 */     // MIs[0] Operand 5
     /* 1416513 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416524 */     // MIs[0] policy
     /* 1416524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1416537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416556 */     // GIR_Coverage, 21145,
     /* 1416556 */     GIR_EraseRootFromParent_Done,
     /* 1416557 */   // Label 20038: @1416557
     /* 1416557 */   GIM_Try, /*On fail goto*//*Label 20039*/ GIMT_Encode4(1416645), // Rule ID 21148 //
     /* 1416562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1416565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1416570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1416573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1416576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1416579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416601 */     // MIs[0] Operand 5
     /* 1416601 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416612 */     // MIs[0] policy
     /* 1416612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416622 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1416625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416644 */     // GIR_Coverage, 21148,
     /* 1416644 */     GIR_EraseRootFromParent_Done,
     /* 1416645 */   // Label 20039: @1416645
     /* 1416645 */   GIM_Try, /*On fail goto*//*Label 20040*/ GIMT_Encode4(1416733), // Rule ID 21149 //
     /* 1416650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1416653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1416658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1416661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1416664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1416667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416689 */     // MIs[0] Operand 5
     /* 1416689 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416700 */     // MIs[0] policy
     /* 1416700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1416713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416732 */     // GIR_Coverage, 21149,
     /* 1416732 */     GIR_EraseRootFromParent_Done,
     /* 1416733 */   // Label 20040: @1416733
     /* 1416733 */   GIM_Try, /*On fail goto*//*Label 20041*/ GIMT_Encode4(1416821), // Rule ID 21152 //
     /* 1416738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1416741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1416746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1416755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416777 */     // MIs[0] Operand 5
     /* 1416777 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416788 */     // MIs[0] policy
     /* 1416788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416798 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1416801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416820 */     // GIR_Coverage, 21152,
     /* 1416820 */     GIR_EraseRootFromParent_Done,
     /* 1416821 */   // Label 20041: @1416821
     /* 1416821 */   GIM_Try, /*On fail goto*//*Label 20042*/ GIMT_Encode4(1416909), // Rule ID 21153 //
     /* 1416826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1416829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1416834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1416843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416865 */     // MIs[0] Operand 5
     /* 1416865 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416876 */     // MIs[0] policy
     /* 1416876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416886 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1416889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416908 */     // GIR_Coverage, 21153,
     /* 1416908 */     GIR_EraseRootFromParent_Done,
     /* 1416909 */   // Label 20042: @1416909
     /* 1416909 */   GIM_Try, /*On fail goto*//*Label 20043*/ GIMT_Encode4(1416997), // Rule ID 21156 //
     /* 1416914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1416917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1416922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1416925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1416928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1416931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1416934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1416941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416953 */     // MIs[0] Operand 5
     /* 1416953 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416964 */     // MIs[0] policy
     /* 1416964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416974 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1416977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416996 */     // GIR_Coverage, 21156,
     /* 1416996 */     GIR_EraseRootFromParent_Done,
     /* 1416997 */   // Label 20043: @1416997
     /* 1416997 */   GIM_Try, /*On fail goto*//*Label 20044*/ GIMT_Encode4(1417085), // Rule ID 21157 //
     /* 1417002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1417010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1417013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1417016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1417019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1417022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1417029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417041 */     // MIs[0] Operand 5
     /* 1417041 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417052 */     // MIs[0] policy
     /* 1417052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417062 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1417065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417084 */     // GIR_Coverage, 21157,
     /* 1417084 */     GIR_EraseRootFromParent_Done,
     /* 1417085 */   // Label 20044: @1417085
     /* 1417085 */   GIM_Try, /*On fail goto*//*Label 20045*/ GIMT_Encode4(1417173), // Rule ID 21160 //
     /* 1417090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1417093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1417098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1417101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1417104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1417107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1417110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417129 */     // MIs[0] Operand 5
     /* 1417129 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417140 */     // MIs[0] policy
     /* 1417140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417150 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1417153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417172 */     // GIR_Coverage, 21160,
     /* 1417172 */     GIR_EraseRootFromParent_Done,
     /* 1417173 */   // Label 20045: @1417173
     /* 1417173 */   GIM_Try, /*On fail goto*//*Label 20046*/ GIMT_Encode4(1417261), // Rule ID 21161 //
     /* 1417178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1417181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1417186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1417189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1417192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1417195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1417198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417217 */     // MIs[0] Operand 5
     /* 1417217 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417228 */     // MIs[0] policy
     /* 1417228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417238 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1417241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417260 */     // GIR_Coverage, 21161,
     /* 1417260 */     GIR_EraseRootFromParent_Done,
     /* 1417261 */   // Label 20046: @1417261
     /* 1417261 */   GIM_Try, /*On fail goto*//*Label 20047*/ GIMT_Encode4(1417349), // Rule ID 21164 //
     /* 1417266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1417269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1417274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1417277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1417280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1417283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1417286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1417293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417305 */     // MIs[0] Operand 5
     /* 1417305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417316 */     // MIs[0] policy
     /* 1417316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1417329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417348 */     // GIR_Coverage, 21164,
     /* 1417348 */     GIR_EraseRootFromParent_Done,
     /* 1417349 */   // Label 20047: @1417349
     /* 1417349 */   GIM_Try, /*On fail goto*//*Label 20048*/ GIMT_Encode4(1417437), // Rule ID 21165 //
     /* 1417354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1417357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1417362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1417365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1417368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1417371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1417374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1417381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417393 */     // MIs[0] Operand 5
     /* 1417393 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417404 */     // MIs[0] policy
     /* 1417404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1417417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417436 */     // GIR_Coverage, 21165,
     /* 1417436 */     GIR_EraseRootFromParent_Done,
     /* 1417437 */   // Label 20048: @1417437
     /* 1417437 */   GIM_Try, /*On fail goto*//*Label 20049*/ GIMT_Encode4(1417525), // Rule ID 21168 //
     /* 1417442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1417445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1417450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1417453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1417456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1417459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1417462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1417469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417481 */     // MIs[0] Operand 5
     /* 1417481 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417492 */     // MIs[0] policy
     /* 1417492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417502 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1417505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417524 */     // GIR_Coverage, 21168,
     /* 1417524 */     GIR_EraseRootFromParent_Done,
     /* 1417525 */   // Label 20049: @1417525
     /* 1417525 */   GIM_Try, /*On fail goto*//*Label 20050*/ GIMT_Encode4(1417613), // Rule ID 21169 //
     /* 1417530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1417533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1417538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1417541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1417544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1417547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1417550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1417557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417569 */     // MIs[0] Operand 5
     /* 1417569 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417580 */     // MIs[0] policy
     /* 1417580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417590 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1417593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417612 */     // GIR_Coverage, 21169,
     /* 1417612 */     GIR_EraseRootFromParent_Done,
     /* 1417613 */   // Label 20050: @1417613
     /* 1417613 */   GIM_Try, /*On fail goto*//*Label 20051*/ GIMT_Encode4(1417701), // Rule ID 21172 //
     /* 1417618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1417621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1417626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1417629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1417632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1417635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1417638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1417645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417657 */     // MIs[0] Operand 5
     /* 1417657 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417668 */     // MIs[0] policy
     /* 1417668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417678 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1417681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417700 */     // GIR_Coverage, 21172,
     /* 1417700 */     GIR_EraseRootFromParent_Done,
     /* 1417701 */   // Label 20051: @1417701
     /* 1417701 */   GIM_Try, /*On fail goto*//*Label 20052*/ GIMT_Encode4(1417789), // Rule ID 21173 //
     /* 1417706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1417709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1417714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1417717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1417720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1417723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1417726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1417733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417745 */     // MIs[0] Operand 5
     /* 1417745 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417756 */     // MIs[0] policy
     /* 1417756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417766 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1417769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417788 */     // GIR_Coverage, 21173,
     /* 1417788 */     GIR_EraseRootFromParent_Done,
     /* 1417789 */   // Label 20052: @1417789
     /* 1417789 */   GIM_Try, /*On fail goto*//*Label 20053*/ GIMT_Encode4(1417877), // Rule ID 21476 //
     /* 1417794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1417802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1417805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1417808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1417811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1417814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417833 */     // MIs[0] Operand 5
     /* 1417833 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417844 */     // MIs[0] policy
     /* 1417844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417854 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1417857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417876 */     // GIR_Coverage, 21476,
     /* 1417876 */     GIR_EraseRootFromParent_Done,
     /* 1417877 */   // Label 20053: @1417877
     /* 1417877 */   GIM_Try, /*On fail goto*//*Label 20054*/ GIMT_Encode4(1417965), // Rule ID 21477 //
     /* 1417882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1417890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1417893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1417896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1417899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1417902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417921 */     // MIs[0] Operand 5
     /* 1417921 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417932 */     // MIs[0] policy
     /* 1417932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417942 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1417945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417964 */     // GIR_Coverage, 21477,
     /* 1417964 */     GIR_EraseRootFromParent_Done,
     /* 1417965 */   // Label 20054: @1417965
     /* 1417965 */   GIM_Try, /*On fail goto*//*Label 20055*/ GIMT_Encode4(1418053), // Rule ID 21480 //
     /* 1417970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1417978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1417981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1417984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1417987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1417990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418009 */     // MIs[0] Operand 5
     /* 1418009 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418020 */     // MIs[0] policy
     /* 1418020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418030 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1418033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418039 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418052 */     // GIR_Coverage, 21480,
     /* 1418052 */     GIR_EraseRootFromParent_Done,
     /* 1418053 */   // Label 20055: @1418053
     /* 1418053 */   GIM_Try, /*On fail goto*//*Label 20056*/ GIMT_Encode4(1418141), // Rule ID 21481 //
     /* 1418058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1418061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1418066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1418069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1418072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1418075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1418078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418097 */     // MIs[0] Operand 5
     /* 1418097 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418108 */     // MIs[0] policy
     /* 1418108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418118 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1418121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418140 */     // GIR_Coverage, 21481,
     /* 1418140 */     GIR_EraseRootFromParent_Done,
     /* 1418141 */   // Label 20056: @1418141
     /* 1418141 */   GIM_Try, /*On fail goto*//*Label 20057*/ GIMT_Encode4(1418229), // Rule ID 21484 //
     /* 1418146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1418149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1418154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1418157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1418160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1418163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418185 */     // MIs[0] Operand 5
     /* 1418185 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418196 */     // MIs[0] policy
     /* 1418196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418206 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1418209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418228 */     // GIR_Coverage, 21484,
     /* 1418228 */     GIR_EraseRootFromParent_Done,
     /* 1418229 */   // Label 20057: @1418229
     /* 1418229 */   GIM_Try, /*On fail goto*//*Label 20058*/ GIMT_Encode4(1418317), // Rule ID 21485 //
     /* 1418234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1418237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1418242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1418245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1418248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1418251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418273 */     // MIs[0] Operand 5
     /* 1418273 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418284 */     // MIs[0] policy
     /* 1418284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418294 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1418297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418316 */     // GIR_Coverage, 21485,
     /* 1418316 */     GIR_EraseRootFromParent_Done,
     /* 1418317 */   // Label 20058: @1418317
     /* 1418317 */   GIM_Try, /*On fail goto*//*Label 20059*/ GIMT_Encode4(1418405), // Rule ID 21488 //
     /* 1418322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1418325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1418330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1418333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1418336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1418339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1418342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418361 */     // MIs[0] Operand 5
     /* 1418361 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418372 */     // MIs[0] policy
     /* 1418372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418382 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1418385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418404 */     // GIR_Coverage, 21488,
     /* 1418404 */     GIR_EraseRootFromParent_Done,
     /* 1418405 */   // Label 20059: @1418405
     /* 1418405 */   GIM_Try, /*On fail goto*//*Label 20060*/ GIMT_Encode4(1418493), // Rule ID 21489 //
     /* 1418410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1418413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1418418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1418421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1418424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1418427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1418430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418449 */     // MIs[0] Operand 5
     /* 1418449 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418460 */     // MIs[0] policy
     /* 1418460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418470 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1418473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418492 */     // GIR_Coverage, 21489,
     /* 1418492 */     GIR_EraseRootFromParent_Done,
     /* 1418493 */   // Label 20060: @1418493
     /* 1418493 */   GIM_Try, /*On fail goto*//*Label 20061*/ GIMT_Encode4(1418581), // Rule ID 21492 //
     /* 1418498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1418501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1418506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1418509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1418512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1418515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1418518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418537 */     // MIs[0] Operand 5
     /* 1418537 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418548 */     // MIs[0] policy
     /* 1418548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418558 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1418561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418580 */     // GIR_Coverage, 21492,
     /* 1418580 */     GIR_EraseRootFromParent_Done,
     /* 1418581 */   // Label 20061: @1418581
     /* 1418581 */   GIM_Try, /*On fail goto*//*Label 20062*/ GIMT_Encode4(1418669), // Rule ID 21493 //
     /* 1418586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1418589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1418594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1418597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1418600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1418603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1418606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418625 */     // MIs[0] Operand 5
     /* 1418625 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418636 */     // MIs[0] policy
     /* 1418636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418646 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1418649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418668 */     // GIR_Coverage, 21493,
     /* 1418668 */     GIR_EraseRootFromParent_Done,
     /* 1418669 */   // Label 20062: @1418669
     /* 1418669 */   GIM_Try, /*On fail goto*//*Label 20063*/ GIMT_Encode4(1418757), // Rule ID 21496 //
     /* 1418674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1418677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1418682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1418685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1418688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1418691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1418694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1418701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418713 */     // MIs[0] Operand 5
     /* 1418713 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418724 */     // MIs[0] policy
     /* 1418724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418734 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1418737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418756 */     // GIR_Coverage, 21496,
     /* 1418756 */     GIR_EraseRootFromParent_Done,
     /* 1418757 */   // Label 20063: @1418757
     /* 1418757 */   GIM_Try, /*On fail goto*//*Label 20064*/ GIMT_Encode4(1418845), // Rule ID 21497 //
     /* 1418762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1418765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1418770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1418773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1418776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1418779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1418782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1418789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418801 */     // MIs[0] Operand 5
     /* 1418801 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418812 */     // MIs[0] policy
     /* 1418812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418822 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1418825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418844 */     // GIR_Coverage, 21497,
     /* 1418844 */     GIR_EraseRootFromParent_Done,
     /* 1418845 */   // Label 20064: @1418845
     /* 1418845 */   GIM_Try, /*On fail goto*//*Label 20065*/ GIMT_Encode4(1418933), // Rule ID 21500 //
     /* 1418850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1418858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1418861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1418864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1418867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1418870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418889 */     // MIs[0] Operand 5
     /* 1418889 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418900 */     // MIs[0] policy
     /* 1418900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418910 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1418913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418932 */     // GIR_Coverage, 21500,
     /* 1418932 */     GIR_EraseRootFromParent_Done,
     /* 1418933 */   // Label 20065: @1418933
     /* 1418933 */   GIM_Try, /*On fail goto*//*Label 20066*/ GIMT_Encode4(1419021), // Rule ID 21501 //
     /* 1418938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1418946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1418949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1418952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1418955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1418958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418977 */     // MIs[0] Operand 5
     /* 1418977 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418988 */     // MIs[0] policy
     /* 1418988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418998 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1419001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419020 */     // GIR_Coverage, 21501,
     /* 1419020 */     GIR_EraseRootFromParent_Done,
     /* 1419021 */   // Label 20066: @1419021
     /* 1419021 */   GIM_Try, /*On fail goto*//*Label 20067*/ GIMT_Encode4(1419109), // Rule ID 21504 //
     /* 1419026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1419029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1419034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1419037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1419040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1419043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1419046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419065 */     // MIs[0] Operand 5
     /* 1419065 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419076 */     // MIs[0] policy
     /* 1419076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1419089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419108 */     // GIR_Coverage, 21504,
     /* 1419108 */     GIR_EraseRootFromParent_Done,
     /* 1419109 */   // Label 20067: @1419109
     /* 1419109 */   GIM_Try, /*On fail goto*//*Label 20068*/ GIMT_Encode4(1419197), // Rule ID 21505 //
     /* 1419114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1419117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1419122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1419125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1419128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1419131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1419134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419153 */     // MIs[0] Operand 5
     /* 1419153 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419164 */     // MIs[0] policy
     /* 1419164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419174 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1419177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419196 */     // GIR_Coverage, 21505,
     /* 1419196 */     GIR_EraseRootFromParent_Done,
     /* 1419197 */   // Label 20068: @1419197
     /* 1419197 */   GIM_Try, /*On fail goto*//*Label 20069*/ GIMT_Encode4(1419285), // Rule ID 21508 //
     /* 1419202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1419205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1419210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1419213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1419216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1419219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1419222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419241 */     // MIs[0] Operand 5
     /* 1419241 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419252 */     // MIs[0] policy
     /* 1419252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419262 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1419265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419271 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419284 */     // GIR_Coverage, 21508,
     /* 1419284 */     GIR_EraseRootFromParent_Done,
     /* 1419285 */   // Label 20069: @1419285
     /* 1419285 */   GIM_Try, /*On fail goto*//*Label 20070*/ GIMT_Encode4(1419373), // Rule ID 21509 //
     /* 1419290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1419293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1419298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1419301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1419304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1419307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1419310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419329 */     // MIs[0] Operand 5
     /* 1419329 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419340 */     // MIs[0] policy
     /* 1419340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419350 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1419353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419372 */     // GIR_Coverage, 21509,
     /* 1419372 */     GIR_EraseRootFromParent_Done,
     /* 1419373 */   // Label 20070: @1419373
     /* 1419373 */   GIM_Try, /*On fail goto*//*Label 20071*/ GIMT_Encode4(1419461), // Rule ID 21512 //
     /* 1419378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1419381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1419386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1419389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1419392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1419395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1419398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419417 */     // MIs[0] Operand 5
     /* 1419417 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419428 */     // MIs[0] policy
     /* 1419428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419438 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1419441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419460 */     // GIR_Coverage, 21512,
     /* 1419460 */     GIR_EraseRootFromParent_Done,
     /* 1419461 */   // Label 20071: @1419461
     /* 1419461 */   GIM_Try, /*On fail goto*//*Label 20072*/ GIMT_Encode4(1419549), // Rule ID 21513 //
     /* 1419466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1419469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1419474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1419477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1419480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1419483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1419486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419505 */     // MIs[0] Operand 5
     /* 1419505 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419516 */     // MIs[0] policy
     /* 1419516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419526 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1419529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419548 */     // GIR_Coverage, 21513,
     /* 1419548 */     GIR_EraseRootFromParent_Done,
     /* 1419549 */   // Label 20072: @1419549
     /* 1419549 */   GIM_Try, /*On fail goto*//*Label 20073*/ GIMT_Encode4(1419637), // Rule ID 21516 //
     /* 1419554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1419557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1419562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1419565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1419568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1419571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1419574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419593 */     // MIs[0] Operand 5
     /* 1419593 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419604 */     // MIs[0] policy
     /* 1419604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419614 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1419617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419636 */     // GIR_Coverage, 21516,
     /* 1419636 */     GIR_EraseRootFromParent_Done,
     /* 1419637 */   // Label 20073: @1419637
     /* 1419637 */   GIM_Try, /*On fail goto*//*Label 20074*/ GIMT_Encode4(1419725), // Rule ID 21517 //
     /* 1419642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1419645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1419650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1419653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1419656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1419659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1419662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419681 */     // MIs[0] Operand 5
     /* 1419681 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419692 */     // MIs[0] policy
     /* 1419692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419702 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1419705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419724 */     // GIR_Coverage, 21517,
     /* 1419724 */     GIR_EraseRootFromParent_Done,
     /* 1419725 */   // Label 20074: @1419725
     /* 1419725 */   GIM_Try, /*On fail goto*//*Label 20075*/ GIMT_Encode4(1419813), // Rule ID 21520 //
     /* 1419730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1419733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1419738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1419741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1419744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1419747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1419750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419769 */     // MIs[0] Operand 5
     /* 1419769 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419780 */     // MIs[0] policy
     /* 1419780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419790 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1419793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419812 */     // GIR_Coverage, 21520,
     /* 1419812 */     GIR_EraseRootFromParent_Done,
     /* 1419813 */   // Label 20075: @1419813
     /* 1419813 */   GIM_Try, /*On fail goto*//*Label 20076*/ GIMT_Encode4(1419901), // Rule ID 21521 //
     /* 1419818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1419821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1419826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1419829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1419832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1419835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1419838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419857 */     // MIs[0] Operand 5
     /* 1419857 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419868 */     // MIs[0] policy
     /* 1419868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419878 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1419881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419887 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419900 */     // GIR_Coverage, 21521,
     /* 1419900 */     GIR_EraseRootFromParent_Done,
     /* 1419901 */   // Label 20076: @1419901
     /* 1419901 */   GIM_Try, /*On fail goto*//*Label 20077*/ GIMT_Encode4(1419989), // Rule ID 21524 //
     /* 1419906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1419909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1419914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1419917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1419920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1419923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1419926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419945 */     // MIs[0] Operand 5
     /* 1419945 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419956 */     // MIs[0] policy
     /* 1419956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1419969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419988 */     // GIR_Coverage, 21524,
     /* 1419988 */     GIR_EraseRootFromParent_Done,
     /* 1419989 */   // Label 20077: @1419989
     /* 1419989 */   GIM_Try, /*On fail goto*//*Label 20078*/ GIMT_Encode4(1420077), // Rule ID 21525 //
     /* 1419994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1419997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1420002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1420005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1420008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1420011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1420014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420033 */     // MIs[0] Operand 5
     /* 1420033 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1420044 */     // MIs[0] policy
     /* 1420044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420054 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1420057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1420063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1420065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420076 */     // GIR_Coverage, 21525,
     /* 1420076 */     GIR_EraseRootFromParent_Done,
     /* 1420077 */   // Label 20078: @1420077
     /* 1420077 */   GIM_Try, /*On fail goto*//*Label 20079*/ GIMT_Encode4(1420165), // Rule ID 21528 //
     /* 1420082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1420085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1420090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1420093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1420096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1420099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1420102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1420109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420121 */     // MIs[0] Operand 5
     /* 1420121 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1420132 */     // MIs[0] policy
     /* 1420132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420142 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1420145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1420151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1420153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420164 */     // GIR_Coverage, 21528,
     /* 1420164 */     GIR_EraseRootFromParent_Done,
     /* 1420165 */   // Label 20079: @1420165
     /* 1420165 */   GIM_Try, /*On fail goto*//*Label 20080*/ GIMT_Encode4(1420253), // Rule ID 21529 //
     /* 1420170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1420173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1420178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1420181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1420184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1420187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1420190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1420197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420209 */     // MIs[0] Operand 5
     /* 1420209 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1420220 */     // MIs[0] policy
     /* 1420220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1420233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1420239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1420241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420252 */     // GIR_Coverage, 21529,
     /* 1420252 */     GIR_EraseRootFromParent_Done,
     /* 1420253 */   // Label 20080: @1420253
     /* 1420253 */   GIM_Try, /*On fail goto*//*Label 20081*/ GIMT_Encode4(1420341), // Rule ID 21532 //
     /* 1420258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1420261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1420266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1420269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1420272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1420275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1420278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1420285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420297 */     // MIs[0] Operand 5
     /* 1420297 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1420308 */     // MIs[0] policy
     /* 1420308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420318 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1420321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1420327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1420329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420340 */     // GIR_Coverage, 21532,
     /* 1420340 */     GIR_EraseRootFromParent_Done,
     /* 1420341 */   // Label 20081: @1420341
     /* 1420341 */   GIM_Try, /*On fail goto*//*Label 20082*/ GIMT_Encode4(1420429), // Rule ID 21533 //
     /* 1420346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1420349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1420354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1420357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1420360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1420363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1420366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1420373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420385 */     // MIs[0] Operand 5
     /* 1420385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1420396 */     // MIs[0] policy
     /* 1420396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420406 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1420409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1420415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1420417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420428 */     // GIR_Coverage, 21533,
     /* 1420428 */     GIR_EraseRootFromParent_Done,
     /* 1420429 */   // Label 20082: @1420429
     /* 1420429 */   GIM_Try, /*On fail goto*//*Label 20083*/ GIMT_Encode4(1420517), // Rule ID 21536 //
     /* 1420434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1420437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1420442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1420445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1420448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1420451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1420454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420473 */     // MIs[0] Operand 5
     /* 1420473 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1420484 */     // MIs[0] policy
     /* 1420484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420494 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1420497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1420503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1420505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420516 */     // GIR_Coverage, 21536,
     /* 1420516 */     GIR_EraseRootFromParent_Done,
     /* 1420517 */   // Label 20083: @1420517
     /* 1420517 */   GIM_Try, /*On fail goto*//*Label 20084*/ GIMT_Encode4(1420605), // Rule ID 21537 //
     /* 1420522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1420525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1420530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1420533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1420536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1420539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1420542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420561 */     // MIs[0] Operand 5
     /* 1420561 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1420572 */     // MIs[0] policy
     /* 1420572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420582 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1420585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1420591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1420593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420604 */     // GIR_Coverage, 21537,
     /* 1420604 */     GIR_EraseRootFromParent_Done,
     /* 1420605 */   // Label 20084: @1420605
     /* 1420605 */   GIM_Try, /*On fail goto*//*Label 20085*/ GIMT_Encode4(1420693), // Rule ID 21540 //
     /* 1420610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1420613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1420618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1420621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1420624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1420627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1420630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420649 */     // MIs[0] Operand 5
     /* 1420649 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1420660 */     // MIs[0] policy
     /* 1420660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420670 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1420673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1420679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1420681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420692 */     // GIR_Coverage, 21540,
     /* 1420692 */     GIR_EraseRootFromParent_Done,
     /* 1420693 */   // Label 20085: @1420693
     /* 1420693 */   GIM_Try, /*On fail goto*//*Label 20086*/ GIMT_Encode4(1420781), // Rule ID 21541 //
     /* 1420698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1420701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1420706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1420709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1420712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1420715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1420718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420737 */     // MIs[0] Operand 5
     /* 1420737 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1420748 */     // MIs[0] policy
     /* 1420748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420758 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1420761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1420767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1420769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420780 */     // GIR_Coverage, 21541,
     /* 1420780 */     GIR_EraseRootFromParent_Done,
     /* 1420781 */   // Label 20086: @1420781
     /* 1420781 */   GIM_Try, /*On fail goto*//*Label 20087*/ GIMT_Encode4(1420869), // Rule ID 21544 //
     /* 1420786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1420789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1420794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1420797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1420800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1420803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1420806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420825 */     // MIs[0] Operand 5
     /* 1420825 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1420836 */     // MIs[0] policy
     /* 1420836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420846 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1420849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1420855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1420857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420868 */     // GIR_Coverage, 21544,
     /* 1420868 */     GIR_EraseRootFromParent_Done,
     /* 1420869 */   // Label 20087: @1420869
     /* 1420869 */   GIM_Try, /*On fail goto*//*Label 20088*/ GIMT_Encode4(1420957), // Rule ID 21545 //
     /* 1420874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1420877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1420882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1420885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1420888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1420891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1420894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420913 */     // MIs[0] Operand 5
     /* 1420913 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1420924 */     // MIs[0] policy
     /* 1420924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420934 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1420937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1420943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1420945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420956 */     // GIR_Coverage, 21545,
     /* 1420956 */     GIR_EraseRootFromParent_Done,
     /* 1420957 */   // Label 20088: @1420957
     /* 1420957 */   GIM_Try, /*On fail goto*//*Label 20089*/ GIMT_Encode4(1421045), // Rule ID 21548 //
     /* 1420962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1420965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1420970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1420973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1420976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1420979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1420982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421001 */     // MIs[0] Operand 5
     /* 1421001 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1421012 */     // MIs[0] policy
     /* 1421012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421022 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1421025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1421031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1421033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421044 */     // GIR_Coverage, 21548,
     /* 1421044 */     GIR_EraseRootFromParent_Done,
     /* 1421045 */   // Label 20089: @1421045
     /* 1421045 */   GIM_Try, /*On fail goto*//*Label 20090*/ GIMT_Encode4(1421133), // Rule ID 21549 //
     /* 1421050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1421053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1421058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1421061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1421064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1421067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1421070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421089 */     // MIs[0] Operand 5
     /* 1421089 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1421100 */     // MIs[0] policy
     /* 1421100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421110 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1421113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1421119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1421121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421132 */     // GIR_Coverage, 21549,
     /* 1421132 */     GIR_EraseRootFromParent_Done,
     /* 1421133 */   // Label 20090: @1421133
     /* 1421133 */   GIM_Try, /*On fail goto*//*Label 20091*/ GIMT_Encode4(1421221), // Rule ID 21552 //
     /* 1421138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1421141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1421146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1421149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1421152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1421155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1421158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421177 */     // MIs[0] Operand 5
     /* 1421177 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1421188 */     // MIs[0] policy
     /* 1421188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421198 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1421201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1421207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1421209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421220 */     // GIR_Coverage, 21552,
     /* 1421220 */     GIR_EraseRootFromParent_Done,
     /* 1421221 */   // Label 20091: @1421221
     /* 1421221 */   GIM_Try, /*On fail goto*//*Label 20092*/ GIMT_Encode4(1421309), // Rule ID 21553 //
     /* 1421226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1421229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1421234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1421237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1421240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1421243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1421246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421265 */     // MIs[0] Operand 5
     /* 1421265 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1421276 */     // MIs[0] policy
     /* 1421276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421286 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1421289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1421295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1421297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421308 */     // GIR_Coverage, 21553,
     /* 1421308 */     GIR_EraseRootFromParent_Done,
     /* 1421309 */   // Label 20092: @1421309
     /* 1421309 */   GIM_Try, /*On fail goto*//*Label 20093*/ GIMT_Encode4(1421397), // Rule ID 21556 //
     /* 1421314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1421317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1421322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1421325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1421328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1421331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1421334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1421341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421353 */     // MIs[0] Operand 5
     /* 1421353 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1421364 */     // MIs[0] policy
     /* 1421364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421374 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1421377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1421383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1421385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421396 */     // GIR_Coverage, 21556,
     /* 1421396 */     GIR_EraseRootFromParent_Done,
     /* 1421397 */   // Label 20093: @1421397
     /* 1421397 */   GIM_Try, /*On fail goto*//*Label 20094*/ GIMT_Encode4(1421485), // Rule ID 21557 //
     /* 1421402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1421405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1421410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1421413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1421416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1421419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1421422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1421429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421441 */     // MIs[0] Operand 5
     /* 1421441 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1421452 */     // MIs[0] policy
     /* 1421452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421462 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1421465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1421471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1421473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421484 */     // GIR_Coverage, 21557,
     /* 1421484 */     GIR_EraseRootFromParent_Done,
     /* 1421485 */   // Label 20094: @1421485
     /* 1421485 */   GIM_Try, /*On fail goto*//*Label 20095*/ GIMT_Encode4(1421573), // Rule ID 21560 //
     /* 1421490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1421493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1421498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1421501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1421504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1421507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1421510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421529 */     // MIs[0] Operand 5
     /* 1421529 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1421540 */     // MIs[0] policy
     /* 1421540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421550 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1421553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1421559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1421561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421572 */     // GIR_Coverage, 21560,
     /* 1421572 */     GIR_EraseRootFromParent_Done,
     /* 1421573 */   // Label 20095: @1421573
     /* 1421573 */   GIM_Try, /*On fail goto*//*Label 20096*/ GIMT_Encode4(1421661), // Rule ID 21561 //
     /* 1421578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1421581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1421586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1421589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1421592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1421595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1421598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421617 */     // MIs[0] Operand 5
     /* 1421617 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1421628 */     // MIs[0] policy
     /* 1421628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421638 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1421641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1421647 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1421649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421660 */     // GIR_Coverage, 21561,
     /* 1421660 */     GIR_EraseRootFromParent_Done,
     /* 1421661 */   // Label 20096: @1421661
     /* 1421661 */   GIM_Try, /*On fail goto*//*Label 20097*/ GIMT_Encode4(1421749), // Rule ID 21564 //
     /* 1421666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1421669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1421674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1421677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1421680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1421683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1421686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421705 */     // MIs[0] Operand 5
     /* 1421705 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1421716 */     // MIs[0] policy
     /* 1421716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1421729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1421735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1421737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421748 */     // GIR_Coverage, 21564,
     /* 1421748 */     GIR_EraseRootFromParent_Done,
     /* 1421749 */   // Label 20097: @1421749
     /* 1421749 */   GIM_Try, /*On fail goto*//*Label 20098*/ GIMT_Encode4(1421837), // Rule ID 21565 //
     /* 1421754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1421757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1421762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1421765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1421768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1421771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1421774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421793 */     // MIs[0] Operand 5
     /* 1421793 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1421804 */     // MIs[0] policy
     /* 1421804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421814 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1421817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1421823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1421825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421836 */     // GIR_Coverage, 21565,
     /* 1421836 */     GIR_EraseRootFromParent_Done,
     /* 1421837 */   // Label 20098: @1421837
     /* 1421837 */   GIM_Try, /*On fail goto*//*Label 20099*/ GIMT_Encode4(1421925), // Rule ID 21568 //
     /* 1421842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1421845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1421850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1421853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1421856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1421859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1421862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421881 */     // MIs[0] Operand 5
     /* 1421881 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1421892 */     // MIs[0] policy
     /* 1421892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1421905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1421911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1421913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421924 */     // GIR_Coverage, 21568,
     /* 1421924 */     GIR_EraseRootFromParent_Done,
     /* 1421925 */   // Label 20099: @1421925
     /* 1421925 */   GIM_Try, /*On fail goto*//*Label 20100*/ GIMT_Encode4(1422013), // Rule ID 21569 //
     /* 1421930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1421933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1421938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1421941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1421944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1421947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1421950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421969 */     // MIs[0] Operand 5
     /* 1421969 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1421980 */     // MIs[0] policy
     /* 1421980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421990 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1421993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1421999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1422001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422012 */     // GIR_Coverage, 21569,
     /* 1422012 */     GIR_EraseRootFromParent_Done,
     /* 1422013 */   // Label 20100: @1422013
     /* 1422013 */   GIM_Try, /*On fail goto*//*Label 20101*/ GIMT_Encode4(1422101), // Rule ID 21572 //
     /* 1422018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1422021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1422026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1422029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1422032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1422035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1422038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422057 */     // MIs[0] Operand 5
     /* 1422057 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1422068 */     // MIs[0] policy
     /* 1422068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422078 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1422081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1422087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1422089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422100 */     // GIR_Coverage, 21572,
     /* 1422100 */     GIR_EraseRootFromParent_Done,
     /* 1422101 */   // Label 20101: @1422101
     /* 1422101 */   GIM_Try, /*On fail goto*//*Label 20102*/ GIMT_Encode4(1422189), // Rule ID 21573 //
     /* 1422106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1422109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1422114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1422117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1422120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1422123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1422126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422145 */     // MIs[0] Operand 5
     /* 1422145 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1422156 */     // MIs[0] policy
     /* 1422156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422166 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1422169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1422175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1422177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422188 */     // GIR_Coverage, 21573,
     /* 1422188 */     GIR_EraseRootFromParent_Done,
     /* 1422189 */   // Label 20102: @1422189
     /* 1422189 */   GIM_Try, /*On fail goto*//*Label 20103*/ GIMT_Encode4(1422277), // Rule ID 21576 //
     /* 1422194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1422197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1422202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1422205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1422208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1422211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1422214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422233 */     // MIs[0] Operand 5
     /* 1422233 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1422244 */     // MIs[0] policy
     /* 1422244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422254 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1422257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1422263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1422265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422276 */     // GIR_Coverage, 21576,
     /* 1422276 */     GIR_EraseRootFromParent_Done,
     /* 1422277 */   // Label 20103: @1422277
     /* 1422277 */   GIM_Try, /*On fail goto*//*Label 20104*/ GIMT_Encode4(1422365), // Rule ID 21577 //
     /* 1422282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1422285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1422290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1422293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1422296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1422299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1422302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422321 */     // MIs[0] Operand 5
     /* 1422321 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1422332 */     // MIs[0] policy
     /* 1422332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422342 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1422345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1422351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1422353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422364 */     // GIR_Coverage, 21577,
     /* 1422364 */     GIR_EraseRootFromParent_Done,
     /* 1422365 */   // Label 20104: @1422365
     /* 1422365 */   GIM_Try, /*On fail goto*//*Label 20105*/ GIMT_Encode4(1422453), // Rule ID 21580 //
     /* 1422370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1422373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1422378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1422381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1422384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1422387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1422390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422409 */     // MIs[0] Operand 5
     /* 1422409 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1422420 */     // MIs[0] policy
     /* 1422420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422430 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1422433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1422439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1422441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422452 */     // GIR_Coverage, 21580,
     /* 1422452 */     GIR_EraseRootFromParent_Done,
     /* 1422453 */   // Label 20105: @1422453
     /* 1422453 */   GIM_Try, /*On fail goto*//*Label 20106*/ GIMT_Encode4(1422541), // Rule ID 21581 //
     /* 1422458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1422461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1422466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1422469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1422472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1422475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1422478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422497 */     // MIs[0] Operand 5
     /* 1422497 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1422508 */     // MIs[0] policy
     /* 1422508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422518 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1422521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1422527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1422529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422540 */     // GIR_Coverage, 21581,
     /* 1422540 */     GIR_EraseRootFromParent_Done,
     /* 1422541 */   // Label 20106: @1422541
     /* 1422541 */   GIM_Try, /*On fail goto*//*Label 20107*/ GIMT_Encode4(1422629), // Rule ID 21584 //
     /* 1422546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1422549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1422554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1422557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1422560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1422563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1422566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422585 */     // MIs[0] Operand 5
     /* 1422585 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1422596 */     // MIs[0] policy
     /* 1422596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422606 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1422609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1422615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1422617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422628 */     // GIR_Coverage, 21584,
     /* 1422628 */     GIR_EraseRootFromParent_Done,
     /* 1422629 */   // Label 20107: @1422629
     /* 1422629 */   GIM_Try, /*On fail goto*//*Label 20108*/ GIMT_Encode4(1422717), // Rule ID 21585 //
     /* 1422634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1422637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1422642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1422645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1422648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1422651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1422654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422673 */     // MIs[0] Operand 5
     /* 1422673 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1422684 */     // MIs[0] policy
     /* 1422684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422694 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1422697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1422703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1422705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422716 */     // GIR_Coverage, 21585,
     /* 1422716 */     GIR_EraseRootFromParent_Done,
     /* 1422717 */   // Label 20108: @1422717
     /* 1422717 */   GIM_Try, /*On fail goto*//*Label 20109*/ GIMT_Encode4(1422805), // Rule ID 21588 //
     /* 1422722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1422725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1422730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1422733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1422736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1422739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1422742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422761 */     // MIs[0] Operand 5
     /* 1422761 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1422772 */     // MIs[0] policy
     /* 1422772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1422785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1422791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1422793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422804 */     // GIR_Coverage, 21588,
     /* 1422804 */     GIR_EraseRootFromParent_Done,
     /* 1422805 */   // Label 20109: @1422805
     /* 1422805 */   GIM_Try, /*On fail goto*//*Label 20110*/ GIMT_Encode4(1422893), // Rule ID 21589 //
     /* 1422810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1422813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1422818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1422821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1422824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1422827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1422830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422849 */     // MIs[0] Operand 5
     /* 1422849 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1422860 */     // MIs[0] policy
     /* 1422860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1422873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1422879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1422881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422892 */     // GIR_Coverage, 21589,
     /* 1422892 */     GIR_EraseRootFromParent_Done,
     /* 1422893 */   // Label 20110: @1422893
     /* 1422893 */   GIM_Try, /*On fail goto*//*Label 20111*/ GIMT_Encode4(1422981), // Rule ID 21592 //
     /* 1422898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1422901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1422906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1422909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1422912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1422915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1422918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422937 */     // MIs[0] Operand 5
     /* 1422937 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1422948 */     // MIs[0] policy
     /* 1422948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422958 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1422961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1422967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1422969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422980 */     // GIR_Coverage, 21592,
     /* 1422980 */     GIR_EraseRootFromParent_Done,
     /* 1422981 */   // Label 20111: @1422981
     /* 1422981 */   GIM_Try, /*On fail goto*//*Label 20112*/ GIMT_Encode4(1423069), // Rule ID 21593 //
     /* 1422986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1422989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1422994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1422997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1423000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1423003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1423006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423025 */     // MIs[0] Operand 5
     /* 1423025 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1423036 */     // MIs[0] policy
     /* 1423036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1423049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1423055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1423057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423068 */     // GIR_Coverage, 21593,
     /* 1423068 */     GIR_EraseRootFromParent_Done,
     /* 1423069 */   // Label 20112: @1423069
     /* 1423069 */   GIM_Try, /*On fail goto*//*Label 20113*/ GIMT_Encode4(1423168), // Rule ID 2790 //
     /* 1423074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1423085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1423088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1423091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1423097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423124 */     // MIs[1] Operand 1
     /* 1423124 */     // No operand predicates
     /* 1423124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423128 */     // MIs[0] policy
     /* 1423128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423140 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1423143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423149 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423167 */     // GIR_Coverage, 2790,
     /* 1423167 */     GIR_EraseRootFromParent_Done,
     /* 1423168 */   // Label 20113: @1423168
     /* 1423168 */   GIM_Try, /*On fail goto*//*Label 20114*/ GIMT_Encode4(1423267), // Rule ID 2791 //
     /* 1423173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1423184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1423187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1423190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1423196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423223 */     // MIs[1] Operand 1
     /* 1423223 */     // No operand predicates
     /* 1423223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423227 */     // MIs[0] policy
     /* 1423227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423239 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1423242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423248 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423266 */     // GIR_Coverage, 2791,
     /* 1423266 */     GIR_EraseRootFromParent_Done,
     /* 1423267 */   // Label 20114: @1423267
     /* 1423267 */   GIM_Try, /*On fail goto*//*Label 20115*/ GIMT_Encode4(1423366), // Rule ID 2798 //
     /* 1423272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1423283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1423286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1423289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423322 */     // MIs[1] Operand 1
     /* 1423322 */     // No operand predicates
     /* 1423322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423326 */     // MIs[0] policy
     /* 1423326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423338 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1423341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423347 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423365 */     // GIR_Coverage, 2798,
     /* 1423365 */     GIR_EraseRootFromParent_Done,
     /* 1423366 */   // Label 20115: @1423366
     /* 1423366 */   GIM_Try, /*On fail goto*//*Label 20116*/ GIMT_Encode4(1423465), // Rule ID 2799 //
     /* 1423371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1423382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1423385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1423388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423421 */     // MIs[1] Operand 1
     /* 1423421 */     // No operand predicates
     /* 1423421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423425 */     // MIs[0] policy
     /* 1423425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423437 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1423440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423446 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423464 */     // GIR_Coverage, 2799,
     /* 1423464 */     GIR_EraseRootFromParent_Done,
     /* 1423465 */   // Label 20116: @1423465
     /* 1423465 */   GIM_Try, /*On fail goto*//*Label 20117*/ GIMT_Encode4(1423564), // Rule ID 2806 //
     /* 1423470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1423481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1423484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1423487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1423493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423520 */     // MIs[1] Operand 1
     /* 1423520 */     // No operand predicates
     /* 1423520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423524 */     // MIs[0] policy
     /* 1423524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423536 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1423539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423545 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423563 */     // GIR_Coverage, 2806,
     /* 1423563 */     GIR_EraseRootFromParent_Done,
     /* 1423564 */   // Label 20117: @1423564
     /* 1423564 */   GIM_Try, /*On fail goto*//*Label 20118*/ GIMT_Encode4(1423663), // Rule ID 2807 //
     /* 1423569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1423580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1423583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1423586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1423592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423619 */     // MIs[1] Operand 1
     /* 1423619 */     // No operand predicates
     /* 1423619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423623 */     // MIs[0] policy
     /* 1423623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423635 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1423638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423644 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423662 */     // GIR_Coverage, 2807,
     /* 1423662 */     GIR_EraseRootFromParent_Done,
     /* 1423663 */   // Label 20118: @1423663
     /* 1423663 */   GIM_Try, /*On fail goto*//*Label 20119*/ GIMT_Encode4(1423762), // Rule ID 2814 //
     /* 1423668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1423679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1423682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1423685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1423691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423718 */     // MIs[1] Operand 1
     /* 1423718 */     // No operand predicates
     /* 1423718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423722 */     // MIs[0] policy
     /* 1423722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423734 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1423737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423743 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1423758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423761 */     // GIR_Coverage, 2814,
     /* 1423761 */     GIR_EraseRootFromParent_Done,
     /* 1423762 */   // Label 20119: @1423762
     /* 1423762 */   GIM_Try, /*On fail goto*//*Label 20120*/ GIMT_Encode4(1423861), // Rule ID 2815 //
     /* 1423767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1423778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1423781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1423784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1423790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423817 */     // MIs[1] Operand 1
     /* 1423817 */     // No operand predicates
     /* 1423817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423821 */     // MIs[0] policy
     /* 1423821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423833 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1423836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423842 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1423857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423860 */     // GIR_Coverage, 2815,
     /* 1423860 */     GIR_EraseRootFromParent_Done,
     /* 1423861 */   // Label 20120: @1423861
     /* 1423861 */   GIM_Try, /*On fail goto*//*Label 20121*/ GIMT_Encode4(1423960), // Rule ID 2822 //
     /* 1423866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1423877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1423880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1423883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423916 */     // MIs[1] Operand 1
     /* 1423916 */     // No operand predicates
     /* 1423916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423920 */     // MIs[0] policy
     /* 1423920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423932 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1423935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423941 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1423956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423959 */     // GIR_Coverage, 2822,
     /* 1423959 */     GIR_EraseRootFromParent_Done,
     /* 1423960 */   // Label 20121: @1423960
     /* 1423960 */   GIM_Try, /*On fail goto*//*Label 20122*/ GIMT_Encode4(1424059), // Rule ID 2823 //
     /* 1423965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1423976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1423979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1423982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1424015 */     // MIs[1] Operand 1
     /* 1424015 */     // No operand predicates
     /* 1424015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424019 */     // MIs[0] policy
     /* 1424019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424031 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424040 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1424045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424058 */     // GIR_Coverage, 2823,
     /* 1424058 */     GIR_EraseRootFromParent_Done,
     /* 1424059 */   // Label 20122: @1424059
     /* 1424059 */   GIM_Try, /*On fail goto*//*Label 20123*/ GIMT_Encode4(1424158), // Rule ID 2830 //
     /* 1424064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1424072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1424075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1424078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1424081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1424114 */     // MIs[1] Operand 1
     /* 1424114 */     // No operand predicates
     /* 1424114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424118 */     // MIs[0] policy
     /* 1424118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424130 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424139 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1424144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424157 */     // GIR_Coverage, 2830,
     /* 1424157 */     GIR_EraseRootFromParent_Done,
     /* 1424158 */   // Label 20123: @1424158
     /* 1424158 */   GIM_Try, /*On fail goto*//*Label 20124*/ GIMT_Encode4(1424257), // Rule ID 2831 //
     /* 1424163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1424171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1424174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1424177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1424180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1424213 */     // MIs[1] Operand 1
     /* 1424213 */     // No operand predicates
     /* 1424213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424217 */     // MIs[0] policy
     /* 1424217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424229 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424238 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1424243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424256 */     // GIR_Coverage, 2831,
     /* 1424256 */     GIR_EraseRootFromParent_Done,
     /* 1424257 */   // Label 20124: @1424257
     /* 1424257 */   GIM_Try, /*On fail goto*//*Label 20125*/ GIMT_Encode4(1424356), // Rule ID 2838 //
     /* 1424262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1424270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1424273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1424276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1424279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1424285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1424312 */     // MIs[1] Operand 1
     /* 1424312 */     // No operand predicates
     /* 1424312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424316 */     // MIs[0] policy
     /* 1424316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424328 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1424331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424337 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1424342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424355 */     // GIR_Coverage, 2838,
     /* 1424355 */     GIR_EraseRootFromParent_Done,
     /* 1424356 */   // Label 20125: @1424356
     /* 1424356 */   GIM_Try, /*On fail goto*//*Label 20126*/ GIMT_Encode4(1424455), // Rule ID 2839 //
     /* 1424361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1424369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1424372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1424375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1424378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1424384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1424411 */     // MIs[1] Operand 1
     /* 1424411 */     // No operand predicates
     /* 1424411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424415 */     // MIs[0] policy
     /* 1424415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424427 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1424430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424436 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1424441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424454 */     // GIR_Coverage, 2839,
     /* 1424454 */     GIR_EraseRootFromParent_Done,
     /* 1424455 */   // Label 20126: @1424455
     /* 1424455 */   GIM_Try, /*On fail goto*//*Label 20127*/ GIMT_Encode4(1424554), // Rule ID 2846 //
     /* 1424460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1424468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1424471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1424474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1424477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1424510 */     // MIs[1] Operand 1
     /* 1424510 */     // No operand predicates
     /* 1424510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424514 */     // MIs[0] policy
     /* 1424514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424526 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1424529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424535 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1424540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424553 */     // GIR_Coverage, 2846,
     /* 1424553 */     GIR_EraseRootFromParent_Done,
     /* 1424554 */   // Label 20127: @1424554
     /* 1424554 */   GIM_Try, /*On fail goto*//*Label 20128*/ GIMT_Encode4(1424653), // Rule ID 2847 //
     /* 1424559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1424567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1424570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1424573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1424576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1424609 */     // MIs[1] Operand 1
     /* 1424609 */     // No operand predicates
     /* 1424609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424613 */     // MIs[0] policy
     /* 1424613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424625 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1424628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424634 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1424639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424652 */     // GIR_Coverage, 2847,
     /* 1424652 */     GIR_EraseRootFromParent_Done,
     /* 1424653 */   // Label 20128: @1424653
     /* 1424653 */   GIM_Try, /*On fail goto*//*Label 20129*/ GIMT_Encode4(1424752), // Rule ID 2854 //
     /* 1424658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1424666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1424669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1424672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1424675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1424708 */     // MIs[1] Operand 1
     /* 1424708 */     // No operand predicates
     /* 1424708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424712 */     // MIs[0] policy
     /* 1424712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1424727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424733 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1424738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424751 */     // GIR_Coverage, 2854,
     /* 1424751 */     GIR_EraseRootFromParent_Done,
     /* 1424752 */   // Label 20129: @1424752
     /* 1424752 */   GIM_Try, /*On fail goto*//*Label 20130*/ GIMT_Encode4(1424851), // Rule ID 2855 //
     /* 1424757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1424765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1424768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1424771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1424774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1424807 */     // MIs[1] Operand 1
     /* 1424807 */     // No operand predicates
     /* 1424807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424811 */     // MIs[0] policy
     /* 1424811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424823 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1424826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424832 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1424837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424850 */     // GIR_Coverage, 2855,
     /* 1424850 */     GIR_EraseRootFromParent_Done,
     /* 1424851 */   // Label 20130: @1424851
     /* 1424851 */   GIM_Try, /*On fail goto*//*Label 20131*/ GIMT_Encode4(1424950), // Rule ID 2862 //
     /* 1424856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1424859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1424864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1424867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1424870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1424873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424902 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1424906 */     // MIs[1] Operand 1
     /* 1424906 */     // No operand predicates
     /* 1424906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424910 */     // MIs[0] policy
     /* 1424910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424922 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1424925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424931 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1424936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1424946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424949 */     // GIR_Coverage, 2862,
     /* 1424949 */     GIR_EraseRootFromParent_Done,
     /* 1424950 */   // Label 20131: @1424950
     /* 1424950 */   GIM_Try, /*On fail goto*//*Label 20132*/ GIMT_Encode4(1425049), // Rule ID 2863 //
     /* 1424955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1424958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1424963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1424966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1424969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1424972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1425005 */     // MIs[1] Operand 1
     /* 1425005 */     // No operand predicates
     /* 1425005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425009 */     // MIs[0] policy
     /* 1425009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425021 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425030 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1425035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425048 */     // GIR_Coverage, 2863,
     /* 1425048 */     GIR_EraseRootFromParent_Done,
     /* 1425049 */   // Label 20132: @1425049
     /* 1425049 */   GIM_Try, /*On fail goto*//*Label 20133*/ GIMT_Encode4(1425148), // Rule ID 2870 //
     /* 1425054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1425062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1425065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1425068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1425071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1425077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1425084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1425104 */     // MIs[1] Operand 1
     /* 1425104 */     // No operand predicates
     /* 1425104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425108 */     // MIs[0] policy
     /* 1425108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425120 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1425123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425129 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1425134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425147 */     // GIR_Coverage, 2870,
     /* 1425147 */     GIR_EraseRootFromParent_Done,
     /* 1425148 */   // Label 20133: @1425148
     /* 1425148 */   GIM_Try, /*On fail goto*//*Label 20134*/ GIMT_Encode4(1425247), // Rule ID 2871 //
     /* 1425153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1425161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1425164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1425167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1425170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1425176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1425183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1425203 */     // MIs[1] Operand 1
     /* 1425203 */     // No operand predicates
     /* 1425203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425207 */     // MIs[0] policy
     /* 1425207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425219 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1425222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425228 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1425233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425246 */     // GIR_Coverage, 2871,
     /* 1425246 */     GIR_EraseRootFromParent_Done,
     /* 1425247 */   // Label 20134: @1425247
     /* 1425247 */   GIM_Try, /*On fail goto*//*Label 20135*/ GIMT_Encode4(1425346), // Rule ID 2878 //
     /* 1425252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1425260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1425263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1425266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1425269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1425275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1425282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1425302 */     // MIs[1] Operand 1
     /* 1425302 */     // No operand predicates
     /* 1425302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425306 */     // MIs[0] policy
     /* 1425306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425318 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1425321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425327 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1425332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425345 */     // GIR_Coverage, 2878,
     /* 1425345 */     GIR_EraseRootFromParent_Done,
     /* 1425346 */   // Label 20135: @1425346
     /* 1425346 */   GIM_Try, /*On fail goto*//*Label 20136*/ GIMT_Encode4(1425445), // Rule ID 2879 //
     /* 1425351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1425359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1425362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1425365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1425368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1425374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1425381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1425401 */     // MIs[1] Operand 1
     /* 1425401 */     // No operand predicates
     /* 1425401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425405 */     // MIs[0] policy
     /* 1425405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425417 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1425420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425426 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1425431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425444 */     // GIR_Coverage, 2879,
     /* 1425444 */     GIR_EraseRootFromParent_Done,
     /* 1425445 */   // Label 20136: @1425445
     /* 1425445 */   GIM_Try, /*On fail goto*//*Label 20137*/ GIMT_Encode4(1425544), // Rule ID 2886 //
     /* 1425450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1425458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1425461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1425464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1425467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1425473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1425480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1425500 */     // MIs[1] Operand 1
     /* 1425500 */     // No operand predicates
     /* 1425500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425504 */     // MIs[0] policy
     /* 1425504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425516 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1425519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425525 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1425530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425543 */     // GIR_Coverage, 2886,
     /* 1425543 */     GIR_EraseRootFromParent_Done,
     /* 1425544 */   // Label 20137: @1425544
     /* 1425544 */   GIM_Try, /*On fail goto*//*Label 20138*/ GIMT_Encode4(1425643), // Rule ID 2887 //
     /* 1425549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1425557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1425560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1425563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1425566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1425572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1425579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1425599 */     // MIs[1] Operand 1
     /* 1425599 */     // No operand predicates
     /* 1425599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425603 */     // MIs[0] policy
     /* 1425603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425615 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1425618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425624 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1425629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425642 */     // GIR_Coverage, 2887,
     /* 1425642 */     GIR_EraseRootFromParent_Done,
     /* 1425643 */   // Label 20138: @1425643
     /* 1425643 */   GIM_Try, /*On fail goto*//*Label 20139*/ GIMT_Encode4(1425742), // Rule ID 2894 //
     /* 1425648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1425656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1425659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1425662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1425665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1425671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1425678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1425698 */     // MIs[1] Operand 1
     /* 1425698 */     // No operand predicates
     /* 1425698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425702 */     // MIs[0] policy
     /* 1425702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1425717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425723 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1425728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425741 */     // GIR_Coverage, 2894,
     /* 1425741 */     GIR_EraseRootFromParent_Done,
     /* 1425742 */   // Label 20139: @1425742
     /* 1425742 */   GIM_Try, /*On fail goto*//*Label 20140*/ GIMT_Encode4(1425841), // Rule ID 2895 //
     /* 1425747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1425755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1425758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1425761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1425764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1425770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1425777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1425797 */     // MIs[1] Operand 1
     /* 1425797 */     // No operand predicates
     /* 1425797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425801 */     // MIs[0] policy
     /* 1425801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425813 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1425816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425822 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1425827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425840 */     // GIR_Coverage, 2895,
     /* 1425840 */     GIR_EraseRootFromParent_Done,
     /* 1425841 */   // Label 20140: @1425841
     /* 1425841 */   GIM_Try, /*On fail goto*//*Label 20141*/ GIMT_Encode4(1425940), // Rule ID 2902 //
     /* 1425846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1425854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1425857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1425860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1425863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1425869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1425876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1425896 */     // MIs[1] Operand 1
     /* 1425896 */     // No operand predicates
     /* 1425896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425900 */     // MIs[0] policy
     /* 1425900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425912 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1425915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425921 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1425926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425939 */     // GIR_Coverage, 2902,
     /* 1425939 */     GIR_EraseRootFromParent_Done,
     /* 1425940 */   // Label 20141: @1425940
     /* 1425940 */   GIM_Try, /*On fail goto*//*Label 20142*/ GIMT_Encode4(1426039), // Rule ID 2903 //
     /* 1425945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1425953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1425956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1425959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1425962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1425968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1425975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1425995 */     // MIs[1] Operand 1
     /* 1425995 */     // No operand predicates
     /* 1425995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425999 */     // MIs[0] policy
     /* 1425999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426011 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426020 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1426025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426038 */     // GIR_Coverage, 2903,
     /* 1426038 */     GIR_EraseRootFromParent_Done,
     /* 1426039 */   // Label 20142: @1426039
     /* 1426039 */   GIM_Try, /*On fail goto*//*Label 20143*/ GIMT_Encode4(1426138), // Rule ID 2910 //
     /* 1426044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1426052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1426055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1426058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1426061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1426067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1426094 */     // MIs[1] Operand 1
     /* 1426094 */     // No operand predicates
     /* 1426094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426098 */     // MIs[0] policy
     /* 1426098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426110 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426119 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1426124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426137 */     // GIR_Coverage, 2910,
     /* 1426137 */     GIR_EraseRootFromParent_Done,
     /* 1426138 */   // Label 20143: @1426138
     /* 1426138 */   GIM_Try, /*On fail goto*//*Label 20144*/ GIMT_Encode4(1426237), // Rule ID 2911 //
     /* 1426143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1426151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1426154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1426157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1426160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1426166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1426193 */     // MIs[1] Operand 1
     /* 1426193 */     // No operand predicates
     /* 1426193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426197 */     // MIs[0] policy
     /* 1426197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426209 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426218 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1426223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426236 */     // GIR_Coverage, 2911,
     /* 1426236 */     GIR_EraseRootFromParent_Done,
     /* 1426237 */   // Label 20144: @1426237
     /* 1426237 */   GIM_Try, /*On fail goto*//*Label 20145*/ GIMT_Encode4(1426336), // Rule ID 2918 //
     /* 1426242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1426250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1426253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1426256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1426259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1426265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1426292 */     // MIs[1] Operand 1
     /* 1426292 */     // No operand predicates
     /* 1426292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426296 */     // MIs[0] policy
     /* 1426296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426308 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426317 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1426322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426335 */     // GIR_Coverage, 2918,
     /* 1426335 */     GIR_EraseRootFromParent_Done,
     /* 1426336 */   // Label 20145: @1426336
     /* 1426336 */   GIM_Try, /*On fail goto*//*Label 20146*/ GIMT_Encode4(1426435), // Rule ID 2919 //
     /* 1426341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1426349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1426352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1426355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1426358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1426364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1426391 */     // MIs[1] Operand 1
     /* 1426391 */     // No operand predicates
     /* 1426391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426395 */     // MIs[0] policy
     /* 1426395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426416 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1426421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426434 */     // GIR_Coverage, 2919,
     /* 1426434 */     GIR_EraseRootFromParent_Done,
     /* 1426435 */   // Label 20146: @1426435
     /* 1426435 */   GIM_Try, /*On fail goto*//*Label 20147*/ GIMT_Encode4(1426534), // Rule ID 2926 //
     /* 1426440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1426448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1426451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1426454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1426457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1426490 */     // MIs[1] Operand 1
     /* 1426490 */     // No operand predicates
     /* 1426490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426494 */     // MIs[0] policy
     /* 1426494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426506 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426515 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1426520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426533 */     // GIR_Coverage, 2926,
     /* 1426533 */     GIR_EraseRootFromParent_Done,
     /* 1426534 */   // Label 20147: @1426534
     /* 1426534 */   GIM_Try, /*On fail goto*//*Label 20148*/ GIMT_Encode4(1426633), // Rule ID 2927 //
     /* 1426539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1426547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1426550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1426553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1426556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1426589 */     // MIs[1] Operand 1
     /* 1426589 */     // No operand predicates
     /* 1426589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426593 */     // MIs[0] policy
     /* 1426593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426605 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426614 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1426619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426632 */     // GIR_Coverage, 2927,
     /* 1426632 */     GIR_EraseRootFromParent_Done,
     /* 1426633 */   // Label 20148: @1426633
     /* 1426633 */   GIM_Try, /*On fail goto*//*Label 20149*/ GIMT_Encode4(1426732), // Rule ID 2934 //
     /* 1426638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1426646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1426649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1426652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1426655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1426688 */     // MIs[1] Operand 1
     /* 1426688 */     // No operand predicates
     /* 1426688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426692 */     // MIs[0] policy
     /* 1426692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426704 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426713 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1426718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426731 */     // GIR_Coverage, 2934,
     /* 1426731 */     GIR_EraseRootFromParent_Done,
     /* 1426732 */   // Label 20149: @1426732
     /* 1426732 */   GIM_Try, /*On fail goto*//*Label 20150*/ GIMT_Encode4(1426831), // Rule ID 2935 //
     /* 1426737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1426745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1426748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1426751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1426754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1426787 */     // MIs[1] Operand 1
     /* 1426787 */     // No operand predicates
     /* 1426787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426791 */     // MIs[0] policy
     /* 1426791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426803 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426812 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1426817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426830 */     // GIR_Coverage, 2935,
     /* 1426830 */     GIR_EraseRootFromParent_Done,
     /* 1426831 */   // Label 20150: @1426831
     /* 1426831 */   GIM_Try, /*On fail goto*//*Label 20151*/ GIMT_Encode4(1426930), // Rule ID 2942 //
     /* 1426836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1426839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1426844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1426847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1426850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1426853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1426859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1426886 */     // MIs[1] Operand 1
     /* 1426886 */     // No operand predicates
     /* 1426886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426890 */     // MIs[0] policy
     /* 1426890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426902 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426911 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1426916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1426926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426929 */     // GIR_Coverage, 2942,
     /* 1426929 */     GIR_EraseRootFromParent_Done,
     /* 1426930 */   // Label 20151: @1426930
     /* 1426930 */   GIM_Try, /*On fail goto*//*Label 20152*/ GIMT_Encode4(1427029), // Rule ID 2943 //
     /* 1426935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1426938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1426943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1426946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1426949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1426952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1426958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1426985 */     // MIs[1] Operand 1
     /* 1426985 */     // No operand predicates
     /* 1426985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426989 */     // MIs[0] policy
     /* 1426989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427001 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1427004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427010 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1427015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427028 */     // GIR_Coverage, 2943,
     /* 1427028 */     GIR_EraseRootFromParent_Done,
     /* 1427029 */   // Label 20152: @1427029
     /* 1427029 */   GIM_Try, /*On fail goto*//*Label 20153*/ GIMT_Encode4(1427128), // Rule ID 2950 //
     /* 1427034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1427042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1427045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1427048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1427051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1427084 */     // MIs[1] Operand 1
     /* 1427084 */     // No operand predicates
     /* 1427084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427088 */     // MIs[0] policy
     /* 1427088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427100 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1427103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427109 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1427114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427127 */     // GIR_Coverage, 2950,
     /* 1427127 */     GIR_EraseRootFromParent_Done,
     /* 1427128 */   // Label 20153: @1427128
     /* 1427128 */   GIM_Try, /*On fail goto*//*Label 20154*/ GIMT_Encode4(1427227), // Rule ID 2951 //
     /* 1427133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1427136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1427141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1427144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1427147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1427150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1427183 */     // MIs[1] Operand 1
     /* 1427183 */     // No operand predicates
     /* 1427183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427187 */     // MIs[0] policy
     /* 1427187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427199 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1427202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427208 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1427213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427226 */     // GIR_Coverage, 2951,
     /* 1427226 */     GIR_EraseRootFromParent_Done,
     /* 1427227 */   // Label 20154: @1427227
     /* 1427227 */   GIM_Try, /*On fail goto*//*Label 20155*/ GIMT_Encode4(1427326), // Rule ID 2958 //
     /* 1427232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1427240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1427243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1427246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1427249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1427255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1427282 */     // MIs[1] Operand 1
     /* 1427282 */     // No operand predicates
     /* 1427282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427286 */     // MIs[0] policy
     /* 1427286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427298 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427307 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1427312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427325 */     // GIR_Coverage, 2958,
     /* 1427325 */     GIR_EraseRootFromParent_Done,
     /* 1427326 */   // Label 20155: @1427326
     /* 1427326 */   GIM_Try, /*On fail goto*//*Label 20156*/ GIMT_Encode4(1427425), // Rule ID 2959 //
     /* 1427331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1427334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1427339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1427342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1427345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1427348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1427354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1427381 */     // MIs[1] Operand 1
     /* 1427381 */     // No operand predicates
     /* 1427381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427385 */     // MIs[0] policy
     /* 1427385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427397 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427406 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1427411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427424 */     // GIR_Coverage, 2959,
     /* 1427424 */     GIR_EraseRootFromParent_Done,
     /* 1427425 */   // Label 20156: @1427425
     /* 1427425 */   GIM_Try, /*On fail goto*//*Label 20157*/ GIMT_Encode4(1427522), // Rule ID 3142 //
     /* 1427430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1427441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1427444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1427447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1427453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427480 */     // MIs[1] Operand 1
     /* 1427480 */     // No operand predicates
     /* 1427480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427484 */     // MIs[0] policy
     /* 1427484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1427499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427521 */     // GIR_Coverage, 3142,
     /* 1427521 */     GIR_EraseRootFromParent_Done,
     /* 1427522 */   // Label 20157: @1427522
     /* 1427522 */   GIM_Try, /*On fail goto*//*Label 20158*/ GIMT_Encode4(1427619), // Rule ID 3143 //
     /* 1427527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1427538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1427541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1427544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1427550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427577 */     // MIs[1] Operand 1
     /* 1427577 */     // No operand predicates
     /* 1427577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427581 */     // MIs[0] policy
     /* 1427581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427593 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1427596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427618 */     // GIR_Coverage, 3143,
     /* 1427618 */     GIR_EraseRootFromParent_Done,
     /* 1427619 */   // Label 20158: @1427619
     /* 1427619 */   GIM_Try, /*On fail goto*//*Label 20159*/ GIMT_Encode4(1427716), // Rule ID 3146 //
     /* 1427624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1427635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1427638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1427641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427674 */     // MIs[1] Operand 1
     /* 1427674 */     // No operand predicates
     /* 1427674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427678 */     // MIs[0] policy
     /* 1427678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427690 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1427693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427715 */     // GIR_Coverage, 3146,
     /* 1427715 */     GIR_EraseRootFromParent_Done,
     /* 1427716 */   // Label 20159: @1427716
     /* 1427716 */   GIM_Try, /*On fail goto*//*Label 20160*/ GIMT_Encode4(1427813), // Rule ID 3147 //
     /* 1427721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1427732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1427735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1427738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427771 */     // MIs[1] Operand 1
     /* 1427771 */     // No operand predicates
     /* 1427771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427775 */     // MIs[0] policy
     /* 1427775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427787 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1427790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427812 */     // GIR_Coverage, 3147,
     /* 1427812 */     GIR_EraseRootFromParent_Done,
     /* 1427813 */   // Label 20160: @1427813
     /* 1427813 */   GIM_Try, /*On fail goto*//*Label 20161*/ GIMT_Encode4(1427910), // Rule ID 3150 //
     /* 1427818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1427829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1427832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1427835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427868 */     // MIs[1] Operand 1
     /* 1427868 */     // No operand predicates
     /* 1427868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427872 */     // MIs[0] policy
     /* 1427872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427884 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1427887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427909 */     // GIR_Coverage, 3150,
     /* 1427909 */     GIR_EraseRootFromParent_Done,
     /* 1427910 */   // Label 20161: @1427910
     /* 1427910 */   GIM_Try, /*On fail goto*//*Label 20162*/ GIMT_Encode4(1428007), // Rule ID 3151 //
     /* 1427915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1427926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1427929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1427932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427965 */     // MIs[1] Operand 1
     /* 1427965 */     // No operand predicates
     /* 1427965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427969 */     // MIs[0] policy
     /* 1427969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427981 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1427984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428006 */     // GIR_Coverage, 3151,
     /* 1428006 */     GIR_EraseRootFromParent_Done,
     /* 1428007 */   // Label 20162: @1428007
     /* 1428007 */   GIM_Try, /*On fail goto*//*Label 20163*/ GIMT_Encode4(1428104), // Rule ID 3154 //
     /* 1428012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1428023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1428026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1428029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428062 */     // MIs[1] Operand 1
     /* 1428062 */     // No operand predicates
     /* 1428062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428066 */     // MIs[0] policy
     /* 1428066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428078 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1428081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428103 */     // GIR_Coverage, 3154,
     /* 1428103 */     GIR_EraseRootFromParent_Done,
     /* 1428104 */   // Label 20163: @1428104
     /* 1428104 */   GIM_Try, /*On fail goto*//*Label 20164*/ GIMT_Encode4(1428201), // Rule ID 3155 //
     /* 1428109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1428120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1428123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1428126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428159 */     // MIs[1] Operand 1
     /* 1428159 */     // No operand predicates
     /* 1428159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428163 */     // MIs[0] policy
     /* 1428163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428175 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1428178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428200 */     // GIR_Coverage, 3155,
     /* 1428200 */     GIR_EraseRootFromParent_Done,
     /* 1428201 */   // Label 20164: @1428201
     /* 1428201 */   GIM_Try, /*On fail goto*//*Label 20165*/ GIMT_Encode4(1428298), // Rule ID 3158 //
     /* 1428206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1428217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1428220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1428223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428256 */     // MIs[1] Operand 1
     /* 1428256 */     // No operand predicates
     /* 1428256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428260 */     // MIs[0] policy
     /* 1428260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428272 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1428275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428297 */     // GIR_Coverage, 3158,
     /* 1428297 */     GIR_EraseRootFromParent_Done,
     /* 1428298 */   // Label 20165: @1428298
     /* 1428298 */   GIM_Try, /*On fail goto*//*Label 20166*/ GIMT_Encode4(1428395), // Rule ID 3159 //
     /* 1428303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1428314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1428317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1428320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428353 */     // MIs[1] Operand 1
     /* 1428353 */     // No operand predicates
     /* 1428353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428357 */     // MIs[0] policy
     /* 1428357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428369 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1428372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428394 */     // GIR_Coverage, 3159,
     /* 1428394 */     GIR_EraseRootFromParent_Done,
     /* 1428395 */   // Label 20166: @1428395
     /* 1428395 */   GIM_Try, /*On fail goto*//*Label 20167*/ GIMT_Encode4(1428492), // Rule ID 3162 //
     /* 1428400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1428411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1428414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1428417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428450 */     // MIs[1] Operand 1
     /* 1428450 */     // No operand predicates
     /* 1428450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428454 */     // MIs[0] policy
     /* 1428454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1428469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1428488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428491 */     // GIR_Coverage, 3162,
     /* 1428491 */     GIR_EraseRootFromParent_Done,
     /* 1428492 */   // Label 20167: @1428492
     /* 1428492 */   GIM_Try, /*On fail goto*//*Label 20168*/ GIMT_Encode4(1428589), // Rule ID 3163 //
     /* 1428497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1428508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1428511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1428514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428547 */     // MIs[1] Operand 1
     /* 1428547 */     // No operand predicates
     /* 1428547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428551 */     // MIs[0] policy
     /* 1428551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428563 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1428566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1428585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428588 */     // GIR_Coverage, 3163,
     /* 1428588 */     GIR_EraseRootFromParent_Done,
     /* 1428589 */   // Label 20168: @1428589
     /* 1428589 */   GIM_Try, /*On fail goto*//*Label 20169*/ GIMT_Encode4(1428686), // Rule ID 3166 //
     /* 1428594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1428605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1428608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1428611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1428617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428644 */     // MIs[1] Operand 1
     /* 1428644 */     // No operand predicates
     /* 1428644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428648 */     // MIs[0] policy
     /* 1428648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428660 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1428663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428685 */     // GIR_Coverage, 3166,
     /* 1428685 */     GIR_EraseRootFromParent_Done,
     /* 1428686 */   // Label 20169: @1428686
     /* 1428686 */   GIM_Try, /*On fail goto*//*Label 20170*/ GIMT_Encode4(1428783), // Rule ID 3167 //
     /* 1428691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1428702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1428705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1428708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1428714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428741 */     // MIs[1] Operand 1
     /* 1428741 */     // No operand predicates
     /* 1428741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428745 */     // MIs[0] policy
     /* 1428745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428757 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1428760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428782 */     // GIR_Coverage, 3167,
     /* 1428782 */     GIR_EraseRootFromParent_Done,
     /* 1428783 */   // Label 20170: @1428783
     /* 1428783 */   GIM_Try, /*On fail goto*//*Label 20171*/ GIMT_Encode4(1428880), // Rule ID 3170 //
     /* 1428788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1428799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1428802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1428805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428838 */     // MIs[1] Operand 1
     /* 1428838 */     // No operand predicates
     /* 1428838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428842 */     // MIs[0] policy
     /* 1428842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428854 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1428857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428879 */     // GIR_Coverage, 3170,
     /* 1428879 */     GIR_EraseRootFromParent_Done,
     /* 1428880 */   // Label 20171: @1428880
     /* 1428880 */   GIM_Try, /*On fail goto*//*Label 20172*/ GIMT_Encode4(1428977), // Rule ID 3171 //
     /* 1428885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1428896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1428899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1428902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428935 */     // MIs[1] Operand 1
     /* 1428935 */     // No operand predicates
     /* 1428935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428939 */     // MIs[0] policy
     /* 1428939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428951 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1428954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428976 */     // GIR_Coverage, 3171,
     /* 1428976 */     GIR_EraseRootFromParent_Done,
     /* 1428977 */   // Label 20172: @1428977
     /* 1428977 */   GIM_Try, /*On fail goto*//*Label 20173*/ GIMT_Encode4(1429074), // Rule ID 3174 //
     /* 1428982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1428993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1428996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1428999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429032 */     // MIs[1] Operand 1
     /* 1429032 */     // No operand predicates
     /* 1429032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429036 */     // MIs[0] policy
     /* 1429036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1429051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429073 */     // GIR_Coverage, 3174,
     /* 1429073 */     GIR_EraseRootFromParent_Done,
     /* 1429074 */   // Label 20173: @1429074
     /* 1429074 */   GIM_Try, /*On fail goto*//*Label 20174*/ GIMT_Encode4(1429171), // Rule ID 3175 //
     /* 1429079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1429087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1429090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1429093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1429096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429129 */     // MIs[1] Operand 1
     /* 1429129 */     // No operand predicates
     /* 1429129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429133 */     // MIs[0] policy
     /* 1429133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429145 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1429148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429170 */     // GIR_Coverage, 3175,
     /* 1429170 */     GIR_EraseRootFromParent_Done,
     /* 1429171 */   // Label 20174: @1429171
     /* 1429171 */   GIM_Try, /*On fail goto*//*Label 20175*/ GIMT_Encode4(1429268), // Rule ID 3178 //
     /* 1429176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1429179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1429184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1429187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1429190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1429193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429226 */     // MIs[1] Operand 1
     /* 1429226 */     // No operand predicates
     /* 1429226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429230 */     // MIs[0] policy
     /* 1429230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429242 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1429245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429267 */     // GIR_Coverage, 3178,
     /* 1429267 */     GIR_EraseRootFromParent_Done,
     /* 1429268 */   // Label 20175: @1429268
     /* 1429268 */   GIM_Try, /*On fail goto*//*Label 20176*/ GIMT_Encode4(1429365), // Rule ID 3179 //
     /* 1429273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1429276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1429281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1429284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1429287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1429290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429323 */     // MIs[1] Operand 1
     /* 1429323 */     // No operand predicates
     /* 1429323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429327 */     // MIs[0] policy
     /* 1429327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429339 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1429342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429364 */     // GIR_Coverage, 3179,
     /* 1429364 */     GIR_EraseRootFromParent_Done,
     /* 1429365 */   // Label 20176: @1429365
     /* 1429365 */   GIM_Try, /*On fail goto*//*Label 20177*/ GIMT_Encode4(1429462), // Rule ID 3182 //
     /* 1429370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1429378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1429381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1429384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1429387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1429393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1429400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429420 */     // MIs[1] Operand 1
     /* 1429420 */     // No operand predicates
     /* 1429420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429424 */     // MIs[0] policy
     /* 1429424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429436 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1429439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429461 */     // GIR_Coverage, 3182,
     /* 1429461 */     GIR_EraseRootFromParent_Done,
     /* 1429462 */   // Label 20177: @1429462
     /* 1429462 */   GIM_Try, /*On fail goto*//*Label 20178*/ GIMT_Encode4(1429559), // Rule ID 3183 //
     /* 1429467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1429475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1429478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1429481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1429484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1429490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1429497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429517 */     // MIs[1] Operand 1
     /* 1429517 */     // No operand predicates
     /* 1429517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429521 */     // MIs[0] policy
     /* 1429521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429533 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1429536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429558 */     // GIR_Coverage, 3183,
     /* 1429558 */     GIR_EraseRootFromParent_Done,
     /* 1429559 */   // Label 20178: @1429559
     /* 1429559 */   GIM_Try, /*On fail goto*//*Label 20179*/ GIMT_Encode4(1429656), // Rule ID 3186 //
     /* 1429564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1429572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1429575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1429578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1429581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1429587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1429594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429614 */     // MIs[1] Operand 1
     /* 1429614 */     // No operand predicates
     /* 1429614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429618 */     // MIs[0] policy
     /* 1429618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429630 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1429633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429655 */     // GIR_Coverage, 3186,
     /* 1429655 */     GIR_EraseRootFromParent_Done,
     /* 1429656 */   // Label 20179: @1429656
     /* 1429656 */   GIM_Try, /*On fail goto*//*Label 20180*/ GIMT_Encode4(1429753), // Rule ID 3187 //
     /* 1429661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1429669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1429672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1429675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1429678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1429684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1429691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429711 */     // MIs[1] Operand 1
     /* 1429711 */     // No operand predicates
     /* 1429711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429715 */     // MIs[0] policy
     /* 1429715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429727 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1429730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429752 */     // GIR_Coverage, 3187,
     /* 1429752 */     GIR_EraseRootFromParent_Done,
     /* 1429753 */   // Label 20180: @1429753
     /* 1429753 */   GIM_Try, /*On fail goto*//*Label 20181*/ GIMT_Encode4(1429850), // Rule ID 3190 //
     /* 1429758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1429766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1429769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1429772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1429775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1429781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1429788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429808 */     // MIs[1] Operand 1
     /* 1429808 */     // No operand predicates
     /* 1429808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429812 */     // MIs[0] policy
     /* 1429812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429824 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1429827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429849 */     // GIR_Coverage, 3190,
     /* 1429849 */     GIR_EraseRootFromParent_Done,
     /* 1429850 */   // Label 20181: @1429850
     /* 1429850 */   GIM_Try, /*On fail goto*//*Label 20182*/ GIMT_Encode4(1429947), // Rule ID 3191 //
     /* 1429855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1429863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1429866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1429869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1429872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1429878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1429885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429905 */     // MIs[1] Operand 1
     /* 1429905 */     // No operand predicates
     /* 1429905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429909 */     // MIs[0] policy
     /* 1429909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429921 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1429924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429946 */     // GIR_Coverage, 3191,
     /* 1429946 */     GIR_EraseRootFromParent_Done,
     /* 1429947 */   // Label 20182: @1429947
     /* 1429947 */   GIM_Try, /*On fail goto*//*Label 20183*/ GIMT_Encode4(1430044), // Rule ID 3194 //
     /* 1429952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1429960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1429963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1429966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1429969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1429982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430002 */     // MIs[1] Operand 1
     /* 1430002 */     // No operand predicates
     /* 1430002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430006 */     // MIs[0] policy
     /* 1430006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1430021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430043 */     // GIR_Coverage, 3194,
     /* 1430043 */     GIR_EraseRootFromParent_Done,
     /* 1430044 */   // Label 20183: @1430044
     /* 1430044 */   GIM_Try, /*On fail goto*//*Label 20184*/ GIMT_Encode4(1430141), // Rule ID 3195 //
     /* 1430049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1430057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1430060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1430063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1430066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1430072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430099 */     // MIs[1] Operand 1
     /* 1430099 */     // No operand predicates
     /* 1430099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430103 */     // MIs[0] policy
     /* 1430103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430115 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1430118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430140 */     // GIR_Coverage, 3195,
     /* 1430140 */     GIR_EraseRootFromParent_Done,
     /* 1430141 */   // Label 20184: @1430141
     /* 1430141 */   GIM_Try, /*On fail goto*//*Label 20185*/ GIMT_Encode4(1430238), // Rule ID 3198 //
     /* 1430146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1430154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1430157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1430160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1430163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1430169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430192 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430196 */     // MIs[1] Operand 1
     /* 1430196 */     // No operand predicates
     /* 1430196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430200 */     // MIs[0] policy
     /* 1430200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430212 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1430215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430237 */     // GIR_Coverage, 3198,
     /* 1430237 */     GIR_EraseRootFromParent_Done,
     /* 1430238 */   // Label 20185: @1430238
     /* 1430238 */   GIM_Try, /*On fail goto*//*Label 20186*/ GIMT_Encode4(1430335), // Rule ID 3199 //
     /* 1430243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1430251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1430254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1430257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1430260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1430266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430293 */     // MIs[1] Operand 1
     /* 1430293 */     // No operand predicates
     /* 1430293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430297 */     // MIs[0] policy
     /* 1430297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430309 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1430312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430334 */     // GIR_Coverage, 3199,
     /* 1430334 */     GIR_EraseRootFromParent_Done,
     /* 1430335 */   // Label 20186: @1430335
     /* 1430335 */   GIM_Try, /*On fail goto*//*Label 20187*/ GIMT_Encode4(1430432), // Rule ID 3202 //
     /* 1430340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1430348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1430351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1430354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1430357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430390 */     // MIs[1] Operand 1
     /* 1430390 */     // No operand predicates
     /* 1430390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430394 */     // MIs[0] policy
     /* 1430394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430406 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1430409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430431 */     // GIR_Coverage, 3202,
     /* 1430431 */     GIR_EraseRootFromParent_Done,
     /* 1430432 */   // Label 20187: @1430432
     /* 1430432 */   GIM_Try, /*On fail goto*//*Label 20188*/ GIMT_Encode4(1430529), // Rule ID 3203 //
     /* 1430437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1430445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1430448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1430451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1430454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430487 */     // MIs[1] Operand 1
     /* 1430487 */     // No operand predicates
     /* 1430487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430491 */     // MIs[0] policy
     /* 1430491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430503 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1430506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430528 */     // GIR_Coverage, 3203,
     /* 1430528 */     GIR_EraseRootFromParent_Done,
     /* 1430529 */   // Label 20188: @1430529
     /* 1430529 */   GIM_Try, /*On fail goto*//*Label 20189*/ GIMT_Encode4(1430626), // Rule ID 3206 //
     /* 1430534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1430542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1430545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1430548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1430551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1430557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430584 */     // MIs[1] Operand 1
     /* 1430584 */     // No operand predicates
     /* 1430584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430588 */     // MIs[0] policy
     /* 1430588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1430603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1430622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430625 */     // GIR_Coverage, 3206,
     /* 1430625 */     GIR_EraseRootFromParent_Done,
     /* 1430626 */   // Label 20189: @1430626
     /* 1430626 */   GIM_Try, /*On fail goto*//*Label 20190*/ GIMT_Encode4(1430723), // Rule ID 3207 //
     /* 1430631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1430639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1430642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1430645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1430648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1430654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430681 */     // MIs[1] Operand 1
     /* 1430681 */     // No operand predicates
     /* 1430681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430685 */     // MIs[0] policy
     /* 1430685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430697 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1430700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1430719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430722 */     // GIR_Coverage, 3207,
     /* 1430722 */     GIR_EraseRootFromParent_Done,
     /* 1430723 */   // Label 20190: @1430723
     /* 1430723 */   GIM_Try, /*On fail goto*//*Label 20191*/ GIMT_Encode4(1430820), // Rule ID 3210 //
     /* 1430728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1430736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1430739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1430742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1430745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1430751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430778 */     // MIs[1] Operand 1
     /* 1430778 */     // No operand predicates
     /* 1430778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430782 */     // MIs[0] policy
     /* 1430782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430794 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1430797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1430816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430819 */     // GIR_Coverage, 3210,
     /* 1430819 */     GIR_EraseRootFromParent_Done,
     /* 1430820 */   // Label 20191: @1430820
     /* 1430820 */   GIM_Try, /*On fail goto*//*Label 20192*/ GIMT_Encode4(1430917), // Rule ID 3211 //
     /* 1430825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1430833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1430836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1430839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1430842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1430848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430875 */     // MIs[1] Operand 1
     /* 1430875 */     // No operand predicates
     /* 1430875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430879 */     // MIs[0] policy
     /* 1430879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430891 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1430894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1430913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430916 */     // GIR_Coverage, 3211,
     /* 1430916 */     GIR_EraseRootFromParent_Done,
     /* 1430917 */   // Label 20192: @1430917
     /* 1430917 */   GIM_Try, /*On fail goto*//*Label 20193*/ GIMT_Encode4(1431014), // Rule ID 3214 //
     /* 1430922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1430930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1430933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1430936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1430939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1430945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430972 */     // MIs[1] Operand 1
     /* 1430972 */     // No operand predicates
     /* 1430972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430976 */     // MIs[0] policy
     /* 1430976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430988 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1430991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431013 */     // GIR_Coverage, 3214,
     /* 1431013 */     GIR_EraseRootFromParent_Done,
     /* 1431014 */   // Label 20193: @1431014
     /* 1431014 */   GIM_Try, /*On fail goto*//*Label 20194*/ GIMT_Encode4(1431111), // Rule ID 3215 //
     /* 1431019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1431027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1431030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1431033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1431036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431069 */     // MIs[1] Operand 1
     /* 1431069 */     // No operand predicates
     /* 1431069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431073 */     // MIs[0] policy
     /* 1431073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431085 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1431088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431110 */     // GIR_Coverage, 3215,
     /* 1431110 */     GIR_EraseRootFromParent_Done,
     /* 1431111 */   // Label 20194: @1431111
     /* 1431111 */   GIM_Try, /*On fail goto*//*Label 20195*/ GIMT_Encode4(1431208), // Rule ID 3218 //
     /* 1431116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1431119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1431124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1431127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1431130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1431133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1431139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431166 */     // MIs[1] Operand 1
     /* 1431166 */     // No operand predicates
     /* 1431166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431170 */     // MIs[0] policy
     /* 1431170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1431185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431207 */     // GIR_Coverage, 3218,
     /* 1431207 */     GIR_EraseRootFromParent_Done,
     /* 1431208 */   // Label 20195: @1431208
     /* 1431208 */   GIM_Try, /*On fail goto*//*Label 20196*/ GIMT_Encode4(1431305), // Rule ID 3219 //
     /* 1431213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1431216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1431221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1431224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1431227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1431230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1431236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431263 */     // MIs[1] Operand 1
     /* 1431263 */     // No operand predicates
     /* 1431263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431267 */     // MIs[0] policy
     /* 1431267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431279 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1431282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431304 */     // GIR_Coverage, 3219,
     /* 1431304 */     GIR_EraseRootFromParent_Done,
     /* 1431305 */   // Label 20196: @1431305
     /* 1431305 */   GIM_Try, /*On fail goto*//*Label 20197*/ GIMT_Encode4(1431402), // Rule ID 3222 //
     /* 1431310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1431313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1431318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1431321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1431324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1431327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431360 */     // MIs[1] Operand 1
     /* 1431360 */     // No operand predicates
     /* 1431360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431364 */     // MIs[0] policy
     /* 1431364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431376 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1431379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431401 */     // GIR_Coverage, 3222,
     /* 1431401 */     GIR_EraseRootFromParent_Done,
     /* 1431402 */   // Label 20197: @1431402
     /* 1431402 */   GIM_Try, /*On fail goto*//*Label 20198*/ GIMT_Encode4(1431499), // Rule ID 3223 //
     /* 1431407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1431410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1431415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1431418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1431421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1431424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431457 */     // MIs[1] Operand 1
     /* 1431457 */     // No operand predicates
     /* 1431457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431461 */     // MIs[0] policy
     /* 1431461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431473 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1431476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431498 */     // GIR_Coverage, 3223,
     /* 1431498 */     GIR_EraseRootFromParent_Done,
     /* 1431499 */   // Label 20198: @1431499
     /* 1431499 */   GIM_Try, /*On fail goto*//*Label 20199*/ GIMT_Encode4(1431596), // Rule ID 3226 //
     /* 1431504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1431507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1431512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1431515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1431518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1431521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431554 */     // MIs[1] Operand 1
     /* 1431554 */     // No operand predicates
     /* 1431554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431558 */     // MIs[0] policy
     /* 1431558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431570 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1431573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431595 */     // GIR_Coverage, 3226,
     /* 1431595 */     GIR_EraseRootFromParent_Done,
     /* 1431596 */   // Label 20199: @1431596
     /* 1431596 */   GIM_Try, /*On fail goto*//*Label 20200*/ GIMT_Encode4(1431693), // Rule ID 3227 //
     /* 1431601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1431604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1431609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1431612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1431615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1431618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431651 */     // MIs[1] Operand 1
     /* 1431651 */     // No operand predicates
     /* 1431651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431655 */     // MIs[0] policy
     /* 1431655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431667 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1431670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431692 */     // GIR_Coverage, 3227,
     /* 1431692 */     GIR_EraseRootFromParent_Done,
     /* 1431693 */   // Label 20200: @1431693
     /* 1431693 */   GIM_Try, /*On fail goto*//*Label 20201*/ GIMT_Encode4(1431790), // Rule ID 3494 //
     /* 1431698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1431709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1431712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1431715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1431721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431744 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431748 */     // MIs[1] Operand 1
     /* 1431748 */     // No operand predicates
     /* 1431748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431752 */     // MIs[0] policy
     /* 1431752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431764 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1431767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1431786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431789 */     // GIR_Coverage, 3494,
     /* 1431789 */     GIR_EraseRootFromParent_Done,
     /* 1431790 */   // Label 20201: @1431790
     /* 1431790 */   GIM_Try, /*On fail goto*//*Label 20202*/ GIMT_Encode4(1431887), // Rule ID 3495 //
     /* 1431795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1431806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1431809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1431812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1431818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431845 */     // MIs[1] Operand 1
     /* 1431845 */     // No operand predicates
     /* 1431845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431849 */     // MIs[0] policy
     /* 1431849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431861 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1431864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1431883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431886 */     // GIR_Coverage, 3495,
     /* 1431886 */     GIR_EraseRootFromParent_Done,
     /* 1431887 */   // Label 20202: @1431887
     /* 1431887 */   GIM_Try, /*On fail goto*//*Label 20203*/ GIMT_Encode4(1431984), // Rule ID 3498 //
     /* 1431892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1431903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1431906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1431909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1431915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431942 */     // MIs[1] Operand 1
     /* 1431942 */     // No operand predicates
     /* 1431942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431946 */     // MIs[0] policy
     /* 1431946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431958 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1431961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1431980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431983 */     // GIR_Coverage, 3498,
     /* 1431983 */     GIR_EraseRootFromParent_Done,
     /* 1431984 */   // Label 20203: @1431984
     /* 1431984 */   GIM_Try, /*On fail goto*//*Label 20204*/ GIMT_Encode4(1432081), // Rule ID 3499 //
     /* 1431989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1432000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1432003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1432006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432039 */     // MIs[1] Operand 1
     /* 1432039 */     // No operand predicates
     /* 1432039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432043 */     // MIs[0] policy
     /* 1432043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432055 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1432058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432080 */     // GIR_Coverage, 3499,
     /* 1432080 */     GIR_EraseRootFromParent_Done,
     /* 1432081 */   // Label 20204: @1432081
     /* 1432081 */   GIM_Try, /*On fail goto*//*Label 20205*/ GIMT_Encode4(1432178), // Rule ID 3502 //
     /* 1432086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1432097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1432100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1432103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1432109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432136 */     // MIs[1] Operand 1
     /* 1432136 */     // No operand predicates
     /* 1432136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432140 */     // MIs[0] policy
     /* 1432140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432152 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1432155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432177 */     // GIR_Coverage, 3502,
     /* 1432177 */     GIR_EraseRootFromParent_Done,
     /* 1432178 */   // Label 20205: @1432178
     /* 1432178 */   GIM_Try, /*On fail goto*//*Label 20206*/ GIMT_Encode4(1432275), // Rule ID 3503 //
     /* 1432183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1432194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1432197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1432200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1432206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432233 */     // MIs[1] Operand 1
     /* 1432233 */     // No operand predicates
     /* 1432233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432237 */     // MIs[0] policy
     /* 1432237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432249 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1432252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432274 */     // GIR_Coverage, 3503,
     /* 1432274 */     GIR_EraseRootFromParent_Done,
     /* 1432275 */   // Label 20206: @1432275
     /* 1432275 */   GIM_Try, /*On fail goto*//*Label 20207*/ GIMT_Encode4(1432372), // Rule ID 3506 //
     /* 1432280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1432291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1432294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1432297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432330 */     // MIs[1] Operand 1
     /* 1432330 */     // No operand predicates
     /* 1432330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432334 */     // MIs[0] policy
     /* 1432334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1432349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432371 */     // GIR_Coverage, 3506,
     /* 1432371 */     GIR_EraseRootFromParent_Done,
     /* 1432372 */   // Label 20207: @1432372
     /* 1432372 */   GIM_Try, /*On fail goto*//*Label 20208*/ GIMT_Encode4(1432469), // Rule ID 3507 //
     /* 1432377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1432388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1432391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1432394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432427 */     // MIs[1] Operand 1
     /* 1432427 */     // No operand predicates
     /* 1432427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432431 */     // MIs[0] policy
     /* 1432431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432443 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1432446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432468 */     // GIR_Coverage, 3507,
     /* 1432468 */     GIR_EraseRootFromParent_Done,
     /* 1432469 */   // Label 20208: @1432469
     /* 1432469 */   GIM_Try, /*On fail goto*//*Label 20209*/ GIMT_Encode4(1432566), // Rule ID 3510 //
     /* 1432474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1432485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1432488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1432491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432524 */     // MIs[1] Operand 1
     /* 1432524 */     // No operand predicates
     /* 1432524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432528 */     // MIs[0] policy
     /* 1432528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432540 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1432543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432565 */     // GIR_Coverage, 3510,
     /* 1432565 */     GIR_EraseRootFromParent_Done,
     /* 1432566 */   // Label 20209: @1432566
     /* 1432566 */   GIM_Try, /*On fail goto*//*Label 20210*/ GIMT_Encode4(1432663), // Rule ID 3511 //
     /* 1432571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1432582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1432585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1432588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432621 */     // MIs[1] Operand 1
     /* 1432621 */     // No operand predicates
     /* 1432621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432625 */     // MIs[0] policy
     /* 1432625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432637 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1432640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432662 */     // GIR_Coverage, 3511,
     /* 1432662 */     GIR_EraseRootFromParent_Done,
     /* 1432663 */   // Label 20210: @1432663
     /* 1432663 */   GIM_Try, /*On fail goto*//*Label 20211*/ GIMT_Encode4(1432760), // Rule ID 3514 //
     /* 1432668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1432679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1432682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1432685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432718 */     // MIs[1] Operand 1
     /* 1432718 */     // No operand predicates
     /* 1432718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432722 */     // MIs[0] policy
     /* 1432722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432734 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1432737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1432756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432759 */     // GIR_Coverage, 3514,
     /* 1432759 */     GIR_EraseRootFromParent_Done,
     /* 1432760 */   // Label 20211: @1432760
     /* 1432760 */   GIM_Try, /*On fail goto*//*Label 20212*/ GIMT_Encode4(1432857), // Rule ID 3515 //
     /* 1432765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1432776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1432779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1432782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432815 */     // MIs[1] Operand 1
     /* 1432815 */     // No operand predicates
     /* 1432815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432819 */     // MIs[0] policy
     /* 1432819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432831 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1432834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1432853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432856 */     // GIR_Coverage, 3515,
     /* 1432856 */     GIR_EraseRootFromParent_Done,
     /* 1432857 */   // Label 20212: @1432857
     /* 1432857 */   GIM_Try, /*On fail goto*//*Label 20213*/ GIMT_Encode4(1432954), // Rule ID 3518 //
     /* 1432862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1432873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1432876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1432879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1432885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432912 */     // MIs[1] Operand 1
     /* 1432912 */     // No operand predicates
     /* 1432912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432916 */     // MIs[0] policy
     /* 1432916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432928 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1432931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432953 */     // GIR_Coverage, 3518,
     /* 1432953 */     GIR_EraseRootFromParent_Done,
     /* 1432954 */   // Label 20213: @1432954
     /* 1432954 */   GIM_Try, /*On fail goto*//*Label 20214*/ GIMT_Encode4(1433051), // Rule ID 3519 //
     /* 1432959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1432970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1432973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1432976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1432982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433009 */     // MIs[1] Operand 1
     /* 1433009 */     // No operand predicates
     /* 1433009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433013 */     // MIs[0] policy
     /* 1433013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433025 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1433028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433050 */     // GIR_Coverage, 3519,
     /* 1433050 */     GIR_EraseRootFromParent_Done,
     /* 1433051 */   // Label 20214: @1433051
     /* 1433051 */   GIM_Try, /*On fail goto*//*Label 20215*/ GIMT_Encode4(1433148), // Rule ID 3522 //
     /* 1433056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1433064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1433067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1433070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1433073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433106 */     // MIs[1] Operand 1
     /* 1433106 */     // No operand predicates
     /* 1433106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433110 */     // MIs[0] policy
     /* 1433110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433122 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1433125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433147 */     // GIR_Coverage, 3522,
     /* 1433147 */     GIR_EraseRootFromParent_Done,
     /* 1433148 */   // Label 20215: @1433148
     /* 1433148 */   GIM_Try, /*On fail goto*//*Label 20216*/ GIMT_Encode4(1433245), // Rule ID 3523 //
     /* 1433153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1433161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1433164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1433167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1433170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433203 */     // MIs[1] Operand 1
     /* 1433203 */     // No operand predicates
     /* 1433203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433207 */     // MIs[0] policy
     /* 1433207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433219 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1433222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433244 */     // GIR_Coverage, 3523,
     /* 1433244 */     GIR_EraseRootFromParent_Done,
     /* 1433245 */   // Label 20216: @1433245
     /* 1433245 */   GIM_Try, /*On fail goto*//*Label 20217*/ GIMT_Encode4(1433342), // Rule ID 3526 //
     /* 1433250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1433258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1433261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1433264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1433267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433300 */     // MIs[1] Operand 1
     /* 1433300 */     // No operand predicates
     /* 1433300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433304 */     // MIs[0] policy
     /* 1433304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1433319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433341 */     // GIR_Coverage, 3526,
     /* 1433341 */     GIR_EraseRootFromParent_Done,
     /* 1433342 */   // Label 20217: @1433342
     /* 1433342 */   GIM_Try, /*On fail goto*//*Label 20218*/ GIMT_Encode4(1433439), // Rule ID 3527 //
     /* 1433347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1433355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1433358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1433361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1433364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433397 */     // MIs[1] Operand 1
     /* 1433397 */     // No operand predicates
     /* 1433397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433401 */     // MIs[0] policy
     /* 1433401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433413 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1433416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433438 */     // GIR_Coverage, 3527,
     /* 1433438 */     GIR_EraseRootFromParent_Done,
     /* 1433439 */   // Label 20218: @1433439
     /* 1433439 */   GIM_Try, /*On fail goto*//*Label 20219*/ GIMT_Encode4(1433536), // Rule ID 3530 //
     /* 1433444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1433447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1433452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1433455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1433458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1433461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433494 */     // MIs[1] Operand 1
     /* 1433494 */     // No operand predicates
     /* 1433494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433498 */     // MIs[0] policy
     /* 1433498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433510 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1433513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433535 */     // GIR_Coverage, 3530,
     /* 1433535 */     GIR_EraseRootFromParent_Done,
     /* 1433536 */   // Label 20219: @1433536
     /* 1433536 */   GIM_Try, /*On fail goto*//*Label 20220*/ GIMT_Encode4(1433633), // Rule ID 3531 //
     /* 1433541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1433544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1433549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1433552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1433555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1433558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433591 */     // MIs[1] Operand 1
     /* 1433591 */     // No operand predicates
     /* 1433591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433595 */     // MIs[0] policy
     /* 1433595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433607 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1433610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433632 */     // GIR_Coverage, 3531,
     /* 1433632 */     GIR_EraseRootFromParent_Done,
     /* 1433633 */   // Label 20220: @1433633
     /* 1433633 */   GIM_Try, /*On fail goto*//*Label 20221*/ GIMT_Encode4(1433730), // Rule ID 3534 //
     /* 1433638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1433646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1433649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1433652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1433655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1433661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1433668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433688 */     // MIs[1] Operand 1
     /* 1433688 */     // No operand predicates
     /* 1433688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433692 */     // MIs[0] policy
     /* 1433692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1433707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433729 */     // GIR_Coverage, 3534,
     /* 1433729 */     GIR_EraseRootFromParent_Done,
     /* 1433730 */   // Label 20221: @1433730
     /* 1433730 */   GIM_Try, /*On fail goto*//*Label 20222*/ GIMT_Encode4(1433827), // Rule ID 3535 //
     /* 1433735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1433743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1433746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1433749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1433752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1433758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1433765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433785 */     // MIs[1] Operand 1
     /* 1433785 */     // No operand predicates
     /* 1433785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433789 */     // MIs[0] policy
     /* 1433789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433801 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1433804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433826 */     // GIR_Coverage, 3535,
     /* 1433826 */     GIR_EraseRootFromParent_Done,
     /* 1433827 */   // Label 20222: @1433827
     /* 1433827 */   GIM_Try, /*On fail goto*//*Label 20223*/ GIMT_Encode4(1433924), // Rule ID 3538 //
     /* 1433832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1433840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1433843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1433846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1433849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1433855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1433862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433882 */     // MIs[1] Operand 1
     /* 1433882 */     // No operand predicates
     /* 1433882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433886 */     // MIs[0] policy
     /* 1433886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433898 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1433901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433923 */     // GIR_Coverage, 3538,
     /* 1433923 */     GIR_EraseRootFromParent_Done,
     /* 1433924 */   // Label 20223: @1433924
     /* 1433924 */   GIM_Try, /*On fail goto*//*Label 20224*/ GIMT_Encode4(1434021), // Rule ID 3539 //
     /* 1433929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1433937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1433940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1433943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1433946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1433952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1433959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433979 */     // MIs[1] Operand 1
     /* 1433979 */     // No operand predicates
     /* 1433979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433983 */     // MIs[0] policy
     /* 1433983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433995 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1433998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434020 */     // GIR_Coverage, 3539,
     /* 1434020 */     GIR_EraseRootFromParent_Done,
     /* 1434021 */   // Label 20224: @1434021
     /* 1434021 */   GIM_Try, /*On fail goto*//*Label 20225*/ GIMT_Encode4(1434118), // Rule ID 3542 //
     /* 1434026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1434034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1434037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1434040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1434043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1434049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1434056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434076 */     // MIs[1] Operand 1
     /* 1434076 */     // No operand predicates
     /* 1434076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434080 */     // MIs[0] policy
     /* 1434080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1434095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434117 */     // GIR_Coverage, 3542,
     /* 1434117 */     GIR_EraseRootFromParent_Done,
     /* 1434118 */   // Label 20225: @1434118
     /* 1434118 */   GIM_Try, /*On fail goto*//*Label 20226*/ GIMT_Encode4(1434215), // Rule ID 3543 //
     /* 1434123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1434131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1434134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1434137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1434140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1434146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1434153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434173 */     // MIs[1] Operand 1
     /* 1434173 */     // No operand predicates
     /* 1434173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434177 */     // MIs[0] policy
     /* 1434177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434189 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1434192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434214 */     // GIR_Coverage, 3543,
     /* 1434214 */     GIR_EraseRootFromParent_Done,
     /* 1434215 */   // Label 20226: @1434215
     /* 1434215 */   GIM_Try, /*On fail goto*//*Label 20227*/ GIMT_Encode4(1434312), // Rule ID 3546 //
     /* 1434220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1434228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1434231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1434234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1434237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1434243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434270 */     // MIs[1] Operand 1
     /* 1434270 */     // No operand predicates
     /* 1434270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434274 */     // MIs[0] policy
     /* 1434274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434286 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1434289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434311 */     // GIR_Coverage, 3546,
     /* 1434311 */     GIR_EraseRootFromParent_Done,
     /* 1434312 */   // Label 20227: @1434312
     /* 1434312 */   GIM_Try, /*On fail goto*//*Label 20228*/ GIMT_Encode4(1434409), // Rule ID 3547 //
     /* 1434317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1434325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1434328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1434331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1434334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1434340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434367 */     // MIs[1] Operand 1
     /* 1434367 */     // No operand predicates
     /* 1434367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434371 */     // MIs[0] policy
     /* 1434371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434383 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1434386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434408 */     // GIR_Coverage, 3547,
     /* 1434408 */     GIR_EraseRootFromParent_Done,
     /* 1434409 */   // Label 20228: @1434409
     /* 1434409 */   GIM_Try, /*On fail goto*//*Label 20229*/ GIMT_Encode4(1434506), // Rule ID 3550 //
     /* 1434414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1434422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1434425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1434428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1434431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434464 */     // MIs[1] Operand 1
     /* 1434464 */     // No operand predicates
     /* 1434464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434468 */     // MIs[0] policy
     /* 1434468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434480 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1434483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434505 */     // GIR_Coverage, 3550,
     /* 1434505 */     GIR_EraseRootFromParent_Done,
     /* 1434506 */   // Label 20229: @1434506
     /* 1434506 */   GIM_Try, /*On fail goto*//*Label 20230*/ GIMT_Encode4(1434603), // Rule ID 3551 //
     /* 1434511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1434519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1434522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1434525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1434528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434561 */     // MIs[1] Operand 1
     /* 1434561 */     // No operand predicates
     /* 1434561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434565 */     // MIs[0] policy
     /* 1434565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434577 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1434580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434602 */     // GIR_Coverage, 3551,
     /* 1434602 */     GIR_EraseRootFromParent_Done,
     /* 1434603 */   // Label 20230: @1434603
     /* 1434603 */   GIM_Try, /*On fail goto*//*Label 20231*/ GIMT_Encode4(1434700), // Rule ID 3554 //
     /* 1434608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1434616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1434619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1434622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1434625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1434631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1434638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434658 */     // MIs[1] Operand 1
     /* 1434658 */     // No operand predicates
     /* 1434658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434662 */     // MIs[0] policy
     /* 1434662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434674 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1434677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434699 */     // GIR_Coverage, 3554,
     /* 1434699 */     GIR_EraseRootFromParent_Done,
     /* 1434700 */   // Label 20231: @1434700
     /* 1434700 */   GIM_Try, /*On fail goto*//*Label 20232*/ GIMT_Encode4(1434797), // Rule ID 3555 //
     /* 1434705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1434713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1434716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1434719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1434722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1434728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1434735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434755 */     // MIs[1] Operand 1
     /* 1434755 */     // No operand predicates
     /* 1434755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434759 */     // MIs[0] policy
     /* 1434759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434771 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1434774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434796 */     // GIR_Coverage, 3555,
     /* 1434796 */     GIR_EraseRootFromParent_Done,
     /* 1434797 */   // Label 20232: @1434797
     /* 1434797 */   GIM_Try, /*On fail goto*//*Label 20233*/ GIMT_Encode4(1434894), // Rule ID 3558 //
     /* 1434802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1434810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1434813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1434816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1434819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1434825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434852 */     // MIs[1] Operand 1
     /* 1434852 */     // No operand predicates
     /* 1434852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434856 */     // MIs[0] policy
     /* 1434856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1434871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1434890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434893 */     // GIR_Coverage, 3558,
     /* 1434893 */     GIR_EraseRootFromParent_Done,
     /* 1434894 */   // Label 20233: @1434894
     /* 1434894 */   GIM_Try, /*On fail goto*//*Label 20234*/ GIMT_Encode4(1434991), // Rule ID 3559 //
     /* 1434899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1434907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1434910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1434913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1434916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1434922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434949 */     // MIs[1] Operand 1
     /* 1434949 */     // No operand predicates
     /* 1434949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434953 */     // MIs[0] policy
     /* 1434953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434965 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1434968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1434987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434990 */     // GIR_Coverage, 3559,
     /* 1434990 */     GIR_EraseRootFromParent_Done,
     /* 1434991 */   // Label 20234: @1434991
     /* 1434991 */   GIM_Try, /*On fail goto*//*Label 20235*/ GIMT_Encode4(1435088), // Rule ID 3562 //
     /* 1434996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1435004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1435007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1435010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1435013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435046 */     // MIs[1] Operand 1
     /* 1435046 */     // No operand predicates
     /* 1435046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435050 */     // MIs[0] policy
     /* 1435050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435062 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1435065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435087 */     // GIR_Coverage, 3562,
     /* 1435087 */     GIR_EraseRootFromParent_Done,
     /* 1435088 */   // Label 20235: @1435088
     /* 1435088 */   GIM_Try, /*On fail goto*//*Label 20236*/ GIMT_Encode4(1435185), // Rule ID 3563 //
     /* 1435093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1435101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1435104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1435107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1435110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435143 */     // MIs[1] Operand 1
     /* 1435143 */     // No operand predicates
     /* 1435143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435147 */     // MIs[0] policy
     /* 1435147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435159 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1435162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435184 */     // GIR_Coverage, 3563,
     /* 1435184 */     GIR_EraseRootFromParent_Done,
     /* 1435185 */   // Label 20236: @1435185
     /* 1435185 */   GIM_Try, /*On fail goto*//*Label 20237*/ GIMT_Encode4(1435282), // Rule ID 3566 //
     /* 1435190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1435198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1435201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1435204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1435207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1435213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435240 */     // MIs[1] Operand 1
     /* 1435240 */     // No operand predicates
     /* 1435240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435244 */     // MIs[0] policy
     /* 1435244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435256 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1435259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435281 */     // GIR_Coverage, 3566,
     /* 1435281 */     GIR_EraseRootFromParent_Done,
     /* 1435282 */   // Label 20237: @1435282
     /* 1435282 */   GIM_Try, /*On fail goto*//*Label 20238*/ GIMT_Encode4(1435379), // Rule ID 3567 //
     /* 1435287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1435295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1435298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1435301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1435304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1435310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435337 */     // MIs[1] Operand 1
     /* 1435337 */     // No operand predicates
     /* 1435337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435341 */     // MIs[0] policy
     /* 1435341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435353 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1435356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435378 */     // GIR_Coverage, 3567,
     /* 1435378 */     GIR_EraseRootFromParent_Done,
     /* 1435379 */   // Label 20238: @1435379
     /* 1435379 */   GIM_Try, /*On fail goto*//*Label 20239*/ GIMT_Encode4(1435476), // Rule ID 3570 //
     /* 1435384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1435387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1435392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1435395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1435398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1435401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1435407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435434 */     // MIs[1] Operand 1
     /* 1435434 */     // No operand predicates
     /* 1435434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435438 */     // MIs[0] policy
     /* 1435438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435450 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1435453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435475 */     // GIR_Coverage, 3570,
     /* 1435475 */     GIR_EraseRootFromParent_Done,
     /* 1435476 */   // Label 20239: @1435476
     /* 1435476 */   GIM_Try, /*On fail goto*//*Label 20240*/ GIMT_Encode4(1435573), // Rule ID 3571 //
     /* 1435481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1435484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1435489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1435492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1435495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1435498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1435504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435531 */     // MIs[1] Operand 1
     /* 1435531 */     // No operand predicates
     /* 1435531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435535 */     // MIs[0] policy
     /* 1435535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435547 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1435550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435572 */     // GIR_Coverage, 3571,
     /* 1435572 */     GIR_EraseRootFromParent_Done,
     /* 1435573 */   // Label 20240: @1435573
     /* 1435573 */   GIM_Try, /*On fail goto*//*Label 20241*/ GIMT_Encode4(1435670), // Rule ID 3574 //
     /* 1435578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1435581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1435586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1435589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1435592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1435595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435628 */     // MIs[1] Operand 1
     /* 1435628 */     // No operand predicates
     /* 1435628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435632 */     // MIs[0] policy
     /* 1435632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435644 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1435647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435669 */     // GIR_Coverage, 3574,
     /* 1435669 */     GIR_EraseRootFromParent_Done,
     /* 1435670 */   // Label 20241: @1435670
     /* 1435670 */   GIM_Try, /*On fail goto*//*Label 20242*/ GIMT_Encode4(1435767), // Rule ID 3575 //
     /* 1435675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1435678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1435683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1435686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1435689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1435692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435725 */     // MIs[1] Operand 1
     /* 1435725 */     // No operand predicates
     /* 1435725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435729 */     // MIs[0] policy
     /* 1435729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435741 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1435744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435766 */     // GIR_Coverage, 3575,
     /* 1435766 */     GIR_EraseRootFromParent_Done,
     /* 1435767 */   // Label 20242: @1435767
     /* 1435767 */   GIM_Try, /*On fail goto*//*Label 20243*/ GIMT_Encode4(1435864), // Rule ID 3578 //
     /* 1435772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1435775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1435780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1435783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1435786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1435789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435822 */     // MIs[1] Operand 1
     /* 1435822 */     // No operand predicates
     /* 1435822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435826 */     // MIs[0] policy
     /* 1435826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435838 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1435841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435863 */     // GIR_Coverage, 3578,
     /* 1435863 */     GIR_EraseRootFromParent_Done,
     /* 1435864 */   // Label 20243: @1435864
     /* 1435864 */   GIM_Try, /*On fail goto*//*Label 20244*/ GIMT_Encode4(1435961), // Rule ID 3579 //
     /* 1435869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1435872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1435877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1435880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1435883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1435886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435919 */     // MIs[1] Operand 1
     /* 1435919 */     // No operand predicates
     /* 1435919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435923 */     // MIs[0] policy
     /* 1435923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435935 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1435938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435960 */     // GIR_Coverage, 3579,
     /* 1435960 */     GIR_EraseRootFromParent_Done,
     /* 1435961 */   // Label 20244: @1435961
     /* 1435961 */   GIM_Try, /*On fail goto*//*Label 20245*/ GIMT_Encode4(1436058), // Rule ID 5942 //
     /* 1435966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1435977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1435980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1435983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1435989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436016 */     // MIs[1] Operand 1
     /* 1436016 */     // No operand predicates
     /* 1436016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436020 */     // MIs[0] policy
     /* 1436020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436032 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1436035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436057 */     // GIR_Coverage, 5942,
     /* 1436057 */     GIR_EraseRootFromParent_Done,
     /* 1436058 */   // Label 20245: @1436058
     /* 1436058 */   GIM_Try, /*On fail goto*//*Label 20246*/ GIMT_Encode4(1436155), // Rule ID 5943 //
     /* 1436063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1436074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1436077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1436080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436113 */     // MIs[1] Operand 1
     /* 1436113 */     // No operand predicates
     /* 1436113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436117 */     // MIs[0] policy
     /* 1436117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436129 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1436132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436154 */     // GIR_Coverage, 5943,
     /* 1436154 */     GIR_EraseRootFromParent_Done,
     /* 1436155 */   // Label 20246: @1436155
     /* 1436155 */   GIM_Try, /*On fail goto*//*Label 20247*/ GIMT_Encode4(1436252), // Rule ID 5946 //
     /* 1436160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1436171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1436174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1436177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1436183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436210 */     // MIs[1] Operand 1
     /* 1436210 */     // No operand predicates
     /* 1436210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436214 */     // MIs[0] policy
     /* 1436214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436226 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1436229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436251 */     // GIR_Coverage, 5946,
     /* 1436251 */     GIR_EraseRootFromParent_Done,
     /* 1436252 */   // Label 20247: @1436252
     /* 1436252 */   GIM_Try, /*On fail goto*//*Label 20248*/ GIMT_Encode4(1436349), // Rule ID 5947 //
     /* 1436257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1436268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1436271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1436274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1436280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436307 */     // MIs[1] Operand 1
     /* 1436307 */     // No operand predicates
     /* 1436307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436311 */     // MIs[0] policy
     /* 1436311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436323 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1436326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436348 */     // GIR_Coverage, 5947,
     /* 1436348 */     GIR_EraseRootFromParent_Done,
     /* 1436349 */   // Label 20248: @1436349
     /* 1436349 */   GIM_Try, /*On fail goto*//*Label 20249*/ GIMT_Encode4(1436446), // Rule ID 5950 //
     /* 1436354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1436365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1436368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1436371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436404 */     // MIs[1] Operand 1
     /* 1436404 */     // No operand predicates
     /* 1436404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436408 */     // MIs[0] policy
     /* 1436408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436420 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1436423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436445 */     // GIR_Coverage, 5950,
     /* 1436445 */     GIR_EraseRootFromParent_Done,
     /* 1436446 */   // Label 20249: @1436446
     /* 1436446 */   GIM_Try, /*On fail goto*//*Label 20250*/ GIMT_Encode4(1436543), // Rule ID 5951 //
     /* 1436451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1436462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1436465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1436468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436501 */     // MIs[1] Operand 1
     /* 1436501 */     // No operand predicates
     /* 1436501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436505 */     // MIs[0] policy
     /* 1436505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436517 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1436520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436542 */     // GIR_Coverage, 5951,
     /* 1436542 */     GIR_EraseRootFromParent_Done,
     /* 1436543 */   // Label 20250: @1436543
     /* 1436543 */   GIM_Try, /*On fail goto*//*Label 20251*/ GIMT_Encode4(1436640), // Rule ID 5954 //
     /* 1436548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1436559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1436562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1436565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436598 */     // MIs[1] Operand 1
     /* 1436598 */     // No operand predicates
     /* 1436598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436602 */     // MIs[0] policy
     /* 1436602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436614 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1436617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436639 */     // GIR_Coverage, 5954,
     /* 1436639 */     GIR_EraseRootFromParent_Done,
     /* 1436640 */   // Label 20251: @1436640
     /* 1436640 */   GIM_Try, /*On fail goto*//*Label 20252*/ GIMT_Encode4(1436737), // Rule ID 5955 //
     /* 1436645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1436656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1436659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1436662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436695 */     // MIs[1] Operand 1
     /* 1436695 */     // No operand predicates
     /* 1436695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436699 */     // MIs[0] policy
     /* 1436699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436711 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1436714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436736 */     // GIR_Coverage, 5955,
     /* 1436736 */     GIR_EraseRootFromParent_Done,
     /* 1436737 */   // Label 20252: @1436737
     /* 1436737 */   GIM_Try, /*On fail goto*//*Label 20253*/ GIMT_Encode4(1436834), // Rule ID 5958 //
     /* 1436742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1436753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1436756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1436759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1436765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436792 */     // MIs[1] Operand 1
     /* 1436792 */     // No operand predicates
     /* 1436792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436796 */     // MIs[0] policy
     /* 1436796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436808 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1436811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436833 */     // GIR_Coverage, 5958,
     /* 1436833 */     GIR_EraseRootFromParent_Done,
     /* 1436834 */   // Label 20253: @1436834
     /* 1436834 */   GIM_Try, /*On fail goto*//*Label 20254*/ GIMT_Encode4(1436931), // Rule ID 5959 //
     /* 1436839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1436850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1436853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1436856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1436862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436889 */     // MIs[1] Operand 1
     /* 1436889 */     // No operand predicates
     /* 1436889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436893 */     // MIs[0] policy
     /* 1436893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436905 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1436908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436930 */     // GIR_Coverage, 5959,
     /* 1436930 */     GIR_EraseRootFromParent_Done,
     /* 1436931 */   // Label 20254: @1436931
     /* 1436931 */   GIM_Try, /*On fail goto*//*Label 20255*/ GIMT_Encode4(1437028), // Rule ID 5962 //
     /* 1436936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1436947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1436950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1436953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436986 */     // MIs[1] Operand 1
     /* 1436986 */     // No operand predicates
     /* 1436986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436990 */     // MIs[0] policy
     /* 1436990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437002 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1437005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437027 */     // GIR_Coverage, 5962,
     /* 1437027 */     GIR_EraseRootFromParent_Done,
     /* 1437028 */   // Label 20255: @1437028
     /* 1437028 */   GIM_Try, /*On fail goto*//*Label 20256*/ GIMT_Encode4(1437125), // Rule ID 5963 //
     /* 1437033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1437041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1437044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1437047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1437050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437083 */     // MIs[1] Operand 1
     /* 1437083 */     // No operand predicates
     /* 1437083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437087 */     // MIs[0] policy
     /* 1437087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437099 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1437102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437124 */     // GIR_Coverage, 5963,
     /* 1437124 */     GIR_EraseRootFromParent_Done,
     /* 1437125 */   // Label 20256: @1437125
     /* 1437125 */   GIM_Try, /*On fail goto*//*Label 20257*/ GIMT_Encode4(1437222), // Rule ID 5966 //
     /* 1437130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1437138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1437141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1437144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1437147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1437153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437176 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437180 */     // MIs[1] Operand 1
     /* 1437180 */     // No operand predicates
     /* 1437180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437184 */     // MIs[0] policy
     /* 1437184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1437199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437221 */     // GIR_Coverage, 5966,
     /* 1437221 */     GIR_EraseRootFromParent_Done,
     /* 1437222 */   // Label 20257: @1437222
     /* 1437222 */   GIM_Try, /*On fail goto*//*Label 20258*/ GIMT_Encode4(1437319), // Rule ID 5967 //
     /* 1437227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1437235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1437238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1437241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1437244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1437250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437277 */     // MIs[1] Operand 1
     /* 1437277 */     // No operand predicates
     /* 1437277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437281 */     // MIs[0] policy
     /* 1437281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437293 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1437296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437318 */     // GIR_Coverage, 5967,
     /* 1437318 */     GIR_EraseRootFromParent_Done,
     /* 1437319 */   // Label 20258: @1437319
     /* 1437319 */   GIM_Try, /*On fail goto*//*Label 20259*/ GIMT_Encode4(1437416), // Rule ID 5970 //
     /* 1437324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1437332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1437335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1437338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1437341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437374 */     // MIs[1] Operand 1
     /* 1437374 */     // No operand predicates
     /* 1437374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437378 */     // MIs[0] policy
     /* 1437378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1437393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437415 */     // GIR_Coverage, 5970,
     /* 1437415 */     GIR_EraseRootFromParent_Done,
     /* 1437416 */   // Label 20259: @1437416
     /* 1437416 */   GIM_Try, /*On fail goto*//*Label 20260*/ GIMT_Encode4(1437513), // Rule ID 5971 //
     /* 1437421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1437429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1437432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1437435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1437438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437471 */     // MIs[1] Operand 1
     /* 1437471 */     // No operand predicates
     /* 1437471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437475 */     // MIs[0] policy
     /* 1437475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437487 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1437490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437512 */     // GIR_Coverage, 5971,
     /* 1437512 */     GIR_EraseRootFromParent_Done,
     /* 1437513 */   // Label 20260: @1437513
     /* 1437513 */   GIM_Try, /*On fail goto*//*Label 20261*/ GIMT_Encode4(1437610), // Rule ID 5974 //
     /* 1437518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1437526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1437529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1437532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1437535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437568 */     // MIs[1] Operand 1
     /* 1437568 */     // No operand predicates
     /* 1437568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437572 */     // MIs[0] policy
     /* 1437572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1437587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437609 */     // GIR_Coverage, 5974,
     /* 1437609 */     GIR_EraseRootFromParent_Done,
     /* 1437610 */   // Label 20261: @1437610
     /* 1437610 */   GIM_Try, /*On fail goto*//*Label 20262*/ GIMT_Encode4(1437707), // Rule ID 5975 //
     /* 1437615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1437623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1437626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1437629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1437632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437665 */     // MIs[1] Operand 1
     /* 1437665 */     // No operand predicates
     /* 1437665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437669 */     // MIs[0] policy
     /* 1437669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437681 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1437684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437706 */     // GIR_Coverage, 5975,
     /* 1437706 */     GIR_EraseRootFromParent_Done,
     /* 1437707 */   // Label 20262: @1437707
     /* 1437707 */   GIM_Try, /*On fail goto*//*Label 20263*/ GIMT_Encode4(1437804), // Rule ID 5978 //
     /* 1437712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1437715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1437720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1437723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1437726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1437729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437762 */     // MIs[1] Operand 1
     /* 1437762 */     // No operand predicates
     /* 1437762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437766 */     // MIs[0] policy
     /* 1437766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437778 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1437781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1437800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437803 */     // GIR_Coverage, 5978,
     /* 1437803 */     GIR_EraseRootFromParent_Done,
     /* 1437804 */   // Label 20263: @1437804
     /* 1437804 */   GIM_Try, /*On fail goto*//*Label 20264*/ GIMT_Encode4(1437901), // Rule ID 5979 //
     /* 1437809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1437812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1437817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1437820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1437823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1437826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437859 */     // MIs[1] Operand 1
     /* 1437859 */     // No operand predicates
     /* 1437859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437863 */     // MIs[0] policy
     /* 1437863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437875 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1437878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1437897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437900 */     // GIR_Coverage, 5979,
     /* 1437900 */     GIR_EraseRootFromParent_Done,
     /* 1437901 */   // Label 20264: @1437901
     /* 1437901 */   GIM_Try, /*On fail goto*//*Label 20265*/ GIMT_Encode4(1437998), // Rule ID 5982 //
     /* 1437906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1437914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1437917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1437920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1437923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1437929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1437936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437956 */     // MIs[1] Operand 1
     /* 1437956 */     // No operand predicates
     /* 1437956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437960 */     // MIs[0] policy
     /* 1437960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437972 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1437975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437997 */     // GIR_Coverage, 5982,
     /* 1437997 */     GIR_EraseRootFromParent_Done,
     /* 1437998 */   // Label 20265: @1437998
     /* 1437998 */   GIM_Try, /*On fail goto*//*Label 20266*/ GIMT_Encode4(1438095), // Rule ID 5983 //
     /* 1438003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1438011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1438014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1438017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1438020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1438026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1438033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438053 */     // MIs[1] Operand 1
     /* 1438053 */     // No operand predicates
     /* 1438053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438057 */     // MIs[0] policy
     /* 1438057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438069 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1438072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438094 */     // GIR_Coverage, 5983,
     /* 1438094 */     GIR_EraseRootFromParent_Done,
     /* 1438095 */   // Label 20266: @1438095
     /* 1438095 */   GIM_Try, /*On fail goto*//*Label 20267*/ GIMT_Encode4(1438192), // Rule ID 5986 //
     /* 1438100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1438108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1438111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1438114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1438117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1438123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1438130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438150 */     // MIs[1] Operand 1
     /* 1438150 */     // No operand predicates
     /* 1438150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438154 */     // MIs[0] policy
     /* 1438154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438166 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1438169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438191 */     // GIR_Coverage, 5986,
     /* 1438191 */     GIR_EraseRootFromParent_Done,
     /* 1438192 */   // Label 20267: @1438192
     /* 1438192 */   GIM_Try, /*On fail goto*//*Label 20268*/ GIMT_Encode4(1438289), // Rule ID 5987 //
     /* 1438197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1438205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1438208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1438211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1438214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1438220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1438227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438247 */     // MIs[1] Operand 1
     /* 1438247 */     // No operand predicates
     /* 1438247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438251 */     // MIs[0] policy
     /* 1438251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438263 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1438266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438288 */     // GIR_Coverage, 5987,
     /* 1438288 */     GIR_EraseRootFromParent_Done,
     /* 1438289 */   // Label 20268: @1438289
     /* 1438289 */   GIM_Try, /*On fail goto*//*Label 20269*/ GIMT_Encode4(1438386), // Rule ID 5990 //
     /* 1438294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1438302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1438305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1438308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1438311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1438317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1438324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438344 */     // MIs[1] Operand 1
     /* 1438344 */     // No operand predicates
     /* 1438344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438348 */     // MIs[0] policy
     /* 1438348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438360 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1438363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438385 */     // GIR_Coverage, 5990,
     /* 1438385 */     GIR_EraseRootFromParent_Done,
     /* 1438386 */   // Label 20269: @1438386
     /* 1438386 */   GIM_Try, /*On fail goto*//*Label 20270*/ GIMT_Encode4(1438483), // Rule ID 5991 //
     /* 1438391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1438399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1438402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1438405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1438408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1438414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1438421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438441 */     // MIs[1] Operand 1
     /* 1438441 */     // No operand predicates
     /* 1438441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438445 */     // MIs[0] policy
     /* 1438445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438457 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1438460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438482 */     // GIR_Coverage, 5991,
     /* 1438482 */     GIR_EraseRootFromParent_Done,
     /* 1438483 */   // Label 20270: @1438483
     /* 1438483 */   GIM_Try, /*On fail goto*//*Label 20271*/ GIMT_Encode4(1438580), // Rule ID 5994 //
     /* 1438488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1438496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1438499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1438502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1438505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1438511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1438518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438538 */     // MIs[1] Operand 1
     /* 1438538 */     // No operand predicates
     /* 1438538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438542 */     // MIs[0] policy
     /* 1438542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438554 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1438557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438579 */     // GIR_Coverage, 5994,
     /* 1438579 */     GIR_EraseRootFromParent_Done,
     /* 1438580 */   // Label 20271: @1438580
     /* 1438580 */   GIM_Try, /*On fail goto*//*Label 20272*/ GIMT_Encode4(1438677), // Rule ID 5995 //
     /* 1438585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1438593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1438596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1438599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1438602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1438608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1438615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438635 */     // MIs[1] Operand 1
     /* 1438635 */     // No operand predicates
     /* 1438635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438639 */     // MIs[0] policy
     /* 1438639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438651 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1438654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438676 */     // GIR_Coverage, 5995,
     /* 1438676 */     GIR_EraseRootFromParent_Done,
     /* 1438677 */   // Label 20272: @1438677
     /* 1438677 */   GIM_Try, /*On fail goto*//*Label 20273*/ GIMT_Encode4(1438774), // Rule ID 5998 //
     /* 1438682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1438690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1438693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1438696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1438699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1438705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1438712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438732 */     // MIs[1] Operand 1
     /* 1438732 */     // No operand predicates
     /* 1438732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438736 */     // MIs[0] policy
     /* 1438736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438748 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1438751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438773 */     // GIR_Coverage, 5998,
     /* 1438773 */     GIR_EraseRootFromParent_Done,
     /* 1438774 */   // Label 20273: @1438774
     /* 1438774 */   GIM_Try, /*On fail goto*//*Label 20274*/ GIMT_Encode4(1438871), // Rule ID 5999 //
     /* 1438779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1438787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1438790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1438793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1438796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1438802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1438809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438829 */     // MIs[1] Operand 1
     /* 1438829 */     // No operand predicates
     /* 1438829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438833 */     // MIs[0] policy
     /* 1438833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438845 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1438848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438870 */     // GIR_Coverage, 5999,
     /* 1438870 */     GIR_EraseRootFromParent_Done,
     /* 1438871 */   // Label 20274: @1438871
     /* 1438871 */   GIM_Try, /*On fail goto*//*Label 20275*/ GIMT_Encode4(1438968), // Rule ID 6002 //
     /* 1438876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1438884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1438887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1438890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1438893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1438899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1438906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438926 */     // MIs[1] Operand 1
     /* 1438926 */     // No operand predicates
     /* 1438926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438930 */     // MIs[0] policy
     /* 1438930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438942 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1438945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438967 */     // GIR_Coverage, 6002,
     /* 1438967 */     GIR_EraseRootFromParent_Done,
     /* 1438968 */   // Label 20275: @1438968
     /* 1438968 */   GIM_Try, /*On fail goto*//*Label 20276*/ GIMT_Encode4(1439065), // Rule ID 6003 //
     /* 1438973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1438981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1438984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1438987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1438990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1438996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439023 */     // MIs[1] Operand 1
     /* 1439023 */     // No operand predicates
     /* 1439023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439027 */     // MIs[0] policy
     /* 1439027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439039 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1439042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439064 */     // GIR_Coverage, 6003,
     /* 1439064 */     GIR_EraseRootFromParent_Done,
     /* 1439065 */   // Label 20276: @1439065
     /* 1439065 */   GIM_Try, /*On fail goto*//*Label 20277*/ GIMT_Encode4(1439162), // Rule ID 6006 //
     /* 1439070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1439078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1439081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1439084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1439087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439120 */     // MIs[1] Operand 1
     /* 1439120 */     // No operand predicates
     /* 1439120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439124 */     // MIs[0] policy
     /* 1439124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1439139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439161 */     // GIR_Coverage, 6006,
     /* 1439161 */     GIR_EraseRootFromParent_Done,
     /* 1439162 */   // Label 20277: @1439162
     /* 1439162 */   GIM_Try, /*On fail goto*//*Label 20278*/ GIMT_Encode4(1439259), // Rule ID 6007 //
     /* 1439167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1439175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1439178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1439181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1439184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439217 */     // MIs[1] Operand 1
     /* 1439217 */     // No operand predicates
     /* 1439217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439221 */     // MIs[0] policy
     /* 1439221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439233 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1439236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439258 */     // GIR_Coverage, 6007,
     /* 1439258 */     GIR_EraseRootFromParent_Done,
     /* 1439259 */   // Label 20278: @1439259
     /* 1439259 */   GIM_Try, /*On fail goto*//*Label 20279*/ GIMT_Encode4(1439356), // Rule ID 6010 //
     /* 1439264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1439272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1439275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1439278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1439281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439314 */     // MIs[1] Operand 1
     /* 1439314 */     // No operand predicates
     /* 1439314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439318 */     // MIs[0] policy
     /* 1439318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439330 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1439333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439355 */     // GIR_Coverage, 6010,
     /* 1439355 */     GIR_EraseRootFromParent_Done,
     /* 1439356 */   // Label 20279: @1439356
     /* 1439356 */   GIM_Try, /*On fail goto*//*Label 20280*/ GIMT_Encode4(1439453), // Rule ID 6011 //
     /* 1439361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1439369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1439372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1439375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1439378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439411 */     // MIs[1] Operand 1
     /* 1439411 */     // No operand predicates
     /* 1439411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439415 */     // MIs[0] policy
     /* 1439415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439427 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1439430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439452 */     // GIR_Coverage, 6011,
     /* 1439452 */     GIR_EraseRootFromParent_Done,
     /* 1439453 */   // Label 20280: @1439453
     /* 1439453 */   GIM_Try, /*On fail goto*//*Label 20281*/ GIMT_Encode4(1439550), // Rule ID 6014 //
     /* 1439458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1439466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1439469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1439472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1439475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1439481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439508 */     // MIs[1] Operand 1
     /* 1439508 */     // No operand predicates
     /* 1439508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439512 */     // MIs[0] policy
     /* 1439512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439524 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1439527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439549 */     // GIR_Coverage, 6014,
     /* 1439549 */     GIR_EraseRootFromParent_Done,
     /* 1439550 */   // Label 20281: @1439550
     /* 1439550 */   GIM_Try, /*On fail goto*//*Label 20282*/ GIMT_Encode4(1439647), // Rule ID 6015 //
     /* 1439555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1439563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1439566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1439569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1439572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1439578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439605 */     // MIs[1] Operand 1
     /* 1439605 */     // No operand predicates
     /* 1439605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439609 */     // MIs[0] policy
     /* 1439609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439621 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1439624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439646 */     // GIR_Coverage, 6015,
     /* 1439646 */     GIR_EraseRootFromParent_Done,
     /* 1439647 */   // Label 20282: @1439647
     /* 1439647 */   GIM_Try, /*On fail goto*//*Label 20283*/ GIMT_Encode4(1439744), // Rule ID 6018 //
     /* 1439652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1439655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1439660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1439663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1439666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1439669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1439675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439702 */     // MIs[1] Operand 1
     /* 1439702 */     // No operand predicates
     /* 1439702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439706 */     // MIs[0] policy
     /* 1439706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439718 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1439721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1439740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439743 */     // GIR_Coverage, 6018,
     /* 1439743 */     GIR_EraseRootFromParent_Done,
     /* 1439744 */   // Label 20283: @1439744
     /* 1439744 */   GIM_Try, /*On fail goto*//*Label 20284*/ GIMT_Encode4(1439841), // Rule ID 6019 //
     /* 1439749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1439752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1439757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1439760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1439763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1439766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1439772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439799 */     // MIs[1] Operand 1
     /* 1439799 */     // No operand predicates
     /* 1439799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439803 */     // MIs[0] policy
     /* 1439803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439815 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1439818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1439837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439840 */     // GIR_Coverage, 6019,
     /* 1439840 */     GIR_EraseRootFromParent_Done,
     /* 1439841 */   // Label 20284: @1439841
     /* 1439841 */   GIM_Try, /*On fail goto*//*Label 20285*/ GIMT_Encode4(1439938), // Rule ID 6022 //
     /* 1439846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1439849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1439854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1439857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1439860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1439863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439896 */     // MIs[1] Operand 1
     /* 1439896 */     // No operand predicates
     /* 1439896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439900 */     // MIs[0] policy
     /* 1439900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439912 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1439915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1439934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439937 */     // GIR_Coverage, 6022,
     /* 1439937 */     GIR_EraseRootFromParent_Done,
     /* 1439938 */   // Label 20285: @1439938
     /* 1439938 */   GIM_Try, /*On fail goto*//*Label 20286*/ GIMT_Encode4(1440035), // Rule ID 6023 //
     /* 1439943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1439946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1439951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1439954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1439957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1439960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439993 */     // MIs[1] Operand 1
     /* 1439993 */     // No operand predicates
     /* 1439993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439997 */     // MIs[0] policy
     /* 1439997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440009 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1440012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440034 */     // GIR_Coverage, 6023,
     /* 1440034 */     GIR_EraseRootFromParent_Done,
     /* 1440035 */   // Label 20286: @1440035
     /* 1440035 */   GIM_Try, /*On fail goto*//*Label 20287*/ GIMT_Encode4(1440132), // Rule ID 6026 //
     /* 1440040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1440048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1440051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1440054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1440057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440090 */     // MIs[1] Operand 1
     /* 1440090 */     // No operand predicates
     /* 1440090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440094 */     // MIs[0] policy
     /* 1440094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440106 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1440109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440131 */     // GIR_Coverage, 6026,
     /* 1440131 */     GIR_EraseRootFromParent_Done,
     /* 1440132 */   // Label 20287: @1440132
     /* 1440132 */   GIM_Try, /*On fail goto*//*Label 20288*/ GIMT_Encode4(1440229), // Rule ID 6027 //
     /* 1440137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1440140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1440145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1440148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1440151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1440154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440187 */     // MIs[1] Operand 1
     /* 1440187 */     // No operand predicates
     /* 1440187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440191 */     // MIs[0] policy
     /* 1440191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440203 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1440206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440228 */     // GIR_Coverage, 6027,
     /* 1440228 */     GIR_EraseRootFromParent_Done,
     /* 1440229 */   // Label 20288: @1440229
     /* 1440229 */   GIM_Try, /*On fail goto*//*Label 20289*/ GIMT_Encode4(1440326), // Rule ID 6206 //
     /* 1440234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1440245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1440248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1440251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1440257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440284 */     // MIs[1] Operand 1
     /* 1440284 */     // No operand predicates
     /* 1440284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440288 */     // MIs[0] policy
     /* 1440288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440300 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1440303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440325 */     // GIR_Coverage, 6206,
     /* 1440325 */     GIR_EraseRootFromParent_Done,
     /* 1440326 */   // Label 20289: @1440326
     /* 1440326 */   GIM_Try, /*On fail goto*//*Label 20290*/ GIMT_Encode4(1440423), // Rule ID 6207 //
     /* 1440331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1440342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1440345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1440348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1440354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440381 */     // MIs[1] Operand 1
     /* 1440381 */     // No operand predicates
     /* 1440381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440385 */     // MIs[0] policy
     /* 1440385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440397 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1440400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440422 */     // GIR_Coverage, 6207,
     /* 1440422 */     GIR_EraseRootFromParent_Done,
     /* 1440423 */   // Label 20290: @1440423
     /* 1440423 */   GIM_Try, /*On fail goto*//*Label 20291*/ GIMT_Encode4(1440520), // Rule ID 6210 //
     /* 1440428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1440439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1440442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1440445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440478 */     // MIs[1] Operand 1
     /* 1440478 */     // No operand predicates
     /* 1440478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440482 */     // MIs[0] policy
     /* 1440482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440494 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1440497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440519 */     // GIR_Coverage, 6210,
     /* 1440519 */     GIR_EraseRootFromParent_Done,
     /* 1440520 */   // Label 20291: @1440520
     /* 1440520 */   GIM_Try, /*On fail goto*//*Label 20292*/ GIMT_Encode4(1440617), // Rule ID 6211 //
     /* 1440525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1440536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1440539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1440542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440575 */     // MIs[1] Operand 1
     /* 1440575 */     // No operand predicates
     /* 1440575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440579 */     // MIs[0] policy
     /* 1440579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440591 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1440594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440616 */     // GIR_Coverage, 6211,
     /* 1440616 */     GIR_EraseRootFromParent_Done,
     /* 1440617 */   // Label 20292: @1440617
     /* 1440617 */   GIM_Try, /*On fail goto*//*Label 20293*/ GIMT_Encode4(1440714), // Rule ID 6214 //
     /* 1440622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1440633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1440636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1440639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1440645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440672 */     // MIs[1] Operand 1
     /* 1440672 */     // No operand predicates
     /* 1440672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440676 */     // MIs[0] policy
     /* 1440676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440688 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1440691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440713 */     // GIR_Coverage, 6214,
     /* 1440713 */     GIR_EraseRootFromParent_Done,
     /* 1440714 */   // Label 20293: @1440714
     /* 1440714 */   GIM_Try, /*On fail goto*//*Label 20294*/ GIMT_Encode4(1440811), // Rule ID 6215 //
     /* 1440719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1440730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1440733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1440736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1440742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440769 */     // MIs[1] Operand 1
     /* 1440769 */     // No operand predicates
     /* 1440769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440773 */     // MIs[0] policy
     /* 1440773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440785 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1440788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440810 */     // GIR_Coverage, 6215,
     /* 1440810 */     GIR_EraseRootFromParent_Done,
     /* 1440811 */   // Label 20294: @1440811
     /* 1440811 */   GIM_Try, /*On fail goto*//*Label 20295*/ GIMT_Encode4(1440908), // Rule ID 6218 //
     /* 1440816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1440827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1440830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1440833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1440839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440866 */     // MIs[1] Operand 1
     /* 1440866 */     // No operand predicates
     /* 1440866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440870 */     // MIs[0] policy
     /* 1440870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440882 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1440885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1440904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440907 */     // GIR_Coverage, 6218,
     /* 1440907 */     GIR_EraseRootFromParent_Done,
     /* 1440908 */   // Label 20295: @1440908
     /* 1440908 */   GIM_Try, /*On fail goto*//*Label 20296*/ GIMT_Encode4(1441005), // Rule ID 6219 //
     /* 1440913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1440924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1440927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1440930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1440936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440963 */     // MIs[1] Operand 1
     /* 1440963 */     // No operand predicates
     /* 1440963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440967 */     // MIs[0] policy
     /* 1440967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440979 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1440982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441004 */     // GIR_Coverage, 6219,
     /* 1441004 */     GIR_EraseRootFromParent_Done,
     /* 1441005 */   // Label 20296: @1441005
     /* 1441005 */   GIM_Try, /*On fail goto*//*Label 20297*/ GIMT_Encode4(1441102), // Rule ID 6222 //
     /* 1441010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1441018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1441021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1441024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1441027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441060 */     // MIs[1] Operand 1
     /* 1441060 */     // No operand predicates
     /* 1441060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441064 */     // MIs[0] policy
     /* 1441064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441076 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1441079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441101 */     // GIR_Coverage, 6222,
     /* 1441101 */     GIR_EraseRootFromParent_Done,
     /* 1441102 */   // Label 20297: @1441102
     /* 1441102 */   GIM_Try, /*On fail goto*//*Label 20298*/ GIMT_Encode4(1441199), // Rule ID 6223 //
     /* 1441107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1441115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1441118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1441121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1441124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441157 */     // MIs[1] Operand 1
     /* 1441157 */     // No operand predicates
     /* 1441157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441161 */     // MIs[0] policy
     /* 1441161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441173 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1441176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441198 */     // GIR_Coverage, 6223,
     /* 1441198 */     GIR_EraseRootFromParent_Done,
     /* 1441199 */   // Label 20298: @1441199
     /* 1441199 */   GIM_Try, /*On fail goto*//*Label 20299*/ GIMT_Encode4(1441296), // Rule ID 6226 //
     /* 1441204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1441212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1441215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1441218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1441221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441254 */     // MIs[1] Operand 1
     /* 1441254 */     // No operand predicates
     /* 1441254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441258 */     // MIs[0] policy
     /* 1441258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441270 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1441273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441295 */     // GIR_Coverage, 6226,
     /* 1441295 */     GIR_EraseRootFromParent_Done,
     /* 1441296 */   // Label 20299: @1441296
     /* 1441296 */   GIM_Try, /*On fail goto*//*Label 20300*/ GIMT_Encode4(1441393), // Rule ID 6227 //
     /* 1441301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1441309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1441312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1441315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1441318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441351 */     // MIs[1] Operand 1
     /* 1441351 */     // No operand predicates
     /* 1441351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441355 */     // MIs[0] policy
     /* 1441355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441367 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1441370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441392 */     // GIR_Coverage, 6227,
     /* 1441392 */     GIR_EraseRootFromParent_Done,
     /* 1441393 */   // Label 20300: @1441393
     /* 1441393 */   GIM_Try, /*On fail goto*//*Label 20301*/ GIMT_Encode4(1441490), // Rule ID 6230 //
     /* 1441398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1441406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1441409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1441412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1441415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1441421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441448 */     // MIs[1] Operand 1
     /* 1441448 */     // No operand predicates
     /* 1441448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441452 */     // MIs[0] policy
     /* 1441452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441464 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1441467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441489 */     // GIR_Coverage, 6230,
     /* 1441489 */     GIR_EraseRootFromParent_Done,
     /* 1441490 */   // Label 20301: @1441490
     /* 1441490 */   GIM_Try, /*On fail goto*//*Label 20302*/ GIMT_Encode4(1441587), // Rule ID 6231 //
     /* 1441495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1441503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1441506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1441509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1441512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1441518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441545 */     // MIs[1] Operand 1
     /* 1441545 */     // No operand predicates
     /* 1441545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441549 */     // MIs[0] policy
     /* 1441549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441561 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1441564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441586 */     // GIR_Coverage, 6231,
     /* 1441586 */     GIR_EraseRootFromParent_Done,
     /* 1441587 */   // Label 20302: @1441587
     /* 1441587 */   GIM_Try, /*On fail goto*//*Label 20303*/ GIMT_Encode4(1441684), // Rule ID 6234 //
     /* 1441592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1441600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1441603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1441606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1441609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441642 */     // MIs[1] Operand 1
     /* 1441642 */     // No operand predicates
     /* 1441642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441646 */     // MIs[0] policy
     /* 1441646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441658 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1441661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441683 */     // GIR_Coverage, 6234,
     /* 1441683 */     GIR_EraseRootFromParent_Done,
     /* 1441684 */   // Label 20303: @1441684
     /* 1441684 */   GIM_Try, /*On fail goto*//*Label 20304*/ GIMT_Encode4(1441781), // Rule ID 6235 //
     /* 1441689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1441697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1441700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1441703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1441706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441739 */     // MIs[1] Operand 1
     /* 1441739 */     // No operand predicates
     /* 1441739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441743 */     // MIs[0] policy
     /* 1441743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441755 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1441758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441780 */     // GIR_Coverage, 6235,
     /* 1441780 */     GIR_EraseRootFromParent_Done,
     /* 1441781 */   // Label 20304: @1441781
     /* 1441781 */   GIM_Try, /*On fail goto*//*Label 20305*/ GIMT_Encode4(1441878), // Rule ID 6238 //
     /* 1441786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1441794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1441797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1441800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1441803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441836 */     // MIs[1] Operand 1
     /* 1441836 */     // No operand predicates
     /* 1441836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441840 */     // MIs[0] policy
     /* 1441840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1441855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441877 */     // GIR_Coverage, 6238,
     /* 1441877 */     GIR_EraseRootFromParent_Done,
     /* 1441878 */   // Label 20305: @1441878
     /* 1441878 */   GIM_Try, /*On fail goto*//*Label 20306*/ GIMT_Encode4(1441975), // Rule ID 6239 //
     /* 1441883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1441891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1441894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1441897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1441900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441933 */     // MIs[1] Operand 1
     /* 1441933 */     // No operand predicates
     /* 1441933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441937 */     // MIs[0] policy
     /* 1441937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441949 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1441952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441974 */     // GIR_Coverage, 6239,
     /* 1441974 */     GIR_EraseRootFromParent_Done,
     /* 1441975 */   // Label 20306: @1441975
     /* 1441975 */   GIM_Try, /*On fail goto*//*Label 20307*/ GIMT_Encode4(1442072), // Rule ID 6242 //
     /* 1441980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1441983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1441988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1441991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1441994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1441997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442030 */     // MIs[1] Operand 1
     /* 1442030 */     // No operand predicates
     /* 1442030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442034 */     // MIs[0] policy
     /* 1442034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442046 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1442049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442071 */     // GIR_Coverage, 6242,
     /* 1442071 */     GIR_EraseRootFromParent_Done,
     /* 1442072 */   // Label 20307: @1442072
     /* 1442072 */   GIM_Try, /*On fail goto*//*Label 20308*/ GIMT_Encode4(1442169), // Rule ID 6243 //
     /* 1442077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1442080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1442085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1442088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1442091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1442094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442127 */     // MIs[1] Operand 1
     /* 1442127 */     // No operand predicates
     /* 1442127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442131 */     // MIs[0] policy
     /* 1442131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442143 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1442146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442168 */     // GIR_Coverage, 6243,
     /* 1442168 */     GIR_EraseRootFromParent_Done,
     /* 1442169 */   // Label 20308: @1442169
     /* 1442169 */   GIM_Try, /*On fail goto*//*Label 20309*/ GIMT_Encode4(1442266), // Rule ID 6246 //
     /* 1442174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1442182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1442185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1442188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1442191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1442197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1442204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442224 */     // MIs[1] Operand 1
     /* 1442224 */     // No operand predicates
     /* 1442224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442228 */     // MIs[0] policy
     /* 1442228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442240 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1442243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442265 */     // GIR_Coverage, 6246,
     /* 1442265 */     GIR_EraseRootFromParent_Done,
     /* 1442266 */   // Label 20309: @1442266
     /* 1442266 */   GIM_Try, /*On fail goto*//*Label 20310*/ GIMT_Encode4(1442363), // Rule ID 6247 //
     /* 1442271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1442279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1442282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1442285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1442288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1442294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1442301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442321 */     // MIs[1] Operand 1
     /* 1442321 */     // No operand predicates
     /* 1442321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442325 */     // MIs[0] policy
     /* 1442325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442337 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1442340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442362 */     // GIR_Coverage, 6247,
     /* 1442362 */     GIR_EraseRootFromParent_Done,
     /* 1442363 */   // Label 20310: @1442363
     /* 1442363 */   GIM_Try, /*On fail goto*//*Label 20311*/ GIMT_Encode4(1442460), // Rule ID 6250 //
     /* 1442368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1442376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1442379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1442382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1442385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1442391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1442398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442418 */     // MIs[1] Operand 1
     /* 1442418 */     // No operand predicates
     /* 1442418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442422 */     // MIs[0] policy
     /* 1442422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442434 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1442437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442459 */     // GIR_Coverage, 6250,
     /* 1442459 */     GIR_EraseRootFromParent_Done,
     /* 1442460 */   // Label 20311: @1442460
     /* 1442460 */   GIM_Try, /*On fail goto*//*Label 20312*/ GIMT_Encode4(1442557), // Rule ID 6251 //
     /* 1442465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1442473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1442476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1442479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1442482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1442488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1442495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442515 */     // MIs[1] Operand 1
     /* 1442515 */     // No operand predicates
     /* 1442515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442519 */     // MIs[0] policy
     /* 1442519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442531 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1442534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442556 */     // GIR_Coverage, 6251,
     /* 1442556 */     GIR_EraseRootFromParent_Done,
     /* 1442557 */   // Label 20312: @1442557
     /* 1442557 */   GIM_Try, /*On fail goto*//*Label 20313*/ GIMT_Encode4(1442654), // Rule ID 6254 //
     /* 1442562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1442570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1442573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1442576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1442579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1442585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1442592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442612 */     // MIs[1] Operand 1
     /* 1442612 */     // No operand predicates
     /* 1442612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442616 */     // MIs[0] policy
     /* 1442616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442628 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1442631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442653 */     // GIR_Coverage, 6254,
     /* 1442653 */     GIR_EraseRootFromParent_Done,
     /* 1442654 */   // Label 20313: @1442654
     /* 1442654 */   GIM_Try, /*On fail goto*//*Label 20314*/ GIMT_Encode4(1442751), // Rule ID 6255 //
     /* 1442659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1442667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1442670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1442673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1442676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1442682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1442689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442709 */     // MIs[1] Operand 1
     /* 1442709 */     // No operand predicates
     /* 1442709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442713 */     // MIs[0] policy
     /* 1442713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442725 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1442728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442750 */     // GIR_Coverage, 6255,
     /* 1442750 */     GIR_EraseRootFromParent_Done,
     /* 1442751 */   // Label 20314: @1442751
     /* 1442751 */   GIM_Try, /*On fail goto*//*Label 20315*/ GIMT_Encode4(1442848), // Rule ID 6258 //
     /* 1442756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1442764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1442767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1442770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1442773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1442779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1442786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442806 */     // MIs[1] Operand 1
     /* 1442806 */     // No operand predicates
     /* 1442806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442810 */     // MIs[0] policy
     /* 1442810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442822 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1442825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442847 */     // GIR_Coverage, 6258,
     /* 1442847 */     GIR_EraseRootFromParent_Done,
     /* 1442848 */   // Label 20315: @1442848
     /* 1442848 */   GIM_Try, /*On fail goto*//*Label 20316*/ GIMT_Encode4(1442945), // Rule ID 6259 //
     /* 1442853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1442861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1442864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1442867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1442870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1442876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1442883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442903 */     // MIs[1] Operand 1
     /* 1442903 */     // No operand predicates
     /* 1442903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442907 */     // MIs[0] policy
     /* 1442907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442919 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1442922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442944 */     // GIR_Coverage, 6259,
     /* 1442944 */     GIR_EraseRootFromParent_Done,
     /* 1442945 */   // Label 20316: @1442945
     /* 1442945 */   GIM_Try, /*On fail goto*//*Label 20317*/ GIMT_Encode4(1443042), // Rule ID 6262 //
     /* 1442950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1442958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1442961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1442964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1442967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1442973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1442980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443000 */     // MIs[1] Operand 1
     /* 1443000 */     // No operand predicates
     /* 1443000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443004 */     // MIs[0] policy
     /* 1443004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443016 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1443019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443041 */     // GIR_Coverage, 6262,
     /* 1443041 */     GIR_EraseRootFromParent_Done,
     /* 1443042 */   // Label 20317: @1443042
     /* 1443042 */   GIM_Try, /*On fail goto*//*Label 20318*/ GIMT_Encode4(1443139), // Rule ID 6263 //
     /* 1443047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1443055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1443058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1443061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1443064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443097 */     // MIs[1] Operand 1
     /* 1443097 */     // No operand predicates
     /* 1443097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443101 */     // MIs[0] policy
     /* 1443101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443113 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1443116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443138 */     // GIR_Coverage, 6263,
     /* 1443138 */     GIR_EraseRootFromParent_Done,
     /* 1443139 */   // Label 20318: @1443139
     /* 1443139 */   GIM_Try, /*On fail goto*//*Label 20319*/ GIMT_Encode4(1443236), // Rule ID 6266 //
     /* 1443144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1443152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1443155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1443158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1443161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1443167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443194 */     // MIs[1] Operand 1
     /* 1443194 */     // No operand predicates
     /* 1443194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443198 */     // MIs[0] policy
     /* 1443198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443210 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1443213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443235 */     // GIR_Coverage, 6266,
     /* 1443235 */     GIR_EraseRootFromParent_Done,
     /* 1443236 */   // Label 20319: @1443236
     /* 1443236 */   GIM_Try, /*On fail goto*//*Label 20320*/ GIMT_Encode4(1443333), // Rule ID 6267 //
     /* 1443241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1443249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1443252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1443255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1443258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1443264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443291 */     // MIs[1] Operand 1
     /* 1443291 */     // No operand predicates
     /* 1443291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443295 */     // MIs[0] policy
     /* 1443295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443307 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1443310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443332 */     // GIR_Coverage, 6267,
     /* 1443332 */     GIR_EraseRootFromParent_Done,
     /* 1443333 */   // Label 20320: @1443333
     /* 1443333 */   GIM_Try, /*On fail goto*//*Label 20321*/ GIMT_Encode4(1443430), // Rule ID 6270 //
     /* 1443338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1443346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1443349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1443352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1443355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1443361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443388 */     // MIs[1] Operand 1
     /* 1443388 */     // No operand predicates
     /* 1443388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443392 */     // MIs[0] policy
     /* 1443392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1443407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443429 */     // GIR_Coverage, 6270,
     /* 1443429 */     GIR_EraseRootFromParent_Done,
     /* 1443430 */   // Label 20321: @1443430
     /* 1443430 */   GIM_Try, /*On fail goto*//*Label 20322*/ GIMT_Encode4(1443527), // Rule ID 6271 //
     /* 1443435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1443443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1443446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1443449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1443452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1443458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443485 */     // MIs[1] Operand 1
     /* 1443485 */     // No operand predicates
     /* 1443485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443489 */     // MIs[0] policy
     /* 1443489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1443504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443526 */     // GIR_Coverage, 6271,
     /* 1443526 */     GIR_EraseRootFromParent_Done,
     /* 1443527 */   // Label 20322: @1443527
     /* 1443527 */   GIM_Try, /*On fail goto*//*Label 20323*/ GIMT_Encode4(1443624), // Rule ID 6274 //
     /* 1443532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1443540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1443543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1443546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1443549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443582 */     // MIs[1] Operand 1
     /* 1443582 */     // No operand predicates
     /* 1443582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443586 */     // MIs[0] policy
     /* 1443586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1443601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443623 */     // GIR_Coverage, 6274,
     /* 1443623 */     GIR_EraseRootFromParent_Done,
     /* 1443624 */   // Label 20323: @1443624
     /* 1443624 */   GIM_Try, /*On fail goto*//*Label 20324*/ GIMT_Encode4(1443721), // Rule ID 6275 //
     /* 1443629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1443637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1443640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1443643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1443646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443679 */     // MIs[1] Operand 1
     /* 1443679 */     // No operand predicates
     /* 1443679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443683 */     // MIs[0] policy
     /* 1443683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443695 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1443698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443720 */     // GIR_Coverage, 6275,
     /* 1443720 */     GIR_EraseRootFromParent_Done,
     /* 1443721 */   // Label 20324: @1443721
     /* 1443721 */   GIM_Try, /*On fail goto*//*Label 20325*/ GIMT_Encode4(1443818), // Rule ID 6278 //
     /* 1443726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1443734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1443737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1443740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1443743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443776 */     // MIs[1] Operand 1
     /* 1443776 */     // No operand predicates
     /* 1443776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443780 */     // MIs[0] policy
     /* 1443780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443792 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1443795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443817 */     // GIR_Coverage, 6278,
     /* 1443817 */     GIR_EraseRootFromParent_Done,
     /* 1443818 */   // Label 20325: @1443818
     /* 1443818 */   GIM_Try, /*On fail goto*//*Label 20326*/ GIMT_Encode4(1443915), // Rule ID 6279 //
     /* 1443823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1443831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1443834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1443837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1443840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443873 */     // MIs[1] Operand 1
     /* 1443873 */     // No operand predicates
     /* 1443873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443877 */     // MIs[0] policy
     /* 1443877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443889 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1443892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443914 */     // GIR_Coverage, 6279,
     /* 1443914 */     GIR_EraseRootFromParent_Done,
     /* 1443915 */   // Label 20326: @1443915
     /* 1443915 */   GIM_Try, /*On fail goto*//*Label 20327*/ GIMT_Encode4(1444012), // Rule ID 6282 //
     /* 1443920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1443923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1443928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1443931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1443934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1443937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1443943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443970 */     // MIs[1] Operand 1
     /* 1443970 */     // No operand predicates
     /* 1443970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443974 */     // MIs[0] policy
     /* 1443974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443986 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1443989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444011 */     // GIR_Coverage, 6282,
     /* 1444011 */     GIR_EraseRootFromParent_Done,
     /* 1444012 */   // Label 20327: @1444012
     /* 1444012 */   GIM_Try, /*On fail goto*//*Label 20328*/ GIMT_Encode4(1444109), // Rule ID 6283 //
     /* 1444017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1444020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1444025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1444028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1444031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1444034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444067 */     // MIs[1] Operand 1
     /* 1444067 */     // No operand predicates
     /* 1444067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444071 */     // MIs[0] policy
     /* 1444071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444083 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1444086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444108 */     // GIR_Coverage, 6283,
     /* 1444108 */     GIR_EraseRootFromParent_Done,
     /* 1444109 */   // Label 20328: @1444109
     /* 1444109 */   GIM_Try, /*On fail goto*//*Label 20329*/ GIMT_Encode4(1444206), // Rule ID 6286 //
     /* 1444114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1444117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1444122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1444125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1444128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1444131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444164 */     // MIs[1] Operand 1
     /* 1444164 */     // No operand predicates
     /* 1444164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444168 */     // MIs[0] policy
     /* 1444168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444180 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1444183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444205 */     // GIR_Coverage, 6286,
     /* 1444205 */     GIR_EraseRootFromParent_Done,
     /* 1444206 */   // Label 20329: @1444206
     /* 1444206 */   GIM_Try, /*On fail goto*//*Label 20330*/ GIMT_Encode4(1444303), // Rule ID 6287 //
     /* 1444211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1444214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1444219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1444222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1444225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1444228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444261 */     // MIs[1] Operand 1
     /* 1444261 */     // No operand predicates
     /* 1444261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444265 */     // MIs[0] policy
     /* 1444265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444277 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1444280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444302 */     // GIR_Coverage, 6287,
     /* 1444302 */     GIR_EraseRootFromParent_Done,
     /* 1444303 */   // Label 20330: @1444303
     /* 1444303 */   GIM_Try, /*On fail goto*//*Label 20331*/ GIMT_Encode4(1444400), // Rule ID 6290 //
     /* 1444308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1444311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1444316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1444319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1444322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1444325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1444331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444354 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444358 */     // MIs[1] Operand 1
     /* 1444358 */     // No operand predicates
     /* 1444358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444362 */     // MIs[0] policy
     /* 1444362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444374 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1444377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444399 */     // GIR_Coverage, 6290,
     /* 1444399 */     GIR_EraseRootFromParent_Done,
     /* 1444400 */   // Label 20331: @1444400
     /* 1444400 */   GIM_Try, /*On fail goto*//*Label 20332*/ GIMT_Encode4(1444497), // Rule ID 6291 //
     /* 1444405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1444408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1444413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1444416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1444419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1444422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1444428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444455 */     // MIs[1] Operand 1
     /* 1444455 */     // No operand predicates
     /* 1444455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444459 */     // MIs[0] policy
     /* 1444459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444471 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1444474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444496 */     // GIR_Coverage, 6291,
     /* 1444496 */     GIR_EraseRootFromParent_Done,
     /* 1444497 */   // Label 20332: @1444497
     /* 1444497 */   GIM_Try, /*On fail goto*//*Label 20333*/ GIMT_Encode4(1444594), // Rule ID 6470 //
     /* 1444502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1444513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1444516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1444519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1444525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444552 */     // MIs[1] Operand 1
     /* 1444552 */     // No operand predicates
     /* 1444552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444556 */     // MIs[0] policy
     /* 1444556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444568 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1444571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1444590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444593 */     // GIR_Coverage, 6470,
     /* 1444593 */     GIR_EraseRootFromParent_Done,
     /* 1444594 */   // Label 20333: @1444594
     /* 1444594 */   GIM_Try, /*On fail goto*//*Label 20334*/ GIMT_Encode4(1444691), // Rule ID 6471 //
     /* 1444599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1444610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1444613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1444616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1444622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444649 */     // MIs[1] Operand 1
     /* 1444649 */     // No operand predicates
     /* 1444649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444653 */     // MIs[0] policy
     /* 1444653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444665 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1444668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1444687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444690 */     // GIR_Coverage, 6471,
     /* 1444690 */     GIR_EraseRootFromParent_Done,
     /* 1444691 */   // Label 20334: @1444691
     /* 1444691 */   GIM_Try, /*On fail goto*//*Label 20335*/ GIMT_Encode4(1444788), // Rule ID 6474 //
     /* 1444696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1444707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1444710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1444713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444746 */     // MIs[1] Operand 1
     /* 1444746 */     // No operand predicates
     /* 1444746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444750 */     // MIs[0] policy
     /* 1444750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444762 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1444765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1444784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444787 */     // GIR_Coverage, 6474,
     /* 1444787 */     GIR_EraseRootFromParent_Done,
     /* 1444788 */   // Label 20335: @1444788
     /* 1444788 */   GIM_Try, /*On fail goto*//*Label 20336*/ GIMT_Encode4(1444885), // Rule ID 6475 //
     /* 1444793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1444804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1444807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1444810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444843 */     // MIs[1] Operand 1
     /* 1444843 */     // No operand predicates
     /* 1444843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444847 */     // MIs[0] policy
     /* 1444847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444859 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1444862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1444881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444884 */     // GIR_Coverage, 6475,
     /* 1444884 */     GIR_EraseRootFromParent_Done,
     /* 1444885 */   // Label 20336: @1444885
     /* 1444885 */   GIM_Try, /*On fail goto*//*Label 20337*/ GIMT_Encode4(1444982), // Rule ID 6478 //
     /* 1444890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1444901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1444904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1444907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444940 */     // MIs[1] Operand 1
     /* 1444940 */     // No operand predicates
     /* 1444940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444944 */     // MIs[0] policy
     /* 1444944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444956 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1444959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1444978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444981 */     // GIR_Coverage, 6478,
     /* 1444981 */     GIR_EraseRootFromParent_Done,
     /* 1444982 */   // Label 20337: @1444982
     /* 1444982 */   GIM_Try, /*On fail goto*//*Label 20338*/ GIMT_Encode4(1445079), // Rule ID 6479 //
     /* 1444987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1444998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1445001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1445004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445037 */     // MIs[1] Operand 1
     /* 1445037 */     // No operand predicates
     /* 1445037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445041 */     // MIs[0] policy
     /* 1445041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445053 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1445056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445078 */     // GIR_Coverage, 6479,
     /* 1445078 */     GIR_EraseRootFromParent_Done,
     /* 1445079 */   // Label 20338: @1445079
     /* 1445079 */   GIM_Try, /*On fail goto*//*Label 20339*/ GIMT_Encode4(1445176), // Rule ID 6482 //
     /* 1445084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1445095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1445098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1445101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445134 */     // MIs[1] Operand 1
     /* 1445134 */     // No operand predicates
     /* 1445134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445138 */     // MIs[0] policy
     /* 1445138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445150 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1445153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445175 */     // GIR_Coverage, 6482,
     /* 1445175 */     GIR_EraseRootFromParent_Done,
     /* 1445176 */   // Label 20339: @1445176
     /* 1445176 */   GIM_Try, /*On fail goto*//*Label 20340*/ GIMT_Encode4(1445273), // Rule ID 6483 //
     /* 1445181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1445192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1445195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1445198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445231 */     // MIs[1] Operand 1
     /* 1445231 */     // No operand predicates
     /* 1445231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445235 */     // MIs[0] policy
     /* 1445235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445247 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1445250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445272 */     // GIR_Coverage, 6483,
     /* 1445272 */     GIR_EraseRootFromParent_Done,
     /* 1445273 */   // Label 20340: @1445273
     /* 1445273 */   GIM_Try, /*On fail goto*//*Label 20341*/ GIMT_Encode4(1445370), // Rule ID 6486 //
     /* 1445278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1445289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1445292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1445295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445328 */     // MIs[1] Operand 1
     /* 1445328 */     // No operand predicates
     /* 1445328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445332 */     // MIs[0] policy
     /* 1445332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445344 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1445347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445369 */     // GIR_Coverage, 6486,
     /* 1445369 */     GIR_EraseRootFromParent_Done,
     /* 1445370 */   // Label 20341: @1445370
     /* 1445370 */   GIM_Try, /*On fail goto*//*Label 20342*/ GIMT_Encode4(1445467), // Rule ID 6487 //
     /* 1445375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1445386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1445389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1445392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445425 */     // MIs[1] Operand 1
     /* 1445425 */     // No operand predicates
     /* 1445425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445429 */     // MIs[0] policy
     /* 1445429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445441 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1445444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445466 */     // GIR_Coverage, 6487,
     /* 1445466 */     GIR_EraseRootFromParent_Done,
     /* 1445467 */   // Label 20342: @1445467
     /* 1445467 */   GIM_Try, /*On fail goto*//*Label 20343*/ GIMT_Encode4(1445564), // Rule ID 6490 //
     /* 1445472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1445483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1445486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1445489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445522 */     // MIs[1] Operand 1
     /* 1445522 */     // No operand predicates
     /* 1445522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445526 */     // MIs[0] policy
     /* 1445526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1445541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445563 */     // GIR_Coverage, 6490,
     /* 1445563 */     GIR_EraseRootFromParent_Done,
     /* 1445564 */   // Label 20343: @1445564
     /* 1445564 */   GIM_Try, /*On fail goto*//*Label 20344*/ GIMT_Encode4(1445661), // Rule ID 6491 //
     /* 1445569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1445580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1445583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1445586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445619 */     // MIs[1] Operand 1
     /* 1445619 */     // No operand predicates
     /* 1445619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445623 */     // MIs[0] policy
     /* 1445623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445635 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1445638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445660 */     // GIR_Coverage, 6491,
     /* 1445660 */     GIR_EraseRootFromParent_Done,
     /* 1445661 */   // Label 20344: @1445661
     /* 1445661 */   GIM_Try, /*On fail goto*//*Label 20345*/ GIMT_Encode4(1445758), // Rule ID 6494 //
     /* 1445666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1445677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1445680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1445683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1445689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445716 */     // MIs[1] Operand 1
     /* 1445716 */     // No operand predicates
     /* 1445716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445720 */     // MIs[0] policy
     /* 1445720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1445735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445757 */     // GIR_Coverage, 6494,
     /* 1445757 */     GIR_EraseRootFromParent_Done,
     /* 1445758 */   // Label 20345: @1445758
     /* 1445758 */   GIM_Try, /*On fail goto*//*Label 20346*/ GIMT_Encode4(1445855), // Rule ID 6495 //
     /* 1445763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1445774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1445777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1445780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1445786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445813 */     // MIs[1] Operand 1
     /* 1445813 */     // No operand predicates
     /* 1445813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445817 */     // MIs[0] policy
     /* 1445817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445829 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1445832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445854 */     // GIR_Coverage, 6495,
     /* 1445854 */     GIR_EraseRootFromParent_Done,
     /* 1445855 */   // Label 20346: @1445855
     /* 1445855 */   GIM_Try, /*On fail goto*//*Label 20347*/ GIMT_Encode4(1445952), // Rule ID 6498 //
     /* 1445860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1445871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1445874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1445877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445910 */     // MIs[1] Operand 1
     /* 1445910 */     // No operand predicates
     /* 1445910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445914 */     // MIs[0] policy
     /* 1445914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445926 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1445929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445951 */     // GIR_Coverage, 6498,
     /* 1445951 */     GIR_EraseRootFromParent_Done,
     /* 1445952 */   // Label 20347: @1445952
     /* 1445952 */   GIM_Try, /*On fail goto*//*Label 20348*/ GIMT_Encode4(1446049), // Rule ID 6499 //
     /* 1445957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1445968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1445971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1445974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1446007 */     // MIs[1] Operand 1
     /* 1446007 */     // No operand predicates
     /* 1446007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446011 */     // MIs[0] policy
     /* 1446011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446023 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1446026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446048 */     // GIR_Coverage, 6499,
     /* 1446048 */     GIR_EraseRootFromParent_Done,
     /* 1446049 */   // Label 20348: @1446049
     /* 1446049 */   GIM_Try, /*On fail goto*//*Label 20349*/ GIMT_Encode4(1446146), // Rule ID 6502 //
     /* 1446054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1446062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1446065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1446068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1446071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1446104 */     // MIs[1] Operand 1
     /* 1446104 */     // No operand predicates
     /* 1446104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446108 */     // MIs[0] policy
     /* 1446108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446120 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1446123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446145 */     // GIR_Coverage, 6502,
     /* 1446145 */     GIR_EraseRootFromParent_Done,
     /* 1446146 */   // Label 20349: @1446146
     /* 1446146 */   GIM_Try, /*On fail goto*//*Label 20350*/ GIMT_Encode4(1446243), // Rule ID 6503 //
     /* 1446151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1446159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1446162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1446165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1446168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1446201 */     // MIs[1] Operand 1
     /* 1446201 */     // No operand predicates
     /* 1446201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446205 */     // MIs[0] policy
     /* 1446205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446217 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1446220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446242 */     // GIR_Coverage, 6503,
     /* 1446242 */     GIR_EraseRootFromParent_Done,
     /* 1446243 */   // Label 20350: @1446243
     /* 1446243 */   GIM_Try, /*On fail goto*//*Label 20351*/ GIMT_Encode4(1446340), // Rule ID 6506 //
     /* 1446248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1446251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1446256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1446259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1446262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1446265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446294 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1446298 */     // MIs[1] Operand 1
     /* 1446298 */     // No operand predicates
     /* 1446298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446302 */     // MIs[0] policy
     /* 1446302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446314 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1446317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446339 */     // GIR_Coverage, 6506,
     /* 1446339 */     GIR_EraseRootFromParent_Done,
     /* 1446340 */   // Label 20351: @1446340
     /* 1446340 */   GIM_Try, /*On fail goto*//*Label 20352*/ GIMT_Encode4(1446437), // Rule ID 6507 //
     /* 1446345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1446348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1446353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1446356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1446359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1446362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1446395 */     // MIs[1] Operand 1
     /* 1446395 */     // No operand predicates
     /* 1446395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446399 */     // MIs[0] policy
     /* 1446399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446411 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1446414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446436 */     // GIR_Coverage, 6507,
     /* 1446436 */     GIR_EraseRootFromParent_Done,
     /* 1446437 */   // Label 20352: @1446437
     /* 1446437 */   GIM_Try, /*On fail goto*//*Label 20353*/ GIMT_Encode4(1446534), // Rule ID 6510 //
     /* 1446442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1446450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1446453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1446456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1446459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1446465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1446472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1446492 */     // MIs[1] Operand 1
     /* 1446492 */     // No operand predicates
     /* 1446492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446496 */     // MIs[0] policy
     /* 1446496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446508 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1446511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446533 */     // GIR_Coverage, 6510,
     /* 1446533 */     GIR_EraseRootFromParent_Done,
     /* 1446534 */   // Label 20353: @1446534
     /* 1446534 */   GIM_Try, /*On fail goto*//*Label 20354*/ GIMT_Encode4(1446631), // Rule ID 6511 //
     /* 1446539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1446547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1446550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1446553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1446556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1446562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1446569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1446589 */     // MIs[1] Operand 1
     /* 1446589 */     // No operand predicates
     /* 1446589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446593 */     // MIs[0] policy
     /* 1446593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446605 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1446608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446630 */     // GIR_Coverage, 6511,
     /* 1446630 */     GIR_EraseRootFromParent_Done,
     /* 1446631 */   // Label 20354: @1446631
     /* 1446631 */   GIM_Try, /*On fail goto*//*Label 20355*/ GIMT_Encode4(1446728), // Rule ID 6514 //
     /* 1446636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1446644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1446647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1446650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1446653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1446659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1446666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1446686 */     // MIs[1] Operand 1
     /* 1446686 */     // No operand predicates
     /* 1446686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446690 */     // MIs[0] policy
     /* 1446690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446702 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1446705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446727 */     // GIR_Coverage, 6514,
     /* 1446727 */     GIR_EraseRootFromParent_Done,
     /* 1446728 */   // Label 20355: @1446728
     /* 1446728 */   GIM_Try, /*On fail goto*//*Label 20356*/ GIMT_Encode4(1446825), // Rule ID 6515 //
     /* 1446733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1446741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1446744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1446747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1446750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1446756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1446763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1446783 */     // MIs[1] Operand 1
     /* 1446783 */     // No operand predicates
     /* 1446783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446787 */     // MIs[0] policy
     /* 1446787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446799 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1446802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446824 */     // GIR_Coverage, 6515,
     /* 1446824 */     GIR_EraseRootFromParent_Done,
     /* 1446825 */   // Label 20356: @1446825
     /* 1446825 */   GIM_Try, /*On fail goto*//*Label 20357*/ GIMT_Encode4(1446922), // Rule ID 6518 //
     /* 1446830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1446838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1446841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1446844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1446847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1446853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1446860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1446880 */     // MIs[1] Operand 1
     /* 1446880 */     // No operand predicates
     /* 1446880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446884 */     // MIs[0] policy
     /* 1446884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446896 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1446899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446921 */     // GIR_Coverage, 6518,
     /* 1446921 */     GIR_EraseRootFromParent_Done,
     /* 1446922 */   // Label 20357: @1446922
     /* 1446922 */   GIM_Try, /*On fail goto*//*Label 20358*/ GIMT_Encode4(1447019), // Rule ID 6519 //
     /* 1446927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1446935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1446938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1446941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1446944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1446950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1446957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1446977 */     // MIs[1] Operand 1
     /* 1446977 */     // No operand predicates
     /* 1446977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446981 */     // MIs[0] policy
     /* 1446981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446993 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1446996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447018 */     // GIR_Coverage, 6519,
     /* 1447018 */     GIR_EraseRootFromParent_Done,
     /* 1447019 */   // Label 20358: @1447019
     /* 1447019 */   GIM_Try, /*On fail goto*//*Label 20359*/ GIMT_Encode4(1447116), // Rule ID 6522 //
     /* 1447024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1447032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1447035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1447038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1447041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1447047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1447074 */     // MIs[1] Operand 1
     /* 1447074 */     // No operand predicates
     /* 1447074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447078 */     // MIs[0] policy
     /* 1447078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447090 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1447093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447115 */     // GIR_Coverage, 6522,
     /* 1447115 */     GIR_EraseRootFromParent_Done,
     /* 1447116 */   // Label 20359: @1447116
     /* 1447116 */   GIM_Try, /*On fail goto*//*Label 20360*/ GIMT_Encode4(1447213), // Rule ID 6523 //
     /* 1447121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1447129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1447132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1447135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1447138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1447144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1447171 */     // MIs[1] Operand 1
     /* 1447171 */     // No operand predicates
     /* 1447171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447175 */     // MIs[0] policy
     /* 1447175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447187 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1447190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447212 */     // GIR_Coverage, 6523,
     /* 1447212 */     GIR_EraseRootFromParent_Done,
     /* 1447213 */   // Label 20360: @1447213
     /* 1447213 */   GIM_Try, /*On fail goto*//*Label 20361*/ GIMT_Encode4(1447310), // Rule ID 6526 //
     /* 1447218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1447226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1447229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1447232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1447235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1447241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1447268 */     // MIs[1] Operand 1
     /* 1447268 */     // No operand predicates
     /* 1447268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447272 */     // MIs[0] policy
     /* 1447272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447284 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1447287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447309 */     // GIR_Coverage, 6526,
     /* 1447309 */     GIR_EraseRootFromParent_Done,
     /* 1447310 */   // Label 20361: @1447310
     /* 1447310 */   GIM_Try, /*On fail goto*//*Label 20362*/ GIMT_Encode4(1447407), // Rule ID 6527 //
     /* 1447315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1447323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1447326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1447329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1447332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1447338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1447365 */     // MIs[1] Operand 1
     /* 1447365 */     // No operand predicates
     /* 1447365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447369 */     // MIs[0] policy
     /* 1447369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447381 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1447384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447406 */     // GIR_Coverage, 6527,
     /* 1447406 */     GIR_EraseRootFromParent_Done,
     /* 1447407 */   // Label 20362: @1447407
     /* 1447407 */   GIM_Try, /*On fail goto*//*Label 20363*/ GIMT_Encode4(1447504), // Rule ID 6530 //
     /* 1447412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1447420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1447423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1447426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1447429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1447462 */     // MIs[1] Operand 1
     /* 1447462 */     // No operand predicates
     /* 1447462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447466 */     // MIs[0] policy
     /* 1447466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447478 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1447481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447503 */     // GIR_Coverage, 6530,
     /* 1447503 */     GIR_EraseRootFromParent_Done,
     /* 1447504 */   // Label 20363: @1447504
     /* 1447504 */   GIM_Try, /*On fail goto*//*Label 20364*/ GIMT_Encode4(1447601), // Rule ID 6531 //
     /* 1447509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1447517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1447520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1447523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1447526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1447559 */     // MIs[1] Operand 1
     /* 1447559 */     // No operand predicates
     /* 1447559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447563 */     // MIs[0] policy
     /* 1447563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447575 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1447578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447600 */     // GIR_Coverage, 6531,
     /* 1447600 */     GIR_EraseRootFromParent_Done,
     /* 1447601 */   // Label 20364: @1447601
     /* 1447601 */   GIM_Try, /*On fail goto*//*Label 20365*/ GIMT_Encode4(1447698), // Rule ID 6534 //
     /* 1447606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1447614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1447617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1447620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1447623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1447629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1447656 */     // MIs[1] Operand 1
     /* 1447656 */     // No operand predicates
     /* 1447656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447660 */     // MIs[0] policy
     /* 1447660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447672 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1447675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447697 */     // GIR_Coverage, 6534,
     /* 1447697 */     GIR_EraseRootFromParent_Done,
     /* 1447698 */   // Label 20365: @1447698
     /* 1447698 */   GIM_Try, /*On fail goto*//*Label 20366*/ GIMT_Encode4(1447795), // Rule ID 6535 //
     /* 1447703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1447711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1447714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1447717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1447720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1447726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1447753 */     // MIs[1] Operand 1
     /* 1447753 */     // No operand predicates
     /* 1447753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447757 */     // MIs[0] policy
     /* 1447757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447769 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1447772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447794 */     // GIR_Coverage, 6535,
     /* 1447794 */     GIR_EraseRootFromParent_Done,
     /* 1447795 */   // Label 20366: @1447795
     /* 1447795 */   GIM_Try, /*On fail goto*//*Label 20367*/ GIMT_Encode4(1447892), // Rule ID 6538 //
     /* 1447800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1447808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1447811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1447814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1447817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1447823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1447850 */     // MIs[1] Operand 1
     /* 1447850 */     // No operand predicates
     /* 1447850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447854 */     // MIs[0] policy
     /* 1447854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1447869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447891 */     // GIR_Coverage, 6538,
     /* 1447891 */     GIR_EraseRootFromParent_Done,
     /* 1447892 */   // Label 20367: @1447892
     /* 1447892 */   GIM_Try, /*On fail goto*//*Label 20368*/ GIMT_Encode4(1447989), // Rule ID 6539 //
     /* 1447897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1447905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1447908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1447911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1447914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1447920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1447947 */     // MIs[1] Operand 1
     /* 1447947 */     // No operand predicates
     /* 1447947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447951 */     // MIs[0] policy
     /* 1447951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447963 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1447966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447988 */     // GIR_Coverage, 6539,
     /* 1447988 */     GIR_EraseRootFromParent_Done,
     /* 1447989 */   // Label 20368: @1447989
     /* 1447989 */   GIM_Try, /*On fail goto*//*Label 20369*/ GIMT_Encode4(1448086), // Rule ID 6542 //
     /* 1447994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1448002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1448005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1448008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1448011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1448044 */     // MIs[1] Operand 1
     /* 1448044 */     // No operand predicates
     /* 1448044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448048 */     // MIs[0] policy
     /* 1448048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448060 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1448063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448085 */     // GIR_Coverage, 6542,
     /* 1448085 */     GIR_EraseRootFromParent_Done,
     /* 1448086 */   // Label 20369: @1448086
     /* 1448086 */   GIM_Try, /*On fail goto*//*Label 20370*/ GIMT_Encode4(1448183), // Rule ID 6543 //
     /* 1448091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1448099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1448102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1448105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1448108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1448141 */     // MIs[1] Operand 1
     /* 1448141 */     // No operand predicates
     /* 1448141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448145 */     // MIs[0] policy
     /* 1448145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448157 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1448160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448182 */     // GIR_Coverage, 6543,
     /* 1448182 */     GIR_EraseRootFromParent_Done,
     /* 1448183 */   // Label 20370: @1448183
     /* 1448183 */   GIM_Try, /*On fail goto*//*Label 20371*/ GIMT_Encode4(1448280), // Rule ID 6546 //
     /* 1448188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1448191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1448196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1448199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1448202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1448205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1448211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1448238 */     // MIs[1] Operand 1
     /* 1448238 */     // No operand predicates
     /* 1448238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448242 */     // MIs[0] policy
     /* 1448242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448254 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1448257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448279 */     // GIR_Coverage, 6546,
     /* 1448279 */     GIR_EraseRootFromParent_Done,
     /* 1448280 */   // Label 20371: @1448280
     /* 1448280 */   GIM_Try, /*On fail goto*//*Label 20372*/ GIMT_Encode4(1448377), // Rule ID 6547 //
     /* 1448285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1448288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1448293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1448296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1448299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1448302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1448308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1448335 */     // MIs[1] Operand 1
     /* 1448335 */     // No operand predicates
     /* 1448335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448339 */     // MIs[0] policy
     /* 1448339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448351 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1448354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448376 */     // GIR_Coverage, 6547,
     /* 1448376 */     GIR_EraseRootFromParent_Done,
     /* 1448377 */   // Label 20372: @1448377
     /* 1448377 */   GIM_Try, /*On fail goto*//*Label 20373*/ GIMT_Encode4(1448474), // Rule ID 6550 //
     /* 1448382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1448385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1448390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1448393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1448396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1448399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1448432 */     // MIs[1] Operand 1
     /* 1448432 */     // No operand predicates
     /* 1448432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448436 */     // MIs[0] policy
     /* 1448436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448448 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1448451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448473 */     // GIR_Coverage, 6550,
     /* 1448473 */     GIR_EraseRootFromParent_Done,
     /* 1448474 */   // Label 20373: @1448474
     /* 1448474 */   GIM_Try, /*On fail goto*//*Label 20374*/ GIMT_Encode4(1448571), // Rule ID 6551 //
     /* 1448479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1448482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1448487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1448490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1448493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1448496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1448529 */     // MIs[1] Operand 1
     /* 1448529 */     // No operand predicates
     /* 1448529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448533 */     // MIs[0] policy
     /* 1448533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448545 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1448548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448570 */     // GIR_Coverage, 6551,
     /* 1448570 */     GIR_EraseRootFromParent_Done,
     /* 1448571 */   // Label 20374: @1448571
     /* 1448571 */   GIM_Try, /*On fail goto*//*Label 20375*/ GIMT_Encode4(1448668), // Rule ID 6554 //
     /* 1448576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1448579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1448584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1448587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1448590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1448593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448622 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1448626 */     // MIs[1] Operand 1
     /* 1448626 */     // No operand predicates
     /* 1448626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448630 */     // MIs[0] policy
     /* 1448630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1448645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448667 */     // GIR_Coverage, 6554,
     /* 1448667 */     GIR_EraseRootFromParent_Done,
     /* 1448668 */   // Label 20375: @1448668
     /* 1448668 */   GIM_Try, /*On fail goto*//*Label 20376*/ GIMT_Encode4(1448765), // Rule ID 6555 //
     /* 1448673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1448676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1448681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1448684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1448687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1448690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1448723 */     // MIs[1] Operand 1
     /* 1448723 */     // No operand predicates
     /* 1448723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448727 */     // MIs[0] policy
     /* 1448727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448739 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1448742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448764 */     // GIR_Coverage, 6555,
     /* 1448764 */     GIR_EraseRootFromParent_Done,
     /* 1448765 */   // Label 20376: @1448765
     /* 1448765 */   GIM_Try, /*On fail goto*//*Label 20377*/ GIMT_Encode4(1448862), // Rule ID 6734 //
     /* 1448770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1448781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1448784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1448787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1448793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448820 */     // MIs[1] Operand 1
     /* 1448820 */     // No operand predicates
     /* 1448820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448824 */     // MIs[0] policy
     /* 1448824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448836 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1448839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1448858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448861 */     // GIR_Coverage, 6734,
     /* 1448861 */     GIR_EraseRootFromParent_Done,
     /* 1448862 */   // Label 20377: @1448862
     /* 1448862 */   GIM_Try, /*On fail goto*//*Label 20378*/ GIMT_Encode4(1448959), // Rule ID 6735 //
     /* 1448867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1448878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1448881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1448884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1448890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448917 */     // MIs[1] Operand 1
     /* 1448917 */     // No operand predicates
     /* 1448917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448921 */     // MIs[0] policy
     /* 1448921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448933 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1448936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1448955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448958 */     // GIR_Coverage, 6735,
     /* 1448958 */     GIR_EraseRootFromParent_Done,
     /* 1448959 */   // Label 20378: @1448959
     /* 1448959 */   GIM_Try, /*On fail goto*//*Label 20379*/ GIMT_Encode4(1449056), // Rule ID 6738 //
     /* 1448964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1448975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1448978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1448981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1448987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449014 */     // MIs[1] Operand 1
     /* 1449014 */     // No operand predicates
     /* 1449014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449018 */     // MIs[0] policy
     /* 1449018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449030 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1449033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449055 */     // GIR_Coverage, 6738,
     /* 1449055 */     GIR_EraseRootFromParent_Done,
     /* 1449056 */   // Label 20379: @1449056
     /* 1449056 */   GIM_Try, /*On fail goto*//*Label 20380*/ GIMT_Encode4(1449153), // Rule ID 6739 //
     /* 1449061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1449072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1449075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1449078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449111 */     // MIs[1] Operand 1
     /* 1449111 */     // No operand predicates
     /* 1449111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449115 */     // MIs[0] policy
     /* 1449115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449127 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1449130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449152 */     // GIR_Coverage, 6739,
     /* 1449152 */     GIR_EraseRootFromParent_Done,
     /* 1449153 */   // Label 20380: @1449153
     /* 1449153 */   GIM_Try, /*On fail goto*//*Label 20381*/ GIMT_Encode4(1449250), // Rule ID 6742 //
     /* 1449158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1449169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1449172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1449175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1449181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449208 */     // MIs[1] Operand 1
     /* 1449208 */     // No operand predicates
     /* 1449208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449212 */     // MIs[0] policy
     /* 1449212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449224 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1449227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449249 */     // GIR_Coverage, 6742,
     /* 1449249 */     GIR_EraseRootFromParent_Done,
     /* 1449250 */   // Label 20381: @1449250
     /* 1449250 */   GIM_Try, /*On fail goto*//*Label 20382*/ GIMT_Encode4(1449347), // Rule ID 6743 //
     /* 1449255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1449266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1449269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1449272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1449278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449305 */     // MIs[1] Operand 1
     /* 1449305 */     // No operand predicates
     /* 1449305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449309 */     // MIs[0] policy
     /* 1449309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449321 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1449324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449346 */     // GIR_Coverage, 6743,
     /* 1449346 */     GIR_EraseRootFromParent_Done,
     /* 1449347 */   // Label 20382: @1449347
     /* 1449347 */   GIM_Try, /*On fail goto*//*Label 20383*/ GIMT_Encode4(1449444), // Rule ID 6746 //
     /* 1449352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1449363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1449366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1449369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449402 */     // MIs[1] Operand 1
     /* 1449402 */     // No operand predicates
     /* 1449402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449406 */     // MIs[0] policy
     /* 1449406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449418 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1449421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449443 */     // GIR_Coverage, 6746,
     /* 1449443 */     GIR_EraseRootFromParent_Done,
     /* 1449444 */   // Label 20383: @1449444
     /* 1449444 */   GIM_Try, /*On fail goto*//*Label 20384*/ GIMT_Encode4(1449541), // Rule ID 6747 //
     /* 1449449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1449460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1449463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1449466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449499 */     // MIs[1] Operand 1
     /* 1449499 */     // No operand predicates
     /* 1449499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449503 */     // MIs[0] policy
     /* 1449503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449515 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1449518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449540 */     // GIR_Coverage, 6747,
     /* 1449540 */     GIR_EraseRootFromParent_Done,
     /* 1449541 */   // Label 20384: @1449541
     /* 1449541 */   GIM_Try, /*On fail goto*//*Label 20385*/ GIMT_Encode4(1449638), // Rule ID 6750 //
     /* 1449546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1449557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1449560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1449563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449596 */     // MIs[1] Operand 1
     /* 1449596 */     // No operand predicates
     /* 1449596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449600 */     // MIs[0] policy
     /* 1449600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449612 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1449615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449637 */     // GIR_Coverage, 6750,
     /* 1449637 */     GIR_EraseRootFromParent_Done,
     /* 1449638 */   // Label 20385: @1449638
     /* 1449638 */   GIM_Try, /*On fail goto*//*Label 20386*/ GIMT_Encode4(1449735), // Rule ID 6751 //
     /* 1449643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1449654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1449657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1449660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449693 */     // MIs[1] Operand 1
     /* 1449693 */     // No operand predicates
     /* 1449693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449697 */     // MIs[0] policy
     /* 1449697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449709 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1449712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449734 */     // GIR_Coverage, 6751,
     /* 1449734 */     GIR_EraseRootFromParent_Done,
     /* 1449735 */   // Label 20386: @1449735
     /* 1449735 */   GIM_Try, /*On fail goto*//*Label 20387*/ GIMT_Encode4(1449832), // Rule ID 6754 //
     /* 1449740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1449751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1449754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1449757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449790 */     // MIs[1] Operand 1
     /* 1449790 */     // No operand predicates
     /* 1449790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449794 */     // MIs[0] policy
     /* 1449794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449806 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1449809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1449828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449831 */     // GIR_Coverage, 6754,
     /* 1449831 */     GIR_EraseRootFromParent_Done,
     /* 1449832 */   // Label 20387: @1449832
     /* 1449832 */   GIM_Try, /*On fail goto*//*Label 20388*/ GIMT_Encode4(1449929), // Rule ID 6755 //
     /* 1449837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1449848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1449851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1449854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449887 */     // MIs[1] Operand 1
     /* 1449887 */     // No operand predicates
     /* 1449887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449891 */     // MIs[0] policy
     /* 1449891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449903 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1449906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1449925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449928 */     // GIR_Coverage, 6755,
     /* 1449928 */     GIR_EraseRootFromParent_Done,
     /* 1449929 */   // Label 20388: @1449929
     /* 1449929 */   GIM_Try, /*On fail goto*//*Label 20389*/ GIMT_Encode4(1450026), // Rule ID 6758 //
     /* 1449934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1449945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1449948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1449951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1449957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449984 */     // MIs[1] Operand 1
     /* 1449984 */     // No operand predicates
     /* 1449984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449988 */     // MIs[0] policy
     /* 1449988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450000 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1450003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450025 */     // GIR_Coverage, 6758,
     /* 1450025 */     GIR_EraseRootFromParent_Done,
     /* 1450026 */   // Label 20389: @1450026
     /* 1450026 */   GIM_Try, /*On fail goto*//*Label 20390*/ GIMT_Encode4(1450123), // Rule ID 6759 //
     /* 1450031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1450039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1450042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1450045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1450048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450081 */     // MIs[1] Operand 1
     /* 1450081 */     // No operand predicates
     /* 1450081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450085 */     // MIs[0] policy
     /* 1450085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450097 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1450100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450122 */     // GIR_Coverage, 6759,
     /* 1450122 */     GIR_EraseRootFromParent_Done,
     /* 1450123 */   // Label 20390: @1450123
     /* 1450123 */   GIM_Try, /*On fail goto*//*Label 20391*/ GIMT_Encode4(1450220), // Rule ID 6762 //
     /* 1450128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1450136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1450139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1450142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1450145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450174 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450178 */     // MIs[1] Operand 1
     /* 1450178 */     // No operand predicates
     /* 1450178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450182 */     // MIs[0] policy
     /* 1450182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450194 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1450197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450219 */     // GIR_Coverage, 6762,
     /* 1450219 */     GIR_EraseRootFromParent_Done,
     /* 1450220 */   // Label 20391: @1450220
     /* 1450220 */   GIM_Try, /*On fail goto*//*Label 20392*/ GIMT_Encode4(1450317), // Rule ID 6763 //
     /* 1450225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1450233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1450236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1450239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1450242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450275 */     // MIs[1] Operand 1
     /* 1450275 */     // No operand predicates
     /* 1450275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450279 */     // MIs[0] policy
     /* 1450279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450291 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1450294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450316 */     // GIR_Coverage, 6763,
     /* 1450316 */     GIR_EraseRootFromParent_Done,
     /* 1450317 */   // Label 20392: @1450317
     /* 1450317 */   GIM_Try, /*On fail goto*//*Label 20393*/ GIMT_Encode4(1450414), // Rule ID 6766 //
     /* 1450322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1450330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1450333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1450336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1450339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450372 */     // MIs[1] Operand 1
     /* 1450372 */     // No operand predicates
     /* 1450372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450376 */     // MIs[0] policy
     /* 1450376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450388 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1450391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450413 */     // GIR_Coverage, 6766,
     /* 1450413 */     GIR_EraseRootFromParent_Done,
     /* 1450414 */   // Label 20393: @1450414
     /* 1450414 */   GIM_Try, /*On fail goto*//*Label 20394*/ GIMT_Encode4(1450511), // Rule ID 6767 //
     /* 1450419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1450427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1450430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1450433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1450436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450469 */     // MIs[1] Operand 1
     /* 1450469 */     // No operand predicates
     /* 1450469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450473 */     // MIs[0] policy
     /* 1450473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450485 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1450488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450510 */     // GIR_Coverage, 6767,
     /* 1450510 */     GIR_EraseRootFromParent_Done,
     /* 1450511 */   // Label 20394: @1450511
     /* 1450511 */   GIM_Try, /*On fail goto*//*Label 20395*/ GIMT_Encode4(1450608), // Rule ID 6770 //
     /* 1450516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1450519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1450524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1450527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1450530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1450533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450566 */     // MIs[1] Operand 1
     /* 1450566 */     // No operand predicates
     /* 1450566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450570 */     // MIs[0] policy
     /* 1450570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450582 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1450585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1450604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450607 */     // GIR_Coverage, 6770,
     /* 1450607 */     GIR_EraseRootFromParent_Done,
     /* 1450608 */   // Label 20395: @1450608
     /* 1450608 */   GIM_Try, /*On fail goto*//*Label 20396*/ GIMT_Encode4(1450705), // Rule ID 6771 //
     /* 1450613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1450616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1450621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1450624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1450627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1450630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450663 */     // MIs[1] Operand 1
     /* 1450663 */     // No operand predicates
     /* 1450663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450667 */     // MIs[0] policy
     /* 1450667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450679 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1450682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1450701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450704 */     // GIR_Coverage, 6771,
     /* 1450704 */     GIR_EraseRootFromParent_Done,
     /* 1450705 */   // Label 20396: @1450705
     /* 1450705 */   GIM_Try, /*On fail goto*//*Label 20397*/ GIMT_Encode4(1450802), // Rule ID 6774 //
     /* 1450710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1450718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1450721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1450724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1450727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1450733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1450740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450760 */     // MIs[1] Operand 1
     /* 1450760 */     // No operand predicates
     /* 1450760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450764 */     // MIs[0] policy
     /* 1450764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450776 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1450779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450801 */     // GIR_Coverage, 6774,
     /* 1450801 */     GIR_EraseRootFromParent_Done,
     /* 1450802 */   // Label 20397: @1450802
     /* 1450802 */   GIM_Try, /*On fail goto*//*Label 20398*/ GIMT_Encode4(1450899), // Rule ID 6775 //
     /* 1450807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1450815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1450818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1450821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1450824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1450830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1450837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450857 */     // MIs[1] Operand 1
     /* 1450857 */     // No operand predicates
     /* 1450857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450861 */     // MIs[0] policy
     /* 1450861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450873 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1450876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450898 */     // GIR_Coverage, 6775,
     /* 1450898 */     GIR_EraseRootFromParent_Done,
     /* 1450899 */   // Label 20398: @1450899
     /* 1450899 */   GIM_Try, /*On fail goto*//*Label 20399*/ GIMT_Encode4(1450996), // Rule ID 6778 //
     /* 1450904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1450912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1450915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1450918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1450921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1450927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1450934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450954 */     // MIs[1] Operand 1
     /* 1450954 */     // No operand predicates
     /* 1450954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450958 */     // MIs[0] policy
     /* 1450958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450970 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1450973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450995 */     // GIR_Coverage, 6778,
     /* 1450995 */     GIR_EraseRootFromParent_Done,
     /* 1450996 */   // Label 20399: @1450996
     /* 1450996 */   GIM_Try, /*On fail goto*//*Label 20400*/ GIMT_Encode4(1451093), // Rule ID 6779 //
     /* 1451001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1451009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1451012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1451015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1451018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1451024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1451031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451051 */     // MIs[1] Operand 1
     /* 1451051 */     // No operand predicates
     /* 1451051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451055 */     // MIs[0] policy
     /* 1451055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451067 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1451070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451092 */     // GIR_Coverage, 6779,
     /* 1451092 */     GIR_EraseRootFromParent_Done,
     /* 1451093 */   // Label 20400: @1451093
     /* 1451093 */   GIM_Try, /*On fail goto*//*Label 20401*/ GIMT_Encode4(1451190), // Rule ID 6782 //
     /* 1451098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1451106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1451109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1451112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1451115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1451121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1451128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451148 */     // MIs[1] Operand 1
     /* 1451148 */     // No operand predicates
     /* 1451148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451152 */     // MIs[0] policy
     /* 1451152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451164 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1451167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451189 */     // GIR_Coverage, 6782,
     /* 1451189 */     GIR_EraseRootFromParent_Done,
     /* 1451190 */   // Label 20401: @1451190
     /* 1451190 */   GIM_Try, /*On fail goto*//*Label 20402*/ GIMT_Encode4(1451287), // Rule ID 6783 //
     /* 1451195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1451203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1451206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1451209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1451212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1451218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1451225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451245 */     // MIs[1] Operand 1
     /* 1451245 */     // No operand predicates
     /* 1451245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451249 */     // MIs[0] policy
     /* 1451249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451261 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1451264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451286 */     // GIR_Coverage, 6783,
     /* 1451286 */     GIR_EraseRootFromParent_Done,
     /* 1451287 */   // Label 20402: @1451287
     /* 1451287 */   GIM_Try, /*On fail goto*//*Label 20403*/ GIMT_Encode4(1451384), // Rule ID 6786 //
     /* 1451292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1451300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1451303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1451306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1451309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1451315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451342 */     // MIs[1] Operand 1
     /* 1451342 */     // No operand predicates
     /* 1451342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451346 */     // MIs[0] policy
     /* 1451346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451358 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1451361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451383 */     // GIR_Coverage, 6786,
     /* 1451383 */     GIR_EraseRootFromParent_Done,
     /* 1451384 */   // Label 20403: @1451384
     /* 1451384 */   GIM_Try, /*On fail goto*//*Label 20404*/ GIMT_Encode4(1451481), // Rule ID 6787 //
     /* 1451389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1451397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1451400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1451403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1451406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1451412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451439 */     // MIs[1] Operand 1
     /* 1451439 */     // No operand predicates
     /* 1451439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451443 */     // MIs[0] policy
     /* 1451443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451455 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1451458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451480 */     // GIR_Coverage, 6787,
     /* 1451480 */     GIR_EraseRootFromParent_Done,
     /* 1451481 */   // Label 20404: @1451481
     /* 1451481 */   GIM_Try, /*On fail goto*//*Label 20405*/ GIMT_Encode4(1451578), // Rule ID 6790 //
     /* 1451486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1451494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1451497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1451500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1451503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1451509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1451516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451536 */     // MIs[1] Operand 1
     /* 1451536 */     // No operand predicates
     /* 1451536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451540 */     // MIs[0] policy
     /* 1451540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451552 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1451555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451577 */     // GIR_Coverage, 6790,
     /* 1451577 */     GIR_EraseRootFromParent_Done,
     /* 1451578 */   // Label 20405: @1451578
     /* 1451578 */   GIM_Try, /*On fail goto*//*Label 20406*/ GIMT_Encode4(1451675), // Rule ID 6791 //
     /* 1451583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1451591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1451594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1451597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1451600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1451606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1451613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451633 */     // MIs[1] Operand 1
     /* 1451633 */     // No operand predicates
     /* 1451633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451637 */     // MIs[0] policy
     /* 1451637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451649 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1451652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451674 */     // GIR_Coverage, 6791,
     /* 1451674 */     GIR_EraseRootFromParent_Done,
     /* 1451675 */   // Label 20406: @1451675
     /* 1451675 */   GIM_Try, /*On fail goto*//*Label 20407*/ GIMT_Encode4(1451772), // Rule ID 6794 //
     /* 1451680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1451688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1451691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1451694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1451697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1451703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1451710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451730 */     // MIs[1] Operand 1
     /* 1451730 */     // No operand predicates
     /* 1451730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451734 */     // MIs[0] policy
     /* 1451734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1451749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451771 */     // GIR_Coverage, 6794,
     /* 1451771 */     GIR_EraseRootFromParent_Done,
     /* 1451772 */   // Label 20407: @1451772
     /* 1451772 */   GIM_Try, /*On fail goto*//*Label 20408*/ GIMT_Encode4(1451869), // Rule ID 6795 //
     /* 1451777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1451785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1451788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1451791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1451794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1451800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1451807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451827 */     // MIs[1] Operand 1
     /* 1451827 */     // No operand predicates
     /* 1451827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451831 */     // MIs[0] policy
     /* 1451831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451843 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1451846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451868 */     // GIR_Coverage, 6795,
     /* 1451868 */     GIR_EraseRootFromParent_Done,
     /* 1451869 */   // Label 20408: @1451869
     /* 1451869 */   GIM_Try, /*On fail goto*//*Label 20409*/ GIMT_Encode4(1451966), // Rule ID 6798 //
     /* 1451874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1451882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1451885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1451888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1451891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1451897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451924 */     // MIs[1] Operand 1
     /* 1451924 */     // No operand predicates
     /* 1451924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451928 */     // MIs[0] policy
     /* 1451928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1451943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1451962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451965 */     // GIR_Coverage, 6798,
     /* 1451965 */     GIR_EraseRootFromParent_Done,
     /* 1451966 */   // Label 20409: @1451966
     /* 1451966 */   GIM_Try, /*On fail goto*//*Label 20410*/ GIMT_Encode4(1452063), // Rule ID 6799 //
     /* 1451971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1451979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1451982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1451985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1451988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1451994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452021 */     // MIs[1] Operand 1
     /* 1452021 */     // No operand predicates
     /* 1452021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452025 */     // MIs[0] policy
     /* 1452025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452037 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1452040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452062 */     // GIR_Coverage, 6799,
     /* 1452062 */     GIR_EraseRootFromParent_Done,
     /* 1452063 */   // Label 20410: @1452063
     /* 1452063 */   GIM_Try, /*On fail goto*//*Label 20411*/ GIMT_Encode4(1452160), // Rule ID 6802 //
     /* 1452068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1452076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1452079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1452082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1452085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452118 */     // MIs[1] Operand 1
     /* 1452118 */     // No operand predicates
     /* 1452118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452122 */     // MIs[0] policy
     /* 1452122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452134 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1452137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452159 */     // GIR_Coverage, 6802,
     /* 1452159 */     GIR_EraseRootFromParent_Done,
     /* 1452160 */   // Label 20411: @1452160
     /* 1452160 */   GIM_Try, /*On fail goto*//*Label 20412*/ GIMT_Encode4(1452257), // Rule ID 6803 //
     /* 1452165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1452173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1452176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1452179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1452182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452215 */     // MIs[1] Operand 1
     /* 1452215 */     // No operand predicates
     /* 1452215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452219 */     // MIs[0] policy
     /* 1452219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452231 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1452234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452256 */     // GIR_Coverage, 6803,
     /* 1452256 */     GIR_EraseRootFromParent_Done,
     /* 1452257 */   // Label 20412: @1452257
     /* 1452257 */   GIM_Try, /*On fail goto*//*Label 20413*/ GIMT_Encode4(1452354), // Rule ID 6806 //
     /* 1452262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1452270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1452273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1452276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1452279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1452285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452312 */     // MIs[1] Operand 1
     /* 1452312 */     // No operand predicates
     /* 1452312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452316 */     // MIs[0] policy
     /* 1452316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452328 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1452331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452353 */     // GIR_Coverage, 6806,
     /* 1452353 */     GIR_EraseRootFromParent_Done,
     /* 1452354 */   // Label 20413: @1452354
     /* 1452354 */   GIM_Try, /*On fail goto*//*Label 20414*/ GIMT_Encode4(1452451), // Rule ID 6807 //
     /* 1452359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1452367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1452370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1452373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1452376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1452382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452409 */     // MIs[1] Operand 1
     /* 1452409 */     // No operand predicates
     /* 1452409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452413 */     // MIs[0] policy
     /* 1452413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452425 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1452428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452450 */     // GIR_Coverage, 6807,
     /* 1452450 */     GIR_EraseRootFromParent_Done,
     /* 1452451 */   // Label 20414: @1452451
     /* 1452451 */   GIM_Try, /*On fail goto*//*Label 20415*/ GIMT_Encode4(1452548), // Rule ID 6810 //
     /* 1452456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1452459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1452464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1452467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1452470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1452473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1452479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452502 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452506 */     // MIs[1] Operand 1
     /* 1452506 */     // No operand predicates
     /* 1452506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452510 */     // MIs[0] policy
     /* 1452510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452522 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1452525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1452544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452547 */     // GIR_Coverage, 6810,
     /* 1452547 */     GIR_EraseRootFromParent_Done,
     /* 1452548 */   // Label 20415: @1452548
     /* 1452548 */   GIM_Try, /*On fail goto*//*Label 20416*/ GIMT_Encode4(1452645), // Rule ID 6811 //
     /* 1452553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1452556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1452561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1452564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1452567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1452570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1452576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452603 */     // MIs[1] Operand 1
     /* 1452603 */     // No operand predicates
     /* 1452603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452607 */     // MIs[0] policy
     /* 1452607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452619 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1452622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1452641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452644 */     // GIR_Coverage, 6811,
     /* 1452644 */     GIR_EraseRootFromParent_Done,
     /* 1452645 */   // Label 20416: @1452645
     /* 1452645 */   GIM_Try, /*On fail goto*//*Label 20417*/ GIMT_Encode4(1452742), // Rule ID 6814 //
     /* 1452650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1452653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1452658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1452661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1452664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1452667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452700 */     // MIs[1] Operand 1
     /* 1452700 */     // No operand predicates
     /* 1452700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452704 */     // MIs[0] policy
     /* 1452704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452716 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1452719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1452738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452741 */     // GIR_Coverage, 6814,
     /* 1452741 */     GIR_EraseRootFromParent_Done,
     /* 1452742 */   // Label 20417: @1452742
     /* 1452742 */   GIM_Try, /*On fail goto*//*Label 20418*/ GIMT_Encode4(1452839), // Rule ID 6815 //
     /* 1452747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1452750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1452755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1452758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1452761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1452764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452797 */     // MIs[1] Operand 1
     /* 1452797 */     // No operand predicates
     /* 1452797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452801 */     // MIs[0] policy
     /* 1452801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452813 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1452816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1452835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452838 */     // GIR_Coverage, 6815,
     /* 1452838 */     GIR_EraseRootFromParent_Done,
     /* 1452839 */   // Label 20418: @1452839
     /* 1452839 */   GIM_Try, /*On fail goto*//*Label 20419*/ GIMT_Encode4(1452936), // Rule ID 6818 //
     /* 1452844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1452847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1452852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1452855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1452858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1452861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452894 */     // MIs[1] Operand 1
     /* 1452894 */     // No operand predicates
     /* 1452894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452898 */     // MIs[0] policy
     /* 1452898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452910 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1452913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1452932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452935 */     // GIR_Coverage, 6818,
     /* 1452935 */     GIR_EraseRootFromParent_Done,
     /* 1452936 */   // Label 20419: @1452936
     /* 1452936 */   GIM_Try, /*On fail goto*//*Label 20420*/ GIMT_Encode4(1453033), // Rule ID 6819 //
     /* 1452941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1452944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1452949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1452952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1452955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1452958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452991 */     // MIs[1] Operand 1
     /* 1452991 */     // No operand predicates
     /* 1452991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452995 */     // MIs[0] policy
     /* 1452995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453007 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1453010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453032 */     // GIR_Coverage, 6819,
     /* 1453032 */     GIR_EraseRootFromParent_Done,
     /* 1453033 */   // Label 20420: @1453033
     /* 1453033 */   GIM_Try, /*On fail goto*//*Label 20421*/ GIMT_Encode4(1453130), // Rule ID 6998 //
     /* 1453038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1453049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1453052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1453055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1453061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453088 */     // MIs[1] Operand 1
     /* 1453088 */     // No operand predicates
     /* 1453088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453092 */     // MIs[0] policy
     /* 1453092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453104 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1453107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453129 */     // GIR_Coverage, 6998,
     /* 1453129 */     GIR_EraseRootFromParent_Done,
     /* 1453130 */   // Label 20421: @1453130
     /* 1453130 */   GIM_Try, /*On fail goto*//*Label 20422*/ GIMT_Encode4(1453227), // Rule ID 6999 //
     /* 1453135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1453146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1453149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1453152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1453158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453185 */     // MIs[1] Operand 1
     /* 1453185 */     // No operand predicates
     /* 1453185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453189 */     // MIs[0] policy
     /* 1453189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453201 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1453204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453226 */     // GIR_Coverage, 6999,
     /* 1453226 */     GIR_EraseRootFromParent_Done,
     /* 1453227 */   // Label 20422: @1453227
     /* 1453227 */   GIM_Try, /*On fail goto*//*Label 20423*/ GIMT_Encode4(1453324), // Rule ID 7002 //
     /* 1453232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1453243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1453246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1453249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453282 */     // MIs[1] Operand 1
     /* 1453282 */     // No operand predicates
     /* 1453282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453286 */     // MIs[0] policy
     /* 1453286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453298 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1453301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453323 */     // GIR_Coverage, 7002,
     /* 1453323 */     GIR_EraseRootFromParent_Done,
     /* 1453324 */   // Label 20423: @1453324
     /* 1453324 */   GIM_Try, /*On fail goto*//*Label 20424*/ GIMT_Encode4(1453421), // Rule ID 7003 //
     /* 1453329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1453340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1453343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1453346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453379 */     // MIs[1] Operand 1
     /* 1453379 */     // No operand predicates
     /* 1453379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453383 */     // MIs[0] policy
     /* 1453383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453395 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1453398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453420 */     // GIR_Coverage, 7003,
     /* 1453420 */     GIR_EraseRootFromParent_Done,
     /* 1453421 */   // Label 20424: @1453421
     /* 1453421 */   GIM_Try, /*On fail goto*//*Label 20425*/ GIMT_Encode4(1453518), // Rule ID 7006 //
     /* 1453426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1453437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1453440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1453443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453476 */     // MIs[1] Operand 1
     /* 1453476 */     // No operand predicates
     /* 1453476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453480 */     // MIs[0] policy
     /* 1453480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453492 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1453495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453517 */     // GIR_Coverage, 7006,
     /* 1453517 */     GIR_EraseRootFromParent_Done,
     /* 1453518 */   // Label 20425: @1453518
     /* 1453518 */   GIM_Try, /*On fail goto*//*Label 20426*/ GIMT_Encode4(1453615), // Rule ID 7007 //
     /* 1453523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1453534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1453537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1453540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453573 */     // MIs[1] Operand 1
     /* 1453573 */     // No operand predicates
     /* 1453573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453577 */     // MIs[0] policy
     /* 1453577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453589 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1453592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453614 */     // GIR_Coverage, 7007,
     /* 1453614 */     GIR_EraseRootFromParent_Done,
     /* 1453615 */   // Label 20426: @1453615
     /* 1453615 */   GIM_Try, /*On fail goto*//*Label 20427*/ GIMT_Encode4(1453712), // Rule ID 7010 //
     /* 1453620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1453631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1453634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1453637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1453643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453670 */     // MIs[1] Operand 1
     /* 1453670 */     // No operand predicates
     /* 1453670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453674 */     // MIs[0] policy
     /* 1453674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453686 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1453689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453711 */     // GIR_Coverage, 7010,
     /* 1453711 */     GIR_EraseRootFromParent_Done,
     /* 1453712 */   // Label 20427: @1453712
     /* 1453712 */   GIM_Try, /*On fail goto*//*Label 20428*/ GIMT_Encode4(1453809), // Rule ID 7011 //
     /* 1453717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1453728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1453731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1453734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1453740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453767 */     // MIs[1] Operand 1
     /* 1453767 */     // No operand predicates
     /* 1453767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453771 */     // MIs[0] policy
     /* 1453771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453783 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1453786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453808 */     // GIR_Coverage, 7011,
     /* 1453808 */     GIR_EraseRootFromParent_Done,
     /* 1453809 */   // Label 20428: @1453809
     /* 1453809 */   GIM_Try, /*On fail goto*//*Label 20429*/ GIMT_Encode4(1453906), // Rule ID 7014 //
     /* 1453814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1453825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1453828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1453831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453864 */     // MIs[1] Operand 1
     /* 1453864 */     // No operand predicates
     /* 1453864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453868 */     // MIs[0] policy
     /* 1453868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453880 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1453883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453905 */     // GIR_Coverage, 7014,
     /* 1453905 */     GIR_EraseRootFromParent_Done,
     /* 1453906 */   // Label 20429: @1453906
     /* 1453906 */   GIM_Try, /*On fail goto*//*Label 20430*/ GIMT_Encode4(1454003), // Rule ID 7015 //
     /* 1453911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1453922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1453925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1453928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453961 */     // MIs[1] Operand 1
     /* 1453961 */     // No operand predicates
     /* 1453961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453965 */     // MIs[0] policy
     /* 1453965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453977 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1453980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454002 */     // GIR_Coverage, 7015,
     /* 1454002 */     GIR_EraseRootFromParent_Done,
     /* 1454003 */   // Label 20430: @1454003
     /* 1454003 */   GIM_Try, /*On fail goto*//*Label 20431*/ GIMT_Encode4(1454100), // Rule ID 7018 //
     /* 1454008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1454016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1454019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1454022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1454025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454058 */     // MIs[1] Operand 1
     /* 1454058 */     // No operand predicates
     /* 1454058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454062 */     // MIs[0] policy
     /* 1454062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454074 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1454077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454099 */     // GIR_Coverage, 7018,
     /* 1454099 */     GIR_EraseRootFromParent_Done,
     /* 1454100 */   // Label 20431: @1454100
     /* 1454100 */   GIM_Try, /*On fail goto*//*Label 20432*/ GIMT_Encode4(1454197), // Rule ID 7019 //
     /* 1454105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1454113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1454116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1454119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1454122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454155 */     // MIs[1] Operand 1
     /* 1454155 */     // No operand predicates
     /* 1454155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454159 */     // MIs[0] policy
     /* 1454159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454171 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1454174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454196 */     // GIR_Coverage, 7019,
     /* 1454196 */     GIR_EraseRootFromParent_Done,
     /* 1454197 */   // Label 20432: @1454197
     /* 1454197 */   GIM_Try, /*On fail goto*//*Label 20433*/ GIMT_Encode4(1454294), // Rule ID 7022 //
     /* 1454202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1454210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1454213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1454216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1454219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1454225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454252 */     // MIs[1] Operand 1
     /* 1454252 */     // No operand predicates
     /* 1454252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454256 */     // MIs[0] policy
     /* 1454256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454268 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1454271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454293 */     // GIR_Coverage, 7022,
     /* 1454293 */     GIR_EraseRootFromParent_Done,
     /* 1454294 */   // Label 20433: @1454294
     /* 1454294 */   GIM_Try, /*On fail goto*//*Label 20434*/ GIMT_Encode4(1454391), // Rule ID 7023 //
     /* 1454299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1454307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1454310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1454313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1454316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1454322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454349 */     // MIs[1] Operand 1
     /* 1454349 */     // No operand predicates
     /* 1454349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454353 */     // MIs[0] policy
     /* 1454353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454365 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1454368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454390 */     // GIR_Coverage, 7023,
     /* 1454390 */     GIR_EraseRootFromParent_Done,
     /* 1454391 */   // Label 20434: @1454391
     /* 1454391 */   GIM_Try, /*On fail goto*//*Label 20435*/ GIMT_Encode4(1454488), // Rule ID 7026 //
     /* 1454396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1454404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1454407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1454410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1454413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454446 */     // MIs[1] Operand 1
     /* 1454446 */     // No operand predicates
     /* 1454446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454450 */     // MIs[0] policy
     /* 1454450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454462 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1454465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454487 */     // GIR_Coverage, 7026,
     /* 1454487 */     GIR_EraseRootFromParent_Done,
     /* 1454488 */   // Label 20435: @1454488
     /* 1454488 */   GIM_Try, /*On fail goto*//*Label 20436*/ GIMT_Encode4(1454585), // Rule ID 7027 //
     /* 1454493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1454501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1454504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1454507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1454510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454543 */     // MIs[1] Operand 1
     /* 1454543 */     // No operand predicates
     /* 1454543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454547 */     // MIs[0] policy
     /* 1454547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454559 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1454562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454584 */     // GIR_Coverage, 7027,
     /* 1454584 */     GIR_EraseRootFromParent_Done,
     /* 1454585 */   // Label 20436: @1454585
     /* 1454585 */   GIM_Try, /*On fail goto*//*Label 20437*/ GIMT_Encode4(1454682), // Rule ID 7030 //
     /* 1454590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1454598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1454601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1454604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1454607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454640 */     // MIs[1] Operand 1
     /* 1454640 */     // No operand predicates
     /* 1454640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454644 */     // MIs[0] policy
     /* 1454644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1454659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454681 */     // GIR_Coverage, 7030,
     /* 1454681 */     GIR_EraseRootFromParent_Done,
     /* 1454682 */   // Label 20437: @1454682
     /* 1454682 */   GIM_Try, /*On fail goto*//*Label 20438*/ GIMT_Encode4(1454779), // Rule ID 7031 //
     /* 1454687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1454695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1454698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1454701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1454704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454737 */     // MIs[1] Operand 1
     /* 1454737 */     // No operand predicates
     /* 1454737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454741 */     // MIs[0] policy
     /* 1454741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454753 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1454756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454778 */     // GIR_Coverage, 7031,
     /* 1454778 */     GIR_EraseRootFromParent_Done,
     /* 1454779 */   // Label 20438: @1454779
     /* 1454779 */   GIM_Try, /*On fail goto*//*Label 20439*/ GIMT_Encode4(1454876), // Rule ID 7034 //
     /* 1454784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1454787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1454792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1454795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1454798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1454801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454834 */     // MIs[1] Operand 1
     /* 1454834 */     // No operand predicates
     /* 1454834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454838 */     // MIs[0] policy
     /* 1454838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454850 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1454853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1454872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454875 */     // GIR_Coverage, 7034,
     /* 1454875 */     GIR_EraseRootFromParent_Done,
     /* 1454876 */   // Label 20439: @1454876
     /* 1454876 */   GIM_Try, /*On fail goto*//*Label 20440*/ GIMT_Encode4(1454973), // Rule ID 7035 //
     /* 1454881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1454884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1454889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1454892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1454895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1454898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454931 */     // MIs[1] Operand 1
     /* 1454931 */     // No operand predicates
     /* 1454931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454935 */     // MIs[0] policy
     /* 1454935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454947 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1454950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1454969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454972 */     // GIR_Coverage, 7035,
     /* 1454972 */     GIR_EraseRootFromParent_Done,
     /* 1454973 */   // Label 20440: @1454973
     /* 1454973 */   GIM_Try, /*On fail goto*//*Label 20441*/ GIMT_Encode4(1455070), // Rule ID 7038 //
     /* 1454978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1454986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1454989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1454992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1454995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1455001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455024 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455028 */     // MIs[1] Operand 1
     /* 1455028 */     // No operand predicates
     /* 1455028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455032 */     // MIs[0] policy
     /* 1455032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1455047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455069 */     // GIR_Coverage, 7038,
     /* 1455069 */     GIR_EraseRootFromParent_Done,
     /* 1455070 */   // Label 20441: @1455070
     /* 1455070 */   GIM_Try, /*On fail goto*//*Label 20442*/ GIMT_Encode4(1455167), // Rule ID 7039 //
     /* 1455075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1455083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1455086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1455089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1455092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1455098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455125 */     // MIs[1] Operand 1
     /* 1455125 */     // No operand predicates
     /* 1455125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455129 */     // MIs[0] policy
     /* 1455129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455141 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1455144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455166 */     // GIR_Coverage, 7039,
     /* 1455166 */     GIR_EraseRootFromParent_Done,
     /* 1455167 */   // Label 20442: @1455167
     /* 1455167 */   GIM_Try, /*On fail goto*//*Label 20443*/ GIMT_Encode4(1455264), // Rule ID 7042 //
     /* 1455172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1455180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1455183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1455186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1455189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1455195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455222 */     // MIs[1] Operand 1
     /* 1455222 */     // No operand predicates
     /* 1455222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455226 */     // MIs[0] policy
     /* 1455226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455238 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1455241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455263 */     // GIR_Coverage, 7042,
     /* 1455263 */     GIR_EraseRootFromParent_Done,
     /* 1455264 */   // Label 20443: @1455264
     /* 1455264 */   GIM_Try, /*On fail goto*//*Label 20444*/ GIMT_Encode4(1455361), // Rule ID 7043 //
     /* 1455269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1455277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1455280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1455283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1455286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1455292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455319 */     // MIs[1] Operand 1
     /* 1455319 */     // No operand predicates
     /* 1455319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455323 */     // MIs[0] policy
     /* 1455323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455335 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1455338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455360 */     // GIR_Coverage, 7043,
     /* 1455360 */     GIR_EraseRootFromParent_Done,
     /* 1455361 */   // Label 20444: @1455361
     /* 1455361 */   GIM_Try, /*On fail goto*//*Label 20445*/ GIMT_Encode4(1455458), // Rule ID 7046 //
     /* 1455366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1455374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1455377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1455380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1455383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1455389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1455396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455416 */     // MIs[1] Operand 1
     /* 1455416 */     // No operand predicates
     /* 1455416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455420 */     // MIs[0] policy
     /* 1455420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455432 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1455435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455457 */     // GIR_Coverage, 7046,
     /* 1455457 */     GIR_EraseRootFromParent_Done,
     /* 1455458 */   // Label 20445: @1455458
     /* 1455458 */   GIM_Try, /*On fail goto*//*Label 20446*/ GIMT_Encode4(1455555), // Rule ID 7047 //
     /* 1455463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1455471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1455474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1455477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1455480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1455486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1455493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455513 */     // MIs[1] Operand 1
     /* 1455513 */     // No operand predicates
     /* 1455513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455517 */     // MIs[0] policy
     /* 1455517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455529 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1455532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455554 */     // GIR_Coverage, 7047,
     /* 1455554 */     GIR_EraseRootFromParent_Done,
     /* 1455555 */   // Label 20446: @1455555
     /* 1455555 */   GIM_Try, /*On fail goto*//*Label 20447*/ GIMT_Encode4(1455652), // Rule ID 7050 //
     /* 1455560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1455568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1455571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1455574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1455577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1455583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455610 */     // MIs[1] Operand 1
     /* 1455610 */     // No operand predicates
     /* 1455610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455614 */     // MIs[0] policy
     /* 1455614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1455629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455651 */     // GIR_Coverage, 7050,
     /* 1455651 */     GIR_EraseRootFromParent_Done,
     /* 1455652 */   // Label 20447: @1455652
     /* 1455652 */   GIM_Try, /*On fail goto*//*Label 20448*/ GIMT_Encode4(1455749), // Rule ID 7051 //
     /* 1455657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1455665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1455668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1455671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1455674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1455680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455707 */     // MIs[1] Operand 1
     /* 1455707 */     // No operand predicates
     /* 1455707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455711 */     // MIs[0] policy
     /* 1455711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455723 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1455726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455748 */     // GIR_Coverage, 7051,
     /* 1455748 */     GIR_EraseRootFromParent_Done,
     /* 1455749 */   // Label 20448: @1455749
     /* 1455749 */   GIM_Try, /*On fail goto*//*Label 20449*/ GIMT_Encode4(1455846), // Rule ID 7054 //
     /* 1455754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1455762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1455765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1455768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1455771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1455777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455804 */     // MIs[1] Operand 1
     /* 1455804 */     // No operand predicates
     /* 1455804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455808 */     // MIs[0] policy
     /* 1455808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455820 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1455823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455845 */     // GIR_Coverage, 7054,
     /* 1455845 */     GIR_EraseRootFromParent_Done,
     /* 1455846 */   // Label 20449: @1455846
     /* 1455846 */   GIM_Try, /*On fail goto*//*Label 20450*/ GIMT_Encode4(1455943), // Rule ID 7055 //
     /* 1455851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1455859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1455862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1455865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1455868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1455874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455901 */     // MIs[1] Operand 1
     /* 1455901 */     // No operand predicates
     /* 1455901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455905 */     // MIs[0] policy
     /* 1455905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455917 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1455920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455942 */     // GIR_Coverage, 7055,
     /* 1455942 */     GIR_EraseRootFromParent_Done,
     /* 1455943 */   // Label 20450: @1455943
     /* 1455943 */   GIM_Try, /*On fail goto*//*Label 20451*/ GIMT_Encode4(1456040), // Rule ID 7058 //
     /* 1455948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1455956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1455959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1455962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1455965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1455971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1455978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455998 */     // MIs[1] Operand 1
     /* 1455998 */     // No operand predicates
     /* 1455998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456002 */     // MIs[0] policy
     /* 1456002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456014 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1456017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456039 */     // GIR_Coverage, 7058,
     /* 1456039 */     GIR_EraseRootFromParent_Done,
     /* 1456040 */   // Label 20451: @1456040
     /* 1456040 */   GIM_Try, /*On fail goto*//*Label 20452*/ GIMT_Encode4(1456137), // Rule ID 7059 //
     /* 1456045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1456053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1456056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1456059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1456062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456095 */     // MIs[1] Operand 1
     /* 1456095 */     // No operand predicates
     /* 1456095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456099 */     // MIs[0] policy
     /* 1456099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456111 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1456114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456136 */     // GIR_Coverage, 7059,
     /* 1456136 */     GIR_EraseRootFromParent_Done,
     /* 1456137 */   // Label 20452: @1456137
     /* 1456137 */   GIM_Try, /*On fail goto*//*Label 20453*/ GIMT_Encode4(1456234), // Rule ID 7062 //
     /* 1456142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1456150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1456153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1456156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1456159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1456165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456192 */     // MIs[1] Operand 1
     /* 1456192 */     // No operand predicates
     /* 1456192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456196 */     // MIs[0] policy
     /* 1456196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456208 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1456211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456233 */     // GIR_Coverage, 7062,
     /* 1456233 */     GIR_EraseRootFromParent_Done,
     /* 1456234 */   // Label 20453: @1456234
     /* 1456234 */   GIM_Try, /*On fail goto*//*Label 20454*/ GIMT_Encode4(1456331), // Rule ID 7063 //
     /* 1456239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1456247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1456250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1456253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1456256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1456262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456289 */     // MIs[1] Operand 1
     /* 1456289 */     // No operand predicates
     /* 1456289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456293 */     // MIs[0] policy
     /* 1456293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456305 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1456308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456330 */     // GIR_Coverage, 7063,
     /* 1456330 */     GIR_EraseRootFromParent_Done,
     /* 1456331 */   // Label 20454: @1456331
     /* 1456331 */   GIM_Try, /*On fail goto*//*Label 20455*/ GIMT_Encode4(1456428), // Rule ID 7066 //
     /* 1456336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1456344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1456347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1456350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1456353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456386 */     // MIs[1] Operand 1
     /* 1456386 */     // No operand predicates
     /* 1456386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456390 */     // MIs[0] policy
     /* 1456390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456402 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1456405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456427 */     // GIR_Coverage, 7066,
     /* 1456427 */     GIR_EraseRootFromParent_Done,
     /* 1456428 */   // Label 20455: @1456428
     /* 1456428 */   GIM_Try, /*On fail goto*//*Label 20456*/ GIMT_Encode4(1456525), // Rule ID 7067 //
     /* 1456433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1456441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1456444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1456447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1456450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456483 */     // MIs[1] Operand 1
     /* 1456483 */     // No operand predicates
     /* 1456483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456487 */     // MIs[0] policy
     /* 1456487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456499 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1456502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456524 */     // GIR_Coverage, 7067,
     /* 1456524 */     GIR_EraseRootFromParent_Done,
     /* 1456525 */   // Label 20456: @1456525
     /* 1456525 */   GIM_Try, /*On fail goto*//*Label 20457*/ GIMT_Encode4(1456622), // Rule ID 7070 //
     /* 1456530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1456538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1456541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1456544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1456547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456580 */     // MIs[1] Operand 1
     /* 1456580 */     // No operand predicates
     /* 1456580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456584 */     // MIs[0] policy
     /* 1456584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1456599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456621 */     // GIR_Coverage, 7070,
     /* 1456621 */     GIR_EraseRootFromParent_Done,
     /* 1456622 */   // Label 20457: @1456622
     /* 1456622 */   GIM_Try, /*On fail goto*//*Label 20458*/ GIMT_Encode4(1456719), // Rule ID 7071 //
     /* 1456627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1456635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1456638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1456641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1456644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456677 */     // MIs[1] Operand 1
     /* 1456677 */     // No operand predicates
     /* 1456677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456681 */     // MIs[0] policy
     /* 1456681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456693 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1456696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456718 */     // GIR_Coverage, 7071,
     /* 1456718 */     GIR_EraseRootFromParent_Done,
     /* 1456719 */   // Label 20458: @1456719
     /* 1456719 */   GIM_Try, /*On fail goto*//*Label 20459*/ GIMT_Encode4(1456816), // Rule ID 7074 //
     /* 1456724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1456727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1456732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1456735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1456738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1456741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1456747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456774 */     // MIs[1] Operand 1
     /* 1456774 */     // No operand predicates
     /* 1456774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456778 */     // MIs[0] policy
     /* 1456778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1456793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1456812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456815 */     // GIR_Coverage, 7074,
     /* 1456815 */     GIR_EraseRootFromParent_Done,
     /* 1456816 */   // Label 20459: @1456816
     /* 1456816 */   GIM_Try, /*On fail goto*//*Label 20460*/ GIMT_Encode4(1456913), // Rule ID 7075 //
     /* 1456821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1456824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1456829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1456832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1456835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1456838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1456844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456871 */     // MIs[1] Operand 1
     /* 1456871 */     // No operand predicates
     /* 1456871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456875 */     // MIs[0] policy
     /* 1456875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456887 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1456890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1456909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456912 */     // GIR_Coverage, 7075,
     /* 1456912 */     GIR_EraseRootFromParent_Done,
     /* 1456913 */   // Label 20460: @1456913
     /* 1456913 */   GIM_Try, /*On fail goto*//*Label 20461*/ GIMT_Encode4(1457010), // Rule ID 7078 //
     /* 1456918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1456921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1456926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1456929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1456932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1456935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1456941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456968 */     // MIs[1] Operand 1
     /* 1456968 */     // No operand predicates
     /* 1456968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456972 */     // MIs[0] policy
     /* 1456972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456984 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1456987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457009 */     // GIR_Coverage, 7078,
     /* 1457009 */     GIR_EraseRootFromParent_Done,
     /* 1457010 */   // Label 20461: @1457010
     /* 1457010 */   GIM_Try, /*On fail goto*//*Label 20462*/ GIMT_Encode4(1457107), // Rule ID 7079 //
     /* 1457015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1457018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1457023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1457026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1457029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1457032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457065 */     // MIs[1] Operand 1
     /* 1457065 */     // No operand predicates
     /* 1457065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457069 */     // MIs[0] policy
     /* 1457069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457081 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1457084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457106 */     // GIR_Coverage, 7079,
     /* 1457106 */     GIR_EraseRootFromParent_Done,
     /* 1457107 */   // Label 20462: @1457107
     /* 1457107 */   GIM_Try, /*On fail goto*//*Label 20463*/ GIMT_Encode4(1457204), // Rule ID 7082 //
     /* 1457112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1457115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1457120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1457123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1457126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1457129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1457135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1457142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457162 */     // MIs[1] Operand 1
     /* 1457162 */     // No operand predicates
     /* 1457162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457166 */     // MIs[0] policy
     /* 1457166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457178 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1457181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457203 */     // GIR_Coverage, 7082,
     /* 1457203 */     GIR_EraseRootFromParent_Done,
     /* 1457204 */   // Label 20463: @1457204
     /* 1457204 */   GIM_Try, /*On fail goto*//*Label 20464*/ GIMT_Encode4(1457301), // Rule ID 7083 //
     /* 1457209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1457212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1457217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1457220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1457223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1457226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1457232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1457239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457259 */     // MIs[1] Operand 1
     /* 1457259 */     // No operand predicates
     /* 1457259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457263 */     // MIs[0] policy
     /* 1457263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457275 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1457278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457300 */     // GIR_Coverage, 7083,
     /* 1457300 */     GIR_EraseRootFromParent_Done,
     /* 1457301 */   // Label 20464: @1457301
     /* 1457301 */   GIM_Try, /*On fail goto*//*Label 20465*/ GIMT_Encode4(1457398), // Rule ID 7262 //
     /* 1457306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1457317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1457320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1457323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1457329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457356 */     // MIs[1] Operand 1
     /* 1457356 */     // No operand predicates
     /* 1457356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457360 */     // MIs[0] policy
     /* 1457360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457372 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1457375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457397 */     // GIR_Coverage, 7262,
     /* 1457397 */     GIR_EraseRootFromParent_Done,
     /* 1457398 */   // Label 20465: @1457398
     /* 1457398 */   GIM_Try, /*On fail goto*//*Label 20466*/ GIMT_Encode4(1457495), // Rule ID 7263 //
     /* 1457403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1457414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1457417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1457420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1457426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457453 */     // MIs[1] Operand 1
     /* 1457453 */     // No operand predicates
     /* 1457453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457457 */     // MIs[0] policy
     /* 1457457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457469 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1457472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457494 */     // GIR_Coverage, 7263,
     /* 1457494 */     GIR_EraseRootFromParent_Done,
     /* 1457495 */   // Label 20466: @1457495
     /* 1457495 */   GIM_Try, /*On fail goto*//*Label 20467*/ GIMT_Encode4(1457592), // Rule ID 7266 //
     /* 1457500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1457511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1457514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1457517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457550 */     // MIs[1] Operand 1
     /* 1457550 */     // No operand predicates
     /* 1457550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457554 */     // MIs[0] policy
     /* 1457554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457566 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1457569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457591 */     // GIR_Coverage, 7266,
     /* 1457591 */     GIR_EraseRootFromParent_Done,
     /* 1457592 */   // Label 20467: @1457592
     /* 1457592 */   GIM_Try, /*On fail goto*//*Label 20468*/ GIMT_Encode4(1457689), // Rule ID 7267 //
     /* 1457597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1457608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1457611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1457614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457647 */     // MIs[1] Operand 1
     /* 1457647 */     // No operand predicates
     /* 1457647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457651 */     // MIs[0] policy
     /* 1457651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457663 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1457666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457688 */     // GIR_Coverage, 7267,
     /* 1457688 */     GIR_EraseRootFromParent_Done,
     /* 1457689 */   // Label 20468: @1457689
     /* 1457689 */   GIM_Try, /*On fail goto*//*Label 20469*/ GIMT_Encode4(1457786), // Rule ID 7270 //
     /* 1457694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1457705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1457708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1457711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457744 */     // MIs[1] Operand 1
     /* 1457744 */     // No operand predicates
     /* 1457744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457748 */     // MIs[0] policy
     /* 1457748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457760 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1457763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457785 */     // GIR_Coverage, 7270,
     /* 1457785 */     GIR_EraseRootFromParent_Done,
     /* 1457786 */   // Label 20469: @1457786
     /* 1457786 */   GIM_Try, /*On fail goto*//*Label 20470*/ GIMT_Encode4(1457883), // Rule ID 7271 //
     /* 1457791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1457802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1457805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1457808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457841 */     // MIs[1] Operand 1
     /* 1457841 */     // No operand predicates
     /* 1457841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457845 */     // MIs[0] policy
     /* 1457845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457857 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1457860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457882 */     // GIR_Coverage, 7271,
     /* 1457882 */     GIR_EraseRootFromParent_Done,
     /* 1457883 */   // Label 20470: @1457883
     /* 1457883 */   GIM_Try, /*On fail goto*//*Label 20471*/ GIMT_Encode4(1457980), // Rule ID 7274 //
     /* 1457888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1457899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1457902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1457905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1457911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457934 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457938 */     // MIs[1] Operand 1
     /* 1457938 */     // No operand predicates
     /* 1457938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457942 */     // MIs[0] policy
     /* 1457942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457954 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1457957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457979 */     // GIR_Coverage, 7274,
     /* 1457979 */     GIR_EraseRootFromParent_Done,
     /* 1457980 */   // Label 20471: @1457980
     /* 1457980 */   GIM_Try, /*On fail goto*//*Label 20472*/ GIMT_Encode4(1458077), // Rule ID 7275 //
     /* 1457985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1457996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1457999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1458002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458035 */     // MIs[1] Operand 1
     /* 1458035 */     // No operand predicates
     /* 1458035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458039 */     // MIs[0] policy
     /* 1458039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458051 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1458054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1458073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458076 */     // GIR_Coverage, 7275,
     /* 1458076 */     GIR_EraseRootFromParent_Done,
     /* 1458077 */   // Label 20472: @1458077
     /* 1458077 */   GIM_Try, /*On fail goto*//*Label 20473*/ GIMT_Encode4(1458174), // Rule ID 7278 //
     /* 1458082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1458093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1458096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1458099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458132 */     // MIs[1] Operand 1
     /* 1458132 */     // No operand predicates
     /* 1458132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458136 */     // MIs[0] policy
     /* 1458136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1458151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1458170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458173 */     // GIR_Coverage, 7278,
     /* 1458173 */     GIR_EraseRootFromParent_Done,
     /* 1458174 */   // Label 20473: @1458174
     /* 1458174 */   GIM_Try, /*On fail goto*//*Label 20474*/ GIMT_Encode4(1458271), // Rule ID 7279 //
     /* 1458179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1458190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1458193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1458196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458229 */     // MIs[1] Operand 1
     /* 1458229 */     // No operand predicates
     /* 1458229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458233 */     // MIs[0] policy
     /* 1458233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458245 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1458248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1458267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458270 */     // GIR_Coverage, 7279,
     /* 1458270 */     GIR_EraseRootFromParent_Done,
     /* 1458271 */   // Label 20474: @1458271
     /* 1458271 */   GIM_Try, /*On fail goto*//*Label 20475*/ GIMT_Encode4(1458368), // Rule ID 7282 //
     /* 1458276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1458287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1458290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1458293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458326 */     // MIs[1] Operand 1
     /* 1458326 */     // No operand predicates
     /* 1458326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458330 */     // MIs[0] policy
     /* 1458330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458342 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1458345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458367 */     // GIR_Coverage, 7282,
     /* 1458367 */     GIR_EraseRootFromParent_Done,
     /* 1458368 */   // Label 20475: @1458368
     /* 1458368 */   GIM_Try, /*On fail goto*//*Label 20476*/ GIMT_Encode4(1458465), // Rule ID 7283 //
     /* 1458373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1458384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1458387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1458390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458423 */     // MIs[1] Operand 1
     /* 1458423 */     // No operand predicates
     /* 1458423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458427 */     // MIs[0] policy
     /* 1458427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458439 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1458442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458464 */     // GIR_Coverage, 7283,
     /* 1458464 */     GIR_EraseRootFromParent_Done,
     /* 1458465 */   // Label 20476: @1458465
     /* 1458465 */   GIM_Try, /*On fail goto*//*Label 20477*/ GIMT_Encode4(1458562), // Rule ID 7286 //
     /* 1458470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1458481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1458484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1458487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458520 */     // MIs[1] Operand 1
     /* 1458520 */     // No operand predicates
     /* 1458520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458524 */     // MIs[0] policy
     /* 1458524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458536 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1458539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458561 */     // GIR_Coverage, 7286,
     /* 1458561 */     GIR_EraseRootFromParent_Done,
     /* 1458562 */   // Label 20477: @1458562
     /* 1458562 */   GIM_Try, /*On fail goto*//*Label 20478*/ GIMT_Encode4(1458659), // Rule ID 7287 //
     /* 1458567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1458578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1458581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1458584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458617 */     // MIs[1] Operand 1
     /* 1458617 */     // No operand predicates
     /* 1458617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458621 */     // MIs[0] policy
     /* 1458621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458633 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1458636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458658 */     // GIR_Coverage, 7287,
     /* 1458658 */     GIR_EraseRootFromParent_Done,
     /* 1458659 */   // Label 20478: @1458659
     /* 1458659 */   GIM_Try, /*On fail goto*//*Label 20479*/ GIMT_Encode4(1458756), // Rule ID 7290 //
     /* 1458664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1458675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1458678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458714 */     // MIs[1] Operand 1
     /* 1458714 */     // No operand predicates
     /* 1458714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458718 */     // MIs[0] policy
     /* 1458718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458730 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1458733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1458752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458755 */     // GIR_Coverage, 7290,
     /* 1458755 */     GIR_EraseRootFromParent_Done,
     /* 1458756 */   // Label 20479: @1458756
     /* 1458756 */   GIM_Try, /*On fail goto*//*Label 20480*/ GIMT_Encode4(1458853), // Rule ID 7291 //
     /* 1458761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1458772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1458775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458811 */     // MIs[1] Operand 1
     /* 1458811 */     // No operand predicates
     /* 1458811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458815 */     // MIs[0] policy
     /* 1458815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1458830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1458849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458852 */     // GIR_Coverage, 7291,
     /* 1458852 */     GIR_EraseRootFromParent_Done,
     /* 1458853 */   // Label 20480: @1458853
     /* 1458853 */   GIM_Try, /*On fail goto*//*Label 20481*/ GIMT_Encode4(1458950), // Rule ID 7294 //
     /* 1458858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1458869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1458872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1458875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458904 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458908 */     // MIs[1] Operand 1
     /* 1458908 */     // No operand predicates
     /* 1458908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458912 */     // MIs[0] policy
     /* 1458912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458924 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1458927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458949 */     // GIR_Coverage, 7294,
     /* 1458949 */     GIR_EraseRootFromParent_Done,
     /* 1458950 */   // Label 20481: @1458950
     /* 1458950 */   GIM_Try, /*On fail goto*//*Label 20482*/ GIMT_Encode4(1459047), // Rule ID 7295 //
     /* 1458955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1458966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1458969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1458972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459005 */     // MIs[1] Operand 1
     /* 1459005 */     // No operand predicates
     /* 1459005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459009 */     // MIs[0] policy
     /* 1459009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459021 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1459024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1459043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459046 */     // GIR_Coverage, 7295,
     /* 1459046 */     GIR_EraseRootFromParent_Done,
     /* 1459047 */   // Label 20482: @1459047
     /* 1459047 */   GIM_Try, /*On fail goto*//*Label 20483*/ GIMT_Encode4(1459144), // Rule ID 7298 //
     /* 1459052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1459055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1459060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1459063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1459066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1459069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459102 */     // MIs[1] Operand 1
     /* 1459102 */     // No operand predicates
     /* 1459102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459106 */     // MIs[0] policy
     /* 1459106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459118 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1459121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1459140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459143 */     // GIR_Coverage, 7298,
     /* 1459143 */     GIR_EraseRootFromParent_Done,
     /* 1459144 */   // Label 20483: @1459144
     /* 1459144 */   GIM_Try, /*On fail goto*//*Label 20484*/ GIMT_Encode4(1459241), // Rule ID 7299 //
     /* 1459149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1459152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1459157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1459160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1459163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1459166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459199 */     // MIs[1] Operand 1
     /* 1459199 */     // No operand predicates
     /* 1459199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459203 */     // MIs[0] policy
     /* 1459203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459215 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1459218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1459237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459240 */     // GIR_Coverage, 7299,
     /* 1459240 */     GIR_EraseRootFromParent_Done,
     /* 1459241 */   // Label 20484: @1459241
     /* 1459241 */   GIM_Try, /*On fail goto*//*Label 20485*/ GIMT_Encode4(1459338), // Rule ID 7302 //
     /* 1459246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1459254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1459257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1459260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1459263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459296 */     // MIs[1] Operand 1
     /* 1459296 */     // No operand predicates
     /* 1459296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459300 */     // MIs[0] policy
     /* 1459300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459312 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1459315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459337 */     // GIR_Coverage, 7302,
     /* 1459337 */     GIR_EraseRootFromParent_Done,
     /* 1459338 */   // Label 20485: @1459338
     /* 1459338 */   GIM_Try, /*On fail goto*//*Label 20486*/ GIMT_Encode4(1459435), // Rule ID 7303 //
     /* 1459343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1459351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1459354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1459357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1459360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459393 */     // MIs[1] Operand 1
     /* 1459393 */     // No operand predicates
     /* 1459393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459397 */     // MIs[0] policy
     /* 1459397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459409 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1459412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459434 */     // GIR_Coverage, 7303,
     /* 1459434 */     GIR_EraseRootFromParent_Done,
     /* 1459435 */   // Label 20486: @1459435
     /* 1459435 */   GIM_Try, /*On fail goto*//*Label 20487*/ GIMT_Encode4(1459532), // Rule ID 7306 //
     /* 1459440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1459448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1459451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1459454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1459457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1459463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459490 */     // MIs[1] Operand 1
     /* 1459490 */     // No operand predicates
     /* 1459490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459494 */     // MIs[0] policy
     /* 1459494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459506 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1459509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459531 */     // GIR_Coverage, 7306,
     /* 1459531 */     GIR_EraseRootFromParent_Done,
     /* 1459532 */   // Label 20487: @1459532
     /* 1459532 */   GIM_Try, /*On fail goto*//*Label 20488*/ GIMT_Encode4(1459629), // Rule ID 7307 //
     /* 1459537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1459545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1459548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1459551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1459554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1459560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459587 */     // MIs[1] Operand 1
     /* 1459587 */     // No operand predicates
     /* 1459587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459591 */     // MIs[0] policy
     /* 1459591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459603 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1459606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459628 */     // GIR_Coverage, 7307,
     /* 1459628 */     GIR_EraseRootFromParent_Done,
     /* 1459629 */   // Label 20488: @1459629
     /* 1459629 */   GIM_Try, /*On fail goto*//*Label 20489*/ GIMT_Encode4(1459726), // Rule ID 7310 //
     /* 1459634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1459642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1459645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1459648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1459651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1459657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1459664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459684 */     // MIs[1] Operand 1
     /* 1459684 */     // No operand predicates
     /* 1459684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459688 */     // MIs[0] policy
     /* 1459688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459700 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1459703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459725 */     // GIR_Coverage, 7310,
     /* 1459725 */     GIR_EraseRootFromParent_Done,
     /* 1459726 */   // Label 20489: @1459726
     /* 1459726 */   GIM_Try, /*On fail goto*//*Label 20490*/ GIMT_Encode4(1459823), // Rule ID 7311 //
     /* 1459731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1459739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1459742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1459745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1459748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1459754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1459761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459781 */     // MIs[1] Operand 1
     /* 1459781 */     // No operand predicates
     /* 1459781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459785 */     // MIs[0] policy
     /* 1459785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459797 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1459800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459822 */     // GIR_Coverage, 7311,
     /* 1459822 */     GIR_EraseRootFromParent_Done,
     /* 1459823 */   // Label 20490: @1459823
     /* 1459823 */   GIM_Try, /*On fail goto*//*Label 20491*/ GIMT_Encode4(1459920), // Rule ID 7314 //
     /* 1459828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1459836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1459839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1459842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1459845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1459851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459874 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459878 */     // MIs[1] Operand 1
     /* 1459878 */     // No operand predicates
     /* 1459878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459882 */     // MIs[0] policy
     /* 1459882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1459897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459919 */     // GIR_Coverage, 7314,
     /* 1459919 */     GIR_EraseRootFromParent_Done,
     /* 1459920 */   // Label 20491: @1459920
     /* 1459920 */   GIM_Try, /*On fail goto*//*Label 20492*/ GIMT_Encode4(1460017), // Rule ID 7315 //
     /* 1459925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1459933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1459936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1459939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1459942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1459948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459975 */     // MIs[1] Operand 1
     /* 1459975 */     // No operand predicates
     /* 1459975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459979 */     // MIs[0] policy
     /* 1459979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459991 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1459994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460016 */     // GIR_Coverage, 7315,
     /* 1460016 */     GIR_EraseRootFromParent_Done,
     /* 1460017 */   // Label 20492: @1460017
     /* 1460017 */   GIM_Try, /*On fail goto*//*Label 20493*/ GIMT_Encode4(1460114), // Rule ID 7318 //
     /* 1460022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1460030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1460033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1460036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1460039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1460045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460072 */     // MIs[1] Operand 1
     /* 1460072 */     // No operand predicates
     /* 1460072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460076 */     // MIs[0] policy
     /* 1460076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460088 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1460091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460113 */     // GIR_Coverage, 7318,
     /* 1460113 */     GIR_EraseRootFromParent_Done,
     /* 1460114 */   // Label 20493: @1460114
     /* 1460114 */   GIM_Try, /*On fail goto*//*Label 20494*/ GIMT_Encode4(1460211), // Rule ID 7319 //
     /* 1460119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1460127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1460130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1460133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1460136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1460142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460169 */     // MIs[1] Operand 1
     /* 1460169 */     // No operand predicates
     /* 1460169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460173 */     // MIs[0] policy
     /* 1460173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460185 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1460188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460210 */     // GIR_Coverage, 7319,
     /* 1460210 */     GIR_EraseRootFromParent_Done,
     /* 1460211 */   // Label 20494: @1460211
     /* 1460211 */   GIM_Try, /*On fail goto*//*Label 20495*/ GIMT_Encode4(1460308), // Rule ID 7322 //
     /* 1460216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1460224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1460227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1460230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1460233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1460239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1460246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460266 */     // MIs[1] Operand 1
     /* 1460266 */     // No operand predicates
     /* 1460266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460270 */     // MIs[0] policy
     /* 1460270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460282 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1460285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460307 */     // GIR_Coverage, 7322,
     /* 1460307 */     GIR_EraseRootFromParent_Done,
     /* 1460308 */   // Label 20495: @1460308
     /* 1460308 */   GIM_Try, /*On fail goto*//*Label 20496*/ GIMT_Encode4(1460405), // Rule ID 7323 //
     /* 1460313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1460321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1460324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1460327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1460330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1460336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1460343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460363 */     // MIs[1] Operand 1
     /* 1460363 */     // No operand predicates
     /* 1460363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460367 */     // MIs[0] policy
     /* 1460367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460379 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1460382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460404 */     // GIR_Coverage, 7323,
     /* 1460404 */     GIR_EraseRootFromParent_Done,
     /* 1460405 */   // Label 20496: @1460405
     /* 1460405 */   GIM_Try, /*On fail goto*//*Label 20497*/ GIMT_Encode4(1460502), // Rule ID 7326 //
     /* 1460410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1460418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1460427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460460 */     // MIs[1] Operand 1
     /* 1460460 */     // No operand predicates
     /* 1460460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460464 */     // MIs[0] policy
     /* 1460464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1460479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460501 */     // GIR_Coverage, 7326,
     /* 1460501 */     GIR_EraseRootFromParent_Done,
     /* 1460502 */   // Label 20497: @1460502
     /* 1460502 */   GIM_Try, /*On fail goto*//*Label 20498*/ GIMT_Encode4(1460599), // Rule ID 7327 //
     /* 1460507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1460515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1460524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460557 */     // MIs[1] Operand 1
     /* 1460557 */     // No operand predicates
     /* 1460557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460561 */     // MIs[0] policy
     /* 1460561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460573 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1460576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460598 */     // GIR_Coverage, 7327,
     /* 1460598 */     GIR_EraseRootFromParent_Done,
     /* 1460599 */   // Label 20498: @1460599
     /* 1460599 */   GIM_Try, /*On fail goto*//*Label 20499*/ GIMT_Encode4(1460696), // Rule ID 7330 //
     /* 1460604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1460612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1460615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1460618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1460621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460654 */     // MIs[1] Operand 1
     /* 1460654 */     // No operand predicates
     /* 1460654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460658 */     // MIs[0] policy
     /* 1460658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460670 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1460673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460695 */     // GIR_Coverage, 7330,
     /* 1460695 */     GIR_EraseRootFromParent_Done,
     /* 1460696 */   // Label 20499: @1460696
     /* 1460696 */   GIM_Try, /*On fail goto*//*Label 20500*/ GIMT_Encode4(1460793), // Rule ID 7331 //
     /* 1460701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1460709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1460712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1460715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1460718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460751 */     // MIs[1] Operand 1
     /* 1460751 */     // No operand predicates
     /* 1460751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460755 */     // MIs[0] policy
     /* 1460755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460767 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1460770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460792 */     // GIR_Coverage, 7331,
     /* 1460792 */     GIR_EraseRootFromParent_Done,
     /* 1460793 */   // Label 20500: @1460793
     /* 1460793 */   GIM_Try, /*On fail goto*//*Label 20501*/ GIMT_Encode4(1460890), // Rule ID 7334 //
     /* 1460798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1460806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1460809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1460812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1460815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1460821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1460828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460848 */     // MIs[1] Operand 1
     /* 1460848 */     // No operand predicates
     /* 1460848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460852 */     // MIs[0] policy
     /* 1460852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1460867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460889 */     // GIR_Coverage, 7334,
     /* 1460889 */     GIR_EraseRootFromParent_Done,
     /* 1460890 */   // Label 20501: @1460890
     /* 1460890 */   GIM_Try, /*On fail goto*//*Label 20502*/ GIMT_Encode4(1460987), // Rule ID 7335 //
     /* 1460895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1460903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1460906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1460909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1460912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1460918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1460925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460945 */     // MIs[1] Operand 1
     /* 1460945 */     // No operand predicates
     /* 1460945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460949 */     // MIs[0] policy
     /* 1460949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460961 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1460964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460986 */     // GIR_Coverage, 7335,
     /* 1460986 */     GIR_EraseRootFromParent_Done,
     /* 1460987 */   // Label 20502: @1460987
     /* 1460987 */   GIM_Try, /*On fail goto*//*Label 20503*/ GIMT_Encode4(1461084), // Rule ID 7338 //
     /* 1460992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1460995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1461000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1461003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1461006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1461009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1461015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1461022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461042 */     // MIs[1] Operand 1
     /* 1461042 */     // No operand predicates
     /* 1461042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461046 */     // MIs[0] policy
     /* 1461046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461058 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1461061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461083 */     // GIR_Coverage, 7338,
     /* 1461083 */     GIR_EraseRootFromParent_Done,
     /* 1461084 */   // Label 20503: @1461084
     /* 1461084 */   GIM_Try, /*On fail goto*//*Label 20504*/ GIMT_Encode4(1461181), // Rule ID 7339 //
     /* 1461089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1461092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1461097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1461100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1461103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1461106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1461112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1461119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461139 */     // MIs[1] Operand 1
     /* 1461139 */     // No operand predicates
     /* 1461139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461143 */     // MIs[0] policy
     /* 1461143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461155 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1461158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461180 */     // GIR_Coverage, 7339,
     /* 1461180 */     GIR_EraseRootFromParent_Done,
     /* 1461181 */   // Label 20504: @1461181
     /* 1461181 */   GIM_Try, /*On fail goto*//*Label 20505*/ GIMT_Encode4(1461278), // Rule ID 7342 //
     /* 1461186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1461189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1461194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1461197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1461200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1461203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1461216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461236 */     // MIs[1] Operand 1
     /* 1461236 */     // No operand predicates
     /* 1461236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461240 */     // MIs[0] policy
     /* 1461240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461252 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1461255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461277 */     // GIR_Coverage, 7342,
     /* 1461277 */     GIR_EraseRootFromParent_Done,
     /* 1461278 */   // Label 20505: @1461278
     /* 1461278 */   GIM_Try, /*On fail goto*//*Label 20506*/ GIMT_Encode4(1461375), // Rule ID 7343 //
     /* 1461283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1461286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1461291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1461294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1461297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1461300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1461313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461333 */     // MIs[1] Operand 1
     /* 1461333 */     // No operand predicates
     /* 1461333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461337 */     // MIs[0] policy
     /* 1461337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461349 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1461352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461374 */     // GIR_Coverage, 7343,
     /* 1461374 */     GIR_EraseRootFromParent_Done,
     /* 1461375 */   // Label 20506: @1461375
     /* 1461375 */   GIM_Try, /*On fail goto*//*Label 20507*/ GIMT_Encode4(1461472), // Rule ID 7346 //
     /* 1461380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1461383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1461388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1461391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1461394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1461397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1461410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461430 */     // MIs[1] Operand 1
     /* 1461430 */     // No operand predicates
     /* 1461430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461434 */     // MIs[0] policy
     /* 1461434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461446 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1461449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461471 */     // GIR_Coverage, 7346,
     /* 1461471 */     GIR_EraseRootFromParent_Done,
     /* 1461472 */   // Label 20507: @1461472
     /* 1461472 */   GIM_Try, /*On fail goto*//*Label 20508*/ GIMT_Encode4(1461569), // Rule ID 7347 //
     /* 1461477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1461480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1461485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1461488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1461491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1461494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1461507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461527 */     // MIs[1] Operand 1
     /* 1461527 */     // No operand predicates
     /* 1461527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461531 */     // MIs[0] policy
     /* 1461531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461543 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1461546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461568 */     // GIR_Coverage, 7347,
     /* 1461568 */     GIR_EraseRootFromParent_Done,
     /* 1461569 */   // Label 20508: @1461569
     /* 1461569 */   GIM_Try, /*On fail goto*//*Label 20509*/ GIMT_Encode4(1461666), // Rule ID 7558 //
     /* 1461574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1461582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1461585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1461588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1461591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461624 */     // MIs[1] Operand 1
     /* 1461624 */     // No operand predicates
     /* 1461624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461628 */     // MIs[0] policy
     /* 1461628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461640 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1461643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461665 */     // GIR_Coverage, 7558,
     /* 1461665 */     GIR_EraseRootFromParent_Done,
     /* 1461666 */   // Label 20509: @1461666
     /* 1461666 */   GIM_Try, /*On fail goto*//*Label 20510*/ GIMT_Encode4(1461763), // Rule ID 7559 //
     /* 1461671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1461679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1461682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1461685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1461688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461721 */     // MIs[1] Operand 1
     /* 1461721 */     // No operand predicates
     /* 1461721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461725 */     // MIs[0] policy
     /* 1461725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461737 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1461740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461762 */     // GIR_Coverage, 7559,
     /* 1461762 */     GIR_EraseRootFromParent_Done,
     /* 1461763 */   // Label 20510: @1461763
     /* 1461763 */   GIM_Try, /*On fail goto*//*Label 20511*/ GIMT_Encode4(1461860), // Rule ID 7562 //
     /* 1461768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1461776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1461779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1461782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1461785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1461791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461814 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461818 */     // MIs[1] Operand 1
     /* 1461818 */     // No operand predicates
     /* 1461818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461822 */     // MIs[0] policy
     /* 1461822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461834 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1461837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461859 */     // GIR_Coverage, 7562,
     /* 1461859 */     GIR_EraseRootFromParent_Done,
     /* 1461860 */   // Label 20511: @1461860
     /* 1461860 */   GIM_Try, /*On fail goto*//*Label 20512*/ GIMT_Encode4(1461957), // Rule ID 7563 //
     /* 1461865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1461873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1461876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1461879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1461882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1461888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461915 */     // MIs[1] Operand 1
     /* 1461915 */     // No operand predicates
     /* 1461915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461919 */     // MIs[0] policy
     /* 1461919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461931 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1461934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461956 */     // GIR_Coverage, 7563,
     /* 1461956 */     GIR_EraseRootFromParent_Done,
     /* 1461957 */   // Label 20512: @1461957
     /* 1461957 */   GIM_Try, /*On fail goto*//*Label 20513*/ GIMT_Encode4(1462054), // Rule ID 7566 //
     /* 1461962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1461970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1461973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1461976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1461979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462012 */     // MIs[1] Operand 1
     /* 1462012 */     // No operand predicates
     /* 1462012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462016 */     // MIs[0] policy
     /* 1462016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462028 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1462031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462053 */     // GIR_Coverage, 7566,
     /* 1462053 */     GIR_EraseRootFromParent_Done,
     /* 1462054 */   // Label 20513: @1462054
     /* 1462054 */   GIM_Try, /*On fail goto*//*Label 20514*/ GIMT_Encode4(1462151), // Rule ID 7567 //
     /* 1462059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1462067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1462070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1462073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1462076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1462082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462109 */     // MIs[1] Operand 1
     /* 1462109 */     // No operand predicates
     /* 1462109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462113 */     // MIs[0] policy
     /* 1462113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462125 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1462128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462150 */     // GIR_Coverage, 7567,
     /* 1462150 */     GIR_EraseRootFromParent_Done,
     /* 1462151 */   // Label 20514: @1462151
     /* 1462151 */   GIM_Try, /*On fail goto*//*Label 20515*/ GIMT_Encode4(1462248), // Rule ID 7570 //
     /* 1462156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1462164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1462167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1462170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1462173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462206 */     // MIs[1] Operand 1
     /* 1462206 */     // No operand predicates
     /* 1462206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462210 */     // MIs[0] policy
     /* 1462210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462222 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1462225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462247 */     // GIR_Coverage, 7570,
     /* 1462247 */     GIR_EraseRootFromParent_Done,
     /* 1462248 */   // Label 20515: @1462248
     /* 1462248 */   GIM_Try, /*On fail goto*//*Label 20516*/ GIMT_Encode4(1462345), // Rule ID 7571 //
     /* 1462253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1462261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1462264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1462267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1462270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462303 */     // MIs[1] Operand 1
     /* 1462303 */     // No operand predicates
     /* 1462303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462307 */     // MIs[0] policy
     /* 1462307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462319 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1462322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462344 */     // GIR_Coverage, 7571,
     /* 1462344 */     GIR_EraseRootFromParent_Done,
     /* 1462345 */   // Label 20516: @1462345
     /* 1462345 */   GIM_Try, /*On fail goto*//*Label 20517*/ GIMT_Encode4(1462442), // Rule ID 7574 //
     /* 1462350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1462358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1462361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1462364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1462367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1462373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462400 */     // MIs[1] Operand 1
     /* 1462400 */     // No operand predicates
     /* 1462400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462404 */     // MIs[0] policy
     /* 1462404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462416 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1462419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462441 */     // GIR_Coverage, 7574,
     /* 1462441 */     GIR_EraseRootFromParent_Done,
     /* 1462442 */   // Label 20517: @1462442
     /* 1462442 */   GIM_Try, /*On fail goto*//*Label 20518*/ GIMT_Encode4(1462539), // Rule ID 7575 //
     /* 1462447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1462455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1462458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1462461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1462464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1462470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462497 */     // MIs[1] Operand 1
     /* 1462497 */     // No operand predicates
     /* 1462497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462501 */     // MIs[0] policy
     /* 1462501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462513 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1462516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462538 */     // GIR_Coverage, 7575,
     /* 1462538 */     GIR_EraseRootFromParent_Done,
     /* 1462539 */   // Label 20518: @1462539
     /* 1462539 */   GIM_Try, /*On fail goto*//*Label 20519*/ GIMT_Encode4(1462636), // Rule ID 7578 //
     /* 1462544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1462552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1462555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1462558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1462561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1462567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1462574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1462582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462594 */     // MIs[1] Operand 1
     /* 1462594 */     // No operand predicates
     /* 1462594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462598 */     // MIs[0] policy
     /* 1462598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462610 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1462613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462635 */     // GIR_Coverage, 7578,
     /* 1462635 */     GIR_EraseRootFromParent_Done,
     /* 1462636 */   // Label 20519: @1462636
     /* 1462636 */   GIM_Try, /*On fail goto*//*Label 20520*/ GIMT_Encode4(1462733), // Rule ID 7579 //
     /* 1462641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1462649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1462652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1462655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1462658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1462664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1462671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1462679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462691 */     // MIs[1] Operand 1
     /* 1462691 */     // No operand predicates
     /* 1462691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462695 */     // MIs[0] policy
     /* 1462695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462707 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1462710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462732 */     // GIR_Coverage, 7579,
     /* 1462732 */     GIR_EraseRootFromParent_Done,
     /* 1462733 */   // Label 20520: @1462733
     /* 1462733 */   GIM_Try, /*On fail goto*//*Label 20521*/ GIMT_Encode4(1462830), // Rule ID 7582 //
     /* 1462738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1462746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1462749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1462752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1462755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462788 */     // MIs[1] Operand 1
     /* 1462788 */     // No operand predicates
     /* 1462788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462792 */     // MIs[0] policy
     /* 1462792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462804 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1462807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462829 */     // GIR_Coverage, 7582,
     /* 1462829 */     GIR_EraseRootFromParent_Done,
     /* 1462830 */   // Label 20521: @1462830
     /* 1462830 */   GIM_Try, /*On fail goto*//*Label 20522*/ GIMT_Encode4(1462927), // Rule ID 7583 //
     /* 1462835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1462843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1462846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1462849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1462852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462885 */     // MIs[1] Operand 1
     /* 1462885 */     // No operand predicates
     /* 1462885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462889 */     // MIs[0] policy
     /* 1462889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462901 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1462904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462926 */     // GIR_Coverage, 7583,
     /* 1462926 */     GIR_EraseRootFromParent_Done,
     /* 1462927 */   // Label 20522: @1462927
     /* 1462927 */   GIM_Try, /*On fail goto*//*Label 20523*/ GIMT_Encode4(1463024), // Rule ID 7586 //
     /* 1462932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1462940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1462943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1462946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1462949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462982 */     // MIs[1] Operand 1
     /* 1462982 */     // No operand predicates
     /* 1462982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462986 */     // MIs[0] policy
     /* 1462986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462998 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1463001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463023 */     // GIR_Coverage, 7586,
     /* 1463023 */     GIR_EraseRootFromParent_Done,
     /* 1463024 */   // Label 20523: @1463024
     /* 1463024 */   GIM_Try, /*On fail goto*//*Label 20524*/ GIMT_Encode4(1463121), // Rule ID 7587 //
     /* 1463029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1463037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1463040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1463043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1463046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463079 */     // MIs[1] Operand 1
     /* 1463079 */     // No operand predicates
     /* 1463079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463083 */     // MIs[0] policy
     /* 1463083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463095 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1463098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463120 */     // GIR_Coverage, 7587,
     /* 1463120 */     GIR_EraseRootFromParent_Done,
     /* 1463121 */   // Label 20524: @1463121
     /* 1463121 */   GIM_Try, /*On fail goto*//*Label 20525*/ GIMT_Encode4(1463218), // Rule ID 7590 //
     /* 1463126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1463134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1463137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1463140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1463143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1463149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463176 */     // MIs[1] Operand 1
     /* 1463176 */     // No operand predicates
     /* 1463176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463180 */     // MIs[0] policy
     /* 1463180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463192 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1463195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463217 */     // GIR_Coverage, 7590,
     /* 1463217 */     GIR_EraseRootFromParent_Done,
     /* 1463218 */   // Label 20525: @1463218
     /* 1463218 */   GIM_Try, /*On fail goto*//*Label 20526*/ GIMT_Encode4(1463315), // Rule ID 7591 //
     /* 1463223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1463231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1463234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1463237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1463240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1463246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463273 */     // MIs[1] Operand 1
     /* 1463273 */     // No operand predicates
     /* 1463273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463277 */     // MIs[0] policy
     /* 1463277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463289 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1463292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463314 */     // GIR_Coverage, 7591,
     /* 1463314 */     GIR_EraseRootFromParent_Done,
     /* 1463315 */   // Label 20526: @1463315
     /* 1463315 */   GIM_Try, /*On fail goto*//*Label 20527*/ GIMT_Encode4(1463412), // Rule ID 7594 //
     /* 1463320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1463328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1463331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1463334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1463337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1463343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463370 */     // MIs[1] Operand 1
     /* 1463370 */     // No operand predicates
     /* 1463370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463374 */     // MIs[0] policy
     /* 1463374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463386 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1463389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463411 */     // GIR_Coverage, 7594,
     /* 1463411 */     GIR_EraseRootFromParent_Done,
     /* 1463412 */   // Label 20527: @1463412
     /* 1463412 */   GIM_Try, /*On fail goto*//*Label 20528*/ GIMT_Encode4(1463509), // Rule ID 7595 //
     /* 1463417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1463425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1463428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1463431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1463434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1463440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463467 */     // MIs[1] Operand 1
     /* 1463467 */     // No operand predicates
     /* 1463467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463471 */     // MIs[0] policy
     /* 1463471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463483 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1463486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463508 */     // GIR_Coverage, 7595,
     /* 1463508 */     GIR_EraseRootFromParent_Done,
     /* 1463509 */   // Label 20528: @1463509
     /* 1463509 */   GIM_Try, /*On fail goto*//*Label 20529*/ GIMT_Encode4(1463606), // Rule ID 7598 //
     /* 1463514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1463522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1463525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1463528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1463531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1463537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463564 */     // MIs[1] Operand 1
     /* 1463564 */     // No operand predicates
     /* 1463564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463568 */     // MIs[0] policy
     /* 1463568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463580 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1463583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463605 */     // GIR_Coverage, 7598,
     /* 1463605 */     GIR_EraseRootFromParent_Done,
     /* 1463606 */   // Label 20529: @1463606
     /* 1463606 */   GIM_Try, /*On fail goto*//*Label 20530*/ GIMT_Encode4(1463703), // Rule ID 7599 //
     /* 1463611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1463619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1463622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1463625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1463628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1463634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463661 */     // MIs[1] Operand 1
     /* 1463661 */     // No operand predicates
     /* 1463661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463665 */     // MIs[0] policy
     /* 1463665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463677 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1463680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463702 */     // GIR_Coverage, 7599,
     /* 1463702 */     GIR_EraseRootFromParent_Done,
     /* 1463703 */   // Label 20530: @1463703
     /* 1463703 */   GIM_Try, /*On fail goto*//*Label 20531*/ GIMT_Encode4(1463800), // Rule ID 7602 //
     /* 1463708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1463716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1463719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1463722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1463725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463758 */     // MIs[1] Operand 1
     /* 1463758 */     // No operand predicates
     /* 1463758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463762 */     // MIs[0] policy
     /* 1463762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463774 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1463777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463799 */     // GIR_Coverage, 7602,
     /* 1463799 */     GIR_EraseRootFromParent_Done,
     /* 1463800 */   // Label 20531: @1463800
     /* 1463800 */   GIM_Try, /*On fail goto*//*Label 20532*/ GIMT_Encode4(1463897), // Rule ID 7603 //
     /* 1463805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1463813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1463816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1463819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1463822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463855 */     // MIs[1] Operand 1
     /* 1463855 */     // No operand predicates
     /* 1463855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463859 */     // MIs[0] policy
     /* 1463859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463871 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1463874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463896 */     // GIR_Coverage, 7603,
     /* 1463896 */     GIR_EraseRootFromParent_Done,
     /* 1463897 */   // Label 20532: @1463897
     /* 1463897 */   GIM_Try, /*On fail goto*//*Label 20533*/ GIMT_Encode4(1463994), // Rule ID 7606 //
     /* 1463902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1463910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1463913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1463916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1463919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463952 */     // MIs[1] Operand 1
     /* 1463952 */     // No operand predicates
     /* 1463952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463956 */     // MIs[0] policy
     /* 1463956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463968 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1463971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463993 */     // GIR_Coverage, 7606,
     /* 1463993 */     GIR_EraseRootFromParent_Done,
     /* 1463994 */   // Label 20533: @1463994
     /* 1463994 */   GIM_Try, /*On fail goto*//*Label 20534*/ GIMT_Encode4(1464091), // Rule ID 7607 //
     /* 1463999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1464002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1464007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1464010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1464013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1464016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1464049 */     // MIs[1] Operand 1
     /* 1464049 */     // No operand predicates
     /* 1464049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464053 */     // MIs[0] policy
     /* 1464053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464065 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1464068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464090 */     // GIR_Coverage, 7607,
     /* 1464090 */     GIR_EraseRootFromParent_Done,
     /* 1464091 */   // Label 20534: @1464091
     /* 1464091 */   GIM_Try, /*On fail goto*//*Label 20535*/ GIMT_Encode4(1464188), // Rule ID 7610 //
     /* 1464096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1464099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1464104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1464107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1464110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1464113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1464126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464142 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1464146 */     // MIs[1] Operand 1
     /* 1464146 */     // No operand predicates
     /* 1464146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464150 */     // MIs[0] policy
     /* 1464150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1464165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464187 */     // GIR_Coverage, 7610,
     /* 1464187 */     GIR_EraseRootFromParent_Done,
     /* 1464188 */   // Label 20535: @1464188
     /* 1464188 */   GIM_Try, /*On fail goto*//*Label 20536*/ GIMT_Encode4(1464285), // Rule ID 7611 //
     /* 1464193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1464196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1464201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1464204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1464207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1464210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1464223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1464243 */     // MIs[1] Operand 1
     /* 1464243 */     // No operand predicates
     /* 1464243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464247 */     // MIs[0] policy
     /* 1464247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464259 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1464262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464284 */     // GIR_Coverage, 7611,
     /* 1464284 */     GIR_EraseRootFromParent_Done,
     /* 1464285 */   // Label 20536: @1464285
     /* 1464285 */   GIM_Try, /*On fail goto*//*Label 20537*/ GIMT_Encode4(1464382), // Rule ID 7614 //
     /* 1464290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1464293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1464298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1464301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1464304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1464307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1464313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1464320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1464340 */     // MIs[1] Operand 1
     /* 1464340 */     // No operand predicates
     /* 1464340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464344 */     // MIs[0] policy
     /* 1464344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464356 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1464359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464381 */     // GIR_Coverage, 7614,
     /* 1464381 */     GIR_EraseRootFromParent_Done,
     /* 1464382 */   // Label 20537: @1464382
     /* 1464382 */   GIM_Try, /*On fail goto*//*Label 20538*/ GIMT_Encode4(1464479), // Rule ID 7615 //
     /* 1464387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1464390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1464395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1464398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1464401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1464404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1464410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1464417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1464437 */     // MIs[1] Operand 1
     /* 1464437 */     // No operand predicates
     /* 1464437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464441 */     // MIs[0] policy
     /* 1464441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464453 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1464456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464478 */     // GIR_Coverage, 7615,
     /* 1464478 */     GIR_EraseRootFromParent_Done,
     /* 1464479 */   // Label 20538: @1464479
     /* 1464479 */   GIM_Try, /*On fail goto*//*Label 20539*/ GIMT_Encode4(1464576), // Rule ID 7738 //
     /* 1464484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1464492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1464495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1464498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1464501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1464534 */     // MIs[1] Operand 1
     /* 1464534 */     // No operand predicates
     /* 1464534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464538 */     // MIs[0] policy
     /* 1464538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464550 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1464553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464575 */     // GIR_Coverage, 7738,
     /* 1464575 */     GIR_EraseRootFromParent_Done,
     /* 1464576 */   // Label 20539: @1464576
     /* 1464576 */   GIM_Try, /*On fail goto*//*Label 20540*/ GIMT_Encode4(1464673), // Rule ID 7739 //
     /* 1464581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1464589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1464592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1464595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1464598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1464631 */     // MIs[1] Operand 1
     /* 1464631 */     // No operand predicates
     /* 1464631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464635 */     // MIs[0] policy
     /* 1464635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464647 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1464650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464672 */     // GIR_Coverage, 7739,
     /* 1464672 */     GIR_EraseRootFromParent_Done,
     /* 1464673 */   // Label 20540: @1464673
     /* 1464673 */   GIM_Try, /*On fail goto*//*Label 20541*/ GIMT_Encode4(1464770), // Rule ID 7742 //
     /* 1464678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1464686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1464689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1464692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1464695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1464728 */     // MIs[1] Operand 1
     /* 1464728 */     // No operand predicates
     /* 1464728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464732 */     // MIs[0] policy
     /* 1464732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464744 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1464747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464769 */     // GIR_Coverage, 7742,
     /* 1464769 */     GIR_EraseRootFromParent_Done,
     /* 1464770 */   // Label 20541: @1464770
     /* 1464770 */   GIM_Try, /*On fail goto*//*Label 20542*/ GIMT_Encode4(1464867), // Rule ID 7743 //
     /* 1464775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1464783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1464786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1464789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1464792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1464825 */     // MIs[1] Operand 1
     /* 1464825 */     // No operand predicates
     /* 1464825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464829 */     // MIs[0] policy
     /* 1464829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464841 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1464844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464866 */     // GIR_Coverage, 7743,
     /* 1464866 */     GIR_EraseRootFromParent_Done,
     /* 1464867 */   // Label 20542: @1464867
     /* 1464867 */   GIM_Try, /*On fail goto*//*Label 20543*/ GIMT_Encode4(1464964), // Rule ID 7746 //
     /* 1464872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1464880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1464883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1464886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1464889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1464922 */     // MIs[1] Operand 1
     /* 1464922 */     // No operand predicates
     /* 1464922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464926 */     // MIs[0] policy
     /* 1464926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464938 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1464941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464963 */     // GIR_Coverage, 7746,
     /* 1464963 */     GIR_EraseRootFromParent_Done,
     /* 1464964 */   // Label 20543: @1464964
     /* 1464964 */   GIM_Try, /*On fail goto*//*Label 20544*/ GIMT_Encode4(1465061), // Rule ID 7747 //
     /* 1464969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1464977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1464980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1464983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1464986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1465019 */     // MIs[1] Operand 1
     /* 1465019 */     // No operand predicates
     /* 1465019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465023 */     // MIs[0] policy
     /* 1465023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465035 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1465038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465060 */     // GIR_Coverage, 7747,
     /* 1465060 */     GIR_EraseRootFromParent_Done,
     /* 1465061 */   // Label 20544: @1465061
     /* 1465061 */   GIM_Try, /*On fail goto*//*Label 20545*/ GIMT_Encode4(1465158), // Rule ID 7750 //
     /* 1465066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1465074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1465077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1465080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1465083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1465089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1465116 */     // MIs[1] Operand 1
     /* 1465116 */     // No operand predicates
     /* 1465116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465120 */     // MIs[0] policy
     /* 1465120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465132 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1465135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465157 */     // GIR_Coverage, 7750,
     /* 1465157 */     GIR_EraseRootFromParent_Done,
     /* 1465158 */   // Label 20545: @1465158
     /* 1465158 */   GIM_Try, /*On fail goto*//*Label 20546*/ GIMT_Encode4(1465255), // Rule ID 7751 //
     /* 1465163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1465171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1465174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1465177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1465180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1465186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1465213 */     // MIs[1] Operand 1
     /* 1465213 */     // No operand predicates
     /* 1465213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465217 */     // MIs[0] policy
     /* 1465217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465229 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1465232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465254 */     // GIR_Coverage, 7751,
     /* 1465254 */     GIR_EraseRootFromParent_Done,
     /* 1465255 */   // Label 20546: @1465255
     /* 1465255 */   GIM_Try, /*On fail goto*//*Label 20547*/ GIMT_Encode4(1465352), // Rule ID 7754 //
     /* 1465260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1465268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1465271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1465274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1465277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1465283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1465310 */     // MIs[1] Operand 1
     /* 1465310 */     // No operand predicates
     /* 1465310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465314 */     // MIs[0] policy
     /* 1465314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1465329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465351 */     // GIR_Coverage, 7754,
     /* 1465351 */     GIR_EraseRootFromParent_Done,
     /* 1465352 */   // Label 20547: @1465352
     /* 1465352 */   GIM_Try, /*On fail goto*//*Label 20548*/ GIMT_Encode4(1465449), // Rule ID 7755 //
     /* 1465357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1465365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1465368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1465371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1465374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1465380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1465407 */     // MIs[1] Operand 1
     /* 1465407 */     // No operand predicates
     /* 1465407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465411 */     // MIs[0] policy
     /* 1465411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465423 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1465426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465448 */     // GIR_Coverage, 7755,
     /* 1465448 */     GIR_EraseRootFromParent_Done,
     /* 1465449 */   // Label 20548: @1465449
     /* 1465449 */   GIM_Try, /*On fail goto*//*Label 20549*/ GIMT_Encode4(1465546), // Rule ID 7758 //
     /* 1465454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1465462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1465465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1465468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1465471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1465477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1465504 */     // MIs[1] Operand 1
     /* 1465504 */     // No operand predicates
     /* 1465504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465508 */     // MIs[0] policy
     /* 1465508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465520 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1465523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465545 */     // GIR_Coverage, 7758,
     /* 1465545 */     GIR_EraseRootFromParent_Done,
     /* 1465546 */   // Label 20549: @1465546
     /* 1465546 */   GIM_Try, /*On fail goto*//*Label 20550*/ GIMT_Encode4(1465643), // Rule ID 7759 //
     /* 1465551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1465559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1465562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1465565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1465568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1465574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1465601 */     // MIs[1] Operand 1
     /* 1465601 */     // No operand predicates
     /* 1465601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465605 */     // MIs[0] policy
     /* 1465605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465617 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1465620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465642 */     // GIR_Coverage, 7759,
     /* 1465642 */     GIR_EraseRootFromParent_Done,
     /* 1465643 */   // Label 20550: @1465643
     /* 1465643 */   GIM_Try, /*On fail goto*//*Label 20551*/ GIMT_Encode4(1465740), // Rule ID 7762 //
     /* 1465648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1465656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1465659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1465662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1465665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1465698 */     // MIs[1] Operand 1
     /* 1465698 */     // No operand predicates
     /* 1465698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465702 */     // MIs[0] policy
     /* 1465702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465714 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1465717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465739 */     // GIR_Coverage, 7762,
     /* 1465739 */     GIR_EraseRootFromParent_Done,
     /* 1465740 */   // Label 20551: @1465740
     /* 1465740 */   GIM_Try, /*On fail goto*//*Label 20552*/ GIMT_Encode4(1465837), // Rule ID 7763 //
     /* 1465745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1465753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1465756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1465759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1465762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1465795 */     // MIs[1] Operand 1
     /* 1465795 */     // No operand predicates
     /* 1465795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465799 */     // MIs[0] policy
     /* 1465799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465811 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1465814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465836 */     // GIR_Coverage, 7763,
     /* 1465836 */     GIR_EraseRootFromParent_Done,
     /* 1465837 */   // Label 20552: @1465837
     /* 1465837 */   GIM_Try, /*On fail goto*//*Label 20553*/ GIMT_Encode4(1465934), // Rule ID 7766 //
     /* 1465842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1465850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1465853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1465856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1465859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1465892 */     // MIs[1] Operand 1
     /* 1465892 */     // No operand predicates
     /* 1465892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465896 */     // MIs[0] policy
     /* 1465896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465908 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1465911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465933 */     // GIR_Coverage, 7766,
     /* 1465933 */     GIR_EraseRootFromParent_Done,
     /* 1465934 */   // Label 20553: @1465934
     /* 1465934 */   GIM_Try, /*On fail goto*//*Label 20554*/ GIMT_Encode4(1466031), // Rule ID 7767 //
     /* 1465939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1465947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1465950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1465953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1465956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1465989 */     // MIs[1] Operand 1
     /* 1465989 */     // No operand predicates
     /* 1465989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465993 */     // MIs[0] policy
     /* 1465993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466005 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1466008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466030 */     // GIR_Coverage, 7767,
     /* 1466030 */     GIR_EraseRootFromParent_Done,
     /* 1466031 */   // Label 20554: @1466031
     /* 1466031 */   GIM_Try, /*On fail goto*//*Label 20555*/ GIMT_Encode4(1466128), // Rule ID 7770 //
     /* 1466036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1466044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1466047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1466050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1466053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1466059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466086 */     // MIs[1] Operand 1
     /* 1466086 */     // No operand predicates
     /* 1466086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466090 */     // MIs[0] policy
     /* 1466090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1466105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466127 */     // GIR_Coverage, 7770,
     /* 1466127 */     GIR_EraseRootFromParent_Done,
     /* 1466128 */   // Label 20555: @1466128
     /* 1466128 */   GIM_Try, /*On fail goto*//*Label 20556*/ GIMT_Encode4(1466225), // Rule ID 7771 //
     /* 1466133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1466141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1466144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1466147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1466150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1466156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466183 */     // MIs[1] Operand 1
     /* 1466183 */     // No operand predicates
     /* 1466183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466187 */     // MIs[0] policy
     /* 1466187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466199 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1466202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466224 */     // GIR_Coverage, 7771,
     /* 1466224 */     GIR_EraseRootFromParent_Done,
     /* 1466225 */   // Label 20556: @1466225
     /* 1466225 */   GIM_Try, /*On fail goto*//*Label 20557*/ GIMT_Encode4(1466322), // Rule ID 7774 //
     /* 1466230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1466238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1466241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1466244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1466247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466280 */     // MIs[1] Operand 1
     /* 1466280 */     // No operand predicates
     /* 1466280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466284 */     // MIs[0] policy
     /* 1466284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1466299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466321 */     // GIR_Coverage, 7774,
     /* 1466321 */     GIR_EraseRootFromParent_Done,
     /* 1466322 */   // Label 20557: @1466322
     /* 1466322 */   GIM_Try, /*On fail goto*//*Label 20558*/ GIMT_Encode4(1466419), // Rule ID 7775 //
     /* 1466327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1466335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1466338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1466341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1466344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466377 */     // MIs[1] Operand 1
     /* 1466377 */     // No operand predicates
     /* 1466377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466381 */     // MIs[0] policy
     /* 1466381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466393 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1466396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466418 */     // GIR_Coverage, 7775,
     /* 1466418 */     GIR_EraseRootFromParent_Done,
     /* 1466419 */   // Label 20558: @1466419
     /* 1466419 */   GIM_Try, /*On fail goto*//*Label 20559*/ GIMT_Encode4(1466516), // Rule ID 7778 //
     /* 1466424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1466432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1466435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1466438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1466441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466474 */     // MIs[1] Operand 1
     /* 1466474 */     // No operand predicates
     /* 1466474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466478 */     // MIs[0] policy
     /* 1466478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466490 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1466493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466515 */     // GIR_Coverage, 7778,
     /* 1466515 */     GIR_EraseRootFromParent_Done,
     /* 1466516 */   // Label 20559: @1466516
     /* 1466516 */   GIM_Try, /*On fail goto*//*Label 20560*/ GIMT_Encode4(1466613), // Rule ID 7779 //
     /* 1466521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1466529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1466532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1466535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1466538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466571 */     // MIs[1] Operand 1
     /* 1466571 */     // No operand predicates
     /* 1466571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466575 */     // MIs[0] policy
     /* 1466575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466587 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1466590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466612 */     // GIR_Coverage, 7779,
     /* 1466612 */     GIR_EraseRootFromParent_Done,
     /* 1466613 */   // Label 20560: @1466613
     /* 1466613 */   GIM_Try, /*On fail goto*//*Label 20561*/ GIMT_Encode4(1466710), // Rule ID 7782 //
     /* 1466618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1466621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1466626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1466629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1466632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1466635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1466641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466668 */     // MIs[1] Operand 1
     /* 1466668 */     // No operand predicates
     /* 1466668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466672 */     // MIs[0] policy
     /* 1466672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1466687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1466706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466709 */     // GIR_Coverage, 7782,
     /* 1466709 */     GIR_EraseRootFromParent_Done,
     /* 1466710 */   // Label 20561: @1466710
     /* 1466710 */   GIM_Try, /*On fail goto*//*Label 20562*/ GIMT_Encode4(1466807), // Rule ID 7783 //
     /* 1466715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1466718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1466723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1466726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1466729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1466732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1466738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466765 */     // MIs[1] Operand 1
     /* 1466765 */     // No operand predicates
     /* 1466765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466769 */     // MIs[0] policy
     /* 1466769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466781 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1466784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1466803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466806 */     // GIR_Coverage, 7783,
     /* 1466806 */     GIR_EraseRootFromParent_Done,
     /* 1466807 */   // Label 20562: @1466807
     /* 1466807 */   GIM_Try, /*On fail goto*//*Label 20563*/ GIMT_Encode4(1466904), // Rule ID 7786 //
     /* 1466812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1466815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1466820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1466823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1466826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1466829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1466835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466862 */     // MIs[1] Operand 1
     /* 1466862 */     // No operand predicates
     /* 1466862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466866 */     // MIs[0] policy
     /* 1466866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466878 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1466881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1466900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466903 */     // GIR_Coverage, 7786,
     /* 1466903 */     GIR_EraseRootFromParent_Done,
     /* 1466904 */   // Label 20563: @1466904
     /* 1466904 */   GIM_Try, /*On fail goto*//*Label 20564*/ GIMT_Encode4(1467001), // Rule ID 7787 //
     /* 1466909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1466912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1466917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1466920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1466923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1466926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1466932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466959 */     // MIs[1] Operand 1
     /* 1466959 */     // No operand predicates
     /* 1466959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466963 */     // MIs[0] policy
     /* 1466963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466975 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1466978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1466997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467000 */     // GIR_Coverage, 7787,
     /* 1467000 */     GIR_EraseRootFromParent_Done,
     /* 1467001 */   // Label 20564: @1467001
     /* 1467001 */   GIM_Try, /*On fail goto*//*Label 20565*/ GIMT_Encode4(1467098), // Rule ID 7790 //
     /* 1467006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1467009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1467014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1467017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1467020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1467023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467056 */     // MIs[1] Operand 1
     /* 1467056 */     // No operand predicates
     /* 1467056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467060 */     // MIs[0] policy
     /* 1467060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467072 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1467075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467097 */     // GIR_Coverage, 7790,
     /* 1467097 */     GIR_EraseRootFromParent_Done,
     /* 1467098 */   // Label 20565: @1467098
     /* 1467098 */   GIM_Try, /*On fail goto*//*Label 20566*/ GIMT_Encode4(1467195), // Rule ID 7791 //
     /* 1467103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1467106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1467111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1467114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1467117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1467120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467153 */     // MIs[1] Operand 1
     /* 1467153 */     // No operand predicates
     /* 1467153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467157 */     // MIs[0] policy
     /* 1467157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1467172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467194 */     // GIR_Coverage, 7791,
     /* 1467194 */     GIR_EraseRootFromParent_Done,
     /* 1467195 */   // Label 20566: @1467195
     /* 1467195 */   GIM_Try, /*On fail goto*//*Label 20567*/ GIMT_Encode4(1467292), // Rule ID 7794 //
     /* 1467200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1467203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1467208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1467211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1467214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1467217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467250 */     // MIs[1] Operand 1
     /* 1467250 */     // No operand predicates
     /* 1467250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467254 */     // MIs[0] policy
     /* 1467254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467266 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1467269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467291 */     // GIR_Coverage, 7794,
     /* 1467291 */     GIR_EraseRootFromParent_Done,
     /* 1467292 */   // Label 20567: @1467292
     /* 1467292 */   GIM_Try, /*On fail goto*//*Label 20568*/ GIMT_Encode4(1467389), // Rule ID 7795 //
     /* 1467297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1467300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1467305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1467308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1467311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1467314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467347 */     // MIs[1] Operand 1
     /* 1467347 */     // No operand predicates
     /* 1467347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467351 */     // MIs[0] policy
     /* 1467351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467363 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1467366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467388 */     // GIR_Coverage, 7795,
     /* 1467388 */     GIR_EraseRootFromParent_Done,
     /* 1467389 */   // Label 20568: @1467389
     /* 1467389 */   GIM_Try, /*On fail goto*//*Label 20569*/ GIMT_Encode4(1467489), // Rule ID 14224 //
     /* 1467394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1467405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1467408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1467411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1467417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467444 */     // MIs[1] Operand 1
     /* 1467444 */     // No operand predicates
     /* 1467444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467448 */     // MIs[0] policy
     /* 1467448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467460 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1467463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467488 */     // GIR_Coverage, 14224,
     /* 1467488 */     GIR_EraseRootFromParent_Done,
     /* 1467489 */   // Label 20569: @1467489
     /* 1467489 */   GIM_Try, /*On fail goto*//*Label 20570*/ GIMT_Encode4(1467589), // Rule ID 14225 //
     /* 1467494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1467505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1467508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1467511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1467517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467544 */     // MIs[1] Operand 1
     /* 1467544 */     // No operand predicates
     /* 1467544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467548 */     // MIs[0] policy
     /* 1467548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467560 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1467563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467588 */     // GIR_Coverage, 14225,
     /* 1467588 */     GIR_EraseRootFromParent_Done,
     /* 1467589 */   // Label 20570: @1467589
     /* 1467589 */   GIM_Try, /*On fail goto*//*Label 20571*/ GIMT_Encode4(1467689), // Rule ID 14228 //
     /* 1467594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1467605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1467608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1467611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467644 */     // MIs[1] Operand 1
     /* 1467644 */     // No operand predicates
     /* 1467644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467648 */     // MIs[0] policy
     /* 1467648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467660 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1467663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467688 */     // GIR_Coverage, 14228,
     /* 1467688 */     GIR_EraseRootFromParent_Done,
     /* 1467689 */   // Label 20571: @1467689
     /* 1467689 */   GIM_Try, /*On fail goto*//*Label 20572*/ GIMT_Encode4(1467789), // Rule ID 14229 //
     /* 1467694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1467705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1467708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1467711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467744 */     // MIs[1] Operand 1
     /* 1467744 */     // No operand predicates
     /* 1467744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467748 */     // MIs[0] policy
     /* 1467748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467760 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1467763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467788 */     // GIR_Coverage, 14229,
     /* 1467788 */     GIR_EraseRootFromParent_Done,
     /* 1467789 */   // Label 20572: @1467789
     /* 1467789 */   GIM_Try, /*On fail goto*//*Label 20573*/ GIMT_Encode4(1467889), // Rule ID 14232 //
     /* 1467794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1467805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1467808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1467811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467844 */     // MIs[1] Operand 1
     /* 1467844 */     // No operand predicates
     /* 1467844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467848 */     // MIs[0] policy
     /* 1467848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467860 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1467863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467888 */     // GIR_Coverage, 14232,
     /* 1467888 */     GIR_EraseRootFromParent_Done,
     /* 1467889 */   // Label 20573: @1467889
     /* 1467889 */   GIM_Try, /*On fail goto*//*Label 20574*/ GIMT_Encode4(1467989), // Rule ID 14233 //
     /* 1467894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1467905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1467908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1467911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467944 */     // MIs[1] Operand 1
     /* 1467944 */     // No operand predicates
     /* 1467944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467948 */     // MIs[0] policy
     /* 1467948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467960 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1467963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467988 */     // GIR_Coverage, 14233,
     /* 1467988 */     GIR_EraseRootFromParent_Done,
     /* 1467989 */   // Label 20574: @1467989
     /* 1467989 */   GIM_Try, /*On fail goto*//*Label 20575*/ GIMT_Encode4(1468089), // Rule ID 14236 //
     /* 1467994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1468005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1468008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1468011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468044 */     // MIs[1] Operand 1
     /* 1468044 */     // No operand predicates
     /* 1468044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468048 */     // MIs[0] policy
     /* 1468048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468060 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1468063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468088 */     // GIR_Coverage, 14236,
     /* 1468088 */     GIR_EraseRootFromParent_Done,
     /* 1468089 */   // Label 20575: @1468089
     /* 1468089 */   GIM_Try, /*On fail goto*//*Label 20576*/ GIMT_Encode4(1468189), // Rule ID 14237 //
     /* 1468094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1468105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1468108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1468111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468144 */     // MIs[1] Operand 1
     /* 1468144 */     // No operand predicates
     /* 1468144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468148 */     // MIs[0] policy
     /* 1468148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468160 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1468163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468188 */     // GIR_Coverage, 14237,
     /* 1468188 */     GIR_EraseRootFromParent_Done,
     /* 1468189 */   // Label 20576: @1468189
     /* 1468189 */   GIM_Try, /*On fail goto*//*Label 20577*/ GIMT_Encode4(1468289), // Rule ID 14240 //
     /* 1468194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1468205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1468208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1468211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468244 */     // MIs[1] Operand 1
     /* 1468244 */     // No operand predicates
     /* 1468244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468248 */     // MIs[0] policy
     /* 1468248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468260 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1468263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468288 */     // GIR_Coverage, 14240,
     /* 1468288 */     GIR_EraseRootFromParent_Done,
     /* 1468289 */   // Label 20577: @1468289
     /* 1468289 */   GIM_Try, /*On fail goto*//*Label 20578*/ GIMT_Encode4(1468389), // Rule ID 14241 //
     /* 1468294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1468305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1468308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1468311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468344 */     // MIs[1] Operand 1
     /* 1468344 */     // No operand predicates
     /* 1468344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468348 */     // MIs[0] policy
     /* 1468348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468360 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1468363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468388 */     // GIR_Coverage, 14241,
     /* 1468388 */     GIR_EraseRootFromParent_Done,
     /* 1468389 */   // Label 20578: @1468389
     /* 1468389 */   GIM_Try, /*On fail goto*//*Label 20579*/ GIMT_Encode4(1468489), // Rule ID 14244 //
     /* 1468394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1468405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1468408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1468411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468444 */     // MIs[1] Operand 1
     /* 1468444 */     // No operand predicates
     /* 1468444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468448 */     // MIs[0] policy
     /* 1468448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468460 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1468463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1468482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468488 */     // GIR_Coverage, 14244,
     /* 1468488 */     GIR_EraseRootFromParent_Done,
     /* 1468489 */   // Label 20579: @1468489
     /* 1468489 */   GIM_Try, /*On fail goto*//*Label 20580*/ GIMT_Encode4(1468589), // Rule ID 14245 //
     /* 1468494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1468505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1468508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1468511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468544 */     // MIs[1] Operand 1
     /* 1468544 */     // No operand predicates
     /* 1468544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468548 */     // MIs[0] policy
     /* 1468548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468560 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1468563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1468582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468588 */     // GIR_Coverage, 14245,
     /* 1468588 */     GIR_EraseRootFromParent_Done,
     /* 1468589 */   // Label 20580: @1468589
     /* 1468589 */   GIM_Try, /*On fail goto*//*Label 20581*/ GIMT_Encode4(1468689), // Rule ID 14248 //
     /* 1468594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1468605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1468608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1468611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1468617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468644 */     // MIs[1] Operand 1
     /* 1468644 */     // No operand predicates
     /* 1468644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468648 */     // MIs[0] policy
     /* 1468648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468660 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1468663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468688 */     // GIR_Coverage, 14248,
     /* 1468688 */     GIR_EraseRootFromParent_Done,
     /* 1468689 */   // Label 20581: @1468689
     /* 1468689 */   GIM_Try, /*On fail goto*//*Label 20582*/ GIMT_Encode4(1468789), // Rule ID 14249 //
     /* 1468694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1468705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1468708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1468711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1468717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468744 */     // MIs[1] Operand 1
     /* 1468744 */     // No operand predicates
     /* 1468744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468748 */     // MIs[0] policy
     /* 1468748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468760 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1468763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468788 */     // GIR_Coverage, 14249,
     /* 1468788 */     GIR_EraseRootFromParent_Done,
     /* 1468789 */   // Label 20582: @1468789
     /* 1468789 */   GIM_Try, /*On fail goto*//*Label 20583*/ GIMT_Encode4(1468889), // Rule ID 14252 //
     /* 1468794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1468805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1468808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1468811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468844 */     // MIs[1] Operand 1
     /* 1468844 */     // No operand predicates
     /* 1468844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468848 */     // MIs[0] policy
     /* 1468848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1468863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468888 */     // GIR_Coverage, 14252,
     /* 1468888 */     GIR_EraseRootFromParent_Done,
     /* 1468889 */   // Label 20583: @1468889
     /* 1468889 */   GIM_Try, /*On fail goto*//*Label 20584*/ GIMT_Encode4(1468989), // Rule ID 14253 //
     /* 1468894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1468905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1468908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1468911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468944 */     // MIs[1] Operand 1
     /* 1468944 */     // No operand predicates
     /* 1468944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468948 */     // MIs[0] policy
     /* 1468948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1468963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468988 */     // GIR_Coverage, 14253,
     /* 1468988 */     GIR_EraseRootFromParent_Done,
     /* 1468989 */   // Label 20584: @1468989
     /* 1468989 */   GIM_Try, /*On fail goto*//*Label 20585*/ GIMT_Encode4(1469089), // Rule ID 14256 //
     /* 1468994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1469002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1469005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1469008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1469011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469044 */     // MIs[1] Operand 1
     /* 1469044 */     // No operand predicates
     /* 1469044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469048 */     // MIs[0] policy
     /* 1469048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469060 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1469063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469088 */     // GIR_Coverage, 14256,
     /* 1469088 */     GIR_EraseRootFromParent_Done,
     /* 1469089 */   // Label 20585: @1469089
     /* 1469089 */   GIM_Try, /*On fail goto*//*Label 20586*/ GIMT_Encode4(1469189), // Rule ID 14257 //
     /* 1469094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1469102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1469105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1469108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1469111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469144 */     // MIs[1] Operand 1
     /* 1469144 */     // No operand predicates
     /* 1469144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469148 */     // MIs[0] policy
     /* 1469148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469160 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1469163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469188 */     // GIR_Coverage, 14257,
     /* 1469188 */     GIR_EraseRootFromParent_Done,
     /* 1469189 */   // Label 20586: @1469189
     /* 1469189 */   GIM_Try, /*On fail goto*//*Label 20587*/ GIMT_Encode4(1469289), // Rule ID 14260 //
     /* 1469194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1469197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1469202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1469205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1469208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1469211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469244 */     // MIs[1] Operand 1
     /* 1469244 */     // No operand predicates
     /* 1469244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469248 */     // MIs[0] policy
     /* 1469248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469260 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1469263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469288 */     // GIR_Coverage, 14260,
     /* 1469288 */     GIR_EraseRootFromParent_Done,
     /* 1469289 */   // Label 20587: @1469289
     /* 1469289 */   GIM_Try, /*On fail goto*//*Label 20588*/ GIMT_Encode4(1469389), // Rule ID 14261 //
     /* 1469294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1469297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1469302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1469305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1469308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1469311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469344 */     // MIs[1] Operand 1
     /* 1469344 */     // No operand predicates
     /* 1469344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469348 */     // MIs[0] policy
     /* 1469348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469360 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1469363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469388 */     // GIR_Coverage, 14261,
     /* 1469388 */     GIR_EraseRootFromParent_Done,
     /* 1469389 */   // Label 20588: @1469389
     /* 1469389 */   GIM_Try, /*On fail goto*//*Label 20589*/ GIMT_Encode4(1469489), // Rule ID 14264 //
     /* 1469394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1469402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1469405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1469408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1469411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1469417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1469424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469444 */     // MIs[1] Operand 1
     /* 1469444 */     // No operand predicates
     /* 1469444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469448 */     // MIs[0] policy
     /* 1469448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469460 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1469463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469488 */     // GIR_Coverage, 14264,
     /* 1469488 */     GIR_EraseRootFromParent_Done,
     /* 1469489 */   // Label 20589: @1469489
     /* 1469489 */   GIM_Try, /*On fail goto*//*Label 20590*/ GIMT_Encode4(1469589), // Rule ID 14265 //
     /* 1469494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1469502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1469505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1469508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1469511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1469517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1469524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469544 */     // MIs[1] Operand 1
     /* 1469544 */     // No operand predicates
     /* 1469544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469548 */     // MIs[0] policy
     /* 1469548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469560 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1469563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469588 */     // GIR_Coverage, 14265,
     /* 1469588 */     GIR_EraseRootFromParent_Done,
     /* 1469589 */   // Label 20590: @1469589
     /* 1469589 */   GIM_Try, /*On fail goto*//*Label 20591*/ GIMT_Encode4(1469689), // Rule ID 14268 //
     /* 1469594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1469602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1469605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1469608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1469611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1469617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1469624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469644 */     // MIs[1] Operand 1
     /* 1469644 */     // No operand predicates
     /* 1469644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469648 */     // MIs[0] policy
     /* 1469648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469660 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1469663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469688 */     // GIR_Coverage, 14268,
     /* 1469688 */     GIR_EraseRootFromParent_Done,
     /* 1469689 */   // Label 20591: @1469689
     /* 1469689 */   GIM_Try, /*On fail goto*//*Label 20592*/ GIMT_Encode4(1469789), // Rule ID 14269 //
     /* 1469694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1469702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1469705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1469708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1469711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1469717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1469724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469744 */     // MIs[1] Operand 1
     /* 1469744 */     // No operand predicates
     /* 1469744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469748 */     // MIs[0] policy
     /* 1469748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469760 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1469763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469788 */     // GIR_Coverage, 14269,
     /* 1469788 */     GIR_EraseRootFromParent_Done,
     /* 1469789 */   // Label 20592: @1469789
     /* 1469789 */   GIM_Try, /*On fail goto*//*Label 20593*/ GIMT_Encode4(1469889), // Rule ID 14272 //
     /* 1469794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1469802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1469805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1469808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1469811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1469817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1469824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469844 */     // MIs[1] Operand 1
     /* 1469844 */     // No operand predicates
     /* 1469844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469848 */     // MIs[0] policy
     /* 1469848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469860 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1469863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469888 */     // GIR_Coverage, 14272,
     /* 1469888 */     GIR_EraseRootFromParent_Done,
     /* 1469889 */   // Label 20593: @1469889
     /* 1469889 */   GIM_Try, /*On fail goto*//*Label 20594*/ GIMT_Encode4(1469989), // Rule ID 14273 //
     /* 1469894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1469902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1469905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1469908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1469911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1469917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1469924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469944 */     // MIs[1] Operand 1
     /* 1469944 */     // No operand predicates
     /* 1469944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469948 */     // MIs[0] policy
     /* 1469948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469960 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1469963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469988 */     // GIR_Coverage, 14273,
     /* 1469988 */     GIR_EraseRootFromParent_Done,
     /* 1469989 */   // Label 20594: @1469989
     /* 1469989 */   GIM_Try, /*On fail goto*//*Label 20595*/ GIMT_Encode4(1470089), // Rule ID 14276 //
     /* 1469994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1470002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1470005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1470008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1470011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1470017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470044 */     // MIs[1] Operand 1
     /* 1470044 */     // No operand predicates
     /* 1470044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470048 */     // MIs[0] policy
     /* 1470048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1470063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470088 */     // GIR_Coverage, 14276,
     /* 1470088 */     GIR_EraseRootFromParent_Done,
     /* 1470089 */   // Label 20595: @1470089
     /* 1470089 */   GIM_Try, /*On fail goto*//*Label 20596*/ GIMT_Encode4(1470189), // Rule ID 14277 //
     /* 1470094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1470102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1470105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1470108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1470111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1470117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470144 */     // MIs[1] Operand 1
     /* 1470144 */     // No operand predicates
     /* 1470144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470148 */     // MIs[0] policy
     /* 1470148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1470163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470188 */     // GIR_Coverage, 14277,
     /* 1470188 */     GIR_EraseRootFromParent_Done,
     /* 1470189 */   // Label 20596: @1470189
     /* 1470189 */   GIM_Try, /*On fail goto*//*Label 20597*/ GIMT_Encode4(1470289), // Rule ID 14280 //
     /* 1470194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1470202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1470205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1470208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1470211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1470217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470244 */     // MIs[1] Operand 1
     /* 1470244 */     // No operand predicates
     /* 1470244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470248 */     // MIs[0] policy
     /* 1470248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470260 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1470263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470288 */     // GIR_Coverage, 14280,
     /* 1470288 */     GIR_EraseRootFromParent_Done,
     /* 1470289 */   // Label 20597: @1470289
     /* 1470289 */   GIM_Try, /*On fail goto*//*Label 20598*/ GIMT_Encode4(1470389), // Rule ID 14281 //
     /* 1470294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1470302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1470305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1470308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1470311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1470317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470344 */     // MIs[1] Operand 1
     /* 1470344 */     // No operand predicates
     /* 1470344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470348 */     // MIs[0] policy
     /* 1470348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470360 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1470363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470388 */     // GIR_Coverage, 14281,
     /* 1470388 */     GIR_EraseRootFromParent_Done,
     /* 1470389 */   // Label 20598: @1470389
     /* 1470389 */   GIM_Try, /*On fail goto*//*Label 20599*/ GIMT_Encode4(1470489), // Rule ID 14284 //
     /* 1470394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1470402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1470405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1470408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1470411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1470417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1470424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470444 */     // MIs[1] Operand 1
     /* 1470444 */     // No operand predicates
     /* 1470444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470448 */     // MIs[0] policy
     /* 1470448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470460 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1470463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470488 */     // GIR_Coverage, 14284,
     /* 1470488 */     GIR_EraseRootFromParent_Done,
     /* 1470489 */   // Label 20599: @1470489
     /* 1470489 */   GIM_Try, /*On fail goto*//*Label 20600*/ GIMT_Encode4(1470589), // Rule ID 14285 //
     /* 1470494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1470502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1470505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1470508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1470511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1470517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1470524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470544 */     // MIs[1] Operand 1
     /* 1470544 */     // No operand predicates
     /* 1470544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470548 */     // MIs[0] policy
     /* 1470548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470560 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1470563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470588 */     // GIR_Coverage, 14285,
     /* 1470588 */     GIR_EraseRootFromParent_Done,
     /* 1470589 */   // Label 20600: @1470589
     /* 1470589 */   GIM_Try, /*On fail goto*//*Label 20601*/ GIMT_Encode4(1470689), // Rule ID 14288 //
     /* 1470594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1470602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1470605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1470608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1470611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1470617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470644 */     // MIs[1] Operand 1
     /* 1470644 */     // No operand predicates
     /* 1470644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470648 */     // MIs[0] policy
     /* 1470648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470660 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1470663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1470682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470688 */     // GIR_Coverage, 14288,
     /* 1470688 */     GIR_EraseRootFromParent_Done,
     /* 1470689 */   // Label 20601: @1470689
     /* 1470689 */   GIM_Try, /*On fail goto*//*Label 20602*/ GIMT_Encode4(1470789), // Rule ID 14289 //
     /* 1470694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1470702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1470705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1470708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1470711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1470717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470744 */     // MIs[1] Operand 1
     /* 1470744 */     // No operand predicates
     /* 1470744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470748 */     // MIs[0] policy
     /* 1470748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1470763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1470782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470788 */     // GIR_Coverage, 14289,
     /* 1470788 */     GIR_EraseRootFromParent_Done,
     /* 1470789 */   // Label 20602: @1470789
     /* 1470789 */   GIM_Try, /*On fail goto*//*Label 20603*/ GIMT_Encode4(1470889), // Rule ID 14292 //
     /* 1470794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1470802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1470805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1470808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1470811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1470817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470844 */     // MIs[1] Operand 1
     /* 1470844 */     // No operand predicates
     /* 1470844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470848 */     // MIs[0] policy
     /* 1470848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470860 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1470863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1470882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470888 */     // GIR_Coverage, 14292,
     /* 1470888 */     GIR_EraseRootFromParent_Done,
     /* 1470889 */   // Label 20603: @1470889
     /* 1470889 */   GIM_Try, /*On fail goto*//*Label 20604*/ GIMT_Encode4(1470989), // Rule ID 14293 //
     /* 1470894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1470902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1470905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1470908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1470911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1470917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470944 */     // MIs[1] Operand 1
     /* 1470944 */     // No operand predicates
     /* 1470944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470948 */     // MIs[0] policy
     /* 1470948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470960 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1470963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1470982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470988 */     // GIR_Coverage, 14293,
     /* 1470988 */     GIR_EraseRootFromParent_Done,
     /* 1470989 */   // Label 20604: @1470989
     /* 1470989 */   GIM_Try, /*On fail goto*//*Label 20605*/ GIMT_Encode4(1471089), // Rule ID 14296 //
     /* 1470994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1471002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1471005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1471008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1471011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1471017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471044 */     // MIs[1] Operand 1
     /* 1471044 */     // No operand predicates
     /* 1471044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471048 */     // MIs[0] policy
     /* 1471048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471060 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1471063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471088 */     // GIR_Coverage, 14296,
     /* 1471088 */     GIR_EraseRootFromParent_Done,
     /* 1471089 */   // Label 20605: @1471089
     /* 1471089 */   GIM_Try, /*On fail goto*//*Label 20606*/ GIMT_Encode4(1471189), // Rule ID 14297 //
     /* 1471094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1471102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1471105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1471108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1471111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1471117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471144 */     // MIs[1] Operand 1
     /* 1471144 */     // No operand predicates
     /* 1471144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471148 */     // MIs[0] policy
     /* 1471148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471160 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1471163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471188 */     // GIR_Coverage, 14297,
     /* 1471188 */     GIR_EraseRootFromParent_Done,
     /* 1471189 */   // Label 20606: @1471189
     /* 1471189 */   GIM_Try, /*On fail goto*//*Label 20607*/ GIMT_Encode4(1471289), // Rule ID 14300 //
     /* 1471194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1471197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1471202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1471205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1471208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1471211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1471217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471244 */     // MIs[1] Operand 1
     /* 1471244 */     // No operand predicates
     /* 1471244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471248 */     // MIs[0] policy
     /* 1471248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471260 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1471263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1471282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471288 */     // GIR_Coverage, 14300,
     /* 1471288 */     GIR_EraseRootFromParent_Done,
     /* 1471289 */   // Label 20607: @1471289
     /* 1471289 */   GIM_Try, /*On fail goto*//*Label 20608*/ GIMT_Encode4(1471389), // Rule ID 14301 //
     /* 1471294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1471297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1471302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1471305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1471308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1471311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1471317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471344 */     // MIs[1] Operand 1
     /* 1471344 */     // No operand predicates
     /* 1471344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471348 */     // MIs[0] policy
     /* 1471348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471360 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1471363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1471382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471388 */     // GIR_Coverage, 14301,
     /* 1471388 */     GIR_EraseRootFromParent_Done,
     /* 1471389 */   // Label 20608: @1471389
     /* 1471389 */   GIM_Try, /*On fail goto*//*Label 20609*/ GIMT_Encode4(1471489), // Rule ID 14304 //
     /* 1471394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1471397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1471402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1471405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1471408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1471411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471444 */     // MIs[1] Operand 1
     /* 1471444 */     // No operand predicates
     /* 1471444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471448 */     // MIs[0] policy
     /* 1471448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471460 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1471463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1471482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471488 */     // GIR_Coverage, 14304,
     /* 1471488 */     GIR_EraseRootFromParent_Done,
     /* 1471489 */   // Label 20609: @1471489
     /* 1471489 */   GIM_Try, /*On fail goto*//*Label 20610*/ GIMT_Encode4(1471589), // Rule ID 14305 //
     /* 1471494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1471497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1471502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1471505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1471508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1471511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471544 */     // MIs[1] Operand 1
     /* 1471544 */     // No operand predicates
     /* 1471544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471548 */     // MIs[0] policy
     /* 1471548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471560 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1471563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1471582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471588 */     // GIR_Coverage, 14305,
     /* 1471588 */     GIR_EraseRootFromParent_Done,
     /* 1471589 */   // Label 20610: @1471589
     /* 1471589 */   GIM_Try, /*On fail goto*//*Label 20611*/ GIMT_Encode4(1471689), // Rule ID 14308 //
     /* 1471594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1471597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1471602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1471605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1471608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1471611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471644 */     // MIs[1] Operand 1
     /* 1471644 */     // No operand predicates
     /* 1471644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471648 */     // MIs[0] policy
     /* 1471648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471660 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1471663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1471682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471688 */     // GIR_Coverage, 14308,
     /* 1471688 */     GIR_EraseRootFromParent_Done,
     /* 1471689 */   // Label 20611: @1471689
     /* 1471689 */   GIM_Try, /*On fail goto*//*Label 20612*/ GIMT_Encode4(1471789), // Rule ID 14309 //
     /* 1471694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1471697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1471702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1471705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1471708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1471711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471744 */     // MIs[1] Operand 1
     /* 1471744 */     // No operand predicates
     /* 1471744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471748 */     // MIs[0] policy
     /* 1471748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471760 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1471763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1471782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471788 */     // GIR_Coverage, 14309,
     /* 1471788 */     GIR_EraseRootFromParent_Done,
     /* 1471789 */   // Label 20612: @1471789
     /* 1471789 */   GIM_Try, /*On fail goto*//*Label 20613*/ GIMT_Encode4(1471889), // Rule ID 14488 //
     /* 1471794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1471805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1471808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1471811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1471817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471844 */     // MIs[1] Operand 1
     /* 1471844 */     // No operand predicates
     /* 1471844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471848 */     // MIs[0] policy
     /* 1471848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471860 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1471863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1471882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471888 */     // GIR_Coverage, 14488,
     /* 1471888 */     GIR_EraseRootFromParent_Done,
     /* 1471889 */   // Label 20613: @1471889
     /* 1471889 */   GIM_Try, /*On fail goto*//*Label 20614*/ GIMT_Encode4(1471989), // Rule ID 14489 //
     /* 1471894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1471905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1471908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1471911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1471917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471944 */     // MIs[1] Operand 1
     /* 1471944 */     // No operand predicates
     /* 1471944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471948 */     // MIs[0] policy
     /* 1471948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471960 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1471963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1471982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471988 */     // GIR_Coverage, 14489,
     /* 1471988 */     GIR_EraseRootFromParent_Done,
     /* 1471989 */   // Label 20614: @1471989
     /* 1471989 */   GIM_Try, /*On fail goto*//*Label 20615*/ GIMT_Encode4(1472089), // Rule ID 14492 //
     /* 1471994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1472005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1472008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1472011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1472017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472044 */     // MIs[1] Operand 1
     /* 1472044 */     // No operand predicates
     /* 1472044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472048 */     // MIs[0] policy
     /* 1472048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472060 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1472063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472088 */     // GIR_Coverage, 14492,
     /* 1472088 */     GIR_EraseRootFromParent_Done,
     /* 1472089 */   // Label 20615: @1472089
     /* 1472089 */   GIM_Try, /*On fail goto*//*Label 20616*/ GIMT_Encode4(1472189), // Rule ID 14493 //
     /* 1472094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1472105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1472108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1472111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1472117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472144 */     // MIs[1] Operand 1
     /* 1472144 */     // No operand predicates
     /* 1472144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472148 */     // MIs[0] policy
     /* 1472148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472160 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1472163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472188 */     // GIR_Coverage, 14493,
     /* 1472188 */     GIR_EraseRootFromParent_Done,
     /* 1472189 */   // Label 20616: @1472189
     /* 1472189 */   GIM_Try, /*On fail goto*//*Label 20617*/ GIMT_Encode4(1472289), // Rule ID 14496 //
     /* 1472194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1472205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1472208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1472211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1472217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472244 */     // MIs[1] Operand 1
     /* 1472244 */     // No operand predicates
     /* 1472244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472248 */     // MIs[0] policy
     /* 1472248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472260 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1472263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472288 */     // GIR_Coverage, 14496,
     /* 1472288 */     GIR_EraseRootFromParent_Done,
     /* 1472289 */   // Label 20617: @1472289
     /* 1472289 */   GIM_Try, /*On fail goto*//*Label 20618*/ GIMT_Encode4(1472389), // Rule ID 14497 //
     /* 1472294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1472305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1472308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1472311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1472317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472344 */     // MIs[1] Operand 1
     /* 1472344 */     // No operand predicates
     /* 1472344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472348 */     // MIs[0] policy
     /* 1472348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472360 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1472363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472388 */     // GIR_Coverage, 14497,
     /* 1472388 */     GIR_EraseRootFromParent_Done,
     /* 1472389 */   // Label 20618: @1472389
     /* 1472389 */   GIM_Try, /*On fail goto*//*Label 20619*/ GIMT_Encode4(1472489), // Rule ID 14500 //
     /* 1472394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1472405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1472408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1472411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472444 */     // MIs[1] Operand 1
     /* 1472444 */     // No operand predicates
     /* 1472444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472448 */     // MIs[0] policy
     /* 1472448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472460 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1472463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1472482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472488 */     // GIR_Coverage, 14500,
     /* 1472488 */     GIR_EraseRootFromParent_Done,
     /* 1472489 */   // Label 20619: @1472489
     /* 1472489 */   GIM_Try, /*On fail goto*//*Label 20620*/ GIMT_Encode4(1472589), // Rule ID 14501 //
     /* 1472494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1472505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1472508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1472511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472544 */     // MIs[1] Operand 1
     /* 1472544 */     // No operand predicates
     /* 1472544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472548 */     // MIs[0] policy
     /* 1472548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472560 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1472563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1472582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472588 */     // GIR_Coverage, 14501,
     /* 1472588 */     GIR_EraseRootFromParent_Done,
     /* 1472589 */   // Label 20620: @1472589
     /* 1472589 */   GIM_Try, /*On fail goto*//*Label 20621*/ GIMT_Encode4(1472689), // Rule ID 14504 //
     /* 1472594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1472605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1472608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1472611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1472617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472644 */     // MIs[1] Operand 1
     /* 1472644 */     // No operand predicates
     /* 1472644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472648 */     // MIs[0] policy
     /* 1472648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472660 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1472663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1472682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472688 */     // GIR_Coverage, 14504,
     /* 1472688 */     GIR_EraseRootFromParent_Done,
     /* 1472689 */   // Label 20621: @1472689
     /* 1472689 */   GIM_Try, /*On fail goto*//*Label 20622*/ GIMT_Encode4(1472789), // Rule ID 14505 //
     /* 1472694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1472705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1472708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1472711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1472717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472744 */     // MIs[1] Operand 1
     /* 1472744 */     // No operand predicates
     /* 1472744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472748 */     // MIs[0] policy
     /* 1472748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472760 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1472763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1472782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472788 */     // GIR_Coverage, 14505,
     /* 1472788 */     GIR_EraseRootFromParent_Done,
     /* 1472789 */   // Label 20622: @1472789
     /* 1472789 */   GIM_Try, /*On fail goto*//*Label 20623*/ GIMT_Encode4(1472889), // Rule ID 14508 //
     /* 1472794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1472805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1472808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1472811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472844 */     // MIs[1] Operand 1
     /* 1472844 */     // No operand predicates
     /* 1472844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472848 */     // MIs[0] policy
     /* 1472848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472860 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1472863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1472882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472888 */     // GIR_Coverage, 14508,
     /* 1472888 */     GIR_EraseRootFromParent_Done,
     /* 1472889 */   // Label 20623: @1472889
     /* 1472889 */   GIM_Try, /*On fail goto*//*Label 20624*/ GIMT_Encode4(1472989), // Rule ID 14509 //
     /* 1472894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1472905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1472908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1472911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472944 */     // MIs[1] Operand 1
     /* 1472944 */     // No operand predicates
     /* 1472944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472948 */     // MIs[0] policy
     /* 1472948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472960 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1472963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1472982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472988 */     // GIR_Coverage, 14509,
     /* 1472988 */     GIR_EraseRootFromParent_Done,
     /* 1472989 */   // Label 20624: @1472989
     /* 1472989 */   GIM_Try, /*On fail goto*//*Label 20625*/ GIMT_Encode4(1473089), // Rule ID 14512 //
     /* 1472994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1473002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1473005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1473008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1473011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1473017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1473044 */     // MIs[1] Operand 1
     /* 1473044 */     // No operand predicates
     /* 1473044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473048 */     // MIs[0] policy
     /* 1473048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473060 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1473063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1473087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473088 */     // GIR_Coverage, 14512,
     /* 1473088 */     GIR_EraseRootFromParent_Done,
     /* 1473089 */   // Label 20625: @1473089
     /* 1473089 */   GIM_Try, /*On fail goto*//*Label 20626*/ GIMT_Encode4(1473189), // Rule ID 14513 //
     /* 1473094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1473102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1473105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1473108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1473111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1473117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1473144 */     // MIs[1] Operand 1
     /* 1473144 */     // No operand predicates
     /* 1473144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473148 */     // MIs[0] policy
     /* 1473148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473160 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1473163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1473187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473188 */     // GIR_Coverage, 14513,
     /* 1473188 */     GIR_EraseRootFromParent_Done,
     /* 1473189 */   // Label 20626: @1473189
     /* 1473189 */   GIM_Try, /*On fail goto*//*Label 20627*/ GIMT_Encode4(1473289), // Rule ID 14516 //
     /* 1473194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1473202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1473205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1473208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1473211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1473244 */     // MIs[1] Operand 1
     /* 1473244 */     // No operand predicates
     /* 1473244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473248 */     // MIs[0] policy
     /* 1473248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473260 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1473263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1473287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473288 */     // GIR_Coverage, 14516,
     /* 1473288 */     GIR_EraseRootFromParent_Done,
     /* 1473289 */   // Label 20627: @1473289
     /* 1473289 */   GIM_Try, /*On fail goto*//*Label 20628*/ GIMT_Encode4(1473389), // Rule ID 14517 //
     /* 1473294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1473302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1473305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1473308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1473311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1473344 */     // MIs[1] Operand 1
     /* 1473344 */     // No operand predicates
     /* 1473344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473348 */     // MIs[0] policy
     /* 1473348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473360 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1473363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1473387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473388 */     // GIR_Coverage, 14517,
     /* 1473388 */     GIR_EraseRootFromParent_Done,
     /* 1473389 */   // Label 20628: @1473389
     /* 1473389 */   GIM_Try, /*On fail goto*//*Label 20629*/ GIMT_Encode4(1473489), // Rule ID 14520 //
     /* 1473394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1473402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1473405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1473408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1473411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1473444 */     // MIs[1] Operand 1
     /* 1473444 */     // No operand predicates
     /* 1473444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473448 */     // MIs[0] policy
     /* 1473448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473460 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1473463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1473487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473488 */     // GIR_Coverage, 14520,
     /* 1473488 */     GIR_EraseRootFromParent_Done,
     /* 1473489 */   // Label 20629: @1473489
     /* 1473489 */   GIM_Try, /*On fail goto*//*Label 20630*/ GIMT_Encode4(1473589), // Rule ID 14521 //
     /* 1473494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1473502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1473505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1473508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1473511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1473544 */     // MIs[1] Operand 1
     /* 1473544 */     // No operand predicates
     /* 1473544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473548 */     // MIs[0] policy
     /* 1473548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473560 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1473563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1473587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473588 */     // GIR_Coverage, 14521,
     /* 1473588 */     GIR_EraseRootFromParent_Done,
     /* 1473589 */   // Label 20630: @1473589
     /* 1473589 */   GIM_Try, /*On fail goto*//*Label 20631*/ GIMT_Encode4(1473689), // Rule ID 14524 //
     /* 1473594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1473597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1473602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1473605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1473608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1473611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1473644 */     // MIs[1] Operand 1
     /* 1473644 */     // No operand predicates
     /* 1473644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473648 */     // MIs[0] policy
     /* 1473648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473660 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1473663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1473682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1473687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473688 */     // GIR_Coverage, 14524,
     /* 1473688 */     GIR_EraseRootFromParent_Done,
     /* 1473689 */   // Label 20631: @1473689
     /* 1473689 */   GIM_Try, /*On fail goto*//*Label 20632*/ GIMT_Encode4(1473789), // Rule ID 14525 //
     /* 1473694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1473697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1473702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1473705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1473708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1473711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1473744 */     // MIs[1] Operand 1
     /* 1473744 */     // No operand predicates
     /* 1473744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473748 */     // MIs[0] policy
     /* 1473748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1473763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1473782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1473787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473788 */     // GIR_Coverage, 14525,
     /* 1473788 */     GIR_EraseRootFromParent_Done,
     /* 1473789 */   // Label 20632: @1473789
     /* 1473789 */   GIM_Try, /*On fail goto*//*Label 20633*/ GIMT_Encode4(1473889), // Rule ID 14528 //
     /* 1473794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1473802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1473805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1473808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1473811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1473817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1473824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1473844 */     // MIs[1] Operand 1
     /* 1473844 */     // No operand predicates
     /* 1473844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473848 */     // MIs[0] policy
     /* 1473848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473860 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1473863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1473887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473888 */     // GIR_Coverage, 14528,
     /* 1473888 */     GIR_EraseRootFromParent_Done,
     /* 1473889 */   // Label 20633: @1473889
     /* 1473889 */   GIM_Try, /*On fail goto*//*Label 20634*/ GIMT_Encode4(1473989), // Rule ID 14529 //
     /* 1473894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1473902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1473905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1473908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1473911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1473917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1473924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1473944 */     // MIs[1] Operand 1
     /* 1473944 */     // No operand predicates
     /* 1473944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473948 */     // MIs[0] policy
     /* 1473948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1473963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1473967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1473987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473988 */     // GIR_Coverage, 14529,
     /* 1473988 */     GIR_EraseRootFromParent_Done,
     /* 1473989 */   // Label 20634: @1473989
     /* 1473989 */   GIM_Try, /*On fail goto*//*Label 20635*/ GIMT_Encode4(1474089), // Rule ID 14532 //
     /* 1473994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1474002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1474005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1474008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1474011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1474017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1474044 */     // MIs[1] Operand 1
     /* 1474044 */     // No operand predicates
     /* 1474044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474048 */     // MIs[0] policy
     /* 1474048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474060 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1474063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1474087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474088 */     // GIR_Coverage, 14532,
     /* 1474088 */     GIR_EraseRootFromParent_Done,
     /* 1474089 */   // Label 20635: @1474089
     /* 1474089 */   GIM_Try, /*On fail goto*//*Label 20636*/ GIMT_Encode4(1474189), // Rule ID 14533 //
     /* 1474094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1474102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1474105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1474108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1474111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1474117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1474144 */     // MIs[1] Operand 1
     /* 1474144 */     // No operand predicates
     /* 1474144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474148 */     // MIs[0] policy
     /* 1474148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474160 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1474163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1474187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474188 */     // GIR_Coverage, 14533,
     /* 1474188 */     GIR_EraseRootFromParent_Done,
     /* 1474189 */   // Label 20636: @1474189
     /* 1474189 */   GIM_Try, /*On fail goto*//*Label 20637*/ GIMT_Encode4(1474289), // Rule ID 14536 //
     /* 1474194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1474202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1474205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1474208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1474211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1474217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1474224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1474244 */     // MIs[1] Operand 1
     /* 1474244 */     // No operand predicates
     /* 1474244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474248 */     // MIs[0] policy
     /* 1474248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474260 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1474263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1474287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474288 */     // GIR_Coverage, 14536,
     /* 1474288 */     GIR_EraseRootFromParent_Done,
     /* 1474289 */   // Label 20637: @1474289
     /* 1474289 */   GIM_Try, /*On fail goto*//*Label 20638*/ GIMT_Encode4(1474389), // Rule ID 14537 //
     /* 1474294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1474302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1474305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1474308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1474311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1474317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1474324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1474344 */     // MIs[1] Operand 1
     /* 1474344 */     // No operand predicates
     /* 1474344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474348 */     // MIs[0] policy
     /* 1474348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474360 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1474363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1474387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474388 */     // GIR_Coverage, 14537,
     /* 1474388 */     GIR_EraseRootFromParent_Done,
     /* 1474389 */   // Label 20638: @1474389
     /* 1474389 */   GIM_Try, /*On fail goto*//*Label 20639*/ GIMT_Encode4(1474489), // Rule ID 14540 //
     /* 1474394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1474402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1474405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1474408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1474411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1474417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1474444 */     // MIs[1] Operand 1
     /* 1474444 */     // No operand predicates
     /* 1474444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474448 */     // MIs[0] policy
     /* 1474448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1474463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1474487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474488 */     // GIR_Coverage, 14540,
     /* 1474488 */     GIR_EraseRootFromParent_Done,
     /* 1474489 */   // Label 20639: @1474489
     /* 1474489 */   GIM_Try, /*On fail goto*//*Label 20640*/ GIMT_Encode4(1474589), // Rule ID 14541 //
     /* 1474494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1474502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1474505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1474508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1474511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1474517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1474544 */     // MIs[1] Operand 1
     /* 1474544 */     // No operand predicates
     /* 1474544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474548 */     // MIs[0] policy
     /* 1474548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474560 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1474563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1474587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474588 */     // GIR_Coverage, 14541,
     /* 1474588 */     GIR_EraseRootFromParent_Done,
     /* 1474589 */   // Label 20640: @1474589
     /* 1474589 */   GIM_Try, /*On fail goto*//*Label 20641*/ GIMT_Encode4(1474689), // Rule ID 14544 //
     /* 1474594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1474602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1474605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1474608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1474611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1474617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1474644 */     // MIs[1] Operand 1
     /* 1474644 */     // No operand predicates
     /* 1474644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474648 */     // MIs[0] policy
     /* 1474648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474660 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1474663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1474687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474688 */     // GIR_Coverage, 14544,
     /* 1474688 */     GIR_EraseRootFromParent_Done,
     /* 1474689 */   // Label 20641: @1474689
     /* 1474689 */   GIM_Try, /*On fail goto*//*Label 20642*/ GIMT_Encode4(1474789), // Rule ID 14545 //
     /* 1474694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1474702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1474705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1474708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1474711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1474717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1474744 */     // MIs[1] Operand 1
     /* 1474744 */     // No operand predicates
     /* 1474744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474748 */     // MIs[0] policy
     /* 1474748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474760 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1474763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1474787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474788 */     // GIR_Coverage, 14545,
     /* 1474788 */     GIR_EraseRootFromParent_Done,
     /* 1474789 */   // Label 20642: @1474789
     /* 1474789 */   GIM_Try, /*On fail goto*//*Label 20643*/ GIMT_Encode4(1474889), // Rule ID 14548 //
     /* 1474794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1474802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1474805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1474808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1474811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1474817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1474824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1474844 */     // MIs[1] Operand 1
     /* 1474844 */     // No operand predicates
     /* 1474844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474848 */     // MIs[0] policy
     /* 1474848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474860 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1474863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1474887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474888 */     // GIR_Coverage, 14548,
     /* 1474888 */     GIR_EraseRootFromParent_Done,
     /* 1474889 */   // Label 20643: @1474889
     /* 1474889 */   GIM_Try, /*On fail goto*//*Label 20644*/ GIMT_Encode4(1474989), // Rule ID 14549 //
     /* 1474894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1474902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1474905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1474908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1474911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1474917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1474924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1474944 */     // MIs[1] Operand 1
     /* 1474944 */     // No operand predicates
     /* 1474944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474948 */     // MIs[0] policy
     /* 1474948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474960 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1474963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1474967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1474987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474988 */     // GIR_Coverage, 14549,
     /* 1474988 */     GIR_EraseRootFromParent_Done,
     /* 1474989 */   // Label 20644: @1474989
     /* 1474989 */   GIM_Try, /*On fail goto*//*Label 20645*/ GIMT_Encode4(1475089), // Rule ID 14552 //
     /* 1474994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1475002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1475005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1475008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1475011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1475017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1475044 */     // MIs[1] Operand 1
     /* 1475044 */     // No operand predicates
     /* 1475044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475048 */     // MIs[0] policy
     /* 1475048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475060 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1475063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1475087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475088 */     // GIR_Coverage, 14552,
     /* 1475088 */     GIR_EraseRootFromParent_Done,
     /* 1475089 */   // Label 20645: @1475089
     /* 1475089 */   GIM_Try, /*On fail goto*//*Label 20646*/ GIMT_Encode4(1475189), // Rule ID 14553 //
     /* 1475094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1475102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1475105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1475108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1475111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1475117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1475144 */     // MIs[1] Operand 1
     /* 1475144 */     // No operand predicates
     /* 1475144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475148 */     // MIs[0] policy
     /* 1475148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1475163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1475187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475188 */     // GIR_Coverage, 14553,
     /* 1475188 */     GIR_EraseRootFromParent_Done,
     /* 1475189 */   // Label 20646: @1475189
     /* 1475189 */   GIM_Try, /*On fail goto*//*Label 20647*/ GIMT_Encode4(1475289), // Rule ID 14556 //
     /* 1475194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1475202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1475205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1475208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1475211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1475244 */     // MIs[1] Operand 1
     /* 1475244 */     // No operand predicates
     /* 1475244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475248 */     // MIs[0] policy
     /* 1475248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475260 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1475263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1475287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475288 */     // GIR_Coverage, 14556,
     /* 1475288 */     GIR_EraseRootFromParent_Done,
     /* 1475289 */   // Label 20647: @1475289
     /* 1475289 */   GIM_Try, /*On fail goto*//*Label 20648*/ GIMT_Encode4(1475389), // Rule ID 14557 //
     /* 1475294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1475302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1475305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1475308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1475311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1475344 */     // MIs[1] Operand 1
     /* 1475344 */     // No operand predicates
     /* 1475344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475348 */     // MIs[0] policy
     /* 1475348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475360 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1475363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1475387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475388 */     // GIR_Coverage, 14557,
     /* 1475388 */     GIR_EraseRootFromParent_Done,
     /* 1475389 */   // Label 20648: @1475389
     /* 1475389 */   GIM_Try, /*On fail goto*//*Label 20649*/ GIMT_Encode4(1475489), // Rule ID 14560 //
     /* 1475394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1475402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1475405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1475408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1475411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1475444 */     // MIs[1] Operand 1
     /* 1475444 */     // No operand predicates
     /* 1475444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475448 */     // MIs[0] policy
     /* 1475448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475460 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1475463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1475487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475488 */     // GIR_Coverage, 14560,
     /* 1475488 */     GIR_EraseRootFromParent_Done,
     /* 1475489 */   // Label 20649: @1475489
     /* 1475489 */   GIM_Try, /*On fail goto*//*Label 20650*/ GIMT_Encode4(1475589), // Rule ID 14561 //
     /* 1475494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1475502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1475505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1475508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1475511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1475544 */     // MIs[1] Operand 1
     /* 1475544 */     // No operand predicates
     /* 1475544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475548 */     // MIs[0] policy
     /* 1475548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475560 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1475563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1475587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475588 */     // GIR_Coverage, 14561,
     /* 1475588 */     GIR_EraseRootFromParent_Done,
     /* 1475589 */   // Label 20650: @1475589
     /* 1475589 */   GIM_Try, /*On fail goto*//*Label 20651*/ GIMT_Encode4(1475689), // Rule ID 14564 //
     /* 1475594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1475597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1475602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1475605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1475608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1475611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1475617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1475644 */     // MIs[1] Operand 1
     /* 1475644 */     // No operand predicates
     /* 1475644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475648 */     // MIs[0] policy
     /* 1475648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1475663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1475682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1475687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475688 */     // GIR_Coverage, 14564,
     /* 1475688 */     GIR_EraseRootFromParent_Done,
     /* 1475689 */   // Label 20651: @1475689
     /* 1475689 */   GIM_Try, /*On fail goto*//*Label 20652*/ GIMT_Encode4(1475789), // Rule ID 14565 //
     /* 1475694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1475697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1475702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1475705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1475708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1475711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1475717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1475744 */     // MIs[1] Operand 1
     /* 1475744 */     // No operand predicates
     /* 1475744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475748 */     // MIs[0] policy
     /* 1475748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1475763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1475782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1475787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475788 */     // GIR_Coverage, 14565,
     /* 1475788 */     GIR_EraseRootFromParent_Done,
     /* 1475789 */   // Label 20652: @1475789
     /* 1475789 */   GIM_Try, /*On fail goto*//*Label 20653*/ GIMT_Encode4(1475889), // Rule ID 14568 //
     /* 1475794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1475797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1475802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1475805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1475808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1475811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1475817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1475844 */     // MIs[1] Operand 1
     /* 1475844 */     // No operand predicates
     /* 1475844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475848 */     // MIs[0] policy
     /* 1475848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475860 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1475863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1475882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1475887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475888 */     // GIR_Coverage, 14568,
     /* 1475888 */     GIR_EraseRootFromParent_Done,
     /* 1475889 */   // Label 20653: @1475889
     /* 1475889 */   GIM_Try, /*On fail goto*//*Label 20654*/ GIMT_Encode4(1475989), // Rule ID 14569 //
     /* 1475894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1475897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1475902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1475905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1475908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1475911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1475917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1475944 */     // MIs[1] Operand 1
     /* 1475944 */     // No operand predicates
     /* 1475944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475948 */     // MIs[0] policy
     /* 1475948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475960 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1475963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1475967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1475982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1475987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475988 */     // GIR_Coverage, 14569,
     /* 1475988 */     GIR_EraseRootFromParent_Done,
     /* 1475989 */   // Label 20654: @1475989
     /* 1475989 */   GIM_Try, /*On fail goto*//*Label 20655*/ GIMT_Encode4(1476089), // Rule ID 14572 //
     /* 1475994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1475997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1476002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1476005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1476008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1476011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1476044 */     // MIs[1] Operand 1
     /* 1476044 */     // No operand predicates
     /* 1476044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476048 */     // MIs[0] policy
     /* 1476048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476060 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1476063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1476087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476088 */     // GIR_Coverage, 14572,
     /* 1476088 */     GIR_EraseRootFromParent_Done,
     /* 1476089 */   // Label 20655: @1476089
     /* 1476089 */   GIM_Try, /*On fail goto*//*Label 20656*/ GIMT_Encode4(1476189), // Rule ID 14573 //
     /* 1476094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1476102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1476105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1476108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1476111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1476144 */     // MIs[1] Operand 1
     /* 1476144 */     // No operand predicates
     /* 1476144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476148 */     // MIs[0] policy
     /* 1476148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476160 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1476163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1476167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1476187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476188 */     // GIR_Coverage, 14573,
     /* 1476188 */     GIR_EraseRootFromParent_Done,
     /* 1476189 */   // Label 20656: @1476189
     /* 1476189 */   GIM_Try, /*On fail goto*//*Label 20657*/ GIMT_Encode4(1476286), // Rule ID 23692 //
     /* 1476194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1476205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1476208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1476211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1476217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476244 */     // MIs[1] Operand 1
     /* 1476244 */     // No operand predicates
     /* 1476244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476248 */     // MIs[0] policy
     /* 1476248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476260 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1476263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476285 */     // GIR_Coverage, 23692,
     /* 1476285 */     GIR_EraseRootFromParent_Done,
     /* 1476286 */   // Label 20657: @1476286
     /* 1476286 */   GIM_Try, /*On fail goto*//*Label 20658*/ GIMT_Encode4(1476383), // Rule ID 23693 //
     /* 1476291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1476302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1476305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1476308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1476314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476341 */     // MIs[1] Operand 1
     /* 1476341 */     // No operand predicates
     /* 1476341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476345 */     // MIs[0] policy
     /* 1476345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476357 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1476360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476382 */     // GIR_Coverage, 23693,
     /* 1476382 */     GIR_EraseRootFromParent_Done,
     /* 1476383 */   // Label 20658: @1476383
     /* 1476383 */   GIM_Try, /*On fail goto*//*Label 20659*/ GIMT_Encode4(1476480), // Rule ID 23696 //
     /* 1476388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1476399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1476402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1476405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476438 */     // MIs[1] Operand 1
     /* 1476438 */     // No operand predicates
     /* 1476438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476442 */     // MIs[0] policy
     /* 1476442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476454 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1476457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476479 */     // GIR_Coverage, 23696,
     /* 1476479 */     GIR_EraseRootFromParent_Done,
     /* 1476480 */   // Label 20659: @1476480
     /* 1476480 */   GIM_Try, /*On fail goto*//*Label 20660*/ GIMT_Encode4(1476577), // Rule ID 23697 //
     /* 1476485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1476496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1476499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1476502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476535 */     // MIs[1] Operand 1
     /* 1476535 */     // No operand predicates
     /* 1476535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476539 */     // MIs[0] policy
     /* 1476539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476551 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1476554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476576 */     // GIR_Coverage, 23697,
     /* 1476576 */     GIR_EraseRootFromParent_Done,
     /* 1476577 */   // Label 20660: @1476577
     /* 1476577 */   GIM_Try, /*On fail goto*//*Label 20661*/ GIMT_Encode4(1476674), // Rule ID 23700 //
     /* 1476582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1476593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1476596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1476599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476632 */     // MIs[1] Operand 1
     /* 1476632 */     // No operand predicates
     /* 1476632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476636 */     // MIs[0] policy
     /* 1476636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476648 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1476651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476673 */     // GIR_Coverage, 23700,
     /* 1476673 */     GIR_EraseRootFromParent_Done,
     /* 1476674 */   // Label 20661: @1476674
     /* 1476674 */   GIM_Try, /*On fail goto*//*Label 20662*/ GIMT_Encode4(1476771), // Rule ID 23701 //
     /* 1476679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1476690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1476693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1476696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476729 */     // MIs[1] Operand 1
     /* 1476729 */     // No operand predicates
     /* 1476729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476733 */     // MIs[0] policy
     /* 1476733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476745 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1476748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476770 */     // GIR_Coverage, 23701,
     /* 1476770 */     GIR_EraseRootFromParent_Done,
     /* 1476771 */   // Label 20662: @1476771
     /* 1476771 */   GIM_Try, /*On fail goto*//*Label 20663*/ GIMT_Encode4(1476868), // Rule ID 23704 //
     /* 1476776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1476787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1476790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1476793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1476799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476826 */     // MIs[1] Operand 1
     /* 1476826 */     // No operand predicates
     /* 1476826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476830 */     // MIs[0] policy
     /* 1476830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476842 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1476845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1476864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476867 */     // GIR_Coverage, 23704,
     /* 1476867 */     GIR_EraseRootFromParent_Done,
     /* 1476868 */   // Label 20663: @1476868
     /* 1476868 */   GIM_Try, /*On fail goto*//*Label 20664*/ GIMT_Encode4(1476965), // Rule ID 23705 //
     /* 1476873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1476884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1476887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1476890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1476896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476923 */     // MIs[1] Operand 1
     /* 1476923 */     // No operand predicates
     /* 1476923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476927 */     // MIs[0] policy
     /* 1476927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476939 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1476942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1476961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476964 */     // GIR_Coverage, 23705,
     /* 1476964 */     GIR_EraseRootFromParent_Done,
     /* 1476965 */   // Label 20664: @1476965
     /* 1476965 */   GIM_Try, /*On fail goto*//*Label 20665*/ GIMT_Encode4(1477062), // Rule ID 23708 //
     /* 1476970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1476981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1476984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1476987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477020 */     // MIs[1] Operand 1
     /* 1477020 */     // No operand predicates
     /* 1477020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477024 */     // MIs[0] policy
     /* 1477024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477036 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1477039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477061 */     // GIR_Coverage, 23708,
     /* 1477061 */     GIR_EraseRootFromParent_Done,
     /* 1477062 */   // Label 20665: @1477062
     /* 1477062 */   GIM_Try, /*On fail goto*//*Label 20666*/ GIMT_Encode4(1477159), // Rule ID 23709 //
     /* 1477067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1477075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1477078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1477081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1477084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477117 */     // MIs[1] Operand 1
     /* 1477117 */     // No operand predicates
     /* 1477117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477121 */     // MIs[0] policy
     /* 1477121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477133 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1477136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477158 */     // GIR_Coverage, 23709,
     /* 1477158 */     GIR_EraseRootFromParent_Done,
     /* 1477159 */   // Label 20666: @1477159
     /* 1477159 */   GIM_Try, /*On fail goto*//*Label 20667*/ GIMT_Encode4(1477256), // Rule ID 23712 //
     /* 1477164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1477172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1477175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1477178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1477181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477214 */     // MIs[1] Operand 1
     /* 1477214 */     // No operand predicates
     /* 1477214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477218 */     // MIs[0] policy
     /* 1477218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477230 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1477233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477255 */     // GIR_Coverage, 23712,
     /* 1477255 */     GIR_EraseRootFromParent_Done,
     /* 1477256 */   // Label 20667: @1477256
     /* 1477256 */   GIM_Try, /*On fail goto*//*Label 20668*/ GIMT_Encode4(1477353), // Rule ID 23713 //
     /* 1477261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1477269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1477272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1477275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1477278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477311 */     // MIs[1] Operand 1
     /* 1477311 */     // No operand predicates
     /* 1477311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477315 */     // MIs[0] policy
     /* 1477315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477327 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1477330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477352 */     // GIR_Coverage, 23713,
     /* 1477352 */     GIR_EraseRootFromParent_Done,
     /* 1477353 */   // Label 20668: @1477353
     /* 1477353 */   GIM_Try, /*On fail goto*//*Label 20669*/ GIMT_Encode4(1477450), // Rule ID 23716 //
     /* 1477358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1477366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1477369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1477372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1477375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1477381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477408 */     // MIs[1] Operand 1
     /* 1477408 */     // No operand predicates
     /* 1477408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477412 */     // MIs[0] policy
     /* 1477412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1477427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477449 */     // GIR_Coverage, 23716,
     /* 1477449 */     GIR_EraseRootFromParent_Done,
     /* 1477450 */   // Label 20669: @1477450
     /* 1477450 */   GIM_Try, /*On fail goto*//*Label 20670*/ GIMT_Encode4(1477547), // Rule ID 23717 //
     /* 1477455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1477463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1477466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1477469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1477472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1477478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477505 */     // MIs[1] Operand 1
     /* 1477505 */     // No operand predicates
     /* 1477505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477509 */     // MIs[0] policy
     /* 1477509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477521 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1477524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477546 */     // GIR_Coverage, 23717,
     /* 1477546 */     GIR_EraseRootFromParent_Done,
     /* 1477547 */   // Label 20670: @1477547
     /* 1477547 */   GIM_Try, /*On fail goto*//*Label 20671*/ GIMT_Encode4(1477644), // Rule ID 23720 //
     /* 1477552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1477560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1477563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1477566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1477569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477602 */     // MIs[1] Operand 1
     /* 1477602 */     // No operand predicates
     /* 1477602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477606 */     // MIs[0] policy
     /* 1477606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477618 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1477621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477643 */     // GIR_Coverage, 23720,
     /* 1477643 */     GIR_EraseRootFromParent_Done,
     /* 1477644 */   // Label 20671: @1477644
     /* 1477644 */   GIM_Try, /*On fail goto*//*Label 20672*/ GIMT_Encode4(1477741), // Rule ID 23721 //
     /* 1477649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1477657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1477660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1477663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1477666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477699 */     // MIs[1] Operand 1
     /* 1477699 */     // No operand predicates
     /* 1477699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477703 */     // MIs[0] policy
     /* 1477703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477715 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1477718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477740 */     // GIR_Coverage, 23721,
     /* 1477740 */     GIR_EraseRootFromParent_Done,
     /* 1477741 */   // Label 20672: @1477741
     /* 1477741 */   GIM_Try, /*On fail goto*//*Label 20673*/ GIMT_Encode4(1477838), // Rule ID 23724 //
     /* 1477746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1477754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1477757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1477760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1477763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477796 */     // MIs[1] Operand 1
     /* 1477796 */     // No operand predicates
     /* 1477796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477800 */     // MIs[0] policy
     /* 1477800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477812 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1477815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477837 */     // GIR_Coverage, 23724,
     /* 1477837 */     GIR_EraseRootFromParent_Done,
     /* 1477838 */   // Label 20673: @1477838
     /* 1477838 */   GIM_Try, /*On fail goto*//*Label 20674*/ GIMT_Encode4(1477935), // Rule ID 23725 //
     /* 1477843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1477851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1477854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1477857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1477860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477893 */     // MIs[1] Operand 1
     /* 1477893 */     // No operand predicates
     /* 1477893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477897 */     // MIs[0] policy
     /* 1477897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477909 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1477912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477934 */     // GIR_Coverage, 23725,
     /* 1477934 */     GIR_EraseRootFromParent_Done,
     /* 1477935 */   // Label 20674: @1477935
     /* 1477935 */   GIM_Try, /*On fail goto*//*Label 20675*/ GIMT_Encode4(1478032), // Rule ID 23728 //
     /* 1477940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1477943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1477948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1477951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1477954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1477957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477990 */     // MIs[1] Operand 1
     /* 1477990 */     // No operand predicates
     /* 1477990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477994 */     // MIs[0] policy
     /* 1477994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478006 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1478009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478031 */     // GIR_Coverage, 23728,
     /* 1478031 */     GIR_EraseRootFromParent_Done,
     /* 1478032 */   // Label 20675: @1478032
     /* 1478032 */   GIM_Try, /*On fail goto*//*Label 20676*/ GIMT_Encode4(1478129), // Rule ID 23729 //
     /* 1478037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1478040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1478048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1478051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1478054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478087 */     // MIs[1] Operand 1
     /* 1478087 */     // No operand predicates
     /* 1478087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478091 */     // MIs[0] policy
     /* 1478091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478103 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1478106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478128 */     // GIR_Coverage, 23729,
     /* 1478128 */     GIR_EraseRootFromParent_Done,
     /* 1478129 */   // Label 20676: @1478129
     /* 1478129 */   GIM_Try, /*On fail goto*//*Label 20677*/ GIMT_Encode4(1478226), // Rule ID 23732 //
     /* 1478134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1478145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1478148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1478151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1478157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478184 */     // MIs[1] Operand 1
     /* 1478184 */     // No operand predicates
     /* 1478184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478188 */     // MIs[0] policy
     /* 1478188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1478203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478225 */     // GIR_Coverage, 23732,
     /* 1478225 */     GIR_EraseRootFromParent_Done,
     /* 1478226 */   // Label 20677: @1478226
     /* 1478226 */   GIM_Try, /*On fail goto*//*Label 20678*/ GIMT_Encode4(1478323), // Rule ID 23733 //
     /* 1478231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1478242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1478245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1478248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1478254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478281 */     // MIs[1] Operand 1
     /* 1478281 */     // No operand predicates
     /* 1478281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478285 */     // MIs[0] policy
     /* 1478285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478297 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1478300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478322 */     // GIR_Coverage, 23733,
     /* 1478322 */     GIR_EraseRootFromParent_Done,
     /* 1478323 */   // Label 20678: @1478323
     /* 1478323 */   GIM_Try, /*On fail goto*//*Label 20679*/ GIMT_Encode4(1478420), // Rule ID 23736 //
     /* 1478328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1478339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1478342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1478345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1478351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1478358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478378 */     // MIs[1] Operand 1
     /* 1478378 */     // No operand predicates
     /* 1478378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478382 */     // MIs[0] policy
     /* 1478382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478394 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1478397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478419 */     // GIR_Coverage, 23736,
     /* 1478419 */     GIR_EraseRootFromParent_Done,
     /* 1478420 */   // Label 20679: @1478420
     /* 1478420 */   GIM_Try, /*On fail goto*//*Label 20680*/ GIMT_Encode4(1478517), // Rule ID 23737 //
     /* 1478425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1478436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1478439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1478442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1478448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1478455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478475 */     // MIs[1] Operand 1
     /* 1478475 */     // No operand predicates
     /* 1478475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478479 */     // MIs[0] policy
     /* 1478479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478491 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1478494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478516 */     // GIR_Coverage, 23737,
     /* 1478516 */     GIR_EraseRootFromParent_Done,
     /* 1478517 */   // Label 20680: @1478517
     /* 1478517 */   GIM_Try, /*On fail goto*//*Label 20681*/ GIMT_Encode4(1478614), // Rule ID 23740 //
     /* 1478522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1478533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1478536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1478539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1478545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1478552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478572 */     // MIs[1] Operand 1
     /* 1478572 */     // No operand predicates
     /* 1478572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478576 */     // MIs[0] policy
     /* 1478576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478588 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1478591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478613 */     // GIR_Coverage, 23740,
     /* 1478613 */     GIR_EraseRootFromParent_Done,
     /* 1478614 */   // Label 20681: @1478614
     /* 1478614 */   GIM_Try, /*On fail goto*//*Label 20682*/ GIMT_Encode4(1478711), // Rule ID 23741 //
     /* 1478619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1478630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1478633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1478636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1478642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1478649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478669 */     // MIs[1] Operand 1
     /* 1478669 */     // No operand predicates
     /* 1478669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478673 */     // MIs[0] policy
     /* 1478673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478685 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1478688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478710 */     // GIR_Coverage, 23741,
     /* 1478710 */     GIR_EraseRootFromParent_Done,
     /* 1478711 */   // Label 20682: @1478711
     /* 1478711 */   GIM_Try, /*On fail goto*//*Label 20683*/ GIMT_Encode4(1478808), // Rule ID 23744 //
     /* 1478716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1478727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1478730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1478733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1478739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478766 */     // MIs[1] Operand 1
     /* 1478766 */     // No operand predicates
     /* 1478766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478770 */     // MIs[0] policy
     /* 1478770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1478785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478807 */     // GIR_Coverage, 23744,
     /* 1478807 */     GIR_EraseRootFromParent_Done,
     /* 1478808 */   // Label 20683: @1478808
     /* 1478808 */   GIM_Try, /*On fail goto*//*Label 20684*/ GIMT_Encode4(1478905), // Rule ID 23745 //
     /* 1478813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1478824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1478827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1478830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1478836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478863 */     // MIs[1] Operand 1
     /* 1478863 */     // No operand predicates
     /* 1478863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478867 */     // MIs[0] policy
     /* 1478867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478879 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1478882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478904 */     // GIR_Coverage, 23745,
     /* 1478904 */     GIR_EraseRootFromParent_Done,
     /* 1478905 */   // Label 20684: @1478905
     /* 1478905 */   GIM_Try, /*On fail goto*//*Label 20685*/ GIMT_Encode4(1479002), // Rule ID 23748 //
     /* 1478910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1478921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1478924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1478927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1478933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1478940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478960 */     // MIs[1] Operand 1
     /* 1478960 */     // No operand predicates
     /* 1478960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478964 */     // MIs[0] policy
     /* 1478964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478976 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1478979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479001 */     // GIR_Coverage, 23748,
     /* 1479001 */     GIR_EraseRootFromParent_Done,
     /* 1479002 */   // Label 20685: @1479002
     /* 1479002 */   GIM_Try, /*On fail goto*//*Label 20686*/ GIMT_Encode4(1479099), // Rule ID 23749 //
     /* 1479007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1479018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1479021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1479024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479057 */     // MIs[1] Operand 1
     /* 1479057 */     // No operand predicates
     /* 1479057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479061 */     // MIs[0] policy
     /* 1479061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479073 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1479076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479098 */     // GIR_Coverage, 23749,
     /* 1479098 */     GIR_EraseRootFromParent_Done,
     /* 1479099 */   // Label 20686: @1479099
     /* 1479099 */   GIM_Try, /*On fail goto*//*Label 20687*/ GIMT_Encode4(1479196), // Rule ID 23752 //
     /* 1479104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1479115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1479118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1479121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1479127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479154 */     // MIs[1] Operand 1
     /* 1479154 */     // No operand predicates
     /* 1479154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479158 */     // MIs[0] policy
     /* 1479158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479170 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1479173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479195 */     // GIR_Coverage, 23752,
     /* 1479195 */     GIR_EraseRootFromParent_Done,
     /* 1479196 */   // Label 20687: @1479196
     /* 1479196 */   GIM_Try, /*On fail goto*//*Label 20688*/ GIMT_Encode4(1479293), // Rule ID 23753 //
     /* 1479201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1479212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1479215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1479218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1479224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479251 */     // MIs[1] Operand 1
     /* 1479251 */     // No operand predicates
     /* 1479251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479255 */     // MIs[0] policy
     /* 1479255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479267 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1479270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479292 */     // GIR_Coverage, 23753,
     /* 1479292 */     GIR_EraseRootFromParent_Done,
     /* 1479293 */   // Label 20688: @1479293
     /* 1479293 */   GIM_Try, /*On fail goto*//*Label 20689*/ GIMT_Encode4(1479390), // Rule ID 23756 //
     /* 1479298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1479309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1479312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1479315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1479321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479348 */     // MIs[1] Operand 1
     /* 1479348 */     // No operand predicates
     /* 1479348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479352 */     // MIs[0] policy
     /* 1479352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1479367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479389 */     // GIR_Coverage, 23756,
     /* 1479389 */     GIR_EraseRootFromParent_Done,
     /* 1479390 */   // Label 20689: @1479390
     /* 1479390 */   GIM_Try, /*On fail goto*//*Label 20690*/ GIMT_Encode4(1479487), // Rule ID 23757 //
     /* 1479395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1479406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1479409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1479412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1479418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479445 */     // MIs[1] Operand 1
     /* 1479445 */     // No operand predicates
     /* 1479445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479449 */     // MIs[0] policy
     /* 1479449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479461 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1479464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479486 */     // GIR_Coverage, 23757,
     /* 1479486 */     GIR_EraseRootFromParent_Done,
     /* 1479487 */   // Label 20690: @1479487
     /* 1479487 */   GIM_Try, /*On fail goto*//*Label 20691*/ GIMT_Encode4(1479584), // Rule ID 23760 //
     /* 1479492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1479503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1479506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1479509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479542 */     // MIs[1] Operand 1
     /* 1479542 */     // No operand predicates
     /* 1479542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479546 */     // MIs[0] policy
     /* 1479546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479558 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1479561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479583 */     // GIR_Coverage, 23760,
     /* 1479583 */     GIR_EraseRootFromParent_Done,
     /* 1479584 */   // Label 20691: @1479584
     /* 1479584 */   GIM_Try, /*On fail goto*//*Label 20692*/ GIMT_Encode4(1479681), // Rule ID 23761 //
     /* 1479589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1479600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1479603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1479606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479639 */     // MIs[1] Operand 1
     /* 1479639 */     // No operand predicates
     /* 1479639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479643 */     // MIs[0] policy
     /* 1479643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479655 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1479658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479680 */     // GIR_Coverage, 23761,
     /* 1479680 */     GIR_EraseRootFromParent_Done,
     /* 1479681 */   // Label 20692: @1479681
     /* 1479681 */   GIM_Try, /*On fail goto*//*Label 20693*/ GIMT_Encode4(1479778), // Rule ID 23764 //
     /* 1479686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1479697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1479700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1479703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479736 */     // MIs[1] Operand 1
     /* 1479736 */     // No operand predicates
     /* 1479736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479740 */     // MIs[0] policy
     /* 1479740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1479755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479777 */     // GIR_Coverage, 23764,
     /* 1479777 */     GIR_EraseRootFromParent_Done,
     /* 1479778 */   // Label 20693: @1479778
     /* 1479778 */   GIM_Try, /*On fail goto*//*Label 20694*/ GIMT_Encode4(1479875), // Rule ID 23765 //
     /* 1479783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1479794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1479797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1479800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479833 */     // MIs[1] Operand 1
     /* 1479833 */     // No operand predicates
     /* 1479833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479837 */     // MIs[0] policy
     /* 1479837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479849 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1479852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479874 */     // GIR_Coverage, 23765,
     /* 1479874 */     GIR_EraseRootFromParent_Done,
     /* 1479875 */   // Label 20694: @1479875
     /* 1479875 */   GIM_Try, /*On fail goto*//*Label 20695*/ GIMT_Encode4(1479972), // Rule ID 23768 //
     /* 1479880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1479883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1479891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1479894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1479897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1479903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479930 */     // MIs[1] Operand 1
     /* 1479930 */     // No operand predicates
     /* 1479930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479934 */     // MIs[0] policy
     /* 1479934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1479949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1479968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479971 */     // GIR_Coverage, 23768,
     /* 1479971 */     GIR_EraseRootFromParent_Done,
     /* 1479972 */   // Label 20695: @1479972
     /* 1479972 */   GIM_Try, /*On fail goto*//*Label 20696*/ GIMT_Encode4(1480069), // Rule ID 23769 //
     /* 1479977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1479980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1479988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1479991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1479994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480027 */     // MIs[1] Operand 1
     /* 1480027 */     // No operand predicates
     /* 1480027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480031 */     // MIs[0] policy
     /* 1480031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480043 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1480046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480068 */     // GIR_Coverage, 23769,
     /* 1480068 */     GIR_EraseRootFromParent_Done,
     /* 1480069 */   // Label 20696: @1480069
     /* 1480069 */   GIM_Try, /*On fail goto*//*Label 20697*/ GIMT_Encode4(1480166), // Rule ID 23772 //
     /* 1480074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1480077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1480085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1480088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1480091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480124 */     // MIs[1] Operand 1
     /* 1480124 */     // No operand predicates
     /* 1480124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480128 */     // MIs[0] policy
     /* 1480128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480140 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1480143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480165 */     // GIR_Coverage, 23772,
     /* 1480165 */     GIR_EraseRootFromParent_Done,
     /* 1480166 */   // Label 20697: @1480166
     /* 1480166 */   GIM_Try, /*On fail goto*//*Label 20698*/ GIMT_Encode4(1480263), // Rule ID 23773 //
     /* 1480171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1480174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1480182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1480185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1480188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480221 */     // MIs[1] Operand 1
     /* 1480221 */     // No operand predicates
     /* 1480221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480225 */     // MIs[0] policy
     /* 1480225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480237 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1480240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480262 */     // GIR_Coverage, 23773,
     /* 1480262 */     GIR_EraseRootFromParent_Done,
     /* 1480263 */   // Label 20698: @1480263
     /* 1480263 */   GIM_Try, /*On fail goto*//*Label 20699*/ GIMT_Encode4(1480360), // Rule ID 23776 //
     /* 1480268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1480271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1480279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1480282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1480285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480318 */     // MIs[1] Operand 1
     /* 1480318 */     // No operand predicates
     /* 1480318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480322 */     // MIs[0] policy
     /* 1480322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480334 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1480337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480359 */     // GIR_Coverage, 23776,
     /* 1480359 */     GIR_EraseRootFromParent_Done,
     /* 1480360 */   // Label 20699: @1480360
     /* 1480360 */   GIM_Try, /*On fail goto*//*Label 20700*/ GIMT_Encode4(1480457), // Rule ID 23777 //
     /* 1480365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1480368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1480376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1480379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1480382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480415 */     // MIs[1] Operand 1
     /* 1480415 */     // No operand predicates
     /* 1480415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480419 */     // MIs[0] policy
     /* 1480419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480431 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1480434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480456 */     // GIR_Coverage, 23777,
     /* 1480456 */     GIR_EraseRootFromParent_Done,
     /* 1480457 */   // Label 20700: @1480457
     /* 1480457 */   GIM_Try, /*On fail goto*//*Label 20701*/ GIMT_Encode4(1480554), // Rule ID 23868 //
     /* 1480462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1480473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1480476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1480479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1480485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480512 */     // MIs[1] Operand 1
     /* 1480512 */     // No operand predicates
     /* 1480512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480516 */     // MIs[0] policy
     /* 1480516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480528 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1480531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1480550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480553 */     // GIR_Coverage, 23868,
     /* 1480553 */     GIR_EraseRootFromParent_Done,
     /* 1480554 */   // Label 20701: @1480554
     /* 1480554 */   GIM_Try, /*On fail goto*//*Label 20702*/ GIMT_Encode4(1480651), // Rule ID 23869 //
     /* 1480559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1480570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1480573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1480576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1480582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480609 */     // MIs[1] Operand 1
     /* 1480609 */     // No operand predicates
     /* 1480609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480613 */     // MIs[0] policy
     /* 1480613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480625 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1480628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1480647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480650 */     // GIR_Coverage, 23869,
     /* 1480650 */     GIR_EraseRootFromParent_Done,
     /* 1480651 */   // Label 20702: @1480651
     /* 1480651 */   GIM_Try, /*On fail goto*//*Label 20703*/ GIMT_Encode4(1480748), // Rule ID 23872 //
     /* 1480656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1480667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1480670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1480673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480706 */     // MIs[1] Operand 1
     /* 1480706 */     // No operand predicates
     /* 1480706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480710 */     // MIs[0] policy
     /* 1480710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480722 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1480725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1480744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480747 */     // GIR_Coverage, 23872,
     /* 1480747 */     GIR_EraseRootFromParent_Done,
     /* 1480748 */   // Label 20703: @1480748
     /* 1480748 */   GIM_Try, /*On fail goto*//*Label 20704*/ GIMT_Encode4(1480845), // Rule ID 23873 //
     /* 1480753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1480764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1480767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1480770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480803 */     // MIs[1] Operand 1
     /* 1480803 */     // No operand predicates
     /* 1480803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480807 */     // MIs[0] policy
     /* 1480807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480819 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1480822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1480841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480844 */     // GIR_Coverage, 23873,
     /* 1480844 */     GIR_EraseRootFromParent_Done,
     /* 1480845 */   // Label 20704: @1480845
     /* 1480845 */   GIM_Try, /*On fail goto*//*Label 20705*/ GIMT_Encode4(1480942), // Rule ID 23876 //
     /* 1480850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1480861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1480864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1480867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480900 */     // MIs[1] Operand 1
     /* 1480900 */     // No operand predicates
     /* 1480900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480904 */     // MIs[0] policy
     /* 1480904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480916 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1480919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1480938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480941 */     // GIR_Coverage, 23876,
     /* 1480941 */     GIR_EraseRootFromParent_Done,
     /* 1480942 */   // Label 20705: @1480942
     /* 1480942 */   GIM_Try, /*On fail goto*//*Label 20706*/ GIMT_Encode4(1481039), // Rule ID 23877 //
     /* 1480947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1480958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1480961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1480964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480997 */     // MIs[1] Operand 1
     /* 1480997 */     // No operand predicates
     /* 1480997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481001 */     // MIs[0] policy
     /* 1481001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481013 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1481016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1481035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481038 */     // GIR_Coverage, 23877,
     /* 1481038 */     GIR_EraseRootFromParent_Done,
     /* 1481039 */   // Label 20706: @1481039
     /* 1481039 */   GIM_Try, /*On fail goto*//*Label 20707*/ GIMT_Encode4(1481136), // Rule ID 23880 //
     /* 1481044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1481055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1481058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1481061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481094 */     // MIs[1] Operand 1
     /* 1481094 */     // No operand predicates
     /* 1481094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481098 */     // MIs[0] policy
     /* 1481098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481110 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1481113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481135 */     // GIR_Coverage, 23880,
     /* 1481135 */     GIR_EraseRootFromParent_Done,
     /* 1481136 */   // Label 20707: @1481136
     /* 1481136 */   GIM_Try, /*On fail goto*//*Label 20708*/ GIMT_Encode4(1481233), // Rule ID 23881 //
     /* 1481141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1481152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1481155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1481158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481191 */     // MIs[1] Operand 1
     /* 1481191 */     // No operand predicates
     /* 1481191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481195 */     // MIs[0] policy
     /* 1481195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481207 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1481210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481232 */     // GIR_Coverage, 23881,
     /* 1481232 */     GIR_EraseRootFromParent_Done,
     /* 1481233 */   // Label 20708: @1481233
     /* 1481233 */   GIM_Try, /*On fail goto*//*Label 20709*/ GIMT_Encode4(1481330), // Rule ID 23884 //
     /* 1481238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1481255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481288 */     // MIs[1] Operand 1
     /* 1481288 */     // No operand predicates
     /* 1481288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481292 */     // MIs[0] policy
     /* 1481292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481304 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1481307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481329 */     // GIR_Coverage, 23884,
     /* 1481329 */     GIR_EraseRootFromParent_Done,
     /* 1481330 */   // Label 20709: @1481330
     /* 1481330 */   GIM_Try, /*On fail goto*//*Label 20710*/ GIMT_Encode4(1481427), // Rule ID 23885 //
     /* 1481335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1481352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481385 */     // MIs[1] Operand 1
     /* 1481385 */     // No operand predicates
     /* 1481385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481389 */     // MIs[0] policy
     /* 1481389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481401 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1481404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481426 */     // GIR_Coverage, 23885,
     /* 1481426 */     GIR_EraseRootFromParent_Done,
     /* 1481427 */   // Label 20710: @1481427
     /* 1481427 */   GIM_Try, /*On fail goto*//*Label 20711*/ GIMT_Encode4(1481524), // Rule ID 23888 //
     /* 1481432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1481443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1481446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1481449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481482 */     // MIs[1] Operand 1
     /* 1481482 */     // No operand predicates
     /* 1481482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481486 */     // MIs[0] policy
     /* 1481486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481498 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1481501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481523 */     // GIR_Coverage, 23888,
     /* 1481523 */     GIR_EraseRootFromParent_Done,
     /* 1481524 */   // Label 20711: @1481524
     /* 1481524 */   GIM_Try, /*On fail goto*//*Label 20712*/ GIMT_Encode4(1481621), // Rule ID 23889 //
     /* 1481529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1481540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1481543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1481546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481579 */     // MIs[1] Operand 1
     /* 1481579 */     // No operand predicates
     /* 1481579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481583 */     // MIs[0] policy
     /* 1481583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481595 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1481598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481620 */     // GIR_Coverage, 23889,
     /* 1481620 */     GIR_EraseRootFromParent_Done,
     /* 1481621 */   // Label 20712: @1481621
     /* 1481621 */   GIM_Try, /*On fail goto*//*Label 20713*/ GIMT_Encode4(1481718), // Rule ID 23892 //
     /* 1481626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1481637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1481640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1481643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481676 */     // MIs[1] Operand 1
     /* 1481676 */     // No operand predicates
     /* 1481676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481680 */     // MIs[0] policy
     /* 1481680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481692 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1481695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1481714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481717 */     // GIR_Coverage, 23892,
     /* 1481717 */     GIR_EraseRootFromParent_Done,
     /* 1481718 */   // Label 20713: @1481718
     /* 1481718 */   GIM_Try, /*On fail goto*//*Label 20714*/ GIMT_Encode4(1481815), // Rule ID 23893 //
     /* 1481723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1481734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1481737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1481740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481773 */     // MIs[1] Operand 1
     /* 1481773 */     // No operand predicates
     /* 1481773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481777 */     // MIs[0] policy
     /* 1481777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481789 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1481792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1481811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481814 */     // GIR_Coverage, 23893,
     /* 1481814 */     GIR_EraseRootFromParent_Done,
     /* 1481815 */   // Label 20714: @1481815
     /* 1481815 */   GIM_Try, /*On fail goto*//*Label 20715*/ GIMT_Encode4(1481912), // Rule ID 23896 //
     /* 1481820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1481831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1481834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1481837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481870 */     // MIs[1] Operand 1
     /* 1481870 */     // No operand predicates
     /* 1481870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481874 */     // MIs[0] policy
     /* 1481874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481886 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1481889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481911 */     // GIR_Coverage, 23896,
     /* 1481911 */     GIR_EraseRootFromParent_Done,
     /* 1481912 */   // Label 20715: @1481912
     /* 1481912 */   GIM_Try, /*On fail goto*//*Label 20716*/ GIMT_Encode4(1482009), // Rule ID 23897 //
     /* 1481917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1481928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1481931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1481934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481967 */     // MIs[1] Operand 1
     /* 1481967 */     // No operand predicates
     /* 1481967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481971 */     // MIs[0] policy
     /* 1481971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481983 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1481986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482008 */     // GIR_Coverage, 23897,
     /* 1482008 */     GIR_EraseRootFromParent_Done,
     /* 1482009 */   // Label 20716: @1482009
     /* 1482009 */   GIM_Try, /*On fail goto*//*Label 20717*/ GIMT_Encode4(1482106), // Rule ID 23900 //
     /* 1482014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1482025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1482028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1482031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1482037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482064 */     // MIs[1] Operand 1
     /* 1482064 */     // No operand predicates
     /* 1482064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482068 */     // MIs[0] policy
     /* 1482068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482080 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1482083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482105 */     // GIR_Coverage, 23900,
     /* 1482105 */     GIR_EraseRootFromParent_Done,
     /* 1482106 */   // Label 20717: @1482106
     /* 1482106 */   GIM_Try, /*On fail goto*//*Label 20718*/ GIMT_Encode4(1482203), // Rule ID 23901 //
     /* 1482111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1482122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1482125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1482128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1482134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482161 */     // MIs[1] Operand 1
     /* 1482161 */     // No operand predicates
     /* 1482161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482165 */     // MIs[0] policy
     /* 1482165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482177 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1482180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482202 */     // GIR_Coverage, 23901,
     /* 1482202 */     GIR_EraseRootFromParent_Done,
     /* 1482203 */   // Label 20718: @1482203
     /* 1482203 */   GIM_Try, /*On fail goto*//*Label 20719*/ GIMT_Encode4(1482300), // Rule ID 23904 //
     /* 1482208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1482211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1482219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1482222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1482225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1482231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482258 */     // MIs[1] Operand 1
     /* 1482258 */     // No operand predicates
     /* 1482258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482262 */     // MIs[0] policy
     /* 1482262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1482277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1482296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482299 */     // GIR_Coverage, 23904,
     /* 1482299 */     GIR_EraseRootFromParent_Done,
     /* 1482300 */   // Label 20719: @1482300
     /* 1482300 */   GIM_Try, /*On fail goto*//*Label 20720*/ GIMT_Encode4(1482397), // Rule ID 23905 //
     /* 1482305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1482308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1482316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1482319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1482322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1482328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482355 */     // MIs[1] Operand 1
     /* 1482355 */     // No operand predicates
     /* 1482355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482359 */     // MIs[0] policy
     /* 1482359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482371 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1482374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1482393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482396 */     // GIR_Coverage, 23905,
     /* 1482396 */     GIR_EraseRootFromParent_Done,
     /* 1482397 */   // Label 20720: @1482397
     /* 1482397 */   GIM_Try, /*On fail goto*//*Label 20721*/ GIMT_Encode4(1482494), // Rule ID 23908 //
     /* 1482402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1482413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1482416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1482419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482452 */     // MIs[1] Operand 1
     /* 1482452 */     // No operand predicates
     /* 1482452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482456 */     // MIs[0] policy
     /* 1482456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482468 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1482471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482493 */     // GIR_Coverage, 23908,
     /* 1482493 */     GIR_EraseRootFromParent_Done,
     /* 1482494 */   // Label 20721: @1482494
     /* 1482494 */   GIM_Try, /*On fail goto*//*Label 20722*/ GIMT_Encode4(1482591), // Rule ID 23909 //
     /* 1482499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1482510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1482513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1482516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482549 */     // MIs[1] Operand 1
     /* 1482549 */     // No operand predicates
     /* 1482549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482553 */     // MIs[0] policy
     /* 1482553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482565 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1482568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482590 */     // GIR_Coverage, 23909,
     /* 1482590 */     GIR_EraseRootFromParent_Done,
     /* 1482591 */   // Label 20722: @1482591
     /* 1482591 */   GIM_Try, /*On fail goto*//*Label 20723*/ GIMT_Encode4(1482688), // Rule ID 23912 //
     /* 1482596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1482607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1482610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1482613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1482619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482646 */     // MIs[1] Operand 1
     /* 1482646 */     // No operand predicates
     /* 1482646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482650 */     // MIs[0] policy
     /* 1482650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482662 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1482665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482687 */     // GIR_Coverage, 23912,
     /* 1482687 */     GIR_EraseRootFromParent_Done,
     /* 1482688 */   // Label 20723: @1482688
     /* 1482688 */   GIM_Try, /*On fail goto*//*Label 20724*/ GIMT_Encode4(1482785), // Rule ID 23913 //
     /* 1482693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1482704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1482707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1482710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1482716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482743 */     // MIs[1] Operand 1
     /* 1482743 */     // No operand predicates
     /* 1482743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482747 */     // MIs[0] policy
     /* 1482747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482759 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1482762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482784 */     // GIR_Coverage, 23913,
     /* 1482784 */     GIR_EraseRootFromParent_Done,
     /* 1482785 */   // Label 20724: @1482785
     /* 1482785 */   GIM_Try, /*On fail goto*//*Label 20725*/ GIMT_Encode4(1482882), // Rule ID 23916 //
     /* 1482790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1482801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1482804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1482807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1482813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1482820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482840 */     // MIs[1] Operand 1
     /* 1482840 */     // No operand predicates
     /* 1482840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482844 */     // MIs[0] policy
     /* 1482844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482856 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1482859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482881 */     // GIR_Coverage, 23916,
     /* 1482881 */     GIR_EraseRootFromParent_Done,
     /* 1482882 */   // Label 20725: @1482882
     /* 1482882 */   GIM_Try, /*On fail goto*//*Label 20726*/ GIMT_Encode4(1482979), // Rule ID 23917 //
     /* 1482887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1482898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1482901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1482904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1482910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1482917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482937 */     // MIs[1] Operand 1
     /* 1482937 */     // No operand predicates
     /* 1482937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482941 */     // MIs[0] policy
     /* 1482941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482953 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1482956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482978 */     // GIR_Coverage, 23917,
     /* 1482978 */     GIR_EraseRootFromParent_Done,
     /* 1482979 */   // Label 20726: @1482979
     /* 1482979 */   GIM_Try, /*On fail goto*//*Label 20727*/ GIMT_Encode4(1483076), // Rule ID 23920 //
     /* 1482984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1482995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1482998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1483001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483034 */     // MIs[1] Operand 1
     /* 1483034 */     // No operand predicates
     /* 1483034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483038 */     // MIs[0] policy
     /* 1483038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483050 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1483053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483075 */     // GIR_Coverage, 23920,
     /* 1483075 */     GIR_EraseRootFromParent_Done,
     /* 1483076 */   // Label 20727: @1483076
     /* 1483076 */   GIM_Try, /*On fail goto*//*Label 20728*/ GIMT_Encode4(1483173), // Rule ID 23921 //
     /* 1483081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1483092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1483095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1483098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483131 */     // MIs[1] Operand 1
     /* 1483131 */     // No operand predicates
     /* 1483131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483135 */     // MIs[0] policy
     /* 1483135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483147 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1483150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483172 */     // GIR_Coverage, 23921,
     /* 1483172 */     GIR_EraseRootFromParent_Done,
     /* 1483173 */   // Label 20728: @1483173
     /* 1483173 */   GIM_Try, /*On fail goto*//*Label 20729*/ GIMT_Encode4(1483270), // Rule ID 23924 //
     /* 1483178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1483189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1483192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1483195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483228 */     // MIs[1] Operand 1
     /* 1483228 */     // No operand predicates
     /* 1483228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483232 */     // MIs[0] policy
     /* 1483232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1483247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483269 */     // GIR_Coverage, 23924,
     /* 1483269 */     GIR_EraseRootFromParent_Done,
     /* 1483270 */   // Label 20729: @1483270
     /* 1483270 */   GIM_Try, /*On fail goto*//*Label 20730*/ GIMT_Encode4(1483367), // Rule ID 23925 //
     /* 1483275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1483286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1483289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1483292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483325 */     // MIs[1] Operand 1
     /* 1483325 */     // No operand predicates
     /* 1483325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483329 */     // MIs[0] policy
     /* 1483329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483341 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1483344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483366 */     // GIR_Coverage, 23925,
     /* 1483366 */     GIR_EraseRootFromParent_Done,
     /* 1483367 */   // Label 20730: @1483367
     /* 1483367 */   GIM_Try, /*On fail goto*//*Label 20731*/ GIMT_Encode4(1483464), // Rule ID 23928 //
     /* 1483372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1483383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1483386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1483389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1483395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483422 */     // MIs[1] Operand 1
     /* 1483422 */     // No operand predicates
     /* 1483422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483426 */     // MIs[0] policy
     /* 1483426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483438 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1483441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483463 */     // GIR_Coverage, 23928,
     /* 1483463 */     GIR_EraseRootFromParent_Done,
     /* 1483464 */   // Label 20731: @1483464
     /* 1483464 */   GIM_Try, /*On fail goto*//*Label 20732*/ GIMT_Encode4(1483561), // Rule ID 23929 //
     /* 1483469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1483480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1483483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1483486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1483492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483519 */     // MIs[1] Operand 1
     /* 1483519 */     // No operand predicates
     /* 1483519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483523 */     // MIs[0] policy
     /* 1483523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483535 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1483538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483560 */     // GIR_Coverage, 23929,
     /* 1483560 */     GIR_EraseRootFromParent_Done,
     /* 1483561 */   // Label 20732: @1483561
     /* 1483561 */   GIM_Try, /*On fail goto*//*Label 20733*/ GIMT_Encode4(1483658), // Rule ID 23932 //
     /* 1483566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1483577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1483580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1483583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483616 */     // MIs[1] Operand 1
     /* 1483616 */     // No operand predicates
     /* 1483616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483620 */     // MIs[0] policy
     /* 1483620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483632 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1483635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483657 */     // GIR_Coverage, 23932,
     /* 1483657 */     GIR_EraseRootFromParent_Done,
     /* 1483658 */   // Label 20733: @1483658
     /* 1483658 */   GIM_Try, /*On fail goto*//*Label 20734*/ GIMT_Encode4(1483755), // Rule ID 23933 //
     /* 1483663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1483674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1483677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1483680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483713 */     // MIs[1] Operand 1
     /* 1483713 */     // No operand predicates
     /* 1483713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483717 */     // MIs[0] policy
     /* 1483717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483729 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1483732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483754 */     // GIR_Coverage, 23933,
     /* 1483754 */     GIR_EraseRootFromParent_Done,
     /* 1483755 */   // Label 20734: @1483755
     /* 1483755 */   GIM_Try, /*On fail goto*//*Label 20735*/ GIMT_Encode4(1483852), // Rule ID 23936 //
     /* 1483760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1483771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1483774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1483777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483810 */     // MIs[1] Operand 1
     /* 1483810 */     // No operand predicates
     /* 1483810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483814 */     // MIs[0] policy
     /* 1483814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483826 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1483829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483851 */     // GIR_Coverage, 23936,
     /* 1483851 */     GIR_EraseRootFromParent_Done,
     /* 1483852 */   // Label 20735: @1483852
     /* 1483852 */   GIM_Try, /*On fail goto*//*Label 20736*/ GIMT_Encode4(1483949), // Rule ID 23937 //
     /* 1483857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1483868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1483871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1483874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483907 */     // MIs[1] Operand 1
     /* 1483907 */     // No operand predicates
     /* 1483907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483911 */     // MIs[0] policy
     /* 1483911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483923 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1483926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483948 */     // GIR_Coverage, 23937,
     /* 1483948 */     GIR_EraseRootFromParent_Done,
     /* 1483949 */   // Label 20736: @1483949
     /* 1483949 */   GIM_Try, /*On fail goto*//*Label 20737*/ GIMT_Encode4(1484046), // Rule ID 23940 //
     /* 1483954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1483971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484004 */     // MIs[1] Operand 1
     /* 1484004 */     // No operand predicates
     /* 1484004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484008 */     // MIs[0] policy
     /* 1484008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484020 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1484023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484045 */     // GIR_Coverage, 23940,
     /* 1484045 */     GIR_EraseRootFromParent_Done,
     /* 1484046 */   // Label 20737: @1484046
     /* 1484046 */   GIM_Try, /*On fail goto*//*Label 20738*/ GIMT_Encode4(1484143), // Rule ID 23941 //
     /* 1484051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1484062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1484065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1484068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1484074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1484081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484101 */     // MIs[1] Operand 1
     /* 1484101 */     // No operand predicates
     /* 1484101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484105 */     // MIs[0] policy
     /* 1484105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484117 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1484120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484142 */     // GIR_Coverage, 23941,
     /* 1484142 */     GIR_EraseRootFromParent_Done,
     /* 1484143 */   // Label 20738: @1484143
     /* 1484143 */   GIM_Try, /*On fail goto*//*Label 20739*/ GIMT_Encode4(1484240), // Rule ID 23944 //
     /* 1484148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1484151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1484159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1484162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1484165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1484178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1484182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1484186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484198 */     // MIs[1] Operand 1
     /* 1484198 */     // No operand predicates
     /* 1484198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484202 */     // MIs[0] policy
     /* 1484202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1484217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484239 */     // GIR_Coverage, 23944,
     /* 1484239 */     GIR_EraseRootFromParent_Done,
     /* 1484240 */   // Label 20739: @1484240
     /* 1484240 */   GIM_Try, /*On fail goto*//*Label 20740*/ GIMT_Encode4(1484337), // Rule ID 23945 //
     /* 1484245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1484248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1484256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1484259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1484262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1484275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1484279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1484283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484295 */     // MIs[1] Operand 1
     /* 1484295 */     // No operand predicates
     /* 1484295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484299 */     // MIs[0] policy
     /* 1484299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1484314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484336 */     // GIR_Coverage, 23945,
     /* 1484336 */     GIR_EraseRootFromParent_Done,
     /* 1484337 */   // Label 20740: @1484337
     /* 1484337 */   GIM_Try, /*On fail goto*//*Label 20741*/ GIMT_Encode4(1484434), // Rule ID 23948 //
     /* 1484342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1484345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1484353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1484356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1484359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1484372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484392 */     // MIs[1] Operand 1
     /* 1484392 */     // No operand predicates
     /* 1484392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484396 */     // MIs[0] policy
     /* 1484396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484408 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1484411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484433 */     // GIR_Coverage, 23948,
     /* 1484433 */     GIR_EraseRootFromParent_Done,
     /* 1484434 */   // Label 20741: @1484434
     /* 1484434 */   GIM_Try, /*On fail goto*//*Label 20742*/ GIMT_Encode4(1484531), // Rule ID 23949 //
     /* 1484439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1484442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1484450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1484453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1484456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1484469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484489 */     // MIs[1] Operand 1
     /* 1484489 */     // No operand predicates
     /* 1484489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484493 */     // MIs[0] policy
     /* 1484493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484505 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1484508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484530 */     // GIR_Coverage, 23949,
     /* 1484530 */     GIR_EraseRootFromParent_Done,
     /* 1484531 */   // Label 20742: @1484531
     /* 1484531 */   GIM_Try, /*On fail goto*//*Label 20743*/ GIMT_Encode4(1484628), // Rule ID 23952 //
     /* 1484536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1484539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1484547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1484550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1484553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1484566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484586 */     // MIs[1] Operand 1
     /* 1484586 */     // No operand predicates
     /* 1484586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484590 */     // MIs[0] policy
     /* 1484590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1484605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484627 */     // GIR_Coverage, 23952,
     /* 1484627 */     GIR_EraseRootFromParent_Done,
     /* 1484628 */   // Label 20743: @1484628
     /* 1484628 */   GIM_Try, /*On fail goto*//*Label 20744*/ GIMT_Encode4(1484725), // Rule ID 23953 //
     /* 1484633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1484636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1484644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1484647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1484650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1484663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484683 */     // MIs[1] Operand 1
     /* 1484683 */     // No operand predicates
     /* 1484683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484687 */     // MIs[0] policy
     /* 1484687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484699 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1484702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484724 */     // GIR_Coverage, 23953,
     /* 1484724 */     GIR_EraseRootFromParent_Done,
     /* 1484725 */   // Label 20744: @1484725
     /* 1484725 */   GIM_Try, /*On fail goto*//*Label 20745*/ GIMT_Encode4(1484822), // Rule ID 24192 //
     /* 1484730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1484733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1484738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1484741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1484744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1484747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484780 */     // MIs[1] Operand 1
     /* 1484780 */     // No operand predicates
     /* 1484780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484784 */     // MIs[0] policy
     /* 1484784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484796 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1484799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484821 */     // GIR_Coverage, 24192,
     /* 1484821 */     GIR_EraseRootFromParent_Done,
     /* 1484822 */   // Label 20745: @1484822
     /* 1484822 */   GIM_Try, /*On fail goto*//*Label 20746*/ GIMT_Encode4(1484919), // Rule ID 24193 //
     /* 1484827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1484830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1484835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1484838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1484841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1484844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484877 */     // MIs[1] Operand 1
     /* 1484877 */     // No operand predicates
     /* 1484877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484881 */     // MIs[0] policy
     /* 1484881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484893 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1484896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484918 */     // GIR_Coverage, 24193,
     /* 1484918 */     GIR_EraseRootFromParent_Done,
     /* 1484919 */   // Label 20746: @1484919
     /* 1484919 */   GIM_Try, /*On fail goto*//*Label 20747*/ GIMT_Encode4(1485016), // Rule ID 24196 //
     /* 1484924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1484927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1484932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1484935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1484938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1484941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484974 */     // MIs[1] Operand 1
     /* 1484974 */     // No operand predicates
     /* 1484974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484978 */     // MIs[0] policy
     /* 1484978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484990 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1484993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485015 */     // GIR_Coverage, 24196,
     /* 1485015 */     GIR_EraseRootFromParent_Done,
     /* 1485016 */   // Label 20747: @1485016
     /* 1485016 */   GIM_Try, /*On fail goto*//*Label 20748*/ GIMT_Encode4(1485113), // Rule ID 24197 //
     /* 1485021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1485024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1485029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1485032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1485035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1485038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1485044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485071 */     // MIs[1] Operand 1
     /* 1485071 */     // No operand predicates
     /* 1485071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485075 */     // MIs[0] policy
     /* 1485075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485087 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1485090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485112 */     // GIR_Coverage, 24197,
     /* 1485112 */     GIR_EraseRootFromParent_Done,
     /* 1485113 */   // Label 20748: @1485113
     /* 1485113 */   GIM_Try, /*On fail goto*//*Label 20749*/ GIMT_Encode4(1485210), // Rule ID 24200 //
     /* 1485118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1485121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1485126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1485129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1485132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1485135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485168 */     // MIs[1] Operand 1
     /* 1485168 */     // No operand predicates
     /* 1485168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485172 */     // MIs[0] policy
     /* 1485172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485184 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1485187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485209 */     // GIR_Coverage, 24200,
     /* 1485209 */     GIR_EraseRootFromParent_Done,
     /* 1485210 */   // Label 20749: @1485210
     /* 1485210 */   GIM_Try, /*On fail goto*//*Label 20750*/ GIMT_Encode4(1485307), // Rule ID 24201 //
     /* 1485215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1485218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1485223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1485226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1485229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1485232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485265 */     // MIs[1] Operand 1
     /* 1485265 */     // No operand predicates
     /* 1485265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485269 */     // MIs[0] policy
     /* 1485269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485281 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1485284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485306 */     // GIR_Coverage, 24201,
     /* 1485306 */     GIR_EraseRootFromParent_Done,
     /* 1485307 */   // Label 20750: @1485307
     /* 1485307 */   GIM_Try, /*On fail goto*//*Label 20751*/ GIMT_Encode4(1485404), // Rule ID 24204 //
     /* 1485312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1485315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1485320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1485323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1485326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1485329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485362 */     // MIs[1] Operand 1
     /* 1485362 */     // No operand predicates
     /* 1485362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485366 */     // MIs[0] policy
     /* 1485366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485378 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1485381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485403 */     // GIR_Coverage, 24204,
     /* 1485403 */     GIR_EraseRootFromParent_Done,
     /* 1485404 */   // Label 20751: @1485404
     /* 1485404 */   GIM_Try, /*On fail goto*//*Label 20752*/ GIMT_Encode4(1485501), // Rule ID 24205 //
     /* 1485409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1485412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1485417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1485420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1485423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1485426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485459 */     // MIs[1] Operand 1
     /* 1485459 */     // No operand predicates
     /* 1485459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485463 */     // MIs[0] policy
     /* 1485463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485475 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1485478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485500 */     // GIR_Coverage, 24205,
     /* 1485500 */     GIR_EraseRootFromParent_Done,
     /* 1485501 */   // Label 20752: @1485501
     /* 1485501 */   GIM_Try, /*On fail goto*//*Label 20753*/ GIMT_Encode4(1485598), // Rule ID 24208 //
     /* 1485506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1485509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1485514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1485517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1485520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1485523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1485529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485556 */     // MIs[1] Operand 1
     /* 1485556 */     // No operand predicates
     /* 1485556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485560 */     // MIs[0] policy
     /* 1485560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485572 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1485575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485597 */     // GIR_Coverage, 24208,
     /* 1485597 */     GIR_EraseRootFromParent_Done,
     /* 1485598 */   // Label 20753: @1485598
     /* 1485598 */   GIM_Try, /*On fail goto*//*Label 20754*/ GIMT_Encode4(1485695), // Rule ID 24209 //
     /* 1485603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1485606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1485611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1485614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1485617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1485620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1485626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485653 */     // MIs[1] Operand 1
     /* 1485653 */     // No operand predicates
     /* 1485653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485657 */     // MIs[0] policy
     /* 1485657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485669 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1485672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485694 */     // GIR_Coverage, 24209,
     /* 1485694 */     GIR_EraseRootFromParent_Done,
     /* 1485695 */   // Label 20754: @1485695
     /* 1485695 */   GIM_Try, /*On fail goto*//*Label 20755*/ GIMT_Encode4(1485792), // Rule ID 24212 //
     /* 1485700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1485703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1485708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1485711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1485714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1485717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485750 */     // MIs[1] Operand 1
     /* 1485750 */     // No operand predicates
     /* 1485750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485754 */     // MIs[0] policy
     /* 1485754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485766 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1485769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1485788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485791 */     // GIR_Coverage, 24212,
     /* 1485791 */     GIR_EraseRootFromParent_Done,
     /* 1485792 */   // Label 20755: @1485792
     /* 1485792 */   GIM_Try, /*On fail goto*//*Label 20756*/ GIMT_Encode4(1485889), // Rule ID 24213 //
     /* 1485797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1485800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1485805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1485808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1485811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1485814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485847 */     // MIs[1] Operand 1
     /* 1485847 */     // No operand predicates
     /* 1485847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485851 */     // MIs[0] policy
     /* 1485851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485863 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1485866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1485885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485888 */     // GIR_Coverage, 24213,
     /* 1485888 */     GIR_EraseRootFromParent_Done,
     /* 1485889 */   // Label 20756: @1485889
     /* 1485889 */   GIM_Try, /*On fail goto*//*Label 20757*/ GIMT_Encode4(1485986), // Rule ID 24216 //
     /* 1485894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1485897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1485902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1485905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1485908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1485911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485944 */     // MIs[1] Operand 1
     /* 1485944 */     // No operand predicates
     /* 1485944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485948 */     // MIs[0] policy
     /* 1485948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485960 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1485963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485985 */     // GIR_Coverage, 24216,
     /* 1485985 */     GIR_EraseRootFromParent_Done,
     /* 1485986 */   // Label 20757: @1485986
     /* 1485986 */   GIM_Try, /*On fail goto*//*Label 20758*/ GIMT_Encode4(1486083), // Rule ID 24217 //
     /* 1485991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1485994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1485999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1486002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1486005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1486008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486041 */     // MIs[1] Operand 1
     /* 1486041 */     // No operand predicates
     /* 1486041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486045 */     // MIs[0] policy
     /* 1486045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486057 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1486060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486082 */     // GIR_Coverage, 24217,
     /* 1486082 */     GIR_EraseRootFromParent_Done,
     /* 1486083 */   // Label 20758: @1486083
     /* 1486083 */   GIM_Try, /*On fail goto*//*Label 20759*/ GIMT_Encode4(1486180), // Rule ID 24220 //
     /* 1486088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1486091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1486096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1486099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1486102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1486105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486138 */     // MIs[1] Operand 1
     /* 1486138 */     // No operand predicates
     /* 1486138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486142 */     // MIs[0] policy
     /* 1486142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486154 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1486157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486179 */     // GIR_Coverage, 24220,
     /* 1486179 */     GIR_EraseRootFromParent_Done,
     /* 1486180 */   // Label 20759: @1486180
     /* 1486180 */   GIM_Try, /*On fail goto*//*Label 20760*/ GIMT_Encode4(1486277), // Rule ID 24221 //
     /* 1486185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1486188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1486193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1486196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1486199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1486202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486235 */     // MIs[1] Operand 1
     /* 1486235 */     // No operand predicates
     /* 1486235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486239 */     // MIs[0] policy
     /* 1486239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486251 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1486254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486276 */     // GIR_Coverage, 24221,
     /* 1486276 */     GIR_EraseRootFromParent_Done,
     /* 1486277 */   // Label 20760: @1486277
     /* 1486277 */   GIM_Try, /*On fail goto*//*Label 20761*/ GIMT_Encode4(1486374), // Rule ID 24224 //
     /* 1486282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1486285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1486290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1486293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1486296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1486299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1486305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486332 */     // MIs[1] Operand 1
     /* 1486332 */     // No operand predicates
     /* 1486332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486336 */     // MIs[0] policy
     /* 1486336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486348 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1486351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486373 */     // GIR_Coverage, 24224,
     /* 1486373 */     GIR_EraseRootFromParent_Done,
     /* 1486374 */   // Label 20761: @1486374
     /* 1486374 */   GIM_Try, /*On fail goto*//*Label 20762*/ GIMT_Encode4(1486471), // Rule ID 24225 //
     /* 1486379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1486382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1486387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1486390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1486393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1486396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1486402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486429 */     // MIs[1] Operand 1
     /* 1486429 */     // No operand predicates
     /* 1486429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486433 */     // MIs[0] policy
     /* 1486433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486445 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1486448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486470 */     // GIR_Coverage, 24225,
     /* 1486470 */     GIR_EraseRootFromParent_Done,
     /* 1486471 */   // Label 20762: @1486471
     /* 1486471 */   GIM_Try, /*On fail goto*//*Label 20763*/ GIMT_Encode4(1486568), // Rule ID 24228 //
     /* 1486476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1486479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1486484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1486487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1486490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1486493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486526 */     // MIs[1] Operand 1
     /* 1486526 */     // No operand predicates
     /* 1486526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486530 */     // MIs[0] policy
     /* 1486530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486542 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1486545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486567 */     // GIR_Coverage, 24228,
     /* 1486567 */     GIR_EraseRootFromParent_Done,
     /* 1486568 */   // Label 20763: @1486568
     /* 1486568 */   GIM_Try, /*On fail goto*//*Label 20764*/ GIMT_Encode4(1486665), // Rule ID 24229 //
     /* 1486573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1486576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1486581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1486584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1486587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1486590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486623 */     // MIs[1] Operand 1
     /* 1486623 */     // No operand predicates
     /* 1486623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486627 */     // MIs[0] policy
     /* 1486627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486639 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1486642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486664 */     // GIR_Coverage, 24229,
     /* 1486664 */     GIR_EraseRootFromParent_Done,
     /* 1486665 */   // Label 20764: @1486665
     /* 1486665 */   GIM_Try, /*On fail goto*//*Label 20765*/ GIMT_Encode4(1486762), // Rule ID 24232 //
     /* 1486670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1486673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1486678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1486681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1486684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1486687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486720 */     // MIs[1] Operand 1
     /* 1486720 */     // No operand predicates
     /* 1486720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486724 */     // MIs[0] policy
     /* 1486724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486736 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1486739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486761 */     // GIR_Coverage, 24232,
     /* 1486761 */     GIR_EraseRootFromParent_Done,
     /* 1486762 */   // Label 20765: @1486762
     /* 1486762 */   GIM_Try, /*On fail goto*//*Label 20766*/ GIMT_Encode4(1486859), // Rule ID 24233 //
     /* 1486767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1486770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1486775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1486778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1486781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1486784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486817 */     // MIs[1] Operand 1
     /* 1486817 */     // No operand predicates
     /* 1486817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486821 */     // MIs[0] policy
     /* 1486821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486833 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1486836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486858 */     // GIR_Coverage, 24233,
     /* 1486858 */     GIR_EraseRootFromParent_Done,
     /* 1486859 */   // Label 20766: @1486859
     /* 1486859 */   GIM_Try, /*On fail goto*//*Label 20767*/ GIMT_Encode4(1486956), // Rule ID 24236 //
     /* 1486864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1486867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1486872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1486875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1486878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1486881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486914 */     // MIs[1] Operand 1
     /* 1486914 */     // No operand predicates
     /* 1486914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486918 */     // MIs[0] policy
     /* 1486918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486930 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1486933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486955 */     // GIR_Coverage, 24236,
     /* 1486955 */     GIR_EraseRootFromParent_Done,
     /* 1486956 */   // Label 20767: @1486956
     /* 1486956 */   GIM_Try, /*On fail goto*//*Label 20768*/ GIMT_Encode4(1487053), // Rule ID 24237 //
     /* 1486961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1486964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1486969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1486972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1486975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1486978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487011 */     // MIs[1] Operand 1
     /* 1487011 */     // No operand predicates
     /* 1487011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487015 */     // MIs[0] policy
     /* 1487015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487027 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1487030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1487049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487052 */     // GIR_Coverage, 24237,
     /* 1487052 */     GIR_EraseRootFromParent_Done,
     /* 1487053 */   // Label 20768: @1487053
     /* 1487053 */   GIM_Try, /*On fail goto*//*Label 20769*/ GIMT_Encode4(1487150), // Rule ID 24240 //
     /* 1487058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1487061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1487066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1487069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1487072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1487075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1487088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487108 */     // MIs[1] Operand 1
     /* 1487108 */     // No operand predicates
     /* 1487108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487112 */     // MIs[0] policy
     /* 1487112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487124 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1487127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1487146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487149 */     // GIR_Coverage, 24240,
     /* 1487149 */     GIR_EraseRootFromParent_Done,
     /* 1487150 */   // Label 20769: @1487150
     /* 1487150 */   GIM_Try, /*On fail goto*//*Label 20770*/ GIMT_Encode4(1487247), // Rule ID 24241 //
     /* 1487155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1487158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1487163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1487166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1487169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1487172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1487185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487205 */     // MIs[1] Operand 1
     /* 1487205 */     // No operand predicates
     /* 1487205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487209 */     // MIs[0] policy
     /* 1487209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487221 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1487224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1487243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487246 */     // GIR_Coverage, 24241,
     /* 1487246 */     GIR_EraseRootFromParent_Done,
     /* 1487247 */   // Label 20770: @1487247
     /* 1487247 */   GIM_Try, /*On fail goto*//*Label 20771*/ GIMT_Encode4(1487344), // Rule ID 24244 //
     /* 1487252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1487255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1487260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1487263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1487266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1487269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1487282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487302 */     // MIs[1] Operand 1
     /* 1487302 */     // No operand predicates
     /* 1487302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487306 */     // MIs[0] policy
     /* 1487306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487318 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1487321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1487340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487343 */     // GIR_Coverage, 24244,
     /* 1487343 */     GIR_EraseRootFromParent_Done,
     /* 1487344 */   // Label 20771: @1487344
     /* 1487344 */   GIM_Try, /*On fail goto*//*Label 20772*/ GIMT_Encode4(1487441), // Rule ID 24245 //
     /* 1487349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1487352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1487357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1487360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1487363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1487366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1487379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487399 */     // MIs[1] Operand 1
     /* 1487399 */     // No operand predicates
     /* 1487399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487403 */     // MIs[0] policy
     /* 1487403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487415 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1487418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1487437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487440 */     // GIR_Coverage, 24245,
     /* 1487440 */     GIR_EraseRootFromParent_Done,
     /* 1487441 */   // Label 20772: @1487441
     /* 1487441 */   GIM_Try, /*On fail goto*//*Label 20773*/ GIMT_Encode4(1487538), // Rule ID 24248 //
     /* 1487446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1487449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1487454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1487457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1487460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1487463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487496 */     // MIs[1] Operand 1
     /* 1487496 */     // No operand predicates
     /* 1487496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487500 */     // MIs[0] policy
     /* 1487500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487512 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1487515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1487534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487537 */     // GIR_Coverage, 24248,
     /* 1487537 */     GIR_EraseRootFromParent_Done,
     /* 1487538 */   // Label 20773: @1487538
     /* 1487538 */   GIM_Try, /*On fail goto*//*Label 20774*/ GIMT_Encode4(1487635), // Rule ID 24249 //
     /* 1487543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1487546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1487551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1487554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1487557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1487560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487593 */     // MIs[1] Operand 1
     /* 1487593 */     // No operand predicates
     /* 1487593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487597 */     // MIs[0] policy
     /* 1487597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487609 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1487612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1487631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487634 */     // GIR_Coverage, 24249,
     /* 1487634 */     GIR_EraseRootFromParent_Done,
     /* 1487635 */   // Label 20774: @1487635
     /* 1487635 */   GIM_Try, /*On fail goto*//*Label 20775*/ GIMT_Encode4(1487732), // Rule ID 24312 //
     /* 1487640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1487643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1487648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1487651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1487654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1487657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487690 */     // MIs[1] Operand 1
     /* 1487690 */     // No operand predicates
     /* 1487690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487694 */     // MIs[0] policy
     /* 1487694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487706 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1487709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487731 */     // GIR_Coverage, 24312,
     /* 1487731 */     GIR_EraseRootFromParent_Done,
     /* 1487732 */   // Label 20775: @1487732
     /* 1487732 */   GIM_Try, /*On fail goto*//*Label 20776*/ GIMT_Encode4(1487829), // Rule ID 24313 //
     /* 1487737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1487740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1487745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1487748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1487751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1487754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487787 */     // MIs[1] Operand 1
     /* 1487787 */     // No operand predicates
     /* 1487787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487791 */     // MIs[0] policy
     /* 1487791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487803 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1487806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487828 */     // GIR_Coverage, 24313,
     /* 1487828 */     GIR_EraseRootFromParent_Done,
     /* 1487829 */   // Label 20776: @1487829
     /* 1487829 */   GIM_Try, /*On fail goto*//*Label 20777*/ GIMT_Encode4(1487926), // Rule ID 24316 //
     /* 1487834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1487837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1487842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1487845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1487848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1487851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487884 */     // MIs[1] Operand 1
     /* 1487884 */     // No operand predicates
     /* 1487884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487888 */     // MIs[0] policy
     /* 1487888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487900 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1487903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487925 */     // GIR_Coverage, 24316,
     /* 1487925 */     GIR_EraseRootFromParent_Done,
     /* 1487926 */   // Label 20777: @1487926
     /* 1487926 */   GIM_Try, /*On fail goto*//*Label 20778*/ GIMT_Encode4(1488023), // Rule ID 24317 //
     /* 1487931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1487934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1487939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1487942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1487945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1487948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487981 */     // MIs[1] Operand 1
     /* 1487981 */     // No operand predicates
     /* 1487981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487985 */     // MIs[0] policy
     /* 1487985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487997 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1488000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1488004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488022 */     // GIR_Coverage, 24317,
     /* 1488022 */     GIR_EraseRootFromParent_Done,
     /* 1488023 */   // Label 20778: @1488023
     /* 1488023 */   GIM_Try, /*On fail goto*//*Label 20779*/ GIMT_Encode4(1488120), // Rule ID 24320 //
     /* 1488028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1488031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1488036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1488039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1488042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1488045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488078 */     // MIs[1] Operand 1
     /* 1488078 */     // No operand predicates
     /* 1488078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488082 */     // MIs[0] policy
     /* 1488082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488094 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1488097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1488101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488119 */     // GIR_Coverage, 24320,
     /* 1488119 */     GIR_EraseRootFromParent_Done,
     /* 1488120 */   // Label 20779: @1488120
     /* 1488120 */   GIM_Try, /*On fail goto*//*Label 20780*/ GIMT_Encode4(1488217), // Rule ID 24321 //
     /* 1488125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1488128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1488133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1488136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1488139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1488142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488175 */     // MIs[1] Operand 1
     /* 1488175 */     // No operand predicates
     /* 1488175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488179 */     // MIs[0] policy
     /* 1488179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488191 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1488194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1488198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488216 */     // GIR_Coverage, 24321,
     /* 1488216 */     GIR_EraseRootFromParent_Done,
     /* 1488217 */   // Label 20780: @1488217
     /* 1488217 */   GIM_Try, /*On fail goto*//*Label 20781*/ GIMT_Encode4(1488314), // Rule ID 24324 //
     /* 1488222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1488225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1488230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1488233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1488236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1488239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488272 */     // MIs[1] Operand 1
     /* 1488272 */     // No operand predicates
     /* 1488272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488276 */     // MIs[0] policy
     /* 1488276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488288 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1488291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1488295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488313 */     // GIR_Coverage, 24324,
     /* 1488313 */     GIR_EraseRootFromParent_Done,
     /* 1488314 */   // Label 20781: @1488314
     /* 1488314 */   GIM_Try, /*On fail goto*//*Label 20782*/ GIMT_Encode4(1488411), // Rule ID 24325 //
     /* 1488319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1488322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1488327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1488330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1488333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1488336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488369 */     // MIs[1] Operand 1
     /* 1488369 */     // No operand predicates
     /* 1488369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488373 */     // MIs[0] policy
     /* 1488373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488385 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1488388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1488392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488410 */     // GIR_Coverage, 24325,
     /* 1488410 */     GIR_EraseRootFromParent_Done,
     /* 1488411 */   // Label 20782: @1488411
     /* 1488411 */   GIM_Try, /*On fail goto*//*Label 20783*/ GIMT_Encode4(1488508), // Rule ID 24328 //
     /* 1488416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1488419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1488424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1488427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1488430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1488433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488466 */     // MIs[1] Operand 1
     /* 1488466 */     // No operand predicates
     /* 1488466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488470 */     // MIs[0] policy
     /* 1488470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488482 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1488485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1488489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488507 */     // GIR_Coverage, 24328,
     /* 1488507 */     GIR_EraseRootFromParent_Done,
     /* 1488508 */   // Label 20783: @1488508
     /* 1488508 */   GIM_Try, /*On fail goto*//*Label 20784*/ GIMT_Encode4(1488605), // Rule ID 24329 //
     /* 1488513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1488516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1488521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1488524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1488527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1488530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488563 */     // MIs[1] Operand 1
     /* 1488563 */     // No operand predicates
     /* 1488563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488567 */     // MIs[0] policy
     /* 1488567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488579 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1488582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1488586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488604 */     // GIR_Coverage, 24329,
     /* 1488604 */     GIR_EraseRootFromParent_Done,
     /* 1488605 */   // Label 20784: @1488605
     /* 1488605 */   GIM_Try, /*On fail goto*//*Label 20785*/ GIMT_Encode4(1488702), // Rule ID 24332 //
     /* 1488610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1488613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1488618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1488621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1488624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1488627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488660 */     // MIs[1] Operand 1
     /* 1488660 */     // No operand predicates
     /* 1488660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488664 */     // MIs[0] policy
     /* 1488664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488676 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1488679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1488683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1488698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488701 */     // GIR_Coverage, 24332,
     /* 1488701 */     GIR_EraseRootFromParent_Done,
     /* 1488702 */   // Label 20785: @1488702
     /* 1488702 */   GIM_Try, /*On fail goto*//*Label 20786*/ GIMT_Encode4(1488799), // Rule ID 24333 //
     /* 1488707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1488710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1488715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1488718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1488721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1488724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488757 */     // MIs[1] Operand 1
     /* 1488757 */     // No operand predicates
     /* 1488757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488761 */     // MIs[0] policy
     /* 1488761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488773 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1488776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1488780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1488795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488798 */     // GIR_Coverage, 24333,
     /* 1488798 */     GIR_EraseRootFromParent_Done,
     /* 1488799 */   // Label 20786: @1488799
     /* 1488799 */   GIM_Try, /*On fail goto*//*Label 20787*/ GIMT_Encode4(1488896), // Rule ID 24336 //
     /* 1488804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1488807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1488812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1488815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1488818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1488821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1488827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1488834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488854 */     // MIs[1] Operand 1
     /* 1488854 */     // No operand predicates
     /* 1488854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488858 */     // MIs[0] policy
     /* 1488858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488870 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1488873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1488877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488895 */     // GIR_Coverage, 24336,
     /* 1488895 */     GIR_EraseRootFromParent_Done,
     /* 1488896 */   // Label 20787: @1488896
     /* 1488896 */   GIM_Try, /*On fail goto*//*Label 20788*/ GIMT_Encode4(1488993), // Rule ID 24337 //
     /* 1488901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1488904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1488909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1488912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1488915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1488918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1488924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1488931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488951 */     // MIs[1] Operand 1
     /* 1488951 */     // No operand predicates
     /* 1488951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488955 */     // MIs[0] policy
     /* 1488955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488967 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1488970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1488974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488992 */     // GIR_Coverage, 24337,
     /* 1488992 */     GIR_EraseRootFromParent_Done,
     /* 1488993 */   // Label 20788: @1488993
     /* 1488993 */   GIM_Try, /*On fail goto*//*Label 20789*/ GIMT_Encode4(1489090), // Rule ID 24340 //
     /* 1488998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1489001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1489006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1489009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1489012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1489015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489048 */     // MIs[1] Operand 1
     /* 1489048 */     // No operand predicates
     /* 1489048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489052 */     // MIs[0] policy
     /* 1489052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489064 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1489067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1489071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489089 */     // GIR_Coverage, 24340,
     /* 1489089 */     GIR_EraseRootFromParent_Done,
     /* 1489090 */   // Label 20789: @1489090
     /* 1489090 */   GIM_Try, /*On fail goto*//*Label 20790*/ GIMT_Encode4(1489187), // Rule ID 24341 //
     /* 1489095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1489098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1489103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1489106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1489109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1489112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489145 */     // MIs[1] Operand 1
     /* 1489145 */     // No operand predicates
     /* 1489145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489149 */     // MIs[0] policy
     /* 1489149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489161 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1489164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1489168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489186 */     // GIR_Coverage, 24341,
     /* 1489186 */     GIR_EraseRootFromParent_Done,
     /* 1489187 */   // Label 20790: @1489187
     /* 1489187 */   GIM_Try, /*On fail goto*//*Label 20791*/ GIMT_Encode4(1489284), // Rule ID 24344 //
     /* 1489192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1489195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1489200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1489203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1489206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1489209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1489215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489242 */     // MIs[1] Operand 1
     /* 1489242 */     // No operand predicates
     /* 1489242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489246 */     // MIs[0] policy
     /* 1489246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489258 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1489261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1489265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489283 */     // GIR_Coverage, 24344,
     /* 1489283 */     GIR_EraseRootFromParent_Done,
     /* 1489284 */   // Label 20791: @1489284
     /* 1489284 */   GIM_Try, /*On fail goto*//*Label 20792*/ GIMT_Encode4(1489381), // Rule ID 24345 //
     /* 1489289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1489292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1489297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1489300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1489303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1489306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1489312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489339 */     // MIs[1] Operand 1
     /* 1489339 */     // No operand predicates
     /* 1489339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489343 */     // MIs[0] policy
     /* 1489343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489355 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1489358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1489362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489380 */     // GIR_Coverage, 24345,
     /* 1489380 */     GIR_EraseRootFromParent_Done,
     /* 1489381 */   // Label 20792: @1489381
     /* 1489381 */   GIM_Try, /*On fail goto*//*Label 20793*/ GIMT_Encode4(1489478), // Rule ID 24348 //
     /* 1489386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1489389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1489394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1489397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1489400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1489403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1489409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489436 */     // MIs[1] Operand 1
     /* 1489436 */     // No operand predicates
     /* 1489436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489440 */     // MIs[0] policy
     /* 1489440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489452 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1489455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1489459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489477 */     // GIR_Coverage, 24348,
     /* 1489477 */     GIR_EraseRootFromParent_Done,
     /* 1489478 */   // Label 20793: @1489478
     /* 1489478 */   GIM_Try, /*On fail goto*//*Label 20794*/ GIMT_Encode4(1489575), // Rule ID 24349 //
     /* 1489483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1489486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1489491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1489494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1489497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1489500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1489506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489533 */     // MIs[1] Operand 1
     /* 1489533 */     // No operand predicates
     /* 1489533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489537 */     // MIs[0] policy
     /* 1489537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489549 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1489552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1489556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489574 */     // GIR_Coverage, 24349,
     /* 1489574 */     GIR_EraseRootFromParent_Done,
     /* 1489575 */   // Label 20794: @1489575
     /* 1489575 */   GIM_Try, /*On fail goto*//*Label 20795*/ GIMT_Encode4(1489672), // Rule ID 24352 //
     /* 1489580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1489583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1489588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1489591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1489594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1489597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489630 */     // MIs[1] Operand 1
     /* 1489630 */     // No operand predicates
     /* 1489630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489634 */     // MIs[0] policy
     /* 1489634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489646 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1489649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1489653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489671 */     // GIR_Coverage, 24352,
     /* 1489671 */     GIR_EraseRootFromParent_Done,
     /* 1489672 */   // Label 20795: @1489672
     /* 1489672 */   GIM_Try, /*On fail goto*//*Label 20796*/ GIMT_Encode4(1489769), // Rule ID 24353 //
     /* 1489677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1489680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1489685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1489688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1489691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1489694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489727 */     // MIs[1] Operand 1
     /* 1489727 */     // No operand predicates
     /* 1489727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489731 */     // MIs[0] policy
     /* 1489731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489743 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1489746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1489750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489768 */     // GIR_Coverage, 24353,
     /* 1489768 */     GIR_EraseRootFromParent_Done,
     /* 1489769 */   // Label 20796: @1489769
     /* 1489769 */   GIM_Try, /*On fail goto*//*Label 20797*/ GIMT_Encode4(1489866), // Rule ID 24356 //
     /* 1489774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1489777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1489782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1489785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1489788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1489791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489824 */     // MIs[1] Operand 1
     /* 1489824 */     // No operand predicates
     /* 1489824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489828 */     // MIs[0] policy
     /* 1489828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489840 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1489843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1489847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489865 */     // GIR_Coverage, 24356,
     /* 1489865 */     GIR_EraseRootFromParent_Done,
     /* 1489866 */   // Label 20797: @1489866
     /* 1489866 */   GIM_Try, /*On fail goto*//*Label 20798*/ GIMT_Encode4(1489963), // Rule ID 24357 //
     /* 1489871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1489874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1489879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1489882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1489885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1489888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489921 */     // MIs[1] Operand 1
     /* 1489921 */     // No operand predicates
     /* 1489921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489925 */     // MIs[0] policy
     /* 1489925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489937 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1489940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1489944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489962 */     // GIR_Coverage, 24357,
     /* 1489962 */     GIR_EraseRootFromParent_Done,
     /* 1489963 */   // Label 20798: @1489963
     /* 1489963 */   GIM_Try, /*On fail goto*//*Label 20799*/ GIMT_Encode4(1490060), // Rule ID 24360 //
     /* 1489968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1489971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1489976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1489979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1489982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1489985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1489991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490018 */     // MIs[1] Operand 1
     /* 1490018 */     // No operand predicates
     /* 1490018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490022 */     // MIs[0] policy
     /* 1490022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490034 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1490037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1490041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490059 */     // GIR_Coverage, 24360,
     /* 1490059 */     GIR_EraseRootFromParent_Done,
     /* 1490060 */   // Label 20799: @1490060
     /* 1490060 */   GIM_Try, /*On fail goto*//*Label 20800*/ GIMT_Encode4(1490157), // Rule ID 24361 //
     /* 1490065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1490068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1490073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1490076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1490079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1490082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490115 */     // MIs[1] Operand 1
     /* 1490115 */     // No operand predicates
     /* 1490115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490119 */     // MIs[0] policy
     /* 1490119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490131 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1490134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1490138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490156 */     // GIR_Coverage, 24361,
     /* 1490156 */     GIR_EraseRootFromParent_Done,
     /* 1490157 */   // Label 20800: @1490157
     /* 1490157 */   GIM_Try, /*On fail goto*//*Label 20801*/ GIMT_Encode4(1490254), // Rule ID 24364 //
     /* 1490162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1490165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1490170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1490173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1490176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1490179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490212 */     // MIs[1] Operand 1
     /* 1490212 */     // No operand predicates
     /* 1490212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490216 */     // MIs[0] policy
     /* 1490216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490228 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1490231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1490235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490253 */     // GIR_Coverage, 24364,
     /* 1490253 */     GIR_EraseRootFromParent_Done,
     /* 1490254 */   // Label 20801: @1490254
     /* 1490254 */   GIM_Try, /*On fail goto*//*Label 20802*/ GIMT_Encode4(1490351), // Rule ID 24365 //
     /* 1490259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1490262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1490267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1490270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1490273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1490276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490309 */     // MIs[1] Operand 1
     /* 1490309 */     // No operand predicates
     /* 1490309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490313 */     // MIs[0] policy
     /* 1490313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490325 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1490328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1490332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490350 */     // GIR_Coverage, 24365,
     /* 1490350 */     GIR_EraseRootFromParent_Done,
     /* 1490351 */   // Label 20802: @1490351
     /* 1490351 */   GIM_Try, /*On fail goto*//*Label 20803*/ GIMT_Encode4(1490448), // Rule ID 24368 //
     /* 1490356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1490359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1490364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1490367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1490370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1490373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490406 */     // MIs[1] Operand 1
     /* 1490406 */     // No operand predicates
     /* 1490406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490410 */     // MIs[0] policy
     /* 1490410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490422 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1490425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1490429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490447 */     // GIR_Coverage, 24368,
     /* 1490447 */     GIR_EraseRootFromParent_Done,
     /* 1490448 */   // Label 20803: @1490448
     /* 1490448 */   GIM_Try, /*On fail goto*//*Label 20804*/ GIMT_Encode4(1490545), // Rule ID 24369 //
     /* 1490453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1490456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1490461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1490464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1490467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1490470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490503 */     // MIs[1] Operand 1
     /* 1490503 */     // No operand predicates
     /* 1490503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490507 */     // MIs[0] policy
     /* 1490507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490519 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1490522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1490526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490544 */     // GIR_Coverage, 24369,
     /* 1490544 */     GIR_EraseRootFromParent_Done,
     /* 1490545 */   // Label 20804: @1490545
     /* 1490545 */   GIM_Try, /*On fail goto*//*Label 20805*/ GIMT_Encode4(1490642), // Rule ID 24668 //
     /* 1490550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1490561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1490564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1490567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1490573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490600 */     // MIs[1] Operand 1
     /* 1490600 */     // No operand predicates
     /* 1490600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490604 */     // MIs[0] policy
     /* 1490604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490616 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1490619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1490638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490641 */     // GIR_Coverage, 24668,
     /* 1490641 */     GIR_EraseRootFromParent_Done,
     /* 1490642 */   // Label 20805: @1490642
     /* 1490642 */   GIM_Try, /*On fail goto*//*Label 20806*/ GIMT_Encode4(1490739), // Rule ID 24669 //
     /* 1490647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1490658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1490661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1490664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1490670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490697 */     // MIs[1] Operand 1
     /* 1490697 */     // No operand predicates
     /* 1490697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490701 */     // MIs[0] policy
     /* 1490701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490713 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1490716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1490735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490738 */     // GIR_Coverage, 24669,
     /* 1490738 */     GIR_EraseRootFromParent_Done,
     /* 1490739 */   // Label 20806: @1490739
     /* 1490739 */   GIM_Try, /*On fail goto*//*Label 20807*/ GIMT_Encode4(1490836), // Rule ID 24672 //
     /* 1490744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1490755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1490758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1490761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490794 */     // MIs[1] Operand 1
     /* 1490794 */     // No operand predicates
     /* 1490794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490798 */     // MIs[0] policy
     /* 1490798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490810 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1490813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1490832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490835 */     // GIR_Coverage, 24672,
     /* 1490835 */     GIR_EraseRootFromParent_Done,
     /* 1490836 */   // Label 20807: @1490836
     /* 1490836 */   GIM_Try, /*On fail goto*//*Label 20808*/ GIMT_Encode4(1490933), // Rule ID 24673 //
     /* 1490841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1490852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1490855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1490858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490891 */     // MIs[1] Operand 1
     /* 1490891 */     // No operand predicates
     /* 1490891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490895 */     // MIs[0] policy
     /* 1490895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490907 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1490910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1490929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490932 */     // GIR_Coverage, 24673,
     /* 1490932 */     GIR_EraseRootFromParent_Done,
     /* 1490933 */   // Label 20808: @1490933
     /* 1490933 */   GIM_Try, /*On fail goto*//*Label 20809*/ GIMT_Encode4(1491030), // Rule ID 24676 //
     /* 1490938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1490949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1490952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1490955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490988 */     // MIs[1] Operand 1
     /* 1490988 */     // No operand predicates
     /* 1490988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490992 */     // MIs[0] policy
     /* 1490992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491004 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491029 */     // GIR_Coverage, 24676,
     /* 1491029 */     GIR_EraseRootFromParent_Done,
     /* 1491030 */   // Label 20809: @1491030
     /* 1491030 */   GIM_Try, /*On fail goto*//*Label 20810*/ GIMT_Encode4(1491127), // Rule ID 24677 //
     /* 1491035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1491046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1491049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1491052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1491058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491085 */     // MIs[1] Operand 1
     /* 1491085 */     // No operand predicates
     /* 1491085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491089 */     // MIs[0] policy
     /* 1491089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491101 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491126 */     // GIR_Coverage, 24677,
     /* 1491126 */     GIR_EraseRootFromParent_Done,
     /* 1491127 */   // Label 20810: @1491127
     /* 1491127 */   GIM_Try, /*On fail goto*//*Label 20811*/ GIMT_Encode4(1491224), // Rule ID 24680 //
     /* 1491132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1491143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1491146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1491149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491182 */     // MIs[1] Operand 1
     /* 1491182 */     // No operand predicates
     /* 1491182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491186 */     // MIs[0] policy
     /* 1491186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491198 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1491201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491223 */     // GIR_Coverage, 24680,
     /* 1491223 */     GIR_EraseRootFromParent_Done,
     /* 1491224 */   // Label 20811: @1491224
     /* 1491224 */   GIM_Try, /*On fail goto*//*Label 20812*/ GIMT_Encode4(1491321), // Rule ID 24681 //
     /* 1491229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1491240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1491243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1491246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491279 */     // MIs[1] Operand 1
     /* 1491279 */     // No operand predicates
     /* 1491279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491283 */     // MIs[0] policy
     /* 1491283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491295 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1491298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491320 */     // GIR_Coverage, 24681,
     /* 1491320 */     GIR_EraseRootFromParent_Done,
     /* 1491321 */   // Label 20812: @1491321
     /* 1491321 */   GIM_Try, /*On fail goto*//*Label 20813*/ GIMT_Encode4(1491418), // Rule ID 24684 //
     /* 1491326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1491337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1491340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1491343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491376 */     // MIs[1] Operand 1
     /* 1491376 */     // No operand predicates
     /* 1491376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491380 */     // MIs[0] policy
     /* 1491380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491392 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491417 */     // GIR_Coverage, 24684,
     /* 1491417 */     GIR_EraseRootFromParent_Done,
     /* 1491418 */   // Label 20813: @1491418
     /* 1491418 */   GIM_Try, /*On fail goto*//*Label 20814*/ GIMT_Encode4(1491515), // Rule ID 24685 //
     /* 1491423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1491434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1491437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1491440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491473 */     // MIs[1] Operand 1
     /* 1491473 */     // No operand predicates
     /* 1491473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491477 */     // MIs[0] policy
     /* 1491477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491489 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491514 */     // GIR_Coverage, 24685,
     /* 1491514 */     GIR_EraseRootFromParent_Done,
     /* 1491515 */   // Label 20814: @1491515
     /* 1491515 */   GIM_Try, /*On fail goto*//*Label 20815*/ GIMT_Encode4(1491612), // Rule ID 24688 //
     /* 1491520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1491531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1491534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1491537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491570 */     // MIs[1] Operand 1
     /* 1491570 */     // No operand predicates
     /* 1491570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491574 */     // MIs[0] policy
     /* 1491574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491611 */     // GIR_Coverage, 24688,
     /* 1491611 */     GIR_EraseRootFromParent_Done,
     /* 1491612 */   // Label 20815: @1491612
     /* 1491612 */   GIM_Try, /*On fail goto*//*Label 20816*/ GIMT_Encode4(1491709), // Rule ID 24689 //
     /* 1491617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1491628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1491631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1491634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491667 */     // MIs[1] Operand 1
     /* 1491667 */     // No operand predicates
     /* 1491667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491671 */     // MIs[0] policy
     /* 1491671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491683 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491708 */     // GIR_Coverage, 24689,
     /* 1491708 */     GIR_EraseRootFromParent_Done,
     /* 1491709 */   // Label 20816: @1491709
     /* 1491709 */   GIM_Try, /*On fail goto*//*Label 20817*/ GIMT_Encode4(1491806), // Rule ID 24692 //
     /* 1491714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1491725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1491728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1491731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1491737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491764 */     // MIs[1] Operand 1
     /* 1491764 */     // No operand predicates
     /* 1491764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491768 */     // MIs[0] policy
     /* 1491768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491780 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1491783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491805 */     // GIR_Coverage, 24692,
     /* 1491805 */     GIR_EraseRootFromParent_Done,
     /* 1491806 */   // Label 20817: @1491806
     /* 1491806 */   GIM_Try, /*On fail goto*//*Label 20818*/ GIMT_Encode4(1491903), // Rule ID 24693 //
     /* 1491811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1491822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1491825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1491828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1491834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491861 */     // MIs[1] Operand 1
     /* 1491861 */     // No operand predicates
     /* 1491861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491865 */     // MIs[0] policy
     /* 1491865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491877 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1491880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491902 */     // GIR_Coverage, 24693,
     /* 1491902 */     GIR_EraseRootFromParent_Done,
     /* 1491903 */   // Label 20818: @1491903
     /* 1491903 */   GIM_Try, /*On fail goto*//*Label 20819*/ GIMT_Encode4(1492000), // Rule ID 24696 //
     /* 1491908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1491919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1491922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1491925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1491931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491958 */     // MIs[1] Operand 1
     /* 1491958 */     // No operand predicates
     /* 1491958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491962 */     // MIs[0] policy
     /* 1491962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491974 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1491977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491999 */     // GIR_Coverage, 24696,
     /* 1491999 */     GIR_EraseRootFromParent_Done,
     /* 1492000 */   // Label 20819: @1492000
     /* 1492000 */   GIM_Try, /*On fail goto*//*Label 20820*/ GIMT_Encode4(1492097), // Rule ID 24697 //
     /* 1492005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1492016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1492019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1492022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492055 */     // MIs[1] Operand 1
     /* 1492055 */     // No operand predicates
     /* 1492055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492059 */     // MIs[0] policy
     /* 1492059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492071 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492096 */     // GIR_Coverage, 24697,
     /* 1492096 */     GIR_EraseRootFromParent_Done,
     /* 1492097 */   // Label 20820: @1492097
     /* 1492097 */   GIM_Try, /*On fail goto*//*Label 20821*/ GIMT_Encode4(1492194), // Rule ID 24700 //
     /* 1492102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1492113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1492116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1492119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1492125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492152 */     // MIs[1] Operand 1
     /* 1492152 */     // No operand predicates
     /* 1492152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492156 */     // MIs[0] policy
     /* 1492156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492168 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492193 */     // GIR_Coverage, 24700,
     /* 1492193 */     GIR_EraseRootFromParent_Done,
     /* 1492194 */   // Label 20821: @1492194
     /* 1492194 */   GIM_Try, /*On fail goto*//*Label 20822*/ GIMT_Encode4(1492291), // Rule ID 24701 //
     /* 1492199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1492210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1492213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1492216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1492222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492249 */     // MIs[1] Operand 1
     /* 1492249 */     // No operand predicates
     /* 1492249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492253 */     // MIs[0] policy
     /* 1492253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492265 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492290 */     // GIR_Coverage, 24701,
     /* 1492290 */     GIR_EraseRootFromParent_Done,
     /* 1492291 */   // Label 20822: @1492291
     /* 1492291 */   GIM_Try, /*On fail goto*//*Label 20823*/ GIMT_Encode4(1492388), // Rule ID 24704 //
     /* 1492296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1492299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1492307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1492310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1492313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1492319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492342 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492346 */     // MIs[1] Operand 1
     /* 1492346 */     // No operand predicates
     /* 1492346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492350 */     // MIs[0] policy
     /* 1492350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492362 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492387 */     // GIR_Coverage, 24704,
     /* 1492387 */     GIR_EraseRootFromParent_Done,
     /* 1492388 */   // Label 20823: @1492388
     /* 1492388 */   GIM_Try, /*On fail goto*//*Label 20824*/ GIMT_Encode4(1492485), // Rule ID 24705 //
     /* 1492393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1492396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1492404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1492407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1492410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1492416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492443 */     // MIs[1] Operand 1
     /* 1492443 */     // No operand predicates
     /* 1492443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492447 */     // MIs[0] policy
     /* 1492447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492459 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492484 */     // GIR_Coverage, 24705,
     /* 1492484 */     GIR_EraseRootFromParent_Done,
     /* 1492485 */   // Label 20824: @1492485
     /* 1492485 */   GIM_Try, /*On fail goto*//*Label 20825*/ GIMT_Encode4(1492582), // Rule ID 24708 //
     /* 1492490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1492501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1492504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1492507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492540 */     // MIs[1] Operand 1
     /* 1492540 */     // No operand predicates
     /* 1492540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492544 */     // MIs[0] policy
     /* 1492544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492556 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492581 */     // GIR_Coverage, 24708,
     /* 1492581 */     GIR_EraseRootFromParent_Done,
     /* 1492582 */   // Label 20825: @1492582
     /* 1492582 */   GIM_Try, /*On fail goto*//*Label 20826*/ GIMT_Encode4(1492679), // Rule ID 24709 //
     /* 1492587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1492598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1492601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1492604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492637 */     // MIs[1] Operand 1
     /* 1492637 */     // No operand predicates
     /* 1492637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492641 */     // MIs[0] policy
     /* 1492641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492653 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492678 */     // GIR_Coverage, 24709,
     /* 1492678 */     GIR_EraseRootFromParent_Done,
     /* 1492679 */   // Label 20826: @1492679
     /* 1492679 */   GIM_Try, /*On fail goto*//*Label 20827*/ GIMT_Encode4(1492776), // Rule ID 24712 //
     /* 1492684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1492695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1492698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1492701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1492707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492734 */     // MIs[1] Operand 1
     /* 1492734 */     // No operand predicates
     /* 1492734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492738 */     // MIs[0] policy
     /* 1492738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492750 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1492753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492775 */     // GIR_Coverage, 24712,
     /* 1492775 */     GIR_EraseRootFromParent_Done,
     /* 1492776 */   // Label 20827: @1492776
     /* 1492776 */   GIM_Try, /*On fail goto*//*Label 20828*/ GIMT_Encode4(1492873), // Rule ID 24713 //
     /* 1492781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1492792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1492795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1492798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1492804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492831 */     // MIs[1] Operand 1
     /* 1492831 */     // No operand predicates
     /* 1492831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492835 */     // MIs[0] policy
     /* 1492835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492847 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1492850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492872 */     // GIR_Coverage, 24713,
     /* 1492872 */     GIR_EraseRootFromParent_Done,
     /* 1492873 */   // Label 20828: @1492873
     /* 1492873 */   GIM_Try, /*On fail goto*//*Label 20829*/ GIMT_Encode4(1492970), // Rule ID 24716 //
     /* 1492878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1492889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1492892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1492895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1492901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1492908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492928 */     // MIs[1] Operand 1
     /* 1492928 */     // No operand predicates
     /* 1492928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492932 */     // MIs[0] policy
     /* 1492932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492944 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1492947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492969 */     // GIR_Coverage, 24716,
     /* 1492969 */     GIR_EraseRootFromParent_Done,
     /* 1492970 */   // Label 20829: @1492970
     /* 1492970 */   GIM_Try, /*On fail goto*//*Label 20830*/ GIMT_Encode4(1493067), // Rule ID 24717 //
     /* 1492975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1492986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1492989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1492992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1492998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493025 */     // MIs[1] Operand 1
     /* 1493025 */     // No operand predicates
     /* 1493025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493029 */     // MIs[0] policy
     /* 1493029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493041 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1493063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493066 */     // GIR_Coverage, 24717,
     /* 1493066 */     GIR_EraseRootFromParent_Done,
     /* 1493067 */   // Label 20830: @1493067
     /* 1493067 */   GIM_Try, /*On fail goto*//*Label 20831*/ GIMT_Encode4(1493164), // Rule ID 24720 //
     /* 1493072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1493083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1493086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1493089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493122 */     // MIs[1] Operand 1
     /* 1493122 */     // No operand predicates
     /* 1493122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493126 */     // MIs[0] policy
     /* 1493126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493138 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493163 */     // GIR_Coverage, 24720,
     /* 1493163 */     GIR_EraseRootFromParent_Done,
     /* 1493164 */   // Label 20831: @1493164
     /* 1493164 */   GIM_Try, /*On fail goto*//*Label 20832*/ GIMT_Encode4(1493261), // Rule ID 24721 //
     /* 1493169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1493180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1493183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1493186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493219 */     // MIs[1] Operand 1
     /* 1493219 */     // No operand predicates
     /* 1493219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493223 */     // MIs[0] policy
     /* 1493223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493235 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493260 */     // GIR_Coverage, 24721,
     /* 1493260 */     GIR_EraseRootFromParent_Done,
     /* 1493261 */   // Label 20832: @1493261
     /* 1493261 */   GIM_Try, /*On fail goto*//*Label 20833*/ GIMT_Encode4(1493358), // Rule ID 24724 //
     /* 1493266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1493277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1493280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1493283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493316 */     // MIs[1] Operand 1
     /* 1493316 */     // No operand predicates
     /* 1493316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493320 */     // MIs[0] policy
     /* 1493320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493332 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1493335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493357 */     // GIR_Coverage, 24724,
     /* 1493357 */     GIR_EraseRootFromParent_Done,
     /* 1493358 */   // Label 20833: @1493358
     /* 1493358 */   GIM_Try, /*On fail goto*//*Label 20834*/ GIMT_Encode4(1493455), // Rule ID 24725 //
     /* 1493363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1493374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1493377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1493380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493413 */     // MIs[1] Operand 1
     /* 1493413 */     // No operand predicates
     /* 1493413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493417 */     // MIs[0] policy
     /* 1493417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493429 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1493432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493454 */     // GIR_Coverage, 24725,
     /* 1493454 */     GIR_EraseRootFromParent_Done,
     /* 1493455 */   // Label 20834: @1493455
     /* 1493455 */   GIM_Try, /*On fail goto*//*Label 20835*/ GIMT_Encode4(1493552), // Rule ID 24728 //
     /* 1493460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1493471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1493474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1493477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1493483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493510 */     // MIs[1] Operand 1
     /* 1493510 */     // No operand predicates
     /* 1493510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493514 */     // MIs[0] policy
     /* 1493514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493526 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493551 */     // GIR_Coverage, 24728,
     /* 1493551 */     GIR_EraseRootFromParent_Done,
     /* 1493552 */   // Label 20835: @1493552
     /* 1493552 */   GIM_Try, /*On fail goto*//*Label 20836*/ GIMT_Encode4(1493649), // Rule ID 24729 //
     /* 1493557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1493568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1493571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1493574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1493580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493607 */     // MIs[1] Operand 1
     /* 1493607 */     // No operand predicates
     /* 1493607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493611 */     // MIs[0] policy
     /* 1493611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493623 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493648 */     // GIR_Coverage, 24729,
     /* 1493648 */     GIR_EraseRootFromParent_Done,
     /* 1493649 */   // Label 20836: @1493649
     /* 1493649 */   GIM_Try, /*On fail goto*//*Label 20837*/ GIMT_Encode4(1493746), // Rule ID 24732 //
     /* 1493654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1493665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1493668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1493671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493704 */     // MIs[1] Operand 1
     /* 1493704 */     // No operand predicates
     /* 1493704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493708 */     // MIs[0] policy
     /* 1493708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493720 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493745 */     // GIR_Coverage, 24732,
     /* 1493745 */     GIR_EraseRootFromParent_Done,
     /* 1493746 */   // Label 20837: @1493746
     /* 1493746 */   GIM_Try, /*On fail goto*//*Label 20838*/ GIMT_Encode4(1493843), // Rule ID 24733 //
     /* 1493751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1493762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1493765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1493768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493801 */     // MIs[1] Operand 1
     /* 1493801 */     // No operand predicates
     /* 1493801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493805 */     // MIs[0] policy
     /* 1493805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493817 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493842 */     // GIR_Coverage, 24733,
     /* 1493842 */     GIR_EraseRootFromParent_Done,
     /* 1493843 */   // Label 20838: @1493843
     /* 1493843 */   GIM_Try, /*On fail goto*//*Label 20839*/ GIMT_Encode4(1493940), // Rule ID 24736 //
     /* 1493848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1493859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1493862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1493865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493898 */     // MIs[1] Operand 1
     /* 1493898 */     // No operand predicates
     /* 1493898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493902 */     // MIs[0] policy
     /* 1493902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1493917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493939 */     // GIR_Coverage, 24736,
     /* 1493939 */     GIR_EraseRootFromParent_Done,
     /* 1493940 */   // Label 20839: @1493940
     /* 1493940 */   GIM_Try, /*On fail goto*//*Label 20840*/ GIMT_Encode4(1494037), // Rule ID 24737 //
     /* 1493945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1493956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1493959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1493962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493995 */     // MIs[1] Operand 1
     /* 1493995 */     // No operand predicates
     /* 1493995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493999 */     // MIs[0] policy
     /* 1493999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494011 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1494014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1494033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494036 */     // GIR_Coverage, 24737,
     /* 1494036 */     GIR_EraseRootFromParent_Done,
     /* 1494037 */   // Label 20840: @1494037
     /* 1494037 */   GIM_Try, /*On fail goto*//*Label 20841*/ GIMT_Encode4(1494134), // Rule ID 24740 //
     /* 1494042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1494045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1494053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1494056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1494059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1494065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494092 */     // MIs[1] Operand 1
     /* 1494092 */     // No operand predicates
     /* 1494092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494096 */     // MIs[0] policy
     /* 1494096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494108 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1494111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1494130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494133 */     // GIR_Coverage, 24740,
     /* 1494133 */     GIR_EraseRootFromParent_Done,
     /* 1494134 */   // Label 20841: @1494134
     /* 1494134 */   GIM_Try, /*On fail goto*//*Label 20842*/ GIMT_Encode4(1494231), // Rule ID 24741 //
     /* 1494139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1494142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1494150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1494153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1494156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1494162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494189 */     // MIs[1] Operand 1
     /* 1494189 */     // No operand predicates
     /* 1494189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494193 */     // MIs[0] policy
     /* 1494193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494205 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1494208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1494227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494230 */     // GIR_Coverage, 24741,
     /* 1494230 */     GIR_EraseRootFromParent_Done,
     /* 1494231 */   // Label 20842: @1494231
     /* 1494231 */   GIM_Try, /*On fail goto*//*Label 20843*/ GIMT_Encode4(1494328), // Rule ID 24744 //
     /* 1494236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1494239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1494247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1494250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1494253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1494266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494286 */     // MIs[1] Operand 1
     /* 1494286 */     // No operand predicates
     /* 1494286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494290 */     // MIs[0] policy
     /* 1494290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1494305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494327 */     // GIR_Coverage, 24744,
     /* 1494327 */     GIR_EraseRootFromParent_Done,
     /* 1494328 */   // Label 20843: @1494328
     /* 1494328 */   GIM_Try, /*On fail goto*//*Label 20844*/ GIMT_Encode4(1494425), // Rule ID 24745 //
     /* 1494333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1494336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1494344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1494347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1494350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1494363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494383 */     // MIs[1] Operand 1
     /* 1494383 */     // No operand predicates
     /* 1494383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494387 */     // MIs[0] policy
     /* 1494387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494399 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1494402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494424 */     // GIR_Coverage, 24745,
     /* 1494424 */     GIR_EraseRootFromParent_Done,
     /* 1494425 */   // Label 20844: @1494425
     /* 1494425 */   GIM_Try, /*On fail goto*//*Label 20845*/ GIMT_Encode4(1494522), // Rule ID 24748 //
     /* 1494430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1494433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1494441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1494444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1494447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494480 */     // MIs[1] Operand 1
     /* 1494480 */     // No operand predicates
     /* 1494480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494484 */     // MIs[0] policy
     /* 1494484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1494499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494521 */     // GIR_Coverage, 24748,
     /* 1494521 */     GIR_EraseRootFromParent_Done,
     /* 1494522 */   // Label 20845: @1494522
     /* 1494522 */   GIM_Try, /*On fail goto*//*Label 20846*/ GIMT_Encode4(1494619), // Rule ID 24749 //
     /* 1494527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1494530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1494538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1494541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1494544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494577 */     // MIs[1] Operand 1
     /* 1494577 */     // No operand predicates
     /* 1494577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494581 */     // MIs[0] policy
     /* 1494581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494593 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1494596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494618 */     // GIR_Coverage, 24749,
     /* 1494618 */     GIR_EraseRootFromParent_Done,
     /* 1494619 */   // Label 20846: @1494619
     /* 1494619 */   GIM_Try, /*On fail goto*//*Label 20847*/ GIMT_Encode4(1494716), // Rule ID 24752 //
     /* 1494624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1494627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1494635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1494638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1494641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494674 */     // MIs[1] Operand 1
     /* 1494674 */     // No operand predicates
     /* 1494674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494678 */     // MIs[0] policy
     /* 1494678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494690 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1494693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494715 */     // GIR_Coverage, 24752,
     /* 1494715 */     GIR_EraseRootFromParent_Done,
     /* 1494716 */   // Label 20847: @1494716
     /* 1494716 */   GIM_Try, /*On fail goto*//*Label 20848*/ GIMT_Encode4(1494813), // Rule ID 24753 //
     /* 1494721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1494724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1494732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1494735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1494738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494771 */     // MIs[1] Operand 1
     /* 1494771 */     // No operand predicates
     /* 1494771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494775 */     // MIs[0] policy
     /* 1494775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494787 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1494790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494812 */     // GIR_Coverage, 24753,
     /* 1494812 */     GIR_EraseRootFromParent_Done,
     /* 1494813 */   // Label 20848: @1494813
     /* 1494813 */   GIM_Try, /*On fail goto*//*Label 20849*/ GIMT_Encode4(1494910), // Rule ID 24912 //
     /* 1494818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1494821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1494829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1494832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1494835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1494841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494868 */     // MIs[1] Operand 1
     /* 1494868 */     // No operand predicates
     /* 1494868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494872 */     // MIs[0] policy
     /* 1494872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494884 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1494887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1494906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494909 */     // GIR_Coverage, 24912,
     /* 1494909 */     GIR_EraseRootFromParent_Done,
     /* 1494910 */   // Label 20849: @1494910
     /* 1494910 */   GIM_Try, /*On fail goto*//*Label 20850*/ GIMT_Encode4(1495007), // Rule ID 24913 //
     /* 1494915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1494918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1494926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1494929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1494932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1494938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494965 */     // MIs[1] Operand 1
     /* 1494965 */     // No operand predicates
     /* 1494965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494969 */     // MIs[0] policy
     /* 1494969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494981 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1494984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495006 */     // GIR_Coverage, 24913,
     /* 1495006 */     GIR_EraseRootFromParent_Done,
     /* 1495007 */   // Label 20850: @1495007
     /* 1495007 */   GIM_Try, /*On fail goto*//*Label 20851*/ GIMT_Encode4(1495104), // Rule ID 24916 //
     /* 1495012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1495015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1495020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1495023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1495026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1495029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1495035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495062 */     // MIs[1] Operand 1
     /* 1495062 */     // No operand predicates
     /* 1495062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495066 */     // MIs[0] policy
     /* 1495066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495078 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1495081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495103 */     // GIR_Coverage, 24916,
     /* 1495103 */     GIR_EraseRootFromParent_Done,
     /* 1495104 */   // Label 20851: @1495104
     /* 1495104 */   GIM_Try, /*On fail goto*//*Label 20852*/ GIMT_Encode4(1495201), // Rule ID 24917 //
     /* 1495109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1495112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1495117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1495120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1495123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1495126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1495132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495159 */     // MIs[1] Operand 1
     /* 1495159 */     // No operand predicates
     /* 1495159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495163 */     // MIs[0] policy
     /* 1495163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495175 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1495178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495200 */     // GIR_Coverage, 24917,
     /* 1495200 */     GIR_EraseRootFromParent_Done,
     /* 1495201 */   // Label 20852: @1495201
     /* 1495201 */   GIM_Try, /*On fail goto*//*Label 20853*/ GIMT_Encode4(1495298), // Rule ID 24920 //
     /* 1495206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1495209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1495214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1495217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1495220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1495223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495256 */     // MIs[1] Operand 1
     /* 1495256 */     // No operand predicates
     /* 1495256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495260 */     // MIs[0] policy
     /* 1495260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495272 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1495275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1495294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495297 */     // GIR_Coverage, 24920,
     /* 1495297 */     GIR_EraseRootFromParent_Done,
     /* 1495298 */   // Label 20853: @1495298
     /* 1495298 */   GIM_Try, /*On fail goto*//*Label 20854*/ GIMT_Encode4(1495395), // Rule ID 24921 //
     /* 1495303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1495306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1495311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1495314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1495317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1495320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495353 */     // MIs[1] Operand 1
     /* 1495353 */     // No operand predicates
     /* 1495353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495357 */     // MIs[0] policy
     /* 1495357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495369 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1495372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1495391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495394 */     // GIR_Coverage, 24921,
     /* 1495394 */     GIR_EraseRootFromParent_Done,
     /* 1495395 */   // Label 20854: @1495395
     /* 1495395 */   GIM_Try, /*On fail goto*//*Label 20855*/ GIMT_Encode4(1495492), // Rule ID 24924 //
     /* 1495400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1495403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1495408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1495411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1495414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1495417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1495423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495450 */     // MIs[1] Operand 1
     /* 1495450 */     // No operand predicates
     /* 1495450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495454 */     // MIs[0] policy
     /* 1495454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495466 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1495469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495491 */     // GIR_Coverage, 24924,
     /* 1495491 */     GIR_EraseRootFromParent_Done,
     /* 1495492 */   // Label 20855: @1495492
     /* 1495492 */   GIM_Try, /*On fail goto*//*Label 20856*/ GIMT_Encode4(1495589), // Rule ID 24925 //
     /* 1495497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1495500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1495505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1495508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1495511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1495514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1495520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495547 */     // MIs[1] Operand 1
     /* 1495547 */     // No operand predicates
     /* 1495547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495551 */     // MIs[0] policy
     /* 1495551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495563 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1495566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495588 */     // GIR_Coverage, 24925,
     /* 1495588 */     GIR_EraseRootFromParent_Done,
     /* 1495589 */   // Label 20856: @1495589
     /* 1495589 */   GIM_Try, /*On fail goto*//*Label 20857*/ GIMT_Encode4(1495686), // Rule ID 24928 //
     /* 1495594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1495597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1495602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1495605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1495608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1495611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495644 */     // MIs[1] Operand 1
     /* 1495644 */     // No operand predicates
     /* 1495644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495648 */     // MIs[0] policy
     /* 1495648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495660 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1495663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495685 */     // GIR_Coverage, 24928,
     /* 1495685 */     GIR_EraseRootFromParent_Done,
     /* 1495686 */   // Label 20857: @1495686
     /* 1495686 */   GIM_Try, /*On fail goto*//*Label 20858*/ GIMT_Encode4(1495783), // Rule ID 24929 //
     /* 1495691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1495694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1495699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1495702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1495705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1495708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495741 */     // MIs[1] Operand 1
     /* 1495741 */     // No operand predicates
     /* 1495741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495745 */     // MIs[0] policy
     /* 1495745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495757 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1495760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495782 */     // GIR_Coverage, 24929,
     /* 1495782 */     GIR_EraseRootFromParent_Done,
     /* 1495783 */   // Label 20858: @1495783
     /* 1495783 */   GIM_Try, /*On fail goto*//*Label 20859*/ GIMT_Encode4(1495880), // Rule ID 24932 //
     /* 1495788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1495791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1495796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1495799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1495802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1495805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495838 */     // MIs[1] Operand 1
     /* 1495838 */     // No operand predicates
     /* 1495838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495842 */     // MIs[0] policy
     /* 1495842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495854 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1495857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495879 */     // GIR_Coverage, 24932,
     /* 1495879 */     GIR_EraseRootFromParent_Done,
     /* 1495880 */   // Label 20859: @1495880
     /* 1495880 */   GIM_Try, /*On fail goto*//*Label 20860*/ GIMT_Encode4(1495977), // Rule ID 24933 //
     /* 1495885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1495888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1495893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1495896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1495899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1495902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495935 */     // MIs[1] Operand 1
     /* 1495935 */     // No operand predicates
     /* 1495935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495939 */     // MIs[0] policy
     /* 1495939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495951 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1495954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495976 */     // GIR_Coverage, 24933,
     /* 1495976 */     GIR_EraseRootFromParent_Done,
     /* 1495977 */   // Label 20860: @1495977
     /* 1495977 */   GIM_Try, /*On fail goto*//*Label 20861*/ GIMT_Encode4(1496074), // Rule ID 24936 //
     /* 1495982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1495985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1495990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1495993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1495996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1495999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496032 */     // MIs[1] Operand 1
     /* 1496032 */     // No operand predicates
     /* 1496032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496036 */     // MIs[0] policy
     /* 1496036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496048 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1496051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496073 */     // GIR_Coverage, 24936,
     /* 1496073 */     GIR_EraseRootFromParent_Done,
     /* 1496074 */   // Label 20861: @1496074
     /* 1496074 */   GIM_Try, /*On fail goto*//*Label 20862*/ GIMT_Encode4(1496171), // Rule ID 24937 //
     /* 1496079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1496082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1496087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1496090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1496093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1496096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496129 */     // MIs[1] Operand 1
     /* 1496129 */     // No operand predicates
     /* 1496129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496133 */     // MIs[0] policy
     /* 1496133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496145 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1496148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496170 */     // GIR_Coverage, 24937,
     /* 1496170 */     GIR_EraseRootFromParent_Done,
     /* 1496171 */   // Label 20862: @1496171
     /* 1496171 */   GIM_Try, /*On fail goto*//*Label 20863*/ GIMT_Encode4(1496268), // Rule ID 24940 //
     /* 1496176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1496179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1496184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1496187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1496190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1496193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496226 */     // MIs[1] Operand 1
     /* 1496226 */     // No operand predicates
     /* 1496226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496230 */     // MIs[0] policy
     /* 1496230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496242 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1496245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496267 */     // GIR_Coverage, 24940,
     /* 1496267 */     GIR_EraseRootFromParent_Done,
     /* 1496268 */   // Label 20863: @1496268
     /* 1496268 */   GIM_Try, /*On fail goto*//*Label 20864*/ GIMT_Encode4(1496365), // Rule ID 24941 //
     /* 1496273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1496276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1496281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1496284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1496287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1496290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496323 */     // MIs[1] Operand 1
     /* 1496323 */     // No operand predicates
     /* 1496323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496327 */     // MIs[0] policy
     /* 1496327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496339 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1496342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496364 */     // GIR_Coverage, 24941,
     /* 1496364 */     GIR_EraseRootFromParent_Done,
     /* 1496365 */   // Label 20864: @1496365
     /* 1496365 */   GIM_Try, /*On fail goto*//*Label 20865*/ GIMT_Encode4(1496462), // Rule ID 24944 //
     /* 1496370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1496373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1496378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1496381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1496384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1496387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1496393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1496400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496420 */     // MIs[1] Operand 1
     /* 1496420 */     // No operand predicates
     /* 1496420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496424 */     // MIs[0] policy
     /* 1496424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496436 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1496439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496461 */     // GIR_Coverage, 24944,
     /* 1496461 */     GIR_EraseRootFromParent_Done,
     /* 1496462 */   // Label 20865: @1496462
     /* 1496462 */   GIM_Try, /*On fail goto*//*Label 20866*/ GIMT_Encode4(1496559), // Rule ID 24945 //
     /* 1496467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1496470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1496475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1496478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1496481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1496484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1496490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1496497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496517 */     // MIs[1] Operand 1
     /* 1496517 */     // No operand predicates
     /* 1496517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496521 */     // MIs[0] policy
     /* 1496521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496533 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1496536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496558 */     // GIR_Coverage, 24945,
     /* 1496558 */     GIR_EraseRootFromParent_Done,
     /* 1496559 */   // Label 20866: @1496559
     /* 1496559 */   GIM_Try, /*On fail goto*//*Label 20867*/ GIMT_Encode4(1496656), // Rule ID 24996 //
     /* 1496564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1496567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1496572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1496575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1496578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1496581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496614 */     // MIs[1] Operand 1
     /* 1496614 */     // No operand predicates
     /* 1496614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496618 */     // MIs[0] policy
     /* 1496618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496630 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1496633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496655 */     // GIR_Coverage, 24996,
     /* 1496655 */     GIR_EraseRootFromParent_Done,
     /* 1496656 */   // Label 20867: @1496656
     /* 1496656 */   GIM_Try, /*On fail goto*//*Label 20868*/ GIMT_Encode4(1496753), // Rule ID 24997 //
     /* 1496661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1496664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1496669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1496672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1496675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1496678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496711 */     // MIs[1] Operand 1
     /* 1496711 */     // No operand predicates
     /* 1496711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496715 */     // MIs[0] policy
     /* 1496715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496727 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1496730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496752 */     // GIR_Coverage, 24997,
     /* 1496752 */     GIR_EraseRootFromParent_Done,
     /* 1496753 */   // Label 20868: @1496753
     /* 1496753 */   GIM_Try, /*On fail goto*//*Label 20869*/ GIMT_Encode4(1496850), // Rule ID 25000 //
     /* 1496758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1496761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1496766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1496769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1496772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1496775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496808 */     // MIs[1] Operand 1
     /* 1496808 */     // No operand predicates
     /* 1496808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496812 */     // MIs[0] policy
     /* 1496812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496824 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1496827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496849 */     // GIR_Coverage, 25000,
     /* 1496849 */     GIR_EraseRootFromParent_Done,
     /* 1496850 */   // Label 20869: @1496850
     /* 1496850 */   GIM_Try, /*On fail goto*//*Label 20870*/ GIMT_Encode4(1496947), // Rule ID 25001 //
     /* 1496855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1496858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1496863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1496866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1496869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1496872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496905 */     // MIs[1] Operand 1
     /* 1496905 */     // No operand predicates
     /* 1496905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496909 */     // MIs[0] policy
     /* 1496909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496921 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1496924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496946 */     // GIR_Coverage, 25001,
     /* 1496946 */     GIR_EraseRootFromParent_Done,
     /* 1496947 */   // Label 20870: @1496947
     /* 1496947 */   GIM_Try, /*On fail goto*//*Label 20871*/ GIMT_Encode4(1497044), // Rule ID 25004 //
     /* 1496952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1496955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1496960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1496963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1496966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1496969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497002 */     // MIs[1] Operand 1
     /* 1497002 */     // No operand predicates
     /* 1497002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497006 */     // MIs[0] policy
     /* 1497006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497018 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1497021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497043 */     // GIR_Coverage, 25004,
     /* 1497043 */     GIR_EraseRootFromParent_Done,
     /* 1497044 */   // Label 20871: @1497044
     /* 1497044 */   GIM_Try, /*On fail goto*//*Label 20872*/ GIMT_Encode4(1497141), // Rule ID 25005 //
     /* 1497049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1497052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1497057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1497060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1497063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1497066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497099 */     // MIs[1] Operand 1
     /* 1497099 */     // No operand predicates
     /* 1497099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497103 */     // MIs[0] policy
     /* 1497103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497115 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1497118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497140 */     // GIR_Coverage, 25005,
     /* 1497140 */     GIR_EraseRootFromParent_Done,
     /* 1497141 */   // Label 20872: @1497141
     /* 1497141 */   GIM_Try, /*On fail goto*//*Label 20873*/ GIMT_Encode4(1497238), // Rule ID 25008 //
     /* 1497146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1497149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1497154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1497157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1497160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1497163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1497176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497192 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497196 */     // MIs[1] Operand 1
     /* 1497196 */     // No operand predicates
     /* 1497196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497200 */     // MIs[0] policy
     /* 1497200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497212 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1497215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497237 */     // GIR_Coverage, 25008,
     /* 1497237 */     GIR_EraseRootFromParent_Done,
     /* 1497238 */   // Label 20873: @1497238
     /* 1497238 */   GIM_Try, /*On fail goto*//*Label 20874*/ GIMT_Encode4(1497335), // Rule ID 25009 //
     /* 1497243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1497246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1497251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1497254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1497257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1497260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1497273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497293 */     // MIs[1] Operand 1
     /* 1497293 */     // No operand predicates
     /* 1497293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497297 */     // MIs[0] policy
     /* 1497297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497309 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1497312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497334 */     // GIR_Coverage, 25009,
     /* 1497334 */     GIR_EraseRootFromParent_Done,
     /* 1497335 */   // Label 20874: @1497335
     /* 1497335 */   GIM_Try, /*On fail goto*//*Label 20875*/ GIMT_Encode4(1497432), // Rule ID 25012 //
     /* 1497340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1497343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1497348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1497351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1497354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1497357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1497363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1497370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497390 */     // MIs[1] Operand 1
     /* 1497390 */     // No operand predicates
     /* 1497390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497394 */     // MIs[0] policy
     /* 1497394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497406 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1497409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497431 */     // GIR_Coverage, 25012,
     /* 1497431 */     GIR_EraseRootFromParent_Done,
     /* 1497432 */   // Label 20875: @1497432
     /* 1497432 */   GIM_Try, /*On fail goto*//*Label 20876*/ GIMT_Encode4(1497529), // Rule ID 25013 //
     /* 1497437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1497440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1497445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1497448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1497451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1497454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1497460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1497467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497487 */     // MIs[1] Operand 1
     /* 1497487 */     // No operand predicates
     /* 1497487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497491 */     // MIs[0] policy
     /* 1497491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497503 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1497506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497528 */     // GIR_Coverage, 25013,
     /* 1497528 */     GIR_EraseRootFromParent_Done,
     /* 1497529 */   // Label 20876: @1497529
     /* 1497529 */   GIM_Try, /*On fail goto*//*Label 20877*/ GIMT_Encode4(1497626), // Rule ID 25016 //
     /* 1497534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1497537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1497542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1497545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1497548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1497551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1497557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1497564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497584 */     // MIs[1] Operand 1
     /* 1497584 */     // No operand predicates
     /* 1497584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497588 */     // MIs[0] policy
     /* 1497588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497600 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1497603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497625 */     // GIR_Coverage, 25016,
     /* 1497625 */     GIR_EraseRootFromParent_Done,
     /* 1497626 */   // Label 20877: @1497626
     /* 1497626 */   GIM_Try, /*On fail goto*//*Label 20878*/ GIMT_Encode4(1497723), // Rule ID 25017 //
     /* 1497631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1497634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1497639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1497642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1497645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1497648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1497654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1497661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497681 */     // MIs[1] Operand 1
     /* 1497681 */     // No operand predicates
     /* 1497681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497685 */     // MIs[0] policy
     /* 1497685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497697 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1497700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497722 */     // GIR_Coverage, 25017,
     /* 1497722 */     GIR_EraseRootFromParent_Done,
     /* 1497723 */   // Label 20878: @1497723
     /* 1497723 */   GIM_Try, /*On fail goto*//*Label 20879*/ GIMT_Encode4(1497820), // Rule ID 61028 //
     /* 1497728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1497731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1497736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1497745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497778 */     // MIs[1] Operand 1
     /* 1497778 */     // No operand predicates
     /* 1497778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497782 */     // MIs[0] policy
     /* 1497782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497794 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1497797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497819 */     // GIR_Coverage, 61028,
     /* 1497819 */     GIR_EraseRootFromParent_Done,
     /* 1497820 */   // Label 20879: @1497820
     /* 1497820 */   GIM_Try, /*On fail goto*//*Label 20880*/ GIMT_Encode4(1497917), // Rule ID 61029 //
     /* 1497825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1497828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1497833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1497842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497875 */     // MIs[1] Operand 1
     /* 1497875 */     // No operand predicates
     /* 1497875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497879 */     // MIs[0] policy
     /* 1497879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497891 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1497894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497916 */     // GIR_Coverage, 61029,
     /* 1497916 */     GIR_EraseRootFromParent_Done,
     /* 1497917 */   // Label 20880: @1497917
     /* 1497917 */   GIM_Try, /*On fail goto*//*Label 20881*/ GIMT_Encode4(1498014), // Rule ID 61036 //
     /* 1497922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1497925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1497930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1497933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1497936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1497939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497972 */     // MIs[1] Operand 1
     /* 1497972 */     // No operand predicates
     /* 1497972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497976 */     // MIs[0] policy
     /* 1497976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497988 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1497991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498013 */     // GIR_Coverage, 61036,
     /* 1498013 */     GIR_EraseRootFromParent_Done,
     /* 1498014 */   // Label 20881: @1498014
     /* 1498014 */   GIM_Try, /*On fail goto*//*Label 20882*/ GIMT_Encode4(1498111), // Rule ID 61037 //
     /* 1498019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1498022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1498027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1498030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1498033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1498036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1498069 */     // MIs[1] Operand 1
     /* 1498069 */     // No operand predicates
     /* 1498069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498073 */     // MIs[0] policy
     /* 1498073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498085 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1498088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498110 */     // GIR_Coverage, 61037,
     /* 1498110 */     GIR_EraseRootFromParent_Done,
     /* 1498111 */   // Label 20882: @1498111
     /* 1498111 */   GIM_Try, /*On fail goto*//*Label 20883*/ GIMT_Encode4(1498208), // Rule ID 61044 //
     /* 1498116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1498119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1498124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1498127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1498130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1498133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1498139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1498166 */     // MIs[1] Operand 1
     /* 1498166 */     // No operand predicates
     /* 1498166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498170 */     // MIs[0] policy
     /* 1498170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1498185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498207 */     // GIR_Coverage, 61044,
     /* 1498207 */     GIR_EraseRootFromParent_Done,
     /* 1498208 */   // Label 20883: @1498208
     /* 1498208 */   GIM_Try, /*On fail goto*//*Label 20884*/ GIMT_Encode4(1498305), // Rule ID 61045 //
     /* 1498213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1498216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1498221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1498224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1498227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1498230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1498236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1498263 */     // MIs[1] Operand 1
     /* 1498263 */     // No operand predicates
     /* 1498263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498267 */     // MIs[0] policy
     /* 1498267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498279 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1498282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498304 */     // GIR_Coverage, 61045,
     /* 1498304 */     GIR_EraseRootFromParent_Done,
     /* 1498305 */   // Label 20884: @1498305
     /* 1498305 */   GIM_Try, /*On fail goto*//*Label 20885*/ GIMT_Encode4(1498402), // Rule ID 61052 //
     /* 1498310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1498313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1498318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1498321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1498324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1498327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1498333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1498340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1498360 */     // MIs[1] Operand 1
     /* 1498360 */     // No operand predicates
     /* 1498360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498364 */     // MIs[0] policy
     /* 1498364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498376 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1498379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498401 */     // GIR_Coverage, 61052,
     /* 1498401 */     GIR_EraseRootFromParent_Done,
     /* 1498402 */   // Label 20885: @1498402
     /* 1498402 */   GIM_Try, /*On fail goto*//*Label 20886*/ GIMT_Encode4(1498499), // Rule ID 61053 //
     /* 1498407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1498410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1498415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1498418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1498421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1498424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1498430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1498437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1498457 */     // MIs[1] Operand 1
     /* 1498457 */     // No operand predicates
     /* 1498457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498461 */     // MIs[0] policy
     /* 1498461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498473 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1498476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498498 */     // GIR_Coverage, 61053,
     /* 1498498 */     GIR_EraseRootFromParent_Done,
     /* 1498499 */   // Label 20886: @1498499
     /* 1498499 */   GIM_Try, /*On fail goto*//*Label 20887*/ GIMT_Encode4(1498596), // Rule ID 61060 //
     /* 1498504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1498507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1498512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1498515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1498518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1498521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1498527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1498534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1498554 */     // MIs[1] Operand 1
     /* 1498554 */     // No operand predicates
     /* 1498554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498558 */     // MIs[0] policy
     /* 1498558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498570 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1498573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498595 */     // GIR_Coverage, 61060,
     /* 1498595 */     GIR_EraseRootFromParent_Done,
     /* 1498596 */   // Label 20887: @1498596
     /* 1498596 */   GIM_Try, /*On fail goto*//*Label 20888*/ GIMT_Encode4(1498693), // Rule ID 61061 //
     /* 1498601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1498604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1498609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1498612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1498615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1498618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1498624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1498631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1498651 */     // MIs[1] Operand 1
     /* 1498651 */     // No operand predicates
     /* 1498651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498655 */     // MIs[0] policy
     /* 1498655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498667 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1498670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498692 */     // GIR_Coverage, 61061,
     /* 1498692 */     GIR_EraseRootFromParent_Done,
     /* 1498693 */   // Label 20888: @1498693
     /* 1498693 */   GIM_Try, /*On fail goto*//*Label 20889*/ GIMT_Encode4(1498790), // Rule ID 61068 //
     /* 1498698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1498701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1498706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1498709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1498712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1498715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1498721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1498728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498744 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1498748 */     // MIs[1] Operand 1
     /* 1498748 */     // No operand predicates
     /* 1498748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498752 */     // MIs[0] policy
     /* 1498752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498764 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1498767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498789 */     // GIR_Coverage, 61068,
     /* 1498789 */     GIR_EraseRootFromParent_Done,
     /* 1498790 */   // Label 20889: @1498790
     /* 1498790 */   GIM_Try, /*On fail goto*//*Label 20890*/ GIMT_Encode4(1498887), // Rule ID 61069 //
     /* 1498795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1498798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1498803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1498806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1498809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1498812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1498818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1498825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1498845 */     // MIs[1] Operand 1
     /* 1498845 */     // No operand predicates
     /* 1498845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498849 */     // MIs[0] policy
     /* 1498849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498861 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1498864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498886 */     // GIR_Coverage, 61069,
     /* 1498886 */     GIR_EraseRootFromParent_Done,
     /* 1498887 */   // Label 20890: @1498887
     /* 1498887 */   GIM_Try, /*On fail goto*//*Label 20891*/ GIMT_Encode4(1498984), // Rule ID 61076 //
     /* 1498892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1498895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1498900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1498903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1498906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1498909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1498915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1498942 */     // MIs[1] Operand 1
     /* 1498942 */     // No operand predicates
     /* 1498942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498946 */     // MIs[0] policy
     /* 1498946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498958 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1498961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498983 */     // GIR_Coverage, 61076,
     /* 1498983 */     GIR_EraseRootFromParent_Done,
     /* 1498984 */   // Label 20891: @1498984
     /* 1498984 */   GIM_Try, /*On fail goto*//*Label 20892*/ GIMT_Encode4(1499081), // Rule ID 61077 //
     /* 1498989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1498992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1498997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1499000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1499003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1499006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1499012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1499019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1499039 */     // MIs[1] Operand 1
     /* 1499039 */     // No operand predicates
     /* 1499039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499043 */     // MIs[0] policy
     /* 1499043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499055 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1499058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499080 */     // GIR_Coverage, 61077,
     /* 1499080 */     GIR_EraseRootFromParent_Done,
     /* 1499081 */   // Label 20892: @1499081
     /* 1499081 */   GIM_Try, /*On fail goto*//*Label 20893*/ GIMT_Encode4(1499178), // Rule ID 61084 //
     /* 1499086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1499089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1499094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1499097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1499100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1499103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1499109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1499116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1499136 */     // MIs[1] Operand 1
     /* 1499136 */     // No operand predicates
     /* 1499136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499140 */     // MIs[0] policy
     /* 1499140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1499155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499177 */     // GIR_Coverage, 61084,
     /* 1499177 */     GIR_EraseRootFromParent_Done,
     /* 1499178 */   // Label 20893: @1499178
     /* 1499178 */   GIM_Try, /*On fail goto*//*Label 20894*/ GIMT_Encode4(1499275), // Rule ID 61085 //
     /* 1499183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1499186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1499191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1499194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1499197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1499200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1499206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1499213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1499233 */     // MIs[1] Operand 1
     /* 1499233 */     // No operand predicates
     /* 1499233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499237 */     // MIs[0] policy
     /* 1499237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499249 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1499252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499274 */     // GIR_Coverage, 61085,
     /* 1499274 */     GIR_EraseRootFromParent_Done,
     /* 1499275 */   // Label 20894: @1499275
     /* 1499275 */   GIM_Try, /*On fail goto*//*Label 20895*/ GIMT_Encode4(1499372), // Rule ID 61092 //
     /* 1499280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1499283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1499288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1499291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1499294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1499297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1499303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1499330 */     // MIs[1] Operand 1
     /* 1499330 */     // No operand predicates
     /* 1499330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499334 */     // MIs[0] policy
     /* 1499334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1499349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499371 */     // GIR_Coverage, 61092,
     /* 1499371 */     GIR_EraseRootFromParent_Done,
     /* 1499372 */   // Label 20895: @1499372
     /* 1499372 */   GIM_Try, /*On fail goto*//*Label 20896*/ GIMT_Encode4(1499469), // Rule ID 61093 //
     /* 1499377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1499380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1499385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1499388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1499391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1499394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1499400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1499427 */     // MIs[1] Operand 1
     /* 1499427 */     // No operand predicates
     /* 1499427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499431 */     // MIs[0] policy
     /* 1499431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499443 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1499446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499468 */     // GIR_Coverage, 61093,
     /* 1499468 */     GIR_EraseRootFromParent_Done,
     /* 1499469 */   // Label 20896: @1499469
     /* 1499469 */   GIM_Try, /*On fail goto*//*Label 20897*/ GIMT_Encode4(1499566), // Rule ID 61100 //
     /* 1499474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1499477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1499482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1499485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1499488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1499491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1499497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1499524 */     // MIs[1] Operand 1
     /* 1499524 */     // No operand predicates
     /* 1499524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499528 */     // MIs[0] policy
     /* 1499528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499540 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1499543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499565 */     // GIR_Coverage, 61100,
     /* 1499565 */     GIR_EraseRootFromParent_Done,
     /* 1499566 */   // Label 20897: @1499566
     /* 1499566 */   GIM_Try, /*On fail goto*//*Label 20898*/ GIMT_Encode4(1499663), // Rule ID 61101 //
     /* 1499571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1499574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1499579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1499582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1499585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1499588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1499594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1499621 */     // MIs[1] Operand 1
     /* 1499621 */     // No operand predicates
     /* 1499621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499625 */     // MIs[0] policy
     /* 1499625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499637 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1499640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499662 */     // GIR_Coverage, 61101,
     /* 1499662 */     GIR_EraseRootFromParent_Done,
     /* 1499663 */   // Label 20898: @1499663
     /* 1499663 */   GIM_Try, /*On fail goto*//*Label 20899*/ GIMT_Encode4(1499760), // Rule ID 61108 //
     /* 1499668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1499671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1499676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1499679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1499682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1499685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1499718 */     // MIs[1] Operand 1
     /* 1499718 */     // No operand predicates
     /* 1499718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499722 */     // MIs[0] policy
     /* 1499722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499734 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1499737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499759 */     // GIR_Coverage, 61108,
     /* 1499759 */     GIR_EraseRootFromParent_Done,
     /* 1499760 */   // Label 20899: @1499760
     /* 1499760 */   GIM_Try, /*On fail goto*//*Label 20900*/ GIMT_Encode4(1499857), // Rule ID 61109 //
     /* 1499765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1499768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1499773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1499776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1499779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1499782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1499815 */     // MIs[1] Operand 1
     /* 1499815 */     // No operand predicates
     /* 1499815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499819 */     // MIs[0] policy
     /* 1499819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499831 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1499834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499856 */     // GIR_Coverage, 61109,
     /* 1499856 */     GIR_EraseRootFromParent_Done,
     /* 1499857 */   // Label 20900: @1499857
     /* 1499857 */   GIM_Try, /*On fail goto*//*Label 20901*/ GIMT_Encode4(1499954), // Rule ID 61116 //
     /* 1499862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1499865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1499870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1499873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1499876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1499879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1499885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1499892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1499912 */     // MIs[1] Operand 1
     /* 1499912 */     // No operand predicates
     /* 1499912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499916 */     // MIs[0] policy
     /* 1499916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1499931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499953 */     // GIR_Coverage, 61116,
     /* 1499953 */     GIR_EraseRootFromParent_Done,
     /* 1499954 */   // Label 20901: @1499954
     /* 1499954 */   GIM_Try, /*On fail goto*//*Label 20902*/ GIMT_Encode4(1500051), // Rule ID 61117 //
     /* 1499959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1499962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1499967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1499970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1499973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1499976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1499982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1499989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1500009 */     // MIs[1] Operand 1
     /* 1500009 */     // No operand predicates
     /* 1500009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500013 */     // MIs[0] policy
     /* 1500013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500025 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1500028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500050 */     // GIR_Coverage, 61117,
     /* 1500050 */     GIR_EraseRootFromParent_Done,
     /* 1500051 */   // Label 20902: @1500051
     /* 1500051 */   GIM_Try, /*On fail goto*//*Label 20903*/ GIMT_Encode4(1500148), // Rule ID 61124 //
     /* 1500056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1500059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1500064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1500067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1500070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1500073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1500079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1500106 */     // MIs[1] Operand 1
     /* 1500106 */     // No operand predicates
     /* 1500106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500110 */     // MIs[0] policy
     /* 1500110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1500125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500147 */     // GIR_Coverage, 61124,
     /* 1500147 */     GIR_EraseRootFromParent_Done,
     /* 1500148 */   // Label 20903: @1500148
     /* 1500148 */   GIM_Try, /*On fail goto*//*Label 20904*/ GIMT_Encode4(1500245), // Rule ID 61125 //
     /* 1500153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1500156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1500161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1500164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1500167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1500170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1500176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1500203 */     // MIs[1] Operand 1
     /* 1500203 */     // No operand predicates
     /* 1500203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500207 */     // MIs[0] policy
     /* 1500207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1500222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500244 */     // GIR_Coverage, 61125,
     /* 1500244 */     GIR_EraseRootFromParent_Done,
     /* 1500245 */   // Label 20904: @1500245
     /* 1500245 */   GIM_Try, /*On fail goto*//*Label 20905*/ GIMT_Encode4(1500342), // Rule ID 61132 //
     /* 1500250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1500253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1500258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1500261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1500264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1500267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1500300 */     // MIs[1] Operand 1
     /* 1500300 */     // No operand predicates
     /* 1500300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500304 */     // MIs[0] policy
     /* 1500304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500316 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1500319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500341 */     // GIR_Coverage, 61132,
     /* 1500341 */     GIR_EraseRootFromParent_Done,
     /* 1500342 */   // Label 20905: @1500342
     /* 1500342 */   GIM_Try, /*On fail goto*//*Label 20906*/ GIMT_Encode4(1500439), // Rule ID 61133 //
     /* 1500347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1500350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1500355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1500358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1500361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1500364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1500397 */     // MIs[1] Operand 1
     /* 1500397 */     // No operand predicates
     /* 1500397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500401 */     // MIs[0] policy
     /* 1500401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500413 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1500416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500438 */     // GIR_Coverage, 61133,
     /* 1500438 */     GIR_EraseRootFromParent_Done,
     /* 1500439 */   // Label 20906: @1500439
     /* 1500439 */   GIM_Try, /*On fail goto*//*Label 20907*/ GIMT_Encode4(1500536), // Rule ID 61140 //
     /* 1500444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1500447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1500452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1500455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1500458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1500461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1500494 */     // MIs[1] Operand 1
     /* 1500494 */     // No operand predicates
     /* 1500494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500498 */     // MIs[0] policy
     /* 1500498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500510 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1500513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500535 */     // GIR_Coverage, 61140,
     /* 1500535 */     GIR_EraseRootFromParent_Done,
     /* 1500536 */   // Label 20907: @1500536
     /* 1500536 */   GIM_Try, /*On fail goto*//*Label 20908*/ GIMT_Encode4(1500633), // Rule ID 61141 //
     /* 1500541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1500544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1500549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1500552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1500555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1500558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1500591 */     // MIs[1] Operand 1
     /* 1500591 */     // No operand predicates
     /* 1500591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500595 */     // MIs[0] policy
     /* 1500595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500607 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1500610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500632 */     // GIR_Coverage, 61141,
     /* 1500632 */     GIR_EraseRootFromParent_Done,
     /* 1500633 */   // Label 20908: @1500633
     /* 1500633 */   GIM_Try, /*On fail goto*//*Label 20909*/ GIMT_Encode4(1500730), // Rule ID 61996 //
     /* 1500638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1500649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1500652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1500655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1500661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1500668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500688 */     // MIs[1] Operand 1
     /* 1500688 */     // No operand predicates
     /* 1500688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500692 */     // MIs[0] policy
     /* 1500692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500704 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1500707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1500726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500729 */     // GIR_Coverage, 61996,
     /* 1500729 */     GIR_EraseRootFromParent_Done,
     /* 1500730 */   // Label 20909: @1500730
     /* 1500730 */   GIM_Try, /*On fail goto*//*Label 20910*/ GIMT_Encode4(1500827), // Rule ID 61997 //
     /* 1500735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1500746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1500749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1500752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1500758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1500765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500785 */     // MIs[1] Operand 1
     /* 1500785 */     // No operand predicates
     /* 1500785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500789 */     // MIs[0] policy
     /* 1500789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500801 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1500804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1500823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500826 */     // GIR_Coverage, 61997,
     /* 1500826 */     GIR_EraseRootFromParent_Done,
     /* 1500827 */   // Label 20910: @1500827
     /* 1500827 */   GIM_Try, /*On fail goto*//*Label 20911*/ GIMT_Encode4(1500924), // Rule ID 62000 //
     /* 1500832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1500843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1500846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1500849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1500855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1500862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500882 */     // MIs[1] Operand 1
     /* 1500882 */     // No operand predicates
     /* 1500882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500886 */     // MIs[0] policy
     /* 1500886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500898 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1500901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1500920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500923 */     // GIR_Coverage, 62000,
     /* 1500923 */     GIR_EraseRootFromParent_Done,
     /* 1500924 */   // Label 20911: @1500924
     /* 1500924 */   GIM_Try, /*On fail goto*//*Label 20912*/ GIMT_Encode4(1501021), // Rule ID 62001 //
     /* 1500929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1500940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1500943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1500946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1500952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1500959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500979 */     // MIs[1] Operand 1
     /* 1500979 */     // No operand predicates
     /* 1500979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500983 */     // MIs[0] policy
     /* 1500983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500995 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1500998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1501017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501020 */     // GIR_Coverage, 62001,
     /* 1501020 */     GIR_EraseRootFromParent_Done,
     /* 1501021 */   // Label 20912: @1501021
     /* 1501021 */   GIM_Try, /*On fail goto*//*Label 20913*/ GIMT_Encode4(1501118), // Rule ID 62004 //
     /* 1501026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1501029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1501037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1501040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1501043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1501046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1501049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501076 */     // MIs[1] Operand 1
     /* 1501076 */     // No operand predicates
     /* 1501076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501080 */     // MIs[0] policy
     /* 1501080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501092 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1501095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1501114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501117 */     // GIR_Coverage, 62004,
     /* 1501117 */     GIR_EraseRootFromParent_Done,
     /* 1501118 */   // Label 20913: @1501118
     /* 1501118 */   GIM_Try, /*On fail goto*//*Label 20914*/ GIMT_Encode4(1501215), // Rule ID 62005 //
     /* 1501123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1501126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1501134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1501137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1501140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1501143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1501146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501173 */     // MIs[1] Operand 1
     /* 1501173 */     // No operand predicates
     /* 1501173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501177 */     // MIs[0] policy
     /* 1501177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501189 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1501192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1501211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501214 */     // GIR_Coverage, 62005,
     /* 1501214 */     GIR_EraseRootFromParent_Done,
     /* 1501215 */   // Label 20914: @1501215
     /* 1501215 */   GIM_Try, /*On fail goto*//*Label 20915*/ GIMT_Encode4(1501312), // Rule ID 62008 //
     /* 1501220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1501223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1501240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1501243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501270 */     // MIs[1] Operand 1
     /* 1501270 */     // No operand predicates
     /* 1501270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501274 */     // MIs[0] policy
     /* 1501274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501286 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1501289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501311 */     // GIR_Coverage, 62008,
     /* 1501311 */     GIR_EraseRootFromParent_Done,
     /* 1501312 */   // Label 20915: @1501312
     /* 1501312 */   GIM_Try, /*On fail goto*//*Label 20916*/ GIMT_Encode4(1501409), // Rule ID 62009 //
     /* 1501317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1501320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1501337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1501340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501367 */     // MIs[1] Operand 1
     /* 1501367 */     // No operand predicates
     /* 1501367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501371 */     // MIs[0] policy
     /* 1501371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501383 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1501386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501408 */     // GIR_Coverage, 62009,
     /* 1501408 */     GIR_EraseRootFromParent_Done,
     /* 1501409 */   // Label 20916: @1501409
     /* 1501409 */   GIM_Try, /*On fail goto*//*Label 20917*/ GIMT_Encode4(1501506), // Rule ID 62012 //
     /* 1501414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1501417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1501425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1501428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1501431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1501434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1501437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501464 */     // MIs[1] Operand 1
     /* 1501464 */     // No operand predicates
     /* 1501464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501468 */     // MIs[0] policy
     /* 1501468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501480 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1501483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501505 */     // GIR_Coverage, 62012,
     /* 1501505 */     GIR_EraseRootFromParent_Done,
     /* 1501506 */   // Label 20917: @1501506
     /* 1501506 */   GIM_Try, /*On fail goto*//*Label 20918*/ GIMT_Encode4(1501603), // Rule ID 62013 //
     /* 1501511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1501514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1501522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1501525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1501528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1501531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1501534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501561 */     // MIs[1] Operand 1
     /* 1501561 */     // No operand predicates
     /* 1501561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501565 */     // MIs[0] policy
     /* 1501565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501577 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1501580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501602 */     // GIR_Coverage, 62013,
     /* 1501602 */     GIR_EraseRootFromParent_Done,
     /* 1501603 */   // Label 20918: @1501603
     /* 1501603 */   GIM_Try, /*On fail goto*//*Label 20919*/ GIMT_Encode4(1501700), // Rule ID 62016 //
     /* 1501608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1501611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1501619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1501622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1501625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1501628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1501631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501658 */     // MIs[1] Operand 1
     /* 1501658 */     // No operand predicates
     /* 1501658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501662 */     // MIs[0] policy
     /* 1501662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501674 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1501677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501699 */     // GIR_Coverage, 62016,
     /* 1501699 */     GIR_EraseRootFromParent_Done,
     /* 1501700 */   // Label 20919: @1501700
     /* 1501700 */   GIM_Try, /*On fail goto*//*Label 20920*/ GIMT_Encode4(1501797), // Rule ID 62017 //
     /* 1501705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1501708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1501716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1501719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1501722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1501725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1501728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501755 */     // MIs[1] Operand 1
     /* 1501755 */     // No operand predicates
     /* 1501755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501759 */     // MIs[0] policy
     /* 1501759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501771 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1501774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501796 */     // GIR_Coverage, 62017,
     /* 1501796 */     GIR_EraseRootFromParent_Done,
     /* 1501797 */   // Label 20920: @1501797
     /* 1501797 */   GIM_Try, /*On fail goto*//*Label 20921*/ GIMT_Encode4(1501894), // Rule ID 62020 //
     /* 1501802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1501805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1501813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1501816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1501819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1501822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1501825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501852 */     // MIs[1] Operand 1
     /* 1501852 */     // No operand predicates
     /* 1501852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501856 */     // MIs[0] policy
     /* 1501856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501868 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1501871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1501890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501893 */     // GIR_Coverage, 62020,
     /* 1501893 */     GIR_EraseRootFromParent_Done,
     /* 1501894 */   // Label 20921: @1501894
     /* 1501894 */   GIM_Try, /*On fail goto*//*Label 20922*/ GIMT_Encode4(1501991), // Rule ID 62021 //
     /* 1501899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1501902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1501910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1501913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1501916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1501919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1501922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501949 */     // MIs[1] Operand 1
     /* 1501949 */     // No operand predicates
     /* 1501949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501953 */     // MIs[0] policy
     /* 1501953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501965 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1501968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1501987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501990 */     // GIR_Coverage, 62021,
     /* 1501990 */     GIR_EraseRootFromParent_Done,
     /* 1501991 */   // Label 20922: @1501991
     /* 1501991 */   GIM_Try, /*On fail goto*//*Label 20923*/ GIMT_Encode4(1502088), // Rule ID 62024 //
     /* 1501996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1501999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1502004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1502007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1502010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1502013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1502016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1502019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1502026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1502038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1502042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1502046 */     // MIs[1] Operand 1
     /* 1502046 */     // No operand predicates
     /* 1502046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502050 */     // MIs[0] policy
     /* 1502050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1502055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502062 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1502065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1502074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502087 */     // GIR_Coverage, 62024,
     /* 1502087 */     GIR_EraseRootFromParent_Done,
     /* 1502088 */   // Label 20923: @1502088
     /* 1502088 */   GIM_Try, /*On fail goto*//*Label 20924*/ GIMT_Encode4(1502185), // Rule ID 62025 //
     /* 1502093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1502096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1502101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1502104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1502107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1502110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1502113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1502116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1502123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1502135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1502139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1502143 */     // MIs[1] Operand 1
     /* 1502143 */     // No operand predicates
     /* 1502143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502147 */     // MIs[0] policy
     /* 1502147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1502152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502159 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1502162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1502171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502184 */     // GIR_Coverage, 62025,
     /* 1502184 */     GIR_EraseRootFromParent_Done,
     /* 1502185 */   // Label 20924: @1502185
     /* 1502185 */   GIM_Try, /*On fail goto*//*Label 20925*/ GIMT_Encode4(1502282), // Rule ID 62028 //
     /* 1502190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1502193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1502198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1502207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1502210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1502213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1502220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1502232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1502236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1502240 */     // MIs[1] Operand 1
     /* 1502240 */     // No operand predicates
     /* 1502240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502244 */     // MIs[0] policy
     /* 1502244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1502249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1502259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1502268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502281 */     // GIR_Coverage, 62028,
     /* 1502281 */     GIR_EraseRootFromParent_Done,
     /* 1502282 */   // Label 20925: @1502282
     /* 1502282 */   GIM_Try, /*On fail goto*//*Label 20926*/ GIMT_Encode4(1502379), // Rule ID 62029 //
     /* 1502287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1502290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1502295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1502304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1502307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1502310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1502317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1502329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1502333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1502337 */     // MIs[1] Operand 1
     /* 1502337 */     // No operand predicates
     /* 1502337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502341 */     // MIs[0] policy
     /* 1502341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1502346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502353 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1502356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1502365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502378 */     // GIR_Coverage, 62029,
     /* 1502378 */     GIR_EraseRootFromParent_Done,
     /* 1502379 */   // Label 20926: @1502379
     /* 1502379 */   GIM_Try, /*On fail goto*//*Label 20927*/ GIMT_Encode4(1502476), // Rule ID 62032 //
     /* 1502384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1502387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1502392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1502395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1502398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1502401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1502404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1502407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1502414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1502426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1502430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1502434 */     // MIs[1] Operand 1
     /* 1502434 */     // No operand predicates
     /* 1502434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502438 */     // MIs[0] policy
     /* 1502438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1502443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502450 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1502453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1502462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502475 */     // GIR_Coverage, 62032,
     /* 1502475 */     GIR_EraseRootFromParent_Done,
     /* 1502476 */   // Label 20927: @1502476
     /* 1502476 */   GIM_Try, /*On fail goto*//*Label 20928*/ GIMT_Encode4(1502573), // Rule ID 62033 //
     /* 1502481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1502484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1502489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1502492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1502495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1502498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1502501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1502504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1502511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1502523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1502527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1502531 */     // MIs[1] Operand 1
     /* 1502531 */     // No operand predicates
     /* 1502531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502535 */     // MIs[0] policy
     /* 1502535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1502540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502547 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1502550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1502559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502572 */     // GIR_Coverage, 62033,
     /* 1502572 */     GIR_EraseRootFromParent_Done,
     /* 1502573 */   // Label 20928: @1502573
     /* 1502573 */   GIM_Try, /*On fail goto*//*Label 20929*/ GIMT_Encode4(1502670), // Rule ID 62036 //
     /* 1502578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1502581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1502586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1502589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1502592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1502595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1502598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1502601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1502608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1502620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1502624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1502628 */     // MIs[1] Operand 1
     /* 1502628 */     // No operand predicates
     /* 1502628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502632 */     // MIs[0] policy
     /* 1502632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1502637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1502647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1502656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1502666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502669 */     // GIR_Coverage, 62036,
     /* 1502669 */     GIR_EraseRootFromParent_Done,
     /* 1502670 */   // Label 20929: @1502670
     /* 1502670 */   GIM_Try, /*On fail goto*//*Label 20930*/ GIMT_Encode4(1502767), // Rule ID 62037 //
     /* 1502675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1502678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1502683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1502686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1502689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1502692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1502695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1502698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1502705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1502717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1502721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1502725 */     // MIs[1] Operand 1
     /* 1502725 */     // No operand predicates
     /* 1502725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502729 */     // MIs[0] policy
     /* 1502729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1502734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502741 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1502744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1502753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1502763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502766 */     // GIR_Coverage, 62037,
     /* 1502766 */     GIR_EraseRootFromParent_Done,
     /* 1502767 */   // Label 20930: @1502767
     /* 1502767 */   GIM_Try, /*On fail goto*//*Label 20931*/ GIMT_Encode4(1502864), // Rule ID 62040 //
     /* 1502772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1502775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1502780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1502783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1502786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1502789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1502792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1502795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1502802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1502814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1502818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1502822 */     // MIs[1] Operand 1
     /* 1502822 */     // No operand predicates
     /* 1502822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502826 */     // MIs[0] policy
     /* 1502826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1502831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502838 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1502841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1502850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1502860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502863 */     // GIR_Coverage, 62040,
     /* 1502863 */     GIR_EraseRootFromParent_Done,
     /* 1502864 */   // Label 20931: @1502864
     /* 1502864 */   GIM_Try, /*On fail goto*//*Label 20932*/ GIMT_Encode4(1502961), // Rule ID 62041 //
     /* 1502869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1502872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1502877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1502880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1502883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1502886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1502889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1502892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1502899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1502911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1502915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1502919 */     // MIs[1] Operand 1
     /* 1502919 */     // No operand predicates
     /* 1502919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1502923 */     // MIs[0] policy
     /* 1502923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1502928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502935 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1502938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1502942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1502947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1502949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1502957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502960 */     // GIR_Coverage, 62041,
     /* 1502960 */     GIR_EraseRootFromParent_Done,
     /* 1502961 */   // Label 20932: @1502961
     /* 1502961 */   GIM_Try, /*On fail goto*//*Label 20933*/ GIMT_Encode4(1503058), // Rule ID 62044 //
     /* 1502966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1502969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1502974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1502977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1502980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1502983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1502986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1502989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1502996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1503008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1503012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1503016 */     // MIs[1] Operand 1
     /* 1503016 */     // No operand predicates
     /* 1503016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503020 */     // MIs[0] policy
     /* 1503020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1503025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503032 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1503035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1503044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1503054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503057 */     // GIR_Coverage, 62044,
     /* 1503057 */     GIR_EraseRootFromParent_Done,
     /* 1503058 */   // Label 20933: @1503058
     /* 1503058 */   GIM_Try, /*On fail goto*//*Label 20934*/ GIMT_Encode4(1503155), // Rule ID 62045 //
     /* 1503063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1503066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1503071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1503074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1503077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1503080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1503083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1503086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1503093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1503105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1503109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1503113 */     // MIs[1] Operand 1
     /* 1503113 */     // No operand predicates
     /* 1503113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503117 */     // MIs[0] policy
     /* 1503117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1503122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503129 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1503132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1503141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1503151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503154 */     // GIR_Coverage, 62045,
     /* 1503154 */     GIR_EraseRootFromParent_Done,
     /* 1503155 */   // Label 20934: @1503155
     /* 1503155 */   GIM_Try, /*On fail goto*//*Label 20935*/ GIMT_Encode4(1503252), // Rule ID 62048 //
     /* 1503160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1503163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1503168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1503171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1503174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1503177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1503180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1503183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1503190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1503202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1503206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1503210 */     // MIs[1] Operand 1
     /* 1503210 */     // No operand predicates
     /* 1503210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503214 */     // MIs[0] policy
     /* 1503214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1503219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503226 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1503229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1503238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503251 */     // GIR_Coverage, 62048,
     /* 1503251 */     GIR_EraseRootFromParent_Done,
     /* 1503252 */   // Label 20935: @1503252
     /* 1503252 */   GIM_Try, /*On fail goto*//*Label 20936*/ GIMT_Encode4(1503349), // Rule ID 62049 //
     /* 1503257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1503260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1503265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1503268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1503271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1503274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1503277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1503280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1503287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1503299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1503303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1503307 */     // MIs[1] Operand 1
     /* 1503307 */     // No operand predicates
     /* 1503307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503311 */     // MIs[0] policy
     /* 1503311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1503316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503323 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1503326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1503335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503348 */     // GIR_Coverage, 62049,
     /* 1503348 */     GIR_EraseRootFromParent_Done,
     /* 1503349 */   // Label 20936: @1503349
     /* 1503349 */   GIM_Try, /*On fail goto*//*Label 20937*/ GIMT_Encode4(1503446), // Rule ID 62052 //
     /* 1503354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1503357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1503362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1503365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1503368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1503371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1503374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1503377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1503384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1503396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1503400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1503404 */     // MIs[1] Operand 1
     /* 1503404 */     // No operand predicates
     /* 1503404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503408 */     // MIs[0] policy
     /* 1503408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1503413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503420 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1503423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1503432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503445 */     // GIR_Coverage, 62052,
     /* 1503445 */     GIR_EraseRootFromParent_Done,
     /* 1503446 */   // Label 20937: @1503446
     /* 1503446 */   GIM_Try, /*On fail goto*//*Label 20938*/ GIMT_Encode4(1503543), // Rule ID 62053 //
     /* 1503451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1503454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1503459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1503462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1503465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1503468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1503471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1503474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1503481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1503493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1503497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1503501 */     // MIs[1] Operand 1
     /* 1503501 */     // No operand predicates
     /* 1503501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503505 */     // MIs[0] policy
     /* 1503505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1503510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503517 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1503520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1503529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503542 */     // GIR_Coverage, 62053,
     /* 1503542 */     GIR_EraseRootFromParent_Done,
     /* 1503543 */   // Label 20938: @1503543
     /* 1503543 */   GIM_Try, /*On fail goto*//*Label 20939*/ GIMT_Encode4(1503640), // Rule ID 62056 //
     /* 1503548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1503551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1503556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1503559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1503562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1503565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1503568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1503571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1503578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1503590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1503594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1503598 */     // MIs[1] Operand 1
     /* 1503598 */     // No operand predicates
     /* 1503598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503602 */     // MIs[0] policy
     /* 1503602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1503607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1503617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1503626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503639 */     // GIR_Coverage, 62056,
     /* 1503639 */     GIR_EraseRootFromParent_Done,
     /* 1503640 */   // Label 20939: @1503640
     /* 1503640 */   GIM_Try, /*On fail goto*//*Label 20940*/ GIMT_Encode4(1503737), // Rule ID 62057 //
     /* 1503645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1503648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1503653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1503656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1503659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1503662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1503665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1503668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1503675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1503687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1503691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1503695 */     // MIs[1] Operand 1
     /* 1503695 */     // No operand predicates
     /* 1503695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503699 */     // MIs[0] policy
     /* 1503699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1503704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503711 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1503714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1503723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503736 */     // GIR_Coverage, 62057,
     /* 1503736 */     GIR_EraseRootFromParent_Done,
     /* 1503737 */   // Label 20940: @1503737
     /* 1503737 */   GIM_Try, /*On fail goto*//*Label 20941*/ GIMT_Encode4(1503834), // Rule ID 62060 //
     /* 1503742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1503745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1503750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1503753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1503756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1503759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1503762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1503765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1503772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1503784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1503788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1503792 */     // MIs[1] Operand 1
     /* 1503792 */     // No operand predicates
     /* 1503792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503796 */     // MIs[0] policy
     /* 1503796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1503801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503808 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1503811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1503820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503833 */     // GIR_Coverage, 62060,
     /* 1503833 */     GIR_EraseRootFromParent_Done,
     /* 1503834 */   // Label 20941: @1503834
     /* 1503834 */   GIM_Try, /*On fail goto*//*Label 20942*/ GIMT_Encode4(1503931), // Rule ID 62061 //
     /* 1503839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1503842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1503847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1503850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1503853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1503856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1503859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1503862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1503869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1503881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1503885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1503889 */     // MIs[1] Operand 1
     /* 1503889 */     // No operand predicates
     /* 1503889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503893 */     // MIs[0] policy
     /* 1503893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1503898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503905 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1503908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1503912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1503917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1503919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503930 */     // GIR_Coverage, 62061,
     /* 1503930 */     GIR_EraseRootFromParent_Done,
     /* 1503931 */   // Label 20942: @1503931
     /* 1503931 */   GIM_Try, /*On fail goto*//*Label 20943*/ GIMT_Encode4(1504028), // Rule ID 62064 //
     /* 1503936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1503939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1503944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1503953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1503956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1503959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1503966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1503978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1503982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1503986 */     // MIs[1] Operand 1
     /* 1503986 */     // No operand predicates
     /* 1503986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1503990 */     // MIs[0] policy
     /* 1503990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1503995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1504005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1504014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504027 */     // GIR_Coverage, 62064,
     /* 1504027 */     GIR_EraseRootFromParent_Done,
     /* 1504028 */   // Label 20943: @1504028
     /* 1504028 */   GIM_Try, /*On fail goto*//*Label 20944*/ GIMT_Encode4(1504125), // Rule ID 62065 //
     /* 1504033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1504036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1504041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1504044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1504047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1504050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1504053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1504056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1504063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1504075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1504079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1504083 */     // MIs[1] Operand 1
     /* 1504083 */     // No operand predicates
     /* 1504083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504087 */     // MIs[0] policy
     /* 1504087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1504092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504099 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1504102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1504111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504124 */     // GIR_Coverage, 62065,
     /* 1504124 */     GIR_EraseRootFromParent_Done,
     /* 1504125 */   // Label 20944: @1504125
     /* 1504125 */   GIM_Try, /*On fail goto*//*Label 20945*/ GIMT_Encode4(1504222), // Rule ID 62068 //
     /* 1504130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1504133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1504138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1504141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1504144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1504147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1504150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1504153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1504160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1504172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1504176 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1504180 */     // MIs[1] Operand 1
     /* 1504180 */     // No operand predicates
     /* 1504180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504184 */     // MIs[0] policy
     /* 1504184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1504189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1504199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1504208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504221 */     // GIR_Coverage, 62068,
     /* 1504221 */     GIR_EraseRootFromParent_Done,
     /* 1504222 */   // Label 20945: @1504222
     /* 1504222 */   GIM_Try, /*On fail goto*//*Label 20946*/ GIMT_Encode4(1504319), // Rule ID 62069 //
     /* 1504227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1504230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1504235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1504238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1504241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1504244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1504247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1504250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1504257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1504269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1504273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1504277 */     // MIs[1] Operand 1
     /* 1504277 */     // No operand predicates
     /* 1504277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504281 */     // MIs[0] policy
     /* 1504281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1504286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504293 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1504296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1504305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504318 */     // GIR_Coverage, 62069,
     /* 1504318 */     GIR_EraseRootFromParent_Done,
     /* 1504319 */   // Label 20946: @1504319
     /* 1504319 */   GIM_Try, /*On fail goto*//*Label 20947*/ GIMT_Encode4(1504416), // Rule ID 62072 //
     /* 1504324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1504327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1504332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1504335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1504338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1504341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1504344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1504347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1504354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1504366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1504370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1504374 */     // MIs[1] Operand 1
     /* 1504374 */     // No operand predicates
     /* 1504374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504378 */     // MIs[0] policy
     /* 1504378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1504383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504390 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1504393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1504402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504415 */     // GIR_Coverage, 62072,
     /* 1504415 */     GIR_EraseRootFromParent_Done,
     /* 1504416 */   // Label 20947: @1504416
     /* 1504416 */   GIM_Try, /*On fail goto*//*Label 20948*/ GIMT_Encode4(1504513), // Rule ID 62073 //
     /* 1504421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1504424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1504429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1504432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1504435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1504438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1504441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1504444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1504451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1504463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1504467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1504471 */     // MIs[1] Operand 1
     /* 1504471 */     // No operand predicates
     /* 1504471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504475 */     // MIs[0] policy
     /* 1504475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1504480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504487 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1504490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1504499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504512 */     // GIR_Coverage, 62073,
     /* 1504512 */     GIR_EraseRootFromParent_Done,
     /* 1504513 */   // Label 20948: @1504513
     /* 1504513 */   GIM_Try, /*On fail goto*//*Label 20949*/ GIMT_Encode4(1504610), // Rule ID 62076 //
     /* 1504518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1504521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1504526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1504529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1504532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1504535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1504538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1504541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1504548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1504560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1504564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1504568 */     // MIs[1] Operand 1
     /* 1504568 */     // No operand predicates
     /* 1504568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504572 */     // MIs[0] policy
     /* 1504572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1504577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504584 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1504587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1504596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504609 */     // GIR_Coverage, 62076,
     /* 1504609 */     GIR_EraseRootFromParent_Done,
     /* 1504610 */   // Label 20949: @1504610
     /* 1504610 */   GIM_Try, /*On fail goto*//*Label 20950*/ GIMT_Encode4(1504707), // Rule ID 62077 //
     /* 1504615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1504618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1504623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1504626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1504629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1504632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1504635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1504638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1504645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1504657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1504661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1504665 */     // MIs[1] Operand 1
     /* 1504665 */     // No operand predicates
     /* 1504665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504669 */     // MIs[0] policy
     /* 1504669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1504674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504681 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1504684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1504693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504706 */     // GIR_Coverage, 62077,
     /* 1504706 */     GIR_EraseRootFromParent_Done,
     /* 1504707 */   // Label 20950: @1504707
     /* 1504707 */   GIM_Try, /*On fail goto*//*Label 20951*/ GIMT_Encode4(1504804), // Rule ID 62080 //
     /* 1504712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1504715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1504720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1504723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1504726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1504729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1504732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1504735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1504742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1504754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1504758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1504762 */     // MIs[1] Operand 1
     /* 1504762 */     // No operand predicates
     /* 1504762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504766 */     // MIs[0] policy
     /* 1504766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1504771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504778 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1504781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1504790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504803 */     // GIR_Coverage, 62080,
     /* 1504803 */     GIR_EraseRootFromParent_Done,
     /* 1504804 */   // Label 20951: @1504804
     /* 1504804 */   GIM_Try, /*On fail goto*//*Label 20952*/ GIMT_Encode4(1504901), // Rule ID 62081 //
     /* 1504809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1504812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1504817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1504820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1504823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1504826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1504829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1504832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1504839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1504851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1504855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1504859 */     // MIs[1] Operand 1
     /* 1504859 */     // No operand predicates
     /* 1504859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504863 */     // MIs[0] policy
     /* 1504863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1504868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504875 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1504878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1504887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1504889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504900 */     // GIR_Coverage, 62081,
     /* 1504900 */     GIR_EraseRootFromParent_Done,
     /* 1504901 */   // Label 20952: @1504901
     /* 1504901 */   GIM_Try, /*On fail goto*//*Label 20953*/ GIMT_Encode4(1504983), // Rule ID 2700 //
     /* 1504906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1504914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1504917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1504920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1504923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1504926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1504933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1504945 */     // MIs[0] round
     /* 1504945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504948 */     // MIs[0] policy
     /* 1504948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504958 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1504961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1504965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1504967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1504969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504982 */     // GIR_Coverage, 2700,
     /* 1504982 */     GIR_EraseRootFromParent_Done,
     /* 1504983 */   // Label 20953: @1504983
     /* 1504983 */   GIM_Try, /*On fail goto*//*Label 20954*/ GIMT_Encode4(1505065), // Rule ID 2701 //
     /* 1504988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1504996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1504999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1505002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1505005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1505008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1505015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505027 */     // MIs[0] round
     /* 1505027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505030 */     // MIs[0] policy
     /* 1505030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505040 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1505043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1505049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1505051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505064 */     // GIR_Coverage, 2701,
     /* 1505064 */     GIR_EraseRootFromParent_Done,
     /* 1505065 */   // Label 20954: @1505065
     /* 1505065 */   GIM_Try, /*On fail goto*//*Label 20955*/ GIMT_Encode4(1505147), // Rule ID 2736 //
     /* 1505070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1505073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1505078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1505081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1505084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1505087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1505090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1505097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505109 */     // MIs[0] round
     /* 1505109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505112 */     // MIs[0] policy
     /* 1505112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505122 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1505125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1505131 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1505133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505146 */     // GIR_Coverage, 2736,
     /* 1505146 */     GIR_EraseRootFromParent_Done,
     /* 1505147 */   // Label 20955: @1505147
     /* 1505147 */   GIM_Try, /*On fail goto*//*Label 20956*/ GIMT_Encode4(1505229), // Rule ID 2737 //
     /* 1505152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1505155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1505160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1505163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1505166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1505169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1505172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1505179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1505191 */     // MIs[0] round
     /* 1505191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505194 */     // MIs[0] policy
     /* 1505194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505204 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1505207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1505211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1505213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1505215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505228 */     // GIR_Coverage, 2737,
     /* 1505228 */     GIR_EraseRootFromParent_Done,
     /* 1505229 */   // Label 20956: @1505229
     /* 1505229 */   GIM_Try, /*On fail goto*//*Label 20957*/ GIMT_Encode4(1505311), // Rule ID 2768 //
     /* 1505234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1505245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1505248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1505251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1505254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505273 */     // MIs[0] round
     /* 1505273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505276 */     // MIs[0] policy
     /* 1505276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505286 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1505289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505310 */     // GIR_Coverage, 2768,
     /* 1505310 */     GIR_EraseRootFromParent_Done,
     /* 1505311 */   // Label 20957: @1505311
     /* 1505311 */   GIM_Try, /*On fail goto*//*Label 20958*/ GIMT_Encode4(1505393), // Rule ID 2769 //
     /* 1505316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1505327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1505330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1505333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1505336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505355 */     // MIs[0] round
     /* 1505355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505358 */     // MIs[0] policy
     /* 1505358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505368 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1505371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505392 */     // GIR_Coverage, 2769,
     /* 1505392 */     GIR_EraseRootFromParent_Done,
     /* 1505393 */   // Label 20958: @1505393
     /* 1505393 */   GIM_Try, /*On fail goto*//*Label 20959*/ GIMT_Encode4(1505475), // Rule ID 17748 //
     /* 1505398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1505409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1505412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1505415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1505418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505437 */     // MIs[0] round
     /* 1505437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505440 */     // MIs[0] policy
     /* 1505440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505450 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1505453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505474 */     // GIR_Coverage, 17748,
     /* 1505474 */     GIR_EraseRootFromParent_Done,
     /* 1505475 */   // Label 20959: @1505475
     /* 1505475 */   GIM_Try, /*On fail goto*//*Label 20960*/ GIMT_Encode4(1505557), // Rule ID 17749 //
     /* 1505480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1505491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1505494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1505497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1505500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505519 */     // MIs[0] round
     /* 1505519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505522 */     // MIs[0] policy
     /* 1505522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505532 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1505535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505556 */     // GIR_Coverage, 17749,
     /* 1505556 */     GIR_EraseRootFromParent_Done,
     /* 1505557 */   // Label 20960: @1505557
     /* 1505557 */   GIM_Try, /*On fail goto*//*Label 20961*/ GIMT_Encode4(1505639), // Rule ID 17752 //
     /* 1505562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1505573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1505576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1505579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1505582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505601 */     // MIs[0] round
     /* 1505601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505604 */     // MIs[0] policy
     /* 1505604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505614 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1505617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505638 */     // GIR_Coverage, 17752,
     /* 1505638 */     GIR_EraseRootFromParent_Done,
     /* 1505639 */   // Label 20961: @1505639
     /* 1505639 */   GIM_Try, /*On fail goto*//*Label 20962*/ GIMT_Encode4(1505721), // Rule ID 17753 //
     /* 1505644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1505655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1505658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1505661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1505664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505683 */     // MIs[0] round
     /* 1505683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505686 */     // MIs[0] policy
     /* 1505686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505696 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1505699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505720 */     // GIR_Coverage, 17753,
     /* 1505720 */     GIR_EraseRootFromParent_Done,
     /* 1505721 */   // Label 20962: @1505721
     /* 1505721 */   GIM_Try, /*On fail goto*//*Label 20963*/ GIMT_Encode4(1505803), // Rule ID 17756 //
     /* 1505726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1505737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1505740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1505743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1505746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505765 */     // MIs[0] round
     /* 1505765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505768 */     // MIs[0] policy
     /* 1505768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505778 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1505781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505802 */     // GIR_Coverage, 17756,
     /* 1505802 */     GIR_EraseRootFromParent_Done,
     /* 1505803 */   // Label 20963: @1505803
     /* 1505803 */   GIM_Try, /*On fail goto*//*Label 20964*/ GIMT_Encode4(1505885), // Rule ID 17757 //
     /* 1505808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1505819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1505822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1505825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1505828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505847 */     // MIs[0] round
     /* 1505847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505850 */     // MIs[0] policy
     /* 1505850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505860 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1505863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505884 */     // GIR_Coverage, 17757,
     /* 1505884 */     GIR_EraseRootFromParent_Done,
     /* 1505885 */   // Label 20964: @1505885
     /* 1505885 */   GIM_Try, /*On fail goto*//*Label 20965*/ GIMT_Encode4(1505967), // Rule ID 17760 //
     /* 1505890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1505901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1505904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1505907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1505910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505929 */     // MIs[0] round
     /* 1505929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505932 */     // MIs[0] policy
     /* 1505932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505942 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1505945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505966 */     // GIR_Coverage, 17760,
     /* 1505966 */     GIR_EraseRootFromParent_Done,
     /* 1505967 */   // Label 20965: @1505967
     /* 1505967 */   GIM_Try, /*On fail goto*//*Label 20966*/ GIMT_Encode4(1506049), // Rule ID 17761 //
     /* 1505972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1505983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1505986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1505989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1505992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506011 */     // MIs[0] round
     /* 1506011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506014 */     // MIs[0] policy
     /* 1506014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506024 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1506027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506048 */     // GIR_Coverage, 17761,
     /* 1506048 */     GIR_EraseRootFromParent_Done,
     /* 1506049 */   // Label 20966: @1506049
     /* 1506049 */   GIM_Try, /*On fail goto*//*Label 20967*/ GIMT_Encode4(1506131), // Rule ID 17764 //
     /* 1506054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1506065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1506068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1506071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1506074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506093 */     // MIs[0] round
     /* 1506093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506096 */     // MIs[0] policy
     /* 1506096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506106 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1506109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506130 */     // GIR_Coverage, 17764,
     /* 1506130 */     GIR_EraseRootFromParent_Done,
     /* 1506131 */   // Label 20967: @1506131
     /* 1506131 */   GIM_Try, /*On fail goto*//*Label 20968*/ GIMT_Encode4(1506213), // Rule ID 17765 //
     /* 1506136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1506147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1506150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1506153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1506156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506175 */     // MIs[0] round
     /* 1506175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506178 */     // MIs[0] policy
     /* 1506178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506188 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1506191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506212 */     // GIR_Coverage, 17765,
     /* 1506212 */     GIR_EraseRootFromParent_Done,
     /* 1506213 */   // Label 20968: @1506213
     /* 1506213 */   GIM_Try, /*On fail goto*//*Label 20969*/ GIMT_Encode4(1506295), // Rule ID 17768 //
     /* 1506218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1506229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1506232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1506235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1506238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506257 */     // MIs[0] round
     /* 1506257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506260 */     // MIs[0] policy
     /* 1506260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506270 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1506273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506294 */     // GIR_Coverage, 17768,
     /* 1506294 */     GIR_EraseRootFromParent_Done,
     /* 1506295 */   // Label 20969: @1506295
     /* 1506295 */   GIM_Try, /*On fail goto*//*Label 20970*/ GIMT_Encode4(1506377), // Rule ID 17769 //
     /* 1506300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1506311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1506314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1506317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1506320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506339 */     // MIs[0] round
     /* 1506339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506342 */     // MIs[0] policy
     /* 1506342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506352 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1506355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506376 */     // GIR_Coverage, 17769,
     /* 1506376 */     GIR_EraseRootFromParent_Done,
     /* 1506377 */   // Label 20970: @1506377
     /* 1506377 */   GIM_Try, /*On fail goto*//*Label 20971*/ GIMT_Encode4(1506459), // Rule ID 17772 //
     /* 1506382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1506393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1506396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1506399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1506402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506421 */     // MIs[0] round
     /* 1506421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506424 */     // MIs[0] policy
     /* 1506424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506434 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1506437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506458 */     // GIR_Coverage, 17772,
     /* 1506458 */     GIR_EraseRootFromParent_Done,
     /* 1506459 */   // Label 20971: @1506459
     /* 1506459 */   GIM_Try, /*On fail goto*//*Label 20972*/ GIMT_Encode4(1506541), // Rule ID 17773 //
     /* 1506464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1506475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1506478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1506481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1506484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506503 */     // MIs[0] round
     /* 1506503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506506 */     // MIs[0] policy
     /* 1506506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506516 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1506519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506540 */     // GIR_Coverage, 17773,
     /* 1506540 */     GIR_EraseRootFromParent_Done,
     /* 1506541 */   // Label 20972: @1506541
     /* 1506541 */   GIM_Try, /*On fail goto*//*Label 20973*/ GIMT_Encode4(1506623), // Rule ID 17776 //
     /* 1506546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1506557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1506560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1506563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1506566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506585 */     // MIs[0] round
     /* 1506585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506588 */     // MIs[0] policy
     /* 1506588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506598 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1506601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506622 */     // GIR_Coverage, 17776,
     /* 1506622 */     GIR_EraseRootFromParent_Done,
     /* 1506623 */   // Label 20973: @1506623
     /* 1506623 */   GIM_Try, /*On fail goto*//*Label 20974*/ GIMT_Encode4(1506705), // Rule ID 17777 //
     /* 1506628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1506639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1506642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1506645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1506648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506667 */     // MIs[0] round
     /* 1506667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506670 */     // MIs[0] policy
     /* 1506670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506680 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1506683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506704 */     // GIR_Coverage, 17777,
     /* 1506704 */     GIR_EraseRootFromParent_Done,
     /* 1506705 */   // Label 20974: @1506705
     /* 1506705 */   GIM_Try, /*On fail goto*//*Label 20975*/ GIMT_Encode4(1506787), // Rule ID 17780 //
     /* 1506710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1506713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1506721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1506724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1506727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1506730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506749 */     // MIs[0] round
     /* 1506749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506752 */     // MIs[0] policy
     /* 1506752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506762 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1506765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506786 */     // GIR_Coverage, 17780,
     /* 1506786 */     GIR_EraseRootFromParent_Done,
     /* 1506787 */   // Label 20975: @1506787
     /* 1506787 */   GIM_Try, /*On fail goto*//*Label 20976*/ GIMT_Encode4(1506869), // Rule ID 17781 //
     /* 1506792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1506795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1506803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1506806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1506809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1506812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506831 */     // MIs[0] round
     /* 1506831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506834 */     // MIs[0] policy
     /* 1506834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506844 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1506847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506868 */     // GIR_Coverage, 17781,
     /* 1506868 */     GIR_EraseRootFromParent_Done,
     /* 1506869 */   // Label 20976: @1506869
     /* 1506869 */   GIM_Try, /*On fail goto*//*Label 20977*/ GIMT_Encode4(1506951), // Rule ID 17784 //
     /* 1506874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1506877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1506885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1506888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1506891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1506894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506913 */     // MIs[0] round
     /* 1506913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506916 */     // MIs[0] policy
     /* 1506916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506926 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1506929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506950 */     // GIR_Coverage, 17784,
     /* 1506950 */     GIR_EraseRootFromParent_Done,
     /* 1506951 */   // Label 20977: @1506951
     /* 1506951 */   GIM_Try, /*On fail goto*//*Label 20978*/ GIMT_Encode4(1507033), // Rule ID 17785 //
     /* 1506956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1506959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1506967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1506970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1506973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1506976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506995 */     // MIs[0] round
     /* 1506995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506998 */     // MIs[0] policy
     /* 1506998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507008 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1507011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507032 */     // GIR_Coverage, 17785,
     /* 1507032 */     GIR_EraseRootFromParent_Done,
     /* 1507033 */   // Label 20978: @1507033
     /* 1507033 */   GIM_Try, /*On fail goto*//*Label 20979*/ GIMT_Encode4(1507115), // Rule ID 17788 //
     /* 1507038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1507041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1507046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1507049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1507052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1507055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1507058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507077 */     // MIs[0] round
     /* 1507077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507080 */     // MIs[0] policy
     /* 1507080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507090 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1507093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507114 */     // GIR_Coverage, 17788,
     /* 1507114 */     GIR_EraseRootFromParent_Done,
     /* 1507115 */   // Label 20979: @1507115
     /* 1507115 */   GIM_Try, /*On fail goto*//*Label 20980*/ GIMT_Encode4(1507197), // Rule ID 17789 //
     /* 1507120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1507123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1507128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1507131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1507134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1507137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1507140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507159 */     // MIs[0] round
     /* 1507159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507162 */     // MIs[0] policy
     /* 1507162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507172 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1507175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507196 */     // GIR_Coverage, 17789,
     /* 1507196 */     GIR_EraseRootFromParent_Done,
     /* 1507197 */   // Label 20980: @1507197
     /* 1507197 */   GIM_Try, /*On fail goto*//*Label 20981*/ GIMT_Encode4(1507279), // Rule ID 17792 //
     /* 1507202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1507205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1507210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1507213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1507216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1507219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1507222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507241 */     // MIs[0] round
     /* 1507241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507244 */     // MIs[0] policy
     /* 1507244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507254 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1507257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507278 */     // GIR_Coverage, 17792,
     /* 1507278 */     GIR_EraseRootFromParent_Done,
     /* 1507279 */   // Label 20981: @1507279
     /* 1507279 */   GIM_Try, /*On fail goto*//*Label 20982*/ GIMT_Encode4(1507361), // Rule ID 17793 //
     /* 1507284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1507287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1507292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1507295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1507298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1507301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1507304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507323 */     // MIs[0] round
     /* 1507323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507326 */     // MIs[0] policy
     /* 1507326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507336 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1507339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507360 */     // GIR_Coverage, 17793,
     /* 1507360 */     GIR_EraseRootFromParent_Done,
     /* 1507361 */   // Label 20982: @1507361
     /* 1507361 */   GIM_Try, /*On fail goto*//*Label 20983*/ GIMT_Encode4(1507443), // Rule ID 17796 //
     /* 1507366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1507369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1507374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1507377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1507380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1507383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1507386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507405 */     // MIs[0] round
     /* 1507405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507408 */     // MIs[0] policy
     /* 1507408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507418 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1507421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507442 */     // GIR_Coverage, 17796,
     /* 1507442 */     GIR_EraseRootFromParent_Done,
     /* 1507443 */   // Label 20983: @1507443
     /* 1507443 */   GIM_Try, /*On fail goto*//*Label 20984*/ GIMT_Encode4(1507525), // Rule ID 17797 //
     /* 1507448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1507451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1507456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1507459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1507462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1507465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1507468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507487 */     // MIs[0] round
     /* 1507487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507490 */     // MIs[0] policy
     /* 1507490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507500 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1507503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507524 */     // GIR_Coverage, 17797,
     /* 1507524 */     GIR_EraseRootFromParent_Done,
     /* 1507525 */   // Label 20984: @1507525
     /* 1507525 */   GIM_Try, /*On fail goto*//*Label 20985*/ GIMT_Encode4(1507607), // Rule ID 17800 //
     /* 1507530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1507533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1507538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1507541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1507544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1507547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1507550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507569 */     // MIs[0] round
     /* 1507569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507572 */     // MIs[0] policy
     /* 1507572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507582 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1507585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507606 */     // GIR_Coverage, 17800,
     /* 1507606 */     GIR_EraseRootFromParent_Done,
     /* 1507607 */   // Label 20985: @1507607
     /* 1507607 */   GIM_Try, /*On fail goto*//*Label 20986*/ GIMT_Encode4(1507689), // Rule ID 17801 //
     /* 1507612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1507615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1507620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1507623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1507626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1507629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1507632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507651 */     // MIs[0] round
     /* 1507651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507654 */     // MIs[0] policy
     /* 1507654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507664 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1507667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507688 */     // GIR_Coverage, 17801,
     /* 1507688 */     GIR_EraseRootFromParent_Done,
     /* 1507689 */   // Label 20986: @1507689
     /* 1507689 */   GIM_Try, /*On fail goto*//*Label 20987*/ GIMT_Encode4(1507771), // Rule ID 17804 //
     /* 1507694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1507702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1507705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1507708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1507714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507733 */     // MIs[0] round
     /* 1507733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507736 */     // MIs[0] policy
     /* 1507736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507746 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1507749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507770 */     // GIR_Coverage, 17804,
     /* 1507770 */     GIR_EraseRootFromParent_Done,
     /* 1507771 */   // Label 20987: @1507771
     /* 1507771 */   GIM_Try, /*On fail goto*//*Label 20988*/ GIMT_Encode4(1507853), // Rule ID 17805 //
     /* 1507776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1507784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1507787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1507790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1507796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507815 */     // MIs[0] round
     /* 1507815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507818 */     // MIs[0] policy
     /* 1507818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507828 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1507831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507852 */     // GIR_Coverage, 17805,
     /* 1507852 */     GIR_EraseRootFromParent_Done,
     /* 1507853 */   // Label 20988: @1507853
     /* 1507853 */   GIM_Try, /*On fail goto*//*Label 20989*/ GIMT_Encode4(1507935), // Rule ID 17808 //
     /* 1507858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1507866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1507869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1507872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1507878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507897 */     // MIs[0] round
     /* 1507897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507900 */     // MIs[0] policy
     /* 1507900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507910 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1507913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507934 */     // GIR_Coverage, 17808,
     /* 1507934 */     GIR_EraseRootFromParent_Done,
     /* 1507935 */   // Label 20989: @1507935
     /* 1507935 */   GIM_Try, /*On fail goto*//*Label 20990*/ GIMT_Encode4(1508017), // Rule ID 17809 //
     /* 1507940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1507948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1507951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1507954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1507960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507979 */     // MIs[0] round
     /* 1507979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507982 */     // MIs[0] policy
     /* 1507982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507992 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1507995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508016 */     // GIR_Coverage, 17809,
     /* 1508016 */     GIR_EraseRootFromParent_Done,
     /* 1508017 */   // Label 20990: @1508017
     /* 1508017 */   GIM_Try, /*On fail goto*//*Label 20991*/ GIMT_Encode4(1508099), // Rule ID 17812 //
     /* 1508022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1508030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1508033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1508036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1508042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508061 */     // MIs[0] round
     /* 1508061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508064 */     // MIs[0] policy
     /* 1508064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508074 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1508077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508098 */     // GIR_Coverage, 17812,
     /* 1508098 */     GIR_EraseRootFromParent_Done,
     /* 1508099 */   // Label 20991: @1508099
     /* 1508099 */   GIM_Try, /*On fail goto*//*Label 20992*/ GIMT_Encode4(1508181), // Rule ID 17813 //
     /* 1508104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1508112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1508115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1508118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1508124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508143 */     // MIs[0] round
     /* 1508143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508146 */     // MIs[0] policy
     /* 1508146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508156 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1508159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508180 */     // GIR_Coverage, 17813,
     /* 1508180 */     GIR_EraseRootFromParent_Done,
     /* 1508181 */   // Label 20992: @1508181
     /* 1508181 */   GIM_Try, /*On fail goto*//*Label 20993*/ GIMT_Encode4(1508263), // Rule ID 17816 //
     /* 1508186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1508189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1508194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1508197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1508200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1508206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508225 */     // MIs[0] round
     /* 1508225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508228 */     // MIs[0] policy
     /* 1508228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508238 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1508241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508262 */     // GIR_Coverage, 17816,
     /* 1508262 */     GIR_EraseRootFromParent_Done,
     /* 1508263 */   // Label 20993: @1508263
     /* 1508263 */   GIM_Try, /*On fail goto*//*Label 20994*/ GIMT_Encode4(1508345), // Rule ID 17817 //
     /* 1508268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1508271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1508276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1508279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1508282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1508288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508307 */     // MIs[0] round
     /* 1508307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508310 */     // MIs[0] policy
     /* 1508310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508320 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1508323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508344 */     // GIR_Coverage, 17817,
     /* 1508344 */     GIR_EraseRootFromParent_Done,
     /* 1508345 */   // Label 20994: @1508345
     /* 1508345 */   GIM_Try, /*On fail goto*//*Label 20995*/ GIMT_Encode4(1508427), // Rule ID 17820 //
     /* 1508350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1508358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1508361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1508364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1508370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508389 */     // MIs[0] round
     /* 1508389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508392 */     // MIs[0] policy
     /* 1508392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508402 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1508405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508426 */     // GIR_Coverage, 17820,
     /* 1508426 */     GIR_EraseRootFromParent_Done,
     /* 1508427 */   // Label 20995: @1508427
     /* 1508427 */   GIM_Try, /*On fail goto*//*Label 20996*/ GIMT_Encode4(1508509), // Rule ID 17821 //
     /* 1508432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1508440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1508443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1508446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1508452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508471 */     // MIs[0] round
     /* 1508471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508474 */     // MIs[0] policy
     /* 1508474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508484 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1508487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508508 */     // GIR_Coverage, 17821,
     /* 1508508 */     GIR_EraseRootFromParent_Done,
     /* 1508509 */   // Label 20996: @1508509
     /* 1508509 */   GIM_Try, /*On fail goto*//*Label 20997*/ GIMT_Encode4(1508591), // Rule ID 17824 //
     /* 1508514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1508522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1508525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1508528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1508531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1508534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1508549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508553 */     // MIs[0] round
     /* 1508553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508556 */     // MIs[0] policy
     /* 1508556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508566 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1508569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508590 */     // GIR_Coverage, 17824,
     /* 1508590 */     GIR_EraseRootFromParent_Done,
     /* 1508591 */   // Label 20997: @1508591
     /* 1508591 */   GIM_Try, /*On fail goto*//*Label 20998*/ GIMT_Encode4(1508673), // Rule ID 17825 //
     /* 1508596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1508604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1508607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1508610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1508613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1508616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1508631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508635 */     // MIs[0] round
     /* 1508635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508638 */     // MIs[0] policy
     /* 1508638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508648 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1508651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508672 */     // GIR_Coverage, 17825,
     /* 1508672 */     GIR_EraseRootFromParent_Done,
     /* 1508673 */   // Label 20998: @1508673
     /* 1508673 */   GIM_Try, /*On fail goto*//*Label 20999*/ GIMT_Encode4(1508755), // Rule ID 17828 //
     /* 1508678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1508681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1508686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1508689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1508692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1508698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508717 */     // MIs[0] round
     /* 1508717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508720 */     // MIs[0] policy
     /* 1508720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508730 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1508733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508754 */     // GIR_Coverage, 17828,
     /* 1508754 */     GIR_EraseRootFromParent_Done,
     /* 1508755 */   // Label 20999: @1508755
     /* 1508755 */   GIM_Try, /*On fail goto*//*Label 21000*/ GIMT_Encode4(1508837), // Rule ID 17829 //
     /* 1508760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1508763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1508768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1508771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1508774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1508780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508799 */     // MIs[0] round
     /* 1508799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508802 */     // MIs[0] policy
     /* 1508802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508812 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1508815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508836 */     // GIR_Coverage, 17829,
     /* 1508836 */     GIR_EraseRootFromParent_Done,
     /* 1508837 */   // Label 21000: @1508837
     /* 1508837 */   GIM_Try, /*On fail goto*//*Label 21001*/ GIMT_Encode4(1508919), // Rule ID 17832 //
     /* 1508842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1508845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1508850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1508853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1508856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1508862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508881 */     // MIs[0] round
     /* 1508881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508884 */     // MIs[0] policy
     /* 1508884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508894 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1508897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508918 */     // GIR_Coverage, 17832,
     /* 1508918 */     GIR_EraseRootFromParent_Done,
     /* 1508919 */   // Label 21001: @1508919
     /* 1508919 */   GIM_Try, /*On fail goto*//*Label 21002*/ GIMT_Encode4(1509001), // Rule ID 17833 //
     /* 1508924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1508927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1508932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1508935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1508938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1508944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508963 */     // MIs[0] round
     /* 1508963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508966 */     // MIs[0] policy
     /* 1508966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508976 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1508979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509000 */     // GIR_Coverage, 17833,
     /* 1509000 */     GIR_EraseRootFromParent_Done,
     /* 1509001 */   // Label 21002: @1509001
     /* 1509001 */   GIM_Try, /*On fail goto*//*Label 21003*/ GIMT_Encode4(1509083), // Rule ID 17836 //
     /* 1509006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1509014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1509017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1509020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1509026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509045 */     // MIs[0] round
     /* 1509045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509048 */     // MIs[0] policy
     /* 1509048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509058 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1509061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509082 */     // GIR_Coverage, 17836,
     /* 1509082 */     GIR_EraseRootFromParent_Done,
     /* 1509083 */   // Label 21003: @1509083
     /* 1509083 */   GIM_Try, /*On fail goto*//*Label 21004*/ GIMT_Encode4(1509165), // Rule ID 17837 //
     /* 1509088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1509096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1509099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1509102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1509108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509127 */     // MIs[0] round
     /* 1509127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509130 */     // MIs[0] policy
     /* 1509130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509140 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1509143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509164 */     // GIR_Coverage, 17837,
     /* 1509164 */     GIR_EraseRootFromParent_Done,
     /* 1509165 */   // Label 21004: @1509165
     /* 1509165 */   GIM_Try, /*On fail goto*//*Label 21005*/ GIMT_Encode4(1509247), // Rule ID 17840 //
     /* 1509170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1509178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1509181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1509184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1509190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509209 */     // MIs[0] round
     /* 1509209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509212 */     // MIs[0] policy
     /* 1509212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509222 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1509225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509246 */     // GIR_Coverage, 17840,
     /* 1509246 */     GIR_EraseRootFromParent_Done,
     /* 1509247 */   // Label 21005: @1509247
     /* 1509247 */   GIM_Try, /*On fail goto*//*Label 21006*/ GIMT_Encode4(1509329), // Rule ID 17841 //
     /* 1509252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1509260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1509263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1509266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1509272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509291 */     // MIs[0] round
     /* 1509291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509294 */     // MIs[0] policy
     /* 1509294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509304 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1509307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509328 */     // GIR_Coverage, 17841,
     /* 1509328 */     GIR_EraseRootFromParent_Done,
     /* 1509329 */   // Label 21006: @1509329
     /* 1509329 */   GIM_Try, /*On fail goto*//*Label 21007*/ GIMT_Encode4(1509411), // Rule ID 17844 //
     /* 1509334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1509342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1509345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1509348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1509354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509373 */     // MIs[0] round
     /* 1509373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509376 */     // MIs[0] policy
     /* 1509376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509386 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1509389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509410 */     // GIR_Coverage, 17844,
     /* 1509410 */     GIR_EraseRootFromParent_Done,
     /* 1509411 */   // Label 21007: @1509411
     /* 1509411 */   GIM_Try, /*On fail goto*//*Label 21008*/ GIMT_Encode4(1509493), // Rule ID 17845 //
     /* 1509416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1509424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1509427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1509430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1509436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509455 */     // MIs[0] round
     /* 1509455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509458 */     // MIs[0] policy
     /* 1509458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509468 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1509471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509492 */     // GIR_Coverage, 17845,
     /* 1509492 */     GIR_EraseRootFromParent_Done,
     /* 1509493 */   // Label 21008: @1509493
     /* 1509493 */   GIM_Try, /*On fail goto*//*Label 21009*/ GIMT_Encode4(1509575), // Rule ID 17848 //
     /* 1509498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1509506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1509509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1509512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1509518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509537 */     // MIs[0] round
     /* 1509537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509540 */     // MIs[0] policy
     /* 1509540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509550 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1509553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509574 */     // GIR_Coverage, 17848,
     /* 1509574 */     GIR_EraseRootFromParent_Done,
     /* 1509575 */   // Label 21009: @1509575
     /* 1509575 */   GIM_Try, /*On fail goto*//*Label 21010*/ GIMT_Encode4(1509657), // Rule ID 17849 //
     /* 1509580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1509588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1509591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1509594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1509600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509619 */     // MIs[0] round
     /* 1509619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509622 */     // MIs[0] policy
     /* 1509622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509632 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1509635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509656 */     // GIR_Coverage, 17849,
     /* 1509656 */     GIR_EraseRootFromParent_Done,
     /* 1509657 */   // Label 21010: @1509657
     /* 1509657 */   GIM_Try, /*On fail goto*//*Label 21011*/ GIMT_Encode4(1509739), // Rule ID 17852 //
     /* 1509662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1509665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1509670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1509673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1509676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1509682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509701 */     // MIs[0] round
     /* 1509701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509704 */     // MIs[0] policy
     /* 1509704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509714 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1509717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509738 */     // GIR_Coverage, 17852,
     /* 1509738 */     GIR_EraseRootFromParent_Done,
     /* 1509739 */   // Label 21011: @1509739
     /* 1509739 */   GIM_Try, /*On fail goto*//*Label 21012*/ GIMT_Encode4(1509821), // Rule ID 17853 //
     /* 1509744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1509747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1509752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1509755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1509758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1509764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509783 */     // MIs[0] round
     /* 1509783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509786 */     // MIs[0] policy
     /* 1509786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509796 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1509799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509820 */     // GIR_Coverage, 17853,
     /* 1509820 */     GIR_EraseRootFromParent_Done,
     /* 1509821 */   // Label 21012: @1509821
     /* 1509821 */   GIM_Try, /*On fail goto*//*Label 21013*/ GIMT_Encode4(1509903), // Rule ID 17856 //
     /* 1509826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1509829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1509834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1509837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1509840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1509846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509865 */     // MIs[0] round
     /* 1509865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509868 */     // MIs[0] policy
     /* 1509868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509878 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1509881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509902 */     // GIR_Coverage, 17856,
     /* 1509902 */     GIR_EraseRootFromParent_Done,
     /* 1509903 */   // Label 21013: @1509903
     /* 1509903 */   GIM_Try, /*On fail goto*//*Label 21014*/ GIMT_Encode4(1509985), // Rule ID 17857 //
     /* 1509908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1509911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1509916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1509919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1509922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1509928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509947 */     // MIs[0] round
     /* 1509947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509950 */     // MIs[0] policy
     /* 1509950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509960 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1509963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509984 */     // GIR_Coverage, 17857,
     /* 1509984 */     GIR_EraseRootFromParent_Done,
     /* 1509985 */   // Label 21014: @1509985
     /* 1509985 */   GIM_Try, /*On fail goto*//*Label 21015*/ GIMT_Encode4(1510067), // Rule ID 17860 //
     /* 1509990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1509993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1509998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1510001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1510004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1510007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1510010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1510025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510029 */     // MIs[0] round
     /* 1510029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510032 */     // MIs[0] policy
     /* 1510032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510042 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1510045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510066 */     // GIR_Coverage, 17860,
     /* 1510066 */     GIR_EraseRootFromParent_Done,
     /* 1510067 */   // Label 21015: @1510067
     /* 1510067 */   GIM_Try, /*On fail goto*//*Label 21016*/ GIMT_Encode4(1510149), // Rule ID 17861 //
     /* 1510072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1510075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1510080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1510083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1510086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1510089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1510092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1510107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510111 */     // MIs[0] round
     /* 1510111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510114 */     // MIs[0] policy
     /* 1510114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510124 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1510127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510148 */     // GIR_Coverage, 17861,
     /* 1510148 */     GIR_EraseRootFromParent_Done,
     /* 1510149 */   // Label 21016: @1510149
     /* 1510149 */   GIM_Try, /*On fail goto*//*Label 21017*/ GIMT_Encode4(1510231), // Rule ID 17864 //
     /* 1510154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1510165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1510168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1510171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1510174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510193 */     // MIs[0] round
     /* 1510193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510196 */     // MIs[0] policy
     /* 1510196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510206 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1510209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510230 */     // GIR_Coverage, 17864,
     /* 1510230 */     GIR_EraseRootFromParent_Done,
     /* 1510231 */   // Label 21017: @1510231
     /* 1510231 */   GIM_Try, /*On fail goto*//*Label 21018*/ GIMT_Encode4(1510313), // Rule ID 17865 //
     /* 1510236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1510247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1510250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1510253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1510256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510275 */     // MIs[0] round
     /* 1510275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510278 */     // MIs[0] policy
     /* 1510278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510288 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1510291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510312 */     // GIR_Coverage, 17865,
     /* 1510312 */     GIR_EraseRootFromParent_Done,
     /* 1510313 */   // Label 21018: @1510313
     /* 1510313 */   GIM_Try, /*On fail goto*//*Label 21019*/ GIMT_Encode4(1510395), // Rule ID 17868 //
     /* 1510318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1510329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1510332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1510335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1510338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510357 */     // MIs[0] round
     /* 1510357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510360 */     // MIs[0] policy
     /* 1510360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510370 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1510373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510394 */     // GIR_Coverage, 17868,
     /* 1510394 */     GIR_EraseRootFromParent_Done,
     /* 1510395 */   // Label 21019: @1510395
     /* 1510395 */   GIM_Try, /*On fail goto*//*Label 21020*/ GIMT_Encode4(1510477), // Rule ID 17869 //
     /* 1510400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1510411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1510414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1510417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1510420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510439 */     // MIs[0] round
     /* 1510439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510442 */     // MIs[0] policy
     /* 1510442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510452 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1510455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510476 */     // GIR_Coverage, 17869,
     /* 1510476 */     GIR_EraseRootFromParent_Done,
     /* 1510477 */   // Label 21020: @1510477
     /* 1510477 */   GIM_Try, /*On fail goto*//*Label 21021*/ GIMT_Encode4(1510559), // Rule ID 17872 //
     /* 1510482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1510493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1510496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1510499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1510502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510521 */     // MIs[0] round
     /* 1510521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510524 */     // MIs[0] policy
     /* 1510524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510534 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1510537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510558 */     // GIR_Coverage, 17872,
     /* 1510558 */     GIR_EraseRootFromParent_Done,
     /* 1510559 */   // Label 21021: @1510559
     /* 1510559 */   GIM_Try, /*On fail goto*//*Label 21022*/ GIMT_Encode4(1510641), // Rule ID 17873 //
     /* 1510564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1510575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1510578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1510581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1510584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510603 */     // MIs[0] round
     /* 1510603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510606 */     // MIs[0] policy
     /* 1510606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510616 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1510619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510640 */     // GIR_Coverage, 17873,
     /* 1510640 */     GIR_EraseRootFromParent_Done,
     /* 1510641 */   // Label 21022: @1510641
     /* 1510641 */   GIM_Try, /*On fail goto*//*Label 21023*/ GIMT_Encode4(1510723), // Rule ID 17876 //
     /* 1510646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1510657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1510660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1510663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1510666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510685 */     // MIs[0] round
     /* 1510685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510688 */     // MIs[0] policy
     /* 1510688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510698 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1510701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510722 */     // GIR_Coverage, 17876,
     /* 1510722 */     GIR_EraseRootFromParent_Done,
     /* 1510723 */   // Label 21023: @1510723
     /* 1510723 */   GIM_Try, /*On fail goto*//*Label 21024*/ GIMT_Encode4(1510805), // Rule ID 17877 //
     /* 1510728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1510739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1510742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1510745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1510748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510767 */     // MIs[0] round
     /* 1510767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510770 */     // MIs[0] policy
     /* 1510770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510780 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1510783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510804 */     // GIR_Coverage, 17877,
     /* 1510804 */     GIR_EraseRootFromParent_Done,
     /* 1510805 */   // Label 21024: @1510805
     /* 1510805 */   GIM_Try, /*On fail goto*//*Label 21025*/ GIMT_Encode4(1510887), // Rule ID 17880 //
     /* 1510810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1510821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1510824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1510827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1510830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510849 */     // MIs[0] round
     /* 1510849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510852 */     // MIs[0] policy
     /* 1510852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510862 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1510865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510886 */     // GIR_Coverage, 17880,
     /* 1510886 */     GIR_EraseRootFromParent_Done,
     /* 1510887 */   // Label 21025: @1510887
     /* 1510887 */   GIM_Try, /*On fail goto*//*Label 21026*/ GIMT_Encode4(1510969), // Rule ID 17881 //
     /* 1510892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1510903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1510906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1510909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1510912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510931 */     // MIs[0] round
     /* 1510931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510934 */     // MIs[0] policy
     /* 1510934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510944 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1510947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510968 */     // GIR_Coverage, 17881,
     /* 1510968 */     GIR_EraseRootFromParent_Done,
     /* 1510969 */   // Label 21026: @1510969
     /* 1510969 */   GIM_Try, /*On fail goto*//*Label 21027*/ GIMT_Encode4(1511051), // Rule ID 17884 //
     /* 1510974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1510977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1510985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1510988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1510991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1510994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511013 */     // MIs[0] round
     /* 1511013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511016 */     // MIs[0] policy
     /* 1511016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511026 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1511029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511050 */     // GIR_Coverage, 17884,
     /* 1511050 */     GIR_EraseRootFromParent_Done,
     /* 1511051 */   // Label 21027: @1511051
     /* 1511051 */   GIM_Try, /*On fail goto*//*Label 21028*/ GIMT_Encode4(1511133), // Rule ID 17885 //
     /* 1511056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1511067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1511070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1511073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1511076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511095 */     // MIs[0] round
     /* 1511095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511098 */     // MIs[0] policy
     /* 1511098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511108 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1511111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511132 */     // GIR_Coverage, 17885,
     /* 1511132 */     GIR_EraseRootFromParent_Done,
     /* 1511133 */   // Label 21028: @1511133
     /* 1511133 */   GIM_Try, /*On fail goto*//*Label 21029*/ GIMT_Encode4(1511215), // Rule ID 17888 //
     /* 1511138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1511149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1511152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1511155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1511158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511177 */     // MIs[0] round
     /* 1511177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511180 */     // MIs[0] policy
     /* 1511180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511190 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1511193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511214 */     // GIR_Coverage, 17888,
     /* 1511214 */     GIR_EraseRootFromParent_Done,
     /* 1511215 */   // Label 21029: @1511215
     /* 1511215 */   GIM_Try, /*On fail goto*//*Label 21030*/ GIMT_Encode4(1511297), // Rule ID 17889 //
     /* 1511220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1511231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1511234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1511237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1511240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511259 */     // MIs[0] round
     /* 1511259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511262 */     // MIs[0] policy
     /* 1511262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511272 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1511275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511296 */     // GIR_Coverage, 17889,
     /* 1511296 */     GIR_EraseRootFromParent_Done,
     /* 1511297 */   // Label 21030: @1511297
     /* 1511297 */   GIM_Try, /*On fail goto*//*Label 21031*/ GIMT_Encode4(1511379), // Rule ID 17892 //
     /* 1511302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1511313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1511316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1511319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1511322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511341 */     // MIs[0] round
     /* 1511341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511344 */     // MIs[0] policy
     /* 1511344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511354 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1511357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511378 */     // GIR_Coverage, 17892,
     /* 1511378 */     GIR_EraseRootFromParent_Done,
     /* 1511379 */   // Label 21031: @1511379
     /* 1511379 */   GIM_Try, /*On fail goto*//*Label 21032*/ GIMT_Encode4(1511461), // Rule ID 17893 //
     /* 1511384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1511395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1511398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1511401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1511404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511423 */     // MIs[0] round
     /* 1511423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511426 */     // MIs[0] policy
     /* 1511426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511436 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1511439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511460 */     // GIR_Coverage, 17893,
     /* 1511460 */     GIR_EraseRootFromParent_Done,
     /* 1511461 */   // Label 21032: @1511461
     /* 1511461 */   GIM_Try, /*On fail goto*//*Label 21033*/ GIMT_Encode4(1511543), // Rule ID 17896 //
     /* 1511466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1511477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1511480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1511483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1511486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511505 */     // MIs[0] round
     /* 1511505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511508 */     // MIs[0] policy
     /* 1511508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511518 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1511521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511542 */     // GIR_Coverage, 17896,
     /* 1511542 */     GIR_EraseRootFromParent_Done,
     /* 1511543 */   // Label 21033: @1511543
     /* 1511543 */   GIM_Try, /*On fail goto*//*Label 21034*/ GIMT_Encode4(1511625), // Rule ID 17897 //
     /* 1511548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1511559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1511562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1511565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1511568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511587 */     // MIs[0] round
     /* 1511587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511590 */     // MIs[0] policy
     /* 1511590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511600 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1511603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511624 */     // GIR_Coverage, 17897,
     /* 1511624 */     GIR_EraseRootFromParent_Done,
     /* 1511625 */   // Label 21034: @1511625
     /* 1511625 */   GIM_Try, /*On fail goto*//*Label 21035*/ GIMT_Encode4(1511707), // Rule ID 17900 //
     /* 1511630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1511633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1511641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1511644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1511647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1511650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511669 */     // MIs[0] round
     /* 1511669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511672 */     // MIs[0] policy
     /* 1511672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511682 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1511685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511706 */     // GIR_Coverage, 17900,
     /* 1511706 */     GIR_EraseRootFromParent_Done,
     /* 1511707 */   // Label 21035: @1511707
     /* 1511707 */   GIM_Try, /*On fail goto*//*Label 21036*/ GIMT_Encode4(1511789), // Rule ID 17901 //
     /* 1511712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1511715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1511723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1511726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1511729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1511732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511751 */     // MIs[0] round
     /* 1511751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511754 */     // MIs[0] policy
     /* 1511754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511764 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1511767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511788 */     // GIR_Coverage, 17901,
     /* 1511788 */     GIR_EraseRootFromParent_Done,
     /* 1511789 */   // Label 21036: @1511789
     /* 1511789 */   GIM_Try, /*On fail goto*//*Label 21037*/ GIMT_Encode4(1511871), // Rule ID 17904 //
     /* 1511794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1511797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1511805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1511808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1511811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1511814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511833 */     // MIs[0] round
     /* 1511833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511836 */     // MIs[0] policy
     /* 1511836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511846 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1511849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511870 */     // GIR_Coverage, 17904,
     /* 1511870 */     GIR_EraseRootFromParent_Done,
     /* 1511871 */   // Label 21037: @1511871
     /* 1511871 */   GIM_Try, /*On fail goto*//*Label 21038*/ GIMT_Encode4(1511953), // Rule ID 17905 //
     /* 1511876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1511879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1511887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1511890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1511893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1511896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511915 */     // MIs[0] round
     /* 1511915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511918 */     // MIs[0] policy
     /* 1511918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511928 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1511931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511952 */     // GIR_Coverage, 17905,
     /* 1511952 */     GIR_EraseRootFromParent_Done,
     /* 1511953 */   // Label 21038: @1511953
     /* 1511953 */   GIM_Try, /*On fail goto*//*Label 21039*/ GIMT_Encode4(1512035), // Rule ID 17908 //
     /* 1511958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1511961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1511969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1511972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1511975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1511978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511997 */     // MIs[0] round
     /* 1511997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512000 */     // MIs[0] policy
     /* 1512000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512010 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1512013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512034 */     // GIR_Coverage, 17908,
     /* 1512034 */     GIR_EraseRootFromParent_Done,
     /* 1512035 */   // Label 21039: @1512035
     /* 1512035 */   GIM_Try, /*On fail goto*//*Label 21040*/ GIMT_Encode4(1512117), // Rule ID 17909 //
     /* 1512040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1512043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1512048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1512051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1512054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1512057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1512060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512079 */     // MIs[0] round
     /* 1512079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512082 */     // MIs[0] policy
     /* 1512082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512092 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1512095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512116 */     // GIR_Coverage, 17909,
     /* 1512116 */     GIR_EraseRootFromParent_Done,
     /* 1512117 */   // Label 21040: @1512117
     /* 1512117 */   GIM_Try, /*On fail goto*//*Label 21041*/ GIMT_Encode4(1512199), // Rule ID 17912 //
     /* 1512122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1512125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1512130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1512133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1512136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1512139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1512142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512161 */     // MIs[0] round
     /* 1512161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512164 */     // MIs[0] policy
     /* 1512164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512174 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1512177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512198 */     // GIR_Coverage, 17912,
     /* 1512198 */     GIR_EraseRootFromParent_Done,
     /* 1512199 */   // Label 21041: @1512199
     /* 1512199 */   GIM_Try, /*On fail goto*//*Label 21042*/ GIMT_Encode4(1512281), // Rule ID 17913 //
     /* 1512204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1512207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1512212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1512215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1512218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1512221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1512224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512243 */     // MIs[0] round
     /* 1512243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512246 */     // MIs[0] policy
     /* 1512246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512256 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1512259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512280 */     // GIR_Coverage, 17913,
     /* 1512280 */     GIR_EraseRootFromParent_Done,
     /* 1512281 */   // Label 21042: @1512281
     /* 1512281 */   GIM_Try, /*On fail goto*//*Label 21043*/ GIMT_Encode4(1512363), // Rule ID 17916 //
     /* 1512286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1512289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1512294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1512297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1512300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1512303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1512306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512325 */     // MIs[0] round
     /* 1512325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512328 */     // MIs[0] policy
     /* 1512328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512338 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1512341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512362 */     // GIR_Coverage, 17916,
     /* 1512362 */     GIR_EraseRootFromParent_Done,
     /* 1512363 */   // Label 21043: @1512363
     /* 1512363 */   GIM_Try, /*On fail goto*//*Label 21044*/ GIMT_Encode4(1512445), // Rule ID 17917 //
     /* 1512368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1512371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1512376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1512379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1512382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1512385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1512388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512407 */     // MIs[0] round
     /* 1512407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512410 */     // MIs[0] policy
     /* 1512410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512420 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1512423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512444 */     // GIR_Coverage, 17917,
     /* 1512444 */     GIR_EraseRootFromParent_Done,
     /* 1512445 */   // Label 21044: @1512445
     /* 1512445 */   GIM_Try, /*On fail goto*//*Label 21045*/ GIMT_Encode4(1512527), // Rule ID 17920 //
     /* 1512450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1512453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1512458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1512461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1512464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1512467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1512470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512489 */     // MIs[0] round
     /* 1512489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512492 */     // MIs[0] policy
     /* 1512492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512502 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1512505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512526 */     // GIR_Coverage, 17920,
     /* 1512526 */     GIR_EraseRootFromParent_Done,
     /* 1512527 */   // Label 21045: @1512527
     /* 1512527 */   GIM_Try, /*On fail goto*//*Label 21046*/ GIMT_Encode4(1512609), // Rule ID 17921 //
     /* 1512532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1512535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1512540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1512543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1512546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1512549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1512552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512571 */     // MIs[0] round
     /* 1512571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512574 */     // MIs[0] policy
     /* 1512574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512584 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1512587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512608 */     // GIR_Coverage, 17921,
     /* 1512608 */     GIR_EraseRootFromParent_Done,
     /* 1512609 */   // Label 21046: @1512609
     /* 1512609 */   GIM_Try, /*On fail goto*//*Label 21047*/ GIMT_Encode4(1512691), // Rule ID 17924 //
     /* 1512614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1512622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1512625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1512628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1512634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512653 */     // MIs[0] round
     /* 1512653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512656 */     // MIs[0] policy
     /* 1512656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512666 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1512669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512690 */     // GIR_Coverage, 17924,
     /* 1512690 */     GIR_EraseRootFromParent_Done,
     /* 1512691 */   // Label 21047: @1512691
     /* 1512691 */   GIM_Try, /*On fail goto*//*Label 21048*/ GIMT_Encode4(1512773), // Rule ID 17925 //
     /* 1512696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1512704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1512707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1512710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1512716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512735 */     // MIs[0] round
     /* 1512735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512738 */     // MIs[0] policy
     /* 1512738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512748 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1512751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512772 */     // GIR_Coverage, 17925,
     /* 1512772 */     GIR_EraseRootFromParent_Done,
     /* 1512773 */   // Label 21048: @1512773
     /* 1512773 */   GIM_Try, /*On fail goto*//*Label 21049*/ GIMT_Encode4(1512855), // Rule ID 17928 //
     /* 1512778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1512786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1512789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1512792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1512798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512817 */     // MIs[0] round
     /* 1512817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512820 */     // MIs[0] policy
     /* 1512820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512830 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1512833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512854 */     // GIR_Coverage, 17928,
     /* 1512854 */     GIR_EraseRootFromParent_Done,
     /* 1512855 */   // Label 21049: @1512855
     /* 1512855 */   GIM_Try, /*On fail goto*//*Label 21050*/ GIMT_Encode4(1512937), // Rule ID 17929 //
     /* 1512860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1512868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1512871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1512874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1512880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512899 */     // MIs[0] round
     /* 1512899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512902 */     // MIs[0] policy
     /* 1512902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512912 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1512915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512936 */     // GIR_Coverage, 17929,
     /* 1512936 */     GIR_EraseRootFromParent_Done,
     /* 1512937 */   // Label 21050: @1512937
     /* 1512937 */   GIM_Try, /*On fail goto*//*Label 21051*/ GIMT_Encode4(1513019), // Rule ID 17932 //
     /* 1512942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1512945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1512950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1512953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1512956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1512959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1512962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1512977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512981 */     // MIs[0] round
     /* 1512981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512984 */     // MIs[0] policy
     /* 1512984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512994 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1512997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513018 */     // GIR_Coverage, 17932,
     /* 1513018 */     GIR_EraseRootFromParent_Done,
     /* 1513019 */   // Label 21051: @1513019
     /* 1513019 */   GIM_Try, /*On fail goto*//*Label 21052*/ GIMT_Encode4(1513101), // Rule ID 17933 //
     /* 1513024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1513032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1513035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1513038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1513044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513063 */     // MIs[0] round
     /* 1513063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513066 */     // MIs[0] policy
     /* 1513066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513076 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1513079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513100 */     // GIR_Coverage, 17933,
     /* 1513100 */     GIR_EraseRootFromParent_Done,
     /* 1513101 */   // Label 21052: @1513101
     /* 1513101 */   GIM_Try, /*On fail goto*//*Label 21053*/ GIMT_Encode4(1513183), // Rule ID 17936 //
     /* 1513106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1513114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1513117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1513120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1513126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513145 */     // MIs[0] round
     /* 1513145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513148 */     // MIs[0] policy
     /* 1513148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513158 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1513161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513182 */     // GIR_Coverage, 17936,
     /* 1513182 */     GIR_EraseRootFromParent_Done,
     /* 1513183 */   // Label 21053: @1513183
     /* 1513183 */   GIM_Try, /*On fail goto*//*Label 21054*/ GIMT_Encode4(1513265), // Rule ID 17937 //
     /* 1513188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1513191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1513196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1513199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1513202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1513208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513227 */     // MIs[0] round
     /* 1513227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513230 */     // MIs[0] policy
     /* 1513230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513240 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1513243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513264 */     // GIR_Coverage, 17937,
     /* 1513264 */     GIR_EraseRootFromParent_Done,
     /* 1513265 */   // Label 21054: @1513265
     /* 1513265 */   GIM_Try, /*On fail goto*//*Label 21055*/ GIMT_Encode4(1513347), // Rule ID 17940 //
     /* 1513270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1513278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1513281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1513284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1513290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513309 */     // MIs[0] round
     /* 1513309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513312 */     // MIs[0] policy
     /* 1513312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513322 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1513325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513346 */     // GIR_Coverage, 17940,
     /* 1513346 */     GIR_EraseRootFromParent_Done,
     /* 1513347 */   // Label 21055: @1513347
     /* 1513347 */   GIM_Try, /*On fail goto*//*Label 21056*/ GIMT_Encode4(1513429), // Rule ID 17941 //
     /* 1513352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1513360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1513363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1513366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1513372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513391 */     // MIs[0] round
     /* 1513391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513394 */     // MIs[0] policy
     /* 1513394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513404 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1513407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513428 */     // GIR_Coverage, 17941,
     /* 1513428 */     GIR_EraseRootFromParent_Done,
     /* 1513429 */   // Label 21056: @1513429
     /* 1513429 */   GIM_Try, /*On fail goto*//*Label 21057*/ GIMT_Encode4(1513511), // Rule ID 17944 //
     /* 1513434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1513442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1513445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1513448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1513451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1513454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1513469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513473 */     // MIs[0] round
     /* 1513473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513476 */     // MIs[0] policy
     /* 1513476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513486 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1513489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513510 */     // GIR_Coverage, 17944,
     /* 1513510 */     GIR_EraseRootFromParent_Done,
     /* 1513511 */   // Label 21057: @1513511
     /* 1513511 */   GIM_Try, /*On fail goto*//*Label 21058*/ GIMT_Encode4(1513593), // Rule ID 17945 //
     /* 1513516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1513524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1513527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1513530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1513533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1513536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1513551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513555 */     // MIs[0] round
     /* 1513555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513558 */     // MIs[0] policy
     /* 1513558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513568 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1513571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513592 */     // GIR_Coverage, 17945,
     /* 1513592 */     GIR_EraseRootFromParent_Done,
     /* 1513593 */   // Label 21058: @1513593
     /* 1513593 */   GIM_Try, /*On fail goto*//*Label 21059*/ GIMT_Encode4(1513675), // Rule ID 17948 //
     /* 1513598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1513606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1513609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1513612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1513618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513637 */     // MIs[0] round
     /* 1513637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513640 */     // MIs[0] policy
     /* 1513640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513650 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1513653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513674 */     // GIR_Coverage, 17948,
     /* 1513674 */     GIR_EraseRootFromParent_Done,
     /* 1513675 */   // Label 21059: @1513675
     /* 1513675 */   GIM_Try, /*On fail goto*//*Label 21060*/ GIMT_Encode4(1513757), // Rule ID 17949 //
     /* 1513680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1513683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1513688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1513691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1513694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1513700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513719 */     // MIs[0] round
     /* 1513719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513722 */     // MIs[0] policy
     /* 1513722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513732 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1513735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513756 */     // GIR_Coverage, 17949,
     /* 1513756 */     GIR_EraseRootFromParent_Done,
     /* 1513757 */   // Label 21060: @1513757
     /* 1513757 */   GIM_Try, /*On fail goto*//*Label 21061*/ GIMT_Encode4(1513839), // Rule ID 17952 //
     /* 1513762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1513770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1513773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1513776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1513782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513801 */     // MIs[0] round
     /* 1513801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513804 */     // MIs[0] policy
     /* 1513804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513814 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1513817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513838 */     // GIR_Coverage, 17952,
     /* 1513838 */     GIR_EraseRootFromParent_Done,
     /* 1513839 */   // Label 21061: @1513839
     /* 1513839 */   GIM_Try, /*On fail goto*//*Label 21062*/ GIMT_Encode4(1513921), // Rule ID 17953 //
     /* 1513844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1513847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1513852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1513855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1513858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1513864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513883 */     // MIs[0] round
     /* 1513883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513886 */     // MIs[0] policy
     /* 1513886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513896 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1513899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513920 */     // GIR_Coverage, 17953,
     /* 1513920 */     GIR_EraseRootFromParent_Done,
     /* 1513921 */   // Label 21062: @1513921
     /* 1513921 */   GIM_Try, /*On fail goto*//*Label 21063*/ GIMT_Encode4(1514003), // Rule ID 17956 //
     /* 1513926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1513934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1513937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1513940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1513946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513965 */     // MIs[0] round
     /* 1513965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513968 */     // MIs[0] policy
     /* 1513968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513978 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1513981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514002 */     // GIR_Coverage, 17956,
     /* 1514002 */     GIR_EraseRootFromParent_Done,
     /* 1514003 */   // Label 21063: @1514003
     /* 1514003 */   GIM_Try, /*On fail goto*//*Label 21064*/ GIMT_Encode4(1514085), // Rule ID 17957 //
     /* 1514008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1514016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1514019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1514022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1514028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514047 */     // MIs[0] round
     /* 1514047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514050 */     // MIs[0] policy
     /* 1514050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514060 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1514063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514084 */     // GIR_Coverage, 17957,
     /* 1514084 */     GIR_EraseRootFromParent_Done,
     /* 1514085 */   // Label 21064: @1514085
     /* 1514085 */   GIM_Try, /*On fail goto*//*Label 21065*/ GIMT_Encode4(1514167), // Rule ID 17960 //
     /* 1514090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1514098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1514101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1514104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1514110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514129 */     // MIs[0] round
     /* 1514129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514132 */     // MIs[0] policy
     /* 1514132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514142 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1514145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514166 */     // GIR_Coverage, 17960,
     /* 1514166 */     GIR_EraseRootFromParent_Done,
     /* 1514167 */   // Label 21065: @1514167
     /* 1514167 */   GIM_Try, /*On fail goto*//*Label 21066*/ GIMT_Encode4(1514249), // Rule ID 17961 //
     /* 1514172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1514180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1514183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1514186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1514192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514211 */     // MIs[0] round
     /* 1514211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514214 */     // MIs[0] policy
     /* 1514214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514224 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1514227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514248 */     // GIR_Coverage, 17961,
     /* 1514248 */     GIR_EraseRootFromParent_Done,
     /* 1514249 */   // Label 21066: @1514249
     /* 1514249 */   GIM_Try, /*On fail goto*//*Label 21067*/ GIMT_Encode4(1514331), // Rule ID 17964 //
     /* 1514254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1514262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1514265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1514268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1514274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514293 */     // MIs[0] round
     /* 1514293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514296 */     // MIs[0] policy
     /* 1514296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514306 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1514309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514330 */     // GIR_Coverage, 17964,
     /* 1514330 */     GIR_EraseRootFromParent_Done,
     /* 1514331 */   // Label 21067: @1514331
     /* 1514331 */   GIM_Try, /*On fail goto*//*Label 21068*/ GIMT_Encode4(1514413), // Rule ID 17965 //
     /* 1514336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1514344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1514347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1514350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1514356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514375 */     // MIs[0] round
     /* 1514375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514378 */     // MIs[0] policy
     /* 1514378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514388 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1514391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514412 */     // GIR_Coverage, 17965,
     /* 1514412 */     GIR_EraseRootFromParent_Done,
     /* 1514413 */   // Label 21068: @1514413
     /* 1514413 */   GIM_Try, /*On fail goto*//*Label 21069*/ GIMT_Encode4(1514495), // Rule ID 17968 //
     /* 1514418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1514426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1514429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1514432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1514438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514457 */     // MIs[0] round
     /* 1514457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514460 */     // MIs[0] policy
     /* 1514460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514470 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1514473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514494 */     // GIR_Coverage, 17968,
     /* 1514494 */     GIR_EraseRootFromParent_Done,
     /* 1514495 */   // Label 21069: @1514495
     /* 1514495 */   GIM_Try, /*On fail goto*//*Label 21070*/ GIMT_Encode4(1514577), // Rule ID 17969 //
     /* 1514500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1514508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1514511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1514514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1514520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514539 */     // MIs[0] round
     /* 1514539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514542 */     // MIs[0] policy
     /* 1514542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514552 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1514555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514576 */     // GIR_Coverage, 17969,
     /* 1514576 */     GIR_EraseRootFromParent_Done,
     /* 1514577 */   // Label 21070: @1514577
     /* 1514577 */   GIM_Try, /*On fail goto*//*Label 21071*/ GIMT_Encode4(1514659), // Rule ID 17972 //
     /* 1514582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1514585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1514590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1514593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1514596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1514602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514621 */     // MIs[0] round
     /* 1514621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514624 */     // MIs[0] policy
     /* 1514624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514634 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1514637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514658 */     // GIR_Coverage, 17972,
     /* 1514658 */     GIR_EraseRootFromParent_Done,
     /* 1514659 */   // Label 21071: @1514659
     /* 1514659 */   GIM_Try, /*On fail goto*//*Label 21072*/ GIMT_Encode4(1514741), // Rule ID 17973 //
     /* 1514664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1514667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1514672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1514675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1514678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1514684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514703 */     // MIs[0] round
     /* 1514703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514706 */     // MIs[0] policy
     /* 1514706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514716 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1514719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514740 */     // GIR_Coverage, 17973,
     /* 1514740 */     GIR_EraseRootFromParent_Done,
     /* 1514741 */   // Label 21072: @1514741
     /* 1514741 */   GIM_Try, /*On fail goto*//*Label 21073*/ GIMT_Encode4(1514823), // Rule ID 17976 //
     /* 1514746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1514749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1514754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1514757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1514760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1514766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514785 */     // MIs[0] round
     /* 1514785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514788 */     // MIs[0] policy
     /* 1514788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514798 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1514801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514822 */     // GIR_Coverage, 17976,
     /* 1514822 */     GIR_EraseRootFromParent_Done,
     /* 1514823 */   // Label 21073: @1514823
     /* 1514823 */   GIM_Try, /*On fail goto*//*Label 21074*/ GIMT_Encode4(1514905), // Rule ID 17977 //
     /* 1514828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1514831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1514836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1514839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1514842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1514848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514867 */     // MIs[0] round
     /* 1514867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514870 */     // MIs[0] policy
     /* 1514870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514880 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1514883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514904 */     // GIR_Coverage, 17977,
     /* 1514904 */     GIR_EraseRootFromParent_Done,
     /* 1514905 */   // Label 21074: @1514905
     /* 1514905 */   GIM_Try, /*On fail goto*//*Label 21075*/ GIMT_Encode4(1514987), // Rule ID 17980 //
     /* 1514910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1514913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1514918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1514921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1514924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1514930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514949 */     // MIs[0] round
     /* 1514949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514952 */     // MIs[0] policy
     /* 1514952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514962 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1514965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514973 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514986 */     // GIR_Coverage, 17980,
     /* 1514986 */     GIR_EraseRootFromParent_Done,
     /* 1514987 */   // Label 21075: @1514987
     /* 1514987 */   GIM_Try, /*On fail goto*//*Label 21076*/ GIMT_Encode4(1515069), // Rule ID 17981 //
     /* 1514992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1514995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1515000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1515003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1515006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1515009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1515012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1515027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515031 */     // MIs[0] round
     /* 1515031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515034 */     // MIs[0] policy
     /* 1515034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515044 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1515047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515068 */     // GIR_Coverage, 17981,
     /* 1515068 */     GIR_EraseRootFromParent_Done,
     /* 1515069 */   // Label 21076: @1515069
     /* 1515069 */   GIM_Try, /*On fail goto*//*Label 21077*/ GIMT_Encode4(1515151), // Rule ID 17984 //
     /* 1515074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1515085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1515088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1515091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1515094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515113 */     // MIs[0] round
     /* 1515113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515116 */     // MIs[0] policy
     /* 1515116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515126 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1515129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515150 */     // GIR_Coverage, 17984,
     /* 1515150 */     GIR_EraseRootFromParent_Done,
     /* 1515151 */   // Label 21077: @1515151
     /* 1515151 */   GIM_Try, /*On fail goto*//*Label 21078*/ GIMT_Encode4(1515233), // Rule ID 17985 //
     /* 1515156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1515167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1515170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1515173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1515176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515195 */     // MIs[0] round
     /* 1515195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515198 */     // MIs[0] policy
     /* 1515198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515208 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1515211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515232 */     // GIR_Coverage, 17985,
     /* 1515232 */     GIR_EraseRootFromParent_Done,
     /* 1515233 */   // Label 21078: @1515233
     /* 1515233 */   GIM_Try, /*On fail goto*//*Label 21079*/ GIMT_Encode4(1515315), // Rule ID 17988 //
     /* 1515238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1515249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1515252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1515255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1515258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515277 */     // MIs[0] round
     /* 1515277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515280 */     // MIs[0] policy
     /* 1515280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515290 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1515293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515314 */     // GIR_Coverage, 17988,
     /* 1515314 */     GIR_EraseRootFromParent_Done,
     /* 1515315 */   // Label 21079: @1515315
     /* 1515315 */   GIM_Try, /*On fail goto*//*Label 21080*/ GIMT_Encode4(1515397), // Rule ID 17989 //
     /* 1515320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1515331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1515334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1515337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1515340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515359 */     // MIs[0] round
     /* 1515359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515362 */     // MIs[0] policy
     /* 1515362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515372 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1515375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515396 */     // GIR_Coverage, 17989,
     /* 1515396 */     GIR_EraseRootFromParent_Done,
     /* 1515397 */   // Label 21080: @1515397
     /* 1515397 */   GIM_Try, /*On fail goto*//*Label 21081*/ GIMT_Encode4(1515479), // Rule ID 17992 //
     /* 1515402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1515413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1515416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1515419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1515422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515441 */     // MIs[0] round
     /* 1515441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515444 */     // MIs[0] policy
     /* 1515444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515454 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1515457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515478 */     // GIR_Coverage, 17992,
     /* 1515478 */     GIR_EraseRootFromParent_Done,
     /* 1515479 */   // Label 21081: @1515479
     /* 1515479 */   GIM_Try, /*On fail goto*//*Label 21082*/ GIMT_Encode4(1515561), // Rule ID 17993 //
     /* 1515484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1515495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1515498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1515501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1515504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515523 */     // MIs[0] round
     /* 1515523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515526 */     // MIs[0] policy
     /* 1515526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515536 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1515539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515560 */     // GIR_Coverage, 17993,
     /* 1515560 */     GIR_EraseRootFromParent_Done,
     /* 1515561 */   // Label 21082: @1515561
     /* 1515561 */   GIM_Try, /*On fail goto*//*Label 21083*/ GIMT_Encode4(1515643), // Rule ID 17996 //
     /* 1515566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1515577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1515580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1515583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1515586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515605 */     // MIs[0] round
     /* 1515605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515608 */     // MIs[0] policy
     /* 1515608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515618 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1515621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515642 */     // GIR_Coverage, 17996,
     /* 1515642 */     GIR_EraseRootFromParent_Done,
     /* 1515643 */   // Label 21083: @1515643
     /* 1515643 */   GIM_Try, /*On fail goto*//*Label 21084*/ GIMT_Encode4(1515725), // Rule ID 17997 //
     /* 1515648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1515659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1515662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1515665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1515668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515687 */     // MIs[0] round
     /* 1515687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515690 */     // MIs[0] policy
     /* 1515690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515700 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1515703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515724 */     // GIR_Coverage, 17997,
     /* 1515724 */     GIR_EraseRootFromParent_Done,
     /* 1515725 */   // Label 21084: @1515725
     /* 1515725 */   GIM_Try, /*On fail goto*//*Label 21085*/ GIMT_Encode4(1515807), // Rule ID 18000 //
     /* 1515730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1515741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1515744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1515747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1515750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515769 */     // MIs[0] round
     /* 1515769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515772 */     // MIs[0] policy
     /* 1515772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515782 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1515785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515806 */     // GIR_Coverage, 18000,
     /* 1515806 */     GIR_EraseRootFromParent_Done,
     /* 1515807 */   // Label 21085: @1515807
     /* 1515807 */   GIM_Try, /*On fail goto*//*Label 21086*/ GIMT_Encode4(1515889), // Rule ID 18001 //
     /* 1515812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1515823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1515826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1515829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1515832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515851 */     // MIs[0] round
     /* 1515851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515854 */     // MIs[0] policy
     /* 1515854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515864 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1515867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515888 */     // GIR_Coverage, 18001,
     /* 1515888 */     GIR_EraseRootFromParent_Done,
     /* 1515889 */   // Label 21086: @1515889
     /* 1515889 */   GIM_Try, /*On fail goto*//*Label 21087*/ GIMT_Encode4(1515971), // Rule ID 18004 //
     /* 1515894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1515897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1515905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1515908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1515911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1515914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515933 */     // MIs[0] round
     /* 1515933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515936 */     // MIs[0] policy
     /* 1515936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515946 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1515949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515970 */     // GIR_Coverage, 18004,
     /* 1515970 */     GIR_EraseRootFromParent_Done,
     /* 1515971 */   // Label 21087: @1515971
     /* 1515971 */   GIM_Try, /*On fail goto*//*Label 21088*/ GIMT_Encode4(1516053), // Rule ID 18005 //
     /* 1515976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1515979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1515987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1515990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1515993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1515996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516015 */     // MIs[0] round
     /* 1516015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516018 */     // MIs[0] policy
     /* 1516018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516028 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1516031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516052 */     // GIR_Coverage, 18005,
     /* 1516052 */     GIR_EraseRootFromParent_Done,
     /* 1516053 */   // Label 21088: @1516053
     /* 1516053 */   GIM_Try, /*On fail goto*//*Label 21089*/ GIMT_Encode4(1516135), // Rule ID 18008 //
     /* 1516058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1516069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1516072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1516075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1516078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516097 */     // MIs[0] round
     /* 1516097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516100 */     // MIs[0] policy
     /* 1516100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516110 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1516113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516134 */     // GIR_Coverage, 18008,
     /* 1516134 */     GIR_EraseRootFromParent_Done,
     /* 1516135 */   // Label 21089: @1516135
     /* 1516135 */   GIM_Try, /*On fail goto*//*Label 21090*/ GIMT_Encode4(1516217), // Rule ID 18009 //
     /* 1516140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1516151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1516154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1516157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1516160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516179 */     // MIs[0] round
     /* 1516179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516182 */     // MIs[0] policy
     /* 1516182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516192 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1516195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516216 */     // GIR_Coverage, 18009,
     /* 1516216 */     GIR_EraseRootFromParent_Done,
     /* 1516217 */   // Label 21090: @1516217
     /* 1516217 */   GIM_Try, /*On fail goto*//*Label 21091*/ GIMT_Encode4(1516299), // Rule ID 18012 //
     /* 1516222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1516233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1516236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1516239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1516242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516261 */     // MIs[0] round
     /* 1516261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516264 */     // MIs[0] policy
     /* 1516264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516274 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1516277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516298 */     // GIR_Coverage, 18012,
     /* 1516298 */     GIR_EraseRootFromParent_Done,
     /* 1516299 */   // Label 21091: @1516299
     /* 1516299 */   GIM_Try, /*On fail goto*//*Label 21092*/ GIMT_Encode4(1516381), // Rule ID 18013 //
     /* 1516304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1516315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1516318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1516321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1516324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516343 */     // MIs[0] round
     /* 1516343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516346 */     // MIs[0] policy
     /* 1516346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516356 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1516359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516380 */     // GIR_Coverage, 18013,
     /* 1516380 */     GIR_EraseRootFromParent_Done,
     /* 1516381 */   // Label 21092: @1516381
     /* 1516381 */   GIM_Try, /*On fail goto*//*Label 21093*/ GIMT_Encode4(1516463), // Rule ID 18016 //
     /* 1516386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1516397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1516400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1516403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1516406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516425 */     // MIs[0] round
     /* 1516425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516428 */     // MIs[0] policy
     /* 1516428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516438 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1516441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516462 */     // GIR_Coverage, 18016,
     /* 1516462 */     GIR_EraseRootFromParent_Done,
     /* 1516463 */   // Label 21093: @1516463
     /* 1516463 */   GIM_Try, /*On fail goto*//*Label 21094*/ GIMT_Encode4(1516545), // Rule ID 18017 //
     /* 1516468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1516479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1516482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1516485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1516488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516507 */     // MIs[0] round
     /* 1516507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516510 */     // MIs[0] policy
     /* 1516510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516520 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1516523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516544 */     // GIR_Coverage, 18017,
     /* 1516544 */     GIR_EraseRootFromParent_Done,
     /* 1516545 */   // Label 21094: @1516545
     /* 1516545 */   GIM_Try, /*On fail goto*//*Label 21095*/ GIMT_Encode4(1516627), // Rule ID 18020 //
     /* 1516550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1516553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1516561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1516564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1516567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1516570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516589 */     // MIs[0] round
     /* 1516589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516592 */     // MIs[0] policy
     /* 1516592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516602 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1516605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516626 */     // GIR_Coverage, 18020,
     /* 1516626 */     GIR_EraseRootFromParent_Done,
     /* 1516627 */   // Label 21095: @1516627
     /* 1516627 */   GIM_Try, /*On fail goto*//*Label 21096*/ GIMT_Encode4(1516709), // Rule ID 18021 //
     /* 1516632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1516635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1516643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1516646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1516649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1516652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516671 */     // MIs[0] round
     /* 1516671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516674 */     // MIs[0] policy
     /* 1516674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516684 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1516687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516708 */     // GIR_Coverage, 18021,
     /* 1516708 */     GIR_EraseRootFromParent_Done,
     /* 1516709 */   // Label 21096: @1516709
     /* 1516709 */   GIM_Try, /*On fail goto*//*Label 21097*/ GIMT_Encode4(1516791), // Rule ID 18024 //
     /* 1516714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1516717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1516725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1516728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1516731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1516734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516753 */     // MIs[0] round
     /* 1516753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516756 */     // MIs[0] policy
     /* 1516756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516766 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1516769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516790 */     // GIR_Coverage, 18024,
     /* 1516790 */     GIR_EraseRootFromParent_Done,
     /* 1516791 */   // Label 21097: @1516791
     /* 1516791 */   GIM_Try, /*On fail goto*//*Label 21098*/ GIMT_Encode4(1516873), // Rule ID 18025 //
     /* 1516796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1516799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1516807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1516810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1516813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1516816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516835 */     // MIs[0] round
     /* 1516835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516838 */     // MIs[0] policy
     /* 1516838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516848 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1516851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516872 */     // GIR_Coverage, 18025,
     /* 1516872 */     GIR_EraseRootFromParent_Done,
     /* 1516873 */   // Label 21098: @1516873
     /* 1516873 */   GIM_Try, /*On fail goto*//*Label 21099*/ GIMT_Encode4(1516955), // Rule ID 18028 //
     /* 1516878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1516881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1516889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1516892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1516895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1516898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516917 */     // MIs[0] round
     /* 1516917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516920 */     // MIs[0] policy
     /* 1516920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516930 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1516933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516954 */     // GIR_Coverage, 18028,
     /* 1516954 */     GIR_EraseRootFromParent_Done,
     /* 1516955 */   // Label 21099: @1516955
     /* 1516955 */   GIM_Try, /*On fail goto*//*Label 21100*/ GIMT_Encode4(1517037), // Rule ID 18029 //
     /* 1516960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1516963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1516971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1516974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1516977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1516980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516999 */     // MIs[0] round
     /* 1516999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517002 */     // MIs[0] policy
     /* 1517002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517012 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1517015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517036 */     // GIR_Coverage, 18029,
     /* 1517036 */     GIR_EraseRootFromParent_Done,
     /* 1517037 */   // Label 21100: @1517037
     /* 1517037 */   GIM_Try, /*On fail goto*//*Label 21101*/ GIMT_Encode4(1517119), // Rule ID 18032 //
     /* 1517042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1517045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1517050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1517053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1517056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1517059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1517062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517081 */     // MIs[0] round
     /* 1517081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517084 */     // MIs[0] policy
     /* 1517084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517094 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1517097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517118 */     // GIR_Coverage, 18032,
     /* 1517118 */     GIR_EraseRootFromParent_Done,
     /* 1517119 */   // Label 21101: @1517119
     /* 1517119 */   GIM_Try, /*On fail goto*//*Label 21102*/ GIMT_Encode4(1517201), // Rule ID 18033 //
     /* 1517124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1517127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1517132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1517135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1517138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1517141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1517144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517163 */     // MIs[0] round
     /* 1517163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517166 */     // MIs[0] policy
     /* 1517166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517176 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1517179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517200 */     // GIR_Coverage, 18033,
     /* 1517200 */     GIR_EraseRootFromParent_Done,
     /* 1517201 */   // Label 21102: @1517201
     /* 1517201 */   GIM_Try, /*On fail goto*//*Label 21103*/ GIMT_Encode4(1517283), // Rule ID 18036 //
     /* 1517206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1517209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1517214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1517217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1517220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1517223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1517226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517245 */     // MIs[0] round
     /* 1517245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517248 */     // MIs[0] policy
     /* 1517248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517258 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1517261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517282 */     // GIR_Coverage, 18036,
     /* 1517282 */     GIR_EraseRootFromParent_Done,
     /* 1517283 */   // Label 21103: @1517283
     /* 1517283 */   GIM_Try, /*On fail goto*//*Label 21104*/ GIMT_Encode4(1517365), // Rule ID 18037 //
     /* 1517288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1517291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1517296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1517299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1517302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1517305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1517308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517327 */     // MIs[0] round
     /* 1517327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517330 */     // MIs[0] policy
     /* 1517330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517340 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1517343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517364 */     // GIR_Coverage, 18037,
     /* 1517364 */     GIR_EraseRootFromParent_Done,
     /* 1517365 */   // Label 21104: @1517365
     /* 1517365 */   GIM_Try, /*On fail goto*//*Label 21105*/ GIMT_Encode4(1517447), // Rule ID 18040 //
     /* 1517370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1517373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1517378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1517381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1517384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1517387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1517390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517409 */     // MIs[0] round
     /* 1517409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517412 */     // MIs[0] policy
     /* 1517412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517422 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1517425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517446 */     // GIR_Coverage, 18040,
     /* 1517446 */     GIR_EraseRootFromParent_Done,
     /* 1517447 */   // Label 21105: @1517447
     /* 1517447 */   GIM_Try, /*On fail goto*//*Label 21106*/ GIMT_Encode4(1517529), // Rule ID 18041 //
     /* 1517452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1517455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1517460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1517463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1517466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1517469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1517472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517491 */     // MIs[0] round
     /* 1517491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517494 */     // MIs[0] policy
     /* 1517494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517504 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1517507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517528 */     // GIR_Coverage, 18041,
     /* 1517528 */     GIR_EraseRootFromParent_Done,
     /* 1517529 */   // Label 21106: @1517529
     /* 1517529 */   GIM_Try, /*On fail goto*//*Label 21107*/ GIMT_Encode4(1517611), // Rule ID 18044 //
     /* 1517534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1517542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1517545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1517548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1517554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517573 */     // MIs[0] round
     /* 1517573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517576 */     // MIs[0] policy
     /* 1517576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517586 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1517589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517610 */     // GIR_Coverage, 18044,
     /* 1517610 */     GIR_EraseRootFromParent_Done,
     /* 1517611 */   // Label 21107: @1517611
     /* 1517611 */   GIM_Try, /*On fail goto*//*Label 21108*/ GIMT_Encode4(1517693), // Rule ID 18045 //
     /* 1517616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1517624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1517627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1517630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1517636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517655 */     // MIs[0] round
     /* 1517655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517658 */     // MIs[0] policy
     /* 1517658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517668 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1517671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517692 */     // GIR_Coverage, 18045,
     /* 1517692 */     GIR_EraseRootFromParent_Done,
     /* 1517693 */   // Label 21108: @1517693
     /* 1517693 */   GIM_Try, /*On fail goto*//*Label 21109*/ GIMT_Encode4(1517775), // Rule ID 18048 //
     /* 1517698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1517706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1517709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1517712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1517718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517737 */     // MIs[0] round
     /* 1517737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517740 */     // MIs[0] policy
     /* 1517740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517750 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1517753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517774 */     // GIR_Coverage, 18048,
     /* 1517774 */     GIR_EraseRootFromParent_Done,
     /* 1517775 */   // Label 21109: @1517775
     /* 1517775 */   GIM_Try, /*On fail goto*//*Label 21110*/ GIMT_Encode4(1517857), // Rule ID 18049 //
     /* 1517780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1517788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1517791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1517794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1517800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517819 */     // MIs[0] round
     /* 1517819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517822 */     // MIs[0] policy
     /* 1517822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517832 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1517835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517856 */     // GIR_Coverage, 18049,
     /* 1517856 */     GIR_EraseRootFromParent_Done,
     /* 1517857 */   // Label 21110: @1517857
     /* 1517857 */   GIM_Try, /*On fail goto*//*Label 21111*/ GIMT_Encode4(1517939), // Rule ID 18052 //
     /* 1517862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1517865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1517870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1517873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1517876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1517879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1517882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1517897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517901 */     // MIs[0] round
     /* 1517901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517904 */     // MIs[0] policy
     /* 1517904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517914 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1517917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517938 */     // GIR_Coverage, 18052,
     /* 1517938 */     GIR_EraseRootFromParent_Done,
     /* 1517939 */   // Label 21111: @1517939
     /* 1517939 */   GIM_Try, /*On fail goto*//*Label 21112*/ GIMT_Encode4(1518021), // Rule ID 18053 //
     /* 1517944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1517947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1517952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1517955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1517958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1517961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1517964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1517979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517983 */     // MIs[0] round
     /* 1517983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517986 */     // MIs[0] policy
     /* 1517986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517996 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1517999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518020 */     // GIR_Coverage, 18053,
     /* 1518020 */     GIR_EraseRootFromParent_Done,
     /* 1518021 */   // Label 21112: @1518021
     /* 1518021 */   GIM_Try, /*On fail goto*//*Label 21113*/ GIMT_Encode4(1518103), // Rule ID 18056 //
     /* 1518026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1518029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1518034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1518037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1518040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1518046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518065 */     // MIs[0] round
     /* 1518065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518068 */     // MIs[0] policy
     /* 1518068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518078 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1518081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518102 */     // GIR_Coverage, 18056,
     /* 1518102 */     GIR_EraseRootFromParent_Done,
     /* 1518103 */   // Label 21113: @1518103
     /* 1518103 */   GIM_Try, /*On fail goto*//*Label 21114*/ GIMT_Encode4(1518185), // Rule ID 18057 //
     /* 1518108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1518116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1518119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1518122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1518128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518147 */     // MIs[0] round
     /* 1518147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518150 */     // MIs[0] policy
     /* 1518150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518160 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1518163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518184 */     // GIR_Coverage, 18057,
     /* 1518184 */     GIR_EraseRootFromParent_Done,
     /* 1518185 */   // Label 21114: @1518185
     /* 1518185 */   GIM_Try, /*On fail goto*//*Label 21115*/ GIMT_Encode4(1518267), // Rule ID 18060 //
     /* 1518190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1518198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1518201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1518204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1518210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518229 */     // MIs[0] round
     /* 1518229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518232 */     // MIs[0] policy
     /* 1518232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518242 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1518245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518266 */     // GIR_Coverage, 18060,
     /* 1518266 */     GIR_EraseRootFromParent_Done,
     /* 1518267 */   // Label 21115: @1518267
     /* 1518267 */   GIM_Try, /*On fail goto*//*Label 21116*/ GIMT_Encode4(1518349), // Rule ID 18061 //
     /* 1518272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1518280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1518283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1518286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1518292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518311 */     // MIs[0] round
     /* 1518311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518314 */     // MIs[0] policy
     /* 1518314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518324 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1518327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518348 */     // GIR_Coverage, 18061,
     /* 1518348 */     GIR_EraseRootFromParent_Done,
     /* 1518349 */   // Label 21116: @1518349
     /* 1518349 */   GIM_Try, /*On fail goto*//*Label 21117*/ GIMT_Encode4(1518431), // Rule ID 18064 //
     /* 1518354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1518362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1518365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1518368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1518371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1518374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1518389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518393 */     // MIs[0] round
     /* 1518393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518396 */     // MIs[0] policy
     /* 1518396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518406 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1518409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518430 */     // GIR_Coverage, 18064,
     /* 1518430 */     GIR_EraseRootFromParent_Done,
     /* 1518431 */   // Label 21117: @1518431
     /* 1518431 */   GIM_Try, /*On fail goto*//*Label 21118*/ GIMT_Encode4(1518513), // Rule ID 18065 //
     /* 1518436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1518444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1518447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1518450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1518453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1518456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1518471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518475 */     // MIs[0] round
     /* 1518475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518478 */     // MIs[0] policy
     /* 1518478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518488 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1518491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518512 */     // GIR_Coverage, 18065,
     /* 1518512 */     GIR_EraseRootFromParent_Done,
     /* 1518513 */   // Label 21118: @1518513
     /* 1518513 */   GIM_Try, /*On fail goto*//*Label 21119*/ GIMT_Encode4(1518595), // Rule ID 18068 //
     /* 1518518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1518521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1518526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1518529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1518532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1518538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518557 */     // MIs[0] round
     /* 1518557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518560 */     // MIs[0] policy
     /* 1518560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518570 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1518573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518594 */     // GIR_Coverage, 18068,
     /* 1518594 */     GIR_EraseRootFromParent_Done,
     /* 1518595 */   // Label 21119: @1518595
     /* 1518595 */   GIM_Try, /*On fail goto*//*Label 21120*/ GIMT_Encode4(1518677), // Rule ID 18069 //
     /* 1518600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1518608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1518611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1518614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1518620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518639 */     // MIs[0] round
     /* 1518639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518642 */     // MIs[0] policy
     /* 1518642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518652 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1518655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518676 */     // GIR_Coverage, 18069,
     /* 1518676 */     GIR_EraseRootFromParent_Done,
     /* 1518677 */   // Label 21120: @1518677
     /* 1518677 */   GIM_Try, /*On fail goto*//*Label 21121*/ GIMT_Encode4(1518759), // Rule ID 18072 //
     /* 1518682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1518685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1518690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1518693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1518696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1518702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518721 */     // MIs[0] round
     /* 1518721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518724 */     // MIs[0] policy
     /* 1518724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518734 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1518737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518758 */     // GIR_Coverage, 18072,
     /* 1518758 */     GIR_EraseRootFromParent_Done,
     /* 1518759 */   // Label 21121: @1518759
     /* 1518759 */   GIM_Try, /*On fail goto*//*Label 21122*/ GIMT_Encode4(1518841), // Rule ID 18073 //
     /* 1518764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1518772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1518775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1518778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1518784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518803 */     // MIs[0] round
     /* 1518803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518806 */     // MIs[0] policy
     /* 1518806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518816 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1518819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518840 */     // GIR_Coverage, 18073,
     /* 1518840 */     GIR_EraseRootFromParent_Done,
     /* 1518841 */   // Label 21122: @1518841
     /* 1518841 */   GIM_Try, /*On fail goto*//*Label 21123*/ GIMT_Encode4(1518923), // Rule ID 18076 //
     /* 1518846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1518849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1518854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1518857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1518860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1518866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518885 */     // MIs[0] round
     /* 1518885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518888 */     // MIs[0] policy
     /* 1518888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518898 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1518901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518909 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518922 */     // GIR_Coverage, 18076,
     /* 1518922 */     GIR_EraseRootFromParent_Done,
     /* 1518923 */   // Label 21123: @1518923
     /* 1518923 */   GIM_Try, /*On fail goto*//*Label 21124*/ GIMT_Encode4(1519005), // Rule ID 18077 //
     /* 1518928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1518936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1518939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1518942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1518948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518967 */     // MIs[0] round
     /* 1518967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518970 */     // MIs[0] policy
     /* 1518970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518980 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1518983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519004 */     // GIR_Coverage, 18077,
     /* 1519004 */     GIR_EraseRootFromParent_Done,
     /* 1519005 */   // Label 21124: @1519005
     /* 1519005 */   GIM_Try, /*On fail goto*//*Label 21125*/ GIMT_Encode4(1519087), // Rule ID 18080 //
     /* 1519010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1519013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1519018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1519021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1519024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1519030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519049 */     // MIs[0] round
     /* 1519049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519052 */     // MIs[0] policy
     /* 1519052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519062 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1519065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519086 */     // GIR_Coverage, 18080,
     /* 1519086 */     GIR_EraseRootFromParent_Done,
     /* 1519087 */   // Label 21125: @1519087
     /* 1519087 */   GIM_Try, /*On fail goto*//*Label 21126*/ GIMT_Encode4(1519169), // Rule ID 18081 //
     /* 1519092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1519100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1519103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1519106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1519112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519131 */     // MIs[0] round
     /* 1519131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519134 */     // MIs[0] policy
     /* 1519134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519144 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1519147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519168 */     // GIR_Coverage, 18081,
     /* 1519168 */     GIR_EraseRootFromParent_Done,
     /* 1519169 */   // Label 21126: @1519169
     /* 1519169 */   GIM_Try, /*On fail goto*//*Label 21127*/ GIMT_Encode4(1519251), // Rule ID 18084 //
     /* 1519174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1519177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1519182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1519185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1519188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1519194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519213 */     // MIs[0] round
     /* 1519213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519216 */     // MIs[0] policy
     /* 1519216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519226 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1519229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519250 */     // GIR_Coverage, 18084,
     /* 1519250 */     GIR_EraseRootFromParent_Done,
     /* 1519251 */   // Label 21127: @1519251
     /* 1519251 */   GIM_Try, /*On fail goto*//*Label 21128*/ GIMT_Encode4(1519333), // Rule ID 18085 //
     /* 1519256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1519264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1519267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1519270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1519276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519295 */     // MIs[0] round
     /* 1519295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519298 */     // MIs[0] policy
     /* 1519298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519308 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1519311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519332 */     // GIR_Coverage, 18085,
     /* 1519332 */     GIR_EraseRootFromParent_Done,
     /* 1519333 */   // Label 21128: @1519333
     /* 1519333 */   GIM_Try, /*On fail goto*//*Label 21129*/ GIMT_Encode4(1519415), // Rule ID 18088 //
     /* 1519338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1519341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1519346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1519349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1519352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1519358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519377 */     // MIs[0] round
     /* 1519377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519380 */     // MIs[0] policy
     /* 1519380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519390 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1519393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519414 */     // GIR_Coverage, 18088,
     /* 1519414 */     GIR_EraseRootFromParent_Done,
     /* 1519415 */   // Label 21129: @1519415
     /* 1519415 */   GIM_Try, /*On fail goto*//*Label 21130*/ GIMT_Encode4(1519497), // Rule ID 18089 //
     /* 1519420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1519428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1519431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1519434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1519440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519459 */     // MIs[0] round
     /* 1519459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519462 */     // MIs[0] policy
     /* 1519462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519472 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1519475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519496 */     // GIR_Coverage, 18089,
     /* 1519496 */     GIR_EraseRootFromParent_Done,
     /* 1519497 */   // Label 21130: @1519497
     /* 1519497 */   GIM_Try, /*On fail goto*//*Label 21131*/ GIMT_Encode4(1519579), // Rule ID 18092 //
     /* 1519502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1519505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1519510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1519513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1519516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1519522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519541 */     // MIs[0] round
     /* 1519541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519544 */     // MIs[0] policy
     /* 1519544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519554 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1519557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519578 */     // GIR_Coverage, 18092,
     /* 1519578 */     GIR_EraseRootFromParent_Done,
     /* 1519579 */   // Label 21131: @1519579
     /* 1519579 */   GIM_Try, /*On fail goto*//*Label 21132*/ GIMT_Encode4(1519661), // Rule ID 18093 //
     /* 1519584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1519587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1519592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1519595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1519598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1519604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519623 */     // MIs[0] round
     /* 1519623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519626 */     // MIs[0] policy
     /* 1519626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519636 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1519639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519660 */     // GIR_Coverage, 18093,
     /* 1519660 */     GIR_EraseRootFromParent_Done,
     /* 1519661 */   // Label 21132: @1519661
     /* 1519661 */   GIM_Try, /*On fail goto*//*Label 21133*/ GIMT_Encode4(1519743), // Rule ID 18096 //
     /* 1519666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1519669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1519674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1519677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1519680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1519686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519705 */     // MIs[0] round
     /* 1519705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519708 */     // MIs[0] policy
     /* 1519708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519718 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1519721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519742 */     // GIR_Coverage, 18096,
     /* 1519742 */     GIR_EraseRootFromParent_Done,
     /* 1519743 */   // Label 21133: @1519743
     /* 1519743 */   GIM_Try, /*On fail goto*//*Label 21134*/ GIMT_Encode4(1519825), // Rule ID 18097 //
     /* 1519748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1519751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1519756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1519759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1519762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1519768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519787 */     // MIs[0] round
     /* 1519787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519790 */     // MIs[0] policy
     /* 1519790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519800 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1519803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519824 */     // GIR_Coverage, 18097,
     /* 1519824 */     GIR_EraseRootFromParent_Done,
     /* 1519825 */   // Label 21134: @1519825
     /* 1519825 */   GIM_Try, /*On fail goto*//*Label 21135*/ GIMT_Encode4(1519907), // Rule ID 18100 //
     /* 1519830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1519833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1519838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1519841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1519844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1519850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519869 */     // MIs[0] round
     /* 1519869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519872 */     // MIs[0] policy
     /* 1519872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519882 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1519885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519906 */     // GIR_Coverage, 18100,
     /* 1519906 */     GIR_EraseRootFromParent_Done,
     /* 1519907 */   // Label 21135: @1519907
     /* 1519907 */   GIM_Try, /*On fail goto*//*Label 21136*/ GIMT_Encode4(1519989), // Rule ID 18101 //
     /* 1519912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1519915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1519920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1519923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1519926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1519932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519951 */     // MIs[0] round
     /* 1519951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519954 */     // MIs[0] policy
     /* 1519954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519964 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1519967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519988 */     // GIR_Coverage, 18101,
     /* 1519988 */     GIR_EraseRootFromParent_Done,
     /* 1519989 */   // Label 21136: @1519989
     /* 1519989 */   GIM_Try, /*On fail goto*//*Label 21137*/ GIMT_Encode4(1520071), // Rule ID 18104 //
     /* 1519994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1520005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1520008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1520011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1520014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520033 */     // MIs[0] round
     /* 1520033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520036 */     // MIs[0] policy
     /* 1520036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520046 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1520049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520070 */     // GIR_Coverage, 18104,
     /* 1520070 */     GIR_EraseRootFromParent_Done,
     /* 1520071 */   // Label 21137: @1520071
     /* 1520071 */   GIM_Try, /*On fail goto*//*Label 21138*/ GIMT_Encode4(1520153), // Rule ID 18105 //
     /* 1520076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1520087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1520090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1520093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1520096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520115 */     // MIs[0] round
     /* 1520115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520118 */     // MIs[0] policy
     /* 1520118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520128 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1520131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520139 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520152 */     // GIR_Coverage, 18105,
     /* 1520152 */     GIR_EraseRootFromParent_Done,
     /* 1520153 */   // Label 21138: @1520153
     /* 1520153 */   GIM_Try, /*On fail goto*//*Label 21139*/ GIMT_Encode4(1520235), // Rule ID 18108 //
     /* 1520158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1520161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1520169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1520172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1520175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1520178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520197 */     // MIs[0] round
     /* 1520197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520200 */     // MIs[0] policy
     /* 1520200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520210 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1520213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520234 */     // GIR_Coverage, 18108,
     /* 1520234 */     GIR_EraseRootFromParent_Done,
     /* 1520235 */   // Label 21139: @1520235
     /* 1520235 */   GIM_Try, /*On fail goto*//*Label 21140*/ GIMT_Encode4(1520317), // Rule ID 18109 //
     /* 1520240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1520251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1520254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1520257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1520260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520279 */     // MIs[0] round
     /* 1520279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520282 */     // MIs[0] policy
     /* 1520282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520292 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1520295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520316 */     // GIR_Coverage, 18109,
     /* 1520316 */     GIR_EraseRootFromParent_Done,
     /* 1520317 */   // Label 21140: @1520317
     /* 1520317 */   GIM_Try, /*On fail goto*//*Label 21141*/ GIMT_Encode4(1520399), // Rule ID 18112 //
     /* 1520322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1520333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1520336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1520339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1520342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520361 */     // MIs[0] round
     /* 1520361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520364 */     // MIs[0] policy
     /* 1520364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520374 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1520377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520398 */     // GIR_Coverage, 18112,
     /* 1520398 */     GIR_EraseRootFromParent_Done,
     /* 1520399 */   // Label 21141: @1520399
     /* 1520399 */   GIM_Try, /*On fail goto*//*Label 21142*/ GIMT_Encode4(1520481), // Rule ID 18113 //
     /* 1520404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1520415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1520418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1520421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1520424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520443 */     // MIs[0] round
     /* 1520443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520446 */     // MIs[0] policy
     /* 1520446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520456 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1520459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520480 */     // GIR_Coverage, 18113,
     /* 1520480 */     GIR_EraseRootFromParent_Done,
     /* 1520481 */   // Label 21142: @1520481
     /* 1520481 */   GIM_Try, /*On fail goto*//*Label 21143*/ GIMT_Encode4(1520563), // Rule ID 18116 //
     /* 1520486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1520489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1520497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1520500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1520503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1520506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520525 */     // MIs[0] round
     /* 1520525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520528 */     // MIs[0] policy
     /* 1520528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520538 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1520541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520562 */     // GIR_Coverage, 18116,
     /* 1520562 */     GIR_EraseRootFromParent_Done,
     /* 1520563 */   // Label 21143: @1520563
     /* 1520563 */   GIM_Try, /*On fail goto*//*Label 21144*/ GIMT_Encode4(1520645), // Rule ID 18117 //
     /* 1520568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1520579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1520582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1520585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1520588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520607 */     // MIs[0] round
     /* 1520607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520610 */     // MIs[0] policy
     /* 1520610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520620 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1520623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520644 */     // GIR_Coverage, 18117,
     /* 1520644 */     GIR_EraseRootFromParent_Done,
     /* 1520645 */   // Label 21144: @1520645
     /* 1520645 */   GIM_Try, /*On fail goto*//*Label 21145*/ GIMT_Encode4(1520727), // Rule ID 18120 //
     /* 1520650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1520661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1520664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1520667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1520670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520689 */     // MIs[0] round
     /* 1520689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520692 */     // MIs[0] policy
     /* 1520692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520702 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1520705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520726 */     // GIR_Coverage, 18120,
     /* 1520726 */     GIR_EraseRootFromParent_Done,
     /* 1520727 */   // Label 21145: @1520727
     /* 1520727 */   GIM_Try, /*On fail goto*//*Label 21146*/ GIMT_Encode4(1520809), // Rule ID 18121 //
     /* 1520732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1520743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1520746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1520749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1520752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520771 */     // MIs[0] round
     /* 1520771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520774 */     // MIs[0] policy
     /* 1520774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520784 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1520787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520808 */     // GIR_Coverage, 18121,
     /* 1520808 */     GIR_EraseRootFromParent_Done,
     /* 1520809 */   // Label 21146: @1520809
     /* 1520809 */   GIM_Try, /*On fail goto*//*Label 21147*/ GIMT_Encode4(1520891), // Rule ID 18124 //
     /* 1520814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1520817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1520825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1520828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1520831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1520834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520853 */     // MIs[0] round
     /* 1520853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520856 */     // MIs[0] policy
     /* 1520856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520866 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1520869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520890 */     // GIR_Coverage, 18124,
     /* 1520890 */     GIR_EraseRootFromParent_Done,
     /* 1520891 */   // Label 21147: @1520891
     /* 1520891 */   GIM_Try, /*On fail goto*//*Label 21148*/ GIMT_Encode4(1520973), // Rule ID 18125 //
     /* 1520896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1520899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1520907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1520910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1520913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1520916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520935 */     // MIs[0] round
     /* 1520935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520938 */     // MIs[0] policy
     /* 1520938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520948 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1520951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520972 */     // GIR_Coverage, 18125,
     /* 1520972 */     GIR_EraseRootFromParent_Done,
     /* 1520973 */   // Label 21148: @1520973
     /* 1520973 */   GIM_Try, /*On fail goto*//*Label 21149*/ GIMT_Encode4(1521055), // Rule ID 18128 //
     /* 1520978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1520981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1520989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1520992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1520995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1520998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521017 */     // MIs[0] round
     /* 1521017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521020 */     // MIs[0] policy
     /* 1521020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521030 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1521033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521054 */     // GIR_Coverage, 18128,
     /* 1521054 */     GIR_EraseRootFromParent_Done,
     /* 1521055 */   // Label 21149: @1521055
     /* 1521055 */   GIM_Try, /*On fail goto*//*Label 21150*/ GIMT_Encode4(1521137), // Rule ID 18129 //
     /* 1521060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1521071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1521074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1521077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1521080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521099 */     // MIs[0] round
     /* 1521099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521102 */     // MIs[0] policy
     /* 1521102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521112 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1521115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521136 */     // GIR_Coverage, 18129,
     /* 1521136 */     GIR_EraseRootFromParent_Done,
     /* 1521137 */   // Label 21150: @1521137
     /* 1521137 */   GIM_Try, /*On fail goto*//*Label 21151*/ GIMT_Encode4(1521219), // Rule ID 18132 //
     /* 1521142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1521153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1521156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1521159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1521162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521181 */     // MIs[0] round
     /* 1521181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521184 */     // MIs[0] policy
     /* 1521184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521194 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1521197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521218 */     // GIR_Coverage, 18132,
     /* 1521218 */     GIR_EraseRootFromParent_Done,
     /* 1521219 */   // Label 21151: @1521219
     /* 1521219 */   GIM_Try, /*On fail goto*//*Label 21152*/ GIMT_Encode4(1521301), // Rule ID 18133 //
     /* 1521224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1521235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1521238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1521241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1521244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521263 */     // MIs[0] round
     /* 1521263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521266 */     // MIs[0] policy
     /* 1521266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521276 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1521279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521300 */     // GIR_Coverage, 18133,
     /* 1521300 */     GIR_EraseRootFromParent_Done,
     /* 1521301 */   // Label 21152: @1521301
     /* 1521301 */   GIM_Try, /*On fail goto*//*Label 21153*/ GIMT_Encode4(1521383), // Rule ID 18136 //
     /* 1521306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1521317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1521320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1521323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1521326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521345 */     // MIs[0] round
     /* 1521345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521348 */     // MIs[0] policy
     /* 1521348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521358 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1521361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521382 */     // GIR_Coverage, 18136,
     /* 1521382 */     GIR_EraseRootFromParent_Done,
     /* 1521383 */   // Label 21153: @1521383
     /* 1521383 */   GIM_Try, /*On fail goto*//*Label 21154*/ GIMT_Encode4(1521465), // Rule ID 18137 //
     /* 1521388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1521399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1521402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1521405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1521408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521427 */     // MIs[0] round
     /* 1521427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521430 */     // MIs[0] policy
     /* 1521430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521440 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1521443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521464 */     // GIR_Coverage, 18137,
     /* 1521464 */     GIR_EraseRootFromParent_Done,
     /* 1521465 */   // Label 21154: @1521465
     /* 1521465 */   GIM_Try, /*On fail goto*//*Label 21155*/ GIMT_Encode4(1521547), // Rule ID 18140 //
     /* 1521470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1521473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1521481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1521484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1521487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1521490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521509 */     // MIs[0] round
     /* 1521509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521512 */     // MIs[0] policy
     /* 1521512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521522 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1521525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521546 */     // GIR_Coverage, 18140,
     /* 1521546 */     GIR_EraseRootFromParent_Done,
     /* 1521547 */   // Label 21155: @1521547
     /* 1521547 */   GIM_Try, /*On fail goto*//*Label 21156*/ GIMT_Encode4(1521629), // Rule ID 18141 //
     /* 1521552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1521555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1521563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1521566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1521569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1521572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521591 */     // MIs[0] round
     /* 1521591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521594 */     // MIs[0] policy
     /* 1521594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521604 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1521607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521628 */     // GIR_Coverage, 18141,
     /* 1521628 */     GIR_EraseRootFromParent_Done,
     /* 1521629 */   // Label 21156: @1521629
     /* 1521629 */   GIM_Try, /*On fail goto*//*Label 21157*/ GIMT_Encode4(1521711), // Rule ID 18144 //
     /* 1521634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1521637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1521645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1521648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1521651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1521654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521673 */     // MIs[0] round
     /* 1521673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521676 */     // MIs[0] policy
     /* 1521676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521686 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1521689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521710 */     // GIR_Coverage, 18144,
     /* 1521710 */     GIR_EraseRootFromParent_Done,
     /* 1521711 */   // Label 21157: @1521711
     /* 1521711 */   GIM_Try, /*On fail goto*//*Label 21158*/ GIMT_Encode4(1521793), // Rule ID 18145 //
     /* 1521716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1521719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1521727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1521730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1521733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1521736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521755 */     // MIs[0] round
     /* 1521755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521758 */     // MIs[0] policy
     /* 1521758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521768 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1521771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521792 */     // GIR_Coverage, 18145,
     /* 1521792 */     GIR_EraseRootFromParent_Done,
     /* 1521793 */   // Label 21158: @1521793
     /* 1521793 */   GIM_Try, /*On fail goto*//*Label 21159*/ GIMT_Encode4(1521875), // Rule ID 18148 //
     /* 1521798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1521801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1521809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1521812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1521815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1521818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521837 */     // MIs[0] round
     /* 1521837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521840 */     // MIs[0] policy
     /* 1521840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521850 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1521853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521874 */     // GIR_Coverage, 18148,
     /* 1521874 */     GIR_EraseRootFromParent_Done,
     /* 1521875 */   // Label 21159: @1521875
     /* 1521875 */   GIM_Try, /*On fail goto*//*Label 21160*/ GIMT_Encode4(1521957), // Rule ID 18149 //
     /* 1521880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1521883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1521891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1521894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1521897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1521900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521919 */     // MIs[0] round
     /* 1521919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521922 */     // MIs[0] policy
     /* 1521922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521932 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1521935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521956 */     // GIR_Coverage, 18149,
     /* 1521956 */     GIR_EraseRootFromParent_Done,
     /* 1521957 */   // Label 21160: @1521957
     /* 1521957 */   GIM_Try, /*On fail goto*//*Label 21161*/ GIMT_Encode4(1522039), // Rule ID 18152 //
     /* 1521962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1521965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1521973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1521976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1521979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1521982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522001 */     // MIs[0] round
     /* 1522001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522004 */     // MIs[0] policy
     /* 1522004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522014 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1522017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522038 */     // GIR_Coverage, 18152,
     /* 1522038 */     GIR_EraseRootFromParent_Done,
     /* 1522039 */   // Label 21161: @1522039
     /* 1522039 */   GIM_Try, /*On fail goto*//*Label 21162*/ GIMT_Encode4(1522121), // Rule ID 18153 //
     /* 1522044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1522047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1522052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1522055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1522058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1522061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1522064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522083 */     // MIs[0] round
     /* 1522083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522086 */     // MIs[0] policy
     /* 1522086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522096 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1522099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522120 */     // GIR_Coverage, 18153,
     /* 1522120 */     GIR_EraseRootFromParent_Done,
     /* 1522121 */   // Label 21162: @1522121
     /* 1522121 */   GIM_Try, /*On fail goto*//*Label 21163*/ GIMT_Encode4(1522203), // Rule ID 18156 //
     /* 1522126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1522129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1522134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1522137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1522140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1522143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1522146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522165 */     // MIs[0] round
     /* 1522165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522168 */     // MIs[0] policy
     /* 1522168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522178 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1522181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522202 */     // GIR_Coverage, 18156,
     /* 1522202 */     GIR_EraseRootFromParent_Done,
     /* 1522203 */   // Label 21163: @1522203
     /* 1522203 */   GIM_Try, /*On fail goto*//*Label 21164*/ GIMT_Encode4(1522285), // Rule ID 18157 //
     /* 1522208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1522211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1522216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1522219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1522222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1522225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1522228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522247 */     // MIs[0] round
     /* 1522247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522250 */     // MIs[0] policy
     /* 1522250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522260 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1522263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522284 */     // GIR_Coverage, 18157,
     /* 1522284 */     GIR_EraseRootFromParent_Done,
     /* 1522285 */   // Label 21164: @1522285
     /* 1522285 */   GIM_Try, /*On fail goto*//*Label 21165*/ GIMT_Encode4(1522367), // Rule ID 18160 //
     /* 1522290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1522293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1522298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1522301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1522304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1522307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1522310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522329 */     // MIs[0] round
     /* 1522329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522332 */     // MIs[0] policy
     /* 1522332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522342 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1522345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522366 */     // GIR_Coverage, 18160,
     /* 1522366 */     GIR_EraseRootFromParent_Done,
     /* 1522367 */   // Label 21165: @1522367
     /* 1522367 */   GIM_Try, /*On fail goto*//*Label 21166*/ GIMT_Encode4(1522449), // Rule ID 18161 //
     /* 1522372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1522375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1522380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1522383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1522386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1522389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1522392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522411 */     // MIs[0] round
     /* 1522411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522414 */     // MIs[0] policy
     /* 1522414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522424 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1522427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522448 */     // GIR_Coverage, 18161,
     /* 1522448 */     GIR_EraseRootFromParent_Done,
     /* 1522449 */   // Label 21166: @1522449
     /* 1522449 */   GIM_Try, /*On fail goto*//*Label 21167*/ GIMT_Encode4(1522531), // Rule ID 18164 //
     /* 1522454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1522462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1522465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1522468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1522474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522493 */     // MIs[0] round
     /* 1522493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522496 */     // MIs[0] policy
     /* 1522496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522506 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1522509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522530 */     // GIR_Coverage, 18164,
     /* 1522530 */     GIR_EraseRootFromParent_Done,
     /* 1522531 */   // Label 21167: @1522531
     /* 1522531 */   GIM_Try, /*On fail goto*//*Label 21168*/ GIMT_Encode4(1522613), // Rule ID 18165 //
     /* 1522536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1522544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1522547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1522550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1522556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522575 */     // MIs[0] round
     /* 1522575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522578 */     // MIs[0] policy
     /* 1522578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522588 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1522591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522612 */     // GIR_Coverage, 18165,
     /* 1522612 */     GIR_EraseRootFromParent_Done,
     /* 1522613 */   // Label 21168: @1522613
     /* 1522613 */   GIM_Try, /*On fail goto*//*Label 21169*/ GIMT_Encode4(1522695), // Rule ID 18168 //
     /* 1522618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1522626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1522629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1522632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1522638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522657 */     // MIs[0] round
     /* 1522657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522660 */     // MIs[0] policy
     /* 1522660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522670 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1522673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522694 */     // GIR_Coverage, 18168,
     /* 1522694 */     GIR_EraseRootFromParent_Done,
     /* 1522695 */   // Label 21169: @1522695
     /* 1522695 */   GIM_Try, /*On fail goto*//*Label 21170*/ GIMT_Encode4(1522777), // Rule ID 18169 //
     /* 1522700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1522708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1522711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1522714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1522720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522739 */     // MIs[0] round
     /* 1522739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522742 */     // MIs[0] policy
     /* 1522742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522752 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1522755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522776 */     // GIR_Coverage, 18169,
     /* 1522776 */     GIR_EraseRootFromParent_Done,
     /* 1522777 */   // Label 21170: @1522777
     /* 1522777 */   GIM_Try, /*On fail goto*//*Label 21171*/ GIMT_Encode4(1522859), // Rule ID 18172 //
     /* 1522782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1522785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1522790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1522793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1522796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1522799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1522802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1522817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522821 */     // MIs[0] round
     /* 1522821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522824 */     // MIs[0] policy
     /* 1522824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522834 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1522837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522858 */     // GIR_Coverage, 18172,
     /* 1522858 */     GIR_EraseRootFromParent_Done,
     /* 1522859 */   // Label 21171: @1522859
     /* 1522859 */   GIM_Try, /*On fail goto*//*Label 21172*/ GIMT_Encode4(1522941), // Rule ID 18173 //
     /* 1522864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1522867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1522872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1522875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1522878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1522881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1522884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1522899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522903 */     // MIs[0] round
     /* 1522903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522906 */     // MIs[0] policy
     /* 1522906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522916 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1522919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522940 */     // GIR_Coverage, 18173,
     /* 1522940 */     GIR_EraseRootFromParent_Done,
     /* 1522941 */   // Label 21172: @1522941
     /* 1522941 */   GIM_Try, /*On fail goto*//*Label 21173*/ GIMT_Encode4(1523023), // Rule ID 18176 //
     /* 1522946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1522954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1522957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1522960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1522966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522985 */     // MIs[0] round
     /* 1522985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522988 */     // MIs[0] policy
     /* 1522988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522998 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1523001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523022 */     // GIR_Coverage, 18176,
     /* 1523022 */     GIR_EraseRootFromParent_Done,
     /* 1523023 */   // Label 21173: @1523023
     /* 1523023 */   GIM_Try, /*On fail goto*//*Label 21174*/ GIMT_Encode4(1523105), // Rule ID 18177 //
     /* 1523028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1523031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1523036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1523039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1523042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1523048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523067 */     // MIs[0] round
     /* 1523067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523070 */     // MIs[0] policy
     /* 1523070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523080 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1523083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523104 */     // GIR_Coverage, 18177,
     /* 1523104 */     GIR_EraseRootFromParent_Done,
     /* 1523105 */   // Label 21174: @1523105
     /* 1523105 */   GIM_Try, /*On fail goto*//*Label 21175*/ GIMT_Encode4(1523187), // Rule ID 18180 //
     /* 1523110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1523118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1523121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1523124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1523130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523149 */     // MIs[0] round
     /* 1523149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523152 */     // MIs[0] policy
     /* 1523152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523162 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1523165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523186 */     // GIR_Coverage, 18180,
     /* 1523186 */     GIR_EraseRootFromParent_Done,
     /* 1523187 */   // Label 21175: @1523187
     /* 1523187 */   GIM_Try, /*On fail goto*//*Label 21176*/ GIMT_Encode4(1523269), // Rule ID 18181 //
     /* 1523192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1523200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1523203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1523206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1523212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523231 */     // MIs[0] round
     /* 1523231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523234 */     // MIs[0] policy
     /* 1523234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523244 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1523247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523268 */     // GIR_Coverage, 18181,
     /* 1523268 */     GIR_EraseRootFromParent_Done,
     /* 1523269 */   // Label 21176: @1523269
     /* 1523269 */   GIM_Try, /*On fail goto*//*Label 21177*/ GIMT_Encode4(1523351), // Rule ID 18184 //
     /* 1523274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1523282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1523285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1523288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1523291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1523294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1523309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523313 */     // MIs[0] round
     /* 1523313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523316 */     // MIs[0] policy
     /* 1523316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523326 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1523329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523350 */     // GIR_Coverage, 18184,
     /* 1523350 */     GIR_EraseRootFromParent_Done,
     /* 1523351 */   // Label 21177: @1523351
     /* 1523351 */   GIM_Try, /*On fail goto*//*Label 21178*/ GIMT_Encode4(1523433), // Rule ID 18185 //
     /* 1523356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1523364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1523367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1523370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1523373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1523376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1523391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523395 */     // MIs[0] round
     /* 1523395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523398 */     // MIs[0] policy
     /* 1523398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523408 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1523411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523432 */     // GIR_Coverage, 18185,
     /* 1523432 */     GIR_EraseRootFromParent_Done,
     /* 1523433 */   // Label 21178: @1523433
     /* 1523433 */   GIM_Try, /*On fail goto*//*Label 21179*/ GIMT_Encode4(1523515), // Rule ID 18188 //
     /* 1523438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1523441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1523446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1523449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1523452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1523458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523477 */     // MIs[0] round
     /* 1523477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523480 */     // MIs[0] policy
     /* 1523480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523490 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1523493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523514 */     // GIR_Coverage, 18188,
     /* 1523514 */     GIR_EraseRootFromParent_Done,
     /* 1523515 */   // Label 21179: @1523515
     /* 1523515 */   GIM_Try, /*On fail goto*//*Label 21180*/ GIMT_Encode4(1523597), // Rule ID 18189 //
     /* 1523520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1523523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1523528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1523531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1523534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1523540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523559 */     // MIs[0] round
     /* 1523559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523562 */     // MIs[0] policy
     /* 1523562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523572 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1523575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523596 */     // GIR_Coverage, 18189,
     /* 1523596 */     GIR_EraseRootFromParent_Done,
     /* 1523597 */   // Label 21180: @1523597
     /* 1523597 */   GIM_Try, /*On fail goto*//*Label 21181*/ GIMT_Encode4(1523679), // Rule ID 18192 //
     /* 1523602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1523605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1523610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1523613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1523616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1523622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523641 */     // MIs[0] round
     /* 1523641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523644 */     // MIs[0] policy
     /* 1523644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523654 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1523657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523678 */     // GIR_Coverage, 18192,
     /* 1523678 */     GIR_EraseRootFromParent_Done,
     /* 1523679 */   // Label 21181: @1523679
     /* 1523679 */   GIM_Try, /*On fail goto*//*Label 21182*/ GIMT_Encode4(1523761), // Rule ID 18193 //
     /* 1523684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1523687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1523692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1523695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1523698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1523704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523723 */     // MIs[0] round
     /* 1523723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523726 */     // MIs[0] policy
     /* 1523726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523736 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1523739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523760 */     // GIR_Coverage, 18193,
     /* 1523760 */     GIR_EraseRootFromParent_Done,
     /* 1523761 */   // Label 21182: @1523761
     /* 1523761 */   GIM_Try, /*On fail goto*//*Label 21183*/ GIMT_Encode4(1523843), // Rule ID 18196 //
     /* 1523766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1523769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1523774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1523777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1523780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1523786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523805 */     // MIs[0] round
     /* 1523805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523808 */     // MIs[0] policy
     /* 1523808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523818 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1523821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523842 */     // GIR_Coverage, 18196,
     /* 1523842 */     GIR_EraseRootFromParent_Done,
     /* 1523843 */   // Label 21183: @1523843
     /* 1523843 */   GIM_Try, /*On fail goto*//*Label 21184*/ GIMT_Encode4(1523925), // Rule ID 18197 //
     /* 1523848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1523851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1523856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1523859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1523862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1523868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523887 */     // MIs[0] round
     /* 1523887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523890 */     // MIs[0] policy
     /* 1523890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523900 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1523903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523924 */     // GIR_Coverage, 18197,
     /* 1523924 */     GIR_EraseRootFromParent_Done,
     /* 1523925 */   // Label 21184: @1523925
     /* 1523925 */   GIM_Try, /*On fail goto*//*Label 21185*/ GIMT_Encode4(1524007), // Rule ID 18200 //
     /* 1523930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1523938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1523941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1523944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1523950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523969 */     // MIs[0] round
     /* 1523969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523972 */     // MIs[0] policy
     /* 1523972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523982 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1523985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524006 */     // GIR_Coverage, 18200,
     /* 1524006 */     GIR_EraseRootFromParent_Done,
     /* 1524007 */   // Label 21185: @1524007
     /* 1524007 */   GIM_Try, /*On fail goto*//*Label 21186*/ GIMT_Encode4(1524089), // Rule ID 18201 //
     /* 1524012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1524015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1524020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1524023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1524026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1524032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524051 */     // MIs[0] round
     /* 1524051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524054 */     // MIs[0] policy
     /* 1524054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524064 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1524067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524088 */     // GIR_Coverage, 18201,
     /* 1524088 */     GIR_EraseRootFromParent_Done,
     /* 1524089 */   // Label 21186: @1524089
     /* 1524089 */   GIM_Try, /*On fail goto*//*Label 21187*/ GIMT_Encode4(1524171), // Rule ID 18204 //
     /* 1524094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1524097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1524102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1524105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1524108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1524114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524133 */     // MIs[0] round
     /* 1524133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524136 */     // MIs[0] policy
     /* 1524136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524146 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1524149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524170 */     // GIR_Coverage, 18204,
     /* 1524170 */     GIR_EraseRootFromParent_Done,
     /* 1524171 */   // Label 21187: @1524171
     /* 1524171 */   GIM_Try, /*On fail goto*//*Label 21188*/ GIMT_Encode4(1524253), // Rule ID 18205 //
     /* 1524176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1524179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1524184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1524187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1524190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1524196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524215 */     // MIs[0] round
     /* 1524215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524218 */     // MIs[0] policy
     /* 1524218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524228 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1524231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524252 */     // GIR_Coverage, 18205,
     /* 1524252 */     GIR_EraseRootFromParent_Done,
     /* 1524253 */   // Label 21188: @1524253
     /* 1524253 */   GIM_Try, /*On fail goto*//*Label 21189*/ GIMT_Encode4(1524335), // Rule ID 18208 //
     /* 1524258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1524261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1524266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1524269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1524272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1524278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524297 */     // MIs[0] round
     /* 1524297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524300 */     // MIs[0] policy
     /* 1524300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524310 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1524313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524334 */     // GIR_Coverage, 18208,
     /* 1524334 */     GIR_EraseRootFromParent_Done,
     /* 1524335 */   // Label 21189: @1524335
     /* 1524335 */   GIM_Try, /*On fail goto*//*Label 21190*/ GIMT_Encode4(1524417), // Rule ID 18209 //
     /* 1524340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1524343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1524348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1524351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1524354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1524360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524379 */     // MIs[0] round
     /* 1524379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524382 */     // MIs[0] policy
     /* 1524382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524392 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1524395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524416 */     // GIR_Coverage, 18209,
     /* 1524416 */     GIR_EraseRootFromParent_Done,
     /* 1524417 */   // Label 21190: @1524417
     /* 1524417 */   GIM_Try, /*On fail goto*//*Label 21191*/ GIMT_Encode4(1524499), // Rule ID 18212 //
     /* 1524422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1524425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1524430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1524433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1524436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1524442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524461 */     // MIs[0] round
     /* 1524461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524464 */     // MIs[0] policy
     /* 1524464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524474 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1524477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524498 */     // GIR_Coverage, 18212,
     /* 1524498 */     GIR_EraseRootFromParent_Done,
     /* 1524499 */   // Label 21191: @1524499
     /* 1524499 */   GIM_Try, /*On fail goto*//*Label 21192*/ GIMT_Encode4(1524581), // Rule ID 18213 //
     /* 1524504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1524507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1524512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1524515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1524518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1524524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524543 */     // MIs[0] round
     /* 1524543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524546 */     // MIs[0] policy
     /* 1524546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524556 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1524559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524580 */     // GIR_Coverage, 18213,
     /* 1524580 */     GIR_EraseRootFromParent_Done,
     /* 1524581 */   // Label 21192: @1524581
     /* 1524581 */   GIM_Try, /*On fail goto*//*Label 21193*/ GIMT_Encode4(1524663), // Rule ID 18216 //
     /* 1524586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1524589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1524594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1524597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1524600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1524606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524625 */     // MIs[0] round
     /* 1524625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524628 */     // MIs[0] policy
     /* 1524628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524638 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1524641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524662 */     // GIR_Coverage, 18216,
     /* 1524662 */     GIR_EraseRootFromParent_Done,
     /* 1524663 */   // Label 21193: @1524663
     /* 1524663 */   GIM_Try, /*On fail goto*//*Label 21194*/ GIMT_Encode4(1524745), // Rule ID 18217 //
     /* 1524668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1524671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1524676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1524679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1524682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1524688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524707 */     // MIs[0] round
     /* 1524707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524710 */     // MIs[0] policy
     /* 1524710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524720 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1524723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524744 */     // GIR_Coverage, 18217,
     /* 1524744 */     GIR_EraseRootFromParent_Done,
     /* 1524745 */   // Label 21194: @1524745
     /* 1524745 */   GIM_Try, /*On fail goto*//*Label 21195*/ GIMT_Encode4(1524827), // Rule ID 18220 //
     /* 1524750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1524753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1524758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1524761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1524764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1524770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524789 */     // MIs[0] round
     /* 1524789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524792 */     // MIs[0] policy
     /* 1524792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524802 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1524805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524826 */     // GIR_Coverage, 18220,
     /* 1524826 */     GIR_EraseRootFromParent_Done,
     /* 1524827 */   // Label 21195: @1524827
     /* 1524827 */   GIM_Try, /*On fail goto*//*Label 21196*/ GIMT_Encode4(1524909), // Rule ID 18221 //
     /* 1524832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1524835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1524840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1524843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1524846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1524852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524871 */     // MIs[0] round
     /* 1524871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524874 */     // MIs[0] policy
     /* 1524874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524884 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1524887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524908 */     // GIR_Coverage, 18221,
     /* 1524908 */     GIR_EraseRootFromParent_Done,
     /* 1524909 */   // Label 21196: @1524909
     /* 1524909 */   GIM_Try, /*On fail goto*//*Label 21197*/ GIMT_Encode4(1524991), // Rule ID 18224 //
     /* 1524914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1524925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1524928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1524931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1524934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524953 */     // MIs[0] round
     /* 1524953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524956 */     // MIs[0] policy
     /* 1524956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524966 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1524969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524990 */     // GIR_Coverage, 18224,
     /* 1524990 */     GIR_EraseRootFromParent_Done,
     /* 1524991 */   // Label 21197: @1524991
     /* 1524991 */   GIM_Try, /*On fail goto*//*Label 21198*/ GIMT_Encode4(1525073), // Rule ID 18225 //
     /* 1524996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1525007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1525010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1525013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1525016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525035 */     // MIs[0] round
     /* 1525035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525038 */     // MIs[0] policy
     /* 1525038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525048 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1525051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525072 */     // GIR_Coverage, 18225,
     /* 1525072 */     GIR_EraseRootFromParent_Done,
     /* 1525073 */   // Label 21198: @1525073
     /* 1525073 */   GIM_Try, /*On fail goto*//*Label 21199*/ GIMT_Encode4(1525155), // Rule ID 18228 //
     /* 1525078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1525081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1525089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1525092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1525095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1525098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525117 */     // MIs[0] round
     /* 1525117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525120 */     // MIs[0] policy
     /* 1525120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525130 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1525133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525154 */     // GIR_Coverage, 18228,
     /* 1525154 */     GIR_EraseRootFromParent_Done,
     /* 1525155 */   // Label 21199: @1525155
     /* 1525155 */   GIM_Try, /*On fail goto*//*Label 21200*/ GIMT_Encode4(1525237), // Rule ID 18229 //
     /* 1525160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1525163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1525171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1525174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1525177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1525180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525199 */     // MIs[0] round
     /* 1525199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525202 */     // MIs[0] policy
     /* 1525202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525212 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1525215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525236 */     // GIR_Coverage, 18229,
     /* 1525236 */     GIR_EraseRootFromParent_Done,
     /* 1525237 */   // Label 21200: @1525237
     /* 1525237 */   GIM_Try, /*On fail goto*//*Label 21201*/ GIMT_Encode4(1525319), // Rule ID 18232 //
     /* 1525242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1525253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1525256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1525259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1525262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525281 */     // MIs[0] round
     /* 1525281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525284 */     // MIs[0] policy
     /* 1525284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525294 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1525297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525318 */     // GIR_Coverage, 18232,
     /* 1525318 */     GIR_EraseRootFromParent_Done,
     /* 1525319 */   // Label 21201: @1525319
     /* 1525319 */   GIM_Try, /*On fail goto*//*Label 21202*/ GIMT_Encode4(1525401), // Rule ID 18233 //
     /* 1525324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1525335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1525338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1525341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1525344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525363 */     // MIs[0] round
     /* 1525363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525366 */     // MIs[0] policy
     /* 1525366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525376 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1525379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525400 */     // GIR_Coverage, 18233,
     /* 1525400 */     GIR_EraseRootFromParent_Done,
     /* 1525401 */   // Label 21202: @1525401
     /* 1525401 */   GIM_Try, /*On fail goto*//*Label 21203*/ GIMT_Encode4(1525483), // Rule ID 18236 //
     /* 1525406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1525409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1525417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1525420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1525423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1525426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525445 */     // MIs[0] round
     /* 1525445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525448 */     // MIs[0] policy
     /* 1525448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525458 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1525461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525482 */     // GIR_Coverage, 18236,
     /* 1525482 */     GIR_EraseRootFromParent_Done,
     /* 1525483 */   // Label 21203: @1525483
     /* 1525483 */   GIM_Try, /*On fail goto*//*Label 21204*/ GIMT_Encode4(1525565), // Rule ID 18237 //
     /* 1525488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1525491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1525499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1525502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1525505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1525508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525527 */     // MIs[0] round
     /* 1525527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525530 */     // MIs[0] policy
     /* 1525530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525540 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1525543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525564 */     // GIR_Coverage, 18237,
     /* 1525564 */     GIR_EraseRootFromParent_Done,
     /* 1525565 */   // Label 21204: @1525565
     /* 1525565 */   GIM_Try, /*On fail goto*//*Label 21205*/ GIMT_Encode4(1525647), // Rule ID 18240 //
     /* 1525570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1525581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1525584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1525587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1525590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525609 */     // MIs[0] round
     /* 1525609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525612 */     // MIs[0] policy
     /* 1525612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525622 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1525625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525646 */     // GIR_Coverage, 18240,
     /* 1525646 */     GIR_EraseRootFromParent_Done,
     /* 1525647 */   // Label 21205: @1525647
     /* 1525647 */   GIM_Try, /*On fail goto*//*Label 21206*/ GIMT_Encode4(1525729), // Rule ID 18241 //
     /* 1525652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1525663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1525666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1525669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1525672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525691 */     // MIs[0] round
     /* 1525691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525694 */     // MIs[0] policy
     /* 1525694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525704 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1525707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525728 */     // GIR_Coverage, 18241,
     /* 1525728 */     GIR_EraseRootFromParent_Done,
     /* 1525729 */   // Label 21206: @1525729
     /* 1525729 */   GIM_Try, /*On fail goto*//*Label 21207*/ GIMT_Encode4(1525811), // Rule ID 18244 //
     /* 1525734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1525737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1525745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1525748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1525751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1525754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525773 */     // MIs[0] round
     /* 1525773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525776 */     // MIs[0] policy
     /* 1525776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525786 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1525789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525810 */     // GIR_Coverage, 18244,
     /* 1525810 */     GIR_EraseRootFromParent_Done,
     /* 1525811 */   // Label 21207: @1525811
     /* 1525811 */   GIM_Try, /*On fail goto*//*Label 21208*/ GIMT_Encode4(1525893), // Rule ID 18245 //
     /* 1525816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1525819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1525827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1525830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1525833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1525836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525855 */     // MIs[0] round
     /* 1525855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525858 */     // MIs[0] policy
     /* 1525858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525868 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1525871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525892 */     // GIR_Coverage, 18245,
     /* 1525892 */     GIR_EraseRootFromParent_Done,
     /* 1525893 */   // Label 21208: @1525893
     /* 1525893 */   GIM_Try, /*On fail goto*//*Label 21209*/ GIMT_Encode4(1525975), // Rule ID 18248 //
     /* 1525898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1525901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1525909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1525912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1525915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1525918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525937 */     // MIs[0] round
     /* 1525937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525940 */     // MIs[0] policy
     /* 1525940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525950 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1525953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525974 */     // GIR_Coverage, 18248,
     /* 1525974 */     GIR_EraseRootFromParent_Done,
     /* 1525975 */   // Label 21209: @1525975
     /* 1525975 */   GIM_Try, /*On fail goto*//*Label 21210*/ GIMT_Encode4(1526057), // Rule ID 18249 //
     /* 1525980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1525983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1525991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1525994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1525997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1526000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526019 */     // MIs[0] round
     /* 1526019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526022 */     // MIs[0] policy
     /* 1526022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526032 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1526035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526056 */     // GIR_Coverage, 18249,
     /* 1526056 */     GIR_EraseRootFromParent_Done,
     /* 1526057 */   // Label 21210: @1526057
     /* 1526057 */   GIM_Try, /*On fail goto*//*Label 21211*/ GIMT_Encode4(1526139), // Rule ID 18252 //
     /* 1526062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1526073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1526076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1526079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1526082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526101 */     // MIs[0] round
     /* 1526101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526104 */     // MIs[0] policy
     /* 1526104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526114 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1526117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526138 */     // GIR_Coverage, 18252,
     /* 1526138 */     GIR_EraseRootFromParent_Done,
     /* 1526139 */   // Label 21211: @1526139
     /* 1526139 */   GIM_Try, /*On fail goto*//*Label 21212*/ GIMT_Encode4(1526221), // Rule ID 18253 //
     /* 1526144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1526155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1526158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1526161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1526164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526183 */     // MIs[0] round
     /* 1526183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526186 */     // MIs[0] policy
     /* 1526186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526196 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1526199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526220 */     // GIR_Coverage, 18253,
     /* 1526220 */     GIR_EraseRootFromParent_Done,
     /* 1526221 */   // Label 21212: @1526221
     /* 1526221 */   GIM_Try, /*On fail goto*//*Label 21213*/ GIMT_Encode4(1526303), // Rule ID 18256 //
     /* 1526226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1526237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1526240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1526243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1526246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526265 */     // MIs[0] round
     /* 1526265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526268 */     // MIs[0] policy
     /* 1526268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526278 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1526281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526302 */     // GIR_Coverage, 18256,
     /* 1526302 */     GIR_EraseRootFromParent_Done,
     /* 1526303 */   // Label 21213: @1526303
     /* 1526303 */   GIM_Try, /*On fail goto*//*Label 21214*/ GIMT_Encode4(1526385), // Rule ID 18257 //
     /* 1526308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1526319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1526322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1526325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1526328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526347 */     // MIs[0] round
     /* 1526347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526350 */     // MIs[0] policy
     /* 1526350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526360 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1526363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526384 */     // GIR_Coverage, 18257,
     /* 1526384 */     GIR_EraseRootFromParent_Done,
     /* 1526385 */   // Label 21214: @1526385
     /* 1526385 */   GIM_Try, /*On fail goto*//*Label 21215*/ GIMT_Encode4(1526467), // Rule ID 18260 //
     /* 1526390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1526393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1526401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1526404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1526407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1526410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526429 */     // MIs[0] round
     /* 1526429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526432 */     // MIs[0] policy
     /* 1526432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526442 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1526445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526466 */     // GIR_Coverage, 18260,
     /* 1526466 */     GIR_EraseRootFromParent_Done,
     /* 1526467 */   // Label 21215: @1526467
     /* 1526467 */   GIM_Try, /*On fail goto*//*Label 21216*/ GIMT_Encode4(1526549), // Rule ID 18261 //
     /* 1526472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1526475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1526483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1526486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1526489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1526492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526511 */     // MIs[0] round
     /* 1526511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526514 */     // MIs[0] policy
     /* 1526514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526524 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1526527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526548 */     // GIR_Coverage, 18261,
     /* 1526548 */     GIR_EraseRootFromParent_Done,
     /* 1526549 */   // Label 21216: @1526549
     /* 1526549 */   GIM_Try, /*On fail goto*//*Label 21217*/ GIMT_Encode4(1526631), // Rule ID 18264 //
     /* 1526554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1526557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1526565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1526568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1526571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1526574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526593 */     // MIs[0] round
     /* 1526593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526596 */     // MIs[0] policy
     /* 1526596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526606 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1526609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526630 */     // GIR_Coverage, 18264,
     /* 1526630 */     GIR_EraseRootFromParent_Done,
     /* 1526631 */   // Label 21217: @1526631
     /* 1526631 */   GIM_Try, /*On fail goto*//*Label 21218*/ GIMT_Encode4(1526713), // Rule ID 18265 //
     /* 1526636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1526639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1526647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1526650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1526653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1526656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526675 */     // MIs[0] round
     /* 1526675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526678 */     // MIs[0] policy
     /* 1526678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526688 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1526691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526712 */     // GIR_Coverage, 18265,
     /* 1526712 */     GIR_EraseRootFromParent_Done,
     /* 1526713 */   // Label 21218: @1526713
     /* 1526713 */   GIM_Try, /*On fail goto*//*Label 21219*/ GIMT_Encode4(1526795), // Rule ID 18268 //
     /* 1526718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1526721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1526729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1526732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1526735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1526738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526757 */     // MIs[0] round
     /* 1526757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526760 */     // MIs[0] policy
     /* 1526760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526770 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1526773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526794 */     // GIR_Coverage, 18268,
     /* 1526794 */     GIR_EraseRootFromParent_Done,
     /* 1526795 */   // Label 21219: @1526795
     /* 1526795 */   GIM_Try, /*On fail goto*//*Label 21220*/ GIMT_Encode4(1526877), // Rule ID 18269 //
     /* 1526800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1526803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1526811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1526814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1526817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1526820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526839 */     // MIs[0] round
     /* 1526839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526842 */     // MIs[0] policy
     /* 1526842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526852 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1526855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526876 */     // GIR_Coverage, 18269,
     /* 1526876 */     GIR_EraseRootFromParent_Done,
     /* 1526877 */   // Label 21220: @1526877
     /* 1526877 */   GIM_Try, /*On fail goto*//*Label 21221*/ GIMT_Encode4(1526959), // Rule ID 18272 //
     /* 1526882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1526885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1526893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1526896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1526899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1526902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526921 */     // MIs[0] round
     /* 1526921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526924 */     // MIs[0] policy
     /* 1526924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526934 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1526937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526958 */     // GIR_Coverage, 18272,
     /* 1526958 */     GIR_EraseRootFromParent_Done,
     /* 1526959 */   // Label 21221: @1526959
     /* 1526959 */   GIM_Try, /*On fail goto*//*Label 21222*/ GIMT_Encode4(1527041), // Rule ID 18273 //
     /* 1526964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1526967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1526975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1526978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1526981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1526984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527003 */     // MIs[0] round
     /* 1527003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527006 */     // MIs[0] policy
     /* 1527006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527016 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1527019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1527037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527040 */     // GIR_Coverage, 18273,
     /* 1527040 */     GIR_EraseRootFromParent_Done,
     /* 1527041 */   // Label 21222: @1527041
     /* 1527041 */   GIM_Try, /*On fail goto*//*Label 21223*/ GIMT_Encode4(1527123), // Rule ID 18276 //
     /* 1527046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1527049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1527054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1527057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1527060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1527063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1527066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527085 */     // MIs[0] round
     /* 1527085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527088 */     // MIs[0] policy
     /* 1527088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527098 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1527101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1527119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527122 */     // GIR_Coverage, 18276,
     /* 1527122 */     GIR_EraseRootFromParent_Done,
     /* 1527123 */   // Label 21223: @1527123
     /* 1527123 */   GIM_Try, /*On fail goto*//*Label 21224*/ GIMT_Encode4(1527205), // Rule ID 18277 //
     /* 1527128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1527131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1527136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1527139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1527142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1527145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1527148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527167 */     // MIs[0] round
     /* 1527167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527170 */     // MIs[0] policy
     /* 1527170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527180 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1527183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1527201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527204 */     // GIR_Coverage, 18277,
     /* 1527204 */     GIR_EraseRootFromParent_Done,
     /* 1527205 */   // Label 21224: @1527205
     /* 1527205 */   GIM_Try, /*On fail goto*//*Label 21225*/ GIMT_Encode4(1527287), // Rule ID 18280 //
     /* 1527210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1527213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1527218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1527221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1527224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1527227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1527230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527249 */     // MIs[0] round
     /* 1527249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527252 */     // MIs[0] policy
     /* 1527252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527262 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1527265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1527283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527286 */     // GIR_Coverage, 18280,
     /* 1527286 */     GIR_EraseRootFromParent_Done,
     /* 1527287 */   // Label 21225: @1527287
     /* 1527287 */   GIM_Try, /*On fail goto*//*Label 21226*/ GIMT_Encode4(1527369), // Rule ID 18281 //
     /* 1527292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1527295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1527300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1527303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1527306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1527309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1527312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527331 */     // MIs[0] round
     /* 1527331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527334 */     // MIs[0] policy
     /* 1527334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527344 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1527347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1527365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527368 */     // GIR_Coverage, 18281,
     /* 1527368 */     GIR_EraseRootFromParent_Done,
     /* 1527369 */   // Label 21226: @1527369
     /* 1527369 */   GIM_Try, /*On fail goto*//*Label 21227*/ GIMT_Encode4(1527451), // Rule ID 18284 //
     /* 1527374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1527382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1527385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1527388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1527394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527413 */     // MIs[0] round
     /* 1527413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527416 */     // MIs[0] policy
     /* 1527416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527426 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1527429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527450 */     // GIR_Coverage, 18284,
     /* 1527450 */     GIR_EraseRootFromParent_Done,
     /* 1527451 */   // Label 21227: @1527451
     /* 1527451 */   GIM_Try, /*On fail goto*//*Label 21228*/ GIMT_Encode4(1527533), // Rule ID 18285 //
     /* 1527456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1527464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1527467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1527470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1527476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527495 */     // MIs[0] round
     /* 1527495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527498 */     // MIs[0] policy
     /* 1527498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527508 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1527511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527532 */     // GIR_Coverage, 18285,
     /* 1527532 */     GIR_EraseRootFromParent_Done,
     /* 1527533 */   // Label 21228: @1527533
     /* 1527533 */   GIM_Try, /*On fail goto*//*Label 21229*/ GIMT_Encode4(1527615), // Rule ID 18288 //
     /* 1527538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1527546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1527549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1527552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1527558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527577 */     // MIs[0] round
     /* 1527577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527580 */     // MIs[0] policy
     /* 1527580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527590 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1527593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527614 */     // GIR_Coverage, 18288,
     /* 1527614 */     GIR_EraseRootFromParent_Done,
     /* 1527615 */   // Label 21229: @1527615
     /* 1527615 */   GIM_Try, /*On fail goto*//*Label 21230*/ GIMT_Encode4(1527697), // Rule ID 18289 //
     /* 1527620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1527628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1527631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1527634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1527640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527659 */     // MIs[0] round
     /* 1527659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527662 */     // MIs[0] policy
     /* 1527662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527672 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1527675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527696 */     // GIR_Coverage, 18289,
     /* 1527696 */     GIR_EraseRootFromParent_Done,
     /* 1527697 */   // Label 21230: @1527697
     /* 1527697 */   GIM_Try, /*On fail goto*//*Label 21231*/ GIMT_Encode4(1527779), // Rule ID 18292 //
     /* 1527702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1527710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1527713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1527716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1527719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1527722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1527737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527741 */     // MIs[0] round
     /* 1527741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527744 */     // MIs[0] policy
     /* 1527744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527754 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1527757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527778 */     // GIR_Coverage, 18292,
     /* 1527778 */     GIR_EraseRootFromParent_Done,
     /* 1527779 */   // Label 21231: @1527779
     /* 1527779 */   GIM_Try, /*On fail goto*//*Label 21232*/ GIMT_Encode4(1527861), // Rule ID 18293 //
     /* 1527784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1527787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1527792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1527795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1527798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1527801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1527804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1527819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527823 */     // MIs[0] round
     /* 1527823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527826 */     // MIs[0] policy
     /* 1527826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527836 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1527839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527860 */     // GIR_Coverage, 18293,
     /* 1527860 */     GIR_EraseRootFromParent_Done,
     /* 1527861 */   // Label 21232: @1527861
     /* 1527861 */   GIM_Try, /*On fail goto*//*Label 21233*/ GIMT_Encode4(1527943), // Rule ID 18296 //
     /* 1527866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1527874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1527877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1527880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1527886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527905 */     // MIs[0] round
     /* 1527905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527908 */     // MIs[0] policy
     /* 1527908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527918 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1527921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527942 */     // GIR_Coverage, 18296,
     /* 1527942 */     GIR_EraseRootFromParent_Done,
     /* 1527943 */   // Label 21233: @1527943
     /* 1527943 */   GIM_Try, /*On fail goto*//*Label 21234*/ GIMT_Encode4(1528025), // Rule ID 18297 //
     /* 1527948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1527956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1527959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1527962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1527968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527987 */     // MIs[0] round
     /* 1527987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527990 */     // MIs[0] policy
     /* 1527990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528000 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1528003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528024 */     // GIR_Coverage, 18297,
     /* 1528024 */     GIR_EraseRootFromParent_Done,
     /* 1528025 */   // Label 21234: @1528025
     /* 1528025 */   GIM_Try, /*On fail goto*//*Label 21235*/ GIMT_Encode4(1528107), // Rule ID 18300 //
     /* 1528030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1528033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1528038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1528041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1528044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1528050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528069 */     // MIs[0] round
     /* 1528069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528072 */     // MIs[0] policy
     /* 1528072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528082 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1528085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528106 */     // GIR_Coverage, 18300,
     /* 1528106 */     GIR_EraseRootFromParent_Done,
     /* 1528107 */   // Label 21235: @1528107
     /* 1528107 */   GIM_Try, /*On fail goto*//*Label 21236*/ GIMT_Encode4(1528189), // Rule ID 18301 //
     /* 1528112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1528120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1528123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1528126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1528132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528151 */     // MIs[0] round
     /* 1528151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528154 */     // MIs[0] policy
     /* 1528154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528164 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1528167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528188 */     // GIR_Coverage, 18301,
     /* 1528188 */     GIR_EraseRootFromParent_Done,
     /* 1528189 */   // Label 21236: @1528189
     /* 1528189 */   GIM_Try, /*On fail goto*//*Label 21237*/ GIMT_Encode4(1528271), // Rule ID 18304 //
     /* 1528194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1528202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1528205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1528208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1528211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1528214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1528229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528233 */     // MIs[0] round
     /* 1528233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528236 */     // MIs[0] policy
     /* 1528236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528246 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1528249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528270 */     // GIR_Coverage, 18304,
     /* 1528270 */     GIR_EraseRootFromParent_Done,
     /* 1528271 */   // Label 21237: @1528271
     /* 1528271 */   GIM_Try, /*On fail goto*//*Label 21238*/ GIMT_Encode4(1528353), // Rule ID 18305 //
     /* 1528276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1528284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1528287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1528290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1528293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1528296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1528311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528315 */     // MIs[0] round
     /* 1528315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528318 */     // MIs[0] policy
     /* 1528318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528328 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1528331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528352 */     // GIR_Coverage, 18305,
     /* 1528352 */     GIR_EraseRootFromParent_Done,
     /* 1528353 */   // Label 21238: @1528353
     /* 1528353 */   GIM_Try, /*On fail goto*//*Label 21239*/ GIMT_Encode4(1528435), // Rule ID 18308 //
     /* 1528358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1528366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1528369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1528372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1528378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528397 */     // MIs[0] round
     /* 1528397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528400 */     // MIs[0] policy
     /* 1528400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528410 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1528413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528434 */     // GIR_Coverage, 18308,
     /* 1528434 */     GIR_EraseRootFromParent_Done,
     /* 1528435 */   // Label 21239: @1528435
     /* 1528435 */   GIM_Try, /*On fail goto*//*Label 21240*/ GIMT_Encode4(1528517), // Rule ID 18309 //
     /* 1528440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1528443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1528448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1528451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1528454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1528460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528479 */     // MIs[0] round
     /* 1528479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528482 */     // MIs[0] policy
     /* 1528482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528492 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1528495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528516 */     // GIR_Coverage, 18309,
     /* 1528516 */     GIR_EraseRootFromParent_Done,
     /* 1528517 */   // Label 21240: @1528517
     /* 1528517 */   GIM_Try, /*On fail goto*//*Label 21241*/ GIMT_Encode4(1528599), // Rule ID 18312 //
     /* 1528522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1528530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1528533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1528536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1528542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528561 */     // MIs[0] round
     /* 1528561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528564 */     // MIs[0] policy
     /* 1528564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528574 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1528577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528598 */     // GIR_Coverage, 18312,
     /* 1528598 */     GIR_EraseRootFromParent_Done,
     /* 1528599 */   // Label 21241: @1528599
     /* 1528599 */   GIM_Try, /*On fail goto*//*Label 21242*/ GIMT_Encode4(1528681), // Rule ID 18313 //
     /* 1528604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1528607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1528612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1528615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1528618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1528624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528643 */     // MIs[0] round
     /* 1528643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528646 */     // MIs[0] policy
     /* 1528646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528656 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1528659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528680 */     // GIR_Coverage, 18313,
     /* 1528680 */     GIR_EraseRootFromParent_Done,
     /* 1528681 */   // Label 21242: @1528681
     /* 1528681 */   GIM_Try, /*On fail goto*//*Label 21243*/ GIMT_Encode4(1528763), // Rule ID 18316 //
     /* 1528686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1528694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1528697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1528700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1528706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528725 */     // MIs[0] round
     /* 1528725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528728 */     // MIs[0] policy
     /* 1528728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528738 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1528741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528762 */     // GIR_Coverage, 18316,
     /* 1528762 */     GIR_EraseRootFromParent_Done,
     /* 1528763 */   // Label 21243: @1528763
     /* 1528763 */   GIM_Try, /*On fail goto*//*Label 21244*/ GIMT_Encode4(1528845), // Rule ID 18317 //
     /* 1528768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1528771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1528776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1528779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1528782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1528788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528807 */     // MIs[0] round
     /* 1528807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528810 */     // MIs[0] policy
     /* 1528810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528820 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1528823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528844 */     // GIR_Coverage, 18317,
     /* 1528844 */     GIR_EraseRootFromParent_Done,
     /* 1528845 */   // Label 21244: @1528845
     /* 1528845 */   GIM_Try, /*On fail goto*//*Label 21245*/ GIMT_Encode4(1528927), // Rule ID 18320 //
     /* 1528850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1528853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1528858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1528861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1528864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1528870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528889 */     // MIs[0] round
     /* 1528889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528892 */     // MIs[0] policy
     /* 1528892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528902 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1528905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528926 */     // GIR_Coverage, 18320,
     /* 1528926 */     GIR_EraseRootFromParent_Done,
     /* 1528927 */   // Label 21245: @1528927
     /* 1528927 */   GIM_Try, /*On fail goto*//*Label 21246*/ GIMT_Encode4(1529009), // Rule ID 18321 //
     /* 1528932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1528940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1528943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1528946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1528952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528971 */     // MIs[0] round
     /* 1528971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528974 */     // MIs[0] policy
     /* 1528974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528984 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1528987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529008 */     // GIR_Coverage, 18321,
     /* 1529008 */     GIR_EraseRootFromParent_Done,
     /* 1529009 */   // Label 21246: @1529009
     /* 1529009 */   GIM_Try, /*On fail goto*//*Label 21247*/ GIMT_Encode4(1529091), // Rule ID 18324 //
     /* 1529014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1529022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1529025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1529028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1529034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529053 */     // MIs[0] round
     /* 1529053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529056 */     // MIs[0] policy
     /* 1529056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529066 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1529069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529090 */     // GIR_Coverage, 18324,
     /* 1529090 */     GIR_EraseRootFromParent_Done,
     /* 1529091 */   // Label 21247: @1529091
     /* 1529091 */   GIM_Try, /*On fail goto*//*Label 21248*/ GIMT_Encode4(1529173), // Rule ID 18325 //
     /* 1529096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1529099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1529104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1529107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1529110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1529116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529135 */     // MIs[0] round
     /* 1529135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529138 */     // MIs[0] policy
     /* 1529138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529148 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1529151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529172 */     // GIR_Coverage, 18325,
     /* 1529172 */     GIR_EraseRootFromParent_Done,
     /* 1529173 */   // Label 21248: @1529173
     /* 1529173 */   GIM_Try, /*On fail goto*//*Label 21249*/ GIMT_Encode4(1529255), // Rule ID 18328 //
     /* 1529178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1529186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1529189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1529192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1529198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529217 */     // MIs[0] round
     /* 1529217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529220 */     // MIs[0] policy
     /* 1529220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529230 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1529233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529254 */     // GIR_Coverage, 18328,
     /* 1529254 */     GIR_EraseRootFromParent_Done,
     /* 1529255 */   // Label 21249: @1529255
     /* 1529255 */   GIM_Try, /*On fail goto*//*Label 21250*/ GIMT_Encode4(1529337), // Rule ID 18329 //
     /* 1529260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1529263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1529268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1529271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1529274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1529280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529299 */     // MIs[0] round
     /* 1529299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529302 */     // MIs[0] policy
     /* 1529302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529312 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1529315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529336 */     // GIR_Coverage, 18329,
     /* 1529336 */     GIR_EraseRootFromParent_Done,
     /* 1529337 */   // Label 21250: @1529337
     /* 1529337 */   GIM_Try, /*On fail goto*//*Label 21251*/ GIMT_Encode4(1529419), // Rule ID 18332 //
     /* 1529342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1529345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1529350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1529353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1529356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1529362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529381 */     // MIs[0] round
     /* 1529381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529384 */     // MIs[0] policy
     /* 1529384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529394 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1529397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529418 */     // GIR_Coverage, 18332,
     /* 1529418 */     GIR_EraseRootFromParent_Done,
     /* 1529419 */   // Label 21251: @1529419
     /* 1529419 */   GIM_Try, /*On fail goto*//*Label 21252*/ GIMT_Encode4(1529501), // Rule ID 18333 //
     /* 1529424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1529427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1529432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1529435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1529438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1529444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529463 */     // MIs[0] round
     /* 1529463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529466 */     // MIs[0] policy
     /* 1529466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529476 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1529479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529500 */     // GIR_Coverage, 18333,
     /* 1529500 */     GIR_EraseRootFromParent_Done,
     /* 1529501 */   // Label 21252: @1529501
     /* 1529501 */   GIM_Try, /*On fail goto*//*Label 21253*/ GIMT_Encode4(1529583), // Rule ID 18336 //
     /* 1529506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1529509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1529514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1529517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1529520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1529526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529545 */     // MIs[0] round
     /* 1529545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529548 */     // MIs[0] policy
     /* 1529548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529558 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1529561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529582 */     // GIR_Coverage, 18336,
     /* 1529582 */     GIR_EraseRootFromParent_Done,
     /* 1529583 */   // Label 21253: @1529583
     /* 1529583 */   GIM_Try, /*On fail goto*//*Label 21254*/ GIMT_Encode4(1529665), // Rule ID 18337 //
     /* 1529588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1529591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1529596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1529599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1529602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1529608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529627 */     // MIs[0] round
     /* 1529627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529630 */     // MIs[0] policy
     /* 1529630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529640 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1529643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529664 */     // GIR_Coverage, 18337,
     /* 1529664 */     GIR_EraseRootFromParent_Done,
     /* 1529665 */   // Label 21254: @1529665
     /* 1529665 */   GIM_Try, /*On fail goto*//*Label 21255*/ GIMT_Encode4(1529747), // Rule ID 18340 //
     /* 1529670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1529673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1529678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1529681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1529684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1529690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529709 */     // MIs[0] round
     /* 1529709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529712 */     // MIs[0] policy
     /* 1529712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529722 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1529725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529746 */     // GIR_Coverage, 18340,
     /* 1529746 */     GIR_EraseRootFromParent_Done,
     /* 1529747 */   // Label 21255: @1529747
     /* 1529747 */   GIM_Try, /*On fail goto*//*Label 21256*/ GIMT_Encode4(1529829), // Rule ID 18341 //
     /* 1529752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1529755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1529760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1529763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1529766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1529772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529791 */     // MIs[0] round
     /* 1529791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529794 */     // MIs[0] policy
     /* 1529794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529804 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1529807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529828 */     // GIR_Coverage, 18341,
     /* 1529828 */     GIR_EraseRootFromParent_Done,
     /* 1529829 */   // Label 21256: @1529829
     /* 1529829 */   GIM_Try, /*On fail goto*//*Label 21257*/ GIMT_Encode4(1529911), // Rule ID 18344 //
     /* 1529834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1529845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1529848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1529851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1529854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529873 */     // MIs[0] round
     /* 1529873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529876 */     // MIs[0] policy
     /* 1529876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529886 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1529889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529910 */     // GIR_Coverage, 18344,
     /* 1529910 */     GIR_EraseRootFromParent_Done,
     /* 1529911 */   // Label 21257: @1529911
     /* 1529911 */   GIM_Try, /*On fail goto*//*Label 21258*/ GIMT_Encode4(1529993), // Rule ID 18345 //
     /* 1529916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1529927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1529930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1529933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1529936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529955 */     // MIs[0] round
     /* 1529955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529958 */     // MIs[0] policy
     /* 1529958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529968 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1529971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529992 */     // GIR_Coverage, 18345,
     /* 1529992 */     GIR_EraseRootFromParent_Done,
     /* 1529993 */   // Label 21258: @1529993
     /* 1529993 */   GIM_Try, /*On fail goto*//*Label 21259*/ GIMT_Encode4(1530075), // Rule ID 18348 //
     /* 1529998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1530001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1530009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1530012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1530015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1530018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530037 */     // MIs[0] round
     /* 1530037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530040 */     // MIs[0] policy
     /* 1530040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530050 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1530053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530074 */     // GIR_Coverage, 18348,
     /* 1530074 */     GIR_EraseRootFromParent_Done,
     /* 1530075 */   // Label 21259: @1530075
     /* 1530075 */   GIM_Try, /*On fail goto*//*Label 21260*/ GIMT_Encode4(1530157), // Rule ID 18349 //
     /* 1530080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1530083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1530091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1530094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1530097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1530100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530119 */     // MIs[0] round
     /* 1530119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530122 */     // MIs[0] policy
     /* 1530122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530132 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1530135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530156 */     // GIR_Coverage, 18349,
     /* 1530156 */     GIR_EraseRootFromParent_Done,
     /* 1530157 */   // Label 21260: @1530157
     /* 1530157 */   GIM_Try, /*On fail goto*//*Label 21261*/ GIMT_Encode4(1530239), // Rule ID 18352 //
     /* 1530162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1530173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1530176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1530179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1530182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530201 */     // MIs[0] round
     /* 1530201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530204 */     // MIs[0] policy
     /* 1530204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530214 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1530217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530238 */     // GIR_Coverage, 18352,
     /* 1530238 */     GIR_EraseRootFromParent_Done,
     /* 1530239 */   // Label 21261: @1530239
     /* 1530239 */   GIM_Try, /*On fail goto*//*Label 21262*/ GIMT_Encode4(1530321), // Rule ID 18353 //
     /* 1530244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1530255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1530258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1530261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1530264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530283 */     // MIs[0] round
     /* 1530283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530286 */     // MIs[0] policy
     /* 1530286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530296 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1530299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530320 */     // GIR_Coverage, 18353,
     /* 1530320 */     GIR_EraseRootFromParent_Done,
     /* 1530321 */   // Label 21262: @1530321
     /* 1530321 */   GIM_Try, /*On fail goto*//*Label 21263*/ GIMT_Encode4(1530403), // Rule ID 18356 //
     /* 1530326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1530329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1530337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1530340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1530343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1530346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530365 */     // MIs[0] round
     /* 1530365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530368 */     // MIs[0] policy
     /* 1530368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530378 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1530381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530402 */     // GIR_Coverage, 18356,
     /* 1530402 */     GIR_EraseRootFromParent_Done,
     /* 1530403 */   // Label 21263: @1530403
     /* 1530403 */   GIM_Try, /*On fail goto*//*Label 21264*/ GIMT_Encode4(1530485), // Rule ID 18357 //
     /* 1530408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1530411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1530419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1530422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1530425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1530428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530447 */     // MIs[0] round
     /* 1530447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530450 */     // MIs[0] policy
     /* 1530450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530460 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1530463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530484 */     // GIR_Coverage, 18357,
     /* 1530484 */     GIR_EraseRootFromParent_Done,
     /* 1530485 */   // Label 21264: @1530485
     /* 1530485 */   GIM_Try, /*On fail goto*//*Label 21265*/ GIMT_Encode4(1530567), // Rule ID 18360 //
     /* 1530490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1530501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1530504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1530507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1530510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530529 */     // MIs[0] round
     /* 1530529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530532 */     // MIs[0] policy
     /* 1530532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530542 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1530545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530566 */     // GIR_Coverage, 18360,
     /* 1530566 */     GIR_EraseRootFromParent_Done,
     /* 1530567 */   // Label 21265: @1530567
     /* 1530567 */   GIM_Try, /*On fail goto*//*Label 21266*/ GIMT_Encode4(1530649), // Rule ID 18361 //
     /* 1530572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1530583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1530586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1530589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1530592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530611 */     // MIs[0] round
     /* 1530611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530614 */     // MIs[0] policy
     /* 1530614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1530627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530648 */     // GIR_Coverage, 18361,
     /* 1530648 */     GIR_EraseRootFromParent_Done,
     /* 1530649 */   // Label 21266: @1530649
     /* 1530649 */   GIM_Try, /*On fail goto*//*Label 21267*/ GIMT_Encode4(1530731), // Rule ID 18364 //
     /* 1530654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1530657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1530665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1530668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1530671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1530674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530693 */     // MIs[0] round
     /* 1530693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530696 */     // MIs[0] policy
     /* 1530696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530706 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1530709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530730 */     // GIR_Coverage, 18364,
     /* 1530730 */     GIR_EraseRootFromParent_Done,
     /* 1530731 */   // Label 21267: @1530731
     /* 1530731 */   GIM_Try, /*On fail goto*//*Label 21268*/ GIMT_Encode4(1530813), // Rule ID 18365 //
     /* 1530736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1530739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1530747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1530750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1530753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1530756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530775 */     // MIs[0] round
     /* 1530775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530778 */     // MIs[0] policy
     /* 1530778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530788 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1530791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530812 */     // GIR_Coverage, 18365,
     /* 1530812 */     GIR_EraseRootFromParent_Done,
     /* 1530813 */   // Label 21268: @1530813
     /* 1530813 */   GIM_Try, /*On fail goto*//*Label 21269*/ GIMT_Encode4(1530895), // Rule ID 18368 //
     /* 1530818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1530821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1530829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1530832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1530835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1530838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530857 */     // MIs[0] round
     /* 1530857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530860 */     // MIs[0] policy
     /* 1530860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530870 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1530873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530894 */     // GIR_Coverage, 18368,
     /* 1530894 */     GIR_EraseRootFromParent_Done,
     /* 1530895 */   // Label 21269: @1530895
     /* 1530895 */   GIM_Try, /*On fail goto*//*Label 21270*/ GIMT_Encode4(1530977), // Rule ID 18369 //
     /* 1530900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1530903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1530911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1530914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1530917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1530920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530939 */     // MIs[0] round
     /* 1530939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530942 */     // MIs[0] policy
     /* 1530942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530952 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1530955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530976 */     // GIR_Coverage, 18369,
     /* 1530976 */     GIR_EraseRootFromParent_Done,
     /* 1530977 */   // Label 21270: @1530977
     /* 1530977 */   GIM_Try, /*On fail goto*//*Label 21271*/ GIMT_Encode4(1531059), // Rule ID 18372 //
     /* 1530982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1530985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1530993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1530996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1530999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1531002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531021 */     // MIs[0] round
     /* 1531021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531024 */     // MIs[0] policy
     /* 1531024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531034 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1531037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531058 */     // GIR_Coverage, 18372,
     /* 1531058 */     GIR_EraseRootFromParent_Done,
     /* 1531059 */   // Label 21271: @1531059
     /* 1531059 */   GIM_Try, /*On fail goto*//*Label 21272*/ GIMT_Encode4(1531141), // Rule ID 18373 //
     /* 1531064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1531075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1531078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1531081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1531084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531103 */     // MIs[0] round
     /* 1531103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531106 */     // MIs[0] policy
     /* 1531106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531116 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1531119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531140 */     // GIR_Coverage, 18373,
     /* 1531140 */     GIR_EraseRootFromParent_Done,
     /* 1531141 */   // Label 21272: @1531141
     /* 1531141 */   GIM_Try, /*On fail goto*//*Label 21273*/ GIMT_Encode4(1531223), // Rule ID 18376 //
     /* 1531146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1531157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1531160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1531163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1531166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531185 */     // MIs[0] round
     /* 1531185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531188 */     // MIs[0] policy
     /* 1531188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531198 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1531201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531222 */     // GIR_Coverage, 18376,
     /* 1531222 */     GIR_EraseRootFromParent_Done,
     /* 1531223 */   // Label 21273: @1531223
     /* 1531223 */   GIM_Try, /*On fail goto*//*Label 21274*/ GIMT_Encode4(1531305), // Rule ID 18377 //
     /* 1531228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1531239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1531242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1531245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1531248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531267 */     // MIs[0] round
     /* 1531267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531270 */     // MIs[0] policy
     /* 1531270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531280 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1531283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531304 */     // GIR_Coverage, 18377,
     /* 1531304 */     GIR_EraseRootFromParent_Done,
     /* 1531305 */   // Label 21274: @1531305
     /* 1531305 */   GIM_Try, /*On fail goto*//*Label 21275*/ GIMT_Encode4(1531387), // Rule ID 18380 //
     /* 1531310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1531313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1531321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1531324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1531327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1531330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531349 */     // MIs[0] round
     /* 1531349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531352 */     // MIs[0] policy
     /* 1531352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531362 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1531365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531386 */     // GIR_Coverage, 18380,
     /* 1531386 */     GIR_EraseRootFromParent_Done,
     /* 1531387 */   // Label 21275: @1531387
     /* 1531387 */   GIM_Try, /*On fail goto*//*Label 21276*/ GIMT_Encode4(1531469), // Rule ID 18381 //
     /* 1531392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1531395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1531403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1531406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1531409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1531412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531431 */     // MIs[0] round
     /* 1531431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531434 */     // MIs[0] policy
     /* 1531434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531444 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1531447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531468 */     // GIR_Coverage, 18381,
     /* 1531468 */     GIR_EraseRootFromParent_Done,
     /* 1531469 */   // Label 21276: @1531469
     /* 1531469 */   GIM_Try, /*On fail goto*//*Label 21277*/ GIMT_Encode4(1531551), // Rule ID 18384 //
     /* 1531474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1531477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1531485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1531488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1531491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1531494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531513 */     // MIs[0] round
     /* 1531513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531516 */     // MIs[0] policy
     /* 1531516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531526 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1531529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531550 */     // GIR_Coverage, 18384,
     /* 1531550 */     GIR_EraseRootFromParent_Done,
     /* 1531551 */   // Label 21277: @1531551
     /* 1531551 */   GIM_Try, /*On fail goto*//*Label 21278*/ GIMT_Encode4(1531633), // Rule ID 18385 //
     /* 1531556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1531559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1531567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1531570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1531573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1531576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531595 */     // MIs[0] round
     /* 1531595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531598 */     // MIs[0] policy
     /* 1531598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531608 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1531611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531632 */     // GIR_Coverage, 18385,
     /* 1531632 */     GIR_EraseRootFromParent_Done,
     /* 1531633 */   // Label 21278: @1531633
     /* 1531633 */   GIM_Try, /*On fail goto*//*Label 21279*/ GIMT_Encode4(1531715), // Rule ID 18388 //
     /* 1531638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1531641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1531649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1531652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1531655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1531658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531677 */     // MIs[0] round
     /* 1531677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531680 */     // MIs[0] policy
     /* 1531680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531690 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1531693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531714 */     // GIR_Coverage, 18388,
     /* 1531714 */     GIR_EraseRootFromParent_Done,
     /* 1531715 */   // Label 21279: @1531715
     /* 1531715 */   GIM_Try, /*On fail goto*//*Label 21280*/ GIMT_Encode4(1531797), // Rule ID 18389 //
     /* 1531720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1531723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1531731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1531734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1531737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1531740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531759 */     // MIs[0] round
     /* 1531759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531762 */     // MIs[0] policy
     /* 1531762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531772 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1531775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531796 */     // GIR_Coverage, 18389,
     /* 1531796 */     GIR_EraseRootFromParent_Done,
     /* 1531797 */   // Label 21280: @1531797
     /* 1531797 */   GIM_Try, /*On fail goto*//*Label 21281*/ GIMT_Encode4(1531879), // Rule ID 18392 //
     /* 1531802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1531805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1531813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1531816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1531819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1531822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531841 */     // MIs[0] round
     /* 1531841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531844 */     // MIs[0] policy
     /* 1531844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531854 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1531857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531878 */     // GIR_Coverage, 18392,
     /* 1531878 */     GIR_EraseRootFromParent_Done,
     /* 1531879 */   // Label 21281: @1531879
     /* 1531879 */   GIM_Try, /*On fail goto*//*Label 21282*/ GIMT_Encode4(1531961), // Rule ID 18393 //
     /* 1531884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1531887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1531895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1531898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1531901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1531904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531923 */     // MIs[0] round
     /* 1531923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531926 */     // MIs[0] policy
     /* 1531926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531936 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1531939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531960 */     // GIR_Coverage, 18393,
     /* 1531960 */     GIR_EraseRootFromParent_Done,
     /* 1531961 */   // Label 21282: @1531961
     /* 1531961 */   GIM_Try, /*On fail goto*//*Label 21283*/ GIMT_Encode4(1532043), // Rule ID 18396 //
     /* 1531966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1531969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1531977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1531980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1531983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1531986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532005 */     // MIs[0] round
     /* 1532005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532008 */     // MIs[0] policy
     /* 1532008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532018 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1532021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532042 */     // GIR_Coverage, 18396,
     /* 1532042 */     GIR_EraseRootFromParent_Done,
     /* 1532043 */   // Label 21283: @1532043
     /* 1532043 */   GIM_Try, /*On fail goto*//*Label 21284*/ GIMT_Encode4(1532125), // Rule ID 18397 //
     /* 1532048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1532051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1532056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1532059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1532062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1532065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1532068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532087 */     // MIs[0] round
     /* 1532087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532090 */     // MIs[0] policy
     /* 1532090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532100 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1532103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532124 */     // GIR_Coverage, 18397,
     /* 1532124 */     GIR_EraseRootFromParent_Done,
     /* 1532125 */   // Label 21284: @1532125
     /* 1532125 */   GIM_Try, /*On fail goto*//*Label 21285*/ GIMT_Encode4(1532207), // Rule ID 18400 //
     /* 1532130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1532133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1532138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1532141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1532144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1532147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1532150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532169 */     // MIs[0] round
     /* 1532169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532172 */     // MIs[0] policy
     /* 1532172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532182 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1532185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532206 */     // GIR_Coverage, 18400,
     /* 1532206 */     GIR_EraseRootFromParent_Done,
     /* 1532207 */   // Label 21285: @1532207
     /* 1532207 */   GIM_Try, /*On fail goto*//*Label 21286*/ GIMT_Encode4(1532289), // Rule ID 18401 //
     /* 1532212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1532215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1532220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1532223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1532226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1532229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1532232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532251 */     // MIs[0] round
     /* 1532251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532254 */     // MIs[0] policy
     /* 1532254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532264 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1532267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532288 */     // GIR_Coverage, 18401,
     /* 1532288 */     GIR_EraseRootFromParent_Done,
     /* 1532289 */   // Label 21286: @1532289
     /* 1532289 */   GIM_Try, /*On fail goto*//*Label 21287*/ GIMT_Encode4(1532371), // Rule ID 18404 //
     /* 1532294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1532302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1532305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1532308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1532314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532333 */     // MIs[0] round
     /* 1532333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532336 */     // MIs[0] policy
     /* 1532336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532346 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1532349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532370 */     // GIR_Coverage, 18404,
     /* 1532370 */     GIR_EraseRootFromParent_Done,
     /* 1532371 */   // Label 21287: @1532371
     /* 1532371 */   GIM_Try, /*On fail goto*//*Label 21288*/ GIMT_Encode4(1532453), // Rule ID 18405 //
     /* 1532376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1532384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1532387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1532390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1532396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532415 */     // MIs[0] round
     /* 1532415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532418 */     // MIs[0] policy
     /* 1532418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532428 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1532431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532452 */     // GIR_Coverage, 18405,
     /* 1532452 */     GIR_EraseRootFromParent_Done,
     /* 1532453 */   // Label 21288: @1532453
     /* 1532453 */   GIM_Try, /*On fail goto*//*Label 21289*/ GIMT_Encode4(1532535), // Rule ID 18408 //
     /* 1532458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1532466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1532469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1532472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1532478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532497 */     // MIs[0] round
     /* 1532497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532500 */     // MIs[0] policy
     /* 1532500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532510 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1532513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532534 */     // GIR_Coverage, 18408,
     /* 1532534 */     GIR_EraseRootFromParent_Done,
     /* 1532535 */   // Label 21289: @1532535
     /* 1532535 */   GIM_Try, /*On fail goto*//*Label 21290*/ GIMT_Encode4(1532617), // Rule ID 18409 //
     /* 1532540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1532548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1532551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1532554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1532560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532579 */     // MIs[0] round
     /* 1532579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532582 */     // MIs[0] policy
     /* 1532582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532592 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1532595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532616 */     // GIR_Coverage, 18409,
     /* 1532616 */     GIR_EraseRootFromParent_Done,
     /* 1532617 */   // Label 21290: @1532617
     /* 1532617 */   GIM_Try, /*On fail goto*//*Label 21291*/ GIMT_Encode4(1532699), // Rule ID 18412 //
     /* 1532622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1532630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1532633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1532636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1532639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1532642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1532657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532661 */     // MIs[0] round
     /* 1532661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532664 */     // MIs[0] policy
     /* 1532664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532674 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1532677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532698 */     // GIR_Coverage, 18412,
     /* 1532698 */     GIR_EraseRootFromParent_Done,
     /* 1532699 */   // Label 21291: @1532699
     /* 1532699 */   GIM_Try, /*On fail goto*//*Label 21292*/ GIMT_Encode4(1532781), // Rule ID 18413 //
     /* 1532704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1532712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1532715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1532718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1532721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1532724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1532739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532743 */     // MIs[0] round
     /* 1532743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532746 */     // MIs[0] policy
     /* 1532746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532756 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1532759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532780 */     // GIR_Coverage, 18413,
     /* 1532780 */     GIR_EraseRootFromParent_Done,
     /* 1532781 */   // Label 21292: @1532781
     /* 1532781 */   GIM_Try, /*On fail goto*//*Label 21293*/ GIMT_Encode4(1532863), // Rule ID 18416 //
     /* 1532786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1532794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1532797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1532800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1532806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532825 */     // MIs[0] round
     /* 1532825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532828 */     // MIs[0] policy
     /* 1532828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532838 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1532841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532862 */     // GIR_Coverage, 18416,
     /* 1532862 */     GIR_EraseRootFromParent_Done,
     /* 1532863 */   // Label 21293: @1532863
     /* 1532863 */   GIM_Try, /*On fail goto*//*Label 21294*/ GIMT_Encode4(1532945), // Rule ID 18417 //
     /* 1532868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1532876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1532879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1532882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1532888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532907 */     // MIs[0] round
     /* 1532907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532910 */     // MIs[0] policy
     /* 1532910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532920 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1532923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532944 */     // GIR_Coverage, 18417,
     /* 1532944 */     GIR_EraseRootFromParent_Done,
     /* 1532945 */   // Label 21294: @1532945
     /* 1532945 */   GIM_Try, /*On fail goto*//*Label 21295*/ GIMT_Encode4(1533027), // Rule ID 18420 //
     /* 1532950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1532958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1532961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1532964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1532967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1532970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1532985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532989 */     // MIs[0] round
     /* 1532989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532992 */     // MIs[0] policy
     /* 1532992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533002 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1533005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533026 */     // GIR_Coverage, 18420,
     /* 1533026 */     GIR_EraseRootFromParent_Done,
     /* 1533027 */   // Label 21295: @1533027
     /* 1533027 */   GIM_Try, /*On fail goto*//*Label 21296*/ GIMT_Encode4(1533109), // Rule ID 18421 //
     /* 1533032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1533035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1533040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1533043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1533046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1533052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533071 */     // MIs[0] round
     /* 1533071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533074 */     // MIs[0] policy
     /* 1533074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533084 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1533087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533108 */     // GIR_Coverage, 18421,
     /* 1533108 */     GIR_EraseRootFromParent_Done,
     /* 1533109 */   // Label 21296: @1533109
     /* 1533109 */   GIM_Try, /*On fail goto*//*Label 21297*/ GIMT_Encode4(1533191), // Rule ID 18424 //
     /* 1533114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1533122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1533125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1533128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1533131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1533134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1533149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533153 */     // MIs[0] round
     /* 1533153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533156 */     // MIs[0] policy
     /* 1533156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533166 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1533169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533190 */     // GIR_Coverage, 18424,
     /* 1533190 */     GIR_EraseRootFromParent_Done,
     /* 1533191 */   // Label 21297: @1533191
     /* 1533191 */   GIM_Try, /*On fail goto*//*Label 21298*/ GIMT_Encode4(1533273), // Rule ID 18425 //
     /* 1533196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1533204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1533207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1533210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1533213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1533216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1533231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533235 */     // MIs[0] round
     /* 1533235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533238 */     // MIs[0] policy
     /* 1533238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533248 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1533251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533272 */     // GIR_Coverage, 18425,
     /* 1533272 */     GIR_EraseRootFromParent_Done,
     /* 1533273 */   // Label 21298: @1533273
     /* 1533273 */   GIM_Try, /*On fail goto*//*Label 21299*/ GIMT_Encode4(1533355), // Rule ID 18428 //
     /* 1533278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1533286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1533289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1533292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1533298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533317 */     // MIs[0] round
     /* 1533317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533320 */     // MIs[0] policy
     /* 1533320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533330 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1533333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533354 */     // GIR_Coverage, 18428,
     /* 1533354 */     GIR_EraseRootFromParent_Done,
     /* 1533355 */   // Label 21299: @1533355
     /* 1533355 */   GIM_Try, /*On fail goto*//*Label 21300*/ GIMT_Encode4(1533437), // Rule ID 18429 //
     /* 1533360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1533368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1533371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1533374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1533380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533399 */     // MIs[0] round
     /* 1533399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533402 */     // MIs[0] policy
     /* 1533402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533412 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1533415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533436 */     // GIR_Coverage, 18429,
     /* 1533436 */     GIR_EraseRootFromParent_Done,
     /* 1533437 */   // Label 21300: @1533437
     /* 1533437 */   GIM_Try, /*On fail goto*//*Label 21301*/ GIMT_Encode4(1533519), // Rule ID 18432 //
     /* 1533442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1533450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1533453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1533456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1533462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533481 */     // MIs[0] round
     /* 1533481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533484 */     // MIs[0] policy
     /* 1533484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533494 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1533497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533518 */     // GIR_Coverage, 18432,
     /* 1533518 */     GIR_EraseRootFromParent_Done,
     /* 1533519 */   // Label 21301: @1533519
     /* 1533519 */   GIM_Try, /*On fail goto*//*Label 21302*/ GIMT_Encode4(1533601), // Rule ID 18433 //
     /* 1533524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1533532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1533535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1533538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1533544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533563 */     // MIs[0] round
     /* 1533563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533566 */     // MIs[0] policy
     /* 1533566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533576 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1533579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533600 */     // GIR_Coverage, 18433,
     /* 1533600 */     GIR_EraseRootFromParent_Done,
     /* 1533601 */   // Label 21302: @1533601
     /* 1533601 */   GIM_Try, /*On fail goto*//*Label 21303*/ GIMT_Encode4(1533683), // Rule ID 18436 //
     /* 1533606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1533614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1533617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1533620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1533626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533645 */     // MIs[0] round
     /* 1533645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533648 */     // MIs[0] policy
     /* 1533648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533658 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1533661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533682 */     // GIR_Coverage, 18436,
     /* 1533682 */     GIR_EraseRootFromParent_Done,
     /* 1533683 */   // Label 21303: @1533683
     /* 1533683 */   GIM_Try, /*On fail goto*//*Label 21304*/ GIMT_Encode4(1533765), // Rule ID 18437 //
     /* 1533688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1533696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1533699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1533702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1533708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533727 */     // MIs[0] round
     /* 1533727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533730 */     // MIs[0] policy
     /* 1533730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533740 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1533743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533764 */     // GIR_Coverage, 18437,
     /* 1533764 */     GIR_EraseRootFromParent_Done,
     /* 1533765 */   // Label 21304: @1533765
     /* 1533765 */   GIM_Try, /*On fail goto*//*Label 21305*/ GIMT_Encode4(1533847), // Rule ID 18440 //
     /* 1533770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1533773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1533778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1533781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1533784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1533790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533809 */     // MIs[0] round
     /* 1533809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533812 */     // MIs[0] policy
     /* 1533812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533822 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1533825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533846 */     // GIR_Coverage, 18440,
     /* 1533846 */     GIR_EraseRootFromParent_Done,
     /* 1533847 */   // Label 21305: @1533847
     /* 1533847 */   GIM_Try, /*On fail goto*//*Label 21306*/ GIMT_Encode4(1533929), // Rule ID 18441 //
     /* 1533852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1533855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1533860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1533863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1533866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1533872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533891 */     // MIs[0] round
     /* 1533891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533894 */     // MIs[0] policy
     /* 1533894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533904 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1533907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533928 */     // GIR_Coverage, 18441,
     /* 1533928 */     GIR_EraseRootFromParent_Done,
     /* 1533929 */   // Label 21306: @1533929
     /* 1533929 */   GIM_Try, /*On fail goto*//*Label 21307*/ GIMT_Encode4(1534011), // Rule ID 18444 //
     /* 1533934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1533937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1533942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1533945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1533948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1533954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533973 */     // MIs[0] round
     /* 1533973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533976 */     // MIs[0] policy
     /* 1533976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533986 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1533989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534010 */     // GIR_Coverage, 18444,
     /* 1534010 */     GIR_EraseRootFromParent_Done,
     /* 1534011 */   // Label 21307: @1534011
     /* 1534011 */   GIM_Try, /*On fail goto*//*Label 21308*/ GIMT_Encode4(1534093), // Rule ID 18445 //
     /* 1534016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1534019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1534024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1534027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1534030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1534036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534055 */     // MIs[0] round
     /* 1534055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534058 */     // MIs[0] policy
     /* 1534058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534068 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1534071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534092 */     // GIR_Coverage, 18445,
     /* 1534092 */     GIR_EraseRootFromParent_Done,
     /* 1534093 */   // Label 21308: @1534093
     /* 1534093 */   GIM_Try, /*On fail goto*//*Label 21309*/ GIMT_Encode4(1534175), // Rule ID 18448 //
     /* 1534098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1534101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1534106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1534109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1534112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1534118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534137 */     // MIs[0] round
     /* 1534137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534140 */     // MIs[0] policy
     /* 1534140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534150 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1534153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534174 */     // GIR_Coverage, 18448,
     /* 1534174 */     GIR_EraseRootFromParent_Done,
     /* 1534175 */   // Label 21309: @1534175
     /* 1534175 */   GIM_Try, /*On fail goto*//*Label 21310*/ GIMT_Encode4(1534257), // Rule ID 18449 //
     /* 1534180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1534183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1534188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1534191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1534194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1534200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534219 */     // MIs[0] round
     /* 1534219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534222 */     // MIs[0] policy
     /* 1534222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534232 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1534235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534256 */     // GIR_Coverage, 18449,
     /* 1534256 */     GIR_EraseRootFromParent_Done,
     /* 1534257 */   // Label 21310: @1534257
     /* 1534257 */   GIM_Try, /*On fail goto*//*Label 21311*/ GIMT_Encode4(1534339), // Rule ID 18452 //
     /* 1534262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1534265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1534270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1534273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1534276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1534282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534301 */     // MIs[0] round
     /* 1534301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534304 */     // MIs[0] policy
     /* 1534304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534314 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1534317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534338 */     // GIR_Coverage, 18452,
     /* 1534338 */     GIR_EraseRootFromParent_Done,
     /* 1534339 */   // Label 21311: @1534339
     /* 1534339 */   GIM_Try, /*On fail goto*//*Label 21312*/ GIMT_Encode4(1534421), // Rule ID 18453 //
     /* 1534344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1534347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1534352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1534355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1534358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1534364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534383 */     // MIs[0] round
     /* 1534383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534386 */     // MIs[0] policy
     /* 1534386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534396 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1534399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534420 */     // GIR_Coverage, 18453,
     /* 1534420 */     GIR_EraseRootFromParent_Done,
     /* 1534421 */   // Label 21312: @1534421
     /* 1534421 */   GIM_Try, /*On fail goto*//*Label 21313*/ GIMT_Encode4(1534503), // Rule ID 18456 //
     /* 1534426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1534429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1534434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1534437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1534440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1534446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534465 */     // MIs[0] round
     /* 1534465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534468 */     // MIs[0] policy
     /* 1534468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534478 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1534481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534502 */     // GIR_Coverage, 18456,
     /* 1534502 */     GIR_EraseRootFromParent_Done,
     /* 1534503 */   // Label 21313: @1534503
     /* 1534503 */   GIM_Try, /*On fail goto*//*Label 21314*/ GIMT_Encode4(1534585), // Rule ID 18457 //
     /* 1534508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1534511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1534516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1534519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1534522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1534528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534547 */     // MIs[0] round
     /* 1534547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534550 */     // MIs[0] policy
     /* 1534550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534560 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1534563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534584 */     // GIR_Coverage, 18457,
     /* 1534584 */     GIR_EraseRootFromParent_Done,
     /* 1534585 */   // Label 21314: @1534585
     /* 1534585 */   GIM_Try, /*On fail goto*//*Label 21315*/ GIMT_Encode4(1534667), // Rule ID 18460 //
     /* 1534590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1534593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1534598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1534601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1534604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1534610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534629 */     // MIs[0] round
     /* 1534629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534632 */     // MIs[0] policy
     /* 1534632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534642 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1534645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534666 */     // GIR_Coverage, 18460,
     /* 1534666 */     GIR_EraseRootFromParent_Done,
     /* 1534667 */   // Label 21315: @1534667
     /* 1534667 */   GIM_Try, /*On fail goto*//*Label 21316*/ GIMT_Encode4(1534749), // Rule ID 18461 //
     /* 1534672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1534675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1534680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1534683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1534686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1534692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534711 */     // MIs[0] round
     /* 1534711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534714 */     // MIs[0] policy
     /* 1534714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534724 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1534727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534748 */     // GIR_Coverage, 18461,
     /* 1534748 */     GIR_EraseRootFromParent_Done,
     /* 1534749 */   // Label 21316: @1534749
     /* 1534749 */   GIM_Try, /*On fail goto*//*Label 21317*/ GIMT_Encode4(1534831), // Rule ID 18464 //
     /* 1534754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1534765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1534768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1534771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1534774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534793 */     // MIs[0] round
     /* 1534793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534796 */     // MIs[0] policy
     /* 1534796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534806 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1534809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534830 */     // GIR_Coverage, 18464,
     /* 1534830 */     GIR_EraseRootFromParent_Done,
     /* 1534831 */   // Label 21317: @1534831
     /* 1534831 */   GIM_Try, /*On fail goto*//*Label 21318*/ GIMT_Encode4(1534913), // Rule ID 18465 //
     /* 1534836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1534847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1534850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1534853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1534856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534875 */     // MIs[0] round
     /* 1534875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534878 */     // MIs[0] policy
     /* 1534878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534888 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1534891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534912 */     // GIR_Coverage, 18465,
     /* 1534912 */     GIR_EraseRootFromParent_Done,
     /* 1534913 */   // Label 21318: @1534913
     /* 1534913 */   GIM_Try, /*On fail goto*//*Label 21319*/ GIMT_Encode4(1534995), // Rule ID 18468 //
     /* 1534918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1534929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1534932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1534935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1534938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534957 */     // MIs[0] round
     /* 1534957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534960 */     // MIs[0] policy
     /* 1534960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534970 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1534973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534994 */     // GIR_Coverage, 18468,
     /* 1534994 */     GIR_EraseRootFromParent_Done,
     /* 1534995 */   // Label 21319: @1534995
     /* 1534995 */   GIM_Try, /*On fail goto*//*Label 21320*/ GIMT_Encode4(1535077), // Rule ID 18469 //
     /* 1535000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1535003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1535011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1535014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1535017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1535020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535039 */     // MIs[0] round
     /* 1535039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535042 */     // MIs[0] policy
     /* 1535042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1535055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535076 */     // GIR_Coverage, 18469,
     /* 1535076 */     GIR_EraseRootFromParent_Done,
     /* 1535077 */   // Label 21320: @1535077
     /* 1535077 */   GIM_Try, /*On fail goto*//*Label 21321*/ GIMT_Encode4(1535159), // Rule ID 18472 //
     /* 1535082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1535093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1535096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1535099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1535102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535121 */     // MIs[0] round
     /* 1535121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535124 */     // MIs[0] policy
     /* 1535124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535134 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1535137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535158 */     // GIR_Coverage, 18472,
     /* 1535158 */     GIR_EraseRootFromParent_Done,
     /* 1535159 */   // Label 21321: @1535159
     /* 1535159 */   GIM_Try, /*On fail goto*//*Label 21322*/ GIMT_Encode4(1535241), // Rule ID 18473 //
     /* 1535164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1535175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1535178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1535181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1535184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535203 */     // MIs[0] round
     /* 1535203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535206 */     // MIs[0] policy
     /* 1535206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535216 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1535219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535240 */     // GIR_Coverage, 18473,
     /* 1535240 */     GIR_EraseRootFromParent_Done,
     /* 1535241 */   // Label 21322: @1535241
     /* 1535241 */   GIM_Try, /*On fail goto*//*Label 21323*/ GIMT_Encode4(1535323), // Rule ID 18476 //
     /* 1535246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1535249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1535257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1535260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1535263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1535266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535285 */     // MIs[0] round
     /* 1535285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535288 */     // MIs[0] policy
     /* 1535288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535298 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1535301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535322 */     // GIR_Coverage, 18476,
     /* 1535322 */     GIR_EraseRootFromParent_Done,
     /* 1535323 */   // Label 21323: @1535323
     /* 1535323 */   GIM_Try, /*On fail goto*//*Label 21324*/ GIMT_Encode4(1535405), // Rule ID 18477 //
     /* 1535328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1535331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1535339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1535342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1535345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1535348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535367 */     // MIs[0] round
     /* 1535367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535370 */     // MIs[0] policy
     /* 1535370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535380 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1535383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535404 */     // GIR_Coverage, 18477,
     /* 1535404 */     GIR_EraseRootFromParent_Done,
     /* 1535405 */   // Label 21324: @1535405
     /* 1535405 */   GIM_Try, /*On fail goto*//*Label 21325*/ GIMT_Encode4(1535487), // Rule ID 18480 //
     /* 1535410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1535421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1535424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1535427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1535430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535449 */     // MIs[0] round
     /* 1535449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535452 */     // MIs[0] policy
     /* 1535452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535462 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1535465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535486 */     // GIR_Coverage, 18480,
     /* 1535486 */     GIR_EraseRootFromParent_Done,
     /* 1535487 */   // Label 21325: @1535487
     /* 1535487 */   GIM_Try, /*On fail goto*//*Label 21326*/ GIMT_Encode4(1535569), // Rule ID 18481 //
     /* 1535492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1535503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1535506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1535509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1535512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535531 */     // MIs[0] round
     /* 1535531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535534 */     // MIs[0] policy
     /* 1535534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535544 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1535547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535568 */     // GIR_Coverage, 18481,
     /* 1535568 */     GIR_EraseRootFromParent_Done,
     /* 1535569 */   // Label 21326: @1535569
     /* 1535569 */   GIM_Try, /*On fail goto*//*Label 21327*/ GIMT_Encode4(1535651), // Rule ID 18484 //
     /* 1535574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1535585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1535588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1535591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1535594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535613 */     // MIs[0] round
     /* 1535613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535616 */     // MIs[0] policy
     /* 1535616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535626 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1535629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535650 */     // GIR_Coverage, 18484,
     /* 1535650 */     GIR_EraseRootFromParent_Done,
     /* 1535651 */   // Label 21327: @1535651
     /* 1535651 */   GIM_Try, /*On fail goto*//*Label 21328*/ GIMT_Encode4(1535733), // Rule ID 18485 //
     /* 1535656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1535659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1535667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1535670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1535673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1535676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535695 */     // MIs[0] round
     /* 1535695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535698 */     // MIs[0] policy
     /* 1535698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535708 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1535711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535732 */     // GIR_Coverage, 18485,
     /* 1535732 */     GIR_EraseRootFromParent_Done,
     /* 1535733 */   // Label 21328: @1535733
     /* 1535733 */   GIM_Try, /*On fail goto*//*Label 21329*/ GIMT_Encode4(1535815), // Rule ID 18488 //
     /* 1535738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1535741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1535749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1535752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1535755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1535758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535777 */     // MIs[0] round
     /* 1535777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535780 */     // MIs[0] policy
     /* 1535780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535790 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1535793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535814 */     // GIR_Coverage, 18488,
     /* 1535814 */     GIR_EraseRootFromParent_Done,
     /* 1535815 */   // Label 21329: @1535815
     /* 1535815 */   GIM_Try, /*On fail goto*//*Label 21330*/ GIMT_Encode4(1535897), // Rule ID 18489 //
     /* 1535820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1535823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1535831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1535834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1535837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1535840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535859 */     // MIs[0] round
     /* 1535859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535862 */     // MIs[0] policy
     /* 1535862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535872 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1535875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535896 */     // GIR_Coverage, 18489,
     /* 1535896 */     GIR_EraseRootFromParent_Done,
     /* 1535897 */   // Label 21330: @1535897
     /* 1535897 */   GIM_Try, /*On fail goto*//*Label 21331*/ GIMT_Encode4(1535979), // Rule ID 18492 //
     /* 1535902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1535905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1535913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1535916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1535919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1535922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535941 */     // MIs[0] round
     /* 1535941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535944 */     // MIs[0] policy
     /* 1535944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535954 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1535957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535978 */     // GIR_Coverage, 18492,
     /* 1535978 */     GIR_EraseRootFromParent_Done,
     /* 1535979 */   // Label 21331: @1535979
     /* 1535979 */   GIM_Try, /*On fail goto*//*Label 21332*/ GIMT_Encode4(1536061), // Rule ID 18493 //
     /* 1535984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1535987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1535995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1535998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1536001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1536004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536023 */     // MIs[0] round
     /* 1536023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536026 */     // MIs[0] policy
     /* 1536026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536036 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1536039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536060 */     // GIR_Coverage, 18493,
     /* 1536060 */     GIR_EraseRootFromParent_Done,
     /* 1536061 */   // Label 21332: @1536061
     /* 1536061 */   GIM_Try, /*On fail goto*//*Label 21333*/ GIMT_Encode4(1536143), // Rule ID 18496 //
     /* 1536066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1536077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1536080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1536083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1536086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536105 */     // MIs[0] round
     /* 1536105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536108 */     // MIs[0] policy
     /* 1536108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536118 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1536121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536142 */     // GIR_Coverage, 18496,
     /* 1536142 */     GIR_EraseRootFromParent_Done,
     /* 1536143 */   // Label 21333: @1536143
     /* 1536143 */   GIM_Try, /*On fail goto*//*Label 21334*/ GIMT_Encode4(1536225), // Rule ID 18497 //
     /* 1536148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1536159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1536162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1536165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1536168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536187 */     // MIs[0] round
     /* 1536187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536190 */     // MIs[0] policy
     /* 1536190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536200 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1536203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536224 */     // GIR_Coverage, 18497,
     /* 1536224 */     GIR_EraseRootFromParent_Done,
     /* 1536225 */   // Label 21334: @1536225
     /* 1536225 */   GIM_Try, /*On fail goto*//*Label 21335*/ GIMT_Encode4(1536307), // Rule ID 18500 //
     /* 1536230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1536233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1536241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1536244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1536247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1536250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536269 */     // MIs[0] round
     /* 1536269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536272 */     // MIs[0] policy
     /* 1536272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536282 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1536285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536306 */     // GIR_Coverage, 18500,
     /* 1536306 */     GIR_EraseRootFromParent_Done,
     /* 1536307 */   // Label 21335: @1536307
     /* 1536307 */   GIM_Try, /*On fail goto*//*Label 21336*/ GIMT_Encode4(1536389), // Rule ID 18501 //
     /* 1536312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1536315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1536323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1536326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1536329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1536332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536351 */     // MIs[0] round
     /* 1536351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536354 */     // MIs[0] policy
     /* 1536354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536364 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1536367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536388 */     // GIR_Coverage, 18501,
     /* 1536388 */     GIR_EraseRootFromParent_Done,
     /* 1536389 */   // Label 21336: @1536389
     /* 1536389 */   GIM_Try, /*On fail goto*//*Label 21337*/ GIMT_Encode4(1536471), // Rule ID 18504 //
     /* 1536394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1536397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1536405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1536408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1536411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1536414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536433 */     // MIs[0] round
     /* 1536433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536436 */     // MIs[0] policy
     /* 1536436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536446 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1536449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536470 */     // GIR_Coverage, 18504,
     /* 1536470 */     GIR_EraseRootFromParent_Done,
     /* 1536471 */   // Label 21337: @1536471
     /* 1536471 */   GIM_Try, /*On fail goto*//*Label 21338*/ GIMT_Encode4(1536553), // Rule ID 18505 //
     /* 1536476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1536479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1536487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1536490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1536493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1536496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536515 */     // MIs[0] round
     /* 1536515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536518 */     // MIs[0] policy
     /* 1536518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536528 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1536531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536552 */     // GIR_Coverage, 18505,
     /* 1536552 */     GIR_EraseRootFromParent_Done,
     /* 1536553 */   // Label 21338: @1536553
     /* 1536553 */   GIM_Try, /*On fail goto*//*Label 21339*/ GIMT_Encode4(1536635), // Rule ID 18508 //
     /* 1536558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1536561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1536569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1536572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1536575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1536578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536597 */     // MIs[0] round
     /* 1536597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536600 */     // MIs[0] policy
     /* 1536600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536610 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1536613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536634 */     // GIR_Coverage, 18508,
     /* 1536634 */     GIR_EraseRootFromParent_Done,
     /* 1536635 */   // Label 21339: @1536635
     /* 1536635 */   GIM_Try, /*On fail goto*//*Label 21340*/ GIMT_Encode4(1536717), // Rule ID 18509 //
     /* 1536640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1536643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1536651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1536654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1536657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1536660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536679 */     // MIs[0] round
     /* 1536679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536682 */     // MIs[0] policy
     /* 1536682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536692 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1536695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536716 */     // GIR_Coverage, 18509,
     /* 1536716 */     GIR_EraseRootFromParent_Done,
     /* 1536717 */   // Label 21340: @1536717
     /* 1536717 */   GIM_Try, /*On fail goto*//*Label 21341*/ GIMT_Encode4(1536799), // Rule ID 18512 //
     /* 1536722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1536725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1536733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1536736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1536739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1536742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536761 */     // MIs[0] round
     /* 1536761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536764 */     // MIs[0] policy
     /* 1536764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536774 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1536777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536798 */     // GIR_Coverage, 18512,
     /* 1536798 */     GIR_EraseRootFromParent_Done,
     /* 1536799 */   // Label 21341: @1536799
     /* 1536799 */   GIM_Try, /*On fail goto*//*Label 21342*/ GIMT_Encode4(1536881), // Rule ID 18513 //
     /* 1536804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1536807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1536815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1536818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1536821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1536824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536843 */     // MIs[0] round
     /* 1536843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536846 */     // MIs[0] policy
     /* 1536846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536856 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1536859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536880 */     // GIR_Coverage, 18513,
     /* 1536880 */     GIR_EraseRootFromParent_Done,
     /* 1536881 */   // Label 21342: @1536881
     /* 1536881 */   GIM_Try, /*On fail goto*//*Label 21343*/ GIMT_Encode4(1536963), // Rule ID 18516 //
     /* 1536886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1536889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1536897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1536900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1536903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1536906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536925 */     // MIs[0] round
     /* 1536925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536928 */     // MIs[0] policy
     /* 1536928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536938 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1536941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536962 */     // GIR_Coverage, 18516,
     /* 1536962 */     GIR_EraseRootFromParent_Done,
     /* 1536963 */   // Label 21343: @1536963
     /* 1536963 */   GIM_Try, /*On fail goto*//*Label 21344*/ GIMT_Encode4(1537045), // Rule ID 18517 //
     /* 1536968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1536971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1536979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1536982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1536985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1536988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537007 */     // MIs[0] round
     /* 1537007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537010 */     // MIs[0] policy
     /* 1537010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537020 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1537023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1537041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537044 */     // GIR_Coverage, 18517,
     /* 1537044 */     GIR_EraseRootFromParent_Done,
     /* 1537045 */   // Label 21344: @1537045
     /* 1537045 */   GIM_Try, /*On fail goto*//*Label 21345*/ GIMT_Encode4(1537127), // Rule ID 18520 //
     /* 1537050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1537053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1537058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1537061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1537064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1537067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1537070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537089 */     // MIs[0] round
     /* 1537089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537092 */     // MIs[0] policy
     /* 1537092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537102 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1537105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1537123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537126 */     // GIR_Coverage, 18520,
     /* 1537126 */     GIR_EraseRootFromParent_Done,
     /* 1537127 */   // Label 21345: @1537127
     /* 1537127 */   GIM_Try, /*On fail goto*//*Label 21346*/ GIMT_Encode4(1537209), // Rule ID 18521 //
     /* 1537132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1537135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1537140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1537143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1537146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1537149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1537152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537171 */     // MIs[0] round
     /* 1537171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537174 */     // MIs[0] policy
     /* 1537174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537184 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1537187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1537205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537208 */     // GIR_Coverage, 18521,
     /* 1537208 */     GIR_EraseRootFromParent_Done,
     /* 1537209 */   // Label 21346: @1537209
     /* 1537209 */   GIM_Try, /*On fail goto*//*Label 21347*/ GIMT_Encode4(1537291), // Rule ID 18524 //
     /* 1537214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1537222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1537225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1537228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1537231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1537234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1537249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537253 */     // MIs[0] round
     /* 1537253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537256 */     // MIs[0] policy
     /* 1537256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537266 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1537269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537290 */     // GIR_Coverage, 18524,
     /* 1537290 */     GIR_EraseRootFromParent_Done,
     /* 1537291 */   // Label 21347: @1537291
     /* 1537291 */   GIM_Try, /*On fail goto*//*Label 21348*/ GIMT_Encode4(1537373), // Rule ID 18525 //
     /* 1537296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1537304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1537307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1537310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1537313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1537316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1537331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537335 */     // MIs[0] round
     /* 1537335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537338 */     // MIs[0] policy
     /* 1537338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537348 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1537351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537372 */     // GIR_Coverage, 18525,
     /* 1537372 */     GIR_EraseRootFromParent_Done,
     /* 1537373 */   // Label 21348: @1537373
     /* 1537373 */   GIM_Try, /*On fail goto*//*Label 21349*/ GIMT_Encode4(1537455), // Rule ID 18528 //
     /* 1537378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1537386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1537389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1537392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1537395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1537398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1537413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537417 */     // MIs[0] round
     /* 1537417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537420 */     // MIs[0] policy
     /* 1537420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537430 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1537433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537454 */     // GIR_Coverage, 18528,
     /* 1537454 */     GIR_EraseRootFromParent_Done,
     /* 1537455 */   // Label 21349: @1537455
     /* 1537455 */   GIM_Try, /*On fail goto*//*Label 21350*/ GIMT_Encode4(1537537), // Rule ID 18529 //
     /* 1537460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1537468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1537471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1537474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1537477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1537480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1537495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537499 */     // MIs[0] round
     /* 1537499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537502 */     // MIs[0] policy
     /* 1537502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537512 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1537515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537536 */     // GIR_Coverage, 18529,
     /* 1537536 */     GIR_EraseRootFromParent_Done,
     /* 1537537 */   // Label 21350: @1537537
     /* 1537537 */   GIM_Try, /*On fail goto*//*Label 21351*/ GIMT_Encode4(1537619), // Rule ID 18532 //
     /* 1537542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1537550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1537553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1537556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1537559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1537562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1537577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537581 */     // MIs[0] round
     /* 1537581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537584 */     // MIs[0] policy
     /* 1537584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537594 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1537597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537618 */     // GIR_Coverage, 18532,
     /* 1537618 */     GIR_EraseRootFromParent_Done,
     /* 1537619 */   // Label 21351: @1537619
     /* 1537619 */   GIM_Try, /*On fail goto*//*Label 21352*/ GIMT_Encode4(1537701), // Rule ID 18533 //
     /* 1537624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1537632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1537635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1537638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1537641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1537644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1537659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537663 */     // MIs[0] round
     /* 1537663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537666 */     // MIs[0] policy
     /* 1537666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537676 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1537679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537700 */     // GIR_Coverage, 18533,
     /* 1537700 */     GIR_EraseRootFromParent_Done,
     /* 1537701 */   // Label 21352: @1537701
     /* 1537701 */   GIM_Try, /*On fail goto*//*Label 21353*/ GIMT_Encode4(1537783), // Rule ID 18536 //
     /* 1537706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1537714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1537717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1537720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1537723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1537726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1537741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537745 */     // MIs[0] round
     /* 1537745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537748 */     // MIs[0] policy
     /* 1537748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537758 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1537761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537782 */     // GIR_Coverage, 18536,
     /* 1537782 */     GIR_EraseRootFromParent_Done,
     /* 1537783 */   // Label 21353: @1537783
     /* 1537783 */   GIM_Try, /*On fail goto*//*Label 21354*/ GIMT_Encode4(1537865), // Rule ID 18537 //
     /* 1537788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1537796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1537799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1537802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1537805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1537808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1537823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537827 */     // MIs[0] round
     /* 1537827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537830 */     // MIs[0] policy
     /* 1537830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537840 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1537843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537864 */     // GIR_Coverage, 18537,
     /* 1537864 */     GIR_EraseRootFromParent_Done,
     /* 1537865 */   // Label 21354: @1537865
     /* 1537865 */   GIM_Try, /*On fail goto*//*Label 21355*/ GIMT_Encode4(1537947), // Rule ID 18540 //
     /* 1537870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1537878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1537881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1537884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1537887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1537890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1537905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537909 */     // MIs[0] round
     /* 1537909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537912 */     // MIs[0] policy
     /* 1537912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537922 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1537925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537946 */     // GIR_Coverage, 18540,
     /* 1537946 */     GIR_EraseRootFromParent_Done,
     /* 1537947 */   // Label 21355: @1537947
     /* 1537947 */   GIM_Try, /*On fail goto*//*Label 21356*/ GIMT_Encode4(1538029), // Rule ID 18541 //
     /* 1537952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1537960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1537963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1537966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1537969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1537972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1537987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537991 */     // MIs[0] round
     /* 1537991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537994 */     // MIs[0] policy
     /* 1537994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538004 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1538007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538028 */     // GIR_Coverage, 18541,
     /* 1538028 */     GIR_EraseRootFromParent_Done,
     /* 1538029 */   // Label 21356: @1538029
     /* 1538029 */   GIM_Try, /*On fail goto*//*Label 21357*/ GIMT_Encode4(1538111), // Rule ID 18544 //
     /* 1538034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1538037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1538042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1538045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1538048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1538051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1538054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1538069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538073 */     // MIs[0] round
     /* 1538073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538076 */     // MIs[0] policy
     /* 1538076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538086 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1538089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538110 */     // GIR_Coverage, 18544,
     /* 1538110 */     GIR_EraseRootFromParent_Done,
     /* 1538111 */   // Label 21357: @1538111
     /* 1538111 */   GIM_Try, /*On fail goto*//*Label 21358*/ GIMT_Encode4(1538193), // Rule ID 18545 //
     /* 1538116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1538124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1538127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1538130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1538133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1538136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1538151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538155 */     // MIs[0] round
     /* 1538155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538158 */     // MIs[0] policy
     /* 1538158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538168 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1538171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538192 */     // GIR_Coverage, 18545,
     /* 1538192 */     GIR_EraseRootFromParent_Done,
     /* 1538193 */   // Label 21358: @1538193
     /* 1538193 */   GIM_Try, /*On fail goto*//*Label 21359*/ GIMT_Encode4(1538275), // Rule ID 18548 //
     /* 1538198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1538201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1538206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1538209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1538212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1538218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538237 */     // MIs[0] round
     /* 1538237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538240 */     // MIs[0] policy
     /* 1538240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538250 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1538253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538274 */     // GIR_Coverage, 18548,
     /* 1538274 */     GIR_EraseRootFromParent_Done,
     /* 1538275 */   // Label 21359: @1538275
     /* 1538275 */   GIM_Try, /*On fail goto*//*Label 21360*/ GIMT_Encode4(1538357), // Rule ID 18549 //
     /* 1538280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1538283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1538288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1538291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1538294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1538300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538319 */     // MIs[0] round
     /* 1538319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538322 */     // MIs[0] policy
     /* 1538322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538332 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1538335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538356 */     // GIR_Coverage, 18549,
     /* 1538356 */     GIR_EraseRootFromParent_Done,
     /* 1538357 */   // Label 21360: @1538357
     /* 1538357 */   GIM_Try, /*On fail goto*//*Label 21361*/ GIMT_Encode4(1538439), // Rule ID 18552 //
     /* 1538362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1538365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1538370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1538373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1538376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1538382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538401 */     // MIs[0] round
     /* 1538401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538404 */     // MIs[0] policy
     /* 1538404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538414 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1538417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538438 */     // GIR_Coverage, 18552,
     /* 1538438 */     GIR_EraseRootFromParent_Done,
     /* 1538439 */   // Label 21361: @1538439
     /* 1538439 */   GIM_Try, /*On fail goto*//*Label 21362*/ GIMT_Encode4(1538521), // Rule ID 18553 //
     /* 1538444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1538447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1538452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1538455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1538458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1538464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538483 */     // MIs[0] round
     /* 1538483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538486 */     // MIs[0] policy
     /* 1538486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538496 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1538499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538520 */     // GIR_Coverage, 18553,
     /* 1538520 */     GIR_EraseRootFromParent_Done,
     /* 1538521 */   // Label 21362: @1538521
     /* 1538521 */   GIM_Try, /*On fail goto*//*Label 21363*/ GIMT_Encode4(1538603), // Rule ID 18556 //
     /* 1538526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1538529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1538534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1538537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1538540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1538546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538565 */     // MIs[0] round
     /* 1538565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538568 */     // MIs[0] policy
     /* 1538568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538578 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1538581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538602 */     // GIR_Coverage, 18556,
     /* 1538602 */     GIR_EraseRootFromParent_Done,
     /* 1538603 */   // Label 21363: @1538603
     /* 1538603 */   GIM_Try, /*On fail goto*//*Label 21364*/ GIMT_Encode4(1538685), // Rule ID 18557 //
     /* 1538608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1538611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1538616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1538619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1538622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1538628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538647 */     // MIs[0] round
     /* 1538647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538650 */     // MIs[0] policy
     /* 1538650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538660 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1538663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538684 */     // GIR_Coverage, 18557,
     /* 1538684 */     GIR_EraseRootFromParent_Done,
     /* 1538685 */   // Label 21364: @1538685
     /* 1538685 */   GIM_Try, /*On fail goto*//*Label 21365*/ GIMT_Encode4(1538767), // Rule ID 18560 //
     /* 1538690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1538693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1538698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1538701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1538704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1538707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1538710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1538725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538729 */     // MIs[0] round
     /* 1538729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538732 */     // MIs[0] policy
     /* 1538732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538742 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1538745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538766 */     // GIR_Coverage, 18560,
     /* 1538766 */     GIR_EraseRootFromParent_Done,
     /* 1538767 */   // Label 21365: @1538767
     /* 1538767 */   GIM_Try, /*On fail goto*//*Label 21366*/ GIMT_Encode4(1538849), // Rule ID 18561 //
     /* 1538772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1538775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1538780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1538783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1538786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1538789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1538792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1538807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538811 */     // MIs[0] round
     /* 1538811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538814 */     // MIs[0] policy
     /* 1538814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1538827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538848 */     // GIR_Coverage, 18561,
     /* 1538848 */     GIR_EraseRootFromParent_Done,
     /* 1538849 */   // Label 21366: @1538849
     /* 1538849 */   GIM_Try, /*On fail goto*//*Label 21367*/ GIMT_Encode4(1538931), // Rule ID 18564 //
     /* 1538854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1538857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1538862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1538865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1538868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1538871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1538874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1538889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538893 */     // MIs[0] round
     /* 1538893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538896 */     // MIs[0] policy
     /* 1538896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538906 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1538909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538930 */     // GIR_Coverage, 18564,
     /* 1538930 */     GIR_EraseRootFromParent_Done,
     /* 1538931 */   // Label 21367: @1538931
     /* 1538931 */   GIM_Try, /*On fail goto*//*Label 21368*/ GIMT_Encode4(1539013), // Rule ID 18565 //
     /* 1538936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1538939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1538944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1538947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1538950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1538953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1538956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1538971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538975 */     // MIs[0] round
     /* 1538975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538978 */     // MIs[0] policy
     /* 1538978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538988 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1538991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539012 */     // GIR_Coverage, 18565,
     /* 1539012 */     GIR_EraseRootFromParent_Done,
     /* 1539013 */   // Label 21368: @1539013
     /* 1539013 */   GIM_Try, /*On fail goto*//*Label 21369*/ GIMT_Encode4(1539095), // Rule ID 18568 //
     /* 1539018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1539021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1539026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1539029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1539032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1539038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539057 */     // MIs[0] round
     /* 1539057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539060 */     // MIs[0] policy
     /* 1539060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539070 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1539073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539094 */     // GIR_Coverage, 18568,
     /* 1539094 */     GIR_EraseRootFromParent_Done,
     /* 1539095 */   // Label 21369: @1539095
     /* 1539095 */   GIM_Try, /*On fail goto*//*Label 21370*/ GIMT_Encode4(1539177), // Rule ID 18569 //
     /* 1539100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1539103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1539108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1539111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1539114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1539120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539139 */     // MIs[0] round
     /* 1539139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539142 */     // MIs[0] policy
     /* 1539142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539152 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1539155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539176 */     // GIR_Coverage, 18569,
     /* 1539176 */     GIR_EraseRootFromParent_Done,
     /* 1539177 */   // Label 21370: @1539177
     /* 1539177 */   GIM_Try, /*On fail goto*//*Label 21371*/ GIMT_Encode4(1539259), // Rule ID 18572 //
     /* 1539182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1539185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1539190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1539193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1539196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1539202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539221 */     // MIs[0] round
     /* 1539221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539224 */     // MIs[0] policy
     /* 1539224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539234 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1539237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539258 */     // GIR_Coverage, 18572,
     /* 1539258 */     GIR_EraseRootFromParent_Done,
     /* 1539259 */   // Label 21371: @1539259
     /* 1539259 */   GIM_Try, /*On fail goto*//*Label 21372*/ GIMT_Encode4(1539341), // Rule ID 18573 //
     /* 1539264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1539267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1539272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1539275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1539278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1539284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539303 */     // MIs[0] round
     /* 1539303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539306 */     // MIs[0] policy
     /* 1539306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539316 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1539319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539340 */     // GIR_Coverage, 18573,
     /* 1539340 */     GIR_EraseRootFromParent_Done,
     /* 1539341 */   // Label 21372: @1539341
     /* 1539341 */   GIM_Try, /*On fail goto*//*Label 21373*/ GIMT_Encode4(1539423), // Rule ID 18576 //
     /* 1539346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1539349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1539354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1539357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1539360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1539366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539385 */     // MIs[0] round
     /* 1539385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539388 */     // MIs[0] policy
     /* 1539388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539398 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1539401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539422 */     // GIR_Coverage, 18576,
     /* 1539422 */     GIR_EraseRootFromParent_Done,
     /* 1539423 */   // Label 21373: @1539423
     /* 1539423 */   GIM_Try, /*On fail goto*//*Label 21374*/ GIMT_Encode4(1539505), // Rule ID 18577 //
     /* 1539428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1539431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1539436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1539439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1539442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1539448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539467 */     // MIs[0] round
     /* 1539467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539470 */     // MIs[0] policy
     /* 1539470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539480 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1539483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539504 */     // GIR_Coverage, 18577,
     /* 1539504 */     GIR_EraseRootFromParent_Done,
     /* 1539505 */   // Label 21374: @1539505
     /* 1539505 */   GIM_Try, /*On fail goto*//*Label 21375*/ GIMT_Encode4(1539587), // Rule ID 18580 //
     /* 1539510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1539513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1539518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1539521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1539524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1539530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539549 */     // MIs[0] round
     /* 1539549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539552 */     // MIs[0] policy
     /* 1539552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539562 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1539565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539586 */     // GIR_Coverage, 18580,
     /* 1539586 */     GIR_EraseRootFromParent_Done,
     /* 1539587 */   // Label 21375: @1539587
     /* 1539587 */   GIM_Try, /*On fail goto*//*Label 21376*/ GIMT_Encode4(1539669), // Rule ID 18581 //
     /* 1539592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1539595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1539600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1539603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1539606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1539612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539631 */     // MIs[0] round
     /* 1539631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539634 */     // MIs[0] policy
     /* 1539634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539644 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1539647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539668 */     // GIR_Coverage, 18581,
     /* 1539668 */     GIR_EraseRootFromParent_Done,
     /* 1539669 */   // Label 21376: @1539669
     /* 1539669 */   GIM_Try, /*On fail goto*//*Label 21377*/ GIMT_Encode4(1539751), // Rule ID 18584 //
     /* 1539674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1539685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1539688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1539691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1539694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539713 */     // MIs[0] round
     /* 1539713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539716 */     // MIs[0] policy
     /* 1539716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539726 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1539729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539750 */     // GIR_Coverage, 18584,
     /* 1539750 */     GIR_EraseRootFromParent_Done,
     /* 1539751 */   // Label 21377: @1539751
     /* 1539751 */   GIM_Try, /*On fail goto*//*Label 21378*/ GIMT_Encode4(1539833), // Rule ID 18585 //
     /* 1539756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1539767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1539770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1539773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1539776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539795 */     // MIs[0] round
     /* 1539795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539798 */     // MIs[0] policy
     /* 1539798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539808 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1539811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539832 */     // GIR_Coverage, 18585,
     /* 1539832 */     GIR_EraseRootFromParent_Done,
     /* 1539833 */   // Label 21378: @1539833
     /* 1539833 */   GIM_Try, /*On fail goto*//*Label 21379*/ GIMT_Encode4(1539915), // Rule ID 18588 //
     /* 1539838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1539849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1539852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1539855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1539858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539877 */     // MIs[0] round
     /* 1539877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539880 */     // MIs[0] policy
     /* 1539880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539890 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1539893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539914 */     // GIR_Coverage, 18588,
     /* 1539914 */     GIR_EraseRootFromParent_Done,
     /* 1539915 */   // Label 21379: @1539915
     /* 1539915 */   GIM_Try, /*On fail goto*//*Label 21380*/ GIMT_Encode4(1539997), // Rule ID 18589 //
     /* 1539920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1539931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1539934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1539937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1539940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539959 */     // MIs[0] round
     /* 1539959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539962 */     // MIs[0] policy
     /* 1539962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539972 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1539975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539996 */     // GIR_Coverage, 18589,
     /* 1539996 */     GIR_EraseRootFromParent_Done,
     /* 1539997 */   // Label 21380: @1539997
     /* 1539997 */   GIM_Try, /*On fail goto*//*Label 21381*/ GIMT_Encode4(1540079), // Rule ID 18592 //
     /* 1540002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1540005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1540013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1540016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1540019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1540022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540041 */     // MIs[0] round
     /* 1540041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540044 */     // MIs[0] policy
     /* 1540044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540054 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1540057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540078 */     // GIR_Coverage, 18592,
     /* 1540078 */     GIR_EraseRootFromParent_Done,
     /* 1540079 */   // Label 21381: @1540079
     /* 1540079 */   GIM_Try, /*On fail goto*//*Label 21382*/ GIMT_Encode4(1540161), // Rule ID 18593 //
     /* 1540084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1540087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1540095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1540098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1540101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1540104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540123 */     // MIs[0] round
     /* 1540123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540126 */     // MIs[0] policy
     /* 1540126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540136 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1540139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540160 */     // GIR_Coverage, 18593,
     /* 1540160 */     GIR_EraseRootFromParent_Done,
     /* 1540161 */   // Label 21382: @1540161
     /* 1540161 */   GIM_Try, /*On fail goto*//*Label 21383*/ GIMT_Encode4(1540243), // Rule ID 18596 //
     /* 1540166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1540169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1540177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1540180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1540183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1540186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540205 */     // MIs[0] round
     /* 1540205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540208 */     // MIs[0] policy
     /* 1540208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540218 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1540221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540242 */     // GIR_Coverage, 18596,
     /* 1540242 */     GIR_EraseRootFromParent_Done,
     /* 1540243 */   // Label 21383: @1540243
     /* 1540243 */   GIM_Try, /*On fail goto*//*Label 21384*/ GIMT_Encode4(1540325), // Rule ID 18597 //
     /* 1540248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1540251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1540259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1540262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1540265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1540268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540287 */     // MIs[0] round
     /* 1540287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540290 */     // MIs[0] policy
     /* 1540290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540300 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1540303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540324 */     // GIR_Coverage, 18597,
     /* 1540324 */     GIR_EraseRootFromParent_Done,
     /* 1540325 */   // Label 21384: @1540325
     /* 1540325 */   GIM_Try, /*On fail goto*//*Label 21385*/ GIMT_Encode4(1540407), // Rule ID 18600 //
     /* 1540330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1540333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1540341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1540344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1540347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1540350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540369 */     // MIs[0] round
     /* 1540369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540372 */     // MIs[0] policy
     /* 1540372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540382 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1540385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540406 */     // GIR_Coverage, 18600,
     /* 1540406 */     GIR_EraseRootFromParent_Done,
     /* 1540407 */   // Label 21385: @1540407
     /* 1540407 */   GIM_Try, /*On fail goto*//*Label 21386*/ GIMT_Encode4(1540489), // Rule ID 18601 //
     /* 1540412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1540415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1540423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1540426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1540429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1540432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540451 */     // MIs[0] round
     /* 1540451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540454 */     // MIs[0] policy
     /* 1540454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540464 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1540467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540488 */     // GIR_Coverage, 18601,
     /* 1540488 */     GIR_EraseRootFromParent_Done,
     /* 1540489 */   // Label 21386: @1540489
     /* 1540489 */   GIM_Try, /*On fail goto*//*Label 21387*/ GIMT_Encode4(1540571), // Rule ID 18604 //
     /* 1540494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1540497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1540505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1540508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1540511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1540514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540533 */     // MIs[0] round
     /* 1540533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540536 */     // MIs[0] policy
     /* 1540536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540546 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1540549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540570 */     // GIR_Coverage, 18604,
     /* 1540570 */     GIR_EraseRootFromParent_Done,
     /* 1540571 */   // Label 21387: @1540571
     /* 1540571 */   GIM_Try, /*On fail goto*//*Label 21388*/ GIMT_Encode4(1540653), // Rule ID 18605 //
     /* 1540576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1540579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1540587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1540590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1540593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1540596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540615 */     // MIs[0] round
     /* 1540615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540618 */     // MIs[0] policy
     /* 1540618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540628 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1540631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540652 */     // GIR_Coverage, 18605,
     /* 1540652 */     GIR_EraseRootFromParent_Done,
     /* 1540653 */   // Label 21388: @1540653
     /* 1540653 */   GIM_Try, /*On fail goto*//*Label 21389*/ GIMT_Encode4(1540735), // Rule ID 18608 //
     /* 1540658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1540661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1540669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1540672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1540675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1540678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540697 */     // MIs[0] round
     /* 1540697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540700 */     // MIs[0] policy
     /* 1540700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540710 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1540713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540734 */     // GIR_Coverage, 18608,
     /* 1540734 */     GIR_EraseRootFromParent_Done,
     /* 1540735 */   // Label 21389: @1540735
     /* 1540735 */   GIM_Try, /*On fail goto*//*Label 21390*/ GIMT_Encode4(1540817), // Rule ID 18609 //
     /* 1540740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1540743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1540751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1540754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1540757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1540760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540779 */     // MIs[0] round
     /* 1540779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540782 */     // MIs[0] policy
     /* 1540782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540792 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1540795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540816 */     // GIR_Coverage, 18609,
     /* 1540816 */     GIR_EraseRootFromParent_Done,
     /* 1540817 */   // Label 21390: @1540817
     /* 1540817 */   GIM_Try, /*On fail goto*//*Label 21391*/ GIMT_Encode4(1540899), // Rule ID 18612 //
     /* 1540822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1540825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1540833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1540836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1540839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1540842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540861 */     // MIs[0] round
     /* 1540861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540864 */     // MIs[0] policy
     /* 1540864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540874 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1540877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540898 */     // GIR_Coverage, 18612,
     /* 1540898 */     GIR_EraseRootFromParent_Done,
     /* 1540899 */   // Label 21391: @1540899
     /* 1540899 */   GIM_Try, /*On fail goto*//*Label 21392*/ GIMT_Encode4(1540981), // Rule ID 18613 //
     /* 1540904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1540907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1540915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1540918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1540921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1540924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540943 */     // MIs[0] round
     /* 1540943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540946 */     // MIs[0] policy
     /* 1540946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540956 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1540959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540980 */     // GIR_Coverage, 18613,
     /* 1540980 */     GIR_EraseRootFromParent_Done,
     /* 1540981 */   // Label 21392: @1540981
     /* 1540981 */   GIM_Try, /*On fail goto*//*Label 21393*/ GIMT_Encode4(1541063), // Rule ID 18616 //
     /* 1540986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1540989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1540997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1541000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1541003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1541006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541025 */     // MIs[0] round
     /* 1541025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541028 */     // MIs[0] policy
     /* 1541028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541038 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1541041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541062 */     // GIR_Coverage, 18616,
     /* 1541062 */     GIR_EraseRootFromParent_Done,
     /* 1541063 */   // Label 21393: @1541063
     /* 1541063 */   GIM_Try, /*On fail goto*//*Label 21394*/ GIMT_Encode4(1541145), // Rule ID 18617 //
     /* 1541068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1541071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1541079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1541082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1541085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1541088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541107 */     // MIs[0] round
     /* 1541107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541110 */     // MIs[0] policy
     /* 1541110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541120 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1541123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541144 */     // GIR_Coverage, 18617,
     /* 1541144 */     GIR_EraseRootFromParent_Done,
     /* 1541145 */   // Label 21394: @1541145
     /* 1541145 */   GIM_Try, /*On fail goto*//*Label 21395*/ GIMT_Encode4(1541227), // Rule ID 18620 //
     /* 1541150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1541153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1541167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1541170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541189 */     // MIs[0] round
     /* 1541189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541192 */     // MIs[0] policy
     /* 1541192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541202 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1541205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541226 */     // GIR_Coverage, 18620,
     /* 1541226 */     GIR_EraseRootFromParent_Done,
     /* 1541227 */   // Label 21395: @1541227
     /* 1541227 */   GIM_Try, /*On fail goto*//*Label 21396*/ GIMT_Encode4(1541309), // Rule ID 18621 //
     /* 1541232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1541235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1541249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1541252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541271 */     // MIs[0] round
     /* 1541271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541274 */     // MIs[0] policy
     /* 1541274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541284 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1541287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541308 */     // GIR_Coverage, 18621,
     /* 1541308 */     GIR_EraseRootFromParent_Done,
     /* 1541309 */   // Label 21396: @1541309
     /* 1541309 */   GIM_Try, /*On fail goto*//*Label 21397*/ GIMT_Encode4(1541391), // Rule ID 18624 //
     /* 1541314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1541317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1541325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1541328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1541331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1541334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541353 */     // MIs[0] round
     /* 1541353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541356 */     // MIs[0] policy
     /* 1541356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541366 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1541369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541390 */     // GIR_Coverage, 18624,
     /* 1541390 */     GIR_EraseRootFromParent_Done,
     /* 1541391 */   // Label 21397: @1541391
     /* 1541391 */   GIM_Try, /*On fail goto*//*Label 21398*/ GIMT_Encode4(1541473), // Rule ID 18625 //
     /* 1541396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1541399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1541407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1541410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1541413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1541416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541435 */     // MIs[0] round
     /* 1541435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541438 */     // MIs[0] policy
     /* 1541438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541448 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1541451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541472 */     // GIR_Coverage, 18625,
     /* 1541472 */     GIR_EraseRootFromParent_Done,
     /* 1541473 */   // Label 21398: @1541473
     /* 1541473 */   GIM_Try, /*On fail goto*//*Label 21399*/ GIMT_Encode4(1541555), // Rule ID 18628 //
     /* 1541478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1541481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1541489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1541492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1541495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1541498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541517 */     // MIs[0] round
     /* 1541517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541520 */     // MIs[0] policy
     /* 1541520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541530 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1541533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541554 */     // GIR_Coverage, 18628,
     /* 1541554 */     GIR_EraseRootFromParent_Done,
     /* 1541555 */   // Label 21399: @1541555
     /* 1541555 */   GIM_Try, /*On fail goto*//*Label 21400*/ GIMT_Encode4(1541637), // Rule ID 18629 //
     /* 1541560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1541563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1541571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1541574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1541577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1541580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541599 */     // MIs[0] round
     /* 1541599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541602 */     // MIs[0] policy
     /* 1541602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541612 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1541615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541636 */     // GIR_Coverage, 18629,
     /* 1541636 */     GIR_EraseRootFromParent_Done,
     /* 1541637 */   // Label 21400: @1541637
     /* 1541637 */   GIM_Try, /*On fail goto*//*Label 21401*/ GIMT_Encode4(1541719), // Rule ID 18632 //
     /* 1541642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1541645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1541653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1541656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1541659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1541662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541681 */     // MIs[0] round
     /* 1541681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541684 */     // MIs[0] policy
     /* 1541684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541694 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1541697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1541715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541718 */     // GIR_Coverage, 18632,
     /* 1541718 */     GIR_EraseRootFromParent_Done,
     /* 1541719 */   // Label 21401: @1541719
     /* 1541719 */   GIM_Try, /*On fail goto*//*Label 21402*/ GIMT_Encode4(1541801), // Rule ID 18633 //
     /* 1541724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1541727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1541735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1541738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1541741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1541744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541763 */     // MIs[0] round
     /* 1541763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541766 */     // MIs[0] policy
     /* 1541766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541776 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1541779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1541797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541800 */     // GIR_Coverage, 18633,
     /* 1541800 */     GIR_EraseRootFromParent_Done,
     /* 1541801 */   // Label 21402: @1541801
     /* 1541801 */   GIM_Try, /*On fail goto*//*Label 21403*/ GIMT_Encode4(1541883), // Rule ID 18636 //
     /* 1541806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1541809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1541817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1541820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1541823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1541826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541845 */     // MIs[0] round
     /* 1541845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541848 */     // MIs[0] policy
     /* 1541848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541858 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1541861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1541879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541882 */     // GIR_Coverage, 18636,
     /* 1541882 */     GIR_EraseRootFromParent_Done,
     /* 1541883 */   // Label 21403: @1541883
     /* 1541883 */   GIM_Try, /*On fail goto*//*Label 21404*/ GIMT_Encode4(1541965), // Rule ID 18637 //
     /* 1541888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1541891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1541899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1541902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1541905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1541908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541927 */     // MIs[0] round
     /* 1541927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541930 */     // MIs[0] policy
     /* 1541930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541940 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1541943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1541961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541964 */     // GIR_Coverage, 18637,
     /* 1541964 */     GIR_EraseRootFromParent_Done,
     /* 1541965 */   // Label 21404: @1541965
     /* 1541965 */   GIM_Try, /*On fail goto*//*Label 21405*/ GIMT_Encode4(1542047), // Rule ID 18640 //
     /* 1541970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1541973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1541981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1541984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1541987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1541990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542009 */     // MIs[0] round
     /* 1542009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542012 */     // MIs[0] policy
     /* 1542012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542022 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1542025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1542043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542046 */     // GIR_Coverage, 18640,
     /* 1542046 */     GIR_EraseRootFromParent_Done,
     /* 1542047 */   // Label 21405: @1542047
     /* 1542047 */   GIM_Try, /*On fail goto*//*Label 21406*/ GIMT_Encode4(1542129), // Rule ID 18641 //
     /* 1542052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1542055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1542060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1542069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1542072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542091 */     // MIs[0] round
     /* 1542091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542094 */     // MIs[0] policy
     /* 1542094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542104 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1542107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1542125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542128 */     // GIR_Coverage, 18641,
     /* 1542128 */     GIR_EraseRootFromParent_Done,
     /* 1542129 */   // Label 21406: @1542129
     /* 1542129 */   GIM_Try, /*On fail goto*//*Label 21407*/ GIMT_Encode4(1542211), // Rule ID 18644 //
     /* 1542134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1542137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1542142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1542145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1542148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1542154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542173 */     // MIs[0] round
     /* 1542173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542176 */     // MIs[0] policy
     /* 1542176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542186 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1542189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542210 */     // GIR_Coverage, 18644,
     /* 1542210 */     GIR_EraseRootFromParent_Done,
     /* 1542211 */   // Label 21407: @1542211
     /* 1542211 */   GIM_Try, /*On fail goto*//*Label 21408*/ GIMT_Encode4(1542293), // Rule ID 18645 //
     /* 1542216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1542219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1542224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1542227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1542230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1542236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542255 */     // MIs[0] round
     /* 1542255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542258 */     // MIs[0] policy
     /* 1542258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542268 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1542271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542292 */     // GIR_Coverage, 18645,
     /* 1542292 */     GIR_EraseRootFromParent_Done,
     /* 1542293 */   // Label 21408: @1542293
     /* 1542293 */   GIM_Try, /*On fail goto*//*Label 21409*/ GIMT_Encode4(1542375), // Rule ID 18648 //
     /* 1542298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1542301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1542306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1542309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1542312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1542318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542337 */     // MIs[0] round
     /* 1542337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542340 */     // MIs[0] policy
     /* 1542340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542350 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1542353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542374 */     // GIR_Coverage, 18648,
     /* 1542374 */     GIR_EraseRootFromParent_Done,
     /* 1542375 */   // Label 21409: @1542375
     /* 1542375 */   GIM_Try, /*On fail goto*//*Label 21410*/ GIMT_Encode4(1542457), // Rule ID 18649 //
     /* 1542380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1542383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1542388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1542391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1542394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1542400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542419 */     // MIs[0] round
     /* 1542419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542422 */     // MIs[0] policy
     /* 1542422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542432 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1542435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542456 */     // GIR_Coverage, 18649,
     /* 1542456 */     GIR_EraseRootFromParent_Done,
     /* 1542457 */   // Label 21410: @1542457
     /* 1542457 */   GIM_Try, /*On fail goto*//*Label 21411*/ GIMT_Encode4(1542539), // Rule ID 18652 //
     /* 1542462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1542465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1542470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1542473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1542476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1542479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1542482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1542497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542501 */     // MIs[0] round
     /* 1542501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542504 */     // MIs[0] policy
     /* 1542504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542514 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1542517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542538 */     // GIR_Coverage, 18652,
     /* 1542538 */     GIR_EraseRootFromParent_Done,
     /* 1542539 */   // Label 21411: @1542539
     /* 1542539 */   GIM_Try, /*On fail goto*//*Label 21412*/ GIMT_Encode4(1542621), // Rule ID 18653 //
     /* 1542544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1542547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1542552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1542555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1542558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1542561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1542564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1542579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542583 */     // MIs[0] round
     /* 1542583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542586 */     // MIs[0] policy
     /* 1542586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542596 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1542599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542620 */     // GIR_Coverage, 18653,
     /* 1542620 */     GIR_EraseRootFromParent_Done,
     /* 1542621 */   // Label 21412: @1542621
     /* 1542621 */   GIM_Try, /*On fail goto*//*Label 21413*/ GIMT_Encode4(1542703), // Rule ID 18656 //
     /* 1542626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1542629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1542634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1542637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1542640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1542646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542665 */     // MIs[0] round
     /* 1542665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542668 */     // MIs[0] policy
     /* 1542668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542678 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1542681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542702 */     // GIR_Coverage, 18656,
     /* 1542702 */     GIR_EraseRootFromParent_Done,
     /* 1542703 */   // Label 21413: @1542703
     /* 1542703 */   GIM_Try, /*On fail goto*//*Label 21414*/ GIMT_Encode4(1542785), // Rule ID 18657 //
     /* 1542708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1542711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1542716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1542719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1542722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1542728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542747 */     // MIs[0] round
     /* 1542747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542750 */     // MIs[0] policy
     /* 1542750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542760 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1542763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542784 */     // GIR_Coverage, 18657,
     /* 1542784 */     GIR_EraseRootFromParent_Done,
     /* 1542785 */   // Label 21414: @1542785
     /* 1542785 */   GIM_Try, /*On fail goto*//*Label 21415*/ GIMT_Encode4(1542867), // Rule ID 18660 //
     /* 1542790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1542793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1542798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1542801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1542804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1542807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1542810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1542825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542829 */     // MIs[0] round
     /* 1542829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542832 */     // MIs[0] policy
     /* 1542832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542842 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1542845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542866 */     // GIR_Coverage, 18660,
     /* 1542866 */     GIR_EraseRootFromParent_Done,
     /* 1542867 */   // Label 21415: @1542867
     /* 1542867 */   GIM_Try, /*On fail goto*//*Label 21416*/ GIMT_Encode4(1542949), // Rule ID 18661 //
     /* 1542872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1542875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1542880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1542883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1542886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1542889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1542892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1542907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542911 */     // MIs[0] round
     /* 1542911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542914 */     // MIs[0] policy
     /* 1542914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542924 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1542927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542948 */     // GIR_Coverage, 18661,
     /* 1542948 */     GIR_EraseRootFromParent_Done,
     /* 1542949 */   // Label 21416: @1542949
     /* 1542949 */   GIM_Try, /*On fail goto*//*Label 21417*/ GIMT_Encode4(1543031), // Rule ID 18664 //
     /* 1542954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1542957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1542962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1542965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1542968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1542971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1542974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1542989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542993 */     // MIs[0] round
     /* 1542993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542996 */     // MIs[0] policy
     /* 1542996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543006 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1543009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1543027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543030 */     // GIR_Coverage, 18664,
     /* 1543030 */     GIR_EraseRootFromParent_Done,
     /* 1543031 */   // Label 21417: @1543031
     /* 1543031 */   GIM_Try, /*On fail goto*//*Label 21418*/ GIMT_Encode4(1543113), // Rule ID 18665 //
     /* 1543036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1543039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1543044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1543047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1543050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1543053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1543056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1543071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543075 */     // MIs[0] round
     /* 1543075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543078 */     // MIs[0] policy
     /* 1543078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543088 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1543091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543099 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1543109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543112 */     // GIR_Coverage, 18665,
     /* 1543112 */     GIR_EraseRootFromParent_Done,
     /* 1543113 */   // Label 21418: @1543113
     /* 1543113 */   GIM_Try, /*On fail goto*//*Label 21419*/ GIMT_Encode4(1543195), // Rule ID 18668 //
     /* 1543118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1543121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1543126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1543129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1543132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1543138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543157 */     // MIs[0] round
     /* 1543157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543160 */     // MIs[0] policy
     /* 1543160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543170 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1543173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543194 */     // GIR_Coverage, 18668,
     /* 1543194 */     GIR_EraseRootFromParent_Done,
     /* 1543195 */   // Label 21419: @1543195
     /* 1543195 */   GIM_Try, /*On fail goto*//*Label 21420*/ GIMT_Encode4(1543277), // Rule ID 18669 //
     /* 1543200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1543203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1543208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1543211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1543214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1543220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543239 */     // MIs[0] round
     /* 1543239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543242 */     // MIs[0] policy
     /* 1543242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543252 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1543255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543276 */     // GIR_Coverage, 18669,
     /* 1543276 */     GIR_EraseRootFromParent_Done,
     /* 1543277 */   // Label 21420: @1543277
     /* 1543277 */   GIM_Try, /*On fail goto*//*Label 21421*/ GIMT_Encode4(1543359), // Rule ID 18672 //
     /* 1543282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1543285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1543290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1543293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1543296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1543302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543321 */     // MIs[0] round
     /* 1543321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543324 */     // MIs[0] policy
     /* 1543324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543334 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1543337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543358 */     // GIR_Coverage, 18672,
     /* 1543358 */     GIR_EraseRootFromParent_Done,
     /* 1543359 */   // Label 21421: @1543359
     /* 1543359 */   GIM_Try, /*On fail goto*//*Label 21422*/ GIMT_Encode4(1543441), // Rule ID 18673 //
     /* 1543364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1543367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1543372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1543375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1543378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1543384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543403 */     // MIs[0] round
     /* 1543403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543406 */     // MIs[0] policy
     /* 1543406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543416 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1543419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543440 */     // GIR_Coverage, 18673,
     /* 1543440 */     GIR_EraseRootFromParent_Done,
     /* 1543441 */   // Label 21422: @1543441
     /* 1543441 */   GIM_Try, /*On fail goto*//*Label 21423*/ GIMT_Encode4(1543523), // Rule ID 18676 //
     /* 1543446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1543449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1543454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1543457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1543460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1543466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543485 */     // MIs[0] round
     /* 1543485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543488 */     // MIs[0] policy
     /* 1543488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543498 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1543501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543522 */     // GIR_Coverage, 18676,
     /* 1543522 */     GIR_EraseRootFromParent_Done,
     /* 1543523 */   // Label 21423: @1543523
     /* 1543523 */   GIM_Try, /*On fail goto*//*Label 21424*/ GIMT_Encode4(1543605), // Rule ID 18677 //
     /* 1543528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1543531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1543536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1543539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1543542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1543548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543567 */     // MIs[0] round
     /* 1543567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543570 */     // MIs[0] policy
     /* 1543570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543580 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1543583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543604 */     // GIR_Coverage, 18677,
     /* 1543604 */     GIR_EraseRootFromParent_Done,
     /* 1543605 */   // Label 21424: @1543605
     /* 1543605 */   GIM_Try, /*On fail goto*//*Label 21425*/ GIMT_Encode4(1543687), // Rule ID 18680 //
     /* 1543610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1543613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1543618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1543621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1543624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1543630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543649 */     // MIs[0] round
     /* 1543649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543652 */     // MIs[0] policy
     /* 1543652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543662 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1543665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543686 */     // GIR_Coverage, 18680,
     /* 1543686 */     GIR_EraseRootFromParent_Done,
     /* 1543687 */   // Label 21425: @1543687
     /* 1543687 */   GIM_Try, /*On fail goto*//*Label 21426*/ GIMT_Encode4(1543769), // Rule ID 18681 //
     /* 1543692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1543695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1543700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1543703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1543706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1543712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543731 */     // MIs[0] round
     /* 1543731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543734 */     // MIs[0] policy
     /* 1543734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543744 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1543747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543768 */     // GIR_Coverage, 18681,
     /* 1543768 */     GIR_EraseRootFromParent_Done,
     /* 1543769 */   // Label 21426: @1543769
     /* 1543769 */   GIM_Try, /*On fail goto*//*Label 21427*/ GIMT_Encode4(1543851), // Rule ID 18684 //
     /* 1543774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1543777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1543782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1543785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1543788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1543794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543813 */     // MIs[0] round
     /* 1543813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543816 */     // MIs[0] policy
     /* 1543816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543826 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1543829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543850 */     // GIR_Coverage, 18684,
     /* 1543850 */     GIR_EraseRootFromParent_Done,
     /* 1543851 */   // Label 21427: @1543851
     /* 1543851 */   GIM_Try, /*On fail goto*//*Label 21428*/ GIMT_Encode4(1543933), // Rule ID 18685 //
     /* 1543856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1543859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1543864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1543867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1543870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1543876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543895 */     // MIs[0] round
     /* 1543895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543898 */     // MIs[0] policy
     /* 1543898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543908 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1543911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543932 */     // GIR_Coverage, 18685,
     /* 1543932 */     GIR_EraseRootFromParent_Done,
     /* 1543933 */   // Label 21428: @1543933
     /* 1543933 */   GIM_Try, /*On fail goto*//*Label 21429*/ GIMT_Encode4(1544015), // Rule ID 18688 //
     /* 1543938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1543941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1543946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1543949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1543952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1543958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543977 */     // MIs[0] round
     /* 1543977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543980 */     // MIs[0] policy
     /* 1543980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543990 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1543993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544014 */     // GIR_Coverage, 18688,
     /* 1544014 */     GIR_EraseRootFromParent_Done,
     /* 1544015 */   // Label 21429: @1544015
     /* 1544015 */   GIM_Try, /*On fail goto*//*Label 21430*/ GIMT_Encode4(1544097), // Rule ID 18689 //
     /* 1544020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1544023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1544028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1544031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1544034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1544037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1544040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1544055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544059 */     // MIs[0] round
     /* 1544059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544062 */     // MIs[0] policy
     /* 1544062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544072 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1544075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544096 */     // GIR_Coverage, 18689,
     /* 1544096 */     GIR_EraseRootFromParent_Done,
     /* 1544097 */   // Label 21430: @1544097
     /* 1544097 */   GIM_Try, /*On fail goto*//*Label 21431*/ GIMT_Encode4(1544179), // Rule ID 18692 //
     /* 1544102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1544105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1544110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1544113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1544116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1544119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1544122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1544137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544141 */     // MIs[0] round
     /* 1544141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544144 */     // MIs[0] policy
     /* 1544144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544154 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1544157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1544175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544178 */     // GIR_Coverage, 18692,
     /* 1544178 */     GIR_EraseRootFromParent_Done,
     /* 1544179 */   // Label 21431: @1544179
     /* 1544179 */   GIM_Try, /*On fail goto*//*Label 21432*/ GIMT_Encode4(1544261), // Rule ID 18693 //
     /* 1544184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1544187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1544192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1544195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1544198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1544201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1544204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1544219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544223 */     // MIs[0] round
     /* 1544223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544226 */     // MIs[0] policy
     /* 1544226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544236 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1544239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1544257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544260 */     // GIR_Coverage, 18693,
     /* 1544260 */     GIR_EraseRootFromParent_Done,
     /* 1544261 */   // Label 21432: @1544261
     /* 1544261 */   GIM_Try, /*On fail goto*//*Label 21433*/ GIMT_Encode4(1544343), // Rule ID 18696 //
     /* 1544266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1544269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1544274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1544277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1544280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1544283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1544286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1544301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544305 */     // MIs[0] round
     /* 1544305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544308 */     // MIs[0] policy
     /* 1544308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544318 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1544321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1544339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544342 */     // GIR_Coverage, 18696,
     /* 1544342 */     GIR_EraseRootFromParent_Done,
     /* 1544343 */   // Label 21433: @1544343
     /* 1544343 */   GIM_Try, /*On fail goto*//*Label 21434*/ GIMT_Encode4(1544425), // Rule ID 18697 //
     /* 1544348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1544351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1544356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1544359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1544362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1544365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1544368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1544383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544387 */     // MIs[0] round
     /* 1544387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544390 */     // MIs[0] policy
     /* 1544390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544400 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1544403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1544421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544424 */     // GIR_Coverage, 18697,
     /* 1544424 */     GIR_EraseRootFromParent_Done,
     /* 1544425 */   // Label 21434: @1544425
     /* 1544425 */   GIM_Try, /*On fail goto*//*Label 21435*/ GIMT_Encode4(1544507), // Rule ID 18700 //
     /* 1544430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1544433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1544438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1544441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1544444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1544447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1544450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1544465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544469 */     // MIs[0] round
     /* 1544469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544472 */     // MIs[0] policy
     /* 1544472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544482 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1544485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1544503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544506 */     // GIR_Coverage, 18700,
     /* 1544506 */     GIR_EraseRootFromParent_Done,
     /* 1544507 */   // Label 21435: @1544507
     /* 1544507 */   GIM_Try, /*On fail goto*//*Label 21436*/ GIMT_Encode4(1544589), // Rule ID 18701 //
     /* 1544512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1544515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1544520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1544523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1544526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1544529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1544532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1544547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544551 */     // MIs[0] round
     /* 1544551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544554 */     // MIs[0] policy
     /* 1544554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544564 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1544567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1544585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544588 */     // GIR_Coverage, 18701,
     /* 1544588 */     GIR_EraseRootFromParent_Done,
     /* 1544589 */   // Label 21436: @1544589
     /* 1544589 */   GIM_Try, /*On fail goto*//*Label 21437*/ GIMT_Encode4(1544671), // Rule ID 18704 //
     /* 1544594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1544602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1544605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1544608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1544611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1544614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544633 */     // MIs[0] round
     /* 1544633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544636 */     // MIs[0] policy
     /* 1544636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544646 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1544649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544670 */     // GIR_Coverage, 18704,
     /* 1544670 */     GIR_EraseRootFromParent_Done,
     /* 1544671 */   // Label 21437: @1544671
     /* 1544671 */   GIM_Try, /*On fail goto*//*Label 21438*/ GIMT_Encode4(1544753), // Rule ID 18705 //
     /* 1544676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1544684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1544687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1544690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1544693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1544696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544715 */     // MIs[0] round
     /* 1544715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544718 */     // MIs[0] policy
     /* 1544718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544728 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1544731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544739 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544752 */     // GIR_Coverage, 18705,
     /* 1544752 */     GIR_EraseRootFromParent_Done,
     /* 1544753 */   // Label 21438: @1544753
     /* 1544753 */   GIM_Try, /*On fail goto*//*Label 21439*/ GIMT_Encode4(1544835), // Rule ID 18708 //
     /* 1544758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1544766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1544769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1544772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1544775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1544778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544797 */     // MIs[0] round
     /* 1544797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544800 */     // MIs[0] policy
     /* 1544800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544810 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1544813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544834 */     // GIR_Coverage, 18708,
     /* 1544834 */     GIR_EraseRootFromParent_Done,
     /* 1544835 */   // Label 21439: @1544835
     /* 1544835 */   GIM_Try, /*On fail goto*//*Label 21440*/ GIMT_Encode4(1544917), // Rule ID 18709 //
     /* 1544840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1544848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1544851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1544854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1544857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1544860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544879 */     // MIs[0] round
     /* 1544879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544882 */     // MIs[0] policy
     /* 1544882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544892 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1544895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544916 */     // GIR_Coverage, 18709,
     /* 1544916 */     GIR_EraseRootFromParent_Done,
     /* 1544917 */   // Label 21440: @1544917
     /* 1544917 */   GIM_Try, /*On fail goto*//*Label 21441*/ GIMT_Encode4(1544999), // Rule ID 18712 //
     /* 1544922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1544930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1544933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1544936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1544939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1544942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544961 */     // MIs[0] round
     /* 1544961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544964 */     // MIs[0] policy
     /* 1544964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544974 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1544977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544998 */     // GIR_Coverage, 18712,
     /* 1544998 */     GIR_EraseRootFromParent_Done,
     /* 1544999 */   // Label 21441: @1544999
     /* 1544999 */   GIM_Try, /*On fail goto*//*Label 21442*/ GIMT_Encode4(1545081), // Rule ID 18713 //
     /* 1545004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1545012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1545015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1545018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1545021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1545024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545043 */     // MIs[0] round
     /* 1545043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545046 */     // MIs[0] policy
     /* 1545046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545056 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1545059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545080 */     // GIR_Coverage, 18713,
     /* 1545080 */     GIR_EraseRootFromParent_Done,
     /* 1545081 */   // Label 21442: @1545081
     /* 1545081 */   GIM_Try, /*On fail goto*//*Label 21443*/ GIMT_Encode4(1545163), // Rule ID 18716 //
     /* 1545086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1545094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1545097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1545100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1545103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1545106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545125 */     // MIs[0] round
     /* 1545125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545128 */     // MIs[0] policy
     /* 1545128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545138 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1545141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545162 */     // GIR_Coverage, 18716,
     /* 1545162 */     GIR_EraseRootFromParent_Done,
     /* 1545163 */   // Label 21443: @1545163
     /* 1545163 */   GIM_Try, /*On fail goto*//*Label 21444*/ GIMT_Encode4(1545245), // Rule ID 18717 //
     /* 1545168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1545176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1545179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1545182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1545185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1545188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545207 */     // MIs[0] round
     /* 1545207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545210 */     // MIs[0] policy
     /* 1545210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545220 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1545223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545244 */     // GIR_Coverage, 18717,
     /* 1545244 */     GIR_EraseRootFromParent_Done,
     /* 1545245 */   // Label 21444: @1545245
     /* 1545245 */   GIM_Try, /*On fail goto*//*Label 21445*/ GIMT_Encode4(1545327), // Rule ID 18720 //
     /* 1545250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1545258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1545261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1545264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1545267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1545270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545289 */     // MIs[0] round
     /* 1545289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545292 */     // MIs[0] policy
     /* 1545292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545302 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1545305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545326 */     // GIR_Coverage, 18720,
     /* 1545326 */     GIR_EraseRootFromParent_Done,
     /* 1545327 */   // Label 21445: @1545327
     /* 1545327 */   GIM_Try, /*On fail goto*//*Label 21446*/ GIMT_Encode4(1545409), // Rule ID 18721 //
     /* 1545332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1545340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1545343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1545346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1545349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1545352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545371 */     // MIs[0] round
     /* 1545371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545374 */     // MIs[0] policy
     /* 1545374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545384 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1545387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545408 */     // GIR_Coverage, 18721,
     /* 1545408 */     GIR_EraseRootFromParent_Done,
     /* 1545409 */   // Label 21446: @1545409
     /* 1545409 */   GIM_Try, /*On fail goto*//*Label 21447*/ GIMT_Encode4(1545491), // Rule ID 18724 //
     /* 1545414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1545422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1545425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1545428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1545431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1545434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545453 */     // MIs[0] round
     /* 1545453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545456 */     // MIs[0] policy
     /* 1545456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545466 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1545469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545490 */     // GIR_Coverage, 18724,
     /* 1545490 */     GIR_EraseRootFromParent_Done,
     /* 1545491 */   // Label 21447: @1545491
     /* 1545491 */   GIM_Try, /*On fail goto*//*Label 21448*/ GIMT_Encode4(1545573), // Rule ID 18725 //
     /* 1545496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1545504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1545507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1545510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1545513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1545516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545535 */     // MIs[0] round
     /* 1545535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545538 */     // MIs[0] policy
     /* 1545538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545548 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1545551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545572 */     // GIR_Coverage, 18725,
     /* 1545572 */     GIR_EraseRootFromParent_Done,
     /* 1545573 */   // Label 21448: @1545573
     /* 1545573 */   GIM_Try, /*On fail goto*//*Label 21449*/ GIMT_Encode4(1545655), // Rule ID 18728 //
     /* 1545578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1545586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1545589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1545592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1545595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1545598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545617 */     // MIs[0] round
     /* 1545617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545620 */     // MIs[0] policy
     /* 1545620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545630 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1545633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545654 */     // GIR_Coverage, 18728,
     /* 1545654 */     GIR_EraseRootFromParent_Done,
     /* 1545655 */   // Label 21449: @1545655
     /* 1545655 */   GIM_Try, /*On fail goto*//*Label 21450*/ GIMT_Encode4(1545737), // Rule ID 18729 //
     /* 1545660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1545668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1545671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1545674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1545677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1545680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545699 */     // MIs[0] round
     /* 1545699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545702 */     // MIs[0] policy
     /* 1545702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545712 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1545715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545736 */     // GIR_Coverage, 18729,
     /* 1545736 */     GIR_EraseRootFromParent_Done,
     /* 1545737 */   // Label 21450: @1545737
     /* 1545737 */   GIM_Try, /*On fail goto*//*Label 21451*/ GIMT_Encode4(1545819), // Rule ID 18732 //
     /* 1545742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1545750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1545753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1545756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1545759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1545762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545781 */     // MIs[0] round
     /* 1545781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545784 */     // MIs[0] policy
     /* 1545784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545794 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1545797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545818 */     // GIR_Coverage, 18732,
     /* 1545818 */     GIR_EraseRootFromParent_Done,
     /* 1545819 */   // Label 21451: @1545819
     /* 1545819 */   GIM_Try, /*On fail goto*//*Label 21452*/ GIMT_Encode4(1545901), // Rule ID 18733 //
     /* 1545824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1545832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1545835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1545838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1545841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1545844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545863 */     // MIs[0] round
     /* 1545863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545866 */     // MIs[0] policy
     /* 1545866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545876 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1545879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545900 */     // GIR_Coverage, 18733,
     /* 1545900 */     GIR_EraseRootFromParent_Done,
     /* 1545901 */   // Label 21452: @1545901
     /* 1545901 */   GIM_Try, /*On fail goto*//*Label 21453*/ GIMT_Encode4(1545983), // Rule ID 18736 //
     /* 1545906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1545914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1545923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545945 */     // MIs[0] round
     /* 1545945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545948 */     // MIs[0] policy
     /* 1545948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545958 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1545961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545982 */     // GIR_Coverage, 18736,
     /* 1545982 */     GIR_EraseRootFromParent_Done,
     /* 1545983 */   // Label 21453: @1545983
     /* 1545983 */   GIM_Try, /*On fail goto*//*Label 21454*/ GIMT_Encode4(1546065), // Rule ID 18737 //
     /* 1545988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1545996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1546002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1546005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1546008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546027 */     // MIs[0] round
     /* 1546027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546030 */     // MIs[0] policy
     /* 1546030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546040 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1546043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546064 */     // GIR_Coverage, 18737,
     /* 1546064 */     GIR_EraseRootFromParent_Done,
     /* 1546065 */   // Label 21454: @1546065
     /* 1546065 */   GIM_Try, /*On fail goto*//*Label 21455*/ GIMT_Encode4(1546147), // Rule ID 18740 //
     /* 1546070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1546078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1546081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1546084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1546090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546109 */     // MIs[0] round
     /* 1546109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546112 */     // MIs[0] policy
     /* 1546112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546122 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1546125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546146 */     // GIR_Coverage, 18740,
     /* 1546146 */     GIR_EraseRootFromParent_Done,
     /* 1546147 */   // Label 21455: @1546147
     /* 1546147 */   GIM_Try, /*On fail goto*//*Label 21456*/ GIMT_Encode4(1546229), // Rule ID 18741 //
     /* 1546152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1546160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1546163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1546166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1546172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546191 */     // MIs[0] round
     /* 1546191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546194 */     // MIs[0] policy
     /* 1546194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546204 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1546207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546228 */     // GIR_Coverage, 18741,
     /* 1546228 */     GIR_EraseRootFromParent_Done,
     /* 1546229 */   // Label 21456: @1546229
     /* 1546229 */   GIM_Try, /*On fail goto*//*Label 21457*/ GIMT_Encode4(1546311), // Rule ID 18744 //
     /* 1546234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1546242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1546245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1546248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1546254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546273 */     // MIs[0] round
     /* 1546273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546276 */     // MIs[0] policy
     /* 1546276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546286 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1546289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546310 */     // GIR_Coverage, 18744,
     /* 1546310 */     GIR_EraseRootFromParent_Done,
     /* 1546311 */   // Label 21457: @1546311
     /* 1546311 */   GIM_Try, /*On fail goto*//*Label 21458*/ GIMT_Encode4(1546393), // Rule ID 18745 //
     /* 1546316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1546324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1546327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1546330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1546336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546355 */     // MIs[0] round
     /* 1546355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546358 */     // MIs[0] policy
     /* 1546358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546368 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1546371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546392 */     // GIR_Coverage, 18745,
     /* 1546392 */     GIR_EraseRootFromParent_Done,
     /* 1546393 */   // Label 21458: @1546393
     /* 1546393 */   GIM_Try, /*On fail goto*//*Label 21459*/ GIMT_Encode4(1546475), // Rule ID 18748 //
     /* 1546398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1546406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1546409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1546412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1546418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546437 */     // MIs[0] round
     /* 1546437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546440 */     // MIs[0] policy
     /* 1546440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546450 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1546453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546474 */     // GIR_Coverage, 18748,
     /* 1546474 */     GIR_EraseRootFromParent_Done,
     /* 1546475 */   // Label 21459: @1546475
     /* 1546475 */   GIM_Try, /*On fail goto*//*Label 21460*/ GIMT_Encode4(1546557), // Rule ID 18749 //
     /* 1546480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1546488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1546491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1546494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1546500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546519 */     // MIs[0] round
     /* 1546519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546522 */     // MIs[0] policy
     /* 1546522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546532 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1546535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546556 */     // GIR_Coverage, 18749,
     /* 1546556 */     GIR_EraseRootFromParent_Done,
     /* 1546557 */   // Label 21460: @1546557
     /* 1546557 */   GIM_Try, /*On fail goto*//*Label 21461*/ GIMT_Encode4(1546639), // Rule ID 18752 //
     /* 1546562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1546570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1546573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1546576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1546582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546601 */     // MIs[0] round
     /* 1546601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546604 */     // MIs[0] policy
     /* 1546604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546614 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1546617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546638 */     // GIR_Coverage, 18752,
     /* 1546638 */     GIR_EraseRootFromParent_Done,
     /* 1546639 */   // Label 21461: @1546639
     /* 1546639 */   GIM_Try, /*On fail goto*//*Label 21462*/ GIMT_Encode4(1546721), // Rule ID 18753 //
     /* 1546644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1546652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1546655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1546658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1546664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546683 */     // MIs[0] round
     /* 1546683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546686 */     // MIs[0] policy
     /* 1546686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546696 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1546699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546720 */     // GIR_Coverage, 18753,
     /* 1546720 */     GIR_EraseRootFromParent_Done,
     /* 1546721 */   // Label 21462: @1546721
     /* 1546721 */   GIM_Try, /*On fail goto*//*Label 21463*/ GIMT_Encode4(1546803), // Rule ID 18756 //
     /* 1546726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1546734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1546737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1546740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1546746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546765 */     // MIs[0] round
     /* 1546765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546768 */     // MIs[0] policy
     /* 1546768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546778 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1546781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546802 */     // GIR_Coverage, 18756,
     /* 1546802 */     GIR_EraseRootFromParent_Done,
     /* 1546803 */   // Label 21463: @1546803
     /* 1546803 */   GIM_Try, /*On fail goto*//*Label 21464*/ GIMT_Encode4(1546885), // Rule ID 18757 //
     /* 1546808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1546816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1546819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1546822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1546828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546847 */     // MIs[0] round
     /* 1546847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546850 */     // MIs[0] policy
     /* 1546850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546860 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1546863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546884 */     // GIR_Coverage, 18757,
     /* 1546884 */     GIR_EraseRootFromParent_Done,
     /* 1546885 */   // Label 21464: @1546885
     /* 1546885 */   GIM_Try, /*On fail goto*//*Label 21465*/ GIMT_Encode4(1546967), // Rule ID 18760 //
     /* 1546890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1546898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1546910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546929 */     // MIs[0] round
     /* 1546929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546932 */     // MIs[0] policy
     /* 1546932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546942 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1546945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546966 */     // GIR_Coverage, 18760,
     /* 1546966 */     GIR_EraseRootFromParent_Done,
     /* 1546967 */   // Label 21465: @1546967
     /* 1546967 */   GIM_Try, /*On fail goto*//*Label 21466*/ GIMT_Encode4(1547049), // Rule ID 18761 //
     /* 1546972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1546980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1546992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1547007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547011 */     // MIs[0] round
     /* 1547011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547014 */     // MIs[0] policy
     /* 1547014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547024 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1547027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547048 */     // GIR_Coverage, 18761,
     /* 1547048 */     GIR_EraseRootFromParent_Done,
     /* 1547049 */   // Label 21466: @1547049
     /* 1547049 */   GIM_Try, /*On fail goto*//*Label 21467*/ GIMT_Encode4(1547131), // Rule ID 18764 //
     /* 1547054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1547062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1547065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1547068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1547071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1547074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1547089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547093 */     // MIs[0] round
     /* 1547093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547096 */     // MIs[0] policy
     /* 1547096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547106 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1547109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547130 */     // GIR_Coverage, 18764,
     /* 1547130 */     GIR_EraseRootFromParent_Done,
     /* 1547131 */   // Label 21467: @1547131
     /* 1547131 */   GIM_Try, /*On fail goto*//*Label 21468*/ GIMT_Encode4(1547213), // Rule ID 18765 //
     /* 1547136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1547139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1547144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1547147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1547150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1547153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1547156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1547171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547175 */     // MIs[0] round
     /* 1547175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547178 */     // MIs[0] policy
     /* 1547178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547188 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1547191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547212 */     // GIR_Coverage, 18765,
     /* 1547212 */     GIR_EraseRootFromParent_Done,
     /* 1547213 */   // Label 21468: @1547213
     /* 1547213 */   GIM_Try, /*On fail goto*//*Label 21469*/ GIMT_Encode4(1547295), // Rule ID 18768 //
     /* 1547218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1547226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1547229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1547232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1547235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1547238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1547253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547257 */     // MIs[0] round
     /* 1547257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547260 */     // MIs[0] policy
     /* 1547260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547270 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1547273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547294 */     // GIR_Coverage, 18768,
     /* 1547294 */     GIR_EraseRootFromParent_Done,
     /* 1547295 */   // Label 21469: @1547295
     /* 1547295 */   GIM_Try, /*On fail goto*//*Label 21470*/ GIMT_Encode4(1547377), // Rule ID 18769 //
     /* 1547300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1547303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1547308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1547311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1547314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1547317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1547320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1547335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547339 */     // MIs[0] round
     /* 1547339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547342 */     // MIs[0] policy
     /* 1547342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547352 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1547355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547376 */     // GIR_Coverage, 18769,
     /* 1547376 */     GIR_EraseRootFromParent_Done,
     /* 1547377 */   // Label 21470: @1547377
     /* 1547377 */   GIM_Try, /*On fail goto*//*Label 21471*/ GIMT_Encode4(1547459), // Rule ID 18772 //
     /* 1547382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1547390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1547393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1547396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1547399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1547402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1547417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547421 */     // MIs[0] round
     /* 1547421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547424 */     // MIs[0] policy
     /* 1547424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547434 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1547437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547458 */     // GIR_Coverage, 18772,
     /* 1547458 */     GIR_EraseRootFromParent_Done,
     /* 1547459 */   // Label 21471: @1547459
     /* 1547459 */   GIM_Try, /*On fail goto*//*Label 21472*/ GIMT_Encode4(1547541), // Rule ID 18773 //
     /* 1547464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1547467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1547472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1547475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1547478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1547481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1547484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1547499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547503 */     // MIs[0] round
     /* 1547503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547506 */     // MIs[0] policy
     /* 1547506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547516 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1547519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547540 */     // GIR_Coverage, 18773,
     /* 1547540 */     GIR_EraseRootFromParent_Done,
     /* 1547541 */   // Label 21472: @1547541
     /* 1547541 */   GIM_Try, /*On fail goto*//*Label 21473*/ GIMT_Encode4(1547623), // Rule ID 18776 //
     /* 1547546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1547554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1547557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1547560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1547563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1547566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547585 */     // MIs[0] round
     /* 1547585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547588 */     // MIs[0] policy
     /* 1547588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547598 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1547601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547622 */     // GIR_Coverage, 18776,
     /* 1547622 */     GIR_EraseRootFromParent_Done,
     /* 1547623 */   // Label 21473: @1547623
     /* 1547623 */   GIM_Try, /*On fail goto*//*Label 21474*/ GIMT_Encode4(1547705), // Rule ID 18777 //
     /* 1547628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1547636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1547639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1547642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1547645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1547648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547667 */     // MIs[0] round
     /* 1547667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547670 */     // MIs[0] policy
     /* 1547670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547680 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1547683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547704 */     // GIR_Coverage, 18777,
     /* 1547704 */     GIR_EraseRootFromParent_Done,
     /* 1547705 */   // Label 21474: @1547705
     /* 1547705 */   GIM_Try, /*On fail goto*//*Label 21475*/ GIMT_Encode4(1547787), // Rule ID 18780 //
     /* 1547710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1547718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1547721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1547724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1547727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1547730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547749 */     // MIs[0] round
     /* 1547749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547752 */     // MIs[0] policy
     /* 1547752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547762 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1547765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547786 */     // GIR_Coverage, 18780,
     /* 1547786 */     GIR_EraseRootFromParent_Done,
     /* 1547787 */   // Label 21475: @1547787
     /* 1547787 */   GIM_Try, /*On fail goto*//*Label 21476*/ GIMT_Encode4(1547869), // Rule ID 18781 //
     /* 1547792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1547800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1547803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1547806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1547809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1547812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547831 */     // MIs[0] round
     /* 1547831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547834 */     // MIs[0] policy
     /* 1547834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547844 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1547847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547868 */     // GIR_Coverage, 18781,
     /* 1547868 */     GIR_EraseRootFromParent_Done,
     /* 1547869 */   // Label 21476: @1547869
     /* 1547869 */   GIM_Try, /*On fail goto*//*Label 21477*/ GIMT_Encode4(1547951), // Rule ID 18784 //
     /* 1547874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1547882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1547885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1547888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1547891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1547894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547913 */     // MIs[0] round
     /* 1547913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547916 */     // MIs[0] policy
     /* 1547916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547926 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1547929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547950 */     // GIR_Coverage, 18784,
     /* 1547950 */     GIR_EraseRootFromParent_Done,
     /* 1547951 */   // Label 21477: @1547951
     /* 1547951 */   GIM_Try, /*On fail goto*//*Label 21478*/ GIMT_Encode4(1548033), // Rule ID 18785 //
     /* 1547956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1547964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1547967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1547970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1547973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1547976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547995 */     // MIs[0] round
     /* 1547995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547998 */     // MIs[0] policy
     /* 1547998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548008 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1548011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548032 */     // GIR_Coverage, 18785,
     /* 1548032 */     GIR_EraseRootFromParent_Done,
     /* 1548033 */   // Label 21478: @1548033
     /* 1548033 */   GIM_Try, /*On fail goto*//*Label 21479*/ GIMT_Encode4(1548115), // Rule ID 18788 //
     /* 1548038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1548046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1548049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1548052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1548055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1548058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548077 */     // MIs[0] round
     /* 1548077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548080 */     // MIs[0] policy
     /* 1548080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548090 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1548093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548114 */     // GIR_Coverage, 18788,
     /* 1548114 */     GIR_EraseRootFromParent_Done,
     /* 1548115 */   // Label 21479: @1548115
     /* 1548115 */   GIM_Try, /*On fail goto*//*Label 21480*/ GIMT_Encode4(1548197), // Rule ID 18789 //
     /* 1548120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1548128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1548131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1548134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1548137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1548140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548159 */     // MIs[0] round
     /* 1548159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548162 */     // MIs[0] policy
     /* 1548162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548172 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1548175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548196 */     // GIR_Coverage, 18789,
     /* 1548196 */     GIR_EraseRootFromParent_Done,
     /* 1548197 */   // Label 21480: @1548197
     /* 1548197 */   GIM_Try, /*On fail goto*//*Label 21481*/ GIMT_Encode4(1548279), // Rule ID 18792 //
     /* 1548202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1548210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1548213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1548216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1548219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1548222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548241 */     // MIs[0] round
     /* 1548241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548244 */     // MIs[0] policy
     /* 1548244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548254 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1548257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548278 */     // GIR_Coverage, 18792,
     /* 1548278 */     GIR_EraseRootFromParent_Done,
     /* 1548279 */   // Label 21481: @1548279
     /* 1548279 */   GIM_Try, /*On fail goto*//*Label 21482*/ GIMT_Encode4(1548361), // Rule ID 18793 //
     /* 1548284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1548292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1548295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1548298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1548301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1548304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548323 */     // MIs[0] round
     /* 1548323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548326 */     // MIs[0] policy
     /* 1548326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548336 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1548339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548360 */     // GIR_Coverage, 18793,
     /* 1548360 */     GIR_EraseRootFromParent_Done,
     /* 1548361 */   // Label 21482: @1548361
     /* 1548361 */   GIM_Try, /*On fail goto*//*Label 21483*/ GIMT_Encode4(1548443), // Rule ID 18796 //
     /* 1548366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1548374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1548377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1548380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1548383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1548386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548405 */     // MIs[0] round
     /* 1548405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548408 */     // MIs[0] policy
     /* 1548408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548418 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1548421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548442 */     // GIR_Coverage, 18796,
     /* 1548442 */     GIR_EraseRootFromParent_Done,
     /* 1548443 */   // Label 21483: @1548443
     /* 1548443 */   GIM_Try, /*On fail goto*//*Label 21484*/ GIMT_Encode4(1548525), // Rule ID 18797 //
     /* 1548448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1548456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1548459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1548462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1548465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1548468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548487 */     // MIs[0] round
     /* 1548487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548490 */     // MIs[0] policy
     /* 1548490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548500 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1548503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548524 */     // GIR_Coverage, 18797,
     /* 1548524 */     GIR_EraseRootFromParent_Done,
     /* 1548525 */   // Label 21484: @1548525
     /* 1548525 */   GIM_Try, /*On fail goto*//*Label 21485*/ GIMT_Encode4(1548607), // Rule ID 18800 //
     /* 1548530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1548538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1548541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1548544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1548547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1548550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548569 */     // MIs[0] round
     /* 1548569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548572 */     // MIs[0] policy
     /* 1548572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548582 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1548585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548606 */     // GIR_Coverage, 18800,
     /* 1548606 */     GIR_EraseRootFromParent_Done,
     /* 1548607 */   // Label 21485: @1548607
     /* 1548607 */   GIM_Try, /*On fail goto*//*Label 21486*/ GIMT_Encode4(1548689), // Rule ID 18801 //
     /* 1548612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1548620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1548623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1548626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1548629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1548632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548651 */     // MIs[0] round
     /* 1548651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548654 */     // MIs[0] policy
     /* 1548654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548664 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1548667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548688 */     // GIR_Coverage, 18801,
     /* 1548688 */     GIR_EraseRootFromParent_Done,
     /* 1548689 */   // Label 21486: @1548689
     /* 1548689 */   GIM_Try, /*On fail goto*//*Label 21487*/ GIMT_Encode4(1548771), // Rule ID 18804 //
     /* 1548694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1548702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1548705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1548708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1548711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1548714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548733 */     // MIs[0] round
     /* 1548733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548736 */     // MIs[0] policy
     /* 1548736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548746 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1548749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548770 */     // GIR_Coverage, 18804,
     /* 1548770 */     GIR_EraseRootFromParent_Done,
     /* 1548771 */   // Label 21487: @1548771
     /* 1548771 */   GIM_Try, /*On fail goto*//*Label 21488*/ GIMT_Encode4(1548853), // Rule ID 18805 //
     /* 1548776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1548784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1548787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1548790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1548793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1548796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548815 */     // MIs[0] round
     /* 1548815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548818 */     // MIs[0] policy
     /* 1548818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548828 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1548831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548852 */     // GIR_Coverage, 18805,
     /* 1548852 */     GIR_EraseRootFromParent_Done,
     /* 1548853 */   // Label 21488: @1548853
     /* 1548853 */   GIM_Try, /*On fail goto*//*Label 21489*/ GIMT_Encode4(1548935), // Rule ID 18808 //
     /* 1548858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1548866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1548869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1548872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1548875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1548878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548897 */     // MIs[0] round
     /* 1548897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548900 */     // MIs[0] policy
     /* 1548900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548910 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1548913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548934 */     // GIR_Coverage, 18808,
     /* 1548934 */     GIR_EraseRootFromParent_Done,
     /* 1548935 */   // Label 21489: @1548935
     /* 1548935 */   GIM_Try, /*On fail goto*//*Label 21490*/ GIMT_Encode4(1549017), // Rule ID 18809 //
     /* 1548940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1548948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1548951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1548954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1548957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1548960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548979 */     // MIs[0] round
     /* 1548979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548982 */     // MIs[0] policy
     /* 1548982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548992 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1548995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549016 */     // GIR_Coverage, 18809,
     /* 1549016 */     GIR_EraseRootFromParent_Done,
     /* 1549017 */   // Label 21490: @1549017
     /* 1549017 */   GIM_Try, /*On fail goto*//*Label 21491*/ GIMT_Encode4(1549099), // Rule ID 18812 //
     /* 1549022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1549030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1549033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1549036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1549042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549061 */     // MIs[0] round
     /* 1549061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549064 */     // MIs[0] policy
     /* 1549064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549074 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1549077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549098 */     // GIR_Coverage, 18812,
     /* 1549098 */     GIR_EraseRootFromParent_Done,
     /* 1549099 */   // Label 21491: @1549099
     /* 1549099 */   GIM_Try, /*On fail goto*//*Label 21492*/ GIMT_Encode4(1549181), // Rule ID 18813 //
     /* 1549104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1549112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1549115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1549118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1549124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549143 */     // MIs[0] round
     /* 1549143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549146 */     // MIs[0] policy
     /* 1549146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549156 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1549159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549180 */     // GIR_Coverage, 18813,
     /* 1549180 */     GIR_EraseRootFromParent_Done,
     /* 1549181 */   // Label 21492: @1549181
     /* 1549181 */   GIM_Try, /*On fail goto*//*Label 21493*/ GIMT_Encode4(1549263), // Rule ID 18816 //
     /* 1549186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1549194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1549197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1549200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1549206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549225 */     // MIs[0] round
     /* 1549225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549228 */     // MIs[0] policy
     /* 1549228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549238 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1549241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549262 */     // GIR_Coverage, 18816,
     /* 1549262 */     GIR_EraseRootFromParent_Done,
     /* 1549263 */   // Label 21493: @1549263
     /* 1549263 */   GIM_Try, /*On fail goto*//*Label 21494*/ GIMT_Encode4(1549345), // Rule ID 18817 //
     /* 1549268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1549276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1549279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1549282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1549288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549307 */     // MIs[0] round
     /* 1549307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549310 */     // MIs[0] policy
     /* 1549310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549320 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1549323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549344 */     // GIR_Coverage, 18817,
     /* 1549344 */     GIR_EraseRootFromParent_Done,
     /* 1549345 */   // Label 21494: @1549345
     /* 1549345 */   GIM_Try, /*On fail goto*//*Label 21495*/ GIMT_Encode4(1549427), // Rule ID 18820 //
     /* 1549350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1549358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1549361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1549364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1549370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549389 */     // MIs[0] round
     /* 1549389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549392 */     // MIs[0] policy
     /* 1549392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549402 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1549405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549426 */     // GIR_Coverage, 18820,
     /* 1549426 */     GIR_EraseRootFromParent_Done,
     /* 1549427 */   // Label 21495: @1549427
     /* 1549427 */   GIM_Try, /*On fail goto*//*Label 21496*/ GIMT_Encode4(1549509), // Rule ID 18821 //
     /* 1549432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1549440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1549443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1549446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1549452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549471 */     // MIs[0] round
     /* 1549471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549474 */     // MIs[0] policy
     /* 1549474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549484 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1549487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549508 */     // GIR_Coverage, 18821,
     /* 1549508 */     GIR_EraseRootFromParent_Done,
     /* 1549509 */   // Label 21496: @1549509
     /* 1549509 */   GIM_Try, /*On fail goto*//*Label 21497*/ GIMT_Encode4(1549591), // Rule ID 18824 //
     /* 1549514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1549522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1549525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1549528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1549534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549553 */     // MIs[0] round
     /* 1549553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549556 */     // MIs[0] policy
     /* 1549556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549566 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1549569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549590 */     // GIR_Coverage, 18824,
     /* 1549590 */     GIR_EraseRootFromParent_Done,
     /* 1549591 */   // Label 21497: @1549591
     /* 1549591 */   GIM_Try, /*On fail goto*//*Label 21498*/ GIMT_Encode4(1549673), // Rule ID 18825 //
     /* 1549596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1549604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1549607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1549610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1549616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549635 */     // MIs[0] round
     /* 1549635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549638 */     // MIs[0] policy
     /* 1549638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549648 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1549651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549672 */     // GIR_Coverage, 18825,
     /* 1549672 */     GIR_EraseRootFromParent_Done,
     /* 1549673 */   // Label 21498: @1549673
     /* 1549673 */   GIM_Try, /*On fail goto*//*Label 21499*/ GIMT_Encode4(1549755), // Rule ID 18828 //
     /* 1549678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1549686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1549689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1549692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1549698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549717 */     // MIs[0] round
     /* 1549717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549720 */     // MIs[0] policy
     /* 1549720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549730 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1549733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549754 */     // GIR_Coverage, 18828,
     /* 1549754 */     GIR_EraseRootFromParent_Done,
     /* 1549755 */   // Label 21499: @1549755
     /* 1549755 */   GIM_Try, /*On fail goto*//*Label 21500*/ GIMT_Encode4(1549837), // Rule ID 18829 //
     /* 1549760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1549768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1549771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1549774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1549780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549799 */     // MIs[0] round
     /* 1549799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549802 */     // MIs[0] policy
     /* 1549802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549812 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1549815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549836 */     // GIR_Coverage, 18829,
     /* 1549836 */     GIR_EraseRootFromParent_Done,
     /* 1549837 */   // Label 21500: @1549837
     /* 1549837 */   GIM_Try, /*On fail goto*//*Label 21501*/ GIMT_Encode4(1549919), // Rule ID 18832 //
     /* 1549842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1549850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1549862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549881 */     // MIs[0] round
     /* 1549881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549884 */     // MIs[0] policy
     /* 1549884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549894 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1549897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549918 */     // GIR_Coverage, 18832,
     /* 1549918 */     GIR_EraseRootFromParent_Done,
     /* 1549919 */   // Label 21501: @1549919
     /* 1549919 */   GIM_Try, /*On fail goto*//*Label 21502*/ GIMT_Encode4(1550001), // Rule ID 18833 //
     /* 1549924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1549932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1549944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549963 */     // MIs[0] round
     /* 1549963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549966 */     // MIs[0] policy
     /* 1549966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549976 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1549979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550000 */     // GIR_Coverage, 18833,
     /* 1550000 */     GIR_EraseRootFromParent_Done,
     /* 1550001 */   // Label 21502: @1550001
     /* 1550001 */   GIM_Try, /*On fail goto*//*Label 21503*/ GIMT_Encode4(1550083), // Rule ID 18836 //
     /* 1550006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1550014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1550017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1550020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1550023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1550026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1550041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550045 */     // MIs[0] round
     /* 1550045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550048 */     // MIs[0] policy
     /* 1550048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550058 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1550061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550082 */     // GIR_Coverage, 18836,
     /* 1550082 */     GIR_EraseRootFromParent_Done,
     /* 1550083 */   // Label 21503: @1550083
     /* 1550083 */   GIM_Try, /*On fail goto*//*Label 21504*/ GIMT_Encode4(1550165), // Rule ID 18837 //
     /* 1550088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1550096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1550099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1550102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1550105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1550108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1550123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550127 */     // MIs[0] round
     /* 1550127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550130 */     // MIs[0] policy
     /* 1550130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550140 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1550143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550164 */     // GIR_Coverage, 18837,
     /* 1550164 */     GIR_EraseRootFromParent_Done,
     /* 1550165 */   // Label 21504: @1550165
     /* 1550165 */   GIM_Try, /*On fail goto*//*Label 21505*/ GIMT_Encode4(1550247), // Rule ID 18840 //
     /* 1550170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1550178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1550181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1550184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1550187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1550190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1550205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550209 */     // MIs[0] round
     /* 1550209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550212 */     // MIs[0] policy
     /* 1550212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550222 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1550225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550246 */     // GIR_Coverage, 18840,
     /* 1550246 */     GIR_EraseRootFromParent_Done,
     /* 1550247 */   // Label 21505: @1550247
     /* 1550247 */   GIM_Try, /*On fail goto*//*Label 21506*/ GIMT_Encode4(1550329), // Rule ID 18841 //
     /* 1550252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1550260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1550263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1550266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1550269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1550272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1550287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550291 */     // MIs[0] round
     /* 1550291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550294 */     // MIs[0] policy
     /* 1550294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550304 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1550307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550328 */     // GIR_Coverage, 18841,
     /* 1550328 */     GIR_EraseRootFromParent_Done,
     /* 1550329 */   // Label 21506: @1550329
     /* 1550329 */   GIM_Try, /*On fail goto*//*Label 21507*/ GIMT_Encode4(1550411), // Rule ID 18844 //
     /* 1550334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1550342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1550345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1550348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1550351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1550354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1550369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550373 */     // MIs[0] round
     /* 1550373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550376 */     // MIs[0] policy
     /* 1550376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550386 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1550389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550410 */     // GIR_Coverage, 18844,
     /* 1550410 */     GIR_EraseRootFromParent_Done,
     /* 1550411 */   // Label 21507: @1550411
     /* 1550411 */   GIM_Try, /*On fail goto*//*Label 21508*/ GIMT_Encode4(1550493), // Rule ID 18845 //
     /* 1550416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1550424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1550427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1550430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1550433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1550436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1550451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550455 */     // MIs[0] round
     /* 1550455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550458 */     // MIs[0] policy
     /* 1550458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550468 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1550471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550492 */     // GIR_Coverage, 18845,
     /* 1550492 */     GIR_EraseRootFromParent_Done,
     /* 1550493 */   // Label 21508: @1550493
     /* 1550493 */   GIM_Try, /*On fail goto*//*Label 21509*/ GIMT_Encode4(1550575), // Rule ID 18848 //
     /* 1550498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1550506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1550509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1550512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1550515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1550518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550537 */     // MIs[0] round
     /* 1550537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550540 */     // MIs[0] policy
     /* 1550540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550550 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1550553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550574 */     // GIR_Coverage, 18848,
     /* 1550574 */     GIR_EraseRootFromParent_Done,
     /* 1550575 */   // Label 21509: @1550575
     /* 1550575 */   GIM_Try, /*On fail goto*//*Label 21510*/ GIMT_Encode4(1550657), // Rule ID 18849 //
     /* 1550580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1550588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1550591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1550594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1550597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1550600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550619 */     // MIs[0] round
     /* 1550619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550622 */     // MIs[0] policy
     /* 1550622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550632 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1550635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550656 */     // GIR_Coverage, 18849,
     /* 1550656 */     GIR_EraseRootFromParent_Done,
     /* 1550657 */   // Label 21510: @1550657
     /* 1550657 */   GIM_Try, /*On fail goto*//*Label 21511*/ GIMT_Encode4(1550739), // Rule ID 18852 //
     /* 1550662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1550670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1550673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1550676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1550679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1550682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550701 */     // MIs[0] round
     /* 1550701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550704 */     // MIs[0] policy
     /* 1550704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550714 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1550717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550738 */     // GIR_Coverage, 18852,
     /* 1550738 */     GIR_EraseRootFromParent_Done,
     /* 1550739 */   // Label 21511: @1550739
     /* 1550739 */   GIM_Try, /*On fail goto*//*Label 21512*/ GIMT_Encode4(1550821), // Rule ID 18853 //
     /* 1550744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1550752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1550755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1550758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1550761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1550764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550783 */     // MIs[0] round
     /* 1550783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550786 */     // MIs[0] policy
     /* 1550786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550796 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1550799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550820 */     // GIR_Coverage, 18853,
     /* 1550820 */     GIR_EraseRootFromParent_Done,
     /* 1550821 */   // Label 21512: @1550821
     /* 1550821 */   GIM_Try, /*On fail goto*//*Label 21513*/ GIMT_Encode4(1550903), // Rule ID 18856 //
     /* 1550826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1550834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1550837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1550840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1550843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1550846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550865 */     // MIs[0] round
     /* 1550865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550868 */     // MIs[0] policy
     /* 1550868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550878 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1550881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550902 */     // GIR_Coverage, 18856,
     /* 1550902 */     GIR_EraseRootFromParent_Done,
     /* 1550903 */   // Label 21513: @1550903
     /* 1550903 */   GIM_Try, /*On fail goto*//*Label 21514*/ GIMT_Encode4(1550985), // Rule ID 18857 //
     /* 1550908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1550916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1550919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1550922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1550925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1550928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550947 */     // MIs[0] round
     /* 1550947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550950 */     // MIs[0] policy
     /* 1550950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550960 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1550963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550984 */     // GIR_Coverage, 18857,
     /* 1550984 */     GIR_EraseRootFromParent_Done,
     /* 1550985 */   // Label 21514: @1550985
     /* 1550985 */   GIM_Try, /*On fail goto*//*Label 21515*/ GIMT_Encode4(1551067), // Rule ID 18860 //
     /* 1550990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1550998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1551001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1551004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1551007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1551010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551029 */     // MIs[0] round
     /* 1551029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551032 */     // MIs[0] policy
     /* 1551032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551042 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1551045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551066 */     // GIR_Coverage, 18860,
     /* 1551066 */     GIR_EraseRootFromParent_Done,
     /* 1551067 */   // Label 21515: @1551067
     /* 1551067 */   GIM_Try, /*On fail goto*//*Label 21516*/ GIMT_Encode4(1551149), // Rule ID 18861 //
     /* 1551072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1551080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1551083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1551086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1551089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1551092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551111 */     // MIs[0] round
     /* 1551111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551114 */     // MIs[0] policy
     /* 1551114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551124 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1551127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551148 */     // GIR_Coverage, 18861,
     /* 1551148 */     GIR_EraseRootFromParent_Done,
     /* 1551149 */   // Label 21516: @1551149
     /* 1551149 */   GIM_Try, /*On fail goto*//*Label 21517*/ GIMT_Encode4(1551231), // Rule ID 18864 //
     /* 1551154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1551162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1551165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1551168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1551171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1551174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551193 */     // MIs[0] round
     /* 1551193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551196 */     // MIs[0] policy
     /* 1551196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551206 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1551209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551230 */     // GIR_Coverage, 18864,
     /* 1551230 */     GIR_EraseRootFromParent_Done,
     /* 1551231 */   // Label 21517: @1551231
     /* 1551231 */   GIM_Try, /*On fail goto*//*Label 21518*/ GIMT_Encode4(1551313), // Rule ID 18865 //
     /* 1551236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1551244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1551247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1551250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1551253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1551256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551275 */     // MIs[0] round
     /* 1551275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551278 */     // MIs[0] policy
     /* 1551278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551288 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1551291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551312 */     // GIR_Coverage, 18865,
     /* 1551312 */     GIR_EraseRootFromParent_Done,
     /* 1551313 */   // Label 21518: @1551313
     /* 1551313 */   GIM_Try, /*On fail goto*//*Label 21519*/ GIMT_Encode4(1551395), // Rule ID 18868 //
     /* 1551318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1551321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1551326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1551329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1551332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1551335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1551338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551357 */     // MIs[0] round
     /* 1551357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551360 */     // MIs[0] policy
     /* 1551360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551370 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1551373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551394 */     // GIR_Coverage, 18868,
     /* 1551394 */     GIR_EraseRootFromParent_Done,
     /* 1551395 */   // Label 21519: @1551395
     /* 1551395 */   GIM_Try, /*On fail goto*//*Label 21520*/ GIMT_Encode4(1551477), // Rule ID 18869 //
     /* 1551400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1551408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1551411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1551414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1551417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1551420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551439 */     // MIs[0] round
     /* 1551439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551442 */     // MIs[0] policy
     /* 1551442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551452 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1551455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551476 */     // GIR_Coverage, 18869,
     /* 1551476 */     GIR_EraseRootFromParent_Done,
     /* 1551477 */   // Label 21520: @1551477
     /* 1551477 */   GIM_Try, /*On fail goto*//*Label 21521*/ GIMT_Encode4(1551559), // Rule ID 18872 //
     /* 1551482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1551485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1551490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1551493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1551496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1551499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1551502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551521 */     // MIs[0] round
     /* 1551521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551524 */     // MIs[0] policy
     /* 1551524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551534 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1551537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551558 */     // GIR_Coverage, 18872,
     /* 1551558 */     GIR_EraseRootFromParent_Done,
     /* 1551559 */   // Label 21521: @1551559
     /* 1551559 */   GIM_Try, /*On fail goto*//*Label 21522*/ GIMT_Encode4(1551641), // Rule ID 18873 //
     /* 1551564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1551572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1551575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1551578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1551581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1551584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551603 */     // MIs[0] round
     /* 1551603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551606 */     // MIs[0] policy
     /* 1551606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551616 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1551619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551640 */     // GIR_Coverage, 18873,
     /* 1551640 */     GIR_EraseRootFromParent_Done,
     /* 1551641 */   // Label 21522: @1551641
     /* 1551641 */   GIM_Try, /*On fail goto*//*Label 21523*/ GIMT_Encode4(1551723), // Rule ID 18876 //
     /* 1551646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1551649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1551654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1551657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1551660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1551663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1551666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551685 */     // MIs[0] round
     /* 1551685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551688 */     // MIs[0] policy
     /* 1551688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551698 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1551701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551722 */     // GIR_Coverage, 18876,
     /* 1551722 */     GIR_EraseRootFromParent_Done,
     /* 1551723 */   // Label 21523: @1551723
     /* 1551723 */   GIM_Try, /*On fail goto*//*Label 21524*/ GIMT_Encode4(1551805), // Rule ID 18877 //
     /* 1551728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1551736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1551739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1551742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1551745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1551748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551767 */     // MIs[0] round
     /* 1551767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551770 */     // MIs[0] policy
     /* 1551770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551780 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1551783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551804 */     // GIR_Coverage, 18877,
     /* 1551804 */     GIR_EraseRootFromParent_Done,
     /* 1551805 */   // Label 21524: @1551805
     /* 1551805 */   GIM_Try, /*On fail goto*//*Label 21525*/ GIMT_Encode4(1551887), // Rule ID 18880 //
     /* 1551810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1551813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1551818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1551821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1551824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1551827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1551830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551849 */     // MIs[0] round
     /* 1551849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551852 */     // MIs[0] policy
     /* 1551852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551862 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1551865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551886 */     // GIR_Coverage, 18880,
     /* 1551886 */     GIR_EraseRootFromParent_Done,
     /* 1551887 */   // Label 21525: @1551887
     /* 1551887 */   GIM_Try, /*On fail goto*//*Label 21526*/ GIMT_Encode4(1551969), // Rule ID 18881 //
     /* 1551892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1551900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1551903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1551906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1551909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1551912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551931 */     // MIs[0] round
     /* 1551931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551934 */     // MIs[0] policy
     /* 1551934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551944 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1551947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551968 */     // GIR_Coverage, 18881,
     /* 1551968 */     GIR_EraseRootFromParent_Done,
     /* 1551969 */   // Label 21526: @1551969
     /* 1551969 */   GIM_Try, /*On fail goto*//*Label 21527*/ GIMT_Encode4(1552051), // Rule ID 18884 //
     /* 1551974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1551982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1551985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1551988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1551994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552013 */     // MIs[0] round
     /* 1552013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552016 */     // MIs[0] policy
     /* 1552016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552026 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1552029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552050 */     // GIR_Coverage, 18884,
     /* 1552050 */     GIR_EraseRootFromParent_Done,
     /* 1552051 */   // Label 21527: @1552051
     /* 1552051 */   GIM_Try, /*On fail goto*//*Label 21528*/ GIMT_Encode4(1552133), // Rule ID 18885 //
     /* 1552056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1552059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1552064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1552067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1552070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1552076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552095 */     // MIs[0] round
     /* 1552095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552098 */     // MIs[0] policy
     /* 1552098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552108 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1552111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552132 */     // GIR_Coverage, 18885,
     /* 1552132 */     GIR_EraseRootFromParent_Done,
     /* 1552133 */   // Label 21528: @1552133
     /* 1552133 */   GIM_Try, /*On fail goto*//*Label 21529*/ GIMT_Encode4(1552215), // Rule ID 18888 //
     /* 1552138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1552141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1552146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1552149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1552152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1552158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552177 */     // MIs[0] round
     /* 1552177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552180 */     // MIs[0] policy
     /* 1552180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552190 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1552193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552214 */     // GIR_Coverage, 18888,
     /* 1552214 */     GIR_EraseRootFromParent_Done,
     /* 1552215 */   // Label 21529: @1552215
     /* 1552215 */   GIM_Try, /*On fail goto*//*Label 21530*/ GIMT_Encode4(1552297), // Rule ID 18889 //
     /* 1552220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1552223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1552228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1552231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1552234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1552240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552259 */     // MIs[0] round
     /* 1552259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552262 */     // MIs[0] policy
     /* 1552262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552272 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1552275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552296 */     // GIR_Coverage, 18889,
     /* 1552296 */     GIR_EraseRootFromParent_Done,
     /* 1552297 */   // Label 21530: @1552297
     /* 1552297 */   GIM_Try, /*On fail goto*//*Label 21531*/ GIMT_Encode4(1552379), // Rule ID 18892 //
     /* 1552302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1552305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1552310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1552313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1552316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1552322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552341 */     // MIs[0] round
     /* 1552341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552344 */     // MIs[0] policy
     /* 1552344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552354 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1552357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552378 */     // GIR_Coverage, 18892,
     /* 1552378 */     GIR_EraseRootFromParent_Done,
     /* 1552379 */   // Label 21531: @1552379
     /* 1552379 */   GIM_Try, /*On fail goto*//*Label 21532*/ GIMT_Encode4(1552461), // Rule ID 18893 //
     /* 1552384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1552387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1552392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1552395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1552398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1552404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552423 */     // MIs[0] round
     /* 1552423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552426 */     // MIs[0] policy
     /* 1552426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552436 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1552439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552460 */     // GIR_Coverage, 18893,
     /* 1552460 */     GIR_EraseRootFromParent_Done,
     /* 1552461 */   // Label 21532: @1552461
     /* 1552461 */   GIM_Try, /*On fail goto*//*Label 21533*/ GIMT_Encode4(1552543), // Rule ID 18896 //
     /* 1552466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1552469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1552474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1552477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1552480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1552486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552505 */     // MIs[0] round
     /* 1552505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552508 */     // MIs[0] policy
     /* 1552508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552518 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1552521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552542 */     // GIR_Coverage, 18896,
     /* 1552542 */     GIR_EraseRootFromParent_Done,
     /* 1552543 */   // Label 21533: @1552543
     /* 1552543 */   GIM_Try, /*On fail goto*//*Label 21534*/ GIMT_Encode4(1552625), // Rule ID 18897 //
     /* 1552548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1552551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1552556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1552559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1552562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1552568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552587 */     // MIs[0] round
     /* 1552587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552590 */     // MIs[0] policy
     /* 1552590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552600 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1552603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552624 */     // GIR_Coverage, 18897,
     /* 1552624 */     GIR_EraseRootFromParent_Done,
     /* 1552625 */   // Label 21534: @1552625
     /* 1552625 */   GIM_Try, /*On fail goto*//*Label 21535*/ GIMT_Encode4(1552707), // Rule ID 18900 //
     /* 1552630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1552633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1552638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1552641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1552644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1552650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552669 */     // MIs[0] round
     /* 1552669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552672 */     // MIs[0] policy
     /* 1552672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552682 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1552685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552706 */     // GIR_Coverage, 18900,
     /* 1552706 */     GIR_EraseRootFromParent_Done,
     /* 1552707 */   // Label 21535: @1552707
     /* 1552707 */   GIM_Try, /*On fail goto*//*Label 21536*/ GIMT_Encode4(1552789), // Rule ID 18901 //
     /* 1552712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1552715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1552720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1552723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1552726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1552732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552751 */     // MIs[0] round
     /* 1552751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552754 */     // MIs[0] policy
     /* 1552754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552764 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1552767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552788 */     // GIR_Coverage, 18901,
     /* 1552788 */     GIR_EraseRootFromParent_Done,
     /* 1552789 */   // Label 21536: @1552789
     /* 1552789 */   GIM_Try, /*On fail goto*//*Label 21537*/ GIMT_Encode4(1552871), // Rule ID 18904 //
     /* 1552794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1552802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1552805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1552808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1552814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552833 */     // MIs[0] round
     /* 1552833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552836 */     // MIs[0] policy
     /* 1552836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552846 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1552849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552870 */     // GIR_Coverage, 18904,
     /* 1552870 */     GIR_EraseRootFromParent_Done,
     /* 1552871 */   // Label 21537: @1552871
     /* 1552871 */   GIM_Try, /*On fail goto*//*Label 21538*/ GIMT_Encode4(1552953), // Rule ID 18905 //
     /* 1552876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1552884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1552887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1552890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1552896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552915 */     // MIs[0] round
     /* 1552915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552918 */     // MIs[0] policy
     /* 1552918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552928 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1552931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552952 */     // GIR_Coverage, 18905,
     /* 1552952 */     GIR_EraseRootFromParent_Done,
     /* 1552953 */   // Label 21538: @1552953
     /* 1552953 */   GIM_Try, /*On fail goto*//*Label 21539*/ GIMT_Encode4(1553035), // Rule ID 18908 //
     /* 1552958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1552966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1552978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552997 */     // MIs[0] round
     /* 1552997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553000 */     // MIs[0] policy
     /* 1553000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553010 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1553013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553034 */     // GIR_Coverage, 18908,
     /* 1553034 */     GIR_EraseRootFromParent_Done,
     /* 1553035 */   // Label 21539: @1553035
     /* 1553035 */   GIM_Try, /*On fail goto*//*Label 21540*/ GIMT_Encode4(1553117), // Rule ID 18909 //
     /* 1553040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1553043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1553048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1553051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1553054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1553057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1553060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1553075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553079 */     // MIs[0] round
     /* 1553079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553082 */     // MIs[0] policy
     /* 1553082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553092 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1553095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553116 */     // GIR_Coverage, 18909,
     /* 1553116 */     GIR_EraseRootFromParent_Done,
     /* 1553117 */   // Label 21540: @1553117
     /* 1553117 */   GIM_Try, /*On fail goto*//*Label 21541*/ GIMT_Encode4(1553199), // Rule ID 18912 //
     /* 1553122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1553125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1553130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1553133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1553136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1553139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1553142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1553157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553161 */     // MIs[0] round
     /* 1553161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553164 */     // MIs[0] policy
     /* 1553164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553174 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1553177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553198 */     // GIR_Coverage, 18912,
     /* 1553198 */     GIR_EraseRootFromParent_Done,
     /* 1553199 */   // Label 21541: @1553199
     /* 1553199 */   GIM_Try, /*On fail goto*//*Label 21542*/ GIMT_Encode4(1553281), // Rule ID 18913 //
     /* 1553204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1553207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1553212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1553215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1553218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1553221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1553224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1553239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553243 */     // MIs[0] round
     /* 1553243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553246 */     // MIs[0] policy
     /* 1553246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553256 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1553259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553280 */     // GIR_Coverage, 18913,
     /* 1553280 */     GIR_EraseRootFromParent_Done,
     /* 1553281 */   // Label 21542: @1553281
     /* 1553281 */   GIM_Try, /*On fail goto*//*Label 21543*/ GIMT_Encode4(1553363), // Rule ID 18916 //
     /* 1553286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1553289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1553294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1553297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1553300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1553303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1553306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1553321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553325 */     // MIs[0] round
     /* 1553325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553328 */     // MIs[0] policy
     /* 1553328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553338 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1553341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553362 */     // GIR_Coverage, 18916,
     /* 1553362 */     GIR_EraseRootFromParent_Done,
     /* 1553363 */   // Label 21543: @1553363
     /* 1553363 */   GIM_Try, /*On fail goto*//*Label 21544*/ GIMT_Encode4(1553445), // Rule ID 18917 //
     /* 1553368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1553371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1553376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1553379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1553382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1553385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1553388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1553403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553407 */     // MIs[0] round
     /* 1553407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553410 */     // MIs[0] policy
     /* 1553410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553420 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1553423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553444 */     // GIR_Coverage, 18917,
     /* 1553444 */     GIR_EraseRootFromParent_Done,
     /* 1553445 */   // Label 21544: @1553445
     /* 1553445 */   GIM_Try, /*On fail goto*//*Label 21545*/ GIMT_Encode4(1553527), // Rule ID 18920 //
     /* 1553450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1553453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1553458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1553461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1553464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1553467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1553470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553489 */     // MIs[0] round
     /* 1553489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553492 */     // MIs[0] policy
     /* 1553492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553502 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1553505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553526 */     // GIR_Coverage, 18920,
     /* 1553526 */     GIR_EraseRootFromParent_Done,
     /* 1553527 */   // Label 21545: @1553527
     /* 1553527 */   GIM_Try, /*On fail goto*//*Label 21546*/ GIMT_Encode4(1553609), // Rule ID 18921 //
     /* 1553532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1553535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1553540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1553543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1553546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1553549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1553552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553571 */     // MIs[0] round
     /* 1553571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553574 */     // MIs[0] policy
     /* 1553574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553584 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1553587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553608 */     // GIR_Coverage, 18921,
     /* 1553608 */     GIR_EraseRootFromParent_Done,
     /* 1553609 */   // Label 21546: @1553609
     /* 1553609 */   GIM_Try, /*On fail goto*//*Label 21547*/ GIMT_Encode4(1553691), // Rule ID 18924 //
     /* 1553614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1553617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1553622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1553631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1553634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553653 */     // MIs[0] round
     /* 1553653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553656 */     // MIs[0] policy
     /* 1553656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553666 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1553669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553690 */     // GIR_Coverage, 18924,
     /* 1553690 */     GIR_EraseRootFromParent_Done,
     /* 1553691 */   // Label 21547: @1553691
     /* 1553691 */   GIM_Try, /*On fail goto*//*Label 21548*/ GIMT_Encode4(1553773), // Rule ID 18925 //
     /* 1553696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1553699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1553704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1553713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1553716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553735 */     // MIs[0] round
     /* 1553735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553738 */     // MIs[0] policy
     /* 1553738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553748 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1553751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553772 */     // GIR_Coverage, 18925,
     /* 1553772 */     GIR_EraseRootFromParent_Done,
     /* 1553773 */   // Label 21548: @1553773
     /* 1553773 */   GIM_Try, /*On fail goto*//*Label 21549*/ GIMT_Encode4(1553855), // Rule ID 18928 //
     /* 1553778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1553781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1553786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1553789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1553792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1553795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1553798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553817 */     // MIs[0] round
     /* 1553817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553820 */     // MIs[0] policy
     /* 1553820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553830 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1553833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553854 */     // GIR_Coverage, 18928,
     /* 1553854 */     GIR_EraseRootFromParent_Done,
     /* 1553855 */   // Label 21549: @1553855
     /* 1553855 */   GIM_Try, /*On fail goto*//*Label 21550*/ GIMT_Encode4(1553937), // Rule ID 18929 //
     /* 1553860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1553863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1553868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1553871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1553874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1553877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1553880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553899 */     // MIs[0] round
     /* 1553899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553902 */     // MIs[0] policy
     /* 1553902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553912 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1553915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553936 */     // GIR_Coverage, 18929,
     /* 1553936 */     GIR_EraseRootFromParent_Done,
     /* 1553937 */   // Label 21550: @1553937
     /* 1553937 */   GIM_Try, /*On fail goto*//*Label 21551*/ GIMT_Encode4(1554019), // Rule ID 18932 //
     /* 1553942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1553945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1553950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1553953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1553956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1553959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1553962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553981 */     // MIs[0] round
     /* 1553981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553984 */     // MIs[0] policy
     /* 1553984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553994 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1553997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1554001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554018 */     // GIR_Coverage, 18932,
     /* 1554018 */     GIR_EraseRootFromParent_Done,
     /* 1554019 */   // Label 21551: @1554019
     /* 1554019 */   GIM_Try, /*On fail goto*//*Label 21552*/ GIMT_Encode4(1554101), // Rule ID 18933 //
     /* 1554024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1554027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1554032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1554035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1554038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1554041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1554044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554063 */     // MIs[0] round
     /* 1554063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554066 */     // MIs[0] policy
     /* 1554066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554076 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1554079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1554083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554100 */     // GIR_Coverage, 18933,
     /* 1554100 */     GIR_EraseRootFromParent_Done,
     /* 1554101 */   // Label 21552: @1554101
     /* 1554101 */   GIM_Try, /*On fail goto*//*Label 21553*/ GIMT_Encode4(1554183), // Rule ID 18936 //
     /* 1554106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1554109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1554114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1554123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1554126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554145 */     // MIs[0] round
     /* 1554145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554148 */     // MIs[0] policy
     /* 1554148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554158 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1554161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1554165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554182 */     // GIR_Coverage, 18936,
     /* 1554182 */     GIR_EraseRootFromParent_Done,
     /* 1554183 */   // Label 21553: @1554183
     /* 1554183 */   GIM_Try, /*On fail goto*//*Label 21554*/ GIMT_Encode4(1554265), // Rule ID 18937 //
     /* 1554188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1554191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1554196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1554205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1554208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554227 */     // MIs[0] round
     /* 1554227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554230 */     // MIs[0] policy
     /* 1554230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554240 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1554243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1554247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554264 */     // GIR_Coverage, 18937,
     /* 1554264 */     GIR_EraseRootFromParent_Done,
     /* 1554265 */   // Label 21554: @1554265
     /* 1554265 */   GIM_Try, /*On fail goto*//*Label 21555*/ GIMT_Encode4(1554347), // Rule ID 18940 //
     /* 1554270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1554273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1554278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1554281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1554284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1554287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1554290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554309 */     // MIs[0] round
     /* 1554309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554312 */     // MIs[0] policy
     /* 1554312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554322 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1554325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1554329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554346 */     // GIR_Coverage, 18940,
     /* 1554346 */     GIR_EraseRootFromParent_Done,
     /* 1554347 */   // Label 21555: @1554347
     /* 1554347 */   GIM_Try, /*On fail goto*//*Label 21556*/ GIMT_Encode4(1554429), // Rule ID 18941 //
     /* 1554352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1554355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1554360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1554363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1554366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1554369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1554372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554391 */     // MIs[0] round
     /* 1554391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554394 */     // MIs[0] policy
     /* 1554394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554404 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1554407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1554411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554428 */     // GIR_Coverage, 18941,
     /* 1554428 */     GIR_EraseRootFromParent_Done,
     /* 1554429 */   // Label 21556: @1554429
     /* 1554429 */   GIM_Try, /*On fail goto*//*Label 21557*/ GIMT_Encode4(1554511), // Rule ID 18944 //
     /* 1554434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1554437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1554442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1554445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1554448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1554451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1554454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554473 */     // MIs[0] round
     /* 1554473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554476 */     // MIs[0] policy
     /* 1554476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554486 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1554489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1554493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554510 */     // GIR_Coverage, 18944,
     /* 1554510 */     GIR_EraseRootFromParent_Done,
     /* 1554511 */   // Label 21557: @1554511
     /* 1554511 */   GIM_Try, /*On fail goto*//*Label 21558*/ GIMT_Encode4(1554593), // Rule ID 18945 //
     /* 1554516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1554519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1554524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1554527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1554530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1554533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1554536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554555 */     // MIs[0] round
     /* 1554555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554558 */     // MIs[0] policy
     /* 1554558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554568 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1554571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1554575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554592 */     // GIR_Coverage, 18945,
     /* 1554592 */     GIR_EraseRootFromParent_Done,
     /* 1554593 */   // Label 21558: @1554593
     /* 1554593 */   GIM_Try, /*On fail goto*//*Label 21559*/ GIMT_Encode4(1554675), // Rule ID 18948 //
     /* 1554598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1554601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1554606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1554609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1554612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1554615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1554618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554637 */     // MIs[0] round
     /* 1554637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554640 */     // MIs[0] policy
     /* 1554640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554650 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1554653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1554657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554674 */     // GIR_Coverage, 18948,
     /* 1554674 */     GIR_EraseRootFromParent_Done,
     /* 1554675 */   // Label 21559: @1554675
     /* 1554675 */   GIM_Try, /*On fail goto*//*Label 21560*/ GIMT_Encode4(1554757), // Rule ID 18949 //
     /* 1554680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1554683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1554688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1554691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1554694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1554697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1554700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554719 */     // MIs[0] round
     /* 1554719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554722 */     // MIs[0] policy
     /* 1554722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554732 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1554735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1554739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554756 */     // GIR_Coverage, 18949,
     /* 1554756 */     GIR_EraseRootFromParent_Done,
     /* 1554757 */   // Label 21560: @1554757
     /* 1554757 */   GIM_Try, /*On fail goto*//*Label 21561*/ GIMT_Encode4(1554839), // Rule ID 18952 //
     /* 1554762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1554765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1554770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1554773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1554776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1554782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554801 */     // MIs[0] round
     /* 1554801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554804 */     // MIs[0] policy
     /* 1554804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554814 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1554817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1554821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554838 */     // GIR_Coverage, 18952,
     /* 1554838 */     GIR_EraseRootFromParent_Done,
     /* 1554839 */   // Label 21561: @1554839
     /* 1554839 */   GIM_Try, /*On fail goto*//*Label 21562*/ GIMT_Encode4(1554921), // Rule ID 18953 //
     /* 1554844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1554847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1554852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1554855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1554858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1554864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554883 */     // MIs[0] round
     /* 1554883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554886 */     // MIs[0] policy
     /* 1554886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554896 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1554899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1554903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554920 */     // GIR_Coverage, 18953,
     /* 1554920 */     GIR_EraseRootFromParent_Done,
     /* 1554921 */   // Label 21562: @1554921
     /* 1554921 */   GIM_Try, /*On fail goto*//*Label 21563*/ GIMT_Encode4(1555003), // Rule ID 18956 //
     /* 1554926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1554929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1554934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1554937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1554940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1554943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1554946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1554961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554965 */     // MIs[0] round
     /* 1554965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554968 */     // MIs[0] policy
     /* 1554968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554978 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1554981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1554985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1554987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1554989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555002 */     // GIR_Coverage, 18956,
     /* 1555002 */     GIR_EraseRootFromParent_Done,
     /* 1555003 */   // Label 21563: @1555003
     /* 1555003 */   GIM_Try, /*On fail goto*//*Label 21564*/ GIMT_Encode4(1555085), // Rule ID 18957 //
     /* 1555008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1555011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1555016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1555019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1555022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1555025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1555028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1555043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555047 */     // MIs[0] round
     /* 1555047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555050 */     // MIs[0] policy
     /* 1555050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555060 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1555063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1555067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555084 */     // GIR_Coverage, 18957,
     /* 1555084 */     GIR_EraseRootFromParent_Done,
     /* 1555085 */   // Label 21564: @1555085
     /* 1555085 */   GIM_Try, /*On fail goto*//*Label 21565*/ GIMT_Encode4(1555167), // Rule ID 18960 //
     /* 1555090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1555093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1555098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1555101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1555104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1555107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1555110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1555125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555129 */     // MIs[0] round
     /* 1555129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555132 */     // MIs[0] policy
     /* 1555132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555142 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1555145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1555149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555166 */     // GIR_Coverage, 18960,
     /* 1555166 */     GIR_EraseRootFromParent_Done,
     /* 1555167 */   // Label 21565: @1555167
     /* 1555167 */   GIM_Try, /*On fail goto*//*Label 21566*/ GIMT_Encode4(1555249), // Rule ID 18961 //
     /* 1555172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1555175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1555180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1555183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1555186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1555189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1555192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1555207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555211 */     // MIs[0] round
     /* 1555211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555214 */     // MIs[0] policy
     /* 1555214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555224 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1555227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1555231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555248 */     // GIR_Coverage, 18961,
     /* 1555248 */     GIR_EraseRootFromParent_Done,
     /* 1555249 */   // Label 21566: @1555249
     /* 1555249 */   GIM_Try, /*On fail goto*//*Label 21567*/ GIMT_Encode4(1555331), // Rule ID 18964 //
     /* 1555254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1555257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1555262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1555265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1555268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1555271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1555274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1555289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555293 */     // MIs[0] round
     /* 1555293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555296 */     // MIs[0] policy
     /* 1555296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555306 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1555309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1555313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555330 */     // GIR_Coverage, 18964,
     /* 1555330 */     GIR_EraseRootFromParent_Done,
     /* 1555331 */   // Label 21567: @1555331
     /* 1555331 */   GIM_Try, /*On fail goto*//*Label 21568*/ GIMT_Encode4(1555413), // Rule ID 18965 //
     /* 1555336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1555339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1555344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1555347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1555350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1555353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1555356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1555371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555375 */     // MIs[0] round
     /* 1555375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555378 */     // MIs[0] policy
     /* 1555378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555388 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1555391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1555395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555412 */     // GIR_Coverage, 18965,
     /* 1555412 */     GIR_EraseRootFromParent_Done,
     /* 1555413 */   // Label 21568: @1555413
     /* 1555413 */   GIM_Try, /*On fail goto*//*Label 21569*/ GIMT_Encode4(1555495), // Rule ID 18968 //
     /* 1555418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1555421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1555426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1555429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1555432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1555435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1555438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1555453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555457 */     // MIs[0] round
     /* 1555457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555460 */     // MIs[0] policy
     /* 1555460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555470 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1555473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1555477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555494 */     // GIR_Coverage, 18968,
     /* 1555494 */     GIR_EraseRootFromParent_Done,
     /* 1555495 */   // Label 21569: @1555495
     /* 1555495 */   GIM_Try, /*On fail goto*//*Label 21570*/ GIMT_Encode4(1555577), // Rule ID 18969 //
     /* 1555500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1555503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1555508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1555511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1555514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1555517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1555520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1555535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555539 */     // MIs[0] round
     /* 1555539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555542 */     // MIs[0] policy
     /* 1555542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555552 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1555555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1555559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555576 */     // GIR_Coverage, 18969,
     /* 1555576 */     GIR_EraseRootFromParent_Done,
     /* 1555577 */   // Label 21570: @1555577
     /* 1555577 */   GIM_Try, /*On fail goto*//*Label 21571*/ GIMT_Encode4(1555659), // Rule ID 18972 //
     /* 1555582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1555585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1555590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1555593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1555596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1555599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1555602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1555617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555621 */     // MIs[0] round
     /* 1555621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555624 */     // MIs[0] policy
     /* 1555624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555634 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1555637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1555641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555658 */     // GIR_Coverage, 18972,
     /* 1555658 */     GIR_EraseRootFromParent_Done,
     /* 1555659 */   // Label 21571: @1555659
     /* 1555659 */   GIM_Try, /*On fail goto*//*Label 21572*/ GIMT_Encode4(1555741), // Rule ID 18973 //
     /* 1555664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1555667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1555672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1555675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1555678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1555681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1555684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1555699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555703 */     // MIs[0] round
     /* 1555703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555706 */     // MIs[0] policy
     /* 1555706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555716 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1555719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1555723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555740 */     // GIR_Coverage, 18973,
     /* 1555740 */     GIR_EraseRootFromParent_Done,
     /* 1555741 */   // Label 21572: @1555741
     /* 1555741 */   GIM_Try, /*On fail goto*//*Label 21573*/ GIMT_Encode4(1555823), // Rule ID 18976 //
     /* 1555746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1555749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1555754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1555757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1555760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1555763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1555766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1555781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555785 */     // MIs[0] round
     /* 1555785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555788 */     // MIs[0] policy
     /* 1555788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555798 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1555801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1555805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555822 */     // GIR_Coverage, 18976,
     /* 1555822 */     GIR_EraseRootFromParent_Done,
     /* 1555823 */   // Label 21573: @1555823
     /* 1555823 */   GIM_Try, /*On fail goto*//*Label 21574*/ GIMT_Encode4(1555905), // Rule ID 18977 //
     /* 1555828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1555831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1555836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1555839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1555842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1555845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1555848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1555863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555867 */     // MIs[0] round
     /* 1555867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555870 */     // MIs[0] policy
     /* 1555870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555880 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1555883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1555887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555904 */     // GIR_Coverage, 18977,
     /* 1555904 */     GIR_EraseRootFromParent_Done,
     /* 1555905 */   // Label 21574: @1555905
     /* 1555905 */   GIM_Try, /*On fail goto*//*Label 21575*/ GIMT_Encode4(1555987), // Rule ID 18980 //
     /* 1555910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1555913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1555918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1555921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1555924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1555927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1555930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1555945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555949 */     // MIs[0] round
     /* 1555949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555952 */     // MIs[0] policy
     /* 1555952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555962 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1555965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1555969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1555971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1555973 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555986 */     // GIR_Coverage, 18980,
     /* 1555986 */     GIR_EraseRootFromParent_Done,
     /* 1555987 */   // Label 21575: @1555987
     /* 1555987 */   GIM_Try, /*On fail goto*//*Label 21576*/ GIMT_Encode4(1556069), // Rule ID 18981 //
     /* 1555992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1555995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1556000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1556003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1556006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1556009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1556012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1556027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556031 */     // MIs[0] round
     /* 1556031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556034 */     // MIs[0] policy
     /* 1556034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556044 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1556047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1556051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556068 */     // GIR_Coverage, 18981,
     /* 1556068 */     GIR_EraseRootFromParent_Done,
     /* 1556069 */   // Label 21576: @1556069
     /* 1556069 */   GIM_Try, /*On fail goto*//*Label 21577*/ GIMT_Encode4(1556151), // Rule ID 18984 //
     /* 1556074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1556077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1556082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1556085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1556088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1556091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1556094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1556109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556113 */     // MIs[0] round
     /* 1556113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556116 */     // MIs[0] policy
     /* 1556116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556126 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1556129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1556133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556150 */     // GIR_Coverage, 18984,
     /* 1556150 */     GIR_EraseRootFromParent_Done,
     /* 1556151 */   // Label 21577: @1556151
     /* 1556151 */   GIM_Try, /*On fail goto*//*Label 21578*/ GIMT_Encode4(1556233), // Rule ID 18985 //
     /* 1556156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1556159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1556164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1556167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1556170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1556173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1556176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1556191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556195 */     // MIs[0] round
     /* 1556195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556198 */     // MIs[0] policy
     /* 1556198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556208 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1556211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1556215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556232 */     // GIR_Coverage, 18985,
     /* 1556232 */     GIR_EraseRootFromParent_Done,
     /* 1556233 */   // Label 21578: @1556233
     /* 1556233 */   GIM_Try, /*On fail goto*//*Label 21579*/ GIMT_Encode4(1556315), // Rule ID 18988 //
     /* 1556238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1556241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1556246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1556249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1556252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1556255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1556258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1556273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556277 */     // MIs[0] round
     /* 1556277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556280 */     // MIs[0] policy
     /* 1556280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556290 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1556293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1556297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556314 */     // GIR_Coverage, 18988,
     /* 1556314 */     GIR_EraseRootFromParent_Done,
     /* 1556315 */   // Label 21579: @1556315
     /* 1556315 */   GIM_Try, /*On fail goto*//*Label 21580*/ GIMT_Encode4(1556397), // Rule ID 18989 //
     /* 1556320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1556323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1556328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1556331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1556334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1556337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1556340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1556355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556359 */     // MIs[0] round
     /* 1556359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556362 */     // MIs[0] policy
     /* 1556362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556372 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1556375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1556379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1556381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1556383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556396 */     // GIR_Coverage, 18989,
     /* 1556396 */     GIR_EraseRootFromParent_Done,
     /* 1556397 */   // Label 21580: @1556397
     /* 1556397 */   GIM_Try, /*On fail goto*//*Label 21581*/ GIMT_Encode4(1556479), // Rule ID 18994 //
     /* 1556402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1556405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1556410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1556413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1556416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1556419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556441 */     // MIs[0] round
     /* 1556441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556444 */     // MIs[0] policy
     /* 1556444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556454 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1556457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556478 */     // GIR_Coverage, 18994,
     /* 1556478 */     GIR_EraseRootFromParent_Done,
     /* 1556479 */   // Label 21581: @1556479
     /* 1556479 */   GIM_Try, /*On fail goto*//*Label 21582*/ GIMT_Encode4(1556561), // Rule ID 18995 //
     /* 1556484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1556487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1556492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1556495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1556498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1556501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556523 */     // MIs[0] round
     /* 1556523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556526 */     // MIs[0] policy
     /* 1556526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556536 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1556539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556560 */     // GIR_Coverage, 18995,
     /* 1556560 */     GIR_EraseRootFromParent_Done,
     /* 1556561 */   // Label 21582: @1556561
     /* 1556561 */   GIM_Try, /*On fail goto*//*Label 21583*/ GIMT_Encode4(1556643), // Rule ID 18998 //
     /* 1556566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1556569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1556574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1556577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1556580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1556583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1556586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556605 */     // MIs[0] round
     /* 1556605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556608 */     // MIs[0] policy
     /* 1556608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556618 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1556621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556642 */     // GIR_Coverage, 18998,
     /* 1556642 */     GIR_EraseRootFromParent_Done,
     /* 1556643 */   // Label 21583: @1556643
     /* 1556643 */   GIM_Try, /*On fail goto*//*Label 21584*/ GIMT_Encode4(1556725), // Rule ID 18999 //
     /* 1556648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1556651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1556656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1556659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1556662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1556665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1556668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556687 */     // MIs[0] round
     /* 1556687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556690 */     // MIs[0] policy
     /* 1556690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556700 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1556703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556724 */     // GIR_Coverage, 18999,
     /* 1556724 */     GIR_EraseRootFromParent_Done,
     /* 1556725 */   // Label 21584: @1556725
     /* 1556725 */   GIM_Try, /*On fail goto*//*Label 21585*/ GIMT_Encode4(1556807), // Rule ID 19002 //
     /* 1556730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1556733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1556738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1556741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1556744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1556747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556769 */     // MIs[0] round
     /* 1556769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556772 */     // MIs[0] policy
     /* 1556772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556782 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1556785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556806 */     // GIR_Coverage, 19002,
     /* 1556806 */     GIR_EraseRootFromParent_Done,
     /* 1556807 */   // Label 21585: @1556807
     /* 1556807 */   GIM_Try, /*On fail goto*//*Label 21586*/ GIMT_Encode4(1556889), // Rule ID 19003 //
     /* 1556812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1556815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1556820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1556823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1556826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1556829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556851 */     // MIs[0] round
     /* 1556851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556854 */     // MIs[0] policy
     /* 1556854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556864 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1556867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556888 */     // GIR_Coverage, 19003,
     /* 1556888 */     GIR_EraseRootFromParent_Done,
     /* 1556889 */   // Label 21586: @1556889
     /* 1556889 */   GIM_Try, /*On fail goto*//*Label 21587*/ GIMT_Encode4(1556971), // Rule ID 19006 //
     /* 1556894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1556897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1556902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1556905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1556908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1556911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556933 */     // MIs[0] round
     /* 1556933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556936 */     // MIs[0] policy
     /* 1556936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556946 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1556949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556955 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556970 */     // GIR_Coverage, 19006,
     /* 1556970 */     GIR_EraseRootFromParent_Done,
     /* 1556971 */   // Label 21587: @1556971
     /* 1556971 */   GIM_Try, /*On fail goto*//*Label 21588*/ GIMT_Encode4(1557053), // Rule ID 19007 //
     /* 1556976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1556979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1556984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1556987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1556990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1556993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557015 */     // MIs[0] round
     /* 1557015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557018 */     // MIs[0] policy
     /* 1557018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557028 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1557031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557052 */     // GIR_Coverage, 19007,
     /* 1557052 */     GIR_EraseRootFromParent_Done,
     /* 1557053 */   // Label 21588: @1557053
     /* 1557053 */   GIM_Try, /*On fail goto*//*Label 21589*/ GIMT_Encode4(1557135), // Rule ID 19010 //
     /* 1557058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1557061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1557066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1557069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1557072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1557075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557097 */     // MIs[0] round
     /* 1557097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557100 */     // MIs[0] policy
     /* 1557100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557110 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1557113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557134 */     // GIR_Coverage, 19010,
     /* 1557134 */     GIR_EraseRootFromParent_Done,
     /* 1557135 */   // Label 21589: @1557135
     /* 1557135 */   GIM_Try, /*On fail goto*//*Label 21590*/ GIMT_Encode4(1557217), // Rule ID 19011 //
     /* 1557140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1557143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1557148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1557151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1557154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1557157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557179 */     // MIs[0] round
     /* 1557179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557182 */     // MIs[0] policy
     /* 1557182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557192 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1557195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557216 */     // GIR_Coverage, 19011,
     /* 1557216 */     GIR_EraseRootFromParent_Done,
     /* 1557217 */   // Label 21590: @1557217
     /* 1557217 */   GIM_Try, /*On fail goto*//*Label 21591*/ GIMT_Encode4(1557299), // Rule ID 19014 //
     /* 1557222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1557225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1557230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1557233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1557236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1557239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1557249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557261 */     // MIs[0] round
     /* 1557261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557264 */     // MIs[0] policy
     /* 1557264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557274 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1557277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557298 */     // GIR_Coverage, 19014,
     /* 1557298 */     GIR_EraseRootFromParent_Done,
     /* 1557299 */   // Label 21591: @1557299
     /* 1557299 */   GIM_Try, /*On fail goto*//*Label 21592*/ GIMT_Encode4(1557381), // Rule ID 19015 //
     /* 1557304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1557307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1557312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1557315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1557318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1557321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1557331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557343 */     // MIs[0] round
     /* 1557343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557346 */     // MIs[0] policy
     /* 1557346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557356 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1557359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557380 */     // GIR_Coverage, 19015,
     /* 1557380 */     GIR_EraseRootFromParent_Done,
     /* 1557381 */   // Label 21592: @1557381
     /* 1557381 */   GIM_Try, /*On fail goto*//*Label 21593*/ GIMT_Encode4(1557463), // Rule ID 19018 //
     /* 1557386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1557389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1557394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1557397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1557400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1557403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1557406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557425 */     // MIs[0] round
     /* 1557425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557428 */     // MIs[0] policy
     /* 1557428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557438 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1557441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557462 */     // GIR_Coverage, 19018,
     /* 1557462 */     GIR_EraseRootFromParent_Done,
     /* 1557463 */   // Label 21593: @1557463
     /* 1557463 */   GIM_Try, /*On fail goto*//*Label 21594*/ GIMT_Encode4(1557545), // Rule ID 19019 //
     /* 1557468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1557471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1557476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1557479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1557482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1557485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1557488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557507 */     // MIs[0] round
     /* 1557507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557510 */     // MIs[0] policy
     /* 1557510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557520 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1557523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557544 */     // GIR_Coverage, 19019,
     /* 1557544 */     GIR_EraseRootFromParent_Done,
     /* 1557545 */   // Label 21594: @1557545
     /* 1557545 */   GIM_Try, /*On fail goto*//*Label 21595*/ GIMT_Encode4(1557627), // Rule ID 19022 //
     /* 1557550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1557553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1557558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1557561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1557564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1557567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1557570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557589 */     // MIs[0] round
     /* 1557589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557592 */     // MIs[0] policy
     /* 1557592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557602 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1557605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557626 */     // GIR_Coverage, 19022,
     /* 1557626 */     GIR_EraseRootFromParent_Done,
     /* 1557627 */   // Label 21595: @1557627
     /* 1557627 */   GIM_Try, /*On fail goto*//*Label 21596*/ GIMT_Encode4(1557709), // Rule ID 19023 //
     /* 1557632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1557635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1557640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1557643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1557646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1557649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1557652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557671 */     // MIs[0] round
     /* 1557671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557674 */     // MIs[0] policy
     /* 1557674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557684 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1557687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557708 */     // GIR_Coverage, 19023,
     /* 1557708 */     GIR_EraseRootFromParent_Done,
     /* 1557709 */   // Label 21596: @1557709
     /* 1557709 */   GIM_Try, /*On fail goto*//*Label 21597*/ GIMT_Encode4(1557791), // Rule ID 19026 //
     /* 1557714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1557717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1557722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1557725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1557728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1557731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1557741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557753 */     // MIs[0] round
     /* 1557753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557756 */     // MIs[0] policy
     /* 1557756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557766 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1557769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557790 */     // GIR_Coverage, 19026,
     /* 1557790 */     GIR_EraseRootFromParent_Done,
     /* 1557791 */   // Label 21597: @1557791
     /* 1557791 */   GIM_Try, /*On fail goto*//*Label 21598*/ GIMT_Encode4(1557873), // Rule ID 19027 //
     /* 1557796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1557799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1557804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1557807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1557810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1557813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1557823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557835 */     // MIs[0] round
     /* 1557835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557838 */     // MIs[0] policy
     /* 1557838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557848 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1557851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557872 */     // GIR_Coverage, 19027,
     /* 1557872 */     GIR_EraseRootFromParent_Done,
     /* 1557873 */   // Label 21598: @1557873
     /* 1557873 */   GIM_Try, /*On fail goto*//*Label 21599*/ GIMT_Encode4(1557955), // Rule ID 19030 //
     /* 1557878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1557881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1557886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1557889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1557892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1557895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557917 */     // MIs[0] round
     /* 1557917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557920 */     // MIs[0] policy
     /* 1557920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557930 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1557933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557954 */     // GIR_Coverage, 19030,
     /* 1557954 */     GIR_EraseRootFromParent_Done,
     /* 1557955 */   // Label 21599: @1557955
     /* 1557955 */   GIM_Try, /*On fail goto*//*Label 21600*/ GIMT_Encode4(1558037), // Rule ID 19031 //
     /* 1557960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1557963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1557968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1557971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1557974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1557977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557999 */     // MIs[0] round
     /* 1557999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558002 */     // MIs[0] policy
     /* 1558002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558012 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1558015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558036 */     // GIR_Coverage, 19031,
     /* 1558036 */     GIR_EraseRootFromParent_Done,
     /* 1558037 */   // Label 21600: @1558037
     /* 1558037 */   GIM_Try, /*On fail goto*//*Label 21601*/ GIMT_Encode4(1558119), // Rule ID 19034 //
     /* 1558042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1558045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1558050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1558053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1558056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1558059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558081 */     // MIs[0] round
     /* 1558081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558084 */     // MIs[0] policy
     /* 1558084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558094 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1558097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558118 */     // GIR_Coverage, 19034,
     /* 1558118 */     GIR_EraseRootFromParent_Done,
     /* 1558119 */   // Label 21601: @1558119
     /* 1558119 */   GIM_Try, /*On fail goto*//*Label 21602*/ GIMT_Encode4(1558201), // Rule ID 19035 //
     /* 1558124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1558127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1558132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1558135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1558138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1558141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558163 */     // MIs[0] round
     /* 1558163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558166 */     // MIs[0] policy
     /* 1558166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558176 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1558179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558200 */     // GIR_Coverage, 19035,
     /* 1558200 */     GIR_EraseRootFromParent_Done,
     /* 1558201 */   // Label 21602: @1558201
     /* 1558201 */   GIM_Try, /*On fail goto*//*Label 21603*/ GIMT_Encode4(1558283), // Rule ID 19038 //
     /* 1558206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1558209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1558214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1558217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1558220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1558223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558245 */     // MIs[0] round
     /* 1558245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558248 */     // MIs[0] policy
     /* 1558248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558258 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1558261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558282 */     // GIR_Coverage, 19038,
     /* 1558282 */     GIR_EraseRootFromParent_Done,
     /* 1558283 */   // Label 21603: @1558283
     /* 1558283 */   GIM_Try, /*On fail goto*//*Label 21604*/ GIMT_Encode4(1558365), // Rule ID 19039 //
     /* 1558288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1558291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1558296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1558299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1558302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1558305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558327 */     // MIs[0] round
     /* 1558327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558330 */     // MIs[0] policy
     /* 1558330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558340 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1558343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558349 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558364 */     // GIR_Coverage, 19039,
     /* 1558364 */     GIR_EraseRootFromParent_Done,
     /* 1558365 */   // Label 21604: @1558365
     /* 1558365 */   GIM_Try, /*On fail goto*//*Label 21605*/ GIMT_Encode4(1558447), // Rule ID 19042 //
     /* 1558370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1558373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1558378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1558381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1558384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1558387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558409 */     // MIs[0] round
     /* 1558409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558412 */     // MIs[0] policy
     /* 1558412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558422 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1558425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558446 */     // GIR_Coverage, 19042,
     /* 1558446 */     GIR_EraseRootFromParent_Done,
     /* 1558447 */   // Label 21605: @1558447
     /* 1558447 */   GIM_Try, /*On fail goto*//*Label 21606*/ GIMT_Encode4(1558529), // Rule ID 19043 //
     /* 1558452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1558455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1558460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1558463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1558466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1558469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558491 */     // MIs[0] round
     /* 1558491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558494 */     // MIs[0] policy
     /* 1558494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558504 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1558507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558528 */     // GIR_Coverage, 19043,
     /* 1558528 */     GIR_EraseRootFromParent_Done,
     /* 1558529 */   // Label 21606: @1558529
     /* 1558529 */   GIM_Try, /*On fail goto*//*Label 21607*/ GIMT_Encode4(1558611), // Rule ID 19046 //
     /* 1558534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1558537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1558542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1558545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1558548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1558551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558573 */     // MIs[0] round
     /* 1558573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558576 */     // MIs[0] policy
     /* 1558576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558586 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1558589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558610 */     // GIR_Coverage, 19046,
     /* 1558610 */     GIR_EraseRootFromParent_Done,
     /* 1558611 */   // Label 21607: @1558611
     /* 1558611 */   GIM_Try, /*On fail goto*//*Label 21608*/ GIMT_Encode4(1558693), // Rule ID 19047 //
     /* 1558616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1558619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1558624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1558627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1558630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1558633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558655 */     // MIs[0] round
     /* 1558655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558658 */     // MIs[0] policy
     /* 1558658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558668 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1558671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558692 */     // GIR_Coverage, 19047,
     /* 1558692 */     GIR_EraseRootFromParent_Done,
     /* 1558693 */   // Label 21608: @1558693
     /* 1558693 */   GIM_Try, /*On fail goto*//*Label 21609*/ GIMT_Encode4(1558775), // Rule ID 19106 //
     /* 1558698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1558701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1558706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1558709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1558712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1558715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558737 */     // MIs[0] round
     /* 1558737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558740 */     // MIs[0] policy
     /* 1558740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558750 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1558753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558774 */     // GIR_Coverage, 19106,
     /* 1558774 */     GIR_EraseRootFromParent_Done,
     /* 1558775 */   // Label 21609: @1558775
     /* 1558775 */   GIM_Try, /*On fail goto*//*Label 21610*/ GIMT_Encode4(1558857), // Rule ID 19107 //
     /* 1558780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1558783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1558788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1558791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1558794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1558797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558819 */     // MIs[0] round
     /* 1558819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558822 */     // MIs[0] policy
     /* 1558822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558832 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1558835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558856 */     // GIR_Coverage, 19107,
     /* 1558856 */     GIR_EraseRootFromParent_Done,
     /* 1558857 */   // Label 21610: @1558857
     /* 1558857 */   GIM_Try, /*On fail goto*//*Label 21611*/ GIMT_Encode4(1558939), // Rule ID 19110 //
     /* 1558862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1558865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1558870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1558873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1558876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1558879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558901 */     // MIs[0] round
     /* 1558901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558904 */     // MIs[0] policy
     /* 1558904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558914 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1558917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558938 */     // GIR_Coverage, 19110,
     /* 1558938 */     GIR_EraseRootFromParent_Done,
     /* 1558939 */   // Label 21611: @1558939
     /* 1558939 */   GIM_Try, /*On fail goto*//*Label 21612*/ GIMT_Encode4(1559021), // Rule ID 19111 //
     /* 1558944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1558947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1558952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1558955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1558958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1558961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558983 */     // MIs[0] round
     /* 1558983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558986 */     // MIs[0] policy
     /* 1558986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558996 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1558999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559020 */     // GIR_Coverage, 19111,
     /* 1559020 */     GIR_EraseRootFromParent_Done,
     /* 1559021 */   // Label 21612: @1559021
     /* 1559021 */   GIM_Try, /*On fail goto*//*Label 21613*/ GIMT_Encode4(1559103), // Rule ID 19114 //
     /* 1559026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1559029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1559034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1559037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1559040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1559043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1559046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559065 */     // MIs[0] round
     /* 1559065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559068 */     // MIs[0] policy
     /* 1559068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559078 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1559081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559102 */     // GIR_Coverage, 19114,
     /* 1559102 */     GIR_EraseRootFromParent_Done,
     /* 1559103 */   // Label 21613: @1559103
     /* 1559103 */   GIM_Try, /*On fail goto*//*Label 21614*/ GIMT_Encode4(1559185), // Rule ID 19115 //
     /* 1559108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1559111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1559116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1559119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1559122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1559125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1559128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559147 */     // MIs[0] round
     /* 1559147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559150 */     // MIs[0] policy
     /* 1559150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559160 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1559163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559184 */     // GIR_Coverage, 19115,
     /* 1559184 */     GIR_EraseRootFromParent_Done,
     /* 1559185 */   // Label 21614: @1559185
     /* 1559185 */   GIM_Try, /*On fail goto*//*Label 21615*/ GIMT_Encode4(1559267), // Rule ID 19118 //
     /* 1559190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1559193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1559198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1559201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1559204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1559207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559229 */     // MIs[0] round
     /* 1559229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559232 */     // MIs[0] policy
     /* 1559232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559242 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1559245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559266 */     // GIR_Coverage, 19118,
     /* 1559266 */     GIR_EraseRootFromParent_Done,
     /* 1559267 */   // Label 21615: @1559267
     /* 1559267 */   GIM_Try, /*On fail goto*//*Label 21616*/ GIMT_Encode4(1559349), // Rule ID 19119 //
     /* 1559272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1559275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1559280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1559283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1559286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1559289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559311 */     // MIs[0] round
     /* 1559311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559314 */     // MIs[0] policy
     /* 1559314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559324 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1559327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559348 */     // GIR_Coverage, 19119,
     /* 1559348 */     GIR_EraseRootFromParent_Done,
     /* 1559349 */   // Label 21616: @1559349
     /* 1559349 */   GIM_Try, /*On fail goto*//*Label 21617*/ GIMT_Encode4(1559431), // Rule ID 19122 //
     /* 1559354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1559357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1559362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1559365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1559368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1559371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559393 */     // MIs[0] round
     /* 1559393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559396 */     // MIs[0] policy
     /* 1559396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559406 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1559409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559430 */     // GIR_Coverage, 19122,
     /* 1559430 */     GIR_EraseRootFromParent_Done,
     /* 1559431 */   // Label 21617: @1559431
     /* 1559431 */   GIM_Try, /*On fail goto*//*Label 21618*/ GIMT_Encode4(1559513), // Rule ID 19123 //
     /* 1559436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1559439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1559444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1559447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1559450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1559453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559475 */     // MIs[0] round
     /* 1559475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559478 */     // MIs[0] policy
     /* 1559478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559488 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1559491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559512 */     // GIR_Coverage, 19123,
     /* 1559512 */     GIR_EraseRootFromParent_Done,
     /* 1559513 */   // Label 21618: @1559513
     /* 1559513 */   GIM_Try, /*On fail goto*//*Label 21619*/ GIMT_Encode4(1559595), // Rule ID 19126 //
     /* 1559518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1559521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1559526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1559529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1559532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1559535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1559538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559557 */     // MIs[0] round
     /* 1559557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559560 */     // MIs[0] policy
     /* 1559560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559570 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1559573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559579 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559594 */     // GIR_Coverage, 19126,
     /* 1559594 */     GIR_EraseRootFromParent_Done,
     /* 1559595 */   // Label 21619: @1559595
     /* 1559595 */   GIM_Try, /*On fail goto*//*Label 21620*/ GIMT_Encode4(1559677), // Rule ID 19127 //
     /* 1559600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1559603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1559608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1559611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1559614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1559617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1559620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559639 */     // MIs[0] round
     /* 1559639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559642 */     // MIs[0] policy
     /* 1559642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559652 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1559655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559676 */     // GIR_Coverage, 19127,
     /* 1559676 */     GIR_EraseRootFromParent_Done,
     /* 1559677 */   // Label 21620: @1559677
     /* 1559677 */   GIM_Try, /*On fail goto*//*Label 21621*/ GIMT_Encode4(1559759), // Rule ID 19130 //
     /* 1559682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1559685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1559690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1559693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1559696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1559699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559721 */     // MIs[0] round
     /* 1559721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559724 */     // MIs[0] policy
     /* 1559724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559734 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1559737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559758 */     // GIR_Coverage, 19130,
     /* 1559758 */     GIR_EraseRootFromParent_Done,
     /* 1559759 */   // Label 21621: @1559759
     /* 1559759 */   GIM_Try, /*On fail goto*//*Label 21622*/ GIMT_Encode4(1559841), // Rule ID 19131 //
     /* 1559764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1559767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1559772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1559775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1559778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1559781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559803 */     // MIs[0] round
     /* 1559803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559806 */     // MIs[0] policy
     /* 1559806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559816 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1559819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559840 */     // GIR_Coverage, 19131,
     /* 1559840 */     GIR_EraseRootFromParent_Done,
     /* 1559841 */   // Label 21622: @1559841
     /* 1559841 */   GIM_Try, /*On fail goto*//*Label 21623*/ GIMT_Encode4(1559923), // Rule ID 19134 //
     /* 1559846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1559849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1559854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1559857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1559860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1559863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559885 */     // MIs[0] round
     /* 1559885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559888 */     // MIs[0] policy
     /* 1559888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559898 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1559901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559909 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559922 */     // GIR_Coverage, 19134,
     /* 1559922 */     GIR_EraseRootFromParent_Done,
     /* 1559923 */   // Label 21623: @1559923
     /* 1559923 */   GIM_Try, /*On fail goto*//*Label 21624*/ GIMT_Encode4(1560005), // Rule ID 19135 //
     /* 1559928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1559931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1559936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1559939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1559942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1559945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559967 */     // MIs[0] round
     /* 1559967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559970 */     // MIs[0] policy
     /* 1559970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559980 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1559983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560004 */     // GIR_Coverage, 19135,
     /* 1560004 */     GIR_EraseRootFromParent_Done,
     /* 1560005 */   // Label 21624: @1560005
     /* 1560005 */   GIM_Try, /*On fail goto*//*Label 21625*/ GIMT_Encode4(1560087), // Rule ID 19138 //
     /* 1560010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1560013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1560018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1560021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1560024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1560027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1560030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1560037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560049 */     // MIs[0] round
     /* 1560049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560052 */     // MIs[0] policy
     /* 1560052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560062 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1560065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560086 */     // GIR_Coverage, 19138,
     /* 1560086 */     GIR_EraseRootFromParent_Done,
     /* 1560087 */   // Label 21625: @1560087
     /* 1560087 */   GIM_Try, /*On fail goto*//*Label 21626*/ GIMT_Encode4(1560169), // Rule ID 19139 //
     /* 1560092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1560095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1560100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1560103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1560106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1560109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1560112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1560119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560131 */     // MIs[0] round
     /* 1560131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560134 */     // MIs[0] policy
     /* 1560134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560144 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1560147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560168 */     // GIR_Coverage, 19139,
     /* 1560168 */     GIR_EraseRootFromParent_Done,
     /* 1560169 */   // Label 21626: @1560169
     /* 1560169 */   GIM_Try, /*On fail goto*//*Label 21627*/ GIMT_Encode4(1560251), // Rule ID 19142 //
     /* 1560174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1560177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1560182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1560185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1560188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1560191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1560201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560213 */     // MIs[0] round
     /* 1560213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560216 */     // MIs[0] policy
     /* 1560216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560226 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1560229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560250 */     // GIR_Coverage, 19142,
     /* 1560250 */     GIR_EraseRootFromParent_Done,
     /* 1560251 */   // Label 21627: @1560251
     /* 1560251 */   GIM_Try, /*On fail goto*//*Label 21628*/ GIMT_Encode4(1560333), // Rule ID 19143 //
     /* 1560256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1560259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1560264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1560267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1560270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1560273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1560283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560295 */     // MIs[0] round
     /* 1560295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560298 */     // MIs[0] policy
     /* 1560298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560308 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1560311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560332 */     // GIR_Coverage, 19143,
     /* 1560332 */     GIR_EraseRootFromParent_Done,
     /* 1560333 */   // Label 21628: @1560333
     /* 1560333 */   GIM_Try, /*On fail goto*//*Label 21629*/ GIMT_Encode4(1560415), // Rule ID 19146 //
     /* 1560338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1560341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1560346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1560349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1560352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1560355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1560365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560377 */     // MIs[0] round
     /* 1560377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560380 */     // MIs[0] policy
     /* 1560380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560390 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1560393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560414 */     // GIR_Coverage, 19146,
     /* 1560414 */     GIR_EraseRootFromParent_Done,
     /* 1560415 */   // Label 21629: @1560415
     /* 1560415 */   GIM_Try, /*On fail goto*//*Label 21630*/ GIMT_Encode4(1560497), // Rule ID 19147 //
     /* 1560420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1560423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1560428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1560431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1560434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1560437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1560447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560459 */     // MIs[0] round
     /* 1560459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560462 */     // MIs[0] policy
     /* 1560462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560472 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1560475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560496 */     // GIR_Coverage, 19147,
     /* 1560496 */     GIR_EraseRootFromParent_Done,
     /* 1560497 */   // Label 21630: @1560497
     /* 1560497 */   GIM_Try, /*On fail goto*//*Label 21631*/ GIMT_Encode4(1560579), // Rule ID 19150 //
     /* 1560502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1560505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1560510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1560513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1560516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1560519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1560522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1560529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560541 */     // MIs[0] round
     /* 1560541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560544 */     // MIs[0] policy
     /* 1560544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560554 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1560557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560563 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560578 */     // GIR_Coverage, 19150,
     /* 1560578 */     GIR_EraseRootFromParent_Done,
     /* 1560579 */   // Label 21631: @1560579
     /* 1560579 */   GIM_Try, /*On fail goto*//*Label 21632*/ GIMT_Encode4(1560661), // Rule ID 19151 //
     /* 1560584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1560587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1560592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1560595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1560598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1560601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1560604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1560611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560623 */     // MIs[0] round
     /* 1560623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560626 */     // MIs[0] policy
     /* 1560626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560636 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1560639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560660 */     // GIR_Coverage, 19151,
     /* 1560660 */     GIR_EraseRootFromParent_Done,
     /* 1560661 */   // Label 21632: @1560661
     /* 1560661 */   GIM_Try, /*On fail goto*//*Label 21633*/ GIMT_Encode4(1560743), // Rule ID 19154 //
     /* 1560666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1560669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1560674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1560677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1560680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1560683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1560693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560705 */     // MIs[0] round
     /* 1560705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560708 */     // MIs[0] policy
     /* 1560708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560718 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1560721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560742 */     // GIR_Coverage, 19154,
     /* 1560742 */     GIR_EraseRootFromParent_Done,
     /* 1560743 */   // Label 21633: @1560743
     /* 1560743 */   GIM_Try, /*On fail goto*//*Label 21634*/ GIMT_Encode4(1560825), // Rule ID 19155 //
     /* 1560748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1560751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1560756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1560759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1560762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1560765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1560775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560787 */     // MIs[0] round
     /* 1560787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560790 */     // MIs[0] policy
     /* 1560790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560800 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1560803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560824 */     // GIR_Coverage, 19155,
     /* 1560824 */     GIR_EraseRootFromParent_Done,
     /* 1560825 */   // Label 21634: @1560825
     /* 1560825 */   GIM_Try, /*On fail goto*//*Label 21635*/ GIMT_Encode4(1560907), // Rule ID 19158 //
     /* 1560830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1560833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1560838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1560841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1560844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1560847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1560857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560869 */     // MIs[0] round
     /* 1560869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560872 */     // MIs[0] policy
     /* 1560872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560882 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1560885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560906 */     // GIR_Coverage, 19158,
     /* 1560906 */     GIR_EraseRootFromParent_Done,
     /* 1560907 */   // Label 21635: @1560907
     /* 1560907 */   GIM_Try, /*On fail goto*//*Label 21636*/ GIMT_Encode4(1560989), // Rule ID 19159 //
     /* 1560912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1560915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1560920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1560923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1560926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1560929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1560939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560951 */     // MIs[0] round
     /* 1560951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560954 */     // MIs[0] policy
     /* 1560954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560964 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1560967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560988 */     // GIR_Coverage, 19159,
     /* 1560988 */     GIR_EraseRootFromParent_Done,
     /* 1560989 */   // Label 21636: @1560989
     /* 1560989 */   GIM_Try, /*On fail goto*//*Label 21637*/ GIMT_Encode4(1561071), // Rule ID 19162 //
     /* 1560994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1560997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1561002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1561005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1561008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1561011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561033 */     // MIs[0] round
     /* 1561033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561036 */     // MIs[0] policy
     /* 1561036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561046 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1561049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561070 */     // GIR_Coverage, 19162,
     /* 1561070 */     GIR_EraseRootFromParent_Done,
     /* 1561071 */   // Label 21637: @1561071
     /* 1561071 */   GIM_Try, /*On fail goto*//*Label 21638*/ GIMT_Encode4(1561153), // Rule ID 19163 //
     /* 1561076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1561079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1561084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1561087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1561090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1561093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561115 */     // MIs[0] round
     /* 1561115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561118 */     // MIs[0] policy
     /* 1561118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561128 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1561131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561139 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561152 */     // GIR_Coverage, 19163,
     /* 1561152 */     GIR_EraseRootFromParent_Done,
     /* 1561153 */   // Label 21638: @1561153
     /* 1561153 */   GIM_Try, /*On fail goto*//*Label 21639*/ GIMT_Encode4(1561235), // Rule ID 20748 //
     /* 1561158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1561161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1561166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1561169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1561172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1561175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1561178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561197 */     // MIs[0] round
     /* 1561197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561200 */     // MIs[0] policy
     /* 1561200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561210 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1561213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561234 */     // GIR_Coverage, 20748,
     /* 1561234 */     GIR_EraseRootFromParent_Done,
     /* 1561235 */   // Label 21639: @1561235
     /* 1561235 */   GIM_Try, /*On fail goto*//*Label 21640*/ GIMT_Encode4(1561317), // Rule ID 20749 //
     /* 1561240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1561248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1561251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1561254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1561257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1561260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561279 */     // MIs[0] round
     /* 1561279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561282 */     // MIs[0] policy
     /* 1561282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561292 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1561295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561316 */     // GIR_Coverage, 20749,
     /* 1561316 */     GIR_EraseRootFromParent_Done,
     /* 1561317 */   // Label 21640: @1561317
     /* 1561317 */   GIM_Try, /*On fail goto*//*Label 21641*/ GIMT_Encode4(1561399), // Rule ID 20752 //
     /* 1561322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1561330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1561333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1561336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1561339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1561342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561361 */     // MIs[0] round
     /* 1561361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561364 */     // MIs[0] policy
     /* 1561364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561374 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1561377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561398 */     // GIR_Coverage, 20752,
     /* 1561398 */     GIR_EraseRootFromParent_Done,
     /* 1561399 */   // Label 21641: @1561399
     /* 1561399 */   GIM_Try, /*On fail goto*//*Label 21642*/ GIMT_Encode4(1561481), // Rule ID 20753 //
     /* 1561404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1561412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1561415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1561418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1561421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1561424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561443 */     // MIs[0] round
     /* 1561443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561446 */     // MIs[0] policy
     /* 1561446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561456 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1561459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561480 */     // GIR_Coverage, 20753,
     /* 1561480 */     GIR_EraseRootFromParent_Done,
     /* 1561481 */   // Label 21642: @1561481
     /* 1561481 */   GIM_Try, /*On fail goto*//*Label 21643*/ GIMT_Encode4(1561563), // Rule ID 20756 //
     /* 1561486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1561489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1561494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1561497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1561500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1561503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561525 */     // MIs[0] round
     /* 1561525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561528 */     // MIs[0] policy
     /* 1561528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561538 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1561541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561547 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561562 */     // GIR_Coverage, 20756,
     /* 1561562 */     GIR_EraseRootFromParent_Done,
     /* 1561563 */   // Label 21643: @1561563
     /* 1561563 */   GIM_Try, /*On fail goto*//*Label 21644*/ GIMT_Encode4(1561645), // Rule ID 20757 //
     /* 1561568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1561576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1561579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1561582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1561585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561607 */     // MIs[0] round
     /* 1561607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561610 */     // MIs[0] policy
     /* 1561610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1561623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561644 */     // GIR_Coverage, 20757,
     /* 1561644 */     GIR_EraseRootFromParent_Done,
     /* 1561645 */   // Label 21644: @1561645
     /* 1561645 */   GIM_Try, /*On fail goto*//*Label 21645*/ GIMT_Encode4(1561727), // Rule ID 20760 //
     /* 1561650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1561658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1561661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1561664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1561667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1561670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561689 */     // MIs[0] round
     /* 1561689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561692 */     // MIs[0] policy
     /* 1561692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1561705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561726 */     // GIR_Coverage, 20760,
     /* 1561726 */     GIR_EraseRootFromParent_Done,
     /* 1561727 */   // Label 21645: @1561727
     /* 1561727 */   GIM_Try, /*On fail goto*//*Label 21646*/ GIMT_Encode4(1561809), // Rule ID 20761 //
     /* 1561732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1561740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1561743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1561746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1561749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1561752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561771 */     // MIs[0] round
     /* 1561771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561774 */     // MIs[0] policy
     /* 1561774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561784 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1561787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561808 */     // GIR_Coverage, 20761,
     /* 1561808 */     GIR_EraseRootFromParent_Done,
     /* 1561809 */   // Label 21646: @1561809
     /* 1561809 */   GIM_Try, /*On fail goto*//*Label 21647*/ GIMT_Encode4(1561891), // Rule ID 20764 //
     /* 1561814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1561817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1561822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1561825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1561828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1561831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1561834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561853 */     // MIs[0] round
     /* 1561853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561856 */     // MIs[0] policy
     /* 1561856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561866 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1561869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561875 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561890 */     // GIR_Coverage, 20764,
     /* 1561890 */     GIR_EraseRootFromParent_Done,
     /* 1561891 */   // Label 21647: @1561891
     /* 1561891 */   GIM_Try, /*On fail goto*//*Label 21648*/ GIMT_Encode4(1561973), // Rule ID 20765 //
     /* 1561896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1561899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1561904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1561907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1561910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1561913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1561916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561935 */     // MIs[0] round
     /* 1561935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561938 */     // MIs[0] policy
     /* 1561938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561948 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1561951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561957 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561972 */     // GIR_Coverage, 20765,
     /* 1561972 */     GIR_EraseRootFromParent_Done,
     /* 1561973 */   // Label 21648: @1561973
     /* 1561973 */   GIM_Try, /*On fail goto*//*Label 21649*/ GIMT_Encode4(1562055), // Rule ID 20768 //
     /* 1561978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1561981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1561986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1561989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1561992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1561995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562017 */     // MIs[0] round
     /* 1562017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562020 */     // MIs[0] policy
     /* 1562020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562030 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1562033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562039 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562054 */     // GIR_Coverage, 20768,
     /* 1562054 */     GIR_EraseRootFromParent_Done,
     /* 1562055 */   // Label 21649: @1562055
     /* 1562055 */   GIM_Try, /*On fail goto*//*Label 21650*/ GIMT_Encode4(1562137), // Rule ID 20769 //
     /* 1562060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1562068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1562071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1562074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1562077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1562080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562099 */     // MIs[0] round
     /* 1562099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562102 */     // MIs[0] policy
     /* 1562102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562112 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1562115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562136 */     // GIR_Coverage, 20769,
     /* 1562136 */     GIR_EraseRootFromParent_Done,
     /* 1562137 */   // Label 21650: @1562137
     /* 1562137 */   GIM_Try, /*On fail goto*//*Label 21651*/ GIMT_Encode4(1562219), // Rule ID 20772 //
     /* 1562142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1562150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1562153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1562156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1562159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1562162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562181 */     // MIs[0] round
     /* 1562181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562184 */     // MIs[0] policy
     /* 1562184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562194 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1562197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562203 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562218 */     // GIR_Coverage, 20772,
     /* 1562218 */     GIR_EraseRootFromParent_Done,
     /* 1562219 */   // Label 21651: @1562219
     /* 1562219 */   GIM_Try, /*On fail goto*//*Label 21652*/ GIMT_Encode4(1562301), // Rule ID 20773 //
     /* 1562224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1562232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1562235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1562238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1562241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1562244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562263 */     // MIs[0] round
     /* 1562263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562266 */     // MIs[0] policy
     /* 1562266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562276 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1562279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562300 */     // GIR_Coverage, 20773,
     /* 1562300 */     GIR_EraseRootFromParent_Done,
     /* 1562301 */   // Label 21652: @1562301
     /* 1562301 */   GIM_Try, /*On fail goto*//*Label 21653*/ GIMT_Encode4(1562383), // Rule ID 20776 //
     /* 1562306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1562314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1562317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1562320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1562323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1562326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562345 */     // MIs[0] round
     /* 1562345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562348 */     // MIs[0] policy
     /* 1562348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562358 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1562361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562382 */     // GIR_Coverage, 20776,
     /* 1562382 */     GIR_EraseRootFromParent_Done,
     /* 1562383 */   // Label 21653: @1562383
     /* 1562383 */   GIM_Try, /*On fail goto*//*Label 21654*/ GIMT_Encode4(1562465), // Rule ID 20777 //
     /* 1562388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1562396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1562399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1562402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1562405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1562408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562427 */     // MIs[0] round
     /* 1562427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562430 */     // MIs[0] policy
     /* 1562430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562440 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1562443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562464 */     // GIR_Coverage, 20777,
     /* 1562464 */     GIR_EraseRootFromParent_Done,
     /* 1562465 */   // Label 21654: @1562465
     /* 1562465 */   GIM_Try, /*On fail goto*//*Label 21655*/ GIMT_Encode4(1562547), // Rule ID 20780 //
     /* 1562470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1562473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1562478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1562481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1562484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1562487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562509 */     // MIs[0] round
     /* 1562509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562512 */     // MIs[0] policy
     /* 1562512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562522 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1562525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562531 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562546 */     // GIR_Coverage, 20780,
     /* 1562546 */     GIR_EraseRootFromParent_Done,
     /* 1562547 */   // Label 21655: @1562547
     /* 1562547 */   GIM_Try, /*On fail goto*//*Label 21656*/ GIMT_Encode4(1562629), // Rule ID 20781 //
     /* 1562552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1562555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1562560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1562563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1562566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1562569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562591 */     // MIs[0] round
     /* 1562591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562594 */     // MIs[0] policy
     /* 1562594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1562607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562628 */     // GIR_Coverage, 20781,
     /* 1562628 */     GIR_EraseRootFromParent_Done,
     /* 1562629 */   // Label 21656: @1562629
     /* 1562629 */   GIM_Try, /*On fail goto*//*Label 21657*/ GIMT_Encode4(1562711), // Rule ID 20784 //
     /* 1562634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1562637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1562642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1562645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1562648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1562651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1562654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562673 */     // MIs[0] round
     /* 1562673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562676 */     // MIs[0] policy
     /* 1562676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1562689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562710 */     // GIR_Coverage, 20784,
     /* 1562710 */     GIR_EraseRootFromParent_Done,
     /* 1562711 */   // Label 21657: @1562711
     /* 1562711 */   GIM_Try, /*On fail goto*//*Label 21658*/ GIMT_Encode4(1562793), // Rule ID 20785 //
     /* 1562716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1562719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1562724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1562727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1562730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1562733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1562736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562755 */     // MIs[0] round
     /* 1562755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562758 */     // MIs[0] policy
     /* 1562758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1562771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562792 */     // GIR_Coverage, 20785,
     /* 1562792 */     GIR_EraseRootFromParent_Done,
     /* 1562793 */   // Label 21658: @1562793
     /* 1562793 */   GIM_Try, /*On fail goto*//*Label 21659*/ GIMT_Encode4(1562875), // Rule ID 20788 //
     /* 1562798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1562801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1562806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1562809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1562812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1562815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1562818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562837 */     // MIs[0] round
     /* 1562837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562840 */     // MIs[0] policy
     /* 1562840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562850 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1562853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562874 */     // GIR_Coverage, 20788,
     /* 1562874 */     GIR_EraseRootFromParent_Done,
     /* 1562875 */   // Label 21659: @1562875
     /* 1562875 */   GIM_Try, /*On fail goto*//*Label 21660*/ GIMT_Encode4(1562957), // Rule ID 20789 //
     /* 1562880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1562883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1562888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1562891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1562894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1562897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1562900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562919 */     // MIs[0] round
     /* 1562919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562922 */     // MIs[0] policy
     /* 1562922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562932 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1562935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562956 */     // GIR_Coverage, 20789,
     /* 1562956 */     GIR_EraseRootFromParent_Done,
     /* 1562957 */   // Label 21660: @1562957
     /* 1562957 */   GIM_Try, /*On fail goto*//*Label 21661*/ GIMT_Encode4(1563039), // Rule ID 20792 //
     /* 1562962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1562965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1562970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1562973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1562976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1562979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563001 */     // MIs[0] round
     /* 1563001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563004 */     // MIs[0] policy
     /* 1563004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1563017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563038 */     // GIR_Coverage, 20792,
     /* 1563038 */     GIR_EraseRootFromParent_Done,
     /* 1563039 */   // Label 21661: @1563039
     /* 1563039 */   GIM_Try, /*On fail goto*//*Label 21662*/ GIMT_Encode4(1563121), // Rule ID 20793 //
     /* 1563044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1563047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1563052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1563055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1563058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1563061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1563064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563083 */     // MIs[0] round
     /* 1563083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563086 */     // MIs[0] policy
     /* 1563086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563096 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1563099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563120 */     // GIR_Coverage, 20793,
     /* 1563120 */     GIR_EraseRootFromParent_Done,
     /* 1563121 */   // Label 21662: @1563121
     /* 1563121 */   GIM_Try, /*On fail goto*//*Label 21663*/ GIMT_Encode4(1563203), // Rule ID 20796 //
     /* 1563126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1563129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1563134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1563137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1563140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1563143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563165 */     // MIs[0] round
     /* 1563165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563168 */     // MIs[0] policy
     /* 1563168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563178 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1563181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563187 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563202 */     // GIR_Coverage, 20796,
     /* 1563202 */     GIR_EraseRootFromParent_Done,
     /* 1563203 */   // Label 21663: @1563203
     /* 1563203 */   GIM_Try, /*On fail goto*//*Label 21664*/ GIMT_Encode4(1563285), // Rule ID 20797 //
     /* 1563208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1563211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1563216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1563219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1563222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1563225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563247 */     // MIs[0] round
     /* 1563247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563250 */     // MIs[0] policy
     /* 1563250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563260 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1563263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563284 */     // GIR_Coverage, 20797,
     /* 1563284 */     GIR_EraseRootFromParent_Done,
     /* 1563285 */   // Label 21664: @1563285
     /* 1563285 */   GIM_Try, /*On fail goto*//*Label 21665*/ GIMT_Encode4(1563367), // Rule ID 20800 //
     /* 1563290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1563293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1563298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1563301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1563304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1563307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563329 */     // MIs[0] round
     /* 1563329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563332 */     // MIs[0] policy
     /* 1563332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563342 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1563345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563366 */     // GIR_Coverage, 20800,
     /* 1563366 */     GIR_EraseRootFromParent_Done,
     /* 1563367 */   // Label 21665: @1563367
     /* 1563367 */   GIM_Try, /*On fail goto*//*Label 21666*/ GIMT_Encode4(1563449), // Rule ID 20801 //
     /* 1563372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1563375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1563380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1563383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1563386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1563389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563411 */     // MIs[0] round
     /* 1563411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563414 */     // MIs[0] policy
     /* 1563414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563424 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1563427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563448 */     // GIR_Coverage, 20801,
     /* 1563448 */     GIR_EraseRootFromParent_Done,
     /* 1563449 */   // Label 21666: @1563449
     /* 1563449 */   GIM_Try, /*On fail goto*//*Label 21667*/ GIMT_Encode4(1563531), // Rule ID 20804 //
     /* 1563454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1563462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1563465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1563468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1563471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1563474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563493 */     // MIs[0] round
     /* 1563493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563496 */     // MIs[0] policy
     /* 1563496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563506 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1563509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563515 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563530 */     // GIR_Coverage, 20804,
     /* 1563530 */     GIR_EraseRootFromParent_Done,
     /* 1563531 */   // Label 21667: @1563531
     /* 1563531 */   GIM_Try, /*On fail goto*//*Label 21668*/ GIMT_Encode4(1563613), // Rule ID 20805 //
     /* 1563536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1563544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1563547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1563550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1563553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1563556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563575 */     // MIs[0] round
     /* 1563575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563578 */     // MIs[0] policy
     /* 1563578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563588 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1563591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563612 */     // GIR_Coverage, 20805,
     /* 1563612 */     GIR_EraseRootFromParent_Done,
     /* 1563613 */   // Label 21668: @1563613
     /* 1563613 */   GIM_Try, /*On fail goto*//*Label 21669*/ GIMT_Encode4(1563695), // Rule ID 20808 //
     /* 1563618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1563626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1563629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1563632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1563635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1563638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563657 */     // MIs[0] round
     /* 1563657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563660 */     // MIs[0] policy
     /* 1563660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563670 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1563673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563694 */     // GIR_Coverage, 20808,
     /* 1563694 */     GIR_EraseRootFromParent_Done,
     /* 1563695 */   // Label 21669: @1563695
     /* 1563695 */   GIM_Try, /*On fail goto*//*Label 21670*/ GIMT_Encode4(1563777), // Rule ID 20809 //
     /* 1563700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1563708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1563711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1563714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1563717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1563720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563739 */     // MIs[0] round
     /* 1563739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563742 */     // MIs[0] policy
     /* 1563742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563752 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1563755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563776 */     // GIR_Coverage, 20809,
     /* 1563776 */     GIR_EraseRootFromParent_Done,
     /* 1563777 */   // Label 21670: @1563777
     /* 1563777 */   GIM_Try, /*On fail goto*//*Label 21671*/ GIMT_Encode4(1563859), // Rule ID 20812 //
     /* 1563782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1563785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1563790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1563793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1563796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1563799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1563802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563821 */     // MIs[0] round
     /* 1563821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563824 */     // MIs[0] policy
     /* 1563824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563834 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1563837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563858 */     // GIR_Coverage, 20812,
     /* 1563858 */     GIR_EraseRootFromParent_Done,
     /* 1563859 */   // Label 21671: @1563859
     /* 1563859 */   GIM_Try, /*On fail goto*//*Label 21672*/ GIMT_Encode4(1563941), // Rule ID 20813 //
     /* 1563864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1563867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1563872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1563875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1563878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1563881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1563884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563903 */     // MIs[0] round
     /* 1563903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563906 */     // MIs[0] policy
     /* 1563906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563916 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1563919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563940 */     // GIR_Coverage, 20813,
     /* 1563940 */     GIR_EraseRootFromParent_Done,
     /* 1563941 */   // Label 21672: @1563941
     /* 1563941 */   GIM_Try, /*On fail goto*//*Label 21673*/ GIMT_Encode4(1564023), // Rule ID 20816 //
     /* 1563946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1563954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1563957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1563960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1563963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563985 */     // MIs[0] round
     /* 1563985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563988 */     // MIs[0] policy
     /* 1563988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563998 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1564001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564022 */     // GIR_Coverage, 20816,
     /* 1564022 */     GIR_EraseRootFromParent_Done,
     /* 1564023 */   // Label 21673: @1564023
     /* 1564023 */   GIM_Try, /*On fail goto*//*Label 21674*/ GIMT_Encode4(1564105), // Rule ID 20817 //
     /* 1564028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1564031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1564036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1564039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1564042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1564045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564067 */     // MIs[0] round
     /* 1564067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564070 */     // MIs[0] policy
     /* 1564070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564080 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1564083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564104 */     // GIR_Coverage, 20817,
     /* 1564104 */     GIR_EraseRootFromParent_Done,
     /* 1564105 */   // Label 21674: @1564105
     /* 1564105 */   GIM_Try, /*On fail goto*//*Label 21675*/ GIMT_Encode4(1564187), // Rule ID 20820 //
     /* 1564110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1564118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1564121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1564124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1564127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564149 */     // MIs[0] round
     /* 1564149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564152 */     // MIs[0] policy
     /* 1564152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564162 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1564165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564171 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564186 */     // GIR_Coverage, 20820,
     /* 1564186 */     GIR_EraseRootFromParent_Done,
     /* 1564187 */   // Label 21675: @1564187
     /* 1564187 */   GIM_Try, /*On fail goto*//*Label 21676*/ GIMT_Encode4(1564269), // Rule ID 20821 //
     /* 1564192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1564200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1564203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1564206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1564209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564231 */     // MIs[0] round
     /* 1564231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564234 */     // MIs[0] policy
     /* 1564234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564244 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1564247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564268 */     // GIR_Coverage, 20821,
     /* 1564268 */     GIR_EraseRootFromParent_Done,
     /* 1564269 */   // Label 21676: @1564269
     /* 1564269 */   GIM_Try, /*On fail goto*//*Label 21677*/ GIMT_Encode4(1564351), // Rule ID 20824 //
     /* 1564274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1564282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1564285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1564288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1564291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564313 */     // MIs[0] round
     /* 1564313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564316 */     // MIs[0] policy
     /* 1564316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564326 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1564329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564350 */     // GIR_Coverage, 20824,
     /* 1564350 */     GIR_EraseRootFromParent_Done,
     /* 1564351 */   // Label 21677: @1564351
     /* 1564351 */   GIM_Try, /*On fail goto*//*Label 21678*/ GIMT_Encode4(1564433), // Rule ID 20825 //
     /* 1564356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1564364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1564367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1564370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1564373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564395 */     // MIs[0] round
     /* 1564395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564398 */     // MIs[0] policy
     /* 1564398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1564411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564432 */     // GIR_Coverage, 20825,
     /* 1564432 */     GIR_EraseRootFromParent_Done,
     /* 1564433 */   // Label 21678: @1564433
     /* 1564433 */   GIM_Try, /*On fail goto*//*Label 21679*/ GIMT_Encode4(1564515), // Rule ID 20828 //
     /* 1564438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1564441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1564446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1564449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1564452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1564455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564477 */     // MIs[0] round
     /* 1564477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564480 */     // MIs[0] policy
     /* 1564480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1564493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564499 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564514 */     // GIR_Coverage, 20828,
     /* 1564514 */     GIR_EraseRootFromParent_Done,
     /* 1564515 */   // Label 21679: @1564515
     /* 1564515 */   GIM_Try, /*On fail goto*//*Label 21680*/ GIMT_Encode4(1564597), // Rule ID 20829 //
     /* 1564520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1564523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1564528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1564531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1564534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1564537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564559 */     // MIs[0] round
     /* 1564559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564562 */     // MIs[0] policy
     /* 1564562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564572 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1564575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564581 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564596 */     // GIR_Coverage, 20829,
     /* 1564596 */     GIR_EraseRootFromParent_Done,
     /* 1564597 */   // Label 21680: @1564597
     /* 1564597 */   GIM_Try, /*On fail goto*//*Label 21681*/ GIMT_Encode4(1564679), // Rule ID 20832 //
     /* 1564602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1564605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1564610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1564613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1564616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1564619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1564622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564641 */     // MIs[0] round
     /* 1564641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564644 */     // MIs[0] policy
     /* 1564644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564654 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1564657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564678 */     // GIR_Coverage, 20832,
     /* 1564678 */     GIR_EraseRootFromParent_Done,
     /* 1564679 */   // Label 21681: @1564679
     /* 1564679 */   GIM_Try, /*On fail goto*//*Label 21682*/ GIMT_Encode4(1564761), // Rule ID 20833 //
     /* 1564684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1564687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1564692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1564695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1564698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1564701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1564704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564723 */     // MIs[0] round
     /* 1564723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564726 */     // MIs[0] policy
     /* 1564726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564736 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1564739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564760 */     // GIR_Coverage, 20833,
     /* 1564760 */     GIR_EraseRootFromParent_Done,
     /* 1564761 */   // Label 21682: @1564761
     /* 1564761 */   GIM_Try, /*On fail goto*//*Label 21683*/ GIMT_Encode4(1564843), // Rule ID 20836 //
     /* 1564766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1564769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1564774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1564777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1564780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1564783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1564786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564805 */     // MIs[0] round
     /* 1564805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564808 */     // MIs[0] policy
     /* 1564808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564818 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1564821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564842 */     // GIR_Coverage, 20836,
     /* 1564842 */     GIR_EraseRootFromParent_Done,
     /* 1564843 */   // Label 21683: @1564843
     /* 1564843 */   GIM_Try, /*On fail goto*//*Label 21684*/ GIMT_Encode4(1564925), // Rule ID 20837 //
     /* 1564848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1564851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1564856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1564859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1564862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1564865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1564868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564887 */     // MIs[0] round
     /* 1564887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564890 */     // MIs[0] policy
     /* 1564890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564900 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1564903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564924 */     // GIR_Coverage, 20837,
     /* 1564924 */     GIR_EraseRootFromParent_Done,
     /* 1564925 */   // Label 21684: @1564925
     /* 1564925 */   GIM_Try, /*On fail goto*//*Label 21685*/ GIMT_Encode4(1565007), // Rule ID 20840 //
     /* 1564930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1564938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1564941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1564944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1564947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564969 */     // MIs[0] round
     /* 1564969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564972 */     // MIs[0] policy
     /* 1564972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1564985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565006 */     // GIR_Coverage, 20840,
     /* 1565006 */     GIR_EraseRootFromParent_Done,
     /* 1565007 */   // Label 21685: @1565007
     /* 1565007 */   GIM_Try, /*On fail goto*//*Label 21686*/ GIMT_Encode4(1565089), // Rule ID 20841 //
     /* 1565012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1565015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1565020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1565023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1565026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1565029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565051 */     // MIs[0] round
     /* 1565051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565054 */     // MIs[0] policy
     /* 1565054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1565067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565088 */     // GIR_Coverage, 20841,
     /* 1565088 */     GIR_EraseRootFromParent_Done,
     /* 1565089 */   // Label 21686: @1565089
     /* 1565089 */   GIM_Try, /*On fail goto*//*Label 21687*/ GIMT_Encode4(1565171), // Rule ID 20844 //
     /* 1565094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1565097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1565102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1565105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1565108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1565111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1565114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565133 */     // MIs[0] round
     /* 1565133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565136 */     // MIs[0] policy
     /* 1565136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1565149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565155 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565170 */     // GIR_Coverage, 20844,
     /* 1565170 */     GIR_EraseRootFromParent_Done,
     /* 1565171 */   // Label 21687: @1565171
     /* 1565171 */   GIM_Try, /*On fail goto*//*Label 21688*/ GIMT_Encode4(1565253), // Rule ID 20845 //
     /* 1565176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1565179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1565184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1565187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1565190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1565193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1565196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565215 */     // MIs[0] round
     /* 1565215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565218 */     // MIs[0] policy
     /* 1565218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565228 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1565231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565252 */     // GIR_Coverage, 20845,
     /* 1565252 */     GIR_EraseRootFromParent_Done,
     /* 1565253 */   // Label 21688: @1565253
     /* 1565253 */   GIM_Try, /*On fail goto*//*Label 21689*/ GIMT_Encode4(1565335), // Rule ID 20848 //
     /* 1565258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1565261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1565266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1565269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1565272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1565275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1565278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1565285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565297 */     // MIs[0] round
     /* 1565297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565300 */     // MIs[0] policy
     /* 1565300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565310 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1565313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565334 */     // GIR_Coverage, 20848,
     /* 1565334 */     GIR_EraseRootFromParent_Done,
     /* 1565335 */   // Label 21689: @1565335
     /* 1565335 */   GIM_Try, /*On fail goto*//*Label 21690*/ GIMT_Encode4(1565417), // Rule ID 20849 //
     /* 1565340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1565343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1565348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1565351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1565354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1565357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1565360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1565367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565379 */     // MIs[0] round
     /* 1565379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565382 */     // MIs[0] policy
     /* 1565382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565392 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1565395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565416 */     // GIR_Coverage, 20849,
     /* 1565416 */     GIR_EraseRootFromParent_Done,
     /* 1565417 */   // Label 21690: @1565417
     /* 1565417 */   GIM_Try, /*On fail goto*//*Label 21691*/ GIMT_Encode4(1565499), // Rule ID 20852 //
     /* 1565422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1565425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1565430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1565433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1565436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1565439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565461 */     // MIs[0] round
     /* 1565461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565464 */     // MIs[0] policy
     /* 1565464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565474 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1565477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565498 */     // GIR_Coverage, 20852,
     /* 1565498 */     GIR_EraseRootFromParent_Done,
     /* 1565499 */   // Label 21691: @1565499
     /* 1565499 */   GIM_Try, /*On fail goto*//*Label 21692*/ GIMT_Encode4(1565581), // Rule ID 20853 //
     /* 1565504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1565507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1565512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1565515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1565518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1565521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565543 */     // MIs[0] round
     /* 1565543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565546 */     // MIs[0] policy
     /* 1565546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1565559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565565 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565580 */     // GIR_Coverage, 20853,
     /* 1565580 */     GIR_EraseRootFromParent_Done,
     /* 1565581 */   // Label 21692: @1565581
     /* 1565581 */   GIM_Try, /*On fail goto*//*Label 21693*/ GIMT_Encode4(1565663), // Rule ID 20856 //
     /* 1565586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1565589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1565594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1565597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1565600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1565603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565625 */     // MIs[0] round
     /* 1565625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565628 */     // MIs[0] policy
     /* 1565628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565638 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1565641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565647 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565662 */     // GIR_Coverage, 20856,
     /* 1565662 */     GIR_EraseRootFromParent_Done,
     /* 1565663 */   // Label 21693: @1565663
     /* 1565663 */   GIM_Try, /*On fail goto*//*Label 21694*/ GIMT_Encode4(1565745), // Rule ID 20857 //
     /* 1565668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1565671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1565676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1565679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1565682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1565685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565707 */     // MIs[0] round
     /* 1565707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565710 */     // MIs[0] policy
     /* 1565710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1565723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565744 */     // GIR_Coverage, 20857,
     /* 1565744 */     GIR_EraseRootFromParent_Done,
     /* 1565745 */   // Label 21694: @1565745
     /* 1565745 */   GIM_Try, /*On fail goto*//*Label 21695*/ GIMT_Encode4(1565827), // Rule ID 20860 //
     /* 1565750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1565753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1565758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1565761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1565764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1565767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1565770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1565777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565789 */     // MIs[0] round
     /* 1565789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565792 */     // MIs[0] policy
     /* 1565792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565802 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1565805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565826 */     // GIR_Coverage, 20860,
     /* 1565826 */     GIR_EraseRootFromParent_Done,
     /* 1565827 */   // Label 21695: @1565827
     /* 1565827 */   GIM_Try, /*On fail goto*//*Label 21696*/ GIMT_Encode4(1565909), // Rule ID 20861 //
     /* 1565832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1565835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1565840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1565843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1565846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1565849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1565852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1565859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565871 */     // MIs[0] round
     /* 1565871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565874 */     // MIs[0] policy
     /* 1565874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565884 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1565887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565908 */     // GIR_Coverage, 20861,
     /* 1565908 */     GIR_EraseRootFromParent_Done,
     /* 1565909 */   // Label 21696: @1565909
     /* 1565909 */   GIM_Try, /*On fail goto*//*Label 21697*/ GIMT_Encode4(1565991), // Rule ID 20984 //
     /* 1565914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1565922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1565925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1565928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1565931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565953 */     // MIs[0] round
     /* 1565953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565956 */     // MIs[0] policy
     /* 1565956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565966 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1565969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565990 */     // GIR_Coverage, 20984,
     /* 1565990 */     GIR_EraseRootFromParent_Done,
     /* 1565991 */   // Label 21697: @1565991
     /* 1565991 */   GIM_Try, /*On fail goto*//*Label 21698*/ GIMT_Encode4(1566073), // Rule ID 20985 //
     /* 1565996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1566004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1566007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1566010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1566013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1566016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566035 */     // MIs[0] round
     /* 1566035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566038 */     // MIs[0] policy
     /* 1566038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566048 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1566051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566072 */     // GIR_Coverage, 20985,
     /* 1566072 */     GIR_EraseRootFromParent_Done,
     /* 1566073 */   // Label 21698: @1566073
     /* 1566073 */   GIM_Try, /*On fail goto*//*Label 21699*/ GIMT_Encode4(1566155), // Rule ID 20988 //
     /* 1566078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1566086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1566089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1566092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1566095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566117 */     // MIs[0] round
     /* 1566117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566120 */     // MIs[0] policy
     /* 1566120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566130 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1566133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566154 */     // GIR_Coverage, 20988,
     /* 1566154 */     GIR_EraseRootFromParent_Done,
     /* 1566155 */   // Label 21699: @1566155
     /* 1566155 */   GIM_Try, /*On fail goto*//*Label 21700*/ GIMT_Encode4(1566237), // Rule ID 20989 //
     /* 1566160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1566168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1566171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1566174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1566177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566199 */     // MIs[0] round
     /* 1566199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566202 */     // MIs[0] policy
     /* 1566202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566212 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1566215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566236 */     // GIR_Coverage, 20989,
     /* 1566236 */     GIR_EraseRootFromParent_Done,
     /* 1566237 */   // Label 21700: @1566237
     /* 1566237 */   GIM_Try, /*On fail goto*//*Label 21701*/ GIMT_Encode4(1566319), // Rule ID 20992 //
     /* 1566242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1566250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1566253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1566256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1566259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1566262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566281 */     // MIs[0] round
     /* 1566281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566284 */     // MIs[0] policy
     /* 1566284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566294 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1566297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566318 */     // GIR_Coverage, 20992,
     /* 1566318 */     GIR_EraseRootFromParent_Done,
     /* 1566319 */   // Label 21701: @1566319
     /* 1566319 */   GIM_Try, /*On fail goto*//*Label 21702*/ GIMT_Encode4(1566401), // Rule ID 20993 //
     /* 1566324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1566332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1566335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1566338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1566341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1566344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566363 */     // MIs[0] round
     /* 1566363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566366 */     // MIs[0] policy
     /* 1566366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566376 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1566379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566400 */     // GIR_Coverage, 20993,
     /* 1566400 */     GIR_EraseRootFromParent_Done,
     /* 1566401 */   // Label 21702: @1566401
     /* 1566401 */   GIM_Try, /*On fail goto*//*Label 21703*/ GIMT_Encode4(1566483), // Rule ID 20996 //
     /* 1566406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1566414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1566417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1566420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1566423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566445 */     // MIs[0] round
     /* 1566445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566448 */     // MIs[0] policy
     /* 1566448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566458 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1566461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566482 */     // GIR_Coverage, 20996,
     /* 1566482 */     GIR_EraseRootFromParent_Done,
     /* 1566483 */   // Label 21703: @1566483
     /* 1566483 */   GIM_Try, /*On fail goto*//*Label 21704*/ GIMT_Encode4(1566565), // Rule ID 20997 //
     /* 1566488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1566496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1566499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1566502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1566505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566527 */     // MIs[0] round
     /* 1566527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566530 */     // MIs[0] policy
     /* 1566530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566540 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1566543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566564 */     // GIR_Coverage, 20997,
     /* 1566564 */     GIR_EraseRootFromParent_Done,
     /* 1566565 */   // Label 21704: @1566565
     /* 1566565 */   GIM_Try, /*On fail goto*//*Label 21705*/ GIMT_Encode4(1566647), // Rule ID 21000 //
     /* 1566570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1566578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1566581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1566584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1566587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566609 */     // MIs[0] round
     /* 1566609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566612 */     // MIs[0] policy
     /* 1566612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566622 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1566625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566646 */     // GIR_Coverage, 21000,
     /* 1566646 */     GIR_EraseRootFromParent_Done,
     /* 1566647 */   // Label 21705: @1566647
     /* 1566647 */   GIM_Try, /*On fail goto*//*Label 21706*/ GIMT_Encode4(1566729), // Rule ID 21001 //
     /* 1566652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1566660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1566663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1566666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1566669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566691 */     // MIs[0] round
     /* 1566691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566694 */     // MIs[0] policy
     /* 1566694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566704 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1566707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566728 */     // GIR_Coverage, 21001,
     /* 1566728 */     GIR_EraseRootFromParent_Done,
     /* 1566729 */   // Label 21706: @1566729
     /* 1566729 */   GIM_Try, /*On fail goto*//*Label 21707*/ GIMT_Encode4(1566811), // Rule ID 21004 //
     /* 1566734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1566737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1566742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1566745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1566748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1566751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1566754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566773 */     // MIs[0] round
     /* 1566773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566776 */     // MIs[0] policy
     /* 1566776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566786 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1566789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566795 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566810 */     // GIR_Coverage, 21004,
     /* 1566810 */     GIR_EraseRootFromParent_Done,
     /* 1566811 */   // Label 21707: @1566811
     /* 1566811 */   GIM_Try, /*On fail goto*//*Label 21708*/ GIMT_Encode4(1566893), // Rule ID 21005 //
     /* 1566816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1566819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1566824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1566827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1566830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1566833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1566836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566855 */     // MIs[0] round
     /* 1566855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566858 */     // MIs[0] policy
     /* 1566858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566868 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1566871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566892 */     // GIR_Coverage, 21005,
     /* 1566892 */     GIR_EraseRootFromParent_Done,
     /* 1566893 */   // Label 21708: @1566893
     /* 1566893 */   GIM_Try, /*On fail goto*//*Label 21709*/ GIMT_Encode4(1566975), // Rule ID 21008 //
     /* 1566898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1566906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1566909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1566912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1566915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566937 */     // MIs[0] round
     /* 1566937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566940 */     // MIs[0] policy
     /* 1566940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566950 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1566953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566974 */     // GIR_Coverage, 21008,
     /* 1566974 */     GIR_EraseRootFromParent_Done,
     /* 1566975 */   // Label 21709: @1566975
     /* 1566975 */   GIM_Try, /*On fail goto*//*Label 21710*/ GIMT_Encode4(1567057), // Rule ID 21009 //
     /* 1566980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1566988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1566991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1566994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1566997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567019 */     // MIs[0] round
     /* 1567019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567022 */     // MIs[0] policy
     /* 1567022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567032 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1567035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567056 */     // GIR_Coverage, 21009,
     /* 1567056 */     GIR_EraseRootFromParent_Done,
     /* 1567057 */   // Label 21710: @1567057
     /* 1567057 */   GIM_Try, /*On fail goto*//*Label 21711*/ GIMT_Encode4(1567139), // Rule ID 21012 //
     /* 1567062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1567070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1567073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1567076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1567079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1567082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567101 */     // MIs[0] round
     /* 1567101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567104 */     // MIs[0] policy
     /* 1567104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567114 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1567117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567138 */     // GIR_Coverage, 21012,
     /* 1567138 */     GIR_EraseRootFromParent_Done,
     /* 1567139 */   // Label 21711: @1567139
     /* 1567139 */   GIM_Try, /*On fail goto*//*Label 21712*/ GIMT_Encode4(1567221), // Rule ID 21013 //
     /* 1567144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1567152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1567155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1567158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1567161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1567164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567183 */     // MIs[0] round
     /* 1567183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567186 */     // MIs[0] policy
     /* 1567186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567196 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1567199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567220 */     // GIR_Coverage, 21013,
     /* 1567220 */     GIR_EraseRootFromParent_Done,
     /* 1567221 */   // Label 21712: @1567221
     /* 1567221 */   GIM_Try, /*On fail goto*//*Label 21713*/ GIMT_Encode4(1567303), // Rule ID 21016 //
     /* 1567226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1567234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1567237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1567240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1567243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1567246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567265 */     // MIs[0] round
     /* 1567265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567268 */     // MIs[0] policy
     /* 1567268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567278 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1567281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567302 */     // GIR_Coverage, 21016,
     /* 1567302 */     GIR_EraseRootFromParent_Done,
     /* 1567303 */   // Label 21713: @1567303
     /* 1567303 */   GIM_Try, /*On fail goto*//*Label 21714*/ GIMT_Encode4(1567385), // Rule ID 21017 //
     /* 1567308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1567316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1567319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1567322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1567325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1567328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567347 */     // MIs[0] round
     /* 1567347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567350 */     // MIs[0] policy
     /* 1567350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567360 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1567363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567384 */     // GIR_Coverage, 21017,
     /* 1567384 */     GIR_EraseRootFromParent_Done,
     /* 1567385 */   // Label 21714: @1567385
     /* 1567385 */   GIM_Try, /*On fail goto*//*Label 21715*/ GIMT_Encode4(1567467), // Rule ID 21020 //
     /* 1567390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1567393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1567398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1567401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1567404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1567407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567429 */     // MIs[0] round
     /* 1567429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567432 */     // MIs[0] policy
     /* 1567432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567442 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1567445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567466 */     // GIR_Coverage, 21020,
     /* 1567466 */     GIR_EraseRootFromParent_Done,
     /* 1567467 */   // Label 21715: @1567467
     /* 1567467 */   GIM_Try, /*On fail goto*//*Label 21716*/ GIMT_Encode4(1567549), // Rule ID 21021 //
     /* 1567472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1567475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1567480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1567483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1567486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1567489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567511 */     // MIs[0] round
     /* 1567511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567514 */     // MIs[0] policy
     /* 1567514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567524 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1567527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567548 */     // GIR_Coverage, 21021,
     /* 1567548 */     GIR_EraseRootFromParent_Done,
     /* 1567549 */   // Label 21716: @1567549
     /* 1567549 */   GIM_Try, /*On fail goto*//*Label 21717*/ GIMT_Encode4(1567631), // Rule ID 21024 //
     /* 1567554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1567557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1567562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1567565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1567568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1567571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567593 */     // MIs[0] round
     /* 1567593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567596 */     // MIs[0] policy
     /* 1567596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567606 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1567609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567630 */     // GIR_Coverage, 21024,
     /* 1567630 */     GIR_EraseRootFromParent_Done,
     /* 1567631 */   // Label 21717: @1567631
     /* 1567631 */   GIM_Try, /*On fail goto*//*Label 21718*/ GIMT_Encode4(1567713), // Rule ID 21025 //
     /* 1567636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1567639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1567644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1567647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1567650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1567653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567675 */     // MIs[0] round
     /* 1567675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567678 */     // MIs[0] policy
     /* 1567678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567688 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1567691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567712 */     // GIR_Coverage, 21025,
     /* 1567712 */     GIR_EraseRootFromParent_Done,
     /* 1567713 */   // Label 21718: @1567713
     /* 1567713 */   GIM_Try, /*On fail goto*//*Label 21719*/ GIMT_Encode4(1567795), // Rule ID 21028 //
     /* 1567718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1567721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1567726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1567729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1567732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1567735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1567738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567757 */     // MIs[0] round
     /* 1567757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567760 */     // MIs[0] policy
     /* 1567760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567770 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1567773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567794 */     // GIR_Coverage, 21028,
     /* 1567794 */     GIR_EraseRootFromParent_Done,
     /* 1567795 */   // Label 21719: @1567795
     /* 1567795 */   GIM_Try, /*On fail goto*//*Label 21720*/ GIMT_Encode4(1567877), // Rule ID 21029 //
     /* 1567800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1567803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1567808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1567811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1567814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1567817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1567820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567839 */     // MIs[0] round
     /* 1567839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567842 */     // MIs[0] policy
     /* 1567842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567852 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1567855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567876 */     // GIR_Coverage, 21029,
     /* 1567876 */     GIR_EraseRootFromParent_Done,
     /* 1567877 */   // Label 21720: @1567877
     /* 1567877 */   GIM_Try, /*On fail goto*//*Label 21721*/ GIMT_Encode4(1567959), // Rule ID 21032 //
     /* 1567882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1567885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1567890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1567893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1567896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1567899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567921 */     // MIs[0] round
     /* 1567921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567924 */     // MIs[0] policy
     /* 1567924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567934 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1567937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567958 */     // GIR_Coverage, 21032,
     /* 1567958 */     GIR_EraseRootFromParent_Done,
     /* 1567959 */   // Label 21721: @1567959
     /* 1567959 */   GIM_Try, /*On fail goto*//*Label 21722*/ GIMT_Encode4(1568041), // Rule ID 21033 //
     /* 1567964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1567967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1567972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1567975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1567978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1567981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568003 */     // MIs[0] round
     /* 1568003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568006 */     // MIs[0] policy
     /* 1568006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568016 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1568019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1568037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568040 */     // GIR_Coverage, 21033,
     /* 1568040 */     GIR_EraseRootFromParent_Done,
     /* 1568041 */   // Label 21722: @1568041
     /* 1568041 */   GIM_Try, /*On fail goto*//*Label 21723*/ GIMT_Encode4(1568123), // Rule ID 21036 //
     /* 1568046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1568049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1568054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1568057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1568060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1568063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568085 */     // MIs[0] round
     /* 1568085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568088 */     // MIs[0] policy
     /* 1568088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568098 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1568101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1568119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568122 */     // GIR_Coverage, 21036,
     /* 1568122 */     GIR_EraseRootFromParent_Done,
     /* 1568123 */   // Label 21723: @1568123
     /* 1568123 */   GIM_Try, /*On fail goto*//*Label 21724*/ GIMT_Encode4(1568205), // Rule ID 21037 //
     /* 1568128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1568131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1568136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1568139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1568142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1568145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568167 */     // MIs[0] round
     /* 1568167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568170 */     // MIs[0] policy
     /* 1568170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568180 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1568183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1568201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568204 */     // GIR_Coverage, 21037,
     /* 1568204 */     GIR_EraseRootFromParent_Done,
     /* 1568205 */   // Label 21724: @1568205
     /* 1568205 */   GIM_Try, /*On fail goto*//*Label 21725*/ GIMT_Encode4(1568287), // Rule ID 21040 //
     /* 1568210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1568213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1568218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1568221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1568224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1568227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568249 */     // MIs[0] round
     /* 1568249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568252 */     // MIs[0] policy
     /* 1568252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568262 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1568265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568271 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1568283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568286 */     // GIR_Coverage, 21040,
     /* 1568286 */     GIR_EraseRootFromParent_Done,
     /* 1568287 */   // Label 21725: @1568287
     /* 1568287 */   GIM_Try, /*On fail goto*//*Label 21726*/ GIMT_Encode4(1568369), // Rule ID 21041 //
     /* 1568292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1568295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1568300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1568303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1568306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1568309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568331 */     // MIs[0] round
     /* 1568331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568334 */     // MIs[0] policy
     /* 1568334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568344 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1568347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1568365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568368 */     // GIR_Coverage, 21041,
     /* 1568368 */     GIR_EraseRootFromParent_Done,
     /* 1568369 */   // Label 21726: @1568369
     /* 1568369 */   GIM_Try, /*On fail goto*//*Label 21727*/ GIMT_Encode4(1568451), // Rule ID 21044 //
     /* 1568374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1568382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1568385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1568388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1568391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568413 */     // MIs[0] round
     /* 1568413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568416 */     // MIs[0] policy
     /* 1568416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568426 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1568429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568450 */     // GIR_Coverage, 21044,
     /* 1568450 */     GIR_EraseRootFromParent_Done,
     /* 1568451 */   // Label 21727: @1568451
     /* 1568451 */   GIM_Try, /*On fail goto*//*Label 21728*/ GIMT_Encode4(1568533), // Rule ID 21045 //
     /* 1568456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1568464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1568467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1568470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1568473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568495 */     // MIs[0] round
     /* 1568495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568498 */     // MIs[0] policy
     /* 1568498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568508 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1568511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568532 */     // GIR_Coverage, 21045,
     /* 1568532 */     GIR_EraseRootFromParent_Done,
     /* 1568533 */   // Label 21728: @1568533
     /* 1568533 */   GIM_Try, /*On fail goto*//*Label 21729*/ GIMT_Encode4(1568615), // Rule ID 21048 //
     /* 1568538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1568546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1568549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1568552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1568555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568577 */     // MIs[0] round
     /* 1568577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568580 */     // MIs[0] policy
     /* 1568580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568590 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1568593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568614 */     // GIR_Coverage, 21048,
     /* 1568614 */     GIR_EraseRootFromParent_Done,
     /* 1568615 */   // Label 21729: @1568615
     /* 1568615 */   GIM_Try, /*On fail goto*//*Label 21730*/ GIMT_Encode4(1568697), // Rule ID 21049 //
     /* 1568620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1568628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1568631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1568634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1568637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568659 */     // MIs[0] round
     /* 1568659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568662 */     // MIs[0] policy
     /* 1568662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568672 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1568675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568696 */     // GIR_Coverage, 21049,
     /* 1568696 */     GIR_EraseRootFromParent_Done,
     /* 1568697 */   // Label 21730: @1568697
     /* 1568697 */   GIM_Try, /*On fail goto*//*Label 21731*/ GIMT_Encode4(1568779), // Rule ID 21052 //
     /* 1568702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1568705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1568710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1568713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1568716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1568719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568741 */     // MIs[0] round
     /* 1568741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568744 */     // MIs[0] policy
     /* 1568744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568754 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1568757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568778 */     // GIR_Coverage, 21052,
     /* 1568778 */     GIR_EraseRootFromParent_Done,
     /* 1568779 */   // Label 21731: @1568779
     /* 1568779 */   GIM_Try, /*On fail goto*//*Label 21732*/ GIMT_Encode4(1568861), // Rule ID 21053 //
     /* 1568784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1568787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1568792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1568795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1568798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1568801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568823 */     // MIs[0] round
     /* 1568823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568826 */     // MIs[0] policy
     /* 1568826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568836 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1568839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568860 */     // GIR_Coverage, 21053,
     /* 1568860 */     GIR_EraseRootFromParent_Done,
     /* 1568861 */   // Label 21732: @1568861
     /* 1568861 */   GIM_Try, /*On fail goto*//*Label 21733*/ GIMT_Encode4(1568943), // Rule ID 21056 //
     /* 1568866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1568874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1568877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1568880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1568883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568905 */     // MIs[0] round
     /* 1568905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568908 */     // MIs[0] policy
     /* 1568908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568918 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1568921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568942 */     // GIR_Coverage, 21056,
     /* 1568942 */     GIR_EraseRootFromParent_Done,
     /* 1568943 */   // Label 21733: @1568943
     /* 1568943 */   GIM_Try, /*On fail goto*//*Label 21734*/ GIMT_Encode4(1569025), // Rule ID 21057 //
     /* 1568948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1568956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1568959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1568962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1568965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568987 */     // MIs[0] round
     /* 1568987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568990 */     // MIs[0] policy
     /* 1568990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569000 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1569003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569024 */     // GIR_Coverage, 21057,
     /* 1569024 */     GIR_EraseRootFromParent_Done,
     /* 1569025 */   // Label 21734: @1569025
     /* 1569025 */   GIM_Try, /*On fail goto*//*Label 21735*/ GIMT_Encode4(1569107), // Rule ID 21060 //
     /* 1569030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1569033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1569038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1569041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1569044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1569047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569069 */     // MIs[0] round
     /* 1569069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569072 */     // MIs[0] policy
     /* 1569072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569082 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1569085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569106 */     // GIR_Coverage, 21060,
     /* 1569106 */     GIR_EraseRootFromParent_Done,
     /* 1569107 */   // Label 21735: @1569107
     /* 1569107 */   GIM_Try, /*On fail goto*//*Label 21736*/ GIMT_Encode4(1569189), // Rule ID 21061 //
     /* 1569112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1569115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1569120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1569123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1569126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1569129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569151 */     // MIs[0] round
     /* 1569151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569154 */     // MIs[0] policy
     /* 1569154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569164 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1569167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569188 */     // GIR_Coverage, 21061,
     /* 1569188 */     GIR_EraseRootFromParent_Done,
     /* 1569189 */   // Label 21736: @1569189
     /* 1569189 */   GIM_Try, /*On fail goto*//*Label 21737*/ GIMT_Encode4(1569271), // Rule ID 21064 //
     /* 1569194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1569197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1569202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1569205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1569208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1569211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569233 */     // MIs[0] round
     /* 1569233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569236 */     // MIs[0] policy
     /* 1569236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569246 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1569249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1569267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569270 */     // GIR_Coverage, 21064,
     /* 1569270 */     GIR_EraseRootFromParent_Done,
     /* 1569271 */   // Label 21737: @1569271
     /* 1569271 */   GIM_Try, /*On fail goto*//*Label 21738*/ GIMT_Encode4(1569353), // Rule ID 21065 //
     /* 1569276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1569279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1569284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1569287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1569290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1569293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569315 */     // MIs[0] round
     /* 1569315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569318 */     // MIs[0] policy
     /* 1569318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569328 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1569331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1569349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569352 */     // GIR_Coverage, 21065,
     /* 1569352 */     GIR_EraseRootFromParent_Done,
     /* 1569353 */   // Label 21738: @1569353
     /* 1569353 */   GIM_Try, /*On fail goto*//*Label 21739*/ GIMT_Encode4(1569435), // Rule ID 21068 //
     /* 1569358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1569366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1569369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1569372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1569375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569397 */     // MIs[0] round
     /* 1569397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569400 */     // MIs[0] policy
     /* 1569400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569410 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1569413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569419 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569434 */     // GIR_Coverage, 21068,
     /* 1569434 */     GIR_EraseRootFromParent_Done,
     /* 1569435 */   // Label 21739: @1569435
     /* 1569435 */   GIM_Try, /*On fail goto*//*Label 21740*/ GIMT_Encode4(1569517), // Rule ID 21069 //
     /* 1569440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1569448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1569451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1569454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1569457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569479 */     // MIs[0] round
     /* 1569479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569482 */     // MIs[0] policy
     /* 1569482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569492 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1569495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569501 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569516 */     // GIR_Coverage, 21069,
     /* 1569516 */     GIR_EraseRootFromParent_Done,
     /* 1569517 */   // Label 21740: @1569517
     /* 1569517 */   GIM_Try, /*On fail goto*//*Label 21741*/ GIMT_Encode4(1569599), // Rule ID 21072 //
     /* 1569522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1569530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1569533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1569536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1569539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1569542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569561 */     // MIs[0] round
     /* 1569561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569564 */     // MIs[0] policy
     /* 1569564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569574 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1569577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569598 */     // GIR_Coverage, 21072,
     /* 1569598 */     GIR_EraseRootFromParent_Done,
     /* 1569599 */   // Label 21741: @1569599
     /* 1569599 */   GIM_Try, /*On fail goto*//*Label 21742*/ GIMT_Encode4(1569681), // Rule ID 21073 //
     /* 1569604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1569612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1569615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1569618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1569621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1569624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569643 */     // MIs[0] round
     /* 1569643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569646 */     // MIs[0] policy
     /* 1569646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569656 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1569659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569680 */     // GIR_Coverage, 21073,
     /* 1569680 */     GIR_EraseRootFromParent_Done,
     /* 1569681 */   // Label 21742: @1569681
     /* 1569681 */   GIM_Try, /*On fail goto*//*Label 21743*/ GIMT_Encode4(1569763), // Rule ID 21076 //
     /* 1569686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1569694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1569697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1569700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1569703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1569706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569725 */     // MIs[0] round
     /* 1569725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569728 */     // MIs[0] policy
     /* 1569728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569738 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1569741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569762 */     // GIR_Coverage, 21076,
     /* 1569762 */     GIR_EraseRootFromParent_Done,
     /* 1569763 */   // Label 21743: @1569763
     /* 1569763 */   GIM_Try, /*On fail goto*//*Label 21744*/ GIMT_Encode4(1569845), // Rule ID 21077 //
     /* 1569768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1569776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1569779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1569782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1569785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1569788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569807 */     // MIs[0] round
     /* 1569807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569810 */     // MIs[0] policy
     /* 1569810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569820 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1569823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569844 */     // GIR_Coverage, 21077,
     /* 1569844 */     GIR_EraseRootFromParent_Done,
     /* 1569845 */   // Label 21744: @1569845
     /* 1569845 */   GIM_Try, /*On fail goto*//*Label 21745*/ GIMT_Encode4(1569927), // Rule ID 21080 //
     /* 1569850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1569853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1569858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1569861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1569864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1569867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569889 */     // MIs[0] round
     /* 1569889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569892 */     // MIs[0] policy
     /* 1569892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569902 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1569905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569926 */     // GIR_Coverage, 21080,
     /* 1569926 */     GIR_EraseRootFromParent_Done,
     /* 1569927 */   // Label 21745: @1569927
     /* 1569927 */   GIM_Try, /*On fail goto*//*Label 21746*/ GIMT_Encode4(1570009), // Rule ID 21081 //
     /* 1569932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1569935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1569940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1569943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1569946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1569949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569971 */     // MIs[0] round
     /* 1569971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569974 */     // MIs[0] policy
     /* 1569974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569984 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1569987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570008 */     // GIR_Coverage, 21081,
     /* 1570008 */     GIR_EraseRootFromParent_Done,
     /* 1570009 */   // Label 21746: @1570009
     /* 1570009 */   GIM_Try, /*On fail goto*//*Label 21747*/ GIMT_Encode4(1570091), // Rule ID 21084 //
     /* 1570014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1570017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1570022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1570025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1570028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1570031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570053 */     // MIs[0] round
     /* 1570053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570056 */     // MIs[0] policy
     /* 1570056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570066 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1570069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570090 */     // GIR_Coverage, 21084,
     /* 1570090 */     GIR_EraseRootFromParent_Done,
     /* 1570091 */   // Label 21747: @1570091
     /* 1570091 */   GIM_Try, /*On fail goto*//*Label 21748*/ GIMT_Encode4(1570173), // Rule ID 21085 //
     /* 1570096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1570099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1570104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1570107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1570110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1570113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570135 */     // MIs[0] round
     /* 1570135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570138 */     // MIs[0] policy
     /* 1570138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570148 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1570151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570172 */     // GIR_Coverage, 21085,
     /* 1570172 */     GIR_EraseRootFromParent_Done,
     /* 1570173 */   // Label 21748: @1570173
     /* 1570173 */   GIM_Try, /*On fail goto*//*Label 21749*/ GIMT_Encode4(1570255), // Rule ID 21088 //
     /* 1570178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1570181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1570186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1570189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1570192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1570195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1570198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1570205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570217 */     // MIs[0] round
     /* 1570217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570220 */     // MIs[0] policy
     /* 1570220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570230 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1570233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570254 */     // GIR_Coverage, 21088,
     /* 1570254 */     GIR_EraseRootFromParent_Done,
     /* 1570255 */   // Label 21749: @1570255
     /* 1570255 */   GIM_Try, /*On fail goto*//*Label 21750*/ GIMT_Encode4(1570337), // Rule ID 21089 //
     /* 1570260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1570263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1570268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1570271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1570274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1570277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1570280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1570287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570299 */     // MIs[0] round
     /* 1570299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570302 */     // MIs[0] policy
     /* 1570302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570312 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1570315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570336 */     // GIR_Coverage, 21089,
     /* 1570336 */     GIR_EraseRootFromParent_Done,
     /* 1570337 */   // Label 21750: @1570337
     /* 1570337 */   GIM_Try, /*On fail goto*//*Label 21751*/ GIMT_Encode4(1570419), // Rule ID 21092 //
     /* 1570342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1570345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1570350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1570353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1570356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1570359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570381 */     // MIs[0] round
     /* 1570381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570384 */     // MIs[0] policy
     /* 1570384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570394 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1570397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1570415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570418 */     // GIR_Coverage, 21092,
     /* 1570418 */     GIR_EraseRootFromParent_Done,
     /* 1570419 */   // Label 21751: @1570419
     /* 1570419 */   GIM_Try, /*On fail goto*//*Label 21752*/ GIMT_Encode4(1570501), // Rule ID 21093 //
     /* 1570424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1570427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1570432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1570435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1570438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1570441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570463 */     // MIs[0] round
     /* 1570463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570466 */     // MIs[0] policy
     /* 1570466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570476 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1570479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1570497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570500 */     // GIR_Coverage, 21093,
     /* 1570500 */     GIR_EraseRootFromParent_Done,
     /* 1570501 */   // Label 21752: @1570501
     /* 1570501 */   GIM_Try, /*On fail goto*//*Label 21753*/ GIMT_Encode4(1570583), // Rule ID 21096 //
     /* 1570506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1570509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1570514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1570517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1570520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1570523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570545 */     // MIs[0] round
     /* 1570545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570548 */     // MIs[0] policy
     /* 1570548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570558 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1570561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1570579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570582 */     // GIR_Coverage, 21096,
     /* 1570582 */     GIR_EraseRootFromParent_Done,
     /* 1570583 */   // Label 21753: @1570583
     /* 1570583 */   GIM_Try, /*On fail goto*//*Label 21754*/ GIMT_Encode4(1570665), // Rule ID 21097 //
     /* 1570588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1570591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1570596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1570599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1570602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1570605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570627 */     // MIs[0] round
     /* 1570627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570630 */     // MIs[0] policy
     /* 1570630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570640 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1570643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1570661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570664 */     // GIR_Coverage, 21097,
     /* 1570664 */     GIR_EraseRootFromParent_Done,
     /* 1570665 */   // Label 21754: @1570665
     /* 1570665 */   GIM_Try, /*On fail goto*//*Label 21755*/ GIMT_Encode4(1570747), // Rule ID 21100 //
     /* 1570670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1570673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1570678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1570681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1570684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1570687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1570697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570709 */     // MIs[0] round
     /* 1570709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570712 */     // MIs[0] policy
     /* 1570712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570722 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1570725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570731 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1570743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570746 */     // GIR_Coverage, 21100,
     /* 1570746 */     GIR_EraseRootFromParent_Done,
     /* 1570747 */   // Label 21755: @1570747
     /* 1570747 */   GIM_Try, /*On fail goto*//*Label 21756*/ GIMT_Encode4(1570829), // Rule ID 21101 //
     /* 1570752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1570755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1570760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1570763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1570766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1570769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1570779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570791 */     // MIs[0] round
     /* 1570791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570794 */     // MIs[0] policy
     /* 1570794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570804 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1570807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570813 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1570825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570828 */     // GIR_Coverage, 21101,
     /* 1570828 */     GIR_EraseRootFromParent_Done,
     /* 1570829 */   // Label 21756: @1570829
     /* 1570829 */   GIM_Try, /*On fail goto*//*Label 21757*/ GIMT_Encode4(1570911), // Rule ID 21176 //
     /* 1570834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1570842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1570845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1570848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1570851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570873 */     // MIs[0] round
     /* 1570873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570876 */     // MIs[0] policy
     /* 1570876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570886 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1570889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570910 */     // GIR_Coverage, 21176,
     /* 1570910 */     GIR_EraseRootFromParent_Done,
     /* 1570911 */   // Label 21757: @1570911
     /* 1570911 */   GIM_Try, /*On fail goto*//*Label 21758*/ GIMT_Encode4(1570993), // Rule ID 21177 //
     /* 1570916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1570924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1570927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1570930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1570933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570955 */     // MIs[0] round
     /* 1570955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570958 */     // MIs[0] policy
     /* 1570958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1570971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570992 */     // GIR_Coverage, 21177,
     /* 1570992 */     GIR_EraseRootFromParent_Done,
     /* 1570993 */   // Label 21758: @1570993
     /* 1570993 */   GIM_Try, /*On fail goto*//*Label 21759*/ GIMT_Encode4(1571075), // Rule ID 21180 //
     /* 1570998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1571001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1571006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1571009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1571012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1571015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571037 */     // MIs[0] round
     /* 1571037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571040 */     // MIs[0] policy
     /* 1571040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1571053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571074 */     // GIR_Coverage, 21180,
     /* 1571074 */     GIR_EraseRootFromParent_Done,
     /* 1571075 */   // Label 21759: @1571075
     /* 1571075 */   GIM_Try, /*On fail goto*//*Label 21760*/ GIMT_Encode4(1571157), // Rule ID 21181 //
     /* 1571080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1571083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1571088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1571091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1571094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1571097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571119 */     // MIs[0] round
     /* 1571119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571122 */     // MIs[0] policy
     /* 1571122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571132 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1571135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571156 */     // GIR_Coverage, 21181,
     /* 1571156 */     GIR_EraseRootFromParent_Done,
     /* 1571157 */   // Label 21760: @1571157
     /* 1571157 */   GIM_Try, /*On fail goto*//*Label 21761*/ GIMT_Encode4(1571239), // Rule ID 21184 //
     /* 1571162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1571165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1571170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1571173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1571176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1571179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571201 */     // MIs[0] round
     /* 1571201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571204 */     // MIs[0] policy
     /* 1571204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1571217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571238 */     // GIR_Coverage, 21184,
     /* 1571238 */     GIR_EraseRootFromParent_Done,
     /* 1571239 */   // Label 21761: @1571239
     /* 1571239 */   GIM_Try, /*On fail goto*//*Label 21762*/ GIMT_Encode4(1571321), // Rule ID 21185 //
     /* 1571244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1571247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1571252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1571255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1571258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1571261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571283 */     // MIs[0] round
     /* 1571283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571286 */     // MIs[0] policy
     /* 1571286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1571299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571320 */     // GIR_Coverage, 21185,
     /* 1571320 */     GIR_EraseRootFromParent_Done,
     /* 1571321 */   // Label 21762: @1571321
     /* 1571321 */   GIM_Try, /*On fail goto*//*Label 21763*/ GIMT_Encode4(1571403), // Rule ID 21188 //
     /* 1571326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1571329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1571334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1571337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1571340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1571343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571365 */     // MIs[0] round
     /* 1571365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571368 */     // MIs[0] policy
     /* 1571368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571378 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1571381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571402 */     // GIR_Coverage, 21188,
     /* 1571402 */     GIR_EraseRootFromParent_Done,
     /* 1571403 */   // Label 21763: @1571403
     /* 1571403 */   GIM_Try, /*On fail goto*//*Label 21764*/ GIMT_Encode4(1571485), // Rule ID 21189 //
     /* 1571408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1571411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1571416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1571419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1571422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1571425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571447 */     // MIs[0] round
     /* 1571447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571450 */     // MIs[0] policy
     /* 1571450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1571463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571484 */     // GIR_Coverage, 21189,
     /* 1571484 */     GIR_EraseRootFromParent_Done,
     /* 1571485 */   // Label 21764: @1571485
     /* 1571485 */   GIM_Try, /*On fail goto*//*Label 21765*/ GIMT_Encode4(1571567), // Rule ID 21192 //
     /* 1571490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1571493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1571498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1571501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1571504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1571507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1571510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1571517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571529 */     // MIs[0] round
     /* 1571529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571532 */     // MIs[0] policy
     /* 1571532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571542 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1571545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571566 */     // GIR_Coverage, 21192,
     /* 1571566 */     GIR_EraseRootFromParent_Done,
     /* 1571567 */   // Label 21765: @1571567
     /* 1571567 */   GIM_Try, /*On fail goto*//*Label 21766*/ GIMT_Encode4(1571649), // Rule ID 21193 //
     /* 1571572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1571575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1571580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1571583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1571586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1571589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1571592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1571599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571611 */     // MIs[0] round
     /* 1571611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571614 */     // MIs[0] policy
     /* 1571614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571624 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1571627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571648 */     // GIR_Coverage, 21193,
     /* 1571648 */     GIR_EraseRootFromParent_Done,
     /* 1571649 */   // Label 21766: @1571649
     /* 1571649 */   GIM_Try, /*On fail goto*//*Label 21767*/ GIMT_Encode4(1571731), // Rule ID 21196 //
     /* 1571654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1571657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1571662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1571665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1571668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1571671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571693 */     // MIs[0] round
     /* 1571693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571696 */     // MIs[0] policy
     /* 1571696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1571709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571730 */     // GIR_Coverage, 21196,
     /* 1571730 */     GIR_EraseRootFromParent_Done,
     /* 1571731 */   // Label 21767: @1571731
     /* 1571731 */   GIM_Try, /*On fail goto*//*Label 21768*/ GIMT_Encode4(1571813), // Rule ID 21197 //
     /* 1571736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1571739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1571744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1571747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1571750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1571753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571775 */     // MIs[0] round
     /* 1571775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571778 */     // MIs[0] policy
     /* 1571778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571788 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1571791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571812 */     // GIR_Coverage, 21197,
     /* 1571812 */     GIR_EraseRootFromParent_Done,
     /* 1571813 */   // Label 21768: @1571813
     /* 1571813 */   GIM_Try, /*On fail goto*//*Label 21769*/ GIMT_Encode4(1571895), // Rule ID 21200 //
     /* 1571818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1571821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1571826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1571829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1571832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1571835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571857 */     // MIs[0] round
     /* 1571857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571860 */     // MIs[0] policy
     /* 1571860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571870 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1571873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571894 */     // GIR_Coverage, 21200,
     /* 1571894 */     GIR_EraseRootFromParent_Done,
     /* 1571895 */   // Label 21769: @1571895
     /* 1571895 */   GIM_Try, /*On fail goto*//*Label 21770*/ GIMT_Encode4(1571977), // Rule ID 21201 //
     /* 1571900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1571903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1571908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1571911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1571914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1571917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571939 */     // MIs[0] round
     /* 1571939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571942 */     // MIs[0] policy
     /* 1571942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571952 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1571955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571976 */     // GIR_Coverage, 21201,
     /* 1571976 */     GIR_EraseRootFromParent_Done,
     /* 1571977 */   // Label 21770: @1571977
     /* 1571977 */   GIM_Try, /*On fail goto*//*Label 21771*/ GIMT_Encode4(1572059), // Rule ID 21204 //
     /* 1571982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1571985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1571990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1571993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1571996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1571999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572021 */     // MIs[0] round
     /* 1572021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572024 */     // MIs[0] policy
     /* 1572024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572034 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1572037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572058 */     // GIR_Coverage, 21204,
     /* 1572058 */     GIR_EraseRootFromParent_Done,
     /* 1572059 */   // Label 21771: @1572059
     /* 1572059 */   GIM_Try, /*On fail goto*//*Label 21772*/ GIMT_Encode4(1572141), // Rule ID 21205 //
     /* 1572064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1572067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1572072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1572075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1572078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1572081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572103 */     // MIs[0] round
     /* 1572103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572106 */     // MIs[0] policy
     /* 1572106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572116 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1572119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572140 */     // GIR_Coverage, 21205,
     /* 1572140 */     GIR_EraseRootFromParent_Done,
     /* 1572141 */   // Label 21772: @1572141
     /* 1572141 */   GIM_Try, /*On fail goto*//*Label 21773*/ GIMT_Encode4(1572223), // Rule ID 21208 //
     /* 1572146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1572149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1572154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1572157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1572160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1572163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1572173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572185 */     // MIs[0] round
     /* 1572185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572188 */     // MIs[0] policy
     /* 1572188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572198 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1572201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572222 */     // GIR_Coverage, 21208,
     /* 1572222 */     GIR_EraseRootFromParent_Done,
     /* 1572223 */   // Label 21773: @1572223
     /* 1572223 */   GIM_Try, /*On fail goto*//*Label 21774*/ GIMT_Encode4(1572305), // Rule ID 21209 //
     /* 1572228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1572231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1572236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1572239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1572242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1572245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1572255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572267 */     // MIs[0] round
     /* 1572267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572270 */     // MIs[0] policy
     /* 1572270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572280 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1572283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572304 */     // GIR_Coverage, 21209,
     /* 1572304 */     GIR_EraseRootFromParent_Done,
     /* 1572305 */   // Label 21774: @1572305
     /* 1572305 */   GIM_Try, /*On fail goto*//*Label 21775*/ GIMT_Encode4(1572387), // Rule ID 21212 //
     /* 1572310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1572318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1572321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1572324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1572327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572349 */     // MIs[0] round
     /* 1572349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572352 */     // MIs[0] policy
     /* 1572352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572362 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1572365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572386 */     // GIR_Coverage, 21212,
     /* 1572386 */     GIR_EraseRootFromParent_Done,
     /* 1572387 */   // Label 21775: @1572387
     /* 1572387 */   GIM_Try, /*On fail goto*//*Label 21776*/ GIMT_Encode4(1572469), // Rule ID 21213 //
     /* 1572392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1572400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1572403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1572406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1572409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572431 */     // MIs[0] round
     /* 1572431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572434 */     // MIs[0] policy
     /* 1572434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572444 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1572447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572468 */     // GIR_Coverage, 21213,
     /* 1572468 */     GIR_EraseRootFromParent_Done,
     /* 1572469 */   // Label 21776: @1572469
     /* 1572469 */   GIM_Try, /*On fail goto*//*Label 21777*/ GIMT_Encode4(1572551), // Rule ID 21216 //
     /* 1572474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1572482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1572485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1572488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1572491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572513 */     // MIs[0] round
     /* 1572513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572516 */     // MIs[0] policy
     /* 1572516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572526 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1572529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572550 */     // GIR_Coverage, 21216,
     /* 1572550 */     GIR_EraseRootFromParent_Done,
     /* 1572551 */   // Label 21777: @1572551
     /* 1572551 */   GIM_Try, /*On fail goto*//*Label 21778*/ GIMT_Encode4(1572633), // Rule ID 21217 //
     /* 1572556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1572564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1572567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1572570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1572573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572595 */     // MIs[0] round
     /* 1572595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572598 */     // MIs[0] policy
     /* 1572598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572608 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1572611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572632 */     // GIR_Coverage, 21217,
     /* 1572632 */     GIR_EraseRootFromParent_Done,
     /* 1572633 */   // Label 21778: @1572633
     /* 1572633 */   GIM_Try, /*On fail goto*//*Label 21779*/ GIMT_Encode4(1572715), // Rule ID 21220 //
     /* 1572638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1572646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1572649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1572652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1572655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572677 */     // MIs[0] round
     /* 1572677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572680 */     // MIs[0] policy
     /* 1572680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1572693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572714 */     // GIR_Coverage, 21220,
     /* 1572714 */     GIR_EraseRootFromParent_Done,
     /* 1572715 */   // Label 21779: @1572715
     /* 1572715 */   GIM_Try, /*On fail goto*//*Label 21780*/ GIMT_Encode4(1572797), // Rule ID 21221 //
     /* 1572720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1572728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1572731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1572734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1572737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572759 */     // MIs[0] round
     /* 1572759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572762 */     // MIs[0] policy
     /* 1572762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1572775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572796 */     // GIR_Coverage, 21221,
     /* 1572796 */     GIR_EraseRootFromParent_Done,
     /* 1572797 */   // Label 21780: @1572797
     /* 1572797 */   GIM_Try, /*On fail goto*//*Label 21781*/ GIMT_Encode4(1572879), // Rule ID 21224 //
     /* 1572802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1572810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1572813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1572816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1572819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572841 */     // MIs[0] round
     /* 1572841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572844 */     // MIs[0] policy
     /* 1572844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572854 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1572857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572878 */     // GIR_Coverage, 21224,
     /* 1572878 */     GIR_EraseRootFromParent_Done,
     /* 1572879 */   // Label 21781: @1572879
     /* 1572879 */   GIM_Try, /*On fail goto*//*Label 21782*/ GIMT_Encode4(1572961), // Rule ID 21225 //
     /* 1572884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1572892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1572895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1572898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1572901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572923 */     // MIs[0] round
     /* 1572923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572926 */     // MIs[0] policy
     /* 1572926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572936 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1572939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572960 */     // GIR_Coverage, 21225,
     /* 1572960 */     GIR_EraseRootFromParent_Done,
     /* 1572961 */   // Label 21782: @1572961
     /* 1572961 */   GIM_Try, /*On fail goto*//*Label 21783*/ GIMT_Encode4(1573043), // Rule ID 21228 //
     /* 1572966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1572974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1572977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1572980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1572983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1572986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1572993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573005 */     // MIs[0] round
     /* 1573005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573008 */     // MIs[0] policy
     /* 1573008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1573021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573042 */     // GIR_Coverage, 21228,
     /* 1573042 */     GIR_EraseRootFromParent_Done,
     /* 1573043 */   // Label 21783: @1573043
     /* 1573043 */   GIM_Try, /*On fail goto*//*Label 21784*/ GIMT_Encode4(1573125), // Rule ID 21229 //
     /* 1573048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1573056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1573059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1573062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1573065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1573068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1573075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573087 */     // MIs[0] round
     /* 1573087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573090 */     // MIs[0] policy
     /* 1573090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1573103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573124 */     // GIR_Coverage, 21229,
     /* 1573124 */     GIR_EraseRootFromParent_Done,
     /* 1573125 */   // Label 21784: @1573125
     /* 1573125 */   GIM_Try, /*On fail goto*//*Label 21785*/ GIMT_Encode4(1573207), // Rule ID 21232 //
     /* 1573130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1573133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1573138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1573141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1573144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1573147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573169 */     // MIs[0] round
     /* 1573169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573172 */     // MIs[0] policy
     /* 1573172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573182 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1573185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573206 */     // GIR_Coverage, 21232,
     /* 1573206 */     GIR_EraseRootFromParent_Done,
     /* 1573207 */   // Label 21785: @1573207
     /* 1573207 */   GIM_Try, /*On fail goto*//*Label 21786*/ GIMT_Encode4(1573289), // Rule ID 21233 //
     /* 1573212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1573215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1573220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1573223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1573226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1573229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573251 */     // MIs[0] round
     /* 1573251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573254 */     // MIs[0] policy
     /* 1573254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573264 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1573267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573288 */     // GIR_Coverage, 21233,
     /* 1573288 */     GIR_EraseRootFromParent_Done,
     /* 1573289 */   // Label 21786: @1573289
     /* 1573289 */   GIM_Try, /*On fail goto*//*Label 21787*/ GIMT_Encode4(1573371), // Rule ID 21236 //
     /* 1573294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1573297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1573302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1573305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1573308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1573311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1573314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573333 */     // MIs[0] round
     /* 1573333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573336 */     // MIs[0] policy
     /* 1573336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1573349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573370 */     // GIR_Coverage, 21236,
     /* 1573370 */     GIR_EraseRootFromParent_Done,
     /* 1573371 */   // Label 21787: @1573371
     /* 1573371 */   GIM_Try, /*On fail goto*//*Label 21788*/ GIMT_Encode4(1573453), // Rule ID 21237 //
     /* 1573376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1573379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1573384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1573387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1573390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1573393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1573396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573415 */     // MIs[0] round
     /* 1573415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573418 */     // MIs[0] policy
     /* 1573418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573428 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1573431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573452 */     // GIR_Coverage, 21237,
     /* 1573452 */     GIR_EraseRootFromParent_Done,
     /* 1573453 */   // Label 21788: @1573453
     /* 1573453 */   GIM_Try, /*On fail goto*//*Label 21789*/ GIMT_Encode4(1573535), // Rule ID 21240 //
     /* 1573458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1573461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1573466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1573469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1573472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1573475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1573478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573497 */     // MIs[0] round
     /* 1573497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573500 */     // MIs[0] policy
     /* 1573500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573510 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1573513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573534 */     // GIR_Coverage, 21240,
     /* 1573534 */     GIR_EraseRootFromParent_Done,
     /* 1573535 */   // Label 21789: @1573535
     /* 1573535 */   GIM_Try, /*On fail goto*//*Label 21790*/ GIMT_Encode4(1573617), // Rule ID 21241 //
     /* 1573540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1573543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1573548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1573551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1573554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1573557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1573560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573579 */     // MIs[0] round
     /* 1573579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573582 */     // MIs[0] policy
     /* 1573582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573592 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1573595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573616 */     // GIR_Coverage, 21241,
     /* 1573616 */     GIR_EraseRootFromParent_Done,
     /* 1573617 */   // Label 21790: @1573617
     /* 1573617 */   GIM_Try, /*On fail goto*//*Label 21791*/ GIMT_Encode4(1573699), // Rule ID 21244 //
     /* 1573622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1573625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1573630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1573633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1573636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1573639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1573649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573661 */     // MIs[0] round
     /* 1573661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573664 */     // MIs[0] policy
     /* 1573664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573674 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1573677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573698 */     // GIR_Coverage, 21244,
     /* 1573698 */     GIR_EraseRootFromParent_Done,
     /* 1573699 */   // Label 21791: @1573699
     /* 1573699 */   GIM_Try, /*On fail goto*//*Label 21792*/ GIMT_Encode4(1573781), // Rule ID 21245 //
     /* 1573704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1573707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1573712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1573715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1573718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1573721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1573731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573743 */     // MIs[0] round
     /* 1573743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573746 */     // MIs[0] policy
     /* 1573746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573756 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1573759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573780 */     // GIR_Coverage, 21245,
     /* 1573780 */     GIR_EraseRootFromParent_Done,
     /* 1573781 */   // Label 21792: @1573781
     /* 1573781 */   GIM_Try, /*On fail goto*//*Label 21793*/ GIMT_Encode4(1573863), // Rule ID 21596 //
     /* 1573786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1573794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1573797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1573800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1573803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573825 */     // MIs[0] round
     /* 1573825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573828 */     // MIs[0] policy
     /* 1573828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573838 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1573841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573862 */     // GIR_Coverage, 21596,
     /* 1573862 */     GIR_EraseRootFromParent_Done,
     /* 1573863 */   // Label 21793: @1573863
     /* 1573863 */   GIM_Try, /*On fail goto*//*Label 21794*/ GIMT_Encode4(1573945), // Rule ID 21597 //
     /* 1573868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1573876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1573879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1573882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1573885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573907 */     // MIs[0] round
     /* 1573907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573910 */     // MIs[0] policy
     /* 1573910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573920 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1573923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573944 */     // GIR_Coverage, 21597,
     /* 1573944 */     GIR_EraseRootFromParent_Done,
     /* 1573945 */   // Label 21794: @1573945
     /* 1573945 */   GIM_Try, /*On fail goto*//*Label 21795*/ GIMT_Encode4(1574027), // Rule ID 21600 //
     /* 1573950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1573958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1573961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1573964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1573967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1573970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573989 */     // MIs[0] round
     /* 1573989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573992 */     // MIs[0] policy
     /* 1573992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1574005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1574023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574026 */     // GIR_Coverage, 21600,
     /* 1574026 */     GIR_EraseRootFromParent_Done,
     /* 1574027 */   // Label 21795: @1574027
     /* 1574027 */   GIM_Try, /*On fail goto*//*Label 21796*/ GIMT_Encode4(1574109), // Rule ID 21601 //
     /* 1574032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1574035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1574040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1574043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1574046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1574049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574071 */     // MIs[0] round
     /* 1574071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574074 */     // MIs[0] policy
     /* 1574074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574084 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1574087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1574105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574108 */     // GIR_Coverage, 21601,
     /* 1574108 */     GIR_EraseRootFromParent_Done,
     /* 1574109 */   // Label 21796: @1574109
     /* 1574109 */   GIM_Try, /*On fail goto*//*Label 21797*/ GIMT_Encode4(1574191), // Rule ID 21604 //
     /* 1574114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1574117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1574122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1574125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1574128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1574131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1574134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574153 */     // MIs[0] round
     /* 1574153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574156 */     // MIs[0] policy
     /* 1574156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574166 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1574169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1574187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574190 */     // GIR_Coverage, 21604,
     /* 1574190 */     GIR_EraseRootFromParent_Done,
     /* 1574191 */   // Label 21797: @1574191
     /* 1574191 */   GIM_Try, /*On fail goto*//*Label 21798*/ GIMT_Encode4(1574273), // Rule ID 21605 //
     /* 1574196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1574199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1574204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1574207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1574210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1574213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1574216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574235 */     // MIs[0] round
     /* 1574235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574238 */     // MIs[0] policy
     /* 1574238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574248 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1574251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1574269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574272 */     // GIR_Coverage, 21605,
     /* 1574272 */     GIR_EraseRootFromParent_Done,
     /* 1574273 */   // Label 21798: @1574273
     /* 1574273 */   GIM_Try, /*On fail goto*//*Label 21799*/ GIMT_Encode4(1574355), // Rule ID 21608 //
     /* 1574278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1574281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1574286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1574289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1574292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1574295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1574298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574317 */     // MIs[0] round
     /* 1574317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574320 */     // MIs[0] policy
     /* 1574320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574330 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1574333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574339 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1574351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574354 */     // GIR_Coverage, 21608,
     /* 1574354 */     GIR_EraseRootFromParent_Done,
     /* 1574355 */   // Label 21799: @1574355
     /* 1574355 */   GIM_Try, /*On fail goto*//*Label 21800*/ GIMT_Encode4(1574437), // Rule ID 21609 //
     /* 1574360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1574363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1574368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1574371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1574374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1574377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1574380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574399 */     // MIs[0] round
     /* 1574399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574402 */     // MIs[0] policy
     /* 1574402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574412 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1574415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574421 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1574433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574436 */     // GIR_Coverage, 21609,
     /* 1574436 */     GIR_EraseRootFromParent_Done,
     /* 1574437 */   // Label 21800: @1574437
     /* 1574437 */   GIM_Try, /*On fail goto*//*Label 21801*/ GIMT_Encode4(1574519), // Rule ID 21612 //
     /* 1574442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1574445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1574450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1574453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1574456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1574459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1574462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574481 */     // MIs[0] round
     /* 1574481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574484 */     // MIs[0] policy
     /* 1574484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574494 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1574497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1574515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574518 */     // GIR_Coverage, 21612,
     /* 1574518 */     GIR_EraseRootFromParent_Done,
     /* 1574519 */   // Label 21801: @1574519
     /* 1574519 */   GIM_Try, /*On fail goto*//*Label 21802*/ GIMT_Encode4(1574601), // Rule ID 21613 //
     /* 1574524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1574527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1574532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1574535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1574538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1574541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1574544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574563 */     // MIs[0] round
     /* 1574563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574566 */     // MIs[0] policy
     /* 1574566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1574579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1574597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574600 */     // GIR_Coverage, 21613,
     /* 1574600 */     GIR_EraseRootFromParent_Done,
     /* 1574601 */   // Label 21802: @1574601
     /* 1574601 */   GIM_Try, /*On fail goto*//*Label 21803*/ GIMT_Encode4(1574683), // Rule ID 21616 //
     /* 1574606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1574609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1574614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1574617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1574620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1574623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1574626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574645 */     // MIs[0] round
     /* 1574645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574648 */     // MIs[0] policy
     /* 1574648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574658 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1574661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1574679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574682 */     // GIR_Coverage, 21616,
     /* 1574682 */     GIR_EraseRootFromParent_Done,
     /* 1574683 */   // Label 21803: @1574683
     /* 1574683 */   GIM_Try, /*On fail goto*//*Label 21804*/ GIMT_Encode4(1574765), // Rule ID 21617 //
     /* 1574688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1574691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1574696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1574699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1574702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1574705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1574708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574727 */     // MIs[0] round
     /* 1574727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574730 */     // MIs[0] policy
     /* 1574730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574740 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1574743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1574761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574764 */     // GIR_Coverage, 21617,
     /* 1574764 */     GIR_EraseRootFromParent_Done,
     /* 1574765 */   // Label 21804: @1574765
     /* 1574765 */   GIM_Try, /*On fail goto*//*Label 21805*/ GIMT_Encode4(1574847), // Rule ID 21620 //
     /* 1574770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1574773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1574778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1574781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1574784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1574787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574809 */     // MIs[0] round
     /* 1574809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574812 */     // MIs[0] policy
     /* 1574812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574822 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1574825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574846 */     // GIR_Coverage, 21620,
     /* 1574846 */     GIR_EraseRootFromParent_Done,
     /* 1574847 */   // Label 21805: @1574847
     /* 1574847 */   GIM_Try, /*On fail goto*//*Label 21806*/ GIMT_Encode4(1574929), // Rule ID 21621 //
     /* 1574852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1574855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1574860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1574863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1574866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1574869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574891 */     // MIs[0] round
     /* 1574891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574894 */     // MIs[0] policy
     /* 1574894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574904 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1574907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574928 */     // GIR_Coverage, 21621,
     /* 1574928 */     GIR_EraseRootFromParent_Done,
     /* 1574929 */   // Label 21806: @1574929
     /* 1574929 */   GIM_Try, /*On fail goto*//*Label 21807*/ GIMT_Encode4(1575011), // Rule ID 21624 //
     /* 1574934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1574937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1574942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1574945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1574948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1574951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574973 */     // MIs[0] round
     /* 1574973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574976 */     // MIs[0] policy
     /* 1574976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574986 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1574989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575010 */     // GIR_Coverage, 21624,
     /* 1575010 */     GIR_EraseRootFromParent_Done,
     /* 1575011 */   // Label 21807: @1575011
     /* 1575011 */   GIM_Try, /*On fail goto*//*Label 21808*/ GIMT_Encode4(1575093), // Rule ID 21625 //
     /* 1575016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1575019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1575024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1575027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1575030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1575033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575055 */     // MIs[0] round
     /* 1575055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575058 */     // MIs[0] policy
     /* 1575058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575068 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1575071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575092 */     // GIR_Coverage, 21625,
     /* 1575092 */     GIR_EraseRootFromParent_Done,
     /* 1575093 */   // Label 21808: @1575093
     /* 1575093 */   GIM_Try, /*On fail goto*//*Label 21809*/ GIMT_Encode4(1575175), // Rule ID 21628 //
     /* 1575098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1575101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1575106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1575109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1575112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1575115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575137 */     // MIs[0] round
     /* 1575137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575140 */     // MIs[0] policy
     /* 1575140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575150 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1575153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575174 */     // GIR_Coverage, 21628,
     /* 1575174 */     GIR_EraseRootFromParent_Done,
     /* 1575175 */   // Label 21809: @1575175
     /* 1575175 */   GIM_Try, /*On fail goto*//*Label 21810*/ GIMT_Encode4(1575257), // Rule ID 21629 //
     /* 1575180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1575183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1575188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1575191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1575194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1575197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575219 */     // MIs[0] round
     /* 1575219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575222 */     // MIs[0] policy
     /* 1575222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1575235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575256 */     // GIR_Coverage, 21629,
     /* 1575256 */     GIR_EraseRootFromParent_Done,
     /* 1575257 */   // Label 21810: @1575257
     /* 1575257 */   GIM_Try, /*On fail goto*//*Label 21811*/ GIMT_Encode4(1575339), // Rule ID 21632 //
     /* 1575262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1575265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1575270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1575273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1575276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1575279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575301 */     // MIs[0] round
     /* 1575301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575304 */     // MIs[0] policy
     /* 1575304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1575317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575323 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575338 */     // GIR_Coverage, 21632,
     /* 1575338 */     GIR_EraseRootFromParent_Done,
     /* 1575339 */   // Label 21811: @1575339
     /* 1575339 */   GIM_Try, /*On fail goto*//*Label 21812*/ GIMT_Encode4(1575421), // Rule ID 21633 //
     /* 1575344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1575347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1575352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1575355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1575358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1575361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575383 */     // MIs[0] round
     /* 1575383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575386 */     // MIs[0] policy
     /* 1575386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1575399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575420 */     // GIR_Coverage, 21633,
     /* 1575420 */     GIR_EraseRootFromParent_Done,
     /* 1575421 */   // Label 21812: @1575421
     /* 1575421 */   GIM_Try, /*On fail goto*//*Label 21813*/ GIMT_Encode4(1575503), // Rule ID 21636 //
     /* 1575426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1575429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1575434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1575437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1575440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1575443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1575446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575465 */     // MIs[0] round
     /* 1575465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575468 */     // MIs[0] policy
     /* 1575468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575478 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1575481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575502 */     // GIR_Coverage, 21636,
     /* 1575502 */     GIR_EraseRootFromParent_Done,
     /* 1575503 */   // Label 21813: @1575503
     /* 1575503 */   GIM_Try, /*On fail goto*//*Label 21814*/ GIMT_Encode4(1575585), // Rule ID 21637 //
     /* 1575508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1575511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1575516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1575519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1575522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1575525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1575528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575547 */     // MIs[0] round
     /* 1575547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575550 */     // MIs[0] policy
     /* 1575550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575560 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1575563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575584 */     // GIR_Coverage, 21637,
     /* 1575584 */     GIR_EraseRootFromParent_Done,
     /* 1575585 */   // Label 21814: @1575585
     /* 1575585 */   GIM_Try, /*On fail goto*//*Label 21815*/ GIMT_Encode4(1575667), // Rule ID 21640 //
     /* 1575590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1575593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1575598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1575601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1575604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1575607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1575610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575629 */     // MIs[0] round
     /* 1575629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575632 */     // MIs[0] policy
     /* 1575632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575642 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1575645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575651 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575666 */     // GIR_Coverage, 21640,
     /* 1575666 */     GIR_EraseRootFromParent_Done,
     /* 1575667 */   // Label 21815: @1575667
     /* 1575667 */   GIM_Try, /*On fail goto*//*Label 21816*/ GIMT_Encode4(1575749), // Rule ID 21641 //
     /* 1575672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1575675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1575680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1575683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1575686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1575689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1575692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575711 */     // MIs[0] round
     /* 1575711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575714 */     // MIs[0] policy
     /* 1575714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1575727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575733 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575748 */     // GIR_Coverage, 21641,
     /* 1575748 */     GIR_EraseRootFromParent_Done,
     /* 1575749 */   // Label 21816: @1575749
     /* 1575749 */   GIM_Try, /*On fail goto*//*Label 21817*/ GIMT_Encode4(1575831), // Rule ID 21644 //
     /* 1575754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1575757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1575762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1575765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1575768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1575771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575793 */     // MIs[0] round
     /* 1575793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575796 */     // MIs[0] policy
     /* 1575796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575806 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1575809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575830 */     // GIR_Coverage, 21644,
     /* 1575830 */     GIR_EraseRootFromParent_Done,
     /* 1575831 */   // Label 21817: @1575831
     /* 1575831 */   GIM_Try, /*On fail goto*//*Label 21818*/ GIMT_Encode4(1575913), // Rule ID 21645 //
     /* 1575836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1575839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1575844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1575847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1575850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1575853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575875 */     // MIs[0] round
     /* 1575875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575878 */     // MIs[0] policy
     /* 1575878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1575891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575912 */     // GIR_Coverage, 21645,
     /* 1575912 */     GIR_EraseRootFromParent_Done,
     /* 1575913 */   // Label 21818: @1575913
     /* 1575913 */   GIM_Try, /*On fail goto*//*Label 21819*/ GIMT_Encode4(1575995), // Rule ID 21648 //
     /* 1575918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1575921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1575926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1575929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1575932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1575935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575957 */     // MIs[0] round
     /* 1575957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575960 */     // MIs[0] policy
     /* 1575960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575970 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1575973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575994 */     // GIR_Coverage, 21648,
     /* 1575994 */     GIR_EraseRootFromParent_Done,
     /* 1575995 */   // Label 21819: @1575995
     /* 1575995 */   GIM_Try, /*On fail goto*//*Label 21820*/ GIMT_Encode4(1576077), // Rule ID 21649 //
     /* 1576000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1576003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1576008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1576011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1576014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1576017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576039 */     // MIs[0] round
     /* 1576039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576042 */     // MIs[0] policy
     /* 1576042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1576055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576076 */     // GIR_Coverage, 21649,
     /* 1576076 */     GIR_EraseRootFromParent_Done,
     /* 1576077 */   // Label 21820: @1576077
     /* 1576077 */   GIM_Try, /*On fail goto*//*Label 21821*/ GIMT_Encode4(1576159), // Rule ID 21652 //
     /* 1576082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1576085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1576090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1576099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576121 */     // MIs[0] round
     /* 1576121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576124 */     // MIs[0] policy
     /* 1576124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576134 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1576137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576158 */     // GIR_Coverage, 21652,
     /* 1576158 */     GIR_EraseRootFromParent_Done,
     /* 1576159 */   // Label 21821: @1576159
     /* 1576159 */   GIM_Try, /*On fail goto*//*Label 21822*/ GIMT_Encode4(1576241), // Rule ID 21653 //
     /* 1576164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1576167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1576172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1576181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576203 */     // MIs[0] round
     /* 1576203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576206 */     // MIs[0] policy
     /* 1576206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576216 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1576219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576240 */     // GIR_Coverage, 21653,
     /* 1576240 */     GIR_EraseRootFromParent_Done,
     /* 1576241 */   // Label 21822: @1576241
     /* 1576241 */   GIM_Try, /*On fail goto*//*Label 21823*/ GIMT_Encode4(1576323), // Rule ID 21656 //
     /* 1576246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1576254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1576257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1576260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1576263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576285 */     // MIs[0] round
     /* 1576285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576288 */     // MIs[0] policy
     /* 1576288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576298 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1576301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576322 */     // GIR_Coverage, 21656,
     /* 1576322 */     GIR_EraseRootFromParent_Done,
     /* 1576323 */   // Label 21823: @1576323
     /* 1576323 */   GIM_Try, /*On fail goto*//*Label 21824*/ GIMT_Encode4(1576405), // Rule ID 21657 //
     /* 1576328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1576336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1576339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1576342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1576345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576367 */     // MIs[0] round
     /* 1576367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576370 */     // MIs[0] policy
     /* 1576370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576380 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1576383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576404 */     // GIR_Coverage, 21657,
     /* 1576404 */     GIR_EraseRootFromParent_Done,
     /* 1576405 */   // Label 21824: @1576405
     /* 1576405 */   GIM_Try, /*On fail goto*//*Label 21825*/ GIMT_Encode4(1576487), // Rule ID 21660 //
     /* 1576410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1576418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1576421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1576424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1576427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576449 */     // MIs[0] round
     /* 1576449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576452 */     // MIs[0] policy
     /* 1576452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576462 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1576465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576486 */     // GIR_Coverage, 21660,
     /* 1576486 */     GIR_EraseRootFromParent_Done,
     /* 1576487 */   // Label 21825: @1576487
     /* 1576487 */   GIM_Try, /*On fail goto*//*Label 21826*/ GIMT_Encode4(1576569), // Rule ID 21661 //
     /* 1576492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1576500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1576503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1576506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1576509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576531 */     // MIs[0] round
     /* 1576531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576534 */     // MIs[0] policy
     /* 1576534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576544 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1576547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576568 */     // GIR_Coverage, 21661,
     /* 1576568 */     GIR_EraseRootFromParent_Done,
     /* 1576569 */   // Label 21826: @1576569
     /* 1576569 */   GIM_Try, /*On fail goto*//*Label 21827*/ GIMT_Encode4(1576651), // Rule ID 21664 //
     /* 1576574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1576582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1576585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1576588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1576591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576613 */     // MIs[0] round
     /* 1576613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576616 */     // MIs[0] policy
     /* 1576616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576626 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1576629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576650 */     // GIR_Coverage, 21664,
     /* 1576650 */     GIR_EraseRootFromParent_Done,
     /* 1576651 */   // Label 21827: @1576651
     /* 1576651 */   GIM_Try, /*On fail goto*//*Label 21828*/ GIMT_Encode4(1576733), // Rule ID 21665 //
     /* 1576656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1576664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1576667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1576670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1576673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576695 */     // MIs[0] round
     /* 1576695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576698 */     // MIs[0] policy
     /* 1576698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576708 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1576711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576732 */     // GIR_Coverage, 21665,
     /* 1576732 */     GIR_EraseRootFromParent_Done,
     /* 1576733 */   // Label 21828: @1576733
     /* 1576733 */   GIM_Try, /*On fail goto*//*Label 21829*/ GIMT_Encode4(1576815), // Rule ID 21668 //
     /* 1576738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1576746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1576749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1576752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1576755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576777 */     // MIs[0] round
     /* 1576777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576780 */     // MIs[0] policy
     /* 1576780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576790 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1576793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576814 */     // GIR_Coverage, 21668,
     /* 1576814 */     GIR_EraseRootFromParent_Done,
     /* 1576815 */   // Label 21829: @1576815
     /* 1576815 */   GIM_Try, /*On fail goto*//*Label 21830*/ GIMT_Encode4(1576897), // Rule ID 21669 //
     /* 1576820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1576828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1576831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1576834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1576837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576859 */     // MIs[0] round
     /* 1576859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576862 */     // MIs[0] policy
     /* 1576862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576872 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1576875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576896 */     // GIR_Coverage, 21669,
     /* 1576896 */     GIR_EraseRootFromParent_Done,
     /* 1576897 */   // Label 21830: @1576897
     /* 1576897 */   GIM_Try, /*On fail goto*//*Label 21831*/ GIMT_Encode4(1576979), // Rule ID 21672 //
     /* 1576902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1576910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1576913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1576916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1576919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1576922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576941 */     // MIs[0] round
     /* 1576941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576944 */     // MIs[0] policy
     /* 1576944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576954 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1576957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576963 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576978 */     // GIR_Coverage, 21672,
     /* 1576978 */     GIR_EraseRootFromParent_Done,
     /* 1576979 */   // Label 21831: @1576979
     /* 1576979 */   GIM_Try, /*On fail goto*//*Label 21832*/ GIMT_Encode4(1577061), // Rule ID 21673 //
     /* 1576984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1576992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1576995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1576998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1577001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1577004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577023 */     // MIs[0] round
     /* 1577023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577026 */     // MIs[0] policy
     /* 1577026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577036 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1577039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577060 */     // GIR_Coverage, 21673,
     /* 1577060 */     GIR_EraseRootFromParent_Done,
     /* 1577061 */   // Label 21832: @1577061
     /* 1577061 */   GIM_Try, /*On fail goto*//*Label 21833*/ GIMT_Encode4(1577143), // Rule ID 21676 //
     /* 1577066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1577069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1577074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1577077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1577080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1577083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1577086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577105 */     // MIs[0] round
     /* 1577105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577108 */     // MIs[0] policy
     /* 1577108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577118 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1577121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577142 */     // GIR_Coverage, 21676,
     /* 1577142 */     GIR_EraseRootFromParent_Done,
     /* 1577143 */   // Label 21833: @1577143
     /* 1577143 */   GIM_Try, /*On fail goto*//*Label 21834*/ GIMT_Encode4(1577225), // Rule ID 21677 //
     /* 1577148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1577151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1577156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1577159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1577162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1577165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1577168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577187 */     // MIs[0] round
     /* 1577187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577190 */     // MIs[0] policy
     /* 1577190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577200 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1577203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577224 */     // GIR_Coverage, 21677,
     /* 1577224 */     GIR_EraseRootFromParent_Done,
     /* 1577225 */   // Label 21834: @1577225
     /* 1577225 */   GIM_Try, /*On fail goto*//*Label 21835*/ GIMT_Encode4(1577307), // Rule ID 21680 //
     /* 1577230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1577233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1577238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1577241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1577244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1577247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577269 */     // MIs[0] round
     /* 1577269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577272 */     // MIs[0] policy
     /* 1577272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577282 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1577285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577306 */     // GIR_Coverage, 21680,
     /* 1577306 */     GIR_EraseRootFromParent_Done,
     /* 1577307 */   // Label 21835: @1577307
     /* 1577307 */   GIM_Try, /*On fail goto*//*Label 21836*/ GIMT_Encode4(1577389), // Rule ID 21681 //
     /* 1577312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1577315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1577320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1577323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1577326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1577329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577351 */     // MIs[0] round
     /* 1577351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577354 */     // MIs[0] policy
     /* 1577354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577364 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1577367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577388 */     // GIR_Coverage, 21681,
     /* 1577388 */     GIR_EraseRootFromParent_Done,
     /* 1577389 */   // Label 21836: @1577389
     /* 1577389 */   GIM_Try, /*On fail goto*//*Label 21837*/ GIMT_Encode4(1577471), // Rule ID 21684 //
     /* 1577394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1577397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1577402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1577405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1577408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1577411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1577414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577433 */     // MIs[0] round
     /* 1577433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577436 */     // MIs[0] policy
     /* 1577436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577446 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1577449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577470 */     // GIR_Coverage, 21684,
     /* 1577470 */     GIR_EraseRootFromParent_Done,
     /* 1577471 */   // Label 21837: @1577471
     /* 1577471 */   GIM_Try, /*On fail goto*//*Label 21838*/ GIMT_Encode4(1577553), // Rule ID 21685 //
     /* 1577476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1577479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1577484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1577487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1577490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1577493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1577496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577515 */     // MIs[0] round
     /* 1577515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577518 */     // MIs[0] policy
     /* 1577518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577528 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1577531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577552 */     // GIR_Coverage, 21685,
     /* 1577552 */     GIR_EraseRootFromParent_Done,
     /* 1577553 */   // Label 21838: @1577553
     /* 1577553 */   GIM_Try, /*On fail goto*//*Label 21839*/ GIMT_Encode4(1577635), // Rule ID 21688 //
     /* 1577558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1577561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1577566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1577569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1577572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1577575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1577578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577597 */     // MIs[0] round
     /* 1577597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577600 */     // MIs[0] policy
     /* 1577600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577610 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1577613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577634 */     // GIR_Coverage, 21688,
     /* 1577634 */     GIR_EraseRootFromParent_Done,
     /* 1577635 */   // Label 21839: @1577635
     /* 1577635 */   GIM_Try, /*On fail goto*//*Label 21840*/ GIMT_Encode4(1577717), // Rule ID 21689 //
     /* 1577640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1577643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1577648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1577651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1577654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1577657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1577660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577679 */     // MIs[0] round
     /* 1577679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577682 */     // MIs[0] policy
     /* 1577682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577692 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1577695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577716 */     // GIR_Coverage, 21689,
     /* 1577716 */     GIR_EraseRootFromParent_Done,
     /* 1577717 */   // Label 21840: @1577717
     /* 1577717 */   GIM_Try, /*On fail goto*//*Label 21841*/ GIMT_Encode4(1577799), // Rule ID 21692 //
     /* 1577722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1577725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1577730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1577733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1577736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1577739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1577742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577761 */     // MIs[0] round
     /* 1577761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577764 */     // MIs[0] policy
     /* 1577764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577774 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1577777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577798 */     // GIR_Coverage, 21692,
     /* 1577798 */     GIR_EraseRootFromParent_Done,
     /* 1577799 */   // Label 21841: @1577799
     /* 1577799 */   GIM_Try, /*On fail goto*//*Label 21842*/ GIMT_Encode4(1577881), // Rule ID 21693 //
     /* 1577804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1577807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1577812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1577815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1577818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1577821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1577824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577843 */     // MIs[0] round
     /* 1577843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577846 */     // MIs[0] policy
     /* 1577846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577856 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1577859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577880 */     // GIR_Coverage, 21693,
     /* 1577880 */     GIR_EraseRootFromParent_Done,
     /* 1577881 */   // Label 21842: @1577881
     /* 1577881 */   GIM_Try, /*On fail goto*//*Label 21843*/ GIMT_Encode4(1577963), // Rule ID 21696 //
     /* 1577886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1577889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1577894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1577897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1577900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1577903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1577906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577925 */     // MIs[0] round
     /* 1577925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577928 */     // MIs[0] policy
     /* 1577928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577938 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1577941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577962 */     // GIR_Coverage, 21696,
     /* 1577962 */     GIR_EraseRootFromParent_Done,
     /* 1577963 */   // Label 21843: @1577963
     /* 1577963 */   GIM_Try, /*On fail goto*//*Label 21844*/ GIMT_Encode4(1578045), // Rule ID 21697 //
     /* 1577968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1577971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1577976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1577979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1577982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1577985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1577988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578007 */     // MIs[0] round
     /* 1578007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578010 */     // MIs[0] policy
     /* 1578010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578020 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1578023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578044 */     // GIR_Coverage, 21697,
     /* 1578044 */     GIR_EraseRootFromParent_Done,
     /* 1578045 */   // Label 21844: @1578045
     /* 1578045 */   GIM_Try, /*On fail goto*//*Label 21845*/ GIMT_Encode4(1578127), // Rule ID 21700 //
     /* 1578050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1578053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1578058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1578061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1578064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1578067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1578070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578089 */     // MIs[0] round
     /* 1578089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578092 */     // MIs[0] policy
     /* 1578092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578102 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1578105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578126 */     // GIR_Coverage, 21700,
     /* 1578126 */     GIR_EraseRootFromParent_Done,
     /* 1578127 */   // Label 21845: @1578127
     /* 1578127 */   GIM_Try, /*On fail goto*//*Label 21846*/ GIMT_Encode4(1578209), // Rule ID 21701 //
     /* 1578132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1578135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1578140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1578143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1578146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1578149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1578152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578171 */     // MIs[0] round
     /* 1578171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578174 */     // MIs[0] policy
     /* 1578174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578184 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1578187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578208 */     // GIR_Coverage, 21701,
     /* 1578208 */     GIR_EraseRootFromParent_Done,
     /* 1578209 */   // Label 21846: @1578209
     /* 1578209 */   GIM_Try, /*On fail goto*//*Label 21847*/ GIMT_Encode4(1578291), // Rule ID 21704 //
     /* 1578214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1578217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1578222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1578225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1578228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1578231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578253 */     // MIs[0] round
     /* 1578253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578256 */     // MIs[0] policy
     /* 1578256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578266 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1578269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578290 */     // GIR_Coverage, 21704,
     /* 1578290 */     GIR_EraseRootFromParent_Done,
     /* 1578291 */   // Label 21847: @1578291
     /* 1578291 */   GIM_Try, /*On fail goto*//*Label 21848*/ GIMT_Encode4(1578373), // Rule ID 21705 //
     /* 1578296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1578299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1578304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1578307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1578310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1578313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578335 */     // MIs[0] round
     /* 1578335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578338 */     // MIs[0] policy
     /* 1578338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578348 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1578351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578372 */     // GIR_Coverage, 21705,
     /* 1578372 */     GIR_EraseRootFromParent_Done,
     /* 1578373 */   // Label 21848: @1578373
     /* 1578373 */   GIM_Try, /*On fail goto*//*Label 21849*/ GIMT_Encode4(1578455), // Rule ID 21708 //
     /* 1578378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1578381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1578386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1578389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1578392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1578395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578417 */     // MIs[0] round
     /* 1578417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578420 */     // MIs[0] policy
     /* 1578420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1578433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578454 */     // GIR_Coverage, 21708,
     /* 1578454 */     GIR_EraseRootFromParent_Done,
     /* 1578455 */   // Label 21849: @1578455
     /* 1578455 */   GIM_Try, /*On fail goto*//*Label 21850*/ GIMT_Encode4(1578537), // Rule ID 21709 //
     /* 1578460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1578463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1578468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1578471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1578474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1578477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578499 */     // MIs[0] round
     /* 1578499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578502 */     // MIs[0] policy
     /* 1578502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1578515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578536 */     // GIR_Coverage, 21709,
     /* 1578536 */     GIR_EraseRootFromParent_Done,
     /* 1578537 */   // Label 21850: @1578537
     /* 1578537 */   GIM_Try, /*On fail goto*//*Label 21851*/ GIMT_Encode4(1578619), // Rule ID 21712 //
     /* 1578542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1578545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1578550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1578553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1578556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1578559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578581 */     // MIs[0] round
     /* 1578581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578584 */     // MIs[0] policy
     /* 1578584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578594 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1578597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578618 */     // GIR_Coverage, 21712,
     /* 1578618 */     GIR_EraseRootFromParent_Done,
     /* 1578619 */   // Label 21851: @1578619
     /* 1578619 */   GIM_Try, /*On fail goto*//*Label 21852*/ GIMT_Encode4(1578701), // Rule ID 21713 //
     /* 1578624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1578627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1578632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1578635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1578638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1578641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578663 */     // MIs[0] round
     /* 1578663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578666 */     // MIs[0] policy
     /* 1578666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578676 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1578679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578700 */     // GIR_Coverage, 21713,
     /* 1578700 */     GIR_EraseRootFromParent_Done,
     /* 1578701 */   // Label 21852: @1578701
     /* 1578701 */   GIM_Try, /*On fail goto*//*Label 21853*/ GIMT_Encode4(1578783), // Rule ID 21836 //
     /* 1578706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1578709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1578714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1578717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1578720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1578723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1578726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578745 */     // MIs[0] round
     /* 1578745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578748 */     // MIs[0] policy
     /* 1578748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578758 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1578761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578782 */     // GIR_Coverage, 21836,
     /* 1578782 */     GIR_EraseRootFromParent_Done,
     /* 1578783 */   // Label 21853: @1578783
     /* 1578783 */   GIM_Try, /*On fail goto*//*Label 21854*/ GIMT_Encode4(1578865), // Rule ID 21837 //
     /* 1578788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1578791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1578796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1578799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1578802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1578805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1578808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578827 */     // MIs[0] round
     /* 1578827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578830 */     // MIs[0] policy
     /* 1578830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578840 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1578843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578864 */     // GIR_Coverage, 21837,
     /* 1578864 */     GIR_EraseRootFromParent_Done,
     /* 1578865 */   // Label 21854: @1578865
     /* 1578865 */   GIM_Try, /*On fail goto*//*Label 21855*/ GIMT_Encode4(1578947), // Rule ID 21840 //
     /* 1578870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1578873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1578878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1578881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1578884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1578887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578909 */     // MIs[0] round
     /* 1578909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578912 */     // MIs[0] policy
     /* 1578912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578922 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1578925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578946 */     // GIR_Coverage, 21840,
     /* 1578946 */     GIR_EraseRootFromParent_Done,
     /* 1578947 */   // Label 21855: @1578947
     /* 1578947 */   GIM_Try, /*On fail goto*//*Label 21856*/ GIMT_Encode4(1579029), // Rule ID 21841 //
     /* 1578952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1578955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1578960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1578963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1578966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1578969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578991 */     // MIs[0] round
     /* 1578991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578994 */     // MIs[0] policy
     /* 1578994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579004 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1579007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579028 */     // GIR_Coverage, 21841,
     /* 1579028 */     GIR_EraseRootFromParent_Done,
     /* 1579029 */   // Label 21856: @1579029
     /* 1579029 */   GIM_Try, /*On fail goto*//*Label 21857*/ GIMT_Encode4(1579111), // Rule ID 21844 //
     /* 1579034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1579037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1579042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1579045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1579048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1579051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1579054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579073 */     // MIs[0] round
     /* 1579073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579076 */     // MIs[0] policy
     /* 1579076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579086 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1579089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579110 */     // GIR_Coverage, 21844,
     /* 1579110 */     GIR_EraseRootFromParent_Done,
     /* 1579111 */   // Label 21857: @1579111
     /* 1579111 */   GIM_Try, /*On fail goto*//*Label 21858*/ GIMT_Encode4(1579193), // Rule ID 21845 //
     /* 1579116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1579119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1579124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1579127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1579130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1579133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1579136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579155 */     // MIs[0] round
     /* 1579155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579158 */     // MIs[0] policy
     /* 1579158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579168 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1579171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579192 */     // GIR_Coverage, 21845,
     /* 1579192 */     GIR_EraseRootFromParent_Done,
     /* 1579193 */   // Label 21858: @1579193
     /* 1579193 */   GIM_Try, /*On fail goto*//*Label 21859*/ GIMT_Encode4(1579275), // Rule ID 21848 //
     /* 1579198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1579201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1579206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1579209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1579212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1579215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1579218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579237 */     // MIs[0] round
     /* 1579237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579240 */     // MIs[0] policy
     /* 1579240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579250 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1579253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579274 */     // GIR_Coverage, 21848,
     /* 1579274 */     GIR_EraseRootFromParent_Done,
     /* 1579275 */   // Label 21859: @1579275
     /* 1579275 */   GIM_Try, /*On fail goto*//*Label 21860*/ GIMT_Encode4(1579357), // Rule ID 21849 //
     /* 1579280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1579283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1579288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1579291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1579294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1579297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1579300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579319 */     // MIs[0] round
     /* 1579319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579322 */     // MIs[0] policy
     /* 1579322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579332 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1579335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579356 */     // GIR_Coverage, 21849,
     /* 1579356 */     GIR_EraseRootFromParent_Done,
     /* 1579357 */   // Label 21860: @1579357
     /* 1579357 */   GIM_Try, /*On fail goto*//*Label 21861*/ GIMT_Encode4(1579439), // Rule ID 21852 //
     /* 1579362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1579365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1579370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1579373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1579376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1579379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1579382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579401 */     // MIs[0] round
     /* 1579401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579404 */     // MIs[0] policy
     /* 1579404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579414 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1579417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579438 */     // GIR_Coverage, 21852,
     /* 1579438 */     GIR_EraseRootFromParent_Done,
     /* 1579439 */   // Label 21861: @1579439
     /* 1579439 */   GIM_Try, /*On fail goto*//*Label 21862*/ GIMT_Encode4(1579521), // Rule ID 21853 //
     /* 1579444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1579447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1579452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1579455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1579458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1579461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1579464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579483 */     // MIs[0] round
     /* 1579483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579486 */     // MIs[0] policy
     /* 1579486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579496 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1579499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579520 */     // GIR_Coverage, 21853,
     /* 1579520 */     GIR_EraseRootFromParent_Done,
     /* 1579521 */   // Label 21862: @1579521
     /* 1579521 */   GIM_Try, /*On fail goto*//*Label 21863*/ GIMT_Encode4(1579603), // Rule ID 21856 //
     /* 1579526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1579529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1579534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1579537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1579540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1579543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1579546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579565 */     // MIs[0] round
     /* 1579565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579568 */     // MIs[0] policy
     /* 1579568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579578 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1579581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579602 */     // GIR_Coverage, 21856,
     /* 1579602 */     GIR_EraseRootFromParent_Done,
     /* 1579603 */   // Label 21863: @1579603
     /* 1579603 */   GIM_Try, /*On fail goto*//*Label 21864*/ GIMT_Encode4(1579685), // Rule ID 21857 //
     /* 1579608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1579611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1579616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1579619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1579622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1579625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1579628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579647 */     // MIs[0] round
     /* 1579647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579650 */     // MIs[0] policy
     /* 1579650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579660 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1579663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579684 */     // GIR_Coverage, 21857,
     /* 1579684 */     GIR_EraseRootFromParent_Done,
     /* 1579685 */   // Label 21864: @1579685
     /* 1579685 */   GIM_Try, /*On fail goto*//*Label 21865*/ GIMT_Encode4(1579767), // Rule ID 21860 //
     /* 1579690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1579693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1579698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1579701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1579704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1579707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1579710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579729 */     // MIs[0] round
     /* 1579729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579732 */     // MIs[0] policy
     /* 1579732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579742 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1579745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579766 */     // GIR_Coverage, 21860,
     /* 1579766 */     GIR_EraseRootFromParent_Done,
     /* 1579767 */   // Label 21865: @1579767
     /* 1579767 */   GIM_Try, /*On fail goto*//*Label 21866*/ GIMT_Encode4(1579849), // Rule ID 21861 //
     /* 1579772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1579775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1579780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1579783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1579786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1579789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1579792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579811 */     // MIs[0] round
     /* 1579811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579814 */     // MIs[0] policy
     /* 1579814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579824 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1579827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579848 */     // GIR_Coverage, 21861,
     /* 1579848 */     GIR_EraseRootFromParent_Done,
     /* 1579849 */   // Label 21866: @1579849
     /* 1579849 */   GIM_Try, /*On fail goto*//*Label 21867*/ GIMT_Encode4(1579931), // Rule ID 21864 //
     /* 1579854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1579857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1579862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1579865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1579868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1579871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1579874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579893 */     // MIs[0] round
     /* 1579893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579896 */     // MIs[0] policy
     /* 1579896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579906 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1579909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579930 */     // GIR_Coverage, 21864,
     /* 1579930 */     GIR_EraseRootFromParent_Done,
     /* 1579931 */   // Label 21867: @1579931
     /* 1579931 */   GIM_Try, /*On fail goto*//*Label 21868*/ GIMT_Encode4(1580013), // Rule ID 21865 //
     /* 1579936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1579939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1579944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1579947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1579950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1579953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1579956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579975 */     // MIs[0] round
     /* 1579975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579978 */     // MIs[0] policy
     /* 1579978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579988 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1579991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1580001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1580009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580012 */     // GIR_Coverage, 21865,
     /* 1580012 */     GIR_EraseRootFromParent_Done,
     /* 1580013 */   // Label 21868: @1580013
     /* 1580013 */   GIM_Try, /*On fail goto*//*Label 21869*/ GIMT_Encode4(1580095), // Rule ID 21868 //
     /* 1580018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1580021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1580026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1580029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1580032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1580035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1580038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580057 */     // MIs[0] round
     /* 1580057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1580060 */     // MIs[0] policy
     /* 1580060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580070 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1580073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1580079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1580081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1580083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1580091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580094 */     // GIR_Coverage, 21868,
     /* 1580094 */     GIR_EraseRootFromParent_Done,
     /* 1580095 */   // Label 21869: @1580095
     /* 1580095 */   GIM_Try, /*On fail goto*//*Label 21870*/ GIMT_Encode4(1580177), // Rule ID 21869 //
     /* 1580100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1580103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1580108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1580111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1580114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1580117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1580120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580139 */     // MIs[0] round
     /* 1580139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1580142 */     // MIs[0] policy
     /* 1580142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580152 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1580155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1580161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1580163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1580165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1580173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580176 */     // GIR_Coverage, 21869,
     /* 1580176 */     GIR_EraseRootFromParent_Done,
     /* 1580177 */   // Label 21870: @1580177
     /* 1580177 */   GIM_Try, /*On fail goto*//*Label 21871*/ GIMT_Encode4(1580259), // Rule ID 21872 //
     /* 1580182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1580185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1580190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1580193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1580196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1580199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1580202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580221 */     // MIs[0] round
     /* 1580221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1580224 */     // MIs[0] policy
     /* 1580224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580234 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1580237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1580243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1580245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1580247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580258 */     // GIR_Coverage, 21872,
     /* 1580258 */     GIR_EraseRootFromParent_Done,
     /* 1580259 */   // Label 21871: @1580259
     /* 1580259 */   GIM_Try, /*On fail goto*//*Label 21872*/ GIMT_Encode4(1580341), // Rule ID 21873 //
     /* 1580264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1580267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1580272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1580275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1580278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1580281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1580284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580303 */     // MIs[0] round
     /* 1580303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1580306 */     // MIs[0] policy
     /* 1580306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580316 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1580319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1580325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1580327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1580329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580340 */     // GIR_Coverage, 21873,
     /* 1580340 */     GIR_EraseRootFromParent_Done,
     /* 1580341 */   // Label 21872: @1580341
     /* 1580341 */   GIM_Try, /*On fail goto*//*Label 21873*/ GIMT_Encode4(1580423), // Rule ID 21876 //
     /* 1580346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1580349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1580354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1580357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1580360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1580363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1580366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580385 */     // MIs[0] round
     /* 1580385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1580388 */     // MIs[0] policy
     /* 1580388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580398 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1580401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1580407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1580409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1580411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580422 */     // GIR_Coverage, 21876,
     /* 1580422 */     GIR_EraseRootFromParent_Done,
     /* 1580423 */   // Label 21873: @1580423
     /* 1580423 */   GIM_Try, /*On fail goto*//*Label 21874*/ GIMT_Encode4(1580505), // Rule ID 21877 //
     /* 1580428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1580431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1580436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1580439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1580442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1580445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1580448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580467 */     // MIs[0] round
     /* 1580467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1580470 */     // MIs[0] policy
     /* 1580470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580480 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1580483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1580489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1580491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1580493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580504 */     // GIR_Coverage, 21877,
     /* 1580504 */     GIR_EraseRootFromParent_Done,
     /* 1580505 */   // Label 21874: @1580505
     /* 1580505 */   GIM_Try, /*On fail goto*//*Label 21875*/ GIMT_Encode4(1580587), // Rule ID 21880 //
     /* 1580510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1580513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1580518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1580521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1580524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1580527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1580530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580549 */     // MIs[0] round
     /* 1580549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1580552 */     // MIs[0] policy
     /* 1580552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580562 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1580565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1580571 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1580573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1580575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580586 */     // GIR_Coverage, 21880,
     /* 1580586 */     GIR_EraseRootFromParent_Done,
     /* 1580587 */   // Label 21875: @1580587
     /* 1580587 */   GIM_Try, /*On fail goto*//*Label 21876*/ GIMT_Encode4(1580669), // Rule ID 21881 //
     /* 1580592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1580595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1580600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1580603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1580606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1580609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1580612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580631 */     // MIs[0] round
     /* 1580631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1580634 */     // MIs[0] policy
     /* 1580634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580644 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1580647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1580653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1580655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1580657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580668 */     // GIR_Coverage, 21881,
     /* 1580668 */     GIR_EraseRootFromParent_Done,
     /* 1580669 */   // Label 21876: @1580669
     /* 1580669 */   GIM_Try, /*On fail goto*//*Label 21877*/ GIMT_Encode4(1580751), // Rule ID 21884 //
     /* 1580674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1580677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1580682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1580685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1580688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1580691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1580694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580713 */     // MIs[0] round
     /* 1580713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1580716 */     // MIs[0] policy
     /* 1580716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580726 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1580729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1580735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1580737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1580739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580750 */     // GIR_Coverage, 21884,
     /* 1580750 */     GIR_EraseRootFromParent_Done,
     /* 1580751 */   // Label 21877: @1580751
     /* 1580751 */   GIM_Try, /*On fail goto*//*Label 21878*/ GIMT_Encode4(1580833), // Rule ID 21885 //
     /* 1580756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1580759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1580764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1580767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1580770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1580773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1580776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580795 */     // MIs[0] round
     /* 1580795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1580798 */     // MIs[0] policy
     /* 1580798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580808 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1580811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1580817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1580819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1580821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580832 */     // GIR_Coverage, 21885,
     /* 1580832 */     GIR_EraseRootFromParent_Done,
     /* 1580833 */   // Label 21878: @1580833
     /* 1580833 */   GIM_Try, /*On fail goto*//*Label 21879*/ GIMT_Encode4(1580915), // Rule ID 21888 //
     /* 1580838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1580841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1580846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1580849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1580852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1580855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1580858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580877 */     // MIs[0] round
     /* 1580877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1580880 */     // MIs[0] policy
     /* 1580880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580890 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1580893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1580899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1580901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1580903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580914 */     // GIR_Coverage, 21888,
     /* 1580914 */     GIR_EraseRootFromParent_Done,
     /* 1580915 */   // Label 21879: @1580915
     /* 1580915 */   GIM_Try, /*On fail goto*//*Label 21880*/ GIMT_Encode4(1580997), // Rule ID 21889 //
     /* 1580920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1580923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1580928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1580931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1580934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1580937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1580940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580959 */     // MIs[0] round
     /* 1580959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1580962 */     // MIs[0] policy
     /* 1580962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580972 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1580975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1580981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1580983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1580985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580996 */     // GIR_Coverage, 21889,
     /* 1580996 */     GIR_EraseRootFromParent_Done,
     /* 1580997 */   // Label 21880: @1580997
     /* 1580997 */   GIM_Try, /*On fail goto*//*Label 21881*/ GIMT_Encode4(1581079), // Rule ID 21892 //
     /* 1581002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1581005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1581010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1581013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1581016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1581019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1581022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581041 */     // MIs[0] round
     /* 1581041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1581044 */     // MIs[0] policy
     /* 1581044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581054 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1581057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1581063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1581065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1581067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581078 */     // GIR_Coverage, 21892,
     /* 1581078 */     GIR_EraseRootFromParent_Done,
     /* 1581079 */   // Label 21881: @1581079
     /* 1581079 */   GIM_Try, /*On fail goto*//*Label 21882*/ GIMT_Encode4(1581161), // Rule ID 21893 //
     /* 1581084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1581087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1581092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1581095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1581098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1581101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1581104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581123 */     // MIs[0] round
     /* 1581123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1581126 */     // MIs[0] policy
     /* 1581126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581136 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1581139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1581145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1581147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1581149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581160 */     // GIR_Coverage, 21893,
     /* 1581160 */     GIR_EraseRootFromParent_Done,
     /* 1581161 */   // Label 21882: @1581161
     /* 1581161 */   GIM_Try, /*On fail goto*//*Label 21883*/ GIMT_Encode4(1581243), // Rule ID 21896 //
     /* 1581166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1581169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1581174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1581177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1581180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1581183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1581186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581205 */     // MIs[0] round
     /* 1581205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1581208 */     // MIs[0] policy
     /* 1581208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581218 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1581221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1581227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1581229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1581231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581242 */     // GIR_Coverage, 21896,
     /* 1581242 */     GIR_EraseRootFromParent_Done,
     /* 1581243 */   // Label 21883: @1581243
     /* 1581243 */   GIM_Try, /*On fail goto*//*Label 21884*/ GIMT_Encode4(1581325), // Rule ID 21897 //
     /* 1581248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1581251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1581256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1581259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1581262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1581265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1581268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581287 */     // MIs[0] round
     /* 1581287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1581290 */     // MIs[0] policy
     /* 1581290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581300 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1581303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1581309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1581311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1581313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581324 */     // GIR_Coverage, 21897,
     /* 1581324 */     GIR_EraseRootFromParent_Done,
     /* 1581325 */   // Label 21884: @1581325
     /* 1581325 */   GIM_Try, /*On fail goto*//*Label 21885*/ GIMT_Encode4(1581407), // Rule ID 21900 //
     /* 1581330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1581333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1581338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1581341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1581344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1581347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1581350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581369 */     // MIs[0] round
     /* 1581369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1581372 */     // MIs[0] policy
     /* 1581372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581382 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1581385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1581391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1581393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1581395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581406 */     // GIR_Coverage, 21900,
     /* 1581406 */     GIR_EraseRootFromParent_Done,
     /* 1581407 */   // Label 21885: @1581407
     /* 1581407 */   GIM_Try, /*On fail goto*//*Label 21886*/ GIMT_Encode4(1581489), // Rule ID 21901 //
     /* 1581412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1581415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1581420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1581423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1581426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1581429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1581432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581451 */     // MIs[0] round
     /* 1581451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1581454 */     // MIs[0] policy
     /* 1581454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581464 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1581467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1581473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1581475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1581477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581488 */     // GIR_Coverage, 21901,
     /* 1581488 */     GIR_EraseRootFromParent_Done,
     /* 1581489 */   // Label 21886: @1581489
     /* 1581489 */   GIM_Try, /*On fail goto*//*Label 21887*/ GIMT_Encode4(1581571), // Rule ID 21904 //
     /* 1581494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1581497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1581502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1581505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1581508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1581511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1581514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581533 */     // MIs[0] round
     /* 1581533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1581536 */     // MIs[0] policy
     /* 1581536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581546 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1581549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1581555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1581557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1581559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581570 */     // GIR_Coverage, 21904,
     /* 1581570 */     GIR_EraseRootFromParent_Done,
     /* 1581571 */   // Label 21887: @1581571
     /* 1581571 */   GIM_Try, /*On fail goto*//*Label 21888*/ GIMT_Encode4(1581653), // Rule ID 21905 //
     /* 1581576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1581579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1581584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1581587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1581590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1581593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1581596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581615 */     // MIs[0] round
     /* 1581615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1581618 */     // MIs[0] policy
     /* 1581618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581628 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1581631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1581637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1581639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1581641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581652 */     // GIR_Coverage, 21905,
     /* 1581652 */     GIR_EraseRootFromParent_Done,
     /* 1581653 */   // Label 21888: @1581653
     /* 1581653 */   GIM_Try, /*On fail goto*//*Label 21889*/ GIMT_Encode4(1581735), // Rule ID 21908 //
     /* 1581658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1581661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1581666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1581669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1581672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1581675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1581678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581697 */     // MIs[0] round
     /* 1581697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1581700 */     // MIs[0] policy
     /* 1581700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581710 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1581713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1581719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1581721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1581723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581734 */     // GIR_Coverage, 21908,
     /* 1581734 */     GIR_EraseRootFromParent_Done,
     /* 1581735 */   // Label 21889: @1581735
     /* 1581735 */   GIM_Try, /*On fail goto*//*Label 21890*/ GIMT_Encode4(1581817), // Rule ID 21909 //
     /* 1581740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1581743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1581748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1581751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1581754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1581757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1581760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581779 */     // MIs[0] round
     /* 1581779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1581782 */     // MIs[0] policy
     /* 1581782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581792 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1581795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1581801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1581803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1581805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581816 */     // GIR_Coverage, 21909,
     /* 1581816 */     GIR_EraseRootFromParent_Done,
     /* 1581817 */   // Label 21890: @1581817
     /* 1581817 */   GIM_Try, /*On fail goto*//*Label 21891*/ GIMT_Encode4(1581899), // Rule ID 21912 //
     /* 1581822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1581825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1581830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1581833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1581836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1581839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1581842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581861 */     // MIs[0] round
     /* 1581861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1581864 */     // MIs[0] policy
     /* 1581864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581874 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1581877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1581883 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1581885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1581887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581898 */     // GIR_Coverage, 21912,
     /* 1581898 */     GIR_EraseRootFromParent_Done,
     /* 1581899 */   // Label 21891: @1581899
     /* 1581899 */   GIM_Try, /*On fail goto*//*Label 21892*/ GIMT_Encode4(1581981), // Rule ID 21913 //
     /* 1581904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1581907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1581912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1581915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1581918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1581921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1581924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581943 */     // MIs[0] round
     /* 1581943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1581946 */     // MIs[0] policy
     /* 1581946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581956 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1581959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1581965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1581967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1581969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581980 */     // GIR_Coverage, 21913,
     /* 1581980 */     GIR_EraseRootFromParent_Done,
     /* 1581981 */   // Label 21892: @1581981
     /* 1581981 */   GIM_Try, /*On fail goto*//*Label 21893*/ GIMT_Encode4(1582063), // Rule ID 21916 //
     /* 1581986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1581989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1581994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1581997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1582000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1582003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1582006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582025 */     // MIs[0] round
     /* 1582025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1582028 */     // MIs[0] policy
     /* 1582028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582038 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1582041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1582047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1582049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1582051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582062 */     // GIR_Coverage, 21916,
     /* 1582062 */     GIR_EraseRootFromParent_Done,
     /* 1582063 */   // Label 21893: @1582063
     /* 1582063 */   GIM_Try, /*On fail goto*//*Label 21894*/ GIMT_Encode4(1582145), // Rule ID 21917 //
     /* 1582068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1582071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1582076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1582079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1582082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1582085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1582088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582107 */     // MIs[0] round
     /* 1582107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1582110 */     // MIs[0] policy
     /* 1582110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582120 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1582123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1582129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1582131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1582133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582144 */     // GIR_Coverage, 21917,
     /* 1582144 */     GIR_EraseRootFromParent_Done,
     /* 1582145 */   // Label 21894: @1582145
     /* 1582145 */   GIM_Try, /*On fail goto*//*Label 21895*/ GIMT_Encode4(1582227), // Rule ID 21920 //
     /* 1582150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1582153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1582158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1582161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1582164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1582167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1582170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582189 */     // MIs[0] round
     /* 1582189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1582192 */     // MIs[0] policy
     /* 1582192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582202 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1582205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1582211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1582213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1582215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582226 */     // GIR_Coverage, 21920,
     /* 1582226 */     GIR_EraseRootFromParent_Done,
     /* 1582227 */   // Label 21895: @1582227
     /* 1582227 */   GIM_Try, /*On fail goto*//*Label 21896*/ GIMT_Encode4(1582309), // Rule ID 21921 //
     /* 1582232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1582235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1582240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1582243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1582246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1582249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1582252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582271 */     // MIs[0] round
     /* 1582271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1582274 */     // MIs[0] policy
     /* 1582274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582284 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1582287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1582293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1582295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1582297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582308 */     // GIR_Coverage, 21921,
     /* 1582308 */     GIR_EraseRootFromParent_Done,
     /* 1582309 */   // Label 21896: @1582309
     /* 1582309 */   GIM_Try, /*On fail goto*//*Label 21897*/ GIMT_Encode4(1582391), // Rule ID 21924 //
     /* 1582314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1582317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1582322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1582325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1582328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1582331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1582334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582353 */     // MIs[0] round
     /* 1582353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1582356 */     // MIs[0] policy
     /* 1582356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582366 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1582369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1582375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1582377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1582379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582390 */     // GIR_Coverage, 21924,
     /* 1582390 */     GIR_EraseRootFromParent_Done,
     /* 1582391 */   // Label 21897: @1582391
     /* 1582391 */   GIM_Try, /*On fail goto*//*Label 21898*/ GIMT_Encode4(1582473), // Rule ID 21925 //
     /* 1582396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1582399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1582404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1582407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1582410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1582413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1582416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582435 */     // MIs[0] round
     /* 1582435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1582438 */     // MIs[0] policy
     /* 1582438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582448 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1582451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1582457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1582459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1582461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582472 */     // GIR_Coverage, 21925,
     /* 1582472 */     GIR_EraseRootFromParent_Done,
     /* 1582473 */   // Label 21898: @1582473
     /* 1582473 */   GIM_Try, /*On fail goto*//*Label 21899*/ GIMT_Encode4(1582555), // Rule ID 21928 //
     /* 1582478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1582481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1582486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1582489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1582492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1582495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1582498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582517 */     // MIs[0] round
     /* 1582517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1582520 */     // MIs[0] policy
     /* 1582520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582530 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1582533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1582539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1582541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1582543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582554 */     // GIR_Coverage, 21928,
     /* 1582554 */     GIR_EraseRootFromParent_Done,
     /* 1582555 */   // Label 21899: @1582555
     /* 1582555 */   GIM_Try, /*On fail goto*//*Label 21900*/ GIMT_Encode4(1582637), // Rule ID 21929 //
     /* 1582560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1582563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1582568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1582571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1582574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1582577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1582580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582599 */     // MIs[0] round
     /* 1582599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1582602 */     // MIs[0] policy
     /* 1582602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582612 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1582615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1582621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1582623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1582625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582636 */     // GIR_Coverage, 21929,
     /* 1582636 */     GIR_EraseRootFromParent_Done,
     /* 1582637 */   // Label 21900: @1582637
     /* 1582637 */   GIM_Try, /*On fail goto*//*Label 21901*/ GIMT_Encode4(1582719), // Rule ID 21932 //
     /* 1582642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1582645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1582650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1582653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1582656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1582659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1582662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582681 */     // MIs[0] round
     /* 1582681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1582684 */     // MIs[0] policy
     /* 1582684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582694 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1582697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1582703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1582705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1582707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582718 */     // GIR_Coverage, 21932,
     /* 1582718 */     GIR_EraseRootFromParent_Done,
     /* 1582719 */   // Label 21901: @1582719
     /* 1582719 */   GIM_Try, /*On fail goto*//*Label 21902*/ GIMT_Encode4(1582801), // Rule ID 21933 //
     /* 1582724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1582727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1582732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1582735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1582738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1582741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1582744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582763 */     // MIs[0] round
     /* 1582763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1582766 */     // MIs[0] policy
     /* 1582766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582776 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1582779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1582785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1582787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1582789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582800 */     // GIR_Coverage, 21933,
     /* 1582800 */     GIR_EraseRootFromParent_Done,
     /* 1582801 */   // Label 21902: @1582801
     /* 1582801 */   GIM_Try, /*On fail goto*//*Label 21903*/ GIMT_Encode4(1582883), // Rule ID 21936 //
     /* 1582806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1582809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1582814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1582817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1582820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1582823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1582826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582845 */     // MIs[0] round
     /* 1582845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1582848 */     // MIs[0] policy
     /* 1582848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582858 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1582861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1582867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1582869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1582871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582882 */     // GIR_Coverage, 21936,
     /* 1582882 */     GIR_EraseRootFromParent_Done,
     /* 1582883 */   // Label 21903: @1582883
     /* 1582883 */   GIM_Try, /*On fail goto*//*Label 21904*/ GIMT_Encode4(1582965), // Rule ID 21937 //
     /* 1582888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1582891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1582896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1582899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1582902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1582905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1582908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582927 */     // MIs[0] round
     /* 1582927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1582930 */     // MIs[0] policy
     /* 1582930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582940 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1582943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1582949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1582951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1582953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582964 */     // GIR_Coverage, 21937,
     /* 1582964 */     GIR_EraseRootFromParent_Done,
     /* 1582965 */   // Label 21904: @1582965
     /* 1582965 */   GIM_Try, /*On fail goto*//*Label 21905*/ GIMT_Encode4(1583047), // Rule ID 21940 //
     /* 1582970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1582973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1582978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1582981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1582984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1582987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1582990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583009 */     // MIs[0] round
     /* 1583009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1583012 */     // MIs[0] policy
     /* 1583012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583022 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1583025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1583031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1583033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1583035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583046 */     // GIR_Coverage, 21940,
     /* 1583046 */     GIR_EraseRootFromParent_Done,
     /* 1583047 */   // Label 21905: @1583047
     /* 1583047 */   GIM_Try, /*On fail goto*//*Label 21906*/ GIMT_Encode4(1583129), // Rule ID 21941 //
     /* 1583052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1583055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1583060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1583063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1583066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1583069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1583072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583091 */     // MIs[0] round
     /* 1583091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1583094 */     // MIs[0] policy
     /* 1583094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583104 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1583107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1583113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1583115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1583117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583128 */     // GIR_Coverage, 21941,
     /* 1583128 */     GIR_EraseRootFromParent_Done,
     /* 1583129 */   // Label 21906: @1583129
     /* 1583129 */   GIM_Try, /*On fail goto*//*Label 21907*/ GIMT_Encode4(1583211), // Rule ID 2750 //
     /* 1583134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1583142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1583145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1583148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1583151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583165 */     // MIs[0] passthru
     /* 1583165 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583178 */     // MIs[0] policy
     /* 1583178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583188 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1583191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583210 */     // GIR_Coverage, 2750,
     /* 1583210 */     GIR_EraseRootFromParent_Done,
     /* 1583211 */   // Label 21907: @1583211
     /* 1583211 */   GIM_Try, /*On fail goto*//*Label 21908*/ GIMT_Encode4(1583293), // Rule ID 2751 //
     /* 1583216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1583224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1583227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1583230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1583233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583247 */     // MIs[0] passthru
     /* 1583247 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583260 */     // MIs[0] policy
     /* 1583260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583270 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1583273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583292 */     // GIR_Coverage, 2751,
     /* 1583292 */     GIR_EraseRootFromParent_Done,
     /* 1583293 */   // Label 21908: @1583293
     /* 1583293 */   GIM_Try, /*On fail goto*//*Label 21909*/ GIMT_Encode4(1583375), // Rule ID 4066 //
     /* 1583298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1583306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1583309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1583312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1583315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583329 */     // MIs[0] passthru
     /* 1583329 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583342 */     // MIs[0] policy
     /* 1583342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583352 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1583355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583374 */     // GIR_Coverage, 4066,
     /* 1583374 */     GIR_EraseRootFromParent_Done,
     /* 1583375 */   // Label 21909: @1583375
     /* 1583375 */   GIM_Try, /*On fail goto*//*Label 21910*/ GIMT_Encode4(1583457), // Rule ID 4067 //
     /* 1583380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1583388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1583391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1583394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1583397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583411 */     // MIs[0] passthru
     /* 1583411 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583424 */     // MIs[0] policy
     /* 1583424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583434 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1583437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583456 */     // GIR_Coverage, 4067,
     /* 1583456 */     GIR_EraseRootFromParent_Done,
     /* 1583457 */   // Label 21910: @1583457
     /* 1583457 */   GIM_Try, /*On fail goto*//*Label 21911*/ GIMT_Encode4(1583539), // Rule ID 4076 //
     /* 1583462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1583470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1583473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1583476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1583479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583493 */     // MIs[0] passthru
     /* 1583493 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583506 */     // MIs[0] policy
     /* 1583506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583516 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1583519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583538 */     // GIR_Coverage, 4076,
     /* 1583538 */     GIR_EraseRootFromParent_Done,
     /* 1583539 */   // Label 21911: @1583539
     /* 1583539 */   GIM_Try, /*On fail goto*//*Label 21912*/ GIMT_Encode4(1583621), // Rule ID 4077 //
     /* 1583544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1583552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1583555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1583558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1583561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583575 */     // MIs[0] passthru
     /* 1583575 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583588 */     // MIs[0] policy
     /* 1583588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583598 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1583601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583620 */     // GIR_Coverage, 4077,
     /* 1583620 */     GIR_EraseRootFromParent_Done,
     /* 1583621 */   // Label 21912: @1583621
     /* 1583621 */   GIM_Try, /*On fail goto*//*Label 21913*/ GIMT_Encode4(1583703), // Rule ID 4086 //
     /* 1583626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1583634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1583637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1583640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1583643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1583646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583657 */     // MIs[0] passthru
     /* 1583657 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583670 */     // MIs[0] policy
     /* 1583670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583680 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1583683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583702 */     // GIR_Coverage, 4086,
     /* 1583702 */     GIR_EraseRootFromParent_Done,
     /* 1583703 */   // Label 21913: @1583703
     /* 1583703 */   GIM_Try, /*On fail goto*//*Label 21914*/ GIMT_Encode4(1583785), // Rule ID 4087 //
     /* 1583708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1583716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1583719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1583722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1583725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1583728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583739 */     // MIs[0] passthru
     /* 1583739 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583752 */     // MIs[0] policy
     /* 1583752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1583765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583784 */     // GIR_Coverage, 4087,
     /* 1583784 */     GIR_EraseRootFromParent_Done,
     /* 1583785 */   // Label 21914: @1583785
     /* 1583785 */   GIM_Try, /*On fail goto*//*Label 21915*/ GIMT_Encode4(1583867), // Rule ID 4096 //
     /* 1583790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1583798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1583801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1583804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1583807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1583810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583821 */     // MIs[0] passthru
     /* 1583821 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583834 */     // MIs[0] policy
     /* 1583834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583844 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1583847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583866 */     // GIR_Coverage, 4096,
     /* 1583866 */     GIR_EraseRootFromParent_Done,
     /* 1583867 */   // Label 21915: @1583867
     /* 1583867 */   GIM_Try, /*On fail goto*//*Label 21916*/ GIMT_Encode4(1583949), // Rule ID 4097 //
     /* 1583872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1583880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1583883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1583886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1583889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1583892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583903 */     // MIs[0] passthru
     /* 1583903 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583916 */     // MIs[0] policy
     /* 1583916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1583929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583948 */     // GIR_Coverage, 4097,
     /* 1583948 */     GIR_EraseRootFromParent_Done,
     /* 1583949 */   // Label 21916: @1583949
     /* 1583949 */   GIM_Try, /*On fail goto*//*Label 21917*/ GIMT_Encode4(1584031), // Rule ID 4106 //
     /* 1583954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1583962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1583965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1583968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1583971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1583974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583985 */     // MIs[0] passthru
     /* 1583985 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583998 */     // MIs[0] policy
     /* 1583998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584008 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1584011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584030 */     // GIR_Coverage, 4106,
     /* 1584030 */     GIR_EraseRootFromParent_Done,
     /* 1584031 */   // Label 21917: @1584031
     /* 1584031 */   GIM_Try, /*On fail goto*//*Label 21918*/ GIMT_Encode4(1584113), // Rule ID 4107 //
     /* 1584036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1584044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1584047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1584050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1584053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1584056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1584063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1584067 */     // MIs[0] passthru
     /* 1584067 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584080 */     // MIs[0] policy
     /* 1584080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584090 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1584093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584112 */     // GIR_Coverage, 4107,
     /* 1584112 */     GIR_EraseRootFromParent_Done,
     /* 1584113 */   // Label 21918: @1584113
     /* 1584113 */   GIM_Try, /*On fail goto*//*Label 21919*/ GIMT_Encode4(1584195), // Rule ID 4116 //
     /* 1584118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1584126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1584129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1584132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1584135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584149 */     // MIs[0] passthru
     /* 1584149 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584162 */     // MIs[0] policy
     /* 1584162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584172 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1584175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584194 */     // GIR_Coverage, 4116,
     /* 1584194 */     GIR_EraseRootFromParent_Done,
     /* 1584195 */   // Label 21919: @1584195
     /* 1584195 */   GIM_Try, /*On fail goto*//*Label 21920*/ GIMT_Encode4(1584277), // Rule ID 4117 //
     /* 1584200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1584208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1584211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1584214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1584217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584231 */     // MIs[0] passthru
     /* 1584231 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584244 */     // MIs[0] policy
     /* 1584244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584254 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1584257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584276 */     // GIR_Coverage, 4117,
     /* 1584276 */     GIR_EraseRootFromParent_Done,
     /* 1584277 */   // Label 21920: @1584277
     /* 1584277 */   GIM_Try, /*On fail goto*//*Label 21921*/ GIMT_Encode4(1584359), // Rule ID 4126 //
     /* 1584282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1584290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1584293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1584296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1584299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584313 */     // MIs[0] passthru
     /* 1584313 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584326 */     // MIs[0] policy
     /* 1584326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11623:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1584339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584358 */     // GIR_Coverage, 4126,
     /* 1584358 */     GIR_EraseRootFromParent_Done,
     /* 1584359 */   // Label 21921: @1584359
     /* 1584359 */   GIM_Try, /*On fail goto*//*Label 21922*/ GIMT_Encode4(1584441), // Rule ID 4127 //
     /* 1584364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1584372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1584375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1584378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1584381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584395 */     // MIs[0] passthru
     /* 1584395 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584408 */     // MIs[0] policy
     /* 1584408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11623:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1584421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584440 */     // GIR_Coverage, 4127,
     /* 1584440 */     GIR_EraseRootFromParent_Done,
     /* 1584441 */   // Label 21922: @1584441
     /* 1584441 */   GIM_Try, /*On fail goto*//*Label 21923*/ GIMT_Encode4(1584523), // Rule ID 4136 //
     /* 1584446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1584454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1584457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1584460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1584463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584477 */     // MIs[0] passthru
     /* 1584477 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584490 */     // MIs[0] policy
     /* 1584490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1584503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584522 */     // GIR_Coverage, 4136,
     /* 1584522 */     GIR_EraseRootFromParent_Done,
     /* 1584523 */   // Label 21923: @1584523
     /* 1584523 */   GIM_Try, /*On fail goto*//*Label 21924*/ GIMT_Encode4(1584605), // Rule ID 4137 //
     /* 1584528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1584536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1584539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1584542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1584545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584559 */     // MIs[0] passthru
     /* 1584559 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584572 */     // MIs[0] policy
     /* 1584572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1584585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584604 */     // GIR_Coverage, 4137,
     /* 1584604 */     GIR_EraseRootFromParent_Done,
     /* 1584605 */   // Label 21924: @1584605
     /* 1584605 */   GIM_Try, /*On fail goto*//*Label 21925*/ GIMT_Encode4(1584687), // Rule ID 4146 //
     /* 1584610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1584618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1584621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1584624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1584627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584641 */     // MIs[0] passthru
     /* 1584641 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584654 */     // MIs[0] policy
     /* 1584654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584664 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1584667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584686 */     // GIR_Coverage, 4146,
     /* 1584686 */     GIR_EraseRootFromParent_Done,
     /* 1584687 */   // Label 21925: @1584687
     /* 1584687 */   GIM_Try, /*On fail goto*//*Label 21926*/ GIMT_Encode4(1584769), // Rule ID 4147 //
     /* 1584692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1584700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1584703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1584706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1584709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584723 */     // MIs[0] passthru
     /* 1584723 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584736 */     // MIs[0] policy
     /* 1584736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1584749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584768 */     // GIR_Coverage, 4147,
     /* 1584768 */     GIR_EraseRootFromParent_Done,
     /* 1584769 */   // Label 21926: @1584769
     /* 1584769 */   GIM_Try, /*On fail goto*//*Label 21927*/ GIMT_Encode4(1584851), // Rule ID 4156 //
     /* 1584774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1584782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1584785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1584788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1584791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1584794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1584801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1584805 */     // MIs[0] passthru
     /* 1584805 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584818 */     // MIs[0] policy
     /* 1584818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584828 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1584831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584850 */     // GIR_Coverage, 4156,
     /* 1584850 */     GIR_EraseRootFromParent_Done,
     /* 1584851 */   // Label 21927: @1584851
     /* 1584851 */   GIM_Try, /*On fail goto*//*Label 21928*/ GIMT_Encode4(1584933), // Rule ID 4157 //
     /* 1584856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1584864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1584867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1584870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1584873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1584876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1584883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1584887 */     // MIs[0] passthru
     /* 1584887 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584900 */     // MIs[0] policy
     /* 1584900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584910 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1584913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584932 */     // GIR_Coverage, 4157,
     /* 1584932 */     GIR_EraseRootFromParent_Done,
     /* 1584933 */   // Label 21928: @1584933
     /* 1584933 */   GIM_Try, /*On fail goto*//*Label 21929*/ GIMT_Encode4(1585015), // Rule ID 4166 //
     /* 1584938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1584941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1584946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1584949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1584952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1584955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584969 */     // MIs[0] passthru
     /* 1584969 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584982 */     // MIs[0] policy
     /* 1584982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584992 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1584995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1585011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585014 */     // GIR_Coverage, 4166,
     /* 1585014 */     GIR_EraseRootFromParent_Done,
     /* 1585015 */   // Label 21929: @1585015
     /* 1585015 */   GIM_Try, /*On fail goto*//*Label 21930*/ GIMT_Encode4(1585097), // Rule ID 4167 //
     /* 1585020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1585023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1585028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1585031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1585034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1585037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1585040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585051 */     // MIs[0] passthru
     /* 1585051 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585064 */     // MIs[0] policy
     /* 1585064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1585077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1585093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585096 */     // GIR_Coverage, 4167,
     /* 1585096 */     GIR_EraseRootFromParent_Done,
     /* 1585097 */   // Label 21930: @1585097
     /* 1585097 */   GIM_Try, /*On fail goto*//*Label 21931*/ GIMT_Encode4(1585179), // Rule ID 4176 //
     /* 1585102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1585105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1585110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1585113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1585116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1585119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585133 */     // MIs[0] passthru
     /* 1585133 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585146 */     // MIs[0] policy
     /* 1585146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585156 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1585159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1585175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585178 */     // GIR_Coverage, 4176,
     /* 1585178 */     GIR_EraseRootFromParent_Done,
     /* 1585179 */   // Label 21931: @1585179
     /* 1585179 */   GIM_Try, /*On fail goto*//*Label 21932*/ GIMT_Encode4(1585261), // Rule ID 4177 //
     /* 1585184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1585187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1585192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1585195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1585198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1585201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585215 */     // MIs[0] passthru
     /* 1585215 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585228 */     // MIs[0] policy
     /* 1585228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1585241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1585257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585260 */     // GIR_Coverage, 4177,
     /* 1585260 */     GIR_EraseRootFromParent_Done,
     /* 1585261 */   // Label 21932: @1585261
     /* 1585261 */   GIM_Try, /*On fail goto*//*Label 21933*/ GIMT_Encode4(1585343), // Rule ID 4186 //
     /* 1585266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1585269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1585274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1585277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1585280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1585283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585297 */     // MIs[0] passthru
     /* 1585297 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585310 */     // MIs[0] policy
     /* 1585310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585320 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1585323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1585339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585342 */     // GIR_Coverage, 4186,
     /* 1585342 */     GIR_EraseRootFromParent_Done,
     /* 1585343 */   // Label 21933: @1585343
     /* 1585343 */   GIM_Try, /*On fail goto*//*Label 21934*/ GIMT_Encode4(1585425), // Rule ID 4187 //
     /* 1585348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1585351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1585356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1585359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1585362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1585365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585379 */     // MIs[0] passthru
     /* 1585379 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585392 */     // MIs[0] policy
     /* 1585392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585402 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1585405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1585421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585424 */     // GIR_Coverage, 4187,
     /* 1585424 */     GIR_EraseRootFromParent_Done,
     /* 1585425 */   // Label 21934: @1585425
     /* 1585425 */   GIM_Try, /*On fail goto*//*Label 21935*/ GIMT_Encode4(1585507), // Rule ID 4196 //
     /* 1585430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1585433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1585438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1585441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1585444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1585447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585461 */     // MIs[0] passthru
     /* 1585461 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585474 */     // MIs[0] policy
     /* 1585474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1585487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1585503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585506 */     // GIR_Coverage, 4196,
     /* 1585506 */     GIR_EraseRootFromParent_Done,
     /* 1585507 */   // Label 21935: @1585507
     /* 1585507 */   GIM_Try, /*On fail goto*//*Label 21936*/ GIMT_Encode4(1585589), // Rule ID 4197 //
     /* 1585512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1585515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1585520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1585523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1585526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1585529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585543 */     // MIs[0] passthru
     /* 1585543 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585556 */     // MIs[0] policy
     /* 1585556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585566 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1585569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1585585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585588 */     // GIR_Coverage, 4197,
     /* 1585588 */     GIR_EraseRootFromParent_Done,
     /* 1585589 */   // Label 21936: @1585589
     /* 1585589 */   GIM_Try, /*On fail goto*//*Label 21937*/ GIMT_Encode4(1585671), // Rule ID 4266 //
     /* 1585594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1585602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1585605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1585608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1585611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1585614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585625 */     // MIs[0] passthru
     /* 1585625 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585638 */     // MIs[0] policy
     /* 1585638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1585651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585670 */     // GIR_Coverage, 4266,
     /* 1585670 */     GIR_EraseRootFromParent_Done,
     /* 1585671 */   // Label 21937: @1585671
     /* 1585671 */   GIM_Try, /*On fail goto*//*Label 21938*/ GIMT_Encode4(1585753), // Rule ID 4267 //
     /* 1585676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1585684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1585687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1585690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1585693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1585696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585707 */     // MIs[0] passthru
     /* 1585707 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585720 */     // MIs[0] policy
     /* 1585720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585730 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1585733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585752 */     // GIR_Coverage, 4267,
     /* 1585752 */     GIR_EraseRootFromParent_Done,
     /* 1585753 */   // Label 21938: @1585753
     /* 1585753 */   GIM_Try, /*On fail goto*//*Label 21939*/ GIMT_Encode4(1585835), // Rule ID 4276 //
     /* 1585758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1585766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1585769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1585772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1585775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585789 */     // MIs[0] passthru
     /* 1585789 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585802 */     // MIs[0] policy
     /* 1585802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585812 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1585815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585834 */     // GIR_Coverage, 4276,
     /* 1585834 */     GIR_EraseRootFromParent_Done,
     /* 1585835 */   // Label 21939: @1585835
     /* 1585835 */   GIM_Try, /*On fail goto*//*Label 21940*/ GIMT_Encode4(1585917), // Rule ID 4277 //
     /* 1585840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1585848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1585851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1585854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1585857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585871 */     // MIs[0] passthru
     /* 1585871 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585884 */     // MIs[0] policy
     /* 1585884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585894 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1585897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585916 */     // GIR_Coverage, 4277,
     /* 1585916 */     GIR_EraseRootFromParent_Done,
     /* 1585917 */   // Label 21940: @1585917
     /* 1585917 */   GIM_Try, /*On fail goto*//*Label 21941*/ GIMT_Encode4(1585999), // Rule ID 4286 //
     /* 1585922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1585930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1585933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1585936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1585939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585953 */     // MIs[0] passthru
     /* 1585953 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585966 */     // MIs[0] policy
     /* 1585966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585976 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1585979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585998 */     // GIR_Coverage, 4286,
     /* 1585998 */     GIR_EraseRootFromParent_Done,
     /* 1585999 */   // Label 21941: @1585999
     /* 1585999 */   GIM_Try, /*On fail goto*//*Label 21942*/ GIMT_Encode4(1586081), // Rule ID 4287 //
     /* 1586004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1586012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1586015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1586018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1586021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586035 */     // MIs[0] passthru
     /* 1586035 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586048 */     // MIs[0] policy
     /* 1586048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1586061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586080 */     // GIR_Coverage, 4287,
     /* 1586080 */     GIR_EraseRootFromParent_Done,
     /* 1586081 */   // Label 21942: @1586081
     /* 1586081 */   GIM_Try, /*On fail goto*//*Label 21943*/ GIMT_Encode4(1586163), // Rule ID 4296 //
     /* 1586086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1586094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1586097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1586100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1586103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586117 */     // MIs[0] passthru
     /* 1586117 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586130 */     // MIs[0] policy
     /* 1586130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586140 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1586143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586162 */     // GIR_Coverage, 4296,
     /* 1586162 */     GIR_EraseRootFromParent_Done,
     /* 1586163 */   // Label 21943: @1586163
     /* 1586163 */   GIM_Try, /*On fail goto*//*Label 21944*/ GIMT_Encode4(1586245), // Rule ID 4297 //
     /* 1586168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1586176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1586179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1586182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1586185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586199 */     // MIs[0] passthru
     /* 1586199 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586212 */     // MIs[0] policy
     /* 1586212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1586225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586244 */     // GIR_Coverage, 4297,
     /* 1586244 */     GIR_EraseRootFromParent_Done,
     /* 1586245 */   // Label 21944: @1586245
     /* 1586245 */   GIM_Try, /*On fail goto*//*Label 21945*/ GIMT_Encode4(1586327), // Rule ID 4306 //
     /* 1586250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1586258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1586261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1586264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1586267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1586270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586281 */     // MIs[0] passthru
     /* 1586281 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586294 */     // MIs[0] policy
     /* 1586294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586304 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1586307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586326 */     // GIR_Coverage, 4306,
     /* 1586326 */     GIR_EraseRootFromParent_Done,
     /* 1586327 */   // Label 21945: @1586327
     /* 1586327 */   GIM_Try, /*On fail goto*//*Label 21946*/ GIMT_Encode4(1586409), // Rule ID 4307 //
     /* 1586332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1586340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1586343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1586346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1586349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1586352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586363 */     // MIs[0] passthru
     /* 1586363 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586376 */     // MIs[0] policy
     /* 1586376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586386 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1586389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586408 */     // GIR_Coverage, 4307,
     /* 1586408 */     GIR_EraseRootFromParent_Done,
     /* 1586409 */   // Label 21946: @1586409
     /* 1586409 */   GIM_Try, /*On fail goto*//*Label 21947*/ GIMT_Encode4(1586491), // Rule ID 4316 //
     /* 1586414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1586422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1586425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1586428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1586431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1586434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586445 */     // MIs[0] passthru
     /* 1586445 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586458 */     // MIs[0] policy
     /* 1586458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586468 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1586471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586490 */     // GIR_Coverage, 4316,
     /* 1586490 */     GIR_EraseRootFromParent_Done,
     /* 1586491 */   // Label 21947: @1586491
     /* 1586491 */   GIM_Try, /*On fail goto*//*Label 21948*/ GIMT_Encode4(1586573), // Rule ID 4317 //
     /* 1586496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1586504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1586507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1586510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1586513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1586516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586527 */     // MIs[0] passthru
     /* 1586527 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586540 */     // MIs[0] policy
     /* 1586540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586550 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1586553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586572 */     // GIR_Coverage, 4317,
     /* 1586572 */     GIR_EraseRootFromParent_Done,
     /* 1586573 */   // Label 21948: @1586573
     /* 1586573 */   GIM_Try, /*On fail goto*//*Label 21949*/ GIMT_Encode4(1586655), // Rule ID 4326 //
     /* 1586578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1586586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1586589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1586592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1586595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586609 */     // MIs[0] passthru
     /* 1586609 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586622 */     // MIs[0] policy
     /* 1586622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586632 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1586635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586654 */     // GIR_Coverage, 4326,
     /* 1586654 */     GIR_EraseRootFromParent_Done,
     /* 1586655 */   // Label 21949: @1586655
     /* 1586655 */   GIM_Try, /*On fail goto*//*Label 21950*/ GIMT_Encode4(1586737), // Rule ID 4327 //
     /* 1586660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1586668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1586671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1586674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1586677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586691 */     // MIs[0] passthru
     /* 1586691 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586704 */     // MIs[0] policy
     /* 1586704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1586717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586736 */     // GIR_Coverage, 4327,
     /* 1586736 */     GIR_EraseRootFromParent_Done,
     /* 1586737 */   // Label 21950: @1586737
     /* 1586737 */   GIM_Try, /*On fail goto*//*Label 21951*/ GIMT_Encode4(1586819), // Rule ID 4336 //
     /* 1586742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1586750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1586753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1586756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1586759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586773 */     // MIs[0] passthru
     /* 1586773 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586786 */     // MIs[0] policy
     /* 1586786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1586799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586818 */     // GIR_Coverage, 4336,
     /* 1586818 */     GIR_EraseRootFromParent_Done,
     /* 1586819 */   // Label 21951: @1586819
     /* 1586819 */   GIM_Try, /*On fail goto*//*Label 21952*/ GIMT_Encode4(1586901), // Rule ID 4337 //
     /* 1586824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1586832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1586835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1586838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1586841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586855 */     // MIs[0] passthru
     /* 1586855 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586868 */     // MIs[0] policy
     /* 1586868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586878 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1586881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586900 */     // GIR_Coverage, 4337,
     /* 1586900 */     GIR_EraseRootFromParent_Done,
     /* 1586901 */   // Label 21952: @1586901
     /* 1586901 */   GIM_Try, /*On fail goto*//*Label 21953*/ GIMT_Encode4(1586983), // Rule ID 4346 //
     /* 1586906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1586914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1586917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1586920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1586923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586937 */     // MIs[0] passthru
     /* 1586937 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586950 */     // MIs[0] policy
     /* 1586950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586960 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1586963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586982 */     // GIR_Coverage, 4346,
     /* 1586982 */     GIR_EraseRootFromParent_Done,
     /* 1586983 */   // Label 21953: @1586983
     /* 1586983 */   GIM_Try, /*On fail goto*//*Label 21954*/ GIMT_Encode4(1587065), // Rule ID 4347 //
     /* 1586988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1586996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1586999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1587002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1587005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1587015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587019 */     // MIs[0] passthru
     /* 1587019 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587032 */     // MIs[0] policy
     /* 1587032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1587045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587064 */     // GIR_Coverage, 4347,
     /* 1587064 */     GIR_EraseRootFromParent_Done,
     /* 1587065 */   // Label 21954: @1587065
     /* 1587065 */   GIM_Try, /*On fail goto*//*Label 21955*/ GIMT_Encode4(1587147), // Rule ID 4356 //
     /* 1587070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1587078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1587081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1587084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1587087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1587097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587101 */     // MIs[0] passthru
     /* 1587101 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587114 */     // MIs[0] policy
     /* 1587114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587124 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1587127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587146 */     // GIR_Coverage, 4356,
     /* 1587146 */     GIR_EraseRootFromParent_Done,
     /* 1587147 */   // Label 21955: @1587147
     /* 1587147 */   GIM_Try, /*On fail goto*//*Label 21956*/ GIMT_Encode4(1587229), // Rule ID 4357 //
     /* 1587152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1587160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1587163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1587166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1587169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1587179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587183 */     // MIs[0] passthru
     /* 1587183 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587196 */     // MIs[0] policy
     /* 1587196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1587209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587228 */     // GIR_Coverage, 4357,
     /* 1587228 */     GIR_EraseRootFromParent_Done,
     /* 1587229 */   // Label 21956: @1587229
     /* 1587229 */   GIM_Try, /*On fail goto*//*Label 21957*/ GIMT_Encode4(1587311), // Rule ID 4366 //
     /* 1587234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1587242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1587245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1587248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1587251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1587254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1587261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1587265 */     // MIs[0] passthru
     /* 1587265 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587278 */     // MIs[0] policy
     /* 1587278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587288 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1587291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587310 */     // GIR_Coverage, 4366,
     /* 1587310 */     GIR_EraseRootFromParent_Done,
     /* 1587311 */   // Label 21957: @1587311
     /* 1587311 */   GIM_Try, /*On fail goto*//*Label 21958*/ GIMT_Encode4(1587393), // Rule ID 4367 //
     /* 1587316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1587324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1587327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1587330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1587333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1587336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1587343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1587347 */     // MIs[0] passthru
     /* 1587347 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587360 */     // MIs[0] policy
     /* 1587360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587370 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1587373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587392 */     // GIR_Coverage, 4367,
     /* 1587392 */     GIR_EraseRootFromParent_Done,
     /* 1587393 */   // Label 21958: @1587393
     /* 1587393 */   GIM_Try, /*On fail goto*//*Label 21959*/ GIMT_Encode4(1587475), // Rule ID 4376 //
     /* 1587398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1587401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1587406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1587409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1587412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1587415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587429 */     // MIs[0] passthru
     /* 1587429 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587442 */     // MIs[0] policy
     /* 1587442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587452 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1587455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587474 */     // GIR_Coverage, 4376,
     /* 1587474 */     GIR_EraseRootFromParent_Done,
     /* 1587475 */   // Label 21959: @1587475
     /* 1587475 */   GIM_Try, /*On fail goto*//*Label 21960*/ GIMT_Encode4(1587557), // Rule ID 4377 //
     /* 1587480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1587483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1587488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1587491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1587494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1587497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587511 */     // MIs[0] passthru
     /* 1587511 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587524 */     // MIs[0] policy
     /* 1587524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587534 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1587537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587556 */     // GIR_Coverage, 4377,
     /* 1587556 */     GIR_EraseRootFromParent_Done,
     /* 1587557 */   // Label 21960: @1587557
     /* 1587557 */   GIM_Try, /*On fail goto*//*Label 21961*/ GIMT_Encode4(1587639), // Rule ID 4386 //
     /* 1587562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1587565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1587570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1587573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1587576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1587579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1587589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587593 */     // MIs[0] passthru
     /* 1587593 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587606 */     // MIs[0] policy
     /* 1587606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1587619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587638 */     // GIR_Coverage, 4386,
     /* 1587638 */     GIR_EraseRootFromParent_Done,
     /* 1587639 */   // Label 21961: @1587639
     /* 1587639 */   GIM_Try, /*On fail goto*//*Label 21962*/ GIMT_Encode4(1587721), // Rule ID 4387 //
     /* 1587644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1587647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1587652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1587655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1587658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1587661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1587671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587675 */     // MIs[0] passthru
     /* 1587675 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587688 */     // MIs[0] policy
     /* 1587688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587698 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1587701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587720 */     // GIR_Coverage, 4387,
     /* 1587720 */     GIR_EraseRootFromParent_Done,
     /* 1587721 */   // Label 21962: @1587721
     /* 1587721 */   GIM_Try, /*On fail goto*//*Label 21963*/ GIMT_Encode4(1587803), // Rule ID 4396 //
     /* 1587726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1587729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1587734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1587737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1587740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1587743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1587753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587757 */     // MIs[0] passthru
     /* 1587757 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587770 */     // MIs[0] policy
     /* 1587770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587780 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1587783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587802 */     // GIR_Coverage, 4396,
     /* 1587802 */     GIR_EraseRootFromParent_Done,
     /* 1587803 */   // Label 21963: @1587803
     /* 1587803 */   GIM_Try, /*On fail goto*//*Label 21964*/ GIMT_Encode4(1587885), // Rule ID 4397 //
     /* 1587808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1587811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1587816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1587819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1587822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1587825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1587835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587839 */     // MIs[0] passthru
     /* 1587839 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587852 */     // MIs[0] policy
     /* 1587852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587862 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1587865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587884 */     // GIR_Coverage, 4397,
     /* 1587884 */     GIR_EraseRootFromParent_Done,
     /* 1587885 */   // Label 21964: @1587885
     /* 1587885 */   GIM_Try, /*On fail goto*//*Label 21965*/ GIMT_Encode4(1587967), // Rule ID 4406 //
     /* 1587890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1587893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1587898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1587901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1587904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1587907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1587917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1587921 */     // MIs[0] passthru
     /* 1587921 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587934 */     // MIs[0] policy
     /* 1587934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587944 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1587947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587966 */     // GIR_Coverage, 4406,
     /* 1587966 */     GIR_EraseRootFromParent_Done,
     /* 1587967 */   // Label 21965: @1587967
     /* 1587967 */   GIM_Try, /*On fail goto*//*Label 21966*/ GIMT_Encode4(1588049), // Rule ID 4407 //
     /* 1587972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1587975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1587980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1587983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1587986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1587989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1587999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588003 */     // MIs[0] passthru
     /* 1588003 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588016 */     // MIs[0] policy
     /* 1588016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588026 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1588029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588048 */     // GIR_Coverage, 4407,
     /* 1588048 */     GIR_EraseRootFromParent_Done,
     /* 1588049 */   // Label 21966: @1588049
     /* 1588049 */   GIM_Try, /*On fail goto*//*Label 21967*/ GIMT_Encode4(1588131), // Rule ID 4476 //
     /* 1588054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1588062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1588065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1588068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1588071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588085 */     // MIs[0] passthru
     /* 1588085 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588098 */     // MIs[0] policy
     /* 1588098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588108 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1588111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588130 */     // GIR_Coverage, 4476,
     /* 1588130 */     GIR_EraseRootFromParent_Done,
     /* 1588131 */   // Label 21967: @1588131
     /* 1588131 */   GIM_Try, /*On fail goto*//*Label 21968*/ GIMT_Encode4(1588213), // Rule ID 4477 //
     /* 1588136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1588144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1588147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1588150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1588153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588167 */     // MIs[0] passthru
     /* 1588167 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588180 */     // MIs[0] policy
     /* 1588180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1588193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588212 */     // GIR_Coverage, 4477,
     /* 1588212 */     GIR_EraseRootFromParent_Done,
     /* 1588213 */   // Label 21968: @1588213
     /* 1588213 */   GIM_Try, /*On fail goto*//*Label 21969*/ GIMT_Encode4(1588295), // Rule ID 4486 //
     /* 1588218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1588226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1588229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1588232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1588235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588249 */     // MIs[0] passthru
     /* 1588249 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588262 */     // MIs[0] policy
     /* 1588262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588272 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1588275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588294 */     // GIR_Coverage, 4486,
     /* 1588294 */     GIR_EraseRootFromParent_Done,
     /* 1588295 */   // Label 21969: @1588295
     /* 1588295 */   GIM_Try, /*On fail goto*//*Label 21970*/ GIMT_Encode4(1588377), // Rule ID 4487 //
     /* 1588300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1588308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1588311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1588314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1588317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588331 */     // MIs[0] passthru
     /* 1588331 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588344 */     // MIs[0] policy
     /* 1588344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588354 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1588357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588376 */     // GIR_Coverage, 4487,
     /* 1588376 */     GIR_EraseRootFromParent_Done,
     /* 1588377 */   // Label 21970: @1588377
     /* 1588377 */   GIM_Try, /*On fail goto*//*Label 21971*/ GIMT_Encode4(1588459), // Rule ID 4496 //
     /* 1588382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1588390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1588393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1588396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1588399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588413 */     // MIs[0] passthru
     /* 1588413 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588426 */     // MIs[0] policy
     /* 1588426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588436 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1588439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588458 */     // GIR_Coverage, 4496,
     /* 1588458 */     GIR_EraseRootFromParent_Done,
     /* 1588459 */   // Label 21971: @1588459
     /* 1588459 */   GIM_Try, /*On fail goto*//*Label 21972*/ GIMT_Encode4(1588541), // Rule ID 4497 //
     /* 1588464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1588472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1588475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1588478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1588481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588495 */     // MIs[0] passthru
     /* 1588495 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588508 */     // MIs[0] policy
     /* 1588508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1588521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588540 */     // GIR_Coverage, 4497,
     /* 1588540 */     GIR_EraseRootFromParent_Done,
     /* 1588541 */   // Label 21972: @1588541
     /* 1588541 */   GIM_Try, /*On fail goto*//*Label 21973*/ GIMT_Encode4(1588623), // Rule ID 4506 //
     /* 1588546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1588554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1588557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1588560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1588563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588577 */     // MIs[0] passthru
     /* 1588577 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588590 */     // MIs[0] policy
     /* 1588590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1588603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588622 */     // GIR_Coverage, 4506,
     /* 1588622 */     GIR_EraseRootFromParent_Done,
     /* 1588623 */   // Label 21973: @1588623
     /* 1588623 */   GIM_Try, /*On fail goto*//*Label 21974*/ GIMT_Encode4(1588705), // Rule ID 4507 //
     /* 1588628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1588636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1588639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1588642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1588645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588659 */     // MIs[0] passthru
     /* 1588659 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588672 */     // MIs[0] policy
     /* 1588672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588682 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1588685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588704 */     // GIR_Coverage, 4507,
     /* 1588704 */     GIR_EraseRootFromParent_Done,
     /* 1588705 */   // Label 21974: @1588705
     /* 1588705 */   GIM_Try, /*On fail goto*//*Label 21975*/ GIMT_Encode4(1588787), // Rule ID 4516 //
     /* 1588710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1588718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1588721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1588724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1588727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588741 */     // MIs[0] passthru
     /* 1588741 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588754 */     // MIs[0] policy
     /* 1588754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588764 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1588767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588786 */     // GIR_Coverage, 4516,
     /* 1588786 */     GIR_EraseRootFromParent_Done,
     /* 1588787 */   // Label 21975: @1588787
     /* 1588787 */   GIM_Try, /*On fail goto*//*Label 21976*/ GIMT_Encode4(1588869), // Rule ID 4517 //
     /* 1588792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1588800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1588803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1588806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1588809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588823 */     // MIs[0] passthru
     /* 1588823 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588836 */     // MIs[0] policy
     /* 1588836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588846 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1588849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588868 */     // GIR_Coverage, 4517,
     /* 1588868 */     GIR_EraseRootFromParent_Done,
     /* 1588869 */   // Label 21976: @1588869
     /* 1588869 */   GIM_Try, /*On fail goto*//*Label 21977*/ GIMT_Encode4(1588951), // Rule ID 4526 //
     /* 1588874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1588882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1588885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1588888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1588891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1588894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588905 */     // MIs[0] passthru
     /* 1588905 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588918 */     // MIs[0] policy
     /* 1588918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588928 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1588931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588950 */     // GIR_Coverage, 4526,
     /* 1588950 */     GIR_EraseRootFromParent_Done,
     /* 1588951 */   // Label 21977: @1588951
     /* 1588951 */   GIM_Try, /*On fail goto*//*Label 21978*/ GIMT_Encode4(1589033), // Rule ID 4527 //
     /* 1588956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1588964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1588967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1588970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1588973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1588976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588987 */     // MIs[0] passthru
     /* 1588987 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589000 */     // MIs[0] policy
     /* 1589000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589010 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1589013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589032 */     // GIR_Coverage, 4527,
     /* 1589032 */     GIR_EraseRootFromParent_Done,
     /* 1589033 */   // Label 21978: @1589033
     /* 1589033 */   GIM_Try, /*On fail goto*//*Label 21979*/ GIMT_Encode4(1589115), // Rule ID 4536 //
     /* 1589038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1589046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1589049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1589052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1589055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589069 */     // MIs[0] passthru
     /* 1589069 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589082 */     // MIs[0] policy
     /* 1589082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589092 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1589095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589114 */     // GIR_Coverage, 4536,
     /* 1589114 */     GIR_EraseRootFromParent_Done,
     /* 1589115 */   // Label 21979: @1589115
     /* 1589115 */   GIM_Try, /*On fail goto*//*Label 21980*/ GIMT_Encode4(1589197), // Rule ID 4537 //
     /* 1589120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1589128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1589131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1589134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1589137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589151 */     // MIs[0] passthru
     /* 1589151 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589164 */     // MIs[0] policy
     /* 1589164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589174 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1589177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589196 */     // GIR_Coverage, 4537,
     /* 1589196 */     GIR_EraseRootFromParent_Done,
     /* 1589197 */   // Label 21980: @1589197
     /* 1589197 */   GIM_Try, /*On fail goto*//*Label 21981*/ GIMT_Encode4(1589279), // Rule ID 4546 //
     /* 1589202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1589210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1589213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1589216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1589219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1589222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589233 */     // MIs[0] passthru
     /* 1589233 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589246 */     // MIs[0] policy
     /* 1589246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1589259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589278 */     // GIR_Coverage, 4546,
     /* 1589278 */     GIR_EraseRootFromParent_Done,
     /* 1589279 */   // Label 21981: @1589279
     /* 1589279 */   GIM_Try, /*On fail goto*//*Label 21982*/ GIMT_Encode4(1589361), // Rule ID 4547 //
     /* 1589284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1589292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1589295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1589298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1589301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1589304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589315 */     // MIs[0] passthru
     /* 1589315 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589328 */     // MIs[0] policy
     /* 1589328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589338 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1589341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589360 */     // GIR_Coverage, 4547,
     /* 1589360 */     GIR_EraseRootFromParent_Done,
     /* 1589361 */   // Label 21982: @1589361
     /* 1589361 */   GIM_Try, /*On fail goto*//*Label 21983*/ GIMT_Encode4(1589443), // Rule ID 4556 //
     /* 1589366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1589374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1589377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1589380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1589383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1589386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589397 */     // MIs[0] passthru
     /* 1589397 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589410 */     // MIs[0] policy
     /* 1589410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1589423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589442 */     // GIR_Coverage, 4556,
     /* 1589442 */     GIR_EraseRootFromParent_Done,
     /* 1589443 */   // Label 21983: @1589443
     /* 1589443 */   GIM_Try, /*On fail goto*//*Label 21984*/ GIMT_Encode4(1589525), // Rule ID 4557 //
     /* 1589448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1589456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1589459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1589462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1589465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1589468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589479 */     // MIs[0] passthru
     /* 1589479 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589492 */     // MIs[0] policy
     /* 1589492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1589505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589524 */     // GIR_Coverage, 4557,
     /* 1589524 */     GIR_EraseRootFromParent_Done,
     /* 1589525 */   // Label 21984: @1589525
     /* 1589525 */   GIM_Try, /*On fail goto*//*Label 21985*/ GIMT_Encode4(1589607), // Rule ID 4566 //
     /* 1589530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1589538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1589541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1589544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1589547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589561 */     // MIs[0] passthru
     /* 1589561 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589574 */     // MIs[0] policy
     /* 1589574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589584 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1589587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589606 */     // GIR_Coverage, 4566,
     /* 1589606 */     GIR_EraseRootFromParent_Done,
     /* 1589607 */   // Label 21985: @1589607
     /* 1589607 */   GIM_Try, /*On fail goto*//*Label 21986*/ GIMT_Encode4(1589689), // Rule ID 4567 //
     /* 1589612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1589620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1589623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1589626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1589629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589643 */     // MIs[0] passthru
     /* 1589643 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589656 */     // MIs[0] policy
     /* 1589656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589666 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1589669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589688 */     // GIR_Coverage, 4567,
     /* 1589688 */     GIR_EraseRootFromParent_Done,
     /* 1589689 */   // Label 21986: @1589689
     /* 1589689 */   GIM_Try, /*On fail goto*//*Label 21987*/ GIMT_Encode4(1589771), // Rule ID 4576 //
     /* 1589694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1589702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1589705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1589708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1589711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1589714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589725 */     // MIs[0] passthru
     /* 1589725 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589738 */     // MIs[0] policy
     /* 1589738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589748 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1589751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589770 */     // GIR_Coverage, 4576,
     /* 1589770 */     GIR_EraseRootFromParent_Done,
     /* 1589771 */   // Label 21987: @1589771
     /* 1589771 */   GIM_Try, /*On fail goto*//*Label 21988*/ GIMT_Encode4(1589853), // Rule ID 4577 //
     /* 1589776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1589784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1589787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1589790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1589793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1589796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589807 */     // MIs[0] passthru
     /* 1589807 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589820 */     // MIs[0] policy
     /* 1589820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589830 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1589833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589852 */     // GIR_Coverage, 4577,
     /* 1589852 */     GIR_EraseRootFromParent_Done,
     /* 1589853 */   // Label 21988: @1589853
     /* 1589853 */   GIM_Try, /*On fail goto*//*Label 21989*/ GIMT_Encode4(1589935), // Rule ID 4586 //
     /* 1589858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1589861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1589866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1589869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1589872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1589875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589889 */     // MIs[0] passthru
     /* 1589889 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589902 */     // MIs[0] policy
     /* 1589902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589912 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1589915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589934 */     // GIR_Coverage, 4586,
     /* 1589934 */     GIR_EraseRootFromParent_Done,
     /* 1589935 */   // Label 21989: @1589935
     /* 1589935 */   GIM_Try, /*On fail goto*//*Label 21990*/ GIMT_Encode4(1590017), // Rule ID 4587 //
     /* 1589940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1589943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1589948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1589951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1589954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1589957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589971 */     // MIs[0] passthru
     /* 1589971 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589984 */     // MIs[0] policy
     /* 1589984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589994 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1589997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590016 */     // GIR_Coverage, 4587,
     /* 1590016 */     GIR_EraseRootFromParent_Done,
     /* 1590017 */   // Label 21990: @1590017
     /* 1590017 */   GIM_Try, /*On fail goto*//*Label 21991*/ GIMT_Encode4(1590099), // Rule ID 4596 //
     /* 1590022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1590025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1590030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1590033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1590036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1590039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1590049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590053 */     // MIs[0] passthru
     /* 1590053 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1590058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590066 */     // MIs[0] policy
     /* 1590066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1590079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590098 */     // GIR_Coverage, 4596,
     /* 1590098 */     GIR_EraseRootFromParent_Done,
     /* 1590099 */   // Label 21991: @1590099
     /* 1590099 */   GIM_Try, /*On fail goto*//*Label 21992*/ GIMT_Encode4(1590181), // Rule ID 4597 //
     /* 1590104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1590107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1590112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1590115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1590118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1590121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1590131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590135 */     // MIs[0] passthru
     /* 1590135 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1590140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590148 */     // MIs[0] policy
     /* 1590148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590158 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1590161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590180 */     // GIR_Coverage, 4597,
     /* 1590180 */     GIR_EraseRootFromParent_Done,
     /* 1590181 */   // Label 21992: @1590181
     /* 1590181 */   GIM_Try, /*On fail goto*//*Label 21993*/ GIMT_Encode4(1590263), // Rule ID 4606 //
     /* 1590186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1590189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1590194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1590197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1590200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1590203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1590213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590217 */     // MIs[0] passthru
     /* 1590217 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1590222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590230 */     // MIs[0] policy
     /* 1590230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590240 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1590243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590262 */     // GIR_Coverage, 4606,
     /* 1590262 */     GIR_EraseRootFromParent_Done,
     /* 1590263 */   // Label 21993: @1590263
     /* 1590263 */   GIM_Try, /*On fail goto*//*Label 21994*/ GIMT_Encode4(1590345), // Rule ID 4607 //
     /* 1590268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1590271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1590276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1590279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1590282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1590285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1590295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590299 */     // MIs[0] passthru
     /* 1590299 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1590304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590312 */     // MIs[0] policy
     /* 1590312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590322 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1590325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590344 */     // GIR_Coverage, 4607,
     /* 1590344 */     GIR_EraseRootFromParent_Done,
     /* 1590345 */   // Label 21994: @1590345
     /* 1590345 */   GIM_Try, /*On fail goto*//*Label 21995*/ GIMT_Encode4(1590427), // Rule ID 4616 //
     /* 1590350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1590353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1590358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1590361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1590364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1590367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1590370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1590377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590381 */     // MIs[0] passthru
     /* 1590381 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1590386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590394 */     // MIs[0] policy
     /* 1590394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590404 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1590407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590426 */     // GIR_Coverage, 4616,
     /* 1590426 */     GIR_EraseRootFromParent_Done,
     /* 1590427 */   // Label 21995: @1590427
     /* 1590427 */   GIM_Try, /*On fail goto*//*Label 21996*/ GIMT_Encode4(1590509), // Rule ID 4617 //
     /* 1590432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1590435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1590440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1590443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1590446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1590449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1590452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1590459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590463 */     // MIs[0] passthru
     /* 1590463 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1590468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590476 */     // MIs[0] policy
     /* 1590476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590486 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1590489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590508 */     // GIR_Coverage, 4617,
     /* 1590508 */     GIR_EraseRootFromParent_Done,
     /* 1590509 */   // Label 21996: @1590509
     /* 1590509 */   GIM_Try, /*On fail goto*//*Label 21997*/ GIMT_Encode4(1590591), // Rule ID 4686 //
     /* 1590514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1590522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1590525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1590528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1590531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590545 */     // MIs[0] passthru
     /* 1590545 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1590550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590558 */     // MIs[0] policy
     /* 1590558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1590571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590590 */     // GIR_Coverage, 4686,
     /* 1590590 */     GIR_EraseRootFromParent_Done,
     /* 1590591 */   // Label 21997: @1590591
     /* 1590591 */   GIM_Try, /*On fail goto*//*Label 21998*/ GIMT_Encode4(1590673), // Rule ID 4687 //
     /* 1590596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1590604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1590607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1590610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1590613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590627 */     // MIs[0] passthru
     /* 1590627 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1590632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590640 */     // MIs[0] policy
     /* 1590640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590650 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1590653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590672 */     // GIR_Coverage, 4687,
     /* 1590672 */     GIR_EraseRootFromParent_Done,
     /* 1590673 */   // Label 21998: @1590673
     /* 1590673 */   GIM_Try, /*On fail goto*//*Label 21999*/ GIMT_Encode4(1590755), // Rule ID 4696 //
     /* 1590678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1590686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1590689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1590692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1590695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590709 */     // MIs[0] passthru
     /* 1590709 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1590714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590722 */     // MIs[0] policy
     /* 1590722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590732 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1590735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590754 */     // GIR_Coverage, 4696,
     /* 1590754 */     GIR_EraseRootFromParent_Done,
     /* 1590755 */   // Label 21999: @1590755
     /* 1590755 */   GIM_Try, /*On fail goto*//*Label 22000*/ GIMT_Encode4(1590837), // Rule ID 4697 //
     /* 1590760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1590768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1590771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1590774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1590777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590791 */     // MIs[0] passthru
     /* 1590791 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1590796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590804 */     // MIs[0] policy
     /* 1590804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590814 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1590817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590836 */     // GIR_Coverage, 4697,
     /* 1590836 */     GIR_EraseRootFromParent_Done,
     /* 1590837 */   // Label 22000: @1590837
     /* 1590837 */   GIM_Try, /*On fail goto*//*Label 22001*/ GIMT_Encode4(1590919), // Rule ID 4706 //
     /* 1590842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1590850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1590853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1590856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1590859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590873 */     // MIs[0] passthru
     /* 1590873 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1590878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590886 */     // MIs[0] policy
     /* 1590886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590896 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1590899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590918 */     // GIR_Coverage, 4706,
     /* 1590918 */     GIR_EraseRootFromParent_Done,
     /* 1590919 */   // Label 22001: @1590919
     /* 1590919 */   GIM_Try, /*On fail goto*//*Label 22002*/ GIMT_Encode4(1591001), // Rule ID 4707 //
     /* 1590924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1590932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1590935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1590938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1590941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590955 */     // MIs[0] passthru
     /* 1590955 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1590960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590968 */     // MIs[0] policy
     /* 1590968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590978 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1590981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591000 */     // GIR_Coverage, 4707,
     /* 1591000 */     GIR_EraseRootFromParent_Done,
     /* 1591001 */   // Label 22002: @1591001
     /* 1591001 */   GIM_Try, /*On fail goto*//*Label 22003*/ GIMT_Encode4(1591083), // Rule ID 4716 //
     /* 1591006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1591014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1591017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1591020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1591023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591037 */     // MIs[0] passthru
     /* 1591037 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1591042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591050 */     // MIs[0] policy
     /* 1591050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1591063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591082 */     // GIR_Coverage, 4716,
     /* 1591082 */     GIR_EraseRootFromParent_Done,
     /* 1591083 */   // Label 22003: @1591083
     /* 1591083 */   GIM_Try, /*On fail goto*//*Label 22004*/ GIMT_Encode4(1591165), // Rule ID 4717 //
     /* 1591088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1591096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1591099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1591102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1591105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591119 */     // MIs[0] passthru
     /* 1591119 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1591124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591132 */     // MIs[0] policy
     /* 1591132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591142 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1591145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591164 */     // GIR_Coverage, 4717,
     /* 1591164 */     GIR_EraseRootFromParent_Done,
     /* 1591165 */   // Label 22004: @1591165
     /* 1591165 */   GIM_Try, /*On fail goto*//*Label 22005*/ GIMT_Encode4(1591247), // Rule ID 4726 //
     /* 1591170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1591178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1591181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1591184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1591187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1591190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1591197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591201 */     // MIs[0] passthru
     /* 1591201 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1591206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591214 */     // MIs[0] policy
     /* 1591214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591224 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1591227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591246 */     // GIR_Coverage, 4726,
     /* 1591246 */     GIR_EraseRootFromParent_Done,
     /* 1591247 */   // Label 22005: @1591247
     /* 1591247 */   GIM_Try, /*On fail goto*//*Label 22006*/ GIMT_Encode4(1591329), // Rule ID 4727 //
     /* 1591252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1591260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1591263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1591266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1591269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1591272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1591279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591283 */     // MIs[0] passthru
     /* 1591283 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1591288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591296 */     // MIs[0] policy
     /* 1591296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591306 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1591309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591328 */     // GIR_Coverage, 4727,
     /* 1591328 */     GIR_EraseRootFromParent_Done,
     /* 1591329 */   // Label 22006: @1591329
     /* 1591329 */   GIM_Try, /*On fail goto*//*Label 22007*/ GIMT_Encode4(1591411), // Rule ID 4736 //
     /* 1591334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1591342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1591345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1591348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1591351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1591354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1591361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591365 */     // MIs[0] passthru
     /* 1591365 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1591370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591378 */     // MIs[0] policy
     /* 1591378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591388 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1591391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591410 */     // GIR_Coverage, 4736,
     /* 1591410 */     GIR_EraseRootFromParent_Done,
     /* 1591411 */   // Label 22007: @1591411
     /* 1591411 */   GIM_Try, /*On fail goto*//*Label 22008*/ GIMT_Encode4(1591493), // Rule ID 4737 //
     /* 1591416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1591424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1591427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1591430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1591433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1591436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1591443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591447 */     // MIs[0] passthru
     /* 1591447 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1591452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591460 */     // MIs[0] policy
     /* 1591460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591470 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1591473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591492 */     // GIR_Coverage, 4737,
     /* 1591492 */     GIR_EraseRootFromParent_Done,
     /* 1591493 */   // Label 22008: @1591493
     /* 1591493 */   GIM_Try, /*On fail goto*//*Label 22009*/ GIMT_Encode4(1591575), // Rule ID 4746 //
     /* 1591498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1591506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1591509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1591512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1591515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591529 */     // MIs[0] passthru
     /* 1591529 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1591534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591542 */     // MIs[0] policy
     /* 1591542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591552 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1591555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591574 */     // GIR_Coverage, 4746,
     /* 1591574 */     GIR_EraseRootFromParent_Done,
     /* 1591575 */   // Label 22009: @1591575
     /* 1591575 */   GIM_Try, /*On fail goto*//*Label 22010*/ GIMT_Encode4(1591657), // Rule ID 4747 //
     /* 1591580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1591588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1591591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1591594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1591597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591611 */     // MIs[0] passthru
     /* 1591611 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1591616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591624 */     // MIs[0] policy
     /* 1591624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591634 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1591637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591656 */     // GIR_Coverage, 4747,
     /* 1591656 */     GIR_EraseRootFromParent_Done,
     /* 1591657 */   // Label 22010: @1591657
     /* 1591657 */   GIM_Try, /*On fail goto*//*Label 22011*/ GIMT_Encode4(1591739), // Rule ID 4756 //
     /* 1591662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1591670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1591673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1591676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1591679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591693 */     // MIs[0] passthru
     /* 1591693 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1591698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591706 */     // MIs[0] policy
     /* 1591706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591716 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1591719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591738 */     // GIR_Coverage, 4756,
     /* 1591738 */     GIR_EraseRootFromParent_Done,
     /* 1591739 */   // Label 22011: @1591739
     /* 1591739 */   GIM_Try, /*On fail goto*//*Label 22012*/ GIMT_Encode4(1591821), // Rule ID 4757 //
     /* 1591744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1591752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1591755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1591758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1591761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591775 */     // MIs[0] passthru
     /* 1591775 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1591780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591788 */     // MIs[0] policy
     /* 1591788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591798 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1591801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591820 */     // GIR_Coverage, 4757,
     /* 1591820 */     GIR_EraseRootFromParent_Done,
     /* 1591821 */   // Label 22012: @1591821
     /* 1591821 */   GIM_Try, /*On fail goto*//*Label 22013*/ GIMT_Encode4(1591903), // Rule ID 4766 //
     /* 1591826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1591834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1591837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1591840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1591843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591857 */     // MIs[0] passthru
     /* 1591857 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1591862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591870 */     // MIs[0] policy
     /* 1591870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1591883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591902 */     // GIR_Coverage, 4766,
     /* 1591902 */     GIR_EraseRootFromParent_Done,
     /* 1591903 */   // Label 22013: @1591903
     /* 1591903 */   GIM_Try, /*On fail goto*//*Label 22014*/ GIMT_Encode4(1591985), // Rule ID 4767 //
     /* 1591908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1591916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1591919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1591922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1591925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591939 */     // MIs[0] passthru
     /* 1591939 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1591944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591952 */     // MIs[0] policy
     /* 1591952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591962 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1591965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591984 */     // GIR_Coverage, 4767,
     /* 1591984 */     GIR_EraseRootFromParent_Done,
     /* 1591985 */   // Label 22014: @1591985
     /* 1591985 */   GIM_Try, /*On fail goto*//*Label 22015*/ GIMT_Encode4(1592067), // Rule ID 4776 //
     /* 1591990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1591998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1592001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1592004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1592007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592021 */     // MIs[0] passthru
     /* 1592021 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1592026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592034 */     // MIs[0] policy
     /* 1592034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592044 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1592047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592066 */     // GIR_Coverage, 4776,
     /* 1592066 */     GIR_EraseRootFromParent_Done,
     /* 1592067 */   // Label 22015: @1592067
     /* 1592067 */   GIM_Try, /*On fail goto*//*Label 22016*/ GIMT_Encode4(1592149), // Rule ID 4777 //
     /* 1592072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1592080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1592083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1592086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1592089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592103 */     // MIs[0] passthru
     /* 1592103 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1592108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592116 */     // MIs[0] policy
     /* 1592116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592126 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1592129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592148 */     // GIR_Coverage, 4777,
     /* 1592148 */     GIR_EraseRootFromParent_Done,
     /* 1592149 */   // Label 22016: @1592149
     /* 1592149 */   GIM_Try, /*On fail goto*//*Label 22017*/ GIMT_Encode4(1592231), // Rule ID 4786 //
     /* 1592154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1592162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1592165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1592168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1592171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592185 */     // MIs[0] passthru
     /* 1592185 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1592190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592198 */     // MIs[0] policy
     /* 1592198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592208 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1592211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592230 */     // GIR_Coverage, 4786,
     /* 1592230 */     GIR_EraseRootFromParent_Done,
     /* 1592231 */   // Label 22017: @1592231
     /* 1592231 */   GIM_Try, /*On fail goto*//*Label 22018*/ GIMT_Encode4(1592313), // Rule ID 4787 //
     /* 1592236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1592244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1592247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1592250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1592253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592267 */     // MIs[0] passthru
     /* 1592267 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1592272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592280 */     // MIs[0] policy
     /* 1592280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592290 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1592293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592312 */     // GIR_Coverage, 4787,
     /* 1592312 */     GIR_EraseRootFromParent_Done,
     /* 1592313 */   // Label 22018: @1592313
     /* 1592313 */   GIM_Try, /*On fail goto*//*Label 22019*/ GIMT_Encode4(1592395), // Rule ID 4796 //
     /* 1592318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1592321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1592326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1592329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1592332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1592335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1592338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592349 */     // MIs[0] passthru
     /* 1592349 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1592354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592362 */     // MIs[0] policy
     /* 1592362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592372 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1592375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592394 */     // GIR_Coverage, 4796,
     /* 1592394 */     GIR_EraseRootFromParent_Done,
     /* 1592395 */   // Label 22019: @1592395
     /* 1592395 */   GIM_Try, /*On fail goto*//*Label 22020*/ GIMT_Encode4(1592477), // Rule ID 4797 //
     /* 1592400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1592403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1592408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1592411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1592414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1592417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1592420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592431 */     // MIs[0] passthru
     /* 1592431 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1592436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592444 */     // MIs[0] policy
     /* 1592444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592454 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1592457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592476 */     // GIR_Coverage, 4797,
     /* 1592476 */     GIR_EraseRootFromParent_Done,
     /* 1592477 */   // Label 22020: @1592477
     /* 1592477 */   GIM_Try, /*On fail goto*//*Label 22021*/ GIMT_Encode4(1592559), // Rule ID 4806 //
     /* 1592482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1592485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1592490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1592493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1592496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1592499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1592502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592513 */     // MIs[0] passthru
     /* 1592513 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1592518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592526 */     // MIs[0] policy
     /* 1592526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592536 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1592539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592558 */     // GIR_Coverage, 4806,
     /* 1592558 */     GIR_EraseRootFromParent_Done,
     /* 1592559 */   // Label 22021: @1592559
     /* 1592559 */   GIM_Try, /*On fail goto*//*Label 22022*/ GIMT_Encode4(1592641), // Rule ID 4807 //
     /* 1592564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1592567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1592572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1592575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1592578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1592581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1592584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592595 */     // MIs[0] passthru
     /* 1592595 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1592600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592608 */     // MIs[0] policy
     /* 1592608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1592621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592640 */     // GIR_Coverage, 4807,
     /* 1592640 */     GIR_EraseRootFromParent_Done,
     /* 1592641 */   // Label 22022: @1592641
     /* 1592641 */   GIM_Try, /*On fail goto*//*Label 22023*/ GIMT_Encode4(1592723), // Rule ID 4816 //
     /* 1592646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1592649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1592654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1592657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1592660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1592663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1592666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592677 */     // MIs[0] passthru
     /* 1592677 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1592682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592690 */     // MIs[0] policy
     /* 1592690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592700 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1592703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592722 */     // GIR_Coverage, 4816,
     /* 1592722 */     GIR_EraseRootFromParent_Done,
     /* 1592723 */   // Label 22023: @1592723
     /* 1592723 */   GIM_Try, /*On fail goto*//*Label 22024*/ GIMT_Encode4(1592805), // Rule ID 4817 //
     /* 1592728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1592731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1592736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1592739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1592742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1592745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1592748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592759 */     // MIs[0] passthru
     /* 1592759 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1592764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592772 */     // MIs[0] policy
     /* 1592772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592782 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1592785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592804 */     // GIR_Coverage, 4817,
     /* 1592804 */     GIR_EraseRootFromParent_Done,
     /* 1592805 */   // Label 22024: @1592805
     /* 1592805 */   GIM_Try, /*On fail goto*//*Label 22025*/ GIMT_Encode4(1592887), // Rule ID 4826 //
     /* 1592810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1592813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1592818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1592821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1592824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1592827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592841 */     // MIs[0] passthru
     /* 1592841 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1592846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592854 */     // MIs[0] policy
     /* 1592854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592864 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1592867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592886 */     // GIR_Coverage, 4826,
     /* 1592886 */     GIR_EraseRootFromParent_Done,
     /* 1592887 */   // Label 22025: @1592887
     /* 1592887 */   GIM_Try, /*On fail goto*//*Label 22026*/ GIMT_Encode4(1592969), // Rule ID 4827 //
     /* 1592892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1592895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1592900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1592903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1592906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1592909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592923 */     // MIs[0] passthru
     /* 1592923 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1592928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592936 */     // MIs[0] policy
     /* 1592936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1592949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592968 */     // GIR_Coverage, 4827,
     /* 1592968 */     GIR_EraseRootFromParent_Done,
     /* 1592969 */   // Label 22026: @1592969
     /* 1592969 */   GIM_Try, /*On fail goto*//*Label 22027*/ GIMT_Encode4(1593055), // Rule ID 2714 //
     /* 1592974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1592985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1592988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1592991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1592994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1592997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593020 */     // MIs[0] policy
     /* 1593020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593030 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1593033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593054 */     // GIR_Coverage, 2714,
     /* 1593054 */     GIR_EraseRootFromParent_Done,
     /* 1593055 */   // Label 22027: @1593055
     /* 1593055 */   GIM_Try, /*On fail goto*//*Label 22028*/ GIMT_Encode4(1593141), // Rule ID 2715 //
     /* 1593060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1593071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1593074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1593077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1593080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1593083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593106 */     // MIs[0] policy
     /* 1593106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593116 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1593119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593140 */     // GIR_Coverage, 2715,
     /* 1593140 */     GIR_EraseRootFromParent_Done,
     /* 1593141 */   // Label 22028: @1593141
     /* 1593141 */   GIM_Try, /*On fail goto*//*Label 22029*/ GIMT_Encode4(1593227), // Rule ID 2752 //
     /* 1593146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1593154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1593157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1593160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1593163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1593166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1593169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593192 */     // MIs[0] policy
     /* 1593192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593202 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1593205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593226 */     // GIR_Coverage, 2752,
     /* 1593226 */     GIR_EraseRootFromParent_Done,
     /* 1593227 */   // Label 22029: @1593227
     /* 1593227 */   GIM_Try, /*On fail goto*//*Label 22030*/ GIMT_Encode4(1593313), // Rule ID 2753 //
     /* 1593232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1593240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1593243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1593246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1593249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1593252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1593255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593278 */     // MIs[0] policy
     /* 1593278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593288 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1593291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593312 */     // GIR_Coverage, 2753,
     /* 1593312 */     GIR_EraseRootFromParent_Done,
     /* 1593313 */   // Label 22030: @1593313
     /* 1593313 */   GIM_Try, /*On fail goto*//*Label 22031*/ GIMT_Encode4(1593399), // Rule ID 2766 //
     /* 1593318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1593326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1593329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1593332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1593335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1593338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1593341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593364 */     // MIs[0] policy
     /* 1593364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593374 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1593377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1593381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593398 */     // GIR_Coverage, 2766,
     /* 1593398 */     GIR_EraseRootFromParent_Done,
     /* 1593399 */   // Label 22031: @1593399
     /* 1593399 */   GIM_Try, /*On fail goto*//*Label 22032*/ GIMT_Encode4(1593485), // Rule ID 2767 //
     /* 1593404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1593412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1593415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1593418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1593421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1593424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1593427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593450 */     // MIs[0] policy
     /* 1593450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593460 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1593463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1593467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593484 */     // GIR_Coverage, 2767,
     /* 1593484 */     GIR_EraseRootFromParent_Done,
     /* 1593485 */   // Label 22032: @1593485
     /* 1593485 */   GIM_Try, /*On fail goto*//*Label 22033*/ GIMT_Encode4(1593571), // Rule ID 2786 //
     /* 1593490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1593501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1593504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1593507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1593510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1593513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593536 */     // MIs[0] policy
     /* 1593536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593546 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1593549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593570 */     // GIR_Coverage, 2786,
     /* 1593570 */     GIR_EraseRootFromParent_Done,
     /* 1593571 */   // Label 22033: @1593571
     /* 1593571 */   GIM_Try, /*On fail goto*//*Label 22034*/ GIMT_Encode4(1593657), // Rule ID 2787 //
     /* 1593576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1593587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1593590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1593593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1593596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1593599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593622 */     // MIs[0] policy
     /* 1593622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593632 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1593635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593656 */     // GIR_Coverage, 2787,
     /* 1593656 */     GIR_EraseRootFromParent_Done,
     /* 1593657 */   // Label 22034: @1593657
     /* 1593657 */   GIM_Try, /*On fail goto*//*Label 22035*/ GIMT_Encode4(1593743), // Rule ID 2794 //
     /* 1593662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1593673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1593676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1593679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1593682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593708 */     // MIs[0] policy
     /* 1593708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593718 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1593721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593742 */     // GIR_Coverage, 2794,
     /* 1593742 */     GIR_EraseRootFromParent_Done,
     /* 1593743 */   // Label 22035: @1593743
     /* 1593743 */   GIM_Try, /*On fail goto*//*Label 22036*/ GIMT_Encode4(1593829), // Rule ID 2795 //
     /* 1593748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1593759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1593762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1593765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1593768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593794 */     // MIs[0] policy
     /* 1593794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593804 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1593807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593828 */     // GIR_Coverage, 2795,
     /* 1593828 */     GIR_EraseRootFromParent_Done,
     /* 1593829 */   // Label 22036: @1593829
     /* 1593829 */   GIM_Try, /*On fail goto*//*Label 22037*/ GIMT_Encode4(1593915), // Rule ID 2802 //
     /* 1593834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1593845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1593848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1593851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1593854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593880 */     // MIs[0] policy
     /* 1593880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593890 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1593893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593914 */     // GIR_Coverage, 2802,
     /* 1593914 */     GIR_EraseRootFromParent_Done,
     /* 1593915 */   // Label 22037: @1593915
     /* 1593915 */   GIM_Try, /*On fail goto*//*Label 22038*/ GIMT_Encode4(1594001), // Rule ID 2803 //
     /* 1593920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1593931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1593934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1593937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1593940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593966 */     // MIs[0] policy
     /* 1593966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593976 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1593979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594000 */     // GIR_Coverage, 2803,
     /* 1594000 */     GIR_EraseRootFromParent_Done,
     /* 1594001 */   // Label 22038: @1594001
     /* 1594001 */   GIM_Try, /*On fail goto*//*Label 22039*/ GIMT_Encode4(1594087), // Rule ID 2810 //
     /* 1594006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1594014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1594017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1594020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1594023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1594026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594052 */     // MIs[0] policy
     /* 1594052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594062 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1594065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1594071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1594073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594086 */     // GIR_Coverage, 2810,
     /* 1594086 */     GIR_EraseRootFromParent_Done,
     /* 1594087 */   // Label 22039: @1594087
     /* 1594087 */   GIM_Try, /*On fail goto*//*Label 22040*/ GIMT_Encode4(1594173), // Rule ID 2811 //
     /* 1594092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1594100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1594103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1594106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1594109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1594112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594138 */     // MIs[0] policy
     /* 1594138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594148 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1594151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1594157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1594159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594172 */     // GIR_Coverage, 2811,
     /* 1594172 */     GIR_EraseRootFromParent_Done,
     /* 1594173 */   // Label 22040: @1594173
     /* 1594173 */   GIM_Try, /*On fail goto*//*Label 22041*/ GIMT_Encode4(1594259), // Rule ID 2818 //
     /* 1594178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1594186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1594189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1594192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1594195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1594198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594224 */     // MIs[0] policy
     /* 1594224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594234 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1594237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1594243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1594245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594258 */     // GIR_Coverage, 2818,
     /* 1594258 */     GIR_EraseRootFromParent_Done,
     /* 1594259 */   // Label 22041: @1594259
     /* 1594259 */   GIM_Try, /*On fail goto*//*Label 22042*/ GIMT_Encode4(1594345), // Rule ID 2819 //
     /* 1594264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1594272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1594275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1594278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1594281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1594284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594310 */     // MIs[0] policy
     /* 1594310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594320 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1594323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1594329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1594331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594344 */     // GIR_Coverage, 2819,
     /* 1594344 */     GIR_EraseRootFromParent_Done,
     /* 1594345 */   // Label 22042: @1594345
     /* 1594345 */   GIM_Try, /*On fail goto*//*Label 22043*/ GIMT_Encode4(1594431), // Rule ID 2826 //
     /* 1594350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1594358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1594361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1594364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1594367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1594370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594396 */     // MIs[0] policy
     /* 1594396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594406 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1594409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1594415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1594417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594430 */     // GIR_Coverage, 2826,
     /* 1594430 */     GIR_EraseRootFromParent_Done,
     /* 1594431 */   // Label 22043: @1594431
     /* 1594431 */   GIM_Try, /*On fail goto*//*Label 22044*/ GIMT_Encode4(1594517), // Rule ID 2827 //
     /* 1594436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1594444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1594447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1594450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1594453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1594456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594482 */     // MIs[0] policy
     /* 1594482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594492 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1594495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1594501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1594503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594516 */     // GIR_Coverage, 2827,
     /* 1594516 */     GIR_EraseRootFromParent_Done,
     /* 1594517 */   // Label 22044: @1594517
     /* 1594517 */   GIM_Try, /*On fail goto*//*Label 22045*/ GIMT_Encode4(1594603), // Rule ID 2834 //
     /* 1594522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1594530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1594533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1594536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1594539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1594542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594568 */     // MIs[0] policy
     /* 1594568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594578 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1594581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1594587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1594589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594602 */     // GIR_Coverage, 2834,
     /* 1594602 */     GIR_EraseRootFromParent_Done,
     /* 1594603 */   // Label 22045: @1594603
     /* 1594603 */   GIM_Try, /*On fail goto*//*Label 22046*/ GIMT_Encode4(1594689), // Rule ID 2835 //
     /* 1594608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1594616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1594619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1594622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1594625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1594628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594654 */     // MIs[0] policy
     /* 1594654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594664 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1594667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1594673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1594675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594688 */     // GIR_Coverage, 2835,
     /* 1594688 */     GIR_EraseRootFromParent_Done,
     /* 1594689 */   // Label 22046: @1594689
     /* 1594689 */   GIM_Try, /*On fail goto*//*Label 22047*/ GIMT_Encode4(1594775), // Rule ID 2842 //
     /* 1594694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1594702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1594705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1594708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1594711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1594714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594740 */     // MIs[0] policy
     /* 1594740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1594753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1594759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1594761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594774 */     // GIR_Coverage, 2842,
     /* 1594774 */     GIR_EraseRootFromParent_Done,
     /* 1594775 */   // Label 22047: @1594775
     /* 1594775 */   GIM_Try, /*On fail goto*//*Label 22048*/ GIMT_Encode4(1594861), // Rule ID 2843 //
     /* 1594780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1594788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1594791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1594794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1594797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1594800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594826 */     // MIs[0] policy
     /* 1594826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594836 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1594839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1594845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1594847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594860 */     // GIR_Coverage, 2843,
     /* 1594860 */     GIR_EraseRootFromParent_Done,
     /* 1594861 */   // Label 22048: @1594861
     /* 1594861 */   GIM_Try, /*On fail goto*//*Label 22049*/ GIMT_Encode4(1594947), // Rule ID 2850 //
     /* 1594866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1594874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1594877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1594880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1594883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1594886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594912 */     // MIs[0] policy
     /* 1594912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594922 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1594925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1594931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1594933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594946 */     // GIR_Coverage, 2850,
     /* 1594946 */     GIR_EraseRootFromParent_Done,
     /* 1594947 */   // Label 22049: @1594947
     /* 1594947 */   GIM_Try, /*On fail goto*//*Label 22050*/ GIMT_Encode4(1595033), // Rule ID 2851 //
     /* 1594952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1594960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1594963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1594966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1594969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1594972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594998 */     // MIs[0] policy
     /* 1594998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1595011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1595017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1595019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595032 */     // GIR_Coverage, 2851,
     /* 1595032 */     GIR_EraseRootFromParent_Done,
     /* 1595033 */   // Label 22050: @1595033
     /* 1595033 */   GIM_Try, /*On fail goto*//*Label 22051*/ GIMT_Encode4(1595119), // Rule ID 2858 //
     /* 1595038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1595041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1595046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1595049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1595052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1595055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1595058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595084 */     // MIs[0] policy
     /* 1595084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1595097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1595103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1595105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1595115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595118 */     // GIR_Coverage, 2858,
     /* 1595118 */     GIR_EraseRootFromParent_Done,
     /* 1595119 */   // Label 22051: @1595119
     /* 1595119 */   GIM_Try, /*On fail goto*//*Label 22052*/ GIMT_Encode4(1595205), // Rule ID 2859 //
     /* 1595124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1595127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1595132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1595135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1595138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1595141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1595144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595170 */     // MIs[0] policy
     /* 1595170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595180 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1595183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1595189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1595191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1595201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595204 */     // GIR_Coverage, 2859,
     /* 1595204 */     GIR_EraseRootFromParent_Done,
     /* 1595205 */   // Label 22052: @1595205
     /* 1595205 */   GIM_Try, /*On fail goto*//*Label 22053*/ GIMT_Encode4(1595291), // Rule ID 2866 //
     /* 1595210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1595218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1595221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1595224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1595227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1595230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595256 */     // MIs[0] policy
     /* 1595256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1595269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1595275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1595277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595290 */     // GIR_Coverage, 2866,
     /* 1595290 */     GIR_EraseRootFromParent_Done,
     /* 1595291 */   // Label 22053: @1595291
     /* 1595291 */   GIM_Try, /*On fail goto*//*Label 22054*/ GIMT_Encode4(1595377), // Rule ID 2867 //
     /* 1595296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1595304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1595307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1595310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1595313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1595316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595342 */     // MIs[0] policy
     /* 1595342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595352 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1595355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1595361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1595363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595376 */     // GIR_Coverage, 2867,
     /* 1595376 */     GIR_EraseRootFromParent_Done,
     /* 1595377 */   // Label 22054: @1595377
     /* 1595377 */   GIM_Try, /*On fail goto*//*Label 22055*/ GIMT_Encode4(1595463), // Rule ID 2874 //
     /* 1595382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1595390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1595393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1595396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1595399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1595402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595428 */     // MIs[0] policy
     /* 1595428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595438 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1595441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1595447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1595449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595462 */     // GIR_Coverage, 2874,
     /* 1595462 */     GIR_EraseRootFromParent_Done,
     /* 1595463 */   // Label 22055: @1595463
     /* 1595463 */   GIM_Try, /*On fail goto*//*Label 22056*/ GIMT_Encode4(1595549), // Rule ID 2875 //
     /* 1595468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1595476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1595479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1595482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1595485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1595488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595514 */     // MIs[0] policy
     /* 1595514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595524 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1595527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1595533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1595535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595548 */     // GIR_Coverage, 2875,
     /* 1595548 */     GIR_EraseRootFromParent_Done,
     /* 1595549 */   // Label 22056: @1595549
     /* 1595549 */   GIM_Try, /*On fail goto*//*Label 22057*/ GIMT_Encode4(1595635), // Rule ID 2882 //
     /* 1595554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1595562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1595565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1595568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1595571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1595574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1595577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595600 */     // MIs[0] policy
     /* 1595600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595610 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1595613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1595619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1595621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595634 */     // GIR_Coverage, 2882,
     /* 1595634 */     GIR_EraseRootFromParent_Done,
     /* 1595635 */   // Label 22057: @1595635
     /* 1595635 */   GIM_Try, /*On fail goto*//*Label 22058*/ GIMT_Encode4(1595721), // Rule ID 2883 //
     /* 1595640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1595648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1595651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1595654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1595657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1595660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1595663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595686 */     // MIs[0] policy
     /* 1595686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595696 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1595699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1595705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1595707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595720 */     // GIR_Coverage, 2883,
     /* 1595720 */     GIR_EraseRootFromParent_Done,
     /* 1595721 */   // Label 22058: @1595721
     /* 1595721 */   GIM_Try, /*On fail goto*//*Label 22059*/ GIMT_Encode4(1595807), // Rule ID 2890 //
     /* 1595726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1595734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1595737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1595740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1595743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1595746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595772 */     // MIs[0] policy
     /* 1595772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1595785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1595791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1595793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595806 */     // GIR_Coverage, 2890,
     /* 1595806 */     GIR_EraseRootFromParent_Done,
     /* 1595807 */   // Label 22059: @1595807
     /* 1595807 */   GIM_Try, /*On fail goto*//*Label 22060*/ GIMT_Encode4(1595893), // Rule ID 2891 //
     /* 1595812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1595820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1595823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1595826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1595829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1595832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595858 */     // MIs[0] policy
     /* 1595858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1595871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1595877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1595879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595892 */     // GIR_Coverage, 2891,
     /* 1595892 */     GIR_EraseRootFromParent_Done,
     /* 1595893 */   // Label 22060: @1595893
     /* 1595893 */   GIM_Try, /*On fail goto*//*Label 22061*/ GIMT_Encode4(1595979), // Rule ID 2898 //
     /* 1595898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1595906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1595909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1595912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1595915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1595918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595944 */     // MIs[0] policy
     /* 1595944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595954 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1595957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1595963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1595965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595978 */     // GIR_Coverage, 2898,
     /* 1595978 */     GIR_EraseRootFromParent_Done,
     /* 1595979 */   // Label 22061: @1595979
     /* 1595979 */   GIM_Try, /*On fail goto*//*Label 22062*/ GIMT_Encode4(1596065), // Rule ID 2899 //
     /* 1595984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1595992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1595995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1595998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1596001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1596004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596030 */     // MIs[0] policy
     /* 1596030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596040 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1596043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1596049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1596051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596064 */     // GIR_Coverage, 2899,
     /* 1596064 */     GIR_EraseRootFromParent_Done,
     /* 1596065 */   // Label 22062: @1596065
     /* 1596065 */   GIM_Try, /*On fail goto*//*Label 22063*/ GIMT_Encode4(1596151), // Rule ID 2906 //
     /* 1596070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1596078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1596081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1596084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1596087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1596090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596116 */     // MIs[0] policy
     /* 1596116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596126 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1596129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1596135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1596137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596150 */     // GIR_Coverage, 2906,
     /* 1596150 */     GIR_EraseRootFromParent_Done,
     /* 1596151 */   // Label 22063: @1596151
     /* 1596151 */   GIM_Try, /*On fail goto*//*Label 22064*/ GIMT_Encode4(1596237), // Rule ID 2907 //
     /* 1596156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1596164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1596167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1596170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1596173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1596176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596202 */     // MIs[0] policy
     /* 1596202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596212 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1596215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1596221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1596223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596236 */     // GIR_Coverage, 2907,
     /* 1596236 */     GIR_EraseRootFromParent_Done,
     /* 1596237 */   // Label 22064: @1596237
     /* 1596237 */   GIM_Try, /*On fail goto*//*Label 22065*/ GIMT_Encode4(1596323), // Rule ID 2914 //
     /* 1596242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1596250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1596253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1596256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1596259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1596262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596288 */     // MIs[0] policy
     /* 1596288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1596301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1596307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1596309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596322 */     // GIR_Coverage, 2914,
     /* 1596322 */     GIR_EraseRootFromParent_Done,
     /* 1596323 */   // Label 22065: @1596323
     /* 1596323 */   GIM_Try, /*On fail goto*//*Label 22066*/ GIMT_Encode4(1596409), // Rule ID 2915 //
     /* 1596328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1596336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1596339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1596342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1596345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1596348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596374 */     // MIs[0] policy
     /* 1596374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1596387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1596393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1596395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596408 */     // GIR_Coverage, 2915,
     /* 1596408 */     GIR_EraseRootFromParent_Done,
     /* 1596409 */   // Label 22066: @1596409
     /* 1596409 */   GIM_Try, /*On fail goto*//*Label 22067*/ GIMT_Encode4(1596495), // Rule ID 2922 //
     /* 1596414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1596422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1596425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1596428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1596431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1596434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596460 */     // MIs[0] policy
     /* 1596460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596470 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1596473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1596479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1596481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596494 */     // GIR_Coverage, 2922,
     /* 1596494 */     GIR_EraseRootFromParent_Done,
     /* 1596495 */   // Label 22067: @1596495
     /* 1596495 */   GIM_Try, /*On fail goto*//*Label 22068*/ GIMT_Encode4(1596581), // Rule ID 2923 //
     /* 1596500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1596508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1596511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1596514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1596517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1596520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596546 */     // MIs[0] policy
     /* 1596546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596556 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1596559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1596565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1596567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596580 */     // GIR_Coverage, 2923,
     /* 1596580 */     GIR_EraseRootFromParent_Done,
     /* 1596581 */   // Label 22068: @1596581
     /* 1596581 */   GIM_Try, /*On fail goto*//*Label 22069*/ GIMT_Encode4(1596667), // Rule ID 2930 //
     /* 1596586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1596594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1596597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1596600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1596603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1596606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596632 */     // MIs[0] policy
     /* 1596632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596642 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1596645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1596651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1596653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596666 */     // GIR_Coverage, 2930,
     /* 1596666 */     GIR_EraseRootFromParent_Done,
     /* 1596667 */   // Label 22069: @1596667
     /* 1596667 */   GIM_Try, /*On fail goto*//*Label 22070*/ GIMT_Encode4(1596753), // Rule ID 2931 //
     /* 1596672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1596680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1596683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1596686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1596689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1596692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596718 */     // MIs[0] policy
     /* 1596718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596728 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1596731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1596737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1596739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596752 */     // GIR_Coverage, 2931,
     /* 1596752 */     GIR_EraseRootFromParent_Done,
     /* 1596753 */   // Label 22070: @1596753
     /* 1596753 */   GIM_Try, /*On fail goto*//*Label 22071*/ GIMT_Encode4(1596839), // Rule ID 2938 //
     /* 1596758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1596761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1596766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1596769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1596772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1596775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1596778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1596781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596804 */     // MIs[0] policy
     /* 1596804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1596817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1596823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1596825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596838 */     // GIR_Coverage, 2938,
     /* 1596838 */     GIR_EraseRootFromParent_Done,
     /* 1596839 */   // Label 22071: @1596839
     /* 1596839 */   GIM_Try, /*On fail goto*//*Label 22072*/ GIMT_Encode4(1596925), // Rule ID 2939 //
     /* 1596844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1596847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1596852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1596855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1596858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1596861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1596864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1596867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596890 */     // MIs[0] policy
     /* 1596890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1596903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1596909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1596911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596924 */     // GIR_Coverage, 2939,
     /* 1596924 */     GIR_EraseRootFromParent_Done,
     /* 1596925 */   // Label 22072: @1596925
     /* 1596925 */   GIM_Try, /*On fail goto*//*Label 22073*/ GIMT_Encode4(1597011), // Rule ID 2946 //
     /* 1596930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1596933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1596938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1596941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1596944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1596947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1596950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596976 */     // MIs[0] policy
     /* 1596976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1596989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1596995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1596997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597010 */     // GIR_Coverage, 2946,
     /* 1597010 */     GIR_EraseRootFromParent_Done,
     /* 1597011 */   // Label 22073: @1597011
     /* 1597011 */   GIM_Try, /*On fail goto*//*Label 22074*/ GIMT_Encode4(1597097), // Rule ID 2947 //
     /* 1597016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1597019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1597024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1597027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1597030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1597033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1597036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597062 */     // MIs[0] policy
     /* 1597062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597072 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1597075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1597081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1597083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597096 */     // GIR_Coverage, 2947,
     /* 1597096 */     GIR_EraseRootFromParent_Done,
     /* 1597097 */   // Label 22074: @1597097
     /* 1597097 */   GIM_Try, /*On fail goto*//*Label 22075*/ GIMT_Encode4(1597183), // Rule ID 2954 //
     /* 1597102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1597105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1597110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1597113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1597116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1597119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1597122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597148 */     // MIs[0] policy
     /* 1597148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1597161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1597167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1597169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597182 */     // GIR_Coverage, 2954,
     /* 1597182 */     GIR_EraseRootFromParent_Done,
     /* 1597183 */   // Label 22075: @1597183
     /* 1597183 */   GIM_Try, /*On fail goto*//*Label 22076*/ GIMT_Encode4(1597269), // Rule ID 2955 //
     /* 1597188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1597191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1597196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1597199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1597202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1597205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1597208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597234 */     // MIs[0] policy
     /* 1597234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597244 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1597247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1597253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1597255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597268 */     // GIR_Coverage, 2955,
     /* 1597268 */     GIR_EraseRootFromParent_Done,
     /* 1597269 */   // Label 22076: @1597269
     /* 1597269 */   GIM_Try, /*On fail goto*//*Label 22077*/ GIMT_Encode4(1597355), // Rule ID 2970 //
     /* 1597274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1597285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1597288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1597291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1597294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597320 */     // MIs[0] policy
     /* 1597320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597330 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1597333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597354 */     // GIR_Coverage, 2970,
     /* 1597354 */     GIR_EraseRootFromParent_Done,
     /* 1597355 */   // Label 22077: @1597355
     /* 1597355 */   GIM_Try, /*On fail goto*//*Label 22078*/ GIMT_Encode4(1597441), // Rule ID 2971 //
     /* 1597360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1597371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1597374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1597377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1597380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597406 */     // MIs[0] policy
     /* 1597406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597416 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1597419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597440 */     // GIR_Coverage, 2971,
     /* 1597440 */     GIR_EraseRootFromParent_Done,
     /* 1597441 */   // Label 22078: @1597441
     /* 1597441 */   GIM_Try, /*On fail goto*//*Label 22079*/ GIMT_Encode4(1597527), // Rule ID 2974 //
     /* 1597446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1597457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1597460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1597463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1597466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597492 */     // MIs[0] policy
     /* 1597492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597502 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1597505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597526 */     // GIR_Coverage, 2974,
     /* 1597526 */     GIR_EraseRootFromParent_Done,
     /* 1597527 */   // Label 22079: @1597527
     /* 1597527 */   GIM_Try, /*On fail goto*//*Label 22080*/ GIMT_Encode4(1597613), // Rule ID 2975 //
     /* 1597532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1597543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1597546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1597549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1597552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597578 */     // MIs[0] policy
     /* 1597578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597588 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1597591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597612 */     // GIR_Coverage, 2975,
     /* 1597612 */     GIR_EraseRootFromParent_Done,
     /* 1597613 */   // Label 22080: @1597613
     /* 1597613 */   GIM_Try, /*On fail goto*//*Label 22081*/ GIMT_Encode4(1597699), // Rule ID 2978 //
     /* 1597618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1597629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1597632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1597635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1597638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597664 */     // MIs[0] policy
     /* 1597664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1597677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597698 */     // GIR_Coverage, 2978,
     /* 1597698 */     GIR_EraseRootFromParent_Done,
     /* 1597699 */   // Label 22081: @1597699
     /* 1597699 */   GIM_Try, /*On fail goto*//*Label 22082*/ GIMT_Encode4(1597785), // Rule ID 2979 //
     /* 1597704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1597715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1597718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1597721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1597724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597750 */     // MIs[0] policy
     /* 1597750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597760 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1597763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597784 */     // GIR_Coverage, 2979,
     /* 1597784 */     GIR_EraseRootFromParent_Done,
     /* 1597785 */   // Label 22082: @1597785
     /* 1597785 */   GIM_Try, /*On fail goto*//*Label 22083*/ GIMT_Encode4(1597871), // Rule ID 2982 //
     /* 1597790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1597801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1597804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1597807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1597810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597836 */     // MIs[0] policy
     /* 1597836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597846 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1597849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597870 */     // GIR_Coverage, 2982,
     /* 1597870 */     GIR_EraseRootFromParent_Done,
     /* 1597871 */   // Label 22083: @1597871
     /* 1597871 */   GIM_Try, /*On fail goto*//*Label 22084*/ GIMT_Encode4(1597957), // Rule ID 2983 //
     /* 1597876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1597887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1597890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1597893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1597896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597922 */     // MIs[0] policy
     /* 1597922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597932 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1597935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597956 */     // GIR_Coverage, 2983,
     /* 1597956 */     GIR_EraseRootFromParent_Done,
     /* 1597957 */   // Label 22084: @1597957
     /* 1597957 */   GIM_Try, /*On fail goto*//*Label 22085*/ GIMT_Encode4(1598043), // Rule ID 2986 //
     /* 1597962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1597973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1597976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1597979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1597982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598008 */     // MIs[0] policy
     /* 1598008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1598021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598042 */     // GIR_Coverage, 2986,
     /* 1598042 */     GIR_EraseRootFromParent_Done,
     /* 1598043 */   // Label 22085: @1598043
     /* 1598043 */   GIM_Try, /*On fail goto*//*Label 22086*/ GIMT_Encode4(1598129), // Rule ID 2987 //
     /* 1598048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1598059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1598062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1598065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1598068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598094 */     // MIs[0] policy
     /* 1598094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598104 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1598107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598128 */     // GIR_Coverage, 2987,
     /* 1598128 */     GIR_EraseRootFromParent_Done,
     /* 1598129 */   // Label 22086: @1598129
     /* 1598129 */   GIM_Try, /*On fail goto*//*Label 22087*/ GIMT_Encode4(1598215), // Rule ID 2990 //
     /* 1598134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1598145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1598148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1598151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1598154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598180 */     // MIs[0] policy
     /* 1598180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598190 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1598193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598214 */     // GIR_Coverage, 2990,
     /* 1598214 */     GIR_EraseRootFromParent_Done,
     /* 1598215 */   // Label 22087: @1598215
     /* 1598215 */   GIM_Try, /*On fail goto*//*Label 22088*/ GIMT_Encode4(1598301), // Rule ID 2991 //
     /* 1598220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1598231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1598234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1598237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1598240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598266 */     // MIs[0] policy
     /* 1598266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598276 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1598279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598300 */     // GIR_Coverage, 2991,
     /* 1598300 */     GIR_EraseRootFromParent_Done,
     /* 1598301 */   // Label 22088: @1598301
     /* 1598301 */   GIM_Try, /*On fail goto*//*Label 22089*/ GIMT_Encode4(1598387), // Rule ID 2994 //
     /* 1598306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1598317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1598320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1598323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1598326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598352 */     // MIs[0] policy
     /* 1598352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598362 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1598365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598386 */     // GIR_Coverage, 2994,
     /* 1598386 */     GIR_EraseRootFromParent_Done,
     /* 1598387 */   // Label 22089: @1598387
     /* 1598387 */   GIM_Try, /*On fail goto*//*Label 22090*/ GIMT_Encode4(1598473), // Rule ID 2995 //
     /* 1598392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1598403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1598406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1598409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1598412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598438 */     // MIs[0] policy
     /* 1598438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1598451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598472 */     // GIR_Coverage, 2995,
     /* 1598472 */     GIR_EraseRootFromParent_Done,
     /* 1598473 */   // Label 22090: @1598473
     /* 1598473 */   GIM_Try, /*On fail goto*//*Label 22091*/ GIMT_Encode4(1598559), // Rule ID 2998 //
     /* 1598478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1598489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1598492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1598495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1598498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598524 */     // MIs[0] policy
     /* 1598524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1598537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598558 */     // GIR_Coverage, 2998,
     /* 1598558 */     GIR_EraseRootFromParent_Done,
     /* 1598559 */   // Label 22091: @1598559
     /* 1598559 */   GIM_Try, /*On fail goto*//*Label 22092*/ GIMT_Encode4(1598645), // Rule ID 2999 //
     /* 1598564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1598575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1598578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1598581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1598584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598610 */     // MIs[0] policy
     /* 1598610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598620 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1598623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598644 */     // GIR_Coverage, 2999,
     /* 1598644 */     GIR_EraseRootFromParent_Done,
     /* 1598645 */   // Label 22092: @1598645
     /* 1598645 */   GIM_Try, /*On fail goto*//*Label 22093*/ GIMT_Encode4(1598731), // Rule ID 3002 //
     /* 1598650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1598653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1598661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1598664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1598667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1598670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598696 */     // MIs[0] policy
     /* 1598696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1598709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598730 */     // GIR_Coverage, 3002,
     /* 1598730 */     GIR_EraseRootFromParent_Done,
     /* 1598731 */   // Label 22093: @1598731
     /* 1598731 */   GIM_Try, /*On fail goto*//*Label 22094*/ GIMT_Encode4(1598817), // Rule ID 3003 //
     /* 1598736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1598739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1598747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1598750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1598753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1598756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598782 */     // MIs[0] policy
     /* 1598782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598792 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1598795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598816 */     // GIR_Coverage, 3003,
     /* 1598816 */     GIR_EraseRootFromParent_Done,
     /* 1598817 */   // Label 22094: @1598817
     /* 1598817 */   GIM_Try, /*On fail goto*//*Label 22095*/ GIMT_Encode4(1598903), // Rule ID 3006 //
     /* 1598822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1598833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1598836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1598839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1598842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1598845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1598852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598868 */     // MIs[0] policy
     /* 1598868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598878 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1598881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598902 */     // GIR_Coverage, 3006,
     /* 1598902 */     GIR_EraseRootFromParent_Done,
     /* 1598903 */   // Label 22095: @1598903
     /* 1598903 */   GIM_Try, /*On fail goto*//*Label 22096*/ GIMT_Encode4(1598989), // Rule ID 3007 //
     /* 1598908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1598919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1598922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1598925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1598928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1598931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1598938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598954 */     // MIs[0] policy
     /* 1598954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598964 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1598967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598988 */     // GIR_Coverage, 3007,
     /* 1598988 */     GIR_EraseRootFromParent_Done,
     /* 1598989 */   // Label 22096: @1598989
     /* 1598989 */   GIM_Try, /*On fail goto*//*Label 22097*/ GIMT_Encode4(1599075), // Rule ID 3010 //
     /* 1598994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1599005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1599008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1599011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1599014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599040 */     // MIs[0] policy
     /* 1599040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599050 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1599053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599074 */     // GIR_Coverage, 3010,
     /* 1599074 */     GIR_EraseRootFromParent_Done,
     /* 1599075 */   // Label 22097: @1599075
     /* 1599075 */   GIM_Try, /*On fail goto*//*Label 22098*/ GIMT_Encode4(1599161), // Rule ID 3011 //
     /* 1599080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1599091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1599094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1599097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1599100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599126 */     // MIs[0] policy
     /* 1599126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599136 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1599139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599160 */     // GIR_Coverage, 3011,
     /* 1599160 */     GIR_EraseRootFromParent_Done,
     /* 1599161 */   // Label 22098: @1599161
     /* 1599161 */   GIM_Try, /*On fail goto*//*Label 22099*/ GIMT_Encode4(1599247), // Rule ID 3014 //
     /* 1599166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1599177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1599180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1599183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1599186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1599189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599212 */     // MIs[0] policy
     /* 1599212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599222 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1599225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599246 */     // GIR_Coverage, 3014,
     /* 1599246 */     GIR_EraseRootFromParent_Done,
     /* 1599247 */   // Label 22099: @1599247
     /* 1599247 */   GIM_Try, /*On fail goto*//*Label 22100*/ GIMT_Encode4(1599333), // Rule ID 3015 //
     /* 1599252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1599263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1599266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1599269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1599272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1599275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599298 */     // MIs[0] policy
     /* 1599298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599308 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1599311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599332 */     // GIR_Coverage, 3015,
     /* 1599332 */     GIR_EraseRootFromParent_Done,
     /* 1599333 */   // Label 22100: @1599333
     /* 1599333 */   GIM_Try, /*On fail goto*//*Label 22101*/ GIMT_Encode4(1599419), // Rule ID 3018 //
     /* 1599338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1599349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1599352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1599355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1599358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599384 */     // MIs[0] policy
     /* 1599384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599394 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1599397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599418 */     // GIR_Coverage, 3018,
     /* 1599418 */     GIR_EraseRootFromParent_Done,
     /* 1599419 */   // Label 22101: @1599419
     /* 1599419 */   GIM_Try, /*On fail goto*//*Label 22102*/ GIMT_Encode4(1599505), // Rule ID 3019 //
     /* 1599424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1599435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1599438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1599441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1599444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599470 */     // MIs[0] policy
     /* 1599470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599480 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1599483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599504 */     // GIR_Coverage, 3019,
     /* 1599504 */     GIR_EraseRootFromParent_Done,
     /* 1599505 */   // Label 22102: @1599505
     /* 1599505 */   GIM_Try, /*On fail goto*//*Label 22103*/ GIMT_Encode4(1599591), // Rule ID 3022 //
     /* 1599510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1599521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1599524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1599527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1599530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599556 */     // MIs[0] policy
     /* 1599556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599566 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1599569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599590 */     // GIR_Coverage, 3022,
     /* 1599590 */     GIR_EraseRootFromParent_Done,
     /* 1599591 */   // Label 22103: @1599591
     /* 1599591 */   GIM_Try, /*On fail goto*//*Label 22104*/ GIMT_Encode4(1599677), // Rule ID 3023 //
     /* 1599596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1599607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1599610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1599613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1599616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599642 */     // MIs[0] policy
     /* 1599642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599652 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1599655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599676 */     // GIR_Coverage, 3023,
     /* 1599676 */     GIR_EraseRootFromParent_Done,
     /* 1599677 */   // Label 22104: @1599677
     /* 1599677 */   GIM_Try, /*On fail goto*//*Label 22105*/ GIMT_Encode4(1599763), // Rule ID 3026 //
     /* 1599682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1599693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1599696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1599699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1599702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599728 */     // MIs[0] policy
     /* 1599728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599738 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1599741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599762 */     // GIR_Coverage, 3026,
     /* 1599762 */     GIR_EraseRootFromParent_Done,
     /* 1599763 */   // Label 22105: @1599763
     /* 1599763 */   GIM_Try, /*On fail goto*//*Label 22106*/ GIMT_Encode4(1599849), // Rule ID 3027 //
     /* 1599768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1599779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1599782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1599785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1599788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599814 */     // MIs[0] policy
     /* 1599814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599824 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1599827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599848 */     // GIR_Coverage, 3027,
     /* 1599848 */     GIR_EraseRootFromParent_Done,
     /* 1599849 */   // Label 22106: @1599849
     /* 1599849 */   GIM_Try, /*On fail goto*//*Label 22107*/ GIMT_Encode4(1599935), // Rule ID 3030 //
     /* 1599854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1599865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1599868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1599871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1599874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1599877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599900 */     // MIs[0] policy
     /* 1599900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599910 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1599913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1599931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599934 */     // GIR_Coverage, 3030,
     /* 1599934 */     GIR_EraseRootFromParent_Done,
     /* 1599935 */   // Label 22107: @1599935
     /* 1599935 */   GIM_Try, /*On fail goto*//*Label 22108*/ GIMT_Encode4(1600021), // Rule ID 3031 //
     /* 1599940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1599951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1599954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1599957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1599960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1599963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599986 */     // MIs[0] policy
     /* 1599986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1599999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600020 */     // GIR_Coverage, 3031,
     /* 1600020 */     GIR_EraseRootFromParent_Done,
     /* 1600021 */   // Label 22108: @1600021
     /* 1600021 */   GIM_Try, /*On fail goto*//*Label 22109*/ GIMT_Encode4(1600107), // Rule ID 3034 //
     /* 1600026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1600037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1600040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1600043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1600046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600072 */     // MIs[0] policy
     /* 1600072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600082 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1600085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600106 */     // GIR_Coverage, 3034,
     /* 1600106 */     GIR_EraseRootFromParent_Done,
     /* 1600107 */   // Label 22109: @1600107
     /* 1600107 */   GIM_Try, /*On fail goto*//*Label 22110*/ GIMT_Encode4(1600193), // Rule ID 3035 //
     /* 1600112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1600123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1600126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1600129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1600132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600158 */     // MIs[0] policy
     /* 1600158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600168 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1600171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600192 */     // GIR_Coverage, 3035,
     /* 1600192 */     GIR_EraseRootFromParent_Done,
     /* 1600193 */   // Label 22110: @1600193
     /* 1600193 */   GIM_Try, /*On fail goto*//*Label 22111*/ GIMT_Encode4(1600279), // Rule ID 3038 //
     /* 1600198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1600209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1600212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1600215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1600218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600244 */     // MIs[0] policy
     /* 1600244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600254 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1600257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600278 */     // GIR_Coverage, 3038,
     /* 1600278 */     GIR_EraseRootFromParent_Done,
     /* 1600279 */   // Label 22111: @1600279
     /* 1600279 */   GIM_Try, /*On fail goto*//*Label 22112*/ GIMT_Encode4(1600365), // Rule ID 3039 //
     /* 1600284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1600295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1600298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1600301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1600304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600330 */     // MIs[0] policy
     /* 1600330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600340 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1600343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600364 */     // GIR_Coverage, 3039,
     /* 1600364 */     GIR_EraseRootFromParent_Done,
     /* 1600365 */   // Label 22112: @1600365
     /* 1600365 */   GIM_Try, /*On fail goto*//*Label 22113*/ GIMT_Encode4(1600451), // Rule ID 3042 //
     /* 1600370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1600381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1600384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1600387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1600390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600416 */     // MIs[0] policy
     /* 1600416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1600429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600450 */     // GIR_Coverage, 3042,
     /* 1600450 */     GIR_EraseRootFromParent_Done,
     /* 1600451 */   // Label 22113: @1600451
     /* 1600451 */   GIM_Try, /*On fail goto*//*Label 22114*/ GIMT_Encode4(1600537), // Rule ID 3043 //
     /* 1600456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1600459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1600467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1600470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1600473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1600476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600502 */     // MIs[0] policy
     /* 1600502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600512 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1600515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600536 */     // GIR_Coverage, 3043,
     /* 1600536 */     GIR_EraseRootFromParent_Done,
     /* 1600537 */   // Label 22114: @1600537
     /* 1600537 */   GIM_Try, /*On fail goto*//*Label 22115*/ GIMT_Encode4(1600623), // Rule ID 3046 //
     /* 1600542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1600553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1600556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1600559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1600562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600588 */     // MIs[0] policy
     /* 1600588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600598 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1600601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600622 */     // GIR_Coverage, 3046,
     /* 1600622 */     GIR_EraseRootFromParent_Done,
     /* 1600623 */   // Label 22115: @1600623
     /* 1600623 */   GIM_Try, /*On fail goto*//*Label 22116*/ GIMT_Encode4(1600709), // Rule ID 3047 //
     /* 1600628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1600631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1600639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1600642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1600645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1600648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600674 */     // MIs[0] policy
     /* 1600674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600684 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1600687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600708 */     // GIR_Coverage, 3047,
     /* 1600708 */     GIR_EraseRootFromParent_Done,
     /* 1600709 */   // Label 22116: @1600709
     /* 1600709 */   GIM_Try, /*On fail goto*//*Label 22117*/ GIMT_Encode4(1600795), // Rule ID 3050 //
     /* 1600714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1600725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1600728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1600731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1600734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600760 */     // MIs[0] policy
     /* 1600760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600770 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1600773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600794 */     // GIR_Coverage, 3050,
     /* 1600794 */     GIR_EraseRootFromParent_Done,
     /* 1600795 */   // Label 22117: @1600795
     /* 1600795 */   GIM_Try, /*On fail goto*//*Label 22118*/ GIMT_Encode4(1600881), // Rule ID 3051 //
     /* 1600800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1600803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1600811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1600814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1600817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1600820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600846 */     // MIs[0] policy
     /* 1600846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600856 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1600859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600880 */     // GIR_Coverage, 3051,
     /* 1600880 */     GIR_EraseRootFromParent_Done,
     /* 1600881 */   // Label 22118: @1600881
     /* 1600881 */   GIM_Try, /*On fail goto*//*Label 22119*/ GIMT_Encode4(1600967), // Rule ID 3054 //
     /* 1600886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1600897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1600900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1600903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1600909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600932 */     // MIs[0] policy
     /* 1600932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600942 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1600945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600966 */     // GIR_Coverage, 3054,
     /* 1600966 */     GIR_EraseRootFromParent_Done,
     /* 1600967 */   // Label 22119: @1600967
     /* 1600967 */   GIM_Try, /*On fail goto*//*Label 22120*/ GIMT_Encode4(1601053), // Rule ID 3055 //
     /* 1600972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1600983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1600986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1600989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1600995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601018 */     // MIs[0] policy
     /* 1601018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601028 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1601031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601052 */     // GIR_Coverage, 3055,
     /* 1601052 */     GIR_EraseRootFromParent_Done,
     /* 1601053 */   // Label 22120: @1601053
     /* 1601053 */   GIM_Try, /*On fail goto*//*Label 22121*/ GIMT_Encode4(1601139), // Rule ID 3058 //
     /* 1601058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1601069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1601072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1601075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601104 */     // MIs[0] policy
     /* 1601104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601114 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1601117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601138 */     // GIR_Coverage, 3058,
     /* 1601138 */     GIR_EraseRootFromParent_Done,
     /* 1601139 */   // Label 22121: @1601139
     /* 1601139 */   GIM_Try, /*On fail goto*//*Label 22122*/ GIMT_Encode4(1601225), // Rule ID 3059 //
     /* 1601144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1601155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1601158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1601161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601190 */     // MIs[0] policy
     /* 1601190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601200 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1601203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601224 */     // GIR_Coverage, 3059,
     /* 1601224 */     GIR_EraseRootFromParent_Done,
     /* 1601225 */   // Label 22122: @1601225
     /* 1601225 */   GIM_Try, /*On fail goto*//*Label 22123*/ GIMT_Encode4(1601311), // Rule ID 3062 //
     /* 1601230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1601241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1601244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1601247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601276 */     // MIs[0] policy
     /* 1601276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601286 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1601289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601310 */     // GIR_Coverage, 3062,
     /* 1601310 */     GIR_EraseRootFromParent_Done,
     /* 1601311 */   // Label 22123: @1601311
     /* 1601311 */   GIM_Try, /*On fail goto*//*Label 22124*/ GIMT_Encode4(1601397), // Rule ID 3063 //
     /* 1601316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1601327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1601330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1601333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601362 */     // MIs[0] policy
     /* 1601362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601372 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1601375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601396 */     // GIR_Coverage, 3063,
     /* 1601396 */     GIR_EraseRootFromParent_Done,
     /* 1601397 */   // Label 22124: @1601397
     /* 1601397 */   GIM_Try, /*On fail goto*//*Label 22125*/ GIMT_Encode4(1601483), // Rule ID 3066 //
     /* 1601402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1601413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1601416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1601419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601448 */     // MIs[0] policy
     /* 1601448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601458 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1601461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601482 */     // GIR_Coverage, 3066,
     /* 1601482 */     GIR_EraseRootFromParent_Done,
     /* 1601483 */   // Label 22125: @1601483
     /* 1601483 */   GIM_Try, /*On fail goto*//*Label 22126*/ GIMT_Encode4(1601569), // Rule ID 3067 //
     /* 1601488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1601499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1601502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1601505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601534 */     // MIs[0] policy
     /* 1601534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601544 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1601547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601568 */     // GIR_Coverage, 3067,
     /* 1601568 */     GIR_EraseRootFromParent_Done,
     /* 1601569 */   // Label 22126: @1601569
     /* 1601569 */   GIM_Try, /*On fail goto*//*Label 22127*/ GIMT_Encode4(1601655), // Rule ID 3070 //
     /* 1601574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1601585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1601588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1601591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601620 */     // MIs[0] policy
     /* 1601620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601630 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1601633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601654 */     // GIR_Coverage, 3070,
     /* 1601654 */     GIR_EraseRootFromParent_Done,
     /* 1601655 */   // Label 22127: @1601655
     /* 1601655 */   GIM_Try, /*On fail goto*//*Label 22128*/ GIMT_Encode4(1601741), // Rule ID 3071 //
     /* 1601660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1601671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1601674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1601677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601706 */     // MIs[0] policy
     /* 1601706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601716 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1601719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601740 */     // GIR_Coverage, 3071,
     /* 1601740 */     GIR_EraseRootFromParent_Done,
     /* 1601741 */   // Label 22128: @1601741
     /* 1601741 */   GIM_Try, /*On fail goto*//*Label 22129*/ GIMT_Encode4(1601827), // Rule ID 3074 //
     /* 1601746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1601757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1601760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1601763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601792 */     // MIs[0] policy
     /* 1601792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1601805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601826 */     // GIR_Coverage, 3074,
     /* 1601826 */     GIR_EraseRootFromParent_Done,
     /* 1601827 */   // Label 22129: @1601827
     /* 1601827 */   GIM_Try, /*On fail goto*//*Label 22130*/ GIMT_Encode4(1601913), // Rule ID 3075 //
     /* 1601832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1601843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1601846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1601849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601878 */     // MIs[0] policy
     /* 1601878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601888 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1601891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601912 */     // GIR_Coverage, 3075,
     /* 1601912 */     GIR_EraseRootFromParent_Done,
     /* 1601913 */   // Label 22130: @1601913
     /* 1601913 */   GIM_Try, /*On fail goto*//*Label 22131*/ GIMT_Encode4(1601999), // Rule ID 3078 //
     /* 1601918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1601929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1601932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1601935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601964 */     // MIs[0] policy
     /* 1601964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1601977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601998 */     // GIR_Coverage, 3078,
     /* 1601998 */     GIR_EraseRootFromParent_Done,
     /* 1601999 */   // Label 22131: @1601999
     /* 1601999 */   GIM_Try, /*On fail goto*//*Label 22132*/ GIMT_Encode4(1602085), // Rule ID 3079 //
     /* 1602004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1602012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1602015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1602018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1602021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1602027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602050 */     // MIs[0] policy
     /* 1602050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602060 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1602063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602084 */     // GIR_Coverage, 3079,
     /* 1602084 */     GIR_EraseRootFromParent_Done,
     /* 1602085 */   // Label 22132: @1602085
     /* 1602085 */   GIM_Try, /*On fail goto*//*Label 22133*/ GIMT_Encode4(1602171), // Rule ID 3082 //
     /* 1602090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1602098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1602101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1602104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1602107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602136 */     // MIs[0] policy
     /* 1602136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1602149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602170 */     // GIR_Coverage, 3082,
     /* 1602170 */     GIR_EraseRootFromParent_Done,
     /* 1602171 */   // Label 22133: @1602171
     /* 1602171 */   GIM_Try, /*On fail goto*//*Label 22134*/ GIMT_Encode4(1602257), // Rule ID 3083 //
     /* 1602176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1602184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1602187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1602190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1602193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602222 */     // MIs[0] policy
     /* 1602222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1602235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602256 */     // GIR_Coverage, 3083,
     /* 1602256 */     GIR_EraseRootFromParent_Done,
     /* 1602257 */   // Label 22134: @1602257
     /* 1602257 */   GIM_Try, /*On fail goto*//*Label 22135*/ GIMT_Encode4(1602343), // Rule ID 3086 //
     /* 1602262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1602270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1602273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1602276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1602279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602308 */     // MIs[0] policy
     /* 1602308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1602321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602342 */     // GIR_Coverage, 3086,
     /* 1602342 */     GIR_EraseRootFromParent_Done,
     /* 1602343 */   // Label 22135: @1602343
     /* 1602343 */   GIM_Try, /*On fail goto*//*Label 22136*/ GIMT_Encode4(1602429), // Rule ID 3087 //
     /* 1602348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1602356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1602359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1602362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1602365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602394 */     // MIs[0] policy
     /* 1602394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602404 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1602407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602428 */     // GIR_Coverage, 3087,
     /* 1602428 */     GIR_EraseRootFromParent_Done,
     /* 1602429 */   // Label 22136: @1602429
     /* 1602429 */   GIM_Try, /*On fail goto*//*Label 22137*/ GIMT_Encode4(1602515), // Rule ID 3090 //
     /* 1602434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1602437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1602442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1602445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1602448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1602451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602480 */     // MIs[0] policy
     /* 1602480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1602493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1602511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602514 */     // GIR_Coverage, 3090,
     /* 1602514 */     GIR_EraseRootFromParent_Done,
     /* 1602515 */   // Label 22137: @1602515
     /* 1602515 */   GIM_Try, /*On fail goto*//*Label 22138*/ GIMT_Encode4(1602601), // Rule ID 3091 //
     /* 1602520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1602523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1602528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1602531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1602534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1602537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602566 */     // MIs[0] policy
     /* 1602566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1602579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1602597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602600 */     // GIR_Coverage, 3091,
     /* 1602600 */     GIR_EraseRootFromParent_Done,
     /* 1602601 */   // Label 22138: @1602601
     /* 1602601 */   GIM_Try, /*On fail goto*//*Label 22139*/ GIMT_Encode4(1602687), // Rule ID 3094 //
     /* 1602606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1602614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1602617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1602620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1602623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1602629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1602636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602652 */     // MIs[0] policy
     /* 1602652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602662 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1602665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602686 */     // GIR_Coverage, 3094,
     /* 1602686 */     GIR_EraseRootFromParent_Done,
     /* 1602687 */   // Label 22139: @1602687
     /* 1602687 */   GIM_Try, /*On fail goto*//*Label 22140*/ GIMT_Encode4(1602773), // Rule ID 3095 //
     /* 1602692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1602700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1602703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1602706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1602709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1602715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1602722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602738 */     // MIs[0] policy
     /* 1602738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602748 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1602751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602772 */     // GIR_Coverage, 3095,
     /* 1602772 */     GIR_EraseRootFromParent_Done,
     /* 1602773 */   // Label 22140: @1602773
     /* 1602773 */   GIM_Try, /*On fail goto*//*Label 22141*/ GIMT_Encode4(1602859), // Rule ID 3098 //
     /* 1602778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1602786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1602789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1602792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1602795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1602801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1602808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602824 */     // MIs[0] policy
     /* 1602824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602834 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1602837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602858 */     // GIR_Coverage, 3098,
     /* 1602858 */     GIR_EraseRootFromParent_Done,
     /* 1602859 */   // Label 22141: @1602859
     /* 1602859 */   GIM_Try, /*On fail goto*//*Label 22142*/ GIMT_Encode4(1602945), // Rule ID 3099 //
     /* 1602864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1602872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1602875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1602878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1602881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1602887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1602894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602910 */     // MIs[0] policy
     /* 1602910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602920 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1602923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602944 */     // GIR_Coverage, 3099,
     /* 1602944 */     GIR_EraseRootFromParent_Done,
     /* 1602945 */   // Label 22142: @1602945
     /* 1602945 */   GIM_Try, /*On fail goto*//*Label 22143*/ GIMT_Encode4(1603031), // Rule ID 3102 //
     /* 1602950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1602958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1602961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1602964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1602967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1602973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1602980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602996 */     // MIs[0] policy
     /* 1602996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603006 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1603009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603030 */     // GIR_Coverage, 3102,
     /* 1603030 */     GIR_EraseRootFromParent_Done,
     /* 1603031 */   // Label 22143: @1603031
     /* 1603031 */   GIM_Try, /*On fail goto*//*Label 22144*/ GIMT_Encode4(1603117), // Rule ID 3103 //
     /* 1603036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1603044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1603047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1603050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1603053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1603059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603082 */     // MIs[0] policy
     /* 1603082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1603095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603116 */     // GIR_Coverage, 3103,
     /* 1603116 */     GIR_EraseRootFromParent_Done,
     /* 1603117 */   // Label 22144: @1603117
     /* 1603117 */   GIM_Try, /*On fail goto*//*Label 22145*/ GIMT_Encode4(1603203), // Rule ID 3106 //
     /* 1603122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1603130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1603133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1603136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1603139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603168 */     // MIs[0] policy
     /* 1603168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603178 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1603181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603202 */     // GIR_Coverage, 3106,
     /* 1603202 */     GIR_EraseRootFromParent_Done,
     /* 1603203 */   // Label 22145: @1603203
     /* 1603203 */   GIM_Try, /*On fail goto*//*Label 22146*/ GIMT_Encode4(1603289), // Rule ID 3107 //
     /* 1603208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1603216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1603219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1603222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1603225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603254 */     // MIs[0] policy
     /* 1603254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603264 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1603267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603288 */     // GIR_Coverage, 3107,
     /* 1603288 */     GIR_EraseRootFromParent_Done,
     /* 1603289 */   // Label 22146: @1603289
     /* 1603289 */   GIM_Try, /*On fail goto*//*Label 22147*/ GIMT_Encode4(1603375), // Rule ID 3110 //
     /* 1603294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1603302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1603305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1603308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1603311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603340 */     // MIs[0] policy
     /* 1603340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1603353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603374 */     // GIR_Coverage, 3110,
     /* 1603374 */     GIR_EraseRootFromParent_Done,
     /* 1603375 */   // Label 22147: @1603375
     /* 1603375 */   GIM_Try, /*On fail goto*//*Label 22148*/ GIMT_Encode4(1603461), // Rule ID 3111 //
     /* 1603380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1603388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1603391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1603394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1603397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603426 */     // MIs[0] policy
     /* 1603426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603436 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1603439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603460 */     // GIR_Coverage, 3111,
     /* 1603460 */     GIR_EraseRootFromParent_Done,
     /* 1603461 */   // Label 22148: @1603461
     /* 1603461 */   GIM_Try, /*On fail goto*//*Label 22149*/ GIMT_Encode4(1603547), // Rule ID 3114 //
     /* 1603466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1603474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1603477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1603480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1603483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603512 */     // MIs[0] policy
     /* 1603512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603522 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1603525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603546 */     // GIR_Coverage, 3114,
     /* 1603546 */     GIR_EraseRootFromParent_Done,
     /* 1603547 */   // Label 22149: @1603547
     /* 1603547 */   GIM_Try, /*On fail goto*//*Label 22150*/ GIMT_Encode4(1603633), // Rule ID 3115 //
     /* 1603552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1603560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1603563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1603566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1603569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603598 */     // MIs[0] policy
     /* 1603598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1603611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603632 */     // GIR_Coverage, 3115,
     /* 1603632 */     GIR_EraseRootFromParent_Done,
     /* 1603633 */   // Label 22150: @1603633
     /* 1603633 */   GIM_Try, /*On fail goto*//*Label 22151*/ GIMT_Encode4(1603719), // Rule ID 3118 //
     /* 1603638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1603646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1603649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1603652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1603655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603684 */     // MIs[0] policy
     /* 1603684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1603697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603718 */     // GIR_Coverage, 3118,
     /* 1603718 */     GIR_EraseRootFromParent_Done,
     /* 1603719 */   // Label 22151: @1603719
     /* 1603719 */   GIM_Try, /*On fail goto*//*Label 22152*/ GIMT_Encode4(1603805), // Rule ID 3119 //
     /* 1603724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1603732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1603735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1603738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1603741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603770 */     // MIs[0] policy
     /* 1603770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603780 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1603783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603804 */     // GIR_Coverage, 3119,
     /* 1603804 */     GIR_EraseRootFromParent_Done,
     /* 1603805 */   // Label 22152: @1603805
     /* 1603805 */   GIM_Try, /*On fail goto*//*Label 22153*/ GIMT_Encode4(1603891), // Rule ID 3122 //
     /* 1603810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1603818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1603821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1603824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1603827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603856 */     // MIs[0] policy
     /* 1603856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1603869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603890 */     // GIR_Coverage, 3122,
     /* 1603890 */     GIR_EraseRootFromParent_Done,
     /* 1603891 */   // Label 22153: @1603891
     /* 1603891 */   GIM_Try, /*On fail goto*//*Label 22154*/ GIMT_Encode4(1603977), // Rule ID 3123 //
     /* 1603896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1603904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1603907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1603910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1603913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603942 */     // MIs[0] policy
     /* 1603942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603952 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1603955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603976 */     // GIR_Coverage, 3123,
     /* 1603976 */     GIR_EraseRootFromParent_Done,
     /* 1603977 */   // Label 22154: @1603977
     /* 1603977 */   GIM_Try, /*On fail goto*//*Label 22155*/ GIMT_Encode4(1604063), // Rule ID 3126 //
     /* 1603982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1603990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1603993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1603996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1603999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604028 */     // MIs[0] policy
     /* 1604028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1604041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604062 */     // GIR_Coverage, 3126,
     /* 1604062 */     GIR_EraseRootFromParent_Done,
     /* 1604063 */   // Label 22155: @1604063
     /* 1604063 */   GIM_Try, /*On fail goto*//*Label 22156*/ GIMT_Encode4(1604149), // Rule ID 3127 //
     /* 1604068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1604076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1604079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1604082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1604085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604114 */     // MIs[0] policy
     /* 1604114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604124 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1604127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604148 */     // GIR_Coverage, 3127,
     /* 1604148 */     GIR_EraseRootFromParent_Done,
     /* 1604149 */   // Label 22156: @1604149
     /* 1604149 */   GIM_Try, /*On fail goto*//*Label 22157*/ GIMT_Encode4(1604235), // Rule ID 3130 //
     /* 1604154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1604162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1604165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1604168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1604171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604200 */     // MIs[0] policy
     /* 1604200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604210 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1604213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604234 */     // GIR_Coverage, 3130,
     /* 1604234 */     GIR_EraseRootFromParent_Done,
     /* 1604235 */   // Label 22157: @1604235
     /* 1604235 */   GIM_Try, /*On fail goto*//*Label 22158*/ GIMT_Encode4(1604321), // Rule ID 3131 //
     /* 1604240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1604248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1604251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1604254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1604257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604286 */     // MIs[0] policy
     /* 1604286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604296 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1604299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604320 */     // GIR_Coverage, 3131,
     /* 1604320 */     GIR_EraseRootFromParent_Done,
     /* 1604321 */   // Label 22158: @1604321
     /* 1604321 */   GIM_Try, /*On fail goto*//*Label 22159*/ GIMT_Encode4(1604407), // Rule ID 3134 //
     /* 1604326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1604334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1604337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1604340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1604343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604372 */     // MIs[0] policy
     /* 1604372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604382 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1604385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604406 */     // GIR_Coverage, 3134,
     /* 1604406 */     GIR_EraseRootFromParent_Done,
     /* 1604407 */   // Label 22159: @1604407
     /* 1604407 */   GIM_Try, /*On fail goto*//*Label 22160*/ GIMT_Encode4(1604493), // Rule ID 3135 //
     /* 1604412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1604420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1604423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1604426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1604429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604458 */     // MIs[0] policy
     /* 1604458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1604471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604492 */     // GIR_Coverage, 3135,
     /* 1604492 */     GIR_EraseRootFromParent_Done,
     /* 1604493 */   // Label 22160: @1604493
     /* 1604493 */   GIM_Try, /*On fail goto*//*Label 22161*/ GIMT_Encode4(1604579), // Rule ID 3138 //
     /* 1604498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1604506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1604509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1604512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1604515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604544 */     // MIs[0] policy
     /* 1604544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604554 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1604557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604578 */     // GIR_Coverage, 3138,
     /* 1604578 */     GIR_EraseRootFromParent_Done,
     /* 1604579 */   // Label 22161: @1604579
     /* 1604579 */   GIM_Try, /*On fail goto*//*Label 22162*/ GIMT_Encode4(1604665), // Rule ID 3139 //
     /* 1604584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1604592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1604595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1604598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1604601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604630 */     // MIs[0] policy
     /* 1604630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604640 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1604643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604664 */     // GIR_Coverage, 3139,
     /* 1604664 */     GIR_EraseRootFromParent_Done,
     /* 1604665 */   // Label 22162: @1604665
     /* 1604665 */   GIM_Try, /*On fail goto*//*Label 22163*/ GIMT_Encode4(1604751), // Rule ID 3230 //
     /* 1604670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1604681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1604684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1604687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1604690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1604693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604716 */     // MIs[0] policy
     /* 1604716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604726 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1604729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604750 */     // GIR_Coverage, 3230,
     /* 1604750 */     GIR_EraseRootFromParent_Done,
     /* 1604751 */   // Label 22163: @1604751
     /* 1604751 */   GIM_Try, /*On fail goto*//*Label 22164*/ GIMT_Encode4(1604837), // Rule ID 3231 //
     /* 1604756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1604767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1604770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1604773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1604776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1604779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604802 */     // MIs[0] policy
     /* 1604802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604812 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1604815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604836 */     // GIR_Coverage, 3231,
     /* 1604836 */     GIR_EraseRootFromParent_Done,
     /* 1604837 */   // Label 22164: @1604837
     /* 1604837 */   GIM_Try, /*On fail goto*//*Label 22165*/ GIMT_Encode4(1604923), // Rule ID 3234 //
     /* 1604842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1604853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1604856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1604859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1604862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604888 */     // MIs[0] policy
     /* 1604888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604898 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1604901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604922 */     // GIR_Coverage, 3234,
     /* 1604922 */     GIR_EraseRootFromParent_Done,
     /* 1604923 */   // Label 22165: @1604923
     /* 1604923 */   GIM_Try, /*On fail goto*//*Label 22166*/ GIMT_Encode4(1605009), // Rule ID 3235 //
     /* 1604928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1604939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1604942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1604945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1604948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604974 */     // MIs[0] policy
     /* 1604974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604984 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1604987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605008 */     // GIR_Coverage, 3235,
     /* 1605008 */     GIR_EraseRootFromParent_Done,
     /* 1605009 */   // Label 22166: @1605009
     /* 1605009 */   GIM_Try, /*On fail goto*//*Label 22167*/ GIMT_Encode4(1605095), // Rule ID 3238 //
     /* 1605014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1605025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1605028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1605031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1605034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605060 */     // MIs[0] policy
     /* 1605060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605070 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1605073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605094 */     // GIR_Coverage, 3238,
     /* 1605094 */     GIR_EraseRootFromParent_Done,
     /* 1605095 */   // Label 22167: @1605095
     /* 1605095 */   GIM_Try, /*On fail goto*//*Label 22168*/ GIMT_Encode4(1605181), // Rule ID 3239 //
     /* 1605100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1605111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1605114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1605117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1605120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605146 */     // MIs[0] policy
     /* 1605146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605156 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1605159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605180 */     // GIR_Coverage, 3239,
     /* 1605180 */     GIR_EraseRootFromParent_Done,
     /* 1605181 */   // Label 22168: @1605181
     /* 1605181 */   GIM_Try, /*On fail goto*//*Label 22169*/ GIMT_Encode4(1605267), // Rule ID 3242 //
     /* 1605186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1605197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1605200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1605203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1605206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605232 */     // MIs[0] policy
     /* 1605232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605242 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1605245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605266 */     // GIR_Coverage, 3242,
     /* 1605266 */     GIR_EraseRootFromParent_Done,
     /* 1605267 */   // Label 22169: @1605267
     /* 1605267 */   GIM_Try, /*On fail goto*//*Label 22170*/ GIMT_Encode4(1605353), // Rule ID 3243 //
     /* 1605272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1605283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1605286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1605289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1605292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605318 */     // MIs[0] policy
     /* 1605318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605328 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1605331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605352 */     // GIR_Coverage, 3243,
     /* 1605352 */     GIR_EraseRootFromParent_Done,
     /* 1605353 */   // Label 22170: @1605353
     /* 1605353 */   GIM_Try, /*On fail goto*//*Label 22171*/ GIMT_Encode4(1605439), // Rule ID 3246 //
     /* 1605358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1605369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1605372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1605375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1605378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605404 */     // MIs[0] policy
     /* 1605404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605414 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1605417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605438 */     // GIR_Coverage, 3246,
     /* 1605438 */     GIR_EraseRootFromParent_Done,
     /* 1605439 */   // Label 22171: @1605439
     /* 1605439 */   GIM_Try, /*On fail goto*//*Label 22172*/ GIMT_Encode4(1605525), // Rule ID 3247 //
     /* 1605444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1605455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1605458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1605461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1605464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605490 */     // MIs[0] policy
     /* 1605490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605500 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1605503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605524 */     // GIR_Coverage, 3247,
     /* 1605524 */     GIR_EraseRootFromParent_Done,
     /* 1605525 */   // Label 22172: @1605525
     /* 1605525 */   GIM_Try, /*On fail goto*//*Label 22173*/ GIMT_Encode4(1605611), // Rule ID 3250 //
     /* 1605530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1605541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1605544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1605547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1605550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605576 */     // MIs[0] policy
     /* 1605576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1605589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605610 */     // GIR_Coverage, 3250,
     /* 1605610 */     GIR_EraseRootFromParent_Done,
     /* 1605611 */   // Label 22173: @1605611
     /* 1605611 */   GIM_Try, /*On fail goto*//*Label 22174*/ GIMT_Encode4(1605697), // Rule ID 3251 //
     /* 1605616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1605627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1605630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1605633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1605636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605662 */     // MIs[0] policy
     /* 1605662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1605675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605696 */     // GIR_Coverage, 3251,
     /* 1605696 */     GIR_EraseRootFromParent_Done,
     /* 1605697 */   // Label 22174: @1605697
     /* 1605697 */   GIM_Try, /*On fail goto*//*Label 22175*/ GIMT_Encode4(1605783), // Rule ID 3254 //
     /* 1605702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1605713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1605716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1605719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1605722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605748 */     // MIs[0] policy
     /* 1605748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1605761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605782 */     // GIR_Coverage, 3254,
     /* 1605782 */     GIR_EraseRootFromParent_Done,
     /* 1605783 */   // Label 22175: @1605783
     /* 1605783 */   GIM_Try, /*On fail goto*//*Label 22176*/ GIMT_Encode4(1605869), // Rule ID 3255 //
     /* 1605788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1605799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1605802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1605805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1605808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605834 */     // MIs[0] policy
     /* 1605834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1605847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605868 */     // GIR_Coverage, 3255,
     /* 1605868 */     GIR_EraseRootFromParent_Done,
     /* 1605869 */   // Label 22176: @1605869
     /* 1605869 */   GIM_Try, /*On fail goto*//*Label 22177*/ GIMT_Encode4(1605955), // Rule ID 3258 //
     /* 1605874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1605885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1605888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1605891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1605894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605920 */     // MIs[0] policy
     /* 1605920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605930 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1605933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605954 */     // GIR_Coverage, 3258,
     /* 1605954 */     GIR_EraseRootFromParent_Done,
     /* 1605955 */   // Label 22177: @1605955
     /* 1605955 */   GIM_Try, /*On fail goto*//*Label 22178*/ GIMT_Encode4(1606041), // Rule ID 3259 //
     /* 1605960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1605971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1605974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1605977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1605980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606006 */     // MIs[0] policy
     /* 1606006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1606019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606040 */     // GIR_Coverage, 3259,
     /* 1606040 */     GIR_EraseRootFromParent_Done,
     /* 1606041 */   // Label 22178: @1606041
     /* 1606041 */   GIM_Try, /*On fail goto*//*Label 22179*/ GIMT_Encode4(1606127), // Rule ID 3262 //
     /* 1606046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1606057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1606060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1606063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1606066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606092 */     // MIs[0] policy
     /* 1606092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606102 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1606105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606126 */     // GIR_Coverage, 3262,
     /* 1606126 */     GIR_EraseRootFromParent_Done,
     /* 1606127 */   // Label 22179: @1606127
     /* 1606127 */   GIM_Try, /*On fail goto*//*Label 22180*/ GIMT_Encode4(1606213), // Rule ID 3263 //
     /* 1606132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1606143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1606146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1606149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1606152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606178 */     // MIs[0] policy
     /* 1606178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606188 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1606191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606212 */     // GIR_Coverage, 3263,
     /* 1606212 */     GIR_EraseRootFromParent_Done,
     /* 1606213 */   // Label 22180: @1606213
     /* 1606213 */   GIM_Try, /*On fail goto*//*Label 22181*/ GIMT_Encode4(1606299), // Rule ID 3266 //
     /* 1606218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1606221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1606229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1606232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1606235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1606238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606264 */     // MIs[0] policy
     /* 1606264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1606277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1606295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606298 */     // GIR_Coverage, 3266,
     /* 1606298 */     GIR_EraseRootFromParent_Done,
     /* 1606299 */   // Label 22181: @1606299
     /* 1606299 */   GIM_Try, /*On fail goto*//*Label 22182*/ GIMT_Encode4(1606385), // Rule ID 3267 //
     /* 1606304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1606307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1606315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1606318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1606321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1606324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606350 */     // MIs[0] policy
     /* 1606350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606360 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1606363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1606381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606384 */     // GIR_Coverage, 3267,
     /* 1606384 */     GIR_EraseRootFromParent_Done,
     /* 1606385 */   // Label 22182: @1606385
     /* 1606385 */   GIM_Try, /*On fail goto*//*Label 22183*/ GIMT_Encode4(1606471), // Rule ID 3270 //
     /* 1606390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1606401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1606404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1606407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1606410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606436 */     // MIs[0] policy
     /* 1606436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606446 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1606449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606470 */     // GIR_Coverage, 3270,
     /* 1606470 */     GIR_EraseRootFromParent_Done,
     /* 1606471 */   // Label 22183: @1606471
     /* 1606471 */   GIM_Try, /*On fail goto*//*Label 22184*/ GIMT_Encode4(1606557), // Rule ID 3271 //
     /* 1606476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1606487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1606490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1606493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1606496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606522 */     // MIs[0] policy
     /* 1606522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606532 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1606535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606556 */     // GIR_Coverage, 3271,
     /* 1606556 */     GIR_EraseRootFromParent_Done,
     /* 1606557 */   // Label 22184: @1606557
     /* 1606557 */   GIM_Try, /*On fail goto*//*Label 22185*/ GIMT_Encode4(1606643), // Rule ID 3274 //
     /* 1606562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1606573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1606576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1606579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1606582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1606585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1606592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606608 */     // MIs[0] policy
     /* 1606608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606618 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1606621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606642 */     // GIR_Coverage, 3274,
     /* 1606642 */     GIR_EraseRootFromParent_Done,
     /* 1606643 */   // Label 22185: @1606643
     /* 1606643 */   GIM_Try, /*On fail goto*//*Label 22186*/ GIMT_Encode4(1606729), // Rule ID 3275 //
     /* 1606648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1606659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1606662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1606665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1606668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1606671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1606678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606694 */     // MIs[0] policy
     /* 1606694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606704 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1606707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606728 */     // GIR_Coverage, 3275,
     /* 1606728 */     GIR_EraseRootFromParent_Done,
     /* 1606729 */   // Label 22186: @1606729
     /* 1606729 */   GIM_Try, /*On fail goto*//*Label 22187*/ GIMT_Encode4(1606815), // Rule ID 3278 //
     /* 1606734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1606745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1606748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1606751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1606754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1606757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1606764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606780 */     // MIs[0] policy
     /* 1606780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606790 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1606793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606814 */     // GIR_Coverage, 3278,
     /* 1606814 */     GIR_EraseRootFromParent_Done,
     /* 1606815 */   // Label 22187: @1606815
     /* 1606815 */   GIM_Try, /*On fail goto*//*Label 22188*/ GIMT_Encode4(1606901), // Rule ID 3279 //
     /* 1606820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1606831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1606834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1606837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1606840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1606843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1606850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606866 */     // MIs[0] policy
     /* 1606866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606876 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1606879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606900 */     // GIR_Coverage, 3279,
     /* 1606900 */     GIR_EraseRootFromParent_Done,
     /* 1606901 */   // Label 22188: @1606901
     /* 1606901 */   GIM_Try, /*On fail goto*//*Label 22189*/ GIMT_Encode4(1606987), // Rule ID 3282 //
     /* 1606906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1606917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1606920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1606923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1606926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606952 */     // MIs[0] policy
     /* 1606952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1606965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606986 */     // GIR_Coverage, 3282,
     /* 1606986 */     GIR_EraseRootFromParent_Done,
     /* 1606987 */   // Label 22189: @1606987
     /* 1606987 */   GIM_Try, /*On fail goto*//*Label 22190*/ GIMT_Encode4(1607073), // Rule ID 3283 //
     /* 1606992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1607003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1607006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1607009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1607012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607038 */     // MIs[0] policy
     /* 1607038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1607051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607072 */     // GIR_Coverage, 3283,
     /* 1607072 */     GIR_EraseRootFromParent_Done,
     /* 1607073 */   // Label 22190: @1607073
     /* 1607073 */   GIM_Try, /*On fail goto*//*Label 22191*/ GIMT_Encode4(1607159), // Rule ID 3286 //
     /* 1607078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1607089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1607092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1607095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1607098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607124 */     // MIs[0] policy
     /* 1607124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1607137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607158 */     // GIR_Coverage, 3286,
     /* 1607158 */     GIR_EraseRootFromParent_Done,
     /* 1607159 */   // Label 22191: @1607159
     /* 1607159 */   GIM_Try, /*On fail goto*//*Label 22192*/ GIMT_Encode4(1607245), // Rule ID 3287 //
     /* 1607164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1607175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1607178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1607181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1607184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607210 */     // MIs[0] policy
     /* 1607210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607220 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1607223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607244 */     // GIR_Coverage, 3287,
     /* 1607244 */     GIR_EraseRootFromParent_Done,
     /* 1607245 */   // Label 22192: @1607245
     /* 1607245 */   GIM_Try, /*On fail goto*//*Label 22193*/ GIMT_Encode4(1607331), // Rule ID 3290 //
     /* 1607250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1607261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1607264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1607267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1607270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1607273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607296 */     // MIs[0] policy
     /* 1607296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607306 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1607309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607330 */     // GIR_Coverage, 3290,
     /* 1607330 */     GIR_EraseRootFromParent_Done,
     /* 1607331 */   // Label 22193: @1607331
     /* 1607331 */   GIM_Try, /*On fail goto*//*Label 22194*/ GIMT_Encode4(1607417), // Rule ID 3291 //
     /* 1607336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1607347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1607350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1607353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1607356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1607359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607382 */     // MIs[0] policy
     /* 1607382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607392 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1607395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607416 */     // GIR_Coverage, 3291,
     /* 1607416 */     GIR_EraseRootFromParent_Done,
     /* 1607417 */   // Label 22194: @1607417
     /* 1607417 */   GIM_Try, /*On fail goto*//*Label 22195*/ GIMT_Encode4(1607503), // Rule ID 3294 //
     /* 1607422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1607433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1607436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1607442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607468 */     // MIs[0] policy
     /* 1607468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607478 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1607481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607502 */     // GIR_Coverage, 3294,
     /* 1607502 */     GIR_EraseRootFromParent_Done,
     /* 1607503 */   // Label 22195: @1607503
     /* 1607503 */   GIM_Try, /*On fail goto*//*Label 22196*/ GIMT_Encode4(1607589), // Rule ID 3295 //
     /* 1607508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1607519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1607522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1607528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607554 */     // MIs[0] policy
     /* 1607554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1607567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607588 */     // GIR_Coverage, 3295,
     /* 1607588 */     GIR_EraseRootFromParent_Done,
     /* 1607589 */   // Label 22196: @1607589
     /* 1607589 */   GIM_Try, /*On fail goto*//*Label 22197*/ GIMT_Encode4(1607675), // Rule ID 3298 //
     /* 1607594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1607605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1607608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1607611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1607614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607640 */     // MIs[0] policy
     /* 1607640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607650 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1607653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607674 */     // GIR_Coverage, 3298,
     /* 1607674 */     GIR_EraseRootFromParent_Done,
     /* 1607675 */   // Label 22197: @1607675
     /* 1607675 */   GIM_Try, /*On fail goto*//*Label 22198*/ GIMT_Encode4(1607761), // Rule ID 3299 //
     /* 1607680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1607691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1607694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1607697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1607700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607726 */     // MIs[0] policy
     /* 1607726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1607739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607760 */     // GIR_Coverage, 3299,
     /* 1607760 */     GIR_EraseRootFromParent_Done,
     /* 1607761 */   // Label 22198: @1607761
     /* 1607761 */   GIM_Try, /*On fail goto*//*Label 22199*/ GIMT_Encode4(1607847), // Rule ID 3302 //
     /* 1607766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1607777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1607780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1607783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1607786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607812 */     // MIs[0] policy
     /* 1607812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607822 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1607825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607846 */     // GIR_Coverage, 3302,
     /* 1607846 */     GIR_EraseRootFromParent_Done,
     /* 1607847 */   // Label 22199: @1607847
     /* 1607847 */   GIM_Try, /*On fail goto*//*Label 22200*/ GIMT_Encode4(1607933), // Rule ID 3303 //
     /* 1607852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1607863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1607866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1607869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1607872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607898 */     // MIs[0] policy
     /* 1607898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607908 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1607911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607932 */     // GIR_Coverage, 3303,
     /* 1607932 */     GIR_EraseRootFromParent_Done,
     /* 1607933 */   // Label 22200: @1607933
     /* 1607933 */   GIM_Try, /*On fail goto*//*Label 22201*/ GIMT_Encode4(1608019), // Rule ID 3306 //
     /* 1607938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1607941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1607949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1607952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1607955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1607958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1607961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607984 */     // MIs[0] policy
     /* 1607984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607994 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1607997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608018 */     // GIR_Coverage, 3306,
     /* 1608018 */     GIR_EraseRootFromParent_Done,
     /* 1608019 */   // Label 22201: @1608019
     /* 1608019 */   GIM_Try, /*On fail goto*//*Label 22202*/ GIMT_Encode4(1608105), // Rule ID 3307 //
     /* 1608024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1608027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1608035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1608038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1608041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1608044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1608054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608070 */     // MIs[0] policy
     /* 1608070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1608083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608104 */     // GIR_Coverage, 3307,
     /* 1608104 */     GIR_EraseRootFromParent_Done,
     /* 1608105 */   // Label 22202: @1608105
     /* 1608105 */   GIM_Try, /*On fail goto*//*Label 22203*/ GIMT_Encode4(1608191), // Rule ID 3310 //
     /* 1608110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1608113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1608121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1608124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1608127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1608130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608156 */     // MIs[0] policy
     /* 1608156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608166 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1608169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608190 */     // GIR_Coverage, 3310,
     /* 1608190 */     GIR_EraseRootFromParent_Done,
     /* 1608191 */   // Label 22203: @1608191
     /* 1608191 */   GIM_Try, /*On fail goto*//*Label 22204*/ GIMT_Encode4(1608277), // Rule ID 3311 //
     /* 1608196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1608199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1608207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1608210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1608213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1608216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608242 */     // MIs[0] policy
     /* 1608242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608252 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1608255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608276 */     // GIR_Coverage, 3311,
     /* 1608276 */     GIR_EraseRootFromParent_Done,
     /* 1608277 */   // Label 22204: @1608277
     /* 1608277 */   GIM_Try, /*On fail goto*//*Label 22205*/ GIMT_Encode4(1608363), // Rule ID 3314 //
     /* 1608282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1608285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1608293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1608296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1608299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1608302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608328 */     // MIs[0] policy
     /* 1608328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608338 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1608341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608362 */     // GIR_Coverage, 3314,
     /* 1608362 */     GIR_EraseRootFromParent_Done,
     /* 1608363 */   // Label 22205: @1608363
     /* 1608363 */   GIM_Try, /*On fail goto*//*Label 22206*/ GIMT_Encode4(1608449), // Rule ID 3315 //
     /* 1608368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1608371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1608379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1608382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1608385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1608388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608414 */     // MIs[0] policy
     /* 1608414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608424 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1608427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608448 */     // GIR_Coverage, 3315,
     /* 1608448 */     GIR_EraseRootFromParent_Done,
     /* 1608449 */   // Label 22206: @1608449
     /* 1608449 */   GIM_Try, /*On fail goto*//*Label 22207*/ GIMT_Encode4(1608535), // Rule ID 3318 //
     /* 1608454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1608465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1608468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608500 */     // MIs[0] policy
     /* 1608500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608510 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1608513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608534 */     // GIR_Coverage, 3318,
     /* 1608534 */     GIR_EraseRootFromParent_Done,
     /* 1608535 */   // Label 22207: @1608535
     /* 1608535 */   GIM_Try, /*On fail goto*//*Label 22208*/ GIMT_Encode4(1608621), // Rule ID 3319 //
     /* 1608540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1608551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1608554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608586 */     // MIs[0] policy
     /* 1608586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1608599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608620 */     // GIR_Coverage, 3319,
     /* 1608620 */     GIR_EraseRootFromParent_Done,
     /* 1608621 */   // Label 22208: @1608621
     /* 1608621 */   GIM_Try, /*On fail goto*//*Label 22209*/ GIMT_Encode4(1608707), // Rule ID 3322 //
     /* 1608626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1608637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1608640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1608643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608672 */     // MIs[0] policy
     /* 1608672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1608685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608706 */     // GIR_Coverage, 3322,
     /* 1608706 */     GIR_EraseRootFromParent_Done,
     /* 1608707 */   // Label 22209: @1608707
     /* 1608707 */   GIM_Try, /*On fail goto*//*Label 22210*/ GIMT_Encode4(1608793), // Rule ID 3323 //
     /* 1608712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1608723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1608726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1608729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608758 */     // MIs[0] policy
     /* 1608758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608768 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1608771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608792 */     // GIR_Coverage, 3323,
     /* 1608792 */     GIR_EraseRootFromParent_Done,
     /* 1608793 */   // Label 22210: @1608793
     /* 1608793 */   GIM_Try, /*On fail goto*//*Label 22211*/ GIMT_Encode4(1608879), // Rule ID 3326 //
     /* 1608798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1608809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1608812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1608815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608844 */     // MIs[0] policy
     /* 1608844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608854 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1608857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608878 */     // GIR_Coverage, 3326,
     /* 1608878 */     GIR_EraseRootFromParent_Done,
     /* 1608879 */   // Label 22211: @1608879
     /* 1608879 */   GIM_Try, /*On fail goto*//*Label 22212*/ GIMT_Encode4(1608965), // Rule ID 3327 //
     /* 1608884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1608895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1608898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1608901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608930 */     // MIs[0] policy
     /* 1608930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608940 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1608943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608964 */     // GIR_Coverage, 3327,
     /* 1608964 */     GIR_EraseRootFromParent_Done,
     /* 1608965 */   // Label 22212: @1608965
     /* 1608965 */   GIM_Try, /*On fail goto*//*Label 22213*/ GIMT_Encode4(1609051), // Rule ID 3330 //
     /* 1608970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1608981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1608984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1608987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609016 */     // MIs[0] policy
     /* 1609016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1609029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609050 */     // GIR_Coverage, 3330,
     /* 1609050 */     GIR_EraseRootFromParent_Done,
     /* 1609051 */   // Label 22213: @1609051
     /* 1609051 */   GIM_Try, /*On fail goto*//*Label 22214*/ GIMT_Encode4(1609137), // Rule ID 3331 //
     /* 1609056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1609064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1609067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1609070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1609073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609102 */     // MIs[0] policy
     /* 1609102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609112 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1609115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609136 */     // GIR_Coverage, 3331,
     /* 1609136 */     GIR_EraseRootFromParent_Done,
     /* 1609137 */   // Label 22214: @1609137
     /* 1609137 */   GIM_Try, /*On fail goto*//*Label 22215*/ GIMT_Encode4(1609223), // Rule ID 3334 //
     /* 1609142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1609150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1609153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1609156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609188 */     // MIs[0] policy
     /* 1609188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609198 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1609201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609222 */     // GIR_Coverage, 3334,
     /* 1609222 */     GIR_EraseRootFromParent_Done,
     /* 1609223 */   // Label 22215: @1609223
     /* 1609223 */   GIM_Try, /*On fail goto*//*Label 22216*/ GIMT_Encode4(1609309), // Rule ID 3335 //
     /* 1609228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1609236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1609239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1609242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609274 */     // MIs[0] policy
     /* 1609274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609284 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1609287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609308 */     // GIR_Coverage, 3335,
     /* 1609308 */     GIR_EraseRootFromParent_Done,
     /* 1609309 */   // Label 22216: @1609309
     /* 1609309 */   GIM_Try, /*On fail goto*//*Label 22217*/ GIMT_Encode4(1609395), // Rule ID 3338 //
     /* 1609314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1609322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1609331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609360 */     // MIs[0] policy
     /* 1609360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1609373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609394 */     // GIR_Coverage, 3338,
     /* 1609394 */     GIR_EraseRootFromParent_Done,
     /* 1609395 */   // Label 22217: @1609395
     /* 1609395 */   GIM_Try, /*On fail goto*//*Label 22218*/ GIMT_Encode4(1609481), // Rule ID 3339 //
     /* 1609400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1609408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1609417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609446 */     // MIs[0] policy
     /* 1609446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609456 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1609459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609480 */     // GIR_Coverage, 3339,
     /* 1609480 */     GIR_EraseRootFromParent_Done,
     /* 1609481 */   // Label 22218: @1609481
     /* 1609481 */   GIM_Try, /*On fail goto*//*Label 22219*/ GIMT_Encode4(1609567), // Rule ID 3342 //
     /* 1609486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1609494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1609497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1609500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1609503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609532 */     // MIs[0] policy
     /* 1609532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609542 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1609545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609566 */     // GIR_Coverage, 3342,
     /* 1609566 */     GIR_EraseRootFromParent_Done,
     /* 1609567 */   // Label 22219: @1609567
     /* 1609567 */   GIM_Try, /*On fail goto*//*Label 22220*/ GIMT_Encode4(1609653), // Rule ID 3343 //
     /* 1609572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1609580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1609583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1609586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1609589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609618 */     // MIs[0] policy
     /* 1609618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609628 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1609631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609652 */     // GIR_Coverage, 3343,
     /* 1609652 */     GIR_EraseRootFromParent_Done,
     /* 1609653 */   // Label 22220: @1609653
     /* 1609653 */   GIM_Try, /*On fail goto*//*Label 22221*/ GIMT_Encode4(1609739), // Rule ID 3346 //
     /* 1609658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1609666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1609669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1609672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1609675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609704 */     // MIs[0] policy
     /* 1609704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1609717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609738 */     // GIR_Coverage, 3346,
     /* 1609738 */     GIR_EraseRootFromParent_Done,
     /* 1609739 */   // Label 22221: @1609739
     /* 1609739 */   GIM_Try, /*On fail goto*//*Label 22222*/ GIMT_Encode4(1609825), // Rule ID 3347 //
     /* 1609744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1609752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1609755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1609758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1609761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609790 */     // MIs[0] policy
     /* 1609790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1609803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609824 */     // GIR_Coverage, 3347,
     /* 1609824 */     GIR_EraseRootFromParent_Done,
     /* 1609825 */   // Label 22222: @1609825
     /* 1609825 */   GIM_Try, /*On fail goto*//*Label 22223*/ GIMT_Encode4(1609911), // Rule ID 3350 //
     /* 1609830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1609838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1609841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1609844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1609847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609876 */     // MIs[0] policy
     /* 1609876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1609889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609910 */     // GIR_Coverage, 3350,
     /* 1609910 */     GIR_EraseRootFromParent_Done,
     /* 1609911 */   // Label 22223: @1609911
     /* 1609911 */   GIM_Try, /*On fail goto*//*Label 22224*/ GIMT_Encode4(1609997), // Rule ID 3351 //
     /* 1609916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1609924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1609927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1609930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1609933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609962 */     // MIs[0] policy
     /* 1609962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609972 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1609975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609996 */     // GIR_Coverage, 3351,
     /* 1609996 */     GIR_EraseRootFromParent_Done,
     /* 1609997 */   // Label 22224: @1609997
     /* 1609997 */   GIM_Try, /*On fail goto*//*Label 22225*/ GIMT_Encode4(1610083), // Rule ID 3354 //
     /* 1610002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1610005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1610010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1610013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1610016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1610019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610048 */     // MIs[0] policy
     /* 1610048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610058 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1610061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1610079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610082 */     // GIR_Coverage, 3354,
     /* 1610082 */     GIR_EraseRootFromParent_Done,
     /* 1610083 */   // Label 22225: @1610083
     /* 1610083 */   GIM_Try, /*On fail goto*//*Label 22226*/ GIMT_Encode4(1610169), // Rule ID 3355 //
     /* 1610088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1610091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1610096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1610099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1610102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1610105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610134 */     // MIs[0] policy
     /* 1610134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610144 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1610147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1610165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610168 */     // GIR_Coverage, 3355,
     /* 1610168 */     GIR_EraseRootFromParent_Done,
     /* 1610169 */   // Label 22226: @1610169
     /* 1610169 */   GIM_Try, /*On fail goto*//*Label 22227*/ GIMT_Encode4(1610255), // Rule ID 3358 //
     /* 1610174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1610182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1610185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1610188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610220 */     // MIs[0] policy
     /* 1610220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1610233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610254 */     // GIR_Coverage, 3358,
     /* 1610254 */     GIR_EraseRootFromParent_Done,
     /* 1610255 */   // Label 22227: @1610255
     /* 1610255 */   GIM_Try, /*On fail goto*//*Label 22228*/ GIMT_Encode4(1610341), // Rule ID 3359 //
     /* 1610260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1610268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1610271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1610274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610306 */     // MIs[0] policy
     /* 1610306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610316 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1610319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610340 */     // GIR_Coverage, 3359,
     /* 1610340 */     GIR_EraseRootFromParent_Done,
     /* 1610341 */   // Label 22228: @1610341
     /* 1610341 */   GIM_Try, /*On fail goto*//*Label 22229*/ GIMT_Encode4(1610427), // Rule ID 3362 //
     /* 1610346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1610354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1610357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1610360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610392 */     // MIs[0] policy
     /* 1610392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610402 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1610405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610426 */     // GIR_Coverage, 3362,
     /* 1610426 */     GIR_EraseRootFromParent_Done,
     /* 1610427 */   // Label 22229: @1610427
     /* 1610427 */   GIM_Try, /*On fail goto*//*Label 22230*/ GIMT_Encode4(1610513), // Rule ID 3363 //
     /* 1610432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1610440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1610443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1610446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610478 */     // MIs[0] policy
     /* 1610478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610488 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1610491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610512 */     // GIR_Coverage, 3363,
     /* 1610512 */     GIR_EraseRootFromParent_Done,
     /* 1610513 */   // Label 22230: @1610513
     /* 1610513 */   GIM_Try, /*On fail goto*//*Label 22231*/ GIMT_Encode4(1610599), // Rule ID 3366 //
     /* 1610518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1610526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1610529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1610532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1610535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1610541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610564 */     // MIs[0] policy
     /* 1610564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610574 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1610577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610598 */     // GIR_Coverage, 3366,
     /* 1610598 */     GIR_EraseRootFromParent_Done,
     /* 1610599 */   // Label 22231: @1610599
     /* 1610599 */   GIM_Try, /*On fail goto*//*Label 22232*/ GIMT_Encode4(1610685), // Rule ID 3367 //
     /* 1610604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1610612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1610615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1610618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1610621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1610627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610650 */     // MIs[0] policy
     /* 1610650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610660 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1610663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610684 */     // GIR_Coverage, 3367,
     /* 1610684 */     GIR_EraseRootFromParent_Done,
     /* 1610685 */   // Label 22232: @1610685
     /* 1610685 */   GIM_Try, /*On fail goto*//*Label 22233*/ GIMT_Encode4(1610771), // Rule ID 3370 //
     /* 1610690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1610698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1610701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1610704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1610707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610736 */     // MIs[0] policy
     /* 1610736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1610749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610770 */     // GIR_Coverage, 3370,
     /* 1610770 */     GIR_EraseRootFromParent_Done,
     /* 1610771 */   // Label 22233: @1610771
     /* 1610771 */   GIM_Try, /*On fail goto*//*Label 22234*/ GIMT_Encode4(1610857), // Rule ID 3371 //
     /* 1610776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1610784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1610787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1610790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1610793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610822 */     // MIs[0] policy
     /* 1610822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610832 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1610835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610856 */     // GIR_Coverage, 3371,
     /* 1610856 */     GIR_EraseRootFromParent_Done,
     /* 1610857 */   // Label 22234: @1610857
     /* 1610857 */   GIM_Try, /*On fail goto*//*Label 22235*/ GIMT_Encode4(1610943), // Rule ID 3374 //
     /* 1610862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1610870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1610873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1610876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1610879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610908 */     // MIs[0] policy
     /* 1610908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1610921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610942 */     // GIR_Coverage, 3374,
     /* 1610942 */     GIR_EraseRootFromParent_Done,
     /* 1610943 */   // Label 22235: @1610943
     /* 1610943 */   GIM_Try, /*On fail goto*//*Label 22236*/ GIMT_Encode4(1611029), // Rule ID 3375 //
     /* 1610948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1610956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1610959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1610962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1610965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610994 */     // MIs[0] policy
     /* 1610994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611004 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1611007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611028 */     // GIR_Coverage, 3375,
     /* 1611028 */     GIR_EraseRootFromParent_Done,
     /* 1611029 */   // Label 22236: @1611029
     /* 1611029 */   GIM_Try, /*On fail goto*//*Label 22237*/ GIMT_Encode4(1611115), // Rule ID 3378 //
     /* 1611034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1611042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1611045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1611048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1611051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1611057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611080 */     // MIs[0] policy
     /* 1611080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611090 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1611093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611114 */     // GIR_Coverage, 3378,
     /* 1611114 */     GIR_EraseRootFromParent_Done,
     /* 1611115 */   // Label 22237: @1611115
     /* 1611115 */   GIM_Try, /*On fail goto*//*Label 22238*/ GIMT_Encode4(1611201), // Rule ID 3379 //
     /* 1611120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1611128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1611131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1611134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1611137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1611143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611166 */     // MIs[0] policy
     /* 1611166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611176 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1611179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611200 */     // GIR_Coverage, 3379,
     /* 1611200 */     GIR_EraseRootFromParent_Done,
     /* 1611201 */   // Label 22238: @1611201
     /* 1611201 */   GIM_Try, /*On fail goto*//*Label 22239*/ GIMT_Encode4(1611287), // Rule ID 3382 //
     /* 1611206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1611214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1611223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611252 */     // MIs[0] policy
     /* 1611252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1611265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611286 */     // GIR_Coverage, 3382,
     /* 1611286 */     GIR_EraseRootFromParent_Done,
     /* 1611287 */   // Label 22239: @1611287
     /* 1611287 */   GIM_Try, /*On fail goto*//*Label 22240*/ GIMT_Encode4(1611373), // Rule ID 3383 //
     /* 1611292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1611300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1611309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611338 */     // MIs[0] policy
     /* 1611338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1611351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611372 */     // GIR_Coverage, 3383,
     /* 1611372 */     GIR_EraseRootFromParent_Done,
     /* 1611373 */   // Label 22240: @1611373
     /* 1611373 */   GIM_Try, /*On fail goto*//*Label 22241*/ GIMT_Encode4(1611459), // Rule ID 3386 //
     /* 1611378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1611386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1611395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611424 */     // MIs[0] policy
     /* 1611424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1611437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611458 */     // GIR_Coverage, 3386,
     /* 1611458 */     GIR_EraseRootFromParent_Done,
     /* 1611459 */   // Label 22241: @1611459
     /* 1611459 */   GIM_Try, /*On fail goto*//*Label 22242*/ GIMT_Encode4(1611545), // Rule ID 3387 //
     /* 1611464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1611472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1611481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611510 */     // MIs[0] policy
     /* 1611510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611520 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1611523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611544 */     // GIR_Coverage, 3387,
     /* 1611544 */     GIR_EraseRootFromParent_Done,
     /* 1611545 */   // Label 22242: @1611545
     /* 1611545 */   GIM_Try, /*On fail goto*//*Label 22243*/ GIMT_Encode4(1611631), // Rule ID 3390 //
     /* 1611550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1611558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1611561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1611564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1611567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611596 */     // MIs[0] policy
     /* 1611596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611606 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1611609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611630 */     // GIR_Coverage, 3390,
     /* 1611630 */     GIR_EraseRootFromParent_Done,
     /* 1611631 */   // Label 22243: @1611631
     /* 1611631 */   GIM_Try, /*On fail goto*//*Label 22244*/ GIMT_Encode4(1611717), // Rule ID 3391 //
     /* 1611636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1611644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1611647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1611650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1611653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611682 */     // MIs[0] policy
     /* 1611682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1611695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611716 */     // GIR_Coverage, 3391,
     /* 1611716 */     GIR_EraseRootFromParent_Done,
     /* 1611717 */   // Label 22244: @1611717
     /* 1611717 */   GIM_Try, /*On fail goto*//*Label 22245*/ GIMT_Encode4(1611803), // Rule ID 3394 //
     /* 1611722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1611725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1611730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1611733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1611736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1611739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1611745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611768 */     // MIs[0] policy
     /* 1611768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1611781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1611799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611802 */     // GIR_Coverage, 3394,
     /* 1611802 */     GIR_EraseRootFromParent_Done,
     /* 1611803 */   // Label 22245: @1611803
     /* 1611803 */   GIM_Try, /*On fail goto*//*Label 22246*/ GIMT_Encode4(1611889), // Rule ID 3395 //
     /* 1611808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1611811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1611816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1611819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1611822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1611825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1611831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611854 */     // MIs[0] policy
     /* 1611854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1611867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1611885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611888 */     // GIR_Coverage, 3395,
     /* 1611888 */     GIR_EraseRootFromParent_Done,
     /* 1611889 */   // Label 22246: @1611889
     /* 1611889 */   GIM_Try, /*On fail goto*//*Label 22247*/ GIMT_Encode4(1611975), // Rule ID 3398 //
     /* 1611894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1611897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1611902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1611905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1611908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1611911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611940 */     // MIs[0] policy
     /* 1611940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1611953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1611971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611974 */     // GIR_Coverage, 3398,
     /* 1611974 */     GIR_EraseRootFromParent_Done,
     /* 1611975 */   // Label 22247: @1611975
     /* 1611975 */   GIM_Try, /*On fail goto*//*Label 22248*/ GIMT_Encode4(1612061), // Rule ID 3399 //
     /* 1611980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1611983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1611988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1611991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1611994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1611997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612026 */     // MIs[0] policy
     /* 1612026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1612039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612060 */     // GIR_Coverage, 3399,
     /* 1612060 */     GIR_EraseRootFromParent_Done,
     /* 1612061 */   // Label 22248: @1612061
     /* 1612061 */   GIM_Try, /*On fail goto*//*Label 22249*/ GIMT_Encode4(1612147), // Rule ID 3402 //
     /* 1612066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1612069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1612074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1612083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612112 */     // MIs[0] policy
     /* 1612112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612122 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1612125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612146 */     // GIR_Coverage, 3402,
     /* 1612146 */     GIR_EraseRootFromParent_Done,
     /* 1612147 */   // Label 22249: @1612147
     /* 1612147 */   GIM_Try, /*On fail goto*//*Label 22250*/ GIMT_Encode4(1612233), // Rule ID 3403 //
     /* 1612152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1612155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1612160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1612169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612198 */     // MIs[0] policy
     /* 1612198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1612211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612232 */     // GIR_Coverage, 3403,
     /* 1612232 */     GIR_EraseRootFromParent_Done,
     /* 1612233 */   // Label 22250: @1612233
     /* 1612233 */   GIM_Try, /*On fail goto*//*Label 22251*/ GIMT_Encode4(1612319), // Rule ID 3406 //
     /* 1612238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1612249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1612252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612284 */     // MIs[0] policy
     /* 1612284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612294 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1612297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612318 */     // GIR_Coverage, 3406,
     /* 1612318 */     GIR_EraseRootFromParent_Done,
     /* 1612319 */   // Label 22251: @1612319
     /* 1612319 */   GIM_Try, /*On fail goto*//*Label 22252*/ GIMT_Encode4(1612405), // Rule ID 3407 //
     /* 1612324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1612335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1612338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612370 */     // MIs[0] policy
     /* 1612370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612380 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1612383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612404 */     // GIR_Coverage, 3407,
     /* 1612404 */     GIR_EraseRootFromParent_Done,
     /* 1612405 */   // Label 22252: @1612405
     /* 1612405 */   GIM_Try, /*On fail goto*//*Label 22253*/ GIMT_Encode4(1612491), // Rule ID 3410 //
     /* 1612410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1612421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1612424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612456 */     // MIs[0] policy
     /* 1612456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612466 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1612469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612490 */     // GIR_Coverage, 3410,
     /* 1612490 */     GIR_EraseRootFromParent_Done,
     /* 1612491 */   // Label 22253: @1612491
     /* 1612491 */   GIM_Try, /*On fail goto*//*Label 22254*/ GIMT_Encode4(1612577), // Rule ID 3411 //
     /* 1612496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1612507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1612510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612542 */     // MIs[0] policy
     /* 1612542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1612555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612576 */     // GIR_Coverage, 3411,
     /* 1612576 */     GIR_EraseRootFromParent_Done,
     /* 1612577 */   // Label 22254: @1612577
     /* 1612577 */   GIM_Try, /*On fail goto*//*Label 22255*/ GIMT_Encode4(1612663), // Rule ID 3414 //
     /* 1612582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1612593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1612596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1612599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612628 */     // MIs[0] policy
     /* 1612628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612638 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1612641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612662 */     // GIR_Coverage, 3414,
     /* 1612662 */     GIR_EraseRootFromParent_Done,
     /* 1612663 */   // Label 22255: @1612663
     /* 1612663 */   GIM_Try, /*On fail goto*//*Label 22256*/ GIMT_Encode4(1612749), // Rule ID 3415 //
     /* 1612668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1612679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1612682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1612685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612714 */     // MIs[0] policy
     /* 1612714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612724 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1612727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612748 */     // GIR_Coverage, 3415,
     /* 1612748 */     GIR_EraseRootFromParent_Done,
     /* 1612749 */   // Label 22256: @1612749
     /* 1612749 */   GIM_Try, /*On fail goto*//*Label 22257*/ GIMT_Encode4(1612835), // Rule ID 3418 //
     /* 1612754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1612771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612800 */     // MIs[0] policy
     /* 1612800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612810 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1612813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1612831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612834 */     // GIR_Coverage, 3418,
     /* 1612834 */     GIR_EraseRootFromParent_Done,
     /* 1612835 */   // Label 22257: @1612835
     /* 1612835 */   GIM_Try, /*On fail goto*//*Label 22258*/ GIMT_Encode4(1612921), // Rule ID 3419 //
     /* 1612840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1612857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612886 */     // MIs[0] policy
     /* 1612886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612896 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1612899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1612917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612920 */     // GIR_Coverage, 3419,
     /* 1612920 */     GIR_EraseRootFromParent_Done,
     /* 1612921 */   // Label 22258: @1612921
     /* 1612921 */   GIM_Try, /*On fail goto*//*Label 22259*/ GIMT_Encode4(1613007), // Rule ID 3422 //
     /* 1612926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1612937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1612940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1612943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612972 */     // MIs[0] policy
     /* 1612972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612982 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1612985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613006 */     // GIR_Coverage, 3422,
     /* 1613006 */     GIR_EraseRootFromParent_Done,
     /* 1613007 */   // Label 22259: @1613007
     /* 1613007 */   GIM_Try, /*On fail goto*//*Label 22260*/ GIMT_Encode4(1613093), // Rule ID 3423 //
     /* 1613012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1613020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1613023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1613026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1613029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613058 */     // MIs[0] policy
     /* 1613058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613068 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1613071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613092 */     // GIR_Coverage, 3423,
     /* 1613092 */     GIR_EraseRootFromParent_Done,
     /* 1613093 */   // Label 22260: @1613093
     /* 1613093 */   GIM_Try, /*On fail goto*//*Label 22261*/ GIMT_Encode4(1613179), // Rule ID 3426 //
     /* 1613098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1613106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1613115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613144 */     // MIs[0] policy
     /* 1613144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613154 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1613157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1613175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613178 */     // GIR_Coverage, 3426,
     /* 1613178 */     GIR_EraseRootFromParent_Done,
     /* 1613179 */   // Label 22261: @1613179
     /* 1613179 */   GIM_Try, /*On fail goto*//*Label 22262*/ GIMT_Encode4(1613265), // Rule ID 3427 //
     /* 1613184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1613192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1613201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613230 */     // MIs[0] policy
     /* 1613230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613240 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1613243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1613261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613264 */     // GIR_Coverage, 3427,
     /* 1613264 */     GIR_EraseRootFromParent_Done,
     /* 1613265 */   // Label 22262: @1613265
     /* 1613265 */   GIM_Try, /*On fail goto*//*Label 22263*/ GIMT_Encode4(1613351), // Rule ID 3430 //
     /* 1613270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1613278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1613281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1613284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1613287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613316 */     // MIs[0] policy
     /* 1613316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613326 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1613329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613350 */     // GIR_Coverage, 3430,
     /* 1613350 */     GIR_EraseRootFromParent_Done,
     /* 1613351 */   // Label 22263: @1613351
     /* 1613351 */   GIM_Try, /*On fail goto*//*Label 22264*/ GIMT_Encode4(1613437), // Rule ID 3431 //
     /* 1613356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1613364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1613367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1613370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1613373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613402 */     // MIs[0] policy
     /* 1613402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613412 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1613415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613436 */     // GIR_Coverage, 3431,
     /* 1613436 */     GIR_EraseRootFromParent_Done,
     /* 1613437 */   // Label 22264: @1613437
     /* 1613437 */   GIM_Try, /*On fail goto*//*Label 22265*/ GIMT_Encode4(1613523), // Rule ID 3434 //
     /* 1613442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1613450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1613453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1613456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1613459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613488 */     // MIs[0] policy
     /* 1613488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1613501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613522 */     // GIR_Coverage, 3434,
     /* 1613522 */     GIR_EraseRootFromParent_Done,
     /* 1613523 */   // Label 22265: @1613523
     /* 1613523 */   GIM_Try, /*On fail goto*//*Label 22266*/ GIMT_Encode4(1613609), // Rule ID 3435 //
     /* 1613528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1613536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1613539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1613542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1613545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613574 */     // MIs[0] policy
     /* 1613574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1613587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613608 */     // GIR_Coverage, 3435,
     /* 1613608 */     GIR_EraseRootFromParent_Done,
     /* 1613609 */   // Label 22266: @1613609
     /* 1613609 */   GIM_Try, /*On fail goto*//*Label 22267*/ GIMT_Encode4(1613695), // Rule ID 3438 //
     /* 1613614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1613622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1613631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613660 */     // MIs[0] policy
     /* 1613660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1613673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1613691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613694 */     // GIR_Coverage, 3438,
     /* 1613694 */     GIR_EraseRootFromParent_Done,
     /* 1613695 */   // Label 22267: @1613695
     /* 1613695 */   GIM_Try, /*On fail goto*//*Label 22268*/ GIMT_Encode4(1613781), // Rule ID 3439 //
     /* 1613700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1613708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1613717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613746 */     // MIs[0] policy
     /* 1613746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1613759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1613777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613780 */     // GIR_Coverage, 3439,
     /* 1613780 */     GIR_EraseRootFromParent_Done,
     /* 1613781 */   // Label 22268: @1613781
     /* 1613781 */   GIM_Try, /*On fail goto*//*Label 22269*/ GIMT_Encode4(1613867), // Rule ID 3442 //
     /* 1613786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1613789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1613794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1613797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1613800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1613803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613832 */     // MIs[0] policy
     /* 1613832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613842 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1613845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1613863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613866 */     // GIR_Coverage, 3442,
     /* 1613866 */     GIR_EraseRootFromParent_Done,
     /* 1613867 */   // Label 22269: @1613867
     /* 1613867 */   GIM_Try, /*On fail goto*//*Label 22270*/ GIMT_Encode4(1613953), // Rule ID 3443 //
     /* 1613872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1613875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1613880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1613883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1613886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1613889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613918 */     // MIs[0] policy
     /* 1613918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1613931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1613949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613952 */     // GIR_Coverage, 3443,
     /* 1613952 */     GIR_EraseRootFromParent_Done,
     /* 1613953 */   // Label 22270: @1613953
     /* 1613953 */   GIM_Try, /*On fail goto*//*Label 22271*/ GIMT_Encode4(1614039), // Rule ID 3446 //
     /* 1613958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1613966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1613969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1613972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1613975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1613981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614004 */     // MIs[0] policy
     /* 1614004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1614017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614038 */     // GIR_Coverage, 3446,
     /* 1614038 */     GIR_EraseRootFromParent_Done,
     /* 1614039 */   // Label 22271: @1614039
     /* 1614039 */   GIM_Try, /*On fail goto*//*Label 22272*/ GIMT_Encode4(1614125), // Rule ID 3447 //
     /* 1614044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1614052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1614055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1614058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1614061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614090 */     // MIs[0] policy
     /* 1614090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614100 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1614103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614124 */     // GIR_Coverage, 3447,
     /* 1614124 */     GIR_EraseRootFromParent_Done,
     /* 1614125 */   // Label 22272: @1614125
     /* 1614125 */   GIM_Try, /*On fail goto*//*Label 22273*/ GIMT_Encode4(1614211), // Rule ID 3450 //
     /* 1614130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1614138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1614141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1614144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1614147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1614153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614176 */     // MIs[0] policy
     /* 1614176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614186 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1614189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614210 */     // GIR_Coverage, 3450,
     /* 1614210 */     GIR_EraseRootFromParent_Done,
     /* 1614211 */   // Label 22273: @1614211
     /* 1614211 */   GIM_Try, /*On fail goto*//*Label 22274*/ GIMT_Encode4(1614297), // Rule ID 3451 //
     /* 1614216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1614224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1614227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1614230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1614233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1614239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614262 */     // MIs[0] policy
     /* 1614262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614272 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1614275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614296 */     // GIR_Coverage, 3451,
     /* 1614296 */     GIR_EraseRootFromParent_Done,
     /* 1614297 */   // Label 22274: @1614297
     /* 1614297 */   GIM_Try, /*On fail goto*//*Label 22275*/ GIMT_Encode4(1614383), // Rule ID 3454 //
     /* 1614302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1614310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1614313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1614316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1614319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1614325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614348 */     // MIs[0] policy
     /* 1614348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614358 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1614361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614382 */     // GIR_Coverage, 3454,
     /* 1614382 */     GIR_EraseRootFromParent_Done,
     /* 1614383 */   // Label 22275: @1614383
     /* 1614383 */   GIM_Try, /*On fail goto*//*Label 22276*/ GIMT_Encode4(1614469), // Rule ID 3455 //
     /* 1614388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1614396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1614399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1614402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1614405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1614411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614434 */     // MIs[0] policy
     /* 1614434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614444 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1614447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614468 */     // GIR_Coverage, 3455,
     /* 1614468 */     GIR_EraseRootFromParent_Done,
     /* 1614469 */   // Label 22276: @1614469
     /* 1614469 */   GIM_Try, /*On fail goto*//*Label 22277*/ GIMT_Encode4(1614555), // Rule ID 3458 //
     /* 1614474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1614482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1614485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1614488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1614491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614520 */     // MIs[0] policy
     /* 1614520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614530 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1614533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614554 */     // GIR_Coverage, 3458,
     /* 1614554 */     GIR_EraseRootFromParent_Done,
     /* 1614555 */   // Label 22277: @1614555
     /* 1614555 */   GIM_Try, /*On fail goto*//*Label 22278*/ GIMT_Encode4(1614641), // Rule ID 3459 //
     /* 1614560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1614568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1614571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1614574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1614577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614606 */     // MIs[0] policy
     /* 1614606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1614619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614640 */     // GIR_Coverage, 3459,
     /* 1614640 */     GIR_EraseRootFromParent_Done,
     /* 1614641 */   // Label 22278: @1614641
     /* 1614641 */   GIM_Try, /*On fail goto*//*Label 22279*/ GIMT_Encode4(1614727), // Rule ID 3462 //
     /* 1614646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1614654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1614657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1614660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1614663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614692 */     // MIs[0] policy
     /* 1614692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614702 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1614705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614726 */     // GIR_Coverage, 3462,
     /* 1614726 */     GIR_EraseRootFromParent_Done,
     /* 1614727 */   // Label 22279: @1614727
     /* 1614727 */   GIM_Try, /*On fail goto*//*Label 22280*/ GIMT_Encode4(1614813), // Rule ID 3463 //
     /* 1614732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1614740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1614743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1614746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1614749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614778 */     // MIs[0] policy
     /* 1614778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614788 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1614791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614812 */     // GIR_Coverage, 3463,
     /* 1614812 */     GIR_EraseRootFromParent_Done,
     /* 1614813 */   // Label 22280: @1614813
     /* 1614813 */   GIM_Try, /*On fail goto*//*Label 22281*/ GIMT_Encode4(1614899), // Rule ID 3466 //
     /* 1614818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1614826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1614829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1614832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1614835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1614841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614864 */     // MIs[0] policy
     /* 1614864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614874 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1614877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614898 */     // GIR_Coverage, 3466,
     /* 1614898 */     GIR_EraseRootFromParent_Done,
     /* 1614899 */   // Label 22281: @1614899
     /* 1614899 */   GIM_Try, /*On fail goto*//*Label 22282*/ GIMT_Encode4(1614985), // Rule ID 3467 //
     /* 1614904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1614912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1614915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1614918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1614921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1614927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614950 */     // MIs[0] policy
     /* 1614950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614960 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1614963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614984 */     // GIR_Coverage, 3467,
     /* 1614984 */     GIR_EraseRootFromParent_Done,
     /* 1614985 */   // Label 22282: @1614985
     /* 1614985 */   GIM_Try, /*On fail goto*//*Label 22283*/ GIMT_Encode4(1615071), // Rule ID 3470 //
     /* 1614990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1614998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1615001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1615004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1615007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615036 */     // MIs[0] policy
     /* 1615036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615046 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1615049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615070 */     // GIR_Coverage, 3470,
     /* 1615070 */     GIR_EraseRootFromParent_Done,
     /* 1615071 */   // Label 22283: @1615071
     /* 1615071 */   GIM_Try, /*On fail goto*//*Label 22284*/ GIMT_Encode4(1615157), // Rule ID 3471 //
     /* 1615076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1615084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1615087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1615090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1615093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615122 */     // MIs[0] policy
     /* 1615122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615132 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1615135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615156 */     // GIR_Coverage, 3471,
     /* 1615156 */     GIR_EraseRootFromParent_Done,
     /* 1615157 */   // Label 22284: @1615157
     /* 1615157 */   GIM_Try, /*On fail goto*//*Label 22285*/ GIMT_Encode4(1615243), // Rule ID 3474 //
     /* 1615162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1615170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1615173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1615176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1615179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615208 */     // MIs[0] policy
     /* 1615208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1615221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615242 */     // GIR_Coverage, 3474,
     /* 1615242 */     GIR_EraseRootFromParent_Done,
     /* 1615243 */   // Label 22285: @1615243
     /* 1615243 */   GIM_Try, /*On fail goto*//*Label 22286*/ GIMT_Encode4(1615329), // Rule ID 3475 //
     /* 1615248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1615256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1615259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1615262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1615265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615294 */     // MIs[0] policy
     /* 1615294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615304 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1615307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615328 */     // GIR_Coverage, 3475,
     /* 1615328 */     GIR_EraseRootFromParent_Done,
     /* 1615329 */   // Label 22286: @1615329
     /* 1615329 */   GIM_Try, /*On fail goto*//*Label 22287*/ GIMT_Encode4(1615415), // Rule ID 3478 //
     /* 1615334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1615342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1615345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1615348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1615351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615380 */     // MIs[0] policy
     /* 1615380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615390 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1615393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615414 */     // GIR_Coverage, 3478,
     /* 1615414 */     GIR_EraseRootFromParent_Done,
     /* 1615415 */   // Label 22287: @1615415
     /* 1615415 */   GIM_Try, /*On fail goto*//*Label 22288*/ GIMT_Encode4(1615501), // Rule ID 3479 //
     /* 1615420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1615428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1615431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1615434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1615437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615466 */     // MIs[0] policy
     /* 1615466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615476 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1615479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615500 */     // GIR_Coverage, 3479,
     /* 1615500 */     GIR_EraseRootFromParent_Done,
     /* 1615501 */   // Label 22288: @1615501
     /* 1615501 */   GIM_Try, /*On fail goto*//*Label 22289*/ GIMT_Encode4(1615587), // Rule ID 3482 //
     /* 1615506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1615509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1615514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1615517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1615520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1615523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615552 */     // MIs[0] policy
     /* 1615552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615562 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1615565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1615583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615586 */     // GIR_Coverage, 3482,
     /* 1615586 */     GIR_EraseRootFromParent_Done,
     /* 1615587 */   // Label 22289: @1615587
     /* 1615587 */   GIM_Try, /*On fail goto*//*Label 22290*/ GIMT_Encode4(1615673), // Rule ID 3483 //
     /* 1615592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1615595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1615600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1615603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1615606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1615609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615638 */     // MIs[0] policy
     /* 1615638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615648 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1615651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1615669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615672 */     // GIR_Coverage, 3483,
     /* 1615672 */     GIR_EraseRootFromParent_Done,
     /* 1615673 */   // Label 22290: @1615673
     /* 1615673 */   GIM_Try, /*On fail goto*//*Label 22291*/ GIMT_Encode4(1615759), // Rule ID 3486 //
     /* 1615678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1615681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1615686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1615689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1615692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1615695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615724 */     // MIs[0] policy
     /* 1615724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1615737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1615755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615758 */     // GIR_Coverage, 3486,
     /* 1615758 */     GIR_EraseRootFromParent_Done,
     /* 1615759 */   // Label 22291: @1615759
     /* 1615759 */   GIM_Try, /*On fail goto*//*Label 22292*/ GIMT_Encode4(1615845), // Rule ID 3487 //
     /* 1615764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1615767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1615772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1615775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1615778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1615781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615810 */     // MIs[0] policy
     /* 1615810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615820 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1615823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1615841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615844 */     // GIR_Coverage, 3487,
     /* 1615844 */     GIR_EraseRootFromParent_Done,
     /* 1615845 */   // Label 22292: @1615845
     /* 1615845 */   GIM_Try, /*On fail goto*//*Label 22293*/ GIMT_Encode4(1615931), // Rule ID 3490 //
     /* 1615850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1615853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1615858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1615861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1615864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1615867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615896 */     // MIs[0] policy
     /* 1615896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615906 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1615909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1615927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615930 */     // GIR_Coverage, 3490,
     /* 1615930 */     GIR_EraseRootFromParent_Done,
     /* 1615931 */   // Label 22293: @1615931
     /* 1615931 */   GIM_Try, /*On fail goto*//*Label 22294*/ GIMT_Encode4(1616017), // Rule ID 3491 //
     /* 1615936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1615939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1615944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1615947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1615950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1615953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615982 */     // MIs[0] policy
     /* 1615982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615992 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1615995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1616013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616016 */     // GIR_Coverage, 3491,
     /* 1616016 */     GIR_EraseRootFromParent_Done,
     /* 1616017 */   // Label 22294: @1616017
     /* 1616017 */   GIM_Try, /*On fail goto*//*Label 22295*/ GIMT_Encode4(1616103), // Rule ID 3582 //
     /* 1616022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1616033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1616036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1616039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1616042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616068 */     // MIs[0] policy
     /* 1616068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616078 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1616081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616102 */     // GIR_Coverage, 3582,
     /* 1616102 */     GIR_EraseRootFromParent_Done,
     /* 1616103 */   // Label 22295: @1616103
     /* 1616103 */   GIM_Try, /*On fail goto*//*Label 22296*/ GIMT_Encode4(1616189), // Rule ID 3583 //
     /* 1616108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1616119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1616122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1616125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1616128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616154 */     // MIs[0] policy
     /* 1616154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616164 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1616167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616188 */     // GIR_Coverage, 3583,
     /* 1616188 */     GIR_EraseRootFromParent_Done,
     /* 1616189 */   // Label 22296: @1616189
     /* 1616189 */   GIM_Try, /*On fail goto*//*Label 22297*/ GIMT_Encode4(1616275), // Rule ID 3586 //
     /* 1616194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1616205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1616208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1616211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1616214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616240 */     // MIs[0] policy
     /* 1616240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616250 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1616253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616274 */     // GIR_Coverage, 3586,
     /* 1616274 */     GIR_EraseRootFromParent_Done,
     /* 1616275 */   // Label 22297: @1616275
     /* 1616275 */   GIM_Try, /*On fail goto*//*Label 22298*/ GIMT_Encode4(1616361), // Rule ID 3587 //
     /* 1616280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1616291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1616294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1616297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1616300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616326 */     // MIs[0] policy
     /* 1616326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616336 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1616339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616360 */     // GIR_Coverage, 3587,
     /* 1616360 */     GIR_EraseRootFromParent_Done,
     /* 1616361 */   // Label 22298: @1616361
     /* 1616361 */   GIM_Try, /*On fail goto*//*Label 22299*/ GIMT_Encode4(1616447), // Rule ID 3590 //
     /* 1616366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1616377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1616380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1616383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1616386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616412 */     // MIs[0] policy
     /* 1616412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616422 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1616425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616446 */     // GIR_Coverage, 3590,
     /* 1616446 */     GIR_EraseRootFromParent_Done,
     /* 1616447 */   // Label 22299: @1616447
     /* 1616447 */   GIM_Try, /*On fail goto*//*Label 22300*/ GIMT_Encode4(1616533), // Rule ID 3591 //
     /* 1616452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1616463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1616466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1616469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1616472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616498 */     // MIs[0] policy
     /* 1616498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616508 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1616511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616532 */     // GIR_Coverage, 3591,
     /* 1616532 */     GIR_EraseRootFromParent_Done,
     /* 1616533 */   // Label 22300: @1616533
     /* 1616533 */   GIM_Try, /*On fail goto*//*Label 22301*/ GIMT_Encode4(1616619), // Rule ID 3594 //
     /* 1616538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1616549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1616552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1616555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1616558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616584 */     // MIs[0] policy
     /* 1616584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616594 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1616597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616618 */     // GIR_Coverage, 3594,
     /* 1616618 */     GIR_EraseRootFromParent_Done,
     /* 1616619 */   // Label 22301: @1616619
     /* 1616619 */   GIM_Try, /*On fail goto*//*Label 22302*/ GIMT_Encode4(1616705), // Rule ID 3595 //
     /* 1616624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1616635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1616638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1616641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1616644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616670 */     // MIs[0] policy
     /* 1616670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616680 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1616683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616704 */     // GIR_Coverage, 3595,
     /* 1616704 */     GIR_EraseRootFromParent_Done,
     /* 1616705 */   // Label 22302: @1616705
     /* 1616705 */   GIM_Try, /*On fail goto*//*Label 22303*/ GIMT_Encode4(1616791), // Rule ID 3598 //
     /* 1616710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1616721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1616724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1616727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1616730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616756 */     // MIs[0] policy
     /* 1616756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616766 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1616769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616790 */     // GIR_Coverage, 3598,
     /* 1616790 */     GIR_EraseRootFromParent_Done,
     /* 1616791 */   // Label 22303: @1616791
     /* 1616791 */   GIM_Try, /*On fail goto*//*Label 22304*/ GIMT_Encode4(1616877), // Rule ID 3599 //
     /* 1616796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1616807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1616810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1616813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1616816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616842 */     // MIs[0] policy
     /* 1616842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616852 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1616855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616876 */     // GIR_Coverage, 3599,
     /* 1616876 */     GIR_EraseRootFromParent_Done,
     /* 1616877 */   // Label 22304: @1616877
     /* 1616877 */   GIM_Try, /*On fail goto*//*Label 22305*/ GIMT_Encode4(1616963), // Rule ID 3602 //
     /* 1616882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1616893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1616896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1616899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1616902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1616905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616928 */     // MIs[0] policy
     /* 1616928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616938 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1616941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616962 */     // GIR_Coverage, 3602,
     /* 1616962 */     GIR_EraseRootFromParent_Done,
     /* 1616963 */   // Label 22305: @1616963
     /* 1616963 */   GIM_Try, /*On fail goto*//*Label 22306*/ GIMT_Encode4(1617049), // Rule ID 3603 //
     /* 1616968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1616979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1616982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1616985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1616988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1616991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617014 */     // MIs[0] policy
     /* 1617014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617024 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1617027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617048 */     // GIR_Coverage, 3603,
     /* 1617048 */     GIR_EraseRootFromParent_Done,
     /* 1617049 */   // Label 22306: @1617049
     /* 1617049 */   GIM_Try, /*On fail goto*//*Label 22307*/ GIMT_Encode4(1617135), // Rule ID 3606 //
     /* 1617054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1617065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1617068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1617071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1617074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617100 */     // MIs[0] policy
     /* 1617100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617110 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1617113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617134 */     // GIR_Coverage, 3606,
     /* 1617134 */     GIR_EraseRootFromParent_Done,
     /* 1617135 */   // Label 22307: @1617135
     /* 1617135 */   GIM_Try, /*On fail goto*//*Label 22308*/ GIMT_Encode4(1617221), // Rule ID 3607 //
     /* 1617140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1617151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1617154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1617157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1617160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617186 */     // MIs[0] policy
     /* 1617186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617196 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1617199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617220 */     // GIR_Coverage, 3607,
     /* 1617220 */     GIR_EraseRootFromParent_Done,
     /* 1617221 */   // Label 22308: @1617221
     /* 1617221 */   GIM_Try, /*On fail goto*//*Label 22309*/ GIMT_Encode4(1617307), // Rule ID 3610 //
     /* 1617226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1617237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1617240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1617243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1617246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617272 */     // MIs[0] policy
     /* 1617272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617282 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1617285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617306 */     // GIR_Coverage, 3610,
     /* 1617306 */     GIR_EraseRootFromParent_Done,
     /* 1617307 */   // Label 22309: @1617307
     /* 1617307 */   GIM_Try, /*On fail goto*//*Label 22310*/ GIMT_Encode4(1617393), // Rule ID 3611 //
     /* 1617312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1617323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1617326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1617329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1617332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617358 */     // MIs[0] policy
     /* 1617358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617368 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1617371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617392 */     // GIR_Coverage, 3611,
     /* 1617392 */     GIR_EraseRootFromParent_Done,
     /* 1617393 */   // Label 22310: @1617393
     /* 1617393 */   GIM_Try, /*On fail goto*//*Label 22311*/ GIMT_Encode4(1617479), // Rule ID 3614 //
     /* 1617398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1617409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1617412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1617415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1617418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617444 */     // MIs[0] policy
     /* 1617444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617454 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1617457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617478 */     // GIR_Coverage, 3614,
     /* 1617478 */     GIR_EraseRootFromParent_Done,
     /* 1617479 */   // Label 22311: @1617479
     /* 1617479 */   GIM_Try, /*On fail goto*//*Label 22312*/ GIMT_Encode4(1617565), // Rule ID 3615 //
     /* 1617484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1617495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1617498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1617501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1617504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617530 */     // MIs[0] policy
     /* 1617530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617540 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1617543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617564 */     // GIR_Coverage, 3615,
     /* 1617564 */     GIR_EraseRootFromParent_Done,
     /* 1617565 */   // Label 22312: @1617565
     /* 1617565 */   GIM_Try, /*On fail goto*//*Label 22313*/ GIMT_Encode4(1617651), // Rule ID 3618 //
     /* 1617570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1617581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1617584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1617587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1617590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617616 */     // MIs[0] policy
     /* 1617616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617626 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1617629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617650 */     // GIR_Coverage, 3618,
     /* 1617650 */     GIR_EraseRootFromParent_Done,
     /* 1617651 */   // Label 22313: @1617651
     /* 1617651 */   GIM_Try, /*On fail goto*//*Label 22314*/ GIMT_Encode4(1617737), // Rule ID 3619 //
     /* 1617656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1617667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1617670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1617673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1617676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617702 */     // MIs[0] policy
     /* 1617702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617712 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1617715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617736 */     // GIR_Coverage, 3619,
     /* 1617736 */     GIR_EraseRootFromParent_Done,
     /* 1617737 */   // Label 22314: @1617737
     /* 1617737 */   GIM_Try, /*On fail goto*//*Label 22315*/ GIMT_Encode4(1617823), // Rule ID 3622 //
     /* 1617742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1617753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1617756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1617759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1617762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1617765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617788 */     // MIs[0] policy
     /* 1617788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617798 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1617801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617822 */     // GIR_Coverage, 3622,
     /* 1617822 */     GIR_EraseRootFromParent_Done,
     /* 1617823 */   // Label 22315: @1617823
     /* 1617823 */   GIM_Try, /*On fail goto*//*Label 22316*/ GIMT_Encode4(1617909), // Rule ID 3623 //
     /* 1617828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1617839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1617842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1617845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1617848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1617851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617874 */     // MIs[0] policy
     /* 1617874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617884 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1617887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617908 */     // GIR_Coverage, 3623,
     /* 1617908 */     GIR_EraseRootFromParent_Done,
     /* 1617909 */   // Label 22316: @1617909
     /* 1617909 */   GIM_Try, /*On fail goto*//*Label 22317*/ GIMT_Encode4(1617995), // Rule ID 3626 //
     /* 1617914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1617925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1617928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1617931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1617934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617960 */     // MIs[0] policy
     /* 1617960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617970 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1617973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617994 */     // GIR_Coverage, 3626,
     /* 1617994 */     GIR_EraseRootFromParent_Done,
     /* 1617995 */   // Label 22317: @1617995
     /* 1617995 */   GIM_Try, /*On fail goto*//*Label 22318*/ GIMT_Encode4(1618081), // Rule ID 3627 //
     /* 1618000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1618003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1618008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1618011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1618014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1618017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1618020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618046 */     // MIs[0] policy
     /* 1618046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618056 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1618059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618080 */     // GIR_Coverage, 3627,
     /* 1618080 */     GIR_EraseRootFromParent_Done,
     /* 1618081 */   // Label 22318: @1618081
     /* 1618081 */   GIM_Try, /*On fail goto*//*Label 22319*/ GIMT_Encode4(1618167), // Rule ID 3630 //
     /* 1618086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1618089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1618094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1618097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1618100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1618103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1618106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618132 */     // MIs[0] policy
     /* 1618132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618142 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1618145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618166 */     // GIR_Coverage, 3630,
     /* 1618166 */     GIR_EraseRootFromParent_Done,
     /* 1618167 */   // Label 22319: @1618167
     /* 1618167 */   GIM_Try, /*On fail goto*//*Label 22320*/ GIMT_Encode4(1618253), // Rule ID 3631 //
     /* 1618172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1618175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1618180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1618183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1618186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1618189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1618192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618218 */     // MIs[0] policy
     /* 1618218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618228 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1618231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618252 */     // GIR_Coverage, 3631,
     /* 1618252 */     GIR_EraseRootFromParent_Done,
     /* 1618253 */   // Label 22320: @1618253
     /* 1618253 */   GIM_Try, /*On fail goto*//*Label 22321*/ GIMT_Encode4(1618339), // Rule ID 3634 //
     /* 1618258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1618261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1618266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1618269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1618272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1618275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1618278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618304 */     // MIs[0] policy
     /* 1618304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618314 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1618317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618338 */     // GIR_Coverage, 3634,
     /* 1618338 */     GIR_EraseRootFromParent_Done,
     /* 1618339 */   // Label 22321: @1618339
     /* 1618339 */   GIM_Try, /*On fail goto*//*Label 22322*/ GIMT_Encode4(1618425), // Rule ID 3635 //
     /* 1618344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1618347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1618352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1618355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1618358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1618361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1618364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618390 */     // MIs[0] policy
     /* 1618390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618400 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1618403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618424 */     // GIR_Coverage, 3635,
     /* 1618424 */     GIR_EraseRootFromParent_Done,
     /* 1618425 */   // Label 22322: @1618425
     /* 1618425 */   GIM_Try, /*On fail goto*//*Label 22323*/ GIMT_Encode4(1618511), // Rule ID 3638 //
     /* 1618430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1618433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1618438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1618441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1618444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1618447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1618450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618476 */     // MIs[0] policy
     /* 1618476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618486 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1618489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618510 */     // GIR_Coverage, 3638,
     /* 1618510 */     GIR_EraseRootFromParent_Done,
     /* 1618511 */   // Label 22323: @1618511
     /* 1618511 */   GIM_Try, /*On fail goto*//*Label 22324*/ GIMT_Encode4(1618597), // Rule ID 3639 //
     /* 1618516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1618519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1618524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1618527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1618530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1618533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1618536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618562 */     // MIs[0] policy
     /* 1618562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618572 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1618575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618596 */     // GIR_Coverage, 3639,
     /* 1618596 */     GIR_EraseRootFromParent_Done,
     /* 1618597 */   // Label 22324: @1618597
     /* 1618597 */   GIM_Try, /*On fail goto*//*Label 22325*/ GIMT_Encode4(1618683), // Rule ID 3642 //
     /* 1618602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1618610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1618613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1618616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1618619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1618622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618648 */     // MIs[0] policy
     /* 1618648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618658 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1618661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618682 */     // GIR_Coverage, 3642,
     /* 1618682 */     GIR_EraseRootFromParent_Done,
     /* 1618683 */   // Label 22325: @1618683
     /* 1618683 */   GIM_Try, /*On fail goto*//*Label 22326*/ GIMT_Encode4(1618769), // Rule ID 3643 //
     /* 1618688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1618696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1618699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1618702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1618705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1618708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618734 */     // MIs[0] policy
     /* 1618734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618744 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1618747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618768 */     // GIR_Coverage, 3643,
     /* 1618768 */     GIR_EraseRootFromParent_Done,
     /* 1618769 */   // Label 22326: @1618769
     /* 1618769 */   GIM_Try, /*On fail goto*//*Label 22327*/ GIMT_Encode4(1618855), // Rule ID 3646 //
     /* 1618774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1618782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1618785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1618788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1618791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1618794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618820 */     // MIs[0] policy
     /* 1618820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618830 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1618833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618854 */     // GIR_Coverage, 3646,
     /* 1618854 */     GIR_EraseRootFromParent_Done,
     /* 1618855 */   // Label 22327: @1618855
     /* 1618855 */   GIM_Try, /*On fail goto*//*Label 22328*/ GIMT_Encode4(1618941), // Rule ID 3647 //
     /* 1618860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1618868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1618871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1618874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1618877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1618880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618906 */     // MIs[0] policy
     /* 1618906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618916 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1618919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618940 */     // GIR_Coverage, 3647,
     /* 1618940 */     GIR_EraseRootFromParent_Done,
     /* 1618941 */   // Label 22328: @1618941
     /* 1618941 */   GIM_Try, /*On fail goto*//*Label 22329*/ GIMT_Encode4(1619027), // Rule ID 3650 //
     /* 1618946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1618954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1618957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1618960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1618963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1618966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618992 */     // MIs[0] policy
     /* 1618992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1619005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619026 */     // GIR_Coverage, 3650,
     /* 1619026 */     GIR_EraseRootFromParent_Done,
     /* 1619027 */   // Label 22329: @1619027
     /* 1619027 */   GIM_Try, /*On fail goto*//*Label 22330*/ GIMT_Encode4(1619113), // Rule ID 3651 //
     /* 1619032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1619040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1619043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1619046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1619049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619078 */     // MIs[0] policy
     /* 1619078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619088 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1619091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619112 */     // GIR_Coverage, 3651,
     /* 1619112 */     GIR_EraseRootFromParent_Done,
     /* 1619113 */   // Label 22330: @1619113
     /* 1619113 */   GIM_Try, /*On fail goto*//*Label 22331*/ GIMT_Encode4(1619199), // Rule ID 3654 //
     /* 1619118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1619126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1619129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1619132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1619135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619164 */     // MIs[0] policy
     /* 1619164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619174 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1619177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619198 */     // GIR_Coverage, 3654,
     /* 1619198 */     GIR_EraseRootFromParent_Done,
     /* 1619199 */   // Label 22331: @1619199
     /* 1619199 */   GIM_Try, /*On fail goto*//*Label 22332*/ GIMT_Encode4(1619285), // Rule ID 3655 //
     /* 1619204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1619212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1619215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1619218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1619221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619250 */     // MIs[0] policy
     /* 1619250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619260 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1619263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619284 */     // GIR_Coverage, 3655,
     /* 1619284 */     GIR_EraseRootFromParent_Done,
     /* 1619285 */   // Label 22332: @1619285
     /* 1619285 */   GIM_Try, /*On fail goto*//*Label 22333*/ GIMT_Encode4(1619371), // Rule ID 3658 //
     /* 1619290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1619298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1619301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1619304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1619307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619336 */     // MIs[0] policy
     /* 1619336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619346 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1619349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619370 */     // GIR_Coverage, 3658,
     /* 1619370 */     GIR_EraseRootFromParent_Done,
     /* 1619371 */   // Label 22333: @1619371
     /* 1619371 */   GIM_Try, /*On fail goto*//*Label 22334*/ GIMT_Encode4(1619457), // Rule ID 3659 //
     /* 1619376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1619384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1619387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1619390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1619393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619422 */     // MIs[0] policy
     /* 1619422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619432 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1619435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619456 */     // GIR_Coverage, 3659,
     /* 1619456 */     GIR_EraseRootFromParent_Done,
     /* 1619457 */   // Label 22334: @1619457
     /* 1619457 */   GIM_Try, /*On fail goto*//*Label 22335*/ GIMT_Encode4(1619543), // Rule ID 3662 //
     /* 1619462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1619470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1619473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1619476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1619479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1619485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619508 */     // MIs[0] policy
     /* 1619508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619518 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1619521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619542 */     // GIR_Coverage, 3662,
     /* 1619542 */     GIR_EraseRootFromParent_Done,
     /* 1619543 */   // Label 22335: @1619543
     /* 1619543 */   GIM_Try, /*On fail goto*//*Label 22336*/ GIMT_Encode4(1619629), // Rule ID 3663 //
     /* 1619548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1619556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1619559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1619562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1619565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1619571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619594 */     // MIs[0] policy
     /* 1619594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619604 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1619607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619628 */     // GIR_Coverage, 3663,
     /* 1619628 */     GIR_EraseRootFromParent_Done,
     /* 1619629 */   // Label 22336: @1619629
     /* 1619629 */   GIM_Try, /*On fail goto*//*Label 22337*/ GIMT_Encode4(1619715), // Rule ID 3666 //
     /* 1619634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1619642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1619645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1619648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1619651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619680 */     // MIs[0] policy
     /* 1619680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619690 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1619693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619714 */     // GIR_Coverage, 3666,
     /* 1619714 */     GIR_EraseRootFromParent_Done,
     /* 1619715 */   // Label 22337: @1619715
     /* 1619715 */   GIM_Try, /*On fail goto*//*Label 22338*/ GIMT_Encode4(1619801), // Rule ID 3667 //
     /* 1619720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1619728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1619731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1619734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1619737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619766 */     // MIs[0] policy
     /* 1619766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619776 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1619779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619800 */     // GIR_Coverage, 3667,
     /* 1619800 */     GIR_EraseRootFromParent_Done,
     /* 1619801 */   // Label 22338: @1619801
     /* 1619801 */   GIM_Try, /*On fail goto*//*Label 22339*/ GIMT_Encode4(1619887), // Rule ID 3670 //
     /* 1619806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1619814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1619817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1619820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1619823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619852 */     // MIs[0] policy
     /* 1619852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619862 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1619865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619886 */     // GIR_Coverage, 3670,
     /* 1619886 */     GIR_EraseRootFromParent_Done,
     /* 1619887 */   // Label 22339: @1619887
     /* 1619887 */   GIM_Try, /*On fail goto*//*Label 22340*/ GIMT_Encode4(1619973), // Rule ID 3671 //
     /* 1619892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1619900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1619903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1619906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1619909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619938 */     // MIs[0] policy
     /* 1619938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619948 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1619951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619972 */     // GIR_Coverage, 3671,
     /* 1619972 */     GIR_EraseRootFromParent_Done,
     /* 1619973 */   // Label 22340: @1619973
     /* 1619973 */   GIM_Try, /*On fail goto*//*Label 22341*/ GIMT_Encode4(1620059), // Rule ID 3674 //
     /* 1619978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1619986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1619989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1619992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1619995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620024 */     // MIs[0] policy
     /* 1620024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1620037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620058 */     // GIR_Coverage, 3674,
     /* 1620058 */     GIR_EraseRootFromParent_Done,
     /* 1620059 */   // Label 22341: @1620059
     /* 1620059 */   GIM_Try, /*On fail goto*//*Label 22342*/ GIMT_Encode4(1620145), // Rule ID 3675 //
     /* 1620064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1620072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1620075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1620078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1620081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620110 */     // MIs[0] policy
     /* 1620110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620120 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1620123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620144 */     // GIR_Coverage, 3675,
     /* 1620144 */     GIR_EraseRootFromParent_Done,
     /* 1620145 */   // Label 22342: @1620145
     /* 1620145 */   GIM_Try, /*On fail goto*//*Label 22343*/ GIMT_Encode4(1620231), // Rule ID 3678 //
     /* 1620150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1620158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1620161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1620164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1620167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620196 */     // MIs[0] policy
     /* 1620196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1620209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620230 */     // GIR_Coverage, 3678,
     /* 1620230 */     GIR_EraseRootFromParent_Done,
     /* 1620231 */   // Label 22343: @1620231
     /* 1620231 */   GIM_Try, /*On fail goto*//*Label 22344*/ GIMT_Encode4(1620317), // Rule ID 3679 //
     /* 1620236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1620244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1620247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1620250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1620253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620282 */     // MIs[0] policy
     /* 1620282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620292 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1620295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620316 */     // GIR_Coverage, 3679,
     /* 1620316 */     GIR_EraseRootFromParent_Done,
     /* 1620317 */   // Label 22344: @1620317
     /* 1620317 */   GIM_Try, /*On fail goto*//*Label 22345*/ GIMT_Encode4(1620403), // Rule ID 3682 //
     /* 1620322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1620330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1620333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1620336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1620339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1620345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620368 */     // MIs[0] policy
     /* 1620368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620378 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1620381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620402 */     // GIR_Coverage, 3682,
     /* 1620402 */     GIR_EraseRootFromParent_Done,
     /* 1620403 */   // Label 22345: @1620403
     /* 1620403 */   GIM_Try, /*On fail goto*//*Label 22346*/ GIMT_Encode4(1620489), // Rule ID 3683 //
     /* 1620408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1620416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1620419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1620422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1620425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1620431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620454 */     // MIs[0] policy
     /* 1620454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1620467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620488 */     // GIR_Coverage, 3683,
     /* 1620488 */     GIR_EraseRootFromParent_Done,
     /* 1620489 */   // Label 22346: @1620489
     /* 1620489 */   GIM_Try, /*On fail goto*//*Label 22347*/ GIMT_Encode4(1620575), // Rule ID 3686 //
     /* 1620494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1620497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1620502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1620505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1620508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1620511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620540 */     // MIs[0] policy
     /* 1620540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620550 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1620553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620574 */     // GIR_Coverage, 3686,
     /* 1620574 */     GIR_EraseRootFromParent_Done,
     /* 1620575 */   // Label 22347: @1620575
     /* 1620575 */   GIM_Try, /*On fail goto*//*Label 22348*/ GIMT_Encode4(1620661), // Rule ID 3687 //
     /* 1620580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1620583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1620588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1620591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1620594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1620597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620626 */     // MIs[0] policy
     /* 1620626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1620639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620660 */     // GIR_Coverage, 3687,
     /* 1620660 */     GIR_EraseRootFromParent_Done,
     /* 1620661 */   // Label 22348: @1620661
     /* 1620661 */   GIM_Try, /*On fail goto*//*Label 22349*/ GIMT_Encode4(1620747), // Rule ID 3690 //
     /* 1620666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1620669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1620674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1620677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1620680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1620683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620712 */     // MIs[0] policy
     /* 1620712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620722 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1620725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620746 */     // GIR_Coverage, 3690,
     /* 1620746 */     GIR_EraseRootFromParent_Done,
     /* 1620747 */   // Label 22349: @1620747
     /* 1620747 */   GIM_Try, /*On fail goto*//*Label 22350*/ GIMT_Encode4(1620833), // Rule ID 3691 //
     /* 1620752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1620755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1620760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1620763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1620766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1620769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620798 */     // MIs[0] policy
     /* 1620798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1620811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620832 */     // GIR_Coverage, 3691,
     /* 1620832 */     GIR_EraseRootFromParent_Done,
     /* 1620833 */   // Label 22350: @1620833
     /* 1620833 */   GIM_Try, /*On fail goto*//*Label 22351*/ GIMT_Encode4(1620919), // Rule ID 3694 //
     /* 1620838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1620841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1620846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1620849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1620852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1620855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620884 */     // MIs[0] policy
     /* 1620884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620894 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1620897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620918 */     // GIR_Coverage, 3694,
     /* 1620918 */     GIR_EraseRootFromParent_Done,
     /* 1620919 */   // Label 22351: @1620919
     /* 1620919 */   GIM_Try, /*On fail goto*//*Label 22352*/ GIMT_Encode4(1621005), // Rule ID 3695 //
     /* 1620924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1620927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1620932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1620935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1620938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1620941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620970 */     // MIs[0] policy
     /* 1620970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620980 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1620983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1621001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621004 */     // GIR_Coverage, 3695,
     /* 1621004 */     GIR_EraseRootFromParent_Done,
     /* 1621005 */   // Label 22352: @1621005
     /* 1621005 */   GIM_Try, /*On fail goto*//*Label 22353*/ GIMT_Encode4(1621091), // Rule ID 3698 //
     /* 1621010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1621013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1621018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1621021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1621024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1621027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621056 */     // MIs[0] policy
     /* 1621056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621066 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1621069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1621087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621090 */     // GIR_Coverage, 3698,
     /* 1621090 */     GIR_EraseRootFromParent_Done,
     /* 1621091 */   // Label 22353: @1621091
     /* 1621091 */   GIM_Try, /*On fail goto*//*Label 22354*/ GIMT_Encode4(1621177), // Rule ID 3699 //
     /* 1621096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1621099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1621104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1621107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1621110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1621113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621142 */     // MIs[0] policy
     /* 1621142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621152 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1621155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1621173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621176 */     // GIR_Coverage, 3699,
     /* 1621176 */     GIR_EraseRootFromParent_Done,
     /* 1621177 */   // Label 22354: @1621177
     /* 1621177 */   GIM_Try, /*On fail goto*//*Label 22355*/ GIMT_Encode4(1621263), // Rule ID 3702 //
     /* 1621182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1621193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1621196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1621199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1621202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621228 */     // MIs[0] policy
     /* 1621228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621238 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1621241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621262 */     // GIR_Coverage, 3702,
     /* 1621262 */     GIR_EraseRootFromParent_Done,
     /* 1621263 */   // Label 22355: @1621263
     /* 1621263 */   GIM_Try, /*On fail goto*//*Label 22356*/ GIMT_Encode4(1621349), // Rule ID 3703 //
     /* 1621268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1621279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1621282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1621285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1621288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621314 */     // MIs[0] policy
     /* 1621314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621324 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1621327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621348 */     // GIR_Coverage, 3703,
     /* 1621348 */     GIR_EraseRootFromParent_Done,
     /* 1621349 */   // Label 22356: @1621349
     /* 1621349 */   GIM_Try, /*On fail goto*//*Label 22357*/ GIMT_Encode4(1621435), // Rule ID 3706 //
     /* 1621354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1621365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1621368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1621371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1621374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621400 */     // MIs[0] policy
     /* 1621400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621410 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1621413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621434 */     // GIR_Coverage, 3706,
     /* 1621434 */     GIR_EraseRootFromParent_Done,
     /* 1621435 */   // Label 22357: @1621435
     /* 1621435 */   GIM_Try, /*On fail goto*//*Label 22358*/ GIMT_Encode4(1621521), // Rule ID 3707 //
     /* 1621440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1621451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1621454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1621457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1621460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621486 */     // MIs[0] policy
     /* 1621486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1621499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621520 */     // GIR_Coverage, 3707,
     /* 1621520 */     GIR_EraseRootFromParent_Done,
     /* 1621521 */   // Label 22358: @1621521
     /* 1621521 */   GIM_Try, /*On fail goto*//*Label 22359*/ GIMT_Encode4(1621607), // Rule ID 3710 //
     /* 1621526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1621537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1621540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1621543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1621546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621572 */     // MIs[0] policy
     /* 1621572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621582 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1621585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621606 */     // GIR_Coverage, 3710,
     /* 1621606 */     GIR_EraseRootFromParent_Done,
     /* 1621607 */   // Label 22359: @1621607
     /* 1621607 */   GIM_Try, /*On fail goto*//*Label 22360*/ GIMT_Encode4(1621693), // Rule ID 3711 //
     /* 1621612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1621623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1621626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1621629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1621632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621658 */     // MIs[0] policy
     /* 1621658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1621671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621692 */     // GIR_Coverage, 3711,
     /* 1621692 */     GIR_EraseRootFromParent_Done,
     /* 1621693 */   // Label 22360: @1621693
     /* 1621693 */   GIM_Try, /*On fail goto*//*Label 22361*/ GIMT_Encode4(1621779), // Rule ID 3714 //
     /* 1621698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1621709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1621712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1621715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1621718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621744 */     // MIs[0] policy
     /* 1621744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1621757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621778 */     // GIR_Coverage, 3714,
     /* 1621778 */     GIR_EraseRootFromParent_Done,
     /* 1621779 */   // Label 22361: @1621779
     /* 1621779 */   GIM_Try, /*On fail goto*//*Label 22362*/ GIMT_Encode4(1621865), // Rule ID 3715 //
     /* 1621784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1621795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1621798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1621801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1621804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621830 */     // MIs[0] policy
     /* 1621830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621840 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1621843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621864 */     // GIR_Coverage, 3715,
     /* 1621864 */     GIR_EraseRootFromParent_Done,
     /* 1621865 */   // Label 22362: @1621865
     /* 1621865 */   GIM_Try, /*On fail goto*//*Label 22363*/ GIMT_Encode4(1621951), // Rule ID 3718 //
     /* 1621870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1621881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1621884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1621887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1621890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621916 */     // MIs[0] policy
     /* 1621916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1621929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621950 */     // GIR_Coverage, 3718,
     /* 1621950 */     GIR_EraseRootFromParent_Done,
     /* 1621951 */   // Label 22363: @1621951
     /* 1621951 */   GIM_Try, /*On fail goto*//*Label 22364*/ GIMT_Encode4(1622037), // Rule ID 3719 //
     /* 1621956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1621967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1621970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1621973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1621976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622002 */     // MIs[0] policy
     /* 1622002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622012 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1622015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622036 */     // GIR_Coverage, 3719,
     /* 1622036 */     GIR_EraseRootFromParent_Done,
     /* 1622037 */   // Label 22364: @1622037
     /* 1622037 */   GIM_Try, /*On fail goto*//*Label 22365*/ GIMT_Encode4(1622123), // Rule ID 3722 //
     /* 1622042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1622053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1622056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1622059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1622062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1622065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622088 */     // MIs[0] policy
     /* 1622088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622098 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1622101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622122 */     // GIR_Coverage, 3722,
     /* 1622122 */     GIR_EraseRootFromParent_Done,
     /* 1622123 */   // Label 22365: @1622123
     /* 1622123 */   GIM_Try, /*On fail goto*//*Label 22366*/ GIMT_Encode4(1622209), // Rule ID 3723 //
     /* 1622128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1622139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1622142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1622145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1622148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1622151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622174 */     // MIs[0] policy
     /* 1622174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622184 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1622187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622208 */     // GIR_Coverage, 3723,
     /* 1622208 */     GIR_EraseRootFromParent_Done,
     /* 1622209 */   // Label 22366: @1622209
     /* 1622209 */   GIM_Try, /*On fail goto*//*Label 22367*/ GIMT_Encode4(1622295), // Rule ID 3726 //
     /* 1622214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1622225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1622228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1622231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1622234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622260 */     // MIs[0] policy
     /* 1622260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622270 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1622273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622294 */     // GIR_Coverage, 3726,
     /* 1622294 */     GIR_EraseRootFromParent_Done,
     /* 1622295 */   // Label 22367: @1622295
     /* 1622295 */   GIM_Try, /*On fail goto*//*Label 22368*/ GIMT_Encode4(1622381), // Rule ID 3727 //
     /* 1622300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1622311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1622314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1622317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1622320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622346 */     // MIs[0] policy
     /* 1622346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622356 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1622359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622380 */     // GIR_Coverage, 3727,
     /* 1622380 */     GIR_EraseRootFromParent_Done,
     /* 1622381 */   // Label 22368: @1622381
     /* 1622381 */   GIM_Try, /*On fail goto*//*Label 22369*/ GIMT_Encode4(1622467), // Rule ID 3730 //
     /* 1622386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1622397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1622400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1622403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1622406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622432 */     // MIs[0] policy
     /* 1622432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622442 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1622445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622466 */     // GIR_Coverage, 3730,
     /* 1622466 */     GIR_EraseRootFromParent_Done,
     /* 1622467 */   // Label 22369: @1622467
     /* 1622467 */   GIM_Try, /*On fail goto*//*Label 22370*/ GIMT_Encode4(1622553), // Rule ID 3731 //
     /* 1622472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1622483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1622486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1622489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1622492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622518 */     // MIs[0] policy
     /* 1622518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1622531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622552 */     // GIR_Coverage, 3731,
     /* 1622552 */     GIR_EraseRootFromParent_Done,
     /* 1622553 */   // Label 22370: @1622553
     /* 1622553 */   GIM_Try, /*On fail goto*//*Label 22371*/ GIMT_Encode4(1622639), // Rule ID 3734 //
     /* 1622558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1622569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1622572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1622575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1622578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622604 */     // MIs[0] policy
     /* 1622604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1622617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622638 */     // GIR_Coverage, 3734,
     /* 1622638 */     GIR_EraseRootFromParent_Done,
     /* 1622639 */   // Label 22371: @1622639
     /* 1622639 */   GIM_Try, /*On fail goto*//*Label 22372*/ GIMT_Encode4(1622725), // Rule ID 3735 //
     /* 1622644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1622655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1622658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1622661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1622664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622690 */     // MIs[0] policy
     /* 1622690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1622703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622724 */     // GIR_Coverage, 3735,
     /* 1622724 */     GIR_EraseRootFromParent_Done,
     /* 1622725 */   // Label 22372: @1622725
     /* 1622725 */   GIM_Try, /*On fail goto*//*Label 22373*/ GIMT_Encode4(1622811), // Rule ID 3738 //
     /* 1622730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1622741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1622744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1622747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1622750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622776 */     // MIs[0] policy
     /* 1622776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622786 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1622789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622810 */     // GIR_Coverage, 3738,
     /* 1622810 */     GIR_EraseRootFromParent_Done,
     /* 1622811 */   // Label 22373: @1622811
     /* 1622811 */   GIM_Try, /*On fail goto*//*Label 22374*/ GIMT_Encode4(1622897), // Rule ID 3739 //
     /* 1622816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1622827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1622830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1622833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1622836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622862 */     // MIs[0] policy
     /* 1622862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622872 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1622875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622896 */     // GIR_Coverage, 3739,
     /* 1622896 */     GIR_EraseRootFromParent_Done,
     /* 1622897 */   // Label 22374: @1622897
     /* 1622897 */   GIM_Try, /*On fail goto*//*Label 22375*/ GIMT_Encode4(1622983), // Rule ID 3742 //
     /* 1622902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1622913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1622916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1622919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1622922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1622925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622948 */     // MIs[0] policy
     /* 1622948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622958 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1622961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622982 */     // GIR_Coverage, 3742,
     /* 1622982 */     GIR_EraseRootFromParent_Done,
     /* 1622983 */   // Label 22375: @1622983
     /* 1622983 */   GIM_Try, /*On fail goto*//*Label 22376*/ GIMT_Encode4(1623069), // Rule ID 3743 //
     /* 1622988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1622999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1623002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1623005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1623008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1623011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623034 */     // MIs[0] policy
     /* 1623034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623044 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1623047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1623065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623068 */     // GIR_Coverage, 3743,
     /* 1623068 */     GIR_EraseRootFromParent_Done,
     /* 1623069 */   // Label 22376: @1623069
     /* 1623069 */   GIM_Try, /*On fail goto*//*Label 22377*/ GIMT_Encode4(1623155), // Rule ID 3746 //
     /* 1623074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1623077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1623082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1623085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1623088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1623091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1623094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623120 */     // MIs[0] policy
     /* 1623120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623130 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1623133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623154 */     // GIR_Coverage, 3746,
     /* 1623154 */     GIR_EraseRootFromParent_Done,
     /* 1623155 */   // Label 22377: @1623155
     /* 1623155 */   GIM_Try, /*On fail goto*//*Label 22378*/ GIMT_Encode4(1623241), // Rule ID 3747 //
     /* 1623160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1623163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1623168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1623171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1623174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1623177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1623180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623206 */     // MIs[0] policy
     /* 1623206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623216 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1623219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623240 */     // GIR_Coverage, 3747,
     /* 1623240 */     GIR_EraseRootFromParent_Done,
     /* 1623241 */   // Label 22378: @1623241
     /* 1623241 */   GIM_Try, /*On fail goto*//*Label 22379*/ GIMT_Encode4(1623327), // Rule ID 3750 //
     /* 1623246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1623249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1623254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1623257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1623260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1623263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1623266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623292 */     // MIs[0] policy
     /* 1623292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1623305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623326 */     // GIR_Coverage, 3750,
     /* 1623326 */     GIR_EraseRootFromParent_Done,
     /* 1623327 */   // Label 22379: @1623327
     /* 1623327 */   GIM_Try, /*On fail goto*//*Label 22380*/ GIMT_Encode4(1623413), // Rule ID 3751 //
     /* 1623332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1623335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1623340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1623343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1623346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1623349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1623352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623378 */     // MIs[0] policy
     /* 1623378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623388 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1623391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623412 */     // GIR_Coverage, 3751,
     /* 1623412 */     GIR_EraseRootFromParent_Done,
     /* 1623413 */   // Label 22380: @1623413
     /* 1623413 */   GIM_Try, /*On fail goto*//*Label 22381*/ GIMT_Encode4(1623499), // Rule ID 3754 //
     /* 1623418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1623421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1623426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1623429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1623432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1623435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1623438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623464 */     // MIs[0] policy
     /* 1623464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1623477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623498 */     // GIR_Coverage, 3754,
     /* 1623498 */     GIR_EraseRootFromParent_Done,
     /* 1623499 */   // Label 22381: @1623499
     /* 1623499 */   GIM_Try, /*On fail goto*//*Label 22382*/ GIMT_Encode4(1623585), // Rule ID 3755 //
     /* 1623504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1623507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1623512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1623515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1623518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1623521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1623524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623550 */     // MIs[0] policy
     /* 1623550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623560 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1623563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623584 */     // GIR_Coverage, 3755,
     /* 1623584 */     GIR_EraseRootFromParent_Done,
     /* 1623585 */   // Label 22382: @1623585
     /* 1623585 */   GIM_Try, /*On fail goto*//*Label 22383*/ GIMT_Encode4(1623671), // Rule ID 3758 //
     /* 1623590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1623593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1623598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1623601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1623604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1623607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1623610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623636 */     // MIs[0] policy
     /* 1623636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1623649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623670 */     // GIR_Coverage, 3758,
     /* 1623670 */     GIR_EraseRootFromParent_Done,
     /* 1623671 */   // Label 22383: @1623671
     /* 1623671 */   GIM_Try, /*On fail goto*//*Label 22384*/ GIMT_Encode4(1623757), // Rule ID 3759 //
     /* 1623676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1623679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1623684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1623687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1623690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1623693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1623696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623722 */     // MIs[0] policy
     /* 1623722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623732 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1623735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623756 */     // GIR_Coverage, 3759,
     /* 1623756 */     GIR_EraseRootFromParent_Done,
     /* 1623757 */   // Label 22384: @1623757
     /* 1623757 */   GIM_Try, /*On fail goto*//*Label 22385*/ GIMT_Encode4(1623843), // Rule ID 3762 //
     /* 1623762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1623770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1623773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1623776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1623779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623808 */     // MIs[0] policy
     /* 1623808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623818 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1623821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623842 */     // GIR_Coverage, 3762,
     /* 1623842 */     GIR_EraseRootFromParent_Done,
     /* 1623843 */   // Label 22385: @1623843
     /* 1623843 */   GIM_Try, /*On fail goto*//*Label 22386*/ GIMT_Encode4(1623929), // Rule ID 3763 //
     /* 1623848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1623856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1623859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1623862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1623865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1623868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623894 */     // MIs[0] policy
     /* 1623894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623904 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1623907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623928 */     // GIR_Coverage, 3763,
     /* 1623928 */     GIR_EraseRootFromParent_Done,
     /* 1623929 */   // Label 22386: @1623929
     /* 1623929 */   GIM_Try, /*On fail goto*//*Label 22387*/ GIMT_Encode4(1624015), // Rule ID 3766 //
     /* 1623934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1623942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1623945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1623948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1623951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623980 */     // MIs[0] policy
     /* 1623980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623990 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1623993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624014 */     // GIR_Coverage, 3766,
     /* 1624014 */     GIR_EraseRootFromParent_Done,
     /* 1624015 */   // Label 22387: @1624015
     /* 1624015 */   GIM_Try, /*On fail goto*//*Label 22388*/ GIMT_Encode4(1624101), // Rule ID 3767 //
     /* 1624020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1624028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1624031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1624034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1624037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624066 */     // MIs[0] policy
     /* 1624066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624076 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1624079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624100 */     // GIR_Coverage, 3767,
     /* 1624100 */     GIR_EraseRootFromParent_Done,
     /* 1624101 */   // Label 22388: @1624101
     /* 1624101 */   GIM_Try, /*On fail goto*//*Label 22389*/ GIMT_Encode4(1624187), // Rule ID 3770 //
     /* 1624106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1624114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1624117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1624120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1624123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624152 */     // MIs[0] policy
     /* 1624152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624162 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1624165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624186 */     // GIR_Coverage, 3770,
     /* 1624186 */     GIR_EraseRootFromParent_Done,
     /* 1624187 */   // Label 22389: @1624187
     /* 1624187 */   GIM_Try, /*On fail goto*//*Label 22390*/ GIMT_Encode4(1624273), // Rule ID 3771 //
     /* 1624192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1624200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1624203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1624206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1624209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624238 */     // MIs[0] policy
     /* 1624238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624248 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1624251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624272 */     // GIR_Coverage, 3771,
     /* 1624272 */     GIR_EraseRootFromParent_Done,
     /* 1624273 */   // Label 22390: @1624273
     /* 1624273 */   GIM_Try, /*On fail goto*//*Label 22391*/ GIMT_Encode4(1624359), // Rule ID 3774 //
     /* 1624278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1624286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1624289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1624292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1624295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624324 */     // MIs[0] policy
     /* 1624324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1624337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624358 */     // GIR_Coverage, 3774,
     /* 1624358 */     GIR_EraseRootFromParent_Done,
     /* 1624359 */   // Label 22391: @1624359
     /* 1624359 */   GIM_Try, /*On fail goto*//*Label 22392*/ GIMT_Encode4(1624445), // Rule ID 3775 //
     /* 1624364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1624372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1624375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1624378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1624381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624410 */     // MIs[0] policy
     /* 1624410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624420 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1624423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624444 */     // GIR_Coverage, 3775,
     /* 1624444 */     GIR_EraseRootFromParent_Done,
     /* 1624445 */   // Label 22392: @1624445
     /* 1624445 */   GIM_Try, /*On fail goto*//*Label 22393*/ GIMT_Encode4(1624531), // Rule ID 3778 //
     /* 1624450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1624458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1624461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1624464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1624467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624496 */     // MIs[0] policy
     /* 1624496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624506 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1624509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624530 */     // GIR_Coverage, 3778,
     /* 1624530 */     GIR_EraseRootFromParent_Done,
     /* 1624531 */   // Label 22393: @1624531
     /* 1624531 */   GIM_Try, /*On fail goto*//*Label 22394*/ GIMT_Encode4(1624617), // Rule ID 3779 //
     /* 1624536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1624544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1624547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1624550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1624553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624582 */     // MIs[0] policy
     /* 1624582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624592 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1624595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624616 */     // GIR_Coverage, 3779,
     /* 1624616 */     GIR_EraseRootFromParent_Done,
     /* 1624617 */   // Label 22394: @1624617
     /* 1624617 */   GIM_Try, /*On fail goto*//*Label 22395*/ GIMT_Encode4(1624703), // Rule ID 3782 //
     /* 1624622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1624630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1624633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1624636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1624639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1624645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624668 */     // MIs[0] policy
     /* 1624668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624678 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1624681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624702 */     // GIR_Coverage, 3782,
     /* 1624702 */     GIR_EraseRootFromParent_Done,
     /* 1624703 */   // Label 22395: @1624703
     /* 1624703 */   GIM_Try, /*On fail goto*//*Label 22396*/ GIMT_Encode4(1624789), // Rule ID 3783 //
     /* 1624708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1624716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1624719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1624722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1624725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1624731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624754 */     // MIs[0] policy
     /* 1624754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624764 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1624767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624788 */     // GIR_Coverage, 3783,
     /* 1624788 */     GIR_EraseRootFromParent_Done,
     /* 1624789 */   // Label 22396: @1624789
     /* 1624789 */   GIM_Try, /*On fail goto*//*Label 22397*/ GIMT_Encode4(1624875), // Rule ID 3786 //
     /* 1624794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1624802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1624805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1624808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1624811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624840 */     // MIs[0] policy
     /* 1624840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624850 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1624853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624874 */     // GIR_Coverage, 3786,
     /* 1624874 */     GIR_EraseRootFromParent_Done,
     /* 1624875 */   // Label 22397: @1624875
     /* 1624875 */   GIM_Try, /*On fail goto*//*Label 22398*/ GIMT_Encode4(1624961), // Rule ID 3787 //
     /* 1624880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1624888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1624891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1624894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1624897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624926 */     // MIs[0] policy
     /* 1624926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624936 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1624939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624960 */     // GIR_Coverage, 3787,
     /* 1624960 */     GIR_EraseRootFromParent_Done,
     /* 1624961 */   // Label 22398: @1624961
     /* 1624961 */   GIM_Try, /*On fail goto*//*Label 22399*/ GIMT_Encode4(1625047), // Rule ID 3790 //
     /* 1624966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1624974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1624977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1624980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1624983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625012 */     // MIs[0] policy
     /* 1625012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625022 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1625025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625046 */     // GIR_Coverage, 3790,
     /* 1625046 */     GIR_EraseRootFromParent_Done,
     /* 1625047 */   // Label 22399: @1625047
     /* 1625047 */   GIM_Try, /*On fail goto*//*Label 22400*/ GIMT_Encode4(1625133), // Rule ID 3791 //
     /* 1625052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1625060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1625063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1625066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1625069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625098 */     // MIs[0] policy
     /* 1625098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625108 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1625111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625132 */     // GIR_Coverage, 3791,
     /* 1625132 */     GIR_EraseRootFromParent_Done,
     /* 1625133 */   // Label 22400: @1625133
     /* 1625133 */   GIM_Try, /*On fail goto*//*Label 22401*/ GIMT_Encode4(1625219), // Rule ID 3794 //
     /* 1625138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1625146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1625149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1625152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1625155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625184 */     // MIs[0] policy
     /* 1625184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625194 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1625197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625218 */     // GIR_Coverage, 3794,
     /* 1625218 */     GIR_EraseRootFromParent_Done,
     /* 1625219 */   // Label 22401: @1625219
     /* 1625219 */   GIM_Try, /*On fail goto*//*Label 22402*/ GIMT_Encode4(1625305), // Rule ID 3795 //
     /* 1625224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1625232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1625235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1625238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1625241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625270 */     // MIs[0] policy
     /* 1625270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1625283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625304 */     // GIR_Coverage, 3795,
     /* 1625304 */     GIR_EraseRootFromParent_Done,
     /* 1625305 */   // Label 22402: @1625305
     /* 1625305 */   GIM_Try, /*On fail goto*//*Label 22403*/ GIMT_Encode4(1625391), // Rule ID 3798 //
     /* 1625310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1625318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1625321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1625324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1625327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625356 */     // MIs[0] policy
     /* 1625356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625366 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1625369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625390 */     // GIR_Coverage, 3798,
     /* 1625390 */     GIR_EraseRootFromParent_Done,
     /* 1625391 */   // Label 22403: @1625391
     /* 1625391 */   GIM_Try, /*On fail goto*//*Label 22404*/ GIMT_Encode4(1625477), // Rule ID 3799 //
     /* 1625396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1625404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1625407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1625410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1625413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625442 */     // MIs[0] policy
     /* 1625442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625452 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1625455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625476 */     // GIR_Coverage, 3799,
     /* 1625476 */     GIR_EraseRootFromParent_Done,
     /* 1625477 */   // Label 22404: @1625477
     /* 1625477 */   GIM_Try, /*On fail goto*//*Label 22405*/ GIMT_Encode4(1625563), // Rule ID 3802 //
     /* 1625482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1625490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1625493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1625496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1625499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1625505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625528 */     // MIs[0] policy
     /* 1625528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625538 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1625541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625562 */     // GIR_Coverage, 3802,
     /* 1625562 */     GIR_EraseRootFromParent_Done,
     /* 1625563 */   // Label 22405: @1625563
     /* 1625563 */   GIM_Try, /*On fail goto*//*Label 22406*/ GIMT_Encode4(1625649), // Rule ID 3803 //
     /* 1625568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1625576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1625579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1625582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1625585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1625591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625614 */     // MIs[0] policy
     /* 1625614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625624 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1625627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625648 */     // GIR_Coverage, 3803,
     /* 1625648 */     GIR_EraseRootFromParent_Done,
     /* 1625649 */   // Label 22406: @1625649
     /* 1625649 */   GIM_Try, /*On fail goto*//*Label 22407*/ GIMT_Encode4(1625735), // Rule ID 3806 //
     /* 1625654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1625657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1625662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1625665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1625668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1625671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625700 */     // MIs[0] policy
     /* 1625700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625710 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1625713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625734 */     // GIR_Coverage, 3806,
     /* 1625734 */     GIR_EraseRootFromParent_Done,
     /* 1625735 */   // Label 22407: @1625735
     /* 1625735 */   GIM_Try, /*On fail goto*//*Label 22408*/ GIMT_Encode4(1625821), // Rule ID 3807 //
     /* 1625740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1625748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1625751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1625754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1625757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625786 */     // MIs[0] policy
     /* 1625786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625796 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1625799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625820 */     // GIR_Coverage, 3807,
     /* 1625820 */     GIR_EraseRootFromParent_Done,
     /* 1625821 */   // Label 22408: @1625821
     /* 1625821 */   GIM_Try, /*On fail goto*//*Label 22409*/ GIMT_Encode4(1625907), // Rule ID 3810 //
     /* 1625826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1625829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1625834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1625837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1625840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1625843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625872 */     // MIs[0] policy
     /* 1625872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1625885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625906 */     // GIR_Coverage, 3810,
     /* 1625906 */     GIR_EraseRootFromParent_Done,
     /* 1625907 */   // Label 22409: @1625907
     /* 1625907 */   GIM_Try, /*On fail goto*//*Label 22410*/ GIMT_Encode4(1625993), // Rule ID 3811 //
     /* 1625912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1625920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1625923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1625926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1625929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625958 */     // MIs[0] policy
     /* 1625958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1625971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625992 */     // GIR_Coverage, 3811,
     /* 1625992 */     GIR_EraseRootFromParent_Done,
     /* 1625993 */   // Label 22410: @1625993
     /* 1625993 */   GIM_Try, /*On fail goto*//*Label 22411*/ GIMT_Encode4(1626079), // Rule ID 3814 //
     /* 1625998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1626001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1626006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1626009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1626012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1626015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626044 */     // MIs[0] policy
     /* 1626044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626054 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1626057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1626075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626078 */     // GIR_Coverage, 3814,
     /* 1626078 */     GIR_EraseRootFromParent_Done,
     /* 1626079 */   // Label 22411: @1626079
     /* 1626079 */   GIM_Try, /*On fail goto*//*Label 22412*/ GIMT_Encode4(1626165), // Rule ID 3815 //
     /* 1626084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1626087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1626092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1626095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1626098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1626101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626130 */     // MIs[0] policy
     /* 1626130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626140 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1626143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1626161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626164 */     // GIR_Coverage, 3815,
     /* 1626164 */     GIR_EraseRootFromParent_Done,
     /* 1626165 */   // Label 22412: @1626165
     /* 1626165 */   GIM_Try, /*On fail goto*//*Label 22413*/ GIMT_Encode4(1626251), // Rule ID 3818 //
     /* 1626170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1626173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1626178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1626181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1626184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1626187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626216 */     // MIs[0] policy
     /* 1626216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626226 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1626229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1626247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626250 */     // GIR_Coverage, 3818,
     /* 1626250 */     GIR_EraseRootFromParent_Done,
     /* 1626251 */   // Label 22413: @1626251
     /* 1626251 */   GIM_Try, /*On fail goto*//*Label 22414*/ GIMT_Encode4(1626337), // Rule ID 3819 //
     /* 1626256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1626259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1626264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1626267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1626270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1626273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626302 */     // MIs[0] policy
     /* 1626302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626312 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1626315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1626333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626336 */     // GIR_Coverage, 3819,
     /* 1626336 */     GIR_EraseRootFromParent_Done,
     /* 1626337 */   // Label 22414: @1626337
     /* 1626337 */   GIM_Try, /*On fail goto*//*Label 22415*/ GIMT_Encode4(1626423), // Rule ID 3822 //
     /* 1626342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1626353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1626356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1626359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1626362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1626365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626388 */     // MIs[0] policy
     /* 1626388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626398 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1626401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626422 */     // GIR_Coverage, 3822,
     /* 1626422 */     GIR_EraseRootFromParent_Done,
     /* 1626423 */   // Label 22415: @1626423
     /* 1626423 */   GIM_Try, /*On fail goto*//*Label 22416*/ GIMT_Encode4(1626509), // Rule ID 3823 //
     /* 1626428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1626439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1626442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1626445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1626448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1626451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626474 */     // MIs[0] policy
     /* 1626474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1626487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626508 */     // GIR_Coverage, 3823,
     /* 1626508 */     GIR_EraseRootFromParent_Done,
     /* 1626509 */   // Label 22416: @1626509
     /* 1626509 */   GIM_Try, /*On fail goto*//*Label 22417*/ GIMT_Encode4(1626595), // Rule ID 3826 //
     /* 1626514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1626525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1626528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1626531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1626534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626560 */     // MIs[0] policy
     /* 1626560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626570 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1626573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626594 */     // GIR_Coverage, 3826,
     /* 1626594 */     GIR_EraseRootFromParent_Done,
     /* 1626595 */   // Label 22417: @1626595
     /* 1626595 */   GIM_Try, /*On fail goto*//*Label 22418*/ GIMT_Encode4(1626681), // Rule ID 3827 //
     /* 1626600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1626611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1626614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1626617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1626620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626646 */     // MIs[0] policy
     /* 1626646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626656 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1626659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626680 */     // GIR_Coverage, 3827,
     /* 1626680 */     GIR_EraseRootFromParent_Done,
     /* 1626681 */   // Label 22418: @1626681
     /* 1626681 */   GIM_Try, /*On fail goto*//*Label 22419*/ GIMT_Encode4(1626767), // Rule ID 3830 //
     /* 1626686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1626697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1626700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1626703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1626706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626732 */     // MIs[0] policy
     /* 1626732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626742 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1626745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626766 */     // GIR_Coverage, 3830,
     /* 1626766 */     GIR_EraseRootFromParent_Done,
     /* 1626767 */   // Label 22419: @1626767
     /* 1626767 */   GIM_Try, /*On fail goto*//*Label 22420*/ GIMT_Encode4(1626853), // Rule ID 3831 //
     /* 1626772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1626783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1626786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1626789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1626792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626818 */     // MIs[0] policy
     /* 1626818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626828 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1626831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626852 */     // GIR_Coverage, 3831,
     /* 1626852 */     GIR_EraseRootFromParent_Done,
     /* 1626853 */   // Label 22420: @1626853
     /* 1626853 */   GIM_Try, /*On fail goto*//*Label 22421*/ GIMT_Encode4(1626939), // Rule ID 3834 //
     /* 1626858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1626869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1626872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1626875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1626878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626904 */     // MIs[0] policy
     /* 1626904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1626917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626938 */     // GIR_Coverage, 3834,
     /* 1626938 */     GIR_EraseRootFromParent_Done,
     /* 1626939 */   // Label 22421: @1626939
     /* 1626939 */   GIM_Try, /*On fail goto*//*Label 22422*/ GIMT_Encode4(1627025), // Rule ID 3835 //
     /* 1626944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1626955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1626958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1626961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1626964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626990 */     // MIs[0] policy
     /* 1626990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627000 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1627003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627024 */     // GIR_Coverage, 3835,
     /* 1627024 */     GIR_EraseRootFromParent_Done,
     /* 1627025 */   // Label 22422: @1627025
     /* 1627025 */   GIM_Try, /*On fail goto*//*Label 22423*/ GIMT_Encode4(1627111), // Rule ID 3838 //
     /* 1627030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1627041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1627044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1627047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1627050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1627053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627076 */     // MIs[0] policy
     /* 1627076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627086 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1627089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627110 */     // GIR_Coverage, 3838,
     /* 1627110 */     GIR_EraseRootFromParent_Done,
     /* 1627111 */   // Label 22423: @1627111
     /* 1627111 */   GIM_Try, /*On fail goto*//*Label 22424*/ GIMT_Encode4(1627197), // Rule ID 3839 //
     /* 1627116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1627127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1627130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1627133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1627136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1627139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627162 */     // MIs[0] policy
     /* 1627162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627172 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1627175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627196 */     // GIR_Coverage, 3839,
     /* 1627196 */     GIR_EraseRootFromParent_Done,
     /* 1627197 */   // Label 22424: @1627197
     /* 1627197 */   GIM_Try, /*On fail goto*//*Label 22425*/ GIMT_Encode4(1627283), // Rule ID 3842 //
     /* 1627202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1627213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1627216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1627219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1627222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1627225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627248 */     // MIs[0] policy
     /* 1627248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627258 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1627261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627282 */     // GIR_Coverage, 3842,
     /* 1627282 */     GIR_EraseRootFromParent_Done,
     /* 1627283 */   // Label 22425: @1627283
     /* 1627283 */   GIM_Try, /*On fail goto*//*Label 22426*/ GIMT_Encode4(1627369), // Rule ID 3843 //
     /* 1627288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1627299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1627302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1627305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1627308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1627311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627334 */     // MIs[0] policy
     /* 1627334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627344 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1627347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627368 */     // GIR_Coverage, 3843,
     /* 1627368 */     GIR_EraseRootFromParent_Done,
     /* 1627369 */   // Label 22426: @1627369
     /* 1627369 */   GIM_Try, /*On fail goto*//*Label 22427*/ GIMT_Encode4(1627455), // Rule ID 3846 //
     /* 1627374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1627385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1627388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1627391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1627394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627420 */     // MIs[0] policy
     /* 1627420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627430 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1627433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627454 */     // GIR_Coverage, 3846,
     /* 1627454 */     GIR_EraseRootFromParent_Done,
     /* 1627455 */   // Label 22427: @1627455
     /* 1627455 */   GIM_Try, /*On fail goto*//*Label 22428*/ GIMT_Encode4(1627541), // Rule ID 3847 //
     /* 1627460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1627471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1627474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1627477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1627480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627506 */     // MIs[0] policy
     /* 1627506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627516 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1627519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627540 */     // GIR_Coverage, 3847,
     /* 1627540 */     GIR_EraseRootFromParent_Done,
     /* 1627541 */   // Label 22428: @1627541
     /* 1627541 */   GIM_Try, /*On fail goto*//*Label 22429*/ GIMT_Encode4(1627627), // Rule ID 3850 //
     /* 1627546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1627557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1627560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1627563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1627566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627592 */     // MIs[0] policy
     /* 1627592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1627605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627626 */     // GIR_Coverage, 3850,
     /* 1627626 */     GIR_EraseRootFromParent_Done,
     /* 1627627 */   // Label 22429: @1627627
     /* 1627627 */   GIM_Try, /*On fail goto*//*Label 22430*/ GIMT_Encode4(1627713), // Rule ID 3851 //
     /* 1627632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1627643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1627646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1627649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1627652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627678 */     // MIs[0] policy
     /* 1627678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627688 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1627691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627712 */     // GIR_Coverage, 3851,
     /* 1627712 */     GIR_EraseRootFromParent_Done,
     /* 1627713 */   // Label 22430: @1627713
     /* 1627713 */   GIM_Try, /*On fail goto*//*Label 22431*/ GIMT_Encode4(1627799), // Rule ID 3854 //
     /* 1627718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1627729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1627732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1627735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1627738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627764 */     // MIs[0] policy
     /* 1627764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627774 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1627777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627798 */     // GIR_Coverage, 3854,
     /* 1627798 */     GIR_EraseRootFromParent_Done,
     /* 1627799 */   // Label 22431: @1627799
     /* 1627799 */   GIM_Try, /*On fail goto*//*Label 22432*/ GIMT_Encode4(1627885), // Rule ID 3855 //
     /* 1627804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1627815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1627818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1627821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1627824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627850 */     // MIs[0] policy
     /* 1627850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627860 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1627863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627884 */     // GIR_Coverage, 3855,
     /* 1627884 */     GIR_EraseRootFromParent_Done,
     /* 1627885 */   // Label 22432: @1627885
     /* 1627885 */   GIM_Try, /*On fail goto*//*Label 22433*/ GIMT_Encode4(1627971), // Rule ID 3858 //
     /* 1627890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1627901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1627904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1627907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1627910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627936 */     // MIs[0] policy
     /* 1627936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1627949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627970 */     // GIR_Coverage, 3858,
     /* 1627970 */     GIR_EraseRootFromParent_Done,
     /* 1627971 */   // Label 22433: @1627971
     /* 1627971 */   GIM_Try, /*On fail goto*//*Label 22434*/ GIMT_Encode4(1628057), // Rule ID 3859 //
     /* 1627976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1627987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1627990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1627993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1627996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628022 */     // MIs[0] policy
     /* 1628022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628032 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1628035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628056 */     // GIR_Coverage, 3859,
     /* 1628056 */     GIR_EraseRootFromParent_Done,
     /* 1628057 */   // Label 22434: @1628057
     /* 1628057 */   GIM_Try, /*On fail goto*//*Label 22435*/ GIMT_Encode4(1628143), // Rule ID 3862 //
     /* 1628062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1628070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1628073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1628076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1628079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1628082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1628085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628108 */     // MIs[0] policy
     /* 1628108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1628121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628142 */     // GIR_Coverage, 3862,
     /* 1628142 */     GIR_EraseRootFromParent_Done,
     /* 1628143 */   // Label 22435: @1628143
     /* 1628143 */   GIM_Try, /*On fail goto*//*Label 22436*/ GIMT_Encode4(1628229), // Rule ID 3863 //
     /* 1628148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1628156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1628159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1628162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1628165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1628168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1628171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628194 */     // MIs[0] policy
     /* 1628194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628204 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1628207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628228 */     // GIR_Coverage, 3863,
     /* 1628228 */     GIR_EraseRootFromParent_Done,
     /* 1628229 */   // Label 22436: @1628229
     /* 1628229 */   GIM_Try, /*On fail goto*//*Label 22437*/ GIMT_Encode4(1628315), // Rule ID 3866 //
     /* 1628234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1628237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1628242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1628245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1628248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1628251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1628254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628280 */     // MIs[0] policy
     /* 1628280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1628293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628314 */     // GIR_Coverage, 3866,
     /* 1628314 */     GIR_EraseRootFromParent_Done,
     /* 1628315 */   // Label 22437: @1628315
     /* 1628315 */   GIM_Try, /*On fail goto*//*Label 22438*/ GIMT_Encode4(1628401), // Rule ID 3867 //
     /* 1628320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1628323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1628328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1628331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1628334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1628337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1628340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628366 */     // MIs[0] policy
     /* 1628366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628376 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1628379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628400 */     // GIR_Coverage, 3867,
     /* 1628400 */     GIR_EraseRootFromParent_Done,
     /* 1628401 */   // Label 22438: @1628401
     /* 1628401 */   GIM_Try, /*On fail goto*//*Label 22439*/ GIMT_Encode4(1628487), // Rule ID 3870 //
     /* 1628406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1628409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1628414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1628417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1628420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1628423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1628426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628452 */     // MIs[0] policy
     /* 1628452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628462 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1628465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628486 */     // GIR_Coverage, 3870,
     /* 1628486 */     GIR_EraseRootFromParent_Done,
     /* 1628487 */   // Label 22439: @1628487
     /* 1628487 */   GIM_Try, /*On fail goto*//*Label 22440*/ GIMT_Encode4(1628573), // Rule ID 3871 //
     /* 1628492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1628495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1628500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1628503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1628506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1628509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1628512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628538 */     // MIs[0] policy
     /* 1628538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628548 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1628551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628572 */     // GIR_Coverage, 3871,
     /* 1628572 */     GIR_EraseRootFromParent_Done,
     /* 1628573 */   // Label 22440: @1628573
     /* 1628573 */   GIM_Try, /*On fail goto*//*Label 22441*/ GIMT_Encode4(1628659), // Rule ID 3874 //
     /* 1628578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1628581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1628586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1628589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1628592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1628595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1628598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628624 */     // MIs[0] policy
     /* 1628624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1628637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628658 */     // GIR_Coverage, 3874,
     /* 1628658 */     GIR_EraseRootFromParent_Done,
     /* 1628659 */   // Label 22441: @1628659
     /* 1628659 */   GIM_Try, /*On fail goto*//*Label 22442*/ GIMT_Encode4(1628745), // Rule ID 3875 //
     /* 1628664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1628667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1628672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1628675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1628678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1628681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1628684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628710 */     // MIs[0] policy
     /* 1628710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1628723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628744 */     // GIR_Coverage, 3875,
     /* 1628744 */     GIR_EraseRootFromParent_Done,
     /* 1628745 */   // Label 22442: @1628745
     /* 1628745 */   GIM_Try, /*On fail goto*//*Label 22443*/ GIMT_Encode4(1628831), // Rule ID 3878 //
     /* 1628750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1628753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1628758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1628761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1628764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1628767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1628770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628796 */     // MIs[0] policy
     /* 1628796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1628809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628830 */     // GIR_Coverage, 3878,
     /* 1628830 */     GIR_EraseRootFromParent_Done,
     /* 1628831 */   // Label 22443: @1628831
     /* 1628831 */   GIM_Try, /*On fail goto*//*Label 22444*/ GIMT_Encode4(1628917), // Rule ID 3879 //
     /* 1628836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1628839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1628844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1628847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1628850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1628853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1628856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628882 */     // MIs[0] policy
     /* 1628882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628892 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1628895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628916 */     // GIR_Coverage, 3879,
     /* 1628916 */     GIR_EraseRootFromParent_Done,
     /* 1628917 */   // Label 22444: @1628917
     /* 1628917 */   GIM_Try, /*On fail goto*//*Label 22445*/ GIMT_Encode4(1629003), // Rule ID 3882 //
     /* 1628922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1628930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1628933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1628936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1628939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628968 */     // MIs[0] policy
     /* 1628968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628978 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1628981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629002 */     // GIR_Coverage, 3882,
     /* 1629002 */     GIR_EraseRootFromParent_Done,
     /* 1629003 */   // Label 22445: @1629003
     /* 1629003 */   GIM_Try, /*On fail goto*//*Label 22446*/ GIMT_Encode4(1629089), // Rule ID 3883 //
     /* 1629008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1629016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1629019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1629022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1629025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629054 */     // MIs[0] policy
     /* 1629054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629064 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1629067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629088 */     // GIR_Coverage, 3883,
     /* 1629088 */     GIR_EraseRootFromParent_Done,
     /* 1629089 */   // Label 22446: @1629089
     /* 1629089 */   GIM_Try, /*On fail goto*//*Label 22447*/ GIMT_Encode4(1629175), // Rule ID 3886 //
     /* 1629094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1629102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1629105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1629108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1629111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629140 */     // MIs[0] policy
     /* 1629140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629150 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1629153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629174 */     // GIR_Coverage, 3886,
     /* 1629174 */     GIR_EraseRootFromParent_Done,
     /* 1629175 */   // Label 22447: @1629175
     /* 1629175 */   GIM_Try, /*On fail goto*//*Label 22448*/ GIMT_Encode4(1629261), // Rule ID 3887 //
     /* 1629180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1629188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1629191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1629194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1629197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629226 */     // MIs[0] policy
     /* 1629226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629236 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1629239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629260 */     // GIR_Coverage, 3887,
     /* 1629260 */     GIR_EraseRootFromParent_Done,
     /* 1629261 */   // Label 22448: @1629261
     /* 1629261 */   GIM_Try, /*On fail goto*//*Label 22449*/ GIMT_Encode4(1629347), // Rule ID 3890 //
     /* 1629266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1629274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1629277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1629280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1629283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629312 */     // MIs[0] policy
     /* 1629312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629322 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1629325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629346 */     // GIR_Coverage, 3890,
     /* 1629346 */     GIR_EraseRootFromParent_Done,
     /* 1629347 */   // Label 22449: @1629347
     /* 1629347 */   GIM_Try, /*On fail goto*//*Label 22450*/ GIMT_Encode4(1629433), // Rule ID 3891 //
     /* 1629352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1629360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1629363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1629366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1629369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629398 */     // MIs[0] policy
     /* 1629398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629408 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1629411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629432 */     // GIR_Coverage, 3891,
     /* 1629432 */     GIR_EraseRootFromParent_Done,
     /* 1629433 */   // Label 22450: @1629433
     /* 1629433 */   GIM_Try, /*On fail goto*//*Label 22451*/ GIMT_Encode4(1629519), // Rule ID 3894 //
     /* 1629438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1629446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1629449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1629452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1629455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629484 */     // MIs[0] policy
     /* 1629484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1629497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629518 */     // GIR_Coverage, 3894,
     /* 1629518 */     GIR_EraseRootFromParent_Done,
     /* 1629519 */   // Label 22451: @1629519
     /* 1629519 */   GIM_Try, /*On fail goto*//*Label 22452*/ GIMT_Encode4(1629605), // Rule ID 3895 //
     /* 1629524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1629532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1629535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1629538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1629541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629570 */     // MIs[0] policy
     /* 1629570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629580 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1629583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629604 */     // GIR_Coverage, 3895,
     /* 1629604 */     GIR_EraseRootFromParent_Done,
     /* 1629605 */   // Label 22452: @1629605
     /* 1629605 */   GIM_Try, /*On fail goto*//*Label 22453*/ GIMT_Encode4(1629691), // Rule ID 3898 //
     /* 1629610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1629618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1629621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1629624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1629627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629656 */     // MIs[0] policy
     /* 1629656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629666 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1629669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629690 */     // GIR_Coverage, 3898,
     /* 1629690 */     GIR_EraseRootFromParent_Done,
     /* 1629691 */   // Label 22453: @1629691
     /* 1629691 */   GIM_Try, /*On fail goto*//*Label 22454*/ GIMT_Encode4(1629777), // Rule ID 3899 //
     /* 1629696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1629704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1629707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1629710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1629713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629742 */     // MIs[0] policy
     /* 1629742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629752 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1629755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629776 */     // GIR_Coverage, 3899,
     /* 1629776 */     GIR_EraseRootFromParent_Done,
     /* 1629777 */   // Label 22454: @1629777
     /* 1629777 */   GIM_Try, /*On fail goto*//*Label 22455*/ GIMT_Encode4(1629863), // Rule ID 3902 //
     /* 1629782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1629790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1629793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1629796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1629799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1629805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629828 */     // MIs[0] policy
     /* 1629828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629838 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1629841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629862 */     // GIR_Coverage, 3902,
     /* 1629862 */     GIR_EraseRootFromParent_Done,
     /* 1629863 */   // Label 22455: @1629863
     /* 1629863 */   GIM_Try, /*On fail goto*//*Label 22456*/ GIMT_Encode4(1629949), // Rule ID 3903 //
     /* 1629868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1629876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1629879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1629882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1629885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1629891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629914 */     // MIs[0] policy
     /* 1629914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629924 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1629927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629948 */     // GIR_Coverage, 3903,
     /* 1629948 */     GIR_EraseRootFromParent_Done,
     /* 1629949 */   // Label 22456: @1629949
     /* 1629949 */   GIM_Try, /*On fail goto*//*Label 22457*/ GIMT_Encode4(1630035), // Rule ID 3906 //
     /* 1629954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1629962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1629965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1629968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1629971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630000 */     // MIs[0] policy
     /* 1630000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630010 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1630013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630034 */     // GIR_Coverage, 3906,
     /* 1630034 */     GIR_EraseRootFromParent_Done,
     /* 1630035 */   // Label 22457: @1630035
     /* 1630035 */   GIM_Try, /*On fail goto*//*Label 22458*/ GIMT_Encode4(1630121), // Rule ID 3907 //
     /* 1630040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1630048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1630051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1630054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1630057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630086 */     // MIs[0] policy
     /* 1630086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630096 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1630099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630120 */     // GIR_Coverage, 3907,
     /* 1630120 */     GIR_EraseRootFromParent_Done,
     /* 1630121 */   // Label 22458: @1630121
     /* 1630121 */   GIM_Try, /*On fail goto*//*Label 22459*/ GIMT_Encode4(1630207), // Rule ID 3910 //
     /* 1630126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1630134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1630137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1630140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1630143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630172 */     // MIs[0] policy
     /* 1630172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630182 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1630185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630206 */     // GIR_Coverage, 3910,
     /* 1630206 */     GIR_EraseRootFromParent_Done,
     /* 1630207 */   // Label 22459: @1630207
     /* 1630207 */   GIM_Try, /*On fail goto*//*Label 22460*/ GIMT_Encode4(1630293), // Rule ID 3911 //
     /* 1630212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1630220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1630223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1630226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1630229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630258 */     // MIs[0] policy
     /* 1630258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630268 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1630271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630292 */     // GIR_Coverage, 3911,
     /* 1630292 */     GIR_EraseRootFromParent_Done,
     /* 1630293 */   // Label 22460: @1630293
     /* 1630293 */   GIM_Try, /*On fail goto*//*Label 22461*/ GIMT_Encode4(1630379), // Rule ID 3914 //
     /* 1630298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1630306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1630309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1630312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1630315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630344 */     // MIs[0] policy
     /* 1630344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630354 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1630357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630378 */     // GIR_Coverage, 3914,
     /* 1630378 */     GIR_EraseRootFromParent_Done,
     /* 1630379 */   // Label 22461: @1630379
     /* 1630379 */   GIM_Try, /*On fail goto*//*Label 22462*/ GIMT_Encode4(1630465), // Rule ID 3915 //
     /* 1630384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1630392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1630395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1630398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1630401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630430 */     // MIs[0] policy
     /* 1630430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1630443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630464 */     // GIR_Coverage, 3915,
     /* 1630464 */     GIR_EraseRootFromParent_Done,
     /* 1630465 */   // Label 22462: @1630465
     /* 1630465 */   GIM_Try, /*On fail goto*//*Label 22463*/ GIMT_Encode4(1630551), // Rule ID 3918 //
     /* 1630470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1630478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1630481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1630484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1630487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630516 */     // MIs[0] policy
     /* 1630516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630526 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1630529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630550 */     // GIR_Coverage, 3918,
     /* 1630550 */     GIR_EraseRootFromParent_Done,
     /* 1630551 */   // Label 22463: @1630551
     /* 1630551 */   GIM_Try, /*On fail goto*//*Label 22464*/ GIMT_Encode4(1630637), // Rule ID 3919 //
     /* 1630556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1630564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1630567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1630570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1630573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630602 */     // MIs[0] policy
     /* 1630602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630612 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1630615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630636 */     // GIR_Coverage, 3919,
     /* 1630636 */     GIR_EraseRootFromParent_Done,
     /* 1630637 */   // Label 22464: @1630637
     /* 1630637 */   GIM_Try, /*On fail goto*//*Label 22465*/ GIMT_Encode4(1630723), // Rule ID 3922 //
     /* 1630642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1630650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1630653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1630656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1630659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1630665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630688 */     // MIs[0] policy
     /* 1630688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630698 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1630701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630722 */     // GIR_Coverage, 3922,
     /* 1630722 */     GIR_EraseRootFromParent_Done,
     /* 1630723 */   // Label 22465: @1630723
     /* 1630723 */   GIM_Try, /*On fail goto*//*Label 22466*/ GIMT_Encode4(1630809), // Rule ID 3923 //
     /* 1630728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1630736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1630739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1630742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1630745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1630751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630774 */     // MIs[0] policy
     /* 1630774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630784 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1630787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630808 */     // GIR_Coverage, 3923,
     /* 1630808 */     GIR_EraseRootFromParent_Done,
     /* 1630809 */   // Label 22466: @1630809
     /* 1630809 */   GIM_Try, /*On fail goto*//*Label 22467*/ GIMT_Encode4(1630895), // Rule ID 3926 //
     /* 1630814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1630822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1630825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1630828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1630831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630860 */     // MIs[0] policy
     /* 1630860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630870 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1630873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630894 */     // GIR_Coverage, 3926,
     /* 1630894 */     GIR_EraseRootFromParent_Done,
     /* 1630895 */   // Label 22467: @1630895
     /* 1630895 */   GIM_Try, /*On fail goto*//*Label 22468*/ GIMT_Encode4(1630981), // Rule ID 3927 //
     /* 1630900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1630908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1630911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1630914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1630917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630946 */     // MIs[0] policy
     /* 1630946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630956 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1630959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630980 */     // GIR_Coverage, 3927,
     /* 1630980 */     GIR_EraseRootFromParent_Done,
     /* 1630981 */   // Label 22468: @1630981
     /* 1630981 */   GIM_Try, /*On fail goto*//*Label 22469*/ GIMT_Encode4(1631067), // Rule ID 3930 //
     /* 1630986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1630994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1630997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1631000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1631003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631032 */     // MIs[0] policy
     /* 1631032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631042 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1631045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1631063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631066 */     // GIR_Coverage, 3930,
     /* 1631066 */     GIR_EraseRootFromParent_Done,
     /* 1631067 */   // Label 22469: @1631067
     /* 1631067 */   GIM_Try, /*On fail goto*//*Label 22470*/ GIMT_Encode4(1631153), // Rule ID 3931 //
     /* 1631072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1631075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1631080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1631083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1631086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1631089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631118 */     // MIs[0] policy
     /* 1631118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631128 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1631131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1631149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631152 */     // GIR_Coverage, 3931,
     /* 1631152 */     GIR_EraseRootFromParent_Done,
     /* 1631153 */   // Label 22470: @1631153
     /* 1631153 */   GIM_Try, /*On fail goto*//*Label 22471*/ GIMT_Encode4(1631239), // Rule ID 3934 //
     /* 1631158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1631161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1631166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1631169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1631172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1631175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631204 */     // MIs[0] policy
     /* 1631204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631214 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1631217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1631235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631238 */     // GIR_Coverage, 3934,
     /* 1631238 */     GIR_EraseRootFromParent_Done,
     /* 1631239 */   // Label 22471: @1631239
     /* 1631239 */   GIM_Try, /*On fail goto*//*Label 22472*/ GIMT_Encode4(1631325), // Rule ID 3935 //
     /* 1631244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1631247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1631252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1631255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1631258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1631261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631290 */     // MIs[0] policy
     /* 1631290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631300 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1631303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1631321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631324 */     // GIR_Coverage, 3935,
     /* 1631324 */     GIR_EraseRootFromParent_Done,
     /* 1631325 */   // Label 22472: @1631325
     /* 1631325 */   GIM_Try, /*On fail goto*//*Label 22473*/ GIMT_Encode4(1631411), // Rule ID 3938 //
     /* 1631330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1631333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1631338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1631341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1631344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1631347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631376 */     // MIs[0] policy
     /* 1631376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1631389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1631407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631410 */     // GIR_Coverage, 3938,
     /* 1631410 */     GIR_EraseRootFromParent_Done,
     /* 1631411 */   // Label 22473: @1631411
     /* 1631411 */   GIM_Try, /*On fail goto*//*Label 22474*/ GIMT_Encode4(1631497), // Rule ID 3939 //
     /* 1631416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1631419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1631424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1631427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1631430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1631433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631462 */     // MIs[0] policy
     /* 1631462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631472 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1631475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1631493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631496 */     // GIR_Coverage, 3939,
     /* 1631496 */     GIR_EraseRootFromParent_Done,
     /* 1631497 */   // Label 22474: @1631497
     /* 1631497 */   GIM_Try, /*On fail goto*//*Label 22475*/ GIMT_Encode4(1631583), // Rule ID 3942 //
     /* 1631502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1631513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1631516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1631519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1631522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631548 */     // MIs[0] policy
     /* 1631548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631558 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1631561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631582 */     // GIR_Coverage, 3942,
     /* 1631582 */     GIR_EraseRootFromParent_Done,
     /* 1631583 */   // Label 22475: @1631583
     /* 1631583 */   GIM_Try, /*On fail goto*//*Label 22476*/ GIMT_Encode4(1631669), // Rule ID 3943 //
     /* 1631588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1631599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1631602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1631605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1631608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631634 */     // MIs[0] policy
     /* 1631634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631644 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1631647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631668 */     // GIR_Coverage, 3943,
     /* 1631668 */     GIR_EraseRootFromParent_Done,
     /* 1631669 */   // Label 22476: @1631669
     /* 1631669 */   GIM_Try, /*On fail goto*//*Label 22477*/ GIMT_Encode4(1631755), // Rule ID 3946 //
     /* 1631674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1631685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1631688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1631691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1631694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631720 */     // MIs[0] policy
     /* 1631720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631730 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1631733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631754 */     // GIR_Coverage, 3946,
     /* 1631754 */     GIR_EraseRootFromParent_Done,
     /* 1631755 */   // Label 22477: @1631755
     /* 1631755 */   GIM_Try, /*On fail goto*//*Label 22478*/ GIMT_Encode4(1631841), // Rule ID 3947 //
     /* 1631760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1631771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1631774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1631777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1631780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631806 */     // MIs[0] policy
     /* 1631806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631816 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1631819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631840 */     // GIR_Coverage, 3947,
     /* 1631840 */     GIR_EraseRootFromParent_Done,
     /* 1631841 */   // Label 22478: @1631841
     /* 1631841 */   GIM_Try, /*On fail goto*//*Label 22479*/ GIMT_Encode4(1631927), // Rule ID 3950 //
     /* 1631846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1631857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1631860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1631863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1631866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631892 */     // MIs[0] policy
     /* 1631892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1631905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631926 */     // GIR_Coverage, 3950,
     /* 1631926 */     GIR_EraseRootFromParent_Done,
     /* 1631927 */   // Label 22479: @1631927
     /* 1631927 */   GIM_Try, /*On fail goto*//*Label 22480*/ GIMT_Encode4(1632013), // Rule ID 3951 //
     /* 1631932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1631943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1631946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1631949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1631952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631978 */     // MIs[0] policy
     /* 1631978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631988 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1631991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632012 */     // GIR_Coverage, 3951,
     /* 1632012 */     GIR_EraseRootFromParent_Done,
     /* 1632013 */   // Label 22480: @1632013
     /* 1632013 */   GIM_Try, /*On fail goto*//*Label 22481*/ GIMT_Encode4(1632099), // Rule ID 3954 //
     /* 1632018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1632029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1632032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1632035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1632038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632064 */     // MIs[0] policy
     /* 1632064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632074 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1632077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632098 */     // GIR_Coverage, 3954,
     /* 1632098 */     GIR_EraseRootFromParent_Done,
     /* 1632099 */   // Label 22481: @1632099
     /* 1632099 */   GIM_Try, /*On fail goto*//*Label 22482*/ GIMT_Encode4(1632185), // Rule ID 3955 //
     /* 1632104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1632115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1632118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1632121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1632124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632150 */     // MIs[0] policy
     /* 1632150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1632163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632184 */     // GIR_Coverage, 3955,
     /* 1632184 */     GIR_EraseRootFromParent_Done,
     /* 1632185 */   // Label 22482: @1632185
     /* 1632185 */   GIM_Try, /*On fail goto*//*Label 22483*/ GIMT_Encode4(1632271), // Rule ID 3958 //
     /* 1632190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1632201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1632204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1632207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1632210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1632213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632236 */     // MIs[0] policy
     /* 1632236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632246 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1632249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632270 */     // GIR_Coverage, 3958,
     /* 1632270 */     GIR_EraseRootFromParent_Done,
     /* 1632271 */   // Label 22483: @1632271
     /* 1632271 */   GIM_Try, /*On fail goto*//*Label 22484*/ GIMT_Encode4(1632357), // Rule ID 3959 //
     /* 1632276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1632287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1632290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1632293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1632296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1632299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632322 */     // MIs[0] policy
     /* 1632322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632332 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1632335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632356 */     // GIR_Coverage, 3959,
     /* 1632356 */     GIR_EraseRootFromParent_Done,
     /* 1632357 */   // Label 22484: @1632357
     /* 1632357 */   GIM_Try, /*On fail goto*//*Label 22485*/ GIMT_Encode4(1632443), // Rule ID 3962 //
     /* 1632362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1632373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1632376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1632379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1632382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1632385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632408 */     // MIs[0] policy
     /* 1632408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632418 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1632421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632442 */     // GIR_Coverage, 3962,
     /* 1632442 */     GIR_EraseRootFromParent_Done,
     /* 1632443 */   // Label 22485: @1632443
     /* 1632443 */   GIM_Try, /*On fail goto*//*Label 22486*/ GIMT_Encode4(1632529), // Rule ID 3963 //
     /* 1632448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1632459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1632462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1632465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1632468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1632471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632494 */     // MIs[0] policy
     /* 1632494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632504 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1632507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632528 */     // GIR_Coverage, 3963,
     /* 1632528 */     GIR_EraseRootFromParent_Done,
     /* 1632529 */   // Label 22486: @1632529
     /* 1632529 */   GIM_Try, /*On fail goto*//*Label 22487*/ GIMT_Encode4(1632615), // Rule ID 3966 //
     /* 1632534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1632545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1632548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1632551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1632554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632580 */     // MIs[0] policy
     /* 1632580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632590 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1632593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632614 */     // GIR_Coverage, 3966,
     /* 1632614 */     GIR_EraseRootFromParent_Done,
     /* 1632615 */   // Label 22487: @1632615
     /* 1632615 */   GIM_Try, /*On fail goto*//*Label 22488*/ GIMT_Encode4(1632701), // Rule ID 3967 //
     /* 1632620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1632631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1632634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1632637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1632640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632666 */     // MIs[0] policy
     /* 1632666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632676 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1632679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632700 */     // GIR_Coverage, 3967,
     /* 1632700 */     GIR_EraseRootFromParent_Done,
     /* 1632701 */   // Label 22488: @1632701
     /* 1632701 */   GIM_Try, /*On fail goto*//*Label 22489*/ GIMT_Encode4(1632787), // Rule ID 3970 //
     /* 1632706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1632717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1632720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1632723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1632726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632752 */     // MIs[0] policy
     /* 1632752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632762 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1632765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632786 */     // GIR_Coverage, 3970,
     /* 1632786 */     GIR_EraseRootFromParent_Done,
     /* 1632787 */   // Label 22489: @1632787
     /* 1632787 */   GIM_Try, /*On fail goto*//*Label 22490*/ GIMT_Encode4(1632873), // Rule ID 3971 //
     /* 1632792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1632803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1632806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1632809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1632812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632838 */     // MIs[0] policy
     /* 1632838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632848 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1632851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632872 */     // GIR_Coverage, 3971,
     /* 1632872 */     GIR_EraseRootFromParent_Done,
     /* 1632873 */   // Label 22490: @1632873
     /* 1632873 */   GIM_Try, /*On fail goto*//*Label 22491*/ GIMT_Encode4(1632959), // Rule ID 3974 //
     /* 1632878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1632889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1632892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1632895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1632898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632924 */     // MIs[0] policy
     /* 1632924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1632937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632958 */     // GIR_Coverage, 3974,
     /* 1632958 */     GIR_EraseRootFromParent_Done,
     /* 1632959 */   // Label 22491: @1632959
     /* 1632959 */   GIM_Try, /*On fail goto*//*Label 22492*/ GIMT_Encode4(1633045), // Rule ID 3975 //
     /* 1632964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1632975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1632978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1632981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1632984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633010 */     // MIs[0] policy
     /* 1633010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633020 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1633023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633044 */     // GIR_Coverage, 3975,
     /* 1633044 */     GIR_EraseRootFromParent_Done,
     /* 1633045 */   // Label 22492: @1633045
     /* 1633045 */   GIM_Try, /*On fail goto*//*Label 22493*/ GIMT_Encode4(1633131), // Rule ID 3978 //
     /* 1633050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1633061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1633064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1633070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633096 */     // MIs[0] policy
     /* 1633096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633106 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1633109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633130 */     // GIR_Coverage, 3978,
     /* 1633130 */     GIR_EraseRootFromParent_Done,
     /* 1633131 */   // Label 22493: @1633131
     /* 1633131 */   GIM_Try, /*On fail goto*//*Label 22494*/ GIMT_Encode4(1633217), // Rule ID 3979 //
     /* 1633136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1633147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1633150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1633156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633182 */     // MIs[0] policy
     /* 1633182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633192 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1633195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633216 */     // GIR_Coverage, 3979,
     /* 1633216 */     GIR_EraseRootFromParent_Done,
     /* 1633217 */   // Label 22494: @1633217
     /* 1633217 */   GIM_Try, /*On fail goto*//*Label 22495*/ GIMT_Encode4(1633303), // Rule ID 3982 //
     /* 1633222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1633233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1633236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1633242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633268 */     // MIs[0] policy
     /* 1633268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633278 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1633281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633302 */     // GIR_Coverage, 3982,
     /* 1633302 */     GIR_EraseRootFromParent_Done,
     /* 1633303 */   // Label 22495: @1633303
     /* 1633303 */   GIM_Try, /*On fail goto*//*Label 22496*/ GIMT_Encode4(1633389), // Rule ID 3983 //
     /* 1633308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1633319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1633322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1633328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633354 */     // MIs[0] policy
     /* 1633354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1633367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633388 */     // GIR_Coverage, 3983,
     /* 1633388 */     GIR_EraseRootFromParent_Done,
     /* 1633389 */   // Label 22496: @1633389
     /* 1633389 */   GIM_Try, /*On fail goto*//*Label 22497*/ GIMT_Encode4(1633475), // Rule ID 3986 //
     /* 1633394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1633397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1633405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1633408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1633411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1633414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1633417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633440 */     // MIs[0] policy
     /* 1633440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633450 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1633453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633474 */     // GIR_Coverage, 3986,
     /* 1633474 */     GIR_EraseRootFromParent_Done,
     /* 1633475 */   // Label 22497: @1633475
     /* 1633475 */   GIM_Try, /*On fail goto*//*Label 22498*/ GIMT_Encode4(1633561), // Rule ID 3987 //
     /* 1633480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1633483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1633491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1633494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1633497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1633500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1633503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633526 */     // MIs[0] policy
     /* 1633526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633536 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1633539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633560 */     // GIR_Coverage, 3987,
     /* 1633560 */     GIR_EraseRootFromParent_Done,
     /* 1633561 */   // Label 22498: @1633561
     /* 1633561 */   GIM_Try, /*On fail goto*//*Label 22499*/ GIMT_Encode4(1633647), // Rule ID 3990 //
     /* 1633566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1633569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1633577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1633580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1633583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1633586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633612 */     // MIs[0] policy
     /* 1633612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633622 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1633625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633646 */     // GIR_Coverage, 3990,
     /* 1633646 */     GIR_EraseRootFromParent_Done,
     /* 1633647 */   // Label 22499: @1633647
     /* 1633647 */   GIM_Try, /*On fail goto*//*Label 22500*/ GIMT_Encode4(1633733), // Rule ID 3991 //
     /* 1633652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1633655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1633663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1633666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1633669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1633672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633698 */     // MIs[0] policy
     /* 1633698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633708 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1633711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633732 */     // GIR_Coverage, 3991,
     /* 1633732 */     GIR_EraseRootFromParent_Done,
     /* 1633733 */   // Label 22500: @1633733
     /* 1633733 */   GIM_Try, /*On fail goto*//*Label 22501*/ GIMT_Encode4(1633819), // Rule ID 3994 //
     /* 1633738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1633741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1633749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1633752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1633755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1633758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633784 */     // MIs[0] policy
     /* 1633784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633794 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1633797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633818 */     // GIR_Coverage, 3994,
     /* 1633818 */     GIR_EraseRootFromParent_Done,
     /* 1633819 */   // Label 22501: @1633819
     /* 1633819 */   GIM_Try, /*On fail goto*//*Label 22502*/ GIMT_Encode4(1633905), // Rule ID 3995 //
     /* 1633824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1633827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1633835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1633838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1633841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1633844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633870 */     // MIs[0] policy
     /* 1633870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633880 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1633883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633904 */     // GIR_Coverage, 3995,
     /* 1633904 */     GIR_EraseRootFromParent_Done,
     /* 1633905 */   // Label 22502: @1633905
     /* 1633905 */   GIM_Try, /*On fail goto*//*Label 22503*/ GIMT_Encode4(1633991), // Rule ID 3998 //
     /* 1633910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1633913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1633921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1633924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1633927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1633930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633956 */     // MIs[0] policy
     /* 1633956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633966 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1633969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633990 */     // GIR_Coverage, 3998,
     /* 1633990 */     GIR_EraseRootFromParent_Done,
     /* 1633991 */   // Label 22503: @1633991
     /* 1633991 */   GIM_Try, /*On fail goto*//*Label 22504*/ GIMT_Encode4(1634077), // Rule ID 3999 //
     /* 1633996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1633999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1634004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1634007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1634010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1634013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1634016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634042 */     // MIs[0] policy
     /* 1634042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634052 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1634055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634076 */     // GIR_Coverage, 3999,
     /* 1634076 */     GIR_EraseRootFromParent_Done,
     /* 1634077 */   // Label 22504: @1634077
     /* 1634077 */   GIM_Try, /*On fail goto*//*Label 22505*/ GIMT_Encode4(1634163), // Rule ID 4002 //
     /* 1634082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1634090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1634093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1634096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1634099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634128 */     // MIs[0] policy
     /* 1634128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634138 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1634141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634162 */     // GIR_Coverage, 4002,
     /* 1634162 */     GIR_EraseRootFromParent_Done,
     /* 1634163 */   // Label 22505: @1634163
     /* 1634163 */   GIM_Try, /*On fail goto*//*Label 22506*/ GIMT_Encode4(1634249), // Rule ID 4003 //
     /* 1634168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1634176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1634179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1634182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1634185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634214 */     // MIs[0] policy
     /* 1634214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634224 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1634227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634248 */     // GIR_Coverage, 4003,
     /* 1634248 */     GIR_EraseRootFromParent_Done,
     /* 1634249 */   // Label 22506: @1634249
     /* 1634249 */   GIM_Try, /*On fail goto*//*Label 22507*/ GIMT_Encode4(1634335), // Rule ID 4006 //
     /* 1634254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1634262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1634265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1634268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1634271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634300 */     // MIs[0] policy
     /* 1634300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634310 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1634313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634334 */     // GIR_Coverage, 4006,
     /* 1634334 */     GIR_EraseRootFromParent_Done,
     /* 1634335 */   // Label 22507: @1634335
     /* 1634335 */   GIM_Try, /*On fail goto*//*Label 22508*/ GIMT_Encode4(1634421), // Rule ID 4007 //
     /* 1634340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1634348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1634351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1634354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1634357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634386 */     // MIs[0] policy
     /* 1634386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634396 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1634399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634420 */     // GIR_Coverage, 4007,
     /* 1634420 */     GIR_EraseRootFromParent_Done,
     /* 1634421 */   // Label 22508: @1634421
     /* 1634421 */   GIM_Try, /*On fail goto*//*Label 22509*/ GIMT_Encode4(1634507), // Rule ID 4010 //
     /* 1634426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1634434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1634437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1634440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1634443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634472 */     // MIs[0] policy
     /* 1634472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634482 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1634485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634506 */     // GIR_Coverage, 4010,
     /* 1634506 */     GIR_EraseRootFromParent_Done,
     /* 1634507 */   // Label 22509: @1634507
     /* 1634507 */   GIM_Try, /*On fail goto*//*Label 22510*/ GIMT_Encode4(1634593), // Rule ID 4011 //
     /* 1634512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1634520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1634523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1634526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1634529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634558 */     // MIs[0] policy
     /* 1634558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1634571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634592 */     // GIR_Coverage, 4011,
     /* 1634592 */     GIR_EraseRootFromParent_Done,
     /* 1634593 */   // Label 22510: @1634593
     /* 1634593 */   GIM_Try, /*On fail goto*//*Label 22511*/ GIMT_Encode4(1634679), // Rule ID 4014 //
     /* 1634598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1634606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1634609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1634612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1634615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634644 */     // MIs[0] policy
     /* 1634644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634654 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1634657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634678 */     // GIR_Coverage, 4014,
     /* 1634678 */     GIR_EraseRootFromParent_Done,
     /* 1634679 */   // Label 22511: @1634679
     /* 1634679 */   GIM_Try, /*On fail goto*//*Label 22512*/ GIMT_Encode4(1634765), // Rule ID 4015 //
     /* 1634684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1634692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1634695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1634698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1634701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634730 */     // MIs[0] policy
     /* 1634730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634740 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1634743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634764 */     // GIR_Coverage, 4015,
     /* 1634764 */     GIR_EraseRootFromParent_Done,
     /* 1634765 */   // Label 22512: @1634765
     /* 1634765 */   GIM_Try, /*On fail goto*//*Label 22513*/ GIMT_Encode4(1634851), // Rule ID 4018 //
     /* 1634770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1634778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1634781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1634784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1634787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634816 */     // MIs[0] policy
     /* 1634816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634826 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1634829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634850 */     // GIR_Coverage, 4018,
     /* 1634850 */     GIR_EraseRootFromParent_Done,
     /* 1634851 */   // Label 22513: @1634851
     /* 1634851 */   GIM_Try, /*On fail goto*//*Label 22514*/ GIMT_Encode4(1634937), // Rule ID 4019 //
     /* 1634856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1634864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1634867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1634870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1634873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634902 */     // MIs[0] policy
     /* 1634902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634912 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1634915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634936 */     // GIR_Coverage, 4019,
     /* 1634936 */     GIR_EraseRootFromParent_Done,
     /* 1634937 */   // Label 22514: @1634937
     /* 1634937 */   GIM_Try, /*On fail goto*//*Label 22515*/ GIMT_Encode4(1635023), // Rule ID 4022 //
     /* 1634942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1634950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1634953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1634956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1634959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1634965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634988 */     // MIs[0] policy
     /* 1634988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634998 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1635001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635022 */     // GIR_Coverage, 4022,
     /* 1635022 */     GIR_EraseRootFromParent_Done,
     /* 1635023 */   // Label 22515: @1635023
     /* 1635023 */   GIM_Try, /*On fail goto*//*Label 22516*/ GIMT_Encode4(1635109), // Rule ID 4023 //
     /* 1635028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1635036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1635039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1635042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1635045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1635051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635074 */     // MIs[0] policy
     /* 1635074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635084 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1635087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635108 */     // GIR_Coverage, 4023,
     /* 1635108 */     GIR_EraseRootFromParent_Done,
     /* 1635109 */   // Label 22516: @1635109
     /* 1635109 */   GIM_Try, /*On fail goto*//*Label 22517*/ GIMT_Encode4(1635195), // Rule ID 4026 //
     /* 1635114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1635122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1635125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1635128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635160 */     // MIs[0] policy
     /* 1635160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635170 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1635173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635194 */     // GIR_Coverage, 4026,
     /* 1635194 */     GIR_EraseRootFromParent_Done,
     /* 1635195 */   // Label 22517: @1635195
     /* 1635195 */   GIM_Try, /*On fail goto*//*Label 22518*/ GIMT_Encode4(1635281), // Rule ID 4027 //
     /* 1635200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1635208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1635211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1635214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635246 */     // MIs[0] policy
     /* 1635246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635256 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1635259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635280 */     // GIR_Coverage, 4027,
     /* 1635280 */     GIR_EraseRootFromParent_Done,
     /* 1635281 */   // Label 22518: @1635281
     /* 1635281 */   GIM_Try, /*On fail goto*//*Label 22519*/ GIMT_Encode4(1635367), // Rule ID 4030 //
     /* 1635286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1635294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1635297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1635300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635332 */     // MIs[0] policy
     /* 1635332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635342 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1635345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635366 */     // GIR_Coverage, 4030,
     /* 1635366 */     GIR_EraseRootFromParent_Done,
     /* 1635367 */   // Label 22519: @1635367
     /* 1635367 */   GIM_Try, /*On fail goto*//*Label 22520*/ GIMT_Encode4(1635453), // Rule ID 4031 //
     /* 1635372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1635380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1635383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1635386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635418 */     // MIs[0] policy
     /* 1635418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635428 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1635431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635452 */     // GIR_Coverage, 4031,
     /* 1635452 */     GIR_EraseRootFromParent_Done,
     /* 1635453 */   // Label 22520: @1635453
     /* 1635453 */   GIM_Try, /*On fail goto*//*Label 22521*/ GIMT_Encode4(1635539), // Rule ID 4034 //
     /* 1635458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1635466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1635469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1635472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1635475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635504 */     // MIs[0] policy
     /* 1635504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635514 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1635517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635538 */     // GIR_Coverage, 4034,
     /* 1635538 */     GIR_EraseRootFromParent_Done,
     /* 1635539 */   // Label 22521: @1635539
     /* 1635539 */   GIM_Try, /*On fail goto*//*Label 22522*/ GIMT_Encode4(1635625), // Rule ID 4035 //
     /* 1635544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1635552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1635555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1635558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1635561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635590 */     // MIs[0] policy
     /* 1635590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1635603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635624 */     // GIR_Coverage, 4035,
     /* 1635624 */     GIR_EraseRootFromParent_Done,
     /* 1635625 */   // Label 22522: @1635625
     /* 1635625 */   GIM_Try, /*On fail goto*//*Label 22523*/ GIMT_Encode4(1635711), // Rule ID 4038 //
     /* 1635630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1635638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1635641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1635644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1635647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1635660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635676 */     // MIs[0] policy
     /* 1635676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1635689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635710 */     // GIR_Coverage, 4038,
     /* 1635710 */     GIR_EraseRootFromParent_Done,
     /* 1635711 */   // Label 22523: @1635711
     /* 1635711 */   GIM_Try, /*On fail goto*//*Label 22524*/ GIMT_Encode4(1635797), // Rule ID 4039 //
     /* 1635716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1635724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1635727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1635730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1635733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1635746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635762 */     // MIs[0] policy
     /* 1635762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635772 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1635775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635796 */     // GIR_Coverage, 4039,
     /* 1635796 */     GIR_EraseRootFromParent_Done,
     /* 1635797 */   // Label 22524: @1635797
     /* 1635797 */   GIM_Try, /*On fail goto*//*Label 22525*/ GIMT_Encode4(1635883), // Rule ID 4042 //
     /* 1635802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1635810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1635813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1635816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1635819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1635825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635848 */     // MIs[0] policy
     /* 1635848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635858 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1635861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635882 */     // GIR_Coverage, 4042,
     /* 1635882 */     GIR_EraseRootFromParent_Done,
     /* 1635883 */   // Label 22525: @1635883
     /* 1635883 */   GIM_Try, /*On fail goto*//*Label 22526*/ GIMT_Encode4(1635969), // Rule ID 4043 //
     /* 1635888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1635896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1635899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1635902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1635905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1635911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635934 */     // MIs[0] policy
     /* 1635934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635944 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1635947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635968 */     // GIR_Coverage, 4043,
     /* 1635968 */     GIR_EraseRootFromParent_Done,
     /* 1635969 */   // Label 22526: @1635969
     /* 1635969 */   GIM_Try, /*On fail goto*//*Label 22527*/ GIMT_Encode4(1636055), // Rule ID 4046 //
     /* 1635974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1635982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1635985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1635988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1635991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636020 */     // MIs[0] policy
     /* 1636020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636030 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1636033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636054 */     // GIR_Coverage, 4046,
     /* 1636054 */     GIR_EraseRootFromParent_Done,
     /* 1636055 */   // Label 22527: @1636055
     /* 1636055 */   GIM_Try, /*On fail goto*//*Label 22528*/ GIMT_Encode4(1636141), // Rule ID 4047 //
     /* 1636060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1636063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1636068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1636071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1636074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1636077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636106 */     // MIs[0] policy
     /* 1636106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636116 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1636119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636140 */     // GIR_Coverage, 4047,
     /* 1636140 */     GIR_EraseRootFromParent_Done,
     /* 1636141 */   // Label 22528: @1636141
     /* 1636141 */   GIM_Try, /*On fail goto*//*Label 22529*/ GIMT_Encode4(1636227), // Rule ID 4050 //
     /* 1636146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1636149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1636154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1636157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1636160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1636163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636192 */     // MIs[0] policy
     /* 1636192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636202 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1636205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636226 */     // GIR_Coverage, 4050,
     /* 1636226 */     GIR_EraseRootFromParent_Done,
     /* 1636227 */   // Label 22529: @1636227
     /* 1636227 */   GIM_Try, /*On fail goto*//*Label 22530*/ GIMT_Encode4(1636313), // Rule ID 4051 //
     /* 1636232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1636235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1636240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1636243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1636246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1636249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636278 */     // MIs[0] policy
     /* 1636278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636288 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1636291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636312 */     // GIR_Coverage, 4051,
     /* 1636312 */     GIR_EraseRootFromParent_Done,
     /* 1636313 */   // Label 22530: @1636313
     /* 1636313 */   GIM_Try, /*On fail goto*//*Label 22531*/ GIMT_Encode4(1636399), // Rule ID 4054 //
     /* 1636318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1636321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1636326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1636329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1636332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1636335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636364 */     // MIs[0] policy
     /* 1636364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636374 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1636377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636398 */     // GIR_Coverage, 4054,
     /* 1636398 */     GIR_EraseRootFromParent_Done,
     /* 1636399 */   // Label 22531: @1636399
     /* 1636399 */   GIM_Try, /*On fail goto*//*Label 22532*/ GIMT_Encode4(1636485), // Rule ID 4055 //
     /* 1636404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1636407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1636412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1636415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1636418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1636421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636450 */     // MIs[0] policy
     /* 1636450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636460 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1636463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636484 */     // GIR_Coverage, 4055,
     /* 1636484 */     GIR_EraseRootFromParent_Done,
     /* 1636485 */   // Label 22532: @1636485
     /* 1636485 */   GIM_Try, /*On fail goto*//*Label 22533*/ GIMT_Encode4(1636571), // Rule ID 4058 //
     /* 1636490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1636493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1636498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1636501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1636504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1636507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636536 */     // MIs[0] policy
     /* 1636536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1636549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636570 */     // GIR_Coverage, 4058,
     /* 1636570 */     GIR_EraseRootFromParent_Done,
     /* 1636571 */   // Label 22533: @1636571
     /* 1636571 */   GIM_Try, /*On fail goto*//*Label 22534*/ GIMT_Encode4(1636657), // Rule ID 4059 //
     /* 1636576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1636579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1636584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1636587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1636590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1636593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636622 */     // MIs[0] policy
     /* 1636622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636632 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1636635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636656 */     // GIR_Coverage, 4059,
     /* 1636656 */     GIR_EraseRootFromParent_Done,
     /* 1636657 */   // Label 22534: @1636657
     /* 1636657 */   GIM_Try, /*On fail goto*//*Label 22535*/ GIMT_Encode4(1636743), // Rule ID 4068 //
     /* 1636662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1636673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1636676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1636679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1636682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636708 */     // MIs[0] policy
     /* 1636708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1636721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636742 */     // GIR_Coverage, 4068,
     /* 1636742 */     GIR_EraseRootFromParent_Done,
     /* 1636743 */   // Label 22535: @1636743
     /* 1636743 */   GIM_Try, /*On fail goto*//*Label 22536*/ GIMT_Encode4(1636829), // Rule ID 4069 //
     /* 1636748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1636759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1636762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1636765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1636768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636794 */     // MIs[0] policy
     /* 1636794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636804 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1636807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636828 */     // GIR_Coverage, 4069,
     /* 1636828 */     GIR_EraseRootFromParent_Done,
     /* 1636829 */   // Label 22536: @1636829
     /* 1636829 */   GIM_Try, /*On fail goto*//*Label 22537*/ GIMT_Encode4(1636915), // Rule ID 4078 //
     /* 1636834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1636845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1636848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1636851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1636854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636880 */     // MIs[0] policy
     /* 1636880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1636893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636914 */     // GIR_Coverage, 4078,
     /* 1636914 */     GIR_EraseRootFromParent_Done,
     /* 1636915 */   // Label 22537: @1636915
     /* 1636915 */   GIM_Try, /*On fail goto*//*Label 22538*/ GIMT_Encode4(1637001), // Rule ID 4079 //
     /* 1636920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1636931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1636934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1636937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1636940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636966 */     // MIs[0] policy
     /* 1636966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636976 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1636979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637000 */     // GIR_Coverage, 4079,
     /* 1637000 */     GIR_EraseRootFromParent_Done,
     /* 1637001 */   // Label 22538: @1637001
     /* 1637001 */   GIM_Try, /*On fail goto*//*Label 22539*/ GIMT_Encode4(1637087), // Rule ID 4088 //
     /* 1637006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1637017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1637020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1637023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1637026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637052 */     // MIs[0] policy
     /* 1637052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637062 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1637065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637086 */     // GIR_Coverage, 4088,
     /* 1637086 */     GIR_EraseRootFromParent_Done,
     /* 1637087 */   // Label 22539: @1637087
     /* 1637087 */   GIM_Try, /*On fail goto*//*Label 22540*/ GIMT_Encode4(1637173), // Rule ID 4089 //
     /* 1637092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1637103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1637106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1637109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1637112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637138 */     // MIs[0] policy
     /* 1637138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637148 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1637151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637172 */     // GIR_Coverage, 4089,
     /* 1637172 */     GIR_EraseRootFromParent_Done,
     /* 1637173 */   // Label 22540: @1637173
     /* 1637173 */   GIM_Try, /*On fail goto*//*Label 22541*/ GIMT_Encode4(1637259), // Rule ID 4098 //
     /* 1637178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1637189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1637192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1637195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1637198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637224 */     // MIs[0] policy
     /* 1637224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637234 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1637237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637258 */     // GIR_Coverage, 4098,
     /* 1637258 */     GIR_EraseRootFromParent_Done,
     /* 1637259 */   // Label 22541: @1637259
     /* 1637259 */   GIM_Try, /*On fail goto*//*Label 22542*/ GIMT_Encode4(1637345), // Rule ID 4099 //
     /* 1637264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1637275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1637278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1637281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1637284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637310 */     // MIs[0] policy
     /* 1637310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637320 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1637323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637344 */     // GIR_Coverage, 4099,
     /* 1637344 */     GIR_EraseRootFromParent_Done,
     /* 1637345 */   // Label 22542: @1637345
     /* 1637345 */   GIM_Try, /*On fail goto*//*Label 22543*/ GIMT_Encode4(1637431), // Rule ID 4108 //
     /* 1637350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1637361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1637364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1637367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1637370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1637373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637396 */     // MIs[0] policy
     /* 1637396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637406 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1637409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637430 */     // GIR_Coverage, 4108,
     /* 1637430 */     GIR_EraseRootFromParent_Done,
     /* 1637431 */   // Label 22543: @1637431
     /* 1637431 */   GIM_Try, /*On fail goto*//*Label 22544*/ GIMT_Encode4(1637517), // Rule ID 4109 //
     /* 1637436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1637447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1637450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1637453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1637456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1637459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637482 */     // MIs[0] policy
     /* 1637482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637492 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1637495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637516 */     // GIR_Coverage, 4109,
     /* 1637516 */     GIR_EraseRootFromParent_Done,
     /* 1637517 */   // Label 22544: @1637517
     /* 1637517 */   GIM_Try, /*On fail goto*//*Label 22545*/ GIMT_Encode4(1637603), // Rule ID 4118 //
     /* 1637522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1637533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1637536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1637539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1637542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637568 */     // MIs[0] policy
     /* 1637568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637578 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1637581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637602 */     // GIR_Coverage, 4118,
     /* 1637602 */     GIR_EraseRootFromParent_Done,
     /* 1637603 */   // Label 22545: @1637603
     /* 1637603 */   GIM_Try, /*On fail goto*//*Label 22546*/ GIMT_Encode4(1637689), // Rule ID 4119 //
     /* 1637608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1637619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1637622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1637625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1637628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637654 */     // MIs[0] policy
     /* 1637654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637664 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1637667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637688 */     // GIR_Coverage, 4119,
     /* 1637688 */     GIR_EraseRootFromParent_Done,
     /* 1637689 */   // Label 22546: @1637689
     /* 1637689 */   GIM_Try, /*On fail goto*//*Label 22547*/ GIMT_Encode4(1637775), // Rule ID 4128 //
     /* 1637694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1637705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1637708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1637711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1637714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637740 */     // MIs[0] policy
     /* 1637740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637750 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11623:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1637753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637774 */     // GIR_Coverage, 4128,
     /* 1637774 */     GIR_EraseRootFromParent_Done,
     /* 1637775 */   // Label 22547: @1637775
     /* 1637775 */   GIM_Try, /*On fail goto*//*Label 22548*/ GIMT_Encode4(1637861), // Rule ID 4129 //
     /* 1637780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1637791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1637794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1637797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1637800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637826 */     // MIs[0] policy
     /* 1637826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637836 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11623:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1637839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637860 */     // GIR_Coverage, 4129,
     /* 1637860 */     GIR_EraseRootFromParent_Done,
     /* 1637861 */   // Label 22548: @1637861
     /* 1637861 */   GIM_Try, /*On fail goto*//*Label 22549*/ GIMT_Encode4(1637947), // Rule ID 4138 //
     /* 1637866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1637877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1637880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1637883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1637886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637912 */     // MIs[0] policy
     /* 1637912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637922 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1637925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637946 */     // GIR_Coverage, 4138,
     /* 1637946 */     GIR_EraseRootFromParent_Done,
     /* 1637947 */   // Label 22549: @1637947
     /* 1637947 */   GIM_Try, /*On fail goto*//*Label 22550*/ GIMT_Encode4(1638033), // Rule ID 4139 //
     /* 1637952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1637963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1637966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1637969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1637972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637998 */     // MIs[0] policy
     /* 1637998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638008 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1638011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1638029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638032 */     // GIR_Coverage, 4139,
     /* 1638032 */     GIR_EraseRootFromParent_Done,
     /* 1638033 */   // Label 22550: @1638033
     /* 1638033 */   GIM_Try, /*On fail goto*//*Label 22551*/ GIMT_Encode4(1638119), // Rule ID 4148 //
     /* 1638038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1638049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1638052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1638055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1638058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638084 */     // MIs[0] policy
     /* 1638084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1638097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1638115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638118 */     // GIR_Coverage, 4148,
     /* 1638118 */     GIR_EraseRootFromParent_Done,
     /* 1638119 */   // Label 22551: @1638119
     /* 1638119 */   GIM_Try, /*On fail goto*//*Label 22552*/ GIMT_Encode4(1638205), // Rule ID 4149 //
     /* 1638124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1638135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1638138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1638141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1638144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638170 */     // MIs[0] policy
     /* 1638170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638180 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1638183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1638201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638204 */     // GIR_Coverage, 4149,
     /* 1638204 */     GIR_EraseRootFromParent_Done,
     /* 1638205 */   // Label 22552: @1638205
     /* 1638205 */   GIM_Try, /*On fail goto*//*Label 22553*/ GIMT_Encode4(1638291), // Rule ID 4158 //
     /* 1638210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1638221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1638224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1638227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1638230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638256 */     // MIs[0] policy
     /* 1638256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638266 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1638269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1638287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638290 */     // GIR_Coverage, 4158,
     /* 1638290 */     GIR_EraseRootFromParent_Done,
     /* 1638291 */   // Label 22553: @1638291
     /* 1638291 */   GIM_Try, /*On fail goto*//*Label 22554*/ GIMT_Encode4(1638377), // Rule ID 4159 //
     /* 1638296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1638307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1638310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1638313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1638316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638342 */     // MIs[0] policy
     /* 1638342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638352 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1638355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1638373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638376 */     // GIR_Coverage, 4159,
     /* 1638376 */     GIR_EraseRootFromParent_Done,
     /* 1638377 */   // Label 22554: @1638377
     /* 1638377 */   GIM_Try, /*On fail goto*//*Label 22555*/ GIMT_Encode4(1638463), // Rule ID 4168 //
     /* 1638382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1638385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1638393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1638396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1638399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1638402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638428 */     // MIs[0] policy
     /* 1638428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638438 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1638441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638462 */     // GIR_Coverage, 4168,
     /* 1638462 */     GIR_EraseRootFromParent_Done,
     /* 1638463 */   // Label 22555: @1638463
     /* 1638463 */   GIM_Try, /*On fail goto*//*Label 22556*/ GIMT_Encode4(1638549), // Rule ID 4169 //
     /* 1638468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1638471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1638479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1638482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1638485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1638488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638514 */     // MIs[0] policy
     /* 1638514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638524 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1638527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638548 */     // GIR_Coverage, 4169,
     /* 1638548 */     GIR_EraseRootFromParent_Done,
     /* 1638549 */   // Label 22556: @1638549
     /* 1638549 */   GIM_Try, /*On fail goto*//*Label 22557*/ GIMT_Encode4(1638635), // Rule ID 4178 //
     /* 1638554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1638557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1638565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1638568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1638571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1638574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638600 */     // MIs[0] policy
     /* 1638600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638610 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1638613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638634 */     // GIR_Coverage, 4178,
     /* 1638634 */     GIR_EraseRootFromParent_Done,
     /* 1638635 */   // Label 22557: @1638635
     /* 1638635 */   GIM_Try, /*On fail goto*//*Label 22558*/ GIMT_Encode4(1638721), // Rule ID 4179 //
     /* 1638640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1638643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1638651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1638654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1638657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1638660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638686 */     // MIs[0] policy
     /* 1638686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638696 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1638699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638720 */     // GIR_Coverage, 4179,
     /* 1638720 */     GIR_EraseRootFromParent_Done,
     /* 1638721 */   // Label 22558: @1638721
     /* 1638721 */   GIM_Try, /*On fail goto*//*Label 22559*/ GIMT_Encode4(1638807), // Rule ID 4188 //
     /* 1638726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1638729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1638737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1638740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1638743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1638746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638772 */     // MIs[0] policy
     /* 1638772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638782 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1638785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638806 */     // GIR_Coverage, 4188,
     /* 1638806 */     GIR_EraseRootFromParent_Done,
     /* 1638807 */   // Label 22559: @1638807
     /* 1638807 */   GIM_Try, /*On fail goto*//*Label 22560*/ GIMT_Encode4(1638893), // Rule ID 4189 //
     /* 1638812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1638815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1638823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1638826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1638829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1638832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638858 */     // MIs[0] policy
     /* 1638858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638868 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1638871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638892 */     // GIR_Coverage, 4189,
     /* 1638892 */     GIR_EraseRootFromParent_Done,
     /* 1638893 */   // Label 22560: @1638893
     /* 1638893 */   GIM_Try, /*On fail goto*//*Label 22561*/ GIMT_Encode4(1638979), // Rule ID 4198 //
     /* 1638898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1638901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1638909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1638912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1638915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1638918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638944 */     // MIs[0] policy
     /* 1638944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638954 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1638957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638978 */     // GIR_Coverage, 4198,
     /* 1638978 */     GIR_EraseRootFromParent_Done,
     /* 1638979 */   // Label 22561: @1638979
     /* 1638979 */   GIM_Try, /*On fail goto*//*Label 22562*/ GIMT_Encode4(1639065), // Rule ID 4199 //
     /* 1638984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1638987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1638995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1638998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1639001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1639004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639030 */     // MIs[0] policy
     /* 1639030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639040 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1639043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1639061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639064 */     // GIR_Coverage, 4199,
     /* 1639064 */     GIR_EraseRootFromParent_Done,
     /* 1639065 */   // Label 22562: @1639065
     /* 1639065 */   GIM_Try, /*On fail goto*//*Label 22563*/ GIMT_Encode4(1639151), // Rule ID 4202 //
     /* 1639070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1639078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1639081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1639084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1639087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639116 */     // MIs[0] policy
     /* 1639116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639126 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1639129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639150 */     // GIR_Coverage, 4202,
     /* 1639150 */     GIR_EraseRootFromParent_Done,
     /* 1639151 */   // Label 22563: @1639151
     /* 1639151 */   GIM_Try, /*On fail goto*//*Label 22564*/ GIMT_Encode4(1639237), // Rule ID 4203 //
     /* 1639156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1639164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1639167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1639170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1639173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639202 */     // MIs[0] policy
     /* 1639202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639212 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1639215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639236 */     // GIR_Coverage, 4203,
     /* 1639236 */     GIR_EraseRootFromParent_Done,
     /* 1639237 */   // Label 22564: @1639237
     /* 1639237 */   GIM_Try, /*On fail goto*//*Label 22565*/ GIMT_Encode4(1639323), // Rule ID 4206 //
     /* 1639242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1639250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1639253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1639256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1639259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639288 */     // MIs[0] policy
     /* 1639288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639298 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1639301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639322 */     // GIR_Coverage, 4206,
     /* 1639322 */     GIR_EraseRootFromParent_Done,
     /* 1639323 */   // Label 22565: @1639323
     /* 1639323 */   GIM_Try, /*On fail goto*//*Label 22566*/ GIMT_Encode4(1639409), // Rule ID 4207 //
     /* 1639328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1639336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1639339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1639342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1639345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639374 */     // MIs[0] policy
     /* 1639374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639384 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1639387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639408 */     // GIR_Coverage, 4207,
     /* 1639408 */     GIR_EraseRootFromParent_Done,
     /* 1639409 */   // Label 22566: @1639409
     /* 1639409 */   GIM_Try, /*On fail goto*//*Label 22567*/ GIMT_Encode4(1639495), // Rule ID 4210 //
     /* 1639414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1639422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1639425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1639428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1639431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639460 */     // MIs[0] policy
     /* 1639460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639470 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1639473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639494 */     // GIR_Coverage, 4210,
     /* 1639494 */     GIR_EraseRootFromParent_Done,
     /* 1639495 */   // Label 22567: @1639495
     /* 1639495 */   GIM_Try, /*On fail goto*//*Label 22568*/ GIMT_Encode4(1639581), // Rule ID 4211 //
     /* 1639500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1639508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1639511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1639514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1639517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639546 */     // MIs[0] policy
     /* 1639546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639556 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11623:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1639559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639580 */     // GIR_Coverage, 4211,
     /* 1639580 */     GIR_EraseRootFromParent_Done,
     /* 1639581 */   // Label 22568: @1639581
     /* 1639581 */   GIM_Try, /*On fail goto*//*Label 22569*/ GIMT_Encode4(1639667), // Rule ID 4214 //
     /* 1639586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1639594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1639597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1639600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1639603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639632 */     // MIs[0] policy
     /* 1639632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639642 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1639645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639666 */     // GIR_Coverage, 4214,
     /* 1639666 */     GIR_EraseRootFromParent_Done,
     /* 1639667 */   // Label 22569: @1639667
     /* 1639667 */   GIM_Try, /*On fail goto*//*Label 22570*/ GIMT_Encode4(1639753), // Rule ID 4215 //
     /* 1639672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1639680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1639683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1639686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1639689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639718 */     // MIs[0] policy
     /* 1639718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1639731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639752 */     // GIR_Coverage, 4215,
     /* 1639752 */     GIR_EraseRootFromParent_Done,
     /* 1639753 */   // Label 22570: @1639753
     /* 1639753 */   GIM_Try, /*On fail goto*//*Label 22571*/ GIMT_Encode4(1639839), // Rule ID 4218 //
     /* 1639758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1639766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1639769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1639772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1639775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1639781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639804 */     // MIs[0] policy
     /* 1639804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639814 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1639817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639838 */     // GIR_Coverage, 4218,
     /* 1639838 */     GIR_EraseRootFromParent_Done,
     /* 1639839 */   // Label 22571: @1639839
     /* 1639839 */   GIM_Try, /*On fail goto*//*Label 22572*/ GIMT_Encode4(1639925), // Rule ID 4219 //
     /* 1639844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1639852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1639855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1639858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1639861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1639867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639890 */     // MIs[0] policy
     /* 1639890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639900 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1639903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639924 */     // GIR_Coverage, 4219,
     /* 1639924 */     GIR_EraseRootFromParent_Done,
     /* 1639925 */   // Label 22572: @1639925
     /* 1639925 */   GIM_Try, /*On fail goto*//*Label 22573*/ GIMT_Encode4(1640011), // Rule ID 4222 //
     /* 1639930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1639938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1639941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1639944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1639947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1639953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639976 */     // MIs[0] policy
     /* 1639976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639986 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1639989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640010 */     // GIR_Coverage, 4222,
     /* 1640010 */     GIR_EraseRootFromParent_Done,
     /* 1640011 */   // Label 22573: @1640011
     /* 1640011 */   GIM_Try, /*On fail goto*//*Label 22574*/ GIMT_Encode4(1640097), // Rule ID 4223 //
     /* 1640016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1640024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1640027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1640030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1640033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1640039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640062 */     // MIs[0] policy
     /* 1640062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640072 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1640075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640096 */     // GIR_Coverage, 4223,
     /* 1640096 */     GIR_EraseRootFromParent_Done,
     /* 1640097 */   // Label 22574: @1640097
     /* 1640097 */   GIM_Try, /*On fail goto*//*Label 22575*/ GIMT_Encode4(1640183), // Rule ID 4226 //
     /* 1640102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1640110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1640113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1640116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1640119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640148 */     // MIs[0] policy
     /* 1640148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640158 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1640161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640182 */     // GIR_Coverage, 4226,
     /* 1640182 */     GIR_EraseRootFromParent_Done,
     /* 1640183 */   // Label 22575: @1640183
     /* 1640183 */   GIM_Try, /*On fail goto*//*Label 22576*/ GIMT_Encode4(1640269), // Rule ID 4227 //
     /* 1640188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1640196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1640199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1640202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1640205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640234 */     // MIs[0] policy
     /* 1640234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640244 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1640247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640268 */     // GIR_Coverage, 4227,
     /* 1640268 */     GIR_EraseRootFromParent_Done,
     /* 1640269 */   // Label 22576: @1640269
     /* 1640269 */   GIM_Try, /*On fail goto*//*Label 22577*/ GIMT_Encode4(1640355), // Rule ID 4230 //
     /* 1640274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1640282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1640285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1640288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1640291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640320 */     // MIs[0] policy
     /* 1640320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640330 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11623:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1640333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640354 */     // GIR_Coverage, 4230,
     /* 1640354 */     GIR_EraseRootFromParent_Done,
     /* 1640355 */   // Label 22577: @1640355
     /* 1640355 */   GIM_Try, /*On fail goto*//*Label 22578*/ GIMT_Encode4(1640441), // Rule ID 4231 //
     /* 1640360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1640368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1640371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1640374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1640377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640406 */     // MIs[0] policy
     /* 1640406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640416 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11623:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1640419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640440 */     // GIR_Coverage, 4231,
     /* 1640440 */     GIR_EraseRootFromParent_Done,
     /* 1640441 */   // Label 22578: @1640441
     /* 1640441 */   GIM_Try, /*On fail goto*//*Label 22579*/ GIMT_Encode4(1640527), // Rule ID 4234 //
     /* 1640446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1640454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1640457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1640460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1640463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640492 */     // MIs[0] policy
     /* 1640492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1640505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640526 */     // GIR_Coverage, 4234,
     /* 1640526 */     GIR_EraseRootFromParent_Done,
     /* 1640527 */   // Label 22579: @1640527
     /* 1640527 */   GIM_Try, /*On fail goto*//*Label 22580*/ GIMT_Encode4(1640613), // Rule ID 4235 //
     /* 1640532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1640540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1640543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1640546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1640549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640578 */     // MIs[0] policy
     /* 1640578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1640591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640612 */     // GIR_Coverage, 4235,
     /* 1640612 */     GIR_EraseRootFromParent_Done,
     /* 1640613 */   // Label 22580: @1640613
     /* 1640613 */   GIM_Try, /*On fail goto*//*Label 22581*/ GIMT_Encode4(1640699), // Rule ID 4238 //
     /* 1640618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1640626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1640629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1640632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1640635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640664 */     // MIs[0] policy
     /* 1640664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1640677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640698 */     // GIR_Coverage, 4238,
     /* 1640698 */     GIR_EraseRootFromParent_Done,
     /* 1640699 */   // Label 22581: @1640699
     /* 1640699 */   GIM_Try, /*On fail goto*//*Label 22582*/ GIMT_Encode4(1640785), // Rule ID 4239 //
     /* 1640704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1640712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1640715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1640718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1640721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640750 */     // MIs[0] policy
     /* 1640750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640760 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1640763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640784 */     // GIR_Coverage, 4239,
     /* 1640784 */     GIR_EraseRootFromParent_Done,
     /* 1640785 */   // Label 22582: @1640785
     /* 1640785 */   GIM_Try, /*On fail goto*//*Label 22583*/ GIMT_Encode4(1640871), // Rule ID 4242 //
     /* 1640790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1640798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1640801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1640804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1640807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1640813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640836 */     // MIs[0] policy
     /* 1640836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640846 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1640849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640870 */     // GIR_Coverage, 4242,
     /* 1640870 */     GIR_EraseRootFromParent_Done,
     /* 1640871 */   // Label 22583: @1640871
     /* 1640871 */   GIM_Try, /*On fail goto*//*Label 22584*/ GIMT_Encode4(1640957), // Rule ID 4243 //
     /* 1640876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1640884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1640887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1640890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1640893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1640899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640922 */     // MIs[0] policy
     /* 1640922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640932 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1640935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640956 */     // GIR_Coverage, 4243,
     /* 1640956 */     GIR_EraseRootFromParent_Done,
     /* 1640957 */   // Label 22584: @1640957
     /* 1640957 */   GIM_Try, /*On fail goto*//*Label 22585*/ GIMT_Encode4(1641043), // Rule ID 4246 //
     /* 1640962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1640970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1640973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1640976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1640979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641008 */     // MIs[0] policy
     /* 1641008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641018 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1641021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641042 */     // GIR_Coverage, 4246,
     /* 1641042 */     GIR_EraseRootFromParent_Done,
     /* 1641043 */   // Label 22585: @1641043
     /* 1641043 */   GIM_Try, /*On fail goto*//*Label 22586*/ GIMT_Encode4(1641129), // Rule ID 4247 //
     /* 1641048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1641051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1641056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1641059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1641062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1641065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641094 */     // MIs[0] policy
     /* 1641094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641104 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11623:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1641107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641128 */     // GIR_Coverage, 4247,
     /* 1641128 */     GIR_EraseRootFromParent_Done,
     /* 1641129 */   // Label 22586: @1641129
     /* 1641129 */   GIM_Try, /*On fail goto*//*Label 22587*/ GIMT_Encode4(1641215), // Rule ID 4250 //
     /* 1641134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1641137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1641142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1641145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1641148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1641151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641180 */     // MIs[0] policy
     /* 1641180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1641193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641214 */     // GIR_Coverage, 4250,
     /* 1641214 */     GIR_EraseRootFromParent_Done,
     /* 1641215 */   // Label 22587: @1641215
     /* 1641215 */   GIM_Try, /*On fail goto*//*Label 22588*/ GIMT_Encode4(1641301), // Rule ID 4251 //
     /* 1641220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1641223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1641228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1641231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1641234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1641237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641266 */     // MIs[0] policy
     /* 1641266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11623:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1641279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641300 */     // GIR_Coverage, 4251,
     /* 1641300 */     GIR_EraseRootFromParent_Done,
     /* 1641301 */   // Label 22588: @1641301
     /* 1641301 */   GIM_Try, /*On fail goto*//*Label 22589*/ GIMT_Encode4(1641387), // Rule ID 4254 //
     /* 1641306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1641309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1641314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1641317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1641320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1641323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641352 */     // MIs[0] policy
     /* 1641352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641362 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1641365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641386 */     // GIR_Coverage, 4254,
     /* 1641386 */     GIR_EraseRootFromParent_Done,
     /* 1641387 */   // Label 22589: @1641387
     /* 1641387 */   GIM_Try, /*On fail goto*//*Label 22590*/ GIMT_Encode4(1641473), // Rule ID 4255 //
     /* 1641392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1641395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1641400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1641403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1641406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1641409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641438 */     // MIs[0] policy
     /* 1641438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641448 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11623:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1641451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641472 */     // GIR_Coverage, 4255,
     /* 1641472 */     GIR_EraseRootFromParent_Done,
     /* 1641473 */   // Label 22590: @1641473
     /* 1641473 */   GIM_Try, /*On fail goto*//*Label 22591*/ GIMT_Encode4(1641559), // Rule ID 4258 //
     /* 1641478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1641481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1641486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1641489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1641492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1641495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641524 */     // MIs[0] policy
     /* 1641524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641534 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1641537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641558 */     // GIR_Coverage, 4258,
     /* 1641558 */     GIR_EraseRootFromParent_Done,
     /* 1641559 */   // Label 22591: @1641559
     /* 1641559 */   GIM_Try, /*On fail goto*//*Label 22592*/ GIMT_Encode4(1641645), // Rule ID 4259 //
     /* 1641564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1641567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1641572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1641575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1641578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1641581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641610 */     // MIs[0] policy
     /* 1641610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641620 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11623:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1641623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641644 */     // GIR_Coverage, 4259,
     /* 1641644 */     GIR_EraseRootFromParent_Done,
     /* 1641645 */   // Label 22592: @1641645
     /* 1641645 */   GIM_Try, /*On fail goto*//*Label 22593*/ GIMT_Encode4(1641731), // Rule ID 4268 //
     /* 1641650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1641661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1641664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1641667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1641670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641696 */     // MIs[0] policy
     /* 1641696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1641709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641730 */     // GIR_Coverage, 4268,
     /* 1641730 */     GIR_EraseRootFromParent_Done,
     /* 1641731 */   // Label 22593: @1641731
     /* 1641731 */   GIM_Try, /*On fail goto*//*Label 22594*/ GIMT_Encode4(1641817), // Rule ID 4269 //
     /* 1641736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1641747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1641750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1641753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1641756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641782 */     // MIs[0] policy
     /* 1641782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641792 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1641795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641816 */     // GIR_Coverage, 4269,
     /* 1641816 */     GIR_EraseRootFromParent_Done,
     /* 1641817 */   // Label 22594: @1641817
     /* 1641817 */   GIM_Try, /*On fail goto*//*Label 22595*/ GIMT_Encode4(1641903), // Rule ID 4278 //
     /* 1641822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1641833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1641836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1641839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1641842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641868 */     // MIs[0] policy
     /* 1641868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641878 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1641881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641902 */     // GIR_Coverage, 4278,
     /* 1641902 */     GIR_EraseRootFromParent_Done,
     /* 1641903 */   // Label 22595: @1641903
     /* 1641903 */   GIM_Try, /*On fail goto*//*Label 22596*/ GIMT_Encode4(1641989), // Rule ID 4279 //
     /* 1641908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1641919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1641922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1641925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1641928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641954 */     // MIs[0] policy
     /* 1641954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1641967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641988 */     // GIR_Coverage, 4279,
     /* 1641988 */     GIR_EraseRootFromParent_Done,
     /* 1641989 */   // Label 22596: @1641989
     /* 1641989 */   GIM_Try, /*On fail goto*//*Label 22597*/ GIMT_Encode4(1642075), // Rule ID 4288 //
     /* 1641994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1642005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1642008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1642011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1642014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642040 */     // MIs[0] policy
     /* 1642040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1642053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642074 */     // GIR_Coverage, 4288,
     /* 1642074 */     GIR_EraseRootFromParent_Done,
     /* 1642075 */   // Label 22597: @1642075
     /* 1642075 */   GIM_Try, /*On fail goto*//*Label 22598*/ GIMT_Encode4(1642161), // Rule ID 4289 //
     /* 1642080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1642091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1642094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1642097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1642100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642126 */     // MIs[0] policy
     /* 1642126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642136 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1642139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642160 */     // GIR_Coverage, 4289,
     /* 1642160 */     GIR_EraseRootFromParent_Done,
     /* 1642161 */   // Label 22598: @1642161
     /* 1642161 */   GIM_Try, /*On fail goto*//*Label 22599*/ GIMT_Encode4(1642247), // Rule ID 4298 //
     /* 1642166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1642177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1642180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1642183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1642186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642212 */     // MIs[0] policy
     /* 1642212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1642225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642246 */     // GIR_Coverage, 4298,
     /* 1642246 */     GIR_EraseRootFromParent_Done,
     /* 1642247 */   // Label 22599: @1642247
     /* 1642247 */   GIM_Try, /*On fail goto*//*Label 22600*/ GIMT_Encode4(1642333), // Rule ID 4299 //
     /* 1642252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1642263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1642266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1642269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1642272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642298 */     // MIs[0] policy
     /* 1642298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1642311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642332 */     // GIR_Coverage, 4299,
     /* 1642332 */     GIR_EraseRootFromParent_Done,
     /* 1642333 */   // Label 22600: @1642333
     /* 1642333 */   GIM_Try, /*On fail goto*//*Label 22601*/ GIMT_Encode4(1642419), // Rule ID 4308 //
     /* 1642338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1642349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1642352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1642355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1642358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642384 */     // MIs[0] policy
     /* 1642384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642394 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1642397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642418 */     // GIR_Coverage, 4308,
     /* 1642418 */     GIR_EraseRootFromParent_Done,
     /* 1642419 */   // Label 22601: @1642419
     /* 1642419 */   GIM_Try, /*On fail goto*//*Label 22602*/ GIMT_Encode4(1642505), // Rule ID 4309 //
     /* 1642424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1642435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1642438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1642441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1642444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642470 */     // MIs[0] policy
     /* 1642470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642480 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1642483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642504 */     // GIR_Coverage, 4309,
     /* 1642504 */     GIR_EraseRootFromParent_Done,
     /* 1642505 */   // Label 22602: @1642505
     /* 1642505 */   GIM_Try, /*On fail goto*//*Label 22603*/ GIMT_Encode4(1642591), // Rule ID 4318 //
     /* 1642510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1642521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1642524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1642527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1642530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1642533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642556 */     // MIs[0] policy
     /* 1642556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642566 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1642569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642590 */     // GIR_Coverage, 4318,
     /* 1642590 */     GIR_EraseRootFromParent_Done,
     /* 1642591 */   // Label 22603: @1642591
     /* 1642591 */   GIM_Try, /*On fail goto*//*Label 22604*/ GIMT_Encode4(1642677), // Rule ID 4319 //
     /* 1642596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1642607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1642610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1642613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1642616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1642619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642642 */     // MIs[0] policy
     /* 1642642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642652 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1642655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642676 */     // GIR_Coverage, 4319,
     /* 1642676 */     GIR_EraseRootFromParent_Done,
     /* 1642677 */   // Label 22604: @1642677
     /* 1642677 */   GIM_Try, /*On fail goto*//*Label 22605*/ GIMT_Encode4(1642763), // Rule ID 4328 //
     /* 1642682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1642693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1642696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1642699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1642702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642728 */     // MIs[0] policy
     /* 1642728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642738 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1642741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642762 */     // GIR_Coverage, 4328,
     /* 1642762 */     GIR_EraseRootFromParent_Done,
     /* 1642763 */   // Label 22605: @1642763
     /* 1642763 */   GIM_Try, /*On fail goto*//*Label 22606*/ GIMT_Encode4(1642849), // Rule ID 4329 //
     /* 1642768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1642779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1642782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1642785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1642788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642814 */     // MIs[0] policy
     /* 1642814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642824 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1642827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642848 */     // GIR_Coverage, 4329,
     /* 1642848 */     GIR_EraseRootFromParent_Done,
     /* 1642849 */   // Label 22606: @1642849
     /* 1642849 */   GIM_Try, /*On fail goto*//*Label 22607*/ GIMT_Encode4(1642935), // Rule ID 4338 //
     /* 1642854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1642865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1642868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1642871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1642874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642900 */     // MIs[0] policy
     /* 1642900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642910 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1642913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642934 */     // GIR_Coverage, 4338,
     /* 1642934 */     GIR_EraseRootFromParent_Done,
     /* 1642935 */   // Label 22607: @1642935
     /* 1642935 */   GIM_Try, /*On fail goto*//*Label 22608*/ GIMT_Encode4(1643021), // Rule ID 4339 //
     /* 1642940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1642951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1642954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1642957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1642960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642986 */     // MIs[0] policy
     /* 1642986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1642999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643020 */     // GIR_Coverage, 4339,
     /* 1643020 */     GIR_EraseRootFromParent_Done,
     /* 1643021 */   // Label 22608: @1643021
     /* 1643021 */   GIM_Try, /*On fail goto*//*Label 22609*/ GIMT_Encode4(1643107), // Rule ID 4348 //
     /* 1643026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1643037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1643040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1643043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1643046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643072 */     // MIs[0] policy
     /* 1643072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1643085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643106 */     // GIR_Coverage, 4348,
     /* 1643106 */     GIR_EraseRootFromParent_Done,
     /* 1643107 */   // Label 22609: @1643107
     /* 1643107 */   GIM_Try, /*On fail goto*//*Label 22610*/ GIMT_Encode4(1643193), // Rule ID 4349 //
     /* 1643112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1643123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1643126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1643129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1643132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643158 */     // MIs[0] policy
     /* 1643158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643168 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1643171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643192 */     // GIR_Coverage, 4349,
     /* 1643192 */     GIR_EraseRootFromParent_Done,
     /* 1643193 */   // Label 22610: @1643193
     /* 1643193 */   GIM_Try, /*On fail goto*//*Label 22611*/ GIMT_Encode4(1643279), // Rule ID 4358 //
     /* 1643198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1643209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1643212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1643215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1643218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643244 */     // MIs[0] policy
     /* 1643244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1643257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643278 */     // GIR_Coverage, 4358,
     /* 1643278 */     GIR_EraseRootFromParent_Done,
     /* 1643279 */   // Label 22611: @1643279
     /* 1643279 */   GIM_Try, /*On fail goto*//*Label 22612*/ GIMT_Encode4(1643365), // Rule ID 4359 //
     /* 1643284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1643295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1643298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1643301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1643304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643330 */     // MIs[0] policy
     /* 1643330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643340 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1643343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643364 */     // GIR_Coverage, 4359,
     /* 1643364 */     GIR_EraseRootFromParent_Done,
     /* 1643365 */   // Label 22612: @1643365
     /* 1643365 */   GIM_Try, /*On fail goto*//*Label 22613*/ GIMT_Encode4(1643451), // Rule ID 4368 //
     /* 1643370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1643381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1643384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1643387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1643390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1643393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643416 */     // MIs[0] policy
     /* 1643416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643426 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1643429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643450 */     // GIR_Coverage, 4368,
     /* 1643450 */     GIR_EraseRootFromParent_Done,
     /* 1643451 */   // Label 22613: @1643451
     /* 1643451 */   GIM_Try, /*On fail goto*//*Label 22614*/ GIMT_Encode4(1643537), // Rule ID 4369 //
     /* 1643456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1643467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1643470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1643473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1643476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1643479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643502 */     // MIs[0] policy
     /* 1643502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643512 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1643515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643536 */     // GIR_Coverage, 4369,
     /* 1643536 */     GIR_EraseRootFromParent_Done,
     /* 1643537 */   // Label 22614: @1643537
     /* 1643537 */   GIM_Try, /*On fail goto*//*Label 22615*/ GIMT_Encode4(1643623), // Rule ID 4378 //
     /* 1643542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1643545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1643553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1643556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1643559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1643562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643588 */     // MIs[0] policy
     /* 1643588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643598 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1643601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643622 */     // GIR_Coverage, 4378,
     /* 1643622 */     GIR_EraseRootFromParent_Done,
     /* 1643623 */   // Label 22615: @1643623
     /* 1643623 */   GIM_Try, /*On fail goto*//*Label 22616*/ GIMT_Encode4(1643709), // Rule ID 4379 //
     /* 1643628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1643639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1643642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1643645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1643648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643674 */     // MIs[0] policy
     /* 1643674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643684 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1643687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643708 */     // GIR_Coverage, 4379,
     /* 1643708 */     GIR_EraseRootFromParent_Done,
     /* 1643709 */   // Label 22616: @1643709
     /* 1643709 */   GIM_Try, /*On fail goto*//*Label 22617*/ GIMT_Encode4(1643795), // Rule ID 4388 //
     /* 1643714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1643717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1643725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1643728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1643731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1643734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643760 */     // MIs[0] policy
     /* 1643760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643770 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1643773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643794 */     // GIR_Coverage, 4388,
     /* 1643794 */     GIR_EraseRootFromParent_Done,
     /* 1643795 */   // Label 22617: @1643795
     /* 1643795 */   GIM_Try, /*On fail goto*//*Label 22618*/ GIMT_Encode4(1643881), // Rule ID 4389 //
     /* 1643800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1643811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1643814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1643817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1643820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643846 */     // MIs[0] policy
     /* 1643846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643856 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1643859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643880 */     // GIR_Coverage, 4389,
     /* 1643880 */     GIR_EraseRootFromParent_Done,
     /* 1643881 */   // Label 22618: @1643881
     /* 1643881 */   GIM_Try, /*On fail goto*//*Label 22619*/ GIMT_Encode4(1643967), // Rule ID 4398 //
     /* 1643886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1643889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1643897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1643900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1643903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1643906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643932 */     // MIs[0] policy
     /* 1643932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643942 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1643945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643966 */     // GIR_Coverage, 4398,
     /* 1643966 */     GIR_EraseRootFromParent_Done,
     /* 1643967 */   // Label 22619: @1643967
     /* 1643967 */   GIM_Try, /*On fail goto*//*Label 22620*/ GIMT_Encode4(1644053), // Rule ID 4399 //
     /* 1643972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1643983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1643986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1643989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1643992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644018 */     // MIs[0] policy
     /* 1644018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644028 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1644031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1644049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644052 */     // GIR_Coverage, 4399,
     /* 1644052 */     GIR_EraseRootFromParent_Done,
     /* 1644053 */   // Label 22620: @1644053
     /* 1644053 */   GIM_Try, /*On fail goto*//*Label 22621*/ GIMT_Encode4(1644139), // Rule ID 4408 //
     /* 1644058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1644061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1644066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1644069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1644072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1644075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1644078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644104 */     // MIs[0] policy
     /* 1644104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1644117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1644135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644138 */     // GIR_Coverage, 4408,
     /* 1644138 */     GIR_EraseRootFromParent_Done,
     /* 1644139 */   // Label 22621: @1644139
     /* 1644139 */   GIM_Try, /*On fail goto*//*Label 22622*/ GIMT_Encode4(1644225), // Rule ID 4409 //
     /* 1644144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1644147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1644152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1644155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1644158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1644161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1644164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644190 */     // MIs[0] policy
     /* 1644190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644200 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1644203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1644221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644224 */     // GIR_Coverage, 4409,
     /* 1644224 */     GIR_EraseRootFromParent_Done,
     /* 1644225 */   // Label 22622: @1644225
     /* 1644225 */   GIM_Try, /*On fail goto*//*Label 22623*/ GIMT_Encode4(1644311), // Rule ID 4412 //
     /* 1644230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1644238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1644241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1644244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1644247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644276 */     // MIs[0] policy
     /* 1644276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644286 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1644289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644310 */     // GIR_Coverage, 4412,
     /* 1644310 */     GIR_EraseRootFromParent_Done,
     /* 1644311 */   // Label 22623: @1644311
     /* 1644311 */   GIM_Try, /*On fail goto*//*Label 22624*/ GIMT_Encode4(1644397), // Rule ID 4413 //
     /* 1644316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1644324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1644327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1644330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1644333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644362 */     // MIs[0] policy
     /* 1644362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644372 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1644375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644396 */     // GIR_Coverage, 4413,
     /* 1644396 */     GIR_EraseRootFromParent_Done,
     /* 1644397 */   // Label 22624: @1644397
     /* 1644397 */   GIM_Try, /*On fail goto*//*Label 22625*/ GIMT_Encode4(1644483), // Rule ID 4416 //
     /* 1644402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1644410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1644413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1644416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1644419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644448 */     // MIs[0] policy
     /* 1644448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644458 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1644461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644482 */     // GIR_Coverage, 4416,
     /* 1644482 */     GIR_EraseRootFromParent_Done,
     /* 1644483 */   // Label 22625: @1644483
     /* 1644483 */   GIM_Try, /*On fail goto*//*Label 22626*/ GIMT_Encode4(1644569), // Rule ID 4417 //
     /* 1644488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1644496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1644499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1644502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1644505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644534 */     // MIs[0] policy
     /* 1644534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644544 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1644547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644568 */     // GIR_Coverage, 4417,
     /* 1644568 */     GIR_EraseRootFromParent_Done,
     /* 1644569 */   // Label 22626: @1644569
     /* 1644569 */   GIM_Try, /*On fail goto*//*Label 22627*/ GIMT_Encode4(1644655), // Rule ID 4420 //
     /* 1644574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1644582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1644585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1644588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1644591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644620 */     // MIs[0] policy
     /* 1644620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644630 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1644633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644654 */     // GIR_Coverage, 4420,
     /* 1644654 */     GIR_EraseRootFromParent_Done,
     /* 1644655 */   // Label 22627: @1644655
     /* 1644655 */   GIM_Try, /*On fail goto*//*Label 22628*/ GIMT_Encode4(1644741), // Rule ID 4421 //
     /* 1644660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1644668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1644671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1644674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1644677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644706 */     // MIs[0] policy
     /* 1644706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1644719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644740 */     // GIR_Coverage, 4421,
     /* 1644740 */     GIR_EraseRootFromParent_Done,
     /* 1644741 */   // Label 22628: @1644741
     /* 1644741 */   GIM_Try, /*On fail goto*//*Label 22629*/ GIMT_Encode4(1644827), // Rule ID 4424 //
     /* 1644746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1644754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1644757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1644760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1644763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644792 */     // MIs[0] policy
     /* 1644792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1644805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644826 */     // GIR_Coverage, 4424,
     /* 1644826 */     GIR_EraseRootFromParent_Done,
     /* 1644827 */   // Label 22629: @1644827
     /* 1644827 */   GIM_Try, /*On fail goto*//*Label 22630*/ GIMT_Encode4(1644913), // Rule ID 4425 //
     /* 1644832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1644840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1644843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1644846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1644849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644878 */     // MIs[0] policy
     /* 1644878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644888 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1644891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644912 */     // GIR_Coverage, 4425,
     /* 1644912 */     GIR_EraseRootFromParent_Done,
     /* 1644913 */   // Label 22630: @1644913
     /* 1644913 */   GIM_Try, /*On fail goto*//*Label 22631*/ GIMT_Encode4(1644999), // Rule ID 4428 //
     /* 1644918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1644926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1644929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1644932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1644935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644964 */     // MIs[0] policy
     /* 1644964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644974 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1644977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644998 */     // GIR_Coverage, 4428,
     /* 1644998 */     GIR_EraseRootFromParent_Done,
     /* 1644999 */   // Label 22631: @1644999
     /* 1644999 */   GIM_Try, /*On fail goto*//*Label 22632*/ GIMT_Encode4(1645085), // Rule ID 4429 //
     /* 1645004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1645012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1645015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1645018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1645021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645050 */     // MIs[0] policy
     /* 1645050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645060 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1645063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645084 */     // GIR_Coverage, 4429,
     /* 1645084 */     GIR_EraseRootFromParent_Done,
     /* 1645085 */   // Label 22632: @1645085
     /* 1645085 */   GIM_Try, /*On fail goto*//*Label 22633*/ GIMT_Encode4(1645171), // Rule ID 4432 //
     /* 1645090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1645098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1645101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1645104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1645107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1645113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645136 */     // MIs[0] policy
     /* 1645136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1645149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645170 */     // GIR_Coverage, 4432,
     /* 1645170 */     GIR_EraseRootFromParent_Done,
     /* 1645171 */   // Label 22633: @1645171
     /* 1645171 */   GIM_Try, /*On fail goto*//*Label 22634*/ GIMT_Encode4(1645257), // Rule ID 4433 //
     /* 1645176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1645184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1645187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1645190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1645193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1645199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645222 */     // MIs[0] policy
     /* 1645222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645232 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1645235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645256 */     // GIR_Coverage, 4433,
     /* 1645256 */     GIR_EraseRootFromParent_Done,
     /* 1645257 */   // Label 22634: @1645257
     /* 1645257 */   GIM_Try, /*On fail goto*//*Label 22635*/ GIMT_Encode4(1645343), // Rule ID 4436 //
     /* 1645262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1645270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1645273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1645276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1645279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645308 */     // MIs[0] policy
     /* 1645308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645318 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1645321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645342 */     // GIR_Coverage, 4436,
     /* 1645342 */     GIR_EraseRootFromParent_Done,
     /* 1645343 */   // Label 22635: @1645343
     /* 1645343 */   GIM_Try, /*On fail goto*//*Label 22636*/ GIMT_Encode4(1645429), // Rule ID 4437 //
     /* 1645348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1645356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1645359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1645362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1645365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645394 */     // MIs[0] policy
     /* 1645394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1645407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645428 */     // GIR_Coverage, 4437,
     /* 1645428 */     GIR_EraseRootFromParent_Done,
     /* 1645429 */   // Label 22636: @1645429
     /* 1645429 */   GIM_Try, /*On fail goto*//*Label 22637*/ GIMT_Encode4(1645515), // Rule ID 4440 //
     /* 1645434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1645442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1645445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1645448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1645451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645480 */     // MIs[0] policy
     /* 1645480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1645493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645514 */     // GIR_Coverage, 4440,
     /* 1645514 */     GIR_EraseRootFromParent_Done,
     /* 1645515 */   // Label 22637: @1645515
     /* 1645515 */   GIM_Try, /*On fail goto*//*Label 22638*/ GIMT_Encode4(1645601), // Rule ID 4441 //
     /* 1645520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1645528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1645531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1645534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1645537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645566 */     // MIs[0] policy
     /* 1645566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1645579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645600 */     // GIR_Coverage, 4441,
     /* 1645600 */     GIR_EraseRootFromParent_Done,
     /* 1645601 */   // Label 22638: @1645601
     /* 1645601 */   GIM_Try, /*On fail goto*//*Label 22639*/ GIMT_Encode4(1645687), // Rule ID 4444 //
     /* 1645606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1645614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1645617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1645620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1645623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645652 */     // MIs[0] policy
     /* 1645652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1645665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645686 */     // GIR_Coverage, 4444,
     /* 1645686 */     GIR_EraseRootFromParent_Done,
     /* 1645687 */   // Label 22639: @1645687
     /* 1645687 */   GIM_Try, /*On fail goto*//*Label 22640*/ GIMT_Encode4(1645773), // Rule ID 4445 //
     /* 1645692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1645700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1645703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1645706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1645709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645738 */     // MIs[0] policy
     /* 1645738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1645751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645772 */     // GIR_Coverage, 4445,
     /* 1645772 */     GIR_EraseRootFromParent_Done,
     /* 1645773 */   // Label 22640: @1645773
     /* 1645773 */   GIM_Try, /*On fail goto*//*Label 22641*/ GIMT_Encode4(1645859), // Rule ID 4448 //
     /* 1645778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1645786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1645789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1645792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1645795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645824 */     // MIs[0] policy
     /* 1645824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645834 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1645837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645858 */     // GIR_Coverage, 4448,
     /* 1645858 */     GIR_EraseRootFromParent_Done,
     /* 1645859 */   // Label 22641: @1645859
     /* 1645859 */   GIM_Try, /*On fail goto*//*Label 22642*/ GIMT_Encode4(1645945), // Rule ID 4449 //
     /* 1645864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1645872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1645875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1645878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1645881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645910 */     // MIs[0] policy
     /* 1645910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645920 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1645923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645944 */     // GIR_Coverage, 4449,
     /* 1645944 */     GIR_EraseRootFromParent_Done,
     /* 1645945 */   // Label 22642: @1645945
     /* 1645945 */   GIM_Try, /*On fail goto*//*Label 22643*/ GIMT_Encode4(1646031), // Rule ID 4452 //
     /* 1645950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1645958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1645961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1645964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1645967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645996 */     // MIs[0] policy
     /* 1645996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646006 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1646009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1646027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646030 */     // GIR_Coverage, 4452,
     /* 1646030 */     GIR_EraseRootFromParent_Done,
     /* 1646031 */   // Label 22643: @1646031
     /* 1646031 */   GIM_Try, /*On fail goto*//*Label 22644*/ GIMT_Encode4(1646117), // Rule ID 4453 //
     /* 1646036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1646044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1646047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1646050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1646053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1646059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646082 */     // MIs[0] policy
     /* 1646082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646092 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1646095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1646113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646116 */     // GIR_Coverage, 4453,
     /* 1646116 */     GIR_EraseRootFromParent_Done,
     /* 1646117 */   // Label 22644: @1646117
     /* 1646117 */   GIM_Try, /*On fail goto*//*Label 22645*/ GIMT_Encode4(1646203), // Rule ID 4456 //
     /* 1646122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1646125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1646130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1646133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1646136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1646139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646168 */     // MIs[0] policy
     /* 1646168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646178 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1646181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646202 */     // GIR_Coverage, 4456,
     /* 1646202 */     GIR_EraseRootFromParent_Done,
     /* 1646203 */   // Label 22645: @1646203
     /* 1646203 */   GIM_Try, /*On fail goto*//*Label 22646*/ GIMT_Encode4(1646289), // Rule ID 4457 //
     /* 1646208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1646211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1646216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1646219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1646222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1646225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646254 */     // MIs[0] policy
     /* 1646254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646264 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1646267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646288 */     // GIR_Coverage, 4457,
     /* 1646288 */     GIR_EraseRootFromParent_Done,
     /* 1646289 */   // Label 22646: @1646289
     /* 1646289 */   GIM_Try, /*On fail goto*//*Label 22647*/ GIMT_Encode4(1646375), // Rule ID 4460 //
     /* 1646294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1646297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1646302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1646305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1646308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1646311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646340 */     // MIs[0] policy
     /* 1646340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646350 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1646353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646374 */     // GIR_Coverage, 4460,
     /* 1646374 */     GIR_EraseRootFromParent_Done,
     /* 1646375 */   // Label 22647: @1646375
     /* 1646375 */   GIM_Try, /*On fail goto*//*Label 22648*/ GIMT_Encode4(1646461), // Rule ID 4461 //
     /* 1646380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1646383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1646388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1646391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1646394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1646397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646426 */     // MIs[0] policy
     /* 1646426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646436 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1646439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646460 */     // GIR_Coverage, 4461,
     /* 1646460 */     GIR_EraseRootFromParent_Done,
     /* 1646461 */   // Label 22648: @1646461
     /* 1646461 */   GIM_Try, /*On fail goto*//*Label 22649*/ GIMT_Encode4(1646547), // Rule ID 4464 //
     /* 1646466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1646469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1646474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1646477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1646480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1646483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646512 */     // MIs[0] policy
     /* 1646512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646522 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1646525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646546 */     // GIR_Coverage, 4464,
     /* 1646546 */     GIR_EraseRootFromParent_Done,
     /* 1646547 */   // Label 22649: @1646547
     /* 1646547 */   GIM_Try, /*On fail goto*//*Label 22650*/ GIMT_Encode4(1646633), // Rule ID 4465 //
     /* 1646552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1646555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1646560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1646563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1646566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1646569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646598 */     // MIs[0] policy
     /* 1646598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646608 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1646611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646632 */     // GIR_Coverage, 4465,
     /* 1646632 */     GIR_EraseRootFromParent_Done,
     /* 1646633 */   // Label 22650: @1646633
     /* 1646633 */   GIM_Try, /*On fail goto*//*Label 22651*/ GIMT_Encode4(1646719), // Rule ID 4468 //
     /* 1646638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1646641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1646646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1646649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1646652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1646655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646684 */     // MIs[0] policy
     /* 1646684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1646697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646718 */     // GIR_Coverage, 4468,
     /* 1646718 */     GIR_EraseRootFromParent_Done,
     /* 1646719 */   // Label 22651: @1646719
     /* 1646719 */   GIM_Try, /*On fail goto*//*Label 22652*/ GIMT_Encode4(1646805), // Rule ID 4469 //
     /* 1646724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1646727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1646732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1646735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1646738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1646741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646770 */     // MIs[0] policy
     /* 1646770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646780 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1646783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646804 */     // GIR_Coverage, 4469,
     /* 1646804 */     GIR_EraseRootFromParent_Done,
     /* 1646805 */   // Label 22652: @1646805
     /* 1646805 */   GIM_Try, /*On fail goto*//*Label 22653*/ GIMT_Encode4(1646891), // Rule ID 4478 //
     /* 1646810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1646821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1646824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1646827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1646830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646856 */     // MIs[0] policy
     /* 1646856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646866 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1646869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646890 */     // GIR_Coverage, 4478,
     /* 1646890 */     GIR_EraseRootFromParent_Done,
     /* 1646891 */   // Label 22653: @1646891
     /* 1646891 */   GIM_Try, /*On fail goto*//*Label 22654*/ GIMT_Encode4(1646977), // Rule ID 4479 //
     /* 1646896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1646907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1646910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1646913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1646916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646942 */     // MIs[0] policy
     /* 1646942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646952 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1646955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646976 */     // GIR_Coverage, 4479,
     /* 1646976 */     GIR_EraseRootFromParent_Done,
     /* 1646977 */   // Label 22654: @1646977
     /* 1646977 */   GIM_Try, /*On fail goto*//*Label 22655*/ GIMT_Encode4(1647063), // Rule ID 4488 //
     /* 1646982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1646993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1646996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1646999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1647002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647028 */     // MIs[0] policy
     /* 1647028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647038 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1647041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647062 */     // GIR_Coverage, 4488,
     /* 1647062 */     GIR_EraseRootFromParent_Done,
     /* 1647063 */   // Label 22655: @1647063
     /* 1647063 */   GIM_Try, /*On fail goto*//*Label 22656*/ GIMT_Encode4(1647149), // Rule ID 4489 //
     /* 1647068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1647079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1647082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1647085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1647088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647114 */     // MIs[0] policy
     /* 1647114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647124 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1647127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647148 */     // GIR_Coverage, 4489,
     /* 1647148 */     GIR_EraseRootFromParent_Done,
     /* 1647149 */   // Label 22656: @1647149
     /* 1647149 */   GIM_Try, /*On fail goto*//*Label 22657*/ GIMT_Encode4(1647235), // Rule ID 4498 //
     /* 1647154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1647165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1647168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1647171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1647174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647200 */     // MIs[0] policy
     /* 1647200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647210 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1647213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647234 */     // GIR_Coverage, 4498,
     /* 1647234 */     GIR_EraseRootFromParent_Done,
     /* 1647235 */   // Label 22657: @1647235
     /* 1647235 */   GIM_Try, /*On fail goto*//*Label 22658*/ GIMT_Encode4(1647321), // Rule ID 4499 //
     /* 1647240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1647251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1647254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1647257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1647260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647286 */     // MIs[0] policy
     /* 1647286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647296 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1647299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647320 */     // GIR_Coverage, 4499,
     /* 1647320 */     GIR_EraseRootFromParent_Done,
     /* 1647321 */   // Label 22658: @1647321
     /* 1647321 */   GIM_Try, /*On fail goto*//*Label 22659*/ GIMT_Encode4(1647407), // Rule ID 4508 //
     /* 1647326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1647337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1647340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1647343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1647346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647372 */     // MIs[0] policy
     /* 1647372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647382 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1647385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647406 */     // GIR_Coverage, 4508,
     /* 1647406 */     GIR_EraseRootFromParent_Done,
     /* 1647407 */   // Label 22659: @1647407
     /* 1647407 */   GIM_Try, /*On fail goto*//*Label 22660*/ GIMT_Encode4(1647493), // Rule ID 4509 //
     /* 1647412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1647423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1647426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1647429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1647432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647458 */     // MIs[0] policy
     /* 1647458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1647471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647492 */     // GIR_Coverage, 4509,
     /* 1647492 */     GIR_EraseRootFromParent_Done,
     /* 1647493 */   // Label 22660: @1647493
     /* 1647493 */   GIM_Try, /*On fail goto*//*Label 22661*/ GIMT_Encode4(1647579), // Rule ID 4518 //
     /* 1647498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1647509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1647512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1647515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1647518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1647521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647544 */     // MIs[0] policy
     /* 1647544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647554 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1647557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647578 */     // GIR_Coverage, 4518,
     /* 1647578 */     GIR_EraseRootFromParent_Done,
     /* 1647579 */   // Label 22661: @1647579
     /* 1647579 */   GIM_Try, /*On fail goto*//*Label 22662*/ GIMT_Encode4(1647665), // Rule ID 4519 //
     /* 1647584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1647595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1647598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1647601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1647604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1647607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647630 */     // MIs[0] policy
     /* 1647630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647640 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1647643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647664 */     // GIR_Coverage, 4519,
     /* 1647664 */     GIR_EraseRootFromParent_Done,
     /* 1647665 */   // Label 22662: @1647665
     /* 1647665 */   GIM_Try, /*On fail goto*//*Label 22663*/ GIMT_Encode4(1647751), // Rule ID 4528 //
     /* 1647670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1647681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1647684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1647687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1647690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1647693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647716 */     // MIs[0] policy
     /* 1647716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647726 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1647729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647750 */     // GIR_Coverage, 4528,
     /* 1647750 */     GIR_EraseRootFromParent_Done,
     /* 1647751 */   // Label 22663: @1647751
     /* 1647751 */   GIM_Try, /*On fail goto*//*Label 22664*/ GIMT_Encode4(1647837), // Rule ID 4529 //
     /* 1647756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1647767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1647770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1647773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1647776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1647779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647802 */     // MIs[0] policy
     /* 1647802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647812 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1647815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647836 */     // GIR_Coverage, 4529,
     /* 1647836 */     GIR_EraseRootFromParent_Done,
     /* 1647837 */   // Label 22664: @1647837
     /* 1647837 */   GIM_Try, /*On fail goto*//*Label 22665*/ GIMT_Encode4(1647923), // Rule ID 4538 //
     /* 1647842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1647853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1647856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1647859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1647862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647888 */     // MIs[0] policy
     /* 1647888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647898 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1647901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647922 */     // GIR_Coverage, 4538,
     /* 1647922 */     GIR_EraseRootFromParent_Done,
     /* 1647923 */   // Label 22665: @1647923
     /* 1647923 */   GIM_Try, /*On fail goto*//*Label 22666*/ GIMT_Encode4(1648009), // Rule ID 4539 //
     /* 1647928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1647939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1647942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1647945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1647948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647974 */     // MIs[0] policy
     /* 1647974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647984 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1647987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648008 */     // GIR_Coverage, 4539,
     /* 1648008 */     GIR_EraseRootFromParent_Done,
     /* 1648009 */   // Label 22666: @1648009
     /* 1648009 */   GIM_Try, /*On fail goto*//*Label 22667*/ GIMT_Encode4(1648095), // Rule ID 4548 //
     /* 1648014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1648025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1648028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1648031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1648034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648060 */     // MIs[0] policy
     /* 1648060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648070 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1648073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648094 */     // GIR_Coverage, 4548,
     /* 1648094 */     GIR_EraseRootFromParent_Done,
     /* 1648095 */   // Label 22667: @1648095
     /* 1648095 */   GIM_Try, /*On fail goto*//*Label 22668*/ GIMT_Encode4(1648181), // Rule ID 4549 //
     /* 1648100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1648111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1648114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1648117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1648120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648146 */     // MIs[0] policy
     /* 1648146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1648159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648180 */     // GIR_Coverage, 4549,
     /* 1648180 */     GIR_EraseRootFromParent_Done,
     /* 1648181 */   // Label 22668: @1648181
     /* 1648181 */   GIM_Try, /*On fail goto*//*Label 22669*/ GIMT_Encode4(1648267), // Rule ID 4558 //
     /* 1648186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1648197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1648200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1648203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1648206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648232 */     // MIs[0] policy
     /* 1648232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1648245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648266 */     // GIR_Coverage, 4558,
     /* 1648266 */     GIR_EraseRootFromParent_Done,
     /* 1648267 */   // Label 22669: @1648267
     /* 1648267 */   GIM_Try, /*On fail goto*//*Label 22670*/ GIMT_Encode4(1648353), // Rule ID 4559 //
     /* 1648272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1648283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1648286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1648289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1648292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648318 */     // MIs[0] policy
     /* 1648318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1648331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648352 */     // GIR_Coverage, 4559,
     /* 1648352 */     GIR_EraseRootFromParent_Done,
     /* 1648353 */   // Label 22670: @1648353
     /* 1648353 */   GIM_Try, /*On fail goto*//*Label 22671*/ GIMT_Encode4(1648439), // Rule ID 4568 //
     /* 1648358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1648369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1648372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1648375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1648378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648404 */     // MIs[0] policy
     /* 1648404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648414 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1648417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648438 */     // GIR_Coverage, 4568,
     /* 1648438 */     GIR_EraseRootFromParent_Done,
     /* 1648439 */   // Label 22671: @1648439
     /* 1648439 */   GIM_Try, /*On fail goto*//*Label 22672*/ GIMT_Encode4(1648525), // Rule ID 4569 //
     /* 1648444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1648455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1648458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1648461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1648464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648490 */     // MIs[0] policy
     /* 1648490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1648503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648524 */     // GIR_Coverage, 4569,
     /* 1648524 */     GIR_EraseRootFromParent_Done,
     /* 1648525 */   // Label 22672: @1648525
     /* 1648525 */   GIM_Try, /*On fail goto*//*Label 22673*/ GIMT_Encode4(1648611), // Rule ID 4578 //
     /* 1648530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1648541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1648544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1648547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1648550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1648553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648576 */     // MIs[0] policy
     /* 1648576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648586 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1648589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648610 */     // GIR_Coverage, 4578,
     /* 1648610 */     GIR_EraseRootFromParent_Done,
     /* 1648611 */   // Label 22673: @1648611
     /* 1648611 */   GIM_Try, /*On fail goto*//*Label 22674*/ GIMT_Encode4(1648697), // Rule ID 4579 //
     /* 1648616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1648627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1648630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1648633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1648636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1648639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648662 */     // MIs[0] policy
     /* 1648662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648672 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1648675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648696 */     // GIR_Coverage, 4579,
     /* 1648696 */     GIR_EraseRootFromParent_Done,
     /* 1648697 */   // Label 22674: @1648697
     /* 1648697 */   GIM_Try, /*On fail goto*//*Label 22675*/ GIMT_Encode4(1648783), // Rule ID 4588 //
     /* 1648702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1648705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1648713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1648716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1648719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1648722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648748 */     // MIs[0] policy
     /* 1648748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648758 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1648761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648782 */     // GIR_Coverage, 4588,
     /* 1648782 */     GIR_EraseRootFromParent_Done,
     /* 1648783 */   // Label 22675: @1648783
     /* 1648783 */   GIM_Try, /*On fail goto*//*Label 22676*/ GIMT_Encode4(1648869), // Rule ID 4589 //
     /* 1648788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1648799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1648802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1648805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1648808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648834 */     // MIs[0] policy
     /* 1648834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648844 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1648847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648868 */     // GIR_Coverage, 4589,
     /* 1648868 */     GIR_EraseRootFromParent_Done,
     /* 1648869 */   // Label 22676: @1648869
     /* 1648869 */   GIM_Try, /*On fail goto*//*Label 22677*/ GIMT_Encode4(1648955), // Rule ID 4598 //
     /* 1648874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1648877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1648885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1648888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1648891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1648894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648920 */     // MIs[0] policy
     /* 1648920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648930 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1648933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648954 */     // GIR_Coverage, 4598,
     /* 1648954 */     GIR_EraseRootFromParent_Done,
     /* 1648955 */   // Label 22677: @1648955
     /* 1648955 */   GIM_Try, /*On fail goto*//*Label 22678*/ GIMT_Encode4(1649041), // Rule ID 4599 //
     /* 1648960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1648971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1648974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1648977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1648980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649006 */     // MIs[0] policy
     /* 1649006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649016 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1649019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649040 */     // GIR_Coverage, 4599,
     /* 1649040 */     GIR_EraseRootFromParent_Done,
     /* 1649041 */   // Label 22678: @1649041
     /* 1649041 */   GIM_Try, /*On fail goto*//*Label 22679*/ GIMT_Encode4(1649127), // Rule ID 4608 //
     /* 1649046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1649049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1649054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1649057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1649060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1649063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1649066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649092 */     // MIs[0] policy
     /* 1649092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649102 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1649105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649126 */     // GIR_Coverage, 4608,
     /* 1649126 */     GIR_EraseRootFromParent_Done,
     /* 1649127 */   // Label 22679: @1649127
     /* 1649127 */   GIM_Try, /*On fail goto*//*Label 22680*/ GIMT_Encode4(1649213), // Rule ID 4609 //
     /* 1649132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1649135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1649140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1649143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1649146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1649149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1649152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649178 */     // MIs[0] policy
     /* 1649178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649188 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1649191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649212 */     // GIR_Coverage, 4609,
     /* 1649212 */     GIR_EraseRootFromParent_Done,
     /* 1649213 */   // Label 22680: @1649213
     /* 1649213 */   GIM_Try, /*On fail goto*//*Label 22681*/ GIMT_Encode4(1649299), // Rule ID 4618 //
     /* 1649218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1649221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1649226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1649229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1649232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1649235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1649238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649264 */     // MIs[0] policy
     /* 1649264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649274 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1649277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649298 */     // GIR_Coverage, 4618,
     /* 1649298 */     GIR_EraseRootFromParent_Done,
     /* 1649299 */   // Label 22681: @1649299
     /* 1649299 */   GIM_Try, /*On fail goto*//*Label 22682*/ GIMT_Encode4(1649385), // Rule ID 4619 //
     /* 1649304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1649307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1649312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1649315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1649318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1649321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1649324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649350 */     // MIs[0] policy
     /* 1649350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649360 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1649363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649384 */     // GIR_Coverage, 4619,
     /* 1649384 */     GIR_EraseRootFromParent_Done,
     /* 1649385 */   // Label 22682: @1649385
     /* 1649385 */   GIM_Try, /*On fail goto*//*Label 22683*/ GIMT_Encode4(1649471), // Rule ID 4622 //
     /* 1649390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1649398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1649401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1649404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1649407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1649410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649436 */     // MIs[0] policy
     /* 1649436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1649449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649470 */     // GIR_Coverage, 4622,
     /* 1649470 */     GIR_EraseRootFromParent_Done,
     /* 1649471 */   // Label 22683: @1649471
     /* 1649471 */   GIM_Try, /*On fail goto*//*Label 22684*/ GIMT_Encode4(1649557), // Rule ID 4623 //
     /* 1649476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1649484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1649487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1649490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1649493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1649496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649522 */     // MIs[0] policy
     /* 1649522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649532 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1649535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649556 */     // GIR_Coverage, 4623,
     /* 1649556 */     GIR_EraseRootFromParent_Done,
     /* 1649557 */   // Label 22684: @1649557
     /* 1649557 */   GIM_Try, /*On fail goto*//*Label 22685*/ GIMT_Encode4(1649643), // Rule ID 4626 //
     /* 1649562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1649570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1649573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1649576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1649579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1649582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649608 */     // MIs[0] policy
     /* 1649608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649618 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1649621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649642 */     // GIR_Coverage, 4626,
     /* 1649642 */     GIR_EraseRootFromParent_Done,
     /* 1649643 */   // Label 22685: @1649643
     /* 1649643 */   GIM_Try, /*On fail goto*//*Label 22686*/ GIMT_Encode4(1649729), // Rule ID 4627 //
     /* 1649648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1649656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1649659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1649662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1649665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1649668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649694 */     // MIs[0] policy
     /* 1649694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649704 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1649707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649728 */     // GIR_Coverage, 4627,
     /* 1649728 */     GIR_EraseRootFromParent_Done,
     /* 1649729 */   // Label 22686: @1649729
     /* 1649729 */   GIM_Try, /*On fail goto*//*Label 22687*/ GIMT_Encode4(1649815), // Rule ID 4630 //
     /* 1649734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1649742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1649745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1649748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1649751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1649754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649780 */     // MIs[0] policy
     /* 1649780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1649793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649814 */     // GIR_Coverage, 4630,
     /* 1649814 */     GIR_EraseRootFromParent_Done,
     /* 1649815 */   // Label 22687: @1649815
     /* 1649815 */   GIM_Try, /*On fail goto*//*Label 22688*/ GIMT_Encode4(1649901), // Rule ID 4631 //
     /* 1649820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1649828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1649831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1649834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1649837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1649840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649866 */     // MIs[0] policy
     /* 1649866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1649879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649900 */     // GIR_Coverage, 4631,
     /* 1649900 */     GIR_EraseRootFromParent_Done,
     /* 1649901 */   // Label 22688: @1649901
     /* 1649901 */   GIM_Try, /*On fail goto*//*Label 22689*/ GIMT_Encode4(1649987), // Rule ID 4634 //
     /* 1649906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1649914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1649917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1649920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1649923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1649926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649952 */     // MIs[0] policy
     /* 1649952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1649965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649986 */     // GIR_Coverage, 4634,
     /* 1649986 */     GIR_EraseRootFromParent_Done,
     /* 1649987 */   // Label 22689: @1649987
     /* 1649987 */   GIM_Try, /*On fail goto*//*Label 22690*/ GIMT_Encode4(1650073), // Rule ID 4635 //
     /* 1649992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1650000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1650003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1650006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1650009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650038 */     // MIs[0] policy
     /* 1650038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1650051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650072 */     // GIR_Coverage, 4635,
     /* 1650072 */     GIR_EraseRootFromParent_Done,
     /* 1650073 */   // Label 22690: @1650073
     /* 1650073 */   GIM_Try, /*On fail goto*//*Label 22691*/ GIMT_Encode4(1650159), // Rule ID 4638 //
     /* 1650078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1650086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1650089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1650092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1650095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1650101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650124 */     // MIs[0] policy
     /* 1650124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1650137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650158 */     // GIR_Coverage, 4638,
     /* 1650158 */     GIR_EraseRootFromParent_Done,
     /* 1650159 */   // Label 22691: @1650159
     /* 1650159 */   GIM_Try, /*On fail goto*//*Label 22692*/ GIMT_Encode4(1650245), // Rule ID 4639 //
     /* 1650164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1650172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1650175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1650178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1650181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1650187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650210 */     // MIs[0] policy
     /* 1650210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650220 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1650223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650244 */     // GIR_Coverage, 4639,
     /* 1650244 */     GIR_EraseRootFromParent_Done,
     /* 1650245 */   // Label 22692: @1650245
     /* 1650245 */   GIM_Try, /*On fail goto*//*Label 22693*/ GIMT_Encode4(1650331), // Rule ID 4642 //
     /* 1650250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1650258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1650261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1650264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1650267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1650273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650296 */     // MIs[0] policy
     /* 1650296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650306 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1650309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650330 */     // GIR_Coverage, 4642,
     /* 1650330 */     GIR_EraseRootFromParent_Done,
     /* 1650331 */   // Label 22693: @1650331
     /* 1650331 */   GIM_Try, /*On fail goto*//*Label 22694*/ GIMT_Encode4(1650417), // Rule ID 4643 //
     /* 1650336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1650344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1650347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1650350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1650353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1650359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650382 */     // MIs[0] policy
     /* 1650382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650392 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1650395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650416 */     // GIR_Coverage, 4643,
     /* 1650416 */     GIR_EraseRootFromParent_Done,
     /* 1650417 */   // Label 22694: @1650417
     /* 1650417 */   GIM_Try, /*On fail goto*//*Label 22695*/ GIMT_Encode4(1650503), // Rule ID 4646 //
     /* 1650422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1650430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1650433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1650436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1650439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650468 */     // MIs[0] policy
     /* 1650468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1650481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650502 */     // GIR_Coverage, 4646,
     /* 1650502 */     GIR_EraseRootFromParent_Done,
     /* 1650503 */   // Label 22695: @1650503
     /* 1650503 */   GIM_Try, /*On fail goto*//*Label 22696*/ GIMT_Encode4(1650589), // Rule ID 4647 //
     /* 1650508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1650516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1650519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1650522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1650525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650554 */     // MIs[0] policy
     /* 1650554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650564 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1650567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650588 */     // GIR_Coverage, 4647,
     /* 1650588 */     GIR_EraseRootFromParent_Done,
     /* 1650589 */   // Label 22696: @1650589
     /* 1650589 */   GIM_Try, /*On fail goto*//*Label 22697*/ GIMT_Encode4(1650675), // Rule ID 4650 //
     /* 1650594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1650602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1650605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1650608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1650611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650640 */     // MIs[0] policy
     /* 1650640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1650653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650674 */     // GIR_Coverage, 4650,
     /* 1650674 */     GIR_EraseRootFromParent_Done,
     /* 1650675 */   // Label 22697: @1650675
     /* 1650675 */   GIM_Try, /*On fail goto*//*Label 22698*/ GIMT_Encode4(1650761), // Rule ID 4651 //
     /* 1650680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1650688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1650691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1650694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1650697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650726 */     // MIs[0] policy
     /* 1650726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1650739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650760 */     // GIR_Coverage, 4651,
     /* 1650760 */     GIR_EraseRootFromParent_Done,
     /* 1650761 */   // Label 22698: @1650761
     /* 1650761 */   GIM_Try, /*On fail goto*//*Label 22699*/ GIMT_Encode4(1650847), // Rule ID 4654 //
     /* 1650766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1650774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1650777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1650780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1650783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650812 */     // MIs[0] policy
     /* 1650812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1650825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650846 */     // GIR_Coverage, 4654,
     /* 1650846 */     GIR_EraseRootFromParent_Done,
     /* 1650847 */   // Label 22699: @1650847
     /* 1650847 */   GIM_Try, /*On fail goto*//*Label 22700*/ GIMT_Encode4(1650933), // Rule ID 4655 //
     /* 1650852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1650860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1650863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1650866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1650869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650898 */     // MIs[0] policy
     /* 1650898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650908 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1650911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650932 */     // GIR_Coverage, 4655,
     /* 1650932 */     GIR_EraseRootFromParent_Done,
     /* 1650933 */   // Label 22700: @1650933
     /* 1650933 */   GIM_Try, /*On fail goto*//*Label 22701*/ GIMT_Encode4(1651019), // Rule ID 4658 //
     /* 1650938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1650946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1650949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1650952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1650955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650984 */     // MIs[0] policy
     /* 1650984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1650997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651018 */     // GIR_Coverage, 4658,
     /* 1651018 */     GIR_EraseRootFromParent_Done,
     /* 1651019 */   // Label 22701: @1651019
     /* 1651019 */   GIM_Try, /*On fail goto*//*Label 22702*/ GIMT_Encode4(1651105), // Rule ID 4659 //
     /* 1651024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1651032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1651035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1651038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1651041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651070 */     // MIs[0] policy
     /* 1651070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651080 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1651083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651104 */     // GIR_Coverage, 4659,
     /* 1651104 */     GIR_EraseRootFromParent_Done,
     /* 1651105 */   // Label 22702: @1651105
     /* 1651105 */   GIM_Try, /*On fail goto*//*Label 22703*/ GIMT_Encode4(1651191), // Rule ID 4662 //
     /* 1651110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1651118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1651121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1651124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1651127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651156 */     // MIs[0] policy
     /* 1651156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1651169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651190 */     // GIR_Coverage, 4662,
     /* 1651190 */     GIR_EraseRootFromParent_Done,
     /* 1651191 */   // Label 22703: @1651191
     /* 1651191 */   GIM_Try, /*On fail goto*//*Label 22704*/ GIMT_Encode4(1651277), // Rule ID 4663 //
     /* 1651196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1651204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1651207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1651210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1651213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651242 */     // MIs[0] policy
     /* 1651242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651252 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1651255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651276 */     // GIR_Coverage, 4663,
     /* 1651276 */     GIR_EraseRootFromParent_Done,
     /* 1651277 */   // Label 22704: @1651277
     /* 1651277 */   GIM_Try, /*On fail goto*//*Label 22705*/ GIMT_Encode4(1651363), // Rule ID 4666 //
     /* 1651282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1651285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1651290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1651293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1651296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1651299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651328 */     // MIs[0] policy
     /* 1651328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651338 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1651341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651362 */     // GIR_Coverage, 4666,
     /* 1651362 */     GIR_EraseRootFromParent_Done,
     /* 1651363 */   // Label 22705: @1651363
     /* 1651363 */   GIM_Try, /*On fail goto*//*Label 22706*/ GIMT_Encode4(1651449), // Rule ID 4667 //
     /* 1651368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1651371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1651376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1651379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1651382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1651385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651414 */     // MIs[0] policy
     /* 1651414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651424 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1651427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651448 */     // GIR_Coverage, 4667,
     /* 1651448 */     GIR_EraseRootFromParent_Done,
     /* 1651449 */   // Label 22706: @1651449
     /* 1651449 */   GIM_Try, /*On fail goto*//*Label 22707*/ GIMT_Encode4(1651535), // Rule ID 4670 //
     /* 1651454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1651457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1651462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1651465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1651468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1651471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651500 */     // MIs[0] policy
     /* 1651500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651510 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1651513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651534 */     // GIR_Coverage, 4670,
     /* 1651534 */     GIR_EraseRootFromParent_Done,
     /* 1651535 */   // Label 22707: @1651535
     /* 1651535 */   GIM_Try, /*On fail goto*//*Label 22708*/ GIMT_Encode4(1651621), // Rule ID 4671 //
     /* 1651540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1651543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1651548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1651551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1651554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1651557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651586 */     // MIs[0] policy
     /* 1651586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1651599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651620 */     // GIR_Coverage, 4671,
     /* 1651620 */     GIR_EraseRootFromParent_Done,
     /* 1651621 */   // Label 22708: @1651621
     /* 1651621 */   GIM_Try, /*On fail goto*//*Label 22709*/ GIMT_Encode4(1651707), // Rule ID 4674 //
     /* 1651626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1651629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1651634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1651637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1651640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1651643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651672 */     // MIs[0] policy
     /* 1651672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651682 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1651685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651706 */     // GIR_Coverage, 4674,
     /* 1651706 */     GIR_EraseRootFromParent_Done,
     /* 1651707 */   // Label 22709: @1651707
     /* 1651707 */   GIM_Try, /*On fail goto*//*Label 22710*/ GIMT_Encode4(1651793), // Rule ID 4675 //
     /* 1651712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1651715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1651720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1651723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1651726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1651729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651758 */     // MIs[0] policy
     /* 1651758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651768 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1651771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651792 */     // GIR_Coverage, 4675,
     /* 1651792 */     GIR_EraseRootFromParent_Done,
     /* 1651793 */   // Label 22710: @1651793
     /* 1651793 */   GIM_Try, /*On fail goto*//*Label 22711*/ GIMT_Encode4(1651879), // Rule ID 4678 //
     /* 1651798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1651801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1651806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1651809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1651812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1651815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651844 */     // MIs[0] policy
     /* 1651844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651854 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1651857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651878 */     // GIR_Coverage, 4678,
     /* 1651878 */     GIR_EraseRootFromParent_Done,
     /* 1651879 */   // Label 22711: @1651879
     /* 1651879 */   GIM_Try, /*On fail goto*//*Label 22712*/ GIMT_Encode4(1651965), // Rule ID 4679 //
     /* 1651884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1651887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1651892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1651895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1651898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1651901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651930 */     // MIs[0] policy
     /* 1651930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651940 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1651943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651964 */     // GIR_Coverage, 4679,
     /* 1651964 */     GIR_EraseRootFromParent_Done,
     /* 1651965 */   // Label 22712: @1651965
     /* 1651965 */   GIM_Try, /*On fail goto*//*Label 22713*/ GIMT_Encode4(1652051), // Rule ID 4688 //
     /* 1651970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1651981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1651984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1651987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1651990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652016 */     // MIs[0] policy
     /* 1652016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1652029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652050 */     // GIR_Coverage, 4688,
     /* 1652050 */     GIR_EraseRootFromParent_Done,
     /* 1652051 */   // Label 22713: @1652051
     /* 1652051 */   GIM_Try, /*On fail goto*//*Label 22714*/ GIMT_Encode4(1652137), // Rule ID 4689 //
     /* 1652056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1652067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1652070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1652073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1652076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652102 */     // MIs[0] policy
     /* 1652102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652112 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1652115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652136 */     // GIR_Coverage, 4689,
     /* 1652136 */     GIR_EraseRootFromParent_Done,
     /* 1652137 */   // Label 22714: @1652137
     /* 1652137 */   GIM_Try, /*On fail goto*//*Label 22715*/ GIMT_Encode4(1652223), // Rule ID 4698 //
     /* 1652142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1652153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1652156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1652159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1652162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652188 */     // MIs[0] policy
     /* 1652188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652198 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1652201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652222 */     // GIR_Coverage, 4698,
     /* 1652222 */     GIR_EraseRootFromParent_Done,
     /* 1652223 */   // Label 22715: @1652223
     /* 1652223 */   GIM_Try, /*On fail goto*//*Label 22716*/ GIMT_Encode4(1652309), // Rule ID 4699 //
     /* 1652228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1652239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1652242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1652245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1652248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652274 */     // MIs[0] policy
     /* 1652274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652284 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1652287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652308 */     // GIR_Coverage, 4699,
     /* 1652308 */     GIR_EraseRootFromParent_Done,
     /* 1652309 */   // Label 22716: @1652309
     /* 1652309 */   GIM_Try, /*On fail goto*//*Label 22717*/ GIMT_Encode4(1652395), // Rule ID 4708 //
     /* 1652314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1652325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1652328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1652331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1652334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652360 */     // MIs[0] policy
     /* 1652360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652370 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1652373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652394 */     // GIR_Coverage, 4708,
     /* 1652394 */     GIR_EraseRootFromParent_Done,
     /* 1652395 */   // Label 22717: @1652395
     /* 1652395 */   GIM_Try, /*On fail goto*//*Label 22718*/ GIMT_Encode4(1652481), // Rule ID 4709 //
     /* 1652400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1652411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1652414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1652417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1652420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652446 */     // MIs[0] policy
     /* 1652446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652456 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1652459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652480 */     // GIR_Coverage, 4709,
     /* 1652480 */     GIR_EraseRootFromParent_Done,
     /* 1652481 */   // Label 22718: @1652481
     /* 1652481 */   GIM_Try, /*On fail goto*//*Label 22719*/ GIMT_Encode4(1652567), // Rule ID 4718 //
     /* 1652486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1652497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1652500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1652503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1652506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652532 */     // MIs[0] policy
     /* 1652532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652542 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1652545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652566 */     // GIR_Coverage, 4718,
     /* 1652566 */     GIR_EraseRootFromParent_Done,
     /* 1652567 */   // Label 22719: @1652567
     /* 1652567 */   GIM_Try, /*On fail goto*//*Label 22720*/ GIMT_Encode4(1652653), // Rule ID 4719 //
     /* 1652572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1652583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1652586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1652589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1652592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652618 */     // MIs[0] policy
     /* 1652618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652628 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1652631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652652 */     // GIR_Coverage, 4719,
     /* 1652652 */     GIR_EraseRootFromParent_Done,
     /* 1652653 */   // Label 22720: @1652653
     /* 1652653 */   GIM_Try, /*On fail goto*//*Label 22721*/ GIMT_Encode4(1652739), // Rule ID 4728 //
     /* 1652658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1652669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1652672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1652675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1652678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652704 */     // MIs[0] policy
     /* 1652704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652714 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1652717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652738 */     // GIR_Coverage, 4728,
     /* 1652738 */     GIR_EraseRootFromParent_Done,
     /* 1652739 */   // Label 22721: @1652739
     /* 1652739 */   GIM_Try, /*On fail goto*//*Label 22722*/ GIMT_Encode4(1652825), // Rule ID 4729 //
     /* 1652744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1652755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1652758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1652761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1652764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652790 */     // MIs[0] policy
     /* 1652790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652800 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1652803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652824 */     // GIR_Coverage, 4729,
     /* 1652824 */     GIR_EraseRootFromParent_Done,
     /* 1652825 */   // Label 22722: @1652825
     /* 1652825 */   GIM_Try, /*On fail goto*//*Label 22723*/ GIMT_Encode4(1652911), // Rule ID 4738 //
     /* 1652830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1652841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1652844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1652847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1652850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1652853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652876 */     // MIs[0] policy
     /* 1652876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652886 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1652889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652910 */     // GIR_Coverage, 4738,
     /* 1652910 */     GIR_EraseRootFromParent_Done,
     /* 1652911 */   // Label 22723: @1652911
     /* 1652911 */   GIM_Try, /*On fail goto*//*Label 22724*/ GIMT_Encode4(1652997), // Rule ID 4739 //
     /* 1652916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1652927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1652930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1652933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1652936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1652939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652962 */     // MIs[0] policy
     /* 1652962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652972 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1652975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652996 */     // GIR_Coverage, 4739,
     /* 1652996 */     GIR_EraseRootFromParent_Done,
     /* 1652997 */   // Label 22724: @1652997
     /* 1652997 */   GIM_Try, /*On fail goto*//*Label 22725*/ GIMT_Encode4(1653083), // Rule ID 4748 //
     /* 1653002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1653013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1653016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1653019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1653022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653048 */     // MIs[0] policy
     /* 1653048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653058 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1653061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653082 */     // GIR_Coverage, 4748,
     /* 1653082 */     GIR_EraseRootFromParent_Done,
     /* 1653083 */   // Label 22725: @1653083
     /* 1653083 */   GIM_Try, /*On fail goto*//*Label 22726*/ GIMT_Encode4(1653169), // Rule ID 4749 //
     /* 1653088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1653099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1653102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1653105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1653108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653134 */     // MIs[0] policy
     /* 1653134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653144 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1653147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653168 */     // GIR_Coverage, 4749,
     /* 1653168 */     GIR_EraseRootFromParent_Done,
     /* 1653169 */   // Label 22726: @1653169
     /* 1653169 */   GIM_Try, /*On fail goto*//*Label 22727*/ GIMT_Encode4(1653255), // Rule ID 4758 //
     /* 1653174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1653185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1653188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1653191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1653194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653220 */     // MIs[0] policy
     /* 1653220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1653233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653254 */     // GIR_Coverage, 4758,
     /* 1653254 */     GIR_EraseRootFromParent_Done,
     /* 1653255 */   // Label 22727: @1653255
     /* 1653255 */   GIM_Try, /*On fail goto*//*Label 22728*/ GIMT_Encode4(1653341), // Rule ID 4759 //
     /* 1653260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1653271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1653274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1653277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1653280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653306 */     // MIs[0] policy
     /* 1653306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1653319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653340 */     // GIR_Coverage, 4759,
     /* 1653340 */     GIR_EraseRootFromParent_Done,
     /* 1653341 */   // Label 22728: @1653341
     /* 1653341 */   GIM_Try, /*On fail goto*//*Label 22729*/ GIMT_Encode4(1653427), // Rule ID 4768 //
     /* 1653346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1653357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1653360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1653363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1653366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653392 */     // MIs[0] policy
     /* 1653392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1653405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653426 */     // GIR_Coverage, 4768,
     /* 1653426 */     GIR_EraseRootFromParent_Done,
     /* 1653427 */   // Label 22729: @1653427
     /* 1653427 */   GIM_Try, /*On fail goto*//*Label 22730*/ GIMT_Encode4(1653513), // Rule ID 4769 //
     /* 1653432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1653443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1653446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1653449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1653452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653478 */     // MIs[0] policy
     /* 1653478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653488 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1653491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653512 */     // GIR_Coverage, 4769,
     /* 1653512 */     GIR_EraseRootFromParent_Done,
     /* 1653513 */   // Label 22730: @1653513
     /* 1653513 */   GIM_Try, /*On fail goto*//*Label 22731*/ GIMT_Encode4(1653599), // Rule ID 4778 //
     /* 1653518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1653529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1653532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1653535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1653538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653564 */     // MIs[0] policy
     /* 1653564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1653577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653598 */     // GIR_Coverage, 4778,
     /* 1653598 */     GIR_EraseRootFromParent_Done,
     /* 1653599 */   // Label 22731: @1653599
     /* 1653599 */   GIM_Try, /*On fail goto*//*Label 22732*/ GIMT_Encode4(1653685), // Rule ID 4779 //
     /* 1653604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1653615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1653618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1653621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1653624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653650 */     // MIs[0] policy
     /* 1653650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653660 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1653663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653684 */     // GIR_Coverage, 4779,
     /* 1653684 */     GIR_EraseRootFromParent_Done,
     /* 1653685 */   // Label 22732: @1653685
     /* 1653685 */   GIM_Try, /*On fail goto*//*Label 22733*/ GIMT_Encode4(1653771), // Rule ID 4788 //
     /* 1653690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1653701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1653704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1653707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1653710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1653713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653736 */     // MIs[0] policy
     /* 1653736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653746 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1653749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653770 */     // GIR_Coverage, 4788,
     /* 1653770 */     GIR_EraseRootFromParent_Done,
     /* 1653771 */   // Label 22733: @1653771
     /* 1653771 */   GIM_Try, /*On fail goto*//*Label 22734*/ GIMT_Encode4(1653857), // Rule ID 4789 //
     /* 1653776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1653787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1653790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1653793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1653796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1653799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653822 */     // MIs[0] policy
     /* 1653822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653832 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1653835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653856 */     // GIR_Coverage, 4789,
     /* 1653856 */     GIR_EraseRootFromParent_Done,
     /* 1653857 */   // Label 22734: @1653857
     /* 1653857 */   GIM_Try, /*On fail goto*//*Label 22735*/ GIMT_Encode4(1653943), // Rule ID 4798 //
     /* 1653862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1653865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1653873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1653876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1653879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1653882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653908 */     // MIs[0] policy
     /* 1653908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653918 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1653921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653942 */     // GIR_Coverage, 4798,
     /* 1653942 */     GIR_EraseRootFromParent_Done,
     /* 1653943 */   // Label 22735: @1653943
     /* 1653943 */   GIM_Try, /*On fail goto*//*Label 22736*/ GIMT_Encode4(1654029), // Rule ID 4799 //
     /* 1653948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1653951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1653959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1653962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1653965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1653968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653994 */     // MIs[0] policy
     /* 1653994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654004 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1654007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654028 */     // GIR_Coverage, 4799,
     /* 1654028 */     GIR_EraseRootFromParent_Done,
     /* 1654029 */   // Label 22736: @1654029
     /* 1654029 */   GIM_Try, /*On fail goto*//*Label 22737*/ GIMT_Encode4(1654115), // Rule ID 4808 //
     /* 1654034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1654037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1654042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1654045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1654048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1654051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1654054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1654064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654080 */     // MIs[0] policy
     /* 1654080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654090 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1654093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654114 */     // GIR_Coverage, 4808,
     /* 1654114 */     GIR_EraseRootFromParent_Done,
     /* 1654115 */   // Label 22737: @1654115
     /* 1654115 */   GIM_Try, /*On fail goto*//*Label 22738*/ GIMT_Encode4(1654201), // Rule ID 4809 //
     /* 1654120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1654123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1654128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1654131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1654134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1654137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1654140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1654150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654166 */     // MIs[0] policy
     /* 1654166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654176 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1654179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654200 */     // GIR_Coverage, 4809,
     /* 1654200 */     GIR_EraseRootFromParent_Done,
     /* 1654201 */   // Label 22738: @1654201
     /* 1654201 */   GIM_Try, /*On fail goto*//*Label 22739*/ GIMT_Encode4(1654287), // Rule ID 4818 //
     /* 1654206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1654209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1654214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1654217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1654220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1654223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1654226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1654236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654252 */     // MIs[0] policy
     /* 1654252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654262 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1654265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654286 */     // GIR_Coverage, 4818,
     /* 1654286 */     GIR_EraseRootFromParent_Done,
     /* 1654287 */   // Label 22739: @1654287
     /* 1654287 */   GIM_Try, /*On fail goto*//*Label 22740*/ GIMT_Encode4(1654373), // Rule ID 4819 //
     /* 1654292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1654295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1654300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1654303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1654306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1654309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1654312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1654322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654338 */     // MIs[0] policy
     /* 1654338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654348 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1654351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654372 */     // GIR_Coverage, 4819,
     /* 1654372 */     GIR_EraseRootFromParent_Done,
     /* 1654373 */   // Label 22740: @1654373
     /* 1654373 */   GIM_Try, /*On fail goto*//*Label 22741*/ GIMT_Encode4(1654459), // Rule ID 4828 //
     /* 1654378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1654381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1654386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1654389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1654392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1654395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1654398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1654408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654424 */     // MIs[0] policy
     /* 1654424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1654437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654458 */     // GIR_Coverage, 4828,
     /* 1654458 */     GIR_EraseRootFromParent_Done,
     /* 1654459 */   // Label 22741: @1654459
     /* 1654459 */   GIM_Try, /*On fail goto*//*Label 22742*/ GIMT_Encode4(1654545), // Rule ID 4829 //
     /* 1654464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1654467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1654472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1654475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1654478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1654481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1654484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1654494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654510 */     // MIs[0] policy
     /* 1654510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654520 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1654523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654544 */     // GIR_Coverage, 4829,
     /* 1654544 */     GIR_EraseRootFromParent_Done,
     /* 1654545 */   // Label 22742: @1654545
     /* 1654545 */   GIM_Try, /*On fail goto*//*Label 22743*/ GIMT_Encode4(1654631), // Rule ID 4832 //
     /* 1654550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1654558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1654561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1654564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1654567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1654570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1654592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654596 */     // MIs[0] policy
     /* 1654596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654606 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1654609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654630 */     // GIR_Coverage, 4832,
     /* 1654630 */     GIR_EraseRootFromParent_Done,
     /* 1654631 */   // Label 22743: @1654631
     /* 1654631 */   GIM_Try, /*On fail goto*//*Label 22744*/ GIMT_Encode4(1654717), // Rule ID 4833 //
     /* 1654636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1654644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1654647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1654650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1654653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1654656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1654678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654682 */     // MIs[0] policy
     /* 1654682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654692 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1654695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654716 */     // GIR_Coverage, 4833,
     /* 1654716 */     GIR_EraseRootFromParent_Done,
     /* 1654717 */   // Label 22744: @1654717
     /* 1654717 */   GIM_Try, /*On fail goto*//*Label 22745*/ GIMT_Encode4(1654803), // Rule ID 4836 //
     /* 1654722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1654730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1654733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1654736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1654739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1654742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1654764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654768 */     // MIs[0] policy
     /* 1654768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654778 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1654781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654802 */     // GIR_Coverage, 4836,
     /* 1654802 */     GIR_EraseRootFromParent_Done,
     /* 1654803 */   // Label 22745: @1654803
     /* 1654803 */   GIM_Try, /*On fail goto*//*Label 22746*/ GIMT_Encode4(1654889), // Rule ID 4837 //
     /* 1654808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1654816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1654819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1654822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1654825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1654828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1654850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654854 */     // MIs[0] policy
     /* 1654854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654864 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1654867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654888 */     // GIR_Coverage, 4837,
     /* 1654888 */     GIR_EraseRootFromParent_Done,
     /* 1654889 */   // Label 22746: @1654889
     /* 1654889 */   GIM_Try, /*On fail goto*//*Label 22747*/ GIMT_Encode4(1654975), // Rule ID 4840 //
     /* 1654894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1654902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1654905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1654908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1654911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1654914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1654936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654940 */     // MIs[0] policy
     /* 1654940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654950 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1654953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654974 */     // GIR_Coverage, 4840,
     /* 1654974 */     GIR_EraseRootFromParent_Done,
     /* 1654975 */   // Label 22747: @1654975
     /* 1654975 */   GIM_Try, /*On fail goto*//*Label 22748*/ GIMT_Encode4(1655061), // Rule ID 4841 //
     /* 1654980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1654988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1654991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1654994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1654997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1655003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655026 */     // MIs[0] policy
     /* 1655026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655036 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1655039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655060 */     // GIR_Coverage, 4841,
     /* 1655060 */     GIR_EraseRootFromParent_Done,
     /* 1655061 */   // Label 22748: @1655061
     /* 1655061 */   GIM_Try, /*On fail goto*//*Label 22749*/ GIMT_Encode4(1655147), // Rule ID 4844 //
     /* 1655066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1655074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1655077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1655080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1655083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1655089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655112 */     // MIs[0] policy
     /* 1655112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655122 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1655125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655146 */     // GIR_Coverage, 4844,
     /* 1655146 */     GIR_EraseRootFromParent_Done,
     /* 1655147 */   // Label 22749: @1655147
     /* 1655147 */   GIM_Try, /*On fail goto*//*Label 22750*/ GIMT_Encode4(1655233), // Rule ID 4845 //
     /* 1655152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1655160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1655163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1655166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1655169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1655175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655198 */     // MIs[0] policy
     /* 1655198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655208 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1655211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655232 */     // GIR_Coverage, 4845,
     /* 1655232 */     GIR_EraseRootFromParent_Done,
     /* 1655233 */   // Label 22750: @1655233
     /* 1655233 */   GIM_Try, /*On fail goto*//*Label 22751*/ GIMT_Encode4(1655319), // Rule ID 4848 //
     /* 1655238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1655246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1655249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1655252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1655255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655284 */     // MIs[0] policy
     /* 1655284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655294 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1655297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655318 */     // GIR_Coverage, 4848,
     /* 1655318 */     GIR_EraseRootFromParent_Done,
     /* 1655319 */   // Label 22751: @1655319
     /* 1655319 */   GIM_Try, /*On fail goto*//*Label 22752*/ GIMT_Encode4(1655405), // Rule ID 4849 //
     /* 1655324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1655332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1655335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1655338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1655341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655370 */     // MIs[0] policy
     /* 1655370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655380 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1655383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655404 */     // GIR_Coverage, 4849,
     /* 1655404 */     GIR_EraseRootFromParent_Done,
     /* 1655405 */   // Label 22752: @1655405
     /* 1655405 */   GIM_Try, /*On fail goto*//*Label 22753*/ GIMT_Encode4(1655491), // Rule ID 4852 //
     /* 1655410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1655418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1655421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1655424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1655427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655456 */     // MIs[0] policy
     /* 1655456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655466 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1655469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655490 */     // GIR_Coverage, 4852,
     /* 1655490 */     GIR_EraseRootFromParent_Done,
     /* 1655491 */   // Label 22753: @1655491
     /* 1655491 */   GIM_Try, /*On fail goto*//*Label 22754*/ GIMT_Encode4(1655577), // Rule ID 4853 //
     /* 1655496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1655504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1655507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1655510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1655513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655542 */     // MIs[0] policy
     /* 1655542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655552 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1655555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655576 */     // GIR_Coverage, 4853,
     /* 1655576 */     GIR_EraseRootFromParent_Done,
     /* 1655577 */   // Label 22754: @1655577
     /* 1655577 */   GIM_Try, /*On fail goto*//*Label 22755*/ GIMT_Encode4(1655663), // Rule ID 4856 //
     /* 1655582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1655590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1655593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1655596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1655599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655628 */     // MIs[0] policy
     /* 1655628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655638 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1655641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655662 */     // GIR_Coverage, 4856,
     /* 1655662 */     GIR_EraseRootFromParent_Done,
     /* 1655663 */   // Label 22755: @1655663
     /* 1655663 */   GIM_Try, /*On fail goto*//*Label 22756*/ GIMT_Encode4(1655749), // Rule ID 4857 //
     /* 1655668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1655676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1655679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1655682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1655685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655714 */     // MIs[0] policy
     /* 1655714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1655727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655748 */     // GIR_Coverage, 4857,
     /* 1655748 */     GIR_EraseRootFromParent_Done,
     /* 1655749 */   // Label 22756: @1655749
     /* 1655749 */   GIM_Try, /*On fail goto*//*Label 22757*/ GIMT_Encode4(1655835), // Rule ID 4860 //
     /* 1655754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1655762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1655765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1655768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1655771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655800 */     // MIs[0] policy
     /* 1655800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1655813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655834 */     // GIR_Coverage, 4860,
     /* 1655834 */     GIR_EraseRootFromParent_Done,
     /* 1655835 */   // Label 22757: @1655835
     /* 1655835 */   GIM_Try, /*On fail goto*//*Label 22758*/ GIMT_Encode4(1655921), // Rule ID 4861 //
     /* 1655840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1655848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1655851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1655854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1655857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655886 */     // MIs[0] policy
     /* 1655886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655896 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1655899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655920 */     // GIR_Coverage, 4861,
     /* 1655920 */     GIR_EraseRootFromParent_Done,
     /* 1655921 */   // Label 22758: @1655921
     /* 1655921 */   GIM_Try, /*On fail goto*//*Label 22759*/ GIMT_Encode4(1656007), // Rule ID 4864 //
     /* 1655926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1655934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1655937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1655940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1655943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1655949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655972 */     // MIs[0] policy
     /* 1655972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1655985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656006 */     // GIR_Coverage, 4864,
     /* 1656006 */     GIR_EraseRootFromParent_Done,
     /* 1656007 */   // Label 22759: @1656007
     /* 1656007 */   GIM_Try, /*On fail goto*//*Label 22760*/ GIMT_Encode4(1656093), // Rule ID 4865 //
     /* 1656012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1656020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1656023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1656026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1656029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656058 */     // MIs[0] policy
     /* 1656058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1656071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656092 */     // GIR_Coverage, 4865,
     /* 1656092 */     GIR_EraseRootFromParent_Done,
     /* 1656093 */   // Label 22760: @1656093
     /* 1656093 */   GIM_Try, /*On fail goto*//*Label 22761*/ GIMT_Encode4(1656179), // Rule ID 4868 //
     /* 1656098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1656106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1656109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1656112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1656115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656144 */     // MIs[0] policy
     /* 1656144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656154 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1656157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656178 */     // GIR_Coverage, 4868,
     /* 1656178 */     GIR_EraseRootFromParent_Done,
     /* 1656179 */   // Label 22761: @1656179
     /* 1656179 */   GIM_Try, /*On fail goto*//*Label 22762*/ GIMT_Encode4(1656265), // Rule ID 4869 //
     /* 1656184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1656192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1656195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1656198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1656201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656230 */     // MIs[0] policy
     /* 1656230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656240 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1656243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656264 */     // GIR_Coverage, 4869,
     /* 1656264 */     GIR_EraseRootFromParent_Done,
     /* 1656265 */   // Label 22762: @1656265
     /* 1656265 */   GIM_Try, /*On fail goto*//*Label 22763*/ GIMT_Encode4(1656351), // Rule ID 4872 //
     /* 1656270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1656278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1656281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1656284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1656287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656316 */     // MIs[0] policy
     /* 1656316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656326 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1656329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656350 */     // GIR_Coverage, 4872,
     /* 1656350 */     GIR_EraseRootFromParent_Done,
     /* 1656351 */   // Label 22763: @1656351
     /* 1656351 */   GIM_Try, /*On fail goto*//*Label 22764*/ GIMT_Encode4(1656437), // Rule ID 4873 //
     /* 1656356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1656364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1656367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1656370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1656373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656402 */     // MIs[0] policy
     /* 1656402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656412 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1656415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656436 */     // GIR_Coverage, 4873,
     /* 1656436 */     GIR_EraseRootFromParent_Done,
     /* 1656437 */   // Label 22764: @1656437
     /* 1656437 */   GIM_Try, /*On fail goto*//*Label 22765*/ GIMT_Encode4(1656523), // Rule ID 4876 //
     /* 1656442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1656445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1656450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1656453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1656456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1656459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1656465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656488 */     // MIs[0] policy
     /* 1656488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656498 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1656501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656522 */     // GIR_Coverage, 4876,
     /* 1656522 */     GIR_EraseRootFromParent_Done,
     /* 1656523 */   // Label 22765: @1656523
     /* 1656523 */   GIM_Try, /*On fail goto*//*Label 22766*/ GIMT_Encode4(1656609), // Rule ID 4877 //
     /* 1656528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1656531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1656536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1656539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1656542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1656545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1656551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656574 */     // MIs[0] policy
     /* 1656574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656584 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1656587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656608 */     // GIR_Coverage, 4877,
     /* 1656608 */     GIR_EraseRootFromParent_Done,
     /* 1656609 */   // Label 22766: @1656609
     /* 1656609 */   GIM_Try, /*On fail goto*//*Label 22767*/ GIMT_Encode4(1656695), // Rule ID 4880 //
     /* 1656614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1656617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1656622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1656625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1656628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1656631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1656637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656660 */     // MIs[0] policy
     /* 1656660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1656673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656694 */     // GIR_Coverage, 4880,
     /* 1656694 */     GIR_EraseRootFromParent_Done,
     /* 1656695 */   // Label 22767: @1656695
     /* 1656695 */   GIM_Try, /*On fail goto*//*Label 22768*/ GIMT_Encode4(1656781), // Rule ID 4881 //
     /* 1656700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1656703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1656708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1656711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1656714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1656717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1656723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656746 */     // MIs[0] policy
     /* 1656746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656756 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1656759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656780 */     // GIR_Coverage, 4881,
     /* 1656780 */     GIR_EraseRootFromParent_Done,
     /* 1656781 */   // Label 22768: @1656781
     /* 1656781 */   GIM_Try, /*On fail goto*//*Label 22769*/ GIMT_Encode4(1656867), // Rule ID 4884 //
     /* 1656786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1656789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1656794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1656797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1656800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1656803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656832 */     // MIs[0] policy
     /* 1656832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656842 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1656845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656866 */     // GIR_Coverage, 4884,
     /* 1656866 */     GIR_EraseRootFromParent_Done,
     /* 1656867 */   // Label 22769: @1656867
     /* 1656867 */   GIM_Try, /*On fail goto*//*Label 22770*/ GIMT_Encode4(1656953), // Rule ID 4885 //
     /* 1656872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1656875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1656880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1656883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1656886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1656889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656918 */     // MIs[0] policy
     /* 1656918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656928 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1656931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656952 */     // GIR_Coverage, 4885,
     /* 1656952 */     GIR_EraseRootFromParent_Done,
     /* 1656953 */   // Label 22770: @1656953
     /* 1656953 */   GIM_Try, /*On fail goto*//*Label 22771*/ GIMT_Encode4(1657039), // Rule ID 4888 //
     /* 1656958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1656961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1656966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1656969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1656972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1656975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657004 */     // MIs[0] policy
     /* 1657004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657014 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1657017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657038 */     // GIR_Coverage, 4888,
     /* 1657038 */     GIR_EraseRootFromParent_Done,
     /* 1657039 */   // Label 22771: @1657039
     /* 1657039 */   GIM_Try, /*On fail goto*//*Label 22772*/ GIMT_Encode4(1657125), // Rule ID 4889 //
     /* 1657044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1657047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1657052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1657055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1657058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1657061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657090 */     // MIs[0] policy
     /* 1657090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657100 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1657103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657124 */     // GIR_Coverage, 4889,
     /* 1657124 */     GIR_EraseRootFromParent_Done,
     /* 1657125 */   // Label 22772: @1657125
     /* 1657125 */   GIM_Try, /*On fail goto*//*Label 22773*/ GIMT_Encode4(1657211), // Rule ID 5766 //
     /* 1657130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1657141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1657144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1657147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1657150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657176 */     // MIs[0] policy
     /* 1657176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657186 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1657189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657210 */     // GIR_Coverage, 5766,
     /* 1657210 */     GIR_EraseRootFromParent_Done,
     /* 1657211 */   // Label 22773: @1657211
     /* 1657211 */   GIM_Try, /*On fail goto*//*Label 22774*/ GIMT_Encode4(1657297), // Rule ID 5767 //
     /* 1657216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1657227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1657230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1657233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1657236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657262 */     // MIs[0] policy
     /* 1657262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657272 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1657275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657296 */     // GIR_Coverage, 5767,
     /* 1657296 */     GIR_EraseRootFromParent_Done,
     /* 1657297 */   // Label 22774: @1657297
     /* 1657297 */   GIM_Try, /*On fail goto*//*Label 22775*/ GIMT_Encode4(1657383), // Rule ID 5770 //
     /* 1657302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1657313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1657316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1657319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1657322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657348 */     // MIs[0] policy
     /* 1657348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657358 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1657361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657382 */     // GIR_Coverage, 5770,
     /* 1657382 */     GIR_EraseRootFromParent_Done,
     /* 1657383 */   // Label 22775: @1657383
     /* 1657383 */   GIM_Try, /*On fail goto*//*Label 22776*/ GIMT_Encode4(1657469), // Rule ID 5771 //
     /* 1657388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1657399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1657402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1657405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1657408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657434 */     // MIs[0] policy
     /* 1657434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657444 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1657447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657468 */     // GIR_Coverage, 5771,
     /* 1657468 */     GIR_EraseRootFromParent_Done,
     /* 1657469 */   // Label 22776: @1657469
     /* 1657469 */   GIM_Try, /*On fail goto*//*Label 22777*/ GIMT_Encode4(1657555), // Rule ID 5774 //
     /* 1657474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1657485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1657488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1657491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1657494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657520 */     // MIs[0] policy
     /* 1657520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657530 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1657533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657554 */     // GIR_Coverage, 5774,
     /* 1657554 */     GIR_EraseRootFromParent_Done,
     /* 1657555 */   // Label 22777: @1657555
     /* 1657555 */   GIM_Try, /*On fail goto*//*Label 22778*/ GIMT_Encode4(1657641), // Rule ID 5775 //
     /* 1657560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1657571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1657574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1657577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1657580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657606 */     // MIs[0] policy
     /* 1657606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657616 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1657619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657640 */     // GIR_Coverage, 5775,
     /* 1657640 */     GIR_EraseRootFromParent_Done,
     /* 1657641 */   // Label 22778: @1657641
     /* 1657641 */   GIM_Try, /*On fail goto*//*Label 22779*/ GIMT_Encode4(1657727), // Rule ID 5778 //
     /* 1657646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1657657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1657660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1657663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1657666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657692 */     // MIs[0] policy
     /* 1657692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657702 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1657705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657726 */     // GIR_Coverage, 5778,
     /* 1657726 */     GIR_EraseRootFromParent_Done,
     /* 1657727 */   // Label 22779: @1657727
     /* 1657727 */   GIM_Try, /*On fail goto*//*Label 22780*/ GIMT_Encode4(1657813), // Rule ID 5779 //
     /* 1657732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1657743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1657746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1657749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1657752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657778 */     // MIs[0] policy
     /* 1657778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657788 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1657791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657812 */     // GIR_Coverage, 5779,
     /* 1657812 */     GIR_EraseRootFromParent_Done,
     /* 1657813 */   // Label 22780: @1657813
     /* 1657813 */   GIM_Try, /*On fail goto*//*Label 22781*/ GIMT_Encode4(1657899), // Rule ID 5782 //
     /* 1657818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1657829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1657832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1657835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1657838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657864 */     // MIs[0] policy
     /* 1657864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657874 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1657877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657898 */     // GIR_Coverage, 5782,
     /* 1657898 */     GIR_EraseRootFromParent_Done,
     /* 1657899 */   // Label 22781: @1657899
     /* 1657899 */   GIM_Try, /*On fail goto*//*Label 22782*/ GIMT_Encode4(1657985), // Rule ID 5783 //
     /* 1657904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1657915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1657918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1657921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1657924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657950 */     // MIs[0] policy
     /* 1657950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657960 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1657963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657984 */     // GIR_Coverage, 5783,
     /* 1657984 */     GIR_EraseRootFromParent_Done,
     /* 1657985 */   // Label 22782: @1657985
     /* 1657985 */   GIM_Try, /*On fail goto*//*Label 22783*/ GIMT_Encode4(1658071), // Rule ID 5786 //
     /* 1657990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1658001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1658004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1658007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1658010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658036 */     // MIs[0] policy
     /* 1658036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1658049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658070 */     // GIR_Coverage, 5786,
     /* 1658070 */     GIR_EraseRootFromParent_Done,
     /* 1658071 */   // Label 22783: @1658071
     /* 1658071 */   GIM_Try, /*On fail goto*//*Label 22784*/ GIMT_Encode4(1658157), // Rule ID 5787 //
     /* 1658076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1658087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1658090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1658093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1658096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658122 */     // MIs[0] policy
     /* 1658122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1658135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658156 */     // GIR_Coverage, 5787,
     /* 1658156 */     GIR_EraseRootFromParent_Done,
     /* 1658157 */   // Label 22784: @1658157
     /* 1658157 */   GIM_Try, /*On fail goto*//*Label 22785*/ GIMT_Encode4(1658243), // Rule ID 5790 //
     /* 1658162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1658173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1658176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1658179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1658182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658208 */     // MIs[0] policy
     /* 1658208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658218 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1658221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658242 */     // GIR_Coverage, 5790,
     /* 1658242 */     GIR_EraseRootFromParent_Done,
     /* 1658243 */   // Label 22785: @1658243
     /* 1658243 */   GIM_Try, /*On fail goto*//*Label 22786*/ GIMT_Encode4(1658329), // Rule ID 5791 //
     /* 1658248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1658259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1658262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1658265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1658268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658294 */     // MIs[0] policy
     /* 1658294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658304 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1658307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658328 */     // GIR_Coverage, 5791,
     /* 1658328 */     GIR_EraseRootFromParent_Done,
     /* 1658329 */   // Label 22786: @1658329
     /* 1658329 */   GIM_Try, /*On fail goto*//*Label 22787*/ GIMT_Encode4(1658415), // Rule ID 5794 //
     /* 1658334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1658345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1658348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1658351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1658354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658380 */     // MIs[0] policy
     /* 1658380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1658393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658414 */     // GIR_Coverage, 5794,
     /* 1658414 */     GIR_EraseRootFromParent_Done,
     /* 1658415 */   // Label 22787: @1658415
     /* 1658415 */   GIM_Try, /*On fail goto*//*Label 22788*/ GIMT_Encode4(1658501), // Rule ID 5795 //
     /* 1658420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1658431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1658434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1658437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1658440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658466 */     // MIs[0] policy
     /* 1658466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1658479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658500 */     // GIR_Coverage, 5795,
     /* 1658500 */     GIR_EraseRootFromParent_Done,
     /* 1658501 */   // Label 22788: @1658501
     /* 1658501 */   GIM_Try, /*On fail goto*//*Label 22789*/ GIMT_Encode4(1658587), // Rule ID 5798 //
     /* 1658506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1658517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1658520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1658523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1658526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658552 */     // MIs[0] policy
     /* 1658552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658562 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1658565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658586 */     // GIR_Coverage, 5798,
     /* 1658586 */     GIR_EraseRootFromParent_Done,
     /* 1658587 */   // Label 22789: @1658587
     /* 1658587 */   GIM_Try, /*On fail goto*//*Label 22790*/ GIMT_Encode4(1658673), // Rule ID 5799 //
     /* 1658592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1658603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1658606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1658609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1658612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658638 */     // MIs[0] policy
     /* 1658638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658648 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1658651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658672 */     // GIR_Coverage, 5799,
     /* 1658672 */     GIR_EraseRootFromParent_Done,
     /* 1658673 */   // Label 22790: @1658673
     /* 1658673 */   GIM_Try, /*On fail goto*//*Label 22791*/ GIMT_Encode4(1658759), // Rule ID 5802 //
     /* 1658678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1658681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1658689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1658692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1658695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1658698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658724 */     // MIs[0] policy
     /* 1658724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658734 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1658737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1658755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658758 */     // GIR_Coverage, 5802,
     /* 1658758 */     GIR_EraseRootFromParent_Done,
     /* 1658759 */   // Label 22791: @1658759
     /* 1658759 */   GIM_Try, /*On fail goto*//*Label 22792*/ GIMT_Encode4(1658845), // Rule ID 5803 //
     /* 1658764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1658767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1658775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1658778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1658781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1658784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658810 */     // MIs[0] policy
     /* 1658810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658820 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1658823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1658841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658844 */     // GIR_Coverage, 5803,
     /* 1658844 */     GIR_EraseRootFromParent_Done,
     /* 1658845 */   // Label 22792: @1658845
     /* 1658845 */   GIM_Try, /*On fail goto*//*Label 22793*/ GIMT_Encode4(1658931), // Rule ID 5806 //
     /* 1658850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1658861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1658864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1658867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1658870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1658873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1658880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658896 */     // MIs[0] policy
     /* 1658896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658906 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1658909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658930 */     // GIR_Coverage, 5806,
     /* 1658930 */     GIR_EraseRootFromParent_Done,
     /* 1658931 */   // Label 22793: @1658931
     /* 1658931 */   GIM_Try, /*On fail goto*//*Label 22794*/ GIMT_Encode4(1659017), // Rule ID 5807 //
     /* 1658936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1658947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1658950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1658953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1658956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1658959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1658966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658982 */     // MIs[0] policy
     /* 1658982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658992 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1658995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659016 */     // GIR_Coverage, 5807,
     /* 1659016 */     GIR_EraseRootFromParent_Done,
     /* 1659017 */   // Label 22794: @1659017
     /* 1659017 */   GIM_Try, /*On fail goto*//*Label 22795*/ GIMT_Encode4(1659103), // Rule ID 5810 //
     /* 1659022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1659033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1659036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1659039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1659042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659068 */     // MIs[0] policy
     /* 1659068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659078 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1659081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659102 */     // GIR_Coverage, 5810,
     /* 1659102 */     GIR_EraseRootFromParent_Done,
     /* 1659103 */   // Label 22795: @1659103
     /* 1659103 */   GIM_Try, /*On fail goto*//*Label 22796*/ GIMT_Encode4(1659189), // Rule ID 5811 //
     /* 1659108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1659119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1659122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1659125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1659128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659154 */     // MIs[0] policy
     /* 1659154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659164 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1659167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659188 */     // GIR_Coverage, 5811,
     /* 1659188 */     GIR_EraseRootFromParent_Done,
     /* 1659189 */   // Label 22796: @1659189
     /* 1659189 */   GIM_Try, /*On fail goto*//*Label 22797*/ GIMT_Encode4(1659275), // Rule ID 5814 //
     /* 1659194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1659205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1659208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1659211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1659214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1659217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659240 */     // MIs[0] policy
     /* 1659240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659250 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1659253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659274 */     // GIR_Coverage, 5814,
     /* 1659274 */     GIR_EraseRootFromParent_Done,
     /* 1659275 */   // Label 22797: @1659275
     /* 1659275 */   GIM_Try, /*On fail goto*//*Label 22798*/ GIMT_Encode4(1659361), // Rule ID 5815 //
     /* 1659280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1659291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1659294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1659297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1659300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1659303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659326 */     // MIs[0] policy
     /* 1659326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659336 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1659339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659360 */     // GIR_Coverage, 5815,
     /* 1659360 */     GIR_EraseRootFromParent_Done,
     /* 1659361 */   // Label 22798: @1659361
     /* 1659361 */   GIM_Try, /*On fail goto*//*Label 22799*/ GIMT_Encode4(1659447), // Rule ID 5818 //
     /* 1659366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1659377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1659380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1659383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1659386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659412 */     // MIs[0] policy
     /* 1659412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659422 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1659425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659446 */     // GIR_Coverage, 5818,
     /* 1659446 */     GIR_EraseRootFromParent_Done,
     /* 1659447 */   // Label 22799: @1659447
     /* 1659447 */   GIM_Try, /*On fail goto*//*Label 22800*/ GIMT_Encode4(1659533), // Rule ID 5819 //
     /* 1659452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1659463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1659466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1659469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1659472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659498 */     // MIs[0] policy
     /* 1659498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1659511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659532 */     // GIR_Coverage, 5819,
     /* 1659532 */     GIR_EraseRootFromParent_Done,
     /* 1659533 */   // Label 22800: @1659533
     /* 1659533 */   GIM_Try, /*On fail goto*//*Label 22801*/ GIMT_Encode4(1659619), // Rule ID 5822 //
     /* 1659538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1659549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1659552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1659555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1659558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659584 */     // MIs[0] policy
     /* 1659584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659594 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1659597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659618 */     // GIR_Coverage, 5822,
     /* 1659618 */     GIR_EraseRootFromParent_Done,
     /* 1659619 */   // Label 22801: @1659619
     /* 1659619 */   GIM_Try, /*On fail goto*//*Label 22802*/ GIMT_Encode4(1659705), // Rule ID 5823 //
     /* 1659624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1659635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1659638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1659641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1659644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659670 */     // MIs[0] policy
     /* 1659670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659680 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1659683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659704 */     // GIR_Coverage, 5823,
     /* 1659704 */     GIR_EraseRootFromParent_Done,
     /* 1659705 */   // Label 22802: @1659705
     /* 1659705 */   GIM_Try, /*On fail goto*//*Label 22803*/ GIMT_Encode4(1659791), // Rule ID 5826 //
     /* 1659710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1659721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1659724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1659727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1659730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659756 */     // MIs[0] policy
     /* 1659756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659766 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1659769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659790 */     // GIR_Coverage, 5826,
     /* 1659790 */     GIR_EraseRootFromParent_Done,
     /* 1659791 */   // Label 22803: @1659791
     /* 1659791 */   GIM_Try, /*On fail goto*//*Label 22804*/ GIMT_Encode4(1659877), // Rule ID 5827 //
     /* 1659796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1659807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1659810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1659813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1659816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659842 */     // MIs[0] policy
     /* 1659842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659852 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1659855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659876 */     // GIR_Coverage, 5827,
     /* 1659876 */     GIR_EraseRootFromParent_Done,
     /* 1659877 */   // Label 22804: @1659877
     /* 1659877 */   GIM_Try, /*On fail goto*//*Label 22805*/ GIMT_Encode4(1659963), // Rule ID 5830 //
     /* 1659882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1659893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1659896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1659899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1659902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659928 */     // MIs[0] policy
     /* 1659928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1659941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659962 */     // GIR_Coverage, 5830,
     /* 1659962 */     GIR_EraseRootFromParent_Done,
     /* 1659963 */   // Label 22805: @1659963
     /* 1659963 */   GIM_Try, /*On fail goto*//*Label 22806*/ GIMT_Encode4(1660049), // Rule ID 5831 //
     /* 1659968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1659979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1659982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1659985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1659988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660014 */     // MIs[0] policy
     /* 1660014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660024 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1660027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660048 */     // GIR_Coverage, 5831,
     /* 1660048 */     GIR_EraseRootFromParent_Done,
     /* 1660049 */   // Label 22806: @1660049
     /* 1660049 */   GIM_Try, /*On fail goto*//*Label 22807*/ GIMT_Encode4(1660135), // Rule ID 5834 //
     /* 1660054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1660065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1660068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1660071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1660074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660100 */     // MIs[0] policy
     /* 1660100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660110 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1660113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660134 */     // GIR_Coverage, 5834,
     /* 1660134 */     GIR_EraseRootFromParent_Done,
     /* 1660135 */   // Label 22807: @1660135
     /* 1660135 */   GIM_Try, /*On fail goto*//*Label 22808*/ GIMT_Encode4(1660221), // Rule ID 5835 //
     /* 1660140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1660151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1660154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1660157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1660160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660186 */     // MIs[0] policy
     /* 1660186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660196 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1660199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660220 */     // GIR_Coverage, 5835,
     /* 1660220 */     GIR_EraseRootFromParent_Done,
     /* 1660221 */   // Label 22808: @1660221
     /* 1660221 */   GIM_Try, /*On fail goto*//*Label 22809*/ GIMT_Encode4(1660307), // Rule ID 5838 //
     /* 1660226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1660237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1660240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1660243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1660246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660272 */     // MIs[0] policy
     /* 1660272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660282 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1660285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660306 */     // GIR_Coverage, 5838,
     /* 1660306 */     GIR_EraseRootFromParent_Done,
     /* 1660307 */   // Label 22809: @1660307
     /* 1660307 */   GIM_Try, /*On fail goto*//*Label 22810*/ GIMT_Encode4(1660393), // Rule ID 5839 //
     /* 1660312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1660323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1660326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1660329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1660332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660358 */     // MIs[0] policy
     /* 1660358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1660371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660392 */     // GIR_Coverage, 5839,
     /* 1660392 */     GIR_EraseRootFromParent_Done,
     /* 1660393 */   // Label 22810: @1660393
     /* 1660393 */   GIM_Try, /*On fail goto*//*Label 22811*/ GIMT_Encode4(1660479), // Rule ID 5842 //
     /* 1660398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1660409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1660412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1660415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1660418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660444 */     // MIs[0] policy
     /* 1660444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660454 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1660457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660478 */     // GIR_Coverage, 5842,
     /* 1660478 */     GIR_EraseRootFromParent_Done,
     /* 1660479 */   // Label 22811: @1660479
     /* 1660479 */   GIM_Try, /*On fail goto*//*Label 22812*/ GIMT_Encode4(1660565), // Rule ID 5843 //
     /* 1660484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1660487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1660495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1660498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1660501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1660504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660530 */     // MIs[0] policy
     /* 1660530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660540 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1660543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660564 */     // GIR_Coverage, 5843,
     /* 1660564 */     GIR_EraseRootFromParent_Done,
     /* 1660565 */   // Label 22812: @1660565
     /* 1660565 */   GIM_Try, /*On fail goto*//*Label 22813*/ GIMT_Encode4(1660651), // Rule ID 5846 //
     /* 1660570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1660581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1660584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1660587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1660590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660616 */     // MIs[0] policy
     /* 1660616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660626 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1660629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660650 */     // GIR_Coverage, 5846,
     /* 1660650 */     GIR_EraseRootFromParent_Done,
     /* 1660651 */   // Label 22813: @1660651
     /* 1660651 */   GIM_Try, /*On fail goto*//*Label 22814*/ GIMT_Encode4(1660737), // Rule ID 5847 //
     /* 1660656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1660659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1660667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1660670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1660673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1660676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660702 */     // MIs[0] policy
     /* 1660702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660712 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1660715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660736 */     // GIR_Coverage, 5847,
     /* 1660736 */     GIR_EraseRootFromParent_Done,
     /* 1660737 */   // Label 22814: @1660737
     /* 1660737 */   GIM_Try, /*On fail goto*//*Label 22815*/ GIMT_Encode4(1660823), // Rule ID 5850 //
     /* 1660742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1660753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1660756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1660759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1660762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660788 */     // MIs[0] policy
     /* 1660788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660798 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1660801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660822 */     // GIR_Coverage, 5850,
     /* 1660822 */     GIR_EraseRootFromParent_Done,
     /* 1660823 */   // Label 22815: @1660823
     /* 1660823 */   GIM_Try, /*On fail goto*//*Label 22816*/ GIMT_Encode4(1660909), // Rule ID 5851 //
     /* 1660828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1660831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1660839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1660842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1660845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1660848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660874 */     // MIs[0] policy
     /* 1660874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660884 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1660887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660908 */     // GIR_Coverage, 5851,
     /* 1660908 */     GIR_EraseRootFromParent_Done,
     /* 1660909 */   // Label 22816: @1660909
     /* 1660909 */   GIM_Try, /*On fail goto*//*Label 22817*/ GIMT_Encode4(1660995), // Rule ID 5854 //
     /* 1660914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1660925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1660928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1660931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1660937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1660944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660960 */     // MIs[0] policy
     /* 1660960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660970 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1660973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660994 */     // GIR_Coverage, 5854,
     /* 1660994 */     GIR_EraseRootFromParent_Done,
     /* 1660995 */   // Label 22817: @1660995
     /* 1660995 */   GIM_Try, /*On fail goto*//*Label 22818*/ GIMT_Encode4(1661081), // Rule ID 5855 //
     /* 1661000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1661011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1661014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1661017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661046 */     // MIs[0] policy
     /* 1661046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661056 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1661059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661080 */     // GIR_Coverage, 5855,
     /* 1661080 */     GIR_EraseRootFromParent_Done,
     /* 1661081 */   // Label 22818: @1661081
     /* 1661081 */   GIM_Try, /*On fail goto*//*Label 22819*/ GIMT_Encode4(1661167), // Rule ID 5858 //
     /* 1661086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1661097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1661100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1661103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661132 */     // MIs[0] policy
     /* 1661132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661142 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1661145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661166 */     // GIR_Coverage, 5858,
     /* 1661166 */     GIR_EraseRootFromParent_Done,
     /* 1661167 */   // Label 22819: @1661167
     /* 1661167 */   GIM_Try, /*On fail goto*//*Label 22820*/ GIMT_Encode4(1661253), // Rule ID 5859 //
     /* 1661172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1661183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1661186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1661189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661218 */     // MIs[0] policy
     /* 1661218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661228 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1661231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661252 */     // GIR_Coverage, 5859,
     /* 1661252 */     GIR_EraseRootFromParent_Done,
     /* 1661253 */   // Label 22820: @1661253
     /* 1661253 */   GIM_Try, /*On fail goto*//*Label 22821*/ GIMT_Encode4(1661339), // Rule ID 5862 //
     /* 1661258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1661269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1661272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1661275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661304 */     // MIs[0] policy
     /* 1661304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661314 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1661317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661338 */     // GIR_Coverage, 5862,
     /* 1661338 */     GIR_EraseRootFromParent_Done,
     /* 1661339 */   // Label 22821: @1661339
     /* 1661339 */   GIM_Try, /*On fail goto*//*Label 22822*/ GIMT_Encode4(1661425), // Rule ID 5863 //
     /* 1661344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1661355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1661358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1661361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661390 */     // MIs[0] policy
     /* 1661390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661400 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1661403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661424 */     // GIR_Coverage, 5863,
     /* 1661424 */     GIR_EraseRootFromParent_Done,
     /* 1661425 */   // Label 22822: @1661425
     /* 1661425 */   GIM_Try, /*On fail goto*//*Label 22823*/ GIMT_Encode4(1661511), // Rule ID 5866 //
     /* 1661430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1661441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1661444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1661447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661476 */     // MIs[0] policy
     /* 1661476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661486 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1661489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661510 */     // GIR_Coverage, 5866,
     /* 1661510 */     GIR_EraseRootFromParent_Done,
     /* 1661511 */   // Label 22823: @1661511
     /* 1661511 */   GIM_Try, /*On fail goto*//*Label 22824*/ GIMT_Encode4(1661597), // Rule ID 5867 //
     /* 1661516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1661527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1661530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1661533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661562 */     // MIs[0] policy
     /* 1661562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661572 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1661575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661596 */     // GIR_Coverage, 5867,
     /* 1661596 */     GIR_EraseRootFromParent_Done,
     /* 1661597 */   // Label 22824: @1661597
     /* 1661597 */   GIM_Try, /*On fail goto*//*Label 22825*/ GIMT_Encode4(1661683), // Rule ID 5870 //
     /* 1661602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1661613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1661616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1661619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661648 */     // MIs[0] policy
     /* 1661648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661658 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1661661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661682 */     // GIR_Coverage, 5870,
     /* 1661682 */     GIR_EraseRootFromParent_Done,
     /* 1661683 */   // Label 22825: @1661683
     /* 1661683 */   GIM_Try, /*On fail goto*//*Label 22826*/ GIMT_Encode4(1661769), // Rule ID 5871 //
     /* 1661688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1661699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1661702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1661705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661734 */     // MIs[0] policy
     /* 1661734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1661747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661768 */     // GIR_Coverage, 5871,
     /* 1661768 */     GIR_EraseRootFromParent_Done,
     /* 1661769 */   // Label 22826: @1661769
     /* 1661769 */   GIM_Try, /*On fail goto*//*Label 22827*/ GIMT_Encode4(1661855), // Rule ID 5874 //
     /* 1661774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1661785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1661788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1661791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661820 */     // MIs[0] policy
     /* 1661820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661830 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1661833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661854 */     // GIR_Coverage, 5874,
     /* 1661854 */     GIR_EraseRootFromParent_Done,
     /* 1661855 */   // Label 22827: @1661855
     /* 1661855 */   GIM_Try, /*On fail goto*//*Label 22828*/ GIMT_Encode4(1661941), // Rule ID 5875 //
     /* 1661860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1661871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1661874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1661877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661906 */     // MIs[0] policy
     /* 1661906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661916 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1661919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661940 */     // GIR_Coverage, 5875,
     /* 1661940 */     GIR_EraseRootFromParent_Done,
     /* 1661941 */   // Label 22828: @1661941
     /* 1661941 */   GIM_Try, /*On fail goto*//*Label 22829*/ GIMT_Encode4(1662027), // Rule ID 5878 //
     /* 1661946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1661957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1661960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1661963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661992 */     // MIs[0] policy
     /* 1661992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662002 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1662005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662026 */     // GIR_Coverage, 5878,
     /* 1662026 */     GIR_EraseRootFromParent_Done,
     /* 1662027 */   // Label 22829: @1662027
     /* 1662027 */   GIM_Try, /*On fail goto*//*Label 22830*/ GIMT_Encode4(1662113), // Rule ID 5879 //
     /* 1662032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1662040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1662043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1662046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1662049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1662055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662078 */     // MIs[0] policy
     /* 1662078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662088 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1662091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662112 */     // GIR_Coverage, 5879,
     /* 1662112 */     GIR_EraseRootFromParent_Done,
     /* 1662113 */   // Label 22830: @1662113
     /* 1662113 */   GIM_Try, /*On fail goto*//*Label 22831*/ GIMT_Encode4(1662199), // Rule ID 5882 //
     /* 1662118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1662126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1662129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1662132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1662135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662164 */     // MIs[0] policy
     /* 1662164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1662177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662198 */     // GIR_Coverage, 5882,
     /* 1662198 */     GIR_EraseRootFromParent_Done,
     /* 1662199 */   // Label 22831: @1662199
     /* 1662199 */   GIM_Try, /*On fail goto*//*Label 22832*/ GIMT_Encode4(1662285), // Rule ID 5883 //
     /* 1662204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1662212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1662215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1662218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1662221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662250 */     // MIs[0] policy
     /* 1662250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662260 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1662263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662284 */     // GIR_Coverage, 5883,
     /* 1662284 */     GIR_EraseRootFromParent_Done,
     /* 1662285 */   // Label 22832: @1662285
     /* 1662285 */   GIM_Try, /*On fail goto*//*Label 22833*/ GIMT_Encode4(1662371), // Rule ID 5886 //
     /* 1662290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1662298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1662301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1662304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1662307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662336 */     // MIs[0] policy
     /* 1662336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662346 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1662349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662370 */     // GIR_Coverage, 5886,
     /* 1662370 */     GIR_EraseRootFromParent_Done,
     /* 1662371 */   // Label 22833: @1662371
     /* 1662371 */   GIM_Try, /*On fail goto*//*Label 22834*/ GIMT_Encode4(1662457), // Rule ID 5887 //
     /* 1662376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1662384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1662387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1662390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1662393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662422 */     // MIs[0] policy
     /* 1662422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1662435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662456 */     // GIR_Coverage, 5887,
     /* 1662456 */     GIR_EraseRootFromParent_Done,
     /* 1662457 */   // Label 22834: @1662457
     /* 1662457 */   GIM_Try, /*On fail goto*//*Label 22835*/ GIMT_Encode4(1662543), // Rule ID 5890 //
     /* 1662462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1662465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1662470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1662473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1662476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1662479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662508 */     // MIs[0] policy
     /* 1662508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1662521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1662539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662542 */     // GIR_Coverage, 5890,
     /* 1662542 */     GIR_EraseRootFromParent_Done,
     /* 1662543 */   // Label 22835: @1662543
     /* 1662543 */   GIM_Try, /*On fail goto*//*Label 22836*/ GIMT_Encode4(1662629), // Rule ID 5891 //
     /* 1662548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1662551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1662556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1662559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1662562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1662565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662594 */     // MIs[0] policy
     /* 1662594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662604 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1662607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1662625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662628 */     // GIR_Coverage, 5891,
     /* 1662628 */     GIR_EraseRootFromParent_Done,
     /* 1662629 */   // Label 22836: @1662629
     /* 1662629 */   GIM_Try, /*On fail goto*//*Label 22837*/ GIMT_Encode4(1662715), // Rule ID 5894 //
     /* 1662634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1662642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1662645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1662648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1662651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1662657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1662664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662680 */     // MIs[0] policy
     /* 1662680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662690 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1662693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662714 */     // GIR_Coverage, 5894,
     /* 1662714 */     GIR_EraseRootFromParent_Done,
     /* 1662715 */   // Label 22837: @1662715
     /* 1662715 */   GIM_Try, /*On fail goto*//*Label 22838*/ GIMT_Encode4(1662801), // Rule ID 5895 //
     /* 1662720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1662728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1662731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1662734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1662737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1662743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1662750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662766 */     // MIs[0] policy
     /* 1662766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662776 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1662779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662800 */     // GIR_Coverage, 5895,
     /* 1662800 */     GIR_EraseRootFromParent_Done,
     /* 1662801 */   // Label 22838: @1662801
     /* 1662801 */   GIM_Try, /*On fail goto*//*Label 22839*/ GIMT_Encode4(1662887), // Rule ID 5898 //
     /* 1662806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1662814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1662817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1662820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1662823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1662829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1662836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662852 */     // MIs[0] policy
     /* 1662852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662862 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1662865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662886 */     // GIR_Coverage, 5898,
     /* 1662886 */     GIR_EraseRootFromParent_Done,
     /* 1662887 */   // Label 22839: @1662887
     /* 1662887 */   GIM_Try, /*On fail goto*//*Label 22840*/ GIMT_Encode4(1662973), // Rule ID 5899 //
     /* 1662892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1662900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1662903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1662906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1662909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1662915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1662922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662938 */     // MIs[0] policy
     /* 1662938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662948 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1662951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662972 */     // GIR_Coverage, 5899,
     /* 1662972 */     GIR_EraseRootFromParent_Done,
     /* 1662973 */   // Label 22840: @1662973
     /* 1662973 */   GIM_Try, /*On fail goto*//*Label 22841*/ GIMT_Encode4(1663059), // Rule ID 5902 //
     /* 1662978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1662986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1662989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1662992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1662995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1663001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663024 */     // MIs[0] policy
     /* 1663024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663034 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1663037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663058 */     // GIR_Coverage, 5902,
     /* 1663058 */     GIR_EraseRootFromParent_Done,
     /* 1663059 */   // Label 22841: @1663059
     /* 1663059 */   GIM_Try, /*On fail goto*//*Label 22842*/ GIMT_Encode4(1663145), // Rule ID 5903 //
     /* 1663064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1663072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1663075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1663078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1663081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1663087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663110 */     // MIs[0] policy
     /* 1663110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663120 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1663123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663144 */     // GIR_Coverage, 5903,
     /* 1663144 */     GIR_EraseRootFromParent_Done,
     /* 1663145 */   // Label 22842: @1663145
     /* 1663145 */   GIM_Try, /*On fail goto*//*Label 22843*/ GIMT_Encode4(1663231), // Rule ID 5906 //
     /* 1663150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1663158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1663161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1663164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1663167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663196 */     // MIs[0] policy
     /* 1663196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1663209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663230 */     // GIR_Coverage, 5906,
     /* 1663230 */     GIR_EraseRootFromParent_Done,
     /* 1663231 */   // Label 22843: @1663231
     /* 1663231 */   GIM_Try, /*On fail goto*//*Label 22844*/ GIMT_Encode4(1663317), // Rule ID 5907 //
     /* 1663236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1663244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1663247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1663250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1663253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663282 */     // MIs[0] policy
     /* 1663282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1663295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663316 */     // GIR_Coverage, 5907,
     /* 1663316 */     GIR_EraseRootFromParent_Done,
     /* 1663317 */   // Label 22844: @1663317
     /* 1663317 */   GIM_Try, /*On fail goto*//*Label 22845*/ GIMT_Encode4(1663403), // Rule ID 5910 //
     /* 1663322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1663330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1663333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1663336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1663339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663368 */     // MIs[0] policy
     /* 1663368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663378 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1663381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663402 */     // GIR_Coverage, 5910,
     /* 1663402 */     GIR_EraseRootFromParent_Done,
     /* 1663403 */   // Label 22845: @1663403
     /* 1663403 */   GIM_Try, /*On fail goto*//*Label 22846*/ GIMT_Encode4(1663489), // Rule ID 5911 //
     /* 1663408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1663416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1663419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1663422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1663425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663454 */     // MIs[0] policy
     /* 1663454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663464 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1663467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663488 */     // GIR_Coverage, 5911,
     /* 1663488 */     GIR_EraseRootFromParent_Done,
     /* 1663489 */   // Label 22846: @1663489
     /* 1663489 */   GIM_Try, /*On fail goto*//*Label 22847*/ GIMT_Encode4(1663575), // Rule ID 5914 //
     /* 1663494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1663502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1663505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1663508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1663511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663540 */     // MIs[0] policy
     /* 1663540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663550 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1663553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663574 */     // GIR_Coverage, 5914,
     /* 1663574 */     GIR_EraseRootFromParent_Done,
     /* 1663575 */   // Label 22847: @1663575
     /* 1663575 */   GIM_Try, /*On fail goto*//*Label 22848*/ GIMT_Encode4(1663661), // Rule ID 5915 //
     /* 1663580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1663588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1663591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1663594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1663597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663626 */     // MIs[0] policy
     /* 1663626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663636 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1663639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663660 */     // GIR_Coverage, 5915,
     /* 1663660 */     GIR_EraseRootFromParent_Done,
     /* 1663661 */   // Label 22848: @1663661
     /* 1663661 */   GIM_Try, /*On fail goto*//*Label 22849*/ GIMT_Encode4(1663747), // Rule ID 5918 //
     /* 1663666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1663674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1663677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1663680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1663683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1663689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663712 */     // MIs[0] policy
     /* 1663712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1663725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663746 */     // GIR_Coverage, 5918,
     /* 1663746 */     GIR_EraseRootFromParent_Done,
     /* 1663747 */   // Label 22849: @1663747
     /* 1663747 */   GIM_Try, /*On fail goto*//*Label 22850*/ GIMT_Encode4(1663833), // Rule ID 5919 //
     /* 1663752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1663760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1663763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1663766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1663769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1663775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663798 */     // MIs[0] policy
     /* 1663798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663808 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1663811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663832 */     // GIR_Coverage, 5919,
     /* 1663832 */     GIR_EraseRootFromParent_Done,
     /* 1663833 */   // Label 22850: @1663833
     /* 1663833 */   GIM_Try, /*On fail goto*//*Label 22851*/ GIMT_Encode4(1663919), // Rule ID 5922 //
     /* 1663838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1663846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1663849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1663852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1663855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663884 */     // MIs[0] policy
     /* 1663884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663894 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1663897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663918 */     // GIR_Coverage, 5922,
     /* 1663918 */     GIR_EraseRootFromParent_Done,
     /* 1663919 */   // Label 22851: @1663919
     /* 1663919 */   GIM_Try, /*On fail goto*//*Label 22852*/ GIMT_Encode4(1664005), // Rule ID 5923 //
     /* 1663924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1663932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1663935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1663938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1663941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663970 */     // MIs[0] policy
     /* 1663970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1663983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664004 */     // GIR_Coverage, 5923,
     /* 1664004 */     GIR_EraseRootFromParent_Done,
     /* 1664005 */   // Label 22852: @1664005
     /* 1664005 */   GIM_Try, /*On fail goto*//*Label 22853*/ GIMT_Encode4(1664091), // Rule ID 5926 //
     /* 1664010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1664018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1664021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1664024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1664027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664056 */     // MIs[0] policy
     /* 1664056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664066 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1664069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664090 */     // GIR_Coverage, 5926,
     /* 1664090 */     GIR_EraseRootFromParent_Done,
     /* 1664091 */   // Label 22853: @1664091
     /* 1664091 */   GIM_Try, /*On fail goto*//*Label 22854*/ GIMT_Encode4(1664177), // Rule ID 5927 //
     /* 1664096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1664104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1664107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1664110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1664113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664142 */     // MIs[0] policy
     /* 1664142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664152 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1664155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664176 */     // GIR_Coverage, 5927,
     /* 1664176 */     GIR_EraseRootFromParent_Done,
     /* 1664177 */   // Label 22854: @1664177
     /* 1664177 */   GIM_Try, /*On fail goto*//*Label 22855*/ GIMT_Encode4(1664263), // Rule ID 5930 //
     /* 1664182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1664190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1664193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1664196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1664199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664228 */     // MIs[0] policy
     /* 1664228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1664241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664262 */     // GIR_Coverage, 5930,
     /* 1664262 */     GIR_EraseRootFromParent_Done,
     /* 1664263 */   // Label 22855: @1664263
     /* 1664263 */   GIM_Try, /*On fail goto*//*Label 22856*/ GIMT_Encode4(1664349), // Rule ID 5931 //
     /* 1664268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1664276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1664279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1664282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1664285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664314 */     // MIs[0] policy
     /* 1664314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1664327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664348 */     // GIR_Coverage, 5931,
     /* 1664348 */     GIR_EraseRootFromParent_Done,
     /* 1664349 */   // Label 22856: @1664349
     /* 1664349 */   GIM_Try, /*On fail goto*//*Label 22857*/ GIMT_Encode4(1664435), // Rule ID 5934 //
     /* 1664354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1664362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1664365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1664368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1664371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664400 */     // MIs[0] policy
     /* 1664400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664410 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1664413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664434 */     // GIR_Coverage, 5934,
     /* 1664434 */     GIR_EraseRootFromParent_Done,
     /* 1664435 */   // Label 22857: @1664435
     /* 1664435 */   GIM_Try, /*On fail goto*//*Label 22858*/ GIMT_Encode4(1664521), // Rule ID 5935 //
     /* 1664440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1664448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1664451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1664454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1664457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664486 */     // MIs[0] policy
     /* 1664486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1664499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664520 */     // GIR_Coverage, 5935,
     /* 1664520 */     GIR_EraseRootFromParent_Done,
     /* 1664521 */   // Label 22858: @1664521
     /* 1664521 */   GIM_Try, /*On fail goto*//*Label 22859*/ GIMT_Encode4(1664607), // Rule ID 5938 //
     /* 1664526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1664534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1664537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1664540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1664543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664572 */     // MIs[0] policy
     /* 1664572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664582 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1664585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664606 */     // GIR_Coverage, 5938,
     /* 1664606 */     GIR_EraseRootFromParent_Done,
     /* 1664607 */   // Label 22859: @1664607
     /* 1664607 */   GIM_Try, /*On fail goto*//*Label 22860*/ GIMT_Encode4(1664693), // Rule ID 5939 //
     /* 1664612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1664620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1664623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1664626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1664629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664658 */     // MIs[0] policy
     /* 1664658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664668 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1664671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664692 */     // GIR_Coverage, 5939,
     /* 1664692 */     GIR_EraseRootFromParent_Done,
     /* 1664693 */   // Label 22860: @1664693
     /* 1664693 */   GIM_Try, /*On fail goto*//*Label 22861*/ GIMT_Encode4(1664779), // Rule ID 6030 //
     /* 1664698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1664709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1664712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1664715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1664718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1664721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664744 */     // MIs[0] policy
     /* 1664744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664754 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1664757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664778 */     // GIR_Coverage, 6030,
     /* 1664778 */     GIR_EraseRootFromParent_Done,
     /* 1664779 */   // Label 22861: @1664779
     /* 1664779 */   GIM_Try, /*On fail goto*//*Label 22862*/ GIMT_Encode4(1664865), // Rule ID 6031 //
     /* 1664784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1664795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1664798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1664801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1664804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1664807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664830 */     // MIs[0] policy
     /* 1664830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664840 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1664843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664864 */     // GIR_Coverage, 6031,
     /* 1664864 */     GIR_EraseRootFromParent_Done,
     /* 1664865 */   // Label 22862: @1664865
     /* 1664865 */   GIM_Try, /*On fail goto*//*Label 22863*/ GIMT_Encode4(1664951), // Rule ID 6034 //
     /* 1664870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1664881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1664884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1664887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1664890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664916 */     // MIs[0] policy
     /* 1664916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664926 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1664929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664950 */     // GIR_Coverage, 6034,
     /* 1664950 */     GIR_EraseRootFromParent_Done,
     /* 1664951 */   // Label 22863: @1664951
     /* 1664951 */   GIM_Try, /*On fail goto*//*Label 22864*/ GIMT_Encode4(1665037), // Rule ID 6035 //
     /* 1664956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1664967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1664970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1664973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1664976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665002 */     // MIs[0] policy
     /* 1665002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665012 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1665015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665036 */     // GIR_Coverage, 6035,
     /* 1665036 */     GIR_EraseRootFromParent_Done,
     /* 1665037 */   // Label 22864: @1665037
     /* 1665037 */   GIM_Try, /*On fail goto*//*Label 22865*/ GIMT_Encode4(1665123), // Rule ID 6038 //
     /* 1665042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1665053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1665056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1665059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1665062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665088 */     // MIs[0] policy
     /* 1665088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665098 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1665101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665122 */     // GIR_Coverage, 6038,
     /* 1665122 */     GIR_EraseRootFromParent_Done,
     /* 1665123 */   // Label 22865: @1665123
     /* 1665123 */   GIM_Try, /*On fail goto*//*Label 22866*/ GIMT_Encode4(1665209), // Rule ID 6039 //
     /* 1665128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1665139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1665142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1665145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1665148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665174 */     // MIs[0] policy
     /* 1665174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665184 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1665187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665208 */     // GIR_Coverage, 6039,
     /* 1665208 */     GIR_EraseRootFromParent_Done,
     /* 1665209 */   // Label 22866: @1665209
     /* 1665209 */   GIM_Try, /*On fail goto*//*Label 22867*/ GIMT_Encode4(1665295), // Rule ID 6042 //
     /* 1665214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1665225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1665228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1665231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1665234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665260 */     // MIs[0] policy
     /* 1665260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665270 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1665273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665294 */     // GIR_Coverage, 6042,
     /* 1665294 */     GIR_EraseRootFromParent_Done,
     /* 1665295 */   // Label 22867: @1665295
     /* 1665295 */   GIM_Try, /*On fail goto*//*Label 22868*/ GIMT_Encode4(1665381), // Rule ID 6043 //
     /* 1665300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1665311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1665314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1665317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1665320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665346 */     // MIs[0] policy
     /* 1665346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665356 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1665359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665380 */     // GIR_Coverage, 6043,
     /* 1665380 */     GIR_EraseRootFromParent_Done,
     /* 1665381 */   // Label 22868: @1665381
     /* 1665381 */   GIM_Try, /*On fail goto*//*Label 22869*/ GIMT_Encode4(1665467), // Rule ID 6046 //
     /* 1665386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1665397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1665400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1665403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1665406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665432 */     // MIs[0] policy
     /* 1665432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665442 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1665445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665466 */     // GIR_Coverage, 6046,
     /* 1665466 */     GIR_EraseRootFromParent_Done,
     /* 1665467 */   // Label 22869: @1665467
     /* 1665467 */   GIM_Try, /*On fail goto*//*Label 22870*/ GIMT_Encode4(1665553), // Rule ID 6047 //
     /* 1665472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1665483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1665486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1665489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1665492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665518 */     // MIs[0] policy
     /* 1665518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665528 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1665531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665552 */     // GIR_Coverage, 6047,
     /* 1665552 */     GIR_EraseRootFromParent_Done,
     /* 1665553 */   // Label 22870: @1665553
     /* 1665553 */   GIM_Try, /*On fail goto*//*Label 22871*/ GIMT_Encode4(1665639), // Rule ID 6050 //
     /* 1665558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1665569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1665572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1665575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1665578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665604 */     // MIs[0] policy
     /* 1665604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665614 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1665617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665638 */     // GIR_Coverage, 6050,
     /* 1665638 */     GIR_EraseRootFromParent_Done,
     /* 1665639 */   // Label 22871: @1665639
     /* 1665639 */   GIM_Try, /*On fail goto*//*Label 22872*/ GIMT_Encode4(1665725), // Rule ID 6051 //
     /* 1665644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1665655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1665658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1665661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1665664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665690 */     // MIs[0] policy
     /* 1665690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665700 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1665703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665724 */     // GIR_Coverage, 6051,
     /* 1665724 */     GIR_EraseRootFromParent_Done,
     /* 1665725 */   // Label 22872: @1665725
     /* 1665725 */   GIM_Try, /*On fail goto*//*Label 22873*/ GIMT_Encode4(1665811), // Rule ID 6054 //
     /* 1665730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1665741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1665744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1665747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1665750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665776 */     // MIs[0] policy
     /* 1665776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665786 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1665789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665810 */     // GIR_Coverage, 6054,
     /* 1665810 */     GIR_EraseRootFromParent_Done,
     /* 1665811 */   // Label 22873: @1665811
     /* 1665811 */   GIM_Try, /*On fail goto*//*Label 22874*/ GIMT_Encode4(1665897), // Rule ID 6055 //
     /* 1665816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1665827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1665830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1665833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1665836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665862 */     // MIs[0] policy
     /* 1665862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665872 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1665875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665896 */     // GIR_Coverage, 6055,
     /* 1665896 */     GIR_EraseRootFromParent_Done,
     /* 1665897 */   // Label 22874: @1665897
     /* 1665897 */   GIM_Try, /*On fail goto*//*Label 22875*/ GIMT_Encode4(1665983), // Rule ID 6058 //
     /* 1665902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1665913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1665916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1665919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1665922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665948 */     // MIs[0] policy
     /* 1665948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665958 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1665961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665982 */     // GIR_Coverage, 6058,
     /* 1665982 */     GIR_EraseRootFromParent_Done,
     /* 1665983 */   // Label 22875: @1665983
     /* 1665983 */   GIM_Try, /*On fail goto*//*Label 22876*/ GIMT_Encode4(1666069), // Rule ID 6059 //
     /* 1665988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1665999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1666002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1666005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1666008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666034 */     // MIs[0] policy
     /* 1666034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666044 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1666047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666068 */     // GIR_Coverage, 6059,
     /* 1666068 */     GIR_EraseRootFromParent_Done,
     /* 1666069 */   // Label 22876: @1666069
     /* 1666069 */   GIM_Try, /*On fail goto*//*Label 22877*/ GIMT_Encode4(1666155), // Rule ID 6062 //
     /* 1666074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1666085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1666088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1666091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1666094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666120 */     // MIs[0] policy
     /* 1666120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1666133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666154 */     // GIR_Coverage, 6062,
     /* 1666154 */     GIR_EraseRootFromParent_Done,
     /* 1666155 */   // Label 22877: @1666155
     /* 1666155 */   GIM_Try, /*On fail goto*//*Label 22878*/ GIMT_Encode4(1666241), // Rule ID 6063 //
     /* 1666160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1666171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1666174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1666177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1666180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666206 */     // MIs[0] policy
     /* 1666206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1666219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666240 */     // GIR_Coverage, 6063,
     /* 1666240 */     GIR_EraseRootFromParent_Done,
     /* 1666241 */   // Label 22878: @1666241
     /* 1666241 */   GIM_Try, /*On fail goto*//*Label 22879*/ GIMT_Encode4(1666327), // Rule ID 6066 //
     /* 1666246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1666249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1666257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1666260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1666263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1666266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666292 */     // MIs[0] policy
     /* 1666292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666302 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1666305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666326 */     // GIR_Coverage, 6066,
     /* 1666326 */     GIR_EraseRootFromParent_Done,
     /* 1666327 */   // Label 22879: @1666327
     /* 1666327 */   GIM_Try, /*On fail goto*//*Label 22880*/ GIMT_Encode4(1666413), // Rule ID 6067 //
     /* 1666332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1666335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1666343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1666346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1666349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1666352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666378 */     // MIs[0] policy
     /* 1666378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666388 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1666391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666412 */     // GIR_Coverage, 6067,
     /* 1666412 */     GIR_EraseRootFromParent_Done,
     /* 1666413 */   // Label 22880: @1666413
     /* 1666413 */   GIM_Try, /*On fail goto*//*Label 22881*/ GIMT_Encode4(1666499), // Rule ID 6070 //
     /* 1666418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1666429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1666432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1666435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1666438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1666441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666464 */     // MIs[0] policy
     /* 1666464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1666477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666498 */     // GIR_Coverage, 6070,
     /* 1666498 */     GIR_EraseRootFromParent_Done,
     /* 1666499 */   // Label 22881: @1666499
     /* 1666499 */   GIM_Try, /*On fail goto*//*Label 22882*/ GIMT_Encode4(1666585), // Rule ID 6071 //
     /* 1666504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1666515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1666518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1666521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1666524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1666527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666550 */     // MIs[0] policy
     /* 1666550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666560 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1666563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666584 */     // GIR_Coverage, 6071,
     /* 1666584 */     GIR_EraseRootFromParent_Done,
     /* 1666585 */   // Label 22882: @1666585
     /* 1666585 */   GIM_Try, /*On fail goto*//*Label 22883*/ GIMT_Encode4(1666671), // Rule ID 6074 //
     /* 1666590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1666601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1666604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1666607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1666610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1666613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1666620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666636 */     // MIs[0] policy
     /* 1666636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666646 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1666649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666670 */     // GIR_Coverage, 6074,
     /* 1666670 */     GIR_EraseRootFromParent_Done,
     /* 1666671 */   // Label 22883: @1666671
     /* 1666671 */   GIM_Try, /*On fail goto*//*Label 22884*/ GIMT_Encode4(1666757), // Rule ID 6075 //
     /* 1666676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1666687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1666690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1666693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1666696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1666699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1666706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666722 */     // MIs[0] policy
     /* 1666722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666732 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1666735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666756 */     // GIR_Coverage, 6075,
     /* 1666756 */     GIR_EraseRootFromParent_Done,
     /* 1666757 */   // Label 22884: @1666757
     /* 1666757 */   GIM_Try, /*On fail goto*//*Label 22885*/ GIMT_Encode4(1666843), // Rule ID 6078 //
     /* 1666762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1666773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1666776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1666779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1666782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1666785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1666792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666808 */     // MIs[0] policy
     /* 1666808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666818 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1666821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666842 */     // GIR_Coverage, 6078,
     /* 1666842 */     GIR_EraseRootFromParent_Done,
     /* 1666843 */   // Label 22885: @1666843
     /* 1666843 */   GIM_Try, /*On fail goto*//*Label 22886*/ GIMT_Encode4(1666929), // Rule ID 6079 //
     /* 1666848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1666859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1666862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1666865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1666868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1666871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1666878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666894 */     // MIs[0] policy
     /* 1666894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666904 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1666907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666928 */     // GIR_Coverage, 6079,
     /* 1666928 */     GIR_EraseRootFromParent_Done,
     /* 1666929 */   // Label 22886: @1666929
     /* 1666929 */   GIM_Try, /*On fail goto*//*Label 22887*/ GIMT_Encode4(1667015), // Rule ID 6082 //
     /* 1666934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1666945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1666948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1666951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1666954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666980 */     // MIs[0] policy
     /* 1666980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666990 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1666993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667014 */     // GIR_Coverage, 6082,
     /* 1667014 */     GIR_EraseRootFromParent_Done,
     /* 1667015 */   // Label 22887: @1667015
     /* 1667015 */   GIM_Try, /*On fail goto*//*Label 22888*/ GIMT_Encode4(1667101), // Rule ID 6083 //
     /* 1667020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1667031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1667034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1667037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1667040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667066 */     // MIs[0] policy
     /* 1667066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667076 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1667079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667100 */     // GIR_Coverage, 6083,
     /* 1667100 */     GIR_EraseRootFromParent_Done,
     /* 1667101 */   // Label 22888: @1667101
     /* 1667101 */   GIM_Try, /*On fail goto*//*Label 22889*/ GIMT_Encode4(1667187), // Rule ID 6086 //
     /* 1667106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1667117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1667120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1667123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1667126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667152 */     // MIs[0] policy
     /* 1667152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667162 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1667165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667186 */     // GIR_Coverage, 6086,
     /* 1667186 */     GIR_EraseRootFromParent_Done,
     /* 1667187 */   // Label 22889: @1667187
     /* 1667187 */   GIM_Try, /*On fail goto*//*Label 22890*/ GIMT_Encode4(1667273), // Rule ID 6087 //
     /* 1667192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1667203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1667206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1667209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1667212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667238 */     // MIs[0] policy
     /* 1667238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667248 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1667251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667272 */     // GIR_Coverage, 6087,
     /* 1667272 */     GIR_EraseRootFromParent_Done,
     /* 1667273 */   // Label 22890: @1667273
     /* 1667273 */   GIM_Try, /*On fail goto*//*Label 22891*/ GIMT_Encode4(1667359), // Rule ID 6090 //
     /* 1667278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1667289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1667292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1667295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1667298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667324 */     // MIs[0] policy
     /* 1667324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667334 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1667337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667358 */     // GIR_Coverage, 6090,
     /* 1667358 */     GIR_EraseRootFromParent_Done,
     /* 1667359 */   // Label 22891: @1667359
     /* 1667359 */   GIM_Try, /*On fail goto*//*Label 22892*/ GIMT_Encode4(1667445), // Rule ID 6091 //
     /* 1667364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1667375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1667378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1667381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1667384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667410 */     // MIs[0] policy
     /* 1667410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667420 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1667423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667444 */     // GIR_Coverage, 6091,
     /* 1667444 */     GIR_EraseRootFromParent_Done,
     /* 1667445 */   // Label 22892: @1667445
     /* 1667445 */   GIM_Try, /*On fail goto*//*Label 22893*/ GIMT_Encode4(1667531), // Rule ID 6094 //
     /* 1667450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1667461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1667464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1667467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1667470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667496 */     // MIs[0] policy
     /* 1667496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667506 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1667509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667530 */     // GIR_Coverage, 6094,
     /* 1667530 */     GIR_EraseRootFromParent_Done,
     /* 1667531 */   // Label 22893: @1667531
     /* 1667531 */   GIM_Try, /*On fail goto*//*Label 22894*/ GIMT_Encode4(1667617), // Rule ID 6095 //
     /* 1667536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1667547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1667550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1667553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1667556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667582 */     // MIs[0] policy
     /* 1667582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667592 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1667595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667616 */     // GIR_Coverage, 6095,
     /* 1667616 */     GIR_EraseRootFromParent_Done,
     /* 1667617 */   // Label 22894: @1667617
     /* 1667617 */   GIM_Try, /*On fail goto*//*Label 22895*/ GIMT_Encode4(1667703), // Rule ID 6098 //
     /* 1667622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1667633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1667636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1667639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1667642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667668 */     // MIs[0] policy
     /* 1667668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667678 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1667681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667702 */     // GIR_Coverage, 6098,
     /* 1667702 */     GIR_EraseRootFromParent_Done,
     /* 1667703 */   // Label 22895: @1667703
     /* 1667703 */   GIM_Try, /*On fail goto*//*Label 22896*/ GIMT_Encode4(1667789), // Rule ID 6099 //
     /* 1667708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1667719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1667722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1667725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1667728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667754 */     // MIs[0] policy
     /* 1667754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667764 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1667767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667788 */     // GIR_Coverage, 6099,
     /* 1667788 */     GIR_EraseRootFromParent_Done,
     /* 1667789 */   // Label 22896: @1667789
     /* 1667789 */   GIM_Try, /*On fail goto*//*Label 22897*/ GIMT_Encode4(1667875), // Rule ID 6102 //
     /* 1667794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1667805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1667808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1667811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1667814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667840 */     // MIs[0] policy
     /* 1667840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667850 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1667853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667874 */     // GIR_Coverage, 6102,
     /* 1667874 */     GIR_EraseRootFromParent_Done,
     /* 1667875 */   // Label 22897: @1667875
     /* 1667875 */   GIM_Try, /*On fail goto*//*Label 22898*/ GIMT_Encode4(1667961), // Rule ID 6103 //
     /* 1667880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1667891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1667894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1667897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1667900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667926 */     // MIs[0] policy
     /* 1667926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667936 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1667939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667960 */     // GIR_Coverage, 6103,
     /* 1667960 */     GIR_EraseRootFromParent_Done,
     /* 1667961 */   // Label 22898: @1667961
     /* 1667961 */   GIM_Try, /*On fail goto*//*Label 22899*/ GIMT_Encode4(1668047), // Rule ID 6106 //
     /* 1667966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1667969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1667977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1667980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1667983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1667986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1667989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668012 */     // MIs[0] policy
     /* 1668012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668022 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1668025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668046 */     // GIR_Coverage, 6106,
     /* 1668046 */     GIR_EraseRootFromParent_Done,
     /* 1668047 */   // Label 22899: @1668047
     /* 1668047 */   GIM_Try, /*On fail goto*//*Label 22900*/ GIMT_Encode4(1668133), // Rule ID 6107 //
     /* 1668052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1668063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1668066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1668069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1668072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668098 */     // MIs[0] policy
     /* 1668098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668108 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1668111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668132 */     // GIR_Coverage, 6107,
     /* 1668132 */     GIR_EraseRootFromParent_Done,
     /* 1668133 */   // Label 22900: @1668133
     /* 1668133 */   GIM_Try, /*On fail goto*//*Label 22901*/ GIMT_Encode4(1668219), // Rule ID 6110 //
     /* 1668138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1668141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1668158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668184 */     // MIs[0] policy
     /* 1668184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668194 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1668197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668218 */     // GIR_Coverage, 6110,
     /* 1668218 */     GIR_EraseRootFromParent_Done,
     /* 1668219 */   // Label 22901: @1668219
     /* 1668219 */   GIM_Try, /*On fail goto*//*Label 22902*/ GIMT_Encode4(1668305), // Rule ID 6111 //
     /* 1668224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1668244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668270 */     // MIs[0] policy
     /* 1668270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668280 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1668283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668304 */     // GIR_Coverage, 6111,
     /* 1668304 */     GIR_EraseRootFromParent_Done,
     /* 1668305 */   // Label 22902: @1668305
     /* 1668305 */   GIM_Try, /*On fail goto*//*Label 22903*/ GIMT_Encode4(1668391), // Rule ID 6114 //
     /* 1668310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1668313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1668321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1668324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1668327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1668330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668356 */     // MIs[0] policy
     /* 1668356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668366 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1668369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668390 */     // GIR_Coverage, 6114,
     /* 1668390 */     GIR_EraseRootFromParent_Done,
     /* 1668391 */   // Label 22903: @1668391
     /* 1668391 */   GIM_Try, /*On fail goto*//*Label 22904*/ GIMT_Encode4(1668477), // Rule ID 6115 //
     /* 1668396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1668407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1668410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1668413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1668416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668442 */     // MIs[0] policy
     /* 1668442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668452 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1668455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668476 */     // GIR_Coverage, 6115,
     /* 1668476 */     GIR_EraseRootFromParent_Done,
     /* 1668477 */   // Label 22904: @1668477
     /* 1668477 */   GIM_Try, /*On fail goto*//*Label 22905*/ GIMT_Encode4(1668563), // Rule ID 6118 //
     /* 1668482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1668493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1668496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1668499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1668505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668528 */     // MIs[0] policy
     /* 1668528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668538 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1668541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668562 */     // GIR_Coverage, 6118,
     /* 1668562 */     GIR_EraseRootFromParent_Done,
     /* 1668563 */   // Label 22905: @1668563
     /* 1668563 */   GIM_Try, /*On fail goto*//*Label 22906*/ GIMT_Encode4(1668649), // Rule ID 6119 //
     /* 1668568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1668579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1668582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1668585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1668591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668614 */     // MIs[0] policy
     /* 1668614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668624 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1668627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668648 */     // GIR_Coverage, 6119,
     /* 1668648 */     GIR_EraseRootFromParent_Done,
     /* 1668649 */   // Label 22906: @1668649
     /* 1668649 */   GIM_Try, /*On fail goto*//*Label 22907*/ GIMT_Encode4(1668735), // Rule ID 6122 //
     /* 1668654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1668665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1668668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1668671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668700 */     // MIs[0] policy
     /* 1668700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668710 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1668713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668734 */     // GIR_Coverage, 6122,
     /* 1668734 */     GIR_EraseRootFromParent_Done,
     /* 1668735 */   // Label 22907: @1668735
     /* 1668735 */   GIM_Try, /*On fail goto*//*Label 22908*/ GIMT_Encode4(1668821), // Rule ID 6123 //
     /* 1668740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1668751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1668754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1668757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668786 */     // MIs[0] policy
     /* 1668786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668796 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1668799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668820 */     // GIR_Coverage, 6123,
     /* 1668820 */     GIR_EraseRootFromParent_Done,
     /* 1668821 */   // Label 22908: @1668821
     /* 1668821 */   GIM_Try, /*On fail goto*//*Label 22909*/ GIMT_Encode4(1668907), // Rule ID 6126 //
     /* 1668826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1668837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1668840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1668843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668872 */     // MIs[0] policy
     /* 1668872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668882 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1668885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668906 */     // GIR_Coverage, 6126,
     /* 1668906 */     GIR_EraseRootFromParent_Done,
     /* 1668907 */   // Label 22909: @1668907
     /* 1668907 */   GIM_Try, /*On fail goto*//*Label 22910*/ GIMT_Encode4(1668993), // Rule ID 6127 //
     /* 1668912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1668923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1668926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1668929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668958 */     // MIs[0] policy
     /* 1668958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668968 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1668971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668992 */     // GIR_Coverage, 6127,
     /* 1668992 */     GIR_EraseRootFromParent_Done,
     /* 1668993 */   // Label 22910: @1668993
     /* 1668993 */   GIM_Try, /*On fail goto*//*Label 22911*/ GIMT_Encode4(1669079), // Rule ID 6130 //
     /* 1668998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1669006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1669009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1669012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1669015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1669018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669044 */     // MIs[0] policy
     /* 1669044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669054 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1669057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669078 */     // GIR_Coverage, 6130,
     /* 1669078 */     GIR_EraseRootFromParent_Done,
     /* 1669079 */   // Label 22911: @1669079
     /* 1669079 */   GIM_Try, /*On fail goto*//*Label 22912*/ GIMT_Encode4(1669165), // Rule ID 6131 //
     /* 1669084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1669092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1669095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1669098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1669101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1669104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669130 */     // MIs[0] policy
     /* 1669130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669140 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1669143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669164 */     // GIR_Coverage, 6131,
     /* 1669164 */     GIR_EraseRootFromParent_Done,
     /* 1669165 */   // Label 22912: @1669165
     /* 1669165 */   GIM_Try, /*On fail goto*//*Label 22913*/ GIMT_Encode4(1669251), // Rule ID 6134 //
     /* 1669170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1669178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1669181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1669184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1669187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1669190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669216 */     // MIs[0] policy
     /* 1669216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669226 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1669229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669250 */     // GIR_Coverage, 6134,
     /* 1669250 */     GIR_EraseRootFromParent_Done,
     /* 1669251 */   // Label 22913: @1669251
     /* 1669251 */   GIM_Try, /*On fail goto*//*Label 22914*/ GIMT_Encode4(1669337), // Rule ID 6135 //
     /* 1669256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1669264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1669267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1669270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1669273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1669276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669302 */     // MIs[0] policy
     /* 1669302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669312 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1669315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669336 */     // GIR_Coverage, 6135,
     /* 1669336 */     GIR_EraseRootFromParent_Done,
     /* 1669337 */   // Label 22914: @1669337
     /* 1669337 */   GIM_Try, /*On fail goto*//*Label 22915*/ GIMT_Encode4(1669423), // Rule ID 6138 //
     /* 1669342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1669350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1669353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1669356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1669359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1669362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669388 */     // MIs[0] policy
     /* 1669388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669398 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1669401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669422 */     // GIR_Coverage, 6138,
     /* 1669422 */     GIR_EraseRootFromParent_Done,
     /* 1669423 */   // Label 22915: @1669423
     /* 1669423 */   GIM_Try, /*On fail goto*//*Label 22916*/ GIMT_Encode4(1669509), // Rule ID 6139 //
     /* 1669428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1669436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1669439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1669442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1669445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1669448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669474 */     // MIs[0] policy
     /* 1669474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1669487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669508 */     // GIR_Coverage, 6139,
     /* 1669508 */     GIR_EraseRootFromParent_Done,
     /* 1669509 */   // Label 22916: @1669509
     /* 1669509 */   GIM_Try, /*On fail goto*//*Label 22917*/ GIMT_Encode4(1669595), // Rule ID 6142 //
     /* 1669514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1669522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1669525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1669528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1669531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1669534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669560 */     // MIs[0] policy
     /* 1669560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669570 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1669573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669594 */     // GIR_Coverage, 6142,
     /* 1669594 */     GIR_EraseRootFromParent_Done,
     /* 1669595 */   // Label 22917: @1669595
     /* 1669595 */   GIM_Try, /*On fail goto*//*Label 22918*/ GIMT_Encode4(1669681), // Rule ID 6143 //
     /* 1669600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1669608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1669611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1669614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1669617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1669620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669646 */     // MIs[0] policy
     /* 1669646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669656 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1669659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669680 */     // GIR_Coverage, 6143,
     /* 1669680 */     GIR_EraseRootFromParent_Done,
     /* 1669681 */   // Label 22918: @1669681
     /* 1669681 */   GIM_Try, /*On fail goto*//*Label 22919*/ GIMT_Encode4(1669767), // Rule ID 6146 //
     /* 1669686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1669694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1669697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1669700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1669703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1669706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669732 */     // MIs[0] policy
     /* 1669732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669742 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1669745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669766 */     // GIR_Coverage, 6146,
     /* 1669766 */     GIR_EraseRootFromParent_Done,
     /* 1669767 */   // Label 22919: @1669767
     /* 1669767 */   GIM_Try, /*On fail goto*//*Label 22920*/ GIMT_Encode4(1669853), // Rule ID 6147 //
     /* 1669772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1669780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1669783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1669786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1669789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1669792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669818 */     // MIs[0] policy
     /* 1669818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669828 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1669831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669852 */     // GIR_Coverage, 6147,
     /* 1669852 */     GIR_EraseRootFromParent_Done,
     /* 1669853 */   // Label 22920: @1669853
     /* 1669853 */   GIM_Try, /*On fail goto*//*Label 22921*/ GIMT_Encode4(1669939), // Rule ID 6150 //
     /* 1669858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1669866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1669869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1669872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1669875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1669878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669904 */     // MIs[0] policy
     /* 1669904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669914 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1669917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669938 */     // GIR_Coverage, 6150,
     /* 1669938 */     GIR_EraseRootFromParent_Done,
     /* 1669939 */   // Label 22921: @1669939
     /* 1669939 */   GIM_Try, /*On fail goto*//*Label 22922*/ GIMT_Encode4(1670025), // Rule ID 6151 //
     /* 1669944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1669952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1669955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1669958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1669961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1669964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669990 */     // MIs[0] policy
     /* 1669990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670000 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1670003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670024 */     // GIR_Coverage, 6151,
     /* 1670024 */     GIR_EraseRootFromParent_Done,
     /* 1670025 */   // Label 22922: @1670025
     /* 1670025 */   GIM_Try, /*On fail goto*//*Label 22923*/ GIMT_Encode4(1670111), // Rule ID 6154 //
     /* 1670030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1670033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1670038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1670041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1670044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1670047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1670050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670076 */     // MIs[0] policy
     /* 1670076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1670089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1670107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670110 */     // GIR_Coverage, 6154,
     /* 1670110 */     GIR_EraseRootFromParent_Done,
     /* 1670111 */   // Label 22923: @1670111
     /* 1670111 */   GIM_Try, /*On fail goto*//*Label 22924*/ GIMT_Encode4(1670197), // Rule ID 6155 //
     /* 1670116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1670119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1670124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1670127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1670130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1670133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1670136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670162 */     // MIs[0] policy
     /* 1670162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670172 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1670175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1670193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670196 */     // GIR_Coverage, 6155,
     /* 1670196 */     GIR_EraseRootFromParent_Done,
     /* 1670197 */   // Label 22924: @1670197
     /* 1670197 */   GIM_Try, /*On fail goto*//*Label 22925*/ GIMT_Encode4(1670283), // Rule ID 6158 //
     /* 1670202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1670210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1670213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1670216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1670219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1670222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670248 */     // MIs[0] policy
     /* 1670248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670258 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1670261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670282 */     // GIR_Coverage, 6158,
     /* 1670282 */     GIR_EraseRootFromParent_Done,
     /* 1670283 */   // Label 22925: @1670283
     /* 1670283 */   GIM_Try, /*On fail goto*//*Label 22926*/ GIMT_Encode4(1670369), // Rule ID 6159 //
     /* 1670288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1670296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1670299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1670302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1670305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1670308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670334 */     // MIs[0] policy
     /* 1670334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670344 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1670347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670368 */     // GIR_Coverage, 6159,
     /* 1670368 */     GIR_EraseRootFromParent_Done,
     /* 1670369 */   // Label 22926: @1670369
     /* 1670369 */   GIM_Try, /*On fail goto*//*Label 22927*/ GIMT_Encode4(1670455), // Rule ID 6162 //
     /* 1670374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1670382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1670385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1670388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1670391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1670394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1670397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670420 */     // MIs[0] policy
     /* 1670420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670430 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1670433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670454 */     // GIR_Coverage, 6162,
     /* 1670454 */     GIR_EraseRootFromParent_Done,
     /* 1670455 */   // Label 22927: @1670455
     /* 1670455 */   GIM_Try, /*On fail goto*//*Label 22928*/ GIMT_Encode4(1670541), // Rule ID 6163 //
     /* 1670460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1670468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1670471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1670474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1670477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1670480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1670483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670506 */     // MIs[0] policy
     /* 1670506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670516 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1670519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670540 */     // GIR_Coverage, 6163,
     /* 1670540 */     GIR_EraseRootFromParent_Done,
     /* 1670541 */   // Label 22928: @1670541
     /* 1670541 */   GIM_Try, /*On fail goto*//*Label 22929*/ GIMT_Encode4(1670627), // Rule ID 6166 //
     /* 1670546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1670554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1670557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1670560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1670563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1670566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1670569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1670576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670592 */     // MIs[0] policy
     /* 1670592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670602 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1670605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670626 */     // GIR_Coverage, 6166,
     /* 1670626 */     GIR_EraseRootFromParent_Done,
     /* 1670627 */   // Label 22929: @1670627
     /* 1670627 */   GIM_Try, /*On fail goto*//*Label 22930*/ GIMT_Encode4(1670713), // Rule ID 6167 //
     /* 1670632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1670640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1670643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1670646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1670649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1670652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1670655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1670662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670678 */     // MIs[0] policy
     /* 1670678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670688 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1670691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670712 */     // GIR_Coverage, 6167,
     /* 1670712 */     GIR_EraseRootFromParent_Done,
     /* 1670713 */   // Label 22930: @1670713
     /* 1670713 */   GIM_Try, /*On fail goto*//*Label 22931*/ GIMT_Encode4(1670799), // Rule ID 6170 //
     /* 1670718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1670726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1670729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1670732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1670735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1670738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1670741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670764 */     // MIs[0] policy
     /* 1670764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670774 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1670777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670798 */     // GIR_Coverage, 6170,
     /* 1670798 */     GIR_EraseRootFromParent_Done,
     /* 1670799 */   // Label 22931: @1670799
     /* 1670799 */   GIM_Try, /*On fail goto*//*Label 22932*/ GIMT_Encode4(1670885), // Rule ID 6171 //
     /* 1670804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1670812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1670815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1670818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1670821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1670824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1670827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670850 */     // MIs[0] policy
     /* 1670850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670860 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1670863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670884 */     // GIR_Coverage, 6171,
     /* 1670884 */     GIR_EraseRootFromParent_Done,
     /* 1670885 */   // Label 22932: @1670885
     /* 1670885 */   GIM_Try, /*On fail goto*//*Label 22933*/ GIMT_Encode4(1670971), // Rule ID 6174 //
     /* 1670890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1670898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1670901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1670904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1670907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1670910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670936 */     // MIs[0] policy
     /* 1670936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670946 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1670949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670970 */     // GIR_Coverage, 6174,
     /* 1670970 */     GIR_EraseRootFromParent_Done,
     /* 1670971 */   // Label 22933: @1670971
     /* 1670971 */   GIM_Try, /*On fail goto*//*Label 22934*/ GIMT_Encode4(1671057), // Rule ID 6175 //
     /* 1670976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1670984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1670987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1670990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1670993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1670996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671022 */     // MIs[0] policy
     /* 1671022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671032 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1671035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671056 */     // GIR_Coverage, 6175,
     /* 1671056 */     GIR_EraseRootFromParent_Done,
     /* 1671057 */   // Label 22934: @1671057
     /* 1671057 */   GIM_Try, /*On fail goto*//*Label 22935*/ GIMT_Encode4(1671143), // Rule ID 6178 //
     /* 1671062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1671070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1671073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1671076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1671079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1671082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671108 */     // MIs[0] policy
     /* 1671108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671118 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1671121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671142 */     // GIR_Coverage, 6178,
     /* 1671142 */     GIR_EraseRootFromParent_Done,
     /* 1671143 */   // Label 22935: @1671143
     /* 1671143 */   GIM_Try, /*On fail goto*//*Label 22936*/ GIMT_Encode4(1671229), // Rule ID 6179 //
     /* 1671148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1671156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1671159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1671162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1671165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1671168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671194 */     // MIs[0] policy
     /* 1671194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671204 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1671207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671228 */     // GIR_Coverage, 6179,
     /* 1671228 */     GIR_EraseRootFromParent_Done,
     /* 1671229 */   // Label 22936: @1671229
     /* 1671229 */   GIM_Try, /*On fail goto*//*Label 22937*/ GIMT_Encode4(1671315), // Rule ID 6182 //
     /* 1671234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1671242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1671245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1671248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1671251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1671254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671280 */     // MIs[0] policy
     /* 1671280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1671293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671314 */     // GIR_Coverage, 6182,
     /* 1671314 */     GIR_EraseRootFromParent_Done,
     /* 1671315 */   // Label 22937: @1671315
     /* 1671315 */   GIM_Try, /*On fail goto*//*Label 22938*/ GIMT_Encode4(1671401), // Rule ID 6183 //
     /* 1671320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1671328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1671331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1671334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1671337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1671340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671366 */     // MIs[0] policy
     /* 1671366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1671379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671400 */     // GIR_Coverage, 6183,
     /* 1671400 */     GIR_EraseRootFromParent_Done,
     /* 1671401 */   // Label 22938: @1671401
     /* 1671401 */   GIM_Try, /*On fail goto*//*Label 22939*/ GIMT_Encode4(1671487), // Rule ID 6186 //
     /* 1671406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1671414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1671417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1671420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1671423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1671426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671452 */     // MIs[0] policy
     /* 1671452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671462 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1671465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671486 */     // GIR_Coverage, 6186,
     /* 1671486 */     GIR_EraseRootFromParent_Done,
     /* 1671487 */   // Label 22939: @1671487
     /* 1671487 */   GIM_Try, /*On fail goto*//*Label 22940*/ GIMT_Encode4(1671573), // Rule ID 6187 //
     /* 1671492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1671500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1671503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1671506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1671509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1671512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671538 */     // MIs[0] policy
     /* 1671538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671548 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1671551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671572 */     // GIR_Coverage, 6187,
     /* 1671572 */     GIR_EraseRootFromParent_Done,
     /* 1671573 */   // Label 22940: @1671573
     /* 1671573 */   GIM_Try, /*On fail goto*//*Label 22941*/ GIMT_Encode4(1671659), // Rule ID 6190 //
     /* 1671578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1671586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1671589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1671592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1671595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1671598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671624 */     // MIs[0] policy
     /* 1671624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671634 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1671637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671658 */     // GIR_Coverage, 6190,
     /* 1671658 */     GIR_EraseRootFromParent_Done,
     /* 1671659 */   // Label 22941: @1671659
     /* 1671659 */   GIM_Try, /*On fail goto*//*Label 22942*/ GIMT_Encode4(1671745), // Rule ID 6191 //
     /* 1671664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1671672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1671675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1671678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1671681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1671684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671710 */     // MIs[0] policy
     /* 1671710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671720 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1671723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671744 */     // GIR_Coverage, 6191,
     /* 1671744 */     GIR_EraseRootFromParent_Done,
     /* 1671745 */   // Label 22942: @1671745
     /* 1671745 */   GIM_Try, /*On fail goto*//*Label 22943*/ GIMT_Encode4(1671831), // Rule ID 6194 //
     /* 1671750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1671753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1671758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1671761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1671764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1671767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1671770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1671773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671796 */     // MIs[0] policy
     /* 1671796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671806 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1671809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1671827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671830 */     // GIR_Coverage, 6194,
     /* 1671830 */     GIR_EraseRootFromParent_Done,
     /* 1671831 */   // Label 22943: @1671831
     /* 1671831 */   GIM_Try, /*On fail goto*//*Label 22944*/ GIMT_Encode4(1671917), // Rule ID 6195 //
     /* 1671836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1671839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1671844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1671847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1671850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1671853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1671856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1671859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671882 */     // MIs[0] policy
     /* 1671882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1671895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1671913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671916 */     // GIR_Coverage, 6195,
     /* 1671916 */     GIR_EraseRootFromParent_Done,
     /* 1671917 */   // Label 22944: @1671917
     /* 1671917 */   GIM_Try, /*On fail goto*//*Label 22945*/ GIMT_Encode4(1672003), // Rule ID 6198 //
     /* 1671922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1671925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1671930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1671933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1671936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1671939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1671942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671968 */     // MIs[0] policy
     /* 1671968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671978 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1671981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1671999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672002 */     // GIR_Coverage, 6198,
     /* 1672002 */     GIR_EraseRootFromParent_Done,
     /* 1672003 */   // Label 22945: @1672003
     /* 1672003 */   GIM_Try, /*On fail goto*//*Label 22946*/ GIMT_Encode4(1672089), // Rule ID 6199 //
     /* 1672008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1672016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1672019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1672022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1672025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672054 */     // MIs[0] policy
     /* 1672054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1672067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672088 */     // GIR_Coverage, 6199,
     /* 1672088 */     GIR_EraseRootFromParent_Done,
     /* 1672089 */   // Label 22946: @1672089
     /* 1672089 */   GIM_Try, /*On fail goto*//*Label 22947*/ GIMT_Encode4(1672175), // Rule ID 6202 //
     /* 1672094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1672102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1672105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1672108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1672111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672140 */     // MIs[0] policy
     /* 1672140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672150 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1672153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672174 */     // GIR_Coverage, 6202,
     /* 1672174 */     GIR_EraseRootFromParent_Done,
     /* 1672175 */   // Label 22947: @1672175
     /* 1672175 */   GIM_Try, /*On fail goto*//*Label 22948*/ GIMT_Encode4(1672261), // Rule ID 6203 //
     /* 1672180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1672188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1672191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1672194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1672197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672226 */     // MIs[0] policy
     /* 1672226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672236 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1672239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672260 */     // GIR_Coverage, 6203,
     /* 1672260 */     GIR_EraseRootFromParent_Done,
     /* 1672261 */   // Label 22948: @1672261
     /* 1672261 */   GIM_Try, /*On fail goto*//*Label 22949*/ GIMT_Encode4(1672347), // Rule ID 6294 //
     /* 1672266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1672277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1672280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1672283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1672286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672312 */     // MIs[0] policy
     /* 1672312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672322 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1672325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672346 */     // GIR_Coverage, 6294,
     /* 1672346 */     GIR_EraseRootFromParent_Done,
     /* 1672347 */   // Label 22949: @1672347
     /* 1672347 */   GIM_Try, /*On fail goto*//*Label 22950*/ GIMT_Encode4(1672433), // Rule ID 6295 //
     /* 1672352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1672363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1672366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1672369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1672372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672398 */     // MIs[0] policy
     /* 1672398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672408 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1672411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672432 */     // GIR_Coverage, 6295,
     /* 1672432 */     GIR_EraseRootFromParent_Done,
     /* 1672433 */   // Label 22950: @1672433
     /* 1672433 */   GIM_Try, /*On fail goto*//*Label 22951*/ GIMT_Encode4(1672519), // Rule ID 6298 //
     /* 1672438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1672449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1672452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1672455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1672458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672484 */     // MIs[0] policy
     /* 1672484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672494 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1672497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672518 */     // GIR_Coverage, 6298,
     /* 1672518 */     GIR_EraseRootFromParent_Done,
     /* 1672519 */   // Label 22951: @1672519
     /* 1672519 */   GIM_Try, /*On fail goto*//*Label 22952*/ GIMT_Encode4(1672605), // Rule ID 6299 //
     /* 1672524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1672535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1672538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1672541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1672544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672570 */     // MIs[0] policy
     /* 1672570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672580 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1672583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672604 */     // GIR_Coverage, 6299,
     /* 1672604 */     GIR_EraseRootFromParent_Done,
     /* 1672605 */   // Label 22952: @1672605
     /* 1672605 */   GIM_Try, /*On fail goto*//*Label 22953*/ GIMT_Encode4(1672691), // Rule ID 6302 //
     /* 1672610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1672621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1672624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1672627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1672630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672656 */     // MIs[0] policy
     /* 1672656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672666 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1672669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672690 */     // GIR_Coverage, 6302,
     /* 1672690 */     GIR_EraseRootFromParent_Done,
     /* 1672691 */   // Label 22953: @1672691
     /* 1672691 */   GIM_Try, /*On fail goto*//*Label 22954*/ GIMT_Encode4(1672777), // Rule ID 6303 //
     /* 1672696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1672707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1672710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1672713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1672716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672742 */     // MIs[0] policy
     /* 1672742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672752 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1672755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672776 */     // GIR_Coverage, 6303,
     /* 1672776 */     GIR_EraseRootFromParent_Done,
     /* 1672777 */   // Label 22954: @1672777
     /* 1672777 */   GIM_Try, /*On fail goto*//*Label 22955*/ GIMT_Encode4(1672863), // Rule ID 6306 //
     /* 1672782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1672793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1672796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1672799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1672802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672828 */     // MIs[0] policy
     /* 1672828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672838 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1672841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672862 */     // GIR_Coverage, 6306,
     /* 1672862 */     GIR_EraseRootFromParent_Done,
     /* 1672863 */   // Label 22955: @1672863
     /* 1672863 */   GIM_Try, /*On fail goto*//*Label 22956*/ GIMT_Encode4(1672949), // Rule ID 6307 //
     /* 1672868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1672879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1672882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1672885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1672888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672914 */     // MIs[0] policy
     /* 1672914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672924 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1672927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672948 */     // GIR_Coverage, 6307,
     /* 1672948 */     GIR_EraseRootFromParent_Done,
     /* 1672949 */   // Label 22956: @1672949
     /* 1672949 */   GIM_Try, /*On fail goto*//*Label 22957*/ GIMT_Encode4(1673035), // Rule ID 6310 //
     /* 1672954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1672965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1672968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1672971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1672974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673000 */     // MIs[0] policy
     /* 1673000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673010 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1673013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673034 */     // GIR_Coverage, 6310,
     /* 1673034 */     GIR_EraseRootFromParent_Done,
     /* 1673035 */   // Label 22957: @1673035
     /* 1673035 */   GIM_Try, /*On fail goto*//*Label 22958*/ GIMT_Encode4(1673121), // Rule ID 6311 //
     /* 1673040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1673051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1673054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1673057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1673060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673086 */     // MIs[0] policy
     /* 1673086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1673099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673120 */     // GIR_Coverage, 6311,
     /* 1673120 */     GIR_EraseRootFromParent_Done,
     /* 1673121 */   // Label 22958: @1673121
     /* 1673121 */   GIM_Try, /*On fail goto*//*Label 22959*/ GIMT_Encode4(1673207), // Rule ID 6314 //
     /* 1673126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1673137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1673140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1673143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1673146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673172 */     // MIs[0] policy
     /* 1673172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673182 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1673185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673206 */     // GIR_Coverage, 6314,
     /* 1673206 */     GIR_EraseRootFromParent_Done,
     /* 1673207 */   // Label 22959: @1673207
     /* 1673207 */   GIM_Try, /*On fail goto*//*Label 22960*/ GIMT_Encode4(1673293), // Rule ID 6315 //
     /* 1673212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1673223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1673226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1673229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1673232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673258 */     // MIs[0] policy
     /* 1673258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1673271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673292 */     // GIR_Coverage, 6315,
     /* 1673292 */     GIR_EraseRootFromParent_Done,
     /* 1673293 */   // Label 22960: @1673293
     /* 1673293 */   GIM_Try, /*On fail goto*//*Label 22961*/ GIMT_Encode4(1673379), // Rule ID 6318 //
     /* 1673298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1673309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1673312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1673315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1673318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673344 */     // MIs[0] policy
     /* 1673344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673354 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1673357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673378 */     // GIR_Coverage, 6318,
     /* 1673378 */     GIR_EraseRootFromParent_Done,
     /* 1673379 */   // Label 22961: @1673379
     /* 1673379 */   GIM_Try, /*On fail goto*//*Label 22962*/ GIMT_Encode4(1673465), // Rule ID 6319 //
     /* 1673384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1673395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1673398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1673401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1673404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673430 */     // MIs[0] policy
     /* 1673430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673440 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1673443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673464 */     // GIR_Coverage, 6319,
     /* 1673464 */     GIR_EraseRootFromParent_Done,
     /* 1673465 */   // Label 22962: @1673465
     /* 1673465 */   GIM_Try, /*On fail goto*//*Label 22963*/ GIMT_Encode4(1673551), // Rule ID 6322 //
     /* 1673470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1673481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1673484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1673487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1673490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673516 */     // MIs[0] policy
     /* 1673516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673526 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1673529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673550 */     // GIR_Coverage, 6322,
     /* 1673550 */     GIR_EraseRootFromParent_Done,
     /* 1673551 */   // Label 22963: @1673551
     /* 1673551 */   GIM_Try, /*On fail goto*//*Label 22964*/ GIMT_Encode4(1673637), // Rule ID 6323 //
     /* 1673556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1673567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1673570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1673573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1673576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673602 */     // MIs[0] policy
     /* 1673602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673612 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1673615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673636 */     // GIR_Coverage, 6323,
     /* 1673636 */     GIR_EraseRootFromParent_Done,
     /* 1673637 */   // Label 22964: @1673637
     /* 1673637 */   GIM_Try, /*On fail goto*//*Label 22965*/ GIMT_Encode4(1673723), // Rule ID 6326 //
     /* 1673642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1673653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1673656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1673659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1673662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673688 */     // MIs[0] policy
     /* 1673688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673698 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1673701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673722 */     // GIR_Coverage, 6326,
     /* 1673722 */     GIR_EraseRootFromParent_Done,
     /* 1673723 */   // Label 22965: @1673723
     /* 1673723 */   GIM_Try, /*On fail goto*//*Label 22966*/ GIMT_Encode4(1673809), // Rule ID 6327 //
     /* 1673728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1673739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1673742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1673745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1673748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673774 */     // MIs[0] policy
     /* 1673774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673784 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1673787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673808 */     // GIR_Coverage, 6327,
     /* 1673808 */     GIR_EraseRootFromParent_Done,
     /* 1673809 */   // Label 22966: @1673809
     /* 1673809 */   GIM_Try, /*On fail goto*//*Label 22967*/ GIMT_Encode4(1673895), // Rule ID 6330 //
     /* 1673814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1673817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1673825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1673828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1673831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1673834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673860 */     // MIs[0] policy
     /* 1673860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673870 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1673873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673894 */     // GIR_Coverage, 6330,
     /* 1673894 */     GIR_EraseRootFromParent_Done,
     /* 1673895 */   // Label 22967: @1673895
     /* 1673895 */   GIM_Try, /*On fail goto*//*Label 22968*/ GIMT_Encode4(1673981), // Rule ID 6331 //
     /* 1673900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1673903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1673911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1673914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1673917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1673920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673946 */     // MIs[0] policy
     /* 1673946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673956 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1673959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673980 */     // GIR_Coverage, 6331,
     /* 1673980 */     GIR_EraseRootFromParent_Done,
     /* 1673981 */   // Label 22968: @1673981
     /* 1673981 */   GIM_Try, /*On fail goto*//*Label 22969*/ GIMT_Encode4(1674067), // Rule ID 6334 //
     /* 1673986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1673997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1674000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1674003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1674006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674032 */     // MIs[0] policy
     /* 1674032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674042 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1674045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674066 */     // GIR_Coverage, 6334,
     /* 1674066 */     GIR_EraseRootFromParent_Done,
     /* 1674067 */   // Label 22969: @1674067
     /* 1674067 */   GIM_Try, /*On fail goto*//*Label 22970*/ GIMT_Encode4(1674153), // Rule ID 6335 //
     /* 1674072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1674083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1674086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1674089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1674092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674118 */     // MIs[0] policy
     /* 1674118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674128 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1674131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674152 */     // GIR_Coverage, 6335,
     /* 1674152 */     GIR_EraseRootFromParent_Done,
     /* 1674153 */   // Label 22970: @1674153
     /* 1674153 */   GIM_Try, /*On fail goto*//*Label 22971*/ GIMT_Encode4(1674239), // Rule ID 6338 //
     /* 1674158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1674169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1674172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1674175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1674178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674204 */     // MIs[0] policy
     /* 1674204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674214 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1674217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674238 */     // GIR_Coverage, 6338,
     /* 1674238 */     GIR_EraseRootFromParent_Done,
     /* 1674239 */   // Label 22971: @1674239
     /* 1674239 */   GIM_Try, /*On fail goto*//*Label 22972*/ GIMT_Encode4(1674325), // Rule ID 6339 //
     /* 1674244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1674255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1674258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1674261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1674264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674290 */     // MIs[0] policy
     /* 1674290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674300 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1674303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674324 */     // GIR_Coverage, 6339,
     /* 1674324 */     GIR_EraseRootFromParent_Done,
     /* 1674325 */   // Label 22972: @1674325
     /* 1674325 */   GIM_Try, /*On fail goto*//*Label 22973*/ GIMT_Encode4(1674411), // Rule ID 6342 //
     /* 1674330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1674341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1674344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1674347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1674350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1674353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674376 */     // MIs[0] policy
     /* 1674376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674386 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1674389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674410 */     // GIR_Coverage, 6342,
     /* 1674410 */     GIR_EraseRootFromParent_Done,
     /* 1674411 */   // Label 22973: @1674411
     /* 1674411 */   GIM_Try, /*On fail goto*//*Label 22974*/ GIMT_Encode4(1674497), // Rule ID 6343 //
     /* 1674416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1674427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1674430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1674433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1674436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1674439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674462 */     // MIs[0] policy
     /* 1674462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674472 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1674475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674496 */     // GIR_Coverage, 6343,
     /* 1674496 */     GIR_EraseRootFromParent_Done,
     /* 1674497 */   // Label 22974: @1674497
     /* 1674497 */   GIM_Try, /*On fail goto*//*Label 22975*/ GIMT_Encode4(1674583), // Rule ID 6346 //
     /* 1674502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1674513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1674516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1674519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1674522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1674525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674548 */     // MIs[0] policy
     /* 1674548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674558 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1674561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674582 */     // GIR_Coverage, 6346,
     /* 1674582 */     GIR_EraseRootFromParent_Done,
     /* 1674583 */   // Label 22975: @1674583
     /* 1674583 */   GIM_Try, /*On fail goto*//*Label 22976*/ GIMT_Encode4(1674669), // Rule ID 6347 //
     /* 1674588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1674599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1674602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1674605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1674608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1674611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674634 */     // MIs[0] policy
     /* 1674634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1674647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674668 */     // GIR_Coverage, 6347,
     /* 1674668 */     GIR_EraseRootFromParent_Done,
     /* 1674669 */   // Label 22976: @1674669
     /* 1674669 */   GIM_Try, /*On fail goto*//*Label 22977*/ GIMT_Encode4(1674755), // Rule ID 6350 //
     /* 1674674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1674685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1674688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1674691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1674694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674720 */     // MIs[0] policy
     /* 1674720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674730 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1674733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674754 */     // GIR_Coverage, 6350,
     /* 1674754 */     GIR_EraseRootFromParent_Done,
     /* 1674755 */   // Label 22977: @1674755
     /* 1674755 */   GIM_Try, /*On fail goto*//*Label 22978*/ GIMT_Encode4(1674841), // Rule ID 6351 //
     /* 1674760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1674771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1674774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1674777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1674780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674806 */     // MIs[0] policy
     /* 1674806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674816 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1674819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674840 */     // GIR_Coverage, 6351,
     /* 1674840 */     GIR_EraseRootFromParent_Done,
     /* 1674841 */   // Label 22978: @1674841
     /* 1674841 */   GIM_Try, /*On fail goto*//*Label 22979*/ GIMT_Encode4(1674927), // Rule ID 6354 //
     /* 1674846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1674857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1674860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1674863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1674866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674892 */     // MIs[0] policy
     /* 1674892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674902 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1674905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674926 */     // GIR_Coverage, 6354,
     /* 1674926 */     GIR_EraseRootFromParent_Done,
     /* 1674927 */   // Label 22979: @1674927
     /* 1674927 */   GIM_Try, /*On fail goto*//*Label 22980*/ GIMT_Encode4(1675013), // Rule ID 6355 //
     /* 1674932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1674943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1674946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1674949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1674952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674978 */     // MIs[0] policy
     /* 1674978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674988 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1674991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675012 */     // GIR_Coverage, 6355,
     /* 1675012 */     GIR_EraseRootFromParent_Done,
     /* 1675013 */   // Label 22980: @1675013
     /* 1675013 */   GIM_Try, /*On fail goto*//*Label 22981*/ GIMT_Encode4(1675099), // Rule ID 6358 //
     /* 1675018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1675029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1675032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1675035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1675038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675064 */     // MIs[0] policy
     /* 1675064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675074 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1675077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675098 */     // GIR_Coverage, 6358,
     /* 1675098 */     GIR_EraseRootFromParent_Done,
     /* 1675099 */   // Label 22981: @1675099
     /* 1675099 */   GIM_Try, /*On fail goto*//*Label 22982*/ GIMT_Encode4(1675185), // Rule ID 6359 //
     /* 1675104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1675115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1675118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1675121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1675124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675150 */     // MIs[0] policy
     /* 1675150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1675163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675184 */     // GIR_Coverage, 6359,
     /* 1675184 */     GIR_EraseRootFromParent_Done,
     /* 1675185 */   // Label 22982: @1675185
     /* 1675185 */   GIM_Try, /*On fail goto*//*Label 22983*/ GIMT_Encode4(1675271), // Rule ID 6362 //
     /* 1675190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1675201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1675204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1675207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1675210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675236 */     // MIs[0] policy
     /* 1675236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675246 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1675249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675270 */     // GIR_Coverage, 6362,
     /* 1675270 */     GIR_EraseRootFromParent_Done,
     /* 1675271 */   // Label 22983: @1675271
     /* 1675271 */   GIM_Try, /*On fail goto*//*Label 22984*/ GIMT_Encode4(1675357), // Rule ID 6363 //
     /* 1675276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1675287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1675290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1675293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1675296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675322 */     // MIs[0] policy
     /* 1675322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675332 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1675335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675356 */     // GIR_Coverage, 6363,
     /* 1675356 */     GIR_EraseRootFromParent_Done,
     /* 1675357 */   // Label 22984: @1675357
     /* 1675357 */   GIM_Try, /*On fail goto*//*Label 22985*/ GIMT_Encode4(1675443), // Rule ID 6366 //
     /* 1675362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1675373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1675376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1675379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1675382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675408 */     // MIs[0] policy
     /* 1675408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675418 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1675421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675442 */     // GIR_Coverage, 6366,
     /* 1675442 */     GIR_EraseRootFromParent_Done,
     /* 1675443 */   // Label 22985: @1675443
     /* 1675443 */   GIM_Try, /*On fail goto*//*Label 22986*/ GIMT_Encode4(1675529), // Rule ID 6367 //
     /* 1675448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1675459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1675462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1675465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1675468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675494 */     // MIs[0] policy
     /* 1675494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675504 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1675507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675528 */     // GIR_Coverage, 6367,
     /* 1675528 */     GIR_EraseRootFromParent_Done,
     /* 1675529 */   // Label 22986: @1675529
     /* 1675529 */   GIM_Try, /*On fail goto*//*Label 22987*/ GIMT_Encode4(1675615), // Rule ID 6370 //
     /* 1675534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1675537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1675545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1675548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1675551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1675554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1675557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675580 */     // MIs[0] policy
     /* 1675580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1675593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675614 */     // GIR_Coverage, 6370,
     /* 1675614 */     GIR_EraseRootFromParent_Done,
     /* 1675615 */   // Label 22987: @1675615
     /* 1675615 */   GIM_Try, /*On fail goto*//*Label 22988*/ GIMT_Encode4(1675701), // Rule ID 6371 //
     /* 1675620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1675623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1675631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1675634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1675637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1675640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1675643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675666 */     // MIs[0] policy
     /* 1675666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1675679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675700 */     // GIR_Coverage, 6371,
     /* 1675700 */     GIR_EraseRootFromParent_Done,
     /* 1675701 */   // Label 22988: @1675701
     /* 1675701 */   GIM_Try, /*On fail goto*//*Label 22989*/ GIMT_Encode4(1675787), // Rule ID 6374 //
     /* 1675706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1675709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1675717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1675720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1675723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1675726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675752 */     // MIs[0] policy
     /* 1675752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675762 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1675765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675786 */     // GIR_Coverage, 6374,
     /* 1675786 */     GIR_EraseRootFromParent_Done,
     /* 1675787 */   // Label 22989: @1675787
     /* 1675787 */   GIM_Try, /*On fail goto*//*Label 22990*/ GIMT_Encode4(1675873), // Rule ID 6375 //
     /* 1675792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1675795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1675803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1675806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1675809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1675812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675838 */     // MIs[0] policy
     /* 1675838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675848 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1675851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675872 */     // GIR_Coverage, 6375,
     /* 1675872 */     GIR_EraseRootFromParent_Done,
     /* 1675873 */   // Label 22990: @1675873
     /* 1675873 */   GIM_Try, /*On fail goto*//*Label 22991*/ GIMT_Encode4(1675959), // Rule ID 6378 //
     /* 1675878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1675881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1675889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1675892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1675895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1675898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675924 */     // MIs[0] policy
     /* 1675924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675934 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1675937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675958 */     // GIR_Coverage, 6378,
     /* 1675958 */     GIR_EraseRootFromParent_Done,
     /* 1675959 */   // Label 22991: @1675959
     /* 1675959 */   GIM_Try, /*On fail goto*//*Label 22992*/ GIMT_Encode4(1676045), // Rule ID 6379 //
     /* 1675964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1675967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1675975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1675978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1675981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1675984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676010 */     // MIs[0] policy
     /* 1676010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676020 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1676023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676044 */     // GIR_Coverage, 6379,
     /* 1676044 */     GIR_EraseRootFromParent_Done,
     /* 1676045 */   // Label 22992: @1676045
     /* 1676045 */   GIM_Try, /*On fail goto*//*Label 22993*/ GIMT_Encode4(1676131), // Rule ID 6382 //
     /* 1676050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1676061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1676064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1676067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676096 */     // MIs[0] policy
     /* 1676096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676106 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1676109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676130 */     // GIR_Coverage, 6382,
     /* 1676130 */     GIR_EraseRootFromParent_Done,
     /* 1676131 */   // Label 22993: @1676131
     /* 1676131 */   GIM_Try, /*On fail goto*//*Label 22994*/ GIMT_Encode4(1676217), // Rule ID 6383 //
     /* 1676136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1676147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1676150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1676153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676182 */     // MIs[0] policy
     /* 1676182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676192 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1676195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676216 */     // GIR_Coverage, 6383,
     /* 1676216 */     GIR_EraseRootFromParent_Done,
     /* 1676217 */   // Label 22994: @1676217
     /* 1676217 */   GIM_Try, /*On fail goto*//*Label 22995*/ GIMT_Encode4(1676303), // Rule ID 6386 //
     /* 1676222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1676233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1676236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1676239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676268 */     // MIs[0] policy
     /* 1676268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676278 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1676281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676302 */     // GIR_Coverage, 6386,
     /* 1676302 */     GIR_EraseRootFromParent_Done,
     /* 1676303 */   // Label 22995: @1676303
     /* 1676303 */   GIM_Try, /*On fail goto*//*Label 22996*/ GIMT_Encode4(1676389), // Rule ID 6387 //
     /* 1676308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1676319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1676322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1676325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676354 */     // MIs[0] policy
     /* 1676354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676364 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1676367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676388 */     // GIR_Coverage, 6387,
     /* 1676388 */     GIR_EraseRootFromParent_Done,
     /* 1676389 */   // Label 22996: @1676389
     /* 1676389 */   GIM_Try, /*On fail goto*//*Label 22997*/ GIMT_Encode4(1676475), // Rule ID 6390 //
     /* 1676394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1676405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1676408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1676411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676440 */     // MIs[0] policy
     /* 1676440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676450 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1676453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676474 */     // GIR_Coverage, 6390,
     /* 1676474 */     GIR_EraseRootFromParent_Done,
     /* 1676475 */   // Label 22997: @1676475
     /* 1676475 */   GIM_Try, /*On fail goto*//*Label 22998*/ GIMT_Encode4(1676561), // Rule ID 6391 //
     /* 1676480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1676491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1676494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1676497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676526 */     // MIs[0] policy
     /* 1676526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676536 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1676539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676560 */     // GIR_Coverage, 6391,
     /* 1676560 */     GIR_EraseRootFromParent_Done,
     /* 1676561 */   // Label 22998: @1676561
     /* 1676561 */   GIM_Try, /*On fail goto*//*Label 22999*/ GIMT_Encode4(1676647), // Rule ID 6394 //
     /* 1676566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1676577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1676580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1676583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676612 */     // MIs[0] policy
     /* 1676612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676622 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1676625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676646 */     // GIR_Coverage, 6394,
     /* 1676646 */     GIR_EraseRootFromParent_Done,
     /* 1676647 */   // Label 22999: @1676647
     /* 1676647 */   GIM_Try, /*On fail goto*//*Label 23000*/ GIMT_Encode4(1676733), // Rule ID 6395 //
     /* 1676652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1676663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1676666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1676669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676698 */     // MIs[0] policy
     /* 1676698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676708 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1676711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676732 */     // GIR_Coverage, 6395,
     /* 1676732 */     GIR_EraseRootFromParent_Done,
     /* 1676733 */   // Label 23000: @1676733
     /* 1676733 */   GIM_Try, /*On fail goto*//*Label 23001*/ GIMT_Encode4(1676819), // Rule ID 6398 //
     /* 1676738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1676749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1676752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1676755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676784 */     // MIs[0] policy
     /* 1676784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676794 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1676797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676818 */     // GIR_Coverage, 6398,
     /* 1676818 */     GIR_EraseRootFromParent_Done,
     /* 1676819 */   // Label 23001: @1676819
     /* 1676819 */   GIM_Try, /*On fail goto*//*Label 23002*/ GIMT_Encode4(1676905), // Rule ID 6399 //
     /* 1676824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1676835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1676838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1676841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676870 */     // MIs[0] policy
     /* 1676870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676880 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1676883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676904 */     // GIR_Coverage, 6399,
     /* 1676904 */     GIR_EraseRootFromParent_Done,
     /* 1676905 */   // Label 23002: @1676905
     /* 1676905 */   GIM_Try, /*On fail goto*//*Label 23003*/ GIMT_Encode4(1676991), // Rule ID 6402 //
     /* 1676910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1676921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1676924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1676927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676956 */     // MIs[0] policy
     /* 1676956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676966 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1676969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676990 */     // GIR_Coverage, 6402,
     /* 1676990 */     GIR_EraseRootFromParent_Done,
     /* 1676991 */   // Label 23003: @1676991
     /* 1676991 */   GIM_Try, /*On fail goto*//*Label 23004*/ GIMT_Encode4(1677077), // Rule ID 6403 //
     /* 1676996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1677004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1677007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1677010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1677013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1677016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677042 */     // MIs[0] policy
     /* 1677042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677052 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1677055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677076 */     // GIR_Coverage, 6403,
     /* 1677076 */     GIR_EraseRootFromParent_Done,
     /* 1677077 */   // Label 23004: @1677077
     /* 1677077 */   GIM_Try, /*On fail goto*//*Label 23005*/ GIMT_Encode4(1677163), // Rule ID 6406 //
     /* 1677082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1677090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1677093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1677096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1677099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1677102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677128 */     // MIs[0] policy
     /* 1677128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677138 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1677141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677162 */     // GIR_Coverage, 6406,
     /* 1677162 */     GIR_EraseRootFromParent_Done,
     /* 1677163 */   // Label 23005: @1677163
     /* 1677163 */   GIM_Try, /*On fail goto*//*Label 23006*/ GIMT_Encode4(1677249), // Rule ID 6407 //
     /* 1677168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1677176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1677179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1677182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1677185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1677188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677214 */     // MIs[0] policy
     /* 1677214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677224 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11653:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1677227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677248 */     // GIR_Coverage, 6407,
     /* 1677248 */     GIR_EraseRootFromParent_Done,
     /* 1677249 */   // Label 23006: @1677249
     /* 1677249 */   GIM_Try, /*On fail goto*//*Label 23007*/ GIMT_Encode4(1677335), // Rule ID 6410 //
     /* 1677254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1677262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1677265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1677268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1677271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1677274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677300 */     // MIs[0] policy
     /* 1677300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677310 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1677313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677334 */     // GIR_Coverage, 6410,
     /* 1677334 */     GIR_EraseRootFromParent_Done,
     /* 1677335 */   // Label 23007: @1677335
     /* 1677335 */   GIM_Try, /*On fail goto*//*Label 23008*/ GIMT_Encode4(1677421), // Rule ID 6411 //
     /* 1677340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1677348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1677351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1677354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1677357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1677360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677386 */     // MIs[0] policy
     /* 1677386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677396 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1677399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677420 */     // GIR_Coverage, 6411,
     /* 1677420 */     GIR_EraseRootFromParent_Done,
     /* 1677421 */   // Label 23008: @1677421
     /* 1677421 */   GIM_Try, /*On fail goto*//*Label 23009*/ GIMT_Encode4(1677507), // Rule ID 6414 //
     /* 1677426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1677434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1677437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1677440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1677443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1677446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677472 */     // MIs[0] policy
     /* 1677472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677482 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1677485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677506 */     // GIR_Coverage, 6414,
     /* 1677506 */     GIR_EraseRootFromParent_Done,
     /* 1677507 */   // Label 23009: @1677507
     /* 1677507 */   GIM_Try, /*On fail goto*//*Label 23010*/ GIMT_Encode4(1677593), // Rule ID 6415 //
     /* 1677512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1677520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1677523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1677526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1677529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1677532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677558 */     // MIs[0] policy
     /* 1677558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677568 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1677571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677592 */     // GIR_Coverage, 6415,
     /* 1677592 */     GIR_EraseRootFromParent_Done,
     /* 1677593 */   // Label 23010: @1677593
     /* 1677593 */   GIM_Try, /*On fail goto*//*Label 23011*/ GIMT_Encode4(1677679), // Rule ID 6418 //
     /* 1677598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1677601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1677606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1677609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1677612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1677615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1677618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677644 */     // MIs[0] policy
     /* 1677644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677654 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1677657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1677675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677678 */     // GIR_Coverage, 6418,
     /* 1677678 */     GIR_EraseRootFromParent_Done,
     /* 1677679 */   // Label 23011: @1677679
     /* 1677679 */   GIM_Try, /*On fail goto*//*Label 23012*/ GIMT_Encode4(1677765), // Rule ID 6419 //
     /* 1677684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1677687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1677692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1677695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1677698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1677701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1677704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677730 */     // MIs[0] policy
     /* 1677730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677740 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1677743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1677761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677764 */     // GIR_Coverage, 6419,
     /* 1677764 */     GIR_EraseRootFromParent_Done,
     /* 1677765 */   // Label 23012: @1677765
     /* 1677765 */   GIM_Try, /*On fail goto*//*Label 23013*/ GIMT_Encode4(1677851), // Rule ID 6422 //
     /* 1677770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1677778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1677781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1677784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1677787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1677790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1677793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1677800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677816 */     // MIs[0] policy
     /* 1677816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677826 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1677829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677850 */     // GIR_Coverage, 6422,
     /* 1677850 */     GIR_EraseRootFromParent_Done,
     /* 1677851 */   // Label 23013: @1677851
     /* 1677851 */   GIM_Try, /*On fail goto*//*Label 23014*/ GIMT_Encode4(1677937), // Rule ID 6423 //
     /* 1677856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1677864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1677867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1677870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1677873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1677876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1677879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1677886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677902 */     // MIs[0] policy
     /* 1677902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677912 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1677915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677936 */     // GIR_Coverage, 6423,
     /* 1677936 */     GIR_EraseRootFromParent_Done,
     /* 1677937 */   // Label 23014: @1677937
     /* 1677937 */   GIM_Try, /*On fail goto*//*Label 23015*/ GIMT_Encode4(1678023), // Rule ID 6426 //
     /* 1677942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1677950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1677953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1677956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1677959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1677962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1677965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1677972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677988 */     // MIs[0] policy
     /* 1677988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677998 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1678001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678022 */     // GIR_Coverage, 6426,
     /* 1678022 */     GIR_EraseRootFromParent_Done,
     /* 1678023 */   // Label 23015: @1678023
     /* 1678023 */   GIM_Try, /*On fail goto*//*Label 23016*/ GIMT_Encode4(1678109), // Rule ID 6427 //
     /* 1678028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1678036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1678039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1678042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1678045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1678048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678074 */     // MIs[0] policy
     /* 1678074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678084 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1678087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678108 */     // GIR_Coverage, 6427,
     /* 1678108 */     GIR_EraseRootFromParent_Done,
     /* 1678109 */   // Label 23016: @1678109
     /* 1678109 */   GIM_Try, /*On fail goto*//*Label 23017*/ GIMT_Encode4(1678195), // Rule ID 6430 //
     /* 1678114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1678122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1678125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1678128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1678131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1678134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1678137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678160 */     // MIs[0] policy
     /* 1678160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678170 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1678173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678194 */     // GIR_Coverage, 6430,
     /* 1678194 */     GIR_EraseRootFromParent_Done,
     /* 1678195 */   // Label 23017: @1678195
     /* 1678195 */   GIM_Try, /*On fail goto*//*Label 23018*/ GIMT_Encode4(1678281), // Rule ID 6431 //
     /* 1678200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1678208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1678211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1678214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1678217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1678220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1678223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678246 */     // MIs[0] policy
     /* 1678246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678256 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1678259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678280 */     // GIR_Coverage, 6431,
     /* 1678280 */     GIR_EraseRootFromParent_Done,
     /* 1678281 */   // Label 23018: @1678281
     /* 1678281 */   GIM_Try, /*On fail goto*//*Label 23019*/ GIMT_Encode4(1678367), // Rule ID 6434 //
     /* 1678286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1678294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1678297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1678300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1678303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1678306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678332 */     // MIs[0] policy
     /* 1678332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678342 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1678345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678366 */     // GIR_Coverage, 6434,
     /* 1678366 */     GIR_EraseRootFromParent_Done,
     /* 1678367 */   // Label 23019: @1678367
     /* 1678367 */   GIM_Try, /*On fail goto*//*Label 23020*/ GIMT_Encode4(1678453), // Rule ID 6435 //
     /* 1678372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1678380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1678383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1678386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1678389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1678392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678418 */     // MIs[0] policy
     /* 1678418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678428 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1678431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678452 */     // GIR_Coverage, 6435,
     /* 1678452 */     GIR_EraseRootFromParent_Done,
     /* 1678453 */   // Label 23020: @1678453
     /* 1678453 */   GIM_Try, /*On fail goto*//*Label 23021*/ GIMT_Encode4(1678539), // Rule ID 6438 //
     /* 1678458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1678466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1678469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1678472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1678475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1678478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678504 */     // MIs[0] policy
     /* 1678504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678514 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1678517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678538 */     // GIR_Coverage, 6438,
     /* 1678538 */     GIR_EraseRootFromParent_Done,
     /* 1678539 */   // Label 23021: @1678539
     /* 1678539 */   GIM_Try, /*On fail goto*//*Label 23022*/ GIMT_Encode4(1678625), // Rule ID 6439 //
     /* 1678544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1678552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1678555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1678558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1678561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1678564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678590 */     // MIs[0] policy
     /* 1678590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678600 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1678603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678624 */     // GIR_Coverage, 6439,
     /* 1678624 */     GIR_EraseRootFromParent_Done,
     /* 1678625 */   // Label 23022: @1678625
     /* 1678625 */   GIM_Try, /*On fail goto*//*Label 23023*/ GIMT_Encode4(1678711), // Rule ID 6442 //
     /* 1678630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1678638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1678641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1678644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1678647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1678650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678676 */     // MIs[0] policy
     /* 1678676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678686 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1678689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678710 */     // GIR_Coverage, 6442,
     /* 1678710 */     GIR_EraseRootFromParent_Done,
     /* 1678711 */   // Label 23023: @1678711
     /* 1678711 */   GIM_Try, /*On fail goto*//*Label 23024*/ GIMT_Encode4(1678797), // Rule ID 6443 //
     /* 1678716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1678724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1678727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1678730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1678733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1678736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678762 */     // MIs[0] policy
     /* 1678762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678772 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1678775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678796 */     // GIR_Coverage, 6443,
     /* 1678796 */     GIR_EraseRootFromParent_Done,
     /* 1678797 */   // Label 23024: @1678797
     /* 1678797 */   GIM_Try, /*On fail goto*//*Label 23025*/ GIMT_Encode4(1678883), // Rule ID 6446 //
     /* 1678802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1678810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1678813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1678816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1678819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1678822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1678825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678848 */     // MIs[0] policy
     /* 1678848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678858 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1678861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678882 */     // GIR_Coverage, 6446,
     /* 1678882 */     GIR_EraseRootFromParent_Done,
     /* 1678883 */   // Label 23025: @1678883
     /* 1678883 */   GIM_Try, /*On fail goto*//*Label 23026*/ GIMT_Encode4(1678969), // Rule ID 6447 //
     /* 1678888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1678896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1678899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1678902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1678905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1678908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1678911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678934 */     // MIs[0] policy
     /* 1678934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1678947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678968 */     // GIR_Coverage, 6447,
     /* 1678968 */     GIR_EraseRootFromParent_Done,
     /* 1678969 */   // Label 23026: @1678969
     /* 1678969 */   GIM_Try, /*On fail goto*//*Label 23027*/ GIMT_Encode4(1679055), // Rule ID 6450 //
     /* 1678974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1678982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1678985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1678988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1678991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1678994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679020 */     // MIs[0] policy
     /* 1679020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679030 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1679033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679054 */     // GIR_Coverage, 6450,
     /* 1679054 */     GIR_EraseRootFromParent_Done,
     /* 1679055 */   // Label 23027: @1679055
     /* 1679055 */   GIM_Try, /*On fail goto*//*Label 23028*/ GIMT_Encode4(1679141), // Rule ID 6451 //
     /* 1679060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1679068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1679071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1679074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1679077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1679080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679106 */     // MIs[0] policy
     /* 1679106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679116 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1679119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679140 */     // GIR_Coverage, 6451,
     /* 1679140 */     GIR_EraseRootFromParent_Done,
     /* 1679141 */   // Label 23028: @1679141
     /* 1679141 */   GIM_Try, /*On fail goto*//*Label 23029*/ GIMT_Encode4(1679227), // Rule ID 6454 //
     /* 1679146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1679154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1679157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1679160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1679163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679192 */     // MIs[0] policy
     /* 1679192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679202 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1679205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679226 */     // GIR_Coverage, 6454,
     /* 1679226 */     GIR_EraseRootFromParent_Done,
     /* 1679227 */   // Label 23029: @1679227
     /* 1679227 */   GIM_Try, /*On fail goto*//*Label 23030*/ GIMT_Encode4(1679313), // Rule ID 6455 //
     /* 1679232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1679240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1679243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1679246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1679249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1679252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679278 */     // MIs[0] policy
     /* 1679278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679288 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1679291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679312 */     // GIR_Coverage, 6455,
     /* 1679312 */     GIR_EraseRootFromParent_Done,
     /* 1679313 */   // Label 23030: @1679313
     /* 1679313 */   GIM_Try, /*On fail goto*//*Label 23031*/ GIMT_Encode4(1679399), // Rule ID 6458 //
     /* 1679318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1679326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1679329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1679332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1679335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679364 */     // MIs[0] policy
     /* 1679364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679374 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1679377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679398 */     // GIR_Coverage, 6458,
     /* 1679398 */     GIR_EraseRootFromParent_Done,
     /* 1679399 */   // Label 23031: @1679399
     /* 1679399 */   GIM_Try, /*On fail goto*//*Label 23032*/ GIMT_Encode4(1679485), // Rule ID 6459 //
     /* 1679404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1679412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1679415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1679418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1679421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1679424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679450 */     // MIs[0] policy
     /* 1679450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679460 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1679463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679484 */     // GIR_Coverage, 6459,
     /* 1679484 */     GIR_EraseRootFromParent_Done,
     /* 1679485 */   // Label 23032: @1679485
     /* 1679485 */   GIM_Try, /*On fail goto*//*Label 23033*/ GIMT_Encode4(1679571), // Rule ID 6462 //
     /* 1679490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1679498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1679501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1679504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1679507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679536 */     // MIs[0] policy
     /* 1679536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679546 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1679549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679570 */     // GIR_Coverage, 6462,
     /* 1679570 */     GIR_EraseRootFromParent_Done,
     /* 1679571 */   // Label 23033: @1679571
     /* 1679571 */   GIM_Try, /*On fail goto*//*Label 23034*/ GIMT_Encode4(1679657), // Rule ID 6463 //
     /* 1679576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1679584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1679587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1679590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1679593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1679596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679622 */     // MIs[0] policy
     /* 1679622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679632 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1679635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679656 */     // GIR_Coverage, 6463,
     /* 1679656 */     GIR_EraseRootFromParent_Done,
     /* 1679657 */   // Label 23034: @1679657
     /* 1679657 */   GIM_Try, /*On fail goto*//*Label 23035*/ GIMT_Encode4(1679743), // Rule ID 6466 //
     /* 1679662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1679670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1679673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1679676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1679679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679708 */     // MIs[0] policy
     /* 1679708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1679721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679742 */     // GIR_Coverage, 6466,
     /* 1679742 */     GIR_EraseRootFromParent_Done,
     /* 1679743 */   // Label 23035: @1679743
     /* 1679743 */   GIM_Try, /*On fail goto*//*Label 23036*/ GIMT_Encode4(1679829), // Rule ID 6467 //
     /* 1679748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1679756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1679759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1679762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1679765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1679768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679794 */     // MIs[0] policy
     /* 1679794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679804 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1679807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679828 */     // GIR_Coverage, 6467,
     /* 1679828 */     GIR_EraseRootFromParent_Done,
     /* 1679829 */   // Label 23036: @1679829
     /* 1679829 */   GIM_Try, /*On fail goto*//*Label 23037*/ GIMT_Encode4(1679915), // Rule ID 6558 //
     /* 1679834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1679845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1679848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1679851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1679854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1679857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1679864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679880 */     // MIs[0] policy
     /* 1679880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679890 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1679893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679914 */     // GIR_Coverage, 6558,
     /* 1679914 */     GIR_EraseRootFromParent_Done,
     /* 1679915 */   // Label 23037: @1679915
     /* 1679915 */   GIM_Try, /*On fail goto*//*Label 23038*/ GIMT_Encode4(1680001), // Rule ID 6559 //
     /* 1679920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1679931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1679934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1679937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1679940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1679943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1679950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679966 */     // MIs[0] policy
     /* 1679966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679976 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1679979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680000 */     // GIR_Coverage, 6559,
     /* 1680000 */     GIR_EraseRootFromParent_Done,
     /* 1680001 */   // Label 23038: @1680001
     /* 1680001 */   GIM_Try, /*On fail goto*//*Label 23039*/ GIMT_Encode4(1680087), // Rule ID 6562 //
     /* 1680006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1680017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1680020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1680023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1680026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680052 */     // MIs[0] policy
     /* 1680052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680062 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1680065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680086 */     // GIR_Coverage, 6562,
     /* 1680086 */     GIR_EraseRootFromParent_Done,
     /* 1680087 */   // Label 23039: @1680087
     /* 1680087 */   GIM_Try, /*On fail goto*//*Label 23040*/ GIMT_Encode4(1680173), // Rule ID 6563 //
     /* 1680092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1680103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1680106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1680109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1680112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680138 */     // MIs[0] policy
     /* 1680138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680148 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1680151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680172 */     // GIR_Coverage, 6563,
     /* 1680172 */     GIR_EraseRootFromParent_Done,
     /* 1680173 */   // Label 23040: @1680173
     /* 1680173 */   GIM_Try, /*On fail goto*//*Label 23041*/ GIMT_Encode4(1680259), // Rule ID 6566 //
     /* 1680178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1680189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1680192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1680195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1680198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680224 */     // MIs[0] policy
     /* 1680224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680234 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1680237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680258 */     // GIR_Coverage, 6566,
     /* 1680258 */     GIR_EraseRootFromParent_Done,
     /* 1680259 */   // Label 23041: @1680259
     /* 1680259 */   GIM_Try, /*On fail goto*//*Label 23042*/ GIMT_Encode4(1680345), // Rule ID 6567 //
     /* 1680264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1680275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1680278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1680281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1680284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680310 */     // MIs[0] policy
     /* 1680310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680320 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1680323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680344 */     // GIR_Coverage, 6567,
     /* 1680344 */     GIR_EraseRootFromParent_Done,
     /* 1680345 */   // Label 23042: @1680345
     /* 1680345 */   GIM_Try, /*On fail goto*//*Label 23043*/ GIMT_Encode4(1680431), // Rule ID 6570 //
     /* 1680350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1680361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1680364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1680367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1680370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680396 */     // MIs[0] policy
     /* 1680396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680406 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1680409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680430 */     // GIR_Coverage, 6570,
     /* 1680430 */     GIR_EraseRootFromParent_Done,
     /* 1680431 */   // Label 23043: @1680431
     /* 1680431 */   GIM_Try, /*On fail goto*//*Label 23044*/ GIMT_Encode4(1680517), // Rule ID 6571 //
     /* 1680436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1680447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1680450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1680453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1680456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680482 */     // MIs[0] policy
     /* 1680482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680492 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1680495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680516 */     // GIR_Coverage, 6571,
     /* 1680516 */     GIR_EraseRootFromParent_Done,
     /* 1680517 */   // Label 23044: @1680517
     /* 1680517 */   GIM_Try, /*On fail goto*//*Label 23045*/ GIMT_Encode4(1680603), // Rule ID 6574 //
     /* 1680522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1680533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1680536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1680539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1680542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680568 */     // MIs[0] policy
     /* 1680568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680578 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1680581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680602 */     // GIR_Coverage, 6574,
     /* 1680602 */     GIR_EraseRootFromParent_Done,
     /* 1680603 */   // Label 23045: @1680603
     /* 1680603 */   GIM_Try, /*On fail goto*//*Label 23046*/ GIMT_Encode4(1680689), // Rule ID 6575 //
     /* 1680608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1680619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1680622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1680625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1680628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680654 */     // MIs[0] policy
     /* 1680654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680664 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1680667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680688 */     // GIR_Coverage, 6575,
     /* 1680688 */     GIR_EraseRootFromParent_Done,
     /* 1680689 */   // Label 23046: @1680689
     /* 1680689 */   GIM_Try, /*On fail goto*//*Label 23047*/ GIMT_Encode4(1680775), // Rule ID 6578 //
     /* 1680694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1680705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1680708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1680711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1680714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680740 */     // MIs[0] policy
     /* 1680740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680750 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1680753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680774 */     // GIR_Coverage, 6578,
     /* 1680774 */     GIR_EraseRootFromParent_Done,
     /* 1680775 */   // Label 23047: @1680775
     /* 1680775 */   GIM_Try, /*On fail goto*//*Label 23048*/ GIMT_Encode4(1680861), // Rule ID 6579 //
     /* 1680780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1680791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1680794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1680797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1680800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680826 */     // MIs[0] policy
     /* 1680826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680836 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1680839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680860 */     // GIR_Coverage, 6579,
     /* 1680860 */     GIR_EraseRootFromParent_Done,
     /* 1680861 */   // Label 23048: @1680861
     /* 1680861 */   GIM_Try, /*On fail goto*//*Label 23049*/ GIMT_Encode4(1680947), // Rule ID 6582 //
     /* 1680866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1680877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1680880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1680883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1680886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680912 */     // MIs[0] policy
     /* 1680912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680922 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1680925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680946 */     // GIR_Coverage, 6582,
     /* 1680946 */     GIR_EraseRootFromParent_Done,
     /* 1680947 */   // Label 23049: @1680947
     /* 1680947 */   GIM_Try, /*On fail goto*//*Label 23050*/ GIMT_Encode4(1681033), // Rule ID 6583 //
     /* 1680952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1680963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1680966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1680969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1680972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680998 */     // MIs[0] policy
     /* 1680998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681008 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1681011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681032 */     // GIR_Coverage, 6583,
     /* 1681032 */     GIR_EraseRootFromParent_Done,
     /* 1681033 */   // Label 23050: @1681033
     /* 1681033 */   GIM_Try, /*On fail goto*//*Label 23051*/ GIMT_Encode4(1681119), // Rule ID 6586 //
     /* 1681038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1681049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1681052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1681055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1681058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681084 */     // MIs[0] policy
     /* 1681084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1681097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681118 */     // GIR_Coverage, 6586,
     /* 1681118 */     GIR_EraseRootFromParent_Done,
     /* 1681119 */   // Label 23051: @1681119
     /* 1681119 */   GIM_Try, /*On fail goto*//*Label 23052*/ GIMT_Encode4(1681205), // Rule ID 6587 //
     /* 1681124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1681135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1681138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1681141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1681144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681170 */     // MIs[0] policy
     /* 1681170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1681183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681204 */     // GIR_Coverage, 6587,
     /* 1681204 */     GIR_EraseRootFromParent_Done,
     /* 1681205 */   // Label 23052: @1681205
     /* 1681205 */   GIM_Try, /*On fail goto*//*Label 23053*/ GIMT_Encode4(1681291), // Rule ID 6590 //
     /* 1681210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1681221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1681224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1681227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1681230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681256 */     // MIs[0] policy
     /* 1681256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681266 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1681269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681290 */     // GIR_Coverage, 6590,
     /* 1681290 */     GIR_EraseRootFromParent_Done,
     /* 1681291 */   // Label 23053: @1681291
     /* 1681291 */   GIM_Try, /*On fail goto*//*Label 23054*/ GIMT_Encode4(1681377), // Rule ID 6591 //
     /* 1681296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1681307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1681310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1681313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1681316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681342 */     // MIs[0] policy
     /* 1681342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1681355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681376 */     // GIR_Coverage, 6591,
     /* 1681376 */     GIR_EraseRootFromParent_Done,
     /* 1681377 */   // Label 23054: @1681377
     /* 1681377 */   GIM_Try, /*On fail goto*//*Label 23055*/ GIMT_Encode4(1681463), // Rule ID 6594 //
     /* 1681382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1681385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1681393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1681396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1681399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1681402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681428 */     // MIs[0] policy
     /* 1681428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681438 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1681441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681462 */     // GIR_Coverage, 6594,
     /* 1681462 */     GIR_EraseRootFromParent_Done,
     /* 1681463 */   // Label 23055: @1681463
     /* 1681463 */   GIM_Try, /*On fail goto*//*Label 23056*/ GIMT_Encode4(1681549), // Rule ID 6595 //
     /* 1681468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1681471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1681479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1681482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1681485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1681488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681514 */     // MIs[0] policy
     /* 1681514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681524 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1681527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681548 */     // GIR_Coverage, 6595,
     /* 1681548 */     GIR_EraseRootFromParent_Done,
     /* 1681549 */   // Label 23056: @1681549
     /* 1681549 */   GIM_Try, /*On fail goto*//*Label 23057*/ GIMT_Encode4(1681635), // Rule ID 6598 //
     /* 1681554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1681565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1681568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1681571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1681574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1681577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1681584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681600 */     // MIs[0] policy
     /* 1681600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681610 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1681613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681634 */     // GIR_Coverage, 6598,
     /* 1681634 */     GIR_EraseRootFromParent_Done,
     /* 1681635 */   // Label 23057: @1681635
     /* 1681635 */   GIM_Try, /*On fail goto*//*Label 23058*/ GIMT_Encode4(1681721), // Rule ID 6599 //
     /* 1681640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1681651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1681654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1681657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1681660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1681663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1681670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681686 */     // MIs[0] policy
     /* 1681686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1681699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681720 */     // GIR_Coverage, 6599,
     /* 1681720 */     GIR_EraseRootFromParent_Done,
     /* 1681721 */   // Label 23058: @1681721
     /* 1681721 */   GIM_Try, /*On fail goto*//*Label 23059*/ GIMT_Encode4(1681807), // Rule ID 6602 //
     /* 1681726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1681737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1681740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1681743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1681746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1681749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1681756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681772 */     // MIs[0] policy
     /* 1681772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681782 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1681785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681806 */     // GIR_Coverage, 6602,
     /* 1681806 */     GIR_EraseRootFromParent_Done,
     /* 1681807 */   // Label 23059: @1681807
     /* 1681807 */   GIM_Try, /*On fail goto*//*Label 23060*/ GIMT_Encode4(1681893), // Rule ID 6603 //
     /* 1681812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1681823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1681826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1681829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1681832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1681835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1681842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681858 */     // MIs[0] policy
     /* 1681858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681868 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1681871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681892 */     // GIR_Coverage, 6603,
     /* 1681892 */     GIR_EraseRootFromParent_Done,
     /* 1681893 */   // Label 23060: @1681893
     /* 1681893 */   GIM_Try, /*On fail goto*//*Label 23061*/ GIMT_Encode4(1681979), // Rule ID 6606 //
     /* 1681898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1681909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1681912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1681915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1681918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1681921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1681928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681944 */     // MIs[0] policy
     /* 1681944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681954 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1681957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681978 */     // GIR_Coverage, 6606,
     /* 1681978 */     GIR_EraseRootFromParent_Done,
     /* 1681979 */   // Label 23061: @1681979
     /* 1681979 */   GIM_Try, /*On fail goto*//*Label 23062*/ GIMT_Encode4(1682065), // Rule ID 6607 //
     /* 1681984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1681995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1681998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1682001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1682004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1682007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682030 */     // MIs[0] policy
     /* 1682030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682040 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1682043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682064 */     // GIR_Coverage, 6607,
     /* 1682064 */     GIR_EraseRootFromParent_Done,
     /* 1682065 */   // Label 23062: @1682065
     /* 1682065 */   GIM_Try, /*On fail goto*//*Label 23063*/ GIMT_Encode4(1682151), // Rule ID 6610 //
     /* 1682070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1682081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1682084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1682087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1682090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682116 */     // MIs[0] policy
     /* 1682116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682126 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1682129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682150 */     // GIR_Coverage, 6610,
     /* 1682150 */     GIR_EraseRootFromParent_Done,
     /* 1682151 */   // Label 23063: @1682151
     /* 1682151 */   GIM_Try, /*On fail goto*//*Label 23064*/ GIMT_Encode4(1682237), // Rule ID 6611 //
     /* 1682156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1682167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1682170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1682173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1682176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682202 */     // MIs[0] policy
     /* 1682202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682212 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1682215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682236 */     // GIR_Coverage, 6611,
     /* 1682236 */     GIR_EraseRootFromParent_Done,
     /* 1682237 */   // Label 23064: @1682237
     /* 1682237 */   GIM_Try, /*On fail goto*//*Label 23065*/ GIMT_Encode4(1682323), // Rule ID 6614 //
     /* 1682242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1682253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1682256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1682259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1682262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682288 */     // MIs[0] policy
     /* 1682288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682298 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1682301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682322 */     // GIR_Coverage, 6614,
     /* 1682322 */     GIR_EraseRootFromParent_Done,
     /* 1682323 */   // Label 23065: @1682323
     /* 1682323 */   GIM_Try, /*On fail goto*//*Label 23066*/ GIMT_Encode4(1682409), // Rule ID 6615 //
     /* 1682328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1682339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1682342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1682345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1682348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682374 */     // MIs[0] policy
     /* 1682374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682384 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1682387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682408 */     // GIR_Coverage, 6615,
     /* 1682408 */     GIR_EraseRootFromParent_Done,
     /* 1682409 */   // Label 23066: @1682409
     /* 1682409 */   GIM_Try, /*On fail goto*//*Label 23067*/ GIMT_Encode4(1682495), // Rule ID 6618 //
     /* 1682414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1682425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1682428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1682431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1682434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682460 */     // MIs[0] policy
     /* 1682460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682470 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1682473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682494 */     // GIR_Coverage, 6618,
     /* 1682494 */     GIR_EraseRootFromParent_Done,
     /* 1682495 */   // Label 23067: @1682495
     /* 1682495 */   GIM_Try, /*On fail goto*//*Label 23068*/ GIMT_Encode4(1682581), // Rule ID 6619 //
     /* 1682500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1682511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1682514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1682517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1682520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682546 */     // MIs[0] policy
     /* 1682546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682556 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1682559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682580 */     // GIR_Coverage, 6619,
     /* 1682580 */     GIR_EraseRootFromParent_Done,
     /* 1682581 */   // Label 23068: @1682581
     /* 1682581 */   GIM_Try, /*On fail goto*//*Label 23069*/ GIMT_Encode4(1682667), // Rule ID 6622 //
     /* 1682586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1682597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1682600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1682603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1682606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1682609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682632 */     // MIs[0] policy
     /* 1682632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682642 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1682645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682666 */     // GIR_Coverage, 6622,
     /* 1682666 */     GIR_EraseRootFromParent_Done,
     /* 1682667 */   // Label 23069: @1682667
     /* 1682667 */   GIM_Try, /*On fail goto*//*Label 23070*/ GIMT_Encode4(1682753), // Rule ID 6623 //
     /* 1682672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1682683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1682686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1682689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1682692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1682695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682718 */     // MIs[0] policy
     /* 1682718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682728 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1682731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682752 */     // GIR_Coverage, 6623,
     /* 1682752 */     GIR_EraseRootFromParent_Done,
     /* 1682753 */   // Label 23070: @1682753
     /* 1682753 */   GIM_Try, /*On fail goto*//*Label 23071*/ GIMT_Encode4(1682839), // Rule ID 6626 //
     /* 1682758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1682769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1682772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1682775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1682778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682804 */     // MIs[0] policy
     /* 1682804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682814 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1682817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682838 */     // GIR_Coverage, 6626,
     /* 1682838 */     GIR_EraseRootFromParent_Done,
     /* 1682839 */   // Label 23071: @1682839
     /* 1682839 */   GIM_Try, /*On fail goto*//*Label 23072*/ GIMT_Encode4(1682925), // Rule ID 6627 //
     /* 1682844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1682855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1682858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1682861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1682864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682890 */     // MIs[0] policy
     /* 1682890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682900 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1682903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682924 */     // GIR_Coverage, 6627,
     /* 1682924 */     GIR_EraseRootFromParent_Done,
     /* 1682925 */   // Label 23072: @1682925
     /* 1682925 */   GIM_Try, /*On fail goto*//*Label 23073*/ GIMT_Encode4(1683011), // Rule ID 6630 //
     /* 1682930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1682941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1682944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1682947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1682950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682976 */     // MIs[0] policy
     /* 1682976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682986 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1682989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683010 */     // GIR_Coverage, 6630,
     /* 1683010 */     GIR_EraseRootFromParent_Done,
     /* 1683011 */   // Label 23073: @1683011
     /* 1683011 */   GIM_Try, /*On fail goto*//*Label 23074*/ GIMT_Encode4(1683097), // Rule ID 6631 //
     /* 1683016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1683027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1683030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1683033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1683036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683062 */     // MIs[0] policy
     /* 1683062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683072 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1683075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683096 */     // GIR_Coverage, 6631,
     /* 1683096 */     GIR_EraseRootFromParent_Done,
     /* 1683097 */   // Label 23074: @1683097
     /* 1683097 */   GIM_Try, /*On fail goto*//*Label 23075*/ GIMT_Encode4(1683183), // Rule ID 6634 //
     /* 1683102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1683113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1683116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1683119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1683122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683148 */     // MIs[0] policy
     /* 1683148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683158 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1683161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683182 */     // GIR_Coverage, 6634,
     /* 1683182 */     GIR_EraseRootFromParent_Done,
     /* 1683183 */   // Label 23075: @1683183
     /* 1683183 */   GIM_Try, /*On fail goto*//*Label 23076*/ GIMT_Encode4(1683269), // Rule ID 6635 //
     /* 1683188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1683199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1683202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1683205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1683208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683234 */     // MIs[0] policy
     /* 1683234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1683247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683268 */     // GIR_Coverage, 6635,
     /* 1683268 */     GIR_EraseRootFromParent_Done,
     /* 1683269 */   // Label 23076: @1683269
     /* 1683269 */   GIM_Try, /*On fail goto*//*Label 23077*/ GIMT_Encode4(1683355), // Rule ID 6638 //
     /* 1683274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1683285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1683288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1683291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1683294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683320 */     // MIs[0] policy
     /* 1683320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683330 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1683333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683354 */     // GIR_Coverage, 6638,
     /* 1683354 */     GIR_EraseRootFromParent_Done,
     /* 1683355 */   // Label 23077: @1683355
     /* 1683355 */   GIM_Try, /*On fail goto*//*Label 23078*/ GIMT_Encode4(1683441), // Rule ID 6639 //
     /* 1683360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1683371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1683374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1683377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1683380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683406 */     // MIs[0] policy
     /* 1683406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683416 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1683419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683440 */     // GIR_Coverage, 6639,
     /* 1683440 */     GIR_EraseRootFromParent_Done,
     /* 1683441 */   // Label 23078: @1683441
     /* 1683441 */   GIM_Try, /*On fail goto*//*Label 23079*/ GIMT_Encode4(1683527), // Rule ID 6642 //
     /* 1683446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1683457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1683460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1683463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1683466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683492 */     // MIs[0] policy
     /* 1683492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1683505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683526 */     // GIR_Coverage, 6642,
     /* 1683526 */     GIR_EraseRootFromParent_Done,
     /* 1683527 */   // Label 23079: @1683527
     /* 1683527 */   GIM_Try, /*On fail goto*//*Label 23080*/ GIMT_Encode4(1683613), // Rule ID 6643 //
     /* 1683532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1683543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1683546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1683549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1683552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683578 */     // MIs[0] policy
     /* 1683578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683588 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1683591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683612 */     // GIR_Coverage, 6643,
     /* 1683612 */     GIR_EraseRootFromParent_Done,
     /* 1683613 */   // Label 23080: @1683613
     /* 1683613 */   GIM_Try, /*On fail goto*//*Label 23081*/ GIMT_Encode4(1683699), // Rule ID 6646 //
     /* 1683618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1683629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1683632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1683635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1683641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683664 */     // MIs[0] policy
     /* 1683664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683674 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1683677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683698 */     // GIR_Coverage, 6646,
     /* 1683698 */     GIR_EraseRootFromParent_Done,
     /* 1683699 */   // Label 23081: @1683699
     /* 1683699 */   GIM_Try, /*On fail goto*//*Label 23082*/ GIMT_Encode4(1683785), // Rule ID 6647 //
     /* 1683704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1683715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1683718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1683721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1683727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683750 */     // MIs[0] policy
     /* 1683750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683760 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1683763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683784 */     // GIR_Coverage, 6647,
     /* 1683784 */     GIR_EraseRootFromParent_Done,
     /* 1683785 */   // Label 23082: @1683785
     /* 1683785 */   GIM_Try, /*On fail goto*//*Label 23083*/ GIMT_Encode4(1683871), // Rule ID 6650 //
     /* 1683790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1683801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1683804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1683807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683836 */     // MIs[0] policy
     /* 1683836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683846 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1683849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683870 */     // GIR_Coverage, 6650,
     /* 1683870 */     GIR_EraseRootFromParent_Done,
     /* 1683871 */   // Label 23083: @1683871
     /* 1683871 */   GIM_Try, /*On fail goto*//*Label 23084*/ GIMT_Encode4(1683957), // Rule ID 6651 //
     /* 1683876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1683887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1683890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1683893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683922 */     // MIs[0] policy
     /* 1683922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683932 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1683935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683956 */     // GIR_Coverage, 6651,
     /* 1683956 */     GIR_EraseRootFromParent_Done,
     /* 1683957 */   // Label 23084: @1683957
     /* 1683957 */   GIM_Try, /*On fail goto*//*Label 23085*/ GIMT_Encode4(1684043), // Rule ID 6654 //
     /* 1683962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1683973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1683976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1683979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684008 */     // MIs[0] policy
     /* 1684008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684018 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1684021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684042 */     // GIR_Coverage, 6654,
     /* 1684042 */     GIR_EraseRootFromParent_Done,
     /* 1684043 */   // Label 23085: @1684043
     /* 1684043 */   GIM_Try, /*On fail goto*//*Label 23086*/ GIMT_Encode4(1684129), // Rule ID 6655 //
     /* 1684048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1684056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1684059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1684062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1684065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1684068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684094 */     // MIs[0] policy
     /* 1684094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684104 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1684107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684128 */     // GIR_Coverage, 6655,
     /* 1684128 */     GIR_EraseRootFromParent_Done,
     /* 1684129 */   // Label 23086: @1684129
     /* 1684129 */   GIM_Try, /*On fail goto*//*Label 23087*/ GIMT_Encode4(1684215), // Rule ID 6658 //
     /* 1684134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1684142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1684145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1684148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1684151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1684154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684180 */     // MIs[0] policy
     /* 1684180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1684193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684214 */     // GIR_Coverage, 6658,
     /* 1684214 */     GIR_EraseRootFromParent_Done,
     /* 1684215 */   // Label 23087: @1684215
     /* 1684215 */   GIM_Try, /*On fail goto*//*Label 23088*/ GIMT_Encode4(1684301), // Rule ID 6659 //
     /* 1684220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1684228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1684231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1684234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1684237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1684240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684266 */     // MIs[0] policy
     /* 1684266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1684279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684300 */     // GIR_Coverage, 6659,
     /* 1684300 */     GIR_EraseRootFromParent_Done,
     /* 1684301 */   // Label 23088: @1684301
     /* 1684301 */   GIM_Try, /*On fail goto*//*Label 23089*/ GIMT_Encode4(1684387), // Rule ID 6662 //
     /* 1684306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1684314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1684317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1684320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1684323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1684326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684352 */     // MIs[0] policy
     /* 1684352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684362 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1684365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684386 */     // GIR_Coverage, 6662,
     /* 1684386 */     GIR_EraseRootFromParent_Done,
     /* 1684387 */   // Label 23089: @1684387
     /* 1684387 */   GIM_Try, /*On fail goto*//*Label 23090*/ GIMT_Encode4(1684473), // Rule ID 6663 //
     /* 1684392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1684400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1684403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1684406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1684409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1684412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684438 */     // MIs[0] policy
     /* 1684438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684448 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1684451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684472 */     // GIR_Coverage, 6663,
     /* 1684472 */     GIR_EraseRootFromParent_Done,
     /* 1684473 */   // Label 23090: @1684473
     /* 1684473 */   GIM_Try, /*On fail goto*//*Label 23091*/ GIMT_Encode4(1684559), // Rule ID 6666 //
     /* 1684478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1684486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1684489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1684492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1684495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1684498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684524 */     // MIs[0] policy
     /* 1684524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684534 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1684537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684558 */     // GIR_Coverage, 6666,
     /* 1684558 */     GIR_EraseRootFromParent_Done,
     /* 1684559 */   // Label 23091: @1684559
     /* 1684559 */   GIM_Try, /*On fail goto*//*Label 23092*/ GIMT_Encode4(1684645), // Rule ID 6667 //
     /* 1684564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1684572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1684575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1684578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1684581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1684584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684610 */     // MIs[0] policy
     /* 1684610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684620 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1684623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684644 */     // GIR_Coverage, 6667,
     /* 1684644 */     GIR_EraseRootFromParent_Done,
     /* 1684645 */   // Label 23092: @1684645
     /* 1684645 */   GIM_Try, /*On fail goto*//*Label 23093*/ GIMT_Encode4(1684731), // Rule ID 6670 //
     /* 1684650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1684658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1684661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1684664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1684667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1684670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1684673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684696 */     // MIs[0] policy
     /* 1684696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684706 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1684709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684730 */     // GIR_Coverage, 6670,
     /* 1684730 */     GIR_EraseRootFromParent_Done,
     /* 1684731 */   // Label 23093: @1684731
     /* 1684731 */   GIM_Try, /*On fail goto*//*Label 23094*/ GIMT_Encode4(1684817), // Rule ID 6671 //
     /* 1684736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1684744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1684747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1684750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1684753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1684756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1684759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684782 */     // MIs[0] policy
     /* 1684782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684792 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1684795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684816 */     // GIR_Coverage, 6671,
     /* 1684816 */     GIR_EraseRootFromParent_Done,
     /* 1684817 */   // Label 23094: @1684817
     /* 1684817 */   GIM_Try, /*On fail goto*//*Label 23095*/ GIMT_Encode4(1684903), // Rule ID 6674 //
     /* 1684822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1684830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1684833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1684836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1684839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1684842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684868 */     // MIs[0] policy
     /* 1684868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684878 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1684881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684902 */     // GIR_Coverage, 6674,
     /* 1684902 */     GIR_EraseRootFromParent_Done,
     /* 1684903 */   // Label 23095: @1684903
     /* 1684903 */   GIM_Try, /*On fail goto*//*Label 23096*/ GIMT_Encode4(1684989), // Rule ID 6675 //
     /* 1684908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1684916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1684919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1684922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1684925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1684928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684954 */     // MIs[0] policy
     /* 1684954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684964 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1684967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684988 */     // GIR_Coverage, 6675,
     /* 1684988 */     GIR_EraseRootFromParent_Done,
     /* 1684989 */   // Label 23096: @1684989
     /* 1684989 */   GIM_Try, /*On fail goto*//*Label 23097*/ GIMT_Encode4(1685075), // Rule ID 6678 //
     /* 1684994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1685002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1685005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1685008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1685011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1685014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685040 */     // MIs[0] policy
     /* 1685040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1685053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685074 */     // GIR_Coverage, 6678,
     /* 1685074 */     GIR_EraseRootFromParent_Done,
     /* 1685075 */   // Label 23097: @1685075
     /* 1685075 */   GIM_Try, /*On fail goto*//*Label 23098*/ GIMT_Encode4(1685161), // Rule ID 6679 //
     /* 1685080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1685088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1685091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1685094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1685097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1685100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685126 */     // MIs[0] policy
     /* 1685126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685136 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1685139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685160 */     // GIR_Coverage, 6679,
     /* 1685160 */     GIR_EraseRootFromParent_Done,
     /* 1685161 */   // Label 23098: @1685161
     /* 1685161 */   GIM_Try, /*On fail goto*//*Label 23099*/ GIMT_Encode4(1685247), // Rule ID 6682 //
     /* 1685166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1685169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1685174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1685177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1685180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1685183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1685186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685212 */     // MIs[0] policy
     /* 1685212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685222 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1685225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685246 */     // GIR_Coverage, 6682,
     /* 1685246 */     GIR_EraseRootFromParent_Done,
     /* 1685247 */   // Label 23099: @1685247
     /* 1685247 */   GIM_Try, /*On fail goto*//*Label 23100*/ GIMT_Encode4(1685333), // Rule ID 6683 //
     /* 1685252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1685255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1685260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1685263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1685266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1685269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1685272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685298 */     // MIs[0] policy
     /* 1685298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1685311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685332 */     // GIR_Coverage, 6683,
     /* 1685332 */     GIR_EraseRootFromParent_Done,
     /* 1685333 */   // Label 23100: @1685333
     /* 1685333 */   GIM_Try, /*On fail goto*//*Label 23101*/ GIMT_Encode4(1685419), // Rule ID 6686 //
     /* 1685338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1685346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1685349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1685352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1685355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1685358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1685361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685384 */     // MIs[0] policy
     /* 1685384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685394 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1685397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685418 */     // GIR_Coverage, 6686,
     /* 1685418 */     GIR_EraseRootFromParent_Done,
     /* 1685419 */   // Label 23101: @1685419
     /* 1685419 */   GIM_Try, /*On fail goto*//*Label 23102*/ GIMT_Encode4(1685505), // Rule ID 6687 //
     /* 1685424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1685432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1685435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1685438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1685441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1685444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1685447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685470 */     // MIs[0] policy
     /* 1685470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685480 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1685483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685504 */     // GIR_Coverage, 6687,
     /* 1685504 */     GIR_EraseRootFromParent_Done,
     /* 1685505 */   // Label 23102: @1685505
     /* 1685505 */   GIM_Try, /*On fail goto*//*Label 23103*/ GIMT_Encode4(1685591), // Rule ID 6690 //
     /* 1685510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1685518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1685521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1685524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1685527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1685530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1685533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1685540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685556 */     // MIs[0] policy
     /* 1685556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685566 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1685569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685590 */     // GIR_Coverage, 6690,
     /* 1685590 */     GIR_EraseRootFromParent_Done,
     /* 1685591 */   // Label 23103: @1685591
     /* 1685591 */   GIM_Try, /*On fail goto*//*Label 23104*/ GIMT_Encode4(1685677), // Rule ID 6691 //
     /* 1685596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1685604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1685607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1685610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1685613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1685616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1685619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1685626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685642 */     // MIs[0] policy
     /* 1685642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685652 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1685655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685676 */     // GIR_Coverage, 6691,
     /* 1685676 */     GIR_EraseRootFromParent_Done,
     /* 1685677 */   // Label 23104: @1685677
     /* 1685677 */   GIM_Try, /*On fail goto*//*Label 23105*/ GIMT_Encode4(1685763), // Rule ID 6694 //
     /* 1685682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1685690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1685693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1685696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1685699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1685702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1685705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1685712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685728 */     // MIs[0] policy
     /* 1685728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685738 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1685741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685762 */     // GIR_Coverage, 6694,
     /* 1685762 */     GIR_EraseRootFromParent_Done,
     /* 1685763 */   // Label 23105: @1685763
     /* 1685763 */   GIM_Try, /*On fail goto*//*Label 23106*/ GIMT_Encode4(1685849), // Rule ID 6695 //
     /* 1685768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1685776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1685779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1685782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1685785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1685788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1685791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1685798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685814 */     // MIs[0] policy
     /* 1685814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685824 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1685827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685848 */     // GIR_Coverage, 6695,
     /* 1685848 */     GIR_EraseRootFromParent_Done,
     /* 1685849 */   // Label 23106: @1685849
     /* 1685849 */   GIM_Try, /*On fail goto*//*Label 23107*/ GIMT_Encode4(1685935), // Rule ID 6698 //
     /* 1685854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1685862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1685865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1685868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1685871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1685874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685900 */     // MIs[0] policy
     /* 1685900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685910 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1685913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685934 */     // GIR_Coverage, 6698,
     /* 1685934 */     GIR_EraseRootFromParent_Done,
     /* 1685935 */   // Label 23107: @1685935
     /* 1685935 */   GIM_Try, /*On fail goto*//*Label 23108*/ GIMT_Encode4(1686021), // Rule ID 6699 //
     /* 1685940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1685948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1685951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1685954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1685957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1685960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685986 */     // MIs[0] policy
     /* 1685986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1685999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686020 */     // GIR_Coverage, 6699,
     /* 1686020 */     GIR_EraseRootFromParent_Done,
     /* 1686021 */   // Label 23108: @1686021
     /* 1686021 */   GIM_Try, /*On fail goto*//*Label 23109*/ GIMT_Encode4(1686107), // Rule ID 6702 //
     /* 1686026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1686034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1686037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1686040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1686043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1686046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686072 */     // MIs[0] policy
     /* 1686072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686082 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1686085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686106 */     // GIR_Coverage, 6702,
     /* 1686106 */     GIR_EraseRootFromParent_Done,
     /* 1686107 */   // Label 23109: @1686107
     /* 1686107 */   GIM_Try, /*On fail goto*//*Label 23110*/ GIMT_Encode4(1686193), // Rule ID 6703 //
     /* 1686112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1686120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1686123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1686126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1686129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1686132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686158 */     // MIs[0] policy
     /* 1686158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686168 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1686171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686192 */     // GIR_Coverage, 6703,
     /* 1686192 */     GIR_EraseRootFromParent_Done,
     /* 1686193 */   // Label 23110: @1686193
     /* 1686193 */   GIM_Try, /*On fail goto*//*Label 23111*/ GIMT_Encode4(1686279), // Rule ID 6706 //
     /* 1686198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1686206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1686209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1686212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1686215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1686218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686244 */     // MIs[0] policy
     /* 1686244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686254 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1686257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686278 */     // GIR_Coverage, 6706,
     /* 1686278 */     GIR_EraseRootFromParent_Done,
     /* 1686279 */   // Label 23111: @1686279
     /* 1686279 */   GIM_Try, /*On fail goto*//*Label 23112*/ GIMT_Encode4(1686365), // Rule ID 6707 //
     /* 1686284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1686292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1686295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1686298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1686301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1686304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686330 */     // MIs[0] policy
     /* 1686330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686340 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1686343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686364 */     // GIR_Coverage, 6707,
     /* 1686364 */     GIR_EraseRootFromParent_Done,
     /* 1686365 */   // Label 23112: @1686365
     /* 1686365 */   GIM_Try, /*On fail goto*//*Label 23113*/ GIMT_Encode4(1686451), // Rule ID 6710 //
     /* 1686370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1686378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1686381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1686384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1686387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1686390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1686393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686416 */     // MIs[0] policy
     /* 1686416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1686429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686450 */     // GIR_Coverage, 6710,
     /* 1686450 */     GIR_EraseRootFromParent_Done,
     /* 1686451 */   // Label 23113: @1686451
     /* 1686451 */   GIM_Try, /*On fail goto*//*Label 23114*/ GIMT_Encode4(1686537), // Rule ID 6711 //
     /* 1686456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1686464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1686467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1686470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1686473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1686476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1686479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686502 */     // MIs[0] policy
     /* 1686502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1686515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686536 */     // GIR_Coverage, 6711,
     /* 1686536 */     GIR_EraseRootFromParent_Done,
     /* 1686537 */   // Label 23114: @1686537
     /* 1686537 */   GIM_Try, /*On fail goto*//*Label 23115*/ GIMT_Encode4(1686623), // Rule ID 6714 //
     /* 1686542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1686550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1686553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1686556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1686559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1686562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686588 */     // MIs[0] policy
     /* 1686588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1686601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686622 */     // GIR_Coverage, 6714,
     /* 1686622 */     GIR_EraseRootFromParent_Done,
     /* 1686623 */   // Label 23115: @1686623
     /* 1686623 */   GIM_Try, /*On fail goto*//*Label 23116*/ GIMT_Encode4(1686709), // Rule ID 6715 //
     /* 1686628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1686636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1686639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1686642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1686645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1686648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686674 */     // MIs[0] policy
     /* 1686674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686684 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1686687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686708 */     // GIR_Coverage, 6715,
     /* 1686708 */     GIR_EraseRootFromParent_Done,
     /* 1686709 */   // Label 23116: @1686709
     /* 1686709 */   GIM_Try, /*On fail goto*//*Label 23117*/ GIMT_Encode4(1686795), // Rule ID 6718 //
     /* 1686714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1686722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1686725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1686728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1686731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1686734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686760 */     // MIs[0] policy
     /* 1686760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686770 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1686773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686794 */     // GIR_Coverage, 6718,
     /* 1686794 */     GIR_EraseRootFromParent_Done,
     /* 1686795 */   // Label 23117: @1686795
     /* 1686795 */   GIM_Try, /*On fail goto*//*Label 23118*/ GIMT_Encode4(1686881), // Rule ID 6719 //
     /* 1686800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1686808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1686811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1686814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1686817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1686820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686846 */     // MIs[0] policy
     /* 1686846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686856 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1686859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686880 */     // GIR_Coverage, 6719,
     /* 1686880 */     GIR_EraseRootFromParent_Done,
     /* 1686881 */   // Label 23118: @1686881
     /* 1686881 */   GIM_Try, /*On fail goto*//*Label 23119*/ GIMT_Encode4(1686967), // Rule ID 6722 //
     /* 1686886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1686889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1686894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1686897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1686900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1686903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1686906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1686909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686932 */     // MIs[0] policy
     /* 1686932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1686945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1686963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686966 */     // GIR_Coverage, 6722,
     /* 1686966 */     GIR_EraseRootFromParent_Done,
     /* 1686967 */   // Label 23119: @1686967
     /* 1686967 */   GIM_Try, /*On fail goto*//*Label 23120*/ GIMT_Encode4(1687053), // Rule ID 6723 //
     /* 1686972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1686975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1686980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1686983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1686986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1686989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1686992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1686995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687018 */     // MIs[0] policy
     /* 1687018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687028 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1687031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687052 */     // GIR_Coverage, 6723,
     /* 1687052 */     GIR_EraseRootFromParent_Done,
     /* 1687053 */   // Label 23120: @1687053
     /* 1687053 */   GIM_Try, /*On fail goto*//*Label 23121*/ GIMT_Encode4(1687139), // Rule ID 6726 //
     /* 1687058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1687066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1687069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1687072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1687075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687104 */     // MIs[0] policy
     /* 1687104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687114 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1687117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687138 */     // GIR_Coverage, 6726,
     /* 1687138 */     GIR_EraseRootFromParent_Done,
     /* 1687139 */   // Label 23121: @1687139
     /* 1687139 */   GIM_Try, /*On fail goto*//*Label 23122*/ GIMT_Encode4(1687225), // Rule ID 6727 //
     /* 1687144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1687152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1687155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1687158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1687161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687190 */     // MIs[0] policy
     /* 1687190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687200 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1687203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687224 */     // GIR_Coverage, 6727,
     /* 1687224 */     GIR_EraseRootFromParent_Done,
     /* 1687225 */   // Label 23122: @1687225
     /* 1687225 */   GIM_Try, /*On fail goto*//*Label 23123*/ GIMT_Encode4(1687311), // Rule ID 6730 //
     /* 1687230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1687238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1687241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1687244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1687247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687276 */     // MIs[0] policy
     /* 1687276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687286 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1687289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687310 */     // GIR_Coverage, 6730,
     /* 1687310 */     GIR_EraseRootFromParent_Done,
     /* 1687311 */   // Label 23123: @1687311
     /* 1687311 */   GIM_Try, /*On fail goto*//*Label 23124*/ GIMT_Encode4(1687397), // Rule ID 6731 //
     /* 1687316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1687324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1687327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1687330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1687333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687362 */     // MIs[0] policy
     /* 1687362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687372 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1687375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687396 */     // GIR_Coverage, 6731,
     /* 1687396 */     GIR_EraseRootFromParent_Done,
     /* 1687397 */   // Label 23124: @1687397
     /* 1687397 */   GIM_Try, /*On fail goto*//*Label 23125*/ GIMT_Encode4(1687483), // Rule ID 6822 //
     /* 1687402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1687413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1687416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1687419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1687422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687448 */     // MIs[0] policy
     /* 1687448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687458 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1687461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687482 */     // GIR_Coverage, 6822,
     /* 1687482 */     GIR_EraseRootFromParent_Done,
     /* 1687483 */   // Label 23125: @1687483
     /* 1687483 */   GIM_Try, /*On fail goto*//*Label 23126*/ GIMT_Encode4(1687569), // Rule ID 6823 //
     /* 1687488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1687499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1687502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1687505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1687508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687534 */     // MIs[0] policy
     /* 1687534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1687547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687568 */     // GIR_Coverage, 6823,
     /* 1687568 */     GIR_EraseRootFromParent_Done,
     /* 1687569 */   // Label 23126: @1687569
     /* 1687569 */   GIM_Try, /*On fail goto*//*Label 23127*/ GIMT_Encode4(1687655), // Rule ID 6826 //
     /* 1687574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1687585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1687588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1687591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1687594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687620 */     // MIs[0] policy
     /* 1687620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687630 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1687633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687654 */     // GIR_Coverage, 6826,
     /* 1687654 */     GIR_EraseRootFromParent_Done,
     /* 1687655 */   // Label 23127: @1687655
     /* 1687655 */   GIM_Try, /*On fail goto*//*Label 23128*/ GIMT_Encode4(1687741), // Rule ID 6827 //
     /* 1687660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1687671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1687674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1687677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1687680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687706 */     // MIs[0] policy
     /* 1687706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687716 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1687719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687740 */     // GIR_Coverage, 6827,
     /* 1687740 */     GIR_EraseRootFromParent_Done,
     /* 1687741 */   // Label 23128: @1687741
     /* 1687741 */   GIM_Try, /*On fail goto*//*Label 23129*/ GIMT_Encode4(1687827), // Rule ID 6830 //
     /* 1687746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1687757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1687760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1687763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1687766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687792 */     // MIs[0] policy
     /* 1687792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687802 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1687805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687826 */     // GIR_Coverage, 6830,
     /* 1687826 */     GIR_EraseRootFromParent_Done,
     /* 1687827 */   // Label 23129: @1687827
     /* 1687827 */   GIM_Try, /*On fail goto*//*Label 23130*/ GIMT_Encode4(1687913), // Rule ID 6831 //
     /* 1687832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1687843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1687846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1687849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1687852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687878 */     // MIs[0] policy
     /* 1687878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687888 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1687891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687912 */     // GIR_Coverage, 6831,
     /* 1687912 */     GIR_EraseRootFromParent_Done,
     /* 1687913 */   // Label 23130: @1687913
     /* 1687913 */   GIM_Try, /*On fail goto*//*Label 23131*/ GIMT_Encode4(1687999), // Rule ID 6834 //
     /* 1687918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1687929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1687932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1687935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1687938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687964 */     // MIs[0] policy
     /* 1687964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687974 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1687977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1687995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687998 */     // GIR_Coverage, 6834,
     /* 1687998 */     GIR_EraseRootFromParent_Done,
     /* 1687999 */   // Label 23131: @1687999
     /* 1687999 */   GIM_Try, /*On fail goto*//*Label 23132*/ GIMT_Encode4(1688085), // Rule ID 6835 //
     /* 1688004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1688015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1688018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1688021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1688024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688050 */     // MIs[0] policy
     /* 1688050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688060 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1688063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688084 */     // GIR_Coverage, 6835,
     /* 1688084 */     GIR_EraseRootFromParent_Done,
     /* 1688085 */   // Label 23132: @1688085
     /* 1688085 */   GIM_Try, /*On fail goto*//*Label 23133*/ GIMT_Encode4(1688171), // Rule ID 6838 //
     /* 1688090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1688101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1688104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1688107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1688110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688136 */     // MIs[0] policy
     /* 1688136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688146 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1688149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688170 */     // GIR_Coverage, 6838,
     /* 1688170 */     GIR_EraseRootFromParent_Done,
     /* 1688171 */   // Label 23133: @1688171
     /* 1688171 */   GIM_Try, /*On fail goto*//*Label 23134*/ GIMT_Encode4(1688257), // Rule ID 6839 //
     /* 1688176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1688187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1688190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1688193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1688196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688222 */     // MIs[0] policy
     /* 1688222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688232 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1688235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688256 */     // GIR_Coverage, 6839,
     /* 1688256 */     GIR_EraseRootFromParent_Done,
     /* 1688257 */   // Label 23134: @1688257
     /* 1688257 */   GIM_Try, /*On fail goto*//*Label 23135*/ GIMT_Encode4(1688343), // Rule ID 6842 //
     /* 1688262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1688273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1688276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1688279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1688282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688308 */     // MIs[0] policy
     /* 1688308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688318 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1688321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688342 */     // GIR_Coverage, 6842,
     /* 1688342 */     GIR_EraseRootFromParent_Done,
     /* 1688343 */   // Label 23135: @1688343
     /* 1688343 */   GIM_Try, /*On fail goto*//*Label 23136*/ GIMT_Encode4(1688429), // Rule ID 6843 //
     /* 1688348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1688359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1688362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1688365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1688368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688394 */     // MIs[0] policy
     /* 1688394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1688407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688428 */     // GIR_Coverage, 6843,
     /* 1688428 */     GIR_EraseRootFromParent_Done,
     /* 1688429 */   // Label 23136: @1688429
     /* 1688429 */   GIM_Try, /*On fail goto*//*Label 23137*/ GIMT_Encode4(1688515), // Rule ID 6846 //
     /* 1688434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1688445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1688448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1688451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1688454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688480 */     // MIs[0] policy
     /* 1688480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688490 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1688493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688514 */     // GIR_Coverage, 6846,
     /* 1688514 */     GIR_EraseRootFromParent_Done,
     /* 1688515 */   // Label 23137: @1688515
     /* 1688515 */   GIM_Try, /*On fail goto*//*Label 23138*/ GIMT_Encode4(1688601), // Rule ID 6847 //
     /* 1688520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1688531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1688534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1688537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1688540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688566 */     // MIs[0] policy
     /* 1688566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688576 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1688579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688600 */     // GIR_Coverage, 6847,
     /* 1688600 */     GIR_EraseRootFromParent_Done,
     /* 1688601 */   // Label 23138: @1688601
     /* 1688601 */   GIM_Try, /*On fail goto*//*Label 23139*/ GIMT_Encode4(1688687), // Rule ID 6850 //
     /* 1688606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1688617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1688620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1688623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1688626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688652 */     // MIs[0] policy
     /* 1688652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688662 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1688665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688686 */     // GIR_Coverage, 6850,
     /* 1688686 */     GIR_EraseRootFromParent_Done,
     /* 1688687 */   // Label 23139: @1688687
     /* 1688687 */   GIM_Try, /*On fail goto*//*Label 23140*/ GIMT_Encode4(1688773), // Rule ID 6851 //
     /* 1688692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1688703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1688706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1688709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1688712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688738 */     // MIs[0] policy
     /* 1688738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688748 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1688751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688772 */     // GIR_Coverage, 6851,
     /* 1688772 */     GIR_EraseRootFromParent_Done,
     /* 1688773 */   // Label 23140: @1688773
     /* 1688773 */   GIM_Try, /*On fail goto*//*Label 23141*/ GIMT_Encode4(1688859), // Rule ID 6854 //
     /* 1688778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1688789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1688792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1688795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1688798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688824 */     // MIs[0] policy
     /* 1688824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1688837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688858 */     // GIR_Coverage, 6854,
     /* 1688858 */     GIR_EraseRootFromParent_Done,
     /* 1688859 */   // Label 23141: @1688859
     /* 1688859 */   GIM_Try, /*On fail goto*//*Label 23142*/ GIMT_Encode4(1688945), // Rule ID 6855 //
     /* 1688864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1688875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1688878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1688881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1688884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688910 */     // MIs[0] policy
     /* 1688910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688920 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1688923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688944 */     // GIR_Coverage, 6855,
     /* 1688944 */     GIR_EraseRootFromParent_Done,
     /* 1688945 */   // Label 23142: @1688945
     /* 1688945 */   GIM_Try, /*On fail goto*//*Label 23143*/ GIMT_Encode4(1689031), // Rule ID 6858 //
     /* 1688950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1688953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1688961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1688964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1688967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1688970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688996 */     // MIs[0] policy
     /* 1688996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689006 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1689009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1689027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689030 */     // GIR_Coverage, 6858,
     /* 1689030 */     GIR_EraseRootFromParent_Done,
     /* 1689031 */   // Label 23143: @1689031
     /* 1689031 */   GIM_Try, /*On fail goto*//*Label 23144*/ GIMT_Encode4(1689117), // Rule ID 6859 //
     /* 1689036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1689039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1689047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1689050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1689053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1689056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689082 */     // MIs[0] policy
     /* 1689082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689092 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1689095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1689113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689116 */     // GIR_Coverage, 6859,
     /* 1689116 */     GIR_EraseRootFromParent_Done,
     /* 1689117 */   // Label 23144: @1689117
     /* 1689117 */   GIM_Try, /*On fail goto*//*Label 23145*/ GIMT_Encode4(1689203), // Rule ID 6862 //
     /* 1689122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1689133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1689136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1689139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1689142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689168 */     // MIs[0] policy
     /* 1689168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689178 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1689181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689202 */     // GIR_Coverage, 6862,
     /* 1689202 */     GIR_EraseRootFromParent_Done,
     /* 1689203 */   // Label 23145: @1689203
     /* 1689203 */   GIM_Try, /*On fail goto*//*Label 23146*/ GIMT_Encode4(1689289), // Rule ID 6863 //
     /* 1689208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1689219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1689222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1689225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1689228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689254 */     // MIs[0] policy
     /* 1689254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689264 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1689267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689288 */     // GIR_Coverage, 6863,
     /* 1689288 */     GIR_EraseRootFromParent_Done,
     /* 1689289 */   // Label 23146: @1689289
     /* 1689289 */   GIM_Try, /*On fail goto*//*Label 23147*/ GIMT_Encode4(1689375), // Rule ID 6866 //
     /* 1689294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1689305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1689308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1689311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1689314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1689317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689340 */     // MIs[0] policy
     /* 1689340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689350 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1689353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689374 */     // GIR_Coverage, 6866,
     /* 1689374 */     GIR_EraseRootFromParent_Done,
     /* 1689375 */   // Label 23147: @1689375
     /* 1689375 */   GIM_Try, /*On fail goto*//*Label 23148*/ GIMT_Encode4(1689461), // Rule ID 6867 //
     /* 1689380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1689391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1689394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1689397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1689400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1689403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689426 */     // MIs[0] policy
     /* 1689426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689436 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1689439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689460 */     // GIR_Coverage, 6867,
     /* 1689460 */     GIR_EraseRootFromParent_Done,
     /* 1689461 */   // Label 23148: @1689461
     /* 1689461 */   GIM_Try, /*On fail goto*//*Label 23149*/ GIMT_Encode4(1689547), // Rule ID 6870 //
     /* 1689466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1689477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1689480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1689483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1689486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1689489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1689496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689512 */     // MIs[0] policy
     /* 1689512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689522 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1689525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689546 */     // GIR_Coverage, 6870,
     /* 1689546 */     GIR_EraseRootFromParent_Done,
     /* 1689547 */   // Label 23149: @1689547
     /* 1689547 */   GIM_Try, /*On fail goto*//*Label 23150*/ GIMT_Encode4(1689633), // Rule ID 6871 //
     /* 1689552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1689563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1689566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1689569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1689572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1689575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1689582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689598 */     // MIs[0] policy
     /* 1689598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689608 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1689611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689632 */     // GIR_Coverage, 6871,
     /* 1689632 */     GIR_EraseRootFromParent_Done,
     /* 1689633 */   // Label 23150: @1689633
     /* 1689633 */   GIM_Try, /*On fail goto*//*Label 23151*/ GIMT_Encode4(1689719), // Rule ID 6874 //
     /* 1689638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1689649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1689652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1689655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1689658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1689661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689684 */     // MIs[0] policy
     /* 1689684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1689697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689718 */     // GIR_Coverage, 6874,
     /* 1689718 */     GIR_EraseRootFromParent_Done,
     /* 1689719 */   // Label 23151: @1689719
     /* 1689719 */   GIM_Try, /*On fail goto*//*Label 23152*/ GIMT_Encode4(1689805), // Rule ID 6875 //
     /* 1689724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1689735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1689738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1689741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1689744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1689747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689770 */     // MIs[0] policy
     /* 1689770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689780 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1689783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689804 */     // GIR_Coverage, 6875,
     /* 1689804 */     GIR_EraseRootFromParent_Done,
     /* 1689805 */   // Label 23152: @1689805
     /* 1689805 */   GIM_Try, /*On fail goto*//*Label 23153*/ GIMT_Encode4(1689891), // Rule ID 6878 //
     /* 1689810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1689821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1689824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1689827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1689830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689856 */     // MIs[0] policy
     /* 1689856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689866 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1689869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689890 */     // GIR_Coverage, 6878,
     /* 1689890 */     GIR_EraseRootFromParent_Done,
     /* 1689891 */   // Label 23153: @1689891
     /* 1689891 */   GIM_Try, /*On fail goto*//*Label 23154*/ GIMT_Encode4(1689977), // Rule ID 6879 //
     /* 1689896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1689907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1689910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1689913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1689916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689942 */     // MIs[0] policy
     /* 1689942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689952 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1689955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689976 */     // GIR_Coverage, 6879,
     /* 1689976 */     GIR_EraseRootFromParent_Done,
     /* 1689977 */   // Label 23154: @1689977
     /* 1689977 */   GIM_Try, /*On fail goto*//*Label 23155*/ GIMT_Encode4(1690063), // Rule ID 6882 //
     /* 1689982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1689993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1689996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1689999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1690002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690028 */     // MIs[0] policy
     /* 1690028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690038 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1690041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690062 */     // GIR_Coverage, 6882,
     /* 1690062 */     GIR_EraseRootFromParent_Done,
     /* 1690063 */   // Label 23155: @1690063
     /* 1690063 */   GIM_Try, /*On fail goto*//*Label 23156*/ GIMT_Encode4(1690149), // Rule ID 6883 //
     /* 1690068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1690079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1690082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1690085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1690088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690114 */     // MIs[0] policy
     /* 1690114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690124 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1690127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690148 */     // GIR_Coverage, 6883,
     /* 1690148 */     GIR_EraseRootFromParent_Done,
     /* 1690149 */   // Label 23156: @1690149
     /* 1690149 */   GIM_Try, /*On fail goto*//*Label 23157*/ GIMT_Encode4(1690235), // Rule ID 6886 //
     /* 1690154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1690165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1690168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1690171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1690174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690200 */     // MIs[0] policy
     /* 1690200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1690213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690234 */     // GIR_Coverage, 6886,
     /* 1690234 */     GIR_EraseRootFromParent_Done,
     /* 1690235 */   // Label 23157: @1690235
     /* 1690235 */   GIM_Try, /*On fail goto*//*Label 23158*/ GIMT_Encode4(1690321), // Rule ID 6887 //
     /* 1690240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1690251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1690254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1690257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1690260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690286 */     // MIs[0] policy
     /* 1690286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1690299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690320 */     // GIR_Coverage, 6887,
     /* 1690320 */     GIR_EraseRootFromParent_Done,
     /* 1690321 */   // Label 23158: @1690321
     /* 1690321 */   GIM_Try, /*On fail goto*//*Label 23159*/ GIMT_Encode4(1690407), // Rule ID 6890 //
     /* 1690326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1690337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1690340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1690343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1690346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690372 */     // MIs[0] policy
     /* 1690372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690382 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1690385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690406 */     // GIR_Coverage, 6890,
     /* 1690406 */     GIR_EraseRootFromParent_Done,
     /* 1690407 */   // Label 23159: @1690407
     /* 1690407 */   GIM_Try, /*On fail goto*//*Label 23160*/ GIMT_Encode4(1690493), // Rule ID 6891 //
     /* 1690412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1690423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1690426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1690429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1690432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690458 */     // MIs[0] policy
     /* 1690458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1690471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690492 */     // GIR_Coverage, 6891,
     /* 1690492 */     GIR_EraseRootFromParent_Done,
     /* 1690493 */   // Label 23160: @1690493
     /* 1690493 */   GIM_Try, /*On fail goto*//*Label 23161*/ GIMT_Encode4(1690579), // Rule ID 6894 //
     /* 1690498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1690509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1690512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1690515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1690518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690544 */     // MIs[0] policy
     /* 1690544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690554 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1690557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690578 */     // GIR_Coverage, 6894,
     /* 1690578 */     GIR_EraseRootFromParent_Done,
     /* 1690579 */   // Label 23161: @1690579
     /* 1690579 */   GIM_Try, /*On fail goto*//*Label 23162*/ GIMT_Encode4(1690665), // Rule ID 6895 //
     /* 1690584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1690595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1690598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1690601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1690604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690630 */     // MIs[0] policy
     /* 1690630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1690643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690664 */     // GIR_Coverage, 6895,
     /* 1690664 */     GIR_EraseRootFromParent_Done,
     /* 1690665 */   // Label 23162: @1690665
     /* 1690665 */   GIM_Try, /*On fail goto*//*Label 23163*/ GIMT_Encode4(1690751), // Rule ID 6898 //
     /* 1690670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1690673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1690681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1690684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1690687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1690690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1690693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690716 */     // MIs[0] policy
     /* 1690716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690726 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1690729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690750 */     // GIR_Coverage, 6898,
     /* 1690750 */     GIR_EraseRootFromParent_Done,
     /* 1690751 */   // Label 23163: @1690751
     /* 1690751 */   GIM_Try, /*On fail goto*//*Label 23164*/ GIMT_Encode4(1690837), // Rule ID 6899 //
     /* 1690756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1690759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1690767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1690770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1690773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1690776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1690779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690802 */     // MIs[0] policy
     /* 1690802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1690815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690836 */     // GIR_Coverage, 6899,
     /* 1690836 */     GIR_EraseRootFromParent_Done,
     /* 1690837 */   // Label 23164: @1690837
     /* 1690837 */   GIM_Try, /*On fail goto*//*Label 23165*/ GIMT_Encode4(1690923), // Rule ID 6902 //
     /* 1690842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1690845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1690853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1690856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1690859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1690862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690888 */     // MIs[0] policy
     /* 1690888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690898 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1690901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690922 */     // GIR_Coverage, 6902,
     /* 1690922 */     GIR_EraseRootFromParent_Done,
     /* 1690923 */   // Label 23165: @1690923
     /* 1690923 */   GIM_Try, /*On fail goto*//*Label 23166*/ GIMT_Encode4(1691009), // Rule ID 6903 //
     /* 1690928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1690931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1690939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1690942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1690945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1690948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690974 */     // MIs[0] policy
     /* 1690974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690984 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1690987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691008 */     // GIR_Coverage, 6903,
     /* 1691008 */     GIR_EraseRootFromParent_Done,
     /* 1691009 */   // Label 23166: @1691009
     /* 1691009 */   GIM_Try, /*On fail goto*//*Label 23167*/ GIMT_Encode4(1691095), // Rule ID 6906 //
     /* 1691014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1691017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1691025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1691028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1691031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1691034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691060 */     // MIs[0] policy
     /* 1691060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691070 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1691073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691094 */     // GIR_Coverage, 6906,
     /* 1691094 */     GIR_EraseRootFromParent_Done,
     /* 1691095 */   // Label 23167: @1691095
     /* 1691095 */   GIM_Try, /*On fail goto*//*Label 23168*/ GIMT_Encode4(1691181), // Rule ID 6907 //
     /* 1691100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1691111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1691114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1691117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1691120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691146 */     // MIs[0] policy
     /* 1691146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691156 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1691159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691180 */     // GIR_Coverage, 6907,
     /* 1691180 */     GIR_EraseRootFromParent_Done,
     /* 1691181 */   // Label 23168: @1691181
     /* 1691181 */   GIM_Try, /*On fail goto*//*Label 23169*/ GIMT_Encode4(1691267), // Rule ID 6910 //
     /* 1691186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1691197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1691200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1691203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691232 */     // MIs[0] policy
     /* 1691232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691242 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1691245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691266 */     // GIR_Coverage, 6910,
     /* 1691266 */     GIR_EraseRootFromParent_Done,
     /* 1691267 */   // Label 23169: @1691267
     /* 1691267 */   GIM_Try, /*On fail goto*//*Label 23170*/ GIMT_Encode4(1691353), // Rule ID 6911 //
     /* 1691272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1691283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1691286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1691289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691318 */     // MIs[0] policy
     /* 1691318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691328 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1691331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691352 */     // GIR_Coverage, 6911,
     /* 1691352 */     GIR_EraseRootFromParent_Done,
     /* 1691353 */   // Label 23170: @1691353
     /* 1691353 */   GIM_Try, /*On fail goto*//*Label 23171*/ GIMT_Encode4(1691439), // Rule ID 6914 //
     /* 1691358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1691369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1691372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1691375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691404 */     // MIs[0] policy
     /* 1691404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691414 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1691417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691438 */     // GIR_Coverage, 6914,
     /* 1691438 */     GIR_EraseRootFromParent_Done,
     /* 1691439 */   // Label 23171: @1691439
     /* 1691439 */   GIM_Try, /*On fail goto*//*Label 23172*/ GIMT_Encode4(1691525), // Rule ID 6915 //
     /* 1691444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1691455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1691458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1691461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691490 */     // MIs[0] policy
     /* 1691490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691500 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1691503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691524 */     // GIR_Coverage, 6915,
     /* 1691524 */     GIR_EraseRootFromParent_Done,
     /* 1691525 */   // Label 23172: @1691525
     /* 1691525 */   GIM_Try, /*On fail goto*//*Label 23173*/ GIMT_Encode4(1691611), // Rule ID 6918 //
     /* 1691530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1691541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1691544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1691547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691576 */     // MIs[0] policy
     /* 1691576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691586 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1691589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691610 */     // GIR_Coverage, 6918,
     /* 1691610 */     GIR_EraseRootFromParent_Done,
     /* 1691611 */   // Label 23173: @1691611
     /* 1691611 */   GIM_Try, /*On fail goto*//*Label 23174*/ GIMT_Encode4(1691697), // Rule ID 6919 //
     /* 1691616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1691627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1691630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1691633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691662 */     // MIs[0] policy
     /* 1691662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691672 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1691675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691696 */     // GIR_Coverage, 6919,
     /* 1691696 */     GIR_EraseRootFromParent_Done,
     /* 1691697 */   // Label 23174: @1691697
     /* 1691697 */   GIM_Try, /*On fail goto*//*Label 23175*/ GIMT_Encode4(1691783), // Rule ID 6922 //
     /* 1691702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1691713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1691716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1691719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691748 */     // MIs[0] policy
     /* 1691748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691758 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1691761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691782 */     // GIR_Coverage, 6922,
     /* 1691782 */     GIR_EraseRootFromParent_Done,
     /* 1691783 */   // Label 23175: @1691783
     /* 1691783 */   GIM_Try, /*On fail goto*//*Label 23176*/ GIMT_Encode4(1691869), // Rule ID 6923 //
     /* 1691788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1691799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1691802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1691805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691834 */     // MIs[0] policy
     /* 1691834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691844 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1691847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691868 */     // GIR_Coverage, 6923,
     /* 1691868 */     GIR_EraseRootFromParent_Done,
     /* 1691869 */   // Label 23176: @1691869
     /* 1691869 */   GIM_Try, /*On fail goto*//*Label 23177*/ GIMT_Encode4(1691955), // Rule ID 6926 //
     /* 1691874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1691885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1691888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1691891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691920 */     // MIs[0] policy
     /* 1691920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691930 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1691933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691954 */     // GIR_Coverage, 6926,
     /* 1691954 */     GIR_EraseRootFromParent_Done,
     /* 1691955 */   // Label 23177: @1691955
     /* 1691955 */   GIM_Try, /*On fail goto*//*Label 23178*/ GIMT_Encode4(1692041), // Rule ID 6927 //
     /* 1691960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1691971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1691974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1691977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692006 */     // MIs[0] policy
     /* 1692006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692016 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1692019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692040 */     // GIR_Coverage, 6927,
     /* 1692040 */     GIR_EraseRootFromParent_Done,
     /* 1692041 */   // Label 23178: @1692041
     /* 1692041 */   GIM_Try, /*On fail goto*//*Label 23179*/ GIMT_Encode4(1692127), // Rule ID 6930 //
     /* 1692046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1692054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1692057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1692060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1692063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1692066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692092 */     // MIs[0] policy
     /* 1692092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692102 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1692105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692126 */     // GIR_Coverage, 6930,
     /* 1692126 */     GIR_EraseRootFromParent_Done,
     /* 1692127 */   // Label 23179: @1692127
     /* 1692127 */   GIM_Try, /*On fail goto*//*Label 23180*/ GIMT_Encode4(1692213), // Rule ID 6931 //
     /* 1692132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1692140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1692143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1692146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1692149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1692152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692178 */     // MIs[0] policy
     /* 1692178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692188 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1692191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692212 */     // GIR_Coverage, 6931,
     /* 1692212 */     GIR_EraseRootFromParent_Done,
     /* 1692213 */   // Label 23180: @1692213
     /* 1692213 */   GIM_Try, /*On fail goto*//*Label 23181*/ GIMT_Encode4(1692299), // Rule ID 6934 //
     /* 1692218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1692226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1692235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1692238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692264 */     // MIs[0] policy
     /* 1692264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692274 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1692277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692298 */     // GIR_Coverage, 6934,
     /* 1692298 */     GIR_EraseRootFromParent_Done,
     /* 1692299 */   // Label 23181: @1692299
     /* 1692299 */   GIM_Try, /*On fail goto*//*Label 23182*/ GIMT_Encode4(1692385), // Rule ID 6935 //
     /* 1692304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1692312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1692321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1692324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692350 */     // MIs[0] policy
     /* 1692350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1692363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692384 */     // GIR_Coverage, 6935,
     /* 1692384 */     GIR_EraseRootFromParent_Done,
     /* 1692385 */   // Label 23182: @1692385
     /* 1692385 */   GIM_Try, /*On fail goto*//*Label 23183*/ GIMT_Encode4(1692471), // Rule ID 6938 //
     /* 1692390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1692398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1692401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1692404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1692407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1692410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692436 */     // MIs[0] policy
     /* 1692436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1692449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692470 */     // GIR_Coverage, 6938,
     /* 1692470 */     GIR_EraseRootFromParent_Done,
     /* 1692471 */   // Label 23183: @1692471
     /* 1692471 */   GIM_Try, /*On fail goto*//*Label 23184*/ GIMT_Encode4(1692557), // Rule ID 6939 //
     /* 1692476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1692484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1692487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1692490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1692493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1692496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692522 */     // MIs[0] policy
     /* 1692522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1692535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692556 */     // GIR_Coverage, 6939,
     /* 1692556 */     GIR_EraseRootFromParent_Done,
     /* 1692557 */   // Label 23184: @1692557
     /* 1692557 */   GIM_Try, /*On fail goto*//*Label 23185*/ GIMT_Encode4(1692643), // Rule ID 6942 //
     /* 1692562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1692570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1692573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1692576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1692579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1692582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692608 */     // MIs[0] policy
     /* 1692608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1692621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692642 */     // GIR_Coverage, 6942,
     /* 1692642 */     GIR_EraseRootFromParent_Done,
     /* 1692643 */   // Label 23185: @1692643
     /* 1692643 */   GIM_Try, /*On fail goto*//*Label 23186*/ GIMT_Encode4(1692729), // Rule ID 6943 //
     /* 1692648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1692656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1692659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1692662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1692665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1692668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692694 */     // MIs[0] policy
     /* 1692694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692704 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1692707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692728 */     // GIR_Coverage, 6943,
     /* 1692728 */     GIR_EraseRootFromParent_Done,
     /* 1692729 */   // Label 23186: @1692729
     /* 1692729 */   GIM_Try, /*On fail goto*//*Label 23187*/ GIMT_Encode4(1692815), // Rule ID 6946 //
     /* 1692734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1692737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1692742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1692745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1692748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1692751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1692754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692780 */     // MIs[0] policy
     /* 1692780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1692793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692814 */     // GIR_Coverage, 6946,
     /* 1692814 */     GIR_EraseRootFromParent_Done,
     /* 1692815 */   // Label 23187: @1692815
     /* 1692815 */   GIM_Try, /*On fail goto*//*Label 23188*/ GIMT_Encode4(1692901), // Rule ID 6947 //
     /* 1692820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1692823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1692828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1692831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1692834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1692837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1692840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692866 */     // MIs[0] policy
     /* 1692866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1692879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692900 */     // GIR_Coverage, 6947,
     /* 1692900 */     GIR_EraseRootFromParent_Done,
     /* 1692901 */   // Label 23188: @1692901
     /* 1692901 */   GIM_Try, /*On fail goto*//*Label 23189*/ GIMT_Encode4(1692987), // Rule ID 6950 //
     /* 1692906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1692914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1692917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1692920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1692923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1692926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1692929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1692936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692952 */     // MIs[0] policy
     /* 1692952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692962 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1692965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692986 */     // GIR_Coverage, 6950,
     /* 1692986 */     GIR_EraseRootFromParent_Done,
     /* 1692987 */   // Label 23189: @1692987
     /* 1692987 */   GIM_Try, /*On fail goto*//*Label 23190*/ GIMT_Encode4(1693073), // Rule ID 6951 //
     /* 1692992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1693000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1693003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1693006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1693009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1693012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693038 */     // MIs[0] policy
     /* 1693038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693048 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1693051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693072 */     // GIR_Coverage, 6951,
     /* 1693072 */     GIR_EraseRootFromParent_Done,
     /* 1693073 */   // Label 23190: @1693073
     /* 1693073 */   GIM_Try, /*On fail goto*//*Label 23191*/ GIMT_Encode4(1693159), // Rule ID 6954 //
     /* 1693078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1693086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1693089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1693092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1693095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1693098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693124 */     // MIs[0] policy
     /* 1693124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693134 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1693137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693158 */     // GIR_Coverage, 6954,
     /* 1693158 */     GIR_EraseRootFromParent_Done,
     /* 1693159 */   // Label 23191: @1693159
     /* 1693159 */   GIM_Try, /*On fail goto*//*Label 23192*/ GIMT_Encode4(1693245), // Rule ID 6955 //
     /* 1693164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1693172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1693175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1693178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1693181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1693184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693210 */     // MIs[0] policy
     /* 1693210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693220 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1693223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693244 */     // GIR_Coverage, 6955,
     /* 1693244 */     GIR_EraseRootFromParent_Done,
     /* 1693245 */   // Label 23192: @1693245
     /* 1693245 */   GIM_Try, /*On fail goto*//*Label 23193*/ GIMT_Encode4(1693331), // Rule ID 6958 //
     /* 1693250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1693258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1693261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1693264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1693267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1693270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1693273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693296 */     // MIs[0] policy
     /* 1693296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693306 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1693309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693330 */     // GIR_Coverage, 6958,
     /* 1693330 */     GIR_EraseRootFromParent_Done,
     /* 1693331 */   // Label 23193: @1693331
     /* 1693331 */   GIM_Try, /*On fail goto*//*Label 23194*/ GIMT_Encode4(1693417), // Rule ID 6959 //
     /* 1693336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1693344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1693347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1693350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1693353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1693356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1693359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693382 */     // MIs[0] policy
     /* 1693382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693392 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1693395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693416 */     // GIR_Coverage, 6959,
     /* 1693416 */     GIR_EraseRootFromParent_Done,
     /* 1693417 */   // Label 23194: @1693417
     /* 1693417 */   GIM_Try, /*On fail goto*//*Label 23195*/ GIMT_Encode4(1693503), // Rule ID 6962 //
     /* 1693422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1693430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1693433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1693436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1693439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1693442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693468 */     // MIs[0] policy
     /* 1693468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693478 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1693481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693502 */     // GIR_Coverage, 6962,
     /* 1693502 */     GIR_EraseRootFromParent_Done,
     /* 1693503 */   // Label 23195: @1693503
     /* 1693503 */   GIM_Try, /*On fail goto*//*Label 23196*/ GIMT_Encode4(1693589), // Rule ID 6963 //
     /* 1693508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1693516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1693519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1693522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1693525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1693528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693554 */     // MIs[0] policy
     /* 1693554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693564 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1693567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693588 */     // GIR_Coverage, 6963,
     /* 1693588 */     GIR_EraseRootFromParent_Done,
     /* 1693589 */   // Label 23196: @1693589
     /* 1693589 */   GIM_Try, /*On fail goto*//*Label 23197*/ GIMT_Encode4(1693675), // Rule ID 6966 //
     /* 1693594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1693602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1693605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1693608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1693611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1693614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693640 */     // MIs[0] policy
     /* 1693640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693650 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1693653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693674 */     // GIR_Coverage, 6966,
     /* 1693674 */     GIR_EraseRootFromParent_Done,
     /* 1693675 */   // Label 23197: @1693675
     /* 1693675 */   GIM_Try, /*On fail goto*//*Label 23198*/ GIMT_Encode4(1693761), // Rule ID 6967 //
     /* 1693680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1693688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1693691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1693694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1693697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1693700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693726 */     // MIs[0] policy
     /* 1693726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693736 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1693739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693760 */     // GIR_Coverage, 6967,
     /* 1693760 */     GIR_EraseRootFromParent_Done,
     /* 1693761 */   // Label 23198: @1693761
     /* 1693761 */   GIM_Try, /*On fail goto*//*Label 23199*/ GIMT_Encode4(1693847), // Rule ID 6970 //
     /* 1693766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1693774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1693777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1693780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1693783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1693786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693812 */     // MIs[0] policy
     /* 1693812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693822 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1693825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693846 */     // GIR_Coverage, 6970,
     /* 1693846 */     GIR_EraseRootFromParent_Done,
     /* 1693847 */   // Label 23199: @1693847
     /* 1693847 */   GIM_Try, /*On fail goto*//*Label 23200*/ GIMT_Encode4(1693933), // Rule ID 6971 //
     /* 1693852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1693860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1693863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1693866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1693869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1693872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693898 */     // MIs[0] policy
     /* 1693898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693908 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1693911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693932 */     // GIR_Coverage, 6971,
     /* 1693932 */     GIR_EraseRootFromParent_Done,
     /* 1693933 */   // Label 23200: @1693933
     /* 1693933 */   GIM_Try, /*On fail goto*//*Label 23201*/ GIMT_Encode4(1694019), // Rule ID 6974 //
     /* 1693938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1693946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1693949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1693952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1693955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1693958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1693961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693984 */     // MIs[0] policy
     /* 1693984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693994 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1693997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694018 */     // GIR_Coverage, 6974,
     /* 1694018 */     GIR_EraseRootFromParent_Done,
     /* 1694019 */   // Label 23201: @1694019
     /* 1694019 */   GIM_Try, /*On fail goto*//*Label 23202*/ GIMT_Encode4(1694105), // Rule ID 6975 //
     /* 1694024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1694032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1694035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1694038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1694041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1694044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694070 */     // MIs[0] policy
     /* 1694070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694080 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1694083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694104 */     // GIR_Coverage, 6975,
     /* 1694104 */     GIR_EraseRootFromParent_Done,
     /* 1694105 */   // Label 23202: @1694105
     /* 1694105 */   GIM_Try, /*On fail goto*//*Label 23203*/ GIMT_Encode4(1694191), // Rule ID 6978 //
     /* 1694110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1694118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1694127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694156 */     // MIs[0] policy
     /* 1694156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694166 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1694169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694190 */     // GIR_Coverage, 6978,
     /* 1694190 */     GIR_EraseRootFromParent_Done,
     /* 1694191 */   // Label 23203: @1694191
     /* 1694191 */   GIM_Try, /*On fail goto*//*Label 23204*/ GIMT_Encode4(1694277), // Rule ID 6979 //
     /* 1694196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1694204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1694213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1694216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694242 */     // MIs[0] policy
     /* 1694242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694252 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1694255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694276 */     // GIR_Coverage, 6979,
     /* 1694276 */     GIR_EraseRootFromParent_Done,
     /* 1694277 */   // Label 23204: @1694277
     /* 1694277 */   GIM_Try, /*On fail goto*//*Label 23205*/ GIMT_Encode4(1694363), // Rule ID 6982 //
     /* 1694282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1694290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1694293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1694296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1694299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694328 */     // MIs[0] policy
     /* 1694328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694338 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1694341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694362 */     // GIR_Coverage, 6982,
     /* 1694362 */     GIR_EraseRootFromParent_Done,
     /* 1694363 */   // Label 23205: @1694363
     /* 1694363 */   GIM_Try, /*On fail goto*//*Label 23206*/ GIMT_Encode4(1694449), // Rule ID 6983 //
     /* 1694368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1694376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1694379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1694382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1694385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1694388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694414 */     // MIs[0] policy
     /* 1694414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694424 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1694427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694448 */     // GIR_Coverage, 6983,
     /* 1694448 */     GIR_EraseRootFromParent_Done,
     /* 1694449 */   // Label 23206: @1694449
     /* 1694449 */   GIM_Try, /*On fail goto*//*Label 23207*/ GIMT_Encode4(1694535), // Rule ID 6986 //
     /* 1694454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1694457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1694462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1694465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1694468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1694471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694500 */     // MIs[0] policy
     /* 1694500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694510 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1694513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694534 */     // GIR_Coverage, 6986,
     /* 1694534 */     GIR_EraseRootFromParent_Done,
     /* 1694535 */   // Label 23207: @1694535
     /* 1694535 */   GIM_Try, /*On fail goto*//*Label 23208*/ GIMT_Encode4(1694621), // Rule ID 6987 //
     /* 1694540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1694543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1694548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1694551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1694554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1694557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1694560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694586 */     // MIs[0] policy
     /* 1694586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1694599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694620 */     // GIR_Coverage, 6987,
     /* 1694620 */     GIR_EraseRootFromParent_Done,
     /* 1694621 */   // Label 23208: @1694621
     /* 1694621 */   GIM_Try, /*On fail goto*//*Label 23209*/ GIMT_Encode4(1694707), // Rule ID 6990 //
     /* 1694626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1694629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1694634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1694637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1694640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1694643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694672 */     // MIs[0] policy
     /* 1694672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694682 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1694685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694706 */     // GIR_Coverage, 6990,
     /* 1694706 */     GIR_EraseRootFromParent_Done,
     /* 1694707 */   // Label 23209: @1694707
     /* 1694707 */   GIM_Try, /*On fail goto*//*Label 23210*/ GIMT_Encode4(1694793), // Rule ID 6991 //
     /* 1694712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1694715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1694720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1694723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1694726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1694729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1694732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694758 */     // MIs[0] policy
     /* 1694758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694768 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1694771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694792 */     // GIR_Coverage, 6991,
     /* 1694792 */     GIR_EraseRootFromParent_Done,
     /* 1694793 */   // Label 23210: @1694793
     /* 1694793 */   GIM_Try, /*On fail goto*//*Label 23211*/ GIMT_Encode4(1694879), // Rule ID 6994 //
     /* 1694798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1694801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1694806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1694809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1694812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1694815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694844 */     // MIs[0] policy
     /* 1694844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694854 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1694857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694878 */     // GIR_Coverage, 6994,
     /* 1694878 */     GIR_EraseRootFromParent_Done,
     /* 1694879 */   // Label 23211: @1694879
     /* 1694879 */   GIM_Try, /*On fail goto*//*Label 23212*/ GIMT_Encode4(1694965), // Rule ID 6995 //
     /* 1694884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1694887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1694892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1694895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1694898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1694901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1694904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694930 */     // MIs[0] policy
     /* 1694930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694940 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1694943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694964 */     // GIR_Coverage, 6995,
     /* 1694964 */     GIR_EraseRootFromParent_Done,
     /* 1694965 */   // Label 23212: @1694965
     /* 1694965 */   GIM_Try, /*On fail goto*//*Label 23213*/ GIMT_Encode4(1695051), // Rule ID 7086 //
     /* 1694970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1694981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1694984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1694987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1694990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1694993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695016 */     // MIs[0] policy
     /* 1695016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695026 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1695029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695050 */     // GIR_Coverage, 7086,
     /* 1695050 */     GIR_EraseRootFromParent_Done,
     /* 1695051 */   // Label 23213: @1695051
     /* 1695051 */   GIM_Try, /*On fail goto*//*Label 23214*/ GIMT_Encode4(1695137), // Rule ID 7087 //
     /* 1695056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1695067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1695070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1695073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1695076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695102 */     // MIs[0] policy
     /* 1695102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695112 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1695115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695136 */     // GIR_Coverage, 7087,
     /* 1695136 */     GIR_EraseRootFromParent_Done,
     /* 1695137 */   // Label 23214: @1695137
     /* 1695137 */   GIM_Try, /*On fail goto*//*Label 23215*/ GIMT_Encode4(1695223), // Rule ID 7090 //
     /* 1695142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1695153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1695156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1695159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1695162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695188 */     // MIs[0] policy
     /* 1695188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695198 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1695201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695222 */     // GIR_Coverage, 7090,
     /* 1695222 */     GIR_EraseRootFromParent_Done,
     /* 1695223 */   // Label 23215: @1695223
     /* 1695223 */   GIM_Try, /*On fail goto*//*Label 23216*/ GIMT_Encode4(1695309), // Rule ID 7091 //
     /* 1695228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1695239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1695242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1695245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1695248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695274 */     // MIs[0] policy
     /* 1695274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695284 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1695287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695308 */     // GIR_Coverage, 7091,
     /* 1695308 */     GIR_EraseRootFromParent_Done,
     /* 1695309 */   // Label 23216: @1695309
     /* 1695309 */   GIM_Try, /*On fail goto*//*Label 23217*/ GIMT_Encode4(1695395), // Rule ID 7094 //
     /* 1695314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1695325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1695328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1695331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1695334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695360 */     // MIs[0] policy
     /* 1695360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695370 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1695373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695394 */     // GIR_Coverage, 7094,
     /* 1695394 */     GIR_EraseRootFromParent_Done,
     /* 1695395 */   // Label 23217: @1695395
     /* 1695395 */   GIM_Try, /*On fail goto*//*Label 23218*/ GIMT_Encode4(1695481), // Rule ID 7095 //
     /* 1695400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1695411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1695414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1695417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1695420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695446 */     // MIs[0] policy
     /* 1695446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695456 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1695459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695480 */     // GIR_Coverage, 7095,
     /* 1695480 */     GIR_EraseRootFromParent_Done,
     /* 1695481 */   // Label 23218: @1695481
     /* 1695481 */   GIM_Try, /*On fail goto*//*Label 23219*/ GIMT_Encode4(1695567), // Rule ID 7098 //
     /* 1695486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1695497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1695500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1695503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1695506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695532 */     // MIs[0] policy
     /* 1695532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695542 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1695545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695566 */     // GIR_Coverage, 7098,
     /* 1695566 */     GIR_EraseRootFromParent_Done,
     /* 1695567 */   // Label 23219: @1695567
     /* 1695567 */   GIM_Try, /*On fail goto*//*Label 23220*/ GIMT_Encode4(1695653), // Rule ID 7099 //
     /* 1695572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1695583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1695586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1695589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1695592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695618 */     // MIs[0] policy
     /* 1695618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695628 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1695631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695652 */     // GIR_Coverage, 7099,
     /* 1695652 */     GIR_EraseRootFromParent_Done,
     /* 1695653 */   // Label 23220: @1695653
     /* 1695653 */   GIM_Try, /*On fail goto*//*Label 23221*/ GIMT_Encode4(1695739), // Rule ID 7102 //
     /* 1695658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1695669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1695672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1695675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1695678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695704 */     // MIs[0] policy
     /* 1695704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695714 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1695717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695738 */     // GIR_Coverage, 7102,
     /* 1695738 */     GIR_EraseRootFromParent_Done,
     /* 1695739 */   // Label 23221: @1695739
     /* 1695739 */   GIM_Try, /*On fail goto*//*Label 23222*/ GIMT_Encode4(1695825), // Rule ID 7103 //
     /* 1695744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1695755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1695758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1695761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1695764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695790 */     // MIs[0] policy
     /* 1695790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695800 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1695803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695824 */     // GIR_Coverage, 7103,
     /* 1695824 */     GIR_EraseRootFromParent_Done,
     /* 1695825 */   // Label 23222: @1695825
     /* 1695825 */   GIM_Try, /*On fail goto*//*Label 23223*/ GIMT_Encode4(1695911), // Rule ID 7106 //
     /* 1695830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1695841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1695844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1695847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1695850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695876 */     // MIs[0] policy
     /* 1695876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695886 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1695889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1695907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695910 */     // GIR_Coverage, 7106,
     /* 1695910 */     GIR_EraseRootFromParent_Done,
     /* 1695911 */   // Label 23223: @1695911
     /* 1695911 */   GIM_Try, /*On fail goto*//*Label 23224*/ GIMT_Encode4(1695997), // Rule ID 7107 //
     /* 1695916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1695927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1695930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1695933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1695936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695962 */     // MIs[0] policy
     /* 1695962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695972 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1695975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1695993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695996 */     // GIR_Coverage, 7107,
     /* 1695996 */     GIR_EraseRootFromParent_Done,
     /* 1695997 */   // Label 23224: @1695997
     /* 1695997 */   GIM_Try, /*On fail goto*//*Label 23225*/ GIMT_Encode4(1696083), // Rule ID 7110 //
     /* 1696002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1696013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1696016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1696019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1696022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696048 */     // MIs[0] policy
     /* 1696048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696058 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1696061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696082 */     // GIR_Coverage, 7110,
     /* 1696082 */     GIR_EraseRootFromParent_Done,
     /* 1696083 */   // Label 23225: @1696083
     /* 1696083 */   GIM_Try, /*On fail goto*//*Label 23226*/ GIMT_Encode4(1696169), // Rule ID 7111 //
     /* 1696088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1696099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1696102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1696105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1696108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696134 */     // MIs[0] policy
     /* 1696134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696144 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1696147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696168 */     // GIR_Coverage, 7111,
     /* 1696168 */     GIR_EraseRootFromParent_Done,
     /* 1696169 */   // Label 23226: @1696169
     /* 1696169 */   GIM_Try, /*On fail goto*//*Label 23227*/ GIMT_Encode4(1696255), // Rule ID 7114 //
     /* 1696174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1696194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696220 */     // MIs[0] policy
     /* 1696220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696230 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1696233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696254 */     // GIR_Coverage, 7114,
     /* 1696254 */     GIR_EraseRootFromParent_Done,
     /* 1696255 */   // Label 23227: @1696255
     /* 1696255 */   GIM_Try, /*On fail goto*//*Label 23228*/ GIMT_Encode4(1696341), // Rule ID 7115 //
     /* 1696260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1696280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696306 */     // MIs[0] policy
     /* 1696306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1696319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696340 */     // GIR_Coverage, 7115,
     /* 1696340 */     GIR_EraseRootFromParent_Done,
     /* 1696341 */   // Label 23228: @1696341
     /* 1696341 */   GIM_Try, /*On fail goto*//*Label 23229*/ GIMT_Encode4(1696427), // Rule ID 7118 //
     /* 1696346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1696357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1696360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1696363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1696366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696392 */     // MIs[0] policy
     /* 1696392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696402 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1696405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696426 */     // GIR_Coverage, 7118,
     /* 1696426 */     GIR_EraseRootFromParent_Done,
     /* 1696427 */   // Label 23229: @1696427
     /* 1696427 */   GIM_Try, /*On fail goto*//*Label 23230*/ GIMT_Encode4(1696513), // Rule ID 7119 //
     /* 1696432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1696443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1696446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1696449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1696452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696478 */     // MIs[0] policy
     /* 1696478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696488 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1696491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696512 */     // GIR_Coverage, 7119,
     /* 1696512 */     GIR_EraseRootFromParent_Done,
     /* 1696513 */   // Label 23230: @1696513
     /* 1696513 */   GIM_Try, /*On fail goto*//*Label 23231*/ GIMT_Encode4(1696599), // Rule ID 7122 //
     /* 1696518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1696521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1696529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1696532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1696535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1696538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696564 */     // MIs[0] policy
     /* 1696564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1696577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1696595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696598 */     // GIR_Coverage, 7122,
     /* 1696598 */     GIR_EraseRootFromParent_Done,
     /* 1696599 */   // Label 23231: @1696599
     /* 1696599 */   GIM_Try, /*On fail goto*//*Label 23232*/ GIMT_Encode4(1696685), // Rule ID 7123 //
     /* 1696604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1696607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1696615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1696618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1696621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1696624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696650 */     // MIs[0] policy
     /* 1696650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696660 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1696663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1696681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696684 */     // GIR_Coverage, 7123,
     /* 1696684 */     GIR_EraseRootFromParent_Done,
     /* 1696685 */   // Label 23232: @1696685
     /* 1696685 */   GIM_Try, /*On fail goto*//*Label 23233*/ GIMT_Encode4(1696771), // Rule ID 7126 //
     /* 1696690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1696701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1696704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1696707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1696710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1696713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1696720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696736 */     // MIs[0] policy
     /* 1696736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696746 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1696749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696770 */     // GIR_Coverage, 7126,
     /* 1696770 */     GIR_EraseRootFromParent_Done,
     /* 1696771 */   // Label 23233: @1696771
     /* 1696771 */   GIM_Try, /*On fail goto*//*Label 23234*/ GIMT_Encode4(1696857), // Rule ID 7127 //
     /* 1696776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1696787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1696790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1696793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1696796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1696799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1696806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696822 */     // MIs[0] policy
     /* 1696822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696832 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1696835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696856 */     // GIR_Coverage, 7127,
     /* 1696856 */     GIR_EraseRootFromParent_Done,
     /* 1696857 */   // Label 23234: @1696857
     /* 1696857 */   GIM_Try, /*On fail goto*//*Label 23235*/ GIMT_Encode4(1696943), // Rule ID 7130 //
     /* 1696862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1696873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1696876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1696879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1696882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1696885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1696892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696908 */     // MIs[0] policy
     /* 1696908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696918 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1696921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696942 */     // GIR_Coverage, 7130,
     /* 1696942 */     GIR_EraseRootFromParent_Done,
     /* 1696943 */   // Label 23235: @1696943
     /* 1696943 */   GIM_Try, /*On fail goto*//*Label 23236*/ GIMT_Encode4(1697029), // Rule ID 7131 //
     /* 1696948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1696959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1696962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1696965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1696968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1696971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1696978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696994 */     // MIs[0] policy
     /* 1696994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697004 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1697007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697028 */     // GIR_Coverage, 7131,
     /* 1697028 */     GIR_EraseRootFromParent_Done,
     /* 1697029 */   // Label 23236: @1697029
     /* 1697029 */   GIM_Try, /*On fail goto*//*Label 23237*/ GIMT_Encode4(1697115), // Rule ID 7134 //
     /* 1697034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1697045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1697048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1697051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1697054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1697057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697080 */     // MIs[0] policy
     /* 1697080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697090 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1697093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697114 */     // GIR_Coverage, 7134,
     /* 1697114 */     GIR_EraseRootFromParent_Done,
     /* 1697115 */   // Label 23237: @1697115
     /* 1697115 */   GIM_Try, /*On fail goto*//*Label 23238*/ GIMT_Encode4(1697201), // Rule ID 7135 //
     /* 1697120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1697131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1697134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1697137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1697140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1697143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697166 */     // MIs[0] policy
     /* 1697166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697176 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1697179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697200 */     // GIR_Coverage, 7135,
     /* 1697200 */     GIR_EraseRootFromParent_Done,
     /* 1697201 */   // Label 23238: @1697201
     /* 1697201 */   GIM_Try, /*On fail goto*//*Label 23239*/ GIMT_Encode4(1697287), // Rule ID 7138 //
     /* 1697206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1697217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1697220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1697226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697252 */     // MIs[0] policy
     /* 1697252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697262 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1697265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697286 */     // GIR_Coverage, 7138,
     /* 1697286 */     GIR_EraseRootFromParent_Done,
     /* 1697287 */   // Label 23239: @1697287
     /* 1697287 */   GIM_Try, /*On fail goto*//*Label 23240*/ GIMT_Encode4(1697373), // Rule ID 7139 //
     /* 1697292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1697303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1697306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1697312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697338 */     // MIs[0] policy
     /* 1697338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1697351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697372 */     // GIR_Coverage, 7139,
     /* 1697372 */     GIR_EraseRootFromParent_Done,
     /* 1697373 */   // Label 23240: @1697373
     /* 1697373 */   GIM_Try, /*On fail goto*//*Label 23241*/ GIMT_Encode4(1697459), // Rule ID 7142 //
     /* 1697378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1697389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1697392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1697395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1697398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697424 */     // MIs[0] policy
     /* 1697424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697434 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1697437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697458 */     // GIR_Coverage, 7142,
     /* 1697458 */     GIR_EraseRootFromParent_Done,
     /* 1697459 */   // Label 23241: @1697459
     /* 1697459 */   GIM_Try, /*On fail goto*//*Label 23242*/ GIMT_Encode4(1697545), // Rule ID 7143 //
     /* 1697464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1697475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1697478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1697481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1697484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697510 */     // MIs[0] policy
     /* 1697510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697520 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1697523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697544 */     // GIR_Coverage, 7143,
     /* 1697544 */     GIR_EraseRootFromParent_Done,
     /* 1697545 */   // Label 23242: @1697545
     /* 1697545 */   GIM_Try, /*On fail goto*//*Label 23243*/ GIMT_Encode4(1697631), // Rule ID 7146 //
     /* 1697550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1697561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1697564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1697567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1697570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697596 */     // MIs[0] policy
     /* 1697596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697606 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1697609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697630 */     // GIR_Coverage, 7146,
     /* 1697630 */     GIR_EraseRootFromParent_Done,
     /* 1697631 */   // Label 23243: @1697631
     /* 1697631 */   GIM_Try, /*On fail goto*//*Label 23244*/ GIMT_Encode4(1697717), // Rule ID 7147 //
     /* 1697636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1697647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1697650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1697653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1697656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697682 */     // MIs[0] policy
     /* 1697682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697692 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1697695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697716 */     // GIR_Coverage, 7147,
     /* 1697716 */     GIR_EraseRootFromParent_Done,
     /* 1697717 */   // Label 23244: @1697717
     /* 1697717 */   GIM_Try, /*On fail goto*//*Label 23245*/ GIMT_Encode4(1697803), // Rule ID 7150 //
     /* 1697722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1697733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1697736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1697739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1697742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1697745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697768 */     // MIs[0] policy
     /* 1697768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1697781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697802 */     // GIR_Coverage, 7150,
     /* 1697802 */     GIR_EraseRootFromParent_Done,
     /* 1697803 */   // Label 23245: @1697803
     /* 1697803 */   GIM_Try, /*On fail goto*//*Label 23246*/ GIMT_Encode4(1697889), // Rule ID 7151 //
     /* 1697808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1697819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1697822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1697825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1697828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1697831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697854 */     // MIs[0] policy
     /* 1697854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1697867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697888 */     // GIR_Coverage, 7151,
     /* 1697888 */     GIR_EraseRootFromParent_Done,
     /* 1697889 */   // Label 23246: @1697889
     /* 1697889 */   GIM_Try, /*On fail goto*//*Label 23247*/ GIMT_Encode4(1697975), // Rule ID 7154 //
     /* 1697894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1697905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1697908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1697911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1697914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697940 */     // MIs[0] policy
     /* 1697940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697950 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1697953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697974 */     // GIR_Coverage, 7154,
     /* 1697974 */     GIR_EraseRootFromParent_Done,
     /* 1697975 */   // Label 23247: @1697975
     /* 1697975 */   GIM_Try, /*On fail goto*//*Label 23248*/ GIMT_Encode4(1698061), // Rule ID 7155 //
     /* 1697980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1697991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1697994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1697997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1698000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698026 */     // MIs[0] policy
     /* 1698026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1698039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698060 */     // GIR_Coverage, 7155,
     /* 1698060 */     GIR_EraseRootFromParent_Done,
     /* 1698061 */   // Label 23248: @1698061
     /* 1698061 */   GIM_Try, /*On fail goto*//*Label 23249*/ GIMT_Encode4(1698147), // Rule ID 7158 //
     /* 1698066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1698077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1698080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1698086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698112 */     // MIs[0] policy
     /* 1698112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698122 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1698125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698146 */     // GIR_Coverage, 7158,
     /* 1698146 */     GIR_EraseRootFromParent_Done,
     /* 1698147 */   // Label 23249: @1698147
     /* 1698147 */   GIM_Try, /*On fail goto*//*Label 23250*/ GIMT_Encode4(1698233), // Rule ID 7159 //
     /* 1698152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1698163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1698166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1698172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698198 */     // MIs[0] policy
     /* 1698198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698208 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1698211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698232 */     // GIR_Coverage, 7159,
     /* 1698232 */     GIR_EraseRootFromParent_Done,
     /* 1698233 */   // Label 23250: @1698233
     /* 1698233 */   GIM_Try, /*On fail goto*//*Label 23251*/ GIMT_Encode4(1698319), // Rule ID 7162 //
     /* 1698238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1698249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1698252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1698258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698284 */     // MIs[0] policy
     /* 1698284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1698297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698318 */     // GIR_Coverage, 7162,
     /* 1698318 */     GIR_EraseRootFromParent_Done,
     /* 1698319 */   // Label 23251: @1698319
     /* 1698319 */   GIM_Try, /*On fail goto*//*Label 23252*/ GIMT_Encode4(1698405), // Rule ID 7163 //
     /* 1698324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1698335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1698338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1698344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698370 */     // MIs[0] policy
     /* 1698370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698380 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1698383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698404 */     // GIR_Coverage, 7163,
     /* 1698404 */     GIR_EraseRootFromParent_Done,
     /* 1698405 */   // Label 23252: @1698405
     /* 1698405 */   GIM_Try, /*On fail goto*//*Label 23253*/ GIMT_Encode4(1698491), // Rule ID 7166 //
     /* 1698410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1698421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1698424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1698427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1698430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698456 */     // MIs[0] policy
     /* 1698456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698466 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1698469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698490 */     // GIR_Coverage, 7166,
     /* 1698490 */     GIR_EraseRootFromParent_Done,
     /* 1698491 */   // Label 23253: @1698491
     /* 1698491 */   GIM_Try, /*On fail goto*//*Label 23254*/ GIMT_Encode4(1698577), // Rule ID 7167 //
     /* 1698496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1698507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1698510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1698513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1698516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698542 */     // MIs[0] policy
     /* 1698542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698552 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1698555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698576 */     // GIR_Coverage, 7167,
     /* 1698576 */     GIR_EraseRootFromParent_Done,
     /* 1698577 */   // Label 23254: @1698577
     /* 1698577 */   GIM_Try, /*On fail goto*//*Label 23255*/ GIMT_Encode4(1698663), // Rule ID 7170 //
     /* 1698582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1698593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1698596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1698599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1698602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698628 */     // MIs[0] policy
     /* 1698628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698638 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1698641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698662 */     // GIR_Coverage, 7170,
     /* 1698662 */     GIR_EraseRootFromParent_Done,
     /* 1698663 */   // Label 23255: @1698663
     /* 1698663 */   GIM_Try, /*On fail goto*//*Label 23256*/ GIMT_Encode4(1698749), // Rule ID 7171 //
     /* 1698668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1698679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1698682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1698685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1698688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698714 */     // MIs[0] policy
     /* 1698714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698724 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1698727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698748 */     // GIR_Coverage, 7171,
     /* 1698748 */     GIR_EraseRootFromParent_Done,
     /* 1698749 */   // Label 23256: @1698749
     /* 1698749 */   GIM_Try, /*On fail goto*//*Label 23257*/ GIMT_Encode4(1698835), // Rule ID 7174 //
     /* 1698754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1698765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1698768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1698771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1698777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698800 */     // MIs[0] policy
     /* 1698800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698810 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1698813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1698831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698834 */     // GIR_Coverage, 7174,
     /* 1698834 */     GIR_EraseRootFromParent_Done,
     /* 1698835 */   // Label 23257: @1698835
     /* 1698835 */   GIM_Try, /*On fail goto*//*Label 23258*/ GIMT_Encode4(1698921), // Rule ID 7175 //
     /* 1698840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1698851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1698854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1698857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1698863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698886 */     // MIs[0] policy
     /* 1698886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1698899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1698917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698920 */     // GIR_Coverage, 7175,
     /* 1698920 */     GIR_EraseRootFromParent_Done,
     /* 1698921 */   // Label 23258: @1698921
     /* 1698921 */   GIM_Try, /*On fail goto*//*Label 23259*/ GIMT_Encode4(1699007), // Rule ID 7178 //
     /* 1698926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1698937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1698940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1698943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698972 */     // MIs[0] policy
     /* 1698972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698982 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1698985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699006 */     // GIR_Coverage, 7178,
     /* 1699006 */     GIR_EraseRootFromParent_Done,
     /* 1699007 */   // Label 23259: @1699007
     /* 1699007 */   GIM_Try, /*On fail goto*//*Label 23260*/ GIMT_Encode4(1699093), // Rule ID 7179 //
     /* 1699012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1699023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1699026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1699029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699058 */     // MIs[0] policy
     /* 1699058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699068 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1699071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699092 */     // GIR_Coverage, 7179,
     /* 1699092 */     GIR_EraseRootFromParent_Done,
     /* 1699093 */   // Label 23260: @1699093
     /* 1699093 */   GIM_Try, /*On fail goto*//*Label 23261*/ GIMT_Encode4(1699179), // Rule ID 7182 //
     /* 1699098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1699109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1699112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1699115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699144 */     // MIs[0] policy
     /* 1699144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699154 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1699157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699178 */     // GIR_Coverage, 7182,
     /* 1699178 */     GIR_EraseRootFromParent_Done,
     /* 1699179 */   // Label 23261: @1699179
     /* 1699179 */   GIM_Try, /*On fail goto*//*Label 23262*/ GIMT_Encode4(1699265), // Rule ID 7183 //
     /* 1699184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1699195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1699198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1699201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699230 */     // MIs[0] policy
     /* 1699230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699240 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1699243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699264 */     // GIR_Coverage, 7183,
     /* 1699264 */     GIR_EraseRootFromParent_Done,
     /* 1699265 */   // Label 23262: @1699265
     /* 1699265 */   GIM_Try, /*On fail goto*//*Label 23263*/ GIMT_Encode4(1699351), // Rule ID 7186 //
     /* 1699270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1699281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1699284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1699287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699316 */     // MIs[0] policy
     /* 1699316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699326 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1699329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1699347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699350 */     // GIR_Coverage, 7186,
     /* 1699350 */     GIR_EraseRootFromParent_Done,
     /* 1699351 */   // Label 23263: @1699351
     /* 1699351 */   GIM_Try, /*On fail goto*//*Label 23264*/ GIMT_Encode4(1699437), // Rule ID 7187 //
     /* 1699356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1699367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1699370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1699373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699402 */     // MIs[0] policy
     /* 1699402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699412 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1699415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1699433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699436 */     // GIR_Coverage, 7187,
     /* 1699436 */     GIR_EraseRootFromParent_Done,
     /* 1699437 */   // Label 23264: @1699437
     /* 1699437 */   GIM_Try, /*On fail goto*//*Label 23265*/ GIMT_Encode4(1699523), // Rule ID 7190 //
     /* 1699442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1699453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1699456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1699459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699488 */     // MIs[0] policy
     /* 1699488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699498 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1699501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1699519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699522 */     // GIR_Coverage, 7190,
     /* 1699522 */     GIR_EraseRootFromParent_Done,
     /* 1699523 */   // Label 23265: @1699523
     /* 1699523 */   GIM_Try, /*On fail goto*//*Label 23266*/ GIMT_Encode4(1699609), // Rule ID 7191 //
     /* 1699528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1699539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1699542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1699545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699574 */     // MIs[0] policy
     /* 1699574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699584 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1699587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1699605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699608 */     // GIR_Coverage, 7191,
     /* 1699608 */     GIR_EraseRootFromParent_Done,
     /* 1699609 */   // Label 23266: @1699609
     /* 1699609 */   GIM_Try, /*On fail goto*//*Label 23267*/ GIMT_Encode4(1699695), // Rule ID 7194 //
     /* 1699614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1699625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1699628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1699631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699660 */     // MIs[0] policy
     /* 1699660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699670 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1699673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1699691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699694 */     // GIR_Coverage, 7194,
     /* 1699694 */     GIR_EraseRootFromParent_Done,
     /* 1699695 */   // Label 23267: @1699695
     /* 1699695 */   GIM_Try, /*On fail goto*//*Label 23268*/ GIMT_Encode4(1699781), // Rule ID 7195 //
     /* 1699700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1699711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1699714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1699717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699746 */     // MIs[0] policy
     /* 1699746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699756 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1699759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1699777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699780 */     // GIR_Coverage, 7195,
     /* 1699780 */     GIR_EraseRootFromParent_Done,
     /* 1699781 */   // Label 23268: @1699781
     /* 1699781 */   GIM_Try, /*On fail goto*//*Label 23269*/ GIMT_Encode4(1699867), // Rule ID 7198 //
     /* 1699786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1699797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1699800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1699803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699832 */     // MIs[0] policy
     /* 1699832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699842 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1699845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699866 */     // GIR_Coverage, 7198,
     /* 1699866 */     GIR_EraseRootFromParent_Done,
     /* 1699867 */   // Label 23269: @1699867
     /* 1699867 */   GIM_Try, /*On fail goto*//*Label 23270*/ GIMT_Encode4(1699953), // Rule ID 7199 //
     /* 1699872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1699883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1699886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1699889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699918 */     // MIs[0] policy
     /* 1699918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699928 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1699931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699952 */     // GIR_Coverage, 7199,
     /* 1699952 */     GIR_EraseRootFromParent_Done,
     /* 1699953 */   // Label 23270: @1699953
     /* 1699953 */   GIM_Try, /*On fail goto*//*Label 23271*/ GIMT_Encode4(1700039), // Rule ID 7202 //
     /* 1699958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1699969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1699972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1699975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700004 */     // MIs[0] policy
     /* 1700004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700014 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1700017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700038 */     // GIR_Coverage, 7202,
     /* 1700038 */     GIR_EraseRootFromParent_Done,
     /* 1700039 */   // Label 23271: @1700039
     /* 1700039 */   GIM_Try, /*On fail goto*//*Label 23272*/ GIMT_Encode4(1700125), // Rule ID 7203 //
     /* 1700044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1700052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1700055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1700058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1700061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700090 */     // MIs[0] policy
     /* 1700090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1700103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700124 */     // GIR_Coverage, 7203,
     /* 1700124 */     GIR_EraseRootFromParent_Done,
     /* 1700125 */   // Label 23272: @1700125
     /* 1700125 */   GIM_Try, /*On fail goto*//*Label 23273*/ GIMT_Encode4(1700211), // Rule ID 7206 //
     /* 1700130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1700138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1700141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1700144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1700147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700176 */     // MIs[0] policy
     /* 1700176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700186 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1700189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1700207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700210 */     // GIR_Coverage, 7206,
     /* 1700210 */     GIR_EraseRootFromParent_Done,
     /* 1700211 */   // Label 23273: @1700211
     /* 1700211 */   GIM_Try, /*On fail goto*//*Label 23274*/ GIMT_Encode4(1700297), // Rule ID 7207 //
     /* 1700216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1700224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1700227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1700230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1700233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700262 */     // MIs[0] policy
     /* 1700262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700272 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1700275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1700293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700296 */     // GIR_Coverage, 7207,
     /* 1700296 */     GIR_EraseRootFromParent_Done,
     /* 1700297 */   // Label 23274: @1700297
     /* 1700297 */   GIM_Try, /*On fail goto*//*Label 23275*/ GIMT_Encode4(1700383), // Rule ID 7210 //
     /* 1700302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1700305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1700310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1700313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1700316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1700319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700348 */     // MIs[0] policy
     /* 1700348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700358 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1700361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1700379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700382 */     // GIR_Coverage, 7210,
     /* 1700382 */     GIR_EraseRootFromParent_Done,
     /* 1700383 */   // Label 23275: @1700383
     /* 1700383 */   GIM_Try, /*On fail goto*//*Label 23276*/ GIMT_Encode4(1700469), // Rule ID 7211 //
     /* 1700388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1700391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1700396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1700399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1700402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1700405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700434 */     // MIs[0] policy
     /* 1700434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700444 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1700447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1700465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700468 */     // GIR_Coverage, 7211,
     /* 1700468 */     GIR_EraseRootFromParent_Done,
     /* 1700469 */   // Label 23276: @1700469
     /* 1700469 */   GIM_Try, /*On fail goto*//*Label 23277*/ GIMT_Encode4(1700555), // Rule ID 7214 //
     /* 1700474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1700482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1700485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1700488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1700491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700520 */     // MIs[0] policy
     /* 1700520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700530 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1700533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700554 */     // GIR_Coverage, 7214,
     /* 1700554 */     GIR_EraseRootFromParent_Done,
     /* 1700555 */   // Label 23277: @1700555
     /* 1700555 */   GIM_Try, /*On fail goto*//*Label 23278*/ GIMT_Encode4(1700641), // Rule ID 7215 //
     /* 1700560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1700568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1700571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1700574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1700577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700606 */     // MIs[0] policy
     /* 1700606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700616 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1700619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700640 */     // GIR_Coverage, 7215,
     /* 1700640 */     GIR_EraseRootFromParent_Done,
     /* 1700641 */   // Label 23278: @1700641
     /* 1700641 */   GIM_Try, /*On fail goto*//*Label 23279*/ GIMT_Encode4(1700727), // Rule ID 7218 //
     /* 1700646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1700654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1700657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1700660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1700663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1700669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700692 */     // MIs[0] policy
     /* 1700692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700702 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1700705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700726 */     // GIR_Coverage, 7218,
     /* 1700726 */     GIR_EraseRootFromParent_Done,
     /* 1700727 */   // Label 23279: @1700727
     /* 1700727 */   GIM_Try, /*On fail goto*//*Label 23280*/ GIMT_Encode4(1700813), // Rule ID 7219 //
     /* 1700732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1700740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1700743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1700746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1700749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1700755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700778 */     // MIs[0] policy
     /* 1700778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700788 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1700791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700812 */     // GIR_Coverage, 7219,
     /* 1700812 */     GIR_EraseRootFromParent_Done,
     /* 1700813 */   // Label 23280: @1700813
     /* 1700813 */   GIM_Try, /*On fail goto*//*Label 23281*/ GIMT_Encode4(1700899), // Rule ID 7222 //
     /* 1700818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1700826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1700829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1700832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1700835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1700841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1700848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700864 */     // MIs[0] policy
     /* 1700864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700874 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1700877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700898 */     // GIR_Coverage, 7222,
     /* 1700898 */     GIR_EraseRootFromParent_Done,
     /* 1700899 */   // Label 23281: @1700899
     /* 1700899 */   GIM_Try, /*On fail goto*//*Label 23282*/ GIMT_Encode4(1700985), // Rule ID 7223 //
     /* 1700904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1700912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1700915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1700918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1700921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1700927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1700934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700950 */     // MIs[0] policy
     /* 1700950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700960 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1700963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700984 */     // GIR_Coverage, 7223,
     /* 1700984 */     GIR_EraseRootFromParent_Done,
     /* 1700985 */   // Label 23282: @1700985
     /* 1700985 */   GIM_Try, /*On fail goto*//*Label 23283*/ GIMT_Encode4(1701071), // Rule ID 7226 //
     /* 1700990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1700998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1701001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1701004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1701007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701036 */     // MIs[0] policy
     /* 1701036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701046 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1701049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701070 */     // GIR_Coverage, 7226,
     /* 1701070 */     GIR_EraseRootFromParent_Done,
     /* 1701071 */   // Label 23283: @1701071
     /* 1701071 */   GIM_Try, /*On fail goto*//*Label 23284*/ GIMT_Encode4(1701157), // Rule ID 7227 //
     /* 1701076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1701084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1701087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1701090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1701093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701122 */     // MIs[0] policy
     /* 1701122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701132 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1701135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701156 */     // GIR_Coverage, 7227,
     /* 1701156 */     GIR_EraseRootFromParent_Done,
     /* 1701157 */   // Label 23284: @1701157
     /* 1701157 */   GIM_Try, /*On fail goto*//*Label 23285*/ GIMT_Encode4(1701243), // Rule ID 7230 //
     /* 1701162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1701170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1701173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1701176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1701179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1701185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701208 */     // MIs[0] policy
     /* 1701208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1701221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701242 */     // GIR_Coverage, 7230,
     /* 1701242 */     GIR_EraseRootFromParent_Done,
     /* 1701243 */   // Label 23285: @1701243
     /* 1701243 */   GIM_Try, /*On fail goto*//*Label 23286*/ GIMT_Encode4(1701329), // Rule ID 7231 //
     /* 1701248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1701256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1701259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1701262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1701265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1701271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701294 */     // MIs[0] policy
     /* 1701294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701304 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1701307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701328 */     // GIR_Coverage, 7231,
     /* 1701328 */     GIR_EraseRootFromParent_Done,
     /* 1701329 */   // Label 23286: @1701329
     /* 1701329 */   GIM_Try, /*On fail goto*//*Label 23287*/ GIMT_Encode4(1701415), // Rule ID 7234 //
     /* 1701334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1701342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1701345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1701348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1701351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1701357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1701364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701380 */     // MIs[0] policy
     /* 1701380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701390 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1701393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701414 */     // GIR_Coverage, 7234,
     /* 1701414 */     GIR_EraseRootFromParent_Done,
     /* 1701415 */   // Label 23287: @1701415
     /* 1701415 */   GIM_Try, /*On fail goto*//*Label 23288*/ GIMT_Encode4(1701501), // Rule ID 7235 //
     /* 1701420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1701428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1701431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1701434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1701437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1701443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1701450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701466 */     // MIs[0] policy
     /* 1701466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701476 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1701479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701500 */     // GIR_Coverage, 7235,
     /* 1701500 */     GIR_EraseRootFromParent_Done,
     /* 1701501 */   // Label 23288: @1701501
     /* 1701501 */   GIM_Try, /*On fail goto*//*Label 23289*/ GIMT_Encode4(1701587), // Rule ID 7238 //
     /* 1701506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1701514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1701517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1701520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1701523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701552 */     // MIs[0] policy
     /* 1701552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1701565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701586 */     // GIR_Coverage, 7238,
     /* 1701586 */     GIR_EraseRootFromParent_Done,
     /* 1701587 */   // Label 23289: @1701587
     /* 1701587 */   GIM_Try, /*On fail goto*//*Label 23290*/ GIMT_Encode4(1701673), // Rule ID 7239 //
     /* 1701592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1701600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1701603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1701606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1701609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701638 */     // MIs[0] policy
     /* 1701638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1701651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701672 */     // GIR_Coverage, 7239,
     /* 1701672 */     GIR_EraseRootFromParent_Done,
     /* 1701673 */   // Label 23290: @1701673
     /* 1701673 */   GIM_Try, /*On fail goto*//*Label 23291*/ GIMT_Encode4(1701759), // Rule ID 7242 //
     /* 1701678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1701686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1701689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1701692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1701695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701724 */     // MIs[0] policy
     /* 1701724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701734 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1701737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701758 */     // GIR_Coverage, 7242,
     /* 1701758 */     GIR_EraseRootFromParent_Done,
     /* 1701759 */   // Label 23291: @1701759
     /* 1701759 */   GIM_Try, /*On fail goto*//*Label 23292*/ GIMT_Encode4(1701845), // Rule ID 7243 //
     /* 1701764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1701772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1701775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1701778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1701781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701810 */     // MIs[0] policy
     /* 1701810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701820 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1701823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701844 */     // GIR_Coverage, 7243,
     /* 1701844 */     GIR_EraseRootFromParent_Done,
     /* 1701845 */   // Label 23292: @1701845
     /* 1701845 */   GIM_Try, /*On fail goto*//*Label 23293*/ GIMT_Encode4(1701931), // Rule ID 7246 //
     /* 1701850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1701858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1701861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1701864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1701867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1701873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1701880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701896 */     // MIs[0] policy
     /* 1701896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701906 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1701909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701930 */     // GIR_Coverage, 7246,
     /* 1701930 */     GIR_EraseRootFromParent_Done,
     /* 1701931 */   // Label 23293: @1701931
     /* 1701931 */   GIM_Try, /*On fail goto*//*Label 23294*/ GIMT_Encode4(1702017), // Rule ID 7247 //
     /* 1701936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1701944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1701947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1701950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1701953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1701959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1701966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701982 */     // MIs[0] policy
     /* 1701982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701992 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1701995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1702013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702016 */     // GIR_Coverage, 7247,
     /* 1702016 */     GIR_EraseRootFromParent_Done,
     /* 1702017 */   // Label 23294: @1702017
     /* 1702017 */   GIM_Try, /*On fail goto*//*Label 23295*/ GIMT_Encode4(1702103), // Rule ID 7250 //
     /* 1702022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1702025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1702030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1702033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1702036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1702039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702068 */     // MIs[0] policy
     /* 1702068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702078 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1702081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1702099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702102 */     // GIR_Coverage, 7250,
     /* 1702102 */     GIR_EraseRootFromParent_Done,
     /* 1702103 */   // Label 23295: @1702103
     /* 1702103 */   GIM_Try, /*On fail goto*//*Label 23296*/ GIMT_Encode4(1702189), // Rule ID 7251 //
     /* 1702108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1702111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1702116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1702119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1702122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1702125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702154 */     // MIs[0] policy
     /* 1702154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1702167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1702185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702188 */     // GIR_Coverage, 7251,
     /* 1702188 */     GIR_EraseRootFromParent_Done,
     /* 1702189 */   // Label 23296: @1702189
     /* 1702189 */   GIM_Try, /*On fail goto*//*Label 23297*/ GIMT_Encode4(1702275), // Rule ID 7254 //
     /* 1702194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1702197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1702202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1702205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1702208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1702211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702240 */     // MIs[0] policy
     /* 1702240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702250 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1702253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1702271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702274 */     // GIR_Coverage, 7254,
     /* 1702274 */     GIR_EraseRootFromParent_Done,
     /* 1702275 */   // Label 23297: @1702275
     /* 1702275 */   GIM_Try, /*On fail goto*//*Label 23298*/ GIMT_Encode4(1702361), // Rule ID 7255 //
     /* 1702280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1702283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1702288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1702291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1702294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1702297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702326 */     // MIs[0] policy
     /* 1702326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702336 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1702339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1702357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702360 */     // GIR_Coverage, 7255,
     /* 1702360 */     GIR_EraseRootFromParent_Done,
     /* 1702361 */   // Label 23298: @1702361
     /* 1702361 */   GIM_Try, /*On fail goto*//*Label 23299*/ GIMT_Encode4(1702447), // Rule ID 7258 //
     /* 1702366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1702369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1702374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1702377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1702380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1702383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1702396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702412 */     // MIs[0] policy
     /* 1702412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702422 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1702425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1702443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702446 */     // GIR_Coverage, 7258,
     /* 1702446 */     GIR_EraseRootFromParent_Done,
     /* 1702447 */   // Label 23299: @1702447
     /* 1702447 */   GIM_Try, /*On fail goto*//*Label 23300*/ GIMT_Encode4(1702533), // Rule ID 7259 //
     /* 1702452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1702455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1702460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1702463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1702466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1702469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1702482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702498 */     // MIs[0] policy
     /* 1702498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702508 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1702511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1702529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702532 */     // GIR_Coverage, 7259,
     /* 1702532 */     GIR_EraseRootFromParent_Done,
     /* 1702533 */   // Label 23300: @1702533
     /* 1702533 */   GIM_Try, /*On fail goto*//*Label 23301*/ GIMT_Encode4(1702619), // Rule ID 7438 //
     /* 1702538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1702549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1702552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1702555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1702558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702584 */     // MIs[0] policy
     /* 1702584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702594 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1702597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702618 */     // GIR_Coverage, 7438,
     /* 1702618 */     GIR_EraseRootFromParent_Done,
     /* 1702619 */   // Label 23301: @1702619
     /* 1702619 */   GIM_Try, /*On fail goto*//*Label 23302*/ GIMT_Encode4(1702705), // Rule ID 7439 //
     /* 1702624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1702635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1702638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1702641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1702644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702670 */     // MIs[0] policy
     /* 1702670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702680 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1702683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702704 */     // GIR_Coverage, 7439,
     /* 1702704 */     GIR_EraseRootFromParent_Done,
     /* 1702705 */   // Label 23302: @1702705
     /* 1702705 */   GIM_Try, /*On fail goto*//*Label 23303*/ GIMT_Encode4(1702791), // Rule ID 7442 //
     /* 1702710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1702721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1702724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1702727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1702730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702756 */     // MIs[0] policy
     /* 1702756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702766 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1702769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702790 */     // GIR_Coverage, 7442,
     /* 1702790 */     GIR_EraseRootFromParent_Done,
     /* 1702791 */   // Label 23303: @1702791
     /* 1702791 */   GIM_Try, /*On fail goto*//*Label 23304*/ GIMT_Encode4(1702877), // Rule ID 7443 //
     /* 1702796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1702807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1702810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1702813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1702816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702842 */     // MIs[0] policy
     /* 1702842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702852 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1702855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702876 */     // GIR_Coverage, 7443,
     /* 1702876 */     GIR_EraseRootFromParent_Done,
     /* 1702877 */   // Label 23304: @1702877
     /* 1702877 */   GIM_Try, /*On fail goto*//*Label 23305*/ GIMT_Encode4(1702963), // Rule ID 7446 //
     /* 1702882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1702893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1702896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1702899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1702902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702928 */     // MIs[0] policy
     /* 1702928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702938 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1702941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702962 */     // GIR_Coverage, 7446,
     /* 1702962 */     GIR_EraseRootFromParent_Done,
     /* 1702963 */   // Label 23305: @1702963
     /* 1702963 */   GIM_Try, /*On fail goto*//*Label 23306*/ GIMT_Encode4(1703049), // Rule ID 7447 //
     /* 1702968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1702979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1702982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1702985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1702988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703014 */     // MIs[0] policy
     /* 1703014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703024 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1703027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1703045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703048 */     // GIR_Coverage, 7447,
     /* 1703048 */     GIR_EraseRootFromParent_Done,
     /* 1703049 */   // Label 23306: @1703049
     /* 1703049 */   GIM_Try, /*On fail goto*//*Label 23307*/ GIMT_Encode4(1703135), // Rule ID 7450 //
     /* 1703054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1703065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1703068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1703071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1703074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703100 */     // MIs[0] policy
     /* 1703100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703110 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1703113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1703131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703134 */     // GIR_Coverage, 7450,
     /* 1703134 */     GIR_EraseRootFromParent_Done,
     /* 1703135 */   // Label 23307: @1703135
     /* 1703135 */   GIM_Try, /*On fail goto*//*Label 23308*/ GIMT_Encode4(1703221), // Rule ID 7451 //
     /* 1703140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1703151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1703154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1703157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1703160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703186 */     // MIs[0] policy
     /* 1703186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1703199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1703217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703220 */     // GIR_Coverage, 7451,
     /* 1703220 */     GIR_EraseRootFromParent_Done,
     /* 1703221 */   // Label 23308: @1703221
     /* 1703221 */   GIM_Try, /*On fail goto*//*Label 23309*/ GIMT_Encode4(1703307), // Rule ID 7454 //
     /* 1703226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1703237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1703240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1703243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1703246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703272 */     // MIs[0] policy
     /* 1703272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703282 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1703285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1703303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703306 */     // GIR_Coverage, 7454,
     /* 1703306 */     GIR_EraseRootFromParent_Done,
     /* 1703307 */   // Label 23309: @1703307
     /* 1703307 */   GIM_Try, /*On fail goto*//*Label 23310*/ GIMT_Encode4(1703393), // Rule ID 7455 //
     /* 1703312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1703323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1703326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1703329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1703332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703358 */     // MIs[0] policy
     /* 1703358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703368 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1703371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1703389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703392 */     // GIR_Coverage, 7455,
     /* 1703392 */     GIR_EraseRootFromParent_Done,
     /* 1703393 */   // Label 23310: @1703393
     /* 1703393 */   GIM_Try, /*On fail goto*//*Label 23311*/ GIMT_Encode4(1703479), // Rule ID 7458 //
     /* 1703398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1703409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1703412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1703415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1703418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1703421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703444 */     // MIs[0] policy
     /* 1703444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703454 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1703457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1703475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703478 */     // GIR_Coverage, 7458,
     /* 1703478 */     GIR_EraseRootFromParent_Done,
     /* 1703479 */   // Label 23311: @1703479
     /* 1703479 */   GIM_Try, /*On fail goto*//*Label 23312*/ GIMT_Encode4(1703565), // Rule ID 7459 //
     /* 1703484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1703495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1703498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1703501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1703504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1703507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703530 */     // MIs[0] policy
     /* 1703530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703540 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1703543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1703561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703564 */     // GIR_Coverage, 7459,
     /* 1703564 */     GIR_EraseRootFromParent_Done,
     /* 1703565 */   // Label 23312: @1703565
     /* 1703565 */   GIM_Try, /*On fail goto*//*Label 23313*/ GIMT_Encode4(1703651), // Rule ID 7462 //
     /* 1703570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1703581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1703584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1703587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1703590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703616 */     // MIs[0] policy
     /* 1703616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703626 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1703629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703650 */     // GIR_Coverage, 7462,
     /* 1703650 */     GIR_EraseRootFromParent_Done,
     /* 1703651 */   // Label 23313: @1703651
     /* 1703651 */   GIM_Try, /*On fail goto*//*Label 23314*/ GIMT_Encode4(1703737), // Rule ID 7463 //
     /* 1703656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1703667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1703670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1703673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1703676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703702 */     // MIs[0] policy
     /* 1703702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703712 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1703715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703736 */     // GIR_Coverage, 7463,
     /* 1703736 */     GIR_EraseRootFromParent_Done,
     /* 1703737 */   // Label 23314: @1703737
     /* 1703737 */   GIM_Try, /*On fail goto*//*Label 23315*/ GIMT_Encode4(1703823), // Rule ID 7466 //
     /* 1703742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1703753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1703756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1703759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1703762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703788 */     // MIs[0] policy
     /* 1703788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703798 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1703801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703822 */     // GIR_Coverage, 7466,
     /* 1703822 */     GIR_EraseRootFromParent_Done,
     /* 1703823 */   // Label 23315: @1703823
     /* 1703823 */   GIM_Try, /*On fail goto*//*Label 23316*/ GIMT_Encode4(1703909), // Rule ID 7467 //
     /* 1703828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1703839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1703842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1703845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1703848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703874 */     // MIs[0] policy
     /* 1703874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703884 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1703887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703908 */     // GIR_Coverage, 7467,
     /* 1703908 */     GIR_EraseRootFromParent_Done,
     /* 1703909 */   // Label 23316: @1703909
     /* 1703909 */   GIM_Try, /*On fail goto*//*Label 23317*/ GIMT_Encode4(1703995), // Rule ID 7470 //
     /* 1703914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1703925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1703928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1703931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1703934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703960 */     // MIs[0] policy
     /* 1703960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703970 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1703973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703994 */     // GIR_Coverage, 7470,
     /* 1703994 */     GIR_EraseRootFromParent_Done,
     /* 1703995 */   // Label 23317: @1703995
     /* 1703995 */   GIM_Try, /*On fail goto*//*Label 23318*/ GIMT_Encode4(1704081), // Rule ID 7471 //
     /* 1704000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1704011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1704014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1704017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1704020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704046 */     // MIs[0] policy
     /* 1704046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704056 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1704059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1704077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704080 */     // GIR_Coverage, 7471,
     /* 1704080 */     GIR_EraseRootFromParent_Done,
     /* 1704081 */   // Label 23318: @1704081
     /* 1704081 */   GIM_Try, /*On fail goto*//*Label 23319*/ GIMT_Encode4(1704167), // Rule ID 7474 //
     /* 1704086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1704097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1704100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1704103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1704106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704132 */     // MIs[0] policy
     /* 1704132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704142 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1704145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1704163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704166 */     // GIR_Coverage, 7474,
     /* 1704166 */     GIR_EraseRootFromParent_Done,
     /* 1704167 */   // Label 23319: @1704167
     /* 1704167 */   GIM_Try, /*On fail goto*//*Label 23320*/ GIMT_Encode4(1704253), // Rule ID 7475 //
     /* 1704172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1704183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1704186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1704189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1704192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704218 */     // MIs[0] policy
     /* 1704218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1704231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1704249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704252 */     // GIR_Coverage, 7475,
     /* 1704252 */     GIR_EraseRootFromParent_Done,
     /* 1704253 */   // Label 23320: @1704253
     /* 1704253 */   GIM_Try, /*On fail goto*//*Label 23321*/ GIMT_Encode4(1704339), // Rule ID 7478 //
     /* 1704258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1704269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1704272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1704275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1704278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1704281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704304 */     // MIs[0] policy
     /* 1704304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704314 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1704317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1704335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704338 */     // GIR_Coverage, 7478,
     /* 1704338 */     GIR_EraseRootFromParent_Done,
     /* 1704339 */   // Label 23321: @1704339
     /* 1704339 */   GIM_Try, /*On fail goto*//*Label 23322*/ GIMT_Encode4(1704425), // Rule ID 7479 //
     /* 1704344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1704355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1704358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1704361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1704364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1704367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704390 */     // MIs[0] policy
     /* 1704390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1704403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1704421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704424 */     // GIR_Coverage, 7479,
     /* 1704424 */     GIR_EraseRootFromParent_Done,
     /* 1704425 */   // Label 23322: @1704425
     /* 1704425 */   GIM_Try, /*On fail goto*//*Label 23323*/ GIMT_Encode4(1704511), // Rule ID 7482 //
     /* 1704430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1704433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1704441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1704444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1704447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1704450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704476 */     // MIs[0] policy
     /* 1704476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1704489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704510 */     // GIR_Coverage, 7482,
     /* 1704510 */     GIR_EraseRootFromParent_Done,
     /* 1704511 */   // Label 23323: @1704511
     /* 1704511 */   GIM_Try, /*On fail goto*//*Label 23324*/ GIMT_Encode4(1704597), // Rule ID 7483 //
     /* 1704516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1704519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1704527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1704530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1704533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1704536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704562 */     // MIs[0] policy
     /* 1704562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1704575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704596 */     // GIR_Coverage, 7483,
     /* 1704596 */     GIR_EraseRootFromParent_Done,
     /* 1704597 */   // Label 23324: @1704597
     /* 1704597 */   GIM_Try, /*On fail goto*//*Label 23325*/ GIMT_Encode4(1704683), // Rule ID 7486 //
     /* 1704602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1704605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1704613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1704616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1704619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1704622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704648 */     // MIs[0] policy
     /* 1704648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1704661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704682 */     // GIR_Coverage, 7486,
     /* 1704682 */     GIR_EraseRootFromParent_Done,
     /* 1704683 */   // Label 23325: @1704683
     /* 1704683 */   GIM_Try, /*On fail goto*//*Label 23326*/ GIMT_Encode4(1704769), // Rule ID 7487 //
     /* 1704688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1704691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1704699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1704702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1704705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1704708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704734 */     // MIs[0] policy
     /* 1704734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1704747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704768 */     // GIR_Coverage, 7487,
     /* 1704768 */     GIR_EraseRootFromParent_Done,
     /* 1704769 */   // Label 23326: @1704769
     /* 1704769 */   GIM_Try, /*On fail goto*//*Label 23327*/ GIMT_Encode4(1704855), // Rule ID 7490 //
     /* 1704774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1704777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1704785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1704788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1704791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1704794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704820 */     // MIs[0] policy
     /* 1704820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1704833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704854 */     // GIR_Coverage, 7490,
     /* 1704854 */     GIR_EraseRootFromParent_Done,
     /* 1704855 */   // Label 23327: @1704855
     /* 1704855 */   GIM_Try, /*On fail goto*//*Label 23328*/ GIMT_Encode4(1704941), // Rule ID 7491 //
     /* 1704860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1704863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1704871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1704874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1704877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1704880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704906 */     // MIs[0] policy
     /* 1704906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1704919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704940 */     // GIR_Coverage, 7491,
     /* 1704940 */     GIR_EraseRootFromParent_Done,
     /* 1704941 */   // Label 23328: @1704941
     /* 1704941 */   GIM_Try, /*On fail goto*//*Label 23329*/ GIMT_Encode4(1705027), // Rule ID 7494 //
     /* 1704946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1704949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1704957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1704960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1704963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1704966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704992 */     // MIs[0] policy
     /* 1704992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1705005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1705023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705026 */     // GIR_Coverage, 7494,
     /* 1705026 */     GIR_EraseRootFromParent_Done,
     /* 1705027 */   // Label 23329: @1705027
     /* 1705027 */   GIM_Try, /*On fail goto*//*Label 23330*/ GIMT_Encode4(1705113), // Rule ID 7495 //
     /* 1705032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1705035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1705040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1705043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1705046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1705049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1705052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705078 */     // MIs[0] policy
     /* 1705078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705088 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1705091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1705109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705112 */     // GIR_Coverage, 7495,
     /* 1705112 */     GIR_EraseRootFromParent_Done,
     /* 1705113 */   // Label 23330: @1705113
     /* 1705113 */   GIM_Try, /*On fail goto*//*Label 23331*/ GIMT_Encode4(1705199), // Rule ID 7498 //
     /* 1705118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1705126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1705129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1705132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1705135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1705138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705164 */     // MIs[0] policy
     /* 1705164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705174 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1705177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705198 */     // GIR_Coverage, 7498,
     /* 1705198 */     GIR_EraseRootFromParent_Done,
     /* 1705199 */   // Label 23331: @1705199
     /* 1705199 */   GIM_Try, /*On fail goto*//*Label 23332*/ GIMT_Encode4(1705285), // Rule ID 7499 //
     /* 1705204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1705212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1705215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1705218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1705221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1705224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705250 */     // MIs[0] policy
     /* 1705250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705260 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1705263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705284 */     // GIR_Coverage, 7499,
     /* 1705284 */     GIR_EraseRootFromParent_Done,
     /* 1705285 */   // Label 23332: @1705285
     /* 1705285 */   GIM_Try, /*On fail goto*//*Label 23333*/ GIMT_Encode4(1705371), // Rule ID 7502 //
     /* 1705290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1705298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1705301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1705304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1705307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1705310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705336 */     // MIs[0] policy
     /* 1705336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1705349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705370 */     // GIR_Coverage, 7502,
     /* 1705370 */     GIR_EraseRootFromParent_Done,
     /* 1705371 */   // Label 23333: @1705371
     /* 1705371 */   GIM_Try, /*On fail goto*//*Label 23334*/ GIMT_Encode4(1705457), // Rule ID 7503 //
     /* 1705376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1705384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1705387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1705390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1705393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1705396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705422 */     // MIs[0] policy
     /* 1705422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705432 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1705435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705456 */     // GIR_Coverage, 7503,
     /* 1705456 */     GIR_EraseRootFromParent_Done,
     /* 1705457 */   // Label 23334: @1705457
     /* 1705457 */   GIM_Try, /*On fail goto*//*Label 23335*/ GIMT_Encode4(1705543), // Rule ID 7506 //
     /* 1705462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1705470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1705473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1705476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1705479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1705482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705508 */     // MIs[0] policy
     /* 1705508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705518 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1705521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705542 */     // GIR_Coverage, 7506,
     /* 1705542 */     GIR_EraseRootFromParent_Done,
     /* 1705543 */   // Label 23335: @1705543
     /* 1705543 */   GIM_Try, /*On fail goto*//*Label 23336*/ GIMT_Encode4(1705629), // Rule ID 7507 //
     /* 1705548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1705556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1705559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1705562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1705565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1705568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705594 */     // MIs[0] policy
     /* 1705594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705604 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1705607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705628 */     // GIR_Coverage, 7507,
     /* 1705628 */     GIR_EraseRootFromParent_Done,
     /* 1705629 */   // Label 23336: @1705629
     /* 1705629 */   GIM_Try, /*On fail goto*//*Label 23337*/ GIMT_Encode4(1705715), // Rule ID 7510 //
     /* 1705634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1705642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1705645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1705648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1705651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1705654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705680 */     // MIs[0] policy
     /* 1705680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705690 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1705693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705714 */     // GIR_Coverage, 7510,
     /* 1705714 */     GIR_EraseRootFromParent_Done,
     /* 1705715 */   // Label 23337: @1705715
     /* 1705715 */   GIM_Try, /*On fail goto*//*Label 23338*/ GIMT_Encode4(1705801), // Rule ID 7511 //
     /* 1705720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1705728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1705731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1705734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1705737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1705740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705766 */     // MIs[0] policy
     /* 1705766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705776 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1705779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705800 */     // GIR_Coverage, 7511,
     /* 1705800 */     GIR_EraseRootFromParent_Done,
     /* 1705801 */   // Label 23338: @1705801
     /* 1705801 */   GIM_Try, /*On fail goto*//*Label 23339*/ GIMT_Encode4(1705887), // Rule ID 7514 //
     /* 1705806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1705814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1705817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1705820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1705823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1705826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705852 */     // MIs[0] policy
     /* 1705852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705862 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1705865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705886 */     // GIR_Coverage, 7514,
     /* 1705886 */     GIR_EraseRootFromParent_Done,
     /* 1705887 */   // Label 23339: @1705887
     /* 1705887 */   GIM_Try, /*On fail goto*//*Label 23340*/ GIMT_Encode4(1705973), // Rule ID 7515 //
     /* 1705892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1705900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1705903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1705906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1705909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1705912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705938 */     // MIs[0] policy
     /* 1705938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1705951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705972 */     // GIR_Coverage, 7515,
     /* 1705972 */     GIR_EraseRootFromParent_Done,
     /* 1705973 */   // Label 23340: @1705973
     /* 1705973 */   GIM_Try, /*On fail goto*//*Label 23341*/ GIMT_Encode4(1706059), // Rule ID 7518 //
     /* 1705978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1705986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1705989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1705992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1705995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1705998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1706001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706024 */     // MIs[0] policy
     /* 1706024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706034 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1706037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706058 */     // GIR_Coverage, 7518,
     /* 1706058 */     GIR_EraseRootFromParent_Done,
     /* 1706059 */   // Label 23341: @1706059
     /* 1706059 */   GIM_Try, /*On fail goto*//*Label 23342*/ GIMT_Encode4(1706145), // Rule ID 7519 //
     /* 1706064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1706072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1706075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1706078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1706081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1706087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706110 */     // MIs[0] policy
     /* 1706110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706120 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1706123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706144 */     // GIR_Coverage, 7519,
     /* 1706144 */     GIR_EraseRootFromParent_Done,
     /* 1706145 */   // Label 23342: @1706145
     /* 1706145 */   GIM_Try, /*On fail goto*//*Label 23343*/ GIMT_Encode4(1706231), // Rule ID 7522 //
     /* 1706150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1706158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1706161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1706164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1706167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706196 */     // MIs[0] policy
     /* 1706196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706206 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1706209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706230 */     // GIR_Coverage, 7522,
     /* 1706230 */     GIR_EraseRootFromParent_Done,
     /* 1706231 */   // Label 23343: @1706231
     /* 1706231 */   GIM_Try, /*On fail goto*//*Label 23344*/ GIMT_Encode4(1706317), // Rule ID 7523 //
     /* 1706236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1706244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1706247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1706250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1706253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706282 */     // MIs[0] policy
     /* 1706282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706292 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1706295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706316 */     // GIR_Coverage, 7523,
     /* 1706316 */     GIR_EraseRootFromParent_Done,
     /* 1706317 */   // Label 23344: @1706317
     /* 1706317 */   GIM_Try, /*On fail goto*//*Label 23345*/ GIMT_Encode4(1706403), // Rule ID 7526 //
     /* 1706322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1706330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1706333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1706336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1706339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706368 */     // MIs[0] policy
     /* 1706368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706378 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1706381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706402 */     // GIR_Coverage, 7526,
     /* 1706402 */     GIR_EraseRootFromParent_Done,
     /* 1706403 */   // Label 23345: @1706403
     /* 1706403 */   GIM_Try, /*On fail goto*//*Label 23346*/ GIMT_Encode4(1706489), // Rule ID 7527 //
     /* 1706408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1706416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1706419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1706422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1706425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706454 */     // MIs[0] policy
     /* 1706454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706464 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1706467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706488 */     // GIR_Coverage, 7527,
     /* 1706488 */     GIR_EraseRootFromParent_Done,
     /* 1706489 */   // Label 23346: @1706489
     /* 1706489 */   GIM_Try, /*On fail goto*//*Label 23347*/ GIMT_Encode4(1706575), // Rule ID 7530 //
     /* 1706494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1706502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1706505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1706508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1706511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706540 */     // MIs[0] policy
     /* 1706540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706550 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1706553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706574 */     // GIR_Coverage, 7530,
     /* 1706574 */     GIR_EraseRootFromParent_Done,
     /* 1706575 */   // Label 23347: @1706575
     /* 1706575 */   GIM_Try, /*On fail goto*//*Label 23348*/ GIMT_Encode4(1706661), // Rule ID 7531 //
     /* 1706580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1706588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1706591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1706594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1706597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706626 */     // MIs[0] policy
     /* 1706626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706636 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1706639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706660 */     // GIR_Coverage, 7531,
     /* 1706660 */     GIR_EraseRootFromParent_Done,
     /* 1706661 */   // Label 23348: @1706661
     /* 1706661 */   GIM_Try, /*On fail goto*//*Label 23349*/ GIMT_Encode4(1706747), // Rule ID 7534 //
     /* 1706666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1706674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1706677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1706680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1706683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706712 */     // MIs[0] policy
     /* 1706712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706722 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1706725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706746 */     // GIR_Coverage, 7534,
     /* 1706746 */     GIR_EraseRootFromParent_Done,
     /* 1706747 */   // Label 23349: @1706747
     /* 1706747 */   GIM_Try, /*On fail goto*//*Label 23350*/ GIMT_Encode4(1706833), // Rule ID 7535 //
     /* 1706752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1706760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1706763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1706766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1706769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706798 */     // MIs[0] policy
     /* 1706798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706808 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1706811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706832 */     // GIR_Coverage, 7535,
     /* 1706832 */     GIR_EraseRootFromParent_Done,
     /* 1706833 */   // Label 23350: @1706833
     /* 1706833 */   GIM_Try, /*On fail goto*//*Label 23351*/ GIMT_Encode4(1706919), // Rule ID 7538 //
     /* 1706838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1706846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1706849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1706852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1706855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1706861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706884 */     // MIs[0] policy
     /* 1706884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706894 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1706897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706918 */     // GIR_Coverage, 7538,
     /* 1706918 */     GIR_EraseRootFromParent_Done,
     /* 1706919 */   // Label 23351: @1706919
     /* 1706919 */   GIM_Try, /*On fail goto*//*Label 23352*/ GIMT_Encode4(1707005), // Rule ID 7539 //
     /* 1706924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1706932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1706935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1706938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1706941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1706947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706970 */     // MIs[0] policy
     /* 1706970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706980 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1706983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707004 */     // GIR_Coverage, 7539,
     /* 1707004 */     GIR_EraseRootFromParent_Done,
     /* 1707005 */   // Label 23352: @1707005
     /* 1707005 */   GIM_Try, /*On fail goto*//*Label 23353*/ GIMT_Encode4(1707091), // Rule ID 7542 //
     /* 1707010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1707013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1707018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1707021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1707024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1707027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707056 */     // MIs[0] policy
     /* 1707056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1707069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707090 */     // GIR_Coverage, 7542,
     /* 1707090 */     GIR_EraseRootFromParent_Done,
     /* 1707091 */   // Label 23353: @1707091
     /* 1707091 */   GIM_Try, /*On fail goto*//*Label 23354*/ GIMT_Encode4(1707177), // Rule ID 7543 //
     /* 1707096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1707099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1707104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1707107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1707110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1707113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707142 */     // MIs[0] policy
     /* 1707142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707152 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1707155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707176 */     // GIR_Coverage, 7543,
     /* 1707176 */     GIR_EraseRootFromParent_Done,
     /* 1707177 */   // Label 23354: @1707177
     /* 1707177 */   GIM_Try, /*On fail goto*//*Label 23355*/ GIMT_Encode4(1707263), // Rule ID 7546 //
     /* 1707182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1707185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1707190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1707193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1707196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1707199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707228 */     // MIs[0] policy
     /* 1707228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707238 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1707241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707262 */     // GIR_Coverage, 7546,
     /* 1707262 */     GIR_EraseRootFromParent_Done,
     /* 1707263 */   // Label 23355: @1707263
     /* 1707263 */   GIM_Try, /*On fail goto*//*Label 23356*/ GIMT_Encode4(1707349), // Rule ID 7547 //
     /* 1707268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1707271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1707276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1707279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1707282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1707285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707314 */     // MIs[0] policy
     /* 1707314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1707327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707348 */     // GIR_Coverage, 7547,
     /* 1707348 */     GIR_EraseRootFromParent_Done,
     /* 1707349 */   // Label 23356: @1707349
     /* 1707349 */   GIM_Try, /*On fail goto*//*Label 23357*/ GIMT_Encode4(1707435), // Rule ID 7550 //
     /* 1707354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1707357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1707362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1707365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1707368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1707371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1707384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707400 */     // MIs[0] policy
     /* 1707400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1707413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707434 */     // GIR_Coverage, 7550,
     /* 1707434 */     GIR_EraseRootFromParent_Done,
     /* 1707435 */   // Label 23357: @1707435
     /* 1707435 */   GIM_Try, /*On fail goto*//*Label 23358*/ GIMT_Encode4(1707521), // Rule ID 7551 //
     /* 1707440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1707443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1707448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1707451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1707454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1707457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1707470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707486 */     // MIs[0] policy
     /* 1707486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1707499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707520 */     // GIR_Coverage, 7551,
     /* 1707520 */     GIR_EraseRootFromParent_Done,
     /* 1707521 */   // Label 23358: @1707521
     /* 1707521 */   GIM_Try, /*On fail goto*//*Label 23359*/ GIMT_Encode4(1707607), // Rule ID 7554 //
     /* 1707526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1707529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1707534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1707537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1707540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1707543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1707556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1707564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707572 */     // MIs[0] policy
     /* 1707572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707582 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1707585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707606 */     // GIR_Coverage, 7554,
     /* 1707606 */     GIR_EraseRootFromParent_Done,
     /* 1707607 */   // Label 23359: @1707607
     /* 1707607 */   GIM_Try, /*On fail goto*//*Label 23360*/ GIMT_Encode4(1707693), // Rule ID 7555 //
     /* 1707612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1707615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1707620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1707623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1707626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1707629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1707642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1707650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707658 */     // MIs[0] policy
     /* 1707658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1707671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707692 */     // GIR_Coverage, 7555,
     /* 1707692 */     GIR_EraseRootFromParent_Done,
     /* 1707693 */   // Label 23360: @1707693
     /* 1707693 */   GIM_Try, /*On fail goto*//*Label 23361*/ GIMT_Encode4(1707779), // Rule ID 7618 //
     /* 1707698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1707709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1707712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1707715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1707718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707744 */     // MIs[0] policy
     /* 1707744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707754 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1707757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707778 */     // GIR_Coverage, 7618,
     /* 1707778 */     GIR_EraseRootFromParent_Done,
     /* 1707779 */   // Label 23361: @1707779
     /* 1707779 */   GIM_Try, /*On fail goto*//*Label 23362*/ GIMT_Encode4(1707865), // Rule ID 7619 //
     /* 1707784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1707795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1707798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1707801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1707804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707830 */     // MIs[0] policy
     /* 1707830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707840 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1707843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707864 */     // GIR_Coverage, 7619,
     /* 1707864 */     GIR_EraseRootFromParent_Done,
     /* 1707865 */   // Label 23362: @1707865
     /* 1707865 */   GIM_Try, /*On fail goto*//*Label 23363*/ GIMT_Encode4(1707951), // Rule ID 7622 //
     /* 1707870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1707881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1707884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1707887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1707890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707916 */     // MIs[0] policy
     /* 1707916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707926 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1707929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707950 */     // GIR_Coverage, 7622,
     /* 1707950 */     GIR_EraseRootFromParent_Done,
     /* 1707951 */   // Label 23363: @1707951
     /* 1707951 */   GIM_Try, /*On fail goto*//*Label 23364*/ GIMT_Encode4(1708037), // Rule ID 7623 //
     /* 1707956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1707967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1707970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1707973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1707976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708002 */     // MIs[0] policy
     /* 1708002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708012 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1708015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708036 */     // GIR_Coverage, 7623,
     /* 1708036 */     GIR_EraseRootFromParent_Done,
     /* 1708037 */   // Label 23364: @1708037
     /* 1708037 */   GIM_Try, /*On fail goto*//*Label 23365*/ GIMT_Encode4(1708123), // Rule ID 7626 //
     /* 1708042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1708053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1708056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1708059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1708062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708088 */     // MIs[0] policy
     /* 1708088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708098 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1708101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708122 */     // GIR_Coverage, 7626,
     /* 1708122 */     GIR_EraseRootFromParent_Done,
     /* 1708123 */   // Label 23365: @1708123
     /* 1708123 */   GIM_Try, /*On fail goto*//*Label 23366*/ GIMT_Encode4(1708209), // Rule ID 7627 //
     /* 1708128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1708139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1708142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1708145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1708148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708174 */     // MIs[0] policy
     /* 1708174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708184 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1708187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708208 */     // GIR_Coverage, 7627,
     /* 1708208 */     GIR_EraseRootFromParent_Done,
     /* 1708209 */   // Label 23366: @1708209
     /* 1708209 */   GIM_Try, /*On fail goto*//*Label 23367*/ GIMT_Encode4(1708295), // Rule ID 7630 //
     /* 1708214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1708225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1708228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1708231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1708234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708260 */     // MIs[0] policy
     /* 1708260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708270 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1708273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708294 */     // GIR_Coverage, 7630,
     /* 1708294 */     GIR_EraseRootFromParent_Done,
     /* 1708295 */   // Label 23367: @1708295
     /* 1708295 */   GIM_Try, /*On fail goto*//*Label 23368*/ GIMT_Encode4(1708381), // Rule ID 7631 //
     /* 1708300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1708311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1708314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1708317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1708320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708346 */     // MIs[0] policy
     /* 1708346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708356 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1708359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708380 */     // GIR_Coverage, 7631,
     /* 1708380 */     GIR_EraseRootFromParent_Done,
     /* 1708381 */   // Label 23368: @1708381
     /* 1708381 */   GIM_Try, /*On fail goto*//*Label 23369*/ GIMT_Encode4(1708467), // Rule ID 7634 //
     /* 1708386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1708397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1708400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1708403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1708406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708432 */     // MIs[0] policy
     /* 1708432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708442 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1708445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708466 */     // GIR_Coverage, 7634,
     /* 1708466 */     GIR_EraseRootFromParent_Done,
     /* 1708467 */   // Label 23369: @1708467
     /* 1708467 */   GIM_Try, /*On fail goto*//*Label 23370*/ GIMT_Encode4(1708553), // Rule ID 7635 //
     /* 1708472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1708483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1708486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1708489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1708492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708518 */     // MIs[0] policy
     /* 1708518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708528 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1708531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708552 */     // GIR_Coverage, 7635,
     /* 1708552 */     GIR_EraseRootFromParent_Done,
     /* 1708553 */   // Label 23370: @1708553
     /* 1708553 */   GIM_Try, /*On fail goto*//*Label 23371*/ GIMT_Encode4(1708639), // Rule ID 7638 //
     /* 1708558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1708569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1708572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1708575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1708578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1708581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708604 */     // MIs[0] policy
     /* 1708604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708614 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1708617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708638 */     // GIR_Coverage, 7638,
     /* 1708638 */     GIR_EraseRootFromParent_Done,
     /* 1708639 */   // Label 23371: @1708639
     /* 1708639 */   GIM_Try, /*On fail goto*//*Label 23372*/ GIMT_Encode4(1708725), // Rule ID 7639 //
     /* 1708644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1708655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1708658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1708661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1708664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1708667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708690 */     // MIs[0] policy
     /* 1708690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708700 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1708703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708724 */     // GIR_Coverage, 7639,
     /* 1708724 */     GIR_EraseRootFromParent_Done,
     /* 1708725 */   // Label 23372: @1708725
     /* 1708725 */   GIM_Try, /*On fail goto*//*Label 23373*/ GIMT_Encode4(1708811), // Rule ID 7642 //
     /* 1708730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1708741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1708744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1708747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1708750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708776 */     // MIs[0] policy
     /* 1708776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1708789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708810 */     // GIR_Coverage, 7642,
     /* 1708810 */     GIR_EraseRootFromParent_Done,
     /* 1708811 */   // Label 23373: @1708811
     /* 1708811 */   GIM_Try, /*On fail goto*//*Label 23374*/ GIMT_Encode4(1708897), // Rule ID 7643 //
     /* 1708816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1708827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1708830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1708833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1708836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708862 */     // MIs[0] policy
     /* 1708862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708872 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1708875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708896 */     // GIR_Coverage, 7643,
     /* 1708896 */     GIR_EraseRootFromParent_Done,
     /* 1708897 */   // Label 23374: @1708897
     /* 1708897 */   GIM_Try, /*On fail goto*//*Label 23375*/ GIMT_Encode4(1708983), // Rule ID 7646 //
     /* 1708902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1708913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1708916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1708919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1708922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708948 */     // MIs[0] policy
     /* 1708948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1708961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708982 */     // GIR_Coverage, 7646,
     /* 1708982 */     GIR_EraseRootFromParent_Done,
     /* 1708983 */   // Label 23375: @1708983
     /* 1708983 */   GIM_Try, /*On fail goto*//*Label 23376*/ GIMT_Encode4(1709069), // Rule ID 7647 //
     /* 1708988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1708999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1709002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1709005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1709008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709034 */     // MIs[0] policy
     /* 1709034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709044 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1709047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709068 */     // GIR_Coverage, 7647,
     /* 1709068 */     GIR_EraseRootFromParent_Done,
     /* 1709069 */   // Label 23376: @1709069
     /* 1709069 */   GIM_Try, /*On fail goto*//*Label 23377*/ GIMT_Encode4(1709155), // Rule ID 7650 //
     /* 1709074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1709085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1709088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1709091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1709094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709120 */     // MIs[0] policy
     /* 1709120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709130 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1709133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709154 */     // GIR_Coverage, 7650,
     /* 1709154 */     GIR_EraseRootFromParent_Done,
     /* 1709155 */   // Label 23377: @1709155
     /* 1709155 */   GIM_Try, /*On fail goto*//*Label 23378*/ GIMT_Encode4(1709241), // Rule ID 7651 //
     /* 1709160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1709171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1709174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1709177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1709180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709206 */     // MIs[0] policy
     /* 1709206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709216 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1709219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709240 */     // GIR_Coverage, 7651,
     /* 1709240 */     GIR_EraseRootFromParent_Done,
     /* 1709241 */   // Label 23378: @1709241
     /* 1709241 */   GIM_Try, /*On fail goto*//*Label 23379*/ GIMT_Encode4(1709327), // Rule ID 7654 //
     /* 1709246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1709257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1709260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1709263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1709266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709292 */     // MIs[0] policy
     /* 1709292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1709305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709326 */     // GIR_Coverage, 7654,
     /* 1709326 */     GIR_EraseRootFromParent_Done,
     /* 1709327 */   // Label 23379: @1709327
     /* 1709327 */   GIM_Try, /*On fail goto*//*Label 23380*/ GIMT_Encode4(1709413), // Rule ID 7655 //
     /* 1709332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1709343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1709346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1709349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1709352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709378 */     // MIs[0] policy
     /* 1709378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709388 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1709391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709412 */     // GIR_Coverage, 7655,
     /* 1709412 */     GIR_EraseRootFromParent_Done,
     /* 1709413 */   // Label 23380: @1709413
     /* 1709413 */   GIM_Try, /*On fail goto*//*Label 23381*/ GIMT_Encode4(1709499), // Rule ID 7658 //
     /* 1709418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1709429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1709432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1709435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1709438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1709441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709464 */     // MIs[0] policy
     /* 1709464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1709477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709498 */     // GIR_Coverage, 7658,
     /* 1709498 */     GIR_EraseRootFromParent_Done,
     /* 1709499 */   // Label 23381: @1709499
     /* 1709499 */   GIM_Try, /*On fail goto*//*Label 23382*/ GIMT_Encode4(1709585), // Rule ID 7659 //
     /* 1709504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1709515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1709518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1709521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1709524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1709527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709550 */     // MIs[0] policy
     /* 1709550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709560 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1709563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709584 */     // GIR_Coverage, 7659,
     /* 1709584 */     GIR_EraseRootFromParent_Done,
     /* 1709585 */   // Label 23382: @1709585
     /* 1709585 */   GIM_Try, /*On fail goto*//*Label 23383*/ GIMT_Encode4(1709671), // Rule ID 7662 //
     /* 1709590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1709593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1709601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1709604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1709607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1709610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709636 */     // MIs[0] policy
     /* 1709636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1709649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709670 */     // GIR_Coverage, 7662,
     /* 1709670 */     GIR_EraseRootFromParent_Done,
     /* 1709671 */   // Label 23383: @1709671
     /* 1709671 */   GIM_Try, /*On fail goto*//*Label 23384*/ GIMT_Encode4(1709757), // Rule ID 7663 //
     /* 1709676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1709679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1709687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1709690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1709693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1709696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709722 */     // MIs[0] policy
     /* 1709722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1709735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709756 */     // GIR_Coverage, 7663,
     /* 1709756 */     GIR_EraseRootFromParent_Done,
     /* 1709757 */   // Label 23384: @1709757
     /* 1709757 */   GIM_Try, /*On fail goto*//*Label 23385*/ GIMT_Encode4(1709843), // Rule ID 7666 //
     /* 1709762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1709765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1709773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1709776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1709779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1709782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709808 */     // MIs[0] policy
     /* 1709808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1709821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709842 */     // GIR_Coverage, 7666,
     /* 1709842 */     GIR_EraseRootFromParent_Done,
     /* 1709843 */   // Label 23385: @1709843
     /* 1709843 */   GIM_Try, /*On fail goto*//*Label 23386*/ GIMT_Encode4(1709929), // Rule ID 7667 //
     /* 1709848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1709851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1709859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1709862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1709865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1709868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709894 */     // MIs[0] policy
     /* 1709894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1709907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709928 */     // GIR_Coverage, 7667,
     /* 1709928 */     GIR_EraseRootFromParent_Done,
     /* 1709929 */   // Label 23386: @1709929
     /* 1709929 */   GIM_Try, /*On fail goto*//*Label 23387*/ GIMT_Encode4(1710015), // Rule ID 7670 //
     /* 1709934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1709937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1709945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1709948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1709951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1709954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709980 */     // MIs[0] policy
     /* 1709980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1709993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710014 */     // GIR_Coverage, 7670,
     /* 1710014 */     GIR_EraseRootFromParent_Done,
     /* 1710015 */   // Label 23387: @1710015
     /* 1710015 */   GIM_Try, /*On fail goto*//*Label 23388*/ GIMT_Encode4(1710101), // Rule ID 7671 //
     /* 1710020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1710023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1710028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1710031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1710034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1710037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1710040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1710050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710066 */     // MIs[0] policy
     /* 1710066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1710079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710100 */     // GIR_Coverage, 7671,
     /* 1710100 */     GIR_EraseRootFromParent_Done,
     /* 1710101 */   // Label 23388: @1710101
     /* 1710101 */   GIM_Try, /*On fail goto*//*Label 23389*/ GIMT_Encode4(1710187), // Rule ID 7674 //
     /* 1710106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1710109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1710114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1710117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1710120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1710123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1710126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1710136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1710144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710152 */     // MIs[0] policy
     /* 1710152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710162 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1710165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710186 */     // GIR_Coverage, 7674,
     /* 1710186 */     GIR_EraseRootFromParent_Done,
     /* 1710187 */   // Label 23389: @1710187
     /* 1710187 */   GIM_Try, /*On fail goto*//*Label 23390*/ GIMT_Encode4(1710273), // Rule ID 7675 //
     /* 1710192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1710195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1710200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1710203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1710206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1710209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1710212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1710222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1710230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710238 */     // MIs[0] policy
     /* 1710238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1710251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710272 */     // GIR_Coverage, 7675,
     /* 1710272 */     GIR_EraseRootFromParent_Done,
     /* 1710273 */   // Label 23390: @1710273
     /* 1710273 */   GIM_Try, /*On fail goto*//*Label 23391*/ GIMT_Encode4(1710359), // Rule ID 7678 //
     /* 1710278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1710286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1710289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1710292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1710295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1710298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1710320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710324 */     // MIs[0] policy
     /* 1710324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1710337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710358 */     // GIR_Coverage, 7678,
     /* 1710358 */     GIR_EraseRootFromParent_Done,
     /* 1710359 */   // Label 23391: @1710359
     /* 1710359 */   GIM_Try, /*On fail goto*//*Label 23392*/ GIMT_Encode4(1710445), // Rule ID 7679 //
     /* 1710364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1710372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1710375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1710378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1710381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1710384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1710406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710410 */     // MIs[0] policy
     /* 1710410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710420 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1710423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710444 */     // GIR_Coverage, 7679,
     /* 1710444 */     GIR_EraseRootFromParent_Done,
     /* 1710445 */   // Label 23392: @1710445
     /* 1710445 */   GIM_Try, /*On fail goto*//*Label 23393*/ GIMT_Encode4(1710531), // Rule ID 7682 //
     /* 1710450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1710458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1710461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1710464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1710467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1710470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1710492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710496 */     // MIs[0] policy
     /* 1710496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710506 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1710509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710530 */     // GIR_Coverage, 7682,
     /* 1710530 */     GIR_EraseRootFromParent_Done,
     /* 1710531 */   // Label 23393: @1710531
     /* 1710531 */   GIM_Try, /*On fail goto*//*Label 23394*/ GIMT_Encode4(1710617), // Rule ID 7683 //
     /* 1710536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1710544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1710547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1710550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1710553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1710556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1710578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710582 */     // MIs[0] policy
     /* 1710582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710592 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1710595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710616 */     // GIR_Coverage, 7683,
     /* 1710616 */     GIR_EraseRootFromParent_Done,
     /* 1710617 */   // Label 23394: @1710617
     /* 1710617 */   GIM_Try, /*On fail goto*//*Label 23395*/ GIMT_Encode4(1710703), // Rule ID 7686 //
     /* 1710622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1710630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1710633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1710636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1710639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1710642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1710664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710668 */     // MIs[0] policy
     /* 1710668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710678 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1710681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710702 */     // GIR_Coverage, 7686,
     /* 1710702 */     GIR_EraseRootFromParent_Done,
     /* 1710703 */   // Label 23395: @1710703
     /* 1710703 */   GIM_Try, /*On fail goto*//*Label 23396*/ GIMT_Encode4(1710789), // Rule ID 7687 //
     /* 1710708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1710716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1710719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1710722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1710725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1710728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1710750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710754 */     // MIs[0] policy
     /* 1710754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710764 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1710767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710788 */     // GIR_Coverage, 7687,
     /* 1710788 */     GIR_EraseRootFromParent_Done,
     /* 1710789 */   // Label 23396: @1710789
     /* 1710789 */   GIM_Try, /*On fail goto*//*Label 23397*/ GIMT_Encode4(1710875), // Rule ID 7690 //
     /* 1710794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1710802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1710805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1710808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1710811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1710814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1710836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710840 */     // MIs[0] policy
     /* 1710840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1710853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710874 */     // GIR_Coverage, 7690,
     /* 1710874 */     GIR_EraseRootFromParent_Done,
     /* 1710875 */   // Label 23397: @1710875
     /* 1710875 */   GIM_Try, /*On fail goto*//*Label 23398*/ GIMT_Encode4(1710961), // Rule ID 7691 //
     /* 1710880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1710888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1710891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1710894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1710897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1710900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1710922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710926 */     // MIs[0] policy
     /* 1710926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710936 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1710939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710960 */     // GIR_Coverage, 7691,
     /* 1710960 */     GIR_EraseRootFromParent_Done,
     /* 1710961 */   // Label 23398: @1710961
     /* 1710961 */   GIM_Try, /*On fail goto*//*Label 23399*/ GIMT_Encode4(1711047), // Rule ID 7694 //
     /* 1710966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1710974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1710977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1710980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1710983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1710986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1710989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1710996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711012 */     // MIs[0] policy
     /* 1711012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711022 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1711025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711046 */     // GIR_Coverage, 7694,
     /* 1711046 */     GIR_EraseRootFromParent_Done,
     /* 1711047 */   // Label 23399: @1711047
     /* 1711047 */   GIM_Try, /*On fail goto*//*Label 23400*/ GIMT_Encode4(1711133), // Rule ID 7695 //
     /* 1711052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1711060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1711063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1711066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1711069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1711072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711098 */     // MIs[0] policy
     /* 1711098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711108 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1711111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711132 */     // GIR_Coverage, 7695,
     /* 1711132 */     GIR_EraseRootFromParent_Done,
     /* 1711133 */   // Label 23400: @1711133
     /* 1711133 */   GIM_Try, /*On fail goto*//*Label 23401*/ GIMT_Encode4(1711219), // Rule ID 7698 //
     /* 1711138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1711146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1711149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1711152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1711155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1711158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711184 */     // MIs[0] policy
     /* 1711184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711194 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1711197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711218 */     // GIR_Coverage, 7698,
     /* 1711218 */     GIR_EraseRootFromParent_Done,
     /* 1711219 */   // Label 23401: @1711219
     /* 1711219 */   GIM_Try, /*On fail goto*//*Label 23402*/ GIMT_Encode4(1711305), // Rule ID 7699 //
     /* 1711224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1711232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1711235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1711238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1711241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1711244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711270 */     // MIs[0] policy
     /* 1711270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711280 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1711283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711304 */     // GIR_Coverage, 7699,
     /* 1711304 */     GIR_EraseRootFromParent_Done,
     /* 1711305 */   // Label 23402: @1711305
     /* 1711305 */   GIM_Try, /*On fail goto*//*Label 23403*/ GIMT_Encode4(1711391), // Rule ID 7702 //
     /* 1711310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1711318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1711321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1711324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1711327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1711330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711356 */     // MIs[0] policy
     /* 1711356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711366 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1711369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711390 */     // GIR_Coverage, 7702,
     /* 1711390 */     GIR_EraseRootFromParent_Done,
     /* 1711391 */   // Label 23403: @1711391
     /* 1711391 */   GIM_Try, /*On fail goto*//*Label 23404*/ GIMT_Encode4(1711477), // Rule ID 7703 //
     /* 1711396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1711404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1711407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1711410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1711413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1711416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711442 */     // MIs[0] policy
     /* 1711442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711452 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1711455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711476 */     // GIR_Coverage, 7703,
     /* 1711476 */     GIR_EraseRootFromParent_Done,
     /* 1711477 */   // Label 23404: @1711477
     /* 1711477 */   GIM_Try, /*On fail goto*//*Label 23405*/ GIMT_Encode4(1711563), // Rule ID 7706 //
     /* 1711482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1711490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1711493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1711496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1711499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1711502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1711505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711528 */     // MIs[0] policy
     /* 1711528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711538 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1711541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711562 */     // GIR_Coverage, 7706,
     /* 1711562 */     GIR_EraseRootFromParent_Done,
     /* 1711563 */   // Label 23405: @1711563
     /* 1711563 */   GIM_Try, /*On fail goto*//*Label 23406*/ GIMT_Encode4(1711649), // Rule ID 7707 //
     /* 1711568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1711576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1711579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1711582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1711585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1711588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1711591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711614 */     // MIs[0] policy
     /* 1711614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711624 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1711627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711648 */     // GIR_Coverage, 7707,
     /* 1711648 */     GIR_EraseRootFromParent_Done,
     /* 1711649 */   // Label 23406: @1711649
     /* 1711649 */   GIM_Try, /*On fail goto*//*Label 23407*/ GIMT_Encode4(1711735), // Rule ID 7710 //
     /* 1711654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1711662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1711665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1711668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1711671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1711674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711700 */     // MIs[0] policy
     /* 1711700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1711713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711734 */     // GIR_Coverage, 7710,
     /* 1711734 */     GIR_EraseRootFromParent_Done,
     /* 1711735 */   // Label 23407: @1711735
     /* 1711735 */   GIM_Try, /*On fail goto*//*Label 23408*/ GIMT_Encode4(1711821), // Rule ID 7711 //
     /* 1711740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1711748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1711751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1711754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1711757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1711760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711786 */     // MIs[0] policy
     /* 1711786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711796 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1711799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711820 */     // GIR_Coverage, 7711,
     /* 1711820 */     GIR_EraseRootFromParent_Done,
     /* 1711821 */   // Label 23408: @1711821
     /* 1711821 */   GIM_Try, /*On fail goto*//*Label 23409*/ GIMT_Encode4(1711907), // Rule ID 7714 //
     /* 1711826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1711834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1711837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1711840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1711843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1711846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711872 */     // MIs[0] policy
     /* 1711872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711882 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1711885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711906 */     // GIR_Coverage, 7714,
     /* 1711906 */     GIR_EraseRootFromParent_Done,
     /* 1711907 */   // Label 23409: @1711907
     /* 1711907 */   GIM_Try, /*On fail goto*//*Label 23410*/ GIMT_Encode4(1711993), // Rule ID 7715 //
     /* 1711912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1711920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1711923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1711926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1711929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1711932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711958 */     // MIs[0] policy
     /* 1711958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1711971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711992 */     // GIR_Coverage, 7715,
     /* 1711992 */     GIR_EraseRootFromParent_Done,
     /* 1711993 */   // Label 23410: @1711993
     /* 1711993 */   GIM_Try, /*On fail goto*//*Label 23411*/ GIMT_Encode4(1712079), // Rule ID 7718 //
     /* 1711998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1712006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1712009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1712012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1712015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712044 */     // MIs[0] policy
     /* 1712044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712054 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1712057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712078 */     // GIR_Coverage, 7718,
     /* 1712078 */     GIR_EraseRootFromParent_Done,
     /* 1712079 */   // Label 23411: @1712079
     /* 1712079 */   GIM_Try, /*On fail goto*//*Label 23412*/ GIMT_Encode4(1712165), // Rule ID 7719 //
     /* 1712084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1712092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1712095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1712098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1712101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712130 */     // MIs[0] policy
     /* 1712130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712140 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1712143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712164 */     // GIR_Coverage, 7719,
     /* 1712164 */     GIR_EraseRootFromParent_Done,
     /* 1712165 */   // Label 23412: @1712165
     /* 1712165 */   GIM_Try, /*On fail goto*//*Label 23413*/ GIMT_Encode4(1712251), // Rule ID 7722 //
     /* 1712170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1712173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1712178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1712181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1712184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1712187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1712193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712216 */     // MIs[0] policy
     /* 1712216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712226 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1712229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712250 */     // GIR_Coverage, 7722,
     /* 1712250 */     GIR_EraseRootFromParent_Done,
     /* 1712251 */   // Label 23413: @1712251
     /* 1712251 */   GIM_Try, /*On fail goto*//*Label 23414*/ GIMT_Encode4(1712337), // Rule ID 7723 //
     /* 1712256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1712259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1712264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1712267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1712270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1712273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1712279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712302 */     // MIs[0] policy
     /* 1712302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712312 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1712315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712336 */     // GIR_Coverage, 7723,
     /* 1712336 */     GIR_EraseRootFromParent_Done,
     /* 1712337 */   // Label 23414: @1712337
     /* 1712337 */   GIM_Try, /*On fail goto*//*Label 23415*/ GIMT_Encode4(1712423), // Rule ID 7726 //
     /* 1712342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1712345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1712350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1712353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1712356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1712359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712388 */     // MIs[0] policy
     /* 1712388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712398 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1712401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712422 */     // GIR_Coverage, 7726,
     /* 1712422 */     GIR_EraseRootFromParent_Done,
     /* 1712423 */   // Label 23415: @1712423
     /* 1712423 */   GIM_Try, /*On fail goto*//*Label 23416*/ GIMT_Encode4(1712509), // Rule ID 7727 //
     /* 1712428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1712431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1712436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1712439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1712442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1712445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712474 */     // MIs[0] policy
     /* 1712474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1712487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712508 */     // GIR_Coverage, 7727,
     /* 1712508 */     GIR_EraseRootFromParent_Done,
     /* 1712509 */   // Label 23416: @1712509
     /* 1712509 */   GIM_Try, /*On fail goto*//*Label 23417*/ GIMT_Encode4(1712595), // Rule ID 7730 //
     /* 1712514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1712517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1712522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1712525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1712528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1712531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712560 */     // MIs[0] policy
     /* 1712560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1712573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712594 */     // GIR_Coverage, 7730,
     /* 1712594 */     GIR_EraseRootFromParent_Done,
     /* 1712595 */   // Label 23417: @1712595
     /* 1712595 */   GIM_Try, /*On fail goto*//*Label 23418*/ GIMT_Encode4(1712681), // Rule ID 7731 //
     /* 1712600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1712603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1712608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1712611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1712614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1712617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712646 */     // MIs[0] policy
     /* 1712646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1712659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712680 */     // GIR_Coverage, 7731,
     /* 1712680 */     GIR_EraseRootFromParent_Done,
     /* 1712681 */   // Label 23418: @1712681
     /* 1712681 */   GIM_Try, /*On fail goto*//*Label 23419*/ GIMT_Encode4(1712767), // Rule ID 7734 //
     /* 1712686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1712689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1712694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1712697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1712700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1712703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712732 */     // MIs[0] policy
     /* 1712732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712742 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1712745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712766 */     // GIR_Coverage, 7734,
     /* 1712766 */     GIR_EraseRootFromParent_Done,
     /* 1712767 */   // Label 23419: @1712767
     /* 1712767 */   GIM_Try, /*On fail goto*//*Label 23420*/ GIMT_Encode4(1712853), // Rule ID 7735 //
     /* 1712772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1712775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1712780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1712783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1712786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1712789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712818 */     // MIs[0] policy
     /* 1712818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712828 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1712831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712852 */     // GIR_Coverage, 7735,
     /* 1712852 */     GIR_EraseRootFromParent_Done,
     /* 1712853 */   // Label 23420: @1712853
     /* 1712853 */   GIM_Try, /*On fail goto*//*Label 23421*/ GIMT_Encode4(1712939), // Rule ID 10250 //
     /* 1712858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1712869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1712872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1712875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1712878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1712881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712904 */     // MIs[0] policy
     /* 1712904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712914 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1712917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712938 */     // GIR_Coverage, 10250,
     /* 1712938 */     GIR_EraseRootFromParent_Done,
     /* 1712939 */   // Label 23421: @1712939
     /* 1712939 */   GIM_Try, /*On fail goto*//*Label 23422*/ GIMT_Encode4(1713025), // Rule ID 10251 //
     /* 1712944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1712955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1712958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1712961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1712964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1712967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712990 */     // MIs[0] policy
     /* 1712990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713000 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1713003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713024 */     // GIR_Coverage, 10251,
     /* 1713024 */     GIR_EraseRootFromParent_Done,
     /* 1713025 */   // Label 23422: @1713025
     /* 1713025 */   GIM_Try, /*On fail goto*//*Label 23423*/ GIMT_Encode4(1713111), // Rule ID 10254 //
     /* 1713030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1713041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1713044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1713047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1713050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713076 */     // MIs[0] policy
     /* 1713076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713086 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1713089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713110 */     // GIR_Coverage, 10254,
     /* 1713110 */     GIR_EraseRootFromParent_Done,
     /* 1713111 */   // Label 23423: @1713111
     /* 1713111 */   GIM_Try, /*On fail goto*//*Label 23424*/ GIMT_Encode4(1713197), // Rule ID 10255 //
     /* 1713116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1713127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1713130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1713133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1713136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713162 */     // MIs[0] policy
     /* 1713162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713172 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1713175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713196 */     // GIR_Coverage, 10255,
     /* 1713196 */     GIR_EraseRootFromParent_Done,
     /* 1713197 */   // Label 23424: @1713197
     /* 1713197 */   GIM_Try, /*On fail goto*//*Label 23425*/ GIMT_Encode4(1713283), // Rule ID 10258 //
     /* 1713202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1713213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1713216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1713219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1713222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713248 */     // MIs[0] policy
     /* 1713248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713258 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1713261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713282 */     // GIR_Coverage, 10258,
     /* 1713282 */     GIR_EraseRootFromParent_Done,
     /* 1713283 */   // Label 23425: @1713283
     /* 1713283 */   GIM_Try, /*On fail goto*//*Label 23426*/ GIMT_Encode4(1713369), // Rule ID 10259 //
     /* 1713288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1713299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1713302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1713305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1713308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713334 */     // MIs[0] policy
     /* 1713334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713344 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1713347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713368 */     // GIR_Coverage, 10259,
     /* 1713368 */     GIR_EraseRootFromParent_Done,
     /* 1713369 */   // Label 23426: @1713369
     /* 1713369 */   GIM_Try, /*On fail goto*//*Label 23427*/ GIMT_Encode4(1713455), // Rule ID 10262 //
     /* 1713374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1713385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1713388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1713391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1713394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713420 */     // MIs[0] policy
     /* 1713420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713430 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1713433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713454 */     // GIR_Coverage, 10262,
     /* 1713454 */     GIR_EraseRootFromParent_Done,
     /* 1713455 */   // Label 23427: @1713455
     /* 1713455 */   GIM_Try, /*On fail goto*//*Label 23428*/ GIMT_Encode4(1713541), // Rule ID 10263 //
     /* 1713460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1713471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1713474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1713477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1713480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713506 */     // MIs[0] policy
     /* 1713506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713516 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1713519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713540 */     // GIR_Coverage, 10263,
     /* 1713540 */     GIR_EraseRootFromParent_Done,
     /* 1713541 */   // Label 23428: @1713541
     /* 1713541 */   GIM_Try, /*On fail goto*//*Label 23429*/ GIMT_Encode4(1713627), // Rule ID 10266 //
     /* 1713546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1713557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1713560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1713563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1713566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713592 */     // MIs[0] policy
     /* 1713592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713602 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1713605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713626 */     // GIR_Coverage, 10266,
     /* 1713626 */     GIR_EraseRootFromParent_Done,
     /* 1713627 */   // Label 23429: @1713627
     /* 1713627 */   GIM_Try, /*On fail goto*//*Label 23430*/ GIMT_Encode4(1713713), // Rule ID 10267 //
     /* 1713632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1713643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1713646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1713649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1713652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713678 */     // MIs[0] policy
     /* 1713678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713688 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1713691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713712 */     // GIR_Coverage, 10267,
     /* 1713712 */     GIR_EraseRootFromParent_Done,
     /* 1713713 */   // Label 23430: @1713713
     /* 1713713 */   GIM_Try, /*On fail goto*//*Label 23431*/ GIMT_Encode4(1713799), // Rule ID 10270 //
     /* 1713718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1713729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1713732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1713735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1713738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713764 */     // MIs[0] policy
     /* 1713764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713774 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1713777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713798 */     // GIR_Coverage, 10270,
     /* 1713798 */     GIR_EraseRootFromParent_Done,
     /* 1713799 */   // Label 23431: @1713799
     /* 1713799 */   GIM_Try, /*On fail goto*//*Label 23432*/ GIMT_Encode4(1713885), // Rule ID 10271 //
     /* 1713804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1713815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1713818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1713821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1713824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713850 */     // MIs[0] policy
     /* 1713850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713860 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1713863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713884 */     // GIR_Coverage, 10271,
     /* 1713884 */     GIR_EraseRootFromParent_Done,
     /* 1713885 */   // Label 23432: @1713885
     /* 1713885 */   GIM_Try, /*On fail goto*//*Label 23433*/ GIMT_Encode4(1713971), // Rule ID 10274 //
     /* 1713890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1713901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1713904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1713907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1713910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713936 */     // MIs[0] policy
     /* 1713936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713946 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1713949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713970 */     // GIR_Coverage, 10274,
     /* 1713970 */     GIR_EraseRootFromParent_Done,
     /* 1713971 */   // Label 23433: @1713971
     /* 1713971 */   GIM_Try, /*On fail goto*//*Label 23434*/ GIMT_Encode4(1714057), // Rule ID 10275 //
     /* 1713976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1713987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1713990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1713993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1713996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714022 */     // MIs[0] policy
     /* 1714022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1714035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714056 */     // GIR_Coverage, 10275,
     /* 1714056 */     GIR_EraseRootFromParent_Done,
     /* 1714057 */   // Label 23434: @1714057
     /* 1714057 */   GIM_Try, /*On fail goto*//*Label 23435*/ GIMT_Encode4(1714143), // Rule ID 10278 //
     /* 1714062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1714073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1714076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1714079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1714082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714108 */     // MIs[0] policy
     /* 1714108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714118 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1714121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714142 */     // GIR_Coverage, 10278,
     /* 1714142 */     GIR_EraseRootFromParent_Done,
     /* 1714143 */   // Label 23435: @1714143
     /* 1714143 */   GIM_Try, /*On fail goto*//*Label 23436*/ GIMT_Encode4(1714229), // Rule ID 10279 //
     /* 1714148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1714159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1714162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1714165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1714168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714194 */     // MIs[0] policy
     /* 1714194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714204 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1714207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714228 */     // GIR_Coverage, 10279,
     /* 1714228 */     GIR_EraseRootFromParent_Done,
     /* 1714229 */   // Label 23436: @1714229
     /* 1714229 */   GIM_Try, /*On fail goto*//*Label 23437*/ GIMT_Encode4(1714315), // Rule ID 10282 //
     /* 1714234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1714245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1714248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1714251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1714254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714280 */     // MIs[0] policy
     /* 1714280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714290 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1714293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714314 */     // GIR_Coverage, 10282,
     /* 1714314 */     GIR_EraseRootFromParent_Done,
     /* 1714315 */   // Label 23437: @1714315
     /* 1714315 */   GIM_Try, /*On fail goto*//*Label 23438*/ GIMT_Encode4(1714401), // Rule ID 10283 //
     /* 1714320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1714331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1714334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1714337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1714340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714366 */     // MIs[0] policy
     /* 1714366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714376 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1714379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714400 */     // GIR_Coverage, 10283,
     /* 1714400 */     GIR_EraseRootFromParent_Done,
     /* 1714401 */   // Label 23438: @1714401
     /* 1714401 */   GIM_Try, /*On fail goto*//*Label 23439*/ GIMT_Encode4(1714487), // Rule ID 10286 //
     /* 1714406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1714409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1714417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1714420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1714423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1714426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714452 */     // MIs[0] policy
     /* 1714452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714462 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1714465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714486 */     // GIR_Coverage, 10286,
     /* 1714486 */     GIR_EraseRootFromParent_Done,
     /* 1714487 */   // Label 23439: @1714487
     /* 1714487 */   GIM_Try, /*On fail goto*//*Label 23440*/ GIMT_Encode4(1714573), // Rule ID 10287 //
     /* 1714492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1714495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1714503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1714506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1714509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1714512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714538 */     // MIs[0] policy
     /* 1714538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714548 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1714551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714572 */     // GIR_Coverage, 10287,
     /* 1714572 */     GIR_EraseRootFromParent_Done,
     /* 1714573 */   // Label 23440: @1714573
     /* 1714573 */   GIM_Try, /*On fail goto*//*Label 23441*/ GIMT_Encode4(1714659), // Rule ID 10290 //
     /* 1714578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1714589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1714592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1714595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1714598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1714601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1714608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714624 */     // MIs[0] policy
     /* 1714624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714634 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1714637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714658 */     // GIR_Coverage, 10290,
     /* 1714658 */     GIR_EraseRootFromParent_Done,
     /* 1714659 */   // Label 23441: @1714659
     /* 1714659 */   GIM_Try, /*On fail goto*//*Label 23442*/ GIMT_Encode4(1714745), // Rule ID 10291 //
     /* 1714664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1714675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1714678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1714681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1714684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1714687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1714694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714710 */     // MIs[0] policy
     /* 1714710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714720 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1714723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714744 */     // GIR_Coverage, 10291,
     /* 1714744 */     GIR_EraseRootFromParent_Done,
     /* 1714745 */   // Label 23442: @1714745
     /* 1714745 */   GIM_Try, /*On fail goto*//*Label 23443*/ GIMT_Encode4(1714831), // Rule ID 10294 //
     /* 1714750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1714761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1714764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1714767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1714770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1714773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1714780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714796 */     // MIs[0] policy
     /* 1714796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714806 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1714809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714830 */     // GIR_Coverage, 10294,
     /* 1714830 */     GIR_EraseRootFromParent_Done,
     /* 1714831 */   // Label 23443: @1714831
     /* 1714831 */   GIM_Try, /*On fail goto*//*Label 23444*/ GIMT_Encode4(1714917), // Rule ID 10295 //
     /* 1714836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1714847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1714850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1714853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1714856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1714859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1714866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714882 */     // MIs[0] policy
     /* 1714882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714892 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1714895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714916 */     // GIR_Coverage, 10295,
     /* 1714916 */     GIR_EraseRootFromParent_Done,
     /* 1714917 */   // Label 23444: @1714917
     /* 1714917 */   GIM_Try, /*On fail goto*//*Label 23445*/ GIMT_Encode4(1715003), // Rule ID 10298 //
     /* 1714922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1714933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1714936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1714939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1714942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1714945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1714952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714968 */     // MIs[0] policy
     /* 1714968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714978 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1714981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715002 */     // GIR_Coverage, 10298,
     /* 1715002 */     GIR_EraseRootFromParent_Done,
     /* 1715003 */   // Label 23445: @1715003
     /* 1715003 */   GIM_Try, /*On fail goto*//*Label 23446*/ GIMT_Encode4(1715089), // Rule ID 10299 //
     /* 1715008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1715019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1715022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1715025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1715028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1715031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715054 */     // MIs[0] policy
     /* 1715054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715064 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1715067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715088 */     // GIR_Coverage, 10299,
     /* 1715088 */     GIR_EraseRootFromParent_Done,
     /* 1715089 */   // Label 23446: @1715089
     /* 1715089 */   GIM_Try, /*On fail goto*//*Label 23447*/ GIMT_Encode4(1715175), // Rule ID 10302 //
     /* 1715094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1715105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1715108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1715111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1715114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715140 */     // MIs[0] policy
     /* 1715140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715150 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1715153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715174 */     // GIR_Coverage, 10302,
     /* 1715174 */     GIR_EraseRootFromParent_Done,
     /* 1715175 */   // Label 23447: @1715175
     /* 1715175 */   GIM_Try, /*On fail goto*//*Label 23448*/ GIMT_Encode4(1715261), // Rule ID 10303 //
     /* 1715180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1715191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1715194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1715197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1715200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715226 */     // MIs[0] policy
     /* 1715226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715236 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1715239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715260 */     // GIR_Coverage, 10303,
     /* 1715260 */     GIR_EraseRootFromParent_Done,
     /* 1715261 */   // Label 23448: @1715261
     /* 1715261 */   GIM_Try, /*On fail goto*//*Label 23449*/ GIMT_Encode4(1715347), // Rule ID 10306 //
     /* 1715266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1715277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1715280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1715283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1715286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715312 */     // MIs[0] policy
     /* 1715312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715322 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1715325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715346 */     // GIR_Coverage, 10306,
     /* 1715346 */     GIR_EraseRootFromParent_Done,
     /* 1715347 */   // Label 23449: @1715347
     /* 1715347 */   GIM_Try, /*On fail goto*//*Label 23450*/ GIMT_Encode4(1715433), // Rule ID 10307 //
     /* 1715352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1715363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1715366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1715369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1715372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715398 */     // MIs[0] policy
     /* 1715398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715408 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1715411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715432 */     // GIR_Coverage, 10307,
     /* 1715432 */     GIR_EraseRootFromParent_Done,
     /* 1715433 */   // Label 23450: @1715433
     /* 1715433 */   GIM_Try, /*On fail goto*//*Label 23451*/ GIMT_Encode4(1715519), // Rule ID 10310 //
     /* 1715438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1715449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1715452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1715455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1715458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715484 */     // MIs[0] policy
     /* 1715484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715494 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1715497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715518 */     // GIR_Coverage, 10310,
     /* 1715518 */     GIR_EraseRootFromParent_Done,
     /* 1715519 */   // Label 23451: @1715519
     /* 1715519 */   GIM_Try, /*On fail goto*//*Label 23452*/ GIMT_Encode4(1715605), // Rule ID 10311 //
     /* 1715524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1715535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1715538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1715541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1715544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715570 */     // MIs[0] policy
     /* 1715570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715580 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1715583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715604 */     // GIR_Coverage, 10311,
     /* 1715604 */     GIR_EraseRootFromParent_Done,
     /* 1715605 */   // Label 23452: @1715605
     /* 1715605 */   GIM_Try, /*On fail goto*//*Label 23453*/ GIMT_Encode4(1715691), // Rule ID 10314 //
     /* 1715610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1715621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1715624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1715627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1715630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715656 */     // MIs[0] policy
     /* 1715656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715666 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1715669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715690 */     // GIR_Coverage, 10314,
     /* 1715690 */     GIR_EraseRootFromParent_Done,
     /* 1715691 */   // Label 23453: @1715691
     /* 1715691 */   GIM_Try, /*On fail goto*//*Label 23454*/ GIMT_Encode4(1715777), // Rule ID 10315 //
     /* 1715696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1715707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1715710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1715713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1715716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715742 */     // MIs[0] policy
     /* 1715742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1715755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715776 */     // GIR_Coverage, 10315,
     /* 1715776 */     GIR_EraseRootFromParent_Done,
     /* 1715777 */   // Label 23454: @1715777
     /* 1715777 */   GIM_Try, /*On fail goto*//*Label 23455*/ GIMT_Encode4(1715863), // Rule ID 10318 //
     /* 1715782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1715793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1715796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1715799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1715802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715828 */     // MIs[0] policy
     /* 1715828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715838 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1715841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715862 */     // GIR_Coverage, 10318,
     /* 1715862 */     GIR_EraseRootFromParent_Done,
     /* 1715863 */   // Label 23455: @1715863
     /* 1715863 */   GIM_Try, /*On fail goto*//*Label 23456*/ GIMT_Encode4(1715949), // Rule ID 10319 //
     /* 1715868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1715879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1715882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1715885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1715888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715914 */     // MIs[0] policy
     /* 1715914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715924 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1715927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715948 */     // GIR_Coverage, 10319,
     /* 1715948 */     GIR_EraseRootFromParent_Done,
     /* 1715949 */   // Label 23456: @1715949
     /* 1715949 */   GIM_Try, /*On fail goto*//*Label 23457*/ GIMT_Encode4(1716035), // Rule ID 10322 //
     /* 1715954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1715965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1715968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1715971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1715974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716000 */     // MIs[0] policy
     /* 1716000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716010 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1716013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716034 */     // GIR_Coverage, 10322,
     /* 1716034 */     GIR_EraseRootFromParent_Done,
     /* 1716035 */   // Label 23457: @1716035
     /* 1716035 */   GIM_Try, /*On fail goto*//*Label 23458*/ GIMT_Encode4(1716121), // Rule ID 10323 //
     /* 1716040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1716051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1716054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1716057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1716060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716086 */     // MIs[0] policy
     /* 1716086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716096 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1716099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716120 */     // GIR_Coverage, 10323,
     /* 1716120 */     GIR_EraseRootFromParent_Done,
     /* 1716121 */   // Label 23458: @1716121
     /* 1716121 */   GIM_Try, /*On fail goto*//*Label 23459*/ GIMT_Encode4(1716207), // Rule ID 10326 //
     /* 1716126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1716137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1716140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1716143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1716146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716172 */     // MIs[0] policy
     /* 1716172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1716185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716206 */     // GIR_Coverage, 10326,
     /* 1716206 */     GIR_EraseRootFromParent_Done,
     /* 1716207 */   // Label 23459: @1716207
     /* 1716207 */   GIM_Try, /*On fail goto*//*Label 23460*/ GIMT_Encode4(1716293), // Rule ID 10327 //
     /* 1716212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1716223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1716226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1716229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1716232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716258 */     // MIs[0] policy
     /* 1716258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716268 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1716271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716292 */     // GIR_Coverage, 10327,
     /* 1716292 */     GIR_EraseRootFromParent_Done,
     /* 1716293 */   // Label 23460: @1716293
     /* 1716293 */   GIM_Try, /*On fail goto*//*Label 23461*/ GIMT_Encode4(1716379), // Rule ID 10330 //
     /* 1716298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1716309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1716312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1716315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1716318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716344 */     // MIs[0] policy
     /* 1716344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716354 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1716357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716378 */     // GIR_Coverage, 10330,
     /* 1716378 */     GIR_EraseRootFromParent_Done,
     /* 1716379 */   // Label 23461: @1716379
     /* 1716379 */   GIM_Try, /*On fail goto*//*Label 23462*/ GIMT_Encode4(1716465), // Rule ID 10331 //
     /* 1716384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1716395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1716398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1716401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1716404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716430 */     // MIs[0] policy
     /* 1716430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716440 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1716443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716464 */     // GIR_Coverage, 10331,
     /* 1716464 */     GIR_EraseRootFromParent_Done,
     /* 1716465 */   // Label 23462: @1716465
     /* 1716465 */   GIM_Try, /*On fail goto*//*Label 23463*/ GIMT_Encode4(1716551), // Rule ID 10334 //
     /* 1716470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1716481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1716484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1716487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1716490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716516 */     // MIs[0] policy
     /* 1716516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716526 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1716529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716550 */     // GIR_Coverage, 10334,
     /* 1716550 */     GIR_EraseRootFromParent_Done,
     /* 1716551 */   // Label 23463: @1716551
     /* 1716551 */   GIM_Try, /*On fail goto*//*Label 23464*/ GIMT_Encode4(1716637), // Rule ID 10335 //
     /* 1716556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1716567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1716570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1716573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1716576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716602 */     // MIs[0] policy
     /* 1716602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716612 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1716615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716636 */     // GIR_Coverage, 10335,
     /* 1716636 */     GIR_EraseRootFromParent_Done,
     /* 1716637 */   // Label 23464: @1716637
     /* 1716637 */   GIM_Try, /*On fail goto*//*Label 23465*/ GIMT_Encode4(1716723), // Rule ID 10338 //
     /* 1716642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1716653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1716656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1716659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1716665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716688 */     // MIs[0] policy
     /* 1716688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716698 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1716701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716722 */     // GIR_Coverage, 10338,
     /* 1716722 */     GIR_EraseRootFromParent_Done,
     /* 1716723 */   // Label 23465: @1716723
     /* 1716723 */   GIM_Try, /*On fail goto*//*Label 23466*/ GIMT_Encode4(1716809), // Rule ID 10339 //
     /* 1716728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1716739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1716742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1716745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1716751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716774 */     // MIs[0] policy
     /* 1716774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716784 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1716787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716808 */     // GIR_Coverage, 10339,
     /* 1716808 */     GIR_EraseRootFromParent_Done,
     /* 1716809 */   // Label 23466: @1716809
     /* 1716809 */   GIM_Try, /*On fail goto*//*Label 23467*/ GIMT_Encode4(1716895), // Rule ID 10342 //
     /* 1716814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1716825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1716828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1716831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716860 */     // MIs[0] policy
     /* 1716860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716870 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1716873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716894 */     // GIR_Coverage, 10342,
     /* 1716894 */     GIR_EraseRootFromParent_Done,
     /* 1716895 */   // Label 23467: @1716895
     /* 1716895 */   GIM_Try, /*On fail goto*//*Label 23468*/ GIMT_Encode4(1716981), // Rule ID 10343 //
     /* 1716900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1716911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1716914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1716917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716946 */     // MIs[0] policy
     /* 1716946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716956 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1716959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716980 */     // GIR_Coverage, 10343,
     /* 1716980 */     GIR_EraseRootFromParent_Done,
     /* 1716981 */   // Label 23468: @1716981
     /* 1716981 */   GIM_Try, /*On fail goto*//*Label 23469*/ GIMT_Encode4(1717067), // Rule ID 10346 //
     /* 1716986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1716997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1717000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1717003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1717006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717032 */     // MIs[0] policy
     /* 1717032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717042 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1717045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717066 */     // GIR_Coverage, 10346,
     /* 1717066 */     GIR_EraseRootFromParent_Done,
     /* 1717067 */   // Label 23469: @1717067
     /* 1717067 */   GIM_Try, /*On fail goto*//*Label 23470*/ GIMT_Encode4(1717153), // Rule ID 10347 //
     /* 1717072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1717080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1717083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1717086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1717089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1717092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717118 */     // MIs[0] policy
     /* 1717118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717128 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1717131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717152 */     // GIR_Coverage, 10347,
     /* 1717152 */     GIR_EraseRootFromParent_Done,
     /* 1717153 */   // Label 23470: @1717153
     /* 1717153 */   GIM_Try, /*On fail goto*//*Label 23471*/ GIMT_Encode4(1717239), // Rule ID 10350 //
     /* 1717158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1717166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1717169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1717172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1717175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1717178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717204 */     // MIs[0] policy
     /* 1717204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1717217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717238 */     // GIR_Coverage, 10350,
     /* 1717238 */     GIR_EraseRootFromParent_Done,
     /* 1717239 */   // Label 23471: @1717239
     /* 1717239 */   GIM_Try, /*On fail goto*//*Label 23472*/ GIMT_Encode4(1717325), // Rule ID 10351 //
     /* 1717244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1717252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1717255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1717258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1717261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1717264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717290 */     // MIs[0] policy
     /* 1717290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717300 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1717303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717324 */     // GIR_Coverage, 10351,
     /* 1717324 */     GIR_EraseRootFromParent_Done,
     /* 1717325 */   // Label 23472: @1717325
     /* 1717325 */   GIM_Try, /*On fail goto*//*Label 23473*/ GIMT_Encode4(1717411), // Rule ID 10354 //
     /* 1717330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1717338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1717341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1717344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1717347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1717350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717376 */     // MIs[0] policy
     /* 1717376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717386 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1717389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717410 */     // GIR_Coverage, 10354,
     /* 1717410 */     GIR_EraseRootFromParent_Done,
     /* 1717411 */   // Label 23473: @1717411
     /* 1717411 */   GIM_Try, /*On fail goto*//*Label 23474*/ GIMT_Encode4(1717497), // Rule ID 10355 //
     /* 1717416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1717424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1717427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1717430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1717433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1717436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717462 */     // MIs[0] policy
     /* 1717462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717472 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1717475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717496 */     // GIR_Coverage, 10355,
     /* 1717496 */     GIR_EraseRootFromParent_Done,
     /* 1717497 */   // Label 23474: @1717497
     /* 1717497 */   GIM_Try, /*On fail goto*//*Label 23475*/ GIMT_Encode4(1717583), // Rule ID 10358 //
     /* 1717502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1717510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1717513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1717516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1717519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1717522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717548 */     // MIs[0] policy
     /* 1717548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717558 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1717561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717582 */     // GIR_Coverage, 10358,
     /* 1717582 */     GIR_EraseRootFromParent_Done,
     /* 1717583 */   // Label 23475: @1717583
     /* 1717583 */   GIM_Try, /*On fail goto*//*Label 23476*/ GIMT_Encode4(1717669), // Rule ID 10359 //
     /* 1717588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1717596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1717599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1717602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1717605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1717608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717634 */     // MIs[0] policy
     /* 1717634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717644 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1717647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717668 */     // GIR_Coverage, 10359,
     /* 1717668 */     GIR_EraseRootFromParent_Done,
     /* 1717669 */   // Label 23476: @1717669
     /* 1717669 */   GIM_Try, /*On fail goto*//*Label 23477*/ GIMT_Encode4(1717755), // Rule ID 10362 //
     /* 1717674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1717682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1717685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1717688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1717691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1717694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717720 */     // MIs[0] policy
     /* 1717720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717730 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1717733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717754 */     // GIR_Coverage, 10362,
     /* 1717754 */     GIR_EraseRootFromParent_Done,
     /* 1717755 */   // Label 23477: @1717755
     /* 1717755 */   GIM_Try, /*On fail goto*//*Label 23478*/ GIMT_Encode4(1717841), // Rule ID 10363 //
     /* 1717760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1717768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1717771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1717774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1717777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1717780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717806 */     // MIs[0] policy
     /* 1717806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717816 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1717819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717840 */     // GIR_Coverage, 10363,
     /* 1717840 */     GIR_EraseRootFromParent_Done,
     /* 1717841 */   // Label 23478: @1717841
     /* 1717841 */   GIM_Try, /*On fail goto*//*Label 23479*/ GIMT_Encode4(1717927), // Rule ID 10366 //
     /* 1717846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1717854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1717857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1717860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1717863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1717866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717892 */     // MIs[0] policy
     /* 1717892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1717905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717926 */     // GIR_Coverage, 10366,
     /* 1717926 */     GIR_EraseRootFromParent_Done,
     /* 1717927 */   // Label 23479: @1717927
     /* 1717927 */   GIM_Try, /*On fail goto*//*Label 23480*/ GIMT_Encode4(1718013), // Rule ID 10367 //
     /* 1717932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1717940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1717943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1717946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1717949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1717952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717978 */     // MIs[0] policy
     /* 1717978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717988 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1717991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718012 */     // GIR_Coverage, 10367,
     /* 1718012 */     GIR_EraseRootFromParent_Done,
     /* 1718013 */   // Label 23480: @1718013
     /* 1718013 */   GIM_Try, /*On fail goto*//*Label 23481*/ GIMT_Encode4(1718099), // Rule ID 10370 //
     /* 1718018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1718026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1718029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1718032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1718035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1718038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718064 */     // MIs[0] policy
     /* 1718064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1718077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718098 */     // GIR_Coverage, 10370,
     /* 1718098 */     GIR_EraseRootFromParent_Done,
     /* 1718099 */   // Label 23481: @1718099
     /* 1718099 */   GIM_Try, /*On fail goto*//*Label 23482*/ GIMT_Encode4(1718185), // Rule ID 10371 //
     /* 1718104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1718112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1718115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1718118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1718121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1718124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718150 */     // MIs[0] policy
     /* 1718150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718160 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1718163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718184 */     // GIR_Coverage, 10371,
     /* 1718184 */     GIR_EraseRootFromParent_Done,
     /* 1718185 */   // Label 23482: @1718185
     /* 1718185 */   GIM_Try, /*On fail goto*//*Label 23483*/ GIMT_Encode4(1718271), // Rule ID 10374 //
     /* 1718190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1718193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1718198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1718201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1718204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1718207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1718210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718236 */     // MIs[0] policy
     /* 1718236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1718249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718270 */     // GIR_Coverage, 10374,
     /* 1718270 */     GIR_EraseRootFromParent_Done,
     /* 1718271 */   // Label 23483: @1718271
     /* 1718271 */   GIM_Try, /*On fail goto*//*Label 23484*/ GIMT_Encode4(1718357), // Rule ID 10375 //
     /* 1718276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1718279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1718284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1718287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1718290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1718293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1718296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718322 */     // MIs[0] policy
     /* 1718322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718332 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1718335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718356 */     // GIR_Coverage, 10375,
     /* 1718356 */     GIR_EraseRootFromParent_Done,
     /* 1718357 */   // Label 23484: @1718357
     /* 1718357 */   GIM_Try, /*On fail goto*//*Label 23485*/ GIMT_Encode4(1718443), // Rule ID 10378 //
     /* 1718362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1718370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1718373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1718376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1718379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1718382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1718385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718408 */     // MIs[0] policy
     /* 1718408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718418 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1718421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718442 */     // GIR_Coverage, 10378,
     /* 1718442 */     GIR_EraseRootFromParent_Done,
     /* 1718443 */   // Label 23485: @1718443
     /* 1718443 */   GIM_Try, /*On fail goto*//*Label 23486*/ GIMT_Encode4(1718529), // Rule ID 10379 //
     /* 1718448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1718456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1718459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1718462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1718465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1718468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1718471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718494 */     // MIs[0] policy
     /* 1718494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718504 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1718507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718528 */     // GIR_Coverage, 10379,
     /* 1718528 */     GIR_EraseRootFromParent_Done,
     /* 1718529 */   // Label 23486: @1718529
     /* 1718529 */   GIM_Try, /*On fail goto*//*Label 23487*/ GIMT_Encode4(1718615), // Rule ID 10382 //
     /* 1718534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1718542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1718545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1718548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1718551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1718554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1718557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1718564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718580 */     // MIs[0] policy
     /* 1718580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718590 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1718593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718614 */     // GIR_Coverage, 10382,
     /* 1718614 */     GIR_EraseRootFromParent_Done,
     /* 1718615 */   // Label 23487: @1718615
     /* 1718615 */   GIM_Try, /*On fail goto*//*Label 23488*/ GIMT_Encode4(1718701), // Rule ID 10383 //
     /* 1718620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1718628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1718631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1718634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1718637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1718640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1718643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1718650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718666 */     // MIs[0] policy
     /* 1718666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718676 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1718679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718700 */     // GIR_Coverage, 10383,
     /* 1718700 */     GIR_EraseRootFromParent_Done,
     /* 1718701 */   // Label 23488: @1718701
     /* 1718701 */   GIM_Try, /*On fail goto*//*Label 23489*/ GIMT_Encode4(1718787), // Rule ID 10386 //
     /* 1718706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1718714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1718717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1718720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1718723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1718726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1718729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1718736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718752 */     // MIs[0] policy
     /* 1718752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718762 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1718765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718786 */     // GIR_Coverage, 10386,
     /* 1718786 */     GIR_EraseRootFromParent_Done,
     /* 1718787 */   // Label 23489: @1718787
     /* 1718787 */   GIM_Try, /*On fail goto*//*Label 23490*/ GIMT_Encode4(1718873), // Rule ID 10387 //
     /* 1718792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1718800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1718803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1718806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1718809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1718812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1718815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1718822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718838 */     // MIs[0] policy
     /* 1718838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718848 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1718851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718872 */     // GIR_Coverage, 10387,
     /* 1718872 */     GIR_EraseRootFromParent_Done,
     /* 1718873 */   // Label 23490: @1718873
     /* 1718873 */   GIM_Try, /*On fail goto*//*Label 23491*/ GIMT_Encode4(1718959), // Rule ID 10390 //
     /* 1718878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1718886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1718889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1718892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1718895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1718898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718924 */     // MIs[0] policy
     /* 1718924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718934 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1718937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718958 */     // GIR_Coverage, 10390,
     /* 1718958 */     GIR_EraseRootFromParent_Done,
     /* 1718959 */   // Label 23491: @1718959
     /* 1718959 */   GIM_Try, /*On fail goto*//*Label 23492*/ GIMT_Encode4(1719045), // Rule ID 10391 //
     /* 1718964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1718972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1718975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1718978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1718981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1718984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719010 */     // MIs[0] policy
     /* 1719010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1719023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719044 */     // GIR_Coverage, 10391,
     /* 1719044 */     GIR_EraseRootFromParent_Done,
     /* 1719045 */   // Label 23492: @1719045
     /* 1719045 */   GIM_Try, /*On fail goto*//*Label 23493*/ GIMT_Encode4(1719131), // Rule ID 10394 //
     /* 1719050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1719058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1719061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1719064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1719067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1719070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719096 */     // MIs[0] policy
     /* 1719096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719106 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1719109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719130 */     // GIR_Coverage, 10394,
     /* 1719130 */     GIR_EraseRootFromParent_Done,
     /* 1719131 */   // Label 23493: @1719131
     /* 1719131 */   GIM_Try, /*On fail goto*//*Label 23494*/ GIMT_Encode4(1719217), // Rule ID 10395 //
     /* 1719136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1719144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1719147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1719150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1719153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1719156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719182 */     // MIs[0] policy
     /* 1719182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719192 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1719195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719216 */     // GIR_Coverage, 10395,
     /* 1719216 */     GIR_EraseRootFromParent_Done,
     /* 1719217 */   // Label 23494: @1719217
     /* 1719217 */   GIM_Try, /*On fail goto*//*Label 23495*/ GIMT_Encode4(1719303), // Rule ID 10398 //
     /* 1719222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1719230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1719233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1719236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1719239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1719242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719268 */     // MIs[0] policy
     /* 1719268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719278 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1719281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719302 */     // GIR_Coverage, 10398,
     /* 1719302 */     GIR_EraseRootFromParent_Done,
     /* 1719303 */   // Label 23495: @1719303
     /* 1719303 */   GIM_Try, /*On fail goto*//*Label 23496*/ GIMT_Encode4(1719389), // Rule ID 10399 //
     /* 1719308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1719316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1719319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1719322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1719325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1719328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719354 */     // MIs[0] policy
     /* 1719354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719364 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1719367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719388 */     // GIR_Coverage, 10399,
     /* 1719388 */     GIR_EraseRootFromParent_Done,
     /* 1719389 */   // Label 23496: @1719389
     /* 1719389 */   GIM_Try, /*On fail goto*//*Label 23497*/ GIMT_Encode4(1719475), // Rule ID 10402 //
     /* 1719394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1719402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1719405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1719408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1719411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1719414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719440 */     // MIs[0] policy
     /* 1719440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719450 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1719453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719474 */     // GIR_Coverage, 10402,
     /* 1719474 */     GIR_EraseRootFromParent_Done,
     /* 1719475 */   // Label 23497: @1719475
     /* 1719475 */   GIM_Try, /*On fail goto*//*Label 23498*/ GIMT_Encode4(1719561), // Rule ID 10403 //
     /* 1719480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1719488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1719491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1719494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1719497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1719500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719526 */     // MIs[0] policy
     /* 1719526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1719539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719560 */     // GIR_Coverage, 10403,
     /* 1719560 */     GIR_EraseRootFromParent_Done,
     /* 1719561 */   // Label 23498: @1719561
     /* 1719561 */   GIM_Try, /*On fail goto*//*Label 23499*/ GIMT_Encode4(1719647), // Rule ID 10406 //
     /* 1719566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1719574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1719577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1719580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1719583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1719586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719612 */     // MIs[0] policy
     /* 1719612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719622 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1719625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719646 */     // GIR_Coverage, 10406,
     /* 1719646 */     GIR_EraseRootFromParent_Done,
     /* 1719647 */   // Label 23499: @1719647
     /* 1719647 */   GIM_Try, /*On fail goto*//*Label 23500*/ GIMT_Encode4(1719733), // Rule ID 10407 //
     /* 1719652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1719660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1719663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1719666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1719669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1719672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719698 */     // MIs[0] policy
     /* 1719698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719708 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1719711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719732 */     // GIR_Coverage, 10407,
     /* 1719732 */     GIR_EraseRootFromParent_Done,
     /* 1719733 */   // Label 23500: @1719733
     /* 1719733 */   GIM_Try, /*On fail goto*//*Label 23501*/ GIMT_Encode4(1719819), // Rule ID 10410 //
     /* 1719738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1719746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1719749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1719752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1719755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1719758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719784 */     // MIs[0] policy
     /* 1719784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719794 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1719797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719818 */     // GIR_Coverage, 10410,
     /* 1719818 */     GIR_EraseRootFromParent_Done,
     /* 1719819 */   // Label 23501: @1719819
     /* 1719819 */   GIM_Try, /*On fail goto*//*Label 23502*/ GIMT_Encode4(1719905), // Rule ID 10411 //
     /* 1719824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1719832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1719835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1719838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1719841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1719844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719870 */     // MIs[0] policy
     /* 1719870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719880 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1719883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719904 */     // GIR_Coverage, 10411,
     /* 1719904 */     GIR_EraseRootFromParent_Done,
     /* 1719905 */   // Label 23502: @1719905
     /* 1719905 */   GIM_Try, /*On fail goto*//*Label 23503*/ GIMT_Encode4(1719991), // Rule ID 10414 //
     /* 1719910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1719913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1719918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1719921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1719924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1719927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1719930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1719933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719956 */     // MIs[0] policy
     /* 1719956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719966 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1719969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1719987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719990 */     // GIR_Coverage, 10414,
     /* 1719990 */     GIR_EraseRootFromParent_Done,
     /* 1719991 */   // Label 23503: @1719991
     /* 1719991 */   GIM_Try, /*On fail goto*//*Label 23504*/ GIMT_Encode4(1720077), // Rule ID 10415 //
     /* 1719996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1719999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1720004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1720007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1720010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1720013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1720019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720042 */     // MIs[0] policy
     /* 1720042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720052 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1720055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720076 */     // GIR_Coverage, 10415,
     /* 1720076 */     GIR_EraseRootFromParent_Done,
     /* 1720077 */   // Label 23504: @1720077
     /* 1720077 */   GIM_Try, /*On fail goto*//*Label 23505*/ GIMT_Encode4(1720163), // Rule ID 10418 //
     /* 1720082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1720090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1720093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1720096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1720099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720128 */     // MIs[0] policy
     /* 1720128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720138 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1720141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720162 */     // GIR_Coverage, 10418,
     /* 1720162 */     GIR_EraseRootFromParent_Done,
     /* 1720163 */   // Label 23505: @1720163
     /* 1720163 */   GIM_Try, /*On fail goto*//*Label 23506*/ GIMT_Encode4(1720249), // Rule ID 10419 //
     /* 1720168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1720176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1720179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1720182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1720185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720214 */     // MIs[0] policy
     /* 1720214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720224 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1720227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720248 */     // GIR_Coverage, 10419,
     /* 1720248 */     GIR_EraseRootFromParent_Done,
     /* 1720249 */   // Label 23506: @1720249
     /* 1720249 */   GIM_Try, /*On fail goto*//*Label 23507*/ GIMT_Encode4(1720335), // Rule ID 10422 //
     /* 1720254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1720262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1720265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1720268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1720271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720300 */     // MIs[0] policy
     /* 1720300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720310 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1720313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720334 */     // GIR_Coverage, 10422,
     /* 1720334 */     GIR_EraseRootFromParent_Done,
     /* 1720335 */   // Label 23507: @1720335
     /* 1720335 */   GIM_Try, /*On fail goto*//*Label 23508*/ GIMT_Encode4(1720421), // Rule ID 10423 //
     /* 1720340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1720348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1720351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1720354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1720357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720386 */     // MIs[0] policy
     /* 1720386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720396 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1720399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720420 */     // GIR_Coverage, 10423,
     /* 1720420 */     GIR_EraseRootFromParent_Done,
     /* 1720421 */   // Label 23508: @1720421
     /* 1720421 */   GIM_Try, /*On fail goto*//*Label 23509*/ GIMT_Encode4(1720507), // Rule ID 10426 //
     /* 1720426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1720437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1720440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1720443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1720446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720472 */     // MIs[0] policy
     /* 1720472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720482 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1720485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720506 */     // GIR_Coverage, 10426,
     /* 1720506 */     GIR_EraseRootFromParent_Done,
     /* 1720507 */   // Label 23509: @1720507
     /* 1720507 */   GIM_Try, /*On fail goto*//*Label 23510*/ GIMT_Encode4(1720593), // Rule ID 10427 //
     /* 1720512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1720523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1720526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1720529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1720532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720558 */     // MIs[0] policy
     /* 1720558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720568 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1720571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720592 */     // GIR_Coverage, 10427,
     /* 1720592 */     GIR_EraseRootFromParent_Done,
     /* 1720593 */   // Label 23510: @1720593
     /* 1720593 */   GIM_Try, /*On fail goto*//*Label 23511*/ GIMT_Encode4(1720679), // Rule ID 10430 //
     /* 1720598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1720609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1720612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1720615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1720618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1720621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720644 */     // MIs[0] policy
     /* 1720644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720654 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1720657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720678 */     // GIR_Coverage, 10430,
     /* 1720678 */     GIR_EraseRootFromParent_Done,
     /* 1720679 */   // Label 23511: @1720679
     /* 1720679 */   GIM_Try, /*On fail goto*//*Label 23512*/ GIMT_Encode4(1720765), // Rule ID 10431 //
     /* 1720684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1720695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1720698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1720701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1720704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1720707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720730 */     // MIs[0] policy
     /* 1720730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720740 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1720743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720764 */     // GIR_Coverage, 10431,
     /* 1720764 */     GIR_EraseRootFromParent_Done,
     /* 1720765 */   // Label 23512: @1720765
     /* 1720765 */   GIM_Try, /*On fail goto*//*Label 23513*/ GIMT_Encode4(1720851), // Rule ID 10434 //
     /* 1720770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1720781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1720784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1720787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1720790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720816 */     // MIs[0] policy
     /* 1720816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720826 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1720829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720850 */     // GIR_Coverage, 10434,
     /* 1720850 */     GIR_EraseRootFromParent_Done,
     /* 1720851 */   // Label 23513: @1720851
     /* 1720851 */   GIM_Try, /*On fail goto*//*Label 23514*/ GIMT_Encode4(1720937), // Rule ID 10435 //
     /* 1720856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1720867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1720870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1720873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1720876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720902 */     // MIs[0] policy
     /* 1720902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720912 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1720915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720936 */     // GIR_Coverage, 10435,
     /* 1720936 */     GIR_EraseRootFromParent_Done,
     /* 1720937 */   // Label 23514: @1720937
     /* 1720937 */   GIM_Try, /*On fail goto*//*Label 23515*/ GIMT_Encode4(1721023), // Rule ID 10438 //
     /* 1720942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1720953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1720956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1720959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1720962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720988 */     // MIs[0] policy
     /* 1720988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720998 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1721001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721022 */     // GIR_Coverage, 10438,
     /* 1721022 */     GIR_EraseRootFromParent_Done,
     /* 1721023 */   // Label 23515: @1721023
     /* 1721023 */   GIM_Try, /*On fail goto*//*Label 23516*/ GIMT_Encode4(1721109), // Rule ID 10439 //
     /* 1721028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1721039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1721042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1721045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1721048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721074 */     // MIs[0] policy
     /* 1721074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1721087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721108 */     // GIR_Coverage, 10439,
     /* 1721108 */     GIR_EraseRootFromParent_Done,
     /* 1721109 */   // Label 23516: @1721109
     /* 1721109 */   GIM_Try, /*On fail goto*//*Label 23517*/ GIMT_Encode4(1721195), // Rule ID 10442 //
     /* 1721114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1721125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1721128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1721131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1721134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721160 */     // MIs[0] policy
     /* 1721160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721170 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1721173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721194 */     // GIR_Coverage, 10442,
     /* 1721194 */     GIR_EraseRootFromParent_Done,
     /* 1721195 */   // Label 23517: @1721195
     /* 1721195 */   GIM_Try, /*On fail goto*//*Label 23518*/ GIMT_Encode4(1721281), // Rule ID 10443 //
     /* 1721200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1721211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1721214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1721217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1721220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721246 */     // MIs[0] policy
     /* 1721246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721256 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1721259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721280 */     // GIR_Coverage, 10443,
     /* 1721280 */     GIR_EraseRootFromParent_Done,
     /* 1721281 */   // Label 23518: @1721281
     /* 1721281 */   GIM_Try, /*On fail goto*//*Label 23519*/ GIMT_Encode4(1721367), // Rule ID 10446 //
     /* 1721286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1721297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1721300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1721303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1721306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721332 */     // MIs[0] policy
     /* 1721332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721342 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1721345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721366 */     // GIR_Coverage, 10446,
     /* 1721366 */     GIR_EraseRootFromParent_Done,
     /* 1721367 */   // Label 23519: @1721367
     /* 1721367 */   GIM_Try, /*On fail goto*//*Label 23520*/ GIMT_Encode4(1721453), // Rule ID 10447 //
     /* 1721372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1721383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1721386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1721389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1721392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721418 */     // MIs[0] policy
     /* 1721418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721428 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1721431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721452 */     // GIR_Coverage, 10447,
     /* 1721452 */     GIR_EraseRootFromParent_Done,
     /* 1721453 */   // Label 23520: @1721453
     /* 1721453 */   GIM_Try, /*On fail goto*//*Label 23521*/ GIMT_Encode4(1721539), // Rule ID 10450 //
     /* 1721458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1721469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1721472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1721475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1721478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721504 */     // MIs[0] policy
     /* 1721504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721514 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1721517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721538 */     // GIR_Coverage, 10450,
     /* 1721538 */     GIR_EraseRootFromParent_Done,
     /* 1721539 */   // Label 23521: @1721539
     /* 1721539 */   GIM_Try, /*On fail goto*//*Label 23522*/ GIMT_Encode4(1721625), // Rule ID 10451 //
     /* 1721544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1721555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1721558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1721561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1721564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721590 */     // MIs[0] policy
     /* 1721590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721600 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1721603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721624 */     // GIR_Coverage, 10451,
     /* 1721624 */     GIR_EraseRootFromParent_Done,
     /* 1721625 */   // Label 23522: @1721625
     /* 1721625 */   GIM_Try, /*On fail goto*//*Label 23523*/ GIMT_Encode4(1721711), // Rule ID 10454 //
     /* 1721630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1721641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1721644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1721647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1721650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721676 */     // MIs[0] policy
     /* 1721676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721686 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1721689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721710 */     // GIR_Coverage, 10454,
     /* 1721710 */     GIR_EraseRootFromParent_Done,
     /* 1721711 */   // Label 23523: @1721711
     /* 1721711 */   GIM_Try, /*On fail goto*//*Label 23524*/ GIMT_Encode4(1721797), // Rule ID 10455 //
     /* 1721716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1721727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1721730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1721733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1721736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721762 */     // MIs[0] policy
     /* 1721762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721772 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1721775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721796 */     // GIR_Coverage, 10455,
     /* 1721796 */     GIR_EraseRootFromParent_Done,
     /* 1721797 */   // Label 23524: @1721797
     /* 1721797 */   GIM_Try, /*On fail goto*//*Label 23525*/ GIMT_Encode4(1721883), // Rule ID 10458 //
     /* 1721802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1721813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1721816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1721819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1721822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721848 */     // MIs[0] policy
     /* 1721848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721858 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1721861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721882 */     // GIR_Coverage, 10458,
     /* 1721882 */     GIR_EraseRootFromParent_Done,
     /* 1721883 */   // Label 23525: @1721883
     /* 1721883 */   GIM_Try, /*On fail goto*//*Label 23526*/ GIMT_Encode4(1721969), // Rule ID 10459 //
     /* 1721888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1721899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1721902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1721905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1721908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721934 */     // MIs[0] policy
     /* 1721934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1721947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721968 */     // GIR_Coverage, 10459,
     /* 1721968 */     GIR_EraseRootFromParent_Done,
     /* 1721969 */   // Label 23526: @1721969
     /* 1721969 */   GIM_Try, /*On fail goto*//*Label 23527*/ GIMT_Encode4(1722055), // Rule ID 10462 //
     /* 1721974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1721977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1721985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1721988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1721991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1721994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722020 */     // MIs[0] policy
     /* 1722020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722030 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1722033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1722051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722054 */     // GIR_Coverage, 10462,
     /* 1722054 */     GIR_EraseRootFromParent_Done,
     /* 1722055 */   // Label 23527: @1722055
     /* 1722055 */   GIM_Try, /*On fail goto*//*Label 23528*/ GIMT_Encode4(1722141), // Rule ID 10463 //
     /* 1722060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1722063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1722071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1722074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1722077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1722080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722106 */     // MIs[0] policy
     /* 1722106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722116 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1722119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1722137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722140 */     // GIR_Coverage, 10463,
     /* 1722140 */     GIR_EraseRootFromParent_Done,
     /* 1722141 */   // Label 23528: @1722141
     /* 1722141 */   GIM_Try, /*On fail goto*//*Label 23529*/ GIMT_Encode4(1722227), // Rule ID 10466 //
     /* 1722146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1722157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1722160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1722163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1722166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722192 */     // MIs[0] policy
     /* 1722192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722202 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1722205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722226 */     // GIR_Coverage, 10466,
     /* 1722226 */     GIR_EraseRootFromParent_Done,
     /* 1722227 */   // Label 23529: @1722227
     /* 1722227 */   GIM_Try, /*On fail goto*//*Label 23530*/ GIMT_Encode4(1722313), // Rule ID 10467 //
     /* 1722232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1722243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1722246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1722249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1722252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722278 */     // MIs[0] policy
     /* 1722278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722288 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1722291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722312 */     // GIR_Coverage, 10467,
     /* 1722312 */     GIR_EraseRootFromParent_Done,
     /* 1722313 */   // Label 23530: @1722313
     /* 1722313 */   GIM_Try, /*On fail goto*//*Label 23531*/ GIMT_Encode4(1722399), // Rule ID 10470 //
     /* 1722318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1722329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1722332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1722335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1722338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1722341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722364 */     // MIs[0] policy
     /* 1722364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722374 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1722377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722398 */     // GIR_Coverage, 10470,
     /* 1722398 */     GIR_EraseRootFromParent_Done,
     /* 1722399 */   // Label 23531: @1722399
     /* 1722399 */   GIM_Try, /*On fail goto*//*Label 23532*/ GIMT_Encode4(1722485), // Rule ID 10471 //
     /* 1722404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1722415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1722418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1722421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1722424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1722427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722450 */     // MIs[0] policy
     /* 1722450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722460 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1722463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722484 */     // GIR_Coverage, 10471,
     /* 1722484 */     GIR_EraseRootFromParent_Done,
     /* 1722485 */   // Label 23532: @1722485
     /* 1722485 */   GIM_Try, /*On fail goto*//*Label 23533*/ GIMT_Encode4(1722571), // Rule ID 10474 //
     /* 1722490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1722501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1722504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1722507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1722510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1722513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1722520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722536 */     // MIs[0] policy
     /* 1722536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722546 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1722549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722570 */     // GIR_Coverage, 10474,
     /* 1722570 */     GIR_EraseRootFromParent_Done,
     /* 1722571 */   // Label 23533: @1722571
     /* 1722571 */   GIM_Try, /*On fail goto*//*Label 23534*/ GIMT_Encode4(1722657), // Rule ID 10475 //
     /* 1722576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1722587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1722590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1722593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1722596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1722599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1722606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722622 */     // MIs[0] policy
     /* 1722622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722632 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1722635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722656 */     // GIR_Coverage, 10475,
     /* 1722656 */     GIR_EraseRootFromParent_Done,
     /* 1722657 */   // Label 23534: @1722657
     /* 1722657 */   GIM_Try, /*On fail goto*//*Label 23535*/ GIMT_Encode4(1722743), // Rule ID 10478 //
     /* 1722662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1722673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1722676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1722679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1722682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1722685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722708 */     // MIs[0] policy
     /* 1722708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1722721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722742 */     // GIR_Coverage, 10478,
     /* 1722742 */     GIR_EraseRootFromParent_Done,
     /* 1722743 */   // Label 23535: @1722743
     /* 1722743 */   GIM_Try, /*On fail goto*//*Label 23536*/ GIMT_Encode4(1722829), // Rule ID 10479 //
     /* 1722748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1722759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1722762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1722765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1722768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1722771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722794 */     // MIs[0] policy
     /* 1722794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722804 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1722807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722828 */     // GIR_Coverage, 10479,
     /* 1722828 */     GIR_EraseRootFromParent_Done,
     /* 1722829 */   // Label 23536: @1722829
     /* 1722829 */   GIM_Try, /*On fail goto*//*Label 23537*/ GIMT_Encode4(1722915), // Rule ID 10482 //
     /* 1722834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1722845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1722848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1722851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1722854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722880 */     // MIs[0] policy
     /* 1722880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722890 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1722893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722914 */     // GIR_Coverage, 10482,
     /* 1722914 */     GIR_EraseRootFromParent_Done,
     /* 1722915 */   // Label 23537: @1722915
     /* 1722915 */   GIM_Try, /*On fail goto*//*Label 23538*/ GIMT_Encode4(1723001), // Rule ID 10483 //
     /* 1722920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1722931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1722934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1722937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1722940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722966 */     // MIs[0] policy
     /* 1722966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722976 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1722979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723000 */     // GIR_Coverage, 10483,
     /* 1723000 */     GIR_EraseRootFromParent_Done,
     /* 1723001 */   // Label 23538: @1723001
     /* 1723001 */   GIM_Try, /*On fail goto*//*Label 23539*/ GIMT_Encode4(1723087), // Rule ID 10486 //
     /* 1723006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1723017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1723020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1723023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1723026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1723029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723052 */     // MIs[0] policy
     /* 1723052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723062 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1723065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723086 */     // GIR_Coverage, 10486,
     /* 1723086 */     GIR_EraseRootFromParent_Done,
     /* 1723087 */   // Label 23539: @1723087
     /* 1723087 */   GIM_Try, /*On fail goto*//*Label 23540*/ GIMT_Encode4(1723173), // Rule ID 10487 //
     /* 1723092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1723103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1723106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1723109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1723112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1723115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723138 */     // MIs[0] policy
     /* 1723138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723148 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1723151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723172 */     // GIR_Coverage, 10487,
     /* 1723172 */     GIR_EraseRootFromParent_Done,
     /* 1723173 */   // Label 23540: @1723173
     /* 1723173 */   GIM_Try, /*On fail goto*//*Label 23541*/ GIMT_Encode4(1723259), // Rule ID 10490 //
     /* 1723178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1723189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1723192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1723195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1723198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723224 */     // MIs[0] policy
     /* 1723224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1723237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723258 */     // GIR_Coverage, 10490,
     /* 1723258 */     GIR_EraseRootFromParent_Done,
     /* 1723259 */   // Label 23541: @1723259
     /* 1723259 */   GIM_Try, /*On fail goto*//*Label 23542*/ GIMT_Encode4(1723345), // Rule ID 10491 //
     /* 1723264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1723275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1723278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1723281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1723284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723310 */     // MIs[0] policy
     /* 1723310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723320 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1723323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723344 */     // GIR_Coverage, 10491,
     /* 1723344 */     GIR_EraseRootFromParent_Done,
     /* 1723345 */   // Label 23542: @1723345
     /* 1723345 */   GIM_Try, /*On fail goto*//*Label 23543*/ GIMT_Encode4(1723431), // Rule ID 10494 //
     /* 1723350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1723361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1723364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1723367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1723370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723396 */     // MIs[0] policy
     /* 1723396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723406 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1723409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723430 */     // GIR_Coverage, 10494,
     /* 1723430 */     GIR_EraseRootFromParent_Done,
     /* 1723431 */   // Label 23543: @1723431
     /* 1723431 */   GIM_Try, /*On fail goto*//*Label 23544*/ GIMT_Encode4(1723517), // Rule ID 10495 //
     /* 1723436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1723447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1723450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1723453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1723456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723482 */     // MIs[0] policy
     /* 1723482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723492 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1723495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723516 */     // GIR_Coverage, 10495,
     /* 1723516 */     GIR_EraseRootFromParent_Done,
     /* 1723517 */   // Label 23544: @1723517
     /* 1723517 */   GIM_Try, /*On fail goto*//*Label 23545*/ GIMT_Encode4(1723603), // Rule ID 10498 //
     /* 1723522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1723533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1723536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1723539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1723542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723568 */     // MIs[0] policy
     /* 1723568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723578 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1723581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723602 */     // GIR_Coverage, 10498,
     /* 1723602 */     GIR_EraseRootFromParent_Done,
     /* 1723603 */   // Label 23545: @1723603
     /* 1723603 */   GIM_Try, /*On fail goto*//*Label 23546*/ GIMT_Encode4(1723689), // Rule ID 10499 //
     /* 1723608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1723619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1723622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1723625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1723628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723654 */     // MIs[0] policy
     /* 1723654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723664 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1723667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723688 */     // GIR_Coverage, 10499,
     /* 1723688 */     GIR_EraseRootFromParent_Done,
     /* 1723689 */   // Label 23546: @1723689
     /* 1723689 */   GIM_Try, /*On fail goto*//*Label 23547*/ GIMT_Encode4(1723775), // Rule ID 10502 //
     /* 1723694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1723697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1723705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1723708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1723711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1723714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1723717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723740 */     // MIs[0] policy
     /* 1723740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723750 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1723753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723774 */     // GIR_Coverage, 10502,
     /* 1723774 */     GIR_EraseRootFromParent_Done,
     /* 1723775 */   // Label 23547: @1723775
     /* 1723775 */   GIM_Try, /*On fail goto*//*Label 23548*/ GIMT_Encode4(1723861), // Rule ID 10503 //
     /* 1723780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1723783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1723791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1723794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1723797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1723800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1723803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723826 */     // MIs[0] policy
     /* 1723826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1723839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723860 */     // GIR_Coverage, 10503,
     /* 1723860 */     GIR_EraseRootFromParent_Done,
     /* 1723861 */   // Label 23548: @1723861
     /* 1723861 */   GIM_Try, /*On fail goto*//*Label 23549*/ GIMT_Encode4(1723947), // Rule ID 10506 //
     /* 1723866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1723869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1723877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1723880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1723883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1723886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723912 */     // MIs[0] policy
     /* 1723912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723922 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1723925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723946 */     // GIR_Coverage, 10506,
     /* 1723946 */     GIR_EraseRootFromParent_Done,
     /* 1723947 */   // Label 23549: @1723947
     /* 1723947 */   GIM_Try, /*On fail goto*//*Label 23550*/ GIMT_Encode4(1724033), // Rule ID 10507 //
     /* 1723952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1723955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1723963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1723966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1723969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1723972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723998 */     // MIs[0] policy
     /* 1723998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724008 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1724011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724032 */     // GIR_Coverage, 10507,
     /* 1724032 */     GIR_EraseRootFromParent_Done,
     /* 1724033 */   // Label 23550: @1724033
     /* 1724033 */   GIM_Try, /*On fail goto*//*Label 23551*/ GIMT_Encode4(1724119), // Rule ID 10510 //
     /* 1724038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1724041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1724049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1724052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1724055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1724058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724084 */     // MIs[0] policy
     /* 1724084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724094 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1724097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724118 */     // GIR_Coverage, 10510,
     /* 1724118 */     GIR_EraseRootFromParent_Done,
     /* 1724119 */   // Label 23551: @1724119
     /* 1724119 */   GIM_Try, /*On fail goto*//*Label 23552*/ GIMT_Encode4(1724205), // Rule ID 10511 //
     /* 1724124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1724127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1724135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1724138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1724141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1724144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724170 */     // MIs[0] policy
     /* 1724170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724180 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1724183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724204 */     // GIR_Coverage, 10511,
     /* 1724204 */     GIR_EraseRootFromParent_Done,
     /* 1724205 */   // Label 23552: @1724205
     /* 1724205 */   GIM_Try, /*On fail goto*//*Label 23553*/ GIMT_Encode4(1724291), // Rule ID 10514 //
     /* 1724210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1724221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1724224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1724227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724256 */     // MIs[0] policy
     /* 1724256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724266 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1724269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724290 */     // GIR_Coverage, 10514,
     /* 1724290 */     GIR_EraseRootFromParent_Done,
     /* 1724291 */   // Label 23553: @1724291
     /* 1724291 */   GIM_Try, /*On fail goto*//*Label 23554*/ GIMT_Encode4(1724377), // Rule ID 10515 //
     /* 1724296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1724307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1724310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1724313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724342 */     // MIs[0] policy
     /* 1724342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724352 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1724355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724376 */     // GIR_Coverage, 10515,
     /* 1724376 */     GIR_EraseRootFromParent_Done,
     /* 1724377 */   // Label 23554: @1724377
     /* 1724377 */   GIM_Try, /*On fail goto*//*Label 23555*/ GIMT_Encode4(1724463), // Rule ID 10518 //
     /* 1724382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1724393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1724396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1724399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724428 */     // MIs[0] policy
     /* 1724428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724438 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1724441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724462 */     // GIR_Coverage, 10518,
     /* 1724462 */     GIR_EraseRootFromParent_Done,
     /* 1724463 */   // Label 23555: @1724463
     /* 1724463 */   GIM_Try, /*On fail goto*//*Label 23556*/ GIMT_Encode4(1724549), // Rule ID 10519 //
     /* 1724468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1724479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1724482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1724485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724514 */     // MIs[0] policy
     /* 1724514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724524 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1724527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724548 */     // GIR_Coverage, 10519,
     /* 1724548 */     GIR_EraseRootFromParent_Done,
     /* 1724549 */   // Label 23556: @1724549
     /* 1724549 */   GIM_Try, /*On fail goto*//*Label 23557*/ GIMT_Encode4(1724635), // Rule ID 10522 //
     /* 1724554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1724565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1724568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1724571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724600 */     // MIs[0] policy
     /* 1724600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724610 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1724613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724634 */     // GIR_Coverage, 10522,
     /* 1724634 */     GIR_EraseRootFromParent_Done,
     /* 1724635 */   // Label 23557: @1724635
     /* 1724635 */   GIM_Try, /*On fail goto*//*Label 23558*/ GIMT_Encode4(1724721), // Rule ID 10523 //
     /* 1724640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1724651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1724654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1724657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724686 */     // MIs[0] policy
     /* 1724686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724696 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1724699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724720 */     // GIR_Coverage, 10523,
     /* 1724720 */     GIR_EraseRootFromParent_Done,
     /* 1724721 */   // Label 23558: @1724721
     /* 1724721 */   GIM_Try, /*On fail goto*//*Label 23559*/ GIMT_Encode4(1724807), // Rule ID 10526 //
     /* 1724726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1724737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1724740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1724743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724772 */     // MIs[0] policy
     /* 1724772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724782 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1724785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724806 */     // GIR_Coverage, 10526,
     /* 1724806 */     GIR_EraseRootFromParent_Done,
     /* 1724807 */   // Label 23559: @1724807
     /* 1724807 */   GIM_Try, /*On fail goto*//*Label 23560*/ GIMT_Encode4(1724893), // Rule ID 10527 //
     /* 1724812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1724823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1724826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1724829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724858 */     // MIs[0] policy
     /* 1724858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1724871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724892 */     // GIR_Coverage, 10527,
     /* 1724892 */     GIR_EraseRootFromParent_Done,
     /* 1724893 */   // Label 23560: @1724893
     /* 1724893 */   GIM_Try, /*On fail goto*//*Label 23561*/ GIMT_Encode4(1724979), // Rule ID 10530 //
     /* 1724898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1724909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1724912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1724915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724944 */     // MIs[0] policy
     /* 1724944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724954 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1724957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724978 */     // GIR_Coverage, 10530,
     /* 1724978 */     GIR_EraseRootFromParent_Done,
     /* 1724979 */   // Label 23561: @1724979
     /* 1724979 */   GIM_Try, /*On fail goto*//*Label 23562*/ GIMT_Encode4(1725065), // Rule ID 10531 //
     /* 1724984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1724995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1724998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1725001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1725004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725030 */     // MIs[0] policy
     /* 1725030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725040 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1725043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725064 */     // GIR_Coverage, 10531,
     /* 1725064 */     GIR_EraseRootFromParent_Done,
     /* 1725065 */   // Label 23562: @1725065
     /* 1725065 */   GIM_Try, /*On fail goto*//*Label 23563*/ GIMT_Encode4(1725151), // Rule ID 10534 //
     /* 1725070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1725078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1725081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1725084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1725087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1725090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725116 */     // MIs[0] policy
     /* 1725116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725126 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1725129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725150 */     // GIR_Coverage, 10534,
     /* 1725150 */     GIR_EraseRootFromParent_Done,
     /* 1725151 */   // Label 23563: @1725151
     /* 1725151 */   GIM_Try, /*On fail goto*//*Label 23564*/ GIMT_Encode4(1725237), // Rule ID 10535 //
     /* 1725156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1725164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1725167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1725170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1725173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1725176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725202 */     // MIs[0] policy
     /* 1725202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725212 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1725215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725236 */     // GIR_Coverage, 10535,
     /* 1725236 */     GIR_EraseRootFromParent_Done,
     /* 1725237 */   // Label 23564: @1725237
     /* 1725237 */   GIM_Try, /*On fail goto*//*Label 23565*/ GIMT_Encode4(1725323), // Rule ID 10538 //
     /* 1725242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1725250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1725253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1725256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1725259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1725262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725288 */     // MIs[0] policy
     /* 1725288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725298 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1725301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725322 */     // GIR_Coverage, 10538,
     /* 1725322 */     GIR_EraseRootFromParent_Done,
     /* 1725323 */   // Label 23565: @1725323
     /* 1725323 */   GIM_Try, /*On fail goto*//*Label 23566*/ GIMT_Encode4(1725409), // Rule ID 10539 //
     /* 1725328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1725336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1725339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1725342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1725345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1725348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725374 */     // MIs[0] policy
     /* 1725374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725384 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1725387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725408 */     // GIR_Coverage, 10539,
     /* 1725408 */     GIR_EraseRootFromParent_Done,
     /* 1725409 */   // Label 23566: @1725409
     /* 1725409 */   GIM_Try, /*On fail goto*//*Label 23567*/ GIMT_Encode4(1725495), // Rule ID 10542 //
     /* 1725414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1725422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1725425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1725428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1725431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1725434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725460 */     // MIs[0] policy
     /* 1725460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725470 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1725473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725494 */     // GIR_Coverage, 10542,
     /* 1725494 */     GIR_EraseRootFromParent_Done,
     /* 1725495 */   // Label 23567: @1725495
     /* 1725495 */   GIM_Try, /*On fail goto*//*Label 23568*/ GIMT_Encode4(1725581), // Rule ID 10543 //
     /* 1725500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1725508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1725511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1725514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1725517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1725520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725546 */     // MIs[0] policy
     /* 1725546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725556 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1725559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725580 */     // GIR_Coverage, 10543,
     /* 1725580 */     GIR_EraseRootFromParent_Done,
     /* 1725581 */   // Label 23568: @1725581
     /* 1725581 */   GIM_Try, /*On fail goto*//*Label 23569*/ GIMT_Encode4(1725667), // Rule ID 10546 //
     /* 1725586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1725594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1725597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1725600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1725603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1725606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725632 */     // MIs[0] policy
     /* 1725632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725642 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1725645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725666 */     // GIR_Coverage, 10546,
     /* 1725666 */     GIR_EraseRootFromParent_Done,
     /* 1725667 */   // Label 23569: @1725667
     /* 1725667 */   GIM_Try, /*On fail goto*//*Label 23570*/ GIMT_Encode4(1725753), // Rule ID 10547 //
     /* 1725672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1725680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1725683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1725686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1725689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1725692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725718 */     // MIs[0] policy
     /* 1725718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725728 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1725731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725752 */     // GIR_Coverage, 10547,
     /* 1725752 */     GIR_EraseRootFromParent_Done,
     /* 1725753 */   // Label 23570: @1725753
     /* 1725753 */   GIM_Try, /*On fail goto*//*Label 23571*/ GIMT_Encode4(1725839), // Rule ID 10550 //
     /* 1725758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1725761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1725766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1725769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1725772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1725775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1725778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725804 */     // MIs[0] policy
     /* 1725804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725814 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1725817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725838 */     // GIR_Coverage, 10550,
     /* 1725838 */     GIR_EraseRootFromParent_Done,
     /* 1725839 */   // Label 23571: @1725839
     /* 1725839 */   GIM_Try, /*On fail goto*//*Label 23572*/ GIMT_Encode4(1725925), // Rule ID 10551 //
     /* 1725844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1725847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1725852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1725855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1725858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1725861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1725864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725890 */     // MIs[0] policy
     /* 1725890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725900 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1725903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725924 */     // GIR_Coverage, 10551,
     /* 1725924 */     GIR_EraseRootFromParent_Done,
     /* 1725925 */   // Label 23572: @1725925
     /* 1725925 */   GIM_Try, /*On fail goto*//*Label 23573*/ GIMT_Encode4(1726011), // Rule ID 10554 //
     /* 1725930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1725938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1725941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1725944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1725947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1725950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1725953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1725960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725976 */     // MIs[0] policy
     /* 1725976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725986 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1725989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726010 */     // GIR_Coverage, 10554,
     /* 1726010 */     GIR_EraseRootFromParent_Done,
     /* 1726011 */   // Label 23573: @1726011
     /* 1726011 */   GIM_Try, /*On fail goto*//*Label 23574*/ GIMT_Encode4(1726097), // Rule ID 10555 //
     /* 1726016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1726024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1726027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1726030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1726033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1726036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1726039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726062 */     // MIs[0] policy
     /* 1726062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726072 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1726075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726096 */     // GIR_Coverage, 10555,
     /* 1726096 */     GIR_EraseRootFromParent_Done,
     /* 1726097 */   // Label 23574: @1726097
     /* 1726097 */   GIM_Try, /*On fail goto*//*Label 23575*/ GIMT_Encode4(1726183), // Rule ID 10558 //
     /* 1726102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1726110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1726113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1726116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1726119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1726122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726148 */     // MIs[0] policy
     /* 1726148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726158 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1726161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726182 */     // GIR_Coverage, 10558,
     /* 1726182 */     GIR_EraseRootFromParent_Done,
     /* 1726183 */   // Label 23575: @1726183
     /* 1726183 */   GIM_Try, /*On fail goto*//*Label 23576*/ GIMT_Encode4(1726269), // Rule ID 10559 //
     /* 1726188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1726196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1726199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1726202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1726205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1726208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726234 */     // MIs[0] policy
     /* 1726234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726244 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1726247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726268 */     // GIR_Coverage, 10559,
     /* 1726268 */     GIR_EraseRootFromParent_Done,
     /* 1726269 */   // Label 23576: @1726269
     /* 1726269 */   GIM_Try, /*On fail goto*//*Label 23577*/ GIMT_Encode4(1726355), // Rule ID 10562 //
     /* 1726274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1726282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1726285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1726288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1726291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1726294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1726297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726320 */     // MIs[0] policy
     /* 1726320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726330 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1726333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726354 */     // GIR_Coverage, 10562,
     /* 1726354 */     GIR_EraseRootFromParent_Done,
     /* 1726355 */   // Label 23577: @1726355
     /* 1726355 */   GIM_Try, /*On fail goto*//*Label 23578*/ GIMT_Encode4(1726441), // Rule ID 10563 //
     /* 1726360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1726368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1726371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1726374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1726377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1726380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1726383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726406 */     // MIs[0] policy
     /* 1726406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726416 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1726419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726440 */     // GIR_Coverage, 10563,
     /* 1726440 */     GIR_EraseRootFromParent_Done,
     /* 1726441 */   // Label 23578: @1726441
     /* 1726441 */   GIM_Try, /*On fail goto*//*Label 23579*/ GIMT_Encode4(1726527), // Rule ID 10566 //
     /* 1726446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1726454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1726457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1726460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1726463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1726466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726492 */     // MIs[0] policy
     /* 1726492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1726505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726526 */     // GIR_Coverage, 10566,
     /* 1726526 */     GIR_EraseRootFromParent_Done,
     /* 1726527 */   // Label 23579: @1726527
     /* 1726527 */   GIM_Try, /*On fail goto*//*Label 23580*/ GIMT_Encode4(1726613), // Rule ID 10567 //
     /* 1726532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1726540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1726543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1726546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1726549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1726552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726578 */     // MIs[0] policy
     /* 1726578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726588 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1726591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726612 */     // GIR_Coverage, 10567,
     /* 1726612 */     GIR_EraseRootFromParent_Done,
     /* 1726613 */   // Label 23580: @1726613
     /* 1726613 */   GIM_Try, /*On fail goto*//*Label 23581*/ GIMT_Encode4(1726699), // Rule ID 10570 //
     /* 1726618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1726626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1726629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1726632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1726635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1726638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1726641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726664 */     // MIs[0] policy
     /* 1726664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726674 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1726677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726698 */     // GIR_Coverage, 10570,
     /* 1726698 */     GIR_EraseRootFromParent_Done,
     /* 1726699 */   // Label 23581: @1726699
     /* 1726699 */   GIM_Try, /*On fail goto*//*Label 23582*/ GIMT_Encode4(1726785), // Rule ID 10571 //
     /* 1726704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1726712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1726715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1726718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1726721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1726724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1726727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726750 */     // MIs[0] policy
     /* 1726750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726760 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1726763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726784 */     // GIR_Coverage, 10571,
     /* 1726784 */     GIR_EraseRootFromParent_Done,
     /* 1726785 */   // Label 23582: @1726785
     /* 1726785 */   GIM_Try, /*On fail goto*//*Label 23583*/ GIMT_Encode4(1726871), // Rule ID 10574 //
     /* 1726790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1726798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1726801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1726804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1726807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1726810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726836 */     // MIs[0] policy
     /* 1726836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726846 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1726849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726870 */     // GIR_Coverage, 10574,
     /* 1726870 */     GIR_EraseRootFromParent_Done,
     /* 1726871 */   // Label 23583: @1726871
     /* 1726871 */   GIM_Try, /*On fail goto*//*Label 23584*/ GIMT_Encode4(1726957), // Rule ID 10575 //
     /* 1726876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1726884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1726887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1726890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1726893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1726896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726922 */     // MIs[0] policy
     /* 1726922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726932 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1726935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726956 */     // GIR_Coverage, 10575,
     /* 1726956 */     GIR_EraseRootFromParent_Done,
     /* 1726957 */   // Label 23584: @1726957
     /* 1726957 */   GIM_Try, /*On fail goto*//*Label 23585*/ GIMT_Encode4(1727043), // Rule ID 10578 //
     /* 1726962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1726970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1726973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1726976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1726979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1726982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1726985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727008 */     // MIs[0] policy
     /* 1727008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727018 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1727021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727042 */     // GIR_Coverage, 10578,
     /* 1727042 */     GIR_EraseRootFromParent_Done,
     /* 1727043 */   // Label 23585: @1727043
     /* 1727043 */   GIM_Try, /*On fail goto*//*Label 23586*/ GIMT_Encode4(1727129), // Rule ID 10579 //
     /* 1727048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1727056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1727059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1727062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1727065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1727068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727094 */     // MIs[0] policy
     /* 1727094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727104 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1727107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727128 */     // GIR_Coverage, 10579,
     /* 1727128 */     GIR_EraseRootFromParent_Done,
     /* 1727129 */   // Label 23586: @1727129
     /* 1727129 */   GIM_Try, /*On fail goto*//*Label 23587*/ GIMT_Encode4(1727215), // Rule ID 10582 //
     /* 1727134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1727142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1727145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1727148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1727151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1727154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727180 */     // MIs[0] policy
     /* 1727180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727190 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1727193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727214 */     // GIR_Coverage, 10582,
     /* 1727214 */     GIR_EraseRootFromParent_Done,
     /* 1727215 */   // Label 23587: @1727215
     /* 1727215 */   GIM_Try, /*On fail goto*//*Label 23588*/ GIMT_Encode4(1727301), // Rule ID 10583 //
     /* 1727220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1727228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1727231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1727234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1727237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1727240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727266 */     // MIs[0] policy
     /* 1727266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727276 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1727279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727300 */     // GIR_Coverage, 10583,
     /* 1727300 */     GIR_EraseRootFromParent_Done,
     /* 1727301 */   // Label 23588: @1727301
     /* 1727301 */   GIM_Try, /*On fail goto*//*Label 23589*/ GIMT_Encode4(1727387), // Rule ID 10586 //
     /* 1727306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1727314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1727317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1727320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1727323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1727326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727352 */     // MIs[0] policy
     /* 1727352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727362 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1727365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727386 */     // GIR_Coverage, 10586,
     /* 1727386 */     GIR_EraseRootFromParent_Done,
     /* 1727387 */   // Label 23589: @1727387
     /* 1727387 */   GIM_Try, /*On fail goto*//*Label 23590*/ GIMT_Encode4(1727473), // Rule ID 10587 //
     /* 1727392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1727400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1727403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1727406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1727409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1727412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727438 */     // MIs[0] policy
     /* 1727438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727448 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1727451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727472 */     // GIR_Coverage, 10587,
     /* 1727472 */     GIR_EraseRootFromParent_Done,
     /* 1727473 */   // Label 23590: @1727473
     /* 1727473 */   GIM_Try, /*On fail goto*//*Label 23591*/ GIMT_Encode4(1727559), // Rule ID 10590 //
     /* 1727478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1727481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1727486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1727489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1727492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1727495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1727498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1727501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727524 */     // MIs[0] policy
     /* 1727524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1727537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727558 */     // GIR_Coverage, 10590,
     /* 1727558 */     GIR_EraseRootFromParent_Done,
     /* 1727559 */   // Label 23591: @1727559
     /* 1727559 */   GIM_Try, /*On fail goto*//*Label 23592*/ GIMT_Encode4(1727645), // Rule ID 10591 //
     /* 1727564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1727567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1727572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1727575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1727578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1727581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1727584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1727587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727610 */     // MIs[0] policy
     /* 1727610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727620 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1727623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727644 */     // GIR_Coverage, 10591,
     /* 1727644 */     GIR_EraseRootFromParent_Done,
     /* 1727645 */   // Label 23592: @1727645
     /* 1727645 */   GIM_Try, /*On fail goto*//*Label 23593*/ GIMT_Encode4(1727731), // Rule ID 10594 //
     /* 1727650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1727653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1727658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1727661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1727664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1727667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1727670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727696 */     // MIs[0] policy
     /* 1727696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727706 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1727709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727730 */     // GIR_Coverage, 10594,
     /* 1727730 */     GIR_EraseRootFromParent_Done,
     /* 1727731 */   // Label 23593: @1727731
     /* 1727731 */   GIM_Try, /*On fail goto*//*Label 23594*/ GIMT_Encode4(1727817), // Rule ID 10595 //
     /* 1727736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1727739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1727744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1727747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1727750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1727753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1727756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727782 */     // MIs[0] policy
     /* 1727782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727792 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1727795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727816 */     // GIR_Coverage, 10595,
     /* 1727816 */     GIR_EraseRootFromParent_Done,
     /* 1727817 */   // Label 23594: @1727817
     /* 1727817 */   GIM_Try, /*On fail goto*//*Label 23595*/ GIMT_Encode4(1727903), // Rule ID 10598 //
     /* 1727822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1727825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1727830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1727833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1727836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1727839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1727842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727868 */     // MIs[0] policy
     /* 1727868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727878 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1727881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727902 */     // GIR_Coverage, 10598,
     /* 1727902 */     GIR_EraseRootFromParent_Done,
     /* 1727903 */   // Label 23595: @1727903
     /* 1727903 */   GIM_Try, /*On fail goto*//*Label 23596*/ GIMT_Encode4(1727989), // Rule ID 10599 //
     /* 1727908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1727911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1727916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1727919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1727922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1727925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1727928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727954 */     // MIs[0] policy
     /* 1727954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727964 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1727967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727988 */     // GIR_Coverage, 10599,
     /* 1727988 */     GIR_EraseRootFromParent_Done,
     /* 1727989 */   // Label 23596: @1727989
     /* 1727989 */   GIM_Try, /*On fail goto*//*Label 23597*/ GIMT_Encode4(1728075), // Rule ID 10602 //
     /* 1727994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1728005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1728008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1728011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1728014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728040 */     // MIs[0] policy
     /* 1728040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728050 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1728053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728074 */     // GIR_Coverage, 10602,
     /* 1728074 */     GIR_EraseRootFromParent_Done,
     /* 1728075 */   // Label 23597: @1728075
     /* 1728075 */   GIM_Try, /*On fail goto*//*Label 23598*/ GIMT_Encode4(1728161), // Rule ID 10603 //
     /* 1728080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1728091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1728094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1728097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1728100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728126 */     // MIs[0] policy
     /* 1728126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728136 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1728139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728160 */     // GIR_Coverage, 10603,
     /* 1728160 */     GIR_EraseRootFromParent_Done,
     /* 1728161 */   // Label 23598: @1728161
     /* 1728161 */   GIM_Try, /*On fail goto*//*Label 23599*/ GIMT_Encode4(1728247), // Rule ID 10606 //
     /* 1728166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1728177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1728180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1728183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1728186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728212 */     // MIs[0] policy
     /* 1728212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728222 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1728225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728246 */     // GIR_Coverage, 10606,
     /* 1728246 */     GIR_EraseRootFromParent_Done,
     /* 1728247 */   // Label 23599: @1728247
     /* 1728247 */   GIM_Try, /*On fail goto*//*Label 23600*/ GIMT_Encode4(1728333), // Rule ID 10607 //
     /* 1728252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1728263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1728266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1728269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1728272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728298 */     // MIs[0] policy
     /* 1728298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728308 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1728311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728332 */     // GIR_Coverage, 10607,
     /* 1728332 */     GIR_EraseRootFromParent_Done,
     /* 1728333 */   // Label 23600: @1728333
     /* 1728333 */   GIM_Try, /*On fail goto*//*Label 23601*/ GIMT_Encode4(1728419), // Rule ID 10610 //
     /* 1728338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1728349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1728352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1728355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1728358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728384 */     // MIs[0] policy
     /* 1728384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728394 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1728397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728418 */     // GIR_Coverage, 10610,
     /* 1728418 */     GIR_EraseRootFromParent_Done,
     /* 1728419 */   // Label 23601: @1728419
     /* 1728419 */   GIM_Try, /*On fail goto*//*Label 23602*/ GIMT_Encode4(1728505), // Rule ID 10611 //
     /* 1728424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1728435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1728438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1728441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1728444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728470 */     // MIs[0] policy
     /* 1728470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728480 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1728483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728504 */     // GIR_Coverage, 10611,
     /* 1728504 */     GIR_EraseRootFromParent_Done,
     /* 1728505 */   // Label 23602: @1728505
     /* 1728505 */   GIM_Try, /*On fail goto*//*Label 23603*/ GIMT_Encode4(1728591), // Rule ID 10614 //
     /* 1728510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1728521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1728524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1728527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1728530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728556 */     // MIs[0] policy
     /* 1728556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728566 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1728569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728590 */     // GIR_Coverage, 10614,
     /* 1728590 */     GIR_EraseRootFromParent_Done,
     /* 1728591 */   // Label 23603: @1728591
     /* 1728591 */   GIM_Try, /*On fail goto*//*Label 23604*/ GIMT_Encode4(1728677), // Rule ID 10615 //
     /* 1728596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1728607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1728610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1728613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1728616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728642 */     // MIs[0] policy
     /* 1728642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728652 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1728655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728676 */     // GIR_Coverage, 10615,
     /* 1728676 */     GIR_EraseRootFromParent_Done,
     /* 1728677 */   // Label 23604: @1728677
     /* 1728677 */   GIM_Try, /*On fail goto*//*Label 23605*/ GIMT_Encode4(1728763), // Rule ID 10618 //
     /* 1728682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1728693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1728696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1728699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1728702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728728 */     // MIs[0] policy
     /* 1728728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728738 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1728741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728762 */     // GIR_Coverage, 10618,
     /* 1728762 */     GIR_EraseRootFromParent_Done,
     /* 1728763 */   // Label 23605: @1728763
     /* 1728763 */   GIM_Try, /*On fail goto*//*Label 23606*/ GIMT_Encode4(1728849), // Rule ID 10619 //
     /* 1728768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1728779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1728782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1728785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1728788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728814 */     // MIs[0] policy
     /* 1728814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728824 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1728827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728848 */     // GIR_Coverage, 10619,
     /* 1728848 */     GIR_EraseRootFromParent_Done,
     /* 1728849 */   // Label 23606: @1728849
     /* 1728849 */   GIM_Try, /*On fail goto*//*Label 23607*/ GIMT_Encode4(1728935), // Rule ID 10622 //
     /* 1728854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1728865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1728868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1728871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1728874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728900 */     // MIs[0] policy
     /* 1728900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728910 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1728913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728934 */     // GIR_Coverage, 10622,
     /* 1728934 */     GIR_EraseRootFromParent_Done,
     /* 1728935 */   // Label 23607: @1728935
     /* 1728935 */   GIM_Try, /*On fail goto*//*Label 23608*/ GIMT_Encode4(1729021), // Rule ID 10623 //
     /* 1728940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1728951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1728954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1728957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1728960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728986 */     // MIs[0] policy
     /* 1728986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728996 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1728999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729020 */     // GIR_Coverage, 10623,
     /* 1729020 */     GIR_EraseRootFromParent_Done,
     /* 1729021 */   // Label 23608: @1729021
     /* 1729021 */   GIM_Try, /*On fail goto*//*Label 23609*/ GIMT_Encode4(1729107), // Rule ID 10626 //
     /* 1729026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1729037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1729040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1729043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1729046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729072 */     // MIs[0] policy
     /* 1729072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729082 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1729085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729106 */     // GIR_Coverage, 10626,
     /* 1729106 */     GIR_EraseRootFromParent_Done,
     /* 1729107 */   // Label 23609: @1729107
     /* 1729107 */   GIM_Try, /*On fail goto*//*Label 23610*/ GIMT_Encode4(1729193), // Rule ID 10627 //
     /* 1729112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1729123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1729126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1729129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1729132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729158 */     // MIs[0] policy
     /* 1729158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729168 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1729171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729192 */     // GIR_Coverage, 10627,
     /* 1729192 */     GIR_EraseRootFromParent_Done,
     /* 1729193 */   // Label 23610: @1729193
     /* 1729193 */   GIM_Try, /*On fail goto*//*Label 23611*/ GIMT_Encode4(1729279), // Rule ID 10630 //
     /* 1729198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1729209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1729212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1729215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1729218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729244 */     // MIs[0] policy
     /* 1729244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729254 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1729257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729278 */     // GIR_Coverage, 10630,
     /* 1729278 */     GIR_EraseRootFromParent_Done,
     /* 1729279 */   // Label 23611: @1729279
     /* 1729279 */   GIM_Try, /*On fail goto*//*Label 23612*/ GIMT_Encode4(1729365), // Rule ID 10631 //
     /* 1729284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1729295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1729298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1729301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1729304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729330 */     // MIs[0] policy
     /* 1729330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729340 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1729343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729364 */     // GIR_Coverage, 10631,
     /* 1729364 */     GIR_EraseRootFromParent_Done,
     /* 1729365 */   // Label 23612: @1729365
     /* 1729365 */   GIM_Try, /*On fail goto*//*Label 23613*/ GIMT_Encode4(1729451), // Rule ID 10634 //
     /* 1729370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1729381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1729384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1729387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1729390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729416 */     // MIs[0] policy
     /* 1729416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729426 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1729429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729450 */     // GIR_Coverage, 10634,
     /* 1729450 */     GIR_EraseRootFromParent_Done,
     /* 1729451 */   // Label 23613: @1729451
     /* 1729451 */   GIM_Try, /*On fail goto*//*Label 23614*/ GIMT_Encode4(1729537), // Rule ID 10635 //
     /* 1729456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1729467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1729470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1729473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1729476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729502 */     // MIs[0] policy
     /* 1729502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729512 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1729515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729536 */     // GIR_Coverage, 10635,
     /* 1729536 */     GIR_EraseRootFromParent_Done,
     /* 1729537 */   // Label 23614: @1729537
     /* 1729537 */   GIM_Try, /*On fail goto*//*Label 23615*/ GIMT_Encode4(1729623), // Rule ID 10638 //
     /* 1729542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1729545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1729553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1729556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1729559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1729562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729588 */     // MIs[0] policy
     /* 1729588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729598 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1729601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729622 */     // GIR_Coverage, 10638,
     /* 1729622 */     GIR_EraseRootFromParent_Done,
     /* 1729623 */   // Label 23615: @1729623
     /* 1729623 */   GIM_Try, /*On fail goto*//*Label 23616*/ GIMT_Encode4(1729709), // Rule ID 10639 //
     /* 1729628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1729631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1729639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1729642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1729645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1729648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729674 */     // MIs[0] policy
     /* 1729674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729684 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1729687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729708 */     // GIR_Coverage, 10639,
     /* 1729708 */     GIR_EraseRootFromParent_Done,
     /* 1729709 */   // Label 23616: @1729709
     /* 1729709 */   GIM_Try, /*On fail goto*//*Label 23617*/ GIMT_Encode4(1729795), // Rule ID 10642 //
     /* 1729714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1729725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1729728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1729731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1729734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1729737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1729744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729760 */     // MIs[0] policy
     /* 1729760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729770 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1729773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729794 */     // GIR_Coverage, 10642,
     /* 1729794 */     GIR_EraseRootFromParent_Done,
     /* 1729795 */   // Label 23617: @1729795
     /* 1729795 */   GIM_Try, /*On fail goto*//*Label 23618*/ GIMT_Encode4(1729881), // Rule ID 10643 //
     /* 1729800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1729811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1729814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1729817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1729820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1729823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1729830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729846 */     // MIs[0] policy
     /* 1729846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729856 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1729859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729880 */     // GIR_Coverage, 10643,
     /* 1729880 */     GIR_EraseRootFromParent_Done,
     /* 1729881 */   // Label 23618: @1729881
     /* 1729881 */   GIM_Try, /*On fail goto*//*Label 23619*/ GIMT_Encode4(1729967), // Rule ID 10646 //
     /* 1729886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1729897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1729900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1729903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1729906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1729909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1729916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729932 */     // MIs[0] policy
     /* 1729932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729942 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1729945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729966 */     // GIR_Coverage, 10646,
     /* 1729966 */     GIR_EraseRootFromParent_Done,
     /* 1729967 */   // Label 23619: @1729967
     /* 1729967 */   GIM_Try, /*On fail goto*//*Label 23620*/ GIMT_Encode4(1730053), // Rule ID 10647 //
     /* 1729972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1729983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1729986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1729989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1729992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1729995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730018 */     // MIs[0] policy
     /* 1730018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730028 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1730031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730052 */     // GIR_Coverage, 10647,
     /* 1730052 */     GIR_EraseRootFromParent_Done,
     /* 1730053 */   // Label 23620: @1730053
     /* 1730053 */   GIM_Try, /*On fail goto*//*Label 23621*/ GIMT_Encode4(1730139), // Rule ID 10650 //
     /* 1730058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1730069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1730072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1730075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1730078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1730081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730104 */     // MIs[0] policy
     /* 1730104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730114 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1730117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730138 */     // GIR_Coverage, 10650,
     /* 1730138 */     GIR_EraseRootFromParent_Done,
     /* 1730139 */   // Label 23621: @1730139
     /* 1730139 */   GIM_Try, /*On fail goto*//*Label 23622*/ GIMT_Encode4(1730225), // Rule ID 10651 //
     /* 1730144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1730155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1730158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1730161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1730164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1730167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730190 */     // MIs[0] policy
     /* 1730190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730200 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1730203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730224 */     // GIR_Coverage, 10651,
     /* 1730224 */     GIR_EraseRootFromParent_Done,
     /* 1730225 */   // Label 23622: @1730225
     /* 1730225 */   GIM_Try, /*On fail goto*//*Label 23623*/ GIMT_Encode4(1730311), // Rule ID 10654 //
     /* 1730230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1730241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1730244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1730247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1730250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730276 */     // MIs[0] policy
     /* 1730276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730286 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1730289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730310 */     // GIR_Coverage, 10654,
     /* 1730310 */     GIR_EraseRootFromParent_Done,
     /* 1730311 */   // Label 23623: @1730311
     /* 1730311 */   GIM_Try, /*On fail goto*//*Label 23624*/ GIMT_Encode4(1730397), // Rule ID 10655 //
     /* 1730316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1730327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1730330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1730333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1730336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730362 */     // MIs[0] policy
     /* 1730362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730372 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1730375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730396 */     // GIR_Coverage, 10655,
     /* 1730396 */     GIR_EraseRootFromParent_Done,
     /* 1730397 */   // Label 23624: @1730397
     /* 1730397 */   GIM_Try, /*On fail goto*//*Label 23625*/ GIMT_Encode4(1730483), // Rule ID 10658 //
     /* 1730402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1730413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1730416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1730419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1730422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730448 */     // MIs[0] policy
     /* 1730448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730458 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1730461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730482 */     // GIR_Coverage, 10658,
     /* 1730482 */     GIR_EraseRootFromParent_Done,
     /* 1730483 */   // Label 23625: @1730483
     /* 1730483 */   GIM_Try, /*On fail goto*//*Label 23626*/ GIMT_Encode4(1730569), // Rule ID 10659 //
     /* 1730488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1730499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1730502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1730505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1730508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730534 */     // MIs[0] policy
     /* 1730534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730544 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1730547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730568 */     // GIR_Coverage, 10659,
     /* 1730568 */     GIR_EraseRootFromParent_Done,
     /* 1730569 */   // Label 23626: @1730569
     /* 1730569 */   GIM_Try, /*On fail goto*//*Label 23627*/ GIMT_Encode4(1730655), // Rule ID 10662 //
     /* 1730574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1730585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1730588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1730591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1730594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1730597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730620 */     // MIs[0] policy
     /* 1730620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730630 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1730633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730654 */     // GIR_Coverage, 10662,
     /* 1730654 */     GIR_EraseRootFromParent_Done,
     /* 1730655 */   // Label 23627: @1730655
     /* 1730655 */   GIM_Try, /*On fail goto*//*Label 23628*/ GIMT_Encode4(1730741), // Rule ID 10663 //
     /* 1730660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1730671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1730674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1730677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1730680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1730683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730706 */     // MIs[0] policy
     /* 1730706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730716 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1730719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730740 */     // GIR_Coverage, 10663,
     /* 1730740 */     GIR_EraseRootFromParent_Done,
     /* 1730741 */   // Label 23628: @1730741
     /* 1730741 */   GIM_Try, /*On fail goto*//*Label 23629*/ GIMT_Encode4(1730827), // Rule ID 10666 //
     /* 1730746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1730757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1730760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1730763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1730766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1730769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730792 */     // MIs[0] policy
     /* 1730792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1730805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730826 */     // GIR_Coverage, 10666,
     /* 1730826 */     GIR_EraseRootFromParent_Done,
     /* 1730827 */   // Label 23629: @1730827
     /* 1730827 */   GIM_Try, /*On fail goto*//*Label 23630*/ GIMT_Encode4(1730913), // Rule ID 10667 //
     /* 1730832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1730843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1730846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1730849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1730852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1730855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730878 */     // MIs[0] policy
     /* 1730878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730888 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1730891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730912 */     // GIR_Coverage, 10667,
     /* 1730912 */     GIR_EraseRootFromParent_Done,
     /* 1730913 */   // Label 23630: @1730913
     /* 1730913 */   GIM_Try, /*On fail goto*//*Label 23631*/ GIMT_Encode4(1730999), // Rule ID 10670 //
     /* 1730918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1730929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1730932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1730935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1730938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730964 */     // MIs[0] policy
     /* 1730964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730974 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1730977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730998 */     // GIR_Coverage, 10670,
     /* 1730998 */     GIR_EraseRootFromParent_Done,
     /* 1730999 */   // Label 23631: @1730999
     /* 1730999 */   GIM_Try, /*On fail goto*//*Label 23632*/ GIMT_Encode4(1731085), // Rule ID 10671 //
     /* 1731004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1731015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1731018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1731021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1731024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731050 */     // MIs[0] policy
     /* 1731050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731060 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1731063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731084 */     // GIR_Coverage, 10671,
     /* 1731084 */     GIR_EraseRootFromParent_Done,
     /* 1731085 */   // Label 23632: @1731085
     /* 1731085 */   GIM_Try, /*On fail goto*//*Label 23633*/ GIMT_Encode4(1731171), // Rule ID 10674 //
     /* 1731090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1731101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1731104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1731107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1731110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731136 */     // MIs[0] policy
     /* 1731136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731146 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1731149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731170 */     // GIR_Coverage, 10674,
     /* 1731170 */     GIR_EraseRootFromParent_Done,
     /* 1731171 */   // Label 23633: @1731171
     /* 1731171 */   GIM_Try, /*On fail goto*//*Label 23634*/ GIMT_Encode4(1731257), // Rule ID 10675 //
     /* 1731176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1731187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1731190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1731193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1731196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731222 */     // MIs[0] policy
     /* 1731222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731232 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1731235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731256 */     // GIR_Coverage, 10675,
     /* 1731256 */     GIR_EraseRootFromParent_Done,
     /* 1731257 */   // Label 23634: @1731257
     /* 1731257 */   GIM_Try, /*On fail goto*//*Label 23635*/ GIMT_Encode4(1731343), // Rule ID 10678 //
     /* 1731262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1731273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1731276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1731279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1731282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731308 */     // MIs[0] policy
     /* 1731308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1731321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731342 */     // GIR_Coverage, 10678,
     /* 1731342 */     GIR_EraseRootFromParent_Done,
     /* 1731343 */   // Label 23635: @1731343
     /* 1731343 */   GIM_Try, /*On fail goto*//*Label 23636*/ GIMT_Encode4(1731429), // Rule ID 10679 //
     /* 1731348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1731359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1731362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1731365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1731368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731394 */     // MIs[0] policy
     /* 1731394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731404 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1731407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731428 */     // GIR_Coverage, 10679,
     /* 1731428 */     GIR_EraseRootFromParent_Done,
     /* 1731429 */   // Label 23636: @1731429
     /* 1731429 */   GIM_Try, /*On fail goto*//*Label 23637*/ GIMT_Encode4(1731515), // Rule ID 10682 //
     /* 1731434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1731445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1731448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1731451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1731454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731480 */     // MIs[0] policy
     /* 1731480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731490 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1731493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731514 */     // GIR_Coverage, 10682,
     /* 1731514 */     GIR_EraseRootFromParent_Done,
     /* 1731515 */   // Label 23637: @1731515
     /* 1731515 */   GIM_Try, /*On fail goto*//*Label 23638*/ GIMT_Encode4(1731601), // Rule ID 10683 //
     /* 1731520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1731531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1731534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1731537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1731540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731566 */     // MIs[0] policy
     /* 1731566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731576 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1731579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731600 */     // GIR_Coverage, 10683,
     /* 1731600 */     GIR_EraseRootFromParent_Done,
     /* 1731601 */   // Label 23638: @1731601
     /* 1731601 */   GIM_Try, /*On fail goto*//*Label 23639*/ GIMT_Encode4(1731687), // Rule ID 10686 //
     /* 1731606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1731617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1731620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1731623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1731626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731652 */     // MIs[0] policy
     /* 1731652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731662 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1731665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731686 */     // GIR_Coverage, 10686,
     /* 1731686 */     GIR_EraseRootFromParent_Done,
     /* 1731687 */   // Label 23639: @1731687
     /* 1731687 */   GIM_Try, /*On fail goto*//*Label 23640*/ GIMT_Encode4(1731773), // Rule ID 10687 //
     /* 1731692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1731703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1731706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1731709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1731712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731738 */     // MIs[0] policy
     /* 1731738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731748 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1731751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731772 */     // GIR_Coverage, 10687,
     /* 1731772 */     GIR_EraseRootFromParent_Done,
     /* 1731773 */   // Label 23640: @1731773
     /* 1731773 */   GIM_Try, /*On fail goto*//*Label 23641*/ GIMT_Encode4(1731859), // Rule ID 10690 //
     /* 1731778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1731789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1731792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1731795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1731801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731824 */     // MIs[0] policy
     /* 1731824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731834 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1731837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731858 */     // GIR_Coverage, 10690,
     /* 1731858 */     GIR_EraseRootFromParent_Done,
     /* 1731859 */   // Label 23641: @1731859
     /* 1731859 */   GIM_Try, /*On fail goto*//*Label 23642*/ GIMT_Encode4(1731945), // Rule ID 10691 //
     /* 1731864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1731875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1731878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1731881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1731887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731910 */     // MIs[0] policy
     /* 1731910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731920 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1731923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731944 */     // GIR_Coverage, 10691,
     /* 1731944 */     GIR_EraseRootFromParent_Done,
     /* 1731945 */   // Label 23642: @1731945
     /* 1731945 */   GIM_Try, /*On fail goto*//*Label 23643*/ GIMT_Encode4(1732031), // Rule ID 10694 //
     /* 1731950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1731961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1731964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1731967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731996 */     // MIs[0] policy
     /* 1731996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732006 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1732009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732030 */     // GIR_Coverage, 10694,
     /* 1732030 */     GIR_EraseRootFromParent_Done,
     /* 1732031 */   // Label 23643: @1732031
     /* 1732031 */   GIM_Try, /*On fail goto*//*Label 23644*/ GIMT_Encode4(1732117), // Rule ID 10695 //
     /* 1732036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1732047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1732050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1732053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1732056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732082 */     // MIs[0] policy
     /* 1732082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732092 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1732095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732116 */     // GIR_Coverage, 10695,
     /* 1732116 */     GIR_EraseRootFromParent_Done,
     /* 1732117 */   // Label 23644: @1732117
     /* 1732117 */   GIM_Try, /*On fail goto*//*Label 23645*/ GIMT_Encode4(1732203), // Rule ID 10698 //
     /* 1732122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1732133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1732136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1732139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1732142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732168 */     // MIs[0] policy
     /* 1732168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732178 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1732181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732202 */     // GIR_Coverage, 10698,
     /* 1732202 */     GIR_EraseRootFromParent_Done,
     /* 1732203 */   // Label 23645: @1732203
     /* 1732203 */   GIM_Try, /*On fail goto*//*Label 23646*/ GIMT_Encode4(1732289), // Rule ID 10699 //
     /* 1732208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1732219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1732222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1732225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1732228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732254 */     // MIs[0] policy
     /* 1732254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732264 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1732267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732288 */     // GIR_Coverage, 10699,
     /* 1732288 */     GIR_EraseRootFromParent_Done,
     /* 1732289 */   // Label 23646: @1732289
     /* 1732289 */   GIM_Try, /*On fail goto*//*Label 23647*/ GIMT_Encode4(1732375), // Rule ID 10702 //
     /* 1732294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1732305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1732308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1732311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1732314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732340 */     // MIs[0] policy
     /* 1732340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732350 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1732353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732374 */     // GIR_Coverage, 10702,
     /* 1732374 */     GIR_EraseRootFromParent_Done,
     /* 1732375 */   // Label 23647: @1732375
     /* 1732375 */   GIM_Try, /*On fail goto*//*Label 23648*/ GIMT_Encode4(1732461), // Rule ID 10703 //
     /* 1732380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1732391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1732394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1732397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1732400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732426 */     // MIs[0] policy
     /* 1732426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732436 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1732439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732460 */     // GIR_Coverage, 10703,
     /* 1732460 */     GIR_EraseRootFromParent_Done,
     /* 1732461 */   // Label 23648: @1732461
     /* 1732461 */   GIM_Try, /*On fail goto*//*Label 23649*/ GIMT_Encode4(1732547), // Rule ID 10706 //
     /* 1732466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1732477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1732480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1732483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1732486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732512 */     // MIs[0] policy
     /* 1732512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732522 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1732525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732546 */     // GIR_Coverage, 10706,
     /* 1732546 */     GIR_EraseRootFromParent_Done,
     /* 1732547 */   // Label 23649: @1732547
     /* 1732547 */   GIM_Try, /*On fail goto*//*Label 23650*/ GIMT_Encode4(1732633), // Rule ID 10707 //
     /* 1732552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1732563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1732566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1732569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1732572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732598 */     // MIs[0] policy
     /* 1732598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732608 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1732611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732632 */     // GIR_Coverage, 10707,
     /* 1732632 */     GIR_EraseRootFromParent_Done,
     /* 1732633 */   // Label 23650: @1732633
     /* 1732633 */   GIM_Try, /*On fail goto*//*Label 23651*/ GIMT_Encode4(1732719), // Rule ID 10710 //
     /* 1732638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1732649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1732652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1732655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1732658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732684 */     // MIs[0] policy
     /* 1732684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732694 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1732697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732718 */     // GIR_Coverage, 10710,
     /* 1732718 */     GIR_EraseRootFromParent_Done,
     /* 1732719 */   // Label 23651: @1732719
     /* 1732719 */   GIM_Try, /*On fail goto*//*Label 23652*/ GIMT_Encode4(1732805), // Rule ID 10711 //
     /* 1732724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1732735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1732738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1732741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1732744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732770 */     // MIs[0] policy
     /* 1732770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732780 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1732783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732804 */     // GIR_Coverage, 10711,
     /* 1732804 */     GIR_EraseRootFromParent_Done,
     /* 1732805 */   // Label 23652: @1732805
     /* 1732805 */   GIM_Try, /*On fail goto*//*Label 23653*/ GIMT_Encode4(1732891), // Rule ID 10714 //
     /* 1732810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1732821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1732824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1732827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1732830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732856 */     // MIs[0] policy
     /* 1732856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732866 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1732869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732890 */     // GIR_Coverage, 10714,
     /* 1732890 */     GIR_EraseRootFromParent_Done,
     /* 1732891 */   // Label 23653: @1732891
     /* 1732891 */   GIM_Try, /*On fail goto*//*Label 23654*/ GIMT_Encode4(1732977), // Rule ID 10715 //
     /* 1732896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1732907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1732910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1732913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1732916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732942 */     // MIs[0] policy
     /* 1732942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11394:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1732955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732976 */     // GIR_Coverage, 10715,
     /* 1732976 */     GIR_EraseRootFromParent_Done,
     /* 1732977 */   // Label 23654: @1732977
     /* 1732977 */   GIM_Try, /*On fail goto*//*Label 23655*/ GIMT_Encode4(1733063), // Rule ID 10718 //
     /* 1732982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1732993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1732996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1732999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1733002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733028 */     // MIs[0] policy
     /* 1733028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733038 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1733041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733062 */     // GIR_Coverage, 10718,
     /* 1733062 */     GIR_EraseRootFromParent_Done,
     /* 1733063 */   // Label 23655: @1733063
     /* 1733063 */   GIM_Try, /*On fail goto*//*Label 23656*/ GIMT_Encode4(1733149), // Rule ID 10719 //
     /* 1733068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1733076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1733079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1733082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1733085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1733088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733114 */     // MIs[0] policy
     /* 1733114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733124 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1733127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733148 */     // GIR_Coverage, 10719,
     /* 1733148 */     GIR_EraseRootFromParent_Done,
     /* 1733149 */   // Label 23656: @1733149
     /* 1733149 */   GIM_Try, /*On fail goto*//*Label 23657*/ GIMT_Encode4(1733235), // Rule ID 10722 //
     /* 1733154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1733162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1733165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1733168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1733171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1733174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733200 */     // MIs[0] policy
     /* 1733200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733210 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1733213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733234 */     // GIR_Coverage, 10722,
     /* 1733234 */     GIR_EraseRootFromParent_Done,
     /* 1733235 */   // Label 23657: @1733235
     /* 1733235 */   GIM_Try, /*On fail goto*//*Label 23658*/ GIMT_Encode4(1733321), // Rule ID 10723 //
     /* 1733240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1733248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1733251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1733254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1733257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1733260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733286 */     // MIs[0] policy
     /* 1733286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1733299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733320 */     // GIR_Coverage, 10723,
     /* 1733320 */     GIR_EraseRootFromParent_Done,
     /* 1733321 */   // Label 23658: @1733321
     /* 1733321 */   GIM_Try, /*On fail goto*//*Label 23659*/ GIMT_Encode4(1733407), // Rule ID 10726 //
     /* 1733326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1733329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1733334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1733337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1733340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1733343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1733346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733372 */     // MIs[0] policy
     /* 1733372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733382 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1733385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733406 */     // GIR_Coverage, 10726,
     /* 1733406 */     GIR_EraseRootFromParent_Done,
     /* 1733407 */   // Label 23659: @1733407
     /* 1733407 */   GIM_Try, /*On fail goto*//*Label 23660*/ GIMT_Encode4(1733493), // Rule ID 10727 //
     /* 1733412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1733415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1733420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1733423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1733426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1733429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1733432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733458 */     // MIs[0] policy
     /* 1733458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733468 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1733471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733492 */     // GIR_Coverage, 10727,
     /* 1733492 */     GIR_EraseRootFromParent_Done,
     /* 1733493 */   // Label 23660: @1733493
     /* 1733493 */   GIM_Try, /*On fail goto*//*Label 23661*/ GIMT_Encode4(1733579), // Rule ID 10730 //
     /* 1733498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1733506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1733509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1733512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1733515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1733518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1733521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1733528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733544 */     // MIs[0] policy
     /* 1733544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733554 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1733557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733578 */     // GIR_Coverage, 10730,
     /* 1733578 */     GIR_EraseRootFromParent_Done,
     /* 1733579 */   // Label 23661: @1733579
     /* 1733579 */   GIM_Try, /*On fail goto*//*Label 23662*/ GIMT_Encode4(1733665), // Rule ID 10731 //
     /* 1733584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1733592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1733595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1733598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1733601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1733604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1733607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1733614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733630 */     // MIs[0] policy
     /* 1733630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733640 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1733643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733664 */     // GIR_Coverage, 10731,
     /* 1733664 */     GIR_EraseRootFromParent_Done,
     /* 1733665 */   // Label 23662: @1733665
     /* 1733665 */   GIM_Try, /*On fail goto*//*Label 23663*/ GIMT_Encode4(1733751), // Rule ID 10734 //
     /* 1733670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1733678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1733681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1733684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1733687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1733690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1733693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1733700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733716 */     // MIs[0] policy
     /* 1733716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733726 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1733729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733750 */     // GIR_Coverage, 10734,
     /* 1733750 */     GIR_EraseRootFromParent_Done,
     /* 1733751 */   // Label 23663: @1733751
     /* 1733751 */   GIM_Try, /*On fail goto*//*Label 23664*/ GIMT_Encode4(1733837), // Rule ID 10735 //
     /* 1733756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1733764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1733767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1733770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1733773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1733776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1733779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1733786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733802 */     // MIs[0] policy
     /* 1733802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733812 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1733815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733836 */     // GIR_Coverage, 10735,
     /* 1733836 */     GIR_EraseRootFromParent_Done,
     /* 1733837 */   // Label 23664: @1733837
     /* 1733837 */   GIM_Try, /*On fail goto*//*Label 23665*/ GIMT_Encode4(1733923), // Rule ID 10738 //
     /* 1733842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1733850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1733853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1733856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1733859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1733862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1733865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1733872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733888 */     // MIs[0] policy
     /* 1733888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733898 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1733901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733922 */     // GIR_Coverage, 10738,
     /* 1733922 */     GIR_EraseRootFromParent_Done,
     /* 1733923 */   // Label 23665: @1733923
     /* 1733923 */   GIM_Try, /*On fail goto*//*Label 23666*/ GIMT_Encode4(1734009), // Rule ID 10739 //
     /* 1733928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1733936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1733939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1733942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1733945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1733948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1733951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1733958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733974 */     // MIs[0] policy
     /* 1733974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733984 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1733987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734008 */     // GIR_Coverage, 10739,
     /* 1734008 */     GIR_EraseRootFromParent_Done,
     /* 1734009 */   // Label 23666: @1734009
     /* 1734009 */   GIM_Try, /*On fail goto*//*Label 23667*/ GIMT_Encode4(1734095), // Rule ID 10742 //
     /* 1734014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1734022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1734025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1734028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1734031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1734034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734060 */     // MIs[0] policy
     /* 1734060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734070 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1734073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734094 */     // GIR_Coverage, 10742,
     /* 1734094 */     GIR_EraseRootFromParent_Done,
     /* 1734095 */   // Label 23667: @1734095
     /* 1734095 */   GIM_Try, /*On fail goto*//*Label 23668*/ GIMT_Encode4(1734181), // Rule ID 10743 //
     /* 1734100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1734108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1734111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1734114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1734117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1734120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734146 */     // MIs[0] policy
     /* 1734146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1734159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734180 */     // GIR_Coverage, 10743,
     /* 1734180 */     GIR_EraseRootFromParent_Done,
     /* 1734181 */   // Label 23668: @1734181
     /* 1734181 */   GIM_Try, /*On fail goto*//*Label 23669*/ GIMT_Encode4(1734267), // Rule ID 10746 //
     /* 1734186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1734194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1734197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1734200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1734203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1734206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734232 */     // MIs[0] policy
     /* 1734232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734242 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1734245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734266 */     // GIR_Coverage, 10746,
     /* 1734266 */     GIR_EraseRootFromParent_Done,
     /* 1734267 */   // Label 23669: @1734267
     /* 1734267 */   GIM_Try, /*On fail goto*//*Label 23670*/ GIMT_Encode4(1734353), // Rule ID 10747 //
     /* 1734272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1734280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1734283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1734286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1734289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1734292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734318 */     // MIs[0] policy
     /* 1734318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734328 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1734331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734352 */     // GIR_Coverage, 10747,
     /* 1734352 */     GIR_EraseRootFromParent_Done,
     /* 1734353 */   // Label 23670: @1734353
     /* 1734353 */   GIM_Try, /*On fail goto*//*Label 23671*/ GIMT_Encode4(1734439), // Rule ID 10750 //
     /* 1734358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1734366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1734369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1734372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1734375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1734378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734404 */     // MIs[0] policy
     /* 1734404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734414 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1734417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734438 */     // GIR_Coverage, 10750,
     /* 1734438 */     GIR_EraseRootFromParent_Done,
     /* 1734439 */   // Label 23671: @1734439
     /* 1734439 */   GIM_Try, /*On fail goto*//*Label 23672*/ GIMT_Encode4(1734525), // Rule ID 10751 //
     /* 1734444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1734452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1734455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1734458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1734461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1734464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734490 */     // MIs[0] policy
     /* 1734490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734500 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1734503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734524 */     // GIR_Coverage, 10751,
     /* 1734524 */     GIR_EraseRootFromParent_Done,
     /* 1734525 */   // Label 23672: @1734525
     /* 1734525 */   GIM_Try, /*On fail goto*//*Label 23673*/ GIMT_Encode4(1734611), // Rule ID 10754 //
     /* 1734530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1734538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1734541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1734544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1734547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1734550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734576 */     // MIs[0] policy
     /* 1734576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1734589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734610 */     // GIR_Coverage, 10754,
     /* 1734610 */     GIR_EraseRootFromParent_Done,
     /* 1734611 */   // Label 23673: @1734611
     /* 1734611 */   GIM_Try, /*On fail goto*//*Label 23674*/ GIMT_Encode4(1734697), // Rule ID 10755 //
     /* 1734616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1734624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1734627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1734630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1734633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1734636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734662 */     // MIs[0] policy
     /* 1734662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734672 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1734675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734696 */     // GIR_Coverage, 10755,
     /* 1734696 */     GIR_EraseRootFromParent_Done,
     /* 1734697 */   // Label 23674: @1734697
     /* 1734697 */   GIM_Try, /*On fail goto*//*Label 23675*/ GIMT_Encode4(1734783), // Rule ID 10758 //
     /* 1734702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1734710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1734713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1734716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1734719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1734722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734748 */     // MIs[0] policy
     /* 1734748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734758 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1734761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734782 */     // GIR_Coverage, 10758,
     /* 1734782 */     GIR_EraseRootFromParent_Done,
     /* 1734783 */   // Label 23675: @1734783
     /* 1734783 */   GIM_Try, /*On fail goto*//*Label 23676*/ GIMT_Encode4(1734869), // Rule ID 10759 //
     /* 1734788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1734796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1734799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1734802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1734805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1734808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734834 */     // MIs[0] policy
     /* 1734834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734844 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1734847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734868 */     // GIR_Coverage, 10759,
     /* 1734868 */     GIR_EraseRootFromParent_Done,
     /* 1734869 */   // Label 23676: @1734869
     /* 1734869 */   GIM_Try, /*On fail goto*//*Label 23677*/ GIMT_Encode4(1734955), // Rule ID 10762 //
     /* 1734874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1734882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1734885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1734888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1734891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1734894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734920 */     // MIs[0] policy
     /* 1734920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734930 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1734933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734954 */     // GIR_Coverage, 10762,
     /* 1734954 */     GIR_EraseRootFromParent_Done,
     /* 1734955 */   // Label 23677: @1734955
     /* 1734955 */   GIM_Try, /*On fail goto*//*Label 23678*/ GIMT_Encode4(1735041), // Rule ID 10763 //
     /* 1734960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1734968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1734971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1734974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1734977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1734980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735006 */     // MIs[0] policy
     /* 1735006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1735019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735040 */     // GIR_Coverage, 10763,
     /* 1735040 */     GIR_EraseRootFromParent_Done,
     /* 1735041 */   // Label 23678: @1735041
     /* 1735041 */   GIM_Try, /*On fail goto*//*Label 23679*/ GIMT_Encode4(1735127), // Rule ID 10766 //
     /* 1735046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1735054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1735057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1735060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1735063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735092 */     // MIs[0] policy
     /* 1735092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735102 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1735105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735126 */     // GIR_Coverage, 10766,
     /* 1735126 */     GIR_EraseRootFromParent_Done,
     /* 1735127 */   // Label 23679: @1735127
     /* 1735127 */   GIM_Try, /*On fail goto*//*Label 23680*/ GIMT_Encode4(1735213), // Rule ID 10767 //
     /* 1735132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1735140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1735143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1735146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1735149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735178 */     // MIs[0] policy
     /* 1735178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735188 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1735191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735212 */     // GIR_Coverage, 10767,
     /* 1735212 */     GIR_EraseRootFromParent_Done,
     /* 1735213 */   // Label 23680: @1735213
     /* 1735213 */   GIM_Try, /*On fail goto*//*Label 23681*/ GIMT_Encode4(1735299), // Rule ID 10770 //
     /* 1735218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1735226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1735229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1735232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1735235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735264 */     // MIs[0] policy
     /* 1735264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735274 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1735277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735298 */     // GIR_Coverage, 10770,
     /* 1735298 */     GIR_EraseRootFromParent_Done,
     /* 1735299 */   // Label 23681: @1735299
     /* 1735299 */   GIM_Try, /*On fail goto*//*Label 23682*/ GIMT_Encode4(1735385), // Rule ID 10771 //
     /* 1735304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1735312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1735315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1735318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1735321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735350 */     // MIs[0] policy
     /* 1735350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735360 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1735363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735384 */     // GIR_Coverage, 10771,
     /* 1735384 */     GIR_EraseRootFromParent_Done,
     /* 1735385 */   // Label 23682: @1735385
     /* 1735385 */   GIM_Try, /*On fail goto*//*Label 23683*/ GIMT_Encode4(1735471), // Rule ID 10774 //
     /* 1735390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1735398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1735401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1735404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1735407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735436 */     // MIs[0] policy
     /* 1735436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735446 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1735449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735470 */     // GIR_Coverage, 10774,
     /* 1735470 */     GIR_EraseRootFromParent_Done,
     /* 1735471 */   // Label 23683: @1735471
     /* 1735471 */   GIM_Try, /*On fail goto*//*Label 23684*/ GIMT_Encode4(1735557), // Rule ID 10775 //
     /* 1735476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1735484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1735487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1735490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1735493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735522 */     // MIs[0] policy
     /* 1735522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735532 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1735535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735556 */     // GIR_Coverage, 10775,
     /* 1735556 */     GIR_EraseRootFromParent_Done,
     /* 1735557 */   // Label 23684: @1735557
     /* 1735557 */   GIM_Try, /*On fail goto*//*Label 23685*/ GIMT_Encode4(1735643), // Rule ID 10778 //
     /* 1735562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1735573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1735576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1735579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1735582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1735585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735608 */     // MIs[0] policy
     /* 1735608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735618 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1735621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735642 */     // GIR_Coverage, 10778,
     /* 1735642 */     GIR_EraseRootFromParent_Done,
     /* 1735643 */   // Label 23685: @1735643
     /* 1735643 */   GIM_Try, /*On fail goto*//*Label 23686*/ GIMT_Encode4(1735729), // Rule ID 10779 //
     /* 1735648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1735659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1735662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1735665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1735668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1735671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735694 */     // MIs[0] policy
     /* 1735694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735704 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1735707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735728 */     // GIR_Coverage, 10779,
     /* 1735728 */     GIR_EraseRootFromParent_Done,
     /* 1735729 */   // Label 23686: @1735729
     /* 1735729 */   GIM_Try, /*On fail goto*//*Label 23687*/ GIMT_Encode4(1735815), // Rule ID 10782 //
     /* 1735734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1735745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1735748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1735751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1735754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735780 */     // MIs[0] policy
     /* 1735780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735790 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1735793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735814 */     // GIR_Coverage, 10782,
     /* 1735814 */     GIR_EraseRootFromParent_Done,
     /* 1735815 */   // Label 23687: @1735815
     /* 1735815 */   GIM_Try, /*On fail goto*//*Label 23688*/ GIMT_Encode4(1735901), // Rule ID 10783 //
     /* 1735820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1735831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1735834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1735837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1735840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735866 */     // MIs[0] policy
     /* 1735866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735876 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1735879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735900 */     // GIR_Coverage, 10783,
     /* 1735900 */     GIR_EraseRootFromParent_Done,
     /* 1735901 */   // Label 23688: @1735901
     /* 1735901 */   GIM_Try, /*On fail goto*//*Label 23689*/ GIMT_Encode4(1735987), // Rule ID 10786 //
     /* 1735906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1735917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1735920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1735923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1735926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735952 */     // MIs[0] policy
     /* 1735952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735962 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1735965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735986 */     // GIR_Coverage, 10786,
     /* 1735986 */     GIR_EraseRootFromParent_Done,
     /* 1735987 */   // Label 23689: @1735987
     /* 1735987 */   GIM_Try, /*On fail goto*//*Label 23690*/ GIMT_Encode4(1736073), // Rule ID 10787 //
     /* 1735992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1736003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1736006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1736009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1736012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736038 */     // MIs[0] policy
     /* 1736038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736048 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1736051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736072 */     // GIR_Coverage, 10787,
     /* 1736072 */     GIR_EraseRootFromParent_Done,
     /* 1736073 */   // Label 23690: @1736073
     /* 1736073 */   GIM_Try, /*On fail goto*//*Label 23691*/ GIMT_Encode4(1736159), // Rule ID 10790 //
     /* 1736078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1736089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1736092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1736095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1736098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736124 */     // MIs[0] policy
     /* 1736124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736134 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1736137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736158 */     // GIR_Coverage, 10790,
     /* 1736158 */     GIR_EraseRootFromParent_Done,
     /* 1736159 */   // Label 23691: @1736159
     /* 1736159 */   GIM_Try, /*On fail goto*//*Label 23692*/ GIMT_Encode4(1736245), // Rule ID 10791 //
     /* 1736164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1736175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1736178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1736181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1736184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736210 */     // MIs[0] policy
     /* 1736210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736220 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1736223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736244 */     // GIR_Coverage, 10791,
     /* 1736244 */     GIR_EraseRootFromParent_Done,
     /* 1736245 */   // Label 23692: @1736245
     /* 1736245 */   GIM_Try, /*On fail goto*//*Label 23693*/ GIMT_Encode4(1736331), // Rule ID 10794 //
     /* 1736250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1736261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1736264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1736267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1736270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736296 */     // MIs[0] policy
     /* 1736296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736306 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1736309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736330 */     // GIR_Coverage, 10794,
     /* 1736330 */     GIR_EraseRootFromParent_Done,
     /* 1736331 */   // Label 23693: @1736331
     /* 1736331 */   GIM_Try, /*On fail goto*//*Label 23694*/ GIMT_Encode4(1736417), // Rule ID 10795 //
     /* 1736336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1736347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1736350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1736353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1736356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736382 */     // MIs[0] policy
     /* 1736382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736392 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1736395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736416 */     // GIR_Coverage, 10795,
     /* 1736416 */     GIR_EraseRootFromParent_Done,
     /* 1736417 */   // Label 23694: @1736417
     /* 1736417 */   GIM_Try, /*On fail goto*//*Label 23695*/ GIMT_Encode4(1736503), // Rule ID 10798 //
     /* 1736422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1736433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1736436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1736439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1736442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736468 */     // MIs[0] policy
     /* 1736468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1736481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736502 */     // GIR_Coverage, 10798,
     /* 1736502 */     GIR_EraseRootFromParent_Done,
     /* 1736503 */   // Label 23695: @1736503
     /* 1736503 */   GIM_Try, /*On fail goto*//*Label 23696*/ GIMT_Encode4(1736589), // Rule ID 10799 //
     /* 1736508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1736519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1736522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1736525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1736528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736554 */     // MIs[0] policy
     /* 1736554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736564 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1736567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736588 */     // GIR_Coverage, 10799,
     /* 1736588 */     GIR_EraseRootFromParent_Done,
     /* 1736589 */   // Label 23696: @1736589
     /* 1736589 */   GIM_Try, /*On fail goto*//*Label 23697*/ GIMT_Encode4(1736675), // Rule ID 10802 //
     /* 1736594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1736605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1736608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1736611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1736614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736640 */     // MIs[0] policy
     /* 1736640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736650 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1736653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736674 */     // GIR_Coverage, 10802,
     /* 1736674 */     GIR_EraseRootFromParent_Done,
     /* 1736675 */   // Label 23697: @1736675
     /* 1736675 */   GIM_Try, /*On fail goto*//*Label 23698*/ GIMT_Encode4(1736761), // Rule ID 10803 //
     /* 1736680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1736691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1736694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1736697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1736700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736726 */     // MIs[0] policy
     /* 1736726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736736 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1736739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736760 */     // GIR_Coverage, 10803,
     /* 1736760 */     GIR_EraseRootFromParent_Done,
     /* 1736761 */   // Label 23698: @1736761
     /* 1736761 */   GIM_Try, /*On fail goto*//*Label 23699*/ GIMT_Encode4(1736847), // Rule ID 10806 //
     /* 1736766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1736777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1736780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1736783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1736786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736812 */     // MIs[0] policy
     /* 1736812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736822 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1736825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736846 */     // GIR_Coverage, 10806,
     /* 1736846 */     GIR_EraseRootFromParent_Done,
     /* 1736847 */   // Label 23699: @1736847
     /* 1736847 */   GIM_Try, /*On fail goto*//*Label 23700*/ GIMT_Encode4(1736933), // Rule ID 10807 //
     /* 1736852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1736863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1736866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1736869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1736872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736898 */     // MIs[0] policy
     /* 1736898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736908 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1736911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736932 */     // GIR_Coverage, 10807,
     /* 1736932 */     GIR_EraseRootFromParent_Done,
     /* 1736933 */   // Label 23700: @1736933
     /* 1736933 */   GIM_Try, /*On fail goto*//*Label 23701*/ GIMT_Encode4(1737019), // Rule ID 10810 //
     /* 1736938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1736949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1736952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1736955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1736958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736984 */     // MIs[0] policy
     /* 1736984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736994 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1736997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1737015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737018 */     // GIR_Coverage, 10810,
     /* 1737018 */     GIR_EraseRootFromParent_Done,
     /* 1737019 */   // Label 23701: @1737019
     /* 1737019 */   GIM_Try, /*On fail goto*//*Label 23702*/ GIMT_Encode4(1737105), // Rule ID 10811 //
     /* 1737024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1737035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1737038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1737041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1737044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737070 */     // MIs[0] policy
     /* 1737070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737080 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1737083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1737101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737104 */     // GIR_Coverage, 10811,
     /* 1737104 */     GIR_EraseRootFromParent_Done,
     /* 1737105 */   // Label 23702: @1737105
     /* 1737105 */   GIM_Try, /*On fail goto*//*Label 23703*/ GIMT_Encode4(1737191), // Rule ID 10814 //
     /* 1737110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1737113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1737121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1737124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1737127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1737130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737156 */     // MIs[0] policy
     /* 1737156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737166 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1737169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737190 */     // GIR_Coverage, 10814,
     /* 1737190 */     GIR_EraseRootFromParent_Done,
     /* 1737191 */   // Label 23703: @1737191
     /* 1737191 */   GIM_Try, /*On fail goto*//*Label 23704*/ GIMT_Encode4(1737277), // Rule ID 10815 //
     /* 1737196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1737199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1737207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1737210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1737213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1737216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737242 */     // MIs[0] policy
     /* 1737242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1737255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737276 */     // GIR_Coverage, 10815,
     /* 1737276 */     GIR_EraseRootFromParent_Done,
     /* 1737277 */   // Label 23704: @1737277
     /* 1737277 */   GIM_Try, /*On fail goto*//*Label 23705*/ GIMT_Encode4(1737363), // Rule ID 10818 //
     /* 1737282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1737293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1737296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1737299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1737302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1737305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737328 */     // MIs[0] policy
     /* 1737328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737338 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1737341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737362 */     // GIR_Coverage, 10818,
     /* 1737362 */     GIR_EraseRootFromParent_Done,
     /* 1737363 */   // Label 23705: @1737363
     /* 1737363 */   GIM_Try, /*On fail goto*//*Label 23706*/ GIMT_Encode4(1737449), // Rule ID 10819 //
     /* 1737368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1737379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1737382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1737385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1737388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1737391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737414 */     // MIs[0] policy
     /* 1737414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737424 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1737427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737448 */     // GIR_Coverage, 10819,
     /* 1737448 */     GIR_EraseRootFromParent_Done,
     /* 1737449 */   // Label 23706: @1737449
     /* 1737449 */   GIM_Try, /*On fail goto*//*Label 23707*/ GIMT_Encode4(1737535), // Rule ID 10822 //
     /* 1737454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1737465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1737468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1737471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1737474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1737477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737500 */     // MIs[0] policy
     /* 1737500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737510 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1737513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737534 */     // GIR_Coverage, 10822,
     /* 1737534 */     GIR_EraseRootFromParent_Done,
     /* 1737535 */   // Label 23707: @1737535
     /* 1737535 */   GIM_Try, /*On fail goto*//*Label 23708*/ GIMT_Encode4(1737621), // Rule ID 10823 //
     /* 1737540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1737551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1737554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1737557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1737560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1737563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737586 */     // MIs[0] policy
     /* 1737586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737596 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1737599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737620 */     // GIR_Coverage, 10823,
     /* 1737620 */     GIR_EraseRootFromParent_Done,
     /* 1737621 */   // Label 23708: @1737621
     /* 1737621 */   GIM_Try, /*On fail goto*//*Label 23709*/ GIMT_Encode4(1737707), // Rule ID 10826 //
     /* 1737626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1737637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1737640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1737643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1737646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1737649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1737656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737672 */     // MIs[0] policy
     /* 1737672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737682 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1737685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737706 */     // GIR_Coverage, 10826,
     /* 1737706 */     GIR_EraseRootFromParent_Done,
     /* 1737707 */   // Label 23709: @1737707
     /* 1737707 */   GIM_Try, /*On fail goto*//*Label 23710*/ GIMT_Encode4(1737793), // Rule ID 10827 //
     /* 1737712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1737723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1737726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1737729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1737732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1737735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1737742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737758 */     // MIs[0] policy
     /* 1737758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737768 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1737771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737792 */     // GIR_Coverage, 10827,
     /* 1737792 */     GIR_EraseRootFromParent_Done,
     /* 1737793 */   // Label 23710: @1737793
     /* 1737793 */   GIM_Try, /*On fail goto*//*Label 23711*/ GIMT_Encode4(1737879), // Rule ID 10830 //
     /* 1737798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1737809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1737812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1737815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1737818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737844 */     // MIs[0] policy
     /* 1737844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737854 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1737857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737878 */     // GIR_Coverage, 10830,
     /* 1737878 */     GIR_EraseRootFromParent_Done,
     /* 1737879 */   // Label 23711: @1737879
     /* 1737879 */   GIM_Try, /*On fail goto*//*Label 23712*/ GIMT_Encode4(1737965), // Rule ID 10831 //
     /* 1737884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1737895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1737898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1737901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1737904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737930 */     // MIs[0] policy
     /* 1737930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737940 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1737943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737964 */     // GIR_Coverage, 10831,
     /* 1737964 */     GIR_EraseRootFromParent_Done,
     /* 1737965 */   // Label 23712: @1737965
     /* 1737965 */   GIM_Try, /*On fail goto*//*Label 23713*/ GIMT_Encode4(1738051), // Rule ID 10834 //
     /* 1737970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1737981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1737984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1737987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1737990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1737993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738016 */     // MIs[0] policy
     /* 1738016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1738029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738050 */     // GIR_Coverage, 10834,
     /* 1738050 */     GIR_EraseRootFromParent_Done,
     /* 1738051 */   // Label 23713: @1738051
     /* 1738051 */   GIM_Try, /*On fail goto*//*Label 23714*/ GIMT_Encode4(1738137), // Rule ID 10835 //
     /* 1738056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1738067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1738070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1738073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1738076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738102 */     // MIs[0] policy
     /* 1738102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738112 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1738115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738136 */     // GIR_Coverage, 10835,
     /* 1738136 */     GIR_EraseRootFromParent_Done,
     /* 1738137 */   // Label 23714: @1738137
     /* 1738137 */   GIM_Try, /*On fail goto*//*Label 23715*/ GIMT_Encode4(1738223), // Rule ID 10838 //
     /* 1738142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1738153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1738156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1738159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1738162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1738165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738188 */     // MIs[0] policy
     /* 1738188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738198 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1738201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738222 */     // GIR_Coverage, 10838,
     /* 1738222 */     GIR_EraseRootFromParent_Done,
     /* 1738223 */   // Label 23715: @1738223
     /* 1738223 */   GIM_Try, /*On fail goto*//*Label 23716*/ GIMT_Encode4(1738309), // Rule ID 10839 //
     /* 1738228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1738239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1738242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1738245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1738248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1738251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738274 */     // MIs[0] policy
     /* 1738274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738284 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1738287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738308 */     // GIR_Coverage, 10839,
     /* 1738308 */     GIR_EraseRootFromParent_Done,
     /* 1738309 */   // Label 23716: @1738309
     /* 1738309 */   GIM_Try, /*On fail goto*//*Label 23717*/ GIMT_Encode4(1738395), // Rule ID 10842 //
     /* 1738314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1738325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1738328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1738331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1738334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738360 */     // MIs[0] policy
     /* 1738360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738370 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1738373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738394 */     // GIR_Coverage, 10842,
     /* 1738394 */     GIR_EraseRootFromParent_Done,
     /* 1738395 */   // Label 23717: @1738395
     /* 1738395 */   GIM_Try, /*On fail goto*//*Label 23718*/ GIMT_Encode4(1738481), // Rule ID 10843 //
     /* 1738400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1738411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1738414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1738417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1738420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738446 */     // MIs[0] policy
     /* 1738446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738456 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1738459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738480 */     // GIR_Coverage, 10843,
     /* 1738480 */     GIR_EraseRootFromParent_Done,
     /* 1738481 */   // Label 23718: @1738481
     /* 1738481 */   GIM_Try, /*On fail goto*//*Label 23719*/ GIMT_Encode4(1738567), // Rule ID 10846 //
     /* 1738486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1738497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1738500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1738503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1738506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738532 */     // MIs[0] policy
     /* 1738532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738542 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1738545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738566 */     // GIR_Coverage, 10846,
     /* 1738566 */     GIR_EraseRootFromParent_Done,
     /* 1738567 */   // Label 23719: @1738567
     /* 1738567 */   GIM_Try, /*On fail goto*//*Label 23720*/ GIMT_Encode4(1738653), // Rule ID 10847 //
     /* 1738572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1738583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1738586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1738589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1738592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738618 */     // MIs[0] policy
     /* 1738618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738628 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1738631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738652 */     // GIR_Coverage, 10847,
     /* 1738652 */     GIR_EraseRootFromParent_Done,
     /* 1738653 */   // Label 23720: @1738653
     /* 1738653 */   GIM_Try, /*On fail goto*//*Label 23721*/ GIMT_Encode4(1738739), // Rule ID 10850 //
     /* 1738658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1738669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1738672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1738675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1738678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738704 */     // MIs[0] policy
     /* 1738704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738714 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1738717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738738 */     // GIR_Coverage, 10850,
     /* 1738738 */     GIR_EraseRootFromParent_Done,
     /* 1738739 */   // Label 23721: @1738739
     /* 1738739 */   GIM_Try, /*On fail goto*//*Label 23722*/ GIMT_Encode4(1738825), // Rule ID 10851 //
     /* 1738744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1738755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1738758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1738761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1738764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738790 */     // MIs[0] policy
     /* 1738790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738800 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1738803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738824 */     // GIR_Coverage, 10851,
     /* 1738824 */     GIR_EraseRootFromParent_Done,
     /* 1738825 */   // Label 23722: @1738825
     /* 1738825 */   GIM_Try, /*On fail goto*//*Label 23723*/ GIMT_Encode4(1738911), // Rule ID 10854 //
     /* 1738830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1738833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1738841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1738844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1738847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1738850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1738853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738876 */     // MIs[0] policy
     /* 1738876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1738889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1738907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738910 */     // GIR_Coverage, 10854,
     /* 1738910 */     GIR_EraseRootFromParent_Done,
     /* 1738911 */   // Label 23723: @1738911
     /* 1738911 */   GIM_Try, /*On fail goto*//*Label 23724*/ GIMT_Encode4(1738997), // Rule ID 10855 //
     /* 1738916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1738919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1738927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1738930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1738933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1738936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1738939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738962 */     // MIs[0] policy
     /* 1738962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738972 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1738975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1738993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738996 */     // GIR_Coverage, 10855,
     /* 1738996 */     GIR_EraseRootFromParent_Done,
     /* 1738997 */   // Label 23724: @1738997
     /* 1738997 */   GIM_Try, /*On fail goto*//*Label 23725*/ GIMT_Encode4(1739083), // Rule ID 10858 //
     /* 1739002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1739005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1739013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1739016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1739019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1739022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739048 */     // MIs[0] policy
     /* 1739048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739058 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1739061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739082 */     // GIR_Coverage, 10858,
     /* 1739082 */     GIR_EraseRootFromParent_Done,
     /* 1739083 */   // Label 23725: @1739083
     /* 1739083 */   GIM_Try, /*On fail goto*//*Label 23726*/ GIMT_Encode4(1739169), // Rule ID 10859 //
     /* 1739088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1739099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1739102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1739105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1739108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739134 */     // MIs[0] policy
     /* 1739134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739144 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1739147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739168 */     // GIR_Coverage, 10859,
     /* 1739168 */     GIR_EraseRootFromParent_Done,
     /* 1739169 */   // Label 23726: @1739169
     /* 1739169 */   GIM_Try, /*On fail goto*//*Label 23727*/ GIMT_Encode4(1739255), // Rule ID 10862 //
     /* 1739174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1739177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1739185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1739188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1739191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1739194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739220 */     // MIs[0] policy
     /* 1739220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739230 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1739233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739254 */     // GIR_Coverage, 10862,
     /* 1739254 */     GIR_EraseRootFromParent_Done,
     /* 1739255 */   // Label 23727: @1739255
     /* 1739255 */   GIM_Try, /*On fail goto*//*Label 23728*/ GIMT_Encode4(1739341), // Rule ID 10863 //
     /* 1739260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1739271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1739274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1739277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1739280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739306 */     // MIs[0] policy
     /* 1739306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739316 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1739319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739340 */     // GIR_Coverage, 10863,
     /* 1739340 */     GIR_EraseRootFromParent_Done,
     /* 1739341 */   // Label 23728: @1739341
     /* 1739341 */   GIM_Try, /*On fail goto*//*Label 23729*/ GIMT_Encode4(1739427), // Rule ID 10866 //
     /* 1739346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1739357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1739360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1739363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739392 */     // MIs[0] policy
     /* 1739392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739402 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1739405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739426 */     // GIR_Coverage, 10866,
     /* 1739426 */     GIR_EraseRootFromParent_Done,
     /* 1739427 */   // Label 23729: @1739427
     /* 1739427 */   GIM_Try, /*On fail goto*//*Label 23730*/ GIMT_Encode4(1739513), // Rule ID 10867 //
     /* 1739432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1739443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1739446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1739449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739478 */     // MIs[0] policy
     /* 1739478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739488 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1739491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739512 */     // GIR_Coverage, 10867,
     /* 1739512 */     GIR_EraseRootFromParent_Done,
     /* 1739513 */   // Label 23730: @1739513
     /* 1739513 */   GIM_Try, /*On fail goto*//*Label 23731*/ GIMT_Encode4(1739599), // Rule ID 10870 //
     /* 1739518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1739529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1739532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1739535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739564 */     // MIs[0] policy
     /* 1739564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739574 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1739577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739598 */     // GIR_Coverage, 10870,
     /* 1739598 */     GIR_EraseRootFromParent_Done,
     /* 1739599 */   // Label 23731: @1739599
     /* 1739599 */   GIM_Try, /*On fail goto*//*Label 23732*/ GIMT_Encode4(1739685), // Rule ID 10871 //
     /* 1739604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1739615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1739618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1739621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739650 */     // MIs[0] policy
     /* 1739650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739660 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1739663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739684 */     // GIR_Coverage, 10871,
     /* 1739684 */     GIR_EraseRootFromParent_Done,
     /* 1739685 */   // Label 23732: @1739685
     /* 1739685 */   GIM_Try, /*On fail goto*//*Label 23733*/ GIMT_Encode4(1739771), // Rule ID 10874 //
     /* 1739690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1739701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1739704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1739707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739736 */     // MIs[0] policy
     /* 1739736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739746 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1739749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739770 */     // GIR_Coverage, 10874,
     /* 1739770 */     GIR_EraseRootFromParent_Done,
     /* 1739771 */   // Label 23733: @1739771
     /* 1739771 */   GIM_Try, /*On fail goto*//*Label 23734*/ GIMT_Encode4(1739857), // Rule ID 10875 //
     /* 1739776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1739787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1739790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1739793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739822 */     // MIs[0] policy
     /* 1739822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739832 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1739835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739856 */     // GIR_Coverage, 10875,
     /* 1739856 */     GIR_EraseRootFromParent_Done,
     /* 1739857 */   // Label 23734: @1739857
     /* 1739857 */   GIM_Try, /*On fail goto*//*Label 23735*/ GIMT_Encode4(1739943), // Rule ID 10878 //
     /* 1739862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1739873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1739876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1739879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739908 */     // MIs[0] policy
     /* 1739908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739918 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1739921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739942 */     // GIR_Coverage, 10878,
     /* 1739942 */     GIR_EraseRootFromParent_Done,
     /* 1739943 */   // Label 23735: @1739943
     /* 1739943 */   GIM_Try, /*On fail goto*//*Label 23736*/ GIMT_Encode4(1740029), // Rule ID 10879 //
     /* 1739948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1739959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1739962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1739965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739994 */     // MIs[0] policy
     /* 1739994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740004 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1740007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740028 */     // GIR_Coverage, 10879,
     /* 1740028 */     GIR_EraseRootFromParent_Done,
     /* 1740029 */   // Label 23736: @1740029
     /* 1740029 */   GIM_Try, /*On fail goto*//*Label 23737*/ GIMT_Encode4(1740115), // Rule ID 10882 //
     /* 1740034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1740042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1740045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1740048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1740051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1740054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740080 */     // MIs[0] policy
     /* 1740080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740090 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1740093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740114 */     // GIR_Coverage, 10882,
     /* 1740114 */     GIR_EraseRootFromParent_Done,
     /* 1740115 */   // Label 23737: @1740115
     /* 1740115 */   GIM_Try, /*On fail goto*//*Label 23738*/ GIMT_Encode4(1740201), // Rule ID 10883 //
     /* 1740120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1740128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1740131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1740134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1740137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1740140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740166 */     // MIs[0] policy
     /* 1740166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740176 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1740179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740200 */     // GIR_Coverage, 10883,
     /* 1740200 */     GIR_EraseRootFromParent_Done,
     /* 1740201 */   // Label 23738: @1740201
     /* 1740201 */   GIM_Try, /*On fail goto*//*Label 23739*/ GIMT_Encode4(1740287), // Rule ID 10886 //
     /* 1740206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1740214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1740217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1740220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1740223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1740226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740252 */     // MIs[0] policy
     /* 1740252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740262 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1740265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740286 */     // GIR_Coverage, 10886,
     /* 1740286 */     GIR_EraseRootFromParent_Done,
     /* 1740287 */   // Label 23739: @1740287
     /* 1740287 */   GIM_Try, /*On fail goto*//*Label 23740*/ GIMT_Encode4(1740373), // Rule ID 10887 //
     /* 1740292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1740300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1740303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1740306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1740309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1740312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740338 */     // MIs[0] policy
     /* 1740338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740348 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1740351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740372 */     // GIR_Coverage, 10887,
     /* 1740372 */     GIR_EraseRootFromParent_Done,
     /* 1740373 */   // Label 23740: @1740373
     /* 1740373 */   GIM_Try, /*On fail goto*//*Label 23741*/ GIMT_Encode4(1740459), // Rule ID 10890 //
     /* 1740378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1740386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1740389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1740392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1740395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1740398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740424 */     // MIs[0] policy
     /* 1740424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740434 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1740437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740458 */     // GIR_Coverage, 10890,
     /* 1740458 */     GIR_EraseRootFromParent_Done,
     /* 1740459 */   // Label 23741: @1740459
     /* 1740459 */   GIM_Try, /*On fail goto*//*Label 23742*/ GIMT_Encode4(1740545), // Rule ID 10891 //
     /* 1740464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1740472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1740475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1740478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1740481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1740484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740510 */     // MIs[0] policy
     /* 1740510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740520 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1740523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740544 */     // GIR_Coverage, 10891,
     /* 1740544 */     GIR_EraseRootFromParent_Done,
     /* 1740545 */   // Label 23742: @1740545
     /* 1740545 */   GIM_Try, /*On fail goto*//*Label 23743*/ GIMT_Encode4(1740631), // Rule ID 10894 //
     /* 1740550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1740558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1740561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1740564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1740567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1740570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740596 */     // MIs[0] policy
     /* 1740596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740606 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1740609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740630 */     // GIR_Coverage, 10894,
     /* 1740630 */     GIR_EraseRootFromParent_Done,
     /* 1740631 */   // Label 23743: @1740631
     /* 1740631 */   GIM_Try, /*On fail goto*//*Label 23744*/ GIMT_Encode4(1740717), // Rule ID 10895 //
     /* 1740636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1740644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1740647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1740650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1740653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1740656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740682 */     // MIs[0] policy
     /* 1740682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740692 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1740695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740716 */     // GIR_Coverage, 10895,
     /* 1740716 */     GIR_EraseRootFromParent_Done,
     /* 1740717 */   // Label 23744: @1740717
     /* 1740717 */   GIM_Try, /*On fail goto*//*Label 23745*/ GIMT_Encode4(1740803), // Rule ID 10898 //
     /* 1740722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1740730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1740733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1740736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1740739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1740742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740768 */     // MIs[0] policy
     /* 1740768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740778 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1740781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740802 */     // GIR_Coverage, 10898,
     /* 1740802 */     GIR_EraseRootFromParent_Done,
     /* 1740803 */   // Label 23745: @1740803
     /* 1740803 */   GIM_Try, /*On fail goto*//*Label 23746*/ GIMT_Encode4(1740889), // Rule ID 10899 //
     /* 1740808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1740816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1740819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1740822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1740825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1740828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740854 */     // MIs[0] policy
     /* 1740854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740864 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1740867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740888 */     // GIR_Coverage, 10899,
     /* 1740888 */     GIR_EraseRootFromParent_Done,
     /* 1740889 */   // Label 23746: @1740889
     /* 1740889 */   GIM_Try, /*On fail goto*//*Label 23747*/ GIMT_Encode4(1740975), // Rule ID 10902 //
     /* 1740894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1740897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1740902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1740905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1740908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1740911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1740914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740940 */     // MIs[0] policy
     /* 1740940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740950 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1740953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740974 */     // GIR_Coverage, 10902,
     /* 1740974 */     GIR_EraseRootFromParent_Done,
     /* 1740975 */   // Label 23747: @1740975
     /* 1740975 */   GIM_Try, /*On fail goto*//*Label 23748*/ GIMT_Encode4(1741061), // Rule ID 10903 //
     /* 1740980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1740983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1740988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1740991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1740994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1740997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1741000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741026 */     // MIs[0] policy
     /* 1741026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741036 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1741039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1741057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741060 */     // GIR_Coverage, 10903,
     /* 1741060 */     GIR_EraseRootFromParent_Done,
     /* 1741061 */   // Label 23748: @1741061
     /* 1741061 */   GIM_Try, /*On fail goto*//*Label 23749*/ GIMT_Encode4(1741147), // Rule ID 10906 //
     /* 1741066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1741074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1741077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1741080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1741083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1741086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741112 */     // MIs[0] policy
     /* 1741112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741122 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1741125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741146 */     // GIR_Coverage, 10906,
     /* 1741146 */     GIR_EraseRootFromParent_Done,
     /* 1741147 */   // Label 23749: @1741147
     /* 1741147 */   GIM_Try, /*On fail goto*//*Label 23750*/ GIMT_Encode4(1741233), // Rule ID 10907 //
     /* 1741152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1741160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1741163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1741166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1741169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1741172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741198 */     // MIs[0] policy
     /* 1741198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741208 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1741211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741232 */     // GIR_Coverage, 10907,
     /* 1741232 */     GIR_EraseRootFromParent_Done,
     /* 1741233 */   // Label 23750: @1741233
     /* 1741233 */   GIM_Try, /*On fail goto*//*Label 23751*/ GIMT_Encode4(1741319), // Rule ID 10910 //
     /* 1741238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1741246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1741249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1741252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1741255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1741258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741284 */     // MIs[0] policy
     /* 1741284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741294 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1741297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741318 */     // GIR_Coverage, 10910,
     /* 1741318 */     GIR_EraseRootFromParent_Done,
     /* 1741319 */   // Label 23751: @1741319
     /* 1741319 */   GIM_Try, /*On fail goto*//*Label 23752*/ GIMT_Encode4(1741405), // Rule ID 10911 //
     /* 1741324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1741332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1741335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1741338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1741341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1741344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741370 */     // MIs[0] policy
     /* 1741370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741380 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1741383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741404 */     // GIR_Coverage, 10911,
     /* 1741404 */     GIR_EraseRootFromParent_Done,
     /* 1741405 */   // Label 23752: @1741405
     /* 1741405 */   GIM_Try, /*On fail goto*//*Label 23753*/ GIMT_Encode4(1741491), // Rule ID 10914 //
     /* 1741410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1741418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1741421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1741424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1741427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1741430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1741433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741456 */     // MIs[0] policy
     /* 1741456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741466 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1741469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741490 */     // GIR_Coverage, 10914,
     /* 1741490 */     GIR_EraseRootFromParent_Done,
     /* 1741491 */   // Label 23753: @1741491
     /* 1741491 */   GIM_Try, /*On fail goto*//*Label 23754*/ GIMT_Encode4(1741577), // Rule ID 10915 //
     /* 1741496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1741504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1741507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1741510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1741513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1741516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1741519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741542 */     // MIs[0] policy
     /* 1741542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741552 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1741555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741576 */     // GIR_Coverage, 10915,
     /* 1741576 */     GIR_EraseRootFromParent_Done,
     /* 1741577 */   // Label 23754: @1741577
     /* 1741577 */   GIM_Try, /*On fail goto*//*Label 23755*/ GIMT_Encode4(1741663), // Rule ID 10918 //
     /* 1741582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1741590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1741593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1741596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1741599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1741602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1741605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741628 */     // MIs[0] policy
     /* 1741628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741638 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1741641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741662 */     // GIR_Coverage, 10918,
     /* 1741662 */     GIR_EraseRootFromParent_Done,
     /* 1741663 */   // Label 23755: @1741663
     /* 1741663 */   GIM_Try, /*On fail goto*//*Label 23756*/ GIMT_Encode4(1741749), // Rule ID 10919 //
     /* 1741668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1741676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1741679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1741682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1741685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1741688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1741691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741714 */     // MIs[0] policy
     /* 1741714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741724 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1741727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741748 */     // GIR_Coverage, 10919,
     /* 1741748 */     GIR_EraseRootFromParent_Done,
     /* 1741749 */   // Label 23756: @1741749
     /* 1741749 */   GIM_Try, /*On fail goto*//*Label 23757*/ GIMT_Encode4(1741835), // Rule ID 10922 //
     /* 1741754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1741762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1741765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1741768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1741771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1741774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741800 */     // MIs[0] policy
     /* 1741800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741810 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1741813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741834 */     // GIR_Coverage, 10922,
     /* 1741834 */     GIR_EraseRootFromParent_Done,
     /* 1741835 */   // Label 23757: @1741835
     /* 1741835 */   GIM_Try, /*On fail goto*//*Label 23758*/ GIMT_Encode4(1741921), // Rule ID 10923 //
     /* 1741840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1741848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1741851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1741854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1741857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1741860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741886 */     // MIs[0] policy
     /* 1741886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741896 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1741899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741920 */     // GIR_Coverage, 10923,
     /* 1741920 */     GIR_EraseRootFromParent_Done,
     /* 1741921 */   // Label 23758: @1741921
     /* 1741921 */   GIM_Try, /*On fail goto*//*Label 23759*/ GIMT_Encode4(1742007), // Rule ID 10926 //
     /* 1741926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1741934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1741937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1741940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1741943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1741946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741972 */     // MIs[0] policy
     /* 1741972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741982 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1741985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742006 */     // GIR_Coverage, 10926,
     /* 1742006 */     GIR_EraseRootFromParent_Done,
     /* 1742007 */   // Label 23759: @1742007
     /* 1742007 */   GIM_Try, /*On fail goto*//*Label 23760*/ GIMT_Encode4(1742093), // Rule ID 10927 //
     /* 1742012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1742020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1742023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1742026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1742029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1742032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1742035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742058 */     // MIs[0] policy
     /* 1742058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742068 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1742071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742092 */     // GIR_Coverage, 10927,
     /* 1742092 */     GIR_EraseRootFromParent_Done,
     /* 1742093 */   // Label 23760: @1742093
     /* 1742093 */   GIM_Try, /*On fail goto*//*Label 23761*/ GIMT_Encode4(1742179), // Rule ID 10930 //
     /* 1742098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1742106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1742109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1742112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1742115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1742118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742144 */     // MIs[0] policy
     /* 1742144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742154 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1742157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742178 */     // GIR_Coverage, 10930,
     /* 1742178 */     GIR_EraseRootFromParent_Done,
     /* 1742179 */   // Label 23761: @1742179
     /* 1742179 */   GIM_Try, /*On fail goto*//*Label 23762*/ GIMT_Encode4(1742265), // Rule ID 10931 //
     /* 1742184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1742192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1742195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1742198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1742201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1742204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742230 */     // MIs[0] policy
     /* 1742230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742240 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1742243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742264 */     // GIR_Coverage, 10931,
     /* 1742264 */     GIR_EraseRootFromParent_Done,
     /* 1742265 */   // Label 23762: @1742265
     /* 1742265 */   GIM_Try, /*On fail goto*//*Label 23763*/ GIMT_Encode4(1742351), // Rule ID 10934 //
     /* 1742270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1742278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1742281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1742284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1742287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1742290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742316 */     // MIs[0] policy
     /* 1742316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742326 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1742329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742350 */     // GIR_Coverage, 10934,
     /* 1742350 */     GIR_EraseRootFromParent_Done,
     /* 1742351 */   // Label 23763: @1742351
     /* 1742351 */   GIM_Try, /*On fail goto*//*Label 23764*/ GIMT_Encode4(1742437), // Rule ID 10935 //
     /* 1742356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1742364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1742367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1742370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1742373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1742376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742402 */     // MIs[0] policy
     /* 1742402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742412 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1742415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742436 */     // GIR_Coverage, 10935,
     /* 1742436 */     GIR_EraseRootFromParent_Done,
     /* 1742437 */   // Label 23764: @1742437
     /* 1742437 */   GIM_Try, /*On fail goto*//*Label 23765*/ GIMT_Encode4(1742523), // Rule ID 10938 //
     /* 1742442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1742450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1742453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1742456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1742459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1742462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742488 */     // MIs[0] policy
     /* 1742488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742498 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1742501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742522 */     // GIR_Coverage, 10938,
     /* 1742522 */     GIR_EraseRootFromParent_Done,
     /* 1742523 */   // Label 23765: @1742523
     /* 1742523 */   GIM_Try, /*On fail goto*//*Label 23766*/ GIMT_Encode4(1742609), // Rule ID 10939 //
     /* 1742528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1742536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1742539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1742542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1742545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1742548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742574 */     // MIs[0] policy
     /* 1742574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742584 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1742587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742608 */     // GIR_Coverage, 10939,
     /* 1742608 */     GIR_EraseRootFromParent_Done,
     /* 1742609 */   // Label 23766: @1742609
     /* 1742609 */   GIM_Try, /*On fail goto*//*Label 23767*/ GIMT_Encode4(1742695), // Rule ID 10942 //
     /* 1742614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1742617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1742622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1742625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1742628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1742631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1742634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1742637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742660 */     // MIs[0] policy
     /* 1742660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1742673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742694 */     // GIR_Coverage, 10942,
     /* 1742694 */     GIR_EraseRootFromParent_Done,
     /* 1742695 */   // Label 23767: @1742695
     /* 1742695 */   GIM_Try, /*On fail goto*//*Label 23768*/ GIMT_Encode4(1742781), // Rule ID 10943 //
     /* 1742700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1742703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1742708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1742711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1742714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1742717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1742720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1742723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742746 */     // MIs[0] policy
     /* 1742746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742756 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1742759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742780 */     // GIR_Coverage, 10943,
     /* 1742780 */     GIR_EraseRootFromParent_Done,
     /* 1742781 */   // Label 23768: @1742781
     /* 1742781 */   GIM_Try, /*On fail goto*//*Label 23769*/ GIMT_Encode4(1742867), // Rule ID 10946 //
     /* 1742786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1742789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1742794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1742797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1742800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1742803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1742806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742832 */     // MIs[0] policy
     /* 1742832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742842 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1742845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742866 */     // GIR_Coverage, 10946,
     /* 1742866 */     GIR_EraseRootFromParent_Done,
     /* 1742867 */   // Label 23769: @1742867
     /* 1742867 */   GIM_Try, /*On fail goto*//*Label 23770*/ GIMT_Encode4(1742953), // Rule ID 10947 //
     /* 1742872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1742875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1742880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1742883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1742886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1742889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1742892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742918 */     // MIs[0] policy
     /* 1742918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742928 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1742931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742952 */     // GIR_Coverage, 10947,
     /* 1742952 */     GIR_EraseRootFromParent_Done,
     /* 1742953 */   // Label 23770: @1742953
     /* 1742953 */   GIM_Try, /*On fail goto*//*Label 23771*/ GIMT_Encode4(1743039), // Rule ID 10950 //
     /* 1742958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1742961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1742966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1742969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1742972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1742975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1742978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743004 */     // MIs[0] policy
     /* 1743004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743014 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1743017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743038 */     // GIR_Coverage, 10950,
     /* 1743038 */     GIR_EraseRootFromParent_Done,
     /* 1743039 */   // Label 23771: @1743039
     /* 1743039 */   GIM_Try, /*On fail goto*//*Label 23772*/ GIMT_Encode4(1743125), // Rule ID 10951 //
     /* 1743044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1743047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1743052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1743055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1743058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1743061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743090 */     // MIs[0] policy
     /* 1743090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743100 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1743103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743124 */     // GIR_Coverage, 10951,
     /* 1743124 */     GIR_EraseRootFromParent_Done,
     /* 1743125 */   // Label 23772: @1743125
     /* 1743125 */   GIM_Try, /*On fail goto*//*Label 23773*/ GIMT_Encode4(1743211), // Rule ID 10954 //
     /* 1743130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1743141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1743144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1743147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1743150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743176 */     // MIs[0] policy
     /* 1743176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743186 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1743189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743210 */     // GIR_Coverage, 10954,
     /* 1743210 */     GIR_EraseRootFromParent_Done,
     /* 1743211 */   // Label 23773: @1743211
     /* 1743211 */   GIM_Try, /*On fail goto*//*Label 23774*/ GIMT_Encode4(1743297), // Rule ID 10955 //
     /* 1743216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1743227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1743230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1743233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1743236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743262 */     // MIs[0] policy
     /* 1743262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743272 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1743275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743296 */     // GIR_Coverage, 10955,
     /* 1743296 */     GIR_EraseRootFromParent_Done,
     /* 1743297 */   // Label 23774: @1743297
     /* 1743297 */   GIM_Try, /*On fail goto*//*Label 23775*/ GIMT_Encode4(1743383), // Rule ID 10958 //
     /* 1743302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1743313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1743316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1743319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1743322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743348 */     // MIs[0] policy
     /* 1743348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743358 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1743361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743382 */     // GIR_Coverage, 10958,
     /* 1743382 */     GIR_EraseRootFromParent_Done,
     /* 1743383 */   // Label 23775: @1743383
     /* 1743383 */   GIM_Try, /*On fail goto*//*Label 23776*/ GIMT_Encode4(1743469), // Rule ID 10959 //
     /* 1743388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1743399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1743402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1743405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1743408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743434 */     // MIs[0] policy
     /* 1743434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743444 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1743447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743468 */     // GIR_Coverage, 10959,
     /* 1743468 */     GIR_EraseRootFromParent_Done,
     /* 1743469 */   // Label 23776: @1743469
     /* 1743469 */   GIM_Try, /*On fail goto*//*Label 23777*/ GIMT_Encode4(1743555), // Rule ID 10962 //
     /* 1743474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1743485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1743488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1743491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1743494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743520 */     // MIs[0] policy
     /* 1743520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743530 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1743533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743554 */     // GIR_Coverage, 10962,
     /* 1743554 */     GIR_EraseRootFromParent_Done,
     /* 1743555 */   // Label 23777: @1743555
     /* 1743555 */   GIM_Try, /*On fail goto*//*Label 23778*/ GIMT_Encode4(1743641), // Rule ID 10963 //
     /* 1743560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1743571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1743574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1743577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1743580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743606 */     // MIs[0] policy
     /* 1743606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743616 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1743619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743640 */     // GIR_Coverage, 10963,
     /* 1743640 */     GIR_EraseRootFromParent_Done,
     /* 1743641 */   // Label 23778: @1743641
     /* 1743641 */   GIM_Try, /*On fail goto*//*Label 23779*/ GIMT_Encode4(1743727), // Rule ID 10966 //
     /* 1743646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1743657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1743660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1743663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1743666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743692 */     // MIs[0] policy
     /* 1743692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743702 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1743705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743726 */     // GIR_Coverage, 10966,
     /* 1743726 */     GIR_EraseRootFromParent_Done,
     /* 1743727 */   // Label 23779: @1743727
     /* 1743727 */   GIM_Try, /*On fail goto*//*Label 23780*/ GIMT_Encode4(1743813), // Rule ID 10967 //
     /* 1743732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1743743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1743746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1743749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1743752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743778 */     // MIs[0] policy
     /* 1743778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743788 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1743791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743812 */     // GIR_Coverage, 10967,
     /* 1743812 */     GIR_EraseRootFromParent_Done,
     /* 1743813 */   // Label 23780: @1743813
     /* 1743813 */   GIM_Try, /*On fail goto*//*Label 23781*/ GIMT_Encode4(1743899), // Rule ID 10970 //
     /* 1743818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1743829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1743832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1743835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1743838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743864 */     // MIs[0] policy
     /* 1743864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743874 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1743877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743898 */     // GIR_Coverage, 10970,
     /* 1743898 */     GIR_EraseRootFromParent_Done,
     /* 1743899 */   // Label 23781: @1743899
     /* 1743899 */   GIM_Try, /*On fail goto*//*Label 23782*/ GIMT_Encode4(1743985), // Rule ID 10971 //
     /* 1743904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1743915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1743918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1743921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1743924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743950 */     // MIs[0] policy
     /* 1743950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743960 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1743963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743984 */     // GIR_Coverage, 10971,
     /* 1743984 */     GIR_EraseRootFromParent_Done,
     /* 1743985 */   // Label 23782: @1743985
     /* 1743985 */   GIM_Try, /*On fail goto*//*Label 23783*/ GIMT_Encode4(1744071), // Rule ID 10974 //
     /* 1743990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1744001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1744004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1744007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1744010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744036 */     // MIs[0] policy
     /* 1744036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1744049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744070 */     // GIR_Coverage, 10974,
     /* 1744070 */     GIR_EraseRootFromParent_Done,
     /* 1744071 */   // Label 23783: @1744071
     /* 1744071 */   GIM_Try, /*On fail goto*//*Label 23784*/ GIMT_Encode4(1744157), // Rule ID 10975 //
     /* 1744076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1744087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1744090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1744093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1744096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744122 */     // MIs[0] policy
     /* 1744122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1744135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744156 */     // GIR_Coverage, 10975,
     /* 1744156 */     GIR_EraseRootFromParent_Done,
     /* 1744157 */   // Label 23784: @1744157
     /* 1744157 */   GIM_Try, /*On fail goto*//*Label 23785*/ GIMT_Encode4(1744243), // Rule ID 10978 //
     /* 1744162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1744173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1744176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1744179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1744182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744208 */     // MIs[0] policy
     /* 1744208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744218 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1744221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744242 */     // GIR_Coverage, 10978,
     /* 1744242 */     GIR_EraseRootFromParent_Done,
     /* 1744243 */   // Label 23785: @1744243
     /* 1744243 */   GIM_Try, /*On fail goto*//*Label 23786*/ GIMT_Encode4(1744329), // Rule ID 10979 //
     /* 1744248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1744259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1744262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1744265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1744268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744294 */     // MIs[0] policy
     /* 1744294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744304 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1744307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744328 */     // GIR_Coverage, 10979,
     /* 1744328 */     GIR_EraseRootFromParent_Done,
     /* 1744329 */   // Label 23786: @1744329
     /* 1744329 */   GIM_Try, /*On fail goto*//*Label 23787*/ GIMT_Encode4(1744415), // Rule ID 10982 //
     /* 1744334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1744345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1744348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1744351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1744354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744380 */     // MIs[0] policy
     /* 1744380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1744393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744414 */     // GIR_Coverage, 10982,
     /* 1744414 */     GIR_EraseRootFromParent_Done,
     /* 1744415 */   // Label 23787: @1744415
     /* 1744415 */   GIM_Try, /*On fail goto*//*Label 23788*/ GIMT_Encode4(1744501), // Rule ID 10983 //
     /* 1744420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1744431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1744434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1744437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1744440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744466 */     // MIs[0] policy
     /* 1744466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1744479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744500 */     // GIR_Coverage, 10983,
     /* 1744500 */     GIR_EraseRootFromParent_Done,
     /* 1744501 */   // Label 23788: @1744501
     /* 1744501 */   GIM_Try, /*On fail goto*//*Label 23789*/ GIMT_Encode4(1744587), // Rule ID 10986 //
     /* 1744506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1744517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1744520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1744523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1744526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744552 */     // MIs[0] policy
     /* 1744552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744562 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1744565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744586 */     // GIR_Coverage, 10986,
     /* 1744586 */     GIR_EraseRootFromParent_Done,
     /* 1744587 */   // Label 23789: @1744587
     /* 1744587 */   GIM_Try, /*On fail goto*//*Label 23790*/ GIMT_Encode4(1744673), // Rule ID 10987 //
     /* 1744592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1744603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1744606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1744609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1744612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744638 */     // MIs[0] policy
     /* 1744638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744648 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1744651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744672 */     // GIR_Coverage, 10987,
     /* 1744672 */     GIR_EraseRootFromParent_Done,
     /* 1744673 */   // Label 23790: @1744673
     /* 1744673 */   GIM_Try, /*On fail goto*//*Label 23791*/ GIMT_Encode4(1744759), // Rule ID 10990 //
     /* 1744678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1744681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1744689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1744692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1744695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1744698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744724 */     // MIs[0] policy
     /* 1744724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744734 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1744737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744758 */     // GIR_Coverage, 10990,
     /* 1744758 */     GIR_EraseRootFromParent_Done,
     /* 1744759 */   // Label 23791: @1744759
     /* 1744759 */   GIM_Try, /*On fail goto*//*Label 23792*/ GIMT_Encode4(1744845), // Rule ID 10991 //
     /* 1744764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1744767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1744775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1744778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1744781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1744784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744810 */     // MIs[0] policy
     /* 1744810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744820 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1744823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744844 */     // GIR_Coverage, 10991,
     /* 1744844 */     GIR_EraseRootFromParent_Done,
     /* 1744845 */   // Label 23792: @1744845
     /* 1744845 */   GIM_Try, /*On fail goto*//*Label 23793*/ GIMT_Encode4(1744931), // Rule ID 10994 //
     /* 1744850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1744861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1744864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1744867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1744870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1744873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1744880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744896 */     // MIs[0] policy
     /* 1744896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744906 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1744909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744930 */     // GIR_Coverage, 10994,
     /* 1744930 */     GIR_EraseRootFromParent_Done,
     /* 1744931 */   // Label 23793: @1744931
     /* 1744931 */   GIM_Try, /*On fail goto*//*Label 23794*/ GIMT_Encode4(1745017), // Rule ID 10995 //
     /* 1744936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1744947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1744950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1744953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1744956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1744959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1744966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744982 */     // MIs[0] policy
     /* 1744982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744992 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1744995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745016 */     // GIR_Coverage, 10995,
     /* 1745016 */     GIR_EraseRootFromParent_Done,
     /* 1745017 */   // Label 23794: @1745017
     /* 1745017 */   GIM_Try, /*On fail goto*//*Label 23795*/ GIMT_Encode4(1745103), // Rule ID 10998 //
     /* 1745022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1745033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1745036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1745039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1745042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745068 */     // MIs[0] policy
     /* 1745068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745078 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1745081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745102 */     // GIR_Coverage, 10998,
     /* 1745102 */     GIR_EraseRootFromParent_Done,
     /* 1745103 */   // Label 23795: @1745103
     /* 1745103 */   GIM_Try, /*On fail goto*//*Label 23796*/ GIMT_Encode4(1745189), // Rule ID 10999 //
     /* 1745108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1745119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1745122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1745125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1745128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745154 */     // MIs[0] policy
     /* 1745154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745164 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1745167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745188 */     // GIR_Coverage, 10999,
     /* 1745188 */     GIR_EraseRootFromParent_Done,
     /* 1745189 */   // Label 23796: @1745189
     /* 1745189 */   GIM_Try, /*On fail goto*//*Label 23797*/ GIMT_Encode4(1745275), // Rule ID 11002 //
     /* 1745194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1745205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1745208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1745211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1745214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1745217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745240 */     // MIs[0] policy
     /* 1745240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745250 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1745253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745274 */     // GIR_Coverage, 11002,
     /* 1745274 */     GIR_EraseRootFromParent_Done,
     /* 1745275 */   // Label 23797: @1745275
     /* 1745275 */   GIM_Try, /*On fail goto*//*Label 23798*/ GIMT_Encode4(1745361), // Rule ID 11003 //
     /* 1745280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1745291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1745294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1745297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1745300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1745303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745326 */     // MIs[0] policy
     /* 1745326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745336 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1745339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745360 */     // GIR_Coverage, 11003,
     /* 1745360 */     GIR_EraseRootFromParent_Done,
     /* 1745361 */   // Label 23798: @1745361
     /* 1745361 */   GIM_Try, /*On fail goto*//*Label 23799*/ GIMT_Encode4(1745447), // Rule ID 11006 //
     /* 1745366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1745383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1745386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745412 */     // MIs[0] policy
     /* 1745412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745422 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1745425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745446 */     // GIR_Coverage, 11006,
     /* 1745446 */     GIR_EraseRootFromParent_Done,
     /* 1745447 */   // Label 23799: @1745447
     /* 1745447 */   GIM_Try, /*On fail goto*//*Label 23800*/ GIMT_Encode4(1745533), // Rule ID 11007 //
     /* 1745452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1745469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1745472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745498 */     // MIs[0] policy
     /* 1745498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1745511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745532 */     // GIR_Coverage, 11007,
     /* 1745532 */     GIR_EraseRootFromParent_Done,
     /* 1745533 */   // Label 23800: @1745533
     /* 1745533 */   GIM_Try, /*On fail goto*//*Label 23801*/ GIMT_Encode4(1745619), // Rule ID 11010 //
     /* 1745538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1745549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1745552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1745555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1745558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745584 */     // MIs[0] policy
     /* 1745584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745594 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1745597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745618 */     // GIR_Coverage, 11010,
     /* 1745618 */     GIR_EraseRootFromParent_Done,
     /* 1745619 */   // Label 23801: @1745619
     /* 1745619 */   GIM_Try, /*On fail goto*//*Label 23802*/ GIMT_Encode4(1745705), // Rule ID 11011 //
     /* 1745624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1745635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1745638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1745641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1745644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745670 */     // MIs[0] policy
     /* 1745670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745680 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1745683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745704 */     // GIR_Coverage, 11011,
     /* 1745704 */     GIR_EraseRootFromParent_Done,
     /* 1745705 */   // Label 23802: @1745705
     /* 1745705 */   GIM_Try, /*On fail goto*//*Label 23803*/ GIMT_Encode4(1745791), // Rule ID 11014 //
     /* 1745710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1745721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1745724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1745727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1745730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745756 */     // MIs[0] policy
     /* 1745756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745766 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1745769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745790 */     // GIR_Coverage, 11014,
     /* 1745790 */     GIR_EraseRootFromParent_Done,
     /* 1745791 */   // Label 23803: @1745791
     /* 1745791 */   GIM_Try, /*On fail goto*//*Label 23804*/ GIMT_Encode4(1745877), // Rule ID 11015 //
     /* 1745796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1745807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1745810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1745813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1745816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745842 */     // MIs[0] policy
     /* 1745842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745852 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1745855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745876 */     // GIR_Coverage, 11015,
     /* 1745876 */     GIR_EraseRootFromParent_Done,
     /* 1745877 */   // Label 23804: @1745877
     /* 1745877 */   GIM_Try, /*On fail goto*//*Label 23805*/ GIMT_Encode4(1745963), // Rule ID 11018 //
     /* 1745882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1745893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1745896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1745899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1745902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1745905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745928 */     // MIs[0] policy
     /* 1745928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1745941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1745959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745962 */     // GIR_Coverage, 11018,
     /* 1745962 */     GIR_EraseRootFromParent_Done,
     /* 1745963 */   // Label 23805: @1745963
     /* 1745963 */   GIM_Try, /*On fail goto*//*Label 23806*/ GIMT_Encode4(1746049), // Rule ID 11019 //
     /* 1745968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1745979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1745982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1745985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1745988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1745991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746014 */     // MIs[0] policy
     /* 1746014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746024 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1746027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746048 */     // GIR_Coverage, 11019,
     /* 1746048 */     GIR_EraseRootFromParent_Done,
     /* 1746049 */   // Label 23806: @1746049
     /* 1746049 */   GIM_Try, /*On fail goto*//*Label 23807*/ GIMT_Encode4(1746135), // Rule ID 11022 //
     /* 1746054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1746071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1746074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746100 */     // MIs[0] policy
     /* 1746100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746110 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1746113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746134 */     // GIR_Coverage, 11022,
     /* 1746134 */     GIR_EraseRootFromParent_Done,
     /* 1746135 */   // Label 23807: @1746135
     /* 1746135 */   GIM_Try, /*On fail goto*//*Label 23808*/ GIMT_Encode4(1746221), // Rule ID 11023 //
     /* 1746140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1746157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1746160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746186 */     // MIs[0] policy
     /* 1746186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746196 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1746199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746220 */     // GIR_Coverage, 11023,
     /* 1746220 */     GIR_EraseRootFromParent_Done,
     /* 1746221 */   // Label 23808: @1746221
     /* 1746221 */   GIM_Try, /*On fail goto*//*Label 23809*/ GIMT_Encode4(1746307), // Rule ID 11026 //
     /* 1746226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1746243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1746246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746272 */     // MIs[0] policy
     /* 1746272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746282 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1746285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746306 */     // GIR_Coverage, 11026,
     /* 1746306 */     GIR_EraseRootFromParent_Done,
     /* 1746307 */   // Label 23809: @1746307
     /* 1746307 */   GIM_Try, /*On fail goto*//*Label 23810*/ GIMT_Encode4(1746393), // Rule ID 11027 //
     /* 1746312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1746329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1746332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746358 */     // MIs[0] policy
     /* 1746358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1746371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746392 */     // GIR_Coverage, 11027,
     /* 1746392 */     GIR_EraseRootFromParent_Done,
     /* 1746393 */   // Label 23810: @1746393
     /* 1746393 */   GIM_Try, /*On fail goto*//*Label 23811*/ GIMT_Encode4(1746479), // Rule ID 11030 //
     /* 1746398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1746401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1746409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1746412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1746415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1746418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746444 */     // MIs[0] policy
     /* 1746444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746454 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1746457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746478 */     // GIR_Coverage, 11030,
     /* 1746478 */     GIR_EraseRootFromParent_Done,
     /* 1746479 */   // Label 23811: @1746479
     /* 1746479 */   GIM_Try, /*On fail goto*//*Label 23812*/ GIMT_Encode4(1746565), // Rule ID 11031 //
     /* 1746484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1746487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1746495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1746498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1746501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1746504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746530 */     // MIs[0] policy
     /* 1746530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746540 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1746543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746564 */     // GIR_Coverage, 11031,
     /* 1746564 */     GIR_EraseRootFromParent_Done,
     /* 1746565 */   // Label 23812: @1746565
     /* 1746565 */   GIM_Try, /*On fail goto*//*Label 23813*/ GIMT_Encode4(1746651), // Rule ID 11034 //
     /* 1746570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1746573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1746581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1746584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1746587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1746590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746616 */     // MIs[0] policy
     /* 1746616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746626 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1746629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746650 */     // GIR_Coverage, 11034,
     /* 1746650 */     GIR_EraseRootFromParent_Done,
     /* 1746651 */   // Label 23813: @1746651
     /* 1746651 */   GIM_Try, /*On fail goto*//*Label 23814*/ GIMT_Encode4(1746737), // Rule ID 11035 //
     /* 1746656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1746659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1746667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1746670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1746673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1746676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746702 */     // MIs[0] policy
     /* 1746702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746712 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1746715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746736 */     // GIR_Coverage, 11035,
     /* 1746736 */     GIR_EraseRootFromParent_Done,
     /* 1746737 */   // Label 23814: @1746737
     /* 1746737 */   GIM_Try, /*On fail goto*//*Label 23815*/ GIMT_Encode4(1746823), // Rule ID 11038 //
     /* 1746742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1746745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1746753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1746756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1746759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1746762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746788 */     // MIs[0] policy
     /* 1746788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746798 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1746801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746822 */     // GIR_Coverage, 11038,
     /* 1746822 */     GIR_EraseRootFromParent_Done,
     /* 1746823 */   // Label 23815: @1746823
     /* 1746823 */   GIM_Try, /*On fail goto*//*Label 23816*/ GIMT_Encode4(1746909), // Rule ID 11039 //
     /* 1746828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1746831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1746839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1746842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1746845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1746848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746874 */     // MIs[0] policy
     /* 1746874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746884 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1746887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746908 */     // GIR_Coverage, 11039,
     /* 1746908 */     GIR_EraseRootFromParent_Done,
     /* 1746909 */   // Label 23816: @1746909
     /* 1746909 */   GIM_Try, /*On fail goto*//*Label 23817*/ GIMT_Encode4(1746995), // Rule ID 11042 //
     /* 1746914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1746925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1746928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1746931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1746937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746960 */     // MIs[0] policy
     /* 1746960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746970 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1746973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746994 */     // GIR_Coverage, 11042,
     /* 1746994 */     GIR_EraseRootFromParent_Done,
     /* 1746995 */   // Label 23817: @1746995
     /* 1746995 */   GIM_Try, /*On fail goto*//*Label 23818*/ GIMT_Encode4(1747081), // Rule ID 11043 //
     /* 1747000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1747011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1747014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1747017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1747020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747046 */     // MIs[0] policy
     /* 1747046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747056 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1747059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747080 */     // GIR_Coverage, 11043,
     /* 1747080 */     GIR_EraseRootFromParent_Done,
     /* 1747081 */   // Label 23818: @1747081
     /* 1747081 */   GIM_Try, /*On fail goto*//*Label 23819*/ GIMT_Encode4(1747167), // Rule ID 11046 //
     /* 1747086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1747097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1747100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1747103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1747106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747132 */     // MIs[0] policy
     /* 1747132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747142 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1747145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747166 */     // GIR_Coverage, 11046,
     /* 1747166 */     GIR_EraseRootFromParent_Done,
     /* 1747167 */   // Label 23819: @1747167
     /* 1747167 */   GIM_Try, /*On fail goto*//*Label 23820*/ GIMT_Encode4(1747253), // Rule ID 11047 //
     /* 1747172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1747183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1747186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1747189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1747192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747218 */     // MIs[0] policy
     /* 1747218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747228 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1747231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747252 */     // GIR_Coverage, 11047,
     /* 1747252 */     GIR_EraseRootFromParent_Done,
     /* 1747253 */   // Label 23820: @1747253
     /* 1747253 */   GIM_Try, /*On fail goto*//*Label 23821*/ GIMT_Encode4(1747339), // Rule ID 11050 //
     /* 1747258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1747269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1747272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1747275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1747278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747304 */     // MIs[0] policy
     /* 1747304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747314 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1747317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747338 */     // GIR_Coverage, 11050,
     /* 1747338 */     GIR_EraseRootFromParent_Done,
     /* 1747339 */   // Label 23821: @1747339
     /* 1747339 */   GIM_Try, /*On fail goto*//*Label 23822*/ GIMT_Encode4(1747425), // Rule ID 11051 //
     /* 1747344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1747355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1747358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1747361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1747364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747390 */     // MIs[0] policy
     /* 1747390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747400 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1747403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747424 */     // GIR_Coverage, 11051,
     /* 1747424 */     GIR_EraseRootFromParent_Done,
     /* 1747425 */   // Label 23822: @1747425
     /* 1747425 */   GIM_Try, /*On fail goto*//*Label 23823*/ GIMT_Encode4(1747511), // Rule ID 11054 //
     /* 1747430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1747441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1747444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1747447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1747450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747476 */     // MIs[0] policy
     /* 1747476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747486 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1747489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747510 */     // GIR_Coverage, 11054,
     /* 1747510 */     GIR_EraseRootFromParent_Done,
     /* 1747511 */   // Label 23823: @1747511
     /* 1747511 */   GIM_Try, /*On fail goto*//*Label 23824*/ GIMT_Encode4(1747597), // Rule ID 11055 //
     /* 1747516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1747527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1747530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1747533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1747536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747562 */     // MIs[0] policy
     /* 1747562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747572 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1747575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747596 */     // GIR_Coverage, 11055,
     /* 1747596 */     GIR_EraseRootFromParent_Done,
     /* 1747597 */   // Label 23824: @1747597
     /* 1747597 */   GIM_Try, /*On fail goto*//*Label 23825*/ GIMT_Encode4(1747683), // Rule ID 11058 //
     /* 1747602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1747613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1747616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1747619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1747622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747648 */     // MIs[0] policy
     /* 1747648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747658 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1747661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747682 */     // GIR_Coverage, 11058,
     /* 1747682 */     GIR_EraseRootFromParent_Done,
     /* 1747683 */   // Label 23825: @1747683
     /* 1747683 */   GIM_Try, /*On fail goto*//*Label 23826*/ GIMT_Encode4(1747769), // Rule ID 11059 //
     /* 1747688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1747699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1747702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1747705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1747708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747734 */     // MIs[0] policy
     /* 1747734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1747747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747768 */     // GIR_Coverage, 11059,
     /* 1747768 */     GIR_EraseRootFromParent_Done,
     /* 1747769 */   // Label 23826: @1747769
     /* 1747769 */   GIM_Try, /*On fail goto*//*Label 23827*/ GIMT_Encode4(1747855), // Rule ID 11062 //
     /* 1747774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1747785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1747788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1747791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1747794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747820 */     // MIs[0] policy
     /* 1747820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747830 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1747833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747854 */     // GIR_Coverage, 11062,
     /* 1747854 */     GIR_EraseRootFromParent_Done,
     /* 1747855 */   // Label 23827: @1747855
     /* 1747855 */   GIM_Try, /*On fail goto*//*Label 23828*/ GIMT_Encode4(1747941), // Rule ID 11063 //
     /* 1747860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1747871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1747874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1747877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1747880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747906 */     // MIs[0] policy
     /* 1747906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747916 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1747919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747940 */     // GIR_Coverage, 11063,
     /* 1747940 */     GIR_EraseRootFromParent_Done,
     /* 1747941 */   // Label 23828: @1747941
     /* 1747941 */   GIM_Try, /*On fail goto*//*Label 23829*/ GIMT_Encode4(1748027), // Rule ID 11066 //
     /* 1747946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1747957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1747960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1747963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1747966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747992 */     // MIs[0] policy
     /* 1747992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748002 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1748005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748026 */     // GIR_Coverage, 11066,
     /* 1748026 */     GIR_EraseRootFromParent_Done,
     /* 1748027 */   // Label 23829: @1748027
     /* 1748027 */   GIM_Try, /*On fail goto*//*Label 23830*/ GIMT_Encode4(1748113), // Rule ID 11067 //
     /* 1748032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1748040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1748043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1748046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1748049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1748052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748078 */     // MIs[0] policy
     /* 1748078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748088 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1748091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748112 */     // GIR_Coverage, 11067,
     /* 1748112 */     GIR_EraseRootFromParent_Done,
     /* 1748113 */   // Label 23830: @1748113
     /* 1748113 */   GIM_Try, /*On fail goto*//*Label 23831*/ GIMT_Encode4(1748199), // Rule ID 11070 //
     /* 1748118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1748126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1748129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1748132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1748135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1748138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748164 */     // MIs[0] policy
     /* 1748164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1748177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748198 */     // GIR_Coverage, 11070,
     /* 1748198 */     GIR_EraseRootFromParent_Done,
     /* 1748199 */   // Label 23831: @1748199
     /* 1748199 */   GIM_Try, /*On fail goto*//*Label 23832*/ GIMT_Encode4(1748285), // Rule ID 11071 //
     /* 1748204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1748212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1748215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1748218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1748221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1748224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748250 */     // MIs[0] policy
     /* 1748250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748260 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1748263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748284 */     // GIR_Coverage, 11071,
     /* 1748284 */     GIR_EraseRootFromParent_Done,
     /* 1748285 */   // Label 23832: @1748285
     /* 1748285 */   GIM_Try, /*On fail goto*//*Label 23833*/ GIMT_Encode4(1748371), // Rule ID 11074 //
     /* 1748290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1748298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1748301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1748304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1748307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1748310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748336 */     // MIs[0] policy
     /* 1748336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748346 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1748349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748370 */     // GIR_Coverage, 11074,
     /* 1748370 */     GIR_EraseRootFromParent_Done,
     /* 1748371 */   // Label 23833: @1748371
     /* 1748371 */   GIM_Try, /*On fail goto*//*Label 23834*/ GIMT_Encode4(1748457), // Rule ID 11075 //
     /* 1748376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1748384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1748387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1748390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1748393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1748396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748422 */     // MIs[0] policy
     /* 1748422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1748435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748456 */     // GIR_Coverage, 11075,
     /* 1748456 */     GIR_EraseRootFromParent_Done,
     /* 1748457 */   // Label 23834: @1748457
     /* 1748457 */   GIM_Try, /*On fail goto*//*Label 23835*/ GIMT_Encode4(1748543), // Rule ID 11078 //
     /* 1748462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1748465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1748470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1748473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1748476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1748479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1748482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1748485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748508 */     // MIs[0] policy
     /* 1748508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1748521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1748539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748542 */     // GIR_Coverage, 11078,
     /* 1748542 */     GIR_EraseRootFromParent_Done,
     /* 1748543 */   // Label 23835: @1748543
     /* 1748543 */   GIM_Try, /*On fail goto*//*Label 23836*/ GIMT_Encode4(1748629), // Rule ID 11079 //
     /* 1748548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1748551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1748556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1748559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1748562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1748565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1748568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1748571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748594 */     // MIs[0] policy
     /* 1748594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748604 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1748607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1748625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748628 */     // GIR_Coverage, 11079,
     /* 1748628 */     GIR_EraseRootFromParent_Done,
     /* 1748629 */   // Label 23836: @1748629
     /* 1748629 */   GIM_Try, /*On fail goto*//*Label 23837*/ GIMT_Encode4(1748715), // Rule ID 11082 //
     /* 1748634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1748642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1748645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1748648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1748651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1748654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748680 */     // MIs[0] policy
     /* 1748680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748690 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1748693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748714 */     // GIR_Coverage, 11082,
     /* 1748714 */     GIR_EraseRootFromParent_Done,
     /* 1748715 */   // Label 23837: @1748715
     /* 1748715 */   GIM_Try, /*On fail goto*//*Label 23838*/ GIMT_Encode4(1748801), // Rule ID 11083 //
     /* 1748720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1748728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1748731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1748734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1748737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1748740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748766 */     // MIs[0] policy
     /* 1748766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748776 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1748779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748800 */     // GIR_Coverage, 11083,
     /* 1748800 */     GIR_EraseRootFromParent_Done,
     /* 1748801 */   // Label 23838: @1748801
     /* 1748801 */   GIM_Try, /*On fail goto*//*Label 23839*/ GIMT_Encode4(1748887), // Rule ID 11086 //
     /* 1748806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1748814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1748817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1748820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1748823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1748826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1748829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1748836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748852 */     // MIs[0] policy
     /* 1748852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748862 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1748865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748886 */     // GIR_Coverage, 11086,
     /* 1748886 */     GIR_EraseRootFromParent_Done,
     /* 1748887 */   // Label 23839: @1748887
     /* 1748887 */   GIM_Try, /*On fail goto*//*Label 23840*/ GIMT_Encode4(1748973), // Rule ID 11087 //
     /* 1748892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1748900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1748903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1748906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1748909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1748912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1748915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1748922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748938 */     // MIs[0] policy
     /* 1748938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748948 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1748951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748972 */     // GIR_Coverage, 11087,
     /* 1748972 */     GIR_EraseRootFromParent_Done,
     /* 1748973 */   // Label 23840: @1748973
     /* 1748973 */   GIM_Try, /*On fail goto*//*Label 23841*/ GIMT_Encode4(1749059), // Rule ID 11090 //
     /* 1748978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1748986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1748989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1748992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1748995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1748998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1749001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749024 */     // MIs[0] policy
     /* 1749024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749034 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1749037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749058 */     // GIR_Coverage, 11090,
     /* 1749058 */     GIR_EraseRootFromParent_Done,
     /* 1749059 */   // Label 23841: @1749059
     /* 1749059 */   GIM_Try, /*On fail goto*//*Label 23842*/ GIMT_Encode4(1749145), // Rule ID 11091 //
     /* 1749064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1749072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1749075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1749078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1749081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1749087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749110 */     // MIs[0] policy
     /* 1749110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749120 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1749123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749144 */     // GIR_Coverage, 11091,
     /* 1749144 */     GIR_EraseRootFromParent_Done,
     /* 1749145 */   // Label 23842: @1749145
     /* 1749145 */   GIM_Try, /*On fail goto*//*Label 23843*/ GIMT_Encode4(1749231), // Rule ID 11094 //
     /* 1749150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1749158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1749161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1749164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1749167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749196 */     // MIs[0] policy
     /* 1749196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1749209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749230 */     // GIR_Coverage, 11094,
     /* 1749230 */     GIR_EraseRootFromParent_Done,
     /* 1749231 */   // Label 23843: @1749231
     /* 1749231 */   GIM_Try, /*On fail goto*//*Label 23844*/ GIMT_Encode4(1749317), // Rule ID 11095 //
     /* 1749236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1749244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1749247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1749250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1749253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749282 */     // MIs[0] policy
     /* 1749282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1749295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749316 */     // GIR_Coverage, 11095,
     /* 1749316 */     GIR_EraseRootFromParent_Done,
     /* 1749317 */   // Label 23844: @1749317
     /* 1749317 */   GIM_Try, /*On fail goto*//*Label 23845*/ GIMT_Encode4(1749403), // Rule ID 11098 //
     /* 1749322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1749330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1749333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1749336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1749339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749368 */     // MIs[0] policy
     /* 1749368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749378 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1749381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749402 */     // GIR_Coverage, 11098,
     /* 1749402 */     GIR_EraseRootFromParent_Done,
     /* 1749403 */   // Label 23845: @1749403
     /* 1749403 */   GIM_Try, /*On fail goto*//*Label 23846*/ GIMT_Encode4(1749489), // Rule ID 11099 //
     /* 1749408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1749416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1749419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1749422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1749425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749454 */     // MIs[0] policy
     /* 1749454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749464 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1749467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749488 */     // GIR_Coverage, 11099,
     /* 1749488 */     GIR_EraseRootFromParent_Done,
     /* 1749489 */   // Label 23846: @1749489
     /* 1749489 */   GIM_Try, /*On fail goto*//*Label 23847*/ GIMT_Encode4(1749575), // Rule ID 11102 //
     /* 1749494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1749502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1749505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1749508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1749511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749540 */     // MIs[0] policy
     /* 1749540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749550 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1749553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749574 */     // GIR_Coverage, 11102,
     /* 1749574 */     GIR_EraseRootFromParent_Done,
     /* 1749575 */   // Label 23847: @1749575
     /* 1749575 */   GIM_Try, /*On fail goto*//*Label 23848*/ GIMT_Encode4(1749661), // Rule ID 11103 //
     /* 1749580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1749588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1749591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1749594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1749597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749626 */     // MIs[0] policy
     /* 1749626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749636 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1749639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749660 */     // GIR_Coverage, 11103,
     /* 1749660 */     GIR_EraseRootFromParent_Done,
     /* 1749661 */   // Label 23848: @1749661
     /* 1749661 */   GIM_Try, /*On fail goto*//*Label 23849*/ GIMT_Encode4(1749747), // Rule ID 11106 //
     /* 1749666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1749674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1749677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1749680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1749683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749712 */     // MIs[0] policy
     /* 1749712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1749725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749746 */     // GIR_Coverage, 11106,
     /* 1749746 */     GIR_EraseRootFromParent_Done,
     /* 1749747 */   // Label 23849: @1749747
     /* 1749747 */   GIM_Try, /*On fail goto*//*Label 23850*/ GIMT_Encode4(1749833), // Rule ID 11107 //
     /* 1749752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1749760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1749763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1749766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1749769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749798 */     // MIs[0] policy
     /* 1749798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749808 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1749811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749832 */     // GIR_Coverage, 11107,
     /* 1749832 */     GIR_EraseRootFromParent_Done,
     /* 1749833 */   // Label 23850: @1749833
     /* 1749833 */   GIM_Try, /*On fail goto*//*Label 23851*/ GIMT_Encode4(1749919), // Rule ID 11110 //
     /* 1749838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1749846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1749849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1749852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1749855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749884 */     // MIs[0] policy
     /* 1749884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749894 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1749897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749918 */     // GIR_Coverage, 11110,
     /* 1749918 */     GIR_EraseRootFromParent_Done,
     /* 1749919 */   // Label 23851: @1749919
     /* 1749919 */   GIM_Try, /*On fail goto*//*Label 23852*/ GIMT_Encode4(1750005), // Rule ID 11111 //
     /* 1749924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1749932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1749935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1749938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1749941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749970 */     // MIs[0] policy
     /* 1749970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1749983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750004 */     // GIR_Coverage, 11111,
     /* 1750004 */     GIR_EraseRootFromParent_Done,
     /* 1750005 */   // Label 23852: @1750005
     /* 1750005 */   GIM_Try, /*On fail goto*//*Label 23853*/ GIMT_Encode4(1750091), // Rule ID 11114 //
     /* 1750010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1750018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1750021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1750024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1750027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1750033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750056 */     // MIs[0] policy
     /* 1750056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750066 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1750069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750090 */     // GIR_Coverage, 11114,
     /* 1750090 */     GIR_EraseRootFromParent_Done,
     /* 1750091 */   // Label 23853: @1750091
     /* 1750091 */   GIM_Try, /*On fail goto*//*Label 23854*/ GIMT_Encode4(1750177), // Rule ID 11115 //
     /* 1750096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1750104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1750107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1750110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1750113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1750119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750142 */     // MIs[0] policy
     /* 1750142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750152 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1750155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750176 */     // GIR_Coverage, 11115,
     /* 1750176 */     GIR_EraseRootFromParent_Done,
     /* 1750177 */   // Label 23854: @1750177
     /* 1750177 */   GIM_Try, /*On fail goto*//*Label 23855*/ GIMT_Encode4(1750263), // Rule ID 11118 //
     /* 1750182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1750185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1750190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1750193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1750196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1750199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1750212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750228 */     // MIs[0] policy
     /* 1750228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1750241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1750259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750262 */     // GIR_Coverage, 11118,
     /* 1750262 */     GIR_EraseRootFromParent_Done,
     /* 1750263 */   // Label 23855: @1750263
     /* 1750263 */   GIM_Try, /*On fail goto*//*Label 23856*/ GIMT_Encode4(1750349), // Rule ID 11119 //
     /* 1750268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1750271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1750276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1750279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1750282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1750285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1750298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750314 */     // MIs[0] policy
     /* 1750314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1750327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1750345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750348 */     // GIR_Coverage, 11119,
     /* 1750348 */     GIR_EraseRootFromParent_Done,
     /* 1750349 */   // Label 23856: @1750349
     /* 1750349 */   GIM_Try, /*On fail goto*//*Label 23857*/ GIMT_Encode4(1750435), // Rule ID 11122 //
     /* 1750354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1750357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1750362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1750365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1750368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1750371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1750384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750400 */     // MIs[0] policy
     /* 1750400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750410 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1750413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1750431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750434 */     // GIR_Coverage, 11122,
     /* 1750434 */     GIR_EraseRootFromParent_Done,
     /* 1750435 */   // Label 23857: @1750435
     /* 1750435 */   GIM_Try, /*On fail goto*//*Label 23858*/ GIMT_Encode4(1750521), // Rule ID 11123 //
     /* 1750440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1750443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1750448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1750451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1750454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1750457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1750470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750486 */     // MIs[0] policy
     /* 1750486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1750499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1750517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750520 */     // GIR_Coverage, 11123,
     /* 1750520 */     GIR_EraseRootFromParent_Done,
     /* 1750521 */   // Label 23858: @1750521
     /* 1750521 */   GIM_Try, /*On fail goto*//*Label 23859*/ GIMT_Encode4(1750607), // Rule ID 11126 //
     /* 1750526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1750529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1750534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1750537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1750540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1750543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1750549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750572 */     // MIs[0] policy
     /* 1750572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750582 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1750585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1750603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750606 */     // GIR_Coverage, 11126,
     /* 1750606 */     GIR_EraseRootFromParent_Done,
     /* 1750607 */   // Label 23859: @1750607
     /* 1750607 */   GIM_Try, /*On fail goto*//*Label 23860*/ GIMT_Encode4(1750693), // Rule ID 11127 //
     /* 1750612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1750615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1750620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1750623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1750626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1750629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1750635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750658 */     // MIs[0] policy
     /* 1750658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750668 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1750671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1750689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750692 */     // GIR_Coverage, 11127,
     /* 1750692 */     GIR_EraseRootFromParent_Done,
     /* 1750693 */   // Label 23860: @1750693
     /* 1750693 */   GIM_Try, /*On fail goto*//*Label 23861*/ GIMT_Encode4(1750779), // Rule ID 11130 //
     /* 1750698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1750709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1750712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1750715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1750718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750744 */     // MIs[0] policy
     /* 1750744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750754 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1750757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750778 */     // GIR_Coverage, 11130,
     /* 1750778 */     GIR_EraseRootFromParent_Done,
     /* 1750779 */   // Label 23861: @1750779
     /* 1750779 */   GIM_Try, /*On fail goto*//*Label 23862*/ GIMT_Encode4(1750865), // Rule ID 11131 //
     /* 1750784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1750795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1750798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1750801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1750804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750830 */     // MIs[0] policy
     /* 1750830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750840 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1750843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750864 */     // GIR_Coverage, 11131,
     /* 1750864 */     GIR_EraseRootFromParent_Done,
     /* 1750865 */   // Label 23862: @1750865
     /* 1750865 */   GIM_Try, /*On fail goto*//*Label 23863*/ GIMT_Encode4(1750951), // Rule ID 11134 //
     /* 1750870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1750881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1750884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1750887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1750890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750916 */     // MIs[0] policy
     /* 1750916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750926 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1750929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750950 */     // GIR_Coverage, 11134,
     /* 1750950 */     GIR_EraseRootFromParent_Done,
     /* 1750951 */   // Label 23863: @1750951
     /* 1750951 */   GIM_Try, /*On fail goto*//*Label 23864*/ GIMT_Encode4(1751037), // Rule ID 11135 //
     /* 1750956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1750967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1750970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1750973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1750976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751002 */     // MIs[0] policy
     /* 1751002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751012 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1751015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751036 */     // GIR_Coverage, 11135,
     /* 1751036 */     GIR_EraseRootFromParent_Done,
     /* 1751037 */   // Label 23864: @1751037
     /* 1751037 */   GIM_Try, /*On fail goto*//*Label 23865*/ GIMT_Encode4(1751123), // Rule ID 11138 //
     /* 1751042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1751053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1751056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1751059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1751062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751088 */     // MIs[0] policy
     /* 1751088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751098 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1751101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751122 */     // GIR_Coverage, 11138,
     /* 1751122 */     GIR_EraseRootFromParent_Done,
     /* 1751123 */   // Label 23865: @1751123
     /* 1751123 */   GIM_Try, /*On fail goto*//*Label 23866*/ GIMT_Encode4(1751209), // Rule ID 11139 //
     /* 1751128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1751139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1751142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1751145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1751148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751174 */     // MIs[0] policy
     /* 1751174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751184 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1751187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751208 */     // GIR_Coverage, 11139,
     /* 1751208 */     GIR_EraseRootFromParent_Done,
     /* 1751209 */   // Label 23866: @1751209
     /* 1751209 */   GIM_Try, /*On fail goto*//*Label 23867*/ GIMT_Encode4(1751295), // Rule ID 11142 //
     /* 1751214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1751225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1751228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1751231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1751234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751260 */     // MIs[0] policy
     /* 1751260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751270 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1751273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751294 */     // GIR_Coverage, 11142,
     /* 1751294 */     GIR_EraseRootFromParent_Done,
     /* 1751295 */   // Label 23867: @1751295
     /* 1751295 */   GIM_Try, /*On fail goto*//*Label 23868*/ GIMT_Encode4(1751381), // Rule ID 11143 //
     /* 1751300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1751311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1751314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1751317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1751320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751346 */     // MIs[0] policy
     /* 1751346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751356 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1751359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751380 */     // GIR_Coverage, 11143,
     /* 1751380 */     GIR_EraseRootFromParent_Done,
     /* 1751381 */   // Label 23868: @1751381
     /* 1751381 */   GIM_Try, /*On fail goto*//*Label 23869*/ GIMT_Encode4(1751467), // Rule ID 11146 //
     /* 1751386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1751397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1751400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1751403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1751406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751432 */     // MIs[0] policy
     /* 1751432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751442 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1751445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751466 */     // GIR_Coverage, 11146,
     /* 1751466 */     GIR_EraseRootFromParent_Done,
     /* 1751467 */   // Label 23869: @1751467
     /* 1751467 */   GIM_Try, /*On fail goto*//*Label 23870*/ GIMT_Encode4(1751553), // Rule ID 11147 //
     /* 1751472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1751483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1751486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1751489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1751492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751518 */     // MIs[0] policy
     /* 1751518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751528 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1751531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751552 */     // GIR_Coverage, 11147,
     /* 1751552 */     GIR_EraseRootFromParent_Done,
     /* 1751553 */   // Label 23870: @1751553
     /* 1751553 */   GIM_Try, /*On fail goto*//*Label 23871*/ GIMT_Encode4(1751639), // Rule ID 11150 //
     /* 1751558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1751569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1751572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1751575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1751578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751604 */     // MIs[0] policy
     /* 1751604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751614 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1751617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751638 */     // GIR_Coverage, 11150,
     /* 1751638 */     GIR_EraseRootFromParent_Done,
     /* 1751639 */   // Label 23871: @1751639
     /* 1751639 */   GIM_Try, /*On fail goto*//*Label 23872*/ GIMT_Encode4(1751725), // Rule ID 11151 //
     /* 1751644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1751655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1751658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1751661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1751664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751690 */     // MIs[0] policy
     /* 1751690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751700 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1751703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751724 */     // GIR_Coverage, 11151,
     /* 1751724 */     GIR_EraseRootFromParent_Done,
     /* 1751725 */   // Label 23872: @1751725
     /* 1751725 */   GIM_Try, /*On fail goto*//*Label 23873*/ GIMT_Encode4(1751811), // Rule ID 11154 //
     /* 1751730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1751741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1751744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1751747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1751750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751776 */     // MIs[0] policy
     /* 1751776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751786 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1751789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751810 */     // GIR_Coverage, 11154,
     /* 1751810 */     GIR_EraseRootFromParent_Done,
     /* 1751811 */   // Label 23873: @1751811
     /* 1751811 */   GIM_Try, /*On fail goto*//*Label 23874*/ GIMT_Encode4(1751897), // Rule ID 11155 //
     /* 1751816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1751827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1751830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1751833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1751836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751862 */     // MIs[0] policy
     /* 1751862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751872 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1751875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751896 */     // GIR_Coverage, 11155,
     /* 1751896 */     GIR_EraseRootFromParent_Done,
     /* 1751897 */   // Label 23874: @1751897
     /* 1751897 */   GIM_Try, /*On fail goto*//*Label 23875*/ GIMT_Encode4(1751983), // Rule ID 11158 //
     /* 1751902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1751913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1751916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1751919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1751922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751948 */     // MIs[0] policy
     /* 1751948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751958 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1751961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751982 */     // GIR_Coverage, 11158,
     /* 1751982 */     GIR_EraseRootFromParent_Done,
     /* 1751983 */   // Label 23875: @1751983
     /* 1751983 */   GIM_Try, /*On fail goto*//*Label 23876*/ GIMT_Encode4(1752069), // Rule ID 11159 //
     /* 1751988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1751999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1752002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1752005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1752008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1752011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752034 */     // MIs[0] policy
     /* 1752034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752044 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1752047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752068 */     // GIR_Coverage, 11159,
     /* 1752068 */     GIR_EraseRootFromParent_Done,
     /* 1752069 */   // Label 23876: @1752069
     /* 1752069 */   GIM_Try, /*On fail goto*//*Label 23877*/ GIMT_Encode4(1752155), // Rule ID 11162 //
     /* 1752074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1752085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1752088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1752091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1752094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1752097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752120 */     // MIs[0] policy
     /* 1752120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1752133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752154 */     // GIR_Coverage, 11162,
     /* 1752154 */     GIR_EraseRootFromParent_Done,
     /* 1752155 */   // Label 23877: @1752155
     /* 1752155 */   GIM_Try, /*On fail goto*//*Label 23878*/ GIMT_Encode4(1752241), // Rule ID 11163 //
     /* 1752160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1752171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1752174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1752177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1752180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1752183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752206 */     // MIs[0] policy
     /* 1752206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1752219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752240 */     // GIR_Coverage, 11163,
     /* 1752240 */     GIR_EraseRootFromParent_Done,
     /* 1752241 */   // Label 23878: @1752241
     /* 1752241 */   GIM_Try, /*On fail goto*//*Label 23879*/ GIMT_Encode4(1752327), // Rule ID 11166 //
     /* 1752246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1752257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1752260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1752263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1752266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752292 */     // MIs[0] policy
     /* 1752292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752302 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1752305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752326 */     // GIR_Coverage, 11166,
     /* 1752326 */     GIR_EraseRootFromParent_Done,
     /* 1752327 */   // Label 23879: @1752327
     /* 1752327 */   GIM_Try, /*On fail goto*//*Label 23880*/ GIMT_Encode4(1752413), // Rule ID 11167 //
     /* 1752332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1752343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1752346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1752349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1752352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752378 */     // MIs[0] policy
     /* 1752378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752388 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1752391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752412 */     // GIR_Coverage, 11167,
     /* 1752412 */     GIR_EraseRootFromParent_Done,
     /* 1752413 */   // Label 23880: @1752413
     /* 1752413 */   GIM_Try, /*On fail goto*//*Label 23881*/ GIMT_Encode4(1752499), // Rule ID 11170 //
     /* 1752418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1752429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1752432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1752435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1752438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752464 */     // MIs[0] policy
     /* 1752464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752474 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1752477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752498 */     // GIR_Coverage, 11170,
     /* 1752498 */     GIR_EraseRootFromParent_Done,
     /* 1752499 */   // Label 23881: @1752499
     /* 1752499 */   GIM_Try, /*On fail goto*//*Label 23882*/ GIMT_Encode4(1752585), // Rule ID 11171 //
     /* 1752504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1752515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1752518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1752521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1752524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752550 */     // MIs[0] policy
     /* 1752550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752560 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1752563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752584 */     // GIR_Coverage, 11171,
     /* 1752584 */     GIR_EraseRootFromParent_Done,
     /* 1752585 */   // Label 23882: @1752585
     /* 1752585 */   GIM_Try, /*On fail goto*//*Label 23883*/ GIMT_Encode4(1752671), // Rule ID 11174 //
     /* 1752590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1752601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1752604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1752607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1752610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1752613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752636 */     // MIs[0] policy
     /* 1752636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752646 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1752649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752670 */     // GIR_Coverage, 11174,
     /* 1752670 */     GIR_EraseRootFromParent_Done,
     /* 1752671 */   // Label 23883: @1752671
     /* 1752671 */   GIM_Try, /*On fail goto*//*Label 23884*/ GIMT_Encode4(1752757), // Rule ID 11175 //
     /* 1752676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1752687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1752690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1752693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1752696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1752699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752722 */     // MIs[0] policy
     /* 1752722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752732 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1752735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752756 */     // GIR_Coverage, 11175,
     /* 1752756 */     GIR_EraseRootFromParent_Done,
     /* 1752757 */   // Label 23884: @1752757
     /* 1752757 */   GIM_Try, /*On fail goto*//*Label 23885*/ GIMT_Encode4(1752843), // Rule ID 11178 //
     /* 1752762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1752773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1752776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1752779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1752782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752808 */     // MIs[0] policy
     /* 1752808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1752821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752842 */     // GIR_Coverage, 11178,
     /* 1752842 */     GIR_EraseRootFromParent_Done,
     /* 1752843 */   // Label 23885: @1752843
     /* 1752843 */   GIM_Try, /*On fail goto*//*Label 23886*/ GIMT_Encode4(1752929), // Rule ID 11179 //
     /* 1752848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1752859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1752862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1752865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1752868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752894 */     // MIs[0] policy
     /* 1752894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752904 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1752907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752928 */     // GIR_Coverage, 11179,
     /* 1752928 */     GIR_EraseRootFromParent_Done,
     /* 1752929 */   // Label 23886: @1752929
     /* 1752929 */   GIM_Try, /*On fail goto*//*Label 23887*/ GIMT_Encode4(1753015), // Rule ID 11182 //
     /* 1752934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1752945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1752948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1752951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1752954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752980 */     // MIs[0] policy
     /* 1752980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752990 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1752993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753014 */     // GIR_Coverage, 11182,
     /* 1753014 */     GIR_EraseRootFromParent_Done,
     /* 1753015 */   // Label 23887: @1753015
     /* 1753015 */   GIM_Try, /*On fail goto*//*Label 23888*/ GIMT_Encode4(1753101), // Rule ID 11183 //
     /* 1753020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1753031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1753034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1753037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1753040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1753043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1753050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753066 */     // MIs[0] policy
     /* 1753066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753076 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1753079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753100 */     // GIR_Coverage, 11183,
     /* 1753100 */     GIR_EraseRootFromParent_Done,
     /* 1753101 */   // Label 23888: @1753101
     /* 1753101 */   GIM_Try, /*On fail goto*//*Label 23889*/ GIMT_Encode4(1753187), // Rule ID 11186 //
     /* 1753106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1753117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1753120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1753123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1753126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1753129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753152 */     // MIs[0] policy
     /* 1753152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753162 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1753165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753186 */     // GIR_Coverage, 11186,
     /* 1753186 */     GIR_EraseRootFromParent_Done,
     /* 1753187 */   // Label 23889: @1753187
     /* 1753187 */   GIM_Try, /*On fail goto*//*Label 23890*/ GIMT_Encode4(1753273), // Rule ID 11187 //
     /* 1753192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1753203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1753206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1753209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1753212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1753215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753238 */     // MIs[0] policy
     /* 1753238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753248 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1753251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753272 */     // GIR_Coverage, 11187,
     /* 1753272 */     GIR_EraseRootFromParent_Done,
     /* 1753273 */   // Label 23890: @1753273
     /* 1753273 */   GIM_Try, /*On fail goto*//*Label 23891*/ GIMT_Encode4(1753359), // Rule ID 11190 //
     /* 1753278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1753289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1753292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1753295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1753298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1753308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753324 */     // MIs[0] policy
     /* 1753324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1753337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753358 */     // GIR_Coverage, 11190,
     /* 1753358 */     GIR_EraseRootFromParent_Done,
     /* 1753359 */   // Label 23891: @1753359
     /* 1753359 */   GIM_Try, /*On fail goto*//*Label 23892*/ GIMT_Encode4(1753445), // Rule ID 11191 //
     /* 1753364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1753375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1753378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1753381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1753384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1753394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753410 */     // MIs[0] policy
     /* 1753410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1753423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753444 */     // GIR_Coverage, 11191,
     /* 1753444 */     GIR_EraseRootFromParent_Done,
     /* 1753445 */   // Label 23892: @1753445
     /* 1753445 */   GIM_Try, /*On fail goto*//*Label 23893*/ GIMT_Encode4(1753531), // Rule ID 11194 //
     /* 1753450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1753461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1753464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1753467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1753470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1753473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1753480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753496 */     // MIs[0] policy
     /* 1753496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753506 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1753509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753530 */     // GIR_Coverage, 11194,
     /* 1753530 */     GIR_EraseRootFromParent_Done,
     /* 1753531 */   // Label 23893: @1753531
     /* 1753531 */   GIM_Try, /*On fail goto*//*Label 23894*/ GIMT_Encode4(1753617), // Rule ID 11195 //
     /* 1753536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1753547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1753550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1753553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1753556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1753559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1753566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753582 */     // MIs[0] policy
     /* 1753582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1753595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753616 */     // GIR_Coverage, 11195,
     /* 1753616 */     GIR_EraseRootFromParent_Done,
     /* 1753617 */   // Label 23894: @1753617
     /* 1753617 */   GIM_Try, /*On fail goto*//*Label 23895*/ GIMT_Encode4(1753703), // Rule ID 11198 //
     /* 1753622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1753633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1753636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1753639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1753642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1753645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753668 */     // MIs[0] policy
     /* 1753668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753678 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1753681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753702 */     // GIR_Coverage, 11198,
     /* 1753702 */     GIR_EraseRootFromParent_Done,
     /* 1753703 */   // Label 23895: @1753703
     /* 1753703 */   GIM_Try, /*On fail goto*//*Label 23896*/ GIMT_Encode4(1753789), // Rule ID 11199 //
     /* 1753708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1753719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1753722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1753725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1753728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1753731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753754 */     // MIs[0] policy
     /* 1753754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753764 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1753767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753788 */     // GIR_Coverage, 11199,
     /* 1753788 */     GIR_EraseRootFromParent_Done,
     /* 1753789 */   // Label 23896: @1753789
     /* 1753789 */   GIM_Try, /*On fail goto*//*Label 23897*/ GIMT_Encode4(1753875), // Rule ID 11202 //
     /* 1753794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1753805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1753808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1753811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1753814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753840 */     // MIs[0] policy
     /* 1753840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753850 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1753853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753874 */     // GIR_Coverage, 11202,
     /* 1753874 */     GIR_EraseRootFromParent_Done,
     /* 1753875 */   // Label 23897: @1753875
     /* 1753875 */   GIM_Try, /*On fail goto*//*Label 23898*/ GIMT_Encode4(1753961), // Rule ID 11203 //
     /* 1753880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1753891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1753894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1753897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1753900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753926 */     // MIs[0] policy
     /* 1753926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753936 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1753939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753960 */     // GIR_Coverage, 11203,
     /* 1753960 */     GIR_EraseRootFromParent_Done,
     /* 1753961 */   // Label 23898: @1753961
     /* 1753961 */   GIM_Try, /*On fail goto*//*Label 23899*/ GIMT_Encode4(1754047), // Rule ID 11206 //
     /* 1753966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1753977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1753980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1753983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1753986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754012 */     // MIs[0] policy
     /* 1754012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754022 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1754025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754046 */     // GIR_Coverage, 11206,
     /* 1754046 */     GIR_EraseRootFromParent_Done,
     /* 1754047 */   // Label 23899: @1754047
     /* 1754047 */   GIM_Try, /*On fail goto*//*Label 23900*/ GIMT_Encode4(1754133), // Rule ID 11207 //
     /* 1754052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1754060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1754063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1754066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1754069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1754072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754098 */     // MIs[0] policy
     /* 1754098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754108 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1754111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754132 */     // GIR_Coverage, 11207,
     /* 1754132 */     GIR_EraseRootFromParent_Done,
     /* 1754133 */   // Label 23900: @1754133
     /* 1754133 */   GIM_Try, /*On fail goto*//*Label 23901*/ GIMT_Encode4(1754219), // Rule ID 11210 //
     /* 1754138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1754146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1754149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1754152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1754155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1754158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754184 */     // MIs[0] policy
     /* 1754184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754194 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1754197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754218 */     // GIR_Coverage, 11210,
     /* 1754218 */     GIR_EraseRootFromParent_Done,
     /* 1754219 */   // Label 23901: @1754219
     /* 1754219 */   GIM_Try, /*On fail goto*//*Label 23902*/ GIMT_Encode4(1754305), // Rule ID 11211 //
     /* 1754224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1754232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1754235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1754238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1754241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1754244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754270 */     // MIs[0] policy
     /* 1754270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754280 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1754283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754304 */     // GIR_Coverage, 11211,
     /* 1754304 */     GIR_EraseRootFromParent_Done,
     /* 1754305 */   // Label 23902: @1754305
     /* 1754305 */   GIM_Try, /*On fail goto*//*Label 23903*/ GIMT_Encode4(1754391), // Rule ID 11214 //
     /* 1754310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1754318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1754321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1754324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1754327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1754330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754356 */     // MIs[0] policy
     /* 1754356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754366 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1754369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754390 */     // GIR_Coverage, 11214,
     /* 1754390 */     GIR_EraseRootFromParent_Done,
     /* 1754391 */   // Label 23903: @1754391
     /* 1754391 */   GIM_Try, /*On fail goto*//*Label 23904*/ GIMT_Encode4(1754477), // Rule ID 11215 //
     /* 1754396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1754404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1754407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1754410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1754413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1754416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754442 */     // MIs[0] policy
     /* 1754442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754452 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1754455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754476 */     // GIR_Coverage, 11215,
     /* 1754476 */     GIR_EraseRootFromParent_Done,
     /* 1754477 */   // Label 23904: @1754477
     /* 1754477 */   GIM_Try, /*On fail goto*//*Label 23905*/ GIMT_Encode4(1754563), // Rule ID 11218 //
     /* 1754482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1754490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1754493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1754496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1754499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1754502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754528 */     // MIs[0] policy
     /* 1754528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754538 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1754541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754562 */     // GIR_Coverage, 11218,
     /* 1754562 */     GIR_EraseRootFromParent_Done,
     /* 1754563 */   // Label 23905: @1754563
     /* 1754563 */   GIM_Try, /*On fail goto*//*Label 23906*/ GIMT_Encode4(1754649), // Rule ID 11219 //
     /* 1754568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1754576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1754579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1754582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1754585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1754588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754614 */     // MIs[0] policy
     /* 1754614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754624 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1754627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754648 */     // GIR_Coverage, 11219,
     /* 1754648 */     GIR_EraseRootFromParent_Done,
     /* 1754649 */   // Label 23906: @1754649
     /* 1754649 */   GIM_Try, /*On fail goto*//*Label 23907*/ GIMT_Encode4(1754735), // Rule ID 11222 //
     /* 1754654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1754662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1754665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1754668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1754671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1754674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754700 */     // MIs[0] policy
     /* 1754700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754710 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1754713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754734 */     // GIR_Coverage, 11222,
     /* 1754734 */     GIR_EraseRootFromParent_Done,
     /* 1754735 */   // Label 23907: @1754735
     /* 1754735 */   GIM_Try, /*On fail goto*//*Label 23908*/ GIMT_Encode4(1754821), // Rule ID 11223 //
     /* 1754740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1754748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1754751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1754754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1754757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1754760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754786 */     // MIs[0] policy
     /* 1754786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754796 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1754799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754820 */     // GIR_Coverage, 11223,
     /* 1754820 */     GIR_EraseRootFromParent_Done,
     /* 1754821 */   // Label 23908: @1754821
     /* 1754821 */   GIM_Try, /*On fail goto*//*Label 23909*/ GIMT_Encode4(1754907), // Rule ID 11226 //
     /* 1754826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1754834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1754837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1754840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1754843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1754846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754872 */     // MIs[0] policy
     /* 1754872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754882 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1754885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754906 */     // GIR_Coverage, 11226,
     /* 1754906 */     GIR_EraseRootFromParent_Done,
     /* 1754907 */   // Label 23909: @1754907
     /* 1754907 */   GIM_Try, /*On fail goto*//*Label 23910*/ GIMT_Encode4(1754993), // Rule ID 11227 //
     /* 1754912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1754920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1754923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1754926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1754929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1754932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754958 */     // MIs[0] policy
     /* 1754958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754968 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1754971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754992 */     // GIR_Coverage, 11227,
     /* 1754992 */     GIR_EraseRootFromParent_Done,
     /* 1754993 */   // Label 23910: @1754993
     /* 1754993 */   GIM_Try, /*On fail goto*//*Label 23911*/ GIMT_Encode4(1755079), // Rule ID 11230 //
     /* 1754998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1755006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1755009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1755012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1755015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1755021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755044 */     // MIs[0] policy
     /* 1755044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755054 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1755057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755078 */     // GIR_Coverage, 11230,
     /* 1755078 */     GIR_EraseRootFromParent_Done,
     /* 1755079 */   // Label 23911: @1755079
     /* 1755079 */   GIM_Try, /*On fail goto*//*Label 23912*/ GIMT_Encode4(1755165), // Rule ID 11231 //
     /* 1755084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1755092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1755095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1755098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1755101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1755104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1755107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755130 */     // MIs[0] policy
     /* 1755130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755140 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1755143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755164 */     // GIR_Coverage, 11231,
     /* 1755164 */     GIR_EraseRootFromParent_Done,
     /* 1755165 */   // Label 23912: @1755165
     /* 1755165 */   GIM_Try, /*On fail goto*//*Label 23913*/ GIMT_Encode4(1755251), // Rule ID 11234 //
     /* 1755170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1755178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1755181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1755184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1755187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1755193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755216 */     // MIs[0] policy
     /* 1755216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755226 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1755229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755250 */     // GIR_Coverage, 11234,
     /* 1755250 */     GIR_EraseRootFromParent_Done,
     /* 1755251 */   // Label 23913: @1755251
     /* 1755251 */   GIM_Try, /*On fail goto*//*Label 23914*/ GIMT_Encode4(1755337), // Rule ID 11235 //
     /* 1755256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1755264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1755267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1755270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1755273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1755276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1755279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755302 */     // MIs[0] policy
     /* 1755302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755312 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1755315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755336 */     // GIR_Coverage, 11235,
     /* 1755336 */     GIR_EraseRootFromParent_Done,
     /* 1755337 */   // Label 23914: @1755337
     /* 1755337 */   GIM_Try, /*On fail goto*//*Label 23915*/ GIMT_Encode4(1755423), // Rule ID 11238 //
     /* 1755342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1755350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1755353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1755356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1755359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755388 */     // MIs[0] policy
     /* 1755388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1755401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755422 */     // GIR_Coverage, 11238,
     /* 1755422 */     GIR_EraseRootFromParent_Done,
     /* 1755423 */   // Label 23915: @1755423
     /* 1755423 */   GIM_Try, /*On fail goto*//*Label 23916*/ GIMT_Encode4(1755509), // Rule ID 11239 //
     /* 1755428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1755436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1755439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1755442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1755445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1755448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755474 */     // MIs[0] policy
     /* 1755474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755484 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1755487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755508 */     // GIR_Coverage, 11239,
     /* 1755508 */     GIR_EraseRootFromParent_Done,
     /* 1755509 */   // Label 23916: @1755509
     /* 1755509 */   GIM_Try, /*On fail goto*//*Label 23917*/ GIMT_Encode4(1755595), // Rule ID 11242 //
     /* 1755514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1755522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1755525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1755528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1755531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755560 */     // MIs[0] policy
     /* 1755560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755570 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1755573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755594 */     // GIR_Coverage, 11242,
     /* 1755594 */     GIR_EraseRootFromParent_Done,
     /* 1755595 */   // Label 23917: @1755595
     /* 1755595 */   GIM_Try, /*On fail goto*//*Label 23918*/ GIMT_Encode4(1755681), // Rule ID 11243 //
     /* 1755600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1755608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1755611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1755614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1755617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1755620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755646 */     // MIs[0] policy
     /* 1755646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755656 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1755659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755680 */     // GIR_Coverage, 11243,
     /* 1755680 */     GIR_EraseRootFromParent_Done,
     /* 1755681 */   // Label 23918: @1755681
     /* 1755681 */   GIM_Try, /*On fail goto*//*Label 23919*/ GIMT_Encode4(1755767), // Rule ID 11246 //
     /* 1755686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1755694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1755697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1755700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1755703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1755709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755732 */     // MIs[0] policy
     /* 1755732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755742 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1755745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755766 */     // GIR_Coverage, 11246,
     /* 1755766 */     GIR_EraseRootFromParent_Done,
     /* 1755767 */   // Label 23919: @1755767
     /* 1755767 */   GIM_Try, /*On fail goto*//*Label 23920*/ GIMT_Encode4(1755853), // Rule ID 11247 //
     /* 1755772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1755780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1755783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1755786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1755789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1755792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1755795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755818 */     // MIs[0] policy
     /* 1755818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755828 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1755831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755852 */     // GIR_Coverage, 11247,
     /* 1755852 */     GIR_EraseRootFromParent_Done,
     /* 1755853 */   // Label 23920: @1755853
     /* 1755853 */   GIM_Try, /*On fail goto*//*Label 23921*/ GIMT_Encode4(1755939), // Rule ID 11250 //
     /* 1755858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1755866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1755869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1755872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1755875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755904 */     // MIs[0] policy
     /* 1755904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1755917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755938 */     // GIR_Coverage, 11250,
     /* 1755938 */     GIR_EraseRootFromParent_Done,
     /* 1755939 */   // Label 23921: @1755939
     /* 1755939 */   GIM_Try, /*On fail goto*//*Label 23922*/ GIMT_Encode4(1756025), // Rule ID 11251 //
     /* 1755944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1755952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1755955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1755958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1755961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1755964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755990 */     // MIs[0] policy
     /* 1755990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756000 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1756003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756024 */     // GIR_Coverage, 11251,
     /* 1756024 */     GIR_EraseRootFromParent_Done,
     /* 1756025 */   // Label 23922: @1756025
     /* 1756025 */   GIM_Try, /*On fail goto*//*Label 23923*/ GIMT_Encode4(1756111), // Rule ID 11254 //
     /* 1756030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1756038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1756041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1756044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1756047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756076 */     // MIs[0] policy
     /* 1756076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756086 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1756089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756110 */     // GIR_Coverage, 11254,
     /* 1756110 */     GIR_EraseRootFromParent_Done,
     /* 1756111 */   // Label 23923: @1756111
     /* 1756111 */   GIM_Try, /*On fail goto*//*Label 23924*/ GIMT_Encode4(1756197), // Rule ID 11255 //
     /* 1756116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1756124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1756127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1756130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1756133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756162 */     // MIs[0] policy
     /* 1756162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756172 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1756175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756196 */     // GIR_Coverage, 11255,
     /* 1756196 */     GIR_EraseRootFromParent_Done,
     /* 1756197 */   // Label 23924: @1756197
     /* 1756197 */   GIM_Try, /*On fail goto*//*Label 23925*/ GIMT_Encode4(1756283), // Rule ID 11258 //
     /* 1756202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1756210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1756213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1756216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1756219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1756225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756248 */     // MIs[0] policy
     /* 1756248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756258 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1756261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756282 */     // GIR_Coverage, 11258,
     /* 1756282 */     GIR_EraseRootFromParent_Done,
     /* 1756283 */   // Label 23925: @1756283
     /* 1756283 */   GIM_Try, /*On fail goto*//*Label 23926*/ GIMT_Encode4(1756369), // Rule ID 11259 //
     /* 1756288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1756296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1756299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1756302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1756305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1756311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756334 */     // MIs[0] policy
     /* 1756334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756344 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1756347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756368 */     // GIR_Coverage, 11259,
     /* 1756368 */     GIR_EraseRootFromParent_Done,
     /* 1756369 */   // Label 23926: @1756369
     /* 1756369 */   GIM_Try, /*On fail goto*//*Label 23927*/ GIMT_Encode4(1756455), // Rule ID 11262 //
     /* 1756374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1756382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1756385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1756388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1756391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1756404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756420 */     // MIs[0] policy
     /* 1756420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1756433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756454 */     // GIR_Coverage, 11262,
     /* 1756454 */     GIR_EraseRootFromParent_Done,
     /* 1756455 */   // Label 23927: @1756455
     /* 1756455 */   GIM_Try, /*On fail goto*//*Label 23928*/ GIMT_Encode4(1756541), // Rule ID 11263 //
     /* 1756460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1756468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1756471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1756474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1756477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1756490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756506 */     // MIs[0] policy
     /* 1756506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756516 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1756519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756540 */     // GIR_Coverage, 11263,
     /* 1756540 */     GIR_EraseRootFromParent_Done,
     /* 1756541 */   // Label 23928: @1756541
     /* 1756541 */   GIM_Try, /*On fail goto*//*Label 23929*/ GIMT_Encode4(1756627), // Rule ID 11266 //
     /* 1756546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1756554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1756557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1756560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1756563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1756569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756592 */     // MIs[0] policy
     /* 1756592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756602 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1756605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756626 */     // GIR_Coverage, 11266,
     /* 1756626 */     GIR_EraseRootFromParent_Done,
     /* 1756627 */   // Label 23929: @1756627
     /* 1756627 */   GIM_Try, /*On fail goto*//*Label 23930*/ GIMT_Encode4(1756713), // Rule ID 11267 //
     /* 1756632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1756640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1756643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1756646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1756649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1756655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756678 */     // MIs[0] policy
     /* 1756678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756688 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1756691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756712 */     // GIR_Coverage, 11267,
     /* 1756712 */     GIR_EraseRootFromParent_Done,
     /* 1756713 */   // Label 23930: @1756713
     /* 1756713 */   GIM_Try, /*On fail goto*//*Label 23931*/ GIMT_Encode4(1756799), // Rule ID 11270 //
     /* 1756718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1756726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1756729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1756732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1756735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756764 */     // MIs[0] policy
     /* 1756764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756774 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1756777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756798 */     // GIR_Coverage, 11270,
     /* 1756798 */     GIR_EraseRootFromParent_Done,
     /* 1756799 */   // Label 23931: @1756799
     /* 1756799 */   GIM_Try, /*On fail goto*//*Label 23932*/ GIMT_Encode4(1756885), // Rule ID 11271 //
     /* 1756804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1756812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1756815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1756818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1756821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756850 */     // MIs[0] policy
     /* 1756850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756860 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1756863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756884 */     // GIR_Coverage, 11271,
     /* 1756884 */     GIR_EraseRootFromParent_Done,
     /* 1756885 */   // Label 23932: @1756885
     /* 1756885 */   GIM_Try, /*On fail goto*//*Label 23933*/ GIMT_Encode4(1756971), // Rule ID 11274 //
     /* 1756890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1756901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1756904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1756907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1756910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756936 */     // MIs[0] policy
     /* 1756936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756946 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1756949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756970 */     // GIR_Coverage, 11274,
     /* 1756970 */     GIR_EraseRootFromParent_Done,
     /* 1756971 */   // Label 23933: @1756971
     /* 1756971 */   GIM_Try, /*On fail goto*//*Label 23934*/ GIMT_Encode4(1757057), // Rule ID 11275 //
     /* 1756976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1756987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1756990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1756993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1756996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757022 */     // MIs[0] policy
     /* 1757022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757032 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1757035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757056 */     // GIR_Coverage, 11275,
     /* 1757056 */     GIR_EraseRootFromParent_Done,
     /* 1757057 */   // Label 23934: @1757057
     /* 1757057 */   GIM_Try, /*On fail goto*//*Label 23935*/ GIMT_Encode4(1757143), // Rule ID 11278 //
     /* 1757062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1757073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1757076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1757079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1757082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757108 */     // MIs[0] policy
     /* 1757108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757118 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1757121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757142 */     // GIR_Coverage, 11278,
     /* 1757142 */     GIR_EraseRootFromParent_Done,
     /* 1757143 */   // Label 23935: @1757143
     /* 1757143 */   GIM_Try, /*On fail goto*//*Label 23936*/ GIMT_Encode4(1757229), // Rule ID 11279 //
     /* 1757148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1757159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1757162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1757165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1757168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757194 */     // MIs[0] policy
     /* 1757194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757204 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1757207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757228 */     // GIR_Coverage, 11279,
     /* 1757228 */     GIR_EraseRootFromParent_Done,
     /* 1757229 */   // Label 23936: @1757229
     /* 1757229 */   GIM_Try, /*On fail goto*//*Label 23937*/ GIMT_Encode4(1757315), // Rule ID 11282 //
     /* 1757234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1757245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1757248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1757251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1757254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757280 */     // MIs[0] policy
     /* 1757280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757290 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1757293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757314 */     // GIR_Coverage, 11282,
     /* 1757314 */     GIR_EraseRootFromParent_Done,
     /* 1757315 */   // Label 23937: @1757315
     /* 1757315 */   GIM_Try, /*On fail goto*//*Label 23938*/ GIMT_Encode4(1757401), // Rule ID 11283 //
     /* 1757320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1757331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1757334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1757337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1757340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757366 */     // MIs[0] policy
     /* 1757366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757376 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1757379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757400 */     // GIR_Coverage, 11283,
     /* 1757400 */     GIR_EraseRootFromParent_Done,
     /* 1757401 */   // Label 23938: @1757401
     /* 1757401 */   GIM_Try, /*On fail goto*//*Label 23939*/ GIMT_Encode4(1757487), // Rule ID 11286 //
     /* 1757406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1757417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1757420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1757423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1757426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757452 */     // MIs[0] policy
     /* 1757452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757462 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1757465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757486 */     // GIR_Coverage, 11286,
     /* 1757486 */     GIR_EraseRootFromParent_Done,
     /* 1757487 */   // Label 23939: @1757487
     /* 1757487 */   GIM_Try, /*On fail goto*//*Label 23940*/ GIMT_Encode4(1757573), // Rule ID 11287 //
     /* 1757492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1757503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1757506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1757509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1757512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757538 */     // MIs[0] policy
     /* 1757538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757548 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1757551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757572 */     // GIR_Coverage, 11287,
     /* 1757572 */     GIR_EraseRootFromParent_Done,
     /* 1757573 */   // Label 23940: @1757573
     /* 1757573 */   GIM_Try, /*On fail goto*//*Label 23941*/ GIMT_Encode4(1757659), // Rule ID 11290 //
     /* 1757578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1757589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1757592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1757595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1757598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757624 */     // MIs[0] policy
     /* 1757624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757634 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1757637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757658 */     // GIR_Coverage, 11290,
     /* 1757658 */     GIR_EraseRootFromParent_Done,
     /* 1757659 */   // Label 23941: @1757659
     /* 1757659 */   GIM_Try, /*On fail goto*//*Label 23942*/ GIMT_Encode4(1757745), // Rule ID 11291 //
     /* 1757664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1757675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1757678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1757681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1757684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757710 */     // MIs[0] policy
     /* 1757710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757720 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1757723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757744 */     // GIR_Coverage, 11291,
     /* 1757744 */     GIR_EraseRootFromParent_Done,
     /* 1757745 */   // Label 23942: @1757745
     /* 1757745 */   GIM_Try, /*On fail goto*//*Label 23943*/ GIMT_Encode4(1757831), // Rule ID 11294 //
     /* 1757750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1757761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1757764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1757770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757796 */     // MIs[0] policy
     /* 1757796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757806 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1757809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757830 */     // GIR_Coverage, 11294,
     /* 1757830 */     GIR_EraseRootFromParent_Done,
     /* 1757831 */   // Label 23943: @1757831
     /* 1757831 */   GIM_Try, /*On fail goto*//*Label 23944*/ GIMT_Encode4(1757917), // Rule ID 11295 //
     /* 1757836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1757847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1757850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1757856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757882 */     // MIs[0] policy
     /* 1757882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757892 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1757895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757916 */     // GIR_Coverage, 11295,
     /* 1757916 */     GIR_EraseRootFromParent_Done,
     /* 1757917 */   // Label 23944: @1757917
     /* 1757917 */   GIM_Try, /*On fail goto*//*Label 23945*/ GIMT_Encode4(1758003), // Rule ID 11298 //
     /* 1757922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1757933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1757936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1757939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1757942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1757945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757968 */     // MIs[0] policy
     /* 1757968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757978 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1757981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758002 */     // GIR_Coverage, 11298,
     /* 1758002 */     GIR_EraseRootFromParent_Done,
     /* 1758003 */   // Label 23945: @1758003
     /* 1758003 */   GIM_Try, /*On fail goto*//*Label 23946*/ GIMT_Encode4(1758089), // Rule ID 11299 //
     /* 1758008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1758019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1758022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1758025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1758028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758054 */     // MIs[0] policy
     /* 1758054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758064 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1758067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758088 */     // GIR_Coverage, 11299,
     /* 1758088 */     GIR_EraseRootFromParent_Done,
     /* 1758089 */   // Label 23946: @1758089
     /* 1758089 */   GIM_Try, /*On fail goto*//*Label 23947*/ GIMT_Encode4(1758175), // Rule ID 11302 //
     /* 1758094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1758105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1758108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1758111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1758114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1758117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758140 */     // MIs[0] policy
     /* 1758140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758150 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1758153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758174 */     // GIR_Coverage, 11302,
     /* 1758174 */     GIR_EraseRootFromParent_Done,
     /* 1758175 */   // Label 23947: @1758175
     /* 1758175 */   GIM_Try, /*On fail goto*//*Label 23948*/ GIMT_Encode4(1758261), // Rule ID 11303 //
     /* 1758180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1758191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1758194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1758197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1758200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1758203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758226 */     // MIs[0] policy
     /* 1758226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758236 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1758239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758260 */     // GIR_Coverage, 11303,
     /* 1758260 */     GIR_EraseRootFromParent_Done,
     /* 1758261 */   // Label 23948: @1758261
     /* 1758261 */   GIM_Try, /*On fail goto*//*Label 23949*/ GIMT_Encode4(1758347), // Rule ID 11306 //
     /* 1758266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1758277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1758280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1758283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1758286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1758289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758312 */     // MIs[0] policy
     /* 1758312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1758325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758346 */     // GIR_Coverage, 11306,
     /* 1758346 */     GIR_EraseRootFromParent_Done,
     /* 1758347 */   // Label 23949: @1758347
     /* 1758347 */   GIM_Try, /*On fail goto*//*Label 23950*/ GIMT_Encode4(1758433), // Rule ID 11307 //
     /* 1758352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1758363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1758366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1758369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1758372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1758375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758398 */     // MIs[0] policy
     /* 1758398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1758411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758432 */     // GIR_Coverage, 11307,
     /* 1758432 */     GIR_EraseRootFromParent_Done,
     /* 1758433 */   // Label 23950: @1758433
     /* 1758433 */   GIM_Try, /*On fail goto*//*Label 23951*/ GIMT_Encode4(1758519), // Rule ID 11310 //
     /* 1758438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1758449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1758452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1758455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1758458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758484 */     // MIs[0] policy
     /* 1758484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758494 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1758497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758518 */     // GIR_Coverage, 11310,
     /* 1758518 */     GIR_EraseRootFromParent_Done,
     /* 1758519 */   // Label 23951: @1758519
     /* 1758519 */   GIM_Try, /*On fail goto*//*Label 23952*/ GIMT_Encode4(1758605), // Rule ID 11311 //
     /* 1758524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1758535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1758538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1758541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1758544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758570 */     // MIs[0] policy
     /* 1758570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758580 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1758583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758604 */     // GIR_Coverage, 11311,
     /* 1758604 */     GIR_EraseRootFromParent_Done,
     /* 1758605 */   // Label 23952: @1758605
     /* 1758605 */   GIM_Try, /*On fail goto*//*Label 23953*/ GIMT_Encode4(1758691), // Rule ID 11314 //
     /* 1758610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1758621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1758624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1758627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1758630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758656 */     // MIs[0] policy
     /* 1758656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758666 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1758669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758690 */     // GIR_Coverage, 11314,
     /* 1758690 */     GIR_EraseRootFromParent_Done,
     /* 1758691 */   // Label 23953: @1758691
     /* 1758691 */   GIM_Try, /*On fail goto*//*Label 23954*/ GIMT_Encode4(1758777), // Rule ID 11315 //
     /* 1758696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1758707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1758710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1758713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1758716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758742 */     // MIs[0] policy
     /* 1758742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758752 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1758755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758776 */     // GIR_Coverage, 11315,
     /* 1758776 */     GIR_EraseRootFromParent_Done,
     /* 1758777 */   // Label 23954: @1758777
     /* 1758777 */   GIM_Try, /*On fail goto*//*Label 23955*/ GIMT_Encode4(1758863), // Rule ID 11318 //
     /* 1758782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1758793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1758796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1758799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1758802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1758805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758828 */     // MIs[0] policy
     /* 1758828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758838 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1758841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758862 */     // GIR_Coverage, 11318,
     /* 1758862 */     GIR_EraseRootFromParent_Done,
     /* 1758863 */   // Label 23955: @1758863
     /* 1758863 */   GIM_Try, /*On fail goto*//*Label 23956*/ GIMT_Encode4(1758949), // Rule ID 11319 //
     /* 1758868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1758879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1758882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1758885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1758888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1758891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758914 */     // MIs[0] policy
     /* 1758914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758924 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1758927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758948 */     // GIR_Coverage, 11319,
     /* 1758948 */     GIR_EraseRootFromParent_Done,
     /* 1758949 */   // Label 23956: @1758949
     /* 1758949 */   GIM_Try, /*On fail goto*//*Label 23957*/ GIMT_Encode4(1759035), // Rule ID 11322 //
     /* 1758954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1758965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1758968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1758971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1758974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759000 */     // MIs[0] policy
     /* 1759000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759010 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1759013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759034 */     // GIR_Coverage, 11322,
     /* 1759034 */     GIR_EraseRootFromParent_Done,
     /* 1759035 */   // Label 23957: @1759035
     /* 1759035 */   GIM_Try, /*On fail goto*//*Label 23958*/ GIMT_Encode4(1759121), // Rule ID 11323 //
     /* 1759040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1759051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1759054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1759057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1759060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759086 */     // MIs[0] policy
     /* 1759086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1759099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759120 */     // GIR_Coverage, 11323,
     /* 1759120 */     GIR_EraseRootFromParent_Done,
     /* 1759121 */   // Label 23958: @1759121
     /* 1759121 */   GIM_Try, /*On fail goto*//*Label 23959*/ GIMT_Encode4(1759207), // Rule ID 11326 //
     /* 1759126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1759137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1759140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1759143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1759146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759172 */     // MIs[0] policy
     /* 1759172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759182 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1759185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759206 */     // GIR_Coverage, 11326,
     /* 1759206 */     GIR_EraseRootFromParent_Done,
     /* 1759207 */   // Label 23959: @1759207
     /* 1759207 */   GIM_Try, /*On fail goto*//*Label 23960*/ GIMT_Encode4(1759293), // Rule ID 11327 //
     /* 1759212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1759223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1759226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1759229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1759232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759258 */     // MIs[0] policy
     /* 1759258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759268 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1759271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759292 */     // GIR_Coverage, 11327,
     /* 1759292 */     GIR_EraseRootFromParent_Done,
     /* 1759293 */   // Label 23960: @1759293
     /* 1759293 */   GIM_Try, /*On fail goto*//*Label 23961*/ GIMT_Encode4(1759379), // Rule ID 11330 //
     /* 1759298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1759309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1759312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1759315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1759318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1759321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759344 */     // MIs[0] policy
     /* 1759344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759354 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1759357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759378 */     // GIR_Coverage, 11330,
     /* 1759378 */     GIR_EraseRootFromParent_Done,
     /* 1759379 */   // Label 23961: @1759379
     /* 1759379 */   GIM_Try, /*On fail goto*//*Label 23962*/ GIMT_Encode4(1759465), // Rule ID 11331 //
     /* 1759384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1759395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1759398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1759401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1759404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1759407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759430 */     // MIs[0] policy
     /* 1759430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759440 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1759443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759464 */     // GIR_Coverage, 11331,
     /* 1759464 */     GIR_EraseRootFromParent_Done,
     /* 1759465 */   // Label 23962: @1759465
     /* 1759465 */   GIM_Try, /*On fail goto*//*Label 23963*/ GIMT_Encode4(1759551), // Rule ID 11334 //
     /* 1759470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1759481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1759484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1759487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1759490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759516 */     // MIs[0] policy
     /* 1759516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1759529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759550 */     // GIR_Coverage, 11334,
     /* 1759550 */     GIR_EraseRootFromParent_Done,
     /* 1759551 */   // Label 23963: @1759551
     /* 1759551 */   GIM_Try, /*On fail goto*//*Label 23964*/ GIMT_Encode4(1759637), // Rule ID 11335 //
     /* 1759556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1759567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1759570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1759573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1759576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759602 */     // MIs[0] policy
     /* 1759602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1759615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759636 */     // GIR_Coverage, 11335,
     /* 1759636 */     GIR_EraseRootFromParent_Done,
     /* 1759637 */   // Label 23964: @1759637
     /* 1759637 */   GIM_Try, /*On fail goto*//*Label 23965*/ GIMT_Encode4(1759723), // Rule ID 11338 //
     /* 1759642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1759653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1759656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1759659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1759662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759688 */     // MIs[0] policy
     /* 1759688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759698 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1759701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759722 */     // GIR_Coverage, 11338,
     /* 1759722 */     GIR_EraseRootFromParent_Done,
     /* 1759723 */   // Label 23965: @1759723
     /* 1759723 */   GIM_Try, /*On fail goto*//*Label 23966*/ GIMT_Encode4(1759809), // Rule ID 11339 //
     /* 1759728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1759739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1759742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1759745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1759748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759774 */     // MIs[0] policy
     /* 1759774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1759787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759808 */     // GIR_Coverage, 11339,
     /* 1759808 */     GIR_EraseRootFromParent_Done,
     /* 1759809 */   // Label 23966: @1759809
     /* 1759809 */   GIM_Try, /*On fail goto*//*Label 23967*/ GIMT_Encode4(1759895), // Rule ID 11342 //
     /* 1759814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1759825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1759828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1759831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1759834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759860 */     // MIs[0] policy
     /* 1759860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759870 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1759873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759894 */     // GIR_Coverage, 11342,
     /* 1759894 */     GIR_EraseRootFromParent_Done,
     /* 1759895 */   // Label 23967: @1759895
     /* 1759895 */   GIM_Try, /*On fail goto*//*Label 23968*/ GIMT_Encode4(1759981), // Rule ID 11343 //
     /* 1759900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1759911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1759914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1759917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1759920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759946 */     // MIs[0] policy
     /* 1759946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759956 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1759959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759980 */     // GIR_Coverage, 11343,
     /* 1759980 */     GIR_EraseRootFromParent_Done,
     /* 1759981 */   // Label 23968: @1759981
     /* 1759981 */   GIM_Try, /*On fail goto*//*Label 23969*/ GIMT_Encode4(1760067), // Rule ID 11346 //
     /* 1759986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1759997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1760000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1760003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760032 */     // MIs[0] policy
     /* 1760032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760042 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1760045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760066 */     // GIR_Coverage, 11346,
     /* 1760066 */     GIR_EraseRootFromParent_Done,
     /* 1760067 */   // Label 23969: @1760067
     /* 1760067 */   GIM_Try, /*On fail goto*//*Label 23970*/ GIMT_Encode4(1760153), // Rule ID 11347 //
     /* 1760072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1760083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1760086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1760089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1760092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760118 */     // MIs[0] policy
     /* 1760118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760128 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1760131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760152 */     // GIR_Coverage, 11347,
     /* 1760152 */     GIR_EraseRootFromParent_Done,
     /* 1760153 */   // Label 23970: @1760153
     /* 1760153 */   GIM_Try, /*On fail goto*//*Label 23971*/ GIMT_Encode4(1760239), // Rule ID 11350 //
     /* 1760158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1760169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1760172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1760175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760204 */     // MIs[0] policy
     /* 1760204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760214 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1760217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760238 */     // GIR_Coverage, 11350,
     /* 1760238 */     GIR_EraseRootFromParent_Done,
     /* 1760239 */   // Label 23971: @1760239
     /* 1760239 */   GIM_Try, /*On fail goto*//*Label 23972*/ GIMT_Encode4(1760325), // Rule ID 11351 //
     /* 1760244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1760255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1760258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1760261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1760264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760290 */     // MIs[0] policy
     /* 1760290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760300 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1760303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760324 */     // GIR_Coverage, 11351,
     /* 1760324 */     GIR_EraseRootFromParent_Done,
     /* 1760325 */   // Label 23972: @1760325
     /* 1760325 */   GIM_Try, /*On fail goto*//*Label 23973*/ GIMT_Encode4(1760411), // Rule ID 11354 //
     /* 1760330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1760341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1760344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1760347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760376 */     // MIs[0] policy
     /* 1760376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760386 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1760389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760410 */     // GIR_Coverage, 11354,
     /* 1760410 */     GIR_EraseRootFromParent_Done,
     /* 1760411 */   // Label 23973: @1760411
     /* 1760411 */   GIM_Try, /*On fail goto*//*Label 23974*/ GIMT_Encode4(1760497), // Rule ID 11355 //
     /* 1760416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1760427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1760430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1760433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1760436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760462 */     // MIs[0] policy
     /* 1760462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760472 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1760475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760496 */     // GIR_Coverage, 11355,
     /* 1760496 */     GIR_EraseRootFromParent_Done,
     /* 1760497 */   // Label 23974: @1760497
     /* 1760497 */   GIM_Try, /*On fail goto*//*Label 23975*/ GIMT_Encode4(1760583), // Rule ID 11358 //
     /* 1760502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1760513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1760516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1760519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760548 */     // MIs[0] policy
     /* 1760548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760558 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1760561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760582 */     // GIR_Coverage, 11358,
     /* 1760582 */     GIR_EraseRootFromParent_Done,
     /* 1760583 */   // Label 23975: @1760583
     /* 1760583 */   GIM_Try, /*On fail goto*//*Label 23976*/ GIMT_Encode4(1760669), // Rule ID 11359 //
     /* 1760588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1760599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1760602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1760605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1760608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760634 */     // MIs[0] policy
     /* 1760634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760644 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1760647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760668 */     // GIR_Coverage, 11359,
     /* 1760668 */     GIR_EraseRootFromParent_Done,
     /* 1760669 */   // Label 23976: @1760669
     /* 1760669 */   GIM_Try, /*On fail goto*//*Label 23977*/ GIMT_Encode4(1760755), // Rule ID 11362 //
     /* 1760674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1760685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1760688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1760691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760720 */     // MIs[0] policy
     /* 1760720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760730 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1760733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760754 */     // GIR_Coverage, 11362,
     /* 1760754 */     GIR_EraseRootFromParent_Done,
     /* 1760755 */   // Label 23977: @1760755
     /* 1760755 */   GIM_Try, /*On fail goto*//*Label 23978*/ GIMT_Encode4(1760841), // Rule ID 11363 //
     /* 1760760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1760771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1760774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1760777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1760780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760806 */     // MIs[0] policy
     /* 1760806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760816 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1760819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760840 */     // GIR_Coverage, 11363,
     /* 1760840 */     GIR_EraseRootFromParent_Done,
     /* 1760841 */   // Label 23978: @1760841
     /* 1760841 */   GIM_Try, /*On fail goto*//*Label 23979*/ GIMT_Encode4(1760927), // Rule ID 11366 //
     /* 1760846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1760857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1760860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1760863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760892 */     // MIs[0] policy
     /* 1760892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760902 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1760905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760926 */     // GIR_Coverage, 11366,
     /* 1760926 */     GIR_EraseRootFromParent_Done,
     /* 1760927 */   // Label 23979: @1760927
     /* 1760927 */   GIM_Try, /*On fail goto*//*Label 23980*/ GIMT_Encode4(1761013), // Rule ID 11367 //
     /* 1760932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1760943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1760946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1760949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1760952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760978 */     // MIs[0] policy
     /* 1760978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760988 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1760991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761012 */     // GIR_Coverage, 11367,
     /* 1761012 */     GIR_EraseRootFromParent_Done,
     /* 1761013 */   // Label 23980: @1761013
     /* 1761013 */   GIM_Try, /*On fail goto*//*Label 23981*/ GIMT_Encode4(1761099), // Rule ID 11370 //
     /* 1761018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1761029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1761032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1761035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761064 */     // MIs[0] policy
     /* 1761064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761074 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1761077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761098 */     // GIR_Coverage, 11370,
     /* 1761098 */     GIR_EraseRootFromParent_Done,
     /* 1761099 */   // Label 23981: @1761099
     /* 1761099 */   GIM_Try, /*On fail goto*//*Label 23982*/ GIMT_Encode4(1761185), // Rule ID 11371 //
     /* 1761104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1761115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1761118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1761121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761150 */     // MIs[0] policy
     /* 1761150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761160 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1761163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761184 */     // GIR_Coverage, 11371,
     /* 1761184 */     GIR_EraseRootFromParent_Done,
     /* 1761185 */   // Label 23982: @1761185
     /* 1761185 */   GIM_Try, /*On fail goto*//*Label 23983*/ GIMT_Encode4(1761271), // Rule ID 11374 //
     /* 1761190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1761201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1761204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1761207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761236 */     // MIs[0] policy
     /* 1761236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1761249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761270 */     // GIR_Coverage, 11374,
     /* 1761270 */     GIR_EraseRootFromParent_Done,
     /* 1761271 */   // Label 23983: @1761271
     /* 1761271 */   GIM_Try, /*On fail goto*//*Label 23984*/ GIMT_Encode4(1761357), // Rule ID 11375 //
     /* 1761276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1761287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1761290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1761293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761322 */     // MIs[0] policy
     /* 1761322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761332 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1761335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761356 */     // GIR_Coverage, 11375,
     /* 1761356 */     GIR_EraseRootFromParent_Done,
     /* 1761357 */   // Label 23984: @1761357
     /* 1761357 */   GIM_Try, /*On fail goto*//*Label 23985*/ GIMT_Encode4(1761443), // Rule ID 11378 //
     /* 1761362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1761373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1761376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1761379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761408 */     // MIs[0] policy
     /* 1761408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1761421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761442 */     // GIR_Coverage, 11378,
     /* 1761442 */     GIR_EraseRootFromParent_Done,
     /* 1761443 */   // Label 23985: @1761443
     /* 1761443 */   GIM_Try, /*On fail goto*//*Label 23986*/ GIMT_Encode4(1761529), // Rule ID 11379 //
     /* 1761448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1761459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1761462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1761465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761494 */     // MIs[0] policy
     /* 1761494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761504 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1761507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761528 */     // GIR_Coverage, 11379,
     /* 1761528 */     GIR_EraseRootFromParent_Done,
     /* 1761529 */   // Label 23986: @1761529
     /* 1761529 */   GIM_Try, /*On fail goto*//*Label 23987*/ GIMT_Encode4(1761615), // Rule ID 11382 //
     /* 1761534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1761545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1761548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1761551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761580 */     // MIs[0] policy
     /* 1761580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761590 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1761593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761614 */     // GIR_Coverage, 11382,
     /* 1761614 */     GIR_EraseRootFromParent_Done,
     /* 1761615 */   // Label 23987: @1761615
     /* 1761615 */   GIM_Try, /*On fail goto*//*Label 23988*/ GIMT_Encode4(1761701), // Rule ID 11383 //
     /* 1761620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1761631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1761634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1761637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761666 */     // MIs[0] policy
     /* 1761666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761676 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1761679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761700 */     // GIR_Coverage, 11383,
     /* 1761700 */     GIR_EraseRootFromParent_Done,
     /* 1761701 */   // Label 23988: @1761701
     /* 1761701 */   GIM_Try, /*On fail goto*//*Label 23989*/ GIMT_Encode4(1761787), // Rule ID 11386 //
     /* 1761706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1761717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1761720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1761723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761752 */     // MIs[0] policy
     /* 1761752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761762 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1761765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761786 */     // GIR_Coverage, 11386,
     /* 1761786 */     GIR_EraseRootFromParent_Done,
     /* 1761787 */   // Label 23989: @1761787
     /* 1761787 */   GIM_Try, /*On fail goto*//*Label 23990*/ GIMT_Encode4(1761873), // Rule ID 11387 //
     /* 1761792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1761803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1761806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1761809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761838 */     // MIs[0] policy
     /* 1761838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761848 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1761851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761872 */     // GIR_Coverage, 11387,
     /* 1761872 */     GIR_EraseRootFromParent_Done,
     /* 1761873 */   // Label 23990: @1761873
     /* 1761873 */   GIM_Try, /*On fail goto*//*Label 23991*/ GIMT_Encode4(1761959), // Rule ID 11390 //
     /* 1761878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1761889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1761892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1761895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1761901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761924 */     // MIs[0] policy
     /* 1761924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761934 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1761937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761958 */     // GIR_Coverage, 11390,
     /* 1761958 */     GIR_EraseRootFromParent_Done,
     /* 1761959 */   // Label 23991: @1761959
     /* 1761959 */   GIM_Try, /*On fail goto*//*Label 23992*/ GIMT_Encode4(1762045), // Rule ID 11391 //
     /* 1761964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1761975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1761978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1761981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1761987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762010 */     // MIs[0] policy
     /* 1762010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762020 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1762023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762044 */     // GIR_Coverage, 11391,
     /* 1762044 */     GIR_EraseRootFromParent_Done,
     /* 1762045 */   // Label 23992: @1762045
     /* 1762045 */   GIM_Try, /*On fail goto*//*Label 23993*/ GIMT_Encode4(1762131), // Rule ID 11394 //
     /* 1762050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1762058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1762061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1762064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1762067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762096 */     // MIs[0] policy
     /* 1762096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762106 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1762109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762130 */     // GIR_Coverage, 11394,
     /* 1762130 */     GIR_EraseRootFromParent_Done,
     /* 1762131 */   // Label 23993: @1762131
     /* 1762131 */   GIM_Try, /*On fail goto*//*Label 23994*/ GIMT_Encode4(1762217), // Rule ID 11395 //
     /* 1762136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1762144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1762147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1762150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1762153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762182 */     // MIs[0] policy
     /* 1762182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762192 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1762195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762216 */     // GIR_Coverage, 11395,
     /* 1762216 */     GIR_EraseRootFromParent_Done,
     /* 1762217 */   // Label 23994: @1762217
     /* 1762217 */   GIM_Try, /*On fail goto*//*Label 23995*/ GIMT_Encode4(1762303), // Rule ID 11398 //
     /* 1762222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1762230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1762233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1762236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1762239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762268 */     // MIs[0] policy
     /* 1762268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762278 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1762281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762302 */     // GIR_Coverage, 11398,
     /* 1762302 */     GIR_EraseRootFromParent_Done,
     /* 1762303 */   // Label 23995: @1762303
     /* 1762303 */   GIM_Try, /*On fail goto*//*Label 23996*/ GIMT_Encode4(1762389), // Rule ID 11399 //
     /* 1762308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1762316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1762319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1762322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1762325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762354 */     // MIs[0] policy
     /* 1762354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762364 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1762367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762388 */     // GIR_Coverage, 11399,
     /* 1762388 */     GIR_EraseRootFromParent_Done,
     /* 1762389 */   // Label 23996: @1762389
     /* 1762389 */   GIM_Try, /*On fail goto*//*Label 23997*/ GIMT_Encode4(1762475), // Rule ID 11402 //
     /* 1762394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1762402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1762405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1762408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1762411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1762417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762440 */     // MIs[0] policy
     /* 1762440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762450 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1762453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762474 */     // GIR_Coverage, 11402,
     /* 1762474 */     GIR_EraseRootFromParent_Done,
     /* 1762475 */   // Label 23997: @1762475
     /* 1762475 */   GIM_Try, /*On fail goto*//*Label 23998*/ GIMT_Encode4(1762561), // Rule ID 11403 //
     /* 1762480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1762488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1762491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1762494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1762497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1762503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762526 */     // MIs[0] policy
     /* 1762526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762536 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1762539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762560 */     // GIR_Coverage, 11403,
     /* 1762560 */     GIR_EraseRootFromParent_Done,
     /* 1762561 */   // Label 23998: @1762561
     /* 1762561 */   GIM_Try, /*On fail goto*//*Label 23999*/ GIMT_Encode4(1762647), // Rule ID 11406 //
     /* 1762566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1762574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1762577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1762580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1762583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762612 */     // MIs[0] policy
     /* 1762612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762622 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1762625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762646 */     // GIR_Coverage, 11406,
     /* 1762646 */     GIR_EraseRootFromParent_Done,
     /* 1762647 */   // Label 23999: @1762647
     /* 1762647 */   GIM_Try, /*On fail goto*//*Label 24000*/ GIMT_Encode4(1762733), // Rule ID 11407 //
     /* 1762652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1762660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1762663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1762666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1762669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762698 */     // MIs[0] policy
     /* 1762698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1762711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762732 */     // GIR_Coverage, 11407,
     /* 1762732 */     GIR_EraseRootFromParent_Done,
     /* 1762733 */   // Label 24000: @1762733
     /* 1762733 */   GIM_Try, /*On fail goto*//*Label 24001*/ GIMT_Encode4(1762819), // Rule ID 11410 //
     /* 1762738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1762746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1762749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1762752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1762755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762784 */     // MIs[0] policy
     /* 1762784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762794 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1762797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762818 */     // GIR_Coverage, 11410,
     /* 1762818 */     GIR_EraseRootFromParent_Done,
     /* 1762819 */   // Label 24001: @1762819
     /* 1762819 */   GIM_Try, /*On fail goto*//*Label 24002*/ GIMT_Encode4(1762905), // Rule ID 11411 //
     /* 1762824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1762832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1762835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1762838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1762841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762870 */     // MIs[0] policy
     /* 1762870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762880 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1762883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762904 */     // GIR_Coverage, 11411,
     /* 1762904 */     GIR_EraseRootFromParent_Done,
     /* 1762905 */   // Label 24002: @1762905
     /* 1762905 */   GIM_Try, /*On fail goto*//*Label 24003*/ GIMT_Encode4(1762991), // Rule ID 11414 //
     /* 1762910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1762918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1762921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1762924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1762927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762956 */     // MIs[0] policy
     /* 1762956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762966 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1762969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762990 */     // GIR_Coverage, 11414,
     /* 1762990 */     GIR_EraseRootFromParent_Done,
     /* 1762991 */   // Label 24003: @1762991
     /* 1762991 */   GIM_Try, /*On fail goto*//*Label 24004*/ GIMT_Encode4(1763077), // Rule ID 11415 //
     /* 1762996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1763004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1763007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1763010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1763013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1763019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1763026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1763030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1763034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763042 */     // MIs[0] policy
     /* 1763042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763052 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1763055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763076 */     // GIR_Coverage, 11415,
     /* 1763076 */     GIR_EraseRootFromParent_Done,
     /* 1763077 */   // Label 24004: @1763077
     /* 1763077 */   GIM_Try, /*On fail goto*//*Label 24005*/ GIMT_Encode4(1763163), // Rule ID 11418 //
     /* 1763082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1763093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1763096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1763099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1763102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763128 */     // MIs[0] policy
     /* 1763128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763138 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1763141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763162 */     // GIR_Coverage, 11418,
     /* 1763162 */     GIR_EraseRootFromParent_Done,
     /* 1763163 */   // Label 24005: @1763163
     /* 1763163 */   GIM_Try, /*On fail goto*//*Label 24006*/ GIMT_Encode4(1763249), // Rule ID 11419 //
     /* 1763168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1763179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1763182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1763185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1763188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763214 */     // MIs[0] policy
     /* 1763214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763224 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1763227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763248 */     // GIR_Coverage, 11419,
     /* 1763248 */     GIR_EraseRootFromParent_Done,
     /* 1763249 */   // Label 24006: @1763249
     /* 1763249 */   GIM_Try, /*On fail goto*//*Label 24007*/ GIMT_Encode4(1763335), // Rule ID 11422 //
     /* 1763254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1763265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1763268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1763271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1763274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763300 */     // MIs[0] policy
     /* 1763300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763310 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1763313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763334 */     // GIR_Coverage, 11422,
     /* 1763334 */     GIR_EraseRootFromParent_Done,
     /* 1763335 */   // Label 24007: @1763335
     /* 1763335 */   GIM_Try, /*On fail goto*//*Label 24008*/ GIMT_Encode4(1763421), // Rule ID 11423 //
     /* 1763340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1763351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1763354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1763357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1763360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763386 */     // MIs[0] policy
     /* 1763386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763396 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1763399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763420 */     // GIR_Coverage, 11423,
     /* 1763420 */     GIR_EraseRootFromParent_Done,
     /* 1763421 */   // Label 24008: @1763421
     /* 1763421 */   GIM_Try, /*On fail goto*//*Label 24009*/ GIMT_Encode4(1763507), // Rule ID 11426 //
     /* 1763426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1763437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1763440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1763443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1763446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763472 */     // MIs[0] policy
     /* 1763472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763482 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1763485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763506 */     // GIR_Coverage, 11426,
     /* 1763506 */     GIR_EraseRootFromParent_Done,
     /* 1763507 */   // Label 24009: @1763507
     /* 1763507 */   GIM_Try, /*On fail goto*//*Label 24010*/ GIMT_Encode4(1763593), // Rule ID 11427 //
     /* 1763512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1763523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1763526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1763529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1763532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763558 */     // MIs[0] policy
     /* 1763558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763568 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1763571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763592 */     // GIR_Coverage, 11427,
     /* 1763592 */     GIR_EraseRootFromParent_Done,
     /* 1763593 */   // Label 24010: @1763593
     /* 1763593 */   GIM_Try, /*On fail goto*//*Label 24011*/ GIMT_Encode4(1763679), // Rule ID 11430 //
     /* 1763598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1763609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1763612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1763615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1763618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763644 */     // MIs[0] policy
     /* 1763644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763654 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1763657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763678 */     // GIR_Coverage, 11430,
     /* 1763678 */     GIR_EraseRootFromParent_Done,
     /* 1763679 */   // Label 24011: @1763679
     /* 1763679 */   GIM_Try, /*On fail goto*//*Label 24012*/ GIMT_Encode4(1763765), // Rule ID 11431 //
     /* 1763684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1763695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1763698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1763701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1763704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763730 */     // MIs[0] policy
     /* 1763730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763740 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1763743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763764 */     // GIR_Coverage, 11431,
     /* 1763764 */     GIR_EraseRootFromParent_Done,
     /* 1763765 */   // Label 24012: @1763765
     /* 1763765 */   GIM_Try, /*On fail goto*//*Label 24013*/ GIMT_Encode4(1763851), // Rule ID 11434 //
     /* 1763770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1763790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763816 */     // MIs[0] policy
     /* 1763816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763826 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1763829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763850 */     // GIR_Coverage, 11434,
     /* 1763850 */     GIR_EraseRootFromParent_Done,
     /* 1763851 */   // Label 24013: @1763851
     /* 1763851 */   GIM_Try, /*On fail goto*//*Label 24014*/ GIMT_Encode4(1763937), // Rule ID 11435 //
     /* 1763856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1763876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763902 */     // MIs[0] policy
     /* 1763902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763912 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1763915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763936 */     // GIR_Coverage, 11435,
     /* 1763936 */     GIR_EraseRootFromParent_Done,
     /* 1763937 */   // Label 24014: @1763937
     /* 1763937 */   GIM_Try, /*On fail goto*//*Label 24015*/ GIMT_Encode4(1764023), // Rule ID 11438 //
     /* 1763942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1763953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1763956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1763959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1763962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763988 */     // MIs[0] policy
     /* 1763988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1764001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764022 */     // GIR_Coverage, 11438,
     /* 1764022 */     GIR_EraseRootFromParent_Done,
     /* 1764023 */   // Label 24015: @1764023
     /* 1764023 */   GIM_Try, /*On fail goto*//*Label 24016*/ GIMT_Encode4(1764109), // Rule ID 11439 //
     /* 1764028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1764039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1764042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1764045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1764048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1764051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764074 */     // MIs[0] policy
     /* 1764074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1764087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764108 */     // GIR_Coverage, 11439,
     /* 1764108 */     GIR_EraseRootFromParent_Done,
     /* 1764109 */   // Label 24016: @1764109
     /* 1764109 */   GIM_Try, /*On fail goto*//*Label 24017*/ GIMT_Encode4(1764195), // Rule ID 11442 //
     /* 1764114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1764125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1764128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1764131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1764134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764160 */     // MIs[0] policy
     /* 1764160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764170 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1764173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764194 */     // GIR_Coverage, 11442,
     /* 1764194 */     GIR_EraseRootFromParent_Done,
     /* 1764195 */   // Label 24017: @1764195
     /* 1764195 */   GIM_Try, /*On fail goto*//*Label 24018*/ GIMT_Encode4(1764281), // Rule ID 11443 //
     /* 1764200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1764211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1764214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1764217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1764220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764246 */     // MIs[0] policy
     /* 1764246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764256 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1764259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764280 */     // GIR_Coverage, 11443,
     /* 1764280 */     GIR_EraseRootFromParent_Done,
     /* 1764281 */   // Label 24018: @1764281
     /* 1764281 */   GIM_Try, /*On fail goto*//*Label 24019*/ GIMT_Encode4(1764367), // Rule ID 11446 //
     /* 1764286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1764297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1764300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1764303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1764306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764332 */     // MIs[0] policy
     /* 1764332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1764345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764366 */     // GIR_Coverage, 11446,
     /* 1764366 */     GIR_EraseRootFromParent_Done,
     /* 1764367 */   // Label 24019: @1764367
     /* 1764367 */   GIM_Try, /*On fail goto*//*Label 24020*/ GIMT_Encode4(1764453), // Rule ID 11447 //
     /* 1764372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1764383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1764386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1764389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1764392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764418 */     // MIs[0] policy
     /* 1764418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764428 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1764431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764452 */     // GIR_Coverage, 11447,
     /* 1764452 */     GIR_EraseRootFromParent_Done,
     /* 1764453 */   // Label 24020: @1764453
     /* 1764453 */   GIM_Try, /*On fail goto*//*Label 24021*/ GIMT_Encode4(1764539), // Rule ID 11450 //
     /* 1764458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1764469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1764472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1764475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1764478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764504 */     // MIs[0] policy
     /* 1764504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764514 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1764517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764538 */     // GIR_Coverage, 11450,
     /* 1764538 */     GIR_EraseRootFromParent_Done,
     /* 1764539 */   // Label 24021: @1764539
     /* 1764539 */   GIM_Try, /*On fail goto*//*Label 24022*/ GIMT_Encode4(1764625), // Rule ID 11451 //
     /* 1764544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1764555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1764558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1764561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1764564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764590 */     // MIs[0] policy
     /* 1764590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1764603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764624 */     // GIR_Coverage, 11451,
     /* 1764624 */     GIR_EraseRootFromParent_Done,
     /* 1764625 */   // Label 24022: @1764625
     /* 1764625 */   GIM_Try, /*On fail goto*//*Label 24023*/ GIMT_Encode4(1764711), // Rule ID 11454 //
     /* 1764630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1764641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1764644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1764647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1764650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764676 */     // MIs[0] policy
     /* 1764676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764686 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1764689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764710 */     // GIR_Coverage, 11454,
     /* 1764710 */     GIR_EraseRootFromParent_Done,
     /* 1764711 */   // Label 24023: @1764711
     /* 1764711 */   GIM_Try, /*On fail goto*//*Label 24024*/ GIMT_Encode4(1764797), // Rule ID 11455 //
     /* 1764716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1764727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1764730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1764733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1764736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764762 */     // MIs[0] policy
     /* 1764762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764772 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1764775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764796 */     // GIR_Coverage, 11455,
     /* 1764796 */     GIR_EraseRootFromParent_Done,
     /* 1764797 */   // Label 24024: @1764797
     /* 1764797 */   GIM_Try, /*On fail goto*//*Label 24025*/ GIMT_Encode4(1764883), // Rule ID 11458 //
     /* 1764802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1764813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1764816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1764819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1764822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764848 */     // MIs[0] policy
     /* 1764848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764858 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1764861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764882 */     // GIR_Coverage, 11458,
     /* 1764882 */     GIR_EraseRootFromParent_Done,
     /* 1764883 */   // Label 24025: @1764883
     /* 1764883 */   GIM_Try, /*On fail goto*//*Label 24026*/ GIMT_Encode4(1764969), // Rule ID 11459 //
     /* 1764888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1764899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1764902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1764905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1764908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764934 */     // MIs[0] policy
     /* 1764934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764944 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1764947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764968 */     // GIR_Coverage, 11459,
     /* 1764968 */     GIR_EraseRootFromParent_Done,
     /* 1764969 */   // Label 24026: @1764969
     /* 1764969 */   GIM_Try, /*On fail goto*//*Label 24027*/ GIMT_Encode4(1765055), // Rule ID 11462 //
     /* 1764974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1764985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1764988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1764991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1764994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1764997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765020 */     // MIs[0] policy
     /* 1765020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765030 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1765033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1765051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765054 */     // GIR_Coverage, 11462,
     /* 1765054 */     GIR_EraseRootFromParent_Done,
     /* 1765055 */   // Label 24027: @1765055
     /* 1765055 */   GIM_Try, /*On fail goto*//*Label 24028*/ GIMT_Encode4(1765141), // Rule ID 11463 //
     /* 1765060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1765071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1765074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1765077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1765080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1765083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765106 */     // MIs[0] policy
     /* 1765106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765116 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1765119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1765137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765140 */     // GIR_Coverage, 11463,
     /* 1765140 */     GIR_EraseRootFromParent_Done,
     /* 1765141 */   // Label 24028: @1765141
     /* 1765141 */   GIM_Try, /*On fail goto*//*Label 24029*/ GIMT_Encode4(1765227), // Rule ID 11466 //
     /* 1765146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1765157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1765160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1765163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1765166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765192 */     // MIs[0] policy
     /* 1765192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1765205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765226 */     // GIR_Coverage, 11466,
     /* 1765226 */     GIR_EraseRootFromParent_Done,
     /* 1765227 */   // Label 24029: @1765227
     /* 1765227 */   GIM_Try, /*On fail goto*//*Label 24030*/ GIMT_Encode4(1765313), // Rule ID 11467 //
     /* 1765232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1765243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1765246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1765249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1765252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765278 */     // MIs[0] policy
     /* 1765278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765288 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1765291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765312 */     // GIR_Coverage, 11467,
     /* 1765312 */     GIR_EraseRootFromParent_Done,
     /* 1765313 */   // Label 24030: @1765313
     /* 1765313 */   GIM_Try, /*On fail goto*//*Label 24031*/ GIMT_Encode4(1765399), // Rule ID 11470 //
     /* 1765318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1765329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1765332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1765335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1765338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765364 */     // MIs[0] policy
     /* 1765364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765374 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1765377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765398 */     // GIR_Coverage, 11470,
     /* 1765398 */     GIR_EraseRootFromParent_Done,
     /* 1765399 */   // Label 24031: @1765399
     /* 1765399 */   GIM_Try, /*On fail goto*//*Label 24032*/ GIMT_Encode4(1765485), // Rule ID 11471 //
     /* 1765404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1765415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1765418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1765421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1765424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765450 */     // MIs[0] policy
     /* 1765450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1765463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765484 */     // GIR_Coverage, 11471,
     /* 1765484 */     GIR_EraseRootFromParent_Done,
     /* 1765485 */   // Label 24032: @1765485
     /* 1765485 */   GIM_Try, /*On fail goto*//*Label 24033*/ GIMT_Encode4(1765571), // Rule ID 11474 //
     /* 1765490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1765501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1765504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1765507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1765510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1765513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765536 */     // MIs[0] policy
     /* 1765536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1765549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765570 */     // GIR_Coverage, 11474,
     /* 1765570 */     GIR_EraseRootFromParent_Done,
     /* 1765571 */   // Label 24033: @1765571
     /* 1765571 */   GIM_Try, /*On fail goto*//*Label 24034*/ GIMT_Encode4(1765657), // Rule ID 11475 //
     /* 1765576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1765587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1765590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1765593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1765596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1765599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765622 */     // MIs[0] policy
     /* 1765622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765632 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1765635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765656 */     // GIR_Coverage, 11475,
     /* 1765656 */     GIR_EraseRootFromParent_Done,
     /* 1765657 */   // Label 24034: @1765657
     /* 1765657 */   GIM_Try, /*On fail goto*//*Label 24035*/ GIMT_Encode4(1765743), // Rule ID 11478 //
     /* 1765662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1765673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1765676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1765679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1765682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765708 */     // MIs[0] policy
     /* 1765708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1765721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765742 */     // GIR_Coverage, 11478,
     /* 1765742 */     GIR_EraseRootFromParent_Done,
     /* 1765743 */   // Label 24035: @1765743
     /* 1765743 */   GIM_Try, /*On fail goto*//*Label 24036*/ GIMT_Encode4(1765829), // Rule ID 11479 //
     /* 1765748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1765759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1765762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1765765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1765768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765794 */     // MIs[0] policy
     /* 1765794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1765807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765828 */     // GIR_Coverage, 11479,
     /* 1765828 */     GIR_EraseRootFromParent_Done,
     /* 1765829 */   // Label 24036: @1765829
     /* 1765829 */   GIM_Try, /*On fail goto*//*Label 24037*/ GIMT_Encode4(1765915), // Rule ID 11482 //
     /* 1765834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1765845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1765848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1765851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1765854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765880 */     // MIs[0] policy
     /* 1765880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765890 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1765893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765914 */     // GIR_Coverage, 11482,
     /* 1765914 */     GIR_EraseRootFromParent_Done,
     /* 1765915 */   // Label 24037: @1765915
     /* 1765915 */   GIM_Try, /*On fail goto*//*Label 24038*/ GIMT_Encode4(1766001), // Rule ID 11483 //
     /* 1765920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1765931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1765934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1765937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1765940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765966 */     // MIs[0] policy
     /* 1765966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1765979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766000 */     // GIR_Coverage, 11483,
     /* 1766000 */     GIR_EraseRootFromParent_Done,
     /* 1766001 */   // Label 24038: @1766001
     /* 1766001 */   GIM_Try, /*On fail goto*//*Label 24039*/ GIMT_Encode4(1766087), // Rule ID 11486 //
     /* 1766006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1766009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1766017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1766020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1766023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1766026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1766029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766052 */     // MIs[0] policy
     /* 1766052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766062 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1766065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1766083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766086 */     // GIR_Coverage, 11486,
     /* 1766086 */     GIR_EraseRootFromParent_Done,
     /* 1766087 */   // Label 24039: @1766087
     /* 1766087 */   GIM_Try, /*On fail goto*//*Label 24040*/ GIMT_Encode4(1766173), // Rule ID 11487 //
     /* 1766092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1766095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1766103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1766106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1766109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1766112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1766115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766138 */     // MIs[0] policy
     /* 1766138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766148 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1766151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1766169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766172 */     // GIR_Coverage, 11487,
     /* 1766172 */     GIR_EraseRootFromParent_Done,
     /* 1766173 */   // Label 24040: @1766173
     /* 1766173 */   GIM_Try, /*On fail goto*//*Label 24041*/ GIMT_Encode4(1766259), // Rule ID 11490 //
     /* 1766178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1766181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1766189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1766192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1766195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766224 */     // MIs[0] policy
     /* 1766224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766234 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1766237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1766255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766258 */     // GIR_Coverage, 11490,
     /* 1766258 */     GIR_EraseRootFromParent_Done,
     /* 1766259 */   // Label 24041: @1766259
     /* 1766259 */   GIM_Try, /*On fail goto*//*Label 24042*/ GIMT_Encode4(1766345), // Rule ID 11491 //
     /* 1766264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1766267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1766275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1766278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1766281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766310 */     // MIs[0] policy
     /* 1766310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766320 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1766323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1766341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766344 */     // GIR_Coverage, 11491,
     /* 1766344 */     GIR_EraseRootFromParent_Done,
     /* 1766345 */   // Label 24042: @1766345
     /* 1766345 */   GIM_Try, /*On fail goto*//*Label 24043*/ GIMT_Encode4(1766431), // Rule ID 11494 //
     /* 1766350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1766353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1766361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1766364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1766367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766396 */     // MIs[0] policy
     /* 1766396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766406 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1766409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1766427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766430 */     // GIR_Coverage, 11494,
     /* 1766430 */     GIR_EraseRootFromParent_Done,
     /* 1766431 */   // Label 24043: @1766431
     /* 1766431 */   GIM_Try, /*On fail goto*//*Label 24044*/ GIMT_Encode4(1766517), // Rule ID 11495 //
     /* 1766436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1766439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1766447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1766450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1766453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766482 */     // MIs[0] policy
     /* 1766482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766492 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1766495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1766513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766516 */     // GIR_Coverage, 11495,
     /* 1766516 */     GIR_EraseRootFromParent_Done,
     /* 1766517 */   // Label 24044: @1766517
     /* 1766517 */   GIM_Try, /*On fail goto*//*Label 24045*/ GIMT_Encode4(1766603), // Rule ID 11498 //
     /* 1766522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1766525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1766533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1766536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1766539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766568 */     // MIs[0] policy
     /* 1766568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766578 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1766581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1766599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766602 */     // GIR_Coverage, 11498,
     /* 1766602 */     GIR_EraseRootFromParent_Done,
     /* 1766603 */   // Label 24045: @1766603
     /* 1766603 */   GIM_Try, /*On fail goto*//*Label 24046*/ GIMT_Encode4(1766689), // Rule ID 11499 //
     /* 1766608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1766611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1766619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1766622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1766625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766654 */     // MIs[0] policy
     /* 1766654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766664 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1766667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1766685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766688 */     // GIR_Coverage, 11499,
     /* 1766688 */     GIR_EraseRootFromParent_Done,
     /* 1766689 */   // Label 24046: @1766689
     /* 1766689 */   GIM_Try, /*On fail goto*//*Label 24047*/ GIMT_Encode4(1766775), // Rule ID 11502 //
     /* 1766694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1766697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1766705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1766708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1766711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766740 */     // MIs[0] policy
     /* 1766740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766750 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1766753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1766771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766774 */     // GIR_Coverage, 11502,
     /* 1766774 */     GIR_EraseRootFromParent_Done,
     /* 1766775 */   // Label 24047: @1766775
     /* 1766775 */   GIM_Try, /*On fail goto*//*Label 24048*/ GIMT_Encode4(1766861), // Rule ID 11503 //
     /* 1766780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1766783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1766791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1766794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1766797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766826 */     // MIs[0] policy
     /* 1766826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766836 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1766839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1766857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766860 */     // GIR_Coverage, 11503,
     /* 1766860 */     GIR_EraseRootFromParent_Done,
     /* 1766861 */   // Label 24048: @1766861
     /* 1766861 */   GIM_Try, /*On fail goto*//*Label 24049*/ GIMT_Encode4(1766947), // Rule ID 11506 //
     /* 1766866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1766869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1766877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1766880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1766883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766912 */     // MIs[0] policy
     /* 1766912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766922 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1766925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1766943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766946 */     // GIR_Coverage, 11506,
     /* 1766946 */     GIR_EraseRootFromParent_Done,
     /* 1766947 */   // Label 24049: @1766947
     /* 1766947 */   GIM_Try, /*On fail goto*//*Label 24050*/ GIMT_Encode4(1767033), // Rule ID 11507 //
     /* 1766952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1766955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1766963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1766966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1766969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766998 */     // MIs[0] policy
     /* 1766998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767008 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1767011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1767029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767032 */     // GIR_Coverage, 11507,
     /* 1767032 */     GIR_EraseRootFromParent_Done,
     /* 1767033 */   // Label 24050: @1767033
     /* 1767033 */   GIM_Try, /*On fail goto*//*Label 24051*/ GIMT_Encode4(1767119), // Rule ID 11510 //
     /* 1767038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1767049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1767052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1767055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767084 */     // MIs[0] policy
     /* 1767084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767094 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1767097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1767115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767118 */     // GIR_Coverage, 11510,
     /* 1767118 */     GIR_EraseRootFromParent_Done,
     /* 1767119 */   // Label 24051: @1767119
     /* 1767119 */   GIM_Try, /*On fail goto*//*Label 24052*/ GIMT_Encode4(1767205), // Rule ID 11511 //
     /* 1767124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1767135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1767138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1767141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767170 */     // MIs[0] policy
     /* 1767170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767180 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1767183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1767201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767204 */     // GIR_Coverage, 11511,
     /* 1767204 */     GIR_EraseRootFromParent_Done,
     /* 1767205 */   // Label 24052: @1767205
     /* 1767205 */   GIM_Try, /*On fail goto*//*Label 24053*/ GIMT_Encode4(1767291), // Rule ID 11514 //
     /* 1767210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1767221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1767224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1767227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767256 */     // MIs[0] policy
     /* 1767256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767266 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1767269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767290 */     // GIR_Coverage, 11514,
     /* 1767290 */     GIR_EraseRootFromParent_Done,
     /* 1767291 */   // Label 24053: @1767291
     /* 1767291 */   GIM_Try, /*On fail goto*//*Label 24054*/ GIMT_Encode4(1767377), // Rule ID 11515 //
     /* 1767296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1767307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1767310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1767313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767342 */     // MIs[0] policy
     /* 1767342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1767355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767376 */     // GIR_Coverage, 11515,
     /* 1767376 */     GIR_EraseRootFromParent_Done,
     /* 1767377 */   // Label 24054: @1767377
     /* 1767377 */   GIM_Try, /*On fail goto*//*Label 24055*/ GIMT_Encode4(1767463), // Rule ID 11518 //
     /* 1767382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1767393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1767396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1767399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767428 */     // MIs[0] policy
     /* 1767428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767438 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1767441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1767459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767462 */     // GIR_Coverage, 11518,
     /* 1767462 */     GIR_EraseRootFromParent_Done,
     /* 1767463 */   // Label 24055: @1767463
     /* 1767463 */   GIM_Try, /*On fail goto*//*Label 24056*/ GIMT_Encode4(1767549), // Rule ID 11519 //
     /* 1767468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1767479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1767482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1767485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767514 */     // MIs[0] policy
     /* 1767514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1767527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1767545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767548 */     // GIR_Coverage, 11519,
     /* 1767548 */     GIR_EraseRootFromParent_Done,
     /* 1767549 */   // Label 24056: @1767549
     /* 1767549 */   GIM_Try, /*On fail goto*//*Label 24057*/ GIMT_Encode4(1767635), // Rule ID 11522 //
     /* 1767554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1767565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1767568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1767571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767600 */     // MIs[0] policy
     /* 1767600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767610 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1767613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1767631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767634 */     // GIR_Coverage, 11522,
     /* 1767634 */     GIR_EraseRootFromParent_Done,
     /* 1767635 */   // Label 24057: @1767635
     /* 1767635 */   GIM_Try, /*On fail goto*//*Label 24058*/ GIMT_Encode4(1767721), // Rule ID 11523 //
     /* 1767640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1767651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1767654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1767657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767686 */     // MIs[0] policy
     /* 1767686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1767699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1767717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767720 */     // GIR_Coverage, 11523,
     /* 1767720 */     GIR_EraseRootFromParent_Done,
     /* 1767721 */   // Label 24058: @1767721
     /* 1767721 */   GIM_Try, /*On fail goto*//*Label 24059*/ GIMT_Encode4(1767807), // Rule ID 11526 //
     /* 1767726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1767737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1767740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1767743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1767749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767772 */     // MIs[0] policy
     /* 1767772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767782 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1767785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767806 */     // GIR_Coverage, 11526,
     /* 1767806 */     GIR_EraseRootFromParent_Done,
     /* 1767807 */   // Label 24059: @1767807
     /* 1767807 */   GIM_Try, /*On fail goto*//*Label 24060*/ GIMT_Encode4(1767893), // Rule ID 11527 //
     /* 1767812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1767823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1767826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1767829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1767835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767858 */     // MIs[0] policy
     /* 1767858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767868 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1767871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767892 */     // GIR_Coverage, 11527,
     /* 1767892 */     GIR_EraseRootFromParent_Done,
     /* 1767893 */   // Label 24060: @1767893
     /* 1767893 */   GIM_Try, /*On fail goto*//*Label 24061*/ GIMT_Encode4(1767979), // Rule ID 11530 //
     /* 1767898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1767909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1767912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1767915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1767921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767944 */     // MIs[0] policy
     /* 1767944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767954 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1767957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767978 */     // GIR_Coverage, 11530,
     /* 1767978 */     GIR_EraseRootFromParent_Done,
     /* 1767979 */   // Label 24061: @1767979
     /* 1767979 */   GIM_Try, /*On fail goto*//*Label 24062*/ GIMT_Encode4(1768065), // Rule ID 11531 //
     /* 1767984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1767995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1767998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1768001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1768007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768030 */     // MIs[0] policy
     /* 1768030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768040 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1768043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768064 */     // GIR_Coverage, 11531,
     /* 1768064 */     GIR_EraseRootFromParent_Done,
     /* 1768065 */   // Label 24062: @1768065
     /* 1768065 */   GIM_Try, /*On fail goto*//*Label 24063*/ GIMT_Encode4(1768151), // Rule ID 11534 //
     /* 1768070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1768081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1768084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1768087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1768093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768116 */     // MIs[0] policy
     /* 1768116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768126 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1768129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768150 */     // GIR_Coverage, 11534,
     /* 1768150 */     GIR_EraseRootFromParent_Done,
     /* 1768151 */   // Label 24063: @1768151
     /* 1768151 */   GIM_Try, /*On fail goto*//*Label 24064*/ GIMT_Encode4(1768237), // Rule ID 11535 //
     /* 1768156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1768167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1768170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1768173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1768179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768202 */     // MIs[0] policy
     /* 1768202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768212 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1768215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768236 */     // GIR_Coverage, 11535,
     /* 1768236 */     GIR_EraseRootFromParent_Done,
     /* 1768237 */   // Label 24064: @1768237
     /* 1768237 */   GIM_Try, /*On fail goto*//*Label 24065*/ GIMT_Encode4(1768323), // Rule ID 11538 //
     /* 1768242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1768253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1768256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1768259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768288 */     // MIs[0] policy
     /* 1768288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1768301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768322 */     // GIR_Coverage, 11538,
     /* 1768322 */     GIR_EraseRootFromParent_Done,
     /* 1768323 */   // Label 24065: @1768323
     /* 1768323 */   GIM_Try, /*On fail goto*//*Label 24066*/ GIMT_Encode4(1768409), // Rule ID 11539 //
     /* 1768328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1768339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1768342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1768345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768374 */     // MIs[0] policy
     /* 1768374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1768387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768408 */     // GIR_Coverage, 11539,
     /* 1768408 */     GIR_EraseRootFromParent_Done,
     /* 1768409 */   // Label 24066: @1768409
     /* 1768409 */   GIM_Try, /*On fail goto*//*Label 24067*/ GIMT_Encode4(1768495), // Rule ID 11542 //
     /* 1768414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1768425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1768428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1768431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1768437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768460 */     // MIs[0] policy
     /* 1768460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768470 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1768473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768494 */     // GIR_Coverage, 11542,
     /* 1768494 */     GIR_EraseRootFromParent_Done,
     /* 1768495 */   // Label 24067: @1768495
     /* 1768495 */   GIM_Try, /*On fail goto*//*Label 24068*/ GIMT_Encode4(1768581), // Rule ID 11543 //
     /* 1768500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1768511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1768514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1768517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1768523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768546 */     // MIs[0] policy
     /* 1768546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768556 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1768559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768580 */     // GIR_Coverage, 11543,
     /* 1768580 */     GIR_EraseRootFromParent_Done,
     /* 1768581 */   // Label 24068: @1768581
     /* 1768581 */   GIM_Try, /*On fail goto*//*Label 24069*/ GIMT_Encode4(1768667), // Rule ID 11546 //
     /* 1768586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1768597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1768600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1768603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1768609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768632 */     // MIs[0] policy
     /* 1768632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768642 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1768645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768666 */     // GIR_Coverage, 11546,
     /* 1768666 */     GIR_EraseRootFromParent_Done,
     /* 1768667 */   // Label 24069: @1768667
     /* 1768667 */   GIM_Try, /*On fail goto*//*Label 24070*/ GIMT_Encode4(1768753), // Rule ID 11547 //
     /* 1768672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1768683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1768686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1768689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1768695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768718 */     // MIs[0] policy
     /* 1768718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768728 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1768731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768752 */     // GIR_Coverage, 11547,
     /* 1768752 */     GIR_EraseRootFromParent_Done,
     /* 1768753 */   // Label 24070: @1768753
     /* 1768753 */   GIM_Try, /*On fail goto*//*Label 24071*/ GIMT_Encode4(1768839), // Rule ID 11550 //
     /* 1768758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1768769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1768772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1768775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768804 */     // MIs[0] policy
     /* 1768804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768814 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1768817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1768835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768838 */     // GIR_Coverage, 11550,
     /* 1768838 */     GIR_EraseRootFromParent_Done,
     /* 1768839 */   // Label 24071: @1768839
     /* 1768839 */   GIM_Try, /*On fail goto*//*Label 24072*/ GIMT_Encode4(1768925), // Rule ID 11551 //
     /* 1768844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1768855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1768858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1768861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768890 */     // MIs[0] policy
     /* 1768890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768900 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1768903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1768921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768924 */     // GIR_Coverage, 11551,
     /* 1768924 */     GIR_EraseRootFromParent_Done,
     /* 1768925 */   // Label 24072: @1768925
     /* 1768925 */   GIM_Try, /*On fail goto*//*Label 24073*/ GIMT_Encode4(1769011), // Rule ID 11554 //
     /* 1768930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1768941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1768944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1768947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768976 */     // MIs[0] policy
     /* 1768976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768986 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1768989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1769007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769010 */     // GIR_Coverage, 11554,
     /* 1769010 */     GIR_EraseRootFromParent_Done,
     /* 1769011 */   // Label 24073: @1769011
     /* 1769011 */   GIM_Try, /*On fail goto*//*Label 24074*/ GIMT_Encode4(1769097), // Rule ID 11555 //
     /* 1769016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1769027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1769030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1769033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769062 */     // MIs[0] policy
     /* 1769062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769072 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1769075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1769093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769096 */     // GIR_Coverage, 11555,
     /* 1769096 */     GIR_EraseRootFromParent_Done,
     /* 1769097 */   // Label 24074: @1769097
     /* 1769097 */   GIM_Try, /*On fail goto*//*Label 24075*/ GIMT_Encode4(1769183), // Rule ID 11558 //
     /* 1769102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1769113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1769116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1769119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1769125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769148 */     // MIs[0] policy
     /* 1769148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769158 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1769161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1769179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769182 */     // GIR_Coverage, 11558,
     /* 1769182 */     GIR_EraseRootFromParent_Done,
     /* 1769183 */   // Label 24075: @1769183
     /* 1769183 */   GIM_Try, /*On fail goto*//*Label 24076*/ GIMT_Encode4(1769269), // Rule ID 11559 //
     /* 1769188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1769199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1769202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1769205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1769211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769234 */     // MIs[0] policy
     /* 1769234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769244 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1769247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1769265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769268 */     // GIR_Coverage, 11559,
     /* 1769268 */     GIR_EraseRootFromParent_Done,
     /* 1769269 */   // Label 24076: @1769269
     /* 1769269 */   GIM_Try, /*On fail goto*//*Label 24077*/ GIMT_Encode4(1769355), // Rule ID 11562 //
     /* 1769274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1769282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1769285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1769288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1769291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1769294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1769297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769320 */     // MIs[0] policy
     /* 1769320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769330 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1769333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769354 */     // GIR_Coverage, 11562,
     /* 1769354 */     GIR_EraseRootFromParent_Done,
     /* 1769355 */   // Label 24077: @1769355
     /* 1769355 */   GIM_Try, /*On fail goto*//*Label 24078*/ GIMT_Encode4(1769441), // Rule ID 11563 //
     /* 1769360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1769368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1769371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1769374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1769377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1769380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1769383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769406 */     // MIs[0] policy
     /* 1769406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769416 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1769419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769440 */     // GIR_Coverage, 11563,
     /* 1769440 */     GIR_EraseRootFromParent_Done,
     /* 1769441 */   // Label 24078: @1769441
     /* 1769441 */   GIM_Try, /*On fail goto*//*Label 24079*/ GIMT_Encode4(1769527), // Rule ID 11566 //
     /* 1769446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1769454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1769457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1769460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1769463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1769466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769492 */     // MIs[0] policy
     /* 1769492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769502 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1769505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769526 */     // GIR_Coverage, 11566,
     /* 1769526 */     GIR_EraseRootFromParent_Done,
     /* 1769527 */   // Label 24079: @1769527
     /* 1769527 */   GIM_Try, /*On fail goto*//*Label 24080*/ GIMT_Encode4(1769613), // Rule ID 11567 //
     /* 1769532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1769540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1769543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1769546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1769549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1769552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769578 */     // MIs[0] policy
     /* 1769578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769588 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1769591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769612 */     // GIR_Coverage, 11567,
     /* 1769612 */     GIR_EraseRootFromParent_Done,
     /* 1769613 */   // Label 24080: @1769613
     /* 1769613 */   GIM_Try, /*On fail goto*//*Label 24081*/ GIMT_Encode4(1769699), // Rule ID 11570 //
     /* 1769618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1769626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1769638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769664 */     // MIs[0] policy
     /* 1769664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769674 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1769677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769698 */     // GIR_Coverage, 11570,
     /* 1769698 */     GIR_EraseRootFromParent_Done,
     /* 1769699 */   // Label 24081: @1769699
     /* 1769699 */   GIM_Try, /*On fail goto*//*Label 24082*/ GIMT_Encode4(1769785), // Rule ID 11571 //
     /* 1769704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1769712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1769724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769750 */     // MIs[0] policy
     /* 1769750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769760 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1769763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769784 */     // GIR_Coverage, 11571,
     /* 1769784 */     GIR_EraseRootFromParent_Done,
     /* 1769785 */   // Label 24082: @1769785
     /* 1769785 */   GIM_Try, /*On fail goto*//*Label 24083*/ GIMT_Encode4(1769871), // Rule ID 11574 //
     /* 1769790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1769798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1769810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769836 */     // MIs[0] policy
     /* 1769836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1769849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769870 */     // GIR_Coverage, 11574,
     /* 1769870 */     GIR_EraseRootFromParent_Done,
     /* 1769871 */   // Label 24083: @1769871
     /* 1769871 */   GIM_Try, /*On fail goto*//*Label 24084*/ GIMT_Encode4(1769957), // Rule ID 11575 //
     /* 1769876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1769884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1769896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769922 */     // MIs[0] policy
     /* 1769922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769932 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1769935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769956 */     // GIR_Coverage, 11575,
     /* 1769956 */     GIR_EraseRootFromParent_Done,
     /* 1769957 */   // Label 24084: @1769957
     /* 1769957 */   GIM_Try, /*On fail goto*//*Label 24085*/ GIMT_Encode4(1770043), // Rule ID 11578 //
     /* 1769962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1769970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1769973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1769976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1769979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1769985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770008 */     // MIs[0] policy
     /* 1770008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770018 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1770021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770042 */     // GIR_Coverage, 11578,
     /* 1770042 */     GIR_EraseRootFromParent_Done,
     /* 1770043 */   // Label 24085: @1770043
     /* 1770043 */   GIM_Try, /*On fail goto*//*Label 24086*/ GIMT_Encode4(1770129), // Rule ID 11579 //
     /* 1770048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1770051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1770056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1770059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1770062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1770065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1770068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770094 */     // MIs[0] policy
     /* 1770094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770104 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1770107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770128 */     // GIR_Coverage, 11579,
     /* 1770128 */     GIR_EraseRootFromParent_Done,
     /* 1770129 */   // Label 24086: @1770129
     /* 1770129 */   GIM_Try, /*On fail goto*//*Label 24087*/ GIMT_Encode4(1770215), // Rule ID 11582 //
     /* 1770134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1770137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1770142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1770145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1770148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1770151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1770154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1770164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770180 */     // MIs[0] policy
     /* 1770180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1770193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770214 */     // GIR_Coverage, 11582,
     /* 1770214 */     GIR_EraseRootFromParent_Done,
     /* 1770215 */   // Label 24087: @1770215
     /* 1770215 */   GIM_Try, /*On fail goto*//*Label 24088*/ GIMT_Encode4(1770301), // Rule ID 11583 //
     /* 1770220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1770223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1770228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1770231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1770234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1770237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1770240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1770250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770266 */     // MIs[0] policy
     /* 1770266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1770279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770300 */     // GIR_Coverage, 11583,
     /* 1770300 */     GIR_EraseRootFromParent_Done,
     /* 1770301 */   // Label 24088: @1770301
     /* 1770301 */   GIM_Try, /*On fail goto*//*Label 24089*/ GIMT_Encode4(1770387), // Rule ID 11586 //
     /* 1770306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1770309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1770314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1770317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1770320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1770323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1770326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1770336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770352 */     // MIs[0] policy
     /* 1770352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770362 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1770365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770386 */     // GIR_Coverage, 11586,
     /* 1770386 */     GIR_EraseRootFromParent_Done,
     /* 1770387 */   // Label 24089: @1770387
     /* 1770387 */   GIM_Try, /*On fail goto*//*Label 24090*/ GIMT_Encode4(1770473), // Rule ID 11587 //
     /* 1770392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1770395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1770400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1770403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1770406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1770409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1770412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1770422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770438 */     // MIs[0] policy
     /* 1770438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770448 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1770451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770472 */     // GIR_Coverage, 11587,
     /* 1770472 */     GIR_EraseRootFromParent_Done,
     /* 1770473 */   // Label 24090: @1770473
     /* 1770473 */   GIM_Try, /*On fail goto*//*Label 24091*/ GIMT_Encode4(1770559), // Rule ID 11590 //
     /* 1770478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1770481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1770486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1770489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1770492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1770495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1770498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1770508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770524 */     // MIs[0] policy
     /* 1770524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770534 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1770537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770558 */     // GIR_Coverage, 11590,
     /* 1770558 */     GIR_EraseRootFromParent_Done,
     /* 1770559 */   // Label 24091: @1770559
     /* 1770559 */   GIM_Try, /*On fail goto*//*Label 24092*/ GIMT_Encode4(1770645), // Rule ID 11591 //
     /* 1770564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1770567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1770572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1770575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1770578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1770581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1770584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1770594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770610 */     // MIs[0] policy
     /* 1770610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770620 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1770623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770644 */     // GIR_Coverage, 11591,
     /* 1770644 */     GIR_EraseRootFromParent_Done,
     /* 1770645 */   // Label 24092: @1770645
     /* 1770645 */   GIM_Try, /*On fail goto*//*Label 24093*/ GIMT_Encode4(1770731), // Rule ID 11594 //
     /* 1770650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1770653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1770658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1770661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1770664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1770667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1770670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770696 */     // MIs[0] policy
     /* 1770696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1770709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770730 */     // GIR_Coverage, 11594,
     /* 1770730 */     GIR_EraseRootFromParent_Done,
     /* 1770731 */   // Label 24093: @1770731
     /* 1770731 */   GIM_Try, /*On fail goto*//*Label 24094*/ GIMT_Encode4(1770817), // Rule ID 11595 //
     /* 1770736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1770739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1770744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1770747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1770750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1770753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1770756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770782 */     // MIs[0] policy
     /* 1770782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770792 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1770795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770816 */     // GIR_Coverage, 11595,
     /* 1770816 */     GIR_EraseRootFromParent_Done,
     /* 1770817 */   // Label 24094: @1770817
     /* 1770817 */   GIM_Try, /*On fail goto*//*Label 24095*/ GIMT_Encode4(1770903), // Rule ID 11598 //
     /* 1770822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1770825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1770830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1770833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1770836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1770839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1770842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1770852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770868 */     // MIs[0] policy
     /* 1770868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770878 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1770881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770902 */     // GIR_Coverage, 11598,
     /* 1770902 */     GIR_EraseRootFromParent_Done,
     /* 1770903 */   // Label 24095: @1770903
     /* 1770903 */   GIM_Try, /*On fail goto*//*Label 24096*/ GIMT_Encode4(1770989), // Rule ID 11599 //
     /* 1770908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1770911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1770916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1770919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1770922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1770925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1770928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1770938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770954 */     // MIs[0] policy
     /* 1770954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770964 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1770967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770988 */     // GIR_Coverage, 11599,
     /* 1770988 */     GIR_EraseRootFromParent_Done,
     /* 1770989 */   // Label 24096: @1770989
     /* 1770989 */   GIM_Try, /*On fail goto*//*Label 24097*/ GIMT_Encode4(1771075), // Rule ID 11602 //
     /* 1770994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1770997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1771002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1771005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1771008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1771011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1771014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1771024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771040 */     // MIs[0] policy
     /* 1771040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771050 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1771053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771074 */     // GIR_Coverage, 11602,
     /* 1771074 */     GIR_EraseRootFromParent_Done,
     /* 1771075 */   // Label 24097: @1771075
     /* 1771075 */   GIM_Try, /*On fail goto*//*Label 24098*/ GIMT_Encode4(1771161), // Rule ID 11603 //
     /* 1771080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1771083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1771088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1771091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1771094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1771097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1771100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1771110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771126 */     // MIs[0] policy
     /* 1771126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771136 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1771139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771160 */     // GIR_Coverage, 11603,
     /* 1771160 */     GIR_EraseRootFromParent_Done,
     /* 1771161 */   // Label 24098: @1771161
     /* 1771161 */   GIM_Try, /*On fail goto*//*Label 24099*/ GIMT_Encode4(1771247), // Rule ID 11606 //
     /* 1771166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1771169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1771174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1771177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1771180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1771183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1771186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1771196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771212 */     // MIs[0] policy
     /* 1771212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771222 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1771225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771246 */     // GIR_Coverage, 11606,
     /* 1771246 */     GIR_EraseRootFromParent_Done,
     /* 1771247 */   // Label 24099: @1771247
     /* 1771247 */   GIM_Try, /*On fail goto*//*Label 24100*/ GIMT_Encode4(1771333), // Rule ID 11607 //
     /* 1771252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1771255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1771260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1771263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1771266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1771269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1771272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1771282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771298 */     // MIs[0] policy
     /* 1771298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771308 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1771311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771332 */     // GIR_Coverage, 11607,
     /* 1771332 */     GIR_EraseRootFromParent_Done,
     /* 1771333 */   // Label 24100: @1771333
     /* 1771333 */   GIM_Try, /*On fail goto*//*Label 24101*/ GIMT_Encode4(1771419), // Rule ID 11610 //
     /* 1771338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1771341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1771346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1771349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1771352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1771355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1771358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771384 */     // MIs[0] policy
     /* 1771384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771394 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1771397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771418 */     // GIR_Coverage, 11610,
     /* 1771418 */     GIR_EraseRootFromParent_Done,
     /* 1771419 */   // Label 24101: @1771419
     /* 1771419 */   GIM_Try, /*On fail goto*//*Label 24102*/ GIMT_Encode4(1771505), // Rule ID 11611 //
     /* 1771424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1771427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1771432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1771435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1771438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1771441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1771444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771470 */     // MIs[0] policy
     /* 1771470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771480 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1771483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771504 */     // GIR_Coverage, 11611,
     /* 1771504 */     GIR_EraseRootFromParent_Done,
     /* 1771505 */   // Label 24102: @1771505
     /* 1771505 */   GIM_Try, /*On fail goto*//*Label 24103*/ GIMT_Encode4(1771591), // Rule ID 11614 //
     /* 1771510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1771513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1771518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1771521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1771524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1771527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1771530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771556 */     // MIs[0] policy
     /* 1771556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1771569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771590 */     // GIR_Coverage, 11614,
     /* 1771590 */     GIR_EraseRootFromParent_Done,
     /* 1771591 */   // Label 24103: @1771591
     /* 1771591 */   GIM_Try, /*On fail goto*//*Label 24104*/ GIMT_Encode4(1771677), // Rule ID 11615 //
     /* 1771596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1771599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1771604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1771607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1771610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1771613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1771616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771642 */     // MIs[0] policy
     /* 1771642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1771655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771676 */     // GIR_Coverage, 11615,
     /* 1771676 */     GIR_EraseRootFromParent_Done,
     /* 1771677 */   // Label 24104: @1771677
     /* 1771677 */   GIM_Try, /*On fail goto*//*Label 24105*/ GIMT_Encode4(1771763), // Rule ID 11618 //
     /* 1771682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1771685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1771690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1771693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1771696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1771699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1771702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1771712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771728 */     // MIs[0] policy
     /* 1771728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771738 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1771741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771762 */     // GIR_Coverage, 11618,
     /* 1771762 */     GIR_EraseRootFromParent_Done,
     /* 1771763 */   // Label 24105: @1771763
     /* 1771763 */   GIM_Try, /*On fail goto*//*Label 24106*/ GIMT_Encode4(1771849), // Rule ID 11619 //
     /* 1771768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1771771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1771776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1771779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1771782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1771785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1771788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1771798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771814 */     // MIs[0] policy
     /* 1771814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771824 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1771827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771848 */     // GIR_Coverage, 11619,
     /* 1771848 */     GIR_EraseRootFromParent_Done,
     /* 1771849 */   // Label 24106: @1771849
     /* 1771849 */   GIM_Try, /*On fail goto*//*Label 24107*/ GIMT_Encode4(1771935), // Rule ID 11622 //
     /* 1771854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1771857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1771862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1771865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1771868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1771871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1771874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1771884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771900 */     // MIs[0] policy
     /* 1771900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771910 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1771913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771934 */     // GIR_Coverage, 11622,
     /* 1771934 */     GIR_EraseRootFromParent_Done,
     /* 1771935 */   // Label 24107: @1771935
     /* 1771935 */   GIM_Try, /*On fail goto*//*Label 24108*/ GIMT_Encode4(1772021), // Rule ID 11623 //
     /* 1771940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1771943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1771948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1771951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1771954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1771957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1771960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1771970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771986 */     // MIs[0] policy
     /* 1771986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771996 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1771999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772020 */     // GIR_Coverage, 11623,
     /* 1772020 */     GIR_EraseRootFromParent_Done,
     /* 1772021 */   // Label 24108: @1772021
     /* 1772021 */   GIM_Try, /*On fail goto*//*Label 24109*/ GIMT_Encode4(1772107), // Rule ID 11626 //
     /* 1772026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1772029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1772034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1772037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1772040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1772043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1772046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1772049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772072 */     // MIs[0] policy
     /* 1772072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1772085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772106 */     // GIR_Coverage, 11626,
     /* 1772106 */     GIR_EraseRootFromParent_Done,
     /* 1772107 */   // Label 24109: @1772107
     /* 1772107 */   GIM_Try, /*On fail goto*//*Label 24110*/ GIMT_Encode4(1772193), // Rule ID 11627 //
     /* 1772112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1772115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1772120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1772123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1772126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1772129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1772132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1772135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772158 */     // MIs[0] policy
     /* 1772158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1772171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772192 */     // GIR_Coverage, 11627,
     /* 1772192 */     GIR_EraseRootFromParent_Done,
     /* 1772193 */   // Label 24110: @1772193
     /* 1772193 */   GIM_Try, /*On fail goto*//*Label 24111*/ GIMT_Encode4(1772279), // Rule ID 11630 //
     /* 1772198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1772201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1772206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1772209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1772212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1772215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1772218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1772221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772244 */     // MIs[0] policy
     /* 1772244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772254 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1772257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772278 */     // GIR_Coverage, 11630,
     /* 1772278 */     GIR_EraseRootFromParent_Done,
     /* 1772279 */   // Label 24111: @1772279
     /* 1772279 */   GIM_Try, /*On fail goto*//*Label 24112*/ GIMT_Encode4(1772365), // Rule ID 11631 //
     /* 1772284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1772287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1772292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1772295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1772298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1772301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1772304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1772307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772330 */     // MIs[0] policy
     /* 1772330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1772343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772364 */     // GIR_Coverage, 11631,
     /* 1772364 */     GIR_EraseRootFromParent_Done,
     /* 1772365 */   // Label 24112: @1772365
     /* 1772365 */   GIM_Try, /*On fail goto*//*Label 24113*/ GIMT_Encode4(1772451), // Rule ID 11634 //
     /* 1772370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1772373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1772378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1772381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1772384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1772387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1772390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772416 */     // MIs[0] policy
     /* 1772416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772426 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1772429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772450 */     // GIR_Coverage, 11634,
     /* 1772450 */     GIR_EraseRootFromParent_Done,
     /* 1772451 */   // Label 24113: @1772451
     /* 1772451 */   GIM_Try, /*On fail goto*//*Label 24114*/ GIMT_Encode4(1772537), // Rule ID 11635 //
     /* 1772456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1772459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1772464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1772467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1772470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1772473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1772476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772502 */     // MIs[0] policy
     /* 1772502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772512 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1772515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772536 */     // GIR_Coverage, 11635,
     /* 1772536 */     GIR_EraseRootFromParent_Done,
     /* 1772537 */   // Label 24114: @1772537
     /* 1772537 */   GIM_Try, /*On fail goto*//*Label 24115*/ GIMT_Encode4(1772623), // Rule ID 11638 //
     /* 1772542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1772545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1772550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1772553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1772556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1772559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1772562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772588 */     // MIs[0] policy
     /* 1772588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772598 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1772601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772622 */     // GIR_Coverage, 11638,
     /* 1772622 */     GIR_EraseRootFromParent_Done,
     /* 1772623 */   // Label 24115: @1772623
     /* 1772623 */   GIM_Try, /*On fail goto*//*Label 24116*/ GIMT_Encode4(1772709), // Rule ID 11639 //
     /* 1772628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1772631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1772636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1772639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1772642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1772645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1772648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772674 */     // MIs[0] policy
     /* 1772674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772684 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1772687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772708 */     // GIR_Coverage, 11639,
     /* 1772708 */     GIR_EraseRootFromParent_Done,
     /* 1772709 */   // Label 24116: @1772709
     /* 1772709 */   GIM_Try, /*On fail goto*//*Label 24117*/ GIMT_Encode4(1772795), // Rule ID 11642 //
     /* 1772714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1772717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1772722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1772725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1772728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1772731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1772734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1772737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772760 */     // MIs[0] policy
     /* 1772760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772770 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1772773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772794 */     // GIR_Coverage, 11642,
     /* 1772794 */     GIR_EraseRootFromParent_Done,
     /* 1772795 */   // Label 24117: @1772795
     /* 1772795 */   GIM_Try, /*On fail goto*//*Label 24118*/ GIMT_Encode4(1772881), // Rule ID 11643 //
     /* 1772800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1772803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1772808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1772811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1772814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1772817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1772820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1772823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772846 */     // MIs[0] policy
     /* 1772846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772856 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1772859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772880 */     // GIR_Coverage, 11643,
     /* 1772880 */     GIR_EraseRootFromParent_Done,
     /* 1772881 */   // Label 24118: @1772881
     /* 1772881 */   GIM_Try, /*On fail goto*//*Label 24119*/ GIMT_Encode4(1772967), // Rule ID 11646 //
     /* 1772886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1772889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1772894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1772897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1772900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1772903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1772906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1772909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772932 */     // MIs[0] policy
     /* 1772932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1772945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772966 */     // GIR_Coverage, 11646,
     /* 1772966 */     GIR_EraseRootFromParent_Done,
     /* 1772967 */   // Label 24119: @1772967
     /* 1772967 */   GIM_Try, /*On fail goto*//*Label 24120*/ GIMT_Encode4(1773053), // Rule ID 11647 //
     /* 1772972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1772975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1772980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1772983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1772986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1772989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1772992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1772995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773018 */     // MIs[0] policy
     /* 1773018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773028 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1773031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773052 */     // GIR_Coverage, 11647,
     /* 1773052 */     GIR_EraseRootFromParent_Done,
     /* 1773053 */   // Label 24120: @1773053
     /* 1773053 */   GIM_Try, /*On fail goto*//*Label 24121*/ GIMT_Encode4(1773139), // Rule ID 11650 //
     /* 1773058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1773061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1773066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1773069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1773072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1773075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773104 */     // MIs[0] policy
     /* 1773104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773114 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1773117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773138 */     // GIR_Coverage, 11650,
     /* 1773138 */     GIR_EraseRootFromParent_Done,
     /* 1773139 */   // Label 24121: @1773139
     /* 1773139 */   GIM_Try, /*On fail goto*//*Label 24122*/ GIMT_Encode4(1773225), // Rule ID 11651 //
     /* 1773144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1773147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1773152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1773155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1773158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1773161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773190 */     // MIs[0] policy
     /* 1773190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773200 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1773203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773224 */     // GIR_Coverage, 11651,
     /* 1773224 */     GIR_EraseRootFromParent_Done,
     /* 1773225 */   // Label 24122: @1773225
     /* 1773225 */   GIM_Try, /*On fail goto*//*Label 24123*/ GIMT_Encode4(1773311), // Rule ID 11654 //
     /* 1773230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1773233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1773238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1773241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1773244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1773247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773276 */     // MIs[0] policy
     /* 1773276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773286 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1773289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773310 */     // GIR_Coverage, 11654,
     /* 1773310 */     GIR_EraseRootFromParent_Done,
     /* 1773311 */   // Label 24123: @1773311
     /* 1773311 */   GIM_Try, /*On fail goto*//*Label 24124*/ GIMT_Encode4(1773397), // Rule ID 11655 //
     /* 1773316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1773319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1773324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1773327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1773330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1773333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773362 */     // MIs[0] policy
     /* 1773362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773372 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1773375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773396 */     // GIR_Coverage, 11655,
     /* 1773396 */     GIR_EraseRootFromParent_Done,
     /* 1773397 */   // Label 24124: @1773397
     /* 1773397 */   GIM_Try, /*On fail goto*//*Label 24125*/ GIMT_Encode4(1773483), // Rule ID 11658 //
     /* 1773402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1773413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1773416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1773419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1773422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773448 */     // MIs[0] policy
     /* 1773448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773458 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1773461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773482 */     // GIR_Coverage, 11658,
     /* 1773482 */     GIR_EraseRootFromParent_Done,
     /* 1773483 */   // Label 24125: @1773483
     /* 1773483 */   GIM_Try, /*On fail goto*//*Label 24126*/ GIMT_Encode4(1773569), // Rule ID 11659 //
     /* 1773488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1773499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1773502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1773505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1773508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773534 */     // MIs[0] policy
     /* 1773534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1773547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773568 */     // GIR_Coverage, 11659,
     /* 1773568 */     GIR_EraseRootFromParent_Done,
     /* 1773569 */   // Label 24126: @1773569
     /* 1773569 */   GIM_Try, /*On fail goto*//*Label 24127*/ GIMT_Encode4(1773655), // Rule ID 11662 //
     /* 1773574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1773585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1773588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1773591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1773594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1773597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773620 */     // MIs[0] policy
     /* 1773620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773630 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1773633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773654 */     // GIR_Coverage, 11662,
     /* 1773654 */     GIR_EraseRootFromParent_Done,
     /* 1773655 */   // Label 24127: @1773655
     /* 1773655 */   GIM_Try, /*On fail goto*//*Label 24128*/ GIMT_Encode4(1773741), // Rule ID 11663 //
     /* 1773660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1773671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1773674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1773677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1773680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1773683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773706 */     // MIs[0] policy
     /* 1773706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773716 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1773719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773740 */     // GIR_Coverage, 11663,
     /* 1773740 */     GIR_EraseRootFromParent_Done,
     /* 1773741 */   // Label 24128: @1773741
     /* 1773741 */   GIM_Try, /*On fail goto*//*Label 24129*/ GIMT_Encode4(1773827), // Rule ID 11666 //
     /* 1773746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1773757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1773760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1773763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1773766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773792 */     // MIs[0] policy
     /* 1773792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773802 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1773805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773826 */     // GIR_Coverage, 11666,
     /* 1773826 */     GIR_EraseRootFromParent_Done,
     /* 1773827 */   // Label 24129: @1773827
     /* 1773827 */   GIM_Try, /*On fail goto*//*Label 24130*/ GIMT_Encode4(1773913), // Rule ID 11667 //
     /* 1773832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1773843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1773846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1773849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1773852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773878 */     // MIs[0] policy
     /* 1773878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773888 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1773891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773912 */     // GIR_Coverage, 11667,
     /* 1773912 */     GIR_EraseRootFromParent_Done,
     /* 1773913 */   // Label 24130: @1773913
     /* 1773913 */   GIM_Try, /*On fail goto*//*Label 24131*/ GIMT_Encode4(1773999), // Rule ID 11670 //
     /* 1773918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1773929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1773932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1773935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1773938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773964 */     // MIs[0] policy
     /* 1773964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773974 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1773977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773998 */     // GIR_Coverage, 11670,
     /* 1773998 */     GIR_EraseRootFromParent_Done,
     /* 1773999 */   // Label 24131: @1773999
     /* 1773999 */   GIM_Try, /*On fail goto*//*Label 24132*/ GIMT_Encode4(1774085), // Rule ID 11671 //
     /* 1774004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1774015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1774018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1774021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1774024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774050 */     // MIs[0] policy
     /* 1774050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774060 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1774063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774084 */     // GIR_Coverage, 11671,
     /* 1774084 */     GIR_EraseRootFromParent_Done,
     /* 1774085 */   // Label 24132: @1774085
     /* 1774085 */   GIM_Try, /*On fail goto*//*Label 24133*/ GIMT_Encode4(1774171), // Rule ID 11674 //
     /* 1774090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1774101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1774104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1774107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1774110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774136 */     // MIs[0] policy
     /* 1774136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774146 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1774149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774170 */     // GIR_Coverage, 11674,
     /* 1774170 */     GIR_EraseRootFromParent_Done,
     /* 1774171 */   // Label 24133: @1774171
     /* 1774171 */   GIM_Try, /*On fail goto*//*Label 24134*/ GIMT_Encode4(1774257), // Rule ID 11675 //
     /* 1774176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1774187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1774190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1774193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1774196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774222 */     // MIs[0] policy
     /* 1774222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774232 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1774235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774256 */     // GIR_Coverage, 11675,
     /* 1774256 */     GIR_EraseRootFromParent_Done,
     /* 1774257 */   // Label 24134: @1774257
     /* 1774257 */   GIM_Try, /*On fail goto*//*Label 24135*/ GIMT_Encode4(1774343), // Rule ID 11678 //
     /* 1774262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1774273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1774276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1774279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1774282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774308 */     // MIs[0] policy
     /* 1774308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774318 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1774321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774342 */     // GIR_Coverage, 11678,
     /* 1774342 */     GIR_EraseRootFromParent_Done,
     /* 1774343 */   // Label 24135: @1774343
     /* 1774343 */   GIM_Try, /*On fail goto*//*Label 24136*/ GIMT_Encode4(1774429), // Rule ID 11679 //
     /* 1774348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1774359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1774362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1774365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1774368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774394 */     // MIs[0] policy
     /* 1774394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1774407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774428 */     // GIR_Coverage, 11679,
     /* 1774428 */     GIR_EraseRootFromParent_Done,
     /* 1774429 */   // Label 24136: @1774429
     /* 1774429 */   GIM_Try, /*On fail goto*//*Label 24137*/ GIMT_Encode4(1774515), // Rule ID 11682 //
     /* 1774434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1774445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1774448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1774451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1774454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774480 */     // MIs[0] policy
     /* 1774480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774490 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1774493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774514 */     // GIR_Coverage, 11682,
     /* 1774514 */     GIR_EraseRootFromParent_Done,
     /* 1774515 */   // Label 24137: @1774515
     /* 1774515 */   GIM_Try, /*On fail goto*//*Label 24138*/ GIMT_Encode4(1774601), // Rule ID 11683 //
     /* 1774520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1774531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1774534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1774537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1774540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774566 */     // MIs[0] policy
     /* 1774566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774576 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1774579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774600 */     // GIR_Coverage, 11683,
     /* 1774600 */     GIR_EraseRootFromParent_Done,
     /* 1774601 */   // Label 24138: @1774601
     /* 1774601 */   GIM_Try, /*On fail goto*//*Label 24139*/ GIMT_Encode4(1774687), // Rule ID 11686 //
     /* 1774606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1774617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1774620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1774623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1774626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774652 */     // MIs[0] policy
     /* 1774652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774662 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1774665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774686 */     // GIR_Coverage, 11686,
     /* 1774686 */     GIR_EraseRootFromParent_Done,
     /* 1774687 */   // Label 24139: @1774687
     /* 1774687 */   GIM_Try, /*On fail goto*//*Label 24140*/ GIMT_Encode4(1774773), // Rule ID 11687 //
     /* 1774692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1774703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1774706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1774709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1774712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774738 */     // MIs[0] policy
     /* 1774738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774748 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1774751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774772 */     // GIR_Coverage, 11687,
     /* 1774772 */     GIR_EraseRootFromParent_Done,
     /* 1774773 */   // Label 24140: @1774773
     /* 1774773 */   GIM_Try, /*On fail goto*//*Label 24141*/ GIMT_Encode4(1774859), // Rule ID 11690 //
     /* 1774778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1774789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1774792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1774795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1774798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774824 */     // MIs[0] policy
     /* 1774824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1774837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774858 */     // GIR_Coverage, 11690,
     /* 1774858 */     GIR_EraseRootFromParent_Done,
     /* 1774859 */   // Label 24141: @1774859
     /* 1774859 */   GIM_Try, /*On fail goto*//*Label 24142*/ GIMT_Encode4(1774945), // Rule ID 11691 //
     /* 1774864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1774875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1774878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1774881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1774884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774910 */     // MIs[0] policy
     /* 1774910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774920 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1774923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774944 */     // GIR_Coverage, 11691,
     /* 1774944 */     GIR_EraseRootFromParent_Done,
     /* 1774945 */   // Label 24142: @1774945
     /* 1774945 */   GIM_Try, /*On fail goto*//*Label 24143*/ GIMT_Encode4(1775031), // Rule ID 11694 //
     /* 1774950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1774953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1774961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1774964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1774967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1774970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774996 */     // MIs[0] policy
     /* 1774996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775006 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1775009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1775027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775030 */     // GIR_Coverage, 11694,
     /* 1775030 */     GIR_EraseRootFromParent_Done,
     /* 1775031 */   // Label 24143: @1775031
     /* 1775031 */   GIM_Try, /*On fail goto*//*Label 24144*/ GIMT_Encode4(1775117), // Rule ID 11695 //
     /* 1775036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1775039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1775047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1775050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1775053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1775056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775082 */     // MIs[0] policy
     /* 1775082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775092 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1775095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1775113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775116 */     // GIR_Coverage, 11695,
     /* 1775116 */     GIR_EraseRootFromParent_Done,
     /* 1775117 */   // Label 24144: @1775117
     /* 1775117 */   GIM_Try, /*On fail goto*//*Label 24145*/ GIMT_Encode4(1775203), // Rule ID 11698 //
     /* 1775122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1775133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1775136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1775139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1775142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775168 */     // MIs[0] policy
     /* 1775168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775178 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1775181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775202 */     // GIR_Coverage, 11698,
     /* 1775202 */     GIR_EraseRootFromParent_Done,
     /* 1775203 */   // Label 24145: @1775203
     /* 1775203 */   GIM_Try, /*On fail goto*//*Label 24146*/ GIMT_Encode4(1775289), // Rule ID 11699 //
     /* 1775208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1775219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1775222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1775225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1775228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775254 */     // MIs[0] policy
     /* 1775254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775264 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1775267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775288 */     // GIR_Coverage, 11699,
     /* 1775288 */     GIR_EraseRootFromParent_Done,
     /* 1775289 */   // Label 24146: @1775289
     /* 1775289 */   GIM_Try, /*On fail goto*//*Label 24147*/ GIMT_Encode4(1775375), // Rule ID 11702 //
     /* 1775294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1775305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1775308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1775311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1775314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1775317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775340 */     // MIs[0] policy
     /* 1775340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775350 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1775353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775374 */     // GIR_Coverage, 11702,
     /* 1775374 */     GIR_EraseRootFromParent_Done,
     /* 1775375 */   // Label 24147: @1775375
     /* 1775375 */   GIM_Try, /*On fail goto*//*Label 24148*/ GIMT_Encode4(1775461), // Rule ID 11703 //
     /* 1775380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1775391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1775394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1775397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1775400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1775403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775426 */     // MIs[0] policy
     /* 1775426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775436 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1775439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775460 */     // GIR_Coverage, 11703,
     /* 1775460 */     GIR_EraseRootFromParent_Done,
     /* 1775461 */   // Label 24148: @1775461
     /* 1775461 */   GIM_Try, /*On fail goto*//*Label 24149*/ GIMT_Encode4(1775547), // Rule ID 11706 //
     /* 1775466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1775477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1775480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1775483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1775486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1775489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1775496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775512 */     // MIs[0] policy
     /* 1775512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775522 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1775525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775546 */     // GIR_Coverage, 11706,
     /* 1775546 */     GIR_EraseRootFromParent_Done,
     /* 1775547 */   // Label 24149: @1775547
     /* 1775547 */   GIM_Try, /*On fail goto*//*Label 24150*/ GIMT_Encode4(1775633), // Rule ID 11707 //
     /* 1775552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1775563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1775566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1775569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1775572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1775575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1775582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775598 */     // MIs[0] policy
     /* 1775598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775608 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1775611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775632 */     // GIR_Coverage, 11707,
     /* 1775632 */     GIR_EraseRootFromParent_Done,
     /* 1775633 */   // Label 24150: @1775633
     /* 1775633 */   GIM_Try, /*On fail goto*//*Label 24151*/ GIMT_Encode4(1775719), // Rule ID 11710 //
     /* 1775638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1775649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1775652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1775655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1775658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1775661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775684 */     // MIs[0] policy
     /* 1775684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1775697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775718 */     // GIR_Coverage, 11710,
     /* 1775718 */     GIR_EraseRootFromParent_Done,
     /* 1775719 */   // Label 24151: @1775719
     /* 1775719 */   GIM_Try, /*On fail goto*//*Label 24152*/ GIMT_Encode4(1775805), // Rule ID 11711 //
     /* 1775724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1775735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1775738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1775741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1775744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1775747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775770 */     // MIs[0] policy
     /* 1775770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775780 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1775783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775804 */     // GIR_Coverage, 11711,
     /* 1775804 */     GIR_EraseRootFromParent_Done,
     /* 1775805 */   // Label 24152: @1775805
     /* 1775805 */   GIM_Try, /*On fail goto*//*Label 24153*/ GIMT_Encode4(1775891), // Rule ID 11714 //
     /* 1775810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1775821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1775824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1775827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1775830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775856 */     // MIs[0] policy
     /* 1775856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775866 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1775869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775890 */     // GIR_Coverage, 11714,
     /* 1775890 */     GIR_EraseRootFromParent_Done,
     /* 1775891 */   // Label 24153: @1775891
     /* 1775891 */   GIM_Try, /*On fail goto*//*Label 24154*/ GIMT_Encode4(1775977), // Rule ID 11715 //
     /* 1775896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1775907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1775910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1775913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1775916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775942 */     // MIs[0] policy
     /* 1775942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775952 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1775955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775976 */     // GIR_Coverage, 11715,
     /* 1775976 */     GIR_EraseRootFromParent_Done,
     /* 1775977 */   // Label 24154: @1775977
     /* 1775977 */   GIM_Try, /*On fail goto*//*Label 24155*/ GIMT_Encode4(1776063), // Rule ID 11718 //
     /* 1775982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1775993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1775996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1775999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1776002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776028 */     // MIs[0] policy
     /* 1776028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776038 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1776041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776062 */     // GIR_Coverage, 11718,
     /* 1776062 */     GIR_EraseRootFromParent_Done,
     /* 1776063 */   // Label 24155: @1776063
     /* 1776063 */   GIM_Try, /*On fail goto*//*Label 24156*/ GIMT_Encode4(1776149), // Rule ID 11719 //
     /* 1776068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1776079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1776082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1776085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1776088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776114 */     // MIs[0] policy
     /* 1776114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776124 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1776127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776148 */     // GIR_Coverage, 11719,
     /* 1776148 */     GIR_EraseRootFromParent_Done,
     /* 1776149 */   // Label 24156: @1776149
     /* 1776149 */   GIM_Try, /*On fail goto*//*Label 24157*/ GIMT_Encode4(1776235), // Rule ID 11722 //
     /* 1776154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1776165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1776168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1776171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1776174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776200 */     // MIs[0] policy
     /* 1776200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1776213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776234 */     // GIR_Coverage, 11722,
     /* 1776234 */     GIR_EraseRootFromParent_Done,
     /* 1776235 */   // Label 24157: @1776235
     /* 1776235 */   GIM_Try, /*On fail goto*//*Label 24158*/ GIMT_Encode4(1776321), // Rule ID 11723 //
     /* 1776240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1776251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1776254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1776257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1776260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776286 */     // MIs[0] policy
     /* 1776286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1776299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776320 */     // GIR_Coverage, 11723,
     /* 1776320 */     GIR_EraseRootFromParent_Done,
     /* 1776321 */   // Label 24158: @1776321
     /* 1776321 */   GIM_Try, /*On fail goto*//*Label 24159*/ GIMT_Encode4(1776407), // Rule ID 11726 //
     /* 1776326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1776337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1776340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1776343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1776346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776372 */     // MIs[0] policy
     /* 1776372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776382 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1776385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776406 */     // GIR_Coverage, 11726,
     /* 1776406 */     GIR_EraseRootFromParent_Done,
     /* 1776407 */   // Label 24159: @1776407
     /* 1776407 */   GIM_Try, /*On fail goto*//*Label 24160*/ GIMT_Encode4(1776493), // Rule ID 11727 //
     /* 1776412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1776423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1776426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1776429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1776432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776458 */     // MIs[0] policy
     /* 1776458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1776471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776492 */     // GIR_Coverage, 11727,
     /* 1776492 */     GIR_EraseRootFromParent_Done,
     /* 1776493 */   // Label 24160: @1776493
     /* 1776493 */   GIM_Try, /*On fail goto*//*Label 24161*/ GIMT_Encode4(1776579), // Rule ID 11730 //
     /* 1776498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1776509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1776512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1776515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1776518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776544 */     // MIs[0] policy
     /* 1776544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776554 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1776557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776578 */     // GIR_Coverage, 11730,
     /* 1776578 */     GIR_EraseRootFromParent_Done,
     /* 1776579 */   // Label 24161: @1776579
     /* 1776579 */   GIM_Try, /*On fail goto*//*Label 24162*/ GIMT_Encode4(1776665), // Rule ID 11731 //
     /* 1776584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1776595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1776598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1776601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1776604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776630 */     // MIs[0] policy
     /* 1776630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1776643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776664 */     // GIR_Coverage, 11731,
     /* 1776664 */     GIR_EraseRootFromParent_Done,
     /* 1776665 */   // Label 24162: @1776665
     /* 1776665 */   GIM_Try, /*On fail goto*//*Label 24163*/ GIMT_Encode4(1776751), // Rule ID 11734 //
     /* 1776670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1776673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1776681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1776684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1776687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1776690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1776693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776716 */     // MIs[0] policy
     /* 1776716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776726 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1776729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776750 */     // GIR_Coverage, 11734,
     /* 1776750 */     GIR_EraseRootFromParent_Done,
     /* 1776751 */   // Label 24163: @1776751
     /* 1776751 */   GIM_Try, /*On fail goto*//*Label 24164*/ GIMT_Encode4(1776837), // Rule ID 11735 //
     /* 1776756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1776759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1776767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1776770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1776773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1776776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1776779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776802 */     // MIs[0] policy
     /* 1776802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1776815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776836 */     // GIR_Coverage, 11735,
     /* 1776836 */     GIR_EraseRootFromParent_Done,
     /* 1776837 */   // Label 24164: @1776837
     /* 1776837 */   GIM_Try, /*On fail goto*//*Label 24165*/ GIMT_Encode4(1776923), // Rule ID 11738 //
     /* 1776842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1776845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1776853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1776856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1776859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1776862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776888 */     // MIs[0] policy
     /* 1776888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776898 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1776901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776922 */     // GIR_Coverage, 11738,
     /* 1776922 */     GIR_EraseRootFromParent_Done,
     /* 1776923 */   // Label 24165: @1776923
     /* 1776923 */   GIM_Try, /*On fail goto*//*Label 24166*/ GIMT_Encode4(1777009), // Rule ID 11739 //
     /* 1776928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1776931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1776939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1776942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1776945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1776948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776974 */     // MIs[0] policy
     /* 1776974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776984 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1776987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777008 */     // GIR_Coverage, 11739,
     /* 1777008 */     GIR_EraseRootFromParent_Done,
     /* 1777009 */   // Label 24166: @1777009
     /* 1777009 */   GIM_Try, /*On fail goto*//*Label 24167*/ GIMT_Encode4(1777095), // Rule ID 11742 //
     /* 1777014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1777017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1777025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1777028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1777031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1777034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777060 */     // MIs[0] policy
     /* 1777060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777070 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1777073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777094 */     // GIR_Coverage, 11742,
     /* 1777094 */     GIR_EraseRootFromParent_Done,
     /* 1777095 */   // Label 24167: @1777095
     /* 1777095 */   GIM_Try, /*On fail goto*//*Label 24168*/ GIMT_Encode4(1777181), // Rule ID 11743 //
     /* 1777100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1777103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1777111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1777114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1777117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1777120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777146 */     // MIs[0] policy
     /* 1777146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777156 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1777159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777180 */     // GIR_Coverage, 11743,
     /* 1777180 */     GIR_EraseRootFromParent_Done,
     /* 1777181 */   // Label 24168: @1777181
     /* 1777181 */   GIM_Try, /*On fail goto*//*Label 24169*/ GIMT_Encode4(1777267), // Rule ID 11746 //
     /* 1777186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1777197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1777200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1777203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777232 */     // MIs[0] policy
     /* 1777232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777242 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1777245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777266 */     // GIR_Coverage, 11746,
     /* 1777266 */     GIR_EraseRootFromParent_Done,
     /* 1777267 */   // Label 24169: @1777267
     /* 1777267 */   GIM_Try, /*On fail goto*//*Label 24170*/ GIMT_Encode4(1777353), // Rule ID 11747 //
     /* 1777272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1777283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1777286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1777289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777318 */     // MIs[0] policy
     /* 1777318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777328 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1777331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777352 */     // GIR_Coverage, 11747,
     /* 1777352 */     GIR_EraseRootFromParent_Done,
     /* 1777353 */   // Label 24170: @1777353
     /* 1777353 */   GIM_Try, /*On fail goto*//*Label 24171*/ GIMT_Encode4(1777439), // Rule ID 11750 //
     /* 1777358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1777369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1777372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1777375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777404 */     // MIs[0] policy
     /* 1777404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777414 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1777417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777438 */     // GIR_Coverage, 11750,
     /* 1777438 */     GIR_EraseRootFromParent_Done,
     /* 1777439 */   // Label 24171: @1777439
     /* 1777439 */   GIM_Try, /*On fail goto*//*Label 24172*/ GIMT_Encode4(1777525), // Rule ID 11751 //
     /* 1777444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1777455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1777458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1777461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777490 */     // MIs[0] policy
     /* 1777490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777500 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1777503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777524 */     // GIR_Coverage, 11751,
     /* 1777524 */     GIR_EraseRootFromParent_Done,
     /* 1777525 */   // Label 24172: @1777525
     /* 1777525 */   GIM_Try, /*On fail goto*//*Label 24173*/ GIMT_Encode4(1777611), // Rule ID 11754 //
     /* 1777530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1777541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1777544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1777547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777576 */     // MIs[0] policy
     /* 1777576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777586 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1777589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777610 */     // GIR_Coverage, 11754,
     /* 1777610 */     GIR_EraseRootFromParent_Done,
     /* 1777611 */   // Label 24173: @1777611
     /* 1777611 */   GIM_Try, /*On fail goto*//*Label 24174*/ GIMT_Encode4(1777697), // Rule ID 11755 //
     /* 1777616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1777627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1777630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1777633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777662 */     // MIs[0] policy
     /* 1777662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777672 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1777675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777696 */     // GIR_Coverage, 11755,
     /* 1777696 */     GIR_EraseRootFromParent_Done,
     /* 1777697 */   // Label 24174: @1777697
     /* 1777697 */   GIM_Try, /*On fail goto*//*Label 24175*/ GIMT_Encode4(1777783), // Rule ID 11758 //
     /* 1777702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1777713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1777716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1777719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777748 */     // MIs[0] policy
     /* 1777748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777758 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1777761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777782 */     // GIR_Coverage, 11758,
     /* 1777782 */     GIR_EraseRootFromParent_Done,
     /* 1777783 */   // Label 24175: @1777783
     /* 1777783 */   GIM_Try, /*On fail goto*//*Label 24176*/ GIMT_Encode4(1777869), // Rule ID 11759 //
     /* 1777788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1777799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1777802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1777805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777834 */     // MIs[0] policy
     /* 1777834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777844 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1777847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777868 */     // GIR_Coverage, 11759,
     /* 1777868 */     GIR_EraseRootFromParent_Done,
     /* 1777869 */   // Label 24176: @1777869
     /* 1777869 */   GIM_Try, /*On fail goto*//*Label 24177*/ GIMT_Encode4(1777955), // Rule ID 11762 //
     /* 1777874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1777885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1777888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1777891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777920 */     // MIs[0] policy
     /* 1777920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777930 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1777933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777954 */     // GIR_Coverage, 11762,
     /* 1777954 */     GIR_EraseRootFromParent_Done,
     /* 1777955 */   // Label 24177: @1777955
     /* 1777955 */   GIM_Try, /*On fail goto*//*Label 24178*/ GIMT_Encode4(1778041), // Rule ID 11763 //
     /* 1777960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1777971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1777974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1777977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778006 */     // MIs[0] policy
     /* 1778006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778016 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1778019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778040 */     // GIR_Coverage, 11763,
     /* 1778040 */     GIR_EraseRootFromParent_Done,
     /* 1778041 */   // Label 24178: @1778041
     /* 1778041 */   GIM_Try, /*On fail goto*//*Label 24179*/ GIMT_Encode4(1778127), // Rule ID 11766 //
     /* 1778046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1778054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1778057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1778060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1778063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1778066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778092 */     // MIs[0] policy
     /* 1778092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778102 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1778105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778126 */     // GIR_Coverage, 11766,
     /* 1778126 */     GIR_EraseRootFromParent_Done,
     /* 1778127 */   // Label 24179: @1778127
     /* 1778127 */   GIM_Try, /*On fail goto*//*Label 24180*/ GIMT_Encode4(1778213), // Rule ID 11767 //
     /* 1778132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1778140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1778143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1778146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1778149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1778152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778178 */     // MIs[0] policy
     /* 1778178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778188 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1778191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778212 */     // GIR_Coverage, 11767,
     /* 1778212 */     GIR_EraseRootFromParent_Done,
     /* 1778213 */   // Label 24180: @1778213
     /* 1778213 */   GIM_Try, /*On fail goto*//*Label 24181*/ GIMT_Encode4(1778299), // Rule ID 11770 //
     /* 1778218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1778226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1778229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1778232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1778235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1778238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778264 */     // MIs[0] policy
     /* 1778264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778274 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1778277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778298 */     // GIR_Coverage, 11770,
     /* 1778298 */     GIR_EraseRootFromParent_Done,
     /* 1778299 */   // Label 24181: @1778299
     /* 1778299 */   GIM_Try, /*On fail goto*//*Label 24182*/ GIMT_Encode4(1778385), // Rule ID 11771 //
     /* 1778304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1778312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1778315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1778318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1778321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1778324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778350 */     // MIs[0] policy
     /* 1778350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1778363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778384 */     // GIR_Coverage, 11771,
     /* 1778384 */     GIR_EraseRootFromParent_Done,
     /* 1778385 */   // Label 24182: @1778385
     /* 1778385 */   GIM_Try, /*On fail goto*//*Label 24183*/ GIMT_Encode4(1778471), // Rule ID 11774 //
     /* 1778390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1778398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1778401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1778404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1778407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1778410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778436 */     // MIs[0] policy
     /* 1778436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1778449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778470 */     // GIR_Coverage, 11774,
     /* 1778470 */     GIR_EraseRootFromParent_Done,
     /* 1778471 */   // Label 24183: @1778471
     /* 1778471 */   GIM_Try, /*On fail goto*//*Label 24184*/ GIMT_Encode4(1778557), // Rule ID 11775 //
     /* 1778476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1778484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1778487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1778490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1778493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1778496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778522 */     // MIs[0] policy
     /* 1778522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1778535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778556 */     // GIR_Coverage, 11775,
     /* 1778556 */     GIR_EraseRootFromParent_Done,
     /* 1778557 */   // Label 24184: @1778557
     /* 1778557 */   GIM_Try, /*On fail goto*//*Label 24185*/ GIMT_Encode4(1778643), // Rule ID 11778 //
     /* 1778562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1778570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1778573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1778576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1778579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1778582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778608 */     // MIs[0] policy
     /* 1778608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1778621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778642 */     // GIR_Coverage, 11778,
     /* 1778642 */     GIR_EraseRootFromParent_Done,
     /* 1778643 */   // Label 24185: @1778643
     /* 1778643 */   GIM_Try, /*On fail goto*//*Label 24186*/ GIMT_Encode4(1778729), // Rule ID 11779 //
     /* 1778648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1778656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1778659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1778662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1778665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1778668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778694 */     // MIs[0] policy
     /* 1778694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778704 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1778707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778728 */     // GIR_Coverage, 11779,
     /* 1778728 */     GIR_EraseRootFromParent_Done,
     /* 1778729 */   // Label 24186: @1778729
     /* 1778729 */   GIM_Try, /*On fail goto*//*Label 24187*/ GIMT_Encode4(1778815), // Rule ID 11782 //
     /* 1778734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1778737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1778742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1778745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1778748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1778751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1778754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778780 */     // MIs[0] policy
     /* 1778780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1778793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778814 */     // GIR_Coverage, 11782,
     /* 1778814 */     GIR_EraseRootFromParent_Done,
     /* 1778815 */   // Label 24187: @1778815
     /* 1778815 */   GIM_Try, /*On fail goto*//*Label 24188*/ GIMT_Encode4(1778901), // Rule ID 11783 //
     /* 1778820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1778823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1778828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1778831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1778834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1778837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1778840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778866 */     // MIs[0] policy
     /* 1778866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1778879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778900 */     // GIR_Coverage, 11783,
     /* 1778900 */     GIR_EraseRootFromParent_Done,
     /* 1778901 */   // Label 24188: @1778901
     /* 1778901 */   GIM_Try, /*On fail goto*//*Label 24189*/ GIMT_Encode4(1778987), // Rule ID 11786 //
     /* 1778906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1778914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1778917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1778920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1778923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1778926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1778929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1778936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778952 */     // MIs[0] policy
     /* 1778952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778962 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1778965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778986 */     // GIR_Coverage, 11786,
     /* 1778986 */     GIR_EraseRootFromParent_Done,
     /* 1778987 */   // Label 24189: @1778987
     /* 1778987 */   GIM_Try, /*On fail goto*//*Label 24190*/ GIMT_Encode4(1779073), // Rule ID 11787 //
     /* 1778992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1779000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1779003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1779006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1779009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1779012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1779015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779038 */     // MIs[0] policy
     /* 1779038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779048 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1779051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779072 */     // GIR_Coverage, 11787,
     /* 1779072 */     GIR_EraseRootFromParent_Done,
     /* 1779073 */   // Label 24190: @1779073
     /* 1779073 */   GIM_Try, /*On fail goto*//*Label 24191*/ GIMT_Encode4(1779159), // Rule ID 11790 //
     /* 1779078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1779086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1779089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1779092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1779095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1779098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779124 */     // MIs[0] policy
     /* 1779124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779134 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1779137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779158 */     // GIR_Coverage, 11790,
     /* 1779158 */     GIR_EraseRootFromParent_Done,
     /* 1779159 */   // Label 24191: @1779159
     /* 1779159 */   GIM_Try, /*On fail goto*//*Label 24192*/ GIMT_Encode4(1779245), // Rule ID 11791 //
     /* 1779164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1779172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1779175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1779178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1779181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1779184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779210 */     // MIs[0] policy
     /* 1779210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779220 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1779223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779244 */     // GIR_Coverage, 11791,
     /* 1779244 */     GIR_EraseRootFromParent_Done,
     /* 1779245 */   // Label 24192: @1779245
     /* 1779245 */   GIM_Try, /*On fail goto*//*Label 24193*/ GIMT_Encode4(1779331), // Rule ID 11794 //
     /* 1779250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1779258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1779261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1779264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1779267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1779270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1779273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779296 */     // MIs[0] policy
     /* 1779296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779306 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1779309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779330 */     // GIR_Coverage, 11794,
     /* 1779330 */     GIR_EraseRootFromParent_Done,
     /* 1779331 */   // Label 24193: @1779331
     /* 1779331 */   GIM_Try, /*On fail goto*//*Label 24194*/ GIMT_Encode4(1779417), // Rule ID 11795 //
     /* 1779336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1779344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1779347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1779350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1779353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1779356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1779359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779382 */     // MIs[0] policy
     /* 1779382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779392 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1779395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779416 */     // GIR_Coverage, 11795,
     /* 1779416 */     GIR_EraseRootFromParent_Done,
     /* 1779417 */   // Label 24194: @1779417
     /* 1779417 */   GIM_Try, /*On fail goto*//*Label 24195*/ GIMT_Encode4(1779503), // Rule ID 11798 //
     /* 1779422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1779430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1779433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1779436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1779439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1779442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779468 */     // MIs[0] policy
     /* 1779468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779478 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1779481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779502 */     // GIR_Coverage, 11798,
     /* 1779502 */     GIR_EraseRootFromParent_Done,
     /* 1779503 */   // Label 24195: @1779503
     /* 1779503 */   GIM_Try, /*On fail goto*//*Label 24196*/ GIMT_Encode4(1779589), // Rule ID 11799 //
     /* 1779508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1779516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1779519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1779522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1779525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1779528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779554 */     // MIs[0] policy
     /* 1779554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779564 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1779567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779588 */     // GIR_Coverage, 11799,
     /* 1779588 */     GIR_EraseRootFromParent_Done,
     /* 1779589 */   // Label 24196: @1779589
     /* 1779589 */   GIM_Try, /*On fail goto*//*Label 24197*/ GIMT_Encode4(1779675), // Rule ID 11802 //
     /* 1779594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1779602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1779605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1779608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1779611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1779614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1779617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779640 */     // MIs[0] policy
     /* 1779640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779650 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1779653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779674 */     // GIR_Coverage, 11802,
     /* 1779674 */     GIR_EraseRootFromParent_Done,
     /* 1779675 */   // Label 24197: @1779675
     /* 1779675 */   GIM_Try, /*On fail goto*//*Label 24198*/ GIMT_Encode4(1779761), // Rule ID 11803 //
     /* 1779680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1779688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1779691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1779694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1779697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1779700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1779703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779726 */     // MIs[0] policy
     /* 1779726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779736 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1779739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779760 */     // GIR_Coverage, 11803,
     /* 1779760 */     GIR_EraseRootFromParent_Done,
     /* 1779761 */   // Label 24198: @1779761
     /* 1779761 */   GIM_Try, /*On fail goto*//*Label 24199*/ GIMT_Encode4(1779847), // Rule ID 11806 //
     /* 1779766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1779774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1779777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1779780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1779783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1779786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779812 */     // MIs[0] policy
     /* 1779812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779822 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1779825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779846 */     // GIR_Coverage, 11806,
     /* 1779846 */     GIR_EraseRootFromParent_Done,
     /* 1779847 */   // Label 24199: @1779847
     /* 1779847 */   GIM_Try, /*On fail goto*//*Label 24200*/ GIMT_Encode4(1779933), // Rule ID 11807 //
     /* 1779852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1779860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1779863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1779866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1779869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1779872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779898 */     // MIs[0] policy
     /* 1779898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779908 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1779911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779932 */     // GIR_Coverage, 11807,
     /* 1779932 */     GIR_EraseRootFromParent_Done,
     /* 1779933 */   // Label 24200: @1779933
     /* 1779933 */   GIM_Try, /*On fail goto*//*Label 24201*/ GIMT_Encode4(1780019), // Rule ID 11810 //
     /* 1779938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1779946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1779949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1779952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1779955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1779958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779984 */     // MIs[0] policy
     /* 1779984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779994 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1779997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780018 */     // GIR_Coverage, 11810,
     /* 1780018 */     GIR_EraseRootFromParent_Done,
     /* 1780019 */   // Label 24201: @1780019
     /* 1780019 */   GIM_Try, /*On fail goto*//*Label 24202*/ GIMT_Encode4(1780105), // Rule ID 11811 //
     /* 1780024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1780032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1780035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1780038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1780041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1780044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780070 */     // MIs[0] policy
     /* 1780070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780080 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1780083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780104 */     // GIR_Coverage, 11811,
     /* 1780104 */     GIR_EraseRootFromParent_Done,
     /* 1780105 */   // Label 24202: @1780105
     /* 1780105 */   GIM_Try, /*On fail goto*//*Label 24203*/ GIMT_Encode4(1780191), // Rule ID 11814 //
     /* 1780110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1780118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1780121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1780124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1780127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1780130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780156 */     // MIs[0] policy
     /* 1780156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780166 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1780169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780190 */     // GIR_Coverage, 11814,
     /* 1780190 */     GIR_EraseRootFromParent_Done,
     /* 1780191 */   // Label 24203: @1780191
     /* 1780191 */   GIM_Try, /*On fail goto*//*Label 24204*/ GIMT_Encode4(1780277), // Rule ID 11815 //
     /* 1780196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1780204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1780207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1780210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1780213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1780216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780242 */     // MIs[0] policy
     /* 1780242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780252 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1780255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780276 */     // GIR_Coverage, 11815,
     /* 1780276 */     GIR_EraseRootFromParent_Done,
     /* 1780277 */   // Label 24204: @1780277
     /* 1780277 */   GIM_Try, /*On fail goto*//*Label 24205*/ GIMT_Encode4(1780363), // Rule ID 11818 //
     /* 1780282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1780290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1780293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1780296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1780299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1780302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780328 */     // MIs[0] policy
     /* 1780328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780338 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1780341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780362 */     // GIR_Coverage, 11818,
     /* 1780362 */     GIR_EraseRootFromParent_Done,
     /* 1780363 */   // Label 24205: @1780363
     /* 1780363 */   GIM_Try, /*On fail goto*//*Label 24206*/ GIMT_Encode4(1780449), // Rule ID 11819 //
     /* 1780368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1780376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1780379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1780382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1780385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1780388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780414 */     // MIs[0] policy
     /* 1780414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780424 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1780427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780448 */     // GIR_Coverage, 11819,
     /* 1780448 */     GIR_EraseRootFromParent_Done,
     /* 1780449 */   // Label 24206: @1780449
     /* 1780449 */   GIM_Try, /*On fail goto*//*Label 24207*/ GIMT_Encode4(1780535), // Rule ID 11822 //
     /* 1780454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1780457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1780462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1780465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1780468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1780471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1780474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780500 */     // MIs[0] policy
     /* 1780500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780510 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1780513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780534 */     // GIR_Coverage, 11822,
     /* 1780534 */     GIR_EraseRootFromParent_Done,
     /* 1780535 */   // Label 24207: @1780535
     /* 1780535 */   GIM_Try, /*On fail goto*//*Label 24208*/ GIMT_Encode4(1780621), // Rule ID 11823 //
     /* 1780540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1780543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1780548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1780551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1780554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1780557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1780560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780586 */     // MIs[0] policy
     /* 1780586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1780599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780620 */     // GIR_Coverage, 11823,
     /* 1780620 */     GIR_EraseRootFromParent_Done,
     /* 1780621 */   // Label 24208: @1780621
     /* 1780621 */   GIM_Try, /*On fail goto*//*Label 24209*/ GIMT_Encode4(1780707), // Rule ID 11826 //
     /* 1780626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1780629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1780634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1780637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1780640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1780643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1780646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780672 */     // MIs[0] policy
     /* 1780672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780682 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1780685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780706 */     // GIR_Coverage, 11826,
     /* 1780706 */     GIR_EraseRootFromParent_Done,
     /* 1780707 */   // Label 24209: @1780707
     /* 1780707 */   GIM_Try, /*On fail goto*//*Label 24210*/ GIMT_Encode4(1780793), // Rule ID 11827 //
     /* 1780712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1780715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1780720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1780723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1780726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1780729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1780732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780758 */     // MIs[0] policy
     /* 1780758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780768 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1780771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780792 */     // GIR_Coverage, 11827,
     /* 1780792 */     GIR_EraseRootFromParent_Done,
     /* 1780793 */   // Label 24210: @1780793
     /* 1780793 */   GIM_Try, /*On fail goto*//*Label 24211*/ GIMT_Encode4(1780879), // Rule ID 11830 //
     /* 1780798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1780801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1780806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1780809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1780812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1780815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1780818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780844 */     // MIs[0] policy
     /* 1780844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780854 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1780857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780878 */     // GIR_Coverage, 11830,
     /* 1780878 */     GIR_EraseRootFromParent_Done,
     /* 1780879 */   // Label 24211: @1780879
     /* 1780879 */   GIM_Try, /*On fail goto*//*Label 24212*/ GIMT_Encode4(1780965), // Rule ID 11831 //
     /* 1780884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1780887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1780892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1780895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1780898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1780901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1780904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780930 */     // MIs[0] policy
     /* 1780930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780940 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1780943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780964 */     // GIR_Coverage, 11831,
     /* 1780964 */     GIR_EraseRootFromParent_Done,
     /* 1780965 */   // Label 24212: @1780965
     /* 1780965 */   GIM_Try, /*On fail goto*//*Label 24213*/ GIMT_Encode4(1781051), // Rule ID 11834 //
     /* 1780970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1780981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1780984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1780987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1780990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1780993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781016 */     // MIs[0] policy
     /* 1781016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781026 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1781029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781050 */     // GIR_Coverage, 11834,
     /* 1781050 */     GIR_EraseRootFromParent_Done,
     /* 1781051 */   // Label 24213: @1781051
     /* 1781051 */   GIM_Try, /*On fail goto*//*Label 24214*/ GIMT_Encode4(1781137), // Rule ID 11835 //
     /* 1781056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1781067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1781070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1781073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1781076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781102 */     // MIs[0] policy
     /* 1781102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781112 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1781115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781136 */     // GIR_Coverage, 11835,
     /* 1781136 */     GIR_EraseRootFromParent_Done,
     /* 1781137 */   // Label 24214: @1781137
     /* 1781137 */   GIM_Try, /*On fail goto*//*Label 24215*/ GIMT_Encode4(1781223), // Rule ID 11838 //
     /* 1781142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1781153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1781156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1781159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1781162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781188 */     // MIs[0] policy
     /* 1781188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781198 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1781201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781222 */     // GIR_Coverage, 11838,
     /* 1781222 */     GIR_EraseRootFromParent_Done,
     /* 1781223 */   // Label 24215: @1781223
     /* 1781223 */   GIM_Try, /*On fail goto*//*Label 24216*/ GIMT_Encode4(1781309), // Rule ID 11839 //
     /* 1781228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1781239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1781242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1781245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1781248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781274 */     // MIs[0] policy
     /* 1781274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781284 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1781287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781308 */     // GIR_Coverage, 11839,
     /* 1781308 */     GIR_EraseRootFromParent_Done,
     /* 1781309 */   // Label 24216: @1781309
     /* 1781309 */   GIM_Try, /*On fail goto*//*Label 24217*/ GIMT_Encode4(1781395), // Rule ID 11842 //
     /* 1781314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1781325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1781328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1781331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1781334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781360 */     // MIs[0] policy
     /* 1781360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781370 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1781373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781394 */     // GIR_Coverage, 11842,
     /* 1781394 */     GIR_EraseRootFromParent_Done,
     /* 1781395 */   // Label 24217: @1781395
     /* 1781395 */   GIM_Try, /*On fail goto*//*Label 24218*/ GIMT_Encode4(1781481), // Rule ID 11843 //
     /* 1781400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1781411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1781414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1781417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1781420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781446 */     // MIs[0] policy
     /* 1781446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781456 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1781459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781480 */     // GIR_Coverage, 11843,
     /* 1781480 */     GIR_EraseRootFromParent_Done,
     /* 1781481 */   // Label 24218: @1781481
     /* 1781481 */   GIM_Try, /*On fail goto*//*Label 24219*/ GIMT_Encode4(1781567), // Rule ID 11846 //
     /* 1781486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1781497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1781500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1781503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1781506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781532 */     // MIs[0] policy
     /* 1781532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781542 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1781545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781566 */     // GIR_Coverage, 11846,
     /* 1781566 */     GIR_EraseRootFromParent_Done,
     /* 1781567 */   // Label 24219: @1781567
     /* 1781567 */   GIM_Try, /*On fail goto*//*Label 24220*/ GIMT_Encode4(1781653), // Rule ID 11847 //
     /* 1781572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1781583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1781586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1781589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1781592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781618 */     // MIs[0] policy
     /* 1781618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781628 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1781631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781652 */     // GIR_Coverage, 11847,
     /* 1781652 */     GIR_EraseRootFromParent_Done,
     /* 1781653 */   // Label 24220: @1781653
     /* 1781653 */   GIM_Try, /*On fail goto*//*Label 24221*/ GIMT_Encode4(1781739), // Rule ID 11850 //
     /* 1781658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1781669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1781672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1781675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1781678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781704 */     // MIs[0] policy
     /* 1781704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781714 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1781717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781738 */     // GIR_Coverage, 11850,
     /* 1781738 */     GIR_EraseRootFromParent_Done,
     /* 1781739 */   // Label 24221: @1781739
     /* 1781739 */   GIM_Try, /*On fail goto*//*Label 24222*/ GIMT_Encode4(1781825), // Rule ID 11851 //
     /* 1781744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1781755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1781758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1781761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1781764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781790 */     // MIs[0] policy
     /* 1781790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781800 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1781803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781824 */     // GIR_Coverage, 11851,
     /* 1781824 */     GIR_EraseRootFromParent_Done,
     /* 1781825 */   // Label 24222: @1781825
     /* 1781825 */   GIM_Try, /*On fail goto*//*Label 24223*/ GIMT_Encode4(1781911), // Rule ID 11854 //
     /* 1781830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1781841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1781844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1781847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1781850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781876 */     // MIs[0] policy
     /* 1781876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781886 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1781889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781910 */     // GIR_Coverage, 11854,
     /* 1781910 */     GIR_EraseRootFromParent_Done,
     /* 1781911 */   // Label 24223: @1781911
     /* 1781911 */   GIM_Try, /*On fail goto*//*Label 24224*/ GIMT_Encode4(1781997), // Rule ID 11855 //
     /* 1781916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1781927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1781930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1781933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1781936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781962 */     // MIs[0] policy
     /* 1781962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781972 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1781975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781996 */     // GIR_Coverage, 11855,
     /* 1781996 */     GIR_EraseRootFromParent_Done,
     /* 1781997 */   // Label 24224: @1781997
     /* 1781997 */   GIM_Try, /*On fail goto*//*Label 24225*/ GIMT_Encode4(1782083), // Rule ID 11858 //
     /* 1782002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1782013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1782016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1782019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1782022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1782025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782048 */     // MIs[0] policy
     /* 1782048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782058 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1782061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782082 */     // GIR_Coverage, 11858,
     /* 1782082 */     GIR_EraseRootFromParent_Done,
     /* 1782083 */   // Label 24225: @1782083
     /* 1782083 */   GIM_Try, /*On fail goto*//*Label 24226*/ GIMT_Encode4(1782169), // Rule ID 11859 //
     /* 1782088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1782099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1782102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1782105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1782108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1782111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782134 */     // MIs[0] policy
     /* 1782134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782144 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1782147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782168 */     // GIR_Coverage, 11859,
     /* 1782168 */     GIR_EraseRootFromParent_Done,
     /* 1782169 */   // Label 24226: @1782169
     /* 1782169 */   GIM_Try, /*On fail goto*//*Label 24227*/ GIMT_Encode4(1782255), // Rule ID 11862 //
     /* 1782174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1782185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1782188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1782191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1782194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782220 */     // MIs[0] policy
     /* 1782220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782230 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1782233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782254 */     // GIR_Coverage, 11862,
     /* 1782254 */     GIR_EraseRootFromParent_Done,
     /* 1782255 */   // Label 24227: @1782255
     /* 1782255 */   GIM_Try, /*On fail goto*//*Label 24228*/ GIMT_Encode4(1782341), // Rule ID 11863 //
     /* 1782260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1782271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1782274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1782277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1782280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782306 */     // MIs[0] policy
     /* 1782306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1782319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782340 */     // GIR_Coverage, 11863,
     /* 1782340 */     GIR_EraseRootFromParent_Done,
     /* 1782341 */   // Label 24228: @1782341
     /* 1782341 */   GIM_Try, /*On fail goto*//*Label 24229*/ GIMT_Encode4(1782427), // Rule ID 11866 //
     /* 1782346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1782357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1782360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1782363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1782366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782392 */     // MIs[0] policy
     /* 1782392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782402 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1782405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782426 */     // GIR_Coverage, 11866,
     /* 1782426 */     GIR_EraseRootFromParent_Done,
     /* 1782427 */   // Label 24229: @1782427
     /* 1782427 */   GIM_Try, /*On fail goto*//*Label 24230*/ GIMT_Encode4(1782513), // Rule ID 11867 //
     /* 1782432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1782443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1782446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1782449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1782452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782478 */     // MIs[0] policy
     /* 1782478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782488 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1782491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782512 */     // GIR_Coverage, 11867,
     /* 1782512 */     GIR_EraseRootFromParent_Done,
     /* 1782513 */   // Label 24230: @1782513
     /* 1782513 */   GIM_Try, /*On fail goto*//*Label 24231*/ GIMT_Encode4(1782599), // Rule ID 11870 //
     /* 1782518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1782521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1782529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1782532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1782535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1782538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782564 */     // MIs[0] policy
     /* 1782564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1782577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782598 */     // GIR_Coverage, 11870,
     /* 1782598 */     GIR_EraseRootFromParent_Done,
     /* 1782599 */   // Label 24231: @1782599
     /* 1782599 */   GIM_Try, /*On fail goto*//*Label 24232*/ GIMT_Encode4(1782685), // Rule ID 11871 //
     /* 1782604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1782607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1782615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1782618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1782621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1782624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782650 */     // MIs[0] policy
     /* 1782650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782660 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1782663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782684 */     // GIR_Coverage, 11871,
     /* 1782684 */     GIR_EraseRootFromParent_Done,
     /* 1782685 */   // Label 24232: @1782685
     /* 1782685 */   GIM_Try, /*On fail goto*//*Label 24233*/ GIMT_Encode4(1782771), // Rule ID 11874 //
     /* 1782690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1782701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1782704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1782707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1782710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1782713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1782720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782736 */     // MIs[0] policy
     /* 1782736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782746 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1782749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782770 */     // GIR_Coverage, 11874,
     /* 1782770 */     GIR_EraseRootFromParent_Done,
     /* 1782771 */   // Label 24233: @1782771
     /* 1782771 */   GIM_Try, /*On fail goto*//*Label 24234*/ GIMT_Encode4(1782857), // Rule ID 11875 //
     /* 1782776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1782787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1782790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1782793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1782796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1782799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1782806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782822 */     // MIs[0] policy
     /* 1782822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782832 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1782835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782856 */     // GIR_Coverage, 11875,
     /* 1782856 */     GIR_EraseRootFromParent_Done,
     /* 1782857 */   // Label 24234: @1782857
     /* 1782857 */   GIM_Try, /*On fail goto*//*Label 24235*/ GIMT_Encode4(1782943), // Rule ID 11878 //
     /* 1782862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1782873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1782876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1782879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1782882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1782885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1782892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782908 */     // MIs[0] policy
     /* 1782908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782918 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1782921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782942 */     // GIR_Coverage, 11878,
     /* 1782942 */     GIR_EraseRootFromParent_Done,
     /* 1782943 */   // Label 24235: @1782943
     /* 1782943 */   GIM_Try, /*On fail goto*//*Label 24236*/ GIMT_Encode4(1783029), // Rule ID 11879 //
     /* 1782948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1782959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1782962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1782965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1782968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1782971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1782978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782994 */     // MIs[0] policy
     /* 1782994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783004 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1783007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783028 */     // GIR_Coverage, 11879,
     /* 1783028 */     GIR_EraseRootFromParent_Done,
     /* 1783029 */   // Label 24236: @1783029
     /* 1783029 */   GIM_Try, /*On fail goto*//*Label 24237*/ GIMT_Encode4(1783115), // Rule ID 11882 //
     /* 1783034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1783045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1783048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1783051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1783054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1783057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783080 */     // MIs[0] policy
     /* 1783080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783090 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1783093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783114 */     // GIR_Coverage, 11882,
     /* 1783114 */     GIR_EraseRootFromParent_Done,
     /* 1783115 */   // Label 24237: @1783115
     /* 1783115 */   GIM_Try, /*On fail goto*//*Label 24238*/ GIMT_Encode4(1783201), // Rule ID 11883 //
     /* 1783120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1783131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1783134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1783137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1783140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1783143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783166 */     // MIs[0] policy
     /* 1783166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783176 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1783179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783200 */     // GIR_Coverage, 11883,
     /* 1783200 */     GIR_EraseRootFromParent_Done,
     /* 1783201 */   // Label 24238: @1783201
     /* 1783201 */   GIM_Try, /*On fail goto*//*Label 24239*/ GIMT_Encode4(1783287), // Rule ID 11886 //
     /* 1783206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1783217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1783220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1783223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1783226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783252 */     // MIs[0] policy
     /* 1783252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783262 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1783265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783286 */     // GIR_Coverage, 11886,
     /* 1783286 */     GIR_EraseRootFromParent_Done,
     /* 1783287 */   // Label 24239: @1783287
     /* 1783287 */   GIM_Try, /*On fail goto*//*Label 24240*/ GIMT_Encode4(1783373), // Rule ID 11887 //
     /* 1783292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1783303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1783306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1783309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1783312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783338 */     // MIs[0] policy
     /* 1783338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1783351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783372 */     // GIR_Coverage, 11887,
     /* 1783372 */     GIR_EraseRootFromParent_Done,
     /* 1783373 */   // Label 24240: @1783373
     /* 1783373 */   GIM_Try, /*On fail goto*//*Label 24241*/ GIMT_Encode4(1783459), // Rule ID 11890 //
     /* 1783378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1783389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1783392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1783395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1783398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783424 */     // MIs[0] policy
     /* 1783424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783434 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1783437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783458 */     // GIR_Coverage, 11890,
     /* 1783458 */     GIR_EraseRootFromParent_Done,
     /* 1783459 */   // Label 24241: @1783459
     /* 1783459 */   GIM_Try, /*On fail goto*//*Label 24242*/ GIMT_Encode4(1783545), // Rule ID 11891 //
     /* 1783464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1783475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1783478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1783481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1783484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783510 */     // MIs[0] policy
     /* 1783510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783520 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1783523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783544 */     // GIR_Coverage, 11891,
     /* 1783544 */     GIR_EraseRootFromParent_Done,
     /* 1783545 */   // Label 24242: @1783545
     /* 1783545 */   GIM_Try, /*On fail goto*//*Label 24243*/ GIMT_Encode4(1783631), // Rule ID 11894 //
     /* 1783550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1783561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1783564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1783567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1783570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783596 */     // MIs[0] policy
     /* 1783596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783606 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1783609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783630 */     // GIR_Coverage, 11894,
     /* 1783630 */     GIR_EraseRootFromParent_Done,
     /* 1783631 */   // Label 24243: @1783631
     /* 1783631 */   GIM_Try, /*On fail goto*//*Label 24244*/ GIMT_Encode4(1783717), // Rule ID 11895 //
     /* 1783636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1783647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1783650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1783653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1783656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783682 */     // MIs[0] policy
     /* 1783682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783692 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1783695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783716 */     // GIR_Coverage, 11895,
     /* 1783716 */     GIR_EraseRootFromParent_Done,
     /* 1783717 */   // Label 24244: @1783717
     /* 1783717 */   GIM_Try, /*On fail goto*//*Label 24245*/ GIMT_Encode4(1783803), // Rule ID 11898 //
     /* 1783722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1783733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1783736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1783739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1783742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1783745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783768 */     // MIs[0] policy
     /* 1783768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1783781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783802 */     // GIR_Coverage, 11898,
     /* 1783802 */     GIR_EraseRootFromParent_Done,
     /* 1783803 */   // Label 24245: @1783803
     /* 1783803 */   GIM_Try, /*On fail goto*//*Label 24246*/ GIMT_Encode4(1783889), // Rule ID 11899 //
     /* 1783808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1783819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1783822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1783825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1783828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1783831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783854 */     // MIs[0] policy
     /* 1783854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1783867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783888 */     // GIR_Coverage, 11899,
     /* 1783888 */     GIR_EraseRootFromParent_Done,
     /* 1783889 */   // Label 24246: @1783889
     /* 1783889 */   GIM_Try, /*On fail goto*//*Label 24247*/ GIMT_Encode4(1783975), // Rule ID 11902 //
     /* 1783894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1783905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1783908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1783911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1783914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783940 */     // MIs[0] policy
     /* 1783940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783950 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1783953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783974 */     // GIR_Coverage, 11902,
     /* 1783974 */     GIR_EraseRootFromParent_Done,
     /* 1783975 */   // Label 24247: @1783975
     /* 1783975 */   GIM_Try, /*On fail goto*//*Label 24248*/ GIMT_Encode4(1784061), // Rule ID 11903 //
     /* 1783980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1783991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1783994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1783997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1784000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784026 */     // MIs[0] policy
     /* 1784026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1784039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784060 */     // GIR_Coverage, 11903,
     /* 1784060 */     GIR_EraseRootFromParent_Done,
     /* 1784061 */   // Label 24248: @1784061
     /* 1784061 */   GIM_Try, /*On fail goto*//*Label 24249*/ GIMT_Encode4(1784147), // Rule ID 11906 //
     /* 1784066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1784077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1784080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1784083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1784086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784112 */     // MIs[0] policy
     /* 1784112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784122 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1784125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784146 */     // GIR_Coverage, 11906,
     /* 1784146 */     GIR_EraseRootFromParent_Done,
     /* 1784147 */   // Label 24249: @1784147
     /* 1784147 */   GIM_Try, /*On fail goto*//*Label 24250*/ GIMT_Encode4(1784233), // Rule ID 11907 //
     /* 1784152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1784163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1784166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1784169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1784172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784198 */     // MIs[0] policy
     /* 1784198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784208 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1784211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784232 */     // GIR_Coverage, 11907,
     /* 1784232 */     GIR_EraseRootFromParent_Done,
     /* 1784233 */   // Label 24250: @1784233
     /* 1784233 */   GIM_Try, /*On fail goto*//*Label 24251*/ GIMT_Encode4(1784319), // Rule ID 11910 //
     /* 1784238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1784249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1784252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1784255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1784258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784284 */     // MIs[0] policy
     /* 1784284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1784297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784318 */     // GIR_Coverage, 11910,
     /* 1784318 */     GIR_EraseRootFromParent_Done,
     /* 1784319 */   // Label 24251: @1784319
     /* 1784319 */   GIM_Try, /*On fail goto*//*Label 24252*/ GIMT_Encode4(1784405), // Rule ID 11911 //
     /* 1784324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1784335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1784338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1784341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1784344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784370 */     // MIs[0] policy
     /* 1784370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784380 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1784383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784404 */     // GIR_Coverage, 11911,
     /* 1784404 */     GIR_EraseRootFromParent_Done,
     /* 1784405 */   // Label 24252: @1784405
     /* 1784405 */   GIM_Try, /*On fail goto*//*Label 24253*/ GIMT_Encode4(1784491), // Rule ID 11914 //
     /* 1784410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1784421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1784424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1784427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1784430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784456 */     // MIs[0] policy
     /* 1784456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784466 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1784469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784490 */     // GIR_Coverage, 11914,
     /* 1784490 */     GIR_EraseRootFromParent_Done,
     /* 1784491 */   // Label 24253: @1784491
     /* 1784491 */   GIM_Try, /*On fail goto*//*Label 24254*/ GIMT_Encode4(1784577), // Rule ID 11915 //
     /* 1784496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1784507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1784510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1784513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1784516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784542 */     // MIs[0] policy
     /* 1784542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784552 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1784555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784576 */     // GIR_Coverage, 11915,
     /* 1784576 */     GIR_EraseRootFromParent_Done,
     /* 1784577 */   // Label 24254: @1784577
     /* 1784577 */   GIM_Try, /*On fail goto*//*Label 24255*/ GIMT_Encode4(1784663), // Rule ID 11918 //
     /* 1784582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1784593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1784596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1784599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1784602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784628 */     // MIs[0] policy
     /* 1784628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784638 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1784641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784662 */     // GIR_Coverage, 11918,
     /* 1784662 */     GIR_EraseRootFromParent_Done,
     /* 1784663 */   // Label 24255: @1784663
     /* 1784663 */   GIM_Try, /*On fail goto*//*Label 24256*/ GIMT_Encode4(1784749), // Rule ID 11919 //
     /* 1784668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1784679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1784682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1784685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1784688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784714 */     // MIs[0] policy
     /* 1784714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784724 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1784727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784748 */     // GIR_Coverage, 11919,
     /* 1784748 */     GIR_EraseRootFromParent_Done,
     /* 1784749 */   // Label 24256: @1784749
     /* 1784749 */   GIM_Try, /*On fail goto*//*Label 24257*/ GIMT_Encode4(1784835), // Rule ID 11922 //
     /* 1784754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1784765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1784768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1784771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1784777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784800 */     // MIs[0] policy
     /* 1784800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784810 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1784813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784834 */     // GIR_Coverage, 11922,
     /* 1784834 */     GIR_EraseRootFromParent_Done,
     /* 1784835 */   // Label 24257: @1784835
     /* 1784835 */   GIM_Try, /*On fail goto*//*Label 24258*/ GIMT_Encode4(1784921), // Rule ID 11923 //
     /* 1784840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1784851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1784854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1784857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1784863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784886 */     // MIs[0] policy
     /* 1784886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1784899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784920 */     // GIR_Coverage, 11923,
     /* 1784920 */     GIR_EraseRootFromParent_Done,
     /* 1784921 */   // Label 24258: @1784921
     /* 1784921 */   GIM_Try, /*On fail goto*//*Label 24259*/ GIMT_Encode4(1785007), // Rule ID 11926 //
     /* 1784926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1784937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1784940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1784943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784972 */     // MIs[0] policy
     /* 1784972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784982 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1784985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785006 */     // GIR_Coverage, 11926,
     /* 1785006 */     GIR_EraseRootFromParent_Done,
     /* 1785007 */   // Label 24259: @1785007
     /* 1785007 */   GIM_Try, /*On fail goto*//*Label 24260*/ GIMT_Encode4(1785093), // Rule ID 11927 //
     /* 1785012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1785023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1785026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1785029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785058 */     // MIs[0] policy
     /* 1785058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785068 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1785071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785092 */     // GIR_Coverage, 11927,
     /* 1785092 */     GIR_EraseRootFromParent_Done,
     /* 1785093 */   // Label 24260: @1785093
     /* 1785093 */   GIM_Try, /*On fail goto*//*Label 24261*/ GIMT_Encode4(1785179), // Rule ID 11930 //
     /* 1785098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1785109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1785112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1785115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785144 */     // MIs[0] policy
     /* 1785144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785154 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1785157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785178 */     // GIR_Coverage, 11930,
     /* 1785178 */     GIR_EraseRootFromParent_Done,
     /* 1785179 */   // Label 24261: @1785179
     /* 1785179 */   GIM_Try, /*On fail goto*//*Label 24262*/ GIMT_Encode4(1785265), // Rule ID 11931 //
     /* 1785184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1785195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1785198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1785201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785230 */     // MIs[0] policy
     /* 1785230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785240 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1785243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785264 */     // GIR_Coverage, 11931,
     /* 1785264 */     GIR_EraseRootFromParent_Done,
     /* 1785265 */   // Label 24262: @1785265
     /* 1785265 */   GIM_Try, /*On fail goto*//*Label 24263*/ GIMT_Encode4(1785351), // Rule ID 11934 //
     /* 1785270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1785281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1785284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1785287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785316 */     // MIs[0] policy
     /* 1785316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785326 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1785329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785350 */     // GIR_Coverage, 11934,
     /* 1785350 */     GIR_EraseRootFromParent_Done,
     /* 1785351 */   // Label 24263: @1785351
     /* 1785351 */   GIM_Try, /*On fail goto*//*Label 24264*/ GIMT_Encode4(1785437), // Rule ID 11935 //
     /* 1785356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1785367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1785370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1785373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785402 */     // MIs[0] policy
     /* 1785402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785412 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1785415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785436 */     // GIR_Coverage, 11935,
     /* 1785436 */     GIR_EraseRootFromParent_Done,
     /* 1785437 */   // Label 24264: @1785437
     /* 1785437 */   GIM_Try, /*On fail goto*//*Label 24265*/ GIMT_Encode4(1785523), // Rule ID 11938 //
     /* 1785442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1785453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1785456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1785459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785488 */     // MIs[0] policy
     /* 1785488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785498 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1785501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785522 */     // GIR_Coverage, 11938,
     /* 1785522 */     GIR_EraseRootFromParent_Done,
     /* 1785523 */   // Label 24265: @1785523
     /* 1785523 */   GIM_Try, /*On fail goto*//*Label 24266*/ GIMT_Encode4(1785609), // Rule ID 11939 //
     /* 1785528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1785539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1785542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1785545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785574 */     // MIs[0] policy
     /* 1785574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785584 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1785587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785608 */     // GIR_Coverage, 11939,
     /* 1785608 */     GIR_EraseRootFromParent_Done,
     /* 1785609 */   // Label 24266: @1785609
     /* 1785609 */   GIM_Try, /*On fail goto*//*Label 24267*/ GIMT_Encode4(1785695), // Rule ID 11942 //
     /* 1785614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1785625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1785628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1785631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785660 */     // MIs[0] policy
     /* 1785660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785670 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1785673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785694 */     // GIR_Coverage, 11942,
     /* 1785694 */     GIR_EraseRootFromParent_Done,
     /* 1785695 */   // Label 24267: @1785695
     /* 1785695 */   GIM_Try, /*On fail goto*//*Label 24268*/ GIMT_Encode4(1785781), // Rule ID 11943 //
     /* 1785700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1785711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1785714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1785717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785746 */     // MIs[0] policy
     /* 1785746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785756 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1785759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785780 */     // GIR_Coverage, 11943,
     /* 1785780 */     GIR_EraseRootFromParent_Done,
     /* 1785781 */   // Label 24268: @1785781
     /* 1785781 */   GIM_Try, /*On fail goto*//*Label 24269*/ GIMT_Encode4(1785867), // Rule ID 11946 //
     /* 1785786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1785797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1785800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1785803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785832 */     // MIs[0] policy
     /* 1785832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785842 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1785845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785866 */     // GIR_Coverage, 11946,
     /* 1785866 */     GIR_EraseRootFromParent_Done,
     /* 1785867 */   // Label 24269: @1785867
     /* 1785867 */   GIM_Try, /*On fail goto*//*Label 24270*/ GIMT_Encode4(1785953), // Rule ID 11947 //
     /* 1785872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1785883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1785886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1785889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785918 */     // MIs[0] policy
     /* 1785918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785928 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1785931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785952 */     // GIR_Coverage, 11947,
     /* 1785952 */     GIR_EraseRootFromParent_Done,
     /* 1785953 */   // Label 24270: @1785953
     /* 1785953 */   GIM_Try, /*On fail goto*//*Label 24271*/ GIMT_Encode4(1786039), // Rule ID 11950 //
     /* 1785958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1785969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1785972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1785975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786004 */     // MIs[0] policy
     /* 1786004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786014 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1786017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786038 */     // GIR_Coverage, 11950,
     /* 1786038 */     GIR_EraseRootFromParent_Done,
     /* 1786039 */   // Label 24271: @1786039
     /* 1786039 */   GIM_Try, /*On fail goto*//*Label 24272*/ GIMT_Encode4(1786125), // Rule ID 11951 //
     /* 1786044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1786052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1786055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1786058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1786061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1786064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786090 */     // MIs[0] policy
     /* 1786090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1786103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786124 */     // GIR_Coverage, 11951,
     /* 1786124 */     GIR_EraseRootFromParent_Done,
     /* 1786125 */   // Label 24272: @1786125
     /* 1786125 */   GIM_Try, /*On fail goto*//*Label 24273*/ GIMT_Encode4(1786211), // Rule ID 11954 //
     /* 1786130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1786138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1786141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1786144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1786147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1786150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786176 */     // MIs[0] policy
     /* 1786176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786186 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1786189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786210 */     // GIR_Coverage, 11954,
     /* 1786210 */     GIR_EraseRootFromParent_Done,
     /* 1786211 */   // Label 24273: @1786211
     /* 1786211 */   GIM_Try, /*On fail goto*//*Label 24274*/ GIMT_Encode4(1786297), // Rule ID 11955 //
     /* 1786216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1786224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1786227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1786230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1786233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1786236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786262 */     // MIs[0] policy
     /* 1786262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786272 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1786275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786296 */     // GIR_Coverage, 11955,
     /* 1786296 */     GIR_EraseRootFromParent_Done,
     /* 1786297 */   // Label 24274: @1786297
     /* 1786297 */   GIM_Try, /*On fail goto*//*Label 24275*/ GIMT_Encode4(1786383), // Rule ID 11958 //
     /* 1786302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1786305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1786310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1786313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1786316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1786319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1786322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786348 */     // MIs[0] policy
     /* 1786348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786358 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1786361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786382 */     // GIR_Coverage, 11958,
     /* 1786382 */     GIR_EraseRootFromParent_Done,
     /* 1786383 */   // Label 24275: @1786383
     /* 1786383 */   GIM_Try, /*On fail goto*//*Label 24276*/ GIMT_Encode4(1786469), // Rule ID 11959 //
     /* 1786388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1786391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1786396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1786399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1786402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1786405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1786408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786434 */     // MIs[0] policy
     /* 1786434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786444 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1786447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786468 */     // GIR_Coverage, 11959,
     /* 1786468 */     GIR_EraseRootFromParent_Done,
     /* 1786469 */   // Label 24276: @1786469
     /* 1786469 */   GIM_Try, /*On fail goto*//*Label 24277*/ GIMT_Encode4(1786555), // Rule ID 11962 //
     /* 1786474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1786482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1786485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1786488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1786491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1786494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1786497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1786504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786520 */     // MIs[0] policy
     /* 1786520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786530 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1786533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786554 */     // GIR_Coverage, 11962,
     /* 1786554 */     GIR_EraseRootFromParent_Done,
     /* 1786555 */   // Label 24277: @1786555
     /* 1786555 */   GIM_Try, /*On fail goto*//*Label 24278*/ GIMT_Encode4(1786641), // Rule ID 11963 //
     /* 1786560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1786568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1786571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1786574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1786577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1786580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1786583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1786590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786606 */     // MIs[0] policy
     /* 1786606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786616 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1786619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786640 */     // GIR_Coverage, 11963,
     /* 1786640 */     GIR_EraseRootFromParent_Done,
     /* 1786641 */   // Label 24278: @1786641
     /* 1786641 */   GIM_Try, /*On fail goto*//*Label 24279*/ GIMT_Encode4(1786727), // Rule ID 11966 //
     /* 1786646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1786654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1786657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1786660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1786663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1786666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1786669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1786676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786692 */     // MIs[0] policy
     /* 1786692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786702 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1786705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786726 */     // GIR_Coverage, 11966,
     /* 1786726 */     GIR_EraseRootFromParent_Done,
     /* 1786727 */   // Label 24279: @1786727
     /* 1786727 */   GIM_Try, /*On fail goto*//*Label 24280*/ GIMT_Encode4(1786813), // Rule ID 11967 //
     /* 1786732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1786740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1786743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1786746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1786749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1786752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1786755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1786762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786778 */     // MIs[0] policy
     /* 1786778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786788 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1786791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786812 */     // GIR_Coverage, 11967,
     /* 1786812 */     GIR_EraseRootFromParent_Done,
     /* 1786813 */   // Label 24280: @1786813
     /* 1786813 */   GIM_Try, /*On fail goto*//*Label 24281*/ GIMT_Encode4(1786899), // Rule ID 11970 //
     /* 1786818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1786826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1786829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1786832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1786835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1786838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1786841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1786848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786864 */     // MIs[0] policy
     /* 1786864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786874 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1786877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786898 */     // GIR_Coverage, 11970,
     /* 1786898 */     GIR_EraseRootFromParent_Done,
     /* 1786899 */   // Label 24281: @1786899
     /* 1786899 */   GIM_Try, /*On fail goto*//*Label 24282*/ GIMT_Encode4(1786985), // Rule ID 11971 //
     /* 1786904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1786912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1786915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1786918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1786921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1786924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1786927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1786934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786950 */     // MIs[0] policy
     /* 1786950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786960 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1786963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786984 */     // GIR_Coverage, 11971,
     /* 1786984 */     GIR_EraseRootFromParent_Done,
     /* 1786985 */   // Label 24282: @1786985
     /* 1786985 */   GIM_Try, /*On fail goto*//*Label 24283*/ GIMT_Encode4(1787071), // Rule ID 11974 //
     /* 1786990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1786998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1787001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1787004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1787007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1787010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787036 */     // MIs[0] policy
     /* 1787036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787046 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1787049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787070 */     // GIR_Coverage, 11974,
     /* 1787070 */     GIR_EraseRootFromParent_Done,
     /* 1787071 */   // Label 24283: @1787071
     /* 1787071 */   GIM_Try, /*On fail goto*//*Label 24284*/ GIMT_Encode4(1787157), // Rule ID 11975 //
     /* 1787076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1787084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1787087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1787090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1787093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1787096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787122 */     // MIs[0] policy
     /* 1787122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787132 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1787135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787156 */     // GIR_Coverage, 11975,
     /* 1787156 */     GIR_EraseRootFromParent_Done,
     /* 1787157 */   // Label 24284: @1787157
     /* 1787157 */   GIM_Try, /*On fail goto*//*Label 24285*/ GIMT_Encode4(1787243), // Rule ID 11978 //
     /* 1787162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1787170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1787173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1787176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1787179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1787182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787208 */     // MIs[0] policy
     /* 1787208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1787221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787242 */     // GIR_Coverage, 11978,
     /* 1787242 */     GIR_EraseRootFromParent_Done,
     /* 1787243 */   // Label 24285: @1787243
     /* 1787243 */   GIM_Try, /*On fail goto*//*Label 24286*/ GIMT_Encode4(1787329), // Rule ID 11979 //
     /* 1787248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1787256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1787259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1787262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1787265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1787268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787294 */     // MIs[0] policy
     /* 1787294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787304 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1787307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787328 */     // GIR_Coverage, 11979,
     /* 1787328 */     GIR_EraseRootFromParent_Done,
     /* 1787329 */   // Label 24286: @1787329
     /* 1787329 */   GIM_Try, /*On fail goto*//*Label 24287*/ GIMT_Encode4(1787415), // Rule ID 11982 //
     /* 1787334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1787342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1787345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1787348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1787351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1787354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787380 */     // MIs[0] policy
     /* 1787380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787390 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1787393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787414 */     // GIR_Coverage, 11982,
     /* 1787414 */     GIR_EraseRootFromParent_Done,
     /* 1787415 */   // Label 24287: @1787415
     /* 1787415 */   GIM_Try, /*On fail goto*//*Label 24288*/ GIMT_Encode4(1787501), // Rule ID 11983 //
     /* 1787420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1787428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1787431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1787434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1787437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1787440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787466 */     // MIs[0] policy
     /* 1787466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787476 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1787479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787500 */     // GIR_Coverage, 11983,
     /* 1787500 */     GIR_EraseRootFromParent_Done,
     /* 1787501 */   // Label 24288: @1787501
     /* 1787501 */   GIM_Try, /*On fail goto*//*Label 24289*/ GIMT_Encode4(1787587), // Rule ID 11986 //
     /* 1787506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1787514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1787517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1787520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1787523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1787526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1787529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787552 */     // MIs[0] policy
     /* 1787552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1787565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787586 */     // GIR_Coverage, 11986,
     /* 1787586 */     GIR_EraseRootFromParent_Done,
     /* 1787587 */   // Label 24289: @1787587
     /* 1787587 */   GIM_Try, /*On fail goto*//*Label 24290*/ GIMT_Encode4(1787673), // Rule ID 11987 //
     /* 1787592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1787600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1787603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1787606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1787609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1787612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1787615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787638 */     // MIs[0] policy
     /* 1787638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1787651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787672 */     // GIR_Coverage, 11987,
     /* 1787672 */     GIR_EraseRootFromParent_Done,
     /* 1787673 */   // Label 24290: @1787673
     /* 1787673 */   GIM_Try, /*On fail goto*//*Label 24291*/ GIMT_Encode4(1787759), // Rule ID 11990 //
     /* 1787678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1787686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1787689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1787692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1787695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1787698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787724 */     // MIs[0] policy
     /* 1787724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787734 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1787737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787758 */     // GIR_Coverage, 11990,
     /* 1787758 */     GIR_EraseRootFromParent_Done,
     /* 1787759 */   // Label 24291: @1787759
     /* 1787759 */   GIM_Try, /*On fail goto*//*Label 24292*/ GIMT_Encode4(1787845), // Rule ID 11991 //
     /* 1787764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1787772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1787775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1787778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1787781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1787784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787810 */     // MIs[0] policy
     /* 1787810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787820 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1787823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787844 */     // GIR_Coverage, 11991,
     /* 1787844 */     GIR_EraseRootFromParent_Done,
     /* 1787845 */   // Label 24292: @1787845
     /* 1787845 */   GIM_Try, /*On fail goto*//*Label 24293*/ GIMT_Encode4(1787931), // Rule ID 11994 //
     /* 1787850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1787858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1787861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1787864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1787867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1787870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787896 */     // MIs[0] policy
     /* 1787896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787906 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1787909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787930 */     // GIR_Coverage, 11994,
     /* 1787930 */     GIR_EraseRootFromParent_Done,
     /* 1787931 */   // Label 24293: @1787931
     /* 1787931 */   GIM_Try, /*On fail goto*//*Label 24294*/ GIMT_Encode4(1788017), // Rule ID 11995 //
     /* 1787936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1787944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1787947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1787950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1787953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1787956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787982 */     // MIs[0] policy
     /* 1787982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787992 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1787995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788016 */     // GIR_Coverage, 11995,
     /* 1788016 */     GIR_EraseRootFromParent_Done,
     /* 1788017 */   // Label 24294: @1788017
     /* 1788017 */   GIM_Try, /*On fail goto*//*Label 24295*/ GIMT_Encode4(1788103), // Rule ID 11998 //
     /* 1788022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1788030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1788033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1788036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1788039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788068 */     // MIs[0] policy
     /* 1788068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788078 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1788081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788102 */     // GIR_Coverage, 11998,
     /* 1788102 */     GIR_EraseRootFromParent_Done,
     /* 1788103 */   // Label 24295: @1788103
     /* 1788103 */   GIM_Try, /*On fail goto*//*Label 24296*/ GIMT_Encode4(1788189), // Rule ID 11999 //
     /* 1788108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1788116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1788119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1788122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1788125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788154 */     // MIs[0] policy
     /* 1788154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1788167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788188 */     // GIR_Coverage, 11999,
     /* 1788188 */     GIR_EraseRootFromParent_Done,
     /* 1788189 */   // Label 24296: @1788189
     /* 1788189 */   GIM_Try, /*On fail goto*//*Label 24297*/ GIMT_Encode4(1788275), // Rule ID 12002 //
     /* 1788194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1788202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1788205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1788208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1788211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788240 */     // MIs[0] policy
     /* 1788240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788250 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1788253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788274 */     // GIR_Coverage, 12002,
     /* 1788274 */     GIR_EraseRootFromParent_Done,
     /* 1788275 */   // Label 24297: @1788275
     /* 1788275 */   GIM_Try, /*On fail goto*//*Label 24298*/ GIMT_Encode4(1788361), // Rule ID 12003 //
     /* 1788280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1788288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1788291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1788294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1788297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788326 */     // MIs[0] policy
     /* 1788326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788336 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1788339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788360 */     // GIR_Coverage, 12003,
     /* 1788360 */     GIR_EraseRootFromParent_Done,
     /* 1788361 */   // Label 24298: @1788361
     /* 1788361 */   GIM_Try, /*On fail goto*//*Label 24299*/ GIMT_Encode4(1788447), // Rule ID 12006 //
     /* 1788366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1788374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1788377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1788380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1788383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788412 */     // MIs[0] policy
     /* 1788412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788422 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1788425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788446 */     // GIR_Coverage, 12006,
     /* 1788446 */     GIR_EraseRootFromParent_Done,
     /* 1788447 */   // Label 24299: @1788447
     /* 1788447 */   GIM_Try, /*On fail goto*//*Label 24300*/ GIMT_Encode4(1788533), // Rule ID 12007 //
     /* 1788452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1788460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1788463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1788466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1788469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788498 */     // MIs[0] policy
     /* 1788498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788508 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1788511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788532 */     // GIR_Coverage, 12007,
     /* 1788532 */     GIR_EraseRootFromParent_Done,
     /* 1788533 */   // Label 24300: @1788533
     /* 1788533 */   GIM_Try, /*On fail goto*//*Label 24301*/ GIMT_Encode4(1788619), // Rule ID 12010 //
     /* 1788538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1788549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1788552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1788555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1788558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1788561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788584 */     // MIs[0] policy
     /* 1788584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788594 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1788597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788618 */     // GIR_Coverage, 12010,
     /* 1788618 */     GIR_EraseRootFromParent_Done,
     /* 1788619 */   // Label 24301: @1788619
     /* 1788619 */   GIM_Try, /*On fail goto*//*Label 24302*/ GIMT_Encode4(1788705), // Rule ID 12011 //
     /* 1788624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1788635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1788638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1788641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1788644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1788647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788670 */     // MIs[0] policy
     /* 1788670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788680 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1788683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788704 */     // GIR_Coverage, 12011,
     /* 1788704 */     GIR_EraseRootFromParent_Done,
     /* 1788705 */   // Label 24302: @1788705
     /* 1788705 */   GIM_Try, /*On fail goto*//*Label 24303*/ GIMT_Encode4(1788791), // Rule ID 12014 //
     /* 1788710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1788721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1788724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1788727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1788730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788756 */     // MIs[0] policy
     /* 1788756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788766 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1788769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788790 */     // GIR_Coverage, 12014,
     /* 1788790 */     GIR_EraseRootFromParent_Done,
     /* 1788791 */   // Label 24303: @1788791
     /* 1788791 */   GIM_Try, /*On fail goto*//*Label 24304*/ GIMT_Encode4(1788877), // Rule ID 12015 //
     /* 1788796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1788807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1788810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1788813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1788816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788842 */     // MIs[0] policy
     /* 1788842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788852 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1788855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788876 */     // GIR_Coverage, 12015,
     /* 1788876 */     GIR_EraseRootFromParent_Done,
     /* 1788877 */   // Label 24304: @1788877
     /* 1788877 */   GIM_Try, /*On fail goto*//*Label 24305*/ GIMT_Encode4(1788963), // Rule ID 12018 //
     /* 1788882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1788893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1788896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1788899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1788902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788928 */     // MIs[0] policy
     /* 1788928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788938 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1788941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788962 */     // GIR_Coverage, 12018,
     /* 1788962 */     GIR_EraseRootFromParent_Done,
     /* 1788963 */   // Label 24305: @1788963
     /* 1788963 */   GIM_Try, /*On fail goto*//*Label 24306*/ GIMT_Encode4(1789049), // Rule ID 12019 //
     /* 1788968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1788979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1788982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1788985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1788988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789014 */     // MIs[0] policy
     /* 1789014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789024 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1789027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789048 */     // GIR_Coverage, 12019,
     /* 1789048 */     GIR_EraseRootFromParent_Done,
     /* 1789049 */   // Label 24306: @1789049
     /* 1789049 */   GIM_Try, /*On fail goto*//*Label 24307*/ GIMT_Encode4(1789135), // Rule ID 12022 //
     /* 1789054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1789065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1789068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1789071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1789074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789100 */     // MIs[0] policy
     /* 1789100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789110 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1789113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789134 */     // GIR_Coverage, 12022,
     /* 1789134 */     GIR_EraseRootFromParent_Done,
     /* 1789135 */   // Label 24307: @1789135
     /* 1789135 */   GIM_Try, /*On fail goto*//*Label 24308*/ GIMT_Encode4(1789221), // Rule ID 12023 //
     /* 1789140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1789151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1789154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1789157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1789160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789186 */     // MIs[0] policy
     /* 1789186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789196 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1789199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789220 */     // GIR_Coverage, 12023,
     /* 1789220 */     GIR_EraseRootFromParent_Done,
     /* 1789221 */   // Label 24308: @1789221
     /* 1789221 */   GIM_Try, /*On fail goto*//*Label 24309*/ GIMT_Encode4(1789307), // Rule ID 12026 //
     /* 1789226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1789237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1789240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1789243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1789246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789272 */     // MIs[0] policy
     /* 1789272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789282 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1789285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789306 */     // GIR_Coverage, 12026,
     /* 1789306 */     GIR_EraseRootFromParent_Done,
     /* 1789307 */   // Label 24309: @1789307
     /* 1789307 */   GIM_Try, /*On fail goto*//*Label 24310*/ GIMT_Encode4(1789393), // Rule ID 12027 //
     /* 1789312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1789323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1789326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1789329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1789332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789358 */     // MIs[0] policy
     /* 1789358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789368 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1789371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789392 */     // GIR_Coverage, 12027,
     /* 1789392 */     GIR_EraseRootFromParent_Done,
     /* 1789393 */   // Label 24310: @1789393
     /* 1789393 */   GIM_Try, /*On fail goto*//*Label 24311*/ GIMT_Encode4(1789479), // Rule ID 12030 //
     /* 1789398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1789409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1789412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1789415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1789418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789444 */     // MIs[0] policy
     /* 1789444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789454 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1789457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789478 */     // GIR_Coverage, 12030,
     /* 1789478 */     GIR_EraseRootFromParent_Done,
     /* 1789479 */   // Label 24311: @1789479
     /* 1789479 */   GIM_Try, /*On fail goto*//*Label 24312*/ GIMT_Encode4(1789565), // Rule ID 12031 //
     /* 1789484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1789495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1789498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1789501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1789504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789530 */     // MIs[0] policy
     /* 1789530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789540 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1789543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789564 */     // GIR_Coverage, 12031,
     /* 1789564 */     GIR_EraseRootFromParent_Done,
     /* 1789565 */   // Label 24312: @1789565
     /* 1789565 */   GIM_Try, /*On fail goto*//*Label 24313*/ GIMT_Encode4(1789651), // Rule ID 12034 //
     /* 1789570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1789581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1789584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1789587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1789590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789616 */     // MIs[0] policy
     /* 1789616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789626 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1789629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789650 */     // GIR_Coverage, 12034,
     /* 1789650 */     GIR_EraseRootFromParent_Done,
     /* 1789651 */   // Label 24313: @1789651
     /* 1789651 */   GIM_Try, /*On fail goto*//*Label 24314*/ GIMT_Encode4(1789737), // Rule ID 12035 //
     /* 1789656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1789667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1789670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1789673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1789676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789702 */     // MIs[0] policy
     /* 1789702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789712 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1789715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789736 */     // GIR_Coverage, 12035,
     /* 1789736 */     GIR_EraseRootFromParent_Done,
     /* 1789737 */   // Label 24314: @1789737
     /* 1789737 */   GIM_Try, /*On fail goto*//*Label 24315*/ GIMT_Encode4(1789823), // Rule ID 12038 //
     /* 1789742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1789753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1789756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1789759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1789762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789788 */     // MIs[0] policy
     /* 1789788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789798 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1789801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789822 */     // GIR_Coverage, 12038,
     /* 1789822 */     GIR_EraseRootFromParent_Done,
     /* 1789823 */   // Label 24315: @1789823
     /* 1789823 */   GIM_Try, /*On fail goto*//*Label 24316*/ GIMT_Encode4(1789909), // Rule ID 12039 //
     /* 1789828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1789839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1789842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1789845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1789848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789874 */     // MIs[0] policy
     /* 1789874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789884 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1789887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789908 */     // GIR_Coverage, 12039,
     /* 1789908 */     GIR_EraseRootFromParent_Done,
     /* 1789909 */   // Label 24316: @1789909
     /* 1789909 */   GIM_Try, /*On fail goto*//*Label 24317*/ GIMT_Encode4(1789995), // Rule ID 12042 //
     /* 1789914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1789925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1789928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1789931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1789934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789960 */     // MIs[0] policy
     /* 1789960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1789973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789994 */     // GIR_Coverage, 12042,
     /* 1789994 */     GIR_EraseRootFromParent_Done,
     /* 1789995 */   // Label 24317: @1789995
     /* 1789995 */   GIM_Try, /*On fail goto*//*Label 24318*/ GIMT_Encode4(1790081), // Rule ID 12043 //
     /* 1790000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1790011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1790014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1790017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1790020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790046 */     // MIs[0] policy
     /* 1790046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790056 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1790059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1790077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790080 */     // GIR_Coverage, 12043,
     /* 1790080 */     GIR_EraseRootFromParent_Done,
     /* 1790081 */   // Label 24318: @1790081
     /* 1790081 */   GIM_Try, /*On fail goto*//*Label 24319*/ GIMT_Encode4(1790167), // Rule ID 12046 //
     /* 1790086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1790089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1790097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1790100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1790103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1790106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790132 */     // MIs[0] policy
     /* 1790132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790142 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1790145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790166 */     // GIR_Coverage, 12046,
     /* 1790166 */     GIR_EraseRootFromParent_Done,
     /* 1790167 */   // Label 24319: @1790167
     /* 1790167 */   GIM_Try, /*On fail goto*//*Label 24320*/ GIMT_Encode4(1790253), // Rule ID 12047 //
     /* 1790172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1790175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1790183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1790186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1790189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1790192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790218 */     // MIs[0] policy
     /* 1790218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790228 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1790231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790252 */     // GIR_Coverage, 12047,
     /* 1790252 */     GIR_EraseRootFromParent_Done,
     /* 1790253 */   // Label 24320: @1790253
     /* 1790253 */   GIM_Try, /*On fail goto*//*Label 24321*/ GIMT_Encode4(1790339), // Rule ID 12050 //
     /* 1790258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1790269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1790272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1790275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1790278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790304 */     // MIs[0] policy
     /* 1790304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790314 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1790317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790338 */     // GIR_Coverage, 12050,
     /* 1790338 */     GIR_EraseRootFromParent_Done,
     /* 1790339 */   // Label 24321: @1790339
     /* 1790339 */   GIM_Try, /*On fail goto*//*Label 24322*/ GIMT_Encode4(1790425), // Rule ID 12051 //
     /* 1790344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1790355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1790358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1790361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1790364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790390 */     // MIs[0] policy
     /* 1790390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790400 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1790403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790424 */     // GIR_Coverage, 12051,
     /* 1790424 */     GIR_EraseRootFromParent_Done,
     /* 1790425 */   // Label 24322: @1790425
     /* 1790425 */   GIM_Try, /*On fail goto*//*Label 24323*/ GIMT_Encode4(1790511), // Rule ID 12054 //
     /* 1790430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1790441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1790444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1790447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1790450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1790453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790476 */     // MIs[0] policy
     /* 1790476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790486 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1790489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790510 */     // GIR_Coverage, 12054,
     /* 1790510 */     GIR_EraseRootFromParent_Done,
     /* 1790511 */   // Label 24323: @1790511
     /* 1790511 */   GIM_Try, /*On fail goto*//*Label 24324*/ GIMT_Encode4(1790597), // Rule ID 12055 //
     /* 1790516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1790527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1790530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1790533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1790536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1790539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790562 */     // MIs[0] policy
     /* 1790562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790572 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1790575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790596 */     // GIR_Coverage, 12055,
     /* 1790596 */     GIR_EraseRootFromParent_Done,
     /* 1790597 */   // Label 24324: @1790597
     /* 1790597 */   GIM_Try, /*On fail goto*//*Label 24325*/ GIMT_Encode4(1790683), // Rule ID 12058 //
     /* 1790602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1790613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1790616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1790619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1790622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1790625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1790632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790648 */     // MIs[0] policy
     /* 1790648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790658 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1790661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790682 */     // GIR_Coverage, 12058,
     /* 1790682 */     GIR_EraseRootFromParent_Done,
     /* 1790683 */   // Label 24325: @1790683
     /* 1790683 */   GIM_Try, /*On fail goto*//*Label 24326*/ GIMT_Encode4(1790769), // Rule ID 12059 //
     /* 1790688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1790699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1790702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1790705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1790708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1790711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1790718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790734 */     // MIs[0] policy
     /* 1790734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790744 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1790747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790768 */     // GIR_Coverage, 12059,
     /* 1790768 */     GIR_EraseRootFromParent_Done,
     /* 1790769 */   // Label 24326: @1790769
     /* 1790769 */   GIM_Try, /*On fail goto*//*Label 24327*/ GIMT_Encode4(1790855), // Rule ID 12062 //
     /* 1790774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1790785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1790788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1790791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1790794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1790797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790820 */     // MIs[0] policy
     /* 1790820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790830 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1790833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790854 */     // GIR_Coverage, 12062,
     /* 1790854 */     GIR_EraseRootFromParent_Done,
     /* 1790855 */   // Label 24327: @1790855
     /* 1790855 */   GIM_Try, /*On fail goto*//*Label 24328*/ GIMT_Encode4(1790941), // Rule ID 12063 //
     /* 1790860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1790871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1790874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1790877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1790880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1790883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790906 */     // MIs[0] policy
     /* 1790906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790916 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1790919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790940 */     // GIR_Coverage, 12063,
     /* 1790940 */     GIR_EraseRootFromParent_Done,
     /* 1790941 */   // Label 24328: @1790941
     /* 1790941 */   GIM_Try, /*On fail goto*//*Label 24329*/ GIMT_Encode4(1791027), // Rule ID 12066 //
     /* 1790946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1790957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1790960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1790963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1790966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790992 */     // MIs[0] policy
     /* 1790992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791002 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1791005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791026 */     // GIR_Coverage, 12066,
     /* 1791026 */     GIR_EraseRootFromParent_Done,
     /* 1791027 */   // Label 24329: @1791027
     /* 1791027 */   GIM_Try, /*On fail goto*//*Label 24330*/ GIMT_Encode4(1791113), // Rule ID 12067 //
     /* 1791032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1791043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1791046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1791049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1791052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791078 */     // MIs[0] policy
     /* 1791078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791088 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1791091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791112 */     // GIR_Coverage, 12067,
     /* 1791112 */     GIR_EraseRootFromParent_Done,
     /* 1791113 */   // Label 24330: @1791113
     /* 1791113 */   GIM_Try, /*On fail goto*//*Label 24331*/ GIMT_Encode4(1791199), // Rule ID 12070 //
     /* 1791118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1791129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1791132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1791135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1791138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1791141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791164 */     // MIs[0] policy
     /* 1791164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791174 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1791177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791198 */     // GIR_Coverage, 12070,
     /* 1791198 */     GIR_EraseRootFromParent_Done,
     /* 1791199 */   // Label 24331: @1791199
     /* 1791199 */   GIM_Try, /*On fail goto*//*Label 24332*/ GIMT_Encode4(1791285), // Rule ID 12071 //
     /* 1791204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1791215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1791218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1791221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1791224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1791227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791250 */     // MIs[0] policy
     /* 1791250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791260 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1791263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791284 */     // GIR_Coverage, 12071,
     /* 1791284 */     GIR_EraseRootFromParent_Done,
     /* 1791285 */   // Label 24332: @1791285
     /* 1791285 */   GIM_Try, /*On fail goto*//*Label 24333*/ GIMT_Encode4(1791371), // Rule ID 12074 //
     /* 1791290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1791301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1791304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1791307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1791310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791336 */     // MIs[0] policy
     /* 1791336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1791349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791370 */     // GIR_Coverage, 12074,
     /* 1791370 */     GIR_EraseRootFromParent_Done,
     /* 1791371 */   // Label 24333: @1791371
     /* 1791371 */   GIM_Try, /*On fail goto*//*Label 24334*/ GIMT_Encode4(1791457), // Rule ID 12075 //
     /* 1791376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1791387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1791390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1791393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1791396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791422 */     // MIs[0] policy
     /* 1791422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1791435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791456 */     // GIR_Coverage, 12075,
     /* 1791456 */     GIR_EraseRootFromParent_Done,
     /* 1791457 */   // Label 24334: @1791457
     /* 1791457 */   GIM_Try, /*On fail goto*//*Label 24335*/ GIMT_Encode4(1791543), // Rule ID 12078 //
     /* 1791462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1791473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1791476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1791479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1791482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791508 */     // MIs[0] policy
     /* 1791508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1791521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791542 */     // GIR_Coverage, 12078,
     /* 1791542 */     GIR_EraseRootFromParent_Done,
     /* 1791543 */   // Label 24335: @1791543
     /* 1791543 */   GIM_Try, /*On fail goto*//*Label 24336*/ GIMT_Encode4(1791629), // Rule ID 12079 //
     /* 1791548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1791559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1791562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1791565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1791568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791594 */     // MIs[0] policy
     /* 1791594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791604 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1791607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791628 */     // GIR_Coverage, 12079,
     /* 1791628 */     GIR_EraseRootFromParent_Done,
     /* 1791629 */   // Label 24336: @1791629
     /* 1791629 */   GIM_Try, /*On fail goto*//*Label 24337*/ GIMT_Encode4(1791715), // Rule ID 12082 //
     /* 1791634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1791645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1791648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1791651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1791654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791680 */     // MIs[0] policy
     /* 1791680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791690 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1791693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791714 */     // GIR_Coverage, 12082,
     /* 1791714 */     GIR_EraseRootFromParent_Done,
     /* 1791715 */   // Label 24337: @1791715
     /* 1791715 */   GIM_Try, /*On fail goto*//*Label 24338*/ GIMT_Encode4(1791801), // Rule ID 12083 //
     /* 1791720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1791731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1791734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1791737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1791740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791766 */     // MIs[0] policy
     /* 1791766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791776 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1791779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791800 */     // GIR_Coverage, 12083,
     /* 1791800 */     GIR_EraseRootFromParent_Done,
     /* 1791801 */   // Label 24338: @1791801
     /* 1791801 */   GIM_Try, /*On fail goto*//*Label 24339*/ GIMT_Encode4(1791887), // Rule ID 12086 //
     /* 1791806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1791809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1791817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1791820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1791823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1791826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1791829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791852 */     // MIs[0] policy
     /* 1791852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791862 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1791865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1791883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791886 */     // GIR_Coverage, 12086,
     /* 1791886 */     GIR_EraseRootFromParent_Done,
     /* 1791887 */   // Label 24339: @1791887
     /* 1791887 */   GIM_Try, /*On fail goto*//*Label 24340*/ GIMT_Encode4(1791973), // Rule ID 12087 //
     /* 1791892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1791895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1791903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1791906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1791909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1791912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1791915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791938 */     // MIs[0] policy
     /* 1791938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791948 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1791951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1791969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791972 */     // GIR_Coverage, 12087,
     /* 1791972 */     GIR_EraseRootFromParent_Done,
     /* 1791973 */   // Label 24340: @1791973
     /* 1791973 */   GIM_Try, /*On fail goto*//*Label 24341*/ GIMT_Encode4(1792059), // Rule ID 12090 //
     /* 1791978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1791981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1791989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1791992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1791995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1791998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792024 */     // MIs[0] policy
     /* 1792024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792034 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1792037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792058 */     // GIR_Coverage, 12090,
     /* 1792058 */     GIR_EraseRootFromParent_Done,
     /* 1792059 */   // Label 24341: @1792059
     /* 1792059 */   GIM_Try, /*On fail goto*//*Label 24342*/ GIMT_Encode4(1792145), // Rule ID 12091 //
     /* 1792064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1792075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1792078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1792081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1792084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792110 */     // MIs[0] policy
     /* 1792110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792120 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1792123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792144 */     // GIR_Coverage, 12091,
     /* 1792144 */     GIR_EraseRootFromParent_Done,
     /* 1792145 */   // Label 24342: @1792145
     /* 1792145 */   GIM_Try, /*On fail goto*//*Label 24343*/ GIMT_Encode4(1792231), // Rule ID 12094 //
     /* 1792150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1792153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1792161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1792164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1792167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1792170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792196 */     // MIs[0] policy
     /* 1792196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792206 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1792209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792230 */     // GIR_Coverage, 12094,
     /* 1792230 */     GIR_EraseRootFromParent_Done,
     /* 1792231 */   // Label 24343: @1792231
     /* 1792231 */   GIM_Try, /*On fail goto*//*Label 24344*/ GIMT_Encode4(1792317), // Rule ID 12095 //
     /* 1792236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1792247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1792250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1792253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1792256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792282 */     // MIs[0] policy
     /* 1792282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792292 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1792295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792316 */     // GIR_Coverage, 12095,
     /* 1792316 */     GIR_EraseRootFromParent_Done,
     /* 1792317 */   // Label 24344: @1792317
     /* 1792317 */   GIM_Try, /*On fail goto*//*Label 24345*/ GIMT_Encode4(1792403), // Rule ID 12098 //
     /* 1792322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1792333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1792336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1792339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792368 */     // MIs[0] policy
     /* 1792368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792378 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1792381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792402 */     // GIR_Coverage, 12098,
     /* 1792402 */     GIR_EraseRootFromParent_Done,
     /* 1792403 */   // Label 24345: @1792403
     /* 1792403 */   GIM_Try, /*On fail goto*//*Label 24346*/ GIMT_Encode4(1792489), // Rule ID 12099 //
     /* 1792408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1792419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1792422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1792425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792454 */     // MIs[0] policy
     /* 1792454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792464 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1792467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792488 */     // GIR_Coverage, 12099,
     /* 1792488 */     GIR_EraseRootFromParent_Done,
     /* 1792489 */   // Label 24346: @1792489
     /* 1792489 */   GIM_Try, /*On fail goto*//*Label 24347*/ GIMT_Encode4(1792575), // Rule ID 12102 //
     /* 1792494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1792505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1792508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1792511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792540 */     // MIs[0] policy
     /* 1792540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792550 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1792553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792574 */     // GIR_Coverage, 12102,
     /* 1792574 */     GIR_EraseRootFromParent_Done,
     /* 1792575 */   // Label 24347: @1792575
     /* 1792575 */   GIM_Try, /*On fail goto*//*Label 24348*/ GIMT_Encode4(1792661), // Rule ID 12103 //
     /* 1792580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1792591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1792594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1792597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792626 */     // MIs[0] policy
     /* 1792626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792636 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1792639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792660 */     // GIR_Coverage, 12103,
     /* 1792660 */     GIR_EraseRootFromParent_Done,
     /* 1792661 */   // Label 24348: @1792661
     /* 1792661 */   GIM_Try, /*On fail goto*//*Label 24349*/ GIMT_Encode4(1792747), // Rule ID 12106 //
     /* 1792666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1792677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1792680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1792683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792712 */     // MIs[0] policy
     /* 1792712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792722 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1792725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792746 */     // GIR_Coverage, 12106,
     /* 1792746 */     GIR_EraseRootFromParent_Done,
     /* 1792747 */   // Label 24349: @1792747
     /* 1792747 */   GIM_Try, /*On fail goto*//*Label 24350*/ GIMT_Encode4(1792833), // Rule ID 12107 //
     /* 1792752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1792763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1792766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1792769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792798 */     // MIs[0] policy
     /* 1792798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792808 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1792811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792832 */     // GIR_Coverage, 12107,
     /* 1792832 */     GIR_EraseRootFromParent_Done,
     /* 1792833 */   // Label 24350: @1792833
     /* 1792833 */   GIM_Try, /*On fail goto*//*Label 24351*/ GIMT_Encode4(1792919), // Rule ID 12110 //
     /* 1792838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1792849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1792852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1792855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792884 */     // MIs[0] policy
     /* 1792884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792894 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1792897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792918 */     // GIR_Coverage, 12110,
     /* 1792918 */     GIR_EraseRootFromParent_Done,
     /* 1792919 */   // Label 24351: @1792919
     /* 1792919 */   GIM_Try, /*On fail goto*//*Label 24352*/ GIMT_Encode4(1793005), // Rule ID 12111 //
     /* 1792924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1792935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1792938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1792941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792970 */     // MIs[0] policy
     /* 1792970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792980 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1792983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793004 */     // GIR_Coverage, 12111,
     /* 1793004 */     GIR_EraseRootFromParent_Done,
     /* 1793005 */   // Label 24352: @1793005
     /* 1793005 */   GIM_Try, /*On fail goto*//*Label 24353*/ GIMT_Encode4(1793091), // Rule ID 12114 //
     /* 1793010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1793018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1793021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1793024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1793027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793056 */     // MIs[0] policy
     /* 1793056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793066 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1793069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793090 */     // GIR_Coverage, 12114,
     /* 1793090 */     GIR_EraseRootFromParent_Done,
     /* 1793091 */   // Label 24353: @1793091
     /* 1793091 */   GIM_Try, /*On fail goto*//*Label 24354*/ GIMT_Encode4(1793177), // Rule ID 12115 //
     /* 1793096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1793104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1793107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1793110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1793113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793142 */     // MIs[0] policy
     /* 1793142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793152 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1793155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793176 */     // GIR_Coverage, 12115,
     /* 1793176 */     GIR_EraseRootFromParent_Done,
     /* 1793177 */   // Label 24354: @1793177
     /* 1793177 */   GIM_Try, /*On fail goto*//*Label 24355*/ GIMT_Encode4(1793263), // Rule ID 12118 //
     /* 1793182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1793190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1793193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1793196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1793199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793228 */     // MIs[0] policy
     /* 1793228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793238 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1793241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793262 */     // GIR_Coverage, 12118,
     /* 1793262 */     GIR_EraseRootFromParent_Done,
     /* 1793263 */   // Label 24355: @1793263
     /* 1793263 */   GIM_Try, /*On fail goto*//*Label 24356*/ GIMT_Encode4(1793349), // Rule ID 12119 //
     /* 1793268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1793276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1793279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1793282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1793285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793314 */     // MIs[0] policy
     /* 1793314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793324 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1793327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793348 */     // GIR_Coverage, 12119,
     /* 1793348 */     GIR_EraseRootFromParent_Done,
     /* 1793349 */   // Label 24356: @1793349
     /* 1793349 */   GIM_Try, /*On fail goto*//*Label 24357*/ GIMT_Encode4(1793435), // Rule ID 12122 //
     /* 1793354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1793362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1793365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1793368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1793371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793400 */     // MIs[0] policy
     /* 1793400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793410 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1793413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793434 */     // GIR_Coverage, 12122,
     /* 1793434 */     GIR_EraseRootFromParent_Done,
     /* 1793435 */   // Label 24357: @1793435
     /* 1793435 */   GIM_Try, /*On fail goto*//*Label 24358*/ GIMT_Encode4(1793521), // Rule ID 12123 //
     /* 1793440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1793448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1793451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1793454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1793457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793486 */     // MIs[0] policy
     /* 1793486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793496 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1793499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793520 */     // GIR_Coverage, 12123,
     /* 1793520 */     GIR_EraseRootFromParent_Done,
     /* 1793521 */   // Label 24358: @1793521
     /* 1793521 */   GIM_Try, /*On fail goto*//*Label 24359*/ GIMT_Encode4(1793607), // Rule ID 12126 //
     /* 1793526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1793534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1793537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1793540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1793543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793572 */     // MIs[0] policy
     /* 1793572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793582 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1793585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793606 */     // GIR_Coverage, 12126,
     /* 1793606 */     GIR_EraseRootFromParent_Done,
     /* 1793607 */   // Label 24359: @1793607
     /* 1793607 */   GIM_Try, /*On fail goto*//*Label 24360*/ GIMT_Encode4(1793693), // Rule ID 12127 //
     /* 1793612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1793620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1793623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1793626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1793629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793658 */     // MIs[0] policy
     /* 1793658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1793671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793692 */     // GIR_Coverage, 12127,
     /* 1793692 */     GIR_EraseRootFromParent_Done,
     /* 1793693 */   // Label 24360: @1793693
     /* 1793693 */   GIM_Try, /*On fail goto*//*Label 24361*/ GIMT_Encode4(1793779), // Rule ID 12130 //
     /* 1793698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1793706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1793709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1793712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1793715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793744 */     // MIs[0] policy
     /* 1793744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793754 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1793757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793778 */     // GIR_Coverage, 12130,
     /* 1793778 */     GIR_EraseRootFromParent_Done,
     /* 1793779 */   // Label 24361: @1793779
     /* 1793779 */   GIM_Try, /*On fail goto*//*Label 24362*/ GIMT_Encode4(1793865), // Rule ID 12131 //
     /* 1793784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1793792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1793795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1793798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1793801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793830 */     // MIs[0] policy
     /* 1793830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1793843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793864 */     // GIR_Coverage, 12131,
     /* 1793864 */     GIR_EraseRootFromParent_Done,
     /* 1793865 */   // Label 24362: @1793865
     /* 1793865 */   GIM_Try, /*On fail goto*//*Label 24363*/ GIMT_Encode4(1793951), // Rule ID 12134 //
     /* 1793870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1793873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1793878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1793881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1793884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1793887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793916 */     // MIs[0] policy
     /* 1793916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793926 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1793929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793950 */     // GIR_Coverage, 12134,
     /* 1793950 */     GIR_EraseRootFromParent_Done,
     /* 1793951 */   // Label 24363: @1793951
     /* 1793951 */   GIM_Try, /*On fail goto*//*Label 24364*/ GIMT_Encode4(1794037), // Rule ID 12135 //
     /* 1793956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1793959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1793964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1793967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1793970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1793973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794002 */     // MIs[0] policy
     /* 1794002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794012 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1794015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1794033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794036 */     // GIR_Coverage, 12135,
     /* 1794036 */     GIR_EraseRootFromParent_Done,
     /* 1794037 */   // Label 24364: @1794037
     /* 1794037 */   GIM_Try, /*On fail goto*//*Label 24365*/ GIMT_Encode4(1794123), // Rule ID 12138 //
     /* 1794042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1794050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1794053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1794056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1794059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1794062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794088 */     // MIs[0] policy
     /* 1794088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794098 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1794101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794122 */     // GIR_Coverage, 12138,
     /* 1794122 */     GIR_EraseRootFromParent_Done,
     /* 1794123 */   // Label 24365: @1794123
     /* 1794123 */   GIM_Try, /*On fail goto*//*Label 24366*/ GIMT_Encode4(1794209), // Rule ID 12139 //
     /* 1794128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1794136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1794139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1794142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1794145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1794148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794174 */     // MIs[0] policy
     /* 1794174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794184 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1794187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794208 */     // GIR_Coverage, 12139,
     /* 1794208 */     GIR_EraseRootFromParent_Done,
     /* 1794209 */   // Label 24366: @1794209
     /* 1794209 */   GIM_Try, /*On fail goto*//*Label 24367*/ GIMT_Encode4(1794295), // Rule ID 12142 //
     /* 1794214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1794222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1794225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1794228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1794231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1794234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794260 */     // MIs[0] policy
     /* 1794260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794270 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1794273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794294 */     // GIR_Coverage, 12142,
     /* 1794294 */     GIR_EraseRootFromParent_Done,
     /* 1794295 */   // Label 24367: @1794295
     /* 1794295 */   GIM_Try, /*On fail goto*//*Label 24368*/ GIMT_Encode4(1794381), // Rule ID 12143 //
     /* 1794300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1794308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1794311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1794314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1794317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1794320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794346 */     // MIs[0] policy
     /* 1794346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794356 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1794359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794380 */     // GIR_Coverage, 12143,
     /* 1794380 */     GIR_EraseRootFromParent_Done,
     /* 1794381 */   // Label 24368: @1794381
     /* 1794381 */   GIM_Try, /*On fail goto*//*Label 24369*/ GIMT_Encode4(1794467), // Rule ID 12146 //
     /* 1794386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1794394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1794397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1794400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1794403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1794406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1794409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794432 */     // MIs[0] policy
     /* 1794432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794442 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1794445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794466 */     // GIR_Coverage, 12146,
     /* 1794466 */     GIR_EraseRootFromParent_Done,
     /* 1794467 */   // Label 24369: @1794467
     /* 1794467 */   GIM_Try, /*On fail goto*//*Label 24370*/ GIMT_Encode4(1794553), // Rule ID 12147 //
     /* 1794472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1794480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1794483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1794486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1794489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1794492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1794495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794518 */     // MIs[0] policy
     /* 1794518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794528 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1794531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794552 */     // GIR_Coverage, 12147,
     /* 1794552 */     GIR_EraseRootFromParent_Done,
     /* 1794553 */   // Label 24370: @1794553
     /* 1794553 */   GIM_Try, /*On fail goto*//*Label 24371*/ GIMT_Encode4(1794639), // Rule ID 12150 //
     /* 1794558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1794566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1794569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1794572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1794575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1794578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794604 */     // MIs[0] policy
     /* 1794604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794614 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1794617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794638 */     // GIR_Coverage, 12150,
     /* 1794638 */     GIR_EraseRootFromParent_Done,
     /* 1794639 */   // Label 24371: @1794639
     /* 1794639 */   GIM_Try, /*On fail goto*//*Label 24372*/ GIMT_Encode4(1794725), // Rule ID 12151 //
     /* 1794644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1794652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1794655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1794658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1794661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1794664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794690 */     // MIs[0] policy
     /* 1794690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794700 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1794703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794724 */     // GIR_Coverage, 12151,
     /* 1794724 */     GIR_EraseRootFromParent_Done,
     /* 1794725 */   // Label 24372: @1794725
     /* 1794725 */   GIM_Try, /*On fail goto*//*Label 24373*/ GIMT_Encode4(1794811), // Rule ID 12154 //
     /* 1794730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1794738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1794741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1794744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1794747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1794750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794776 */     // MIs[0] policy
     /* 1794776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794786 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1794789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794810 */     // GIR_Coverage, 12154,
     /* 1794810 */     GIR_EraseRootFromParent_Done,
     /* 1794811 */   // Label 24373: @1794811
     /* 1794811 */   GIM_Try, /*On fail goto*//*Label 24374*/ GIMT_Encode4(1794897), // Rule ID 12155 //
     /* 1794816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1794824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1794827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1794830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1794833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1794836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794862 */     // MIs[0] policy
     /* 1794862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794872 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1794875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794896 */     // GIR_Coverage, 12155,
     /* 1794896 */     GIR_EraseRootFromParent_Done,
     /* 1794897 */   // Label 24374: @1794897
     /* 1794897 */   GIM_Try, /*On fail goto*//*Label 24375*/ GIMT_Encode4(1794983), // Rule ID 12158 //
     /* 1794902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1794910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1794913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1794916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1794919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1794922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794948 */     // MIs[0] policy
     /* 1794948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794958 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1794961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794982 */     // GIR_Coverage, 12158,
     /* 1794982 */     GIR_EraseRootFromParent_Done,
     /* 1794983 */   // Label 24375: @1794983
     /* 1794983 */   GIM_Try, /*On fail goto*//*Label 24376*/ GIMT_Encode4(1795069), // Rule ID 12159 //
     /* 1794988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1794996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1794999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1795002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1795005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1795008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1795011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795034 */     // MIs[0] policy
     /* 1795034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795044 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1795047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795068 */     // GIR_Coverage, 12159,
     /* 1795068 */     GIR_EraseRootFromParent_Done,
     /* 1795069 */   // Label 24376: @1795069
     /* 1795069 */   GIM_Try, /*On fail goto*//*Label 24377*/ GIMT_Encode4(1795155), // Rule ID 12162 //
     /* 1795074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1795082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1795085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1795088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1795094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795120 */     // MIs[0] policy
     /* 1795120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795130 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1795133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795154 */     // GIR_Coverage, 12162,
     /* 1795154 */     GIR_EraseRootFromParent_Done,
     /* 1795155 */   // Label 24377: @1795155
     /* 1795155 */   GIM_Try, /*On fail goto*//*Label 24378*/ GIMT_Encode4(1795241), // Rule ID 12163 //
     /* 1795160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1795168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1795171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1795174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1795180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795206 */     // MIs[0] policy
     /* 1795206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1795219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795240 */     // GIR_Coverage, 12163,
     /* 1795240 */     GIR_EraseRootFromParent_Done,
     /* 1795241 */   // Label 24378: @1795241
     /* 1795241 */   GIM_Try, /*On fail goto*//*Label 24379*/ GIMT_Encode4(1795327), // Rule ID 12166 //
     /* 1795246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1795254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1795257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1795260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1795263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1795266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795292 */     // MIs[0] policy
     /* 1795292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1795305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795326 */     // GIR_Coverage, 12166,
     /* 1795326 */     GIR_EraseRootFromParent_Done,
     /* 1795327 */   // Label 24379: @1795327
     /* 1795327 */   GIM_Try, /*On fail goto*//*Label 24380*/ GIMT_Encode4(1795413), // Rule ID 12167 //
     /* 1795332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1795340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1795343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1795346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1795349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1795352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795378 */     // MIs[0] policy
     /* 1795378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795388 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1795391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795412 */     // GIR_Coverage, 12167,
     /* 1795412 */     GIR_EraseRootFromParent_Done,
     /* 1795413 */   // Label 24380: @1795413
     /* 1795413 */   GIM_Try, /*On fail goto*//*Label 24381*/ GIMT_Encode4(1795499), // Rule ID 12170 //
     /* 1795418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1795426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1795429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1795432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1795435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1795438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795464 */     // MIs[0] policy
     /* 1795464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795474 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1795477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795498 */     // GIR_Coverage, 12170,
     /* 1795498 */     GIR_EraseRootFromParent_Done,
     /* 1795499 */   // Label 24381: @1795499
     /* 1795499 */   GIM_Try, /*On fail goto*//*Label 24382*/ GIMT_Encode4(1795585), // Rule ID 12171 //
     /* 1795504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1795512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1795515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1795518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1795521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1795524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795550 */     // MIs[0] policy
     /* 1795550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795560 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1795563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795584 */     // GIR_Coverage, 12171,
     /* 1795584 */     GIR_EraseRootFromParent_Done,
     /* 1795585 */   // Label 24382: @1795585
     /* 1795585 */   GIM_Try, /*On fail goto*//*Label 24383*/ GIMT_Encode4(1795671), // Rule ID 12174 //
     /* 1795590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1795593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1795598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1795601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1795604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1795607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1795610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1795613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795636 */     // MIs[0] policy
     /* 1795636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1795649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795670 */     // GIR_Coverage, 12174,
     /* 1795670 */     GIR_EraseRootFromParent_Done,
     /* 1795671 */   // Label 24383: @1795671
     /* 1795671 */   GIM_Try, /*On fail goto*//*Label 24384*/ GIMT_Encode4(1795757), // Rule ID 12175 //
     /* 1795676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1795679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1795684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1795687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1795690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1795693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1795696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1795699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795722 */     // MIs[0] policy
     /* 1795722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795732 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1795735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795756 */     // GIR_Coverage, 12175,
     /* 1795756 */     GIR_EraseRootFromParent_Done,
     /* 1795757 */   // Label 24384: @1795757
     /* 1795757 */   GIM_Try, /*On fail goto*//*Label 24385*/ GIMT_Encode4(1795843), // Rule ID 12178 //
     /* 1795762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1795765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1795770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1795773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1795776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1795779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1795782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795808 */     // MIs[0] policy
     /* 1795808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795818 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1795821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795842 */     // GIR_Coverage, 12178,
     /* 1795842 */     GIR_EraseRootFromParent_Done,
     /* 1795843 */   // Label 24385: @1795843
     /* 1795843 */   GIM_Try, /*On fail goto*//*Label 24386*/ GIMT_Encode4(1795929), // Rule ID 12179 //
     /* 1795848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1795851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1795856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1795859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1795862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1795865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1795868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795894 */     // MIs[0] policy
     /* 1795894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795904 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1795907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795928 */     // GIR_Coverage, 12179,
     /* 1795928 */     GIR_EraseRootFromParent_Done,
     /* 1795929 */   // Label 24386: @1795929
     /* 1795929 */   GIM_Try, /*On fail goto*//*Label 24387*/ GIMT_Encode4(1796015), // Rule ID 12182 //
     /* 1795934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1795937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1795942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1795945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1795948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1795951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1795954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795980 */     // MIs[0] policy
     /* 1795980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795990 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1795993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796014 */     // GIR_Coverage, 12182,
     /* 1796014 */     GIR_EraseRootFromParent_Done,
     /* 1796015 */   // Label 24387: @1796015
     /* 1796015 */   GIM_Try, /*On fail goto*//*Label 24388*/ GIMT_Encode4(1796101), // Rule ID 12183 //
     /* 1796020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1796023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1796028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1796031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1796034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1796037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796066 */     // MIs[0] policy
     /* 1796066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796076 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1796079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796100 */     // GIR_Coverage, 12183,
     /* 1796100 */     GIR_EraseRootFromParent_Done,
     /* 1796101 */   // Label 24388: @1796101
     /* 1796101 */   GIM_Try, /*On fail goto*//*Label 24389*/ GIMT_Encode4(1796187), // Rule ID 12186 //
     /* 1796106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1796117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1796120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1796123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1796126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796152 */     // MIs[0] policy
     /* 1796152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796162 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1796165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796186 */     // GIR_Coverage, 12186,
     /* 1796186 */     GIR_EraseRootFromParent_Done,
     /* 1796187 */   // Label 24389: @1796187
     /* 1796187 */   GIM_Try, /*On fail goto*//*Label 24390*/ GIMT_Encode4(1796273), // Rule ID 12187 //
     /* 1796192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1796203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1796206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1796209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1796212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796238 */     // MIs[0] policy
     /* 1796238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796248 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1796251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796272 */     // GIR_Coverage, 12187,
     /* 1796272 */     GIR_EraseRootFromParent_Done,
     /* 1796273 */   // Label 24390: @1796273
     /* 1796273 */   GIM_Try, /*On fail goto*//*Label 24391*/ GIMT_Encode4(1796359), // Rule ID 12190 //
     /* 1796278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1796289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1796292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1796295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1796298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796324 */     // MIs[0] policy
     /* 1796324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796334 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1796337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796358 */     // GIR_Coverage, 12190,
     /* 1796358 */     GIR_EraseRootFromParent_Done,
     /* 1796359 */   // Label 24391: @1796359
     /* 1796359 */   GIM_Try, /*On fail goto*//*Label 24392*/ GIMT_Encode4(1796445), // Rule ID 12191 //
     /* 1796364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1796375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1796378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1796381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1796384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796410 */     // MIs[0] policy
     /* 1796410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796420 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1796423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796444 */     // GIR_Coverage, 12191,
     /* 1796444 */     GIR_EraseRootFromParent_Done,
     /* 1796445 */   // Label 24392: @1796445
     /* 1796445 */   GIM_Try, /*On fail goto*//*Label 24393*/ GIMT_Encode4(1796531), // Rule ID 12194 //
     /* 1796450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1796461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1796464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1796467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1796470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796496 */     // MIs[0] policy
     /* 1796496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796506 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1796509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796530 */     // GIR_Coverage, 12194,
     /* 1796530 */     GIR_EraseRootFromParent_Done,
     /* 1796531 */   // Label 24393: @1796531
     /* 1796531 */   GIM_Try, /*On fail goto*//*Label 24394*/ GIMT_Encode4(1796617), // Rule ID 12195 //
     /* 1796536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1796547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1796550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1796553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1796556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796582 */     // MIs[0] policy
     /* 1796582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796592 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1796595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796616 */     // GIR_Coverage, 12195,
     /* 1796616 */     GIR_EraseRootFromParent_Done,
     /* 1796617 */   // Label 24394: @1796617
     /* 1796617 */   GIM_Try, /*On fail goto*//*Label 24395*/ GIMT_Encode4(1796703), // Rule ID 12198 //
     /* 1796622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1796633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1796636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1796639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1796642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796668 */     // MIs[0] policy
     /* 1796668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796678 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1796681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796702 */     // GIR_Coverage, 12198,
     /* 1796702 */     GIR_EraseRootFromParent_Done,
     /* 1796703 */   // Label 24395: @1796703
     /* 1796703 */   GIM_Try, /*On fail goto*//*Label 24396*/ GIMT_Encode4(1796789), // Rule ID 12199 //
     /* 1796708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1796719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1796722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1796725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1796728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796754 */     // MIs[0] policy
     /* 1796754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796764 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1796767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796788 */     // GIR_Coverage, 12199,
     /* 1796788 */     GIR_EraseRootFromParent_Done,
     /* 1796789 */   // Label 24396: @1796789
     /* 1796789 */   GIM_Try, /*On fail goto*//*Label 24397*/ GIMT_Encode4(1796875), // Rule ID 12202 //
     /* 1796794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1796805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1796808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1796811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1796814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796840 */     // MIs[0] policy
     /* 1796840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796850 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1796853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796874 */     // GIR_Coverage, 12202,
     /* 1796874 */     GIR_EraseRootFromParent_Done,
     /* 1796875 */   // Label 24397: @1796875
     /* 1796875 */   GIM_Try, /*On fail goto*//*Label 24398*/ GIMT_Encode4(1796961), // Rule ID 12203 //
     /* 1796880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1796891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1796894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1796897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1796900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796926 */     // MIs[0] policy
     /* 1796926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796936 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1796939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796960 */     // GIR_Coverage, 12203,
     /* 1796960 */     GIR_EraseRootFromParent_Done,
     /* 1796961 */   // Label 24398: @1796961
     /* 1796961 */   GIM_Try, /*On fail goto*//*Label 24399*/ GIMT_Encode4(1797047), // Rule ID 12206 //
     /* 1796966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1796977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1796980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1796983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1796986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797012 */     // MIs[0] policy
     /* 1797012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797022 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1797025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797046 */     // GIR_Coverage, 12206,
     /* 1797046 */     GIR_EraseRootFromParent_Done,
     /* 1797047 */   // Label 24399: @1797047
     /* 1797047 */   GIM_Try, /*On fail goto*//*Label 24400*/ GIMT_Encode4(1797133), // Rule ID 12207 //
     /* 1797052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1797063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1797066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1797069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1797072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797098 */     // MIs[0] policy
     /* 1797098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1797111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797132 */     // GIR_Coverage, 12207,
     /* 1797132 */     GIR_EraseRootFromParent_Done,
     /* 1797133 */   // Label 24400: @1797133
     /* 1797133 */   GIM_Try, /*On fail goto*//*Label 24401*/ GIMT_Encode4(1797219), // Rule ID 12210 //
     /* 1797138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1797149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1797152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1797155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1797158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797184 */     // MIs[0] policy
     /* 1797184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797194 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1797197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797218 */     // GIR_Coverage, 12210,
     /* 1797218 */     GIR_EraseRootFromParent_Done,
     /* 1797219 */   // Label 24401: @1797219
     /* 1797219 */   GIM_Try, /*On fail goto*//*Label 24402*/ GIMT_Encode4(1797305), // Rule ID 12211 //
     /* 1797224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1797235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1797238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1797241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1797244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797270 */     // MIs[0] policy
     /* 1797270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797280 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1797283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797304 */     // GIR_Coverage, 12211,
     /* 1797304 */     GIR_EraseRootFromParent_Done,
     /* 1797305 */   // Label 24402: @1797305
     /* 1797305 */   GIM_Try, /*On fail goto*//*Label 24403*/ GIMT_Encode4(1797391), // Rule ID 12214 //
     /* 1797310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1797321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1797324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1797330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797356 */     // MIs[0] policy
     /* 1797356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1797369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797390 */     // GIR_Coverage, 12214,
     /* 1797390 */     GIR_EraseRootFromParent_Done,
     /* 1797391 */   // Label 24403: @1797391
     /* 1797391 */   GIM_Try, /*On fail goto*//*Label 24404*/ GIMT_Encode4(1797477), // Rule ID 12215 //
     /* 1797396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1797407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1797410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1797416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797442 */     // MIs[0] policy
     /* 1797442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1797455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797476 */     // GIR_Coverage, 12215,
     /* 1797476 */     GIR_EraseRootFromParent_Done,
     /* 1797477 */   // Label 24404: @1797477
     /* 1797477 */   GIM_Try, /*On fail goto*//*Label 24405*/ GIMT_Encode4(1797563), // Rule ID 12218 //
     /* 1797482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1797502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797528 */     // MIs[0] policy
     /* 1797528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797538 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1797541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797562 */     // GIR_Coverage, 12218,
     /* 1797562 */     GIR_EraseRootFromParent_Done,
     /* 1797563 */   // Label 24405: @1797563
     /* 1797563 */   GIM_Try, /*On fail goto*//*Label 24406*/ GIMT_Encode4(1797649), // Rule ID 12219 //
     /* 1797568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1797588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797614 */     // MIs[0] policy
     /* 1797614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1797627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797648 */     // GIR_Coverage, 12219,
     /* 1797648 */     GIR_EraseRootFromParent_Done,
     /* 1797649 */   // Label 24406: @1797649
     /* 1797649 */   GIM_Try, /*On fail goto*//*Label 24407*/ GIMT_Encode4(1797735), // Rule ID 12222 //
     /* 1797654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1797657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1797665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1797668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1797671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1797674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797700 */     // MIs[0] policy
     /* 1797700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797710 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1797713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797734 */     // GIR_Coverage, 12222,
     /* 1797734 */     GIR_EraseRootFromParent_Done,
     /* 1797735 */   // Label 24407: @1797735
     /* 1797735 */   GIM_Try, /*On fail goto*//*Label 24408*/ GIMT_Encode4(1797821), // Rule ID 12223 //
     /* 1797740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1797743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1797751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1797754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1797757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1797760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797786 */     // MIs[0] policy
     /* 1797786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797796 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1797799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797820 */     // GIR_Coverage, 12223,
     /* 1797820 */     GIR_EraseRootFromParent_Done,
     /* 1797821 */   // Label 24408: @1797821
     /* 1797821 */   GIM_Try, /*On fail goto*//*Label 24409*/ GIMT_Encode4(1797907), // Rule ID 12226 //
     /* 1797826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1797837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1797840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1797843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1797846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1797849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1797856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797872 */     // MIs[0] policy
     /* 1797872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797882 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1797885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797906 */     // GIR_Coverage, 12226,
     /* 1797906 */     GIR_EraseRootFromParent_Done,
     /* 1797907 */   // Label 24409: @1797907
     /* 1797907 */   GIM_Try, /*On fail goto*//*Label 24410*/ GIMT_Encode4(1797993), // Rule ID 12227 //
     /* 1797912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1797923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1797926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1797929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1797932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1797935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1797942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797958 */     // MIs[0] policy
     /* 1797958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797968 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1797971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797992 */     // GIR_Coverage, 12227,
     /* 1797992 */     GIR_EraseRootFromParent_Done,
     /* 1797993 */   // Label 24410: @1797993
     /* 1797993 */   GIM_Try, /*On fail goto*//*Label 24411*/ GIMT_Encode4(1798079), // Rule ID 12230 //
     /* 1797998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1798009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1798012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1798015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1798018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798044 */     // MIs[0] policy
     /* 1798044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798054 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1798057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798078 */     // GIR_Coverage, 12230,
     /* 1798078 */     GIR_EraseRootFromParent_Done,
     /* 1798079 */   // Label 24411: @1798079
     /* 1798079 */   GIM_Try, /*On fail goto*//*Label 24412*/ GIMT_Encode4(1798165), // Rule ID 12231 //
     /* 1798084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1798095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1798098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1798101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1798104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798130 */     // MIs[0] policy
     /* 1798130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798140 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1798143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798164 */     // GIR_Coverage, 12231,
     /* 1798164 */     GIR_EraseRootFromParent_Done,
     /* 1798165 */   // Label 24412: @1798165
     /* 1798165 */   GIM_Try, /*On fail goto*//*Label 24413*/ GIMT_Encode4(1798251), // Rule ID 12234 //
     /* 1798170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1798181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1798184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1798187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1798190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1798193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798216 */     // MIs[0] policy
     /* 1798216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798226 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1798229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798250 */     // GIR_Coverage, 12234,
     /* 1798250 */     GIR_EraseRootFromParent_Done,
     /* 1798251 */   // Label 24413: @1798251
     /* 1798251 */   GIM_Try, /*On fail goto*//*Label 24414*/ GIMT_Encode4(1798337), // Rule ID 12235 //
     /* 1798256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1798267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1798270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1798273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1798276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1798279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798302 */     // MIs[0] policy
     /* 1798302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798312 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1798315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798336 */     // GIR_Coverage, 12235,
     /* 1798336 */     GIR_EraseRootFromParent_Done,
     /* 1798337 */   // Label 24414: @1798337
     /* 1798337 */   GIM_Try, /*On fail goto*//*Label 24415*/ GIMT_Encode4(1798423), // Rule ID 12238 //
     /* 1798342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1798359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1798362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798388 */     // MIs[0] policy
     /* 1798388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798398 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1798401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798422 */     // GIR_Coverage, 12238,
     /* 1798422 */     GIR_EraseRootFromParent_Done,
     /* 1798423 */   // Label 24415: @1798423
     /* 1798423 */   GIM_Try, /*On fail goto*//*Label 24416*/ GIMT_Encode4(1798509), // Rule ID 12239 //
     /* 1798428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1798445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1798448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798474 */     // MIs[0] policy
     /* 1798474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1798487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798508 */     // GIR_Coverage, 12239,
     /* 1798508 */     GIR_EraseRootFromParent_Done,
     /* 1798509 */   // Label 24416: @1798509
     /* 1798509 */   GIM_Try, /*On fail goto*//*Label 24417*/ GIMT_Encode4(1798595), // Rule ID 12242 //
     /* 1798514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1798525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1798528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1798531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1798534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798560 */     // MIs[0] policy
     /* 1798560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798570 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1798573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798594 */     // GIR_Coverage, 12242,
     /* 1798594 */     GIR_EraseRootFromParent_Done,
     /* 1798595 */   // Label 24417: @1798595
     /* 1798595 */   GIM_Try, /*On fail goto*//*Label 24418*/ GIMT_Encode4(1798681), // Rule ID 12243 //
     /* 1798600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1798611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1798614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1798617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1798620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798646 */     // MIs[0] policy
     /* 1798646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798656 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1798659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798680 */     // GIR_Coverage, 12243,
     /* 1798680 */     GIR_EraseRootFromParent_Done,
     /* 1798681 */   // Label 24418: @1798681
     /* 1798681 */   GIM_Try, /*On fail goto*//*Label 24419*/ GIMT_Encode4(1798767), // Rule ID 12246 //
     /* 1798686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1798697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1798700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1798703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1798706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798732 */     // MIs[0] policy
     /* 1798732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798742 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1798745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798766 */     // GIR_Coverage, 12246,
     /* 1798766 */     GIR_EraseRootFromParent_Done,
     /* 1798767 */   // Label 24419: @1798767
     /* 1798767 */   GIM_Try, /*On fail goto*//*Label 24420*/ GIMT_Encode4(1798853), // Rule ID 12247 //
     /* 1798772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1798783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1798786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1798789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1798792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798818 */     // MIs[0] policy
     /* 1798818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798828 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1798831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798852 */     // GIR_Coverage, 12247,
     /* 1798852 */     GIR_EraseRootFromParent_Done,
     /* 1798853 */   // Label 24420: @1798853
     /* 1798853 */   GIM_Try, /*On fail goto*//*Label 24421*/ GIMT_Encode4(1798939), // Rule ID 12250 //
     /* 1798858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1798869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1798872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1798875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1798878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798904 */     // MIs[0] policy
     /* 1798904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798914 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1798917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798938 */     // GIR_Coverage, 12250,
     /* 1798938 */     GIR_EraseRootFromParent_Done,
     /* 1798939 */   // Label 24421: @1798939
     /* 1798939 */   GIM_Try, /*On fail goto*//*Label 24422*/ GIMT_Encode4(1799025), // Rule ID 12251 //
     /* 1798944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1798955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1798958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1798961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1798964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798990 */     // MIs[0] policy
     /* 1798990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799000 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1799003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799024 */     // GIR_Coverage, 12251,
     /* 1799024 */     GIR_EraseRootFromParent_Done,
     /* 1799025 */   // Label 24422: @1799025
     /* 1799025 */   GIM_Try, /*On fail goto*//*Label 24423*/ GIMT_Encode4(1799111), // Rule ID 12254 //
     /* 1799030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1799041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1799044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1799047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1799050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799076 */     // MIs[0] policy
     /* 1799076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799086 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1799089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799110 */     // GIR_Coverage, 12254,
     /* 1799110 */     GIR_EraseRootFromParent_Done,
     /* 1799111 */   // Label 24423: @1799111
     /* 1799111 */   GIM_Try, /*On fail goto*//*Label 24424*/ GIMT_Encode4(1799197), // Rule ID 12255 //
     /* 1799116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1799127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1799130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1799133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1799136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799162 */     // MIs[0] policy
     /* 1799162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799172 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1799175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799196 */     // GIR_Coverage, 12255,
     /* 1799196 */     GIR_EraseRootFromParent_Done,
     /* 1799197 */   // Label 24424: @1799197
     /* 1799197 */   GIM_Try, /*On fail goto*//*Label 24425*/ GIMT_Encode4(1799283), // Rule ID 12258 //
     /* 1799202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1799213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1799216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1799219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1799222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799248 */     // MIs[0] policy
     /* 1799248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799258 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1799261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799282 */     // GIR_Coverage, 12258,
     /* 1799282 */     GIR_EraseRootFromParent_Done,
     /* 1799283 */   // Label 24425: @1799283
     /* 1799283 */   GIM_Try, /*On fail goto*//*Label 24426*/ GIMT_Encode4(1799369), // Rule ID 12259 //
     /* 1799288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1799299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1799302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1799305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1799308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799334 */     // MIs[0] policy
     /* 1799334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799344 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1799347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799368 */     // GIR_Coverage, 12259,
     /* 1799368 */     GIR_EraseRootFromParent_Done,
     /* 1799369 */   // Label 24426: @1799369
     /* 1799369 */   GIM_Try, /*On fail goto*//*Label 24427*/ GIMT_Encode4(1799455), // Rule ID 12262 //
     /* 1799374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1799377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1799385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1799388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1799391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1799394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799420 */     // MIs[0] policy
     /* 1799420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799430 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1799433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799454 */     // GIR_Coverage, 12262,
     /* 1799454 */     GIR_EraseRootFromParent_Done,
     /* 1799455 */   // Label 24427: @1799455
     /* 1799455 */   GIM_Try, /*On fail goto*//*Label 24428*/ GIMT_Encode4(1799541), // Rule ID 12263 //
     /* 1799460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1799463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1799471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1799474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1799477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1799480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799506 */     // MIs[0] policy
     /* 1799506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1799519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799540 */     // GIR_Coverage, 12263,
     /* 1799540 */     GIR_EraseRootFromParent_Done,
     /* 1799541 */   // Label 24428: @1799541
     /* 1799541 */   GIM_Try, /*On fail goto*//*Label 24429*/ GIMT_Encode4(1799627), // Rule ID 12266 //
     /* 1799546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1799549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1799557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1799560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1799563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1799566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799592 */     // MIs[0] policy
     /* 1799592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799602 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1799605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799626 */     // GIR_Coverage, 12266,
     /* 1799626 */     GIR_EraseRootFromParent_Done,
     /* 1799627 */   // Label 24429: @1799627
     /* 1799627 */   GIM_Try, /*On fail goto*//*Label 24430*/ GIMT_Encode4(1799713), // Rule ID 12267 //
     /* 1799632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1799635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1799643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1799646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1799649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1799652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799678 */     // MIs[0] policy
     /* 1799678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799688 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1799691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799712 */     // GIR_Coverage, 12267,
     /* 1799712 */     GIR_EraseRootFromParent_Done,
     /* 1799713 */   // Label 24430: @1799713
     /* 1799713 */   GIM_Try, /*On fail goto*//*Label 24431*/ GIMT_Encode4(1799799), // Rule ID 12270 //
     /* 1799718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1799721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1799729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1799732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1799735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1799738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799764 */     // MIs[0] policy
     /* 1799764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799774 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1799777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799798 */     // GIR_Coverage, 12270,
     /* 1799798 */     GIR_EraseRootFromParent_Done,
     /* 1799799 */   // Label 24431: @1799799
     /* 1799799 */   GIM_Try, /*On fail goto*//*Label 24432*/ GIMT_Encode4(1799885), // Rule ID 12271 //
     /* 1799804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1799807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1799815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1799818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1799821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1799824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799850 */     // MIs[0] policy
     /* 1799850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799860 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1799863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799884 */     // GIR_Coverage, 12271,
     /* 1799884 */     GIR_EraseRootFromParent_Done,
     /* 1799885 */   // Label 24432: @1799885
     /* 1799885 */   GIM_Try, /*On fail goto*//*Label 24433*/ GIMT_Encode4(1799971), // Rule ID 12274 //
     /* 1799890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1799901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1799904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1799907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799936 */     // MIs[0] policy
     /* 1799936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799946 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1799949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1799967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799970 */     // GIR_Coverage, 12274,
     /* 1799970 */     GIR_EraseRootFromParent_Done,
     /* 1799971 */   // Label 24433: @1799971
     /* 1799971 */   GIM_Try, /*On fail goto*//*Label 24434*/ GIMT_Encode4(1800057), // Rule ID 12275 //
     /* 1799976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1799987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1799990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1799993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800022 */     // MIs[0] policy
     /* 1800022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800032 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1800035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800056 */     // GIR_Coverage, 12275,
     /* 1800056 */     GIR_EraseRootFromParent_Done,
     /* 1800057 */   // Label 24434: @1800057
     /* 1800057 */   GIM_Try, /*On fail goto*//*Label 24435*/ GIMT_Encode4(1800143), // Rule ID 12278 //
     /* 1800062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1800073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1800076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1800079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1800082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800108 */     // MIs[0] policy
     /* 1800108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800118 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1800121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800142 */     // GIR_Coverage, 12278,
     /* 1800142 */     GIR_EraseRootFromParent_Done,
     /* 1800143 */   // Label 24435: @1800143
     /* 1800143 */   GIM_Try, /*On fail goto*//*Label 24436*/ GIMT_Encode4(1800229), // Rule ID 12279 //
     /* 1800148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1800159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1800162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1800165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800194 */     // MIs[0] policy
     /* 1800194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800204 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1800207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800228 */     // GIR_Coverage, 12279,
     /* 1800228 */     GIR_EraseRootFromParent_Done,
     /* 1800229 */   // Label 24436: @1800229
     /* 1800229 */   GIM_Try, /*On fail goto*//*Label 24437*/ GIMT_Encode4(1800315), // Rule ID 12282 //
     /* 1800234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1800245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1800248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1800251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1800254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800280 */     // MIs[0] policy
     /* 1800280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800290 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1800293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800314 */     // GIR_Coverage, 12282,
     /* 1800314 */     GIR_EraseRootFromParent_Done,
     /* 1800315 */   // Label 24437: @1800315
     /* 1800315 */   GIM_Try, /*On fail goto*//*Label 24438*/ GIMT_Encode4(1800401), // Rule ID 12283 //
     /* 1800320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1800331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1800334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1800337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800366 */     // MIs[0] policy
     /* 1800366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800376 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1800379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800400 */     // GIR_Coverage, 12283,
     /* 1800400 */     GIR_EraseRootFromParent_Done,
     /* 1800401 */   // Label 24438: @1800401
     /* 1800401 */   GIM_Try, /*On fail goto*//*Label 24439*/ GIMT_Encode4(1800487), // Rule ID 12286 //
     /* 1800406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1800417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1800420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1800423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1800426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800452 */     // MIs[0] policy
     /* 1800452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800462 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1800465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800486 */     // GIR_Coverage, 12286,
     /* 1800486 */     GIR_EraseRootFromParent_Done,
     /* 1800487 */   // Label 24439: @1800487
     /* 1800487 */   GIM_Try, /*On fail goto*//*Label 24440*/ GIMT_Encode4(1800573), // Rule ID 12287 //
     /* 1800492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1800503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1800506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1800509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800538 */     // MIs[0] policy
     /* 1800538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800548 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1800551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800572 */     // GIR_Coverage, 12287,
     /* 1800572 */     GIR_EraseRootFromParent_Done,
     /* 1800573 */   // Label 24440: @1800573
     /* 1800573 */   GIM_Try, /*On fail goto*//*Label 24441*/ GIMT_Encode4(1800659), // Rule ID 12290 //
     /* 1800578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1800589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1800592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1800595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1800598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800624 */     // MIs[0] policy
     /* 1800624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800634 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1800637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800658 */     // GIR_Coverage, 12290,
     /* 1800658 */     GIR_EraseRootFromParent_Done,
     /* 1800659 */   // Label 24441: @1800659
     /* 1800659 */   GIM_Try, /*On fail goto*//*Label 24442*/ GIMT_Encode4(1800745), // Rule ID 12291 //
     /* 1800664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1800675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1800678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1800681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800710 */     // MIs[0] policy
     /* 1800710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800720 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1800723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800744 */     // GIR_Coverage, 12291,
     /* 1800744 */     GIR_EraseRootFromParent_Done,
     /* 1800745 */   // Label 24442: @1800745
     /* 1800745 */   GIM_Try, /*On fail goto*//*Label 24443*/ GIMT_Encode4(1800831), // Rule ID 12294 //
     /* 1800750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1800761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1800764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1800767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1800770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800796 */     // MIs[0] policy
     /* 1800796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800806 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1800809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800830 */     // GIR_Coverage, 12294,
     /* 1800830 */     GIR_EraseRootFromParent_Done,
     /* 1800831 */   // Label 24443: @1800831
     /* 1800831 */   GIM_Try, /*On fail goto*//*Label 24444*/ GIMT_Encode4(1800917), // Rule ID 12295 //
     /* 1800836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1800847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1800850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1800853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800882 */     // MIs[0] policy
     /* 1800882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800892 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1800895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800916 */     // GIR_Coverage, 12295,
     /* 1800916 */     GIR_EraseRootFromParent_Done,
     /* 1800917 */   // Label 24444: @1800917
     /* 1800917 */   GIM_Try, /*On fail goto*//*Label 24445*/ GIMT_Encode4(1801003), // Rule ID 12298 //
     /* 1800922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1800933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1800936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1800939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1800942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800968 */     // MIs[0] policy
     /* 1800968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800978 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1800981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801002 */     // GIR_Coverage, 12298,
     /* 1801002 */     GIR_EraseRootFromParent_Done,
     /* 1801003 */   // Label 24445: @1801003
     /* 1801003 */   GIM_Try, /*On fail goto*//*Label 24446*/ GIMT_Encode4(1801089), // Rule ID 12299 //
     /* 1801008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1801016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1801019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1801022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1801025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801054 */     // MIs[0] policy
     /* 1801054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801064 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1801067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801088 */     // GIR_Coverage, 12299,
     /* 1801088 */     GIR_EraseRootFromParent_Done,
     /* 1801089 */   // Label 24446: @1801089
     /* 1801089 */   GIM_Try, /*On fail goto*//*Label 24447*/ GIMT_Encode4(1801175), // Rule ID 12302 //
     /* 1801094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1801102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1801105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1801108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1801111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801140 */     // MIs[0] policy
     /* 1801140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801150 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1801153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801174 */     // GIR_Coverage, 12302,
     /* 1801174 */     GIR_EraseRootFromParent_Done,
     /* 1801175 */   // Label 24447: @1801175
     /* 1801175 */   GIM_Try, /*On fail goto*//*Label 24448*/ GIMT_Encode4(1801261), // Rule ID 12303 //
     /* 1801180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1801188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1801191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1801194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1801197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801226 */     // MIs[0] policy
     /* 1801226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801236 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1801239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801260 */     // GIR_Coverage, 12303,
     /* 1801260 */     GIR_EraseRootFromParent_Done,
     /* 1801261 */   // Label 24448: @1801261
     /* 1801261 */   GIM_Try, /*On fail goto*//*Label 24449*/ GIMT_Encode4(1801347), // Rule ID 12306 //
     /* 1801266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1801274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1801277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1801280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1801283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801312 */     // MIs[0] policy
     /* 1801312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1801325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801346 */     // GIR_Coverage, 12306,
     /* 1801346 */     GIR_EraseRootFromParent_Done,
     /* 1801347 */   // Label 24449: @1801347
     /* 1801347 */   GIM_Try, /*On fail goto*//*Label 24450*/ GIMT_Encode4(1801433), // Rule ID 12307 //
     /* 1801352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1801360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1801363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1801366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1801369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801398 */     // MIs[0] policy
     /* 1801398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1801411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801432 */     // GIR_Coverage, 12307,
     /* 1801432 */     GIR_EraseRootFromParent_Done,
     /* 1801433 */   // Label 24450: @1801433
     /* 1801433 */   GIM_Try, /*On fail goto*//*Label 24451*/ GIMT_Encode4(1801519), // Rule ID 12310 //
     /* 1801438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1801441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1801446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1801449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1801452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1801455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801484 */     // MIs[0] policy
     /* 1801484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1801497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1801515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801518 */     // GIR_Coverage, 12310,
     /* 1801518 */     GIR_EraseRootFromParent_Done,
     /* 1801519 */   // Label 24451: @1801519
     /* 1801519 */   GIM_Try, /*On fail goto*//*Label 24452*/ GIMT_Encode4(1801605), // Rule ID 12311 //
     /* 1801524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1801527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1801532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1801535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1801538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1801541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801570 */     // MIs[0] policy
     /* 1801570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801580 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1801583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1801601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801604 */     // GIR_Coverage, 12311,
     /* 1801604 */     GIR_EraseRootFromParent_Done,
     /* 1801605 */   // Label 24452: @1801605
     /* 1801605 */   GIM_Try, /*On fail goto*//*Label 24453*/ GIMT_Encode4(1801691), // Rule ID 12314 //
     /* 1801610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1801618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1801621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1801624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1801627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801656 */     // MIs[0] policy
     /* 1801656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801666 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1801669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801690 */     // GIR_Coverage, 12314,
     /* 1801690 */     GIR_EraseRootFromParent_Done,
     /* 1801691 */   // Label 24453: @1801691
     /* 1801691 */   GIM_Try, /*On fail goto*//*Label 24454*/ GIMT_Encode4(1801777), // Rule ID 12315 //
     /* 1801696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1801704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1801707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1801710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1801713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801742 */     // MIs[0] policy
     /* 1801742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801752 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1801755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801776 */     // GIR_Coverage, 12315,
     /* 1801776 */     GIR_EraseRootFromParent_Done,
     /* 1801777 */   // Label 24454: @1801777
     /* 1801777 */   GIM_Try, /*On fail goto*//*Label 24455*/ GIMT_Encode4(1801863), // Rule ID 12318 //
     /* 1801782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1801790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1801793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1801796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1801799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1801805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801828 */     // MIs[0] policy
     /* 1801828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801838 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1801841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801862 */     // GIR_Coverage, 12318,
     /* 1801862 */     GIR_EraseRootFromParent_Done,
     /* 1801863 */   // Label 24455: @1801863
     /* 1801863 */   GIM_Try, /*On fail goto*//*Label 24456*/ GIMT_Encode4(1801949), // Rule ID 12319 //
     /* 1801868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1801876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1801879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1801882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1801885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1801891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801914 */     // MIs[0] policy
     /* 1801914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801924 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1801927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801948 */     // GIR_Coverage, 12319,
     /* 1801948 */     GIR_EraseRootFromParent_Done,
     /* 1801949 */   // Label 24456: @1801949
     /* 1801949 */   GIM_Try, /*On fail goto*//*Label 24457*/ GIMT_Encode4(1802035), // Rule ID 12322 //
     /* 1801954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1801962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1801965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1801968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1801971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1801977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802000 */     // MIs[0] policy
     /* 1802000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802010 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1802013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802034 */     // GIR_Coverage, 12322,
     /* 1802034 */     GIR_EraseRootFromParent_Done,
     /* 1802035 */   // Label 24457: @1802035
     /* 1802035 */   GIM_Try, /*On fail goto*//*Label 24458*/ GIMT_Encode4(1802121), // Rule ID 12323 //
     /* 1802040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1802048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1802051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1802054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1802057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1802063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802086 */     // MIs[0] policy
     /* 1802086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802096 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1802099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802120 */     // GIR_Coverage, 12323,
     /* 1802120 */     GIR_EraseRootFromParent_Done,
     /* 1802121 */   // Label 24458: @1802121
     /* 1802121 */   GIM_Try, /*On fail goto*//*Label 24459*/ GIMT_Encode4(1802207), // Rule ID 12326 //
     /* 1802126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1802134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1802137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1802140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1802143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802172 */     // MIs[0] policy
     /* 1802172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802182 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1802185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802206 */     // GIR_Coverage, 12326,
     /* 1802206 */     GIR_EraseRootFromParent_Done,
     /* 1802207 */   // Label 24459: @1802207
     /* 1802207 */   GIM_Try, /*On fail goto*//*Label 24460*/ GIMT_Encode4(1802293), // Rule ID 12327 //
     /* 1802212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1802220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1802223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1802226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1802229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802258 */     // MIs[0] policy
     /* 1802258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802268 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1802271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802292 */     // GIR_Coverage, 12327,
     /* 1802292 */     GIR_EraseRootFromParent_Done,
     /* 1802293 */   // Label 24460: @1802293
     /* 1802293 */   GIM_Try, /*On fail goto*//*Label 24461*/ GIMT_Encode4(1802379), // Rule ID 12330 //
     /* 1802298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1802306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1802309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1802312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1802315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1802321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802344 */     // MIs[0] policy
     /* 1802344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802354 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1802357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802378 */     // GIR_Coverage, 12330,
     /* 1802378 */     GIR_EraseRootFromParent_Done,
     /* 1802379 */   // Label 24461: @1802379
     /* 1802379 */   GIM_Try, /*On fail goto*//*Label 24462*/ GIMT_Encode4(1802465), // Rule ID 12331 //
     /* 1802384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1802392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1802395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1802398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1802401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1802407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802430 */     // MIs[0] policy
     /* 1802430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802440 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1802443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802464 */     // GIR_Coverage, 12331,
     /* 1802464 */     GIR_EraseRootFromParent_Done,
     /* 1802465 */   // Label 24462: @1802465
     /* 1802465 */   GIM_Try, /*On fail goto*//*Label 24463*/ GIMT_Encode4(1802551), // Rule ID 12334 //
     /* 1802470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1802478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1802481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1802484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1802487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1802493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802516 */     // MIs[0] policy
     /* 1802516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802526 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1802529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802550 */     // GIR_Coverage, 12334,
     /* 1802550 */     GIR_EraseRootFromParent_Done,
     /* 1802551 */   // Label 24463: @1802551
     /* 1802551 */   GIM_Try, /*On fail goto*//*Label 24464*/ GIMT_Encode4(1802637), // Rule ID 12335 //
     /* 1802556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1802564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1802567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1802570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1802573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1802579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802602 */     // MIs[0] policy
     /* 1802602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802612 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1802615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802636 */     // GIR_Coverage, 12335,
     /* 1802636 */     GIR_EraseRootFromParent_Done,
     /* 1802637 */   // Label 24464: @1802637
     /* 1802637 */   GIM_Try, /*On fail goto*//*Label 24465*/ GIMT_Encode4(1802723), // Rule ID 12338 //
     /* 1802642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1802650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1802653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1802656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1802659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802688 */     // MIs[0] policy
     /* 1802688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1802701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802722 */     // GIR_Coverage, 12338,
     /* 1802722 */     GIR_EraseRootFromParent_Done,
     /* 1802723 */   // Label 24465: @1802723
     /* 1802723 */   GIM_Try, /*On fail goto*//*Label 24466*/ GIMT_Encode4(1802809), // Rule ID 12339 //
     /* 1802728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1802736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1802739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1802742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1802745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802774 */     // MIs[0] policy
     /* 1802774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1802787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802808 */     // GIR_Coverage, 12339,
     /* 1802808 */     GIR_EraseRootFromParent_Done,
     /* 1802809 */   // Label 24466: @1802809
     /* 1802809 */   GIM_Try, /*On fail goto*//*Label 24467*/ GIMT_Encode4(1802895), // Rule ID 12342 //
     /* 1802814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1802822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1802825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1802828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1802831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802860 */     // MIs[0] policy
     /* 1802860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802870 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1802873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802894 */     // GIR_Coverage, 12342,
     /* 1802894 */     GIR_EraseRootFromParent_Done,
     /* 1802895 */   // Label 24467: @1802895
     /* 1802895 */   GIM_Try, /*On fail goto*//*Label 24468*/ GIMT_Encode4(1802981), // Rule ID 12343 //
     /* 1802900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1802908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1802911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1802914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1802917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802946 */     // MIs[0] policy
     /* 1802946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802956 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1802959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802980 */     // GIR_Coverage, 12343,
     /* 1802980 */     GIR_EraseRootFromParent_Done,
     /* 1802981 */   // Label 24468: @1802981
     /* 1802981 */   GIM_Try, /*On fail goto*//*Label 24469*/ GIMT_Encode4(1803067), // Rule ID 12346 //
     /* 1802986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1802994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1802997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1803000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1803003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803032 */     // MIs[0] policy
     /* 1803032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803042 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1803045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1803063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803066 */     // GIR_Coverage, 12346,
     /* 1803066 */     GIR_EraseRootFromParent_Done,
     /* 1803067 */   // Label 24469: @1803067
     /* 1803067 */   GIM_Try, /*On fail goto*//*Label 24470*/ GIMT_Encode4(1803153), // Rule ID 12347 //
     /* 1803072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1803080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1803083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1803086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1803089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803118 */     // MIs[0] policy
     /* 1803118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803128 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1803131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1803149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803152 */     // GIR_Coverage, 12347,
     /* 1803152 */     GIR_EraseRootFromParent_Done,
     /* 1803153 */   // Label 24470: @1803153
     /* 1803153 */   GIM_Try, /*On fail goto*//*Label 24471*/ GIMT_Encode4(1803239), // Rule ID 12350 //
     /* 1803158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1803161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1803166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1803169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1803172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1803175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803204 */     // MIs[0] policy
     /* 1803204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1803217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1803235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803238 */     // GIR_Coverage, 12350,
     /* 1803238 */     GIR_EraseRootFromParent_Done,
     /* 1803239 */   // Label 24471: @1803239
     /* 1803239 */   GIM_Try, /*On fail goto*//*Label 24472*/ GIMT_Encode4(1803325), // Rule ID 12351 //
     /* 1803244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1803247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1803252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1803255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1803258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1803261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803290 */     // MIs[0] policy
     /* 1803290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1803303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1803321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803324 */     // GIR_Coverage, 12351,
     /* 1803324 */     GIR_EraseRootFromParent_Done,
     /* 1803325 */   // Label 24472: @1803325
     /* 1803325 */   GIM_Try, /*On fail goto*//*Label 24473*/ GIMT_Encode4(1803411), // Rule ID 12354 //
     /* 1803330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1803333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1803338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1803341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1803344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1803347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803376 */     // MIs[0] policy
     /* 1803376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803386 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1803389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1803407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803410 */     // GIR_Coverage, 12354,
     /* 1803410 */     GIR_EraseRootFromParent_Done,
     /* 1803411 */   // Label 24473: @1803411
     /* 1803411 */   GIM_Try, /*On fail goto*//*Label 24474*/ GIMT_Encode4(1803497), // Rule ID 12355 //
     /* 1803416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1803419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1803424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1803427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1803430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1803433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803462 */     // MIs[0] policy
     /* 1803462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803472 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1803475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1803493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803496 */     // GIR_Coverage, 12355,
     /* 1803496 */     GIR_EraseRootFromParent_Done,
     /* 1803497 */   // Label 24474: @1803497
     /* 1803497 */   GIM_Try, /*On fail goto*//*Label 24475*/ GIMT_Encode4(1803583), // Rule ID 12358 //
     /* 1803502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1803505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1803510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1803513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1803516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1803519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803548 */     // MIs[0] policy
     /* 1803548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803558 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1803561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1803579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803582 */     // GIR_Coverage, 12358,
     /* 1803582 */     GIR_EraseRootFromParent_Done,
     /* 1803583 */   // Label 24475: @1803583
     /* 1803583 */   GIM_Try, /*On fail goto*//*Label 24476*/ GIMT_Encode4(1803669), // Rule ID 12359 //
     /* 1803588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1803591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1803596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1803599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1803602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1803605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803634 */     // MIs[0] policy
     /* 1803634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803644 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1803647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1803665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803668 */     // GIR_Coverage, 12359,
     /* 1803668 */     GIR_EraseRootFromParent_Done,
     /* 1803669 */   // Label 24476: @1803669
     /* 1803669 */   GIM_Try, /*On fail goto*//*Label 24477*/ GIMT_Encode4(1803755), // Rule ID 12362 //
     /* 1803674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1803685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1803688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1803691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1803694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1803697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803720 */     // MIs[0] policy
     /* 1803720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803730 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1803733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803754 */     // GIR_Coverage, 12362,
     /* 1803754 */     GIR_EraseRootFromParent_Done,
     /* 1803755 */   // Label 24477: @1803755
     /* 1803755 */   GIM_Try, /*On fail goto*//*Label 24478*/ GIMT_Encode4(1803841), // Rule ID 12363 //
     /* 1803760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1803771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1803774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1803777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1803780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1803783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803806 */     // MIs[0] policy
     /* 1803806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803816 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1803819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803840 */     // GIR_Coverage, 12363,
     /* 1803840 */     GIR_EraseRootFromParent_Done,
     /* 1803841 */   // Label 24478: @1803841
     /* 1803841 */   GIM_Try, /*On fail goto*//*Label 24479*/ GIMT_Encode4(1803927), // Rule ID 12366 //
     /* 1803846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1803857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1803860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1803863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1803866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803892 */     // MIs[0] policy
     /* 1803892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803902 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1803905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803926 */     // GIR_Coverage, 12366,
     /* 1803926 */     GIR_EraseRootFromParent_Done,
     /* 1803927 */   // Label 24479: @1803927
     /* 1803927 */   GIM_Try, /*On fail goto*//*Label 24480*/ GIMT_Encode4(1804013), // Rule ID 12367 //
     /* 1803932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1803943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1803946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1803949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1803952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803978 */     // MIs[0] policy
     /* 1803978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803988 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1803991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804012 */     // GIR_Coverage, 12367,
     /* 1804012 */     GIR_EraseRootFromParent_Done,
     /* 1804013 */   // Label 24480: @1804013
     /* 1804013 */   GIM_Try, /*On fail goto*//*Label 24481*/ GIMT_Encode4(1804099), // Rule ID 12370 //
     /* 1804018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1804029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1804032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1804035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1804038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804064 */     // MIs[0] policy
     /* 1804064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1804077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804098 */     // GIR_Coverage, 12370,
     /* 1804098 */     GIR_EraseRootFromParent_Done,
     /* 1804099 */   // Label 24481: @1804099
     /* 1804099 */   GIM_Try, /*On fail goto*//*Label 24482*/ GIMT_Encode4(1804185), // Rule ID 12371 //
     /* 1804104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1804115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1804118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1804121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1804124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804150 */     // MIs[0] policy
     /* 1804150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804160 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1804163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804184 */     // GIR_Coverage, 12371,
     /* 1804184 */     GIR_EraseRootFromParent_Done,
     /* 1804185 */   // Label 24482: @1804185
     /* 1804185 */   GIM_Try, /*On fail goto*//*Label 24483*/ GIMT_Encode4(1804271), // Rule ID 12374 //
     /* 1804190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1804201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1804204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1804207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1804210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804236 */     // MIs[0] policy
     /* 1804236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1804249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804270 */     // GIR_Coverage, 12374,
     /* 1804270 */     GIR_EraseRootFromParent_Done,
     /* 1804271 */   // Label 24483: @1804271
     /* 1804271 */   GIM_Try, /*On fail goto*//*Label 24484*/ GIMT_Encode4(1804357), // Rule ID 12375 //
     /* 1804276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1804287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1804290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1804293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1804296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804322 */     // MIs[0] policy
     /* 1804322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804332 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1804335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804356 */     // GIR_Coverage, 12375,
     /* 1804356 */     GIR_EraseRootFromParent_Done,
     /* 1804357 */   // Label 24484: @1804357
     /* 1804357 */   GIM_Try, /*On fail goto*//*Label 24485*/ GIMT_Encode4(1804443), // Rule ID 12378 //
     /* 1804362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1804373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1804376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1804379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1804382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804408 */     // MIs[0] policy
     /* 1804408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804418 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1804421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804442 */     // GIR_Coverage, 12378,
     /* 1804442 */     GIR_EraseRootFromParent_Done,
     /* 1804443 */   // Label 24485: @1804443
     /* 1804443 */   GIM_Try, /*On fail goto*//*Label 24486*/ GIMT_Encode4(1804529), // Rule ID 12379 //
     /* 1804448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1804459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1804462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1804465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1804468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804494 */     // MIs[0] policy
     /* 1804494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804504 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1804507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804528 */     // GIR_Coverage, 12379,
     /* 1804528 */     GIR_EraseRootFromParent_Done,
     /* 1804529 */   // Label 24486: @1804529
     /* 1804529 */   GIM_Try, /*On fail goto*//*Label 24487*/ GIMT_Encode4(1804615), // Rule ID 12382 //
     /* 1804534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1804545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1804548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1804551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1804554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1804557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804580 */     // MIs[0] policy
     /* 1804580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804590 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1804593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804614 */     // GIR_Coverage, 12382,
     /* 1804614 */     GIR_EraseRootFromParent_Done,
     /* 1804615 */   // Label 24487: @1804615
     /* 1804615 */   GIM_Try, /*On fail goto*//*Label 24488*/ GIMT_Encode4(1804701), // Rule ID 12383 //
     /* 1804620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1804631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1804634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1804637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1804640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1804643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804666 */     // MIs[0] policy
     /* 1804666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804676 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1804679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804700 */     // GIR_Coverage, 12383,
     /* 1804700 */     GIR_EraseRootFromParent_Done,
     /* 1804701 */   // Label 24488: @1804701
     /* 1804701 */   GIM_Try, /*On fail goto*//*Label 24489*/ GIMT_Encode4(1804787), // Rule ID 12386 //
     /* 1804706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1804717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1804720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1804723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1804726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804752 */     // MIs[0] policy
     /* 1804752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804762 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1804765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804786 */     // GIR_Coverage, 12386,
     /* 1804786 */     GIR_EraseRootFromParent_Done,
     /* 1804787 */   // Label 24489: @1804787
     /* 1804787 */   GIM_Try, /*On fail goto*//*Label 24490*/ GIMT_Encode4(1804873), // Rule ID 12387 //
     /* 1804792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1804803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1804806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1804809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1804812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804838 */     // MIs[0] policy
     /* 1804838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804848 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1804851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804872 */     // GIR_Coverage, 12387,
     /* 1804872 */     GIR_EraseRootFromParent_Done,
     /* 1804873 */   // Label 24490: @1804873
     /* 1804873 */   GIM_Try, /*On fail goto*//*Label 24491*/ GIMT_Encode4(1804959), // Rule ID 12390 //
     /* 1804878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1804889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1804892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1804895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1804898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804924 */     // MIs[0] policy
     /* 1804924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1804937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804958 */     // GIR_Coverage, 12390,
     /* 1804958 */     GIR_EraseRootFromParent_Done,
     /* 1804959 */   // Label 24491: @1804959
     /* 1804959 */   GIM_Try, /*On fail goto*//*Label 24492*/ GIMT_Encode4(1805045), // Rule ID 12391 //
     /* 1804964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1804975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1804978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1804981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1804984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805010 */     // MIs[0] policy
     /* 1805010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1805023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805044 */     // GIR_Coverage, 12391,
     /* 1805044 */     GIR_EraseRootFromParent_Done,
     /* 1805045 */   // Label 24492: @1805045
     /* 1805045 */   GIM_Try, /*On fail goto*//*Label 24493*/ GIMT_Encode4(1805131), // Rule ID 12394 //
     /* 1805050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1805061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1805064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1805067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1805070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805096 */     // MIs[0] policy
     /* 1805096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1805109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805130 */     // GIR_Coverage, 12394,
     /* 1805130 */     GIR_EraseRootFromParent_Done,
     /* 1805131 */   // Label 24493: @1805131
     /* 1805131 */   GIM_Try, /*On fail goto*//*Label 24494*/ GIMT_Encode4(1805217), // Rule ID 12395 //
     /* 1805136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1805147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1805150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1805153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1805156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805182 */     // MIs[0] policy
     /* 1805182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1805195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805216 */     // GIR_Coverage, 12395,
     /* 1805216 */     GIR_EraseRootFromParent_Done,
     /* 1805217 */   // Label 24494: @1805217
     /* 1805217 */   GIM_Try, /*On fail goto*//*Label 24495*/ GIMT_Encode4(1805303), // Rule ID 12398 //
     /* 1805222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1805233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1805236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1805239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1805242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805268 */     // MIs[0] policy
     /* 1805268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805278 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1805281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805302 */     // GIR_Coverage, 12398,
     /* 1805302 */     GIR_EraseRootFromParent_Done,
     /* 1805303 */   // Label 24495: @1805303
     /* 1805303 */   GIM_Try, /*On fail goto*//*Label 24496*/ GIMT_Encode4(1805389), // Rule ID 12399 //
     /* 1805308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1805319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1805322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1805325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1805328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805354 */     // MIs[0] policy
     /* 1805354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1805367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805388 */     // GIR_Coverage, 12399,
     /* 1805388 */     GIR_EraseRootFromParent_Done,
     /* 1805389 */   // Label 24496: @1805389
     /* 1805389 */   GIM_Try, /*On fail goto*//*Label 24497*/ GIMT_Encode4(1805475), // Rule ID 12402 //
     /* 1805394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1805405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1805408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1805411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1805414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1805417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805440 */     // MIs[0] policy
     /* 1805440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805450 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1805453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805474 */     // GIR_Coverage, 12402,
     /* 1805474 */     GIR_EraseRootFromParent_Done,
     /* 1805475 */   // Label 24497: @1805475
     /* 1805475 */   GIM_Try, /*On fail goto*//*Label 24498*/ GIMT_Encode4(1805561), // Rule ID 12403 //
     /* 1805480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1805491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1805494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1805497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1805500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1805503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805526 */     // MIs[0] policy
     /* 1805526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1805539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805560 */     // GIR_Coverage, 12403,
     /* 1805560 */     GIR_EraseRootFromParent_Done,
     /* 1805561 */   // Label 24498: @1805561
     /* 1805561 */   GIM_Try, /*On fail goto*//*Label 24499*/ GIMT_Encode4(1805647), // Rule ID 12406 //
     /* 1805566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1805569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1805577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1805580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1805583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1805586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805612 */     // MIs[0] policy
     /* 1805612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805622 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1805625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805646 */     // GIR_Coverage, 12406,
     /* 1805646 */     GIR_EraseRootFromParent_Done,
     /* 1805647 */   // Label 24499: @1805647
     /* 1805647 */   GIM_Try, /*On fail goto*//*Label 24500*/ GIMT_Encode4(1805733), // Rule ID 12407 //
     /* 1805652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1805663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1805666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1805669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1805672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805698 */     // MIs[0] policy
     /* 1805698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805708 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1805711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805732 */     // GIR_Coverage, 12407,
     /* 1805732 */     GIR_EraseRootFromParent_Done,
     /* 1805733 */   // Label 24500: @1805733
     /* 1805733 */   GIM_Try, /*On fail goto*//*Label 24501*/ GIMT_Encode4(1805819), // Rule ID 12410 //
     /* 1805738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1805741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1805749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1805752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1805755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1805758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805784 */     // MIs[0] policy
     /* 1805784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805794 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1805797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805818 */     // GIR_Coverage, 12410,
     /* 1805818 */     GIR_EraseRootFromParent_Done,
     /* 1805819 */   // Label 24501: @1805819
     /* 1805819 */   GIM_Try, /*On fail goto*//*Label 24502*/ GIMT_Encode4(1805905), // Rule ID 12411 //
     /* 1805824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1805835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1805838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1805841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1805844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805870 */     // MIs[0] policy
     /* 1805870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805880 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1805883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805904 */     // GIR_Coverage, 12411,
     /* 1805904 */     GIR_EraseRootFromParent_Done,
     /* 1805905 */   // Label 24502: @1805905
     /* 1805905 */   GIM_Try, /*On fail goto*//*Label 24503*/ GIMT_Encode4(1805991), // Rule ID 12414 //
     /* 1805910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1805913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1805921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1805924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1805927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1805930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805956 */     // MIs[0] policy
     /* 1805956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1805969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805990 */     // GIR_Coverage, 12414,
     /* 1805990 */     GIR_EraseRootFromParent_Done,
     /* 1805991 */   // Label 24503: @1805991
     /* 1805991 */   GIM_Try, /*On fail goto*//*Label 24504*/ GIMT_Encode4(1806077), // Rule ID 12415 //
     /* 1805996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1806004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1806007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1806010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1806013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1806016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806042 */     // MIs[0] policy
     /* 1806042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806052 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1806055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1806073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806076 */     // GIR_Coverage, 12415,
     /* 1806076 */     GIR_EraseRootFromParent_Done,
     /* 1806077 */   // Label 24504: @1806077
     /* 1806077 */   GIM_Try, /*On fail goto*//*Label 24505*/ GIMT_Encode4(1806163), // Rule ID 12418 //
     /* 1806082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1806085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1806090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1806093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1806096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1806099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1806102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806128 */     // MIs[0] policy
     /* 1806128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806138 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1806141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1806159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806162 */     // GIR_Coverage, 12418,
     /* 1806162 */     GIR_EraseRootFromParent_Done,
     /* 1806163 */   // Label 24505: @1806163
     /* 1806163 */   GIM_Try, /*On fail goto*//*Label 24506*/ GIMT_Encode4(1806249), // Rule ID 12419 //
     /* 1806168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1806171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1806176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1806179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1806182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1806185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1806188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806214 */     // MIs[0] policy
     /* 1806214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806224 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1806227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1806245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806248 */     // GIR_Coverage, 12419,
     /* 1806248 */     GIR_EraseRootFromParent_Done,
     /* 1806249 */   // Label 24506: @1806249
     /* 1806249 */   GIM_Try, /*On fail goto*//*Label 24507*/ GIMT_Encode4(1806335), // Rule ID 12422 //
     /* 1806254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1806262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1806265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1806268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1806271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806300 */     // MIs[0] policy
     /* 1806300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806310 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1806313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806334 */     // GIR_Coverage, 12422,
     /* 1806334 */     GIR_EraseRootFromParent_Done,
     /* 1806335 */   // Label 24507: @1806335
     /* 1806335 */   GIM_Try, /*On fail goto*//*Label 24508*/ GIMT_Encode4(1806421), // Rule ID 12423 //
     /* 1806340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1806348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1806351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1806354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1806357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806386 */     // MIs[0] policy
     /* 1806386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806396 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1806399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806420 */     // GIR_Coverage, 12423,
     /* 1806420 */     GIR_EraseRootFromParent_Done,
     /* 1806421 */   // Label 24508: @1806421
     /* 1806421 */   GIM_Try, /*On fail goto*//*Label 24509*/ GIMT_Encode4(1806507), // Rule ID 12426 //
     /* 1806426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1806434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1806437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1806440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1806443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806472 */     // MIs[0] policy
     /* 1806472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806482 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1806485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806506 */     // GIR_Coverage, 12426,
     /* 1806506 */     GIR_EraseRootFromParent_Done,
     /* 1806507 */   // Label 24509: @1806507
     /* 1806507 */   GIM_Try, /*On fail goto*//*Label 24510*/ GIMT_Encode4(1806593), // Rule ID 12427 //
     /* 1806512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1806520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1806523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1806526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1806529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806558 */     // MIs[0] policy
     /* 1806558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806568 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1806571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806592 */     // GIR_Coverage, 12427,
     /* 1806592 */     GIR_EraseRootFromParent_Done,
     /* 1806593 */   // Label 24510: @1806593
     /* 1806593 */   GIM_Try, /*On fail goto*//*Label 24511*/ GIMT_Encode4(1806679), // Rule ID 12430 //
     /* 1806598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1806606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1806609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1806612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1806615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806644 */     // MIs[0] policy
     /* 1806644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806654 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1806657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806678 */     // GIR_Coverage, 12430,
     /* 1806678 */     GIR_EraseRootFromParent_Done,
     /* 1806679 */   // Label 24511: @1806679
     /* 1806679 */   GIM_Try, /*On fail goto*//*Label 24512*/ GIMT_Encode4(1806765), // Rule ID 12431 //
     /* 1806684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1806692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1806695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1806698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1806701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806730 */     // MIs[0] policy
     /* 1806730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806740 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11633:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1806743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806764 */     // GIR_Coverage, 12431,
     /* 1806764 */     GIR_EraseRootFromParent_Done,
     /* 1806765 */   // Label 24512: @1806765
     /* 1806765 */   GIM_Try, /*On fail goto*//*Label 24513*/ GIMT_Encode4(1806851), // Rule ID 12434 //
     /* 1806770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1806778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1806781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1806784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1806787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806816 */     // MIs[0] policy
     /* 1806816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806826 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1806829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806850 */     // GIR_Coverage, 12434,
     /* 1806850 */     GIR_EraseRootFromParent_Done,
     /* 1806851 */   // Label 24513: @1806851
     /* 1806851 */   GIM_Try, /*On fail goto*//*Label 24514*/ GIMT_Encode4(1806937), // Rule ID 12435 //
     /* 1806856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1806864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1806867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1806870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1806873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806902 */     // MIs[0] policy
     /* 1806902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806912 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1806915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806936 */     // GIR_Coverage, 12435,
     /* 1806936 */     GIR_EraseRootFromParent_Done,
     /* 1806937 */   // Label 24514: @1806937
     /* 1806937 */   GIM_Try, /*On fail goto*//*Label 24515*/ GIMT_Encode4(1807023), // Rule ID 12438 //
     /* 1806942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1806950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1806953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1806956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1806959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806988 */     // MIs[0] policy
     /* 1806988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806998 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1807001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807022 */     // GIR_Coverage, 12438,
     /* 1807022 */     GIR_EraseRootFromParent_Done,
     /* 1807023 */   // Label 24515: @1807023
     /* 1807023 */   GIM_Try, /*On fail goto*//*Label 24516*/ GIMT_Encode4(1807109), // Rule ID 12439 //
     /* 1807028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1807036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1807039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1807042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1807045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1807051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807074 */     // MIs[0] policy
     /* 1807074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807084 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1807087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807108 */     // GIR_Coverage, 12439,
     /* 1807108 */     GIR_EraseRootFromParent_Done,
     /* 1807109 */   // Label 24516: @1807109
     /* 1807109 */   GIM_Try, /*On fail goto*//*Label 24517*/ GIMT_Encode4(1807195), // Rule ID 12442 //
     /* 1807114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1807122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1807125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1807128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1807131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1807137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807160 */     // MIs[0] policy
     /* 1807160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807170 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1807173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807194 */     // GIR_Coverage, 12442,
     /* 1807194 */     GIR_EraseRootFromParent_Done,
     /* 1807195 */   // Label 24517: @1807195
     /* 1807195 */   GIM_Try, /*On fail goto*//*Label 24518*/ GIMT_Encode4(1807281), // Rule ID 12443 //
     /* 1807200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1807208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1807211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1807214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1807217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1807223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807246 */     // MIs[0] policy
     /* 1807246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807256 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1807259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807280 */     // GIR_Coverage, 12443,
     /* 1807280 */     GIR_EraseRootFromParent_Done,
     /* 1807281 */   // Label 24518: @1807281
     /* 1807281 */   GIM_Try, /*On fail goto*//*Label 24519*/ GIMT_Encode4(1807367), // Rule ID 12446 //
     /* 1807286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1807294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1807297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1807300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1807303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807332 */     // MIs[0] policy
     /* 1807332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807342 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1807345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807366 */     // GIR_Coverage, 12446,
     /* 1807366 */     GIR_EraseRootFromParent_Done,
     /* 1807367 */   // Label 24519: @1807367
     /* 1807367 */   GIM_Try, /*On fail goto*//*Label 24520*/ GIMT_Encode4(1807453), // Rule ID 12447 //
     /* 1807372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1807380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1807383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1807386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1807389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807418 */     // MIs[0] policy
     /* 1807418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807428 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1807431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807452 */     // GIR_Coverage, 12447,
     /* 1807452 */     GIR_EraseRootFromParent_Done,
     /* 1807453 */   // Label 24520: @1807453
     /* 1807453 */   GIM_Try, /*On fail goto*//*Label 24521*/ GIMT_Encode4(1807539), // Rule ID 12450 //
     /* 1807458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1807466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1807469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1807472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1807475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807504 */     // MIs[0] policy
     /* 1807504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807514 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1807517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807538 */     // GIR_Coverage, 12450,
     /* 1807538 */     GIR_EraseRootFromParent_Done,
     /* 1807539 */   // Label 24521: @1807539
     /* 1807539 */   GIM_Try, /*On fail goto*//*Label 24522*/ GIMT_Encode4(1807625), // Rule ID 12451 //
     /* 1807544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1807552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1807555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1807558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1807561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807590 */     // MIs[0] policy
     /* 1807590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11633:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1807603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807624 */     // GIR_Coverage, 12451,
     /* 1807624 */     GIR_EraseRootFromParent_Done,
     /* 1807625 */   // Label 24522: @1807625
     /* 1807625 */   GIM_Try, /*On fail goto*//*Label 24523*/ GIMT_Encode4(1807711), // Rule ID 12454 //
     /* 1807630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1807638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1807641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1807644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1807647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807676 */     // MIs[0] policy
     /* 1807676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807686 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1807689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807710 */     // GIR_Coverage, 12454,
     /* 1807710 */     GIR_EraseRootFromParent_Done,
     /* 1807711 */   // Label 24523: @1807711
     /* 1807711 */   GIM_Try, /*On fail goto*//*Label 24524*/ GIMT_Encode4(1807797), // Rule ID 12455 //
     /* 1807716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1807724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1807727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1807730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1807733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807762 */     // MIs[0] policy
     /* 1807762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1807775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807796 */     // GIR_Coverage, 12455,
     /* 1807796 */     GIR_EraseRootFromParent_Done,
     /* 1807797 */   // Label 24524: @1807797
     /* 1807797 */   GIM_Try, /*On fail goto*//*Label 24525*/ GIMT_Encode4(1807883), // Rule ID 12458 //
     /* 1807802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1807810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1807813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1807816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1807819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807848 */     // MIs[0] policy
     /* 1807848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807858 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1807861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807882 */     // GIR_Coverage, 12458,
     /* 1807882 */     GIR_EraseRootFromParent_Done,
     /* 1807883 */   // Label 24525: @1807883
     /* 1807883 */   GIM_Try, /*On fail goto*//*Label 24526*/ GIMT_Encode4(1807969), // Rule ID 12459 //
     /* 1807888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1807896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1807899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1807902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1807905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807934 */     // MIs[0] policy
     /* 1807934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807944 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1807947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807968 */     // GIR_Coverage, 12459,
     /* 1807968 */     GIR_EraseRootFromParent_Done,
     /* 1807969 */   // Label 24526: @1807969
     /* 1807969 */   GIM_Try, /*On fail goto*//*Label 24527*/ GIMT_Encode4(1808055), // Rule ID 12462 //
     /* 1807974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1807982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1807985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1807988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1807991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1807997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808020 */     // MIs[0] policy
     /* 1808020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1808033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808054 */     // GIR_Coverage, 12462,
     /* 1808054 */     GIR_EraseRootFromParent_Done,
     /* 1808055 */   // Label 24527: @1808055
     /* 1808055 */   GIM_Try, /*On fail goto*//*Label 24528*/ GIMT_Encode4(1808141), // Rule ID 12463 //
     /* 1808060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1808068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1808071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1808074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1808077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1808083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808106 */     // MIs[0] policy
     /* 1808106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808116 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1808119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808140 */     // GIR_Coverage, 12463,
     /* 1808140 */     GIR_EraseRootFromParent_Done,
     /* 1808141 */   // Label 24528: @1808141
     /* 1808141 */   GIM_Try, /*On fail goto*//*Label 24529*/ GIMT_Encode4(1808227), // Rule ID 12466 //
     /* 1808146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1808149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1808154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1808157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1808160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1808163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808192 */     // MIs[0] policy
     /* 1808192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808202 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1808205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808226 */     // GIR_Coverage, 12466,
     /* 1808226 */     GIR_EraseRootFromParent_Done,
     /* 1808227 */   // Label 24529: @1808227
     /* 1808227 */   GIM_Try, /*On fail goto*//*Label 24530*/ GIMT_Encode4(1808313), // Rule ID 12467 //
     /* 1808232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1808235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1808240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1808243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1808246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1808249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808278 */     // MIs[0] policy
     /* 1808278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808288 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11633:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1808291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808312 */     // GIR_Coverage, 12467,
     /* 1808312 */     GIR_EraseRootFromParent_Done,
     /* 1808313 */   // Label 24530: @1808313
     /* 1808313 */   GIM_Try, /*On fail goto*//*Label 24531*/ GIMT_Encode4(1808399), // Rule ID 12470 //
     /* 1808318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1808321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1808326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1808329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1808332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1808335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808364 */     // MIs[0] policy
     /* 1808364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808374 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1808377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808398 */     // GIR_Coverage, 12470,
     /* 1808398 */     GIR_EraseRootFromParent_Done,
     /* 1808399 */   // Label 24531: @1808399
     /* 1808399 */   GIM_Try, /*On fail goto*//*Label 24532*/ GIMT_Encode4(1808485), // Rule ID 12471 //
     /* 1808404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1808407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1808412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1808415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1808418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1808421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808450 */     // MIs[0] policy
     /* 1808450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808460 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11633:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1808463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808484 */     // GIR_Coverage, 12471,
     /* 1808484 */     GIR_EraseRootFromParent_Done,
     /* 1808485 */   // Label 24532: @1808485
     /* 1808485 */   GIM_Try, /*On fail goto*//*Label 24533*/ GIMT_Encode4(1808571), // Rule ID 12474 //
     /* 1808490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1808493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1808498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1808501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1808504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1808507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808536 */     // MIs[0] policy
     /* 1808536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808546 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1808549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808570 */     // GIR_Coverage, 12474,
     /* 1808570 */     GIR_EraseRootFromParent_Done,
     /* 1808571 */   // Label 24533: @1808571
     /* 1808571 */   GIM_Try, /*On fail goto*//*Label 24534*/ GIMT_Encode4(1808657), // Rule ID 12475 //
     /* 1808576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1808579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1808584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1808587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1808590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1808593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808622 */     // MIs[0] policy
     /* 1808622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808632 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11633:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1808635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808656 */     // GIR_Coverage, 12475,
     /* 1808656 */     GIR_EraseRootFromParent_Done,
     /* 1808657 */   // Label 24534: @1808657
     /* 1808657 */   GIM_Try, /*On fail goto*//*Label 24535*/ GIMT_Encode4(1808743), // Rule ID 12478 //
     /* 1808662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1808665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1808670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1808673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1808676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1808679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808708 */     // MIs[0] policy
     /* 1808708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1808721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808742 */     // GIR_Coverage, 12478,
     /* 1808742 */     GIR_EraseRootFromParent_Done,
     /* 1808743 */   // Label 24535: @1808743
     /* 1808743 */   GIM_Try, /*On fail goto*//*Label 24536*/ GIMT_Encode4(1808829), // Rule ID 12479 //
     /* 1808748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1808751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1808756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1808759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1808762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1808765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808794 */     // MIs[0] policy
     /* 1808794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808804 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11633:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1808807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808828 */     // GIR_Coverage, 12479,
     /* 1808828 */     GIR_EraseRootFromParent_Done,
     /* 1808829 */   // Label 24536: @1808829
     /* 1808829 */   GIM_Try, /*On fail goto*//*Label 24537*/ GIMT_Encode4(1808915), // Rule ID 12482 //
     /* 1808834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1808845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1808848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1808851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1808854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808880 */     // MIs[0] policy
     /* 1808880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808890 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1808893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808914 */     // GIR_Coverage, 12482,
     /* 1808914 */     GIR_EraseRootFromParent_Done,
     /* 1808915 */   // Label 24537: @1808915
     /* 1808915 */   GIM_Try, /*On fail goto*//*Label 24538*/ GIMT_Encode4(1809001), // Rule ID 12483 //
     /* 1808920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1808931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1808934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1808937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1808940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808966 */     // MIs[0] policy
     /* 1808966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1808979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809000 */     // GIR_Coverage, 12483,
     /* 1809000 */     GIR_EraseRootFromParent_Done,
     /* 1809001 */   // Label 24538: @1809001
     /* 1809001 */   GIM_Try, /*On fail goto*//*Label 24539*/ GIMT_Encode4(1809087), // Rule ID 12486 //
     /* 1809006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1809017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1809020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1809023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1809026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809052 */     // MIs[0] policy
     /* 1809052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809062 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1809065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809086 */     // GIR_Coverage, 12486,
     /* 1809086 */     GIR_EraseRootFromParent_Done,
     /* 1809087 */   // Label 24539: @1809087
     /* 1809087 */   GIM_Try, /*On fail goto*//*Label 24540*/ GIMT_Encode4(1809173), // Rule ID 12487 //
     /* 1809092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1809103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1809106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1809109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1809112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809138 */     // MIs[0] policy
     /* 1809138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1809151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809172 */     // GIR_Coverage, 12487,
     /* 1809172 */     GIR_EraseRootFromParent_Done,
     /* 1809173 */   // Label 24540: @1809173
     /* 1809173 */   GIM_Try, /*On fail goto*//*Label 24541*/ GIMT_Encode4(1809259), // Rule ID 12490 //
     /* 1809178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1809189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1809192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1809195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1809198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809224 */     // MIs[0] policy
     /* 1809224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809234 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1809237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809258 */     // GIR_Coverage, 12490,
     /* 1809258 */     GIR_EraseRootFromParent_Done,
     /* 1809259 */   // Label 24541: @1809259
     /* 1809259 */   GIM_Try, /*On fail goto*//*Label 24542*/ GIMT_Encode4(1809345), // Rule ID 12491 //
     /* 1809264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1809275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1809278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1809281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1809284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809310 */     // MIs[0] policy
     /* 1809310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809320 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1809323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809344 */     // GIR_Coverage, 12491,
     /* 1809344 */     GIR_EraseRootFromParent_Done,
     /* 1809345 */   // Label 24542: @1809345
     /* 1809345 */   GIM_Try, /*On fail goto*//*Label 24543*/ GIMT_Encode4(1809431), // Rule ID 12494 //
     /* 1809350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1809361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1809364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1809367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1809370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809396 */     // MIs[0] policy
     /* 1809396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809406 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1809409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809430 */     // GIR_Coverage, 12494,
     /* 1809430 */     GIR_EraseRootFromParent_Done,
     /* 1809431 */   // Label 24543: @1809431
     /* 1809431 */   GIM_Try, /*On fail goto*//*Label 24544*/ GIMT_Encode4(1809517), // Rule ID 12495 //
     /* 1809436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1809447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1809450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1809453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1809456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809482 */     // MIs[0] policy
     /* 1809482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809492 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1809495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809516 */     // GIR_Coverage, 12495,
     /* 1809516 */     GIR_EraseRootFromParent_Done,
     /* 1809517 */   // Label 24544: @1809517
     /* 1809517 */   GIM_Try, /*On fail goto*//*Label 24545*/ GIMT_Encode4(1809603), // Rule ID 12498 //
     /* 1809522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1809533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1809536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1809539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1809542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809568 */     // MIs[0] policy
     /* 1809568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809578 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1809581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809602 */     // GIR_Coverage, 12498,
     /* 1809602 */     GIR_EraseRootFromParent_Done,
     /* 1809603 */   // Label 24545: @1809603
     /* 1809603 */   GIM_Try, /*On fail goto*//*Label 24546*/ GIMT_Encode4(1809689), // Rule ID 12499 //
     /* 1809608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1809619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1809622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1809625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1809628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809654 */     // MIs[0] policy
     /* 1809654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809664 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1809667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809688 */     // GIR_Coverage, 12499,
     /* 1809688 */     GIR_EraseRootFromParent_Done,
     /* 1809689 */   // Label 24546: @1809689
     /* 1809689 */   GIM_Try, /*On fail goto*//*Label 24547*/ GIMT_Encode4(1809775), // Rule ID 12502 //
     /* 1809694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1809705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1809708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1809711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1809714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1809717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809740 */     // MIs[0] policy
     /* 1809740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809750 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1809753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809774 */     // GIR_Coverage, 12502,
     /* 1809774 */     GIR_EraseRootFromParent_Done,
     /* 1809775 */   // Label 24547: @1809775
     /* 1809775 */   GIM_Try, /*On fail goto*//*Label 24548*/ GIMT_Encode4(1809861), // Rule ID 12503 //
     /* 1809780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1809791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1809794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1809797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1809800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1809803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809826 */     // MIs[0] policy
     /* 1809826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809836 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1809839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809860 */     // GIR_Coverage, 12503,
     /* 1809860 */     GIR_EraseRootFromParent_Done,
     /* 1809861 */   // Label 24548: @1809861
     /* 1809861 */   GIM_Try, /*On fail goto*//*Label 24549*/ GIMT_Encode4(1809947), // Rule ID 12506 //
     /* 1809866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1809877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1809880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1809883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1809886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809912 */     // MIs[0] policy
     /* 1809912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809922 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1809925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809946 */     // GIR_Coverage, 12506,
     /* 1809946 */     GIR_EraseRootFromParent_Done,
     /* 1809947 */   // Label 24549: @1809947
     /* 1809947 */   GIM_Try, /*On fail goto*//*Label 24550*/ GIMT_Encode4(1810033), // Rule ID 12507 //
     /* 1809952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1809963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1809966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1809969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1809972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809998 */     // MIs[0] policy
     /* 1809998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810008 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1810011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810032 */     // GIR_Coverage, 12507,
     /* 1810032 */     GIR_EraseRootFromParent_Done,
     /* 1810033 */   // Label 24550: @1810033
     /* 1810033 */   GIM_Try, /*On fail goto*//*Label 24551*/ GIMT_Encode4(1810119), // Rule ID 12510 //
     /* 1810038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1810049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1810052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1810055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1810058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810084 */     // MIs[0] policy
     /* 1810084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810094 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1810097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810118 */     // GIR_Coverage, 12510,
     /* 1810118 */     GIR_EraseRootFromParent_Done,
     /* 1810119 */   // Label 24551: @1810119
     /* 1810119 */   GIM_Try, /*On fail goto*//*Label 24552*/ GIMT_Encode4(1810205), // Rule ID 12511 //
     /* 1810124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1810135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1810138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1810141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1810144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810170 */     // MIs[0] policy
     /* 1810170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810180 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1810183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810204 */     // GIR_Coverage, 12511,
     /* 1810204 */     GIR_EraseRootFromParent_Done,
     /* 1810205 */   // Label 24552: @1810205
     /* 1810205 */   GIM_Try, /*On fail goto*//*Label 24553*/ GIMT_Encode4(1810291), // Rule ID 12514 //
     /* 1810210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1810221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1810224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1810227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1810230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810256 */     // MIs[0] policy
     /* 1810256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810266 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1810269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810290 */     // GIR_Coverage, 12514,
     /* 1810290 */     GIR_EraseRootFromParent_Done,
     /* 1810291 */   // Label 24553: @1810291
     /* 1810291 */   GIM_Try, /*On fail goto*//*Label 24554*/ GIMT_Encode4(1810377), // Rule ID 12515 //
     /* 1810296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1810307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1810310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1810313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1810316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810342 */     // MIs[0] policy
     /* 1810342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1810355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810376 */     // GIR_Coverage, 12515,
     /* 1810376 */     GIR_EraseRootFromParent_Done,
     /* 1810377 */   // Label 24554: @1810377
     /* 1810377 */   GIM_Try, /*On fail goto*//*Label 24555*/ GIMT_Encode4(1810463), // Rule ID 12518 //
     /* 1810382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1810393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1810396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1810399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1810402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810428 */     // MIs[0] policy
     /* 1810428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810438 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1810441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810462 */     // GIR_Coverage, 12518,
     /* 1810462 */     GIR_EraseRootFromParent_Done,
     /* 1810463 */   // Label 24555: @1810463
     /* 1810463 */   GIM_Try, /*On fail goto*//*Label 24556*/ GIMT_Encode4(1810549), // Rule ID 12519 //
     /* 1810468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1810479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1810482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1810485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1810488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810514 */     // MIs[0] policy
     /* 1810514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1810527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810548 */     // GIR_Coverage, 12519,
     /* 1810548 */     GIR_EraseRootFromParent_Done,
     /* 1810549 */   // Label 24556: @1810549
     /* 1810549 */   GIM_Try, /*On fail goto*//*Label 24557*/ GIMT_Encode4(1810635), // Rule ID 12522 //
     /* 1810554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1810565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1810568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1810571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1810574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1810577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810600 */     // MIs[0] policy
     /* 1810600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810610 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1810613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810634 */     // GIR_Coverage, 12522,
     /* 1810634 */     GIR_EraseRootFromParent_Done,
     /* 1810635 */   // Label 24557: @1810635
     /* 1810635 */   GIM_Try, /*On fail goto*//*Label 24558*/ GIMT_Encode4(1810721), // Rule ID 12523 //
     /* 1810640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1810651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1810654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1810657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1810660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1810663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810686 */     // MIs[0] policy
     /* 1810686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810696 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1810699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810720 */     // GIR_Coverage, 12523,
     /* 1810720 */     GIR_EraseRootFromParent_Done,
     /* 1810721 */   // Label 24558: @1810721
     /* 1810721 */   GIM_Try, /*On fail goto*//*Label 24559*/ GIMT_Encode4(1810807), // Rule ID 12526 //
     /* 1810726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1810729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1810737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1810740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1810743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1810746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810772 */     // MIs[0] policy
     /* 1810772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810782 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1810785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810806 */     // GIR_Coverage, 12526,
     /* 1810806 */     GIR_EraseRootFromParent_Done,
     /* 1810807 */   // Label 24559: @1810807
     /* 1810807 */   GIM_Try, /*On fail goto*//*Label 24560*/ GIMT_Encode4(1810893), // Rule ID 12527 //
     /* 1810812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1810823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1810826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1810829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1810832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810858 */     // MIs[0] policy
     /* 1810858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810868 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1810871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810892 */     // GIR_Coverage, 12527,
     /* 1810892 */     GIR_EraseRootFromParent_Done,
     /* 1810893 */   // Label 24560: @1810893
     /* 1810893 */   GIM_Try, /*On fail goto*//*Label 24561*/ GIMT_Encode4(1810979), // Rule ID 12530 //
     /* 1810898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1810901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1810909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1810912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1810915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1810918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810944 */     // MIs[0] policy
     /* 1810944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810954 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1810957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810978 */     // GIR_Coverage, 12530,
     /* 1810978 */     GIR_EraseRootFromParent_Done,
     /* 1810979 */   // Label 24561: @1810979
     /* 1810979 */   GIM_Try, /*On fail goto*//*Label 24562*/ GIMT_Encode4(1811065), // Rule ID 12531 //
     /* 1810984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1810995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1810998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1811001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1811004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811030 */     // MIs[0] policy
     /* 1811030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1811043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811064 */     // GIR_Coverage, 12531,
     /* 1811064 */     GIR_EraseRootFromParent_Done,
     /* 1811065 */   // Label 24562: @1811065
     /* 1811065 */   GIM_Try, /*On fail goto*//*Label 24563*/ GIMT_Encode4(1811151), // Rule ID 12534 //
     /* 1811070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1811073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1811078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1811081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1811084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1811087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1811090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811116 */     // MIs[0] policy
     /* 1811116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811126 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1811129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811150 */     // GIR_Coverage, 12534,
     /* 1811150 */     GIR_EraseRootFromParent_Done,
     /* 1811151 */   // Label 24563: @1811151
     /* 1811151 */   GIM_Try, /*On fail goto*//*Label 24564*/ GIMT_Encode4(1811237), // Rule ID 12535 //
     /* 1811156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1811159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1811164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1811167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1811170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1811173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1811176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811202 */     // MIs[0] policy
     /* 1811202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811212 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1811215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811236 */     // GIR_Coverage, 12535,
     /* 1811236 */     GIR_EraseRootFromParent_Done,
     /* 1811237 */   // Label 24564: @1811237
     /* 1811237 */   GIM_Try, /*On fail goto*//*Label 24565*/ GIMT_Encode4(1811323), // Rule ID 12538 //
     /* 1811242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1811245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1811250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1811253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1811256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1811259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1811262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811288 */     // MIs[0] policy
     /* 1811288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811298 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1811301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811322 */     // GIR_Coverage, 12538,
     /* 1811322 */     GIR_EraseRootFromParent_Done,
     /* 1811323 */   // Label 24565: @1811323
     /* 1811323 */   GIM_Try, /*On fail goto*//*Label 24566*/ GIMT_Encode4(1811409), // Rule ID 12539 //
     /* 1811328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1811331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1811336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1811339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1811342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1811345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1811348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811374 */     // MIs[0] policy
     /* 1811374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811384 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1811387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811408 */     // GIR_Coverage, 12539,
     /* 1811408 */     GIR_EraseRootFromParent_Done,
     /* 1811409 */   // Label 24566: @1811409
     /* 1811409 */   GIM_Try, /*On fail goto*//*Label 24567*/ GIMT_Encode4(1811495), // Rule ID 12542 //
     /* 1811414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1811422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1811425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1811428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1811431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1811434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1811437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811460 */     // MIs[0] policy
     /* 1811460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811470 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1811473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811494 */     // GIR_Coverage, 12542,
     /* 1811494 */     GIR_EraseRootFromParent_Done,
     /* 1811495 */   // Label 24567: @1811495
     /* 1811495 */   GIM_Try, /*On fail goto*//*Label 24568*/ GIMT_Encode4(1811581), // Rule ID 12543 //
     /* 1811500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1811508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1811511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1811514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1811517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1811520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1811523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811546 */     // MIs[0] policy
     /* 1811546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811556 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1811559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811580 */     // GIR_Coverage, 12543,
     /* 1811580 */     GIR_EraseRootFromParent_Done,
     /* 1811581 */   // Label 24568: @1811581
     /* 1811581 */   GIM_Try, /*On fail goto*//*Label 24569*/ GIMT_Encode4(1811667), // Rule ID 12546 //
     /* 1811586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1811594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1811597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1811600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1811603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1811606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811632 */     // MIs[0] policy
     /* 1811632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811642 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1811645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811666 */     // GIR_Coverage, 12546,
     /* 1811666 */     GIR_EraseRootFromParent_Done,
     /* 1811667 */   // Label 24569: @1811667
     /* 1811667 */   GIM_Try, /*On fail goto*//*Label 24570*/ GIMT_Encode4(1811753), // Rule ID 12547 //
     /* 1811672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1811680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1811683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1811686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1811689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1811692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811718 */     // MIs[0] policy
     /* 1811718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811728 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1811731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811752 */     // GIR_Coverage, 12547,
     /* 1811752 */     GIR_EraseRootFromParent_Done,
     /* 1811753 */   // Label 24570: @1811753
     /* 1811753 */   GIM_Try, /*On fail goto*//*Label 24571*/ GIMT_Encode4(1811839), // Rule ID 12550 //
     /* 1811758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1811766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1811769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1811772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1811775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1811778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811804 */     // MIs[0] policy
     /* 1811804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811814 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1811817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811838 */     // GIR_Coverage, 12550,
     /* 1811838 */     GIR_EraseRootFromParent_Done,
     /* 1811839 */   // Label 24571: @1811839
     /* 1811839 */   GIM_Try, /*On fail goto*//*Label 24572*/ GIMT_Encode4(1811925), // Rule ID 12551 //
     /* 1811844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1811852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1811855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1811858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1811861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1811864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811890 */     // MIs[0] policy
     /* 1811890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1811903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811924 */     // GIR_Coverage, 12551,
     /* 1811924 */     GIR_EraseRootFromParent_Done,
     /* 1811925 */   // Label 24572: @1811925
     /* 1811925 */   GIM_Try, /*On fail goto*//*Label 24573*/ GIMT_Encode4(1812011), // Rule ID 12554 //
     /* 1811930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1811938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1811941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1811944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1811947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1811950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811976 */     // MIs[0] policy
     /* 1811976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1811989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812010 */     // GIR_Coverage, 12554,
     /* 1812010 */     GIR_EraseRootFromParent_Done,
     /* 1812011 */   // Label 24573: @1812011
     /* 1812011 */   GIM_Try, /*On fail goto*//*Label 24574*/ GIMT_Encode4(1812097), // Rule ID 12555 //
     /* 1812016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1812024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1812027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1812030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1812033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812062 */     // MIs[0] policy
     /* 1812062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812072 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1812075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812096 */     // GIR_Coverage, 12555,
     /* 1812096 */     GIR_EraseRootFromParent_Done,
     /* 1812097 */   // Label 24574: @1812097
     /* 1812097 */   GIM_Try, /*On fail goto*//*Label 24575*/ GIMT_Encode4(1812183), // Rule ID 12558 //
     /* 1812102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1812110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1812113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1812116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1812119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1812125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812148 */     // MIs[0] policy
     /* 1812148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812158 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1812161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812182 */     // GIR_Coverage, 12558,
     /* 1812182 */     GIR_EraseRootFromParent_Done,
     /* 1812183 */   // Label 24575: @1812183
     /* 1812183 */   GIM_Try, /*On fail goto*//*Label 24576*/ GIMT_Encode4(1812269), // Rule ID 12559 //
     /* 1812188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1812196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1812199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1812202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1812205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1812211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812234 */     // MIs[0] policy
     /* 1812234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1812247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812268 */     // GIR_Coverage, 12559,
     /* 1812268 */     GIR_EraseRootFromParent_Done,
     /* 1812269 */   // Label 24576: @1812269
     /* 1812269 */   GIM_Try, /*On fail goto*//*Label 24577*/ GIMT_Encode4(1812355), // Rule ID 12562 //
     /* 1812274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1812282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1812285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1812288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1812291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1812297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812320 */     // MIs[0] policy
     /* 1812320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812330 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1812333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812354 */     // GIR_Coverage, 12562,
     /* 1812354 */     GIR_EraseRootFromParent_Done,
     /* 1812355 */   // Label 24577: @1812355
     /* 1812355 */   GIM_Try, /*On fail goto*//*Label 24578*/ GIMT_Encode4(1812441), // Rule ID 12563 //
     /* 1812360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1812368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1812371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1812374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1812377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1812383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812406 */     // MIs[0] policy
     /* 1812406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812416 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1812419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812440 */     // GIR_Coverage, 12563,
     /* 1812440 */     GIR_EraseRootFromParent_Done,
     /* 1812441 */   // Label 24578: @1812441
     /* 1812441 */   GIM_Try, /*On fail goto*//*Label 24579*/ GIMT_Encode4(1812527), // Rule ID 12566 //
     /* 1812446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1812454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1812457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1812460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1812463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812492 */     // MIs[0] policy
     /* 1812492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1812505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812526 */     // GIR_Coverage, 12566,
     /* 1812526 */     GIR_EraseRootFromParent_Done,
     /* 1812527 */   // Label 24579: @1812527
     /* 1812527 */   GIM_Try, /*On fail goto*//*Label 24580*/ GIMT_Encode4(1812613), // Rule ID 12567 //
     /* 1812532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1812540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1812543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1812546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1812549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812578 */     // MIs[0] policy
     /* 1812578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812588 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1812591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812612 */     // GIR_Coverage, 12567,
     /* 1812612 */     GIR_EraseRootFromParent_Done,
     /* 1812613 */   // Label 24580: @1812613
     /* 1812613 */   GIM_Try, /*On fail goto*//*Label 24581*/ GIMT_Encode4(1812699), // Rule ID 12570 //
     /* 1812618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1812626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1812629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1812632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1812635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812664 */     // MIs[0] policy
     /* 1812664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1812677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812698 */     // GIR_Coverage, 12570,
     /* 1812698 */     GIR_EraseRootFromParent_Done,
     /* 1812699 */   // Label 24581: @1812699
     /* 1812699 */   GIM_Try, /*On fail goto*//*Label 24582*/ GIMT_Encode4(1812785), // Rule ID 12571 //
     /* 1812704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1812712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1812715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1812718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1812721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812750 */     // MIs[0] policy
     /* 1812750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812760 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1812763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812784 */     // GIR_Coverage, 12571,
     /* 1812784 */     GIR_EraseRootFromParent_Done,
     /* 1812785 */   // Label 24582: @1812785
     /* 1812785 */   GIM_Try, /*On fail goto*//*Label 24583*/ GIMT_Encode4(1812871), // Rule ID 12574 //
     /* 1812790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1812798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1812801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1812804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1812807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812836 */     // MIs[0] policy
     /* 1812836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812846 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1812849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812870 */     // GIR_Coverage, 12574,
     /* 1812870 */     GIR_EraseRootFromParent_Done,
     /* 1812871 */   // Label 24583: @1812871
     /* 1812871 */   GIM_Try, /*On fail goto*//*Label 24584*/ GIMT_Encode4(1812957), // Rule ID 12575 //
     /* 1812876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1812884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1812887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1812890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1812893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812922 */     // MIs[0] policy
     /* 1812922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812932 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1812935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812956 */     // GIR_Coverage, 12575,
     /* 1812956 */     GIR_EraseRootFromParent_Done,
     /* 1812957 */   // Label 24584: @1812957
     /* 1812957 */   GIM_Try, /*On fail goto*//*Label 24585*/ GIMT_Encode4(1813043), // Rule ID 12578 //
     /* 1812962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1812970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1812973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1812976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1812979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813008 */     // MIs[0] policy
     /* 1813008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813018 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1813021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813042 */     // GIR_Coverage, 12578,
     /* 1813042 */     GIR_EraseRootFromParent_Done,
     /* 1813043 */   // Label 24585: @1813043
     /* 1813043 */   GIM_Try, /*On fail goto*//*Label 24586*/ GIMT_Encode4(1813129), // Rule ID 12579 //
     /* 1813048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1813056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1813059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1813062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1813065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1813078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813094 */     // MIs[0] policy
     /* 1813094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813104 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1813107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813128 */     // GIR_Coverage, 12579,
     /* 1813128 */     GIR_EraseRootFromParent_Done,
     /* 1813129 */   // Label 24586: @1813129
     /* 1813129 */   GIM_Try, /*On fail goto*//*Label 24587*/ GIMT_Encode4(1813215), // Rule ID 12582 //
     /* 1813134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1813142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1813145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1813148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1813151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1813157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813180 */     // MIs[0] policy
     /* 1813180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813190 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1813193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813214 */     // GIR_Coverage, 12582,
     /* 1813214 */     GIR_EraseRootFromParent_Done,
     /* 1813215 */   // Label 24587: @1813215
     /* 1813215 */   GIM_Try, /*On fail goto*//*Label 24588*/ GIMT_Encode4(1813301), // Rule ID 12583 //
     /* 1813220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1813228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1813231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1813234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1813237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1813243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813266 */     // MIs[0] policy
     /* 1813266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813276 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1813279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813300 */     // GIR_Coverage, 12583,
     /* 1813300 */     GIR_EraseRootFromParent_Done,
     /* 1813301 */   // Label 24588: @1813301
     /* 1813301 */   GIM_Try, /*On fail goto*//*Label 24589*/ GIMT_Encode4(1813387), // Rule ID 12586 //
     /* 1813306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1813309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1813314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1813317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1813320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1813323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813352 */     // MIs[0] policy
     /* 1813352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813362 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1813365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813386 */     // GIR_Coverage, 12586,
     /* 1813386 */     GIR_EraseRootFromParent_Done,
     /* 1813387 */   // Label 24589: @1813387
     /* 1813387 */   GIM_Try, /*On fail goto*//*Label 24590*/ GIMT_Encode4(1813473), // Rule ID 12587 //
     /* 1813392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1813395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1813400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1813403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1813406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1813409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813438 */     // MIs[0] policy
     /* 1813438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813448 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1813451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813472 */     // GIR_Coverage, 12587,
     /* 1813472 */     GIR_EraseRootFromParent_Done,
     /* 1813473 */   // Label 24590: @1813473
     /* 1813473 */   GIM_Try, /*On fail goto*//*Label 24591*/ GIMT_Encode4(1813559), // Rule ID 12590 //
     /* 1813478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1813481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1813486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1813489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1813492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1813495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1813508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813524 */     // MIs[0] policy
     /* 1813524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1813537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813558 */     // GIR_Coverage, 12590,
     /* 1813558 */     GIR_EraseRootFromParent_Done,
     /* 1813559 */   // Label 24591: @1813559
     /* 1813559 */   GIM_Try, /*On fail goto*//*Label 24592*/ GIMT_Encode4(1813645), // Rule ID 12591 //
     /* 1813564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1813567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1813572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1813575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1813578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1813581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1813594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813610 */     // MIs[0] policy
     /* 1813610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813620 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1813623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813644 */     // GIR_Coverage, 12591,
     /* 1813644 */     GIR_EraseRootFromParent_Done,
     /* 1813645 */   // Label 24592: @1813645
     /* 1813645 */   GIM_Try, /*On fail goto*//*Label 24593*/ GIMT_Encode4(1813731), // Rule ID 12594 //
     /* 1813650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1813653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1813658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1813661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1813664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1813667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1813680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813696 */     // MIs[0] policy
     /* 1813696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813706 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1813709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813730 */     // GIR_Coverage, 12594,
     /* 1813730 */     GIR_EraseRootFromParent_Done,
     /* 1813731 */   // Label 24593: @1813731
     /* 1813731 */   GIM_Try, /*On fail goto*//*Label 24594*/ GIMT_Encode4(1813817), // Rule ID 12595 //
     /* 1813736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1813739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1813744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1813747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1813750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1813753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1813766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813782 */     // MIs[0] policy
     /* 1813782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813792 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1813795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813816 */     // GIR_Coverage, 12595,
     /* 1813816 */     GIR_EraseRootFromParent_Done,
     /* 1813817 */   // Label 24594: @1813817
     /* 1813817 */   GIM_Try, /*On fail goto*//*Label 24595*/ GIMT_Encode4(1813903), // Rule ID 12598 //
     /* 1813822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1813825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1813830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1813833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1813836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1813839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813868 */     // MIs[0] policy
     /* 1813868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813878 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1813881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813902 */     // GIR_Coverage, 12598,
     /* 1813902 */     GIR_EraseRootFromParent_Done,
     /* 1813903 */   // Label 24595: @1813903
     /* 1813903 */   GIM_Try, /*On fail goto*//*Label 24596*/ GIMT_Encode4(1813989), // Rule ID 12599 //
     /* 1813908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1813911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1813916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1813919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1813922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1813925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813954 */     // MIs[0] policy
     /* 1813954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813964 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1813967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813988 */     // GIR_Coverage, 12599,
     /* 1813988 */     GIR_EraseRootFromParent_Done,
     /* 1813989 */   // Label 24596: @1813989
     /* 1813989 */   GIM_Try, /*On fail goto*//*Label 24597*/ GIMT_Encode4(1814075), // Rule ID 12602 //
     /* 1813994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1814005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1814008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1814011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1814014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1814017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814040 */     // MIs[0] policy
     /* 1814040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814050 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1814053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814074 */     // GIR_Coverage, 12602,
     /* 1814074 */     GIR_EraseRootFromParent_Done,
     /* 1814075 */   // Label 24597: @1814075
     /* 1814075 */   GIM_Try, /*On fail goto*//*Label 24598*/ GIMT_Encode4(1814161), // Rule ID 12603 //
     /* 1814080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1814091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1814094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1814097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1814100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1814103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814126 */     // MIs[0] policy
     /* 1814126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814136 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1814139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814160 */     // GIR_Coverage, 12603,
     /* 1814160 */     GIR_EraseRootFromParent_Done,
     /* 1814161 */   // Label 24598: @1814161
     /* 1814161 */   GIM_Try, /*On fail goto*//*Label 24599*/ GIMT_Encode4(1814247), // Rule ID 12606 //
     /* 1814166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1814177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1814180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1814183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1814186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814212 */     // MIs[0] policy
     /* 1814212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814222 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1814225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814246 */     // GIR_Coverage, 12606,
     /* 1814246 */     GIR_EraseRootFromParent_Done,
     /* 1814247 */   // Label 24599: @1814247
     /* 1814247 */   GIM_Try, /*On fail goto*//*Label 24600*/ GIMT_Encode4(1814333), // Rule ID 12607 //
     /* 1814252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1814263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1814266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1814269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1814272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814298 */     // MIs[0] policy
     /* 1814298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814308 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1814311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814332 */     // GIR_Coverage, 12607,
     /* 1814332 */     GIR_EraseRootFromParent_Done,
     /* 1814333 */   // Label 24600: @1814333
     /* 1814333 */   GIM_Try, /*On fail goto*//*Label 24601*/ GIMT_Encode4(1814419), // Rule ID 12610 //
     /* 1814338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1814349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1814352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1814355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1814358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814384 */     // MIs[0] policy
     /* 1814384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814394 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1814397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814418 */     // GIR_Coverage, 12610,
     /* 1814418 */     GIR_EraseRootFromParent_Done,
     /* 1814419 */   // Label 24601: @1814419
     /* 1814419 */   GIM_Try, /*On fail goto*//*Label 24602*/ GIMT_Encode4(1814505), // Rule ID 12611 //
     /* 1814424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1814435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1814438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1814441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1814444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814470 */     // MIs[0] policy
     /* 1814470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814480 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1814483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814504 */     // GIR_Coverage, 12611,
     /* 1814504 */     GIR_EraseRootFromParent_Done,
     /* 1814505 */   // Label 24602: @1814505
     /* 1814505 */   GIM_Try, /*On fail goto*//*Label 24603*/ GIMT_Encode4(1814591), // Rule ID 12614 //
     /* 1814510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1814521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1814524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1814527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1814530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814556 */     // MIs[0] policy
     /* 1814556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814566 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1814569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814590 */     // GIR_Coverage, 12614,
     /* 1814590 */     GIR_EraseRootFromParent_Done,
     /* 1814591 */   // Label 24603: @1814591
     /* 1814591 */   GIM_Try, /*On fail goto*//*Label 24604*/ GIMT_Encode4(1814677), // Rule ID 12615 //
     /* 1814596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1814607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1814610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1814613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1814616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814642 */     // MIs[0] policy
     /* 1814642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1814655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814676 */     // GIR_Coverage, 12615,
     /* 1814676 */     GIR_EraseRootFromParent_Done,
     /* 1814677 */   // Label 24604: @1814677
     /* 1814677 */   GIM_Try, /*On fail goto*//*Label 24605*/ GIMT_Encode4(1814763), // Rule ID 12618 //
     /* 1814682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1814693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1814696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1814699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1814702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814728 */     // MIs[0] policy
     /* 1814728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814738 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1814741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814762 */     // GIR_Coverage, 12618,
     /* 1814762 */     GIR_EraseRootFromParent_Done,
     /* 1814763 */   // Label 24605: @1814763
     /* 1814763 */   GIM_Try, /*On fail goto*//*Label 24606*/ GIMT_Encode4(1814849), // Rule ID 12619 //
     /* 1814768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1814779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1814782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1814785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1814788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814814 */     // MIs[0] policy
     /* 1814814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814824 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1814827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814848 */     // GIR_Coverage, 12619,
     /* 1814848 */     GIR_EraseRootFromParent_Done,
     /* 1814849 */   // Label 24606: @1814849
     /* 1814849 */   GIM_Try, /*On fail goto*//*Label 24607*/ GIMT_Encode4(1814935), // Rule ID 12622 //
     /* 1814854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1814865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1814868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1814871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1814874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1814877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814900 */     // MIs[0] policy
     /* 1814900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814910 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1814913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814934 */     // GIR_Coverage, 12622,
     /* 1814934 */     GIR_EraseRootFromParent_Done,
     /* 1814935 */   // Label 24607: @1814935
     /* 1814935 */   GIM_Try, /*On fail goto*//*Label 24608*/ GIMT_Encode4(1815021), // Rule ID 12623 //
     /* 1814940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1814951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1814954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1814957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1814960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1814963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814986 */     // MIs[0] policy
     /* 1814986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814996 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1814999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815020 */     // GIR_Coverage, 12623,
     /* 1815020 */     GIR_EraseRootFromParent_Done,
     /* 1815021 */   // Label 24608: @1815021
     /* 1815021 */   GIM_Try, /*On fail goto*//*Label 24609*/ GIMT_Encode4(1815107), // Rule ID 12626 //
     /* 1815026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1815037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1815040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1815043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1815046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815072 */     // MIs[0] policy
     /* 1815072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815082 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1815085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815106 */     // GIR_Coverage, 12626,
     /* 1815106 */     GIR_EraseRootFromParent_Done,
     /* 1815107 */   // Label 24609: @1815107
     /* 1815107 */   GIM_Try, /*On fail goto*//*Label 24610*/ GIMT_Encode4(1815193), // Rule ID 12627 //
     /* 1815112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1815123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1815126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1815129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1815132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815158 */     // MIs[0] policy
     /* 1815158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1815171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815192 */     // GIR_Coverage, 12627,
     /* 1815192 */     GIR_EraseRootFromParent_Done,
     /* 1815193 */   // Label 24610: @1815193
     /* 1815193 */   GIM_Try, /*On fail goto*//*Label 24611*/ GIMT_Encode4(1815279), // Rule ID 12630 //
     /* 1815198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1815209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1815212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1815215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1815218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815244 */     // MIs[0] policy
     /* 1815244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815254 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1815257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815278 */     // GIR_Coverage, 12630,
     /* 1815278 */     GIR_EraseRootFromParent_Done,
     /* 1815279 */   // Label 24611: @1815279
     /* 1815279 */   GIM_Try, /*On fail goto*//*Label 24612*/ GIMT_Encode4(1815365), // Rule ID 12631 //
     /* 1815284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1815295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1815298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1815301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1815304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815330 */     // MIs[0] policy
     /* 1815330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1815343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815364 */     // GIR_Coverage, 12631,
     /* 1815364 */     GIR_EraseRootFromParent_Done,
     /* 1815365 */   // Label 24612: @1815365
     /* 1815365 */   GIM_Try, /*On fail goto*//*Label 24613*/ GIMT_Encode4(1815451), // Rule ID 12634 //
     /* 1815370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1815381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1815384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1815387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1815390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815416 */     // MIs[0] policy
     /* 1815416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1815429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815450 */     // GIR_Coverage, 12634,
     /* 1815450 */     GIR_EraseRootFromParent_Done,
     /* 1815451 */   // Label 24613: @1815451
     /* 1815451 */   GIM_Try, /*On fail goto*//*Label 24614*/ GIMT_Encode4(1815537), // Rule ID 12635 //
     /* 1815456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1815467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1815470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1815473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1815476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815502 */     // MIs[0] policy
     /* 1815502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1815515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815536 */     // GIR_Coverage, 12635,
     /* 1815536 */     GIR_EraseRootFromParent_Done,
     /* 1815537 */   // Label 24614: @1815537
     /* 1815537 */   GIM_Try, /*On fail goto*//*Label 24615*/ GIMT_Encode4(1815623), // Rule ID 12638 //
     /* 1815542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1815553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1815556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1815559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1815562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815588 */     // MIs[0] policy
     /* 1815588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1815601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815622 */     // GIR_Coverage, 12638,
     /* 1815622 */     GIR_EraseRootFromParent_Done,
     /* 1815623 */   // Label 24615: @1815623
     /* 1815623 */   GIM_Try, /*On fail goto*//*Label 24616*/ GIMT_Encode4(1815709), // Rule ID 12639 //
     /* 1815628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1815639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1815642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1815645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1815648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815674 */     // MIs[0] policy
     /* 1815674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815684 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1815687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815708 */     // GIR_Coverage, 12639,
     /* 1815708 */     GIR_EraseRootFromParent_Done,
     /* 1815709 */   // Label 24616: @1815709
     /* 1815709 */   GIM_Try, /*On fail goto*//*Label 24617*/ GIMT_Encode4(1815795), // Rule ID 12642 //
     /* 1815714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1815725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1815728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1815731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1815734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1815737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815760 */     // MIs[0] policy
     /* 1815760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815770 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1815773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815794 */     // GIR_Coverage, 12642,
     /* 1815794 */     GIR_EraseRootFromParent_Done,
     /* 1815795 */   // Label 24617: @1815795
     /* 1815795 */   GIM_Try, /*On fail goto*//*Label 24618*/ GIMT_Encode4(1815881), // Rule ID 12643 //
     /* 1815800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1815811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1815814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1815817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1815820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1815823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815846 */     // MIs[0] policy
     /* 1815846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815856 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1815859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815880 */     // GIR_Coverage, 12643,
     /* 1815880 */     GIR_EraseRootFromParent_Done,
     /* 1815881 */   // Label 24618: @1815881
     /* 1815881 */   GIM_Try, /*On fail goto*//*Label 24619*/ GIMT_Encode4(1815967), // Rule ID 12646 //
     /* 1815886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1815889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1815897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1815900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1815903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1815906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815932 */     // MIs[0] policy
     /* 1815932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815942 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1815945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815966 */     // GIR_Coverage, 12646,
     /* 1815966 */     GIR_EraseRootFromParent_Done,
     /* 1815967 */   // Label 24619: @1815967
     /* 1815967 */   GIM_Try, /*On fail goto*//*Label 24620*/ GIMT_Encode4(1816053), // Rule ID 12647 //
     /* 1815972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1815975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1815983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1815986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1815989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1815992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816018 */     // MIs[0] policy
     /* 1816018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816028 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1816031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816052 */     // GIR_Coverage, 12647,
     /* 1816052 */     GIR_EraseRootFromParent_Done,
     /* 1816053 */   // Label 24620: @1816053
     /* 1816053 */   GIM_Try, /*On fail goto*//*Label 24621*/ GIMT_Encode4(1816139), // Rule ID 12650 //
     /* 1816058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1816061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1816066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1816069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1816072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1816075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1816078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1816088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816104 */     // MIs[0] policy
     /* 1816104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1816117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816138 */     // GIR_Coverage, 12650,
     /* 1816138 */     GIR_EraseRootFromParent_Done,
     /* 1816139 */   // Label 24621: @1816139
     /* 1816139 */   GIM_Try, /*On fail goto*//*Label 24622*/ GIMT_Encode4(1816225), // Rule ID 12651 //
     /* 1816144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1816147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1816152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1816155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1816158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1816161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1816164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1816174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816190 */     // MIs[0] policy
     /* 1816190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816200 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1816203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816224 */     // GIR_Coverage, 12651,
     /* 1816224 */     GIR_EraseRootFromParent_Done,
     /* 1816225 */   // Label 24622: @1816225
     /* 1816225 */   GIM_Try, /*On fail goto*//*Label 24623*/ GIMT_Encode4(1816311), // Rule ID 12654 //
     /* 1816230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1816233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1816238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1816241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1816244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1816247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1816250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1816260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816276 */     // MIs[0] policy
     /* 1816276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816286 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1816289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816310 */     // GIR_Coverage, 12654,
     /* 1816310 */     GIR_EraseRootFromParent_Done,
     /* 1816311 */   // Label 24623: @1816311
     /* 1816311 */   GIM_Try, /*On fail goto*//*Label 24624*/ GIMT_Encode4(1816397), // Rule ID 12655 //
     /* 1816316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1816319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1816324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1816327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1816330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1816333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1816336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1816346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816362 */     // MIs[0] policy
     /* 1816362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816372 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1816375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816396 */     // GIR_Coverage, 12655,
     /* 1816396 */     GIR_EraseRootFromParent_Done,
     /* 1816397 */   // Label 24624: @1816397
     /* 1816397 */   GIM_Try, /*On fail goto*//*Label 24625*/ GIMT_Encode4(1816483), // Rule ID 12658 //
     /* 1816402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1816405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1816410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1816413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1816416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1816419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1816422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1816432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816448 */     // MIs[0] policy
     /* 1816448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816458 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1816461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816482 */     // GIR_Coverage, 12658,
     /* 1816482 */     GIR_EraseRootFromParent_Done,
     /* 1816483 */   // Label 24625: @1816483
     /* 1816483 */   GIM_Try, /*On fail goto*//*Label 24626*/ GIMT_Encode4(1816569), // Rule ID 12659 //
     /* 1816488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1816491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1816496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1816499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1816502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1816505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1816508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1816518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816534 */     // MIs[0] policy
     /* 1816534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816544 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1816547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816568 */     // GIR_Coverage, 12659,
     /* 1816568 */     GIR_EraseRootFromParent_Done,
     /* 1816569 */   // Label 24626: @1816569
     /* 1816569 */   GIM_Try, /*On fail goto*//*Label 24627*/ GIMT_Encode4(1816655), // Rule ID 12662 //
     /* 1816574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1816582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1816585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1816588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1816591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1816594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1816616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816620 */     // MIs[0] policy
     /* 1816620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1816633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816654 */     // GIR_Coverage, 12662,
     /* 1816654 */     GIR_EraseRootFromParent_Done,
     /* 1816655 */   // Label 24627: @1816655
     /* 1816655 */   GIM_Try, /*On fail goto*//*Label 24628*/ GIMT_Encode4(1816741), // Rule ID 12663 //
     /* 1816660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1816668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1816671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1816674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1816677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1816680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1816702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816706 */     // MIs[0] policy
     /* 1816706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816716 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1816719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816740 */     // GIR_Coverage, 12663,
     /* 1816740 */     GIR_EraseRootFromParent_Done,
     /* 1816741 */   // Label 24628: @1816741
     /* 1816741 */   GIM_Try, /*On fail goto*//*Label 24629*/ GIMT_Encode4(1816827), // Rule ID 12666 //
     /* 1816746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1816754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1816757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1816760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1816763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1816766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1816788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816792 */     // MIs[0] policy
     /* 1816792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816802 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1816805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816826 */     // GIR_Coverage, 12666,
     /* 1816826 */     GIR_EraseRootFromParent_Done,
     /* 1816827 */   // Label 24629: @1816827
     /* 1816827 */   GIM_Try, /*On fail goto*//*Label 24630*/ GIMT_Encode4(1816913), // Rule ID 12667 //
     /* 1816832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1816840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1816843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1816846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1816849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1816852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1816874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816878 */     // MIs[0] policy
     /* 1816878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816888 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1816891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816912 */     // GIR_Coverage, 12667,
     /* 1816912 */     GIR_EraseRootFromParent_Done,
     /* 1816913 */   // Label 24630: @1816913
     /* 1816913 */   GIM_Try, /*On fail goto*//*Label 24631*/ GIMT_Encode4(1816999), // Rule ID 12670 //
     /* 1816918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1816926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1816929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1816932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1816935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1816938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1816960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816964 */     // MIs[0] policy
     /* 1816964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816974 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1816977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1816981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816998 */     // GIR_Coverage, 12670,
     /* 1816998 */     GIR_EraseRootFromParent_Done,
     /* 1816999 */   // Label 24631: @1816999
     /* 1816999 */   GIM_Try, /*On fail goto*//*Label 24632*/ GIMT_Encode4(1817085), // Rule ID 12671 //
     /* 1817004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1817012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1817015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1817018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1817021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1817024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1817027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817050 */     // MIs[0] policy
     /* 1817050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817060 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1817063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817084 */     // GIR_Coverage, 12671,
     /* 1817084 */     GIR_EraseRootFromParent_Done,
     /* 1817085 */   // Label 24632: @1817085
     /* 1817085 */   GIM_Try, /*On fail goto*//*Label 24633*/ GIMT_Encode4(1817171), // Rule ID 12674 //
     /* 1817090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1817098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1817101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1817104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1817107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1817110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817136 */     // MIs[0] policy
     /* 1817136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1817149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817170 */     // GIR_Coverage, 12674,
     /* 1817170 */     GIR_EraseRootFromParent_Done,
     /* 1817171 */   // Label 24633: @1817171
     /* 1817171 */   GIM_Try, /*On fail goto*//*Label 24634*/ GIMT_Encode4(1817257), // Rule ID 12675 //
     /* 1817176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1817184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1817187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1817190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1817193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1817196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817222 */     // MIs[0] policy
     /* 1817222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817232 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1817235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817256 */     // GIR_Coverage, 12675,
     /* 1817256 */     GIR_EraseRootFromParent_Done,
     /* 1817257 */   // Label 24634: @1817257
     /* 1817257 */   GIM_Try, /*On fail goto*//*Label 24635*/ GIMT_Encode4(1817343), // Rule ID 12678 //
     /* 1817262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1817270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1817273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1817276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1817279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1817282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1817285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817308 */     // MIs[0] policy
     /* 1817308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817318 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1817321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817342 */     // GIR_Coverage, 12678,
     /* 1817342 */     GIR_EraseRootFromParent_Done,
     /* 1817343 */   // Label 24635: @1817343
     /* 1817343 */   GIM_Try, /*On fail goto*//*Label 24636*/ GIMT_Encode4(1817429), // Rule ID 12679 //
     /* 1817348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1817356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1817359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1817362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1817365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1817368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1817371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817394 */     // MIs[0] policy
     /* 1817394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1817407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817428 */     // GIR_Coverage, 12679,
     /* 1817428 */     GIR_EraseRootFromParent_Done,
     /* 1817429 */   // Label 24636: @1817429
     /* 1817429 */   GIM_Try, /*On fail goto*//*Label 24637*/ GIMT_Encode4(1817515), // Rule ID 12682 //
     /* 1817434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1817442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1817445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1817448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1817451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1817454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817480 */     // MIs[0] policy
     /* 1817480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817490 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1817493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817514 */     // GIR_Coverage, 12682,
     /* 1817514 */     GIR_EraseRootFromParent_Done,
     /* 1817515 */   // Label 24637: @1817515
     /* 1817515 */   GIM_Try, /*On fail goto*//*Label 24638*/ GIMT_Encode4(1817601), // Rule ID 12683 //
     /* 1817520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1817528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1817531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1817534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1817537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1817540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817566 */     // MIs[0] policy
     /* 1817566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817576 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1817579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817600 */     // GIR_Coverage, 12683,
     /* 1817600 */     GIR_EraseRootFromParent_Done,
     /* 1817601 */   // Label 24638: @1817601
     /* 1817601 */   GIM_Try, /*On fail goto*//*Label 24639*/ GIMT_Encode4(1817687), // Rule ID 12686 //
     /* 1817606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1817614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1817617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1817620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1817623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1817626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817652 */     // MIs[0] policy
     /* 1817652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817662 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1817665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817686 */     // GIR_Coverage, 12686,
     /* 1817686 */     GIR_EraseRootFromParent_Done,
     /* 1817687 */   // Label 24639: @1817687
     /* 1817687 */   GIM_Try, /*On fail goto*//*Label 24640*/ GIMT_Encode4(1817773), // Rule ID 12687 //
     /* 1817692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1817700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1817703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1817706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1817709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1817712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817738 */     // MIs[0] policy
     /* 1817738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817748 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1817751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817772 */     // GIR_Coverage, 12687,
     /* 1817772 */     GIR_EraseRootFromParent_Done,
     /* 1817773 */   // Label 24640: @1817773
     /* 1817773 */   GIM_Try, /*On fail goto*//*Label 24641*/ GIMT_Encode4(1817859), // Rule ID 12690 //
     /* 1817778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1817786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1817789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1817792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1817795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1817798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817824 */     // MIs[0] policy
     /* 1817824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1817837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817858 */     // GIR_Coverage, 12690,
     /* 1817858 */     GIR_EraseRootFromParent_Done,
     /* 1817859 */   // Label 24641: @1817859
     /* 1817859 */   GIM_Try, /*On fail goto*//*Label 24642*/ GIMT_Encode4(1817945), // Rule ID 12691 //
     /* 1817864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1817872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1817875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1817878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1817881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1817884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817910 */     // MIs[0] policy
     /* 1817910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817920 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1817923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1817927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817944 */     // GIR_Coverage, 12691,
     /* 1817944 */     GIR_EraseRootFromParent_Done,
     /* 1817945 */   // Label 24642: @1817945
     /* 1817945 */   GIM_Try, /*On fail goto*//*Label 24643*/ GIMT_Encode4(1818031), // Rule ID 12694 //
     /* 1817950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1817958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1817961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1817964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1817967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1817970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1817973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817996 */     // MIs[0] policy
     /* 1817996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818006 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1818009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818030 */     // GIR_Coverage, 12694,
     /* 1818030 */     GIR_EraseRootFromParent_Done,
     /* 1818031 */   // Label 24643: @1818031
     /* 1818031 */   GIM_Try, /*On fail goto*//*Label 24644*/ GIMT_Encode4(1818117), // Rule ID 12695 //
     /* 1818036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1818044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1818047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1818050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1818053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1818056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818082 */     // MIs[0] policy
     /* 1818082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818092 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1818095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818116 */     // GIR_Coverage, 12695,
     /* 1818116 */     GIR_EraseRootFromParent_Done,
     /* 1818117 */   // Label 24644: @1818117
     /* 1818117 */   GIM_Try, /*On fail goto*//*Label 24645*/ GIMT_Encode4(1818203), // Rule ID 12698 //
     /* 1818122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1818130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1818133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1818136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1818139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1818142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818168 */     // MIs[0] policy
     /* 1818168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818178 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1818181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818202 */     // GIR_Coverage, 12698,
     /* 1818202 */     GIR_EraseRootFromParent_Done,
     /* 1818203 */   // Label 24645: @1818203
     /* 1818203 */   GIM_Try, /*On fail goto*//*Label 24646*/ GIMT_Encode4(1818289), // Rule ID 12699 //
     /* 1818208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1818216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1818219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1818222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1818225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1818228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818254 */     // MIs[0] policy
     /* 1818254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818264 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1818267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818288 */     // GIR_Coverage, 12699,
     /* 1818288 */     GIR_EraseRootFromParent_Done,
     /* 1818289 */   // Label 24646: @1818289
     /* 1818289 */   GIM_Try, /*On fail goto*//*Label 24647*/ GIMT_Encode4(1818375), // Rule ID 12702 //
     /* 1818294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1818302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1818305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1818308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1818311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1818314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818340 */     // MIs[0] policy
     /* 1818340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818350 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1818353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818374 */     // GIR_Coverage, 12702,
     /* 1818374 */     GIR_EraseRootFromParent_Done,
     /* 1818375 */   // Label 24647: @1818375
     /* 1818375 */   GIM_Try, /*On fail goto*//*Label 24648*/ GIMT_Encode4(1818461), // Rule ID 12703 //
     /* 1818380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1818388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1818391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1818394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1818397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1818400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818426 */     // MIs[0] policy
     /* 1818426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818436 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1818439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818460 */     // GIR_Coverage, 12703,
     /* 1818460 */     GIR_EraseRootFromParent_Done,
     /* 1818461 */   // Label 24648: @1818461
     /* 1818461 */   GIM_Try, /*On fail goto*//*Label 24649*/ GIMT_Encode4(1818547), // Rule ID 12706 //
     /* 1818466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1818469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1818474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1818477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1818480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1818483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1818486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1818489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818512 */     // MIs[0] policy
     /* 1818512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818522 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1818525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818546 */     // GIR_Coverage, 12706,
     /* 1818546 */     GIR_EraseRootFromParent_Done,
     /* 1818547 */   // Label 24649: @1818547
     /* 1818547 */   GIM_Try, /*On fail goto*//*Label 24650*/ GIMT_Encode4(1818633), // Rule ID 12707 //
     /* 1818552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1818555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1818560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1818563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1818566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1818569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1818572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1818575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818598 */     // MIs[0] policy
     /* 1818598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818608 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1818611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818632 */     // GIR_Coverage, 12707,
     /* 1818632 */     GIR_EraseRootFromParent_Done,
     /* 1818633 */   // Label 24650: @1818633
     /* 1818633 */   GIM_Try, /*On fail goto*//*Label 24651*/ GIMT_Encode4(1818719), // Rule ID 12710 //
     /* 1818638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1818641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1818646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1818649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1818652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1818655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1818658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818684 */     // MIs[0] policy
     /* 1818684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818694 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1818697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818718 */     // GIR_Coverage, 12710,
     /* 1818718 */     GIR_EraseRootFromParent_Done,
     /* 1818719 */   // Label 24651: @1818719
     /* 1818719 */   GIM_Try, /*On fail goto*//*Label 24652*/ GIMT_Encode4(1818805), // Rule ID 12711 //
     /* 1818724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1818727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1818732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1818735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1818738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1818741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1818744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818770 */     // MIs[0] policy
     /* 1818770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1818783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818804 */     // GIR_Coverage, 12711,
     /* 1818804 */     GIR_EraseRootFromParent_Done,
     /* 1818805 */   // Label 24652: @1818805
     /* 1818805 */   GIM_Try, /*On fail goto*//*Label 24653*/ GIMT_Encode4(1818891), // Rule ID 12714 //
     /* 1818810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1818813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1818818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1818821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1818824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1818827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1818830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818856 */     // MIs[0] policy
     /* 1818856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818866 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1818869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818890 */     // GIR_Coverage, 12714,
     /* 1818890 */     GIR_EraseRootFromParent_Done,
     /* 1818891 */   // Label 24653: @1818891
     /* 1818891 */   GIM_Try, /*On fail goto*//*Label 24654*/ GIMT_Encode4(1818977), // Rule ID 12715 //
     /* 1818896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1818899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1818904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1818907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1818910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1818913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1818916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818942 */     // MIs[0] policy
     /* 1818942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818952 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1818955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1818959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818976 */     // GIR_Coverage, 12715,
     /* 1818976 */     GIR_EraseRootFromParent_Done,
     /* 1818977 */   // Label 24654: @1818977
     /* 1818977 */   GIM_Try, /*On fail goto*//*Label 24655*/ GIMT_Encode4(1819063), // Rule ID 12718 //
     /* 1818982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1818985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1818990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1818993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1818996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1818999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1819002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819028 */     // MIs[0] policy
     /* 1819028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819038 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1819041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1819045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819062 */     // GIR_Coverage, 12718,
     /* 1819062 */     GIR_EraseRootFromParent_Done,
     /* 1819063 */   // Label 24655: @1819063
     /* 1819063 */   GIM_Try, /*On fail goto*//*Label 24656*/ GIMT_Encode4(1819149), // Rule ID 12719 //
     /* 1819068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1819071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1819076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1819079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1819082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1819085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1819088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819114 */     // MIs[0] policy
     /* 1819114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819124 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1819127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1819131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819148 */     // GIR_Coverage, 12719,
     /* 1819148 */     GIR_EraseRootFromParent_Done,
     /* 1819149 */   // Label 24656: @1819149
     /* 1819149 */   GIM_Try, /*On fail goto*//*Label 24657*/ GIMT_Encode4(1819235), // Rule ID 12722 //
     /* 1819154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1819165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1819168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1819171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1819174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819200 */     // MIs[0] policy
     /* 1819200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819210 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1819213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819234 */     // GIR_Coverage, 12722,
     /* 1819234 */     GIR_EraseRootFromParent_Done,
     /* 1819235 */   // Label 24657: @1819235
     /* 1819235 */   GIM_Try, /*On fail goto*//*Label 24658*/ GIMT_Encode4(1819321), // Rule ID 12723 //
     /* 1819240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1819251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1819254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1819257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1819260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819286 */     // MIs[0] policy
     /* 1819286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819296 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1819299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819320 */     // GIR_Coverage, 12723,
     /* 1819320 */     GIR_EraseRootFromParent_Done,
     /* 1819321 */   // Label 24658: @1819321
     /* 1819321 */   GIM_Try, /*On fail goto*//*Label 24659*/ GIMT_Encode4(1819407), // Rule ID 12726 //
     /* 1819326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1819337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1819340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1819343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1819346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819372 */     // MIs[0] policy
     /* 1819372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819382 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1819385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819406 */     // GIR_Coverage, 12726,
     /* 1819406 */     GIR_EraseRootFromParent_Done,
     /* 1819407 */   // Label 24659: @1819407
     /* 1819407 */   GIM_Try, /*On fail goto*//*Label 24660*/ GIMT_Encode4(1819493), // Rule ID 12727 //
     /* 1819412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1819423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1819426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1819429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1819432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819458 */     // MIs[0] policy
     /* 1819458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819468 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1819471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819492 */     // GIR_Coverage, 12727,
     /* 1819492 */     GIR_EraseRootFromParent_Done,
     /* 1819493 */   // Label 24660: @1819493
     /* 1819493 */   GIM_Try, /*On fail goto*//*Label 24661*/ GIMT_Encode4(1819579), // Rule ID 12730 //
     /* 1819498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1819509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1819512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1819515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1819518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819544 */     // MIs[0] policy
     /* 1819544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819554 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1819557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819578 */     // GIR_Coverage, 12730,
     /* 1819578 */     GIR_EraseRootFromParent_Done,
     /* 1819579 */   // Label 24661: @1819579
     /* 1819579 */   GIM_Try, /*On fail goto*//*Label 24662*/ GIMT_Encode4(1819665), // Rule ID 12731 //
     /* 1819584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1819595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1819598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1819601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1819604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819630 */     // MIs[0] policy
     /* 1819630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819640 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1819643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819664 */     // GIR_Coverage, 12731,
     /* 1819664 */     GIR_EraseRootFromParent_Done,
     /* 1819665 */   // Label 24662: @1819665
     /* 1819665 */   GIM_Try, /*On fail goto*//*Label 24663*/ GIMT_Encode4(1819751), // Rule ID 12734 //
     /* 1819670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1819681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1819684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1819687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1819690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819716 */     // MIs[0] policy
     /* 1819716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1819729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819750 */     // GIR_Coverage, 12734,
     /* 1819750 */     GIR_EraseRootFromParent_Done,
     /* 1819751 */   // Label 24663: @1819751
     /* 1819751 */   GIM_Try, /*On fail goto*//*Label 24664*/ GIMT_Encode4(1819837), // Rule ID 12735 //
     /* 1819756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1819767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1819770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1819773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1819776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819802 */     // MIs[0] policy
     /* 1819802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819812 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1819815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819836 */     // GIR_Coverage, 12735,
     /* 1819836 */     GIR_EraseRootFromParent_Done,
     /* 1819837 */   // Label 24664: @1819837
     /* 1819837 */   GIM_Try, /*On fail goto*//*Label 24665*/ GIMT_Encode4(1819923), // Rule ID 12738 //
     /* 1819842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1819853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1819856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1819859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1819862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819888 */     // MIs[0] policy
     /* 1819888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819898 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1819901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819922 */     // GIR_Coverage, 12738,
     /* 1819922 */     GIR_EraseRootFromParent_Done,
     /* 1819923 */   // Label 24665: @1819923
     /* 1819923 */   GIM_Try, /*On fail goto*//*Label 24666*/ GIMT_Encode4(1820009), // Rule ID 12739 //
     /* 1819928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1819939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1819942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1819945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1819948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819974 */     // MIs[0] policy
     /* 1819974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819984 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1819987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820008 */     // GIR_Coverage, 12739,
     /* 1820008 */     GIR_EraseRootFromParent_Done,
     /* 1820009 */   // Label 24666: @1820009
     /* 1820009 */   GIM_Try, /*On fail goto*//*Label 24667*/ GIMT_Encode4(1820095), // Rule ID 12742 //
     /* 1820014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1820025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1820028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1820031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1820034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1820037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820060 */     // MIs[0] policy
     /* 1820060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1820073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820094 */     // GIR_Coverage, 12742,
     /* 1820094 */     GIR_EraseRootFromParent_Done,
     /* 1820095 */   // Label 24667: @1820095
     /* 1820095 */   GIM_Try, /*On fail goto*//*Label 24668*/ GIMT_Encode4(1820181), // Rule ID 12743 //
     /* 1820100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1820111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1820114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1820117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1820120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1820123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820146 */     // MIs[0] policy
     /* 1820146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820156 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1820159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820180 */     // GIR_Coverage, 12743,
     /* 1820180 */     GIR_EraseRootFromParent_Done,
     /* 1820181 */   // Label 24668: @1820181
     /* 1820181 */   GIM_Try, /*On fail goto*//*Label 24669*/ GIMT_Encode4(1820267), // Rule ID 12746 //
     /* 1820186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1820197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1820200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1820203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1820206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820232 */     // MIs[0] policy
     /* 1820232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820242 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1820245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820266 */     // GIR_Coverage, 12746,
     /* 1820266 */     GIR_EraseRootFromParent_Done,
     /* 1820267 */   // Label 24669: @1820267
     /* 1820267 */   GIM_Try, /*On fail goto*//*Label 24670*/ GIMT_Encode4(1820353), // Rule ID 12747 //
     /* 1820272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1820283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1820286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1820289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1820292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820318 */     // MIs[0] policy
     /* 1820318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820328 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1820331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820352 */     // GIR_Coverage, 12747,
     /* 1820352 */     GIR_EraseRootFromParent_Done,
     /* 1820353 */   // Label 24670: @1820353
     /* 1820353 */   GIM_Try, /*On fail goto*//*Label 24671*/ GIMT_Encode4(1820439), // Rule ID 12750 //
     /* 1820358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1820369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1820372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1820375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1820378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820404 */     // MIs[0] policy
     /* 1820404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820414 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1820417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820438 */     // GIR_Coverage, 12750,
     /* 1820438 */     GIR_EraseRootFromParent_Done,
     /* 1820439 */   // Label 24671: @1820439
     /* 1820439 */   GIM_Try, /*On fail goto*//*Label 24672*/ GIMT_Encode4(1820525), // Rule ID 12751 //
     /* 1820444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1820455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1820458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1820461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1820464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820490 */     // MIs[0] policy
     /* 1820490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820500 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1820503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820524 */     // GIR_Coverage, 12751,
     /* 1820524 */     GIR_EraseRootFromParent_Done,
     /* 1820525 */   // Label 24672: @1820525
     /* 1820525 */   GIM_Try, /*On fail goto*//*Label 24673*/ GIMT_Encode4(1820611), // Rule ID 12754 //
     /* 1820530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1820533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1820541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1820544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1820547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1820550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820576 */     // MIs[0] policy
     /* 1820576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820586 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1820589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820610 */     // GIR_Coverage, 12754,
     /* 1820610 */     GIR_EraseRootFromParent_Done,
     /* 1820611 */   // Label 24673: @1820611
     /* 1820611 */   GIM_Try, /*On fail goto*//*Label 24674*/ GIMT_Encode4(1820697), // Rule ID 12755 //
     /* 1820616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1820619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1820627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1820630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1820633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1820636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820662 */     // MIs[0] policy
     /* 1820662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820672 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1820675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820696 */     // GIR_Coverage, 12755,
     /* 1820696 */     GIR_EraseRootFromParent_Done,
     /* 1820697 */   // Label 24674: @1820697
     /* 1820697 */   GIM_Try, /*On fail goto*//*Label 24675*/ GIMT_Encode4(1820783), // Rule ID 12758 //
     /* 1820702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1820713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1820716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1820719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1820722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1820725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1820732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820748 */     // MIs[0] policy
     /* 1820748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820758 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1820761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820782 */     // GIR_Coverage, 12758,
     /* 1820782 */     GIR_EraseRootFromParent_Done,
     /* 1820783 */   // Label 24675: @1820783
     /* 1820783 */   GIM_Try, /*On fail goto*//*Label 24676*/ GIMT_Encode4(1820869), // Rule ID 12759 //
     /* 1820788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1820799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1820802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1820805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1820808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1820811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1820818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820834 */     // MIs[0] policy
     /* 1820834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820844 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1820847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820868 */     // GIR_Coverage, 12759,
     /* 1820868 */     GIR_EraseRootFromParent_Done,
     /* 1820869 */   // Label 24676: @1820869
     /* 1820869 */   GIM_Try, /*On fail goto*//*Label 24677*/ GIMT_Encode4(1820955), // Rule ID 12762 //
     /* 1820874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1820885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1820888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1820891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1820894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1820897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1820904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820920 */     // MIs[0] policy
     /* 1820920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820930 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1820933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820954 */     // GIR_Coverage, 12762,
     /* 1820954 */     GIR_EraseRootFromParent_Done,
     /* 1820955 */   // Label 24677: @1820955
     /* 1820955 */   GIM_Try, /*On fail goto*//*Label 24678*/ GIMT_Encode4(1821041), // Rule ID 12763 //
     /* 1820960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1820971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1820974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1820977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1820980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1820983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1820990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821006 */     // MIs[0] policy
     /* 1821006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821016 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1821019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821040 */     // GIR_Coverage, 12763,
     /* 1821040 */     GIR_EraseRootFromParent_Done,
     /* 1821041 */   // Label 24678: @1821041
     /* 1821041 */   GIM_Try, /*On fail goto*//*Label 24679*/ GIMT_Encode4(1821127), // Rule ID 12766 //
     /* 1821046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1821057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1821060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1821063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1821066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1821069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821092 */     // MIs[0] policy
     /* 1821092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821102 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1821105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821126 */     // GIR_Coverage, 12766,
     /* 1821126 */     GIR_EraseRootFromParent_Done,
     /* 1821127 */   // Label 24679: @1821127
     /* 1821127 */   GIM_Try, /*On fail goto*//*Label 24680*/ GIMT_Encode4(1821213), // Rule ID 12767 //
     /* 1821132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1821143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1821146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1821149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1821152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1821155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821178 */     // MIs[0] policy
     /* 1821178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821188 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1821191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821212 */     // GIR_Coverage, 12767,
     /* 1821212 */     GIR_EraseRootFromParent_Done,
     /* 1821213 */   // Label 24680: @1821213
     /* 1821213 */   GIM_Try, /*On fail goto*//*Label 24681*/ GIMT_Encode4(1821299), // Rule ID 12770 //
     /* 1821218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1821229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1821232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1821235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1821238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821264 */     // MIs[0] policy
     /* 1821264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821274 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1821277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821298 */     // GIR_Coverage, 12770,
     /* 1821298 */     GIR_EraseRootFromParent_Done,
     /* 1821299 */   // Label 24681: @1821299
     /* 1821299 */   GIM_Try, /*On fail goto*//*Label 24682*/ GIMT_Encode4(1821385), // Rule ID 12771 //
     /* 1821304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1821315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1821318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1821321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1821324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821350 */     // MIs[0] policy
     /* 1821350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821360 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1821363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821384 */     // GIR_Coverage, 12771,
     /* 1821384 */     GIR_EraseRootFromParent_Done,
     /* 1821385 */   // Label 24682: @1821385
     /* 1821385 */   GIM_Try, /*On fail goto*//*Label 24683*/ GIMT_Encode4(1821471), // Rule ID 12774 //
     /* 1821390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1821401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1821404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1821407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1821410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821436 */     // MIs[0] policy
     /* 1821436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821446 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1821449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821470 */     // GIR_Coverage, 12774,
     /* 1821470 */     GIR_EraseRootFromParent_Done,
     /* 1821471 */   // Label 24683: @1821471
     /* 1821471 */   GIM_Try, /*On fail goto*//*Label 24684*/ GIMT_Encode4(1821557), // Rule ID 12775 //
     /* 1821476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1821487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1821490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1821493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1821496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821522 */     // MIs[0] policy
     /* 1821522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821532 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1821535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821556 */     // GIR_Coverage, 12775,
     /* 1821556 */     GIR_EraseRootFromParent_Done,
     /* 1821557 */   // Label 24684: @1821557
     /* 1821557 */   GIM_Try, /*On fail goto*//*Label 24685*/ GIMT_Encode4(1821643), // Rule ID 12778 //
     /* 1821562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1821573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1821576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1821579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1821582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821608 */     // MIs[0] policy
     /* 1821608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821618 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1821621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821642 */     // GIR_Coverage, 12778,
     /* 1821642 */     GIR_EraseRootFromParent_Done,
     /* 1821643 */   // Label 24685: @1821643
     /* 1821643 */   GIM_Try, /*On fail goto*//*Label 24686*/ GIMT_Encode4(1821729), // Rule ID 12779 //
     /* 1821648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1821659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1821662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1821665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1821668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821694 */     // MIs[0] policy
     /* 1821694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821704 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1821707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821728 */     // GIR_Coverage, 12779,
     /* 1821728 */     GIR_EraseRootFromParent_Done,
     /* 1821729 */   // Label 24686: @1821729
     /* 1821729 */   GIM_Try, /*On fail goto*//*Label 24687*/ GIMT_Encode4(1821815), // Rule ID 12782 //
     /* 1821734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1821745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1821748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1821751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1821754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1821757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821780 */     // MIs[0] policy
     /* 1821780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1821793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821814 */     // GIR_Coverage, 12782,
     /* 1821814 */     GIR_EraseRootFromParent_Done,
     /* 1821815 */   // Label 24687: @1821815
     /* 1821815 */   GIM_Try, /*On fail goto*//*Label 24688*/ GIMT_Encode4(1821901), // Rule ID 12783 //
     /* 1821820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1821831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1821834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1821837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1821840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1821843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821866 */     // MIs[0] policy
     /* 1821866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1821879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821900 */     // GIR_Coverage, 12783,
     /* 1821900 */     GIR_EraseRootFromParent_Done,
     /* 1821901 */   // Label 24688: @1821901
     /* 1821901 */   GIM_Try, /*On fail goto*//*Label 24689*/ GIMT_Encode4(1821987), // Rule ID 12786 //
     /* 1821906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1821917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1821920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1821923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1821926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821952 */     // MIs[0] policy
     /* 1821952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821962 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1821965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821986 */     // GIR_Coverage, 12786,
     /* 1821986 */     GIR_EraseRootFromParent_Done,
     /* 1821987 */   // Label 24689: @1821987
     /* 1821987 */   GIM_Try, /*On fail goto*//*Label 24690*/ GIMT_Encode4(1822073), // Rule ID 12787 //
     /* 1821992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1822003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1822006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1822009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1822012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822038 */     // MIs[0] policy
     /* 1822038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822048 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1822051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822072 */     // GIR_Coverage, 12787,
     /* 1822072 */     GIR_EraseRootFromParent_Done,
     /* 1822073 */   // Label 24690: @1822073
     /* 1822073 */   GIM_Try, /*On fail goto*//*Label 24691*/ GIMT_Encode4(1822159), // Rule ID 12790 //
     /* 1822078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1822089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1822092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1822095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1822098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822124 */     // MIs[0] policy
     /* 1822124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822134 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1822137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822158 */     // GIR_Coverage, 12790,
     /* 1822158 */     GIR_EraseRootFromParent_Done,
     /* 1822159 */   // Label 24691: @1822159
     /* 1822159 */   GIM_Try, /*On fail goto*//*Label 24692*/ GIMT_Encode4(1822245), // Rule ID 12791 //
     /* 1822164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1822175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1822178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1822181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1822184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822210 */     // MIs[0] policy
     /* 1822210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822220 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1822223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822244 */     // GIR_Coverage, 12791,
     /* 1822244 */     GIR_EraseRootFromParent_Done,
     /* 1822245 */   // Label 24692: @1822245
     /* 1822245 */   GIM_Try, /*On fail goto*//*Label 24693*/ GIMT_Encode4(1822331), // Rule ID 12794 //
     /* 1822250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1822261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1822264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1822267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1822270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822296 */     // MIs[0] policy
     /* 1822296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1822309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822330 */     // GIR_Coverage, 12794,
     /* 1822330 */     GIR_EraseRootFromParent_Done,
     /* 1822331 */   // Label 24693: @1822331
     /* 1822331 */   GIM_Try, /*On fail goto*//*Label 24694*/ GIMT_Encode4(1822417), // Rule ID 12795 //
     /* 1822336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1822347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1822350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1822353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1822356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822382 */     // MIs[0] policy
     /* 1822382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822392 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1822395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822416 */     // GIR_Coverage, 12795,
     /* 1822416 */     GIR_EraseRootFromParent_Done,
     /* 1822417 */   // Label 24694: @1822417
     /* 1822417 */   GIM_Try, /*On fail goto*//*Label 24695*/ GIMT_Encode4(1822503), // Rule ID 12798 //
     /* 1822422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1822433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1822436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1822439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1822442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822468 */     // MIs[0] policy
     /* 1822468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822478 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1822481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822502 */     // GIR_Coverage, 12798,
     /* 1822502 */     GIR_EraseRootFromParent_Done,
     /* 1822503 */   // Label 24695: @1822503
     /* 1822503 */   GIM_Try, /*On fail goto*//*Label 24696*/ GIMT_Encode4(1822589), // Rule ID 12799 //
     /* 1822508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1822519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1822522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1822525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1822528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822554 */     // MIs[0] policy
     /* 1822554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822564 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1822567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822588 */     // GIR_Coverage, 12799,
     /* 1822588 */     GIR_EraseRootFromParent_Done,
     /* 1822589 */   // Label 24696: @1822589
     /* 1822589 */   GIM_Try, /*On fail goto*//*Label 24697*/ GIMT_Encode4(1822675), // Rule ID 12802 //
     /* 1822594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1822605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1822608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1822611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1822614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822640 */     // MIs[0] policy
     /* 1822640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822650 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1822653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822674 */     // GIR_Coverage, 12802,
     /* 1822674 */     GIR_EraseRootFromParent_Done,
     /* 1822675 */   // Label 24697: @1822675
     /* 1822675 */   GIM_Try, /*On fail goto*//*Label 24698*/ GIMT_Encode4(1822761), // Rule ID 12803 //
     /* 1822680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1822691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1822694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1822697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1822700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822726 */     // MIs[0] policy
     /* 1822726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822736 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1822739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822760 */     // GIR_Coverage, 12803,
     /* 1822760 */     GIR_EraseRootFromParent_Done,
     /* 1822761 */   // Label 24698: @1822761
     /* 1822761 */   GIM_Try, /*On fail goto*//*Label 24699*/ GIMT_Encode4(1822847), // Rule ID 12806 //
     /* 1822766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1822777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1822780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1822786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1822789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1822796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822812 */     // MIs[0] policy
     /* 1822812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822822 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1822825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822846 */     // GIR_Coverage, 12806,
     /* 1822846 */     GIR_EraseRootFromParent_Done,
     /* 1822847 */   // Label 24699: @1822847
     /* 1822847 */   GIM_Try, /*On fail goto*//*Label 24700*/ GIMT_Encode4(1822933), // Rule ID 12807 //
     /* 1822852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1822863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1822866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1822872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1822875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1822882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822898 */     // MIs[0] policy
     /* 1822898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822908 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1822911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822932 */     // GIR_Coverage, 12807,
     /* 1822932 */     GIR_EraseRootFromParent_Done,
     /* 1822933 */   // Label 24700: @1822933
     /* 1822933 */   GIM_Try, /*On fail goto*//*Label 24701*/ GIMT_Encode4(1823019), // Rule ID 12810 //
     /* 1822938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1822949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1822952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1822958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1822968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822984 */     // MIs[0] policy
     /* 1822984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822994 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1822997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823018 */     // GIR_Coverage, 12810,
     /* 1823018 */     GIR_EraseRootFromParent_Done,
     /* 1823019 */   // Label 24701: @1823019
     /* 1823019 */   GIM_Try, /*On fail goto*//*Label 24702*/ GIMT_Encode4(1823105), // Rule ID 12811 //
     /* 1823024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1823035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1823038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1823041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1823044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823070 */     // MIs[0] policy
     /* 1823070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823080 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1823083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823104 */     // GIR_Coverage, 12811,
     /* 1823104 */     GIR_EraseRootFromParent_Done,
     /* 1823105 */   // Label 24702: @1823105
     /* 1823105 */   GIM_Try, /*On fail goto*//*Label 24703*/ GIMT_Encode4(1823191), // Rule ID 12814 //
     /* 1823110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1823121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1823124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1823127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1823130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823156 */     // MIs[0] policy
     /* 1823156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823166 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1823169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823190 */     // GIR_Coverage, 12814,
     /* 1823190 */     GIR_EraseRootFromParent_Done,
     /* 1823191 */   // Label 24703: @1823191
     /* 1823191 */   GIM_Try, /*On fail goto*//*Label 24704*/ GIMT_Encode4(1823277), // Rule ID 12815 //
     /* 1823196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1823207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1823210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1823213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1823216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823242 */     // MIs[0] policy
     /* 1823242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823252 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1823255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823276 */     // GIR_Coverage, 12815,
     /* 1823276 */     GIR_EraseRootFromParent_Done,
     /* 1823277 */   // Label 24704: @1823277
     /* 1823277 */   GIM_Try, /*On fail goto*//*Label 24705*/ GIMT_Encode4(1823363), // Rule ID 12818 //
     /* 1823282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1823293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1823296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1823299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1823302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823328 */     // MIs[0] policy
     /* 1823328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823338 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1823341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823362 */     // GIR_Coverage, 12818,
     /* 1823362 */     GIR_EraseRootFromParent_Done,
     /* 1823363 */   // Label 24705: @1823363
     /* 1823363 */   GIM_Try, /*On fail goto*//*Label 24706*/ GIMT_Encode4(1823449), // Rule ID 12819 //
     /* 1823368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1823379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1823382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1823385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1823388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823414 */     // MIs[0] policy
     /* 1823414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823424 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1823427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823448 */     // GIR_Coverage, 12819,
     /* 1823448 */     GIR_EraseRootFromParent_Done,
     /* 1823449 */   // Label 24706: @1823449
     /* 1823449 */   GIM_Try, /*On fail goto*//*Label 24707*/ GIMT_Encode4(1823535), // Rule ID 12822 //
     /* 1823454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1823465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1823468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1823471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1823474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823500 */     // MIs[0] policy
     /* 1823500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823510 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1823513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823534 */     // GIR_Coverage, 12822,
     /* 1823534 */     GIR_EraseRootFromParent_Done,
     /* 1823535 */   // Label 24707: @1823535
     /* 1823535 */   GIM_Try, /*On fail goto*//*Label 24708*/ GIMT_Encode4(1823621), // Rule ID 12823 //
     /* 1823540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1823551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1823554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1823557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1823560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823586 */     // MIs[0] policy
     /* 1823586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823596 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1823599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823620 */     // GIR_Coverage, 12823,
     /* 1823620 */     GIR_EraseRootFromParent_Done,
     /* 1823621 */   // Label 24708: @1823621
     /* 1823621 */   GIM_Try, /*On fail goto*//*Label 24709*/ GIMT_Encode4(1823707), // Rule ID 12826 //
     /* 1823626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1823637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1823640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1823643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1823646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823672 */     // MIs[0] policy
     /* 1823672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823682 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1823685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823706 */     // GIR_Coverage, 12826,
     /* 1823706 */     GIR_EraseRootFromParent_Done,
     /* 1823707 */   // Label 24709: @1823707
     /* 1823707 */   GIM_Try, /*On fail goto*//*Label 24710*/ GIMT_Encode4(1823793), // Rule ID 12827 //
     /* 1823712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1823723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1823726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1823729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1823732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823758 */     // MIs[0] policy
     /* 1823758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1823771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823792 */     // GIR_Coverage, 12827,
     /* 1823792 */     GIR_EraseRootFromParent_Done,
     /* 1823793 */   // Label 24710: @1823793
     /* 1823793 */   GIM_Try, /*On fail goto*//*Label 24711*/ GIMT_Encode4(1823879), // Rule ID 12830 //
     /* 1823798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1823809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1823812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1823815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1823818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823844 */     // MIs[0] policy
     /* 1823844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823854 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1823857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823878 */     // GIR_Coverage, 12830,
     /* 1823878 */     GIR_EraseRootFromParent_Done,
     /* 1823879 */   // Label 24711: @1823879
     /* 1823879 */   GIM_Try, /*On fail goto*//*Label 24712*/ GIMT_Encode4(1823965), // Rule ID 12831 //
     /* 1823884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1823895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1823898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1823901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1823904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823930 */     // MIs[0] policy
     /* 1823930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823940 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11388:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1823943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823964 */     // GIR_Coverage, 12831,
     /* 1823964 */     GIR_EraseRootFromParent_Done,
     /* 1823965 */   // Label 24712: @1823965
     /* 1823965 */   GIM_Try, /*On fail goto*//*Label 24713*/ GIMT_Encode4(1824051), // Rule ID 12834 //
     /* 1823970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1823981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1823984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1823987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1823990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824016 */     // MIs[0] policy
     /* 1824016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824026 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1824029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824050 */     // GIR_Coverage, 12834,
     /* 1824050 */     GIR_EraseRootFromParent_Done,
     /* 1824051 */   // Label 24713: @1824051
     /* 1824051 */   GIM_Try, /*On fail goto*//*Label 24714*/ GIMT_Encode4(1824137), // Rule ID 12835 //
     /* 1824056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1824064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1824067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1824070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1824073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1824076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824102 */     // MIs[0] policy
     /* 1824102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824112 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1824115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824136 */     // GIR_Coverage, 12835,
     /* 1824136 */     GIR_EraseRootFromParent_Done,
     /* 1824137 */   // Label 24714: @1824137
     /* 1824137 */   GIM_Try, /*On fail goto*//*Label 24715*/ GIMT_Encode4(1824223), // Rule ID 12838 //
     /* 1824142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1824150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1824153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1824156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1824159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1824162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824188 */     // MIs[0] policy
     /* 1824188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824198 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1824201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824222 */     // GIR_Coverage, 12838,
     /* 1824222 */     GIR_EraseRootFromParent_Done,
     /* 1824223 */   // Label 24715: @1824223
     /* 1824223 */   GIM_Try, /*On fail goto*//*Label 24716*/ GIMT_Encode4(1824309), // Rule ID 12839 //
     /* 1824228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1824236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1824239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1824242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1824245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1824248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824274 */     // MIs[0] policy
     /* 1824274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824284 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1824287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824308 */     // GIR_Coverage, 12839,
     /* 1824308 */     GIR_EraseRootFromParent_Done,
     /* 1824309 */   // Label 24716: @1824309
     /* 1824309 */   GIM_Try, /*On fail goto*//*Label 24717*/ GIMT_Encode4(1824395), // Rule ID 12842 //
     /* 1824314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1824317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1824322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1824325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1824328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1824331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1824334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824360 */     // MIs[0] policy
     /* 1824360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824370 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1824373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1824391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824394 */     // GIR_Coverage, 12842,
     /* 1824394 */     GIR_EraseRootFromParent_Done,
     /* 1824395 */   // Label 24717: @1824395
     /* 1824395 */   GIM_Try, /*On fail goto*//*Label 24718*/ GIMT_Encode4(1824481), // Rule ID 12843 //
     /* 1824400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1824403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1824408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1824411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1824414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1824417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1824420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824446 */     // MIs[0] policy
     /* 1824446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824456 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1824459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1824477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824480 */     // GIR_Coverage, 12843,
     /* 1824480 */     GIR_EraseRootFromParent_Done,
     /* 1824481 */   // Label 24718: @1824481
     /* 1824481 */   GIM_Try, /*On fail goto*//*Label 24719*/ GIMT_Encode4(1824567), // Rule ID 12846 //
     /* 1824486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1824494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1824497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1824500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1824503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1824506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1824509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1824516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824532 */     // MIs[0] policy
     /* 1824532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824542 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1824545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824566 */     // GIR_Coverage, 12846,
     /* 1824566 */     GIR_EraseRootFromParent_Done,
     /* 1824567 */   // Label 24719: @1824567
     /* 1824567 */   GIM_Try, /*On fail goto*//*Label 24720*/ GIMT_Encode4(1824653), // Rule ID 12847 //
     /* 1824572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1824580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1824583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1824586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1824589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1824592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1824595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1824602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824618 */     // MIs[0] policy
     /* 1824618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824628 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1824631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824652 */     // GIR_Coverage, 12847,
     /* 1824652 */     GIR_EraseRootFromParent_Done,
     /* 1824653 */   // Label 24720: @1824653
     /* 1824653 */   GIM_Try, /*On fail goto*//*Label 24721*/ GIMT_Encode4(1824739), // Rule ID 12850 //
     /* 1824658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1824666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1824669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1824672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1824675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1824678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1824681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1824688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824704 */     // MIs[0] policy
     /* 1824704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824714 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1824717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824738 */     // GIR_Coverage, 12850,
     /* 1824738 */     GIR_EraseRootFromParent_Done,
     /* 1824739 */   // Label 24721: @1824739
     /* 1824739 */   GIM_Try, /*On fail goto*//*Label 24722*/ GIMT_Encode4(1824825), // Rule ID 12851 //
     /* 1824744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1824752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1824755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1824758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1824761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1824764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1824767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1824774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824790 */     // MIs[0] policy
     /* 1824790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824800 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1824803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824824 */     // GIR_Coverage, 12851,
     /* 1824824 */     GIR_EraseRootFromParent_Done,
     /* 1824825 */   // Label 24722: @1824825
     /* 1824825 */   GIM_Try, /*On fail goto*//*Label 24723*/ GIMT_Encode4(1824911), // Rule ID 12854 //
     /* 1824830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1824838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1824841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1824844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1824847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1824850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1824853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1824860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824876 */     // MIs[0] policy
     /* 1824876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824886 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1824889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824910 */     // GIR_Coverage, 12854,
     /* 1824910 */     GIR_EraseRootFromParent_Done,
     /* 1824911 */   // Label 24723: @1824911
     /* 1824911 */   GIM_Try, /*On fail goto*//*Label 24724*/ GIMT_Encode4(1824997), // Rule ID 12855 //
     /* 1824916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1824924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1824927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1824930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1824933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1824936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1824939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1824946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824962 */     // MIs[0] policy
     /* 1824962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824972 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1824975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824996 */     // GIR_Coverage, 12855,
     /* 1824996 */     GIR_EraseRootFromParent_Done,
     /* 1824997 */   // Label 24724: @1824997
     /* 1824997 */   GIM_Try, /*On fail goto*//*Label 24725*/ GIMT_Encode4(1825083), // Rule ID 12858 //
     /* 1825002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1825010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1825013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1825016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1825019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1825022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825048 */     // MIs[0] policy
     /* 1825048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825058 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1825061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825082 */     // GIR_Coverage, 12858,
     /* 1825082 */     GIR_EraseRootFromParent_Done,
     /* 1825083 */   // Label 24725: @1825083
     /* 1825083 */   GIM_Try, /*On fail goto*//*Label 24726*/ GIMT_Encode4(1825169), // Rule ID 12859 //
     /* 1825088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1825096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1825099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1825102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1825105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1825108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825134 */     // MIs[0] policy
     /* 1825134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825144 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1825147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825168 */     // GIR_Coverage, 12859,
     /* 1825168 */     GIR_EraseRootFromParent_Done,
     /* 1825169 */   // Label 24726: @1825169
     /* 1825169 */   GIM_Try, /*On fail goto*//*Label 24727*/ GIMT_Encode4(1825255), // Rule ID 12862 //
     /* 1825174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1825182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1825185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1825188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1825191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1825194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825220 */     // MIs[0] policy
     /* 1825220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825230 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1825233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825254 */     // GIR_Coverage, 12862,
     /* 1825254 */     GIR_EraseRootFromParent_Done,
     /* 1825255 */   // Label 24727: @1825255
     /* 1825255 */   GIM_Try, /*On fail goto*//*Label 24728*/ GIMT_Encode4(1825341), // Rule ID 12863 //
     /* 1825260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1825268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1825271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1825274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1825277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1825280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825306 */     // MIs[0] policy
     /* 1825306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825316 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1825319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825340 */     // GIR_Coverage, 12863,
     /* 1825340 */     GIR_EraseRootFromParent_Done,
     /* 1825341 */   // Label 24728: @1825341
     /* 1825341 */   GIM_Try, /*On fail goto*//*Label 24729*/ GIMT_Encode4(1825427), // Rule ID 12866 //
     /* 1825346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1825354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1825357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1825360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1825363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1825366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825392 */     // MIs[0] policy
     /* 1825392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825402 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1825405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825426 */     // GIR_Coverage, 12866,
     /* 1825426 */     GIR_EraseRootFromParent_Done,
     /* 1825427 */   // Label 24729: @1825427
     /* 1825427 */   GIM_Try, /*On fail goto*//*Label 24730*/ GIMT_Encode4(1825513), // Rule ID 12867 //
     /* 1825432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1825440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1825443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1825446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1825449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1825452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825478 */     // MIs[0] policy
     /* 1825478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825488 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1825491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825512 */     // GIR_Coverage, 12867,
     /* 1825512 */     GIR_EraseRootFromParent_Done,
     /* 1825513 */   // Label 24730: @1825513
     /* 1825513 */   GIM_Try, /*On fail goto*//*Label 24731*/ GIMT_Encode4(1825599), // Rule ID 12870 //
     /* 1825518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1825526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1825529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1825532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1825535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1825538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1825541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825564 */     // MIs[0] policy
     /* 1825564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825574 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1825577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825598 */     // GIR_Coverage, 12870,
     /* 1825598 */     GIR_EraseRootFromParent_Done,
     /* 1825599 */   // Label 24731: @1825599
     /* 1825599 */   GIM_Try, /*On fail goto*//*Label 24732*/ GIMT_Encode4(1825685), // Rule ID 12871 //
     /* 1825604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1825612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1825615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1825618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1825621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1825624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1825627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825650 */     // MIs[0] policy
     /* 1825650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825660 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1825663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825684 */     // GIR_Coverage, 12871,
     /* 1825684 */     GIR_EraseRootFromParent_Done,
     /* 1825685 */   // Label 24732: @1825685
     /* 1825685 */   GIM_Try, /*On fail goto*//*Label 24733*/ GIMT_Encode4(1825771), // Rule ID 12874 //
     /* 1825690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1825698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1825701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1825704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1825707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1825710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825736 */     // MIs[0] policy
     /* 1825736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1825749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825770 */     // GIR_Coverage, 12874,
     /* 1825770 */     GIR_EraseRootFromParent_Done,
     /* 1825771 */   // Label 24733: @1825771
     /* 1825771 */   GIM_Try, /*On fail goto*//*Label 24734*/ GIMT_Encode4(1825857), // Rule ID 12875 //
     /* 1825776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1825784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1825787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1825790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1825793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1825796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825822 */     // MIs[0] policy
     /* 1825822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825832 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1825835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825856 */     // GIR_Coverage, 12875,
     /* 1825856 */     GIR_EraseRootFromParent_Done,
     /* 1825857 */   // Label 24734: @1825857
     /* 1825857 */   GIM_Try, /*On fail goto*//*Label 24735*/ GIMT_Encode4(1825943), // Rule ID 12878 //
     /* 1825862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1825870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1825873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1825876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1825879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1825882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825908 */     // MIs[0] policy
     /* 1825908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1825921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825942 */     // GIR_Coverage, 12878,
     /* 1825942 */     GIR_EraseRootFromParent_Done,
     /* 1825943 */   // Label 24735: @1825943
     /* 1825943 */   GIM_Try, /*On fail goto*//*Label 24736*/ GIMT_Encode4(1826029), // Rule ID 12879 //
     /* 1825948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1825956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1825959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1825962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1825965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1825968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825994 */     // MIs[0] policy
     /* 1825994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826004 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1826007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826028 */     // GIR_Coverage, 12879,
     /* 1826028 */     GIR_EraseRootFromParent_Done,
     /* 1826029 */   // Label 24736: @1826029
     /* 1826029 */   GIM_Try, /*On fail goto*//*Label 24737*/ GIMT_Encode4(1826115), // Rule ID 12882 //
     /* 1826034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1826042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1826045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1826048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1826054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826080 */     // MIs[0] policy
     /* 1826080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826090 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1826093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826114 */     // GIR_Coverage, 12882,
     /* 1826114 */     GIR_EraseRootFromParent_Done,
     /* 1826115 */   // Label 24737: @1826115
     /* 1826115 */   GIM_Try, /*On fail goto*//*Label 24738*/ GIMT_Encode4(1826201), // Rule ID 12883 //
     /* 1826120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1826128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1826131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1826134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1826140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826166 */     // MIs[0] policy
     /* 1826166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826176 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1826179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826200 */     // GIR_Coverage, 12883,
     /* 1826200 */     GIR_EraseRootFromParent_Done,
     /* 1826201 */   // Label 24738: @1826201
     /* 1826201 */   GIM_Try, /*On fail goto*//*Label 24739*/ GIMT_Encode4(1826287), // Rule ID 12886 //
     /* 1826206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1826214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1826217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1826220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1826226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826252 */     // MIs[0] policy
     /* 1826252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826262 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1826265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826286 */     // GIR_Coverage, 12886,
     /* 1826286 */     GIR_EraseRootFromParent_Done,
     /* 1826287 */   // Label 24739: @1826287
     /* 1826287 */   GIM_Try, /*On fail goto*//*Label 24740*/ GIMT_Encode4(1826373), // Rule ID 12887 //
     /* 1826292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1826300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1826303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1826306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1826312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826338 */     // MIs[0] policy
     /* 1826338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826348 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1826351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826372 */     // GIR_Coverage, 12887,
     /* 1826372 */     GIR_EraseRootFromParent_Done,
     /* 1826373 */   // Label 24740: @1826373
     /* 1826373 */   GIM_Try, /*On fail goto*//*Label 24741*/ GIMT_Encode4(1826459), // Rule ID 12890 //
     /* 1826378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1826386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1826389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1826392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1826398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826424 */     // MIs[0] policy
     /* 1826424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1826437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826458 */     // GIR_Coverage, 12890,
     /* 1826458 */     GIR_EraseRootFromParent_Done,
     /* 1826459 */   // Label 24741: @1826459
     /* 1826459 */   GIM_Try, /*On fail goto*//*Label 24742*/ GIMT_Encode4(1826545), // Rule ID 12891 //
     /* 1826464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1826472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1826475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1826478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1826484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826510 */     // MIs[0] policy
     /* 1826510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826520 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1826523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826544 */     // GIR_Coverage, 12891,
     /* 1826544 */     GIR_EraseRootFromParent_Done,
     /* 1826545 */   // Label 24742: @1826545
     /* 1826545 */   GIM_Try, /*On fail goto*//*Label 24743*/ GIMT_Encode4(1826631), // Rule ID 12894 //
     /* 1826550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1826561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1826564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1826567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1826570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1826573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826596 */     // MIs[0] policy
     /* 1826596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826606 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1826609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826630 */     // GIR_Coverage, 12894,
     /* 1826630 */     GIR_EraseRootFromParent_Done,
     /* 1826631 */   // Label 24743: @1826631
     /* 1826631 */   GIM_Try, /*On fail goto*//*Label 24744*/ GIMT_Encode4(1826717), // Rule ID 12895 //
     /* 1826636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1826647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1826650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1826653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1826656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1826659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826682 */     // MIs[0] policy
     /* 1826682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826692 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1826695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826716 */     // GIR_Coverage, 12895,
     /* 1826716 */     GIR_EraseRootFromParent_Done,
     /* 1826717 */   // Label 24744: @1826717
     /* 1826717 */   GIM_Try, /*On fail goto*//*Label 24745*/ GIMT_Encode4(1826803), // Rule ID 12898 //
     /* 1826722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1826733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1826736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1826739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1826742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826768 */     // MIs[0] policy
     /* 1826768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826778 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1826781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826802 */     // GIR_Coverage, 12898,
     /* 1826802 */     GIR_EraseRootFromParent_Done,
     /* 1826803 */   // Label 24745: @1826803
     /* 1826803 */   GIM_Try, /*On fail goto*//*Label 24746*/ GIMT_Encode4(1826889), // Rule ID 12899 //
     /* 1826808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1826819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1826822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1826825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1826828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826854 */     // MIs[0] policy
     /* 1826854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826864 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1826867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826888 */     // GIR_Coverage, 12899,
     /* 1826888 */     GIR_EraseRootFromParent_Done,
     /* 1826889 */   // Label 24746: @1826889
     /* 1826889 */   GIM_Try, /*On fail goto*//*Label 24747*/ GIMT_Encode4(1826975), // Rule ID 12902 //
     /* 1826894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1826905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1826908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1826911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1826914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826940 */     // MIs[0] policy
     /* 1826940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826950 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1826953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826974 */     // GIR_Coverage, 12902,
     /* 1826974 */     GIR_EraseRootFromParent_Done,
     /* 1826975 */   // Label 24747: @1826975
     /* 1826975 */   GIM_Try, /*On fail goto*//*Label 24748*/ GIMT_Encode4(1827061), // Rule ID 12903 //
     /* 1826980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1826991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1826994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1826997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1827000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827026 */     // MIs[0] policy
     /* 1827026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827036 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1827039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827060 */     // GIR_Coverage, 12903,
     /* 1827060 */     GIR_EraseRootFromParent_Done,
     /* 1827061 */   // Label 24748: @1827061
     /* 1827061 */   GIM_Try, /*On fail goto*//*Label 24749*/ GIMT_Encode4(1827147), // Rule ID 12906 //
     /* 1827066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1827077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1827080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1827083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1827086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827112 */     // MIs[0] policy
     /* 1827112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827122 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1827125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827146 */     // GIR_Coverage, 12906,
     /* 1827146 */     GIR_EraseRootFromParent_Done,
     /* 1827147 */   // Label 24749: @1827147
     /* 1827147 */   GIM_Try, /*On fail goto*//*Label 24750*/ GIMT_Encode4(1827233), // Rule ID 12907 //
     /* 1827152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1827163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1827166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1827169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1827172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827198 */     // MIs[0] policy
     /* 1827198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827208 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1827211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827232 */     // GIR_Coverage, 12907,
     /* 1827232 */     GIR_EraseRootFromParent_Done,
     /* 1827233 */   // Label 24750: @1827233
     /* 1827233 */   GIM_Try, /*On fail goto*//*Label 24751*/ GIMT_Encode4(1827319), // Rule ID 12910 //
     /* 1827238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1827249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1827252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1827255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1827258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827284 */     // MIs[0] policy
     /* 1827284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827294 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1827297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827318 */     // GIR_Coverage, 12910,
     /* 1827318 */     GIR_EraseRootFromParent_Done,
     /* 1827319 */   // Label 24751: @1827319
     /* 1827319 */   GIM_Try, /*On fail goto*//*Label 24752*/ GIMT_Encode4(1827405), // Rule ID 12911 //
     /* 1827324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1827335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1827338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1827341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1827344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827370 */     // MIs[0] policy
     /* 1827370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827380 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1827383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827404 */     // GIR_Coverage, 12911,
     /* 1827404 */     GIR_EraseRootFromParent_Done,
     /* 1827405 */   // Label 24752: @1827405
     /* 1827405 */   GIM_Try, /*On fail goto*//*Label 24753*/ GIMT_Encode4(1827491), // Rule ID 12914 //
     /* 1827410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1827421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1827424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1827427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1827430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827456 */     // MIs[0] policy
     /* 1827456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1827469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827490 */     // GIR_Coverage, 12914,
     /* 1827490 */     GIR_EraseRootFromParent_Done,
     /* 1827491 */   // Label 24753: @1827491
     /* 1827491 */   GIM_Try, /*On fail goto*//*Label 24754*/ GIMT_Encode4(1827577), // Rule ID 12915 //
     /* 1827496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1827507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1827510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1827513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1827516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827542 */     // MIs[0] policy
     /* 1827542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827552 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1827555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827576 */     // GIR_Coverage, 12915,
     /* 1827576 */     GIR_EraseRootFromParent_Done,
     /* 1827577 */   // Label 24754: @1827577
     /* 1827577 */   GIM_Try, /*On fail goto*//*Label 24755*/ GIMT_Encode4(1827663), // Rule ID 12918 //
     /* 1827582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1827593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1827596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1827599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1827602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827628 */     // MIs[0] policy
     /* 1827628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827638 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1827641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827662 */     // GIR_Coverage, 12918,
     /* 1827662 */     GIR_EraseRootFromParent_Done,
     /* 1827663 */   // Label 24755: @1827663
     /* 1827663 */   GIM_Try, /*On fail goto*//*Label 24756*/ GIMT_Encode4(1827749), // Rule ID 12919 //
     /* 1827668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1827679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1827682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1827685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1827688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827714 */     // MIs[0] policy
     /* 1827714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827724 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1827727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827748 */     // GIR_Coverage, 12919,
     /* 1827748 */     GIR_EraseRootFromParent_Done,
     /* 1827749 */   // Label 24756: @1827749
     /* 1827749 */   GIM_Try, /*On fail goto*//*Label 24757*/ GIMT_Encode4(1827835), // Rule ID 12922 //
     /* 1827754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1827765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1827768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1827771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1827774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827800 */     // MIs[0] policy
     /* 1827800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827810 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1827813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827834 */     // GIR_Coverage, 12922,
     /* 1827834 */     GIR_EraseRootFromParent_Done,
     /* 1827835 */   // Label 24757: @1827835
     /* 1827835 */   GIM_Try, /*On fail goto*//*Label 24758*/ GIMT_Encode4(1827921), // Rule ID 12923 //
     /* 1827840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1827851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1827854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1827857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1827860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827886 */     // MIs[0] policy
     /* 1827886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827896 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1827899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827920 */     // GIR_Coverage, 12923,
     /* 1827920 */     GIR_EraseRootFromParent_Done,
     /* 1827921 */   // Label 24758: @1827921
     /* 1827921 */   GIM_Try, /*On fail goto*//*Label 24759*/ GIMT_Encode4(1828007), // Rule ID 12926 //
     /* 1827926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1827937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1827940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1827943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1827946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827972 */     // MIs[0] policy
     /* 1827972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827982 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1827985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828006 */     // GIR_Coverage, 12926,
     /* 1828006 */     GIR_EraseRootFromParent_Done,
     /* 1828007 */   // Label 24759: @1828007
     /* 1828007 */   GIM_Try, /*On fail goto*//*Label 24760*/ GIMT_Encode4(1828093), // Rule ID 12927 //
     /* 1828012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1828023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1828026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1828029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1828032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828058 */     // MIs[0] policy
     /* 1828058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828068 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1828071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828092 */     // GIR_Coverage, 12927,
     /* 1828092 */     GIR_EraseRootFromParent_Done,
     /* 1828093 */   // Label 24760: @1828093
     /* 1828093 */   GIM_Try, /*On fail goto*//*Label 24761*/ GIMT_Encode4(1828179), // Rule ID 12930 //
     /* 1828098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1828101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1828109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1828112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1828115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1828118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828144 */     // MIs[0] policy
     /* 1828144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828154 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1828157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1828175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828178 */     // GIR_Coverage, 12930,
     /* 1828178 */     GIR_EraseRootFromParent_Done,
     /* 1828179 */   // Label 24761: @1828179
     /* 1828179 */   GIM_Try, /*On fail goto*//*Label 24762*/ GIMT_Encode4(1828265), // Rule ID 12931 //
     /* 1828184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1828187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1828195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1828198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1828201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1828204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828230 */     // MIs[0] policy
     /* 1828230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828240 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1828243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1828261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828264 */     // GIR_Coverage, 12931,
     /* 1828264 */     GIR_EraseRootFromParent_Done,
     /* 1828265 */   // Label 24762: @1828265
     /* 1828265 */   GIM_Try, /*On fail goto*//*Label 24763*/ GIMT_Encode4(1828351), // Rule ID 12934 //
     /* 1828270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1828281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1828284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1828287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1828290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1828293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828316 */     // MIs[0] policy
     /* 1828316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1828329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828350 */     // GIR_Coverage, 12934,
     /* 1828350 */     GIR_EraseRootFromParent_Done,
     /* 1828351 */   // Label 24763: @1828351
     /* 1828351 */   GIM_Try, /*On fail goto*//*Label 24764*/ GIMT_Encode4(1828437), // Rule ID 12935 //
     /* 1828356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1828367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1828370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1828373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1828376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1828379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828402 */     // MIs[0] policy
     /* 1828402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828412 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1828415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828436 */     // GIR_Coverage, 12935,
     /* 1828436 */     GIR_EraseRootFromParent_Done,
     /* 1828437 */   // Label 24764: @1828437
     /* 1828437 */   GIM_Try, /*On fail goto*//*Label 24765*/ GIMT_Encode4(1828523), // Rule ID 12938 //
     /* 1828442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1828453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1828456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1828459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1828462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1828465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1828472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828488 */     // MIs[0] policy
     /* 1828488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828498 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1828501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828522 */     // GIR_Coverage, 12938,
     /* 1828522 */     GIR_EraseRootFromParent_Done,
     /* 1828523 */   // Label 24765: @1828523
     /* 1828523 */   GIM_Try, /*On fail goto*//*Label 24766*/ GIMT_Encode4(1828609), // Rule ID 12939 //
     /* 1828528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1828539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1828542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1828545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1828548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1828551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1828558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828574 */     // MIs[0] policy
     /* 1828574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828584 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1828587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828608 */     // GIR_Coverage, 12939,
     /* 1828608 */     GIR_EraseRootFromParent_Done,
     /* 1828609 */   // Label 24766: @1828609
     /* 1828609 */   GIM_Try, /*On fail goto*//*Label 24767*/ GIMT_Encode4(1828695), // Rule ID 12942 //
     /* 1828614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1828625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1828628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1828631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1828634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1828637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1828644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828660 */     // MIs[0] policy
     /* 1828660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828670 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1828673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828694 */     // GIR_Coverage, 12942,
     /* 1828694 */     GIR_EraseRootFromParent_Done,
     /* 1828695 */   // Label 24767: @1828695
     /* 1828695 */   GIM_Try, /*On fail goto*//*Label 24768*/ GIMT_Encode4(1828781), // Rule ID 12943 //
     /* 1828700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1828711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1828714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1828717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1828720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1828723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1828730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828746 */     // MIs[0] policy
     /* 1828746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828756 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1828759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828780 */     // GIR_Coverage, 12943,
     /* 1828780 */     GIR_EraseRootFromParent_Done,
     /* 1828781 */   // Label 24768: @1828781
     /* 1828781 */   GIM_Try, /*On fail goto*//*Label 24769*/ GIMT_Encode4(1828867), // Rule ID 12946 //
     /* 1828786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1828797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1828800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1828803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1828806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828832 */     // MIs[0] policy
     /* 1828832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828842 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1828845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828866 */     // GIR_Coverage, 12946,
     /* 1828866 */     GIR_EraseRootFromParent_Done,
     /* 1828867 */   // Label 24769: @1828867
     /* 1828867 */   GIM_Try, /*On fail goto*//*Label 24770*/ GIMT_Encode4(1828953), // Rule ID 12947 //
     /* 1828872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1828883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1828886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1828889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1828892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828918 */     // MIs[0] policy
     /* 1828918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828928 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1828931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828952 */     // GIR_Coverage, 12947,
     /* 1828952 */     GIR_EraseRootFromParent_Done,
     /* 1828953 */   // Label 24770: @1828953
     /* 1828953 */   GIM_Try, /*On fail goto*//*Label 24771*/ GIMT_Encode4(1829039), // Rule ID 12950 //
     /* 1828958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1828969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1828972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1828975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1828978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1828981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1828988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829004 */     // MIs[0] policy
     /* 1829004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829014 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1829017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829038 */     // GIR_Coverage, 12950,
     /* 1829038 */     GIR_EraseRootFromParent_Done,
     /* 1829039 */   // Label 24771: @1829039
     /* 1829039 */   GIM_Try, /*On fail goto*//*Label 24772*/ GIMT_Encode4(1829125), // Rule ID 12951 //
     /* 1829044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1829055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1829058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1829061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1829064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829090 */     // MIs[0] policy
     /* 1829090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829100 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1829103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829124 */     // GIR_Coverage, 12951,
     /* 1829124 */     GIR_EraseRootFromParent_Done,
     /* 1829125 */   // Label 24772: @1829125
     /* 1829125 */   GIM_Try, /*On fail goto*//*Label 24773*/ GIMT_Encode4(1829211), // Rule ID 12954 //
     /* 1829130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1829141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1829144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1829147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1829150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829176 */     // MIs[0] policy
     /* 1829176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829186 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1829189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829210 */     // GIR_Coverage, 12954,
     /* 1829210 */     GIR_EraseRootFromParent_Done,
     /* 1829211 */   // Label 24773: @1829211
     /* 1829211 */   GIM_Try, /*On fail goto*//*Label 24774*/ GIMT_Encode4(1829297), // Rule ID 12955 //
     /* 1829216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1829227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1829230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1829233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1829236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829262 */     // MIs[0] policy
     /* 1829262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829272 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1829275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829296 */     // GIR_Coverage, 12955,
     /* 1829296 */     GIR_EraseRootFromParent_Done,
     /* 1829297 */   // Label 24774: @1829297
     /* 1829297 */   GIM_Try, /*On fail goto*//*Label 24775*/ GIMT_Encode4(1829383), // Rule ID 12958 //
     /* 1829302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1829313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1829316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1829319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1829322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829348 */     // MIs[0] policy
     /* 1829348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1829361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829382 */     // GIR_Coverage, 12958,
     /* 1829382 */     GIR_EraseRootFromParent_Done,
     /* 1829383 */   // Label 24775: @1829383
     /* 1829383 */   GIM_Try, /*On fail goto*//*Label 24776*/ GIMT_Encode4(1829469), // Rule ID 12959 //
     /* 1829388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1829399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1829402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1829405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1829408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829434 */     // MIs[0] policy
     /* 1829434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1829447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829468 */     // GIR_Coverage, 12959,
     /* 1829468 */     GIR_EraseRootFromParent_Done,
     /* 1829469 */   // Label 24776: @1829469
     /* 1829469 */   GIM_Try, /*On fail goto*//*Label 24777*/ GIMT_Encode4(1829555), // Rule ID 12962 //
     /* 1829474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1829485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1829488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1829491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1829494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829520 */     // MIs[0] policy
     /* 1829520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829530 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1829533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829554 */     // GIR_Coverage, 12962,
     /* 1829554 */     GIR_EraseRootFromParent_Done,
     /* 1829555 */   // Label 24777: @1829555
     /* 1829555 */   GIM_Try, /*On fail goto*//*Label 24778*/ GIMT_Encode4(1829641), // Rule ID 12963 //
     /* 1829560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1829571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1829574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1829577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1829580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829606 */     // MIs[0] policy
     /* 1829606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829616 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1829619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829640 */     // GIR_Coverage, 12963,
     /* 1829640 */     GIR_EraseRootFromParent_Done,
     /* 1829641 */   // Label 24778: @1829641
     /* 1829641 */   GIM_Try, /*On fail goto*//*Label 24779*/ GIMT_Encode4(1829727), // Rule ID 12966 //
     /* 1829646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1829657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1829660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1829663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1829666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829692 */     // MIs[0] policy
     /* 1829692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829702 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1829705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829726 */     // GIR_Coverage, 12966,
     /* 1829726 */     GIR_EraseRootFromParent_Done,
     /* 1829727 */   // Label 24779: @1829727
     /* 1829727 */   GIM_Try, /*On fail goto*//*Label 24780*/ GIMT_Encode4(1829813), // Rule ID 12967 //
     /* 1829732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1829743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1829746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1829749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1829752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829778 */     // MIs[0] policy
     /* 1829778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829788 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1829791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829812 */     // GIR_Coverage, 12967,
     /* 1829812 */     GIR_EraseRootFromParent_Done,
     /* 1829813 */   // Label 24780: @1829813
     /* 1829813 */   GIM_Try, /*On fail goto*//*Label 24781*/ GIMT_Encode4(1829899), // Rule ID 12970 //
     /* 1829818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1829821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1829829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1829832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1829835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1829838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1829841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829864 */     // MIs[0] policy
     /* 1829864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1829877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1829895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829898 */     // GIR_Coverage, 12970,
     /* 1829898 */     GIR_EraseRootFromParent_Done,
     /* 1829899 */   // Label 24781: @1829899
     /* 1829899 */   GIM_Try, /*On fail goto*//*Label 24782*/ GIMT_Encode4(1829985), // Rule ID 12971 //
     /* 1829904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1829907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1829915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1829918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1829921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1829924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1829927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829950 */     // MIs[0] policy
     /* 1829950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829960 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1829963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1829981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829984 */     // GIR_Coverage, 12971,
     /* 1829984 */     GIR_EraseRootFromParent_Done,
     /* 1829985 */   // Label 24782: @1829985
     /* 1829985 */   GIM_Try, /*On fail goto*//*Label 24783*/ GIMT_Encode4(1830071), // Rule ID 12974 //
     /* 1829990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1829993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1830001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1830004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1830007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1830010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830036 */     // MIs[0] policy
     /* 1830036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830046 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1830049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830070 */     // GIR_Coverage, 12974,
     /* 1830070 */     GIR_EraseRootFromParent_Done,
     /* 1830071 */   // Label 24783: @1830071
     /* 1830071 */   GIM_Try, /*On fail goto*//*Label 24784*/ GIMT_Encode4(1830157), // Rule ID 12975 //
     /* 1830076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1830079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1830087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1830090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1830093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1830096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830122 */     // MIs[0] policy
     /* 1830122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830132 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1830135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830156 */     // GIR_Coverage, 12975,
     /* 1830156 */     GIR_EraseRootFromParent_Done,
     /* 1830157 */   // Label 24784: @1830157
     /* 1830157 */   GIM_Try, /*On fail goto*//*Label 24785*/ GIMT_Encode4(1830243), // Rule ID 12978 //
     /* 1830162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1830165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1830173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1830176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1830179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1830182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830208 */     // MIs[0] policy
     /* 1830208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830218 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1830221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830242 */     // GIR_Coverage, 12978,
     /* 1830242 */     GIR_EraseRootFromParent_Done,
     /* 1830243 */   // Label 24785: @1830243
     /* 1830243 */   GIM_Try, /*On fail goto*//*Label 24786*/ GIMT_Encode4(1830329), // Rule ID 12979 //
     /* 1830248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1830251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1830259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1830262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1830265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1830268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830294 */     // MIs[0] policy
     /* 1830294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830304 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1830307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830328 */     // GIR_Coverage, 12979,
     /* 1830328 */     GIR_EraseRootFromParent_Done,
     /* 1830329 */   // Label 24786: @1830329
     /* 1830329 */   GIM_Try, /*On fail goto*//*Label 24787*/ GIMT_Encode4(1830415), // Rule ID 12982 //
     /* 1830334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1830345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1830348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1830354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830380 */     // MIs[0] policy
     /* 1830380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830390 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1830393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830414 */     // GIR_Coverage, 12982,
     /* 1830414 */     GIR_EraseRootFromParent_Done,
     /* 1830415 */   // Label 24787: @1830415
     /* 1830415 */   GIM_Try, /*On fail goto*//*Label 24788*/ GIMT_Encode4(1830501), // Rule ID 12983 //
     /* 1830420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1830431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1830434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1830440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830466 */     // MIs[0] policy
     /* 1830466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830476 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1830479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830500 */     // GIR_Coverage, 12983,
     /* 1830500 */     GIR_EraseRootFromParent_Done,
     /* 1830501 */   // Label 24788: @1830501
     /* 1830501 */   GIM_Try, /*On fail goto*//*Label 24789*/ GIMT_Encode4(1830587), // Rule ID 12986 //
     /* 1830506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1830517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1830520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1830526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830552 */     // MIs[0] policy
     /* 1830552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830562 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1830565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830586 */     // GIR_Coverage, 12986,
     /* 1830586 */     GIR_EraseRootFromParent_Done,
     /* 1830587 */   // Label 24789: @1830587
     /* 1830587 */   GIM_Try, /*On fail goto*//*Label 24790*/ GIMT_Encode4(1830673), // Rule ID 12987 //
     /* 1830592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1830603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1830606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1830612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830638 */     // MIs[0] policy
     /* 1830638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830648 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1830651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830672 */     // GIR_Coverage, 12987,
     /* 1830672 */     GIR_EraseRootFromParent_Done,
     /* 1830673 */   // Label 24790: @1830673
     /* 1830673 */   GIM_Try, /*On fail goto*//*Label 24791*/ GIMT_Encode4(1830759), // Rule ID 12990 //
     /* 1830678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1830689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1830692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1830698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830724 */     // MIs[0] policy
     /* 1830724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830734 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1830737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830758 */     // GIR_Coverage, 12990,
     /* 1830758 */     GIR_EraseRootFromParent_Done,
     /* 1830759 */   // Label 24791: @1830759
     /* 1830759 */   GIM_Try, /*On fail goto*//*Label 24792*/ GIMT_Encode4(1830845), // Rule ID 12991 //
     /* 1830764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1830775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1830778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1830784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830810 */     // MIs[0] policy
     /* 1830810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830820 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1830823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830844 */     // GIR_Coverage, 12991,
     /* 1830844 */     GIR_EraseRootFromParent_Done,
     /* 1830845 */   // Label 24792: @1830845
     /* 1830845 */   GIM_Try, /*On fail goto*//*Label 24793*/ GIMT_Encode4(1830931), // Rule ID 12994 //
     /* 1830850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1830861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1830864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1830870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830896 */     // MIs[0] policy
     /* 1830896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830906 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1830909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830930 */     // GIR_Coverage, 12994,
     /* 1830930 */     GIR_EraseRootFromParent_Done,
     /* 1830931 */   // Label 24793: @1830931
     /* 1830931 */   GIM_Try, /*On fail goto*//*Label 24794*/ GIMT_Encode4(1831017), // Rule ID 12995 //
     /* 1830936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1830947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1830950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1830956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830982 */     // MIs[0] policy
     /* 1830982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830992 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1830995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831016 */     // GIR_Coverage, 12995,
     /* 1831016 */     GIR_EraseRootFromParent_Done,
     /* 1831017 */   // Label 24794: @1831017
     /* 1831017 */   GIM_Try, /*On fail goto*//*Label 24795*/ GIMT_Encode4(1831103), // Rule ID 12998 //
     /* 1831022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1831030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1831033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1831036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1831039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1831042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831068 */     // MIs[0] policy
     /* 1831068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831078 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1831081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831102 */     // GIR_Coverage, 12998,
     /* 1831102 */     GIR_EraseRootFromParent_Done,
     /* 1831103 */   // Label 24795: @1831103
     /* 1831103 */   GIM_Try, /*On fail goto*//*Label 24796*/ GIMT_Encode4(1831189), // Rule ID 12999 //
     /* 1831108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1831116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1831119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1831122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1831125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1831128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831154 */     // MIs[0] policy
     /* 1831154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831164 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1831167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831188 */     // GIR_Coverage, 12999,
     /* 1831188 */     GIR_EraseRootFromParent_Done,
     /* 1831189 */   // Label 24796: @1831189
     /* 1831189 */   GIM_Try, /*On fail goto*//*Label 24797*/ GIMT_Encode4(1831275), // Rule ID 13002 //
     /* 1831194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1831202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1831205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1831208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1831211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1831214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831240 */     // MIs[0] policy
     /* 1831240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831250 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1831253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831274 */     // GIR_Coverage, 13002,
     /* 1831274 */     GIR_EraseRootFromParent_Done,
     /* 1831275 */   // Label 24797: @1831275
     /* 1831275 */   GIM_Try, /*On fail goto*//*Label 24798*/ GIMT_Encode4(1831361), // Rule ID 13003 //
     /* 1831280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1831288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1831291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1831294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1831297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1831300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831326 */     // MIs[0] policy
     /* 1831326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831336 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1831339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831360 */     // GIR_Coverage, 13003,
     /* 1831360 */     GIR_EraseRootFromParent_Done,
     /* 1831361 */   // Label 24798: @1831361
     /* 1831361 */   GIM_Try, /*On fail goto*//*Label 24799*/ GIMT_Encode4(1831447), // Rule ID 13006 //
     /* 1831366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1831374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1831377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1831380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1831383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1831386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831412 */     // MIs[0] policy
     /* 1831412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831422 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1831425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831446 */     // GIR_Coverage, 13006,
     /* 1831446 */     GIR_EraseRootFromParent_Done,
     /* 1831447 */   // Label 24799: @1831447
     /* 1831447 */   GIM_Try, /*On fail goto*//*Label 24800*/ GIMT_Encode4(1831533), // Rule ID 13007 //
     /* 1831452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1831460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1831463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1831466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1831469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1831472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831498 */     // MIs[0] policy
     /* 1831498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831508 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1831511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831532 */     // GIR_Coverage, 13007,
     /* 1831532 */     GIR_EraseRootFromParent_Done,
     /* 1831533 */   // Label 24800: @1831533
     /* 1831533 */   GIM_Try, /*On fail goto*//*Label 24801*/ GIMT_Encode4(1831619), // Rule ID 13010 //
     /* 1831538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1831546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1831549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1831552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1831555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1831558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831584 */     // MIs[0] policy
     /* 1831584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831594 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1831597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831618 */     // GIR_Coverage, 13010,
     /* 1831618 */     GIR_EraseRootFromParent_Done,
     /* 1831619 */   // Label 24801: @1831619
     /* 1831619 */   GIM_Try, /*On fail goto*//*Label 24802*/ GIMT_Encode4(1831705), // Rule ID 13011 //
     /* 1831624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1831632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1831635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1831638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1831641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1831644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831670 */     // MIs[0] policy
     /* 1831670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831680 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1831683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831704 */     // GIR_Coverage, 13011,
     /* 1831704 */     GIR_EraseRootFromParent_Done,
     /* 1831705 */   // Label 24802: @1831705
     /* 1831705 */   GIM_Try, /*On fail goto*//*Label 24803*/ GIMT_Encode4(1831791), // Rule ID 13014 //
     /* 1831710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1831718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1831721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1831724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1831727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1831730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831756 */     // MIs[0] policy
     /* 1831756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831766 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1831769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831790 */     // GIR_Coverage, 13014,
     /* 1831790 */     GIR_EraseRootFromParent_Done,
     /* 1831791 */   // Label 24803: @1831791
     /* 1831791 */   GIM_Try, /*On fail goto*//*Label 24804*/ GIMT_Encode4(1831877), // Rule ID 13015 //
     /* 1831796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1831804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1831807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1831810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1831813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1831816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831842 */     // MIs[0] policy
     /* 1831842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1831855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831876 */     // GIR_Coverage, 13015,
     /* 1831876 */     GIR_EraseRootFromParent_Done,
     /* 1831877 */   // Label 24804: @1831877
     /* 1831877 */   GIM_Try, /*On fail goto*//*Label 24805*/ GIMT_Encode4(1831963), // Rule ID 13018 //
     /* 1831882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1831885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1831890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1831893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1831896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1831899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1831902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831928 */     // MIs[0] policy
     /* 1831928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831938 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1831941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831962 */     // GIR_Coverage, 13018,
     /* 1831962 */     GIR_EraseRootFromParent_Done,
     /* 1831963 */   // Label 24805: @1831963
     /* 1831963 */   GIM_Try, /*On fail goto*//*Label 24806*/ GIMT_Encode4(1832049), // Rule ID 13019 //
     /* 1831968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1831971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1831976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1831979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1831982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1831985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1831988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832014 */     // MIs[0] policy
     /* 1832014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832024 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1832027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1832045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832048 */     // GIR_Coverage, 13019,
     /* 1832048 */     GIR_EraseRootFromParent_Done,
     /* 1832049 */   // Label 24806: @1832049
     /* 1832049 */   GIM_Try, /*On fail goto*//*Label 24807*/ GIMT_Encode4(1832135), // Rule ID 13022 //
     /* 1832054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1832062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1832065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1832068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1832071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1832074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832100 */     // MIs[0] policy
     /* 1832100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832110 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1832113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832134 */     // GIR_Coverage, 13022,
     /* 1832134 */     GIR_EraseRootFromParent_Done,
     /* 1832135 */   // Label 24807: @1832135
     /* 1832135 */   GIM_Try, /*On fail goto*//*Label 24808*/ GIMT_Encode4(1832221), // Rule ID 13023 //
     /* 1832140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1832148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1832151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1832154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1832157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1832160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832186 */     // MIs[0] policy
     /* 1832186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832196 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1832199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832220 */     // GIR_Coverage, 13023,
     /* 1832220 */     GIR_EraseRootFromParent_Done,
     /* 1832221 */   // Label 24808: @1832221
     /* 1832221 */   GIM_Try, /*On fail goto*//*Label 24809*/ GIMT_Encode4(1832307), // Rule ID 13026 //
     /* 1832226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1832234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1832237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1832240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1832243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1832246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832272 */     // MIs[0] policy
     /* 1832272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832282 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1832285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832306 */     // GIR_Coverage, 13026,
     /* 1832306 */     GIR_EraseRootFromParent_Done,
     /* 1832307 */   // Label 24809: @1832307
     /* 1832307 */   GIM_Try, /*On fail goto*//*Label 24810*/ GIMT_Encode4(1832393), // Rule ID 13027 //
     /* 1832312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1832320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1832323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1832326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1832329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1832332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832358 */     // MIs[0] policy
     /* 1832358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832368 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1832371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832392 */     // GIR_Coverage, 13027,
     /* 1832392 */     GIR_EraseRootFromParent_Done,
     /* 1832393 */   // Label 24810: @1832393
     /* 1832393 */   GIM_Try, /*On fail goto*//*Label 24811*/ GIMT_Encode4(1832479), // Rule ID 13030 //
     /* 1832398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1832406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1832409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1832412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1832415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1832418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1832421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832444 */     // MIs[0] policy
     /* 1832444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832454 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1832457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832478 */     // GIR_Coverage, 13030,
     /* 1832478 */     GIR_EraseRootFromParent_Done,
     /* 1832479 */   // Label 24811: @1832479
     /* 1832479 */   GIM_Try, /*On fail goto*//*Label 24812*/ GIMT_Encode4(1832565), // Rule ID 13031 //
     /* 1832484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1832492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1832495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1832498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1832501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1832504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1832507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832530 */     // MIs[0] policy
     /* 1832530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832540 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1832543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832564 */     // GIR_Coverage, 13031,
     /* 1832564 */     GIR_EraseRootFromParent_Done,
     /* 1832565 */   // Label 24812: @1832565
     /* 1832565 */   GIM_Try, /*On fail goto*//*Label 24813*/ GIMT_Encode4(1832651), // Rule ID 13034 //
     /* 1832570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1832578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1832581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1832584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1832587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1832590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1832593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832616 */     // MIs[0] policy
     /* 1832616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1832629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832650 */     // GIR_Coverage, 13034,
     /* 1832650 */     GIR_EraseRootFromParent_Done,
     /* 1832651 */   // Label 24813: @1832651
     /* 1832651 */   GIM_Try, /*On fail goto*//*Label 24814*/ GIMT_Encode4(1832737), // Rule ID 13035 //
     /* 1832656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1832664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1832667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1832670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1832673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1832676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1832679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832702 */     // MIs[0] policy
     /* 1832702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1832715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832736 */     // GIR_Coverage, 13035,
     /* 1832736 */     GIR_EraseRootFromParent_Done,
     /* 1832737 */   // Label 24814: @1832737
     /* 1832737 */   GIM_Try, /*On fail goto*//*Label 24815*/ GIMT_Encode4(1832823), // Rule ID 13038 //
     /* 1832742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1832750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1832753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1832756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1832759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1832762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832788 */     // MIs[0] policy
     /* 1832788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832798 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1832801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832822 */     // GIR_Coverage, 13038,
     /* 1832822 */     GIR_EraseRootFromParent_Done,
     /* 1832823 */   // Label 24815: @1832823
     /* 1832823 */   GIM_Try, /*On fail goto*//*Label 24816*/ GIMT_Encode4(1832909), // Rule ID 13039 //
     /* 1832828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1832836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1832839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1832842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1832845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1832848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832874 */     // MIs[0] policy
     /* 1832874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832884 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1832887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832908 */     // GIR_Coverage, 13039,
     /* 1832908 */     GIR_EraseRootFromParent_Done,
     /* 1832909 */   // Label 24816: @1832909
     /* 1832909 */   GIM_Try, /*On fail goto*//*Label 24817*/ GIMT_Encode4(1832995), // Rule ID 13042 //
     /* 1832914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1832922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1832925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1832928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1832931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1832934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832960 */     // MIs[0] policy
     /* 1832960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832970 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1832973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832994 */     // GIR_Coverage, 13042,
     /* 1832994 */     GIR_EraseRootFromParent_Done,
     /* 1832995 */   // Label 24817: @1832995
     /* 1832995 */   GIM_Try, /*On fail goto*//*Label 24818*/ GIMT_Encode4(1833081), // Rule ID 13043 //
     /* 1833000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1833008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1833011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1833014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1833017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1833020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1833023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833046 */     // MIs[0] policy
     /* 1833046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833056 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1833059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833080 */     // GIR_Coverage, 13043,
     /* 1833080 */     GIR_EraseRootFromParent_Done,
     /* 1833081 */   // Label 24818: @1833081
     /* 1833081 */   GIM_Try, /*On fail goto*//*Label 24819*/ GIMT_Encode4(1833167), // Rule ID 13046 //
     /* 1833086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1833094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1833097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1833100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1833103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1833106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833132 */     // MIs[0] policy
     /* 1833132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833142 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1833145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833166 */     // GIR_Coverage, 13046,
     /* 1833166 */     GIR_EraseRootFromParent_Done,
     /* 1833167 */   // Label 24819: @1833167
     /* 1833167 */   GIM_Try, /*On fail goto*//*Label 24820*/ GIMT_Encode4(1833253), // Rule ID 13047 //
     /* 1833172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1833180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1833183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1833186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1833189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1833192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833218 */     // MIs[0] policy
     /* 1833218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1833231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833252 */     // GIR_Coverage, 13047,
     /* 1833252 */     GIR_EraseRootFromParent_Done,
     /* 1833253 */   // Label 24820: @1833253
     /* 1833253 */   GIM_Try, /*On fail goto*//*Label 24821*/ GIMT_Encode4(1833339), // Rule ID 13050 //
     /* 1833258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1833266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1833269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1833272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1833275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1833278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833304 */     // MIs[0] policy
     /* 1833304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1833317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833338 */     // GIR_Coverage, 13050,
     /* 1833338 */     GIR_EraseRootFromParent_Done,
     /* 1833339 */   // Label 24821: @1833339
     /* 1833339 */   GIM_Try, /*On fail goto*//*Label 24822*/ GIMT_Encode4(1833425), // Rule ID 13051 //
     /* 1833344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1833352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1833355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1833358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1833361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1833364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833390 */     // MIs[0] policy
     /* 1833390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833400 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1833403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833424 */     // GIR_Coverage, 13051,
     /* 1833424 */     GIR_EraseRootFromParent_Done,
     /* 1833425 */   // Label 24822: @1833425
     /* 1833425 */   GIM_Try, /*On fail goto*//*Label 24823*/ GIMT_Encode4(1833511), // Rule ID 13054 //
     /* 1833430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1833438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1833441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1833444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1833447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1833450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833476 */     // MIs[0] policy
     /* 1833476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1833489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833510 */     // GIR_Coverage, 13054,
     /* 1833510 */     GIR_EraseRootFromParent_Done,
     /* 1833511 */   // Label 24823: @1833511
     /* 1833511 */   GIM_Try, /*On fail goto*//*Label 24824*/ GIMT_Encode4(1833597), // Rule ID 13055 //
     /* 1833516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1833524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1833527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1833530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1833533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1833536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833562 */     // MIs[0] policy
     /* 1833562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833572 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1833575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833596 */     // GIR_Coverage, 13055,
     /* 1833596 */     GIR_EraseRootFromParent_Done,
     /* 1833597 */   // Label 24824: @1833597
     /* 1833597 */   GIM_Try, /*On fail goto*//*Label 24825*/ GIMT_Encode4(1833683), // Rule ID 13058 //
     /* 1833602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1833605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1833610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1833613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1833616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1833619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1833622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1833625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833648 */     // MIs[0] policy
     /* 1833648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833658 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1833661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833682 */     // GIR_Coverage, 13058,
     /* 1833682 */     GIR_EraseRootFromParent_Done,
     /* 1833683 */   // Label 24825: @1833683
     /* 1833683 */   GIM_Try, /*On fail goto*//*Label 24826*/ GIMT_Encode4(1833769), // Rule ID 13059 //
     /* 1833688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1833691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1833696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1833699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1833702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1833705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1833708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1833711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833734 */     // MIs[0] policy
     /* 1833734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1833747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833768 */     // GIR_Coverage, 13059,
     /* 1833768 */     GIR_EraseRootFromParent_Done,
     /* 1833769 */   // Label 24826: @1833769
     /* 1833769 */   GIM_Try, /*On fail goto*//*Label 24827*/ GIMT_Encode4(1833855), // Rule ID 13062 //
     /* 1833774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1833777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1833782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1833785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1833788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1833791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1833794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833820 */     // MIs[0] policy
     /* 1833820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833830 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1833833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833854 */     // GIR_Coverage, 13062,
     /* 1833854 */     GIR_EraseRootFromParent_Done,
     /* 1833855 */   // Label 24827: @1833855
     /* 1833855 */   GIM_Try, /*On fail goto*//*Label 24828*/ GIMT_Encode4(1833941), // Rule ID 13063 //
     /* 1833860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1833863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1833868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1833871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1833874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1833877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1833880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833906 */     // MIs[0] policy
     /* 1833906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833916 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1833919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833940 */     // GIR_Coverage, 13063,
     /* 1833940 */     GIR_EraseRootFromParent_Done,
     /* 1833941 */   // Label 24828: @1833941
     /* 1833941 */   GIM_Try, /*On fail goto*//*Label 24829*/ GIMT_Encode4(1834027), // Rule ID 13066 //
     /* 1833946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1833949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1833954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1833957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1833960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1833963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1833966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833992 */     // MIs[0] policy
     /* 1833992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834002 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1834005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834026 */     // GIR_Coverage, 13066,
     /* 1834026 */     GIR_EraseRootFromParent_Done,
     /* 1834027 */   // Label 24829: @1834027
     /* 1834027 */   GIM_Try, /*On fail goto*//*Label 24830*/ GIMT_Encode4(1834113), // Rule ID 13067 //
     /* 1834032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1834035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1834040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1834043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1834046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1834052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834078 */     // MIs[0] policy
     /* 1834078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834088 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1834091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834112 */     // GIR_Coverage, 13067,
     /* 1834112 */     GIR_EraseRootFromParent_Done,
     /* 1834113 */   // Label 24830: @1834113
     /* 1834113 */   GIM_Try, /*On fail goto*//*Label 24831*/ GIMT_Encode4(1834199), // Rule ID 13070 //
     /* 1834118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1834129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1834132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1834135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1834138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834164 */     // MIs[0] policy
     /* 1834164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834174 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1834177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834198 */     // GIR_Coverage, 13070,
     /* 1834198 */     GIR_EraseRootFromParent_Done,
     /* 1834199 */   // Label 24831: @1834199
     /* 1834199 */   GIM_Try, /*On fail goto*//*Label 24832*/ GIMT_Encode4(1834285), // Rule ID 13071 //
     /* 1834204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1834215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1834218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1834221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1834224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834250 */     // MIs[0] policy
     /* 1834250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834260 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1834263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834284 */     // GIR_Coverage, 13071,
     /* 1834284 */     GIR_EraseRootFromParent_Done,
     /* 1834285 */   // Label 24832: @1834285
     /* 1834285 */   GIM_Try, /*On fail goto*//*Label 24833*/ GIMT_Encode4(1834371), // Rule ID 13074 //
     /* 1834290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1834301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1834304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1834307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1834310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834336 */     // MIs[0] policy
     /* 1834336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1834349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834370 */     // GIR_Coverage, 13074,
     /* 1834370 */     GIR_EraseRootFromParent_Done,
     /* 1834371 */   // Label 24833: @1834371
     /* 1834371 */   GIM_Try, /*On fail goto*//*Label 24834*/ GIMT_Encode4(1834457), // Rule ID 13075 //
     /* 1834376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1834387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1834390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1834393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1834396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834422 */     // MIs[0] policy
     /* 1834422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834432 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1834435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834456 */     // GIR_Coverage, 13075,
     /* 1834456 */     GIR_EraseRootFromParent_Done,
     /* 1834457 */   // Label 24834: @1834457
     /* 1834457 */   GIM_Try, /*On fail goto*//*Label 24835*/ GIMT_Encode4(1834543), // Rule ID 13078 //
     /* 1834462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1834473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1834476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1834479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1834482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834508 */     // MIs[0] policy
     /* 1834508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834518 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1834521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834542 */     // GIR_Coverage, 13078,
     /* 1834542 */     GIR_EraseRootFromParent_Done,
     /* 1834543 */   // Label 24835: @1834543
     /* 1834543 */   GIM_Try, /*On fail goto*//*Label 24836*/ GIMT_Encode4(1834629), // Rule ID 13079 //
     /* 1834548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1834559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1834562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1834565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1834568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834594 */     // MIs[0] policy
     /* 1834594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834604 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1834607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834628 */     // GIR_Coverage, 13079,
     /* 1834628 */     GIR_EraseRootFromParent_Done,
     /* 1834629 */   // Label 24836: @1834629
     /* 1834629 */   GIM_Try, /*On fail goto*//*Label 24837*/ GIMT_Encode4(1834715), // Rule ID 13082 //
     /* 1834634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1834645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1834648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1834651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1834654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834680 */     // MIs[0] policy
     /* 1834680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834690 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1834693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834714 */     // GIR_Coverage, 13082,
     /* 1834714 */     GIR_EraseRootFromParent_Done,
     /* 1834715 */   // Label 24837: @1834715
     /* 1834715 */   GIM_Try, /*On fail goto*//*Label 24838*/ GIMT_Encode4(1834801), // Rule ID 13083 //
     /* 1834720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1834731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1834734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1834737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1834740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834766 */     // MIs[0] policy
     /* 1834766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834776 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1834779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834800 */     // GIR_Coverage, 13083,
     /* 1834800 */     GIR_EraseRootFromParent_Done,
     /* 1834801 */   // Label 24838: @1834801
     /* 1834801 */   GIM_Try, /*On fail goto*//*Label 24839*/ GIMT_Encode4(1834887), // Rule ID 13086 //
     /* 1834806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1834817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1834820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1834823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1834826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834852 */     // MIs[0] policy
     /* 1834852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834862 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1834865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834886 */     // GIR_Coverage, 13086,
     /* 1834886 */     GIR_EraseRootFromParent_Done,
     /* 1834887 */   // Label 24839: @1834887
     /* 1834887 */   GIM_Try, /*On fail goto*//*Label 24840*/ GIMT_Encode4(1834973), // Rule ID 13087 //
     /* 1834892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1834903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1834906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1834909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1834912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834938 */     // MIs[0] policy
     /* 1834938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834948 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1834951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834972 */     // GIR_Coverage, 13087,
     /* 1834972 */     GIR_EraseRootFromParent_Done,
     /* 1834973 */   // Label 24840: @1834973
     /* 1834973 */   GIM_Try, /*On fail goto*//*Label 24841*/ GIMT_Encode4(1835059), // Rule ID 13090 //
     /* 1834978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1834989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1834992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1834995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1834998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835024 */     // MIs[0] policy
     /* 1835024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1835037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835058 */     // GIR_Coverage, 13090,
     /* 1835058 */     GIR_EraseRootFromParent_Done,
     /* 1835059 */   // Label 24841: @1835059
     /* 1835059 */   GIM_Try, /*On fail goto*//*Label 24842*/ GIMT_Encode4(1835145), // Rule ID 13091 //
     /* 1835064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1835075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1835078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1835081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1835084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835110 */     // MIs[0] policy
     /* 1835110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835120 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1835123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835144 */     // GIR_Coverage, 13091,
     /* 1835144 */     GIR_EraseRootFromParent_Done,
     /* 1835145 */   // Label 24842: @1835145
     /* 1835145 */   GIM_Try, /*On fail goto*//*Label 24843*/ GIMT_Encode4(1835231), // Rule ID 13094 //
     /* 1835150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1835161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1835164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1835167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1835170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835196 */     // MIs[0] policy
     /* 1835196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835206 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1835209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835230 */     // GIR_Coverage, 13094,
     /* 1835230 */     GIR_EraseRootFromParent_Done,
     /* 1835231 */   // Label 24843: @1835231
     /* 1835231 */   GIM_Try, /*On fail goto*//*Label 24844*/ GIMT_Encode4(1835317), // Rule ID 13095 //
     /* 1835236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1835247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1835250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1835253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1835256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835282 */     // MIs[0] policy
     /* 1835282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835292 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1835295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835316 */     // GIR_Coverage, 13095,
     /* 1835316 */     GIR_EraseRootFromParent_Done,
     /* 1835317 */   // Label 24844: @1835317
     /* 1835317 */   GIM_Try, /*On fail goto*//*Label 24845*/ GIMT_Encode4(1835403), // Rule ID 13098 //
     /* 1835322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1835333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1835336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1835339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1835342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835368 */     // MIs[0] policy
     /* 1835368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835378 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1835381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835402 */     // GIR_Coverage, 13098,
     /* 1835402 */     GIR_EraseRootFromParent_Done,
     /* 1835403 */   // Label 24845: @1835403
     /* 1835403 */   GIM_Try, /*On fail goto*//*Label 24846*/ GIMT_Encode4(1835489), // Rule ID 13099 //
     /* 1835408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1835419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1835422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1835425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1835428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835454 */     // MIs[0] policy
     /* 1835454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835464 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1835467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835488 */     // GIR_Coverage, 13099,
     /* 1835488 */     GIR_EraseRootFromParent_Done,
     /* 1835489 */   // Label 24846: @1835489
     /* 1835489 */   GIM_Try, /*On fail goto*//*Label 24847*/ GIMT_Encode4(1835575), // Rule ID 13102 //
     /* 1835494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1835505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1835508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1835511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1835514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835540 */     // MIs[0] policy
     /* 1835540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1835553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835574 */     // GIR_Coverage, 13102,
     /* 1835574 */     GIR_EraseRootFromParent_Done,
     /* 1835575 */   // Label 24847: @1835575
     /* 1835575 */   GIM_Try, /*On fail goto*//*Label 24848*/ GIMT_Encode4(1835661), // Rule ID 13103 //
     /* 1835580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1835591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1835594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1835597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1835600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835626 */     // MIs[0] policy
     /* 1835626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835636 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1835639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835660 */     // GIR_Coverage, 13103,
     /* 1835660 */     GIR_EraseRootFromParent_Done,
     /* 1835661 */   // Label 24848: @1835661
     /* 1835661 */   GIM_Try, /*On fail goto*//*Label 24849*/ GIMT_Encode4(1835747), // Rule ID 13106 //
     /* 1835666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1835669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1835677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1835680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1835683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1835686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835712 */     // MIs[0] policy
     /* 1835712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835722 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1835725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835746 */     // GIR_Coverage, 13106,
     /* 1835746 */     GIR_EraseRootFromParent_Done,
     /* 1835747 */   // Label 24849: @1835747
     /* 1835747 */   GIM_Try, /*On fail goto*//*Label 24850*/ GIMT_Encode4(1835833), // Rule ID 13107 //
     /* 1835752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1835755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1835763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1835766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1835769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1835772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835798 */     // MIs[0] policy
     /* 1835798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1835811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835832 */     // GIR_Coverage, 13107,
     /* 1835832 */     GIR_EraseRootFromParent_Done,
     /* 1835833 */   // Label 24850: @1835833
     /* 1835833 */   GIM_Try, /*On fail goto*//*Label 24851*/ GIMT_Encode4(1835919), // Rule ID 13110 //
     /* 1835838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1835849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1835852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1835855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1835858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1835861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1835868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835884 */     // MIs[0] policy
     /* 1835884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835894 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1835897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835918 */     // GIR_Coverage, 13110,
     /* 1835918 */     GIR_EraseRootFromParent_Done,
     /* 1835919 */   // Label 24851: @1835919
     /* 1835919 */   GIM_Try, /*On fail goto*//*Label 24852*/ GIMT_Encode4(1836005), // Rule ID 13111 //
     /* 1835924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1835935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1835938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1835941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1835944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1835947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1835954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835970 */     // MIs[0] policy
     /* 1835970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835980 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1835983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836004 */     // GIR_Coverage, 13111,
     /* 1836004 */     GIR_EraseRootFromParent_Done,
     /* 1836005 */   // Label 24852: @1836005
     /* 1836005 */   GIM_Try, /*On fail goto*//*Label 24853*/ GIMT_Encode4(1836091), // Rule ID 13114 //
     /* 1836010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1836021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1836024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1836027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1836030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836056 */     // MIs[0] policy
     /* 1836056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836066 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1836069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836090 */     // GIR_Coverage, 13114,
     /* 1836090 */     GIR_EraseRootFromParent_Done,
     /* 1836091 */   // Label 24853: @1836091
     /* 1836091 */   GIM_Try, /*On fail goto*//*Label 24854*/ GIMT_Encode4(1836177), // Rule ID 13115 //
     /* 1836096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1836107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1836110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1836113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1836116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836142 */     // MIs[0] policy
     /* 1836142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836152 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1836155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836176 */     // GIR_Coverage, 13115,
     /* 1836176 */     GIR_EraseRootFromParent_Done,
     /* 1836177 */   // Label 24854: @1836177
     /* 1836177 */   GIM_Try, /*On fail goto*//*Label 24855*/ GIMT_Encode4(1836263), // Rule ID 13118 //
     /* 1836182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1836193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1836196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1836199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1836202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1836205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836228 */     // MIs[0] policy
     /* 1836228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836238 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1836241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836262 */     // GIR_Coverage, 13118,
     /* 1836262 */     GIR_EraseRootFromParent_Done,
     /* 1836263 */   // Label 24855: @1836263
     /* 1836263 */   GIM_Try, /*On fail goto*//*Label 24856*/ GIMT_Encode4(1836349), // Rule ID 13119 //
     /* 1836268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1836279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1836282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1836285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1836288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1836291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836314 */     // MIs[0] policy
     /* 1836314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836324 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1836327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836348 */     // GIR_Coverage, 13119,
     /* 1836348 */     GIR_EraseRootFromParent_Done,
     /* 1836349 */   // Label 24856: @1836349
     /* 1836349 */   GIM_Try, /*On fail goto*//*Label 24857*/ GIMT_Encode4(1836435), // Rule ID 13122 //
     /* 1836354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1836365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1836368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1836371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1836374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836400 */     // MIs[0] policy
     /* 1836400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836410 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1836413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836434 */     // GIR_Coverage, 13122,
     /* 1836434 */     GIR_EraseRootFromParent_Done,
     /* 1836435 */   // Label 24857: @1836435
     /* 1836435 */   GIM_Try, /*On fail goto*//*Label 24858*/ GIMT_Encode4(1836521), // Rule ID 13123 //
     /* 1836440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1836451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1836454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1836457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1836460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836486 */     // MIs[0] policy
     /* 1836486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836496 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1836499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836520 */     // GIR_Coverage, 13123,
     /* 1836520 */     GIR_EraseRootFromParent_Done,
     /* 1836521 */   // Label 24858: @1836521
     /* 1836521 */   GIM_Try, /*On fail goto*//*Label 24859*/ GIMT_Encode4(1836607), // Rule ID 13126 //
     /* 1836526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1836537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1836540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1836543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1836546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836572 */     // MIs[0] policy
     /* 1836572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836582 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1836585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836606 */     // GIR_Coverage, 13126,
     /* 1836606 */     GIR_EraseRootFromParent_Done,
     /* 1836607 */   // Label 24859: @1836607
     /* 1836607 */   GIM_Try, /*On fail goto*//*Label 24860*/ GIMT_Encode4(1836693), // Rule ID 13127 //
     /* 1836612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1836623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1836626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1836629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1836632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836658 */     // MIs[0] policy
     /* 1836658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836668 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1836671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836692 */     // GIR_Coverage, 13127,
     /* 1836692 */     GIR_EraseRootFromParent_Done,
     /* 1836693 */   // Label 24860: @1836693
     /* 1836693 */   GIM_Try, /*On fail goto*//*Label 24861*/ GIMT_Encode4(1836779), // Rule ID 13130 //
     /* 1836698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1836709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1836712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1836715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1836718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836744 */     // MIs[0] policy
     /* 1836744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836754 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1836757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836778 */     // GIR_Coverage, 13130,
     /* 1836778 */     GIR_EraseRootFromParent_Done,
     /* 1836779 */   // Label 24861: @1836779
     /* 1836779 */   GIM_Try, /*On fail goto*//*Label 24862*/ GIMT_Encode4(1836865), // Rule ID 13131 //
     /* 1836784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1836795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1836798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1836801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1836804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836830 */     // MIs[0] policy
     /* 1836830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836840 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1836843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836864 */     // GIR_Coverage, 13131,
     /* 1836864 */     GIR_EraseRootFromParent_Done,
     /* 1836865 */   // Label 24862: @1836865
     /* 1836865 */   GIM_Try, /*On fail goto*//*Label 24863*/ GIMT_Encode4(1836951), // Rule ID 13134 //
     /* 1836870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1836881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1836884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1836887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1836890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1836893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836916 */     // MIs[0] policy
     /* 1836916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1836929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836950 */     // GIR_Coverage, 13134,
     /* 1836950 */     GIR_EraseRootFromParent_Done,
     /* 1836951 */   // Label 24863: @1836951
     /* 1836951 */   GIM_Try, /*On fail goto*//*Label 24864*/ GIMT_Encode4(1837037), // Rule ID 13135 //
     /* 1836956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1836967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1836970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1836973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1836976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1836979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837002 */     // MIs[0] policy
     /* 1837002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837012 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1837015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837036 */     // GIR_Coverage, 13135,
     /* 1837036 */     GIR_EraseRootFromParent_Done,
     /* 1837037 */   // Label 24864: @1837037
     /* 1837037 */   GIM_Try, /*On fail goto*//*Label 24865*/ GIMT_Encode4(1837123), // Rule ID 13138 //
     /* 1837042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1837053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1837056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1837059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1837062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837088 */     // MIs[0] policy
     /* 1837088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837098 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1837101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837122 */     // GIR_Coverage, 13138,
     /* 1837122 */     GIR_EraseRootFromParent_Done,
     /* 1837123 */   // Label 24865: @1837123
     /* 1837123 */   GIM_Try, /*On fail goto*//*Label 24866*/ GIMT_Encode4(1837209), // Rule ID 13139 //
     /* 1837128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1837139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1837142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1837145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1837148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837174 */     // MIs[0] policy
     /* 1837174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837184 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1837187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837208 */     // GIR_Coverage, 13139,
     /* 1837208 */     GIR_EraseRootFromParent_Done,
     /* 1837209 */   // Label 24866: @1837209
     /* 1837209 */   GIM_Try, /*On fail goto*//*Label 24867*/ GIMT_Encode4(1837295), // Rule ID 13142 //
     /* 1837214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1837225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1837228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1837231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1837234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837260 */     // MIs[0] policy
     /* 1837260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837270 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1837273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837294 */     // GIR_Coverage, 13142,
     /* 1837294 */     GIR_EraseRootFromParent_Done,
     /* 1837295 */   // Label 24867: @1837295
     /* 1837295 */   GIM_Try, /*On fail goto*//*Label 24868*/ GIMT_Encode4(1837381), // Rule ID 13143 //
     /* 1837300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1837311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1837314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1837317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1837320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837346 */     // MIs[0] policy
     /* 1837346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837356 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1837359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837380 */     // GIR_Coverage, 13143,
     /* 1837380 */     GIR_EraseRootFromParent_Done,
     /* 1837381 */   // Label 24868: @1837381
     /* 1837381 */   GIM_Try, /*On fail goto*//*Label 24869*/ GIMT_Encode4(1837467), // Rule ID 13146 //
     /* 1837386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1837397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1837400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1837403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1837406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837432 */     // MIs[0] policy
     /* 1837432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837442 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1837445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837466 */     // GIR_Coverage, 13146,
     /* 1837466 */     GIR_EraseRootFromParent_Done,
     /* 1837467 */   // Label 24869: @1837467
     /* 1837467 */   GIM_Try, /*On fail goto*//*Label 24870*/ GIMT_Encode4(1837553), // Rule ID 13147 //
     /* 1837472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1837475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1837483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1837486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1837489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1837492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837518 */     // MIs[0] policy
     /* 1837518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837528 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1837531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837552 */     // GIR_Coverage, 13147,
     /* 1837552 */     GIR_EraseRootFromParent_Done,
     /* 1837553 */   // Label 24870: @1837553
     /* 1837553 */   GIM_Try, /*On fail goto*//*Label 24871*/ GIMT_Encode4(1837639), // Rule ID 13150 //
     /* 1837558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1837569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1837572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1837575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1837578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837604 */     // MIs[0] policy
     /* 1837604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837614 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1837617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837638 */     // GIR_Coverage, 13150,
     /* 1837638 */     GIR_EraseRootFromParent_Done,
     /* 1837639 */   // Label 24871: @1837639
     /* 1837639 */   GIM_Try, /*On fail goto*//*Label 24872*/ GIMT_Encode4(1837725), // Rule ID 13151 //
     /* 1837644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1837647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1837655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1837658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1837661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1837664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837690 */     // MIs[0] policy
     /* 1837690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837700 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1837703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837724 */     // GIR_Coverage, 13151,
     /* 1837724 */     GIR_EraseRootFromParent_Done,
     /* 1837725 */   // Label 24872: @1837725
     /* 1837725 */   GIM_Try, /*On fail goto*//*Label 24873*/ GIMT_Encode4(1837811), // Rule ID 13154 //
     /* 1837730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1837741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1837744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1837747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1837750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837776 */     // MIs[0] policy
     /* 1837776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1837789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837810 */     // GIR_Coverage, 13154,
     /* 1837810 */     GIR_EraseRootFromParent_Done,
     /* 1837811 */   // Label 24873: @1837811
     /* 1837811 */   GIM_Try, /*On fail goto*//*Label 24874*/ GIMT_Encode4(1837897), // Rule ID 13155 //
     /* 1837816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1837819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1837827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1837830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1837833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1837836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837862 */     // MIs[0] policy
     /* 1837862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837872 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1837875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837896 */     // GIR_Coverage, 13155,
     /* 1837896 */     GIR_EraseRootFromParent_Done,
     /* 1837897 */   // Label 24874: @1837897
     /* 1837897 */   GIM_Try, /*On fail goto*//*Label 24875*/ GIMT_Encode4(1837983), // Rule ID 13158 //
     /* 1837902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1837913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1837916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1837922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1837925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1837932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837948 */     // MIs[0] policy
     /* 1837948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837958 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1837961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1837979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837982 */     // GIR_Coverage, 13158,
     /* 1837982 */     GIR_EraseRootFromParent_Done,
     /* 1837983 */   // Label 24875: @1837983
     /* 1837983 */   GIM_Try, /*On fail goto*//*Label 24876*/ GIMT_Encode4(1838069), // Rule ID 13159 //
     /* 1837988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1837999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1838002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1838008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838034 */     // MIs[0] policy
     /* 1838034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838044 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1838047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838068 */     // GIR_Coverage, 13159,
     /* 1838068 */     GIR_EraseRootFromParent_Done,
     /* 1838069 */   // Label 24876: @1838069
     /* 1838069 */   GIM_Try, /*On fail goto*//*Label 24877*/ GIMT_Encode4(1838155), // Rule ID 13162 //
     /* 1838074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1838085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1838088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1838091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1838094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838120 */     // MIs[0] policy
     /* 1838120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838130 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1838133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838154 */     // GIR_Coverage, 13162,
     /* 1838154 */     GIR_EraseRootFromParent_Done,
     /* 1838155 */   // Label 24877: @1838155
     /* 1838155 */   GIM_Try, /*On fail goto*//*Label 24878*/ GIMT_Encode4(1838241), // Rule ID 13163 //
     /* 1838160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1838171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1838174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1838180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838206 */     // MIs[0] policy
     /* 1838206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838216 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1838219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838240 */     // GIR_Coverage, 13163,
     /* 1838240 */     GIR_EraseRootFromParent_Done,
     /* 1838241 */   // Label 24878: @1838241
     /* 1838241 */   GIM_Try, /*On fail goto*//*Label 24879*/ GIMT_Encode4(1838327), // Rule ID 13166 //
     /* 1838246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1838257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1838260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1838263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1838266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838292 */     // MIs[0] policy
     /* 1838292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838302 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1838305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838326 */     // GIR_Coverage, 13166,
     /* 1838326 */     GIR_EraseRootFromParent_Done,
     /* 1838327 */   // Label 24879: @1838327
     /* 1838327 */   GIM_Try, /*On fail goto*//*Label 24880*/ GIMT_Encode4(1838413), // Rule ID 13167 //
     /* 1838332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1838343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1838346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1838352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838378 */     // MIs[0] policy
     /* 1838378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838388 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1838391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838412 */     // GIR_Coverage, 13167,
     /* 1838412 */     GIR_EraseRootFromParent_Done,
     /* 1838413 */   // Label 24880: @1838413
     /* 1838413 */   GIM_Try, /*On fail goto*//*Label 24881*/ GIMT_Encode4(1838499), // Rule ID 13170 //
     /* 1838418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1838429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1838432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1838435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1838438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838464 */     // MIs[0] policy
     /* 1838464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1838477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838498 */     // GIR_Coverage, 13170,
     /* 1838498 */     GIR_EraseRootFromParent_Done,
     /* 1838499 */   // Label 24881: @1838499
     /* 1838499 */   GIM_Try, /*On fail goto*//*Label 24882*/ GIMT_Encode4(1838585), // Rule ID 13171 //
     /* 1838504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1838515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1838518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1838524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838550 */     // MIs[0] policy
     /* 1838550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838560 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1838563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838584 */     // GIR_Coverage, 13171,
     /* 1838584 */     GIR_EraseRootFromParent_Done,
     /* 1838585 */   // Label 24882: @1838585
     /* 1838585 */   GIM_Try, /*On fail goto*//*Label 24883*/ GIMT_Encode4(1838671), // Rule ID 13174 //
     /* 1838590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1838601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1838604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1838607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1838610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838636 */     // MIs[0] policy
     /* 1838636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838646 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1838649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838670 */     // GIR_Coverage, 13174,
     /* 1838670 */     GIR_EraseRootFromParent_Done,
     /* 1838671 */   // Label 24883: @1838671
     /* 1838671 */   GIM_Try, /*On fail goto*//*Label 24884*/ GIMT_Encode4(1838757), // Rule ID 13175 //
     /* 1838676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1838687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1838690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1838696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838722 */     // MIs[0] policy
     /* 1838722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838732 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1838735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838756 */     // GIR_Coverage, 13175,
     /* 1838756 */     GIR_EraseRootFromParent_Done,
     /* 1838757 */   // Label 24884: @1838757
     /* 1838757 */   GIM_Try, /*On fail goto*//*Label 24885*/ GIMT_Encode4(1838843), // Rule ID 13178 //
     /* 1838762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1838773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1838776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1838779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1838782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838808 */     // MIs[0] policy
     /* 1838808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838818 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1838821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838842 */     // GIR_Coverage, 13178,
     /* 1838842 */     GIR_EraseRootFromParent_Done,
     /* 1838843 */   // Label 24885: @1838843
     /* 1838843 */   GIM_Try, /*On fail goto*//*Label 24886*/ GIMT_Encode4(1838929), // Rule ID 13179 //
     /* 1838848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1838859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1838862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1838868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838894 */     // MIs[0] policy
     /* 1838894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838904 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1838907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838928 */     // GIR_Coverage, 13179,
     /* 1838928 */     GIR_EraseRootFromParent_Done,
     /* 1838929 */   // Label 24886: @1838929
     /* 1838929 */   GIM_Try, /*On fail goto*//*Label 24887*/ GIMT_Encode4(1839015), // Rule ID 13182 //
     /* 1838934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1838945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1838948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1838951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1838954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838980 */     // MIs[0] policy
     /* 1838980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838990 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1838993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839014 */     // GIR_Coverage, 13182,
     /* 1839014 */     GIR_EraseRootFromParent_Done,
     /* 1839015 */   // Label 24887: @1839015
     /* 1839015 */   GIM_Try, /*On fail goto*//*Label 24888*/ GIMT_Encode4(1839101), // Rule ID 13183 //
     /* 1839020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1839028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1839031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1839034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1839037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1839040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1839043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839066 */     // MIs[0] policy
     /* 1839066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839076 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1839079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839100 */     // GIR_Coverage, 13183,
     /* 1839100 */     GIR_EraseRootFromParent_Done,
     /* 1839101 */   // Label 24888: @1839101
     /* 1839101 */   GIM_Try, /*On fail goto*//*Label 24889*/ GIMT_Encode4(1839187), // Rule ID 13186 //
     /* 1839106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1839114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1839117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1839120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1839123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1839126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839152 */     // MIs[0] policy
     /* 1839152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839162 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1839165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839186 */     // GIR_Coverage, 13186,
     /* 1839186 */     GIR_EraseRootFromParent_Done,
     /* 1839187 */   // Label 24889: @1839187
     /* 1839187 */   GIM_Try, /*On fail goto*//*Label 24890*/ GIMT_Encode4(1839273), // Rule ID 13187 //
     /* 1839192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1839200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1839203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1839206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1839209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1839212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839238 */     // MIs[0] policy
     /* 1839238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839248 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1839251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839272 */     // GIR_Coverage, 13187,
     /* 1839272 */     GIR_EraseRootFromParent_Done,
     /* 1839273 */   // Label 24890: @1839273
     /* 1839273 */   GIM_Try, /*On fail goto*//*Label 24891*/ GIMT_Encode4(1839359), // Rule ID 13190 //
     /* 1839278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1839286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1839289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1839292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1839295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1839298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839324 */     // MIs[0] policy
     /* 1839324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1839337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839358 */     // GIR_Coverage, 13190,
     /* 1839358 */     GIR_EraseRootFromParent_Done,
     /* 1839359 */   // Label 24891: @1839359
     /* 1839359 */   GIM_Try, /*On fail goto*//*Label 24892*/ GIMT_Encode4(1839445), // Rule ID 13191 //
     /* 1839364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1839372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1839375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1839378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1839381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1839384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839410 */     // MIs[0] policy
     /* 1839410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839420 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1839423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839444 */     // GIR_Coverage, 13191,
     /* 1839444 */     GIR_EraseRootFromParent_Done,
     /* 1839445 */   // Label 24892: @1839445
     /* 1839445 */   GIM_Try, /*On fail goto*//*Label 24893*/ GIMT_Encode4(1839531), // Rule ID 13194 //
     /* 1839450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1839453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1839458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1839461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1839464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1839467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1839470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839496 */     // MIs[0] policy
     /* 1839496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839506 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1839509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839530 */     // GIR_Coverage, 13194,
     /* 1839530 */     GIR_EraseRootFromParent_Done,
     /* 1839531 */   // Label 24893: @1839531
     /* 1839531 */   GIM_Try, /*On fail goto*//*Label 24894*/ GIMT_Encode4(1839617), // Rule ID 13195 //
     /* 1839536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1839539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1839544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1839547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1839550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1839553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1839556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839582 */     // MIs[0] policy
     /* 1839582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839592 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1839595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839616 */     // GIR_Coverage, 13195,
     /* 1839616 */     GIR_EraseRootFromParent_Done,
     /* 1839617 */   // Label 24894: @1839617
     /* 1839617 */   GIM_Try, /*On fail goto*//*Label 24895*/ GIMT_Encode4(1839703), // Rule ID 13198 //
     /* 1839622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1839630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1839633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1839636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1839639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1839642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1839645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1839652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839668 */     // MIs[0] policy
     /* 1839668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839678 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1839681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839702 */     // GIR_Coverage, 13198,
     /* 1839702 */     GIR_EraseRootFromParent_Done,
     /* 1839703 */   // Label 24895: @1839703
     /* 1839703 */   GIM_Try, /*On fail goto*//*Label 24896*/ GIMT_Encode4(1839789), // Rule ID 13199 //
     /* 1839708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1839716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1839719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1839722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1839725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1839728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1839731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1839738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839754 */     // MIs[0] policy
     /* 1839754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839764 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1839767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839788 */     // GIR_Coverage, 13199,
     /* 1839788 */     GIR_EraseRootFromParent_Done,
     /* 1839789 */   // Label 24896: @1839789
     /* 1839789 */   GIM_Try, /*On fail goto*//*Label 24897*/ GIMT_Encode4(1839875), // Rule ID 13202 //
     /* 1839794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1839802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1839805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1839808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1839811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1839814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1839817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839840 */     // MIs[0] policy
     /* 1839840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839850 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1839853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839874 */     // GIR_Coverage, 13202,
     /* 1839874 */     GIR_EraseRootFromParent_Done,
     /* 1839875 */   // Label 24897: @1839875
     /* 1839875 */   GIM_Try, /*On fail goto*//*Label 24898*/ GIMT_Encode4(1839961), // Rule ID 13203 //
     /* 1839880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1839888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1839891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1839894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1839897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1839900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1839903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839926 */     // MIs[0] policy
     /* 1839926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839936 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1839939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839960 */     // GIR_Coverage, 13203,
     /* 1839960 */     GIR_EraseRootFromParent_Done,
     /* 1839961 */   // Label 24898: @1839961
     /* 1839961 */   GIM_Try, /*On fail goto*//*Label 24899*/ GIMT_Encode4(1840047), // Rule ID 13206 //
     /* 1839966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1839974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1839977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1839980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1839983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1839986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1839989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1839996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840012 */     // MIs[0] policy
     /* 1840012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840022 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1840025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840046 */     // GIR_Coverage, 13206,
     /* 1840046 */     GIR_EraseRootFromParent_Done,
     /* 1840047 */   // Label 24899: @1840047
     /* 1840047 */   GIM_Try, /*On fail goto*//*Label 24900*/ GIMT_Encode4(1840133), // Rule ID 13207 //
     /* 1840052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1840060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1840063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1840066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1840069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1840072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1840075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840098 */     // MIs[0] policy
     /* 1840098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840108 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1840111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840132 */     // GIR_Coverage, 13207,
     /* 1840132 */     GIR_EraseRootFromParent_Done,
     /* 1840133 */   // Label 24900: @1840133
     /* 1840133 */   GIM_Try, /*On fail goto*//*Label 24901*/ GIMT_Encode4(1840219), // Rule ID 13210 //
     /* 1840138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1840146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1840149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1840152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1840155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1840158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840184 */     // MIs[0] policy
     /* 1840184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1840197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840218 */     // GIR_Coverage, 13210,
     /* 1840218 */     GIR_EraseRootFromParent_Done,
     /* 1840219 */   // Label 24901: @1840219
     /* 1840219 */   GIM_Try, /*On fail goto*//*Label 24902*/ GIMT_Encode4(1840305), // Rule ID 13211 //
     /* 1840224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1840232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1840235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1840238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1840241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1840244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840270 */     // MIs[0] policy
     /* 1840270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840280 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1840283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840304 */     // GIR_Coverage, 13211,
     /* 1840304 */     GIR_EraseRootFromParent_Done,
     /* 1840305 */   // Label 24902: @1840305
     /* 1840305 */   GIM_Try, /*On fail goto*//*Label 24903*/ GIMT_Encode4(1840391), // Rule ID 13214 //
     /* 1840310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1840318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1840321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1840324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1840327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1840330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840356 */     // MIs[0] policy
     /* 1840356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840366 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1840369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840390 */     // GIR_Coverage, 13214,
     /* 1840390 */     GIR_EraseRootFromParent_Done,
     /* 1840391 */   // Label 24903: @1840391
     /* 1840391 */   GIM_Try, /*On fail goto*//*Label 24904*/ GIMT_Encode4(1840477), // Rule ID 13215 //
     /* 1840396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1840404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1840407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1840410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1840413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1840416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840442 */     // MIs[0] policy
     /* 1840442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840452 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1840455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840476 */     // GIR_Coverage, 13215,
     /* 1840476 */     GIR_EraseRootFromParent_Done,
     /* 1840477 */   // Label 24904: @1840477
     /* 1840477 */   GIM_Try, /*On fail goto*//*Label 24905*/ GIMT_Encode4(1840563), // Rule ID 13218 //
     /* 1840482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1840490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1840493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1840496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1840499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1840502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1840505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840528 */     // MIs[0] policy
     /* 1840528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840538 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1840541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840562 */     // GIR_Coverage, 13218,
     /* 1840562 */     GIR_EraseRootFromParent_Done,
     /* 1840563 */   // Label 24905: @1840563
     /* 1840563 */   GIM_Try, /*On fail goto*//*Label 24906*/ GIMT_Encode4(1840649), // Rule ID 13219 //
     /* 1840568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1840576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1840579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1840582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1840585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1840588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1840591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840614 */     // MIs[0] policy
     /* 1840614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840624 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1840627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840648 */     // GIR_Coverage, 13219,
     /* 1840648 */     GIR_EraseRootFromParent_Done,
     /* 1840649 */   // Label 24906: @1840649
     /* 1840649 */   GIM_Try, /*On fail goto*//*Label 24907*/ GIMT_Encode4(1840735), // Rule ID 13222 //
     /* 1840654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1840662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1840665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1840668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1840671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1840674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1840677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840700 */     // MIs[0] policy
     /* 1840700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1840713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840734 */     // GIR_Coverage, 13222,
     /* 1840734 */     GIR_EraseRootFromParent_Done,
     /* 1840735 */   // Label 24907: @1840735
     /* 1840735 */   GIM_Try, /*On fail goto*//*Label 24908*/ GIMT_Encode4(1840821), // Rule ID 13223 //
     /* 1840740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1840748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1840751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1840754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1840757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1840760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1840763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840786 */     // MIs[0] policy
     /* 1840786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1840799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840820 */     // GIR_Coverage, 13223,
     /* 1840820 */     GIR_EraseRootFromParent_Done,
     /* 1840821 */   // Label 24908: @1840821
     /* 1840821 */   GIM_Try, /*On fail goto*//*Label 24909*/ GIMT_Encode4(1840907), // Rule ID 13226 //
     /* 1840826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1840834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1840837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1840840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1840843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1840846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840872 */     // MIs[0] policy
     /* 1840872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840882 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1840885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840906 */     // GIR_Coverage, 13226,
     /* 1840906 */     GIR_EraseRootFromParent_Done,
     /* 1840907 */   // Label 24909: @1840907
     /* 1840907 */   GIM_Try, /*On fail goto*//*Label 24910*/ GIMT_Encode4(1840993), // Rule ID 13227 //
     /* 1840912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1840920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1840923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1840926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1840929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1840932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840958 */     // MIs[0] policy
     /* 1840958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1840971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840992 */     // GIR_Coverage, 13227,
     /* 1840992 */     GIR_EraseRootFromParent_Done,
     /* 1840993 */   // Label 24910: @1840993
     /* 1840993 */   GIM_Try, /*On fail goto*//*Label 24911*/ GIMT_Encode4(1841079), // Rule ID 13230 //
     /* 1840998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1841006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1841009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1841012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1841018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841044 */     // MIs[0] policy
     /* 1841044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1841057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841078 */     // GIR_Coverage, 13230,
     /* 1841078 */     GIR_EraseRootFromParent_Done,
     /* 1841079 */   // Label 24911: @1841079
     /* 1841079 */   GIM_Try, /*On fail goto*//*Label 24912*/ GIMT_Encode4(1841165), // Rule ID 13231 //
     /* 1841084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1841092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1841095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1841098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1841104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841130 */     // MIs[0] policy
     /* 1841130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841140 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1841143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841164 */     // GIR_Coverage, 13231,
     /* 1841164 */     GIR_EraseRootFromParent_Done,
     /* 1841165 */   // Label 24912: @1841165
     /* 1841165 */   GIM_Try, /*On fail goto*//*Label 24913*/ GIMT_Encode4(1841251), // Rule ID 13234 //
     /* 1841170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1841178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1841181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1841184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1841190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841216 */     // MIs[0] policy
     /* 1841216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1841229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841250 */     // GIR_Coverage, 13234,
     /* 1841250 */     GIR_EraseRootFromParent_Done,
     /* 1841251 */   // Label 24913: @1841251
     /* 1841251 */   GIM_Try, /*On fail goto*//*Label 24914*/ GIMT_Encode4(1841337), // Rule ID 13235 //
     /* 1841256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1841264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1841267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1841270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1841276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841302 */     // MIs[0] policy
     /* 1841302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841312 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1841315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841336 */     // GIR_Coverage, 13235,
     /* 1841336 */     GIR_EraseRootFromParent_Done,
     /* 1841337 */   // Label 24914: @1841337
     /* 1841337 */   GIM_Try, /*On fail goto*//*Label 24915*/ GIMT_Encode4(1841423), // Rule ID 13238 //
     /* 1841342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1841350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1841353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1841356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1841362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841388 */     // MIs[0] policy
     /* 1841388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841398 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1841401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841422 */     // GIR_Coverage, 13238,
     /* 1841422 */     GIR_EraseRootFromParent_Done,
     /* 1841423 */   // Label 24915: @1841423
     /* 1841423 */   GIM_Try, /*On fail goto*//*Label 24916*/ GIMT_Encode4(1841509), // Rule ID 13239 //
     /* 1841428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1841436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1841439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1841442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1841448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841474 */     // MIs[0] policy
     /* 1841474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1841487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841508 */     // GIR_Coverage, 13239,
     /* 1841508 */     GIR_EraseRootFromParent_Done,
     /* 1841509 */   // Label 24916: @1841509
     /* 1841509 */   GIM_Try, /*On fail goto*//*Label 24917*/ GIMT_Encode4(1841595), // Rule ID 13242 //
     /* 1841514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1841522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1841525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1841528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1841534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841560 */     // MIs[0] policy
     /* 1841560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841570 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1841573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841594 */     // GIR_Coverage, 13242,
     /* 1841594 */     GIR_EraseRootFromParent_Done,
     /* 1841595 */   // Label 24917: @1841595
     /* 1841595 */   GIM_Try, /*On fail goto*//*Label 24918*/ GIMT_Encode4(1841681), // Rule ID 13243 //
     /* 1841600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1841608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1841611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1841614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1841620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841646 */     // MIs[0] policy
     /* 1841646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841656 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1841659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841680 */     // GIR_Coverage, 13243,
     /* 1841680 */     GIR_EraseRootFromParent_Done,
     /* 1841681 */   // Label 24918: @1841681
     /* 1841681 */   GIM_Try, /*On fail goto*//*Label 24919*/ GIMT_Encode4(1841767), // Rule ID 13246 //
     /* 1841686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1841697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1841700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1841703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1841706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1841709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841732 */     // MIs[0] policy
     /* 1841732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841742 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1841745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841766 */     // GIR_Coverage, 13246,
     /* 1841766 */     GIR_EraseRootFromParent_Done,
     /* 1841767 */   // Label 24919: @1841767
     /* 1841767 */   GIM_Try, /*On fail goto*//*Label 24920*/ GIMT_Encode4(1841853), // Rule ID 13247 //
     /* 1841772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1841783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1841786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1841789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1841792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1841795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841818 */     // MIs[0] policy
     /* 1841818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841828 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1841831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841852 */     // GIR_Coverage, 13247,
     /* 1841852 */     GIR_EraseRootFromParent_Done,
     /* 1841853 */   // Label 24920: @1841853
     /* 1841853 */   GIM_Try, /*On fail goto*//*Label 24921*/ GIMT_Encode4(1841939), // Rule ID 13250 //
     /* 1841858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1841869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1841872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1841875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1841878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841904 */     // MIs[0] policy
     /* 1841904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841914 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1841917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841938 */     // GIR_Coverage, 13250,
     /* 1841938 */     GIR_EraseRootFromParent_Done,
     /* 1841939 */   // Label 24921: @1841939
     /* 1841939 */   GIM_Try, /*On fail goto*//*Label 24922*/ GIMT_Encode4(1842025), // Rule ID 13251 //
     /* 1841944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1841955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1841958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1841961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1841964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841990 */     // MIs[0] policy
     /* 1841990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842000 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1842003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842024 */     // GIR_Coverage, 13251,
     /* 1842024 */     GIR_EraseRootFromParent_Done,
     /* 1842025 */   // Label 24922: @1842025
     /* 1842025 */   GIM_Try, /*On fail goto*//*Label 24923*/ GIMT_Encode4(1842111), // Rule ID 13254 //
     /* 1842030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1842041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1842044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1842047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1842050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842076 */     // MIs[0] policy
     /* 1842076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842086 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1842089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842110 */     // GIR_Coverage, 13254,
     /* 1842110 */     GIR_EraseRootFromParent_Done,
     /* 1842111 */   // Label 24923: @1842111
     /* 1842111 */   GIM_Try, /*On fail goto*//*Label 24924*/ GIMT_Encode4(1842197), // Rule ID 13255 //
     /* 1842116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1842127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1842130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1842133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1842136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842162 */     // MIs[0] policy
     /* 1842162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842172 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1842175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842196 */     // GIR_Coverage, 13255,
     /* 1842196 */     GIR_EraseRootFromParent_Done,
     /* 1842197 */   // Label 24924: @1842197
     /* 1842197 */   GIM_Try, /*On fail goto*//*Label 24925*/ GIMT_Encode4(1842283), // Rule ID 13258 //
     /* 1842202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1842213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1842216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1842219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1842222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842248 */     // MIs[0] policy
     /* 1842248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842258 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1842261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842282 */     // GIR_Coverage, 13258,
     /* 1842282 */     GIR_EraseRootFromParent_Done,
     /* 1842283 */   // Label 24925: @1842283
     /* 1842283 */   GIM_Try, /*On fail goto*//*Label 24926*/ GIMT_Encode4(1842369), // Rule ID 13259 //
     /* 1842288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1842299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1842302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1842305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1842308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842334 */     // MIs[0] policy
     /* 1842334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842344 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1842347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842368 */     // GIR_Coverage, 13259,
     /* 1842368 */     GIR_EraseRootFromParent_Done,
     /* 1842369 */   // Label 24926: @1842369
     /* 1842369 */   GIM_Try, /*On fail goto*//*Label 24927*/ GIMT_Encode4(1842455), // Rule ID 13262 //
     /* 1842374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1842385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1842388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1842391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1842394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842420 */     // MIs[0] policy
     /* 1842420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842430 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1842433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842454 */     // GIR_Coverage, 13262,
     /* 1842454 */     GIR_EraseRootFromParent_Done,
     /* 1842455 */   // Label 24927: @1842455
     /* 1842455 */   GIM_Try, /*On fail goto*//*Label 24928*/ GIMT_Encode4(1842541), // Rule ID 13263 //
     /* 1842460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1842471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1842474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1842477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1842480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842506 */     // MIs[0] policy
     /* 1842506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842516 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1842519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842540 */     // GIR_Coverage, 13263,
     /* 1842540 */     GIR_EraseRootFromParent_Done,
     /* 1842541 */   // Label 24928: @1842541
     /* 1842541 */   GIM_Try, /*On fail goto*//*Label 24929*/ GIMT_Encode4(1842627), // Rule ID 13266 //
     /* 1842546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1842557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1842560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1842563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1842566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842592 */     // MIs[0] policy
     /* 1842592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842602 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1842605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842626 */     // GIR_Coverage, 13266,
     /* 1842626 */     GIR_EraseRootFromParent_Done,
     /* 1842627 */   // Label 24929: @1842627
     /* 1842627 */   GIM_Try, /*On fail goto*//*Label 24930*/ GIMT_Encode4(1842713), // Rule ID 13267 //
     /* 1842632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1842643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1842646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1842649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1842652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842678 */     // MIs[0] policy
     /* 1842678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842688 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1842691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842712 */     // GIR_Coverage, 13267,
     /* 1842712 */     GIR_EraseRootFromParent_Done,
     /* 1842713 */   // Label 24930: @1842713
     /* 1842713 */   GIM_Try, /*On fail goto*//*Label 24931*/ GIMT_Encode4(1842799), // Rule ID 13270 //
     /* 1842718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1842729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1842732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1842735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1842738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842764 */     // MIs[0] policy
     /* 1842764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842774 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1842777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842798 */     // GIR_Coverage, 13270,
     /* 1842798 */     GIR_EraseRootFromParent_Done,
     /* 1842799 */   // Label 24931: @1842799
     /* 1842799 */   GIM_Try, /*On fail goto*//*Label 24932*/ GIMT_Encode4(1842885), // Rule ID 13271 //
     /* 1842804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1842815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1842818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1842821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1842824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842850 */     // MIs[0] policy
     /* 1842850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842860 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1842863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842884 */     // GIR_Coverage, 13271,
     /* 1842884 */     GIR_EraseRootFromParent_Done,
     /* 1842885 */   // Label 24932: @1842885
     /* 1842885 */   GIM_Try, /*On fail goto*//*Label 24933*/ GIMT_Encode4(1842971), // Rule ID 13274 //
     /* 1842890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1842901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1842904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1842907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1842910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842936 */     // MIs[0] policy
     /* 1842936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1842949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842970 */     // GIR_Coverage, 13274,
     /* 1842970 */     GIR_EraseRootFromParent_Done,
     /* 1842971 */   // Label 24933: @1842971
     /* 1842971 */   GIM_Try, /*On fail goto*//*Label 24934*/ GIMT_Encode4(1843057), // Rule ID 13275 //
     /* 1842976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1842987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1842990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1842993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1842996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843022 */     // MIs[0] policy
     /* 1843022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843032 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1843035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843056 */     // GIR_Coverage, 13275,
     /* 1843056 */     GIR_EraseRootFromParent_Done,
     /* 1843057 */   // Label 24934: @1843057
     /* 1843057 */   GIM_Try, /*On fail goto*//*Label 24935*/ GIMT_Encode4(1843143), // Rule ID 13278 //
     /* 1843062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1843073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1843076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1843079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1843082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843108 */     // MIs[0] policy
     /* 1843108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1843121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843142 */     // GIR_Coverage, 13278,
     /* 1843142 */     GIR_EraseRootFromParent_Done,
     /* 1843143 */   // Label 24935: @1843143
     /* 1843143 */   GIM_Try, /*On fail goto*//*Label 24936*/ GIMT_Encode4(1843229), // Rule ID 13279 //
     /* 1843148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1843159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1843162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1843165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1843168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843194 */     // MIs[0] policy
     /* 1843194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843204 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1843207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843228 */     // GIR_Coverage, 13279,
     /* 1843228 */     GIR_EraseRootFromParent_Done,
     /* 1843229 */   // Label 24936: @1843229
     /* 1843229 */   GIM_Try, /*On fail goto*//*Label 24937*/ GIMT_Encode4(1843315), // Rule ID 13282 //
     /* 1843234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1843237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1843251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1843254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843280 */     // MIs[0] policy
     /* 1843280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1843293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1843311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843314 */     // GIR_Coverage, 13282,
     /* 1843314 */     GIR_EraseRootFromParent_Done,
     /* 1843315 */   // Label 24937: @1843315
     /* 1843315 */   GIM_Try, /*On fail goto*//*Label 24938*/ GIMT_Encode4(1843401), // Rule ID 13283 //
     /* 1843320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1843323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1843337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1843340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843366 */     // MIs[0] policy
     /* 1843366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843376 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1843379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1843397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843400 */     // GIR_Coverage, 13283,
     /* 1843400 */     GIR_EraseRootFromParent_Done,
     /* 1843401 */   // Label 24938: @1843401
     /* 1843401 */   GIM_Try, /*On fail goto*//*Label 24939*/ GIMT_Encode4(1843487), // Rule ID 13286 //
     /* 1843406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1843417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1843420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1843423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1843426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843452 */     // MIs[0] policy
     /* 1843452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843462 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1843465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843486 */     // GIR_Coverage, 13286,
     /* 1843486 */     GIR_EraseRootFromParent_Done,
     /* 1843487 */   // Label 24939: @1843487
     /* 1843487 */   GIM_Try, /*On fail goto*//*Label 24940*/ GIMT_Encode4(1843573), // Rule ID 13287 //
     /* 1843492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1843503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1843506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1843509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1843512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843538 */     // MIs[0] policy
     /* 1843538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843548 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1843551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843572 */     // GIR_Coverage, 13287,
     /* 1843572 */     GIR_EraseRootFromParent_Done,
     /* 1843573 */   // Label 24940: @1843573
     /* 1843573 */   GIM_Try, /*On fail goto*//*Label 24941*/ GIMT_Encode4(1843659), // Rule ID 13290 //
     /* 1843578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1843589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1843592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1843595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1843598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1843601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1843608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843624 */     // MIs[0] policy
     /* 1843624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843634 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1843637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843658 */     // GIR_Coverage, 13290,
     /* 1843658 */     GIR_EraseRootFromParent_Done,
     /* 1843659 */   // Label 24941: @1843659
     /* 1843659 */   GIM_Try, /*On fail goto*//*Label 24942*/ GIMT_Encode4(1843745), // Rule ID 13291 //
     /* 1843664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1843675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1843678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1843681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1843684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1843687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1843694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843710 */     // MIs[0] policy
     /* 1843710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843720 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1843723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843744 */     // GIR_Coverage, 13291,
     /* 1843744 */     GIR_EraseRootFromParent_Done,
     /* 1843745 */   // Label 24942: @1843745
     /* 1843745 */   GIM_Try, /*On fail goto*//*Label 24943*/ GIMT_Encode4(1843831), // Rule ID 13294 //
     /* 1843750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1843761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1843764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1843767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1843770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1843773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1843780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843796 */     // MIs[0] policy
     /* 1843796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843806 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1843809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843830 */     // GIR_Coverage, 13294,
     /* 1843830 */     GIR_EraseRootFromParent_Done,
     /* 1843831 */   // Label 24943: @1843831
     /* 1843831 */   GIM_Try, /*On fail goto*//*Label 24944*/ GIMT_Encode4(1843917), // Rule ID 13295 //
     /* 1843836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1843847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1843850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1843853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1843856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1843859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1843866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843882 */     // MIs[0] policy
     /* 1843882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843892 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1843895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843916 */     // GIR_Coverage, 13295,
     /* 1843916 */     GIR_EraseRootFromParent_Done,
     /* 1843917 */   // Label 24944: @1843917
     /* 1843917 */   GIM_Try, /*On fail goto*//*Label 24945*/ GIMT_Encode4(1844003), // Rule ID 13298 //
     /* 1843922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1843933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1843936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1843939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1843942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843968 */     // MIs[0] policy
     /* 1843968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1843981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844002 */     // GIR_Coverage, 13298,
     /* 1844002 */     GIR_EraseRootFromParent_Done,
     /* 1844003 */   // Label 24945: @1844003
     /* 1844003 */   GIM_Try, /*On fail goto*//*Label 24946*/ GIMT_Encode4(1844089), // Rule ID 13299 //
     /* 1844008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1844019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1844022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1844025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1844028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844054 */     // MIs[0] policy
     /* 1844054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1844067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844088 */     // GIR_Coverage, 13299,
     /* 1844088 */     GIR_EraseRootFromParent_Done,
     /* 1844089 */   // Label 24946: @1844089
     /* 1844089 */   GIM_Try, /*On fail goto*//*Label 24947*/ GIMT_Encode4(1844175), // Rule ID 13302 //
     /* 1844094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1844111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1844114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844140 */     // MIs[0] policy
     /* 1844140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844150 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1844153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844174 */     // GIR_Coverage, 13302,
     /* 1844174 */     GIR_EraseRootFromParent_Done,
     /* 1844175 */   // Label 24947: @1844175
     /* 1844175 */   GIM_Try, /*On fail goto*//*Label 24948*/ GIMT_Encode4(1844261), // Rule ID 13303 //
     /* 1844180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1844197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1844200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844226 */     // MIs[0] policy
     /* 1844226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844236 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1844239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844260 */     // GIR_Coverage, 13303,
     /* 1844260 */     GIR_EraseRootFromParent_Done,
     /* 1844261 */   // Label 24948: @1844261
     /* 1844261 */   GIM_Try, /*On fail goto*//*Label 24949*/ GIMT_Encode4(1844347), // Rule ID 13306 //
     /* 1844266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1844283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1844286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844312 */     // MIs[0] policy
     /* 1844312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844322 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1844325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844346 */     // GIR_Coverage, 13306,
     /* 1844346 */     GIR_EraseRootFromParent_Done,
     /* 1844347 */   // Label 24949: @1844347
     /* 1844347 */   GIM_Try, /*On fail goto*//*Label 24950*/ GIMT_Encode4(1844433), // Rule ID 13307 //
     /* 1844352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1844369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1844372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844398 */     // MIs[0] policy
     /* 1844398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844408 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1844411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844432 */     // GIR_Coverage, 13307,
     /* 1844432 */     GIR_EraseRootFromParent_Done,
     /* 1844433 */   // Label 24950: @1844433
     /* 1844433 */   GIM_Try, /*On fail goto*//*Label 24951*/ GIMT_Encode4(1844519), // Rule ID 13310 //
     /* 1844438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1844455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1844458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844484 */     // MIs[0] policy
     /* 1844484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1844497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844518 */     // GIR_Coverage, 13310,
     /* 1844518 */     GIR_EraseRootFromParent_Done,
     /* 1844519 */   // Label 24951: @1844519
     /* 1844519 */   GIM_Try, /*On fail goto*//*Label 24952*/ GIMT_Encode4(1844605), // Rule ID 13311 //
     /* 1844524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1844541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1844544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844570 */     // MIs[0] policy
     /* 1844570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1844583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844604 */     // GIR_Coverage, 13311,
     /* 1844604 */     GIR_EraseRootFromParent_Done,
     /* 1844605 */   // Label 24952: @1844605
     /* 1844605 */   GIM_Try, /*On fail goto*//*Label 24953*/ GIMT_Encode4(1844691), // Rule ID 13314 //
     /* 1844610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1844621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1844624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1844627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1844630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844656 */     // MIs[0] policy
     /* 1844656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844666 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1844669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844690 */     // GIR_Coverage, 13314,
     /* 1844690 */     GIR_EraseRootFromParent_Done,
     /* 1844691 */   // Label 24953: @1844691
     /* 1844691 */   GIM_Try, /*On fail goto*//*Label 24954*/ GIMT_Encode4(1844777), // Rule ID 13315 //
     /* 1844696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1844707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1844710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1844713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1844716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844742 */     // MIs[0] policy
     /* 1844742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844752 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1844755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844776 */     // GIR_Coverage, 13315,
     /* 1844776 */     GIR_EraseRootFromParent_Done,
     /* 1844777 */   // Label 24954: @1844777
     /* 1844777 */   GIM_Try, /*On fail goto*//*Label 24955*/ GIMT_Encode4(1844863), // Rule ID 13318 //
     /* 1844782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1844793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1844796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1844799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1844802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844828 */     // MIs[0] policy
     /* 1844828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844838 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1844841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844862 */     // GIR_Coverage, 13318,
     /* 1844862 */     GIR_EraseRootFromParent_Done,
     /* 1844863 */   // Label 24955: @1844863
     /* 1844863 */   GIM_Try, /*On fail goto*//*Label 24956*/ GIMT_Encode4(1844949), // Rule ID 13319 //
     /* 1844868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1844879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1844882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1844885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1844888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844914 */     // MIs[0] policy
     /* 1844914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844924 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1844927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844948 */     // GIR_Coverage, 13319,
     /* 1844948 */     GIR_EraseRootFromParent_Done,
     /* 1844949 */   // Label 24956: @1844949
     /* 1844949 */   GIM_Try, /*On fail goto*//*Label 24957*/ GIMT_Encode4(1845035), // Rule ID 13322 //
     /* 1844954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1844957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1844965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1844968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1844971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1844974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1844977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845000 */     // MIs[0] policy
     /* 1845000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1845013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845034 */     // GIR_Coverage, 13322,
     /* 1845034 */     GIR_EraseRootFromParent_Done,
     /* 1845035 */   // Label 24957: @1845035
     /* 1845035 */   GIM_Try, /*On fail goto*//*Label 24958*/ GIMT_Encode4(1845121), // Rule ID 13323 //
     /* 1845040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1845043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1845051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1845054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1845057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1845060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845086 */     // MIs[0] policy
     /* 1845086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845096 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1845099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845120 */     // GIR_Coverage, 13323,
     /* 1845120 */     GIR_EraseRootFromParent_Done,
     /* 1845121 */   // Label 24958: @1845121
     /* 1845121 */   GIM_Try, /*On fail goto*//*Label 24959*/ GIMT_Encode4(1845207), // Rule ID 13326 //
     /* 1845126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1845129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1845143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1845146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845172 */     // MIs[0] policy
     /* 1845172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845182 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1845185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845206 */     // GIR_Coverage, 13326,
     /* 1845206 */     GIR_EraseRootFromParent_Done,
     /* 1845207 */   // Label 24959: @1845207
     /* 1845207 */   GIM_Try, /*On fail goto*//*Label 24960*/ GIMT_Encode4(1845293), // Rule ID 13327 //
     /* 1845212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1845215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1845229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1845232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845258 */     // MIs[0] policy
     /* 1845258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845268 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1845271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845292 */     // GIR_Coverage, 13327,
     /* 1845292 */     GIR_EraseRootFromParent_Done,
     /* 1845293 */   // Label 24960: @1845293
     /* 1845293 */   GIM_Try, /*On fail goto*//*Label 24961*/ GIMT_Encode4(1845379), // Rule ID 13330 //
     /* 1845298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1845301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1845315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1845318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845344 */     // MIs[0] policy
     /* 1845344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845354 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1845357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845378 */     // GIR_Coverage, 13330,
     /* 1845378 */     GIR_EraseRootFromParent_Done,
     /* 1845379 */   // Label 24961: @1845379
     /* 1845379 */   GIM_Try, /*On fail goto*//*Label 24962*/ GIMT_Encode4(1845465), // Rule ID 13331 //
     /* 1845384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1845387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1845401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1845404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845430 */     // MIs[0] policy
     /* 1845430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845440 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1845443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845464 */     // GIR_Coverage, 13331,
     /* 1845464 */     GIR_EraseRootFromParent_Done,
     /* 1845465 */   // Label 24962: @1845465
     /* 1845465 */   GIM_Try, /*On fail goto*//*Label 24963*/ GIMT_Encode4(1845551), // Rule ID 13334 //
     /* 1845470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1845481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1845484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845516 */     // MIs[0] policy
     /* 1845516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845526 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1845529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845550 */     // GIR_Coverage, 13334,
     /* 1845550 */     GIR_EraseRootFromParent_Done,
     /* 1845551 */   // Label 24963: @1845551
     /* 1845551 */   GIM_Try, /*On fail goto*//*Label 24964*/ GIMT_Encode4(1845637), // Rule ID 13335 //
     /* 1845556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1845567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1845570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845602 */     // MIs[0] policy
     /* 1845602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845612 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1845615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845636 */     // GIR_Coverage, 13335,
     /* 1845636 */     GIR_EraseRootFromParent_Done,
     /* 1845637 */   // Label 24964: @1845637
     /* 1845637 */   GIM_Try, /*On fail goto*//*Label 24965*/ GIMT_Encode4(1845723), // Rule ID 13338 //
     /* 1845642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1845653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1845656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1845662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845688 */     // MIs[0] policy
     /* 1845688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845698 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1845701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845722 */     // GIR_Coverage, 13338,
     /* 1845722 */     GIR_EraseRootFromParent_Done,
     /* 1845723 */   // Label 24965: @1845723
     /* 1845723 */   GIM_Try, /*On fail goto*//*Label 24966*/ GIMT_Encode4(1845809), // Rule ID 13339 //
     /* 1845728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1845739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1845742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1845748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845774 */     // MIs[0] policy
     /* 1845774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845784 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1845787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845808 */     // GIR_Coverage, 13339,
     /* 1845808 */     GIR_EraseRootFromParent_Done,
     /* 1845809 */   // Label 24966: @1845809
     /* 1845809 */   GIM_Try, /*On fail goto*//*Label 24967*/ GIMT_Encode4(1845895), // Rule ID 13342 //
     /* 1845814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1845825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1845828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1845834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845860 */     // MIs[0] policy
     /* 1845860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845870 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1845873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845894 */     // GIR_Coverage, 13342,
     /* 1845894 */     GIR_EraseRootFromParent_Done,
     /* 1845895 */   // Label 24967: @1845895
     /* 1845895 */   GIM_Try, /*On fail goto*//*Label 24968*/ GIMT_Encode4(1845981), // Rule ID 13343 //
     /* 1845900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1845911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1845914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1845920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845946 */     // MIs[0] policy
     /* 1845946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845956 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1845959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845980 */     // GIR_Coverage, 13343,
     /* 1845980 */     GIR_EraseRootFromParent_Done,
     /* 1845981 */   // Label 24968: @1845981
     /* 1845981 */   GIM_Try, /*On fail goto*//*Label 24969*/ GIMT_Encode4(1846067), // Rule ID 13346 //
     /* 1845986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1845997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1846000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1846006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846032 */     // MIs[0] policy
     /* 1846032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846042 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1846045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846066 */     // GIR_Coverage, 13346,
     /* 1846066 */     GIR_EraseRootFromParent_Done,
     /* 1846067 */   // Label 24969: @1846067
     /* 1846067 */   GIM_Try, /*On fail goto*//*Label 24970*/ GIMT_Encode4(1846153), // Rule ID 13347 //
     /* 1846072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1846080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1846083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1846086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1846092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846118 */     // MIs[0] policy
     /* 1846118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846128 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1846131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846152 */     // GIR_Coverage, 13347,
     /* 1846152 */     GIR_EraseRootFromParent_Done,
     /* 1846153 */   // Label 24970: @1846153
     /* 1846153 */   GIM_Try, /*On fail goto*//*Label 24971*/ GIMT_Encode4(1846239), // Rule ID 13350 //
     /* 1846158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1846166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1846169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1846172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1846178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846204 */     // MIs[0] policy
     /* 1846204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846214 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1846217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846238 */     // GIR_Coverage, 13350,
     /* 1846238 */     GIR_EraseRootFromParent_Done,
     /* 1846239 */   // Label 24971: @1846239
     /* 1846239 */   GIM_Try, /*On fail goto*//*Label 24972*/ GIMT_Encode4(1846325), // Rule ID 13351 //
     /* 1846244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1846252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1846255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1846258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1846264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846290 */     // MIs[0] policy
     /* 1846290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846300 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1846303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846324 */     // GIR_Coverage, 13351,
     /* 1846324 */     GIR_EraseRootFromParent_Done,
     /* 1846325 */   // Label 24972: @1846325
     /* 1846325 */   GIM_Try, /*On fail goto*//*Label 24973*/ GIMT_Encode4(1846411), // Rule ID 13354 //
     /* 1846330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1846338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1846341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1846344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1846350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846376 */     // MIs[0] policy
     /* 1846376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846386 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1846389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1846407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846410 */     // GIR_Coverage, 13354,
     /* 1846410 */     GIR_EraseRootFromParent_Done,
     /* 1846411 */   // Label 24973: @1846411
     /* 1846411 */   GIM_Try, /*On fail goto*//*Label 24974*/ GIMT_Encode4(1846497), // Rule ID 13355 //
     /* 1846416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1846424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1846427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1846430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1846436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846462 */     // MIs[0] policy
     /* 1846462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846472 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1846475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1846493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846496 */     // GIR_Coverage, 13355,
     /* 1846496 */     GIR_EraseRootFromParent_Done,
     /* 1846497 */   // Label 24974: @1846497
     /* 1846497 */   GIM_Try, /*On fail goto*//*Label 24975*/ GIMT_Encode4(1846583), // Rule ID 13358 //
     /* 1846502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1846510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1846513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1846516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1846522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846548 */     // MIs[0] policy
     /* 1846548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846558 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1846561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846582 */     // GIR_Coverage, 13358,
     /* 1846582 */     GIR_EraseRootFromParent_Done,
     /* 1846583 */   // Label 24975: @1846583
     /* 1846583 */   GIM_Try, /*On fail goto*//*Label 24976*/ GIMT_Encode4(1846669), // Rule ID 13359 //
     /* 1846588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1846596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1846599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1846602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1846608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846634 */     // MIs[0] policy
     /* 1846634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846644 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1846647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846668 */     // GIR_Coverage, 13359,
     /* 1846668 */     GIR_EraseRootFromParent_Done,
     /* 1846669 */   // Label 24976: @1846669
     /* 1846669 */   GIM_Try, /*On fail goto*//*Label 24977*/ GIMT_Encode4(1846755), // Rule ID 13362 //
     /* 1846674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1846682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1846685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1846688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1846694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846720 */     // MIs[0] policy
     /* 1846720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846730 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1846733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846754 */     // GIR_Coverage, 13362,
     /* 1846754 */     GIR_EraseRootFromParent_Done,
     /* 1846755 */   // Label 24977: @1846755
     /* 1846755 */   GIM_Try, /*On fail goto*//*Label 24978*/ GIMT_Encode4(1846841), // Rule ID 13363 //
     /* 1846760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1846768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1846771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1846774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1846780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846806 */     // MIs[0] policy
     /* 1846806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846816 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1846819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846840 */     // GIR_Coverage, 13363,
     /* 1846840 */     GIR_EraseRootFromParent_Done,
     /* 1846841 */   // Label 24978: @1846841
     /* 1846841 */   GIM_Try, /*On fail goto*//*Label 24979*/ GIMT_Encode4(1846927), // Rule ID 13366 //
     /* 1846846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1846854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1846857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1846860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1846866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846892 */     // MIs[0] policy
     /* 1846892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1846905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1846923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846926 */     // GIR_Coverage, 13366,
     /* 1846926 */     GIR_EraseRootFromParent_Done,
     /* 1846927 */   // Label 24979: @1846927
     /* 1846927 */   GIM_Try, /*On fail goto*//*Label 24980*/ GIMT_Encode4(1847013), // Rule ID 13367 //
     /* 1846932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1846940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1846943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1846946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1846952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846978 */     // MIs[0] policy
     /* 1846978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846988 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1846991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847012 */     // GIR_Coverage, 13367,
     /* 1847012 */     GIR_EraseRootFromParent_Done,
     /* 1847013 */   // Label 24980: @1847013
     /* 1847013 */   GIM_Try, /*On fail goto*//*Label 24981*/ GIMT_Encode4(1847099), // Rule ID 13370 //
     /* 1847018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1847021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1847026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1847038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847064 */     // MIs[0] policy
     /* 1847064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1847077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1847095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847098 */     // GIR_Coverage, 13370,
     /* 1847098 */     GIR_EraseRootFromParent_Done,
     /* 1847099 */   // Label 24981: @1847099
     /* 1847099 */   GIM_Try, /*On fail goto*//*Label 24982*/ GIMT_Encode4(1847185), // Rule ID 13371 //
     /* 1847104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1847107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1847112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1847124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847150 */     // MIs[0] policy
     /* 1847150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847160 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1847163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1847181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847184 */     // GIR_Coverage, 13371,
     /* 1847184 */     GIR_EraseRootFromParent_Done,
     /* 1847185 */   // Label 24982: @1847185
     /* 1847185 */   GIM_Try, /*On fail goto*//*Label 24983*/ GIMT_Encode4(1847271), // Rule ID 13374 //
     /* 1847190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1847198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1847201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1847204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1847210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847236 */     // MIs[0] policy
     /* 1847236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847246 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1847249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847270 */     // GIR_Coverage, 13374,
     /* 1847270 */     GIR_EraseRootFromParent_Done,
     /* 1847271 */   // Label 24983: @1847271
     /* 1847271 */   GIM_Try, /*On fail goto*//*Label 24984*/ GIMT_Encode4(1847357), // Rule ID 13375 //
     /* 1847276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1847284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1847287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1847290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1847296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847322 */     // MIs[0] policy
     /* 1847322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847332 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1847335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847356 */     // GIR_Coverage, 13375,
     /* 1847356 */     GIR_EraseRootFromParent_Done,
     /* 1847357 */   // Label 24984: @1847357
     /* 1847357 */   GIM_Try, /*On fail goto*//*Label 24985*/ GIMT_Encode4(1847443), // Rule ID 13378 //
     /* 1847362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1847370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1847373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1847376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1847382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1847385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847408 */     // MIs[0] policy
     /* 1847408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847418 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1847421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847442 */     // GIR_Coverage, 13378,
     /* 1847442 */     GIR_EraseRootFromParent_Done,
     /* 1847443 */   // Label 24985: @1847443
     /* 1847443 */   GIM_Try, /*On fail goto*//*Label 24986*/ GIMT_Encode4(1847529), // Rule ID 13379 //
     /* 1847448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1847456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1847459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1847462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1847468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1847471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847494 */     // MIs[0] policy
     /* 1847494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847504 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1847507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847528 */     // GIR_Coverage, 13379,
     /* 1847528 */     GIR_EraseRootFromParent_Done,
     /* 1847529 */   // Label 24986: @1847529
     /* 1847529 */   GIM_Try, /*On fail goto*//*Label 24987*/ GIMT_Encode4(1847615), // Rule ID 13382 //
     /* 1847534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1847542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1847545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1847548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1847554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1847557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847580 */     // MIs[0] policy
     /* 1847580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847590 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1847593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847614 */     // GIR_Coverage, 13382,
     /* 1847614 */     GIR_EraseRootFromParent_Done,
     /* 1847615 */   // Label 24987: @1847615
     /* 1847615 */   GIM_Try, /*On fail goto*//*Label 24988*/ GIMT_Encode4(1847701), // Rule ID 13383 //
     /* 1847620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1847628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1847631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1847634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1847640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1847643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847666 */     // MIs[0] policy
     /* 1847666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847676 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1847679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847700 */     // GIR_Coverage, 13383,
     /* 1847700 */     GIR_EraseRootFromParent_Done,
     /* 1847701 */   // Label 24988: @1847701
     /* 1847701 */   GIM_Try, /*On fail goto*//*Label 24989*/ GIMT_Encode4(1847787), // Rule ID 13386 //
     /* 1847706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1847714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1847717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1847720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1847726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847752 */     // MIs[0] policy
     /* 1847752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1847765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847786 */     // GIR_Coverage, 13386,
     /* 1847786 */     GIR_EraseRootFromParent_Done,
     /* 1847787 */   // Label 24989: @1847787
     /* 1847787 */   GIM_Try, /*On fail goto*//*Label 24990*/ GIMT_Encode4(1847873), // Rule ID 13387 //
     /* 1847792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1847800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1847803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1847806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1847812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847838 */     // MIs[0] policy
     /* 1847838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1847851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847872 */     // GIR_Coverage, 13387,
     /* 1847872 */     GIR_EraseRootFromParent_Done,
     /* 1847873 */   // Label 24990: @1847873
     /* 1847873 */   GIM_Try, /*On fail goto*//*Label 24991*/ GIMT_Encode4(1847959), // Rule ID 13390 //
     /* 1847878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1847886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1847889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1847892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1847898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847924 */     // MIs[0] policy
     /* 1847924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1847937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847958 */     // GIR_Coverage, 13390,
     /* 1847958 */     GIR_EraseRootFromParent_Done,
     /* 1847959 */   // Label 24991: @1847959
     /* 1847959 */   GIM_Try, /*On fail goto*//*Label 24992*/ GIMT_Encode4(1848045), // Rule ID 13391 //
     /* 1847964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1847972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1847975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1847978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1847984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848010 */     // MIs[0] policy
     /* 1848010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848020 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1848023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1848041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848044 */     // GIR_Coverage, 13391,
     /* 1848044 */     GIR_EraseRootFromParent_Done,
     /* 1848045 */   // Label 24992: @1848045
     /* 1848045 */   GIM_Try, /*On fail goto*//*Label 24993*/ GIMT_Encode4(1848131), // Rule ID 13394 //
     /* 1848050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1848058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1848061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1848064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1848070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1848073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848096 */     // MIs[0] policy
     /* 1848096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848106 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1848109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1848127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848130 */     // GIR_Coverage, 13394,
     /* 1848130 */     GIR_EraseRootFromParent_Done,
     /* 1848131 */   // Label 24993: @1848131
     /* 1848131 */   GIM_Try, /*On fail goto*//*Label 24994*/ GIMT_Encode4(1848217), // Rule ID 13395 //
     /* 1848136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1848144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1848147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1848150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1848156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1848159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848182 */     // MIs[0] policy
     /* 1848182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848192 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1848195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1848213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848216 */     // GIR_Coverage, 13395,
     /* 1848216 */     GIR_EraseRootFromParent_Done,
     /* 1848217 */   // Label 24994: @1848217
     /* 1848217 */   GIM_Try, /*On fail goto*//*Label 24995*/ GIMT_Encode4(1848303), // Rule ID 13398 //
     /* 1848222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1848230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1848233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1848236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1848242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848268 */     // MIs[0] policy
     /* 1848268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1848281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848302 */     // GIR_Coverage, 13398,
     /* 1848302 */     GIR_EraseRootFromParent_Done,
     /* 1848303 */   // Label 24995: @1848303
     /* 1848303 */   GIM_Try, /*On fail goto*//*Label 24996*/ GIMT_Encode4(1848389), // Rule ID 13399 //
     /* 1848308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1848316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1848319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1848322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1848328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848354 */     // MIs[0] policy
     /* 1848354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1848367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848388 */     // GIR_Coverage, 13399,
     /* 1848388 */     GIR_EraseRootFromParent_Done,
     /* 1848389 */   // Label 24996: @1848389
     /* 1848389 */   GIM_Try, /*On fail goto*//*Label 24997*/ GIMT_Encode4(1848475), // Rule ID 13402 //
     /* 1848394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1848402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1848405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1848408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1848414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848440 */     // MIs[0] policy
     /* 1848440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848450 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1848453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848474 */     // GIR_Coverage, 13402,
     /* 1848474 */     GIR_EraseRootFromParent_Done,
     /* 1848475 */   // Label 24997: @1848475
     /* 1848475 */   GIM_Try, /*On fail goto*//*Label 24998*/ GIMT_Encode4(1848561), // Rule ID 13403 //
     /* 1848480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1848488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1848491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1848494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1848500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848526 */     // MIs[0] policy
     /* 1848526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848536 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1848539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848560 */     // GIR_Coverage, 13403,
     /* 1848560 */     GIR_EraseRootFromParent_Done,
     /* 1848561 */   // Label 24998: @1848561
     /* 1848561 */   GIM_Try, /*On fail goto*//*Label 24999*/ GIMT_Encode4(1848647), // Rule ID 13406 //
     /* 1848566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1848574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1848577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1848580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1848586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1848589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848612 */     // MIs[0] policy
     /* 1848612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848622 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1848625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848646 */     // GIR_Coverage, 13406,
     /* 1848646 */     GIR_EraseRootFromParent_Done,
     /* 1848647 */   // Label 24999: @1848647
     /* 1848647 */   GIM_Try, /*On fail goto*//*Label 25000*/ GIMT_Encode4(1848733), // Rule ID 13407 //
     /* 1848652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1848660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1848663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1848666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1848672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1848675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848698 */     // MIs[0] policy
     /* 1848698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848708 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1848711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848732 */     // GIR_Coverage, 13407,
     /* 1848732 */     GIR_EraseRootFromParent_Done,
     /* 1848733 */   // Label 25000: @1848733
     /* 1848733 */   GIM_Try, /*On fail goto*//*Label 25001*/ GIMT_Encode4(1848819), // Rule ID 13410 //
     /* 1848738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1848741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1848746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1848749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1848752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1848758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848784 */     // MIs[0] policy
     /* 1848784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848794 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1848797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1848815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848818 */     // GIR_Coverage, 13410,
     /* 1848818 */     GIR_EraseRootFromParent_Done,
     /* 1848819 */   // Label 25001: @1848819
     /* 1848819 */   GIM_Try, /*On fail goto*//*Label 25002*/ GIMT_Encode4(1848905), // Rule ID 13411 //
     /* 1848824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1848827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1848832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1848835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1848838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1848844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848870 */     // MIs[0] policy
     /* 1848870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848880 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1848883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1848901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848904 */     // GIR_Coverage, 13411,
     /* 1848904 */     GIR_EraseRootFromParent_Done,
     /* 1848905 */   // Label 25002: @1848905
     /* 1848905 */   GIM_Try, /*On fail goto*//*Label 25003*/ GIMT_Encode4(1848991), // Rule ID 13414 //
     /* 1848910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1848913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1848918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1848921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1848924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1848930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848956 */     // MIs[0] policy
     /* 1848956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1848969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1848987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848990 */     // GIR_Coverage, 13414,
     /* 1848990 */     GIR_EraseRootFromParent_Done,
     /* 1848991 */   // Label 25003: @1848991
     /* 1848991 */   GIM_Try, /*On fail goto*//*Label 25004*/ GIMT_Encode4(1849077), // Rule ID 13415 //
     /* 1848996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1848999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1849004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1849007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1849010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1849016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849042 */     // MIs[0] policy
     /* 1849042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849052 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1849055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1849073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849076 */     // GIR_Coverage, 13415,
     /* 1849076 */     GIR_EraseRootFromParent_Done,
     /* 1849077 */   // Label 25004: @1849077
     /* 1849077 */   GIM_Try, /*On fail goto*//*Label 25005*/ GIMT_Encode4(1849163), // Rule ID 13418 //
     /* 1849082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1849085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1849090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1849093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1849096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1849102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849128 */     // MIs[0] policy
     /* 1849128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849138 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1849141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1849159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849162 */     // GIR_Coverage, 13418,
     /* 1849162 */     GIR_EraseRootFromParent_Done,
     /* 1849163 */   // Label 25005: @1849163
     /* 1849163 */   GIM_Try, /*On fail goto*//*Label 25006*/ GIMT_Encode4(1849249), // Rule ID 13419 //
     /* 1849168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1849171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1849176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1849179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1849182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1849188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849214 */     // MIs[0] policy
     /* 1849214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849224 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1849227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1849245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849248 */     // GIR_Coverage, 13419,
     /* 1849248 */     GIR_EraseRootFromParent_Done,
     /* 1849249 */   // Label 25006: @1849249
     /* 1849249 */   GIM_Try, /*On fail goto*//*Label 25007*/ GIMT_Encode4(1849335), // Rule ID 13422 //
     /* 1849254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1849265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1849268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1849271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1849274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849300 */     // MIs[0] policy
     /* 1849300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849310 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11629:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1849313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849334 */     // GIR_Coverage, 13422,
     /* 1849334 */     GIR_EraseRootFromParent_Done,
     /* 1849335 */   // Label 25007: @1849335
     /* 1849335 */   GIM_Try, /*On fail goto*//*Label 25008*/ GIMT_Encode4(1849421), // Rule ID 13423 //
     /* 1849340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1849351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1849354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1849357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1849360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849386 */     // MIs[0] policy
     /* 1849386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849396 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11629:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1849399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849420 */     // GIR_Coverage, 13423,
     /* 1849420 */     GIR_EraseRootFromParent_Done,
     /* 1849421 */   // Label 25008: @1849421
     /* 1849421 */   GIM_Try, /*On fail goto*//*Label 25009*/ GIMT_Encode4(1849507), // Rule ID 13426 //
     /* 1849426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1849437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1849440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1849443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1849446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849472 */     // MIs[0] policy
     /* 1849472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849482 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11629:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1849485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849506 */     // GIR_Coverage, 13426,
     /* 1849506 */     GIR_EraseRootFromParent_Done,
     /* 1849507 */   // Label 25009: @1849507
     /* 1849507 */   GIM_Try, /*On fail goto*//*Label 25010*/ GIMT_Encode4(1849593), // Rule ID 13427 //
     /* 1849512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1849523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1849526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1849529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1849532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849558 */     // MIs[0] policy
     /* 1849558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849568 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11629:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1849571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849592 */     // GIR_Coverage, 13427,
     /* 1849592 */     GIR_EraseRootFromParent_Done,
     /* 1849593 */   // Label 25010: @1849593
     /* 1849593 */   GIM_Try, /*On fail goto*//*Label 25011*/ GIMT_Encode4(1849679), // Rule ID 13430 //
     /* 1849598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1849609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1849612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1849615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1849618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849644 */     // MIs[0] policy
     /* 1849644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849654 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11629:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1849657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849678 */     // GIR_Coverage, 13430,
     /* 1849678 */     GIR_EraseRootFromParent_Done,
     /* 1849679 */   // Label 25011: @1849679
     /* 1849679 */   GIM_Try, /*On fail goto*//*Label 25012*/ GIMT_Encode4(1849765), // Rule ID 13431 //
     /* 1849684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1849695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1849698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1849701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1849704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849730 */     // MIs[0] policy
     /* 1849730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849740 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11629:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1849743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849764 */     // GIR_Coverage, 13431,
     /* 1849764 */     GIR_EraseRootFromParent_Done,
     /* 1849765 */   // Label 25012: @1849765
     /* 1849765 */   GIM_Try, /*On fail goto*//*Label 25013*/ GIMT_Encode4(1849851), // Rule ID 13434 //
     /* 1849770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1849781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1849784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1849787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1849790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849816 */     // MIs[0] policy
     /* 1849816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849826 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11629:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1849829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849850 */     // GIR_Coverage, 13434,
     /* 1849850 */     GIR_EraseRootFromParent_Done,
     /* 1849851 */   // Label 25013: @1849851
     /* 1849851 */   GIM_Try, /*On fail goto*//*Label 25014*/ GIMT_Encode4(1849937), // Rule ID 13435 //
     /* 1849856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1849867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1849870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1849873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1849876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849902 */     // MIs[0] policy
     /* 1849902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849912 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11629:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1849915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849936 */     // GIR_Coverage, 13435,
     /* 1849936 */     GIR_EraseRootFromParent_Done,
     /* 1849937 */   // Label 25014: @1849937
     /* 1849937 */   GIM_Try, /*On fail goto*//*Label 25015*/ GIMT_Encode4(1850023), // Rule ID 13438 //
     /* 1849942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1849953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1849956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1849959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1849962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1849965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849988 */     // MIs[0] policy
     /* 1849988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849998 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11629:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1850001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850022 */     // GIR_Coverage, 13438,
     /* 1850022 */     GIR_EraseRootFromParent_Done,
     /* 1850023 */   // Label 25015: @1850023
     /* 1850023 */   GIM_Try, /*On fail goto*//*Label 25016*/ GIMT_Encode4(1850109), // Rule ID 13439 //
     /* 1850028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1850039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1850042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1850045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1850048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1850051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850074 */     // MIs[0] policy
     /* 1850074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850084 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11629:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1850087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850108 */     // GIR_Coverage, 13439,
     /* 1850108 */     GIR_EraseRootFromParent_Done,
     /* 1850109 */   // Label 25016: @1850109
     /* 1850109 */   GIM_Try, /*On fail goto*//*Label 25017*/ GIMT_Encode4(1850195), // Rule ID 13442 //
     /* 1850114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1850125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1850128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1850131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1850134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1850137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850160 */     // MIs[0] policy
     /* 1850160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850170 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11629:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1850173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850194 */     // GIR_Coverage, 13442,
     /* 1850194 */     GIR_EraseRootFromParent_Done,
     /* 1850195 */   // Label 25017: @1850195
     /* 1850195 */   GIM_Try, /*On fail goto*//*Label 25018*/ GIMT_Encode4(1850281), // Rule ID 13443 //
     /* 1850200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1850211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1850214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1850217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1850220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1850223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850246 */     // MIs[0] policy
     /* 1850246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850256 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11629:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1850259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850280 */     // GIR_Coverage, 13443,
     /* 1850280 */     GIR_EraseRootFromParent_Done,
     /* 1850281 */   // Label 25018: @1850281
     /* 1850281 */   GIM_Try, /*On fail goto*//*Label 25019*/ GIMT_Encode4(1850367), // Rule ID 13446 //
     /* 1850286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1850297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1850300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1850303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1850306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850332 */     // MIs[0] policy
     /* 1850332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850342 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11629:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1850345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850366 */     // GIR_Coverage, 13446,
     /* 1850366 */     GIR_EraseRootFromParent_Done,
     /* 1850367 */   // Label 25019: @1850367
     /* 1850367 */   GIM_Try, /*On fail goto*//*Label 25020*/ GIMT_Encode4(1850453), // Rule ID 13447 //
     /* 1850372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1850383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1850386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1850389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1850392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850418 */     // MIs[0] policy
     /* 1850418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850428 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11629:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1850431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850452 */     // GIR_Coverage, 13447,
     /* 1850452 */     GIR_EraseRootFromParent_Done,
     /* 1850453 */   // Label 25020: @1850453
     /* 1850453 */   GIM_Try, /*On fail goto*//*Label 25021*/ GIMT_Encode4(1850539), // Rule ID 13450 //
     /* 1850458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1850469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1850472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1850475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1850478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850504 */     // MIs[0] policy
     /* 1850504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850514 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11629:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1850517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850538 */     // GIR_Coverage, 13450,
     /* 1850538 */     GIR_EraseRootFromParent_Done,
     /* 1850539 */   // Label 25021: @1850539
     /* 1850539 */   GIM_Try, /*On fail goto*//*Label 25022*/ GIMT_Encode4(1850625), // Rule ID 13451 //
     /* 1850544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1850555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1850558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1850561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1850564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850590 */     // MIs[0] policy
     /* 1850590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11629:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1850603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850624 */     // GIR_Coverage, 13451,
     /* 1850624 */     GIR_EraseRootFromParent_Done,
     /* 1850625 */   // Label 25022: @1850625
     /* 1850625 */   GIM_Try, /*On fail goto*//*Label 25023*/ GIMT_Encode4(1850711), // Rule ID 13454 //
     /* 1850630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1850641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1850644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1850647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1850650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850676 */     // MIs[0] policy
     /* 1850676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850686 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11629:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1850689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850710 */     // GIR_Coverage, 13454,
     /* 1850710 */     GIR_EraseRootFromParent_Done,
     /* 1850711 */   // Label 25023: @1850711
     /* 1850711 */   GIM_Try, /*On fail goto*//*Label 25024*/ GIMT_Encode4(1850797), // Rule ID 13455 //
     /* 1850716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1850727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1850730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1850733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1850736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850762 */     // MIs[0] policy
     /* 1850762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11629:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1850775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850796 */     // GIR_Coverage, 13455,
     /* 1850796 */     GIR_EraseRootFromParent_Done,
     /* 1850797 */   // Label 25024: @1850797
     /* 1850797 */   GIM_Try, /*On fail goto*//*Label 25025*/ GIMT_Encode4(1850883), // Rule ID 13458 //
     /* 1850802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1850813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1850816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1850819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1850822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850848 */     // MIs[0] policy
     /* 1850848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850858 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11629:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1850861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850882 */     // GIR_Coverage, 13458,
     /* 1850882 */     GIR_EraseRootFromParent_Done,
     /* 1850883 */   // Label 25025: @1850883
     /* 1850883 */   GIM_Try, /*On fail goto*//*Label 25026*/ GIMT_Encode4(1850969), // Rule ID 13459 //
     /* 1850888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1850899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1850902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1850905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1850908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850934 */     // MIs[0] policy
     /* 1850934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850944 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11629:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1850947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850968 */     // GIR_Coverage, 13459,
     /* 1850968 */     GIR_EraseRootFromParent_Done,
     /* 1850969 */   // Label 25026: @1850969
     /* 1850969 */   GIM_Try, /*On fail goto*//*Label 25027*/ GIMT_Encode4(1851055), // Rule ID 13462 //
     /* 1850974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1850985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1850988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1850991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1850994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1850997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851020 */     // MIs[0] policy
     /* 1851020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11629:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1851033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851054 */     // GIR_Coverage, 13462,
     /* 1851054 */     GIR_EraseRootFromParent_Done,
     /* 1851055 */   // Label 25027: @1851055
     /* 1851055 */   GIM_Try, /*On fail goto*//*Label 25028*/ GIMT_Encode4(1851141), // Rule ID 13463 //
     /* 1851060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1851068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1851071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1851074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1851077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1851080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851106 */     // MIs[0] policy
     /* 1851106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851116 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11629:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1851119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851140 */     // GIR_Coverage, 13463,
     /* 1851140 */     GIR_EraseRootFromParent_Done,
     /* 1851141 */   // Label 25028: @1851141
     /* 1851141 */   GIM_Try, /*On fail goto*//*Label 25029*/ GIMT_Encode4(1851227), // Rule ID 13466 //
     /* 1851146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1851149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1851154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1851157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1851160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1851163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1851166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851192 */     // MIs[0] policy
     /* 1851192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851202 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11629:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1851205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851226 */     // GIR_Coverage, 13466,
     /* 1851226 */     GIR_EraseRootFromParent_Done,
     /* 1851227 */   // Label 25029: @1851227
     /* 1851227 */   GIM_Try, /*On fail goto*//*Label 25030*/ GIMT_Encode4(1851313), // Rule ID 13467 //
     /* 1851232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1851235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1851240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1851243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1851246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1851249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1851252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851278 */     // MIs[0] policy
     /* 1851278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851288 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11629:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1851291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851312 */     // GIR_Coverage, 13467,
     /* 1851312 */     GIR_EraseRootFromParent_Done,
     /* 1851313 */   // Label 25030: @1851313
     /* 1851313 */   GIM_Try, /*On fail goto*//*Label 25031*/ GIMT_Encode4(1851399), // Rule ID 13470 //
     /* 1851318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1851321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1851326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1851329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1851332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1851335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1851338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851364 */     // MIs[0] policy
     /* 1851364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851374 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11629:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1851377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851398 */     // GIR_Coverage, 13470,
     /* 1851398 */     GIR_EraseRootFromParent_Done,
     /* 1851399 */   // Label 25031: @1851399
     /* 1851399 */   GIM_Try, /*On fail goto*//*Label 25032*/ GIMT_Encode4(1851485), // Rule ID 13471 //
     /* 1851404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1851407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1851412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1851415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1851418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1851421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1851424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851450 */     // MIs[0] policy
     /* 1851450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851460 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11629:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1851463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851484 */     // GIR_Coverage, 13471,
     /* 1851484 */     GIR_EraseRootFromParent_Done,
     /* 1851485 */   // Label 25032: @1851485
     /* 1851485 */   GIM_Try, /*On fail goto*//*Label 25033*/ GIMT_Encode4(1851571), // Rule ID 13474 //
     /* 1851490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1851493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1851498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1851501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1851504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1851507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1851510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851536 */     // MIs[0] policy
     /* 1851536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851546 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11629:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1851549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851570 */     // GIR_Coverage, 13474,
     /* 1851570 */     GIR_EraseRootFromParent_Done,
     /* 1851571 */   // Label 25033: @1851571
     /* 1851571 */   GIM_Try, /*On fail goto*//*Label 25034*/ GIMT_Encode4(1851657), // Rule ID 13475 //
     /* 1851576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1851579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1851584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1851587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1851590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1851593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1851596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851622 */     // MIs[0] policy
     /* 1851622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851632 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11629:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1851635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851656 */     // GIR_Coverage, 13475,
     /* 1851656 */     GIR_EraseRootFromParent_Done,
     /* 1851657 */   // Label 25034: @1851657
     /* 1851657 */   GIM_Try, /*On fail goto*//*Label 25035*/ GIMT_Encode4(1851743), // Rule ID 13478 //
     /* 1851662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1851665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1851670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1851673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1851676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1851679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1851682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851708 */     // MIs[0] policy
     /* 1851708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11629:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1851721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851742 */     // GIR_Coverage, 13478,
     /* 1851742 */     GIR_EraseRootFromParent_Done,
     /* 1851743 */   // Label 25035: @1851743
     /* 1851743 */   GIM_Try, /*On fail goto*//*Label 25036*/ GIMT_Encode4(1851829), // Rule ID 13479 //
     /* 1851748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1851751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1851756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1851759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1851762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1851765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1851768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851794 */     // MIs[0] policy
     /* 1851794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851804 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11629:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1851807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851828 */     // GIR_Coverage, 13479,
     /* 1851828 */     GIR_EraseRootFromParent_Done,
     /* 1851829 */   // Label 25036: @1851829
     /* 1851829 */   GIM_Try, /*On fail goto*//*Label 25037*/ GIMT_Encode4(1851915), // Rule ID 13482 //
     /* 1851834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1851842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1851845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1851848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1851851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1851854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851880 */     // MIs[0] policy
     /* 1851880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851890 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11629:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1851893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851914 */     // GIR_Coverage, 13482,
     /* 1851914 */     GIR_EraseRootFromParent_Done,
     /* 1851915 */   // Label 25037: @1851915
     /* 1851915 */   GIM_Try, /*On fail goto*//*Label 25038*/ GIMT_Encode4(1852001), // Rule ID 13483 //
     /* 1851920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1851928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1851931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1851934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1851937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1851940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851966 */     // MIs[0] policy
     /* 1851966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11629:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1851979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852000 */     // GIR_Coverage, 13483,
     /* 1852000 */     GIR_EraseRootFromParent_Done,
     /* 1852001 */   // Label 25038: @1852001
     /* 1852001 */   GIM_Try, /*On fail goto*//*Label 25039*/ GIMT_Encode4(1852087), // Rule ID 13486 //
     /* 1852006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1852014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1852017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1852020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1852026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852052 */     // MIs[0] policy
     /* 1852052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852062 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11629:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1852065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852086 */     // GIR_Coverage, 13486,
     /* 1852086 */     GIR_EraseRootFromParent_Done,
     /* 1852087 */   // Label 25039: @1852087
     /* 1852087 */   GIM_Try, /*On fail goto*//*Label 25040*/ GIMT_Encode4(1852173), // Rule ID 13487 //
     /* 1852092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1852100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1852103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1852106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1852112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852138 */     // MIs[0] policy
     /* 1852138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11629:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1852151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852172 */     // GIR_Coverage, 13487,
     /* 1852172 */     GIR_EraseRootFromParent_Done,
     /* 1852173 */   // Label 25040: @1852173
     /* 1852173 */   GIM_Try, /*On fail goto*//*Label 25041*/ GIMT_Encode4(1852259), // Rule ID 13490 //
     /* 1852178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1852186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1852189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1852192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1852198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852224 */     // MIs[0] policy
     /* 1852224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852234 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11629:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1852237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852258 */     // GIR_Coverage, 13490,
     /* 1852258 */     GIR_EraseRootFromParent_Done,
     /* 1852259 */   // Label 25041: @1852259
     /* 1852259 */   GIM_Try, /*On fail goto*//*Label 25042*/ GIMT_Encode4(1852345), // Rule ID 13491 //
     /* 1852264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1852272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1852275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1852278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1852284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852310 */     // MIs[0] policy
     /* 1852310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852320 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11629:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1852323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852344 */     // GIR_Coverage, 13491,
     /* 1852344 */     GIR_EraseRootFromParent_Done,
     /* 1852345 */   // Label 25042: @1852345
     /* 1852345 */   GIM_Try, /*On fail goto*//*Label 25043*/ GIMT_Encode4(1852431), // Rule ID 13494 //
     /* 1852350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1852358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1852361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1852364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1852370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852396 */     // MIs[0] policy
     /* 1852396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852406 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11629:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1852409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852430 */     // GIR_Coverage, 13494,
     /* 1852430 */     GIR_EraseRootFromParent_Done,
     /* 1852431 */   // Label 25043: @1852431
     /* 1852431 */   GIM_Try, /*On fail goto*//*Label 25044*/ GIMT_Encode4(1852517), // Rule ID 13495 //
     /* 1852436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1852444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1852447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1852450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1852456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852482 */     // MIs[0] policy
     /* 1852482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852492 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11629:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1852495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852516 */     // GIR_Coverage, 13495,
     /* 1852516 */     GIR_EraseRootFromParent_Done,
     /* 1852517 */   // Label 25044: @1852517
     /* 1852517 */   GIM_Try, /*On fail goto*//*Label 25045*/ GIMT_Encode4(1852603), // Rule ID 13498 //
     /* 1852522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1852530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1852533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1852536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1852542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852568 */     // MIs[0] policy
     /* 1852568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852578 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11629:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1852581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852602 */     // GIR_Coverage, 13498,
     /* 1852602 */     GIR_EraseRootFromParent_Done,
     /* 1852603 */   // Label 25045: @1852603
     /* 1852603 */   GIM_Try, /*On fail goto*//*Label 25046*/ GIMT_Encode4(1852689), // Rule ID 13499 //
     /* 1852608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1852616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1852619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1852622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1852628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852654 */     // MIs[0] policy
     /* 1852654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852664 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11629:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1852667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852688 */     // GIR_Coverage, 13499,
     /* 1852688 */     GIR_EraseRootFromParent_Done,
     /* 1852689 */   // Label 25046: @1852689
     /* 1852689 */   GIM_Try, /*On fail goto*//*Label 25047*/ GIMT_Encode4(1852775), // Rule ID 13502 //
     /* 1852694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1852702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1852705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1852708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1852714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1852717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852740 */     // MIs[0] policy
     /* 1852740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852750 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11629:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1852753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852774 */     // GIR_Coverage, 13502,
     /* 1852774 */     GIR_EraseRootFromParent_Done,
     /* 1852775 */   // Label 25047: @1852775
     /* 1852775 */   GIM_Try, /*On fail goto*//*Label 25048*/ GIMT_Encode4(1852861), // Rule ID 13503 //
     /* 1852780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1852788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1852791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1852794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1852800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1852803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852826 */     // MIs[0] policy
     /* 1852826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852836 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11629:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1852839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852860 */     // GIR_Coverage, 13503,
     /* 1852860 */     GIR_EraseRootFromParent_Done,
     /* 1852861 */   // Label 25048: @1852861
     /* 1852861 */   GIM_Try, /*On fail goto*//*Label 25049*/ GIMT_Encode4(1852947), // Rule ID 13506 //
     /* 1852866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1852874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1852877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1852880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1852886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852912 */     // MIs[0] policy
     /* 1852912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852922 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11629:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1852925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852946 */     // GIR_Coverage, 13506,
     /* 1852946 */     GIR_EraseRootFromParent_Done,
     /* 1852947 */   // Label 25049: @1852947
     /* 1852947 */   GIM_Try, /*On fail goto*//*Label 25050*/ GIMT_Encode4(1853033), // Rule ID 13507 //
     /* 1852952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1852960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1852963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1852966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1852972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852998 */     // MIs[0] policy
     /* 1852998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853008 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11629:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1853011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853032 */     // GIR_Coverage, 13507,
     /* 1853032 */     GIR_EraseRootFromParent_Done,
     /* 1853033 */   // Label 25050: @1853033
     /* 1853033 */   GIM_Try, /*On fail goto*//*Label 25051*/ GIMT_Encode4(1853119), // Rule ID 13510 //
     /* 1853038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1853046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1853049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1853052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1853058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853084 */     // MIs[0] policy
     /* 1853084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853094 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11629:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1853097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853118 */     // GIR_Coverage, 13510,
     /* 1853118 */     GIR_EraseRootFromParent_Done,
     /* 1853119 */   // Label 25051: @1853119
     /* 1853119 */   GIM_Try, /*On fail goto*//*Label 25052*/ GIMT_Encode4(1853205), // Rule ID 13511 //
     /* 1853124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1853132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1853135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1853138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1853144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853170 */     // MIs[0] policy
     /* 1853170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853180 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11629:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1853183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853204 */     // GIR_Coverage, 13511,
     /* 1853204 */     GIR_EraseRootFromParent_Done,
     /* 1853205 */   // Label 25052: @1853205
     /* 1853205 */   GIM_Try, /*On fail goto*//*Label 25053*/ GIMT_Encode4(1853291), // Rule ID 13514 //
     /* 1853210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1853218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1853221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1853224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1853230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853256 */     // MIs[0] policy
     /* 1853256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853266 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11629:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1853269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853290 */     // GIR_Coverage, 13514,
     /* 1853290 */     GIR_EraseRootFromParent_Done,
     /* 1853291 */   // Label 25053: @1853291
     /* 1853291 */   GIM_Try, /*On fail goto*//*Label 25054*/ GIMT_Encode4(1853377), // Rule ID 13515 //
     /* 1853296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1853304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1853307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1853310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1853316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853342 */     // MIs[0] policy
     /* 1853342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11629:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1853355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853376 */     // GIR_Coverage, 13515,
     /* 1853376 */     GIR_EraseRootFromParent_Done,
     /* 1853377 */   // Label 25054: @1853377
     /* 1853377 */   GIM_Try, /*On fail goto*//*Label 25055*/ GIMT_Encode4(1853463), // Rule ID 13518 //
     /* 1853382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1853390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1853393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1853396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1853402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853428 */     // MIs[0] policy
     /* 1853428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853438 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11629:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1853441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853462 */     // GIR_Coverage, 13518,
     /* 1853462 */     GIR_EraseRootFromParent_Done,
     /* 1853463 */   // Label 25055: @1853463
     /* 1853463 */   GIM_Try, /*On fail goto*//*Label 25056*/ GIMT_Encode4(1853549), // Rule ID 13519 //
     /* 1853468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1853476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1853479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1853482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1853488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853514 */     // MIs[0] policy
     /* 1853514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11629:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1853527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853548 */     // GIR_Coverage, 13519,
     /* 1853548 */     GIR_EraseRootFromParent_Done,
     /* 1853549 */   // Label 25056: @1853549
     /* 1853549 */   GIM_Try, /*On fail goto*//*Label 25057*/ GIMT_Encode4(1853635), // Rule ID 13522 //
     /* 1853554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1853562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1853565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1853568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1853574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1853577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853600 */     // MIs[0] policy
     /* 1853600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853610 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11629:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1853613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853634 */     // GIR_Coverage, 13522,
     /* 1853634 */     GIR_EraseRootFromParent_Done,
     /* 1853635 */   // Label 25057: @1853635
     /* 1853635 */   GIM_Try, /*On fail goto*//*Label 25058*/ GIMT_Encode4(1853721), // Rule ID 13523 //
     /* 1853640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1853648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1853651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1853654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1853660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1853663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853686 */     // MIs[0] policy
     /* 1853686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853696 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11629:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1853699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853720 */     // GIR_Coverage, 13523,
     /* 1853720 */     GIR_EraseRootFromParent_Done,
     /* 1853721 */   // Label 25058: @1853721
     /* 1853721 */   GIM_Try, /*On fail goto*//*Label 25059*/ GIMT_Encode4(1853807), // Rule ID 13526 //
     /* 1853726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1853729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1853734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1853737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1853740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1853746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853772 */     // MIs[0] policy
     /* 1853772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853782 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11629:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1853785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853806 */     // GIR_Coverage, 13526,
     /* 1853806 */     GIR_EraseRootFromParent_Done,
     /* 1853807 */   // Label 25059: @1853807
     /* 1853807 */   GIM_Try, /*On fail goto*//*Label 25060*/ GIMT_Encode4(1853893), // Rule ID 13527 //
     /* 1853812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1853820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1853823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1853826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1853832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853858 */     // MIs[0] policy
     /* 1853858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853868 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11629:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1853871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853892 */     // GIR_Coverage, 13527,
     /* 1853892 */     GIR_EraseRootFromParent_Done,
     /* 1853893 */   // Label 25060: @1853893
     /* 1853893 */   GIM_Try, /*On fail goto*//*Label 25061*/ GIMT_Encode4(1853979), // Rule ID 13530 //
     /* 1853898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1853901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1853906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1853909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1853912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1853918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853944 */     // MIs[0] policy
     /* 1853944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853954 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11629:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1853957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853978 */     // GIR_Coverage, 13530,
     /* 1853978 */     GIR_EraseRootFromParent_Done,
     /* 1853979 */   // Label 25061: @1853979
     /* 1853979 */   GIM_Try, /*On fail goto*//*Label 25062*/ GIMT_Encode4(1854065), // Rule ID 13531 //
     /* 1853984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1853992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1853995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1853998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1854004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854030 */     // MIs[0] policy
     /* 1854030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11629:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1854043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1854061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854064 */     // GIR_Coverage, 13531,
     /* 1854064 */     GIR_EraseRootFromParent_Done,
     /* 1854065 */   // Label 25062: @1854065
     /* 1854065 */   GIM_Try, /*On fail goto*//*Label 25063*/ GIMT_Encode4(1854151), // Rule ID 13534 //
     /* 1854070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1854073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1854078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1854081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1854084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1854090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1854100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854116 */     // MIs[0] policy
     /* 1854116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854126 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11629:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1854129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1854147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854150 */     // GIR_Coverage, 13534,
     /* 1854150 */     GIR_EraseRootFromParent_Done,
     /* 1854151 */   // Label 25063: @1854151
     /* 1854151 */   GIM_Try, /*On fail goto*//*Label 25064*/ GIMT_Encode4(1854237), // Rule ID 13535 //
     /* 1854156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1854159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1854164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1854167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1854170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1854176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1854186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854202 */     // MIs[0] policy
     /* 1854202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854212 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11629:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1854215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1854233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854236 */     // GIR_Coverage, 13535,
     /* 1854236 */     GIR_EraseRootFromParent_Done,
     /* 1854237 */   // Label 25064: @1854237
     /* 1854237 */   GIM_Try, /*On fail goto*//*Label 25065*/ GIMT_Encode4(1854323), // Rule ID 13538 //
     /* 1854242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1854245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1854250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1854253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1854256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1854262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854288 */     // MIs[0] policy
     /* 1854288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854298 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11629:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1854301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1854319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854322 */     // GIR_Coverage, 13538,
     /* 1854322 */     GIR_EraseRootFromParent_Done,
     /* 1854323 */   // Label 25065: @1854323
     /* 1854323 */   GIM_Try, /*On fail goto*//*Label 25066*/ GIMT_Encode4(1854409), // Rule ID 13539 //
     /* 1854328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1854331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1854336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1854339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1854342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1854348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854374 */     // MIs[0] policy
     /* 1854374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854384 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11629:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1854387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1854405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854408 */     // GIR_Coverage, 13539,
     /* 1854408 */     GIR_EraseRootFromParent_Done,
     /* 1854409 */   // Label 25066: @1854409
     /* 1854409 */   GIM_Try, /*On fail goto*//*Label 25067*/ GIMT_Encode4(1854495), // Rule ID 13542 //
     /* 1854414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1854425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1854428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1854431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1854434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854460 */     // MIs[0] policy
     /* 1854460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854470 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11625:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1854473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854494 */     // GIR_Coverage, 13542,
     /* 1854494 */     GIR_EraseRootFromParent_Done,
     /* 1854495 */   // Label 25067: @1854495
     /* 1854495 */   GIM_Try, /*On fail goto*//*Label 25068*/ GIMT_Encode4(1854581), // Rule ID 13543 //
     /* 1854500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1854511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1854514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1854517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1854520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854546 */     // MIs[0] policy
     /* 1854546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854556 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11625:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1854559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854580 */     // GIR_Coverage, 13543,
     /* 1854580 */     GIR_EraseRootFromParent_Done,
     /* 1854581 */   // Label 25068: @1854581
     /* 1854581 */   GIM_Try, /*On fail goto*//*Label 25069*/ GIMT_Encode4(1854667), // Rule ID 13546 //
     /* 1854586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1854597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1854600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1854603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1854606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854632 */     // MIs[0] policy
     /* 1854632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854642 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11625:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1854645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854666 */     // GIR_Coverage, 13546,
     /* 1854666 */     GIR_EraseRootFromParent_Done,
     /* 1854667 */   // Label 25069: @1854667
     /* 1854667 */   GIM_Try, /*On fail goto*//*Label 25070*/ GIMT_Encode4(1854753), // Rule ID 13547 //
     /* 1854672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1854683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1854686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1854689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1854692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854718 */     // MIs[0] policy
     /* 1854718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854728 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11625:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1854731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854752 */     // GIR_Coverage, 13547,
     /* 1854752 */     GIR_EraseRootFromParent_Done,
     /* 1854753 */   // Label 25070: @1854753
     /* 1854753 */   GIM_Try, /*On fail goto*//*Label 25071*/ GIMT_Encode4(1854839), // Rule ID 13550 //
     /* 1854758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1854769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1854772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1854775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1854778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854804 */     // MIs[0] policy
     /* 1854804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854814 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11625:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1854817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854838 */     // GIR_Coverage, 13550,
     /* 1854838 */     GIR_EraseRootFromParent_Done,
     /* 1854839 */   // Label 25071: @1854839
     /* 1854839 */   GIM_Try, /*On fail goto*//*Label 25072*/ GIMT_Encode4(1854925), // Rule ID 13551 //
     /* 1854844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1854855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1854858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1854861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1854864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854890 */     // MIs[0] policy
     /* 1854890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11625:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1854903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854924 */     // GIR_Coverage, 13551,
     /* 1854924 */     GIR_EraseRootFromParent_Done,
     /* 1854925 */   // Label 25072: @1854925
     /* 1854925 */   GIM_Try, /*On fail goto*//*Label 25073*/ GIMT_Encode4(1855011), // Rule ID 13554 //
     /* 1854930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1854941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1854944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1854947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1854950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854976 */     // MIs[0] policy
     /* 1854976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11625:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1854989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855010 */     // GIR_Coverage, 13554,
     /* 1855010 */     GIR_EraseRootFromParent_Done,
     /* 1855011 */   // Label 25073: @1855011
     /* 1855011 */   GIM_Try, /*On fail goto*//*Label 25074*/ GIMT_Encode4(1855097), // Rule ID 13555 //
     /* 1855016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1855027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1855030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1855033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1855036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855062 */     // MIs[0] policy
     /* 1855062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855072 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11625:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1855075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855096 */     // GIR_Coverage, 13555,
     /* 1855096 */     GIR_EraseRootFromParent_Done,
     /* 1855097 */   // Label 25074: @1855097
     /* 1855097 */   GIM_Try, /*On fail goto*//*Label 25075*/ GIMT_Encode4(1855183), // Rule ID 13558 //
     /* 1855102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1855113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1855116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1855119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1855122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1855125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855148 */     // MIs[0] policy
     /* 1855148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855158 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11625:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1855161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855182 */     // GIR_Coverage, 13558,
     /* 1855182 */     GIR_EraseRootFromParent_Done,
     /* 1855183 */   // Label 25075: @1855183
     /* 1855183 */   GIM_Try, /*On fail goto*//*Label 25076*/ GIMT_Encode4(1855269), // Rule ID 13559 //
     /* 1855188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1855199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1855202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1855205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1855208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1855211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855234 */     // MIs[0] policy
     /* 1855234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11625:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1855247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855268 */     // GIR_Coverage, 13559,
     /* 1855268 */     GIR_EraseRootFromParent_Done,
     /* 1855269 */   // Label 25076: @1855269
     /* 1855269 */   GIM_Try, /*On fail goto*//*Label 25077*/ GIMT_Encode4(1855355), // Rule ID 13562 //
     /* 1855274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1855285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1855288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1855291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1855294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1855297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855320 */     // MIs[0] policy
     /* 1855320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855330 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11625:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1855333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855354 */     // GIR_Coverage, 13562,
     /* 1855354 */     GIR_EraseRootFromParent_Done,
     /* 1855355 */   // Label 25077: @1855355
     /* 1855355 */   GIM_Try, /*On fail goto*//*Label 25078*/ GIMT_Encode4(1855441), // Rule ID 13563 //
     /* 1855360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1855371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1855374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1855377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1855380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1855383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855406 */     // MIs[0] policy
     /* 1855406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855416 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11625:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1855419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855440 */     // GIR_Coverage, 13563,
     /* 1855440 */     GIR_EraseRootFromParent_Done,
     /* 1855441 */   // Label 25078: @1855441
     /* 1855441 */   GIM_Try, /*On fail goto*//*Label 25079*/ GIMT_Encode4(1855527), // Rule ID 13566 //
     /* 1855446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1855457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1855460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1855463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1855466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855492 */     // MIs[0] policy
     /* 1855492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11625:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1855505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855526 */     // GIR_Coverage, 13566,
     /* 1855526 */     GIR_EraseRootFromParent_Done,
     /* 1855527 */   // Label 25079: @1855527
     /* 1855527 */   GIM_Try, /*On fail goto*//*Label 25080*/ GIMT_Encode4(1855613), // Rule ID 13567 //
     /* 1855532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1855543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1855546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1855549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1855552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855578 */     // MIs[0] policy
     /* 1855578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855588 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11625:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1855591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855612 */     // GIR_Coverage, 13567,
     /* 1855612 */     GIR_EraseRootFromParent_Done,
     /* 1855613 */   // Label 25080: @1855613
     /* 1855613 */   GIM_Try, /*On fail goto*//*Label 25081*/ GIMT_Encode4(1855699), // Rule ID 13570 //
     /* 1855618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1855629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1855632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1855635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1855638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855664 */     // MIs[0] policy
     /* 1855664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11625:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1855677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855698 */     // GIR_Coverage, 13570,
     /* 1855698 */     GIR_EraseRootFromParent_Done,
     /* 1855699 */   // Label 25081: @1855699
     /* 1855699 */   GIM_Try, /*On fail goto*//*Label 25082*/ GIMT_Encode4(1855785), // Rule ID 13571 //
     /* 1855704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1855715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1855718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1855721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1855724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855750 */     // MIs[0] policy
     /* 1855750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855760 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11625:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1855763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855784 */     // GIR_Coverage, 13571,
     /* 1855784 */     GIR_EraseRootFromParent_Done,
     /* 1855785 */   // Label 25082: @1855785
     /* 1855785 */   GIM_Try, /*On fail goto*//*Label 25083*/ GIMT_Encode4(1855871), // Rule ID 13574 //
     /* 1855790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1855801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1855804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1855807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1855810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855836 */     // MIs[0] policy
     /* 1855836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855846 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11625:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1855849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855870 */     // GIR_Coverage, 13574,
     /* 1855870 */     GIR_EraseRootFromParent_Done,
     /* 1855871 */   // Label 25083: @1855871
     /* 1855871 */   GIM_Try, /*On fail goto*//*Label 25084*/ GIMT_Encode4(1855957), // Rule ID 13575 //
     /* 1855876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1855887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1855890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1855893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1855896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855922 */     // MIs[0] policy
     /* 1855922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855932 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11625:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1855935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855956 */     // GIR_Coverage, 13575,
     /* 1855956 */     GIR_EraseRootFromParent_Done,
     /* 1855957 */   // Label 25084: @1855957
     /* 1855957 */   GIM_Try, /*On fail goto*//*Label 25085*/ GIMT_Encode4(1856043), // Rule ID 13578 //
     /* 1855962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1855973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1855976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1855979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1855982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856008 */     // MIs[0] policy
     /* 1856008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856018 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11625:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1856021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1856039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856042 */     // GIR_Coverage, 13578,
     /* 1856042 */     GIR_EraseRootFromParent_Done,
     /* 1856043 */   // Label 25085: @1856043
     /* 1856043 */   GIM_Try, /*On fail goto*//*Label 25086*/ GIMT_Encode4(1856129), // Rule ID 13579 //
     /* 1856048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1856059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1856062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1856065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1856068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856094 */     // MIs[0] policy
     /* 1856094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856104 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11625:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1856107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1856125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856128 */     // GIR_Coverage, 13579,
     /* 1856128 */     GIR_EraseRootFromParent_Done,
     /* 1856129 */   // Label 25086: @1856129
     /* 1856129 */   GIM_Try, /*On fail goto*//*Label 25087*/ GIMT_Encode4(1856215), // Rule ID 13582 //
     /* 1856134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1856145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1856148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1856151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1856154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856180 */     // MIs[0] policy
     /* 1856180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856190 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11625:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1856193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1856211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856214 */     // GIR_Coverage, 13582,
     /* 1856214 */     GIR_EraseRootFromParent_Done,
     /* 1856215 */   // Label 25087: @1856215
     /* 1856215 */   GIM_Try, /*On fail goto*//*Label 25088*/ GIMT_Encode4(1856301), // Rule ID 13583 //
     /* 1856220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1856231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1856234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1856237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1856240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856266 */     // MIs[0] policy
     /* 1856266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856276 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11625:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1856279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1856297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856300 */     // GIR_Coverage, 13583,
     /* 1856300 */     GIR_EraseRootFromParent_Done,
     /* 1856301 */   // Label 25088: @1856301
     /* 1856301 */   GIM_Try, /*On fail goto*//*Label 25089*/ GIMT_Encode4(1856387), // Rule ID 13586 //
     /* 1856306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1856309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1856317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1856320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1856323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1856326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856352 */     // MIs[0] policy
     /* 1856352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856362 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11625:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1856365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856386 */     // GIR_Coverage, 13586,
     /* 1856386 */     GIR_EraseRootFromParent_Done,
     /* 1856387 */   // Label 25089: @1856387
     /* 1856387 */   GIM_Try, /*On fail goto*//*Label 25090*/ GIMT_Encode4(1856473), // Rule ID 13587 //
     /* 1856392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1856395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1856403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1856406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1856409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1856412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856438 */     // MIs[0] policy
     /* 1856438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856448 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11625:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1856451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856472 */     // GIR_Coverage, 13587,
     /* 1856472 */     GIR_EraseRootFromParent_Done,
     /* 1856473 */   // Label 25090: @1856473
     /* 1856473 */   GIM_Try, /*On fail goto*//*Label 25091*/ GIMT_Encode4(1856559), // Rule ID 13590 //
     /* 1856478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1856481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1856489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1856492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1856495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1856498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856524 */     // MIs[0] policy
     /* 1856524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11625:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1856537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856558 */     // GIR_Coverage, 13590,
     /* 1856558 */     GIR_EraseRootFromParent_Done,
     /* 1856559 */   // Label 25091: @1856559
     /* 1856559 */   GIM_Try, /*On fail goto*//*Label 25092*/ GIMT_Encode4(1856645), // Rule ID 13591 //
     /* 1856564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1856567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1856575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1856578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1856581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1856584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856610 */     // MIs[0] policy
     /* 1856610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856620 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11625:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1856623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856644 */     // GIR_Coverage, 13591,
     /* 1856644 */     GIR_EraseRootFromParent_Done,
     /* 1856645 */   // Label 25092: @1856645
     /* 1856645 */   GIM_Try, /*On fail goto*//*Label 25093*/ GIMT_Encode4(1856731), // Rule ID 13594 //
     /* 1856650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1856653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1856661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1856664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1856667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1856670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856696 */     // MIs[0] policy
     /* 1856696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856706 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11625:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1856709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856730 */     // GIR_Coverage, 13594,
     /* 1856730 */     GIR_EraseRootFromParent_Done,
     /* 1856731 */   // Label 25093: @1856731
     /* 1856731 */   GIM_Try, /*On fail goto*//*Label 25094*/ GIMT_Encode4(1856817), // Rule ID 13595 //
     /* 1856736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1856739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1856747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1856750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1856753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1856756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856782 */     // MIs[0] policy
     /* 1856782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856792 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11625:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1856795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856816 */     // GIR_Coverage, 13595,
     /* 1856816 */     GIR_EraseRootFromParent_Done,
     /* 1856817 */   // Label 25094: @1856817
     /* 1856817 */   GIM_Try, /*On fail goto*//*Label 25095*/ GIMT_Encode4(1856903), // Rule ID 13598 //
     /* 1856822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1856825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1856833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1856836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1856839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1856842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856868 */     // MIs[0] policy
     /* 1856868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856878 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11625:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1856881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856902 */     // GIR_Coverage, 13598,
     /* 1856902 */     GIR_EraseRootFromParent_Done,
     /* 1856903 */   // Label 25095: @1856903
     /* 1856903 */   GIM_Try, /*On fail goto*//*Label 25096*/ GIMT_Encode4(1856989), // Rule ID 13599 //
     /* 1856908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1856911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1856919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1856922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1856925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1856928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856954 */     // MIs[0] policy
     /* 1856954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856964 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11625:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1856967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856988 */     // GIR_Coverage, 13599,
     /* 1856988 */     GIR_EraseRootFromParent_Done,
     /* 1856989 */   // Label 25096: @1856989
     /* 1856989 */   GIM_Try, /*On fail goto*//*Label 25097*/ GIMT_Encode4(1857075), // Rule ID 13602 //
     /* 1856994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1857002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1857005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1857008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1857011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1857014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857040 */     // MIs[0] policy
     /* 1857040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857050 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11625:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1857053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857074 */     // GIR_Coverage, 13602,
     /* 1857074 */     GIR_EraseRootFromParent_Done,
     /* 1857075 */   // Label 25097: @1857075
     /* 1857075 */   GIM_Try, /*On fail goto*//*Label 25098*/ GIMT_Encode4(1857161), // Rule ID 13603 //
     /* 1857080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1857088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1857091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1857094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1857097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1857100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857126 */     // MIs[0] policy
     /* 1857126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857136 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11625:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1857139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857160 */     // GIR_Coverage, 13603,
     /* 1857160 */     GIR_EraseRootFromParent_Done,
     /* 1857161 */   // Label 25098: @1857161
     /* 1857161 */   GIM_Try, /*On fail goto*//*Label 25099*/ GIMT_Encode4(1857247), // Rule ID 13606 //
     /* 1857166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1857174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1857177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1857180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1857183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1857186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857212 */     // MIs[0] policy
     /* 1857212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857222 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11625:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1857225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857246 */     // GIR_Coverage, 13606,
     /* 1857246 */     GIR_EraseRootFromParent_Done,
     /* 1857247 */   // Label 25099: @1857247
     /* 1857247 */   GIM_Try, /*On fail goto*//*Label 25100*/ GIMT_Encode4(1857333), // Rule ID 13607 //
     /* 1857252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1857260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1857263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1857266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1857269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1857272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857298 */     // MIs[0] policy
     /* 1857298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857308 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11625:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1857311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857332 */     // GIR_Coverage, 13607,
     /* 1857332 */     GIR_EraseRootFromParent_Done,
     /* 1857333 */   // Label 25100: @1857333
     /* 1857333 */   GIM_Try, /*On fail goto*//*Label 25101*/ GIMT_Encode4(1857419), // Rule ID 13610 //
     /* 1857338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1857346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1857349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1857352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1857355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1857358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857384 */     // MIs[0] policy
     /* 1857384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857394 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11625:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1857397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857418 */     // GIR_Coverage, 13610,
     /* 1857418 */     GIR_EraseRootFromParent_Done,
     /* 1857419 */   // Label 25101: @1857419
     /* 1857419 */   GIM_Try, /*On fail goto*//*Label 25102*/ GIMT_Encode4(1857505), // Rule ID 13611 //
     /* 1857424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1857432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1857435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1857438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1857441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1857444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857470 */     // MIs[0] policy
     /* 1857470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857480 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11625:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1857483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857504 */     // GIR_Coverage, 13611,
     /* 1857504 */     GIR_EraseRootFromParent_Done,
     /* 1857505 */   // Label 25102: @1857505
     /* 1857505 */   GIM_Try, /*On fail goto*//*Label 25103*/ GIMT_Encode4(1857591), // Rule ID 13614 //
     /* 1857510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1857518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1857521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1857524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1857527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1857530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857556 */     // MIs[0] policy
     /* 1857556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857566 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11625:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1857569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857590 */     // GIR_Coverage, 13614,
     /* 1857590 */     GIR_EraseRootFromParent_Done,
     /* 1857591 */   // Label 25103: @1857591
     /* 1857591 */   GIM_Try, /*On fail goto*//*Label 25104*/ GIMT_Encode4(1857677), // Rule ID 13615 //
     /* 1857596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1857604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1857607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1857610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1857613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1857616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857642 */     // MIs[0] policy
     /* 1857642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11625:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1857655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857676 */     // GIR_Coverage, 13615,
     /* 1857676 */     GIR_EraseRootFromParent_Done,
     /* 1857677 */   // Label 25104: @1857677
     /* 1857677 */   GIM_Try, /*On fail goto*//*Label 25105*/ GIMT_Encode4(1857763), // Rule ID 13618 //
     /* 1857682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1857690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1857693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1857696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1857699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1857702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1857705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857728 */     // MIs[0] policy
     /* 1857728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857738 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11625:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1857741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857762 */     // GIR_Coverage, 13618,
     /* 1857762 */     GIR_EraseRootFromParent_Done,
     /* 1857763 */   // Label 25105: @1857763
     /* 1857763 */   GIM_Try, /*On fail goto*//*Label 25106*/ GIMT_Encode4(1857849), // Rule ID 13619 //
     /* 1857768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1857776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1857779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1857782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1857785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1857788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1857791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857814 */     // MIs[0] policy
     /* 1857814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857824 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11625:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1857827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857848 */     // GIR_Coverage, 13619,
     /* 1857848 */     GIR_EraseRootFromParent_Done,
     /* 1857849 */   // Label 25106: @1857849
     /* 1857849 */   GIM_Try, /*On fail goto*//*Label 25107*/ GIMT_Encode4(1857935), // Rule ID 13622 //
     /* 1857854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1857862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1857865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1857868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1857871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1857874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1857877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857900 */     // MIs[0] policy
     /* 1857900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857910 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11625:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1857913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857934 */     // GIR_Coverage, 13622,
     /* 1857934 */     GIR_EraseRootFromParent_Done,
     /* 1857935 */   // Label 25107: @1857935
     /* 1857935 */   GIM_Try, /*On fail goto*//*Label 25108*/ GIMT_Encode4(1858021), // Rule ID 13623 //
     /* 1857940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1857948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1857951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1857954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1857957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1857960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1857963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857986 */     // MIs[0] policy
     /* 1857986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857996 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11625:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1857999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858020 */     // GIR_Coverage, 13623,
     /* 1858020 */     GIR_EraseRootFromParent_Done,
     /* 1858021 */   // Label 25108: @1858021
     /* 1858021 */   GIM_Try, /*On fail goto*//*Label 25109*/ GIMT_Encode4(1858107), // Rule ID 13626 //
     /* 1858026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1858034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1858037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1858040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1858046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858072 */     // MIs[0] policy
     /* 1858072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858082 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11625:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1858085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858106 */     // GIR_Coverage, 13626,
     /* 1858106 */     GIR_EraseRootFromParent_Done,
     /* 1858107 */   // Label 25109: @1858107
     /* 1858107 */   GIM_Try, /*On fail goto*//*Label 25110*/ GIMT_Encode4(1858193), // Rule ID 13627 //
     /* 1858112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1858120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1858123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1858126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1858132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858158 */     // MIs[0] policy
     /* 1858158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11625:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1858171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858192 */     // GIR_Coverage, 13627,
     /* 1858192 */     GIR_EraseRootFromParent_Done,
     /* 1858193 */   // Label 25110: @1858193
     /* 1858193 */   GIM_Try, /*On fail goto*//*Label 25111*/ GIMT_Encode4(1858279), // Rule ID 13630 //
     /* 1858198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1858206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1858209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1858212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1858218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858244 */     // MIs[0] policy
     /* 1858244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858254 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11625:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1858257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858278 */     // GIR_Coverage, 13630,
     /* 1858278 */     GIR_EraseRootFromParent_Done,
     /* 1858279 */   // Label 25111: @1858279
     /* 1858279 */   GIM_Try, /*On fail goto*//*Label 25112*/ GIMT_Encode4(1858365), // Rule ID 13631 //
     /* 1858284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1858292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1858295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1858298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1858304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858330 */     // MIs[0] policy
     /* 1858330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11625:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1858343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858364 */     // GIR_Coverage, 13631,
     /* 1858364 */     GIR_EraseRootFromParent_Done,
     /* 1858365 */   // Label 25112: @1858365
     /* 1858365 */   GIM_Try, /*On fail goto*//*Label 25113*/ GIMT_Encode4(1858451), // Rule ID 13634 //
     /* 1858370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1858378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1858381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1858384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1858390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858416 */     // MIs[0] policy
     /* 1858416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11625:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1858429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858450 */     // GIR_Coverage, 13634,
     /* 1858450 */     GIR_EraseRootFromParent_Done,
     /* 1858451 */   // Label 25113: @1858451
     /* 1858451 */   GIM_Try, /*On fail goto*//*Label 25114*/ GIMT_Encode4(1858537), // Rule ID 13635 //
     /* 1858456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1858464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1858467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1858470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1858476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858502 */     // MIs[0] policy
     /* 1858502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11625:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1858515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858536 */     // GIR_Coverage, 13635,
     /* 1858536 */     GIR_EraseRootFromParent_Done,
     /* 1858537 */   // Label 25114: @1858537
     /* 1858537 */   GIM_Try, /*On fail goto*//*Label 25115*/ GIMT_Encode4(1858623), // Rule ID 13638 //
     /* 1858542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1858550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1858553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1858556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1858562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858588 */     // MIs[0] policy
     /* 1858588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11625:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1858601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858622 */     // GIR_Coverage, 13638,
     /* 1858622 */     GIR_EraseRootFromParent_Done,
     /* 1858623 */   // Label 25115: @1858623
     /* 1858623 */   GIM_Try, /*On fail goto*//*Label 25116*/ GIMT_Encode4(1858709), // Rule ID 13639 //
     /* 1858628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1858636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1858639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1858642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1858648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858674 */     // MIs[0] policy
     /* 1858674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858684 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11625:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1858687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858708 */     // GIR_Coverage, 13639,
     /* 1858708 */     GIR_EraseRootFromParent_Done,
     /* 1858709 */   // Label 25116: @1858709
     /* 1858709 */   GIM_Try, /*On fail goto*//*Label 25117*/ GIMT_Encode4(1858795), // Rule ID 13642 //
     /* 1858714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1858722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1858725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1858728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1858734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1858737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858760 */     // MIs[0] policy
     /* 1858760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858770 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11625:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1858773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858794 */     // GIR_Coverage, 13642,
     /* 1858794 */     GIR_EraseRootFromParent_Done,
     /* 1858795 */   // Label 25117: @1858795
     /* 1858795 */   GIM_Try, /*On fail goto*//*Label 25118*/ GIMT_Encode4(1858881), // Rule ID 13643 //
     /* 1858800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1858808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1858811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1858814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1858820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1858823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858846 */     // MIs[0] policy
     /* 1858846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858856 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11625:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1858859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858880 */     // GIR_Coverage, 13643,
     /* 1858880 */     GIR_EraseRootFromParent_Done,
     /* 1858881 */   // Label 25118: @1858881
     /* 1858881 */   GIM_Try, /*On fail goto*//*Label 25119*/ GIMT_Encode4(1858967), // Rule ID 13646 //
     /* 1858886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1858894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1858897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1858900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1858906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858932 */     // MIs[0] policy
     /* 1858932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858942 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11625:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1858945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858966 */     // GIR_Coverage, 13646,
     /* 1858966 */     GIR_EraseRootFromParent_Done,
     /* 1858967 */   // Label 25119: @1858967
     /* 1858967 */   GIM_Try, /*On fail goto*//*Label 25120*/ GIMT_Encode4(1859053), // Rule ID 13647 //
     /* 1858972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1858980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1858983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1858986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1858992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859018 */     // MIs[0] policy
     /* 1859018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859028 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11625:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1859031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859052 */     // GIR_Coverage, 13647,
     /* 1859052 */     GIR_EraseRootFromParent_Done,
     /* 1859053 */   // Label 25120: @1859053
     /* 1859053 */   GIM_Try, /*On fail goto*//*Label 25121*/ GIMT_Encode4(1859139), // Rule ID 13650 //
     /* 1859058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1859061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1859066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1859069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1859072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1859078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859104 */     // MIs[0] policy
     /* 1859104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11625:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1859117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859138 */     // GIR_Coverage, 13650,
     /* 1859138 */     GIR_EraseRootFromParent_Done,
     /* 1859139 */   // Label 25121: @1859139
     /* 1859139 */   GIM_Try, /*On fail goto*//*Label 25122*/ GIMT_Encode4(1859225), // Rule ID 13651 //
     /* 1859144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1859147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1859152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1859155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1859158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1859164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859190 */     // MIs[0] policy
     /* 1859190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859200 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11625:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1859203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859224 */     // GIR_Coverage, 13651,
     /* 1859224 */     GIR_EraseRootFromParent_Done,
     /* 1859225 */   // Label 25122: @1859225
     /* 1859225 */   GIM_Try, /*On fail goto*//*Label 25123*/ GIMT_Encode4(1859311), // Rule ID 13654 //
     /* 1859230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1859233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1859238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1859241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1859244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1859250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859276 */     // MIs[0] policy
     /* 1859276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859286 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11625:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1859289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859310 */     // GIR_Coverage, 13654,
     /* 1859310 */     GIR_EraseRootFromParent_Done,
     /* 1859311 */   // Label 25123: @1859311
     /* 1859311 */   GIM_Try, /*On fail goto*//*Label 25124*/ GIMT_Encode4(1859397), // Rule ID 13655 //
     /* 1859316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1859319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1859324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1859327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1859330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1859336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859362 */     // MIs[0] policy
     /* 1859362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859372 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11625:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1859375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859396 */     // GIR_Coverage, 13655,
     /* 1859396 */     GIR_EraseRootFromParent_Done,
     /* 1859397 */   // Label 25124: @1859397
     /* 1859397 */   GIM_Try, /*On fail goto*//*Label 25125*/ GIMT_Encode4(1859483), // Rule ID 13658 //
     /* 1859402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1859405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1859410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1859413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1859416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1859422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859448 */     // MIs[0] policy
     /* 1859448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859458 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11625:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1859461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859482 */     // GIR_Coverage, 13658,
     /* 1859482 */     GIR_EraseRootFromParent_Done,
     /* 1859483 */   // Label 25125: @1859483
     /* 1859483 */   GIM_Try, /*On fail goto*//*Label 25126*/ GIMT_Encode4(1859569), // Rule ID 13659 //
     /* 1859488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1859491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1859496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1859499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1859502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1859508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859534 */     // MIs[0] policy
     /* 1859534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859544 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11625:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1859547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859568 */     // GIR_Coverage, 13659,
     /* 1859568 */     GIR_EraseRootFromParent_Done,
     /* 1859569 */   // Label 25126: @1859569
     /* 1859569 */   GIM_Try, /*On fail goto*//*Label 25127*/ GIMT_Encode4(1859655), // Rule ID 13662 //
     /* 1859574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1859585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1859588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1859591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1859594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859620 */     // MIs[0] policy
     /* 1859620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11627:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1859633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859654 */     // GIR_Coverage, 13662,
     /* 1859654 */     GIR_EraseRootFromParent_Done,
     /* 1859655 */   // Label 25127: @1859655
     /* 1859655 */   GIM_Try, /*On fail goto*//*Label 25128*/ GIMT_Encode4(1859741), // Rule ID 13663 //
     /* 1859660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1859671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1859674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1859677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1859680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859706 */     // MIs[0] policy
     /* 1859706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859716 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11627:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1859719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859740 */     // GIR_Coverage, 13663,
     /* 1859740 */     GIR_EraseRootFromParent_Done,
     /* 1859741 */   // Label 25128: @1859741
     /* 1859741 */   GIM_Try, /*On fail goto*//*Label 25129*/ GIMT_Encode4(1859827), // Rule ID 13666 //
     /* 1859746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1859757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1859760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1859763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1859766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859792 */     // MIs[0] policy
     /* 1859792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859802 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11627:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1859805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859826 */     // GIR_Coverage, 13666,
     /* 1859826 */     GIR_EraseRootFromParent_Done,
     /* 1859827 */   // Label 25129: @1859827
     /* 1859827 */   GIM_Try, /*On fail goto*//*Label 25130*/ GIMT_Encode4(1859913), // Rule ID 13667 //
     /* 1859832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1859843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1859846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1859849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1859852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859878 */     // MIs[0] policy
     /* 1859878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859888 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11627:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1859891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859912 */     // GIR_Coverage, 13667,
     /* 1859912 */     GIR_EraseRootFromParent_Done,
     /* 1859913 */   // Label 25130: @1859913
     /* 1859913 */   GIM_Try, /*On fail goto*//*Label 25131*/ GIMT_Encode4(1859999), // Rule ID 13670 //
     /* 1859918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1859929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1859932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1859935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1859938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859964 */     // MIs[0] policy
     /* 1859964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859974 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11627:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1859977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859998 */     // GIR_Coverage, 13670,
     /* 1859998 */     GIR_EraseRootFromParent_Done,
     /* 1859999 */   // Label 25131: @1859999
     /* 1859999 */   GIM_Try, /*On fail goto*//*Label 25132*/ GIMT_Encode4(1860085), // Rule ID 13671 //
     /* 1860004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1860015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1860018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1860021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1860024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860050 */     // MIs[0] policy
     /* 1860050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860060 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11627:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1860063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1860081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860084 */     // GIR_Coverage, 13671,
     /* 1860084 */     GIR_EraseRootFromParent_Done,
     /* 1860085 */   // Label 25132: @1860085
     /* 1860085 */   GIM_Try, /*On fail goto*//*Label 25133*/ GIMT_Encode4(1860171), // Rule ID 13674 //
     /* 1860090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1860101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1860104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1860107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1860110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860136 */     // MIs[0] policy
     /* 1860136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11627:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1860149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1860167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860170 */     // GIR_Coverage, 13674,
     /* 1860170 */     GIR_EraseRootFromParent_Done,
     /* 1860171 */   // Label 25133: @1860171
     /* 1860171 */   GIM_Try, /*On fail goto*//*Label 25134*/ GIMT_Encode4(1860257), // Rule ID 13675 //
     /* 1860176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1860187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1860190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1860193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1860196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860222 */     // MIs[0] policy
     /* 1860222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860232 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11627:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1860235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1860253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860256 */     // GIR_Coverage, 13675,
     /* 1860256 */     GIR_EraseRootFromParent_Done,
     /* 1860257 */   // Label 25134: @1860257
     /* 1860257 */   GIM_Try, /*On fail goto*//*Label 25135*/ GIMT_Encode4(1860343), // Rule ID 13678 //
     /* 1860262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1860273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1860276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1860279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1860282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860308 */     // MIs[0] policy
     /* 1860308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860318 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11627:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1860321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1860339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860342 */     // GIR_Coverage, 13678,
     /* 1860342 */     GIR_EraseRootFromParent_Done,
     /* 1860343 */   // Label 25135: @1860343
     /* 1860343 */   GIM_Try, /*On fail goto*//*Label 25136*/ GIMT_Encode4(1860429), // Rule ID 13679 //
     /* 1860348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1860359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1860362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1860365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1860368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860394 */     // MIs[0] policy
     /* 1860394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11627:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1860407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1860425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860428 */     // GIR_Coverage, 13679,
     /* 1860428 */     GIR_EraseRootFromParent_Done,
     /* 1860429 */   // Label 25136: @1860429
     /* 1860429 */   GIM_Try, /*On fail goto*//*Label 25137*/ GIMT_Encode4(1860515), // Rule ID 13682 //
     /* 1860434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1860445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1860448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1860451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1860454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1860457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860480 */     // MIs[0] policy
     /* 1860480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860490 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11627:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1860493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1860511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860514 */     // GIR_Coverage, 13682,
     /* 1860514 */     GIR_EraseRootFromParent_Done,
     /* 1860515 */   // Label 25137: @1860515
     /* 1860515 */   GIM_Try, /*On fail goto*//*Label 25138*/ GIMT_Encode4(1860601), // Rule ID 13683 //
     /* 1860520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1860531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1860534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1860537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1860540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1860543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860566 */     // MIs[0] policy
     /* 1860566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860576 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11627:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1860579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1860597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860600 */     // GIR_Coverage, 13683,
     /* 1860600 */     GIR_EraseRootFromParent_Done,
     /* 1860601 */   // Label 25138: @1860601
     /* 1860601 */   GIM_Try, /*On fail goto*//*Label 25139*/ GIMT_Encode4(1860687), // Rule ID 13686 //
     /* 1860606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1860617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1860620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1860623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1860626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860652 */     // MIs[0] policy
     /* 1860652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860662 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11627:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1860665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860686 */     // GIR_Coverage, 13686,
     /* 1860686 */     GIR_EraseRootFromParent_Done,
     /* 1860687 */   // Label 25139: @1860687
     /* 1860687 */   GIM_Try, /*On fail goto*//*Label 25140*/ GIMT_Encode4(1860773), // Rule ID 13687 //
     /* 1860692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1860703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1860706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1860709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1860712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860738 */     // MIs[0] policy
     /* 1860738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860748 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11627:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1860751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860772 */     // GIR_Coverage, 13687,
     /* 1860772 */     GIR_EraseRootFromParent_Done,
     /* 1860773 */   // Label 25140: @1860773
     /* 1860773 */   GIM_Try, /*On fail goto*//*Label 25141*/ GIMT_Encode4(1860859), // Rule ID 13690 //
     /* 1860778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1860789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1860792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1860795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1860798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860824 */     // MIs[0] policy
     /* 1860824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11627:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1860837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860858 */     // GIR_Coverage, 13690,
     /* 1860858 */     GIR_EraseRootFromParent_Done,
     /* 1860859 */   // Label 25141: @1860859
     /* 1860859 */   GIM_Try, /*On fail goto*//*Label 25142*/ GIMT_Encode4(1860945), // Rule ID 13691 //
     /* 1860864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1860875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1860878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1860881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1860884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860910 */     // MIs[0] policy
     /* 1860910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860920 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11627:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1860923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860944 */     // GIR_Coverage, 13691,
     /* 1860944 */     GIR_EraseRootFromParent_Done,
     /* 1860945 */   // Label 25142: @1860945
     /* 1860945 */   GIM_Try, /*On fail goto*//*Label 25143*/ GIMT_Encode4(1861031), // Rule ID 13694 //
     /* 1860950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1860961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1860964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1860967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1860970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860996 */     // MIs[0] policy
     /* 1860996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861006 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11627:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1861009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861030 */     // GIR_Coverage, 13694,
     /* 1861030 */     GIR_EraseRootFromParent_Done,
     /* 1861031 */   // Label 25143: @1861031
     /* 1861031 */   GIM_Try, /*On fail goto*//*Label 25144*/ GIMT_Encode4(1861117), // Rule ID 13695 //
     /* 1861036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1861047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1861050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1861053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1861056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1861066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861082 */     // MIs[0] policy
     /* 1861082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861092 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11627:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1861095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861116 */     // GIR_Coverage, 13695,
     /* 1861116 */     GIR_EraseRootFromParent_Done,
     /* 1861117 */   // Label 25144: @1861117
     /* 1861117 */   GIM_Try, /*On fail goto*//*Label 25145*/ GIMT_Encode4(1861203), // Rule ID 13698 //
     /* 1861122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1861133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1861136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1861139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1861142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861168 */     // MIs[0] policy
     /* 1861168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861178 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11627:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1861181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861202 */     // GIR_Coverage, 13698,
     /* 1861202 */     GIR_EraseRootFromParent_Done,
     /* 1861203 */   // Label 25145: @1861203
     /* 1861203 */   GIM_Try, /*On fail goto*//*Label 25146*/ GIMT_Encode4(1861289), // Rule ID 13699 //
     /* 1861208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1861219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1861222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1861225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1861228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861254 */     // MIs[0] policy
     /* 1861254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861264 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11627:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1861267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861288 */     // GIR_Coverage, 13699,
     /* 1861288 */     GIR_EraseRootFromParent_Done,
     /* 1861289 */   // Label 25146: @1861289
     /* 1861289 */   GIM_Try, /*On fail goto*//*Label 25147*/ GIMT_Encode4(1861375), // Rule ID 13702 //
     /* 1861294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1861305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1861308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1861311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1861314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1861317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861340 */     // MIs[0] policy
     /* 1861340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861350 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11627:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1861353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861374 */     // GIR_Coverage, 13702,
     /* 1861374 */     GIR_EraseRootFromParent_Done,
     /* 1861375 */   // Label 25147: @1861375
     /* 1861375 */   GIM_Try, /*On fail goto*//*Label 25148*/ GIMT_Encode4(1861461), // Rule ID 13703 //
     /* 1861380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1861391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1861394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1861397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1861400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1861403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861426 */     // MIs[0] policy
     /* 1861426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861436 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11627:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1861439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861460 */     // GIR_Coverage, 13703,
     /* 1861460 */     GIR_EraseRootFromParent_Done,
     /* 1861461 */   // Label 25148: @1861461
     /* 1861461 */   GIM_Try, /*On fail goto*//*Label 25149*/ GIMT_Encode4(1861547), // Rule ID 13706 //
     /* 1861466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1861469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1861477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1861480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1861483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1861486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861512 */     // MIs[0] policy
     /* 1861512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861522 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11627:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1861525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861546 */     // GIR_Coverage, 13706,
     /* 1861546 */     GIR_EraseRootFromParent_Done,
     /* 1861547 */   // Label 25149: @1861547
     /* 1861547 */   GIM_Try, /*On fail goto*//*Label 25150*/ GIMT_Encode4(1861633), // Rule ID 13707 //
     /* 1861552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1861555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1861563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1861566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1861569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1861572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861598 */     // MIs[0] policy
     /* 1861598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861608 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11627:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1861611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861632 */     // GIR_Coverage, 13707,
     /* 1861632 */     GIR_EraseRootFromParent_Done,
     /* 1861633 */   // Label 25150: @1861633
     /* 1861633 */   GIM_Try, /*On fail goto*//*Label 25151*/ GIMT_Encode4(1861719), // Rule ID 13710 //
     /* 1861638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1861641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1861649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1861652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1861655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1861658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1861668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861684 */     // MIs[0] policy
     /* 1861684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861694 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11627:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1861697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861718 */     // GIR_Coverage, 13710,
     /* 1861718 */     GIR_EraseRootFromParent_Done,
     /* 1861719 */   // Label 25151: @1861719
     /* 1861719 */   GIM_Try, /*On fail goto*//*Label 25152*/ GIMT_Encode4(1861805), // Rule ID 13711 //
     /* 1861724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1861727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1861735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1861738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1861741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1861744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1861754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861770 */     // MIs[0] policy
     /* 1861770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11627:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1861783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861804 */     // GIR_Coverage, 13711,
     /* 1861804 */     GIR_EraseRootFromParent_Done,
     /* 1861805 */   // Label 25152: @1861805
     /* 1861805 */   GIM_Try, /*On fail goto*//*Label 25153*/ GIMT_Encode4(1861891), // Rule ID 13714 //
     /* 1861810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1861813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1861821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1861824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1861827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1861830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861856 */     // MIs[0] policy
     /* 1861856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861866 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11627:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1861869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861890 */     // GIR_Coverage, 13714,
     /* 1861890 */     GIR_EraseRootFromParent_Done,
     /* 1861891 */   // Label 25153: @1861891
     /* 1861891 */   GIM_Try, /*On fail goto*//*Label 25154*/ GIMT_Encode4(1861977), // Rule ID 13715 //
     /* 1861896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1861899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1861907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1861910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1861913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1861916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861942 */     // MIs[0] policy
     /* 1861942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861952 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11627:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1861955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861976 */     // GIR_Coverage, 13715,
     /* 1861976 */     GIR_EraseRootFromParent_Done,
     /* 1861977 */   // Label 25154: @1861977
     /* 1861977 */   GIM_Try, /*On fail goto*//*Label 25155*/ GIMT_Encode4(1862063), // Rule ID 13718 //
     /* 1861982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1861985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1861993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1861996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1861999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1862002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1862005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1862012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1862016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862028 */     // MIs[0] policy
     /* 1862028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862038 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11627:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1862041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862062 */     // GIR_Coverage, 13718,
     /* 1862062 */     GIR_EraseRootFromParent_Done,
     /* 1862063 */   // Label 25155: @1862063
     /* 1862063 */   GIM_Try, /*On fail goto*//*Label 25156*/ GIMT_Encode4(1862149), // Rule ID 13719 //
     /* 1862068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1862071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1862076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1862079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1862082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1862085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1862088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1862091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1862098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1862102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862114 */     // MIs[0] policy
     /* 1862114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862124 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11627:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1862127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862148 */     // GIR_Coverage, 13719,
     /* 1862148 */     GIR_EraseRootFromParent_Done,
     /* 1862149 */   // Label 25156: @1862149
     /* 1862149 */   GIM_Try, /*On fail goto*//*Label 25157*/ GIMT_Encode4(1862235), // Rule ID 13722 //
     /* 1862154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1862162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1862165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1862168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1862174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862200 */     // MIs[0] policy
     /* 1862200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11627:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1862213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862234 */     // GIR_Coverage, 13722,
     /* 1862234 */     GIR_EraseRootFromParent_Done,
     /* 1862235 */   // Label 25157: @1862235
     /* 1862235 */   GIM_Try, /*On fail goto*//*Label 25158*/ GIMT_Encode4(1862321), // Rule ID 13723 //
     /* 1862240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1862248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1862251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1862254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1862260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862286 */     // MIs[0] policy
     /* 1862286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862296 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11627:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1862299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862320 */     // GIR_Coverage, 13723,
     /* 1862320 */     GIR_EraseRootFromParent_Done,
     /* 1862321 */   // Label 25158: @1862321
     /* 1862321 */   GIM_Try, /*On fail goto*//*Label 25159*/ GIMT_Encode4(1862407), // Rule ID 13726 //
     /* 1862326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1862334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1862337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1862340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1862346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862372 */     // MIs[0] policy
     /* 1862372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11627:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1862385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862406 */     // GIR_Coverage, 13726,
     /* 1862406 */     GIR_EraseRootFromParent_Done,
     /* 1862407 */   // Label 25159: @1862407
     /* 1862407 */   GIM_Try, /*On fail goto*//*Label 25160*/ GIMT_Encode4(1862493), // Rule ID 13727 //
     /* 1862412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1862420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1862423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1862426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1862432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862458 */     // MIs[0] policy
     /* 1862458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862468 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11627:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1862471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862492 */     // GIR_Coverage, 13727,
     /* 1862492 */     GIR_EraseRootFromParent_Done,
     /* 1862493 */   // Label 25160: @1862493
     /* 1862493 */   GIM_Try, /*On fail goto*//*Label 25161*/ GIMT_Encode4(1862579), // Rule ID 13730 //
     /* 1862498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1862506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1862509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1862512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1862518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862544 */     // MIs[0] policy
     /* 1862544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862554 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11627:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1862557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862578 */     // GIR_Coverage, 13730,
     /* 1862578 */     GIR_EraseRootFromParent_Done,
     /* 1862579 */   // Label 25161: @1862579
     /* 1862579 */   GIM_Try, /*On fail goto*//*Label 25162*/ GIMT_Encode4(1862665), // Rule ID 13731 //
     /* 1862584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1862592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1862595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1862598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1862604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862630 */     // MIs[0] policy
     /* 1862630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862640 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11627:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1862643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862664 */     // GIR_Coverage, 13731,
     /* 1862664 */     GIR_EraseRootFromParent_Done,
     /* 1862665 */   // Label 25162: @1862665
     /* 1862665 */   GIM_Try, /*On fail goto*//*Label 25163*/ GIMT_Encode4(1862751), // Rule ID 13734 //
     /* 1862670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1862678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1862681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1862684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1862690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1862693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862716 */     // MIs[0] policy
     /* 1862716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11627:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1862729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862750 */     // GIR_Coverage, 13734,
     /* 1862750 */     GIR_EraseRootFromParent_Done,
     /* 1862751 */   // Label 25163: @1862751
     /* 1862751 */   GIM_Try, /*On fail goto*//*Label 25164*/ GIMT_Encode4(1862837), // Rule ID 13735 //
     /* 1862756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1862764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1862767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1862770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1862776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1862779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862802 */     // MIs[0] policy
     /* 1862802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862812 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11627:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1862815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862836 */     // GIR_Coverage, 13735,
     /* 1862836 */     GIR_EraseRootFromParent_Done,
     /* 1862837 */   // Label 25164: @1862837
     /* 1862837 */   GIM_Try, /*On fail goto*//*Label 25165*/ GIMT_Encode4(1862923), // Rule ID 13738 //
     /* 1862842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1862850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1862853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1862856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1862862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1862865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862888 */     // MIs[0] policy
     /* 1862888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862898 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11627:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1862901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862922 */     // GIR_Coverage, 13738,
     /* 1862922 */     GIR_EraseRootFromParent_Done,
     /* 1862923 */   // Label 25165: @1862923
     /* 1862923 */   GIM_Try, /*On fail goto*//*Label 25166*/ GIMT_Encode4(1863009), // Rule ID 13739 //
     /* 1862928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1862936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1862939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1862942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1862948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1862951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862974 */     // MIs[0] policy
     /* 1862974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862984 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11627:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1862987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863008 */     // GIR_Coverage, 13739,
     /* 1863008 */     GIR_EraseRootFromParent_Done,
     /* 1863009 */   // Label 25166: @1863009
     /* 1863009 */   GIM_Try, /*On fail goto*//*Label 25167*/ GIMT_Encode4(1863095), // Rule ID 13742 //
     /* 1863014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1863022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1863025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1863028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1863034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1863037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863060 */     // MIs[0] policy
     /* 1863060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863070 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11627:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1863073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863094 */     // GIR_Coverage, 13742,
     /* 1863094 */     GIR_EraseRootFromParent_Done,
     /* 1863095 */   // Label 25167: @1863095
     /* 1863095 */   GIM_Try, /*On fail goto*//*Label 25168*/ GIMT_Encode4(1863181), // Rule ID 13743 //
     /* 1863100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1863108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1863111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1863114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1863120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1863123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863146 */     // MIs[0] policy
     /* 1863146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863156 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11627:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1863159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863180 */     // GIR_Coverage, 13743,
     /* 1863180 */     GIR_EraseRootFromParent_Done,
     /* 1863181 */   // Label 25168: @1863181
     /* 1863181 */   GIM_Try, /*On fail goto*//*Label 25169*/ GIMT_Encode4(1863267), // Rule ID 13746 //
     /* 1863186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1863194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1863197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1863200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1863206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1863209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863232 */     // MIs[0] policy
     /* 1863232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863242 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11627:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1863245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863266 */     // GIR_Coverage, 13746,
     /* 1863266 */     GIR_EraseRootFromParent_Done,
     /* 1863267 */   // Label 25169: @1863267
     /* 1863267 */   GIM_Try, /*On fail goto*//*Label 25170*/ GIMT_Encode4(1863353), // Rule ID 13747 //
     /* 1863272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1863280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1863283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1863286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1863292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1863295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863318 */     // MIs[0] policy
     /* 1863318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863328 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11627:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1863331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863352 */     // GIR_Coverage, 13747,
     /* 1863352 */     GIR_EraseRootFromParent_Done,
     /* 1863353 */   // Label 25170: @1863353
     /* 1863353 */   GIM_Try, /*On fail goto*//*Label 25171*/ GIMT_Encode4(1863439), // Rule ID 13750 //
     /* 1863358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1863366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1863369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1863372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1863378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1863381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863404 */     // MIs[0] policy
     /* 1863404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863414 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11627:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1863417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863438 */     // GIR_Coverage, 13750,
     /* 1863438 */     GIR_EraseRootFromParent_Done,
     /* 1863439 */   // Label 25171: @1863439
     /* 1863439 */   GIM_Try, /*On fail goto*//*Label 25172*/ GIMT_Encode4(1863525), // Rule ID 13751 //
     /* 1863444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1863452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1863455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1863458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1863464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1863467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863490 */     // MIs[0] policy
     /* 1863490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863500 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11627:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1863503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863524 */     // GIR_Coverage, 13751,
     /* 1863524 */     GIR_EraseRootFromParent_Done,
     /* 1863525 */   // Label 25172: @1863525
     /* 1863525 */   GIM_Try, /*On fail goto*//*Label 25173*/ GIMT_Encode4(1863611), // Rule ID 13754 //
     /* 1863530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1863538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1863541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1863544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1863550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863576 */     // MIs[0] policy
     /* 1863576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11627:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1863589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863610 */     // GIR_Coverage, 13754,
     /* 1863610 */     GIR_EraseRootFromParent_Done,
     /* 1863611 */   // Label 25173: @1863611
     /* 1863611 */   GIM_Try, /*On fail goto*//*Label 25174*/ GIMT_Encode4(1863697), // Rule ID 13755 //
     /* 1863616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1863624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1863627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1863630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1863636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863662 */     // MIs[0] policy
     /* 1863662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863672 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11627:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1863675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863696 */     // GIR_Coverage, 13755,
     /* 1863696 */     GIR_EraseRootFromParent_Done,
     /* 1863697 */   // Label 25174: @1863697
     /* 1863697 */   GIM_Try, /*On fail goto*//*Label 25175*/ GIMT_Encode4(1863783), // Rule ID 13758 //
     /* 1863702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1863710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1863713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1863716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1863722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863748 */     // MIs[0] policy
     /* 1863748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863758 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11627:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1863761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863782 */     // GIR_Coverage, 13758,
     /* 1863782 */     GIR_EraseRootFromParent_Done,
     /* 1863783 */   // Label 25175: @1863783
     /* 1863783 */   GIM_Try, /*On fail goto*//*Label 25176*/ GIMT_Encode4(1863869), // Rule ID 13759 //
     /* 1863788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1863796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1863799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1863802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1863808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863834 */     // MIs[0] policy
     /* 1863834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863844 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11627:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1863847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863868 */     // GIR_Coverage, 13759,
     /* 1863868 */     GIR_EraseRootFromParent_Done,
     /* 1863869 */   // Label 25176: @1863869
     /* 1863869 */   GIM_Try, /*On fail goto*//*Label 25177*/ GIMT_Encode4(1863955), // Rule ID 13762 //
     /* 1863874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1863882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1863885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1863888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1863894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863920 */     // MIs[0] policy
     /* 1863920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863930 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11627:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1863933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863954 */     // GIR_Coverage, 13762,
     /* 1863954 */     GIR_EraseRootFromParent_Done,
     /* 1863955 */   // Label 25177: @1863955
     /* 1863955 */   GIM_Try, /*On fail goto*//*Label 25178*/ GIMT_Encode4(1864041), // Rule ID 13763 //
     /* 1863960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1863968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1863971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1863974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1863980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864006 */     // MIs[0] policy
     /* 1864006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11627:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1864019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1864023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864040 */     // GIR_Coverage, 13763,
     /* 1864040 */     GIR_EraseRootFromParent_Done,
     /* 1864041 */   // Label 25178: @1864041
     /* 1864041 */   GIM_Try, /*On fail goto*//*Label 25179*/ GIMT_Encode4(1864127), // Rule ID 13766 //
     /* 1864046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1864049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1864054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1864057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1864060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1864063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1864066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864092 */     // MIs[0] policy
     /* 1864092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864102 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11627:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1864105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1864109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864126 */     // GIR_Coverage, 13766,
     /* 1864126 */     GIR_EraseRootFromParent_Done,
     /* 1864127 */   // Label 25179: @1864127
     /* 1864127 */   GIM_Try, /*On fail goto*//*Label 25180*/ GIMT_Encode4(1864213), // Rule ID 13767 //
     /* 1864132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1864135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1864140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1864143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1864146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1864149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1864152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864178 */     // MIs[0] policy
     /* 1864178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864188 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11627:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1864191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1864195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864212 */     // GIR_Coverage, 13767,
     /* 1864212 */     GIR_EraseRootFromParent_Done,
     /* 1864213 */   // Label 25180: @1864213
     /* 1864213 */   GIM_Try, /*On fail goto*//*Label 25181*/ GIMT_Encode4(1864299), // Rule ID 13770 //
     /* 1864218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1864221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1864226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1864229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1864232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1864235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1864238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1864248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864264 */     // MIs[0] policy
     /* 1864264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864274 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11627:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1864277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1864281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864298 */     // GIR_Coverage, 13770,
     /* 1864298 */     GIR_EraseRootFromParent_Done,
     /* 1864299 */   // Label 25181: @1864299
     /* 1864299 */   GIM_Try, /*On fail goto*//*Label 25182*/ GIMT_Encode4(1864385), // Rule ID 13771 //
     /* 1864304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1864307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1864312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1864315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1864318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1864321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1864324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1864334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864350 */     // MIs[0] policy
     /* 1864350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864360 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11627:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1864363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1864367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864384 */     // GIR_Coverage, 13771,
     /* 1864384 */     GIR_EraseRootFromParent_Done,
     /* 1864385 */   // Label 25182: @1864385
     /* 1864385 */   GIM_Try, /*On fail goto*//*Label 25183*/ GIMT_Encode4(1864471), // Rule ID 13774 //
     /* 1864390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1864393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1864398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1864401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1864404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1864407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1864410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1864420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864436 */     // MIs[0] policy
     /* 1864436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864446 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11627:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1864449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1864453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864470 */     // GIR_Coverage, 13774,
     /* 1864470 */     GIR_EraseRootFromParent_Done,
     /* 1864471 */   // Label 25183: @1864471
     /* 1864471 */   GIM_Try, /*On fail goto*//*Label 25184*/ GIMT_Encode4(1864557), // Rule ID 13775 //
     /* 1864476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1864479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1864484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1864487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1864490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1864493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1864496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1864506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864522 */     // MIs[0] policy
     /* 1864522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864532 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11627:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1864535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1864539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864556 */     // GIR_Coverage, 13775,
     /* 1864556 */     GIR_EraseRootFromParent_Done,
     /* 1864557 */   // Label 25184: @1864557
     /* 1864557 */   GIM_Try, /*On fail goto*//*Label 25185*/ GIMT_Encode4(1864643), // Rule ID 13778 //
     /* 1864562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1864565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1864570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1864573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1864576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1864579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1864582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1864585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1864592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864608 */     // MIs[0] policy
     /* 1864608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864618 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11627:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1864621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1864625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864642 */     // GIR_Coverage, 13778,
     /* 1864642 */     GIR_EraseRootFromParent_Done,
     /* 1864643 */   // Label 25185: @1864643
     /* 1864643 */   GIM_Try, /*On fail goto*//*Label 25186*/ GIMT_Encode4(1864729), // Rule ID 13779 //
     /* 1864648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1864651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1864656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1864659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1864662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1864665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1864668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1864671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1864678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864694 */     // MIs[0] policy
     /* 1864694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864704 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11627:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1864707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1864711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864728 */     // GIR_Coverage, 13779,
     /* 1864728 */     GIR_EraseRootFromParent_Done,
     /* 1864729 */   // Label 25186: @1864729
     /* 1864729 */   GIM_Try, /*On fail goto*//*Label 25187*/ GIMT_Encode4(1864815), // Rule ID 13782 //
     /* 1864734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1864742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1864745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1864748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1864751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1864754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864780 */     // MIs[0] policy
     /* 1864780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864790 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1864793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1864797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864814 */     // GIR_Coverage, 13782,
     /* 1864814 */     GIR_EraseRootFromParent_Done,
     /* 1864815 */   // Label 25187: @1864815
     /* 1864815 */   GIM_Try, /*On fail goto*//*Label 25188*/ GIMT_Encode4(1864901), // Rule ID 13783 //
     /* 1864820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1864828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1864831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1864834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1864837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1864840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864866 */     // MIs[0] policy
     /* 1864866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864876 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1864879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1864883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864900 */     // GIR_Coverage, 13783,
     /* 1864900 */     GIR_EraseRootFromParent_Done,
     /* 1864901 */   // Label 25188: @1864901
     /* 1864901 */   GIM_Try, /*On fail goto*//*Label 25189*/ GIMT_Encode4(1864987), // Rule ID 13786 //
     /* 1864906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1864914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1864917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1864920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1864923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1864926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864952 */     // MIs[0] policy
     /* 1864952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864962 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1864965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1864969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864986 */     // GIR_Coverage, 13786,
     /* 1864986 */     GIR_EraseRootFromParent_Done,
     /* 1864987 */   // Label 25189: @1864987
     /* 1864987 */   GIM_Try, /*On fail goto*//*Label 25190*/ GIMT_Encode4(1865073), // Rule ID 13787 //
     /* 1864992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1865000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1865003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1865006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1865009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1865012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865038 */     // MIs[0] policy
     /* 1865038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865048 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1865051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1865055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865072 */     // GIR_Coverage, 13787,
     /* 1865072 */     GIR_EraseRootFromParent_Done,
     /* 1865073 */   // Label 25190: @1865073
     /* 1865073 */   GIM_Try, /*On fail goto*//*Label 25191*/ GIMT_Encode4(1865159), // Rule ID 13790 //
     /* 1865078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1865086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1865089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1865092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1865095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1865098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1865101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865124 */     // MIs[0] policy
     /* 1865124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865134 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1865137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1865141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865158 */     // GIR_Coverage, 13790,
     /* 1865158 */     GIR_EraseRootFromParent_Done,
     /* 1865159 */   // Label 25191: @1865159
     /* 1865159 */   GIM_Try, /*On fail goto*//*Label 25192*/ GIMT_Encode4(1865245), // Rule ID 13791 //
     /* 1865164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1865172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1865175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1865178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1865181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1865184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1865187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865210 */     // MIs[0] policy
     /* 1865210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865220 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11631:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1865223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1865227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865244 */     // GIR_Coverage, 13791,
     /* 1865244 */     GIR_EraseRootFromParent_Done,
     /* 1865245 */   // Label 25192: @1865245
     /* 1865245 */   GIM_Try, /*On fail goto*//*Label 25193*/ GIMT_Encode4(1865331), // Rule ID 13794 //
     /* 1865250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1865258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1865261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1865264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1865267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1865270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865296 */     // MIs[0] policy
     /* 1865296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1865309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1865313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865330 */     // GIR_Coverage, 13794,
     /* 1865330 */     GIR_EraseRootFromParent_Done,
     /* 1865331 */   // Label 25193: @1865331
     /* 1865331 */   GIM_Try, /*On fail goto*//*Label 25194*/ GIMT_Encode4(1865417), // Rule ID 13795 //
     /* 1865336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1865344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1865347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1865350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1865353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1865356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865382 */     // MIs[0] policy
     /* 1865382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1865395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1865399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865416 */     // GIR_Coverage, 13795,
     /* 1865416 */     GIR_EraseRootFromParent_Done,
     /* 1865417 */   // Label 25194: @1865417
     /* 1865417 */   GIM_Try, /*On fail goto*//*Label 25195*/ GIMT_Encode4(1865503), // Rule ID 13798 //
     /* 1865422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1865430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1865433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1865436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1865439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1865442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1865452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865468 */     // MIs[0] policy
     /* 1865468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865478 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1865481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1865485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865502 */     // GIR_Coverage, 13798,
     /* 1865502 */     GIR_EraseRootFromParent_Done,
     /* 1865503 */   // Label 25195: @1865503
     /* 1865503 */   GIM_Try, /*On fail goto*//*Label 25196*/ GIMT_Encode4(1865589), // Rule ID 13799 //
     /* 1865508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1865516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1865519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1865522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1865525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1865528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1865538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865554 */     // MIs[0] policy
     /* 1865554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865564 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1865567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1865571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865588 */     // GIR_Coverage, 13799,
     /* 1865588 */     GIR_EraseRootFromParent_Done,
     /* 1865589 */   // Label 25196: @1865589
     /* 1865589 */   GIM_Try, /*On fail goto*//*Label 25197*/ GIMT_Encode4(1865675), // Rule ID 13802 //
     /* 1865594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1865602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1865605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1865608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1865611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1865614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1865617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1865624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865640 */     // MIs[0] policy
     /* 1865640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865650 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1865653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1865657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865674 */     // GIR_Coverage, 13802,
     /* 1865674 */     GIR_EraseRootFromParent_Done,
     /* 1865675 */   // Label 25197: @1865675
     /* 1865675 */   GIM_Try, /*On fail goto*//*Label 25198*/ GIMT_Encode4(1865761), // Rule ID 13803 //
     /* 1865680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1865688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1865691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1865694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1865697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1865700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1865703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1865710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865726 */     // MIs[0] policy
     /* 1865726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865736 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1865739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1865743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865760 */     // GIR_Coverage, 13803,
     /* 1865760 */     GIR_EraseRootFromParent_Done,
     /* 1865761 */   // Label 25198: @1865761
     /* 1865761 */   GIM_Try, /*On fail goto*//*Label 25199*/ GIMT_Encode4(1865847), // Rule ID 13806 //
     /* 1865766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1865774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1865777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1865780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1865783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1865786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865812 */     // MIs[0] policy
     /* 1865812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865822 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1865825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1865829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865846 */     // GIR_Coverage, 13806,
     /* 1865846 */     GIR_EraseRootFromParent_Done,
     /* 1865847 */   // Label 25199: @1865847
     /* 1865847 */   GIM_Try, /*On fail goto*//*Label 25200*/ GIMT_Encode4(1865933), // Rule ID 13807 //
     /* 1865852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1865860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1865863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1865866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1865869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1865872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865898 */     // MIs[0] policy
     /* 1865898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865908 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1865911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1865915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865932 */     // GIR_Coverage, 13807,
     /* 1865932 */     GIR_EraseRootFromParent_Done,
     /* 1865933 */   // Label 25200: @1865933
     /* 1865933 */   GIM_Try, /*On fail goto*//*Label 25201*/ GIMT_Encode4(1866019), // Rule ID 13810 //
     /* 1865938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1865946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1865949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1865952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1865955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1865958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865984 */     // MIs[0] policy
     /* 1865984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865994 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1865997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1866001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866018 */     // GIR_Coverage, 13810,
     /* 1866018 */     GIR_EraseRootFromParent_Done,
     /* 1866019 */   // Label 25201: @1866019
     /* 1866019 */   GIM_Try, /*On fail goto*//*Label 25202*/ GIMT_Encode4(1866105), // Rule ID 13811 //
     /* 1866024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1866032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1866035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1866038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1866041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1866044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1866047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866070 */     // MIs[0] policy
     /* 1866070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866080 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11631:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1866083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1866087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866104 */     // GIR_Coverage, 13811,
     /* 1866104 */     GIR_EraseRootFromParent_Done,
     /* 1866105 */   // Label 25202: @1866105
     /* 1866105 */   GIM_Try, /*On fail goto*//*Label 25203*/ GIMT_Encode4(1866191), // Rule ID 13814 //
     /* 1866110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1866118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1866121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1866124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1866127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1866130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866156 */     // MIs[0] policy
     /* 1866156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1866169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1866173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866190 */     // GIR_Coverage, 13814,
     /* 1866190 */     GIR_EraseRootFromParent_Done,
     /* 1866191 */   // Label 25203: @1866191
     /* 1866191 */   GIM_Try, /*On fail goto*//*Label 25204*/ GIMT_Encode4(1866277), // Rule ID 13815 //
     /* 1866196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1866204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1866207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1866210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1866213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1866216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866242 */     // MIs[0] policy
     /* 1866242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1866255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1866259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866276 */     // GIR_Coverage, 13815,
     /* 1866276 */     GIR_EraseRootFromParent_Done,
     /* 1866277 */   // Label 25204: @1866277
     /* 1866277 */   GIM_Try, /*On fail goto*//*Label 25205*/ GIMT_Encode4(1866363), // Rule ID 13818 //
     /* 1866282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1866290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1866293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1866296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1866299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1866302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866328 */     // MIs[0] policy
     /* 1866328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866338 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1866341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1866345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866362 */     // GIR_Coverage, 13818,
     /* 1866362 */     GIR_EraseRootFromParent_Done,
     /* 1866363 */   // Label 25205: @1866363
     /* 1866363 */   GIM_Try, /*On fail goto*//*Label 25206*/ GIMT_Encode4(1866449), // Rule ID 13819 //
     /* 1866368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1866376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1866379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1866382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1866385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1866388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866414 */     // MIs[0] policy
     /* 1866414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866424 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1866427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1866431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866448 */     // GIR_Coverage, 13819,
     /* 1866448 */     GIR_EraseRootFromParent_Done,
     /* 1866449 */   // Label 25206: @1866449
     /* 1866449 */   GIM_Try, /*On fail goto*//*Label 25207*/ GIMT_Encode4(1866535), // Rule ID 13822 //
     /* 1866454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1866462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1866465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1866468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1866471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1866474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866500 */     // MIs[0] policy
     /* 1866500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866510 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1866513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1866517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866534 */     // GIR_Coverage, 13822,
     /* 1866534 */     GIR_EraseRootFromParent_Done,
     /* 1866535 */   // Label 25207: @1866535
     /* 1866535 */   GIM_Try, /*On fail goto*//*Label 25208*/ GIMT_Encode4(1866621), // Rule ID 13823 //
     /* 1866540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1866548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1866551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1866554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1866557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1866560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866586 */     // MIs[0] policy
     /* 1866586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1866599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1866603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866620 */     // GIR_Coverage, 13823,
     /* 1866620 */     GIR_EraseRootFromParent_Done,
     /* 1866621 */   // Label 25208: @1866621
     /* 1866621 */   GIM_Try, /*On fail goto*//*Label 25209*/ GIMT_Encode4(1866707), // Rule ID 13826 //
     /* 1866626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1866629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1866634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1866637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1866640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1866643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1866646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1866649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866672 */     // MIs[0] policy
     /* 1866672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866682 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1866685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1866689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866706 */     // GIR_Coverage, 13826,
     /* 1866706 */     GIR_EraseRootFromParent_Done,
     /* 1866707 */   // Label 25209: @1866707
     /* 1866707 */   GIM_Try, /*On fail goto*//*Label 25210*/ GIMT_Encode4(1866793), // Rule ID 13827 //
     /* 1866712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1866715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1866720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1866723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1866726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1866729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1866732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1866735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866758 */     // MIs[0] policy
     /* 1866758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866768 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11631:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1866771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1866775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866792 */     // GIR_Coverage, 13827,
     /* 1866792 */     GIR_EraseRootFromParent_Done,
     /* 1866793 */   // Label 25210: @1866793
     /* 1866793 */   GIM_Try, /*On fail goto*//*Label 25211*/ GIMT_Encode4(1866879), // Rule ID 13830 //
     /* 1866798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1866801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1866806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1866809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1866812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1866815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1866818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1866821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866844 */     // MIs[0] policy
     /* 1866844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866854 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1866857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1866861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866878 */     // GIR_Coverage, 13830,
     /* 1866878 */     GIR_EraseRootFromParent_Done,
     /* 1866879 */   // Label 25211: @1866879
     /* 1866879 */   GIM_Try, /*On fail goto*//*Label 25212*/ GIMT_Encode4(1866965), // Rule ID 13831 //
     /* 1866884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1866887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1866892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1866895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1866898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1866901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1866904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1866907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866930 */     // MIs[0] policy
     /* 1866930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866940 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11631:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1866943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1866947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866964 */     // GIR_Coverage, 13831,
     /* 1866964 */     GIR_EraseRootFromParent_Done,
     /* 1866965 */   // Label 25212: @1866965
     /* 1866965 */   GIM_Try, /*On fail goto*//*Label 25213*/ GIMT_Encode4(1867051), // Rule ID 13834 //
     /* 1866970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1866973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1866978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1866981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1866984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1866987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1866990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867016 */     // MIs[0] policy
     /* 1867016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867026 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1867029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1867033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867050 */     // GIR_Coverage, 13834,
     /* 1867050 */     GIR_EraseRootFromParent_Done,
     /* 1867051 */   // Label 25213: @1867051
     /* 1867051 */   GIM_Try, /*On fail goto*//*Label 25214*/ GIMT_Encode4(1867137), // Rule ID 13835 //
     /* 1867056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1867059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1867064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1867067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1867070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1867073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1867076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867102 */     // MIs[0] policy
     /* 1867102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867112 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11631:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1867115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1867119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867136 */     // GIR_Coverage, 13835,
     /* 1867136 */     GIR_EraseRootFromParent_Done,
     /* 1867137 */   // Label 25214: @1867137
     /* 1867137 */   GIM_Try, /*On fail goto*//*Label 25215*/ GIMT_Encode4(1867223), // Rule ID 13838 //
     /* 1867142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1867145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1867150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1867153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1867156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1867159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1867162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867188 */     // MIs[0] policy
     /* 1867188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867198 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1867201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1867205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867222 */     // GIR_Coverage, 13838,
     /* 1867222 */     GIR_EraseRootFromParent_Done,
     /* 1867223 */   // Label 25215: @1867223
     /* 1867223 */   GIM_Try, /*On fail goto*//*Label 25216*/ GIMT_Encode4(1867309), // Rule ID 13839 //
     /* 1867228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1867231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1867236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1867239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1867242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1867245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1867248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867274 */     // MIs[0] policy
     /* 1867274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867284 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11631:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1867287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1867291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867308 */     // GIR_Coverage, 13839,
     /* 1867308 */     GIR_EraseRootFromParent_Done,
     /* 1867309 */   // Label 25216: @1867309
     /* 1867309 */   GIM_Try, /*On fail goto*//*Label 25217*/ GIMT_Encode4(1867398), // Rule ID 14048 //
     /* 1867314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1867325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1867328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1867331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1867334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867360 */     // MIs[0] policy
     /* 1867360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867370 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1867373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867393 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867397 */     // GIR_Coverage, 14048,
     /* 1867397 */     GIR_EraseRootFromParent_Done,
     /* 1867398 */   // Label 25217: @1867398
     /* 1867398 */   GIM_Try, /*On fail goto*//*Label 25218*/ GIMT_Encode4(1867487), // Rule ID 14049 //
     /* 1867403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1867414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1867417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1867420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1867423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867449 */     // MIs[0] policy
     /* 1867449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867459 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1867462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867486 */     // GIR_Coverage, 14049,
     /* 1867486 */     GIR_EraseRootFromParent_Done,
     /* 1867487 */   // Label 25218: @1867487
     /* 1867487 */   GIM_Try, /*On fail goto*//*Label 25219*/ GIMT_Encode4(1867576), // Rule ID 14052 //
     /* 1867492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1867503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1867506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1867509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1867512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1867515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867538 */     // MIs[0] policy
     /* 1867538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867548 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1867551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867575 */     // GIR_Coverage, 14052,
     /* 1867575 */     GIR_EraseRootFromParent_Done,
     /* 1867576 */   // Label 25219: @1867576
     /* 1867576 */   GIM_Try, /*On fail goto*//*Label 25220*/ GIMT_Encode4(1867665), // Rule ID 14053 //
     /* 1867581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1867592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1867595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1867598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1867601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1867604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867627 */     // MIs[0] policy
     /* 1867627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867637 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1867640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867664 */     // GIR_Coverage, 14053,
     /* 1867664 */     GIR_EraseRootFromParent_Done,
     /* 1867665 */   // Label 25220: @1867665
     /* 1867665 */   GIM_Try, /*On fail goto*//*Label 25221*/ GIMT_Encode4(1867754), // Rule ID 14056 //
     /* 1867670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1867681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1867684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1867687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1867690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867716 */     // MIs[0] policy
     /* 1867716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867726 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1867729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867753 */     // GIR_Coverage, 14056,
     /* 1867753 */     GIR_EraseRootFromParent_Done,
     /* 1867754 */   // Label 25221: @1867754
     /* 1867754 */   GIM_Try, /*On fail goto*//*Label 25222*/ GIMT_Encode4(1867843), // Rule ID 14057 //
     /* 1867759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1867770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1867773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1867776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1867779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867805 */     // MIs[0] policy
     /* 1867805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867815 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1867818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867842 */     // GIR_Coverage, 14057,
     /* 1867842 */     GIR_EraseRootFromParent_Done,
     /* 1867843 */   // Label 25222: @1867843
     /* 1867843 */   GIM_Try, /*On fail goto*//*Label 25223*/ GIMT_Encode4(1867932), // Rule ID 14060 //
     /* 1867848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1867859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1867862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1867865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1867868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867894 */     // MIs[0] policy
     /* 1867894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867904 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1867907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867931 */     // GIR_Coverage, 14060,
     /* 1867931 */     GIR_EraseRootFromParent_Done,
     /* 1867932 */   // Label 25223: @1867932
     /* 1867932 */   GIM_Try, /*On fail goto*//*Label 25224*/ GIMT_Encode4(1868021), // Rule ID 14061 //
     /* 1867937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1867948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1867951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1867954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1867957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867983 */     // MIs[0] policy
     /* 1867983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867993 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1867996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868020 */     // GIR_Coverage, 14061,
     /* 1868020 */     GIR_EraseRootFromParent_Done,
     /* 1868021 */   // Label 25224: @1868021
     /* 1868021 */   GIM_Try, /*On fail goto*//*Label 25225*/ GIMT_Encode4(1868110), // Rule ID 14064 //
     /* 1868026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1868037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1868040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1868043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1868046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868072 */     // MIs[0] policy
     /* 1868072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868082 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1868085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868109 */     // GIR_Coverage, 14064,
     /* 1868109 */     GIR_EraseRootFromParent_Done,
     /* 1868110 */   // Label 25225: @1868110
     /* 1868110 */   GIM_Try, /*On fail goto*//*Label 25226*/ GIMT_Encode4(1868199), // Rule ID 14065 //
     /* 1868115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1868126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1868129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1868132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1868135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868161 */     // MIs[0] policy
     /* 1868161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1868174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868198 */     // GIR_Coverage, 14065,
     /* 1868198 */     GIR_EraseRootFromParent_Done,
     /* 1868199 */   // Label 25226: @1868199
     /* 1868199 */   GIM_Try, /*On fail goto*//*Label 25227*/ GIMT_Encode4(1868288), // Rule ID 14068 //
     /* 1868204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1868215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1868218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1868221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1868224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868250 */     // MIs[0] policy
     /* 1868250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868260 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1868263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868287 */     // GIR_Coverage, 14068,
     /* 1868287 */     GIR_EraseRootFromParent_Done,
     /* 1868288 */   // Label 25227: @1868288
     /* 1868288 */   GIM_Try, /*On fail goto*//*Label 25228*/ GIMT_Encode4(1868377), // Rule ID 14069 //
     /* 1868293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1868304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1868307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1868310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1868313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868339 */     // MIs[0] policy
     /* 1868339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868349 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1868352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868376 */     // GIR_Coverage, 14069,
     /* 1868376 */     GIR_EraseRootFromParent_Done,
     /* 1868377 */   // Label 25228: @1868377
     /* 1868377 */   GIM_Try, /*On fail goto*//*Label 25229*/ GIMT_Encode4(1868466), // Rule ID 14072 //
     /* 1868382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1868393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1868396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1868399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1868402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868428 */     // MIs[0] policy
     /* 1868428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868438 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1868441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868465 */     // GIR_Coverage, 14072,
     /* 1868465 */     GIR_EraseRootFromParent_Done,
     /* 1868466 */   // Label 25229: @1868466
     /* 1868466 */   GIM_Try, /*On fail goto*//*Label 25230*/ GIMT_Encode4(1868555), // Rule ID 14073 //
     /* 1868471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1868482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1868485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1868488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1868491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868517 */     // MIs[0] policy
     /* 1868517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868527 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1868530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868554 */     // GIR_Coverage, 14073,
     /* 1868554 */     GIR_EraseRootFromParent_Done,
     /* 1868555 */   // Label 25230: @1868555
     /* 1868555 */   GIM_Try, /*On fail goto*//*Label 25231*/ GIMT_Encode4(1868644), // Rule ID 14076 //
     /* 1868560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1868571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1868574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1868577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1868580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868606 */     // MIs[0] policy
     /* 1868606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868616 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1868619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868643 */     // GIR_Coverage, 14076,
     /* 1868643 */     GIR_EraseRootFromParent_Done,
     /* 1868644 */   // Label 25231: @1868644
     /* 1868644 */   GIM_Try, /*On fail goto*//*Label 25232*/ GIMT_Encode4(1868733), // Rule ID 14077 //
     /* 1868649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1868660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1868663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1868666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1868669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868695 */     // MIs[0] policy
     /* 1868695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868705 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1868708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868732 */     // GIR_Coverage, 14077,
     /* 1868732 */     GIR_EraseRootFromParent_Done,
     /* 1868733 */   // Label 25232: @1868733
     /* 1868733 */   GIM_Try, /*On fail goto*//*Label 25233*/ GIMT_Encode4(1868822), // Rule ID 14080 //
     /* 1868738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1868749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1868752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1868755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1868758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868784 */     // MIs[0] policy
     /* 1868784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868794 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1868797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868821 */     // GIR_Coverage, 14080,
     /* 1868821 */     GIR_EraseRootFromParent_Done,
     /* 1868822 */   // Label 25233: @1868822
     /* 1868822 */   GIM_Try, /*On fail goto*//*Label 25234*/ GIMT_Encode4(1868911), // Rule ID 14081 //
     /* 1868827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1868838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1868841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1868844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1868847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868873 */     // MIs[0] policy
     /* 1868873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868883 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1868886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868910 */     // GIR_Coverage, 14081,
     /* 1868910 */     GIR_EraseRootFromParent_Done,
     /* 1868911 */   // Label 25234: @1868911
     /* 1868911 */   GIM_Try, /*On fail goto*//*Label 25235*/ GIMT_Encode4(1869000), // Rule ID 14084 //
     /* 1868916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1868919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1868927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1868930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1868933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1868936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868962 */     // MIs[0] policy
     /* 1868962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868972 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1868975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1868993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868999 */     // GIR_Coverage, 14084,
     /* 1868999 */     GIR_EraseRootFromParent_Done,
     /* 1869000 */   // Label 25235: @1869000
     /* 1869000 */   GIM_Try, /*On fail goto*//*Label 25236*/ GIMT_Encode4(1869089), // Rule ID 14085 //
     /* 1869005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1869008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1869016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1869019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1869022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1869025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869051 */     // MIs[0] policy
     /* 1869051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869061 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1869064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869088 */     // GIR_Coverage, 14085,
     /* 1869088 */     GIR_EraseRootFromParent_Done,
     /* 1869089 */   // Label 25236: @1869089
     /* 1869089 */   GIM_Try, /*On fail goto*//*Label 25237*/ GIMT_Encode4(1869178), // Rule ID 14088 //
     /* 1869094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1869105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1869108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1869111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1869114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869140 */     // MIs[0] policy
     /* 1869140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869150 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1869153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869177 */     // GIR_Coverage, 14088,
     /* 1869177 */     GIR_EraseRootFromParent_Done,
     /* 1869178 */   // Label 25237: @1869178
     /* 1869178 */   GIM_Try, /*On fail goto*//*Label 25238*/ GIMT_Encode4(1869267), // Rule ID 14089 //
     /* 1869183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1869194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1869197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1869200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1869203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869229 */     // MIs[0] policy
     /* 1869229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869239 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1869242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869266 */     // GIR_Coverage, 14089,
     /* 1869266 */     GIR_EraseRootFromParent_Done,
     /* 1869267 */   // Label 25238: @1869267
     /* 1869267 */   GIM_Try, /*On fail goto*//*Label 25239*/ GIMT_Encode4(1869356), // Rule ID 14092 //
     /* 1869272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1869283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1869286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1869289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1869292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1869295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869318 */     // MIs[0] policy
     /* 1869318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869328 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1869331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869355 */     // GIR_Coverage, 14092,
     /* 1869355 */     GIR_EraseRootFromParent_Done,
     /* 1869356 */   // Label 25239: @1869356
     /* 1869356 */   GIM_Try, /*On fail goto*//*Label 25240*/ GIMT_Encode4(1869445), // Rule ID 14093 //
     /* 1869361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1869372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1869375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1869378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1869381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1869384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869407 */     // MIs[0] policy
     /* 1869407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869417 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1869420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869444 */     // GIR_Coverage, 14093,
     /* 1869444 */     GIR_EraseRootFromParent_Done,
     /* 1869445 */   // Label 25240: @1869445
     /* 1869445 */   GIM_Try, /*On fail goto*//*Label 25241*/ GIMT_Encode4(1869534), // Rule ID 14096 //
     /* 1869450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1869461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1869464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1869467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1869470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1869473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1869480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869496 */     // MIs[0] policy
     /* 1869496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869506 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1869509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869533 */     // GIR_Coverage, 14096,
     /* 1869533 */     GIR_EraseRootFromParent_Done,
     /* 1869534 */   // Label 25241: @1869534
     /* 1869534 */   GIM_Try, /*On fail goto*//*Label 25242*/ GIMT_Encode4(1869623), // Rule ID 14097 //
     /* 1869539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1869550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1869553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1869556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1869559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1869562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1869569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869585 */     // MIs[0] policy
     /* 1869585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869595 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1869598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869622 */     // GIR_Coverage, 14097,
     /* 1869622 */     GIR_EraseRootFromParent_Done,
     /* 1869623 */   // Label 25242: @1869623
     /* 1869623 */   GIM_Try, /*On fail goto*//*Label 25243*/ GIMT_Encode4(1869712), // Rule ID 14100 //
     /* 1869628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1869639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1869642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1869645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1869648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1869651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869674 */     // MIs[0] policy
     /* 1869674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1869687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869711 */     // GIR_Coverage, 14100,
     /* 1869711 */     GIR_EraseRootFromParent_Done,
     /* 1869712 */   // Label 25243: @1869712
     /* 1869712 */   GIM_Try, /*On fail goto*//*Label 25244*/ GIMT_Encode4(1869801), // Rule ID 14101 //
     /* 1869717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1869728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1869731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1869734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1869737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1869740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869763 */     // MIs[0] policy
     /* 1869763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869773 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1869776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869800 */     // GIR_Coverage, 14101,
     /* 1869800 */     GIR_EraseRootFromParent_Done,
     /* 1869801 */   // Label 25244: @1869801
     /* 1869801 */   GIM_Try, /*On fail goto*//*Label 25245*/ GIMT_Encode4(1869890), // Rule ID 14104 //
     /* 1869806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1869817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1869820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1869823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1869826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869852 */     // MIs[0] policy
     /* 1869852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869862 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1869865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869889 */     // GIR_Coverage, 14104,
     /* 1869889 */     GIR_EraseRootFromParent_Done,
     /* 1869890 */   // Label 25245: @1869890
     /* 1869890 */   GIM_Try, /*On fail goto*//*Label 25246*/ GIMT_Encode4(1869979), // Rule ID 14105 //
     /* 1869895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1869906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1869909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1869912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1869915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869941 */     // MIs[0] policy
     /* 1869941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869951 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1869954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869978 */     // GIR_Coverage, 14105,
     /* 1869978 */     GIR_EraseRootFromParent_Done,
     /* 1869979 */   // Label 25246: @1869979
     /* 1869979 */   GIM_Try, /*On fail goto*//*Label 25247*/ GIMT_Encode4(1870068), // Rule ID 14108 //
     /* 1869984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1869995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1869998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1870001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1870004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1870007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870030 */     // MIs[0] policy
     /* 1870030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870040 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1870043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870067 */     // GIR_Coverage, 14108,
     /* 1870067 */     GIR_EraseRootFromParent_Done,
     /* 1870068 */   // Label 25247: @1870068
     /* 1870068 */   GIM_Try, /*On fail goto*//*Label 25248*/ GIMT_Encode4(1870157), // Rule ID 14109 //
     /* 1870073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1870084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1870087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1870090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1870093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1870096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870119 */     // MIs[0] policy
     /* 1870119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870129 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1870132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870156 */     // GIR_Coverage, 14109,
     /* 1870156 */     GIR_EraseRootFromParent_Done,
     /* 1870157 */   // Label 25248: @1870157
     /* 1870157 */   GIM_Try, /*On fail goto*//*Label 25249*/ GIMT_Encode4(1870246), // Rule ID 14112 //
     /* 1870162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1870173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1870176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1870179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1870182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870208 */     // MIs[0] policy
     /* 1870208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1870221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870245 */     // GIR_Coverage, 14112,
     /* 1870245 */     GIR_EraseRootFromParent_Done,
     /* 1870246 */   // Label 25249: @1870246
     /* 1870246 */   GIM_Try, /*On fail goto*//*Label 25250*/ GIMT_Encode4(1870335), // Rule ID 14113 //
     /* 1870251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1870262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1870265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1870268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1870271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870297 */     // MIs[0] policy
     /* 1870297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870307 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1870310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870334 */     // GIR_Coverage, 14113,
     /* 1870334 */     GIR_EraseRootFromParent_Done,
     /* 1870335 */   // Label 25250: @1870335
     /* 1870335 */   GIM_Try, /*On fail goto*//*Label 25251*/ GIMT_Encode4(1870424), // Rule ID 14116 //
     /* 1870340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1870351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1870354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1870357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1870360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870386 */     // MIs[0] policy
     /* 1870386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870396 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1870399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870423 */     // GIR_Coverage, 14116,
     /* 1870423 */     GIR_EraseRootFromParent_Done,
     /* 1870424 */   // Label 25251: @1870424
     /* 1870424 */   GIM_Try, /*On fail goto*//*Label 25252*/ GIMT_Encode4(1870513), // Rule ID 14117 //
     /* 1870429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1870440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1870443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1870446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1870449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870475 */     // MIs[0] policy
     /* 1870475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870485 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1870488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870512 */     // GIR_Coverage, 14117,
     /* 1870512 */     GIR_EraseRootFromParent_Done,
     /* 1870513 */   // Label 25252: @1870513
     /* 1870513 */   GIM_Try, /*On fail goto*//*Label 25253*/ GIMT_Encode4(1870602), // Rule ID 14120 //
     /* 1870518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1870529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1870532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1870535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1870538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870564 */     // MIs[0] policy
     /* 1870564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870574 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1870577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870601 */     // GIR_Coverage, 14120,
     /* 1870601 */     GIR_EraseRootFromParent_Done,
     /* 1870602 */   // Label 25253: @1870602
     /* 1870602 */   GIM_Try, /*On fail goto*//*Label 25254*/ GIMT_Encode4(1870691), // Rule ID 14121 //
     /* 1870607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1870618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1870621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1870624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1870627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870653 */     // MIs[0] policy
     /* 1870653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870663 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1870666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870690 */     // GIR_Coverage, 14121,
     /* 1870690 */     GIR_EraseRootFromParent_Done,
     /* 1870691 */   // Label 25254: @1870691
     /* 1870691 */   GIM_Try, /*On fail goto*//*Label 25255*/ GIMT_Encode4(1870780), // Rule ID 14124 //
     /* 1870696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1870699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1870707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1870710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1870713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1870716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1870719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870742 */     // MIs[0] policy
     /* 1870742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1870755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870779 */     // GIR_Coverage, 14124,
     /* 1870779 */     GIR_EraseRootFromParent_Done,
     /* 1870780 */   // Label 25255: @1870780
     /* 1870780 */   GIM_Try, /*On fail goto*//*Label 25256*/ GIMT_Encode4(1870869), // Rule ID 14125 //
     /* 1870785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1870788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1870796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1870799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1870802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1870805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1870808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870831 */     // MIs[0] policy
     /* 1870831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870841 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1870844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870868 */     // GIR_Coverage, 14125,
     /* 1870868 */     GIR_EraseRootFromParent_Done,
     /* 1870869 */   // Label 25256: @1870869
     /* 1870869 */   GIM_Try, /*On fail goto*//*Label 25257*/ GIMT_Encode4(1870958), // Rule ID 14128 //
     /* 1870874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1870877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1870885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1870888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1870891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1870894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870920 */     // MIs[0] policy
     /* 1870920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870930 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1870933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870957 */     // GIR_Coverage, 14128,
     /* 1870957 */     GIR_EraseRootFromParent_Done,
     /* 1870958 */   // Label 25257: @1870958
     /* 1870958 */   GIM_Try, /*On fail goto*//*Label 25258*/ GIMT_Encode4(1871047), // Rule ID 14129 //
     /* 1870963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1870966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1870974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1870977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1870980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1870983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871009 */     // MIs[0] policy
     /* 1871009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871019 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1871022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871046 */     // GIR_Coverage, 14129,
     /* 1871046 */     GIR_EraseRootFromParent_Done,
     /* 1871047 */   // Label 25258: @1871047
     /* 1871047 */   GIM_Try, /*On fail goto*//*Label 25259*/ GIMT_Encode4(1871136), // Rule ID 14132 //
     /* 1871052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1871055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1871063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1871066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1871069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1871072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871098 */     // MIs[0] policy
     /* 1871098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871108 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1871111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871131 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871135 */     // GIR_Coverage, 14132,
     /* 1871135 */     GIR_EraseRootFromParent_Done,
     /* 1871136 */   // Label 25259: @1871136
     /* 1871136 */   GIM_Try, /*On fail goto*//*Label 25260*/ GIMT_Encode4(1871225), // Rule ID 14133 //
     /* 1871141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1871144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1871152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1871155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1871158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1871161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871187 */     // MIs[0] policy
     /* 1871187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871197 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1871200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871224 */     // GIR_Coverage, 14133,
     /* 1871224 */     GIR_EraseRootFromParent_Done,
     /* 1871225 */   // Label 25260: @1871225
     /* 1871225 */   GIM_Try, /*On fail goto*//*Label 25261*/ GIMT_Encode4(1871314), // Rule ID 14136 //
     /* 1871230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1871241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1871244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1871247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871276 */     // MIs[0] policy
     /* 1871276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871286 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1871289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871313 */     // GIR_Coverage, 14136,
     /* 1871313 */     GIR_EraseRootFromParent_Done,
     /* 1871314 */   // Label 25261: @1871314
     /* 1871314 */   GIM_Try, /*On fail goto*//*Label 25262*/ GIMT_Encode4(1871403), // Rule ID 14137 //
     /* 1871319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1871330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1871333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1871336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871365 */     // MIs[0] policy
     /* 1871365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871375 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1871378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871402 */     // GIR_Coverage, 14137,
     /* 1871402 */     GIR_EraseRootFromParent_Done,
     /* 1871403 */   // Label 25262: @1871403
     /* 1871403 */   GIM_Try, /*On fail goto*//*Label 25263*/ GIMT_Encode4(1871492), // Rule ID 14140 //
     /* 1871408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1871419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1871422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1871425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871454 */     // MIs[0] policy
     /* 1871454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871464 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1871467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871491 */     // GIR_Coverage, 14140,
     /* 1871491 */     GIR_EraseRootFromParent_Done,
     /* 1871492 */   // Label 25263: @1871492
     /* 1871492 */   GIM_Try, /*On fail goto*//*Label 25264*/ GIMT_Encode4(1871581), // Rule ID 14141 //
     /* 1871497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1871508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1871511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1871514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871543 */     // MIs[0] policy
     /* 1871543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871553 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1871556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871580 */     // GIR_Coverage, 14141,
     /* 1871580 */     GIR_EraseRootFromParent_Done,
     /* 1871581 */   // Label 25264: @1871581
     /* 1871581 */   GIM_Try, /*On fail goto*//*Label 25265*/ GIMT_Encode4(1871670), // Rule ID 14144 //
     /* 1871586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1871597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1871600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1871603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871632 */     // MIs[0] policy
     /* 1871632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871642 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1871645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871669 */     // GIR_Coverage, 14144,
     /* 1871669 */     GIR_EraseRootFromParent_Done,
     /* 1871670 */   // Label 25265: @1871670
     /* 1871670 */   GIM_Try, /*On fail goto*//*Label 25266*/ GIMT_Encode4(1871759), // Rule ID 14145 //
     /* 1871675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1871686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1871689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1871692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871721 */     // MIs[0] policy
     /* 1871721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871731 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1871734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871758 */     // GIR_Coverage, 14145,
     /* 1871758 */     GIR_EraseRootFromParent_Done,
     /* 1871759 */   // Label 25266: @1871759
     /* 1871759 */   GIM_Try, /*On fail goto*//*Label 25267*/ GIMT_Encode4(1871848), // Rule ID 14148 //
     /* 1871764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1871775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1871778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1871781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871810 */     // MIs[0] policy
     /* 1871810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871820 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1871823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871847 */     // GIR_Coverage, 14148,
     /* 1871847 */     GIR_EraseRootFromParent_Done,
     /* 1871848 */   // Label 25267: @1871848
     /* 1871848 */   GIM_Try, /*On fail goto*//*Label 25268*/ GIMT_Encode4(1871937), // Rule ID 14149 //
     /* 1871853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1871864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1871867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1871870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871899 */     // MIs[0] policy
     /* 1871899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871909 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1871912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871936 */     // GIR_Coverage, 14149,
     /* 1871936 */     GIR_EraseRootFromParent_Done,
     /* 1871937 */   // Label 25268: @1871937
     /* 1871937 */   GIM_Try, /*On fail goto*//*Label 25269*/ GIMT_Encode4(1872026), // Rule ID 14152 //
     /* 1871942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1871953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1871956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1871959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871988 */     // MIs[0] policy
     /* 1871988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871998 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1872001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872025 */     // GIR_Coverage, 14152,
     /* 1872025 */     GIR_EraseRootFromParent_Done,
     /* 1872026 */   // Label 25269: @1872026
     /* 1872026 */   GIM_Try, /*On fail goto*//*Label 25270*/ GIMT_Encode4(1872115), // Rule ID 14153 //
     /* 1872031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1872039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1872042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1872045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1872048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1872051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872077 */     // MIs[0] policy
     /* 1872077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872087 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1872090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872114 */     // GIR_Coverage, 14153,
     /* 1872114 */     GIR_EraseRootFromParent_Done,
     /* 1872115 */   // Label 25270: @1872115
     /* 1872115 */   GIM_Try, /*On fail goto*//*Label 25271*/ GIMT_Encode4(1872204), // Rule ID 14156 //
     /* 1872120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1872128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1872131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1872134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1872137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1872140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872166 */     // MIs[0] policy
     /* 1872166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1872179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872203 */     // GIR_Coverage, 14156,
     /* 1872203 */     GIR_EraseRootFromParent_Done,
     /* 1872204 */   // Label 25271: @1872204
     /* 1872204 */   GIM_Try, /*On fail goto*//*Label 25272*/ GIMT_Encode4(1872293), // Rule ID 14157 //
     /* 1872209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1872217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1872220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1872223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1872226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1872229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872255 */     // MIs[0] policy
     /* 1872255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872265 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1872268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872292 */     // GIR_Coverage, 14157,
     /* 1872292 */     GIR_EraseRootFromParent_Done,
     /* 1872293 */   // Label 25272: @1872293
     /* 1872293 */   GIM_Try, /*On fail goto*//*Label 25273*/ GIMT_Encode4(1872382), // Rule ID 14160 //
     /* 1872298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1872306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1872309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1872312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1872315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1872318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872344 */     // MIs[0] policy
     /* 1872344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872354 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1872357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872377 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872381 */     // GIR_Coverage, 14160,
     /* 1872381 */     GIR_EraseRootFromParent_Done,
     /* 1872382 */   // Label 25273: @1872382
     /* 1872382 */   GIM_Try, /*On fail goto*//*Label 25274*/ GIMT_Encode4(1872471), // Rule ID 14161 //
     /* 1872387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1872395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1872398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1872401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1872404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1872407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872433 */     // MIs[0] policy
     /* 1872433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872443 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1872446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872470 */     // GIR_Coverage, 14161,
     /* 1872470 */     GIR_EraseRootFromParent_Done,
     /* 1872471 */   // Label 25274: @1872471
     /* 1872471 */   GIM_Try, /*On fail goto*//*Label 25275*/ GIMT_Encode4(1872560), // Rule ID 14164 //
     /* 1872476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1872484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1872487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1872490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1872493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1872496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872522 */     // MIs[0] policy
     /* 1872522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1872535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872559 */     // GIR_Coverage, 14164,
     /* 1872559 */     GIR_EraseRootFromParent_Done,
     /* 1872560 */   // Label 25275: @1872560
     /* 1872560 */   GIM_Try, /*On fail goto*//*Label 25276*/ GIMT_Encode4(1872649), // Rule ID 14165 //
     /* 1872565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1872573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1872576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1872579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1872582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1872585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872611 */     // MIs[0] policy
     /* 1872611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1872624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872648 */     // GIR_Coverage, 14165,
     /* 1872648 */     GIR_EraseRootFromParent_Done,
     /* 1872649 */   // Label 25276: @1872649
     /* 1872649 */   GIM_Try, /*On fail goto*//*Label 25277*/ GIMT_Encode4(1872738), // Rule ID 14168 //
     /* 1872654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1872662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1872665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1872668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1872671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1872674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872700 */     // MIs[0] policy
     /* 1872700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872710 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1872713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872733 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872737 */     // GIR_Coverage, 14168,
     /* 1872737 */     GIR_EraseRootFromParent_Done,
     /* 1872738 */   // Label 25277: @1872738
     /* 1872738 */   GIM_Try, /*On fail goto*//*Label 25278*/ GIMT_Encode4(1872827), // Rule ID 14169 //
     /* 1872743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1872751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1872754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1872757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1872760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1872763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872789 */     // MIs[0] policy
     /* 1872789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872799 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1872802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872826 */     // GIR_Coverage, 14169,
     /* 1872826 */     GIR_EraseRootFromParent_Done,
     /* 1872827 */   // Label 25278: @1872827
     /* 1872827 */   GIM_Try, /*On fail goto*//*Label 25279*/ GIMT_Encode4(1872916), // Rule ID 14172 //
     /* 1872832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1872835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1872840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1872843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1872846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1872849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1872852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872878 */     // MIs[0] policy
     /* 1872878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872888 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1872891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872915 */     // GIR_Coverage, 14172,
     /* 1872915 */     GIR_EraseRootFromParent_Done,
     /* 1872916 */   // Label 25279: @1872916
     /* 1872916 */   GIM_Try, /*On fail goto*//*Label 25280*/ GIMT_Encode4(1873005), // Rule ID 14173 //
     /* 1872921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1872924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1872929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1872932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1872935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1872938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1872941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872967 */     // MIs[0] policy
     /* 1872967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872977 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1872980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873004 */     // GIR_Coverage, 14173,
     /* 1873004 */     GIR_EraseRootFromParent_Done,
     /* 1873005 */   // Label 25280: @1873005
     /* 1873005 */   GIM_Try, /*On fail goto*//*Label 25281*/ GIMT_Encode4(1873094), // Rule ID 14176 //
     /* 1873010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1873018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1873021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1873024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1873027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1873030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873056 */     // MIs[0] policy
     /* 1873056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873066 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1873069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873093 */     // GIR_Coverage, 14176,
     /* 1873093 */     GIR_EraseRootFromParent_Done,
     /* 1873094 */   // Label 25281: @1873094
     /* 1873094 */   GIM_Try, /*On fail goto*//*Label 25282*/ GIMT_Encode4(1873183), // Rule ID 14177 //
     /* 1873099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1873107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1873110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1873113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1873116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1873119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873145 */     // MIs[0] policy
     /* 1873145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873155 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1873158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873182 */     // GIR_Coverage, 14177,
     /* 1873182 */     GIR_EraseRootFromParent_Done,
     /* 1873183 */   // Label 25282: @1873183
     /* 1873183 */   GIM_Try, /*On fail goto*//*Label 25283*/ GIMT_Encode4(1873272), // Rule ID 14180 //
     /* 1873188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1873196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1873199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1873202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1873205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1873208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1873211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873234 */     // MIs[0] policy
     /* 1873234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873244 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1873247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873271 */     // GIR_Coverage, 14180,
     /* 1873271 */     GIR_EraseRootFromParent_Done,
     /* 1873272 */   // Label 25283: @1873272
     /* 1873272 */   GIM_Try, /*On fail goto*//*Label 25284*/ GIMT_Encode4(1873361), // Rule ID 14181 //
     /* 1873277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1873285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1873288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1873291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1873294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1873297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1873300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873323 */     // MIs[0] policy
     /* 1873323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873333 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1873336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873360 */     // GIR_Coverage, 14181,
     /* 1873360 */     GIR_EraseRootFromParent_Done,
     /* 1873361 */   // Label 25284: @1873361
     /* 1873361 */   GIM_Try, /*On fail goto*//*Label 25285*/ GIMT_Encode4(1873450), // Rule ID 14184 //
     /* 1873366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1873374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1873377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1873380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1873383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1873386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1873389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1873396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873412 */     // MIs[0] policy
     /* 1873412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873422 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1873425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873449 */     // GIR_Coverage, 14184,
     /* 1873449 */     GIR_EraseRootFromParent_Done,
     /* 1873450 */   // Label 25285: @1873450
     /* 1873450 */   GIM_Try, /*On fail goto*//*Label 25286*/ GIMT_Encode4(1873539), // Rule ID 14185 //
     /* 1873455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1873463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1873466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1873469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1873472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1873475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1873478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1873485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873501 */     // MIs[0] policy
     /* 1873501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873511 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1873514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873538 */     // GIR_Coverage, 14185,
     /* 1873538 */     GIR_EraseRootFromParent_Done,
     /* 1873539 */   // Label 25286: @1873539
     /* 1873539 */   GIM_Try, /*On fail goto*//*Label 25287*/ GIMT_Encode4(1873628), // Rule ID 14188 //
     /* 1873544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1873552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1873555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1873558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1873561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1873564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1873567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873590 */     // MIs[0] policy
     /* 1873590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1873603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873627 */     // GIR_Coverage, 14188,
     /* 1873627 */     GIR_EraseRootFromParent_Done,
     /* 1873628 */   // Label 25287: @1873628
     /* 1873628 */   GIM_Try, /*On fail goto*//*Label 25288*/ GIMT_Encode4(1873717), // Rule ID 14189 //
     /* 1873633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1873641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1873644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1873647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1873650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1873653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1873656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873679 */     // MIs[0] policy
     /* 1873679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873689 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1873692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873716 */     // GIR_Coverage, 14189,
     /* 1873716 */     GIR_EraseRootFromParent_Done,
     /* 1873717 */   // Label 25288: @1873717
     /* 1873717 */   GIM_Try, /*On fail goto*//*Label 25289*/ GIMT_Encode4(1873806), // Rule ID 14192 //
     /* 1873722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1873730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1873733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1873736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1873739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1873742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873768 */     // MIs[0] policy
     /* 1873768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873778 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1873781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873805 */     // GIR_Coverage, 14192,
     /* 1873805 */     GIR_EraseRootFromParent_Done,
     /* 1873806 */   // Label 25289: @1873806
     /* 1873806 */   GIM_Try, /*On fail goto*//*Label 25290*/ GIMT_Encode4(1873895), // Rule ID 14193 //
     /* 1873811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1873819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1873822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1873825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1873828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1873831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873857 */     // MIs[0] policy
     /* 1873857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873867 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1873870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873894 */     // GIR_Coverage, 14193,
     /* 1873894 */     GIR_EraseRootFromParent_Done,
     /* 1873895 */   // Label 25290: @1873895
     /* 1873895 */   GIM_Try, /*On fail goto*//*Label 25291*/ GIMT_Encode4(1873984), // Rule ID 14196 //
     /* 1873900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1873908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1873911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1873914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1873917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1873920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1873923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1873930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873946 */     // MIs[0] policy
     /* 1873946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873956 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1873959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873983 */     // GIR_Coverage, 14196,
     /* 1873983 */     GIR_EraseRootFromParent_Done,
     /* 1873984 */   // Label 25291: @1873984
     /* 1873984 */   GIM_Try, /*On fail goto*//*Label 25292*/ GIMT_Encode4(1874073), // Rule ID 14197 //
     /* 1873989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1873997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1874000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1874003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1874006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1874009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1874012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874035 */     // MIs[0] policy
     /* 1874035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874045 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1874048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874068 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874072 */     // GIR_Coverage, 14197,
     /* 1874072 */     GIR_EraseRootFromParent_Done,
     /* 1874073 */   // Label 25292: @1874073
     /* 1874073 */   GIM_Try, /*On fail goto*//*Label 25293*/ GIMT_Encode4(1874162), // Rule ID 14200 //
     /* 1874078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1874086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1874089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1874092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1874095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1874098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874124 */     // MIs[0] policy
     /* 1874124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1874137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874161 */     // GIR_Coverage, 14200,
     /* 1874161 */     GIR_EraseRootFromParent_Done,
     /* 1874162 */   // Label 25293: @1874162
     /* 1874162 */   GIM_Try, /*On fail goto*//*Label 25294*/ GIMT_Encode4(1874251), // Rule ID 14201 //
     /* 1874167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1874175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1874178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1874181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1874184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1874187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874213 */     // MIs[0] policy
     /* 1874213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874223 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1874226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874250 */     // GIR_Coverage, 14201,
     /* 1874250 */     GIR_EraseRootFromParent_Done,
     /* 1874251 */   // Label 25294: @1874251
     /* 1874251 */   GIM_Try, /*On fail goto*//*Label 25295*/ GIMT_Encode4(1874340), // Rule ID 14204 //
     /* 1874256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1874264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1874267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1874270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1874273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1874276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874302 */     // MIs[0] policy
     /* 1874302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874312 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1874315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874339 */     // GIR_Coverage, 14204,
     /* 1874339 */     GIR_EraseRootFromParent_Done,
     /* 1874340 */   // Label 25295: @1874340
     /* 1874340 */   GIM_Try, /*On fail goto*//*Label 25296*/ GIMT_Encode4(1874429), // Rule ID 14205 //
     /* 1874345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1874353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1874356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1874359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1874362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1874365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874391 */     // MIs[0] policy
     /* 1874391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874401 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1874404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874428 */     // GIR_Coverage, 14205,
     /* 1874428 */     GIR_EraseRootFromParent_Done,
     /* 1874429 */   // Label 25296: @1874429
     /* 1874429 */   GIM_Try, /*On fail goto*//*Label 25297*/ GIMT_Encode4(1874518), // Rule ID 14208 //
     /* 1874434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1874442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1874445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1874448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1874451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1874454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874480 */     // MIs[0] policy
     /* 1874480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874490 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1874493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874517 */     // GIR_Coverage, 14208,
     /* 1874517 */     GIR_EraseRootFromParent_Done,
     /* 1874518 */   // Label 25297: @1874518
     /* 1874518 */   GIM_Try, /*On fail goto*//*Label 25298*/ GIMT_Encode4(1874607), // Rule ID 14209 //
     /* 1874523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1874531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1874534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1874537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1874540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1874543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874569 */     // MIs[0] policy
     /* 1874569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874579 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1874582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874606 */     // GIR_Coverage, 14209,
     /* 1874606 */     GIR_EraseRootFromParent_Done,
     /* 1874607 */   // Label 25298: @1874607
     /* 1874607 */   GIM_Try, /*On fail goto*//*Label 25299*/ GIMT_Encode4(1874696), // Rule ID 14212 //
     /* 1874612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1874615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1874620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1874623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1874626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1874629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1874632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1874635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874658 */     // MIs[0] policy
     /* 1874658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1874671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874695 */     // GIR_Coverage, 14212,
     /* 1874695 */     GIR_EraseRootFromParent_Done,
     /* 1874696 */   // Label 25299: @1874696
     /* 1874696 */   GIM_Try, /*On fail goto*//*Label 25300*/ GIMT_Encode4(1874785), // Rule ID 14213 //
     /* 1874701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1874704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1874709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1874712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1874715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1874718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1874721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1874724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874747 */     // MIs[0] policy
     /* 1874747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1874760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874784 */     // GIR_Coverage, 14213,
     /* 1874784 */     GIR_EraseRootFromParent_Done,
     /* 1874785 */   // Label 25300: @1874785
     /* 1874785 */   GIM_Try, /*On fail goto*//*Label 25301*/ GIMT_Encode4(1874874), // Rule ID 14216 //
     /* 1874790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1874793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1874798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1874801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1874804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1874807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1874810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874836 */     // MIs[0] policy
     /* 1874836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874846 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1874849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874873 */     // GIR_Coverage, 14216,
     /* 1874873 */     GIR_EraseRootFromParent_Done,
     /* 1874874 */   // Label 25301: @1874874
     /* 1874874 */   GIM_Try, /*On fail goto*//*Label 25302*/ GIMT_Encode4(1874963), // Rule ID 14217 //
     /* 1874879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1874882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1874887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1874890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1874893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1874896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1874899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874925 */     // MIs[0] policy
     /* 1874925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874935 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1874938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874962 */     // GIR_Coverage, 14217,
     /* 1874962 */     GIR_EraseRootFromParent_Done,
     /* 1874963 */   // Label 25302: @1874963
     /* 1874963 */   GIM_Try, /*On fail goto*//*Label 25303*/ GIMT_Encode4(1875052), // Rule ID 14220 //
     /* 1874968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1874971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1874976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1874979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1874982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1874985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1874988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875014 */     // MIs[0] policy
     /* 1875014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875024 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1875027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875051 */     // GIR_Coverage, 14220,
     /* 1875051 */     GIR_EraseRootFromParent_Done,
     /* 1875052 */   // Label 25303: @1875052
     /* 1875052 */   GIM_Try, /*On fail goto*//*Label 25304*/ GIMT_Encode4(1875141), // Rule ID 14221 //
     /* 1875057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1875060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1875065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1875068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1875071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1875074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875103 */     // MIs[0] policy
     /* 1875103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875113 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1875116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875140 */     // GIR_Coverage, 14221,
     /* 1875140 */     GIR_EraseRootFromParent_Done,
     /* 1875141 */   // Label 25304: @1875141
     /* 1875141 */   GIM_Try, /*On fail goto*//*Label 25305*/ GIMT_Encode4(1875230), // Rule ID 14312 //
     /* 1875146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1875157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1875160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1875163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1875166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875192 */     // MIs[0] policy
     /* 1875192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875202 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1875205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875229 */     // GIR_Coverage, 14312,
     /* 1875229 */     GIR_EraseRootFromParent_Done,
     /* 1875230 */   // Label 25305: @1875230
     /* 1875230 */   GIM_Try, /*On fail goto*//*Label 25306*/ GIMT_Encode4(1875319), // Rule ID 14313 //
     /* 1875235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1875246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1875249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1875252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1875255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875281 */     // MIs[0] policy
     /* 1875281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875291 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1875294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875318 */     // GIR_Coverage, 14313,
     /* 1875318 */     GIR_EraseRootFromParent_Done,
     /* 1875319 */   // Label 25306: @1875319
     /* 1875319 */   GIM_Try, /*On fail goto*//*Label 25307*/ GIMT_Encode4(1875408), // Rule ID 14316 //
     /* 1875324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1875335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1875338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1875341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1875344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875370 */     // MIs[0] policy
     /* 1875370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875380 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1875383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875407 */     // GIR_Coverage, 14316,
     /* 1875407 */     GIR_EraseRootFromParent_Done,
     /* 1875408 */   // Label 25307: @1875408
     /* 1875408 */   GIM_Try, /*On fail goto*//*Label 25308*/ GIMT_Encode4(1875497), // Rule ID 14317 //
     /* 1875413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1875424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1875427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1875430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1875433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875459 */     // MIs[0] policy
     /* 1875459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875469 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1875472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875496 */     // GIR_Coverage, 14317,
     /* 1875496 */     GIR_EraseRootFromParent_Done,
     /* 1875497 */   // Label 25308: @1875497
     /* 1875497 */   GIM_Try, /*On fail goto*//*Label 25309*/ GIMT_Encode4(1875586), // Rule ID 14320 //
     /* 1875502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1875513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1875516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1875519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1875522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875548 */     // MIs[0] policy
     /* 1875548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875558 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1875561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875585 */     // GIR_Coverage, 14320,
     /* 1875585 */     GIR_EraseRootFromParent_Done,
     /* 1875586 */   // Label 25309: @1875586
     /* 1875586 */   GIM_Try, /*On fail goto*//*Label 25310*/ GIMT_Encode4(1875675), // Rule ID 14321 //
     /* 1875591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1875602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1875605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1875608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1875611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875637 */     // MIs[0] policy
     /* 1875637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875647 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1875650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875674 */     // GIR_Coverage, 14321,
     /* 1875674 */     GIR_EraseRootFromParent_Done,
     /* 1875675 */   // Label 25310: @1875675
     /* 1875675 */   GIM_Try, /*On fail goto*//*Label 25311*/ GIMT_Encode4(1875764), // Rule ID 14324 //
     /* 1875680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1875691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1875694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1875697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1875700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875726 */     // MIs[0] policy
     /* 1875726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875736 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1875739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875763 */     // GIR_Coverage, 14324,
     /* 1875763 */     GIR_EraseRootFromParent_Done,
     /* 1875764 */   // Label 25311: @1875764
     /* 1875764 */   GIM_Try, /*On fail goto*//*Label 25312*/ GIMT_Encode4(1875853), // Rule ID 14325 //
     /* 1875769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1875780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1875783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1875786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1875789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875815 */     // MIs[0] policy
     /* 1875815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875825 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1875828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875852 */     // GIR_Coverage, 14325,
     /* 1875852 */     GIR_EraseRootFromParent_Done,
     /* 1875853 */   // Label 25312: @1875853
     /* 1875853 */   GIM_Try, /*On fail goto*//*Label 25313*/ GIMT_Encode4(1875942), // Rule ID 14328 //
     /* 1875858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1875869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1875872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1875875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1875878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875904 */     // MIs[0] policy
     /* 1875904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875914 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1875917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875941 */     // GIR_Coverage, 14328,
     /* 1875941 */     GIR_EraseRootFromParent_Done,
     /* 1875942 */   // Label 25313: @1875942
     /* 1875942 */   GIM_Try, /*On fail goto*//*Label 25314*/ GIMT_Encode4(1876031), // Rule ID 14329 //
     /* 1875947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1875958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1875961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1875964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1875967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875993 */     // MIs[0] policy
     /* 1875993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876003 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1876006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876030 */     // GIR_Coverage, 14329,
     /* 1876030 */     GIR_EraseRootFromParent_Done,
     /* 1876031 */   // Label 25314: @1876031
     /* 1876031 */   GIM_Try, /*On fail goto*//*Label 25315*/ GIMT_Encode4(1876120), // Rule ID 14332 //
     /* 1876036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1876047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1876050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1876053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1876056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876082 */     // MIs[0] policy
     /* 1876082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876092 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1876095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876119 */     // GIR_Coverage, 14332,
     /* 1876119 */     GIR_EraseRootFromParent_Done,
     /* 1876120 */   // Label 25315: @1876120
     /* 1876120 */   GIM_Try, /*On fail goto*//*Label 25316*/ GIMT_Encode4(1876209), // Rule ID 14333 //
     /* 1876125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1876136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1876139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1876142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1876145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876171 */     // MIs[0] policy
     /* 1876171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876181 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1876184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876208 */     // GIR_Coverage, 14333,
     /* 1876208 */     GIR_EraseRootFromParent_Done,
     /* 1876209 */   // Label 25316: @1876209
     /* 1876209 */   GIM_Try, /*On fail goto*//*Label 25317*/ GIMT_Encode4(1876298), // Rule ID 14336 //
     /* 1876214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1876225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1876228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1876231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1876234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876260 */     // MIs[0] policy
     /* 1876260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876270 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1876273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876297 */     // GIR_Coverage, 14336,
     /* 1876297 */     GIR_EraseRootFromParent_Done,
     /* 1876298 */   // Label 25317: @1876298
     /* 1876298 */   GIM_Try, /*On fail goto*//*Label 25318*/ GIMT_Encode4(1876387), // Rule ID 14337 //
     /* 1876303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1876314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1876317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1876320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1876323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876349 */     // MIs[0] policy
     /* 1876349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876359 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1876362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876386 */     // GIR_Coverage, 14337,
     /* 1876386 */     GIR_EraseRootFromParent_Done,
     /* 1876387 */   // Label 25318: @1876387
     /* 1876387 */   GIM_Try, /*On fail goto*//*Label 25319*/ GIMT_Encode4(1876476), // Rule ID 14340 //
     /* 1876392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1876403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1876406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1876409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1876412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876438 */     // MIs[0] policy
     /* 1876438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1876451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876475 */     // GIR_Coverage, 14340,
     /* 1876475 */     GIR_EraseRootFromParent_Done,
     /* 1876476 */   // Label 25319: @1876476
     /* 1876476 */   GIM_Try, /*On fail goto*//*Label 25320*/ GIMT_Encode4(1876565), // Rule ID 14341 //
     /* 1876481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1876492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1876495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1876498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1876501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876527 */     // MIs[0] policy
     /* 1876527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876537 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1876540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876564 */     // GIR_Coverage, 14341,
     /* 1876564 */     GIR_EraseRootFromParent_Done,
     /* 1876565 */   // Label 25320: @1876565
     /* 1876565 */   GIM_Try, /*On fail goto*//*Label 25321*/ GIMT_Encode4(1876654), // Rule ID 14344 //
     /* 1876570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1876581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1876584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1876587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1876590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876616 */     // MIs[0] policy
     /* 1876616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876626 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1876629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876653 */     // GIR_Coverage, 14344,
     /* 1876653 */     GIR_EraseRootFromParent_Done,
     /* 1876654 */   // Label 25321: @1876654
     /* 1876654 */   GIM_Try, /*On fail goto*//*Label 25322*/ GIMT_Encode4(1876743), // Rule ID 14345 //
     /* 1876659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1876670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1876673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1876676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1876679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876705 */     // MIs[0] policy
     /* 1876705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876715 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1876718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876742 */     // GIR_Coverage, 14345,
     /* 1876742 */     GIR_EraseRootFromParent_Done,
     /* 1876743 */   // Label 25322: @1876743
     /* 1876743 */   GIM_Try, /*On fail goto*//*Label 25323*/ GIMT_Encode4(1876832), // Rule ID 14348 //
     /* 1876748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1876751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1876759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1876762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1876765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1876768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876794 */     // MIs[0] policy
     /* 1876794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876804 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1876807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876831 */     // GIR_Coverage, 14348,
     /* 1876831 */     GIR_EraseRootFromParent_Done,
     /* 1876832 */   // Label 25323: @1876832
     /* 1876832 */   GIM_Try, /*On fail goto*//*Label 25324*/ GIMT_Encode4(1876921), // Rule ID 14349 //
     /* 1876837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1876840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1876848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1876851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1876854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1876857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876883 */     // MIs[0] policy
     /* 1876883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876893 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1876896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876920 */     // GIR_Coverage, 14349,
     /* 1876920 */     GIR_EraseRootFromParent_Done,
     /* 1876921 */   // Label 25324: @1876921
     /* 1876921 */   GIM_Try, /*On fail goto*//*Label 25325*/ GIMT_Encode4(1877010), // Rule ID 14352 //
     /* 1876926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1876937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1876940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1876943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1876946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1876949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1876956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1876960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1876964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1876968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876972 */     // MIs[0] policy
     /* 1876972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876982 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1876985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877009 */     // GIR_Coverage, 14352,
     /* 1877009 */     GIR_EraseRootFromParent_Done,
     /* 1877010 */   // Label 25325: @1877010
     /* 1877010 */   GIM_Try, /*On fail goto*//*Label 25326*/ GIMT_Encode4(1877099), // Rule ID 14353 //
     /* 1877015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1877026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1877029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1877032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1877035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877061 */     // MIs[0] policy
     /* 1877061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877071 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1877074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877098 */     // GIR_Coverage, 14353,
     /* 1877098 */     GIR_EraseRootFromParent_Done,
     /* 1877099 */   // Label 25326: @1877099
     /* 1877099 */   GIM_Try, /*On fail goto*//*Label 25327*/ GIMT_Encode4(1877188), // Rule ID 14356 //
     /* 1877104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1877115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1877118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1877121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1877124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877150 */     // MIs[0] policy
     /* 1877150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877160 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1877163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877187 */     // GIR_Coverage, 14356,
     /* 1877187 */     GIR_EraseRootFromParent_Done,
     /* 1877188 */   // Label 25327: @1877188
     /* 1877188 */   GIM_Try, /*On fail goto*//*Label 25328*/ GIMT_Encode4(1877277), // Rule ID 14357 //
     /* 1877193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1877204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1877207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1877210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1877213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877239 */     // MIs[0] policy
     /* 1877239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877249 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1877252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877276 */     // GIR_Coverage, 14357,
     /* 1877276 */     GIR_EraseRootFromParent_Done,
     /* 1877277 */   // Label 25328: @1877277
     /* 1877277 */   GIM_Try, /*On fail goto*//*Label 25329*/ GIMT_Encode4(1877366), // Rule ID 14360 //
     /* 1877282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1877293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1877296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1877299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1877302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1877305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877328 */     // MIs[0] policy
     /* 1877328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877338 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1877341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877365 */     // GIR_Coverage, 14360,
     /* 1877365 */     GIR_EraseRootFromParent_Done,
     /* 1877366 */   // Label 25329: @1877366
     /* 1877366 */   GIM_Try, /*On fail goto*//*Label 25330*/ GIMT_Encode4(1877455), // Rule ID 14361 //
     /* 1877371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1877382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1877385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1877388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1877391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1877394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877417 */     // MIs[0] policy
     /* 1877417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877427 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1877430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877454 */     // GIR_Coverage, 14361,
     /* 1877454 */     GIR_EraseRootFromParent_Done,
     /* 1877455 */   // Label 25330: @1877455
     /* 1877455 */   GIM_Try, /*On fail goto*//*Label 25331*/ GIMT_Encode4(1877544), // Rule ID 14364 //
     /* 1877460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1877471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1877474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1877477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1877480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1877483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877506 */     // MIs[0] policy
     /* 1877506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1877519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877543 */     // GIR_Coverage, 14364,
     /* 1877543 */     GIR_EraseRootFromParent_Done,
     /* 1877544 */   // Label 25331: @1877544
     /* 1877544 */   GIM_Try, /*On fail goto*//*Label 25332*/ GIMT_Encode4(1877633), // Rule ID 14365 //
     /* 1877549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1877560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1877563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1877566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1877569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1877572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877595 */     // MIs[0] policy
     /* 1877595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877605 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1877608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877632 */     // GIR_Coverage, 14365,
     /* 1877632 */     GIR_EraseRootFromParent_Done,
     /* 1877633 */   // Label 25332: @1877633
     /* 1877633 */   GIM_Try, /*On fail goto*//*Label 25333*/ GIMT_Encode4(1877722), // Rule ID 14368 //
     /* 1877638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1877649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1877652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1877655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1877658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877684 */     // MIs[0] policy
     /* 1877684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877694 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1877697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877721 */     // GIR_Coverage, 14368,
     /* 1877721 */     GIR_EraseRootFromParent_Done,
     /* 1877722 */   // Label 25333: @1877722
     /* 1877722 */   GIM_Try, /*On fail goto*//*Label 25334*/ GIMT_Encode4(1877811), // Rule ID 14369 //
     /* 1877727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1877738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1877741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1877744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1877747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877773 */     // MIs[0] policy
     /* 1877773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877783 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1877786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877810 */     // GIR_Coverage, 14369,
     /* 1877810 */     GIR_EraseRootFromParent_Done,
     /* 1877811 */   // Label 25334: @1877811
     /* 1877811 */   GIM_Try, /*On fail goto*//*Label 25335*/ GIMT_Encode4(1877900), // Rule ID 14372 //
     /* 1877816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1877827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1877830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1877833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1877836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877862 */     // MIs[0] policy
     /* 1877862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877872 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1877875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877899 */     // GIR_Coverage, 14372,
     /* 1877899 */     GIR_EraseRootFromParent_Done,
     /* 1877900 */   // Label 25335: @1877900
     /* 1877900 */   GIM_Try, /*On fail goto*//*Label 25336*/ GIMT_Encode4(1877989), // Rule ID 14373 //
     /* 1877905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1877916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1877919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1877922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1877925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877951 */     // MIs[0] policy
     /* 1877951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877961 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1877964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877988 */     // GIR_Coverage, 14373,
     /* 1877988 */     GIR_EraseRootFromParent_Done,
     /* 1877989 */   // Label 25336: @1877989
     /* 1877989 */   GIM_Try, /*On fail goto*//*Label 25337*/ GIMT_Encode4(1878078), // Rule ID 14376 //
     /* 1877994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1878005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1878008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1878011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1878014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878040 */     // MIs[0] policy
     /* 1878040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878050 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1878053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878077 */     // GIR_Coverage, 14376,
     /* 1878077 */     GIR_EraseRootFromParent_Done,
     /* 1878078 */   // Label 25337: @1878078
     /* 1878078 */   GIM_Try, /*On fail goto*//*Label 25338*/ GIMT_Encode4(1878167), // Rule ID 14377 //
     /* 1878083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1878094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1878097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1878100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1878103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878129 */     // MIs[0] policy
     /* 1878129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1878142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878166 */     // GIR_Coverage, 14377,
     /* 1878166 */     GIR_EraseRootFromParent_Done,
     /* 1878167 */   // Label 25338: @1878167
     /* 1878167 */   GIM_Try, /*On fail goto*//*Label 25339*/ GIMT_Encode4(1878256), // Rule ID 14380 //
     /* 1878172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1878183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1878186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1878189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1878192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878218 */     // MIs[0] policy
     /* 1878218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878228 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1878231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878255 */     // GIR_Coverage, 14380,
     /* 1878255 */     GIR_EraseRootFromParent_Done,
     /* 1878256 */   // Label 25339: @1878256
     /* 1878256 */   GIM_Try, /*On fail goto*//*Label 25340*/ GIMT_Encode4(1878345), // Rule ID 14381 //
     /* 1878261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1878272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1878275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1878278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1878281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878307 */     // MIs[0] policy
     /* 1878307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878317 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1878320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878344 */     // GIR_Coverage, 14381,
     /* 1878344 */     GIR_EraseRootFromParent_Done,
     /* 1878345 */   // Label 25340: @1878345
     /* 1878345 */   GIM_Try, /*On fail goto*//*Label 25341*/ GIMT_Encode4(1878434), // Rule ID 14384 //
     /* 1878350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1878361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1878364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1878367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1878370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878396 */     // MIs[0] policy
     /* 1878396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878406 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1878409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878433 */     // GIR_Coverage, 14384,
     /* 1878433 */     GIR_EraseRootFromParent_Done,
     /* 1878434 */   // Label 25341: @1878434
     /* 1878434 */   GIM_Try, /*On fail goto*//*Label 25342*/ GIMT_Encode4(1878523), // Rule ID 14385 //
     /* 1878439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1878450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1878453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1878456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1878459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878485 */     // MIs[0] policy
     /* 1878485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878495 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1878498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878522 */     // GIR_Coverage, 14385,
     /* 1878522 */     GIR_EraseRootFromParent_Done,
     /* 1878523 */   // Label 25342: @1878523
     /* 1878523 */   GIM_Try, /*On fail goto*//*Label 25343*/ GIMT_Encode4(1878612), // Rule ID 14388 //
     /* 1878528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1878531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1878539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1878542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1878545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1878548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1878551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878574 */     // MIs[0] policy
     /* 1878574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1878587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878611 */     // GIR_Coverage, 14388,
     /* 1878611 */     GIR_EraseRootFromParent_Done,
     /* 1878612 */   // Label 25343: @1878612
     /* 1878612 */   GIM_Try, /*On fail goto*//*Label 25344*/ GIMT_Encode4(1878701), // Rule ID 14389 //
     /* 1878617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1878620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1878628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1878631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1878634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1878637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1878640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878663 */     // MIs[0] policy
     /* 1878663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878673 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1878676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878700 */     // GIR_Coverage, 14389,
     /* 1878700 */     GIR_EraseRootFromParent_Done,
     /* 1878701 */   // Label 25344: @1878701
     /* 1878701 */   GIM_Try, /*On fail goto*//*Label 25345*/ GIMT_Encode4(1878790), // Rule ID 14392 //
     /* 1878706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1878709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1878717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1878720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1878723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1878726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878752 */     // MIs[0] policy
     /* 1878752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878762 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1878765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878789 */     // GIR_Coverage, 14392,
     /* 1878789 */     GIR_EraseRootFromParent_Done,
     /* 1878790 */   // Label 25345: @1878790
     /* 1878790 */   GIM_Try, /*On fail goto*//*Label 25346*/ GIMT_Encode4(1878879), // Rule ID 14393 //
     /* 1878795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1878798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1878806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1878809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1878812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1878815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878841 */     // MIs[0] policy
     /* 1878841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878851 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1878854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878878 */     // GIR_Coverage, 14393,
     /* 1878878 */     GIR_EraseRootFromParent_Done,
     /* 1878879 */   // Label 25346: @1878879
     /* 1878879 */   GIM_Try, /*On fail goto*//*Label 25347*/ GIMT_Encode4(1878968), // Rule ID 14396 //
     /* 1878884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1878887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1878895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1878898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1878901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1878904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878930 */     // MIs[0] policy
     /* 1878930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878940 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1878943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878967 */     // GIR_Coverage, 14396,
     /* 1878967 */     GIR_EraseRootFromParent_Done,
     /* 1878968 */   // Label 25347: @1878968
     /* 1878968 */   GIM_Try, /*On fail goto*//*Label 25348*/ GIMT_Encode4(1879057), // Rule ID 14397 //
     /* 1878973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1878976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1878984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1878987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1878990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1878993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879019 */     // MIs[0] policy
     /* 1879019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879029 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1879032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879056 */     // GIR_Coverage, 14397,
     /* 1879056 */     GIR_EraseRootFromParent_Done,
     /* 1879057 */   // Label 25348: @1879057
     /* 1879057 */   GIM_Try, /*On fail goto*//*Label 25349*/ GIMT_Encode4(1879146), // Rule ID 14400 //
     /* 1879062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1879073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1879076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1879079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879108 */     // MIs[0] policy
     /* 1879108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879118 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1879121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879145 */     // GIR_Coverage, 14400,
     /* 1879145 */     GIR_EraseRootFromParent_Done,
     /* 1879146 */   // Label 25349: @1879146
     /* 1879146 */   GIM_Try, /*On fail goto*//*Label 25350*/ GIMT_Encode4(1879235), // Rule ID 14401 //
     /* 1879151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1879162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1879165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1879168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879197 */     // MIs[0] policy
     /* 1879197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879207 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1879210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879234 */     // GIR_Coverage, 14401,
     /* 1879234 */     GIR_EraseRootFromParent_Done,
     /* 1879235 */   // Label 25350: @1879235
     /* 1879235 */   GIM_Try, /*On fail goto*//*Label 25351*/ GIMT_Encode4(1879324), // Rule ID 14404 //
     /* 1879240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1879251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1879254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1879257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879286 */     // MIs[0] policy
     /* 1879286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879296 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1879299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879323 */     // GIR_Coverage, 14404,
     /* 1879323 */     GIR_EraseRootFromParent_Done,
     /* 1879324 */   // Label 25351: @1879324
     /* 1879324 */   GIM_Try, /*On fail goto*//*Label 25352*/ GIMT_Encode4(1879413), // Rule ID 14405 //
     /* 1879329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1879340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1879343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1879346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879375 */     // MIs[0] policy
     /* 1879375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879385 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1879388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879412 */     // GIR_Coverage, 14405,
     /* 1879412 */     GIR_EraseRootFromParent_Done,
     /* 1879413 */   // Label 25352: @1879413
     /* 1879413 */   GIM_Try, /*On fail goto*//*Label 25353*/ GIMT_Encode4(1879502), // Rule ID 14408 //
     /* 1879418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1879429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1879432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1879435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879464 */     // MIs[0] policy
     /* 1879464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879474 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1879477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879501 */     // GIR_Coverage, 14408,
     /* 1879501 */     GIR_EraseRootFromParent_Done,
     /* 1879502 */   // Label 25353: @1879502
     /* 1879502 */   GIM_Try, /*On fail goto*//*Label 25354*/ GIMT_Encode4(1879591), // Rule ID 14409 //
     /* 1879507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1879518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1879521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1879524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879553 */     // MIs[0] policy
     /* 1879553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879563 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1879566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879590 */     // GIR_Coverage, 14409,
     /* 1879590 */     GIR_EraseRootFromParent_Done,
     /* 1879591 */   // Label 25354: @1879591
     /* 1879591 */   GIM_Try, /*On fail goto*//*Label 25355*/ GIMT_Encode4(1879680), // Rule ID 14412 //
     /* 1879596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1879607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1879610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1879613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879642 */     // MIs[0] policy
     /* 1879642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879652 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1879655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879679 */     // GIR_Coverage, 14412,
     /* 1879679 */     GIR_EraseRootFromParent_Done,
     /* 1879680 */   // Label 25355: @1879680
     /* 1879680 */   GIM_Try, /*On fail goto*//*Label 25356*/ GIMT_Encode4(1879769), // Rule ID 14413 //
     /* 1879685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1879696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1879699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1879702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879731 */     // MIs[0] policy
     /* 1879731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879741 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1879744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879768 */     // GIR_Coverage, 14413,
     /* 1879768 */     GIR_EraseRootFromParent_Done,
     /* 1879769 */   // Label 25356: @1879769
     /* 1879769 */   GIM_Try, /*On fail goto*//*Label 25357*/ GIMT_Encode4(1879858), // Rule ID 14416 //
     /* 1879774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1879785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1879788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1879791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879820 */     // MIs[0] policy
     /* 1879820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879830 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1879833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879857 */     // GIR_Coverage, 14416,
     /* 1879857 */     GIR_EraseRootFromParent_Done,
     /* 1879858 */   // Label 25357: @1879858
     /* 1879858 */   GIM_Try, /*On fail goto*//*Label 25358*/ GIMT_Encode4(1879947), // Rule ID 14417 //
     /* 1879863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1879874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1879877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1879880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879909 */     // MIs[0] policy
     /* 1879909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879919 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1879922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879946 */     // GIR_Coverage, 14417,
     /* 1879946 */     GIR_EraseRootFromParent_Done,
     /* 1879947 */   // Label 25358: @1879947
     /* 1879947 */   GIM_Try, /*On fail goto*//*Label 25359*/ GIMT_Encode4(1880036), // Rule ID 14420 //
     /* 1879952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1879963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1879966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1879969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879998 */     // MIs[0] policy
     /* 1879998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880008 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1880011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880035 */     // GIR_Coverage, 14420,
     /* 1880035 */     GIR_EraseRootFromParent_Done,
     /* 1880036 */   // Label 25359: @1880036
     /* 1880036 */   GIM_Try, /*On fail goto*//*Label 25360*/ GIMT_Encode4(1880125), // Rule ID 14421 //
     /* 1880041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1880049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1880052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1880055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1880058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1880061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880087 */     // MIs[0] policy
     /* 1880087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880097 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1880100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880124 */     // GIR_Coverage, 14421,
     /* 1880124 */     GIR_EraseRootFromParent_Done,
     /* 1880125 */   // Label 25360: @1880125
     /* 1880125 */   GIM_Try, /*On fail goto*//*Label 25361*/ GIMT_Encode4(1880214), // Rule ID 14424 //
     /* 1880130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1880138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1880141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1880144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1880147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1880150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880176 */     // MIs[0] policy
     /* 1880176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880186 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1880189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880209 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880213 */     // GIR_Coverage, 14424,
     /* 1880213 */     GIR_EraseRootFromParent_Done,
     /* 1880214 */   // Label 25361: @1880214
     /* 1880214 */   GIM_Try, /*On fail goto*//*Label 25362*/ GIMT_Encode4(1880303), // Rule ID 14425 //
     /* 1880219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1880227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1880230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1880233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1880236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1880239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880265 */     // MIs[0] policy
     /* 1880265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880275 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1880278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880302 */     // GIR_Coverage, 14425,
     /* 1880302 */     GIR_EraseRootFromParent_Done,
     /* 1880303 */   // Label 25362: @1880303
     /* 1880303 */   GIM_Try, /*On fail goto*//*Label 25363*/ GIMT_Encode4(1880392), // Rule ID 14428 //
     /* 1880308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1880316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1880319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1880322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1880325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1880328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880354 */     // MIs[0] policy
     /* 1880354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880364 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1880367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880391 */     // GIR_Coverage, 14428,
     /* 1880391 */     GIR_EraseRootFromParent_Done,
     /* 1880392 */   // Label 25363: @1880392
     /* 1880392 */   GIM_Try, /*On fail goto*//*Label 25364*/ GIMT_Encode4(1880481), // Rule ID 14429 //
     /* 1880397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1880405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1880408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1880411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1880414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1880417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880443 */     // MIs[0] policy
     /* 1880443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880453 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1880456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880480 */     // GIR_Coverage, 14429,
     /* 1880480 */     GIR_EraseRootFromParent_Done,
     /* 1880481 */   // Label 25364: @1880481
     /* 1880481 */   GIM_Try, /*On fail goto*//*Label 25365*/ GIMT_Encode4(1880570), // Rule ID 14432 //
     /* 1880486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1880494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1880497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1880500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1880503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1880506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880532 */     // MIs[0] policy
     /* 1880532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880542 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1880545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880569 */     // GIR_Coverage, 14432,
     /* 1880569 */     GIR_EraseRootFromParent_Done,
     /* 1880570 */   // Label 25365: @1880570
     /* 1880570 */   GIM_Try, /*On fail goto*//*Label 25366*/ GIMT_Encode4(1880659), // Rule ID 14433 //
     /* 1880575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1880583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1880586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1880589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1880592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1880595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880621 */     // MIs[0] policy
     /* 1880621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880631 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1880634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880658 */     // GIR_Coverage, 14433,
     /* 1880658 */     GIR_EraseRootFromParent_Done,
     /* 1880659 */   // Label 25366: @1880659
     /* 1880659 */   GIM_Try, /*On fail goto*//*Label 25367*/ GIMT_Encode4(1880748), // Rule ID 14436 //
     /* 1880664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1880667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1880672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1880675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1880678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1880681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1880684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880710 */     // MIs[0] policy
     /* 1880710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880720 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1880723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880747 */     // GIR_Coverage, 14436,
     /* 1880747 */     GIR_EraseRootFromParent_Done,
     /* 1880748 */   // Label 25367: @1880748
     /* 1880748 */   GIM_Try, /*On fail goto*//*Label 25368*/ GIMT_Encode4(1880837), // Rule ID 14437 //
     /* 1880753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1880756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1880761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1880764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1880767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1880770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1880773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880799 */     // MIs[0] policy
     /* 1880799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880809 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1880812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880836 */     // GIR_Coverage, 14437,
     /* 1880836 */     GIR_EraseRootFromParent_Done,
     /* 1880837 */   // Label 25368: @1880837
     /* 1880837 */   GIM_Try, /*On fail goto*//*Label 25369*/ GIMT_Encode4(1880926), // Rule ID 14440 //
     /* 1880842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1880850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1880853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1880856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1880859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1880862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1880865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1880872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880888 */     // MIs[0] policy
     /* 1880888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880898 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1880901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880925 */     // GIR_Coverage, 14440,
     /* 1880925 */     GIR_EraseRootFromParent_Done,
     /* 1880926 */   // Label 25369: @1880926
     /* 1880926 */   GIM_Try, /*On fail goto*//*Label 25370*/ GIMT_Encode4(1881015), // Rule ID 14441 //
     /* 1880931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1880939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1880942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1880945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1880948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1880951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1880954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1880961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880977 */     // MIs[0] policy
     /* 1880977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880987 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1880990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881014 */     // GIR_Coverage, 14441,
     /* 1881014 */     GIR_EraseRootFromParent_Done,
     /* 1881015 */   // Label 25370: @1881015
     /* 1881015 */   GIM_Try, /*On fail goto*//*Label 25371*/ GIMT_Encode4(1881104), // Rule ID 14444 //
     /* 1881020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1881028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1881031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1881034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1881037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1881040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881066 */     // MIs[0] policy
     /* 1881066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881076 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1881079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881103 */     // GIR_Coverage, 14444,
     /* 1881103 */     GIR_EraseRootFromParent_Done,
     /* 1881104 */   // Label 25371: @1881104
     /* 1881104 */   GIM_Try, /*On fail goto*//*Label 25372*/ GIMT_Encode4(1881193), // Rule ID 14445 //
     /* 1881109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1881117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1881120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1881123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1881126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1881129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881155 */     // MIs[0] policy
     /* 1881155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881165 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1881168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881192 */     // GIR_Coverage, 14445,
     /* 1881192 */     GIR_EraseRootFromParent_Done,
     /* 1881193 */   // Label 25372: @1881193
     /* 1881193 */   GIM_Try, /*On fail goto*//*Label 25373*/ GIMT_Encode4(1881282), // Rule ID 14448 //
     /* 1881198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1881206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1881209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1881212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1881215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1881218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1881221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881244 */     // MIs[0] policy
     /* 1881244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881254 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1881257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881281 */     // GIR_Coverage, 14448,
     /* 1881281 */     GIR_EraseRootFromParent_Done,
     /* 1881282 */   // Label 25373: @1881282
     /* 1881282 */   GIM_Try, /*On fail goto*//*Label 25374*/ GIMT_Encode4(1881371), // Rule ID 14449 //
     /* 1881287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1881295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1881298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1881301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1881304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1881307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1881310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881333 */     // MIs[0] policy
     /* 1881333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881343 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1881346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881370 */     // GIR_Coverage, 14449,
     /* 1881370 */     GIR_EraseRootFromParent_Done,
     /* 1881371 */   // Label 25374: @1881371
     /* 1881371 */   GIM_Try, /*On fail goto*//*Label 25375*/ GIMT_Encode4(1881460), // Rule ID 14452 //
     /* 1881376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1881384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1881387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1881390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1881393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1881396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881422 */     // MIs[0] policy
     /* 1881422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881432 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1881435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881459 */     // GIR_Coverage, 14452,
     /* 1881459 */     GIR_EraseRootFromParent_Done,
     /* 1881460 */   // Label 25375: @1881460
     /* 1881460 */   GIM_Try, /*On fail goto*//*Label 25376*/ GIMT_Encode4(1881549), // Rule ID 14453 //
     /* 1881465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1881473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1881476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1881479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1881482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1881485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881511 */     // MIs[0] policy
     /* 1881511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1881524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881548 */     // GIR_Coverage, 14453,
     /* 1881548 */     GIR_EraseRootFromParent_Done,
     /* 1881549 */   // Label 25376: @1881549
     /* 1881549 */   GIM_Try, /*On fail goto*//*Label 25377*/ GIMT_Encode4(1881638), // Rule ID 14456 //
     /* 1881554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1881562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1881565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1881568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1881571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1881574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881600 */     // MIs[0] policy
     /* 1881600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881610 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1881613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881637 */     // GIR_Coverage, 14456,
     /* 1881637 */     GIR_EraseRootFromParent_Done,
     /* 1881638 */   // Label 25377: @1881638
     /* 1881638 */   GIM_Try, /*On fail goto*//*Label 25378*/ GIMT_Encode4(1881727), // Rule ID 14457 //
     /* 1881643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1881651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1881654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1881657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1881660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1881663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881689 */     // MIs[0] policy
     /* 1881689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881699 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1881702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881726 */     // GIR_Coverage, 14457,
     /* 1881726 */     GIR_EraseRootFromParent_Done,
     /* 1881727 */   // Label 25378: @1881727
     /* 1881727 */   GIM_Try, /*On fail goto*//*Label 25379*/ GIMT_Encode4(1881816), // Rule ID 14460 //
     /* 1881732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1881740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1881743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1881746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1881749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1881752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881778 */     // MIs[0] policy
     /* 1881778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881788 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1881791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881815 */     // GIR_Coverage, 14460,
     /* 1881815 */     GIR_EraseRootFromParent_Done,
     /* 1881816 */   // Label 25379: @1881816
     /* 1881816 */   GIM_Try, /*On fail goto*//*Label 25380*/ GIMT_Encode4(1881905), // Rule ID 14461 //
     /* 1881821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1881829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1881832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1881835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1881838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1881841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881867 */     // MIs[0] policy
     /* 1881867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881877 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1881880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881904 */     // GIR_Coverage, 14461,
     /* 1881904 */     GIR_EraseRootFromParent_Done,
     /* 1881905 */   // Label 25380: @1881905
     /* 1881905 */   GIM_Try, /*On fail goto*//*Label 25381*/ GIMT_Encode4(1881994), // Rule ID 14464 //
     /* 1881910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1881918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1881921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1881924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1881927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1881930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1881933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881956 */     // MIs[0] policy
     /* 1881956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1881969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881993 */     // GIR_Coverage, 14464,
     /* 1881993 */     GIR_EraseRootFromParent_Done,
     /* 1881994 */   // Label 25381: @1881994
     /* 1881994 */   GIM_Try, /*On fail goto*//*Label 25382*/ GIMT_Encode4(1882083), // Rule ID 14465 //
     /* 1881999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1882007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1882010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1882013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1882016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1882019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882045 */     // MIs[0] policy
     /* 1882045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1882058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882082 */     // GIR_Coverage, 14465,
     /* 1882082 */     GIR_EraseRootFromParent_Done,
     /* 1882083 */   // Label 25382: @1882083
     /* 1882083 */   GIM_Try, /*On fail goto*//*Label 25383*/ GIMT_Encode4(1882172), // Rule ID 14468 //
     /* 1882088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1882096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1882099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1882102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1882105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1882108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882134 */     // MIs[0] policy
     /* 1882134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882144 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1882147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882171 */     // GIR_Coverage, 14468,
     /* 1882171 */     GIR_EraseRootFromParent_Done,
     /* 1882172 */   // Label 25383: @1882172
     /* 1882172 */   GIM_Try, /*On fail goto*//*Label 25384*/ GIMT_Encode4(1882261), // Rule ID 14469 //
     /* 1882177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1882185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1882188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1882191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1882194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1882197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882223 */     // MIs[0] policy
     /* 1882223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882233 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1882236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882260 */     // GIR_Coverage, 14469,
     /* 1882260 */     GIR_EraseRootFromParent_Done,
     /* 1882261 */   // Label 25384: @1882261
     /* 1882261 */   GIM_Try, /*On fail goto*//*Label 25385*/ GIMT_Encode4(1882350), // Rule ID 14472 //
     /* 1882266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1882274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1882277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1882280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1882283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1882286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882312 */     // MIs[0] policy
     /* 1882312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882322 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1882325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882349 */     // GIR_Coverage, 14472,
     /* 1882349 */     GIR_EraseRootFromParent_Done,
     /* 1882350 */   // Label 25385: @1882350
     /* 1882350 */   GIM_Try, /*On fail goto*//*Label 25386*/ GIMT_Encode4(1882439), // Rule ID 14473 //
     /* 1882355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1882363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1882366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1882369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1882372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1882375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882401 */     // MIs[0] policy
     /* 1882401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882411 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1882414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882438 */     // GIR_Coverage, 14473,
     /* 1882438 */     GIR_EraseRootFromParent_Done,
     /* 1882439 */   // Label 25386: @1882439
     /* 1882439 */   GIM_Try, /*On fail goto*//*Label 25387*/ GIMT_Encode4(1882528), // Rule ID 14476 //
     /* 1882444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1882447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1882452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1882455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1882458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1882461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1882464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1882467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882490 */     // MIs[0] policy
     /* 1882490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882500 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1882503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882527 */     // GIR_Coverage, 14476,
     /* 1882527 */     GIR_EraseRootFromParent_Done,
     /* 1882528 */   // Label 25387: @1882528
     /* 1882528 */   GIM_Try, /*On fail goto*//*Label 25388*/ GIMT_Encode4(1882617), // Rule ID 14477 //
     /* 1882533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1882536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1882541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1882544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1882547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1882550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1882553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1882556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882579 */     // MIs[0] policy
     /* 1882579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882589 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1882592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882616 */     // GIR_Coverage, 14477,
     /* 1882616 */     GIR_EraseRootFromParent_Done,
     /* 1882617 */   // Label 25388: @1882617
     /* 1882617 */   GIM_Try, /*On fail goto*//*Label 25389*/ GIMT_Encode4(1882706), // Rule ID 14480 //
     /* 1882622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1882625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1882630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1882633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1882636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1882639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1882642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882668 */     // MIs[0] policy
     /* 1882668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882678 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1882681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882705 */     // GIR_Coverage, 14480,
     /* 1882705 */     GIR_EraseRootFromParent_Done,
     /* 1882706 */   // Label 25389: @1882706
     /* 1882706 */   GIM_Try, /*On fail goto*//*Label 25390*/ GIMT_Encode4(1882795), // Rule ID 14481 //
     /* 1882711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1882714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1882719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1882722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1882725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1882728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1882731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882757 */     // MIs[0] policy
     /* 1882757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882767 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1882770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882794 */     // GIR_Coverage, 14481,
     /* 1882794 */     GIR_EraseRootFromParent_Done,
     /* 1882795 */   // Label 25390: @1882795
     /* 1882795 */   GIM_Try, /*On fail goto*//*Label 25391*/ GIMT_Encode4(1882884), // Rule ID 14484 //
     /* 1882800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1882803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1882808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1882811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1882814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1882817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1882820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882846 */     // MIs[0] policy
     /* 1882846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882856 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1882859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882883 */     // GIR_Coverage, 14484,
     /* 1882883 */     GIR_EraseRootFromParent_Done,
     /* 1882884 */   // Label 25391: @1882884
     /* 1882884 */   GIM_Try, /*On fail goto*//*Label 25392*/ GIMT_Encode4(1882973), // Rule ID 14485 //
     /* 1882889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1882892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1882897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1882900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1882903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1882906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1882909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882935 */     // MIs[0] policy
     /* 1882935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882945 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1882948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882972 */     // GIR_Coverage, 14485,
     /* 1882972 */     GIR_EraseRootFromParent_Done,
     /* 1882973 */   // Label 25392: @1882973
     /* 1882973 */   GIM_Try, /*On fail goto*//*Label 25393*/ GIMT_Encode4(1883062), // Rule ID 14576 //
     /* 1882978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1882989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1882992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1882995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1882998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883024 */     // MIs[0] policy
     /* 1883024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883034 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1883037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883061 */     // GIR_Coverage, 14576,
     /* 1883061 */     GIR_EraseRootFromParent_Done,
     /* 1883062 */   // Label 25393: @1883062
     /* 1883062 */   GIM_Try, /*On fail goto*//*Label 25394*/ GIMT_Encode4(1883151), // Rule ID 14577 //
     /* 1883067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1883078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1883081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1883084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1883087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883113 */     // MIs[0] policy
     /* 1883113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883123 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1883126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883150 */     // GIR_Coverage, 14577,
     /* 1883150 */     GIR_EraseRootFromParent_Done,
     /* 1883151 */   // Label 25394: @1883151
     /* 1883151 */   GIM_Try, /*On fail goto*//*Label 25395*/ GIMT_Encode4(1883240), // Rule ID 14580 //
     /* 1883156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1883167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1883170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1883173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1883176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883202 */     // MIs[0] policy
     /* 1883202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883212 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1883215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883239 */     // GIR_Coverage, 14580,
     /* 1883239 */     GIR_EraseRootFromParent_Done,
     /* 1883240 */   // Label 25395: @1883240
     /* 1883240 */   GIM_Try, /*On fail goto*//*Label 25396*/ GIMT_Encode4(1883329), // Rule ID 14581 //
     /* 1883245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1883256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1883259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1883262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1883265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883291 */     // MIs[0] policy
     /* 1883291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883301 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1883304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883328 */     // GIR_Coverage, 14581,
     /* 1883328 */     GIR_EraseRootFromParent_Done,
     /* 1883329 */   // Label 25396: @1883329
     /* 1883329 */   GIM_Try, /*On fail goto*//*Label 25397*/ GIMT_Encode4(1883418), // Rule ID 14584 //
     /* 1883334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1883345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1883348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1883351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1883354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883380 */     // MIs[0] policy
     /* 1883380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883390 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1883393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883417 */     // GIR_Coverage, 14584,
     /* 1883417 */     GIR_EraseRootFromParent_Done,
     /* 1883418 */   // Label 25397: @1883418
     /* 1883418 */   GIM_Try, /*On fail goto*//*Label 25398*/ GIMT_Encode4(1883507), // Rule ID 14585 //
     /* 1883423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1883434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1883437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1883440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1883443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883469 */     // MIs[0] policy
     /* 1883469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883479 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1883482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883506 */     // GIR_Coverage, 14585,
     /* 1883506 */     GIR_EraseRootFromParent_Done,
     /* 1883507 */   // Label 25398: @1883507
     /* 1883507 */   GIM_Try, /*On fail goto*//*Label 25399*/ GIMT_Encode4(1883596), // Rule ID 14588 //
     /* 1883512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1883523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1883526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1883529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1883532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883558 */     // MIs[0] policy
     /* 1883558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1883571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883595 */     // GIR_Coverage, 14588,
     /* 1883595 */     GIR_EraseRootFromParent_Done,
     /* 1883596 */   // Label 25399: @1883596
     /* 1883596 */   GIM_Try, /*On fail goto*//*Label 25400*/ GIMT_Encode4(1883685), // Rule ID 14589 //
     /* 1883601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1883612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1883615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1883618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1883621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883647 */     // MIs[0] policy
     /* 1883647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883657 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1883660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883684 */     // GIR_Coverage, 14589,
     /* 1883684 */     GIR_EraseRootFromParent_Done,
     /* 1883685 */   // Label 25400: @1883685
     /* 1883685 */   GIM_Try, /*On fail goto*//*Label 25401*/ GIMT_Encode4(1883774), // Rule ID 14592 //
     /* 1883690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1883701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1883704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1883707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1883710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883736 */     // MIs[0] policy
     /* 1883736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883746 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1883749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883773 */     // GIR_Coverage, 14592,
     /* 1883773 */     GIR_EraseRootFromParent_Done,
     /* 1883774 */   // Label 25401: @1883774
     /* 1883774 */   GIM_Try, /*On fail goto*//*Label 25402*/ GIMT_Encode4(1883863), // Rule ID 14593 //
     /* 1883779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1883790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1883793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1883796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1883799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883825 */     // MIs[0] policy
     /* 1883825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883835 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1883838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883862 */     // GIR_Coverage, 14593,
     /* 1883862 */     GIR_EraseRootFromParent_Done,
     /* 1883863 */   // Label 25402: @1883863
     /* 1883863 */   GIM_Try, /*On fail goto*//*Label 25403*/ GIMT_Encode4(1883952), // Rule ID 14596 //
     /* 1883868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1883879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1883882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1883885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1883888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883914 */     // MIs[0] policy
     /* 1883914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1883927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1883945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883951 */     // GIR_Coverage, 14596,
     /* 1883951 */     GIR_EraseRootFromParent_Done,
     /* 1883952 */   // Label 25403: @1883952
     /* 1883952 */   GIM_Try, /*On fail goto*//*Label 25404*/ GIMT_Encode4(1884041), // Rule ID 14597 //
     /* 1883957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1883968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1883971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1883974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1883977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884003 */     // MIs[0] policy
     /* 1884003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884013 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1884016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884040 */     // GIR_Coverage, 14597,
     /* 1884040 */     GIR_EraseRootFromParent_Done,
     /* 1884041 */   // Label 25404: @1884041
     /* 1884041 */   GIM_Try, /*On fail goto*//*Label 25405*/ GIMT_Encode4(1884130), // Rule ID 14600 //
     /* 1884046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1884057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1884060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1884063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1884066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884092 */     // MIs[0] policy
     /* 1884092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1884105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884129 */     // GIR_Coverage, 14600,
     /* 1884129 */     GIR_EraseRootFromParent_Done,
     /* 1884130 */   // Label 25405: @1884130
     /* 1884130 */   GIM_Try, /*On fail goto*//*Label 25406*/ GIMT_Encode4(1884219), // Rule ID 14601 //
     /* 1884135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1884146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1884149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1884152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1884155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884181 */     // MIs[0] policy
     /* 1884181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884191 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1884194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884218 */     // GIR_Coverage, 14601,
     /* 1884218 */     GIR_EraseRootFromParent_Done,
     /* 1884219 */   // Label 25406: @1884219
     /* 1884219 */   GIM_Try, /*On fail goto*//*Label 25407*/ GIMT_Encode4(1884308), // Rule ID 14604 //
     /* 1884224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1884235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1884238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1884241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1884244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884270 */     // MIs[0] policy
     /* 1884270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884280 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1884283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884307 */     // GIR_Coverage, 14604,
     /* 1884307 */     GIR_EraseRootFromParent_Done,
     /* 1884308 */   // Label 25407: @1884308
     /* 1884308 */   GIM_Try, /*On fail goto*//*Label 25408*/ GIMT_Encode4(1884397), // Rule ID 14605 //
     /* 1884313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1884324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1884327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1884330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1884333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884359 */     // MIs[0] policy
     /* 1884359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884369 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1884372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884396 */     // GIR_Coverage, 14605,
     /* 1884396 */     GIR_EraseRootFromParent_Done,
     /* 1884397 */   // Label 25408: @1884397
     /* 1884397 */   GIM_Try, /*On fail goto*//*Label 25409*/ GIMT_Encode4(1884486), // Rule ID 14608 //
     /* 1884402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1884413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1884416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1884419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1884422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884448 */     // MIs[0] policy
     /* 1884448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884458 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1884461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884485 */     // GIR_Coverage, 14608,
     /* 1884485 */     GIR_EraseRootFromParent_Done,
     /* 1884486 */   // Label 25409: @1884486
     /* 1884486 */   GIM_Try, /*On fail goto*//*Label 25410*/ GIMT_Encode4(1884575), // Rule ID 14609 //
     /* 1884491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1884502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1884505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1884508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1884511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884537 */     // MIs[0] policy
     /* 1884537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884547 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1884550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884574 */     // GIR_Coverage, 14609,
     /* 1884574 */     GIR_EraseRootFromParent_Done,
     /* 1884575 */   // Label 25410: @1884575
     /* 1884575 */   GIM_Try, /*On fail goto*//*Label 25411*/ GIMT_Encode4(1884664), // Rule ID 14612 //
     /* 1884580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1884583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1884591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1884594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1884597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1884600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884626 */     // MIs[0] policy
     /* 1884626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1884639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884663 */     // GIR_Coverage, 14612,
     /* 1884663 */     GIR_EraseRootFromParent_Done,
     /* 1884664 */   // Label 25411: @1884664
     /* 1884664 */   GIM_Try, /*On fail goto*//*Label 25412*/ GIMT_Encode4(1884753), // Rule ID 14613 //
     /* 1884669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1884672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1884680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1884683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1884686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1884689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884715 */     // MIs[0] policy
     /* 1884715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884725 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1884728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884752 */     // GIR_Coverage, 14613,
     /* 1884752 */     GIR_EraseRootFromParent_Done,
     /* 1884753 */   // Label 25412: @1884753
     /* 1884753 */   GIM_Try, /*On fail goto*//*Label 25413*/ GIMT_Encode4(1884842), // Rule ID 14616 //
     /* 1884758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1884769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1884772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1884775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1884778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1884781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1884788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884804 */     // MIs[0] policy
     /* 1884804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884814 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1884817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884841 */     // GIR_Coverage, 14616,
     /* 1884841 */     GIR_EraseRootFromParent_Done,
     /* 1884842 */   // Label 25413: @1884842
     /* 1884842 */   GIM_Try, /*On fail goto*//*Label 25414*/ GIMT_Encode4(1884931), // Rule ID 14617 //
     /* 1884847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1884858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1884861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1884864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1884867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1884870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1884877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884893 */     // MIs[0] policy
     /* 1884893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884903 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1884906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884930 */     // GIR_Coverage, 14617,
     /* 1884930 */     GIR_EraseRootFromParent_Done,
     /* 1884931 */   // Label 25414: @1884931
     /* 1884931 */   GIM_Try, /*On fail goto*//*Label 25415*/ GIMT_Encode4(1885020), // Rule ID 14620 //
     /* 1884936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1884947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1884950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1884953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1884956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1884959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1884966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1884970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1884974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1884978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884982 */     // MIs[0] policy
     /* 1884982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884992 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1884995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885019 */     // GIR_Coverage, 14620,
     /* 1885019 */     GIR_EraseRootFromParent_Done,
     /* 1885020 */   // Label 25415: @1885020
     /* 1885020 */   GIM_Try, /*On fail goto*//*Label 25416*/ GIMT_Encode4(1885109), // Rule ID 14621 //
     /* 1885025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1885036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1885039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1885042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1885045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885071 */     // MIs[0] policy
     /* 1885071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885081 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1885084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885108 */     // GIR_Coverage, 14621,
     /* 1885108 */     GIR_EraseRootFromParent_Done,
     /* 1885109 */   // Label 25416: @1885109
     /* 1885109 */   GIM_Try, /*On fail goto*//*Label 25417*/ GIMT_Encode4(1885198), // Rule ID 14624 //
     /* 1885114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1885125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1885128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1885131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1885134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1885137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885160 */     // MIs[0] policy
     /* 1885160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885170 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1885173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885197 */     // GIR_Coverage, 14624,
     /* 1885197 */     GIR_EraseRootFromParent_Done,
     /* 1885198 */   // Label 25417: @1885198
     /* 1885198 */   GIM_Try, /*On fail goto*//*Label 25418*/ GIMT_Encode4(1885287), // Rule ID 14625 //
     /* 1885203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1885214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1885217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1885220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1885223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1885226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885249 */     // MIs[0] policy
     /* 1885249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885259 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1885262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885286 */     // GIR_Coverage, 14625,
     /* 1885286 */     GIR_EraseRootFromParent_Done,
     /* 1885287 */   // Label 25418: @1885287
     /* 1885287 */   GIM_Try, /*On fail goto*//*Label 25419*/ GIMT_Encode4(1885376), // Rule ID 14628 //
     /* 1885292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1885303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1885306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1885309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1885312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885338 */     // MIs[0] policy
     /* 1885338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1885351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885375 */     // GIR_Coverage, 14628,
     /* 1885375 */     GIR_EraseRootFromParent_Done,
     /* 1885376 */   // Label 25419: @1885376
     /* 1885376 */   GIM_Try, /*On fail goto*//*Label 25420*/ GIMT_Encode4(1885465), // Rule ID 14629 //
     /* 1885381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1885392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1885395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1885398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1885401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885427 */     // MIs[0] policy
     /* 1885427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885437 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1885440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885464 */     // GIR_Coverage, 14629,
     /* 1885464 */     GIR_EraseRootFromParent_Done,
     /* 1885465 */   // Label 25420: @1885465
     /* 1885465 */   GIM_Try, /*On fail goto*//*Label 25421*/ GIMT_Encode4(1885554), // Rule ID 14632 //
     /* 1885470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1885481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1885484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1885487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1885490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1885493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885516 */     // MIs[0] policy
     /* 1885516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885526 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1885529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885553 */     // GIR_Coverage, 14632,
     /* 1885553 */     GIR_EraseRootFromParent_Done,
     /* 1885554 */   // Label 25421: @1885554
     /* 1885554 */   GIM_Try, /*On fail goto*//*Label 25422*/ GIMT_Encode4(1885643), // Rule ID 14633 //
     /* 1885559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1885570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1885573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1885576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1885579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1885582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885605 */     // MIs[0] policy
     /* 1885605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885615 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1885618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885642 */     // GIR_Coverage, 14633,
     /* 1885642 */     GIR_EraseRootFromParent_Done,
     /* 1885643 */   // Label 25422: @1885643
     /* 1885643 */   GIM_Try, /*On fail goto*//*Label 25423*/ GIMT_Encode4(1885732), // Rule ID 14636 //
     /* 1885648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1885659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1885662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1885665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1885668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885694 */     // MIs[0] policy
     /* 1885694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885704 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1885707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885731 */     // GIR_Coverage, 14636,
     /* 1885731 */     GIR_EraseRootFromParent_Done,
     /* 1885732 */   // Label 25423: @1885732
     /* 1885732 */   GIM_Try, /*On fail goto*//*Label 25424*/ GIMT_Encode4(1885821), // Rule ID 14637 //
     /* 1885737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1885748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1885751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1885754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1885757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885783 */     // MIs[0] policy
     /* 1885783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885793 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1885796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885820 */     // GIR_Coverage, 14637,
     /* 1885820 */     GIR_EraseRootFromParent_Done,
     /* 1885821 */   // Label 25424: @1885821
     /* 1885821 */   GIM_Try, /*On fail goto*//*Label 25425*/ GIMT_Encode4(1885910), // Rule ID 14640 //
     /* 1885826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1885837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1885840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1885843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1885846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1885849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885872 */     // MIs[0] policy
     /* 1885872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885882 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1885885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885909 */     // GIR_Coverage, 14640,
     /* 1885909 */     GIR_EraseRootFromParent_Done,
     /* 1885910 */   // Label 25425: @1885910
     /* 1885910 */   GIM_Try, /*On fail goto*//*Label 25426*/ GIMT_Encode4(1885999), // Rule ID 14641 //
     /* 1885915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1885926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1885929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1885932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1885935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1885938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885961 */     // MIs[0] policy
     /* 1885961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1885974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885998 */     // GIR_Coverage, 14641,
     /* 1885998 */     GIR_EraseRootFromParent_Done,
     /* 1885999 */   // Label 25426: @1885999
     /* 1885999 */   GIM_Try, /*On fail goto*//*Label 25427*/ GIMT_Encode4(1886088), // Rule ID 14644 //
     /* 1886004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1886015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1886018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1886021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1886024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886050 */     // MIs[0] policy
     /* 1886050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886060 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1886063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886087 */     // GIR_Coverage, 14644,
     /* 1886087 */     GIR_EraseRootFromParent_Done,
     /* 1886088 */   // Label 25427: @1886088
     /* 1886088 */   GIM_Try, /*On fail goto*//*Label 25428*/ GIMT_Encode4(1886177), // Rule ID 14645 //
     /* 1886093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1886104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1886107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1886110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1886113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886139 */     // MIs[0] policy
     /* 1886139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886149 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1886152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886176 */     // GIR_Coverage, 14645,
     /* 1886176 */     GIR_EraseRootFromParent_Done,
     /* 1886177 */   // Label 25428: @1886177
     /* 1886177 */   GIM_Try, /*On fail goto*//*Label 25429*/ GIMT_Encode4(1886266), // Rule ID 14648 //
     /* 1886182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1886193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1886196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1886199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1886202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886228 */     // MIs[0] policy
     /* 1886228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886238 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1886241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886265 */     // GIR_Coverage, 14648,
     /* 1886265 */     GIR_EraseRootFromParent_Done,
     /* 1886266 */   // Label 25429: @1886266
     /* 1886266 */   GIM_Try, /*On fail goto*//*Label 25430*/ GIMT_Encode4(1886355), // Rule ID 14649 //
     /* 1886271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1886282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1886285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1886288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1886291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886317 */     // MIs[0] policy
     /* 1886317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886327 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1886330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886354 */     // GIR_Coverage, 14649,
     /* 1886354 */     GIR_EraseRootFromParent_Done,
     /* 1886355 */   // Label 25430: @1886355
     /* 1886355 */   GIM_Try, /*On fail goto*//*Label 25431*/ GIMT_Encode4(1886444), // Rule ID 14652 //
     /* 1886360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1886363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1886371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1886374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1886377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1886380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1886383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886406 */     // MIs[0] policy
     /* 1886406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1886419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886443 */     // GIR_Coverage, 14652,
     /* 1886443 */     GIR_EraseRootFromParent_Done,
     /* 1886444 */   // Label 25431: @1886444
     /* 1886444 */   GIM_Try, /*On fail goto*//*Label 25432*/ GIMT_Encode4(1886533), // Rule ID 14653 //
     /* 1886449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1886452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1886460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1886463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1886466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1886469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1886472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886495 */     // MIs[0] policy
     /* 1886495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1886508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886532 */     // GIR_Coverage, 14653,
     /* 1886532 */     GIR_EraseRootFromParent_Done,
     /* 1886533 */   // Label 25432: @1886533
     /* 1886533 */   GIM_Try, /*On fail goto*//*Label 25433*/ GIMT_Encode4(1886622), // Rule ID 14656 //
     /* 1886538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1886541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1886549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1886552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1886555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1886558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886584 */     // MIs[0] policy
     /* 1886584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886594 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1886597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886621 */     // GIR_Coverage, 14656,
     /* 1886621 */     GIR_EraseRootFromParent_Done,
     /* 1886622 */   // Label 25433: @1886622
     /* 1886622 */   GIM_Try, /*On fail goto*//*Label 25434*/ GIMT_Encode4(1886711), // Rule ID 14657 //
     /* 1886627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1886630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1886638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1886641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1886644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1886647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886673 */     // MIs[0] policy
     /* 1886673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886683 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1886686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886710 */     // GIR_Coverage, 14657,
     /* 1886710 */     GIR_EraseRootFromParent_Done,
     /* 1886711 */   // Label 25434: @1886711
     /* 1886711 */   GIM_Try, /*On fail goto*//*Label 25435*/ GIMT_Encode4(1886800), // Rule ID 14660 //
     /* 1886716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1886719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1886727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1886730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1886733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1886736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886762 */     // MIs[0] policy
     /* 1886762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886772 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1886775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886799 */     // GIR_Coverage, 14660,
     /* 1886799 */     GIR_EraseRootFromParent_Done,
     /* 1886800 */   // Label 25435: @1886800
     /* 1886800 */   GIM_Try, /*On fail goto*//*Label 25436*/ GIMT_Encode4(1886889), // Rule ID 14661 //
     /* 1886805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1886808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1886816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1886819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1886822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1886825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886851 */     // MIs[0] policy
     /* 1886851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886861 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1886864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886888 */     // GIR_Coverage, 14661,
     /* 1886888 */     GIR_EraseRootFromParent_Done,
     /* 1886889 */   // Label 25436: @1886889
     /* 1886889 */   GIM_Try, /*On fail goto*//*Label 25437*/ GIMT_Encode4(1886978), // Rule ID 14664 //
     /* 1886894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1886905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1886908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1886911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1886917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1886924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886940 */     // MIs[0] policy
     /* 1886940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886950 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1886953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1886971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886977 */     // GIR_Coverage, 14664,
     /* 1886977 */     GIR_EraseRootFromParent_Done,
     /* 1886978 */   // Label 25437: @1886978
     /* 1886978 */   GIM_Try, /*On fail goto*//*Label 25438*/ GIMT_Encode4(1887067), // Rule ID 14665 //
     /* 1886983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1886994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1886997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1887000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887029 */     // MIs[0] policy
     /* 1887029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887039 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1887042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887066 */     // GIR_Coverage, 14665,
     /* 1887066 */     GIR_EraseRootFromParent_Done,
     /* 1887067 */   // Label 25438: @1887067
     /* 1887067 */   GIM_Try, /*On fail goto*//*Label 25439*/ GIMT_Encode4(1887156), // Rule ID 14668 //
     /* 1887072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1887083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1887086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1887089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887118 */     // MIs[0] policy
     /* 1887118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887128 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1887131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887155 */     // GIR_Coverage, 14668,
     /* 1887155 */     GIR_EraseRootFromParent_Done,
     /* 1887156 */   // Label 25439: @1887156
     /* 1887156 */   GIM_Try, /*On fail goto*//*Label 25440*/ GIMT_Encode4(1887245), // Rule ID 14669 //
     /* 1887161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1887172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1887175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1887178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887207 */     // MIs[0] policy
     /* 1887207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887217 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1887220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887244 */     // GIR_Coverage, 14669,
     /* 1887244 */     GIR_EraseRootFromParent_Done,
     /* 1887245 */   // Label 25440: @1887245
     /* 1887245 */   GIM_Try, /*On fail goto*//*Label 25441*/ GIMT_Encode4(1887334), // Rule ID 14672 //
     /* 1887250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1887261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1887264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1887267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887296 */     // MIs[0] policy
     /* 1887296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887306 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1887309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887333 */     // GIR_Coverage, 14672,
     /* 1887333 */     GIR_EraseRootFromParent_Done,
     /* 1887334 */   // Label 25441: @1887334
     /* 1887334 */   GIM_Try, /*On fail goto*//*Label 25442*/ GIMT_Encode4(1887423), // Rule ID 14673 //
     /* 1887339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1887350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1887353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1887356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887385 */     // MIs[0] policy
     /* 1887385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887395 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1887398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887422 */     // GIR_Coverage, 14673,
     /* 1887422 */     GIR_EraseRootFromParent_Done,
     /* 1887423 */   // Label 25442: @1887423
     /* 1887423 */   GIM_Try, /*On fail goto*//*Label 25443*/ GIMT_Encode4(1887512), // Rule ID 14676 //
     /* 1887428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1887439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1887442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1887445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887474 */     // MIs[0] policy
     /* 1887474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1887487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887511 */     // GIR_Coverage, 14676,
     /* 1887511 */     GIR_EraseRootFromParent_Done,
     /* 1887512 */   // Label 25443: @1887512
     /* 1887512 */   GIM_Try, /*On fail goto*//*Label 25444*/ GIMT_Encode4(1887601), // Rule ID 14677 //
     /* 1887517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1887528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1887531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1887534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887563 */     // MIs[0] policy
     /* 1887563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887573 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1887576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887600 */     // GIR_Coverage, 14677,
     /* 1887600 */     GIR_EraseRootFromParent_Done,
     /* 1887601 */   // Label 25444: @1887601
     /* 1887601 */   GIM_Try, /*On fail goto*//*Label 25445*/ GIMT_Encode4(1887690), // Rule ID 14680 //
     /* 1887606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1887617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1887620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1887623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887652 */     // MIs[0] policy
     /* 1887652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887662 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1887665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887689 */     // GIR_Coverage, 14680,
     /* 1887689 */     GIR_EraseRootFromParent_Done,
     /* 1887690 */   // Label 25445: @1887690
     /* 1887690 */   GIM_Try, /*On fail goto*//*Label 25446*/ GIMT_Encode4(1887779), // Rule ID 14681 //
     /* 1887695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1887706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1887709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1887712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887741 */     // MIs[0] policy
     /* 1887741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887751 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1887754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887778 */     // GIR_Coverage, 14681,
     /* 1887778 */     GIR_EraseRootFromParent_Done,
     /* 1887779 */   // Label 25446: @1887779
     /* 1887779 */   GIM_Try, /*On fail goto*//*Label 25447*/ GIMT_Encode4(1887868), // Rule ID 14684 //
     /* 1887784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1887795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1887798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1887801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887830 */     // MIs[0] policy
     /* 1887830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1887843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887867 */     // GIR_Coverage, 14684,
     /* 1887867 */     GIR_EraseRootFromParent_Done,
     /* 1887868 */   // Label 25447: @1887868
     /* 1887868 */   GIM_Try, /*On fail goto*//*Label 25448*/ GIMT_Encode4(1887957), // Rule ID 14685 //
     /* 1887873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1887884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1887887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1887890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887919 */     // MIs[0] policy
     /* 1887919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887929 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1887932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887956 */     // GIR_Coverage, 14685,
     /* 1887956 */     GIR_EraseRootFromParent_Done,
     /* 1887957 */   // Label 25448: @1887957
     /* 1887957 */   GIM_Try, /*On fail goto*//*Label 25449*/ GIMT_Encode4(1888046), // Rule ID 14688 //
     /* 1887962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1887973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1887976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1887979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1887985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888008 */     // MIs[0] policy
     /* 1888008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888018 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1888021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888045 */     // GIR_Coverage, 14688,
     /* 1888045 */     GIR_EraseRootFromParent_Done,
     /* 1888046 */   // Label 25449: @1888046
     /* 1888046 */   GIM_Try, /*On fail goto*//*Label 25450*/ GIMT_Encode4(1888135), // Rule ID 14689 //
     /* 1888051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1888059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1888062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1888065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1888068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1888071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888097 */     // MIs[0] policy
     /* 1888097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888107 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11597:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1888110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888134 */     // GIR_Coverage, 14689,
     /* 1888134 */     GIR_EraseRootFromParent_Done,
     /* 1888135 */   // Label 25450: @1888135
     /* 1888135 */   GIM_Try, /*On fail goto*//*Label 25451*/ GIMT_Encode4(1888224), // Rule ID 14692 //
     /* 1888140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1888148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1888160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888186 */     // MIs[0] policy
     /* 1888186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888196 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1888199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888223 */     // GIR_Coverage, 14692,
     /* 1888223 */     GIR_EraseRootFromParent_Done,
     /* 1888224 */   // Label 25451: @1888224
     /* 1888224 */   GIM_Try, /*On fail goto*//*Label 25452*/ GIMT_Encode4(1888313), // Rule ID 14693 //
     /* 1888229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1888237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1888249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888275 */     // MIs[0] policy
     /* 1888275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888285 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1888288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888312 */     // GIR_Coverage, 14693,
     /* 1888312 */     GIR_EraseRootFromParent_Done,
     /* 1888313 */   // Label 25452: @1888313
     /* 1888313 */   GIM_Try, /*On fail goto*//*Label 25453*/ GIMT_Encode4(1888402), // Rule ID 14696 //
     /* 1888318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1888326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1888329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1888332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1888335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1888338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888364 */     // MIs[0] policy
     /* 1888364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888374 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1888377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888401 */     // GIR_Coverage, 14696,
     /* 1888401 */     GIR_EraseRootFromParent_Done,
     /* 1888402 */   // Label 25453: @1888402
     /* 1888402 */   GIM_Try, /*On fail goto*//*Label 25454*/ GIMT_Encode4(1888491), // Rule ID 14697 //
     /* 1888407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1888415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1888418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1888421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1888424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1888427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888453 */     // MIs[0] policy
     /* 1888453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888463 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1888466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888490 */     // GIR_Coverage, 14697,
     /* 1888490 */     GIR_EraseRootFromParent_Done,
     /* 1888491 */   // Label 25454: @1888491
     /* 1888491 */   GIM_Try, /*On fail goto*//*Label 25455*/ GIMT_Encode4(1888580), // Rule ID 14700 //
     /* 1888496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1888499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1888504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1888507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1888510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1888513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1888516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888542 */     // MIs[0] policy
     /* 1888542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888552 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1888555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888579 */     // GIR_Coverage, 14700,
     /* 1888579 */     GIR_EraseRootFromParent_Done,
     /* 1888580 */   // Label 25455: @1888580
     /* 1888580 */   GIM_Try, /*On fail goto*//*Label 25456*/ GIMT_Encode4(1888669), // Rule ID 14701 //
     /* 1888585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1888588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1888593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1888596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1888599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1888602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1888605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888631 */     // MIs[0] policy
     /* 1888631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888641 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1888644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888668 */     // GIR_Coverage, 14701,
     /* 1888668 */     GIR_EraseRootFromParent_Done,
     /* 1888669 */   // Label 25456: @1888669
     /* 1888669 */   GIM_Try, /*On fail goto*//*Label 25457*/ GIMT_Encode4(1888758), // Rule ID 14704 //
     /* 1888674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1888682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1888685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1888688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1888691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1888694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1888697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1888704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888720 */     // MIs[0] policy
     /* 1888720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888730 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1888733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888757 */     // GIR_Coverage, 14704,
     /* 1888757 */     GIR_EraseRootFromParent_Done,
     /* 1888758 */   // Label 25457: @1888758
     /* 1888758 */   GIM_Try, /*On fail goto*//*Label 25458*/ GIMT_Encode4(1888847), // Rule ID 14705 //
     /* 1888763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1888771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1888774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1888777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1888780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1888783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1888786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1888793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888809 */     // MIs[0] policy
     /* 1888809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888819 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1888822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888846 */     // GIR_Coverage, 14705,
     /* 1888846 */     GIR_EraseRootFromParent_Done,
     /* 1888847 */   // Label 25458: @1888847
     /* 1888847 */   GIM_Try, /*On fail goto*//*Label 25459*/ GIMT_Encode4(1888936), // Rule ID 14708 //
     /* 1888852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1888860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1888863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1888866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1888869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1888872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1888875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1888882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888898 */     // MIs[0] policy
     /* 1888898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888908 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1888911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888935 */     // GIR_Coverage, 14708,
     /* 1888935 */     GIR_EraseRootFromParent_Done,
     /* 1888936 */   // Label 25459: @1888936
     /* 1888936 */   GIM_Try, /*On fail goto*//*Label 25460*/ GIMT_Encode4(1889025), // Rule ID 14709 //
     /* 1888941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1888949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1888952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1888955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1888958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1888961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1888964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1888971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888987 */     // MIs[0] policy
     /* 1888987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888997 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1889000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889024 */     // GIR_Coverage, 14709,
     /* 1889024 */     GIR_EraseRootFromParent_Done,
     /* 1889025 */   // Label 25460: @1889025
     /* 1889025 */   GIM_Try, /*On fail goto*//*Label 25461*/ GIMT_Encode4(1889114), // Rule ID 14712 //
     /* 1889030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1889038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1889041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1889044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1889047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1889050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1889053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889076 */     // MIs[0] policy
     /* 1889076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889086 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1889089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889113 */     // GIR_Coverage, 14712,
     /* 1889113 */     GIR_EraseRootFromParent_Done,
     /* 1889114 */   // Label 25461: @1889114
     /* 1889114 */   GIM_Try, /*On fail goto*//*Label 25462*/ GIMT_Encode4(1889203), // Rule ID 14713 //
     /* 1889119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1889127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1889130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1889133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1889136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1889139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1889142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889165 */     // MIs[0] policy
     /* 1889165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889175 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1889178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889202 */     // GIR_Coverage, 14713,
     /* 1889202 */     GIR_EraseRootFromParent_Done,
     /* 1889203 */   // Label 25462: @1889203
     /* 1889203 */   GIM_Try, /*On fail goto*//*Label 25463*/ GIMT_Encode4(1889292), // Rule ID 14716 //
     /* 1889208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1889216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1889228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889254 */     // MIs[0] policy
     /* 1889254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889264 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1889267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889291 */     // GIR_Coverage, 14716,
     /* 1889291 */     GIR_EraseRootFromParent_Done,
     /* 1889292 */   // Label 25463: @1889292
     /* 1889292 */   GIM_Try, /*On fail goto*//*Label 25464*/ GIMT_Encode4(1889381), // Rule ID 14717 //
     /* 1889297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1889305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1889317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889343 */     // MIs[0] policy
     /* 1889343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1889356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889380 */     // GIR_Coverage, 14717,
     /* 1889380 */     GIR_EraseRootFromParent_Done,
     /* 1889381 */   // Label 25464: @1889381
     /* 1889381 */   GIM_Try, /*On fail goto*//*Label 25465*/ GIMT_Encode4(1889470), // Rule ID 14720 //
     /* 1889386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1889394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1889397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1889400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1889403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1889406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889432 */     // MIs[0] policy
     /* 1889432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889442 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1889445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889469 */     // GIR_Coverage, 14720,
     /* 1889469 */     GIR_EraseRootFromParent_Done,
     /* 1889470 */   // Label 25465: @1889470
     /* 1889470 */   GIM_Try, /*On fail goto*//*Label 25466*/ GIMT_Encode4(1889559), // Rule ID 14721 //
     /* 1889475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1889483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1889486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1889489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1889492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1889495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889521 */     // MIs[0] policy
     /* 1889521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889531 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1889534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889558 */     // GIR_Coverage, 14721,
     /* 1889558 */     GIR_EraseRootFromParent_Done,
     /* 1889559 */   // Label 25466: @1889559
     /* 1889559 */   GIM_Try, /*On fail goto*//*Label 25467*/ GIMT_Encode4(1889648), // Rule ID 14724 //
     /* 1889564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1889572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1889575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1889578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1889581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1889584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889610 */     // MIs[0] policy
     /* 1889610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889620 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1889623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889647 */     // GIR_Coverage, 14724,
     /* 1889647 */     GIR_EraseRootFromParent_Done,
     /* 1889648 */   // Label 25467: @1889648
     /* 1889648 */   GIM_Try, /*On fail goto*//*Label 25468*/ GIMT_Encode4(1889737), // Rule ID 14725 //
     /* 1889653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1889661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1889664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1889667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1889670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1889673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889699 */     // MIs[0] policy
     /* 1889699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889709 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1889712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889736 */     // GIR_Coverage, 14725,
     /* 1889736 */     GIR_EraseRootFromParent_Done,
     /* 1889737 */   // Label 25468: @1889737
     /* 1889737 */   GIM_Try, /*On fail goto*//*Label 25469*/ GIMT_Encode4(1889826), // Rule ID 14728 //
     /* 1889742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1889750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1889753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1889756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1889759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1889762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1889765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889788 */     // MIs[0] policy
     /* 1889788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1889801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889825 */     // GIR_Coverage, 14728,
     /* 1889825 */     GIR_EraseRootFromParent_Done,
     /* 1889826 */   // Label 25469: @1889826
     /* 1889826 */   GIM_Try, /*On fail goto*//*Label 25470*/ GIMT_Encode4(1889915), // Rule ID 14729 //
     /* 1889831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1889839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1889842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1889845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1889848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1889851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1889854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889877 */     // MIs[0] policy
     /* 1889877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1889890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889914 */     // GIR_Coverage, 14729,
     /* 1889914 */     GIR_EraseRootFromParent_Done,
     /* 1889915 */   // Label 25470: @1889915
     /* 1889915 */   GIM_Try, /*On fail goto*//*Label 25471*/ GIMT_Encode4(1890004), // Rule ID 14732 //
     /* 1889920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1889928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1889931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1889934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1889937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1889940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889966 */     // MIs[0] policy
     /* 1889966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1889979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890003 */     // GIR_Coverage, 14732,
     /* 1890003 */     GIR_EraseRootFromParent_Done,
     /* 1890004 */   // Label 25471: @1890004
     /* 1890004 */   GIM_Try, /*On fail goto*//*Label 25472*/ GIMT_Encode4(1890093), // Rule ID 14733 //
     /* 1890009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1890017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1890020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1890023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1890026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1890029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890055 */     // MIs[0] policy
     /* 1890055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890065 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1890068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890092 */     // GIR_Coverage, 14733,
     /* 1890092 */     GIR_EraseRootFromParent_Done,
     /* 1890093 */   // Label 25472: @1890093
     /* 1890093 */   GIM_Try, /*On fail goto*//*Label 25473*/ GIMT_Encode4(1890182), // Rule ID 14736 //
     /* 1890098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1890106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1890118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890144 */     // MIs[0] policy
     /* 1890144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890154 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1890157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890181 */     // GIR_Coverage, 14736,
     /* 1890181 */     GIR_EraseRootFromParent_Done,
     /* 1890182 */   // Label 25473: @1890182
     /* 1890182 */   GIM_Try, /*On fail goto*//*Label 25474*/ GIMT_Encode4(1890271), // Rule ID 14737 //
     /* 1890187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1890195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1890207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890233 */     // MIs[0] policy
     /* 1890233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890243 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1890246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890270 */     // GIR_Coverage, 14737,
     /* 1890270 */     GIR_EraseRootFromParent_Done,
     /* 1890271 */   // Label 25474: @1890271
     /* 1890271 */   GIM_Try, /*On fail goto*//*Label 25475*/ GIMT_Encode4(1890360), // Rule ID 14740 //
     /* 1890276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1890279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1890284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1890296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890322 */     // MIs[0] policy
     /* 1890322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1890335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890359 */     // GIR_Coverage, 14740,
     /* 1890359 */     GIR_EraseRootFromParent_Done,
     /* 1890360 */   // Label 25475: @1890360
     /* 1890360 */   GIM_Try, /*On fail goto*//*Label 25476*/ GIMT_Encode4(1890449), // Rule ID 14741 //
     /* 1890365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1890368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1890373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1890385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890411 */     // MIs[0] policy
     /* 1890411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1890424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890448 */     // GIR_Coverage, 14741,
     /* 1890448 */     GIR_EraseRootFromParent_Done,
     /* 1890449 */   // Label 25476: @1890449
     /* 1890449 */   GIM_Try, /*On fail goto*//*Label 25477*/ GIMT_Encode4(1890538), // Rule ID 14744 //
     /* 1890454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1890457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1890462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1890465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1890468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1890471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1890474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890500 */     // MIs[0] policy
     /* 1890500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890510 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1890513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890533 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890537 */     // GIR_Coverage, 14744,
     /* 1890537 */     GIR_EraseRootFromParent_Done,
     /* 1890538 */   // Label 25477: @1890538
     /* 1890538 */   GIM_Try, /*On fail goto*//*Label 25478*/ GIMT_Encode4(1890627), // Rule ID 14745 //
     /* 1890543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1890546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1890551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1890554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1890557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1890560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1890563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890589 */     // MIs[0] policy
     /* 1890589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890599 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1890602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890626 */     // GIR_Coverage, 14745,
     /* 1890626 */     GIR_EraseRootFromParent_Done,
     /* 1890627 */   // Label 25478: @1890627
     /* 1890627 */   GIM_Try, /*On fail goto*//*Label 25479*/ GIMT_Encode4(1890716), // Rule ID 14748 //
     /* 1890632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1890635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1890640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1890643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1890646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1890649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1890652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890678 */     // MIs[0] policy
     /* 1890678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890688 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1890691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890715 */     // GIR_Coverage, 14748,
     /* 1890715 */     GIR_EraseRootFromParent_Done,
     /* 1890716 */   // Label 25479: @1890716
     /* 1890716 */   GIM_Try, /*On fail goto*//*Label 25480*/ GIMT_Encode4(1890805), // Rule ID 14749 //
     /* 1890721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1890724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1890729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1890732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1890735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1890738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1890741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890767 */     // MIs[0] policy
     /* 1890767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890777 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1890780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890804 */     // GIR_Coverage, 14749,
     /* 1890804 */     GIR_EraseRootFromParent_Done,
     /* 1890805 */   // Label 25480: @1890805
     /* 1890805 */   GIM_Try, /*On fail goto*//*Label 25481*/ GIMT_Encode4(1890894), // Rule ID 14752 //
     /* 1890810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1890821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1890824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1890827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1890830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1890833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1890840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890856 */     // MIs[0] policy
     /* 1890856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890866 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1890869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1890887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890893 */     // GIR_Coverage, 14752,
     /* 1890893 */     GIR_EraseRootFromParent_Done,
     /* 1890894 */   // Label 25481: @1890894
     /* 1890894 */   GIM_Try, /*On fail goto*//*Label 25482*/ GIMT_Encode4(1890983), // Rule ID 14753 //
     /* 1890899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1890910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1890913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1890916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1890919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1890922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1890929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890945 */     // MIs[0] policy
     /* 1890945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890955 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1890958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1890976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890978 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890982 */     // GIR_Coverage, 14753,
     /* 1890982 */     GIR_EraseRootFromParent_Done,
     /* 1890983 */   // Label 25482: @1890983
     /* 1890983 */   GIM_Try, /*On fail goto*//*Label 25483*/ GIMT_Encode4(1891072), // Rule ID 14756 //
     /* 1890988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1890999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1891002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1891005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1891008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891034 */     // MIs[0] policy
     /* 1891034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891044 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1891047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891071 */     // GIR_Coverage, 14756,
     /* 1891071 */     GIR_EraseRootFromParent_Done,
     /* 1891072 */   // Label 25483: @1891072
     /* 1891072 */   GIM_Try, /*On fail goto*//*Label 25484*/ GIMT_Encode4(1891161), // Rule ID 14757 //
     /* 1891077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1891088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1891091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1891094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1891097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891123 */     // MIs[0] policy
     /* 1891123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891133 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1891136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891160 */     // GIR_Coverage, 14757,
     /* 1891160 */     GIR_EraseRootFromParent_Done,
     /* 1891161 */   // Label 25484: @1891161
     /* 1891161 */   GIM_Try, /*On fail goto*//*Label 25485*/ GIMT_Encode4(1891250), // Rule ID 14760 //
     /* 1891166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1891177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1891180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1891183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1891186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891212 */     // MIs[0] policy
     /* 1891212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891222 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1891225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891249 */     // GIR_Coverage, 14760,
     /* 1891249 */     GIR_EraseRootFromParent_Done,
     /* 1891250 */   // Label 25485: @1891250
     /* 1891250 */   GIM_Try, /*On fail goto*//*Label 25486*/ GIMT_Encode4(1891339), // Rule ID 14761 //
     /* 1891255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1891266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1891269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1891272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1891275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891301 */     // MIs[0] policy
     /* 1891301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891311 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1891314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891338 */     // GIR_Coverage, 14761,
     /* 1891338 */     GIR_EraseRootFromParent_Done,
     /* 1891339 */   // Label 25486: @1891339
     /* 1891339 */   GIM_Try, /*On fail goto*//*Label 25487*/ GIMT_Encode4(1891428), // Rule ID 14764 //
     /* 1891344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1891355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1891358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1891361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1891364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891390 */     // MIs[0] policy
     /* 1891390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891400 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1891403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891427 */     // GIR_Coverage, 14764,
     /* 1891427 */     GIR_EraseRootFromParent_Done,
     /* 1891428 */   // Label 25487: @1891428
     /* 1891428 */   GIM_Try, /*On fail goto*//*Label 25488*/ GIMT_Encode4(1891517), // Rule ID 14765 //
     /* 1891433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1891444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1891447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1891450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1891453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891479 */     // MIs[0] policy
     /* 1891479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891489 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1891492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891516 */     // GIR_Coverage, 14765,
     /* 1891516 */     GIR_EraseRootFromParent_Done,
     /* 1891517 */   // Label 25488: @1891517
     /* 1891517 */   GIM_Try, /*On fail goto*//*Label 25489*/ GIMT_Encode4(1891606), // Rule ID 14768 //
     /* 1891522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1891533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1891536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1891539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1891542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891568 */     // MIs[0] policy
     /* 1891568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891578 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1891581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891605 */     // GIR_Coverage, 14768,
     /* 1891605 */     GIR_EraseRootFromParent_Done,
     /* 1891606 */   // Label 25489: @1891606
     /* 1891606 */   GIM_Try, /*On fail goto*//*Label 25490*/ GIMT_Encode4(1891695), // Rule ID 14769 //
     /* 1891611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1891622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1891625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1891628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1891631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891657 */     // MIs[0] policy
     /* 1891657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891667 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1891670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891694 */     // GIR_Coverage, 14769,
     /* 1891694 */     GIR_EraseRootFromParent_Done,
     /* 1891695 */   // Label 25490: @1891695
     /* 1891695 */   GIM_Try, /*On fail goto*//*Label 25491*/ GIMT_Encode4(1891784), // Rule ID 14772 //
     /* 1891700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1891711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1891714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1891717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1891720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891746 */     // MIs[0] policy
     /* 1891746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891756 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1891759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891783 */     // GIR_Coverage, 14772,
     /* 1891783 */     GIR_EraseRootFromParent_Done,
     /* 1891784 */   // Label 25491: @1891784
     /* 1891784 */   GIM_Try, /*On fail goto*//*Label 25492*/ GIMT_Encode4(1891873), // Rule ID 14773 //
     /* 1891789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1891800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1891803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1891806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1891809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891835 */     // MIs[0] policy
     /* 1891835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891845 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1891848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891872 */     // GIR_Coverage, 14773,
     /* 1891872 */     GIR_EraseRootFromParent_Done,
     /* 1891873 */   // Label 25492: @1891873
     /* 1891873 */   GIM_Try, /*On fail goto*//*Label 25493*/ GIMT_Encode4(1891962), // Rule ID 14776 //
     /* 1891878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1891889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1891892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1891895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1891898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891924 */     // MIs[0] policy
     /* 1891924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891934 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1891937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891961 */     // GIR_Coverage, 14776,
     /* 1891961 */     GIR_EraseRootFromParent_Done,
     /* 1891962 */   // Label 25493: @1891962
     /* 1891962 */   GIM_Try, /*On fail goto*//*Label 25494*/ GIMT_Encode4(1892051), // Rule ID 14777 //
     /* 1891967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1891978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1891981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1891984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1891987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892013 */     // MIs[0] policy
     /* 1892013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892023 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1892026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892050 */     // GIR_Coverage, 14777,
     /* 1892050 */     GIR_EraseRootFromParent_Done,
     /* 1892051 */   // Label 25494: @1892051
     /* 1892051 */   GIM_Try, /*On fail goto*//*Label 25495*/ GIMT_Encode4(1892140), // Rule ID 14780 //
     /* 1892056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1892067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1892070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1892073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1892076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892102 */     // MIs[0] policy
     /* 1892102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892112 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1892115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892139 */     // GIR_Coverage, 14780,
     /* 1892139 */     GIR_EraseRootFromParent_Done,
     /* 1892140 */   // Label 25495: @1892140
     /* 1892140 */   GIM_Try, /*On fail goto*//*Label 25496*/ GIMT_Encode4(1892229), // Rule ID 14781 //
     /* 1892145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1892156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1892159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1892162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1892165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892191 */     // MIs[0] policy
     /* 1892191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892201 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1892204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892228 */     // GIR_Coverage, 14781,
     /* 1892228 */     GIR_EraseRootFromParent_Done,
     /* 1892229 */   // Label 25496: @1892229
     /* 1892229 */   GIM_Try, /*On fail goto*//*Label 25497*/ GIMT_Encode4(1892318), // Rule ID 14784 //
     /* 1892234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1892245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1892248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1892251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1892254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892280 */     // MIs[0] policy
     /* 1892280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892290 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1892293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892317 */     // GIR_Coverage, 14784,
     /* 1892317 */     GIR_EraseRootFromParent_Done,
     /* 1892318 */   // Label 25497: @1892318
     /* 1892318 */   GIM_Try, /*On fail goto*//*Label 25498*/ GIMT_Encode4(1892407), // Rule ID 14785 //
     /* 1892323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1892334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1892337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1892340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1892343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892369 */     // MIs[0] policy
     /* 1892369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892379 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1892382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892406 */     // GIR_Coverage, 14785,
     /* 1892406 */     GIR_EraseRootFromParent_Done,
     /* 1892407 */   // Label 25498: @1892407
     /* 1892407 */   GIM_Try, /*On fail goto*//*Label 25499*/ GIMT_Encode4(1892496), // Rule ID 14788 //
     /* 1892412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1892415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1892423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1892426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1892429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1892432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892458 */     // MIs[0] policy
     /* 1892458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892468 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1892471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892495 */     // GIR_Coverage, 14788,
     /* 1892495 */     GIR_EraseRootFromParent_Done,
     /* 1892496 */   // Label 25499: @1892496
     /* 1892496 */   GIM_Try, /*On fail goto*//*Label 25500*/ GIMT_Encode4(1892585), // Rule ID 14789 //
     /* 1892501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1892504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1892512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1892515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1892518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1892521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892547 */     // MIs[0] policy
     /* 1892547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892557 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1892560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892584 */     // GIR_Coverage, 14789,
     /* 1892584 */     GIR_EraseRootFromParent_Done,
     /* 1892585 */   // Label 25500: @1892585
     /* 1892585 */   GIM_Try, /*On fail goto*//*Label 25501*/ GIMT_Encode4(1892674), // Rule ID 14792 //
     /* 1892590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1892601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1892604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1892607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1892610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1892613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1892620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892636 */     // MIs[0] policy
     /* 1892636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892646 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1892649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892673 */     // GIR_Coverage, 14792,
     /* 1892673 */     GIR_EraseRootFromParent_Done,
     /* 1892674 */   // Label 25501: @1892674
     /* 1892674 */   GIM_Try, /*On fail goto*//*Label 25502*/ GIMT_Encode4(1892763), // Rule ID 14793 //
     /* 1892679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1892690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1892693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1892696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1892699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1892702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1892709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892725 */     // MIs[0] policy
     /* 1892725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892735 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1892738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892762 */     // GIR_Coverage, 14793,
     /* 1892762 */     GIR_EraseRootFromParent_Done,
     /* 1892763 */   // Label 25502: @1892763
     /* 1892763 */   GIM_Try, /*On fail goto*//*Label 25503*/ GIMT_Encode4(1892852), // Rule ID 14796 //
     /* 1892768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1892779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1892782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1892785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1892788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1892791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1892798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892814 */     // MIs[0] policy
     /* 1892814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892824 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1892827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892847 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892851 */     // GIR_Coverage, 14796,
     /* 1892851 */     GIR_EraseRootFromParent_Done,
     /* 1892852 */   // Label 25503: @1892852
     /* 1892852 */   GIM_Try, /*On fail goto*//*Label 25504*/ GIMT_Encode4(1892941), // Rule ID 14797 //
     /* 1892857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1892868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1892871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1892874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1892877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1892880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1892887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892903 */     // MIs[0] policy
     /* 1892903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892913 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1892916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892940 */     // GIR_Coverage, 14797,
     /* 1892940 */     GIR_EraseRootFromParent_Done,
     /* 1892941 */   // Label 25504: @1892941
     /* 1892941 */   GIM_Try, /*On fail goto*//*Label 25505*/ GIMT_Encode4(1893030), // Rule ID 14800 //
     /* 1892946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1892957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1892960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1892963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1892966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1892969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1892976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892992 */     // MIs[0] policy
     /* 1892992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893002 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1893005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893029 */     // GIR_Coverage, 14800,
     /* 1893029 */     GIR_EraseRootFromParent_Done,
     /* 1893030 */   // Label 25505: @1893030
     /* 1893030 */   GIM_Try, /*On fail goto*//*Label 25506*/ GIMT_Encode4(1893119), // Rule ID 14801 //
     /* 1893035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1893046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1893049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1893052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1893055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1893058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893081 */     // MIs[0] policy
     /* 1893081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893091 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1893094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893118 */     // GIR_Coverage, 14801,
     /* 1893118 */     GIR_EraseRootFromParent_Done,
     /* 1893119 */   // Label 25506: @1893119
     /* 1893119 */   GIM_Try, /*On fail goto*//*Label 25507*/ GIMT_Encode4(1893208), // Rule ID 14804 //
     /* 1893124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1893144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893170 */     // MIs[0] policy
     /* 1893170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893180 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1893183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893207 */     // GIR_Coverage, 14804,
     /* 1893207 */     GIR_EraseRootFromParent_Done,
     /* 1893208 */   // Label 25507: @1893208
     /* 1893208 */   GIM_Try, /*On fail goto*//*Label 25508*/ GIMT_Encode4(1893297), // Rule ID 14805 //
     /* 1893213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1893233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893259 */     // MIs[0] policy
     /* 1893259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1893272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893296 */     // GIR_Coverage, 14805,
     /* 1893296 */     GIR_EraseRootFromParent_Done,
     /* 1893297 */   // Label 25508: @1893297
     /* 1893297 */   GIM_Try, /*On fail goto*//*Label 25509*/ GIMT_Encode4(1893386), // Rule ID 14808 //
     /* 1893302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1893322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893348 */     // MIs[0] policy
     /* 1893348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893358 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1893361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893385 */     // GIR_Coverage, 14808,
     /* 1893385 */     GIR_EraseRootFromParent_Done,
     /* 1893386 */   // Label 25509: @1893386
     /* 1893386 */   GIM_Try, /*On fail goto*//*Label 25510*/ GIMT_Encode4(1893475), // Rule ID 14809 //
     /* 1893391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1893411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893437 */     // MIs[0] policy
     /* 1893437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893447 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1893450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893474 */     // GIR_Coverage, 14809,
     /* 1893474 */     GIR_EraseRootFromParent_Done,
     /* 1893475 */   // Label 25510: @1893475
     /* 1893475 */   GIM_Try, /*On fail goto*//*Label 25511*/ GIMT_Encode4(1893564), // Rule ID 14812 //
     /* 1893480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1893491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1893494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1893497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1893500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893526 */     // MIs[0] policy
     /* 1893526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893536 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1893539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893563 */     // GIR_Coverage, 14812,
     /* 1893563 */     GIR_EraseRootFromParent_Done,
     /* 1893564 */   // Label 25511: @1893564
     /* 1893564 */   GIM_Try, /*On fail goto*//*Label 25512*/ GIMT_Encode4(1893653), // Rule ID 14813 //
     /* 1893569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1893580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1893583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1893586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1893589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893615 */     // MIs[0] policy
     /* 1893615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893625 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1893628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893652 */     // GIR_Coverage, 14813,
     /* 1893652 */     GIR_EraseRootFromParent_Done,
     /* 1893653 */   // Label 25512: @1893653
     /* 1893653 */   GIM_Try, /*On fail goto*//*Label 25513*/ GIMT_Encode4(1893742), // Rule ID 14816 //
     /* 1893658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1893669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1893672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1893675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1893678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1893681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893704 */     // MIs[0] policy
     /* 1893704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893714 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1893717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893741 */     // GIR_Coverage, 14816,
     /* 1893741 */     GIR_EraseRootFromParent_Done,
     /* 1893742 */   // Label 25513: @1893742
     /* 1893742 */   GIM_Try, /*On fail goto*//*Label 25514*/ GIMT_Encode4(1893831), // Rule ID 14817 //
     /* 1893747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1893758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1893761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1893764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1893767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1893770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893793 */     // MIs[0] policy
     /* 1893793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1893806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893830 */     // GIR_Coverage, 14817,
     /* 1893830 */     GIR_EraseRootFromParent_Done,
     /* 1893831 */   // Label 25514: @1893831
     /* 1893831 */   GIM_Try, /*On fail goto*//*Label 25515*/ GIMT_Encode4(1893920), // Rule ID 14820 //
     /* 1893836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1893847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1893850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1893853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1893856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893882 */     // MIs[0] policy
     /* 1893882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893892 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1893895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893919 */     // GIR_Coverage, 14820,
     /* 1893919 */     GIR_EraseRootFromParent_Done,
     /* 1893920 */   // Label 25515: @1893920
     /* 1893920 */   GIM_Try, /*On fail goto*//*Label 25516*/ GIMT_Encode4(1894009), // Rule ID 14821 //
     /* 1893925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1893936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1893939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1893942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1893945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893971 */     // MIs[0] policy
     /* 1893971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893981 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1893984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894008 */     // GIR_Coverage, 14821,
     /* 1894008 */     GIR_EraseRootFromParent_Done,
     /* 1894009 */   // Label 25516: @1894009
     /* 1894009 */   GIM_Try, /*On fail goto*//*Label 25517*/ GIMT_Encode4(1894098), // Rule ID 14824 //
     /* 1894014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1894017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1894034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894060 */     // MIs[0] policy
     /* 1894060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894070 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1894073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894097 */     // GIR_Coverage, 14824,
     /* 1894097 */     GIR_EraseRootFromParent_Done,
     /* 1894098 */   // Label 25517: @1894098
     /* 1894098 */   GIM_Try, /*On fail goto*//*Label 25518*/ GIMT_Encode4(1894187), // Rule ID 14825 //
     /* 1894103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1894123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894149 */     // MIs[0] policy
     /* 1894149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894159 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1894162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894186 */     // GIR_Coverage, 14825,
     /* 1894186 */     GIR_EraseRootFromParent_Done,
     /* 1894187 */   // Label 25518: @1894187
     /* 1894187 */   GIM_Try, /*On fail goto*//*Label 25519*/ GIMT_Encode4(1894276), // Rule ID 14828 //
     /* 1894192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1894195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1894212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894238 */     // MIs[0] policy
     /* 1894238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894248 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1894251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894275 */     // GIR_Coverage, 14828,
     /* 1894275 */     GIR_EraseRootFromParent_Done,
     /* 1894276 */   // Label 25519: @1894276
     /* 1894276 */   GIM_Try, /*On fail goto*//*Label 25520*/ GIMT_Encode4(1894365), // Rule ID 14829 //
     /* 1894281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1894284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1894301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894327 */     // MIs[0] policy
     /* 1894327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894337 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1894340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894364 */     // GIR_Coverage, 14829,
     /* 1894364 */     GIR_EraseRootFromParent_Done,
     /* 1894365 */   // Label 25520: @1894365
     /* 1894365 */   GIM_Try, /*On fail goto*//*Label 25521*/ GIMT_Encode4(1894454), // Rule ID 14832 //
     /* 1894370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1894373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1894381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1894384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1894387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1894390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894416 */     // MIs[0] policy
     /* 1894416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894426 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1894429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894453 */     // GIR_Coverage, 14832,
     /* 1894453 */     GIR_EraseRootFromParent_Done,
     /* 1894454 */   // Label 25521: @1894454
     /* 1894454 */   GIM_Try, /*On fail goto*//*Label 25522*/ GIMT_Encode4(1894543), // Rule ID 14833 //
     /* 1894459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1894462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1894470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1894473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1894476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1894479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894505 */     // MIs[0] policy
     /* 1894505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894515 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1894518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894542 */     // GIR_Coverage, 14833,
     /* 1894542 */     GIR_EraseRootFromParent_Done,
     /* 1894543 */   // Label 25522: @1894543
     /* 1894543 */   GIM_Try, /*On fail goto*//*Label 25523*/ GIMT_Encode4(1894632), // Rule ID 14836 //
     /* 1894548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1894551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1894559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1894562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1894565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1894568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894594 */     // MIs[0] policy
     /* 1894594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894604 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1894607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894631 */     // GIR_Coverage, 14836,
     /* 1894631 */     GIR_EraseRootFromParent_Done,
     /* 1894632 */   // Label 25523: @1894632
     /* 1894632 */   GIM_Try, /*On fail goto*//*Label 25524*/ GIMT_Encode4(1894721), // Rule ID 14837 //
     /* 1894637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1894640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1894648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1894651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1894654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1894657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894683 */     // MIs[0] policy
     /* 1894683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894693 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1894696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894720 */     // GIR_Coverage, 14837,
     /* 1894720 */     GIR_EraseRootFromParent_Done,
     /* 1894721 */   // Label 25524: @1894721
     /* 1894721 */   GIM_Try, /*On fail goto*//*Label 25525*/ GIMT_Encode4(1894810), // Rule ID 14840 //
     /* 1894726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1894729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1894737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1894740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1894743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1894749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1894756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894772 */     // MIs[0] policy
     /* 1894772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894782 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1894785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1894803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894809 */     // GIR_Coverage, 14840,
     /* 1894809 */     GIR_EraseRootFromParent_Done,
     /* 1894810 */   // Label 25525: @1894810
     /* 1894810 */   GIM_Try, /*On fail goto*//*Label 25526*/ GIMT_Encode4(1894899), // Rule ID 14841 //
     /* 1894815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1894826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1894829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1894832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1894838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1894845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894861 */     // MIs[0] policy
     /* 1894861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894871 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1894874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1894892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894898 */     // GIR_Coverage, 14841,
     /* 1894898 */     GIR_EraseRootFromParent_Done,
     /* 1894899 */   // Label 25526: @1894899
     /* 1894899 */   GIM_Try, /*On fail goto*//*Label 25527*/ GIMT_Encode4(1894988), // Rule ID 14844 //
     /* 1894904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1894907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1894915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1894918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1894921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1894934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894950 */     // MIs[0] policy
     /* 1894950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894960 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1894963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1894981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894987 */     // GIR_Coverage, 14844,
     /* 1894987 */     GIR_EraseRootFromParent_Done,
     /* 1894988 */   // Label 25527: @1894988
     /* 1894988 */   GIM_Try, /*On fail goto*//*Label 25528*/ GIMT_Encode4(1895077), // Rule ID 14845 //
     /* 1894993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1895004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1895007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1895010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895039 */     // MIs[0] policy
     /* 1895039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895049 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1895052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1895070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895076 */     // GIR_Coverage, 14845,
     /* 1895076 */     GIR_EraseRootFromParent_Done,
     /* 1895077 */   // Label 25528: @1895077
     /* 1895077 */   GIM_Try, /*On fail goto*//*Label 25529*/ GIMT_Encode4(1895166), // Rule ID 14848 //
     /* 1895082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1895085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1895093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1895096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1895099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1895102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895128 */     // MIs[0] policy
     /* 1895128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895138 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1895141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1895159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895165 */     // GIR_Coverage, 14848,
     /* 1895165 */     GIR_EraseRootFromParent_Done,
     /* 1895166 */   // Label 25529: @1895166
     /* 1895166 */   GIM_Try, /*On fail goto*//*Label 25530*/ GIMT_Encode4(1895255), // Rule ID 14849 //
     /* 1895171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1895174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1895182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1895185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1895188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895217 */     // MIs[0] policy
     /* 1895217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895227 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1895230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1895248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895254 */     // GIR_Coverage, 14849,
     /* 1895254 */     GIR_EraseRootFromParent_Done,
     /* 1895255 */   // Label 25530: @1895255
     /* 1895255 */   GIM_Try, /*On fail goto*//*Label 25531*/ GIMT_Encode4(1895344), // Rule ID 14852 //
     /* 1895260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1895263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1895271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1895274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1895277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1895280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895306 */     // MIs[0] policy
     /* 1895306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895316 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1895319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895343 */     // GIR_Coverage, 14852,
     /* 1895343 */     GIR_EraseRootFromParent_Done,
     /* 1895344 */   // Label 25531: @1895344
     /* 1895344 */   GIM_Try, /*On fail goto*//*Label 25532*/ GIMT_Encode4(1895433), // Rule ID 14853 //
     /* 1895349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1895352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1895360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1895363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1895366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895395 */     // MIs[0] policy
     /* 1895395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895405 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1895408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895432 */     // GIR_Coverage, 14853,
     /* 1895432 */     GIR_EraseRootFromParent_Done,
     /* 1895433 */   // Label 25532: @1895433
     /* 1895433 */   GIM_Try, /*On fail goto*//*Label 25533*/ GIMT_Encode4(1895522), // Rule ID 14856 //
     /* 1895438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1895441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1895449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1895452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1895455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1895458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895484 */     // MIs[0] policy
     /* 1895484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895494 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1895497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895521 */     // GIR_Coverage, 14856,
     /* 1895521 */     GIR_EraseRootFromParent_Done,
     /* 1895522 */   // Label 25533: @1895522
     /* 1895522 */   GIM_Try, /*On fail goto*//*Label 25534*/ GIMT_Encode4(1895611), // Rule ID 14857 //
     /* 1895527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1895530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1895538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1895541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1895544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895573 */     // MIs[0] policy
     /* 1895573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895583 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1895586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895610 */     // GIR_Coverage, 14857,
     /* 1895610 */     GIR_EraseRootFromParent_Done,
     /* 1895611 */   // Label 25534: @1895611
     /* 1895611 */   GIM_Try, /*On fail goto*//*Label 25535*/ GIMT_Encode4(1895700), // Rule ID 14860 //
     /* 1895616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1895619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1895633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1895636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895662 */     // MIs[0] policy
     /* 1895662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1895675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895699 */     // GIR_Coverage, 14860,
     /* 1895699 */     GIR_EraseRootFromParent_Done,
     /* 1895700 */   // Label 25535: @1895700
     /* 1895700 */   GIM_Try, /*On fail goto*//*Label 25536*/ GIMT_Encode4(1895789), // Rule ID 14861 //
     /* 1895705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1895708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1895722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895751 */     // MIs[0] policy
     /* 1895751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895761 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1895764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895788 */     // GIR_Coverage, 14861,
     /* 1895788 */     GIR_EraseRootFromParent_Done,
     /* 1895789 */   // Label 25536: @1895789
     /* 1895789 */   GIM_Try, /*On fail goto*//*Label 25537*/ GIMT_Encode4(1895878), // Rule ID 14864 //
     /* 1895794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1895797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1895805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1895808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1895811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1895814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895840 */     // MIs[0] policy
     /* 1895840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1895853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1895871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895877 */     // GIR_Coverage, 14864,
     /* 1895877 */     GIR_EraseRootFromParent_Done,
     /* 1895878 */   // Label 25537: @1895878
     /* 1895878 */   GIM_Try, /*On fail goto*//*Label 25538*/ GIMT_Encode4(1895967), // Rule ID 14865 //
     /* 1895883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1895886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1895894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1895897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1895900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895929 */     // MIs[0] policy
     /* 1895929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895939 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11595:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1895942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1895960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895966 */     // GIR_Coverage, 14865,
     /* 1895966 */     GIR_EraseRootFromParent_Done,
     /* 1895967 */   // Label 25538: @1895967
     /* 1895967 */   GIM_Try, /*On fail goto*//*Label 25539*/ GIMT_Encode4(1896056), // Rule ID 14868 //
     /* 1895972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1895975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1895983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1895986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1895989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1895992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896018 */     // MIs[0] policy
     /* 1896018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896028 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1896031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1896054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896055 */     // GIR_Coverage, 14868,
     /* 1896055 */     GIR_EraseRootFromParent_Done,
     /* 1896056 */   // Label 25539: @1896056
     /* 1896056 */   GIM_Try, /*On fail goto*//*Label 25540*/ GIMT_Encode4(1896145), // Rule ID 14869 //
     /* 1896061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1896064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1896069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1896072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1896075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1896078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896107 */     // MIs[0] policy
     /* 1896107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896117 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1896120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1896143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896144 */     // GIR_Coverage, 14869,
     /* 1896144 */     GIR_EraseRootFromParent_Done,
     /* 1896145 */   // Label 25540: @1896145
     /* 1896145 */   GIM_Try, /*On fail goto*//*Label 25541*/ GIMT_Encode4(1896234), // Rule ID 14872 //
     /* 1896150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1896153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1896158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1896161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1896164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1896167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1896170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1896173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896196 */     // MIs[0] policy
     /* 1896196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896206 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1896209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1896232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896233 */     // GIR_Coverage, 14872,
     /* 1896233 */     GIR_EraseRootFromParent_Done,
     /* 1896234 */   // Label 25541: @1896234
     /* 1896234 */   GIM_Try, /*On fail goto*//*Label 25542*/ GIMT_Encode4(1896323), // Rule ID 14873 //
     /* 1896239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1896242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1896247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1896250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1896253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1896256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1896262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896285 */     // MIs[0] policy
     /* 1896285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896295 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1896298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1896321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896322 */     // GIR_Coverage, 14873,
     /* 1896322 */     GIR_EraseRootFromParent_Done,
     /* 1896323 */   // Label 25542: @1896323
     /* 1896323 */   GIM_Try, /*On fail goto*//*Label 25543*/ GIMT_Encode4(1896412), // Rule ID 14876 //
     /* 1896328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1896331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1896336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1896339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1896342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1896345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1896348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1896351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896374 */     // MIs[0] policy
     /* 1896374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1896387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1896405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1896410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896411 */     // GIR_Coverage, 14876,
     /* 1896411 */     GIR_EraseRootFromParent_Done,
     /* 1896412 */   // Label 25543: @1896412
     /* 1896412 */   GIM_Try, /*On fail goto*//*Label 25544*/ GIMT_Encode4(1896501), // Rule ID 14877 //
     /* 1896417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1896420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1896425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1896428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1896431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1896434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1896440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896463 */     // MIs[0] policy
     /* 1896463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896473 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1896476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1896494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1896499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896500 */     // GIR_Coverage, 14877,
     /* 1896500 */     GIR_EraseRootFromParent_Done,
     /* 1896501 */   // Label 25544: @1896501
     /* 1896501 */   GIM_Try, /*On fail goto*//*Label 25545*/ GIMT_Encode4(1896590), // Rule ID 14880 //
     /* 1896506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1896509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1896514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1896517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1896520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1896523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1896526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896552 */     // MIs[0] policy
     /* 1896552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896562 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1896565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1896583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1896588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896589 */     // GIR_Coverage, 14880,
     /* 1896589 */     GIR_EraseRootFromParent_Done,
     /* 1896590 */   // Label 25545: @1896590
     /* 1896590 */   GIM_Try, /*On fail goto*//*Label 25546*/ GIMT_Encode4(1896679), // Rule ID 14881 //
     /* 1896595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1896598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1896603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1896606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1896609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1896612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896641 */     // MIs[0] policy
     /* 1896641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896651 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1896654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1896672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1896677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896678 */     // GIR_Coverage, 14881,
     /* 1896678 */     GIR_EraseRootFromParent_Done,
     /* 1896679 */   // Label 25546: @1896679
     /* 1896679 */   GIM_Try, /*On fail goto*//*Label 25547*/ GIMT_Encode4(1896768), // Rule ID 14884 //
     /* 1896684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1896687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1896692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1896695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1896698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1896701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1896704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896730 */     // MIs[0] policy
     /* 1896730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896740 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1896743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1896761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1896766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896767 */     // GIR_Coverage, 14884,
     /* 1896767 */     GIR_EraseRootFromParent_Done,
     /* 1896768 */   // Label 25547: @1896768
     /* 1896768 */   GIM_Try, /*On fail goto*//*Label 25548*/ GIMT_Encode4(1896857), // Rule ID 14885 //
     /* 1896773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1896776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1896781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1896784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1896787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1896790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896819 */     // MIs[0] policy
     /* 1896819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896829 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1896832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1896850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1896855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896856 */     // GIR_Coverage, 14885,
     /* 1896856 */     GIR_EraseRootFromParent_Done,
     /* 1896857 */   // Label 25548: @1896857
     /* 1896857 */   GIM_Try, /*On fail goto*//*Label 25549*/ GIMT_Encode4(1896946), // Rule ID 14888 //
     /* 1896862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1896865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1896870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1896873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1896876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1896879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1896882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1896885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896908 */     // MIs[0] policy
     /* 1896908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896918 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1896921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1896939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1896944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896945 */     // GIR_Coverage, 14888,
     /* 1896945 */     GIR_EraseRootFromParent_Done,
     /* 1896946 */   // Label 25549: @1896946
     /* 1896946 */   GIM_Try, /*On fail goto*//*Label 25550*/ GIMT_Encode4(1897035), // Rule ID 14889 //
     /* 1896951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1896954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1896959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1896962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1896965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1896968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1896974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1896993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896997 */     // MIs[0] policy
     /* 1896997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897007 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1897010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1897028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1897033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897034 */     // GIR_Coverage, 14889,
     /* 1897034 */     GIR_EraseRootFromParent_Done,
     /* 1897035 */   // Label 25550: @1897035
     /* 1897035 */   GIM_Try, /*On fail goto*//*Label 25551*/ GIMT_Encode4(1897124), // Rule ID 14892 //
     /* 1897040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1897043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1897048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1897051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1897054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1897057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1897060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897086 */     // MIs[0] policy
     /* 1897086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1897099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1897122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897123 */     // GIR_Coverage, 14892,
     /* 1897123 */     GIR_EraseRootFromParent_Done,
     /* 1897124 */   // Label 25551: @1897124
     /* 1897124 */   GIM_Try, /*On fail goto*//*Label 25552*/ GIMT_Encode4(1897213), // Rule ID 14893 //
     /* 1897129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1897132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1897137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1897140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1897143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1897146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897175 */     // MIs[0] policy
     /* 1897175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897185 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1897188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1897211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897212 */     // GIR_Coverage, 14893,
     /* 1897212 */     GIR_EraseRootFromParent_Done,
     /* 1897213 */   // Label 25552: @1897213
     /* 1897213 */   GIM_Try, /*On fail goto*//*Label 25553*/ GIMT_Encode4(1897302), // Rule ID 14896 //
     /* 1897218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1897221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1897226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1897229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1897232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1897235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1897238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897264 */     // MIs[0] policy
     /* 1897264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897274 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1897277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1897300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897301 */     // GIR_Coverage, 14896,
     /* 1897301 */     GIR_EraseRootFromParent_Done,
     /* 1897302 */   // Label 25553: @1897302
     /* 1897302 */   GIM_Try, /*On fail goto*//*Label 25554*/ GIMT_Encode4(1897391), // Rule ID 14897 //
     /* 1897307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1897310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1897315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1897318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1897321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1897324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897353 */     // MIs[0] policy
     /* 1897353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897363 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1897366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1897389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897390 */     // GIR_Coverage, 14897,
     /* 1897390 */     GIR_EraseRootFromParent_Done,
     /* 1897391 */   // Label 25554: @1897391
     /* 1897391 */   GIM_Try, /*On fail goto*//*Label 25555*/ GIMT_Encode4(1897480), // Rule ID 14900 //
     /* 1897396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1897399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1897404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1897407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1897410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1897413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1897416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1897419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897442 */     // MIs[0] policy
     /* 1897442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897452 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1897455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1897478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897479 */     // GIR_Coverage, 14900,
     /* 1897479 */     GIR_EraseRootFromParent_Done,
     /* 1897480 */   // Label 25555: @1897480
     /* 1897480 */   GIM_Try, /*On fail goto*//*Label 25556*/ GIMT_Encode4(1897569), // Rule ID 14901 //
     /* 1897485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1897488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1897493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1897496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1897499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1897502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1897508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897531 */     // MIs[0] policy
     /* 1897531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897541 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1897544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1897567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897568 */     // GIR_Coverage, 14901,
     /* 1897568 */     GIR_EraseRootFromParent_Done,
     /* 1897569 */   // Label 25556: @1897569
     /* 1897569 */   GIM_Try, /*On fail goto*//*Label 25557*/ GIMT_Encode4(1897658), // Rule ID 14904 //
     /* 1897574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1897577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1897582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1897585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1897588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1897591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1897594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897620 */     // MIs[0] policy
     /* 1897620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1897633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1897656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897657 */     // GIR_Coverage, 14904,
     /* 1897657 */     GIR_EraseRootFromParent_Done,
     /* 1897658 */   // Label 25557: @1897658
     /* 1897658 */   GIM_Try, /*On fail goto*//*Label 25558*/ GIMT_Encode4(1897747), // Rule ID 14905 //
     /* 1897663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1897666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1897671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1897674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1897677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1897680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897709 */     // MIs[0] policy
     /* 1897709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1897722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1897745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897746 */     // GIR_Coverage, 14905,
     /* 1897746 */     GIR_EraseRootFromParent_Done,
     /* 1897747 */   // Label 25558: @1897747
     /* 1897747 */   GIM_Try, /*On fail goto*//*Label 25559*/ GIMT_Encode4(1897836), // Rule ID 14908 //
     /* 1897752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1897755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1897760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1897763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1897766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1897769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1897772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897798 */     // MIs[0] policy
     /* 1897798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897808 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1897811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1897834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897835 */     // GIR_Coverage, 14908,
     /* 1897835 */     GIR_EraseRootFromParent_Done,
     /* 1897836 */   // Label 25559: @1897836
     /* 1897836 */   GIM_Try, /*On fail goto*//*Label 25560*/ GIMT_Encode4(1897925), // Rule ID 14909 //
     /* 1897841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1897844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1897849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1897852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1897855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1897858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897887 */     // MIs[0] policy
     /* 1897887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897897 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1897900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1897923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897924 */     // GIR_Coverage, 14909,
     /* 1897924 */     GIR_EraseRootFromParent_Done,
     /* 1897925 */   // Label 25560: @1897925
     /* 1897925 */   GIM_Try, /*On fail goto*//*Label 25561*/ GIMT_Encode4(1898014), // Rule ID 14912 //
     /* 1897930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1897933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1897938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1897941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1897944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1897947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1897950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1897972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897976 */     // MIs[0] policy
     /* 1897976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897986 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1897989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1898012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898013 */     // GIR_Coverage, 14912,
     /* 1898013 */     GIR_EraseRootFromParent_Done,
     /* 1898014 */   // Label 25561: @1898014
     /* 1898014 */   GIM_Try, /*On fail goto*//*Label 25562*/ GIMT_Encode4(1898103), // Rule ID 14913 //
     /* 1898019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1898022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1898027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1898030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1898033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1898036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1898042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1898049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1898061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898065 */     // MIs[0] policy
     /* 1898065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898075 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1898078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1898101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898102 */     // GIR_Coverage, 14913,
     /* 1898102 */     GIR_EraseRootFromParent_Done,
     /* 1898103 */   // Label 25562: @1898103
     /* 1898103 */   GIM_Try, /*On fail goto*//*Label 25563*/ GIMT_Encode4(1898192), // Rule ID 14916 //
     /* 1898108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1898111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1898116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1898119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1898122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1898125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1898150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898154 */     // MIs[0] policy
     /* 1898154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1898167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1898190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898191 */     // GIR_Coverage, 14916,
     /* 1898191 */     GIR_EraseRootFromParent_Done,
     /* 1898192 */   // Label 25563: @1898192
     /* 1898192 */   GIM_Try, /*On fail goto*//*Label 25564*/ GIMT_Encode4(1898281), // Rule ID 14917 //
     /* 1898197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1898200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1898205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1898208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1898211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1898214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1898239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898243 */     // MIs[0] policy
     /* 1898243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898253 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1898256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1898279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898280 */     // GIR_Coverage, 14917,
     /* 1898280 */     GIR_EraseRootFromParent_Done,
     /* 1898281 */   // Label 25564: @1898281
     /* 1898281 */   GIM_Try, /*On fail goto*//*Label 25565*/ GIMT_Encode4(1898370), // Rule ID 14920 //
     /* 1898286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1898289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1898294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1898297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1898300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1898303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1898316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1898328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898332 */     // MIs[0] policy
     /* 1898332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898342 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1898345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1898368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898369 */     // GIR_Coverage, 14920,
     /* 1898369 */     GIR_EraseRootFromParent_Done,
     /* 1898370 */   // Label 25565: @1898370
     /* 1898370 */   GIM_Try, /*On fail goto*//*Label 25566*/ GIMT_Encode4(1898459), // Rule ID 14921 //
     /* 1898375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1898378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1898383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1898386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1898389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1898392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1898405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1898417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898421 */     // MIs[0] policy
     /* 1898421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898431 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1898434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1898457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898458 */     // GIR_Coverage, 14921,
     /* 1898458 */     GIR_EraseRootFromParent_Done,
     /* 1898459 */   // Label 25566: @1898459
     /* 1898459 */   GIM_Try, /*On fail goto*//*Label 25567*/ GIMT_Encode4(1898548), // Rule ID 14924 //
     /* 1898464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1898467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1898472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1898475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1898478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1898481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1898494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1898506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898510 */     // MIs[0] policy
     /* 1898510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898520 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1898523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1898546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898547 */     // GIR_Coverage, 14924,
     /* 1898547 */     GIR_EraseRootFromParent_Done,
     /* 1898548 */   // Label 25567: @1898548
     /* 1898548 */   GIM_Try, /*On fail goto*//*Label 25568*/ GIMT_Encode4(1898637), // Rule ID 14925 //
     /* 1898553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1898556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1898561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1898564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1898567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1898570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1898583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1898595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898599 */     // MIs[0] policy
     /* 1898599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898609 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1898612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1898635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898636 */     // GIR_Coverage, 14925,
     /* 1898636 */     GIR_EraseRootFromParent_Done,
     /* 1898637 */   // Label 25568: @1898637
     /* 1898637 */   GIM_Try, /*On fail goto*//*Label 25569*/ GIMT_Encode4(1898723), // Rule ID 19166 //
     /* 1898642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1898653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1898656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1898659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1898662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898688 */     // MIs[0] policy
     /* 1898688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898698 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1898701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898722 */     // GIR_Coverage, 19166,
     /* 1898722 */     GIR_EraseRootFromParent_Done,
     /* 1898723 */   // Label 25569: @1898723
     /* 1898723 */   GIM_Try, /*On fail goto*//*Label 25570*/ GIMT_Encode4(1898809), // Rule ID 19167 //
     /* 1898728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1898739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1898742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1898745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1898748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898774 */     // MIs[0] policy
     /* 1898774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898784 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1898787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898808 */     // GIR_Coverage, 19167,
     /* 1898808 */     GIR_EraseRootFromParent_Done,
     /* 1898809 */   // Label 25570: @1898809
     /* 1898809 */   GIM_Try, /*On fail goto*//*Label 25571*/ GIMT_Encode4(1898895), // Rule ID 19170 //
     /* 1898814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1898825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1898828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1898831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1898834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898860 */     // MIs[0] policy
     /* 1898860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898870 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1898873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898894 */     // GIR_Coverage, 19170,
     /* 1898894 */     GIR_EraseRootFromParent_Done,
     /* 1898895 */   // Label 25571: @1898895
     /* 1898895 */   GIM_Try, /*On fail goto*//*Label 25572*/ GIMT_Encode4(1898981), // Rule ID 19171 //
     /* 1898900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1898911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1898914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1898917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1898920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898946 */     // MIs[0] policy
     /* 1898946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898956 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1898959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898980 */     // GIR_Coverage, 19171,
     /* 1898980 */     GIR_EraseRootFromParent_Done,
     /* 1898981 */   // Label 25572: @1898981
     /* 1898981 */   GIM_Try, /*On fail goto*//*Label 25573*/ GIMT_Encode4(1899067), // Rule ID 19174 //
     /* 1898986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1898989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1898997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1899000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1899003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1899006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1899009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899032 */     // MIs[0] policy
     /* 1899032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899042 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1899045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899066 */     // GIR_Coverage, 19174,
     /* 1899066 */     GIR_EraseRootFromParent_Done,
     /* 1899067 */   // Label 25573: @1899067
     /* 1899067 */   GIM_Try, /*On fail goto*//*Label 25574*/ GIMT_Encode4(1899153), // Rule ID 19175 //
     /* 1899072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1899083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1899086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1899089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1899092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1899095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899118 */     // MIs[0] policy
     /* 1899118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899128 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1899131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899152 */     // GIR_Coverage, 19175,
     /* 1899152 */     GIR_EraseRootFromParent_Done,
     /* 1899153 */   // Label 25574: @1899153
     /* 1899153 */   GIM_Try, /*On fail goto*//*Label 25575*/ GIMT_Encode4(1899239), // Rule ID 19178 //
     /* 1899158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1899169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1899172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1899175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1899178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899204 */     // MIs[0] policy
     /* 1899204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899214 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1899217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899238 */     // GIR_Coverage, 19178,
     /* 1899238 */     GIR_EraseRootFromParent_Done,
     /* 1899239 */   // Label 25575: @1899239
     /* 1899239 */   GIM_Try, /*On fail goto*//*Label 25576*/ GIMT_Encode4(1899325), // Rule ID 19179 //
     /* 1899244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1899247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1899255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1899258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1899261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1899264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899290 */     // MIs[0] policy
     /* 1899290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899300 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1899303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899324 */     // GIR_Coverage, 19179,
     /* 1899324 */     GIR_EraseRootFromParent_Done,
     /* 1899325 */   // Label 25576: @1899325
     /* 1899325 */   GIM_Try, /*On fail goto*//*Label 25577*/ GIMT_Encode4(1899411), // Rule ID 19182 //
     /* 1899330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1899341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1899344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1899347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1899350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1899353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899376 */     // MIs[0] policy
     /* 1899376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899386 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1899389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899410 */     // GIR_Coverage, 19182,
     /* 1899410 */     GIR_EraseRootFromParent_Done,
     /* 1899411 */   // Label 25577: @1899411
     /* 1899411 */   GIM_Try, /*On fail goto*//*Label 25578*/ GIMT_Encode4(1899497), // Rule ID 19183 //
     /* 1899416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1899427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1899430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1899433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1899436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1899439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899462 */     // MIs[0] policy
     /* 1899462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899472 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1899475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899496 */     // GIR_Coverage, 19183,
     /* 1899496 */     GIR_EraseRootFromParent_Done,
     /* 1899497 */   // Label 25578: @1899497
     /* 1899497 */   GIM_Try, /*On fail goto*//*Label 25579*/ GIMT_Encode4(1899583), // Rule ID 19186 //
     /* 1899502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1899505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1899513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1899516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1899519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1899522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1899525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899548 */     // MIs[0] policy
     /* 1899548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899558 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1899561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899582 */     // GIR_Coverage, 19186,
     /* 1899582 */     GIR_EraseRootFromParent_Done,
     /* 1899583 */   // Label 25579: @1899583
     /* 1899583 */   GIM_Try, /*On fail goto*//*Label 25580*/ GIMT_Encode4(1899669), // Rule ID 19187 //
     /* 1899588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1899591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1899599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1899602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1899605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1899608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1899611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899634 */     // MIs[0] policy
     /* 1899634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899644 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1899647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899668 */     // GIR_Coverage, 19187,
     /* 1899668 */     GIR_EraseRootFromParent_Done,
     /* 1899669 */   // Label 25580: @1899669
     /* 1899669 */   GIM_Try, /*On fail goto*//*Label 25581*/ GIMT_Encode4(1899755), // Rule ID 19190 //
     /* 1899674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1899685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1899688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1899691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1899694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899720 */     // MIs[0] policy
     /* 1899720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899730 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1899733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899754 */     // GIR_Coverage, 19190,
     /* 1899754 */     GIR_EraseRootFromParent_Done,
     /* 1899755 */   // Label 25581: @1899755
     /* 1899755 */   GIM_Try, /*On fail goto*//*Label 25582*/ GIMT_Encode4(1899841), // Rule ID 19191 //
     /* 1899760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1899763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1899771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1899774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1899777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1899780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899806 */     // MIs[0] policy
     /* 1899806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899816 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1899819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899840 */     // GIR_Coverage, 19191,
     /* 1899840 */     GIR_EraseRootFromParent_Done,
     /* 1899841 */   // Label 25582: @1899841
     /* 1899841 */   GIM_Try, /*On fail goto*//*Label 25583*/ GIMT_Encode4(1899927), // Rule ID 19194 //
     /* 1899846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1899857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1899860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1899863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1899866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899892 */     // MIs[0] policy
     /* 1899892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899902 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1899905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899926 */     // GIR_Coverage, 19194,
     /* 1899926 */     GIR_EraseRootFromParent_Done,
     /* 1899927 */   // Label 25583: @1899927
     /* 1899927 */   GIM_Try, /*On fail goto*//*Label 25584*/ GIMT_Encode4(1900013), // Rule ID 19195 //
     /* 1899932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1899935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1899943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1899946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1899949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1899952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899978 */     // MIs[0] policy
     /* 1899978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899988 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1899991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900012 */     // GIR_Coverage, 19195,
     /* 1900012 */     GIR_EraseRootFromParent_Done,
     /* 1900013 */   // Label 25584: @1900013
     /* 1900013 */   GIM_Try, /*On fail goto*//*Label 25585*/ GIMT_Encode4(1900099), // Rule ID 19198 //
     /* 1900018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1900029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1900032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1900035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1900038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1900041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900064 */     // MIs[0] policy
     /* 1900064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900074 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1900077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900098 */     // GIR_Coverage, 19198,
     /* 1900098 */     GIR_EraseRootFromParent_Done,
     /* 1900099 */   // Label 25585: @1900099
     /* 1900099 */   GIM_Try, /*On fail goto*//*Label 25586*/ GIMT_Encode4(1900185), // Rule ID 19199 //
     /* 1900104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1900115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1900118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1900121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1900124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1900127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900150 */     // MIs[0] policy
     /* 1900150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900160 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1900163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900184 */     // GIR_Coverage, 19199,
     /* 1900184 */     GIR_EraseRootFromParent_Done,
     /* 1900185 */   // Label 25586: @1900185
     /* 1900185 */   GIM_Try, /*On fail goto*//*Label 25587*/ GIMT_Encode4(1900271), // Rule ID 19202 //
     /* 1900190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1900201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1900204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1900207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1900210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1900220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900236 */     // MIs[0] policy
     /* 1900236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900246 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1900249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900270 */     // GIR_Coverage, 19202,
     /* 1900270 */     GIR_EraseRootFromParent_Done,
     /* 1900271 */   // Label 25587: @1900271
     /* 1900271 */   GIM_Try, /*On fail goto*//*Label 25588*/ GIMT_Encode4(1900357), // Rule ID 19203 //
     /* 1900276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1900279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1900287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1900290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1900293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1900296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1900306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900322 */     // MIs[0] policy
     /* 1900322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900332 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1900335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900356 */     // GIR_Coverage, 19203,
     /* 1900356 */     GIR_EraseRootFromParent_Done,
     /* 1900357 */   // Label 25588: @1900357
     /* 1900357 */   GIM_Try, /*On fail goto*//*Label 25589*/ GIMT_Encode4(1900443), // Rule ID 19206 //
     /* 1900362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1900373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1900376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1900379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1900382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1900385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900408 */     // MIs[0] policy
     /* 1900408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900418 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1900421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900442 */     // GIR_Coverage, 19206,
     /* 1900442 */     GIR_EraseRootFromParent_Done,
     /* 1900443 */   // Label 25589: @1900443
     /* 1900443 */   GIM_Try, /*On fail goto*//*Label 25590*/ GIMT_Encode4(1900529), // Rule ID 19207 //
     /* 1900448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1900451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1900459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1900462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1900465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1900468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1900471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900494 */     // MIs[0] policy
     /* 1900494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900504 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1900507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900528 */     // GIR_Coverage, 19207,
     /* 1900528 */     GIR_EraseRootFromParent_Done,
     /* 1900529 */   // Label 25590: @1900529
     /* 1900529 */   GIM_Try, /*On fail goto*//*Label 25591*/ GIMT_Encode4(1900615), // Rule ID 19210 //
     /* 1900534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1900545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1900548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1900551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1900554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1900557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900580 */     // MIs[0] policy
     /* 1900580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900590 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1900593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900614 */     // GIR_Coverage, 19210,
     /* 1900614 */     GIR_EraseRootFromParent_Done,
     /* 1900615 */   // Label 25591: @1900615
     /* 1900615 */   GIM_Try, /*On fail goto*//*Label 25592*/ GIMT_Encode4(1900701), // Rule ID 19211 //
     /* 1900620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1900623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1900631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1900634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1900637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1900640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1900643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900666 */     // MIs[0] policy
     /* 1900666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900676 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1900679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900700 */     // GIR_Coverage, 19211,
     /* 1900700 */     GIR_EraseRootFromParent_Done,
     /* 1900701 */   // Label 25592: @1900701
     /* 1900701 */   GIM_Try, /*On fail goto*//*Label 25593*/ GIMT_Encode4(1900787), // Rule ID 19214 //
     /* 1900706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1900709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1900717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1900720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1900723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1900726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1900736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900752 */     // MIs[0] policy
     /* 1900752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900762 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1900765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900786 */     // GIR_Coverage, 19214,
     /* 1900786 */     GIR_EraseRootFromParent_Done,
     /* 1900787 */   // Label 25593: @1900787
     /* 1900787 */   GIM_Try, /*On fail goto*//*Label 25594*/ GIMT_Encode4(1900873), // Rule ID 19215 //
     /* 1900792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1900795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1900803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1900806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1900809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1900812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1900822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900838 */     // MIs[0] policy
     /* 1900838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900848 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1900851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900872 */     // GIR_Coverage, 19215,
     /* 1900872 */     GIR_EraseRootFromParent_Done,
     /* 1900873 */   // Label 25594: @1900873
     /* 1900873 */   GIM_Try, /*On fail goto*//*Label 25595*/ GIMT_Encode4(1900959), // Rule ID 19218 //
     /* 1900878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1900881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1900889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1900892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1900895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1900898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900924 */     // MIs[0] policy
     /* 1900924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900934 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1900937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900958 */     // GIR_Coverage, 19218,
     /* 1900958 */     GIR_EraseRootFromParent_Done,
     /* 1900959 */   // Label 25595: @1900959
     /* 1900959 */   GIM_Try, /*On fail goto*//*Label 25596*/ GIMT_Encode4(1901045), // Rule ID 19219 //
     /* 1900964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1900967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1900975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1900978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1900981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1900984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901010 */     // MIs[0] policy
     /* 1901010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901020 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1901023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1901041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901044 */     // GIR_Coverage, 19219,
     /* 1901044 */     GIR_EraseRootFromParent_Done,
     /* 1901045 */   // Label 25596: @1901045
     /* 1901045 */   GIM_Try, /*On fail goto*//*Label 25597*/ GIMT_Encode4(1901131), // Rule ID 19222 //
     /* 1901050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1901053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1901058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1901061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1901064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1901067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1901070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901096 */     // MIs[0] policy
     /* 1901096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901106 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1901109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1901127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901130 */     // GIR_Coverage, 19222,
     /* 1901130 */     GIR_EraseRootFromParent_Done,
     /* 1901131 */   // Label 25597: @1901131
     /* 1901131 */   GIM_Try, /*On fail goto*//*Label 25598*/ GIMT_Encode4(1901217), // Rule ID 19223 //
     /* 1901136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1901139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1901144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1901147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1901150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1901153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1901156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901182 */     // MIs[0] policy
     /* 1901182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901192 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1901195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1901213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901216 */     // GIR_Coverage, 19223,
     /* 1901216 */     GIR_EraseRootFromParent_Done,
     /* 1901217 */   // Label 25598: @1901217
     /* 1901217 */   GIM_Try, /*On fail goto*//*Label 25599*/ GIMT_Encode4(1901303), // Rule ID 19226 //
     /* 1901222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1901230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1901233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1901236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1901239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901268 */     // MIs[0] policy
     /* 1901268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901278 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1901281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901302 */     // GIR_Coverage, 19226,
     /* 1901302 */     GIR_EraseRootFromParent_Done,
     /* 1901303 */   // Label 25599: @1901303
     /* 1901303 */   GIM_Try, /*On fail goto*//*Label 25600*/ GIMT_Encode4(1901389), // Rule ID 19227 //
     /* 1901308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1901316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1901319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1901322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1901325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901354 */     // MIs[0] policy
     /* 1901354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901364 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1901367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901388 */     // GIR_Coverage, 19227,
     /* 1901388 */     GIR_EraseRootFromParent_Done,
     /* 1901389 */   // Label 25600: @1901389
     /* 1901389 */   GIM_Try, /*On fail goto*//*Label 25601*/ GIMT_Encode4(1901475), // Rule ID 19230 //
     /* 1901394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1901402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1901405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1901408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1901411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901440 */     // MIs[0] policy
     /* 1901440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901450 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1901453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901474 */     // GIR_Coverage, 19230,
     /* 1901474 */     GIR_EraseRootFromParent_Done,
     /* 1901475 */   // Label 25601: @1901475
     /* 1901475 */   GIM_Try, /*On fail goto*//*Label 25602*/ GIMT_Encode4(1901561), // Rule ID 19231 //
     /* 1901480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1901488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1901491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1901494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1901497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901526 */     // MIs[0] policy
     /* 1901526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901536 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1901539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901560 */     // GIR_Coverage, 19231,
     /* 1901560 */     GIR_EraseRootFromParent_Done,
     /* 1901561 */   // Label 25602: @1901561
     /* 1901561 */   GIM_Try, /*On fail goto*//*Label 25603*/ GIMT_Encode4(1901647), // Rule ID 19234 //
     /* 1901566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1901574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1901577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1901580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1901583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1901586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1901608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901612 */     // MIs[0] policy
     /* 1901612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901622 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1901625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901646 */     // GIR_Coverage, 19234,
     /* 1901646 */     GIR_EraseRootFromParent_Done,
     /* 1901647 */   // Label 25603: @1901647
     /* 1901647 */   GIM_Try, /*On fail goto*//*Label 25604*/ GIMT_Encode4(1901733), // Rule ID 19235 //
     /* 1901652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1901660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1901663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1901666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1901669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1901672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1901694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901698 */     // MIs[0] policy
     /* 1901698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901708 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1901711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901732 */     // GIR_Coverage, 19235,
     /* 1901732 */     GIR_EraseRootFromParent_Done,
     /* 1901733 */   // Label 25604: @1901733
     /* 1901733 */   GIM_Try, /*On fail goto*//*Label 25605*/ GIMT_Encode4(1901819), // Rule ID 19238 //
     /* 1901738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1901746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1901749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1901752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1901755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901784 */     // MIs[0] policy
     /* 1901784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901794 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1901797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901818 */     // GIR_Coverage, 19238,
     /* 1901818 */     GIR_EraseRootFromParent_Done,
     /* 1901819 */   // Label 25605: @1901819
     /* 1901819 */   GIM_Try, /*On fail goto*//*Label 25606*/ GIMT_Encode4(1901905), // Rule ID 19239 //
     /* 1901824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1901832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1901835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1901838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1901841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901870 */     // MIs[0] policy
     /* 1901870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901880 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1901883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901904 */     // GIR_Coverage, 19239,
     /* 1901904 */     GIR_EraseRootFromParent_Done,
     /* 1901905 */   // Label 25606: @1901905
     /* 1901905 */   GIM_Try, /*On fail goto*//*Label 25607*/ GIMT_Encode4(1901991), // Rule ID 19242 //
     /* 1901910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1901918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1901921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1901924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1901927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1901930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1901952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901956 */     // MIs[0] policy
     /* 1901956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901966 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1901969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901990 */     // GIR_Coverage, 19242,
     /* 1901990 */     GIR_EraseRootFromParent_Done,
     /* 1901991 */   // Label 25607: @1901991
     /* 1901991 */   GIM_Try, /*On fail goto*//*Label 25608*/ GIMT_Encode4(1902077), // Rule ID 19243 //
     /* 1901996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1902004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1902007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1902010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1902013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902042 */     // MIs[0] policy
     /* 1902042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902052 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1902055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902076 */     // GIR_Coverage, 19243,
     /* 1902076 */     GIR_EraseRootFromParent_Done,
     /* 1902077 */   // Label 25608: @1902077
     /* 1902077 */   GIM_Try, /*On fail goto*//*Label 25609*/ GIMT_Encode4(1902163), // Rule ID 19246 //
     /* 1902082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1902090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1902093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1902096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1902099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1902102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1902124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902128 */     // MIs[0] policy
     /* 1902128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902138 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1902141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902162 */     // GIR_Coverage, 19246,
     /* 1902162 */     GIR_EraseRootFromParent_Done,
     /* 1902163 */   // Label 25609: @1902163
     /* 1902163 */   GIM_Try, /*On fail goto*//*Label 25610*/ GIMT_Encode4(1902249), // Rule ID 19247 //
     /* 1902168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1902176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1902179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1902182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1902185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1902188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1902210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902214 */     // MIs[0] policy
     /* 1902214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902224 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1902227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902248 */     // GIR_Coverage, 19247,
     /* 1902248 */     GIR_EraseRootFromParent_Done,
     /* 1902249 */   // Label 25610: @1902249
     /* 1902249 */   GIM_Try, /*On fail goto*//*Label 25611*/ GIMT_Encode4(1902335), // Rule ID 19250 //
     /* 1902254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1902262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1902265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1902268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1902271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902300 */     // MIs[0] policy
     /* 1902300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902310 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1902313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902334 */     // GIR_Coverage, 19250,
     /* 1902334 */     GIR_EraseRootFromParent_Done,
     /* 1902335 */   // Label 25611: @1902335
     /* 1902335 */   GIM_Try, /*On fail goto*//*Label 25612*/ GIMT_Encode4(1902421), // Rule ID 19251 //
     /* 1902340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1902348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1902351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1902354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1902357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902386 */     // MIs[0] policy
     /* 1902386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902396 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1902399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902420 */     // GIR_Coverage, 19251,
     /* 1902420 */     GIR_EraseRootFromParent_Done,
     /* 1902421 */   // Label 25612: @1902421
     /* 1902421 */   GIM_Try, /*On fail goto*//*Label 25613*/ GIMT_Encode4(1902507), // Rule ID 19254 //
     /* 1902426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1902434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1902437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1902440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1902443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1902449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902472 */     // MIs[0] policy
     /* 1902472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902482 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1902485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902506 */     // GIR_Coverage, 19254,
     /* 1902506 */     GIR_EraseRootFromParent_Done,
     /* 1902507 */   // Label 25613: @1902507
     /* 1902507 */   GIM_Try, /*On fail goto*//*Label 25614*/ GIMT_Encode4(1902593), // Rule ID 19255 //
     /* 1902512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1902520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1902523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1902526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1902529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1902535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902558 */     // MIs[0] policy
     /* 1902558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902568 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1902571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902592 */     // GIR_Coverage, 19255,
     /* 1902592 */     GIR_EraseRootFromParent_Done,
     /* 1902593 */   // Label 25614: @1902593
     /* 1902593 */   GIM_Try, /*On fail goto*//*Label 25615*/ GIMT_Encode4(1902679), // Rule ID 19258 //
     /* 1902598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1902606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1902609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1902612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1902615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1902621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902644 */     // MIs[0] policy
     /* 1902644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902654 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1902657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902678 */     // GIR_Coverage, 19258,
     /* 1902678 */     GIR_EraseRootFromParent_Done,
     /* 1902679 */   // Label 25615: @1902679
     /* 1902679 */   GIM_Try, /*On fail goto*//*Label 25616*/ GIMT_Encode4(1902765), // Rule ID 19259 //
     /* 1902684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1902692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1902695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1902698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1902701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1902707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902730 */     // MIs[0] policy
     /* 1902730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902740 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1902743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902764 */     // GIR_Coverage, 19259,
     /* 1902764 */     GIR_EraseRootFromParent_Done,
     /* 1902765 */   // Label 25616: @1902765
     /* 1902765 */   GIM_Try, /*On fail goto*//*Label 25617*/ GIMT_Encode4(1902851), // Rule ID 19262 //
     /* 1902770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1902778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1902781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1902784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1902787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902816 */     // MIs[0] policy
     /* 1902816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902826 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1902829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902850 */     // GIR_Coverage, 19262,
     /* 1902850 */     GIR_EraseRootFromParent_Done,
     /* 1902851 */   // Label 25617: @1902851
     /* 1902851 */   GIM_Try, /*On fail goto*//*Label 25618*/ GIMT_Encode4(1902937), // Rule ID 19263 //
     /* 1902856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1902864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1902867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1902870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1902873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902902 */     // MIs[0] policy
     /* 1902902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902912 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1902915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902936 */     // GIR_Coverage, 19263,
     /* 1902936 */     GIR_EraseRootFromParent_Done,
     /* 1902937 */   // Label 25618: @1902937
     /* 1902937 */   GIM_Try, /*On fail goto*//*Label 25619*/ GIMT_Encode4(1903023), // Rule ID 19266 //
     /* 1902942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1902950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1902953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1902956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1902959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902988 */     // MIs[0] policy
     /* 1902988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902998 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1903001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903022 */     // GIR_Coverage, 19266,
     /* 1903022 */     GIR_EraseRootFromParent_Done,
     /* 1903023 */   // Label 25619: @1903023
     /* 1903023 */   GIM_Try, /*On fail goto*//*Label 25620*/ GIMT_Encode4(1903109), // Rule ID 19267 //
     /* 1903028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1903031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1903036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1903039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1903042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1903045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1903051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1903058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903074 */     // MIs[0] policy
     /* 1903074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903084 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1903087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903108 */     // GIR_Coverage, 19267,
     /* 1903108 */     GIR_EraseRootFromParent_Done,
     /* 1903109 */   // Label 25620: @1903109
     /* 1903109 */   GIM_Try, /*On fail goto*//*Label 25621*/ GIMT_Encode4(1903195), // Rule ID 19270 //
     /* 1903114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1903117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1903122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1903125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1903128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1903131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1903137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1903144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903160 */     // MIs[0] policy
     /* 1903160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903170 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1903173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903194 */     // GIR_Coverage, 19270,
     /* 1903194 */     GIR_EraseRootFromParent_Done,
     /* 1903195 */   // Label 25621: @1903195
     /* 1903195 */   GIM_Try, /*On fail goto*//*Label 25622*/ GIMT_Encode4(1903281), // Rule ID 19271 //
     /* 1903200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1903203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1903208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1903211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1903214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1903217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1903223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1903230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903246 */     // MIs[0] policy
     /* 1903246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903256 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1903259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903280 */     // GIR_Coverage, 19271,
     /* 1903280 */     GIR_EraseRootFromParent_Done,
     /* 1903281 */   // Label 25622: @1903281
     /* 1903281 */   GIM_Try, /*On fail goto*//*Label 25623*/ GIMT_Encode4(1903367), // Rule ID 19274 //
     /* 1903286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1903294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1903297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1903300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1903303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1903316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903332 */     // MIs[0] policy
     /* 1903332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903342 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1903345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903366 */     // GIR_Coverage, 19274,
     /* 1903366 */     GIR_EraseRootFromParent_Done,
     /* 1903367 */   // Label 25623: @1903367
     /* 1903367 */   GIM_Try, /*On fail goto*//*Label 25624*/ GIMT_Encode4(1903453), // Rule ID 19275 //
     /* 1903372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1903380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1903383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1903386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1903389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1903402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903418 */     // MIs[0] policy
     /* 1903418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903428 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1903431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903452 */     // GIR_Coverage, 19275,
     /* 1903452 */     GIR_EraseRootFromParent_Done,
     /* 1903453 */   // Label 25624: @1903453
     /* 1903453 */   GIM_Try, /*On fail goto*//*Label 25625*/ GIMT_Encode4(1903539), // Rule ID 19278 //
     /* 1903458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1903466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1903469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1903472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1903475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1903488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903504 */     // MIs[0] policy
     /* 1903504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903514 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1903517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903538 */     // GIR_Coverage, 19278,
     /* 1903538 */     GIR_EraseRootFromParent_Done,
     /* 1903539 */   // Label 25625: @1903539
     /* 1903539 */   GIM_Try, /*On fail goto*//*Label 25626*/ GIMT_Encode4(1903625), // Rule ID 19279 //
     /* 1903544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1903552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1903555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1903558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1903561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1903574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903590 */     // MIs[0] policy
     /* 1903590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903600 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1903603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903624 */     // GIR_Coverage, 19279,
     /* 1903624 */     GIR_EraseRootFromParent_Done,
     /* 1903625 */   // Label 25626: @1903625
     /* 1903625 */   GIM_Try, /*On fail goto*//*Label 25627*/ GIMT_Encode4(1903711), // Rule ID 19282 //
     /* 1903630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1903638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1903641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1903644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1903647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1903653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1903660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903676 */     // MIs[0] policy
     /* 1903676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903686 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1903689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903710 */     // GIR_Coverage, 19282,
     /* 1903710 */     GIR_EraseRootFromParent_Done,
     /* 1903711 */   // Label 25627: @1903711
     /* 1903711 */   GIM_Try, /*On fail goto*//*Label 25628*/ GIMT_Encode4(1903797), // Rule ID 19283 //
     /* 1903716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1903724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1903727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1903730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1903733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1903739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1903746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903762 */     // MIs[0] policy
     /* 1903762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903772 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1903775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903796 */     // GIR_Coverage, 19283,
     /* 1903796 */     GIR_EraseRootFromParent_Done,
     /* 1903797 */   // Label 25628: @1903797
     /* 1903797 */   GIM_Try, /*On fail goto*//*Label 25629*/ GIMT_Encode4(1903883), // Rule ID 19286 //
     /* 1903802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1903813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1903816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1903819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1903822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903848 */     // MIs[0] policy
     /* 1903848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903858 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1903861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903882 */     // GIR_Coverage, 19286,
     /* 1903882 */     GIR_EraseRootFromParent_Done,
     /* 1903883 */   // Label 25629: @1903883
     /* 1903883 */   GIM_Try, /*On fail goto*//*Label 25630*/ GIMT_Encode4(1903969), // Rule ID 19287 //
     /* 1903888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1903899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1903902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1903905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1903908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903934 */     // MIs[0] policy
     /* 1903934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903944 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1903947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903968 */     // GIR_Coverage, 19287,
     /* 1903968 */     GIR_EraseRootFromParent_Done,
     /* 1903969 */   // Label 25630: @1903969
     /* 1903969 */   GIM_Try, /*On fail goto*//*Label 25631*/ GIMT_Encode4(1904055), // Rule ID 19290 //
     /* 1903974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1903985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1903988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1903991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1903994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904020 */     // MIs[0] policy
     /* 1904020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904030 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1904033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904054 */     // GIR_Coverage, 19290,
     /* 1904054 */     GIR_EraseRootFromParent_Done,
     /* 1904055 */   // Label 25631: @1904055
     /* 1904055 */   GIM_Try, /*On fail goto*//*Label 25632*/ GIMT_Encode4(1904141), // Rule ID 19291 //
     /* 1904060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1904071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1904074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1904077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1904080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904106 */     // MIs[0] policy
     /* 1904106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904116 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1904119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904140 */     // GIR_Coverage, 19291,
     /* 1904140 */     GIR_EraseRootFromParent_Done,
     /* 1904141 */   // Label 25632: @1904141
     /* 1904141 */   GIM_Try, /*On fail goto*//*Label 25633*/ GIMT_Encode4(1904227), // Rule ID 19294 //
     /* 1904146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1904157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1904160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1904163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1904166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1904169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904192 */     // MIs[0] policy
     /* 1904192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904202 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1904205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904226 */     // GIR_Coverage, 19294,
     /* 1904226 */     GIR_EraseRootFromParent_Done,
     /* 1904227 */   // Label 25633: @1904227
     /* 1904227 */   GIM_Try, /*On fail goto*//*Label 25634*/ GIMT_Encode4(1904313), // Rule ID 19295 //
     /* 1904232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1904243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1904246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1904249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1904252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1904255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904278 */     // MIs[0] policy
     /* 1904278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904288 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1904291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904312 */     // GIR_Coverage, 19295,
     /* 1904312 */     GIR_EraseRootFromParent_Done,
     /* 1904313 */   // Label 25634: @1904313
     /* 1904313 */   GIM_Try, /*On fail goto*//*Label 25635*/ GIMT_Encode4(1904399), // Rule ID 19298 //
     /* 1904318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1904329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1904332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1904335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1904338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904364 */     // MIs[0] policy
     /* 1904364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904374 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1904377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904398 */     // GIR_Coverage, 19298,
     /* 1904398 */     GIR_EraseRootFromParent_Done,
     /* 1904399 */   // Label 25635: @1904399
     /* 1904399 */   GIM_Try, /*On fail goto*//*Label 25636*/ GIMT_Encode4(1904485), // Rule ID 19299 //
     /* 1904404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1904415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1904418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1904421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1904424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904450 */     // MIs[0] policy
     /* 1904450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904460 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1904463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904484 */     // GIR_Coverage, 19299,
     /* 1904484 */     GIR_EraseRootFromParent_Done,
     /* 1904485 */   // Label 25636: @1904485
     /* 1904485 */   GIM_Try, /*On fail goto*//*Label 25637*/ GIMT_Encode4(1904571), // Rule ID 19302 //
     /* 1904490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1904501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1904504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1904507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1904510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904536 */     // MIs[0] policy
     /* 1904536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904546 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1904549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904570 */     // GIR_Coverage, 19302,
     /* 1904570 */     GIR_EraseRootFromParent_Done,
     /* 1904571 */   // Label 25637: @1904571
     /* 1904571 */   GIM_Try, /*On fail goto*//*Label 25638*/ GIMT_Encode4(1904657), // Rule ID 19303 //
     /* 1904576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1904587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1904590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1904593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1904596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904622 */     // MIs[0] policy
     /* 1904622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904632 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1904635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904656 */     // GIR_Coverage, 19303,
     /* 1904656 */     GIR_EraseRootFromParent_Done,
     /* 1904657 */   // Label 25638: @1904657
     /* 1904657 */   GIM_Try, /*On fail goto*//*Label 25639*/ GIMT_Encode4(1904743), // Rule ID 19306 //
     /* 1904662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1904665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1904673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1904676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1904679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1904682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1904685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904708 */     // MIs[0] policy
     /* 1904708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904718 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1904721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904742 */     // GIR_Coverage, 19306,
     /* 1904742 */     GIR_EraseRootFromParent_Done,
     /* 1904743 */   // Label 25639: @1904743
     /* 1904743 */   GIM_Try, /*On fail goto*//*Label 25640*/ GIMT_Encode4(1904829), // Rule ID 19307 //
     /* 1904748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1904751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1904759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1904762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1904765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1904768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1904771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904794 */     // MIs[0] policy
     /* 1904794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904804 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1904807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904828 */     // GIR_Coverage, 19307,
     /* 1904828 */     GIR_EraseRootFromParent_Done,
     /* 1904829 */   // Label 25640: @1904829
     /* 1904829 */   GIM_Try, /*On fail goto*//*Label 25641*/ GIMT_Encode4(1904915), // Rule ID 19310 //
     /* 1904834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1904845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1904848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1904851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1904854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904880 */     // MIs[0] policy
     /* 1904880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904890 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1904893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904914 */     // GIR_Coverage, 19310,
     /* 1904914 */     GIR_EraseRootFromParent_Done,
     /* 1904915 */   // Label 25641: @1904915
     /* 1904915 */   GIM_Try, /*On fail goto*//*Label 25642*/ GIMT_Encode4(1905001), // Rule ID 19311 //
     /* 1904920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1904931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1904934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1904937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1904940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904966 */     // MIs[0] policy
     /* 1904966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904976 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1904979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905000 */     // GIR_Coverage, 19311,
     /* 1905000 */     GIR_EraseRootFromParent_Done,
     /* 1905001 */   // Label 25642: @1905001
     /* 1905001 */   GIM_Try, /*On fail goto*//*Label 25643*/ GIMT_Encode4(1905087), // Rule ID 19314 //
     /* 1905006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1905017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1905020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1905023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1905026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1905029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905052 */     // MIs[0] policy
     /* 1905052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905062 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1905065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905086 */     // GIR_Coverage, 19314,
     /* 1905086 */     GIR_EraseRootFromParent_Done,
     /* 1905087 */   // Label 25643: @1905087
     /* 1905087 */   GIM_Try, /*On fail goto*//*Label 25644*/ GIMT_Encode4(1905173), // Rule ID 19315 //
     /* 1905092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1905103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1905106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1905109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1905112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1905115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905138 */     // MIs[0] policy
     /* 1905138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905148 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1905151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905172 */     // GIR_Coverage, 19315,
     /* 1905172 */     GIR_EraseRootFromParent_Done,
     /* 1905173 */   // Label 25644: @1905173
     /* 1905173 */   GIM_Try, /*On fail goto*//*Label 25645*/ GIMT_Encode4(1905259), // Rule ID 19318 //
     /* 1905178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1905189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1905192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1905195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1905198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1905201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905224 */     // MIs[0] policy
     /* 1905224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905234 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1905237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905258 */     // GIR_Coverage, 19318,
     /* 1905258 */     GIR_EraseRootFromParent_Done,
     /* 1905259 */   // Label 25645: @1905259
     /* 1905259 */   GIM_Try, /*On fail goto*//*Label 25646*/ GIMT_Encode4(1905345), // Rule ID 19319 //
     /* 1905264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1905275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1905278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1905281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1905284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1905287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905310 */     // MIs[0] policy
     /* 1905310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905320 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1905323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905344 */     // GIR_Coverage, 19319,
     /* 1905344 */     GIR_EraseRootFromParent_Done,
     /* 1905345 */   // Label 25646: @1905345
     /* 1905345 */   GIM_Try, /*On fail goto*//*Label 25647*/ GIMT_Encode4(1905431), // Rule ID 19322 //
     /* 1905350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1905361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1905364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1905367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1905370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1905380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905396 */     // MIs[0] policy
     /* 1905396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905406 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1905409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905430 */     // GIR_Coverage, 19322,
     /* 1905430 */     GIR_EraseRootFromParent_Done,
     /* 1905431 */   // Label 25647: @1905431
     /* 1905431 */   GIM_Try, /*On fail goto*//*Label 25648*/ GIMT_Encode4(1905517), // Rule ID 19323 //
     /* 1905436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1905447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1905450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1905453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1905456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1905466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905482 */     // MIs[0] policy
     /* 1905482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905492 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1905495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905516 */     // GIR_Coverage, 19323,
     /* 1905516 */     GIR_EraseRootFromParent_Done,
     /* 1905517 */   // Label 25648: @1905517
     /* 1905517 */   GIM_Try, /*On fail goto*//*Label 25649*/ GIMT_Encode4(1905603), // Rule ID 19326 //
     /* 1905522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1905533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1905536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1905539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1905542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905568 */     // MIs[0] policy
     /* 1905568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905578 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1905581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905602 */     // GIR_Coverage, 19326,
     /* 1905602 */     GIR_EraseRootFromParent_Done,
     /* 1905603 */   // Label 25649: @1905603
     /* 1905603 */   GIM_Try, /*On fail goto*//*Label 25650*/ GIMT_Encode4(1905689), // Rule ID 19327 //
     /* 1905608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1905619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1905622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1905625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1905628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905654 */     // MIs[0] policy
     /* 1905654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905664 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1905667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905688 */     // GIR_Coverage, 19327,
     /* 1905688 */     GIR_EraseRootFromParent_Done,
     /* 1905689 */   // Label 25650: @1905689
     /* 1905689 */   GIM_Try, /*On fail goto*//*Label 25651*/ GIMT_Encode4(1905775), // Rule ID 19330 //
     /* 1905694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1905705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1905708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1905711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1905714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1905717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905740 */     // MIs[0] policy
     /* 1905740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905750 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1905753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905774 */     // GIR_Coverage, 19330,
     /* 1905774 */     GIR_EraseRootFromParent_Done,
     /* 1905775 */   // Label 25651: @1905775
     /* 1905775 */   GIM_Try, /*On fail goto*//*Label 25652*/ GIMT_Encode4(1905861), // Rule ID 19331 //
     /* 1905780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1905791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1905794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1905797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1905800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1905803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905826 */     // MIs[0] policy
     /* 1905826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905836 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1905839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905860 */     // GIR_Coverage, 19331,
     /* 1905860 */     GIR_EraseRootFromParent_Done,
     /* 1905861 */   // Label 25652: @1905861
     /* 1905861 */   GIM_Try, /*On fail goto*//*Label 25653*/ GIMT_Encode4(1905947), // Rule ID 19334 //
     /* 1905866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1905877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1905880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1905883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1905886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1905896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905912 */     // MIs[0] policy
     /* 1905912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905922 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1905925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905946 */     // GIR_Coverage, 19334,
     /* 1905946 */     GIR_EraseRootFromParent_Done,
     /* 1905947 */   // Label 25653: @1905947
     /* 1905947 */   GIM_Try, /*On fail goto*//*Label 25654*/ GIMT_Encode4(1906033), // Rule ID 19335 //
     /* 1905952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1905955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1905963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1905966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1905969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1905972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1905982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905998 */     // MIs[0] policy
     /* 1905998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906008 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1906011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906032 */     // GIR_Coverage, 19335,
     /* 1906032 */     GIR_EraseRootFromParent_Done,
     /* 1906033 */   // Label 25654: @1906033
     /* 1906033 */   GIM_Try, /*On fail goto*//*Label 25655*/ GIMT_Encode4(1906119), // Rule ID 19338 //
     /* 1906038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1906041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1906046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1906049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1906052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1906055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1906058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906084 */     // MIs[0] policy
     /* 1906084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906094 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1906097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906118 */     // GIR_Coverage, 19338,
     /* 1906118 */     GIR_EraseRootFromParent_Done,
     /* 1906119 */   // Label 25655: @1906119
     /* 1906119 */   GIM_Try, /*On fail goto*//*Label 25656*/ GIMT_Encode4(1906205), // Rule ID 19339 //
     /* 1906124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1906127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1906132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1906135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1906138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1906141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1906144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906170 */     // MIs[0] policy
     /* 1906170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906180 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1906183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906204 */     // GIR_Coverage, 19339,
     /* 1906204 */     GIR_EraseRootFromParent_Done,
     /* 1906205 */   // Label 25656: @1906205
     /* 1906205 */   GIM_Try, /*On fail goto*//*Label 25657*/ GIMT_Encode4(1906291), // Rule ID 19342 //
     /* 1906210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1906213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1906218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1906221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1906224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1906227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1906230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1906240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906256 */     // MIs[0] policy
     /* 1906256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906266 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1906269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906290 */     // GIR_Coverage, 19342,
     /* 1906290 */     GIR_EraseRootFromParent_Done,
     /* 1906291 */   // Label 25657: @1906291
     /* 1906291 */   GIM_Try, /*On fail goto*//*Label 25658*/ GIMT_Encode4(1906377), // Rule ID 19343 //
     /* 1906296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1906299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1906304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1906307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1906310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1906313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1906316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1906326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906342 */     // MIs[0] policy
     /* 1906342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906352 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1906355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906376 */     // GIR_Coverage, 19343,
     /* 1906376 */     GIR_EraseRootFromParent_Done,
     /* 1906377 */   // Label 25658: @1906377
     /* 1906377 */   GIM_Try, /*On fail goto*//*Label 25659*/ GIMT_Encode4(1906463), // Rule ID 19346 //
     /* 1906382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1906390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1906393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1906396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1906399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906428 */     // MIs[0] policy
     /* 1906428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906438 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1906441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906462 */     // GIR_Coverage, 19346,
     /* 1906462 */     GIR_EraseRootFromParent_Done,
     /* 1906463 */   // Label 25659: @1906463
     /* 1906463 */   GIM_Try, /*On fail goto*//*Label 25660*/ GIMT_Encode4(1906549), // Rule ID 19347 //
     /* 1906468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1906476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1906479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1906482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1906485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906514 */     // MIs[0] policy
     /* 1906514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906524 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1906527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906548 */     // GIR_Coverage, 19347,
     /* 1906548 */     GIR_EraseRootFromParent_Done,
     /* 1906549 */   // Label 25660: @1906549
     /* 1906549 */   GIM_Try, /*On fail goto*//*Label 25661*/ GIMT_Encode4(1906635), // Rule ID 19350 //
     /* 1906554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1906562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1906565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1906568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1906571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906600 */     // MIs[0] policy
     /* 1906600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906610 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1906613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906634 */     // GIR_Coverage, 19350,
     /* 1906634 */     GIR_EraseRootFromParent_Done,
     /* 1906635 */   // Label 25661: @1906635
     /* 1906635 */   GIM_Try, /*On fail goto*//*Label 25662*/ GIMT_Encode4(1906721), // Rule ID 19351 //
     /* 1906640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1906648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1906651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1906654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1906657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906686 */     // MIs[0] policy
     /* 1906686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906696 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1906699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906720 */     // GIR_Coverage, 19351,
     /* 1906720 */     GIR_EraseRootFromParent_Done,
     /* 1906721 */   // Label 25662: @1906721
     /* 1906721 */   GIM_Try, /*On fail goto*//*Label 25663*/ GIMT_Encode4(1906807), // Rule ID 19354 //
     /* 1906726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1906729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1906734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1906737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1906740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1906743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1906746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1906768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906772 */     // MIs[0] policy
     /* 1906772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906782 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1906785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906806 */     // GIR_Coverage, 19354,
     /* 1906806 */     GIR_EraseRootFromParent_Done,
     /* 1906807 */   // Label 25663: @1906807
     /* 1906807 */   GIM_Try, /*On fail goto*//*Label 25664*/ GIMT_Encode4(1906893), // Rule ID 19355 //
     /* 1906812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1906815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1906820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1906823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1906826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1906829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1906832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1906854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906858 */     // MIs[0] policy
     /* 1906858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906868 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1906871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906892 */     // GIR_Coverage, 19355,
     /* 1906892 */     GIR_EraseRootFromParent_Done,
     /* 1906893 */   // Label 25664: @1906893
     /* 1906893 */   GIM_Try, /*On fail goto*//*Label 25665*/ GIMT_Encode4(1906979), // Rule ID 19358 //
     /* 1906898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1906906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1906909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1906912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1906915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906944 */     // MIs[0] policy
     /* 1906944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906954 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1906957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906978 */     // GIR_Coverage, 19358,
     /* 1906978 */     GIR_EraseRootFromParent_Done,
     /* 1906979 */   // Label 25665: @1906979
     /* 1906979 */   GIM_Try, /*On fail goto*//*Label 25666*/ GIMT_Encode4(1907065), // Rule ID 19359 //
     /* 1906984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1906992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1906995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1906998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1907001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907030 */     // MIs[0] policy
     /* 1907030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907040 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1907043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907064 */     // GIR_Coverage, 19359,
     /* 1907064 */     GIR_EraseRootFromParent_Done,
     /* 1907065 */   // Label 25666: @1907065
     /* 1907065 */   GIM_Try, /*On fail goto*//*Label 25667*/ GIMT_Encode4(1907151), // Rule ID 19362 //
     /* 1907070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1907078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1907081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1907084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1907087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1907090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1907112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907116 */     // MIs[0] policy
     /* 1907116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907126 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1907129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907150 */     // GIR_Coverage, 19362,
     /* 1907150 */     GIR_EraseRootFromParent_Done,
     /* 1907151 */   // Label 25667: @1907151
     /* 1907151 */   GIM_Try, /*On fail goto*//*Label 25668*/ GIMT_Encode4(1907237), // Rule ID 19363 //
     /* 1907156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1907164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1907167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1907170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1907173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1907176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1907198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907202 */     // MIs[0] policy
     /* 1907202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907212 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1907215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907236 */     // GIR_Coverage, 19363,
     /* 1907236 */     GIR_EraseRootFromParent_Done,
     /* 1907237 */   // Label 25668: @1907237
     /* 1907237 */   GIM_Try, /*On fail goto*//*Label 25669*/ GIMT_Encode4(1907323), // Rule ID 19366 //
     /* 1907242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1907250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1907253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1907256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1907259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1907262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1907265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1907284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907288 */     // MIs[0] policy
     /* 1907288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907298 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1907301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907322 */     // GIR_Coverage, 19366,
     /* 1907322 */     GIR_EraseRootFromParent_Done,
     /* 1907323 */   // Label 25669: @1907323
     /* 1907323 */   GIM_Try, /*On fail goto*//*Label 25670*/ GIMT_Encode4(1907409), // Rule ID 19367 //
     /* 1907328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1907336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1907339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1907342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1907345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1907348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1907351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1907370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907374 */     // MIs[0] policy
     /* 1907374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907384 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1907387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907408 */     // GIR_Coverage, 19367,
     /* 1907408 */     GIR_EraseRootFromParent_Done,
     /* 1907409 */   // Label 25670: @1907409
     /* 1907409 */   GIM_Try, /*On fail goto*//*Label 25671*/ GIMT_Encode4(1907495), // Rule ID 19370 //
     /* 1907414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1907422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1907425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1907428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1907431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907460 */     // MIs[0] policy
     /* 1907460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907470 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1907473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907494 */     // GIR_Coverage, 19370,
     /* 1907494 */     GIR_EraseRootFromParent_Done,
     /* 1907495 */   // Label 25671: @1907495
     /* 1907495 */   GIM_Try, /*On fail goto*//*Label 25672*/ GIMT_Encode4(1907581), // Rule ID 19371 //
     /* 1907500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1907508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1907511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1907514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1907517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907546 */     // MIs[0] policy
     /* 1907546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907556 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1907559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907580 */     // GIR_Coverage, 19371,
     /* 1907580 */     GIR_EraseRootFromParent_Done,
     /* 1907581 */   // Label 25672: @1907581
     /* 1907581 */   GIM_Try, /*On fail goto*//*Label 25673*/ GIMT_Encode4(1907667), // Rule ID 19374 //
     /* 1907586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1907594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1907597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1907600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1907603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907632 */     // MIs[0] policy
     /* 1907632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907642 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1907645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907666 */     // GIR_Coverage, 19374,
     /* 1907666 */     GIR_EraseRootFromParent_Done,
     /* 1907667 */   // Label 25673: @1907667
     /* 1907667 */   GIM_Try, /*On fail goto*//*Label 25674*/ GIMT_Encode4(1907753), // Rule ID 19375 //
     /* 1907672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1907680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1907683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1907686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1907689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907718 */     // MIs[0] policy
     /* 1907718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907728 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1907731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907752 */     // GIR_Coverage, 19375,
     /* 1907752 */     GIR_EraseRootFromParent_Done,
     /* 1907753 */   // Label 25674: @1907753
     /* 1907753 */   GIM_Try, /*On fail goto*//*Label 25675*/ GIMT_Encode4(1907839), // Rule ID 19378 //
     /* 1907758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1907766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1907769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1907772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1907775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1907781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907804 */     // MIs[0] policy
     /* 1907804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907814 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1907817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907838 */     // GIR_Coverage, 19378,
     /* 1907838 */     GIR_EraseRootFromParent_Done,
     /* 1907839 */   // Label 25675: @1907839
     /* 1907839 */   GIM_Try, /*On fail goto*//*Label 25676*/ GIMT_Encode4(1907925), // Rule ID 19379 //
     /* 1907844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1907852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1907855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1907858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1907861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1907867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907890 */     // MIs[0] policy
     /* 1907890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907900 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1907903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907924 */     // GIR_Coverage, 19379,
     /* 1907924 */     GIR_EraseRootFromParent_Done,
     /* 1907925 */   // Label 25676: @1907925
     /* 1907925 */   GIM_Try, /*On fail goto*//*Label 25677*/ GIMT_Encode4(1908011), // Rule ID 19382 //
     /* 1907930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1907938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1907941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1907944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1907947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1907950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1907972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907976 */     // MIs[0] policy
     /* 1907976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907986 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1907989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908010 */     // GIR_Coverage, 19382,
     /* 1908010 */     GIR_EraseRootFromParent_Done,
     /* 1908011 */   // Label 25677: @1908011
     /* 1908011 */   GIM_Try, /*On fail goto*//*Label 25678*/ GIMT_Encode4(1908097), // Rule ID 19383 //
     /* 1908016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1908024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1908027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1908030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1908033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1908046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908062 */     // MIs[0] policy
     /* 1908062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908072 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1908075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908096 */     // GIR_Coverage, 19383,
     /* 1908096 */     GIR_EraseRootFromParent_Done,
     /* 1908097 */   // Label 25678: @1908097
     /* 1908097 */   GIM_Try, /*On fail goto*//*Label 25679*/ GIMT_Encode4(1908183), // Rule ID 19386 //
     /* 1908102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1908110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1908113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1908116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1908119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1908132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908148 */     // MIs[0] policy
     /* 1908148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908158 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1908161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908182 */     // GIR_Coverage, 19386,
     /* 1908182 */     GIR_EraseRootFromParent_Done,
     /* 1908183 */   // Label 25679: @1908183
     /* 1908183 */   GIM_Try, /*On fail goto*//*Label 25680*/ GIMT_Encode4(1908269), // Rule ID 19387 //
     /* 1908188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1908196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1908199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1908202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1908205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1908218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908234 */     // MIs[0] policy
     /* 1908234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908244 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1908247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908268 */     // GIR_Coverage, 19387,
     /* 1908268 */     GIR_EraseRootFromParent_Done,
     /* 1908269 */   // Label 25680: @1908269
     /* 1908269 */   GIM_Try, /*On fail goto*//*Label 25681*/ GIMT_Encode4(1908355), // Rule ID 19390 //
     /* 1908274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1908282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1908285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1908288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1908291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1908297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1908304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908320 */     // MIs[0] policy
     /* 1908320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908330 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1908333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908354 */     // GIR_Coverage, 19390,
     /* 1908354 */     GIR_EraseRootFromParent_Done,
     /* 1908355 */   // Label 25681: @1908355
     /* 1908355 */   GIM_Try, /*On fail goto*//*Label 25682*/ GIMT_Encode4(1908441), // Rule ID 19391 //
     /* 1908360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1908368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1908371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1908374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1908377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1908383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1908390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908406 */     // MIs[0] policy
     /* 1908406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908416 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1908419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908440 */     // GIR_Coverage, 19391,
     /* 1908440 */     GIR_EraseRootFromParent_Done,
     /* 1908441 */   // Label 25682: @1908441
     /* 1908441 */   GIM_Try, /*On fail goto*//*Label 25683*/ GIMT_Encode4(1908527), // Rule ID 19394 //
     /* 1908446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1908449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1908454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1908457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1908460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1908463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1908476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908492 */     // MIs[0] policy
     /* 1908492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908502 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1908505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908526 */     // GIR_Coverage, 19394,
     /* 1908526 */     GIR_EraseRootFromParent_Done,
     /* 1908527 */   // Label 25683: @1908527
     /* 1908527 */   GIM_Try, /*On fail goto*//*Label 25684*/ GIMT_Encode4(1908613), // Rule ID 19395 //
     /* 1908532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1908535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1908540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1908543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1908546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1908549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1908562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908578 */     // MIs[0] policy
     /* 1908578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908588 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1908591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908612 */     // GIR_Coverage, 19395,
     /* 1908612 */     GIR_EraseRootFromParent_Done,
     /* 1908613 */   // Label 25684: @1908613
     /* 1908613 */   GIM_Try, /*On fail goto*//*Label 25685*/ GIMT_Encode4(1908699), // Rule ID 19398 //
     /* 1908618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1908621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1908626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1908629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1908632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1908635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1908648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908664 */     // MIs[0] policy
     /* 1908664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908674 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1908677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908698 */     // GIR_Coverage, 19398,
     /* 1908698 */     GIR_EraseRootFromParent_Done,
     /* 1908699 */   // Label 25685: @1908699
     /* 1908699 */   GIM_Try, /*On fail goto*//*Label 25686*/ GIMT_Encode4(1908785), // Rule ID 19399 //
     /* 1908704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1908707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1908712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1908715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1908718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1908721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1908734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908750 */     // MIs[0] policy
     /* 1908750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908760 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1908763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908784 */     // GIR_Coverage, 19399,
     /* 1908784 */     GIR_EraseRootFromParent_Done,
     /* 1908785 */   // Label 25686: @1908785
     /* 1908785 */   GIM_Try, /*On fail goto*//*Label 25687*/ GIMT_Encode4(1908871), // Rule ID 19402 //
     /* 1908790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1908793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1908798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1908801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1908804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1908807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1908820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908836 */     // MIs[0] policy
     /* 1908836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908846 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1908849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908870 */     // GIR_Coverage, 19402,
     /* 1908870 */     GIR_EraseRootFromParent_Done,
     /* 1908871 */   // Label 25687: @1908871
     /* 1908871 */   GIM_Try, /*On fail goto*//*Label 25688*/ GIMT_Encode4(1908957), // Rule ID 19403 //
     /* 1908876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1908879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1908884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1908887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1908890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1908893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1908906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908922 */     // MIs[0] policy
     /* 1908922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908932 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1908935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908956 */     // GIR_Coverage, 19403,
     /* 1908956 */     GIR_EraseRootFromParent_Done,
     /* 1908957 */   // Label 25688: @1908957
     /* 1908957 */   GIM_Try, /*On fail goto*//*Label 25689*/ GIMT_Encode4(1909043), // Rule ID 19406 //
     /* 1908962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1908973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1908976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1908979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1908982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909008 */     // MIs[0] policy
     /* 1909008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909018 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1909021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909042 */     // GIR_Coverage, 19406,
     /* 1909042 */     GIR_EraseRootFromParent_Done,
     /* 1909043 */   // Label 25689: @1909043
     /* 1909043 */   GIM_Try, /*On fail goto*//*Label 25690*/ GIMT_Encode4(1909129), // Rule ID 19407 //
     /* 1909048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1909059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1909062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1909065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1909068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909094 */     // MIs[0] policy
     /* 1909094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909104 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1909107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909128 */     // GIR_Coverage, 19407,
     /* 1909128 */     GIR_EraseRootFromParent_Done,
     /* 1909129 */   // Label 25690: @1909129
     /* 1909129 */   GIM_Try, /*On fail goto*//*Label 25691*/ GIMT_Encode4(1909215), // Rule ID 19410 //
     /* 1909134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1909145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1909148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1909151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1909154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909180 */     // MIs[0] policy
     /* 1909180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909190 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1909193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909214 */     // GIR_Coverage, 19410,
     /* 1909214 */     GIR_EraseRootFromParent_Done,
     /* 1909215 */   // Label 25691: @1909215
     /* 1909215 */   GIM_Try, /*On fail goto*//*Label 25692*/ GIMT_Encode4(1909301), // Rule ID 19411 //
     /* 1909220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1909231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1909234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1909237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1909240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909266 */     // MIs[0] policy
     /* 1909266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909276 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1909279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909300 */     // GIR_Coverage, 19411,
     /* 1909300 */     GIR_EraseRootFromParent_Done,
     /* 1909301 */   // Label 25692: @1909301
     /* 1909301 */   GIM_Try, /*On fail goto*//*Label 25693*/ GIMT_Encode4(1909387), // Rule ID 19414 //
     /* 1909306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1909317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1909320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1909323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1909326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909352 */     // MIs[0] policy
     /* 1909352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909362 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1909365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909386 */     // GIR_Coverage, 19414,
     /* 1909386 */     GIR_EraseRootFromParent_Done,
     /* 1909387 */   // Label 25693: @1909387
     /* 1909387 */   GIM_Try, /*On fail goto*//*Label 25694*/ GIMT_Encode4(1909473), // Rule ID 19415 //
     /* 1909392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1909403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1909406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1909409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1909412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909438 */     // MIs[0] policy
     /* 1909438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909448 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1909451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909472 */     // GIR_Coverage, 19415,
     /* 1909472 */     GIR_EraseRootFromParent_Done,
     /* 1909473 */   // Label 25694: @1909473
     /* 1909473 */   GIM_Try, /*On fail goto*//*Label 25695*/ GIMT_Encode4(1909559), // Rule ID 19418 //
     /* 1909478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1909489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1909492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1909495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1909498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909524 */     // MIs[0] policy
     /* 1909524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909534 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1909537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909558 */     // GIR_Coverage, 19418,
     /* 1909558 */     GIR_EraseRootFromParent_Done,
     /* 1909559 */   // Label 25695: @1909559
     /* 1909559 */   GIM_Try, /*On fail goto*//*Label 25696*/ GIMT_Encode4(1909645), // Rule ID 19419 //
     /* 1909564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1909575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1909578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1909581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1909584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909610 */     // MIs[0] policy
     /* 1909610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909620 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1909623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909644 */     // GIR_Coverage, 19419,
     /* 1909644 */     GIR_EraseRootFromParent_Done,
     /* 1909645 */   // Label 25696: @1909645
     /* 1909645 */   GIM_Try, /*On fail goto*//*Label 25697*/ GIMT_Encode4(1909731), // Rule ID 19422 //
     /* 1909650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1909661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1909664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1909667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1909670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909696 */     // MIs[0] policy
     /* 1909696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909706 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1909709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909730 */     // GIR_Coverage, 19422,
     /* 1909730 */     GIR_EraseRootFromParent_Done,
     /* 1909731 */   // Label 25697: @1909731
     /* 1909731 */   GIM_Try, /*On fail goto*//*Label 25698*/ GIMT_Encode4(1909817), // Rule ID 19423 //
     /* 1909736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1909747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1909750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1909753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1909756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909782 */     // MIs[0] policy
     /* 1909782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909792 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1909795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909816 */     // GIR_Coverage, 19423,
     /* 1909816 */     GIR_EraseRootFromParent_Done,
     /* 1909817 */   // Label 25698: @1909817
     /* 1909817 */   GIM_Try, /*On fail goto*//*Label 25699*/ GIMT_Encode4(1909903), // Rule ID 19426 //
     /* 1909822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1909825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1909833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1909836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1909839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1909842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909868 */     // MIs[0] policy
     /* 1909868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909878 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1909881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1909899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909902 */     // GIR_Coverage, 19426,
     /* 1909902 */     GIR_EraseRootFromParent_Done,
     /* 1909903 */   // Label 25699: @1909903
     /* 1909903 */   GIM_Try, /*On fail goto*//*Label 25700*/ GIMT_Encode4(1909989), // Rule ID 19427 //
     /* 1909908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1909911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1909919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1909922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1909925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1909928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909954 */     // MIs[0] policy
     /* 1909954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909964 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1909967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1909985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909988 */     // GIR_Coverage, 19427,
     /* 1909988 */     GIR_EraseRootFromParent_Done,
     /* 1909989 */   // Label 25700: @1909989
     /* 1909989 */   GIM_Try, /*On fail goto*//*Label 25701*/ GIMT_Encode4(1910075), // Rule ID 19430 //
     /* 1909994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1910005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1910008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1910011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1910014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910040 */     // MIs[0] policy
     /* 1910040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910050 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1910053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910074 */     // GIR_Coverage, 19430,
     /* 1910074 */     GIR_EraseRootFromParent_Done,
     /* 1910075 */   // Label 25701: @1910075
     /* 1910075 */   GIM_Try, /*On fail goto*//*Label 25702*/ GIMT_Encode4(1910161), // Rule ID 19431 //
     /* 1910080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1910091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1910094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1910097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1910100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910126 */     // MIs[0] policy
     /* 1910126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910136 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1910139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910160 */     // GIR_Coverage, 19431,
     /* 1910160 */     GIR_EraseRootFromParent_Done,
     /* 1910161 */   // Label 25702: @1910161
     /* 1910161 */   GIM_Try, /*On fail goto*//*Label 25703*/ GIMT_Encode4(1910247), // Rule ID 19434 //
     /* 1910166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1910177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1910180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1910183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1910186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910212 */     // MIs[0] policy
     /* 1910212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910222 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1910225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910246 */     // GIR_Coverage, 19434,
     /* 1910246 */     GIR_EraseRootFromParent_Done,
     /* 1910247 */   // Label 25703: @1910247
     /* 1910247 */   GIM_Try, /*On fail goto*//*Label 25704*/ GIMT_Encode4(1910333), // Rule ID 19435 //
     /* 1910252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1910263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1910266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1910269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1910272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910298 */     // MIs[0] policy
     /* 1910298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910308 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1910311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910332 */     // GIR_Coverage, 19435,
     /* 1910332 */     GIR_EraseRootFromParent_Done,
     /* 1910333 */   // Label 25704: @1910333
     /* 1910333 */   GIM_Try, /*On fail goto*//*Label 25705*/ GIMT_Encode4(1910419), // Rule ID 19438 //
     /* 1910338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1910349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1910352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1910355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1910358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1910361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910384 */     // MIs[0] policy
     /* 1910384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910394 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1910397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910418 */     // GIR_Coverage, 19438,
     /* 1910418 */     GIR_EraseRootFromParent_Done,
     /* 1910419 */   // Label 25705: @1910419
     /* 1910419 */   GIM_Try, /*On fail goto*//*Label 25706*/ GIMT_Encode4(1910505), // Rule ID 19439 //
     /* 1910424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1910435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1910438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1910441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1910444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1910447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910470 */     // MIs[0] policy
     /* 1910470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910480 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1910483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910504 */     // GIR_Coverage, 19439,
     /* 1910504 */     GIR_EraseRootFromParent_Done,
     /* 1910505 */   // Label 25706: @1910505
     /* 1910505 */   GIM_Try, /*On fail goto*//*Label 25707*/ GIMT_Encode4(1910591), // Rule ID 19442 //
     /* 1910510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1910521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1910524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1910527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1910530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910556 */     // MIs[0] policy
     /* 1910556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910566 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1910569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910590 */     // GIR_Coverage, 19442,
     /* 1910590 */     GIR_EraseRootFromParent_Done,
     /* 1910591 */   // Label 25707: @1910591
     /* 1910591 */   GIM_Try, /*On fail goto*//*Label 25708*/ GIMT_Encode4(1910677), // Rule ID 19443 //
     /* 1910596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1910599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1910607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1910610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1910613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1910616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910642 */     // MIs[0] policy
     /* 1910642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910652 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1910655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910676 */     // GIR_Coverage, 19443,
     /* 1910676 */     GIR_EraseRootFromParent_Done,
     /* 1910677 */   // Label 25708: @1910677
     /* 1910677 */   GIM_Try, /*On fail goto*//*Label 25709*/ GIMT_Encode4(1910763), // Rule ID 19446 //
     /* 1910682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1910693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1910696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1910699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1910702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910728 */     // MIs[0] policy
     /* 1910728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910738 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1910741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910762 */     // GIR_Coverage, 19446,
     /* 1910762 */     GIR_EraseRootFromParent_Done,
     /* 1910763 */   // Label 25709: @1910763
     /* 1910763 */   GIM_Try, /*On fail goto*//*Label 25710*/ GIMT_Encode4(1910849), // Rule ID 19447 //
     /* 1910768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1910771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1910779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1910782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1910785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1910788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910814 */     // MIs[0] policy
     /* 1910814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910824 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1910827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910848 */     // GIR_Coverage, 19447,
     /* 1910848 */     GIR_EraseRootFromParent_Done,
     /* 1910849 */   // Label 25710: @1910849
     /* 1910849 */   GIM_Try, /*On fail goto*//*Label 25711*/ GIMT_Encode4(1910935), // Rule ID 19450 //
     /* 1910854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1910865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1910868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1910871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1910874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910900 */     // MIs[0] policy
     /* 1910900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910910 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1910913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910934 */     // GIR_Coverage, 19450,
     /* 1910934 */     GIR_EraseRootFromParent_Done,
     /* 1910935 */   // Label 25711: @1910935
     /* 1910935 */   GIM_Try, /*On fail goto*//*Label 25712*/ GIMT_Encode4(1911021), // Rule ID 19451 //
     /* 1910940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1910943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1910951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1910954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1910957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1910960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910986 */     // MIs[0] policy
     /* 1910986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910996 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1910999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911020 */     // GIR_Coverage, 19451,
     /* 1911020 */     GIR_EraseRootFromParent_Done,
     /* 1911021 */   // Label 25712: @1911021
     /* 1911021 */   GIM_Try, /*On fail goto*//*Label 25713*/ GIMT_Encode4(1911107), // Rule ID 19454 //
     /* 1911026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1911029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1911034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1911037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1911040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1911043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1911046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911072 */     // MIs[0] policy
     /* 1911072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911082 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1911085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911106 */     // GIR_Coverage, 19454,
     /* 1911106 */     GIR_EraseRootFromParent_Done,
     /* 1911107 */   // Label 25713: @1911107
     /* 1911107 */   GIM_Try, /*On fail goto*//*Label 25714*/ GIMT_Encode4(1911193), // Rule ID 19455 //
     /* 1911112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1911115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1911120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1911123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1911126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1911129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1911132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911158 */     // MIs[0] policy
     /* 1911158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911168 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1911171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911192 */     // GIR_Coverage, 19455,
     /* 1911192 */     GIR_EraseRootFromParent_Done,
     /* 1911193 */   // Label 25714: @1911193
     /* 1911193 */   GIM_Try, /*On fail goto*//*Label 25715*/ GIMT_Encode4(1911279), // Rule ID 19458 //
     /* 1911198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1911201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1911206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1911209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1911212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1911215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1911218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1911228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911244 */     // MIs[0] policy
     /* 1911244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911254 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1911257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911278 */     // GIR_Coverage, 19458,
     /* 1911278 */     GIR_EraseRootFromParent_Done,
     /* 1911279 */   // Label 25715: @1911279
     /* 1911279 */   GIM_Try, /*On fail goto*//*Label 25716*/ GIMT_Encode4(1911365), // Rule ID 19459 //
     /* 1911284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1911287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1911292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1911295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1911298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1911301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1911304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1911314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911330 */     // MIs[0] policy
     /* 1911330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911340 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1911343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911364 */     // GIR_Coverage, 19459,
     /* 1911364 */     GIR_EraseRootFromParent_Done,
     /* 1911365 */   // Label 25716: @1911365
     /* 1911365 */   GIM_Try, /*On fail goto*//*Label 25717*/ GIMT_Encode4(1911451), // Rule ID 19462 //
     /* 1911370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1911373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1911378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1911381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1911384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1911387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1911390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1911400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911416 */     // MIs[0] policy
     /* 1911416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911426 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1911429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911450 */     // GIR_Coverage, 19462,
     /* 1911450 */     GIR_EraseRootFromParent_Done,
     /* 1911451 */   // Label 25717: @1911451
     /* 1911451 */   GIM_Try, /*On fail goto*//*Label 25718*/ GIMT_Encode4(1911537), // Rule ID 19463 //
     /* 1911456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1911459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1911464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1911467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1911470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1911473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1911476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1911486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911502 */     // MIs[0] policy
     /* 1911502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911512 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1911515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911536 */     // GIR_Coverage, 19463,
     /* 1911536 */     GIR_EraseRootFromParent_Done,
     /* 1911537 */   // Label 25718: @1911537
     /* 1911537 */   GIM_Try, /*On fail goto*//*Label 25719*/ GIMT_Encode4(1911623), // Rule ID 19466 //
     /* 1911542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1911550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1911553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1911556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1911559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911588 */     // MIs[0] policy
     /* 1911588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911598 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1911601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911622 */     // GIR_Coverage, 19466,
     /* 1911622 */     GIR_EraseRootFromParent_Done,
     /* 1911623 */   // Label 25719: @1911623
     /* 1911623 */   GIM_Try, /*On fail goto*//*Label 25720*/ GIMT_Encode4(1911709), // Rule ID 19467 //
     /* 1911628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1911636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1911639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1911642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1911645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911674 */     // MIs[0] policy
     /* 1911674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911684 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1911687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911708 */     // GIR_Coverage, 19467,
     /* 1911708 */     GIR_EraseRootFromParent_Done,
     /* 1911709 */   // Label 25720: @1911709
     /* 1911709 */   GIM_Try, /*On fail goto*//*Label 25721*/ GIMT_Encode4(1911795), // Rule ID 19470 //
     /* 1911714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1911722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1911725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1911728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1911731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911760 */     // MIs[0] policy
     /* 1911760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911770 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1911773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911794 */     // GIR_Coverage, 19470,
     /* 1911794 */     GIR_EraseRootFromParent_Done,
     /* 1911795 */   // Label 25721: @1911795
     /* 1911795 */   GIM_Try, /*On fail goto*//*Label 25722*/ GIMT_Encode4(1911881), // Rule ID 19471 //
     /* 1911800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1911808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1911811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1911814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1911817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911846 */     // MIs[0] policy
     /* 1911846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911856 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1911859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911880 */     // GIR_Coverage, 19471,
     /* 1911880 */     GIR_EraseRootFromParent_Done,
     /* 1911881 */   // Label 25722: @1911881
     /* 1911881 */   GIM_Try, /*On fail goto*//*Label 25723*/ GIMT_Encode4(1911967), // Rule ID 19474 //
     /* 1911886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1911889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1911894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1911897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1911900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1911903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1911906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1911928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911932 */     // MIs[0] policy
     /* 1911932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911942 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1911945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911966 */     // GIR_Coverage, 19474,
     /* 1911966 */     GIR_EraseRootFromParent_Done,
     /* 1911967 */   // Label 25723: @1911967
     /* 1911967 */   GIM_Try, /*On fail goto*//*Label 25724*/ GIMT_Encode4(1912053), // Rule ID 19475 //
     /* 1911972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1911975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1911980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1911983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1911986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1911989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1911992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1912014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912018 */     // MIs[0] policy
     /* 1912018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912028 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1912031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912052 */     // GIR_Coverage, 19475,
     /* 1912052 */     GIR_EraseRootFromParent_Done,
     /* 1912053 */   // Label 25724: @1912053
     /* 1912053 */   GIM_Try, /*On fail goto*//*Label 25725*/ GIMT_Encode4(1912139), // Rule ID 19478 //
     /* 1912058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1912061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1912066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1912069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1912072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1912075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912104 */     // MIs[0] policy
     /* 1912104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912114 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1912117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912138 */     // GIR_Coverage, 19478,
     /* 1912138 */     GIR_EraseRootFromParent_Done,
     /* 1912139 */   // Label 25725: @1912139
     /* 1912139 */   GIM_Try, /*On fail goto*//*Label 25726*/ GIMT_Encode4(1912225), // Rule ID 19479 //
     /* 1912144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1912152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1912155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1912158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1912161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912190 */     // MIs[0] policy
     /* 1912190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912200 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1912203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912224 */     // GIR_Coverage, 19479,
     /* 1912224 */     GIR_EraseRootFromParent_Done,
     /* 1912225 */   // Label 25726: @1912225
     /* 1912225 */   GIM_Try, /*On fail goto*//*Label 25727*/ GIMT_Encode4(1912311), // Rule ID 19482 //
     /* 1912230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1912238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1912241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1912244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1912247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1912272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912276 */     // MIs[0] policy
     /* 1912276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912286 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1912289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912310 */     // GIR_Coverage, 19482,
     /* 1912310 */     GIR_EraseRootFromParent_Done,
     /* 1912311 */   // Label 25727: @1912311
     /* 1912311 */   GIM_Try, /*On fail goto*//*Label 25728*/ GIMT_Encode4(1912397), // Rule ID 19483 //
     /* 1912316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1912324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1912327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1912330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1912333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1912358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912362 */     // MIs[0] policy
     /* 1912362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912372 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1912375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912396 */     // GIR_Coverage, 19483,
     /* 1912396 */     GIR_EraseRootFromParent_Done,
     /* 1912397 */   // Label 25728: @1912397
     /* 1912397 */   GIM_Try, /*On fail goto*//*Label 25729*/ GIMT_Encode4(1912483), // Rule ID 19486 //
     /* 1912402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1912410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1912413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1912416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1912419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1912422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1912425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1912444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912448 */     // MIs[0] policy
     /* 1912448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912458 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1912461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912482 */     // GIR_Coverage, 19486,
     /* 1912482 */     GIR_EraseRootFromParent_Done,
     /* 1912483 */   // Label 25729: @1912483
     /* 1912483 */   GIM_Try, /*On fail goto*//*Label 25730*/ GIMT_Encode4(1912569), // Rule ID 19487 //
     /* 1912488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1912491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1912496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1912499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1912502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1912505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1912508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1912511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1912530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912534 */     // MIs[0] policy
     /* 1912534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912544 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1912547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912568 */     // GIR_Coverage, 19487,
     /* 1912568 */     GIR_EraseRootFromParent_Done,
     /* 1912569 */   // Label 25730: @1912569
     /* 1912569 */   GIM_Try, /*On fail goto*//*Label 25731*/ GIMT_Encode4(1912655), // Rule ID 19490 //
     /* 1912574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1912577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1912582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1912585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1912588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1912591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912620 */     // MIs[0] policy
     /* 1912620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912630 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1912633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912654 */     // GIR_Coverage, 19490,
     /* 1912654 */     GIR_EraseRootFromParent_Done,
     /* 1912655 */   // Label 25731: @1912655
     /* 1912655 */   GIM_Try, /*On fail goto*//*Label 25732*/ GIMT_Encode4(1912741), // Rule ID 19491 //
     /* 1912660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1912668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1912671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1912674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1912677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912706 */     // MIs[0] policy
     /* 1912706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912716 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1912719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912740 */     // GIR_Coverage, 19491,
     /* 1912740 */     GIR_EraseRootFromParent_Done,
     /* 1912741 */   // Label 25732: @1912741
     /* 1912741 */   GIM_Try, /*On fail goto*//*Label 25733*/ GIMT_Encode4(1912827), // Rule ID 19494 //
     /* 1912746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1912749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1912754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1912757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1912760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1912763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912792 */     // MIs[0] policy
     /* 1912792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912802 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1912805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912826 */     // GIR_Coverage, 19494,
     /* 1912826 */     GIR_EraseRootFromParent_Done,
     /* 1912827 */   // Label 25733: @1912827
     /* 1912827 */   GIM_Try, /*On fail goto*//*Label 25734*/ GIMT_Encode4(1912913), // Rule ID 19495 //
     /* 1912832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1912840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1912843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1912846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1912849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912878 */     // MIs[0] policy
     /* 1912878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912888 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1912891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912912 */     // GIR_Coverage, 19495,
     /* 1912912 */     GIR_EraseRootFromParent_Done,
     /* 1912913 */   // Label 25734: @1912913
     /* 1912913 */   GIM_Try, /*On fail goto*//*Label 25735*/ GIMT_Encode4(1912999), // Rule ID 19498 //
     /* 1912918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1912921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1912926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1912929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1912932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1912935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1912941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912964 */     // MIs[0] policy
     /* 1912964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912974 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1912977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912998 */     // GIR_Coverage, 19498,
     /* 1912998 */     GIR_EraseRootFromParent_Done,
     /* 1912999 */   // Label 25735: @1912999
     /* 1912999 */   GIM_Try, /*On fail goto*//*Label 25736*/ GIMT_Encode4(1913085), // Rule ID 19499 //
     /* 1913004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1913012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1913015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1913018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1913021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1913027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913050 */     // MIs[0] policy
     /* 1913050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913060 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1913063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913084 */     // GIR_Coverage, 19499,
     /* 1913084 */     GIR_EraseRootFromParent_Done,
     /* 1913085 */   // Label 25736: @1913085
     /* 1913085 */   GIM_Try, /*On fail goto*//*Label 25737*/ GIMT_Encode4(1913171), // Rule ID 19502 //
     /* 1913090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1913093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1913098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1913101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1913104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1913107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913136 */     // MIs[0] policy
     /* 1913136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913146 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1913149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913170 */     // GIR_Coverage, 19502,
     /* 1913170 */     GIR_EraseRootFromParent_Done,
     /* 1913171 */   // Label 25737: @1913171
     /* 1913171 */   GIM_Try, /*On fail goto*//*Label 25738*/ GIMT_Encode4(1913257), // Rule ID 19503 //
     /* 1913176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1913184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1913187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1913190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1913193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913222 */     // MIs[0] policy
     /* 1913222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913232 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1913235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913256 */     // GIR_Coverage, 19503,
     /* 1913256 */     GIR_EraseRootFromParent_Done,
     /* 1913257 */   // Label 25738: @1913257
     /* 1913257 */   GIM_Try, /*On fail goto*//*Label 25739*/ GIMT_Encode4(1913343), // Rule ID 19506 //
     /* 1913262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1913265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1913270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1913273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1913276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1913279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913308 */     // MIs[0] policy
     /* 1913308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913318 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1913321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913342 */     // GIR_Coverage, 19506,
     /* 1913342 */     GIR_EraseRootFromParent_Done,
     /* 1913343 */   // Label 25739: @1913343
     /* 1913343 */   GIM_Try, /*On fail goto*//*Label 25740*/ GIMT_Encode4(1913429), // Rule ID 19507 //
     /* 1913348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1913356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1913359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1913362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1913365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913394 */     // MIs[0] policy
     /* 1913394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913404 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1913407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913428 */     // GIR_Coverage, 19507,
     /* 1913428 */     GIR_EraseRootFromParent_Done,
     /* 1913429 */   // Label 25740: @1913429
     /* 1913429 */   GIM_Try, /*On fail goto*//*Label 25741*/ GIMT_Encode4(1913515), // Rule ID 19510 //
     /* 1913434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1913437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1913442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1913445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1913448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1913451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1913457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913480 */     // MIs[0] policy
     /* 1913480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913490 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1913493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913514 */     // GIR_Coverage, 19510,
     /* 1913514 */     GIR_EraseRootFromParent_Done,
     /* 1913515 */   // Label 25741: @1913515
     /* 1913515 */   GIM_Try, /*On fail goto*//*Label 25742*/ GIMT_Encode4(1913601), // Rule ID 19511 //
     /* 1913520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1913528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1913531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1913534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1913537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1913543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913566 */     // MIs[0] policy
     /* 1913566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913576 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1913579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913600 */     // GIR_Coverage, 19511,
     /* 1913600 */     GIR_EraseRootFromParent_Done,
     /* 1913601 */   // Label 25742: @1913601
     /* 1913601 */   GIM_Try, /*On fail goto*//*Label 25743*/ GIMT_Encode4(1913687), // Rule ID 19514 //
     /* 1913606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1913609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1913614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1913617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1913620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1913623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913652 */     // MIs[0] policy
     /* 1913652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913662 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1913665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913686 */     // GIR_Coverage, 19514,
     /* 1913686 */     GIR_EraseRootFromParent_Done,
     /* 1913687 */   // Label 25743: @1913687
     /* 1913687 */   GIM_Try, /*On fail goto*//*Label 25744*/ GIMT_Encode4(1913773), // Rule ID 19515 //
     /* 1913692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1913695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1913700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1913703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1913706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1913709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913738 */     // MIs[0] policy
     /* 1913738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913748 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1913751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913772 */     // GIR_Coverage, 19515,
     /* 1913772 */     GIR_EraseRootFromParent_Done,
     /* 1913773 */   // Label 25744: @1913773
     /* 1913773 */   GIM_Try, /*On fail goto*//*Label 25745*/ GIMT_Encode4(1913859), // Rule ID 19518 //
     /* 1913778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1913781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1913786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1913789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1913792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1913795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913824 */     // MIs[0] policy
     /* 1913824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913834 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1913837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913858 */     // GIR_Coverage, 19518,
     /* 1913858 */     GIR_EraseRootFromParent_Done,
     /* 1913859 */   // Label 25745: @1913859
     /* 1913859 */   GIM_Try, /*On fail goto*//*Label 25746*/ GIMT_Encode4(1913945), // Rule ID 19519 //
     /* 1913864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1913867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1913872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1913875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1913878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1913881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913910 */     // MIs[0] policy
     /* 1913910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913920 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1913923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913944 */     // GIR_Coverage, 19519,
     /* 1913944 */     GIR_EraseRootFromParent_Done,
     /* 1913945 */   // Label 25746: @1913945
     /* 1913945 */   GIM_Try, /*On fail goto*//*Label 25747*/ GIMT_Encode4(1914031), // Rule ID 19522 //
     /* 1913950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1913953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1913958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1913961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1913964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1913967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913996 */     // MIs[0] policy
     /* 1913996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914006 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1914009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914030 */     // GIR_Coverage, 19522,
     /* 1914030 */     GIR_EraseRootFromParent_Done,
     /* 1914031 */   // Label 25747: @1914031
     /* 1914031 */   GIM_Try, /*On fail goto*//*Label 25748*/ GIMT_Encode4(1914117), // Rule ID 19523 //
     /* 1914036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1914039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1914044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1914047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1914050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1914053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1914078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914082 */     // MIs[0] policy
     /* 1914082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914092 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1914095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914116 */     // GIR_Coverage, 19523,
     /* 1914116 */     GIR_EraseRootFromParent_Done,
     /* 1914117 */   // Label 25748: @1914117
     /* 1914117 */   GIM_Try, /*On fail goto*//*Label 25749*/ GIMT_Encode4(1914203), // Rule ID 19526 //
     /* 1914122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1914133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1914136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1914139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1914142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914168 */     // MIs[0] policy
     /* 1914168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914178 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1914181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914202 */     // GIR_Coverage, 19526,
     /* 1914202 */     GIR_EraseRootFromParent_Done,
     /* 1914203 */   // Label 25749: @1914203
     /* 1914203 */   GIM_Try, /*On fail goto*//*Label 25750*/ GIMT_Encode4(1914289), // Rule ID 19527 //
     /* 1914208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1914219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1914222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1914225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1914228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914254 */     // MIs[0] policy
     /* 1914254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914264 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1914267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914288 */     // GIR_Coverage, 19527,
     /* 1914288 */     GIR_EraseRootFromParent_Done,
     /* 1914289 */   // Label 25750: @1914289
     /* 1914289 */   GIM_Try, /*On fail goto*//*Label 25751*/ GIMT_Encode4(1914375), // Rule ID 19530 //
     /* 1914294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1914305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1914308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1914311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1914314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914340 */     // MIs[0] policy
     /* 1914340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914350 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1914353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914374 */     // GIR_Coverage, 19530,
     /* 1914374 */     GIR_EraseRootFromParent_Done,
     /* 1914375 */   // Label 25751: @1914375
     /* 1914375 */   GIM_Try, /*On fail goto*//*Label 25752*/ GIMT_Encode4(1914461), // Rule ID 19531 //
     /* 1914380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1914391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1914394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1914397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1914400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914426 */     // MIs[0] policy
     /* 1914426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914436 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1914439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914460 */     // GIR_Coverage, 19531,
     /* 1914460 */     GIR_EraseRootFromParent_Done,
     /* 1914461 */   // Label 25752: @1914461
     /* 1914461 */   GIM_Try, /*On fail goto*//*Label 25753*/ GIMT_Encode4(1914547), // Rule ID 19534 //
     /* 1914466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1914477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1914480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1914483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1914486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914512 */     // MIs[0] policy
     /* 1914512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914522 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1914525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914546 */     // GIR_Coverage, 19534,
     /* 1914546 */     GIR_EraseRootFromParent_Done,
     /* 1914547 */   // Label 25753: @1914547
     /* 1914547 */   GIM_Try, /*On fail goto*//*Label 25754*/ GIMT_Encode4(1914633), // Rule ID 19535 //
     /* 1914552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1914555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1914563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1914566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1914569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1914572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914598 */     // MIs[0] policy
     /* 1914598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914608 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1914611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914632 */     // GIR_Coverage, 19535,
     /* 1914632 */     GIR_EraseRootFromParent_Done,
     /* 1914633 */   // Label 25754: @1914633
     /* 1914633 */   GIM_Try, /*On fail goto*//*Label 25755*/ GIMT_Encode4(1914719), // Rule ID 19538 //
     /* 1914638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1914649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1914652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1914655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1914658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914684 */     // MIs[0] policy
     /* 1914684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914694 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1914697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914718 */     // GIR_Coverage, 19538,
     /* 1914718 */     GIR_EraseRootFromParent_Done,
     /* 1914719 */   // Label 25755: @1914719
     /* 1914719 */   GIM_Try, /*On fail goto*//*Label 25756*/ GIMT_Encode4(1914805), // Rule ID 19539 //
     /* 1914724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1914735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1914738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1914741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1914744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914770 */     // MIs[0] policy
     /* 1914770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914780 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1914783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914804 */     // GIR_Coverage, 19539,
     /* 1914804 */     GIR_EraseRootFromParent_Done,
     /* 1914805 */   // Label 25756: @1914805
     /* 1914805 */   GIM_Try, /*On fail goto*//*Label 25757*/ GIMT_Encode4(1914891), // Rule ID 19542 //
     /* 1914810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1914821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1914824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1914827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1914830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914856 */     // MIs[0] policy
     /* 1914856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914866 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1914869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914890 */     // GIR_Coverage, 19542,
     /* 1914890 */     GIR_EraseRootFromParent_Done,
     /* 1914891 */   // Label 25757: @1914891
     /* 1914891 */   GIM_Try, /*On fail goto*//*Label 25758*/ GIMT_Encode4(1914977), // Rule ID 19543 //
     /* 1914896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1914899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1914907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1914910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1914913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1914916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914942 */     // MIs[0] policy
     /* 1914942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914952 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1914955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914976 */     // GIR_Coverage, 19543,
     /* 1914976 */     GIR_EraseRootFromParent_Done,
     /* 1914977 */   // Label 25758: @1914977
     /* 1914977 */   GIM_Try, /*On fail goto*//*Label 25759*/ GIMT_Encode4(1915063), // Rule ID 19546 //
     /* 1914982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1914985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1914993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1914996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1914999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1915002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915028 */     // MIs[0] policy
     /* 1915028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915038 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1915041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915062 */     // GIR_Coverage, 19546,
     /* 1915062 */     GIR_EraseRootFromParent_Done,
     /* 1915063 */   // Label 25759: @1915063
     /* 1915063 */   GIM_Try, /*On fail goto*//*Label 25760*/ GIMT_Encode4(1915149), // Rule ID 19547 //
     /* 1915068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1915079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1915082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1915085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1915088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915114 */     // MIs[0] policy
     /* 1915114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915124 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1915127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915148 */     // GIR_Coverage, 19547,
     /* 1915148 */     GIR_EraseRootFromParent_Done,
     /* 1915149 */   // Label 25760: @1915149
     /* 1915149 */   GIM_Try, /*On fail goto*//*Label 25761*/ GIMT_Encode4(1915235), // Rule ID 19550 //
     /* 1915154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1915157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1915165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1915168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1915171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1915174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915200 */     // MIs[0] policy
     /* 1915200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915210 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1915213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915234 */     // GIR_Coverage, 19550,
     /* 1915234 */     GIR_EraseRootFromParent_Done,
     /* 1915235 */   // Label 25761: @1915235
     /* 1915235 */   GIM_Try, /*On fail goto*//*Label 25762*/ GIMT_Encode4(1915321), // Rule ID 19551 //
     /* 1915240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1915243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1915251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1915254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1915257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1915260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915286 */     // MIs[0] policy
     /* 1915286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915296 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1915299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915320 */     // GIR_Coverage, 19551,
     /* 1915320 */     GIR_EraseRootFromParent_Done,
     /* 1915321 */   // Label 25762: @1915321
     /* 1915321 */   GIM_Try, /*On fail goto*//*Label 25763*/ GIMT_Encode4(1915407), // Rule ID 19554 //
     /* 1915326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1915329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1915337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1915340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1915343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1915346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1915349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915372 */     // MIs[0] policy
     /* 1915372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915382 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1915385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915406 */     // GIR_Coverage, 19554,
     /* 1915406 */     GIR_EraseRootFromParent_Done,
     /* 1915407 */   // Label 25763: @1915407
     /* 1915407 */   GIM_Try, /*On fail goto*//*Label 25764*/ GIMT_Encode4(1915493), // Rule ID 19555 //
     /* 1915412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1915415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1915423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1915426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1915429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1915432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1915435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915458 */     // MIs[0] policy
     /* 1915458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915468 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1915471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915492 */     // GIR_Coverage, 19555,
     /* 1915492 */     GIR_EraseRootFromParent_Done,
     /* 1915493 */   // Label 25764: @1915493
     /* 1915493 */   GIM_Try, /*On fail goto*//*Label 25765*/ GIMT_Encode4(1915579), // Rule ID 19558 //
     /* 1915498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1915501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1915509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1915512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1915515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1915518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1915521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915544 */     // MIs[0] policy
     /* 1915544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915554 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1915557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915578 */     // GIR_Coverage, 19558,
     /* 1915578 */     GIR_EraseRootFromParent_Done,
     /* 1915579 */   // Label 25765: @1915579
     /* 1915579 */   GIM_Try, /*On fail goto*//*Label 25766*/ GIMT_Encode4(1915665), // Rule ID 19559 //
     /* 1915584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1915587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1915595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1915598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1915601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1915604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1915607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915630 */     // MIs[0] policy
     /* 1915630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915640 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1915643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915664 */     // GIR_Coverage, 19559,
     /* 1915664 */     GIR_EraseRootFromParent_Done,
     /* 1915665 */   // Label 25766: @1915665
     /* 1915665 */   GIM_Try, /*On fail goto*//*Label 25767*/ GIMT_Encode4(1915751), // Rule ID 19562 //
     /* 1915670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1915673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1915681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1915684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1915687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1915690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915716 */     // MIs[0] policy
     /* 1915716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915726 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1915729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915750 */     // GIR_Coverage, 19562,
     /* 1915750 */     GIR_EraseRootFromParent_Done,
     /* 1915751 */   // Label 25767: @1915751
     /* 1915751 */   GIM_Try, /*On fail goto*//*Label 25768*/ GIMT_Encode4(1915837), // Rule ID 19563 //
     /* 1915756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1915759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1915767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1915770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1915773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1915776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915802 */     // MIs[0] policy
     /* 1915802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915812 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1915815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915836 */     // GIR_Coverage, 19563,
     /* 1915836 */     GIR_EraseRootFromParent_Done,
     /* 1915837 */   // Label 25768: @1915837
     /* 1915837 */   GIM_Try, /*On fail goto*//*Label 25769*/ GIMT_Encode4(1915923), // Rule ID 19566 //
     /* 1915842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1915845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1915853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1915856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1915859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1915862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915888 */     // MIs[0] policy
     /* 1915888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915898 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1915901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915922 */     // GIR_Coverage, 19566,
     /* 1915922 */     GIR_EraseRootFromParent_Done,
     /* 1915923 */   // Label 25769: @1915923
     /* 1915923 */   GIM_Try, /*On fail goto*//*Label 25770*/ GIMT_Encode4(1916009), // Rule ID 19567 //
     /* 1915928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1915931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1915939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1915942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1915945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1915948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915974 */     // MIs[0] policy
     /* 1915974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915984 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1915987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916008 */     // GIR_Coverage, 19567,
     /* 1916008 */     GIR_EraseRootFromParent_Done,
     /* 1916009 */   // Label 25770: @1916009
     /* 1916009 */   GIM_Try, /*On fail goto*//*Label 25771*/ GIMT_Encode4(1916095), // Rule ID 19570 //
     /* 1916014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1916017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1916022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1916025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1916028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1916031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1916034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1916037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1916044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916060 */     // MIs[0] policy
     /* 1916060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916070 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1916073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916094 */     // GIR_Coverage, 19570,
     /* 1916094 */     GIR_EraseRootFromParent_Done,
     /* 1916095 */   // Label 25771: @1916095
     /* 1916095 */   GIM_Try, /*On fail goto*//*Label 25772*/ GIMT_Encode4(1916181), // Rule ID 19571 //
     /* 1916100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1916103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1916108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1916111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1916114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1916117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1916120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1916123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1916130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916146 */     // MIs[0] policy
     /* 1916146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916156 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1916159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916180 */     // GIR_Coverage, 19571,
     /* 1916180 */     GIR_EraseRootFromParent_Done,
     /* 1916181 */   // Label 25772: @1916181
     /* 1916181 */   GIM_Try, /*On fail goto*//*Label 25773*/ GIMT_Encode4(1916267), // Rule ID 19574 //
     /* 1916186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1916189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1916194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1916197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1916200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1916203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1916206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916232 */     // MIs[0] policy
     /* 1916232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916242 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1916245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916266 */     // GIR_Coverage, 19574,
     /* 1916266 */     GIR_EraseRootFromParent_Done,
     /* 1916267 */   // Label 25773: @1916267
     /* 1916267 */   GIM_Try, /*On fail goto*//*Label 25774*/ GIMT_Encode4(1916353), // Rule ID 19575 //
     /* 1916272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1916275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1916280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1916283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1916286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1916289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1916292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916318 */     // MIs[0] policy
     /* 1916318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916328 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1916331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916352 */     // GIR_Coverage, 19575,
     /* 1916352 */     GIR_EraseRootFromParent_Done,
     /* 1916353 */   // Label 25774: @1916353
     /* 1916353 */   GIM_Try, /*On fail goto*//*Label 25775*/ GIMT_Encode4(1916439), // Rule ID 19578 //
     /* 1916358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1916361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1916366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1916369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1916372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1916375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1916378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1916388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916404 */     // MIs[0] policy
     /* 1916404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916414 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1916417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916438 */     // GIR_Coverage, 19578,
     /* 1916438 */     GIR_EraseRootFromParent_Done,
     /* 1916439 */   // Label 25775: @1916439
     /* 1916439 */   GIM_Try, /*On fail goto*//*Label 25776*/ GIMT_Encode4(1916525), // Rule ID 19579 //
     /* 1916444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1916447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1916452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1916455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1916458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1916461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1916464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1916474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916490 */     // MIs[0] policy
     /* 1916490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916500 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1916503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916524 */     // GIR_Coverage, 19579,
     /* 1916524 */     GIR_EraseRootFromParent_Done,
     /* 1916525 */   // Label 25776: @1916525
     /* 1916525 */   GIM_Try, /*On fail goto*//*Label 25777*/ GIMT_Encode4(1916611), // Rule ID 19582 //
     /* 1916530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1916533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1916538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1916541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1916544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1916547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1916550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1916560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916576 */     // MIs[0] policy
     /* 1916576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916586 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1916589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916610 */     // GIR_Coverage, 19582,
     /* 1916610 */     GIR_EraseRootFromParent_Done,
     /* 1916611 */   // Label 25777: @1916611
     /* 1916611 */   GIM_Try, /*On fail goto*//*Label 25778*/ GIMT_Encode4(1916697), // Rule ID 19583 //
     /* 1916616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1916619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1916624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1916627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1916630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1916633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1916636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1916646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916662 */     // MIs[0] policy
     /* 1916662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916672 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1916675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916696 */     // GIR_Coverage, 19583,
     /* 1916696 */     GIR_EraseRootFromParent_Done,
     /* 1916697 */   // Label 25778: @1916697
     /* 1916697 */   GIM_Try, /*On fail goto*//*Label 25779*/ GIMT_Encode4(1916783), // Rule ID 19586 //
     /* 1916702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1916710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1916713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1916716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1916719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1916722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1916744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916748 */     // MIs[0] policy
     /* 1916748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916758 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1916761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916782 */     // GIR_Coverage, 19586,
     /* 1916782 */     GIR_EraseRootFromParent_Done,
     /* 1916783 */   // Label 25779: @1916783
     /* 1916783 */   GIM_Try, /*On fail goto*//*Label 25780*/ GIMT_Encode4(1916869), // Rule ID 19587 //
     /* 1916788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1916796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1916799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1916802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1916805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1916808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1916830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916834 */     // MIs[0] policy
     /* 1916834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916844 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1916847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916868 */     // GIR_Coverage, 19587,
     /* 1916868 */     GIR_EraseRootFromParent_Done,
     /* 1916869 */   // Label 25780: @1916869
     /* 1916869 */   GIM_Try, /*On fail goto*//*Label 25781*/ GIMT_Encode4(1916955), // Rule ID 19590 //
     /* 1916874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1916882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1916885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1916888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1916891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1916894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1916916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916920 */     // MIs[0] policy
     /* 1916920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916930 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1916933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916954 */     // GIR_Coverage, 19590,
     /* 1916954 */     GIR_EraseRootFromParent_Done,
     /* 1916955 */   // Label 25781: @1916955
     /* 1916955 */   GIM_Try, /*On fail goto*//*Label 25782*/ GIMT_Encode4(1917041), // Rule ID 19591 //
     /* 1916960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1916968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1916971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1916974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1916977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1916980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1917002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917006 */     // MIs[0] policy
     /* 1917006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917016 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1917019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917040 */     // GIR_Coverage, 19591,
     /* 1917040 */     GIR_EraseRootFromParent_Done,
     /* 1917041 */   // Label 25782: @1917041
     /* 1917041 */   GIM_Try, /*On fail goto*//*Label 25783*/ GIMT_Encode4(1917127), // Rule ID 19594 //
     /* 1917046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1917054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1917057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1917060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1917063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1917069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1917076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1917088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917092 */     // MIs[0] policy
     /* 1917092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917102 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1917105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917126 */     // GIR_Coverage, 19594,
     /* 1917126 */     GIR_EraseRootFromParent_Done,
     /* 1917127 */   // Label 25783: @1917127
     /* 1917127 */   GIM_Try, /*On fail goto*//*Label 25784*/ GIMT_Encode4(1917213), // Rule ID 19595 //
     /* 1917132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1917140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1917143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1917146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1917149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1917155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1917162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1917174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917178 */     // MIs[0] policy
     /* 1917178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917188 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1917191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917212 */     // GIR_Coverage, 19595,
     /* 1917212 */     GIR_EraseRootFromParent_Done,
     /* 1917213 */   // Label 25784: @1917213
     /* 1917213 */   GIM_Try, /*On fail goto*//*Label 25785*/ GIMT_Encode4(1917299), // Rule ID 19598 //
     /* 1917218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1917221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1917226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1917229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1917232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1917235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1917238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1917248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1917260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917264 */     // MIs[0] policy
     /* 1917264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917274 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1917277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917298 */     // GIR_Coverage, 19598,
     /* 1917298 */     GIR_EraseRootFromParent_Done,
     /* 1917299 */   // Label 25785: @1917299
     /* 1917299 */   GIM_Try, /*On fail goto*//*Label 25786*/ GIMT_Encode4(1917385), // Rule ID 19599 //
     /* 1917304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1917307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1917312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1917315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1917318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1917321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1917324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1917334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1917346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917350 */     // MIs[0] policy
     /* 1917350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917360 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1917363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917384 */     // GIR_Coverage, 19599,
     /* 1917384 */     GIR_EraseRootFromParent_Done,
     /* 1917385 */   // Label 25786: @1917385
     /* 1917385 */   GIM_Try, /*On fail goto*//*Label 25787*/ GIMT_Encode4(1917471), // Rule ID 19602 //
     /* 1917390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1917398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1917401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1917404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1917407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1917413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1917420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1917432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917436 */     // MIs[0] policy
     /* 1917436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917446 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1917449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917470 */     // GIR_Coverage, 19602,
     /* 1917470 */     GIR_EraseRootFromParent_Done,
     /* 1917471 */   // Label 25787: @1917471
     /* 1917471 */   GIM_Try, /*On fail goto*//*Label 25788*/ GIMT_Encode4(1917557), // Rule ID 19603 //
     /* 1917476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1917484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1917487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1917490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1917493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1917499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1917506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1917518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917522 */     // MIs[0] policy
     /* 1917522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917532 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1917535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917556 */     // GIR_Coverage, 19603,
     /* 1917556 */     GIR_EraseRootFromParent_Done,
     /* 1917557 */   // Label 25788: @1917557
     /* 1917557 */   GIM_Try, /*On fail goto*//*Label 25789*/ GIMT_Encode4(1917643), // Rule ID 19606 //
     /* 1917562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1917565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1917570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1917573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1917576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1917579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1917585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1917592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1917604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917608 */     // MIs[0] policy
     /* 1917608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917618 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1917621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917642 */     // GIR_Coverage, 19606,
     /* 1917642 */     GIR_EraseRootFromParent_Done,
     /* 1917643 */   // Label 25789: @1917643
     /* 1917643 */   GIM_Try, /*On fail goto*//*Label 25790*/ GIMT_Encode4(1917729), // Rule ID 19607 //
     /* 1917648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1917651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1917656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1917659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1917662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1917665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1917671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1917678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1917690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917694 */     // MIs[0] policy
     /* 1917694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917704 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1917707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917728 */     // GIR_Coverage, 19607,
     /* 1917728 */     GIR_EraseRootFromParent_Done,
     /* 1917729 */   // Label 25790: @1917729
     /* 1917729 */   GIM_Try, /*On fail goto*//*Label 25791*/ GIMT_Encode4(1917815), // Rule ID 19610 //
     /* 1917734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1917737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1917742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1917745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1917748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1917751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1917754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1917776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917780 */     // MIs[0] policy
     /* 1917780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917790 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1917793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917814 */     // GIR_Coverage, 19610,
     /* 1917814 */     GIR_EraseRootFromParent_Done,
     /* 1917815 */   // Label 25791: @1917815
     /* 1917815 */   GIM_Try, /*On fail goto*//*Label 25792*/ GIMT_Encode4(1917901), // Rule ID 19611 //
     /* 1917820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1917823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1917828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1917831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1917834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1917837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1917840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1917862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917866 */     // MIs[0] policy
     /* 1917866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917876 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1917879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917900 */     // GIR_Coverage, 19611,
     /* 1917900 */     GIR_EraseRootFromParent_Done,
     /* 1917901 */   // Label 25792: @1917901
     /* 1917901 */   GIM_Try, /*On fail goto*//*Label 25793*/ GIMT_Encode4(1917987), // Rule ID 19614 //
     /* 1917906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1917909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1917914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1917917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1917920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1917923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1917926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1917948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917952 */     // MIs[0] policy
     /* 1917952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917962 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1917965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917986 */     // GIR_Coverage, 19614,
     /* 1917986 */     GIR_EraseRootFromParent_Done,
     /* 1917987 */   // Label 25793: @1917987
     /* 1917987 */   GIM_Try, /*On fail goto*//*Label 25794*/ GIMT_Encode4(1918073), // Rule ID 19615 //
     /* 1917992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1917995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1918000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1918003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1918006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1918009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1918015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1918022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918038 */     // MIs[0] policy
     /* 1918038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918048 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1918051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918072 */     // GIR_Coverage, 19615,
     /* 1918072 */     GIR_EraseRootFromParent_Done,
     /* 1918073 */   // Label 25794: @1918073
     /* 1918073 */   GIM_Try, /*On fail goto*//*Label 25795*/ GIMT_Encode4(1918159), // Rule ID 19618 //
     /* 1918078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1918081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1918086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1918089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1918092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1918095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1918101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1918108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918124 */     // MIs[0] policy
     /* 1918124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918134 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1918137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918158 */     // GIR_Coverage, 19618,
     /* 1918158 */     GIR_EraseRootFromParent_Done,
     /* 1918159 */   // Label 25795: @1918159
     /* 1918159 */   GIM_Try, /*On fail goto*//*Label 25796*/ GIMT_Encode4(1918245), // Rule ID 19619 //
     /* 1918164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1918167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1918172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1918175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1918178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1918181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1918187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1918194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918210 */     // MIs[0] policy
     /* 1918210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918220 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1918223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918244 */     // GIR_Coverage, 19619,
     /* 1918244 */     GIR_EraseRootFromParent_Done,
     /* 1918245 */   // Label 25796: @1918245
     /* 1918245 */   GIM_Try, /*On fail goto*//*Label 25797*/ GIMT_Encode4(1918331), // Rule ID 19622 //
     /* 1918250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1918253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1918258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1918261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1918264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1918267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1918280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918296 */     // MIs[0] policy
     /* 1918296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918306 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1918309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918330 */     // GIR_Coverage, 19622,
     /* 1918330 */     GIR_EraseRootFromParent_Done,
     /* 1918331 */   // Label 25797: @1918331
     /* 1918331 */   GIM_Try, /*On fail goto*//*Label 25798*/ GIMT_Encode4(1918417), // Rule ID 19623 //
     /* 1918336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1918339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1918344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1918347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1918350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1918353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1918366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918382 */     // MIs[0] policy
     /* 1918382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918392 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1918395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918416 */     // GIR_Coverage, 19623,
     /* 1918416 */     GIR_EraseRootFromParent_Done,
     /* 1918417 */   // Label 25798: @1918417
     /* 1918417 */   GIM_Try, /*On fail goto*//*Label 25799*/ GIMT_Encode4(1918503), // Rule ID 19626 //
     /* 1918422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1918425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1918430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1918433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1918436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1918439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1918445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1918452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918468 */     // MIs[0] policy
     /* 1918468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918478 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1918481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918502 */     // GIR_Coverage, 19626,
     /* 1918502 */     GIR_EraseRootFromParent_Done,
     /* 1918503 */   // Label 25799: @1918503
     /* 1918503 */   GIM_Try, /*On fail goto*//*Label 25800*/ GIMT_Encode4(1918589), // Rule ID 19627 //
     /* 1918508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1918511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1918516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1918519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1918522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1918525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1918531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1918538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918554 */     // MIs[0] policy
     /* 1918554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918564 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1918567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918588 */     // GIR_Coverage, 19627,
     /* 1918588 */     GIR_EraseRootFromParent_Done,
     /* 1918589 */   // Label 25800: @1918589
     /* 1918589 */   GIM_Try, /*On fail goto*//*Label 25801*/ GIMT_Encode4(1918675), // Rule ID 19630 //
     /* 1918594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1918597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1918602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1918605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1918608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1918611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1918617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1918624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918640 */     // MIs[0] policy
     /* 1918640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918650 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1918653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918674 */     // GIR_Coverage, 19630,
     /* 1918674 */     GIR_EraseRootFromParent_Done,
     /* 1918675 */   // Label 25801: @1918675
     /* 1918675 */   GIM_Try, /*On fail goto*//*Label 25802*/ GIMT_Encode4(1918761), // Rule ID 19631 //
     /* 1918680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1918683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1918688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1918691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1918694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1918697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1918703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1918710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918726 */     // MIs[0] policy
     /* 1918726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918736 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1918739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918760 */     // GIR_Coverage, 19631,
     /* 1918760 */     GIR_EraseRootFromParent_Done,
     /* 1918761 */   // Label 25802: @1918761
     /* 1918761 */   GIM_Try, /*On fail goto*//*Label 25803*/ GIMT_Encode4(1918847), // Rule ID 19634 //
     /* 1918766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1918769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1918774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1918777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1918780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1918783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1918796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1918808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918812 */     // MIs[0] policy
     /* 1918812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918822 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1918825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918846 */     // GIR_Coverage, 19634,
     /* 1918846 */     GIR_EraseRootFromParent_Done,
     /* 1918847 */   // Label 25803: @1918847
     /* 1918847 */   GIM_Try, /*On fail goto*//*Label 25804*/ GIMT_Encode4(1918933), // Rule ID 19635 //
     /* 1918852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1918855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1918860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1918863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1918866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1918869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1918882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1918894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918898 */     // MIs[0] policy
     /* 1918898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918908 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1918911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918932 */     // GIR_Coverage, 19635,
     /* 1918932 */     GIR_EraseRootFromParent_Done,
     /* 1918933 */   // Label 25804: @1918933
     /* 1918933 */   GIM_Try, /*On fail goto*//*Label 25805*/ GIMT_Encode4(1919019), // Rule ID 19638 //
     /* 1918938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1918941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1918946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1918949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1918952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1918955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1918968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1918980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918984 */     // MIs[0] policy
     /* 1918984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918994 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1918997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919018 */     // GIR_Coverage, 19638,
     /* 1919018 */     GIR_EraseRootFromParent_Done,
     /* 1919019 */   // Label 25805: @1919019
     /* 1919019 */   GIM_Try, /*On fail goto*//*Label 25806*/ GIMT_Encode4(1919105), // Rule ID 19639 //
     /* 1919024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1919027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1919032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1919035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1919038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1919041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1919066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919070 */     // MIs[0] policy
     /* 1919070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919080 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1919083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919104 */     // GIR_Coverage, 19639,
     /* 1919104 */     GIR_EraseRootFromParent_Done,
     /* 1919105 */   // Label 25806: @1919105
     /* 1919105 */   GIM_Try, /*On fail goto*//*Label 25807*/ GIMT_Encode4(1919191), // Rule ID 19642 //
     /* 1919110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1919113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1919118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1919121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1919124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1919127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1919152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919156 */     // MIs[0] policy
     /* 1919156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919166 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1919169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919190 */     // GIR_Coverage, 19642,
     /* 1919190 */     GIR_EraseRootFromParent_Done,
     /* 1919191 */   // Label 25807: @1919191
     /* 1919191 */   GIM_Try, /*On fail goto*//*Label 25808*/ GIMT_Encode4(1919277), // Rule ID 19643 //
     /* 1919196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1919199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1919204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1919207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1919210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1919213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1919238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919242 */     // MIs[0] policy
     /* 1919242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919252 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1919255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919276 */     // GIR_Coverage, 19643,
     /* 1919276 */     GIR_EraseRootFromParent_Done,
     /* 1919277 */   // Label 25808: @1919277
     /* 1919277 */   GIM_Try, /*On fail goto*//*Label 25809*/ GIMT_Encode4(1919363), // Rule ID 19646 //
     /* 1919282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1919293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1919296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1919299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1919302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919328 */     // MIs[0] policy
     /* 1919328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919338 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1919341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919362 */     // GIR_Coverage, 19646,
     /* 1919362 */     GIR_EraseRootFromParent_Done,
     /* 1919363 */   // Label 25809: @1919363
     /* 1919363 */   GIM_Try, /*On fail goto*//*Label 25810*/ GIMT_Encode4(1919449), // Rule ID 19647 //
     /* 1919368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1919379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1919382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1919385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1919388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919414 */     // MIs[0] policy
     /* 1919414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919424 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1919427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919448 */     // GIR_Coverage, 19647,
     /* 1919448 */     GIR_EraseRootFromParent_Done,
     /* 1919449 */   // Label 25810: @1919449
     /* 1919449 */   GIM_Try, /*On fail goto*//*Label 25811*/ GIMT_Encode4(1919535), // Rule ID 19650 //
     /* 1919454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1919465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1919468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1919471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1919474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919500 */     // MIs[0] policy
     /* 1919500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919510 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1919513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919534 */     // GIR_Coverage, 19650,
     /* 1919534 */     GIR_EraseRootFromParent_Done,
     /* 1919535 */   // Label 25811: @1919535
     /* 1919535 */   GIM_Try, /*On fail goto*//*Label 25812*/ GIMT_Encode4(1919621), // Rule ID 19651 //
     /* 1919540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1919551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1919554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1919557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1919560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919586 */     // MIs[0] policy
     /* 1919586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919596 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1919599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919620 */     // GIR_Coverage, 19651,
     /* 1919620 */     GIR_EraseRootFromParent_Done,
     /* 1919621 */   // Label 25812: @1919621
     /* 1919621 */   GIM_Try, /*On fail goto*//*Label 25813*/ GIMT_Encode4(1919707), // Rule ID 19654 //
     /* 1919626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1919629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1919637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1919640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1919643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1919646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919672 */     // MIs[0] policy
     /* 1919672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919682 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1919685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919706 */     // GIR_Coverage, 19654,
     /* 1919706 */     GIR_EraseRootFromParent_Done,
     /* 1919707 */   // Label 25813: @1919707
     /* 1919707 */   GIM_Try, /*On fail goto*//*Label 25814*/ GIMT_Encode4(1919793), // Rule ID 19655 //
     /* 1919712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1919715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1919723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1919726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1919729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1919732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919758 */     // MIs[0] policy
     /* 1919758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919768 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1919771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919792 */     // GIR_Coverage, 19655,
     /* 1919792 */     GIR_EraseRootFromParent_Done,
     /* 1919793 */   // Label 25814: @1919793
     /* 1919793 */   GIM_Try, /*On fail goto*//*Label 25815*/ GIMT_Encode4(1919879), // Rule ID 19658 //
     /* 1919798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1919809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1919812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1919815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1919818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919844 */     // MIs[0] policy
     /* 1919844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919854 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1919857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919878 */     // GIR_Coverage, 19658,
     /* 1919878 */     GIR_EraseRootFromParent_Done,
     /* 1919879 */   // Label 25815: @1919879
     /* 1919879 */   GIM_Try, /*On fail goto*//*Label 25816*/ GIMT_Encode4(1919965), // Rule ID 19659 //
     /* 1919884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1919895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1919898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1919901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1919904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919930 */     // MIs[0] policy
     /* 1919930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919940 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1919943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919964 */     // GIR_Coverage, 19659,
     /* 1919964 */     GIR_EraseRootFromParent_Done,
     /* 1919965 */   // Label 25816: @1919965
     /* 1919965 */   GIM_Try, /*On fail goto*//*Label 25817*/ GIMT_Encode4(1920051), // Rule ID 19662 //
     /* 1919970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1919973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1919981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1919984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1919987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1919990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920016 */     // MIs[0] policy
     /* 1920016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920026 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1920029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920050 */     // GIR_Coverage, 19662,
     /* 1920050 */     GIR_EraseRootFromParent_Done,
     /* 1920051 */   // Label 25817: @1920051
     /* 1920051 */   GIM_Try, /*On fail goto*//*Label 25818*/ GIMT_Encode4(1920137), // Rule ID 19663 //
     /* 1920056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1920059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1920067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1920070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1920073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1920076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920102 */     // MIs[0] policy
     /* 1920102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920112 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1920115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920136 */     // GIR_Coverage, 19663,
     /* 1920136 */     GIR_EraseRootFromParent_Done,
     /* 1920137 */   // Label 25818: @1920137
     /* 1920137 */   GIM_Try, /*On fail goto*//*Label 25819*/ GIMT_Encode4(1920223), // Rule ID 19666 //
     /* 1920142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1920145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1920153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1920156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1920159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1920162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1920165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920188 */     // MIs[0] policy
     /* 1920188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920198 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1920201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920222 */     // GIR_Coverage, 19666,
     /* 1920222 */     GIR_EraseRootFromParent_Done,
     /* 1920223 */   // Label 25819: @1920223
     /* 1920223 */   GIM_Try, /*On fail goto*//*Label 25820*/ GIMT_Encode4(1920309), // Rule ID 19667 //
     /* 1920228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1920231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1920239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1920242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1920245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1920248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1920251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920274 */     // MIs[0] policy
     /* 1920274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920284 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1920287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920308 */     // GIR_Coverage, 19667,
     /* 1920308 */     GIR_EraseRootFromParent_Done,
     /* 1920309 */   // Label 25820: @1920309
     /* 1920309 */   GIM_Try, /*On fail goto*//*Label 25821*/ GIMT_Encode4(1920395), // Rule ID 19670 //
     /* 1920314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1920317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1920325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1920328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1920331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1920334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920360 */     // MIs[0] policy
     /* 1920360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920370 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1920373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920394 */     // GIR_Coverage, 19670,
     /* 1920394 */     GIR_EraseRootFromParent_Done,
     /* 1920395 */   // Label 25821: @1920395
     /* 1920395 */   GIM_Try, /*On fail goto*//*Label 25822*/ GIMT_Encode4(1920481), // Rule ID 19671 //
     /* 1920400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1920403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1920411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1920414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1920417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1920420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920446 */     // MIs[0] policy
     /* 1920446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920456 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1920459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920480 */     // GIR_Coverage, 19671,
     /* 1920480 */     GIR_EraseRootFromParent_Done,
     /* 1920481 */   // Label 25822: @1920481
     /* 1920481 */   GIM_Try, /*On fail goto*//*Label 25823*/ GIMT_Encode4(1920567), // Rule ID 19674 //
     /* 1920486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1920489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1920497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1920500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1920503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1920506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920532 */     // MIs[0] policy
     /* 1920532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920542 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1920545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920566 */     // GIR_Coverage, 19674,
     /* 1920566 */     GIR_EraseRootFromParent_Done,
     /* 1920567 */   // Label 25823: @1920567
     /* 1920567 */   GIM_Try, /*On fail goto*//*Label 25824*/ GIMT_Encode4(1920653), // Rule ID 19675 //
     /* 1920572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1920575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1920583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1920586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1920589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1920592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920618 */     // MIs[0] policy
     /* 1920618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920628 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1920631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920652 */     // GIR_Coverage, 19675,
     /* 1920652 */     GIR_EraseRootFromParent_Done,
     /* 1920653 */   // Label 25824: @1920653
     /* 1920653 */   GIM_Try, /*On fail goto*//*Label 25825*/ GIMT_Encode4(1920739), // Rule ID 19678 //
     /* 1920658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1920661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1920669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1920672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1920675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1920678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1920681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920704 */     // MIs[0] policy
     /* 1920704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920714 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1920717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920738 */     // GIR_Coverage, 19678,
     /* 1920738 */     GIR_EraseRootFromParent_Done,
     /* 1920739 */   // Label 25825: @1920739
     /* 1920739 */   GIM_Try, /*On fail goto*//*Label 25826*/ GIMT_Encode4(1920825), // Rule ID 19679 //
     /* 1920744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1920747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1920755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1920758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1920761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1920764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1920767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920790 */     // MIs[0] policy
     /* 1920790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920800 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1920803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920824 */     // GIR_Coverage, 19679,
     /* 1920824 */     GIR_EraseRootFromParent_Done,
     /* 1920825 */   // Label 25826: @1920825
     /* 1920825 */   GIM_Try, /*On fail goto*//*Label 25827*/ GIMT_Encode4(1920911), // Rule ID 19682 //
     /* 1920830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1920833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1920841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1920844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1920847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1920850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920876 */     // MIs[0] policy
     /* 1920876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920886 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1920889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920910 */     // GIR_Coverage, 19682,
     /* 1920910 */     GIR_EraseRootFromParent_Done,
     /* 1920911 */   // Label 25827: @1920911
     /* 1920911 */   GIM_Try, /*On fail goto*//*Label 25828*/ GIMT_Encode4(1920997), // Rule ID 19683 //
     /* 1920916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1920919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1920927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1920930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1920933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1920936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920962 */     // MIs[0] policy
     /* 1920962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920972 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1920975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920996 */     // GIR_Coverage, 19683,
     /* 1920996 */     GIR_EraseRootFromParent_Done,
     /* 1920997 */   // Label 25828: @1920997
     /* 1920997 */   GIM_Try, /*On fail goto*//*Label 25829*/ GIMT_Encode4(1921083), // Rule ID 19686 //
     /* 1921002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1921005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1921010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1921013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1921016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1921019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1921022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1921032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921048 */     // MIs[0] policy
     /* 1921048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921058 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1921061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921082 */     // GIR_Coverage, 19686,
     /* 1921082 */     GIR_EraseRootFromParent_Done,
     /* 1921083 */   // Label 25829: @1921083
     /* 1921083 */   GIM_Try, /*On fail goto*//*Label 25830*/ GIMT_Encode4(1921169), // Rule ID 19687 //
     /* 1921088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1921091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1921096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1921099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1921102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1921105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1921108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1921118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921134 */     // MIs[0] policy
     /* 1921134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921144 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1921147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921168 */     // GIR_Coverage, 19687,
     /* 1921168 */     GIR_EraseRootFromParent_Done,
     /* 1921169 */   // Label 25830: @1921169
     /* 1921169 */   GIM_Try, /*On fail goto*//*Label 25831*/ GIMT_Encode4(1921255), // Rule ID 19690 //
     /* 1921174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1921177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1921182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1921185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1921188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1921191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1921194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1921197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1921204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921220 */     // MIs[0] policy
     /* 1921220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921230 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1921233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921254 */     // GIR_Coverage, 19690,
     /* 1921254 */     GIR_EraseRootFromParent_Done,
     /* 1921255 */   // Label 25831: @1921255
     /* 1921255 */   GIM_Try, /*On fail goto*//*Label 25832*/ GIMT_Encode4(1921341), // Rule ID 19691 //
     /* 1921260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1921263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1921268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1921271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1921274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1921277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1921280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1921283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1921290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921306 */     // MIs[0] policy
     /* 1921306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921316 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1921319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921340 */     // GIR_Coverage, 19691,
     /* 1921340 */     GIR_EraseRootFromParent_Done,
     /* 1921341 */   // Label 25832: @1921341
     /* 1921341 */   GIM_Try, /*On fail goto*//*Label 25833*/ GIMT_Encode4(1921427), // Rule ID 19694 //
     /* 1921346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1921349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1921354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1921357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1921360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1921363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1921366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1921376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921392 */     // MIs[0] policy
     /* 1921392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921402 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1921405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921426 */     // GIR_Coverage, 19694,
     /* 1921426 */     GIR_EraseRootFromParent_Done,
     /* 1921427 */   // Label 25833: @1921427
     /* 1921427 */   GIM_Try, /*On fail goto*//*Label 25834*/ GIMT_Encode4(1921513), // Rule ID 19695 //
     /* 1921432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1921435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1921440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1921443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1921446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1921449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1921452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1921462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921478 */     // MIs[0] policy
     /* 1921478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921488 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1921491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921512 */     // GIR_Coverage, 19695,
     /* 1921512 */     GIR_EraseRootFromParent_Done,
     /* 1921513 */   // Label 25834: @1921513
     /* 1921513 */   GIM_Try, /*On fail goto*//*Label 25835*/ GIMT_Encode4(1921599), // Rule ID 19698 //
     /* 1921518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1921521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1921526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1921529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1921532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1921535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1921538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1921548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921564 */     // MIs[0] policy
     /* 1921564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921574 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1921577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921598 */     // GIR_Coverage, 19698,
     /* 1921598 */     GIR_EraseRootFromParent_Done,
     /* 1921599 */   // Label 25835: @1921599
     /* 1921599 */   GIM_Try, /*On fail goto*//*Label 25836*/ GIMT_Encode4(1921685), // Rule ID 19699 //
     /* 1921604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1921607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1921612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1921615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1921618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1921621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1921624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1921634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921650 */     // MIs[0] policy
     /* 1921650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921660 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1921663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921684 */     // GIR_Coverage, 19699,
     /* 1921684 */     GIR_EraseRootFromParent_Done,
     /* 1921685 */   // Label 25836: @1921685
     /* 1921685 */   GIM_Try, /*On fail goto*//*Label 25837*/ GIMT_Encode4(1921771), // Rule ID 19702 //
     /* 1921690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1921693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1921698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1921701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1921704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1921707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1921710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1921720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921736 */     // MIs[0] policy
     /* 1921736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921746 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1921749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921770 */     // GIR_Coverage, 19702,
     /* 1921770 */     GIR_EraseRootFromParent_Done,
     /* 1921771 */   // Label 25837: @1921771
     /* 1921771 */   GIM_Try, /*On fail goto*//*Label 25838*/ GIMT_Encode4(1921857), // Rule ID 19703 //
     /* 1921776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1921779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1921784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1921787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1921790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1921793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1921796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1921806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921822 */     // MIs[0] policy
     /* 1921822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921832 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1921835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921856 */     // GIR_Coverage, 19703,
     /* 1921856 */     GIR_EraseRootFromParent_Done,
     /* 1921857 */   // Label 25838: @1921857
     /* 1921857 */   GIM_Try, /*On fail goto*//*Label 25839*/ GIMT_Encode4(1921943), // Rule ID 19706 //
     /* 1921862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1921865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1921870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1921873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1921876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1921879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1921882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1921904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921908 */     // MIs[0] policy
     /* 1921908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921918 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1921921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921942 */     // GIR_Coverage, 19706,
     /* 1921942 */     GIR_EraseRootFromParent_Done,
     /* 1921943 */   // Label 25839: @1921943
     /* 1921943 */   GIM_Try, /*On fail goto*//*Label 25840*/ GIMT_Encode4(1922029), // Rule ID 19707 //
     /* 1921948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1921951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1921956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1921959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1921962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1921965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1921968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1921990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921994 */     // MIs[0] policy
     /* 1921994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922004 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1922007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922028 */     // GIR_Coverage, 19707,
     /* 1922028 */     GIR_EraseRootFromParent_Done,
     /* 1922029 */   // Label 25840: @1922029
     /* 1922029 */   GIM_Try, /*On fail goto*//*Label 25841*/ GIMT_Encode4(1922115), // Rule ID 19710 //
     /* 1922034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1922037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1922042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1922045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1922048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1922051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1922054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1922076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922080 */     // MIs[0] policy
     /* 1922080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922090 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1922093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922114 */     // GIR_Coverage, 19710,
     /* 1922114 */     GIR_EraseRootFromParent_Done,
     /* 1922115 */   // Label 25841: @1922115
     /* 1922115 */   GIM_Try, /*On fail goto*//*Label 25842*/ GIMT_Encode4(1922201), // Rule ID 19711 //
     /* 1922120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1922123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1922128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1922131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1922134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1922137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1922140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1922162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922166 */     // MIs[0] policy
     /* 1922166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922176 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1922179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922200 */     // GIR_Coverage, 19711,
     /* 1922200 */     GIR_EraseRootFromParent_Done,
     /* 1922201 */   // Label 25842: @1922201
     /* 1922201 */   GIM_Try, /*On fail goto*//*Label 25843*/ GIMT_Encode4(1922287), // Rule ID 19714 //
     /* 1922206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1922209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1922214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1922217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1922220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1922223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1922248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922252 */     // MIs[0] policy
     /* 1922252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922262 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1922265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922286 */     // GIR_Coverage, 19714,
     /* 1922286 */     GIR_EraseRootFromParent_Done,
     /* 1922287 */   // Label 25843: @1922287
     /* 1922287 */   GIM_Try, /*On fail goto*//*Label 25844*/ GIMT_Encode4(1922373), // Rule ID 19715 //
     /* 1922292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1922295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1922300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1922303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1922306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1922309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1922334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922338 */     // MIs[0] policy
     /* 1922338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922348 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1922351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922372 */     // GIR_Coverage, 19715,
     /* 1922372 */     GIR_EraseRootFromParent_Done,
     /* 1922373 */   // Label 25844: @1922373
     /* 1922373 */   GIM_Try, /*On fail goto*//*Label 25845*/ GIMT_Encode4(1922459), // Rule ID 19718 //
     /* 1922378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1922381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1922386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1922389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1922392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1922395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1922398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1922420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922424 */     // MIs[0] policy
     /* 1922424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922434 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1922437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922458 */     // GIR_Coverage, 19718,
     /* 1922458 */     GIR_EraseRootFromParent_Done,
     /* 1922459 */   // Label 25845: @1922459
     /* 1922459 */   GIM_Try, /*On fail goto*//*Label 25846*/ GIMT_Encode4(1922545), // Rule ID 19719 //
     /* 1922464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1922467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1922472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1922475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1922478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1922481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1922484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1922506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922510 */     // MIs[0] policy
     /* 1922510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922520 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1922523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922544 */     // GIR_Coverage, 19719,
     /* 1922544 */     GIR_EraseRootFromParent_Done,
     /* 1922545 */   // Label 25846: @1922545
     /* 1922545 */   GIM_Try, /*On fail goto*//*Label 25847*/ GIMT_Encode4(1922631), // Rule ID 19722 //
     /* 1922550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1922553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1922558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1922561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1922564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1922567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1922592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922596 */     // MIs[0] policy
     /* 1922596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922606 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1922609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922630 */     // GIR_Coverage, 19722,
     /* 1922630 */     GIR_EraseRootFromParent_Done,
     /* 1922631 */   // Label 25847: @1922631
     /* 1922631 */   GIM_Try, /*On fail goto*//*Label 25848*/ GIMT_Encode4(1922717), // Rule ID 19723 //
     /* 1922636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1922639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1922644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1922647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1922650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1922653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1922678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922682 */     // MIs[0] policy
     /* 1922682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922692 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1922695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922716 */     // GIR_Coverage, 19723,
     /* 1922716 */     GIR_EraseRootFromParent_Done,
     /* 1922717 */   // Label 25848: @1922717
     /* 1922717 */   GIM_Try, /*On fail goto*//*Label 25849*/ GIMT_Encode4(1922803), // Rule ID 19726 //
     /* 1922722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1922725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1922730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1922733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1922736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1922739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1922764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922768 */     // MIs[0] policy
     /* 1922768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922778 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1922781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1922799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922802 */     // GIR_Coverage, 19726,
     /* 1922802 */     GIR_EraseRootFromParent_Done,
     /* 1922803 */   // Label 25849: @1922803
     /* 1922803 */   GIM_Try, /*On fail goto*//*Label 25850*/ GIMT_Encode4(1922889), // Rule ID 19727 //
     /* 1922808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1922811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1922816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1922819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1922822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1922825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1922850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922854 */     // MIs[0] policy
     /* 1922854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922864 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1922867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1922885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922888 */     // GIR_Coverage, 19727,
     /* 1922888 */     GIR_EraseRootFromParent_Done,
     /* 1922889 */   // Label 25850: @1922889
     /* 1922889 */   GIM_Try, /*On fail goto*//*Label 25851*/ GIMT_Encode4(1922975), // Rule ID 19730 //
     /* 1922894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1922897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1922902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1922905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1922908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1922911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1922914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1922936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922940 */     // MIs[0] policy
     /* 1922940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922950 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1922953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922974 */     // GIR_Coverage, 19730,
     /* 1922974 */     GIR_EraseRootFromParent_Done,
     /* 1922975 */   // Label 25851: @1922975
     /* 1922975 */   GIM_Try, /*On fail goto*//*Label 25852*/ GIMT_Encode4(1923061), // Rule ID 19731 //
     /* 1922980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1922983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1922988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1922991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1922994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1922997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1923000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1923022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923026 */     // MIs[0] policy
     /* 1923026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923036 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1923039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923060 */     // GIR_Coverage, 19731,
     /* 1923060 */     GIR_EraseRootFromParent_Done,
     /* 1923061 */   // Label 25852: @1923061
     /* 1923061 */   GIM_Try, /*On fail goto*//*Label 25853*/ GIMT_Encode4(1923147), // Rule ID 19734 //
     /* 1923066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1923069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1923074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1923077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1923080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1923083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1923086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1923108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923112 */     // MIs[0] policy
     /* 1923112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923122 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1923125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923146 */     // GIR_Coverage, 19734,
     /* 1923146 */     GIR_EraseRootFromParent_Done,
     /* 1923147 */   // Label 25853: @1923147
     /* 1923147 */   GIM_Try, /*On fail goto*//*Label 25854*/ GIMT_Encode4(1923233), // Rule ID 19735 //
     /* 1923152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1923155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1923160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1923163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1923166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1923169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1923172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1923194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923198 */     // MIs[0] policy
     /* 1923198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923208 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1923211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923232 */     // GIR_Coverage, 19735,
     /* 1923232 */     GIR_EraseRootFromParent_Done,
     /* 1923233 */   // Label 25854: @1923233
     /* 1923233 */   GIM_Try, /*On fail goto*//*Label 25855*/ GIMT_Encode4(1923319), // Rule ID 19738 //
     /* 1923238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1923241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1923246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1923249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1923252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1923255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1923258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1923280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923284 */     // MIs[0] policy
     /* 1923284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923294 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1923297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923318 */     // GIR_Coverage, 19738,
     /* 1923318 */     GIR_EraseRootFromParent_Done,
     /* 1923319 */   // Label 25855: @1923319
     /* 1923319 */   GIM_Try, /*On fail goto*//*Label 25856*/ GIMT_Encode4(1923405), // Rule ID 19739 //
     /* 1923324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1923327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1923332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1923335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1923338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1923341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1923344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1923366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923370 */     // MIs[0] policy
     /* 1923370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923380 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1923383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923404 */     // GIR_Coverage, 19739,
     /* 1923404 */     GIR_EraseRootFromParent_Done,
     /* 1923405 */   // Label 25856: @1923405
     /* 1923405 */   GIM_Try, /*On fail goto*//*Label 25857*/ GIMT_Encode4(1923491), // Rule ID 19742 //
     /* 1923410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1923413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1923418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1923421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1923424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1923427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1923433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1923452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923456 */     // MIs[0] policy
     /* 1923456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923466 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1923469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923490 */     // GIR_Coverage, 19742,
     /* 1923490 */     GIR_EraseRootFromParent_Done,
     /* 1923491 */   // Label 25857: @1923491
     /* 1923491 */   GIM_Try, /*On fail goto*//*Label 25858*/ GIMT_Encode4(1923577), // Rule ID 19743 //
     /* 1923496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1923499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1923504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1923507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1923510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1923513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1923519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1923538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923542 */     // MIs[0] policy
     /* 1923542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923552 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1923555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923576 */     // GIR_Coverage, 19743,
     /* 1923576 */     GIR_EraseRootFromParent_Done,
     /* 1923577 */   // Label 25858: @1923577
     /* 1923577 */   GIM_Try, /*On fail goto*//*Label 25859*/ GIMT_Encode4(1923663), // Rule ID 19746 //
     /* 1923582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1923585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1923590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1923593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1923596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1923599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1923624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923628 */     // MIs[0] policy
     /* 1923628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923638 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1923641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923662 */     // GIR_Coverage, 19746,
     /* 1923662 */     GIR_EraseRootFromParent_Done,
     /* 1923663 */   // Label 25859: @1923663
     /* 1923663 */   GIM_Try, /*On fail goto*//*Label 25860*/ GIMT_Encode4(1923749), // Rule ID 19747 //
     /* 1923668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1923671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1923676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1923679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1923682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1923685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1923710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923714 */     // MIs[0] policy
     /* 1923714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923724 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1923727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923748 */     // GIR_Coverage, 19747,
     /* 1923748 */     GIR_EraseRootFromParent_Done,
     /* 1923749 */   // Label 25860: @1923749
     /* 1923749 */   GIM_Try, /*On fail goto*//*Label 25861*/ GIMT_Encode4(1923835), // Rule ID 19750 //
     /* 1923754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1923757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1923762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1923765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1923768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1923771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1923796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923800 */     // MIs[0] policy
     /* 1923800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923810 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1923813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923834 */     // GIR_Coverage, 19750,
     /* 1923834 */     GIR_EraseRootFromParent_Done,
     /* 1923835 */   // Label 25861: @1923835
     /* 1923835 */   GIM_Try, /*On fail goto*//*Label 25862*/ GIMT_Encode4(1923921), // Rule ID 19751 //
     /* 1923840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1923843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1923848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1923851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1923854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1923857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1923882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923886 */     // MIs[0] policy
     /* 1923886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923896 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1923899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923920 */     // GIR_Coverage, 19751,
     /* 1923920 */     GIR_EraseRootFromParent_Done,
     /* 1923921 */   // Label 25862: @1923921
     /* 1923921 */   GIM_Try, /*On fail goto*//*Label 25863*/ GIMT_Encode4(1924007), // Rule ID 19754 //
     /* 1923926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1923929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1923934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1923937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1923940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1923943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1923949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1923968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923972 */     // MIs[0] policy
     /* 1923972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923982 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1923985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924006 */     // GIR_Coverage, 19754,
     /* 1924006 */     GIR_EraseRootFromParent_Done,
     /* 1924007 */   // Label 25863: @1924007
     /* 1924007 */   GIM_Try, /*On fail goto*//*Label 25864*/ GIMT_Encode4(1924093), // Rule ID 19755 //
     /* 1924012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1924015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1924020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1924023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1924026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1924029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1924054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924058 */     // MIs[0] policy
     /* 1924058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924068 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1924071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924092 */     // GIR_Coverage, 19755,
     /* 1924092 */     GIR_EraseRootFromParent_Done,
     /* 1924093 */   // Label 25864: @1924093
     /* 1924093 */   GIM_Try, /*On fail goto*//*Label 25865*/ GIMT_Encode4(1924179), // Rule ID 19758 //
     /* 1924098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1924101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1924106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1924109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1924112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1924115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1924140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924144 */     // MIs[0] policy
     /* 1924144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924154 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1924157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924178 */     // GIR_Coverage, 19758,
     /* 1924178 */     GIR_EraseRootFromParent_Done,
     /* 1924179 */   // Label 25865: @1924179
     /* 1924179 */   GIM_Try, /*On fail goto*//*Label 25866*/ GIMT_Encode4(1924265), // Rule ID 19759 //
     /* 1924184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1924187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1924192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1924195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1924198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1924201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1924226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924230 */     // MIs[0] policy
     /* 1924230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924240 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1924243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924264 */     // GIR_Coverage, 19759,
     /* 1924264 */     GIR_EraseRootFromParent_Done,
     /* 1924265 */   // Label 25866: @1924265
     /* 1924265 */   GIM_Try, /*On fail goto*//*Label 25867*/ GIMT_Encode4(1924351), // Rule ID 19762 //
     /* 1924270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1924273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1924278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1924281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1924284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1924287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1924312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924316 */     // MIs[0] policy
     /* 1924316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924326 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1924329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924350 */     // GIR_Coverage, 19762,
     /* 1924350 */     GIR_EraseRootFromParent_Done,
     /* 1924351 */   // Label 25867: @1924351
     /* 1924351 */   GIM_Try, /*On fail goto*//*Label 25868*/ GIMT_Encode4(1924437), // Rule ID 19763 //
     /* 1924356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1924359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1924364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1924367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1924370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1924373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1924398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924402 */     // MIs[0] policy
     /* 1924402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924412 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1924415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924436 */     // GIR_Coverage, 19763,
     /* 1924436 */     GIR_EraseRootFromParent_Done,
     /* 1924437 */   // Label 25868: @1924437
     /* 1924437 */   GIM_Try, /*On fail goto*//*Label 25869*/ GIMT_Encode4(1924523), // Rule ID 23604 //
     /* 1924442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1924453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1924456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1924459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924488 */     // MIs[0] policy
     /* 1924488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924498 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1924501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924522 */     // GIR_Coverage, 23604,
     /* 1924522 */     GIR_EraseRootFromParent_Done,
     /* 1924523 */   // Label 25869: @1924523
     /* 1924523 */   GIM_Try, /*On fail goto*//*Label 25870*/ GIMT_Encode4(1924609), // Rule ID 23605 //
     /* 1924528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1924539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1924542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1924545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924574 */     // MIs[0] policy
     /* 1924574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924584 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1924587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924608 */     // GIR_Coverage, 23605,
     /* 1924608 */     GIR_EraseRootFromParent_Done,
     /* 1924609 */   // Label 25870: @1924609
     /* 1924609 */   GIM_Try, /*On fail goto*//*Label 25871*/ GIMT_Encode4(1924695), // Rule ID 23608 //
     /* 1924614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1924625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1924628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1924631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924660 */     // MIs[0] policy
     /* 1924660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924670 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1924673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924694 */     // GIR_Coverage, 23608,
     /* 1924694 */     GIR_EraseRootFromParent_Done,
     /* 1924695 */   // Label 25871: @1924695
     /* 1924695 */   GIM_Try, /*On fail goto*//*Label 25872*/ GIMT_Encode4(1924781), // Rule ID 23609 //
     /* 1924700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1924711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1924714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1924717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924746 */     // MIs[0] policy
     /* 1924746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924756 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1924759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924780 */     // GIR_Coverage, 23609,
     /* 1924780 */     GIR_EraseRootFromParent_Done,
     /* 1924781 */   // Label 25872: @1924781
     /* 1924781 */   GIM_Try, /*On fail goto*//*Label 25873*/ GIMT_Encode4(1924867), // Rule ID 23612 //
     /* 1924786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1924797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1924800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1924803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924832 */     // MIs[0] policy
     /* 1924832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924842 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1924845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924866 */     // GIR_Coverage, 23612,
     /* 1924866 */     GIR_EraseRootFromParent_Done,
     /* 1924867 */   // Label 25873: @1924867
     /* 1924867 */   GIM_Try, /*On fail goto*//*Label 25874*/ GIMT_Encode4(1924953), // Rule ID 23613 //
     /* 1924872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1924883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1924886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1924889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924918 */     // MIs[0] policy
     /* 1924918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924928 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1924931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924952 */     // GIR_Coverage, 23613,
     /* 1924952 */     GIR_EraseRootFromParent_Done,
     /* 1924953 */   // Label 25874: @1924953
     /* 1924953 */   GIM_Try, /*On fail goto*//*Label 25875*/ GIMT_Encode4(1925039), // Rule ID 23616 //
     /* 1924958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1924969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1924972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1924975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925004 */     // MIs[0] policy
     /* 1925004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925014 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1925017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925038 */     // GIR_Coverage, 23616,
     /* 1925038 */     GIR_EraseRootFromParent_Done,
     /* 1925039 */   // Label 25875: @1925039
     /* 1925039 */   GIM_Try, /*On fail goto*//*Label 25876*/ GIMT_Encode4(1925125), // Rule ID 23617 //
     /* 1925044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1925052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1925055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1925058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1925061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925090 */     // MIs[0] policy
     /* 1925090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925100 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1925103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925124 */     // GIR_Coverage, 23617,
     /* 1925124 */     GIR_EraseRootFromParent_Done,
     /* 1925125 */   // Label 25876: @1925125
     /* 1925125 */   GIM_Try, /*On fail goto*//*Label 25877*/ GIMT_Encode4(1925211), // Rule ID 23620 //
     /* 1925130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1925138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1925141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1925144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1925147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925176 */     // MIs[0] policy
     /* 1925176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925186 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1925189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925210 */     // GIR_Coverage, 23620,
     /* 1925210 */     GIR_EraseRootFromParent_Done,
     /* 1925211 */   // Label 25877: @1925211
     /* 1925211 */   GIM_Try, /*On fail goto*//*Label 25878*/ GIMT_Encode4(1925297), // Rule ID 23621 //
     /* 1925216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1925224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1925227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1925230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1925233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925262 */     // MIs[0] policy
     /* 1925262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925272 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1925275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925296 */     // GIR_Coverage, 23621,
     /* 1925296 */     GIR_EraseRootFromParent_Done,
     /* 1925297 */   // Label 25878: @1925297
     /* 1925297 */   GIM_Try, /*On fail goto*//*Label 25879*/ GIMT_Encode4(1925383), // Rule ID 23624 //
     /* 1925302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1925310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1925313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1925316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1925319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925348 */     // MIs[0] policy
     /* 1925348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925358 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1925361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925382 */     // GIR_Coverage, 23624,
     /* 1925382 */     GIR_EraseRootFromParent_Done,
     /* 1925383 */   // Label 25879: @1925383
     /* 1925383 */   GIM_Try, /*On fail goto*//*Label 25880*/ GIMT_Encode4(1925469), // Rule ID 23625 //
     /* 1925388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1925396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1925399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1925402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1925405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925434 */     // MIs[0] policy
     /* 1925434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925444 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1925447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925468 */     // GIR_Coverage, 23625,
     /* 1925468 */     GIR_EraseRootFromParent_Done,
     /* 1925469 */   // Label 25880: @1925469
     /* 1925469 */   GIM_Try, /*On fail goto*//*Label 25881*/ GIMT_Encode4(1925555), // Rule ID 23628 //
     /* 1925474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1925482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1925485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1925488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1925491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925520 */     // MIs[0] policy
     /* 1925520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925530 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1925533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925554 */     // GIR_Coverage, 23628,
     /* 1925554 */     GIR_EraseRootFromParent_Done,
     /* 1925555 */   // Label 25881: @1925555
     /* 1925555 */   GIM_Try, /*On fail goto*//*Label 25882*/ GIMT_Encode4(1925641), // Rule ID 23629 //
     /* 1925560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1925568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1925571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1925574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1925577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925606 */     // MIs[0] policy
     /* 1925606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925616 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1925619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925640 */     // GIR_Coverage, 23629,
     /* 1925640 */     GIR_EraseRootFromParent_Done,
     /* 1925641 */   // Label 25882: @1925641
     /* 1925641 */   GIM_Try, /*On fail goto*//*Label 25883*/ GIMT_Encode4(1925727), // Rule ID 23632 //
     /* 1925646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1925654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1925657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1925660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1925663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925692 */     // MIs[0] policy
     /* 1925692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1925705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925726 */     // GIR_Coverage, 23632,
     /* 1925726 */     GIR_EraseRootFromParent_Done,
     /* 1925727 */   // Label 25883: @1925727
     /* 1925727 */   GIM_Try, /*On fail goto*//*Label 25884*/ GIMT_Encode4(1925813), // Rule ID 23633 //
     /* 1925732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1925740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1925743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1925746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1925749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925778 */     // MIs[0] policy
     /* 1925778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925788 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1925791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925812 */     // GIR_Coverage, 23633,
     /* 1925812 */     GIR_EraseRootFromParent_Done,
     /* 1925813 */   // Label 25884: @1925813
     /* 1925813 */   GIM_Try, /*On fail goto*//*Label 25885*/ GIMT_Encode4(1925899), // Rule ID 23636 //
     /* 1925818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1925826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1925829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1925832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1925835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925864 */     // MIs[0] policy
     /* 1925864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925874 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1925877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925898 */     // GIR_Coverage, 23636,
     /* 1925898 */     GIR_EraseRootFromParent_Done,
     /* 1925899 */   // Label 25885: @1925899
     /* 1925899 */   GIM_Try, /*On fail goto*//*Label 25886*/ GIMT_Encode4(1925985), // Rule ID 23637 //
     /* 1925904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1925912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1925915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1925918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1925921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925950 */     // MIs[0] policy
     /* 1925950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925960 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1925963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925984 */     // GIR_Coverage, 23637,
     /* 1925984 */     GIR_EraseRootFromParent_Done,
     /* 1925985 */   // Label 25886: @1925985
     /* 1925985 */   GIM_Try, /*On fail goto*//*Label 25887*/ GIMT_Encode4(1926071), // Rule ID 23640 //
     /* 1925990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1925993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1925998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1926001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1926004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1926007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926036 */     // MIs[0] policy
     /* 1926036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926046 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1926049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1926067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926070 */     // GIR_Coverage, 23640,
     /* 1926070 */     GIR_EraseRootFromParent_Done,
     /* 1926071 */   // Label 25887: @1926071
     /* 1926071 */   GIM_Try, /*On fail goto*//*Label 25888*/ GIMT_Encode4(1926157), // Rule ID 23641 //
     /* 1926076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1926079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1926084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1926087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1926090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1926093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926122 */     // MIs[0] policy
     /* 1926122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926132 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1926135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1926153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926156 */     // GIR_Coverage, 23641,
     /* 1926156 */     GIR_EraseRootFromParent_Done,
     /* 1926157 */   // Label 25888: @1926157
     /* 1926157 */   GIM_Try, /*On fail goto*//*Label 25889*/ GIMT_Encode4(1926243), // Rule ID 23644 //
     /* 1926162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1926170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1926173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1926176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1926179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926208 */     // MIs[0] policy
     /* 1926208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926218 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1926221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926242 */     // GIR_Coverage, 23644,
     /* 1926242 */     GIR_EraseRootFromParent_Done,
     /* 1926243 */   // Label 25889: @1926243
     /* 1926243 */   GIM_Try, /*On fail goto*//*Label 25890*/ GIMT_Encode4(1926329), // Rule ID 23645 //
     /* 1926248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1926256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1926259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1926262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1926265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926294 */     // MIs[0] policy
     /* 1926294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926304 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1926307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926328 */     // GIR_Coverage, 23645,
     /* 1926328 */     GIR_EraseRootFromParent_Done,
     /* 1926329 */   // Label 25890: @1926329
     /* 1926329 */   GIM_Try, /*On fail goto*//*Label 25891*/ GIMT_Encode4(1926415), // Rule ID 23648 //
     /* 1926334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1926342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1926345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1926348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1926351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1926357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926380 */     // MIs[0] policy
     /* 1926380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926390 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1926393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926414 */     // GIR_Coverage, 23648,
     /* 1926414 */     GIR_EraseRootFromParent_Done,
     /* 1926415 */   // Label 25891: @1926415
     /* 1926415 */   GIM_Try, /*On fail goto*//*Label 25892*/ GIMT_Encode4(1926501), // Rule ID 23649 //
     /* 1926420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1926428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1926431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1926434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1926437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1926443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926466 */     // MIs[0] policy
     /* 1926466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926476 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1926479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926500 */     // GIR_Coverage, 23649,
     /* 1926500 */     GIR_EraseRootFromParent_Done,
     /* 1926501 */   // Label 25892: @1926501
     /* 1926501 */   GIM_Try, /*On fail goto*//*Label 25893*/ GIMT_Encode4(1926587), // Rule ID 23652 //
     /* 1926506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1926514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1926517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1926520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1926523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1926529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1926536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926552 */     // MIs[0] policy
     /* 1926552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926562 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1926565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926586 */     // GIR_Coverage, 23652,
     /* 1926586 */     GIR_EraseRootFromParent_Done,
     /* 1926587 */   // Label 25893: @1926587
     /* 1926587 */   GIM_Try, /*On fail goto*//*Label 25894*/ GIMT_Encode4(1926673), // Rule ID 23653 //
     /* 1926592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1926600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1926603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1926606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1926609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1926615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1926622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926638 */     // MIs[0] policy
     /* 1926638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926648 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1926651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926672 */     // GIR_Coverage, 23653,
     /* 1926672 */     GIR_EraseRootFromParent_Done,
     /* 1926673 */   // Label 25894: @1926673
     /* 1926673 */   GIM_Try, /*On fail goto*//*Label 25895*/ GIMT_Encode4(1926759), // Rule ID 23656 //
     /* 1926678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1926686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1926689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1926692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1926695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1926701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926724 */     // MIs[0] policy
     /* 1926724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1926737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926758 */     // GIR_Coverage, 23656,
     /* 1926758 */     GIR_EraseRootFromParent_Done,
     /* 1926759 */   // Label 25895: @1926759
     /* 1926759 */   GIM_Try, /*On fail goto*//*Label 25896*/ GIMT_Encode4(1926845), // Rule ID 23657 //
     /* 1926764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1926772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1926775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1926778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1926781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1926787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926810 */     // MIs[0] policy
     /* 1926810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926820 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1926823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926844 */     // GIR_Coverage, 23657,
     /* 1926844 */     GIR_EraseRootFromParent_Done,
     /* 1926845 */   // Label 25896: @1926845
     /* 1926845 */   GIM_Try, /*On fail goto*//*Label 25897*/ GIMT_Encode4(1926931), // Rule ID 23660 //
     /* 1926850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1926858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1926861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1926864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1926867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926896 */     // MIs[0] policy
     /* 1926896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926906 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1926909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926930 */     // GIR_Coverage, 23660,
     /* 1926930 */     GIR_EraseRootFromParent_Done,
     /* 1926931 */   // Label 25897: @1926931
     /* 1926931 */   GIM_Try, /*On fail goto*//*Label 25898*/ GIMT_Encode4(1927017), // Rule ID 23661 //
     /* 1926936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1926944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1926947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1926950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1926953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926982 */     // MIs[0] policy
     /* 1926982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926992 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1926995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927016 */     // GIR_Coverage, 23661,
     /* 1927016 */     GIR_EraseRootFromParent_Done,
     /* 1927017 */   // Label 25898: @1927017
     /* 1927017 */   GIM_Try, /*On fail goto*//*Label 25899*/ GIMT_Encode4(1927103), // Rule ID 23664 //
     /* 1927022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1927030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1927033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1927036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1927039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1927045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927068 */     // MIs[0] policy
     /* 1927068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927078 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1927081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927102 */     // GIR_Coverage, 23664,
     /* 1927102 */     GIR_EraseRootFromParent_Done,
     /* 1927103 */   // Label 25899: @1927103
     /* 1927103 */   GIM_Try, /*On fail goto*//*Label 25900*/ GIMT_Encode4(1927189), // Rule ID 23665 //
     /* 1927108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1927116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1927119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1927122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1927125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1927131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927154 */     // MIs[0] policy
     /* 1927154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927164 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1927167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927188 */     // GIR_Coverage, 23665,
     /* 1927188 */     GIR_EraseRootFromParent_Done,
     /* 1927189 */   // Label 25900: @1927189
     /* 1927189 */   GIM_Try, /*On fail goto*//*Label 25901*/ GIMT_Encode4(1927275), // Rule ID 23668 //
     /* 1927194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1927202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1927205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1927208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1927211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927240 */     // MIs[0] policy
     /* 1927240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1927253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927274 */     // GIR_Coverage, 23668,
     /* 1927274 */     GIR_EraseRootFromParent_Done,
     /* 1927275 */   // Label 25901: @1927275
     /* 1927275 */   GIM_Try, /*On fail goto*//*Label 25902*/ GIMT_Encode4(1927361), // Rule ID 23669 //
     /* 1927280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1927288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1927291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1927294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1927297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927326 */     // MIs[0] policy
     /* 1927326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1927339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927360 */     // GIR_Coverage, 23669,
     /* 1927360 */     GIR_EraseRootFromParent_Done,
     /* 1927361 */   // Label 25902: @1927361
     /* 1927361 */   GIM_Try, /*On fail goto*//*Label 25903*/ GIMT_Encode4(1927447), // Rule ID 23672 //
     /* 1927366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1927374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1927377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1927380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1927383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927412 */     // MIs[0] policy
     /* 1927412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1927425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927446 */     // GIR_Coverage, 23672,
     /* 1927446 */     GIR_EraseRootFromParent_Done,
     /* 1927447 */   // Label 25903: @1927447
     /* 1927447 */   GIM_Try, /*On fail goto*//*Label 25904*/ GIMT_Encode4(1927533), // Rule ID 23673 //
     /* 1927452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1927460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1927463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1927466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1927469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927498 */     // MIs[0] policy
     /* 1927498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927508 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1927511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927532 */     // GIR_Coverage, 23673,
     /* 1927532 */     GIR_EraseRootFromParent_Done,
     /* 1927533 */   // Label 25904: @1927533
     /* 1927533 */   GIM_Try, /*On fail goto*//*Label 25905*/ GIMT_Encode4(1927619), // Rule ID 23676 //
     /* 1927538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1927546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1927549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1927552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1927555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927584 */     // MIs[0] policy
     /* 1927584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927594 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1927597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927618 */     // GIR_Coverage, 23676,
     /* 1927618 */     GIR_EraseRootFromParent_Done,
     /* 1927619 */   // Label 25905: @1927619
     /* 1927619 */   GIM_Try, /*On fail goto*//*Label 25906*/ GIMT_Encode4(1927705), // Rule ID 23677 //
     /* 1927624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1927632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1927635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1927638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1927641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927670 */     // MIs[0] policy
     /* 1927670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927680 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1927683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927704 */     // GIR_Coverage, 23677,
     /* 1927704 */     GIR_EraseRootFromParent_Done,
     /* 1927705 */   // Label 25906: @1927705
     /* 1927705 */   GIM_Try, /*On fail goto*//*Label 25907*/ GIMT_Encode4(1927791), // Rule ID 23680 //
     /* 1927710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1927713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1927718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1927721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1927724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1927727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1927733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927756 */     // MIs[0] policy
     /* 1927756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927766 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1927769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927790 */     // GIR_Coverage, 23680,
     /* 1927790 */     GIR_EraseRootFromParent_Done,
     /* 1927791 */   // Label 25907: @1927791
     /* 1927791 */   GIM_Try, /*On fail goto*//*Label 25908*/ GIMT_Encode4(1927877), // Rule ID 23681 //
     /* 1927796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1927799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1927804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1927807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1927810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1927813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1927819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927842 */     // MIs[0] policy
     /* 1927842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927852 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1927855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927876 */     // GIR_Coverage, 23681,
     /* 1927876 */     GIR_EraseRootFromParent_Done,
     /* 1927877 */   // Label 25908: @1927877
     /* 1927877 */   GIM_Try, /*On fail goto*//*Label 25909*/ GIMT_Encode4(1927963), // Rule ID 23684 //
     /* 1927882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1927885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1927890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1927893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1927896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1927899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927928 */     // MIs[0] policy
     /* 1927928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927938 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1927941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927962 */     // GIR_Coverage, 23684,
     /* 1927962 */     GIR_EraseRootFromParent_Done,
     /* 1927963 */   // Label 25909: @1927963
     /* 1927963 */   GIM_Try, /*On fail goto*//*Label 25910*/ GIMT_Encode4(1928049), // Rule ID 23685 //
     /* 1927968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1927971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1927976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1927979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1927982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1927985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928014 */     // MIs[0] policy
     /* 1928014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928024 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1928027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928048 */     // GIR_Coverage, 23685,
     /* 1928048 */     GIR_EraseRootFromParent_Done,
     /* 1928049 */   // Label 25910: @1928049
     /* 1928049 */   GIM_Try, /*On fail goto*//*Label 25911*/ GIMT_Encode4(1928135), // Rule ID 23688 //
     /* 1928054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1928057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1928062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1928065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1928068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1928071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928100 */     // MIs[0] policy
     /* 1928100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928110 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1928113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928134 */     // GIR_Coverage, 23688,
     /* 1928134 */     GIR_EraseRootFromParent_Done,
     /* 1928135 */   // Label 25911: @1928135
     /* 1928135 */   GIM_Try, /*On fail goto*//*Label 25912*/ GIMT_Encode4(1928221), // Rule ID 23689 //
     /* 1928140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1928143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1928148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1928151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1928154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1928157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928186 */     // MIs[0] policy
     /* 1928186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928196 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1928199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928220 */     // GIR_Coverage, 23689,
     /* 1928220 */     GIR_EraseRootFromParent_Done,
     /* 1928221 */   // Label 25912: @1928221
     /* 1928221 */   GIM_Try, /*On fail goto*//*Label 25913*/ GIMT_Encode4(1928307), // Rule ID 23780 //
     /* 1928226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1928237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1928240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1928243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928272 */     // MIs[0] policy
     /* 1928272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928282 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1928285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928306 */     // GIR_Coverage, 23780,
     /* 1928306 */     GIR_EraseRootFromParent_Done,
     /* 1928307 */   // Label 25913: @1928307
     /* 1928307 */   GIM_Try, /*On fail goto*//*Label 25914*/ GIMT_Encode4(1928393), // Rule ID 23781 //
     /* 1928312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1928323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1928326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1928329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928358 */     // MIs[0] policy
     /* 1928358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928368 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1928371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928392 */     // GIR_Coverage, 23781,
     /* 1928392 */     GIR_EraseRootFromParent_Done,
     /* 1928393 */   // Label 25914: @1928393
     /* 1928393 */   GIM_Try, /*On fail goto*//*Label 25915*/ GIMT_Encode4(1928479), // Rule ID 23784 //
     /* 1928398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1928409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1928412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1928415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928444 */     // MIs[0] policy
     /* 1928444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928454 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1928457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928478 */     // GIR_Coverage, 23784,
     /* 1928478 */     GIR_EraseRootFromParent_Done,
     /* 1928479 */   // Label 25915: @1928479
     /* 1928479 */   GIM_Try, /*On fail goto*//*Label 25916*/ GIMT_Encode4(1928565), // Rule ID 23785 //
     /* 1928484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1928495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1928498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1928501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928530 */     // MIs[0] policy
     /* 1928530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928540 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1928543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928564 */     // GIR_Coverage, 23785,
     /* 1928564 */     GIR_EraseRootFromParent_Done,
     /* 1928565 */   // Label 25916: @1928565
     /* 1928565 */   GIM_Try, /*On fail goto*//*Label 25917*/ GIMT_Encode4(1928651), // Rule ID 23788 //
     /* 1928570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1928581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1928584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1928587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928616 */     // MIs[0] policy
     /* 1928616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928626 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1928629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928650 */     // GIR_Coverage, 23788,
     /* 1928650 */     GIR_EraseRootFromParent_Done,
     /* 1928651 */   // Label 25917: @1928651
     /* 1928651 */   GIM_Try, /*On fail goto*//*Label 25918*/ GIMT_Encode4(1928737), // Rule ID 23789 //
     /* 1928656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1928667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1928670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1928673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928702 */     // MIs[0] policy
     /* 1928702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928712 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1928715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928736 */     // GIR_Coverage, 23789,
     /* 1928736 */     GIR_EraseRootFromParent_Done,
     /* 1928737 */   // Label 25918: @1928737
     /* 1928737 */   GIM_Try, /*On fail goto*//*Label 25919*/ GIMT_Encode4(1928823), // Rule ID 23792 //
     /* 1928742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1928753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1928756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1928759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928788 */     // MIs[0] policy
     /* 1928788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928798 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1928801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928822 */     // GIR_Coverage, 23792,
     /* 1928822 */     GIR_EraseRootFromParent_Done,
     /* 1928823 */   // Label 25919: @1928823
     /* 1928823 */   GIM_Try, /*On fail goto*//*Label 25920*/ GIMT_Encode4(1928909), // Rule ID 23793 //
     /* 1928828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1928839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1928842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1928845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928874 */     // MIs[0] policy
     /* 1928874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928884 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1928887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928908 */     // GIR_Coverage, 23793,
     /* 1928908 */     GIR_EraseRootFromParent_Done,
     /* 1928909 */   // Label 25920: @1928909
     /* 1928909 */   GIM_Try, /*On fail goto*//*Label 25921*/ GIMT_Encode4(1928995), // Rule ID 23796 //
     /* 1928914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1928925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1928928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1928931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928960 */     // MIs[0] policy
     /* 1928960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928970 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1928973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928994 */     // GIR_Coverage, 23796,
     /* 1928994 */     GIR_EraseRootFromParent_Done,
     /* 1928995 */   // Label 25921: @1928995
     /* 1928995 */   GIM_Try, /*On fail goto*//*Label 25922*/ GIMT_Encode4(1929081), // Rule ID 23797 //
     /* 1929000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1929008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1929011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1929014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1929017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929046 */     // MIs[0] policy
     /* 1929046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929056 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1929059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929080 */     // GIR_Coverage, 23797,
     /* 1929080 */     GIR_EraseRootFromParent_Done,
     /* 1929081 */   // Label 25922: @1929081
     /* 1929081 */   GIM_Try, /*On fail goto*//*Label 25923*/ GIMT_Encode4(1929167), // Rule ID 23800 //
     /* 1929086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1929094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929132 */     // MIs[0] policy
     /* 1929132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929142 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1929145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929166 */     // GIR_Coverage, 23800,
     /* 1929166 */     GIR_EraseRootFromParent_Done,
     /* 1929167 */   // Label 25923: @1929167
     /* 1929167 */   GIM_Try, /*On fail goto*//*Label 25924*/ GIMT_Encode4(1929253), // Rule ID 23801 //
     /* 1929172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1929180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929218 */     // MIs[0] policy
     /* 1929218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929228 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1929231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929252 */     // GIR_Coverage, 23801,
     /* 1929252 */     GIR_EraseRootFromParent_Done,
     /* 1929253 */   // Label 25924: @1929253
     /* 1929253 */   GIM_Try, /*On fail goto*//*Label 25925*/ GIMT_Encode4(1929339), // Rule ID 23804 //
     /* 1929258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1929266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1929269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1929272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1929275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1929281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929304 */     // MIs[0] policy
     /* 1929304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929314 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1929317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929338 */     // GIR_Coverage, 23804,
     /* 1929338 */     GIR_EraseRootFromParent_Done,
     /* 1929339 */   // Label 25925: @1929339
     /* 1929339 */   GIM_Try, /*On fail goto*//*Label 25926*/ GIMT_Encode4(1929425), // Rule ID 23805 //
     /* 1929344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1929352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1929355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1929358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1929361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1929367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929390 */     // MIs[0] policy
     /* 1929390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929400 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1929403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929424 */     // GIR_Coverage, 23805,
     /* 1929424 */     GIR_EraseRootFromParent_Done,
     /* 1929425 */   // Label 25926: @1929425
     /* 1929425 */   GIM_Try, /*On fail goto*//*Label 25927*/ GIMT_Encode4(1929511), // Rule ID 23808 //
     /* 1929430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1929438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1929441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1929444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1929447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929476 */     // MIs[0] policy
     /* 1929476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929486 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1929489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929510 */     // GIR_Coverage, 23808,
     /* 1929510 */     GIR_EraseRootFromParent_Done,
     /* 1929511 */   // Label 25927: @1929511
     /* 1929511 */   GIM_Try, /*On fail goto*//*Label 25928*/ GIMT_Encode4(1929597), // Rule ID 23809 //
     /* 1929516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1929524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1929527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1929530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1929533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929562 */     // MIs[0] policy
     /* 1929562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929572 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1929575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929596 */     // GIR_Coverage, 23809,
     /* 1929596 */     GIR_EraseRootFromParent_Done,
     /* 1929597 */   // Label 25928: @1929597
     /* 1929597 */   GIM_Try, /*On fail goto*//*Label 25929*/ GIMT_Encode4(1929683), // Rule ID 23812 //
     /* 1929602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1929610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1929613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1929616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1929619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929648 */     // MIs[0] policy
     /* 1929648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1929661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929682 */     // GIR_Coverage, 23812,
     /* 1929682 */     GIR_EraseRootFromParent_Done,
     /* 1929683 */   // Label 25929: @1929683
     /* 1929683 */   GIM_Try, /*On fail goto*//*Label 25930*/ GIMT_Encode4(1929769), // Rule ID 23813 //
     /* 1929688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1929696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1929699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1929702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1929705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929734 */     // MIs[0] policy
     /* 1929734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1929747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929768 */     // GIR_Coverage, 23813,
     /* 1929768 */     GIR_EraseRootFromParent_Done,
     /* 1929769 */   // Label 25930: @1929769
     /* 1929769 */   GIM_Try, /*On fail goto*//*Label 25931*/ GIMT_Encode4(1929855), // Rule ID 23816 //
     /* 1929774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1929777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1929782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1929785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1929788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1929791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929820 */     // MIs[0] policy
     /* 1929820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929830 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1929833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929854 */     // GIR_Coverage, 23816,
     /* 1929854 */     GIR_EraseRootFromParent_Done,
     /* 1929855 */   // Label 25931: @1929855
     /* 1929855 */   GIM_Try, /*On fail goto*//*Label 25932*/ GIMT_Encode4(1929941), // Rule ID 23817 //
     /* 1929860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1929863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1929868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1929871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1929874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1929877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929906 */     // MIs[0] policy
     /* 1929906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929916 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1929919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929940 */     // GIR_Coverage, 23817,
     /* 1929940 */     GIR_EraseRootFromParent_Done,
     /* 1929941 */   // Label 25932: @1929941
     /* 1929941 */   GIM_Try, /*On fail goto*//*Label 25933*/ GIMT_Encode4(1930027), // Rule ID 23820 //
     /* 1929946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1929954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1929957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1929960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1929963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1929969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1929976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1929980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1929984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929992 */     // MIs[0] policy
     /* 1929992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930002 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1930005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930026 */     // GIR_Coverage, 23820,
     /* 1930026 */     GIR_EraseRootFromParent_Done,
     /* 1930027 */   // Label 25933: @1930027
     /* 1930027 */   GIM_Try, /*On fail goto*//*Label 25934*/ GIMT_Encode4(1930113), // Rule ID 23821 //
     /* 1930032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1930040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1930043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1930046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1930049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930078 */     // MIs[0] policy
     /* 1930078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930088 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1930091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930112 */     // GIR_Coverage, 23821,
     /* 1930112 */     GIR_EraseRootFromParent_Done,
     /* 1930113 */   // Label 25934: @1930113
     /* 1930113 */   GIM_Try, /*On fail goto*//*Label 25935*/ GIMT_Encode4(1930199), // Rule ID 23824 //
     /* 1930118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1930126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1930129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1930132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1930135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930164 */     // MIs[0] policy
     /* 1930164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930174 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1930177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930198 */     // GIR_Coverage, 23824,
     /* 1930198 */     GIR_EraseRootFromParent_Done,
     /* 1930199 */   // Label 25935: @1930199
     /* 1930199 */   GIM_Try, /*On fail goto*//*Label 25936*/ GIMT_Encode4(1930285), // Rule ID 23825 //
     /* 1930204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1930212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1930215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1930218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1930221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930250 */     // MIs[0] policy
     /* 1930250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930260 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1930263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930284 */     // GIR_Coverage, 23825,
     /* 1930284 */     GIR_EraseRootFromParent_Done,
     /* 1930285 */   // Label 25936: @1930285
     /* 1930285 */   GIM_Try, /*On fail goto*//*Label 25937*/ GIMT_Encode4(1930371), // Rule ID 23828 //
     /* 1930290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1930298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1930301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1930304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1930307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1930313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930336 */     // MIs[0] policy
     /* 1930336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930346 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1930349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930370 */     // GIR_Coverage, 23828,
     /* 1930370 */     GIR_EraseRootFromParent_Done,
     /* 1930371 */   // Label 25937: @1930371
     /* 1930371 */   GIM_Try, /*On fail goto*//*Label 25938*/ GIMT_Encode4(1930457), // Rule ID 23829 //
     /* 1930376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1930384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1930387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1930390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1930393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1930399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930422 */     // MIs[0] policy
     /* 1930422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930432 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1930435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930456 */     // GIR_Coverage, 23829,
     /* 1930456 */     GIR_EraseRootFromParent_Done,
     /* 1930457 */   // Label 25938: @1930457
     /* 1930457 */   GIM_Try, /*On fail goto*//*Label 25939*/ GIMT_Encode4(1930543), // Rule ID 23832 //
     /* 1930462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1930470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1930473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1930476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1930479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930508 */     // MIs[0] policy
     /* 1930508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930518 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1930521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930542 */     // GIR_Coverage, 23832,
     /* 1930542 */     GIR_EraseRootFromParent_Done,
     /* 1930543 */   // Label 25939: @1930543
     /* 1930543 */   GIM_Try, /*On fail goto*//*Label 25940*/ GIMT_Encode4(1930629), // Rule ID 23833 //
     /* 1930548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1930556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1930559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1930562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1930565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930594 */     // MIs[0] policy
     /* 1930594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930604 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1930607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930628 */     // GIR_Coverage, 23833,
     /* 1930628 */     GIR_EraseRootFromParent_Done,
     /* 1930629 */   // Label 25940: @1930629
     /* 1930629 */   GIM_Try, /*On fail goto*//*Label 25941*/ GIMT_Encode4(1930715), // Rule ID 23836 //
     /* 1930634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1930642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1930645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1930648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1930651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930680 */     // MIs[0] policy
     /* 1930680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930690 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1930693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930714 */     // GIR_Coverage, 23836,
     /* 1930714 */     GIR_EraseRootFromParent_Done,
     /* 1930715 */   // Label 25941: @1930715
     /* 1930715 */   GIM_Try, /*On fail goto*//*Label 25942*/ GIMT_Encode4(1930801), // Rule ID 23837 //
     /* 1930720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1930728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1930731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1930734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1930737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930766 */     // MIs[0] policy
     /* 1930766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930776 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1930779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930800 */     // GIR_Coverage, 23837,
     /* 1930800 */     GIR_EraseRootFromParent_Done,
     /* 1930801 */   // Label 25942: @1930801
     /* 1930801 */   GIM_Try, /*On fail goto*//*Label 25943*/ GIMT_Encode4(1930887), // Rule ID 23840 //
     /* 1930806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1930814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1930817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1930820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1930823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930852 */     // MIs[0] policy
     /* 1930852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930862 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1930865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930886 */     // GIR_Coverage, 23840,
     /* 1930886 */     GIR_EraseRootFromParent_Done,
     /* 1930887 */   // Label 25943: @1930887
     /* 1930887 */   GIM_Try, /*On fail goto*//*Label 25944*/ GIMT_Encode4(1930973), // Rule ID 23841 //
     /* 1930892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1930900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1930903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1930906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1930909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930938 */     // MIs[0] policy
     /* 1930938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930948 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1930951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930972 */     // GIR_Coverage, 23841,
     /* 1930972 */     GIR_EraseRootFromParent_Done,
     /* 1930973 */   // Label 25944: @1930973
     /* 1930973 */   GIM_Try, /*On fail goto*//*Label 25945*/ GIMT_Encode4(1931059), // Rule ID 23844 //
     /* 1930978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1930986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1930989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1930992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1930995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931024 */     // MIs[0] policy
     /* 1931024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1931037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931058 */     // GIR_Coverage, 23844,
     /* 1931058 */     GIR_EraseRootFromParent_Done,
     /* 1931059 */   // Label 25945: @1931059
     /* 1931059 */   GIM_Try, /*On fail goto*//*Label 25946*/ GIMT_Encode4(1931145), // Rule ID 23845 //
     /* 1931064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1931075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1931078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1931081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931110 */     // MIs[0] policy
     /* 1931110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931120 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1931123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931144 */     // GIR_Coverage, 23845,
     /* 1931144 */     GIR_EraseRootFromParent_Done,
     /* 1931145 */   // Label 25946: @1931145
     /* 1931145 */   GIM_Try, /*On fail goto*//*Label 25947*/ GIMT_Encode4(1931231), // Rule ID 23848 //
     /* 1931150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1931161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1931164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1931167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931196 */     // MIs[0] policy
     /* 1931196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1931209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931230 */     // GIR_Coverage, 23848,
     /* 1931230 */     GIR_EraseRootFromParent_Done,
     /* 1931231 */   // Label 25947: @1931231
     /* 1931231 */   GIM_Try, /*On fail goto*//*Label 25948*/ GIMT_Encode4(1931317), // Rule ID 23849 //
     /* 1931236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1931247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1931250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1931253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931282 */     // MIs[0] policy
     /* 1931282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931292 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1931295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931316 */     // GIR_Coverage, 23849,
     /* 1931316 */     GIR_EraseRootFromParent_Done,
     /* 1931317 */   // Label 25948: @1931317
     /* 1931317 */   GIM_Try, /*On fail goto*//*Label 25949*/ GIMT_Encode4(1931403), // Rule ID 23852 //
     /* 1931322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1931333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1931336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1931339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931368 */     // MIs[0] policy
     /* 1931368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931378 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1931381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931402 */     // GIR_Coverage, 23852,
     /* 1931402 */     GIR_EraseRootFromParent_Done,
     /* 1931403 */   // Label 25949: @1931403
     /* 1931403 */   GIM_Try, /*On fail goto*//*Label 25950*/ GIMT_Encode4(1931489), // Rule ID 23853 //
     /* 1931408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1931419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1931422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1931425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931454 */     // MIs[0] policy
     /* 1931454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1931467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931488 */     // GIR_Coverage, 23853,
     /* 1931488 */     GIR_EraseRootFromParent_Done,
     /* 1931489 */   // Label 25950: @1931489
     /* 1931489 */   GIM_Try, /*On fail goto*//*Label 25951*/ GIMT_Encode4(1931575), // Rule ID 23856 //
     /* 1931494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1931497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1931505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1931508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1931511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1931517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931540 */     // MIs[0] policy
     /* 1931540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931550 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1931553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931574 */     // GIR_Coverage, 23856,
     /* 1931574 */     GIR_EraseRootFromParent_Done,
     /* 1931575 */   // Label 25951: @1931575
     /* 1931575 */   GIM_Try, /*On fail goto*//*Label 25952*/ GIMT_Encode4(1931661), // Rule ID 23857 //
     /* 1931580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1931583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1931591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1931594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1931597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1931603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931626 */     // MIs[0] policy
     /* 1931626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1931639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931660 */     // GIR_Coverage, 23857,
     /* 1931660 */     GIR_EraseRootFromParent_Done,
     /* 1931661 */   // Label 25952: @1931661
     /* 1931661 */   GIM_Try, /*On fail goto*//*Label 25953*/ GIMT_Encode4(1931747), // Rule ID 23860 //
     /* 1931666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1931669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1931677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1931680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1931683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931712 */     // MIs[0] policy
     /* 1931712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931722 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1931725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931746 */     // GIR_Coverage, 23860,
     /* 1931746 */     GIR_EraseRootFromParent_Done,
     /* 1931747 */   // Label 25953: @1931747
     /* 1931747 */   GIM_Try, /*On fail goto*//*Label 25954*/ GIMT_Encode4(1931833), // Rule ID 23861 //
     /* 1931752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1931755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1931763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1931766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1931769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931798 */     // MIs[0] policy
     /* 1931798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931808 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1931811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931832 */     // GIR_Coverage, 23861,
     /* 1931832 */     GIR_EraseRootFromParent_Done,
     /* 1931833 */   // Label 25954: @1931833
     /* 1931833 */   GIM_Try, /*On fail goto*//*Label 25955*/ GIMT_Encode4(1931919), // Rule ID 23864 //
     /* 1931838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1931841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1931849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1931852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1931855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931884 */     // MIs[0] policy
     /* 1931884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931894 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1931897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931918 */     // GIR_Coverage, 23864,
     /* 1931918 */     GIR_EraseRootFromParent_Done,
     /* 1931919 */   // Label 25955: @1931919
     /* 1931919 */   GIM_Try, /*On fail goto*//*Label 25956*/ GIMT_Encode4(1932005), // Rule ID 23865 //
     /* 1931924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1931927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1931935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1931938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1931941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931970 */     // MIs[0] policy
     /* 1931970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931980 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1931983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932004 */     // GIR_Coverage, 23865,
     /* 1932004 */     GIR_EraseRootFromParent_Done,
     /* 1932005 */   // Label 25956: @1932005
     /* 1932005 */   GIM_Try, /*On fail goto*//*Label 25957*/ GIMT_Encode4(1932091), // Rule ID 23956 //
     /* 1932010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1932021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1932024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1932027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932056 */     // MIs[0] policy
     /* 1932056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932066 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1932069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932090 */     // GIR_Coverage, 23956,
     /* 1932090 */     GIR_EraseRootFromParent_Done,
     /* 1932091 */   // Label 25957: @1932091
     /* 1932091 */   GIM_Try, /*On fail goto*//*Label 25958*/ GIMT_Encode4(1932177), // Rule ID 23957 //
     /* 1932096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1932107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1932110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1932113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932142 */     // MIs[0] policy
     /* 1932142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932152 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1932155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932176 */     // GIR_Coverage, 23957,
     /* 1932176 */     GIR_EraseRootFromParent_Done,
     /* 1932177 */   // Label 25958: @1932177
     /* 1932177 */   GIM_Try, /*On fail goto*//*Label 25959*/ GIMT_Encode4(1932263), // Rule ID 23960 //
     /* 1932182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1932193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1932196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1932199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932228 */     // MIs[0] policy
     /* 1932228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932238 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1932241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932262 */     // GIR_Coverage, 23960,
     /* 1932262 */     GIR_EraseRootFromParent_Done,
     /* 1932263 */   // Label 25959: @1932263
     /* 1932263 */   GIM_Try, /*On fail goto*//*Label 25960*/ GIMT_Encode4(1932349), // Rule ID 23961 //
     /* 1932268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1932279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1932282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1932285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932314 */     // MIs[0] policy
     /* 1932314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932324 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1932327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932348 */     // GIR_Coverage, 23961,
     /* 1932348 */     GIR_EraseRootFromParent_Done,
     /* 1932349 */   // Label 25960: @1932349
     /* 1932349 */   GIM_Try, /*On fail goto*//*Label 25961*/ GIMT_Encode4(1932435), // Rule ID 23964 //
     /* 1932354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1932365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1932368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1932371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932400 */     // MIs[0] policy
     /* 1932400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932410 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1932413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932434 */     // GIR_Coverage, 23964,
     /* 1932434 */     GIR_EraseRootFromParent_Done,
     /* 1932435 */   // Label 25961: @1932435
     /* 1932435 */   GIM_Try, /*On fail goto*//*Label 25962*/ GIMT_Encode4(1932521), // Rule ID 23965 //
     /* 1932440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1932451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1932454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1932457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932486 */     // MIs[0] policy
     /* 1932486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1932499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932520 */     // GIR_Coverage, 23965,
     /* 1932520 */     GIR_EraseRootFromParent_Done,
     /* 1932521 */   // Label 25962: @1932521
     /* 1932521 */   GIM_Try, /*On fail goto*//*Label 25963*/ GIMT_Encode4(1932607), // Rule ID 23968 //
     /* 1932526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1932537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1932540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1932543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932572 */     // MIs[0] policy
     /* 1932572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932582 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1932585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932606 */     // GIR_Coverage, 23968,
     /* 1932606 */     GIR_EraseRootFromParent_Done,
     /* 1932607 */   // Label 25963: @1932607
     /* 1932607 */   GIM_Try, /*On fail goto*//*Label 25964*/ GIMT_Encode4(1932693), // Rule ID 23969 //
     /* 1932612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1932623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1932626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1932629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932658 */     // MIs[0] policy
     /* 1932658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1932671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932692 */     // GIR_Coverage, 23969,
     /* 1932692 */     GIR_EraseRootFromParent_Done,
     /* 1932693 */   // Label 25964: @1932693
     /* 1932693 */   GIM_Try, /*On fail goto*//*Label 25965*/ GIMT_Encode4(1932779), // Rule ID 23972 //
     /* 1932698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1932709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1932712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1932715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932744 */     // MIs[0] policy
     /* 1932744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932754 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1932757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932778 */     // GIR_Coverage, 23972,
     /* 1932778 */     GIR_EraseRootFromParent_Done,
     /* 1932779 */   // Label 25965: @1932779
     /* 1932779 */   GIM_Try, /*On fail goto*//*Label 25966*/ GIMT_Encode4(1932865), // Rule ID 23973 //
     /* 1932784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1932795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1932798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1932801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932830 */     // MIs[0] policy
     /* 1932830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932840 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1932843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932864 */     // GIR_Coverage, 23973,
     /* 1932864 */     GIR_EraseRootFromParent_Done,
     /* 1932865 */   // Label 25966: @1932865
     /* 1932865 */   GIM_Try, /*On fail goto*//*Label 25967*/ GIMT_Encode4(1932951), // Rule ID 23976 //
     /* 1932870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1932881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1932884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1932887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932916 */     // MIs[0] policy
     /* 1932916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932926 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1932929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932950 */     // GIR_Coverage, 23976,
     /* 1932950 */     GIR_EraseRootFromParent_Done,
     /* 1932951 */   // Label 25967: @1932951
     /* 1932951 */   GIM_Try, /*On fail goto*//*Label 25968*/ GIMT_Encode4(1933037), // Rule ID 23977 //
     /* 1932956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1932967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1932970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1932973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933002 */     // MIs[0] policy
     /* 1933002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933012 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1933015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933036 */     // GIR_Coverage, 23977,
     /* 1933036 */     GIR_EraseRootFromParent_Done,
     /* 1933037 */   // Label 25968: @1933037
     /* 1933037 */   GIM_Try, /*On fail goto*//*Label 25969*/ GIMT_Encode4(1933123), // Rule ID 23980 //
     /* 1933042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1933050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1933053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1933056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1933059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933088 */     // MIs[0] policy
     /* 1933088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933098 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1933101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933122 */     // GIR_Coverage, 23980,
     /* 1933122 */     GIR_EraseRootFromParent_Done,
     /* 1933123 */   // Label 25969: @1933123
     /* 1933123 */   GIM_Try, /*On fail goto*//*Label 25970*/ GIMT_Encode4(1933209), // Rule ID 23981 //
     /* 1933128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1933136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1933139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1933142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1933145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933174 */     // MIs[0] policy
     /* 1933174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933184 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1933187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933208 */     // GIR_Coverage, 23981,
     /* 1933208 */     GIR_EraseRootFromParent_Done,
     /* 1933209 */   // Label 25970: @1933209
     /* 1933209 */   GIM_Try, /*On fail goto*//*Label 25971*/ GIMT_Encode4(1933295), // Rule ID 23984 //
     /* 1933214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1933222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1933225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1933228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1933231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933260 */     // MIs[0] policy
     /* 1933260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933270 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1933273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933294 */     // GIR_Coverage, 23984,
     /* 1933294 */     GIR_EraseRootFromParent_Done,
     /* 1933295 */   // Label 25971: @1933295
     /* 1933295 */   GIM_Try, /*On fail goto*//*Label 25972*/ GIMT_Encode4(1933381), // Rule ID 23985 //
     /* 1933300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1933308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1933311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1933314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1933317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933346 */     // MIs[0] policy
     /* 1933346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933356 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1933359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933380 */     // GIR_Coverage, 23985,
     /* 1933380 */     GIR_EraseRootFromParent_Done,
     /* 1933381 */   // Label 25972: @1933381
     /* 1933381 */   GIM_Try, /*On fail goto*//*Label 25973*/ GIMT_Encode4(1933467), // Rule ID 23988 //
     /* 1933386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1933394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1933397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1933400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1933403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933432 */     // MIs[0] policy
     /* 1933432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933442 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1933445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933466 */     // GIR_Coverage, 23988,
     /* 1933466 */     GIR_EraseRootFromParent_Done,
     /* 1933467 */   // Label 25973: @1933467
     /* 1933467 */   GIM_Try, /*On fail goto*//*Label 25974*/ GIMT_Encode4(1933553), // Rule ID 23989 //
     /* 1933472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1933480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1933483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1933486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1933489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933518 */     // MIs[0] policy
     /* 1933518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1933531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933552 */     // GIR_Coverage, 23989,
     /* 1933552 */     GIR_EraseRootFromParent_Done,
     /* 1933553 */   // Label 25974: @1933553
     /* 1933553 */   GIM_Try, /*On fail goto*//*Label 25975*/ GIMT_Encode4(1933639), // Rule ID 23992 //
     /* 1933558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1933561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1933566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1933569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1933572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1933575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933604 */     // MIs[0] policy
     /* 1933604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933614 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1933617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933638 */     // GIR_Coverage, 23992,
     /* 1933638 */     GIR_EraseRootFromParent_Done,
     /* 1933639 */   // Label 25975: @1933639
     /* 1933639 */   GIM_Try, /*On fail goto*//*Label 25976*/ GIMT_Encode4(1933725), // Rule ID 23993 //
     /* 1933644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1933647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1933652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1933655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1933658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1933661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933690 */     // MIs[0] policy
     /* 1933690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933700 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1933703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933724 */     // GIR_Coverage, 23993,
     /* 1933724 */     GIR_EraseRootFromParent_Done,
     /* 1933725 */   // Label 25976: @1933725
     /* 1933725 */   GIM_Try, /*On fail goto*//*Label 25977*/ GIMT_Encode4(1933811), // Rule ID 23996 //
     /* 1933730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1933738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1933741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1933744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1933747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1933753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1933760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933776 */     // MIs[0] policy
     /* 1933776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933786 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1933789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933810 */     // GIR_Coverage, 23996,
     /* 1933810 */     GIR_EraseRootFromParent_Done,
     /* 1933811 */   // Label 25977: @1933811
     /* 1933811 */   GIM_Try, /*On fail goto*//*Label 25978*/ GIMT_Encode4(1933897), // Rule ID 23997 //
     /* 1933816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1933824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1933827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1933830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1933833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1933839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1933846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933862 */     // MIs[0] policy
     /* 1933862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933872 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1933875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933896 */     // GIR_Coverage, 23997,
     /* 1933896 */     GIR_EraseRootFromParent_Done,
     /* 1933897 */   // Label 25978: @1933897
     /* 1933897 */   GIM_Try, /*On fail goto*//*Label 25979*/ GIMT_Encode4(1933983), // Rule ID 24000 //
     /* 1933902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1933910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1933913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1933916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1933919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1933925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1933932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933948 */     // MIs[0] policy
     /* 1933948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933958 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1933961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933982 */     // GIR_Coverage, 24000,
     /* 1933982 */     GIR_EraseRootFromParent_Done,
     /* 1933983 */   // Label 25979: @1933983
     /* 1933983 */   GIM_Try, /*On fail goto*//*Label 25980*/ GIMT_Encode4(1934069), // Rule ID 24001 //
     /* 1933988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1933996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1933999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1934002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1934005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1934011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934034 */     // MIs[0] policy
     /* 1934034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934044 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1934047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934068 */     // GIR_Coverage, 24001,
     /* 1934068 */     GIR_EraseRootFromParent_Done,
     /* 1934069 */   // Label 25980: @1934069
     /* 1934069 */   GIM_Try, /*On fail goto*//*Label 25981*/ GIMT_Encode4(1934155), // Rule ID 24004 //
     /* 1934074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1934082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1934085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1934088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1934091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1934097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934120 */     // MIs[0] policy
     /* 1934120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934130 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1934133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934154 */     // GIR_Coverage, 24004,
     /* 1934154 */     GIR_EraseRootFromParent_Done,
     /* 1934155 */   // Label 25981: @1934155
     /* 1934155 */   GIM_Try, /*On fail goto*//*Label 25982*/ GIMT_Encode4(1934241), // Rule ID 24005 //
     /* 1934160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1934168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1934171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1934174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1934177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1934183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934206 */     // MIs[0] policy
     /* 1934206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934216 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1934219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934240 */     // GIR_Coverage, 24005,
     /* 1934240 */     GIR_EraseRootFromParent_Done,
     /* 1934241 */   // Label 25982: @1934241
     /* 1934241 */   GIM_Try, /*On fail goto*//*Label 25983*/ GIMT_Encode4(1934327), // Rule ID 24008 //
     /* 1934246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1934254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1934257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1934260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1934263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934292 */     // MIs[0] policy
     /* 1934292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1934305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934326 */     // GIR_Coverage, 24008,
     /* 1934326 */     GIR_EraseRootFromParent_Done,
     /* 1934327 */   // Label 25983: @1934327
     /* 1934327 */   GIM_Try, /*On fail goto*//*Label 25984*/ GIMT_Encode4(1934413), // Rule ID 24009 //
     /* 1934332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1934340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1934343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1934346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1934349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934378 */     // MIs[0] policy
     /* 1934378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934388 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1934391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934412 */     // GIR_Coverage, 24009,
     /* 1934412 */     GIR_EraseRootFromParent_Done,
     /* 1934413 */   // Label 25984: @1934413
     /* 1934413 */   GIM_Try, /*On fail goto*//*Label 25985*/ GIMT_Encode4(1934499), // Rule ID 24012 //
     /* 1934418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1934426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1934429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1934432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1934435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934464 */     // MIs[0] policy
     /* 1934464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1934477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934498 */     // GIR_Coverage, 24012,
     /* 1934498 */     GIR_EraseRootFromParent_Done,
     /* 1934499 */   // Label 25985: @1934499
     /* 1934499 */   GIM_Try, /*On fail goto*//*Label 25986*/ GIMT_Encode4(1934585), // Rule ID 24013 //
     /* 1934504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1934512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1934515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1934518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1934521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934550 */     // MIs[0] policy
     /* 1934550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934560 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1934563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934584 */     // GIR_Coverage, 24013,
     /* 1934584 */     GIR_EraseRootFromParent_Done,
     /* 1934585 */   // Label 25986: @1934585
     /* 1934585 */   GIM_Try, /*On fail goto*//*Label 25987*/ GIMT_Encode4(1934671), // Rule ID 24016 //
     /* 1934590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1934598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1934601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1934604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1934607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1934613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934636 */     // MIs[0] policy
     /* 1934636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1934649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934670 */     // GIR_Coverage, 24016,
     /* 1934670 */     GIR_EraseRootFromParent_Done,
     /* 1934671 */   // Label 25987: @1934671
     /* 1934671 */   GIM_Try, /*On fail goto*//*Label 25988*/ GIMT_Encode4(1934757), // Rule ID 24017 //
     /* 1934676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1934684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1934687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1934690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1934693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1934699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934722 */     // MIs[0] policy
     /* 1934722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934732 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1934735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934756 */     // GIR_Coverage, 24017,
     /* 1934756 */     GIR_EraseRootFromParent_Done,
     /* 1934757 */   // Label 25988: @1934757
     /* 1934757 */   GIM_Try, /*On fail goto*//*Label 25989*/ GIMT_Encode4(1934843), // Rule ID 24020 //
     /* 1934762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1934770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1934773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1934776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1934779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1934785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934808 */     // MIs[0] policy
     /* 1934808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1934821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934842 */     // GIR_Coverage, 24020,
     /* 1934842 */     GIR_EraseRootFromParent_Done,
     /* 1934843 */   // Label 25989: @1934843
     /* 1934843 */   GIM_Try, /*On fail goto*//*Label 25990*/ GIMT_Encode4(1934929), // Rule ID 24021 //
     /* 1934848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1934856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1934859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1934862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1934865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1934871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934894 */     // MIs[0] policy
     /* 1934894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934904 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1934907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934928 */     // GIR_Coverage, 24021,
     /* 1934928 */     GIR_EraseRootFromParent_Done,
     /* 1934929 */   // Label 25990: @1934929
     /* 1934929 */   GIM_Try, /*On fail goto*//*Label 25991*/ GIMT_Encode4(1935015), // Rule ID 24024 //
     /* 1934934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1934942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1934945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1934948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1934951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934980 */     // MIs[0] policy
     /* 1934980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934990 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1934993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935014 */     // GIR_Coverage, 24024,
     /* 1935014 */     GIR_EraseRootFromParent_Done,
     /* 1935015 */   // Label 25991: @1935015
     /* 1935015 */   GIM_Try, /*On fail goto*//*Label 25992*/ GIMT_Encode4(1935101), // Rule ID 24025 //
     /* 1935020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1935028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1935031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1935034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1935037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935066 */     // MIs[0] policy
     /* 1935066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1935079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935100 */     // GIR_Coverage, 24025,
     /* 1935100 */     GIR_EraseRootFromParent_Done,
     /* 1935101 */   // Label 25992: @1935101
     /* 1935101 */   GIM_Try, /*On fail goto*//*Label 25993*/ GIMT_Encode4(1935187), // Rule ID 24028 //
     /* 1935106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1935114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1935117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1935120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1935123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935152 */     // MIs[0] policy
     /* 1935152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935162 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1935165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935186 */     // GIR_Coverage, 24028,
     /* 1935186 */     GIR_EraseRootFromParent_Done,
     /* 1935187 */   // Label 25993: @1935187
     /* 1935187 */   GIM_Try, /*On fail goto*//*Label 25994*/ GIMT_Encode4(1935273), // Rule ID 24029 //
     /* 1935192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1935200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1935203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1935206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1935209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935238 */     // MIs[0] policy
     /* 1935238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935248 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1935251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935272 */     // GIR_Coverage, 24029,
     /* 1935272 */     GIR_EraseRootFromParent_Done,
     /* 1935273 */   // Label 25994: @1935273
     /* 1935273 */   GIM_Try, /*On fail goto*//*Label 25995*/ GIMT_Encode4(1935359), // Rule ID 24032 //
     /* 1935278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1935281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1935286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1935289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1935292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1935295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935324 */     // MIs[0] policy
     /* 1935324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935334 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1935337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935358 */     // GIR_Coverage, 24032,
     /* 1935358 */     GIR_EraseRootFromParent_Done,
     /* 1935359 */   // Label 25995: @1935359
     /* 1935359 */   GIM_Try, /*On fail goto*//*Label 25996*/ GIMT_Encode4(1935445), // Rule ID 24033 //
     /* 1935364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1935367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1935372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1935375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1935378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1935381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935410 */     // MIs[0] policy
     /* 1935410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935420 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1935423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935444 */     // GIR_Coverage, 24033,
     /* 1935444 */     GIR_EraseRootFromParent_Done,
     /* 1935445 */   // Label 25996: @1935445
     /* 1935445 */   GIM_Try, /*On fail goto*//*Label 25997*/ GIMT_Encode4(1935531), // Rule ID 24036 //
     /* 1935450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1935453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1935458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1935461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1935464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1935467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935496 */     // MIs[0] policy
     /* 1935496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935506 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1935509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935530 */     // GIR_Coverage, 24036,
     /* 1935530 */     GIR_EraseRootFromParent_Done,
     /* 1935531 */   // Label 25997: @1935531
     /* 1935531 */   GIM_Try, /*On fail goto*//*Label 25998*/ GIMT_Encode4(1935617), // Rule ID 24037 //
     /* 1935536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1935539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1935544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1935547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1935550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1935553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935582 */     // MIs[0] policy
     /* 1935582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935592 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1935595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935616 */     // GIR_Coverage, 24037,
     /* 1935616 */     GIR_EraseRootFromParent_Done,
     /* 1935617 */   // Label 25998: @1935617
     /* 1935617 */   GIM_Try, /*On fail goto*//*Label 25999*/ GIMT_Encode4(1935703), // Rule ID 24040 //
     /* 1935622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1935625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1935630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1935633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1935636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1935639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935668 */     // MIs[0] policy
     /* 1935668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935678 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1935681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935702 */     // GIR_Coverage, 24040,
     /* 1935702 */     GIR_EraseRootFromParent_Done,
     /* 1935703 */   // Label 25999: @1935703
     /* 1935703 */   GIM_Try, /*On fail goto*//*Label 26000*/ GIMT_Encode4(1935789), // Rule ID 24041 //
     /* 1935708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1935711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1935716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1935719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1935722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1935725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935754 */     // MIs[0] policy
     /* 1935754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935764 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1935767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935788 */     // GIR_Coverage, 24041,
     /* 1935788 */     GIR_EraseRootFromParent_Done,
     /* 1935789 */   // Label 26000: @1935789
     /* 1935789 */   GIM_Try, /*On fail goto*//*Label 26001*/ GIMT_Encode4(1935875), // Rule ID 24044 //
     /* 1935794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1935805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1935808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1935811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1935817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1935824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935840 */     // MIs[0] policy
     /* 1935840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935850 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1935853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1935871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935874 */     // GIR_Coverage, 24044,
     /* 1935874 */     GIR_EraseRootFromParent_Done,
     /* 1935875 */   // Label 26001: @1935875
     /* 1935875 */   GIM_Try, /*On fail goto*//*Label 26002*/ GIMT_Encode4(1935961), // Rule ID 24045 //
     /* 1935880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1935891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1935894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1935897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1935903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1935910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935926 */     // MIs[0] policy
     /* 1935926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935936 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1935939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1935957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935960 */     // GIR_Coverage, 24045,
     /* 1935960 */     GIR_EraseRootFromParent_Done,
     /* 1935961 */   // Label 26002: @1935961
     /* 1935961 */   GIM_Try, /*On fail goto*//*Label 26003*/ GIMT_Encode4(1936047), // Rule ID 24048 //
     /* 1935966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1935977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1935980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1935983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1935996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936012 */     // MIs[0] policy
     /* 1936012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936022 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1936025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1936043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936046 */     // GIR_Coverage, 24048,
     /* 1936046 */     GIR_EraseRootFromParent_Done,
     /* 1936047 */   // Label 26003: @1936047
     /* 1936047 */   GIM_Try, /*On fail goto*//*Label 26004*/ GIMT_Encode4(1936133), // Rule ID 24049 //
     /* 1936052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1936063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1936066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1936069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936098 */     // MIs[0] policy
     /* 1936098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936108 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1936111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1936129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936132 */     // GIR_Coverage, 24049,
     /* 1936132 */     GIR_EraseRootFromParent_Done,
     /* 1936133 */   // Label 26004: @1936133
     /* 1936133 */   GIM_Try, /*On fail goto*//*Label 26005*/ GIMT_Encode4(1936219), // Rule ID 24052 //
     /* 1936138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1936149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1936152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1936155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936184 */     // MIs[0] policy
     /* 1936184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936194 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1936197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1936215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936218 */     // GIR_Coverage, 24052,
     /* 1936218 */     GIR_EraseRootFromParent_Done,
     /* 1936219 */   // Label 26005: @1936219
     /* 1936219 */   GIM_Try, /*On fail goto*//*Label 26006*/ GIMT_Encode4(1936305), // Rule ID 24053 //
     /* 1936224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1936235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1936238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1936241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936270 */     // MIs[0] policy
     /* 1936270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936280 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1936283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1936301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936304 */     // GIR_Coverage, 24053,
     /* 1936304 */     GIR_EraseRootFromParent_Done,
     /* 1936305 */   // Label 26006: @1936305
     /* 1936305 */   GIM_Try, /*On fail goto*//*Label 26007*/ GIMT_Encode4(1936391), // Rule ID 24056 //
     /* 1936310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1936321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1936324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1936327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936356 */     // MIs[0] policy
     /* 1936356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936366 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1936369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936390 */     // GIR_Coverage, 24056,
     /* 1936390 */     GIR_EraseRootFromParent_Done,
     /* 1936391 */   // Label 26007: @1936391
     /* 1936391 */   GIM_Try, /*On fail goto*//*Label 26008*/ GIMT_Encode4(1936477), // Rule ID 24057 //
     /* 1936396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1936407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1936410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1936413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936442 */     // MIs[0] policy
     /* 1936442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936452 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1936455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936476 */     // GIR_Coverage, 24057,
     /* 1936476 */     GIR_EraseRootFromParent_Done,
     /* 1936477 */   // Label 26008: @1936477
     /* 1936477 */   GIM_Try, /*On fail goto*//*Label 26009*/ GIMT_Encode4(1936563), // Rule ID 24060 //
     /* 1936482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1936493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1936496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1936499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936528 */     // MIs[0] policy
     /* 1936528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936538 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1936541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936562 */     // GIR_Coverage, 24060,
     /* 1936562 */     GIR_EraseRootFromParent_Done,
     /* 1936563 */   // Label 26009: @1936563
     /* 1936563 */   GIM_Try, /*On fail goto*//*Label 26010*/ GIMT_Encode4(1936649), // Rule ID 24061 //
     /* 1936568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1936579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1936582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1936585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936614 */     // MIs[0] policy
     /* 1936614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936624 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1936627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936648 */     // GIR_Coverage, 24061,
     /* 1936648 */     GIR_EraseRootFromParent_Done,
     /* 1936649 */   // Label 26010: @1936649
     /* 1936649 */   GIM_Try, /*On fail goto*//*Label 26011*/ GIMT_Encode4(1936735), // Rule ID 24064 //
     /* 1936654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1936665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1936668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1936671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936700 */     // MIs[0] policy
     /* 1936700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936710 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1936713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936734 */     // GIR_Coverage, 24064,
     /* 1936734 */     GIR_EraseRootFromParent_Done,
     /* 1936735 */   // Label 26011: @1936735
     /* 1936735 */   GIM_Try, /*On fail goto*//*Label 26012*/ GIMT_Encode4(1936821), // Rule ID 24065 //
     /* 1936740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1936751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1936754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1936757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936786 */     // MIs[0] policy
     /* 1936786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936796 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1936799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936820 */     // GIR_Coverage, 24065,
     /* 1936820 */     GIR_EraseRootFromParent_Done,
     /* 1936821 */   // Label 26012: @1936821
     /* 1936821 */   GIM_Try, /*On fail goto*//*Label 26013*/ GIMT_Encode4(1936907), // Rule ID 24068 //
     /* 1936826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1936837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1936840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1936843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936872 */     // MIs[0] policy
     /* 1936872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936882 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1936885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1936903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936906 */     // GIR_Coverage, 24068,
     /* 1936906 */     GIR_EraseRootFromParent_Done,
     /* 1936907 */   // Label 26013: @1936907
     /* 1936907 */   GIM_Try, /*On fail goto*//*Label 26014*/ GIMT_Encode4(1936993), // Rule ID 24069 //
     /* 1936912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1936923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1936926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1936929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936958 */     // MIs[0] policy
     /* 1936958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936968 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1936971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1936989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936992 */     // GIR_Coverage, 24069,
     /* 1936992 */     GIR_EraseRootFromParent_Done,
     /* 1936993 */   // Label 26014: @1936993
     /* 1936993 */   GIM_Try, /*On fail goto*//*Label 26015*/ GIMT_Encode4(1937079), // Rule ID 24072 //
     /* 1936998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1937006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1937009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1937012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1937015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937044 */     // MIs[0] policy
     /* 1937044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937054 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1937057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937078 */     // GIR_Coverage, 24072,
     /* 1937078 */     GIR_EraseRootFromParent_Done,
     /* 1937079 */   // Label 26015: @1937079
     /* 1937079 */   GIM_Try, /*On fail goto*//*Label 26016*/ GIMT_Encode4(1937165), // Rule ID 24073 //
     /* 1937084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1937092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1937095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1937098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1937101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937130 */     // MIs[0] policy
     /* 1937130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937140 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1937143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937164 */     // GIR_Coverage, 24073,
     /* 1937164 */     GIR_EraseRootFromParent_Done,
     /* 1937165 */   // Label 26016: @1937165
     /* 1937165 */   GIM_Try, /*On fail goto*//*Label 26017*/ GIMT_Encode4(1937251), // Rule ID 24076 //
     /* 1937170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1937178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1937181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1937184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1937187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937216 */     // MIs[0] policy
     /* 1937216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937226 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1937229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937250 */     // GIR_Coverage, 24076,
     /* 1937250 */     GIR_EraseRootFromParent_Done,
     /* 1937251 */   // Label 26017: @1937251
     /* 1937251 */   GIM_Try, /*On fail goto*//*Label 26018*/ GIMT_Encode4(1937337), // Rule ID 24077 //
     /* 1937256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1937264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1937267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1937270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1937273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937302 */     // MIs[0] policy
     /* 1937302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937312 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1937315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937336 */     // GIR_Coverage, 24077,
     /* 1937336 */     GIR_EraseRootFromParent_Done,
     /* 1937337 */   // Label 26018: @1937337
     /* 1937337 */   GIM_Try, /*On fail goto*//*Label 26019*/ GIMT_Encode4(1937423), // Rule ID 24080 //
     /* 1937342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1937345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1937350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1937353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1937356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1937359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937388 */     // MIs[0] policy
     /* 1937388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937398 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1937401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937422 */     // GIR_Coverage, 24080,
     /* 1937422 */     GIR_EraseRootFromParent_Done,
     /* 1937423 */   // Label 26019: @1937423
     /* 1937423 */   GIM_Try, /*On fail goto*//*Label 26020*/ GIMT_Encode4(1937509), // Rule ID 24081 //
     /* 1937428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1937431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1937436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1937439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1937442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1937445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937474 */     // MIs[0] policy
     /* 1937474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937484 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1937487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937508 */     // GIR_Coverage, 24081,
     /* 1937508 */     GIR_EraseRootFromParent_Done,
     /* 1937509 */   // Label 26020: @1937509
     /* 1937509 */   GIM_Try, /*On fail goto*//*Label 26021*/ GIMT_Encode4(1937595), // Rule ID 24084 //
     /* 1937514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1937522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1937525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1937528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1937531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937560 */     // MIs[0] policy
     /* 1937560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937570 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1937573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1937591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937594 */     // GIR_Coverage, 24084,
     /* 1937594 */     GIR_EraseRootFromParent_Done,
     /* 1937595 */   // Label 26021: @1937595
     /* 1937595 */   GIM_Try, /*On fail goto*//*Label 26022*/ GIMT_Encode4(1937681), // Rule ID 24085 //
     /* 1937600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1937608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1937611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1937614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1937617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937646 */     // MIs[0] policy
     /* 1937646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937656 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1937659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1937677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937680 */     // GIR_Coverage, 24085,
     /* 1937680 */     GIR_EraseRootFromParent_Done,
     /* 1937681 */   // Label 26022: @1937681
     /* 1937681 */   GIM_Try, /*On fail goto*//*Label 26023*/ GIMT_Encode4(1937767), // Rule ID 24088 //
     /* 1937686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1937694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1937697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1937700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1937703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1937709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937732 */     // MIs[0] policy
     /* 1937732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937742 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1937745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1937763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937766 */     // GIR_Coverage, 24088,
     /* 1937766 */     GIR_EraseRootFromParent_Done,
     /* 1937767 */   // Label 26023: @1937767
     /* 1937767 */   GIM_Try, /*On fail goto*//*Label 26024*/ GIMT_Encode4(1937853), // Rule ID 24089 //
     /* 1937772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1937780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1937783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1937786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1937789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1937795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937818 */     // MIs[0] policy
     /* 1937818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937828 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1937831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1937849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937852 */     // GIR_Coverage, 24089,
     /* 1937852 */     GIR_EraseRootFromParent_Done,
     /* 1937853 */   // Label 26024: @1937853
     /* 1937853 */   GIM_Try, /*On fail goto*//*Label 26025*/ GIMT_Encode4(1937939), // Rule ID 24092 //
     /* 1937858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1937866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1937869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1937872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1937875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1937881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937904 */     // MIs[0] policy
     /* 1937904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937914 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1937917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1937935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937938 */     // GIR_Coverage, 24092,
     /* 1937938 */     GIR_EraseRootFromParent_Done,
     /* 1937939 */   // Label 26025: @1937939
     /* 1937939 */   GIM_Try, /*On fail goto*//*Label 26026*/ GIMT_Encode4(1938025), // Rule ID 24093 //
     /* 1937944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1937952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1937955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1937958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1937961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1937967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937990 */     // MIs[0] policy
     /* 1937990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938000 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1938003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1938021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938024 */     // GIR_Coverage, 24093,
     /* 1938024 */     GIR_EraseRootFromParent_Done,
     /* 1938025 */   // Label 26026: @1938025
     /* 1938025 */   GIM_Try, /*On fail goto*//*Label 26027*/ GIMT_Encode4(1938111), // Rule ID 24096 //
     /* 1938030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1938038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1938041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1938044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1938047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938076 */     // MIs[0] policy
     /* 1938076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938086 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1938089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938110 */     // GIR_Coverage, 24096,
     /* 1938110 */     GIR_EraseRootFromParent_Done,
     /* 1938111 */   // Label 26027: @1938111
     /* 1938111 */   GIM_Try, /*On fail goto*//*Label 26028*/ GIMT_Encode4(1938197), // Rule ID 24097 //
     /* 1938116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1938124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1938127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1938130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1938133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938162 */     // MIs[0] policy
     /* 1938162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938172 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1938175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938196 */     // GIR_Coverage, 24097,
     /* 1938196 */     GIR_EraseRootFromParent_Done,
     /* 1938197 */   // Label 26028: @1938197
     /* 1938197 */   GIM_Try, /*On fail goto*//*Label 26029*/ GIMT_Encode4(1938283), // Rule ID 24100 //
     /* 1938202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1938210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1938213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1938216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1938219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1938225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938248 */     // MIs[0] policy
     /* 1938248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938258 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1938261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938282 */     // GIR_Coverage, 24100,
     /* 1938282 */     GIR_EraseRootFromParent_Done,
     /* 1938283 */   // Label 26029: @1938283
     /* 1938283 */   GIM_Try, /*On fail goto*//*Label 26030*/ GIMT_Encode4(1938369), // Rule ID 24101 //
     /* 1938288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1938296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1938299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1938302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1938305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1938311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938334 */     // MIs[0] policy
     /* 1938334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938344 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1938347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938368 */     // GIR_Coverage, 24101,
     /* 1938368 */     GIR_EraseRootFromParent_Done,
     /* 1938369 */   // Label 26030: @1938369
     /* 1938369 */   GIM_Try, /*On fail goto*//*Label 26031*/ GIMT_Encode4(1938455), // Rule ID 24104 //
     /* 1938374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1938382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1938385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1938388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1938391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1938397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938420 */     // MIs[0] policy
     /* 1938420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938430 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1938433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938454 */     // GIR_Coverage, 24104,
     /* 1938454 */     GIR_EraseRootFromParent_Done,
     /* 1938455 */   // Label 26031: @1938455
     /* 1938455 */   GIM_Try, /*On fail goto*//*Label 26032*/ GIMT_Encode4(1938541), // Rule ID 24105 //
     /* 1938460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1938468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1938471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1938474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1938477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1938483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938506 */     // MIs[0] policy
     /* 1938506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938516 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1938519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938540 */     // GIR_Coverage, 24105,
     /* 1938540 */     GIR_EraseRootFromParent_Done,
     /* 1938541 */   // Label 26032: @1938541
     /* 1938541 */   GIM_Try, /*On fail goto*//*Label 26033*/ GIMT_Encode4(1938627), // Rule ID 24108 //
     /* 1938546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1938554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1938557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1938560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1938563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938592 */     // MIs[0] policy
     /* 1938592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938602 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1938605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938626 */     // GIR_Coverage, 24108,
     /* 1938626 */     GIR_EraseRootFromParent_Done,
     /* 1938627 */   // Label 26033: @1938627
     /* 1938627 */   GIM_Try, /*On fail goto*//*Label 26034*/ GIMT_Encode4(1938713), // Rule ID 24109 //
     /* 1938632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1938640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1938643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1938646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1938649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938678 */     // MIs[0] policy
     /* 1938678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1938691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938712 */     // GIR_Coverage, 24109,
     /* 1938712 */     GIR_EraseRootFromParent_Done,
     /* 1938713 */   // Label 26034: @1938713
     /* 1938713 */   GIM_Try, /*On fail goto*//*Label 26035*/ GIMT_Encode4(1938799), // Rule ID 24112 //
     /* 1938718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1938726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1938729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1938732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1938735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938764 */     // MIs[0] policy
     /* 1938764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938774 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1938777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938798 */     // GIR_Coverage, 24112,
     /* 1938798 */     GIR_EraseRootFromParent_Done,
     /* 1938799 */   // Label 26035: @1938799
     /* 1938799 */   GIM_Try, /*On fail goto*//*Label 26036*/ GIMT_Encode4(1938885), // Rule ID 24113 //
     /* 1938804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1938812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1938815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1938818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1938821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938850 */     // MIs[0] policy
     /* 1938850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938860 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1938863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938884 */     // GIR_Coverage, 24113,
     /* 1938884 */     GIR_EraseRootFromParent_Done,
     /* 1938885 */   // Label 26036: @1938885
     /* 1938885 */   GIM_Try, /*On fail goto*//*Label 26037*/ GIMT_Encode4(1938971), // Rule ID 24116 //
     /* 1938890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1938898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1938901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1938904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1938907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1938913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938936 */     // MIs[0] policy
     /* 1938936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938946 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1938949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938970 */     // GIR_Coverage, 24116,
     /* 1938970 */     GIR_EraseRootFromParent_Done,
     /* 1938971 */   // Label 26037: @1938971
     /* 1938971 */   GIM_Try, /*On fail goto*//*Label 26038*/ GIMT_Encode4(1939057), // Rule ID 24117 //
     /* 1938976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1938984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1938987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1938990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1938993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1938999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1939006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939022 */     // MIs[0] policy
     /* 1939022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939032 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1939035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939056 */     // GIR_Coverage, 24117,
     /* 1939056 */     GIR_EraseRootFromParent_Done,
     /* 1939057 */   // Label 26038: @1939057
     /* 1939057 */   GIM_Try, /*On fail goto*//*Label 26039*/ GIMT_Encode4(1939143), // Rule ID 24120 //
     /* 1939062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1939065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1939070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1939073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1939076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1939079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939108 */     // MIs[0] policy
     /* 1939108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939118 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1939121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939142 */     // GIR_Coverage, 24120,
     /* 1939142 */     GIR_EraseRootFromParent_Done,
     /* 1939143 */   // Label 26039: @1939143
     /* 1939143 */   GIM_Try, /*On fail goto*//*Label 26040*/ GIMT_Encode4(1939229), // Rule ID 24121 //
     /* 1939148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1939151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1939156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1939159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1939162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1939165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939194 */     // MIs[0] policy
     /* 1939194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939204 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1939207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939228 */     // GIR_Coverage, 24121,
     /* 1939228 */     GIR_EraseRootFromParent_Done,
     /* 1939229 */   // Label 26040: @1939229
     /* 1939229 */   GIM_Try, /*On fail goto*//*Label 26041*/ GIMT_Encode4(1939315), // Rule ID 24124 //
     /* 1939234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1939237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1939242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1939245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1939248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1939251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939280 */     // MIs[0] policy
     /* 1939280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939290 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1939293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939314 */     // GIR_Coverage, 24124,
     /* 1939314 */     GIR_EraseRootFromParent_Done,
     /* 1939315 */   // Label 26041: @1939315
     /* 1939315 */   GIM_Try, /*On fail goto*//*Label 26042*/ GIMT_Encode4(1939401), // Rule ID 24125 //
     /* 1939320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1939323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1939328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1939331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1939334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1939337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939366 */     // MIs[0] policy
     /* 1939366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939376 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1939379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939400 */     // GIR_Coverage, 24125,
     /* 1939400 */     GIR_EraseRootFromParent_Done,
     /* 1939401 */   // Label 26042: @1939401
     /* 1939401 */   GIM_Try, /*On fail goto*//*Label 26043*/ GIMT_Encode4(1939487), // Rule ID 24128 //
     /* 1939406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1939409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1939414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1939417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1939420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1939423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1939436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939452 */     // MIs[0] policy
     /* 1939452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939462 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1939465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939486 */     // GIR_Coverage, 24128,
     /* 1939486 */     GIR_EraseRootFromParent_Done,
     /* 1939487 */   // Label 26043: @1939487
     /* 1939487 */   GIM_Try, /*On fail goto*//*Label 26044*/ GIMT_Encode4(1939573), // Rule ID 24129 //
     /* 1939492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1939495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1939500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1939503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1939506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1939509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1939522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939538 */     // MIs[0] policy
     /* 1939538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939548 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1939551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939572 */     // GIR_Coverage, 24129,
     /* 1939572 */     GIR_EraseRootFromParent_Done,
     /* 1939573 */   // Label 26044: @1939573
     /* 1939573 */   GIM_Try, /*On fail goto*//*Label 26045*/ GIMT_Encode4(1939659), // Rule ID 24132 //
     /* 1939578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1939581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1939586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1939589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1939592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1939595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939624 */     // MIs[0] policy
     /* 1939624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939634 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1939637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939658 */     // GIR_Coverage, 24132,
     /* 1939658 */     GIR_EraseRootFromParent_Done,
     /* 1939659 */   // Label 26045: @1939659
     /* 1939659 */   GIM_Try, /*On fail goto*//*Label 26046*/ GIMT_Encode4(1939745), // Rule ID 24133 //
     /* 1939664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1939667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1939672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1939675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1939678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1939681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939710 */     // MIs[0] policy
     /* 1939710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939720 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1939723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939744 */     // GIR_Coverage, 24133,
     /* 1939744 */     GIR_EraseRootFromParent_Done,
     /* 1939745 */   // Label 26046: @1939745
     /* 1939745 */   GIM_Try, /*On fail goto*//*Label 26047*/ GIMT_Encode4(1939831), // Rule ID 24136 //
     /* 1939750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1939753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1939758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1939761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1939764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1939767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939796 */     // MIs[0] policy
     /* 1939796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939806 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1939809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939830 */     // GIR_Coverage, 24136,
     /* 1939830 */     GIR_EraseRootFromParent_Done,
     /* 1939831 */   // Label 26047: @1939831
     /* 1939831 */   GIM_Try, /*On fail goto*//*Label 26048*/ GIMT_Encode4(1939917), // Rule ID 24137 //
     /* 1939836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1939839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1939844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1939847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1939850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1939853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939882 */     // MIs[0] policy
     /* 1939882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939892 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1939895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939916 */     // GIR_Coverage, 24137,
     /* 1939916 */     GIR_EraseRootFromParent_Done,
     /* 1939917 */   // Label 26048: @1939917
     /* 1939917 */   GIM_Try, /*On fail goto*//*Label 26049*/ GIMT_Encode4(1940003), // Rule ID 24140 //
     /* 1939922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1939925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1939930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1939933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1939936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1939939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939968 */     // MIs[0] policy
     /* 1939968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939978 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1939981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940002 */     // GIR_Coverage, 24140,
     /* 1940002 */     GIR_EraseRootFromParent_Done,
     /* 1940003 */   // Label 26049: @1940003
     /* 1940003 */   GIM_Try, /*On fail goto*//*Label 26050*/ GIMT_Encode4(1940089), // Rule ID 24141 //
     /* 1940008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1940011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1940016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1940019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1940022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1940025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1940031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940054 */     // MIs[0] policy
     /* 1940054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940064 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1940067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940088 */     // GIR_Coverage, 24141,
     /* 1940088 */     GIR_EraseRootFromParent_Done,
     /* 1940089 */   // Label 26050: @1940089
     /* 1940089 */   GIM_Try, /*On fail goto*//*Label 26051*/ GIMT_Encode4(1940175), // Rule ID 24144 //
     /* 1940094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1940097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1940102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1940105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1940108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1940111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940140 */     // MIs[0] policy
     /* 1940140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940150 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1940153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940174 */     // GIR_Coverage, 24144,
     /* 1940174 */     GIR_EraseRootFromParent_Done,
     /* 1940175 */   // Label 26051: @1940175
     /* 1940175 */   GIM_Try, /*On fail goto*//*Label 26052*/ GIMT_Encode4(1940261), // Rule ID 24145 //
     /* 1940180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1940183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1940188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1940191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1940194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1940197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940226 */     // MIs[0] policy
     /* 1940226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940236 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1940239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940260 */     // GIR_Coverage, 24145,
     /* 1940260 */     GIR_EraseRootFromParent_Done,
     /* 1940261 */   // Label 26052: @1940261
     /* 1940261 */   GIM_Try, /*On fail goto*//*Label 26053*/ GIMT_Encode4(1940347), // Rule ID 24148 //
     /* 1940266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1940269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1940274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1940277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1940280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1940283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940312 */     // MIs[0] policy
     /* 1940312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940322 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1940325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940346 */     // GIR_Coverage, 24148,
     /* 1940346 */     GIR_EraseRootFromParent_Done,
     /* 1940347 */   // Label 26053: @1940347
     /* 1940347 */   GIM_Try, /*On fail goto*//*Label 26054*/ GIMT_Encode4(1940433), // Rule ID 24149 //
     /* 1940352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1940355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1940360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1940363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1940366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1940369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940398 */     // MIs[0] policy
     /* 1940398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940408 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1940411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940432 */     // GIR_Coverage, 24149,
     /* 1940432 */     GIR_EraseRootFromParent_Done,
     /* 1940433 */   // Label 26054: @1940433
     /* 1940433 */   GIM_Try, /*On fail goto*//*Label 26055*/ GIMT_Encode4(1940519), // Rule ID 24152 //
     /* 1940438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1940441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1940446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1940449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1940452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1940455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1940461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940484 */     // MIs[0] policy
     /* 1940484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940494 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1940497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940518 */     // GIR_Coverage, 24152,
     /* 1940518 */     GIR_EraseRootFromParent_Done,
     /* 1940519 */   // Label 26055: @1940519
     /* 1940519 */   GIM_Try, /*On fail goto*//*Label 26056*/ GIMT_Encode4(1940605), // Rule ID 24153 //
     /* 1940524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1940527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1940532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1940535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1940538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1940541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1940547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940570 */     // MIs[0] policy
     /* 1940570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940580 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1940583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940604 */     // GIR_Coverage, 24153,
     /* 1940604 */     GIR_EraseRootFromParent_Done,
     /* 1940605 */   // Label 26056: @1940605
     /* 1940605 */   GIM_Try, /*On fail goto*//*Label 26057*/ GIMT_Encode4(1940691), // Rule ID 24156 //
     /* 1940610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1940613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1940618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1940621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1940624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1940627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940656 */     // MIs[0] policy
     /* 1940656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940666 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1940669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940690 */     // GIR_Coverage, 24156,
     /* 1940690 */     GIR_EraseRootFromParent_Done,
     /* 1940691 */   // Label 26057: @1940691
     /* 1940691 */   GIM_Try, /*On fail goto*//*Label 26058*/ GIMT_Encode4(1940777), // Rule ID 24157 //
     /* 1940696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1940699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1940704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1940707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1940710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1940713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940742 */     // MIs[0] policy
     /* 1940742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940752 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1940755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940776 */     // GIR_Coverage, 24157,
     /* 1940776 */     GIR_EraseRootFromParent_Done,
     /* 1940777 */   // Label 26058: @1940777
     /* 1940777 */   GIM_Try, /*On fail goto*//*Label 26059*/ GIMT_Encode4(1940863), // Rule ID 24160 //
     /* 1940782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1940785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1940790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1940793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1940796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1940799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940828 */     // MIs[0] policy
     /* 1940828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940838 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1940841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940862 */     // GIR_Coverage, 24160,
     /* 1940862 */     GIR_EraseRootFromParent_Done,
     /* 1940863 */   // Label 26059: @1940863
     /* 1940863 */   GIM_Try, /*On fail goto*//*Label 26060*/ GIMT_Encode4(1940949), // Rule ID 24161 //
     /* 1940868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1940871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1940876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1940879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1940882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1940885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940914 */     // MIs[0] policy
     /* 1940914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940924 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1940927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940948 */     // GIR_Coverage, 24161,
     /* 1940948 */     GIR_EraseRootFromParent_Done,
     /* 1940949 */   // Label 26060: @1940949
     /* 1940949 */   GIM_Try, /*On fail goto*//*Label 26061*/ GIMT_Encode4(1941035), // Rule ID 24164 //
     /* 1940954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1940957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1940962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1940965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1940968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1940971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1940977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941000 */     // MIs[0] policy
     /* 1941000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941010 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1941013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941034 */     // GIR_Coverage, 24164,
     /* 1941034 */     GIR_EraseRootFromParent_Done,
     /* 1941035 */   // Label 26061: @1941035
     /* 1941035 */   GIM_Try, /*On fail goto*//*Label 26062*/ GIMT_Encode4(1941121), // Rule ID 24165 //
     /* 1941040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1941048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1941051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1941054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1941057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1941063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1941070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941086 */     // MIs[0] policy
     /* 1941086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941096 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1941099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941120 */     // GIR_Coverage, 24165,
     /* 1941120 */     GIR_EraseRootFromParent_Done,
     /* 1941121 */   // Label 26062: @1941121
     /* 1941121 */   GIM_Try, /*On fail goto*//*Label 26063*/ GIMT_Encode4(1941207), // Rule ID 24168 //
     /* 1941126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1941129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1941134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1941137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1941140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1941143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1941156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941172 */     // MIs[0] policy
     /* 1941172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941182 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1941185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941206 */     // GIR_Coverage, 24168,
     /* 1941206 */     GIR_EraseRootFromParent_Done,
     /* 1941207 */   // Label 26063: @1941207
     /* 1941207 */   GIM_Try, /*On fail goto*//*Label 26064*/ GIMT_Encode4(1941293), // Rule ID 24169 //
     /* 1941212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1941215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1941220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1941223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1941226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1941229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1941242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941258 */     // MIs[0] policy
     /* 1941258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941268 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1941271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941292 */     // GIR_Coverage, 24169,
     /* 1941292 */     GIR_EraseRootFromParent_Done,
     /* 1941293 */   // Label 26064: @1941293
     /* 1941293 */   GIM_Try, /*On fail goto*//*Label 26065*/ GIMT_Encode4(1941379), // Rule ID 24172 //
     /* 1941298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1941301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1941306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1941309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1941312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1941315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1941328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941344 */     // MIs[0] policy
     /* 1941344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941354 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1941357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941378 */     // GIR_Coverage, 24172,
     /* 1941378 */     GIR_EraseRootFromParent_Done,
     /* 1941379 */   // Label 26065: @1941379
     /* 1941379 */   GIM_Try, /*On fail goto*//*Label 26066*/ GIMT_Encode4(1941465), // Rule ID 24173 //
     /* 1941384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1941387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1941392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1941395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1941398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1941401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1941414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941430 */     // MIs[0] policy
     /* 1941430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941440 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1941443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941464 */     // GIR_Coverage, 24173,
     /* 1941464 */     GIR_EraseRootFromParent_Done,
     /* 1941465 */   // Label 26066: @1941465
     /* 1941465 */   GIM_Try, /*On fail goto*//*Label 26067*/ GIMT_Encode4(1941551), // Rule ID 24176 //
     /* 1941470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1941473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1941478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1941481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1941484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1941487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1941493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1941500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941516 */     // MIs[0] policy
     /* 1941516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941526 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1941529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941550 */     // GIR_Coverage, 24176,
     /* 1941550 */     GIR_EraseRootFromParent_Done,
     /* 1941551 */   // Label 26067: @1941551
     /* 1941551 */   GIM_Try, /*On fail goto*//*Label 26068*/ GIMT_Encode4(1941637), // Rule ID 24177 //
     /* 1941556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1941559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1941564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1941567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1941570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1941573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1941579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1941586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941602 */     // MIs[0] policy
     /* 1941602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941612 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1941615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941636 */     // GIR_Coverage, 24177,
     /* 1941636 */     GIR_EraseRootFromParent_Done,
     /* 1941637 */   // Label 26068: @1941637
     /* 1941637 */   GIM_Try, /*On fail goto*//*Label 26069*/ GIMT_Encode4(1941723), // Rule ID 24180 //
     /* 1941642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1941645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1941650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1941653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1941656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1941659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1941672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941688 */     // MIs[0] policy
     /* 1941688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941698 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1941701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941722 */     // GIR_Coverage, 24180,
     /* 1941722 */     GIR_EraseRootFromParent_Done,
     /* 1941723 */   // Label 26069: @1941723
     /* 1941723 */   GIM_Try, /*On fail goto*//*Label 26070*/ GIMT_Encode4(1941809), // Rule ID 24181 //
     /* 1941728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1941731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1941736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1941739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1941742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1941745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1941758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941774 */     // MIs[0] policy
     /* 1941774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941784 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1941787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941808 */     // GIR_Coverage, 24181,
     /* 1941808 */     GIR_EraseRootFromParent_Done,
     /* 1941809 */   // Label 26070: @1941809
     /* 1941809 */   GIM_Try, /*On fail goto*//*Label 26071*/ GIMT_Encode4(1941895), // Rule ID 24184 //
     /* 1941814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1941817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1941822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1941825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1941828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1941831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1941844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941860 */     // MIs[0] policy
     /* 1941860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941870 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1941873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941894 */     // GIR_Coverage, 24184,
     /* 1941894 */     GIR_EraseRootFromParent_Done,
     /* 1941895 */   // Label 26071: @1941895
     /* 1941895 */   GIM_Try, /*On fail goto*//*Label 26072*/ GIMT_Encode4(1941981), // Rule ID 24185 //
     /* 1941900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1941903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1941908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1941911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1941914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1941917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1941930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941946 */     // MIs[0] policy
     /* 1941946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941956 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1941959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941980 */     // GIR_Coverage, 24185,
     /* 1941980 */     GIR_EraseRootFromParent_Done,
     /* 1941981 */   // Label 26072: @1941981
     /* 1941981 */   GIM_Try, /*On fail goto*//*Label 26073*/ GIMT_Encode4(1942067), // Rule ID 24188 //
     /* 1941986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1941989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1941994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1941997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1942000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1942003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942032 */     // MIs[0] policy
     /* 1942032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942042 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1942045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1942049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1942063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942066 */     // GIR_Coverage, 24188,
     /* 1942066 */     GIR_EraseRootFromParent_Done,
     /* 1942067 */   // Label 26073: @1942067
     /* 1942067 */   GIM_Try, /*On fail goto*//*Label 26074*/ GIMT_Encode4(1942153), // Rule ID 24189 //
     /* 1942072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1942075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1942080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1942083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1942086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1942089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942118 */     // MIs[0] policy
     /* 1942118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942128 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1942131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1942135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1942149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942152 */     // GIR_Coverage, 24189,
     /* 1942152 */     GIR_EraseRootFromParent_Done,
     /* 1942153 */   // Label 26074: @1942153
     /* 1942153 */   GIM_Try, /*On fail goto*//*Label 26075*/ GIMT_Encode4(1942239), // Rule ID 24252 //
     /* 1942158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1942166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1942169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1942172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1942175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942204 */     // MIs[0] policy
     /* 1942204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942214 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1942217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1942221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942238 */     // GIR_Coverage, 24252,
     /* 1942238 */     GIR_EraseRootFromParent_Done,
     /* 1942239 */   // Label 26075: @1942239
     /* 1942239 */   GIM_Try, /*On fail goto*//*Label 26076*/ GIMT_Encode4(1942325), // Rule ID 24253 //
     /* 1942244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1942252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1942255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1942258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1942261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942290 */     // MIs[0] policy
     /* 1942290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942300 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1942303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1942307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942324 */     // GIR_Coverage, 24253,
     /* 1942324 */     GIR_EraseRootFromParent_Done,
     /* 1942325 */   // Label 26076: @1942325
     /* 1942325 */   GIM_Try, /*On fail goto*//*Label 26077*/ GIMT_Encode4(1942411), // Rule ID 24256 //
     /* 1942330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1942338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1942341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1942344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1942347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942376 */     // MIs[0] policy
     /* 1942376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942386 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1942389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1942393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942410 */     // GIR_Coverage, 24256,
     /* 1942410 */     GIR_EraseRootFromParent_Done,
     /* 1942411 */   // Label 26077: @1942411
     /* 1942411 */   GIM_Try, /*On fail goto*//*Label 26078*/ GIMT_Encode4(1942497), // Rule ID 24257 //
     /* 1942416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1942424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1942427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1942430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1942433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942462 */     // MIs[0] policy
     /* 1942462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942472 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1942475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1942479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942496 */     // GIR_Coverage, 24257,
     /* 1942496 */     GIR_EraseRootFromParent_Done,
     /* 1942497 */   // Label 26078: @1942497
     /* 1942497 */   GIM_Try, /*On fail goto*//*Label 26079*/ GIMT_Encode4(1942583), // Rule ID 24260 //
     /* 1942502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1942510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1942513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1942516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1942519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942548 */     // MIs[0] policy
     /* 1942548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942558 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1942561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1942565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942582 */     // GIR_Coverage, 24260,
     /* 1942582 */     GIR_EraseRootFromParent_Done,
     /* 1942583 */   // Label 26079: @1942583
     /* 1942583 */   GIM_Try, /*On fail goto*//*Label 26080*/ GIMT_Encode4(1942669), // Rule ID 24261 //
     /* 1942588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1942591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1942596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1942599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1942602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1942605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942634 */     // MIs[0] policy
     /* 1942634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942644 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1942647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1942651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942668 */     // GIR_Coverage, 24261,
     /* 1942668 */     GIR_EraseRootFromParent_Done,
     /* 1942669 */   // Label 26080: @1942669
     /* 1942669 */   GIM_Try, /*On fail goto*//*Label 26081*/ GIMT_Encode4(1942755), // Rule ID 24264 //
     /* 1942674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1942682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1942685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1942688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1942691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942720 */     // MIs[0] policy
     /* 1942720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942730 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1942733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1942737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942754 */     // GIR_Coverage, 24264,
     /* 1942754 */     GIR_EraseRootFromParent_Done,
     /* 1942755 */   // Label 26081: @1942755
     /* 1942755 */   GIM_Try, /*On fail goto*//*Label 26082*/ GIMT_Encode4(1942841), // Rule ID 24265 //
     /* 1942760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1942768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1942771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1942774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1942777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942806 */     // MIs[0] policy
     /* 1942806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942816 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1942819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1942823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942840 */     // GIR_Coverage, 24265,
     /* 1942840 */     GIR_EraseRootFromParent_Done,
     /* 1942841 */   // Label 26082: @1942841
     /* 1942841 */   GIM_Try, /*On fail goto*//*Label 26083*/ GIMT_Encode4(1942927), // Rule ID 24268 //
     /* 1942846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1942854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1942857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1942860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1942863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942892 */     // MIs[0] policy
     /* 1942892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942902 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1942905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1942909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942926 */     // GIR_Coverage, 24268,
     /* 1942926 */     GIR_EraseRootFromParent_Done,
     /* 1942927 */   // Label 26083: @1942927
     /* 1942927 */   GIM_Try, /*On fail goto*//*Label 26084*/ GIMT_Encode4(1943013), // Rule ID 24269 //
     /* 1942932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1942935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1942940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1942943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1942946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1942949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1942974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942978 */     // MIs[0] policy
     /* 1942978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942988 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1942991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1942995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943012 */     // GIR_Coverage, 24269,
     /* 1943012 */     GIR_EraseRootFromParent_Done,
     /* 1943013 */   // Label 26084: @1943013
     /* 1943013 */   GIM_Try, /*On fail goto*//*Label 26085*/ GIMT_Encode4(1943099), // Rule ID 24272 //
     /* 1943018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1943026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1943029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1943032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1943035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943064 */     // MIs[0] policy
     /* 1943064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943074 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1943077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1943081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943098 */     // GIR_Coverage, 24272,
     /* 1943098 */     GIR_EraseRootFromParent_Done,
     /* 1943099 */   // Label 26085: @1943099
     /* 1943099 */   GIM_Try, /*On fail goto*//*Label 26086*/ GIMT_Encode4(1943185), // Rule ID 24273 //
     /* 1943104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1943112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1943115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1943118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1943121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943150 */     // MIs[0] policy
     /* 1943150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943160 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1943163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1943167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943184 */     // GIR_Coverage, 24273,
     /* 1943184 */     GIR_EraseRootFromParent_Done,
     /* 1943185 */   // Label 26086: @1943185
     /* 1943185 */   GIM_Try, /*On fail goto*//*Label 26087*/ GIMT_Encode4(1943271), // Rule ID 24276 //
     /* 1943190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1943193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1943198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1943201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1943204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1943207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943236 */     // MIs[0] policy
     /* 1943236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943246 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1943249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1943253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943270 */     // GIR_Coverage, 24276,
     /* 1943270 */     GIR_EraseRootFromParent_Done,
     /* 1943271 */   // Label 26087: @1943271
     /* 1943271 */   GIM_Try, /*On fail goto*//*Label 26088*/ GIMT_Encode4(1943357), // Rule ID 24277 //
     /* 1943276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1943279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1943284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1943287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1943290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1943293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943322 */     // MIs[0] policy
     /* 1943322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943332 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1943335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1943339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943356 */     // GIR_Coverage, 24277,
     /* 1943356 */     GIR_EraseRootFromParent_Done,
     /* 1943357 */   // Label 26088: @1943357
     /* 1943357 */   GIM_Try, /*On fail goto*//*Label 26089*/ GIMT_Encode4(1943443), // Rule ID 24280 //
     /* 1943362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1943365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1943370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1943373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1943376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1943379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1943385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943408 */     // MIs[0] policy
     /* 1943408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943418 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1943421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1943425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943442 */     // GIR_Coverage, 24280,
     /* 1943442 */     GIR_EraseRootFromParent_Done,
     /* 1943443 */   // Label 26089: @1943443
     /* 1943443 */   GIM_Try, /*On fail goto*//*Label 26090*/ GIMT_Encode4(1943529), // Rule ID 24281 //
     /* 1943448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1943451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1943456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1943459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1943462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1943465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1943471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943494 */     // MIs[0] policy
     /* 1943494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943504 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1943507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1943511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943528 */     // GIR_Coverage, 24281,
     /* 1943528 */     GIR_EraseRootFromParent_Done,
     /* 1943529 */   // Label 26090: @1943529
     /* 1943529 */   GIM_Try, /*On fail goto*//*Label 26091*/ GIMT_Encode4(1943615), // Rule ID 24284 //
     /* 1943534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1943537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1943542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1943545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1943548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1943551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1943557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943580 */     // MIs[0] policy
     /* 1943580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943590 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1943593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1943597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943614 */     // GIR_Coverage, 24284,
     /* 1943614 */     GIR_EraseRootFromParent_Done,
     /* 1943615 */   // Label 26091: @1943615
     /* 1943615 */   GIM_Try, /*On fail goto*//*Label 26092*/ GIMT_Encode4(1943701), // Rule ID 24285 //
     /* 1943620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1943623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1943628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1943631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1943634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1943637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1943643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943666 */     // MIs[0] policy
     /* 1943666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943676 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1943679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1943683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943700 */     // GIR_Coverage, 24285,
     /* 1943700 */     GIR_EraseRootFromParent_Done,
     /* 1943701 */   // Label 26092: @1943701
     /* 1943701 */   GIM_Try, /*On fail goto*//*Label 26093*/ GIMT_Encode4(1943787), // Rule ID 24288 //
     /* 1943706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1943709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1943714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1943717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1943720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1943723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943752 */     // MIs[0] policy
     /* 1943752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943762 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1943765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1943769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943786 */     // GIR_Coverage, 24288,
     /* 1943786 */     GIR_EraseRootFromParent_Done,
     /* 1943787 */   // Label 26093: @1943787
     /* 1943787 */   GIM_Try, /*On fail goto*//*Label 26094*/ GIMT_Encode4(1943873), // Rule ID 24289 //
     /* 1943792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1943795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1943800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1943803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1943806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1943809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943838 */     // MIs[0] policy
     /* 1943838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943848 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1943851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1943855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943872 */     // GIR_Coverage, 24289,
     /* 1943872 */     GIR_EraseRootFromParent_Done,
     /* 1943873 */   // Label 26094: @1943873
     /* 1943873 */   GIM_Try, /*On fail goto*//*Label 26095*/ GIMT_Encode4(1943959), // Rule ID 24292 //
     /* 1943878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1943881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1943886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1943889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1943892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1943895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943924 */     // MIs[0] policy
     /* 1943924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943934 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1943937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1943941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943958 */     // GIR_Coverage, 24292,
     /* 1943958 */     GIR_EraseRootFromParent_Done,
     /* 1943959 */   // Label 26095: @1943959
     /* 1943959 */   GIM_Try, /*On fail goto*//*Label 26096*/ GIMT_Encode4(1944045), // Rule ID 24293 //
     /* 1943964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1943967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1943972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1943975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1943978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1943981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944010 */     // MIs[0] policy
     /* 1944010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944020 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1944023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1944027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944044 */     // GIR_Coverage, 24293,
     /* 1944044 */     GIR_EraseRootFromParent_Done,
     /* 1944045 */   // Label 26096: @1944045
     /* 1944045 */   GIM_Try, /*On fail goto*//*Label 26097*/ GIMT_Encode4(1944131), // Rule ID 24296 //
     /* 1944050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1944053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1944058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1944061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1944064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1944067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1944073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1944080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944096 */     // MIs[0] policy
     /* 1944096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944106 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1944109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1944113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944130 */     // GIR_Coverage, 24296,
     /* 1944130 */     GIR_EraseRootFromParent_Done,
     /* 1944131 */   // Label 26097: @1944131
     /* 1944131 */   GIM_Try, /*On fail goto*//*Label 26098*/ GIMT_Encode4(1944217), // Rule ID 24297 //
     /* 1944136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1944139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1944144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1944147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1944150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1944153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1944159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1944166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944182 */     // MIs[0] policy
     /* 1944182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944192 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1944195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1944199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944216 */     // GIR_Coverage, 24297,
     /* 1944216 */     GIR_EraseRootFromParent_Done,
     /* 1944217 */   // Label 26098: @1944217
     /* 1944217 */   GIM_Try, /*On fail goto*//*Label 26099*/ GIMT_Encode4(1944303), // Rule ID 24300 //
     /* 1944222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1944225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1944230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1944233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1944236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1944239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1944252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944268 */     // MIs[0] policy
     /* 1944268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944278 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1944281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1944285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944302 */     // GIR_Coverage, 24300,
     /* 1944302 */     GIR_EraseRootFromParent_Done,
     /* 1944303 */   // Label 26099: @1944303
     /* 1944303 */   GIM_Try, /*On fail goto*//*Label 26100*/ GIMT_Encode4(1944389), // Rule ID 24301 //
     /* 1944308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1944311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1944316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1944319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1944322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1944325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1944338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944354 */     // MIs[0] policy
     /* 1944354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944364 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1944367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1944371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944388 */     // GIR_Coverage, 24301,
     /* 1944388 */     GIR_EraseRootFromParent_Done,
     /* 1944389 */   // Label 26100: @1944389
     /* 1944389 */   GIM_Try, /*On fail goto*//*Label 26101*/ GIMT_Encode4(1944475), // Rule ID 24304 //
     /* 1944394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1944397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1944402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1944405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1944408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1944411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1944424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944440 */     // MIs[0] policy
     /* 1944440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944450 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1944453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1944457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944474 */     // GIR_Coverage, 24304,
     /* 1944474 */     GIR_EraseRootFromParent_Done,
     /* 1944475 */   // Label 26101: @1944475
     /* 1944475 */   GIM_Try, /*On fail goto*//*Label 26102*/ GIMT_Encode4(1944561), // Rule ID 24305 //
     /* 1944480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1944483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1944488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1944491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1944494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1944497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1944510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944526 */     // MIs[0] policy
     /* 1944526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944536 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1944539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1944543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944560 */     // GIR_Coverage, 24305,
     /* 1944560 */     GIR_EraseRootFromParent_Done,
     /* 1944561 */   // Label 26102: @1944561
     /* 1944561 */   GIM_Try, /*On fail goto*//*Label 26103*/ GIMT_Encode4(1944647), // Rule ID 24308 //
     /* 1944566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1944569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1944574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1944577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1944580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1944583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1944589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1944596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944612 */     // MIs[0] policy
     /* 1944612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944622 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1944625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1944629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944646 */     // GIR_Coverage, 24308,
     /* 1944646 */     GIR_EraseRootFromParent_Done,
     /* 1944647 */   // Label 26103: @1944647
     /* 1944647 */   GIM_Try, /*On fail goto*//*Label 26104*/ GIMT_Encode4(1944733), // Rule ID 24309 //
     /* 1944652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1944655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1944660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1944663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1944666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1944669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1944675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1944682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944698 */     // MIs[0] policy
     /* 1944698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944708 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1944711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1944715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944732 */     // GIR_Coverage, 24309,
     /* 1944732 */     GIR_EraseRootFromParent_Done,
     /* 1944733 */   // Label 26104: @1944733
     /* 1944733 */   GIM_Try, /*On fail goto*//*Label 26105*/ GIMT_Encode4(1944819), // Rule ID 24372 //
     /* 1944738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1944746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1944749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1944752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1944755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944784 */     // MIs[0] policy
     /* 1944784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944794 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1944797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944818 */     // GIR_Coverage, 24372,
     /* 1944818 */     GIR_EraseRootFromParent_Done,
     /* 1944819 */   // Label 26105: @1944819
     /* 1944819 */   GIM_Try, /*On fail goto*//*Label 26106*/ GIMT_Encode4(1944905), // Rule ID 24373 //
     /* 1944824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1944832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1944835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1944838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1944841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944870 */     // MIs[0] policy
     /* 1944870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944880 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1944883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944904 */     // GIR_Coverage, 24373,
     /* 1944904 */     GIR_EraseRootFromParent_Done,
     /* 1944905 */   // Label 26106: @1944905
     /* 1944905 */   GIM_Try, /*On fail goto*//*Label 26107*/ GIMT_Encode4(1944991), // Rule ID 24376 //
     /* 1944910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1944918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1944921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1944924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1944927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944956 */     // MIs[0] policy
     /* 1944956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944966 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1944969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944990 */     // GIR_Coverage, 24376,
     /* 1944990 */     GIR_EraseRootFromParent_Done,
     /* 1944991 */   // Label 26107: @1944991
     /* 1944991 */   GIM_Try, /*On fail goto*//*Label 26108*/ GIMT_Encode4(1945077), // Rule ID 24377 //
     /* 1944996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1945004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1945007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1945010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1945013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1945019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945042 */     // MIs[0] policy
     /* 1945042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1945055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945076 */     // GIR_Coverage, 24377,
     /* 1945076 */     GIR_EraseRootFromParent_Done,
     /* 1945077 */   // Label 26108: @1945077
     /* 1945077 */   GIM_Try, /*On fail goto*//*Label 26109*/ GIMT_Encode4(1945163), // Rule ID 24380 //
     /* 1945082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1945090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1945093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1945096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1945099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1945105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945128 */     // MIs[0] policy
     /* 1945128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945138 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1945141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945162 */     // GIR_Coverage, 24380,
     /* 1945162 */     GIR_EraseRootFromParent_Done,
     /* 1945163 */   // Label 26109: @1945163
     /* 1945163 */   GIM_Try, /*On fail goto*//*Label 26110*/ GIMT_Encode4(1945249), // Rule ID 24381 //
     /* 1945168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1945176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1945179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1945182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1945185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1945191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945214 */     // MIs[0] policy
     /* 1945214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945224 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1945227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945248 */     // GIR_Coverage, 24381,
     /* 1945248 */     GIR_EraseRootFromParent_Done,
     /* 1945249 */   // Label 26110: @1945249
     /* 1945249 */   GIM_Try, /*On fail goto*//*Label 26111*/ GIMT_Encode4(1945335), // Rule ID 24384 //
     /* 1945254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1945257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1945262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1945265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1945268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1945271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945300 */     // MIs[0] policy
     /* 1945300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945310 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1945313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945334 */     // GIR_Coverage, 24384,
     /* 1945334 */     GIR_EraseRootFromParent_Done,
     /* 1945335 */   // Label 26111: @1945335
     /* 1945335 */   GIM_Try, /*On fail goto*//*Label 26112*/ GIMT_Encode4(1945421), // Rule ID 24385 //
     /* 1945340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1945343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1945348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1945351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1945354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1945357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945386 */     // MIs[0] policy
     /* 1945386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945396 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1945399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945420 */     // GIR_Coverage, 24385,
     /* 1945420 */     GIR_EraseRootFromParent_Done,
     /* 1945421 */   // Label 26112: @1945421
     /* 1945421 */   GIM_Try, /*On fail goto*//*Label 26113*/ GIMT_Encode4(1945507), // Rule ID 24388 //
     /* 1945426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1945434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1945437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1945440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1945443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1945449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945472 */     // MIs[0] policy
     /* 1945472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945482 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1945485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945506 */     // GIR_Coverage, 24388,
     /* 1945506 */     GIR_EraseRootFromParent_Done,
     /* 1945507 */   // Label 26113: @1945507
     /* 1945507 */   GIM_Try, /*On fail goto*//*Label 26114*/ GIMT_Encode4(1945593), // Rule ID 24389 //
     /* 1945512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1945520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1945523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1945526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1945529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1945535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945558 */     // MIs[0] policy
     /* 1945558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945568 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1945571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945592 */     // GIR_Coverage, 24389,
     /* 1945592 */     GIR_EraseRootFromParent_Done,
     /* 1945593 */   // Label 26114: @1945593
     /* 1945593 */   GIM_Try, /*On fail goto*//*Label 26115*/ GIMT_Encode4(1945679), // Rule ID 24392 //
     /* 1945598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1945601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1945606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1945609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1945612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1945615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1945621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1945640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945644 */     // MIs[0] policy
     /* 1945644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945654 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1945657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945678 */     // GIR_Coverage, 24392,
     /* 1945678 */     GIR_EraseRootFromParent_Done,
     /* 1945679 */   // Label 26115: @1945679
     /* 1945679 */   GIM_Try, /*On fail goto*//*Label 26116*/ GIMT_Encode4(1945765), // Rule ID 24393 //
     /* 1945684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1945687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1945692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1945695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1945698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1945701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1945707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1945726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945730 */     // MIs[0] policy
     /* 1945730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945740 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1945743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945764 */     // GIR_Coverage, 24393,
     /* 1945764 */     GIR_EraseRootFromParent_Done,
     /* 1945765 */   // Label 26116: @1945765
     /* 1945765 */   GIM_Try, /*On fail goto*//*Label 26117*/ GIMT_Encode4(1945851), // Rule ID 24396 //
     /* 1945770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1945773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1945778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1945781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1945784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1945787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945816 */     // MIs[0] policy
     /* 1945816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945826 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1945829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945850 */     // GIR_Coverage, 24396,
     /* 1945850 */     GIR_EraseRootFromParent_Done,
     /* 1945851 */   // Label 26117: @1945851
     /* 1945851 */   GIM_Try, /*On fail goto*//*Label 26118*/ GIMT_Encode4(1945937), // Rule ID 24397 //
     /* 1945856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1945859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1945864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1945867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1945870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1945873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945902 */     // MIs[0] policy
     /* 1945902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945912 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1945915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945936 */     // GIR_Coverage, 24397,
     /* 1945936 */     GIR_EraseRootFromParent_Done,
     /* 1945937 */   // Label 26118: @1945937
     /* 1945937 */   GIM_Try, /*On fail goto*//*Label 26119*/ GIMT_Encode4(1946023), // Rule ID 24400 //
     /* 1945942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1945945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1945950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1945953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1945956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1945959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945988 */     // MIs[0] policy
     /* 1945988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945998 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1946001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946022 */     // GIR_Coverage, 24400,
     /* 1946022 */     GIR_EraseRootFromParent_Done,
     /* 1946023 */   // Label 26119: @1946023
     /* 1946023 */   GIM_Try, /*On fail goto*//*Label 26120*/ GIMT_Encode4(1946109), // Rule ID 24401 //
     /* 1946028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1946031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1946036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1946039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1946042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1946045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1946048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1946051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1946070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946074 */     // MIs[0] policy
     /* 1946074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946084 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1946087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946108 */     // GIR_Coverage, 24401,
     /* 1946108 */     GIR_EraseRootFromParent_Done,
     /* 1946109 */   // Label 26120: @1946109
     /* 1946109 */   GIM_Try, /*On fail goto*//*Label 26121*/ GIMT_Encode4(1946195), // Rule ID 24404 //
     /* 1946114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1946117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1946122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1946125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1946128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1946131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1946134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1946137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1946156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946160 */     // MIs[0] policy
     /* 1946160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946170 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1946173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946194 */     // GIR_Coverage, 24404,
     /* 1946194 */     GIR_EraseRootFromParent_Done,
     /* 1946195 */   // Label 26121: @1946195
     /* 1946195 */   GIM_Try, /*On fail goto*//*Label 26122*/ GIMT_Encode4(1946281), // Rule ID 24405 //
     /* 1946200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1946203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1946208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1946211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1946214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1946217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1946220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1946223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1946242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946246 */     // MIs[0] policy
     /* 1946246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946256 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1946259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946280 */     // GIR_Coverage, 24405,
     /* 1946280 */     GIR_EraseRootFromParent_Done,
     /* 1946281 */   // Label 26122: @1946281
     /* 1946281 */   GIM_Try, /*On fail goto*//*Label 26123*/ GIMT_Encode4(1946367), // Rule ID 24408 //
     /* 1946286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1946289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1946294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1946297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1946300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1946303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1946306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1946328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946332 */     // MIs[0] policy
     /* 1946332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946342 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1946345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946366 */     // GIR_Coverage, 24408,
     /* 1946366 */     GIR_EraseRootFromParent_Done,
     /* 1946367 */   // Label 26123: @1946367
     /* 1946367 */   GIM_Try, /*On fail goto*//*Label 26124*/ GIMT_Encode4(1946453), // Rule ID 24409 //
     /* 1946372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1946375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1946380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1946383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1946386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1946389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1946392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1946414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946418 */     // MIs[0] policy
     /* 1946418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946428 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1946431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946452 */     // GIR_Coverage, 24409,
     /* 1946452 */     GIR_EraseRootFromParent_Done,
     /* 1946453 */   // Label 26124: @1946453
     /* 1946453 */   GIM_Try, /*On fail goto*//*Label 26125*/ GIMT_Encode4(1946539), // Rule ID 24412 //
     /* 1946458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1946461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1946466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1946469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1946472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1946475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1946478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1946500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946504 */     // MIs[0] policy
     /* 1946504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946514 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1946517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946538 */     // GIR_Coverage, 24412,
     /* 1946538 */     GIR_EraseRootFromParent_Done,
     /* 1946539 */   // Label 26125: @1946539
     /* 1946539 */   GIM_Try, /*On fail goto*//*Label 26126*/ GIMT_Encode4(1946625), // Rule ID 24413 //
     /* 1946544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1946547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1946552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1946555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1946558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1946561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1946564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1946586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946590 */     // MIs[0] policy
     /* 1946590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946600 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1946603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946624 */     // GIR_Coverage, 24413,
     /* 1946624 */     GIR_EraseRootFromParent_Done,
     /* 1946625 */   // Label 26126: @1946625
     /* 1946625 */   GIM_Try, /*On fail goto*//*Label 26127*/ GIMT_Encode4(1946711), // Rule ID 24416 //
     /* 1946630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1946633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1946638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1946641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1946644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1946647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1946650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1946653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1946672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946676 */     // MIs[0] policy
     /* 1946676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946686 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1946689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946710 */     // GIR_Coverage, 24416,
     /* 1946710 */     GIR_EraseRootFromParent_Done,
     /* 1946711 */   // Label 26127: @1946711
     /* 1946711 */   GIM_Try, /*On fail goto*//*Label 26128*/ GIMT_Encode4(1946797), // Rule ID 24417 //
     /* 1946716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1946719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1946724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1946727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1946730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1946733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1946736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1946739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1946758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946762 */     // MIs[0] policy
     /* 1946762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946772 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1946775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946796 */     // GIR_Coverage, 24417,
     /* 1946796 */     GIR_EraseRootFromParent_Done,
     /* 1946797 */   // Label 26128: @1946797
     /* 1946797 */   GIM_Try, /*On fail goto*//*Label 26129*/ GIMT_Encode4(1946883), // Rule ID 24420 //
     /* 1946802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1946805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1946810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1946813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1946816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1946819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946848 */     // MIs[0] policy
     /* 1946848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946858 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1946861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946882 */     // GIR_Coverage, 24420,
     /* 1946882 */     GIR_EraseRootFromParent_Done,
     /* 1946883 */   // Label 26129: @1946883
     /* 1946883 */   GIM_Try, /*On fail goto*//*Label 26130*/ GIMT_Encode4(1946969), // Rule ID 24421 //
     /* 1946888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1946891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1946896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1946899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1946902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1946905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946934 */     // MIs[0] policy
     /* 1946934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946944 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1946947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946968 */     // GIR_Coverage, 24421,
     /* 1946968 */     GIR_EraseRootFromParent_Done,
     /* 1946969 */   // Label 26130: @1946969
     /* 1946969 */   GIM_Try, /*On fail goto*//*Label 26131*/ GIMT_Encode4(1947055), // Rule ID 24424 //
     /* 1946974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1946977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1946982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1946985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1946988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1946991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1947004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1947016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947020 */     // MIs[0] policy
     /* 1947020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947030 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1947033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947054 */     // GIR_Coverage, 24424,
     /* 1947054 */     GIR_EraseRootFromParent_Done,
     /* 1947055 */   // Label 26131: @1947055
     /* 1947055 */   GIM_Try, /*On fail goto*//*Label 26132*/ GIMT_Encode4(1947141), // Rule ID 24425 //
     /* 1947060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1947063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1947068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1947071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1947074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1947077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1947080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1947090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1947102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947106 */     // MIs[0] policy
     /* 1947106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947116 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1947119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947140 */     // GIR_Coverage, 24425,
     /* 1947140 */     GIR_EraseRootFromParent_Done,
     /* 1947141 */   // Label 26132: @1947141
     /* 1947141 */   GIM_Try, /*On fail goto*//*Label 26133*/ GIMT_Encode4(1947227), // Rule ID 24428 //
     /* 1947146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1947149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1947154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1947157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1947160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1947163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1947166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1947176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1947188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947192 */     // MIs[0] policy
     /* 1947192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947202 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1947205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947226 */     // GIR_Coverage, 24428,
     /* 1947226 */     GIR_EraseRootFromParent_Done,
     /* 1947227 */   // Label 26133: @1947227
     /* 1947227 */   GIM_Try, /*On fail goto*//*Label 26134*/ GIMT_Encode4(1947313), // Rule ID 24429 //
     /* 1947232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1947235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1947240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1947243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1947246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1947249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1947252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1947262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1947274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947278 */     // MIs[0] policy
     /* 1947278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947288 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1947291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947312 */     // GIR_Coverage, 24429,
     /* 1947312 */     GIR_EraseRootFromParent_Done,
     /* 1947313 */   // Label 26134: @1947313
     /* 1947313 */   GIM_Try, /*On fail goto*//*Label 26135*/ GIMT_Encode4(1947399), // Rule ID 24432 //
     /* 1947318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1947321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1947326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1947329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1947332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1947335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1947338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1947360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947364 */     // MIs[0] policy
     /* 1947364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947374 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1947377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947398 */     // GIR_Coverage, 24432,
     /* 1947398 */     GIR_EraseRootFromParent_Done,
     /* 1947399 */   // Label 26135: @1947399
     /* 1947399 */   GIM_Try, /*On fail goto*//*Label 26136*/ GIMT_Encode4(1947485), // Rule ID 24433 //
     /* 1947404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1947407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1947412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1947415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1947418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1947421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1947424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1947446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947450 */     // MIs[0] policy
     /* 1947450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947460 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1947463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947484 */     // GIR_Coverage, 24433,
     /* 1947484 */     GIR_EraseRootFromParent_Done,
     /* 1947485 */   // Label 26136: @1947485
     /* 1947485 */   GIM_Try, /*On fail goto*//*Label 26137*/ GIMT_Encode4(1947571), // Rule ID 24436 //
     /* 1947490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1947493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1947498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1947501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1947504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1947507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1947510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1947532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947536 */     // MIs[0] policy
     /* 1947536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947546 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1947549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947570 */     // GIR_Coverage, 24436,
     /* 1947570 */     GIR_EraseRootFromParent_Done,
     /* 1947571 */   // Label 26137: @1947571
     /* 1947571 */   GIM_Try, /*On fail goto*//*Label 26138*/ GIMT_Encode4(1947657), // Rule ID 24437 //
     /* 1947576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1947579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1947584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1947587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1947590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1947593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1947596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1947618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947622 */     // MIs[0] policy
     /* 1947622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947632 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1947635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947656 */     // GIR_Coverage, 24437,
     /* 1947656 */     GIR_EraseRootFromParent_Done,
     /* 1947657 */   // Label 26138: @1947657
     /* 1947657 */   GIM_Try, /*On fail goto*//*Label 26139*/ GIMT_Encode4(1947743), // Rule ID 24440 //
     /* 1947662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1947665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1947670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1947673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1947676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1947679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1947682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1947704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947708 */     // MIs[0] policy
     /* 1947708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947718 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1947721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947742 */     // GIR_Coverage, 24440,
     /* 1947742 */     GIR_EraseRootFromParent_Done,
     /* 1947743 */   // Label 26139: @1947743
     /* 1947743 */   GIM_Try, /*On fail goto*//*Label 26140*/ GIMT_Encode4(1947829), // Rule ID 24441 //
     /* 1947748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1947751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1947756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1947759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1947762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1947765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1947768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1947790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947794 */     // MIs[0] policy
     /* 1947794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947804 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1947807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947828 */     // GIR_Coverage, 24441,
     /* 1947828 */     GIR_EraseRootFromParent_Done,
     /* 1947829 */   // Label 26140: @1947829
     /* 1947829 */   GIM_Try, /*On fail goto*//*Label 26141*/ GIMT_Encode4(1947915), // Rule ID 24444 //
     /* 1947834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1947837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1947842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1947845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1947848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1947851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1947854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1947876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947880 */     // MIs[0] policy
     /* 1947880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947890 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1947893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947914 */     // GIR_Coverage, 24444,
     /* 1947914 */     GIR_EraseRootFromParent_Done,
     /* 1947915 */   // Label 26141: @1947915
     /* 1947915 */   GIM_Try, /*On fail goto*//*Label 26142*/ GIMT_Encode4(1948001), // Rule ID 24445 //
     /* 1947920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1947923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1947928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1947931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1947934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1947937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1947940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1947962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947966 */     // MIs[0] policy
     /* 1947966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947976 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1947979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948000 */     // GIR_Coverage, 24445,
     /* 1948000 */     GIR_EraseRootFromParent_Done,
     /* 1948001 */   // Label 26142: @1948001
     /* 1948001 */   GIM_Try, /*On fail goto*//*Label 26143*/ GIMT_Encode4(1948087), // Rule ID 24448 //
     /* 1948006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1948009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1948014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1948017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1948020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1948023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1948026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1948029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1948048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948052 */     // MIs[0] policy
     /* 1948052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948062 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1948065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948086 */     // GIR_Coverage, 24448,
     /* 1948086 */     GIR_EraseRootFromParent_Done,
     /* 1948087 */   // Label 26143: @1948087
     /* 1948087 */   GIM_Try, /*On fail goto*//*Label 26144*/ GIMT_Encode4(1948173), // Rule ID 24449 //
     /* 1948092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1948095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1948100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1948103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1948106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1948109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1948112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1948115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1948134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948138 */     // MIs[0] policy
     /* 1948138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948148 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1948151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948172 */     // GIR_Coverage, 24449,
     /* 1948172 */     GIR_EraseRootFromParent_Done,
     /* 1948173 */   // Label 26144: @1948173
     /* 1948173 */   GIM_Try, /*On fail goto*//*Label 26145*/ GIMT_Encode4(1948259), // Rule ID 24452 //
     /* 1948178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1948181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1948186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1948189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1948192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1948195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1948198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1948201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1948220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948224 */     // MIs[0] policy
     /* 1948224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948234 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1948237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1948255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948258 */     // GIR_Coverage, 24452,
     /* 1948258 */     GIR_EraseRootFromParent_Done,
     /* 1948259 */   // Label 26145: @1948259
     /* 1948259 */   GIM_Try, /*On fail goto*//*Label 26146*/ GIMT_Encode4(1948345), // Rule ID 24453 //
     /* 1948264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1948267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1948272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1948275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1948278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1948281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1948284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1948287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1948306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948310 */     // MIs[0] policy
     /* 1948310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948320 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1948323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1948341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948344 */     // GIR_Coverage, 24453,
     /* 1948344 */     GIR_EraseRootFromParent_Done,
     /* 1948345 */   // Label 26146: @1948345
     /* 1948345 */   GIM_Try, /*On fail goto*//*Label 26147*/ GIMT_Encode4(1948431), // Rule ID 24456 //
     /* 1948350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1948353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1948358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1948361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1948364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1948367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1948370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1948392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948396 */     // MIs[0] policy
     /* 1948396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948406 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1948409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948430 */     // GIR_Coverage, 24456,
     /* 1948430 */     GIR_EraseRootFromParent_Done,
     /* 1948431 */   // Label 26147: @1948431
     /* 1948431 */   GIM_Try, /*On fail goto*//*Label 26148*/ GIMT_Encode4(1948517), // Rule ID 24457 //
     /* 1948436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1948439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1948444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1948447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1948450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1948453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1948456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1948478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948482 */     // MIs[0] policy
     /* 1948482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948492 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1948495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948516 */     // GIR_Coverage, 24457,
     /* 1948516 */     GIR_EraseRootFromParent_Done,
     /* 1948517 */   // Label 26148: @1948517
     /* 1948517 */   GIM_Try, /*On fail goto*//*Label 26149*/ GIMT_Encode4(1948603), // Rule ID 24460 //
     /* 1948522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1948525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1948530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1948533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1948536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1948539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1948542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1948564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948568 */     // MIs[0] policy
     /* 1948568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948578 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1948581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948602 */     // GIR_Coverage, 24460,
     /* 1948602 */     GIR_EraseRootFromParent_Done,
     /* 1948603 */   // Label 26149: @1948603
     /* 1948603 */   GIM_Try, /*On fail goto*//*Label 26150*/ GIMT_Encode4(1948689), // Rule ID 24461 //
     /* 1948608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1948611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1948616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1948619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1948622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1948625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1948628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1948650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948654 */     // MIs[0] policy
     /* 1948654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948664 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1948667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948688 */     // GIR_Coverage, 24461,
     /* 1948688 */     GIR_EraseRootFromParent_Done,
     /* 1948689 */   // Label 26150: @1948689
     /* 1948689 */   GIM_Try, /*On fail goto*//*Label 26151*/ GIMT_Encode4(1948775), // Rule ID 24464 //
     /* 1948694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1948697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1948702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1948705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1948708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1948711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1948714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1948736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948740 */     // MIs[0] policy
     /* 1948740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948750 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1948753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948774 */     // GIR_Coverage, 24464,
     /* 1948774 */     GIR_EraseRootFromParent_Done,
     /* 1948775 */   // Label 26151: @1948775
     /* 1948775 */   GIM_Try, /*On fail goto*//*Label 26152*/ GIMT_Encode4(1948861), // Rule ID 24465 //
     /* 1948780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1948783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1948788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1948791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1948794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1948797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1948800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1948822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948826 */     // MIs[0] policy
     /* 1948826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948836 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1948839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948860 */     // GIR_Coverage, 24465,
     /* 1948860 */     GIR_EraseRootFromParent_Done,
     /* 1948861 */   // Label 26152: @1948861
     /* 1948861 */   GIM_Try, /*On fail goto*//*Label 26153*/ GIMT_Encode4(1948947), // Rule ID 24468 //
     /* 1948866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1948869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1948874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1948877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1948880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1948883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1948886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1948908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948912 */     // MIs[0] policy
     /* 1948912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948922 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1948925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948946 */     // GIR_Coverage, 24468,
     /* 1948946 */     GIR_EraseRootFromParent_Done,
     /* 1948947 */   // Label 26153: @1948947
     /* 1948947 */   GIM_Try, /*On fail goto*//*Label 26154*/ GIMT_Encode4(1949033), // Rule ID 24469 //
     /* 1948952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1948955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1948960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1948963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1948966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1948969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1948972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1948994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948998 */     // MIs[0] policy
     /* 1948998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949008 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1949011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949032 */     // GIR_Coverage, 24469,
     /* 1949032 */     GIR_EraseRootFromParent_Done,
     /* 1949033 */   // Label 26154: @1949033
     /* 1949033 */   GIM_Try, /*On fail goto*//*Label 26155*/ GIMT_Encode4(1949119), // Rule ID 24472 //
     /* 1949038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1949041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1949046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1949049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1949052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1949055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1949080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949084 */     // MIs[0] policy
     /* 1949084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949094 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1949097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949118 */     // GIR_Coverage, 24472,
     /* 1949118 */     GIR_EraseRootFromParent_Done,
     /* 1949119 */   // Label 26155: @1949119
     /* 1949119 */   GIM_Try, /*On fail goto*//*Label 26156*/ GIMT_Encode4(1949205), // Rule ID 24473 //
     /* 1949124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1949127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1949132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1949135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1949138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1949141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1949166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949170 */     // MIs[0] policy
     /* 1949170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949180 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1949183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949204 */     // GIR_Coverage, 24473,
     /* 1949204 */     GIR_EraseRootFromParent_Done,
     /* 1949205 */   // Label 26156: @1949205
     /* 1949205 */   GIM_Try, /*On fail goto*//*Label 26157*/ GIMT_Encode4(1949291), // Rule ID 24476 //
     /* 1949210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1949213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1949218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1949221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1949224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1949227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1949252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949256 */     // MIs[0] policy
     /* 1949256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949266 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1949269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949290 */     // GIR_Coverage, 24476,
     /* 1949290 */     GIR_EraseRootFromParent_Done,
     /* 1949291 */   // Label 26157: @1949291
     /* 1949291 */   GIM_Try, /*On fail goto*//*Label 26158*/ GIMT_Encode4(1949377), // Rule ID 24477 //
     /* 1949296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1949299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1949304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1949307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1949310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1949313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1949338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949342 */     // MIs[0] policy
     /* 1949342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949352 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1949355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949376 */     // GIR_Coverage, 24477,
     /* 1949376 */     GIR_EraseRootFromParent_Done,
     /* 1949377 */   // Label 26158: @1949377
     /* 1949377 */   GIM_Try, /*On fail goto*//*Label 26159*/ GIMT_Encode4(1949463), // Rule ID 24480 //
     /* 1949382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1949385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1949390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1949393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1949396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1949399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1949424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949428 */     // MIs[0] policy
     /* 1949428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949438 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1949441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949462 */     // GIR_Coverage, 24480,
     /* 1949462 */     GIR_EraseRootFromParent_Done,
     /* 1949463 */   // Label 26159: @1949463
     /* 1949463 */   GIM_Try, /*On fail goto*//*Label 26160*/ GIMT_Encode4(1949549), // Rule ID 24481 //
     /* 1949468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1949471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1949476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1949479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1949482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1949485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1949510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949514 */     // MIs[0] policy
     /* 1949514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949524 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1949527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949548 */     // GIR_Coverage, 24481,
     /* 1949548 */     GIR_EraseRootFromParent_Done,
     /* 1949549 */   // Label 26160: @1949549
     /* 1949549 */   GIM_Try, /*On fail goto*//*Label 26161*/ GIMT_Encode4(1949635), // Rule ID 24484 //
     /* 1949554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1949557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1949562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1949565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1949568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1949571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1949596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949600 */     // MIs[0] policy
     /* 1949600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949610 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1949613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949634 */     // GIR_Coverage, 24484,
     /* 1949634 */     GIR_EraseRootFromParent_Done,
     /* 1949635 */   // Label 26161: @1949635
     /* 1949635 */   GIM_Try, /*On fail goto*//*Label 26162*/ GIMT_Encode4(1949721), // Rule ID 24485 //
     /* 1949640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1949643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1949648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1949651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1949654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1949657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1949682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949686 */     // MIs[0] policy
     /* 1949686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949696 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1949699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949720 */     // GIR_Coverage, 24485,
     /* 1949720 */     GIR_EraseRootFromParent_Done,
     /* 1949721 */   // Label 26162: @1949721
     /* 1949721 */   GIM_Try, /*On fail goto*//*Label 26163*/ GIMT_Encode4(1949807), // Rule ID 24488 //
     /* 1949726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1949729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1949734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1949737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1949740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1949743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1949768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949772 */     // MIs[0] policy
     /* 1949772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949782 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1949785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949806 */     // GIR_Coverage, 24488,
     /* 1949806 */     GIR_EraseRootFromParent_Done,
     /* 1949807 */   // Label 26163: @1949807
     /* 1949807 */   GIM_Try, /*On fail goto*//*Label 26164*/ GIMT_Encode4(1949893), // Rule ID 24489 //
     /* 1949812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1949815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1949820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1949823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1949826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1949829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1949854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949858 */     // MIs[0] policy
     /* 1949858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949868 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1949871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949892 */     // GIR_Coverage, 24489,
     /* 1949892 */     GIR_EraseRootFromParent_Done,
     /* 1949893 */   // Label 26164: @1949893
     /* 1949893 */   GIM_Try, /*On fail goto*//*Label 26165*/ GIMT_Encode4(1949979), // Rule ID 24492 //
     /* 1949898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1949909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1949912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1949915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1949918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1949921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949944 */     // MIs[0] policy
     /* 1949944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949954 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1949957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949978 */     // GIR_Coverage, 24492,
     /* 1949978 */     GIR_EraseRootFromParent_Done,
     /* 1949979 */   // Label 26165: @1949979
     /* 1949979 */   GIM_Try, /*On fail goto*//*Label 26166*/ GIMT_Encode4(1950065), // Rule ID 24493 //
     /* 1949984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1949995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1949998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1950001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1950004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950030 */     // MIs[0] policy
     /* 1950030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950040 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1950043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950064 */     // GIR_Coverage, 24493,
     /* 1950064 */     GIR_EraseRootFromParent_Done,
     /* 1950065 */   // Label 26166: @1950065
     /* 1950065 */   GIM_Try, /*On fail goto*//*Label 26167*/ GIMT_Encode4(1950151), // Rule ID 24496 //
     /* 1950070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1950081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1950084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1950087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1950090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950116 */     // MIs[0] policy
     /* 1950116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950126 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1950129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950150 */     // GIR_Coverage, 24496,
     /* 1950150 */     GIR_EraseRootFromParent_Done,
     /* 1950151 */   // Label 26167: @1950151
     /* 1950151 */   GIM_Try, /*On fail goto*//*Label 26168*/ GIMT_Encode4(1950237), // Rule ID 24497 //
     /* 1950156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1950167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1950170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1950173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1950176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950202 */     // MIs[0] policy
     /* 1950202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950212 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1950215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950236 */     // GIR_Coverage, 24497,
     /* 1950236 */     GIR_EraseRootFromParent_Done,
     /* 1950237 */   // Label 26168: @1950237
     /* 1950237 */   GIM_Try, /*On fail goto*//*Label 26169*/ GIMT_Encode4(1950323), // Rule ID 24500 //
     /* 1950242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1950253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1950256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1950259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1950262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950288 */     // MIs[0] policy
     /* 1950288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950298 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1950301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950322 */     // GIR_Coverage, 24500,
     /* 1950322 */     GIR_EraseRootFromParent_Done,
     /* 1950323 */   // Label 26169: @1950323
     /* 1950323 */   GIM_Try, /*On fail goto*//*Label 26170*/ GIMT_Encode4(1950409), // Rule ID 24501 //
     /* 1950328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1950339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1950342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1950345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1950348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950374 */     // MIs[0] policy
     /* 1950374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950384 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1950387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950408 */     // GIR_Coverage, 24501,
     /* 1950408 */     GIR_EraseRootFromParent_Done,
     /* 1950409 */   // Label 26170: @1950409
     /* 1950409 */   GIM_Try, /*On fail goto*//*Label 26171*/ GIMT_Encode4(1950495), // Rule ID 24504 //
     /* 1950414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1950425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1950428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1950431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1950434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950460 */     // MIs[0] policy
     /* 1950460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950470 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1950473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950494 */     // GIR_Coverage, 24504,
     /* 1950494 */     GIR_EraseRootFromParent_Done,
     /* 1950495 */   // Label 26171: @1950495
     /* 1950495 */   GIM_Try, /*On fail goto*//*Label 26172*/ GIMT_Encode4(1950581), // Rule ID 24505 //
     /* 1950500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1950511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1950514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1950517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1950520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950546 */     // MIs[0] policy
     /* 1950546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950556 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1950559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950580 */     // GIR_Coverage, 24505,
     /* 1950580 */     GIR_EraseRootFromParent_Done,
     /* 1950581 */   // Label 26172: @1950581
     /* 1950581 */   GIM_Try, /*On fail goto*//*Label 26173*/ GIMT_Encode4(1950667), // Rule ID 24508 //
     /* 1950586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1950597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1950600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1950603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1950606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950632 */     // MIs[0] policy
     /* 1950632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950642 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1950645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950666 */     // GIR_Coverage, 24508,
     /* 1950666 */     GIR_EraseRootFromParent_Done,
     /* 1950667 */   // Label 26173: @1950667
     /* 1950667 */   GIM_Try, /*On fail goto*//*Label 26174*/ GIMT_Encode4(1950753), // Rule ID 24509 //
     /* 1950672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1950683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1950686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1950689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1950692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950718 */     // MIs[0] policy
     /* 1950718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950728 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1950731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950752 */     // GIR_Coverage, 24509,
     /* 1950752 */     GIR_EraseRootFromParent_Done,
     /* 1950753 */   // Label 26174: @1950753
     /* 1950753 */   GIM_Try, /*On fail goto*//*Label 26175*/ GIMT_Encode4(1950839), // Rule ID 24512 //
     /* 1950758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1950769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1950772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1950775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1950778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950804 */     // MIs[0] policy
     /* 1950804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1950817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950838 */     // GIR_Coverage, 24512,
     /* 1950838 */     GIR_EraseRootFromParent_Done,
     /* 1950839 */   // Label 26175: @1950839
     /* 1950839 */   GIM_Try, /*On fail goto*//*Label 26176*/ GIMT_Encode4(1950925), // Rule ID 24513 //
     /* 1950844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1950855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1950858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1950861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1950864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950890 */     // MIs[0] policy
     /* 1950890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950900 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1950903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950924 */     // GIR_Coverage, 24513,
     /* 1950924 */     GIR_EraseRootFromParent_Done,
     /* 1950925 */   // Label 26176: @1950925
     /* 1950925 */   GIM_Try, /*On fail goto*//*Label 26177*/ GIMT_Encode4(1951011), // Rule ID 24516 //
     /* 1950930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1950941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1950944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1950947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1950950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950976 */     // MIs[0] policy
     /* 1950976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950986 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1950989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951010 */     // GIR_Coverage, 24516,
     /* 1951010 */     GIR_EraseRootFromParent_Done,
     /* 1951011 */   // Label 26177: @1951011
     /* 1951011 */   GIM_Try, /*On fail goto*//*Label 26178*/ GIMT_Encode4(1951097), // Rule ID 24517 //
     /* 1951016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1951027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1951030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1951033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1951036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1951039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951062 */     // MIs[0] policy
     /* 1951062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951072 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1951075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951096 */     // GIR_Coverage, 24517,
     /* 1951096 */     GIR_EraseRootFromParent_Done,
     /* 1951097 */   // Label 26178: @1951097
     /* 1951097 */   GIM_Try, /*On fail goto*//*Label 26179*/ GIMT_Encode4(1951183), // Rule ID 24520 //
     /* 1951102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1951113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1951116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1951119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1951122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951148 */     // MIs[0] policy
     /* 1951148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1951161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951182 */     // GIR_Coverage, 24520,
     /* 1951182 */     GIR_EraseRootFromParent_Done,
     /* 1951183 */   // Label 26179: @1951183
     /* 1951183 */   GIM_Try, /*On fail goto*//*Label 26180*/ GIMT_Encode4(1951269), // Rule ID 24521 //
     /* 1951188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1951199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1951202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1951205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1951208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951234 */     // MIs[0] policy
     /* 1951234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951244 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1951247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951268 */     // GIR_Coverage, 24521,
     /* 1951268 */     GIR_EraseRootFromParent_Done,
     /* 1951269 */   // Label 26180: @1951269
     /* 1951269 */   GIM_Try, /*On fail goto*//*Label 26181*/ GIMT_Encode4(1951355), // Rule ID 24524 //
     /* 1951274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1951285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1951288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1951291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1951294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951320 */     // MIs[0] policy
     /* 1951320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951330 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1951333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951354 */     // GIR_Coverage, 24524,
     /* 1951354 */     GIR_EraseRootFromParent_Done,
     /* 1951355 */   // Label 26181: @1951355
     /* 1951355 */   GIM_Try, /*On fail goto*//*Label 26182*/ GIMT_Encode4(1951441), // Rule ID 24525 //
     /* 1951360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1951371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1951374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1951377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1951380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951406 */     // MIs[0] policy
     /* 1951406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951416 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1951419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951440 */     // GIR_Coverage, 24525,
     /* 1951440 */     GIR_EraseRootFromParent_Done,
     /* 1951441 */   // Label 26182: @1951441
     /* 1951441 */   GIM_Try, /*On fail goto*//*Label 26183*/ GIMT_Encode4(1951527), // Rule ID 24528 //
     /* 1951446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1951449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1951457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1951460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1951463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1951466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951492 */     // MIs[0] policy
     /* 1951492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1951505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951526 */     // GIR_Coverage, 24528,
     /* 1951526 */     GIR_EraseRootFromParent_Done,
     /* 1951527 */   // Label 26183: @1951527
     /* 1951527 */   GIM_Try, /*On fail goto*//*Label 26184*/ GIMT_Encode4(1951613), // Rule ID 24529 //
     /* 1951532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1951535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1951543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1951546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1951549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1951552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951578 */     // MIs[0] policy
     /* 1951578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951588 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1951591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951612 */     // GIR_Coverage, 24529,
     /* 1951612 */     GIR_EraseRootFromParent_Done,
     /* 1951613 */   // Label 26184: @1951613
     /* 1951613 */   GIM_Try, /*On fail goto*//*Label 26185*/ GIMT_Encode4(1951699), // Rule ID 24532 //
     /* 1951618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1951629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1951632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1951635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1951638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1951641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951664 */     // MIs[0] policy
     /* 1951664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951674 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1951677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951698 */     // GIR_Coverage, 24532,
     /* 1951698 */     GIR_EraseRootFromParent_Done,
     /* 1951699 */   // Label 26185: @1951699
     /* 1951699 */   GIM_Try, /*On fail goto*//*Label 26186*/ GIMT_Encode4(1951785), // Rule ID 24533 //
     /* 1951704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1951715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1951718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1951721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1951724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1951727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951750 */     // MIs[0] policy
     /* 1951750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951760 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1951763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951784 */     // GIR_Coverage, 24533,
     /* 1951784 */     GIR_EraseRootFromParent_Done,
     /* 1951785 */   // Label 26186: @1951785
     /* 1951785 */   GIM_Try, /*On fail goto*//*Label 26187*/ GIMT_Encode4(1951871), // Rule ID 24536 //
     /* 1951790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1951801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1951804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1951807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1951810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1951813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951836 */     // MIs[0] policy
     /* 1951836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1951849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951870 */     // GIR_Coverage, 24536,
     /* 1951870 */     GIR_EraseRootFromParent_Done,
     /* 1951871 */   // Label 26187: @1951871
     /* 1951871 */   GIM_Try, /*On fail goto*//*Label 26188*/ GIMT_Encode4(1951957), // Rule ID 24537 //
     /* 1951876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1951887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1951890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1951893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1951896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1951899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951922 */     // MIs[0] policy
     /* 1951922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951932 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1951935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951956 */     // GIR_Coverage, 24537,
     /* 1951956 */     GIR_EraseRootFromParent_Done,
     /* 1951957 */   // Label 26188: @1951957
     /* 1951957 */   GIM_Try, /*On fail goto*//*Label 26189*/ GIMT_Encode4(1952043), // Rule ID 24540 //
     /* 1951962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1951973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1951976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1951979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1951982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1951985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1951992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952008 */     // MIs[0] policy
     /* 1952008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952018 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1952021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952042 */     // GIR_Coverage, 24540,
     /* 1952042 */     GIR_EraseRootFromParent_Done,
     /* 1952043 */   // Label 26189: @1952043
     /* 1952043 */   GIM_Try, /*On fail goto*//*Label 26190*/ GIMT_Encode4(1952129), // Rule ID 24541 //
     /* 1952048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1952056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1952059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1952062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1952065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1952068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1952071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952094 */     // MIs[0] policy
     /* 1952094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952104 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1952107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952128 */     // GIR_Coverage, 24541,
     /* 1952128 */     GIR_EraseRootFromParent_Done,
     /* 1952129 */   // Label 26190: @1952129
     /* 1952129 */   GIM_Try, /*On fail goto*//*Label 26191*/ GIMT_Encode4(1952215), // Rule ID 24544 //
     /* 1952134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1952142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1952145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1952148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1952151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1952154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952180 */     // MIs[0] policy
     /* 1952180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1952193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952214 */     // GIR_Coverage, 24544,
     /* 1952214 */     GIR_EraseRootFromParent_Done,
     /* 1952215 */   // Label 26191: @1952215
     /* 1952215 */   GIM_Try, /*On fail goto*//*Label 26192*/ GIMT_Encode4(1952301), // Rule ID 24545 //
     /* 1952220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1952228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1952231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1952234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1952237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1952240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952266 */     // MIs[0] policy
     /* 1952266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952276 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1952279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952300 */     // GIR_Coverage, 24545,
     /* 1952300 */     GIR_EraseRootFromParent_Done,
     /* 1952301 */   // Label 26192: @1952301
     /* 1952301 */   GIM_Try, /*On fail goto*//*Label 26193*/ GIMT_Encode4(1952387), // Rule ID 24548 //
     /* 1952306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1952314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1952317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1952320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1952323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1952326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952352 */     // MIs[0] policy
     /* 1952352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952362 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1952365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952386 */     // GIR_Coverage, 24548,
     /* 1952386 */     GIR_EraseRootFromParent_Done,
     /* 1952387 */   // Label 26193: @1952387
     /* 1952387 */   GIM_Try, /*On fail goto*//*Label 26194*/ GIMT_Encode4(1952473), // Rule ID 24549 //
     /* 1952392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1952400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1952403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1952406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1952409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1952412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952438 */     // MIs[0] policy
     /* 1952438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952448 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1952451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952472 */     // GIR_Coverage, 24549,
     /* 1952472 */     GIR_EraseRootFromParent_Done,
     /* 1952473 */   // Label 26194: @1952473
     /* 1952473 */   GIM_Try, /*On fail goto*//*Label 26195*/ GIMT_Encode4(1952559), // Rule ID 24552 //
     /* 1952478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1952486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1952489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1952492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1952495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1952498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952524 */     // MIs[0] policy
     /* 1952524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952534 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1952537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952558 */     // GIR_Coverage, 24552,
     /* 1952558 */     GIR_EraseRootFromParent_Done,
     /* 1952559 */   // Label 26195: @1952559
     /* 1952559 */   GIM_Try, /*On fail goto*//*Label 26196*/ GIMT_Encode4(1952645), // Rule ID 24553 //
     /* 1952564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1952572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1952575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1952578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1952581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1952584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952610 */     // MIs[0] policy
     /* 1952610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952620 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1952623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952644 */     // GIR_Coverage, 24553,
     /* 1952644 */     GIR_EraseRootFromParent_Done,
     /* 1952645 */   // Label 26196: @1952645
     /* 1952645 */   GIM_Try, /*On fail goto*//*Label 26197*/ GIMT_Encode4(1952731), // Rule ID 24556 //
     /* 1952650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1952658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1952661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1952664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1952667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1952670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952696 */     // MIs[0] policy
     /* 1952696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1952709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952730 */     // GIR_Coverage, 24556,
     /* 1952730 */     GIR_EraseRootFromParent_Done,
     /* 1952731 */   // Label 26197: @1952731
     /* 1952731 */   GIM_Try, /*On fail goto*//*Label 26198*/ GIMT_Encode4(1952817), // Rule ID 24557 //
     /* 1952736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1952744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1952747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1952750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1952753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1952756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952782 */     // MIs[0] policy
     /* 1952782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952792 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1952795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952816 */     // GIR_Coverage, 24557,
     /* 1952816 */     GIR_EraseRootFromParent_Done,
     /* 1952817 */   // Label 26198: @1952817
     /* 1952817 */   GIM_Try, /*On fail goto*//*Label 26199*/ GIMT_Encode4(1952903), // Rule ID 24560 //
     /* 1952822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1952830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1952833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1952836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1952839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1952842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952868 */     // MIs[0] policy
     /* 1952868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1952881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952902 */     // GIR_Coverage, 24560,
     /* 1952902 */     GIR_EraseRootFromParent_Done,
     /* 1952903 */   // Label 26199: @1952903
     /* 1952903 */   GIM_Try, /*On fail goto*//*Label 26200*/ GIMT_Encode4(1952989), // Rule ID 24561 //
     /* 1952908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1952916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1952919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1952922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1952925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1952928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952954 */     // MIs[0] policy
     /* 1952954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952964 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1952967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952988 */     // GIR_Coverage, 24561,
     /* 1952988 */     GIR_EraseRootFromParent_Done,
     /* 1952989 */   // Label 26200: @1952989
     /* 1952989 */   GIM_Try, /*On fail goto*//*Label 26201*/ GIMT_Encode4(1953075), // Rule ID 24564 //
     /* 1952994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1953002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1953005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1953008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1953011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1953014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953040 */     // MIs[0] policy
     /* 1953040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953050 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1953053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953074 */     // GIR_Coverage, 24564,
     /* 1953074 */     GIR_EraseRootFromParent_Done,
     /* 1953075 */   // Label 26201: @1953075
     /* 1953075 */   GIM_Try, /*On fail goto*//*Label 26202*/ GIMT_Encode4(1953161), // Rule ID 24565 //
     /* 1953080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1953088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1953091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1953094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1953097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1953100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953126 */     // MIs[0] policy
     /* 1953126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953136 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1953139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953160 */     // GIR_Coverage, 24565,
     /* 1953160 */     GIR_EraseRootFromParent_Done,
     /* 1953161 */   // Label 26202: @1953161
     /* 1953161 */   GIM_Try, /*On fail goto*//*Label 26203*/ GIMT_Encode4(1953247), // Rule ID 24568 //
     /* 1953166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1953174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1953177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1953180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1953183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1953186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953212 */     // MIs[0] policy
     /* 1953212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953222 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1953225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953246 */     // GIR_Coverage, 24568,
     /* 1953246 */     GIR_EraseRootFromParent_Done,
     /* 1953247 */   // Label 26203: @1953247
     /* 1953247 */   GIM_Try, /*On fail goto*//*Label 26204*/ GIMT_Encode4(1953333), // Rule ID 24569 //
     /* 1953252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1953260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1953263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1953266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1953269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1953272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953298 */     // MIs[0] policy
     /* 1953298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953308 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1953311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953332 */     // GIR_Coverage, 24569,
     /* 1953332 */     GIR_EraseRootFromParent_Done,
     /* 1953333 */   // Label 26204: @1953333
     /* 1953333 */   GIM_Try, /*On fail goto*//*Label 26205*/ GIMT_Encode4(1953419), // Rule ID 24572 //
     /* 1953338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1953346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1953349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1953352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1953355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1953358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953384 */     // MIs[0] policy
     /* 1953384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953394 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1953397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953418 */     // GIR_Coverage, 24572,
     /* 1953418 */     GIR_EraseRootFromParent_Done,
     /* 1953419 */   // Label 26205: @1953419
     /* 1953419 */   GIM_Try, /*On fail goto*//*Label 26206*/ GIMT_Encode4(1953505), // Rule ID 24573 //
     /* 1953424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1953432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1953435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1953438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1953441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1953444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953470 */     // MIs[0] policy
     /* 1953470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953480 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1953483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953504 */     // GIR_Coverage, 24573,
     /* 1953504 */     GIR_EraseRootFromParent_Done,
     /* 1953505 */   // Label 26206: @1953505
     /* 1953505 */   GIM_Try, /*On fail goto*//*Label 26207*/ GIMT_Encode4(1953591), // Rule ID 24576 //
     /* 1953510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1953518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1953521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1953524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1953527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1953530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953556 */     // MIs[0] policy
     /* 1953556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953566 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1953569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953590 */     // GIR_Coverage, 24576,
     /* 1953590 */     GIR_EraseRootFromParent_Done,
     /* 1953591 */   // Label 26207: @1953591
     /* 1953591 */   GIM_Try, /*On fail goto*//*Label 26208*/ GIMT_Encode4(1953677), // Rule ID 24577 //
     /* 1953596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1953604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1953607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1953610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1953613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1953616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953642 */     // MIs[0] policy
     /* 1953642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953652 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1953655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953676 */     // GIR_Coverage, 24577,
     /* 1953676 */     GIR_EraseRootFromParent_Done,
     /* 1953677 */   // Label 26208: @1953677
     /* 1953677 */   GIM_Try, /*On fail goto*//*Label 26209*/ GIMT_Encode4(1953763), // Rule ID 24580 //
     /* 1953682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1953693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1953696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1953699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1953705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953728 */     // MIs[0] policy
     /* 1953728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953738 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1953741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953762 */     // GIR_Coverage, 24580,
     /* 1953762 */     GIR_EraseRootFromParent_Done,
     /* 1953763 */   // Label 26209: @1953763
     /* 1953763 */   GIM_Try, /*On fail goto*//*Label 26210*/ GIMT_Encode4(1953849), // Rule ID 24581 //
     /* 1953768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1953779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1953782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1953785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1953791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953814 */     // MIs[0] policy
     /* 1953814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953824 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1953827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953848 */     // GIR_Coverage, 24581,
     /* 1953848 */     GIR_EraseRootFromParent_Done,
     /* 1953849 */   // Label 26210: @1953849
     /* 1953849 */   GIM_Try, /*On fail goto*//*Label 26211*/ GIMT_Encode4(1953935), // Rule ID 24584 //
     /* 1953854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1953865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1953868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1953871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953900 */     // MIs[0] policy
     /* 1953900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953910 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1953913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953934 */     // GIR_Coverage, 24584,
     /* 1953934 */     GIR_EraseRootFromParent_Done,
     /* 1953935 */   // Label 26211: @1953935
     /* 1953935 */   GIM_Try, /*On fail goto*//*Label 26212*/ GIMT_Encode4(1954021), // Rule ID 24585 //
     /* 1953940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1953951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1953954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1953957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953986 */     // MIs[0] policy
     /* 1953986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953996 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1953999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954020 */     // GIR_Coverage, 24585,
     /* 1954020 */     GIR_EraseRootFromParent_Done,
     /* 1954021 */   // Label 26212: @1954021
     /* 1954021 */   GIM_Try, /*On fail goto*//*Label 26213*/ GIMT_Encode4(1954107), // Rule ID 24588 //
     /* 1954026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1954037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1954040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1954043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1954046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954072 */     // MIs[0] policy
     /* 1954072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954082 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1954085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954106 */     // GIR_Coverage, 24588,
     /* 1954106 */     GIR_EraseRootFromParent_Done,
     /* 1954107 */   // Label 26213: @1954107
     /* 1954107 */   GIM_Try, /*On fail goto*//*Label 26214*/ GIMT_Encode4(1954193), // Rule ID 24589 //
     /* 1954112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1954123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1954126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1954129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1954132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954158 */     // MIs[0] policy
     /* 1954158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954168 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1954171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954192 */     // GIR_Coverage, 24589,
     /* 1954192 */     GIR_EraseRootFromParent_Done,
     /* 1954193 */   // Label 26214: @1954193
     /* 1954193 */   GIM_Try, /*On fail goto*//*Label 26215*/ GIMT_Encode4(1954279), // Rule ID 24592 //
     /* 1954198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1954209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1954212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1954215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1954218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954244 */     // MIs[0] policy
     /* 1954244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954254 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1954257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954278 */     // GIR_Coverage, 24592,
     /* 1954278 */     GIR_EraseRootFromParent_Done,
     /* 1954279 */   // Label 26215: @1954279
     /* 1954279 */   GIM_Try, /*On fail goto*//*Label 26216*/ GIMT_Encode4(1954365), // Rule ID 24593 //
     /* 1954284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1954295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1954298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1954301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1954304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954330 */     // MIs[0] policy
     /* 1954330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954340 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1954343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954364 */     // GIR_Coverage, 24593,
     /* 1954364 */     GIR_EraseRootFromParent_Done,
     /* 1954365 */   // Label 26216: @1954365
     /* 1954365 */   GIM_Try, /*On fail goto*//*Label 26217*/ GIMT_Encode4(1954451), // Rule ID 24596 //
     /* 1954370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1954381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1954384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1954387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1954390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954416 */     // MIs[0] policy
     /* 1954416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954426 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1954429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954450 */     // GIR_Coverage, 24596,
     /* 1954450 */     GIR_EraseRootFromParent_Done,
     /* 1954451 */   // Label 26217: @1954451
     /* 1954451 */   GIM_Try, /*On fail goto*//*Label 26218*/ GIMT_Encode4(1954537), // Rule ID 24597 //
     /* 1954456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1954467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1954470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1954473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1954476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954502 */     // MIs[0] policy
     /* 1954502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954512 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1954515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954536 */     // GIR_Coverage, 24597,
     /* 1954536 */     GIR_EraseRootFromParent_Done,
     /* 1954537 */   // Label 26218: @1954537
     /* 1954537 */   GIM_Try, /*On fail goto*//*Label 26219*/ GIMT_Encode4(1954623), // Rule ID 24600 //
     /* 1954542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1954553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1954556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1954559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1954562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954588 */     // MIs[0] policy
     /* 1954588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954598 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1954601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954622 */     // GIR_Coverage, 24600,
     /* 1954622 */     GIR_EraseRootFromParent_Done,
     /* 1954623 */   // Label 26219: @1954623
     /* 1954623 */   GIM_Try, /*On fail goto*//*Label 26220*/ GIMT_Encode4(1954709), // Rule ID 24601 //
     /* 1954628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1954639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1954642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1954645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1954648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954674 */     // MIs[0] policy
     /* 1954674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1954687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954708 */     // GIR_Coverage, 24601,
     /* 1954708 */     GIR_EraseRootFromParent_Done,
     /* 1954709 */   // Label 26220: @1954709
     /* 1954709 */   GIM_Try, /*On fail goto*//*Label 26221*/ GIMT_Encode4(1954795), // Rule ID 24604 //
     /* 1954714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1954725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1954728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1954731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1954734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954760 */     // MIs[0] policy
     /* 1954760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954770 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1954773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954794 */     // GIR_Coverage, 24604,
     /* 1954794 */     GIR_EraseRootFromParent_Done,
     /* 1954795 */   // Label 26221: @1954795
     /* 1954795 */   GIM_Try, /*On fail goto*//*Label 26222*/ GIMT_Encode4(1954881), // Rule ID 24605 //
     /* 1954800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1954811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1954814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1954817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1954820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954846 */     // MIs[0] policy
     /* 1954846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954856 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1954859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954880 */     // GIR_Coverage, 24605,
     /* 1954880 */     GIR_EraseRootFromParent_Done,
     /* 1954881 */   // Label 26222: @1954881
     /* 1954881 */   GIM_Try, /*On fail goto*//*Label 26223*/ GIMT_Encode4(1954967), // Rule ID 24608 //
     /* 1954886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1954897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1954900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1954903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1954906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954932 */     // MIs[0] policy
     /* 1954932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954942 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1954945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954966 */     // GIR_Coverage, 24608,
     /* 1954966 */     GIR_EraseRootFromParent_Done,
     /* 1954967 */   // Label 26223: @1954967
     /* 1954967 */   GIM_Try, /*On fail goto*//*Label 26224*/ GIMT_Encode4(1955053), // Rule ID 24609 //
     /* 1954972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1954983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1954986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1954989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1954992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955018 */     // MIs[0] policy
     /* 1955018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955028 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1955031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955052 */     // GIR_Coverage, 24609,
     /* 1955052 */     GIR_EraseRootFromParent_Done,
     /* 1955053 */   // Label 26224: @1955053
     /* 1955053 */   GIM_Try, /*On fail goto*//*Label 26225*/ GIMT_Encode4(1955139), // Rule ID 24612 //
     /* 1955058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1955069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1955072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1955075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1955078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1955081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955104 */     // MIs[0] policy
     /* 1955104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1955117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955138 */     // GIR_Coverage, 24612,
     /* 1955138 */     GIR_EraseRootFromParent_Done,
     /* 1955139 */   // Label 26225: @1955139
     /* 1955139 */   GIM_Try, /*On fail goto*//*Label 26226*/ GIMT_Encode4(1955225), // Rule ID 24613 //
     /* 1955144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1955155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1955158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1955161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1955164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1955167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955190 */     // MIs[0] policy
     /* 1955190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955200 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1955203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955224 */     // GIR_Coverage, 24613,
     /* 1955224 */     GIR_EraseRootFromParent_Done,
     /* 1955225 */   // Label 26226: @1955225
     /* 1955225 */   GIM_Try, /*On fail goto*//*Label 26227*/ GIMT_Encode4(1955311), // Rule ID 24616 //
     /* 1955230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1955233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1955241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1955244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1955247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1955250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955276 */     // MIs[0] policy
     /* 1955276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955286 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1955289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1955307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955310 */     // GIR_Coverage, 24616,
     /* 1955310 */     GIR_EraseRootFromParent_Done,
     /* 1955311 */   // Label 26227: @1955311
     /* 1955311 */   GIM_Try, /*On fail goto*//*Label 26228*/ GIMT_Encode4(1955397), // Rule ID 24617 //
     /* 1955316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1955319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1955327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1955330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1955333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1955336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955362 */     // MIs[0] policy
     /* 1955362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955372 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1955375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1955393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955396 */     // GIR_Coverage, 24617,
     /* 1955396 */     GIR_EraseRootFromParent_Done,
     /* 1955397 */   // Label 26228: @1955397
     /* 1955397 */   GIM_Try, /*On fail goto*//*Label 26229*/ GIMT_Encode4(1955483), // Rule ID 24620 //
     /* 1955402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1955413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1955416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1955419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1955422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955448 */     // MIs[0] policy
     /* 1955448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955458 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1955461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955482 */     // GIR_Coverage, 24620,
     /* 1955482 */     GIR_EraseRootFromParent_Done,
     /* 1955483 */   // Label 26229: @1955483
     /* 1955483 */   GIM_Try, /*On fail goto*//*Label 26230*/ GIMT_Encode4(1955569), // Rule ID 24621 //
     /* 1955488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1955499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1955502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1955505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1955508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955534 */     // MIs[0] policy
     /* 1955534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955544 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1955547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955568 */     // GIR_Coverage, 24621,
     /* 1955568 */     GIR_EraseRootFromParent_Done,
     /* 1955569 */   // Label 26230: @1955569
     /* 1955569 */   GIM_Try, /*On fail goto*//*Label 26231*/ GIMT_Encode4(1955655), // Rule ID 24624 //
     /* 1955574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1955585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1955588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1955591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1955594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1955597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955620 */     // MIs[0] policy
     /* 1955620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955630 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1955633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955654 */     // GIR_Coverage, 24624,
     /* 1955654 */     GIR_EraseRootFromParent_Done,
     /* 1955655 */   // Label 26231: @1955655
     /* 1955655 */   GIM_Try, /*On fail goto*//*Label 26232*/ GIMT_Encode4(1955741), // Rule ID 24625 //
     /* 1955660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1955671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1955674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1955677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1955680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1955683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955706 */     // MIs[0] policy
     /* 1955706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955716 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1955719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955740 */     // GIR_Coverage, 24625,
     /* 1955740 */     GIR_EraseRootFromParent_Done,
     /* 1955741 */   // Label 26232: @1955741
     /* 1955741 */   GIM_Try, /*On fail goto*//*Label 26233*/ GIMT_Encode4(1955827), // Rule ID 24628 //
     /* 1955746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1955757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1955760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1955763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1955766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1955769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1955776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955792 */     // MIs[0] policy
     /* 1955792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955802 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1955805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955826 */     // GIR_Coverage, 24628,
     /* 1955826 */     GIR_EraseRootFromParent_Done,
     /* 1955827 */   // Label 26233: @1955827
     /* 1955827 */   GIM_Try, /*On fail goto*//*Label 26234*/ GIMT_Encode4(1955913), // Rule ID 24629 //
     /* 1955832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1955843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1955846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1955849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1955852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1955855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1955862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955878 */     // MIs[0] policy
     /* 1955878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955888 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1955891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955912 */     // GIR_Coverage, 24629,
     /* 1955912 */     GIR_EraseRootFromParent_Done,
     /* 1955913 */   // Label 26234: @1955913
     /* 1955913 */   GIM_Try, /*On fail goto*//*Label 26235*/ GIMT_Encode4(1955999), // Rule ID 24632 //
     /* 1955918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1955929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1955932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1955935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1955938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955964 */     // MIs[0] policy
     /* 1955964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955974 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1955977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955998 */     // GIR_Coverage, 24632,
     /* 1955998 */     GIR_EraseRootFromParent_Done,
     /* 1955999 */   // Label 26235: @1955999
     /* 1955999 */   GIM_Try, /*On fail goto*//*Label 26236*/ GIMT_Encode4(1956085), // Rule ID 24633 //
     /* 1956004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1956015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1956018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1956021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1956024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956050 */     // MIs[0] policy
     /* 1956050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1956063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956084 */     // GIR_Coverage, 24633,
     /* 1956084 */     GIR_EraseRootFromParent_Done,
     /* 1956085 */   // Label 26236: @1956085
     /* 1956085 */   GIM_Try, /*On fail goto*//*Label 26237*/ GIMT_Encode4(1956171), // Rule ID 24636 //
     /* 1956090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1956101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1956104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1956107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1956110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956136 */     // MIs[0] policy
     /* 1956136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956146 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1956149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956170 */     // GIR_Coverage, 24636,
     /* 1956170 */     GIR_EraseRootFromParent_Done,
     /* 1956171 */   // Label 26237: @1956171
     /* 1956171 */   GIM_Try, /*On fail goto*//*Label 26238*/ GIMT_Encode4(1956257), // Rule ID 24637 //
     /* 1956176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1956187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1956190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1956193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1956196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956222 */     // MIs[0] policy
     /* 1956222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956232 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1956235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956256 */     // GIR_Coverage, 24637,
     /* 1956256 */     GIR_EraseRootFromParent_Done,
     /* 1956257 */   // Label 26238: @1956257
     /* 1956257 */   GIM_Try, /*On fail goto*//*Label 26239*/ GIMT_Encode4(1956343), // Rule ID 24640 //
     /* 1956262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1956273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1956276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1956279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1956282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956308 */     // MIs[0] policy
     /* 1956308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956318 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1956321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956342 */     // GIR_Coverage, 24640,
     /* 1956342 */     GIR_EraseRootFromParent_Done,
     /* 1956343 */   // Label 26239: @1956343
     /* 1956343 */   GIM_Try, /*On fail goto*//*Label 26240*/ GIMT_Encode4(1956429), // Rule ID 24641 //
     /* 1956348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1956359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1956362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1956365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1956368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956394 */     // MIs[0] policy
     /* 1956394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956404 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1956407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956428 */     // GIR_Coverage, 24641,
     /* 1956428 */     GIR_EraseRootFromParent_Done,
     /* 1956429 */   // Label 26240: @1956429
     /* 1956429 */   GIM_Try, /*On fail goto*//*Label 26241*/ GIMT_Encode4(1956515), // Rule ID 24644 //
     /* 1956434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1956445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1956448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1956451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1956454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956480 */     // MIs[0] policy
     /* 1956480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956490 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1956493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956514 */     // GIR_Coverage, 24644,
     /* 1956514 */     GIR_EraseRootFromParent_Done,
     /* 1956515 */   // Label 26241: @1956515
     /* 1956515 */   GIM_Try, /*On fail goto*//*Label 26242*/ GIMT_Encode4(1956601), // Rule ID 24645 //
     /* 1956520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1956531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1956534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1956537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1956540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956566 */     // MIs[0] policy
     /* 1956566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1956579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956600 */     // GIR_Coverage, 24645,
     /* 1956600 */     GIR_EraseRootFromParent_Done,
     /* 1956601 */   // Label 26242: @1956601
     /* 1956601 */   GIM_Try, /*On fail goto*//*Label 26243*/ GIMT_Encode4(1956687), // Rule ID 24648 //
     /* 1956606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1956617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1956620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1956623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1956626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956652 */     // MIs[0] policy
     /* 1956652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956662 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1956665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956686 */     // GIR_Coverage, 24648,
     /* 1956686 */     GIR_EraseRootFromParent_Done,
     /* 1956687 */   // Label 26243: @1956687
     /* 1956687 */   GIM_Try, /*On fail goto*//*Label 26244*/ GIMT_Encode4(1956773), // Rule ID 24649 //
     /* 1956692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1956703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1956706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1956709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1956712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956738 */     // MIs[0] policy
     /* 1956738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1956751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956772 */     // GIR_Coverage, 24649,
     /* 1956772 */     GIR_EraseRootFromParent_Done,
     /* 1956773 */   // Label 26244: @1956773
     /* 1956773 */   GIM_Try, /*On fail goto*//*Label 26245*/ GIMT_Encode4(1956859), // Rule ID 24652 //
     /* 1956778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1956789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1956792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1956795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1956798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956824 */     // MIs[0] policy
     /* 1956824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956834 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1956837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956858 */     // GIR_Coverage, 24652,
     /* 1956858 */     GIR_EraseRootFromParent_Done,
     /* 1956859 */   // Label 26245: @1956859
     /* 1956859 */   GIM_Try, /*On fail goto*//*Label 26246*/ GIMT_Encode4(1956945), // Rule ID 24653 //
     /* 1956864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1956875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1956878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1956881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1956884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956910 */     // MIs[0] policy
     /* 1956910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956920 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1956923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956944 */     // GIR_Coverage, 24653,
     /* 1956944 */     GIR_EraseRootFromParent_Done,
     /* 1956945 */   // Label 26246: @1956945
     /* 1956945 */   GIM_Try, /*On fail goto*//*Label 26247*/ GIMT_Encode4(1957031), // Rule ID 24656 //
     /* 1956950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1956953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1956961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1956964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1956967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1956970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956996 */     // MIs[0] policy
     /* 1956996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1957009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957030 */     // GIR_Coverage, 24656,
     /* 1957030 */     GIR_EraseRootFromParent_Done,
     /* 1957031 */   // Label 26247: @1957031
     /* 1957031 */   GIM_Try, /*On fail goto*//*Label 26248*/ GIMT_Encode4(1957117), // Rule ID 24657 //
     /* 1957036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1957039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1957047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1957050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1957053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1957056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1957066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957082 */     // MIs[0] policy
     /* 1957082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957092 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1957095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957116 */     // GIR_Coverage, 24657,
     /* 1957116 */     GIR_EraseRootFromParent_Done,
     /* 1957117 */   // Label 26248: @1957117
     /* 1957117 */   GIM_Try, /*On fail goto*//*Label 26249*/ GIMT_Encode4(1957203), // Rule ID 24660 //
     /* 1957122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1957125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1957133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1957136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1957139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1957142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957168 */     // MIs[0] policy
     /* 1957168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957178 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1957181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957202 */     // GIR_Coverage, 24660,
     /* 1957202 */     GIR_EraseRootFromParent_Done,
     /* 1957203 */   // Label 26249: @1957203
     /* 1957203 */   GIM_Try, /*On fail goto*//*Label 26250*/ GIMT_Encode4(1957289), // Rule ID 24661 //
     /* 1957208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1957211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1957219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1957222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1957225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1957228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957254 */     // MIs[0] policy
     /* 1957254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1957267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957288 */     // GIR_Coverage, 24661,
     /* 1957288 */     GIR_EraseRootFromParent_Done,
     /* 1957289 */   // Label 26250: @1957289
     /* 1957289 */   GIM_Try, /*On fail goto*//*Label 26251*/ GIMT_Encode4(1957375), // Rule ID 24664 //
     /* 1957294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1957297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1957305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1957308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1957311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1957314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957340 */     // MIs[0] policy
     /* 1957340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957350 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1957353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957374 */     // GIR_Coverage, 24664,
     /* 1957374 */     GIR_EraseRootFromParent_Done,
     /* 1957375 */   // Label 26251: @1957375
     /* 1957375 */   GIM_Try, /*On fail goto*//*Label 26252*/ GIMT_Encode4(1957461), // Rule ID 24665 //
     /* 1957380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1957383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1957391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1957394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1957397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1957400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957426 */     // MIs[0] policy
     /* 1957426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957436 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1957439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957460 */     // GIR_Coverage, 24665,
     /* 1957460 */     GIR_EraseRootFromParent_Done,
     /* 1957461 */   // Label 26252: @1957461
     /* 1957461 */   GIM_Try, /*On fail goto*//*Label 26253*/ GIMT_Encode4(1957547), // Rule ID 24756 //
     /* 1957466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1957477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1957480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1957483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1957486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957512 */     // MIs[0] policy
     /* 1957512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957522 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1957525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1957543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957546 */     // GIR_Coverage, 24756,
     /* 1957546 */     GIR_EraseRootFromParent_Done,
     /* 1957547 */   // Label 26253: @1957547
     /* 1957547 */   GIM_Try, /*On fail goto*//*Label 26254*/ GIMT_Encode4(1957633), // Rule ID 24757 //
     /* 1957552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1957563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1957566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1957569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1957572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957598 */     // MIs[0] policy
     /* 1957598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957608 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1957611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1957629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957632 */     // GIR_Coverage, 24757,
     /* 1957632 */     GIR_EraseRootFromParent_Done,
     /* 1957633 */   // Label 26254: @1957633
     /* 1957633 */   GIM_Try, /*On fail goto*//*Label 26255*/ GIMT_Encode4(1957719), // Rule ID 24760 //
     /* 1957638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1957649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1957652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1957655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957684 */     // MIs[0] policy
     /* 1957684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957694 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1957697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1957715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957718 */     // GIR_Coverage, 24760,
     /* 1957718 */     GIR_EraseRootFromParent_Done,
     /* 1957719 */   // Label 26255: @1957719
     /* 1957719 */   GIM_Try, /*On fail goto*//*Label 26256*/ GIMT_Encode4(1957805), // Rule ID 24761 //
     /* 1957724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1957735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1957738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1957741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957770 */     // MIs[0] policy
     /* 1957770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957780 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1957783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1957801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957804 */     // GIR_Coverage, 24761,
     /* 1957804 */     GIR_EraseRootFromParent_Done,
     /* 1957805 */   // Label 26256: @1957805
     /* 1957805 */   GIM_Try, /*On fail goto*//*Label 26257*/ GIMT_Encode4(1957891), // Rule ID 24764 //
     /* 1957810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1957821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1957824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1957827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1957830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957856 */     // MIs[0] policy
     /* 1957856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957866 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1957869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1957887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957890 */     // GIR_Coverage, 24764,
     /* 1957890 */     GIR_EraseRootFromParent_Done,
     /* 1957891 */   // Label 26257: @1957891
     /* 1957891 */   GIM_Try, /*On fail goto*//*Label 26258*/ GIMT_Encode4(1957977), // Rule ID 24765 //
     /* 1957896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1957907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1957910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1957913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1957916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957942 */     // MIs[0] policy
     /* 1957942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957952 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1957955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1957973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957976 */     // GIR_Coverage, 24765,
     /* 1957976 */     GIR_EraseRootFromParent_Done,
     /* 1957977 */   // Label 26258: @1957977
     /* 1957977 */   GIM_Try, /*On fail goto*//*Label 26259*/ GIMT_Encode4(1958063), // Rule ID 24768 //
     /* 1957982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1957993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1957996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1957999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1958002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958028 */     // MIs[0] policy
     /* 1958028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958038 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1958041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958062 */     // GIR_Coverage, 24768,
     /* 1958062 */     GIR_EraseRootFromParent_Done,
     /* 1958063 */   // Label 26259: @1958063
     /* 1958063 */   GIM_Try, /*On fail goto*//*Label 26260*/ GIMT_Encode4(1958149), // Rule ID 24769 //
     /* 1958068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1958079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1958082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1958085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1958088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958114 */     // MIs[0] policy
     /* 1958114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958124 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1958127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958148 */     // GIR_Coverage, 24769,
     /* 1958148 */     GIR_EraseRootFromParent_Done,
     /* 1958149 */   // Label 26260: @1958149
     /* 1958149 */   GIM_Try, /*On fail goto*//*Label 26261*/ GIMT_Encode4(1958235), // Rule ID 24772 //
     /* 1958154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1958165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1958168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1958171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1958174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958200 */     // MIs[0] policy
     /* 1958200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958210 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1958213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958234 */     // GIR_Coverage, 24772,
     /* 1958234 */     GIR_EraseRootFromParent_Done,
     /* 1958235 */   // Label 26261: @1958235
     /* 1958235 */   GIM_Try, /*On fail goto*//*Label 26262*/ GIMT_Encode4(1958321), // Rule ID 24773 //
     /* 1958240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1958251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1958254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1958257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1958260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958286 */     // MIs[0] policy
     /* 1958286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958296 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1958299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958320 */     // GIR_Coverage, 24773,
     /* 1958320 */     GIR_EraseRootFromParent_Done,
     /* 1958321 */   // Label 26262: @1958321
     /* 1958321 */   GIM_Try, /*On fail goto*//*Label 26263*/ GIMT_Encode4(1958407), // Rule ID 24776 //
     /* 1958326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1958337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1958340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1958343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1958346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958372 */     // MIs[0] policy
     /* 1958372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958382 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1958385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958406 */     // GIR_Coverage, 24776,
     /* 1958406 */     GIR_EraseRootFromParent_Done,
     /* 1958407 */   // Label 26263: @1958407
     /* 1958407 */   GIM_Try, /*On fail goto*//*Label 26264*/ GIMT_Encode4(1958493), // Rule ID 24777 //
     /* 1958412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1958423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1958426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1958429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1958432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958458 */     // MIs[0] policy
     /* 1958458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958468 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1958471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958492 */     // GIR_Coverage, 24777,
     /* 1958492 */     GIR_EraseRootFromParent_Done,
     /* 1958493 */   // Label 26264: @1958493
     /* 1958493 */   GIM_Try, /*On fail goto*//*Label 26265*/ GIMT_Encode4(1958579), // Rule ID 24780 //
     /* 1958498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1958509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1958512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1958515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958544 */     // MIs[0] policy
     /* 1958544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958554 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1958557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1958575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958578 */     // GIR_Coverage, 24780,
     /* 1958578 */     GIR_EraseRootFromParent_Done,
     /* 1958579 */   // Label 26265: @1958579
     /* 1958579 */   GIM_Try, /*On fail goto*//*Label 26266*/ GIMT_Encode4(1958665), // Rule ID 24781 //
     /* 1958584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1958595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1958598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1958601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958630 */     // MIs[0] policy
     /* 1958630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958640 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1958643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1958661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958664 */     // GIR_Coverage, 24781,
     /* 1958664 */     GIR_EraseRootFromParent_Done,
     /* 1958665 */   // Label 26266: @1958665
     /* 1958665 */   GIM_Try, /*On fail goto*//*Label 26267*/ GIMT_Encode4(1958751), // Rule ID 24784 //
     /* 1958670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1958681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1958684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1958687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1958690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958716 */     // MIs[0] policy
     /* 1958716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958726 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1958729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958750 */     // GIR_Coverage, 24784,
     /* 1958750 */     GIR_EraseRootFromParent_Done,
     /* 1958751 */   // Label 26267: @1958751
     /* 1958751 */   GIM_Try, /*On fail goto*//*Label 26268*/ GIMT_Encode4(1958837), // Rule ID 24785 //
     /* 1958756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1958767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1958770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1958773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1958776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958802 */     // MIs[0] policy
     /* 1958802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958812 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1958815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958836 */     // GIR_Coverage, 24785,
     /* 1958836 */     GIR_EraseRootFromParent_Done,
     /* 1958837 */   // Label 26268: @1958837
     /* 1958837 */   GIM_Try, /*On fail goto*//*Label 26269*/ GIMT_Encode4(1958923), // Rule ID 24788 //
     /* 1958842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1958853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1958856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1958859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1958862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958888 */     // MIs[0] policy
     /* 1958888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958898 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1958901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958922 */     // GIR_Coverage, 24788,
     /* 1958922 */     GIR_EraseRootFromParent_Done,
     /* 1958923 */   // Label 26269: @1958923
     /* 1958923 */   GIM_Try, /*On fail goto*//*Label 26270*/ GIMT_Encode4(1959009), // Rule ID 24789 //
     /* 1958928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1958939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1958942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1958945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1958948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958974 */     // MIs[0] policy
     /* 1958974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1958987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959008 */     // GIR_Coverage, 24789,
     /* 1959008 */     GIR_EraseRootFromParent_Done,
     /* 1959009 */   // Label 26270: @1959009
     /* 1959009 */   GIM_Try, /*On fail goto*//*Label 26271*/ GIMT_Encode4(1959095), // Rule ID 24792 //
     /* 1959014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1959017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1959022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1959025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1959028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1959031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1959034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1959037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959060 */     // MIs[0] policy
     /* 1959060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959070 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1959073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959094 */     // GIR_Coverage, 24792,
     /* 1959094 */     GIR_EraseRootFromParent_Done,
     /* 1959095 */   // Label 26271: @1959095
     /* 1959095 */   GIM_Try, /*On fail goto*//*Label 26272*/ GIMT_Encode4(1959181), // Rule ID 24793 //
     /* 1959100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1959103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1959108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1959111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1959114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1959117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1959120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1959123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959146 */     // MIs[0] policy
     /* 1959146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959156 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1959159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959180 */     // GIR_Coverage, 24793,
     /* 1959180 */     GIR_EraseRootFromParent_Done,
     /* 1959181 */   // Label 26272: @1959181
     /* 1959181 */   GIM_Try, /*On fail goto*//*Label 26273*/ GIMT_Encode4(1959267), // Rule ID 24796 //
     /* 1959186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1959194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1959197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1959200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1959203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1959206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959232 */     // MIs[0] policy
     /* 1959232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959242 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1959245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959266 */     // GIR_Coverage, 24796,
     /* 1959266 */     GIR_EraseRootFromParent_Done,
     /* 1959267 */   // Label 26273: @1959267
     /* 1959267 */   GIM_Try, /*On fail goto*//*Label 26274*/ GIMT_Encode4(1959353), // Rule ID 24797 //
     /* 1959272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1959280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1959283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1959286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1959289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1959292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959318 */     // MIs[0] policy
     /* 1959318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959328 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1959331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959352 */     // GIR_Coverage, 24797,
     /* 1959352 */     GIR_EraseRootFromParent_Done,
     /* 1959353 */   // Label 26274: @1959353
     /* 1959353 */   GIM_Try, /*On fail goto*//*Label 26275*/ GIMT_Encode4(1959439), // Rule ID 24800 //
     /* 1959358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1959366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1959369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1959372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1959375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1959378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959404 */     // MIs[0] policy
     /* 1959404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959414 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1959417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959438 */     // GIR_Coverage, 24800,
     /* 1959438 */     GIR_EraseRootFromParent_Done,
     /* 1959439 */   // Label 26275: @1959439
     /* 1959439 */   GIM_Try, /*On fail goto*//*Label 26276*/ GIMT_Encode4(1959525), // Rule ID 24801 //
     /* 1959444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1959452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1959455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1959458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1959461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1959464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959490 */     // MIs[0] policy
     /* 1959490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959500 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1959503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959524 */     // GIR_Coverage, 24801,
     /* 1959524 */     GIR_EraseRootFromParent_Done,
     /* 1959525 */   // Label 26276: @1959525
     /* 1959525 */   GIM_Try, /*On fail goto*//*Label 26277*/ GIMT_Encode4(1959611), // Rule ID 24804 //
     /* 1959530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1959538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1959541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1959544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1959547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1959550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959576 */     // MIs[0] policy
     /* 1959576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959586 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1959589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959610 */     // GIR_Coverage, 24804,
     /* 1959610 */     GIR_EraseRootFromParent_Done,
     /* 1959611 */   // Label 26277: @1959611
     /* 1959611 */   GIM_Try, /*On fail goto*//*Label 26278*/ GIMT_Encode4(1959697), // Rule ID 24805 //
     /* 1959616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1959624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1959627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1959630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1959633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1959636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959662 */     // MIs[0] policy
     /* 1959662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959672 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1959675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959696 */     // GIR_Coverage, 24805,
     /* 1959696 */     GIR_EraseRootFromParent_Done,
     /* 1959697 */   // Label 26278: @1959697
     /* 1959697 */   GIM_Try, /*On fail goto*//*Label 26279*/ GIMT_Encode4(1959783), // Rule ID 24808 //
     /* 1959702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1959710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1959713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1959716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1959719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1959722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959748 */     // MIs[0] policy
     /* 1959748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959758 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1959761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959782 */     // GIR_Coverage, 24808,
     /* 1959782 */     GIR_EraseRootFromParent_Done,
     /* 1959783 */   // Label 26279: @1959783
     /* 1959783 */   GIM_Try, /*On fail goto*//*Label 26280*/ GIMT_Encode4(1959869), // Rule ID 24809 //
     /* 1959788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1959796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1959799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1959802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1959805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1959808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959834 */     // MIs[0] policy
     /* 1959834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959844 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1959847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959868 */     // GIR_Coverage, 24809,
     /* 1959868 */     GIR_EraseRootFromParent_Done,
     /* 1959869 */   // Label 26280: @1959869
     /* 1959869 */   GIM_Try, /*On fail goto*//*Label 26281*/ GIMT_Encode4(1959955), // Rule ID 24812 //
     /* 1959874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1959882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1959885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1959888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1959891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1959894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959920 */     // MIs[0] policy
     /* 1959920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959930 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1959933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959954 */     // GIR_Coverage, 24812,
     /* 1959954 */     GIR_EraseRootFromParent_Done,
     /* 1959955 */   // Label 26281: @1959955
     /* 1959955 */   GIM_Try, /*On fail goto*//*Label 26282*/ GIMT_Encode4(1960041), // Rule ID 24813 //
     /* 1959960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1959968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1959971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1959974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1959977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1959980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960006 */     // MIs[0] policy
     /* 1960006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960016 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1960019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960040 */     // GIR_Coverage, 24813,
     /* 1960040 */     GIR_EraseRootFromParent_Done,
     /* 1960041 */   // Label 26282: @1960041
     /* 1960041 */   GIM_Try, /*On fail goto*//*Label 26283*/ GIMT_Encode4(1960127), // Rule ID 24816 //
     /* 1960046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1960057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1960060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1960063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1960066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960092 */     // MIs[0] policy
     /* 1960092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1960105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960126 */     // GIR_Coverage, 24816,
     /* 1960126 */     GIR_EraseRootFromParent_Done,
     /* 1960127 */   // Label 26283: @1960127
     /* 1960127 */   GIM_Try, /*On fail goto*//*Label 26284*/ GIMT_Encode4(1960213), // Rule ID 24817 //
     /* 1960132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1960143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1960146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1960149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1960152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960178 */     // MIs[0] policy
     /* 1960178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960188 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1960191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960212 */     // GIR_Coverage, 24817,
     /* 1960212 */     GIR_EraseRootFromParent_Done,
     /* 1960213 */   // Label 26284: @1960213
     /* 1960213 */   GIM_Try, /*On fail goto*//*Label 26285*/ GIMT_Encode4(1960299), // Rule ID 24820 //
     /* 1960218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1960229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1960232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1960235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1960238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1960248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960264 */     // MIs[0] policy
     /* 1960264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960274 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1960277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960298 */     // GIR_Coverage, 24820,
     /* 1960298 */     GIR_EraseRootFromParent_Done,
     /* 1960299 */   // Label 26285: @1960299
     /* 1960299 */   GIM_Try, /*On fail goto*//*Label 26286*/ GIMT_Encode4(1960385), // Rule ID 24821 //
     /* 1960304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1960315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1960318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1960321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1960324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1960334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960350 */     // MIs[0] policy
     /* 1960350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960360 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1960363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960384 */     // GIR_Coverage, 24821,
     /* 1960384 */     GIR_EraseRootFromParent_Done,
     /* 1960385 */   // Label 26286: @1960385
     /* 1960385 */   GIM_Try, /*On fail goto*//*Label 26287*/ GIMT_Encode4(1960471), // Rule ID 24824 //
     /* 1960390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1960401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1960404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1960407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1960410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1960413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960436 */     // MIs[0] policy
     /* 1960436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1960449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960470 */     // GIR_Coverage, 24824,
     /* 1960470 */     GIR_EraseRootFromParent_Done,
     /* 1960471 */   // Label 26287: @1960471
     /* 1960471 */   GIM_Try, /*On fail goto*//*Label 26288*/ GIMT_Encode4(1960557), // Rule ID 24825 //
     /* 1960476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1960487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1960490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1960493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1960496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1960499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960522 */     // MIs[0] policy
     /* 1960522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960532 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1960535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960556 */     // GIR_Coverage, 24825,
     /* 1960556 */     GIR_EraseRootFromParent_Done,
     /* 1960557 */   // Label 26288: @1960557
     /* 1960557 */   GIM_Try, /*On fail goto*//*Label 26289*/ GIMT_Encode4(1960643), // Rule ID 24828 //
     /* 1960562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1960565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1960573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1960576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1960579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1960582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960608 */     // MIs[0] policy
     /* 1960608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1960621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960642 */     // GIR_Coverage, 24828,
     /* 1960642 */     GIR_EraseRootFromParent_Done,
     /* 1960643 */   // Label 26289: @1960643
     /* 1960643 */   GIM_Try, /*On fail goto*//*Label 26290*/ GIMT_Encode4(1960729), // Rule ID 24829 //
     /* 1960648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1960651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1960659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1960662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1960665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1960668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960694 */     // MIs[0] policy
     /* 1960694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960704 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1960707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960728 */     // GIR_Coverage, 24829,
     /* 1960728 */     GIR_EraseRootFromParent_Done,
     /* 1960729 */   // Label 26290: @1960729
     /* 1960729 */   GIM_Try, /*On fail goto*//*Label 26291*/ GIMT_Encode4(1960815), // Rule ID 24832 //
     /* 1960734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1960737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1960745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1960748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1960751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1960754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1960764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960780 */     // MIs[0] policy
     /* 1960780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960790 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1960793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960814 */     // GIR_Coverage, 24832,
     /* 1960814 */     GIR_EraseRootFromParent_Done,
     /* 1960815 */   // Label 26291: @1960815
     /* 1960815 */   GIM_Try, /*On fail goto*//*Label 26292*/ GIMT_Encode4(1960901), // Rule ID 24833 //
     /* 1960820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1960823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1960831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1960834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1960837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1960840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1960850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960866 */     // MIs[0] policy
     /* 1960866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960876 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1960879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960900 */     // GIR_Coverage, 24833,
     /* 1960900 */     GIR_EraseRootFromParent_Done,
     /* 1960901 */   // Label 26292: @1960901
     /* 1960901 */   GIM_Try, /*On fail goto*//*Label 26293*/ GIMT_Encode4(1960987), // Rule ID 24836 //
     /* 1960906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1960909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1960917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1960920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1960923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1960926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960952 */     // MIs[0] policy
     /* 1960952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960962 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1960965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960986 */     // GIR_Coverage, 24836,
     /* 1960986 */     GIR_EraseRootFromParent_Done,
     /* 1960987 */   // Label 26293: @1960987
     /* 1960987 */   GIM_Try, /*On fail goto*//*Label 26294*/ GIMT_Encode4(1961073), // Rule ID 24837 //
     /* 1960992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1960995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1961000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1961003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1961006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1961009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1961012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961038 */     // MIs[0] policy
     /* 1961038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961048 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1961051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961072 */     // GIR_Coverage, 24837,
     /* 1961072 */     GIR_EraseRootFromParent_Done,
     /* 1961073 */   // Label 26294: @1961073
     /* 1961073 */   GIM_Try, /*On fail goto*//*Label 26295*/ GIMT_Encode4(1961159), // Rule ID 24840 //
     /* 1961078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1961081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1961086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1961089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1961092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1961095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1961098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961124 */     // MIs[0] policy
     /* 1961124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961134 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1961137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961158 */     // GIR_Coverage, 24840,
     /* 1961158 */     GIR_EraseRootFromParent_Done,
     /* 1961159 */   // Label 26295: @1961159
     /* 1961159 */   GIM_Try, /*On fail goto*//*Label 26296*/ GIMT_Encode4(1961245), // Rule ID 24841 //
     /* 1961164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1961167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1961172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1961175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1961178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1961181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1961184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961210 */     // MIs[0] policy
     /* 1961210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961220 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1961223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961244 */     // GIR_Coverage, 24841,
     /* 1961244 */     GIR_EraseRootFromParent_Done,
     /* 1961245 */   // Label 26296: @1961245
     /* 1961245 */   GIM_Try, /*On fail goto*//*Label 26297*/ GIMT_Encode4(1961331), // Rule ID 24844 //
     /* 1961250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1961253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1961258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1961261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1961264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1961267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1961270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1961273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961296 */     // MIs[0] policy
     /* 1961296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961306 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1961309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961330 */     // GIR_Coverage, 24844,
     /* 1961330 */     GIR_EraseRootFromParent_Done,
     /* 1961331 */   // Label 26297: @1961331
     /* 1961331 */   GIM_Try, /*On fail goto*//*Label 26298*/ GIMT_Encode4(1961417), // Rule ID 24845 //
     /* 1961336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1961339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1961344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1961347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1961350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1961353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1961356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1961359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961382 */     // MIs[0] policy
     /* 1961382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961392 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1961395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961416 */     // GIR_Coverage, 24845,
     /* 1961416 */     GIR_EraseRootFromParent_Done,
     /* 1961417 */   // Label 26298: @1961417
     /* 1961417 */   GIM_Try, /*On fail goto*//*Label 26299*/ GIMT_Encode4(1961503), // Rule ID 24848 //
     /* 1961422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1961425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1961430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1961433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1961436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1961439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1961442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961468 */     // MIs[0] policy
     /* 1961468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961478 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1961481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961502 */     // GIR_Coverage, 24848,
     /* 1961502 */     GIR_EraseRootFromParent_Done,
     /* 1961503 */   // Label 26299: @1961503
     /* 1961503 */   GIM_Try, /*On fail goto*//*Label 26300*/ GIMT_Encode4(1961589), // Rule ID 24849 //
     /* 1961508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1961511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1961516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1961519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1961522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1961525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1961528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961554 */     // MIs[0] policy
     /* 1961554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961564 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1961567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961588 */     // GIR_Coverage, 24849,
     /* 1961588 */     GIR_EraseRootFromParent_Done,
     /* 1961589 */   // Label 26300: @1961589
     /* 1961589 */   GIM_Try, /*On fail goto*//*Label 26301*/ GIMT_Encode4(1961675), // Rule ID 24852 //
     /* 1961594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1961597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1961602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1961605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1961608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1961611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1961614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961640 */     // MIs[0] policy
     /* 1961640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961650 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1961653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961674 */     // GIR_Coverage, 24852,
     /* 1961674 */     GIR_EraseRootFromParent_Done,
     /* 1961675 */   // Label 26301: @1961675
     /* 1961675 */   GIM_Try, /*On fail goto*//*Label 26302*/ GIMT_Encode4(1961761), // Rule ID 24853 //
     /* 1961680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1961683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1961688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1961691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1961694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1961697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1961700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961726 */     // MIs[0] policy
     /* 1961726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961736 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1961739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961760 */     // GIR_Coverage, 24853,
     /* 1961760 */     GIR_EraseRootFromParent_Done,
     /* 1961761 */   // Label 26302: @1961761
     /* 1961761 */   GIM_Try, /*On fail goto*//*Label 26303*/ GIMT_Encode4(1961847), // Rule ID 24856 //
     /* 1961766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1961769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1961774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1961777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1961780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1961783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1961786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961812 */     // MIs[0] policy
     /* 1961812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961822 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1961825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961846 */     // GIR_Coverage, 24856,
     /* 1961846 */     GIR_EraseRootFromParent_Done,
     /* 1961847 */   // Label 26303: @1961847
     /* 1961847 */   GIM_Try, /*On fail goto*//*Label 26304*/ GIMT_Encode4(1961933), // Rule ID 24857 //
     /* 1961852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1961855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1961860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1961863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1961866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1961869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1961872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961898 */     // MIs[0] policy
     /* 1961898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961908 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1961911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961932 */     // GIR_Coverage, 24857,
     /* 1961932 */     GIR_EraseRootFromParent_Done,
     /* 1961933 */   // Label 26304: @1961933
     /* 1961933 */   GIM_Try, /*On fail goto*//*Label 26305*/ GIMT_Encode4(1962019), // Rule ID 24860 //
     /* 1961938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1961941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1961946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1961949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1961952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1961955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1961958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961984 */     // MIs[0] policy
     /* 1961984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961994 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1961997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962018 */     // GIR_Coverage, 24860,
     /* 1962018 */     GIR_EraseRootFromParent_Done,
     /* 1962019 */   // Label 26305: @1962019
     /* 1962019 */   GIM_Try, /*On fail goto*//*Label 26306*/ GIMT_Encode4(1962105), // Rule ID 24861 //
     /* 1962024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1962027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1962032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1962035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1962038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1962041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1962044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1962047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962070 */     // MIs[0] policy
     /* 1962070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962080 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1962083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962104 */     // GIR_Coverage, 24861,
     /* 1962104 */     GIR_EraseRootFromParent_Done,
     /* 1962105 */   // Label 26306: @1962105
     /* 1962105 */   GIM_Try, /*On fail goto*//*Label 26307*/ GIMT_Encode4(1962191), // Rule ID 24864 //
     /* 1962110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1962113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1962118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1962121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1962124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1962127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1962130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1962140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962156 */     // MIs[0] policy
     /* 1962156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962166 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1962169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962190 */     // GIR_Coverage, 24864,
     /* 1962190 */     GIR_EraseRootFromParent_Done,
     /* 1962191 */   // Label 26307: @1962191
     /* 1962191 */   GIM_Try, /*On fail goto*//*Label 26308*/ GIMT_Encode4(1962277), // Rule ID 24865 //
     /* 1962196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1962199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1962204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1962207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1962210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1962213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1962216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1962226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962242 */     // MIs[0] policy
     /* 1962242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962252 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1962255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962276 */     // GIR_Coverage, 24865,
     /* 1962276 */     GIR_EraseRootFromParent_Done,
     /* 1962277 */   // Label 26308: @1962277
     /* 1962277 */   GIM_Try, /*On fail goto*//*Label 26309*/ GIMT_Encode4(1962363), // Rule ID 24868 //
     /* 1962282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1962285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1962290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1962293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1962296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1962299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1962302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962328 */     // MIs[0] policy
     /* 1962328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962338 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1962341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962362 */     // GIR_Coverage, 24868,
     /* 1962362 */     GIR_EraseRootFromParent_Done,
     /* 1962363 */   // Label 26309: @1962363
     /* 1962363 */   GIM_Try, /*On fail goto*//*Label 26310*/ GIMT_Encode4(1962449), // Rule ID 24869 //
     /* 1962368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1962371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1962376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1962379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1962382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1962385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1962388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962414 */     // MIs[0] policy
     /* 1962414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962424 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1962427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962448 */     // GIR_Coverage, 24869,
     /* 1962448 */     GIR_EraseRootFromParent_Done,
     /* 1962449 */   // Label 26310: @1962449
     /* 1962449 */   GIM_Try, /*On fail goto*//*Label 26311*/ GIMT_Encode4(1962535), // Rule ID 24872 //
     /* 1962454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1962457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1962462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1962465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1962468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1962471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1962474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962500 */     // MIs[0] policy
     /* 1962500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962510 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1962513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962534 */     // GIR_Coverage, 24872,
     /* 1962534 */     GIR_EraseRootFromParent_Done,
     /* 1962535 */   // Label 26311: @1962535
     /* 1962535 */   GIM_Try, /*On fail goto*//*Label 26312*/ GIMT_Encode4(1962621), // Rule ID 24873 //
     /* 1962540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1962543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1962548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1962551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1962554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1962557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1962560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962586 */     // MIs[0] policy
     /* 1962586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962596 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1962599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962620 */     // GIR_Coverage, 24873,
     /* 1962620 */     GIR_EraseRootFromParent_Done,
     /* 1962621 */   // Label 26312: @1962621
     /* 1962621 */   GIM_Try, /*On fail goto*//*Label 26313*/ GIMT_Encode4(1962707), // Rule ID 24876 //
     /* 1962626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1962629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1962637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1962640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1962643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962672 */     // MIs[0] policy
     /* 1962672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962682 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1962685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962706 */     // GIR_Coverage, 24876,
     /* 1962706 */     GIR_EraseRootFromParent_Done,
     /* 1962707 */   // Label 26313: @1962707
     /* 1962707 */   GIM_Try, /*On fail goto*//*Label 26314*/ GIMT_Encode4(1962793), // Rule ID 24877 //
     /* 1962712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1962715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1962723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1962726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1962729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962758 */     // MIs[0] policy
     /* 1962758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962768 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1962771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962792 */     // GIR_Coverage, 24877,
     /* 1962792 */     GIR_EraseRootFromParent_Done,
     /* 1962793 */   // Label 26314: @1962793
     /* 1962793 */   GIM_Try, /*On fail goto*//*Label 26315*/ GIMT_Encode4(1962879), // Rule ID 24880 //
     /* 1962798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1962801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1962809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1962812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1962815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962844 */     // MIs[0] policy
     /* 1962844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962854 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1962857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962878 */     // GIR_Coverage, 24880,
     /* 1962878 */     GIR_EraseRootFromParent_Done,
     /* 1962879 */   // Label 26315: @1962879
     /* 1962879 */   GIM_Try, /*On fail goto*//*Label 26316*/ GIMT_Encode4(1962965), // Rule ID 24881 //
     /* 1962884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1962887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1962895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1962898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1962901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962930 */     // MIs[0] policy
     /* 1962930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962940 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1962943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962964 */     // GIR_Coverage, 24881,
     /* 1962964 */     GIR_EraseRootFromParent_Done,
     /* 1962965 */   // Label 26316: @1962965
     /* 1962965 */   GIM_Try, /*On fail goto*//*Label 26317*/ GIMT_Encode4(1963051), // Rule ID 24884 //
     /* 1962970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1962973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1962981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1962984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1962987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963016 */     // MIs[0] policy
     /* 1963016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963026 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1963029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963050 */     // GIR_Coverage, 24884,
     /* 1963050 */     GIR_EraseRootFromParent_Done,
     /* 1963051 */   // Label 26317: @1963051
     /* 1963051 */   GIM_Try, /*On fail goto*//*Label 26318*/ GIMT_Encode4(1963137), // Rule ID 24885 //
     /* 1963056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1963059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1963064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1963067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1963070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1963073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1963076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963102 */     // MIs[0] policy
     /* 1963102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963112 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1963115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963136 */     // GIR_Coverage, 24885,
     /* 1963136 */     GIR_EraseRootFromParent_Done,
     /* 1963137 */   // Label 26318: @1963137
     /* 1963137 */   GIM_Try, /*On fail goto*//*Label 26319*/ GIMT_Encode4(1963223), // Rule ID 24888 //
     /* 1963142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1963145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1963150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1963153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1963156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1963159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1963162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963188 */     // MIs[0] policy
     /* 1963188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963198 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1963201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963222 */     // GIR_Coverage, 24888,
     /* 1963222 */     GIR_EraseRootFromParent_Done,
     /* 1963223 */   // Label 26319: @1963223
     /* 1963223 */   GIM_Try, /*On fail goto*//*Label 26320*/ GIMT_Encode4(1963309), // Rule ID 24889 //
     /* 1963228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1963231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1963236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1963239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1963242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1963245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1963248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963274 */     // MIs[0] policy
     /* 1963274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963284 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1963287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963308 */     // GIR_Coverage, 24889,
     /* 1963308 */     GIR_EraseRootFromParent_Done,
     /* 1963309 */   // Label 26320: @1963309
     /* 1963309 */   GIM_Try, /*On fail goto*//*Label 26321*/ GIMT_Encode4(1963395), // Rule ID 24892 //
     /* 1963314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1963317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1963322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1963325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1963328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1963331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1963334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963360 */     // MIs[0] policy
     /* 1963360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963370 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1963373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963394 */     // GIR_Coverage, 24892,
     /* 1963394 */     GIR_EraseRootFromParent_Done,
     /* 1963395 */   // Label 26321: @1963395
     /* 1963395 */   GIM_Try, /*On fail goto*//*Label 26322*/ GIMT_Encode4(1963481), // Rule ID 24893 //
     /* 1963400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1963403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1963408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1963411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1963414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1963417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1963420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963446 */     // MIs[0] policy
     /* 1963446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963456 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1963459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963480 */     // GIR_Coverage, 24893,
     /* 1963480 */     GIR_EraseRootFromParent_Done,
     /* 1963481 */   // Label 26322: @1963481
     /* 1963481 */   GIM_Try, /*On fail goto*//*Label 26323*/ GIMT_Encode4(1963567), // Rule ID 24896 //
     /* 1963486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1963489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1963494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1963497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1963500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1963503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1963506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1963509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963532 */     // MIs[0] policy
     /* 1963532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963542 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1963545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963566 */     // GIR_Coverage, 24896,
     /* 1963566 */     GIR_EraseRootFromParent_Done,
     /* 1963567 */   // Label 26323: @1963567
     /* 1963567 */   GIM_Try, /*On fail goto*//*Label 26324*/ GIMT_Encode4(1963653), // Rule ID 24897 //
     /* 1963572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1963575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1963580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1963583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1963586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1963589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1963592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1963595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963618 */     // MIs[0] policy
     /* 1963618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963628 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1963631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963652 */     // GIR_Coverage, 24897,
     /* 1963652 */     GIR_EraseRootFromParent_Done,
     /* 1963653 */   // Label 26324: @1963653
     /* 1963653 */   GIM_Try, /*On fail goto*//*Label 26325*/ GIMT_Encode4(1963739), // Rule ID 24900 //
     /* 1963658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1963661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1963666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1963669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1963672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1963675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1963678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963704 */     // MIs[0] policy
     /* 1963704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963714 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1963717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963738 */     // GIR_Coverage, 24900,
     /* 1963738 */     GIR_EraseRootFromParent_Done,
     /* 1963739 */   // Label 26325: @1963739
     /* 1963739 */   GIM_Try, /*On fail goto*//*Label 26326*/ GIMT_Encode4(1963825), // Rule ID 24901 //
     /* 1963744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1963747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1963752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1963755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1963758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1963761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1963764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963790 */     // MIs[0] policy
     /* 1963790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963800 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1963803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963824 */     // GIR_Coverage, 24901,
     /* 1963824 */     GIR_EraseRootFromParent_Done,
     /* 1963825 */   // Label 26326: @1963825
     /* 1963825 */   GIM_Try, /*On fail goto*//*Label 26327*/ GIMT_Encode4(1963911), // Rule ID 24904 //
     /* 1963830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1963833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1963838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1963841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1963844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1963847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1963850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963876 */     // MIs[0] policy
     /* 1963876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963886 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1963889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963910 */     // GIR_Coverage, 24904,
     /* 1963910 */     GIR_EraseRootFromParent_Done,
     /* 1963911 */   // Label 26327: @1963911
     /* 1963911 */   GIM_Try, /*On fail goto*//*Label 26328*/ GIMT_Encode4(1963997), // Rule ID 24905 //
     /* 1963916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1963919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1963924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1963927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1963930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1963933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1963936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963962 */     // MIs[0] policy
     /* 1963962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963972 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1963975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963996 */     // GIR_Coverage, 24905,
     /* 1963996 */     GIR_EraseRootFromParent_Done,
     /* 1963997 */   // Label 26328: @1963997
     /* 1963997 */   GIM_Try, /*On fail goto*//*Label 26329*/ GIMT_Encode4(1964083), // Rule ID 24908 //
     /* 1964002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1964005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1964010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1964013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1964016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1964019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1964022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964048 */     // MIs[0] policy
     /* 1964048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964058 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1964061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964082 */     // GIR_Coverage, 24908,
     /* 1964082 */     GIR_EraseRootFromParent_Done,
     /* 1964083 */   // Label 26329: @1964083
     /* 1964083 */   GIM_Try, /*On fail goto*//*Label 26330*/ GIMT_Encode4(1964169), // Rule ID 24909 //
     /* 1964088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1964091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1964096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1964099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1964102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1964105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1964108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964134 */     // MIs[0] policy
     /* 1964134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964144 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1964147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964168 */     // GIR_Coverage, 24909,
     /* 1964168 */     GIR_EraseRootFromParent_Done,
     /* 1964169 */   // Label 26330: @1964169
     /* 1964169 */   GIM_Try, /*On fail goto*//*Label 26331*/ GIMT_Encode4(1964255), // Rule ID 24948 //
     /* 1964174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1964177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1964182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1964185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1964188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1964191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1964194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1964197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964220 */     // MIs[0] policy
     /* 1964220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964230 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1964233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964254 */     // GIR_Coverage, 24948,
     /* 1964254 */     GIR_EraseRootFromParent_Done,
     /* 1964255 */   // Label 26331: @1964255
     /* 1964255 */   GIM_Try, /*On fail goto*//*Label 26332*/ GIMT_Encode4(1964341), // Rule ID 24949 //
     /* 1964260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1964263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1964268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1964271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1964274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1964277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1964280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1964283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964306 */     // MIs[0] policy
     /* 1964306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964316 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1964319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964340 */     // GIR_Coverage, 24949,
     /* 1964340 */     GIR_EraseRootFromParent_Done,
     /* 1964341 */   // Label 26332: @1964341
     /* 1964341 */   GIM_Try, /*On fail goto*//*Label 26333*/ GIMT_Encode4(1964427), // Rule ID 24952 //
     /* 1964346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1964349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1964354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1964357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1964360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1964363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1964366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964392 */     // MIs[0] policy
     /* 1964392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964402 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1964405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964426 */     // GIR_Coverage, 24952,
     /* 1964426 */     GIR_EraseRootFromParent_Done,
     /* 1964427 */   // Label 26333: @1964427
     /* 1964427 */   GIM_Try, /*On fail goto*//*Label 26334*/ GIMT_Encode4(1964513), // Rule ID 24953 //
     /* 1964432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1964435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1964440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1964443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1964446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1964449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1964452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964478 */     // MIs[0] policy
     /* 1964478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964488 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1964491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964512 */     // GIR_Coverage, 24953,
     /* 1964512 */     GIR_EraseRootFromParent_Done,
     /* 1964513 */   // Label 26334: @1964513
     /* 1964513 */   GIM_Try, /*On fail goto*//*Label 26335*/ GIMT_Encode4(1964599), // Rule ID 24956 //
     /* 1964518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1964521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1964526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1964529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1964532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1964535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964564 */     // MIs[0] policy
     /* 1964564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964574 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1964577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964598 */     // GIR_Coverage, 24956,
     /* 1964598 */     GIR_EraseRootFromParent_Done,
     /* 1964599 */   // Label 26335: @1964599
     /* 1964599 */   GIM_Try, /*On fail goto*//*Label 26336*/ GIMT_Encode4(1964685), // Rule ID 24957 //
     /* 1964604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1964607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1964612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1964615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1964618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1964621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964650 */     // MIs[0] policy
     /* 1964650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964660 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1964663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964684 */     // GIR_Coverage, 24957,
     /* 1964684 */     GIR_EraseRootFromParent_Done,
     /* 1964685 */   // Label 26336: @1964685
     /* 1964685 */   GIM_Try, /*On fail goto*//*Label 26337*/ GIMT_Encode4(1964771), // Rule ID 24960 //
     /* 1964690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1964693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1964698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1964701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1964704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1964707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964736 */     // MIs[0] policy
     /* 1964736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964746 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1964749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964770 */     // GIR_Coverage, 24960,
     /* 1964770 */     GIR_EraseRootFromParent_Done,
     /* 1964771 */   // Label 26337: @1964771
     /* 1964771 */   GIM_Try, /*On fail goto*//*Label 26338*/ GIMT_Encode4(1964857), // Rule ID 24961 //
     /* 1964776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1964779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1964784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1964787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1964790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1964793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964822 */     // MIs[0] policy
     /* 1964822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964832 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1964835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964856 */     // GIR_Coverage, 24961,
     /* 1964856 */     GIR_EraseRootFromParent_Done,
     /* 1964857 */   // Label 26338: @1964857
     /* 1964857 */   GIM_Try, /*On fail goto*//*Label 26339*/ GIMT_Encode4(1964943), // Rule ID 24964 //
     /* 1964862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1964865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1964870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1964873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1964876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1964879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964908 */     // MIs[0] policy
     /* 1964908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964918 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1964921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964942 */     // GIR_Coverage, 24964,
     /* 1964942 */     GIR_EraseRootFromParent_Done,
     /* 1964943 */   // Label 26339: @1964943
     /* 1964943 */   GIM_Try, /*On fail goto*//*Label 26340*/ GIMT_Encode4(1965029), // Rule ID 24965 //
     /* 1964948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1964951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1964956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1964959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1964962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1964965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964994 */     // MIs[0] policy
     /* 1964994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965004 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1965007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965028 */     // GIR_Coverage, 24965,
     /* 1965028 */     GIR_EraseRootFromParent_Done,
     /* 1965029 */   // Label 26340: @1965029
     /* 1965029 */   GIM_Try, /*On fail goto*//*Label 26341*/ GIMT_Encode4(1965115), // Rule ID 24968 //
     /* 1965034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1965037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1965042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1965045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1965048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1965051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1965054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1965057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965080 */     // MIs[0] policy
     /* 1965080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965090 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1965093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965114 */     // GIR_Coverage, 24968,
     /* 1965114 */     GIR_EraseRootFromParent_Done,
     /* 1965115 */   // Label 26341: @1965115
     /* 1965115 */   GIM_Try, /*On fail goto*//*Label 26342*/ GIMT_Encode4(1965201), // Rule ID 24969 //
     /* 1965120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1965123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1965128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1965131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1965134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1965137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1965140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1965143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965166 */     // MIs[0] policy
     /* 1965166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965176 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1965179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965200 */     // GIR_Coverage, 24969,
     /* 1965200 */     GIR_EraseRootFromParent_Done,
     /* 1965201 */   // Label 26342: @1965201
     /* 1965201 */   GIM_Try, /*On fail goto*//*Label 26343*/ GIMT_Encode4(1965287), // Rule ID 24972 //
     /* 1965206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1965209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1965214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1965217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1965220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1965223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965252 */     // MIs[0] policy
     /* 1965252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965262 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1965265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965286 */     // GIR_Coverage, 24972,
     /* 1965286 */     GIR_EraseRootFromParent_Done,
     /* 1965287 */   // Label 26343: @1965287
     /* 1965287 */   GIM_Try, /*On fail goto*//*Label 26344*/ GIMT_Encode4(1965373), // Rule ID 24973 //
     /* 1965292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1965295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1965300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1965303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1965306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1965309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965338 */     // MIs[0] policy
     /* 1965338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965348 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1965351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965372 */     // GIR_Coverage, 24973,
     /* 1965372 */     GIR_EraseRootFromParent_Done,
     /* 1965373 */   // Label 26344: @1965373
     /* 1965373 */   GIM_Try, /*On fail goto*//*Label 26345*/ GIMT_Encode4(1965459), // Rule ID 24976 //
     /* 1965378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1965381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1965386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1965395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965424 */     // MIs[0] policy
     /* 1965424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965434 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1965437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965458 */     // GIR_Coverage, 24976,
     /* 1965458 */     GIR_EraseRootFromParent_Done,
     /* 1965459 */   // Label 26345: @1965459
     /* 1965459 */   GIM_Try, /*On fail goto*//*Label 26346*/ GIMT_Encode4(1965545), // Rule ID 24977 //
     /* 1965464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1965467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1965472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1965481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965510 */     // MIs[0] policy
     /* 1965510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965520 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1965523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965544 */     // GIR_Coverage, 24977,
     /* 1965544 */     GIR_EraseRootFromParent_Done,
     /* 1965545 */   // Label 26346: @1965545
     /* 1965545 */   GIM_Try, /*On fail goto*//*Label 26347*/ GIMT_Encode4(1965631), // Rule ID 24980 //
     /* 1965550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1965553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1965558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1965561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1965564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1965567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965596 */     // MIs[0] policy
     /* 1965596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965606 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1965609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965630 */     // GIR_Coverage, 24980,
     /* 1965630 */     GIR_EraseRootFromParent_Done,
     /* 1965631 */   // Label 26347: @1965631
     /* 1965631 */   GIM_Try, /*On fail goto*//*Label 26348*/ GIMT_Encode4(1965717), // Rule ID 24981 //
     /* 1965636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1965639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1965644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1965647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1965650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1965653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965682 */     // MIs[0] policy
     /* 1965682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965692 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1965695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965716 */     // GIR_Coverage, 24981,
     /* 1965716 */     GIR_EraseRootFromParent_Done,
     /* 1965717 */   // Label 26348: @1965717
     /* 1965717 */   GIM_Try, /*On fail goto*//*Label 26349*/ GIMT_Encode4(1965803), // Rule ID 24984 //
     /* 1965722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1965725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1965730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1965733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1965736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1965739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965768 */     // MIs[0] policy
     /* 1965768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965778 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1965781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965802 */     // GIR_Coverage, 24984,
     /* 1965802 */     GIR_EraseRootFromParent_Done,
     /* 1965803 */   // Label 26349: @1965803
     /* 1965803 */   GIM_Try, /*On fail goto*//*Label 26350*/ GIMT_Encode4(1965889), // Rule ID 24985 //
     /* 1965808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1965811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1965816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1965819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1965822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1965825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965854 */     // MIs[0] policy
     /* 1965854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965864 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1965867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965888 */     // GIR_Coverage, 24985,
     /* 1965888 */     GIR_EraseRootFromParent_Done,
     /* 1965889 */   // Label 26350: @1965889
     /* 1965889 */   GIM_Try, /*On fail goto*//*Label 26351*/ GIMT_Encode4(1965975), // Rule ID 24988 //
     /* 1965894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1965897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1965902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1965905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1965908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1965911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1965917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965940 */     // MIs[0] policy
     /* 1965940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965950 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1965953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1965971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965974 */     // GIR_Coverage, 24988,
     /* 1965974 */     GIR_EraseRootFromParent_Done,
     /* 1965975 */   // Label 26351: @1965975
     /* 1965975 */   GIM_Try, /*On fail goto*//*Label 26352*/ GIMT_Encode4(1966061), // Rule ID 24989 //
     /* 1965980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1965983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1965988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1965991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1965994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1965997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1966003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966026 */     // MIs[0] policy
     /* 1966026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966036 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1966039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966060 */     // GIR_Coverage, 24989,
     /* 1966060 */     GIR_EraseRootFromParent_Done,
     /* 1966061 */   // Label 26352: @1966061
     /* 1966061 */   GIM_Try, /*On fail goto*//*Label 26353*/ GIMT_Encode4(1966147), // Rule ID 24992 //
     /* 1966066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1966069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1966074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1966077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1966080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1966083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1966086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1966089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966112 */     // MIs[0] policy
     /* 1966112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966122 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1966125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966146 */     // GIR_Coverage, 24992,
     /* 1966146 */     GIR_EraseRootFromParent_Done,
     /* 1966147 */   // Label 26353: @1966147
     /* 1966147 */   GIM_Try, /*On fail goto*//*Label 26354*/ GIMT_Encode4(1966233), // Rule ID 24993 //
     /* 1966152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1966155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1966160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1966163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1966166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1966169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1966175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966198 */     // MIs[0] policy
     /* 1966198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966208 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1966211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966232 */     // GIR_Coverage, 24993,
     /* 1966232 */     GIR_EraseRootFromParent_Done,
     /* 1966233 */   // Label 26354: @1966233
     /* 1966233 */   GIM_Try, /*On fail goto*//*Label 26355*/ GIMT_Encode4(1966319), // Rule ID 25020 //
     /* 1966238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1966241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1966246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1966249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1966252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966284 */     // MIs[0] policy
     /* 1966284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966294 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1966297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966318 */     // GIR_Coverage, 25020,
     /* 1966318 */     GIR_EraseRootFromParent_Done,
     /* 1966319 */   // Label 26355: @1966319
     /* 1966319 */   GIM_Try, /*On fail goto*//*Label 26356*/ GIMT_Encode4(1966405), // Rule ID 25021 //
     /* 1966324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1966327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1966332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1966335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1966338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966370 */     // MIs[0] policy
     /* 1966370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966380 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1966383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966404 */     // GIR_Coverage, 25021,
     /* 1966404 */     GIR_EraseRootFromParent_Done,
     /* 1966405 */   // Label 26356: @1966405
     /* 1966405 */   GIM_Try, /*On fail goto*//*Label 26357*/ GIMT_Encode4(1966491), // Rule ID 25024 //
     /* 1966410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1966413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1966418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1966421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1966424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1966427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1966430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966456 */     // MIs[0] policy
     /* 1966456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966466 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1966469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966490 */     // GIR_Coverage, 25024,
     /* 1966490 */     GIR_EraseRootFromParent_Done,
     /* 1966491 */   // Label 26357: @1966491
     /* 1966491 */   GIM_Try, /*On fail goto*//*Label 26358*/ GIMT_Encode4(1966577), // Rule ID 25025 //
     /* 1966496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1966499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1966504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1966507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1966510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1966513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1966516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966542 */     // MIs[0] policy
     /* 1966542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966552 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1966555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966576 */     // GIR_Coverage, 25025,
     /* 1966576 */     GIR_EraseRootFromParent_Done,
     /* 1966577 */   // Label 26358: @1966577
     /* 1966577 */   GIM_Try, /*On fail goto*//*Label 26359*/ GIMT_Encode4(1966663), // Rule ID 25028 //
     /* 1966582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1966585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1966590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1966593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1966596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1966599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966628 */     // MIs[0] policy
     /* 1966628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966638 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1966641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1966659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966662 */     // GIR_Coverage, 25028,
     /* 1966662 */     GIR_EraseRootFromParent_Done,
     /* 1966663 */   // Label 26359: @1966663
     /* 1966663 */   GIM_Try, /*On fail goto*//*Label 26360*/ GIMT_Encode4(1966749), // Rule ID 25029 //
     /* 1966668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1966671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1966676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1966679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1966682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1966685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966714 */     // MIs[0] policy
     /* 1966714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966724 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1966727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1966745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966748 */     // GIR_Coverage, 25029,
     /* 1966748 */     GIR_EraseRootFromParent_Done,
     /* 1966749 */   // Label 26360: @1966749
     /* 1966749 */   GIM_Try, /*On fail goto*//*Label 26361*/ GIMT_Encode4(1966835), // Rule ID 25032 //
     /* 1966754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1966757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1966762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1966765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1966768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1966771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1966774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966800 */     // MIs[0] policy
     /* 1966800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966810 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1966813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966834 */     // GIR_Coverage, 25032,
     /* 1966834 */     GIR_EraseRootFromParent_Done,
     /* 1966835 */   // Label 26361: @1966835
     /* 1966835 */   GIM_Try, /*On fail goto*//*Label 26362*/ GIMT_Encode4(1966921), // Rule ID 25033 //
     /* 1966840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1966843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1966848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1966851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1966854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1966857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1966860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966886 */     // MIs[0] policy
     /* 1966886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966896 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1966899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966920 */     // GIR_Coverage, 25033,
     /* 1966920 */     GIR_EraseRootFromParent_Done,
     /* 1966921 */   // Label 26362: @1966921
     /* 1966921 */   GIM_Try, /*On fail goto*//*Label 26363*/ GIMT_Encode4(1967007), // Rule ID 25036 //
     /* 1966926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1966929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1966934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1966937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1966940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1966943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1966946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966972 */     // MIs[0] policy
     /* 1966972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966982 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1966985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967006 */     // GIR_Coverage, 25036,
     /* 1967006 */     GIR_EraseRootFromParent_Done,
     /* 1967007 */   // Label 26363: @1967007
     /* 1967007 */   GIM_Try, /*On fail goto*//*Label 26364*/ GIMT_Encode4(1967093), // Rule ID 25037 //
     /* 1967012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1967015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1967020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1967023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1967026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1967029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1967032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967058 */     // MIs[0] policy
     /* 1967058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967068 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1967071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967092 */     // GIR_Coverage, 25037,
     /* 1967092 */     GIR_EraseRootFromParent_Done,
     /* 1967093 */   // Label 26364: @1967093
     /* 1967093 */   GIM_Try, /*On fail goto*//*Label 26365*/ GIMT_Encode4(1967179), // Rule ID 25040 //
     /* 1967098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1967101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1967106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1967109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1967112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1967115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1967118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967144 */     // MIs[0] policy
     /* 1967144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967154 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1967157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1967175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967178 */     // GIR_Coverage, 25040,
     /* 1967178 */     GIR_EraseRootFromParent_Done,
     /* 1967179 */   // Label 26365: @1967179
     /* 1967179 */   GIM_Try, /*On fail goto*//*Label 26366*/ GIMT_Encode4(1967265), // Rule ID 25041 //
     /* 1967184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1967187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1967192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1967195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1967198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1967201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1967204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967230 */     // MIs[0] policy
     /* 1967230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967240 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1967243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1967261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967264 */     // GIR_Coverage, 25041,
     /* 1967264 */     GIR_EraseRootFromParent_Done,
     /* 1967265 */   // Label 26366: @1967265
     /* 1967265 */   GIM_Try, /*On fail goto*//*Label 26367*/ GIMT_Encode4(1967351), // Rule ID 25044 //
     /* 1967270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1967273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1967278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1967281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1967284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1967287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1967290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967316 */     // MIs[0] policy
     /* 1967316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967326 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1967329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967350 */     // GIR_Coverage, 25044,
     /* 1967350 */     GIR_EraseRootFromParent_Done,
     /* 1967351 */   // Label 26367: @1967351
     /* 1967351 */   GIM_Try, /*On fail goto*//*Label 26368*/ GIMT_Encode4(1967437), // Rule ID 25045 //
     /* 1967356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1967359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1967364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1967367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1967370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1967373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1967376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967402 */     // MIs[0] policy
     /* 1967402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967412 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1967415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967436 */     // GIR_Coverage, 25045,
     /* 1967436 */     GIR_EraseRootFromParent_Done,
     /* 1967437 */   // Label 26368: @1967437
     /* 1967437 */   GIM_Try, /*On fail goto*//*Label 26369*/ GIMT_Encode4(1967523), // Rule ID 25048 //
     /* 1967442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1967445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1967450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1967453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1967456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1967459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1967462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1967465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967488 */     // MIs[0] policy
     /* 1967488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967498 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1967501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967522 */     // GIR_Coverage, 25048,
     /* 1967522 */     GIR_EraseRootFromParent_Done,
     /* 1967523 */   // Label 26369: @1967523
     /* 1967523 */   GIM_Try, /*On fail goto*//*Label 26370*/ GIMT_Encode4(1967609), // Rule ID 25049 //
     /* 1967528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1967531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1967536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1967539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1967542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1967545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1967548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1967551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967574 */     // MIs[0] policy
     /* 1967574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967584 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1967587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967608 */     // GIR_Coverage, 25049,
     /* 1967608 */     GIR_EraseRootFromParent_Done,
     /* 1967609 */   // Label 26370: @1967609
     /* 1967609 */   GIM_Try, /*On fail goto*//*Label 26371*/ GIMT_Encode4(1967695), // Rule ID 25052 //
     /* 1967614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1967617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1967622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1967625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1967628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1967631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1967634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1967637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967660 */     // MIs[0] policy
     /* 1967660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967670 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1967673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967694 */     // GIR_Coverage, 25052,
     /* 1967694 */     GIR_EraseRootFromParent_Done,
     /* 1967695 */   // Label 26371: @1967695
     /* 1967695 */   GIM_Try, /*On fail goto*//*Label 26372*/ GIMT_Encode4(1967781), // Rule ID 25053 //
     /* 1967700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1967703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1967708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1967711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1967714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1967717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1967720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1967723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967746 */     // MIs[0] policy
     /* 1967746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967756 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1967759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967780 */     // GIR_Coverage, 25053,
     /* 1967780 */     GIR_EraseRootFromParent_Done,
     /* 1967781 */   // Label 26372: @1967781
     /* 1967781 */   GIM_Try, /*On fail goto*//*Label 26373*/ GIMT_Encode4(1967867), // Rule ID 25056 //
     /* 1967786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1967789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1967794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1967797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1967800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1967806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967832 */     // MIs[0] policy
     /* 1967832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967842 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1967845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967866 */     // GIR_Coverage, 25056,
     /* 1967866 */     GIR_EraseRootFromParent_Done,
     /* 1967867 */   // Label 26373: @1967867
     /* 1967867 */   GIM_Try, /*On fail goto*//*Label 26374*/ GIMT_Encode4(1967953), // Rule ID 25057 //
     /* 1967872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1967875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1967880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1967883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1967886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1967892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967918 */     // MIs[0] policy
     /* 1967918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967928 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1967931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967952 */     // GIR_Coverage, 25057,
     /* 1967952 */     GIR_EraseRootFromParent_Done,
     /* 1967953 */   // Label 26374: @1967953
     /* 1967953 */   GIM_Try, /*On fail goto*//*Label 26375*/ GIMT_Encode4(1968039), // Rule ID 25060 //
     /* 1967958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1967961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1967966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1967969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1967972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1967975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1967978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968004 */     // MIs[0] policy
     /* 1968004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968014 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1968017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1968035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968038 */     // GIR_Coverage, 25060,
     /* 1968038 */     GIR_EraseRootFromParent_Done,
     /* 1968039 */   // Label 26375: @1968039
     /* 1968039 */   GIM_Try, /*On fail goto*//*Label 26376*/ GIMT_Encode4(1968125), // Rule ID 25061 //
     /* 1968044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1968047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1968052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1968055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1968058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1968061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1968064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968090 */     // MIs[0] policy
     /* 1968090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968100 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1968103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1968121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968124 */     // GIR_Coverage, 25061,
     /* 1968124 */     GIR_EraseRootFromParent_Done,
     /* 1968125 */   // Label 26376: @1968125
     /* 1968125 */   GIM_Try, /*On fail goto*//*Label 26377*/ GIMT_Encode4(1968211), // Rule ID 25064 //
     /* 1968130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1968133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1968138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1968141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1968144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1968147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1968150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968176 */     // MIs[0] policy
     /* 1968176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968186 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1968189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1968207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968210 */     // GIR_Coverage, 25064,
     /* 1968210 */     GIR_EraseRootFromParent_Done,
     /* 1968211 */   // Label 26377: @1968211
     /* 1968211 */   GIM_Try, /*On fail goto*//*Label 26378*/ GIMT_Encode4(1968297), // Rule ID 25065 //
     /* 1968216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1968219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1968224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1968227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1968230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1968233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1968236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968262 */     // MIs[0] policy
     /* 1968262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968272 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1968275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1968293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968296 */     // GIR_Coverage, 25065,
     /* 1968296 */     GIR_EraseRootFromParent_Done,
     /* 1968297 */   // Label 26378: @1968297
     /* 1968297 */   GIM_Try, /*On fail goto*//*Label 26379*/ GIMT_Encode4(1968383), // Rule ID 25068 //
     /* 1968302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1968305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1968310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1968313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1968316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1968319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1968322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968348 */     // MIs[0] policy
     /* 1968348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968358 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1968361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968382 */     // GIR_Coverage, 25068,
     /* 1968382 */     GIR_EraseRootFromParent_Done,
     /* 1968383 */   // Label 26379: @1968383
     /* 1968383 */   GIM_Try, /*On fail goto*//*Label 26380*/ GIMT_Encode4(1968469), // Rule ID 25069 //
     /* 1968388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1968391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1968396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1968399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1968402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1968405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1968408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968434 */     // MIs[0] policy
     /* 1968434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968444 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1968447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968468 */     // GIR_Coverage, 25069,
     /* 1968468 */     GIR_EraseRootFromParent_Done,
     /* 1968469 */   // Label 26380: @1968469
     /* 1968469 */   GIM_Try, /*On fail goto*//*Label 26381*/ GIMT_Encode4(1968555), // Rule ID 25072 //
     /* 1968474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1968477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1968482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1968485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1968488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1968491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1968494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968520 */     // MIs[0] policy
     /* 1968520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968530 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1968533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968554 */     // GIR_Coverage, 25072,
     /* 1968554 */     GIR_EraseRootFromParent_Done,
     /* 1968555 */   // Label 26381: @1968555
     /* 1968555 */   GIM_Try, /*On fail goto*//*Label 26382*/ GIMT_Encode4(1968641), // Rule ID 25073 //
     /* 1968560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1968563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1968568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1968571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1968574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1968577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1968580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968606 */     // MIs[0] policy
     /* 1968606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968616 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1968619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968640 */     // GIR_Coverage, 25073,
     /* 1968640 */     GIR_EraseRootFromParent_Done,
     /* 1968641 */   // Label 26382: @1968641
     /* 1968641 */   GIM_Try, /*On fail goto*//*Label 26383*/ GIMT_Encode4(1968727), // Rule ID 25076 //
     /* 1968646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1968649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1968654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1968657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1968660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1968663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1968666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968692 */     // MIs[0] policy
     /* 1968692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968702 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1968705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968726 */     // GIR_Coverage, 25076,
     /* 1968726 */     GIR_EraseRootFromParent_Done,
     /* 1968727 */   // Label 26383: @1968727
     /* 1968727 */   GIM_Try, /*On fail goto*//*Label 26384*/ GIMT_Encode4(1968813), // Rule ID 25077 //
     /* 1968732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1968735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1968740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1968743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1968746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1968749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1968752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968778 */     // MIs[0] policy
     /* 1968778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968788 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1968791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968812 */     // GIR_Coverage, 25077,
     /* 1968812 */     GIR_EraseRootFromParent_Done,
     /* 1968813 */   // Label 26384: @1968813
     /* 1968813 */   GIM_Try, /*On fail goto*//*Label 26385*/ GIMT_Encode4(1968899), // Rule ID 60964 //
     /* 1968818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1968829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1968832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1968835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1968838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968864 */     // MIs[0] policy
     /* 1968864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968874 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1968877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968898 */     // GIR_Coverage, 60964,
     /* 1968898 */     GIR_EraseRootFromParent_Done,
     /* 1968899 */   // Label 26385: @1968899
     /* 1968899 */   GIM_Try, /*On fail goto*//*Label 26386*/ GIMT_Encode4(1968985), // Rule ID 60965 //
     /* 1968904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1968915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1968918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1968921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1968924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968950 */     // MIs[0] policy
     /* 1968950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968960 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1968963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968984 */     // GIR_Coverage, 60965,
     /* 1968984 */     GIR_EraseRootFromParent_Done,
     /* 1968985 */   // Label 26386: @1968985
     /* 1968985 */   GIM_Try, /*On fail goto*//*Label 26387*/ GIMT_Encode4(1969071), // Rule ID 60968 //
     /* 1968990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1969001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1969004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1969007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1969010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969036 */     // MIs[0] policy
     /* 1969036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969046 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1969049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969070 */     // GIR_Coverage, 60968,
     /* 1969070 */     GIR_EraseRootFromParent_Done,
     /* 1969071 */   // Label 26387: @1969071
     /* 1969071 */   GIM_Try, /*On fail goto*//*Label 26388*/ GIMT_Encode4(1969157), // Rule ID 60969 //
     /* 1969076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1969087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1969090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1969093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1969096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969122 */     // MIs[0] policy
     /* 1969122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969132 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1969135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969156 */     // GIR_Coverage, 60969,
     /* 1969156 */     GIR_EraseRootFromParent_Done,
     /* 1969157 */   // Label 26388: @1969157
     /* 1969157 */   GIM_Try, /*On fail goto*//*Label 26389*/ GIMT_Encode4(1969243), // Rule ID 60972 //
     /* 1969162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1969173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1969176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1969179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1969182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969208 */     // MIs[0] policy
     /* 1969208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969218 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1969221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969242 */     // GIR_Coverage, 60972,
     /* 1969242 */     GIR_EraseRootFromParent_Done,
     /* 1969243 */   // Label 26389: @1969243
     /* 1969243 */   GIM_Try, /*On fail goto*//*Label 26390*/ GIMT_Encode4(1969329), // Rule ID 60973 //
     /* 1969248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1969259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1969262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1969265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1969268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969294 */     // MIs[0] policy
     /* 1969294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969304 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1969307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969328 */     // GIR_Coverage, 60973,
     /* 1969328 */     GIR_EraseRootFromParent_Done,
     /* 1969329 */   // Label 26390: @1969329
     /* 1969329 */   GIM_Try, /*On fail goto*//*Label 26391*/ GIMT_Encode4(1969415), // Rule ID 60976 //
     /* 1969334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1969345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1969348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1969351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1969354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969380 */     // MIs[0] policy
     /* 1969380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969390 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1969393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969414 */     // GIR_Coverage, 60976,
     /* 1969414 */     GIR_EraseRootFromParent_Done,
     /* 1969415 */   // Label 26391: @1969415
     /* 1969415 */   GIM_Try, /*On fail goto*//*Label 26392*/ GIMT_Encode4(1969501), // Rule ID 60977 //
     /* 1969420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1969431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1969434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1969437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1969440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969466 */     // MIs[0] policy
     /* 1969466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1969479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969500 */     // GIR_Coverage, 60977,
     /* 1969500 */     GIR_EraseRootFromParent_Done,
     /* 1969501 */   // Label 26392: @1969501
     /* 1969501 */   GIM_Try, /*On fail goto*//*Label 26393*/ GIMT_Encode4(1969587), // Rule ID 60980 //
     /* 1969506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1969517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1969520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1969523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1969526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1969529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969552 */     // MIs[0] policy
     /* 1969552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969562 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1969565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969586 */     // GIR_Coverage, 60980,
     /* 1969586 */     GIR_EraseRootFromParent_Done,
     /* 1969587 */   // Label 26393: @1969587
     /* 1969587 */   GIM_Try, /*On fail goto*//*Label 26394*/ GIMT_Encode4(1969673), // Rule ID 60981 //
     /* 1969592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1969603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1969606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1969609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1969612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1969615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969638 */     // MIs[0] policy
     /* 1969638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969648 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1969651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969672 */     // GIR_Coverage, 60981,
     /* 1969672 */     GIR_EraseRootFromParent_Done,
     /* 1969673 */   // Label 26394: @1969673
     /* 1969673 */   GIM_Try, /*On fail goto*//*Label 26395*/ GIMT_Encode4(1969759), // Rule ID 60984 //
     /* 1969678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1969689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1969692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1969695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1969698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1969701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969724 */     // MIs[0] policy
     /* 1969724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969734 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1969737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969758 */     // GIR_Coverage, 60984,
     /* 1969758 */     GIR_EraseRootFromParent_Done,
     /* 1969759 */   // Label 26395: @1969759
     /* 1969759 */   GIM_Try, /*On fail goto*//*Label 26396*/ GIMT_Encode4(1969845), // Rule ID 60985 //
     /* 1969764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1969775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1969778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1969781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1969784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1969787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969810 */     // MIs[0] policy
     /* 1969810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969820 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1969823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969844 */     // GIR_Coverage, 60985,
     /* 1969844 */     GIR_EraseRootFromParent_Done,
     /* 1969845 */   // Label 26396: @1969845
     /* 1969845 */   GIM_Try, /*On fail goto*//*Label 26397*/ GIMT_Encode4(1969931), // Rule ID 60988 //
     /* 1969850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1969861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1969864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1969867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1969870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969896 */     // MIs[0] policy
     /* 1969896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969906 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1969909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969930 */     // GIR_Coverage, 60988,
     /* 1969930 */     GIR_EraseRootFromParent_Done,
     /* 1969931 */   // Label 26397: @1969931
     /* 1969931 */   GIM_Try, /*On fail goto*//*Label 26398*/ GIMT_Encode4(1970017), // Rule ID 60989 //
     /* 1969936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1969947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1969950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1969953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1969956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969982 */     // MIs[0] policy
     /* 1969982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969992 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1969995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970016 */     // GIR_Coverage, 60989,
     /* 1970016 */     GIR_EraseRootFromParent_Done,
     /* 1970017 */   // Label 26398: @1970017
     /* 1970017 */   GIM_Try, /*On fail goto*//*Label 26399*/ GIMT_Encode4(1970103), // Rule ID 60992 //
     /* 1970022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1970025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1970033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1970036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1970039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1970042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970068 */     // MIs[0] policy
     /* 1970068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970078 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1970081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970102 */     // GIR_Coverage, 60992,
     /* 1970102 */     GIR_EraseRootFromParent_Done,
     /* 1970103 */   // Label 26399: @1970103
     /* 1970103 */   GIM_Try, /*On fail goto*//*Label 26400*/ GIMT_Encode4(1970189), // Rule ID 60993 //
     /* 1970108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1970119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1970122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1970125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1970128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970154 */     // MIs[0] policy
     /* 1970154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1970167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970188 */     // GIR_Coverage, 60993,
     /* 1970188 */     GIR_EraseRootFromParent_Done,
     /* 1970189 */   // Label 26400: @1970189
     /* 1970189 */   GIM_Try, /*On fail goto*//*Label 26401*/ GIMT_Encode4(1970275), // Rule ID 60996 //
     /* 1970194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1970197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1970205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1970208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1970211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1970214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970240 */     // MIs[0] policy
     /* 1970240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1970253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970274 */     // GIR_Coverage, 60996,
     /* 1970274 */     GIR_EraseRootFromParent_Done,
     /* 1970275 */   // Label 26401: @1970275
     /* 1970275 */   GIM_Try, /*On fail goto*//*Label 26402*/ GIMT_Encode4(1970361), // Rule ID 60997 //
     /* 1970280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1970291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1970294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1970297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1970300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970326 */     // MIs[0] policy
     /* 1970326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1970339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970360 */     // GIR_Coverage, 60997,
     /* 1970360 */     GIR_EraseRootFromParent_Done,
     /* 1970361 */   // Label 26402: @1970361
     /* 1970361 */   GIM_Try, /*On fail goto*//*Label 26403*/ GIMT_Encode4(1970447), // Rule ID 61000 //
     /* 1970366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1970369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1970377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1970380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1970383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1970386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970412 */     // MIs[0] policy
     /* 1970412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1970425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970446 */     // GIR_Coverage, 61000,
     /* 1970446 */     GIR_EraseRootFromParent_Done,
     /* 1970447 */   // Label 26403: @1970447
     /* 1970447 */   GIM_Try, /*On fail goto*//*Label 26404*/ GIMT_Encode4(1970533), // Rule ID 61001 //
     /* 1970452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1970463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1970466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1970469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1970472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970498 */     // MIs[0] policy
     /* 1970498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970508 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1970511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970532 */     // GIR_Coverage, 61001,
     /* 1970532 */     GIR_EraseRootFromParent_Done,
     /* 1970533 */   // Label 26404: @1970533
     /* 1970533 */   GIM_Try, /*On fail goto*//*Label 26405*/ GIMT_Encode4(1970619), // Rule ID 61004 //
     /* 1970538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1970541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1970549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1970552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1970555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1970558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1970561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970584 */     // MIs[0] policy
     /* 1970584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970594 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1970597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970618 */     // GIR_Coverage, 61004,
     /* 1970618 */     GIR_EraseRootFromParent_Done,
     /* 1970619 */   // Label 26405: @1970619
     /* 1970619 */   GIM_Try, /*On fail goto*//*Label 26406*/ GIMT_Encode4(1970705), // Rule ID 61005 //
     /* 1970624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1970635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1970638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1970641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1970644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1970647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970670 */     // MIs[0] policy
     /* 1970670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970680 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1970683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970704 */     // GIR_Coverage, 61005,
     /* 1970704 */     GIR_EraseRootFromParent_Done,
     /* 1970705 */   // Label 26406: @1970705
     /* 1970705 */   GIM_Try, /*On fail goto*//*Label 26407*/ GIMT_Encode4(1970791), // Rule ID 61008 //
     /* 1970710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1970713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1970727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1970730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970756 */     // MIs[0] policy
     /* 1970756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970766 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1970769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970790 */     // GIR_Coverage, 61008,
     /* 1970790 */     GIR_EraseRootFromParent_Done,
     /* 1970791 */   // Label 26407: @1970791
     /* 1970791 */   GIM_Try, /*On fail goto*//*Label 26408*/ GIMT_Encode4(1970877), // Rule ID 61009 //
     /* 1970796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1970813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1970816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970842 */     // MIs[0] policy
     /* 1970842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1970855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970876 */     // GIR_Coverage, 61009,
     /* 1970876 */     GIR_EraseRootFromParent_Done,
     /* 1970877 */   // Label 26408: @1970877
     /* 1970877 */   GIM_Try, /*On fail goto*//*Label 26409*/ GIMT_Encode4(1970963), // Rule ID 61012 //
     /* 1970882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1970885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1970899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1970902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970928 */     // MIs[0] policy
     /* 1970928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970938 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1970941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970962 */     // GIR_Coverage, 61012,
     /* 1970962 */     GIR_EraseRootFromParent_Done,
     /* 1970963 */   // Label 26409: @1970963
     /* 1970963 */   GIM_Try, /*On fail goto*//*Label 26410*/ GIMT_Encode4(1971049), // Rule ID 61013 //
     /* 1970968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1970985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1970988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971014 */     // MIs[0] policy
     /* 1971014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1971027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1971045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971048 */     // GIR_Coverage, 61013,
     /* 1971048 */     GIR_EraseRootFromParent_Done,
     /* 1971049 */   // Label 26410: @1971049
     /* 1971049 */   GIM_Try, /*On fail goto*//*Label 26411*/ GIMT_Encode4(1971135), // Rule ID 61016 //
     /* 1971054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1971057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1971062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1971071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1971074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971100 */     // MIs[0] policy
     /* 1971100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971110 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1971113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1971131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971134 */     // GIR_Coverage, 61016,
     /* 1971134 */     GIR_EraseRootFromParent_Done,
     /* 1971135 */   // Label 26411: @1971135
     /* 1971135 */   GIM_Try, /*On fail goto*//*Label 26412*/ GIMT_Encode4(1971221), // Rule ID 61017 //
     /* 1971140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1971143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1971148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1971157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1971160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971186 */     // MIs[0] policy
     /* 1971186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1971199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1971217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971220 */     // GIR_Coverage, 61017,
     /* 1971220 */     GIR_EraseRootFromParent_Done,
     /* 1971221 */   // Label 26412: @1971221
     /* 1971221 */   GIM_Try, /*On fail goto*//*Label 26413*/ GIMT_Encode4(1971307), // Rule ID 61020 //
     /* 1971226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1971229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1971234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1971243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1971246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971272 */     // MIs[0] policy
     /* 1971272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971282 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1971285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1971303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971306 */     // GIR_Coverage, 61020,
     /* 1971306 */     GIR_EraseRootFromParent_Done,
     /* 1971307 */   // Label 26413: @1971307
     /* 1971307 */   GIM_Try, /*On fail goto*//*Label 26414*/ GIMT_Encode4(1971393), // Rule ID 61021 //
     /* 1971312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1971315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1971320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1971329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1971332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971358 */     // MIs[0] policy
     /* 1971358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1971371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1971389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971392 */     // GIR_Coverage, 61021,
     /* 1971392 */     GIR_EraseRootFromParent_Done,
     /* 1971393 */   // Label 26414: @1971393
     /* 1971393 */   GIM_Try, /*On fail goto*//*Label 26415*/ GIMT_Encode4(1971479), // Rule ID 61024 //
     /* 1971398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1971401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1971406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1971409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1971412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1971415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971444 */     // MIs[0] policy
     /* 1971444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971454 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1971457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971478 */     // GIR_Coverage, 61024,
     /* 1971478 */     GIR_EraseRootFromParent_Done,
     /* 1971479 */   // Label 26415: @1971479
     /* 1971479 */   GIM_Try, /*On fail goto*//*Label 26416*/ GIMT_Encode4(1971565), // Rule ID 61025 //
     /* 1971484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1971487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1971492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1971495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1971498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1971501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971530 */     // MIs[0] policy
     /* 1971530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971540 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1971543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971564 */     // GIR_Coverage, 61025,
     /* 1971564 */     GIR_EraseRootFromParent_Done,
     /* 1971565 */   // Label 26416: @1971565
     /* 1971565 */   GIM_Try, /*On fail goto*//*Label 26417*/ GIMT_Encode4(1971651), // Rule ID 61032 //
     /* 1971570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1971573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1971578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1971581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1971584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1971587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971616 */     // MIs[0] policy
     /* 1971616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971626 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1971629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971650 */     // GIR_Coverage, 61032,
     /* 1971650 */     GIR_EraseRootFromParent_Done,
     /* 1971651 */   // Label 26417: @1971651
     /* 1971651 */   GIM_Try, /*On fail goto*//*Label 26418*/ GIMT_Encode4(1971737), // Rule ID 61033 //
     /* 1971656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1971659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1971664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1971667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1971670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1971673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971702 */     // MIs[0] policy
     /* 1971702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971712 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1971715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971736 */     // GIR_Coverage, 61033,
     /* 1971736 */     GIR_EraseRootFromParent_Done,
     /* 1971737 */   // Label 26418: @1971737
     /* 1971737 */   GIM_Try, /*On fail goto*//*Label 26419*/ GIMT_Encode4(1971823), // Rule ID 61040 //
     /* 1971742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1971745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1971750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1971753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1971756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1971759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971788 */     // MIs[0] policy
     /* 1971788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971798 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1971801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971822 */     // GIR_Coverage, 61040,
     /* 1971822 */     GIR_EraseRootFromParent_Done,
     /* 1971823 */   // Label 26419: @1971823
     /* 1971823 */   GIM_Try, /*On fail goto*//*Label 26420*/ GIMT_Encode4(1971909), // Rule ID 61041 //
     /* 1971828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1971831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1971836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1971839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1971842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1971845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971874 */     // MIs[0] policy
     /* 1971874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971884 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1971887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971908 */     // GIR_Coverage, 61041,
     /* 1971908 */     GIR_EraseRootFromParent_Done,
     /* 1971909 */   // Label 26420: @1971909
     /* 1971909 */   GIM_Try, /*On fail goto*//*Label 26421*/ GIMT_Encode4(1971995), // Rule ID 61048 //
     /* 1971914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1971917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1971922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1971925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1971928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1971931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971960 */     // MIs[0] policy
     /* 1971960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971970 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1971973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971994 */     // GIR_Coverage, 61048,
     /* 1971994 */     GIR_EraseRootFromParent_Done,
     /* 1971995 */   // Label 26421: @1971995
     /* 1971995 */   GIM_Try, /*On fail goto*//*Label 26422*/ GIMT_Encode4(1972081), // Rule ID 61049 //
     /* 1972000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1972003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1972008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1972011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1972014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1972017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972046 */     // MIs[0] policy
     /* 1972046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972056 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1972059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972080 */     // GIR_Coverage, 61049,
     /* 1972080 */     GIR_EraseRootFromParent_Done,
     /* 1972081 */   // Label 26422: @1972081
     /* 1972081 */   GIM_Try, /*On fail goto*//*Label 26423*/ GIMT_Encode4(1972167), // Rule ID 61056 //
     /* 1972086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1972089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1972094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1972097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1972100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1972103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1972109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972132 */     // MIs[0] policy
     /* 1972132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972142 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1972145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972166 */     // GIR_Coverage, 61056,
     /* 1972166 */     GIR_EraseRootFromParent_Done,
     /* 1972167 */   // Label 26423: @1972167
     /* 1972167 */   GIM_Try, /*On fail goto*//*Label 26424*/ GIMT_Encode4(1972253), // Rule ID 61057 //
     /* 1972172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1972175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1972180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1972183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1972186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1972189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1972195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972218 */     // MIs[0] policy
     /* 1972218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972228 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1972231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972252 */     // GIR_Coverage, 61057,
     /* 1972252 */     GIR_EraseRootFromParent_Done,
     /* 1972253 */   // Label 26424: @1972253
     /* 1972253 */   GIM_Try, /*On fail goto*//*Label 26425*/ GIMT_Encode4(1972339), // Rule ID 61064 //
     /* 1972258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1972261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1972266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1972269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1972272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1972275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1972281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972304 */     // MIs[0] policy
     /* 1972304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972314 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1972317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972338 */     // GIR_Coverage, 61064,
     /* 1972338 */     GIR_EraseRootFromParent_Done,
     /* 1972339 */   // Label 26425: @1972339
     /* 1972339 */   GIM_Try, /*On fail goto*//*Label 26426*/ GIMT_Encode4(1972425), // Rule ID 61065 //
     /* 1972344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1972347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1972352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1972355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1972358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1972361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1972367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972390 */     // MIs[0] policy
     /* 1972390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972400 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1972403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972424 */     // GIR_Coverage, 61065,
     /* 1972424 */     GIR_EraseRootFromParent_Done,
     /* 1972425 */   // Label 26426: @1972425
     /* 1972425 */   GIM_Try, /*On fail goto*//*Label 26427*/ GIMT_Encode4(1972511), // Rule ID 61072 //
     /* 1972430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1972433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1972438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1972441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1972444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1972447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972476 */     // MIs[0] policy
     /* 1972476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1972489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972510 */     // GIR_Coverage, 61072,
     /* 1972510 */     GIR_EraseRootFromParent_Done,
     /* 1972511 */   // Label 26427: @1972511
     /* 1972511 */   GIM_Try, /*On fail goto*//*Label 26428*/ GIMT_Encode4(1972597), // Rule ID 61073 //
     /* 1972516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1972519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1972524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1972527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1972530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1972533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972562 */     // MIs[0] policy
     /* 1972562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1972575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972596 */     // GIR_Coverage, 61073,
     /* 1972596 */     GIR_EraseRootFromParent_Done,
     /* 1972597 */   // Label 26428: @1972597
     /* 1972597 */   GIM_Try, /*On fail goto*//*Label 26429*/ GIMT_Encode4(1972683), // Rule ID 61080 //
     /* 1972602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1972605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1972610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1972613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1972616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1972619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972648 */     // MIs[0] policy
     /* 1972648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1972661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972682 */     // GIR_Coverage, 61080,
     /* 1972682 */     GIR_EraseRootFromParent_Done,
     /* 1972683 */   // Label 26429: @1972683
     /* 1972683 */   GIM_Try, /*On fail goto*//*Label 26430*/ GIMT_Encode4(1972769), // Rule ID 61081 //
     /* 1972688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1972691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1972696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1972699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1972702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1972705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972734 */     // MIs[0] policy
     /* 1972734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1972747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972768 */     // GIR_Coverage, 61081,
     /* 1972768 */     GIR_EraseRootFromParent_Done,
     /* 1972769 */   // Label 26430: @1972769
     /* 1972769 */   GIM_Try, /*On fail goto*//*Label 26431*/ GIMT_Encode4(1972855), // Rule ID 61088 //
     /* 1972774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1972777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1972782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1972785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1972788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1972791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972820 */     // MIs[0] policy
     /* 1972820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1972833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972854 */     // GIR_Coverage, 61088,
     /* 1972854 */     GIR_EraseRootFromParent_Done,
     /* 1972855 */   // Label 26431: @1972855
     /* 1972855 */   GIM_Try, /*On fail goto*//*Label 26432*/ GIMT_Encode4(1972941), // Rule ID 61089 //
     /* 1972860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1972863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1972868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1972871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1972874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1972877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972906 */     // MIs[0] policy
     /* 1972906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1972919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972940 */     // GIR_Coverage, 61089,
     /* 1972940 */     GIR_EraseRootFromParent_Done,
     /* 1972941 */   // Label 26432: @1972941
     /* 1972941 */   GIM_Try, /*On fail goto*//*Label 26433*/ GIMT_Encode4(1973027), // Rule ID 61096 //
     /* 1972946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1972949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1972954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1972957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1972960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1972963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972992 */     // MIs[0] policy
     /* 1972992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1973005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973026 */     // GIR_Coverage, 61096,
     /* 1973026 */     GIR_EraseRootFromParent_Done,
     /* 1973027 */   // Label 26433: @1973027
     /* 1973027 */   GIM_Try, /*On fail goto*//*Label 26434*/ GIMT_Encode4(1973113), // Rule ID 61097 //
     /* 1973032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1973035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1973040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1973043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1973046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1973049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973078 */     // MIs[0] policy
     /* 1973078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973088 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1973091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973112 */     // GIR_Coverage, 61097,
     /* 1973112 */     GIR_EraseRootFromParent_Done,
     /* 1973113 */   // Label 26434: @1973113
     /* 1973113 */   GIM_Try, /*On fail goto*//*Label 26435*/ GIMT_Encode4(1973199), // Rule ID 61104 //
     /* 1973118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1973121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1973126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1973129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1973132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1973135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1973141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973164 */     // MIs[0] policy
     /* 1973164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1973177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973198 */     // GIR_Coverage, 61104,
     /* 1973198 */     GIR_EraseRootFromParent_Done,
     /* 1973199 */   // Label 26435: @1973199
     /* 1973199 */   GIM_Try, /*On fail goto*//*Label 26436*/ GIMT_Encode4(1973285), // Rule ID 61105 //
     /* 1973204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1973207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1973212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1973215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1973218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1973221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1973227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973250 */     // MIs[0] policy
     /* 1973250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973260 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1973263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973284 */     // GIR_Coverage, 61105,
     /* 1973284 */     GIR_EraseRootFromParent_Done,
     /* 1973285 */   // Label 26436: @1973285
     /* 1973285 */   GIM_Try, /*On fail goto*//*Label 26437*/ GIMT_Encode4(1973371), // Rule ID 61112 //
     /* 1973290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1973293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1973298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1973301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1973304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1973307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973336 */     // MIs[0] policy
     /* 1973336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973346 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1973349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973370 */     // GIR_Coverage, 61112,
     /* 1973370 */     GIR_EraseRootFromParent_Done,
     /* 1973371 */   // Label 26437: @1973371
     /* 1973371 */   GIM_Try, /*On fail goto*//*Label 26438*/ GIMT_Encode4(1973457), // Rule ID 61113 //
     /* 1973376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1973379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1973384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1973387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1973390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1973393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973422 */     // MIs[0] policy
     /* 1973422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973432 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1973435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973456 */     // GIR_Coverage, 61113,
     /* 1973456 */     GIR_EraseRootFromParent_Done,
     /* 1973457 */   // Label 26438: @1973457
     /* 1973457 */   GIM_Try, /*On fail goto*//*Label 26439*/ GIMT_Encode4(1973543), // Rule ID 61120 //
     /* 1973462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1973465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1973470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1973473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1973476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1973479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1973492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973508 */     // MIs[0] policy
     /* 1973508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973518 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1973521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973542 */     // GIR_Coverage, 61120,
     /* 1973542 */     GIR_EraseRootFromParent_Done,
     /* 1973543 */   // Label 26439: @1973543
     /* 1973543 */   GIM_Try, /*On fail goto*//*Label 26440*/ GIMT_Encode4(1973629), // Rule ID 61121 //
     /* 1973548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1973551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1973556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1973559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1973562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1973565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1973578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973594 */     // MIs[0] policy
     /* 1973594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973604 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1973607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973628 */     // GIR_Coverage, 61121,
     /* 1973628 */     GIR_EraseRootFromParent_Done,
     /* 1973629 */   // Label 26440: @1973629
     /* 1973629 */   GIM_Try, /*On fail goto*//*Label 26441*/ GIMT_Encode4(1973715), // Rule ID 61128 //
     /* 1973634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1973637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1973642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1973645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1973648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1973651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973680 */     // MIs[0] policy
     /* 1973680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973690 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1973693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973714 */     // GIR_Coverage, 61128,
     /* 1973714 */     GIR_EraseRootFromParent_Done,
     /* 1973715 */   // Label 26441: @1973715
     /* 1973715 */   GIM_Try, /*On fail goto*//*Label 26442*/ GIMT_Encode4(1973801), // Rule ID 61129 //
     /* 1973720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1973723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1973728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1973731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1973734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1973737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973766 */     // MIs[0] policy
     /* 1973766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973776 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1973779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973800 */     // GIR_Coverage, 61129,
     /* 1973800 */     GIR_EraseRootFromParent_Done,
     /* 1973801 */   // Label 26442: @1973801
     /* 1973801 */   GIM_Try, /*On fail goto*//*Label 26443*/ GIMT_Encode4(1973887), // Rule ID 61136 //
     /* 1973806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1973809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1973814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1973817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1973820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1973823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973852 */     // MIs[0] policy
     /* 1973852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973862 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1973865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973886 */     // GIR_Coverage, 61136,
     /* 1973886 */     GIR_EraseRootFromParent_Done,
     /* 1973887 */   // Label 26443: @1973887
     /* 1973887 */   GIM_Try, /*On fail goto*//*Label 26444*/ GIMT_Encode4(1973973), // Rule ID 61137 //
     /* 1973892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1973895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1973900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1973903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1973906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1973909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973938 */     // MIs[0] policy
     /* 1973938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973948 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1973951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973972 */     // GIR_Coverage, 61137,
     /* 1973972 */     GIR_EraseRootFromParent_Done,
     /* 1973973 */   // Label 26444: @1973973
     /* 1973973 */   GIM_Try, /*On fail goto*//*Label 26445*/ GIMT_Encode4(1974059), // Rule ID 61144 //
     /* 1973978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1973981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1973986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1973989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1973992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1973995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1973998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974024 */     // MIs[0] policy
     /* 1974024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974034 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1974037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974058 */     // GIR_Coverage, 61144,
     /* 1974058 */     GIR_EraseRootFromParent_Done,
     /* 1974059 */   // Label 26445: @1974059
     /* 1974059 */   GIM_Try, /*On fail goto*//*Label 26446*/ GIMT_Encode4(1974145), // Rule ID 61145 //
     /* 1974064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1974067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1974072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1974075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1974078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1974081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1974084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974110 */     // MIs[0] policy
     /* 1974110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1974123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974144 */     // GIR_Coverage, 61145,
     /* 1974144 */     GIR_EraseRootFromParent_Done,
     /* 1974145 */   // Label 26446: @1974145
     /* 1974145 */   GIM_Try, /*On fail goto*//*Label 26447*/ GIMT_Encode4(1974231), // Rule ID 61148 //
     /* 1974150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1974153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1974158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1974161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1974164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1974167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1974170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1974180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974196 */     // MIs[0] policy
     /* 1974196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974206 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1974209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974230 */     // GIR_Coverage, 61148,
     /* 1974230 */     GIR_EraseRootFromParent_Done,
     /* 1974231 */   // Label 26447: @1974231
     /* 1974231 */   GIM_Try, /*On fail goto*//*Label 26448*/ GIMT_Encode4(1974317), // Rule ID 61149 //
     /* 1974236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1974239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1974244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1974247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1974250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1974253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1974256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1974266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974282 */     // MIs[0] policy
     /* 1974282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1974295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974316 */     // GIR_Coverage, 61149,
     /* 1974316 */     GIR_EraseRootFromParent_Done,
     /* 1974317 */   // Label 26448: @1974317
     /* 1974317 */   GIM_Try, /*On fail goto*//*Label 26449*/ GIMT_Encode4(1974403), // Rule ID 61152 //
     /* 1974322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1974325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1974330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1974333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1974336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1974339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1974342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1974352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974368 */     // MIs[0] policy
     /* 1974368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974378 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1974381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974402 */     // GIR_Coverage, 61152,
     /* 1974402 */     GIR_EraseRootFromParent_Done,
     /* 1974403 */   // Label 26449: @1974403
     /* 1974403 */   GIM_Try, /*On fail goto*//*Label 26450*/ GIMT_Encode4(1974489), // Rule ID 61153 //
     /* 1974408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1974411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1974416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1974419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1974422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1974425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1974428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1974438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974454 */     // MIs[0] policy
     /* 1974454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974464 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1974467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974488 */     // GIR_Coverage, 61153,
     /* 1974488 */     GIR_EraseRootFromParent_Done,
     /* 1974489 */   // Label 26450: @1974489
     /* 1974489 */   GIM_Try, /*On fail goto*//*Label 26451*/ GIMT_Encode4(1974575), // Rule ID 61156 //
     /* 1974494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1974497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1974502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1974505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1974508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1974511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1974514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1974517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1974524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974540 */     // MIs[0] policy
     /* 1974540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974550 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1974553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974574 */     // GIR_Coverage, 61156,
     /* 1974574 */     GIR_EraseRootFromParent_Done,
     /* 1974575 */   // Label 26451: @1974575
     /* 1974575 */   GIM_Try, /*On fail goto*//*Label 26452*/ GIMT_Encode4(1974661), // Rule ID 61157 //
     /* 1974580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1974583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1974588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1974591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1974594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1974597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1974600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1974603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1974610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974626 */     // MIs[0] policy
     /* 1974626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974636 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1974639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974660 */     // GIR_Coverage, 61157,
     /* 1974660 */     GIR_EraseRootFromParent_Done,
     /* 1974661 */   // Label 26452: @1974661
     /* 1974661 */   GIM_Try, /*On fail goto*//*Label 26453*/ GIMT_Encode4(1974747), // Rule ID 61160 //
     /* 1974666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1974669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1974674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1974677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1974680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1974683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1974686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974712 */     // MIs[0] policy
     /* 1974712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974722 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1974725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974746 */     // GIR_Coverage, 61160,
     /* 1974746 */     GIR_EraseRootFromParent_Done,
     /* 1974747 */   // Label 26453: @1974747
     /* 1974747 */   GIM_Try, /*On fail goto*//*Label 26454*/ GIMT_Encode4(1974833), // Rule ID 61161 //
     /* 1974752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1974755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1974760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1974763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1974766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1974769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1974772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974798 */     // MIs[0] policy
     /* 1974798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1974811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974832 */     // GIR_Coverage, 61161,
     /* 1974832 */     GIR_EraseRootFromParent_Done,
     /* 1974833 */   // Label 26454: @1974833
     /* 1974833 */   GIM_Try, /*On fail goto*//*Label 26455*/ GIMT_Encode4(1974919), // Rule ID 61164 //
     /* 1974838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1974841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1974846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1974849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1974852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1974855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1974858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1974868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974884 */     // MIs[0] policy
     /* 1974884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1974897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974918 */     // GIR_Coverage, 61164,
     /* 1974918 */     GIR_EraseRootFromParent_Done,
     /* 1974919 */   // Label 26455: @1974919
     /* 1974919 */   GIM_Try, /*On fail goto*//*Label 26456*/ GIMT_Encode4(1975005), // Rule ID 61165 //
     /* 1974924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1974927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1974932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1974935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1974938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1974941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1974944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1974954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974970 */     // MIs[0] policy
     /* 1974970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974980 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1974983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975004 */     // GIR_Coverage, 61165,
     /* 1975004 */     GIR_EraseRootFromParent_Done,
     /* 1975005 */   // Label 26456: @1975005
     /* 1975005 */   GIM_Try, /*On fail goto*//*Label 26457*/ GIMT_Encode4(1975091), // Rule ID 61168 //
     /* 1975010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1975013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1975018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1975021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1975024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1975027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1975030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1975033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975056 */     // MIs[0] policy
     /* 1975056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1975069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975090 */     // GIR_Coverage, 61168,
     /* 1975090 */     GIR_EraseRootFromParent_Done,
     /* 1975091 */   // Label 26457: @1975091
     /* 1975091 */   GIM_Try, /*On fail goto*//*Label 26458*/ GIMT_Encode4(1975177), // Rule ID 61169 //
     /* 1975096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1975099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1975104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1975107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1975110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1975113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1975119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975142 */     // MIs[0] policy
     /* 1975142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975152 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1975155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975176 */     // GIR_Coverage, 61169,
     /* 1975176 */     GIR_EraseRootFromParent_Done,
     /* 1975177 */   // Label 26458: @1975177
     /* 1975177 */   GIM_Try, /*On fail goto*//*Label 26459*/ GIMT_Encode4(1975263), // Rule ID 61172 //
     /* 1975182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1975185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1975190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1975193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1975196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1975199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1975202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975228 */     // MIs[0] policy
     /* 1975228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975238 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1975241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975262 */     // GIR_Coverage, 61172,
     /* 1975262 */     GIR_EraseRootFromParent_Done,
     /* 1975263 */   // Label 26459: @1975263
     /* 1975263 */   GIM_Try, /*On fail goto*//*Label 26460*/ GIMT_Encode4(1975349), // Rule ID 61173 //
     /* 1975268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1975271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1975276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1975279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1975282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1975285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975314 */     // MIs[0] policy
     /* 1975314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975324 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1975327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975348 */     // GIR_Coverage, 61173,
     /* 1975348 */     GIR_EraseRootFromParent_Done,
     /* 1975349 */   // Label 26460: @1975349
     /* 1975349 */   GIM_Try, /*On fail goto*//*Label 26461*/ GIMT_Encode4(1975435), // Rule ID 61176 //
     /* 1975354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1975357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1975362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1975365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1975368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1975371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1975374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1975377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975400 */     // MIs[0] policy
     /* 1975400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975410 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1975413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975434 */     // GIR_Coverage, 61176,
     /* 1975434 */     GIR_EraseRootFromParent_Done,
     /* 1975435 */   // Label 26461: @1975435
     /* 1975435 */   GIM_Try, /*On fail goto*//*Label 26462*/ GIMT_Encode4(1975521), // Rule ID 61177 //
     /* 1975440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1975443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1975448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1975451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1975454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1975457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1975460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1975463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975486 */     // MIs[0] policy
     /* 1975486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975496 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1975499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975520 */     // GIR_Coverage, 61177,
     /* 1975520 */     GIR_EraseRootFromParent_Done,
     /* 1975521 */   // Label 26462: @1975521
     /* 1975521 */   GIM_Try, /*On fail goto*//*Label 26463*/ GIMT_Encode4(1975607), // Rule ID 61180 //
     /* 1975526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1975529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1975534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1975537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1975540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1975543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1975546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1975549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975572 */     // MIs[0] policy
     /* 1975572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975582 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1975585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975606 */     // GIR_Coverage, 61180,
     /* 1975606 */     GIR_EraseRootFromParent_Done,
     /* 1975607 */   // Label 26463: @1975607
     /* 1975607 */   GIM_Try, /*On fail goto*//*Label 26464*/ GIMT_Encode4(1975693), // Rule ID 61181 //
     /* 1975612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1975615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1975620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1975623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1975626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1975629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1975632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1975635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975658 */     // MIs[0] policy
     /* 1975658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1975671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975692 */     // GIR_Coverage, 61181,
     /* 1975692 */     GIR_EraseRootFromParent_Done,
     /* 1975693 */   // Label 26464: @1975693
     /* 1975693 */   GIM_Try, /*On fail goto*//*Label 26465*/ GIMT_Encode4(1975779), // Rule ID 61184 //
     /* 1975698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1975701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1975706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1975709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1975712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1975715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1975718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1975721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975744 */     // MIs[0] policy
     /* 1975744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975754 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1975757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975778 */     // GIR_Coverage, 61184,
     /* 1975778 */     GIR_EraseRootFromParent_Done,
     /* 1975779 */   // Label 26465: @1975779
     /* 1975779 */   GIM_Try, /*On fail goto*//*Label 26466*/ GIMT_Encode4(1975865), // Rule ID 61185 //
     /* 1975784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1975787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1975792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1975795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1975798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1975801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1975804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1975807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975830 */     // MIs[0] policy
     /* 1975830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975840 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1975843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975864 */     // GIR_Coverage, 61185,
     /* 1975864 */     GIR_EraseRootFromParent_Done,
     /* 1975865 */   // Label 26466: @1975865
     /* 1975865 */   GIM_Try, /*On fail goto*//*Label 26467*/ GIMT_Encode4(1975951), // Rule ID 61188 //
     /* 1975870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1975873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1975878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1975881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1975884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1975887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1975890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975916 */     // MIs[0] policy
     /* 1975916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975926 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1975929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975950 */     // GIR_Coverage, 61188,
     /* 1975950 */     GIR_EraseRootFromParent_Done,
     /* 1975951 */   // Label 26467: @1975951
     /* 1975951 */   GIM_Try, /*On fail goto*//*Label 26468*/ GIMT_Encode4(1976037), // Rule ID 61189 //
     /* 1975956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1975959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1975964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1975967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1975970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1975973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1975976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976002 */     // MIs[0] policy
     /* 1976002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976012 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1976015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976036 */     // GIR_Coverage, 61189,
     /* 1976036 */     GIR_EraseRootFromParent_Done,
     /* 1976037 */   // Label 26468: @1976037
     /* 1976037 */   GIM_Try, /*On fail goto*//*Label 26469*/ GIMT_Encode4(1976123), // Rule ID 61192 //
     /* 1976042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1976045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1976050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1976053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1976056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1976059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1976065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976088 */     // MIs[0] policy
     /* 1976088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976098 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1976101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976122 */     // GIR_Coverage, 61192,
     /* 1976122 */     GIR_EraseRootFromParent_Done,
     /* 1976123 */   // Label 26469: @1976123
     /* 1976123 */   GIM_Try, /*On fail goto*//*Label 26470*/ GIMT_Encode4(1976209), // Rule ID 61193 //
     /* 1976128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1976131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1976136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1976139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1976142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1976145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1976151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976174 */     // MIs[0] policy
     /* 1976174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976184 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1976187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976208 */     // GIR_Coverage, 61193,
     /* 1976208 */     GIR_EraseRootFromParent_Done,
     /* 1976209 */   // Label 26470: @1976209
     /* 1976209 */   GIM_Try, /*On fail goto*//*Label 26471*/ GIMT_Encode4(1976295), // Rule ID 61196 //
     /* 1976214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1976217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1976222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1976225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1976228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1976231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976260 */     // MIs[0] policy
     /* 1976260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976270 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1976273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976294 */     // GIR_Coverage, 61196,
     /* 1976294 */     GIR_EraseRootFromParent_Done,
     /* 1976295 */   // Label 26471: @1976295
     /* 1976295 */   GIM_Try, /*On fail goto*//*Label 26472*/ GIMT_Encode4(1976381), // Rule ID 61197 //
     /* 1976300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1976303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1976308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1976311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1976314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1976317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976346 */     // MIs[0] policy
     /* 1976346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976356 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1976359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976380 */     // GIR_Coverage, 61197,
     /* 1976380 */     GIR_EraseRootFromParent_Done,
     /* 1976381 */   // Label 26472: @1976381
     /* 1976381 */   GIM_Try, /*On fail goto*//*Label 26473*/ GIMT_Encode4(1976467), // Rule ID 61200 //
     /* 1976386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1976389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1976394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1976397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1976400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1976403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976432 */     // MIs[0] policy
     /* 1976432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976442 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1976445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976466 */     // GIR_Coverage, 61200,
     /* 1976466 */     GIR_EraseRootFromParent_Done,
     /* 1976467 */   // Label 26473: @1976467
     /* 1976467 */   GIM_Try, /*On fail goto*//*Label 26474*/ GIMT_Encode4(1976553), // Rule ID 61201 //
     /* 1976472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1976475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1976480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1976483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1976486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1976489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976518 */     // MIs[0] policy
     /* 1976518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976528 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1976531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976552 */     // GIR_Coverage, 61201,
     /* 1976552 */     GIR_EraseRootFromParent_Done,
     /* 1976553 */   // Label 26474: @1976553
     /* 1976553 */   GIM_Try, /*On fail goto*//*Label 26475*/ GIMT_Encode4(1976639), // Rule ID 61204 //
     /* 1976558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1976561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1976566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1976569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1976572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1976575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976604 */     // MIs[0] policy
     /* 1976604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976614 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1976617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976638 */     // GIR_Coverage, 61204,
     /* 1976638 */     GIR_EraseRootFromParent_Done,
     /* 1976639 */   // Label 26475: @1976639
     /* 1976639 */   GIM_Try, /*On fail goto*//*Label 26476*/ GIMT_Encode4(1976725), // Rule ID 61205 //
     /* 1976644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1976647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1976652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1976655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1976658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1976661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976690 */     // MIs[0] policy
     /* 1976690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976700 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1976703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976724 */     // GIR_Coverage, 61205,
     /* 1976724 */     GIR_EraseRootFromParent_Done,
     /* 1976725 */   // Label 26476: @1976725
     /* 1976725 */   GIM_Try, /*On fail goto*//*Label 26477*/ GIMT_Encode4(1976811), // Rule ID 61208 //
     /* 1976730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1976741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1976744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1976747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1976750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1976753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976776 */     // MIs[0] policy
     /* 1976776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976786 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1976789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976810 */     // GIR_Coverage, 61208,
     /* 1976810 */     GIR_EraseRootFromParent_Done,
     /* 1976811 */   // Label 26477: @1976811
     /* 1976811 */   GIM_Try, /*On fail goto*//*Label 26478*/ GIMT_Encode4(1976897), // Rule ID 61209 //
     /* 1976816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1976827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1976830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1976833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1976836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1976839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976862 */     // MIs[0] policy
     /* 1976862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976872 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1976875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976896 */     // GIR_Coverage, 61209,
     /* 1976896 */     GIR_EraseRootFromParent_Done,
     /* 1976897 */   // Label 26478: @1976897
     /* 1976897 */   GIM_Try, /*On fail goto*//*Label 26479*/ GIMT_Encode4(1976983), // Rule ID 61212 //
     /* 1976902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1976913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1976916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1976919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1976922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976948 */     // MIs[0] policy
     /* 1976948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976958 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1976961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976982 */     // GIR_Coverage, 61212,
     /* 1976982 */     GIR_EraseRootFromParent_Done,
     /* 1976983 */   // Label 26479: @1976983
     /* 1976983 */   GIM_Try, /*On fail goto*//*Label 26480*/ GIMT_Encode4(1977069), // Rule ID 61213 //
     /* 1976988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1976999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1977002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1977005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1977008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977034 */     // MIs[0] policy
     /* 1977034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977044 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1977047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977068 */     // GIR_Coverage, 61213,
     /* 1977068 */     GIR_EraseRootFromParent_Done,
     /* 1977069 */   // Label 26480: @1977069
     /* 1977069 */   GIM_Try, /*On fail goto*//*Label 26481*/ GIMT_Encode4(1977155), // Rule ID 61216 //
     /* 1977074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1977085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1977088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1977091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1977094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977120 */     // MIs[0] policy
     /* 1977120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977130 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1977133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977154 */     // GIR_Coverage, 61216,
     /* 1977154 */     GIR_EraseRootFromParent_Done,
     /* 1977155 */   // Label 26481: @1977155
     /* 1977155 */   GIM_Try, /*On fail goto*//*Label 26482*/ GIMT_Encode4(1977241), // Rule ID 61217 //
     /* 1977160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1977171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1977174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1977177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1977180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977206 */     // MIs[0] policy
     /* 1977206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977216 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1977219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977240 */     // GIR_Coverage, 61217,
     /* 1977240 */     GIR_EraseRootFromParent_Done,
     /* 1977241 */   // Label 26482: @1977241
     /* 1977241 */   GIM_Try, /*On fail goto*//*Label 26483*/ GIMT_Encode4(1977327), // Rule ID 61220 //
     /* 1977246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1977257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1977260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1977263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1977266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977292 */     // MIs[0] policy
     /* 1977292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977302 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1977305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977326 */     // GIR_Coverage, 61220,
     /* 1977326 */     GIR_EraseRootFromParent_Done,
     /* 1977327 */   // Label 26483: @1977327
     /* 1977327 */   GIM_Try, /*On fail goto*//*Label 26484*/ GIMT_Encode4(1977413), // Rule ID 61221 //
     /* 1977332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1977343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1977346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1977349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1977352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977378 */     // MIs[0] policy
     /* 1977378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977388 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1977391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977412 */     // GIR_Coverage, 61221,
     /* 1977412 */     GIR_EraseRootFromParent_Done,
     /* 1977413 */   // Label 26484: @1977413
     /* 1977413 */   GIM_Try, /*On fail goto*//*Label 26485*/ GIMT_Encode4(1977499), // Rule ID 61224 //
     /* 1977418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1977429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1977432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1977435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1977438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977464 */     // MIs[0] policy
     /* 1977464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977474 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1977477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977498 */     // GIR_Coverage, 61224,
     /* 1977498 */     GIR_EraseRootFromParent_Done,
     /* 1977499 */   // Label 26485: @1977499
     /* 1977499 */   GIM_Try, /*On fail goto*//*Label 26486*/ GIMT_Encode4(1977585), // Rule ID 61225 //
     /* 1977504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1977515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1977518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1977521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1977524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977550 */     // MIs[0] policy
     /* 1977550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977560 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1977563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977584 */     // GIR_Coverage, 61225,
     /* 1977584 */     GIR_EraseRootFromParent_Done,
     /* 1977585 */   // Label 26486: @1977585
     /* 1977585 */   GIM_Try, /*On fail goto*//*Label 26487*/ GIMT_Encode4(1977671), // Rule ID 61228 //
     /* 1977590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1977601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1977604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1977607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1977610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977636 */     // MIs[0] policy
     /* 1977636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1977649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977670 */     // GIR_Coverage, 61228,
     /* 1977670 */     GIR_EraseRootFromParent_Done,
     /* 1977671 */   // Label 26487: @1977671
     /* 1977671 */   GIM_Try, /*On fail goto*//*Label 26488*/ GIMT_Encode4(1977757), // Rule ID 61229 //
     /* 1977676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1977687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1977690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1977693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1977696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977722 */     // MIs[0] policy
     /* 1977722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1977735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977756 */     // GIR_Coverage, 61229,
     /* 1977756 */     GIR_EraseRootFromParent_Done,
     /* 1977757 */   // Label 26488: @1977757
     /* 1977757 */   GIM_Try, /*On fail goto*//*Label 26489*/ GIMT_Encode4(1977843), // Rule ID 61232 //
     /* 1977762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1977773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1977776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1977779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1977782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977808 */     // MIs[0] policy
     /* 1977808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1977821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977842 */     // GIR_Coverage, 61232,
     /* 1977842 */     GIR_EraseRootFromParent_Done,
     /* 1977843 */   // Label 26489: @1977843
     /* 1977843 */   GIM_Try, /*On fail goto*//*Label 26490*/ GIMT_Encode4(1977929), // Rule ID 61233 //
     /* 1977848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1977859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1977862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1977865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1977868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977894 */     // MIs[0] policy
     /* 1977894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977904 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1977907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977928 */     // GIR_Coverage, 61233,
     /* 1977928 */     GIR_EraseRootFromParent_Done,
     /* 1977929 */   // Label 26490: @1977929
     /* 1977929 */   GIM_Try, /*On fail goto*//*Label 26491*/ GIMT_Encode4(1978015), // Rule ID 61236 //
     /* 1977934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1977945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1977948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1977951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1977954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977980 */     // MIs[0] policy
     /* 1977980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977990 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1977993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978014 */     // GIR_Coverage, 61236,
     /* 1978014 */     GIR_EraseRootFromParent_Done,
     /* 1978015 */   // Label 26491: @1978015
     /* 1978015 */   GIM_Try, /*On fail goto*//*Label 26492*/ GIMT_Encode4(1978101), // Rule ID 61237 //
     /* 1978020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1978031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1978034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1978037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1978040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1978043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978066 */     // MIs[0] policy
     /* 1978066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978076 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1978079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978100 */     // GIR_Coverage, 61237,
     /* 1978100 */     GIR_EraseRootFromParent_Done,
     /* 1978101 */   // Label 26492: @1978101
     /* 1978101 */   GIM_Try, /*On fail goto*//*Label 26493*/ GIMT_Encode4(1978187), // Rule ID 61240 //
     /* 1978106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1978117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1978120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1978123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1978126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978152 */     // MIs[0] policy
     /* 1978152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978162 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1978165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978186 */     // GIR_Coverage, 61240,
     /* 1978186 */     GIR_EraseRootFromParent_Done,
     /* 1978187 */   // Label 26493: @1978187
     /* 1978187 */   GIM_Try, /*On fail goto*//*Label 26494*/ GIMT_Encode4(1978273), // Rule ID 61241 //
     /* 1978192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1978203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1978206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1978209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1978212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978238 */     // MIs[0] policy
     /* 1978238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978248 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1978251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978272 */     // GIR_Coverage, 61241,
     /* 1978272 */     GIR_EraseRootFromParent_Done,
     /* 1978273 */   // Label 26494: @1978273
     /* 1978273 */   GIM_Try, /*On fail goto*//*Label 26495*/ GIMT_Encode4(1978359), // Rule ID 61244 //
     /* 1978278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1978289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1978292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1978295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1978298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978324 */     // MIs[0] policy
     /* 1978324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978334 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1978337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1978355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978358 */     // GIR_Coverage, 61244,
     /* 1978358 */     GIR_EraseRootFromParent_Done,
     /* 1978359 */   // Label 26495: @1978359
     /* 1978359 */   GIM_Try, /*On fail goto*//*Label 26496*/ GIMT_Encode4(1978445), // Rule ID 61245 //
     /* 1978364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1978375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1978378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1978381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1978384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978410 */     // MIs[0] policy
     /* 1978410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1978423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1978441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978444 */     // GIR_Coverage, 61245,
     /* 1978444 */     GIR_EraseRootFromParent_Done,
     /* 1978445 */   // Label 26496: @1978445
     /* 1978445 */   GIM_Try, /*On fail goto*//*Label 26497*/ GIMT_Encode4(1978531), // Rule ID 61248 //
     /* 1978450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1978461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1978464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1978467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1978470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1978473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1978480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978496 */     // MIs[0] policy
     /* 1978496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978506 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1978509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978530 */     // GIR_Coverage, 61248,
     /* 1978530 */     GIR_EraseRootFromParent_Done,
     /* 1978531 */   // Label 26497: @1978531
     /* 1978531 */   GIM_Try, /*On fail goto*//*Label 26498*/ GIMT_Encode4(1978617), // Rule ID 61249 //
     /* 1978536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1978547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1978550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1978553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1978556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1978559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1978566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978582 */     // MIs[0] policy
     /* 1978582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1978595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978616 */     // GIR_Coverage, 61249,
     /* 1978616 */     GIR_EraseRootFromParent_Done,
     /* 1978617 */   // Label 26498: @1978617
     /* 1978617 */   GIM_Try, /*On fail goto*//*Label 26499*/ GIMT_Encode4(1978703), // Rule ID 61252 //
     /* 1978622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1978633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1978636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1978639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1978642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1978645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1978652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978668 */     // MIs[0] policy
     /* 1978668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978678 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1978681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978702 */     // GIR_Coverage, 61252,
     /* 1978702 */     GIR_EraseRootFromParent_Done,
     /* 1978703 */   // Label 26499: @1978703
     /* 1978703 */   GIM_Try, /*On fail goto*//*Label 26500*/ GIMT_Encode4(1978789), // Rule ID 61253 //
     /* 1978708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1978719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1978722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1978725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1978728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1978731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1978738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978754 */     // MIs[0] policy
     /* 1978754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978764 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1978767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978788 */     // GIR_Coverage, 61253,
     /* 1978788 */     GIR_EraseRootFromParent_Done,
     /* 1978789 */   // Label 26500: @1978789
     /* 1978789 */   GIM_Try, /*On fail goto*//*Label 26501*/ GIMT_Encode4(1978875), // Rule ID 61256 //
     /* 1978794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1978805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1978808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1978811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1978814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1978817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1978824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978840 */     // MIs[0] policy
     /* 1978840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978850 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1978853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978874 */     // GIR_Coverage, 61256,
     /* 1978874 */     GIR_EraseRootFromParent_Done,
     /* 1978875 */   // Label 26501: @1978875
     /* 1978875 */   GIM_Try, /*On fail goto*//*Label 26502*/ GIMT_Encode4(1978961), // Rule ID 61257 //
     /* 1978880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1978891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1978894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1978897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1978900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1978903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1978910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978926 */     // MIs[0] policy
     /* 1978926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978936 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1978939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978960 */     // GIR_Coverage, 61257,
     /* 1978960 */     GIR_EraseRootFromParent_Done,
     /* 1978961 */   // Label 26502: @1978961
     /* 1978961 */   GIM_Try, /*On fail goto*//*Label 26503*/ GIMT_Encode4(1979047), // Rule ID 61260 //
     /* 1978966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1978977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1978980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1978983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1978986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1978989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1978996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979012 */     // MIs[0] policy
     /* 1979012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1979025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979046 */     // GIR_Coverage, 61260,
     /* 1979046 */     GIR_EraseRootFromParent_Done,
     /* 1979047 */   // Label 26503: @1979047
     /* 1979047 */   GIM_Try, /*On fail goto*//*Label 26504*/ GIMT_Encode4(1979133), // Rule ID 61261 //
     /* 1979052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1979063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1979066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1979069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1979072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979098 */     // MIs[0] policy
     /* 1979098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979108 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1979111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979132 */     // GIR_Coverage, 61261,
     /* 1979132 */     GIR_EraseRootFromParent_Done,
     /* 1979133 */   // Label 26504: @1979133
     /* 1979133 */   GIM_Try, /*On fail goto*//*Label 26505*/ GIMT_Encode4(1979219), // Rule ID 61264 //
     /* 1979138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1979149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1979152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1979155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1979158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979184 */     // MIs[0] policy
     /* 1979184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979194 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1979197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979218 */     // GIR_Coverage, 61264,
     /* 1979218 */     GIR_EraseRootFromParent_Done,
     /* 1979219 */   // Label 26505: @1979219
     /* 1979219 */   GIM_Try, /*On fail goto*//*Label 26506*/ GIMT_Encode4(1979305), // Rule ID 61265 //
     /* 1979224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1979235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1979238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1979241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1979244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979270 */     // MIs[0] policy
     /* 1979270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979280 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1979283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979304 */     // GIR_Coverage, 61265,
     /* 1979304 */     GIR_EraseRootFromParent_Done,
     /* 1979305 */   // Label 26506: @1979305
     /* 1979305 */   GIM_Try, /*On fail goto*//*Label 26507*/ GIMT_Encode4(1979391), // Rule ID 61268 //
     /* 1979310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1979321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1979324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1979327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1979330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979356 */     // MIs[0] policy
     /* 1979356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979366 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1979369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979390 */     // GIR_Coverage, 61268,
     /* 1979390 */     GIR_EraseRootFromParent_Done,
     /* 1979391 */   // Label 26507: @1979391
     /* 1979391 */   GIM_Try, /*On fail goto*//*Label 26508*/ GIMT_Encode4(1979477), // Rule ID 61269 //
     /* 1979396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1979407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1979410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1979413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1979416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979442 */     // MIs[0] policy
     /* 1979442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979452 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1979455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979476 */     // GIR_Coverage, 61269,
     /* 1979476 */     GIR_EraseRootFromParent_Done,
     /* 1979477 */   // Label 26508: @1979477
     /* 1979477 */   GIM_Try, /*On fail goto*//*Label 26509*/ GIMT_Encode4(1979563), // Rule ID 61272 //
     /* 1979482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1979493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1979496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1979499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1979502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1979505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979528 */     // MIs[0] policy
     /* 1979528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979538 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1979541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979562 */     // GIR_Coverage, 61272,
     /* 1979562 */     GIR_EraseRootFromParent_Done,
     /* 1979563 */   // Label 26509: @1979563
     /* 1979563 */   GIM_Try, /*On fail goto*//*Label 26510*/ GIMT_Encode4(1979649), // Rule ID 61273 //
     /* 1979568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1979579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1979582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1979585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1979588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1979591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979614 */     // MIs[0] policy
     /* 1979614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1979627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979648 */     // GIR_Coverage, 61273,
     /* 1979648 */     GIR_EraseRootFromParent_Done,
     /* 1979649 */   // Label 26510: @1979649
     /* 1979649 */   GIM_Try, /*On fail goto*//*Label 26511*/ GIMT_Encode4(1979735), // Rule ID 61276 //
     /* 1979654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1979665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1979668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1979671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1979674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979700 */     // MIs[0] policy
     /* 1979700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979710 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1979713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979734 */     // GIR_Coverage, 61276,
     /* 1979734 */     GIR_EraseRootFromParent_Done,
     /* 1979735 */   // Label 26511: @1979735
     /* 1979735 */   GIM_Try, /*On fail goto*//*Label 26512*/ GIMT_Encode4(1979821), // Rule ID 61277 //
     /* 1979740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1979751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1979754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1979757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1979760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979786 */     // MIs[0] policy
     /* 1979786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979796 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1979799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979820 */     // GIR_Coverage, 61277,
     /* 1979820 */     GIR_EraseRootFromParent_Done,
     /* 1979821 */   // Label 26512: @1979821
     /* 1979821 */   GIM_Try, /*On fail goto*//*Label 26513*/ GIMT_Encode4(1979907), // Rule ID 61280 //
     /* 1979826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1979837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1979840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1979843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1979846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979872 */     // MIs[0] policy
     /* 1979872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979882 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1979885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979906 */     // GIR_Coverage, 61280,
     /* 1979906 */     GIR_EraseRootFromParent_Done,
     /* 1979907 */   // Label 26513: @1979907
     /* 1979907 */   GIM_Try, /*On fail goto*//*Label 26514*/ GIMT_Encode4(1979993), // Rule ID 61281 //
     /* 1979912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1979923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1979926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1979929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1979932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979958 */     // MIs[0] policy
     /* 1979958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979968 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1979971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979992 */     // GIR_Coverage, 61281,
     /* 1979992 */     GIR_EraseRootFromParent_Done,
     /* 1979993 */   // Label 26514: @1979993
     /* 1979993 */   GIM_Try, /*On fail goto*//*Label 26515*/ GIMT_Encode4(1980079), // Rule ID 61284 //
     /* 1979998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1980009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1980012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1980015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1980018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980044 */     // MIs[0] policy
     /* 1980044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980054 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1980057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980078 */     // GIR_Coverage, 61284,
     /* 1980078 */     GIR_EraseRootFromParent_Done,
     /* 1980079 */   // Label 26515: @1980079
     /* 1980079 */   GIM_Try, /*On fail goto*//*Label 26516*/ GIMT_Encode4(1980165), // Rule ID 61285 //
     /* 1980084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1980095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1980098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1980101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1980104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980130 */     // MIs[0] policy
     /* 1980130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980140 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1980143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980164 */     // GIR_Coverage, 61285,
     /* 1980164 */     GIR_EraseRootFromParent_Done,
     /* 1980165 */   // Label 26516: @1980165
     /* 1980165 */   GIM_Try, /*On fail goto*//*Label 26517*/ GIMT_Encode4(1980251), // Rule ID 61288 //
     /* 1980170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1980181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1980184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1980187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1980190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980216 */     // MIs[0] policy
     /* 1980216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980226 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1980229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980250 */     // GIR_Coverage, 61288,
     /* 1980250 */     GIR_EraseRootFromParent_Done,
     /* 1980251 */   // Label 26517: @1980251
     /* 1980251 */   GIM_Try, /*On fail goto*//*Label 26518*/ GIMT_Encode4(1980337), // Rule ID 61289 //
     /* 1980256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1980267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1980270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1980273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1980276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980302 */     // MIs[0] policy
     /* 1980302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980312 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1980315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980336 */     // GIR_Coverage, 61289,
     /* 1980336 */     GIR_EraseRootFromParent_Done,
     /* 1980337 */   // Label 26518: @1980337
     /* 1980337 */   GIM_Try, /*On fail goto*//*Label 26519*/ GIMT_Encode4(1980423), // Rule ID 61292 //
     /* 1980342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1980353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1980356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1980359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1980362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980388 */     // MIs[0] policy
     /* 1980388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980398 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1980401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980422 */     // GIR_Coverage, 61292,
     /* 1980422 */     GIR_EraseRootFromParent_Done,
     /* 1980423 */   // Label 26519: @1980423
     /* 1980423 */   GIM_Try, /*On fail goto*//*Label 26520*/ GIMT_Encode4(1980509), // Rule ID 61293 //
     /* 1980428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1980439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1980442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1980445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1980448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980474 */     // MIs[0] policy
     /* 1980474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1980487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980508 */     // GIR_Coverage, 61293,
     /* 1980508 */     GIR_EraseRootFromParent_Done,
     /* 1980509 */   // Label 26520: @1980509
     /* 1980509 */   GIM_Try, /*On fail goto*//*Label 26521*/ GIMT_Encode4(1980595), // Rule ID 61296 //
     /* 1980514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1980525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1980528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1980531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1980537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980560 */     // MIs[0] policy
     /* 1980560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980570 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1980573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980594 */     // GIR_Coverage, 61296,
     /* 1980594 */     GIR_EraseRootFromParent_Done,
     /* 1980595 */   // Label 26521: @1980595
     /* 1980595 */   GIM_Try, /*On fail goto*//*Label 26522*/ GIMT_Encode4(1980681), // Rule ID 61297 //
     /* 1980600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1980611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1980614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1980617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1980623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980646 */     // MIs[0] policy
     /* 1980646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980656 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1980659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980680 */     // GIR_Coverage, 61297,
     /* 1980680 */     GIR_EraseRootFromParent_Done,
     /* 1980681 */   // Label 26522: @1980681
     /* 1980681 */   GIM_Try, /*On fail goto*//*Label 26523*/ GIMT_Encode4(1980767), // Rule ID 61300 //
     /* 1980686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1980697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1980700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1980703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980732 */     // MIs[0] policy
     /* 1980732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980742 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1980745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980766 */     // GIR_Coverage, 61300,
     /* 1980766 */     GIR_EraseRootFromParent_Done,
     /* 1980767 */   // Label 26523: @1980767
     /* 1980767 */   GIM_Try, /*On fail goto*//*Label 26524*/ GIMT_Encode4(1980853), // Rule ID 61301 //
     /* 1980772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1980783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1980786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1980789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980818 */     // MIs[0] policy
     /* 1980818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980828 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1980831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980852 */     // GIR_Coverage, 61301,
     /* 1980852 */     GIR_EraseRootFromParent_Done,
     /* 1980853 */   // Label 26524: @1980853
     /* 1980853 */   GIM_Try, /*On fail goto*//*Label 26525*/ GIMT_Encode4(1980939), // Rule ID 61304 //
     /* 1980858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1980869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1980872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1980875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980904 */     // MIs[0] policy
     /* 1980904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980914 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1980917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980938 */     // GIR_Coverage, 61304,
     /* 1980938 */     GIR_EraseRootFromParent_Done,
     /* 1980939 */   // Label 26525: @1980939
     /* 1980939 */   GIM_Try, /*On fail goto*//*Label 26526*/ GIMT_Encode4(1981025), // Rule ID 61305 //
     /* 1980944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1980955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1980958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1980961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980990 */     // MIs[0] policy
     /* 1980990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981000 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1981003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981024 */     // GIR_Coverage, 61305,
     /* 1981024 */     GIR_EraseRootFromParent_Done,
     /* 1981025 */   // Label 26526: @1981025
     /* 1981025 */   GIM_Try, /*On fail goto*//*Label 26527*/ GIMT_Encode4(1981111), // Rule ID 61308 //
     /* 1981030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1981038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1981041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1981044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1981047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1981050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981076 */     // MIs[0] policy
     /* 1981076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981086 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1981089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981110 */     // GIR_Coverage, 61308,
     /* 1981110 */     GIR_EraseRootFromParent_Done,
     /* 1981111 */   // Label 26527: @1981111
     /* 1981111 */   GIM_Try, /*On fail goto*//*Label 26528*/ GIMT_Encode4(1981197), // Rule ID 61309 //
     /* 1981116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1981124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1981127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1981130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1981133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1981136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981162 */     // MIs[0] policy
     /* 1981162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981172 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1981175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981196 */     // GIR_Coverage, 61309,
     /* 1981196 */     GIR_EraseRootFromParent_Done,
     /* 1981197 */   // Label 26528: @1981197
     /* 1981197 */   GIM_Try, /*On fail goto*//*Label 26529*/ GIMT_Encode4(1981283), // Rule ID 61312 //
     /* 1981202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1981210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1981213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1981216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1981219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1981222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981248 */     // MIs[0] policy
     /* 1981248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981258 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1981261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981282 */     // GIR_Coverage, 61312,
     /* 1981282 */     GIR_EraseRootFromParent_Done,
     /* 1981283 */   // Label 26529: @1981283
     /* 1981283 */   GIM_Try, /*On fail goto*//*Label 26530*/ GIMT_Encode4(1981369), // Rule ID 61313 //
     /* 1981288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1981296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1981299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1981302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1981305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1981308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981334 */     // MIs[0] policy
     /* 1981334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981344 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1981347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981368 */     // GIR_Coverage, 61313,
     /* 1981368 */     GIR_EraseRootFromParent_Done,
     /* 1981369 */   // Label 26530: @1981369
     /* 1981369 */   GIM_Try, /*On fail goto*//*Label 26531*/ GIMT_Encode4(1981455), // Rule ID 61316 //
     /* 1981374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1981382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1981385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1981388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1981391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1981394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981420 */     // MIs[0] policy
     /* 1981420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981430 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1981433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981454 */     // GIR_Coverage, 61316,
     /* 1981454 */     GIR_EraseRootFromParent_Done,
     /* 1981455 */   // Label 26531: @1981455
     /* 1981455 */   GIM_Try, /*On fail goto*//*Label 26532*/ GIMT_Encode4(1981541), // Rule ID 61317 //
     /* 1981460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1981468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1981471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1981474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1981477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1981480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981506 */     // MIs[0] policy
     /* 1981506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981516 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1981519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981540 */     // GIR_Coverage, 61317,
     /* 1981540 */     GIR_EraseRootFromParent_Done,
     /* 1981541 */   // Label 26532: @1981541
     /* 1981541 */   GIM_Try, /*On fail goto*//*Label 26533*/ GIMT_Encode4(1981627), // Rule ID 61320 //
     /* 1981546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1981554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1981557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1981560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1981563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1981566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981592 */     // MIs[0] policy
     /* 1981592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1981605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981626 */     // GIR_Coverage, 61320,
     /* 1981626 */     GIR_EraseRootFromParent_Done,
     /* 1981627 */   // Label 26533: @1981627
     /* 1981627 */   GIM_Try, /*On fail goto*//*Label 26534*/ GIMT_Encode4(1981713), // Rule ID 61321 //
     /* 1981632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1981640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1981643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1981646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1981649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1981652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981678 */     // MIs[0] policy
     /* 1981678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981688 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1981691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981712 */     // GIR_Coverage, 61321,
     /* 1981712 */     GIR_EraseRootFromParent_Done,
     /* 1981713 */   // Label 26534: @1981713
     /* 1981713 */   GIM_Try, /*On fail goto*//*Label 26535*/ GIMT_Encode4(1981799), // Rule ID 61324 //
     /* 1981718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1981726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1981729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1981732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1981735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1981738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981764 */     // MIs[0] policy
     /* 1981764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981774 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1981777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981798 */     // GIR_Coverage, 61324,
     /* 1981798 */     GIR_EraseRootFromParent_Done,
     /* 1981799 */   // Label 26535: @1981799
     /* 1981799 */   GIM_Try, /*On fail goto*//*Label 26536*/ GIMT_Encode4(1981885), // Rule ID 61325 //
     /* 1981804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1981812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1981815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1981818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1981821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1981824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981850 */     // MIs[0] policy
     /* 1981850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1981863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981884 */     // GIR_Coverage, 61325,
     /* 1981884 */     GIR_EraseRootFromParent_Done,
     /* 1981885 */   // Label 26536: @1981885
     /* 1981885 */   GIM_Try, /*On fail goto*//*Label 26537*/ GIMT_Encode4(1981971), // Rule ID 61328 //
     /* 1981890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1981898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1981901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1981904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1981907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1981910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981936 */     // MIs[0] policy
     /* 1981936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1981949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981970 */     // GIR_Coverage, 61328,
     /* 1981970 */     GIR_EraseRootFromParent_Done,
     /* 1981971 */   // Label 26537: @1981971
     /* 1981971 */   GIM_Try, /*On fail goto*//*Label 26538*/ GIMT_Encode4(1982057), // Rule ID 61329 //
     /* 1981976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1981984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1981987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1981990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1981993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1981996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982022 */     // MIs[0] policy
     /* 1982022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982032 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1982035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1982053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982056 */     // GIR_Coverage, 61329,
     /* 1982056 */     GIR_EraseRootFromParent_Done,
     /* 1982057 */   // Label 26538: @1982057
     /* 1982057 */   GIM_Try, /*On fail goto*//*Label 26539*/ GIMT_Encode4(1982143), // Rule ID 61332 //
     /* 1982062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1982070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1982073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1982076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1982079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982108 */     // MIs[0] policy
     /* 1982108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982118 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1982121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1982139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982142 */     // GIR_Coverage, 61332,
     /* 1982142 */     GIR_EraseRootFromParent_Done,
     /* 1982143 */   // Label 26539: @1982143
     /* 1982143 */   GIM_Try, /*On fail goto*//*Label 26540*/ GIMT_Encode4(1982229), // Rule ID 61333 //
     /* 1982148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1982156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1982159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1982162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1982165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982194 */     // MIs[0] policy
     /* 1982194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982204 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1982207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1982225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982228 */     // GIR_Coverage, 61333,
     /* 1982228 */     GIR_EraseRootFromParent_Done,
     /* 1982229 */   // Label 26540: @1982229
     /* 1982229 */   GIM_Try, /*On fail goto*//*Label 26541*/ GIMT_Encode4(1982315), // Rule ID 61336 //
     /* 1982234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1982242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1982245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1982248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1982251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982280 */     // MIs[0] policy
     /* 1982280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982290 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1982293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982314 */     // GIR_Coverage, 61336,
     /* 1982314 */     GIR_EraseRootFromParent_Done,
     /* 1982315 */   // Label 26541: @1982315
     /* 1982315 */   GIM_Try, /*On fail goto*//*Label 26542*/ GIMT_Encode4(1982401), // Rule ID 61337 //
     /* 1982320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1982328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1982331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1982334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1982337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982366 */     // MIs[0] policy
     /* 1982366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982376 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1982379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982400 */     // GIR_Coverage, 61337,
     /* 1982400 */     GIR_EraseRootFromParent_Done,
     /* 1982401 */   // Label 26542: @1982401
     /* 1982401 */   GIM_Try, /*On fail goto*//*Label 26543*/ GIMT_Encode4(1982487), // Rule ID 61340 //
     /* 1982406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1982414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1982417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1982420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1982423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1982429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982452 */     // MIs[0] policy
     /* 1982452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982462 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1982465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982486 */     // GIR_Coverage, 61340,
     /* 1982486 */     GIR_EraseRootFromParent_Done,
     /* 1982487 */   // Label 26543: @1982487
     /* 1982487 */   GIM_Try, /*On fail goto*//*Label 26544*/ GIMT_Encode4(1982573), // Rule ID 61341 //
     /* 1982492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1982500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1982503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1982506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1982509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1982515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982538 */     // MIs[0] policy
     /* 1982538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982548 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1982551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982572 */     // GIR_Coverage, 61341,
     /* 1982572 */     GIR_EraseRootFromParent_Done,
     /* 1982573 */   // Label 26544: @1982573
     /* 1982573 */   GIM_Try, /*On fail goto*//*Label 26545*/ GIMT_Encode4(1982659), // Rule ID 61344 //
     /* 1982578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1982586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1982589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1982592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1982595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1982601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1982608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982624 */     // MIs[0] policy
     /* 1982624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982634 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1982637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982658 */     // GIR_Coverage, 61344,
     /* 1982658 */     GIR_EraseRootFromParent_Done,
     /* 1982659 */   // Label 26545: @1982659
     /* 1982659 */   GIM_Try, /*On fail goto*//*Label 26546*/ GIMT_Encode4(1982745), // Rule ID 61345 //
     /* 1982664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1982672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1982675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1982678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1982681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1982687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1982694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982710 */     // MIs[0] policy
     /* 1982710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982720 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1982723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982744 */     // GIR_Coverage, 61345,
     /* 1982744 */     GIR_EraseRootFromParent_Done,
     /* 1982745 */   // Label 26546: @1982745
     /* 1982745 */   GIM_Try, /*On fail goto*//*Label 26547*/ GIMT_Encode4(1982831), // Rule ID 61348 //
     /* 1982750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1982758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1982761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1982764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1982767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1982773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982796 */     // MIs[0] policy
     /* 1982796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982806 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1982809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982830 */     // GIR_Coverage, 61348,
     /* 1982830 */     GIR_EraseRootFromParent_Done,
     /* 1982831 */   // Label 26547: @1982831
     /* 1982831 */   GIM_Try, /*On fail goto*//*Label 26548*/ GIMT_Encode4(1982917), // Rule ID 61349 //
     /* 1982836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1982844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1982847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1982850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1982853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1982859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982882 */     // MIs[0] policy
     /* 1982882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982892 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1982895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982916 */     // GIR_Coverage, 61349,
     /* 1982916 */     GIR_EraseRootFromParent_Done,
     /* 1982917 */   // Label 26548: @1982917
     /* 1982917 */   GIM_Try, /*On fail goto*//*Label 26549*/ GIMT_Encode4(1983003), // Rule ID 61352 //
     /* 1982922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1982930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1982933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1982936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1982939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982968 */     // MIs[0] policy
     /* 1982968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982978 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1982981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983002 */     // GIR_Coverage, 61352,
     /* 1983002 */     GIR_EraseRootFromParent_Done,
     /* 1983003 */   // Label 26549: @1983003
     /* 1983003 */   GIM_Try, /*On fail goto*//*Label 26550*/ GIMT_Encode4(1983089), // Rule ID 61353 //
     /* 1983008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1983016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1983019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1983022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1983025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983054 */     // MIs[0] policy
     /* 1983054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1983067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983088 */     // GIR_Coverage, 61353,
     /* 1983088 */     GIR_EraseRootFromParent_Done,
     /* 1983089 */   // Label 26550: @1983089
     /* 1983089 */   GIM_Try, /*On fail goto*//*Label 26551*/ GIMT_Encode4(1983175), // Rule ID 61356 //
     /* 1983094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1983102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1983105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1983108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1983111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983140 */     // MIs[0] policy
     /* 1983140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983150 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1983153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983174 */     // GIR_Coverage, 61356,
     /* 1983174 */     GIR_EraseRootFromParent_Done,
     /* 1983175 */   // Label 26551: @1983175
     /* 1983175 */   GIM_Try, /*On fail goto*//*Label 26552*/ GIMT_Encode4(1983261), // Rule ID 61357 //
     /* 1983180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1983188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1983191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1983194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1983197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983226 */     // MIs[0] policy
     /* 1983226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983236 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1983239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983260 */     // GIR_Coverage, 61357,
     /* 1983260 */     GIR_EraseRootFromParent_Done,
     /* 1983261 */   // Label 26552: @1983261
     /* 1983261 */   GIM_Try, /*On fail goto*//*Label 26553*/ GIMT_Encode4(1983347), // Rule ID 61360 //
     /* 1983266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1983274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1983277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1983280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1983283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983312 */     // MIs[0] policy
     /* 1983312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1983325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983346 */     // GIR_Coverage, 61360,
     /* 1983346 */     GIR_EraseRootFromParent_Done,
     /* 1983347 */   // Label 26553: @1983347
     /* 1983347 */   GIM_Try, /*On fail goto*//*Label 26554*/ GIMT_Encode4(1983433), // Rule ID 61361 //
     /* 1983352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1983360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1983363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1983366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1983369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983398 */     // MIs[0] policy
     /* 1983398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983408 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1983411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983432 */     // GIR_Coverage, 61361,
     /* 1983432 */     GIR_EraseRootFromParent_Done,
     /* 1983433 */   // Label 26554: @1983433
     /* 1983433 */   GIM_Try, /*On fail goto*//*Label 26555*/ GIMT_Encode4(1983519), // Rule ID 61364 //
     /* 1983438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1983446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1983449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1983452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1983455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983484 */     // MIs[0] policy
     /* 1983484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1983497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983518 */     // GIR_Coverage, 61364,
     /* 1983518 */     GIR_EraseRootFromParent_Done,
     /* 1983519 */   // Label 26555: @1983519
     /* 1983519 */   GIM_Try, /*On fail goto*//*Label 26556*/ GIMT_Encode4(1983605), // Rule ID 61365 //
     /* 1983524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1983532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1983535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1983538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1983541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983570 */     // MIs[0] policy
     /* 1983570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983580 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1983583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983604 */     // GIR_Coverage, 61365,
     /* 1983604 */     GIR_EraseRootFromParent_Done,
     /* 1983605 */   // Label 26556: @1983605
     /* 1983605 */   GIM_Try, /*On fail goto*//*Label 26557*/ GIMT_Encode4(1983691), // Rule ID 61368 //
     /* 1983610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1983618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1983621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1983624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1983627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983656 */     // MIs[0] policy
     /* 1983656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1983669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983690 */     // GIR_Coverage, 61368,
     /* 1983690 */     GIR_EraseRootFromParent_Done,
     /* 1983691 */   // Label 26557: @1983691
     /* 1983691 */   GIM_Try, /*On fail goto*//*Label 26558*/ GIMT_Encode4(1983777), // Rule ID 61369 //
     /* 1983696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1983704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1983707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1983710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1983713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983742 */     // MIs[0] policy
     /* 1983742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1983755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983776 */     // GIR_Coverage, 61369,
     /* 1983776 */     GIR_EraseRootFromParent_Done,
     /* 1983777 */   // Label 26558: @1983777
     /* 1983777 */   GIM_Try, /*On fail goto*//*Label 26559*/ GIMT_Encode4(1983863), // Rule ID 61372 //
     /* 1983782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1983790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1983793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1983796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1983799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1983805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983828 */     // MIs[0] policy
     /* 1983828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983838 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1983841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983862 */     // GIR_Coverage, 61372,
     /* 1983862 */     GIR_EraseRootFromParent_Done,
     /* 1983863 */   // Label 26559: @1983863
     /* 1983863 */   GIM_Try, /*On fail goto*//*Label 26560*/ GIMT_Encode4(1983949), // Rule ID 61373 //
     /* 1983868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1983876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1983879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1983882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1983885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1983891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983914 */     // MIs[0] policy
     /* 1983914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1983927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983948 */     // GIR_Coverage, 61373,
     /* 1983948 */     GIR_EraseRootFromParent_Done,
     /* 1983949 */   // Label 26560: @1983949
     /* 1983949 */   GIM_Try, /*On fail goto*//*Label 26561*/ GIMT_Encode4(1984035), // Rule ID 61376 //
     /* 1983954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1983962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1983965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1983968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1983971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984000 */     // MIs[0] policy
     /* 1984000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984010 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1984013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984034 */     // GIR_Coverage, 61376,
     /* 1984034 */     GIR_EraseRootFromParent_Done,
     /* 1984035 */   // Label 26561: @1984035
     /* 1984035 */   GIM_Try, /*On fail goto*//*Label 26562*/ GIMT_Encode4(1984121), // Rule ID 61377 //
     /* 1984040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1984048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1984051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1984054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1984057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984086 */     // MIs[0] policy
     /* 1984086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1984099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984120 */     // GIR_Coverage, 61377,
     /* 1984120 */     GIR_EraseRootFromParent_Done,
     /* 1984121 */   // Label 26562: @1984121
     /* 1984121 */   GIM_Try, /*On fail goto*//*Label 26563*/ GIMT_Encode4(1984207), // Rule ID 61380 //
     /* 1984126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1984134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1984137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1984140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1984143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984172 */     // MIs[0] policy
     /* 1984172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984182 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1984185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984206 */     // GIR_Coverage, 61380,
     /* 1984206 */     GIR_EraseRootFromParent_Done,
     /* 1984207 */   // Label 26563: @1984207
     /* 1984207 */   GIM_Try, /*On fail goto*//*Label 26564*/ GIMT_Encode4(1984293), // Rule ID 61381 //
     /* 1984212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1984220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1984223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1984226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1984229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984258 */     // MIs[0] policy
     /* 1984258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984268 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1984271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984292 */     // GIR_Coverage, 61381,
     /* 1984292 */     GIR_EraseRootFromParent_Done,
     /* 1984293 */   // Label 26564: @1984293
     /* 1984293 */   GIM_Try, /*On fail goto*//*Label 26565*/ GIMT_Encode4(1984379), // Rule ID 61560 //
     /* 1984298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1984309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1984312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1984315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1984318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984344 */     // MIs[0] policy
     /* 1984344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984354 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1984357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984378 */     // GIR_Coverage, 61560,
     /* 1984378 */     GIR_EraseRootFromParent_Done,
     /* 1984379 */   // Label 26565: @1984379
     /* 1984379 */   GIM_Try, /*On fail goto*//*Label 26566*/ GIMT_Encode4(1984465), // Rule ID 61561 //
     /* 1984384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1984395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1984398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1984401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1984404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984430 */     // MIs[0] policy
     /* 1984430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984440 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1984443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984464 */     // GIR_Coverage, 61561,
     /* 1984464 */     GIR_EraseRootFromParent_Done,
     /* 1984465 */   // Label 26566: @1984465
     /* 1984465 */   GIM_Try, /*On fail goto*//*Label 26567*/ GIMT_Encode4(1984551), // Rule ID 61564 //
     /* 1984470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1984481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1984484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1984487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1984490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984516 */     // MIs[0] policy
     /* 1984516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984526 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1984529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984550 */     // GIR_Coverage, 61564,
     /* 1984550 */     GIR_EraseRootFromParent_Done,
     /* 1984551 */   // Label 26567: @1984551
     /* 1984551 */   GIM_Try, /*On fail goto*//*Label 26568*/ GIMT_Encode4(1984637), // Rule ID 61565 //
     /* 1984556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1984567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1984570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1984573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1984576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984602 */     // MIs[0] policy
     /* 1984602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984612 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1984615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984636 */     // GIR_Coverage, 61565,
     /* 1984636 */     GIR_EraseRootFromParent_Done,
     /* 1984637 */   // Label 26568: @1984637
     /* 1984637 */   GIM_Try, /*On fail goto*//*Label 26569*/ GIMT_Encode4(1984723), // Rule ID 61568 //
     /* 1984642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1984653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1984656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1984659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1984662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984688 */     // MIs[0] policy
     /* 1984688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984698 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1984701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984722 */     // GIR_Coverage, 61568,
     /* 1984722 */     GIR_EraseRootFromParent_Done,
     /* 1984723 */   // Label 26569: @1984723
     /* 1984723 */   GIM_Try, /*On fail goto*//*Label 26570*/ GIMT_Encode4(1984809), // Rule ID 61569 //
     /* 1984728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1984739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1984742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1984745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1984748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984774 */     // MIs[0] policy
     /* 1984774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984784 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1984787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984808 */     // GIR_Coverage, 61569,
     /* 1984808 */     GIR_EraseRootFromParent_Done,
     /* 1984809 */   // Label 26570: @1984809
     /* 1984809 */   GIM_Try, /*On fail goto*//*Label 26571*/ GIMT_Encode4(1984895), // Rule ID 61572 //
     /* 1984814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1984825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1984828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1984831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1984834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984860 */     // MIs[0] policy
     /* 1984860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984870 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1984873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984894 */     // GIR_Coverage, 61572,
     /* 1984894 */     GIR_EraseRootFromParent_Done,
     /* 1984895 */   // Label 26571: @1984895
     /* 1984895 */   GIM_Try, /*On fail goto*//*Label 26572*/ GIMT_Encode4(1984981), // Rule ID 61573 //
     /* 1984900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1984911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1984914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1984917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1984920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984946 */     // MIs[0] policy
     /* 1984946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984956 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1984959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984980 */     // GIR_Coverage, 61573,
     /* 1984980 */     GIR_EraseRootFromParent_Done,
     /* 1984981 */   // Label 26572: @1984981
     /* 1984981 */   GIM_Try, /*On fail goto*//*Label 26573*/ GIMT_Encode4(1985067), // Rule ID 61576 //
     /* 1984986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1984997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1985000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1985003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1985006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985032 */     // MIs[0] policy
     /* 1985032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985042 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1985045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985066 */     // GIR_Coverage, 61576,
     /* 1985066 */     GIR_EraseRootFromParent_Done,
     /* 1985067 */   // Label 26573: @1985067
     /* 1985067 */   GIM_Try, /*On fail goto*//*Label 26574*/ GIMT_Encode4(1985153), // Rule ID 61577 //
     /* 1985072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1985083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1985086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1985089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1985092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985118 */     // MIs[0] policy
     /* 1985118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985128 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1985131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985152 */     // GIR_Coverage, 61577,
     /* 1985152 */     GIR_EraseRootFromParent_Done,
     /* 1985153 */   // Label 26574: @1985153
     /* 1985153 */   GIM_Try, /*On fail goto*//*Label 26575*/ GIMT_Encode4(1985239), // Rule ID 61580 //
     /* 1985158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1985169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1985172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1985175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1985178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985204 */     // MIs[0] policy
     /* 1985204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985214 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1985217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985238 */     // GIR_Coverage, 61580,
     /* 1985238 */     GIR_EraseRootFromParent_Done,
     /* 1985239 */   // Label 26575: @1985239
     /* 1985239 */   GIM_Try, /*On fail goto*//*Label 26576*/ GIMT_Encode4(1985325), // Rule ID 61581 //
     /* 1985244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1985255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1985258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1985261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1985264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985290 */     // MIs[0] policy
     /* 1985290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985300 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1985303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985324 */     // GIR_Coverage, 61581,
     /* 1985324 */     GIR_EraseRootFromParent_Done,
     /* 1985325 */   // Label 26576: @1985325
     /* 1985325 */   GIM_Try, /*On fail goto*//*Label 26577*/ GIMT_Encode4(1985411), // Rule ID 61584 //
     /* 1985330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1985341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1985344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1985347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1985350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985376 */     // MIs[0] policy
     /* 1985376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985386 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1985389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985410 */     // GIR_Coverage, 61584,
     /* 1985410 */     GIR_EraseRootFromParent_Done,
     /* 1985411 */   // Label 26577: @1985411
     /* 1985411 */   GIM_Try, /*On fail goto*//*Label 26578*/ GIMT_Encode4(1985497), // Rule ID 61585 //
     /* 1985416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1985427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1985430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1985433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1985436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985462 */     // MIs[0] policy
     /* 1985462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985472 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1985475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985496 */     // GIR_Coverage, 61585,
     /* 1985496 */     GIR_EraseRootFromParent_Done,
     /* 1985497 */   // Label 26578: @1985497
     /* 1985497 */   GIM_Try, /*On fail goto*//*Label 26579*/ GIMT_Encode4(1985583), // Rule ID 61588 //
     /* 1985502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1985513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1985516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1985519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1985522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985548 */     // MIs[0] policy
     /* 1985548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1985561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985582 */     // GIR_Coverage, 61588,
     /* 1985582 */     GIR_EraseRootFromParent_Done,
     /* 1985583 */   // Label 26579: @1985583
     /* 1985583 */   GIM_Try, /*On fail goto*//*Label 26580*/ GIMT_Encode4(1985669), // Rule ID 61589 //
     /* 1985588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1985599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1985602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1985605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1985608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985634 */     // MIs[0] policy
     /* 1985634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985644 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1985647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985668 */     // GIR_Coverage, 61589,
     /* 1985668 */     GIR_EraseRootFromParent_Done,
     /* 1985669 */   // Label 26580: @1985669
     /* 1985669 */   GIM_Try, /*On fail goto*//*Label 26581*/ GIMT_Encode4(1985755), // Rule ID 61592 //
     /* 1985674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1985685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1985688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1985691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1985694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985720 */     // MIs[0] policy
     /* 1985720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985730 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1985733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985754 */     // GIR_Coverage, 61592,
     /* 1985754 */     GIR_EraseRootFromParent_Done,
     /* 1985755 */   // Label 26581: @1985755
     /* 1985755 */   GIM_Try, /*On fail goto*//*Label 26582*/ GIMT_Encode4(1985841), // Rule ID 61593 //
     /* 1985760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1985771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1985774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1985777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1985780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985806 */     // MIs[0] policy
     /* 1985806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985816 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1985819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985840 */     // GIR_Coverage, 61593,
     /* 1985840 */     GIR_EraseRootFromParent_Done,
     /* 1985841 */   // Label 26582: @1985841
     /* 1985841 */   GIM_Try, /*On fail goto*//*Label 26583*/ GIMT_Encode4(1985927), // Rule ID 61596 //
     /* 1985846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1985857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1985860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1985863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1985866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985892 */     // MIs[0] policy
     /* 1985892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985902 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1985905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985926 */     // GIR_Coverage, 61596,
     /* 1985926 */     GIR_EraseRootFromParent_Done,
     /* 1985927 */   // Label 26583: @1985927
     /* 1985927 */   GIM_Try, /*On fail goto*//*Label 26584*/ GIMT_Encode4(1986013), // Rule ID 61597 //
     /* 1985932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1985943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1985946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1985949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1985952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985978 */     // MIs[0] policy
     /* 1985978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985988 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1985991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1986009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986012 */     // GIR_Coverage, 61597,
     /* 1986012 */     GIR_EraseRootFromParent_Done,
     /* 1986013 */   // Label 26584: @1986013
     /* 1986013 */   GIM_Try, /*On fail goto*//*Label 26585*/ GIMT_Encode4(1986099), // Rule ID 61600 //
     /* 1986018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1986029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1986032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1986035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1986038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986064 */     // MIs[0] policy
     /* 1986064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986074 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1986077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986098 */     // GIR_Coverage, 61600,
     /* 1986098 */     GIR_EraseRootFromParent_Done,
     /* 1986099 */   // Label 26585: @1986099
     /* 1986099 */   GIM_Try, /*On fail goto*//*Label 26586*/ GIMT_Encode4(1986185), // Rule ID 61601 //
     /* 1986104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1986115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1986118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1986121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1986124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986150 */     // MIs[0] policy
     /* 1986150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986160 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1986163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986184 */     // GIR_Coverage, 61601,
     /* 1986184 */     GIR_EraseRootFromParent_Done,
     /* 1986185 */   // Label 26586: @1986185
     /* 1986185 */   GIM_Try, /*On fail goto*//*Label 26587*/ GIMT_Encode4(1986271), // Rule ID 61604 //
     /* 1986190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1986201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1986204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1986207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1986210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986236 */     // MIs[0] policy
     /* 1986236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986246 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1986249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986270 */     // GIR_Coverage, 61604,
     /* 1986270 */     GIR_EraseRootFromParent_Done,
     /* 1986271 */   // Label 26587: @1986271
     /* 1986271 */   GIM_Try, /*On fail goto*//*Label 26588*/ GIMT_Encode4(1986357), // Rule ID 61605 //
     /* 1986276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1986287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1986290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1986293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1986296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986322 */     // MIs[0] policy
     /* 1986322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986332 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1986335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986356 */     // GIR_Coverage, 61605,
     /* 1986356 */     GIR_EraseRootFromParent_Done,
     /* 1986357 */   // Label 26588: @1986357
     /* 1986357 */   GIM_Try, /*On fail goto*//*Label 26589*/ GIMT_Encode4(1986443), // Rule ID 61608 //
     /* 1986362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1986373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1986376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1986379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1986382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1986385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986408 */     // MIs[0] policy
     /* 1986408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986418 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1986421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986442 */     // GIR_Coverage, 61608,
     /* 1986442 */     GIR_EraseRootFromParent_Done,
     /* 1986443 */   // Label 26589: @1986443
     /* 1986443 */   GIM_Try, /*On fail goto*//*Label 26590*/ GIMT_Encode4(1986529), // Rule ID 61609 //
     /* 1986448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1986459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1986462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1986465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1986468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1986471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986494 */     // MIs[0] policy
     /* 1986494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986504 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1986507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986528 */     // GIR_Coverage, 61609,
     /* 1986528 */     GIR_EraseRootFromParent_Done,
     /* 1986529 */   // Label 26590: @1986529
     /* 1986529 */   GIM_Try, /*On fail goto*//*Label 26591*/ GIMT_Encode4(1986615), // Rule ID 61612 //
     /* 1986534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1986545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1986548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1986551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1986554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986580 */     // MIs[0] policy
     /* 1986580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1986593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986614 */     // GIR_Coverage, 61612,
     /* 1986614 */     GIR_EraseRootFromParent_Done,
     /* 1986615 */   // Label 26591: @1986615
     /* 1986615 */   GIM_Try, /*On fail goto*//*Label 26592*/ GIMT_Encode4(1986701), // Rule ID 61613 //
     /* 1986620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1986631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1986634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1986637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1986640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986666 */     // MIs[0] policy
     /* 1986666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1986679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986700 */     // GIR_Coverage, 61613,
     /* 1986700 */     GIR_EraseRootFromParent_Done,
     /* 1986701 */   // Label 26592: @1986701
     /* 1986701 */   GIM_Try, /*On fail goto*//*Label 26593*/ GIMT_Encode4(1986787), // Rule ID 61616 //
     /* 1986706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1986717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1986720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1986723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1986726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986752 */     // MIs[0] policy
     /* 1986752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986762 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1986765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986786 */     // GIR_Coverage, 61616,
     /* 1986786 */     GIR_EraseRootFromParent_Done,
     /* 1986787 */   // Label 26593: @1986787
     /* 1986787 */   GIM_Try, /*On fail goto*//*Label 26594*/ GIMT_Encode4(1986873), // Rule ID 61617 //
     /* 1986792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1986803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1986806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1986809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1986812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986838 */     // MIs[0] policy
     /* 1986838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1986851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986872 */     // GIR_Coverage, 61617,
     /* 1986872 */     GIR_EraseRootFromParent_Done,
     /* 1986873 */   // Label 26594: @1986873
     /* 1986873 */   GIM_Try, /*On fail goto*//*Label 26595*/ GIMT_Encode4(1986959), // Rule ID 61620 //
     /* 1986878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1986889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1986892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1986895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1986898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986924 */     // MIs[0] policy
     /* 1986924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986934 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1986937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986958 */     // GIR_Coverage, 61620,
     /* 1986958 */     GIR_EraseRootFromParent_Done,
     /* 1986959 */   // Label 26595: @1986959
     /* 1986959 */   GIM_Try, /*On fail goto*//*Label 26596*/ GIMT_Encode4(1987045), // Rule ID 61621 //
     /* 1986964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1986975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1986978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1986981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1986984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987010 */     // MIs[0] policy
     /* 1987010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987020 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1987023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987044 */     // GIR_Coverage, 61621,
     /* 1987044 */     GIR_EraseRootFromParent_Done,
     /* 1987045 */   // Label 26596: @1987045
     /* 1987045 */   GIM_Try, /*On fail goto*//*Label 26597*/ GIMT_Encode4(1987131), // Rule ID 61624 //
     /* 1987050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1987061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1987064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1987067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1987070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987096 */     // MIs[0] policy
     /* 1987096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1987109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987130 */     // GIR_Coverage, 61624,
     /* 1987130 */     GIR_EraseRootFromParent_Done,
     /* 1987131 */   // Label 26597: @1987131
     /* 1987131 */   GIM_Try, /*On fail goto*//*Label 26598*/ GIMT_Encode4(1987217), // Rule ID 61625 //
     /* 1987136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1987147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1987150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1987153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1987156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987182 */     // MIs[0] policy
     /* 1987182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1987195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987216 */     // GIR_Coverage, 61625,
     /* 1987216 */     GIR_EraseRootFromParent_Done,
     /* 1987217 */   // Label 26598: @1987217
     /* 1987217 */   GIM_Try, /*On fail goto*//*Label 26599*/ GIMT_Encode4(1987303), // Rule ID 61628 //
     /* 1987222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1987233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1987236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1987239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1987242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987268 */     // MIs[0] policy
     /* 1987268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987278 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1987281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987302 */     // GIR_Coverage, 61628,
     /* 1987302 */     GIR_EraseRootFromParent_Done,
     /* 1987303 */   // Label 26599: @1987303
     /* 1987303 */   GIM_Try, /*On fail goto*//*Label 26600*/ GIMT_Encode4(1987389), // Rule ID 61629 //
     /* 1987308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1987319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1987322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1987325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1987328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987354 */     // MIs[0] policy
     /* 1987354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1987367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987388 */     // GIR_Coverage, 61629,
     /* 1987388 */     GIR_EraseRootFromParent_Done,
     /* 1987389 */   // Label 26600: @1987389
     /* 1987389 */   GIM_Try, /*On fail goto*//*Label 26601*/ GIMT_Encode4(1987475), // Rule ID 61632 //
     /* 1987394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1987405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1987408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1987411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1987414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987440 */     // MIs[0] policy
     /* 1987440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987450 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1987453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987474 */     // GIR_Coverage, 61632,
     /* 1987474 */     GIR_EraseRootFromParent_Done,
     /* 1987475 */   // Label 26601: @1987475
     /* 1987475 */   GIM_Try, /*On fail goto*//*Label 26602*/ GIMT_Encode4(1987561), // Rule ID 61633 //
     /* 1987480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1987491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1987494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1987497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1987500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987526 */     // MIs[0] policy
     /* 1987526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1987539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987560 */     // GIR_Coverage, 61633,
     /* 1987560 */     GIR_EraseRootFromParent_Done,
     /* 1987561 */   // Label 26602: @1987561
     /* 1987561 */   GIM_Try, /*On fail goto*//*Label 26603*/ GIMT_Encode4(1987647), // Rule ID 61636 //
     /* 1987566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1987577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1987580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1987583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1987586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1987589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987612 */     // MIs[0] policy
     /* 1987612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987622 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1987625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987646 */     // GIR_Coverage, 61636,
     /* 1987646 */     GIR_EraseRootFromParent_Done,
     /* 1987647 */   // Label 26603: @1987647
     /* 1987647 */   GIM_Try, /*On fail goto*//*Label 26604*/ GIMT_Encode4(1987733), // Rule ID 61637 //
     /* 1987652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1987663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1987666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1987669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1987672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1987675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987698 */     // MIs[0] policy
     /* 1987698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987708 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1987711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987732 */     // GIR_Coverage, 61637,
     /* 1987732 */     GIR_EraseRootFromParent_Done,
     /* 1987733 */   // Label 26604: @1987733
     /* 1987733 */   GIM_Try, /*On fail goto*//*Label 26605*/ GIMT_Encode4(1987819), // Rule ID 61640 //
     /* 1987738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1987749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1987752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1987755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1987758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987784 */     // MIs[0] policy
     /* 1987784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987794 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1987797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987818 */     // GIR_Coverage, 61640,
     /* 1987818 */     GIR_EraseRootFromParent_Done,
     /* 1987819 */   // Label 26605: @1987819
     /* 1987819 */   GIM_Try, /*On fail goto*//*Label 26606*/ GIMT_Encode4(1987905), // Rule ID 61641 //
     /* 1987824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1987835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1987838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1987841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1987844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987870 */     // MIs[0] policy
     /* 1987870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987880 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1987883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987904 */     // GIR_Coverage, 61641,
     /* 1987904 */     GIR_EraseRootFromParent_Done,
     /* 1987905 */   // Label 26606: @1987905
     /* 1987905 */   GIM_Try, /*On fail goto*//*Label 26607*/ GIMT_Encode4(1987991), // Rule ID 61644 //
     /* 1987910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1987921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1987924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1987927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1987930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987956 */     // MIs[0] policy
     /* 1987956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987966 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1987969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987990 */     // GIR_Coverage, 61644,
     /* 1987990 */     GIR_EraseRootFromParent_Done,
     /* 1987991 */   // Label 26607: @1987991
     /* 1987991 */   GIM_Try, /*On fail goto*//*Label 26608*/ GIMT_Encode4(1988077), // Rule ID 61645 //
     /* 1987996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1988007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1988010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1988013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1988016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1988026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988042 */     // MIs[0] policy
     /* 1988042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988052 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1988055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988076 */     // GIR_Coverage, 61645,
     /* 1988076 */     GIR_EraseRootFromParent_Done,
     /* 1988077 */   // Label 26608: @1988077
     /* 1988077 */   GIM_Try, /*On fail goto*//*Label 26609*/ GIMT_Encode4(1988163), // Rule ID 61648 //
     /* 1988082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1988093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1988096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1988099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988128 */     // MIs[0] policy
     /* 1988128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988138 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1988141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988162 */     // GIR_Coverage, 61648,
     /* 1988162 */     GIR_EraseRootFromParent_Done,
     /* 1988163 */   // Label 26609: @1988163
     /* 1988163 */   GIM_Try, /*On fail goto*//*Label 26610*/ GIMT_Encode4(1988249), // Rule ID 61649 //
     /* 1988168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1988179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1988182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1988185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988214 */     // MIs[0] policy
     /* 1988214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988224 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1988227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988248 */     // GIR_Coverage, 61649,
     /* 1988248 */     GIR_EraseRootFromParent_Done,
     /* 1988249 */   // Label 26610: @1988249
     /* 1988249 */   GIM_Try, /*On fail goto*//*Label 26611*/ GIMT_Encode4(1988335), // Rule ID 61652 //
     /* 1988254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1988265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1988268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1988271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988300 */     // MIs[0] policy
     /* 1988300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988310 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1988313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988334 */     // GIR_Coverage, 61652,
     /* 1988334 */     GIR_EraseRootFromParent_Done,
     /* 1988335 */   // Label 26611: @1988335
     /* 1988335 */   GIM_Try, /*On fail goto*//*Label 26612*/ GIMT_Encode4(1988421), // Rule ID 61653 //
     /* 1988340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1988351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1988354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1988357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988386 */     // MIs[0] policy
     /* 1988386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988396 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1988399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988420 */     // GIR_Coverage, 61653,
     /* 1988420 */     GIR_EraseRootFromParent_Done,
     /* 1988421 */   // Label 26612: @1988421
     /* 1988421 */   GIM_Try, /*On fail goto*//*Label 26613*/ GIMT_Encode4(1988507), // Rule ID 61656 //
     /* 1988426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1988437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1988440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1988443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988472 */     // MIs[0] policy
     /* 1988472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988482 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1988485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988506 */     // GIR_Coverage, 61656,
     /* 1988506 */     GIR_EraseRootFromParent_Done,
     /* 1988507 */   // Label 26613: @1988507
     /* 1988507 */   GIM_Try, /*On fail goto*//*Label 26614*/ GIMT_Encode4(1988593), // Rule ID 61657 //
     /* 1988512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1988523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1988526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1988529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988558 */     // MIs[0] policy
     /* 1988558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988568 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1988571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988592 */     // GIR_Coverage, 61657,
     /* 1988592 */     GIR_EraseRootFromParent_Done,
     /* 1988593 */   // Label 26614: @1988593
     /* 1988593 */   GIM_Try, /*On fail goto*//*Label 26615*/ GIMT_Encode4(1988679), // Rule ID 61660 //
     /* 1988598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1988609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1988612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1988615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988644 */     // MIs[0] policy
     /* 1988644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988654 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1988657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988678 */     // GIR_Coverage, 61660,
     /* 1988678 */     GIR_EraseRootFromParent_Done,
     /* 1988679 */   // Label 26615: @1988679
     /* 1988679 */   GIM_Try, /*On fail goto*//*Label 26616*/ GIMT_Encode4(1988765), // Rule ID 61661 //
     /* 1988684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1988695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1988698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1988701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988730 */     // MIs[0] policy
     /* 1988730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988740 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1988743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988764 */     // GIR_Coverage, 61661,
     /* 1988764 */     GIR_EraseRootFromParent_Done,
     /* 1988765 */   // Label 26616: @1988765
     /* 1988765 */   GIM_Try, /*On fail goto*//*Label 26617*/ GIMT_Encode4(1988851), // Rule ID 61664 //
     /* 1988770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1988781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1988784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1988787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988816 */     // MIs[0] policy
     /* 1988816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988826 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1988829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988850 */     // GIR_Coverage, 61664,
     /* 1988850 */     GIR_EraseRootFromParent_Done,
     /* 1988851 */   // Label 26617: @1988851
     /* 1988851 */   GIM_Try, /*On fail goto*//*Label 26618*/ GIMT_Encode4(1988937), // Rule ID 61665 //
     /* 1988856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1988867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1988870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1988873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988902 */     // MIs[0] policy
     /* 1988902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988912 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1988915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988936 */     // GIR_Coverage, 61665,
     /* 1988936 */     GIR_EraseRootFromParent_Done,
     /* 1988937 */   // Label 26618: @1988937
     /* 1988937 */   GIM_Try, /*On fail goto*//*Label 26619*/ GIMT_Encode4(1989023), // Rule ID 61668 //
     /* 1988942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1988953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1988956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1988959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988988 */     // MIs[0] policy
     /* 1988988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1989001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989022 */     // GIR_Coverage, 61668,
     /* 1989022 */     GIR_EraseRootFromParent_Done,
     /* 1989023 */   // Label 26619: @1989023
     /* 1989023 */   GIM_Try, /*On fail goto*//*Label 26620*/ GIMT_Encode4(1989109), // Rule ID 61669 //
     /* 1989028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1989036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1989039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1989042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1989045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1989048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989074 */     // MIs[0] policy
     /* 1989074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1989087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989108 */     // GIR_Coverage, 61669,
     /* 1989108 */     GIR_EraseRootFromParent_Done,
     /* 1989109 */   // Label 26620: @1989109
     /* 1989109 */   GIM_Try, /*On fail goto*//*Label 26621*/ GIMT_Encode4(1989195), // Rule ID 61672 //
     /* 1989114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1989122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1989125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1989128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1989131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989160 */     // MIs[0] policy
     /* 1989160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989170 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1989173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989194 */     // GIR_Coverage, 61672,
     /* 1989194 */     GIR_EraseRootFromParent_Done,
     /* 1989195 */   // Label 26621: @1989195
     /* 1989195 */   GIM_Try, /*On fail goto*//*Label 26622*/ GIMT_Encode4(1989281), // Rule ID 61673 //
     /* 1989200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1989208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1989211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1989214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1989217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1989220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989246 */     // MIs[0] policy
     /* 1989246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989256 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1989259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989280 */     // GIR_Coverage, 61673,
     /* 1989280 */     GIR_EraseRootFromParent_Done,
     /* 1989281 */   // Label 26622: @1989281
     /* 1989281 */   GIM_Try, /*On fail goto*//*Label 26623*/ GIMT_Encode4(1989367), // Rule ID 61676 //
     /* 1989286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1989294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1989297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1989300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1989303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989332 */     // MIs[0] policy
     /* 1989332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1989345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989366 */     // GIR_Coverage, 61676,
     /* 1989366 */     GIR_EraseRootFromParent_Done,
     /* 1989367 */   // Label 26623: @1989367
     /* 1989367 */   GIM_Try, /*On fail goto*//*Label 26624*/ GIMT_Encode4(1989453), // Rule ID 61677 //
     /* 1989372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1989380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1989383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1989386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1989389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1989392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989418 */     // MIs[0] policy
     /* 1989418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989428 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1989431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989452 */     // GIR_Coverage, 61677,
     /* 1989452 */     GIR_EraseRootFromParent_Done,
     /* 1989453 */   // Label 26624: @1989453
     /* 1989453 */   GIM_Try, /*On fail goto*//*Label 26625*/ GIMT_Encode4(1989539), // Rule ID 61680 //
     /* 1989458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1989466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1989469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1989472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1989475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989504 */     // MIs[0] policy
     /* 1989504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989514 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1989517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989538 */     // GIR_Coverage, 61680,
     /* 1989538 */     GIR_EraseRootFromParent_Done,
     /* 1989539 */   // Label 26625: @1989539
     /* 1989539 */   GIM_Try, /*On fail goto*//*Label 26626*/ GIMT_Encode4(1989625), // Rule ID 61681 //
     /* 1989544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1989552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1989555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1989558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1989561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1989564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989590 */     // MIs[0] policy
     /* 1989590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1989603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989624 */     // GIR_Coverage, 61681,
     /* 1989624 */     GIR_EraseRootFromParent_Done,
     /* 1989625 */   // Label 26626: @1989625
     /* 1989625 */   GIM_Try, /*On fail goto*//*Label 26627*/ GIMT_Encode4(1989711), // Rule ID 61684 //
     /* 1989630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1989638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1989641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1989644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1989647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989676 */     // MIs[0] policy
     /* 1989676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989686 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1989689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1989707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989710 */     // GIR_Coverage, 61684,
     /* 1989710 */     GIR_EraseRootFromParent_Done,
     /* 1989711 */   // Label 26627: @1989711
     /* 1989711 */   GIM_Try, /*On fail goto*//*Label 26628*/ GIMT_Encode4(1989797), // Rule ID 61685 //
     /* 1989716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1989724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1989727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1989730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1989733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1989736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989762 */     // MIs[0] policy
     /* 1989762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989772 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1989775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1989793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989796 */     // GIR_Coverage, 61685,
     /* 1989796 */     GIR_EraseRootFromParent_Done,
     /* 1989797 */   // Label 26628: @1989797
     /* 1989797 */   GIM_Try, /*On fail goto*//*Label 26629*/ GIMT_Encode4(1989883), // Rule ID 61688 //
     /* 1989802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1989810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1989813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1989816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1989819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1989825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1989832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989848 */     // MIs[0] policy
     /* 1989848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1989861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989882 */     // GIR_Coverage, 61688,
     /* 1989882 */     GIR_EraseRootFromParent_Done,
     /* 1989883 */   // Label 26629: @1989883
     /* 1989883 */   GIM_Try, /*On fail goto*//*Label 26630*/ GIMT_Encode4(1989969), // Rule ID 61689 //
     /* 1989888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1989896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1989899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1989902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1989905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1989908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1989911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1989918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989934 */     // MIs[0] policy
     /* 1989934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989944 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1989947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989968 */     // GIR_Coverage, 61689,
     /* 1989968 */     GIR_EraseRootFromParent_Done,
     /* 1989969 */   // Label 26630: @1989969
     /* 1989969 */   GIM_Try, /*On fail goto*//*Label 26631*/ GIMT_Encode4(1990055), // Rule ID 61692 //
     /* 1989974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1989982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1989985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1989988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1989991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1989997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990020 */     // MIs[0] policy
     /* 1990020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990030 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1990033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990054 */     // GIR_Coverage, 61692,
     /* 1990054 */     GIR_EraseRootFromParent_Done,
     /* 1990055 */   // Label 26631: @1990055
     /* 1990055 */   GIM_Try, /*On fail goto*//*Label 26632*/ GIMT_Encode4(1990141), // Rule ID 61693 //
     /* 1990060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1990068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1990071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1990074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1990077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990106 */     // MIs[0] policy
     /* 1990106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990116 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1990119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990140 */     // GIR_Coverage, 61693,
     /* 1990140 */     GIR_EraseRootFromParent_Done,
     /* 1990141 */   // Label 26632: @1990141
     /* 1990141 */   GIM_Try, /*On fail goto*//*Label 26633*/ GIMT_Encode4(1990227), // Rule ID 61696 //
     /* 1990146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1990154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1990157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1990160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1990163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1990169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990192 */     // MIs[0] policy
     /* 1990192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990202 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1990205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990226 */     // GIR_Coverage, 61696,
     /* 1990226 */     GIR_EraseRootFromParent_Done,
     /* 1990227 */   // Label 26633: @1990227
     /* 1990227 */   GIM_Try, /*On fail goto*//*Label 26634*/ GIMT_Encode4(1990313), // Rule ID 61697 //
     /* 1990232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1990240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1990243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1990246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1990249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1990255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990278 */     // MIs[0] policy
     /* 1990278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990288 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1990291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990312 */     // GIR_Coverage, 61697,
     /* 1990312 */     GIR_EraseRootFromParent_Done,
     /* 1990313 */   // Label 26634: @1990313
     /* 1990313 */   GIM_Try, /*On fail goto*//*Label 26635*/ GIMT_Encode4(1990399), // Rule ID 61700 //
     /* 1990318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1990326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1990329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1990332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1990335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990364 */     // MIs[0] policy
     /* 1990364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990374 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1990377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990398 */     // GIR_Coverage, 61700,
     /* 1990398 */     GIR_EraseRootFromParent_Done,
     /* 1990399 */   // Label 26635: @1990399
     /* 1990399 */   GIM_Try, /*On fail goto*//*Label 26636*/ GIMT_Encode4(1990485), // Rule ID 61701 //
     /* 1990404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1990412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1990415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1990418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1990421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990450 */     // MIs[0] policy
     /* 1990450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1990463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990484 */     // GIR_Coverage, 61701,
     /* 1990484 */     GIR_EraseRootFromParent_Done,
     /* 1990485 */   // Label 26636: @1990485
     /* 1990485 */   GIM_Try, /*On fail goto*//*Label 26637*/ GIMT_Encode4(1990571), // Rule ID 61704 //
     /* 1990490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1990498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1990501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1990504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1990507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990536 */     // MIs[0] policy
     /* 1990536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1990549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990570 */     // GIR_Coverage, 61704,
     /* 1990570 */     GIR_EraseRootFromParent_Done,
     /* 1990571 */   // Label 26637: @1990571
     /* 1990571 */   GIM_Try, /*On fail goto*//*Label 26638*/ GIMT_Encode4(1990657), // Rule ID 61705 //
     /* 1990576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1990584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1990587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1990590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1990593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990622 */     // MIs[0] policy
     /* 1990622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990632 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1990635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990656 */     // GIR_Coverage, 61705,
     /* 1990656 */     GIR_EraseRootFromParent_Done,
     /* 1990657 */   // Label 26638: @1990657
     /* 1990657 */   GIM_Try, /*On fail goto*//*Label 26639*/ GIMT_Encode4(1990743), // Rule ID 61708 //
     /* 1990662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1990670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1990673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1990676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1990679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990708 */     // MIs[0] policy
     /* 1990708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990718 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1990721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990742 */     // GIR_Coverage, 61708,
     /* 1990742 */     GIR_EraseRootFromParent_Done,
     /* 1990743 */   // Label 26639: @1990743
     /* 1990743 */   GIM_Try, /*On fail goto*//*Label 26640*/ GIMT_Encode4(1990829), // Rule ID 61709 //
     /* 1990748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1990756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1990759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1990762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1990765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990794 */     // MIs[0] policy
     /* 1990794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990804 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1990807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990828 */     // GIR_Coverage, 61709,
     /* 1990828 */     GIR_EraseRootFromParent_Done,
     /* 1990829 */   // Label 26640: @1990829
     /* 1990829 */   GIM_Try, /*On fail goto*//*Label 26641*/ GIMT_Encode4(1990915), // Rule ID 61712 //
     /* 1990834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1990842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1990845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1990848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1990851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1990857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990880 */     // MIs[0] policy
     /* 1990880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1990893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990914 */     // GIR_Coverage, 61712,
     /* 1990914 */     GIR_EraseRootFromParent_Done,
     /* 1990915 */   // Label 26641: @1990915
     /* 1990915 */   GIM_Try, /*On fail goto*//*Label 26642*/ GIMT_Encode4(1991001), // Rule ID 61713 //
     /* 1990920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1990928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1990931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1990934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1990937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1990943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990966 */     // MIs[0] policy
     /* 1990966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990976 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1990979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991000 */     // GIR_Coverage, 61713,
     /* 1991000 */     GIR_EraseRootFromParent_Done,
     /* 1991001 */   // Label 26642: @1991001
     /* 1991001 */   GIM_Try, /*On fail goto*//*Label 26643*/ GIMT_Encode4(1991087), // Rule ID 61716 //
     /* 1991006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1991014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1991017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1991020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1991023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1991026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991052 */     // MIs[0] policy
     /* 1991052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991062 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1991065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991086 */     // GIR_Coverage, 61716,
     /* 1991086 */     GIR_EraseRootFromParent_Done,
     /* 1991087 */   // Label 26643: @1991087
     /* 1991087 */   GIM_Try, /*On fail goto*//*Label 26644*/ GIMT_Encode4(1991173), // Rule ID 61717 //
     /* 1991092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1991100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1991103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1991106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1991109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991138 */     // MIs[0] policy
     /* 1991138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991148 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1991151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991172 */     // GIR_Coverage, 61717,
     /* 1991172 */     GIR_EraseRootFromParent_Done,
     /* 1991173 */   // Label 26644: @1991173
     /* 1991173 */   GIM_Try, /*On fail goto*//*Label 26645*/ GIMT_Encode4(1991259), // Rule ID 61720 //
     /* 1991178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1991186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1991189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1991192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1991195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1991198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991224 */     // MIs[0] policy
     /* 1991224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991234 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1991237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991258 */     // GIR_Coverage, 61720,
     /* 1991258 */     GIR_EraseRootFromParent_Done,
     /* 1991259 */   // Label 26645: @1991259
     /* 1991259 */   GIM_Try, /*On fail goto*//*Label 26646*/ GIMT_Encode4(1991345), // Rule ID 61721 //
     /* 1991264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1991272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1991275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1991278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1991281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991310 */     // MIs[0] policy
     /* 1991310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991320 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1991323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991344 */     // GIR_Coverage, 61721,
     /* 1991344 */     GIR_EraseRootFromParent_Done,
     /* 1991345 */   // Label 26646: @1991345
     /* 1991345 */   GIM_Try, /*On fail goto*//*Label 26647*/ GIMT_Encode4(1991431), // Rule ID 61724 //
     /* 1991350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1991358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1991361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1991364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1991367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1991370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1991373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991396 */     // MIs[0] policy
     /* 1991396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991406 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1991409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991430 */     // GIR_Coverage, 61724,
     /* 1991430 */     GIR_EraseRootFromParent_Done,
     /* 1991431 */   // Label 26647: @1991431
     /* 1991431 */   GIM_Try, /*On fail goto*//*Label 26648*/ GIMT_Encode4(1991517), // Rule ID 61725 //
     /* 1991436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1991444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1991447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1991450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1991453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1991459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991482 */     // MIs[0] policy
     /* 1991482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991492 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1991495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991516 */     // GIR_Coverage, 61725,
     /* 1991516 */     GIR_EraseRootFromParent_Done,
     /* 1991517 */   // Label 26648: @1991517
     /* 1991517 */   GIM_Try, /*On fail goto*//*Label 26649*/ GIMT_Encode4(1991603), // Rule ID 61728 //
     /* 1991522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1991530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1991533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1991536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1991539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1991542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991568 */     // MIs[0] policy
     /* 1991568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991578 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1991581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991602 */     // GIR_Coverage, 61728,
     /* 1991602 */     GIR_EraseRootFromParent_Done,
     /* 1991603 */   // Label 26649: @1991603
     /* 1991603 */   GIM_Try, /*On fail goto*//*Label 26650*/ GIMT_Encode4(1991689), // Rule ID 61729 //
     /* 1991608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1991616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1991619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1991622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1991625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991654 */     // MIs[0] policy
     /* 1991654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991664 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1991667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991688 */     // GIR_Coverage, 61729,
     /* 1991688 */     GIR_EraseRootFromParent_Done,
     /* 1991689 */   // Label 26650: @1991689
     /* 1991689 */   GIM_Try, /*On fail goto*//*Label 26651*/ GIMT_Encode4(1991775), // Rule ID 61732 //
     /* 1991694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1991702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1991705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1991708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1991711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1991714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991740 */     // MIs[0] policy
     /* 1991740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991750 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1991753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991774 */     // GIR_Coverage, 61732,
     /* 1991774 */     GIR_EraseRootFromParent_Done,
     /* 1991775 */   // Label 26651: @1991775
     /* 1991775 */   GIM_Try, /*On fail goto*//*Label 26652*/ GIMT_Encode4(1991861), // Rule ID 61733 //
     /* 1991780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1991788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1991791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1991794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1991797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991826 */     // MIs[0] policy
     /* 1991826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991836 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1991839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991860 */     // GIR_Coverage, 61733,
     /* 1991860 */     GIR_EraseRootFromParent_Done,
     /* 1991861 */   // Label 26652: @1991861
     /* 1991861 */   GIM_Try, /*On fail goto*//*Label 26653*/ GIMT_Encode4(1991947), // Rule ID 61820 //
     /* 1991866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1991877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1991880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1991883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1991886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1991889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991912 */     // MIs[0] policy
     /* 1991912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991922 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1991925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991946 */     // GIR_Coverage, 61820,
     /* 1991946 */     GIR_EraseRootFromParent_Done,
     /* 1991947 */   // Label 26653: @1991947
     /* 1991947 */   GIM_Try, /*On fail goto*//*Label 26654*/ GIMT_Encode4(1992033), // Rule ID 61821 //
     /* 1991952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1991963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1991966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1991969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1991972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1991975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991998 */     // MIs[0] policy
     /* 1991998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992008 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1992011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992032 */     // GIR_Coverage, 61821,
     /* 1992032 */     GIR_EraseRootFromParent_Done,
     /* 1992033 */   // Label 26654: @1992033
     /* 1992033 */   GIM_Try, /*On fail goto*//*Label 26655*/ GIMT_Encode4(1992119), // Rule ID 61824 //
     /* 1992038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1992049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1992052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1992055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1992058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992084 */     // MIs[0] policy
     /* 1992084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992094 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1992097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992118 */     // GIR_Coverage, 61824,
     /* 1992118 */     GIR_EraseRootFromParent_Done,
     /* 1992119 */   // Label 26655: @1992119
     /* 1992119 */   GIM_Try, /*On fail goto*//*Label 26656*/ GIMT_Encode4(1992205), // Rule ID 61825 //
     /* 1992124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1992135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1992138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1992141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1992144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992170 */     // MIs[0] policy
     /* 1992170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992180 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1992183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992204 */     // GIR_Coverage, 61825,
     /* 1992204 */     GIR_EraseRootFromParent_Done,
     /* 1992205 */   // Label 26656: @1992205
     /* 1992205 */   GIM_Try, /*On fail goto*//*Label 26657*/ GIMT_Encode4(1992291), // Rule ID 61828 //
     /* 1992210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1992221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1992224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1992227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1992230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992256 */     // MIs[0] policy
     /* 1992256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992266 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1992269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992290 */     // GIR_Coverage, 61828,
     /* 1992290 */     GIR_EraseRootFromParent_Done,
     /* 1992291 */   // Label 26657: @1992291
     /* 1992291 */   GIM_Try, /*On fail goto*//*Label 26658*/ GIMT_Encode4(1992377), // Rule ID 61829 //
     /* 1992296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1992307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1992310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1992313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1992316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992342 */     // MIs[0] policy
     /* 1992342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992352 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1992355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992376 */     // GIR_Coverage, 61829,
     /* 1992376 */     GIR_EraseRootFromParent_Done,
     /* 1992377 */   // Label 26658: @1992377
     /* 1992377 */   GIM_Try, /*On fail goto*//*Label 26659*/ GIMT_Encode4(1992463), // Rule ID 61832 //
     /* 1992382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1992393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1992396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1992399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1992402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992428 */     // MIs[0] policy
     /* 1992428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992438 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1992441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992462 */     // GIR_Coverage, 61832,
     /* 1992462 */     GIR_EraseRootFromParent_Done,
     /* 1992463 */   // Label 26659: @1992463
     /* 1992463 */   GIM_Try, /*On fail goto*//*Label 26660*/ GIMT_Encode4(1992549), // Rule ID 61833 //
     /* 1992468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1992479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1992482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1992485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1992488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992514 */     // MIs[0] policy
     /* 1992514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992524 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1992527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992548 */     // GIR_Coverage, 61833,
     /* 1992548 */     GIR_EraseRootFromParent_Done,
     /* 1992549 */   // Label 26660: @1992549
     /* 1992549 */   GIM_Try, /*On fail goto*//*Label 26661*/ GIMT_Encode4(1992635), // Rule ID 61836 //
     /* 1992554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1992565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1992568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1992571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1992574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992600 */     // MIs[0] policy
     /* 1992600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992610 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1992613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992634 */     // GIR_Coverage, 61836,
     /* 1992634 */     GIR_EraseRootFromParent_Done,
     /* 1992635 */   // Label 26661: @1992635
     /* 1992635 */   GIM_Try, /*On fail goto*//*Label 26662*/ GIMT_Encode4(1992721), // Rule ID 61837 //
     /* 1992640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1992651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1992654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1992657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1992660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992686 */     // MIs[0] policy
     /* 1992686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1992699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992720 */     // GIR_Coverage, 61837,
     /* 1992720 */     GIR_EraseRootFromParent_Done,
     /* 1992721 */   // Label 26662: @1992721
     /* 1992721 */   GIM_Try, /*On fail goto*//*Label 26663*/ GIMT_Encode4(1992807), // Rule ID 61840 //
     /* 1992726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1992737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1992740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1992743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1992746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992772 */     // MIs[0] policy
     /* 1992772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1992785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992806 */     // GIR_Coverage, 61840,
     /* 1992806 */     GIR_EraseRootFromParent_Done,
     /* 1992807 */   // Label 26663: @1992807
     /* 1992807 */   GIM_Try, /*On fail goto*//*Label 26664*/ GIMT_Encode4(1992893), // Rule ID 61841 //
     /* 1992812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1992823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1992826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1992829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1992832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992858 */     // MIs[0] policy
     /* 1992858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1992871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992892 */     // GIR_Coverage, 61841,
     /* 1992892 */     GIR_EraseRootFromParent_Done,
     /* 1992893 */   // Label 26664: @1992893
     /* 1992893 */   GIM_Try, /*On fail goto*//*Label 26665*/ GIMT_Encode4(1992979), // Rule ID 61844 //
     /* 1992898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1992909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1992912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1992915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1992918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992944 */     // MIs[0] policy
     /* 1992944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992954 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1992957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992978 */     // GIR_Coverage, 61844,
     /* 1992978 */     GIR_EraseRootFromParent_Done,
     /* 1992979 */   // Label 26665: @1992979
     /* 1992979 */   GIM_Try, /*On fail goto*//*Label 26666*/ GIMT_Encode4(1993065), // Rule ID 61845 //
     /* 1992984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1992995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1992998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1993001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1993004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1993007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993030 */     // MIs[0] policy
     /* 1993030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1993043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993064 */     // GIR_Coverage, 61845,
     /* 1993064 */     GIR_EraseRootFromParent_Done,
     /* 1993065 */   // Label 26666: @1993065
     /* 1993065 */   GIM_Try, /*On fail goto*//*Label 26667*/ GIMT_Encode4(1993151), // Rule ID 61848 //
     /* 1993070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1993081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1993084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1993087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1993090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993116 */     // MIs[0] policy
     /* 1993116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993126 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1993129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993150 */     // GIR_Coverage, 61848,
     /* 1993150 */     GIR_EraseRootFromParent_Done,
     /* 1993151 */   // Label 26667: @1993151
     /* 1993151 */   GIM_Try, /*On fail goto*//*Label 26668*/ GIMT_Encode4(1993237), // Rule ID 61849 //
     /* 1993156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1993167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1993170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1993173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1993176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993202 */     // MIs[0] policy
     /* 1993202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993212 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1993215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993236 */     // GIR_Coverage, 61849,
     /* 1993236 */     GIR_EraseRootFromParent_Done,
     /* 1993237 */   // Label 26668: @1993237
     /* 1993237 */   GIM_Try, /*On fail goto*//*Label 26669*/ GIMT_Encode4(1993323), // Rule ID 61852 //
     /* 1993242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1993259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1993262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993288 */     // MIs[0] policy
     /* 1993288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993298 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1993301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993322 */     // GIR_Coverage, 61852,
     /* 1993322 */     GIR_EraseRootFromParent_Done,
     /* 1993323 */   // Label 26669: @1993323
     /* 1993323 */   GIM_Try, /*On fail goto*//*Label 26670*/ GIMT_Encode4(1993409), // Rule ID 61853 //
     /* 1993328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1993345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1993348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993374 */     // MIs[0] policy
     /* 1993374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993384 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1993387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993408 */     // GIR_Coverage, 61853,
     /* 1993408 */     GIR_EraseRootFromParent_Done,
     /* 1993409 */   // Label 26670: @1993409
     /* 1993409 */   GIM_Try, /*On fail goto*//*Label 26671*/ GIMT_Encode4(1993495), // Rule ID 61856 //
     /* 1993414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1993425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1993428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1993431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1993434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993460 */     // MIs[0] policy
     /* 1993460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1993473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993494 */     // GIR_Coverage, 61856,
     /* 1993494 */     GIR_EraseRootFromParent_Done,
     /* 1993495 */   // Label 26671: @1993495
     /* 1993495 */   GIM_Try, /*On fail goto*//*Label 26672*/ GIMT_Encode4(1993581), // Rule ID 61857 //
     /* 1993500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1993511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1993514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1993517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1993520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993546 */     // MIs[0] policy
     /* 1993546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993556 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1993559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993580 */     // GIR_Coverage, 61857,
     /* 1993580 */     GIR_EraseRootFromParent_Done,
     /* 1993581 */   // Label 26672: @1993581
     /* 1993581 */   GIM_Try, /*On fail goto*//*Label 26673*/ GIMT_Encode4(1993667), // Rule ID 61860 //
     /* 1993586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1993597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1993600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1993603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1993606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1993609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1993616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993632 */     // MIs[0] policy
     /* 1993632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993642 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1993645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993666 */     // GIR_Coverage, 61860,
     /* 1993666 */     GIR_EraseRootFromParent_Done,
     /* 1993667 */   // Label 26673: @1993667
     /* 1993667 */   GIM_Try, /*On fail goto*//*Label 26674*/ GIMT_Encode4(1993753), // Rule ID 61861 //
     /* 1993672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1993683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1993686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1993689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1993692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1993695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1993702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993718 */     // MIs[0] policy
     /* 1993718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993728 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1993731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993752 */     // GIR_Coverage, 61861,
     /* 1993752 */     GIR_EraseRootFromParent_Done,
     /* 1993753 */   // Label 26674: @1993753
     /* 1993753 */   GIM_Try, /*On fail goto*//*Label 26675*/ GIMT_Encode4(1993839), // Rule ID 61864 //
     /* 1993758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1993769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1993772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1993775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1993778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1993781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993804 */     // MIs[0] policy
     /* 1993804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993814 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1993817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993838 */     // GIR_Coverage, 61864,
     /* 1993838 */     GIR_EraseRootFromParent_Done,
     /* 1993839 */   // Label 26675: @1993839
     /* 1993839 */   GIM_Try, /*On fail goto*//*Label 26676*/ GIMT_Encode4(1993925), // Rule ID 61865 //
     /* 1993844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1993855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1993858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1993861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1993864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1993867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993890 */     // MIs[0] policy
     /* 1993890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993900 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1993903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993924 */     // GIR_Coverage, 61865,
     /* 1993924 */     GIR_EraseRootFromParent_Done,
     /* 1993925 */   // Label 26676: @1993925
     /* 1993925 */   GIM_Try, /*On fail goto*//*Label 26677*/ GIMT_Encode4(1994011), // Rule ID 61868 //
     /* 1993930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1993941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1993944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1993947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1993950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1993953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1993960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993976 */     // MIs[0] policy
     /* 1993976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993986 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1993989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994010 */     // GIR_Coverage, 61868,
     /* 1994010 */     GIR_EraseRootFromParent_Done,
     /* 1994011 */   // Label 26677: @1994011
     /* 1994011 */   GIM_Try, /*On fail goto*//*Label 26678*/ GIMT_Encode4(1994097), // Rule ID 61869 //
     /* 1994016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1994027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1994030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1994033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1994036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1994039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994062 */     // MIs[0] policy
     /* 1994062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994072 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1994075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994096 */     // GIR_Coverage, 61869,
     /* 1994096 */     GIR_EraseRootFromParent_Done,
     /* 1994097 */   // Label 26678: @1994097
     /* 1994097 */   GIM_Try, /*On fail goto*//*Label 26679*/ GIMT_Encode4(1994183), // Rule ID 61872 //
     /* 1994102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1994113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1994116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1994119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1994122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994148 */     // MIs[0] policy
     /* 1994148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994158 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1994161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994182 */     // GIR_Coverage, 61872,
     /* 1994182 */     GIR_EraseRootFromParent_Done,
     /* 1994183 */   // Label 26679: @1994183
     /* 1994183 */   GIM_Try, /*On fail goto*//*Label 26680*/ GIMT_Encode4(1994269), // Rule ID 61873 //
     /* 1994188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1994199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1994202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1994205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1994208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994234 */     // MIs[0] policy
     /* 1994234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994244 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1994247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994268 */     // GIR_Coverage, 61873,
     /* 1994268 */     GIR_EraseRootFromParent_Done,
     /* 1994269 */   // Label 26680: @1994269
     /* 1994269 */   GIM_Try, /*On fail goto*//*Label 26681*/ GIMT_Encode4(1994355), // Rule ID 61876 //
     /* 1994274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1994285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1994288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1994291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1994294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994320 */     // MIs[0] policy
     /* 1994320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994330 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1994333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994354 */     // GIR_Coverage, 61876,
     /* 1994354 */     GIR_EraseRootFromParent_Done,
     /* 1994355 */   // Label 26681: @1994355
     /* 1994355 */   GIM_Try, /*On fail goto*//*Label 26682*/ GIMT_Encode4(1994441), // Rule ID 61877 //
     /* 1994360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1994371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1994374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1994377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1994380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994406 */     // MIs[0] policy
     /* 1994406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994416 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1994419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994440 */     // GIR_Coverage, 61877,
     /* 1994440 */     GIR_EraseRootFromParent_Done,
     /* 1994441 */   // Label 26682: @1994441
     /* 1994441 */   GIM_Try, /*On fail goto*//*Label 26683*/ GIMT_Encode4(1994527), // Rule ID 61880 //
     /* 1994446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1994457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1994460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1994463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1994466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994492 */     // MIs[0] policy
     /* 1994492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994502 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1994505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994526 */     // GIR_Coverage, 61880,
     /* 1994526 */     GIR_EraseRootFromParent_Done,
     /* 1994527 */   // Label 26683: @1994527
     /* 1994527 */   GIM_Try, /*On fail goto*//*Label 26684*/ GIMT_Encode4(1994613), // Rule ID 61881 //
     /* 1994532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1994543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1994546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1994549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1994552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994578 */     // MIs[0] policy
     /* 1994578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994588 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1994591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994612 */     // GIR_Coverage, 61881,
     /* 1994612 */     GIR_EraseRootFromParent_Done,
     /* 1994613 */   // Label 26684: @1994613
     /* 1994613 */   GIM_Try, /*On fail goto*//*Label 26685*/ GIMT_Encode4(1994699), // Rule ID 61884 //
     /* 1994618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1994629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1994632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1994635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1994638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1994641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994664 */     // MIs[0] policy
     /* 1994664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994674 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1994677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994698 */     // GIR_Coverage, 61884,
     /* 1994698 */     GIR_EraseRootFromParent_Done,
     /* 1994699 */   // Label 26685: @1994699
     /* 1994699 */   GIM_Try, /*On fail goto*//*Label 26686*/ GIMT_Encode4(1994785), // Rule ID 61885 //
     /* 1994704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1994715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1994718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1994721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1994724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1994727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994750 */     // MIs[0] policy
     /* 1994750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1994763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994784 */     // GIR_Coverage, 61885,
     /* 1994784 */     GIR_EraseRootFromParent_Done,
     /* 1994785 */   // Label 26686: @1994785
     /* 1994785 */   GIM_Try, /*On fail goto*//*Label 26687*/ GIMT_Encode4(1994871), // Rule ID 61888 //
     /* 1994790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1994801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1994804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1994807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1994810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994836 */     // MIs[0] policy
     /* 1994836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1994849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994870 */     // GIR_Coverage, 61888,
     /* 1994870 */     GIR_EraseRootFromParent_Done,
     /* 1994871 */   // Label 26687: @1994871
     /* 1994871 */   GIM_Try, /*On fail goto*//*Label 26688*/ GIMT_Encode4(1994957), // Rule ID 61889 //
     /* 1994876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1994887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1994890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1994893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1994896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994922 */     // MIs[0] policy
     /* 1994922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994932 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1994935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994956 */     // GIR_Coverage, 61889,
     /* 1994956 */     GIR_EraseRootFromParent_Done,
     /* 1994957 */   // Label 26688: @1994957
     /* 1994957 */   GIM_Try, /*On fail goto*//*Label 26689*/ GIMT_Encode4(1995043), // Rule ID 61892 //
     /* 1994962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1994973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1994976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1994979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1994982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995008 */     // MIs[0] policy
     /* 1995008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1995021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995042 */     // GIR_Coverage, 61892,
     /* 1995042 */     GIR_EraseRootFromParent_Done,
     /* 1995043 */   // Label 26689: @1995043
     /* 1995043 */   GIM_Try, /*On fail goto*//*Label 26690*/ GIMT_Encode4(1995129), // Rule ID 61893 //
     /* 1995048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1995059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1995062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1995065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1995068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1995071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995094 */     // MIs[0] policy
     /* 1995094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995104 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1995107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995128 */     // GIR_Coverage, 61893,
     /* 1995128 */     GIR_EraseRootFromParent_Done,
     /* 1995129 */   // Label 26690: @1995129
     /* 1995129 */   GIM_Try, /*On fail goto*//*Label 26691*/ GIMT_Encode4(1995215), // Rule ID 61896 //
     /* 1995134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1995145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1995148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1995151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1995154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995180 */     // MIs[0] policy
     /* 1995180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1995193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995214 */     // GIR_Coverage, 61896,
     /* 1995214 */     GIR_EraseRootFromParent_Done,
     /* 1995215 */   // Label 26691: @1995215
     /* 1995215 */   GIM_Try, /*On fail goto*//*Label 26692*/ GIMT_Encode4(1995301), // Rule ID 61897 //
     /* 1995220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1995231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1995234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1995237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1995240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995266 */     // MIs[0] policy
     /* 1995266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1995279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995300 */     // GIR_Coverage, 61897,
     /* 1995300 */     GIR_EraseRootFromParent_Done,
     /* 1995301 */   // Label 26692: @1995301
     /* 1995301 */   GIM_Try, /*On fail goto*//*Label 26693*/ GIMT_Encode4(1995387), // Rule ID 61900 //
     /* 1995306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1995317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1995320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1995323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1995326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995352 */     // MIs[0] policy
     /* 1995352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995362 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1995365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995386 */     // GIR_Coverage, 61900,
     /* 1995386 */     GIR_EraseRootFromParent_Done,
     /* 1995387 */   // Label 26693: @1995387
     /* 1995387 */   GIM_Try, /*On fail goto*//*Label 26694*/ GIMT_Encode4(1995473), // Rule ID 61901 //
     /* 1995392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1995403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1995406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1995409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1995412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995438 */     // MIs[0] policy
     /* 1995438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995448 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1995451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995472 */     // GIR_Coverage, 61901,
     /* 1995472 */     GIR_EraseRootFromParent_Done,
     /* 1995473 */   // Label 26694: @1995473
     /* 1995473 */   GIM_Try, /*On fail goto*//*Label 26695*/ GIMT_Encode4(1995559), // Rule ID 61904 //
     /* 1995478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1995489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1995492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1995495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1995498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995524 */     // MIs[0] policy
     /* 1995524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995534 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1995537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995558 */     // GIR_Coverage, 61904,
     /* 1995558 */     GIR_EraseRootFromParent_Done,
     /* 1995559 */   // Label 26695: @1995559
     /* 1995559 */   GIM_Try, /*On fail goto*//*Label 26696*/ GIMT_Encode4(1995645), // Rule ID 61905 //
     /* 1995564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1995575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1995578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1995581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1995584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995610 */     // MIs[0] policy
     /* 1995610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995620 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1995623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995644 */     // GIR_Coverage, 61905,
     /* 1995644 */     GIR_EraseRootFromParent_Done,
     /* 1995645 */   // Label 26696: @1995645
     /* 1995645 */   GIM_Try, /*On fail goto*//*Label 26697*/ GIMT_Encode4(1995731), // Rule ID 61908 //
     /* 1995650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1995661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1995664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1995667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1995673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995696 */     // MIs[0] policy
     /* 1995696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995706 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1995709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1995727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995730 */     // GIR_Coverage, 61908,
     /* 1995730 */     GIR_EraseRootFromParent_Done,
     /* 1995731 */   // Label 26697: @1995731
     /* 1995731 */   GIM_Try, /*On fail goto*//*Label 26698*/ GIMT_Encode4(1995817), // Rule ID 61909 //
     /* 1995736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1995747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1995750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1995753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1995759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995782 */     // MIs[0] policy
     /* 1995782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995792 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1995795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1995813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995816 */     // GIR_Coverage, 61909,
     /* 1995816 */     GIR_EraseRootFromParent_Done,
     /* 1995817 */   // Label 26698: @1995817
     /* 1995817 */   GIM_Try, /*On fail goto*//*Label 26699*/ GIMT_Encode4(1995903), // Rule ID 61912 //
     /* 1995822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1995833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1995836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1995839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995868 */     // MIs[0] policy
     /* 1995868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995878 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1995881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1995899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995902 */     // GIR_Coverage, 61912,
     /* 1995902 */     GIR_EraseRootFromParent_Done,
     /* 1995903 */   // Label 26699: @1995903
     /* 1995903 */   GIM_Try, /*On fail goto*//*Label 26700*/ GIMT_Encode4(1995989), // Rule ID 61913 //
     /* 1995908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1995919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1995922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1995925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995954 */     // MIs[0] policy
     /* 1995954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995964 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1995967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1995985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995988 */     // GIR_Coverage, 61913,
     /* 1995988 */     GIR_EraseRootFromParent_Done,
     /* 1995989 */   // Label 26700: @1995989
     /* 1995989 */   GIM_Try, /*On fail goto*//*Label 26701*/ GIMT_Encode4(1996075), // Rule ID 61916 //
     /* 1995994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1996002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1996005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1996008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1996011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1996014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996040 */     // MIs[0] policy
     /* 1996040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996050 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1996053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1996071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996074 */     // GIR_Coverage, 61916,
     /* 1996074 */     GIR_EraseRootFromParent_Done,
     /* 1996075 */   // Label 26701: @1996075
     /* 1996075 */   GIM_Try, /*On fail goto*//*Label 26702*/ GIMT_Encode4(1996161), // Rule ID 61917 //
     /* 1996080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1996083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1996088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1996091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1996094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1996097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1996100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996126 */     // MIs[0] policy
     /* 1996126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996136 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1996139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1996157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996160 */     // GIR_Coverage, 61917,
     /* 1996160 */     GIR_EraseRootFromParent_Done,
     /* 1996161 */   // Label 26702: @1996161
     /* 1996161 */   GIM_Try, /*On fail goto*//*Label 26703*/ GIMT_Encode4(1996247), // Rule ID 61920 //
     /* 1996166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1996169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1996174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1996177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1996180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1996183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1996186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1996189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996212 */     // MIs[0] policy
     /* 1996212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996222 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1996225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996246 */     // GIR_Coverage, 61920,
     /* 1996246 */     GIR_EraseRootFromParent_Done,
     /* 1996247 */   // Label 26703: @1996247
     /* 1996247 */   GIM_Try, /*On fail goto*//*Label 26704*/ GIMT_Encode4(1996333), // Rule ID 61921 //
     /* 1996252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1996255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1996260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1996263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1996266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1996269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1996272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1996275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996298 */     // MIs[0] policy
     /* 1996298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996308 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1996311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996332 */     // GIR_Coverage, 61921,
     /* 1996332 */     GIR_EraseRootFromParent_Done,
     /* 1996333 */   // Label 26704: @1996333
     /* 1996333 */   GIM_Try, /*On fail goto*//*Label 26705*/ GIMT_Encode4(1996419), // Rule ID 61924 //
     /* 1996338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1996341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1996346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1996349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1996352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1996355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1996358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1996361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996384 */     // MIs[0] policy
     /* 1996384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996394 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1996397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996418 */     // GIR_Coverage, 61924,
     /* 1996418 */     GIR_EraseRootFromParent_Done,
     /* 1996419 */   // Label 26705: @1996419
     /* 1996419 */   GIM_Try, /*On fail goto*//*Label 26706*/ GIMT_Encode4(1996505), // Rule ID 61925 //
     /* 1996424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1996427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1996432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1996435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1996438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1996441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1996444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1996447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996470 */     // MIs[0] policy
     /* 1996470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996480 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1996483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996504 */     // GIR_Coverage, 61925,
     /* 1996504 */     GIR_EraseRootFromParent_Done,
     /* 1996505 */   // Label 26706: @1996505
     /* 1996505 */   GIM_Try, /*On fail goto*//*Label 26707*/ GIMT_Encode4(1996591), // Rule ID 61928 //
     /* 1996510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1996513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1996518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1996527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1996530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1996533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996556 */     // MIs[0] policy
     /* 1996556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996566 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1996569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996590 */     // GIR_Coverage, 61928,
     /* 1996590 */     GIR_EraseRootFromParent_Done,
     /* 1996591 */   // Label 26707: @1996591
     /* 1996591 */   GIM_Try, /*On fail goto*//*Label 26708*/ GIMT_Encode4(1996677), // Rule ID 61929 //
     /* 1996596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1996599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1996604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1996613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1996616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1996619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996642 */     // MIs[0] policy
     /* 1996642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1996655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996676 */     // GIR_Coverage, 61929,
     /* 1996676 */     GIR_EraseRootFromParent_Done,
     /* 1996677 */   // Label 26708: @1996677
     /* 1996677 */   GIM_Try, /*On fail goto*//*Label 26709*/ GIMT_Encode4(1996763), // Rule ID 61932 //
     /* 1996682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1996685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1996690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1996693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1996696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1996699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1996702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996728 */     // MIs[0] policy
     /* 1996728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996738 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1996741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1996759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996762 */     // GIR_Coverage, 61932,
     /* 1996762 */     GIR_EraseRootFromParent_Done,
     /* 1996763 */   // Label 26709: @1996763
     /* 1996763 */   GIM_Try, /*On fail goto*//*Label 26710*/ GIMT_Encode4(1996849), // Rule ID 61933 //
     /* 1996768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1996771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1996776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1996779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1996782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1996785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1996788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996814 */     // MIs[0] policy
     /* 1996814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996824 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1996827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1996845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996848 */     // GIR_Coverage, 61933,
     /* 1996848 */     GIR_EraseRootFromParent_Done,
     /* 1996849 */   // Label 26710: @1996849
     /* 1996849 */   GIM_Try, /*On fail goto*//*Label 26711*/ GIMT_Encode4(1996935), // Rule ID 61936 //
     /* 1996854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1996857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1996862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1996865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1996868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1996871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1996874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996900 */     // MIs[0] policy
     /* 1996900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996910 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1996913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996934 */     // GIR_Coverage, 61936,
     /* 1996934 */     GIR_EraseRootFromParent_Done,
     /* 1996935 */   // Label 26711: @1996935
     /* 1996935 */   GIM_Try, /*On fail goto*//*Label 26712*/ GIMT_Encode4(1997021), // Rule ID 61937 //
     /* 1996940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1996943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1996948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1996951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1996954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1996957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1996960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996986 */     // MIs[0] policy
     /* 1996986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1996999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1997017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997020 */     // GIR_Coverage, 61937,
     /* 1997020 */     GIR_EraseRootFromParent_Done,
     /* 1997021 */   // Label 26712: @1997021
     /* 1997021 */   GIM_Try, /*On fail goto*//*Label 26713*/ GIMT_Encode4(1997107), // Rule ID 61940 //
     /* 1997026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1997029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1997034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1997043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1997046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1997049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997072 */     // MIs[0] policy
     /* 1997072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997082 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1997085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997106 */     // GIR_Coverage, 61940,
     /* 1997106 */     GIR_EraseRootFromParent_Done,
     /* 1997107 */   // Label 26713: @1997107
     /* 1997107 */   GIM_Try, /*On fail goto*//*Label 26714*/ GIMT_Encode4(1997193), // Rule ID 61941 //
     /* 1997112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1997115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1997120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1997129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1997132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1997135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997158 */     // MIs[0] policy
     /* 1997158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997168 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1997171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997192 */     // GIR_Coverage, 61941,
     /* 1997192 */     GIR_EraseRootFromParent_Done,
     /* 1997193 */   // Label 26714: @1997193
     /* 1997193 */   GIM_Try, /*On fail goto*//*Label 26715*/ GIMT_Encode4(1997279), // Rule ID 61944 //
     /* 1997198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1997201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1997206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1997209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1997212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1997215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1997218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1997221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997244 */     // MIs[0] policy
     /* 1997244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997254 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1997257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1997275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997278 */     // GIR_Coverage, 61944,
     /* 1997278 */     GIR_EraseRootFromParent_Done,
     /* 1997279 */   // Label 26715: @1997279
     /* 1997279 */   GIM_Try, /*On fail goto*//*Label 26716*/ GIMT_Encode4(1997365), // Rule ID 61945 //
     /* 1997284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1997287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1997292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1997295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1997298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1997301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1997304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1997307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997330 */     // MIs[0] policy
     /* 1997330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997340 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1997343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1997361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997364 */     // GIR_Coverage, 61945,
     /* 1997364 */     GIR_EraseRootFromParent_Done,
     /* 1997365 */   // Label 26716: @1997365
     /* 1997365 */   GIM_Try, /*On fail goto*//*Label 26717*/ GIMT_Encode4(1997451), // Rule ID 61948 //
     /* 1997370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1997373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1997378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1997381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1997384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1997387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1997390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997416 */     // MIs[0] policy
     /* 1997416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997426 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1997429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1997447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997450 */     // GIR_Coverage, 61948,
     /* 1997450 */     GIR_EraseRootFromParent_Done,
     /* 1997451 */   // Label 26717: @1997451
     /* 1997451 */   GIM_Try, /*On fail goto*//*Label 26718*/ GIMT_Encode4(1997537), // Rule ID 61949 //
     /* 1997456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1997459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1997464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1997467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1997470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1997473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1997476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997502 */     // MIs[0] policy
     /* 1997502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997512 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1997515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1997533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997536 */     // GIR_Coverage, 61949,
     /* 1997536 */     GIR_EraseRootFromParent_Done,
     /* 1997537 */   // Label 26718: @1997537
     /* 1997537 */   GIM_Try, /*On fail goto*//*Label 26719*/ GIMT_Encode4(1997623), // Rule ID 61952 //
     /* 1997542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1997545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1997550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1997553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1997556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1997559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1997562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997588 */     // MIs[0] policy
     /* 1997588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997598 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1997601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1997619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997622 */     // GIR_Coverage, 61952,
     /* 1997622 */     GIR_EraseRootFromParent_Done,
     /* 1997623 */   // Label 26719: @1997623
     /* 1997623 */   GIM_Try, /*On fail goto*//*Label 26720*/ GIMT_Encode4(1997709), // Rule ID 61953 //
     /* 1997628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1997631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1997636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1997639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1997642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1997645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1997648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997674 */     // MIs[0] policy
     /* 1997674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997684 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1997687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1997705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997708 */     // GIR_Coverage, 61953,
     /* 1997708 */     GIR_EraseRootFromParent_Done,
     /* 1997709 */   // Label 26720: @1997709
     /* 1997709 */   GIM_Try, /*On fail goto*//*Label 26721*/ GIMT_Encode4(1997795), // Rule ID 61956 //
     /* 1997714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1997717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1997722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1997725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1997728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1997731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1997734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1997737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1997744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997760 */     // MIs[0] policy
     /* 1997760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997770 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1997773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1997791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997794 */     // GIR_Coverage, 61956,
     /* 1997794 */     GIR_EraseRootFromParent_Done,
     /* 1997795 */   // Label 26721: @1997795
     /* 1997795 */   GIM_Try, /*On fail goto*//*Label 26722*/ GIMT_Encode4(1997881), // Rule ID 61957 //
     /* 1997800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1997803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1997808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1997811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1997814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1997817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1997820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1997823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1997830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997846 */     // MIs[0] policy
     /* 1997846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997856 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1997859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1997877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997880 */     // GIR_Coverage, 61957,
     /* 1997880 */     GIR_EraseRootFromParent_Done,
     /* 1997881 */   // Label 26722: @1997881
     /* 1997881 */   GIM_Try, /*On fail goto*//*Label 26723*/ GIMT_Encode4(1997967), // Rule ID 61960 //
     /* 1997886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1997889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1997894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1997897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1997900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1997903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1997906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997932 */     // MIs[0] policy
     /* 1997932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997942 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1997945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1997949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1997963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997966 */     // GIR_Coverage, 61960,
     /* 1997966 */     GIR_EraseRootFromParent_Done,
     /* 1997967 */   // Label 26723: @1997967
     /* 1997967 */   GIM_Try, /*On fail goto*//*Label 26724*/ GIMT_Encode4(1998053), // Rule ID 61961 //
     /* 1997972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1997975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1997980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1997983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1997986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1997989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1997992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998018 */     // MIs[0] policy
     /* 1998018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998028 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1998031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998052 */     // GIR_Coverage, 61961,
     /* 1998052 */     GIR_EraseRootFromParent_Done,
     /* 1998053 */   // Label 26724: @1998053
     /* 1998053 */   GIM_Try, /*On fail goto*//*Label 26725*/ GIMT_Encode4(1998139), // Rule ID 61964 //
     /* 1998058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1998061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1998066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1998069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1998072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1998075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1998078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998104 */     // MIs[0] policy
     /* 1998104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998114 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1998117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998138 */     // GIR_Coverage, 61964,
     /* 1998138 */     GIR_EraseRootFromParent_Done,
     /* 1998139 */   // Label 26725: @1998139
     /* 1998139 */   GIM_Try, /*On fail goto*//*Label 26726*/ GIMT_Encode4(1998225), // Rule ID 61965 //
     /* 1998144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1998147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1998152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1998155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1998158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1998161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1998164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998190 */     // MIs[0] policy
     /* 1998190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998200 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1998203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998224 */     // GIR_Coverage, 61965,
     /* 1998224 */     GIR_EraseRootFromParent_Done,
     /* 1998225 */   // Label 26726: @1998225
     /* 1998225 */   GIM_Try, /*On fail goto*//*Label 26727*/ GIMT_Encode4(1998311), // Rule ID 61968 //
     /* 1998230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1998233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1998238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1998241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1998244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1998247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1998250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998276 */     // MIs[0] policy
     /* 1998276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1998289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998310 */     // GIR_Coverage, 61968,
     /* 1998310 */     GIR_EraseRootFromParent_Done,
     /* 1998311 */   // Label 26727: @1998311
     /* 1998311 */   GIM_Try, /*On fail goto*//*Label 26728*/ GIMT_Encode4(1998397), // Rule ID 61969 //
     /* 1998316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1998319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1998324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1998327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1998330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1998333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1998336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998362 */     // MIs[0] policy
     /* 1998362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998372 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1998375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998396 */     // GIR_Coverage, 61969,
     /* 1998396 */     GIR_EraseRootFromParent_Done,
     /* 1998397 */   // Label 26728: @1998397
     /* 1998397 */   GIM_Try, /*On fail goto*//*Label 26729*/ GIMT_Encode4(1998483), // Rule ID 61972 //
     /* 1998402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1998405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1998410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1998419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1998422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998448 */     // MIs[0] policy
     /* 1998448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1998461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998482 */     // GIR_Coverage, 61972,
     /* 1998482 */     GIR_EraseRootFromParent_Done,
     /* 1998483 */   // Label 26729: @1998483
     /* 1998483 */   GIM_Try, /*On fail goto*//*Label 26730*/ GIMT_Encode4(1998569), // Rule ID 61973 //
     /* 1998488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1998491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1998496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1998505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1998508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998534 */     // MIs[0] policy
     /* 1998534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1998547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998568 */     // GIR_Coverage, 61973,
     /* 1998568 */     GIR_EraseRootFromParent_Done,
     /* 1998569 */   // Label 26730: @1998569
     /* 1998569 */   GIM_Try, /*On fail goto*//*Label 26731*/ GIMT_Encode4(1998655), // Rule ID 61976 //
     /* 1998574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1998577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1998582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1998591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1998594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998620 */     // MIs[0] policy
     /* 1998620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998630 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1998633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998654 */     // GIR_Coverage, 61976,
     /* 1998654 */     GIR_EraseRootFromParent_Done,
     /* 1998655 */   // Label 26731: @1998655
     /* 1998655 */   GIM_Try, /*On fail goto*//*Label 26732*/ GIMT_Encode4(1998741), // Rule ID 61977 //
     /* 1998660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1998663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1998668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1998677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1998680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998706 */     // MIs[0] policy
     /* 1998706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1998719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998740 */     // GIR_Coverage, 61977,
     /* 1998740 */     GIR_EraseRootFromParent_Done,
     /* 1998741 */   // Label 26732: @1998741
     /* 1998741 */   GIM_Try, /*On fail goto*//*Label 26733*/ GIMT_Encode4(1998827), // Rule ID 61980 //
     /* 1998746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1998749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1998754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1998763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1998766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998792 */     // MIs[0] policy
     /* 1998792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998802 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1998805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998826 */     // GIR_Coverage, 61980,
     /* 1998826 */     GIR_EraseRootFromParent_Done,
     /* 1998827 */   // Label 26733: @1998827
     /* 1998827 */   GIM_Try, /*On fail goto*//*Label 26734*/ GIMT_Encode4(1998913), // Rule ID 61981 //
     /* 1998832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1998835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1998840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1998849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1998852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998878 */     // MIs[0] policy
     /* 1998878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998888 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1998891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998912 */     // GIR_Coverage, 61981,
     /* 1998912 */     GIR_EraseRootFromParent_Done,
     /* 1998913 */   // Label 26734: @1998913
     /* 1998913 */   GIM_Try, /*On fail goto*//*Label 26735*/ GIMT_Encode4(1998999), // Rule ID 61984 //
     /* 1998918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1998921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1998926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1998929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1998932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1998935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1998938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1998941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998964 */     // MIs[0] policy
     /* 1998964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998974 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1998977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1998981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1998995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998998 */     // GIR_Coverage, 61984,
     /* 1998998 */     GIR_EraseRootFromParent_Done,
     /* 1998999 */   // Label 26735: @1998999
     /* 1998999 */   GIM_Try, /*On fail goto*//*Label 26736*/ GIMT_Encode4(1999085), // Rule ID 61985 //
     /* 1999004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1999007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1999012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1999015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1999018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1999021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1999024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1999027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999050 */     // MIs[0] policy
     /* 1999050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999060 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1999063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1999081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999084 */     // GIR_Coverage, 61985,
     /* 1999084 */     GIR_EraseRootFromParent_Done,
     /* 1999085 */   // Label 26736: @1999085
     /* 1999085 */   GIM_Try, /*On fail goto*//*Label 26737*/ GIMT_Encode4(1999171), // Rule ID 61988 //
     /* 1999090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1999093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1999098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1999101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1999104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1999107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1999110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999136 */     // MIs[0] policy
     /* 1999136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999146 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1999149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1999167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999170 */     // GIR_Coverage, 61988,
     /* 1999170 */     GIR_EraseRootFromParent_Done,
     /* 1999171 */   // Label 26737: @1999171
     /* 1999171 */   GIM_Try, /*On fail goto*//*Label 26738*/ GIMT_Encode4(1999257), // Rule ID 61989 //
     /* 1999176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1999179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1999184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1999187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1999190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1999193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1999196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999222 */     // MIs[0] policy
     /* 1999222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999232 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1999235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1999253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999256 */     // GIR_Coverage, 61989,
     /* 1999256 */     GIR_EraseRootFromParent_Done,
     /* 1999257 */   // Label 26738: @1999257
     /* 1999257 */   GIM_Try, /*On fail goto*//*Label 26739*/ GIMT_Encode4(1999343), // Rule ID 61992 //
     /* 1999262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1999265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1999270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1999273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1999276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1999279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1999282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999308 */     // MIs[0] policy
     /* 1999308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999318 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1999321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1999339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999342 */     // GIR_Coverage, 61992,
     /* 1999342 */     GIR_EraseRootFromParent_Done,
     /* 1999343 */   // Label 26739: @1999343
     /* 1999343 */   GIM_Try, /*On fail goto*//*Label 26740*/ GIMT_Encode4(1999429), // Rule ID 61993 //
     /* 1999348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1999351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1999356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1999359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1999362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1999365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1999368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999394 */     // MIs[0] policy
     /* 1999394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999404 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1999407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1999411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1999425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999428 */     // GIR_Coverage, 61993,
     /* 1999428 */     GIR_EraseRootFromParent_Done,
     /* 1999429 */   // Label 26740: @1999429
     /* 1999429 */   GIM_Try, /*On fail goto*//*Label 26741*/ GIMT_Encode4(1999515), // Rule ID 62598 //
     /* 1999434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1999442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1999451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1999454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999480 */     // MIs[0] policy
     /* 1999480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999490 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2_MASK),
     /* 1999493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999514 */     // GIR_Coverage, 62598,
     /* 1999514 */     GIR_EraseRootFromParent_Done,
     /* 1999515 */   // Label 26741: @1999515
     /* 1999515 */   GIM_Try, /*On fail goto*//*Label 26742*/ GIMT_Encode4(1999601), // Rule ID 62599 //
     /* 1999520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1999528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1999537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1999540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999566 */     // MIs[0] policy
     /* 1999566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999576 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2_MASK),
     /* 1999579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999600 */     // GIR_Coverage, 62599,
     /* 1999600 */     GIR_EraseRootFromParent_Done,
     /* 1999601 */   // Label 26742: @1999601
     /* 1999601 */   GIM_Try, /*On fail goto*//*Label 26743*/ GIMT_Encode4(1999687), // Rule ID 62602 //
     /* 1999606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1999614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1999623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1999626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999652 */     // MIs[0] policy
     /* 1999652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999662 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1_MASK),
     /* 1999665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999686 */     // GIR_Coverage, 62602,
     /* 1999686 */     GIR_EraseRootFromParent_Done,
     /* 1999687 */   // Label 26743: @1999687
     /* 1999687 */   GIM_Try, /*On fail goto*//*Label 26744*/ GIMT_Encode4(1999773), // Rule ID 62603 //
     /* 1999692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1999700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1999709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1999712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999738 */     // MIs[0] policy
     /* 1999738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999748 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1_MASK),
     /* 1999751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999772 */     // GIR_Coverage, 62603,
     /* 1999772 */     GIR_EraseRootFromParent_Done,
     /* 1999773 */   // Label 26744: @1999773
     /* 1999773 */   GIM_Try, /*On fail goto*//*Label 26745*/ GIMT_Encode4(1999859), // Rule ID 62606 //
     /* 1999778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1999786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1999789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1999792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1999795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999824 */     // MIs[0] policy
     /* 1999824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2_MASK),
     /* 1999837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999858 */     // GIR_Coverage, 62606,
     /* 1999858 */     GIR_EraseRootFromParent_Done,
     /* 1999859 */   // Label 26745: @1999859
     /* 1999859 */   GIM_Try, /*On fail goto*//*Label 26746*/ GIMT_Encode4(1999945), // Rule ID 62607 //
     /* 1999864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1999872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1999875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1999878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1999881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999910 */     // MIs[0] policy
     /* 1999910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2_MASK),
     /* 1999923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999944 */     // GIR_Coverage, 62607,
     /* 1999944 */     GIR_EraseRootFromParent_Done,
     /* 1999945 */   // Label 26746: @1999945
     /* 1999945 */   GIM_Try, /*On fail goto*//*Label 26747*/ GIMT_Encode4(2000031), // Rule ID 62610 //
     /* 1999950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1999958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1999961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1999964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1999967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1999970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1999973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999996 */     // MIs[0] policy
     /* 1999996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000006 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4_MASK),
     /* 2000009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000030 */     // GIR_Coverage, 62610,
     /* 2000030 */     GIR_EraseRootFromParent_Done,
     /* 2000031 */   // Label 26747: @2000031
     /* 2000031 */   GIM_Try, /*On fail goto*//*Label 26748*/ GIMT_Encode4(2000117), // Rule ID 62611 //
     /* 2000036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 2000044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2000053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000082 */     // MIs[0] policy
     /* 2000082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000092 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4_MASK),
     /* 2000095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000116 */     // GIR_Coverage, 62611,
     /* 2000116 */     GIR_EraseRootFromParent_Done,
     /* 2000117 */   // Label 26748: @2000117
     /* 2000117 */   GIM_Try, /*On fail goto*//*Label 26749*/ GIMT_Encode4(2000203), // Rule ID 62614 //
     /* 2000122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 2000130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2000133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2000136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2000139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2000142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2000145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2000152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000168 */     // MIs[0] policy
     /* 2000168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000178 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8_MASK),
     /* 2000181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000202 */     // GIR_Coverage, 62614,
     /* 2000202 */     GIR_EraseRootFromParent_Done,
     /* 2000203 */   // Label 26749: @2000203
     /* 2000203 */   GIM_Try, /*On fail goto*//*Label 26750*/ GIMT_Encode4(2000289), // Rule ID 62615 //
     /* 2000208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 2000216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2000219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2000222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2000225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2000228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2000231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2000238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000254 */     // MIs[0] policy
     /* 2000254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000264 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8_MASK),
     /* 2000267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000288 */     // GIR_Coverage, 62615,
     /* 2000288 */     GIR_EraseRootFromParent_Done,
     /* 2000289 */   // Label 26750: @2000289
     /* 2000289 */   GIM_Try, /*On fail goto*//*Label 26751*/ GIMT_Encode4(2000375), // Rule ID 62618 //
     /* 2000294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 2000302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2000305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2000308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2000314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000340 */     // MIs[0] policy
     /* 2000340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000350 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2_MASK),
     /* 2000353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000374 */     // GIR_Coverage, 62618,
     /* 2000374 */     GIR_EraseRootFromParent_Done,
     /* 2000375 */   // Label 26751: @2000375
     /* 2000375 */   GIM_Try, /*On fail goto*//*Label 26752*/ GIMT_Encode4(2000461), // Rule ID 62619 //
     /* 2000380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 2000388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2000391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2000394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2000400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000426 */     // MIs[0] policy
     /* 2000426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000436 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2_MASK),
     /* 2000439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000460 */     // GIR_Coverage, 62619,
     /* 2000460 */     GIR_EraseRootFromParent_Done,
     /* 2000461 */   // Label 26752: @2000461
     /* 2000461 */   GIM_Try, /*On fail goto*//*Label 26753*/ GIMT_Encode4(2000547), // Rule ID 62622 //
     /* 2000466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 2000474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2000486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000512 */     // MIs[0] policy
     /* 2000512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000522 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1_MASK),
     /* 2000525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000546 */     // GIR_Coverage, 62622,
     /* 2000546 */     GIR_EraseRootFromParent_Done,
     /* 2000547 */   // Label 26753: @2000547
     /* 2000547 */   GIM_Try, /*On fail goto*//*Label 26754*/ GIMT_Encode4(2000633), // Rule ID 62623 //
     /* 2000552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 2000560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2000572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000598 */     // MIs[0] policy
     /* 2000598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000608 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1_MASK),
     /* 2000611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000632 */     // GIR_Coverage, 62623,
     /* 2000632 */     GIR_EraseRootFromParent_Done,
     /* 2000633 */   // Label 26754: @2000633
     /* 2000633 */   GIM_Try, /*On fail goto*//*Label 26755*/ GIMT_Encode4(2000719), // Rule ID 62626 //
     /* 2000638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 2000646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2000649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2000652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2000658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2000668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000684 */     // MIs[0] policy
     /* 2000684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2_MASK),
     /* 2000697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000718 */     // GIR_Coverage, 62626,
     /* 2000718 */     GIR_EraseRootFromParent_Done,
     /* 2000719 */   // Label 26755: @2000719
     /* 2000719 */   GIM_Try, /*On fail goto*//*Label 26756*/ GIMT_Encode4(2000805), // Rule ID 62627 //
     /* 2000724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 2000732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2000735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2000738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2000744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2000754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000770 */     // MIs[0] policy
     /* 2000770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000780 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2_MASK),
     /* 2000783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000804 */     // GIR_Coverage, 62627,
     /* 2000804 */     GIR_EraseRootFromParent_Done,
     /* 2000805 */   // Label 26756: @2000805
     /* 2000805 */   GIM_Try, /*On fail goto*//*Label 26757*/ GIMT_Encode4(2000891), // Rule ID 62630 //
     /* 2000810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 2000818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000856 */     // MIs[0] policy
     /* 2000856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4_MASK),
     /* 2000869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000890 */     // GIR_Coverage, 62630,
     /* 2000890 */     GIR_EraseRootFromParent_Done,
     /* 2000891 */   // Label 26757: @2000891
     /* 2000891 */   GIM_Try, /*On fail goto*//*Label 26758*/ GIMT_Encode4(2000977), // Rule ID 62631 //
     /* 2000896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 2000904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000942 */     // MIs[0] policy
     /* 2000942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000952 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4_MASK),
     /* 2000955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000976 */     // GIR_Coverage, 62631,
     /* 2000976 */     GIR_EraseRootFromParent_Done,
     /* 2000977 */   // Label 26758: @2000977
     /* 2000977 */   GIM_Try, /*On fail goto*//*Label 26759*/ GIMT_Encode4(2001063), // Rule ID 62634 //
     /* 2000982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 2000990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2000993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2000996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001028 */     // MIs[0] policy
     /* 2001028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8_MASK),
     /* 2001041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001062 */     // GIR_Coverage, 62634,
     /* 2001062 */     GIR_EraseRootFromParent_Done,
     /* 2001063 */   // Label 26759: @2001063
     /* 2001063 */   GIM_Try, /*On fail goto*//*Label 26760*/ GIMT_Encode4(2001149), // Rule ID 62635 //
     /* 2001068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 2001076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001114 */     // MIs[0] policy
     /* 2001114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001124 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8_MASK),
     /* 2001127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001148 */     // GIR_Coverage, 62635,
     /* 2001148 */     GIR_EraseRootFromParent_Done,
     /* 2001149 */   // Label 26760: @2001149
     /* 2001149 */   GIM_Try, /*On fail goto*//*Label 26761*/ GIMT_Encode4(2001235), // Rule ID 62638 //
     /* 2001154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2001162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2001165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2001168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2001171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2001174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001200 */     // MIs[0] policy
     /* 2001200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001210 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2_MASK),
     /* 2001213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001234 */     // GIR_Coverage, 62638,
     /* 2001234 */     GIR_EraseRootFromParent_Done,
     /* 2001235 */   // Label 26761: @2001235
     /* 2001235 */   GIM_Try, /*On fail goto*//*Label 26762*/ GIMT_Encode4(2001321), // Rule ID 62639 //
     /* 2001240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2001248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2001251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2001254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2001257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2001260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001286 */     // MIs[0] policy
     /* 2001286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001296 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2_MASK),
     /* 2001299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001320 */     // GIR_Coverage, 62639,
     /* 2001320 */     GIR_EraseRootFromParent_Done,
     /* 2001321 */   // Label 26762: @2001321
     /* 2001321 */   GIM_Try, /*On fail goto*//*Label 26763*/ GIMT_Encode4(2001407), // Rule ID 62642 //
     /* 2001326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2001334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2001343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2001346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001372 */     // MIs[0] policy
     /* 2001372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001382 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1_MASK),
     /* 2001385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001406 */     // GIR_Coverage, 62642,
     /* 2001406 */     GIR_EraseRootFromParent_Done,
     /* 2001407 */   // Label 26763: @2001407
     /* 2001407 */   GIM_Try, /*On fail goto*//*Label 26764*/ GIMT_Encode4(2001493), // Rule ID 62643 //
     /* 2001412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2001420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2001429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2001432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001458 */     // MIs[0] policy
     /* 2001458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001468 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1_MASK),
     /* 2001471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001492 */     // GIR_Coverage, 62643,
     /* 2001492 */     GIR_EraseRootFromParent_Done,
     /* 2001493 */   // Label 26764: @2001493
     /* 2001493 */   GIM_Try, /*On fail goto*//*Label 26765*/ GIMT_Encode4(2001579), // Rule ID 62646 //
     /* 2001498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2001506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2001515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2001518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001544 */     // MIs[0] policy
     /* 2001544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2_MASK),
     /* 2001557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001578 */     // GIR_Coverage, 62646,
     /* 2001578 */     GIR_EraseRootFromParent_Done,
     /* 2001579 */   // Label 26765: @2001579
     /* 2001579 */   GIM_Try, /*On fail goto*//*Label 26766*/ GIMT_Encode4(2001665), // Rule ID 62647 //
     /* 2001584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2001592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2001601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2001604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001630 */     // MIs[0] policy
     /* 2001630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2_MASK),
     /* 2001643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001664 */     // GIR_Coverage, 62647,
     /* 2001664 */     GIR_EraseRootFromParent_Done,
     /* 2001665 */   // Label 26766: @2001665
     /* 2001665 */   GIM_Try, /*On fail goto*//*Label 26767*/ GIMT_Encode4(2001751), // Rule ID 62650 //
     /* 2001670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2001678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2001681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2001684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2001687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2001690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2001693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001716 */     // MIs[0] policy
     /* 2001716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001726 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4_MASK),
     /* 2001729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001750 */     // GIR_Coverage, 62650,
     /* 2001750 */     GIR_EraseRootFromParent_Done,
     /* 2001751 */   // Label 26767: @2001751
     /* 2001751 */   GIM_Try, /*On fail goto*//*Label 26768*/ GIMT_Encode4(2001837), // Rule ID 62651 //
     /* 2001756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2001764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2001767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2001770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2001773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2001776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2001779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001802 */     // MIs[0] policy
     /* 2001802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001812 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4_MASK),
     /* 2001815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001836 */     // GIR_Coverage, 62651,
     /* 2001836 */     GIR_EraseRootFromParent_Done,
     /* 2001837 */   // Label 26768: @2001837
     /* 2001837 */   GIM_Try, /*On fail goto*//*Label 26769*/ GIMT_Encode4(2001923), // Rule ID 62654 //
     /* 2001842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2001850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2001859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001888 */     // MIs[0] policy
     /* 2001888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001898 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8_MASK),
     /* 2001901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001922 */     // GIR_Coverage, 62654,
     /* 2001922 */     GIR_EraseRootFromParent_Done,
     /* 2001923 */   // Label 26769: @2001923
     /* 2001923 */   GIM_Try, /*On fail goto*//*Label 26770*/ GIMT_Encode4(2002009), // Rule ID 62655 //
     /* 2001928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2001936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2001945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001974 */     // MIs[0] policy
     /* 2001974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001984 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8_MASK),
     /* 2001987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002008 */     // GIR_Coverage, 62655,
     /* 2002008 */     GIR_EraseRootFromParent_Done,
     /* 2002009 */   // Label 26770: @2002009
     /* 2002009 */   GIM_Try, /*On fail goto*//*Label 26771*/ GIMT_Encode4(2002095), // Rule ID 62658 //
     /* 2002014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2002017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2002022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2002025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2002028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2002031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2002034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2002052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002060 */     // MIs[0] policy
     /* 2002060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002070 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2_MASK),
     /* 2002073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002094 */     // GIR_Coverage, 62658,
     /* 2002094 */     GIR_EraseRootFromParent_Done,
     /* 2002095 */   // Label 26771: @2002095
     /* 2002095 */   GIM_Try, /*On fail goto*//*Label 26772*/ GIMT_Encode4(2002181), // Rule ID 62659 //
     /* 2002100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2002103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2002108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2002111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2002114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2002117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2002120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2002138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002146 */     // MIs[0] policy
     /* 2002146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002156 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2_MASK),
     /* 2002159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002180 */     // GIR_Coverage, 62659,
     /* 2002180 */     GIR_EraseRootFromParent_Done,
     /* 2002181 */   // Label 26772: @2002181
     /* 2002181 */   GIM_Try, /*On fail goto*//*Label 26773*/ GIMT_Encode4(2002267), // Rule ID 62662 //
     /* 2002186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2002189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2002194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2002203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2002206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2002209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2002224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002232 */     // MIs[0] policy
     /* 2002232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002242 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1_MASK),
     /* 2002245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002266 */     // GIR_Coverage, 62662,
     /* 2002266 */     GIR_EraseRootFromParent_Done,
     /* 2002267 */   // Label 26773: @2002267
     /* 2002267 */   GIM_Try, /*On fail goto*//*Label 26774*/ GIMT_Encode4(2002353), // Rule ID 62663 //
     /* 2002272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2002275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2002280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2002289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2002292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2002295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2002310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002318 */     // MIs[0] policy
     /* 2002318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002328 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1_MASK),
     /* 2002331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002352 */     // GIR_Coverage, 62663,
     /* 2002352 */     GIR_EraseRootFromParent_Done,
     /* 2002353 */   // Label 26774: @2002353
     /* 2002353 */   GIM_Try, /*On fail goto*//*Label 26775*/ GIMT_Encode4(2002439), // Rule ID 62666 //
     /* 2002358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2002361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2002366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2002369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2002372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2002375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2002378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2002381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2002388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2002396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002404 */     // MIs[0] policy
     /* 2002404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2_MASK),
     /* 2002417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002438 */     // GIR_Coverage, 62666,
     /* 2002438 */     GIR_EraseRootFromParent_Done,
     /* 2002439 */   // Label 26775: @2002439
     /* 2002439 */   GIM_Try, /*On fail goto*//*Label 26776*/ GIMT_Encode4(2002525), // Rule ID 62667 //
     /* 2002444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2002447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2002452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2002455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2002458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2002461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2002464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2002467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2002474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2002482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002490 */     // MIs[0] policy
     /* 2002490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2_MASK),
     /* 2002503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002524 */     // GIR_Coverage, 62667,
     /* 2002524 */     GIR_EraseRootFromParent_Done,
     /* 2002525 */   // Label 26776: @2002525
     /* 2002525 */   GIM_Try, /*On fail goto*//*Label 26777*/ GIMT_Encode4(2002611), // Rule ID 62670 //
     /* 2002530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2002533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2002538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2002541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2002544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2002547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2002550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2002553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2002568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002576 */     // MIs[0] policy
     /* 2002576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4_MASK),
     /* 2002589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002610 */     // GIR_Coverage, 62670,
     /* 2002610 */     GIR_EraseRootFromParent_Done,
     /* 2002611 */   // Label 26777: @2002611
     /* 2002611 */   GIM_Try, /*On fail goto*//*Label 26778*/ GIMT_Encode4(2002697), // Rule ID 62671 //
     /* 2002616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2002619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2002624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2002627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2002630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2002633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2002636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2002639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2002654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002662 */     // MIs[0] policy
     /* 2002662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002672 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4_MASK),
     /* 2002675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002696 */     // GIR_Coverage, 62671,
     /* 2002696 */     GIR_EraseRootFromParent_Done,
     /* 2002697 */   // Label 26778: @2002697
     /* 2002697 */   GIM_Try, /*On fail goto*//*Label 26779*/ GIMT_Encode4(2002783), // Rule ID 62674 //
     /* 2002702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2002705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2002710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2002713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2002716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2002719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2002722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2002725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2002740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002748 */     // MIs[0] policy
     /* 2002748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002758 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8_MASK),
     /* 2002761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002782 */     // GIR_Coverage, 62674,
     /* 2002782 */     GIR_EraseRootFromParent_Done,
     /* 2002783 */   // Label 26779: @2002783
     /* 2002783 */   GIM_Try, /*On fail goto*//*Label 26780*/ GIMT_Encode4(2002869), // Rule ID 62675 //
     /* 2002788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2002791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 2002796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2002799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2002802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2002805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2002808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2002811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2002826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002834 */     // MIs[0] policy
     /* 2002834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002844 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8_MASK),
     /* 2002847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002868 */     // GIR_Coverage, 62675,
     /* 2002868 */     GIR_EraseRootFromParent_Done,
     /* 2002869 */   // Label 26780: @2002869
     /* 2002869 */   GIM_Try, /*On fail goto*//*Label 26781*/ GIMT_Encode4(2002955), // Rule ID 62678 //
     /* 2002874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2002877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2002882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2002885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2002888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2002891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2002894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002920 */     // MIs[0] policy
     /* 2002920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002930 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2_MASK),
     /* 2002933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002954 */     // GIR_Coverage, 62678,
     /* 2002954 */     GIR_EraseRootFromParent_Done,
     /* 2002955 */   // Label 26781: @2002955
     /* 2002955 */   GIM_Try, /*On fail goto*//*Label 26782*/ GIMT_Encode4(2003041), // Rule ID 62679 //
     /* 2002960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2002963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2002968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2002971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2002974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2002977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2002980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003006 */     // MIs[0] policy
     /* 2003006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2_MASK),
     /* 2003019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003040 */     // GIR_Coverage, 62679,
     /* 2003040 */     GIR_EraseRootFromParent_Done,
     /* 2003041 */   // Label 26782: @2003041
     /* 2003041 */   GIM_Try, /*On fail goto*//*Label 26783*/ GIMT_Encode4(2003127), // Rule ID 62682 //
     /* 2003046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2003049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2003054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2003063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2003066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003092 */     // MIs[0] policy
     /* 2003092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003102 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1_MASK),
     /* 2003105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003126 */     // GIR_Coverage, 62682,
     /* 2003126 */     GIR_EraseRootFromParent_Done,
     /* 2003127 */   // Label 26783: @2003127
     /* 2003127 */   GIM_Try, /*On fail goto*//*Label 26784*/ GIMT_Encode4(2003213), // Rule ID 62683 //
     /* 2003132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2003135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2003140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2003149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2003152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003178 */     // MIs[0] policy
     /* 2003178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003188 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1_MASK),
     /* 2003191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003212 */     // GIR_Coverage, 62683,
     /* 2003212 */     GIR_EraseRootFromParent_Done,
     /* 2003213 */   // Label 26784: @2003213
     /* 2003213 */   GIM_Try, /*On fail goto*//*Label 26785*/ GIMT_Encode4(2003299), // Rule ID 62686 //
     /* 2003218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2003221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2003226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2003229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2003232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2003235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2003238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2003241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003264 */     // MIs[0] policy
     /* 2003264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2_MASK),
     /* 2003277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003298 */     // GIR_Coverage, 62686,
     /* 2003298 */     GIR_EraseRootFromParent_Done,
     /* 2003299 */   // Label 26785: @2003299
     /* 2003299 */   GIM_Try, /*On fail goto*//*Label 26786*/ GIMT_Encode4(2003385), // Rule ID 62687 //
     /* 2003304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2003307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2003312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2003315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2003318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2003321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2003324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2003327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003350 */     // MIs[0] policy
     /* 2003350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003360 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2_MASK),
     /* 2003363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003384 */     // GIR_Coverage, 62687,
     /* 2003384 */     GIR_EraseRootFromParent_Done,
     /* 2003385 */   // Label 26786: @2003385
     /* 2003385 */   GIM_Try, /*On fail goto*//*Label 26787*/ GIMT_Encode4(2003471), // Rule ID 62690 //
     /* 2003390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2003393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2003398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2003401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2003404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2003407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2003410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2003413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2003420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003436 */     // MIs[0] policy
     /* 2003436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4_MASK),
     /* 2003449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003470 */     // GIR_Coverage, 62690,
     /* 2003470 */     GIR_EraseRootFromParent_Done,
     /* 2003471 */   // Label 26787: @2003471
     /* 2003471 */   GIM_Try, /*On fail goto*//*Label 26788*/ GIMT_Encode4(2003557), // Rule ID 62691 //
     /* 2003476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2003479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2003484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2003487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2003490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2003493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2003496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2003499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2003506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003522 */     // MIs[0] policy
     /* 2003522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003532 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4_MASK),
     /* 2003535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003556 */     // GIR_Coverage, 62691,
     /* 2003556 */     GIR_EraseRootFromParent_Done,
     /* 2003557 */   // Label 26788: @2003557
     /* 2003557 */   GIM_Try, /*On fail goto*//*Label 26789*/ GIMT_Encode4(2003643), // Rule ID 62694 //
     /* 2003562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2003565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2003570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2003573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2003576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2003579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2003582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2003585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003608 */     // MIs[0] policy
     /* 2003608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8_MASK),
     /* 2003621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003642 */     // GIR_Coverage, 62694,
     /* 2003642 */     GIR_EraseRootFromParent_Done,
     /* 2003643 */   // Label 26789: @2003643
     /* 2003643 */   GIM_Try, /*On fail goto*//*Label 26790*/ GIMT_Encode4(2003729), // Rule ID 62695 //
     /* 2003648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2003651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2003656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2003659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2003662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2003665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2003668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2003671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003694 */     // MIs[0] policy
     /* 2003694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003704 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8_MASK),
     /* 2003707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003728 */     // GIR_Coverage, 62695,
     /* 2003728 */     GIR_EraseRootFromParent_Done,
     /* 2003729 */   // Label 26790: @2003729
     /* 2003729 */   GIM_Try, /*On fail goto*//*Label 26791*/ GIMT_Encode4(2003815), // Rule ID 62698 //
     /* 2003734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2003737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2003742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2003745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2003748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2003751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2003754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2003772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003780 */     // MIs[0] policy
     /* 2003780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003790 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2_MASK),
     /* 2003793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003814 */     // GIR_Coverage, 62698,
     /* 2003814 */     GIR_EraseRootFromParent_Done,
     /* 2003815 */   // Label 26791: @2003815
     /* 2003815 */   GIM_Try, /*On fail goto*//*Label 26792*/ GIMT_Encode4(2003901), // Rule ID 62699 //
     /* 2003820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2003823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2003828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2003831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2003834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2003837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2003840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2003858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003866 */     // MIs[0] policy
     /* 2003866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003876 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2_MASK),
     /* 2003879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003900 */     // GIR_Coverage, 62699,
     /* 2003900 */     GIR_EraseRootFromParent_Done,
     /* 2003901 */   // Label 26792: @2003901
     /* 2003901 */   GIM_Try, /*On fail goto*//*Label 26793*/ GIMT_Encode4(2003987), // Rule ID 62702 //
     /* 2003906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2003909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2003914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2003923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2003926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2003944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003952 */     // MIs[0] policy
     /* 2003952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003962 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1_MASK),
     /* 2003965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003986 */     // GIR_Coverage, 62702,
     /* 2003986 */     GIR_EraseRootFromParent_Done,
     /* 2003987 */   // Label 26793: @2003987
     /* 2003987 */   GIM_Try, /*On fail goto*//*Label 26794*/ GIMT_Encode4(2004073), // Rule ID 62703 //
     /* 2003992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2003995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2004000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2004003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2004006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2004009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2004012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2004030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004038 */     // MIs[0] policy
     /* 2004038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1_MASK),
     /* 2004051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004072 */     // GIR_Coverage, 62703,
     /* 2004072 */     GIR_EraseRootFromParent_Done,
     /* 2004073 */   // Label 26794: @2004073
     /* 2004073 */   GIM_Try, /*On fail goto*//*Label 26795*/ GIMT_Encode4(2004159), // Rule ID 62706 //
     /* 2004078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2004081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2004086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2004089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2004092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2004095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2004098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2004101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2004116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004124 */     // MIs[0] policy
     /* 2004124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2_MASK),
     /* 2004137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004158 */     // GIR_Coverage, 62706,
     /* 2004158 */     GIR_EraseRootFromParent_Done,
     /* 2004159 */   // Label 26795: @2004159
     /* 2004159 */   GIM_Try, /*On fail goto*//*Label 26796*/ GIMT_Encode4(2004245), // Rule ID 62707 //
     /* 2004164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2004167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2004172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2004175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2004178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2004181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2004184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2004187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2004202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004210 */     // MIs[0] policy
     /* 2004210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004220 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2_MASK),
     /* 2004223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004244 */     // GIR_Coverage, 62707,
     /* 2004244 */     GIR_EraseRootFromParent_Done,
     /* 2004245 */   // Label 26796: @2004245
     /* 2004245 */   GIM_Try, /*On fail goto*//*Label 26797*/ GIMT_Encode4(2004331), // Rule ID 62710 //
     /* 2004250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2004253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2004258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2004261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2004264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2004267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2004270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2004273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2004288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004296 */     // MIs[0] policy
     /* 2004296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004306 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4_MASK),
     /* 2004309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004330 */     // GIR_Coverage, 62710,
     /* 2004330 */     GIR_EraseRootFromParent_Done,
     /* 2004331 */   // Label 26797: @2004331
     /* 2004331 */   GIM_Try, /*On fail goto*//*Label 26798*/ GIMT_Encode4(2004417), // Rule ID 62711 //
     /* 2004336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2004339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2004344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2004347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2004350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2004353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2004356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2004359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2004374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004382 */     // MIs[0] policy
     /* 2004382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004392 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4_MASK),
     /* 2004395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004416 */     // GIR_Coverage, 62711,
     /* 2004416 */     GIR_EraseRootFromParent_Done,
     /* 2004417 */   // Label 26798: @2004417
     /* 2004417 */   GIM_Try, /*On fail goto*//*Label 26799*/ GIMT_Encode4(2004503), // Rule ID 62714 //
     /* 2004422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2004425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2004430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2004433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2004436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2004439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2004442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2004445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2004460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004468 */     // MIs[0] policy
     /* 2004468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8_MASK),
     /* 2004481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004502 */     // GIR_Coverage, 62714,
     /* 2004502 */     GIR_EraseRootFromParent_Done,
     /* 2004503 */   // Label 26799: @2004503
     /* 2004503 */   GIM_Try, /*On fail goto*//*Label 26800*/ GIMT_Encode4(2004589), // Rule ID 62715 //
     /* 2004508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2004511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2004516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2004519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2004522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2004525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2004528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2004531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2004546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004554 */     // MIs[0] policy
     /* 2004554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004564 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8_MASK),
     /* 2004567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004588 */     // GIR_Coverage, 62715,
     /* 2004588 */     GIR_EraseRootFromParent_Done,
     /* 2004589 */   // Label 26800: @2004589
     /* 2004589 */   GIM_Try, /*On fail goto*//*Label 26801*/ GIMT_Encode4(2004675), // Rule ID 62718 //
     /* 2004594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2004597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2004602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2004605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2004608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2004611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2004614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2004632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004640 */     // MIs[0] policy
     /* 2004640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004650 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2_MASK),
     /* 2004653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004674 */     // GIR_Coverage, 62718,
     /* 2004674 */     GIR_EraseRootFromParent_Done,
     /* 2004675 */   // Label 26801: @2004675
     /* 2004675 */   GIM_Try, /*On fail goto*//*Label 26802*/ GIMT_Encode4(2004761), // Rule ID 62719 //
     /* 2004680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2004683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2004688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2004691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2004694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2004697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2004700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2004718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004726 */     // MIs[0] policy
     /* 2004726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004736 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2_MASK),
     /* 2004739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004760 */     // GIR_Coverage, 62719,
     /* 2004760 */     GIR_EraseRootFromParent_Done,
     /* 2004761 */   // Label 26802: @2004761
     /* 2004761 */   GIM_Try, /*On fail goto*//*Label 26803*/ GIMT_Encode4(2004847), // Rule ID 62722 //
     /* 2004766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2004769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2004774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2004777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2004780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2004783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2004786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2004804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004812 */     // MIs[0] policy
     /* 2004812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004822 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1_MASK),
     /* 2004825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004846 */     // GIR_Coverage, 62722,
     /* 2004846 */     GIR_EraseRootFromParent_Done,
     /* 2004847 */   // Label 26803: @2004847
     /* 2004847 */   GIM_Try, /*On fail goto*//*Label 26804*/ GIMT_Encode4(2004933), // Rule ID 62723 //
     /* 2004852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2004855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2004860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2004863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2004866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2004869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2004872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2004890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004898 */     // MIs[0] policy
     /* 2004898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004908 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1_MASK),
     /* 2004911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004932 */     // GIR_Coverage, 62723,
     /* 2004932 */     GIR_EraseRootFromParent_Done,
     /* 2004933 */   // Label 26804: @2004933
     /* 2004933 */   GIM_Try, /*On fail goto*//*Label 26805*/ GIMT_Encode4(2005019), // Rule ID 62726 //
     /* 2004938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2004941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2004946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2004949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2004952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2004955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2004958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2004961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2004976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004984 */     // MIs[0] policy
     /* 2004984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004994 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2_MASK),
     /* 2004997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005018 */     // GIR_Coverage, 62726,
     /* 2005018 */     GIR_EraseRootFromParent_Done,
     /* 2005019 */   // Label 26805: @2005019
     /* 2005019 */   GIM_Try, /*On fail goto*//*Label 26806*/ GIMT_Encode4(2005105), // Rule ID 62727 //
     /* 2005024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2005027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2005032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2005035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2005038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2005041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2005044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2005047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2005062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005070 */     // MIs[0] policy
     /* 2005070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005080 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2_MASK),
     /* 2005083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005104 */     // GIR_Coverage, 62727,
     /* 2005104 */     GIR_EraseRootFromParent_Done,
     /* 2005105 */   // Label 26806: @2005105
     /* 2005105 */   GIM_Try, /*On fail goto*//*Label 26807*/ GIMT_Encode4(2005191), // Rule ID 62730 //
     /* 2005110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2005113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2005118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2005121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2005124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2005127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2005130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2005133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2005140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2005148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005156 */     // MIs[0] policy
     /* 2005156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005166 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4_MASK),
     /* 2005169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005190 */     // GIR_Coverage, 62730,
     /* 2005190 */     GIR_EraseRootFromParent_Done,
     /* 2005191 */   // Label 26807: @2005191
     /* 2005191 */   GIM_Try, /*On fail goto*//*Label 26808*/ GIMT_Encode4(2005277), // Rule ID 62731 //
     /* 2005196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2005199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2005204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2005207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2005210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2005213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2005216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2005219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2005226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2005234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005242 */     // MIs[0] policy
     /* 2005242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005252 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4_MASK),
     /* 2005255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005276 */     // GIR_Coverage, 62731,
     /* 2005276 */     GIR_EraseRootFromParent_Done,
     /* 2005277 */   // Label 26808: @2005277
     /* 2005277 */   GIM_Try, /*On fail goto*//*Label 26809*/ GIMT_Encode4(2005363), // Rule ID 62734 //
     /* 2005282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2005285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2005290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2005293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2005296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2005299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2005302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2005305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2005320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005328 */     // MIs[0] policy
     /* 2005328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005338 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8_MASK),
     /* 2005341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005362 */     // GIR_Coverage, 62734,
     /* 2005362 */     GIR_EraseRootFromParent_Done,
     /* 2005363 */   // Label 26809: @2005363
     /* 2005363 */   GIM_Try, /*On fail goto*//*Label 26810*/ GIMT_Encode4(2005449), // Rule ID 62735 //
     /* 2005368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2005371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2005376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2005379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2005382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2005385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2005388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2005391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2005406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005414 */     // MIs[0] policy
     /* 2005414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005424 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8_MASK),
     /* 2005427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005448 */     // GIR_Coverage, 62735,
     /* 2005448 */     GIR_EraseRootFromParent_Done,
     /* 2005449 */   // Label 26810: @2005449
     /* 2005449 */   GIM_Try, /*On fail goto*//*Label 26811*/ GIMT_Encode4(2005535), // Rule ID 65111 //
     /* 2005454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2005462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2005465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2005468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2005471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2005474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005500 */     // MIs[0] policy
     /* 2005500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005510 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11006:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2_MASK),
     /* 2005513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005534 */     // GIR_Coverage, 65111,
     /* 2005534 */     GIR_EraseRootFromParent_Done,
     /* 2005535 */   // Label 26811: @2005535
     /* 2005535 */   GIM_Try, /*On fail goto*//*Label 26812*/ GIMT_Encode4(2005621), // Rule ID 65112 //
     /* 2005540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2005548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2005551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2005554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2005557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2005560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005586 */     // MIs[0] policy
     /* 2005586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005596 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11006:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2_MASK),
     /* 2005599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005620 */     // GIR_Coverage, 65112,
     /* 2005620 */     GIR_EraseRootFromParent_Done,
     /* 2005621 */   // Label 26812: @2005621
     /* 2005621 */   GIM_Try, /*On fail goto*//*Label 26813*/ GIMT_Encode4(2005707), // Rule ID 65115 //
     /* 2005626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2005634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2005643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2005646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005672 */     // MIs[0] policy
     /* 2005672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11006:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2005685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005706 */     // GIR_Coverage, 65115,
     /* 2005706 */     GIR_EraseRootFromParent_Done,
     /* 2005707 */   // Label 26813: @2005707
     /* 2005707 */   GIM_Try, /*On fail goto*//*Label 26814*/ GIMT_Encode4(2005793), // Rule ID 65116 //
     /* 2005712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2005720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2005729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2005732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005758 */     // MIs[0] policy
     /* 2005758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005768 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11006:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2005771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005792 */     // GIR_Coverage, 65116,
     /* 2005792 */     GIR_EraseRootFromParent_Done,
     /* 2005793 */   // Label 26814: @2005793
     /* 2005793 */   GIM_Try, /*On fail goto*//*Label 26815*/ GIMT_Encode4(2005879), // Rule ID 65119 //
     /* 2005798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2005806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2005809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2005812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2005815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2005818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005844 */     // MIs[0] policy
     /* 2005844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11006:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2005857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005878 */     // GIR_Coverage, 65119,
     /* 2005878 */     GIR_EraseRootFromParent_Done,
     /* 2005879 */   // Label 26815: @2005879
     /* 2005879 */   GIM_Try, /*On fail goto*//*Label 26816*/ GIMT_Encode4(2005965), // Rule ID 65120 //
     /* 2005884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2005892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2005895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2005898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2005901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2005904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005930 */     // MIs[0] policy
     /* 2005930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11006:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2005943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005964 */     // GIR_Coverage, 65120,
     /* 2005964 */     GIR_EraseRootFromParent_Done,
     /* 2005965 */   // Label 26816: @2005965
     /* 2005965 */   GIM_Try, /*On fail goto*//*Label 26817*/ GIMT_Encode4(2006051), // Rule ID 65123 //
     /* 2005970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2005978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2005981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2005984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2005987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2005990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006016 */     // MIs[0] policy
     /* 2006016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006026 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11006:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2006029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006050 */     // GIR_Coverage, 65123,
     /* 2006050 */     GIR_EraseRootFromParent_Done,
     /* 2006051 */   // Label 26817: @2006051
     /* 2006051 */   GIM_Try, /*On fail goto*//*Label 26818*/ GIMT_Encode4(2006137), // Rule ID 65124 //
     /* 2006056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2006059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2006064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2006067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2006070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2006073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2006076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006102 */     // MIs[0] policy
     /* 2006102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11006:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2006115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006136 */     // GIR_Coverage, 65124,
     /* 2006136 */     GIR_EraseRootFromParent_Done,
     /* 2006137 */   // Label 26818: @2006137
     /* 2006137 */   GIM_Try, /*On fail goto*//*Label 26819*/ GIMT_Encode4(2006223), // Rule ID 65127 //
     /* 2006142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2006145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2006150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2006153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2006156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2006159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2006162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2006165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006188 */     // MIs[0] policy
     /* 2006188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11006:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2006201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006222 */     // GIR_Coverage, 65127,
     /* 2006222 */     GIR_EraseRootFromParent_Done,
     /* 2006223 */   // Label 26819: @2006223
     /* 2006223 */   GIM_Try, /*On fail goto*//*Label 26820*/ GIMT_Encode4(2006309), // Rule ID 65128 //
     /* 2006228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2006231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2006236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2006239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2006242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2006245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2006248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2006251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006274 */     // MIs[0] policy
     /* 2006274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006284 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11006:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2006287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006308 */     // GIR_Coverage, 65128,
     /* 2006308 */     GIR_EraseRootFromParent_Done,
     /* 2006309 */   // Label 26820: @2006309
     /* 2006309 */   GIM_Try, /*On fail goto*//*Label 26821*/ GIMT_Encode4(2006395), // Rule ID 65131 //
     /* 2006314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2006322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2006331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006360 */     // MIs[0] policy
     /* 2006360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006370 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11006:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2006373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006394 */     // GIR_Coverage, 65131,
     /* 2006394 */     GIR_EraseRootFromParent_Done,
     /* 2006395 */   // Label 26821: @2006395
     /* 2006395 */   GIM_Try, /*On fail goto*//*Label 26822*/ GIMT_Encode4(2006481), // Rule ID 65132 //
     /* 2006400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2006408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2006417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006446 */     // MIs[0] policy
     /* 2006446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006456 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11006:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2006459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006480 */     // GIR_Coverage, 65132,
     /* 2006480 */     GIR_EraseRootFromParent_Done,
     /* 2006481 */   // Label 26822: @2006481
     /* 2006481 */   GIM_Try, /*On fail goto*//*Label 26823*/ GIMT_Encode4(2006567), // Rule ID 65135 //
     /* 2006486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2006494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2006497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2006500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2006503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2006506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2006516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006532 */     // MIs[0] policy
     /* 2006532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11006:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2006545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006566 */     // GIR_Coverage, 65135,
     /* 2006566 */     GIR_EraseRootFromParent_Done,
     /* 2006567 */   // Label 26823: @2006567
     /* 2006567 */   GIM_Try, /*On fail goto*//*Label 26824*/ GIMT_Encode4(2006653), // Rule ID 65136 //
     /* 2006572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2006580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2006583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2006586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2006589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2006592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2006602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006618 */     // MIs[0] policy
     /* 2006618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11006:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2006631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006652 */     // GIR_Coverage, 65136,
     /* 2006652 */     GIR_EraseRootFromParent_Done,
     /* 2006653 */   // Label 26824: @2006653
     /* 2006653 */   GIM_Try, /*On fail goto*//*Label 26825*/ GIMT_Encode4(2006739), // Rule ID 65139 //
     /* 2006658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2006666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2006669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2006672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2006675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2006678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006704 */     // MIs[0] policy
     /* 2006704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006714 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11006:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2006717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006738 */     // GIR_Coverage, 65139,
     /* 2006738 */     GIR_EraseRootFromParent_Done,
     /* 2006739 */   // Label 26825: @2006739
     /* 2006739 */   GIM_Try, /*On fail goto*//*Label 26826*/ GIMT_Encode4(2006825), // Rule ID 65140 //
     /* 2006744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2006752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2006755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2006758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2006761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2006764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006790 */     // MIs[0] policy
     /* 2006790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006800 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11006:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2006803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006824 */     // GIR_Coverage, 65140,
     /* 2006824 */     GIR_EraseRootFromParent_Done,
     /* 2006825 */   // Label 26826: @2006825
     /* 2006825 */   GIM_Try, /*On fail goto*//*Label 26827*/ GIMT_Encode4(2006911), // Rule ID 65143 //
     /* 2006830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2006838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2006841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2006844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2006847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2006850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006876 */     // MIs[0] policy
     /* 2006876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11006:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2006889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006910 */     // GIR_Coverage, 65143,
     /* 2006910 */     GIR_EraseRootFromParent_Done,
     /* 2006911 */   // Label 26827: @2006911
     /* 2006911 */   GIM_Try, /*On fail goto*//*Label 26828*/ GIMT_Encode4(2006997), // Rule ID 65144 //
     /* 2006916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2006924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2006927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2006930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2006933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2006936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006962 */     // MIs[0] policy
     /* 2006962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006972 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11006:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2006975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006996 */     // GIR_Coverage, 65144,
     /* 2006996 */     GIR_EraseRootFromParent_Done,
     /* 2006997 */   // Label 26828: @2006997
     /* 2006997 */   GIM_Try, /*On fail goto*//*Label 26829*/ GIMT_Encode4(2007083), // Rule ID 65147 //
     /* 2007002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2007005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2007010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2007013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2007016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2007019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2007022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2007028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007048 */     // MIs[0] policy
     /* 2007048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2007051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007058 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11010:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2_MASK),
     /* 2007061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2007081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007082 */     // GIR_Coverage, 65147,
     /* 2007082 */     GIR_EraseRootFromParent_Done,
     /* 2007083 */   // Label 26829: @2007083
     /* 2007083 */   GIM_Try, /*On fail goto*//*Label 26830*/ GIMT_Encode4(2007169), // Rule ID 65148 //
     /* 2007088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2007091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2007096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2007099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2007102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2007105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2007108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2007114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007134 */     // MIs[0] policy
     /* 2007134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2007137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007144 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11010:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2_MASK),
     /* 2007147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2007167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007168 */     // GIR_Coverage, 65148,
     /* 2007168 */     GIR_EraseRootFromParent_Done,
     /* 2007169 */   // Label 26830: @2007169
     /* 2007169 */   GIM_Try, /*On fail goto*//*Label 26831*/ GIMT_Encode4(2007255), // Rule ID 65151 //
     /* 2007174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2007177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2007182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2007191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2007194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2007200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007220 */     // MIs[0] policy
     /* 2007220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2007223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11010:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2007233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2007253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007254 */     // GIR_Coverage, 65151,
     /* 2007254 */     GIR_EraseRootFromParent_Done,
     /* 2007255 */   // Label 26831: @2007255
     /* 2007255 */   GIM_Try, /*On fail goto*//*Label 26832*/ GIMT_Encode4(2007341), // Rule ID 65152 //
     /* 2007260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2007263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2007268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2007277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2007280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2007286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007306 */     // MIs[0] policy
     /* 2007306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2007309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11010:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2007319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2007339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007340 */     // GIR_Coverage, 65152,
     /* 2007340 */     GIR_EraseRootFromParent_Done,
     /* 2007341 */   // Label 26832: @2007341
     /* 2007341 */   GIM_Try, /*On fail goto*//*Label 26833*/ GIMT_Encode4(2007427), // Rule ID 65155 //
     /* 2007346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2007349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2007354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2007357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2007360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2007363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2007366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2007372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2007376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007392 */     // MIs[0] policy
     /* 2007392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2007395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11010:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2007405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2007425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007426 */     // GIR_Coverage, 65155,
     /* 2007426 */     GIR_EraseRootFromParent_Done,
     /* 2007427 */   // Label 26833: @2007427
     /* 2007427 */   GIM_Try, /*On fail goto*//*Label 26834*/ GIMT_Encode4(2007513), // Rule ID 65156 //
     /* 2007432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2007435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2007440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2007443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2007446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2007449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2007452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2007458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2007462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007478 */     // MIs[0] policy
     /* 2007478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2007481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007488 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11010:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2007491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2007511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007512 */     // GIR_Coverage, 65156,
     /* 2007512 */     GIR_EraseRootFromParent_Done,
     /* 2007513 */   // Label 26834: @2007513
     /* 2007513 */   GIM_Try, /*On fail goto*//*Label 26835*/ GIMT_Encode4(2007599), // Rule ID 65159 //
     /* 2007518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2007521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2007526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2007529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2007532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2007535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2007538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2007544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2007548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007564 */     // MIs[0] policy
     /* 2007564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2007567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11010:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2007577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2007597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007598 */     // GIR_Coverage, 65159,
     /* 2007598 */     GIR_EraseRootFromParent_Done,
     /* 2007599 */   // Label 26835: @2007599
     /* 2007599 */   GIM_Try, /*On fail goto*//*Label 26836*/ GIMT_Encode4(2007685), // Rule ID 65160 //
     /* 2007604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2007607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2007612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2007615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2007618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2007621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2007624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2007630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2007634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007650 */     // MIs[0] policy
     /* 2007650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2007653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007660 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11010:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2007663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2007683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007684 */     // GIR_Coverage, 65160,
     /* 2007684 */     GIR_EraseRootFromParent_Done,
     /* 2007685 */   // Label 26836: @2007685
     /* 2007685 */   GIM_Try, /*On fail goto*//*Label 26837*/ GIMT_Encode4(2007771), // Rule ID 65163 //
     /* 2007690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2007693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2007698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2007701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2007704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2007707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2007710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2007716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2007720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007736 */     // MIs[0] policy
     /* 2007736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2007739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007746 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11010:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2007749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2007769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007770 */     // GIR_Coverage, 65163,
     /* 2007770 */     GIR_EraseRootFromParent_Done,
     /* 2007771 */   // Label 26837: @2007771
     /* 2007771 */   GIM_Try, /*On fail goto*//*Label 26838*/ GIMT_Encode4(2007857), // Rule ID 65164 //
     /* 2007776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2007779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2007784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2007787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2007790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2007793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2007796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2007802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2007806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007822 */     // MIs[0] policy
     /* 2007822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2007825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007832 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11010:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2007835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2007855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007856 */     // GIR_Coverage, 65164,
     /* 2007856 */     GIR_EraseRootFromParent_Done,
     /* 2007857 */   // Label 26838: @2007857
     /* 2007857 */   GIM_Try, /*On fail goto*//*Label 26839*/ GIMT_Encode4(2007943), // Rule ID 65167 //
     /* 2007862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2007865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2007870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2007879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2007888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007908 */     // MIs[0] policy
     /* 2007908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2007911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007918 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11010:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2007921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2007941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007942 */     // GIR_Coverage, 65167,
     /* 2007942 */     GIR_EraseRootFromParent_Done,
     /* 2007943 */   // Label 26839: @2007943
     /* 2007943 */   GIM_Try, /*On fail goto*//*Label 26840*/ GIMT_Encode4(2008029), // Rule ID 65168 //
     /* 2007948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2007951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2007956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2007965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2007974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007994 */     // MIs[0] policy
     /* 2007994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2007997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008004 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11010:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2008007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2008027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008028 */     // GIR_Coverage, 65168,
     /* 2008028 */     GIR_EraseRootFromParent_Done,
     /* 2008029 */   // Label 26840: @2008029
     /* 2008029 */   GIM_Try, /*On fail goto*//*Label 26841*/ GIMT_Encode4(2008115), // Rule ID 65171 //
     /* 2008034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2008037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2008042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2008045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2008048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2008051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2008054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2008060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2008064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008080 */     // MIs[0] policy
     /* 2008080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2008083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008090 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11010:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2008093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2008113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008114 */     // GIR_Coverage, 65171,
     /* 2008114 */     GIR_EraseRootFromParent_Done,
     /* 2008115 */   // Label 26841: @2008115
     /* 2008115 */   GIM_Try, /*On fail goto*//*Label 26842*/ GIMT_Encode4(2008201), // Rule ID 65172 //
     /* 2008120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2008123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2008128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2008131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2008134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2008137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2008140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2008146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2008150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008166 */     // MIs[0] policy
     /* 2008166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2008169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008176 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11010:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2008179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2008199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008200 */     // GIR_Coverage, 65172,
     /* 2008200 */     GIR_EraseRootFromParent_Done,
     /* 2008201 */   // Label 26842: @2008201
     /* 2008201 */   GIM_Try, /*On fail goto*//*Label 26843*/ GIMT_Encode4(2008287), // Rule ID 65175 //
     /* 2008206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2008209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2008214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2008217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2008220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2008223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2008226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2008232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2008236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008252 */     // MIs[0] policy
     /* 2008252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2008255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008262 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11010:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2008265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2008285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008286 */     // GIR_Coverage, 65175,
     /* 2008286 */     GIR_EraseRootFromParent_Done,
     /* 2008287 */   // Label 26843: @2008287
     /* 2008287 */   GIM_Try, /*On fail goto*//*Label 26844*/ GIMT_Encode4(2008373), // Rule ID 65176 //
     /* 2008292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2008295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2008300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2008303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2008306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2008309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2008312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2008318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2008322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008338 */     // MIs[0] policy
     /* 2008338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2008341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008348 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11010:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2008351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2008371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008372 */     // GIR_Coverage, 65176,
     /* 2008372 */     GIR_EraseRootFromParent_Done,
     /* 2008373 */   // Label 26844: @2008373
     /* 2008373 */   GIM_Try, /*On fail goto*//*Label 26845*/ GIMT_Encode4(2008459), // Rule ID 65179 //
     /* 2008378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2008381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2008386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2008389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2008392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2008395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2008398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2008404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2008408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008424 */     // MIs[0] policy
     /* 2008424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2008427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11010:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2008437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2008457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008458 */     // GIR_Coverage, 65179,
     /* 2008458 */     GIR_EraseRootFromParent_Done,
     /* 2008459 */   // Label 26845: @2008459
     /* 2008459 */   GIM_Try, /*On fail goto*//*Label 26846*/ GIMT_Encode4(2008545), // Rule ID 65180 //
     /* 2008464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2008467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2008472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2008475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2008478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2008481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2008484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2008490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2008494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008510 */     // MIs[0] policy
     /* 2008510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2008513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008520 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11010:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2008523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2008543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008544 */     // GIR_Coverage, 65180,
     /* 2008544 */     GIR_EraseRootFromParent_Done,
     /* 2008545 */   // Label 26846: @2008545
     /* 2008545 */   GIM_Try, /*On fail goto*//*Label 26847*/ GIMT_Encode4(2008631), // Rule ID 65183 //
     /* 2008550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2008553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2008558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2008561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2008564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2008567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2008570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2008573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2008576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008596 */     // MIs[0] policy
     /* 2008596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2008599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008606 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2_MASK),
     /* 2008609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2008629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008630 */     // GIR_Coverage, 65183,
     /* 2008630 */     GIR_EraseRootFromParent_Done,
     /* 2008631 */   // Label 26847: @2008631
     /* 2008631 */   GIM_Try, /*On fail goto*//*Label 26848*/ GIMT_Encode4(2008717), // Rule ID 65184 //
     /* 2008636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2008639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2008644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2008647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2008650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2008653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2008656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2008659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2008662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008682 */     // MIs[0] policy
     /* 2008682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2008685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008692 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2_MASK),
     /* 2008695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2008715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008716 */     // GIR_Coverage, 65184,
     /* 2008716 */     GIR_EraseRootFromParent_Done,
     /* 2008717 */   // Label 26848: @2008717
     /* 2008717 */   GIM_Try, /*On fail goto*//*Label 26849*/ GIMT_Encode4(2008803), // Rule ID 65187 //
     /* 2008722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2008725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2008730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2008739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2008742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2008748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008768 */     // MIs[0] policy
     /* 2008768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2008771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008778 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2008781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2008801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008802 */     // GIR_Coverage, 65187,
     /* 2008802 */     GIR_EraseRootFromParent_Done,
     /* 2008803 */   // Label 26849: @2008803
     /* 2008803 */   GIM_Try, /*On fail goto*//*Label 26850*/ GIMT_Encode4(2008889), // Rule ID 65188 //
     /* 2008808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2008811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2008816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2008825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2008828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2008834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008854 */     // MIs[0] policy
     /* 2008854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2008857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008864 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11008:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2008867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2008887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008888 */     // GIR_Coverage, 65188,
     /* 2008888 */     GIR_EraseRootFromParent_Done,
     /* 2008889 */   // Label 26850: @2008889
     /* 2008889 */   GIM_Try, /*On fail goto*//*Label 26851*/ GIMT_Encode4(2008975), // Rule ID 65191 //
     /* 2008894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2008897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2008902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2008905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2008908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2008911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2008914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2008920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2008924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008940 */     // MIs[0] policy
     /* 2008940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2008943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2008953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2008973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008974 */     // GIR_Coverage, 65191,
     /* 2008974 */     GIR_EraseRootFromParent_Done,
     /* 2008975 */   // Label 26851: @2008975
     /* 2008975 */   GIM_Try, /*On fail goto*//*Label 26852*/ GIMT_Encode4(2009061), // Rule ID 65192 //
     /* 2008980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2008983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2008988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2008991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2008994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2008997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2009000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2009006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2009010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009026 */     // MIs[0] policy
     /* 2009026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2009029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009036 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2009039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2009059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009060 */     // GIR_Coverage, 65192,
     /* 2009060 */     GIR_EraseRootFromParent_Done,
     /* 2009061 */   // Label 26852: @2009061
     /* 2009061 */   GIM_Try, /*On fail goto*//*Label 26853*/ GIMT_Encode4(2009147), // Rule ID 65195 //
     /* 2009066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2009069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2009074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2009077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2009080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2009083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2009086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2009089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2009092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2009096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009112 */     // MIs[0] policy
     /* 2009112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2009115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009122 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2009125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2009145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009146 */     // GIR_Coverage, 65195,
     /* 2009146 */     GIR_EraseRootFromParent_Done,
     /* 2009147 */   // Label 26853: @2009147
     /* 2009147 */   GIM_Try, /*On fail goto*//*Label 26854*/ GIMT_Encode4(2009233), // Rule ID 65196 //
     /* 2009152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2009155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2009160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2009163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2009166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2009169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2009172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2009175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2009178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2009182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009198 */     // MIs[0] policy
     /* 2009198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2009201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009208 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2009211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2009231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009232 */     // GIR_Coverage, 65196,
     /* 2009232 */     GIR_EraseRootFromParent_Done,
     /* 2009233 */   // Label 26854: @2009233
     /* 2009233 */   GIM_Try, /*On fail goto*//*Label 26855*/ GIMT_Encode4(2009319), // Rule ID 65199 //
     /* 2009238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2009241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2009246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2009249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2009252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2009255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2009258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2009261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2009264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2009268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009284 */     // MIs[0] policy
     /* 2009284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2009287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009294 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2009297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2009317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009318 */     // GIR_Coverage, 65199,
     /* 2009318 */     GIR_EraseRootFromParent_Done,
     /* 2009319 */   // Label 26855: @2009319
     /* 2009319 */   GIM_Try, /*On fail goto*//*Label 26856*/ GIMT_Encode4(2009405), // Rule ID 65200 //
     /* 2009324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2009327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2009332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2009335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2009338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2009341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2009344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2009347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2009350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2009354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009370 */     // MIs[0] policy
     /* 2009370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2009373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009380 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2009383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2009403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009404 */     // GIR_Coverage, 65200,
     /* 2009404 */     GIR_EraseRootFromParent_Done,
     /* 2009405 */   // Label 26856: @2009405
     /* 2009405 */   GIM_Try, /*On fail goto*//*Label 26857*/ GIMT_Encode4(2009491), // Rule ID 65203 //
     /* 2009410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2009413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2009418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2009427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2009436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009456 */     // MIs[0] policy
     /* 2009456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2009459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009466 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2009469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2009489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009490 */     // GIR_Coverage, 65203,
     /* 2009490 */     GIR_EraseRootFromParent_Done,
     /* 2009491 */   // Label 26857: @2009491
     /* 2009491 */   GIM_Try, /*On fail goto*//*Label 26858*/ GIMT_Encode4(2009577), // Rule ID 65204 //
     /* 2009496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2009499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2009504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2009513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2009522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009542 */     // MIs[0] policy
     /* 2009542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2009545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009552 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11008:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2009555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2009575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009576 */     // GIR_Coverage, 65204,
     /* 2009576 */     GIR_EraseRootFromParent_Done,
     /* 2009577 */   // Label 26858: @2009577
     /* 2009577 */   GIM_Try, /*On fail goto*//*Label 26859*/ GIMT_Encode4(2009663), // Rule ID 65207 //
     /* 2009582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2009585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2009590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2009593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2009596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2009599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2009602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2009608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2009612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009628 */     // MIs[0] policy
     /* 2009628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2009631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009638 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2009641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2009661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009662 */     // GIR_Coverage, 65207,
     /* 2009662 */     GIR_EraseRootFromParent_Done,
     /* 2009663 */   // Label 26859: @2009663
     /* 2009663 */   GIM_Try, /*On fail goto*//*Label 26860*/ GIMT_Encode4(2009749), // Rule ID 65208 //
     /* 2009668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2009671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2009676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2009679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2009682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2009685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2009688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2009694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2009698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2009710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009714 */     // MIs[0] policy
     /* 2009714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2009717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11008:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2009727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2009747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009748 */     // GIR_Coverage, 65208,
     /* 2009748 */     GIR_EraseRootFromParent_Done,
     /* 2009749 */   // Label 26860: @2009749
     /* 2009749 */   GIM_Try, /*On fail goto*//*Label 26861*/ GIMT_Encode4(2009835), // Rule ID 65211 //
     /* 2009754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2009757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2009762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2009765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2009768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2009771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2009774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2009780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2009784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009800 */     // MIs[0] policy
     /* 2009800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2009803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009810 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2009813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2009833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009834 */     // GIR_Coverage, 65211,
     /* 2009834 */     GIR_EraseRootFromParent_Done,
     /* 2009835 */   // Label 26861: @2009835
     /* 2009835 */   GIM_Try, /*On fail goto*//*Label 26862*/ GIMT_Encode4(2009921), // Rule ID 65212 //
     /* 2009840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2009843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2009848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2009851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2009854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2009857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2009860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2009866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2009870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009886 */     // MIs[0] policy
     /* 2009886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2009889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11008:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2009899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2009919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009920 */     // GIR_Coverage, 65212,
     /* 2009920 */     GIR_EraseRootFromParent_Done,
     /* 2009921 */   // Label 26862: @2009921
     /* 2009921 */   GIM_Try, /*On fail goto*//*Label 26863*/ GIMT_Encode4(2010007), // Rule ID 65215 //
     /* 2009926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2009929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2009934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2009937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2009940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2009943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2009946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2009949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2009952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2009956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009972 */     // MIs[0] policy
     /* 2009972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2009975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009982 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2009985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2010005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010006 */     // GIR_Coverage, 65215,
     /* 2010006 */     GIR_EraseRootFromParent_Done,
     /* 2010007 */   // Label 26863: @2010007
     /* 2010007 */   GIM_Try, /*On fail goto*//*Label 26864*/ GIMT_Encode4(2010093), // Rule ID 65216 //
     /* 2010012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2010015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2010020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2010023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2010026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2010029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2010032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2010038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2010042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010058 */     // MIs[0] policy
     /* 2010058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2010061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010068 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11008:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2010071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2010091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010092 */     // GIR_Coverage, 65216,
     /* 2010092 */     GIR_EraseRootFromParent_Done,
     /* 2010093 */   // Label 26864: @2010093
     /* 2010093 */   GIM_Try, /*On fail goto*//*Label 26865*/ GIMT_Encode4(2010182), // Rule ID 2778 //
     /* 2010098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2010106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2010115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010144 */     // MIs[0] round
     /* 2010144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010154 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 2010157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010181 */     // GIR_Coverage, 2778,
     /* 2010181 */     GIR_EraseRootFromParent_Done,
     /* 2010182 */   // Label 26865: @2010182
     /* 2010182 */   GIM_Try, /*On fail goto*//*Label 26866*/ GIMT_Encode4(2010271), // Rule ID 2779 //
     /* 2010187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2010195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2010204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010233 */     // MIs[0] round
     /* 2010233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010243 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 2010246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010270 */     // GIR_Coverage, 2779,
     /* 2010270 */     GIR_EraseRootFromParent_Done,
     /* 2010271 */   // Label 26866: @2010271
     /* 2010271 */   GIM_Try, /*On fail goto*//*Label 26867*/ GIMT_Encode4(2010360), // Rule ID 22824 //
     /* 2010276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2010284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2010293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010322 */     // MIs[0] round
     /* 2010322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010332 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 2010335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010359 */     // GIR_Coverage, 22824,
     /* 2010359 */     GIR_EraseRootFromParent_Done,
     /* 2010360 */   // Label 26867: @2010360
     /* 2010360 */   GIM_Try, /*On fail goto*//*Label 26868*/ GIMT_Encode4(2010449), // Rule ID 22825 //
     /* 2010365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2010373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2010382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010411 */     // MIs[0] round
     /* 2010411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010421 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 2010424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010448 */     // GIR_Coverage, 22825,
     /* 2010448 */     GIR_EraseRootFromParent_Done,
     /* 2010449 */   // Label 26868: @2010449
     /* 2010449 */   GIM_Try, /*On fail goto*//*Label 26869*/ GIMT_Encode4(2010538), // Rule ID 22828 //
     /* 2010454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2010457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2010462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2010471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010500 */     // MIs[0] round
     /* 2010500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010510 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 2010513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010537 */     // GIR_Coverage, 22828,
     /* 2010537 */     GIR_EraseRootFromParent_Done,
     /* 2010538 */   // Label 26869: @2010538
     /* 2010538 */   GIM_Try, /*On fail goto*//*Label 26870*/ GIMT_Encode4(2010627), // Rule ID 22829 //
     /* 2010543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2010546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2010551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2010560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010589 */     // MIs[0] round
     /* 2010589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010599 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 2010602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010626 */     // GIR_Coverage, 22829,
     /* 2010626 */     GIR_EraseRootFromParent_Done,
     /* 2010627 */   // Label 26870: @2010627
     /* 2010627 */   GIM_Try, /*On fail goto*//*Label 26871*/ GIMT_Encode4(2010716), // Rule ID 22832 //
     /* 2010632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2010640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2010649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010678 */     // MIs[0] round
     /* 2010678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010688 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 2010691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010715 */     // GIR_Coverage, 22832,
     /* 2010715 */     GIR_EraseRootFromParent_Done,
     /* 2010716 */   // Label 26871: @2010716
     /* 2010716 */   GIM_Try, /*On fail goto*//*Label 26872*/ GIMT_Encode4(2010805), // Rule ID 22833 //
     /* 2010721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2010729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2010738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010767 */     // MIs[0] round
     /* 2010767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010777 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 2010780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010804 */     // GIR_Coverage, 22833,
     /* 2010804 */     GIR_EraseRootFromParent_Done,
     /* 2010805 */   // Label 26872: @2010805
     /* 2010805 */   GIM_Try, /*On fail goto*//*Label 26873*/ GIMT_Encode4(2010894), // Rule ID 22836 //
     /* 2010810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2010813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2010818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2010827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010856 */     // MIs[0] round
     /* 2010856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010866 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 2010869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010893 */     // GIR_Coverage, 22836,
     /* 2010893 */     GIR_EraseRootFromParent_Done,
     /* 2010894 */   // Label 26873: @2010894
     /* 2010894 */   GIM_Try, /*On fail goto*//*Label 26874*/ GIMT_Encode4(2010983), // Rule ID 22837 //
     /* 2010899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2010902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2010907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2010916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010945 */     // MIs[0] round
     /* 2010945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010955 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 2010958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010982 */     // GIR_Coverage, 22837,
     /* 2010982 */     GIR_EraseRootFromParent_Done,
     /* 2010983 */   // Label 26874: @2010983
     /* 2010983 */   GIM_Try, /*On fail goto*//*Label 26875*/ GIMT_Encode4(2011072), // Rule ID 22840 //
     /* 2010988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2010991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2010996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2010999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2011005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2011011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011034 */     // MIs[0] round
     /* 2011034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011044 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 2011047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011071 */     // GIR_Coverage, 22840,
     /* 2011071 */     GIR_EraseRootFromParent_Done,
     /* 2011072 */   // Label 26875: @2011072
     /* 2011072 */   GIM_Try, /*On fail goto*//*Label 26876*/ GIMT_Encode4(2011161), // Rule ID 22841 //
     /* 2011077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2011080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2011085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2011094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2011100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011123 */     // MIs[0] round
     /* 2011123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011133 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 2011136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011160 */     // GIR_Coverage, 22841,
     /* 2011160 */     GIR_EraseRootFromParent_Done,
     /* 2011161 */   // Label 26876: @2011161
     /* 2011161 */   GIM_Try, /*On fail goto*//*Label 26877*/ GIMT_Encode4(2011250), // Rule ID 22844 //
     /* 2011166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2011169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2011174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2011177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2011180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2011183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2011186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011212 */     // MIs[0] round
     /* 2011212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011222 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 2011225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011249 */     // GIR_Coverage, 22844,
     /* 2011249 */     GIR_EraseRootFromParent_Done,
     /* 2011250 */   // Label 26877: @2011250
     /* 2011250 */   GIM_Try, /*On fail goto*//*Label 26878*/ GIMT_Encode4(2011339), // Rule ID 22845 //
     /* 2011255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2011258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2011263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2011266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2011269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2011272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2011275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011301 */     // MIs[0] round
     /* 2011301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011311 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 2011314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011338 */     // GIR_Coverage, 22845,
     /* 2011338 */     GIR_EraseRootFromParent_Done,
     /* 2011339 */   // Label 26878: @2011339
     /* 2011339 */   GIM_Try, /*On fail goto*//*Label 26879*/ GIMT_Encode4(2011428), // Rule ID 22848 //
     /* 2011344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2011347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2011352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2011355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2011358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2011361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2011364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2011367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011390 */     // MIs[0] round
     /* 2011390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011400 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 2011403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011427 */     // GIR_Coverage, 22848,
     /* 2011427 */     GIR_EraseRootFromParent_Done,
     /* 2011428 */   // Label 26879: @2011428
     /* 2011428 */   GIM_Try, /*On fail goto*//*Label 26880*/ GIMT_Encode4(2011517), // Rule ID 22849 //
     /* 2011433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2011436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2011441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2011444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2011447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2011450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2011453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2011456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011479 */     // MIs[0] round
     /* 2011479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011489 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 2011492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011516 */     // GIR_Coverage, 22849,
     /* 2011516 */     GIR_EraseRootFromParent_Done,
     /* 2011517 */   // Label 26880: @2011517
     /* 2011517 */   GIM_Try, /*On fail goto*//*Label 26881*/ GIMT_Encode4(2011606), // Rule ID 22852 //
     /* 2011522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2011525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2011530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2011533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2011536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2011539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2011542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2011545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011568 */     // MIs[0] round
     /* 2011568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011578 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 2011581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011605 */     // GIR_Coverage, 22852,
     /* 2011605 */     GIR_EraseRootFromParent_Done,
     /* 2011606 */   // Label 26881: @2011606
     /* 2011606 */   GIM_Try, /*On fail goto*//*Label 26882*/ GIMT_Encode4(2011695), // Rule ID 22853 //
     /* 2011611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2011614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2011619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2011622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2011625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2011628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2011631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2011634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011657 */     // MIs[0] round
     /* 2011657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011667 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 2011670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011694 */     // GIR_Coverage, 22853,
     /* 2011694 */     GIR_EraseRootFromParent_Done,
     /* 2011695 */   // Label 26882: @2011695
     /* 2011695 */   GIM_Try, /*On fail goto*//*Label 26883*/ GIMT_Encode4(2011784), // Rule ID 22856 //
     /* 2011700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2011703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2011708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2011717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011746 */     // MIs[0] round
     /* 2011746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011756 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 2011759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011783 */     // GIR_Coverage, 22856,
     /* 2011783 */     GIR_EraseRootFromParent_Done,
     /* 2011784 */   // Label 26883: @2011784
     /* 2011784 */   GIM_Try, /*On fail goto*//*Label 26884*/ GIMT_Encode4(2011873), // Rule ID 22857 //
     /* 2011789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2011792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2011797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2011806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011835 */     // MIs[0] round
     /* 2011835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011845 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 2011848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011872 */     // GIR_Coverage, 22857,
     /* 2011872 */     GIR_EraseRootFromParent_Done,
     /* 2011873 */   // Label 26884: @2011873
     /* 2011873 */   GIM_Try, /*On fail goto*//*Label 26885*/ GIMT_Encode4(2011962), // Rule ID 22860 //
     /* 2011878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2011881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2011886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2011895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011924 */     // MIs[0] round
     /* 2011924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011934 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 2011937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011961 */     // GIR_Coverage, 22860,
     /* 2011961 */     GIR_EraseRootFromParent_Done,
     /* 2011962 */   // Label 26885: @2011962
     /* 2011962 */   GIM_Try, /*On fail goto*//*Label 26886*/ GIMT_Encode4(2012051), // Rule ID 22861 //
     /* 2011967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2011970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2011975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2011984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012013 */     // MIs[0] round
     /* 2012013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012023 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 2012026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012050 */     // GIR_Coverage, 22861,
     /* 2012050 */     GIR_EraseRootFromParent_Done,
     /* 2012051 */   // Label 26886: @2012051
     /* 2012051 */   GIM_Try, /*On fail goto*//*Label 26887*/ GIMT_Encode4(2012140), // Rule ID 22864 //
     /* 2012056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2012059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2012064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2012073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2012079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012102 */     // MIs[0] round
     /* 2012102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012112 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 2012115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012139 */     // GIR_Coverage, 22864,
     /* 2012139 */     GIR_EraseRootFromParent_Done,
     /* 2012140 */   // Label 26887: @2012140
     /* 2012140 */   GIM_Try, /*On fail goto*//*Label 26888*/ GIMT_Encode4(2012229), // Rule ID 22865 //
     /* 2012145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2012148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2012153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2012162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2012168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012191 */     // MIs[0] round
     /* 2012191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012201 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 2012204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012228 */     // GIR_Coverage, 22865,
     /* 2012228 */     GIR_EraseRootFromParent_Done,
     /* 2012229 */   // Label 26888: @2012229
     /* 2012229 */   GIM_Try, /*On fail goto*//*Label 26889*/ GIMT_Encode4(2012318), // Rule ID 22868 //
     /* 2012234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2012237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2012242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2012251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012280 */     // MIs[0] round
     /* 2012280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012290 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 2012293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012317 */     // GIR_Coverage, 22868,
     /* 2012317 */     GIR_EraseRootFromParent_Done,
     /* 2012318 */   // Label 26889: @2012318
     /* 2012318 */   GIM_Try, /*On fail goto*//*Label 26890*/ GIMT_Encode4(2012407), // Rule ID 22869 //
     /* 2012323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2012326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2012331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2012340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012369 */     // MIs[0] round
     /* 2012369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012379 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 2012382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012406 */     // GIR_Coverage, 22869,
     /* 2012406 */     GIR_EraseRootFromParent_Done,
     /* 2012407 */   // Label 26890: @2012407
     /* 2012407 */   GIM_Try, /*On fail goto*//*Label 26891*/ GIMT_Encode4(2012496), // Rule ID 22872 //
     /* 2012412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2012415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2012420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2012429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012458 */     // MIs[0] round
     /* 2012458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012468 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 2012471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012495 */     // GIR_Coverage, 22872,
     /* 2012495 */     GIR_EraseRootFromParent_Done,
     /* 2012496 */   // Label 26891: @2012496
     /* 2012496 */   GIM_Try, /*On fail goto*//*Label 26892*/ GIMT_Encode4(2012585), // Rule ID 22873 //
     /* 2012501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2012504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2012509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2012518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012547 */     // MIs[0] round
     /* 2012547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012557 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 2012560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012584 */     // GIR_Coverage, 22873,
     /* 2012584 */     GIR_EraseRootFromParent_Done,
     /* 2012585 */   // Label 26892: @2012585
     /* 2012585 */   GIM_Try, /*On fail goto*//*Label 26893*/ GIMT_Encode4(2012674), // Rule ID 22876 //
     /* 2012590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2012593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2012598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2012607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012636 */     // MIs[0] round
     /* 2012636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012646 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 2012649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012673 */     // GIR_Coverage, 22876,
     /* 2012673 */     GIR_EraseRootFromParent_Done,
     /* 2012674 */   // Label 26893: @2012674
     /* 2012674 */   GIM_Try, /*On fail goto*//*Label 26894*/ GIMT_Encode4(2012763), // Rule ID 22877 //
     /* 2012679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2012682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2012687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2012696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012725 */     // MIs[0] round
     /* 2012725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012735 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 2012738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012762 */     // GIR_Coverage, 22877,
     /* 2012762 */     GIR_EraseRootFromParent_Done,
     /* 2012763 */   // Label 26894: @2012763
     /* 2012763 */   GIM_Try, /*On fail goto*//*Label 26895*/ GIMT_Encode4(2012852), // Rule ID 22880 //
     /* 2012768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2012776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2012779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2012782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2012785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2012788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012814 */     // MIs[0] round
     /* 2012814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012824 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 2012827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012851 */     // GIR_Coverage, 22880,
     /* 2012851 */     GIR_EraseRootFromParent_Done,
     /* 2012852 */   // Label 26895: @2012852
     /* 2012852 */   GIM_Try, /*On fail goto*//*Label 26896*/ GIMT_Encode4(2012941), // Rule ID 22881 //
     /* 2012857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2012865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2012868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2012871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2012874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2012877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012903 */     // MIs[0] round
     /* 2012903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012913 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 2012916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012940 */     // GIR_Coverage, 22881,
     /* 2012940 */     GIR_EraseRootFromParent_Done,
     /* 2012941 */   // Label 26896: @2012941
     /* 2012941 */   GIM_Try, /*On fail goto*//*Label 26897*/ GIMT_Encode4(2013030), // Rule ID 22884 //
     /* 2012946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2012954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2012957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2012960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2012963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2012966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012992 */     // MIs[0] round
     /* 2012992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013002 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 2013005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013029 */     // GIR_Coverage, 22884,
     /* 2013029 */     GIR_EraseRootFromParent_Done,
     /* 2013030 */   // Label 26897: @2013030
     /* 2013030 */   GIM_Try, /*On fail goto*//*Label 26898*/ GIMT_Encode4(2013119), // Rule ID 22885 //
     /* 2013035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2013038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2013043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2013046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2013049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2013052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2013055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013081 */     // MIs[0] round
     /* 2013081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013091 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 2013094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013118 */     // GIR_Coverage, 22885,
     /* 2013118 */     GIR_EraseRootFromParent_Done,
     /* 2013119 */   // Label 26898: @2013119
     /* 2013119 */   GIM_Try, /*On fail goto*//*Label 26899*/ GIMT_Encode4(2013208), // Rule ID 22888 //
     /* 2013124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2013132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2013141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013170 */     // MIs[0] round
     /* 2013170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013180 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 2013183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013207 */     // GIR_Coverage, 22888,
     /* 2013207 */     GIR_EraseRootFromParent_Done,
     /* 2013208 */   // Label 26899: @2013208
     /* 2013208 */   GIM_Try, /*On fail goto*//*Label 26900*/ GIMT_Encode4(2013297), // Rule ID 22889 //
     /* 2013213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2013221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2013230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013259 */     // MIs[0] round
     /* 2013259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013269 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 2013272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013282 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013296 */     // GIR_Coverage, 22889,
     /* 2013296 */     GIR_EraseRootFromParent_Done,
     /* 2013297 */   // Label 26900: @2013297
     /* 2013297 */   GIM_Try, /*On fail goto*//*Label 26901*/ GIMT_Encode4(2013386), // Rule ID 22892 //
     /* 2013302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2013305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2013310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2013313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2013316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2013319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2013322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013348 */     // MIs[0] round
     /* 2013348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013358 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 2013361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013385 */     // GIR_Coverage, 22892,
     /* 2013385 */     GIR_EraseRootFromParent_Done,
     /* 2013386 */   // Label 26901: @2013386
     /* 2013386 */   GIM_Try, /*On fail goto*//*Label 26902*/ GIMT_Encode4(2013475), // Rule ID 22893 //
     /* 2013391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2013394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2013399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2013402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2013405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2013408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2013411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013437 */     // MIs[0] round
     /* 2013437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013447 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 2013450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013460 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013474 */     // GIR_Coverage, 22893,
     /* 2013474 */     GIR_EraseRootFromParent_Done,
     /* 2013475 */   // Label 26902: @2013475
     /* 2013475 */   GIM_Try, /*On fail goto*//*Label 26903*/ GIMT_Encode4(2013564), // Rule ID 22896 //
     /* 2013480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2013488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2013497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013526 */     // MIs[0] round
     /* 2013526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013536 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 2013539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013563 */     // GIR_Coverage, 22896,
     /* 2013563 */     GIR_EraseRootFromParent_Done,
     /* 2013564 */   // Label 26903: @2013564
     /* 2013564 */   GIM_Try, /*On fail goto*//*Label 26904*/ GIMT_Encode4(2013653), // Rule ID 22897 //
     /* 2013569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2013577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2013586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013615 */     // MIs[0] round
     /* 2013615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013625 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 2013628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013652 */     // GIR_Coverage, 22897,
     /* 2013652 */     GIR_EraseRootFromParent_Done,
     /* 2013653 */   // Label 26904: @2013653
     /* 2013653 */   GIM_Try, /*On fail goto*//*Label 26905*/ GIMT_Encode4(2013742), // Rule ID 22900 //
     /* 2013658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2013661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2013666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2013675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013704 */     // MIs[0] round
     /* 2013704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013714 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 2013717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2013737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013741 */     // GIR_Coverage, 22900,
     /* 2013741 */     GIR_EraseRootFromParent_Done,
     /* 2013742 */   // Label 26905: @2013742
     /* 2013742 */   GIM_Try, /*On fail goto*//*Label 26906*/ GIMT_Encode4(2013831), // Rule ID 22901 //
     /* 2013747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2013750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2013755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2013764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013793 */     // MIs[0] round
     /* 2013793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013803 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 2013806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2013826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013830 */     // GIR_Coverage, 22901,
     /* 2013830 */     GIR_EraseRootFromParent_Done,
     /* 2013831 */   // Label 26906: @2013831
     /* 2013831 */   GIM_Try, /*On fail goto*//*Label 26907*/ GIMT_Encode4(2013920), // Rule ID 22904 //
     /* 2013836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2013839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2013844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2013847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2013850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2013853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2013856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013882 */     // MIs[0] round
     /* 2013882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013892 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 2013895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013919 */     // GIR_Coverage, 22904,
     /* 2013919 */     GIR_EraseRootFromParent_Done,
     /* 2013920 */   // Label 26907: @2013920
     /* 2013920 */   GIM_Try, /*On fail goto*//*Label 26908*/ GIMT_Encode4(2014009), // Rule ID 22905 //
     /* 2013925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2013928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2013933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2013936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2013939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2013942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2013945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013971 */     // MIs[0] round
     /* 2013971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013981 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 2013984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014008 */     // GIR_Coverage, 22905,
     /* 2014008 */     GIR_EraseRootFromParent_Done,
     /* 2014009 */   // Label 26908: @2014009
     /* 2014009 */   GIM_Try, /*On fail goto*//*Label 26909*/ GIMT_Encode4(2014098), // Rule ID 22908 //
     /* 2014014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2014022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2014025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2014028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2014031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2014034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2014037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014060 */     // MIs[0] round
     /* 2014060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014070 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 2014073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014097 */     // GIR_Coverage, 22908,
     /* 2014097 */     GIR_EraseRootFromParent_Done,
     /* 2014098 */   // Label 26909: @2014098
     /* 2014098 */   GIM_Try, /*On fail goto*//*Label 26910*/ GIMT_Encode4(2014187), // Rule ID 22909 //
     /* 2014103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2014111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2014114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2014117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2014120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2014123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2014126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014149 */     // MIs[0] round
     /* 2014149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014159 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 2014162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014186 */     // GIR_Coverage, 22909,
     /* 2014186 */     GIR_EraseRootFromParent_Done,
     /* 2014187 */   // Label 26910: @2014187
     /* 2014187 */   GIM_Try, /*On fail goto*//*Label 26911*/ GIMT_Encode4(2014276), // Rule ID 22912 //
     /* 2014192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2014200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2014203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2014206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2014209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2014212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2014215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2014230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014238 */     // MIs[0] round
     /* 2014238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014248 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 2014251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014275 */     // GIR_Coverage, 22912,
     /* 2014275 */     GIR_EraseRootFromParent_Done,
     /* 2014276 */   // Label 26911: @2014276
     /* 2014276 */   GIM_Try, /*On fail goto*//*Label 26912*/ GIMT_Encode4(2014365), // Rule ID 22913 //
     /* 2014281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2014289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2014292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2014295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2014298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2014301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2014304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2014319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014327 */     // MIs[0] round
     /* 2014327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014337 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 2014340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014364 */     // GIR_Coverage, 22913,
     /* 2014364 */     GIR_EraseRootFromParent_Done,
     /* 2014365 */   // Label 26912: @2014365
     /* 2014365 */   GIM_Try, /*On fail goto*//*Label 26913*/ GIMT_Encode4(2014454), // Rule ID 22916 //
     /* 2014370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2014373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2014378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2014387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014416 */     // MIs[0] round
     /* 2014416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014426 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 2014429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014453 */     // GIR_Coverage, 22916,
     /* 2014453 */     GIR_EraseRootFromParent_Done,
     /* 2014454 */   // Label 26913: @2014454
     /* 2014454 */   GIM_Try, /*On fail goto*//*Label 26914*/ GIMT_Encode4(2014543), // Rule ID 22917 //
     /* 2014459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2014462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2014467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2014476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014505 */     // MIs[0] round
     /* 2014505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014515 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 2014518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014542 */     // GIR_Coverage, 22917,
     /* 2014542 */     GIR_EraseRootFromParent_Done,
     /* 2014543 */   // Label 26914: @2014543
     /* 2014543 */   GIM_Try, /*On fail goto*//*Label 26915*/ GIMT_Encode4(2014632), // Rule ID 22920 //
     /* 2014548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2014551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2014556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2014565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2014571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014594 */     // MIs[0] round
     /* 2014594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014604 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 2014607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014631 */     // GIR_Coverage, 22920,
     /* 2014631 */     GIR_EraseRootFromParent_Done,
     /* 2014632 */   // Label 26915: @2014632
     /* 2014632 */   GIM_Try, /*On fail goto*//*Label 26916*/ GIMT_Encode4(2014721), // Rule ID 22921 //
     /* 2014637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2014640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2014645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2014654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2014660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014683 */     // MIs[0] round
     /* 2014683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014693 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 2014696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014720 */     // GIR_Coverage, 22921,
     /* 2014720 */     GIR_EraseRootFromParent_Done,
     /* 2014721 */   // Label 26916: @2014721
     /* 2014721 */   GIM_Try, /*On fail goto*//*Label 26917*/ GIMT_Encode4(2014810), // Rule ID 22924 //
     /* 2014726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2014729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2014734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2014743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2014749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2014764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014772 */     // MIs[0] round
     /* 2014772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014782 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 2014785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014809 */     // GIR_Coverage, 22924,
     /* 2014809 */     GIR_EraseRootFromParent_Done,
     /* 2014810 */   // Label 26917: @2014810
     /* 2014810 */   GIM_Try, /*On fail goto*//*Label 26918*/ GIMT_Encode4(2014899), // Rule ID 22925 //
     /* 2014815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2014818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2014823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2014832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2014838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2014853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014861 */     // MIs[0] round
     /* 2014861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014871 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 2014874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014898 */     // GIR_Coverage, 22925,
     /* 2014898 */     GIR_EraseRootFromParent_Done,
     /* 2014899 */   // Label 26918: @2014899
     /* 2014899 */   GIM_Try, /*On fail goto*//*Label 26919*/ GIMT_Encode4(2014988), // Rule ID 22928 //
     /* 2014904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2014907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2014912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2014921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014950 */     // MIs[0] round
     /* 2014950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014960 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 2014963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2014983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014987 */     // GIR_Coverage, 22928,
     /* 2014987 */     GIR_EraseRootFromParent_Done,
     /* 2014988 */   // Label 26919: @2014988
     /* 2014988 */   GIM_Try, /*On fail goto*//*Label 26920*/ GIMT_Encode4(2015077), // Rule ID 22929 //
     /* 2014993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2014996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2015001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2015010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2015016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015039 */     // MIs[0] round
     /* 2015039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015049 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 2015052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2015072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015076 */     // GIR_Coverage, 22929,
     /* 2015076 */     GIR_EraseRootFromParent_Done,
     /* 2015077 */   // Label 26920: @2015077
     /* 2015077 */   GIM_Try, /*On fail goto*//*Label 26921*/ GIMT_Encode4(2015166), // Rule ID 22932 //
     /* 2015082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2015085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2015090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2015099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015128 */     // MIs[0] round
     /* 2015128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015138 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2015141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2015161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015165 */     // GIR_Coverage, 22932,
     /* 2015165 */     GIR_EraseRootFromParent_Done,
     /* 2015166 */   // Label 26921: @2015166
     /* 2015166 */   GIM_Try, /*On fail goto*//*Label 26922*/ GIMT_Encode4(2015255), // Rule ID 22933 //
     /* 2015171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2015174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2015179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2015188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015217 */     // MIs[0] round
     /* 2015217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015227 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2015230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2015250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015254 */     // GIR_Coverage, 22933,
     /* 2015254 */     GIR_EraseRootFromParent_Done,
     /* 2015255 */   // Label 26922: @2015255
     /* 2015255 */   GIM_Try, /*On fail goto*//*Label 26923*/ GIMT_Encode4(2015344), // Rule ID 22936 //
     /* 2015260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2015263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2015268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2015277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015306 */     // MIs[0] round
     /* 2015306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015316 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2015319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2015339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015343 */     // GIR_Coverage, 22936,
     /* 2015343 */     GIR_EraseRootFromParent_Done,
     /* 2015344 */   // Label 26923: @2015344
     /* 2015344 */   GIM_Try, /*On fail goto*//*Label 26924*/ GIMT_Encode4(2015433), // Rule ID 22937 //
     /* 2015349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2015352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2015357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2015366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015395 */     // MIs[0] round
     /* 2015395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015405 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2015408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2015428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015432 */     // GIR_Coverage, 22937,
     /* 2015432 */     GIR_EraseRootFromParent_Done,
     /* 2015433 */   // Label 26924: @2015433
     /* 2015433 */   GIM_Try, /*On fail goto*//*Label 26925*/ GIMT_Encode4(2015522), // Rule ID 23060 //
     /* 2015438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2015441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2015446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2015455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2015461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015484 */     // MIs[0] round
     /* 2015484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015494 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2015497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015521 */     // GIR_Coverage, 23060,
     /* 2015521 */     GIR_EraseRootFromParent_Done,
     /* 2015522 */   // Label 26925: @2015522
     /* 2015522 */   GIM_Try, /*On fail goto*//*Label 26926*/ GIMT_Encode4(2015611), // Rule ID 23061 //
     /* 2015527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2015530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2015535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2015544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2015550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015573 */     // MIs[0] round
     /* 2015573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015583 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2015586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015610 */     // GIR_Coverage, 23061,
     /* 2015610 */     GIR_EraseRootFromParent_Done,
     /* 2015611 */   // Label 26926: @2015611
     /* 2015611 */   GIM_Try, /*On fail goto*//*Label 26927*/ GIMT_Encode4(2015700), // Rule ID 23064 //
     /* 2015616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2015619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2015624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2015633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2015639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015662 */     // MIs[0] round
     /* 2015662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015672 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2015675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015699 */     // GIR_Coverage, 23064,
     /* 2015699 */     GIR_EraseRootFromParent_Done,
     /* 2015700 */   // Label 26927: @2015700
     /* 2015700 */   GIM_Try, /*On fail goto*//*Label 26928*/ GIMT_Encode4(2015789), // Rule ID 23065 //
     /* 2015705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2015708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2015713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2015722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2015728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015751 */     // MIs[0] round
     /* 2015751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015761 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2015764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015788 */     // GIR_Coverage, 23065,
     /* 2015788 */     GIR_EraseRootFromParent_Done,
     /* 2015789 */   // Label 26928: @2015789
     /* 2015789 */   GIM_Try, /*On fail goto*//*Label 26929*/ GIMT_Encode4(2015878), // Rule ID 23068 //
     /* 2015794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2015797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2015802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2015811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2015817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015840 */     // MIs[0] round
     /* 2015840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015850 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2015853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015877 */     // GIR_Coverage, 23068,
     /* 2015877 */     GIR_EraseRootFromParent_Done,
     /* 2015878 */   // Label 26929: @2015878
     /* 2015878 */   GIM_Try, /*On fail goto*//*Label 26930*/ GIMT_Encode4(2015967), // Rule ID 23069 //
     /* 2015883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2015886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2015891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2015900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2015906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015929 */     // MIs[0] round
     /* 2015929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015939 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2015942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015966 */     // GIR_Coverage, 23069,
     /* 2015966 */     GIR_EraseRootFromParent_Done,
     /* 2015967 */   // Label 26930: @2015967
     /* 2015967 */   GIM_Try, /*On fail goto*//*Label 26931*/ GIMT_Encode4(2016056), // Rule ID 23072 //
     /* 2015972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2015975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2015980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2015989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016018 */     // MIs[0] round
     /* 2016018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016028 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2016028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2016031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2016035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2016054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016055 */     // GIR_Coverage, 23072,
     /* 2016055 */     GIR_EraseRootFromParent_Done,
     /* 2016056 */   // Label 26931: @2016056
     /* 2016056 */   GIM_Try, /*On fail goto*//*Label 26932*/ GIMT_Encode4(2016145), // Rule ID 23073 //
     /* 2016061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2016064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2016069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2016072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2016075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2016078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2016081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016107 */     // MIs[0] round
     /* 2016107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016117 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2016117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2016120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2016124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2016143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016144 */     // GIR_Coverage, 23073,
     /* 2016144 */     GIR_EraseRootFromParent_Done,
     /* 2016145 */   // Label 26932: @2016145
     /* 2016145 */   GIM_Try, /*On fail goto*//*Label 26933*/ GIMT_Encode4(2016234), // Rule ID 23076 //
     /* 2016150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2016153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2016158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2016161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2016164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2016167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2016170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016196 */     // MIs[0] round
     /* 2016196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016206 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2016206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2016209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2016213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2016232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016233 */     // GIR_Coverage, 23076,
     /* 2016233 */     GIR_EraseRootFromParent_Done,
     /* 2016234 */   // Label 26933: @2016234
     /* 2016234 */   GIM_Try, /*On fail goto*//*Label 26934*/ GIMT_Encode4(2016323), // Rule ID 23077 //
     /* 2016239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2016242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2016247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2016250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2016253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2016256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2016259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016285 */     // MIs[0] round
     /* 2016285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016295 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2016295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2016298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2016302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2016321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016322 */     // GIR_Coverage, 23077,
     /* 2016322 */     GIR_EraseRootFromParent_Done,
     /* 2016323 */   // Label 26934: @2016323
     /* 2016323 */   GIM_Try, /*On fail goto*//*Label 26935*/ GIMT_Encode4(2016412), // Rule ID 23080 //
     /* 2016328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2016331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2016336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2016339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2016342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2016345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2016348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2016351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016374 */     // MIs[0] round
     /* 2016374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016384 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2016384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2016387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2016391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2016410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016411 */     // GIR_Coverage, 23080,
     /* 2016411 */     GIR_EraseRootFromParent_Done,
     /* 2016412 */   // Label 26935: @2016412
     /* 2016412 */   GIM_Try, /*On fail goto*//*Label 26936*/ GIMT_Encode4(2016501), // Rule ID 23081 //
     /* 2016417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2016420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2016425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2016428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2016431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2016434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2016437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2016440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016463 */     // MIs[0] round
     /* 2016463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016473 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2016473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2016476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2016480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2016499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016500 */     // GIR_Coverage, 23081,
     /* 2016500 */     GIR_EraseRootFromParent_Done,
     /* 2016501 */   // Label 26936: @2016501
     /* 2016501 */   GIM_Try, /*On fail goto*//*Label 26937*/ GIMT_Encode4(2016590), // Rule ID 23084 //
     /* 2016506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2016509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2016514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2016517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2016520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2016523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2016526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2016529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016552 */     // MIs[0] round
     /* 2016552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016562 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2016562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2016565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2016569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2016588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016589 */     // GIR_Coverage, 23084,
     /* 2016589 */     GIR_EraseRootFromParent_Done,
     /* 2016590 */   // Label 26937: @2016590
     /* 2016590 */   GIM_Try, /*On fail goto*//*Label 26938*/ GIMT_Encode4(2016679), // Rule ID 23085 //
     /* 2016595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2016598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2016603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2016606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2016609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2016612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2016615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2016618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016641 */     // MIs[0] round
     /* 2016641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016651 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2016651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2016654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2016658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2016677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016678 */     // GIR_Coverage, 23085,
     /* 2016678 */     GIR_EraseRootFromParent_Done,
     /* 2016679 */   // Label 26938: @2016679
     /* 2016679 */   GIM_Try, /*On fail goto*//*Label 26939*/ GIMT_Encode4(2016768), // Rule ID 23088 //
     /* 2016684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2016687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2016692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2016695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2016698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2016701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2016704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2016707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016730 */     // MIs[0] round
     /* 2016730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016740 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2016740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2016743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2016747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2016766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016767 */     // GIR_Coverage, 23088,
     /* 2016767 */     GIR_EraseRootFromParent_Done,
     /* 2016768 */   // Label 26939: @2016768
     /* 2016768 */   GIM_Try, /*On fail goto*//*Label 26940*/ GIMT_Encode4(2016857), // Rule ID 23089 //
     /* 2016773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2016776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2016781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2016784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2016787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2016790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2016793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2016796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016819 */     // MIs[0] round
     /* 2016819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016829 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2016829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2016832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2016836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2016855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016856 */     // GIR_Coverage, 23089,
     /* 2016856 */     GIR_EraseRootFromParent_Done,
     /* 2016857 */   // Label 26940: @2016857
     /* 2016857 */   GIM_Try, /*On fail goto*//*Label 26941*/ GIMT_Encode4(2016946), // Rule ID 23092 //
     /* 2016862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2016865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2016870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2016873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2016876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2016879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2016882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016908 */     // MIs[0] round
     /* 2016908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016918 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2016918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2016921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2016925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2016929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2016944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016945 */     // GIR_Coverage, 23092,
     /* 2016945 */     GIR_EraseRootFromParent_Done,
     /* 2016946 */   // Label 26941: @2016946
     /* 2016946 */   GIM_Try, /*On fail goto*//*Label 26942*/ GIMT_Encode4(2017035), // Rule ID 23093 //
     /* 2016951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2016954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2016959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2016962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2016965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2016968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2016971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016997 */     // MIs[0] round
     /* 2016997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017007 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2017007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2017010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2017014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2017033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017034 */     // GIR_Coverage, 23093,
     /* 2017034 */     GIR_EraseRootFromParent_Done,
     /* 2017035 */   // Label 26942: @2017035
     /* 2017035 */   GIM_Try, /*On fail goto*//*Label 26943*/ GIMT_Encode4(2017124), // Rule ID 23096 //
     /* 2017040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2017043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2017048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2017057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2017060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2017063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017086 */     // MIs[0] round
     /* 2017086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017096 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2017096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2017099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2017103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2017122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017123 */     // GIR_Coverage, 23096,
     /* 2017123 */     GIR_EraseRootFromParent_Done,
     /* 2017124 */   // Label 26943: @2017124
     /* 2017124 */   GIM_Try, /*On fail goto*//*Label 26944*/ GIMT_Encode4(2017213), // Rule ID 23097 //
     /* 2017129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2017132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2017137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2017146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2017149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2017152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017175 */     // MIs[0] round
     /* 2017175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017185 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2017185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2017188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2017192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2017211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017212 */     // GIR_Coverage, 23097,
     /* 2017212 */     GIR_EraseRootFromParent_Done,
     /* 2017213 */   // Label 26944: @2017213
     /* 2017213 */   GIM_Try, /*On fail goto*//*Label 26945*/ GIMT_Encode4(2017302), // Rule ID 23100 //
     /* 2017218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2017221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2017226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2017235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2017238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2017241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2017256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017264 */     // MIs[0] round
     /* 2017264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017274 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2017274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2017277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2017281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2017300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017301 */     // GIR_Coverage, 23100,
     /* 2017301 */     GIR_EraseRootFromParent_Done,
     /* 2017302 */   // Label 26945: @2017302
     /* 2017302 */   GIM_Try, /*On fail goto*//*Label 26946*/ GIMT_Encode4(2017391), // Rule ID 23101 //
     /* 2017307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2017310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2017315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2017324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2017327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2017330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2017345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017353 */     // MIs[0] round
     /* 2017353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017363 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2017363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2017366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2017370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2017389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017390 */     // GIR_Coverage, 23101,
     /* 2017390 */     GIR_EraseRootFromParent_Done,
     /* 2017391 */   // Label 26946: @2017391
     /* 2017391 */   GIM_Try, /*On fail goto*//*Label 26947*/ GIMT_Encode4(2017480), // Rule ID 23104 //
     /* 2017396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2017399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2017404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2017413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2017416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017442 */     // MIs[0] round
     /* 2017442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017452 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2017452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2017455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2017459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2017478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017479 */     // GIR_Coverage, 23104,
     /* 2017479 */     GIR_EraseRootFromParent_Done,
     /* 2017480 */   // Label 26947: @2017480
     /* 2017480 */   GIM_Try, /*On fail goto*//*Label 26948*/ GIMT_Encode4(2017569), // Rule ID 23105 //
     /* 2017485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2017488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2017493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2017502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2017505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017531 */     // MIs[0] round
     /* 2017531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017541 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2017541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2017544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2017548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017554 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2017567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017568 */     // GIR_Coverage, 23105,
     /* 2017568 */     GIR_EraseRootFromParent_Done,
     /* 2017569 */   // Label 26948: @2017569
     /* 2017569 */   GIM_Try, /*On fail goto*//*Label 26949*/ GIMT_Encode4(2017658), // Rule ID 23108 //
     /* 2017574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2017577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2017582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2017591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2017594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017620 */     // MIs[0] round
     /* 2017620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017630 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2017630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2017633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2017637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2017656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017657 */     // GIR_Coverage, 23108,
     /* 2017657 */     GIR_EraseRootFromParent_Done,
     /* 2017658 */   // Label 26949: @2017658
     /* 2017658 */   GIM_Try, /*On fail goto*//*Label 26950*/ GIMT_Encode4(2017747), // Rule ID 23109 //
     /* 2017663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2017666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2017671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2017680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2017683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017709 */     // MIs[0] round
     /* 2017709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017719 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2017719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2017722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2017726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2017745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017746 */     // GIR_Coverage, 23109,
     /* 2017746 */     GIR_EraseRootFromParent_Done,
     /* 2017747 */   // Label 26950: @2017747
     /* 2017747 */   GIM_Try, /*On fail goto*//*Label 26951*/ GIMT_Encode4(2017836), // Rule ID 23112 //
     /* 2017752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2017755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2017760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2017769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2017772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017798 */     // MIs[0] round
     /* 2017798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017808 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2017808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2017811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2017815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2017834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017835 */     // GIR_Coverage, 23112,
     /* 2017835 */     GIR_EraseRootFromParent_Done,
     /* 2017836 */   // Label 26951: @2017836
     /* 2017836 */   GIM_Try, /*On fail goto*//*Label 26952*/ GIMT_Encode4(2017925), // Rule ID 23113 //
     /* 2017841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2017844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2017849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2017858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2017861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017887 */     // MIs[0] round
     /* 2017887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017897 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2017897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2017900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2017904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2017923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017924 */     // GIR_Coverage, 23113,
     /* 2017924 */     GIR_EraseRootFromParent_Done,
     /* 2017925 */   // Label 26952: @2017925
     /* 2017925 */   GIM_Try, /*On fail goto*//*Label 26953*/ GIMT_Encode4(2018014), // Rule ID 23116 //
     /* 2017930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2017933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2017938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2017947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2017950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2017953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017976 */     // MIs[0] round
     /* 2017976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017986 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2017986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2017989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2017993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2017997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2018012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018013 */     // GIR_Coverage, 23116,
     /* 2018013 */     GIR_EraseRootFromParent_Done,
     /* 2018014 */   // Label 26953: @2018014
     /* 2018014 */   GIM_Try, /*On fail goto*//*Label 26954*/ GIMT_Encode4(2018103), // Rule ID 23117 //
     /* 2018019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2018022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2018027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2018030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2018033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2018036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2018039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018065 */     // MIs[0] round
     /* 2018065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018075 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2018075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2018078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2018082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2018101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018102 */     // GIR_Coverage, 23117,
     /* 2018102 */     GIR_EraseRootFromParent_Done,
     /* 2018103 */   // Label 26954: @2018103
     /* 2018103 */   GIM_Try, /*On fail goto*//*Label 26955*/ GIMT_Encode4(2018192), // Rule ID 23120 //
     /* 2018108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2018111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2018116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2018119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2018122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2018125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2018128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2018131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018154 */     // MIs[0] round
     /* 2018154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018164 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2018164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2018167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2018171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2018190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018191 */     // GIR_Coverage, 23120,
     /* 2018191 */     GIR_EraseRootFromParent_Done,
     /* 2018192 */   // Label 26955: @2018192
     /* 2018192 */   GIM_Try, /*On fail goto*//*Label 26956*/ GIMT_Encode4(2018281), // Rule ID 23121 //
     /* 2018197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2018200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2018205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2018208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2018211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2018214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2018217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2018220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018243 */     // MIs[0] round
     /* 2018243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018253 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2018253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2018256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2018260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2018279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018280 */     // GIR_Coverage, 23121,
     /* 2018280 */     GIR_EraseRootFromParent_Done,
     /* 2018281 */   // Label 26956: @2018281
     /* 2018281 */   GIM_Try, /*On fail goto*//*Label 26957*/ GIMT_Encode4(2018370), // Rule ID 23124 //
     /* 2018286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2018289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2018294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2018297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2018300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2018303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2018306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018332 */     // MIs[0] round
     /* 2018332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018342 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2018342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2018345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2018349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2018368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018369 */     // GIR_Coverage, 23124,
     /* 2018369 */     GIR_EraseRootFromParent_Done,
     /* 2018370 */   // Label 26957: @2018370
     /* 2018370 */   GIM_Try, /*On fail goto*//*Label 26958*/ GIMT_Encode4(2018459), // Rule ID 23125 //
     /* 2018375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2018378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2018383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2018386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2018389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2018392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2018395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018421 */     // MIs[0] round
     /* 2018421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018431 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2018431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2018434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2018438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2018457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018458 */     // GIR_Coverage, 23125,
     /* 2018458 */     GIR_EraseRootFromParent_Done,
     /* 2018459 */   // Label 26958: @2018459
     /* 2018459 */   GIM_Try, /*On fail goto*//*Label 26959*/ GIMT_Encode4(2018548), // Rule ID 23128 //
     /* 2018464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2018467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2018472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2018475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2018478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2018481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2018484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018510 */     // MIs[0] round
     /* 2018510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018520 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2018520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2018523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2018527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2018546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018547 */     // GIR_Coverage, 23128,
     /* 2018547 */     GIR_EraseRootFromParent_Done,
     /* 2018548 */   // Label 26959: @2018548
     /* 2018548 */   GIM_Try, /*On fail goto*//*Label 26960*/ GIMT_Encode4(2018637), // Rule ID 23129 //
     /* 2018553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2018556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2018561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2018564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2018567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2018570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2018573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018599 */     // MIs[0] round
     /* 2018599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018609 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2018609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2018612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2018616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2018635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018636 */     // GIR_Coverage, 23129,
     /* 2018636 */     GIR_EraseRootFromParent_Done,
     /* 2018637 */   // Label 26960: @2018637
     /* 2018637 */   GIM_Try, /*On fail goto*//*Label 26961*/ GIMT_Encode4(2018726), // Rule ID 23132 //
     /* 2018642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2018645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2018650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2018653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2018656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2018659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2018662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2018665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018688 */     // MIs[0] round
     /* 2018688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018698 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2018698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2018701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2018705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2018724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018725 */     // GIR_Coverage, 23132,
     /* 2018725 */     GIR_EraseRootFromParent_Done,
     /* 2018726 */   // Label 26961: @2018726
     /* 2018726 */   GIM_Try, /*On fail goto*//*Label 26962*/ GIMT_Encode4(2018815), // Rule ID 23133 //
     /* 2018731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2018734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2018739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2018742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2018745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2018748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2018751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2018754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018777 */     // MIs[0] round
     /* 2018777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018787 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2018787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2018790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2018794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2018813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018814 */     // GIR_Coverage, 23133,
     /* 2018814 */     GIR_EraseRootFromParent_Done,
     /* 2018815 */   // Label 26962: @2018815
     /* 2018815 */   GIM_Try, /*On fail goto*//*Label 26963*/ GIMT_Encode4(2018904), // Rule ID 23136 //
     /* 2018820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2018823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2018828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2018831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2018834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2018837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2018840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018866 */     // MIs[0] round
     /* 2018866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018876 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2018876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2018879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2018883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2018902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018903 */     // GIR_Coverage, 23136,
     /* 2018903 */     GIR_EraseRootFromParent_Done,
     /* 2018904 */   // Label 26963: @2018904
     /* 2018904 */   GIM_Try, /*On fail goto*//*Label 26964*/ GIMT_Encode4(2018993), // Rule ID 23137 //
     /* 2018909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2018912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2018917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2018920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2018923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2018926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2018929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018955 */     // MIs[0] round
     /* 2018955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018965 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2018965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2018968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2018972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2018976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2018991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018992 */     // GIR_Coverage, 23137,
     /* 2018992 */     GIR_EraseRootFromParent_Done,
     /* 2018993 */   // Label 26964: @2018993
     /* 2018993 */   GIM_Try, /*On fail goto*//*Label 26965*/ GIMT_Encode4(2019082), // Rule ID 23140 //
     /* 2018998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2019001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2019006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2019009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2019012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2019015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2019018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019044 */     // MIs[0] round
     /* 2019044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019054 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2019054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2019057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2019061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2019080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019081 */     // GIR_Coverage, 23140,
     /* 2019081 */     GIR_EraseRootFromParent_Done,
     /* 2019082 */   // Label 26965: @2019082
     /* 2019082 */   GIM_Try, /*On fail goto*//*Label 26966*/ GIMT_Encode4(2019171), // Rule ID 23141 //
     /* 2019087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2019090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2019095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2019098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2019101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2019104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2019107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019133 */     // MIs[0] round
     /* 2019133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019143 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2019143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2019146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2019150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2019169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019170 */     // GIR_Coverage, 23141,
     /* 2019170 */     GIR_EraseRootFromParent_Done,
     /* 2019171 */   // Label 26966: @2019171
     /* 2019171 */   GIM_Try, /*On fail goto*//*Label 26967*/ GIMT_Encode4(2019260), // Rule ID 23144 //
     /* 2019176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2019179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2019184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2019187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2019190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2019196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019222 */     // MIs[0] round
     /* 2019222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019232 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2019232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2019235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2019239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2019258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019259 */     // GIR_Coverage, 23144,
     /* 2019259 */     GIR_EraseRootFromParent_Done,
     /* 2019260 */   // Label 26967: @2019260
     /* 2019260 */   GIM_Try, /*On fail goto*//*Label 26968*/ GIMT_Encode4(2019349), // Rule ID 23145 //
     /* 2019265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2019268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2019273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2019276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2019279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2019285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019311 */     // MIs[0] round
     /* 2019311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019321 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2019321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2019324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2019328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2019347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019348 */     // GIR_Coverage, 23145,
     /* 2019348 */     GIR_EraseRootFromParent_Done,
     /* 2019349 */   // Label 26968: @2019349
     /* 2019349 */   GIM_Reject,
     /* 2019350 */ // Label 19912: @2019350
     /* 2019350 */ GIM_Try, /*On fail goto*//*Label 26969*/ GIMT_Encode4(2209835),
     /* 2019355 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 2019358 */   GIM_Try, /*On fail goto*//*Label 26970*/ GIMT_Encode4(2019460), // Rule ID 15980 //
     /* 2019363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2019374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2019377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2019380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2019386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019413 */     // MIs[1] Operand 1
     /* 2019413 */     // No operand predicates
     /* 2019413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019417 */     // MIs[0] round
     /* 2019417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019420 */     // MIs[0] policy
     /* 2019420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019432 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2019435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2019456 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019459 */     // GIR_Coverage, 15980,
     /* 2019459 */     GIR_EraseRootFromParent_Done,
     /* 2019460 */   // Label 26970: @2019460
     /* 2019460 */   GIM_Try, /*On fail goto*//*Label 26971*/ GIMT_Encode4(2019562), // Rule ID 15981 //
     /* 2019465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2019476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2019479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2019482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2019488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019515 */     // MIs[1] Operand 1
     /* 2019515 */     // No operand predicates
     /* 2019515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019519 */     // MIs[0] round
     /* 2019519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019522 */     // MIs[0] policy
     /* 2019522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019534 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2019537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2019558 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019561 */     // GIR_Coverage, 15981,
     /* 2019561 */     GIR_EraseRootFromParent_Done,
     /* 2019562 */   // Label 26971: @2019562
     /* 2019562 */   GIM_Try, /*On fail goto*//*Label 26972*/ GIMT_Encode4(2019664), // Rule ID 15984 //
     /* 2019567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2019578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2019581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2019584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019617 */     // MIs[1] Operand 1
     /* 2019617 */     // No operand predicates
     /* 2019617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019621 */     // MIs[0] round
     /* 2019621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019624 */     // MIs[0] policy
     /* 2019624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019636 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2019639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2019660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019663 */     // GIR_Coverage, 15984,
     /* 2019663 */     GIR_EraseRootFromParent_Done,
     /* 2019664 */   // Label 26972: @2019664
     /* 2019664 */   GIM_Try, /*On fail goto*//*Label 26973*/ GIMT_Encode4(2019766), // Rule ID 15985 //
     /* 2019669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2019680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2019683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2019686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019719 */     // MIs[1] Operand 1
     /* 2019719 */     // No operand predicates
     /* 2019719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019723 */     // MIs[0] round
     /* 2019723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019726 */     // MIs[0] policy
     /* 2019726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019738 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2019741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2019762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019765 */     // GIR_Coverage, 15985,
     /* 2019765 */     GIR_EraseRootFromParent_Done,
     /* 2019766 */   // Label 26973: @2019766
     /* 2019766 */   GIM_Try, /*On fail goto*//*Label 26974*/ GIMT_Encode4(2019868), // Rule ID 15988 //
     /* 2019771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2019782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2019785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2019788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019821 */     // MIs[1] Operand 1
     /* 2019821 */     // No operand predicates
     /* 2019821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019825 */     // MIs[0] round
     /* 2019825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019828 */     // MIs[0] policy
     /* 2019828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019840 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2019843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2019864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019867 */     // GIR_Coverage, 15988,
     /* 2019867 */     GIR_EraseRootFromParent_Done,
     /* 2019868 */   // Label 26974: @2019868
     /* 2019868 */   GIM_Try, /*On fail goto*//*Label 26975*/ GIMT_Encode4(2019970), // Rule ID 15989 //
     /* 2019873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2019884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2019887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2019890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019923 */     // MIs[1] Operand 1
     /* 2019923 */     // No operand predicates
     /* 2019923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019927 */     // MIs[0] round
     /* 2019927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019930 */     // MIs[0] policy
     /* 2019930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019942 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2019945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2019966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019969 */     // GIR_Coverage, 15989,
     /* 2019969 */     GIR_EraseRootFromParent_Done,
     /* 2019970 */   // Label 26975: @2019970
     /* 2019970 */   GIM_Try, /*On fail goto*//*Label 26976*/ GIMT_Encode4(2020072), // Rule ID 15992 //
     /* 2019975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2019986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2019989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2019992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2019998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020025 */     // MIs[1] Operand 1
     /* 2020025 */     // No operand predicates
     /* 2020025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020029 */     // MIs[0] round
     /* 2020029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020032 */     // MIs[0] policy
     /* 2020032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020044 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2020047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020071 */     // GIR_Coverage, 15992,
     /* 2020071 */     GIR_EraseRootFromParent_Done,
     /* 2020072 */   // Label 26976: @2020072
     /* 2020072 */   GIM_Try, /*On fail goto*//*Label 26977*/ GIMT_Encode4(2020174), // Rule ID 15993 //
     /* 2020077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2020088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2020091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2020094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020127 */     // MIs[1] Operand 1
     /* 2020127 */     // No operand predicates
     /* 2020127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020131 */     // MIs[0] round
     /* 2020131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020134 */     // MIs[0] policy
     /* 2020134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020146 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2020149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020173 */     // GIR_Coverage, 15993,
     /* 2020173 */     GIR_EraseRootFromParent_Done,
     /* 2020174 */   // Label 26977: @2020174
     /* 2020174 */   GIM_Try, /*On fail goto*//*Label 26978*/ GIMT_Encode4(2020276), // Rule ID 15996 //
     /* 2020179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2020190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2020193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2020196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020229 */     // MIs[1] Operand 1
     /* 2020229 */     // No operand predicates
     /* 2020229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020233 */     // MIs[0] round
     /* 2020233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020236 */     // MIs[0] policy
     /* 2020236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020248 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2020251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020275 */     // GIR_Coverage, 15996,
     /* 2020275 */     GIR_EraseRootFromParent_Done,
     /* 2020276 */   // Label 26978: @2020276
     /* 2020276 */   GIM_Try, /*On fail goto*//*Label 26979*/ GIMT_Encode4(2020378), // Rule ID 15997 //
     /* 2020281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2020292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2020295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2020298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020331 */     // MIs[1] Operand 1
     /* 2020331 */     // No operand predicates
     /* 2020331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020335 */     // MIs[0] round
     /* 2020335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020338 */     // MIs[0] policy
     /* 2020338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020350 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2020353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020377 */     // GIR_Coverage, 15997,
     /* 2020377 */     GIR_EraseRootFromParent_Done,
     /* 2020378 */   // Label 26979: @2020378
     /* 2020378 */   GIM_Try, /*On fail goto*//*Label 26980*/ GIMT_Encode4(2020480), // Rule ID 16000 //
     /* 2020383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2020394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2020397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2020400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020433 */     // MIs[1] Operand 1
     /* 2020433 */     // No operand predicates
     /* 2020433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020437 */     // MIs[0] round
     /* 2020437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020440 */     // MIs[0] policy
     /* 2020440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020452 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2020455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020479 */     // GIR_Coverage, 16000,
     /* 2020479 */     GIR_EraseRootFromParent_Done,
     /* 2020480 */   // Label 26980: @2020480
     /* 2020480 */   GIM_Try, /*On fail goto*//*Label 26981*/ GIMT_Encode4(2020582), // Rule ID 16001 //
     /* 2020485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2020496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2020499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2020502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020535 */     // MIs[1] Operand 1
     /* 2020535 */     // No operand predicates
     /* 2020535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020539 */     // MIs[0] round
     /* 2020539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020542 */     // MIs[0] policy
     /* 2020542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020554 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2020557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020581 */     // GIR_Coverage, 16001,
     /* 2020581 */     GIR_EraseRootFromParent_Done,
     /* 2020582 */   // Label 26981: @2020582
     /* 2020582 */   GIM_Try, /*On fail goto*//*Label 26982*/ GIMT_Encode4(2020684), // Rule ID 16004 //
     /* 2020587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2020598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2020601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2020604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020637 */     // MIs[1] Operand 1
     /* 2020637 */     // No operand predicates
     /* 2020637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020641 */     // MIs[0] round
     /* 2020641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020644 */     // MIs[0] policy
     /* 2020644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020656 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2020659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020683 */     // GIR_Coverage, 16004,
     /* 2020683 */     GIR_EraseRootFromParent_Done,
     /* 2020684 */   // Label 26982: @2020684
     /* 2020684 */   GIM_Try, /*On fail goto*//*Label 26983*/ GIMT_Encode4(2020786), // Rule ID 16005 //
     /* 2020689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2020700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2020703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2020706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020739 */     // MIs[1] Operand 1
     /* 2020739 */     // No operand predicates
     /* 2020739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020743 */     // MIs[0] round
     /* 2020743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020746 */     // MIs[0] policy
     /* 2020746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2020761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020785 */     // GIR_Coverage, 16005,
     /* 2020785 */     GIR_EraseRootFromParent_Done,
     /* 2020786 */   // Label 26983: @2020786
     /* 2020786 */   GIM_Try, /*On fail goto*//*Label 26984*/ GIMT_Encode4(2020888), // Rule ID 16008 //
     /* 2020791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2020802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2020805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2020808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020841 */     // MIs[1] Operand 1
     /* 2020841 */     // No operand predicates
     /* 2020841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020845 */     // MIs[0] round
     /* 2020845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020848 */     // MIs[0] policy
     /* 2020848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2020863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020887 */     // GIR_Coverage, 16008,
     /* 2020887 */     GIR_EraseRootFromParent_Done,
     /* 2020888 */   // Label 26984: @2020888
     /* 2020888 */   GIM_Try, /*On fail goto*//*Label 26985*/ GIMT_Encode4(2020990), // Rule ID 16009 //
     /* 2020893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2020904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2020907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2020910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020943 */     // MIs[1] Operand 1
     /* 2020943 */     // No operand predicates
     /* 2020943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020947 */     // MIs[0] round
     /* 2020947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020950 */     // MIs[0] policy
     /* 2020950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020962 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2020965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020989 */     // GIR_Coverage, 16009,
     /* 2020989 */     GIR_EraseRootFromParent_Done,
     /* 2020990 */   // Label 26985: @2020990
     /* 2020990 */   GIM_Try, /*On fail goto*//*Label 26986*/ GIMT_Encode4(2021092), // Rule ID 16012 //
     /* 2020995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2021003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2021006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2021009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2021012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021045 */     // MIs[1] Operand 1
     /* 2021045 */     // No operand predicates
     /* 2021045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021049 */     // MIs[0] round
     /* 2021049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021052 */     // MIs[0] policy
     /* 2021052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021064 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2021067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021091 */     // GIR_Coverage, 16012,
     /* 2021091 */     GIR_EraseRootFromParent_Done,
     /* 2021092 */   // Label 26986: @2021092
     /* 2021092 */   GIM_Try, /*On fail goto*//*Label 26987*/ GIMT_Encode4(2021194), // Rule ID 16013 //
     /* 2021097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2021105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2021108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2021111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2021114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021147 */     // MIs[1] Operand 1
     /* 2021147 */     // No operand predicates
     /* 2021147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021151 */     // MIs[0] round
     /* 2021151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021154 */     // MIs[0] policy
     /* 2021154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2021169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021193 */     // GIR_Coverage, 16013,
     /* 2021193 */     GIR_EraseRootFromParent_Done,
     /* 2021194 */   // Label 26987: @2021194
     /* 2021194 */   GIM_Try, /*On fail goto*//*Label 26988*/ GIMT_Encode4(2021296), // Rule ID 16016 //
     /* 2021199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2021202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2021207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2021210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2021213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2021216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021249 */     // MIs[1] Operand 1
     /* 2021249 */     // No operand predicates
     /* 2021249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021253 */     // MIs[0] round
     /* 2021253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021256 */     // MIs[0] policy
     /* 2021256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2021271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021282 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2021292 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021295 */     // GIR_Coverage, 16016,
     /* 2021295 */     GIR_EraseRootFromParent_Done,
     /* 2021296 */   // Label 26988: @2021296
     /* 2021296 */   GIM_Try, /*On fail goto*//*Label 26989*/ GIMT_Encode4(2021398), // Rule ID 16017 //
     /* 2021301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2021304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2021309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2021312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2021315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2021318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021351 */     // MIs[1] Operand 1
     /* 2021351 */     // No operand predicates
     /* 2021351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021355 */     // MIs[0] round
     /* 2021355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021358 */     // MIs[0] policy
     /* 2021358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021370 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2021373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2021394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021397 */     // GIR_Coverage, 16017,
     /* 2021397 */     GIR_EraseRootFromParent_Done,
     /* 2021398 */   // Label 26989: @2021398
     /* 2021398 */   GIM_Try, /*On fail goto*//*Label 26990*/ GIMT_Encode4(2021500), // Rule ID 16020 //
     /* 2021403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2021411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2021414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2021417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2021420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2021426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2021433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021453 */     // MIs[1] Operand 1
     /* 2021453 */     // No operand predicates
     /* 2021453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021457 */     // MIs[0] round
     /* 2021457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021460 */     // MIs[0] policy
     /* 2021460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021472 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2021475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021499 */     // GIR_Coverage, 16020,
     /* 2021499 */     GIR_EraseRootFromParent_Done,
     /* 2021500 */   // Label 26990: @2021500
     /* 2021500 */   GIM_Try, /*On fail goto*//*Label 26991*/ GIMT_Encode4(2021602), // Rule ID 16021 //
     /* 2021505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2021513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2021516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2021519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2021522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2021528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2021535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021555 */     // MIs[1] Operand 1
     /* 2021555 */     // No operand predicates
     /* 2021555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021559 */     // MIs[0] round
     /* 2021559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021562 */     // MIs[0] policy
     /* 2021562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021574 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2021577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021601 */     // GIR_Coverage, 16021,
     /* 2021601 */     GIR_EraseRootFromParent_Done,
     /* 2021602 */   // Label 26991: @2021602
     /* 2021602 */   GIM_Try, /*On fail goto*//*Label 26992*/ GIMT_Encode4(2021704), // Rule ID 16024 //
     /* 2021607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2021615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2021618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2021621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2021624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2021630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2021637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021657 */     // MIs[1] Operand 1
     /* 2021657 */     // No operand predicates
     /* 2021657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021661 */     // MIs[0] round
     /* 2021661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021664 */     // MIs[0] policy
     /* 2021664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021676 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2021679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021703 */     // GIR_Coverage, 16024,
     /* 2021703 */     GIR_EraseRootFromParent_Done,
     /* 2021704 */   // Label 26992: @2021704
     /* 2021704 */   GIM_Try, /*On fail goto*//*Label 26993*/ GIMT_Encode4(2021806), // Rule ID 16025 //
     /* 2021709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2021717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2021720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2021723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2021726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2021732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2021739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021759 */     // MIs[1] Operand 1
     /* 2021759 */     // No operand predicates
     /* 2021759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021763 */     // MIs[0] round
     /* 2021763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021766 */     // MIs[0] policy
     /* 2021766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021778 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2021781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021805 */     // GIR_Coverage, 16025,
     /* 2021805 */     GIR_EraseRootFromParent_Done,
     /* 2021806 */   // Label 26993: @2021806
     /* 2021806 */   GIM_Try, /*On fail goto*//*Label 26994*/ GIMT_Encode4(2021908), // Rule ID 16028 //
     /* 2021811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2021819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2021822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2021825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2021828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2021834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2021841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2021845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2021849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021861 */     // MIs[1] Operand 1
     /* 2021861 */     // No operand predicates
     /* 2021861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021865 */     // MIs[0] round
     /* 2021865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021868 */     // MIs[0] policy
     /* 2021868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021880 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2021883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021907 */     // GIR_Coverage, 16028,
     /* 2021907 */     GIR_EraseRootFromParent_Done,
     /* 2021908 */   // Label 26994: @2021908
     /* 2021908 */   GIM_Try, /*On fail goto*//*Label 26995*/ GIMT_Encode4(2022010), // Rule ID 16029 //
     /* 2021913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2021921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2021924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2021927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2021930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2021936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2021943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2021947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2021951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021963 */     // MIs[1] Operand 1
     /* 2021963 */     // No operand predicates
     /* 2021963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021967 */     // MIs[0] round
     /* 2021967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021970 */     // MIs[0] policy
     /* 2021970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021982 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2021985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021996 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022006 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022009 */     // GIR_Coverage, 16029,
     /* 2022009 */     GIR_EraseRootFromParent_Done,
     /* 2022010 */   // Label 26995: @2022010
     /* 2022010 */   GIM_Try, /*On fail goto*//*Label 26996*/ GIMT_Encode4(2022112), // Rule ID 16032 //
     /* 2022015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2022023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2022026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2022029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2022032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022065 */     // MIs[1] Operand 1
     /* 2022065 */     // No operand predicates
     /* 2022065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022069 */     // MIs[0] round
     /* 2022069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022072 */     // MIs[0] policy
     /* 2022072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022084 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2022087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022111 */     // GIR_Coverage, 16032,
     /* 2022111 */     GIR_EraseRootFromParent_Done,
     /* 2022112 */   // Label 26996: @2022112
     /* 2022112 */   GIM_Try, /*On fail goto*//*Label 26997*/ GIMT_Encode4(2022214), // Rule ID 16033 //
     /* 2022117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2022125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2022128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2022131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2022134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022167 */     // MIs[1] Operand 1
     /* 2022167 */     // No operand predicates
     /* 2022167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022171 */     // MIs[0] round
     /* 2022171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022174 */     // MIs[0] policy
     /* 2022174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022186 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2022189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022213 */     // GIR_Coverage, 16033,
     /* 2022213 */     GIR_EraseRootFromParent_Done,
     /* 2022214 */   // Label 26997: @2022214
     /* 2022214 */   GIM_Try, /*On fail goto*//*Label 26998*/ GIMT_Encode4(2022316), // Rule ID 16036 //
     /* 2022219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2022227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2022230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2022233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2022236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022269 */     // MIs[1] Operand 1
     /* 2022269 */     // No operand predicates
     /* 2022269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022273 */     // MIs[0] round
     /* 2022273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022276 */     // MIs[0] policy
     /* 2022276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022288 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2022291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022315 */     // GIR_Coverage, 16036,
     /* 2022315 */     GIR_EraseRootFromParent_Done,
     /* 2022316 */   // Label 26998: @2022316
     /* 2022316 */   GIM_Try, /*On fail goto*//*Label 26999*/ GIMT_Encode4(2022418), // Rule ID 16037 //
     /* 2022321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2022329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2022332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2022335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2022338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022371 */     // MIs[1] Operand 1
     /* 2022371 */     // No operand predicates
     /* 2022371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022375 */     // MIs[0] round
     /* 2022375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022378 */     // MIs[0] policy
     /* 2022378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022390 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2022393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022417 */     // GIR_Coverage, 16037,
     /* 2022417 */     GIR_EraseRootFromParent_Done,
     /* 2022418 */   // Label 26999: @2022418
     /* 2022418 */   GIM_Try, /*On fail goto*//*Label 27000*/ GIMT_Encode4(2022520), // Rule ID 16040 //
     /* 2022423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2022431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2022434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2022437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2022440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2022446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2022453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022473 */     // MIs[1] Operand 1
     /* 2022473 */     // No operand predicates
     /* 2022473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022477 */     // MIs[0] round
     /* 2022477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022480 */     // MIs[0] policy
     /* 2022480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022492 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2022495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022519 */     // GIR_Coverage, 16040,
     /* 2022519 */     GIR_EraseRootFromParent_Done,
     /* 2022520 */   // Label 27000: @2022520
     /* 2022520 */   GIM_Try, /*On fail goto*//*Label 27001*/ GIMT_Encode4(2022622), // Rule ID 16041 //
     /* 2022525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2022533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2022536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2022539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2022542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2022548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2022555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022575 */     // MIs[1] Operand 1
     /* 2022575 */     // No operand predicates
     /* 2022575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022579 */     // MIs[0] round
     /* 2022579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022582 */     // MIs[0] policy
     /* 2022582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022594 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2022597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022621 */     // GIR_Coverage, 16041,
     /* 2022621 */     GIR_EraseRootFromParent_Done,
     /* 2022622 */   // Label 27001: @2022622
     /* 2022622 */   GIM_Try, /*On fail goto*//*Label 27002*/ GIMT_Encode4(2022724), // Rule ID 16044 //
     /* 2022627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2022635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2022638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2022641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2022644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2022650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022677 */     // MIs[1] Operand 1
     /* 2022677 */     // No operand predicates
     /* 2022677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022681 */     // MIs[0] round
     /* 2022681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022684 */     // MIs[0] policy
     /* 2022684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2022699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022723 */     // GIR_Coverage, 16044,
     /* 2022723 */     GIR_EraseRootFromParent_Done,
     /* 2022724 */   // Label 27002: @2022724
     /* 2022724 */   GIM_Try, /*On fail goto*//*Label 27003*/ GIMT_Encode4(2022826), // Rule ID 16045 //
     /* 2022729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2022737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2022740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2022743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2022746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2022752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022779 */     // MIs[1] Operand 1
     /* 2022779 */     // No operand predicates
     /* 2022779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022783 */     // MIs[0] round
     /* 2022783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022786 */     // MIs[0] policy
     /* 2022786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2022801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022825 */     // GIR_Coverage, 16045,
     /* 2022825 */     GIR_EraseRootFromParent_Done,
     /* 2022826 */   // Label 27003: @2022826
     /* 2022826 */   GIM_Try, /*On fail goto*//*Label 27004*/ GIMT_Encode4(2022928), // Rule ID 16048 //
     /* 2022831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2022839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2022842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2022845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2022848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022881 */     // MIs[1] Operand 1
     /* 2022881 */     // No operand predicates
     /* 2022881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022885 */     // MIs[0] round
     /* 2022885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022888 */     // MIs[0] policy
     /* 2022888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022900 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2022903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022914 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022924 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022927 */     // GIR_Coverage, 16048,
     /* 2022927 */     GIR_EraseRootFromParent_Done,
     /* 2022928 */   // Label 27004: @2022928
     /* 2022928 */   GIM_Try, /*On fail goto*//*Label 27005*/ GIMT_Encode4(2023030), // Rule ID 16049 //
     /* 2022933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2022941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2022944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2022947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2022950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022983 */     // MIs[1] Operand 1
     /* 2022983 */     // No operand predicates
     /* 2022983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022987 */     // MIs[0] round
     /* 2022987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022990 */     // MIs[0] policy
     /* 2022990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2023005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023029 */     // GIR_Coverage, 16049,
     /* 2023029 */     GIR_EraseRootFromParent_Done,
     /* 2023030 */   // Label 27005: @2023030
     /* 2023030 */   GIM_Try, /*On fail goto*//*Label 27006*/ GIMT_Encode4(2023132), // Rule ID 16052 //
     /* 2023035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2023043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2023046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2023049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2023052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2023058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023085 */     // MIs[1] Operand 1
     /* 2023085 */     // No operand predicates
     /* 2023085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023089 */     // MIs[0] round
     /* 2023089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023092 */     // MIs[0] policy
     /* 2023092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023104 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2023107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023131 */     // GIR_Coverage, 16052,
     /* 2023131 */     GIR_EraseRootFromParent_Done,
     /* 2023132 */   // Label 27006: @2023132
     /* 2023132 */   GIM_Try, /*On fail goto*//*Label 27007*/ GIMT_Encode4(2023234), // Rule ID 16053 //
     /* 2023137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2023145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2023148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2023151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2023154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2023160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023187 */     // MIs[1] Operand 1
     /* 2023187 */     // No operand predicates
     /* 2023187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023191 */     // MIs[0] round
     /* 2023191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023194 */     // MIs[0] policy
     /* 2023194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023206 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2023209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023233 */     // GIR_Coverage, 16053,
     /* 2023233 */     GIR_EraseRootFromParent_Done,
     /* 2023234 */   // Label 27007: @2023234
     /* 2023234 */   GIM_Try, /*On fail goto*//*Label 27008*/ GIMT_Encode4(2023336), // Rule ID 16056 //
     /* 2023239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2023242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2023247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2023250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2023253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2023256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2023262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023289 */     // MIs[1] Operand 1
     /* 2023289 */     // No operand predicates
     /* 2023289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023293 */     // MIs[0] round
     /* 2023293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023296 */     // MIs[0] policy
     /* 2023296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023308 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2023311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2023332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023335 */     // GIR_Coverage, 16056,
     /* 2023335 */     GIR_EraseRootFromParent_Done,
     /* 2023336 */   // Label 27008: @2023336
     /* 2023336 */   GIM_Try, /*On fail goto*//*Label 27009*/ GIMT_Encode4(2023438), // Rule ID 16057 //
     /* 2023341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2023344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2023349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2023352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2023355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2023358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2023364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023391 */     // MIs[1] Operand 1
     /* 2023391 */     // No operand predicates
     /* 2023391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023395 */     // MIs[0] round
     /* 2023395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023398 */     // MIs[0] policy
     /* 2023398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2023413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2023434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023437 */     // GIR_Coverage, 16057,
     /* 2023437 */     GIR_EraseRootFromParent_Done,
     /* 2023438 */   // Label 27009: @2023438
     /* 2023438 */   GIM_Try, /*On fail goto*//*Label 27010*/ GIMT_Encode4(2023540), // Rule ID 16060 //
     /* 2023443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2023446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2023451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2023454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2023457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2023460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023493 */     // MIs[1] Operand 1
     /* 2023493 */     // No operand predicates
     /* 2023493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023497 */     // MIs[0] round
     /* 2023497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023500 */     // MIs[0] policy
     /* 2023500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023512 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2023515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2023536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023539 */     // GIR_Coverage, 16060,
     /* 2023539 */     GIR_EraseRootFromParent_Done,
     /* 2023540 */   // Label 27010: @2023540
     /* 2023540 */   GIM_Try, /*On fail goto*//*Label 27011*/ GIMT_Encode4(2023642), // Rule ID 16061 //
     /* 2023545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2023548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2023553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2023556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2023559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2023562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023595 */     // MIs[1] Operand 1
     /* 2023595 */     // No operand predicates
     /* 2023595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023599 */     // MIs[0] round
     /* 2023599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023602 */     // MIs[0] policy
     /* 2023602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023614 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2023617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2023638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023641 */     // GIR_Coverage, 16061,
     /* 2023641 */     GIR_EraseRootFromParent_Done,
     /* 2023642 */   // Label 27011: @2023642
     /* 2023642 */   GIM_Try, /*On fail goto*//*Label 27012*/ GIMT_Encode4(2023744), // Rule ID 16064 //
     /* 2023647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2023650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2023655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2023658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2023661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2023664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023697 */     // MIs[1] Operand 1
     /* 2023697 */     // No operand predicates
     /* 2023697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023701 */     // MIs[0] round
     /* 2023701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023704 */     // MIs[0] policy
     /* 2023704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023716 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2023719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023730 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2023740 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023743 */     // GIR_Coverage, 16064,
     /* 2023743 */     GIR_EraseRootFromParent_Done,
     /* 2023744 */   // Label 27012: @2023744
     /* 2023744 */   GIM_Try, /*On fail goto*//*Label 27013*/ GIMT_Encode4(2023846), // Rule ID 16065 //
     /* 2023749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2023752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2023757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2023760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2023763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2023766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023799 */     // MIs[1] Operand 1
     /* 2023799 */     // No operand predicates
     /* 2023799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023803 */     // MIs[0] round
     /* 2023803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023806 */     // MIs[0] policy
     /* 2023806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023818 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2023821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2023842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023845 */     // GIR_Coverage, 16065,
     /* 2023845 */     GIR_EraseRootFromParent_Done,
     /* 2023846 */   // Label 27013: @2023846
     /* 2023846 */   GIM_Try, /*On fail goto*//*Label 27014*/ GIMT_Encode4(2023948), // Rule ID 16244 //
     /* 2023851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2023862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2023865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2023868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023901 */     // MIs[1] Operand 1
     /* 2023901 */     // No operand predicates
     /* 2023901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023905 */     // MIs[0] round
     /* 2023905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023908 */     // MIs[0] policy
     /* 2023908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023920 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2023923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2023944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023947 */     // GIR_Coverage, 16244,
     /* 2023947 */     GIR_EraseRootFromParent_Done,
     /* 2023948 */   // Label 27014: @2023948
     /* 2023948 */   GIM_Try, /*On fail goto*//*Label 27015*/ GIMT_Encode4(2024050), // Rule ID 16245 //
     /* 2023953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2023964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2023967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2023970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024003 */     // MIs[1] Operand 1
     /* 2024003 */     // No operand predicates
     /* 2024003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024007 */     // MIs[0] round
     /* 2024007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024010 */     // MIs[0] policy
     /* 2024010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024022 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2024025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024049 */     // GIR_Coverage, 16245,
     /* 2024049 */     GIR_EraseRootFromParent_Done,
     /* 2024050 */   // Label 27015: @2024050
     /* 2024050 */   GIM_Try, /*On fail goto*//*Label 27016*/ GIMT_Encode4(2024152), // Rule ID 16248 //
     /* 2024055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2024066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2024069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2024072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024105 */     // MIs[1] Operand 1
     /* 2024105 */     // No operand predicates
     /* 2024105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024109 */     // MIs[0] round
     /* 2024109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024112 */     // MIs[0] policy
     /* 2024112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024124 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2024127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024151 */     // GIR_Coverage, 16248,
     /* 2024151 */     GIR_EraseRootFromParent_Done,
     /* 2024152 */   // Label 27016: @2024152
     /* 2024152 */   GIM_Try, /*On fail goto*//*Label 27017*/ GIMT_Encode4(2024254), // Rule ID 16249 //
     /* 2024157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2024168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2024171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2024174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024207 */     // MIs[1] Operand 1
     /* 2024207 */     // No operand predicates
     /* 2024207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024211 */     // MIs[0] round
     /* 2024211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024214 */     // MIs[0] policy
     /* 2024214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024226 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2024229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024253 */     // GIR_Coverage, 16249,
     /* 2024253 */     GIR_EraseRootFromParent_Done,
     /* 2024254 */   // Label 27017: @2024254
     /* 2024254 */   GIM_Try, /*On fail goto*//*Label 27018*/ GIMT_Encode4(2024356), // Rule ID 16252 //
     /* 2024259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2024270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2024273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2024276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024309 */     // MIs[1] Operand 1
     /* 2024309 */     // No operand predicates
     /* 2024309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024313 */     // MIs[0] round
     /* 2024313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024316 */     // MIs[0] policy
     /* 2024316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024328 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2024331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024355 */     // GIR_Coverage, 16252,
     /* 2024355 */     GIR_EraseRootFromParent_Done,
     /* 2024356 */   // Label 27018: @2024356
     /* 2024356 */   GIM_Try, /*On fail goto*//*Label 27019*/ GIMT_Encode4(2024458), // Rule ID 16253 //
     /* 2024361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2024372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2024375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2024378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024411 */     // MIs[1] Operand 1
     /* 2024411 */     // No operand predicates
     /* 2024411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024415 */     // MIs[0] round
     /* 2024415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024418 */     // MIs[0] policy
     /* 2024418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024430 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2024433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024457 */     // GIR_Coverage, 16253,
     /* 2024457 */     GIR_EraseRootFromParent_Done,
     /* 2024458 */   // Label 27019: @2024458
     /* 2024458 */   GIM_Try, /*On fail goto*//*Label 27020*/ GIMT_Encode4(2024560), // Rule ID 16256 //
     /* 2024463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2024474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2024477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2024480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024513 */     // MIs[1] Operand 1
     /* 2024513 */     // No operand predicates
     /* 2024513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024517 */     // MIs[0] round
     /* 2024517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024520 */     // MIs[0] policy
     /* 2024520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024532 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2024535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024546 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024556 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024559 */     // GIR_Coverage, 16256,
     /* 2024559 */     GIR_EraseRootFromParent_Done,
     /* 2024560 */   // Label 27020: @2024560
     /* 2024560 */   GIM_Try, /*On fail goto*//*Label 27021*/ GIMT_Encode4(2024662), // Rule ID 16257 //
     /* 2024565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2024576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2024579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2024582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024615 */     // MIs[1] Operand 1
     /* 2024615 */     // No operand predicates
     /* 2024615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024619 */     // MIs[0] round
     /* 2024619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024622 */     // MIs[0] policy
     /* 2024622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024634 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2024637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024661 */     // GIR_Coverage, 16257,
     /* 2024661 */     GIR_EraseRootFromParent_Done,
     /* 2024662 */   // Label 27021: @2024662
     /* 2024662 */   GIM_Try, /*On fail goto*//*Label 27022*/ GIMT_Encode4(2024764), // Rule ID 16260 //
     /* 2024667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2024678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2024681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2024684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024717 */     // MIs[1] Operand 1
     /* 2024717 */     // No operand predicates
     /* 2024717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024721 */     // MIs[0] round
     /* 2024721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024724 */     // MIs[0] policy
     /* 2024724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024736 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2024739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024763 */     // GIR_Coverage, 16260,
     /* 2024763 */     GIR_EraseRootFromParent_Done,
     /* 2024764 */   // Label 27022: @2024764
     /* 2024764 */   GIM_Try, /*On fail goto*//*Label 27023*/ GIMT_Encode4(2024866), // Rule ID 16261 //
     /* 2024769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2024780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2024783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2024786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024819 */     // MIs[1] Operand 1
     /* 2024819 */     // No operand predicates
     /* 2024819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024823 */     // MIs[0] round
     /* 2024823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024826 */     // MIs[0] policy
     /* 2024826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024838 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2024841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024865 */     // GIR_Coverage, 16261,
     /* 2024865 */     GIR_EraseRootFromParent_Done,
     /* 2024866 */   // Label 27023: @2024866
     /* 2024866 */   GIM_Try, /*On fail goto*//*Label 27024*/ GIMT_Encode4(2024968), // Rule ID 16264 //
     /* 2024871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2024882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2024885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2024888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024921 */     // MIs[1] Operand 1
     /* 2024921 */     // No operand predicates
     /* 2024921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024925 */     // MIs[0] round
     /* 2024925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024928 */     // MIs[0] policy
     /* 2024928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024940 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2024943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024967 */     // GIR_Coverage, 16264,
     /* 2024967 */     GIR_EraseRootFromParent_Done,
     /* 2024968 */   // Label 27024: @2024968
     /* 2024968 */   GIM_Try, /*On fail goto*//*Label 27025*/ GIMT_Encode4(2025070), // Rule ID 16265 //
     /* 2024973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2024984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2024987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2024990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025023 */     // MIs[1] Operand 1
     /* 2025023 */     // No operand predicates
     /* 2025023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025027 */     // MIs[0] round
     /* 2025027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025030 */     // MIs[0] policy
     /* 2025030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025042 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2025045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025069 */     // GIR_Coverage, 16265,
     /* 2025069 */     GIR_EraseRootFromParent_Done,
     /* 2025070 */   // Label 27025: @2025070
     /* 2025070 */   GIM_Try, /*On fail goto*//*Label 27026*/ GIMT_Encode4(2025172), // Rule ID 16268 //
     /* 2025075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2025083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2025086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2025089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2025092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025125 */     // MIs[1] Operand 1
     /* 2025125 */     // No operand predicates
     /* 2025125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025129 */     // MIs[0] round
     /* 2025129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025132 */     // MIs[0] policy
     /* 2025132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025144 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2025147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025171 */     // GIR_Coverage, 16268,
     /* 2025171 */     GIR_EraseRootFromParent_Done,
     /* 2025172 */   // Label 27026: @2025172
     /* 2025172 */   GIM_Try, /*On fail goto*//*Label 27027*/ GIMT_Encode4(2025274), // Rule ID 16269 //
     /* 2025177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2025185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2025188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2025191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2025194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025227 */     // MIs[1] Operand 1
     /* 2025227 */     // No operand predicates
     /* 2025227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025231 */     // MIs[0] round
     /* 2025231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025234 */     // MIs[0] policy
     /* 2025234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025246 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2025249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025273 */     // GIR_Coverage, 16269,
     /* 2025273 */     GIR_EraseRootFromParent_Done,
     /* 2025274 */   // Label 27027: @2025274
     /* 2025274 */   GIM_Try, /*On fail goto*//*Label 27028*/ GIMT_Encode4(2025376), // Rule ID 16272 //
     /* 2025279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2025287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2025290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2025293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2025296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025329 */     // MIs[1] Operand 1
     /* 2025329 */     // No operand predicates
     /* 2025329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025333 */     // MIs[0] round
     /* 2025333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025336 */     // MIs[0] policy
     /* 2025336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025348 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2025351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025375 */     // GIR_Coverage, 16272,
     /* 2025375 */     GIR_EraseRootFromParent_Done,
     /* 2025376 */   // Label 27028: @2025376
     /* 2025376 */   GIM_Try, /*On fail goto*//*Label 27029*/ GIMT_Encode4(2025478), // Rule ID 16273 //
     /* 2025381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2025389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2025392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2025395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2025398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025431 */     // MIs[1] Operand 1
     /* 2025431 */     // No operand predicates
     /* 2025431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025435 */     // MIs[0] round
     /* 2025435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025438 */     // MIs[0] policy
     /* 2025438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025450 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2025453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025477 */     // GIR_Coverage, 16273,
     /* 2025477 */     GIR_EraseRootFromParent_Done,
     /* 2025478 */   // Label 27029: @2025478
     /* 2025478 */   GIM_Try, /*On fail goto*//*Label 27030*/ GIMT_Encode4(2025580), // Rule ID 16276 //
     /* 2025483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2025491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2025494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2025497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2025500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2025506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025533 */     // MIs[1] Operand 1
     /* 2025533 */     // No operand predicates
     /* 2025533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025537 */     // MIs[0] round
     /* 2025537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025540 */     // MIs[0] policy
     /* 2025540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2025555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025579 */     // GIR_Coverage, 16276,
     /* 2025579 */     GIR_EraseRootFromParent_Done,
     /* 2025580 */   // Label 27030: @2025580
     /* 2025580 */   GIM_Try, /*On fail goto*//*Label 27031*/ GIMT_Encode4(2025682), // Rule ID 16277 //
     /* 2025585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2025593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2025596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2025599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2025602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2025608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025635 */     // MIs[1] Operand 1
     /* 2025635 */     // No operand predicates
     /* 2025635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025639 */     // MIs[0] round
     /* 2025639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025642 */     // MIs[0] policy
     /* 2025642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025654 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2025657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025681 */     // GIR_Coverage, 16277,
     /* 2025681 */     GIR_EraseRootFromParent_Done,
     /* 2025682 */   // Label 27031: @2025682
     /* 2025682 */   GIM_Try, /*On fail goto*//*Label 27032*/ GIMT_Encode4(2025784), // Rule ID 16280 //
     /* 2025687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2025690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2025695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2025698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2025701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2025704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2025710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025737 */     // MIs[1] Operand 1
     /* 2025737 */     // No operand predicates
     /* 2025737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025741 */     // MIs[0] round
     /* 2025741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025744 */     // MIs[0] policy
     /* 2025744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025756 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2025759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2025780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025783 */     // GIR_Coverage, 16280,
     /* 2025783 */     GIR_EraseRootFromParent_Done,
     /* 2025784 */   // Label 27032: @2025784
     /* 2025784 */   GIM_Try, /*On fail goto*//*Label 27033*/ GIMT_Encode4(2025886), // Rule ID 16281 //
     /* 2025789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2025792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2025797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2025800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2025803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2025806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2025812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025839 */     // MIs[1] Operand 1
     /* 2025839 */     // No operand predicates
     /* 2025839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025843 */     // MIs[0] round
     /* 2025843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025846 */     // MIs[0] policy
     /* 2025846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025858 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2025861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2025882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025885 */     // GIR_Coverage, 16281,
     /* 2025885 */     GIR_EraseRootFromParent_Done,
     /* 2025886 */   // Label 27033: @2025886
     /* 2025886 */   GIM_Try, /*On fail goto*//*Label 27034*/ GIMT_Encode4(2025988), // Rule ID 16284 //
     /* 2025891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2025899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2025902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2025905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2025908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2025914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025941 */     // MIs[1] Operand 1
     /* 2025941 */     // No operand predicates
     /* 2025941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025945 */     // MIs[0] round
     /* 2025945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025948 */     // MIs[0] policy
     /* 2025948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2025963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025987 */     // GIR_Coverage, 16284,
     /* 2025987 */     GIR_EraseRootFromParent_Done,
     /* 2025988 */   // Label 27034: @2025988
     /* 2025988 */   GIM_Try, /*On fail goto*//*Label 27035*/ GIMT_Encode4(2026090), // Rule ID 16285 //
     /* 2025993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2026001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2026004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2026007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2026010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2026016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026043 */     // MIs[1] Operand 1
     /* 2026043 */     // No operand predicates
     /* 2026043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026047 */     // MIs[0] round
     /* 2026047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026050 */     // MIs[0] policy
     /* 2026050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026062 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2026065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2026086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026089 */     // GIR_Coverage, 16285,
     /* 2026089 */     GIR_EraseRootFromParent_Done,
     /* 2026090 */   // Label 27035: @2026090
     /* 2026090 */   GIM_Try, /*On fail goto*//*Label 27036*/ GIMT_Encode4(2026192), // Rule ID 16288 //
     /* 2026095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2026103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2026106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2026109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2026112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2026118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026145 */     // MIs[1] Operand 1
     /* 2026145 */     // No operand predicates
     /* 2026145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026149 */     // MIs[0] round
     /* 2026149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026152 */     // MIs[0] policy
     /* 2026152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026164 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2026167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2026188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026191 */     // GIR_Coverage, 16288,
     /* 2026191 */     GIR_EraseRootFromParent_Done,
     /* 2026192 */   // Label 27036: @2026192
     /* 2026192 */   GIM_Try, /*On fail goto*//*Label 27037*/ GIMT_Encode4(2026294), // Rule ID 16289 //
     /* 2026197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2026205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2026208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2026211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2026214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2026220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026247 */     // MIs[1] Operand 1
     /* 2026247 */     // No operand predicates
     /* 2026247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026251 */     // MIs[0] round
     /* 2026251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026254 */     // MIs[0] policy
     /* 2026254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026266 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2026269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2026290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026293 */     // GIR_Coverage, 16289,
     /* 2026293 */     GIR_EraseRootFromParent_Done,
     /* 2026294 */   // Label 27037: @2026294
     /* 2026294 */   GIM_Try, /*On fail goto*//*Label 27038*/ GIMT_Encode4(2026396), // Rule ID 16292 //
     /* 2026299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2026307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2026310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2026313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2026316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2026322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2026329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026349 */     // MIs[1] Operand 1
     /* 2026349 */     // No operand predicates
     /* 2026349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026353 */     // MIs[0] round
     /* 2026353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026356 */     // MIs[0] policy
     /* 2026356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026368 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2026371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2026392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026395 */     // GIR_Coverage, 16292,
     /* 2026395 */     GIR_EraseRootFromParent_Done,
     /* 2026396 */   // Label 27038: @2026396
     /* 2026396 */   GIM_Try, /*On fail goto*//*Label 27039*/ GIMT_Encode4(2026498), // Rule ID 16293 //
     /* 2026401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2026409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2026412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2026415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2026418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2026424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2026431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026451 */     // MIs[1] Operand 1
     /* 2026451 */     // No operand predicates
     /* 2026451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026455 */     // MIs[0] round
     /* 2026455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026458 */     // MIs[0] policy
     /* 2026458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026470 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2026473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2026494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026497 */     // GIR_Coverage, 16293,
     /* 2026497 */     GIR_EraseRootFromParent_Done,
     /* 2026498 */   // Label 27039: @2026498
     /* 2026498 */   GIM_Try, /*On fail goto*//*Label 27040*/ GIMT_Encode4(2026600), // Rule ID 16296 //
     /* 2026503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2026511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2026514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2026517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2026520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026553 */     // MIs[1] Operand 1
     /* 2026553 */     // No operand predicates
     /* 2026553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026557 */     // MIs[0] round
     /* 2026557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026560 */     // MIs[0] policy
     /* 2026560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026572 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2026575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026599 */     // GIR_Coverage, 16296,
     /* 2026599 */     GIR_EraseRootFromParent_Done,
     /* 2026600 */   // Label 27040: @2026600
     /* 2026600 */   GIM_Try, /*On fail goto*//*Label 27041*/ GIMT_Encode4(2026702), // Rule ID 16297 //
     /* 2026605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2026613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2026616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2026619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2026622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026655 */     // MIs[1] Operand 1
     /* 2026655 */     // No operand predicates
     /* 2026655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026659 */     // MIs[0] round
     /* 2026659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026662 */     // MIs[0] policy
     /* 2026662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026674 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2026677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026701 */     // GIR_Coverage, 16297,
     /* 2026701 */     GIR_EraseRootFromParent_Done,
     /* 2026702 */   // Label 27041: @2026702
     /* 2026702 */   GIM_Try, /*On fail goto*//*Label 27042*/ GIMT_Encode4(2026804), // Rule ID 16300 //
     /* 2026707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2026715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2026718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2026721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2026724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2026730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026757 */     // MIs[1] Operand 1
     /* 2026757 */     // No operand predicates
     /* 2026757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026761 */     // MIs[0] round
     /* 2026761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026764 */     // MIs[0] policy
     /* 2026764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026776 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2026779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026803 */     // GIR_Coverage, 16300,
     /* 2026803 */     GIR_EraseRootFromParent_Done,
     /* 2026804 */   // Label 27042: @2026804
     /* 2026804 */   GIM_Try, /*On fail goto*//*Label 27043*/ GIMT_Encode4(2026906), // Rule ID 16301 //
     /* 2026809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2026817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2026820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2026823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2026826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2026832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026859 */     // MIs[1] Operand 1
     /* 2026859 */     // No operand predicates
     /* 2026859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026863 */     // MIs[0] round
     /* 2026863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026866 */     // MIs[0] policy
     /* 2026866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026878 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2026881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026905 */     // GIR_Coverage, 16301,
     /* 2026905 */     GIR_EraseRootFromParent_Done,
     /* 2026906 */   // Label 27043: @2026906
     /* 2026906 */   GIM_Try, /*On fail goto*//*Label 27044*/ GIMT_Encode4(2027008), // Rule ID 16304 //
     /* 2026911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2026919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2026922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2026925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2026928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2026934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2026941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026961 */     // MIs[1] Operand 1
     /* 2026961 */     // No operand predicates
     /* 2026961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026965 */     // MIs[0] round
     /* 2026965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026968 */     // MIs[0] policy
     /* 2026968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026980 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2026983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027007 */     // GIR_Coverage, 16304,
     /* 2027007 */     GIR_EraseRootFromParent_Done,
     /* 2027008 */   // Label 27044: @2027008
     /* 2027008 */   GIM_Try, /*On fail goto*//*Label 27045*/ GIMT_Encode4(2027110), // Rule ID 16305 //
     /* 2027013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2027021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2027024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2027027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2027030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2027036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2027043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027063 */     // MIs[1] Operand 1
     /* 2027063 */     // No operand predicates
     /* 2027063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027067 */     // MIs[0] round
     /* 2027067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027070 */     // MIs[0] policy
     /* 2027070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027082 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2027085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027109 */     // GIR_Coverage, 16305,
     /* 2027109 */     GIR_EraseRootFromParent_Done,
     /* 2027110 */   // Label 27045: @2027110
     /* 2027110 */   GIM_Try, /*On fail goto*//*Label 27046*/ GIMT_Encode4(2027212), // Rule ID 16308 //
     /* 2027115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2027123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2027126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2027129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2027132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027165 */     // MIs[1] Operand 1
     /* 2027165 */     // No operand predicates
     /* 2027165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027169 */     // MIs[0] round
     /* 2027169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027172 */     // MIs[0] policy
     /* 2027172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2027187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027211 */     // GIR_Coverage, 16308,
     /* 2027211 */     GIR_EraseRootFromParent_Done,
     /* 2027212 */   // Label 27046: @2027212
     /* 2027212 */   GIM_Try, /*On fail goto*//*Label 27047*/ GIMT_Encode4(2027314), // Rule ID 16309 //
     /* 2027217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2027225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2027228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2027231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2027234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027267 */     // MIs[1] Operand 1
     /* 2027267 */     // No operand predicates
     /* 2027267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027271 */     // MIs[0] round
     /* 2027271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027274 */     // MIs[0] policy
     /* 2027274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2027289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027313 */     // GIR_Coverage, 16309,
     /* 2027313 */     GIR_EraseRootFromParent_Done,
     /* 2027314 */   // Label 27047: @2027314
     /* 2027314 */   GIM_Try, /*On fail goto*//*Label 27048*/ GIMT_Encode4(2027416), // Rule ID 16312 //
     /* 2027319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2027327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2027330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2027333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2027336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2027342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027369 */     // MIs[1] Operand 1
     /* 2027369 */     // No operand predicates
     /* 2027369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027373 */     // MIs[0] round
     /* 2027373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027376 */     // MIs[0] policy
     /* 2027376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027388 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2027391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027415 */     // GIR_Coverage, 16312,
     /* 2027415 */     GIR_EraseRootFromParent_Done,
     /* 2027416 */   // Label 27048: @2027416
     /* 2027416 */   GIM_Try, /*On fail goto*//*Label 27049*/ GIMT_Encode4(2027518), // Rule ID 16313 //
     /* 2027421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2027429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2027432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2027435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2027438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2027444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027471 */     // MIs[1] Operand 1
     /* 2027471 */     // No operand predicates
     /* 2027471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027475 */     // MIs[0] round
     /* 2027475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027478 */     // MIs[0] policy
     /* 2027478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2027493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027517 */     // GIR_Coverage, 16313,
     /* 2027517 */     GIR_EraseRootFromParent_Done,
     /* 2027518 */   // Label 27049: @2027518
     /* 2027518 */   GIM_Try, /*On fail goto*//*Label 27050*/ GIMT_Encode4(2027620), // Rule ID 16316 //
     /* 2027523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2027531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2027534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2027537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2027540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2027546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2027553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027573 */     // MIs[1] Operand 1
     /* 2027573 */     // No operand predicates
     /* 2027573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027577 */     // MIs[0] round
     /* 2027577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027580 */     // MIs[0] policy
     /* 2027580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027592 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2027595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027619 */     // GIR_Coverage, 16316,
     /* 2027619 */     GIR_EraseRootFromParent_Done,
     /* 2027620 */   // Label 27050: @2027620
     /* 2027620 */   GIM_Try, /*On fail goto*//*Label 27051*/ GIMT_Encode4(2027722), // Rule ID 16317 //
     /* 2027625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2027633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2027636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2027639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2027642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2027648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2027655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027675 */     // MIs[1] Operand 1
     /* 2027675 */     // No operand predicates
     /* 2027675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027679 */     // MIs[0] round
     /* 2027679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027682 */     // MIs[0] policy
     /* 2027682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027694 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2027697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027721 */     // GIR_Coverage, 16317,
     /* 2027721 */     GIR_EraseRootFromParent_Done,
     /* 2027722 */   // Label 27051: @2027722
     /* 2027722 */   GIM_Try, /*On fail goto*//*Label 27052*/ GIMT_Encode4(2027824), // Rule ID 16320 //
     /* 2027727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2027730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2027735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2027738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2027741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2027744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027777 */     // MIs[1] Operand 1
     /* 2027777 */     // No operand predicates
     /* 2027777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027781 */     // MIs[0] round
     /* 2027781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027784 */     // MIs[0] policy
     /* 2027784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027796 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2027799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2027820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027823 */     // GIR_Coverage, 16320,
     /* 2027823 */     GIR_EraseRootFromParent_Done,
     /* 2027824 */   // Label 27052: @2027824
     /* 2027824 */   GIM_Try, /*On fail goto*//*Label 27053*/ GIMT_Encode4(2027926), // Rule ID 16321 //
     /* 2027829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2027832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2027837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2027840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2027843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2027846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027879 */     // MIs[1] Operand 1
     /* 2027879 */     // No operand predicates
     /* 2027879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027883 */     // MIs[0] round
     /* 2027883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027886 */     // MIs[0] policy
     /* 2027886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027898 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2027901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2027922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027925 */     // GIR_Coverage, 16321,
     /* 2027925 */     GIR_EraseRootFromParent_Done,
     /* 2027926 */   // Label 27053: @2027926
     /* 2027926 */   GIM_Try, /*On fail goto*//*Label 27054*/ GIMT_Encode4(2028028), // Rule ID 16324 //
     /* 2027931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2027934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2027939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2027942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2027945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2027948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027981 */     // MIs[1] Operand 1
     /* 2027981 */     // No operand predicates
     /* 2027981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027985 */     // MIs[0] round
     /* 2027985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027988 */     // MIs[0] policy
     /* 2027988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028000 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2028003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2028024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028027 */     // GIR_Coverage, 16324,
     /* 2028027 */     GIR_EraseRootFromParent_Done,
     /* 2028028 */   // Label 27054: @2028028
     /* 2028028 */   GIM_Try, /*On fail goto*//*Label 27055*/ GIMT_Encode4(2028130), // Rule ID 16325 //
     /* 2028033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2028036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2028041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2028044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2028047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2028050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2028063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028083 */     // MIs[1] Operand 1
     /* 2028083 */     // No operand predicates
     /* 2028083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028087 */     // MIs[0] round
     /* 2028087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028090 */     // MIs[0] policy
     /* 2028090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028102 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2028105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2028126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028129 */     // GIR_Coverage, 16325,
     /* 2028129 */     GIR_EraseRootFromParent_Done,
     /* 2028130 */   // Label 27055: @2028130
     /* 2028130 */   GIM_Try, /*On fail goto*//*Label 27056*/ GIMT_Encode4(2028232), // Rule ID 16328 //
     /* 2028135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2028138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2028143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2028146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2028149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2028152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2028165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028185 */     // MIs[1] Operand 1
     /* 2028185 */     // No operand predicates
     /* 2028185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028189 */     // MIs[0] round
     /* 2028189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028192 */     // MIs[0] policy
     /* 2028192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028204 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2028207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2028228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028231 */     // GIR_Coverage, 16328,
     /* 2028231 */     GIR_EraseRootFromParent_Done,
     /* 2028232 */   // Label 27056: @2028232
     /* 2028232 */   GIM_Try, /*On fail goto*//*Label 27057*/ GIMT_Encode4(2028334), // Rule ID 16329 //
     /* 2028237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2028240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2028245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2028248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2028251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2028254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2028267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028287 */     // MIs[1] Operand 1
     /* 2028287 */     // No operand predicates
     /* 2028287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028291 */     // MIs[0] round
     /* 2028291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028294 */     // MIs[0] policy
     /* 2028294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2028309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2028330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028333 */     // GIR_Coverage, 16329,
     /* 2028333 */     GIR_EraseRootFromParent_Done,
     /* 2028334 */   // Label 27057: @2028334
     /* 2028334 */   GIM_Try, /*On fail goto*//*Label 27058*/ GIMT_Encode4(2028439), // Rule ID 16452 //
     /* 2028339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2028347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2028350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2028353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2028356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028389 */     // MIs[1] Operand 1
     /* 2028389 */     // No operand predicates
     /* 2028389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028393 */     // MIs[0] round
     /* 2028393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028396 */     // MIs[0] policy
     /* 2028396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028408 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2028411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028438 */     // GIR_Coverage, 16452,
     /* 2028438 */     GIR_EraseRootFromParent_Done,
     /* 2028439 */   // Label 27058: @2028439
     /* 2028439 */   GIM_Try, /*On fail goto*//*Label 27059*/ GIMT_Encode4(2028544), // Rule ID 16453 //
     /* 2028444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2028452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2028455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2028458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2028461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028494 */     // MIs[1] Operand 1
     /* 2028494 */     // No operand predicates
     /* 2028494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028498 */     // MIs[0] round
     /* 2028498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028501 */     // MIs[0] policy
     /* 2028501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028513 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2028516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028543 */     // GIR_Coverage, 16453,
     /* 2028543 */     GIR_EraseRootFromParent_Done,
     /* 2028544 */   // Label 27059: @2028544
     /* 2028544 */   GIM_Try, /*On fail goto*//*Label 27060*/ GIMT_Encode4(2028649), // Rule ID 16456 //
     /* 2028549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2028557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2028560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2028563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2028566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028599 */     // MIs[1] Operand 1
     /* 2028599 */     // No operand predicates
     /* 2028599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028603 */     // MIs[0] round
     /* 2028603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028606 */     // MIs[0] policy
     /* 2028606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028618 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2028621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028648 */     // GIR_Coverage, 16456,
     /* 2028648 */     GIR_EraseRootFromParent_Done,
     /* 2028649 */   // Label 27060: @2028649
     /* 2028649 */   GIM_Try, /*On fail goto*//*Label 27061*/ GIMT_Encode4(2028754), // Rule ID 16457 //
     /* 2028654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2028662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2028665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2028668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2028671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028677 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028704 */     // MIs[1] Operand 1
     /* 2028704 */     // No operand predicates
     /* 2028704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028708 */     // MIs[0] round
     /* 2028708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028711 */     // MIs[0] policy
     /* 2028711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028723 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2028726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028753 */     // GIR_Coverage, 16457,
     /* 2028753 */     GIR_EraseRootFromParent_Done,
     /* 2028754 */   // Label 27061: @2028754
     /* 2028754 */   GIM_Try, /*On fail goto*//*Label 27062*/ GIMT_Encode4(2028859), // Rule ID 16460 //
     /* 2028759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2028767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2028770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2028773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028809 */     // MIs[1] Operand 1
     /* 2028809 */     // No operand predicates
     /* 2028809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028813 */     // MIs[0] round
     /* 2028813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028816 */     // MIs[0] policy
     /* 2028816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028828 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2028831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028858 */     // GIR_Coverage, 16460,
     /* 2028858 */     GIR_EraseRootFromParent_Done,
     /* 2028859 */   // Label 27062: @2028859
     /* 2028859 */   GIM_Try, /*On fail goto*//*Label 27063*/ GIMT_Encode4(2028964), // Rule ID 16461 //
     /* 2028864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2028872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2028875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2028878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028914 */     // MIs[1] Operand 1
     /* 2028914 */     // No operand predicates
     /* 2028914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028918 */     // MIs[0] round
     /* 2028918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028921 */     // MIs[0] policy
     /* 2028921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028933 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2028936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028963 */     // GIR_Coverage, 16461,
     /* 2028963 */     GIR_EraseRootFromParent_Done,
     /* 2028964 */   // Label 27063: @2028964
     /* 2028964 */   GIM_Try, /*On fail goto*//*Label 27064*/ GIMT_Encode4(2029069), // Rule ID 16464 //
     /* 2028969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2028977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2028980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2028983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2028986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029019 */     // MIs[1] Operand 1
     /* 2029019 */     // No operand predicates
     /* 2029019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029023 */     // MIs[0] round
     /* 2029023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029026 */     // MIs[0] policy
     /* 2029026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029038 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2029041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029068 */     // GIR_Coverage, 16464,
     /* 2029068 */     GIR_EraseRootFromParent_Done,
     /* 2029069 */   // Label 27064: @2029069
     /* 2029069 */   GIM_Try, /*On fail goto*//*Label 27065*/ GIMT_Encode4(2029174), // Rule ID 16465 //
     /* 2029074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2029082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2029085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2029088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2029091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2029097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029124 */     // MIs[1] Operand 1
     /* 2029124 */     // No operand predicates
     /* 2029124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029128 */     // MIs[0] round
     /* 2029128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029131 */     // MIs[0] policy
     /* 2029131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029143 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2029146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029173 */     // GIR_Coverage, 16465,
     /* 2029173 */     GIR_EraseRootFromParent_Done,
     /* 2029174 */   // Label 27065: @2029174
     /* 2029174 */   GIM_Try, /*On fail goto*//*Label 27066*/ GIMT_Encode4(2029279), // Rule ID 16468 //
     /* 2029179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2029187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2029190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2029193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2029196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2029202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029229 */     // MIs[1] Operand 1
     /* 2029229 */     // No operand predicates
     /* 2029229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029233 */     // MIs[0] round
     /* 2029233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029236 */     // MIs[0] policy
     /* 2029236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2029251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029278 */     // GIR_Coverage, 16468,
     /* 2029278 */     GIR_EraseRootFromParent_Done,
     /* 2029279 */   // Label 27066: @2029279
     /* 2029279 */   GIM_Try, /*On fail goto*//*Label 27067*/ GIMT_Encode4(2029384), // Rule ID 16469 //
     /* 2029284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2029292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2029295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2029298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2029301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2029307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029334 */     // MIs[1] Operand 1
     /* 2029334 */     // No operand predicates
     /* 2029334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029338 */     // MIs[0] round
     /* 2029338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029341 */     // MIs[0] policy
     /* 2029341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029353 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2029356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029383 */     // GIR_Coverage, 16469,
     /* 2029383 */     GIR_EraseRootFromParent_Done,
     /* 2029384 */   // Label 27067: @2029384
     /* 2029384 */   GIM_Try, /*On fail goto*//*Label 27068*/ GIMT_Encode4(2029489), // Rule ID 16472 //
     /* 2029389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2029397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2029400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2029403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2029406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2029412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029439 */     // MIs[1] Operand 1
     /* 2029439 */     // No operand predicates
     /* 2029439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029443 */     // MIs[0] round
     /* 2029443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029446 */     // MIs[0] policy
     /* 2029446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029458 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2029461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029488 */     // GIR_Coverage, 16472,
     /* 2029488 */     GIR_EraseRootFromParent_Done,
     /* 2029489 */   // Label 27068: @2029489
     /* 2029489 */   GIM_Try, /*On fail goto*//*Label 27069*/ GIMT_Encode4(2029594), // Rule ID 16473 //
     /* 2029494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2029502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2029505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2029508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2029511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2029517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029544 */     // MIs[1] Operand 1
     /* 2029544 */     // No operand predicates
     /* 2029544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029548 */     // MIs[0] round
     /* 2029548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029551 */     // MIs[0] policy
     /* 2029551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029563 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2029566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029593 */     // GIR_Coverage, 16473,
     /* 2029593 */     GIR_EraseRootFromParent_Done,
     /* 2029594 */   // Label 27069: @2029594
     /* 2029594 */   GIM_Try, /*On fail goto*//*Label 27070*/ GIMT_Encode4(2029699), // Rule ID 16476 //
     /* 2029599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2029607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2029610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2029613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2029616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029649 */     // MIs[1] Operand 1
     /* 2029649 */     // No operand predicates
     /* 2029649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029653 */     // MIs[0] round
     /* 2029653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029656 */     // MIs[0] policy
     /* 2029656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2029671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029698 */     // GIR_Coverage, 16476,
     /* 2029698 */     GIR_EraseRootFromParent_Done,
     /* 2029699 */   // Label 27070: @2029699
     /* 2029699 */   GIM_Try, /*On fail goto*//*Label 27071*/ GIMT_Encode4(2029804), // Rule ID 16477 //
     /* 2029704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2029712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2029715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2029718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2029721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029754 */     // MIs[1] Operand 1
     /* 2029754 */     // No operand predicates
     /* 2029754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029758 */     // MIs[0] round
     /* 2029758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029761 */     // MIs[0] policy
     /* 2029761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029773 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2029776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029803 */     // GIR_Coverage, 16477,
     /* 2029803 */     GIR_EraseRootFromParent_Done,
     /* 2029804 */   // Label 27071: @2029804
     /* 2029804 */   GIM_Try, /*On fail goto*//*Label 27072*/ GIMT_Encode4(2029909), // Rule ID 16480 //
     /* 2029809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2029817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2029820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2029823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2029826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029859 */     // MIs[1] Operand 1
     /* 2029859 */     // No operand predicates
     /* 2029859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029863 */     // MIs[0] round
     /* 2029863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029866 */     // MIs[0] policy
     /* 2029866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029878 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2029881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029908 */     // GIR_Coverage, 16480,
     /* 2029908 */     GIR_EraseRootFromParent_Done,
     /* 2029909 */   // Label 27072: @2029909
     /* 2029909 */   GIM_Try, /*On fail goto*//*Label 27073*/ GIMT_Encode4(2030014), // Rule ID 16481 //
     /* 2029914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2029922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2029925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2029928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2029931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029964 */     // MIs[1] Operand 1
     /* 2029964 */     // No operand predicates
     /* 2029964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029968 */     // MIs[0] round
     /* 2029968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029971 */     // MIs[0] policy
     /* 2029971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029983 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2029986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030013 */     // GIR_Coverage, 16481,
     /* 2030013 */     GIR_EraseRootFromParent_Done,
     /* 2030014 */   // Label 27073: @2030014
     /* 2030014 */   GIM_Try, /*On fail goto*//*Label 27074*/ GIMT_Encode4(2030119), // Rule ID 16484 //
     /* 2030019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2030022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2030027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2030030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2030033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2030036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030069 */     // MIs[1] Operand 1
     /* 2030069 */     // No operand predicates
     /* 2030069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030073 */     // MIs[0] round
     /* 2030073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030076 */     // MIs[0] policy
     /* 2030076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030088 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2030091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030118 */     // GIR_Coverage, 16484,
     /* 2030118 */     GIR_EraseRootFromParent_Done,
     /* 2030119 */   // Label 27074: @2030119
     /* 2030119 */   GIM_Try, /*On fail goto*//*Label 27075*/ GIMT_Encode4(2030224), // Rule ID 16485 //
     /* 2030124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2030132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2030135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2030138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2030141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030174 */     // MIs[1] Operand 1
     /* 2030174 */     // No operand predicates
     /* 2030174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030178 */     // MIs[0] round
     /* 2030178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030181 */     // MIs[0] policy
     /* 2030181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030193 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2030196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030223 */     // GIR_Coverage, 16485,
     /* 2030223 */     GIR_EraseRootFromParent_Done,
     /* 2030224 */   // Label 27075: @2030224
     /* 2030224 */   GIM_Try, /*On fail goto*//*Label 27076*/ GIMT_Encode4(2030329), // Rule ID 16488 //
     /* 2030229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2030232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2030237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2030240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2030243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2030246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030279 */     // MIs[1] Operand 1
     /* 2030279 */     // No operand predicates
     /* 2030279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030283 */     // MIs[0] round
     /* 2030283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030286 */     // MIs[0] policy
     /* 2030286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2030301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030328 */     // GIR_Coverage, 16488,
     /* 2030328 */     GIR_EraseRootFromParent_Done,
     /* 2030329 */   // Label 27076: @2030329
     /* 2030329 */   GIM_Try, /*On fail goto*//*Label 27077*/ GIMT_Encode4(2030434), // Rule ID 16489 //
     /* 2030334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2030342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2030345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2030348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2030351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030384 */     // MIs[1] Operand 1
     /* 2030384 */     // No operand predicates
     /* 2030384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030388 */     // MIs[0] round
     /* 2030388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030391 */     // MIs[0] policy
     /* 2030391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030403 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2030406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030433 */     // GIR_Coverage, 16489,
     /* 2030433 */     GIR_EraseRootFromParent_Done,
     /* 2030434 */   // Label 27077: @2030434
     /* 2030434 */   GIM_Try, /*On fail goto*//*Label 27078*/ GIMT_Encode4(2030539), // Rule ID 16492 //
     /* 2030439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2030442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2030447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2030450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2030453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2030456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030489 */     // MIs[1] Operand 1
     /* 2030489 */     // No operand predicates
     /* 2030489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030493 */     // MIs[0] round
     /* 2030493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030496 */     // MIs[0] policy
     /* 2030496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030508 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2030511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030538 */     // GIR_Coverage, 16492,
     /* 2030538 */     GIR_EraseRootFromParent_Done,
     /* 2030539 */   // Label 27078: @2030539
     /* 2030539 */   GIM_Try, /*On fail goto*//*Label 27079*/ GIMT_Encode4(2030644), // Rule ID 16493 //
     /* 2030544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2030552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2030555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2030558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2030561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030594 */     // MIs[1] Operand 1
     /* 2030594 */     // No operand predicates
     /* 2030594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030598 */     // MIs[0] round
     /* 2030598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030601 */     // MIs[0] policy
     /* 2030601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030613 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2030616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030643 */     // GIR_Coverage, 16493,
     /* 2030643 */     GIR_EraseRootFromParent_Done,
     /* 2030644 */   // Label 27079: @2030644
     /* 2030644 */   GIM_Try, /*On fail goto*//*Label 27080*/ GIMT_Encode4(2030749), // Rule ID 16496 //
     /* 2030649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2030657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2030660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2030663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2030666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2030672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030699 */     // MIs[1] Operand 1
     /* 2030699 */     // No operand predicates
     /* 2030699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030703 */     // MIs[0] round
     /* 2030703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030706 */     // MIs[0] policy
     /* 2030706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030718 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2030721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030748 */     // GIR_Coverage, 16496,
     /* 2030748 */     GIR_EraseRootFromParent_Done,
     /* 2030749 */   // Label 27080: @2030749
     /* 2030749 */   GIM_Try, /*On fail goto*//*Label 27081*/ GIMT_Encode4(2030854), // Rule ID 16497 //
     /* 2030754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2030762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2030765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2030768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2030771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2030777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030804 */     // MIs[1] Operand 1
     /* 2030804 */     // No operand predicates
     /* 2030804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030808 */     // MIs[0] round
     /* 2030808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030811 */     // MIs[0] policy
     /* 2030811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030823 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2030826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030853 */     // GIR_Coverage, 16497,
     /* 2030853 */     GIR_EraseRootFromParent_Done,
     /* 2030854 */   // Label 27081: @2030854
     /* 2030854 */   GIM_Try, /*On fail goto*//*Label 27082*/ GIMT_Encode4(2030959), // Rule ID 16500 //
     /* 2030859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2030867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2030870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2030873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030909 */     // MIs[1] Operand 1
     /* 2030909 */     // No operand predicates
     /* 2030909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030913 */     // MIs[0] round
     /* 2030913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030916 */     // MIs[0] policy
     /* 2030916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030928 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2030931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030958 */     // GIR_Coverage, 16500,
     /* 2030958 */     GIR_EraseRootFromParent_Done,
     /* 2030959 */   // Label 27082: @2030959
     /* 2030959 */   GIM_Try, /*On fail goto*//*Label 27083*/ GIMT_Encode4(2031064), // Rule ID 16501 //
     /* 2030964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2030972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2030975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2030978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031014 */     // MIs[1] Operand 1
     /* 2031014 */     // No operand predicates
     /* 2031014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031018 */     // MIs[0] round
     /* 2031018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031021 */     // MIs[0] policy
     /* 2031021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031033 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2031036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031063 */     // GIR_Coverage, 16501,
     /* 2031063 */     GIR_EraseRootFromParent_Done,
     /* 2031064 */   // Label 27083: @2031064
     /* 2031064 */   GIM_Try, /*On fail goto*//*Label 27084*/ GIMT_Encode4(2031169), // Rule ID 16504 //
     /* 2031069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2031072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2031077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2031080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2031083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2031086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2031089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031119 */     // MIs[1] Operand 1
     /* 2031119 */     // No operand predicates
     /* 2031119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031123 */     // MIs[0] round
     /* 2031123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031126 */     // MIs[0] policy
     /* 2031126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031138 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2031141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031168 */     // GIR_Coverage, 16504,
     /* 2031168 */     GIR_EraseRootFromParent_Done,
     /* 2031169 */   // Label 27084: @2031169
     /* 2031169 */   GIM_Try, /*On fail goto*//*Label 27085*/ GIMT_Encode4(2031274), // Rule ID 16505 //
     /* 2031174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2031177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2031182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2031185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2031188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2031191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2031194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031224 */     // MIs[1] Operand 1
     /* 2031224 */     // No operand predicates
     /* 2031224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031228 */     // MIs[0] round
     /* 2031228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031231 */     // MIs[0] policy
     /* 2031231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031243 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2031246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031273 */     // GIR_Coverage, 16505,
     /* 2031273 */     GIR_EraseRootFromParent_Done,
     /* 2031274 */   // Label 27085: @2031274
     /* 2031274 */   GIM_Try, /*On fail goto*//*Label 27086*/ GIMT_Encode4(2031379), // Rule ID 16508 //
     /* 2031279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2031282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2031287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2031296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2031299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031329 */     // MIs[1] Operand 1
     /* 2031329 */     // No operand predicates
     /* 2031329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031333 */     // MIs[0] round
     /* 2031333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031336 */     // MIs[0] policy
     /* 2031336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031348 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2031351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031378 */     // GIR_Coverage, 16508,
     /* 2031378 */     GIR_EraseRootFromParent_Done,
     /* 2031379 */   // Label 27086: @2031379
     /* 2031379 */   GIM_Try, /*On fail goto*//*Label 27087*/ GIMT_Encode4(2031484), // Rule ID 16509 //
     /* 2031384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2031387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2031392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2031401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2031404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031434 */     // MIs[1] Operand 1
     /* 2031434 */     // No operand predicates
     /* 2031434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031438 */     // MIs[0] round
     /* 2031438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031441 */     // MIs[0] policy
     /* 2031441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031453 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2031456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031479 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031483 */     // GIR_Coverage, 16509,
     /* 2031483 */     GIR_EraseRootFromParent_Done,
     /* 2031484 */   // Label 27087: @2031484
     /* 2031484 */   GIM_Try, /*On fail goto*//*Label 27088*/ GIMT_Encode4(2031589), // Rule ID 16632 //
     /* 2031489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2031492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2031497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2031500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2031503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2031506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2031509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031539 */     // MIs[1] Operand 1
     /* 2031539 */     // No operand predicates
     /* 2031539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031543 */     // MIs[0] round
     /* 2031543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031546 */     // MIs[0] policy
     /* 2031546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031558 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2031561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031588 */     // GIR_Coverage, 16632,
     /* 2031588 */     GIR_EraseRootFromParent_Done,
     /* 2031589 */   // Label 27088: @2031589
     /* 2031589 */   GIM_Try, /*On fail goto*//*Label 27089*/ GIMT_Encode4(2031694), // Rule ID 16633 //
     /* 2031594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2031597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2031602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2031605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2031608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2031611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2031614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031644 */     // MIs[1] Operand 1
     /* 2031644 */     // No operand predicates
     /* 2031644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031648 */     // MIs[0] round
     /* 2031648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031651 */     // MIs[0] policy
     /* 2031651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031663 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2031666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031693 */     // GIR_Coverage, 16633,
     /* 2031693 */     GIR_EraseRootFromParent_Done,
     /* 2031694 */   // Label 27089: @2031694
     /* 2031694 */   GIM_Try, /*On fail goto*//*Label 27090*/ GIMT_Encode4(2031799), // Rule ID 16636 //
     /* 2031699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2031702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2031707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2031710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2031713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2031716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2031719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031749 */     // MIs[1] Operand 1
     /* 2031749 */     // No operand predicates
     /* 2031749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031753 */     // MIs[0] round
     /* 2031753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031756 */     // MIs[0] policy
     /* 2031756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031768 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2031771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031798 */     // GIR_Coverage, 16636,
     /* 2031798 */     GIR_EraseRootFromParent_Done,
     /* 2031799 */   // Label 27090: @2031799
     /* 2031799 */   GIM_Try, /*On fail goto*//*Label 27091*/ GIMT_Encode4(2031904), // Rule ID 16637 //
     /* 2031804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2031807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2031812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2031815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2031818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2031821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2031824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031854 */     // MIs[1] Operand 1
     /* 2031854 */     // No operand predicates
     /* 2031854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031858 */     // MIs[0] round
     /* 2031858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031861 */     // MIs[0] policy
     /* 2031861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031873 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2031876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031903 */     // GIR_Coverage, 16637,
     /* 2031903 */     GIR_EraseRootFromParent_Done,
     /* 2031904 */   // Label 27091: @2031904
     /* 2031904 */   GIM_Try, /*On fail goto*//*Label 27092*/ GIMT_Encode4(2032009), // Rule ID 16640 //
     /* 2031909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2031912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2031917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2031920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2031923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2031926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2031929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031959 */     // MIs[1] Operand 1
     /* 2031959 */     // No operand predicates
     /* 2031959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031963 */     // MIs[0] round
     /* 2031963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031966 */     // MIs[0] policy
     /* 2031966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031978 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2031981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2032002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2032007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032008 */     // GIR_Coverage, 16640,
     /* 2032008 */     GIR_EraseRootFromParent_Done,
     /* 2032009 */   // Label 27092: @2032009
     /* 2032009 */   GIM_Try, /*On fail goto*//*Label 27093*/ GIMT_Encode4(2032114), // Rule ID 16641 //
     /* 2032014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2032022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2032025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2032028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2032031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2032056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2032060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2032064 */     // MIs[1] Operand 1
     /* 2032064 */     // No operand predicates
     /* 2032064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032068 */     // MIs[0] round
     /* 2032068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032071 */     // MIs[0] policy
     /* 2032071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2032076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032083 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2032086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2032095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2032107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2032112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032113 */     // GIR_Coverage, 16641,
     /* 2032113 */     GIR_EraseRootFromParent_Done,
     /* 2032114 */   // Label 27093: @2032114
     /* 2032114 */   GIM_Try, /*On fail goto*//*Label 27094*/ GIMT_Encode4(2032219), // Rule ID 16644 //
     /* 2032119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2032127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2032130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2032133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2032136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2032139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2032161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2032165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2032169 */     // MIs[1] Operand 1
     /* 2032169 */     // No operand predicates
     /* 2032169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032173 */     // MIs[0] round
     /* 2032173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032176 */     // MIs[0] policy
     /* 2032176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2032181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032188 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2032191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2032200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2032212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2032217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032218 */     // GIR_Coverage, 16644,
     /* 2032218 */     GIR_EraseRootFromParent_Done,
     /* 2032219 */   // Label 27094: @2032219
     /* 2032219 */   GIM_Try, /*On fail goto*//*Label 27095*/ GIMT_Encode4(2032324), // Rule ID 16645 //
     /* 2032224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2032232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2032235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2032238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2032241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2032266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2032270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2032274 */     // MIs[1] Operand 1
     /* 2032274 */     // No operand predicates
     /* 2032274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032278 */     // MIs[0] round
     /* 2032278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032281 */     // MIs[0] policy
     /* 2032281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2032286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032293 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2032296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2032305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2032317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2032322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032323 */     // GIR_Coverage, 16645,
     /* 2032323 */     GIR_EraseRootFromParent_Done,
     /* 2032324 */   // Label 27095: @2032324
     /* 2032324 */   GIM_Try, /*On fail goto*//*Label 27096*/ GIMT_Encode4(2032429), // Rule ID 16648 //
     /* 2032329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2032337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2032340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2032343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2032346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2032349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2032352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2032359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2032371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2032375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2032379 */     // MIs[1] Operand 1
     /* 2032379 */     // No operand predicates
     /* 2032379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032383 */     // MIs[0] round
     /* 2032383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032386 */     // MIs[0] policy
     /* 2032386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2032391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2032401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2032410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2032422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2032427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032428 */     // GIR_Coverage, 16648,
     /* 2032428 */     GIR_EraseRootFromParent_Done,
     /* 2032429 */   // Label 27096: @2032429
     /* 2032429 */   GIM_Try, /*On fail goto*//*Label 27097*/ GIMT_Encode4(2032534), // Rule ID 16649 //
     /* 2032434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2032442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2032445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2032448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2032451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2032457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2032464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2032476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2032480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2032484 */     // MIs[1] Operand 1
     /* 2032484 */     // No operand predicates
     /* 2032484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032488 */     // MIs[0] round
     /* 2032488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032491 */     // MIs[0] policy
     /* 2032491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2032496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032503 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2032506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2032515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2032527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2032532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032533 */     // GIR_Coverage, 16649,
     /* 2032533 */     GIR_EraseRootFromParent_Done,
     /* 2032534 */   // Label 27097: @2032534
     /* 2032534 */   GIM_Try, /*On fail goto*//*Label 27098*/ GIMT_Encode4(2032639), // Rule ID 16652 //
     /* 2032539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2032547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2032550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2032553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2032556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2032559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2032562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2032577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2032581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2032585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2032589 */     // MIs[1] Operand 1
     /* 2032589 */     // No operand predicates
     /* 2032589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032593 */     // MIs[0] round
     /* 2032593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032596 */     // MIs[0] policy
     /* 2032596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2032601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032608 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2032611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2032620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2032632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2032637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032638 */     // GIR_Coverage, 16652,
     /* 2032638 */     GIR_EraseRootFromParent_Done,
     /* 2032639 */   // Label 27098: @2032639
     /* 2032639 */   GIM_Try, /*On fail goto*//*Label 27099*/ GIMT_Encode4(2032744), // Rule ID 16653 //
     /* 2032644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2032652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2032655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2032658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2032661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2032667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2032682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2032686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2032690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2032694 */     // MIs[1] Operand 1
     /* 2032694 */     // No operand predicates
     /* 2032694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032698 */     // MIs[0] round
     /* 2032698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032701 */     // MIs[0] policy
     /* 2032701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2032706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032713 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2032716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2032725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2032737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2032742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032743 */     // GIR_Coverage, 16653,
     /* 2032743 */     GIR_EraseRootFromParent_Done,
     /* 2032744 */   // Label 27099: @2032744
     /* 2032744 */   GIM_Try, /*On fail goto*//*Label 27100*/ GIMT_Encode4(2032849), // Rule ID 16656 //
     /* 2032749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2032757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2032760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2032763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2032766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2032769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2032791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2032795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2032799 */     // MIs[1] Operand 1
     /* 2032799 */     // No operand predicates
     /* 2032799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032803 */     // MIs[0] round
     /* 2032803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032806 */     // MIs[0] policy
     /* 2032806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2032811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032818 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2032821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2032830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2032847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032848 */     // GIR_Coverage, 16656,
     /* 2032848 */     GIR_EraseRootFromParent_Done,
     /* 2032849 */   // Label 27100: @2032849
     /* 2032849 */   GIM_Try, /*On fail goto*//*Label 27101*/ GIMT_Encode4(2032954), // Rule ID 16657 //
     /* 2032854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2032862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2032865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2032868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2032871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2032896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2032900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2032904 */     // MIs[1] Operand 1
     /* 2032904 */     // No operand predicates
     /* 2032904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032908 */     // MIs[0] round
     /* 2032908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032911 */     // MIs[0] policy
     /* 2032911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2032916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032923 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2032926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2032935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2032952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032953 */     // GIR_Coverage, 16657,
     /* 2032953 */     GIR_EraseRootFromParent_Done,
     /* 2032954 */   // Label 27101: @2032954
     /* 2032954 */   GIM_Try, /*On fail goto*//*Label 27102*/ GIMT_Encode4(2033059), // Rule ID 16660 //
     /* 2032959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2032967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2032970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2032973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2032976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2032979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2033001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2033005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2033009 */     // MIs[1] Operand 1
     /* 2033009 */     // No operand predicates
     /* 2033009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033013 */     // MIs[0] round
     /* 2033013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033016 */     // MIs[0] policy
     /* 2033016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2033021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033028 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2033031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2033040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2033057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033058 */     // GIR_Coverage, 16660,
     /* 2033058 */     GIR_EraseRootFromParent_Done,
     /* 2033059 */   // Label 27102: @2033059
     /* 2033059 */   GIM_Try, /*On fail goto*//*Label 27103*/ GIMT_Encode4(2033164), // Rule ID 16661 //
     /* 2033064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2033067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2033072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2033075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2033078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2033081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2033106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2033110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2033114 */     // MIs[1] Operand 1
     /* 2033114 */     // No operand predicates
     /* 2033114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033118 */     // MIs[0] round
     /* 2033118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033121 */     // MIs[0] policy
     /* 2033121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2033126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033133 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2033136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2033145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2033162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033163 */     // GIR_Coverage, 16661,
     /* 2033163 */     GIR_EraseRootFromParent_Done,
     /* 2033164 */   // Label 27103: @2033164
     /* 2033164 */   GIM_Try, /*On fail goto*//*Label 27104*/ GIMT_Encode4(2033269), // Rule ID 16664 //
     /* 2033169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2033177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2033180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2033183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2033186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2033189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2033192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2033211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2033215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2033219 */     // MIs[1] Operand 1
     /* 2033219 */     // No operand predicates
     /* 2033219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033223 */     // MIs[0] round
     /* 2033223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033226 */     // MIs[0] policy
     /* 2033226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2033231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033238 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2033241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2033250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2033267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033268 */     // GIR_Coverage, 16664,
     /* 2033268 */     GIR_EraseRootFromParent_Done,
     /* 2033269 */   // Label 27104: @2033269
     /* 2033269 */   GIM_Try, /*On fail goto*//*Label 27105*/ GIMT_Encode4(2033374), // Rule ID 16665 //
     /* 2033274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2033277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2033282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2033285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2033288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2033291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2033297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2033316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2033320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2033324 */     // MIs[1] Operand 1
     /* 2033324 */     // No operand predicates
     /* 2033324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033328 */     // MIs[0] round
     /* 2033328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033331 */     // MIs[0] policy
     /* 2033331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2033336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033343 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2033346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2033355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2033372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033373 */     // GIR_Coverage, 16665,
     /* 2033373 */     GIR_EraseRootFromParent_Done,
     /* 2033374 */   // Label 27105: @2033374
     /* 2033374 */   GIM_Try, /*On fail goto*//*Label 27106*/ GIMT_Encode4(2033479), // Rule ID 16668 //
     /* 2033379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2033387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2033390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2033393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2033396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2033399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2033421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2033425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2033429 */     // MIs[1] Operand 1
     /* 2033429 */     // No operand predicates
     /* 2033429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033433 */     // MIs[0] round
     /* 2033433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033436 */     // MIs[0] policy
     /* 2033436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2033441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2033451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2033460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2033477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033478 */     // GIR_Coverage, 16668,
     /* 2033478 */     GIR_EraseRootFromParent_Done,
     /* 2033479 */   // Label 27106: @2033479
     /* 2033479 */   GIM_Try, /*On fail goto*//*Label 27107*/ GIMT_Encode4(2033584), // Rule ID 16669 //
     /* 2033484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2033487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2033492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2033495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2033498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2033501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2033526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2033530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2033534 */     // MIs[1] Operand 1
     /* 2033534 */     // No operand predicates
     /* 2033534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033538 */     // MIs[0] round
     /* 2033538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033541 */     // MIs[0] policy
     /* 2033541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2033546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033553 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2033556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2033565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2033582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033583 */     // GIR_Coverage, 16669,
     /* 2033583 */     GIR_EraseRootFromParent_Done,
     /* 2033584 */   // Label 27107: @2033584
     /* 2033584 */   GIM_Try, /*On fail goto*//*Label 27108*/ GIMT_Encode4(2033689), // Rule ID 16672 //
     /* 2033589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2033597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2033600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2033603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2033606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2033609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2033631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2033635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2033639 */     // MIs[1] Operand 1
     /* 2033639 */     // No operand predicates
     /* 2033639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033643 */     // MIs[0] round
     /* 2033643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033646 */     // MIs[0] policy
     /* 2033646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2033651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033658 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2033661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2033670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2033687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033688 */     // GIR_Coverage, 16672,
     /* 2033688 */     GIR_EraseRootFromParent_Done,
     /* 2033689 */   // Label 27108: @2033689
     /* 2033689 */   GIM_Try, /*On fail goto*//*Label 27109*/ GIMT_Encode4(2033794), // Rule ID 16673 //
     /* 2033694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2033697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2033702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2033705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2033708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2033711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2033736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2033740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2033744 */     // MIs[1] Operand 1
     /* 2033744 */     // No operand predicates
     /* 2033744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033748 */     // MIs[0] round
     /* 2033748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033751 */     // MIs[0] policy
     /* 2033751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2033756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033763 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2033766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2033775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2033792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033793 */     // GIR_Coverage, 16673,
     /* 2033793 */     GIR_EraseRootFromParent_Done,
     /* 2033794 */   // Label 27109: @2033794
     /* 2033794 */   GIM_Try, /*On fail goto*//*Label 27110*/ GIMT_Encode4(2033899), // Rule ID 16676 //
     /* 2033799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2033802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2033807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2033810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2033813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2033816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2033819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2033841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2033845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2033849 */     // MIs[1] Operand 1
     /* 2033849 */     // No operand predicates
     /* 2033849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033853 */     // MIs[0] round
     /* 2033853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033856 */     // MIs[0] policy
     /* 2033856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2033861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2033871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2033880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2033897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033898 */     // GIR_Coverage, 16676,
     /* 2033898 */     GIR_EraseRootFromParent_Done,
     /* 2033899 */   // Label 27110: @2033899
     /* 2033899 */   GIM_Try, /*On fail goto*//*Label 27111*/ GIMT_Encode4(2034004), // Rule ID 16677 //
     /* 2033904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2033907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2033912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2033915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2033918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2033921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2033946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2033950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2033954 */     // MIs[1] Operand 1
     /* 2033954 */     // No operand predicates
     /* 2033954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033958 */     // MIs[0] round
     /* 2033958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033961 */     // MIs[0] policy
     /* 2033961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2033966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033973 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2033976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2033985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2034002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034003 */     // GIR_Coverage, 16677,
     /* 2034003 */     GIR_EraseRootFromParent_Done,
     /* 2034004 */   // Label 27111: @2034004
     /* 2034004 */   GIM_Try, /*On fail goto*//*Label 27112*/ GIMT_Encode4(2034109), // Rule ID 16680 //
     /* 2034009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2034012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2034017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2034020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2034023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2034026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2034029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2034051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2034055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2034059 */     // MIs[1] Operand 1
     /* 2034059 */     // No operand predicates
     /* 2034059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034063 */     // MIs[0] round
     /* 2034063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034066 */     // MIs[0] policy
     /* 2034066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2034071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034078 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2034081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2034090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2034107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034108 */     // GIR_Coverage, 16680,
     /* 2034108 */     GIR_EraseRootFromParent_Done,
     /* 2034109 */   // Label 27112: @2034109
     /* 2034109 */   GIM_Try, /*On fail goto*//*Label 27113*/ GIMT_Encode4(2034214), // Rule ID 16681 //
     /* 2034114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2034117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2034122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2034125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2034128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2034131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2034134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2034156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2034160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2034164 */     // MIs[1] Operand 1
     /* 2034164 */     // No operand predicates
     /* 2034164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034168 */     // MIs[0] round
     /* 2034168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034171 */     // MIs[0] policy
     /* 2034171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2034176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034183 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2034186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2034195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034209 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2034212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034213 */     // GIR_Coverage, 16681,
     /* 2034213 */     GIR_EraseRootFromParent_Done,
     /* 2034214 */   // Label 27113: @2034214
     /* 2034214 */   GIM_Try, /*On fail goto*//*Label 27114*/ GIMT_Encode4(2034319), // Rule ID 16684 //
     /* 2034219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2034222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2034227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2034230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2034233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2034236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2034239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2034249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2034261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2034265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2034269 */     // MIs[1] Operand 1
     /* 2034269 */     // No operand predicates
     /* 2034269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034273 */     // MIs[0] round
     /* 2034273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034276 */     // MIs[0] policy
     /* 2034276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2034281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034288 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2034291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2034300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2034317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034318 */     // GIR_Coverage, 16684,
     /* 2034318 */     GIR_EraseRootFromParent_Done,
     /* 2034319 */   // Label 27114: @2034319
     /* 2034319 */   GIM_Try, /*On fail goto*//*Label 27115*/ GIMT_Encode4(2034424), // Rule ID 16685 //
     /* 2034324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2034327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2034332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2034335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2034338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2034341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2034344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2034354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2034366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2034370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2034374 */     // MIs[1] Operand 1
     /* 2034374 */     // No operand predicates
     /* 2034374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034378 */     // MIs[0] round
     /* 2034378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034381 */     // MIs[0] policy
     /* 2034381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2034386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2034396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2034405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2034422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034423 */     // GIR_Coverage, 16685,
     /* 2034423 */     GIR_EraseRootFromParent_Done,
     /* 2034424 */   // Label 27115: @2034424
     /* 2034424 */   GIM_Try, /*On fail goto*//*Label 27116*/ GIMT_Encode4(2034529), // Rule ID 16688 //
     /* 2034429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2034432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2034437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2034440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2034443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2034446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2034449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2034452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2034471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2034475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2034479 */     // MIs[1] Operand 1
     /* 2034479 */     // No operand predicates
     /* 2034479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034483 */     // MIs[0] round
     /* 2034483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034486 */     // MIs[0] policy
     /* 2034486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2034491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034498 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2034501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2034510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2034527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034528 */     // GIR_Coverage, 16688,
     /* 2034528 */     GIR_EraseRootFromParent_Done,
     /* 2034529 */   // Label 27116: @2034529
     /* 2034529 */   GIM_Try, /*On fail goto*//*Label 27117*/ GIMT_Encode4(2034634), // Rule ID 16689 //
     /* 2034534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2034537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2034542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2034545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2034548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2034551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2034554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2034557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2034576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2034580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2034584 */     // MIs[1] Operand 1
     /* 2034584 */     // No operand predicates
     /* 2034584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034588 */     // MIs[0] round
     /* 2034588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034591 */     // MIs[0] policy
     /* 2034591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2034596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034603 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2034606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2034615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2034632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034633 */     // GIR_Coverage, 16689,
     /* 2034633 */     GIR_EraseRootFromParent_Done,
     /* 2034634 */   // Label 27117: @2034634
     /* 2034634 */   GIM_Try, /*On fail goto*//*Label 27118*/ GIMT_Encode4(2034721), // Rule ID 2760 //
     /* 2034639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2034642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2034647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2034650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2034653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034670 */     // MIs[0] passthru
     /* 2034670 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2034675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034683 */     // MIs[0] round
     /* 2034683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034686 */     // MIs[0] policy
     /* 2034686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034696 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2034699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034720 */     // GIR_Coverage, 2760,
     /* 2034720 */     GIR_EraseRootFromParent_Done,
     /* 2034721 */   // Label 27118: @2034721
     /* 2034721 */   GIM_Try, /*On fail goto*//*Label 27119*/ GIMT_Encode4(2034808), // Rule ID 2761 //
     /* 2034726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2034729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2034734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2034737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2034740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034757 */     // MIs[0] passthru
     /* 2034757 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2034762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034770 */     // MIs[0] round
     /* 2034770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034773 */     // MIs[0] policy
     /* 2034773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034783 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2034786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034807 */     // GIR_Coverage, 2761,
     /* 2034807 */     GIR_EraseRootFromParent_Done,
     /* 2034808 */   // Label 27119: @2034808
     /* 2034808 */   GIM_Try, /*On fail goto*//*Label 27120*/ GIMT_Encode4(2034895), // Rule ID 17140 //
     /* 2034813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2034816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2034821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2034824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2034827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2034830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034844 */     // MIs[0] passthru
     /* 2034844 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2034849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034857 */     // MIs[0] round
     /* 2034857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034860 */     // MIs[0] policy
     /* 2034860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034870 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2034873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034894 */     // GIR_Coverage, 17140,
     /* 2034894 */     GIR_EraseRootFromParent_Done,
     /* 2034895 */   // Label 27120: @2034895
     /* 2034895 */   GIM_Try, /*On fail goto*//*Label 27121*/ GIMT_Encode4(2034982), // Rule ID 17141 //
     /* 2034900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2034903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2034908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2034911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2034914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2034917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034931 */     // MIs[0] passthru
     /* 2034931 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2034936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034944 */     // MIs[0] round
     /* 2034944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034947 */     // MIs[0] policy
     /* 2034947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034957 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2034960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034981 */     // GIR_Coverage, 17141,
     /* 2034981 */     GIR_EraseRootFromParent_Done,
     /* 2034982 */   // Label 27121: @2034982
     /* 2034982 */   GIM_Try, /*On fail goto*//*Label 27122*/ GIMT_Encode4(2035069), // Rule ID 17150 //
     /* 2034987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2034990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2034995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2034998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2035001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2035004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2035014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035018 */     // MIs[0] passthru
     /* 2035018 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2035023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035031 */     // MIs[0] round
     /* 2035031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035034 */     // MIs[0] policy
     /* 2035034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035044 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2035047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035068 */     // GIR_Coverage, 17150,
     /* 2035068 */     GIR_EraseRootFromParent_Done,
     /* 2035069 */   // Label 27122: @2035069
     /* 2035069 */   GIM_Try, /*On fail goto*//*Label 27123*/ GIMT_Encode4(2035156), // Rule ID 17151 //
     /* 2035074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2035077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2035082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2035085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2035088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2035091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2035101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035105 */     // MIs[0] passthru
     /* 2035105 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2035110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035118 */     // MIs[0] round
     /* 2035118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035121 */     // MIs[0] policy
     /* 2035121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035131 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2035134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035155 */     // GIR_Coverage, 17151,
     /* 2035155 */     GIR_EraseRootFromParent_Done,
     /* 2035156 */   // Label 27123: @2035156
     /* 2035156 */   GIM_Try, /*On fail goto*//*Label 27124*/ GIMT_Encode4(2035243), // Rule ID 17160 //
     /* 2035161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2035164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2035169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2035172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2035175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2035178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2035188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035192 */     // MIs[0] passthru
     /* 2035192 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2035197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035205 */     // MIs[0] round
     /* 2035205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035208 */     // MIs[0] policy
     /* 2035208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035218 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2035221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035242 */     // GIR_Coverage, 17160,
     /* 2035242 */     GIR_EraseRootFromParent_Done,
     /* 2035243 */   // Label 27124: @2035243
     /* 2035243 */   GIM_Try, /*On fail goto*//*Label 27125*/ GIMT_Encode4(2035330), // Rule ID 17161 //
     /* 2035248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2035251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2035256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2035259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2035262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2035265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2035275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035279 */     // MIs[0] passthru
     /* 2035279 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2035284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035292 */     // MIs[0] round
     /* 2035292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035295 */     // MIs[0] policy
     /* 2035295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035305 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2035308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035329 */     // GIR_Coverage, 17161,
     /* 2035329 */     GIR_EraseRootFromParent_Done,
     /* 2035330 */   // Label 27125: @2035330
     /* 2035330 */   GIM_Try, /*On fail goto*//*Label 27126*/ GIMT_Encode4(2035417), // Rule ID 17170 //
     /* 2035335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2035338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2035343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2035346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2035349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2035352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2035355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2035362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2035366 */     // MIs[0] passthru
     /* 2035366 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2035371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035379 */     // MIs[0] round
     /* 2035379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035382 */     // MIs[0] policy
     /* 2035382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035392 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2035395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035416 */     // GIR_Coverage, 17170,
     /* 2035416 */     GIR_EraseRootFromParent_Done,
     /* 2035417 */   // Label 27126: @2035417
     /* 2035417 */   GIM_Try, /*On fail goto*//*Label 27127*/ GIMT_Encode4(2035504), // Rule ID 17171 //
     /* 2035422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2035425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2035430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2035433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2035436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2035439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2035442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2035449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2035453 */     // MIs[0] passthru
     /* 2035453 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2035458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035466 */     // MIs[0] round
     /* 2035466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035469 */     // MIs[0] policy
     /* 2035469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035479 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2035482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035503 */     // GIR_Coverage, 17171,
     /* 2035503 */     GIR_EraseRootFromParent_Done,
     /* 2035504 */   // Label 27127: @2035504
     /* 2035504 */   GIM_Try, /*On fail goto*//*Label 27128*/ GIMT_Encode4(2035591), // Rule ID 17180 //
     /* 2035509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2035512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2035517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2035520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2035523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2035526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035540 */     // MIs[0] passthru
     /* 2035540 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2035545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035553 */     // MIs[0] round
     /* 2035553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035556 */     // MIs[0] policy
     /* 2035556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035566 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2035569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035590 */     // GIR_Coverage, 17180,
     /* 2035590 */     GIR_EraseRootFromParent_Done,
     /* 2035591 */   // Label 27128: @2035591
     /* 2035591 */   GIM_Try, /*On fail goto*//*Label 27129*/ GIMT_Encode4(2035678), // Rule ID 17181 //
     /* 2035596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2035599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2035604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2035607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2035610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2035613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035627 */     // MIs[0] passthru
     /* 2035627 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2035632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035640 */     // MIs[0] round
     /* 2035640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035643 */     // MIs[0] policy
     /* 2035643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035653 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2035656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035677 */     // GIR_Coverage, 17181,
     /* 2035677 */     GIR_EraseRootFromParent_Done,
     /* 2035678 */   // Label 27129: @2035678
     /* 2035678 */   GIM_Try, /*On fail goto*//*Label 27130*/ GIMT_Encode4(2035765), // Rule ID 17190 //
     /* 2035683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2035686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2035691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2035694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2035697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2035700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2035710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035714 */     // MIs[0] passthru
     /* 2035714 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2035719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035727 */     // MIs[0] round
     /* 2035727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035730 */     // MIs[0] policy
     /* 2035730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035740 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2035743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035764 */     // GIR_Coverage, 17190,
     /* 2035764 */     GIR_EraseRootFromParent_Done,
     /* 2035765 */   // Label 27130: @2035765
     /* 2035765 */   GIM_Try, /*On fail goto*//*Label 27131*/ GIMT_Encode4(2035852), // Rule ID 17191 //
     /* 2035770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2035773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2035778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2035781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2035784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2035787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2035797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035801 */     // MIs[0] passthru
     /* 2035801 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2035806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035814 */     // MIs[0] round
     /* 2035814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035817 */     // MIs[0] policy
     /* 2035817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035827 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2035830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035851 */     // GIR_Coverage, 17191,
     /* 2035851 */     GIR_EraseRootFromParent_Done,
     /* 2035852 */   // Label 27131: @2035852
     /* 2035852 */   GIM_Try, /*On fail goto*//*Label 27132*/ GIMT_Encode4(2035939), // Rule ID 17200 //
     /* 2035857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2035860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2035865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2035868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2035871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2035874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2035884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035888 */     // MIs[0] passthru
     /* 2035888 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2035893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035901 */     // MIs[0] round
     /* 2035901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035904 */     // MIs[0] policy
     /* 2035904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035914 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2035917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035938 */     // GIR_Coverage, 17200,
     /* 2035938 */     GIR_EraseRootFromParent_Done,
     /* 2035939 */   // Label 27132: @2035939
     /* 2035939 */   GIM_Try, /*On fail goto*//*Label 27133*/ GIMT_Encode4(2036026), // Rule ID 17201 //
     /* 2035944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2035947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2035952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2035955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2035958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2035961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2035971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035975 */     // MIs[0] passthru
     /* 2035975 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2035980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035988 */     // MIs[0] round
     /* 2035988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035991 */     // MIs[0] policy
     /* 2035991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036001 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2036004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036025 */     // GIR_Coverage, 17201,
     /* 2036025 */     GIR_EraseRootFromParent_Done,
     /* 2036026 */   // Label 27133: @2036026
     /* 2036026 */   GIM_Try, /*On fail goto*//*Label 27134*/ GIMT_Encode4(2036113), // Rule ID 17210 //
     /* 2036031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2036034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2036039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2036042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2036045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2036048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036051 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2036058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036062 */     // MIs[0] passthru
     /* 2036062 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2036067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036075 */     // MIs[0] round
     /* 2036075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036078 */     // MIs[0] policy
     /* 2036078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036088 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2036091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036112 */     // GIR_Coverage, 17210,
     /* 2036112 */     GIR_EraseRootFromParent_Done,
     /* 2036113 */   // Label 27134: @2036113
     /* 2036113 */   GIM_Try, /*On fail goto*//*Label 27135*/ GIMT_Encode4(2036200), // Rule ID 17211 //
     /* 2036118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2036121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2036126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2036129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2036132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2036135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2036145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036149 */     // MIs[0] passthru
     /* 2036149 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2036154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036162 */     // MIs[0] round
     /* 2036162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036165 */     // MIs[0] policy
     /* 2036165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036175 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2036178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036186 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036196 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036199 */     // GIR_Coverage, 17211,
     /* 2036199 */     GIR_EraseRootFromParent_Done,
     /* 2036200 */   // Label 27135: @2036200
     /* 2036200 */   GIM_Try, /*On fail goto*//*Label 27136*/ GIMT_Encode4(2036287), // Rule ID 17256 //
     /* 2036205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2036208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2036213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2036216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2036219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2036222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036236 */     // MIs[0] passthru
     /* 2036236 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2036241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036249 */     // MIs[0] round
     /* 2036249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036252 */     // MIs[0] policy
     /* 2036252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036262 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2036265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036286 */     // GIR_Coverage, 17256,
     /* 2036286 */     GIR_EraseRootFromParent_Done,
     /* 2036287 */   // Label 27136: @2036287
     /* 2036287 */   GIM_Try, /*On fail goto*//*Label 27137*/ GIMT_Encode4(2036374), // Rule ID 17257 //
     /* 2036292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2036295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2036300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2036303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2036306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2036309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036323 */     // MIs[0] passthru
     /* 2036323 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2036328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036336 */     // MIs[0] round
     /* 2036336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036339 */     // MIs[0] policy
     /* 2036339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036349 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2036352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036373 */     // GIR_Coverage, 17257,
     /* 2036373 */     GIR_EraseRootFromParent_Done,
     /* 2036374 */   // Label 27137: @2036374
     /* 2036374 */   GIM_Try, /*On fail goto*//*Label 27138*/ GIMT_Encode4(2036461), // Rule ID 17266 //
     /* 2036379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2036382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2036387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2036390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2036393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2036396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036410 */     // MIs[0] passthru
     /* 2036410 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2036415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036423 */     // MIs[0] round
     /* 2036423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036426 */     // MIs[0] policy
     /* 2036426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036436 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2036439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036460 */     // GIR_Coverage, 17266,
     /* 2036460 */     GIR_EraseRootFromParent_Done,
     /* 2036461 */   // Label 27138: @2036461
     /* 2036461 */   GIM_Try, /*On fail goto*//*Label 27139*/ GIMT_Encode4(2036548), // Rule ID 17267 //
     /* 2036466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2036469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2036474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2036477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2036480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2036483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036497 */     // MIs[0] passthru
     /* 2036497 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2036502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036510 */     // MIs[0] round
     /* 2036510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036513 */     // MIs[0] policy
     /* 2036513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036523 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2036526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036547 */     // GIR_Coverage, 17267,
     /* 2036547 */     GIR_EraseRootFromParent_Done,
     /* 2036548 */   // Label 27139: @2036548
     /* 2036548 */   GIM_Try, /*On fail goto*//*Label 27140*/ GIMT_Encode4(2036635), // Rule ID 17276 //
     /* 2036553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2036556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2036561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2036564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2036567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2036570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2036573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036584 */     // MIs[0] passthru
     /* 2036584 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2036589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036597 */     // MIs[0] round
     /* 2036597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036600 */     // MIs[0] policy
     /* 2036600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036610 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2036613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036634 */     // GIR_Coverage, 17276,
     /* 2036634 */     GIR_EraseRootFromParent_Done,
     /* 2036635 */   // Label 27140: @2036635
     /* 2036635 */   GIM_Try, /*On fail goto*//*Label 27141*/ GIMT_Encode4(2036722), // Rule ID 17277 //
     /* 2036640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2036643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2036648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2036651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2036654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2036657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2036660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036671 */     // MIs[0] passthru
     /* 2036671 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2036676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036684 */     // MIs[0] round
     /* 2036684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036687 */     // MIs[0] policy
     /* 2036687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036697 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2036700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036721 */     // GIR_Coverage, 17277,
     /* 2036721 */     GIR_EraseRootFromParent_Done,
     /* 2036722 */   // Label 27141: @2036722
     /* 2036722 */   GIM_Try, /*On fail goto*//*Label 27142*/ GIMT_Encode4(2036809), // Rule ID 17286 //
     /* 2036727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2036730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2036735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2036738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2036741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2036744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036758 */     // MIs[0] passthru
     /* 2036758 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2036763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036771 */     // MIs[0] round
     /* 2036771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036774 */     // MIs[0] policy
     /* 2036774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036784 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2036787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036808 */     // GIR_Coverage, 17286,
     /* 2036808 */     GIR_EraseRootFromParent_Done,
     /* 2036809 */   // Label 27142: @2036809
     /* 2036809 */   GIM_Try, /*On fail goto*//*Label 27143*/ GIMT_Encode4(2036896), // Rule ID 17287 //
     /* 2036814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2036817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2036822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2036825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2036828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2036831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036845 */     // MIs[0] passthru
     /* 2036845 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2036850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036858 */     // MIs[0] round
     /* 2036858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036861 */     // MIs[0] policy
     /* 2036861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036871 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2036874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036895 */     // GIR_Coverage, 17287,
     /* 2036895 */     GIR_EraseRootFromParent_Done,
     /* 2036896 */   // Label 27143: @2036896
     /* 2036896 */   GIM_Try, /*On fail goto*//*Label 27144*/ GIMT_Encode4(2036983), // Rule ID 17296 //
     /* 2036901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2036904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2036909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2036912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2036915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2036918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2036928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036932 */     // MIs[0] passthru
     /* 2036932 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2036937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036945 */     // MIs[0] round
     /* 2036945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036948 */     // MIs[0] policy
     /* 2036948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036958 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2036961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036982 */     // GIR_Coverage, 17296,
     /* 2036982 */     GIR_EraseRootFromParent_Done,
     /* 2036983 */   // Label 27144: @2036983
     /* 2036983 */   GIM_Try, /*On fail goto*//*Label 27145*/ GIMT_Encode4(2037070), // Rule ID 17297 //
     /* 2036988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2036991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2036996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2036999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2037002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2037005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037019 */     // MIs[0] passthru
     /* 2037019 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2037024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037032 */     // MIs[0] round
     /* 2037032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037035 */     // MIs[0] policy
     /* 2037035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037045 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2037048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037069 */     // GIR_Coverage, 17297,
     /* 2037069 */     GIR_EraseRootFromParent_Done,
     /* 2037070 */   // Label 27145: @2037070
     /* 2037070 */   GIM_Try, /*On fail goto*//*Label 27146*/ GIMT_Encode4(2037157), // Rule ID 17306 //
     /* 2037075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2037078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2037083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2037086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2037089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2037092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2037095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2037102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037106 */     // MIs[0] passthru
     /* 2037106 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2037111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037119 */     // MIs[0] round
     /* 2037119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037122 */     // MIs[0] policy
     /* 2037122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037132 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2037135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037156 */     // GIR_Coverage, 17306,
     /* 2037156 */     GIR_EraseRootFromParent_Done,
     /* 2037157 */   // Label 27146: @2037157
     /* 2037157 */   GIM_Try, /*On fail goto*//*Label 27147*/ GIMT_Encode4(2037244), // Rule ID 17307 //
     /* 2037162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2037165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2037170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2037173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2037176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2037179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2037182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2037189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037193 */     // MIs[0] passthru
     /* 2037193 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2037198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037206 */     // MIs[0] round
     /* 2037206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037209 */     // MIs[0] policy
     /* 2037209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037219 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2037222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037243 */     // GIR_Coverage, 17307,
     /* 2037243 */     GIR_EraseRootFromParent_Done,
     /* 2037244 */   // Label 27147: @2037244
     /* 2037244 */   GIM_Try, /*On fail goto*//*Label 27148*/ GIMT_Encode4(2037331), // Rule ID 17316 //
     /* 2037249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2037252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2037257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2037260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2037263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2037266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2037269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037280 */     // MIs[0] passthru
     /* 2037280 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2037285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037293 */     // MIs[0] round
     /* 2037293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037296 */     // MIs[0] policy
     /* 2037296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037306 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2037309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037330 */     // GIR_Coverage, 17316,
     /* 2037330 */     GIR_EraseRootFromParent_Done,
     /* 2037331 */   // Label 27148: @2037331
     /* 2037331 */   GIM_Try, /*On fail goto*//*Label 27149*/ GIMT_Encode4(2037418), // Rule ID 17317 //
     /* 2037336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2037339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2037344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2037347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2037350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2037353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2037356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037367 */     // MIs[0] passthru
     /* 2037367 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2037372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037380 */     // MIs[0] round
     /* 2037380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037383 */     // MIs[0] policy
     /* 2037383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037393 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2037396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037417 */     // GIR_Coverage, 17317,
     /* 2037417 */     GIR_EraseRootFromParent_Done,
     /* 2037418 */   // Label 27149: @2037418
     /* 2037418 */   GIM_Try, /*On fail goto*//*Label 27150*/ GIMT_Encode4(2037505), // Rule ID 17326 //
     /* 2037423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2037426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2037431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2037434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2037437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2037440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037454 */     // MIs[0] passthru
     /* 2037454 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2037459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037467 */     // MIs[0] round
     /* 2037467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037470 */     // MIs[0] policy
     /* 2037470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037480 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2037483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037504 */     // GIR_Coverage, 17326,
     /* 2037504 */     GIR_EraseRootFromParent_Done,
     /* 2037505 */   // Label 27150: @2037505
     /* 2037505 */   GIM_Try, /*On fail goto*//*Label 27151*/ GIMT_Encode4(2037592), // Rule ID 17327 //
     /* 2037510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2037513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2037518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2037521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2037524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2037527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037541 */     // MIs[0] passthru
     /* 2037541 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2037546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037554 */     // MIs[0] round
     /* 2037554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037557 */     // MIs[0] policy
     /* 2037557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037567 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2037570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037591 */     // GIR_Coverage, 17327,
     /* 2037591 */     GIR_EraseRootFromParent_Done,
     /* 2037592 */   // Label 27151: @2037592
     /* 2037592 */   GIM_Try, /*On fail goto*//*Label 27152*/ GIMT_Encode4(2037679), // Rule ID 17336 //
     /* 2037597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2037600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2037605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2037608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2037611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2037614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037628 */     // MIs[0] passthru
     /* 2037628 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2037633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037641 */     // MIs[0] round
     /* 2037641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037644 */     // MIs[0] policy
     /* 2037644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037654 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2037657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037678 */     // GIR_Coverage, 17336,
     /* 2037678 */     GIR_EraseRootFromParent_Done,
     /* 2037679 */   // Label 27152: @2037679
     /* 2037679 */   GIM_Try, /*On fail goto*//*Label 27153*/ GIMT_Encode4(2037766), // Rule ID 17337 //
     /* 2037684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2037687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2037692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2037695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2037698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2037701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037715 */     // MIs[0] passthru
     /* 2037715 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2037720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037728 */     // MIs[0] round
     /* 2037728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037731 */     // MIs[0] policy
     /* 2037731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037741 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2037744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037765 */     // GIR_Coverage, 17337,
     /* 2037765 */     GIR_EraseRootFromParent_Done,
     /* 2037766 */   // Label 27153: @2037766
     /* 2037766 */   GIM_Try, /*On fail goto*//*Label 27154*/ GIMT_Encode4(2037857), // Rule ID 2718 //
     /* 2037771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2037782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2037785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2037788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2037791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2037794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2037801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037817 */     // MIs[0] round
     /* 2037817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037820 */     // MIs[0] policy
     /* 2037820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037830 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2037833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037856 */     // GIR_Coverage, 2718,
     /* 2037856 */     GIR_EraseRootFromParent_Done,
     /* 2037857 */   // Label 27154: @2037857
     /* 2037857 */   GIM_Try, /*On fail goto*//*Label 27155*/ GIMT_Encode4(2037948), // Rule ID 2719 //
     /* 2037862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2037873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2037876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2037879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2037882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2037885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2037892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037908 */     // MIs[0] round
     /* 2037908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037911 */     // MIs[0] policy
     /* 2037911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037921 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2037924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037947 */     // GIR_Coverage, 2719,
     /* 2037947 */     GIR_EraseRootFromParent_Done,
     /* 2037948 */   // Label 27155: @2037948
     /* 2037948 */   GIM_Try, /*On fail goto*//*Label 27156*/ GIMT_Encode4(2038039), // Rule ID 2762 //
     /* 2037953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2037956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2037961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2037964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2037967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2037970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2037973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2037976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2037983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037999 */     // MIs[0] round
     /* 2037999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038002 */     // MIs[0] policy
     /* 2038002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038012 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2038015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038038 */     // GIR_Coverage, 2762,
     /* 2038038 */     GIR_EraseRootFromParent_Done,
     /* 2038039 */   // Label 27156: @2038039
     /* 2038039 */   GIM_Try, /*On fail goto*//*Label 27157*/ GIMT_Encode4(2038130), // Rule ID 2763 //
     /* 2038044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2038047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2038052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2038055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2038058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2038061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2038064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038090 */     // MIs[0] round
     /* 2038090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038093 */     // MIs[0] policy
     /* 2038093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038103 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2038106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038129 */     // GIR_Coverage, 2763,
     /* 2038129 */     GIR_EraseRootFromParent_Done,
     /* 2038130 */   // Label 27157: @2038130
     /* 2038130 */   GIM_Try, /*On fail goto*//*Label 27158*/ GIMT_Encode4(2038221), // Rule ID 2770 //
     /* 2038135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2038138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2038143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2038146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2038149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2038152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2038155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038181 */     // MIs[0] round
     /* 2038181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038184 */     // MIs[0] policy
     /* 2038184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038194 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2038197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2038201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038220 */     // GIR_Coverage, 2770,
     /* 2038220 */     GIR_EraseRootFromParent_Done,
     /* 2038221 */   // Label 27158: @2038221
     /* 2038221 */   GIM_Try, /*On fail goto*//*Label 27159*/ GIMT_Encode4(2038312), // Rule ID 2771 //
     /* 2038226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2038229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2038234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2038237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2038240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2038243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2038246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038272 */     // MIs[0] round
     /* 2038272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038275 */     // MIs[0] policy
     /* 2038275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038285 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2038288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2038292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038311 */     // GIR_Coverage, 2771,
     /* 2038311 */     GIR_EraseRootFromParent_Done,
     /* 2038312 */   // Label 27159: @2038312
     /* 2038312 */   GIM_Try, /*On fail goto*//*Label 27160*/ GIMT_Encode4(2038403), // Rule ID 14928 //
     /* 2038317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2038328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2038331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2038334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2038337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038363 */     // MIs[0] round
     /* 2038363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038366 */     // MIs[0] policy
     /* 2038366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2038379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038402 */     // GIR_Coverage, 14928,
     /* 2038402 */     GIR_EraseRootFromParent_Done,
     /* 2038403 */   // Label 27160: @2038403
     /* 2038403 */   GIM_Try, /*On fail goto*//*Label 27161*/ GIMT_Encode4(2038494), // Rule ID 14929 //
     /* 2038408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2038419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2038422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2038425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2038428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038454 */     // MIs[0] round
     /* 2038454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038457 */     // MIs[0] policy
     /* 2038457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038467 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2038470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038493 */     // GIR_Coverage, 14929,
     /* 2038493 */     GIR_EraseRootFromParent_Done,
     /* 2038494 */   // Label 27161: @2038494
     /* 2038494 */   GIM_Try, /*On fail goto*//*Label 27162*/ GIMT_Encode4(2038585), // Rule ID 14932 //
     /* 2038499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2038510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2038513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2038516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2038519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038545 */     // MIs[0] round
     /* 2038545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038548 */     // MIs[0] policy
     /* 2038548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038558 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2038561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038584 */     // GIR_Coverage, 14932,
     /* 2038584 */     GIR_EraseRootFromParent_Done,
     /* 2038585 */   // Label 27162: @2038585
     /* 2038585 */   GIM_Try, /*On fail goto*//*Label 27163*/ GIMT_Encode4(2038676), // Rule ID 14933 //
     /* 2038590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2038601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2038604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2038607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2038610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038636 */     // MIs[0] round
     /* 2038636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038639 */     // MIs[0] policy
     /* 2038639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038649 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2038652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038675 */     // GIR_Coverage, 14933,
     /* 2038675 */     GIR_EraseRootFromParent_Done,
     /* 2038676 */   // Label 27163: @2038676
     /* 2038676 */   GIM_Try, /*On fail goto*//*Label 27164*/ GIMT_Encode4(2038767), // Rule ID 14936 //
     /* 2038681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2038692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2038695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2038698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2038701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038727 */     // MIs[0] round
     /* 2038727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038730 */     // MIs[0] policy
     /* 2038730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038740 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2038743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038766 */     // GIR_Coverage, 14936,
     /* 2038766 */     GIR_EraseRootFromParent_Done,
     /* 2038767 */   // Label 27164: @2038767
     /* 2038767 */   GIM_Try, /*On fail goto*//*Label 27165*/ GIMT_Encode4(2038858), // Rule ID 14937 //
     /* 2038772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2038783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2038786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2038789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2038792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038818 */     // MIs[0] round
     /* 2038818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038821 */     // MIs[0] policy
     /* 2038821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038831 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2038834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038857 */     // GIR_Coverage, 14937,
     /* 2038857 */     GIR_EraseRootFromParent_Done,
     /* 2038858 */   // Label 27165: @2038858
     /* 2038858 */   GIM_Try, /*On fail goto*//*Label 27166*/ GIMT_Encode4(2038949), // Rule ID 14940 //
     /* 2038863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2038874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2038877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2038880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2038883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038909 */     // MIs[0] round
     /* 2038909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038912 */     // MIs[0] policy
     /* 2038912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038922 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2038925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038948 */     // GIR_Coverage, 14940,
     /* 2038948 */     GIR_EraseRootFromParent_Done,
     /* 2038949 */   // Label 27166: @2038949
     /* 2038949 */   GIM_Try, /*On fail goto*//*Label 27167*/ GIMT_Encode4(2039040), // Rule ID 14941 //
     /* 2038954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2038965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2038968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2038971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2038974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039000 */     // MIs[0] round
     /* 2039000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039003 */     // MIs[0] policy
     /* 2039003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039013 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2039016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039039 */     // GIR_Coverage, 14941,
     /* 2039039 */     GIR_EraseRootFromParent_Done,
     /* 2039040 */   // Label 27167: @2039040
     /* 2039040 */   GIM_Try, /*On fail goto*//*Label 27168*/ GIMT_Encode4(2039131), // Rule ID 14944 //
     /* 2039045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2039056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2039059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2039062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2039065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039091 */     // MIs[0] round
     /* 2039091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039094 */     // MIs[0] policy
     /* 2039094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039104 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2039107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039130 */     // GIR_Coverage, 14944,
     /* 2039130 */     GIR_EraseRootFromParent_Done,
     /* 2039131 */   // Label 27168: @2039131
     /* 2039131 */   GIM_Try, /*On fail goto*//*Label 27169*/ GIMT_Encode4(2039222), // Rule ID 14945 //
     /* 2039136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2039147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2039150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2039153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2039156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039182 */     // MIs[0] round
     /* 2039182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039185 */     // MIs[0] policy
     /* 2039185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039195 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2039198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039221 */     // GIR_Coverage, 14945,
     /* 2039221 */     GIR_EraseRootFromParent_Done,
     /* 2039222 */   // Label 27169: @2039222
     /* 2039222 */   GIM_Try, /*On fail goto*//*Label 27170*/ GIMT_Encode4(2039313), // Rule ID 14948 //
     /* 2039227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2039238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2039241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2039244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2039247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039273 */     // MIs[0] round
     /* 2039273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039276 */     // MIs[0] policy
     /* 2039276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039286 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2039289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039312 */     // GIR_Coverage, 14948,
     /* 2039312 */     GIR_EraseRootFromParent_Done,
     /* 2039313 */   // Label 27170: @2039313
     /* 2039313 */   GIM_Try, /*On fail goto*//*Label 27171*/ GIMT_Encode4(2039404), // Rule ID 14949 //
     /* 2039318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2039329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2039332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2039335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2039338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039364 */     // MIs[0] round
     /* 2039364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039367 */     // MIs[0] policy
     /* 2039367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039377 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2039380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039403 */     // GIR_Coverage, 14949,
     /* 2039403 */     GIR_EraseRootFromParent_Done,
     /* 2039404 */   // Label 27171: @2039404
     /* 2039404 */   GIM_Try, /*On fail goto*//*Label 27172*/ GIMT_Encode4(2039495), // Rule ID 14952 //
     /* 2039409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2039420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2039423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2039426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2039429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039455 */     // MIs[0] round
     /* 2039455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039458 */     // MIs[0] policy
     /* 2039458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039468 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2039471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039494 */     // GIR_Coverage, 14952,
     /* 2039494 */     GIR_EraseRootFromParent_Done,
     /* 2039495 */   // Label 27172: @2039495
     /* 2039495 */   GIM_Try, /*On fail goto*//*Label 27173*/ GIMT_Encode4(2039586), // Rule ID 14953 //
     /* 2039500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2039511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2039514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2039517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2039520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039546 */     // MIs[0] round
     /* 2039546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039549 */     // MIs[0] policy
     /* 2039549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039559 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2039562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039585 */     // GIR_Coverage, 14953,
     /* 2039585 */     GIR_EraseRootFromParent_Done,
     /* 2039586 */   // Label 27173: @2039586
     /* 2039586 */   GIM_Try, /*On fail goto*//*Label 27174*/ GIMT_Encode4(2039677), // Rule ID 14956 //
     /* 2039591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2039602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2039605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2039608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2039611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039637 */     // MIs[0] round
     /* 2039637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039640 */     // MIs[0] policy
     /* 2039640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2039653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039676 */     // GIR_Coverage, 14956,
     /* 2039676 */     GIR_EraseRootFromParent_Done,
     /* 2039677 */   // Label 27174: @2039677
     /* 2039677 */   GIM_Try, /*On fail goto*//*Label 27175*/ GIMT_Encode4(2039768), // Rule ID 14957 //
     /* 2039682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2039693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2039696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2039699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2039702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039728 */     // MIs[0] round
     /* 2039728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039731 */     // MIs[0] policy
     /* 2039731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039741 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2039744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039767 */     // GIR_Coverage, 14957,
     /* 2039767 */     GIR_EraseRootFromParent_Done,
     /* 2039768 */   // Label 27175: @2039768
     /* 2039768 */   GIM_Try, /*On fail goto*//*Label 27176*/ GIMT_Encode4(2039859), // Rule ID 14960 //
     /* 2039773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2039776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2039784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2039787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2039790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2039793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039819 */     // MIs[0] round
     /* 2039819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039822 */     // MIs[0] policy
     /* 2039822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039832 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2039835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2039855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039858 */     // GIR_Coverage, 14960,
     /* 2039858 */     GIR_EraseRootFromParent_Done,
     /* 2039859 */   // Label 27176: @2039859
     /* 2039859 */   GIM_Try, /*On fail goto*//*Label 27177*/ GIMT_Encode4(2039950), // Rule ID 14961 //
     /* 2039864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2039867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2039875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2039878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2039881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2039884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039910 */     // MIs[0] round
     /* 2039910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039913 */     // MIs[0] policy
     /* 2039913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039923 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2039926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039936 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2039946 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039949 */     // GIR_Coverage, 14961,
     /* 2039949 */     GIR_EraseRootFromParent_Done,
     /* 2039950 */   // Label 27177: @2039950
     /* 2039950 */   GIM_Try, /*On fail goto*//*Label 27178*/ GIMT_Encode4(2040041), // Rule ID 14964 //
     /* 2039955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2039966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2039969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2039972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2039975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2039978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2039985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2039989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2039993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2039997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040001 */     // MIs[0] round
     /* 2040001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040004 */     // MIs[0] policy
     /* 2040004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2040017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040040 */     // GIR_Coverage, 14964,
     /* 2040040 */     GIR_EraseRootFromParent_Done,
     /* 2040041 */   // Label 27178: @2040041
     /* 2040041 */   GIM_Try, /*On fail goto*//*Label 27179*/ GIMT_Encode4(2040132), // Rule ID 14965 //
     /* 2040046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2040057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2040060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2040063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2040066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040092 */     // MIs[0] round
     /* 2040092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040095 */     // MIs[0] policy
     /* 2040095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040105 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2040108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040131 */     // GIR_Coverage, 14965,
     /* 2040131 */     GIR_EraseRootFromParent_Done,
     /* 2040132 */   // Label 27179: @2040132
     /* 2040132 */   GIM_Try, /*On fail goto*//*Label 27180*/ GIMT_Encode4(2040223), // Rule ID 14968 //
     /* 2040137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2040148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2040151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2040154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2040157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2040160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040183 */     // MIs[0] round
     /* 2040183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040186 */     // MIs[0] policy
     /* 2040186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040196 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2040199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040222 */     // GIR_Coverage, 14968,
     /* 2040222 */     GIR_EraseRootFromParent_Done,
     /* 2040223 */   // Label 27180: @2040223
     /* 2040223 */   GIM_Try, /*On fail goto*//*Label 27181*/ GIMT_Encode4(2040314), // Rule ID 14969 //
     /* 2040228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2040239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2040242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2040245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2040248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2040251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040274 */     // MIs[0] round
     /* 2040274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040277 */     // MIs[0] policy
     /* 2040277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040287 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2040290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040313 */     // GIR_Coverage, 14969,
     /* 2040313 */     GIR_EraseRootFromParent_Done,
     /* 2040314 */   // Label 27181: @2040314
     /* 2040314 */   GIM_Try, /*On fail goto*//*Label 27182*/ GIMT_Encode4(2040405), // Rule ID 14972 //
     /* 2040319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2040330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2040333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2040336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2040339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2040342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2040349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040365 */     // MIs[0] round
     /* 2040365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040368 */     // MIs[0] policy
     /* 2040368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040378 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2040381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040404 */     // GIR_Coverage, 14972,
     /* 2040404 */     GIR_EraseRootFromParent_Done,
     /* 2040405 */   // Label 27182: @2040405
     /* 2040405 */   GIM_Try, /*On fail goto*//*Label 27183*/ GIMT_Encode4(2040496), // Rule ID 14973 //
     /* 2040410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2040421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2040424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2040427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2040430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2040433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2040440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040456 */     // MIs[0] round
     /* 2040456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040459 */     // MIs[0] policy
     /* 2040459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040469 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2040472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040495 */     // GIR_Coverage, 14973,
     /* 2040495 */     GIR_EraseRootFromParent_Done,
     /* 2040496 */   // Label 27183: @2040496
     /* 2040496 */   GIM_Try, /*On fail goto*//*Label 27184*/ GIMT_Encode4(2040587), // Rule ID 14976 //
     /* 2040501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2040512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2040515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2040518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2040521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2040524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040547 */     // MIs[0] round
     /* 2040547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040550 */     // MIs[0] policy
     /* 2040550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040560 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2040563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040586 */     // GIR_Coverage, 14976,
     /* 2040586 */     GIR_EraseRootFromParent_Done,
     /* 2040587 */   // Label 27184: @2040587
     /* 2040587 */   GIM_Try, /*On fail goto*//*Label 27185*/ GIMT_Encode4(2040678), // Rule ID 14977 //
     /* 2040592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2040603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2040606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2040609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2040612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2040615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040638 */     // MIs[0] round
     /* 2040638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040641 */     // MIs[0] policy
     /* 2040641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040651 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2040654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040677 */     // GIR_Coverage, 14977,
     /* 2040677 */     GIR_EraseRootFromParent_Done,
     /* 2040678 */   // Label 27185: @2040678
     /* 2040678 */   GIM_Try, /*On fail goto*//*Label 27186*/ GIMT_Encode4(2040769), // Rule ID 14980 //
     /* 2040683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2040694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2040697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2040700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2040703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040729 */     // MIs[0] round
     /* 2040729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040732 */     // MIs[0] policy
     /* 2040732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040742 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2040745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040768 */     // GIR_Coverage, 14980,
     /* 2040768 */     GIR_EraseRootFromParent_Done,
     /* 2040769 */   // Label 27186: @2040769
     /* 2040769 */   GIM_Try, /*On fail goto*//*Label 27187*/ GIMT_Encode4(2040860), // Rule ID 14981 //
     /* 2040774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2040785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2040788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2040791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2040794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040820 */     // MIs[0] round
     /* 2040820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040823 */     // MIs[0] policy
     /* 2040823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040833 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2040836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040859 */     // GIR_Coverage, 14981,
     /* 2040859 */     GIR_EraseRootFromParent_Done,
     /* 2040860 */   // Label 27187: @2040860
     /* 2040860 */   GIM_Try, /*On fail goto*//*Label 27188*/ GIMT_Encode4(2040951), // Rule ID 14984 //
     /* 2040865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2040876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2040879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2040882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2040885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2040888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2040895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040911 */     // MIs[0] round
     /* 2040911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040914 */     // MIs[0] policy
     /* 2040914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040924 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2040927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040950 */     // GIR_Coverage, 14984,
     /* 2040950 */     GIR_EraseRootFromParent_Done,
     /* 2040951 */   // Label 27188: @2040951
     /* 2040951 */   GIM_Try, /*On fail goto*//*Label 27189*/ GIMT_Encode4(2041042), // Rule ID 14985 //
     /* 2040956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2040967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2040970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2040973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2040976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2040979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2040986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041002 */     // MIs[0] round
     /* 2041002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041005 */     // MIs[0] policy
     /* 2041005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041015 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2041018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041041 */     // GIR_Coverage, 14985,
     /* 2041041 */     GIR_EraseRootFromParent_Done,
     /* 2041042 */   // Label 27189: @2041042
     /* 2041042 */   GIM_Try, /*On fail goto*//*Label 27190*/ GIMT_Encode4(2041133), // Rule ID 14988 //
     /* 2041047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2041058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2041061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2041064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2041067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041093 */     // MIs[0] round
     /* 2041093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041096 */     // MIs[0] policy
     /* 2041096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2041109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041132 */     // GIR_Coverage, 14988,
     /* 2041132 */     GIR_EraseRootFromParent_Done,
     /* 2041133 */   // Label 27190: @2041133
     /* 2041133 */   GIM_Try, /*On fail goto*//*Label 27191*/ GIMT_Encode4(2041224), // Rule ID 14989 //
     /* 2041138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2041149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2041152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2041155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2041158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041184 */     // MIs[0] round
     /* 2041184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041187 */     // MIs[0] policy
     /* 2041187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2041200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041223 */     // GIR_Coverage, 14989,
     /* 2041223 */     GIR_EraseRootFromParent_Done,
     /* 2041224 */   // Label 27191: @2041224
     /* 2041224 */   GIM_Try, /*On fail goto*//*Label 27192*/ GIMT_Encode4(2041315), // Rule ID 14992 //
     /* 2041229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2041240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2041243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2041246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2041249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041275 */     // MIs[0] round
     /* 2041275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041278 */     // MIs[0] policy
     /* 2041278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041288 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2041291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041314 */     // GIR_Coverage, 14992,
     /* 2041314 */     GIR_EraseRootFromParent_Done,
     /* 2041315 */   // Label 27192: @2041315
     /* 2041315 */   GIM_Try, /*On fail goto*//*Label 27193*/ GIMT_Encode4(2041406), // Rule ID 14993 //
     /* 2041320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2041331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2041334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2041337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2041340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041366 */     // MIs[0] round
     /* 2041366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041369 */     // MIs[0] policy
     /* 2041369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041379 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2041382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041405 */     // GIR_Coverage, 14993,
     /* 2041405 */     GIR_EraseRootFromParent_Done,
     /* 2041406 */   // Label 27193: @2041406
     /* 2041406 */   GIM_Try, /*On fail goto*//*Label 27194*/ GIMT_Encode4(2041497), // Rule ID 14996 //
     /* 2041411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2041422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2041425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2041428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2041431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041457 */     // MIs[0] round
     /* 2041457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041460 */     // MIs[0] policy
     /* 2041460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041470 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2041473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041496 */     // GIR_Coverage, 14996,
     /* 2041496 */     GIR_EraseRootFromParent_Done,
     /* 2041497 */   // Label 27194: @2041497
     /* 2041497 */   GIM_Try, /*On fail goto*//*Label 27195*/ GIMT_Encode4(2041588), // Rule ID 14997 //
     /* 2041502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2041513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2041516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2041519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2041522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041548 */     // MIs[0] round
     /* 2041548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041551 */     // MIs[0] policy
     /* 2041551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041561 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2041564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041587 */     // GIR_Coverage, 14997,
     /* 2041587 */     GIR_EraseRootFromParent_Done,
     /* 2041588 */   // Label 27195: @2041588
     /* 2041588 */   GIM_Try, /*On fail goto*//*Label 27196*/ GIMT_Encode4(2041679), // Rule ID 15000 //
     /* 2041593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2041596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2041604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2041607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2041610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2041613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2041616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041639 */     // MIs[0] round
     /* 2041639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041642 */     // MIs[0] policy
     /* 2041642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2041655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2041675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041678 */     // GIR_Coverage, 15000,
     /* 2041678 */     GIR_EraseRootFromParent_Done,
     /* 2041679 */   // Label 27196: @2041679
     /* 2041679 */   GIM_Try, /*On fail goto*//*Label 27197*/ GIMT_Encode4(2041770), // Rule ID 15001 //
     /* 2041684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2041687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2041695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2041698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2041701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2041704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2041707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041730 */     // MIs[0] round
     /* 2041730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041733 */     // MIs[0] policy
     /* 2041733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2041746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2041766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041769 */     // GIR_Coverage, 15001,
     /* 2041769 */     GIR_EraseRootFromParent_Done,
     /* 2041770 */   // Label 27197: @2041770
     /* 2041770 */   GIM_Try, /*On fail goto*//*Label 27198*/ GIMT_Encode4(2041861), // Rule ID 15004 //
     /* 2041775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2041778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2041786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2041789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2041792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2041795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041821 */     // MIs[0] round
     /* 2041821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041824 */     // MIs[0] policy
     /* 2041824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041834 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2041837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2041857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041860 */     // GIR_Coverage, 15004,
     /* 2041860 */     GIR_EraseRootFromParent_Done,
     /* 2041861 */   // Label 27198: @2041861
     /* 2041861 */   GIM_Try, /*On fail goto*//*Label 27199*/ GIMT_Encode4(2041952), // Rule ID 15005 //
     /* 2041866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2041869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2041877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2041880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2041883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2041886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041912 */     // MIs[0] round
     /* 2041912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041915 */     // MIs[0] policy
     /* 2041915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041925 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2041928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2041948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041951 */     // GIR_Coverage, 15005,
     /* 2041951 */     GIR_EraseRootFromParent_Done,
     /* 2041952 */   // Label 27199: @2041952
     /* 2041952 */   GIM_Try, /*On fail goto*//*Label 27200*/ GIMT_Encode4(2042043), // Rule ID 15008 //
     /* 2041957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2041960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2041968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2041971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2041974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2041977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042003 */     // MIs[0] round
     /* 2042003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042006 */     // MIs[0] policy
     /* 2042006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2042019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042042 */     // GIR_Coverage, 15008,
     /* 2042042 */     GIR_EraseRootFromParent_Done,
     /* 2042043 */   // Label 27200: @2042043
     /* 2042043 */   GIM_Try, /*On fail goto*//*Label 27201*/ GIMT_Encode4(2042134), // Rule ID 15009 //
     /* 2042048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2042059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2042062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2042065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2042068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042094 */     // MIs[0] round
     /* 2042094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042097 */     // MIs[0] policy
     /* 2042097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042107 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2042110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042133 */     // GIR_Coverage, 15009,
     /* 2042133 */     GIR_EraseRootFromParent_Done,
     /* 2042134 */   // Label 27201: @2042134
     /* 2042134 */   GIM_Try, /*On fail goto*//*Label 27202*/ GIMT_Encode4(2042225), // Rule ID 15012 //
     /* 2042139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2042150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2042153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2042156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042185 */     // MIs[0] round
     /* 2042185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042188 */     // MIs[0] policy
     /* 2042188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042198 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2042201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042224 */     // GIR_Coverage, 15012,
     /* 2042224 */     GIR_EraseRootFromParent_Done,
     /* 2042225 */   // Label 27202: @2042225
     /* 2042225 */   GIM_Try, /*On fail goto*//*Label 27203*/ GIMT_Encode4(2042316), // Rule ID 15013 //
     /* 2042230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2042241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2042244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2042247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042276 */     // MIs[0] round
     /* 2042276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042279 */     // MIs[0] policy
     /* 2042279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042289 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2042292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042315 */     // GIR_Coverage, 15013,
     /* 2042315 */     GIR_EraseRootFromParent_Done,
     /* 2042316 */   // Label 27203: @2042316
     /* 2042316 */   GIM_Try, /*On fail goto*//*Label 27204*/ GIMT_Encode4(2042407), // Rule ID 15016 //
     /* 2042321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2042332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2042335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2042338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042367 */     // MIs[0] round
     /* 2042367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042370 */     // MIs[0] policy
     /* 2042370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042380 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2042383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042406 */     // GIR_Coverage, 15016,
     /* 2042406 */     GIR_EraseRootFromParent_Done,
     /* 2042407 */   // Label 27204: @2042407
     /* 2042407 */   GIM_Try, /*On fail goto*//*Label 27205*/ GIMT_Encode4(2042498), // Rule ID 15017 //
     /* 2042412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2042423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2042426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2042429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042458 */     // MIs[0] round
     /* 2042458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042461 */     // MIs[0] policy
     /* 2042461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042471 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2042474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042497 */     // GIR_Coverage, 15017,
     /* 2042497 */     GIR_EraseRootFromParent_Done,
     /* 2042498 */   // Label 27205: @2042498
     /* 2042498 */   GIM_Try, /*On fail goto*//*Label 27206*/ GIMT_Encode4(2042589), // Rule ID 15020 //
     /* 2042503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2042514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2042517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2042520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042549 */     // MIs[0] round
     /* 2042549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042552 */     // MIs[0] policy
     /* 2042552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042562 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2042565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042588 */     // GIR_Coverage, 15020,
     /* 2042588 */     GIR_EraseRootFromParent_Done,
     /* 2042589 */   // Label 27206: @2042589
     /* 2042589 */   GIM_Try, /*On fail goto*//*Label 27207*/ GIMT_Encode4(2042680), // Rule ID 15021 //
     /* 2042594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2042605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2042608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2042611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042640 */     // MIs[0] round
     /* 2042640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042643 */     // MIs[0] policy
     /* 2042643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042653 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2042656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042679 */     // GIR_Coverage, 15021,
     /* 2042679 */     GIR_EraseRootFromParent_Done,
     /* 2042680 */   // Label 27207: @2042680
     /* 2042680 */   GIM_Try, /*On fail goto*//*Label 27208*/ GIMT_Encode4(2042771), // Rule ID 15024 //
     /* 2042685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2042696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2042699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2042702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042731 */     // MIs[0] round
     /* 2042731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042734 */     // MIs[0] policy
     /* 2042734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042744 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2042747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2042767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042770 */     // GIR_Coverage, 15024,
     /* 2042770 */     GIR_EraseRootFromParent_Done,
     /* 2042771 */   // Label 27208: @2042771
     /* 2042771 */   GIM_Try, /*On fail goto*//*Label 27209*/ GIMT_Encode4(2042862), // Rule ID 15025 //
     /* 2042776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2042787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2042790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2042793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042822 */     // MIs[0] round
     /* 2042822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042825 */     // MIs[0] policy
     /* 2042825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042835 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2042838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2042858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042861 */     // GIR_Coverage, 15025,
     /* 2042861 */     GIR_EraseRootFromParent_Done,
     /* 2042862 */   // Label 27209: @2042862
     /* 2042862 */   GIM_Try, /*On fail goto*//*Label 27210*/ GIMT_Encode4(2042953), // Rule ID 15028 //
     /* 2042867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2042878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2042881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2042884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042913 */     // MIs[0] round
     /* 2042913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042916 */     // MIs[0] policy
     /* 2042916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042926 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2042929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2042949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042952 */     // GIR_Coverage, 15028,
     /* 2042952 */     GIR_EraseRootFromParent_Done,
     /* 2042953 */   // Label 27210: @2042953
     /* 2042953 */   GIM_Try, /*On fail goto*//*Label 27211*/ GIMT_Encode4(2043044), // Rule ID 15029 //
     /* 2042958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2042969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2042972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2042975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043004 */     // MIs[0] round
     /* 2043004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043007 */     // MIs[0] policy
     /* 2043007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043017 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2043020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043043 */     // GIR_Coverage, 15029,
     /* 2043043 */     GIR_EraseRootFromParent_Done,
     /* 2043044 */   // Label 27211: @2043044
     /* 2043044 */   GIM_Try, /*On fail goto*//*Label 27212*/ GIMT_Encode4(2043135), // Rule ID 15032 //
     /* 2043049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2043057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2043060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2043063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2043066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2043069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043095 */     // MIs[0] round
     /* 2043095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043098 */     // MIs[0] policy
     /* 2043098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2043111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043134 */     // GIR_Coverage, 15032,
     /* 2043134 */     GIR_EraseRootFromParent_Done,
     /* 2043135 */   // Label 27212: @2043135
     /* 2043135 */   GIM_Try, /*On fail goto*//*Label 27213*/ GIMT_Encode4(2043226), // Rule ID 15033 //
     /* 2043140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2043148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2043151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2043154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2043157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2043160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043186 */     // MIs[0] round
     /* 2043186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043189 */     // MIs[0] policy
     /* 2043189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043199 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2043202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043225 */     // GIR_Coverage, 15033,
     /* 2043225 */     GIR_EraseRootFromParent_Done,
     /* 2043226 */   // Label 27213: @2043226
     /* 2043226 */   GIM_Try, /*On fail goto*//*Label 27214*/ GIMT_Encode4(2043317), // Rule ID 15036 //
     /* 2043231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2043239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2043242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2043245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2043248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2043251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043277 */     // MIs[0] round
     /* 2043277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043280 */     // MIs[0] policy
     /* 2043280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043290 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2043293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043316 */     // GIR_Coverage, 15036,
     /* 2043316 */     GIR_EraseRootFromParent_Done,
     /* 2043317 */   // Label 27214: @2043317
     /* 2043317 */   GIM_Try, /*On fail goto*//*Label 27215*/ GIMT_Encode4(2043408), // Rule ID 15037 //
     /* 2043322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2043330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2043333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2043336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2043339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2043342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043368 */     // MIs[0] round
     /* 2043368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043371 */     // MIs[0] policy
     /* 2043371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043381 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2043384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043407 */     // GIR_Coverage, 15037,
     /* 2043407 */     GIR_EraseRootFromParent_Done,
     /* 2043408 */   // Label 27215: @2043408
     /* 2043408 */   GIM_Try, /*On fail goto*//*Label 27216*/ GIMT_Encode4(2043499), // Rule ID 15040 //
     /* 2043413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2043421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2043424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2043427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2043430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2043433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043459 */     // MIs[0] round
     /* 2043459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043462 */     // MIs[0] policy
     /* 2043462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043472 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2043475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043498 */     // GIR_Coverage, 15040,
     /* 2043498 */     GIR_EraseRootFromParent_Done,
     /* 2043499 */   // Label 27216: @2043499
     /* 2043499 */   GIM_Try, /*On fail goto*//*Label 27217*/ GIMT_Encode4(2043590), // Rule ID 15041 //
     /* 2043504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2043512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2043515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2043518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2043521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2043524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043550 */     // MIs[0] round
     /* 2043550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043553 */     // MIs[0] policy
     /* 2043553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043563 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2043566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043589 */     // GIR_Coverage, 15041,
     /* 2043589 */     GIR_EraseRootFromParent_Done,
     /* 2043590 */   // Label 27217: @2043590
     /* 2043590 */   GIM_Try, /*On fail goto*//*Label 27218*/ GIMT_Encode4(2043681), // Rule ID 15044 //
     /* 2043595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2043603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2043606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2043609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2043612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2043615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043641 */     // MIs[0] round
     /* 2043641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043644 */     // MIs[0] policy
     /* 2043644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043654 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2043657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043680 */     // GIR_Coverage, 15044,
     /* 2043680 */     GIR_EraseRootFromParent_Done,
     /* 2043681 */   // Label 27218: @2043681
     /* 2043681 */   GIM_Try, /*On fail goto*//*Label 27219*/ GIMT_Encode4(2043772), // Rule ID 15045 //
     /* 2043686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2043694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2043697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2043700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2043703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2043706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043732 */     // MIs[0] round
     /* 2043732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043735 */     // MIs[0] policy
     /* 2043735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043745 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2043748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043771 */     // GIR_Coverage, 15045,
     /* 2043771 */     GIR_EraseRootFromParent_Done,
     /* 2043772 */   // Label 27219: @2043772
     /* 2043772 */   GIM_Try, /*On fail goto*//*Label 27220*/ GIMT_Encode4(2043863), // Rule ID 15048 //
     /* 2043777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2043780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2043785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2043788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2043791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2043794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2043797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043823 */     // MIs[0] round
     /* 2043823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043826 */     // MIs[0] policy
     /* 2043826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043836 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2043839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2043859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043862 */     // GIR_Coverage, 15048,
     /* 2043862 */     GIR_EraseRootFromParent_Done,
     /* 2043863 */   // Label 27220: @2043863
     /* 2043863 */   GIM_Try, /*On fail goto*//*Label 27221*/ GIMT_Encode4(2043954), // Rule ID 15049 //
     /* 2043868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2043871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2043876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2043879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2043882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2043885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2043888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043914 */     // MIs[0] round
     /* 2043914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043917 */     // MIs[0] policy
     /* 2043917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043927 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2043930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2043950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043953 */     // GIR_Coverage, 15049,
     /* 2043953 */     GIR_EraseRootFromParent_Done,
     /* 2043954 */   // Label 27221: @2043954
     /* 2043954 */   GIM_Try, /*On fail goto*//*Label 27222*/ GIMT_Encode4(2044045), // Rule ID 15052 //
     /* 2043959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2043967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2043970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2043973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2043976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2043979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2043982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2043989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2043993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2043997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044005 */     // MIs[0] round
     /* 2044005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044008 */     // MIs[0] policy
     /* 2044008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044018 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2044021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044044 */     // GIR_Coverage, 15052,
     /* 2044044 */     GIR_EraseRootFromParent_Done,
     /* 2044045 */   // Label 27222: @2044045
     /* 2044045 */   GIM_Try, /*On fail goto*//*Label 27223*/ GIMT_Encode4(2044136), // Rule ID 15053 //
     /* 2044050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2044058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2044061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2044064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2044067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2044070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044096 */     // MIs[0] round
     /* 2044096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044099 */     // MIs[0] policy
     /* 2044099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044109 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2044112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044135 */     // GIR_Coverage, 15053,
     /* 2044135 */     GIR_EraseRootFromParent_Done,
     /* 2044136 */   // Label 27223: @2044136
     /* 2044136 */   GIM_Try, /*On fail goto*//*Label 27224*/ GIMT_Encode4(2044227), // Rule ID 15056 //
     /* 2044141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2044149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2044152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2044155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2044158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2044161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044187 */     // MIs[0] round
     /* 2044187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044190 */     // MIs[0] policy
     /* 2044190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044200 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2044203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044226 */     // GIR_Coverage, 15056,
     /* 2044226 */     GIR_EraseRootFromParent_Done,
     /* 2044227 */   // Label 27224: @2044227
     /* 2044227 */   GIM_Try, /*On fail goto*//*Label 27225*/ GIMT_Encode4(2044318), // Rule ID 15057 //
     /* 2044232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2044240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2044243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2044246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2044249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2044252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044278 */     // MIs[0] round
     /* 2044278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044281 */     // MIs[0] policy
     /* 2044281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044291 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2044294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044317 */     // GIR_Coverage, 15057,
     /* 2044317 */     GIR_EraseRootFromParent_Done,
     /* 2044318 */   // Label 27225: @2044318
     /* 2044318 */   GIM_Try, /*On fail goto*//*Label 27226*/ GIMT_Encode4(2044409), // Rule ID 15060 //
     /* 2044323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2044331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2044334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2044337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2044340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2044343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2044346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044369 */     // MIs[0] round
     /* 2044369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044372 */     // MIs[0] policy
     /* 2044372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044382 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2044385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044408 */     // GIR_Coverage, 15060,
     /* 2044408 */     GIR_EraseRootFromParent_Done,
     /* 2044409 */   // Label 27226: @2044409
     /* 2044409 */   GIM_Try, /*On fail goto*//*Label 27227*/ GIMT_Encode4(2044500), // Rule ID 15061 //
     /* 2044414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2044422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2044425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2044428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2044431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2044434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2044437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044460 */     // MIs[0] round
     /* 2044460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044463 */     // MIs[0] policy
     /* 2044463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044473 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2044476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044499 */     // GIR_Coverage, 15061,
     /* 2044499 */     GIR_EraseRootFromParent_Done,
     /* 2044500 */   // Label 27227: @2044500
     /* 2044500 */   GIM_Try, /*On fail goto*//*Label 27228*/ GIMT_Encode4(2044591), // Rule ID 15064 //
     /* 2044505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2044513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2044516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2044519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2044522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2044525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2044528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044551 */     // MIs[0] round
     /* 2044551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044554 */     // MIs[0] policy
     /* 2044554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044564 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2044567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044590 */     // GIR_Coverage, 15064,
     /* 2044590 */     GIR_EraseRootFromParent_Done,
     /* 2044591 */   // Label 27228: @2044591
     /* 2044591 */   GIM_Try, /*On fail goto*//*Label 27229*/ GIMT_Encode4(2044682), // Rule ID 15065 //
     /* 2044596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2044604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2044607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2044610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2044613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2044616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2044619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044642 */     // MIs[0] round
     /* 2044642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044645 */     // MIs[0] policy
     /* 2044645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044655 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2044658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044681 */     // GIR_Coverage, 15065,
     /* 2044681 */     GIR_EraseRootFromParent_Done,
     /* 2044682 */   // Label 27229: @2044682
     /* 2044682 */   GIM_Try, /*On fail goto*//*Label 27230*/ GIMT_Encode4(2044773), // Rule ID 15068 //
     /* 2044687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2044695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2044698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2044701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2044704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2044707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044733 */     // MIs[0] round
     /* 2044733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044736 */     // MIs[0] policy
     /* 2044736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044746 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2044749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044772 */     // GIR_Coverage, 15068,
     /* 2044772 */     GIR_EraseRootFromParent_Done,
     /* 2044773 */   // Label 27230: @2044773
     /* 2044773 */   GIM_Try, /*On fail goto*//*Label 27231*/ GIMT_Encode4(2044864), // Rule ID 15069 //
     /* 2044778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2044786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2044789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2044792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2044795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2044798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044824 */     // MIs[0] round
     /* 2044824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044827 */     // MIs[0] policy
     /* 2044827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044837 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2044840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044863 */     // GIR_Coverage, 15069,
     /* 2044863 */     GIR_EraseRootFromParent_Done,
     /* 2044864 */   // Label 27231: @2044864
     /* 2044864 */   GIM_Try, /*On fail goto*//*Label 27232*/ GIMT_Encode4(2044955), // Rule ID 15072 //
     /* 2044869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2044877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2044880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2044883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2044886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2044889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044915 */     // MIs[0] round
     /* 2044915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044918 */     // MIs[0] policy
     /* 2044918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044928 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2044931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044954 */     // GIR_Coverage, 15072,
     /* 2044954 */     GIR_EraseRootFromParent_Done,
     /* 2044955 */   // Label 27232: @2044955
     /* 2044955 */   GIM_Try, /*On fail goto*//*Label 27233*/ GIMT_Encode4(2045046), // Rule ID 15073 //
     /* 2044960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2044968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2044971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2044974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2044977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2044980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045006 */     // MIs[0] round
     /* 2045006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045009 */     // MIs[0] policy
     /* 2045009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045019 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2045022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045045 */     // GIR_Coverage, 15073,
     /* 2045045 */     GIR_EraseRootFromParent_Done,
     /* 2045046 */   // Label 27233: @2045046
     /* 2045046 */   GIM_Try, /*On fail goto*//*Label 27234*/ GIMT_Encode4(2045137), // Rule ID 15076 //
     /* 2045051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2045059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2045062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2045065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2045068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2045071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045097 */     // MIs[0] round
     /* 2045097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045100 */     // MIs[0] policy
     /* 2045100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2045113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045136 */     // GIR_Coverage, 15076,
     /* 2045136 */     GIR_EraseRootFromParent_Done,
     /* 2045137 */   // Label 27234: @2045137
     /* 2045137 */   GIM_Try, /*On fail goto*//*Label 27235*/ GIMT_Encode4(2045228), // Rule ID 15077 //
     /* 2045142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2045150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2045153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2045156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2045159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2045162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045188 */     // MIs[0] round
     /* 2045188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045191 */     // MIs[0] policy
     /* 2045191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045201 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2045204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045227 */     // GIR_Coverage, 15077,
     /* 2045227 */     GIR_EraseRootFromParent_Done,
     /* 2045228 */   // Label 27235: @2045228
     /* 2045228 */   GIM_Try, /*On fail goto*//*Label 27236*/ GIMT_Encode4(2045319), // Rule ID 15080 //
     /* 2045233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2045241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2045244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2045247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2045250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2045253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045279 */     // MIs[0] round
     /* 2045279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045282 */     // MIs[0] policy
     /* 2045282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045292 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2045295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045318 */     // GIR_Coverage, 15080,
     /* 2045318 */     GIR_EraseRootFromParent_Done,
     /* 2045319 */   // Label 27236: @2045319
     /* 2045319 */   GIM_Try, /*On fail goto*//*Label 27237*/ GIMT_Encode4(2045410), // Rule ID 15081 //
     /* 2045324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2045332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2045335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2045338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2045341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2045344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045370 */     // MIs[0] round
     /* 2045370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045373 */     // MIs[0] policy
     /* 2045373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045383 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2045386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045409 */     // GIR_Coverage, 15081,
     /* 2045409 */     GIR_EraseRootFromParent_Done,
     /* 2045410 */   // Label 27237: @2045410
     /* 2045410 */   GIM_Try, /*On fail goto*//*Label 27238*/ GIMT_Encode4(2045501), // Rule ID 15084 //
     /* 2045415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2045423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2045426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2045429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2045432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2045435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045461 */     // MIs[0] round
     /* 2045461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045464 */     // MIs[0] policy
     /* 2045464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045474 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2045477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045500 */     // GIR_Coverage, 15084,
     /* 2045500 */     GIR_EraseRootFromParent_Done,
     /* 2045501 */   // Label 27238: @2045501
     /* 2045501 */   GIM_Try, /*On fail goto*//*Label 27239*/ GIMT_Encode4(2045592), // Rule ID 15085 //
     /* 2045506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2045514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2045517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2045520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2045523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2045526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045552 */     // MIs[0] round
     /* 2045552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045555 */     // MIs[0] policy
     /* 2045555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045565 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2045568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045591 */     // GIR_Coverage, 15085,
     /* 2045591 */     GIR_EraseRootFromParent_Done,
     /* 2045592 */   // Label 27239: @2045592
     /* 2045592 */   GIM_Try, /*On fail goto*//*Label 27240*/ GIMT_Encode4(2045683), // Rule ID 15088 //
     /* 2045597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2045600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2045605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2045608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2045611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2045614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2045617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2045620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045643 */     // MIs[0] round
     /* 2045643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045646 */     // MIs[0] policy
     /* 2045646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045656 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2045659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045682 */     // GIR_Coverage, 15088,
     /* 2045682 */     GIR_EraseRootFromParent_Done,
     /* 2045683 */   // Label 27240: @2045683
     /* 2045683 */   GIM_Try, /*On fail goto*//*Label 27241*/ GIMT_Encode4(2045774), // Rule ID 15089 //
     /* 2045688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2045691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2045696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2045699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2045702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2045705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2045708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2045711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045734 */     // MIs[0] round
     /* 2045734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045737 */     // MIs[0] policy
     /* 2045737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045747 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2045750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045773 */     // GIR_Coverage, 15089,
     /* 2045773 */     GIR_EraseRootFromParent_Done,
     /* 2045774 */   // Label 27241: @2045774
     /* 2045774 */   GIM_Try, /*On fail goto*//*Label 27242*/ GIMT_Encode4(2045865), // Rule ID 15092 //
     /* 2045779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2045782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2045787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2045790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2045793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2045796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2045799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045825 */     // MIs[0] round
     /* 2045825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045828 */     // MIs[0] policy
     /* 2045828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045838 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2045841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045864 */     // GIR_Coverage, 15092,
     /* 2045864 */     GIR_EraseRootFromParent_Done,
     /* 2045865 */   // Label 27242: @2045865
     /* 2045865 */   GIM_Try, /*On fail goto*//*Label 27243*/ GIMT_Encode4(2045956), // Rule ID 15093 //
     /* 2045870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2045873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2045878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2045881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2045884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2045887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2045890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045916 */     // MIs[0] round
     /* 2045916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045919 */     // MIs[0] policy
     /* 2045919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045929 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2045932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045955 */     // GIR_Coverage, 15093,
     /* 2045955 */     GIR_EraseRootFromParent_Done,
     /* 2045956 */   // Label 27243: @2045956
     /* 2045956 */   GIM_Try, /*On fail goto*//*Label 27244*/ GIMT_Encode4(2046047), // Rule ID 15096 //
     /* 2045961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2045964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2045969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2045972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2045975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2045978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2045981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046007 */     // MIs[0] round
     /* 2046007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046010 */     // MIs[0] policy
     /* 2046010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046020 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2046023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046046 */     // GIR_Coverage, 15096,
     /* 2046046 */     GIR_EraseRootFromParent_Done,
     /* 2046047 */   // Label 27244: @2046047
     /* 2046047 */   GIM_Try, /*On fail goto*//*Label 27245*/ GIMT_Encode4(2046138), // Rule ID 15097 //
     /* 2046052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2046060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2046063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2046066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2046069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046098 */     // MIs[0] round
     /* 2046098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046101 */     // MIs[0] policy
     /* 2046101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046111 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2046114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046137 */     // GIR_Coverage, 15097,
     /* 2046137 */     GIR_EraseRootFromParent_Done,
     /* 2046138 */   // Label 27245: @2046138
     /* 2046138 */   GIM_Try, /*On fail goto*//*Label 27246*/ GIMT_Encode4(2046229), // Rule ID 15100 //
     /* 2046143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2046154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2046157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2046160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2046163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046189 */     // MIs[0] round
     /* 2046189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046192 */     // MIs[0] policy
     /* 2046192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046202 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2046205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046228 */     // GIR_Coverage, 15100,
     /* 2046228 */     GIR_EraseRootFromParent_Done,
     /* 2046229 */   // Label 27246: @2046229
     /* 2046229 */   GIM_Try, /*On fail goto*//*Label 27247*/ GIMT_Encode4(2046320), // Rule ID 15101 //
     /* 2046234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2046245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2046248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2046251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2046254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046280 */     // MIs[0] round
     /* 2046280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046283 */     // MIs[0] policy
     /* 2046283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046293 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2046296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046319 */     // GIR_Coverage, 15101,
     /* 2046319 */     GIR_EraseRootFromParent_Done,
     /* 2046320 */   // Label 27247: @2046320
     /* 2046320 */   GIM_Try, /*On fail goto*//*Label 27248*/ GIMT_Encode4(2046411), // Rule ID 15104 //
     /* 2046325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2046336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2046339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2046342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2046345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046371 */     // MIs[0] round
     /* 2046371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046374 */     // MIs[0] policy
     /* 2046374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046384 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2046387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046410 */     // GIR_Coverage, 15104,
     /* 2046410 */     GIR_EraseRootFromParent_Done,
     /* 2046411 */   // Label 27248: @2046411
     /* 2046411 */   GIM_Try, /*On fail goto*//*Label 27249*/ GIMT_Encode4(2046502), // Rule ID 15105 //
     /* 2046416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2046427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2046430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2046433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2046436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046462 */     // MIs[0] round
     /* 2046462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046465 */     // MIs[0] policy
     /* 2046465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046475 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2046478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046501 */     // GIR_Coverage, 15105,
     /* 2046501 */     GIR_EraseRootFromParent_Done,
     /* 2046502 */   // Label 27249: @2046502
     /* 2046502 */   GIM_Try, /*On fail goto*//*Label 27250*/ GIMT_Encode4(2046593), // Rule ID 15108 //
     /* 2046507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2046518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2046521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2046524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2046527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046553 */     // MIs[0] round
     /* 2046553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046556 */     // MIs[0] policy
     /* 2046556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046566 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2046569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046592 */     // GIR_Coverage, 15108,
     /* 2046592 */     GIR_EraseRootFromParent_Done,
     /* 2046593 */   // Label 27250: @2046593
     /* 2046593 */   GIM_Try, /*On fail goto*//*Label 27251*/ GIMT_Encode4(2046684), // Rule ID 15109 //
     /* 2046598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2046609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2046612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2046615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2046618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046644 */     // MIs[0] round
     /* 2046644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046647 */     // MIs[0] policy
     /* 2046647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046657 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2046660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046683 */     // GIR_Coverage, 15109,
     /* 2046683 */     GIR_EraseRootFromParent_Done,
     /* 2046684 */   // Label 27251: @2046684
     /* 2046684 */   GIM_Try, /*On fail goto*//*Label 27252*/ GIMT_Encode4(2046775), // Rule ID 15112 //
     /* 2046689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2046700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2046703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2046706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2046709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046735 */     // MIs[0] round
     /* 2046735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046738 */     // MIs[0] policy
     /* 2046738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046748 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2046751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046774 */     // GIR_Coverage, 15112,
     /* 2046774 */     GIR_EraseRootFromParent_Done,
     /* 2046775 */   // Label 27252: @2046775
     /* 2046775 */   GIM_Try, /*On fail goto*//*Label 27253*/ GIMT_Encode4(2046866), // Rule ID 15113 //
     /* 2046780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2046791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2046794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2046797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2046800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046826 */     // MIs[0] round
     /* 2046826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046829 */     // MIs[0] policy
     /* 2046829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046839 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2046842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046865 */     // GIR_Coverage, 15113,
     /* 2046865 */     GIR_EraseRootFromParent_Done,
     /* 2046866 */   // Label 27253: @2046866
     /* 2046866 */   GIM_Try, /*On fail goto*//*Label 27254*/ GIMT_Encode4(2046957), // Rule ID 15116 //
     /* 2046871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2046882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2046885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2046888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2046891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046917 */     // MIs[0] round
     /* 2046917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046920 */     // MIs[0] policy
     /* 2046920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046930 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2046933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046956 */     // GIR_Coverage, 15116,
     /* 2046956 */     GIR_EraseRootFromParent_Done,
     /* 2046957 */   // Label 27254: @2046957
     /* 2046957 */   GIM_Try, /*On fail goto*//*Label 27255*/ GIMT_Encode4(2047048), // Rule ID 15117 //
     /* 2046962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2046973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2046976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2046979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2046982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047008 */     // MIs[0] round
     /* 2047008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047011 */     // MIs[0] policy
     /* 2047011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047021 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2047024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047047 */     // GIR_Coverage, 15117,
     /* 2047047 */     GIR_EraseRootFromParent_Done,
     /* 2047048 */   // Label 27255: @2047048
     /* 2047048 */   GIM_Try, /*On fail goto*//*Label 27256*/ GIMT_Encode4(2047139), // Rule ID 15120 //
     /* 2047053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2047064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2047067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2047070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2047073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047099 */     // MIs[0] round
     /* 2047099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047102 */     // MIs[0] policy
     /* 2047102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047112 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2047115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047138 */     // GIR_Coverage, 15120,
     /* 2047138 */     GIR_EraseRootFromParent_Done,
     /* 2047139 */   // Label 27256: @2047139
     /* 2047139 */   GIM_Try, /*On fail goto*//*Label 27257*/ GIMT_Encode4(2047230), // Rule ID 15121 //
     /* 2047144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2047155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2047158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2047161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2047164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047190 */     // MIs[0] round
     /* 2047190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047193 */     // MIs[0] policy
     /* 2047193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047203 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2047206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047229 */     // GIR_Coverage, 15121,
     /* 2047229 */     GIR_EraseRootFromParent_Done,
     /* 2047230 */   // Label 27257: @2047230
     /* 2047230 */   GIM_Try, /*On fail goto*//*Label 27258*/ GIMT_Encode4(2047321), // Rule ID 15124 //
     /* 2047235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2047246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2047249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2047252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2047255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047281 */     // MIs[0] round
     /* 2047281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047284 */     // MIs[0] policy
     /* 2047284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047294 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2047297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047320 */     // GIR_Coverage, 15124,
     /* 2047320 */     GIR_EraseRootFromParent_Done,
     /* 2047321 */   // Label 27258: @2047321
     /* 2047321 */   GIM_Try, /*On fail goto*//*Label 27259*/ GIMT_Encode4(2047412), // Rule ID 15125 //
     /* 2047326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2047337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2047340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2047343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2047346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047372 */     // MIs[0] round
     /* 2047372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047375 */     // MIs[0] policy
     /* 2047375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047385 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2047388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047411 */     // GIR_Coverage, 15125,
     /* 2047411 */     GIR_EraseRootFromParent_Done,
     /* 2047412 */   // Label 27259: @2047412
     /* 2047412 */   GIM_Try, /*On fail goto*//*Label 27260*/ GIMT_Encode4(2047503), // Rule ID 15128 //
     /* 2047417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2047428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2047431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2047434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2047437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047463 */     // MIs[0] round
     /* 2047463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047466 */     // MIs[0] policy
     /* 2047466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2047479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047502 */     // GIR_Coverage, 15128,
     /* 2047502 */     GIR_EraseRootFromParent_Done,
     /* 2047503 */   // Label 27260: @2047503
     /* 2047503 */   GIM_Try, /*On fail goto*//*Label 27261*/ GIMT_Encode4(2047594), // Rule ID 15129 //
     /* 2047508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2047519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2047522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2047525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2047528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047554 */     // MIs[0] round
     /* 2047554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047557 */     // MIs[0] policy
     /* 2047557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047567 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2047570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047593 */     // GIR_Coverage, 15129,
     /* 2047593 */     GIR_EraseRootFromParent_Done,
     /* 2047594 */   // Label 27261: @2047594
     /* 2047594 */   GIM_Try, /*On fail goto*//*Label 27262*/ GIMT_Encode4(2047685), // Rule ID 15132 //
     /* 2047599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2047610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2047613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2047616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2047619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047645 */     // MIs[0] round
     /* 2047645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047648 */     // MIs[0] policy
     /* 2047648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2047661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047684 */     // GIR_Coverage, 15132,
     /* 2047684 */     GIR_EraseRootFromParent_Done,
     /* 2047685 */   // Label 27262: @2047685
     /* 2047685 */   GIM_Try, /*On fail goto*//*Label 27263*/ GIMT_Encode4(2047776), // Rule ID 15133 //
     /* 2047690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2047701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2047704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2047707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2047710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047736 */     // MIs[0] round
     /* 2047736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047739 */     // MIs[0] policy
     /* 2047739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047749 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2047752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047775 */     // GIR_Coverage, 15133,
     /* 2047775 */     GIR_EraseRootFromParent_Done,
     /* 2047776 */   // Label 27263: @2047776
     /* 2047776 */   GIM_Try, /*On fail goto*//*Label 27264*/ GIMT_Encode4(2047867), // Rule ID 15136 //
     /* 2047781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2047784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2047792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2047795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2047798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2047801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047827 */     // MIs[0] round
     /* 2047827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047830 */     // MIs[0] policy
     /* 2047830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047840 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2047843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2047863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047866 */     // GIR_Coverage, 15136,
     /* 2047866 */     GIR_EraseRootFromParent_Done,
     /* 2047867 */   // Label 27264: @2047867
     /* 2047867 */   GIM_Try, /*On fail goto*//*Label 27265*/ GIMT_Encode4(2047958), // Rule ID 15137 //
     /* 2047872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2047875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2047883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2047886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2047889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2047892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047918 */     // MIs[0] round
     /* 2047918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047921 */     // MIs[0] policy
     /* 2047921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047931 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2047934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2047954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047957 */     // GIR_Coverage, 15137,
     /* 2047957 */     GIR_EraseRootFromParent_Done,
     /* 2047958 */   // Label 27265: @2047958
     /* 2047958 */   GIM_Try, /*On fail goto*//*Label 27266*/ GIMT_Encode4(2048049), // Rule ID 15140 //
     /* 2047963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2047974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2047977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2047980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2047983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2047986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2047993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048009 */     // MIs[0] round
     /* 2048009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048012 */     // MIs[0] policy
     /* 2048012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048022 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2048025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048048 */     // GIR_Coverage, 15140,
     /* 2048048 */     GIR_EraseRootFromParent_Done,
     /* 2048049 */   // Label 27266: @2048049
     /* 2048049 */   GIM_Try, /*On fail goto*//*Label 27267*/ GIMT_Encode4(2048140), // Rule ID 15141 //
     /* 2048054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2048065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2048068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2048071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2048074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048100 */     // MIs[0] round
     /* 2048100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048103 */     // MIs[0] policy
     /* 2048103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048113 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2048116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048139 */     // GIR_Coverage, 15141,
     /* 2048139 */     GIR_EraseRootFromParent_Done,
     /* 2048140 */   // Label 27267: @2048140
     /* 2048140 */   GIM_Try, /*On fail goto*//*Label 27268*/ GIMT_Encode4(2048231), // Rule ID 15144 //
     /* 2048145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2048156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2048159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2048162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2048165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2048168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048191 */     // MIs[0] round
     /* 2048191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048194 */     // MIs[0] policy
     /* 2048194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048204 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2048207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048230 */     // GIR_Coverage, 15144,
     /* 2048230 */     GIR_EraseRootFromParent_Done,
     /* 2048231 */   // Label 27268: @2048231
     /* 2048231 */   GIM_Try, /*On fail goto*//*Label 27269*/ GIMT_Encode4(2048322), // Rule ID 15145 //
     /* 2048236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2048247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2048250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2048253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2048256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2048259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048282 */     // MIs[0] round
     /* 2048282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048285 */     // MIs[0] policy
     /* 2048285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048295 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2048298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048321 */     // GIR_Coverage, 15145,
     /* 2048321 */     GIR_EraseRootFromParent_Done,
     /* 2048322 */   // Label 27269: @2048322
     /* 2048322 */   GIM_Try, /*On fail goto*//*Label 27270*/ GIMT_Encode4(2048413), // Rule ID 15148 //
     /* 2048327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2048338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2048341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2048344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2048347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2048350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2048357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048373 */     // MIs[0] round
     /* 2048373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048376 */     // MIs[0] policy
     /* 2048376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048386 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2048389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048412 */     // GIR_Coverage, 15148,
     /* 2048412 */     GIR_EraseRootFromParent_Done,
     /* 2048413 */   // Label 27270: @2048413
     /* 2048413 */   GIM_Try, /*On fail goto*//*Label 27271*/ GIMT_Encode4(2048504), // Rule ID 15149 //
     /* 2048418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2048429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2048432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2048435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2048438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2048441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2048448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048464 */     // MIs[0] round
     /* 2048464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048467 */     // MIs[0] policy
     /* 2048467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048477 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2048480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048503 */     // GIR_Coverage, 15149,
     /* 2048503 */     GIR_EraseRootFromParent_Done,
     /* 2048504 */   // Label 27271: @2048504
     /* 2048504 */   GIM_Try, /*On fail goto*//*Label 27272*/ GIMT_Encode4(2048595), // Rule ID 15152 //
     /* 2048509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2048520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2048523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2048526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2048529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2048532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048555 */     // MIs[0] round
     /* 2048555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048558 */     // MIs[0] policy
     /* 2048558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2048571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048594 */     // GIR_Coverage, 15152,
     /* 2048594 */     GIR_EraseRootFromParent_Done,
     /* 2048595 */   // Label 27272: @2048595
     /* 2048595 */   GIM_Try, /*On fail goto*//*Label 27273*/ GIMT_Encode4(2048686), // Rule ID 15153 //
     /* 2048600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2048611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2048614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2048617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2048620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2048623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048646 */     // MIs[0] round
     /* 2048646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048649 */     // MIs[0] policy
     /* 2048649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048659 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2048662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048685 */     // GIR_Coverage, 15153,
     /* 2048685 */     GIR_EraseRootFromParent_Done,
     /* 2048686 */   // Label 27273: @2048686
     /* 2048686 */   GIM_Try, /*On fail goto*//*Label 27274*/ GIMT_Encode4(2048777), // Rule ID 15156 //
     /* 2048691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2048702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2048705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2048708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2048711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048737 */     // MIs[0] round
     /* 2048737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048740 */     // MIs[0] policy
     /* 2048740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048750 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2048753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048776 */     // GIR_Coverage, 15156,
     /* 2048776 */     GIR_EraseRootFromParent_Done,
     /* 2048777 */   // Label 27274: @2048777
     /* 2048777 */   GIM_Try, /*On fail goto*//*Label 27275*/ GIMT_Encode4(2048868), // Rule ID 15157 //
     /* 2048782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2048793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2048796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2048799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2048802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048828 */     // MIs[0] round
     /* 2048828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048831 */     // MIs[0] policy
     /* 2048831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048841 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2048844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048867 */     // GIR_Coverage, 15157,
     /* 2048867 */     GIR_EraseRootFromParent_Done,
     /* 2048868 */   // Label 27275: @2048868
     /* 2048868 */   GIM_Try, /*On fail goto*//*Label 27276*/ GIMT_Encode4(2048959), // Rule ID 15160 //
     /* 2048873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2048884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2048887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2048890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2048893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2048896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2048903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048919 */     // MIs[0] round
     /* 2048919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048922 */     // MIs[0] policy
     /* 2048922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048932 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2048935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048958 */     // GIR_Coverage, 15160,
     /* 2048958 */     GIR_EraseRootFromParent_Done,
     /* 2048959 */   // Label 27276: @2048959
     /* 2048959 */   GIM_Try, /*On fail goto*//*Label 27277*/ GIMT_Encode4(2049050), // Rule ID 15161 //
     /* 2048964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2048975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2048978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2048981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2048984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2048987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2048994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049010 */     // MIs[0] round
     /* 2049010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049013 */     // MIs[0] policy
     /* 2049013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049023 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2049026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049049 */     // GIR_Coverage, 15161,
     /* 2049049 */     GIR_EraseRootFromParent_Done,
     /* 2049050 */   // Label 27277: @2049050
     /* 2049050 */   GIM_Try, /*On fail goto*//*Label 27278*/ GIMT_Encode4(2049141), // Rule ID 15164 //
     /* 2049055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2049066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2049069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2049072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2049075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049101 */     // MIs[0] round
     /* 2049101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049104 */     // MIs[0] policy
     /* 2049104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049114 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2049117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049140 */     // GIR_Coverage, 15164,
     /* 2049140 */     GIR_EraseRootFromParent_Done,
     /* 2049141 */   // Label 27278: @2049141
     /* 2049141 */   GIM_Try, /*On fail goto*//*Label 27279*/ GIMT_Encode4(2049232), // Rule ID 15165 //
     /* 2049146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2049157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2049160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2049163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2049166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049192 */     // MIs[0] round
     /* 2049192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049195 */     // MIs[0] policy
     /* 2049195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049205 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2049208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049231 */     // GIR_Coverage, 15165,
     /* 2049231 */     GIR_EraseRootFromParent_Done,
     /* 2049232 */   // Label 27279: @2049232
     /* 2049232 */   GIM_Try, /*On fail goto*//*Label 27280*/ GIMT_Encode4(2049323), // Rule ID 15168 //
     /* 2049237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2049248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2049251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2049254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2049257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049283 */     // MIs[0] round
     /* 2049283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049286 */     // MIs[0] policy
     /* 2049286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049296 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2049299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049322 */     // GIR_Coverage, 15168,
     /* 2049322 */     GIR_EraseRootFromParent_Done,
     /* 2049323 */   // Label 27280: @2049323
     /* 2049323 */   GIM_Try, /*On fail goto*//*Label 27281*/ GIMT_Encode4(2049414), // Rule ID 15169 //
     /* 2049328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2049339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2049342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2049345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2049348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049374 */     // MIs[0] round
     /* 2049374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049377 */     // MIs[0] policy
     /* 2049377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049387 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2049390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049413 */     // GIR_Coverage, 15169,
     /* 2049413 */     GIR_EraseRootFromParent_Done,
     /* 2049414 */   // Label 27281: @2049414
     /* 2049414 */   GIM_Try, /*On fail goto*//*Label 27282*/ GIMT_Encode4(2049505), // Rule ID 15172 //
     /* 2049419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2049430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2049433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2049436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2049439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049465 */     // MIs[0] round
     /* 2049465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049468 */     // MIs[0] policy
     /* 2049468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2049481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049504 */     // GIR_Coverage, 15172,
     /* 2049504 */     GIR_EraseRootFromParent_Done,
     /* 2049505 */   // Label 27282: @2049505
     /* 2049505 */   GIM_Try, /*On fail goto*//*Label 27283*/ GIMT_Encode4(2049596), // Rule ID 15173 //
     /* 2049510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2049521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2049524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2049527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2049530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049556 */     // MIs[0] round
     /* 2049556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049559 */     // MIs[0] policy
     /* 2049559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049569 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2049572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049595 */     // GIR_Coverage, 15173,
     /* 2049595 */     GIR_EraseRootFromParent_Done,
     /* 2049596 */   // Label 27283: @2049596
     /* 2049596 */   GIM_Try, /*On fail goto*//*Label 27284*/ GIMT_Encode4(2049687), // Rule ID 15176 //
     /* 2049601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2049604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2049612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2049615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2049618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2049621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2049624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049647 */     // MIs[0] round
     /* 2049647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049650 */     // MIs[0] policy
     /* 2049650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2049663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2049683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049686 */     // GIR_Coverage, 15176,
     /* 2049686 */     GIR_EraseRootFromParent_Done,
     /* 2049687 */   // Label 27284: @2049687
     /* 2049687 */   GIM_Try, /*On fail goto*//*Label 27285*/ GIMT_Encode4(2049778), // Rule ID 15177 //
     /* 2049692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2049695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2049703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2049706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2049709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2049712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2049715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049738 */     // MIs[0] round
     /* 2049738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049741 */     // MIs[0] policy
     /* 2049741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049751 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2049754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2049774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049777 */     // GIR_Coverage, 15177,
     /* 2049777 */     GIR_EraseRootFromParent_Done,
     /* 2049778 */   // Label 27285: @2049778
     /* 2049778 */   GIM_Try, /*On fail goto*//*Label 27286*/ GIMT_Encode4(2049869), // Rule ID 15180 //
     /* 2049783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2049786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2049794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2049797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2049800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2049803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049829 */     // MIs[0] round
     /* 2049829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049832 */     // MIs[0] policy
     /* 2049832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049842 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2049845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2049865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049868 */     // GIR_Coverage, 15180,
     /* 2049868 */     GIR_EraseRootFromParent_Done,
     /* 2049869 */   // Label 27286: @2049869
     /* 2049869 */   GIM_Try, /*On fail goto*//*Label 27287*/ GIMT_Encode4(2049960), // Rule ID 15181 //
     /* 2049874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2049877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2049885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2049888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2049891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2049894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049920 */     // MIs[0] round
     /* 2049920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049923 */     // MIs[0] policy
     /* 2049923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049933 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2049936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2049956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049959 */     // GIR_Coverage, 15181,
     /* 2049959 */     GIR_EraseRootFromParent_Done,
     /* 2049960 */   // Label 27287: @2049960
     /* 2049960 */   GIM_Try, /*On fail goto*//*Label 27288*/ GIMT_Encode4(2050051), // Rule ID 15184 //
     /* 2049965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2049968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2049976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2049979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2049982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2049985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050011 */     // MIs[0] round
     /* 2050011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050014 */     // MIs[0] policy
     /* 2050014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050024 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2050027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050050 */     // GIR_Coverage, 15184,
     /* 2050050 */     GIR_EraseRootFromParent_Done,
     /* 2050051 */   // Label 27288: @2050051
     /* 2050051 */   GIM_Try, /*On fail goto*//*Label 27289*/ GIMT_Encode4(2050142), // Rule ID 15185 //
     /* 2050056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2050067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2050070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2050073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2050076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050102 */     // MIs[0] round
     /* 2050102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050105 */     // MIs[0] policy
     /* 2050105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050115 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2050118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050141 */     // GIR_Coverage, 15185,
     /* 2050141 */     GIR_EraseRootFromParent_Done,
     /* 2050142 */   // Label 27289: @2050142
     /* 2050142 */   GIM_Try, /*On fail goto*//*Label 27290*/ GIMT_Encode4(2050233), // Rule ID 15188 //
     /* 2050147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2050158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2050161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2050164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050193 */     // MIs[0] round
     /* 2050193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050196 */     // MIs[0] policy
     /* 2050196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050206 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2050209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050232 */     // GIR_Coverage, 15188,
     /* 2050232 */     GIR_EraseRootFromParent_Done,
     /* 2050233 */   // Label 27290: @2050233
     /* 2050233 */   GIM_Try, /*On fail goto*//*Label 27291*/ GIMT_Encode4(2050324), // Rule ID 15189 //
     /* 2050238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2050249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2050252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2050255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050284 */     // MIs[0] round
     /* 2050284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050287 */     // MIs[0] policy
     /* 2050287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050297 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2050300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050323 */     // GIR_Coverage, 15189,
     /* 2050323 */     GIR_EraseRootFromParent_Done,
     /* 2050324 */   // Label 27291: @2050324
     /* 2050324 */   GIM_Try, /*On fail goto*//*Label 27292*/ GIMT_Encode4(2050415), // Rule ID 15192 //
     /* 2050329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2050340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2050343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2050346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050375 */     // MIs[0] round
     /* 2050375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050378 */     // MIs[0] policy
     /* 2050378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050388 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2050391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050414 */     // GIR_Coverage, 15192,
     /* 2050414 */     GIR_EraseRootFromParent_Done,
     /* 2050415 */   // Label 27292: @2050415
     /* 2050415 */   GIM_Try, /*On fail goto*//*Label 27293*/ GIMT_Encode4(2050506), // Rule ID 15193 //
     /* 2050420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2050431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2050434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2050437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050466 */     // MIs[0] round
     /* 2050466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050469 */     // MIs[0] policy
     /* 2050469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050479 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2050482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050505 */     // GIR_Coverage, 15193,
     /* 2050505 */     GIR_EraseRootFromParent_Done,
     /* 2050506 */   // Label 27293: @2050506
     /* 2050506 */   GIM_Try, /*On fail goto*//*Label 27294*/ GIMT_Encode4(2050597), // Rule ID 15196 //
     /* 2050511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2050522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2050525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2050528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050557 */     // MIs[0] round
     /* 2050557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050560 */     // MIs[0] policy
     /* 2050560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050570 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2050573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050596 */     // GIR_Coverage, 15196,
     /* 2050596 */     GIR_EraseRootFromParent_Done,
     /* 2050597 */   // Label 27294: @2050597
     /* 2050597 */   GIM_Try, /*On fail goto*//*Label 27295*/ GIMT_Encode4(2050688), // Rule ID 15197 //
     /* 2050602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2050613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2050616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2050619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050648 */     // MIs[0] round
     /* 2050648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050651 */     // MIs[0] policy
     /* 2050651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050661 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2050664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050687 */     // GIR_Coverage, 15197,
     /* 2050687 */     GIR_EraseRootFromParent_Done,
     /* 2050688 */   // Label 27295: @2050688
     /* 2050688 */   GIM_Try, /*On fail goto*//*Label 27296*/ GIMT_Encode4(2050779), // Rule ID 15200 //
     /* 2050693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2050704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2050707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2050710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050739 */     // MIs[0] round
     /* 2050739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050742 */     // MIs[0] policy
     /* 2050742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050752 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2050755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2050775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050778 */     // GIR_Coverage, 15200,
     /* 2050778 */     GIR_EraseRootFromParent_Done,
     /* 2050779 */   // Label 27296: @2050779
     /* 2050779 */   GIM_Try, /*On fail goto*//*Label 27297*/ GIMT_Encode4(2050870), // Rule ID 15201 //
     /* 2050784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2050795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2050798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2050801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050830 */     // MIs[0] round
     /* 2050830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050833 */     // MIs[0] policy
     /* 2050833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2050846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2050866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050869 */     // GIR_Coverage, 15201,
     /* 2050869 */     GIR_EraseRootFromParent_Done,
     /* 2050870 */   // Label 27297: @2050870
     /* 2050870 */   GIM_Try, /*On fail goto*//*Label 27298*/ GIMT_Encode4(2050961), // Rule ID 15204 //
     /* 2050875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2050886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2050889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2050892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050921 */     // MIs[0] round
     /* 2050921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050924 */     // MIs[0] policy
     /* 2050924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050934 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2050937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2050957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050960 */     // GIR_Coverage, 15204,
     /* 2050960 */     GIR_EraseRootFromParent_Done,
     /* 2050961 */   // Label 27298: @2050961
     /* 2050961 */   GIM_Try, /*On fail goto*//*Label 27299*/ GIMT_Encode4(2051052), // Rule ID 15205 //
     /* 2050966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2050977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2050980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2050983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051012 */     // MIs[0] round
     /* 2051012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051015 */     // MIs[0] policy
     /* 2051015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051025 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2051028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051051 */     // GIR_Coverage, 15205,
     /* 2051051 */     GIR_EraseRootFromParent_Done,
     /* 2051052 */   // Label 27299: @2051052
     /* 2051052 */   GIM_Try, /*On fail goto*//*Label 27300*/ GIMT_Encode4(2051143), // Rule ID 15208 //
     /* 2051057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2051065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2051068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2051071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2051074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2051077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051103 */     // MIs[0] round
     /* 2051103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051106 */     // MIs[0] policy
     /* 2051106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051116 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2051119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051142 */     // GIR_Coverage, 15208,
     /* 2051142 */     GIR_EraseRootFromParent_Done,
     /* 2051143 */   // Label 27300: @2051143
     /* 2051143 */   GIM_Try, /*On fail goto*//*Label 27301*/ GIMT_Encode4(2051234), // Rule ID 15209 //
     /* 2051148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2051156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2051159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2051162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2051165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2051168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051194 */     // MIs[0] round
     /* 2051194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051197 */     // MIs[0] policy
     /* 2051197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051207 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2051210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051233 */     // GIR_Coverage, 15209,
     /* 2051233 */     GIR_EraseRootFromParent_Done,
     /* 2051234 */   // Label 27301: @2051234
     /* 2051234 */   GIM_Try, /*On fail goto*//*Label 27302*/ GIMT_Encode4(2051325), // Rule ID 15212 //
     /* 2051239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2051247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2051250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2051253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2051256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2051259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2051262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051285 */     // MIs[0] round
     /* 2051285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051288 */     // MIs[0] policy
     /* 2051288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051298 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2051301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051324 */     // GIR_Coverage, 15212,
     /* 2051324 */     GIR_EraseRootFromParent_Done,
     /* 2051325 */   // Label 27302: @2051325
     /* 2051325 */   GIM_Try, /*On fail goto*//*Label 27303*/ GIMT_Encode4(2051416), // Rule ID 15213 //
     /* 2051330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2051338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2051341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2051344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2051347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2051350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2051353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051376 */     // MIs[0] round
     /* 2051376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051379 */     // MIs[0] policy
     /* 2051379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051389 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2051392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051415 */     // GIR_Coverage, 15213,
     /* 2051415 */     GIR_EraseRootFromParent_Done,
     /* 2051416 */   // Label 27303: @2051416
     /* 2051416 */   GIM_Try, /*On fail goto*//*Label 27304*/ GIMT_Encode4(2051507), // Rule ID 15216 //
     /* 2051421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2051429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2051432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2051435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2051438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2051441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051467 */     // MIs[0] round
     /* 2051467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051470 */     // MIs[0] policy
     /* 2051470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051480 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2051483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051506 */     // GIR_Coverage, 15216,
     /* 2051506 */     GIR_EraseRootFromParent_Done,
     /* 2051507 */   // Label 27304: @2051507
     /* 2051507 */   GIM_Try, /*On fail goto*//*Label 27305*/ GIMT_Encode4(2051598), // Rule ID 15217 //
     /* 2051512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2051520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2051523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2051526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2051529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2051532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051558 */     // MIs[0] round
     /* 2051558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051561 */     // MIs[0] policy
     /* 2051561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051571 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2051574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051597 */     // GIR_Coverage, 15217,
     /* 2051597 */     GIR_EraseRootFromParent_Done,
     /* 2051598 */   // Label 27305: @2051598
     /* 2051598 */   GIM_Try, /*On fail goto*//*Label 27306*/ GIMT_Encode4(2051689), // Rule ID 15220 //
     /* 2051603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2051611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2051614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2051617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2051620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2051623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051649 */     // MIs[0] round
     /* 2051649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051652 */     // MIs[0] policy
     /* 2051652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051662 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2051665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051688 */     // GIR_Coverage, 15220,
     /* 2051688 */     GIR_EraseRootFromParent_Done,
     /* 2051689 */   // Label 27306: @2051689
     /* 2051689 */   GIM_Try, /*On fail goto*//*Label 27307*/ GIMT_Encode4(2051780), // Rule ID 15221 //
     /* 2051694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2051702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2051705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2051708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2051711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2051714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051740 */     // MIs[0] round
     /* 2051740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051743 */     // MIs[0] policy
     /* 2051743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051753 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2051756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051779 */     // GIR_Coverage, 15221,
     /* 2051779 */     GIR_EraseRootFromParent_Done,
     /* 2051780 */   // Label 27307: @2051780
     /* 2051780 */   GIM_Try, /*On fail goto*//*Label 27308*/ GIMT_Encode4(2051871), // Rule ID 15224 //
     /* 2051785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2051788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2051793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2051796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2051799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2051802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2051805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051831 */     // MIs[0] round
     /* 2051831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051834 */     // MIs[0] policy
     /* 2051834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051844 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2051847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2051867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051870 */     // GIR_Coverage, 15224,
     /* 2051870 */     GIR_EraseRootFromParent_Done,
     /* 2051871 */   // Label 27308: @2051871
     /* 2051871 */   GIM_Try, /*On fail goto*//*Label 27309*/ GIMT_Encode4(2051962), // Rule ID 15225 //
     /* 2051876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2051879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2051884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2051887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2051890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2051893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2051896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051922 */     // MIs[0] round
     /* 2051922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051925 */     // MIs[0] policy
     /* 2051925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051935 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2051938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2051958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051961 */     // GIR_Coverage, 15225,
     /* 2051961 */     GIR_EraseRootFromParent_Done,
     /* 2051962 */   // Label 27309: @2051962
     /* 2051962 */   GIM_Try, /*On fail goto*//*Label 27310*/ GIMT_Encode4(2052053), // Rule ID 15228 //
     /* 2051967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2051975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2051978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2051981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2051984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2051987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2051990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2051997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052013 */     // MIs[0] round
     /* 2052013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052016 */     // MIs[0] policy
     /* 2052016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2052029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052052 */     // GIR_Coverage, 15228,
     /* 2052052 */     GIR_EraseRootFromParent_Done,
     /* 2052053 */   // Label 27310: @2052053
     /* 2052053 */   GIM_Try, /*On fail goto*//*Label 27311*/ GIMT_Encode4(2052144), // Rule ID 15229 //
     /* 2052058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2052066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2052069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2052072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2052075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2052078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052104 */     // MIs[0] round
     /* 2052104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052107 */     // MIs[0] policy
     /* 2052107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052117 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2052120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052143 */     // GIR_Coverage, 15229,
     /* 2052143 */     GIR_EraseRootFromParent_Done,
     /* 2052144 */   // Label 27311: @2052144
     /* 2052144 */   GIM_Try, /*On fail goto*//*Label 27312*/ GIMT_Encode4(2052235), // Rule ID 15232 //
     /* 2052149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2052157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2052160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2052163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2052166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2052169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052195 */     // MIs[0] round
     /* 2052195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052198 */     // MIs[0] policy
     /* 2052198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052208 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2052211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052234 */     // GIR_Coverage, 15232,
     /* 2052234 */     GIR_EraseRootFromParent_Done,
     /* 2052235 */   // Label 27312: @2052235
     /* 2052235 */   GIM_Try, /*On fail goto*//*Label 27313*/ GIMT_Encode4(2052326), // Rule ID 15233 //
     /* 2052240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2052248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2052251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2052254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2052257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2052260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052286 */     // MIs[0] round
     /* 2052286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052289 */     // MIs[0] policy
     /* 2052289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052299 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2052302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052325 */     // GIR_Coverage, 15233,
     /* 2052325 */     GIR_EraseRootFromParent_Done,
     /* 2052326 */   // Label 27313: @2052326
     /* 2052326 */   GIM_Try, /*On fail goto*//*Label 27314*/ GIMT_Encode4(2052417), // Rule ID 15236 //
     /* 2052331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2052339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2052342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2052345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2052348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2052351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2052354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2052361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052377 */     // MIs[0] round
     /* 2052377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052380 */     // MIs[0] policy
     /* 2052380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052390 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2052393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052416 */     // GIR_Coverage, 15236,
     /* 2052416 */     GIR_EraseRootFromParent_Done,
     /* 2052417 */   // Label 27314: @2052417
     /* 2052417 */   GIM_Try, /*On fail goto*//*Label 27315*/ GIMT_Encode4(2052508), // Rule ID 15237 //
     /* 2052422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2052430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2052433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2052436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2052439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2052442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2052445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2052452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052468 */     // MIs[0] round
     /* 2052468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052471 */     // MIs[0] policy
     /* 2052471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052481 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2052484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052507 */     // GIR_Coverage, 15237,
     /* 2052507 */     GIR_EraseRootFromParent_Done,
     /* 2052508 */   // Label 27315: @2052508
     /* 2052508 */   GIM_Try, /*On fail goto*//*Label 27316*/ GIMT_Encode4(2052599), // Rule ID 15240 //
     /* 2052513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2052521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2052524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2052527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2052530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2052533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052559 */     // MIs[0] round
     /* 2052559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052562 */     // MIs[0] policy
     /* 2052562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052572 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2052575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052598 */     // GIR_Coverage, 15240,
     /* 2052598 */     GIR_EraseRootFromParent_Done,
     /* 2052599 */   // Label 27316: @2052599
     /* 2052599 */   GIM_Try, /*On fail goto*//*Label 27317*/ GIMT_Encode4(2052690), // Rule ID 15241 //
     /* 2052604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2052612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2052615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2052618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2052621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2052624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052650 */     // MIs[0] round
     /* 2052650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052653 */     // MIs[0] policy
     /* 2052653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052663 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2052666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052689 */     // GIR_Coverage, 15241,
     /* 2052689 */     GIR_EraseRootFromParent_Done,
     /* 2052690 */   // Label 27317: @2052690
     /* 2052690 */   GIM_Try, /*On fail goto*//*Label 27318*/ GIMT_Encode4(2052781), // Rule ID 15244 //
     /* 2052695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2052703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2052706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2052709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2052712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2052715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052741 */     // MIs[0] round
     /* 2052741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052744 */     // MIs[0] policy
     /* 2052744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052754 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2052757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052780 */     // GIR_Coverage, 15244,
     /* 2052780 */     GIR_EraseRootFromParent_Done,
     /* 2052781 */   // Label 27318: @2052781
     /* 2052781 */   GIM_Try, /*On fail goto*//*Label 27319*/ GIMT_Encode4(2052872), // Rule ID 15245 //
     /* 2052786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2052794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2052797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2052800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2052803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2052806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052832 */     // MIs[0] round
     /* 2052832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052835 */     // MIs[0] policy
     /* 2052835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052845 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2052848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052871 */     // GIR_Coverage, 15245,
     /* 2052871 */     GIR_EraseRootFromParent_Done,
     /* 2052872 */   // Label 27319: @2052872
     /* 2052872 */   GIM_Try, /*On fail goto*//*Label 27320*/ GIMT_Encode4(2052963), // Rule ID 15248 //
     /* 2052877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2052885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2052888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2052891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2052894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2052897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2052907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052923 */     // MIs[0] round
     /* 2052923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052926 */     // MIs[0] policy
     /* 2052926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052936 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2052939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052962 */     // GIR_Coverage, 15248,
     /* 2052962 */     GIR_EraseRootFromParent_Done,
     /* 2052963 */   // Label 27320: @2052963
     /* 2052963 */   GIM_Try, /*On fail goto*//*Label 27321*/ GIMT_Encode4(2053054), // Rule ID 15249 //
     /* 2052968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2052976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2052979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2052982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2052985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2052988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2052998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053014 */     // MIs[0] round
     /* 2053014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053017 */     // MIs[0] policy
     /* 2053017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053027 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2053030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053053 */     // GIR_Coverage, 15249,
     /* 2053053 */     GIR_EraseRootFromParent_Done,
     /* 2053054 */   // Label 27321: @2053054
     /* 2053054 */   GIM_Try, /*On fail goto*//*Label 27322*/ GIMT_Encode4(2053145), // Rule ID 15252 //
     /* 2053059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2053067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2053070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2053073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2053076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2053079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053105 */     // MIs[0] round
     /* 2053105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053108 */     // MIs[0] policy
     /* 2053108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2053121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053144 */     // GIR_Coverage, 15252,
     /* 2053144 */     GIR_EraseRootFromParent_Done,
     /* 2053145 */   // Label 27322: @2053145
     /* 2053145 */   GIM_Try, /*On fail goto*//*Label 27323*/ GIMT_Encode4(2053236), // Rule ID 15253 //
     /* 2053150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2053158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2053161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2053164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2053167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2053170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053196 */     // MIs[0] round
     /* 2053196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053199 */     // MIs[0] policy
     /* 2053199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053209 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2053212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053235 */     // GIR_Coverage, 15253,
     /* 2053235 */     GIR_EraseRootFromParent_Done,
     /* 2053236 */   // Label 27323: @2053236
     /* 2053236 */   GIM_Try, /*On fail goto*//*Label 27324*/ GIMT_Encode4(2053327), // Rule ID 15256 //
     /* 2053241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2053249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2053252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2053255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2053258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2053261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053287 */     // MIs[0] round
     /* 2053287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053290 */     // MIs[0] policy
     /* 2053290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053300 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2053303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053326 */     // GIR_Coverage, 15256,
     /* 2053326 */     GIR_EraseRootFromParent_Done,
     /* 2053327 */   // Label 27324: @2053327
     /* 2053327 */   GIM_Try, /*On fail goto*//*Label 27325*/ GIMT_Encode4(2053418), // Rule ID 15257 //
     /* 2053332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2053340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2053343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2053346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2053349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2053352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053378 */     // MIs[0] round
     /* 2053378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053381 */     // MIs[0] policy
     /* 2053381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053391 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2053394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053417 */     // GIR_Coverage, 15257,
     /* 2053417 */     GIR_EraseRootFromParent_Done,
     /* 2053418 */   // Label 27325: @2053418
     /* 2053418 */   GIM_Try, /*On fail goto*//*Label 27326*/ GIMT_Encode4(2053509), // Rule ID 15260 //
     /* 2053423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2053431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2053434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2053437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2053440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2053443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053469 */     // MIs[0] round
     /* 2053469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053472 */     // MIs[0] policy
     /* 2053472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053482 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2053485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053508 */     // GIR_Coverage, 15260,
     /* 2053508 */     GIR_EraseRootFromParent_Done,
     /* 2053509 */   // Label 27326: @2053509
     /* 2053509 */   GIM_Try, /*On fail goto*//*Label 27327*/ GIMT_Encode4(2053600), // Rule ID 15261 //
     /* 2053514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2053522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2053525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2053528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2053531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2053534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053560 */     // MIs[0] round
     /* 2053560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053563 */     // MIs[0] policy
     /* 2053563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053573 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2053576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053599 */     // GIR_Coverage, 15261,
     /* 2053599 */     GIR_EraseRootFromParent_Done,
     /* 2053600 */   // Label 27327: @2053600
     /* 2053600 */   GIM_Try, /*On fail goto*//*Label 27328*/ GIMT_Encode4(2053691), // Rule ID 15264 //
     /* 2053605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2053608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2053613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2053616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2053619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2053622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2053625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2053628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053651 */     // MIs[0] round
     /* 2053651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053654 */     // MIs[0] policy
     /* 2053654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053664 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2053667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053690 */     // GIR_Coverage, 15264,
     /* 2053690 */     GIR_EraseRootFromParent_Done,
     /* 2053691 */   // Label 27328: @2053691
     /* 2053691 */   GIM_Try, /*On fail goto*//*Label 27329*/ GIMT_Encode4(2053782), // Rule ID 15265 //
     /* 2053696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2053699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2053704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2053707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2053710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2053713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2053716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2053719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053742 */     // MIs[0] round
     /* 2053742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053745 */     // MIs[0] policy
     /* 2053745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053755 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2053758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053781 */     // GIR_Coverage, 15265,
     /* 2053781 */     GIR_EraseRootFromParent_Done,
     /* 2053782 */   // Label 27329: @2053782
     /* 2053782 */   GIM_Try, /*On fail goto*//*Label 27330*/ GIMT_Encode4(2053873), // Rule ID 15268 //
     /* 2053787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2053790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2053795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2053798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2053801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2053804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2053807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053833 */     // MIs[0] round
     /* 2053833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053836 */     // MIs[0] policy
     /* 2053836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053846 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2053849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053872 */     // GIR_Coverage, 15268,
     /* 2053872 */     GIR_EraseRootFromParent_Done,
     /* 2053873 */   // Label 27330: @2053873
     /* 2053873 */   GIM_Try, /*On fail goto*//*Label 27331*/ GIMT_Encode4(2053964), // Rule ID 15269 //
     /* 2053878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2053881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2053886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2053889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2053892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2053895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2053898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053924 */     // MIs[0] round
     /* 2053924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053927 */     // MIs[0] policy
     /* 2053927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053937 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2053940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053963 */     // GIR_Coverage, 15269,
     /* 2053963 */     GIR_EraseRootFromParent_Done,
     /* 2053964 */   // Label 27331: @2053964
     /* 2053964 */   GIM_Try, /*On fail goto*//*Label 27332*/ GIMT_Encode4(2054055), // Rule ID 15272 //
     /* 2053969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2053972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2053977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2053980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2053983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2053986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2053989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054015 */     // MIs[0] round
     /* 2054015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054018 */     // MIs[0] policy
     /* 2054018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054028 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2054031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054054 */     // GIR_Coverage, 15272,
     /* 2054054 */     GIR_EraseRootFromParent_Done,
     /* 2054055 */   // Label 27332: @2054055
     /* 2054055 */   GIM_Try, /*On fail goto*//*Label 27333*/ GIMT_Encode4(2054146), // Rule ID 15273 //
     /* 2054060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2054068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2054071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2054074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2054077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054106 */     // MIs[0] round
     /* 2054106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054109 */     // MIs[0] policy
     /* 2054109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054119 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2054122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054145 */     // GIR_Coverage, 15273,
     /* 2054145 */     GIR_EraseRootFromParent_Done,
     /* 2054146 */   // Label 27333: @2054146
     /* 2054146 */   GIM_Try, /*On fail goto*//*Label 27334*/ GIMT_Encode4(2054237), // Rule ID 15276 //
     /* 2054151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2054162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2054165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2054168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2054171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054197 */     // MIs[0] round
     /* 2054197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054200 */     // MIs[0] policy
     /* 2054200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054210 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2054213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054236 */     // GIR_Coverage, 15276,
     /* 2054236 */     GIR_EraseRootFromParent_Done,
     /* 2054237 */   // Label 27334: @2054237
     /* 2054237 */   GIM_Try, /*On fail goto*//*Label 27335*/ GIMT_Encode4(2054328), // Rule ID 15277 //
     /* 2054242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2054253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2054256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2054259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2054262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054288 */     // MIs[0] round
     /* 2054288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054291 */     // MIs[0] policy
     /* 2054291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054301 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2054304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054327 */     // GIR_Coverage, 15277,
     /* 2054327 */     GIR_EraseRootFromParent_Done,
     /* 2054328 */   // Label 27335: @2054328
     /* 2054328 */   GIM_Try, /*On fail goto*//*Label 27336*/ GIMT_Encode4(2054419), // Rule ID 15280 //
     /* 2054333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2054344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2054347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2054350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2054353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054379 */     // MIs[0] round
     /* 2054379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054382 */     // MIs[0] policy
     /* 2054382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054392 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2054395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054418 */     // GIR_Coverage, 15280,
     /* 2054418 */     GIR_EraseRootFromParent_Done,
     /* 2054419 */   // Label 27336: @2054419
     /* 2054419 */   GIM_Try, /*On fail goto*//*Label 27337*/ GIMT_Encode4(2054510), // Rule ID 15281 //
     /* 2054424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2054435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2054438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2054441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2054444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054470 */     // MIs[0] round
     /* 2054470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054473 */     // MIs[0] policy
     /* 2054473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054483 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2054486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054509 */     // GIR_Coverage, 15281,
     /* 2054509 */     GIR_EraseRootFromParent_Done,
     /* 2054510 */   // Label 27337: @2054510
     /* 2054510 */   GIM_Try, /*On fail goto*//*Label 27338*/ GIMT_Encode4(2054601), // Rule ID 15284 //
     /* 2054515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2054526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2054529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2054532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2054535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054561 */     // MIs[0] round
     /* 2054561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054564 */     // MIs[0] policy
     /* 2054564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054574 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2054577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054600 */     // GIR_Coverage, 15284,
     /* 2054600 */     GIR_EraseRootFromParent_Done,
     /* 2054601 */   // Label 27338: @2054601
     /* 2054601 */   GIM_Try, /*On fail goto*//*Label 27339*/ GIMT_Encode4(2054692), // Rule ID 15285 //
     /* 2054606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2054617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2054620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2054623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2054626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054652 */     // MIs[0] round
     /* 2054652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054655 */     // MIs[0] policy
     /* 2054655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054665 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2054668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054691 */     // GIR_Coverage, 15285,
     /* 2054691 */     GIR_EraseRootFromParent_Done,
     /* 2054692 */   // Label 27339: @2054692
     /* 2054692 */   GIM_Try, /*On fail goto*//*Label 27340*/ GIMT_Encode4(2054783), // Rule ID 15288 //
     /* 2054697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2054708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2054711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2054714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2054717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054743 */     // MIs[0] round
     /* 2054743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054746 */     // MIs[0] policy
     /* 2054746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054756 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2054759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054782 */     // GIR_Coverage, 15288,
     /* 2054782 */     GIR_EraseRootFromParent_Done,
     /* 2054783 */   // Label 27340: @2054783
     /* 2054783 */   GIM_Try, /*On fail goto*//*Label 27341*/ GIMT_Encode4(2054874), // Rule ID 15289 //
     /* 2054788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2054799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2054802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2054805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2054808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054834 */     // MIs[0] round
     /* 2054834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054837 */     // MIs[0] policy
     /* 2054837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054847 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2054850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054873 */     // GIR_Coverage, 15289,
     /* 2054873 */     GIR_EraseRootFromParent_Done,
     /* 2054874 */   // Label 27341: @2054874
     /* 2054874 */   GIM_Try, /*On fail goto*//*Label 27342*/ GIMT_Encode4(2054965), // Rule ID 15292 //
     /* 2054879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2054890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2054893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2054896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2054899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054925 */     // MIs[0] round
     /* 2054925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054928 */     // MIs[0] policy
     /* 2054928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054938 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2054941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054964 */     // GIR_Coverage, 15292,
     /* 2054964 */     GIR_EraseRootFromParent_Done,
     /* 2054965 */   // Label 27342: @2054965
     /* 2054965 */   GIM_Try, /*On fail goto*//*Label 27343*/ GIMT_Encode4(2055056), // Rule ID 15293 //
     /* 2054970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2054981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2054984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2054987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2054990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055016 */     // MIs[0] round
     /* 2055016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055019 */     // MIs[0] policy
     /* 2055019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055029 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2055032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055055 */     // GIR_Coverage, 15293,
     /* 2055055 */     GIR_EraseRootFromParent_Done,
     /* 2055056 */   // Label 27343: @2055056
     /* 2055056 */   GIM_Try, /*On fail goto*//*Label 27344*/ GIMT_Encode4(2055147), // Rule ID 15296 //
     /* 2055061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2055072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2055075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2055078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2055081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055107 */     // MIs[0] round
     /* 2055107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055110 */     // MIs[0] policy
     /* 2055110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055120 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2055123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055146 */     // GIR_Coverage, 15296,
     /* 2055146 */     GIR_EraseRootFromParent_Done,
     /* 2055147 */   // Label 27344: @2055147
     /* 2055147 */   GIM_Try, /*On fail goto*//*Label 27345*/ GIMT_Encode4(2055238), // Rule ID 15297 //
     /* 2055152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2055163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2055166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2055169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2055172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055198 */     // MIs[0] round
     /* 2055198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055201 */     // MIs[0] policy
     /* 2055201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055211 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2055214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055237 */     // GIR_Coverage, 15297,
     /* 2055237 */     GIR_EraseRootFromParent_Done,
     /* 2055238 */   // Label 27345: @2055238
     /* 2055238 */   GIM_Try, /*On fail goto*//*Label 27346*/ GIMT_Encode4(2055329), // Rule ID 15300 //
     /* 2055243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2055254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2055257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2055260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2055263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055289 */     // MIs[0] round
     /* 2055289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055292 */     // MIs[0] policy
     /* 2055292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2055305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055328 */     // GIR_Coverage, 15300,
     /* 2055328 */     GIR_EraseRootFromParent_Done,
     /* 2055329 */   // Label 27346: @2055329
     /* 2055329 */   GIM_Try, /*On fail goto*//*Label 27347*/ GIMT_Encode4(2055420), // Rule ID 15301 //
     /* 2055334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2055345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2055348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2055351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2055354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055380 */     // MIs[0] round
     /* 2055380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055383 */     // MIs[0] policy
     /* 2055383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055393 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2055396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055419 */     // GIR_Coverage, 15301,
     /* 2055419 */     GIR_EraseRootFromParent_Done,
     /* 2055420 */   // Label 27347: @2055420
     /* 2055420 */   GIM_Try, /*On fail goto*//*Label 27348*/ GIMT_Encode4(2055511), // Rule ID 15304 //
     /* 2055425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2055436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2055439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2055442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2055445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055471 */     // MIs[0] round
     /* 2055471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055474 */     // MIs[0] policy
     /* 2055474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2055487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055510 */     // GIR_Coverage, 15304,
     /* 2055510 */     GIR_EraseRootFromParent_Done,
     /* 2055511 */   // Label 27348: @2055511
     /* 2055511 */   GIM_Try, /*On fail goto*//*Label 27349*/ GIMT_Encode4(2055602), // Rule ID 15305 //
     /* 2055516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2055527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2055530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2055533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2055536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055562 */     // MIs[0] round
     /* 2055562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055565 */     // MIs[0] policy
     /* 2055565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055575 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2055578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055601 */     // GIR_Coverage, 15305,
     /* 2055601 */     GIR_EraseRootFromParent_Done,
     /* 2055602 */   // Label 27349: @2055602
     /* 2055602 */   GIM_Try, /*On fail goto*//*Label 27350*/ GIMT_Encode4(2055693), // Rule ID 15308 //
     /* 2055607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2055618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2055621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2055624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2055627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055653 */     // MIs[0] round
     /* 2055653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055656 */     // MIs[0] policy
     /* 2055656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055666 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2055669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055692 */     // GIR_Coverage, 15308,
     /* 2055692 */     GIR_EraseRootFromParent_Done,
     /* 2055693 */   // Label 27350: @2055693
     /* 2055693 */   GIM_Try, /*On fail goto*//*Label 27351*/ GIMT_Encode4(2055784), // Rule ID 15309 //
     /* 2055698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2055709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2055712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2055715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2055718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055744 */     // MIs[0] round
     /* 2055744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055747 */     // MIs[0] policy
     /* 2055747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055757 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2055760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055783 */     // GIR_Coverage, 15309,
     /* 2055783 */     GIR_EraseRootFromParent_Done,
     /* 2055784 */   // Label 27351: @2055784
     /* 2055784 */   GIM_Try, /*On fail goto*//*Label 27352*/ GIMT_Encode4(2055875), // Rule ID 15312 //
     /* 2055789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2055792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2055800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2055803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2055806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2055809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055835 */     // MIs[0] round
     /* 2055835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055838 */     // MIs[0] policy
     /* 2055838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055848 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2055851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2055871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055874 */     // GIR_Coverage, 15312,
     /* 2055874 */     GIR_EraseRootFromParent_Done,
     /* 2055875 */   // Label 27352: @2055875
     /* 2055875 */   GIM_Try, /*On fail goto*//*Label 27353*/ GIMT_Encode4(2055966), // Rule ID 15313 //
     /* 2055880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2055883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2055891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2055894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2055897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2055900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055926 */     // MIs[0] round
     /* 2055926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055929 */     // MIs[0] policy
     /* 2055929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055939 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2055942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2055962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055965 */     // GIR_Coverage, 15313,
     /* 2055965 */     GIR_EraseRootFromParent_Done,
     /* 2055966 */   // Label 27353: @2055966
     /* 2055966 */   GIM_Try, /*On fail goto*//*Label 27354*/ GIMT_Encode4(2056057), // Rule ID 15316 //
     /* 2055971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2055982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2055985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2055988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2055991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2055994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056017 */     // MIs[0] round
     /* 2056017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056020 */     // MIs[0] policy
     /* 2056020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056030 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2056033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056056 */     // GIR_Coverage, 15316,
     /* 2056056 */     GIR_EraseRootFromParent_Done,
     /* 2056057 */   // Label 27354: @2056057
     /* 2056057 */   GIM_Try, /*On fail goto*//*Label 27355*/ GIMT_Encode4(2056148), // Rule ID 15317 //
     /* 2056062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2056073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2056076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2056079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2056082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056108 */     // MIs[0] round
     /* 2056108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056111 */     // MIs[0] policy
     /* 2056111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056121 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2056124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056147 */     // GIR_Coverage, 15317,
     /* 2056147 */     GIR_EraseRootFromParent_Done,
     /* 2056148 */   // Label 27355: @2056148
     /* 2056148 */   GIM_Try, /*On fail goto*//*Label 27356*/ GIMT_Encode4(2056239), // Rule ID 15320 //
     /* 2056153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2056164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2056167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2056170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2056173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2056176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056199 */     // MIs[0] round
     /* 2056199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056202 */     // MIs[0] policy
     /* 2056202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056212 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2056215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056238 */     // GIR_Coverage, 15320,
     /* 2056238 */     GIR_EraseRootFromParent_Done,
     /* 2056239 */   // Label 27356: @2056239
     /* 2056239 */   GIM_Try, /*On fail goto*//*Label 27357*/ GIMT_Encode4(2056330), // Rule ID 15321 //
     /* 2056244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2056255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2056258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2056261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2056264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2056267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056290 */     // MIs[0] round
     /* 2056290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056293 */     // MIs[0] policy
     /* 2056293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056303 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2056306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056329 */     // GIR_Coverage, 15321,
     /* 2056329 */     GIR_EraseRootFromParent_Done,
     /* 2056330 */   // Label 27357: @2056330
     /* 2056330 */   GIM_Try, /*On fail goto*//*Label 27358*/ GIMT_Encode4(2056421), // Rule ID 15324 //
     /* 2056335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2056346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2056349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2056352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2056355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2056358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2056365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056381 */     // MIs[0] round
     /* 2056381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056384 */     // MIs[0] policy
     /* 2056384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056394 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2056397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056420 */     // GIR_Coverage, 15324,
     /* 2056420 */     GIR_EraseRootFromParent_Done,
     /* 2056421 */   // Label 27358: @2056421
     /* 2056421 */   GIM_Try, /*On fail goto*//*Label 27359*/ GIMT_Encode4(2056512), // Rule ID 15325 //
     /* 2056426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2056437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2056440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2056443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2056446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2056449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2056456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056472 */     // MIs[0] round
     /* 2056472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056475 */     // MIs[0] policy
     /* 2056475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056485 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2056488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056511 */     // GIR_Coverage, 15325,
     /* 2056511 */     GIR_EraseRootFromParent_Done,
     /* 2056512 */   // Label 27359: @2056512
     /* 2056512 */   GIM_Try, /*On fail goto*//*Label 27360*/ GIMT_Encode4(2056603), // Rule ID 15328 //
     /* 2056517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2056528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2056531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2056534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2056537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2056540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056563 */     // MIs[0] round
     /* 2056563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056566 */     // MIs[0] policy
     /* 2056566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056576 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2056579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056602 */     // GIR_Coverage, 15328,
     /* 2056602 */     GIR_EraseRootFromParent_Done,
     /* 2056603 */   // Label 27360: @2056603
     /* 2056603 */   GIM_Try, /*On fail goto*//*Label 27361*/ GIMT_Encode4(2056694), // Rule ID 15329 //
     /* 2056608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2056619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2056622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2056625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2056628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2056631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056654 */     // MIs[0] round
     /* 2056654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056657 */     // MIs[0] policy
     /* 2056657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056667 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2056670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056693 */     // GIR_Coverage, 15329,
     /* 2056693 */     GIR_EraseRootFromParent_Done,
     /* 2056694 */   // Label 27361: @2056694
     /* 2056694 */   GIM_Try, /*On fail goto*//*Label 27362*/ GIMT_Encode4(2056785), // Rule ID 15332 //
     /* 2056699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2056710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2056713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2056716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2056719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056745 */     // MIs[0] round
     /* 2056745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056748 */     // MIs[0] policy
     /* 2056748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056758 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2056761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056784 */     // GIR_Coverage, 15332,
     /* 2056784 */     GIR_EraseRootFromParent_Done,
     /* 2056785 */   // Label 27362: @2056785
     /* 2056785 */   GIM_Try, /*On fail goto*//*Label 27363*/ GIMT_Encode4(2056876), // Rule ID 15333 //
     /* 2056790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2056801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2056804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2056807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2056810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056836 */     // MIs[0] round
     /* 2056836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056839 */     // MIs[0] policy
     /* 2056839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056849 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2056852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056875 */     // GIR_Coverage, 15333,
     /* 2056875 */     GIR_EraseRootFromParent_Done,
     /* 2056876 */   // Label 27363: @2056876
     /* 2056876 */   GIM_Try, /*On fail goto*//*Label 27364*/ GIMT_Encode4(2056967), // Rule ID 15336 //
     /* 2056881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2056892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2056895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2056898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2056901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2056904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2056911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056927 */     // MIs[0] round
     /* 2056927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056930 */     // MIs[0] policy
     /* 2056930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056940 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2056943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056966 */     // GIR_Coverage, 15336,
     /* 2056966 */     GIR_EraseRootFromParent_Done,
     /* 2056967 */   // Label 27364: @2056967
     /* 2056967 */   GIM_Try, /*On fail goto*//*Label 27365*/ GIMT_Encode4(2057058), // Rule ID 15337 //
     /* 2056972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2056983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2056986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2056989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2056992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2056995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057018 */     // MIs[0] round
     /* 2057018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057021 */     // MIs[0] policy
     /* 2057021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057031 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2057034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057057 */     // GIR_Coverage, 15337,
     /* 2057057 */     GIR_EraseRootFromParent_Done,
     /* 2057058 */   // Label 27365: @2057058
     /* 2057058 */   GIM_Try, /*On fail goto*//*Label 27366*/ GIMT_Encode4(2057149), // Rule ID 15340 //
     /* 2057063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2057074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2057077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2057080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2057083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057109 */     // MIs[0] round
     /* 2057109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057112 */     // MIs[0] policy
     /* 2057112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057122 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2057125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057148 */     // GIR_Coverage, 15340,
     /* 2057148 */     GIR_EraseRootFromParent_Done,
     /* 2057149 */   // Label 27366: @2057149
     /* 2057149 */   GIM_Try, /*On fail goto*//*Label 27367*/ GIMT_Encode4(2057240), // Rule ID 15341 //
     /* 2057154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2057165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2057168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2057171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2057174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057200 */     // MIs[0] round
     /* 2057200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057203 */     // MIs[0] policy
     /* 2057203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057213 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2057216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057239 */     // GIR_Coverage, 15341,
     /* 2057239 */     GIR_EraseRootFromParent_Done,
     /* 2057240 */   // Label 27367: @2057240
     /* 2057240 */   GIM_Try, /*On fail goto*//*Label 27368*/ GIMT_Encode4(2057331), // Rule ID 15344 //
     /* 2057245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2057256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2057259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2057262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2057265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057291 */     // MIs[0] round
     /* 2057291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057294 */     // MIs[0] policy
     /* 2057294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057304 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2057307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057330 */     // GIR_Coverage, 15344,
     /* 2057330 */     GIR_EraseRootFromParent_Done,
     /* 2057331 */   // Label 27368: @2057331
     /* 2057331 */   GIM_Try, /*On fail goto*//*Label 27369*/ GIMT_Encode4(2057422), // Rule ID 15345 //
     /* 2057336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2057347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2057350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2057353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2057356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057382 */     // MIs[0] round
     /* 2057382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057385 */     // MIs[0] policy
     /* 2057385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057395 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2057398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057421 */     // GIR_Coverage, 15345,
     /* 2057421 */     GIR_EraseRootFromParent_Done,
     /* 2057422 */   // Label 27369: @2057422
     /* 2057422 */   GIM_Try, /*On fail goto*//*Label 27370*/ GIMT_Encode4(2057513), // Rule ID 15348 //
     /* 2057427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2057438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2057441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2057444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2057447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057473 */     // MIs[0] round
     /* 2057473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057476 */     // MIs[0] policy
     /* 2057476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2057489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057512 */     // GIR_Coverage, 15348,
     /* 2057512 */     GIR_EraseRootFromParent_Done,
     /* 2057513 */   // Label 27370: @2057513
     /* 2057513 */   GIM_Try, /*On fail goto*//*Label 27371*/ GIMT_Encode4(2057604), // Rule ID 15349 //
     /* 2057518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2057529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2057532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2057535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2057538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057564 */     // MIs[0] round
     /* 2057564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057567 */     // MIs[0] policy
     /* 2057567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057577 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2057580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057603 */     // GIR_Coverage, 15349,
     /* 2057603 */     GIR_EraseRootFromParent_Done,
     /* 2057604 */   // Label 27371: @2057604
     /* 2057604 */   GIM_Try, /*On fail goto*//*Label 27372*/ GIMT_Encode4(2057695), // Rule ID 15352 //
     /* 2057609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2057612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2057620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2057623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2057626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2057629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2057632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057655 */     // MIs[0] round
     /* 2057655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057658 */     // MIs[0] policy
     /* 2057658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2057671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2057691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057694 */     // GIR_Coverage, 15352,
     /* 2057694 */     GIR_EraseRootFromParent_Done,
     /* 2057695 */   // Label 27372: @2057695
     /* 2057695 */   GIM_Try, /*On fail goto*//*Label 27373*/ GIMT_Encode4(2057786), // Rule ID 15353 //
     /* 2057700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2057703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2057711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2057714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2057717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2057720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2057723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057746 */     // MIs[0] round
     /* 2057746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057749 */     // MIs[0] policy
     /* 2057749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057759 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2057762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2057782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057785 */     // GIR_Coverage, 15353,
     /* 2057785 */     GIR_EraseRootFromParent_Done,
     /* 2057786 */   // Label 27373: @2057786
     /* 2057786 */   GIM_Try, /*On fail goto*//*Label 27374*/ GIMT_Encode4(2057877), // Rule ID 15356 //
     /* 2057791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2057794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2057802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2057805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2057808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2057811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057837 */     // MIs[0] round
     /* 2057837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057840 */     // MIs[0] policy
     /* 2057840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057850 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2057853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2057873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057876 */     // GIR_Coverage, 15356,
     /* 2057876 */     GIR_EraseRootFromParent_Done,
     /* 2057877 */   // Label 27374: @2057877
     /* 2057877 */   GIM_Try, /*On fail goto*//*Label 27375*/ GIMT_Encode4(2057968), // Rule ID 15357 //
     /* 2057882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2057885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2057893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2057896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2057899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2057902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057928 */     // MIs[0] round
     /* 2057928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057931 */     // MIs[0] policy
     /* 2057931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057941 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2057944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2057964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057967 */     // GIR_Coverage, 15357,
     /* 2057967 */     GIR_EraseRootFromParent_Done,
     /* 2057968 */   // Label 27375: @2057968
     /* 2057968 */   GIM_Try, /*On fail goto*//*Label 27376*/ GIMT_Encode4(2058059), // Rule ID 15360 //
     /* 2057973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2057976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2057984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2057987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2057990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2057993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058019 */     // MIs[0] round
     /* 2058019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058022 */     // MIs[0] policy
     /* 2058022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058032 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2058035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058058 */     // GIR_Coverage, 15360,
     /* 2058058 */     GIR_EraseRootFromParent_Done,
     /* 2058059 */   // Label 27376: @2058059
     /* 2058059 */   GIM_Try, /*On fail goto*//*Label 27377*/ GIMT_Encode4(2058150), // Rule ID 15361 //
     /* 2058064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2058067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2058075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2058078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2058081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2058084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058110 */     // MIs[0] round
     /* 2058110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058113 */     // MIs[0] policy
     /* 2058113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058123 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2058126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058149 */     // GIR_Coverage, 15361,
     /* 2058149 */     GIR_EraseRootFromParent_Done,
     /* 2058150 */   // Label 27377: @2058150
     /* 2058150 */   GIM_Try, /*On fail goto*//*Label 27378*/ GIMT_Encode4(2058241), // Rule ID 15364 //
     /* 2058155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2058166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2058169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2058172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058201 */     // MIs[0] round
     /* 2058201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058204 */     // MIs[0] policy
     /* 2058204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058214 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2058217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058240 */     // GIR_Coverage, 15364,
     /* 2058240 */     GIR_EraseRootFromParent_Done,
     /* 2058241 */   // Label 27378: @2058241
     /* 2058241 */   GIM_Try, /*On fail goto*//*Label 27379*/ GIMT_Encode4(2058332), // Rule ID 15365 //
     /* 2058246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2058257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2058260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2058263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058292 */     // MIs[0] round
     /* 2058292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058295 */     // MIs[0] policy
     /* 2058295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058305 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2058308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058331 */     // GIR_Coverage, 15365,
     /* 2058331 */     GIR_EraseRootFromParent_Done,
     /* 2058332 */   // Label 27379: @2058332
     /* 2058332 */   GIM_Try, /*On fail goto*//*Label 27380*/ GIMT_Encode4(2058423), // Rule ID 15368 //
     /* 2058337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2058348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2058351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2058354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058383 */     // MIs[0] round
     /* 2058383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058386 */     // MIs[0] policy
     /* 2058386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058396 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2058399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058422 */     // GIR_Coverage, 15368,
     /* 2058422 */     GIR_EraseRootFromParent_Done,
     /* 2058423 */   // Label 27380: @2058423
     /* 2058423 */   GIM_Try, /*On fail goto*//*Label 27381*/ GIMT_Encode4(2058514), // Rule ID 15369 //
     /* 2058428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2058439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2058442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2058445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058474 */     // MIs[0] round
     /* 2058474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058477 */     // MIs[0] policy
     /* 2058477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058487 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2058490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058513 */     // GIR_Coverage, 15369,
     /* 2058513 */     GIR_EraseRootFromParent_Done,
     /* 2058514 */   // Label 27381: @2058514
     /* 2058514 */   GIM_Try, /*On fail goto*//*Label 27382*/ GIMT_Encode4(2058605), // Rule ID 15372 //
     /* 2058519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2058530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2058533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2058536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058565 */     // MIs[0] round
     /* 2058565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058568 */     // MIs[0] policy
     /* 2058568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058578 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2058581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058604 */     // GIR_Coverage, 15372,
     /* 2058604 */     GIR_EraseRootFromParent_Done,
     /* 2058605 */   // Label 27382: @2058605
     /* 2058605 */   GIM_Try, /*On fail goto*//*Label 27383*/ GIMT_Encode4(2058696), // Rule ID 15373 //
     /* 2058610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2058621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2058624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2058627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058656 */     // MIs[0] round
     /* 2058656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058659 */     // MIs[0] policy
     /* 2058659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058669 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2058672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058695 */     // GIR_Coverage, 15373,
     /* 2058695 */     GIR_EraseRootFromParent_Done,
     /* 2058696 */   // Label 27383: @2058696
     /* 2058696 */   GIM_Try, /*On fail goto*//*Label 27384*/ GIMT_Encode4(2058787), // Rule ID 15376 //
     /* 2058701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2058712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2058715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2058718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058747 */     // MIs[0] round
     /* 2058747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058750 */     // MIs[0] policy
     /* 2058750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058760 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2058763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2058783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058786 */     // GIR_Coverage, 15376,
     /* 2058786 */     GIR_EraseRootFromParent_Done,
     /* 2058787 */   // Label 27384: @2058787
     /* 2058787 */   GIM_Try, /*On fail goto*//*Label 27385*/ GIMT_Encode4(2058878), // Rule ID 15377 //
     /* 2058792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2058803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2058806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2058809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058838 */     // MIs[0] round
     /* 2058838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058841 */     // MIs[0] policy
     /* 2058841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058851 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2058854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2058874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058877 */     // GIR_Coverage, 15377,
     /* 2058877 */     GIR_EraseRootFromParent_Done,
     /* 2058878 */   // Label 27385: @2058878
     /* 2058878 */   GIM_Try, /*On fail goto*//*Label 27386*/ GIMT_Encode4(2058969), // Rule ID 15380 //
     /* 2058883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2058894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2058897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2058900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058929 */     // MIs[0] round
     /* 2058929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058932 */     // MIs[0] policy
     /* 2058932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058942 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2058945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2058965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058968 */     // GIR_Coverage, 15380,
     /* 2058968 */     GIR_EraseRootFromParent_Done,
     /* 2058969 */   // Label 27386: @2058969
     /* 2058969 */   GIM_Try, /*On fail goto*//*Label 27387*/ GIMT_Encode4(2059060), // Rule ID 15381 //
     /* 2058974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2058985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2058988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2058991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059020 */     // MIs[0] round
     /* 2059020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059023 */     // MIs[0] policy
     /* 2059023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059033 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2059036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059059 */     // GIR_Coverage, 15381,
     /* 2059059 */     GIR_EraseRootFromParent_Done,
     /* 2059060 */   // Label 27387: @2059060
     /* 2059060 */   GIM_Try, /*On fail goto*//*Label 27388*/ GIMT_Encode4(2059151), // Rule ID 15384 //
     /* 2059065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2059073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2059082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2059085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059111 */     // MIs[0] round
     /* 2059111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059114 */     // MIs[0] policy
     /* 2059114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059124 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2059127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059150 */     // GIR_Coverage, 15384,
     /* 2059150 */     GIR_EraseRootFromParent_Done,
     /* 2059151 */   // Label 27388: @2059151
     /* 2059151 */   GIM_Try, /*On fail goto*//*Label 27389*/ GIMT_Encode4(2059242), // Rule ID 15385 //
     /* 2059156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2059164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2059173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2059176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059202 */     // MIs[0] round
     /* 2059202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059205 */     // MIs[0] policy
     /* 2059205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059215 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2059218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059241 */     // GIR_Coverage, 15385,
     /* 2059241 */     GIR_EraseRootFromParent_Done,
     /* 2059242 */   // Label 27389: @2059242
     /* 2059242 */   GIM_Try, /*On fail goto*//*Label 27390*/ GIMT_Encode4(2059333), // Rule ID 15388 //
     /* 2059247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2059255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2059258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2059261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2059264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2059267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059293 */     // MIs[0] round
     /* 2059293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059296 */     // MIs[0] policy
     /* 2059296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059306 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2059309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059332 */     // GIR_Coverage, 15388,
     /* 2059332 */     GIR_EraseRootFromParent_Done,
     /* 2059333 */   // Label 27390: @2059333
     /* 2059333 */   GIM_Try, /*On fail goto*//*Label 27391*/ GIMT_Encode4(2059424), // Rule ID 15389 //
     /* 2059338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2059346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2059349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2059352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2059355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2059358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059384 */     // MIs[0] round
     /* 2059384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059387 */     // MIs[0] policy
     /* 2059387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059397 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2059400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059423 */     // GIR_Coverage, 15389,
     /* 2059423 */     GIR_EraseRootFromParent_Done,
     /* 2059424 */   // Label 27391: @2059424
     /* 2059424 */   GIM_Try, /*On fail goto*//*Label 27392*/ GIMT_Encode4(2059515), // Rule ID 15392 //
     /* 2059429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2059437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2059440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2059443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2059446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2059449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059475 */     // MIs[0] round
     /* 2059475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059478 */     // MIs[0] policy
     /* 2059478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059488 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2059491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059514 */     // GIR_Coverage, 15392,
     /* 2059514 */     GIR_EraseRootFromParent_Done,
     /* 2059515 */   // Label 27392: @2059515
     /* 2059515 */   GIM_Try, /*On fail goto*//*Label 27393*/ GIMT_Encode4(2059606), // Rule ID 15393 //
     /* 2059520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2059528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2059531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2059534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2059537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2059540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059566 */     // MIs[0] round
     /* 2059566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059569 */     // MIs[0] policy
     /* 2059569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059579 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2059582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059605 */     // GIR_Coverage, 15393,
     /* 2059605 */     GIR_EraseRootFromParent_Done,
     /* 2059606 */   // Label 27393: @2059606
     /* 2059606 */   GIM_Try, /*On fail goto*//*Label 27394*/ GIMT_Encode4(2059697), // Rule ID 15396 //
     /* 2059611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2059619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2059622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2059625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2059628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2059631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059657 */     // MIs[0] round
     /* 2059657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059660 */     // MIs[0] policy
     /* 2059660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2059673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059696 */     // GIR_Coverage, 15396,
     /* 2059696 */     GIR_EraseRootFromParent_Done,
     /* 2059697 */   // Label 27394: @2059697
     /* 2059697 */   GIM_Try, /*On fail goto*//*Label 27395*/ GIMT_Encode4(2059788), // Rule ID 15397 //
     /* 2059702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2059710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2059713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2059716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2059719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2059722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059748 */     // MIs[0] round
     /* 2059748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059751 */     // MIs[0] policy
     /* 2059751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059761 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2059764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059787 */     // GIR_Coverage, 15397,
     /* 2059787 */     GIR_EraseRootFromParent_Done,
     /* 2059788 */   // Label 27395: @2059788
     /* 2059788 */   GIM_Try, /*On fail goto*//*Label 27396*/ GIMT_Encode4(2059879), // Rule ID 15400 //
     /* 2059793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2059796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2059801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2059804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2059807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2059810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2059813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059839 */     // MIs[0] round
     /* 2059839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059842 */     // MIs[0] policy
     /* 2059842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2059855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2059875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059878 */     // GIR_Coverage, 15400,
     /* 2059878 */     GIR_EraseRootFromParent_Done,
     /* 2059879 */   // Label 27396: @2059879
     /* 2059879 */   GIM_Try, /*On fail goto*//*Label 27397*/ GIMT_Encode4(2059970), // Rule ID 15401 //
     /* 2059884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2059887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2059892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2059895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2059898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2059901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2059904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059930 */     // MIs[0] round
     /* 2059930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059933 */     // MIs[0] policy
     /* 2059933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059943 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2059946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2059966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059969 */     // GIR_Coverage, 15401,
     /* 2059969 */     GIR_EraseRootFromParent_Done,
     /* 2059970 */   // Label 27397: @2059970
     /* 2059970 */   GIM_Try, /*On fail goto*//*Label 27398*/ GIMT_Encode4(2060061), // Rule ID 15404 //
     /* 2059975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2059983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2059986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2059989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2059992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2059995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2059998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060021 */     // MIs[0] round
     /* 2060021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060024 */     // MIs[0] policy
     /* 2060024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060034 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2060037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060060 */     // GIR_Coverage, 15404,
     /* 2060060 */     GIR_EraseRootFromParent_Done,
     /* 2060061 */   // Label 27398: @2060061
     /* 2060061 */   GIM_Try, /*On fail goto*//*Label 27399*/ GIMT_Encode4(2060152), // Rule ID 15405 //
     /* 2060066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2060074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2060077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2060080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2060083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2060086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060112 */     // MIs[0] round
     /* 2060112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060115 */     // MIs[0] policy
     /* 2060115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060125 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2060128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060151 */     // GIR_Coverage, 15405,
     /* 2060151 */     GIR_EraseRootFromParent_Done,
     /* 2060152 */   // Label 27399: @2060152
     /* 2060152 */   GIM_Try, /*On fail goto*//*Label 27400*/ GIMT_Encode4(2060243), // Rule ID 15408 //
     /* 2060157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2060165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2060168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2060171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2060174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2060177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060203 */     // MIs[0] round
     /* 2060203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060206 */     // MIs[0] policy
     /* 2060206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060216 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2060219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060242 */     // GIR_Coverage, 15408,
     /* 2060242 */     GIR_EraseRootFromParent_Done,
     /* 2060243 */   // Label 27400: @2060243
     /* 2060243 */   GIM_Try, /*On fail goto*//*Label 27401*/ GIMT_Encode4(2060334), // Rule ID 15409 //
     /* 2060248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2060256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2060259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2060262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2060265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2060268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060294 */     // MIs[0] round
     /* 2060294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060297 */     // MIs[0] policy
     /* 2060297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060307 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2060310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060333 */     // GIR_Coverage, 15409,
     /* 2060333 */     GIR_EraseRootFromParent_Done,
     /* 2060334 */   // Label 27401: @2060334
     /* 2060334 */   GIM_Try, /*On fail goto*//*Label 27402*/ GIMT_Encode4(2060425), // Rule ID 15412 //
     /* 2060339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2060347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2060350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2060353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2060356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2060359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2060362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2060369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060385 */     // MIs[0] round
     /* 2060385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060388 */     // MIs[0] policy
     /* 2060388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060398 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2060401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060424 */     // GIR_Coverage, 15412,
     /* 2060424 */     GIR_EraseRootFromParent_Done,
     /* 2060425 */   // Label 27402: @2060425
     /* 2060425 */   GIM_Try, /*On fail goto*//*Label 27403*/ GIMT_Encode4(2060516), // Rule ID 15413 //
     /* 2060430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2060438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2060441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2060444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2060447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2060450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2060453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2060460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060476 */     // MIs[0] round
     /* 2060476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060479 */     // MIs[0] policy
     /* 2060479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060489 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2060492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060515 */     // GIR_Coverage, 15413,
     /* 2060515 */     GIR_EraseRootFromParent_Done,
     /* 2060516 */   // Label 27403: @2060516
     /* 2060516 */   GIM_Try, /*On fail goto*//*Label 27404*/ GIMT_Encode4(2060607), // Rule ID 15416 //
     /* 2060521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2060529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2060532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2060535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2060538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2060541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2060544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060567 */     // MIs[0] round
     /* 2060567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060570 */     // MIs[0] policy
     /* 2060570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060580 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2060583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060606 */     // GIR_Coverage, 15416,
     /* 2060606 */     GIR_EraseRootFromParent_Done,
     /* 2060607 */   // Label 27404: @2060607
     /* 2060607 */   GIM_Try, /*On fail goto*//*Label 27405*/ GIMT_Encode4(2060698), // Rule ID 15417 //
     /* 2060612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2060620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2060623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2060626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2060629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2060632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2060635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060658 */     // MIs[0] round
     /* 2060658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060661 */     // MIs[0] policy
     /* 2060661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060671 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2060674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060697 */     // GIR_Coverage, 15417,
     /* 2060697 */     GIR_EraseRootFromParent_Done,
     /* 2060698 */   // Label 27405: @2060698
     /* 2060698 */   GIM_Try, /*On fail goto*//*Label 27406*/ GIMT_Encode4(2060789), // Rule ID 15420 //
     /* 2060703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2060711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2060714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2060717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2060720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2060723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060749 */     // MIs[0] round
     /* 2060749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060752 */     // MIs[0] policy
     /* 2060752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060762 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2060765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060788 */     // GIR_Coverage, 15420,
     /* 2060788 */     GIR_EraseRootFromParent_Done,
     /* 2060789 */   // Label 27406: @2060789
     /* 2060789 */   GIM_Try, /*On fail goto*//*Label 27407*/ GIMT_Encode4(2060880), // Rule ID 15421 //
     /* 2060794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2060802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2060805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2060808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2060811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2060814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060840 */     // MIs[0] round
     /* 2060840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060843 */     // MIs[0] policy
     /* 2060843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060853 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2060856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060879 */     // GIR_Coverage, 15421,
     /* 2060879 */     GIR_EraseRootFromParent_Done,
     /* 2060880 */   // Label 27407: @2060880
     /* 2060880 */   GIM_Try, /*On fail goto*//*Label 27408*/ GIMT_Encode4(2060971), // Rule ID 15424 //
     /* 2060885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2060893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2060896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2060899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2060902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2060905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2060915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060931 */     // MIs[0] round
     /* 2060931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060934 */     // MIs[0] policy
     /* 2060934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060944 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2060947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060970 */     // GIR_Coverage, 15424,
     /* 2060970 */     GIR_EraseRootFromParent_Done,
     /* 2060971 */   // Label 27408: @2060971
     /* 2060971 */   GIM_Try, /*On fail goto*//*Label 27409*/ GIMT_Encode4(2061062), // Rule ID 15425 //
     /* 2060976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2060984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2060987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2060990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2060993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2060996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061022 */     // MIs[0] round
     /* 2061022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061025 */     // MIs[0] policy
     /* 2061025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061035 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2061038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061061 */     // GIR_Coverage, 15425,
     /* 2061061 */     GIR_EraseRootFromParent_Done,
     /* 2061062 */   // Label 27409: @2061062
     /* 2061062 */   GIM_Try, /*On fail goto*//*Label 27410*/ GIMT_Encode4(2061153), // Rule ID 15428 //
     /* 2061067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2061075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2061078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2061081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2061084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2061087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061113 */     // MIs[0] round
     /* 2061113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061116 */     // MIs[0] policy
     /* 2061116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061126 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2061129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061152 */     // GIR_Coverage, 15428,
     /* 2061152 */     GIR_EraseRootFromParent_Done,
     /* 2061153 */   // Label 27410: @2061153
     /* 2061153 */   GIM_Try, /*On fail goto*//*Label 27411*/ GIMT_Encode4(2061244), // Rule ID 15429 //
     /* 2061158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2061166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2061169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2061172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2061175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2061178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061204 */     // MIs[0] round
     /* 2061204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061207 */     // MIs[0] policy
     /* 2061207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061217 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2061220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061243 */     // GIR_Coverage, 15429,
     /* 2061243 */     GIR_EraseRootFromParent_Done,
     /* 2061244 */   // Label 27411: @2061244
     /* 2061244 */   GIM_Try, /*On fail goto*//*Label 27412*/ GIMT_Encode4(2061335), // Rule ID 15432 //
     /* 2061249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2061257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2061266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2061269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061295 */     // MIs[0] round
     /* 2061295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061298 */     // MIs[0] policy
     /* 2061298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061308 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2061311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061334 */     // GIR_Coverage, 15432,
     /* 2061334 */     GIR_EraseRootFromParent_Done,
     /* 2061335 */   // Label 27412: @2061335
     /* 2061335 */   GIM_Try, /*On fail goto*//*Label 27413*/ GIMT_Encode4(2061426), // Rule ID 15433 //
     /* 2061340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2061348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2061357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2061360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061386 */     // MIs[0] round
     /* 2061386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061389 */     // MIs[0] policy
     /* 2061389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061399 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2061402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061425 */     // GIR_Coverage, 15433,
     /* 2061425 */     GIR_EraseRootFromParent_Done,
     /* 2061426 */   // Label 27413: @2061426
     /* 2061426 */   GIM_Try, /*On fail goto*//*Label 27414*/ GIMT_Encode4(2061517), // Rule ID 15436 //
     /* 2061431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2061439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2061442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2061445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2061448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2061451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061477 */     // MIs[0] round
     /* 2061477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061480 */     // MIs[0] policy
     /* 2061480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061490 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2061493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061516 */     // GIR_Coverage, 15436,
     /* 2061516 */     GIR_EraseRootFromParent_Done,
     /* 2061517 */   // Label 27414: @2061517
     /* 2061517 */   GIM_Try, /*On fail goto*//*Label 27415*/ GIMT_Encode4(2061608), // Rule ID 15437 //
     /* 2061522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2061530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2061533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2061536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2061539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2061542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061568 */     // MIs[0] round
     /* 2061568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061571 */     // MIs[0] policy
     /* 2061571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061581 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2061584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061607 */     // GIR_Coverage, 15437,
     /* 2061607 */     GIR_EraseRootFromParent_Done,
     /* 2061608 */   // Label 27415: @2061608
     /* 2061608 */   GIM_Try, /*On fail goto*//*Label 27416*/ GIMT_Encode4(2061699), // Rule ID 15440 //
     /* 2061613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2061616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2061621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2061624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2061627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2061630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2061633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2061636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061659 */     // MIs[0] round
     /* 2061659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061662 */     // MIs[0] policy
     /* 2061662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061672 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2061675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061698 */     // GIR_Coverage, 15440,
     /* 2061698 */     GIR_EraseRootFromParent_Done,
     /* 2061699 */   // Label 27416: @2061699
     /* 2061699 */   GIM_Try, /*On fail goto*//*Label 27417*/ GIMT_Encode4(2061790), // Rule ID 15441 //
     /* 2061704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2061707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2061712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2061715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2061718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2061721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2061724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2061727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061750 */     // MIs[0] round
     /* 2061750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061753 */     // MIs[0] policy
     /* 2061753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061763 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2061766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061789 */     // GIR_Coverage, 15441,
     /* 2061789 */     GIR_EraseRootFromParent_Done,
     /* 2061790 */   // Label 27417: @2061790
     /* 2061790 */   GIM_Try, /*On fail goto*//*Label 27418*/ GIMT_Encode4(2061881), // Rule ID 15444 //
     /* 2061795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2061798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2061803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2061806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2061809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2061812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2061815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061841 */     // MIs[0] round
     /* 2061841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061844 */     // MIs[0] policy
     /* 2061844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061854 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2061857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061880 */     // GIR_Coverage, 15444,
     /* 2061880 */     GIR_EraseRootFromParent_Done,
     /* 2061881 */   // Label 27418: @2061881
     /* 2061881 */   GIM_Try, /*On fail goto*//*Label 27419*/ GIMT_Encode4(2061972), // Rule ID 15445 //
     /* 2061886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2061889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2061894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2061897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2061900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2061903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2061906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061932 */     // MIs[0] round
     /* 2061932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061935 */     // MIs[0] policy
     /* 2061935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061945 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2061948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061971 */     // GIR_Coverage, 15445,
     /* 2061971 */     GIR_EraseRootFromParent_Done,
     /* 2061972 */   // Label 27419: @2061972
     /* 2061972 */   GIM_Try, /*On fail goto*//*Label 27420*/ GIMT_Encode4(2062063), // Rule ID 15448 //
     /* 2061977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2061980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2061985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2061988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2061991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2061994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2061997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062023 */     // MIs[0] round
     /* 2062023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062026 */     // MIs[0] policy
     /* 2062026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062036 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2062039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062062 */     // GIR_Coverage, 15448,
     /* 2062062 */     GIR_EraseRootFromParent_Done,
     /* 2062063 */   // Label 27420: @2062063
     /* 2062063 */   GIM_Try, /*On fail goto*//*Label 27421*/ GIMT_Encode4(2062154), // Rule ID 15449 //
     /* 2062068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2062071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2062076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2062079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2062082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2062085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062114 */     // MIs[0] round
     /* 2062114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062117 */     // MIs[0] policy
     /* 2062117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062127 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2062130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062153 */     // GIR_Coverage, 15449,
     /* 2062153 */     GIR_EraseRootFromParent_Done,
     /* 2062154 */   // Label 27421: @2062154
     /* 2062154 */   GIM_Try, /*On fail goto*//*Label 27422*/ GIMT_Encode4(2062245), // Rule ID 15452 //
     /* 2062159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2062170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2062173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2062176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2062179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062205 */     // MIs[0] round
     /* 2062205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062208 */     // MIs[0] policy
     /* 2062208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062218 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2062221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062244 */     // GIR_Coverage, 15452,
     /* 2062244 */     GIR_EraseRootFromParent_Done,
     /* 2062245 */   // Label 27422: @2062245
     /* 2062245 */   GIM_Try, /*On fail goto*//*Label 27423*/ GIMT_Encode4(2062336), // Rule ID 15453 //
     /* 2062250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2062261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2062264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2062267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2062270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062296 */     // MIs[0] round
     /* 2062296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062299 */     // MIs[0] policy
     /* 2062299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062309 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2062312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062335 */     // GIR_Coverage, 15453,
     /* 2062335 */     GIR_EraseRootFromParent_Done,
     /* 2062336 */   // Label 27423: @2062336
     /* 2062336 */   GIM_Try, /*On fail goto*//*Label 27424*/ GIMT_Encode4(2062427), // Rule ID 15456 //
     /* 2062341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2062352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2062355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2062358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2062361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062387 */     // MIs[0] round
     /* 2062387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062390 */     // MIs[0] policy
     /* 2062390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062400 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2062403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062426 */     // GIR_Coverage, 15456,
     /* 2062426 */     GIR_EraseRootFromParent_Done,
     /* 2062427 */   // Label 27424: @2062427
     /* 2062427 */   GIM_Try, /*On fail goto*//*Label 27425*/ GIMT_Encode4(2062518), // Rule ID 15457 //
     /* 2062432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2062443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2062446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2062449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2062452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062478 */     // MIs[0] round
     /* 2062478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062481 */     // MIs[0] policy
     /* 2062481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062491 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2062494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062517 */     // GIR_Coverage, 15457,
     /* 2062517 */     GIR_EraseRootFromParent_Done,
     /* 2062518 */   // Label 27425: @2062518
     /* 2062518 */   GIM_Try, /*On fail goto*//*Label 27426*/ GIMT_Encode4(2062609), // Rule ID 15460 //
     /* 2062523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2062534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2062537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2062540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2062543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062569 */     // MIs[0] round
     /* 2062569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062572 */     // MIs[0] policy
     /* 2062572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062582 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2062585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062608 */     // GIR_Coverage, 15460,
     /* 2062608 */     GIR_EraseRootFromParent_Done,
     /* 2062609 */   // Label 27426: @2062609
     /* 2062609 */   GIM_Try, /*On fail goto*//*Label 27427*/ GIMT_Encode4(2062700), // Rule ID 15461 //
     /* 2062614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2062625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2062628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2062631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2062634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062660 */     // MIs[0] round
     /* 2062660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062663 */     // MIs[0] policy
     /* 2062663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062673 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2062676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062699 */     // GIR_Coverage, 15461,
     /* 2062699 */     GIR_EraseRootFromParent_Done,
     /* 2062700 */   // Label 27427: @2062700
     /* 2062700 */   GIM_Try, /*On fail goto*//*Label 27428*/ GIMT_Encode4(2062791), // Rule ID 15464 //
     /* 2062705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2062716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2062719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2062722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2062725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062751 */     // MIs[0] round
     /* 2062751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062754 */     // MIs[0] policy
     /* 2062754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062764 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2062767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062790 */     // GIR_Coverage, 15464,
     /* 2062790 */     GIR_EraseRootFromParent_Done,
     /* 2062791 */   // Label 27428: @2062791
     /* 2062791 */   GIM_Try, /*On fail goto*//*Label 27429*/ GIMT_Encode4(2062882), // Rule ID 15465 //
     /* 2062796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2062807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2062810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2062813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2062816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062842 */     // MIs[0] round
     /* 2062842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062845 */     // MIs[0] policy
     /* 2062845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062855 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2062858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062881 */     // GIR_Coverage, 15465,
     /* 2062881 */     GIR_EraseRootFromParent_Done,
     /* 2062882 */   // Label 27429: @2062882
     /* 2062882 */   GIM_Try, /*On fail goto*//*Label 27430*/ GIMT_Encode4(2062973), // Rule ID 15468 //
     /* 2062887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2062898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2062901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2062904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2062907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062933 */     // MIs[0] round
     /* 2062933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062936 */     // MIs[0] policy
     /* 2062936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062946 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2062949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062972 */     // GIR_Coverage, 15468,
     /* 2062972 */     GIR_EraseRootFromParent_Done,
     /* 2062973 */   // Label 27430: @2062973
     /* 2062973 */   GIM_Try, /*On fail goto*//*Label 27431*/ GIMT_Encode4(2063064), // Rule ID 15469 //
     /* 2062978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2062989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2062992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2062995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2062998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063024 */     // MIs[0] round
     /* 2063024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063027 */     // MIs[0] policy
     /* 2063027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063037 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2063040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063063 */     // GIR_Coverage, 15469,
     /* 2063063 */     GIR_EraseRootFromParent_Done,
     /* 2063064 */   // Label 27431: @2063064
     /* 2063064 */   GIM_Try, /*On fail goto*//*Label 27432*/ GIMT_Encode4(2063155), // Rule ID 15472 //
     /* 2063069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2063080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2063083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2063086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2063089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063115 */     // MIs[0] round
     /* 2063115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063118 */     // MIs[0] policy
     /* 2063118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063128 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2063131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063154 */     // GIR_Coverage, 15472,
     /* 2063154 */     GIR_EraseRootFromParent_Done,
     /* 2063155 */   // Label 27432: @2063155
     /* 2063155 */   GIM_Try, /*On fail goto*//*Label 27433*/ GIMT_Encode4(2063246), // Rule ID 15473 //
     /* 2063160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2063171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2063174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2063177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2063180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063206 */     // MIs[0] round
     /* 2063206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063209 */     // MIs[0] policy
     /* 2063209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063219 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2063222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063245 */     // GIR_Coverage, 15473,
     /* 2063245 */     GIR_EraseRootFromParent_Done,
     /* 2063246 */   // Label 27433: @2063246
     /* 2063246 */   GIM_Try, /*On fail goto*//*Label 27434*/ GIMT_Encode4(2063337), // Rule ID 15476 //
     /* 2063251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2063262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2063265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2063268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2063271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063297 */     // MIs[0] round
     /* 2063297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063300 */     // MIs[0] policy
     /* 2063300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063310 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2063313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063336 */     // GIR_Coverage, 15476,
     /* 2063336 */     GIR_EraseRootFromParent_Done,
     /* 2063337 */   // Label 27434: @2063337
     /* 2063337 */   GIM_Try, /*On fail goto*//*Label 27435*/ GIMT_Encode4(2063428), // Rule ID 15477 //
     /* 2063342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2063353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2063356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2063359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2063362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063388 */     // MIs[0] round
     /* 2063388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063391 */     // MIs[0] policy
     /* 2063391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063401 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2063404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063427 */     // GIR_Coverage, 15477,
     /* 2063427 */     GIR_EraseRootFromParent_Done,
     /* 2063428 */   // Label 27435: @2063428
     /* 2063428 */   GIM_Try, /*On fail goto*//*Label 27436*/ GIMT_Encode4(2063519), // Rule ID 15480 //
     /* 2063433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2063444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2063447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2063450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2063453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063479 */     // MIs[0] round
     /* 2063479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063482 */     // MIs[0] policy
     /* 2063482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063492 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2063495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063518 */     // GIR_Coverage, 15480,
     /* 2063518 */     GIR_EraseRootFromParent_Done,
     /* 2063519 */   // Label 27436: @2063519
     /* 2063519 */   GIM_Try, /*On fail goto*//*Label 27437*/ GIMT_Encode4(2063610), // Rule ID 15481 //
     /* 2063524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2063535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2063538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2063541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2063544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063570 */     // MIs[0] round
     /* 2063570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063573 */     // MIs[0] policy
     /* 2063573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063583 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2063586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063609 */     // GIR_Coverage, 15481,
     /* 2063609 */     GIR_EraseRootFromParent_Done,
     /* 2063610 */   // Label 27437: @2063610
     /* 2063610 */   GIM_Try, /*On fail goto*//*Label 27438*/ GIMT_Encode4(2063701), // Rule ID 15484 //
     /* 2063615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2063626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2063629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2063632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2063635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063661 */     // MIs[0] round
     /* 2063661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063664 */     // MIs[0] policy
     /* 2063664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2063677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063700 */     // GIR_Coverage, 15484,
     /* 2063700 */     GIR_EraseRootFromParent_Done,
     /* 2063701 */   // Label 27438: @2063701
     /* 2063701 */   GIM_Try, /*On fail goto*//*Label 27439*/ GIMT_Encode4(2063792), // Rule ID 15485 //
     /* 2063706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2063717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2063720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2063723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2063726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063752 */     // MIs[0] round
     /* 2063752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063755 */     // MIs[0] policy
     /* 2063755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2063768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063791 */     // GIR_Coverage, 15485,
     /* 2063791 */     GIR_EraseRootFromParent_Done,
     /* 2063792 */   // Label 27439: @2063792
     /* 2063792 */   GIM_Try, /*On fail goto*//*Label 27440*/ GIMT_Encode4(2063883), // Rule ID 15488 //
     /* 2063797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2063800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2063808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2063811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2063814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2063817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063843 */     // MIs[0] round
     /* 2063843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063846 */     // MIs[0] policy
     /* 2063846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063856 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2063859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2063879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063882 */     // GIR_Coverage, 15488,
     /* 2063882 */     GIR_EraseRootFromParent_Done,
     /* 2063883 */   // Label 27440: @2063883
     /* 2063883 */   GIM_Try, /*On fail goto*//*Label 27441*/ GIMT_Encode4(2063974), // Rule ID 15489 //
     /* 2063888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2063891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2063899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2063902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2063905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2063908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063934 */     // MIs[0] round
     /* 2063934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063937 */     // MIs[0] policy
     /* 2063937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063947 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2063950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2063970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063973 */     // GIR_Coverage, 15489,
     /* 2063973 */     GIR_EraseRootFromParent_Done,
     /* 2063974 */   // Label 27441: @2063974
     /* 2063974 */   GIM_Try, /*On fail goto*//*Label 27442*/ GIMT_Encode4(2064065), // Rule ID 15492 //
     /* 2063979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2063990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2063993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2063996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2063999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064025 */     // MIs[0] round
     /* 2064025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064028 */     // MIs[0] policy
     /* 2064028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064038 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2064041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064064 */     // GIR_Coverage, 15492,
     /* 2064064 */     GIR_EraseRootFromParent_Done,
     /* 2064065 */   // Label 27442: @2064065
     /* 2064065 */   GIM_Try, /*On fail goto*//*Label 27443*/ GIMT_Encode4(2064156), // Rule ID 15493 //
     /* 2064070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2064081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2064084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2064087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2064090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064116 */     // MIs[0] round
     /* 2064116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064119 */     // MIs[0] policy
     /* 2064119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064129 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2064132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064155 */     // GIR_Coverage, 15493,
     /* 2064155 */     GIR_EraseRootFromParent_Done,
     /* 2064156 */   // Label 27443: @2064156
     /* 2064156 */   GIM_Try, /*On fail goto*//*Label 27444*/ GIMT_Encode4(2064247), // Rule ID 15496 //
     /* 2064161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2064172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2064175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2064178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2064181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2064184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064207 */     // MIs[0] round
     /* 2064207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064210 */     // MIs[0] policy
     /* 2064210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064220 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2064223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064246 */     // GIR_Coverage, 15496,
     /* 2064246 */     GIR_EraseRootFromParent_Done,
     /* 2064247 */   // Label 27444: @2064247
     /* 2064247 */   GIM_Try, /*On fail goto*//*Label 27445*/ GIMT_Encode4(2064338), // Rule ID 15497 //
     /* 2064252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2064263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2064266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2064269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2064272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2064275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064298 */     // MIs[0] round
     /* 2064298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064301 */     // MIs[0] policy
     /* 2064301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064311 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2064314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064337 */     // GIR_Coverage, 15497,
     /* 2064337 */     GIR_EraseRootFromParent_Done,
     /* 2064338 */   // Label 27445: @2064338
     /* 2064338 */   GIM_Try, /*On fail goto*//*Label 27446*/ GIMT_Encode4(2064429), // Rule ID 15500 //
     /* 2064343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2064354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2064357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2064360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2064363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2064366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2064373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064389 */     // MIs[0] round
     /* 2064389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064392 */     // MIs[0] policy
     /* 2064392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064402 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2064405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064428 */     // GIR_Coverage, 15500,
     /* 2064428 */     GIR_EraseRootFromParent_Done,
     /* 2064429 */   // Label 27446: @2064429
     /* 2064429 */   GIM_Try, /*On fail goto*//*Label 27447*/ GIMT_Encode4(2064520), // Rule ID 15501 //
     /* 2064434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2064445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2064448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2064451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2064454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2064457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2064464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064480 */     // MIs[0] round
     /* 2064480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064483 */     // MIs[0] policy
     /* 2064483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064493 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2064496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064519 */     // GIR_Coverage, 15501,
     /* 2064519 */     GIR_EraseRootFromParent_Done,
     /* 2064520 */   // Label 27447: @2064520
     /* 2064520 */   GIM_Try, /*On fail goto*//*Label 27448*/ GIMT_Encode4(2064611), // Rule ID 15504 //
     /* 2064525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2064536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2064539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2064542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2064545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2064548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064571 */     // MIs[0] round
     /* 2064571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064574 */     // MIs[0] policy
     /* 2064574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2064587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064610 */     // GIR_Coverage, 15504,
     /* 2064610 */     GIR_EraseRootFromParent_Done,
     /* 2064611 */   // Label 27448: @2064611
     /* 2064611 */   GIM_Try, /*On fail goto*//*Label 27449*/ GIMT_Encode4(2064702), // Rule ID 15505 //
     /* 2064616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2064627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2064630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2064633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2064636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2064639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064662 */     // MIs[0] round
     /* 2064662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064665 */     // MIs[0] policy
     /* 2064665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064675 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2064678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064701 */     // GIR_Coverage, 15505,
     /* 2064701 */     GIR_EraseRootFromParent_Done,
     /* 2064702 */   // Label 27449: @2064702
     /* 2064702 */   GIM_Try, /*On fail goto*//*Label 27450*/ GIMT_Encode4(2064793), // Rule ID 15508 //
     /* 2064707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2064718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2064721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2064724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2064727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064753 */     // MIs[0] round
     /* 2064753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064756 */     // MIs[0] policy
     /* 2064756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064766 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2064769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064792 */     // GIR_Coverage, 15508,
     /* 2064792 */     GIR_EraseRootFromParent_Done,
     /* 2064793 */   // Label 27450: @2064793
     /* 2064793 */   GIM_Try, /*On fail goto*//*Label 27451*/ GIMT_Encode4(2064884), // Rule ID 15509 //
     /* 2064798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2064809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2064812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2064815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2064818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064844 */     // MIs[0] round
     /* 2064844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064847 */     // MIs[0] policy
     /* 2064847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064857 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2064860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064883 */     // GIR_Coverage, 15509,
     /* 2064883 */     GIR_EraseRootFromParent_Done,
     /* 2064884 */   // Label 27451: @2064884
     /* 2064884 */   GIM_Try, /*On fail goto*//*Label 27452*/ GIMT_Encode4(2064975), // Rule ID 15512 //
     /* 2064889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2064900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2064903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2064906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2064909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2064912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2064919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064935 */     // MIs[0] round
     /* 2064935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064938 */     // MIs[0] policy
     /* 2064938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064948 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2064951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064974 */     // GIR_Coverage, 15512,
     /* 2064974 */     GIR_EraseRootFromParent_Done,
     /* 2064975 */   // Label 27452: @2064975
     /* 2064975 */   GIM_Try, /*On fail goto*//*Label 27453*/ GIMT_Encode4(2065066), // Rule ID 15513 //
     /* 2064980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2064991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2064994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2064997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2065000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2065003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065026 */     // MIs[0] round
     /* 2065026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065029 */     // MIs[0] policy
     /* 2065029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065039 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2065042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065065 */     // GIR_Coverage, 15513,
     /* 2065065 */     GIR_EraseRootFromParent_Done,
     /* 2065066 */   // Label 27453: @2065066
     /* 2065066 */   GIM_Try, /*On fail goto*//*Label 27454*/ GIMT_Encode4(2065157), // Rule ID 15516 //
     /* 2065071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2065082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2065085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2065088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2065091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065117 */     // MIs[0] round
     /* 2065117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065120 */     // MIs[0] policy
     /* 2065120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065130 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2065133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065156 */     // GIR_Coverage, 15516,
     /* 2065156 */     GIR_EraseRootFromParent_Done,
     /* 2065157 */   // Label 27454: @2065157
     /* 2065157 */   GIM_Try, /*On fail goto*//*Label 27455*/ GIMT_Encode4(2065248), // Rule ID 15517 //
     /* 2065162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2065173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2065176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2065179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2065182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065208 */     // MIs[0] round
     /* 2065208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065211 */     // MIs[0] policy
     /* 2065211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065221 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2065224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065247 */     // GIR_Coverage, 15517,
     /* 2065247 */     GIR_EraseRootFromParent_Done,
     /* 2065248 */   // Label 27455: @2065248
     /* 2065248 */   GIM_Try, /*On fail goto*//*Label 27456*/ GIMT_Encode4(2065339), // Rule ID 15520 //
     /* 2065253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2065264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2065267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2065270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2065273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065299 */     // MIs[0] round
     /* 2065299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065302 */     // MIs[0] policy
     /* 2065302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065312 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2065315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065338 */     // GIR_Coverage, 15520,
     /* 2065338 */     GIR_EraseRootFromParent_Done,
     /* 2065339 */   // Label 27456: @2065339
     /* 2065339 */   GIM_Try, /*On fail goto*//*Label 27457*/ GIMT_Encode4(2065430), // Rule ID 15521 //
     /* 2065344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2065355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2065358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2065361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2065364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065390 */     // MIs[0] round
     /* 2065390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065393 */     // MIs[0] policy
     /* 2065393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065403 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2065406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065429 */     // GIR_Coverage, 15521,
     /* 2065429 */     GIR_EraseRootFromParent_Done,
     /* 2065430 */   // Label 27457: @2065430
     /* 2065430 */   GIM_Try, /*On fail goto*//*Label 27458*/ GIMT_Encode4(2065521), // Rule ID 15524 //
     /* 2065435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2065446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2065449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2065452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2065455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065481 */     // MIs[0] round
     /* 2065481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065484 */     // MIs[0] policy
     /* 2065484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065494 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2065497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065520 */     // GIR_Coverage, 15524,
     /* 2065520 */     GIR_EraseRootFromParent_Done,
     /* 2065521 */   // Label 27458: @2065521
     /* 2065521 */   GIM_Try, /*On fail goto*//*Label 27459*/ GIMT_Encode4(2065612), // Rule ID 15525 //
     /* 2065526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2065537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2065540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2065543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2065546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065572 */     // MIs[0] round
     /* 2065572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065575 */     // MIs[0] policy
     /* 2065575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065585 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2065588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065611 */     // GIR_Coverage, 15525,
     /* 2065611 */     GIR_EraseRootFromParent_Done,
     /* 2065612 */   // Label 27459: @2065612
     /* 2065612 */   GIM_Try, /*On fail goto*//*Label 27460*/ GIMT_Encode4(2065703), // Rule ID 15528 //
     /* 2065617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2065620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2065628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2065631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2065634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2065637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2065640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065663 */     // MIs[0] round
     /* 2065663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065666 */     // MIs[0] policy
     /* 2065666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2065679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2065699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065702 */     // GIR_Coverage, 15528,
     /* 2065702 */     GIR_EraseRootFromParent_Done,
     /* 2065703 */   // Label 27460: @2065703
     /* 2065703 */   GIM_Try, /*On fail goto*//*Label 27461*/ GIMT_Encode4(2065794), // Rule ID 15529 //
     /* 2065708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2065711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2065719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2065722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2065725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2065728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2065731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065754 */     // MIs[0] round
     /* 2065754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065757 */     // MIs[0] policy
     /* 2065757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065767 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2065770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2065790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065793 */     // GIR_Coverage, 15529,
     /* 2065793 */     GIR_EraseRootFromParent_Done,
     /* 2065794 */   // Label 27461: @2065794
     /* 2065794 */   GIM_Try, /*On fail goto*//*Label 27462*/ GIMT_Encode4(2065885), // Rule ID 15532 //
     /* 2065799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2065802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2065810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2065813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2065816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2065819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065845 */     // MIs[0] round
     /* 2065845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065848 */     // MIs[0] policy
     /* 2065848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065858 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2065861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2065881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065884 */     // GIR_Coverage, 15532,
     /* 2065884 */     GIR_EraseRootFromParent_Done,
     /* 2065885 */   // Label 27462: @2065885
     /* 2065885 */   GIM_Try, /*On fail goto*//*Label 27463*/ GIMT_Encode4(2065976), // Rule ID 15533 //
     /* 2065890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2065893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2065901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2065904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2065907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2065910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065936 */     // MIs[0] round
     /* 2065936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065939 */     // MIs[0] policy
     /* 2065939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065949 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2065952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2065972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065975 */     // GIR_Coverage, 15533,
     /* 2065975 */     GIR_EraseRootFromParent_Done,
     /* 2065976 */   // Label 27463: @2065976
     /* 2065976 */   GIM_Try, /*On fail goto*//*Label 27464*/ GIMT_Encode4(2066067), // Rule ID 15536 //
     /* 2065981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2065984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2065992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2065995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2065998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2066001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066027 */     // MIs[0] round
     /* 2066027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066030 */     // MIs[0] policy
     /* 2066030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066040 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2066043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066066 */     // GIR_Coverage, 15536,
     /* 2066066 */     GIR_EraseRootFromParent_Done,
     /* 2066067 */   // Label 27464: @2066067
     /* 2066067 */   GIM_Try, /*On fail goto*//*Label 27465*/ GIMT_Encode4(2066158), // Rule ID 15537 //
     /* 2066072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2066075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2066083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2066086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2066089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2066092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066118 */     // MIs[0] round
     /* 2066118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066121 */     // MIs[0] policy
     /* 2066121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066131 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2066134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066157 */     // GIR_Coverage, 15537,
     /* 2066157 */     GIR_EraseRootFromParent_Done,
     /* 2066158 */   // Label 27465: @2066158
     /* 2066158 */   GIM_Try, /*On fail goto*//*Label 27466*/ GIMT_Encode4(2066249), // Rule ID 15540 //
     /* 2066163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2066174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2066177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2066180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066209 */     // MIs[0] round
     /* 2066209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066212 */     // MIs[0] policy
     /* 2066212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066222 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2066225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066248 */     // GIR_Coverage, 15540,
     /* 2066248 */     GIR_EraseRootFromParent_Done,
     /* 2066249 */   // Label 27466: @2066249
     /* 2066249 */   GIM_Try, /*On fail goto*//*Label 27467*/ GIMT_Encode4(2066340), // Rule ID 15541 //
     /* 2066254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2066265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2066268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2066271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066300 */     // MIs[0] round
     /* 2066300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066303 */     // MIs[0] policy
     /* 2066303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066313 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2066316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066339 */     // GIR_Coverage, 15541,
     /* 2066339 */     GIR_EraseRootFromParent_Done,
     /* 2066340 */   // Label 27467: @2066340
     /* 2066340 */   GIM_Try, /*On fail goto*//*Label 27468*/ GIMT_Encode4(2066431), // Rule ID 15544 //
     /* 2066345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2066356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2066359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2066362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066391 */     // MIs[0] round
     /* 2066391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066394 */     // MIs[0] policy
     /* 2066394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066404 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2066407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066430 */     // GIR_Coverage, 15544,
     /* 2066430 */     GIR_EraseRootFromParent_Done,
     /* 2066431 */   // Label 27468: @2066431
     /* 2066431 */   GIM_Try, /*On fail goto*//*Label 27469*/ GIMT_Encode4(2066522), // Rule ID 15545 //
     /* 2066436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2066447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2066450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2066453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066482 */     // MIs[0] round
     /* 2066482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066485 */     // MIs[0] policy
     /* 2066485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066495 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2066498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066521 */     // GIR_Coverage, 15545,
     /* 2066521 */     GIR_EraseRootFromParent_Done,
     /* 2066522 */   // Label 27469: @2066522
     /* 2066522 */   GIM_Try, /*On fail goto*//*Label 27470*/ GIMT_Encode4(2066613), // Rule ID 15548 //
     /* 2066527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2066538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2066541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2066544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066573 */     // MIs[0] round
     /* 2066573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066576 */     // MIs[0] policy
     /* 2066576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066586 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2066589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066612 */     // GIR_Coverage, 15548,
     /* 2066612 */     GIR_EraseRootFromParent_Done,
     /* 2066613 */   // Label 27470: @2066613
     /* 2066613 */   GIM_Try, /*On fail goto*//*Label 27471*/ GIMT_Encode4(2066704), // Rule ID 15549 //
     /* 2066618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2066629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2066632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2066635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066664 */     // MIs[0] round
     /* 2066664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066667 */     // MIs[0] policy
     /* 2066667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066677 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2066680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066703 */     // GIR_Coverage, 15549,
     /* 2066703 */     GIR_EraseRootFromParent_Done,
     /* 2066704 */   // Label 27471: @2066704
     /* 2066704 */   GIM_Try, /*On fail goto*//*Label 27472*/ GIMT_Encode4(2066795), // Rule ID 15552 //
     /* 2066709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2066720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2066723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2066726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066755 */     // MIs[0] round
     /* 2066755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066758 */     // MIs[0] policy
     /* 2066758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2066771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2066791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066794 */     // GIR_Coverage, 15552,
     /* 2066794 */     GIR_EraseRootFromParent_Done,
     /* 2066795 */   // Label 27472: @2066795
     /* 2066795 */   GIM_Try, /*On fail goto*//*Label 27473*/ GIMT_Encode4(2066886), // Rule ID 15553 //
     /* 2066800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2066811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2066814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2066817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066846 */     // MIs[0] round
     /* 2066846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066849 */     // MIs[0] policy
     /* 2066849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066859 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2066862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2066882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066885 */     // GIR_Coverage, 15553,
     /* 2066885 */     GIR_EraseRootFromParent_Done,
     /* 2066886 */   // Label 27473: @2066886
     /* 2066886 */   GIM_Try, /*On fail goto*//*Label 27474*/ GIMT_Encode4(2066977), // Rule ID 15556 //
     /* 2066891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2066902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2066905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2066908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066937 */     // MIs[0] round
     /* 2066937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066940 */     // MIs[0] policy
     /* 2066940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066950 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2066953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2066973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066976 */     // GIR_Coverage, 15556,
     /* 2066976 */     GIR_EraseRootFromParent_Done,
     /* 2066977 */   // Label 27474: @2066977
     /* 2066977 */   GIM_Try, /*On fail goto*//*Label 27475*/ GIMT_Encode4(2067068), // Rule ID 15557 //
     /* 2066982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2066993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2066996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2066999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2067002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067028 */     // MIs[0] round
     /* 2067028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067031 */     // MIs[0] policy
     /* 2067031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067041 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2067044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067067 */     // GIR_Coverage, 15557,
     /* 2067067 */     GIR_EraseRootFromParent_Done,
     /* 2067068 */   // Label 27475: @2067068
     /* 2067068 */   GIM_Try, /*On fail goto*//*Label 27476*/ GIMT_Encode4(2067159), // Rule ID 15560 //
     /* 2067073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2067081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2067084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2067087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2067090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2067093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067119 */     // MIs[0] round
     /* 2067119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067122 */     // MIs[0] policy
     /* 2067122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2067135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067158 */     // GIR_Coverage, 15560,
     /* 2067158 */     GIR_EraseRootFromParent_Done,
     /* 2067159 */   // Label 27476: @2067159
     /* 2067159 */   GIM_Try, /*On fail goto*//*Label 27477*/ GIMT_Encode4(2067250), // Rule ID 15561 //
     /* 2067164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2067172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2067175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2067178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2067181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2067184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067210 */     // MIs[0] round
     /* 2067210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067213 */     // MIs[0] policy
     /* 2067213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067223 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2067226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067249 */     // GIR_Coverage, 15561,
     /* 2067249 */     GIR_EraseRootFromParent_Done,
     /* 2067250 */   // Label 27477: @2067250
     /* 2067250 */   GIM_Try, /*On fail goto*//*Label 27478*/ GIMT_Encode4(2067341), // Rule ID 15564 //
     /* 2067255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2067263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2067266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2067269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2067272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2067275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067301 */     // MIs[0] round
     /* 2067301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067304 */     // MIs[0] policy
     /* 2067304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067314 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2067317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067340 */     // GIR_Coverage, 15564,
     /* 2067340 */     GIR_EraseRootFromParent_Done,
     /* 2067341 */   // Label 27478: @2067341
     /* 2067341 */   GIM_Try, /*On fail goto*//*Label 27479*/ GIMT_Encode4(2067432), // Rule ID 15565 //
     /* 2067346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2067354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2067357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2067360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2067363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2067366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067392 */     // MIs[0] round
     /* 2067392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067395 */     // MIs[0] policy
     /* 2067395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067405 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2067408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067431 */     // GIR_Coverage, 15565,
     /* 2067431 */     GIR_EraseRootFromParent_Done,
     /* 2067432 */   // Label 27479: @2067432
     /* 2067432 */   GIM_Try, /*On fail goto*//*Label 27480*/ GIMT_Encode4(2067523), // Rule ID 15568 //
     /* 2067437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2067445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2067448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2067451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2067454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2067457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067483 */     // MIs[0] round
     /* 2067483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067486 */     // MIs[0] policy
     /* 2067486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067496 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2067499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067522 */     // GIR_Coverage, 15568,
     /* 2067522 */     GIR_EraseRootFromParent_Done,
     /* 2067523 */   // Label 27480: @2067523
     /* 2067523 */   GIM_Try, /*On fail goto*//*Label 27481*/ GIMT_Encode4(2067614), // Rule ID 15569 //
     /* 2067528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2067536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2067539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2067542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2067545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2067548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067574 */     // MIs[0] round
     /* 2067574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067577 */     // MIs[0] policy
     /* 2067577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067587 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2067590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067613 */     // GIR_Coverage, 15569,
     /* 2067613 */     GIR_EraseRootFromParent_Done,
     /* 2067614 */   // Label 27481: @2067614
     /* 2067614 */   GIM_Try, /*On fail goto*//*Label 27482*/ GIMT_Encode4(2067705), // Rule ID 15572 //
     /* 2067619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2067627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2067630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2067633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2067636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2067639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067665 */     // MIs[0] round
     /* 2067665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067668 */     // MIs[0] policy
     /* 2067668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2067681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067704 */     // GIR_Coverage, 15572,
     /* 2067704 */     GIR_EraseRootFromParent_Done,
     /* 2067705 */   // Label 27482: @2067705
     /* 2067705 */   GIM_Try, /*On fail goto*//*Label 27483*/ GIMT_Encode4(2067796), // Rule ID 15573 //
     /* 2067710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2067718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2067721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2067724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2067727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2067730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067756 */     // MIs[0] round
     /* 2067756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067759 */     // MIs[0] policy
     /* 2067759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067769 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2067772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067795 */     // GIR_Coverage, 15573,
     /* 2067795 */     GIR_EraseRootFromParent_Done,
     /* 2067796 */   // Label 27483: @2067796
     /* 2067796 */   GIM_Try, /*On fail goto*//*Label 27484*/ GIMT_Encode4(2067887), // Rule ID 15576 //
     /* 2067801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2067804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2067809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2067812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2067815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2067818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2067821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067847 */     // MIs[0] round
     /* 2067847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067850 */     // MIs[0] policy
     /* 2067850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067860 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2067863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067886 */     // GIR_Coverage, 15576,
     /* 2067886 */     GIR_EraseRootFromParent_Done,
     /* 2067887 */   // Label 27484: @2067887
     /* 2067887 */   GIM_Try, /*On fail goto*//*Label 27485*/ GIMT_Encode4(2067978), // Rule ID 15577 //
     /* 2067892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2067895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2067900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2067903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2067906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2067909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2067912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067938 */     // MIs[0] round
     /* 2067938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067941 */     // MIs[0] policy
     /* 2067941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067951 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2067954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067977 */     // GIR_Coverage, 15577,
     /* 2067977 */     GIR_EraseRootFromParent_Done,
     /* 2067978 */   // Label 27485: @2067978
     /* 2067978 */   GIM_Try, /*On fail goto*//*Label 27486*/ GIMT_Encode4(2068069), // Rule ID 15580 //
     /* 2067983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2067991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2067994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2067997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2068000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2068003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068029 */     // MIs[0] round
     /* 2068029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068032 */     // MIs[0] policy
     /* 2068032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068042 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2068045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068068 */     // GIR_Coverage, 15580,
     /* 2068068 */     GIR_EraseRootFromParent_Done,
     /* 2068069 */   // Label 27486: @2068069
     /* 2068069 */   GIM_Try, /*On fail goto*//*Label 27487*/ GIMT_Encode4(2068160), // Rule ID 15581 //
     /* 2068074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2068082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2068085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2068088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2068091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2068094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068120 */     // MIs[0] round
     /* 2068120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068123 */     // MIs[0] policy
     /* 2068123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068133 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2068136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068159 */     // GIR_Coverage, 15581,
     /* 2068159 */     GIR_EraseRootFromParent_Done,
     /* 2068160 */   // Label 27487: @2068160
     /* 2068160 */   GIM_Try, /*On fail goto*//*Label 27488*/ GIMT_Encode4(2068251), // Rule ID 15584 //
     /* 2068165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2068173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2068176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2068179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2068182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2068185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068211 */     // MIs[0] round
     /* 2068211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068214 */     // MIs[0] policy
     /* 2068214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068224 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2068227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068250 */     // GIR_Coverage, 15584,
     /* 2068250 */     GIR_EraseRootFromParent_Done,
     /* 2068251 */   // Label 27488: @2068251
     /* 2068251 */   GIM_Try, /*On fail goto*//*Label 27489*/ GIMT_Encode4(2068342), // Rule ID 15585 //
     /* 2068256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2068264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2068267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2068270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2068273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2068276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068302 */     // MIs[0] round
     /* 2068302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068305 */     // MIs[0] policy
     /* 2068305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068315 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2068318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068341 */     // GIR_Coverage, 15585,
     /* 2068341 */     GIR_EraseRootFromParent_Done,
     /* 2068342 */   // Label 27489: @2068342
     /* 2068342 */   GIM_Try, /*On fail goto*//*Label 27490*/ GIMT_Encode4(2068433), // Rule ID 15588 //
     /* 2068347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2068355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2068358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2068361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2068364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2068367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2068370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068393 */     // MIs[0] round
     /* 2068393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068396 */     // MIs[0] policy
     /* 2068396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068406 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2068409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068432 */     // GIR_Coverage, 15588,
     /* 2068432 */     GIR_EraseRootFromParent_Done,
     /* 2068433 */   // Label 27490: @2068433
     /* 2068433 */   GIM_Try, /*On fail goto*//*Label 27491*/ GIMT_Encode4(2068524), // Rule ID 15589 //
     /* 2068438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2068446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2068449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2068452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2068455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2068458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2068461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068484 */     // MIs[0] round
     /* 2068484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068487 */     // MIs[0] policy
     /* 2068487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068497 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2068500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068523 */     // GIR_Coverage, 15589,
     /* 2068523 */     GIR_EraseRootFromParent_Done,
     /* 2068524 */   // Label 27491: @2068524
     /* 2068524 */   GIM_Try, /*On fail goto*//*Label 27492*/ GIMT_Encode4(2068615), // Rule ID 15592 //
     /* 2068529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2068537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2068540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2068543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2068546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2068549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068575 */     // MIs[0] round
     /* 2068575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068578 */     // MIs[0] policy
     /* 2068578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068588 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2068591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068614 */     // GIR_Coverage, 15592,
     /* 2068614 */     GIR_EraseRootFromParent_Done,
     /* 2068615 */   // Label 27492: @2068615
     /* 2068615 */   GIM_Try, /*On fail goto*//*Label 27493*/ GIMT_Encode4(2068706), // Rule ID 15593 //
     /* 2068620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2068628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2068631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2068634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2068637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2068640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068666 */     // MIs[0] round
     /* 2068666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068669 */     // MIs[0] policy
     /* 2068669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068679 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2068682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068705 */     // GIR_Coverage, 15593,
     /* 2068705 */     GIR_EraseRootFromParent_Done,
     /* 2068706 */   // Label 27493: @2068706
     /* 2068706 */   GIM_Try, /*On fail goto*//*Label 27494*/ GIMT_Encode4(2068797), // Rule ID 15596 //
     /* 2068711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2068719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2068722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2068725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2068728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2068731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068757 */     // MIs[0] round
     /* 2068757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068760 */     // MIs[0] policy
     /* 2068760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068770 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2068773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068796 */     // GIR_Coverage, 15596,
     /* 2068796 */     GIR_EraseRootFromParent_Done,
     /* 2068797 */   // Label 27494: @2068797
     /* 2068797 */   GIM_Try, /*On fail goto*//*Label 27495*/ GIMT_Encode4(2068888), // Rule ID 15597 //
     /* 2068802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2068810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2068813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2068816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2068819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2068822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068848 */     // MIs[0] round
     /* 2068848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068851 */     // MIs[0] policy
     /* 2068851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068861 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2068864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068887 */     // GIR_Coverage, 15597,
     /* 2068887 */     GIR_EraseRootFromParent_Done,
     /* 2068888 */   // Label 27495: @2068888
     /* 2068888 */   GIM_Try, /*On fail goto*//*Label 27496*/ GIMT_Encode4(2068979), // Rule ID 15600 //
     /* 2068893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2068901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2068904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2068907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2068910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2068913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068939 */     // MIs[0] round
     /* 2068939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068942 */     // MIs[0] policy
     /* 2068942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068952 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2068955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068978 */     // GIR_Coverage, 15600,
     /* 2068978 */     GIR_EraseRootFromParent_Done,
     /* 2068979 */   // Label 27496: @2068979
     /* 2068979 */   GIM_Try, /*On fail goto*//*Label 27497*/ GIMT_Encode4(2069070), // Rule ID 15601 //
     /* 2068984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2068992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2068995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2068998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2069001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2069004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2069007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069030 */     // MIs[0] round
     /* 2069030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069033 */     // MIs[0] policy
     /* 2069033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069043 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2069046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069069 */     // GIR_Coverage, 15601,
     /* 2069069 */     GIR_EraseRootFromParent_Done,
     /* 2069070 */   // Label 27497: @2069070
     /* 2069070 */   GIM_Try, /*On fail goto*//*Label 27498*/ GIMT_Encode4(2069161), // Rule ID 15604 //
     /* 2069075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2069083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2069086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2069089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2069092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069121 */     // MIs[0] round
     /* 2069121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069124 */     // MIs[0] policy
     /* 2069124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2069137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069160 */     // GIR_Coverage, 15604,
     /* 2069160 */     GIR_EraseRootFromParent_Done,
     /* 2069161 */   // Label 27498: @2069161
     /* 2069161 */   GIM_Try, /*On fail goto*//*Label 27499*/ GIMT_Encode4(2069252), // Rule ID 15605 //
     /* 2069166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2069174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2069177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2069180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2069183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2069186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069212 */     // MIs[0] round
     /* 2069212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069215 */     // MIs[0] policy
     /* 2069215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069225 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2069228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069251 */     // GIR_Coverage, 15605,
     /* 2069251 */     GIR_EraseRootFromParent_Done,
     /* 2069252 */   // Label 27499: @2069252
     /* 2069252 */   GIM_Try, /*On fail goto*//*Label 27500*/ GIMT_Encode4(2069343), // Rule ID 15608 //
     /* 2069257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2069265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2069268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2069271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2069274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069303 */     // MIs[0] round
     /* 2069303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069306 */     // MIs[0] policy
     /* 2069306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069316 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2069319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069342 */     // GIR_Coverage, 15608,
     /* 2069342 */     GIR_EraseRootFromParent_Done,
     /* 2069343 */   // Label 27500: @2069343
     /* 2069343 */   GIM_Try, /*On fail goto*//*Label 27501*/ GIMT_Encode4(2069434), // Rule ID 15609 //
     /* 2069348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2069356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2069359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2069362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2069365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2069368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069394 */     // MIs[0] round
     /* 2069394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069397 */     // MIs[0] policy
     /* 2069397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069407 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2069410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069433 */     // GIR_Coverage, 15609,
     /* 2069433 */     GIR_EraseRootFromParent_Done,
     /* 2069434 */   // Label 27501: @2069434
     /* 2069434 */   GIM_Try, /*On fail goto*//*Label 27502*/ GIMT_Encode4(2069525), // Rule ID 15612 //
     /* 2069439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2069447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2069450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2069453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2069456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069485 */     // MIs[0] round
     /* 2069485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069488 */     // MIs[0] policy
     /* 2069488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069498 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2069501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069524 */     // GIR_Coverage, 15612,
     /* 2069524 */     GIR_EraseRootFromParent_Done,
     /* 2069525 */   // Label 27502: @2069525
     /* 2069525 */   GIM_Try, /*On fail goto*//*Label 27503*/ GIMT_Encode4(2069616), // Rule ID 15613 //
     /* 2069530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2069538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2069541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2069544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2069547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2069550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069576 */     // MIs[0] round
     /* 2069576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069579 */     // MIs[0] policy
     /* 2069579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069589 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2069592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069615 */     // GIR_Coverage, 15613,
     /* 2069615 */     GIR_EraseRootFromParent_Done,
     /* 2069616 */   // Label 27503: @2069616
     /* 2069616 */   GIM_Try, /*On fail goto*//*Label 27504*/ GIMT_Encode4(2069707), // Rule ID 15616 //
     /* 2069621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2069624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2069629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2069632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2069635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2069638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2069644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069667 */     // MIs[0] round
     /* 2069667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069670 */     // MIs[0] policy
     /* 2069670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069680 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2069683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2069703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069706 */     // GIR_Coverage, 15616,
     /* 2069706 */     GIR_EraseRootFromParent_Done,
     /* 2069707 */   // Label 27504: @2069707
     /* 2069707 */   GIM_Try, /*On fail goto*//*Label 27505*/ GIMT_Encode4(2069798), // Rule ID 15617 //
     /* 2069712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2069715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2069720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2069723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2069726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2069729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2069732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2069735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069758 */     // MIs[0] round
     /* 2069758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069761 */     // MIs[0] policy
     /* 2069761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069771 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2069774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2069794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069797 */     // GIR_Coverage, 15617,
     /* 2069797 */     GIR_EraseRootFromParent_Done,
     /* 2069798 */   // Label 27505: @2069798
     /* 2069798 */   GIM_Try, /*On fail goto*//*Label 27506*/ GIMT_Encode4(2069889), // Rule ID 15620 //
     /* 2069803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2069806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2069811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2069814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2069817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2069820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069849 */     // MIs[0] round
     /* 2069849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069852 */     // MIs[0] policy
     /* 2069852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069862 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2069865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2069885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069888 */     // GIR_Coverage, 15620,
     /* 2069888 */     GIR_EraseRootFromParent_Done,
     /* 2069889 */   // Label 27506: @2069889
     /* 2069889 */   GIM_Try, /*On fail goto*//*Label 27507*/ GIMT_Encode4(2069980), // Rule ID 15621 //
     /* 2069894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2069897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2069902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2069905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2069908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2069911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2069914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069940 */     // MIs[0] round
     /* 2069940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069943 */     // MIs[0] policy
     /* 2069943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069953 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2069956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2069976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069979 */     // GIR_Coverage, 15621,
     /* 2069979 */     GIR_EraseRootFromParent_Done,
     /* 2069980 */   // Label 27507: @2069980
     /* 2069980 */   GIM_Try, /*On fail goto*//*Label 27508*/ GIMT_Encode4(2070071), // Rule ID 15624 //
     /* 2069985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2069988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2069993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2069996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2069999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2070002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2070008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070031 */     // MIs[0] round
     /* 2070031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070034 */     // MIs[0] policy
     /* 2070034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070044 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2070047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2070067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070070 */     // GIR_Coverage, 15624,
     /* 2070070 */     GIR_EraseRootFromParent_Done,
     /* 2070071 */   // Label 27508: @2070071
     /* 2070071 */   GIM_Try, /*On fail goto*//*Label 27509*/ GIMT_Encode4(2070162), // Rule ID 15625 //
     /* 2070076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2070079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2070084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2070087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2070090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2070093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2070099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070122 */     // MIs[0] round
     /* 2070122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070125 */     // MIs[0] policy
     /* 2070125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070135 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2070138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2070158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070161 */     // GIR_Coverage, 15625,
     /* 2070161 */     GIR_EraseRootFromParent_Done,
     /* 2070162 */   // Label 27509: @2070162
     /* 2070162 */   GIM_Try, /*On fail goto*//*Label 27510*/ GIMT_Encode4(2070256), // Rule ID 15628 //
     /* 2070167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2070178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2070181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2070184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2070187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070213 */     // MIs[0] round
     /* 2070213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070216 */     // MIs[0] policy
     /* 2070216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070226 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2070229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070255 */     // GIR_Coverage, 15628,
     /* 2070255 */     GIR_EraseRootFromParent_Done,
     /* 2070256 */   // Label 27510: @2070256
     /* 2070256 */   GIM_Try, /*On fail goto*//*Label 27511*/ GIMT_Encode4(2070350), // Rule ID 15629 //
     /* 2070261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2070272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2070275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2070278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2070281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070307 */     // MIs[0] round
     /* 2070307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070310 */     // MIs[0] policy
     /* 2070310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070320 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2070323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070349 */     // GIR_Coverage, 15629,
     /* 2070349 */     GIR_EraseRootFromParent_Done,
     /* 2070350 */   // Label 27511: @2070350
     /* 2070350 */   GIM_Try, /*On fail goto*//*Label 27512*/ GIMT_Encode4(2070444), // Rule ID 15632 //
     /* 2070355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2070366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2070369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2070372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2070375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070401 */     // MIs[0] round
     /* 2070401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070404 */     // MIs[0] policy
     /* 2070404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070414 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2070417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070443 */     // GIR_Coverage, 15632,
     /* 2070443 */     GIR_EraseRootFromParent_Done,
     /* 2070444 */   // Label 27512: @2070444
     /* 2070444 */   GIM_Try, /*On fail goto*//*Label 27513*/ GIMT_Encode4(2070538), // Rule ID 15633 //
     /* 2070449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2070460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2070463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2070466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2070469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070495 */     // MIs[0] round
     /* 2070495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070498 */     // MIs[0] policy
     /* 2070498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070508 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2070511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070533 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070537 */     // GIR_Coverage, 15633,
     /* 2070537 */     GIR_EraseRootFromParent_Done,
     /* 2070538 */   // Label 27513: @2070538
     /* 2070538 */   GIM_Try, /*On fail goto*//*Label 27514*/ GIMT_Encode4(2070632), // Rule ID 15636 //
     /* 2070543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2070554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2070557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2070560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2070563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070589 */     // MIs[0] round
     /* 2070589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070592 */     // MIs[0] policy
     /* 2070592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070602 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2070605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070631 */     // GIR_Coverage, 15636,
     /* 2070631 */     GIR_EraseRootFromParent_Done,
     /* 2070632 */   // Label 27514: @2070632
     /* 2070632 */   GIM_Try, /*On fail goto*//*Label 27515*/ GIMT_Encode4(2070726), // Rule ID 15637 //
     /* 2070637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2070648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2070651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2070654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2070657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070683 */     // MIs[0] round
     /* 2070683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070686 */     // MIs[0] policy
     /* 2070686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070696 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2070699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070725 */     // GIR_Coverage, 15637,
     /* 2070725 */     GIR_EraseRootFromParent_Done,
     /* 2070726 */   // Label 27515: @2070726
     /* 2070726 */   GIM_Try, /*On fail goto*//*Label 27516*/ GIMT_Encode4(2070820), // Rule ID 15640 //
     /* 2070731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2070742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2070745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2070748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2070751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070777 */     // MIs[0] round
     /* 2070777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070780 */     // MIs[0] policy
     /* 2070780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070790 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2070793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070819 */     // GIR_Coverage, 15640,
     /* 2070819 */     GIR_EraseRootFromParent_Done,
     /* 2070820 */   // Label 27516: @2070820
     /* 2070820 */   GIM_Try, /*On fail goto*//*Label 27517*/ GIMT_Encode4(2070914), // Rule ID 15641 //
     /* 2070825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2070836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2070839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2070842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2070845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070871 */     // MIs[0] round
     /* 2070871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070874 */     // MIs[0] policy
     /* 2070874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070884 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2070887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070913 */     // GIR_Coverage, 15641,
     /* 2070913 */     GIR_EraseRootFromParent_Done,
     /* 2070914 */   // Label 27517: @2070914
     /* 2070914 */   GIM_Try, /*On fail goto*//*Label 27518*/ GIMT_Encode4(2071008), // Rule ID 15644 //
     /* 2070919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2070930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2070933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2070936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2070939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070965 */     // MIs[0] round
     /* 2070965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070968 */     // MIs[0] policy
     /* 2070968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070978 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2070981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071007 */     // GIR_Coverage, 15644,
     /* 2071007 */     GIR_EraseRootFromParent_Done,
     /* 2071008 */   // Label 27518: @2071008
     /* 2071008 */   GIM_Try, /*On fail goto*//*Label 27519*/ GIMT_Encode4(2071102), // Rule ID 15645 //
     /* 2071013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2071024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2071027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2071030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2071033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071059 */     // MIs[0] round
     /* 2071059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071062 */     // MIs[0] policy
     /* 2071062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071072 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2071075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071101 */     // GIR_Coverage, 15645,
     /* 2071101 */     GIR_EraseRootFromParent_Done,
     /* 2071102 */   // Label 27519: @2071102
     /* 2071102 */   GIM_Try, /*On fail goto*//*Label 27520*/ GIMT_Encode4(2071196), // Rule ID 15648 //
     /* 2071107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2071118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2071121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2071124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2071127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2071130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071153 */     // MIs[0] round
     /* 2071153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071156 */     // MIs[0] policy
     /* 2071156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071166 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2071169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071195 */     // GIR_Coverage, 15648,
     /* 2071195 */     GIR_EraseRootFromParent_Done,
     /* 2071196 */   // Label 27520: @2071196
     /* 2071196 */   GIM_Try, /*On fail goto*//*Label 27521*/ GIMT_Encode4(2071290), // Rule ID 15649 //
     /* 2071201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2071212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2071215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2071218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2071221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2071224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071247 */     // MIs[0] round
     /* 2071247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071250 */     // MIs[0] policy
     /* 2071250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071260 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2071263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071289 */     // GIR_Coverage, 15649,
     /* 2071289 */     GIR_EraseRootFromParent_Done,
     /* 2071290 */   // Label 27521: @2071290
     /* 2071290 */   GIM_Try, /*On fail goto*//*Label 27522*/ GIMT_Encode4(2071384), // Rule ID 15652 //
     /* 2071295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2071306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2071309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2071312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2071315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071341 */     // MIs[0] round
     /* 2071341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071344 */     // MIs[0] policy
     /* 2071344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071354 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2071357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071383 */     // GIR_Coverage, 15652,
     /* 2071383 */     GIR_EraseRootFromParent_Done,
     /* 2071384 */   // Label 27522: @2071384
     /* 2071384 */   GIM_Try, /*On fail goto*//*Label 27523*/ GIMT_Encode4(2071478), // Rule ID 15653 //
     /* 2071389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2071400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2071403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2071406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2071409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071435 */     // MIs[0] round
     /* 2071435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071438 */     // MIs[0] policy
     /* 2071438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071448 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2071451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071461 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071471 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071477 */     // GIR_Coverage, 15653,
     /* 2071477 */     GIR_EraseRootFromParent_Done,
     /* 2071478 */   // Label 27523: @2071478
     /* 2071478 */   GIM_Try, /*On fail goto*//*Label 27524*/ GIMT_Encode4(2071572), // Rule ID 15656 //
     /* 2071483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2071494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2071497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2071500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2071503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071529 */     // MIs[0] round
     /* 2071529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071532 */     // MIs[0] policy
     /* 2071532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071542 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2071545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071571 */     // GIR_Coverage, 15656,
     /* 2071571 */     GIR_EraseRootFromParent_Done,
     /* 2071572 */   // Label 27524: @2071572
     /* 2071572 */   GIM_Try, /*On fail goto*//*Label 27525*/ GIMT_Encode4(2071666), // Rule ID 15657 //
     /* 2071577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2071588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2071591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2071594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2071597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071623 */     // MIs[0] round
     /* 2071623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071626 */     // MIs[0] policy
     /* 2071626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071636 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2071639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071661 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071665 */     // GIR_Coverage, 15657,
     /* 2071665 */     GIR_EraseRootFromParent_Done,
     /* 2071666 */   // Label 27525: @2071666
     /* 2071666 */   GIM_Try, /*On fail goto*//*Label 27526*/ GIMT_Encode4(2071760), // Rule ID 15660 //
     /* 2071671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2071682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2071685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2071688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2071691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071717 */     // MIs[0] round
     /* 2071717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071720 */     // MIs[0] policy
     /* 2071720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071730 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2071733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071759 */     // GIR_Coverage, 15660,
     /* 2071759 */     GIR_EraseRootFromParent_Done,
     /* 2071760 */   // Label 27526: @2071760
     /* 2071760 */   GIM_Try, /*On fail goto*//*Label 27527*/ GIMT_Encode4(2071854), // Rule ID 15661 //
     /* 2071765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2071776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2071779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2071782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2071785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071811 */     // MIs[0] round
     /* 2071811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071814 */     // MIs[0] policy
     /* 2071814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2071827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071853 */     // GIR_Coverage, 15661,
     /* 2071853 */     GIR_EraseRootFromParent_Done,
     /* 2071854 */   // Label 27527: @2071854
     /* 2071854 */   GIM_Try, /*On fail goto*//*Label 27528*/ GIMT_Encode4(2071948), // Rule ID 15664 //
     /* 2071859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2071870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2071873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2071876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2071879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071905 */     // MIs[0] round
     /* 2071905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071908 */     // MIs[0] policy
     /* 2071908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071918 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2071921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071947 */     // GIR_Coverage, 15664,
     /* 2071947 */     GIR_EraseRootFromParent_Done,
     /* 2071948 */   // Label 27528: @2071948
     /* 2071948 */   GIM_Try, /*On fail goto*//*Label 27529*/ GIMT_Encode4(2072042), // Rule ID 15665 //
     /* 2071953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2071964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2071967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2071970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2071973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071999 */     // MIs[0] round
     /* 2071999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072002 */     // MIs[0] policy
     /* 2072002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072012 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2072015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072041 */     // GIR_Coverage, 15665,
     /* 2072041 */     GIR_EraseRootFromParent_Done,
     /* 2072042 */   // Label 27529: @2072042
     /* 2072042 */   GIM_Try, /*On fail goto*//*Label 27530*/ GIMT_Encode4(2072136), // Rule ID 15668 //
     /* 2072047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2072058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2072061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2072064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2072067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072093 */     // MIs[0] round
     /* 2072093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072096 */     // MIs[0] policy
     /* 2072096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072106 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2072109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072131 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072135 */     // GIR_Coverage, 15668,
     /* 2072135 */     GIR_EraseRootFromParent_Done,
     /* 2072136 */   // Label 27530: @2072136
     /* 2072136 */   GIM_Try, /*On fail goto*//*Label 27531*/ GIMT_Encode4(2072230), // Rule ID 15669 //
     /* 2072141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2072152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2072155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2072158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2072161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072187 */     // MIs[0] round
     /* 2072187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072190 */     // MIs[0] policy
     /* 2072190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072200 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2072203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072229 */     // GIR_Coverage, 15669,
     /* 2072229 */     GIR_EraseRootFromParent_Done,
     /* 2072230 */   // Label 27531: @2072230
     /* 2072230 */   GIM_Try, /*On fail goto*//*Label 27532*/ GIMT_Encode4(2072324), // Rule ID 15672 //
     /* 2072235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2072246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2072249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2072252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2072255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2072258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072281 */     // MIs[0] round
     /* 2072281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072284 */     // MIs[0] policy
     /* 2072284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072294 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2072297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072323 */     // GIR_Coverage, 15672,
     /* 2072323 */     GIR_EraseRootFromParent_Done,
     /* 2072324 */   // Label 27532: @2072324
     /* 2072324 */   GIM_Try, /*On fail goto*//*Label 27533*/ GIMT_Encode4(2072418), // Rule ID 15673 //
     /* 2072329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2072340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2072343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2072346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2072349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2072352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072375 */     // MIs[0] round
     /* 2072375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072378 */     // MIs[0] policy
     /* 2072378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072388 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2072391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072417 */     // GIR_Coverage, 15673,
     /* 2072417 */     GIR_EraseRootFromParent_Done,
     /* 2072418 */   // Label 27533: @2072418
     /* 2072418 */   GIM_Try, /*On fail goto*//*Label 27534*/ GIMT_Encode4(2072512), // Rule ID 15676 //
     /* 2072423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2072434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2072437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2072440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2072443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072469 */     // MIs[0] round
     /* 2072469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072472 */     // MIs[0] policy
     /* 2072472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2072485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072511 */     // GIR_Coverage, 15676,
     /* 2072511 */     GIR_EraseRootFromParent_Done,
     /* 2072512 */   // Label 27534: @2072512
     /* 2072512 */   GIM_Try, /*On fail goto*//*Label 27535*/ GIMT_Encode4(2072606), // Rule ID 15677 //
     /* 2072517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2072528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2072531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2072534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2072537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072563 */     // MIs[0] round
     /* 2072563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072566 */     // MIs[0] policy
     /* 2072566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072576 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2072579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072605 */     // GIR_Coverage, 15677,
     /* 2072605 */     GIR_EraseRootFromParent_Done,
     /* 2072606 */   // Label 27535: @2072606
     /* 2072606 */   GIM_Try, /*On fail goto*//*Label 27536*/ GIMT_Encode4(2072700), // Rule ID 15680 //
     /* 2072611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2072622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2072625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2072628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2072631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072657 */     // MIs[0] round
     /* 2072657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072660 */     // MIs[0] policy
     /* 2072660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072670 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2072673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072699 */     // GIR_Coverage, 15680,
     /* 2072699 */     GIR_EraseRootFromParent_Done,
     /* 2072700 */   // Label 27536: @2072700
     /* 2072700 */   GIM_Try, /*On fail goto*//*Label 27537*/ GIMT_Encode4(2072794), // Rule ID 15681 //
     /* 2072705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2072716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2072719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2072722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2072725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072751 */     // MIs[0] round
     /* 2072751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072754 */     // MIs[0] policy
     /* 2072754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072764 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2072767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072793 */     // GIR_Coverage, 15681,
     /* 2072793 */     GIR_EraseRootFromParent_Done,
     /* 2072794 */   // Label 27537: @2072794
     /* 2072794 */   GIM_Try, /*On fail goto*//*Label 27538*/ GIMT_Encode4(2072888), // Rule ID 15684 //
     /* 2072799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2072810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2072813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2072816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2072819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072845 */     // MIs[0] round
     /* 2072845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072848 */     // MIs[0] policy
     /* 2072848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072858 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2072861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072887 */     // GIR_Coverage, 15684,
     /* 2072887 */     GIR_EraseRootFromParent_Done,
     /* 2072888 */   // Label 27538: @2072888
     /* 2072888 */   GIM_Try, /*On fail goto*//*Label 27539*/ GIMT_Encode4(2072982), // Rule ID 15685 //
     /* 2072893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2072904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2072907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2072910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2072913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072939 */     // MIs[0] round
     /* 2072939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072942 */     // MIs[0] policy
     /* 2072942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072952 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2072955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072981 */     // GIR_Coverage, 15685,
     /* 2072981 */     GIR_EraseRootFromParent_Done,
     /* 2072982 */   // Label 27539: @2072982
     /* 2072982 */   GIM_Try, /*On fail goto*//*Label 27540*/ GIMT_Encode4(2073076), // Rule ID 15688 //
     /* 2072987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2072998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2073001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2073004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2073007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073033 */     // MIs[0] round
     /* 2073033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073036 */     // MIs[0] policy
     /* 2073036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073046 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2073049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073075 */     // GIR_Coverage, 15688,
     /* 2073075 */     GIR_EraseRootFromParent_Done,
     /* 2073076 */   // Label 27540: @2073076
     /* 2073076 */   GIM_Try, /*On fail goto*//*Label 27541*/ GIMT_Encode4(2073170), // Rule ID 15689 //
     /* 2073081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2073092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2073095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2073098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2073101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073127 */     // MIs[0] round
     /* 2073127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073130 */     // MIs[0] policy
     /* 2073130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073140 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2073143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073169 */     // GIR_Coverage, 15689,
     /* 2073169 */     GIR_EraseRootFromParent_Done,
     /* 2073170 */   // Label 27541: @2073170
     /* 2073170 */   GIM_Try, /*On fail goto*//*Label 27542*/ GIMT_Encode4(2073264), // Rule ID 15692 //
     /* 2073175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2073186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2073189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2073192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2073195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2073198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073221 */     // MIs[0] round
     /* 2073221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073224 */     // MIs[0] policy
     /* 2073224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073234 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2073237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073263 */     // GIR_Coverage, 15692,
     /* 2073263 */     GIR_EraseRootFromParent_Done,
     /* 2073264 */   // Label 27542: @2073264
     /* 2073264 */   GIM_Try, /*On fail goto*//*Label 27543*/ GIMT_Encode4(2073358), // Rule ID 15693 //
     /* 2073269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2073280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2073283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2073286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2073289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2073292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073315 */     // MIs[0] round
     /* 2073315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073318 */     // MIs[0] policy
     /* 2073318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2073331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073357 */     // GIR_Coverage, 15693,
     /* 2073357 */     GIR_EraseRootFromParent_Done,
     /* 2073358 */   // Label 27543: @2073358
     /* 2073358 */   GIM_Try, /*On fail goto*//*Label 27544*/ GIMT_Encode4(2073452), // Rule ID 15696 //
     /* 2073363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2073374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2073377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2073380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2073383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2073386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073409 */     // MIs[0] round
     /* 2073409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073412 */     // MIs[0] policy
     /* 2073412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073422 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2073425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073451 */     // GIR_Coverage, 15696,
     /* 2073451 */     GIR_EraseRootFromParent_Done,
     /* 2073452 */   // Label 27544: @2073452
     /* 2073452 */   GIM_Try, /*On fail goto*//*Label 27545*/ GIMT_Encode4(2073546), // Rule ID 15697 //
     /* 2073457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2073468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2073471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2073474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2073477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2073480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073503 */     // MIs[0] round
     /* 2073503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073506 */     // MIs[0] policy
     /* 2073506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073516 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2073519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073545 */     // GIR_Coverage, 15697,
     /* 2073545 */     GIR_EraseRootFromParent_Done,
     /* 2073546 */   // Label 27545: @2073546
     /* 2073546 */   GIM_Try, /*On fail goto*//*Label 27546*/ GIMT_Encode4(2073640), // Rule ID 15700 //
     /* 2073551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2073562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2073565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2073568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073597 */     // MIs[0] round
     /* 2073597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073600 */     // MIs[0] policy
     /* 2073600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073610 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2073613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073639 */     // GIR_Coverage, 15700,
     /* 2073639 */     GIR_EraseRootFromParent_Done,
     /* 2073640 */   // Label 27546: @2073640
     /* 2073640 */   GIM_Try, /*On fail goto*//*Label 27547*/ GIMT_Encode4(2073734), // Rule ID 15701 //
     /* 2073645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2073656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2073659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2073662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073691 */     // MIs[0] round
     /* 2073691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073694 */     // MIs[0] policy
     /* 2073694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073704 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2073707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073733 */     // GIR_Coverage, 15701,
     /* 2073733 */     GIR_EraseRootFromParent_Done,
     /* 2073734 */   // Label 27547: @2073734
     /* 2073734 */   GIM_Try, /*On fail goto*//*Label 27548*/ GIMT_Encode4(2073828), // Rule ID 15704 //
     /* 2073739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2073750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2073753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2073756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073785 */     // MIs[0] round
     /* 2073785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073788 */     // MIs[0] policy
     /* 2073788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073798 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2073801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073827 */     // GIR_Coverage, 15704,
     /* 2073827 */     GIR_EraseRootFromParent_Done,
     /* 2073828 */   // Label 27548: @2073828
     /* 2073828 */   GIM_Try, /*On fail goto*//*Label 27549*/ GIMT_Encode4(2073922), // Rule ID 15705 //
     /* 2073833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2073844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2073847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2073850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073879 */     // MIs[0] round
     /* 2073879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073882 */     // MIs[0] policy
     /* 2073882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073892 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2073895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073921 */     // GIR_Coverage, 15705,
     /* 2073921 */     GIR_EraseRootFromParent_Done,
     /* 2073922 */   // Label 27549: @2073922
     /* 2073922 */   GIM_Try, /*On fail goto*//*Label 27550*/ GIMT_Encode4(2074016), // Rule ID 15708 //
     /* 2073927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2073938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2073941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2073944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073973 */     // MIs[0] round
     /* 2073973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073976 */     // MIs[0] policy
     /* 2073976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073986 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2073989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2074009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074015 */     // GIR_Coverage, 15708,
     /* 2074015 */     GIR_EraseRootFromParent_Done,
     /* 2074016 */   // Label 27550: @2074016
     /* 2074016 */   GIM_Try, /*On fail goto*//*Label 27551*/ GIMT_Encode4(2074110), // Rule ID 15709 //
     /* 2074021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2074032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2074035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2074038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074067 */     // MIs[0] round
     /* 2074067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074070 */     // MIs[0] policy
     /* 2074070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074080 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2074083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2074103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074109 */     // GIR_Coverage, 15709,
     /* 2074109 */     GIR_EraseRootFromParent_Done,
     /* 2074110 */   // Label 27551: @2074110
     /* 2074110 */   GIM_Try, /*On fail goto*//*Label 27552*/ GIMT_Encode4(2074204), // Rule ID 15712 //
     /* 2074115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2074126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2074129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2074132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2074138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074161 */     // MIs[0] round
     /* 2074161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074164 */     // MIs[0] policy
     /* 2074164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074174 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2074177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074197 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074203 */     // GIR_Coverage, 15712,
     /* 2074203 */     GIR_EraseRootFromParent_Done,
     /* 2074204 */   // Label 27552: @2074204
     /* 2074204 */   GIM_Try, /*On fail goto*//*Label 27553*/ GIMT_Encode4(2074298), // Rule ID 15713 //
     /* 2074209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2074220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2074223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2074226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2074232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074255 */     // MIs[0] round
     /* 2074255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074258 */     // MIs[0] policy
     /* 2074258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2074271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074297 */     // GIR_Coverage, 15713,
     /* 2074297 */     GIR_EraseRootFromParent_Done,
     /* 2074298 */   // Label 27553: @2074298
     /* 2074298 */   GIM_Try, /*On fail goto*//*Label 27554*/ GIMT_Encode4(2074392), // Rule ID 15716 //
     /* 2074303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2074314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2074317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2074320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074349 */     // MIs[0] round
     /* 2074349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074352 */     // MIs[0] policy
     /* 2074352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074362 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2074365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074391 */     // GIR_Coverage, 15716,
     /* 2074391 */     GIR_EraseRootFromParent_Done,
     /* 2074392 */   // Label 27554: @2074392
     /* 2074392 */   GIM_Try, /*On fail goto*//*Label 27555*/ GIMT_Encode4(2074486), // Rule ID 15717 //
     /* 2074397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2074408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2074411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2074414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074443 */     // MIs[0] round
     /* 2074443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074446 */     // MIs[0] policy
     /* 2074446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074456 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2074459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074485 */     // GIR_Coverage, 15717,
     /* 2074485 */     GIR_EraseRootFromParent_Done,
     /* 2074486 */   // Label 27555: @2074486
     /* 2074486 */   GIM_Try, /*On fail goto*//*Label 27556*/ GIMT_Encode4(2074580), // Rule ID 15720 //
     /* 2074491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2074502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2074505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2074508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2074514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074537 */     // MIs[0] round
     /* 2074537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074540 */     // MIs[0] policy
     /* 2074540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074550 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2074553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074579 */     // GIR_Coverage, 15720,
     /* 2074579 */     GIR_EraseRootFromParent_Done,
     /* 2074580 */   // Label 27556: @2074580
     /* 2074580 */   GIM_Try, /*On fail goto*//*Label 27557*/ GIMT_Encode4(2074674), // Rule ID 15721 //
     /* 2074585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2074596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2074599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2074602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2074608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074631 */     // MIs[0] round
     /* 2074631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074634 */     // MIs[0] policy
     /* 2074634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074644 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2074647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074673 */     // GIR_Coverage, 15721,
     /* 2074673 */     GIR_EraseRootFromParent_Done,
     /* 2074674 */   // Label 27557: @2074674
     /* 2074674 */   GIM_Try, /*On fail goto*//*Label 27558*/ GIMT_Encode4(2074768), // Rule ID 15724 //
     /* 2074679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2074690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2074693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2074696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074725 */     // MIs[0] round
     /* 2074725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074728 */     // MIs[0] policy
     /* 2074728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074738 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2074741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2074761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074767 */     // GIR_Coverage, 15724,
     /* 2074767 */     GIR_EraseRootFromParent_Done,
     /* 2074768 */   // Label 27558: @2074768
     /* 2074768 */   GIM_Try, /*On fail goto*//*Label 27559*/ GIMT_Encode4(2074862), // Rule ID 15725 //
     /* 2074773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2074784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2074787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2074790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074819 */     // MIs[0] round
     /* 2074819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074822 */     // MIs[0] policy
     /* 2074822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074832 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2074835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2074855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074861 */     // GIR_Coverage, 15725,
     /* 2074861 */     GIR_EraseRootFromParent_Done,
     /* 2074862 */   // Label 27559: @2074862
     /* 2074862 */   GIM_Try, /*On fail goto*//*Label 27560*/ GIMT_Encode4(2074956), // Rule ID 15728 //
     /* 2074867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2074878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2074881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2074884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074913 */     // MIs[0] round
     /* 2074913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074916 */     // MIs[0] policy
     /* 2074916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074926 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2074929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074955 */     // GIR_Coverage, 15728,
     /* 2074955 */     GIR_EraseRootFromParent_Done,
     /* 2074956 */   // Label 27560: @2074956
     /* 2074956 */   GIM_Try, /*On fail goto*//*Label 27561*/ GIMT_Encode4(2075050), // Rule ID 15729 //
     /* 2074961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2074972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2074975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2074978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075007 */     // MIs[0] round
     /* 2075007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075010 */     // MIs[0] policy
     /* 2075010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2075023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2075048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075049 */     // GIR_Coverage, 15729,
     /* 2075049 */     GIR_EraseRootFromParent_Done,
     /* 2075050 */   // Label 27561: @2075050
     /* 2075050 */   GIM_Try, /*On fail goto*//*Label 27562*/ GIMT_Encode4(2075144), // Rule ID 15732 //
     /* 2075055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2075063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2075066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2075069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2075072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2075075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075101 */     // MIs[0] round
     /* 2075101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075104 */     // MIs[0] policy
     /* 2075104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2075117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2075137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2075142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075143 */     // GIR_Coverage, 15732,
     /* 2075143 */     GIR_EraseRootFromParent_Done,
     /* 2075144 */   // Label 27562: @2075144
     /* 2075144 */   GIM_Try, /*On fail goto*//*Label 27563*/ GIMT_Encode4(2075238), // Rule ID 15733 //
     /* 2075149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2075157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2075160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2075163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2075166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2075169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075195 */     // MIs[0] round
     /* 2075195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075198 */     // MIs[0] policy
     /* 2075198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075208 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2075211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2075231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2075236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075237 */     // GIR_Coverage, 15733,
     /* 2075237 */     GIR_EraseRootFromParent_Done,
     /* 2075238 */   // Label 27563: @2075238
     /* 2075238 */   GIM_Try, /*On fail goto*//*Label 27564*/ GIMT_Encode4(2075332), // Rule ID 15736 //
     /* 2075243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2075251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2075254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2075257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2075260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2075263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2075266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2075273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075289 */     // MIs[0] round
     /* 2075289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075292 */     // MIs[0] policy
     /* 2075292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075302 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2075305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2075330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075331 */     // GIR_Coverage, 15736,
     /* 2075331 */     GIR_EraseRootFromParent_Done,
     /* 2075332 */   // Label 27564: @2075332
     /* 2075332 */   GIM_Try, /*On fail goto*//*Label 27565*/ GIMT_Encode4(2075426), // Rule ID 15737 //
     /* 2075337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2075345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2075348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2075351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2075354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2075357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2075360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2075367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075383 */     // MIs[0] round
     /* 2075383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075386 */     // MIs[0] policy
     /* 2075386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2075399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2075424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075425 */     // GIR_Coverage, 15737,
     /* 2075425 */     GIR_EraseRootFromParent_Done,
     /* 2075426 */   // Label 27565: @2075426
     /* 2075426 */   GIM_Try, /*On fail goto*//*Label 27566*/ GIMT_Encode4(2075520), // Rule ID 15740 //
     /* 2075431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2075439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2075442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2075445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2075448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2075451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2075454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2075461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075477 */     // MIs[0] round
     /* 2075477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075480 */     // MIs[0] policy
     /* 2075480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075490 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2075493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2075518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075519 */     // GIR_Coverage, 15740,
     /* 2075519 */     GIR_EraseRootFromParent_Done,
     /* 2075520 */   // Label 27566: @2075520
     /* 2075520 */   GIM_Try, /*On fail goto*//*Label 27567*/ GIMT_Encode4(2075614), // Rule ID 15741 //
     /* 2075525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2075533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2075536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2075539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2075542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2075545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2075548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2075555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075571 */     // MIs[0] round
     /* 2075571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075574 */     // MIs[0] policy
     /* 2075574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075584 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2075587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075609 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2075612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075613 */     // GIR_Coverage, 15741,
     /* 2075613 */     GIR_EraseRootFromParent_Done,
     /* 2075614 */   // Label 27567: @2075614
     /* 2075614 */   GIM_Try, /*On fail goto*//*Label 27568*/ GIMT_Encode4(2075708), // Rule ID 15744 //
     /* 2075619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2075627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2075630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2075633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2075636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2075639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2075642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2075649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075665 */     // MIs[0] round
     /* 2075665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075668 */     // MIs[0] policy
     /* 2075668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075678 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2075681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075703 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2075706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075707 */     // GIR_Coverage, 15744,
     /* 2075707 */     GIR_EraseRootFromParent_Done,
     /* 2075708 */   // Label 27568: @2075708
     /* 2075708 */   GIM_Try, /*On fail goto*//*Label 27569*/ GIMT_Encode4(2075802), // Rule ID 15745 //
     /* 2075713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2075721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2075724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2075727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2075730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2075733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2075736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2075743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075759 */     // MIs[0] round
     /* 2075759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075762 */     // MIs[0] policy
     /* 2075762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075772 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2075775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2075800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075801 */     // GIR_Coverage, 15745,
     /* 2075801 */     GIR_EraseRootFromParent_Done,
     /* 2075802 */   // Label 27569: @2075802
     /* 2075802 */   GIM_Try, /*On fail goto*//*Label 27570*/ GIMT_Encode4(2075896), // Rule ID 15748 //
     /* 2075807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2075815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2075818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2075821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2075824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2075827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2075830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2075837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075853 */     // MIs[0] round
     /* 2075853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075856 */     // MIs[0] policy
     /* 2075856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2075869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2075894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075895 */     // GIR_Coverage, 15748,
     /* 2075895 */     GIR_EraseRootFromParent_Done,
     /* 2075896 */   // Label 27570: @2075896
     /* 2075896 */   GIM_Try, /*On fail goto*//*Label 27571*/ GIMT_Encode4(2075990), // Rule ID 15749 //
     /* 2075901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2075909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2075912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2075915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2075918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2075921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2075924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2075931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075947 */     // MIs[0] round
     /* 2075947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075950 */     // MIs[0] policy
     /* 2075950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075960 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2075963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2075988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075989 */     // GIR_Coverage, 15749,
     /* 2075989 */     GIR_EraseRootFromParent_Done,
     /* 2075990 */   // Label 27571: @2075990
     /* 2075990 */   GIM_Try, /*On fail goto*//*Label 27572*/ GIMT_Encode4(2076084), // Rule ID 15752 //
     /* 2075995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2076003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2076006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2076009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2076012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2076015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2076018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2076025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076041 */     // MIs[0] round
     /* 2076041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076044 */     // MIs[0] policy
     /* 2076044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076054 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2076057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2076082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076083 */     // GIR_Coverage, 15752,
     /* 2076083 */     GIR_EraseRootFromParent_Done,
     /* 2076084 */   // Label 27572: @2076084
     /* 2076084 */   GIM_Try, /*On fail goto*//*Label 27573*/ GIMT_Encode4(2076178), // Rule ID 15753 //
     /* 2076089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2076097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2076100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2076103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2076106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2076109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2076112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2076119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076135 */     // MIs[0] round
     /* 2076135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076138 */     // MIs[0] policy
     /* 2076138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076148 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2076151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2076176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076177 */     // GIR_Coverage, 15753,
     /* 2076177 */     GIR_EraseRootFromParent_Done,
     /* 2076178 */   // Label 27573: @2076178
     /* 2076178 */   GIM_Try, /*On fail goto*//*Label 27574*/ GIMT_Encode4(2076272), // Rule ID 15756 //
     /* 2076183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2076191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2076194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2076197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2076200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2076203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2076206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2076213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076229 */     // MIs[0] round
     /* 2076229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076232 */     // MIs[0] policy
     /* 2076232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076242 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2076245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2076270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076271 */     // GIR_Coverage, 15756,
     /* 2076271 */     GIR_EraseRootFromParent_Done,
     /* 2076272 */   // Label 27574: @2076272
     /* 2076272 */   GIM_Try, /*On fail goto*//*Label 27575*/ GIMT_Encode4(2076366), // Rule ID 15757 //
     /* 2076277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2076285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2076288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2076291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2076294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2076297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2076300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2076307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076323 */     // MIs[0] round
     /* 2076323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076326 */     // MIs[0] policy
     /* 2076326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076336 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2076339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2076364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076365 */     // GIR_Coverage, 15757,
     /* 2076365 */     GIR_EraseRootFromParent_Done,
     /* 2076366 */   // Label 27575: @2076366
     /* 2076366 */   GIM_Try, /*On fail goto*//*Label 27576*/ GIMT_Encode4(2076460), // Rule ID 15760 //
     /* 2076371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2076379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2076382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2076385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2076388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2076391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2076394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2076401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076417 */     // MIs[0] round
     /* 2076417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076420 */     // MIs[0] policy
     /* 2076420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2076433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2076458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076459 */     // GIR_Coverage, 15760,
     /* 2076459 */     GIR_EraseRootFromParent_Done,
     /* 2076460 */   // Label 27576: @2076460
     /* 2076460 */   GIM_Try, /*On fail goto*//*Label 27577*/ GIMT_Encode4(2076554), // Rule ID 15761 //
     /* 2076465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2076473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2076476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2076479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2076482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2076485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2076488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2076495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076511 */     // MIs[0] round
     /* 2076511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076514 */     // MIs[0] policy
     /* 2076514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076524 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2076527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2076552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076553 */     // GIR_Coverage, 15761,
     /* 2076553 */     GIR_EraseRootFromParent_Done,
     /* 2076554 */   // Label 27577: @2076554
     /* 2076554 */   GIM_Try, /*On fail goto*//*Label 27578*/ GIMT_Encode4(2076648), // Rule ID 15764 //
     /* 2076559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2076567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2076570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2076573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2076576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2076579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2076589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076605 */     // MIs[0] round
     /* 2076605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076608 */     // MIs[0] policy
     /* 2076608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2076621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2076646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076647 */     // GIR_Coverage, 15764,
     /* 2076647 */     GIR_EraseRootFromParent_Done,
     /* 2076648 */   // Label 27578: @2076648
     /* 2076648 */   GIM_Try, /*On fail goto*//*Label 27579*/ GIMT_Encode4(2076742), // Rule ID 15765 //
     /* 2076653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2076661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2076664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2076667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2076670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2076673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2076683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076699 */     // MIs[0] round
     /* 2076699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076702 */     // MIs[0] policy
     /* 2076702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076712 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2076715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2076740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076741 */     // GIR_Coverage, 15765,
     /* 2076741 */     GIR_EraseRootFromParent_Done,
     /* 2076742 */   // Label 27579: @2076742
     /* 2076742 */   GIM_Try, /*On fail goto*//*Label 27580*/ GIMT_Encode4(2076836), // Rule ID 15768 //
     /* 2076747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2076755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2076758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2076761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2076764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2076767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2076770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2076777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076793 */     // MIs[0] round
     /* 2076793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076796 */     // MIs[0] policy
     /* 2076796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076806 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2076809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2076834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076835 */     // GIR_Coverage, 15768,
     /* 2076835 */     GIR_EraseRootFromParent_Done,
     /* 2076836 */   // Label 27580: @2076836
     /* 2076836 */   GIM_Try, /*On fail goto*//*Label 27581*/ GIMT_Encode4(2076930), // Rule ID 15769 //
     /* 2076841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2076849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2076852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2076855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2076858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2076861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2076864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2076871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076887 */     // MIs[0] round
     /* 2076887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076890 */     // MIs[0] policy
     /* 2076890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076900 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2076903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2076928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076929 */     // GIR_Coverage, 15769,
     /* 2076929 */     GIR_EraseRootFromParent_Done,
     /* 2076930 */   // Label 27581: @2076930
     /* 2076930 */   GIM_Try, /*On fail goto*//*Label 27582*/ GIMT_Encode4(2077024), // Rule ID 15772 //
     /* 2076935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2076938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2076943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2076946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2076949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2076952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2076955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076981 */     // MIs[0] round
     /* 2076981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076984 */     // MIs[0] policy
     /* 2076984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076994 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2076997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2077022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077023 */     // GIR_Coverage, 15772,
     /* 2077023 */     GIR_EraseRootFromParent_Done,
     /* 2077024 */   // Label 27582: @2077024
     /* 2077024 */   GIM_Try, /*On fail goto*//*Label 27583*/ GIMT_Encode4(2077118), // Rule ID 15773 //
     /* 2077029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2077032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2077037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2077040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2077043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2077046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2077049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2077052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2077059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077075 */     // MIs[0] round
     /* 2077075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077078 */     // MIs[0] policy
     /* 2077078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077088 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2077091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2077116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077117 */     // GIR_Coverage, 15773,
     /* 2077117 */     GIR_EraseRootFromParent_Done,
     /* 2077118 */   // Label 27583: @2077118
     /* 2077118 */   GIM_Try, /*On fail goto*//*Label 27584*/ GIMT_Encode4(2077212), // Rule ID 15776 //
     /* 2077123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2077126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2077131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2077134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2077137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2077140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2077143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2077146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077169 */     // MIs[0] round
     /* 2077169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077172 */     // MIs[0] policy
     /* 2077172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2077185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2077210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077211 */     // GIR_Coverage, 15776,
     /* 2077211 */     GIR_EraseRootFromParent_Done,
     /* 2077212 */   // Label 27584: @2077212
     /* 2077212 */   GIM_Try, /*On fail goto*//*Label 27585*/ GIMT_Encode4(2077306), // Rule ID 15777 //
     /* 2077217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2077220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2077225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2077228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2077231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2077234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2077237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2077240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077263 */     // MIs[0] round
     /* 2077263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077266 */     // MIs[0] policy
     /* 2077266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2077279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2077304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077305 */     // GIR_Coverage, 15777,
     /* 2077305 */     GIR_EraseRootFromParent_Done,
     /* 2077306 */   // Label 27585: @2077306
     /* 2077306 */   GIM_Try, /*On fail goto*//*Label 27586*/ GIMT_Encode4(2077400), // Rule ID 15780 //
     /* 2077311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2077314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2077319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2077322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2077325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2077328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2077331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2077334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077357 */     // MIs[0] round
     /* 2077357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077360 */     // MIs[0] policy
     /* 2077360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077370 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2077373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2077398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077399 */     // GIR_Coverage, 15780,
     /* 2077399 */     GIR_EraseRootFromParent_Done,
     /* 2077400 */   // Label 27586: @2077400
     /* 2077400 */   GIM_Try, /*On fail goto*//*Label 27587*/ GIMT_Encode4(2077494), // Rule ID 15781 //
     /* 2077405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2077408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2077413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2077416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2077419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2077422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2077425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2077428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077451 */     // MIs[0] round
     /* 2077451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077454 */     // MIs[0] policy
     /* 2077454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077464 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2077467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2077492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077493 */     // GIR_Coverage, 15781,
     /* 2077493 */     GIR_EraseRootFromParent_Done,
     /* 2077494 */   // Label 27587: @2077494
     /* 2077494 */   GIM_Try, /*On fail goto*//*Label 27588*/ GIMT_Encode4(2077588), // Rule ID 15784 //
     /* 2077499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2077502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2077507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2077510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2077513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2077516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2077519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077545 */     // MIs[0] round
     /* 2077545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077548 */     // MIs[0] policy
     /* 2077548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077558 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2077561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2077586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077587 */     // GIR_Coverage, 15784,
     /* 2077587 */     GIR_EraseRootFromParent_Done,
     /* 2077588 */   // Label 27588: @2077588
     /* 2077588 */   GIM_Try, /*On fail goto*//*Label 27589*/ GIMT_Encode4(2077682), // Rule ID 15785 //
     /* 2077593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2077596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2077601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2077604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2077607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2077610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2077613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077639 */     // MIs[0] round
     /* 2077639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077642 */     // MIs[0] policy
     /* 2077642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077652 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2077655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2077680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077681 */     // GIR_Coverage, 15785,
     /* 2077681 */     GIR_EraseRootFromParent_Done,
     /* 2077682 */   // Label 27589: @2077682
     /* 2077682 */   GIM_Try, /*On fail goto*//*Label 27590*/ GIMT_Encode4(2077776), // Rule ID 15788 //
     /* 2077687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2077690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2077695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2077698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2077701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2077704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2077707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2077710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2077717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077733 */     // MIs[0] round
     /* 2077733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077736 */     // MIs[0] policy
     /* 2077736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077746 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2077749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2077774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077775 */     // GIR_Coverage, 15788,
     /* 2077775 */     GIR_EraseRootFromParent_Done,
     /* 2077776 */   // Label 27590: @2077776
     /* 2077776 */   GIM_Try, /*On fail goto*//*Label 27591*/ GIMT_Encode4(2077870), // Rule ID 15789 //
     /* 2077781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2077784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2077789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2077792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2077795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2077798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2077801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2077804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2077811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077827 */     // MIs[0] round
     /* 2077827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077830 */     // MIs[0] policy
     /* 2077830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077840 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2077843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2077868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077869 */     // GIR_Coverage, 15789,
     /* 2077869 */     GIR_EraseRootFromParent_Done,
     /* 2077870 */   // Label 27591: @2077870
     /* 2077870 */   GIM_Try, /*On fail goto*//*Label 27592*/ GIMT_Encode4(2077964), // Rule ID 15792 //
     /* 2077875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2077878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2077883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2077886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2077889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2077892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2077895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2077898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077921 */     // MIs[0] round
     /* 2077921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077924 */     // MIs[0] policy
     /* 2077924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077934 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2077937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2077962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077963 */     // GIR_Coverage, 15792,
     /* 2077963 */     GIR_EraseRootFromParent_Done,
     /* 2077964 */   // Label 27592: @2077964
     /* 2077964 */   GIM_Try, /*On fail goto*//*Label 27593*/ GIMT_Encode4(2078058), // Rule ID 15793 //
     /* 2077969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2077972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2077977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2077980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2077983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2077986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2077989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2077992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078015 */     // MIs[0] round
     /* 2078015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078018 */     // MIs[0] policy
     /* 2078018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078028 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2078031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2078056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078057 */     // GIR_Coverage, 15793,
     /* 2078057 */     GIR_EraseRootFromParent_Done,
     /* 2078058 */   // Label 27593: @2078058
     /* 2078058 */   GIM_Try, /*On fail goto*//*Label 27594*/ GIMT_Encode4(2078152), // Rule ID 15796 //
     /* 2078063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2078066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2078071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2078074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2078077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2078080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2078083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078109 */     // MIs[0] round
     /* 2078109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078112 */     // MIs[0] policy
     /* 2078112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078122 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2078125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2078150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078151 */     // GIR_Coverage, 15796,
     /* 2078151 */     GIR_EraseRootFromParent_Done,
     /* 2078152 */   // Label 27594: @2078152
     /* 2078152 */   GIM_Try, /*On fail goto*//*Label 27595*/ GIMT_Encode4(2078246), // Rule ID 15797 //
     /* 2078157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2078160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2078165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2078168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2078171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2078174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2078177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078203 */     // MIs[0] round
     /* 2078203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078206 */     // MIs[0] policy
     /* 2078206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078216 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2078219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2078244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078245 */     // GIR_Coverage, 15797,
     /* 2078245 */     GIR_EraseRootFromParent_Done,
     /* 2078246 */   // Label 27595: @2078246
     /* 2078246 */   GIM_Try, /*On fail goto*//*Label 27596*/ GIMT_Encode4(2078340), // Rule ID 15800 //
     /* 2078251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2078254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2078259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2078262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2078265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2078268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2078271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078297 */     // MIs[0] round
     /* 2078297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078300 */     // MIs[0] policy
     /* 2078300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078310 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2078313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2078338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078339 */     // GIR_Coverage, 15800,
     /* 2078339 */     GIR_EraseRootFromParent_Done,
     /* 2078340 */   // Label 27596: @2078340
     /* 2078340 */   GIM_Try, /*On fail goto*//*Label 27597*/ GIMT_Encode4(2078434), // Rule ID 15801 //
     /* 2078345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2078348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2078353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2078356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2078359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2078362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2078365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078391 */     // MIs[0] round
     /* 2078391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078394 */     // MIs[0] policy
     /* 2078394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078404 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2078407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2078432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078433 */     // GIR_Coverage, 15801,
     /* 2078433 */     GIR_EraseRootFromParent_Done,
     /* 2078434 */   // Label 27597: @2078434
     /* 2078434 */   GIM_Try, /*On fail goto*//*Label 27598*/ GIMT_Encode4(2078525), // Rule ID 15804 //
     /* 2078439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2078450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2078453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2078456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2078459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2078462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078485 */     // MIs[0] round
     /* 2078485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078488 */     // MIs[0] policy
     /* 2078488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078498 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2078501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078524 */     // GIR_Coverage, 15804,
     /* 2078524 */     GIR_EraseRootFromParent_Done,
     /* 2078525 */   // Label 27598: @2078525
     /* 2078525 */   GIM_Try, /*On fail goto*//*Label 27599*/ GIMT_Encode4(2078616), // Rule ID 15805 //
     /* 2078530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2078541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2078544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2078547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2078550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2078553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078576 */     // MIs[0] round
     /* 2078576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078579 */     // MIs[0] policy
     /* 2078579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078589 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2078592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078615 */     // GIR_Coverage, 15805,
     /* 2078615 */     GIR_EraseRootFromParent_Done,
     /* 2078616 */   // Label 27599: @2078616
     /* 2078616 */   GIM_Try, /*On fail goto*//*Label 27600*/ GIMT_Encode4(2078707), // Rule ID 15808 //
     /* 2078621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2078632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2078635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2078638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2078641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078667 */     // MIs[0] round
     /* 2078667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078670 */     // MIs[0] policy
     /* 2078670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078680 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2078683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078706 */     // GIR_Coverage, 15808,
     /* 2078706 */     GIR_EraseRootFromParent_Done,
     /* 2078707 */   // Label 27600: @2078707
     /* 2078707 */   GIM_Try, /*On fail goto*//*Label 27601*/ GIMT_Encode4(2078798), // Rule ID 15809 //
     /* 2078712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2078723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2078726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2078729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2078732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078758 */     // MIs[0] round
     /* 2078758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078761 */     // MIs[0] policy
     /* 2078761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078771 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2078774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078797 */     // GIR_Coverage, 15809,
     /* 2078797 */     GIR_EraseRootFromParent_Done,
     /* 2078798 */   // Label 27601: @2078798
     /* 2078798 */   GIM_Try, /*On fail goto*//*Label 27602*/ GIMT_Encode4(2078889), // Rule ID 15812 //
     /* 2078803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2078814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2078817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2078820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2078823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078849 */     // MIs[0] round
     /* 2078849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078852 */     // MIs[0] policy
     /* 2078852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078862 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2078865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078888 */     // GIR_Coverage, 15812,
     /* 2078888 */     GIR_EraseRootFromParent_Done,
     /* 2078889 */   // Label 27602: @2078889
     /* 2078889 */   GIM_Try, /*On fail goto*//*Label 27603*/ GIMT_Encode4(2078980), // Rule ID 15813 //
     /* 2078894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2078905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2078908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2078911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2078914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078940 */     // MIs[0] round
     /* 2078940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078943 */     // MIs[0] policy
     /* 2078943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078953 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2078956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078979 */     // GIR_Coverage, 15813,
     /* 2078979 */     GIR_EraseRootFromParent_Done,
     /* 2078980 */   // Label 27603: @2078980
     /* 2078980 */   GIM_Try, /*On fail goto*//*Label 27604*/ GIMT_Encode4(2079071), // Rule ID 15816 //
     /* 2078985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2078996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2078999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2079002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2079005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079031 */     // MIs[0] round
     /* 2079031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079034 */     // MIs[0] policy
     /* 2079034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079044 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2079047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079070 */     // GIR_Coverage, 15816,
     /* 2079070 */     GIR_EraseRootFromParent_Done,
     /* 2079071 */   // Label 27604: @2079071
     /* 2079071 */   GIM_Try, /*On fail goto*//*Label 27605*/ GIMT_Encode4(2079162), // Rule ID 15817 //
     /* 2079076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2079087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2079090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2079093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2079096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079122 */     // MIs[0] round
     /* 2079122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079125 */     // MIs[0] policy
     /* 2079125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079135 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2079138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079161 */     // GIR_Coverage, 15817,
     /* 2079161 */     GIR_EraseRootFromParent_Done,
     /* 2079162 */   // Label 27605: @2079162
     /* 2079162 */   GIM_Try, /*On fail goto*//*Label 27606*/ GIMT_Encode4(2079253), // Rule ID 15820 //
     /* 2079167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2079178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2079181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2079184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2079187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079213 */     // MIs[0] round
     /* 2079213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079216 */     // MIs[0] policy
     /* 2079216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079226 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2079229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079252 */     // GIR_Coverage, 15820,
     /* 2079252 */     GIR_EraseRootFromParent_Done,
     /* 2079253 */   // Label 27606: @2079253
     /* 2079253 */   GIM_Try, /*On fail goto*//*Label 27607*/ GIMT_Encode4(2079344), // Rule ID 15821 //
     /* 2079258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2079269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2079272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2079275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2079278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079304 */     // MIs[0] round
     /* 2079304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079307 */     // MIs[0] policy
     /* 2079307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079317 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2079320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079343 */     // GIR_Coverage, 15821,
     /* 2079343 */     GIR_EraseRootFromParent_Done,
     /* 2079344 */   // Label 27607: @2079344
     /* 2079344 */   GIM_Try, /*On fail goto*//*Label 27608*/ GIMT_Encode4(2079435), // Rule ID 15824 //
     /* 2079349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2079360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2079363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2079366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2079369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079395 */     // MIs[0] round
     /* 2079395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079398 */     // MIs[0] policy
     /* 2079398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079408 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2079411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2079431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079434 */     // GIR_Coverage, 15824,
     /* 2079434 */     GIR_EraseRootFromParent_Done,
     /* 2079435 */   // Label 27608: @2079435
     /* 2079435 */   GIM_Try, /*On fail goto*//*Label 27609*/ GIMT_Encode4(2079526), // Rule ID 15825 //
     /* 2079440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2079451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2079454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2079457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2079460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079486 */     // MIs[0] round
     /* 2079486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079489 */     // MIs[0] policy
     /* 2079489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079499 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2079502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2079522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079525 */     // GIR_Coverage, 15825,
     /* 2079525 */     GIR_EraseRootFromParent_Done,
     /* 2079526 */   // Label 27609: @2079526
     /* 2079526 */   GIM_Try, /*On fail goto*//*Label 27610*/ GIMT_Encode4(2079617), // Rule ID 15828 //
     /* 2079531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2079542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2079545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2079548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2079551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079577 */     // MIs[0] round
     /* 2079577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079580 */     // MIs[0] policy
     /* 2079580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079590 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2079593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079616 */     // GIR_Coverage, 15828,
     /* 2079616 */     GIR_EraseRootFromParent_Done,
     /* 2079617 */   // Label 27610: @2079617
     /* 2079617 */   GIM_Try, /*On fail goto*//*Label 27611*/ GIMT_Encode4(2079708), // Rule ID 15829 //
     /* 2079622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2079633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2079636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2079639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2079642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079668 */     // MIs[0] round
     /* 2079668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079671 */     // MIs[0] policy
     /* 2079671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079681 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2079684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079707 */     // GIR_Coverage, 15829,
     /* 2079707 */     GIR_EraseRootFromParent_Done,
     /* 2079708 */   // Label 27611: @2079708
     /* 2079708 */   GIM_Try, /*On fail goto*//*Label 27612*/ GIMT_Encode4(2079799), // Rule ID 15832 //
     /* 2079713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2079724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2079727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2079730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2079733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079759 */     // MIs[0] round
     /* 2079759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079762 */     // MIs[0] policy
     /* 2079762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079772 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2079775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079798 */     // GIR_Coverage, 15832,
     /* 2079798 */     GIR_EraseRootFromParent_Done,
     /* 2079799 */   // Label 27612: @2079799
     /* 2079799 */   GIM_Try, /*On fail goto*//*Label 27613*/ GIMT_Encode4(2079890), // Rule ID 15833 //
     /* 2079804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2079815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2079818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2079821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2079824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079850 */     // MIs[0] round
     /* 2079850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079853 */     // MIs[0] policy
     /* 2079853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079863 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2079866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079889 */     // GIR_Coverage, 15833,
     /* 2079889 */     GIR_EraseRootFromParent_Done,
     /* 2079890 */   // Label 27613: @2079890
     /* 2079890 */   GIM_Try, /*On fail goto*//*Label 27614*/ GIMT_Encode4(2079981), // Rule ID 15836 //
     /* 2079895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2079906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2079909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2079912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2079915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079941 */     // MIs[0] round
     /* 2079941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079944 */     // MIs[0] policy
     /* 2079944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079954 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2079957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2079977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079980 */     // GIR_Coverage, 15836,
     /* 2079980 */     GIR_EraseRootFromParent_Done,
     /* 2079981 */   // Label 27614: @2079981
     /* 2079981 */   GIM_Try, /*On fail goto*//*Label 27615*/ GIMT_Encode4(2080072), // Rule ID 15837 //
     /* 2079986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2079997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2080000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2080003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2080006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080032 */     // MIs[0] round
     /* 2080032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080035 */     // MIs[0] policy
     /* 2080035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080045 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2080048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080071 */     // GIR_Coverage, 15837,
     /* 2080071 */     GIR_EraseRootFromParent_Done,
     /* 2080072 */   // Label 27615: @2080072
     /* 2080072 */   GIM_Try, /*On fail goto*//*Label 27616*/ GIMT_Encode4(2080163), // Rule ID 15840 //
     /* 2080077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2080080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2080088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2080091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2080094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2080097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080123 */     // MIs[0] round
     /* 2080123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080126 */     // MIs[0] policy
     /* 2080126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080136 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2080139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080162 */     // GIR_Coverage, 15840,
     /* 2080162 */     GIR_EraseRootFromParent_Done,
     /* 2080163 */   // Label 27616: @2080163
     /* 2080163 */   GIM_Try, /*On fail goto*//*Label 27617*/ GIMT_Encode4(2080254), // Rule ID 15841 //
     /* 2080168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2080171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2080179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2080182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2080185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2080188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080214 */     // MIs[0] round
     /* 2080214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080217 */     // MIs[0] policy
     /* 2080217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080227 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2080230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080253 */     // GIR_Coverage, 15841,
     /* 2080253 */     GIR_EraseRootFromParent_Done,
     /* 2080254 */   // Label 27617: @2080254
     /* 2080254 */   GIM_Try, /*On fail goto*//*Label 27618*/ GIMT_Encode4(2080345), // Rule ID 15844 //
     /* 2080259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2080270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2080273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2080276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2080279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2080282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080305 */     // MIs[0] round
     /* 2080305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080308 */     // MIs[0] policy
     /* 2080308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2080321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080344 */     // GIR_Coverage, 15844,
     /* 2080344 */     GIR_EraseRootFromParent_Done,
     /* 2080345 */   // Label 27618: @2080345
     /* 2080345 */   GIM_Try, /*On fail goto*//*Label 27619*/ GIMT_Encode4(2080436), // Rule ID 15845 //
     /* 2080350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2080361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2080364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2080367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2080370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2080373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080396 */     // MIs[0] round
     /* 2080396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080399 */     // MIs[0] policy
     /* 2080399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080409 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2080412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080435 */     // GIR_Coverage, 15845,
     /* 2080435 */     GIR_EraseRootFromParent_Done,
     /* 2080436 */   // Label 27619: @2080436
     /* 2080436 */   GIM_Try, /*On fail goto*//*Label 27620*/ GIMT_Encode4(2080527), // Rule ID 15848 //
     /* 2080441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2080452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2080455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2080458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2080461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2080464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2080471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080487 */     // MIs[0] round
     /* 2080487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080490 */     // MIs[0] policy
     /* 2080490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080500 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2080503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080526 */     // GIR_Coverage, 15848,
     /* 2080526 */     GIR_EraseRootFromParent_Done,
     /* 2080527 */   // Label 27620: @2080527
     /* 2080527 */   GIM_Try, /*On fail goto*//*Label 27621*/ GIMT_Encode4(2080618), // Rule ID 15849 //
     /* 2080532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2080543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2080546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2080549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2080552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2080555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2080562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080578 */     // MIs[0] round
     /* 2080578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080581 */     // MIs[0] policy
     /* 2080581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080591 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2080594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080617 */     // GIR_Coverage, 15849,
     /* 2080617 */     GIR_EraseRootFromParent_Done,
     /* 2080618 */   // Label 27621: @2080618
     /* 2080618 */   GIM_Try, /*On fail goto*//*Label 27622*/ GIMT_Encode4(2080709), // Rule ID 15852 //
     /* 2080623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2080634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2080637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2080640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2080643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2080646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2080653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080669 */     // MIs[0] round
     /* 2080669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080672 */     // MIs[0] policy
     /* 2080672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080682 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2080685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080708 */     // GIR_Coverage, 15852,
     /* 2080708 */     GIR_EraseRootFromParent_Done,
     /* 2080709 */   // Label 27622: @2080709
     /* 2080709 */   GIM_Try, /*On fail goto*//*Label 27623*/ GIMT_Encode4(2080800), // Rule ID 15853 //
     /* 2080714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2080725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2080728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2080731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2080734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2080737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2080744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080760 */     // MIs[0] round
     /* 2080760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080763 */     // MIs[0] policy
     /* 2080763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080773 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2080776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080796 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080799 */     // GIR_Coverage, 15853,
     /* 2080799 */     GIR_EraseRootFromParent_Done,
     /* 2080800 */   // Label 27623: @2080800
     /* 2080800 */   GIM_Try, /*On fail goto*//*Label 27624*/ GIMT_Encode4(2080891), // Rule ID 15856 //
     /* 2080805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2080816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2080819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2080822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2080825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080851 */     // MIs[0] round
     /* 2080851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080854 */     // MIs[0] policy
     /* 2080854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080864 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2080867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080890 */     // GIR_Coverage, 15856,
     /* 2080890 */     GIR_EraseRootFromParent_Done,
     /* 2080891 */   // Label 27624: @2080891
     /* 2080891 */   GIM_Try, /*On fail goto*//*Label 27625*/ GIMT_Encode4(2080982), // Rule ID 15857 //
     /* 2080896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2080907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2080910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2080913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2080916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080942 */     // MIs[0] round
     /* 2080942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080945 */     // MIs[0] policy
     /* 2080945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080955 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2080958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080981 */     // GIR_Coverage, 15857,
     /* 2080981 */     GIR_EraseRootFromParent_Done,
     /* 2080982 */   // Label 27625: @2080982
     /* 2080982 */   GIM_Try, /*On fail goto*//*Label 27626*/ GIMT_Encode4(2081073), // Rule ID 15860 //
     /* 2080987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2080998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2081001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2081004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2081007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081033 */     // MIs[0] round
     /* 2081033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081036 */     // MIs[0] policy
     /* 2081036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081046 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2081049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081072 */     // GIR_Coverage, 15860,
     /* 2081072 */     GIR_EraseRootFromParent_Done,
     /* 2081073 */   // Label 27626: @2081073
     /* 2081073 */   GIM_Try, /*On fail goto*//*Label 27627*/ GIMT_Encode4(2081164), // Rule ID 15861 //
     /* 2081078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2081089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2081092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2081095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2081098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081124 */     // MIs[0] round
     /* 2081124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081127 */     // MIs[0] policy
     /* 2081127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081137 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2081140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081163 */     // GIR_Coverage, 15861,
     /* 2081163 */     GIR_EraseRootFromParent_Done,
     /* 2081164 */   // Label 27627: @2081164
     /* 2081164 */   GIM_Try, /*On fail goto*//*Label 27628*/ GIMT_Encode4(2081255), // Rule ID 15864 //
     /* 2081169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2081180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2081183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2081186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2081189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081215 */     // MIs[0] round
     /* 2081215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081218 */     // MIs[0] policy
     /* 2081218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081228 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2081231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081254 */     // GIR_Coverage, 15864,
     /* 2081254 */     GIR_EraseRootFromParent_Done,
     /* 2081255 */   // Label 27628: @2081255
     /* 2081255 */   GIM_Try, /*On fail goto*//*Label 27629*/ GIMT_Encode4(2081346), // Rule ID 15865 //
     /* 2081260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2081271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2081274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2081277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2081280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081306 */     // MIs[0] round
     /* 2081306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081309 */     // MIs[0] policy
     /* 2081309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081319 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2081322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081345 */     // GIR_Coverage, 15865,
     /* 2081345 */     GIR_EraseRootFromParent_Done,
     /* 2081346 */   // Label 27629: @2081346
     /* 2081346 */   GIM_Try, /*On fail goto*//*Label 27630*/ GIMT_Encode4(2081437), // Rule ID 15868 //
     /* 2081351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2081362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2081365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2081368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2081371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2081374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081397 */     // MIs[0] round
     /* 2081397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081400 */     // MIs[0] policy
     /* 2081400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2081413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081436 */     // GIR_Coverage, 15868,
     /* 2081436 */     GIR_EraseRootFromParent_Done,
     /* 2081437 */   // Label 27630: @2081437
     /* 2081437 */   GIM_Try, /*On fail goto*//*Label 27631*/ GIMT_Encode4(2081528), // Rule ID 15869 //
     /* 2081442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2081453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2081456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2081459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2081462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2081465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081488 */     // MIs[0] round
     /* 2081488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081491 */     // MIs[0] policy
     /* 2081491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2081504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081527 */     // GIR_Coverage, 15869,
     /* 2081527 */     GIR_EraseRootFromParent_Done,
     /* 2081528 */   // Label 27631: @2081528
     /* 2081528 */   GIM_Try, /*On fail goto*//*Label 27632*/ GIMT_Encode4(2081619), // Rule ID 15872 //
     /* 2081533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2081544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2081547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2081550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2081553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081579 */     // MIs[0] round
     /* 2081579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081582 */     // MIs[0] policy
     /* 2081582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2081595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081618 */     // GIR_Coverage, 15872,
     /* 2081618 */     GIR_EraseRootFromParent_Done,
     /* 2081619 */   // Label 27632: @2081619
     /* 2081619 */   GIM_Try, /*On fail goto*//*Label 27633*/ GIMT_Encode4(2081710), // Rule ID 15873 //
     /* 2081624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2081635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2081638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2081641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2081644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081670 */     // MIs[0] round
     /* 2081670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081673 */     // MIs[0] policy
     /* 2081673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081683 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2081686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081709 */     // GIR_Coverage, 15873,
     /* 2081709 */     GIR_EraseRootFromParent_Done,
     /* 2081710 */   // Label 27633: @2081710
     /* 2081710 */   GIM_Try, /*On fail goto*//*Label 27634*/ GIMT_Encode4(2081801), // Rule ID 15876 //
     /* 2081715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2081726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2081729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2081732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2081735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081761 */     // MIs[0] round
     /* 2081761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081764 */     // MIs[0] policy
     /* 2081764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081774 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2081777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081800 */     // GIR_Coverage, 15876,
     /* 2081800 */     GIR_EraseRootFromParent_Done,
     /* 2081801 */   // Label 27634: @2081801
     /* 2081801 */   GIM_Try, /*On fail goto*//*Label 27635*/ GIMT_Encode4(2081892), // Rule ID 15877 //
     /* 2081806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2081817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2081820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2081823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2081826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081852 */     // MIs[0] round
     /* 2081852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081855 */     // MIs[0] policy
     /* 2081855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081865 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2081868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081891 */     // GIR_Coverage, 15877,
     /* 2081891 */     GIR_EraseRootFromParent_Done,
     /* 2081892 */   // Label 27635: @2081892
     /* 2081892 */   GIM_Try, /*On fail goto*//*Label 27636*/ GIMT_Encode4(2081983), // Rule ID 15880 //
     /* 2081897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2081900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2081908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2081911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2081914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2081917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2081920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081943 */     // MIs[0] round
     /* 2081943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081946 */     // MIs[0] policy
     /* 2081946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081956 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2081959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2081979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081982 */     // GIR_Coverage, 15880,
     /* 2081982 */     GIR_EraseRootFromParent_Done,
     /* 2081983 */   // Label 27636: @2081983
     /* 2081983 */   GIM_Try, /*On fail goto*//*Label 27637*/ GIMT_Encode4(2082074), // Rule ID 15881 //
     /* 2081988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2081991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2081999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2082002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2082005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2082008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082034 */     // MIs[0] round
     /* 2082034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082037 */     // MIs[0] policy
     /* 2082037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082047 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2082050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082073 */     // GIR_Coverage, 15881,
     /* 2082073 */     GIR_EraseRootFromParent_Done,
     /* 2082074 */   // Label 27637: @2082074
     /* 2082074 */   GIM_Try, /*On fail goto*//*Label 27638*/ GIMT_Encode4(2082165), // Rule ID 15884 //
     /* 2082079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2082090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2082093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2082096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2082099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082125 */     // MIs[0] round
     /* 2082125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082128 */     // MIs[0] policy
     /* 2082128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082138 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2082141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082164 */     // GIR_Coverage, 15884,
     /* 2082164 */     GIR_EraseRootFromParent_Done,
     /* 2082165 */   // Label 27638: @2082165
     /* 2082165 */   GIM_Try, /*On fail goto*//*Label 27639*/ GIMT_Encode4(2082256), // Rule ID 15885 //
     /* 2082170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2082181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2082184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2082187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2082190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082216 */     // MIs[0] round
     /* 2082216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082219 */     // MIs[0] policy
     /* 2082219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082229 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2082232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082255 */     // GIR_Coverage, 15885,
     /* 2082255 */     GIR_EraseRootFromParent_Done,
     /* 2082256 */   // Label 27639: @2082256
     /* 2082256 */   GIM_Try, /*On fail goto*//*Label 27640*/ GIMT_Encode4(2082347), // Rule ID 15888 //
     /* 2082261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2082272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2082275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2082278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2082281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082307 */     // MIs[0] round
     /* 2082307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082310 */     // MIs[0] policy
     /* 2082310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082320 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2082323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082346 */     // GIR_Coverage, 15888,
     /* 2082346 */     GIR_EraseRootFromParent_Done,
     /* 2082347 */   // Label 27640: @2082347
     /* 2082347 */   GIM_Try, /*On fail goto*//*Label 27641*/ GIMT_Encode4(2082438), // Rule ID 15889 //
     /* 2082352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2082363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2082366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2082369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2082372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082398 */     // MIs[0] round
     /* 2082398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082401 */     // MIs[0] policy
     /* 2082401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082411 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2082414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082437 */     // GIR_Coverage, 15889,
     /* 2082437 */     GIR_EraseRootFromParent_Done,
     /* 2082438 */   // Label 27641: @2082438
     /* 2082438 */   GIM_Try, /*On fail goto*//*Label 27642*/ GIMT_Encode4(2082529), // Rule ID 15892 //
     /* 2082443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2082454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2082457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2082460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2082466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082489 */     // MIs[0] round
     /* 2082489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082492 */     // MIs[0] policy
     /* 2082492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082502 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2082505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082528 */     // GIR_Coverage, 15892,
     /* 2082528 */     GIR_EraseRootFromParent_Done,
     /* 2082529 */   // Label 27642: @2082529
     /* 2082529 */   GIM_Try, /*On fail goto*//*Label 27643*/ GIMT_Encode4(2082620), // Rule ID 15893 //
     /* 2082534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2082545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2082548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2082551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2082557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082580 */     // MIs[0] round
     /* 2082580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082583 */     // MIs[0] policy
     /* 2082583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082593 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2082596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082619 */     // GIR_Coverage, 15893,
     /* 2082619 */     GIR_EraseRootFromParent_Done,
     /* 2082620 */   // Label 27643: @2082620
     /* 2082620 */   GIM_Try, /*On fail goto*//*Label 27644*/ GIMT_Encode4(2082711), // Rule ID 15896 //
     /* 2082625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2082636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2082639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2082642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082671 */     // MIs[0] round
     /* 2082671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082674 */     // MIs[0] policy
     /* 2082674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082684 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2082687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082710 */     // GIR_Coverage, 15896,
     /* 2082710 */     GIR_EraseRootFromParent_Done,
     /* 2082711 */   // Label 27644: @2082711
     /* 2082711 */   GIM_Try, /*On fail goto*//*Label 27645*/ GIMT_Encode4(2082802), // Rule ID 15897 //
     /* 2082716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2082727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2082730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2082733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082762 */     // MIs[0] round
     /* 2082762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082765 */     // MIs[0] policy
     /* 2082765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082775 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2082778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082801 */     // GIR_Coverage, 15897,
     /* 2082801 */     GIR_EraseRootFromParent_Done,
     /* 2082802 */   // Label 27645: @2082802
     /* 2082802 */   GIM_Try, /*On fail goto*//*Label 27646*/ GIMT_Encode4(2082893), // Rule ID 15900 //
     /* 2082807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2082818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2082821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2082824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082853 */     // MIs[0] round
     /* 2082853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082856 */     // MIs[0] policy
     /* 2082856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082866 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2082869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082892 */     // GIR_Coverage, 15900,
     /* 2082892 */     GIR_EraseRootFromParent_Done,
     /* 2082893 */   // Label 27646: @2082893
     /* 2082893 */   GIM_Try, /*On fail goto*//*Label 27647*/ GIMT_Encode4(2082984), // Rule ID 15901 //
     /* 2082898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2082909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2082912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2082915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082944 */     // MIs[0] round
     /* 2082944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082947 */     // MIs[0] policy
     /* 2082947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082957 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2082960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082970 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082980 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082983 */     // GIR_Coverage, 15901,
     /* 2082983 */     GIR_EraseRootFromParent_Done,
     /* 2082984 */   // Label 27647: @2082984
     /* 2082984 */   GIM_Try, /*On fail goto*//*Label 27648*/ GIMT_Encode4(2083075), // Rule ID 15904 //
     /* 2082989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2083000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2083003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083035 */     // MIs[0] round
     /* 2083035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083038 */     // MIs[0] policy
     /* 2083038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083048 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2083051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083074 */     // GIR_Coverage, 15904,
     /* 2083074 */     GIR_EraseRootFromParent_Done,
     /* 2083075 */   // Label 27648: @2083075
     /* 2083075 */   GIM_Try, /*On fail goto*//*Label 27649*/ GIMT_Encode4(2083166), // Rule ID 15905 //
     /* 2083080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2083088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2083091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2083094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083126 */     // MIs[0] round
     /* 2083126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083129 */     // MIs[0] policy
     /* 2083129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083139 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2083142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083165 */     // GIR_Coverage, 15905,
     /* 2083165 */     GIR_EraseRootFromParent_Done,
     /* 2083166 */   // Label 27649: @2083166
     /* 2083166 */   GIM_Try, /*On fail goto*//*Label 27650*/ GIMT_Encode4(2083257), // Rule ID 15908 //
     /* 2083171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2083179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2083182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2083185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2083188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083217 */     // MIs[0] round
     /* 2083217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083220 */     // MIs[0] policy
     /* 2083220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083230 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2083233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083256 */     // GIR_Coverage, 15908,
     /* 2083256 */     GIR_EraseRootFromParent_Done,
     /* 2083257 */   // Label 27650: @2083257
     /* 2083257 */   GIM_Try, /*On fail goto*//*Label 27651*/ GIMT_Encode4(2083348), // Rule ID 15909 //
     /* 2083262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2083270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2083273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2083276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2083279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083308 */     // MIs[0] round
     /* 2083308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083311 */     // MIs[0] policy
     /* 2083311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083321 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2083324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083347 */     // GIR_Coverage, 15909,
     /* 2083347 */     GIR_EraseRootFromParent_Done,
     /* 2083348 */   // Label 27651: @2083348
     /* 2083348 */   GIM_Try, /*On fail goto*//*Label 27652*/ GIMT_Encode4(2083439), // Rule ID 15912 //
     /* 2083353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2083361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2083364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2083367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2083370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083399 */     // MIs[0] round
     /* 2083399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083402 */     // MIs[0] policy
     /* 2083402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083412 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2083415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2083435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083438 */     // GIR_Coverage, 15912,
     /* 2083438 */     GIR_EraseRootFromParent_Done,
     /* 2083439 */   // Label 27652: @2083439
     /* 2083439 */   GIM_Try, /*On fail goto*//*Label 27653*/ GIMT_Encode4(2083530), // Rule ID 15913 //
     /* 2083444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2083452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2083455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2083458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2083461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083490 */     // MIs[0] round
     /* 2083490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083493 */     // MIs[0] policy
     /* 2083493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083503 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2083506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2083526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083529 */     // GIR_Coverage, 15913,
     /* 2083529 */     GIR_EraseRootFromParent_Done,
     /* 2083530 */   // Label 27653: @2083530
     /* 2083530 */   GIM_Try, /*On fail goto*//*Label 27654*/ GIMT_Encode4(2083621), // Rule ID 15916 //
     /* 2083535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2083543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2083546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2083549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2083552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2083558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083581 */     // MIs[0] round
     /* 2083581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083584 */     // MIs[0] policy
     /* 2083584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083594 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2083597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083620 */     // GIR_Coverage, 15916,
     /* 2083620 */     GIR_EraseRootFromParent_Done,
     /* 2083621 */   // Label 27654: @2083621
     /* 2083621 */   GIM_Try, /*On fail goto*//*Label 27655*/ GIMT_Encode4(2083712), // Rule ID 15917 //
     /* 2083626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2083634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2083637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2083640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2083643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2083649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083672 */     // MIs[0] round
     /* 2083672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083675 */     // MIs[0] policy
     /* 2083675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083685 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2083688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083711 */     // GIR_Coverage, 15917,
     /* 2083711 */     GIR_EraseRootFromParent_Done,
     /* 2083712 */   // Label 27655: @2083712
     /* 2083712 */   GIM_Try, /*On fail goto*//*Label 27656*/ GIMT_Encode4(2083803), // Rule ID 15920 //
     /* 2083717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2083725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2083728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2083731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2083734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083763 */     // MIs[0] round
     /* 2083763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083766 */     // MIs[0] policy
     /* 2083766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083776 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2083779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083802 */     // GIR_Coverage, 15920,
     /* 2083802 */     GIR_EraseRootFromParent_Done,
     /* 2083803 */   // Label 27656: @2083803
     /* 2083803 */   GIM_Try, /*On fail goto*//*Label 27657*/ GIMT_Encode4(2083894), // Rule ID 15921 //
     /* 2083808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2083816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2083819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2083822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2083825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083854 */     // MIs[0] round
     /* 2083854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083857 */     // MIs[0] policy
     /* 2083857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083867 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2083870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083893 */     // GIR_Coverage, 15921,
     /* 2083893 */     GIR_EraseRootFromParent_Done,
     /* 2083894 */   // Label 27657: @2083894
     /* 2083894 */   GIM_Try, /*On fail goto*//*Label 27658*/ GIMT_Encode4(2083985), // Rule ID 15924 //
     /* 2083899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2083907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2083910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2083913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2083916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083945 */     // MIs[0] round
     /* 2083945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083948 */     // MIs[0] policy
     /* 2083948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2083961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2083981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083984 */     // GIR_Coverage, 15924,
     /* 2083984 */     GIR_EraseRootFromParent_Done,
     /* 2083985 */   // Label 27658: @2083985
     /* 2083985 */   GIM_Try, /*On fail goto*//*Label 27659*/ GIMT_Encode4(2084076), // Rule ID 15925 //
     /* 2083990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2083998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2084001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2084004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2084007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2084010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084036 */     // MIs[0] round
     /* 2084036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084039 */     // MIs[0] policy
     /* 2084039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084049 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2084052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084075 */     // GIR_Coverage, 15925,
     /* 2084075 */     GIR_EraseRootFromParent_Done,
     /* 2084076 */   // Label 27659: @2084076
     /* 2084076 */   GIM_Try, /*On fail goto*//*Label 27660*/ GIMT_Encode4(2084167), // Rule ID 15928 //
     /* 2084081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2084084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2084089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2084092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2084095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2084098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2084101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084127 */     // MIs[0] round
     /* 2084127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084130 */     // MIs[0] policy
     /* 2084130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2084143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2084163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084166 */     // GIR_Coverage, 15928,
     /* 2084166 */     GIR_EraseRootFromParent_Done,
     /* 2084167 */   // Label 27660: @2084167
     /* 2084167 */   GIM_Try, /*On fail goto*//*Label 27661*/ GIMT_Encode4(2084258), // Rule ID 15929 //
     /* 2084172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2084175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2084180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2084183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2084186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2084189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2084192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084218 */     // MIs[0] round
     /* 2084218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084221 */     // MIs[0] policy
     /* 2084221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084231 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2084234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2084254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084257 */     // GIR_Coverage, 15929,
     /* 2084257 */     GIR_EraseRootFromParent_Done,
     /* 2084258 */   // Label 27661: @2084258
     /* 2084258 */   GIM_Try, /*On fail goto*//*Label 27662*/ GIMT_Encode4(2084349), // Rule ID 15932 //
     /* 2084263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2084271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2084274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2084277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2084280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2084283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084309 */     // MIs[0] round
     /* 2084309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084312 */     // MIs[0] policy
     /* 2084312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084322 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2084325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084348 */     // GIR_Coverage, 15932,
     /* 2084348 */     GIR_EraseRootFromParent_Done,
     /* 2084349 */   // Label 27662: @2084349
     /* 2084349 */   GIM_Try, /*On fail goto*//*Label 27663*/ GIMT_Encode4(2084440), // Rule ID 15933 //
     /* 2084354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2084362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2084365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2084368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2084371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2084374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084400 */     // MIs[0] round
     /* 2084400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084403 */     // MIs[0] policy
     /* 2084403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084413 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2084416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084439 */     // GIR_Coverage, 15933,
     /* 2084439 */     GIR_EraseRootFromParent_Done,
     /* 2084440 */   // Label 27663: @2084440
     /* 2084440 */   GIM_Try, /*On fail goto*//*Label 27664*/ GIMT_Encode4(2084531), // Rule ID 15936 //
     /* 2084445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2084453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2084456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2084459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2084462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2084465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2084468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084491 */     // MIs[0] round
     /* 2084491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084494 */     // MIs[0] policy
     /* 2084494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084504 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2084507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084530 */     // GIR_Coverage, 15936,
     /* 2084530 */     GIR_EraseRootFromParent_Done,
     /* 2084531 */   // Label 27664: @2084531
     /* 2084531 */   GIM_Try, /*On fail goto*//*Label 27665*/ GIMT_Encode4(2084622), // Rule ID 15937 //
     /* 2084536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2084544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2084547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2084550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2084553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2084556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2084559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084582 */     // MIs[0] round
     /* 2084582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084585 */     // MIs[0] policy
     /* 2084585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084595 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2084598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084621 */     // GIR_Coverage, 15937,
     /* 2084621 */     GIR_EraseRootFromParent_Done,
     /* 2084622 */   // Label 27665: @2084622
     /* 2084622 */   GIM_Try, /*On fail goto*//*Label 27666*/ GIMT_Encode4(2084713), // Rule ID 15940 //
     /* 2084627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2084635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2084638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2084641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2084644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2084647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2084650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2084657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084673 */     // MIs[0] round
     /* 2084673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084676 */     // MIs[0] policy
     /* 2084676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084686 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2084689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084712 */     // GIR_Coverage, 15940,
     /* 2084712 */     GIR_EraseRootFromParent_Done,
     /* 2084713 */   // Label 27666: @2084713
     /* 2084713 */   GIM_Try, /*On fail goto*//*Label 27667*/ GIMT_Encode4(2084804), // Rule ID 15941 //
     /* 2084718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2084726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2084729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2084732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2084735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2084738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2084741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2084748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084764 */     // MIs[0] round
     /* 2084764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084767 */     // MIs[0] policy
     /* 2084767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084777 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2084780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084803 */     // GIR_Coverage, 15941,
     /* 2084803 */     GIR_EraseRootFromParent_Done,
     /* 2084804 */   // Label 27667: @2084804
     /* 2084804 */   GIM_Try, /*On fail goto*//*Label 27668*/ GIMT_Encode4(2084895), // Rule ID 15944 //
     /* 2084809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2084817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2084820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2084823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2084826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2084829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084855 */     // MIs[0] round
     /* 2084855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084858 */     // MIs[0] policy
     /* 2084858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2084871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084894 */     // GIR_Coverage, 15944,
     /* 2084894 */     GIR_EraseRootFromParent_Done,
     /* 2084895 */   // Label 27668: @2084895
     /* 2084895 */   GIM_Try, /*On fail goto*//*Label 27669*/ GIMT_Encode4(2084986), // Rule ID 15945 //
     /* 2084900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2084908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2084911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2084914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2084917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2084920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084946 */     // MIs[0] round
     /* 2084946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084949 */     // MIs[0] policy
     /* 2084949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084959 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2084962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084985 */     // GIR_Coverage, 15945,
     /* 2084985 */     GIR_EraseRootFromParent_Done,
     /* 2084986 */   // Label 27669: @2084986
     /* 2084986 */   GIM_Try, /*On fail goto*//*Label 27670*/ GIMT_Encode4(2085077), // Rule ID 15948 //
     /* 2084991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2084999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2085002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2085005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2085008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2085011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2085033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085037 */     // MIs[0] round
     /* 2085037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085040 */     // MIs[0] policy
     /* 2085040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085050 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2085053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085076 */     // GIR_Coverage, 15948,
     /* 2085076 */     GIR_EraseRootFromParent_Done,
     /* 2085077 */   // Label 27670: @2085077
     /* 2085077 */   GIM_Try, /*On fail goto*//*Label 27671*/ GIMT_Encode4(2085168), // Rule ID 15949 //
     /* 2085082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2085090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2085093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2085096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2085099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2085102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2085124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085128 */     // MIs[0] round
     /* 2085128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085131 */     // MIs[0] policy
     /* 2085131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085141 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2085144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085154 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085164 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085167 */     // GIR_Coverage, 15949,
     /* 2085167 */     GIR_EraseRootFromParent_Done,
     /* 2085168 */   // Label 27671: @2085168
     /* 2085168 */   GIM_Try, /*On fail goto*//*Label 27672*/ GIMT_Encode4(2085259), // Rule ID 15952 //
     /* 2085173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2085181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2085184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2085187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2085190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2085193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2085215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085219 */     // MIs[0] round
     /* 2085219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085222 */     // MIs[0] policy
     /* 2085222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085232 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2085235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085258 */     // GIR_Coverage, 15952,
     /* 2085258 */     GIR_EraseRootFromParent_Done,
     /* 2085259 */   // Label 27672: @2085259
     /* 2085259 */   GIM_Try, /*On fail goto*//*Label 27673*/ GIMT_Encode4(2085350), // Rule ID 15953 //
     /* 2085264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2085272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2085275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2085278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2085281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2085284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2085306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085310 */     // MIs[0] round
     /* 2085310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085313 */     // MIs[0] policy
     /* 2085313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085323 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2085326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085349 */     // GIR_Coverage, 15953,
     /* 2085349 */     GIR_EraseRootFromParent_Done,
     /* 2085350 */   // Label 27673: @2085350
     /* 2085350 */   GIM_Try, /*On fail goto*//*Label 27674*/ GIMT_Encode4(2085441), // Rule ID 15956 //
     /* 2085355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2085363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2085366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2085369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2085372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2085375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2085397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085401 */     // MIs[0] round
     /* 2085401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085404 */     // MIs[0] policy
     /* 2085404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2085417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085440 */     // GIR_Coverage, 15956,
     /* 2085440 */     GIR_EraseRootFromParent_Done,
     /* 2085441 */   // Label 27674: @2085441
     /* 2085441 */   GIM_Try, /*On fail goto*//*Label 27675*/ GIMT_Encode4(2085532), // Rule ID 15957 //
     /* 2085446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2085454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2085457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2085460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2085463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2085466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2085488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085492 */     // MIs[0] round
     /* 2085492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085495 */     // MIs[0] policy
     /* 2085495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085505 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2085508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085531 */     // GIR_Coverage, 15957,
     /* 2085531 */     GIR_EraseRootFromParent_Done,
     /* 2085532 */   // Label 27675: @2085532
     /* 2085532 */   GIM_Try, /*On fail goto*//*Label 27676*/ GIMT_Encode4(2085623), // Rule ID 15960 //
     /* 2085537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2085545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2085548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2085551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2085554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2085557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2085579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085583 */     // MIs[0] round
     /* 2085583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085586 */     // MIs[0] policy
     /* 2085586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2085599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085622 */     // GIR_Coverage, 15960,
     /* 2085622 */     GIR_EraseRootFromParent_Done,
     /* 2085623 */   // Label 27676: @2085623
     /* 2085623 */   GIM_Try, /*On fail goto*//*Label 27677*/ GIMT_Encode4(2085714), // Rule ID 15961 //
     /* 2085628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2085636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2085639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2085642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2085645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2085648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2085670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085674 */     // MIs[0] round
     /* 2085674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085677 */     // MIs[0] policy
     /* 2085677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085687 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2085690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085713 */     // GIR_Coverage, 15961,
     /* 2085713 */     GIR_EraseRootFromParent_Done,
     /* 2085714 */   // Label 27677: @2085714
     /* 2085714 */   GIM_Try, /*On fail goto*//*Label 27678*/ GIMT_Encode4(2085805), // Rule ID 15964 //
     /* 2085719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2085727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2085730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2085733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2085736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2085739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2085761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085765 */     // MIs[0] round
     /* 2085765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085768 */     // MIs[0] policy
     /* 2085768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085778 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2085781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085804 */     // GIR_Coverage, 15964,
     /* 2085804 */     GIR_EraseRootFromParent_Done,
     /* 2085805 */   // Label 27678: @2085805
     /* 2085805 */   GIM_Try, /*On fail goto*//*Label 27679*/ GIMT_Encode4(2085896), // Rule ID 15965 //
     /* 2085810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2085818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2085821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2085824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2085827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2085830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2085852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085856 */     // MIs[0] round
     /* 2085856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085859 */     // MIs[0] policy
     /* 2085859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085869 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2085872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085895 */     // GIR_Coverage, 15965,
     /* 2085895 */     GIR_EraseRootFromParent_Done,
     /* 2085896 */   // Label 27679: @2085896
     /* 2085896 */   GIM_Try, /*On fail goto*//*Label 27680*/ GIMT_Encode4(2085987), // Rule ID 15968 //
     /* 2085901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2085904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2085909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2085912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2085915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2085918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2085921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2085924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2085943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085947 */     // MIs[0] round
     /* 2085947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085950 */     // MIs[0] policy
     /* 2085950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085960 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2085963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2085983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085986 */     // GIR_Coverage, 15968,
     /* 2085986 */     GIR_EraseRootFromParent_Done,
     /* 2085987 */   // Label 27680: @2085987
     /* 2085987 */   GIM_Try, /*On fail goto*//*Label 27681*/ GIMT_Encode4(2086078), // Rule ID 15969 //
     /* 2085992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2085995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2086000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2086003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2086006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2086009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2086012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086038 */     // MIs[0] round
     /* 2086038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086041 */     // MIs[0] policy
     /* 2086041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086051 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2086054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086077 */     // GIR_Coverage, 15969,
     /* 2086077 */     GIR_EraseRootFromParent_Done,
     /* 2086078 */   // Label 27681: @2086078
     /* 2086078 */   GIM_Try, /*On fail goto*//*Label 27682*/ GIMT_Encode4(2086169), // Rule ID 15972 //
     /* 2086083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2086091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2086094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2086097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2086100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2086103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086129 */     // MIs[0] round
     /* 2086129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086132 */     // MIs[0] policy
     /* 2086132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086142 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2086145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086168 */     // GIR_Coverage, 15972,
     /* 2086168 */     GIR_EraseRootFromParent_Done,
     /* 2086169 */   // Label 27682: @2086169
     /* 2086169 */   GIM_Try, /*On fail goto*//*Label 27683*/ GIMT_Encode4(2086260), // Rule ID 15973 //
     /* 2086174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2086182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2086185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2086188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2086191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2086194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086220 */     // MIs[0] round
     /* 2086220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086223 */     // MIs[0] policy
     /* 2086223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086233 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2086236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086259 */     // GIR_Coverage, 15973,
     /* 2086259 */     GIR_EraseRootFromParent_Done,
     /* 2086260 */   // Label 27683: @2086260
     /* 2086260 */   GIM_Try, /*On fail goto*//*Label 27684*/ GIMT_Encode4(2086351), // Rule ID 15976 //
     /* 2086265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2086273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2086276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2086279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2086282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2086285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086311 */     // MIs[0] round
     /* 2086311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086314 */     // MIs[0] policy
     /* 2086314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086324 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2086327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086350 */     // GIR_Coverage, 15976,
     /* 2086350 */     GIR_EraseRootFromParent_Done,
     /* 2086351 */   // Label 27684: @2086351
     /* 2086351 */   GIM_Try, /*On fail goto*//*Label 27685*/ GIMT_Encode4(2086442), // Rule ID 15977 //
     /* 2086356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2086364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2086367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2086370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2086373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2086376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086402 */     // MIs[0] round
     /* 2086402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086405 */     // MIs[0] policy
     /* 2086405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086415 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2086418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086441 */     // GIR_Coverage, 15977,
     /* 2086441 */     GIR_EraseRootFromParent_Done,
     /* 2086442 */   // Label 27685: @2086442
     /* 2086442 */   GIM_Try, /*On fail goto*//*Label 27686*/ GIMT_Encode4(2086533), // Rule ID 16068 //
     /* 2086447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2086458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2086461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2086464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2086467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2086470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086493 */     // MIs[0] round
     /* 2086493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086496 */     // MIs[0] policy
     /* 2086496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086506 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2086509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086532 */     // GIR_Coverage, 16068,
     /* 2086532 */     GIR_EraseRootFromParent_Done,
     /* 2086533 */   // Label 27686: @2086533
     /* 2086533 */   GIM_Try, /*On fail goto*//*Label 27687*/ GIMT_Encode4(2086624), // Rule ID 16069 //
     /* 2086538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2086549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2086552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2086555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2086558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2086561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086584 */     // MIs[0] round
     /* 2086584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086587 */     // MIs[0] policy
     /* 2086587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086597 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2086600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086623 */     // GIR_Coverage, 16069,
     /* 2086623 */     GIR_EraseRootFromParent_Done,
     /* 2086624 */   // Label 27687: @2086624
     /* 2086624 */   GIM_Try, /*On fail goto*//*Label 27688*/ GIMT_Encode4(2086715), // Rule ID 16072 //
     /* 2086629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2086640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2086643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2086646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2086649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086675 */     // MIs[0] round
     /* 2086675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086678 */     // MIs[0] policy
     /* 2086678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086688 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2086691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086714 */     // GIR_Coverage, 16072,
     /* 2086714 */     GIR_EraseRootFromParent_Done,
     /* 2086715 */   // Label 27688: @2086715
     /* 2086715 */   GIM_Try, /*On fail goto*//*Label 27689*/ GIMT_Encode4(2086806), // Rule ID 16073 //
     /* 2086720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2086731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2086734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2086737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2086740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086766 */     // MIs[0] round
     /* 2086766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086769 */     // MIs[0] policy
     /* 2086769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086779 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2086782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086805 */     // GIR_Coverage, 16073,
     /* 2086805 */     GIR_EraseRootFromParent_Done,
     /* 2086806 */   // Label 27689: @2086806
     /* 2086806 */   GIM_Try, /*On fail goto*//*Label 27690*/ GIMT_Encode4(2086897), // Rule ID 16076 //
     /* 2086811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2086822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2086825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2086828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2086831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086857 */     // MIs[0] round
     /* 2086857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086860 */     // MIs[0] policy
     /* 2086860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086870 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2086873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086896 */     // GIR_Coverage, 16076,
     /* 2086896 */     GIR_EraseRootFromParent_Done,
     /* 2086897 */   // Label 27690: @2086897
     /* 2086897 */   GIM_Try, /*On fail goto*//*Label 27691*/ GIMT_Encode4(2086988), // Rule ID 16077 //
     /* 2086902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2086913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2086916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2086919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2086922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086948 */     // MIs[0] round
     /* 2086948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086951 */     // MIs[0] policy
     /* 2086951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086961 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2086964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086987 */     // GIR_Coverage, 16077,
     /* 2086987 */     GIR_EraseRootFromParent_Done,
     /* 2086988 */   // Label 27691: @2086988
     /* 2086988 */   GIM_Try, /*On fail goto*//*Label 27692*/ GIMT_Encode4(2087079), // Rule ID 16080 //
     /* 2086993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2087004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2087007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2087013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087039 */     // MIs[0] round
     /* 2087039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087042 */     // MIs[0] policy
     /* 2087042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087052 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2087055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087078 */     // GIR_Coverage, 16080,
     /* 2087078 */     GIR_EraseRootFromParent_Done,
     /* 2087079 */   // Label 27692: @2087079
     /* 2087079 */   GIM_Try, /*On fail goto*//*Label 27693*/ GIMT_Encode4(2087170), // Rule ID 16081 //
     /* 2087084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2087095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2087098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2087104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087130 */     // MIs[0] round
     /* 2087130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087133 */     // MIs[0] policy
     /* 2087133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087143 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2087146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087169 */     // GIR_Coverage, 16081,
     /* 2087169 */     GIR_EraseRootFromParent_Done,
     /* 2087170 */   // Label 27693: @2087170
     /* 2087170 */   GIM_Try, /*On fail goto*//*Label 27694*/ GIMT_Encode4(2087261), // Rule ID 16084 //
     /* 2087175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2087186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2087189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2087192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2087195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087221 */     // MIs[0] round
     /* 2087221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087224 */     // MIs[0] policy
     /* 2087224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087234 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2087237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087260 */     // GIR_Coverage, 16084,
     /* 2087260 */     GIR_EraseRootFromParent_Done,
     /* 2087261 */   // Label 27694: @2087261
     /* 2087261 */   GIM_Try, /*On fail goto*//*Label 27695*/ GIMT_Encode4(2087352), // Rule ID 16085 //
     /* 2087266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2087277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2087280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2087283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2087286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087312 */     // MIs[0] round
     /* 2087312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087315 */     // MIs[0] policy
     /* 2087315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087325 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2087328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087351 */     // GIR_Coverage, 16085,
     /* 2087351 */     GIR_EraseRootFromParent_Done,
     /* 2087352 */   // Label 27695: @2087352
     /* 2087352 */   GIM_Try, /*On fail goto*//*Label 27696*/ GIMT_Encode4(2087443), // Rule ID 16088 //
     /* 2087357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2087368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2087371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2087374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2087377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087403 */     // MIs[0] round
     /* 2087403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087406 */     // MIs[0] policy
     /* 2087406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2087419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087442 */     // GIR_Coverage, 16088,
     /* 2087442 */     GIR_EraseRootFromParent_Done,
     /* 2087443 */   // Label 27696: @2087443
     /* 2087443 */   GIM_Try, /*On fail goto*//*Label 27697*/ GIMT_Encode4(2087534), // Rule ID 16089 //
     /* 2087448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2087459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2087462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2087465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2087468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087494 */     // MIs[0] round
     /* 2087494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087497 */     // MIs[0] policy
     /* 2087497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087507 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2087510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087533 */     // GIR_Coverage, 16089,
     /* 2087533 */     GIR_EraseRootFromParent_Done,
     /* 2087534 */   // Label 27697: @2087534
     /* 2087534 */   GIM_Try, /*On fail goto*//*Label 27698*/ GIMT_Encode4(2087625), // Rule ID 16092 //
     /* 2087539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2087550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2087553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2087556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2087559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087585 */     // MIs[0] round
     /* 2087585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087588 */     // MIs[0] policy
     /* 2087588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087598 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2087601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087624 */     // GIR_Coverage, 16092,
     /* 2087624 */     GIR_EraseRootFromParent_Done,
     /* 2087625 */   // Label 27698: @2087625
     /* 2087625 */   GIM_Try, /*On fail goto*//*Label 27699*/ GIMT_Encode4(2087716), // Rule ID 16093 //
     /* 2087630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2087641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2087644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2087647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2087650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087676 */     // MIs[0] round
     /* 2087676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087679 */     // MIs[0] policy
     /* 2087679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087689 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2087692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087715 */     // GIR_Coverage, 16093,
     /* 2087715 */     GIR_EraseRootFromParent_Done,
     /* 2087716 */   // Label 27699: @2087716
     /* 2087716 */   GIM_Try, /*On fail goto*//*Label 27700*/ GIMT_Encode4(2087807), // Rule ID 16096 //
     /* 2087721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2087732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2087735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2087738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2087741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087767 */     // MIs[0] round
     /* 2087767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087770 */     // MIs[0] policy
     /* 2087770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087780 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2087783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087806 */     // GIR_Coverage, 16096,
     /* 2087806 */     GIR_EraseRootFromParent_Done,
     /* 2087807 */   // Label 27700: @2087807
     /* 2087807 */   GIM_Try, /*On fail goto*//*Label 27701*/ GIMT_Encode4(2087898), // Rule ID 16097 //
     /* 2087812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2087823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2087826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2087829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2087832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087858 */     // MIs[0] round
     /* 2087858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087861 */     // MIs[0] policy
     /* 2087861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087871 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2087874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087897 */     // GIR_Coverage, 16097,
     /* 2087897 */     GIR_EraseRootFromParent_Done,
     /* 2087898 */   // Label 27701: @2087898
     /* 2087898 */   GIM_Try, /*On fail goto*//*Label 27702*/ GIMT_Encode4(2087989), // Rule ID 16100 //
     /* 2087903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2087914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2087917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2087920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2087923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087949 */     // MIs[0] round
     /* 2087949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087952 */     // MIs[0] policy
     /* 2087952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087962 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2087965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087988 */     // GIR_Coverage, 16100,
     /* 2087988 */     GIR_EraseRootFromParent_Done,
     /* 2087989 */   // Label 27702: @2087989
     /* 2087989 */   GIM_Try, /*On fail goto*//*Label 27703*/ GIMT_Encode4(2088080), // Rule ID 16101 //
     /* 2087994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2088005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2088008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2088011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2088014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088040 */     // MIs[0] round
     /* 2088040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088043 */     // MIs[0] policy
     /* 2088043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088053 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2088056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088079 */     // GIR_Coverage, 16101,
     /* 2088079 */     GIR_EraseRootFromParent_Done,
     /* 2088080 */   // Label 27703: @2088080
     /* 2088080 */   GIM_Try, /*On fail goto*//*Label 27704*/ GIMT_Encode4(2088171), // Rule ID 16104 //
     /* 2088085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2088088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2088096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2088099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2088102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2088105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088131 */     // MIs[0] round
     /* 2088131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088134 */     // MIs[0] policy
     /* 2088134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088144 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2088147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2088167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088170 */     // GIR_Coverage, 16104,
     /* 2088170 */     GIR_EraseRootFromParent_Done,
     /* 2088171 */   // Label 27704: @2088171
     /* 2088171 */   GIM_Try, /*On fail goto*//*Label 27705*/ GIMT_Encode4(2088262), // Rule ID 16105 //
     /* 2088176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2088179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2088187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2088190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2088193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2088196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088222 */     // MIs[0] round
     /* 2088222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088225 */     // MIs[0] policy
     /* 2088225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088235 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2088238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2088258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088261 */     // GIR_Coverage, 16105,
     /* 2088261 */     GIR_EraseRootFromParent_Done,
     /* 2088262 */   // Label 27705: @2088262
     /* 2088262 */   GIM_Try, /*On fail goto*//*Label 27706*/ GIMT_Encode4(2088353), // Rule ID 16108 //
     /* 2088267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2088278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2088281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2088284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2088287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2088290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088313 */     // MIs[0] round
     /* 2088313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088316 */     // MIs[0] policy
     /* 2088316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2088329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088352 */     // GIR_Coverage, 16108,
     /* 2088352 */     GIR_EraseRootFromParent_Done,
     /* 2088353 */   // Label 27706: @2088353
     /* 2088353 */   GIM_Try, /*On fail goto*//*Label 27707*/ GIMT_Encode4(2088444), // Rule ID 16109 //
     /* 2088358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2088369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2088372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2088375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2088378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2088381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088404 */     // MIs[0] round
     /* 2088404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088407 */     // MIs[0] policy
     /* 2088407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088417 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2088420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088443 */     // GIR_Coverage, 16109,
     /* 2088443 */     GIR_EraseRootFromParent_Done,
     /* 2088444 */   // Label 27707: @2088444
     /* 2088444 */   GIM_Try, /*On fail goto*//*Label 27708*/ GIMT_Encode4(2088535), // Rule ID 16112 //
     /* 2088449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2088460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2088463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2088466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2088469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2088472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2088479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088495 */     // MIs[0] round
     /* 2088495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088498 */     // MIs[0] policy
     /* 2088498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088508 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2088511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088534 */     // GIR_Coverage, 16112,
     /* 2088534 */     GIR_EraseRootFromParent_Done,
     /* 2088535 */   // Label 27708: @2088535
     /* 2088535 */   GIM_Try, /*On fail goto*//*Label 27709*/ GIMT_Encode4(2088626), // Rule ID 16113 //
     /* 2088540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2088551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2088554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2088557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2088560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2088563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2088570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088586 */     // MIs[0] round
     /* 2088586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088589 */     // MIs[0] policy
     /* 2088589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088599 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2088602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088625 */     // GIR_Coverage, 16113,
     /* 2088625 */     GIR_EraseRootFromParent_Done,
     /* 2088626 */   // Label 27709: @2088626
     /* 2088626 */   GIM_Try, /*On fail goto*//*Label 27710*/ GIMT_Encode4(2088717), // Rule ID 16116 //
     /* 2088631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2088642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2088645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2088648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2088651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2088654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2088661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088677 */     // MIs[0] round
     /* 2088677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088680 */     // MIs[0] policy
     /* 2088680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088690 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2088693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088716 */     // GIR_Coverage, 16116,
     /* 2088716 */     GIR_EraseRootFromParent_Done,
     /* 2088717 */   // Label 27710: @2088717
     /* 2088717 */   GIM_Try, /*On fail goto*//*Label 27711*/ GIMT_Encode4(2088808), // Rule ID 16117 //
     /* 2088722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2088733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2088736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2088739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2088742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2088745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2088752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088768 */     // MIs[0] round
     /* 2088768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088771 */     // MIs[0] policy
     /* 2088771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088781 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2088784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088807 */     // GIR_Coverage, 16117,
     /* 2088807 */     GIR_EraseRootFromParent_Done,
     /* 2088808 */   // Label 27711: @2088808
     /* 2088808 */   GIM_Try, /*On fail goto*//*Label 27712*/ GIMT_Encode4(2088899), // Rule ID 16120 //
     /* 2088813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2088824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2088827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2088830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2088833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2088836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088859 */     // MIs[0] round
     /* 2088859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088862 */     // MIs[0] policy
     /* 2088862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088872 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2088875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088898 */     // GIR_Coverage, 16120,
     /* 2088898 */     GIR_EraseRootFromParent_Done,
     /* 2088899 */   // Label 27712: @2088899
     /* 2088899 */   GIM_Try, /*On fail goto*//*Label 27713*/ GIMT_Encode4(2088990), // Rule ID 16121 //
     /* 2088904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2088915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2088918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2088921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2088924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2088927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088950 */     // MIs[0] round
     /* 2088950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088953 */     // MIs[0] policy
     /* 2088953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088963 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2088966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088989 */     // GIR_Coverage, 16121,
     /* 2088989 */     GIR_EraseRootFromParent_Done,
     /* 2088990 */   // Label 27713: @2088990
     /* 2088990 */   GIM_Try, /*On fail goto*//*Label 27714*/ GIMT_Encode4(2089081), // Rule ID 16124 //
     /* 2088995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2089006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2089009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2089012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2089015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089041 */     // MIs[0] round
     /* 2089041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089044 */     // MIs[0] policy
     /* 2089044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089054 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2089057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089080 */     // GIR_Coverage, 16124,
     /* 2089080 */     GIR_EraseRootFromParent_Done,
     /* 2089081 */   // Label 27714: @2089081
     /* 2089081 */   GIM_Try, /*On fail goto*//*Label 27715*/ GIMT_Encode4(2089172), // Rule ID 16125 //
     /* 2089086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2089097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2089100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2089103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2089106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089132 */     // MIs[0] round
     /* 2089132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089135 */     // MIs[0] policy
     /* 2089135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089145 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2089148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089171 */     // GIR_Coverage, 16125,
     /* 2089171 */     GIR_EraseRootFromParent_Done,
     /* 2089172 */   // Label 27715: @2089172
     /* 2089172 */   GIM_Try, /*On fail goto*//*Label 27716*/ GIMT_Encode4(2089263), // Rule ID 16128 //
     /* 2089177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2089188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2089191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2089194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2089197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089223 */     // MIs[0] round
     /* 2089223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089226 */     // MIs[0] policy
     /* 2089226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089236 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2089239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089262 */     // GIR_Coverage, 16128,
     /* 2089262 */     GIR_EraseRootFromParent_Done,
     /* 2089263 */   // Label 27716: @2089263
     /* 2089263 */   GIM_Try, /*On fail goto*//*Label 27717*/ GIMT_Encode4(2089354), // Rule ID 16129 //
     /* 2089268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2089279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2089282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2089285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2089288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089314 */     // MIs[0] round
     /* 2089314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089317 */     // MIs[0] policy
     /* 2089317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089327 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2089330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089353 */     // GIR_Coverage, 16129,
     /* 2089353 */     GIR_EraseRootFromParent_Done,
     /* 2089354 */   // Label 27717: @2089354
     /* 2089354 */   GIM_Try, /*On fail goto*//*Label 27718*/ GIMT_Encode4(2089445), // Rule ID 16132 //
     /* 2089359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2089370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2089373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2089376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2089379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089405 */     // MIs[0] round
     /* 2089405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089408 */     // MIs[0] policy
     /* 2089408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2089421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089444 */     // GIR_Coverage, 16132,
     /* 2089444 */     GIR_EraseRootFromParent_Done,
     /* 2089445 */   // Label 27718: @2089445
     /* 2089445 */   GIM_Try, /*On fail goto*//*Label 27719*/ GIMT_Encode4(2089536), // Rule ID 16133 //
     /* 2089450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2089461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2089464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2089467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2089470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089496 */     // MIs[0] round
     /* 2089496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089499 */     // MIs[0] policy
     /* 2089499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089509 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2089512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089535 */     // GIR_Coverage, 16133,
     /* 2089535 */     GIR_EraseRootFromParent_Done,
     /* 2089536 */   // Label 27719: @2089536
     /* 2089536 */   GIM_Try, /*On fail goto*//*Label 27720*/ GIMT_Encode4(2089627), // Rule ID 16136 //
     /* 2089541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2089552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2089555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2089558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2089561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089587 */     // MIs[0] round
     /* 2089587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089590 */     // MIs[0] policy
     /* 2089590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089600 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2089603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089626 */     // GIR_Coverage, 16136,
     /* 2089626 */     GIR_EraseRootFromParent_Done,
     /* 2089627 */   // Label 27720: @2089627
     /* 2089627 */   GIM_Try, /*On fail goto*//*Label 27721*/ GIMT_Encode4(2089718), // Rule ID 16137 //
     /* 2089632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2089643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2089646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2089649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2089652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089678 */     // MIs[0] round
     /* 2089678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089681 */     // MIs[0] policy
     /* 2089681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089691 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2089694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089717 */     // GIR_Coverage, 16137,
     /* 2089717 */     GIR_EraseRootFromParent_Done,
     /* 2089718 */   // Label 27721: @2089718
     /* 2089718 */   GIM_Try, /*On fail goto*//*Label 27722*/ GIMT_Encode4(2089809), // Rule ID 16140 //
     /* 2089723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2089734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2089737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2089740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2089743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089769 */     // MIs[0] round
     /* 2089769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089772 */     // MIs[0] policy
     /* 2089772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089782 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2089785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089808 */     // GIR_Coverage, 16140,
     /* 2089808 */     GIR_EraseRootFromParent_Done,
     /* 2089809 */   // Label 27722: @2089809
     /* 2089809 */   GIM_Try, /*On fail goto*//*Label 27723*/ GIMT_Encode4(2089900), // Rule ID 16141 //
     /* 2089814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2089825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2089828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2089831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2089834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089860 */     // MIs[0] round
     /* 2089860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089863 */     // MIs[0] policy
     /* 2089863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089873 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2089876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089899 */     // GIR_Coverage, 16141,
     /* 2089899 */     GIR_EraseRootFromParent_Done,
     /* 2089900 */   // Label 27723: @2089900
     /* 2089900 */   GIM_Try, /*On fail goto*//*Label 27724*/ GIMT_Encode4(2089991), // Rule ID 16144 //
     /* 2089905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2089908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2089916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2089919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2089922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2089925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2089928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089951 */     // MIs[0] round
     /* 2089951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089954 */     // MIs[0] policy
     /* 2089954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089964 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2089967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2089987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089990 */     // GIR_Coverage, 16144,
     /* 2089990 */     GIR_EraseRootFromParent_Done,
     /* 2089991 */   // Label 27724: @2089991
     /* 2089991 */   GIM_Try, /*On fail goto*//*Label 27725*/ GIMT_Encode4(2090082), // Rule ID 16145 //
     /* 2089996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2089999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2090007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2090010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2090013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2090016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090042 */     // MIs[0] round
     /* 2090042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090045 */     // MIs[0] policy
     /* 2090045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090055 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2090058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090081 */     // GIR_Coverage, 16145,
     /* 2090081 */     GIR_EraseRootFromParent_Done,
     /* 2090082 */   // Label 27725: @2090082
     /* 2090082 */   GIM_Try, /*On fail goto*//*Label 27726*/ GIMT_Encode4(2090173), // Rule ID 16148 //
     /* 2090087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2090098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2090101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2090104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2090107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090133 */     // MIs[0] round
     /* 2090133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090136 */     // MIs[0] policy
     /* 2090136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090146 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2090149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090172 */     // GIR_Coverage, 16148,
     /* 2090172 */     GIR_EraseRootFromParent_Done,
     /* 2090173 */   // Label 27726: @2090173
     /* 2090173 */   GIM_Try, /*On fail goto*//*Label 27727*/ GIMT_Encode4(2090264), // Rule ID 16149 //
     /* 2090178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2090189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2090192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2090195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2090198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090224 */     // MIs[0] round
     /* 2090224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090227 */     // MIs[0] policy
     /* 2090227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090237 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2090240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090263 */     // GIR_Coverage, 16149,
     /* 2090263 */     GIR_EraseRootFromParent_Done,
     /* 2090264 */   // Label 27727: @2090264
     /* 2090264 */   GIM_Try, /*On fail goto*//*Label 27728*/ GIMT_Encode4(2090355), // Rule ID 16152 //
     /* 2090269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2090280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2090283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2090286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2090289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090315 */     // MIs[0] round
     /* 2090315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090318 */     // MIs[0] policy
     /* 2090318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090328 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2090331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090354 */     // GIR_Coverage, 16152,
     /* 2090354 */     GIR_EraseRootFromParent_Done,
     /* 2090355 */   // Label 27728: @2090355
     /* 2090355 */   GIM_Try, /*On fail goto*//*Label 27729*/ GIMT_Encode4(2090446), // Rule ID 16153 //
     /* 2090360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2090371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2090374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2090377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2090380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090406 */     // MIs[0] round
     /* 2090406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090409 */     // MIs[0] policy
     /* 2090409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090419 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2090422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090445 */     // GIR_Coverage, 16153,
     /* 2090445 */     GIR_EraseRootFromParent_Done,
     /* 2090446 */   // Label 27729: @2090446
     /* 2090446 */   GIM_Try, /*On fail goto*//*Label 27730*/ GIMT_Encode4(2090537), // Rule ID 16156 //
     /* 2090451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2090462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2090465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2090468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2090474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090497 */     // MIs[0] round
     /* 2090497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090500 */     // MIs[0] policy
     /* 2090500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090510 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2090513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090536 */     // GIR_Coverage, 16156,
     /* 2090536 */     GIR_EraseRootFromParent_Done,
     /* 2090537 */   // Label 27730: @2090537
     /* 2090537 */   GIM_Try, /*On fail goto*//*Label 27731*/ GIMT_Encode4(2090628), // Rule ID 16157 //
     /* 2090542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2090553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2090556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2090559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2090565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090588 */     // MIs[0] round
     /* 2090588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090591 */     // MIs[0] policy
     /* 2090591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090601 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2090604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090627 */     // GIR_Coverage, 16157,
     /* 2090627 */     GIR_EraseRootFromParent_Done,
     /* 2090628 */   // Label 27731: @2090628
     /* 2090628 */   GIM_Try, /*On fail goto*//*Label 27732*/ GIMT_Encode4(2090719), // Rule ID 16160 //
     /* 2090633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2090644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2090647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2090650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090679 */     // MIs[0] round
     /* 2090679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090682 */     // MIs[0] policy
     /* 2090682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090692 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2090695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090718 */     // GIR_Coverage, 16160,
     /* 2090718 */     GIR_EraseRootFromParent_Done,
     /* 2090719 */   // Label 27732: @2090719
     /* 2090719 */   GIM_Try, /*On fail goto*//*Label 27733*/ GIMT_Encode4(2090810), // Rule ID 16161 //
     /* 2090724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2090735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2090738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2090741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090770 */     // MIs[0] round
     /* 2090770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090773 */     // MIs[0] policy
     /* 2090773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090783 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2090786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090809 */     // GIR_Coverage, 16161,
     /* 2090809 */     GIR_EraseRootFromParent_Done,
     /* 2090810 */   // Label 27733: @2090810
     /* 2090810 */   GIM_Try, /*On fail goto*//*Label 27734*/ GIMT_Encode4(2090901), // Rule ID 16164 //
     /* 2090815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2090826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2090829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2090832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090861 */     // MIs[0] round
     /* 2090861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090864 */     // MIs[0] policy
     /* 2090864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090874 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2090877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090900 */     // GIR_Coverage, 16164,
     /* 2090900 */     GIR_EraseRootFromParent_Done,
     /* 2090901 */   // Label 27734: @2090901
     /* 2090901 */   GIM_Try, /*On fail goto*//*Label 27735*/ GIMT_Encode4(2090992), // Rule ID 16165 //
     /* 2090906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2090917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2090920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2090923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090952 */     // MIs[0] round
     /* 2090952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090955 */     // MIs[0] policy
     /* 2090955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090965 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2090968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090991 */     // GIR_Coverage, 16165,
     /* 2090991 */     GIR_EraseRootFromParent_Done,
     /* 2090992 */   // Label 27735: @2090992
     /* 2090992 */   GIM_Try, /*On fail goto*//*Label 27736*/ GIMT_Encode4(2091083), // Rule ID 16168 //
     /* 2090997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2091005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2091008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2091011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2091014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2091017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2091039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091043 */     // MIs[0] round
     /* 2091043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091046 */     // MIs[0] policy
     /* 2091046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091056 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2091059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091082 */     // GIR_Coverage, 16168,
     /* 2091082 */     GIR_EraseRootFromParent_Done,
     /* 2091083 */   // Label 27736: @2091083
     /* 2091083 */   GIM_Try, /*On fail goto*//*Label 27737*/ GIMT_Encode4(2091174), // Rule ID 16169 //
     /* 2091088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2091096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2091099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2091102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2091105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2091108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2091130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091134 */     // MIs[0] round
     /* 2091134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091137 */     // MIs[0] policy
     /* 2091137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091147 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2091150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091173 */     // GIR_Coverage, 16169,
     /* 2091173 */     GIR_EraseRootFromParent_Done,
     /* 2091174 */   // Label 27737: @2091174
     /* 2091174 */   GIM_Try, /*On fail goto*//*Label 27738*/ GIMT_Encode4(2091265), // Rule ID 16172 //
     /* 2091179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2091187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2091190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2091193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2091196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2091199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2091221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091225 */     // MIs[0] round
     /* 2091225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091228 */     // MIs[0] policy
     /* 2091228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091238 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2091241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091264 */     // GIR_Coverage, 16172,
     /* 2091264 */     GIR_EraseRootFromParent_Done,
     /* 2091265 */   // Label 27738: @2091265
     /* 2091265 */   GIM_Try, /*On fail goto*//*Label 27739*/ GIMT_Encode4(2091356), // Rule ID 16173 //
     /* 2091270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2091278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2091281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2091284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2091287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2091290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2091312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091316 */     // MIs[0] round
     /* 2091316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091319 */     // MIs[0] policy
     /* 2091319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091329 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2091332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091355 */     // GIR_Coverage, 16173,
     /* 2091355 */     GIR_EraseRootFromParent_Done,
     /* 2091356 */   // Label 27739: @2091356
     /* 2091356 */   GIM_Try, /*On fail goto*//*Label 27740*/ GIMT_Encode4(2091447), // Rule ID 16176 //
     /* 2091361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2091369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2091372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2091375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2091378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2091381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2091403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091407 */     // MIs[0] round
     /* 2091407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091410 */     // MIs[0] policy
     /* 2091410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091420 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2091423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091446 */     // GIR_Coverage, 16176,
     /* 2091446 */     GIR_EraseRootFromParent_Done,
     /* 2091447 */   // Label 27740: @2091447
     /* 2091447 */   GIM_Try, /*On fail goto*//*Label 27741*/ GIMT_Encode4(2091538), // Rule ID 16177 //
     /* 2091452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2091460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2091463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2091466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2091469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2091472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2091494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091498 */     // MIs[0] round
     /* 2091498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091501 */     // MIs[0] policy
     /* 2091501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091511 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2091514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091537 */     // GIR_Coverage, 16177,
     /* 2091537 */     GIR_EraseRootFromParent_Done,
     /* 2091538 */   // Label 27741: @2091538
     /* 2091538 */   GIM_Try, /*On fail goto*//*Label 27742*/ GIMT_Encode4(2091629), // Rule ID 16180 //
     /* 2091543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2091551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2091554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2091557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2091560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2091563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2091585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091589 */     // MIs[0] round
     /* 2091589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091592 */     // MIs[0] policy
     /* 2091592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2091605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091628 */     // GIR_Coverage, 16180,
     /* 2091628 */     GIR_EraseRootFromParent_Done,
     /* 2091629 */   // Label 27742: @2091629
     /* 2091629 */   GIM_Try, /*On fail goto*//*Label 27743*/ GIMT_Encode4(2091720), // Rule ID 16181 //
     /* 2091634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2091642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2091645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2091648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2091651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2091654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2091676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091680 */     // MIs[0] round
     /* 2091680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091683 */     // MIs[0] policy
     /* 2091683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091693 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2091696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091719 */     // GIR_Coverage, 16181,
     /* 2091719 */     GIR_EraseRootFromParent_Done,
     /* 2091720 */   // Label 27743: @2091720
     /* 2091720 */   GIM_Try, /*On fail goto*//*Label 27744*/ GIMT_Encode4(2091811), // Rule ID 16184 //
     /* 2091725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2091733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2091736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2091739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2091742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2091745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2091767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091771 */     // MIs[0] round
     /* 2091771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091774 */     // MIs[0] policy
     /* 2091774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2091787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091810 */     // GIR_Coverage, 16184,
     /* 2091810 */     GIR_EraseRootFromParent_Done,
     /* 2091811 */   // Label 27744: @2091811
     /* 2091811 */   GIM_Try, /*On fail goto*//*Label 27745*/ GIMT_Encode4(2091902), // Rule ID 16185 //
     /* 2091816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2091824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2091827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2091830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2091833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2091836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2091858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091862 */     // MIs[0] round
     /* 2091862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091865 */     // MIs[0] policy
     /* 2091865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091875 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2091878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091901 */     // GIR_Coverage, 16185,
     /* 2091901 */     GIR_EraseRootFromParent_Done,
     /* 2091902 */   // Label 27745: @2091902
     /* 2091902 */   GIM_Try, /*On fail goto*//*Label 27746*/ GIMT_Encode4(2091993), // Rule ID 16188 //
     /* 2091907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2091915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2091918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2091921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2091924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2091927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2091949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091953 */     // MIs[0] round
     /* 2091953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091956 */     // MIs[0] policy
     /* 2091956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2091969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091992 */     // GIR_Coverage, 16188,
     /* 2091992 */     GIR_EraseRootFromParent_Done,
     /* 2091993 */   // Label 27746: @2091993
     /* 2091993 */   GIM_Try, /*On fail goto*//*Label 27747*/ GIMT_Encode4(2092084), // Rule ID 16189 //
     /* 2091998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2092006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2092009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2092012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2092015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2092018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092044 */     // MIs[0] round
     /* 2092044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092047 */     // MIs[0] policy
     /* 2092047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092057 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2092060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092083 */     // GIR_Coverage, 16189,
     /* 2092083 */     GIR_EraseRootFromParent_Done,
     /* 2092084 */   // Label 27747: @2092084
     /* 2092084 */   GIM_Try, /*On fail goto*//*Label 27748*/ GIMT_Encode4(2092175), // Rule ID 16192 //
     /* 2092089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2092092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2092097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2092100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2092103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2092106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2092109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092135 */     // MIs[0] round
     /* 2092135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092138 */     // MIs[0] policy
     /* 2092138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092148 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2092151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2092171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092174 */     // GIR_Coverage, 16192,
     /* 2092174 */     GIR_EraseRootFromParent_Done,
     /* 2092175 */   // Label 27748: @2092175
     /* 2092175 */   GIM_Try, /*On fail goto*//*Label 27749*/ GIMT_Encode4(2092266), // Rule ID 16193 //
     /* 2092180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2092183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2092188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2092191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2092194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2092197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2092200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092226 */     // MIs[0] round
     /* 2092226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092229 */     // MIs[0] policy
     /* 2092229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092239 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2092242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2092262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092265 */     // GIR_Coverage, 16193,
     /* 2092265 */     GIR_EraseRootFromParent_Done,
     /* 2092266 */   // Label 27749: @2092266
     /* 2092266 */   GIM_Try, /*On fail goto*//*Label 27750*/ GIMT_Encode4(2092357), // Rule ID 16196 //
     /* 2092271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2092279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2092282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2092285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2092288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2092291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092317 */     // MIs[0] round
     /* 2092317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092320 */     // MIs[0] policy
     /* 2092320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092330 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2092333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092356 */     // GIR_Coverage, 16196,
     /* 2092356 */     GIR_EraseRootFromParent_Done,
     /* 2092357 */   // Label 27750: @2092357
     /* 2092357 */   GIM_Try, /*On fail goto*//*Label 27751*/ GIMT_Encode4(2092448), // Rule ID 16197 //
     /* 2092362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2092370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2092373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2092376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2092379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2092382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092408 */     // MIs[0] round
     /* 2092408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092411 */     // MIs[0] policy
     /* 2092411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092421 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2092424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092447 */     // GIR_Coverage, 16197,
     /* 2092447 */     GIR_EraseRootFromParent_Done,
     /* 2092448 */   // Label 27751: @2092448
     /* 2092448 */   GIM_Try, /*On fail goto*//*Label 27752*/ GIMT_Encode4(2092539), // Rule ID 16200 //
     /* 2092453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2092461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2092464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2092467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2092470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2092473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2092476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092499 */     // MIs[0] round
     /* 2092499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092502 */     // MIs[0] policy
     /* 2092502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092512 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2092515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092538 */     // GIR_Coverage, 16200,
     /* 2092538 */     GIR_EraseRootFromParent_Done,
     /* 2092539 */   // Label 27752: @2092539
     /* 2092539 */   GIM_Try, /*On fail goto*//*Label 27753*/ GIMT_Encode4(2092630), // Rule ID 16201 //
     /* 2092544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2092552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2092555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2092558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2092561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2092564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2092567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092590 */     // MIs[0] round
     /* 2092590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092593 */     // MIs[0] policy
     /* 2092593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092603 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2092606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092629 */     // GIR_Coverage, 16201,
     /* 2092629 */     GIR_EraseRootFromParent_Done,
     /* 2092630 */   // Label 27753: @2092630
     /* 2092630 */   GIM_Try, /*On fail goto*//*Label 27754*/ GIMT_Encode4(2092721), // Rule ID 16204 //
     /* 2092635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2092643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2092646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2092649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2092652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2092655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2092658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2092665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092681 */     // MIs[0] round
     /* 2092681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092684 */     // MIs[0] policy
     /* 2092684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092694 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2092697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092720 */     // GIR_Coverage, 16204,
     /* 2092720 */     GIR_EraseRootFromParent_Done,
     /* 2092721 */   // Label 27754: @2092721
     /* 2092721 */   GIM_Try, /*On fail goto*//*Label 27755*/ GIMT_Encode4(2092812), // Rule ID 16205 //
     /* 2092726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2092734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2092737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2092740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2092743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2092746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2092749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2092756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092772 */     // MIs[0] round
     /* 2092772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092775 */     // MIs[0] policy
     /* 2092775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092785 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2092788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092811 */     // GIR_Coverage, 16205,
     /* 2092811 */     GIR_EraseRootFromParent_Done,
     /* 2092812 */   // Label 27755: @2092812
     /* 2092812 */   GIM_Try, /*On fail goto*//*Label 27756*/ GIMT_Encode4(2092903), // Rule ID 16208 //
     /* 2092817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2092825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2092828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2092831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2092834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2092837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092863 */     // MIs[0] round
     /* 2092863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092866 */     // MIs[0] policy
     /* 2092866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2092879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092902 */     // GIR_Coverage, 16208,
     /* 2092902 */     GIR_EraseRootFromParent_Done,
     /* 2092903 */   // Label 27756: @2092903
     /* 2092903 */   GIM_Try, /*On fail goto*//*Label 27757*/ GIMT_Encode4(2092994), // Rule ID 16209 //
     /* 2092908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2092916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2092919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2092922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2092925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2092928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092954 */     // MIs[0] round
     /* 2092954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092957 */     // MIs[0] policy
     /* 2092957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092967 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2092970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092993 */     // GIR_Coverage, 16209,
     /* 2092993 */     GIR_EraseRootFromParent_Done,
     /* 2092994 */   // Label 27757: @2092994
     /* 2092994 */   GIM_Try, /*On fail goto*//*Label 27758*/ GIMT_Encode4(2093085), // Rule ID 16212 //
     /* 2092999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2093007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2093010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2093013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2093016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2093022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093045 */     // MIs[0] round
     /* 2093045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093048 */     // MIs[0] policy
     /* 2093048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093058 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2093061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093084 */     // GIR_Coverage, 16212,
     /* 2093084 */     GIR_EraseRootFromParent_Done,
     /* 2093085 */   // Label 27758: @2093085
     /* 2093085 */   GIM_Try, /*On fail goto*//*Label 27759*/ GIMT_Encode4(2093176), // Rule ID 16213 //
     /* 2093090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2093098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2093101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2093104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2093107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2093113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093136 */     // MIs[0] round
     /* 2093136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093139 */     // MIs[0] policy
     /* 2093139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093149 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2093152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093175 */     // GIR_Coverage, 16213,
     /* 2093175 */     GIR_EraseRootFromParent_Done,
     /* 2093176 */   // Label 27759: @2093176
     /* 2093176 */   GIM_Try, /*On fail goto*//*Label 27760*/ GIMT_Encode4(2093267), // Rule ID 16216 //
     /* 2093181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2093189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2093192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2093195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2093198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2093204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2093211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093227 */     // MIs[0] round
     /* 2093227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093230 */     // MIs[0] policy
     /* 2093230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093240 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2093243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093266 */     // GIR_Coverage, 16216,
     /* 2093266 */     GIR_EraseRootFromParent_Done,
     /* 2093267 */   // Label 27760: @2093267
     /* 2093267 */   GIM_Try, /*On fail goto*//*Label 27761*/ GIMT_Encode4(2093358), // Rule ID 16217 //
     /* 2093272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2093280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2093283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2093286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2093289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2093295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2093302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093318 */     // MIs[0] round
     /* 2093318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093321 */     // MIs[0] policy
     /* 2093321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093331 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2093334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093357 */     // GIR_Coverage, 16217,
     /* 2093357 */     GIR_EraseRootFromParent_Done,
     /* 2093358 */   // Label 27761: @2093358
     /* 2093358 */   GIM_Try, /*On fail goto*//*Label 27762*/ GIMT_Encode4(2093449), // Rule ID 16220 //
     /* 2093363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2093371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2093374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2093377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2093380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093409 */     // MIs[0] round
     /* 2093409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093412 */     // MIs[0] policy
     /* 2093412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093422 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2093425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093448 */     // GIR_Coverage, 16220,
     /* 2093448 */     GIR_EraseRootFromParent_Done,
     /* 2093449 */   // Label 27762: @2093449
     /* 2093449 */   GIM_Try, /*On fail goto*//*Label 27763*/ GIMT_Encode4(2093540), // Rule ID 16221 //
     /* 2093454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2093462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2093465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2093468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2093471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093500 */     // MIs[0] round
     /* 2093500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093503 */     // MIs[0] policy
     /* 2093503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093513 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2093516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093539 */     // GIR_Coverage, 16221,
     /* 2093539 */     GIR_EraseRootFromParent_Done,
     /* 2093540 */   // Label 27763: @2093540
     /* 2093540 */   GIM_Try, /*On fail goto*//*Label 27764*/ GIMT_Encode4(2093631), // Rule ID 16224 //
     /* 2093545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2093553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2093556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2093559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2093562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093591 */     // MIs[0] round
     /* 2093591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093594 */     // MIs[0] policy
     /* 2093594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093604 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2093607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093630 */     // GIR_Coverage, 16224,
     /* 2093630 */     GIR_EraseRootFromParent_Done,
     /* 2093631 */   // Label 27764: @2093631
     /* 2093631 */   GIM_Try, /*On fail goto*//*Label 27765*/ GIMT_Encode4(2093722), // Rule ID 16225 //
     /* 2093636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2093644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2093647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2093650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2093653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093682 */     // MIs[0] round
     /* 2093682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093685 */     // MIs[0] policy
     /* 2093685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093695 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2093698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093721 */     // GIR_Coverage, 16225,
     /* 2093721 */     GIR_EraseRootFromParent_Done,
     /* 2093722 */   // Label 27765: @2093722
     /* 2093722 */   GIM_Try, /*On fail goto*//*Label 27766*/ GIMT_Encode4(2093813), // Rule ID 16228 //
     /* 2093727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2093735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2093738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2093741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2093744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2093750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2093757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093773 */     // MIs[0] round
     /* 2093773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093776 */     // MIs[0] policy
     /* 2093776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093786 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2093789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093812 */     // GIR_Coverage, 16228,
     /* 2093812 */     GIR_EraseRootFromParent_Done,
     /* 2093813 */   // Label 27766: @2093813
     /* 2093813 */   GIM_Try, /*On fail goto*//*Label 27767*/ GIMT_Encode4(2093904), // Rule ID 16229 //
     /* 2093818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2093826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2093829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2093832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2093835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2093841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2093848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093864 */     // MIs[0] round
     /* 2093864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093867 */     // MIs[0] policy
     /* 2093867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093877 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2093880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093903 */     // GIR_Coverage, 16229,
     /* 2093903 */     GIR_EraseRootFromParent_Done,
     /* 2093904 */   // Label 27767: @2093904
     /* 2093904 */   GIM_Try, /*On fail goto*//*Label 27768*/ GIMT_Encode4(2093995), // Rule ID 16232 //
     /* 2093909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2093912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2093917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2093920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2093923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2093926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093955 */     // MIs[0] round
     /* 2093955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093958 */     // MIs[0] policy
     /* 2093958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2093971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2093991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093994 */     // GIR_Coverage, 16232,
     /* 2093994 */     GIR_EraseRootFromParent_Done,
     /* 2093995 */   // Label 27768: @2093995
     /* 2093995 */   GIM_Try, /*On fail goto*//*Label 27769*/ GIMT_Encode4(2094086), // Rule ID 16233 //
     /* 2094000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2094003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2094008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2094011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2094014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2094017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094046 */     // MIs[0] round
     /* 2094046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094049 */     // MIs[0] policy
     /* 2094049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2094062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2094082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094085 */     // GIR_Coverage, 16233,
     /* 2094085 */     GIR_EraseRootFromParent_Done,
     /* 2094086 */   // Label 27769: @2094086
     /* 2094086 */   GIM_Try, /*On fail goto*//*Label 27770*/ GIMT_Encode4(2094177), // Rule ID 16236 //
     /* 2094091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2094094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2094099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2094102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2094105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2094108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094137 */     // MIs[0] round
     /* 2094137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094140 */     // MIs[0] policy
     /* 2094140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094150 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2094153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2094173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094176 */     // GIR_Coverage, 16236,
     /* 2094176 */     GIR_EraseRootFromParent_Done,
     /* 2094177 */   // Label 27770: @2094177
     /* 2094177 */   GIM_Try, /*On fail goto*//*Label 27771*/ GIMT_Encode4(2094268), // Rule ID 16237 //
     /* 2094182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2094185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2094190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2094193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2094196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2094199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094228 */     // MIs[0] round
     /* 2094228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094231 */     // MIs[0] policy
     /* 2094231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094241 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2094244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2094264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094267 */     // GIR_Coverage, 16237,
     /* 2094267 */     GIR_EraseRootFromParent_Done,
     /* 2094268 */   // Label 27771: @2094268
     /* 2094268 */   GIM_Try, /*On fail goto*//*Label 27772*/ GIMT_Encode4(2094359), // Rule ID 16240 //
     /* 2094273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2094276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2094281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2094284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2094287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2094290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2094303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094319 */     // MIs[0] round
     /* 2094319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094322 */     // MIs[0] policy
     /* 2094322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094332 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2094335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2094355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094358 */     // GIR_Coverage, 16240,
     /* 2094358 */     GIR_EraseRootFromParent_Done,
     /* 2094359 */   // Label 27772: @2094359
     /* 2094359 */   GIM_Try, /*On fail goto*//*Label 27773*/ GIMT_Encode4(2094450), // Rule ID 16241 //
     /* 2094364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2094367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2094372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2094375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2094378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2094381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2094394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094410 */     // MIs[0] round
     /* 2094410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094413 */     // MIs[0] policy
     /* 2094413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094423 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2094426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2094446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094449 */     // GIR_Coverage, 16241,
     /* 2094449 */     GIR_EraseRootFromParent_Done,
     /* 2094450 */   // Label 27773: @2094450
     /* 2094450 */   GIM_Try, /*On fail goto*//*Label 27774*/ GIMT_Encode4(2094544), // Rule ID 16332 //
     /* 2094455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2094466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2094469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2094472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2094475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094501 */     // MIs[0] round
     /* 2094501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094504 */     // MIs[0] policy
     /* 2094504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094514 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2094517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094543 */     // GIR_Coverage, 16332,
     /* 2094543 */     GIR_EraseRootFromParent_Done,
     /* 2094544 */   // Label 27774: @2094544
     /* 2094544 */   GIM_Try, /*On fail goto*//*Label 27775*/ GIMT_Encode4(2094638), // Rule ID 16333 //
     /* 2094549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2094560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2094563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2094566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2094569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094595 */     // MIs[0] round
     /* 2094595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094598 */     // MIs[0] policy
     /* 2094598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094608 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2094611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094637 */     // GIR_Coverage, 16333,
     /* 2094637 */     GIR_EraseRootFromParent_Done,
     /* 2094638 */   // Label 27775: @2094638
     /* 2094638 */   GIM_Try, /*On fail goto*//*Label 27776*/ GIMT_Encode4(2094732), // Rule ID 16336 //
     /* 2094643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2094654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2094657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2094660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2094663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094689 */     // MIs[0] round
     /* 2094689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094692 */     // MIs[0] policy
     /* 2094692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094702 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2094705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094731 */     // GIR_Coverage, 16336,
     /* 2094731 */     GIR_EraseRootFromParent_Done,
     /* 2094732 */   // Label 27776: @2094732
     /* 2094732 */   GIM_Try, /*On fail goto*//*Label 27777*/ GIMT_Encode4(2094826), // Rule ID 16337 //
     /* 2094737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2094748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2094751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2094754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2094757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094783 */     // MIs[0] round
     /* 2094783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094786 */     // MIs[0] policy
     /* 2094786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094796 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2094799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094825 */     // GIR_Coverage, 16337,
     /* 2094825 */     GIR_EraseRootFromParent_Done,
     /* 2094826 */   // Label 27777: @2094826
     /* 2094826 */   GIM_Try, /*On fail goto*//*Label 27778*/ GIMT_Encode4(2094920), // Rule ID 16340 //
     /* 2094831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2094842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2094845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2094848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2094851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094877 */     // MIs[0] round
     /* 2094877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094880 */     // MIs[0] policy
     /* 2094880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094890 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2094893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094919 */     // GIR_Coverage, 16340,
     /* 2094919 */     GIR_EraseRootFromParent_Done,
     /* 2094920 */   // Label 27778: @2094920
     /* 2094920 */   GIM_Try, /*On fail goto*//*Label 27779*/ GIMT_Encode4(2095014), // Rule ID 16341 //
     /* 2094925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2094936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2094939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2094942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2094945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094971 */     // MIs[0] round
     /* 2094971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094974 */     // MIs[0] policy
     /* 2094974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094984 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2094987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2095007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095013 */     // GIR_Coverage, 16341,
     /* 2095013 */     GIR_EraseRootFromParent_Done,
     /* 2095014 */   // Label 27779: @2095014
     /* 2095014 */   GIM_Try, /*On fail goto*//*Label 27780*/ GIMT_Encode4(2095108), // Rule ID 16344 //
     /* 2095019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2095030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2095033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2095036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2095039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095065 */     // MIs[0] round
     /* 2095065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095068 */     // MIs[0] policy
     /* 2095068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095078 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2095081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2095101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095107 */     // GIR_Coverage, 16344,
     /* 2095107 */     GIR_EraseRootFromParent_Done,
     /* 2095108 */   // Label 27780: @2095108
     /* 2095108 */   GIM_Try, /*On fail goto*//*Label 27781*/ GIMT_Encode4(2095202), // Rule ID 16345 //
     /* 2095113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2095124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2095127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2095130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2095133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095159 */     // MIs[0] round
     /* 2095159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095162 */     // MIs[0] policy
     /* 2095162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095172 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2095175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2095195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095201 */     // GIR_Coverage, 16345,
     /* 2095201 */     GIR_EraseRootFromParent_Done,
     /* 2095202 */   // Label 27781: @2095202
     /* 2095202 */   GIM_Try, /*On fail goto*//*Label 27782*/ GIMT_Encode4(2095296), // Rule ID 16348 //
     /* 2095207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2095218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2095221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2095224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2095227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2095230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095253 */     // MIs[0] round
     /* 2095253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095256 */     // MIs[0] policy
     /* 2095256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2095269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2095289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095295 */     // GIR_Coverage, 16348,
     /* 2095295 */     GIR_EraseRootFromParent_Done,
     /* 2095296 */   // Label 27782: @2095296
     /* 2095296 */   GIM_Try, /*On fail goto*//*Label 27783*/ GIMT_Encode4(2095390), // Rule ID 16349 //
     /* 2095301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2095312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2095315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2095318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2095321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2095324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095347 */     // MIs[0] round
     /* 2095347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095350 */     // MIs[0] policy
     /* 2095350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095360 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2095363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2095383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095385 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095389 */     // GIR_Coverage, 16349,
     /* 2095389 */     GIR_EraseRootFromParent_Done,
     /* 2095390 */   // Label 27783: @2095390
     /* 2095390 */   GIM_Try, /*On fail goto*//*Label 27784*/ GIMT_Encode4(2095484), // Rule ID 16352 //
     /* 2095395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2095406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2095409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2095412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2095415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2095418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095441 */     // MIs[0] round
     /* 2095441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095444 */     // MIs[0] policy
     /* 2095444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095454 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2095457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2095477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095479 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095483 */     // GIR_Coverage, 16352,
     /* 2095483 */     GIR_EraseRootFromParent_Done,
     /* 2095484 */   // Label 27784: @2095484
     /* 2095484 */   GIM_Try, /*On fail goto*//*Label 27785*/ GIMT_Encode4(2095578), // Rule ID 16353 //
     /* 2095489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2095500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2095503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2095506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2095509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2095512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095535 */     // MIs[0] round
     /* 2095535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095538 */     // MIs[0] policy
     /* 2095538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095548 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2095551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2095571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095577 */     // GIR_Coverage, 16353,
     /* 2095577 */     GIR_EraseRootFromParent_Done,
     /* 2095578 */   // Label 27785: @2095578
     /* 2095578 */   GIM_Try, /*On fail goto*//*Label 27786*/ GIMT_Encode4(2095672), // Rule ID 16356 //
     /* 2095583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2095594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2095597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2095600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2095603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095629 */     // MIs[0] round
     /* 2095629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095632 */     // MIs[0] policy
     /* 2095632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095642 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2095645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095671 */     // GIR_Coverage, 16356,
     /* 2095671 */     GIR_EraseRootFromParent_Done,
     /* 2095672 */   // Label 27786: @2095672
     /* 2095672 */   GIM_Try, /*On fail goto*//*Label 27787*/ GIMT_Encode4(2095766), // Rule ID 16357 //
     /* 2095677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2095688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2095691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2095694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2095697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095723 */     // MIs[0] round
     /* 2095723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095726 */     // MIs[0] policy
     /* 2095726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095736 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2095739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095765 */     // GIR_Coverage, 16357,
     /* 2095765 */     GIR_EraseRootFromParent_Done,
     /* 2095766 */   // Label 27787: @2095766
     /* 2095766 */   GIM_Try, /*On fail goto*//*Label 27788*/ GIMT_Encode4(2095860), // Rule ID 16360 //
     /* 2095771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2095782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2095785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2095788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2095791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095817 */     // MIs[0] round
     /* 2095817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095820 */     // MIs[0] policy
     /* 2095820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095830 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2095833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095859 */     // GIR_Coverage, 16360,
     /* 2095859 */     GIR_EraseRootFromParent_Done,
     /* 2095860 */   // Label 27788: @2095860
     /* 2095860 */   GIM_Try, /*On fail goto*//*Label 27789*/ GIMT_Encode4(2095954), // Rule ID 16361 //
     /* 2095865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2095876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2095879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2095882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2095885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095911 */     // MIs[0] round
     /* 2095911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095914 */     // MIs[0] policy
     /* 2095914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095924 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2095927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095953 */     // GIR_Coverage, 16361,
     /* 2095953 */     GIR_EraseRootFromParent_Done,
     /* 2095954 */   // Label 27789: @2095954
     /* 2095954 */   GIM_Try, /*On fail goto*//*Label 27790*/ GIMT_Encode4(2096048), // Rule ID 16364 //
     /* 2095959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2095970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2095973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2095976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2095979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096005 */     // MIs[0] round
     /* 2096005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096008 */     // MIs[0] policy
     /* 2096008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096018 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2096021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096047 */     // GIR_Coverage, 16364,
     /* 2096047 */     GIR_EraseRootFromParent_Done,
     /* 2096048 */   // Label 27790: @2096048
     /* 2096048 */   GIM_Try, /*On fail goto*//*Label 27791*/ GIMT_Encode4(2096142), // Rule ID 16365 //
     /* 2096053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2096056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2096064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2096067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2096070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2096073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096099 */     // MIs[0] round
     /* 2096099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096102 */     // MIs[0] policy
     /* 2096102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096112 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2096115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096141 */     // GIR_Coverage, 16365,
     /* 2096141 */     GIR_EraseRootFromParent_Done,
     /* 2096142 */   // Label 27791: @2096142
     /* 2096142 */   GIM_Try, /*On fail goto*//*Label 27792*/ GIMT_Encode4(2096236), // Rule ID 16368 //
     /* 2096147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2096158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2096161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2096164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2096167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096193 */     // MIs[0] round
     /* 2096193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096196 */     // MIs[0] policy
     /* 2096196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2096209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096235 */     // GIR_Coverage, 16368,
     /* 2096235 */     GIR_EraseRootFromParent_Done,
     /* 2096236 */   // Label 27792: @2096236
     /* 2096236 */   GIM_Try, /*On fail goto*//*Label 27793*/ GIMT_Encode4(2096330), // Rule ID 16369 //
     /* 2096241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2096244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2096252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2096255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2096258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2096261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096287 */     // MIs[0] round
     /* 2096287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096290 */     // MIs[0] policy
     /* 2096290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096300 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2096303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096329 */     // GIR_Coverage, 16369,
     /* 2096329 */     GIR_EraseRootFromParent_Done,
     /* 2096330 */   // Label 27793: @2096330
     /* 2096330 */   GIM_Try, /*On fail goto*//*Label 27794*/ GIMT_Encode4(2096424), // Rule ID 16372 //
     /* 2096335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2096346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2096349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2096352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2096355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2096358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096381 */     // MIs[0] round
     /* 2096381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096384 */     // MIs[0] policy
     /* 2096384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096394 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2096397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096423 */     // GIR_Coverage, 16372,
     /* 2096423 */     GIR_EraseRootFromParent_Done,
     /* 2096424 */   // Label 27794: @2096424
     /* 2096424 */   GIM_Try, /*On fail goto*//*Label 27795*/ GIMT_Encode4(2096518), // Rule ID 16373 //
     /* 2096429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2096432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2096440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2096443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2096446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2096449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2096452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096475 */     // MIs[0] round
     /* 2096475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096478 */     // MIs[0] policy
     /* 2096478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096488 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2096491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096517 */     // GIR_Coverage, 16373,
     /* 2096517 */     GIR_EraseRootFromParent_Done,
     /* 2096518 */   // Label 27795: @2096518
     /* 2096518 */   GIM_Try, /*On fail goto*//*Label 27796*/ GIMT_Encode4(2096612), // Rule ID 16376 //
     /* 2096523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2096526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2096534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2096537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2096540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2096543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096569 */     // MIs[0] round
     /* 2096569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096572 */     // MIs[0] policy
     /* 2096572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096582 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2096585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096611 */     // GIR_Coverage, 16376,
     /* 2096611 */     GIR_EraseRootFromParent_Done,
     /* 2096612 */   // Label 27796: @2096612
     /* 2096612 */   GIM_Try, /*On fail goto*//*Label 27797*/ GIMT_Encode4(2096706), // Rule ID 16377 //
     /* 2096617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2096620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2096628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2096631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2096634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2096637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096663 */     // MIs[0] round
     /* 2096663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096666 */     // MIs[0] policy
     /* 2096666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096676 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2096679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096705 */     // GIR_Coverage, 16377,
     /* 2096705 */     GIR_EraseRootFromParent_Done,
     /* 2096706 */   // Label 27797: @2096706
     /* 2096706 */   GIM_Try, /*On fail goto*//*Label 27798*/ GIMT_Encode4(2096800), // Rule ID 16380 //
     /* 2096711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2096714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2096722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2096725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2096728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2096731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096757 */     // MIs[0] round
     /* 2096757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096760 */     // MIs[0] policy
     /* 2096760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2096773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096799 */     // GIR_Coverage, 16380,
     /* 2096799 */     GIR_EraseRootFromParent_Done,
     /* 2096800 */   // Label 27798: @2096800
     /* 2096800 */   GIM_Try, /*On fail goto*//*Label 27799*/ GIMT_Encode4(2096894), // Rule ID 16381 //
     /* 2096805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2096808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2096816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2096819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2096822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2096825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096851 */     // MIs[0] round
     /* 2096851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096854 */     // MIs[0] policy
     /* 2096854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096864 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2096867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096893 */     // GIR_Coverage, 16381,
     /* 2096893 */     GIR_EraseRootFromParent_Done,
     /* 2096894 */   // Label 27799: @2096894
     /* 2096894 */   GIM_Try, /*On fail goto*//*Label 27800*/ GIMT_Encode4(2096988), // Rule ID 16384 //
     /* 2096899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2096902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2096910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2096913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2096916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2096919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096945 */     // MIs[0] round
     /* 2096945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096948 */     // MIs[0] policy
     /* 2096948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2096961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096987 */     // GIR_Coverage, 16384,
     /* 2096987 */     GIR_EraseRootFromParent_Done,
     /* 2096988 */   // Label 27800: @2096988
     /* 2096988 */   GIM_Try, /*On fail goto*//*Label 27801*/ GIMT_Encode4(2097082), // Rule ID 16385 //
     /* 2096993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2096996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2097001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2097004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2097007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2097010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2097013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097039 */     // MIs[0] round
     /* 2097039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097042 */     // MIs[0] policy
     /* 2097042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2097055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2097075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097081 */     // GIR_Coverage, 16385,
     /* 2097081 */     GIR_EraseRootFromParent_Done,
     /* 2097082 */   // Label 27801: @2097082
     /* 2097082 */   GIM_Try, /*On fail goto*//*Label 27802*/ GIMT_Encode4(2097176), // Rule ID 16388 //
     /* 2097087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2097090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2097095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2097098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2097101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2097104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2097107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097133 */     // MIs[0] round
     /* 2097133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097136 */     // MIs[0] policy
     /* 2097136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2097149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2097169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097175 */     // GIR_Coverage, 16388,
     /* 2097175 */     GIR_EraseRootFromParent_Done,
     /* 2097176 */   // Label 27802: @2097176
     /* 2097176 */   GIM_Try, /*On fail goto*//*Label 27803*/ GIMT_Encode4(2097270), // Rule ID 16389 //
     /* 2097181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2097184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2097189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2097192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2097195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2097198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2097201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097227 */     // MIs[0] round
     /* 2097227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097230 */     // MIs[0] policy
     /* 2097230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097240 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2097243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2097263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097269 */     // GIR_Coverage, 16389,
     /* 2097269 */     GIR_EraseRootFromParent_Done,
     /* 2097270 */   // Label 27803: @2097270
     /* 2097270 */   GIM_Try, /*On fail goto*//*Label 27804*/ GIMT_Encode4(2097364), // Rule ID 16392 //
     /* 2097275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2097283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2097286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2097289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2097292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2097295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2097317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097321 */     // MIs[0] round
     /* 2097321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097324 */     // MIs[0] policy
     /* 2097324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2097337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097363 */     // GIR_Coverage, 16392,
     /* 2097363 */     GIR_EraseRootFromParent_Done,
     /* 2097364 */   // Label 27804: @2097364
     /* 2097364 */   GIM_Try, /*On fail goto*//*Label 27805*/ GIMT_Encode4(2097458), // Rule ID 16393 //
     /* 2097369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2097377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2097380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2097383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2097386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2097411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097415 */     // MIs[0] round
     /* 2097415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097418 */     // MIs[0] policy
     /* 2097418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097428 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2097431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097453 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097457 */     // GIR_Coverage, 16393,
     /* 2097457 */     GIR_EraseRootFromParent_Done,
     /* 2097458 */   // Label 27805: @2097458
     /* 2097458 */   GIM_Try, /*On fail goto*//*Label 27806*/ GIMT_Encode4(2097552), // Rule ID 16396 //
     /* 2097463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2097471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2097474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2097477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2097480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2097483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2097505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097509 */     // MIs[0] round
     /* 2097509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097512 */     // MIs[0] policy
     /* 2097512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097522 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2097525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097547 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097551 */     // GIR_Coverage, 16396,
     /* 2097551 */     GIR_EraseRootFromParent_Done,
     /* 2097552 */   // Label 27806: @2097552
     /* 2097552 */   GIM_Try, /*On fail goto*//*Label 27807*/ GIMT_Encode4(2097646), // Rule ID 16397 //
     /* 2097557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2097565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2097568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2097571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2097574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2097599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097603 */     // MIs[0] round
     /* 2097603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097606 */     // MIs[0] policy
     /* 2097606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097616 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2097619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097645 */     // GIR_Coverage, 16397,
     /* 2097645 */     GIR_EraseRootFromParent_Done,
     /* 2097646 */   // Label 27807: @2097646
     /* 2097646 */   GIM_Try, /*On fail goto*//*Label 27808*/ GIMT_Encode4(2097740), // Rule ID 16400 //
     /* 2097651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2097659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2097662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2097665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2097668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2097671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2097693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097697 */     // MIs[0] round
     /* 2097697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097700 */     // MIs[0] policy
     /* 2097700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097710 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2097713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097739 */     // GIR_Coverage, 16400,
     /* 2097739 */     GIR_EraseRootFromParent_Done,
     /* 2097740 */   // Label 27808: @2097740
     /* 2097740 */   GIM_Try, /*On fail goto*//*Label 27809*/ GIMT_Encode4(2097834), // Rule ID 16401 //
     /* 2097745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2097753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2097756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2097759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2097762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2097787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097791 */     // MIs[0] round
     /* 2097791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097794 */     // MIs[0] policy
     /* 2097794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097804 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2097807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097833 */     // GIR_Coverage, 16401,
     /* 2097833 */     GIR_EraseRootFromParent_Done,
     /* 2097834 */   // Label 27809: @2097834
     /* 2097834 */   GIM_Try, /*On fail goto*//*Label 27810*/ GIMT_Encode4(2097928), // Rule ID 16404 //
     /* 2097839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2097847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2097850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2097853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2097856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2097859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2097881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097885 */     // MIs[0] round
     /* 2097885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097888 */     // MIs[0] policy
     /* 2097888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097898 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2097901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097927 */     // GIR_Coverage, 16404,
     /* 2097927 */     GIR_EraseRootFromParent_Done,
     /* 2097928 */   // Label 27810: @2097928
     /* 2097928 */   GIM_Try, /*On fail goto*//*Label 27811*/ GIMT_Encode4(2098022), // Rule ID 16405 //
     /* 2097933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2097941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2097944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2097947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2097950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2097953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2097975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097979 */     // MIs[0] round
     /* 2097979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097982 */     // MIs[0] policy
     /* 2097982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097992 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2097995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2098015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098021 */     // GIR_Coverage, 16405,
     /* 2098021 */     GIR_EraseRootFromParent_Done,
     /* 2098022 */   // Label 27811: @2098022
     /* 2098022 */   GIM_Try, /*On fail goto*//*Label 27812*/ GIMT_Encode4(2098116), // Rule ID 16408 //
     /* 2098027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2098035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2098038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2098041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2098044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2098047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098073 */     // MIs[0] round
     /* 2098073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098076 */     // MIs[0] policy
     /* 2098076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098086 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2098089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2098109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098115 */     // GIR_Coverage, 16408,
     /* 2098115 */     GIR_EraseRootFromParent_Done,
     /* 2098116 */   // Label 27812: @2098116
     /* 2098116 */   GIM_Try, /*On fail goto*//*Label 27813*/ GIMT_Encode4(2098210), // Rule ID 16409 //
     /* 2098121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2098129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2098132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2098135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2098138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098167 */     // MIs[0] round
     /* 2098167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098170 */     // MIs[0] policy
     /* 2098170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2098183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2098203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098209 */     // GIR_Coverage, 16409,
     /* 2098209 */     GIR_EraseRootFromParent_Done,
     /* 2098210 */   // Label 27813: @2098210
     /* 2098210 */   GIM_Try, /*On fail goto*//*Label 27814*/ GIMT_Encode4(2098304), // Rule ID 16412 //
     /* 2098215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2098223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2098226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2098229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2098232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2098235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2098238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098261 */     // MIs[0] round
     /* 2098261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098264 */     // MIs[0] policy
     /* 2098264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098274 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2098277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2098297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098303 */     // GIR_Coverage, 16412,
     /* 2098303 */     GIR_EraseRootFromParent_Done,
     /* 2098304 */   // Label 27814: @2098304
     /* 2098304 */   GIM_Try, /*On fail goto*//*Label 27815*/ GIMT_Encode4(2098398), // Rule ID 16413 //
     /* 2098309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2098317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2098320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2098323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2098326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2098332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098355 */     // MIs[0] round
     /* 2098355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098358 */     // MIs[0] policy
     /* 2098358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098368 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2098371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2098391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098393 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098397 */     // GIR_Coverage, 16413,
     /* 2098397 */     GIR_EraseRootFromParent_Done,
     /* 2098398 */   // Label 27815: @2098398
     /* 2098398 */   GIM_Try, /*On fail goto*//*Label 27816*/ GIMT_Encode4(2098492), // Rule ID 16416 //
     /* 2098403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2098411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2098414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2098417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2098420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2098423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098449 */     // MIs[0] round
     /* 2098449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098452 */     // MIs[0] policy
     /* 2098452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098462 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2098465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098491 */     // GIR_Coverage, 16416,
     /* 2098491 */     GIR_EraseRootFromParent_Done,
     /* 2098492 */   // Label 27816: @2098492
     /* 2098492 */   GIM_Try, /*On fail goto*//*Label 27817*/ GIMT_Encode4(2098586), // Rule ID 16417 //
     /* 2098497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2098505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2098508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2098511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2098514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098543 */     // MIs[0] round
     /* 2098543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098546 */     // MIs[0] policy
     /* 2098546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098556 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2098559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098585 */     // GIR_Coverage, 16417,
     /* 2098585 */     GIR_EraseRootFromParent_Done,
     /* 2098586 */   // Label 27817: @2098586
     /* 2098586 */   GIM_Try, /*On fail goto*//*Label 27818*/ GIMT_Encode4(2098680), // Rule ID 16420 //
     /* 2098591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2098599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2098602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2098605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2098608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2098611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098637 */     // MIs[0] round
     /* 2098637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098640 */     // MIs[0] policy
     /* 2098640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098650 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2098653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098679 */     // GIR_Coverage, 16420,
     /* 2098679 */     GIR_EraseRootFromParent_Done,
     /* 2098680 */   // Label 27818: @2098680
     /* 2098680 */   GIM_Try, /*On fail goto*//*Label 27819*/ GIMT_Encode4(2098774), // Rule ID 16421 //
     /* 2098685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2098693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2098696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2098699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2098702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098731 */     // MIs[0] round
     /* 2098731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098734 */     // MIs[0] policy
     /* 2098734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2098747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098773 */     // GIR_Coverage, 16421,
     /* 2098773 */     GIR_EraseRootFromParent_Done,
     /* 2098774 */   // Label 27819: @2098774
     /* 2098774 */   GIM_Try, /*On fail goto*//*Label 27820*/ GIMT_Encode4(2098868), // Rule ID 16424 //
     /* 2098779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2098787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2098790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2098793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2098796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2098799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098825 */     // MIs[0] round
     /* 2098825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098828 */     // MIs[0] policy
     /* 2098828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098838 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2098841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098867 */     // GIR_Coverage, 16424,
     /* 2098867 */     GIR_EraseRootFromParent_Done,
     /* 2098868 */   // Label 27820: @2098868
     /* 2098868 */   GIM_Try, /*On fail goto*//*Label 27821*/ GIMT_Encode4(2098962), // Rule ID 16425 //
     /* 2098873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2098881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2098884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2098887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2098890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2098915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098919 */     // MIs[0] round
     /* 2098919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098922 */     // MIs[0] policy
     /* 2098922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098932 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2098935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098961 */     // GIR_Coverage, 16425,
     /* 2098961 */     GIR_EraseRootFromParent_Done,
     /* 2098962 */   // Label 27821: @2098962
     /* 2098962 */   GIM_Try, /*On fail goto*//*Label 27822*/ GIMT_Encode4(2099056), // Rule ID 16428 //
     /* 2098967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2098975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2098978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2098981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2098984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2098987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099013 */     // MIs[0] round
     /* 2099013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099016 */     // MIs[0] policy
     /* 2099016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099026 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2099029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099055 */     // GIR_Coverage, 16428,
     /* 2099055 */     GIR_EraseRootFromParent_Done,
     /* 2099056 */   // Label 27822: @2099056
     /* 2099056 */   GIM_Try, /*On fail goto*//*Label 27823*/ GIMT_Encode4(2099150), // Rule ID 16429 //
     /* 2099061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2099069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2099072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2099075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2099078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099107 */     // MIs[0] round
     /* 2099107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099110 */     // MIs[0] policy
     /* 2099110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099120 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2099123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099149 */     // GIR_Coverage, 16429,
     /* 2099149 */     GIR_EraseRootFromParent_Done,
     /* 2099150 */   // Label 27823: @2099150
     /* 2099150 */   GIM_Try, /*On fail goto*//*Label 27824*/ GIMT_Encode4(2099244), // Rule ID 16432 //
     /* 2099155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2099163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2099166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2099169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2099172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2099178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2099185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099201 */     // MIs[0] round
     /* 2099201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099204 */     // MIs[0] policy
     /* 2099204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099214 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2099217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099243 */     // GIR_Coverage, 16432,
     /* 2099243 */     GIR_EraseRootFromParent_Done,
     /* 2099244 */   // Label 27824: @2099244
     /* 2099244 */   GIM_Try, /*On fail goto*//*Label 27825*/ GIMT_Encode4(2099338), // Rule ID 16433 //
     /* 2099249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2099257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2099260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2099263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2099266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2099272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2099279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099295 */     // MIs[0] round
     /* 2099295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099298 */     // MIs[0] policy
     /* 2099298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099308 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2099311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099337 */     // GIR_Coverage, 16433,
     /* 2099337 */     GIR_EraseRootFromParent_Done,
     /* 2099338 */   // Label 27825: @2099338
     /* 2099338 */   GIM_Try, /*On fail goto*//*Label 27826*/ GIMT_Encode4(2099432), // Rule ID 16436 //
     /* 2099343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2099346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2099351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2099354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2099357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2099360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099389 */     // MIs[0] round
     /* 2099389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099392 */     // MIs[0] policy
     /* 2099392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099402 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2099405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099431 */     // GIR_Coverage, 16436,
     /* 2099431 */     GIR_EraseRootFromParent_Done,
     /* 2099432 */   // Label 27826: @2099432
     /* 2099432 */   GIM_Try, /*On fail goto*//*Label 27827*/ GIMT_Encode4(2099526), // Rule ID 16437 //
     /* 2099437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2099440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2099445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2099448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2099451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2099454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099483 */     // MIs[0] round
     /* 2099483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099486 */     // MIs[0] policy
     /* 2099486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099496 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2099499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099521 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099525 */     // GIR_Coverage, 16437,
     /* 2099525 */     GIR_EraseRootFromParent_Done,
     /* 2099526 */   // Label 27827: @2099526
     /* 2099526 */   GIM_Try, /*On fail goto*//*Label 27828*/ GIMT_Encode4(2099620), // Rule ID 16440 //
     /* 2099531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2099534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2099539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2099542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2099545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2099548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099577 */     // MIs[0] round
     /* 2099577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099580 */     // MIs[0] policy
     /* 2099580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099590 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2099593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099619 */     // GIR_Coverage, 16440,
     /* 2099619 */     GIR_EraseRootFromParent_Done,
     /* 2099620 */   // Label 27828: @2099620
     /* 2099620 */   GIM_Try, /*On fail goto*//*Label 27829*/ GIMT_Encode4(2099714), // Rule ID 16441 //
     /* 2099625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2099628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2099633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2099636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2099639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2099642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099671 */     // MIs[0] round
     /* 2099671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099674 */     // MIs[0] policy
     /* 2099674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099684 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2099687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099713 */     // GIR_Coverage, 16441,
     /* 2099713 */     GIR_EraseRootFromParent_Done,
     /* 2099714 */   // Label 27829: @2099714
     /* 2099714 */   GIM_Try, /*On fail goto*//*Label 27830*/ GIMT_Encode4(2099808), // Rule ID 16444 //
     /* 2099719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2099722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2099727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2099730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2099733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2099736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099765 */     // MIs[0] round
     /* 2099765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099768 */     // MIs[0] policy
     /* 2099768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2099781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099807 */     // GIR_Coverage, 16444,
     /* 2099807 */     GIR_EraseRootFromParent_Done,
     /* 2099808 */   // Label 27830: @2099808
     /* 2099808 */   GIM_Try, /*On fail goto*//*Label 27831*/ GIMT_Encode4(2099902), // Rule ID 16445 //
     /* 2099813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2099816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2099821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2099824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2099827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2099830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099859 */     // MIs[0] round
     /* 2099859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099862 */     // MIs[0] policy
     /* 2099862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2099875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099901 */     // GIR_Coverage, 16445,
     /* 2099901 */     GIR_EraseRootFromParent_Done,
     /* 2099902 */   // Label 27831: @2099902
     /* 2099902 */   GIM_Try, /*On fail goto*//*Label 27832*/ GIMT_Encode4(2099996), // Rule ID 16448 //
     /* 2099907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2099910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2099915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2099918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2099921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2099924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2099937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099953 */     // MIs[0] round
     /* 2099953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099956 */     // MIs[0] policy
     /* 2099956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099966 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2099969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099995 */     // GIR_Coverage, 16448,
     /* 2099995 */     GIR_EraseRootFromParent_Done,
     /* 2099996 */   // Label 27832: @2099996
     /* 2099996 */   GIM_Try, /*On fail goto*//*Label 27833*/ GIMT_Encode4(2100090), // Rule ID 16449 //
     /* 2100001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2100004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2100009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2100012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2100015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2100018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100047 */     // MIs[0] round
     /* 2100047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100050 */     // MIs[0] policy
     /* 2100050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100060 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2100063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2100083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100089 */     // GIR_Coverage, 16449,
     /* 2100089 */     GIR_EraseRootFromParent_Done,
     /* 2100090 */   // Label 27833: @2100090
     /* 2100090 */   GIM_Try, /*On fail goto*//*Label 27834*/ GIMT_Encode4(2100184), // Rule ID 16512 //
     /* 2100095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2100106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2100109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2100112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2100115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100141 */     // MIs[0] round
     /* 2100141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100144 */     // MIs[0] policy
     /* 2100144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100154 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2100157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100183 */     // GIR_Coverage, 16512,
     /* 2100183 */     GIR_EraseRootFromParent_Done,
     /* 2100184 */   // Label 27834: @2100184
     /* 2100184 */   GIM_Try, /*On fail goto*//*Label 27835*/ GIMT_Encode4(2100278), // Rule ID 16513 //
     /* 2100189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2100200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2100203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2100206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2100209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100235 */     // MIs[0] round
     /* 2100235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100238 */     // MIs[0] policy
     /* 2100238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100248 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2100251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100277 */     // GIR_Coverage, 16513,
     /* 2100277 */     GIR_EraseRootFromParent_Done,
     /* 2100278 */   // Label 27835: @2100278
     /* 2100278 */   GIM_Try, /*On fail goto*//*Label 27836*/ GIMT_Encode4(2100372), // Rule ID 16516 //
     /* 2100283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2100294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2100297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2100300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2100303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2100306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100329 */     // MIs[0] round
     /* 2100329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100332 */     // MIs[0] policy
     /* 2100332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100342 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2100345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100371 */     // GIR_Coverage, 16516,
     /* 2100371 */     GIR_EraseRootFromParent_Done,
     /* 2100372 */   // Label 27836: @2100372
     /* 2100372 */   GIM_Try, /*On fail goto*//*Label 27837*/ GIMT_Encode4(2100466), // Rule ID 16517 //
     /* 2100377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2100388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2100391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2100394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2100397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2100400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100423 */     // MIs[0] round
     /* 2100423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100426 */     // MIs[0] policy
     /* 2100426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100436 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2100439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100465 */     // GIR_Coverage, 16517,
     /* 2100465 */     GIR_EraseRootFromParent_Done,
     /* 2100466 */   // Label 27837: @2100466
     /* 2100466 */   GIM_Try, /*On fail goto*//*Label 27838*/ GIMT_Encode4(2100560), // Rule ID 16520 //
     /* 2100471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2100482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2100485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2100488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2100491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2100494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100517 */     // MIs[0] round
     /* 2100517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100520 */     // MIs[0] policy
     /* 2100520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100530 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2100533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100559 */     // GIR_Coverage, 16520,
     /* 2100559 */     GIR_EraseRootFromParent_Done,
     /* 2100560 */   // Label 27838: @2100560
     /* 2100560 */   GIM_Try, /*On fail goto*//*Label 27839*/ GIMT_Encode4(2100654), // Rule ID 16521 //
     /* 2100565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2100576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2100579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2100582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2100585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2100588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100611 */     // MIs[0] round
     /* 2100611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100614 */     // MIs[0] policy
     /* 2100614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100624 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2100627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100653 */     // GIR_Coverage, 16521,
     /* 2100653 */     GIR_EraseRootFromParent_Done,
     /* 2100654 */   // Label 27839: @2100654
     /* 2100654 */   GIM_Try, /*On fail goto*//*Label 27840*/ GIMT_Encode4(2100748), // Rule ID 16524 //
     /* 2100659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2100670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2100673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2100676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2100679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100705 */     // MIs[0] round
     /* 2100705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100708 */     // MIs[0] policy
     /* 2100708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2100721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100747 */     // GIR_Coverage, 16524,
     /* 2100747 */     GIR_EraseRootFromParent_Done,
     /* 2100748 */   // Label 27840: @2100748
     /* 2100748 */   GIM_Try, /*On fail goto*//*Label 27841*/ GIMT_Encode4(2100842), // Rule ID 16525 //
     /* 2100753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2100764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2100767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2100770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2100773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100799 */     // MIs[0] round
     /* 2100799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100802 */     // MIs[0] policy
     /* 2100802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100812 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2100815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100841 */     // GIR_Coverage, 16525,
     /* 2100841 */     GIR_EraseRootFromParent_Done,
     /* 2100842 */   // Label 27841: @2100842
     /* 2100842 */   GIM_Try, /*On fail goto*//*Label 27842*/ GIMT_Encode4(2100936), // Rule ID 16528 //
     /* 2100847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2100858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2100861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2100864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2100867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2100870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100893 */     // MIs[0] round
     /* 2100893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100896 */     // MIs[0] policy
     /* 2100896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100906 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2100909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100935 */     // GIR_Coverage, 16528,
     /* 2100935 */     GIR_EraseRootFromParent_Done,
     /* 2100936 */   // Label 27842: @2100936
     /* 2100936 */   GIM_Try, /*On fail goto*//*Label 27843*/ GIMT_Encode4(2101030), // Rule ID 16529 //
     /* 2100941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2100952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2100955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2100958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2100961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2100964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100987 */     // MIs[0] round
     /* 2100987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100990 */     // MIs[0] policy
     /* 2100990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101000 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2101003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101029 */     // GIR_Coverage, 16529,
     /* 2101029 */     GIR_EraseRootFromParent_Done,
     /* 2101030 */   // Label 27843: @2101030
     /* 2101030 */   GIM_Try, /*On fail goto*//*Label 27844*/ GIMT_Encode4(2101124), // Rule ID 16532 //
     /* 2101035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2101046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2101049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2101052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2101055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2101058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101081 */     // MIs[0] round
     /* 2101081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101084 */     // MIs[0] policy
     /* 2101084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101094 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2101097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101123 */     // GIR_Coverage, 16532,
     /* 2101123 */     GIR_EraseRootFromParent_Done,
     /* 2101124 */   // Label 27844: @2101124
     /* 2101124 */   GIM_Try, /*On fail goto*//*Label 27845*/ GIMT_Encode4(2101218), // Rule ID 16533 //
     /* 2101129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2101140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2101143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2101146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2101149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2101152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101175 */     // MIs[0] round
     /* 2101175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101178 */     // MIs[0] policy
     /* 2101178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101188 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2101191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2101211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101217 */     // GIR_Coverage, 16533,
     /* 2101217 */     GIR_EraseRootFromParent_Done,
     /* 2101218 */   // Label 27845: @2101218
     /* 2101218 */   GIM_Try, /*On fail goto*//*Label 27846*/ GIMT_Encode4(2101312), // Rule ID 16536 //
     /* 2101223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2101234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2101237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2101240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2101243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101269 */     // MIs[0] round
     /* 2101269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101272 */     // MIs[0] policy
     /* 2101272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101282 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2101285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101311 */     // GIR_Coverage, 16536,
     /* 2101311 */     GIR_EraseRootFromParent_Done,
     /* 2101312 */   // Label 27846: @2101312
     /* 2101312 */   GIM_Try, /*On fail goto*//*Label 27847*/ GIMT_Encode4(2101406), // Rule ID 16537 //
     /* 2101317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2101328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2101331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2101334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2101337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101363 */     // MIs[0] round
     /* 2101363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101366 */     // MIs[0] policy
     /* 2101366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2101379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101405 */     // GIR_Coverage, 16537,
     /* 2101405 */     GIR_EraseRootFromParent_Done,
     /* 2101406 */   // Label 27847: @2101406
     /* 2101406 */   GIM_Try, /*On fail goto*//*Label 27848*/ GIMT_Encode4(2101500), // Rule ID 16540 //
     /* 2101411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2101422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2101425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2101428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2101431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101457 */     // MIs[0] round
     /* 2101457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101460 */     // MIs[0] policy
     /* 2101460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101470 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2101473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101499 */     // GIR_Coverage, 16540,
     /* 2101499 */     GIR_EraseRootFromParent_Done,
     /* 2101500 */   // Label 27848: @2101500
     /* 2101500 */   GIM_Try, /*On fail goto*//*Label 27849*/ GIMT_Encode4(2101594), // Rule ID 16541 //
     /* 2101505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2101516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2101519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2101522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2101525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101551 */     // MIs[0] round
     /* 2101551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101554 */     // MIs[0] policy
     /* 2101554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2101567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101593 */     // GIR_Coverage, 16541,
     /* 2101593 */     GIR_EraseRootFromParent_Done,
     /* 2101594 */   // Label 27849: @2101594
     /* 2101594 */   GIM_Try, /*On fail goto*//*Label 27850*/ GIMT_Encode4(2101688), // Rule ID 16544 //
     /* 2101599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2101610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2101613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2101616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2101619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101645 */     // MIs[0] round
     /* 2101645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101648 */     // MIs[0] policy
     /* 2101648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101658 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2101661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101687 */     // GIR_Coverage, 16544,
     /* 2101687 */     GIR_EraseRootFromParent_Done,
     /* 2101688 */   // Label 27850: @2101688
     /* 2101688 */   GIM_Try, /*On fail goto*//*Label 27851*/ GIMT_Encode4(2101782), // Rule ID 16545 //
     /* 2101693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2101704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2101707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2101710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2101713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101739 */     // MIs[0] round
     /* 2101739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101742 */     // MIs[0] policy
     /* 2101742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2101755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101781 */     // GIR_Coverage, 16545,
     /* 2101781 */     GIR_EraseRootFromParent_Done,
     /* 2101782 */   // Label 27851: @2101782
     /* 2101782 */   GIM_Try, /*On fail goto*//*Label 27852*/ GIMT_Encode4(2101876), // Rule ID 16548 //
     /* 2101787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2101798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2101801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2101804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2101807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101833 */     // MIs[0] round
     /* 2101833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101836 */     // MIs[0] policy
     /* 2101836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2101849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101875 */     // GIR_Coverage, 16548,
     /* 2101875 */     GIR_EraseRootFromParent_Done,
     /* 2101876 */   // Label 27852: @2101876
     /* 2101876 */   GIM_Try, /*On fail goto*//*Label 27853*/ GIMT_Encode4(2101970), // Rule ID 16549 //
     /* 2101881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2101892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2101895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2101898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2101901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101927 */     // MIs[0] round
     /* 2101927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101930 */     // MIs[0] policy
     /* 2101930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101940 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2101943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101969 */     // GIR_Coverage, 16549,
     /* 2101969 */     GIR_EraseRootFromParent_Done,
     /* 2101970 */   // Label 27853: @2101970
     /* 2101970 */   GIM_Try, /*On fail goto*//*Label 27854*/ GIMT_Encode4(2102064), // Rule ID 16552 //
     /* 2101975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2101986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2101989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2101992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2101995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2101998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102021 */     // MIs[0] round
     /* 2102021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102024 */     // MIs[0] policy
     /* 2102024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2102037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102063 */     // GIR_Coverage, 16552,
     /* 2102063 */     GIR_EraseRootFromParent_Done,
     /* 2102064 */   // Label 27854: @2102064
     /* 2102064 */   GIM_Try, /*On fail goto*//*Label 27855*/ GIMT_Encode4(2102158), // Rule ID 16553 //
     /* 2102069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2102072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2102080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2102083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2102086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2102089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2102092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102115 */     // MIs[0] round
     /* 2102115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102118 */     // MIs[0] policy
     /* 2102118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102128 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2102131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102157 */     // GIR_Coverage, 16553,
     /* 2102157 */     GIR_EraseRootFromParent_Done,
     /* 2102158 */   // Label 27855: @2102158
     /* 2102158 */   GIM_Try, /*On fail goto*//*Label 27856*/ GIMT_Encode4(2102252), // Rule ID 16556 //
     /* 2102163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2102166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2102174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2102177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2102180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2102183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102209 */     // MIs[0] round
     /* 2102209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102212 */     // MIs[0] policy
     /* 2102212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102222 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2102225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102251 */     // GIR_Coverage, 16556,
     /* 2102251 */     GIR_EraseRootFromParent_Done,
     /* 2102252 */   // Label 27856: @2102252
     /* 2102252 */   GIM_Try, /*On fail goto*//*Label 27857*/ GIMT_Encode4(2102346), // Rule ID 16557 //
     /* 2102257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2102260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2102268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2102271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2102274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2102277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102303 */     // MIs[0] round
     /* 2102303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102306 */     // MIs[0] policy
     /* 2102306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102316 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2102319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102345 */     // GIR_Coverage, 16557,
     /* 2102345 */     GIR_EraseRootFromParent_Done,
     /* 2102346 */   // Label 27857: @2102346
     /* 2102346 */   GIM_Try, /*On fail goto*//*Label 27858*/ GIMT_Encode4(2102440), // Rule ID 16560 //
     /* 2102351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2102354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2102362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2102365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2102368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2102371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102397 */     // MIs[0] round
     /* 2102397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102400 */     // MIs[0] policy
     /* 2102400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102410 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2102413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102439 */     // GIR_Coverage, 16560,
     /* 2102439 */     GIR_EraseRootFromParent_Done,
     /* 2102440 */   // Label 27858: @2102440
     /* 2102440 */   GIM_Try, /*On fail goto*//*Label 27859*/ GIMT_Encode4(2102534), // Rule ID 16561 //
     /* 2102445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2102448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2102456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2102459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2102462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2102465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102491 */     // MIs[0] round
     /* 2102491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102494 */     // MIs[0] policy
     /* 2102494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102504 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2102507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102533 */     // GIR_Coverage, 16561,
     /* 2102533 */     GIR_EraseRootFromParent_Done,
     /* 2102534 */   // Label 27859: @2102534
     /* 2102534 */   GIM_Try, /*On fail goto*//*Label 27860*/ GIMT_Encode4(2102628), // Rule ID 16564 //
     /* 2102539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2102542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2102550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2102553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2102556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2102559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2102569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102585 */     // MIs[0] round
     /* 2102585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102588 */     // MIs[0] policy
     /* 2102588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2102601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102627 */     // GIR_Coverage, 16564,
     /* 2102627 */     GIR_EraseRootFromParent_Done,
     /* 2102628 */   // Label 27860: @2102628
     /* 2102628 */   GIM_Try, /*On fail goto*//*Label 27861*/ GIMT_Encode4(2102722), // Rule ID 16565 //
     /* 2102633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2102636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2102644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2102647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2102650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2102653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2102663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102679 */     // MIs[0] round
     /* 2102679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102682 */     // MIs[0] policy
     /* 2102682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2102695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102721 */     // GIR_Coverage, 16565,
     /* 2102721 */     GIR_EraseRootFromParent_Done,
     /* 2102722 */   // Label 27861: @2102722
     /* 2102722 */   GIM_Try, /*On fail goto*//*Label 27862*/ GIMT_Encode4(2102816), // Rule ID 16568 //
     /* 2102727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2102730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2102738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2102741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2102744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2102747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2102750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102773 */     // MIs[0] round
     /* 2102773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102776 */     // MIs[0] policy
     /* 2102776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102786 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2102789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102815 */     // GIR_Coverage, 16568,
     /* 2102815 */     GIR_EraseRootFromParent_Done,
     /* 2102816 */   // Label 27862: @2102816
     /* 2102816 */   GIM_Try, /*On fail goto*//*Label 27863*/ GIMT_Encode4(2102910), // Rule ID 16569 //
     /* 2102821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2102824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2102832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2102835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2102838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2102841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2102844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102867 */     // MIs[0] round
     /* 2102867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102870 */     // MIs[0] policy
     /* 2102870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102880 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2102883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102909 */     // GIR_Coverage, 16569,
     /* 2102909 */     GIR_EraseRootFromParent_Done,
     /* 2102910 */   // Label 27863: @2102910
     /* 2102910 */   GIM_Try, /*On fail goto*//*Label 27864*/ GIMT_Encode4(2103004), // Rule ID 16572 //
     /* 2102915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2102918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2102926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2102929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2102932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2102935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2102957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102961 */     // MIs[0] round
     /* 2102961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102964 */     // MIs[0] policy
     /* 2102964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102974 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2102977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2102997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2103002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103003 */     // GIR_Coverage, 16572,
     /* 2103003 */     GIR_EraseRootFromParent_Done,
     /* 2103004 */   // Label 27864: @2103004
     /* 2103004 */   GIM_Try, /*On fail goto*//*Label 27865*/ GIMT_Encode4(2103098), // Rule ID 16573 //
     /* 2103009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2103012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2103017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2103020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2103023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2103026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2103032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103055 */     // MIs[0] round
     /* 2103055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103058 */     // MIs[0] policy
     /* 2103058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103068 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2103071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2103096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103097 */     // GIR_Coverage, 16573,
     /* 2103097 */     GIR_EraseRootFromParent_Done,
     /* 2103098 */   // Label 27865: @2103098
     /* 2103098 */   GIM_Try, /*On fail goto*//*Label 27866*/ GIMT_Encode4(2103192), // Rule ID 16576 //
     /* 2103103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2103106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2103111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2103114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2103117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2103120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2103123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2103126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103149 */     // MIs[0] round
     /* 2103149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103152 */     // MIs[0] policy
     /* 2103152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103162 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2103165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2103190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103191 */     // GIR_Coverage, 16576,
     /* 2103191 */     GIR_EraseRootFromParent_Done,
     /* 2103192 */   // Label 27866: @2103192
     /* 2103192 */   GIM_Try, /*On fail goto*//*Label 27867*/ GIMT_Encode4(2103286), // Rule ID 16577 //
     /* 2103197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2103200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2103205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2103208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2103211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2103214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2103220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103243 */     // MIs[0] round
     /* 2103243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103246 */     // MIs[0] policy
     /* 2103246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103256 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2103259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2103284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103285 */     // GIR_Coverage, 16577,
     /* 2103285 */     GIR_EraseRootFromParent_Done,
     /* 2103286 */   // Label 27867: @2103286
     /* 2103286 */   GIM_Try, /*On fail goto*//*Label 27868*/ GIMT_Encode4(2103380), // Rule ID 16580 //
     /* 2103291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2103294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2103299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2103302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2103305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2103308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2103311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2103314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103337 */     // MIs[0] round
     /* 2103337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103340 */     // MIs[0] policy
     /* 2103340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103350 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2103353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2103378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103379 */     // GIR_Coverage, 16580,
     /* 2103379 */     GIR_EraseRootFromParent_Done,
     /* 2103380 */   // Label 27868: @2103380
     /* 2103380 */   GIM_Try, /*On fail goto*//*Label 27869*/ GIMT_Encode4(2103474), // Rule ID 16581 //
     /* 2103385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2103388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2103393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2103396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2103399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2103402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2103408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103431 */     // MIs[0] round
     /* 2103431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103434 */     // MIs[0] policy
     /* 2103434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103444 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2103447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2103472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103473 */     // GIR_Coverage, 16581,
     /* 2103473 */     GIR_EraseRootFromParent_Done,
     /* 2103474 */   // Label 27869: @2103474
     /* 2103474 */   GIM_Try, /*On fail goto*//*Label 27870*/ GIMT_Encode4(2103568), // Rule ID 16584 //
     /* 2103479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2103482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2103487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2103490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2103493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2103496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2103499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103525 */     // MIs[0] round
     /* 2103525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103528 */     // MIs[0] policy
     /* 2103528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103538 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2103541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103563 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2103566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103567 */     // GIR_Coverage, 16584,
     /* 2103567 */     GIR_EraseRootFromParent_Done,
     /* 2103568 */   // Label 27870: @2103568
     /* 2103568 */   GIM_Try, /*On fail goto*//*Label 27871*/ GIMT_Encode4(2103662), // Rule ID 16585 //
     /* 2103573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2103576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2103581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2103584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2103587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2103590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103619 */     // MIs[0] round
     /* 2103619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103622 */     // MIs[0] policy
     /* 2103622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103632 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2103635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103657 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2103660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103661 */     // GIR_Coverage, 16585,
     /* 2103661 */     GIR_EraseRootFromParent_Done,
     /* 2103662 */   // Label 27871: @2103662
     /* 2103662 */   GIM_Try, /*On fail goto*//*Label 27872*/ GIMT_Encode4(2103756), // Rule ID 16588 //
     /* 2103667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2103670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2103675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2103678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2103681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2103684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2103687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103713 */     // MIs[0] round
     /* 2103713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103716 */     // MIs[0] policy
     /* 2103716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103726 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2103729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2103754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103755 */     // GIR_Coverage, 16588,
     /* 2103755 */     GIR_EraseRootFromParent_Done,
     /* 2103756 */   // Label 27872: @2103756
     /* 2103756 */   GIM_Try, /*On fail goto*//*Label 27873*/ GIMT_Encode4(2103850), // Rule ID 16589 //
     /* 2103761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2103764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2103769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2103772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2103775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2103778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103807 */     // MIs[0] round
     /* 2103807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103810 */     // MIs[0] policy
     /* 2103810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103820 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2103823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2103848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103849 */     // GIR_Coverage, 16589,
     /* 2103849 */     GIR_EraseRootFromParent_Done,
     /* 2103850 */   // Label 27873: @2103850
     /* 2103850 */   GIM_Try, /*On fail goto*//*Label 27874*/ GIMT_Encode4(2103944), // Rule ID 16592 //
     /* 2103855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2103858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2103863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2103866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2103869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2103872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2103875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2103878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103901 */     // MIs[0] round
     /* 2103901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103904 */     // MIs[0] policy
     /* 2103904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103914 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2103917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2103937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2103942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103943 */     // GIR_Coverage, 16592,
     /* 2103943 */     GIR_EraseRootFromParent_Done,
     /* 2103944 */   // Label 27874: @2103944
     /* 2103944 */   GIM_Try, /*On fail goto*//*Label 27875*/ GIMT_Encode4(2104038), // Rule ID 16593 //
     /* 2103949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2103952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2103957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2103960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2103963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2103966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2103972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2103991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103995 */     // MIs[0] round
     /* 2103995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103998 */     // MIs[0] policy
     /* 2103998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104008 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2104011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2104031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2104036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104037 */     // GIR_Coverage, 16593,
     /* 2104037 */     GIR_EraseRootFromParent_Done,
     /* 2104038 */   // Label 27875: @2104038
     /* 2104038 */   GIM_Try, /*On fail goto*//*Label 27876*/ GIMT_Encode4(2104132), // Rule ID 16596 //
     /* 2104043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2104046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2104051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2104054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2104057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2104060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2104063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2104066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2104085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104089 */     // MIs[0] round
     /* 2104089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104092 */     // MIs[0] policy
     /* 2104092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104102 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2104105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2104130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104131 */     // GIR_Coverage, 16596,
     /* 2104131 */     GIR_EraseRootFromParent_Done,
     /* 2104132 */   // Label 27876: @2104132
     /* 2104132 */   GIM_Try, /*On fail goto*//*Label 27877*/ GIMT_Encode4(2104226), // Rule ID 16597 //
     /* 2104137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2104140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2104145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2104148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2104151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2104154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2104157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2104160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2104179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104183 */     // MIs[0] round
     /* 2104183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104186 */     // MIs[0] policy
     /* 2104186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104196 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2104199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104221 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2104224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104225 */     // GIR_Coverage, 16597,
     /* 2104225 */     GIR_EraseRootFromParent_Done,
     /* 2104226 */   // Label 27877: @2104226
     /* 2104226 */   GIM_Try, /*On fail goto*//*Label 27878*/ GIMT_Encode4(2104320), // Rule ID 16600 //
     /* 2104231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2104234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2104239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2104242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2104245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2104248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2104251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2104273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104277 */     // MIs[0] round
     /* 2104277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104280 */     // MIs[0] policy
     /* 2104280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104290 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2104293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2104318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104319 */     // GIR_Coverage, 16600,
     /* 2104319 */     GIR_EraseRootFromParent_Done,
     /* 2104320 */   // Label 27878: @2104320
     /* 2104320 */   GIM_Try, /*On fail goto*//*Label 27879*/ GIMT_Encode4(2104414), // Rule ID 16601 //
     /* 2104325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2104328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2104333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2104336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2104339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2104342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2104345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2104367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104371 */     // MIs[0] round
     /* 2104371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104374 */     // MIs[0] policy
     /* 2104374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104384 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2104387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2104412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104413 */     // GIR_Coverage, 16601,
     /* 2104413 */     GIR_EraseRootFromParent_Done,
     /* 2104414 */   // Label 27879: @2104414
     /* 2104414 */   GIM_Try, /*On fail goto*//*Label 27880*/ GIMT_Encode4(2104508), // Rule ID 16604 //
     /* 2104419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2104422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2104427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2104430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2104433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2104436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2104439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2104461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104465 */     // MIs[0] round
     /* 2104465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104468 */     // MIs[0] policy
     /* 2104468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104478 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2104481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2104506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104507 */     // GIR_Coverage, 16604,
     /* 2104507 */     GIR_EraseRootFromParent_Done,
     /* 2104508 */   // Label 27880: @2104508
     /* 2104508 */   GIM_Try, /*On fail goto*//*Label 27881*/ GIMT_Encode4(2104602), // Rule ID 16605 //
     /* 2104513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2104516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2104521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2104524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2104527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2104530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2104533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2104555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104559 */     // MIs[0] round
     /* 2104559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104562 */     // MIs[0] policy
     /* 2104562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104572 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2104575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2104600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104601 */     // GIR_Coverage, 16605,
     /* 2104601 */     GIR_EraseRootFromParent_Done,
     /* 2104602 */   // Label 27881: @2104602
     /* 2104602 */   GIM_Try, /*On fail goto*//*Label 27882*/ GIMT_Encode4(2104696), // Rule ID 16608 //
     /* 2104607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2104610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2104615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2104618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2104621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2104624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2104627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2104649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104653 */     // MIs[0] round
     /* 2104653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104656 */     // MIs[0] policy
     /* 2104656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104666 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2104669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2104694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104695 */     // GIR_Coverage, 16608,
     /* 2104695 */     GIR_EraseRootFromParent_Done,
     /* 2104696 */   // Label 27882: @2104696
     /* 2104696 */   GIM_Try, /*On fail goto*//*Label 27883*/ GIMT_Encode4(2104790), // Rule ID 16609 //
     /* 2104701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2104704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2104709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2104712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2104715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2104718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2104721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2104743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104747 */     // MIs[0] round
     /* 2104747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104750 */     // MIs[0] policy
     /* 2104750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104760 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2104763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2104788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104789 */     // GIR_Coverage, 16609,
     /* 2104789 */     GIR_EraseRootFromParent_Done,
     /* 2104790 */   // Label 27883: @2104790
     /* 2104790 */   GIM_Try, /*On fail goto*//*Label 27884*/ GIMT_Encode4(2104884), // Rule ID 16612 //
     /* 2104795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2104798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2104803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2104806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2104809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2104812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2104815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2104818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2104837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104841 */     // MIs[0] round
     /* 2104841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104844 */     // MIs[0] policy
     /* 2104844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104854 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2104857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2104882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104883 */     // GIR_Coverage, 16612,
     /* 2104883 */     GIR_EraseRootFromParent_Done,
     /* 2104884 */   // Label 27884: @2104884
     /* 2104884 */   GIM_Try, /*On fail goto*//*Label 27885*/ GIMT_Encode4(2104978), // Rule ID 16613 //
     /* 2104889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2104892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2104897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2104900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2104903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2104906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2104909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2104912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2104931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104935 */     // MIs[0] round
     /* 2104935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104938 */     // MIs[0] policy
     /* 2104938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104948 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2104951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2104976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104977 */     // GIR_Coverage, 16613,
     /* 2104977 */     GIR_EraseRootFromParent_Done,
     /* 2104978 */   // Label 27885: @2104978
     /* 2104978 */   GIM_Try, /*On fail goto*//*Label 27886*/ GIMT_Encode4(2105072), // Rule ID 16616 //
     /* 2104983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2104986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2104991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2104994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2104997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2105000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2105025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105029 */     // MIs[0] round
     /* 2105029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105032 */     // MIs[0] policy
     /* 2105032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105042 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2105045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2105070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105071 */     // GIR_Coverage, 16616,
     /* 2105071 */     GIR_EraseRootFromParent_Done,
     /* 2105072 */   // Label 27886: @2105072
     /* 2105072 */   GIM_Try, /*On fail goto*//*Label 27887*/ GIMT_Encode4(2105166), // Rule ID 16617 //
     /* 2105077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2105080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2105085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2105088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2105091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2105094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2105119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105123 */     // MIs[0] round
     /* 2105123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105126 */     // MIs[0] policy
     /* 2105126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105136 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2105139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2105164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105165 */     // GIR_Coverage, 16617,
     /* 2105165 */     GIR_EraseRootFromParent_Done,
     /* 2105166 */   // Label 27887: @2105166
     /* 2105166 */   GIM_Try, /*On fail goto*//*Label 27888*/ GIMT_Encode4(2105260), // Rule ID 16620 //
     /* 2105171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2105174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2105179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2105182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2105185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2105188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2105213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105217 */     // MIs[0] round
     /* 2105217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105220 */     // MIs[0] policy
     /* 2105220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2105233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2105258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105259 */     // GIR_Coverage, 16620,
     /* 2105259 */     GIR_EraseRootFromParent_Done,
     /* 2105260 */   // Label 27888: @2105260
     /* 2105260 */   GIM_Try, /*On fail goto*//*Label 27889*/ GIMT_Encode4(2105354), // Rule ID 16621 //
     /* 2105265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2105268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2105273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2105276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2105279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2105282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2105307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105311 */     // MIs[0] round
     /* 2105311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105314 */     // MIs[0] policy
     /* 2105314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2105327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2105352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105353 */     // GIR_Coverage, 16621,
     /* 2105353 */     GIR_EraseRootFromParent_Done,
     /* 2105354 */   // Label 27889: @2105354
     /* 2105354 */   GIM_Try, /*On fail goto*//*Label 27890*/ GIMT_Encode4(2105448), // Rule ID 16624 //
     /* 2105359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2105362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2105367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2105370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2105373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2105376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2105389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2105401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105405 */     // MIs[0] round
     /* 2105405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105408 */     // MIs[0] policy
     /* 2105408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2105421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2105446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105447 */     // GIR_Coverage, 16624,
     /* 2105447 */     GIR_EraseRootFromParent_Done,
     /* 2105448 */   // Label 27890: @2105448
     /* 2105448 */   GIM_Try, /*On fail goto*//*Label 27891*/ GIMT_Encode4(2105542), // Rule ID 16625 //
     /* 2105453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2105456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2105461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2105464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2105467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2105470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2105483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2105495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105499 */     // MIs[0] round
     /* 2105499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105502 */     // MIs[0] policy
     /* 2105502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2105515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2105540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105541 */     // GIR_Coverage, 16625,
     /* 2105541 */     GIR_EraseRootFromParent_Done,
     /* 2105542 */   // Label 27891: @2105542
     /* 2105542 */   GIM_Try, /*On fail goto*//*Label 27892*/ GIMT_Encode4(2105636), // Rule ID 16628 //
     /* 2105547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2105550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2105555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2105558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2105561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2105564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2105577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2105589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105593 */     // MIs[0] round
     /* 2105593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105596 */     // MIs[0] policy
     /* 2105596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2105609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2105634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105635 */     // GIR_Coverage, 16628,
     /* 2105635 */     GIR_EraseRootFromParent_Done,
     /* 2105636 */   // Label 27892: @2105636
     /* 2105636 */   GIM_Try, /*On fail goto*//*Label 27893*/ GIMT_Encode4(2105730), // Rule ID 16629 //
     /* 2105641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2105644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2105649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2105652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2105655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2105658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2105671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2105683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105687 */     // MIs[0] round
     /* 2105687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105690 */     // MIs[0] policy
     /* 2105690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105700 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2105703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2105728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105729 */     // GIR_Coverage, 16629,
     /* 2105729 */     GIR_EraseRootFromParent_Done,
     /* 2105730 */   // Label 27893: @2105730
     /* 2105730 */   GIM_Try, /*On fail goto*//*Label 27894*/ GIMT_Encode4(2105821), // Rule ID 16692 //
     /* 2105735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2105746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2105749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2105752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2105755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105781 */     // MIs[0] round
     /* 2105781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105784 */     // MIs[0] policy
     /* 2105784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105794 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2105797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105820 */     // GIR_Coverage, 16692,
     /* 2105820 */     GIR_EraseRootFromParent_Done,
     /* 2105821 */   // Label 27894: @2105821
     /* 2105821 */   GIM_Try, /*On fail goto*//*Label 27895*/ GIMT_Encode4(2105912), // Rule ID 16693 //
     /* 2105826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2105829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2105837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2105840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2105843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2105846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105872 */     // MIs[0] round
     /* 2105872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105875 */     // MIs[0] policy
     /* 2105875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105885 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2105888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105898 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105908 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105911 */     // GIR_Coverage, 16693,
     /* 2105911 */     GIR_EraseRootFromParent_Done,
     /* 2105912 */   // Label 27895: @2105912
     /* 2105912 */   GIM_Try, /*On fail goto*//*Label 27896*/ GIMT_Encode4(2106003), // Rule ID 16696 //
     /* 2105917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2105928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2105931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2105934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2105937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105963 */     // MIs[0] round
     /* 2105963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105966 */     // MIs[0] policy
     /* 2105966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105976 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2105979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106002 */     // GIR_Coverage, 16696,
     /* 2106002 */     GIR_EraseRootFromParent_Done,
     /* 2106003 */   // Label 27896: @2106003
     /* 2106003 */   GIM_Try, /*On fail goto*//*Label 27897*/ GIMT_Encode4(2106094), // Rule ID 16697 //
     /* 2106008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2106019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2106022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2106025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2106028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2106031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106054 */     // MIs[0] round
     /* 2106054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106057 */     // MIs[0] policy
     /* 2106057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106067 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2106070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106093 */     // GIR_Coverage, 16697,
     /* 2106093 */     GIR_EraseRootFromParent_Done,
     /* 2106094 */   // Label 27897: @2106094
     /* 2106094 */   GIM_Try, /*On fail goto*//*Label 27898*/ GIMT_Encode4(2106185), // Rule ID 16700 //
     /* 2106099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2106110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2106113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2106116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2106119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106145 */     // MIs[0] round
     /* 2106145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106148 */     // MIs[0] policy
     /* 2106148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106158 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2106161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106181 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106184 */     // GIR_Coverage, 16700,
     /* 2106184 */     GIR_EraseRootFromParent_Done,
     /* 2106185 */   // Label 27898: @2106185
     /* 2106185 */   GIM_Try, /*On fail goto*//*Label 27899*/ GIMT_Encode4(2106276), // Rule ID 16701 //
     /* 2106190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2106193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2106201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2106204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2106207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2106210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106236 */     // MIs[0] round
     /* 2106236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106239 */     // MIs[0] policy
     /* 2106239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106249 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2106252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106275 */     // GIR_Coverage, 16701,
     /* 2106275 */     GIR_EraseRootFromParent_Done,
     /* 2106276 */   // Label 27899: @2106276
     /* 2106276 */   GIM_Try, /*On fail goto*//*Label 27900*/ GIMT_Encode4(2106367), // Rule ID 16704 //
     /* 2106281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2106284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2106292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2106295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2106298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2106301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106327 */     // MIs[0] round
     /* 2106327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106330 */     // MIs[0] policy
     /* 2106330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106340 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2106343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106366 */     // GIR_Coverage, 16704,
     /* 2106366 */     GIR_EraseRootFromParent_Done,
     /* 2106367 */   // Label 27900: @2106367
     /* 2106367 */   GIM_Try, /*On fail goto*//*Label 27901*/ GIMT_Encode4(2106458), // Rule ID 16705 //
     /* 2106372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2106383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2106386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2106389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2106392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106395 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106418 */     // MIs[0] round
     /* 2106418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106421 */     // MIs[0] policy
     /* 2106421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106431 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2106434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106457 */     // GIR_Coverage, 16705,
     /* 2106457 */     GIR_EraseRootFromParent_Done,
     /* 2106458 */   // Label 27901: @2106458
     /* 2106458 */   GIM_Try, /*On fail goto*//*Label 27902*/ GIMT_Encode4(2106549), // Rule ID 16708 //
     /* 2106463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2106474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2106477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2106480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2106483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2106486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106509 */     // MIs[0] round
     /* 2106509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106512 */     // MIs[0] policy
     /* 2106512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106522 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2106525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106548 */     // GIR_Coverage, 16708,
     /* 2106548 */     GIR_EraseRootFromParent_Done,
     /* 2106549 */   // Label 27902: @2106549
     /* 2106549 */   GIM_Try, /*On fail goto*//*Label 27903*/ GIMT_Encode4(2106640), // Rule ID 16709 //
     /* 2106554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2106557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2106565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2106568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2106571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2106574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2106577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106600 */     // MIs[0] round
     /* 2106600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106603 */     // MIs[0] policy
     /* 2106603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106613 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2106616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106639 */     // GIR_Coverage, 16709,
     /* 2106639 */     GIR_EraseRootFromParent_Done,
     /* 2106640 */   // Label 27903: @2106640
     /* 2106640 */   GIM_Try, /*On fail goto*//*Label 27904*/ GIMT_Encode4(2106731), // Rule ID 16712 //
     /* 2106645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2106648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2106656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2106659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2106662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2106665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106691 */     // MIs[0] round
     /* 2106691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106694 */     // MIs[0] policy
     /* 2106694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106704 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2106707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106730 */     // GIR_Coverage, 16712,
     /* 2106730 */     GIR_EraseRootFromParent_Done,
     /* 2106731 */   // Label 27904: @2106731
     /* 2106731 */   GIM_Try, /*On fail goto*//*Label 27905*/ GIMT_Encode4(2106822), // Rule ID 16713 //
     /* 2106736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2106739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2106747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2106750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2106753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2106756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106782 */     // MIs[0] round
     /* 2106782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106785 */     // MIs[0] policy
     /* 2106785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106795 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2106798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106821 */     // GIR_Coverage, 16713,
     /* 2106821 */     GIR_EraseRootFromParent_Done,
     /* 2106822 */   // Label 27905: @2106822
     /* 2106822 */   GIM_Try, /*On fail goto*//*Label 27906*/ GIMT_Encode4(2106913), // Rule ID 16716 //
     /* 2106827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2106830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2106838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2106841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2106844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2106847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106873 */     // MIs[0] round
     /* 2106873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106876 */     // MIs[0] policy
     /* 2106876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106886 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2106889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106912 */     // GIR_Coverage, 16716,
     /* 2106912 */     GIR_EraseRootFromParent_Done,
     /* 2106913 */   // Label 27906: @2106913
     /* 2106913 */   GIM_Try, /*On fail goto*//*Label 27907*/ GIMT_Encode4(2107004), // Rule ID 16717 //
     /* 2106918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2106929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2106932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2106935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2106938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106964 */     // MIs[0] round
     /* 2106964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106967 */     // MIs[0] policy
     /* 2106967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106977 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2106980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106990 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107000 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107003 */     // GIR_Coverage, 16717,
     /* 2107003 */     GIR_EraseRootFromParent_Done,
     /* 2107004 */   // Label 27907: @2107004
     /* 2107004 */   GIM_Try, /*On fail goto*//*Label 27908*/ GIMT_Encode4(2107095), // Rule ID 16720 //
     /* 2107009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2107012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2107020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2107023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2107026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2107029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2107032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107055 */     // MIs[0] round
     /* 2107055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107058 */     // MIs[0] policy
     /* 2107058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107068 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2107071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107094 */     // GIR_Coverage, 16720,
     /* 2107094 */     GIR_EraseRootFromParent_Done,
     /* 2107095 */   // Label 27908: @2107095
     /* 2107095 */   GIM_Try, /*On fail goto*//*Label 27909*/ GIMT_Encode4(2107186), // Rule ID 16721 //
     /* 2107100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2107103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2107111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2107114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2107117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2107120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2107123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107146 */     // MIs[0] round
     /* 2107146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107149 */     // MIs[0] policy
     /* 2107149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107159 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2107162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107185 */     // GIR_Coverage, 16721,
     /* 2107185 */     GIR_EraseRootFromParent_Done,
     /* 2107186 */   // Label 27909: @2107186
     /* 2107186 */   GIM_Try, /*On fail goto*//*Label 27910*/ GIMT_Encode4(2107277), // Rule ID 16724 //
     /* 2107191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2107194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2107202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2107205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2107208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2107211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2107214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107237 */     // MIs[0] round
     /* 2107237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107240 */     // MIs[0] policy
     /* 2107240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107250 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2107253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107276 */     // GIR_Coverage, 16724,
     /* 2107276 */     GIR_EraseRootFromParent_Done,
     /* 2107277 */   // Label 27910: @2107277
     /* 2107277 */   GIM_Try, /*On fail goto*//*Label 27911*/ GIMT_Encode4(2107368), // Rule ID 16725 //
     /* 2107282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2107285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2107293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2107296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2107299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2107302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2107305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107328 */     // MIs[0] round
     /* 2107328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107331 */     // MIs[0] policy
     /* 2107331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107341 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2107344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107367 */     // GIR_Coverage, 16725,
     /* 2107367 */     GIR_EraseRootFromParent_Done,
     /* 2107368 */   // Label 27911: @2107368
     /* 2107368 */   GIM_Try, /*On fail goto*//*Label 27912*/ GIMT_Encode4(2107459), // Rule ID 16728 //
     /* 2107373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2107376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2107384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2107387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2107390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2107393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107419 */     // MIs[0] round
     /* 2107419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107422 */     // MIs[0] policy
     /* 2107422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107432 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2107435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107458 */     // GIR_Coverage, 16728,
     /* 2107458 */     GIR_EraseRootFromParent_Done,
     /* 2107459 */   // Label 27912: @2107459
     /* 2107459 */   GIM_Try, /*On fail goto*//*Label 27913*/ GIMT_Encode4(2107550), // Rule ID 16729 //
     /* 2107464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2107467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2107475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2107478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2107481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2107484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107510 */     // MIs[0] round
     /* 2107510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107513 */     // MIs[0] policy
     /* 2107513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107523 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2107526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107549 */     // GIR_Coverage, 16729,
     /* 2107549 */     GIR_EraseRootFromParent_Done,
     /* 2107550 */   // Label 27913: @2107550
     /* 2107550 */   GIM_Try, /*On fail goto*//*Label 27914*/ GIMT_Encode4(2107641), // Rule ID 16732 //
     /* 2107555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2107558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2107566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2107569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2107572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2107575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107601 */     // MIs[0] round
     /* 2107601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107604 */     // MIs[0] policy
     /* 2107604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107614 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2107617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107640 */     // GIR_Coverage, 16732,
     /* 2107640 */     GIR_EraseRootFromParent_Done,
     /* 2107641 */   // Label 27914: @2107641
     /* 2107641 */   GIM_Try, /*On fail goto*//*Label 27915*/ GIMT_Encode4(2107732), // Rule ID 16733 //
     /* 2107646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2107649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2107657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2107660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2107663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2107666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107692 */     // MIs[0] round
     /* 2107692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107695 */     // MIs[0] policy
     /* 2107695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107705 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2107708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107731 */     // GIR_Coverage, 16733,
     /* 2107731 */     GIR_EraseRootFromParent_Done,
     /* 2107732 */   // Label 27915: @2107732
     /* 2107732 */   GIM_Try, /*On fail goto*//*Label 27916*/ GIMT_Encode4(2107823), // Rule ID 16736 //
     /* 2107737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2107740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2107748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2107751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2107754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2107757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2107760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107783 */     // MIs[0] round
     /* 2107783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107786 */     // MIs[0] policy
     /* 2107786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107796 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2107799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107822 */     // GIR_Coverage, 16736,
     /* 2107822 */     GIR_EraseRootFromParent_Done,
     /* 2107823 */   // Label 27916: @2107823
     /* 2107823 */   GIM_Try, /*On fail goto*//*Label 27917*/ GIMT_Encode4(2107914), // Rule ID 16737 //
     /* 2107828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2107831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2107839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2107842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2107845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2107848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2107851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107874 */     // MIs[0] round
     /* 2107874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107877 */     // MIs[0] policy
     /* 2107877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107887 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2107890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107913 */     // GIR_Coverage, 16737,
     /* 2107913 */     GIR_EraseRootFromParent_Done,
     /* 2107914 */   // Label 27917: @2107914
     /* 2107914 */   GIM_Try, /*On fail goto*//*Label 27918*/ GIMT_Encode4(2108005), // Rule ID 16740 //
     /* 2107919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2107922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2107930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2107933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2107936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2107939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2107942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107965 */     // MIs[0] round
     /* 2107965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107968 */     // MIs[0] policy
     /* 2107968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107978 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2107981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108004 */     // GIR_Coverage, 16740,
     /* 2108004 */     GIR_EraseRootFromParent_Done,
     /* 2108005 */   // Label 27918: @2108005
     /* 2108005 */   GIM_Try, /*On fail goto*//*Label 27919*/ GIMT_Encode4(2108096), // Rule ID 16741 //
     /* 2108010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2108013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2108018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2108021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2108024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2108027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2108030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2108040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108056 */     // MIs[0] round
     /* 2108056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108059 */     // MIs[0] policy
     /* 2108059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108069 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2108072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108095 */     // GIR_Coverage, 16741,
     /* 2108095 */     GIR_EraseRootFromParent_Done,
     /* 2108096 */   // Label 27919: @2108096
     /* 2108096 */   GIM_Try, /*On fail goto*//*Label 27920*/ GIMT_Encode4(2108187), // Rule ID 16744 //
     /* 2108101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2108104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2108109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2108112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2108115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2108118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2108121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2108124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2108131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108147 */     // MIs[0] round
     /* 2108147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108150 */     // MIs[0] policy
     /* 2108150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108160 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2108163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108186 */     // GIR_Coverage, 16744,
     /* 2108186 */     GIR_EraseRootFromParent_Done,
     /* 2108187 */   // Label 27920: @2108187
     /* 2108187 */   GIM_Try, /*On fail goto*//*Label 27921*/ GIMT_Encode4(2108278), // Rule ID 16745 //
     /* 2108192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2108195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2108200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2108203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2108206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2108209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2108212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2108215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2108222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108238 */     // MIs[0] round
     /* 2108238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108241 */     // MIs[0] policy
     /* 2108241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108251 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2108254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108264 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108274 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108277 */     // GIR_Coverage, 16745,
     /* 2108277 */     GIR_EraseRootFromParent_Done,
     /* 2108278 */   // Label 27921: @2108278
     /* 2108278 */   GIM_Try, /*On fail goto*//*Label 27922*/ GIMT_Encode4(2108369), // Rule ID 16748 //
     /* 2108283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2108286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2108291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2108294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2108297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2108300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2108303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2108306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2108313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108329 */     // MIs[0] round
     /* 2108329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108332 */     // MIs[0] policy
     /* 2108332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108342 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2108345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108368 */     // GIR_Coverage, 16748,
     /* 2108368 */     GIR_EraseRootFromParent_Done,
     /* 2108369 */   // Label 27922: @2108369
     /* 2108369 */   GIM_Try, /*On fail goto*//*Label 27923*/ GIMT_Encode4(2108460), // Rule ID 16749 //
     /* 2108374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2108377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2108382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2108385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2108388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2108391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2108394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2108397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2108404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108420 */     // MIs[0] round
     /* 2108420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108423 */     // MIs[0] policy
     /* 2108423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108433 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2108436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108456 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108459 */     // GIR_Coverage, 16749,
     /* 2108459 */     GIR_EraseRootFromParent_Done,
     /* 2108460 */   // Label 27923: @2108460
     /* 2108460 */   GIM_Try, /*On fail goto*//*Label 27924*/ GIMT_Encode4(2108551), // Rule ID 16752 //
     /* 2108465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2108473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2108476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2108479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2108482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2108485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2108507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108511 */     // MIs[0] round
     /* 2108511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108514 */     // MIs[0] policy
     /* 2108514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108524 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2108527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108550 */     // GIR_Coverage, 16752,
     /* 2108550 */     GIR_EraseRootFromParent_Done,
     /* 2108551 */   // Label 27924: @2108551
     /* 2108551 */   GIM_Try, /*On fail goto*//*Label 27925*/ GIMT_Encode4(2108642), // Rule ID 16753 //
     /* 2108556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2108559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2108564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2108567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2108570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2108573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2108576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2108598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108602 */     // MIs[0] round
     /* 2108602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108605 */     // MIs[0] policy
     /* 2108605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108615 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2108618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108641 */     // GIR_Coverage, 16753,
     /* 2108641 */     GIR_EraseRootFromParent_Done,
     /* 2108642 */   // Label 27925: @2108642
     /* 2108642 */   GIM_Try, /*On fail goto*//*Label 27926*/ GIMT_Encode4(2108733), // Rule ID 16756 //
     /* 2108647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2108655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2108658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2108661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2108664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2108667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2108689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108693 */     // MIs[0] round
     /* 2108693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108696 */     // MIs[0] policy
     /* 2108696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108706 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2108709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108732 */     // GIR_Coverage, 16756,
     /* 2108732 */     GIR_EraseRootFromParent_Done,
     /* 2108733 */   // Label 27926: @2108733
     /* 2108733 */   GIM_Try, /*On fail goto*//*Label 27927*/ GIMT_Encode4(2108824), // Rule ID 16757 //
     /* 2108738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2108741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2108746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2108749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2108752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2108755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2108758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2108780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108784 */     // MIs[0] round
     /* 2108784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108787 */     // MIs[0] policy
     /* 2108787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108797 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2108800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108823 */     // GIR_Coverage, 16757,
     /* 2108823 */     GIR_EraseRootFromParent_Done,
     /* 2108824 */   // Label 27927: @2108824
     /* 2108824 */   GIM_Try, /*On fail goto*//*Label 27928*/ GIMT_Encode4(2108915), // Rule ID 16760 //
     /* 2108829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2108832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2108837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2108840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2108843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2108846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2108849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2108871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108875 */     // MIs[0] round
     /* 2108875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108878 */     // MIs[0] policy
     /* 2108878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108888 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2108891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108914 */     // GIR_Coverage, 16760,
     /* 2108914 */     GIR_EraseRootFromParent_Done,
     /* 2108915 */   // Label 27928: @2108915
     /* 2108915 */   GIM_Try, /*On fail goto*//*Label 27929*/ GIMT_Encode4(2109006), // Rule ID 16761 //
     /* 2108920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2108923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2108928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2108931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2108934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2108937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2108940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2108962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108966 */     // MIs[0] round
     /* 2108966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108969 */     // MIs[0] policy
     /* 2108969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108979 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2108982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109005 */     // GIR_Coverage, 16761,
     /* 2109005 */     GIR_EraseRootFromParent_Done,
     /* 2109006 */   // Label 27929: @2109006
     /* 2109006 */   GIM_Try, /*On fail goto*//*Label 27930*/ GIMT_Encode4(2109097), // Rule ID 16764 //
     /* 2109011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2109014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2109019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2109022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2109025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2109028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2109041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109057 */     // MIs[0] round
     /* 2109057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109060 */     // MIs[0] policy
     /* 2109060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109070 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2109073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109096 */     // GIR_Coverage, 16764,
     /* 2109096 */     GIR_EraseRootFromParent_Done,
     /* 2109097 */   // Label 27930: @2109097
     /* 2109097 */   GIM_Try, /*On fail goto*//*Label 27931*/ GIMT_Encode4(2109188), // Rule ID 16765 //
     /* 2109102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2109105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2109110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2109113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2109116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2109119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2109132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109148 */     // MIs[0] round
     /* 2109148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109151 */     // MIs[0] policy
     /* 2109151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109161 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2109164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109174 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109184 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109187 */     // GIR_Coverage, 16765,
     /* 2109187 */     GIR_EraseRootFromParent_Done,
     /* 2109188 */   // Label 27931: @2109188
     /* 2109188 */   GIM_Try, /*On fail goto*//*Label 27932*/ GIMT_Encode4(2109279), // Rule ID 16768 //
     /* 2109193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2109196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2109201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2109204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2109207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2109210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2109213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2109216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2109223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2109235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109239 */     // MIs[0] round
     /* 2109239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109242 */     // MIs[0] policy
     /* 2109242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2109255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109278 */     // GIR_Coverage, 16768,
     /* 2109278 */     GIR_EraseRootFromParent_Done,
     /* 2109279 */   // Label 27932: @2109279
     /* 2109279 */   GIM_Try, /*On fail goto*//*Label 27933*/ GIMT_Encode4(2109370), // Rule ID 16769 //
     /* 2109284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2109287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2109292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2109295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2109298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2109301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2109304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2109307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2109314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2109326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109330 */     // MIs[0] round
     /* 2109330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109333 */     // MIs[0] policy
     /* 2109333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109343 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2109346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109369 */     // GIR_Coverage, 16769,
     /* 2109369 */     GIR_EraseRootFromParent_Done,
     /* 2109370 */   // Label 27933: @2109370
     /* 2109370 */   GIM_Try, /*On fail goto*//*Label 27934*/ GIMT_Encode4(2109461), // Rule ID 16772 //
     /* 2109375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2109378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2109383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2109386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2109389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2109392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2109395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2109398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2109405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2109417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109421 */     // MIs[0] round
     /* 2109421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109424 */     // MIs[0] policy
     /* 2109424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109434 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2109437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109460 */     // GIR_Coverage, 16772,
     /* 2109460 */     GIR_EraseRootFromParent_Done,
     /* 2109461 */   // Label 27934: @2109461
     /* 2109461 */   GIM_Try, /*On fail goto*//*Label 27935*/ GIMT_Encode4(2109552), // Rule ID 16773 //
     /* 2109466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2109469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2109474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2109477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2109480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2109483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2109486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2109489 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2109496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2109508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109512 */     // MIs[0] round
     /* 2109512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109515 */     // MIs[0] policy
     /* 2109515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109525 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2109528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109551 */     // GIR_Coverage, 16773,
     /* 2109551 */     GIR_EraseRootFromParent_Done,
     /* 2109552 */   // Label 27935: @2109552
     /* 2109552 */   GIM_Try, /*On fail goto*//*Label 27936*/ GIMT_Encode4(2109643), // Rule ID 16776 //
     /* 2109557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2109560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2109565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2109568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2109571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2109574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109603 */     // MIs[0] round
     /* 2109603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109606 */     // MIs[0] policy
     /* 2109606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109616 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2109619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109642 */     // GIR_Coverage, 16776,
     /* 2109642 */     GIR_EraseRootFromParent_Done,
     /* 2109643 */   // Label 27936: @2109643
     /* 2109643 */   GIM_Try, /*On fail goto*//*Label 27937*/ GIMT_Encode4(2109734), // Rule ID 16777 //
     /* 2109648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2109651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2109656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2109659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2109662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2109665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109694 */     // MIs[0] round
     /* 2109694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109697 */     // MIs[0] policy
     /* 2109697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109707 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2109710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109733 */     // GIR_Coverage, 16777,
     /* 2109733 */     GIR_EraseRootFromParent_Done,
     /* 2109734 */   // Label 27937: @2109734
     /* 2109734 */   GIM_Try, /*On fail goto*//*Label 27938*/ GIMT_Encode4(2109825), // Rule ID 16780 //
     /* 2109739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2109742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2109747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2109750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2109753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2109756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109785 */     // MIs[0] round
     /* 2109785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109788 */     // MIs[0] policy
     /* 2109788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109798 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2109801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109824 */     // GIR_Coverage, 16780,
     /* 2109824 */     GIR_EraseRootFromParent_Done,
     /* 2109825 */   // Label 27938: @2109825
     /* 2109825 */   GIM_Try, /*On fail goto*//*Label 27939*/ GIMT_Encode4(2109916), // Rule ID 16781 //
     /* 2109830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2109833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2109838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2109841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2109844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2109847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109876 */     // MIs[0] round
     /* 2109876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109879 */     // MIs[0] policy
     /* 2109879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109889 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2109892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109915 */     // GIR_Coverage, 16781,
     /* 2109915 */     GIR_EraseRootFromParent_Done,
     /* 2109916 */   // Label 27939: @2109916
     /* 2109916 */   GIM_Try, /*On fail goto*//*Label 27940*/ GIMT_Encode4(2110007), // Rule ID 16784 //
     /* 2109921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2109924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2109929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2109932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2109935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2109938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2109944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109967 */     // MIs[0] round
     /* 2109967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109970 */     // MIs[0] policy
     /* 2109970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109980 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2109983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110006 */     // GIR_Coverage, 16784,
     /* 2110006 */     GIR_EraseRootFromParent_Done,
     /* 2110007 */   // Label 27940: @2110007
     /* 2110007 */   GIM_Try, /*On fail goto*//*Label 27941*/ GIMT_Encode4(2110098), // Rule ID 16785 //
     /* 2110012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2110015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2110020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2110023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2110026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2110029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2110035 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110058 */     // MIs[0] round
     /* 2110058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110061 */     // MIs[0] policy
     /* 2110061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110071 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2110074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110097 */     // GIR_Coverage, 16785,
     /* 2110097 */     GIR_EraseRootFromParent_Done,
     /* 2110098 */   // Label 27941: @2110098
     /* 2110098 */   GIM_Try, /*On fail goto*//*Label 27942*/ GIMT_Encode4(2110189), // Rule ID 16788 //
     /* 2110103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2110106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2110111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2110114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2110117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2110120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2110133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110149 */     // MIs[0] round
     /* 2110149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110152 */     // MIs[0] policy
     /* 2110152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110162 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2110165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110188 */     // GIR_Coverage, 16788,
     /* 2110188 */     GIR_EraseRootFromParent_Done,
     /* 2110189 */   // Label 27942: @2110189
     /* 2110189 */   GIM_Try, /*On fail goto*//*Label 27943*/ GIMT_Encode4(2110280), // Rule ID 16789 //
     /* 2110194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2110197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2110202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2110205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2110208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2110211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110217 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2110224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110240 */     // MIs[0] round
     /* 2110240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110243 */     // MIs[0] policy
     /* 2110243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110253 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2110256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110276 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110279 */     // GIR_Coverage, 16789,
     /* 2110279 */     GIR_EraseRootFromParent_Done,
     /* 2110280 */   // Label 27943: @2110280
     /* 2110280 */   GIM_Try, /*On fail goto*//*Label 27944*/ GIMT_Encode4(2110371), // Rule ID 16792 //
     /* 2110285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2110288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2110293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2110296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2110299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2110302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2110315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110331 */     // MIs[0] round
     /* 2110331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110334 */     // MIs[0] policy
     /* 2110334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110344 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2110347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110370 */     // GIR_Coverage, 16792,
     /* 2110370 */     GIR_EraseRootFromParent_Done,
     /* 2110371 */   // Label 27944: @2110371
     /* 2110371 */   GIM_Try, /*On fail goto*//*Label 27945*/ GIMT_Encode4(2110462), // Rule ID 16793 //
     /* 2110376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2110379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2110384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2110387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2110390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2110393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2110406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110422 */     // MIs[0] round
     /* 2110422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110425 */     // MIs[0] policy
     /* 2110425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110435 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2110438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110461 */     // GIR_Coverage, 16793,
     /* 2110461 */     GIR_EraseRootFromParent_Done,
     /* 2110462 */   // Label 27945: @2110462
     /* 2110462 */   GIM_Try, /*On fail goto*//*Label 27946*/ GIMT_Encode4(2110553), // Rule ID 16796 //
     /* 2110467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2110470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2110475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2110478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2110481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2110484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2110490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110513 */     // MIs[0] round
     /* 2110513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110516 */     // MIs[0] policy
     /* 2110516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110526 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2110529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110552 */     // GIR_Coverage, 16796,
     /* 2110552 */     GIR_EraseRootFromParent_Done,
     /* 2110553 */   // Label 27946: @2110553
     /* 2110553 */   GIM_Try, /*On fail goto*//*Label 27947*/ GIMT_Encode4(2110644), // Rule ID 16797 //
     /* 2110558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2110561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2110566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2110569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2110572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2110575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2110581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110604 */     // MIs[0] round
     /* 2110604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110607 */     // MIs[0] policy
     /* 2110607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110617 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2110620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110643 */     // GIR_Coverage, 16797,
     /* 2110643 */     GIR_EraseRootFromParent_Done,
     /* 2110644 */   // Label 27947: @2110644
     /* 2110644 */   GIM_Try, /*On fail goto*//*Label 27948*/ GIMT_Encode4(2110735), // Rule ID 16800 //
     /* 2110649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2110652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2110657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2110660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2110663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2110666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2110669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2110679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2110691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110695 */     // MIs[0] round
     /* 2110695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110698 */     // MIs[0] policy
     /* 2110698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110708 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2110711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110734 */     // GIR_Coverage, 16800,
     /* 2110734 */     GIR_EraseRootFromParent_Done,
     /* 2110735 */   // Label 27948: @2110735
     /* 2110735 */   GIM_Try, /*On fail goto*//*Label 27949*/ GIMT_Encode4(2110826), // Rule ID 16801 //
     /* 2110740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2110743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2110748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2110751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2110754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2110757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2110760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2110770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2110782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110786 */     // MIs[0] round
     /* 2110786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110789 */     // MIs[0] policy
     /* 2110789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110799 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2110802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110825 */     // GIR_Coverage, 16801,
     /* 2110825 */     GIR_EraseRootFromParent_Done,
     /* 2110826 */   // Label 27949: @2110826
     /* 2110826 */   GIM_Try, /*On fail goto*//*Label 27950*/ GIMT_Encode4(2110917), // Rule ID 16804 //
     /* 2110831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2110834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2110839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2110842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2110845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2110848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2110851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2110861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2110873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110877 */     // MIs[0] round
     /* 2110877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110880 */     // MIs[0] policy
     /* 2110880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110890 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2110893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110916 */     // GIR_Coverage, 16804,
     /* 2110916 */     GIR_EraseRootFromParent_Done,
     /* 2110917 */   // Label 27950: @2110917
     /* 2110917 */   GIM_Try, /*On fail goto*//*Label 27951*/ GIMT_Encode4(2111008), // Rule ID 16805 //
     /* 2110922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2110925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2110930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2110933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2110936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2110939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2110942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2110952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2110964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110968 */     // MIs[0] round
     /* 2110968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110971 */     // MIs[0] policy
     /* 2110971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110981 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2110984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2111004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111007 */     // GIR_Coverage, 16805,
     /* 2111007 */     GIR_EraseRootFromParent_Done,
     /* 2111008 */   // Label 27951: @2111008
     /* 2111008 */   GIM_Try, /*On fail goto*//*Label 27952*/ GIMT_Encode4(2111099), // Rule ID 16808 //
     /* 2111013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2111016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2111021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2111024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2111027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2111030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2111033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2111043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2111055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111059 */     // MIs[0] round
     /* 2111059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111062 */     // MIs[0] policy
     /* 2111062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111072 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2111075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2111095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111098 */     // GIR_Coverage, 16808,
     /* 2111098 */     GIR_EraseRootFromParent_Done,
     /* 2111099 */   // Label 27952: @2111099
     /* 2111099 */   GIM_Try, /*On fail goto*//*Label 27953*/ GIMT_Encode4(2111190), // Rule ID 16809 //
     /* 2111104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2111107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2111112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2111115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2111118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2111121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2111124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2111134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2111146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111150 */     // MIs[0] round
     /* 2111150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111153 */     // MIs[0] policy
     /* 2111153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111163 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2111166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2111186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111189 */     // GIR_Coverage, 16809,
     /* 2111189 */     GIR_EraseRootFromParent_Done,
     /* 2111190 */   // Label 27953: @2111190
     /* 2111190 */   GIM_Try, /*On fail goto*//*Label 27954*/ GIMT_Encode4(2111281), // Rule ID 16812 //
     /* 2111195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2111206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2111209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2111212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2111215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111241 */     // MIs[0] round
     /* 2111241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111244 */     // MIs[0] policy
     /* 2111244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111254 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2111257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111280 */     // GIR_Coverage, 16812,
     /* 2111280 */     GIR_EraseRootFromParent_Done,
     /* 2111281 */   // Label 27954: @2111281
     /* 2111281 */   GIM_Try, /*On fail goto*//*Label 27955*/ GIMT_Encode4(2111372), // Rule ID 16813 //
     /* 2111286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2111297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2111300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2111303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2111306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111332 */     // MIs[0] round
     /* 2111332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111335 */     // MIs[0] policy
     /* 2111335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111345 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2111348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111371 */     // GIR_Coverage, 16813,
     /* 2111371 */     GIR_EraseRootFromParent_Done,
     /* 2111372 */   // Label 27955: @2111372
     /* 2111372 */   GIM_Try, /*On fail goto*//*Label 27956*/ GIMT_Encode4(2111463), // Rule ID 16816 //
     /* 2111377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2111388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2111391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2111394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2111397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2111400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111423 */     // MIs[0] round
     /* 2111423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111426 */     // MIs[0] policy
     /* 2111426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111436 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2111439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111462 */     // GIR_Coverage, 16816,
     /* 2111462 */     GIR_EraseRootFromParent_Done,
     /* 2111463 */   // Label 27956: @2111463
     /* 2111463 */   GIM_Try, /*On fail goto*//*Label 27957*/ GIMT_Encode4(2111554), // Rule ID 16817 //
     /* 2111468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2111479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2111482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2111485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2111488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2111491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111514 */     // MIs[0] round
     /* 2111514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111517 */     // MIs[0] policy
     /* 2111517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111527 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2111530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111553 */     // GIR_Coverage, 16817,
     /* 2111553 */     GIR_EraseRootFromParent_Done,
     /* 2111554 */   // Label 27957: @2111554
     /* 2111554 */   GIM_Try, /*On fail goto*//*Label 27958*/ GIMT_Encode4(2111645), // Rule ID 16820 //
     /* 2111559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2111562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2111570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2111573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2111576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2111579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111605 */     // MIs[0] round
     /* 2111605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111608 */     // MIs[0] policy
     /* 2111608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111618 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2111621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111644 */     // GIR_Coverage, 16820,
     /* 2111644 */     GIR_EraseRootFromParent_Done,
     /* 2111645 */   // Label 27958: @2111645
     /* 2111645 */   GIM_Try, /*On fail goto*//*Label 27959*/ GIMT_Encode4(2111736), // Rule ID 16821 //
     /* 2111650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2111653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2111661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2111664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2111667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2111670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111696 */     // MIs[0] round
     /* 2111696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111699 */     // MIs[0] policy
     /* 2111699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111709 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2111712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111735 */     // GIR_Coverage, 16821,
     /* 2111735 */     GIR_EraseRootFromParent_Done,
     /* 2111736 */   // Label 27959: @2111736
     /* 2111736 */   GIM_Try, /*On fail goto*//*Label 27960*/ GIMT_Encode4(2111827), // Rule ID 16824 //
     /* 2111741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2111752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2111755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2111758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2111761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111787 */     // MIs[0] round
     /* 2111787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111790 */     // MIs[0] policy
     /* 2111790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111800 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2111803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111826 */     // GIR_Coverage, 16824,
     /* 2111826 */     GIR_EraseRootFromParent_Done,
     /* 2111827 */   // Label 27960: @2111827
     /* 2111827 */   GIM_Try, /*On fail goto*//*Label 27961*/ GIMT_Encode4(2111918), // Rule ID 16825 //
     /* 2111832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2111843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2111846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2111849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2111852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111878 */     // MIs[0] round
     /* 2111878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111881 */     // MIs[0] policy
     /* 2111881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111891 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2111894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111917 */     // GIR_Coverage, 16825,
     /* 2111917 */     GIR_EraseRootFromParent_Done,
     /* 2111918 */   // Label 27961: @2111918
     /* 2111918 */   GIM_Try, /*On fail goto*//*Label 27962*/ GIMT_Encode4(2112009), // Rule ID 16828 //
     /* 2111923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2111926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2111934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2111937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2111940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2111943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2111946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111969 */     // MIs[0] round
     /* 2111969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111972 */     // MIs[0] policy
     /* 2111972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111982 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2111985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112008 */     // GIR_Coverage, 16828,
     /* 2112008 */     GIR_EraseRootFromParent_Done,
     /* 2112009 */   // Label 27962: @2112009
     /* 2112009 */   GIM_Try, /*On fail goto*//*Label 27963*/ GIMT_Encode4(2112100), // Rule ID 16829 //
     /* 2112014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2112017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2112025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2112028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2112031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2112034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2112037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112060 */     // MIs[0] round
     /* 2112060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112063 */     // MIs[0] policy
     /* 2112063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112073 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2112076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112099 */     // GIR_Coverage, 16829,
     /* 2112099 */     GIR_EraseRootFromParent_Done,
     /* 2112100 */   // Label 27963: @2112100
     /* 2112100 */   GIM_Try, /*On fail goto*//*Label 27964*/ GIMT_Encode4(2112191), // Rule ID 16832 //
     /* 2112105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2112108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2112116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2112119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2112122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2112125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2112128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112151 */     // MIs[0] round
     /* 2112151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112154 */     // MIs[0] policy
     /* 2112154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112164 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2112167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112190 */     // GIR_Coverage, 16832,
     /* 2112190 */     GIR_EraseRootFromParent_Done,
     /* 2112191 */   // Label 27964: @2112191
     /* 2112191 */   GIM_Try, /*On fail goto*//*Label 27965*/ GIMT_Encode4(2112282), // Rule ID 16833 //
     /* 2112196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2112199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2112207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2112210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2112213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2112216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2112219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112242 */     // MIs[0] round
     /* 2112242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112245 */     // MIs[0] policy
     /* 2112245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112255 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2112258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112281 */     // GIR_Coverage, 16833,
     /* 2112281 */     GIR_EraseRootFromParent_Done,
     /* 2112282 */   // Label 27965: @2112282
     /* 2112282 */   GIM_Try, /*On fail goto*//*Label 27966*/ GIMT_Encode4(2112373), // Rule ID 16836 //
     /* 2112287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2112290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2112298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2112301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2112304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2112307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112333 */     // MIs[0] round
     /* 2112333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112336 */     // MIs[0] policy
     /* 2112336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112346 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2112349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112372 */     // GIR_Coverage, 16836,
     /* 2112372 */     GIR_EraseRootFromParent_Done,
     /* 2112373 */   // Label 27966: @2112373
     /* 2112373 */   GIM_Try, /*On fail goto*//*Label 27967*/ GIMT_Encode4(2112464), // Rule ID 16837 //
     /* 2112378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2112381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2112389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2112392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2112395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2112398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112424 */     // MIs[0] round
     /* 2112424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112427 */     // MIs[0] policy
     /* 2112427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112437 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2112440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112463 */     // GIR_Coverage, 16837,
     /* 2112463 */     GIR_EraseRootFromParent_Done,
     /* 2112464 */   // Label 27967: @2112464
     /* 2112464 */   GIM_Try, /*On fail goto*//*Label 27968*/ GIMT_Encode4(2112555), // Rule ID 16840 //
     /* 2112469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2112472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2112480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2112483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2112486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2112489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2112492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112515 */     // MIs[0] round
     /* 2112515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112518 */     // MIs[0] policy
     /* 2112518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112528 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2112531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112554 */     // GIR_Coverage, 16840,
     /* 2112554 */     GIR_EraseRootFromParent_Done,
     /* 2112555 */   // Label 27968: @2112555
     /* 2112555 */   GIM_Try, /*On fail goto*//*Label 27969*/ GIMT_Encode4(2112646), // Rule ID 16841 //
     /* 2112560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2112563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2112571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2112574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2112577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2112580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2112583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112606 */     // MIs[0] round
     /* 2112606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112609 */     // MIs[0] policy
     /* 2112609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112619 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2112622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112645 */     // GIR_Coverage, 16841,
     /* 2112645 */     GIR_EraseRootFromParent_Done,
     /* 2112646 */   // Label 27969: @2112646
     /* 2112646 */   GIM_Try, /*On fail goto*//*Label 27970*/ GIMT_Encode4(2112737), // Rule ID 16844 //
     /* 2112651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2112654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2112662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2112665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2112668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2112671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2112674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112697 */     // MIs[0] round
     /* 2112697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112700 */     // MIs[0] policy
     /* 2112700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112710 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2112713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112736 */     // GIR_Coverage, 16844,
     /* 2112736 */     GIR_EraseRootFromParent_Done,
     /* 2112737 */   // Label 27970: @2112737
     /* 2112737 */   GIM_Try, /*On fail goto*//*Label 27971*/ GIMT_Encode4(2112828), // Rule ID 16845 //
     /* 2112742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2112745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2112753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2112756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2112759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2112762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2112765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112788 */     // MIs[0] round
     /* 2112788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112791 */     // MIs[0] policy
     /* 2112791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112801 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2112804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112814 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112824 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112827 */     // GIR_Coverage, 16845,
     /* 2112827 */     GIR_EraseRootFromParent_Done,
     /* 2112828 */   // Label 27971: @2112828
     /* 2112828 */   GIM_Try, /*On fail goto*//*Label 27972*/ GIMT_Encode4(2112919), // Rule ID 16848 //
     /* 2112833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2112836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2112844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2112847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2112850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2112853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112879 */     // MIs[0] round
     /* 2112879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112882 */     // MIs[0] policy
     /* 2112882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112892 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2112895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112918 */     // GIR_Coverage, 16848,
     /* 2112918 */     GIR_EraseRootFromParent_Done,
     /* 2112919 */   // Label 27972: @2112919
     /* 2112919 */   GIM_Try, /*On fail goto*//*Label 27973*/ GIMT_Encode4(2113010), // Rule ID 16849 //
     /* 2112924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2112927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2112935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2112938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2112941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2112944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112970 */     // MIs[0] round
     /* 2112970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112973 */     // MIs[0] policy
     /* 2112973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112983 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2112986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112996 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113006 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113009 */     // GIR_Coverage, 16849,
     /* 2113009 */     GIR_EraseRootFromParent_Done,
     /* 2113010 */   // Label 27973: @2113010
     /* 2113010 */   GIM_Try, /*On fail goto*//*Label 27974*/ GIMT_Encode4(2113101), // Rule ID 16852 //
     /* 2113015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2113018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2113026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2113029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2113032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2113035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2113045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113061 */     // MIs[0] round
     /* 2113061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113064 */     // MIs[0] policy
     /* 2113064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113074 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2113077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113100 */     // GIR_Coverage, 16852,
     /* 2113100 */     GIR_EraseRootFromParent_Done,
     /* 2113101 */   // Label 27974: @2113101
     /* 2113101 */   GIM_Try, /*On fail goto*//*Label 27975*/ GIMT_Encode4(2113192), // Rule ID 16853 //
     /* 2113106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2113109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2113117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2113120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2113123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2113126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2113136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113152 */     // MIs[0] round
     /* 2113152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113155 */     // MIs[0] policy
     /* 2113155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113165 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2113168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113191 */     // GIR_Coverage, 16853,
     /* 2113191 */     GIR_EraseRootFromParent_Done,
     /* 2113192 */   // Label 27975: @2113192
     /* 2113192 */   GIM_Try, /*On fail goto*//*Label 27976*/ GIMT_Encode4(2113283), // Rule ID 16856 //
     /* 2113197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2113200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2113208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2113211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2113214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2113217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2113220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113243 */     // MIs[0] round
     /* 2113243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113246 */     // MIs[0] policy
     /* 2113246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113256 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2113259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113282 */     // GIR_Coverage, 16856,
     /* 2113282 */     GIR_EraseRootFromParent_Done,
     /* 2113283 */   // Label 27976: @2113283
     /* 2113283 */   GIM_Try, /*On fail goto*//*Label 27977*/ GIMT_Encode4(2113374), // Rule ID 16857 //
     /* 2113288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2113291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2113299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2113302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2113305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2113308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2113311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113334 */     // MIs[0] round
     /* 2113334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113337 */     // MIs[0] policy
     /* 2113337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113347 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2113350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113373 */     // GIR_Coverage, 16857,
     /* 2113373 */     GIR_EraseRootFromParent_Done,
     /* 2113374 */   // Label 27977: @2113374
     /* 2113374 */   GIM_Try, /*On fail goto*//*Label 27978*/ GIMT_Encode4(2113465), // Rule ID 16860 //
     /* 2113379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2113382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2113390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2113393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2113396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2113399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2113409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113425 */     // MIs[0] round
     /* 2113425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113428 */     // MIs[0] policy
     /* 2113428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113438 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2113441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113464 */     // GIR_Coverage, 16860,
     /* 2113464 */     GIR_EraseRootFromParent_Done,
     /* 2113465 */   // Label 27978: @2113465
     /* 2113465 */   GIM_Try, /*On fail goto*//*Label 27979*/ GIMT_Encode4(2113556), // Rule ID 16861 //
     /* 2113470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2113473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2113481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2113484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2113487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2113490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2113500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113516 */     // MIs[0] round
     /* 2113516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113519 */     // MIs[0] policy
     /* 2113519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113529 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2113532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113555 */     // GIR_Coverage, 16861,
     /* 2113555 */     GIR_EraseRootFromParent_Done,
     /* 2113556 */   // Label 27979: @2113556
     /* 2113556 */   GIM_Try, /*On fail goto*//*Label 27980*/ GIMT_Encode4(2113647), // Rule ID 16864 //
     /* 2113561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2113564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2113572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2113575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2113578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2113581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2113591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113607 */     // MIs[0] round
     /* 2113607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113610 */     // MIs[0] policy
     /* 2113610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113620 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2113623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113646 */     // GIR_Coverage, 16864,
     /* 2113646 */     GIR_EraseRootFromParent_Done,
     /* 2113647 */   // Label 27980: @2113647
     /* 2113647 */   GIM_Try, /*On fail goto*//*Label 27981*/ GIMT_Encode4(2113738), // Rule ID 16865 //
     /* 2113652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2113655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2113663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2113666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2113669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2113672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2113682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113698 */     // MIs[0] round
     /* 2113698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113701 */     // MIs[0] policy
     /* 2113701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113711 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2113714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113737 */     // GIR_Coverage, 16865,
     /* 2113737 */     GIR_EraseRootFromParent_Done,
     /* 2113738 */   // Label 27981: @2113738
     /* 2113738 */   GIM_Try, /*On fail goto*//*Label 27982*/ GIMT_Encode4(2113829), // Rule ID 16868 //
     /* 2113743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2113746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2113754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2113757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2113760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2113763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113789 */     // MIs[0] round
     /* 2113789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113792 */     // MIs[0] policy
     /* 2113792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113802 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2113805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113828 */     // GIR_Coverage, 16868,
     /* 2113828 */     GIR_EraseRootFromParent_Done,
     /* 2113829 */   // Label 27982: @2113829
     /* 2113829 */   GIM_Try, /*On fail goto*//*Label 27983*/ GIMT_Encode4(2113920), // Rule ID 16869 //
     /* 2113834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2113837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2113845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2113848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2113851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2113854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113857 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113880 */     // MIs[0] round
     /* 2113880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113883 */     // MIs[0] policy
     /* 2113883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113893 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2113896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113919 */     // GIR_Coverage, 16869,
     /* 2113919 */     GIR_EraseRootFromParent_Done,
     /* 2113920 */   // Label 27983: @2113920
     /* 2113920 */   GIM_Try, /*On fail goto*//*Label 27984*/ GIMT_Encode4(2114011), // Rule ID 16872 //
     /* 2113925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2113928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2113936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2113939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2113942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113971 */     // MIs[0] round
     /* 2113971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113974 */     // MIs[0] policy
     /* 2113974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113984 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2113987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114010 */     // GIR_Coverage, 16872,
     /* 2114010 */     GIR_EraseRootFromParent_Done,
     /* 2114011 */   // Label 27984: @2114011
     /* 2114011 */   GIM_Try, /*On fail goto*//*Label 27985*/ GIMT_Encode4(2114102), // Rule ID 16873 //
     /* 2114016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2114024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2114027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2114030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2114033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114062 */     // MIs[0] round
     /* 2114062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114065 */     // MIs[0] policy
     /* 2114065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114075 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2114078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114101 */     // GIR_Coverage, 16873,
     /* 2114101 */     GIR_EraseRootFromParent_Done,
     /* 2114102 */   // Label 27985: @2114102
     /* 2114102 */   GIM_Try, /*On fail goto*//*Label 27986*/ GIMT_Encode4(2114193), // Rule ID 16876 //
     /* 2114107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2114110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2114115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2114118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2114121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2114124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2114130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114153 */     // MIs[0] round
     /* 2114153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114156 */     // MIs[0] policy
     /* 2114156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114166 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2114169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114192 */     // GIR_Coverage, 16876,
     /* 2114192 */     GIR_EraseRootFromParent_Done,
     /* 2114193 */   // Label 27986: @2114193
     /* 2114193 */   GIM_Try, /*On fail goto*//*Label 27987*/ GIMT_Encode4(2114284), // Rule ID 16877 //
     /* 2114198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2114206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2114209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2114212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2114215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2114221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114244 */     // MIs[0] round
     /* 2114244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114247 */     // MIs[0] policy
     /* 2114247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114257 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2114260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114283 */     // GIR_Coverage, 16877,
     /* 2114283 */     GIR_EraseRootFromParent_Done,
     /* 2114284 */   // Label 27987: @2114284
     /* 2114284 */   GIM_Try, /*On fail goto*//*Label 27988*/ GIMT_Encode4(2114375), // Rule ID 16880 //
     /* 2114289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2114292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2114297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2114300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2114303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2114306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114335 */     // MIs[0] round
     /* 2114335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114338 */     // MIs[0] policy
     /* 2114338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114348 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2114351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114374 */     // GIR_Coverage, 16880,
     /* 2114374 */     GIR_EraseRootFromParent_Done,
     /* 2114375 */   // Label 27988: @2114375
     /* 2114375 */   GIM_Try, /*On fail goto*//*Label 27989*/ GIMT_Encode4(2114466), // Rule ID 16881 //
     /* 2114380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2114383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2114388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2114391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2114394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2114397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114426 */     // MIs[0] round
     /* 2114426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114429 */     // MIs[0] policy
     /* 2114429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114439 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2114442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114452 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114462 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114465 */     // GIR_Coverage, 16881,
     /* 2114465 */     GIR_EraseRootFromParent_Done,
     /* 2114466 */   // Label 27989: @2114466
     /* 2114466 */   GIM_Try, /*On fail goto*//*Label 27990*/ GIMT_Encode4(2114557), // Rule ID 16884 //
     /* 2114471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2114474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2114479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2114482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2114485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2114488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2114494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114517 */     // MIs[0] round
     /* 2114517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114520 */     // MIs[0] policy
     /* 2114520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114530 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2114533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114556 */     // GIR_Coverage, 16884,
     /* 2114556 */     GIR_EraseRootFromParent_Done,
     /* 2114557 */   // Label 27990: @2114557
     /* 2114557 */   GIM_Try, /*On fail goto*//*Label 27991*/ GIMT_Encode4(2114648), // Rule ID 16885 //
     /* 2114562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2114570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2114573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2114576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2114579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2114585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114608 */     // MIs[0] round
     /* 2114608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114611 */     // MIs[0] policy
     /* 2114611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114621 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2114624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114647 */     // GIR_Coverage, 16885,
     /* 2114647 */     GIR_EraseRootFromParent_Done,
     /* 2114648 */   // Label 27991: @2114648
     /* 2114648 */   GIM_Try, /*On fail goto*//*Label 27992*/ GIMT_Encode4(2114739), // Rule ID 16888 //
     /* 2114653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2114656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2114661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2114664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2114667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2114670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2114676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114699 */     // MIs[0] round
     /* 2114699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114702 */     // MIs[0] policy
     /* 2114702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114712 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2114715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114738 */     // GIR_Coverage, 16888,
     /* 2114738 */     GIR_EraseRootFromParent_Done,
     /* 2114739 */   // Label 27992: @2114739
     /* 2114739 */   GIM_Try, /*On fail goto*//*Label 27993*/ GIMT_Encode4(2114830), // Rule ID 16889 //
     /* 2114744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2114747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2114752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2114755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2114758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2114761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2114767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114790 */     // MIs[0] round
     /* 2114790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114793 */     // MIs[0] policy
     /* 2114793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114803 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2114806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114829 */     // GIR_Coverage, 16889,
     /* 2114829 */     GIR_EraseRootFromParent_Done,
     /* 2114830 */   // Label 27993: @2114830
     /* 2114830 */   GIM_Try, /*On fail goto*//*Label 27994*/ GIMT_Encode4(2114921), // Rule ID 16892 //
     /* 2114835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2114838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2114843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2114846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2114849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2114852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2114855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2114877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114881 */     // MIs[0] round
     /* 2114881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114884 */     // MIs[0] policy
     /* 2114884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114894 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2114897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2114917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114920 */     // GIR_Coverage, 16892,
     /* 2114920 */     GIR_EraseRootFromParent_Done,
     /* 2114921 */   // Label 27994: @2114921
     /* 2114921 */   GIM_Try, /*On fail goto*//*Label 27995*/ GIMT_Encode4(2115012), // Rule ID 16893 //
     /* 2114926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2114929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2114934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2114937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2114940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2114943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2114946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2114968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114972 */     // MIs[0] round
     /* 2114972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114975 */     // MIs[0] policy
     /* 2114975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114985 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2114988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115008 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115011 */     // GIR_Coverage, 16893,
     /* 2115011 */     GIR_EraseRootFromParent_Done,
     /* 2115012 */   // Label 27995: @2115012
     /* 2115012 */   GIM_Try, /*On fail goto*//*Label 27996*/ GIMT_Encode4(2115103), // Rule ID 16896 //
     /* 2115017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2115020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2115025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2115028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2115031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2115034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2115037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2115059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115063 */     // MIs[0] round
     /* 2115063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115066 */     // MIs[0] policy
     /* 2115066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115076 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2115079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115102 */     // GIR_Coverage, 16896,
     /* 2115102 */     GIR_EraseRootFromParent_Done,
     /* 2115103 */   // Label 27996: @2115103
     /* 2115103 */   GIM_Try, /*On fail goto*//*Label 27997*/ GIMT_Encode4(2115194), // Rule ID 16897 //
     /* 2115108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2115111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2115116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2115119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2115122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2115125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2115128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2115150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115154 */     // MIs[0] round
     /* 2115154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115157 */     // MIs[0] policy
     /* 2115157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115167 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2115170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115193 */     // GIR_Coverage, 16897,
     /* 2115193 */     GIR_EraseRootFromParent_Done,
     /* 2115194 */   // Label 27997: @2115194
     /* 2115194 */   GIM_Try, /*On fail goto*//*Label 27998*/ GIMT_Encode4(2115285), // Rule ID 16900 //
     /* 2115199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2115202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2115207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2115210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2115213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2115216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2115219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2115222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2115241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115245 */     // MIs[0] round
     /* 2115245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115248 */     // MIs[0] policy
     /* 2115248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115258 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2115261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115284 */     // GIR_Coverage, 16900,
     /* 2115284 */     GIR_EraseRootFromParent_Done,
     /* 2115285 */   // Label 27998: @2115285
     /* 2115285 */   GIM_Try, /*On fail goto*//*Label 27999*/ GIMT_Encode4(2115376), // Rule ID 16901 //
     /* 2115290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2115293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2115298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2115301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2115304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2115307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2115310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2115313 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2115332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115336 */     // MIs[0] round
     /* 2115336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115339 */     // MIs[0] policy
     /* 2115339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115349 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2115352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115375 */     // GIR_Coverage, 16901,
     /* 2115375 */     GIR_EraseRootFromParent_Done,
     /* 2115376 */   // Label 27999: @2115376
     /* 2115376 */   GIM_Try, /*On fail goto*//*Label 28000*/ GIMT_Encode4(2115467), // Rule ID 16904 //
     /* 2115381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2115384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2115389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2115392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2115395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2115398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2115401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2115404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2115423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115427 */     // MIs[0] round
     /* 2115427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115430 */     // MIs[0] policy
     /* 2115430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115440 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2115443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115466 */     // GIR_Coverage, 16904,
     /* 2115466 */     GIR_EraseRootFromParent_Done,
     /* 2115467 */   // Label 28000: @2115467
     /* 2115467 */   GIM_Try, /*On fail goto*//*Label 28001*/ GIMT_Encode4(2115558), // Rule ID 16905 //
     /* 2115472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2115475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2115480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2115483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2115486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2115489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2115492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2115495 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2115514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115518 */     // MIs[0] round
     /* 2115518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115521 */     // MIs[0] policy
     /* 2115521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115531 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2115534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115554 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115557 */     // GIR_Coverage, 16905,
     /* 2115557 */     GIR_EraseRootFromParent_Done,
     /* 2115558 */   // Label 28001: @2115558
     /* 2115558 */   GIM_Try, /*On fail goto*//*Label 28002*/ GIMT_Encode4(2115649), // Rule ID 16908 //
     /* 2115563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2115566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2115571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2115574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2115577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2115580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115609 */     // MIs[0] round
     /* 2115609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115612 */     // MIs[0] policy
     /* 2115612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115622 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2115625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115648 */     // GIR_Coverage, 16908,
     /* 2115648 */     GIR_EraseRootFromParent_Done,
     /* 2115649 */   // Label 28002: @2115649
     /* 2115649 */   GIM_Try, /*On fail goto*//*Label 28003*/ GIMT_Encode4(2115740), // Rule ID 16909 //
     /* 2115654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2115657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2115662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2115665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2115668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2115671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115677 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115700 */     // MIs[0] round
     /* 2115700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115703 */     // MIs[0] policy
     /* 2115703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115713 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2115716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115736 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115739 */     // GIR_Coverage, 16909,
     /* 2115739 */     GIR_EraseRootFromParent_Done,
     /* 2115740 */   // Label 28003: @2115740
     /* 2115740 */   GIM_Try, /*On fail goto*//*Label 28004*/ GIMT_Encode4(2115831), // Rule ID 16912 //
     /* 2115745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2115748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2115753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2115756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2115759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2115762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115791 */     // MIs[0] round
     /* 2115791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115794 */     // MIs[0] policy
     /* 2115794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115804 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2115807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115830 */     // GIR_Coverage, 16912,
     /* 2115830 */     GIR_EraseRootFromParent_Done,
     /* 2115831 */   // Label 28004: @2115831
     /* 2115831 */   GIM_Try, /*On fail goto*//*Label 28005*/ GIMT_Encode4(2115922), // Rule ID 16913 //
     /* 2115836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2115839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2115844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2115847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2115850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2115853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115882 */     // MIs[0] round
     /* 2115882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115885 */     // MIs[0] policy
     /* 2115885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115895 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2115898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115921 */     // GIR_Coverage, 16913,
     /* 2115921 */     GIR_EraseRootFromParent_Done,
     /* 2115922 */   // Label 28005: @2115922
     /* 2115922 */   GIM_Try, /*On fail goto*//*Label 28006*/ GIMT_Encode4(2116013), // Rule ID 16916 //
     /* 2115927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2115930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2115935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2115938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2115941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2115944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2115950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115973 */     // MIs[0] round
     /* 2115973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115976 */     // MIs[0] policy
     /* 2115976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115986 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2115989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116012 */     // GIR_Coverage, 16916,
     /* 2116012 */     GIR_EraseRootFromParent_Done,
     /* 2116013 */   // Label 28006: @2116013
     /* 2116013 */   GIM_Try, /*On fail goto*//*Label 28007*/ GIMT_Encode4(2116104), // Rule ID 16917 //
     /* 2116018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2116021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2116026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2116029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2116032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2116035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2116038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2116041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2116060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116064 */     // MIs[0] round
     /* 2116064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116067 */     // MIs[0] policy
     /* 2116067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116077 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2116080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116103 */     // GIR_Coverage, 16917,
     /* 2116103 */     GIR_EraseRootFromParent_Done,
     /* 2116104 */   // Label 28007: @2116104
     /* 2116104 */   GIM_Try, /*On fail goto*//*Label 28008*/ GIMT_Encode4(2116195), // Rule ID 16920 //
     /* 2116109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2116112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2116117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2116120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2116123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2116126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2116129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2116151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116155 */     // MIs[0] round
     /* 2116155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116158 */     // MIs[0] policy
     /* 2116158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116168 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2116171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2116191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116194 */     // GIR_Coverage, 16920,
     /* 2116194 */     GIR_EraseRootFromParent_Done,
     /* 2116195 */   // Label 28008: @2116195
     /* 2116195 */   GIM_Try, /*On fail goto*//*Label 28009*/ GIMT_Encode4(2116286), // Rule ID 16921 //
     /* 2116200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2116203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2116208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2116211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2116214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2116217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2116220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2116242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116246 */     // MIs[0] round
     /* 2116246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116249 */     // MIs[0] policy
     /* 2116249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116259 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2116262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2116282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116285 */     // GIR_Coverage, 16921,
     /* 2116285 */     GIR_EraseRootFromParent_Done,
     /* 2116286 */   // Label 28009: @2116286
     /* 2116286 */   GIM_Try, /*On fail goto*//*Label 28010*/ GIMT_Encode4(2116377), // Rule ID 16924 //
     /* 2116291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2116294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2116299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2116302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2116305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2116308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2116311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2116333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116337 */     // MIs[0] round
     /* 2116337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116340 */     // MIs[0] policy
     /* 2116340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116350 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2116353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2116373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116376 */     // GIR_Coverage, 16924,
     /* 2116376 */     GIR_EraseRootFromParent_Done,
     /* 2116377 */   // Label 28010: @2116377
     /* 2116377 */   GIM_Try, /*On fail goto*//*Label 28011*/ GIMT_Encode4(2116468), // Rule ID 16925 //
     /* 2116382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2116385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2116390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2116393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2116396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2116399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2116402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2116424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116428 */     // MIs[0] round
     /* 2116428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116431 */     // MIs[0] policy
     /* 2116431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116441 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2116444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2116464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116467 */     // GIR_Coverage, 16925,
     /* 2116467 */     GIR_EraseRootFromParent_Done,
     /* 2116468 */   // Label 28011: @2116468
     /* 2116468 */   GIM_Try, /*On fail goto*//*Label 28012*/ GIMT_Encode4(2116559), // Rule ID 16928 //
     /* 2116473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2116476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2116481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2116484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2116487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2116490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2116493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2116515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116519 */     // MIs[0] round
     /* 2116519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116522 */     // MIs[0] policy
     /* 2116522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116532 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2116535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2116555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116558 */     // GIR_Coverage, 16928,
     /* 2116558 */     GIR_EraseRootFromParent_Done,
     /* 2116559 */   // Label 28012: @2116559
     /* 2116559 */   GIM_Try, /*On fail goto*//*Label 28013*/ GIMT_Encode4(2116650), // Rule ID 16929 //
     /* 2116564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2116567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2116572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2116575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2116578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2116581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2116584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2116606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116610 */     // MIs[0] round
     /* 2116610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116613 */     // MIs[0] policy
     /* 2116613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116623 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2116626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2116646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116649 */     // GIR_Coverage, 16929,
     /* 2116649 */     GIR_EraseRootFromParent_Done,
     /* 2116650 */   // Label 28013: @2116650
     /* 2116650 */   GIM_Try, /*On fail goto*//*Label 28014*/ GIMT_Encode4(2116741), // Rule ID 16932 //
     /* 2116655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2116658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2116663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2116666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2116669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2116672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2116675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116701 */     // MIs[0] round
     /* 2116701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116704 */     // MIs[0] policy
     /* 2116704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116714 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2116717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116740 */     // GIR_Coverage, 16932,
     /* 2116740 */     GIR_EraseRootFromParent_Done,
     /* 2116741 */   // Label 28014: @2116741
     /* 2116741 */   GIM_Try, /*On fail goto*//*Label 28015*/ GIMT_Encode4(2116832), // Rule ID 16933 //
     /* 2116746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2116749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2116754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2116757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2116760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2116763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2116766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116792 */     // MIs[0] round
     /* 2116792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116795 */     // MIs[0] policy
     /* 2116795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116805 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2116808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116831 */     // GIR_Coverage, 16933,
     /* 2116831 */     GIR_EraseRootFromParent_Done,
     /* 2116832 */   // Label 28015: @2116832
     /* 2116832 */   GIM_Try, /*On fail goto*//*Label 28016*/ GIMT_Encode4(2116923), // Rule ID 16936 //
     /* 2116837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2116840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2116845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2116848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2116851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2116854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2116857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116883 */     // MIs[0] round
     /* 2116883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116886 */     // MIs[0] policy
     /* 2116886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116896 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2116899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116922 */     // GIR_Coverage, 16936,
     /* 2116922 */     GIR_EraseRootFromParent_Done,
     /* 2116923 */   // Label 28016: @2116923
     /* 2116923 */   GIM_Try, /*On fail goto*//*Label 28017*/ GIMT_Encode4(2117014), // Rule ID 16937 //
     /* 2116928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2116931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2116936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2116939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2116942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2116945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2116948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116951 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116974 */     // MIs[0] round
     /* 2116974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116977 */     // MIs[0] policy
     /* 2116977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116987 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2116990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117013 */     // GIR_Coverage, 16937,
     /* 2117013 */     GIR_EraseRootFromParent_Done,
     /* 2117014 */   // Label 28017: @2117014
     /* 2117014 */   GIM_Try, /*On fail goto*//*Label 28018*/ GIMT_Encode4(2117105), // Rule ID 16940 //
     /* 2117019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2117022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2117027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2117030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2117033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2117036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2117039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2117061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117065 */     // MIs[0] round
     /* 2117065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117068 */     // MIs[0] policy
     /* 2117068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117078 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2117081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117104 */     // GIR_Coverage, 16940,
     /* 2117104 */     GIR_EraseRootFromParent_Done,
     /* 2117105 */   // Label 28018: @2117105
     /* 2117105 */   GIM_Try, /*On fail goto*//*Label 28019*/ GIMT_Encode4(2117196), // Rule ID 16941 //
     /* 2117110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2117113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2117118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2117121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2117124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2117127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2117130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2117152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117156 */     // MIs[0] round
     /* 2117156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117159 */     // MIs[0] policy
     /* 2117159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117169 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2117172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117195 */     // GIR_Coverage, 16941,
     /* 2117195 */     GIR_EraseRootFromParent_Done,
     /* 2117196 */   // Label 28019: @2117196
     /* 2117196 */   GIM_Try, /*On fail goto*//*Label 28020*/ GIMT_Encode4(2117287), // Rule ID 16944 //
     /* 2117201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2117204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2117209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2117212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2117215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2117218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117247 */     // MIs[0] round
     /* 2117247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117250 */     // MIs[0] policy
     /* 2117250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117260 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2117263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117286 */     // GIR_Coverage, 16944,
     /* 2117286 */     GIR_EraseRootFromParent_Done,
     /* 2117287 */   // Label 28020: @2117287
     /* 2117287 */   GIM_Try, /*On fail goto*//*Label 28021*/ GIMT_Encode4(2117378), // Rule ID 16945 //
     /* 2117292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2117295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2117300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2117303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2117306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2117309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117338 */     // MIs[0] round
     /* 2117338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117341 */     // MIs[0] policy
     /* 2117341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117351 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2117354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117377 */     // GIR_Coverage, 16945,
     /* 2117377 */     GIR_EraseRootFromParent_Done,
     /* 2117378 */   // Label 28021: @2117378
     /* 2117378 */   GIM_Try, /*On fail goto*//*Label 28022*/ GIMT_Encode4(2117469), // Rule ID 16948 //
     /* 2117383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2117386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2117391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2117394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2117397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2117400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2117403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2117425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117429 */     // MIs[0] round
     /* 2117429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117432 */     // MIs[0] policy
     /* 2117432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117442 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2117445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117468 */     // GIR_Coverage, 16948,
     /* 2117468 */     GIR_EraseRootFromParent_Done,
     /* 2117469 */   // Label 28022: @2117469
     /* 2117469 */   GIM_Try, /*On fail goto*//*Label 28023*/ GIMT_Encode4(2117560), // Rule ID 16949 //
     /* 2117474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2117477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2117482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2117485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2117488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2117491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2117494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2117516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117520 */     // MIs[0] round
     /* 2117520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117523 */     // MIs[0] policy
     /* 2117523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117533 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2117536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117546 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117556 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117559 */     // GIR_Coverage, 16949,
     /* 2117559 */     GIR_EraseRootFromParent_Done,
     /* 2117560 */   // Label 28023: @2117560
     /* 2117560 */   GIM_Try, /*On fail goto*//*Label 28024*/ GIMT_Encode4(2117651), // Rule ID 16952 //
     /* 2117565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2117568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2117573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2117576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2117579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2117582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2117585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2117607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117611 */     // MIs[0] round
     /* 2117611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117614 */     // MIs[0] policy
     /* 2117614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117624 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2117627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2117647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117650 */     // GIR_Coverage, 16952,
     /* 2117650 */     GIR_EraseRootFromParent_Done,
     /* 2117651 */   // Label 28024: @2117651
     /* 2117651 */   GIM_Try, /*On fail goto*//*Label 28025*/ GIMT_Encode4(2117742), // Rule ID 16953 //
     /* 2117656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2117659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2117664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2117667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2117670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2117673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2117676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117679 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2117698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117702 */     // MIs[0] round
     /* 2117702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117705 */     // MIs[0] policy
     /* 2117705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117715 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2117718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2117738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117741 */     // GIR_Coverage, 16953,
     /* 2117741 */     GIR_EraseRootFromParent_Done,
     /* 2117742 */   // Label 28025: @2117742
     /* 2117742 */   GIM_Try, /*On fail goto*//*Label 28026*/ GIMT_Encode4(2117833), // Rule ID 16956 //
     /* 2117747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2117750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2117755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2117758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2117761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2117764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117793 */     // MIs[0] round
     /* 2117793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117796 */     // MIs[0] policy
     /* 2117796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117806 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2117809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117832 */     // GIR_Coverage, 16956,
     /* 2117832 */     GIR_EraseRootFromParent_Done,
     /* 2117833 */   // Label 28026: @2117833
     /* 2117833 */   GIM_Try, /*On fail goto*//*Label 28027*/ GIMT_Encode4(2117924), // Rule ID 16957 //
     /* 2117838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2117841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2117846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2117849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2117852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2117855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117884 */     // MIs[0] round
     /* 2117884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117887 */     // MIs[0] policy
     /* 2117887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117897 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2117900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117923 */     // GIR_Coverage, 16957,
     /* 2117923 */     GIR_EraseRootFromParent_Done,
     /* 2117924 */   // Label 28027: @2117924
     /* 2117924 */   GIM_Try, /*On fail goto*//*Label 28028*/ GIMT_Encode4(2118015), // Rule ID 16960 //
     /* 2117929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2117932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2117937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2117940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2117943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2117946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2117952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2117959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117975 */     // MIs[0] round
     /* 2117975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117978 */     // MIs[0] policy
     /* 2117978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117988 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2117991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118014 */     // GIR_Coverage, 16960,
     /* 2118014 */     GIR_EraseRootFromParent_Done,
     /* 2118015 */   // Label 28028: @2118015
     /* 2118015 */   GIM_Try, /*On fail goto*//*Label 28029*/ GIMT_Encode4(2118106), // Rule ID 16961 //
     /* 2118020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2118023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2118028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2118031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2118034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2118037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2118043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118066 */     // MIs[0] round
     /* 2118066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118069 */     // MIs[0] policy
     /* 2118069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118079 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2118082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118105 */     // GIR_Coverage, 16961,
     /* 2118105 */     GIR_EraseRootFromParent_Done,
     /* 2118106 */   // Label 28029: @2118106
     /* 2118106 */   GIM_Try, /*On fail goto*//*Label 28030*/ GIMT_Encode4(2118197), // Rule ID 16964 //
     /* 2118111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2118114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2118119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2118122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2118125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2118128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2118134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118157 */     // MIs[0] round
     /* 2118157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118160 */     // MIs[0] policy
     /* 2118160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118170 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2118173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118196 */     // GIR_Coverage, 16964,
     /* 2118196 */     GIR_EraseRootFromParent_Done,
     /* 2118197 */   // Label 28030: @2118197
     /* 2118197 */   GIM_Try, /*On fail goto*//*Label 28031*/ GIMT_Encode4(2118288), // Rule ID 16965 //
     /* 2118202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2118205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2118210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2118213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2118216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2118219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2118225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118248 */     // MIs[0] round
     /* 2118248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118251 */     // MIs[0] policy
     /* 2118251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118261 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2118264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118287 */     // GIR_Coverage, 16965,
     /* 2118287 */     GIR_EraseRootFromParent_Done,
     /* 2118288 */   // Label 28031: @2118288
     /* 2118288 */   GIM_Try, /*On fail goto*//*Label 28032*/ GIMT_Encode4(2118379), // Rule ID 16968 //
     /* 2118293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2118296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2118301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2118304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2118307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2118310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118339 */     // MIs[0] round
     /* 2118339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118342 */     // MIs[0] policy
     /* 2118342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118352 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2118355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118378 */     // GIR_Coverage, 16968,
     /* 2118378 */     GIR_EraseRootFromParent_Done,
     /* 2118379 */   // Label 28032: @2118379
     /* 2118379 */   GIM_Try, /*On fail goto*//*Label 28033*/ GIMT_Encode4(2118470), // Rule ID 16969 //
     /* 2118384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2118387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2118392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2118395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2118398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2118401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118430 */     // MIs[0] round
     /* 2118430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118433 */     // MIs[0] policy
     /* 2118433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118443 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2118446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118469 */     // GIR_Coverage, 16969,
     /* 2118469 */     GIR_EraseRootFromParent_Done,
     /* 2118470 */   // Label 28033: @2118470
     /* 2118470 */   GIM_Try, /*On fail goto*//*Label 28034*/ GIMT_Encode4(2118561), // Rule ID 16972 //
     /* 2118475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2118478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2118483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2118486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2118489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2118492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118521 */     // MIs[0] round
     /* 2118521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118524 */     // MIs[0] policy
     /* 2118524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118534 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2118537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118560 */     // GIR_Coverage, 16972,
     /* 2118560 */     GIR_EraseRootFromParent_Done,
     /* 2118561 */   // Label 28034: @2118561
     /* 2118561 */   GIM_Try, /*On fail goto*//*Label 28035*/ GIMT_Encode4(2118652), // Rule ID 16973 //
     /* 2118566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2118569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2118574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2118577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2118580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2118583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118612 */     // MIs[0] round
     /* 2118612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118615 */     // MIs[0] policy
     /* 2118615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118625 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2118628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118651 */     // GIR_Coverage, 16973,
     /* 2118651 */     GIR_EraseRootFromParent_Done,
     /* 2118652 */   // Label 28035: @2118652
     /* 2118652 */   GIM_Try, /*On fail goto*//*Label 28036*/ GIMT_Encode4(2118743), // Rule ID 16976 //
     /* 2118657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2118660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2118665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2118668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2118671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2118674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2118680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118703 */     // MIs[0] round
     /* 2118703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118706 */     // MIs[0] policy
     /* 2118706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118716 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2118719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118742 */     // GIR_Coverage, 16976,
     /* 2118742 */     GIR_EraseRootFromParent_Done,
     /* 2118743 */   // Label 28036: @2118743
     /* 2118743 */   GIM_Try, /*On fail goto*//*Label 28037*/ GIMT_Encode4(2118834), // Rule ID 16977 //
     /* 2118748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2118751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2118756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2118759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2118762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2118765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2118771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118794 */     // MIs[0] round
     /* 2118794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118797 */     // MIs[0] policy
     /* 2118797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118807 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2118810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118833 */     // GIR_Coverage, 16977,
     /* 2118833 */     GIR_EraseRootFromParent_Done,
     /* 2118834 */   // Label 28037: @2118834
     /* 2118834 */   GIM_Try, /*On fail goto*//*Label 28038*/ GIMT_Encode4(2118925), // Rule ID 16980 //
     /* 2118839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2118842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2118847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2118850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2118853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2118856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2118859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2118862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2118881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118885 */     // MIs[0] round
     /* 2118885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118888 */     // MIs[0] policy
     /* 2118888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118898 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2118901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2118921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118924 */     // GIR_Coverage, 16980,
     /* 2118924 */     GIR_EraseRootFromParent_Done,
     /* 2118925 */   // Label 28038: @2118925
     /* 2118925 */   GIM_Try, /*On fail goto*//*Label 28039*/ GIMT_Encode4(2119016), // Rule ID 16981 //
     /* 2118930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2118933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2118938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2118941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2118944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2118947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2118950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2118953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2118972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118976 */     // MIs[0] round
     /* 2118976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118979 */     // MIs[0] policy
     /* 2118979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118989 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2118992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119002 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2119012 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119015 */     // GIR_Coverage, 16981,
     /* 2119015 */     GIR_EraseRootFromParent_Done,
     /* 2119016 */   // Label 28039: @2119016
     /* 2119016 */   GIM_Try, /*On fail goto*//*Label 28040*/ GIMT_Encode4(2119107), // Rule ID 16984 //
     /* 2119021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2119024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2119029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2119032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2119035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2119038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2119041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2119063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119067 */     // MIs[0] round
     /* 2119067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119070 */     // MIs[0] policy
     /* 2119070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119080 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2119083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2119103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119106 */     // GIR_Coverage, 16984,
     /* 2119106 */     GIR_EraseRootFromParent_Done,
     /* 2119107 */   // Label 28040: @2119107
     /* 2119107 */   GIM_Try, /*On fail goto*//*Label 28041*/ GIMT_Encode4(2119198), // Rule ID 16985 //
     /* 2119112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2119115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2119120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2119123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2119126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2119129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2119132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119135 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2119154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119158 */     // MIs[0] round
     /* 2119158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119161 */     // MIs[0] policy
     /* 2119161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119171 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2119174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2119194 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119197 */     // GIR_Coverage, 16985,
     /* 2119197 */     GIR_EraseRootFromParent_Done,
     /* 2119198 */   // Label 28041: @2119198
     /* 2119198 */   GIM_Try, /*On fail goto*//*Label 28042*/ GIMT_Encode4(2119289), // Rule ID 16988 //
     /* 2119203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2119206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2119211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2119214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2119217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2119220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2119223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2119245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119249 */     // MIs[0] round
     /* 2119249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119252 */     // MIs[0] policy
     /* 2119252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119262 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2119265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2119285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119288 */     // GIR_Coverage, 16988,
     /* 2119288 */     GIR_EraseRootFromParent_Done,
     /* 2119289 */   // Label 28042: @2119289
     /* 2119289 */   GIM_Try, /*On fail goto*//*Label 28043*/ GIMT_Encode4(2119380), // Rule ID 16989 //
     /* 2119294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2119297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2119302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2119305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2119308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2119311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2119314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119317 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2119336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119340 */     // MIs[0] round
     /* 2119340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119343 */     // MIs[0] policy
     /* 2119343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119353 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2119356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2119376 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119379 */     // GIR_Coverage, 16989,
     /* 2119379 */     GIR_EraseRootFromParent_Done,
     /* 2119380 */   // Label 28043: @2119380
     /* 2119380 */   GIM_Try, /*On fail goto*//*Label 28044*/ GIMT_Encode4(2119471), // Rule ID 16992 //
     /* 2119385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2119393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2119396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2119399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2119402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2119405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119431 */     // MIs[0] round
     /* 2119431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119434 */     // MIs[0] policy
     /* 2119434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119444 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2119447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119470 */     // GIR_Coverage, 16992,
     /* 2119470 */     GIR_EraseRootFromParent_Done,
     /* 2119471 */   // Label 28044: @2119471
     /* 2119471 */   GIM_Try, /*On fail goto*//*Label 28045*/ GIMT_Encode4(2119562), // Rule ID 16993 //
     /* 2119476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2119484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2119487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2119490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2119493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2119496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119522 */     // MIs[0] round
     /* 2119522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119525 */     // MIs[0] policy
     /* 2119525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119535 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2119538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119558 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119561 */     // GIR_Coverage, 16993,
     /* 2119561 */     GIR_EraseRootFromParent_Done,
     /* 2119562 */   // Label 28045: @2119562
     /* 2119562 */   GIM_Try, /*On fail goto*//*Label 28046*/ GIMT_Encode4(2119653), // Rule ID 16996 //
     /* 2119567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2119575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2119578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2119581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2119584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2119587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119613 */     // MIs[0] round
     /* 2119613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119616 */     // MIs[0] policy
     /* 2119616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119626 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2119629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119639 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119649 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119652 */     // GIR_Coverage, 16996,
     /* 2119652 */     GIR_EraseRootFromParent_Done,
     /* 2119653 */   // Label 28046: @2119653
     /* 2119653 */   GIM_Try, /*On fail goto*//*Label 28047*/ GIMT_Encode4(2119744), // Rule ID 16997 //
     /* 2119658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2119666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2119669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2119672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2119675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2119678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119704 */     // MIs[0] round
     /* 2119704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119707 */     // MIs[0] policy
     /* 2119707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119717 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2119720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119730 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119740 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119743 */     // GIR_Coverage, 16997,
     /* 2119743 */     GIR_EraseRootFromParent_Done,
     /* 2119744 */   // Label 28047: @2119744
     /* 2119744 */   GIM_Try, /*On fail goto*//*Label 28048*/ GIMT_Encode4(2119835), // Rule ID 17000 //
     /* 2119749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2119757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2119760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2119763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2119766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2119769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119795 */     // MIs[0] round
     /* 2119795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119798 */     // MIs[0] policy
     /* 2119798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119808 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2119811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119834 */     // GIR_Coverage, 17000,
     /* 2119834 */     GIR_EraseRootFromParent_Done,
     /* 2119835 */   // Label 28048: @2119835
     /* 2119835 */   GIM_Try, /*On fail goto*//*Label 28049*/ GIMT_Encode4(2119926), // Rule ID 17001 //
     /* 2119840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2119848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2119851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2119854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2119857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2119860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119886 */     // MIs[0] round
     /* 2119886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119889 */     // MIs[0] policy
     /* 2119889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119899 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2119902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119925 */     // GIR_Coverage, 17001,
     /* 2119925 */     GIR_EraseRootFromParent_Done,
     /* 2119926 */   // Label 28049: @2119926
     /* 2119926 */   GIM_Try, /*On fail goto*//*Label 28050*/ GIMT_Encode4(2120017), // Rule ID 17004 //
     /* 2119931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2119939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2119942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2119945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2119948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2119951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119977 */     // MIs[0] round
     /* 2119977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119980 */     // MIs[0] policy
     /* 2119980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119990 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2119993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120016 */     // GIR_Coverage, 17004,
     /* 2120016 */     GIR_EraseRootFromParent_Done,
     /* 2120017 */   // Label 28050: @2120017
     /* 2120017 */   GIM_Try, /*On fail goto*//*Label 28051*/ GIMT_Encode4(2120108), // Rule ID 17005 //
     /* 2120022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2120030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2120033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2120036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2120039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2120042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2120045 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2120052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120068 */     // MIs[0] round
     /* 2120068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120071 */     // MIs[0] policy
     /* 2120071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120081 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2120084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120104 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120107 */     // GIR_Coverage, 17005,
     /* 2120107 */     GIR_EraseRootFromParent_Done,
     /* 2120108 */   // Label 28051: @2120108
     /* 2120108 */   GIM_Try, /*On fail goto*//*Label 28052*/ GIMT_Encode4(2120199), // Rule ID 17008 //
     /* 2120113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2120121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2120124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2120127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2120130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2120133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2120136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120159 */     // MIs[0] round
     /* 2120159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120162 */     // MIs[0] policy
     /* 2120162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120172 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2120175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120198 */     // GIR_Coverage, 17008,
     /* 2120198 */     GIR_EraseRootFromParent_Done,
     /* 2120199 */   // Label 28052: @2120199
     /* 2120199 */   GIM_Try, /*On fail goto*//*Label 28053*/ GIMT_Encode4(2120290), // Rule ID 17009 //
     /* 2120204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2120212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2120215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2120218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2120221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2120224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2120227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120250 */     // MIs[0] round
     /* 2120250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120253 */     // MIs[0] policy
     /* 2120253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120263 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2120266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120286 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120289 */     // GIR_Coverage, 17009,
     /* 2120289 */     GIR_EraseRootFromParent_Done,
     /* 2120290 */   // Label 28053: @2120290
     /* 2120290 */   GIM_Try, /*On fail goto*//*Label 28054*/ GIMT_Encode4(2120381), // Rule ID 17012 //
     /* 2120295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2120303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2120306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2120309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2120312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2120315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120341 */     // MIs[0] round
     /* 2120341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120344 */     // MIs[0] policy
     /* 2120344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120354 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2120357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120380 */     // GIR_Coverage, 17012,
     /* 2120380 */     GIR_EraseRootFromParent_Done,
     /* 2120381 */   // Label 28054: @2120381
     /* 2120381 */   GIM_Try, /*On fail goto*//*Label 28055*/ GIMT_Encode4(2120472), // Rule ID 17013 //
     /* 2120386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2120394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2120397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2120400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2120403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2120406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120432 */     // MIs[0] round
     /* 2120432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120435 */     // MIs[0] policy
     /* 2120435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120445 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2120448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120471 */     // GIR_Coverage, 17013,
     /* 2120471 */     GIR_EraseRootFromParent_Done,
     /* 2120472 */   // Label 28055: @2120472
     /* 2120472 */   GIM_Try, /*On fail goto*//*Label 28056*/ GIMT_Encode4(2120563), // Rule ID 17016 //
     /* 2120477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2120485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2120488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2120491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2120494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2120497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120523 */     // MIs[0] round
     /* 2120523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120526 */     // MIs[0] policy
     /* 2120526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120536 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2120539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120562 */     // GIR_Coverage, 17016,
     /* 2120562 */     GIR_EraseRootFromParent_Done,
     /* 2120563 */   // Label 28056: @2120563
     /* 2120563 */   GIM_Try, /*On fail goto*//*Label 28057*/ GIMT_Encode4(2120654), // Rule ID 17017 //
     /* 2120568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2120576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2120579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2120582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2120585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2120588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120614 */     // MIs[0] round
     /* 2120614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120617 */     // MIs[0] policy
     /* 2120617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120627 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2120630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120653 */     // GIR_Coverage, 17017,
     /* 2120653 */     GIR_EraseRootFromParent_Done,
     /* 2120654 */   // Label 28057: @2120654
     /* 2120654 */   GIM_Try, /*On fail goto*//*Label 28058*/ GIMT_Encode4(2120745), // Rule ID 17020 //
     /* 2120659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2120667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2120670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2120673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2120676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2120679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2120689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120705 */     // MIs[0] round
     /* 2120705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120708 */     // MIs[0] policy
     /* 2120708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120718 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2120721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120744 */     // GIR_Coverage, 17020,
     /* 2120744 */     GIR_EraseRootFromParent_Done,
     /* 2120745 */   // Label 28058: @2120745
     /* 2120745 */   GIM_Try, /*On fail goto*//*Label 28059*/ GIMT_Encode4(2120836), // Rule ID 17021 //
     /* 2120750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2120758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2120761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2120764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2120767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2120770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2120780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120796 */     // MIs[0] round
     /* 2120796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120799 */     // MIs[0] policy
     /* 2120799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120809 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2120812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120822 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120832 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120835 */     // GIR_Coverage, 17021,
     /* 2120835 */     GIR_EraseRootFromParent_Done,
     /* 2120836 */   // Label 28059: @2120836
     /* 2120836 */   GIM_Try, /*On fail goto*//*Label 28060*/ GIMT_Encode4(2120927), // Rule ID 17024 //
     /* 2120841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2120849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2120852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2120855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2120858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2120861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2120864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120887 */     // MIs[0] round
     /* 2120887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120890 */     // MIs[0] policy
     /* 2120890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120900 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2120903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120926 */     // GIR_Coverage, 17024,
     /* 2120926 */     GIR_EraseRootFromParent_Done,
     /* 2120927 */   // Label 28060: @2120927
     /* 2120927 */   GIM_Try, /*On fail goto*//*Label 28061*/ GIMT_Encode4(2121018), // Rule ID 17025 //
     /* 2120932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2120940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2120943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2120946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2120949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2120952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2120955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120978 */     // MIs[0] round
     /* 2120978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120981 */     // MIs[0] policy
     /* 2120981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120991 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2120994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121004 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121014 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121017 */     // GIR_Coverage, 17025,
     /* 2121017 */     GIR_EraseRootFromParent_Done,
     /* 2121018 */   // Label 28061: @2121018
     /* 2121018 */   GIM_Try, /*On fail goto*//*Label 28062*/ GIMT_Encode4(2121109), // Rule ID 17028 //
     /* 2121023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2121031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2121034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2121037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2121040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121069 */     // MIs[0] round
     /* 2121069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121072 */     // MIs[0] policy
     /* 2121072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121082 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2121085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121108 */     // GIR_Coverage, 17028,
     /* 2121108 */     GIR_EraseRootFromParent_Done,
     /* 2121109 */   // Label 28062: @2121109
     /* 2121109 */   GIM_Try, /*On fail goto*//*Label 28063*/ GIMT_Encode4(2121200), // Rule ID 17029 //
     /* 2121114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2121122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2121125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2121128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2121131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121160 */     // MIs[0] round
     /* 2121160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121163 */     // MIs[0] policy
     /* 2121163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121173 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2121176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121186 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121196 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121199 */     // GIR_Coverage, 17029,
     /* 2121199 */     GIR_EraseRootFromParent_Done,
     /* 2121200 */   // Label 28063: @2121200
     /* 2121200 */   GIM_Try, /*On fail goto*//*Label 28064*/ GIMT_Encode4(2121291), // Rule ID 17032 //
     /* 2121205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2121213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2121216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2121219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2121222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121251 */     // MIs[0] round
     /* 2121251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121254 */     // MIs[0] policy
     /* 2121254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121264 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2121267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121287 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121290 */     // GIR_Coverage, 17032,
     /* 2121290 */     GIR_EraseRootFromParent_Done,
     /* 2121291 */   // Label 28064: @2121291
     /* 2121291 */   GIM_Try, /*On fail goto*//*Label 28065*/ GIMT_Encode4(2121382), // Rule ID 17033 //
     /* 2121296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2121304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2121307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2121310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2121313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121319 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121342 */     // MIs[0] round
     /* 2121342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121345 */     // MIs[0] policy
     /* 2121345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121355 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2121358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121368 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121378 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121381 */     // GIR_Coverage, 17033,
     /* 2121381 */     GIR_EraseRootFromParent_Done,
     /* 2121382 */   // Label 28065: @2121382
     /* 2121382 */   GIM_Try, /*On fail goto*//*Label 28066*/ GIMT_Encode4(2121473), // Rule ID 17036 //
     /* 2121387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2121395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2121398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2121401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2121404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121433 */     // MIs[0] round
     /* 2121433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121436 */     // MIs[0] policy
     /* 2121436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121446 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2121449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121472 */     // GIR_Coverage, 17036,
     /* 2121472 */     GIR_EraseRootFromParent_Done,
     /* 2121473 */   // Label 28066: @2121473
     /* 2121473 */   GIM_Try, /*On fail goto*//*Label 28067*/ GIMT_Encode4(2121564), // Rule ID 17037 //
     /* 2121478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2121486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2121489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2121492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2121495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121501 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121524 */     // MIs[0] round
     /* 2121524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121527 */     // MIs[0] policy
     /* 2121527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121537 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2121540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121550 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121560 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121563 */     // GIR_Coverage, 17037,
     /* 2121563 */     GIR_EraseRootFromParent_Done,
     /* 2121564 */   // Label 28067: @2121564
     /* 2121564 */   GIM_Try, /*On fail goto*//*Label 28068*/ GIMT_Encode4(2121655), // Rule ID 17040 //
     /* 2121569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2121577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2121580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2121583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2121586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121615 */     // MIs[0] round
     /* 2121615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121618 */     // MIs[0] policy
     /* 2121618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121628 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2121631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121641 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121651 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121654 */     // GIR_Coverage, 17040,
     /* 2121654 */     GIR_EraseRootFromParent_Done,
     /* 2121655 */   // Label 28068: @2121655
     /* 2121655 */   GIM_Try, /*On fail goto*//*Label 28069*/ GIMT_Encode4(2121746), // Rule ID 17041 //
     /* 2121660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2121668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2121671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2121674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2121677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121683 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121706 */     // MIs[0] round
     /* 2121706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121709 */     // MIs[0] policy
     /* 2121709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121719 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2121722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121745 */     // GIR_Coverage, 17041,
     /* 2121745 */     GIR_EraseRootFromParent_Done,
     /* 2121746 */   // Label 28069: @2121746
     /* 2121746 */   GIM_Try, /*On fail goto*//*Label 28070*/ GIMT_Encode4(2121837), // Rule ID 17044 //
     /* 2121751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2121759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2121762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2121765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2121768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2121774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121797 */     // MIs[0] round
     /* 2121797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121800 */     // MIs[0] policy
     /* 2121800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121810 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2121813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121836 */     // GIR_Coverage, 17044,
     /* 2121836 */     GIR_EraseRootFromParent_Done,
     /* 2121837 */   // Label 28070: @2121837
     /* 2121837 */   GIM_Try, /*On fail goto*//*Label 28071*/ GIMT_Encode4(2121928), // Rule ID 17045 //
     /* 2121842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2121850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2121853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2121856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2121859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2121865 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121888 */     // MIs[0] round
     /* 2121888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121891 */     // MIs[0] policy
     /* 2121891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121901 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2121904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121914 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121924 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121927 */     // GIR_Coverage, 17045,
     /* 2121927 */     GIR_EraseRootFromParent_Done,
     /* 2121928 */   // Label 28071: @2121928
     /* 2121928 */   GIM_Try, /*On fail goto*//*Label 28072*/ GIMT_Encode4(2122019), // Rule ID 17048 //
     /* 2121933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2121941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2121944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2121947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2121950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121979 */     // MIs[0] round
     /* 2121979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121982 */     // MIs[0] policy
     /* 2121982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121992 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2121995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122018 */     // GIR_Coverage, 17048,
     /* 2122018 */     GIR_EraseRootFromParent_Done,
     /* 2122019 */   // Label 28072: @2122019
     /* 2122019 */   GIM_Try, /*On fail goto*//*Label 28073*/ GIMT_Encode4(2122110), // Rule ID 17049 //
     /* 2122024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2122032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2122035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2122038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2122041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2122047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122070 */     // MIs[0] round
     /* 2122070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122073 */     // MIs[0] policy
     /* 2122073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122083 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2122086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122109 */     // GIR_Coverage, 17049,
     /* 2122109 */     GIR_EraseRootFromParent_Done,
     /* 2122110 */   // Label 28073: @2122110
     /* 2122110 */   GIM_Try, /*On fail goto*//*Label 28074*/ GIMT_Encode4(2122201), // Rule ID 17052 //
     /* 2122115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2122118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2122123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2122126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2122129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122161 */     // MIs[0] round
     /* 2122161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122164 */     // MIs[0] policy
     /* 2122164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122174 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2122177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122197 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122200 */     // GIR_Coverage, 17052,
     /* 2122200 */     GIR_EraseRootFromParent_Done,
     /* 2122201 */   // Label 28074: @2122201
     /* 2122201 */   GIM_Try, /*On fail goto*//*Label 28075*/ GIMT_Encode4(2122292), // Rule ID 17053 //
     /* 2122206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2122214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2122217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2122220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122252 */     // MIs[0] round
     /* 2122252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122255 */     // MIs[0] policy
     /* 2122255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122265 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2122268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122278 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122288 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122291 */     // GIR_Coverage, 17053,
     /* 2122291 */     GIR_EraseRootFromParent_Done,
     /* 2122292 */   // Label 28075: @2122292
     /* 2122292 */   GIM_Try, /*On fail goto*//*Label 28076*/ GIMT_Encode4(2122383), // Rule ID 17056 //
     /* 2122297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2122300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2122305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2122308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2122311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122343 */     // MIs[0] round
     /* 2122343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122346 */     // MIs[0] policy
     /* 2122346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122356 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2122359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122382 */     // GIR_Coverage, 17056,
     /* 2122382 */     GIR_EraseRootFromParent_Done,
     /* 2122383 */   // Label 28076: @2122383
     /* 2122383 */   GIM_Try, /*On fail goto*//*Label 28077*/ GIMT_Encode4(2122474), // Rule ID 17057 //
     /* 2122388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2122396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2122399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2122402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122411 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122434 */     // MIs[0] round
     /* 2122434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122437 */     // MIs[0] policy
     /* 2122437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122447 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2122450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122460 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122470 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122473 */     // GIR_Coverage, 17057,
     /* 2122473 */     GIR_EraseRootFromParent_Done,
     /* 2122474 */   // Label 28077: @2122474
     /* 2122474 */   GIM_Try, /*On fail goto*//*Label 28078*/ GIMT_Encode4(2122565), // Rule ID 17060 //
     /* 2122479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2122482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2122487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2122490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2122493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122525 */     // MIs[0] round
     /* 2122525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122528 */     // MIs[0] policy
     /* 2122528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122538 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2122541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122564 */     // GIR_Coverage, 17060,
     /* 2122564 */     GIR_EraseRootFromParent_Done,
     /* 2122565 */   // Label 28078: @2122565
     /* 2122565 */   GIM_Try, /*On fail goto*//*Label 28079*/ GIMT_Encode4(2122656), // Rule ID 17061 //
     /* 2122570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2122578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2122581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2122584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122593 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122616 */     // MIs[0] round
     /* 2122616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122619 */     // MIs[0] policy
     /* 2122619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122629 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2122632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122652 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122655 */     // GIR_Coverage, 17061,
     /* 2122655 */     GIR_EraseRootFromParent_Done,
     /* 2122656 */   // Label 28079: @2122656
     /* 2122656 */   GIM_Try, /*On fail goto*//*Label 28080*/ GIMT_Encode4(2122747), // Rule ID 17064 //
     /* 2122661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2122672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2122675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2122678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2122681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2122684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122707 */     // MIs[0] round
     /* 2122707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122710 */     // MIs[0] policy
     /* 2122710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122720 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2122723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122746 */     // GIR_Coverage, 17064,
     /* 2122746 */     GIR_EraseRootFromParent_Done,
     /* 2122747 */   // Label 28080: @2122747
     /* 2122747 */   GIM_Try, /*On fail goto*//*Label 28081*/ GIMT_Encode4(2122838), // Rule ID 17065 //
     /* 2122752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2122763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2122766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2122769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2122772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2122775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122798 */     // MIs[0] round
     /* 2122798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122801 */     // MIs[0] policy
     /* 2122801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122811 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2122814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122837 */     // GIR_Coverage, 17065,
     /* 2122837 */     GIR_EraseRootFromParent_Done,
     /* 2122838 */   // Label 28081: @2122838
     /* 2122838 */   GIM_Try, /*On fail goto*//*Label 28082*/ GIMT_Encode4(2122929), // Rule ID 17068 //
     /* 2122843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2122854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2122857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2122860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2122863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122889 */     // MIs[0] round
     /* 2122889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122892 */     // MIs[0] policy
     /* 2122892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122902 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2122905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122928 */     // GIR_Coverage, 17068,
     /* 2122928 */     GIR_EraseRootFromParent_Done,
     /* 2122929 */   // Label 28082: @2122929
     /* 2122929 */   GIM_Try, /*On fail goto*//*Label 28083*/ GIMT_Encode4(2123020), // Rule ID 17069 //
     /* 2122934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2122945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2122948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2122951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2122954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122980 */     // MIs[0] round
     /* 2122980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122983 */     // MIs[0] policy
     /* 2122983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122993 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2122996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123019 */     // GIR_Coverage, 17069,
     /* 2123019 */     GIR_EraseRootFromParent_Done,
     /* 2123020 */   // Label 28083: @2123020
     /* 2123020 */   GIM_Try, /*On fail goto*//*Label 28084*/ GIMT_Encode4(2123111), // Rule ID 17072 //
     /* 2123025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2123028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2123033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2123036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2123039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2123042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2123045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123071 */     // MIs[0] round
     /* 2123071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123074 */     // MIs[0] policy
     /* 2123074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123084 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2123087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123110 */     // GIR_Coverage, 17072,
     /* 2123110 */     GIR_EraseRootFromParent_Done,
     /* 2123111 */   // Label 28084: @2123111
     /* 2123111 */   GIM_Try, /*On fail goto*//*Label 28085*/ GIMT_Encode4(2123202), // Rule ID 17073 //
     /* 2123116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2123119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2123124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2123127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2123130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2123133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2123136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123139 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123162 */     // MIs[0] round
     /* 2123162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123165 */     // MIs[0] policy
     /* 2123165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123175 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2123178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123201 */     // GIR_Coverage, 17073,
     /* 2123201 */     GIR_EraseRootFromParent_Done,
     /* 2123202 */   // Label 28085: @2123202
     /* 2123202 */   GIM_Try, /*On fail goto*//*Label 28086*/ GIMT_Encode4(2123293), // Rule ID 17076 //
     /* 2123207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2123210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2123215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2123218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2123221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2123224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2123227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123253 */     // MIs[0] round
     /* 2123253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123256 */     // MIs[0] policy
     /* 2123256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123266 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2123269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123292 */     // GIR_Coverage, 17076,
     /* 2123292 */     GIR_EraseRootFromParent_Done,
     /* 2123293 */   // Label 28086: @2123293
     /* 2123293 */   GIM_Try, /*On fail goto*//*Label 28087*/ GIMT_Encode4(2123384), // Rule ID 17077 //
     /* 2123298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2123301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2123306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2123309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2123312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2123315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2123318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123321 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123344 */     // MIs[0] round
     /* 2123344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123347 */     // MIs[0] policy
     /* 2123347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123357 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2123360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123383 */     // GIR_Coverage, 17077,
     /* 2123383 */     GIR_EraseRootFromParent_Done,
     /* 2123384 */   // Label 28087: @2123384
     /* 2123384 */   GIM_Try, /*On fail goto*//*Label 28088*/ GIMT_Encode4(2123475), // Rule ID 17080 //
     /* 2123389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2123392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2123397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2123400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2123403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2123406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2123409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2123412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123435 */     // MIs[0] round
     /* 2123435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123438 */     // MIs[0] policy
     /* 2123438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123448 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2123451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123461 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123471 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123474 */     // GIR_Coverage, 17080,
     /* 2123474 */     GIR_EraseRootFromParent_Done,
     /* 2123475 */   // Label 28088: @2123475
     /* 2123475 */   GIM_Try, /*On fail goto*//*Label 28089*/ GIMT_Encode4(2123566), // Rule ID 17081 //
     /* 2123480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2123483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2123488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2123491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2123494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2123497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2123500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2123503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123526 */     // MIs[0] round
     /* 2123526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123529 */     // MIs[0] policy
     /* 2123529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123539 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2123542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123552 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123562 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123565 */     // GIR_Coverage, 17081,
     /* 2123565 */     GIR_EraseRootFromParent_Done,
     /* 2123566 */   // Label 28089: @2123566
     /* 2123566 */   GIM_Try, /*On fail goto*//*Label 28090*/ GIMT_Encode4(2123657), // Rule ID 17084 //
     /* 2123571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2123579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2123582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2123585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2123588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2123591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123617 */     // MIs[0] round
     /* 2123617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123620 */     // MIs[0] policy
     /* 2123620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123630 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2123633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123656 */     // GIR_Coverage, 17084,
     /* 2123656 */     GIR_EraseRootFromParent_Done,
     /* 2123657 */   // Label 28090: @2123657
     /* 2123657 */   GIM_Try, /*On fail goto*//*Label 28091*/ GIMT_Encode4(2123748), // Rule ID 17085 //
     /* 2123662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2123670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2123673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2123676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2123679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2123682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123708 */     // MIs[0] round
     /* 2123708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123711 */     // MIs[0] policy
     /* 2123711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123721 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2123724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123747 */     // GIR_Coverage, 17085,
     /* 2123747 */     GIR_EraseRootFromParent_Done,
     /* 2123748 */   // Label 28091: @2123748
     /* 2123748 */   GIM_Try, /*On fail goto*//*Label 28092*/ GIMT_Encode4(2123839), // Rule ID 17088 //
     /* 2123753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2123761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2123764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2123767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2123770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2123773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123799 */     // MIs[0] round
     /* 2123799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123802 */     // MIs[0] policy
     /* 2123802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123812 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2123815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123838 */     // GIR_Coverage, 17088,
     /* 2123838 */     GIR_EraseRootFromParent_Done,
     /* 2123839 */   // Label 28092: @2123839
     /* 2123839 */   GIM_Try, /*On fail goto*//*Label 28093*/ GIMT_Encode4(2123930), // Rule ID 17089 //
     /* 2123844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2123852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2123855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2123858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2123861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2123864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123890 */     // MIs[0] round
     /* 2123890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123893 */     // MIs[0] policy
     /* 2123893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123903 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2123906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123926 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123929 */     // GIR_Coverage, 17089,
     /* 2123929 */     GIR_EraseRootFromParent_Done,
     /* 2123930 */   // Label 28093: @2123930
     /* 2123930 */   GIM_Try, /*On fail goto*//*Label 28094*/ GIMT_Encode4(2124021), // Rule ID 17092 //
     /* 2123935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2123943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2123946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2123949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2123952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2123955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123981 */     // MIs[0] round
     /* 2123981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123984 */     // MIs[0] policy
     /* 2123984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123994 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2123997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124020 */     // GIR_Coverage, 17092,
     /* 2124020 */     GIR_EraseRootFromParent_Done,
     /* 2124021 */   // Label 28094: @2124021
     /* 2124021 */   GIM_Try, /*On fail goto*//*Label 28095*/ GIMT_Encode4(2124112), // Rule ID 17093 //
     /* 2124026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2124029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2124034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2124037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2124040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2124043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2124046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124072 */     // MIs[0] round
     /* 2124072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124075 */     // MIs[0] policy
     /* 2124075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124085 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2124088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124111 */     // GIR_Coverage, 17093,
     /* 2124111 */     GIR_EraseRootFromParent_Done,
     /* 2124112 */   // Label 28095: @2124112
     /* 2124112 */   GIM_Try, /*On fail goto*//*Label 28096*/ GIMT_Encode4(2124203), // Rule ID 17096 //
     /* 2124117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2124120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2124125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2124128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2124131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2124134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2124137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124163 */     // MIs[0] round
     /* 2124163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124166 */     // MIs[0] policy
     /* 2124166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124176 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2124179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124202 */     // GIR_Coverage, 17096,
     /* 2124202 */     GIR_EraseRootFromParent_Done,
     /* 2124203 */   // Label 28096: @2124203
     /* 2124203 */   GIM_Try, /*On fail goto*//*Label 28097*/ GIMT_Encode4(2124294), // Rule ID 17097 //
     /* 2124208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2124211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2124216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2124219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2124222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2124225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2124228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124254 */     // MIs[0] round
     /* 2124254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124257 */     // MIs[0] policy
     /* 2124257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124267 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2124270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124293 */     // GIR_Coverage, 17097,
     /* 2124293 */     GIR_EraseRootFromParent_Done,
     /* 2124294 */   // Label 28097: @2124294
     /* 2124294 */   GIM_Try, /*On fail goto*//*Label 28098*/ GIMT_Encode4(2124385), // Rule ID 17100 //
     /* 2124299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2124307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2124310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2124313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2124316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124345 */     // MIs[0] round
     /* 2124345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124348 */     // MIs[0] policy
     /* 2124348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124358 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2124361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124381 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124384 */     // GIR_Coverage, 17100,
     /* 2124384 */     GIR_EraseRootFromParent_Done,
     /* 2124385 */   // Label 28098: @2124385
     /* 2124385 */   GIM_Try, /*On fail goto*//*Label 28099*/ GIMT_Encode4(2124476), // Rule ID 17101 //
     /* 2124390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2124398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2124401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2124404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2124407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124436 */     // MIs[0] round
     /* 2124436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124439 */     // MIs[0] policy
     /* 2124439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124449 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2124452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124475 */     // GIR_Coverage, 17101,
     /* 2124475 */     GIR_EraseRootFromParent_Done,
     /* 2124476 */   // Label 28099: @2124476
     /* 2124476 */   GIM_Try, /*On fail goto*//*Label 28100*/ GIMT_Encode4(2124567), // Rule ID 17104 //
     /* 2124481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2124489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2124492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2124495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2124498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124527 */     // MIs[0] round
     /* 2124527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124530 */     // MIs[0] policy
     /* 2124530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124540 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2124543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124566 */     // GIR_Coverage, 17104,
     /* 2124566 */     GIR_EraseRootFromParent_Done,
     /* 2124567 */   // Label 28100: @2124567
     /* 2124567 */   GIM_Try, /*On fail goto*//*Label 28101*/ GIMT_Encode4(2124658), // Rule ID 17105 //
     /* 2124572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2124580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2124583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2124586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2124589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124618 */     // MIs[0] round
     /* 2124618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124621 */     // MIs[0] policy
     /* 2124621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124631 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2124634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124644 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124654 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124657 */     // GIR_Coverage, 17105,
     /* 2124657 */     GIR_EraseRootFromParent_Done,
     /* 2124658 */   // Label 28101: @2124658
     /* 2124658 */   GIM_Try, /*On fail goto*//*Label 28102*/ GIMT_Encode4(2124749), // Rule ID 17108 //
     /* 2124663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2124671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2124674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2124677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2124680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124709 */     // MIs[0] round
     /* 2124709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124712 */     // MIs[0] policy
     /* 2124712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124722 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2124725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124748 */     // GIR_Coverage, 17108,
     /* 2124748 */     GIR_EraseRootFromParent_Done,
     /* 2124749 */   // Label 28102: @2124749
     /* 2124749 */   GIM_Try, /*On fail goto*//*Label 28103*/ GIMT_Encode4(2124840), // Rule ID 17109 //
     /* 2124754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2124762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2124765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2124768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2124771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124800 */     // MIs[0] round
     /* 2124800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124803 */     // MIs[0] policy
     /* 2124803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124813 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2124816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124839 */     // GIR_Coverage, 17109,
     /* 2124839 */     GIR_EraseRootFromParent_Done,
     /* 2124840 */   // Label 28103: @2124840
     /* 2124840 */   GIM_Try, /*On fail goto*//*Label 28104*/ GIMT_Encode4(2124931), // Rule ID 17112 //
     /* 2124845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2124853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2124856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2124859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2124862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124891 */     // MIs[0] round
     /* 2124891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124894 */     // MIs[0] policy
     /* 2124894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124904 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2124907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124930 */     // GIR_Coverage, 17112,
     /* 2124930 */     GIR_EraseRootFromParent_Done,
     /* 2124931 */   // Label 28104: @2124931
     /* 2124931 */   GIM_Try, /*On fail goto*//*Label 28105*/ GIMT_Encode4(2125022), // Rule ID 17113 //
     /* 2124936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2124944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2124947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2124950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2124953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124959 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124982 */     // MIs[0] round
     /* 2124982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124985 */     // MIs[0] policy
     /* 2124985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124995 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2124998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125008 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125018 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125021 */     // GIR_Coverage, 17113,
     /* 2125021 */     GIR_EraseRootFromParent_Done,
     /* 2125022 */   // Label 28105: @2125022
     /* 2125022 */   GIM_Try, /*On fail goto*//*Label 28106*/ GIMT_Encode4(2125113), // Rule ID 17116 //
     /* 2125027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2125035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2125038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2125041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2125044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2125047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2125050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2125069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125073 */     // MIs[0] round
     /* 2125073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125076 */     // MIs[0] policy
     /* 2125076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125086 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2125089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125112 */     // GIR_Coverage, 17116,
     /* 2125112 */     GIR_EraseRootFromParent_Done,
     /* 2125113 */   // Label 28106: @2125113
     /* 2125113 */   GIM_Try, /*On fail goto*//*Label 28107*/ GIMT_Encode4(2125204), // Rule ID 17117 //
     /* 2125118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2125121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2125126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2125129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2125132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2125135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2125138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2125141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2125160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125164 */     // MIs[0] round
     /* 2125164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125167 */     // MIs[0] policy
     /* 2125167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125177 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2125180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125203 */     // GIR_Coverage, 17117,
     /* 2125203 */     GIR_EraseRootFromParent_Done,
     /* 2125204 */   // Label 28107: @2125204
     /* 2125204 */   GIM_Try, /*On fail goto*//*Label 28108*/ GIMT_Encode4(2125295), // Rule ID 17120 //
     /* 2125209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2125212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2125217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2125220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2125223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2125226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125255 */     // MIs[0] round
     /* 2125255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125258 */     // MIs[0] policy
     /* 2125258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125268 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2125271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125294 */     // GIR_Coverage, 17120,
     /* 2125294 */     GIR_EraseRootFromParent_Done,
     /* 2125295 */   // Label 28108: @2125295
     /* 2125295 */   GIM_Try, /*On fail goto*//*Label 28109*/ GIMT_Encode4(2125386), // Rule ID 17121 //
     /* 2125300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2125308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2125311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2125314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2125317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125323 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125346 */     // MIs[0] round
     /* 2125346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125349 */     // MIs[0] policy
     /* 2125349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125359 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2125362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125372 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125382 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125385 */     // GIR_Coverage, 17121,
     /* 2125385 */     GIR_EraseRootFromParent_Done,
     /* 2125386 */   // Label 28109: @2125386
     /* 2125386 */   GIM_Try, /*On fail goto*//*Label 28110*/ GIMT_Encode4(2125477), // Rule ID 17124 //
     /* 2125391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2125394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2125399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2125402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2125405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2125408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2125421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125437 */     // MIs[0] round
     /* 2125437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125440 */     // MIs[0] policy
     /* 2125440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125450 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2125453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125476 */     // GIR_Coverage, 17124,
     /* 2125476 */     GIR_EraseRootFromParent_Done,
     /* 2125477 */   // Label 28110: @2125477
     /* 2125477 */   GIM_Try, /*On fail goto*//*Label 28111*/ GIMT_Encode4(2125568), // Rule ID 17125 //
     /* 2125482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2125490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2125493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2125496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2125499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125505 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2125512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125528 */     // MIs[0] round
     /* 2125528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125531 */     // MIs[0] policy
     /* 2125531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125541 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2125544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125554 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125564 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125567 */     // GIR_Coverage, 17125,
     /* 2125567 */     GIR_EraseRootFromParent_Done,
     /* 2125568 */   // Label 28111: @2125568
     /* 2125568 */   GIM_Try, /*On fail goto*//*Label 28112*/ GIMT_Encode4(2125659), // Rule ID 17128 //
     /* 2125573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2125576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2125581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2125584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2125587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2125590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125619 */     // MIs[0] round
     /* 2125619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125622 */     // MIs[0] policy
     /* 2125622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125632 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2125635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125658 */     // GIR_Coverage, 17128,
     /* 2125658 */     GIR_EraseRootFromParent_Done,
     /* 2125659 */   // Label 28112: @2125659
     /* 2125659 */   GIM_Try, /*On fail goto*//*Label 28113*/ GIMT_Encode4(2125750), // Rule ID 17129 //
     /* 2125664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2125672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2125675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2125678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2125681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125687 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125710 */     // MIs[0] round
     /* 2125710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125713 */     // MIs[0] policy
     /* 2125713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125723 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2125726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125736 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125746 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125749 */     // GIR_Coverage, 17129,
     /* 2125749 */     GIR_EraseRootFromParent_Done,
     /* 2125750 */   // Label 28113: @2125750
     /* 2125750 */   GIM_Try, /*On fail goto*//*Label 28114*/ GIMT_Encode4(2125841), // Rule ID 17132 //
     /* 2125755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2125758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2125763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2125766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2125769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2125772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125801 */     // MIs[0] round
     /* 2125801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125804 */     // MIs[0] policy
     /* 2125804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125814 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2125817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125837 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125840 */     // GIR_Coverage, 17132,
     /* 2125840 */     GIR_EraseRootFromParent_Done,
     /* 2125841 */   // Label 28114: @2125841
     /* 2125841 */   GIM_Try, /*On fail goto*//*Label 28115*/ GIMT_Encode4(2125932), // Rule ID 17133 //
     /* 2125846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2125854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2125857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2125860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2125863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125869 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125892 */     // MIs[0] round
     /* 2125892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125895 */     // MIs[0] policy
     /* 2125895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125905 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2125908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125931 */     // GIR_Coverage, 17133,
     /* 2125931 */     GIR_EraseRootFromParent_Done,
     /* 2125932 */   // Label 28115: @2125932
     /* 2125932 */   GIM_Try, /*On fail goto*//*Label 28116*/ GIMT_Encode4(2126023), // Rule ID 17142 //
     /* 2125937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2125948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2125951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2125954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2125957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125983 */     // MIs[0] round
     /* 2125983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125986 */     // MIs[0] policy
     /* 2125986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125996 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2125999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126022 */     // GIR_Coverage, 17142,
     /* 2126022 */     GIR_EraseRootFromParent_Done,
     /* 2126023 */   // Label 28116: @2126023
     /* 2126023 */   GIM_Try, /*On fail goto*//*Label 28117*/ GIMT_Encode4(2126114), // Rule ID 17143 //
     /* 2126028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2126036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2126039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2126042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2126045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2126048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126051 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126074 */     // MIs[0] round
     /* 2126074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126077 */     // MIs[0] policy
     /* 2126077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126087 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2126090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126100 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126110 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126113 */     // GIR_Coverage, 17143,
     /* 2126113 */     GIR_EraseRootFromParent_Done,
     /* 2126114 */   // Label 28117: @2126114
     /* 2126114 */   GIM_Try, /*On fail goto*//*Label 28118*/ GIMT_Encode4(2126205), // Rule ID 17152 //
     /* 2126119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2126122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2126127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2126130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2126133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2126136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2126139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126165 */     // MIs[0] round
     /* 2126165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126168 */     // MIs[0] policy
     /* 2126168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126178 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2126181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126204 */     // GIR_Coverage, 17152,
     /* 2126204 */     GIR_EraseRootFromParent_Done,
     /* 2126205 */   // Label 28118: @2126205
     /* 2126205 */   GIM_Try, /*On fail goto*//*Label 28119*/ GIMT_Encode4(2126296), // Rule ID 17153 //
     /* 2126210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2126218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2126221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2126224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2126227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2126230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126233 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126256 */     // MIs[0] round
     /* 2126256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126259 */     // MIs[0] policy
     /* 2126259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126269 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2126272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126282 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126292 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126295 */     // GIR_Coverage, 17153,
     /* 2126295 */     GIR_EraseRootFromParent_Done,
     /* 2126296 */   // Label 28119: @2126296
     /* 2126296 */   GIM_Try, /*On fail goto*//*Label 28120*/ GIMT_Encode4(2126387), // Rule ID 17162 //
     /* 2126301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2126304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2126309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2126312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2126315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2126318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2126321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126347 */     // MIs[0] round
     /* 2126347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126350 */     // MIs[0] policy
     /* 2126350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126360 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2126363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126386 */     // GIR_Coverage, 17162,
     /* 2126386 */     GIR_EraseRootFromParent_Done,
     /* 2126387 */   // Label 28120: @2126387
     /* 2126387 */   GIM_Try, /*On fail goto*//*Label 28121*/ GIMT_Encode4(2126478), // Rule ID 17163 //
     /* 2126392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2126400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2126403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2126406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2126409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2126412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126438 */     // MIs[0] round
     /* 2126438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126441 */     // MIs[0] policy
     /* 2126441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126451 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2126454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126477 */     // GIR_Coverage, 17163,
     /* 2126477 */     GIR_EraseRootFromParent_Done,
     /* 2126478 */   // Label 28121: @2126478
     /* 2126478 */   GIM_Try, /*On fail goto*//*Label 28122*/ GIMT_Encode4(2126569), // Rule ID 17172 //
     /* 2126483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2126486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2126491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2126494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2126497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2126500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2126503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2126506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126529 */     // MIs[0] round
     /* 2126529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126532 */     // MIs[0] policy
     /* 2126532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126542 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2126545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126568 */     // GIR_Coverage, 17172,
     /* 2126568 */     GIR_EraseRootFromParent_Done,
     /* 2126569 */   // Label 28122: @2126569
     /* 2126569 */   GIM_Try, /*On fail goto*//*Label 28123*/ GIMT_Encode4(2126660), // Rule ID 17173 //
     /* 2126574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2126582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2126585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2126588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2126591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2126594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2126597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126620 */     // MIs[0] round
     /* 2126620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126623 */     // MIs[0] policy
     /* 2126623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126633 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2126636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126646 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126656 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126659 */     // GIR_Coverage, 17173,
     /* 2126659 */     GIR_EraseRootFromParent_Done,
     /* 2126660 */   // Label 28123: @2126660
     /* 2126660 */   GIM_Try, /*On fail goto*//*Label 28124*/ GIMT_Encode4(2126751), // Rule ID 17182 //
     /* 2126665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2126673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2126676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2126679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2126682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2126685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126711 */     // MIs[0] round
     /* 2126711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126714 */     // MIs[0] policy
     /* 2126714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126724 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2126727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126750 */     // GIR_Coverage, 17182,
     /* 2126750 */     GIR_EraseRootFromParent_Done,
     /* 2126751 */   // Label 28124: @2126751
     /* 2126751 */   GIM_Try, /*On fail goto*//*Label 28125*/ GIMT_Encode4(2126842), // Rule ID 17183 //
     /* 2126756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2126764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2126767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2126770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2126773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2126776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126779 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126802 */     // MIs[0] round
     /* 2126802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126805 */     // MIs[0] policy
     /* 2126805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126815 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2126818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126841 */     // GIR_Coverage, 17183,
     /* 2126841 */     GIR_EraseRootFromParent_Done,
     /* 2126842 */   // Label 28125: @2126842
     /* 2126842 */   GIM_Try, /*On fail goto*//*Label 28126*/ GIMT_Encode4(2126933), // Rule ID 17192 //
     /* 2126847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2126855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2126858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2126861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2126864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2126867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126893 */     // MIs[0] round
     /* 2126893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126896 */     // MIs[0] policy
     /* 2126896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126906 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2126909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126932 */     // GIR_Coverage, 17192,
     /* 2126932 */     GIR_EraseRootFromParent_Done,
     /* 2126933 */   // Label 28126: @2126933
     /* 2126933 */   GIM_Try, /*On fail goto*//*Label 28127*/ GIMT_Encode4(2127024), // Rule ID 17193 //
     /* 2126938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2126946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2126949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2126952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2126955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2126958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126961 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126984 */     // MIs[0] round
     /* 2126984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126987 */     // MIs[0] policy
     /* 2126987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126997 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2127000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127023 */     // GIR_Coverage, 17193,
     /* 2127023 */     GIR_EraseRootFromParent_Done,
     /* 2127024 */   // Label 28127: @2127024
     /* 2127024 */   GIM_Try, /*On fail goto*//*Label 28128*/ GIMT_Encode4(2127115), // Rule ID 17202 //
     /* 2127029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2127032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2127037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2127040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2127043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2127046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2127049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127075 */     // MIs[0] round
     /* 2127075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127078 */     // MIs[0] policy
     /* 2127078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127088 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2127091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127114 */     // GIR_Coverage, 17202,
     /* 2127114 */     GIR_EraseRootFromParent_Done,
     /* 2127115 */   // Label 28128: @2127115
     /* 2127115 */   GIM_Try, /*On fail goto*//*Label 28129*/ GIMT_Encode4(2127206), // Rule ID 17203 //
     /* 2127120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2127123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2127128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2127131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2127134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2127137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2127140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127143 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127166 */     // MIs[0] round
     /* 2127166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127169 */     // MIs[0] policy
     /* 2127169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127179 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2127182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127202 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127205 */     // GIR_Coverage, 17203,
     /* 2127205 */     GIR_EraseRootFromParent_Done,
     /* 2127206 */   // Label 28129: @2127206
     /* 2127206 */   GIM_Try, /*On fail goto*//*Label 28130*/ GIMT_Encode4(2127297), // Rule ID 17212 //
     /* 2127211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2127214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2127219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2127222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2127225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2127228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2127231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2127241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127257 */     // MIs[0] round
     /* 2127257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127260 */     // MIs[0] policy
     /* 2127260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127270 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2127273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127296 */     // GIR_Coverage, 17212,
     /* 2127296 */     GIR_EraseRootFromParent_Done,
     /* 2127297 */   // Label 28130: @2127297
     /* 2127297 */   GIM_Try, /*On fail goto*//*Label 28131*/ GIMT_Encode4(2127388), // Rule ID 17213 //
     /* 2127302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2127305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2127310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2127313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2127316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2127319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2127322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2127332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127348 */     // MIs[0] round
     /* 2127348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127351 */     // MIs[0] policy
     /* 2127351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127361 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2127364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127387 */     // GIR_Coverage, 17213,
     /* 2127387 */     GIR_EraseRootFromParent_Done,
     /* 2127388 */   // Label 28131: @2127388
     /* 2127388 */   GIM_Try, /*On fail goto*//*Label 28132*/ GIMT_Encode4(2127479), // Rule ID 17216 //
     /* 2127393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2127401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2127404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2127407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2127410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127439 */     // MIs[0] round
     /* 2127439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127442 */     // MIs[0] policy
     /* 2127442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127452 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2127455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127478 */     // GIR_Coverage, 17216,
     /* 2127478 */     GIR_EraseRootFromParent_Done,
     /* 2127479 */   // Label 28132: @2127479
     /* 2127479 */   GIM_Try, /*On fail goto*//*Label 28133*/ GIMT_Encode4(2127570), // Rule ID 17217 //
     /* 2127484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2127492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2127495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2127498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2127501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127530 */     // MIs[0] round
     /* 2127530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127533 */     // MIs[0] policy
     /* 2127533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127543 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2127546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127566 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127569 */     // GIR_Coverage, 17217,
     /* 2127569 */     GIR_EraseRootFromParent_Done,
     /* 2127570 */   // Label 28133: @2127570
     /* 2127570 */   GIM_Try, /*On fail goto*//*Label 28134*/ GIMT_Encode4(2127661), // Rule ID 17220 //
     /* 2127575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2127583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2127586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2127589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2127592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127621 */     // MIs[0] round
     /* 2127621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127624 */     // MIs[0] policy
     /* 2127624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127634 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2127637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127660 */     // GIR_Coverage, 17220,
     /* 2127660 */     GIR_EraseRootFromParent_Done,
     /* 2127661 */   // Label 28134: @2127661
     /* 2127661 */   GIM_Try, /*On fail goto*//*Label 28135*/ GIMT_Encode4(2127752), // Rule ID 17221 //
     /* 2127666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2127674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2127677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2127680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2127683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127712 */     // MIs[0] round
     /* 2127712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127715 */     // MIs[0] policy
     /* 2127715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127725 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2127728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127751 */     // GIR_Coverage, 17221,
     /* 2127751 */     GIR_EraseRootFromParent_Done,
     /* 2127752 */   // Label 28135: @2127752
     /* 2127752 */   GIM_Try, /*On fail goto*//*Label 28136*/ GIMT_Encode4(2127843), // Rule ID 17224 //
     /* 2127757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2127765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2127768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2127771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2127774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127803 */     // MIs[0] round
     /* 2127803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127806 */     // MIs[0] policy
     /* 2127806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127816 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2127819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127842 */     // GIR_Coverage, 17224,
     /* 2127842 */     GIR_EraseRootFromParent_Done,
     /* 2127843 */   // Label 28136: @2127843
     /* 2127843 */   GIM_Try, /*On fail goto*//*Label 28137*/ GIMT_Encode4(2127934), // Rule ID 17225 //
     /* 2127848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2127856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2127859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2127862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2127865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127894 */     // MIs[0] round
     /* 2127894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127897 */     // MIs[0] policy
     /* 2127897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127907 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2127910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127933 */     // GIR_Coverage, 17225,
     /* 2127933 */     GIR_EraseRootFromParent_Done,
     /* 2127934 */   // Label 28137: @2127934
     /* 2127934 */   GIM_Try, /*On fail goto*//*Label 28138*/ GIMT_Encode4(2128025), // Rule ID 17228 //
     /* 2127939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2127947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2127950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2127953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2127956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127985 */     // MIs[0] round
     /* 2127985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127988 */     // MIs[0] policy
     /* 2127988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127998 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2128001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128024 */     // GIR_Coverage, 17228,
     /* 2128024 */     GIR_EraseRootFromParent_Done,
     /* 2128025 */   // Label 28138: @2128025
     /* 2128025 */   GIM_Try, /*On fail goto*//*Label 28139*/ GIMT_Encode4(2128116), // Rule ID 17229 //
     /* 2128030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2128033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2128038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2128041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2128044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2128047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2128050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2128072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128076 */     // MIs[0] round
     /* 2128076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128079 */     // MIs[0] policy
     /* 2128079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128089 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2128092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128115 */     // GIR_Coverage, 17229,
     /* 2128115 */     GIR_EraseRootFromParent_Done,
     /* 2128116 */   // Label 28139: @2128116
     /* 2128116 */   GIM_Try, /*On fail goto*//*Label 28140*/ GIMT_Encode4(2128207), // Rule ID 17232 //
     /* 2128121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2128124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2128129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2128132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2128135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2128138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2128141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2128144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2128163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128167 */     // MIs[0] round
     /* 2128167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128170 */     // MIs[0] policy
     /* 2128170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128180 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2128183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128206 */     // GIR_Coverage, 17232,
     /* 2128206 */     GIR_EraseRootFromParent_Done,
     /* 2128207 */   // Label 28140: @2128207
     /* 2128207 */   GIM_Try, /*On fail goto*//*Label 28141*/ GIMT_Encode4(2128298), // Rule ID 17233 //
     /* 2128212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2128215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2128220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2128223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2128226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2128229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2128232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2128235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2128254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128258 */     // MIs[0] round
     /* 2128258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128261 */     // MIs[0] policy
     /* 2128261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128271 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2128274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128297 */     // GIR_Coverage, 17233,
     /* 2128297 */     GIR_EraseRootFromParent_Done,
     /* 2128298 */   // Label 28141: @2128298
     /* 2128298 */   GIM_Try, /*On fail goto*//*Label 28142*/ GIMT_Encode4(2128389), // Rule ID 17236 //
     /* 2128303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2128311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2128314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2128317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2128320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128349 */     // MIs[0] round
     /* 2128349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128352 */     // MIs[0] policy
     /* 2128352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128362 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2128365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128388 */     // GIR_Coverage, 17236,
     /* 2128388 */     GIR_EraseRootFromParent_Done,
     /* 2128389 */   // Label 28142: @2128389
     /* 2128389 */   GIM_Try, /*On fail goto*//*Label 28143*/ GIMT_Encode4(2128480), // Rule ID 17237 //
     /* 2128394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2128402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2128405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2128408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2128411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128417 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128440 */     // MIs[0] round
     /* 2128440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128443 */     // MIs[0] policy
     /* 2128443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128453 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2128456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128479 */     // GIR_Coverage, 17237,
     /* 2128479 */     GIR_EraseRootFromParent_Done,
     /* 2128480 */   // Label 28143: @2128480
     /* 2128480 */   GIM_Try, /*On fail goto*//*Label 28144*/ GIMT_Encode4(2128571), // Rule ID 17240 //
     /* 2128485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2128493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2128496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2128499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2128502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2128515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128531 */     // MIs[0] round
     /* 2128531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128534 */     // MIs[0] policy
     /* 2128534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128544 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2128547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128570 */     // GIR_Coverage, 17240,
     /* 2128570 */     GIR_EraseRootFromParent_Done,
     /* 2128571 */   // Label 28144: @2128571
     /* 2128571 */   GIM_Try, /*On fail goto*//*Label 28145*/ GIMT_Encode4(2128662), // Rule ID 17241 //
     /* 2128576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2128584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2128587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2128590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2128593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2128606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128622 */     // MIs[0] round
     /* 2128622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128625 */     // MIs[0] policy
     /* 2128625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128635 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2128638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128661 */     // GIR_Coverage, 17241,
     /* 2128661 */     GIR_EraseRootFromParent_Done,
     /* 2128662 */   // Label 28145: @2128662
     /* 2128662 */   GIM_Try, /*On fail goto*//*Label 28146*/ GIMT_Encode4(2128753), // Rule ID 17244 //
     /* 2128667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2128675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2128678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2128681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2128684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128713 */     // MIs[0] round
     /* 2128713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128716 */     // MIs[0] policy
     /* 2128716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128726 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2128729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128752 */     // GIR_Coverage, 17244,
     /* 2128752 */     GIR_EraseRootFromParent_Done,
     /* 2128753 */   // Label 28146: @2128753
     /* 2128753 */   GIM_Try, /*On fail goto*//*Label 28147*/ GIMT_Encode4(2128844), // Rule ID 17245 //
     /* 2128758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2128766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2128769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2128772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2128775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128804 */     // MIs[0] round
     /* 2128804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128807 */     // MIs[0] policy
     /* 2128807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128817 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2128820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128843 */     // GIR_Coverage, 17245,
     /* 2128843 */     GIR_EraseRootFromParent_Done,
     /* 2128844 */   // Label 28147: @2128844
     /* 2128844 */   GIM_Try, /*On fail goto*//*Label 28148*/ GIMT_Encode4(2128935), // Rule ID 17248 //
     /* 2128849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2128857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2128860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2128863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2128866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128895 */     // MIs[0] round
     /* 2128895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128898 */     // MIs[0] policy
     /* 2128898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128908 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2128911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128934 */     // GIR_Coverage, 17248,
     /* 2128934 */     GIR_EraseRootFromParent_Done,
     /* 2128935 */   // Label 28148: @2128935
     /* 2128935 */   GIM_Try, /*On fail goto*//*Label 28149*/ GIMT_Encode4(2129026), // Rule ID 17249 //
     /* 2128940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2128948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2128951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2128954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2128957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128986 */     // MIs[0] round
     /* 2128986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128989 */     // MIs[0] policy
     /* 2128989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128999 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2129002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129025 */     // GIR_Coverage, 17249,
     /* 2129025 */     GIR_EraseRootFromParent_Done,
     /* 2129026 */   // Label 28149: @2129026
     /* 2129026 */   GIM_Try, /*On fail goto*//*Label 28150*/ GIMT_Encode4(2129117), // Rule ID 17258 //
     /* 2129031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2129034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2129039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2129042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2129045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2129048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2129051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129077 */     // MIs[0] round
     /* 2129077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129080 */     // MIs[0] policy
     /* 2129080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129090 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2129093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129116 */     // GIR_Coverage, 17258,
     /* 2129116 */     GIR_EraseRootFromParent_Done,
     /* 2129117 */   // Label 28150: @2129117
     /* 2129117 */   GIM_Try, /*On fail goto*//*Label 28151*/ GIMT_Encode4(2129208), // Rule ID 17259 //
     /* 2129122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2129125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2129130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2129133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2129136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2129139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2129142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129168 */     // MIs[0] round
     /* 2129168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129171 */     // MIs[0] policy
     /* 2129171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129181 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2129184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129207 */     // GIR_Coverage, 17259,
     /* 2129207 */     GIR_EraseRootFromParent_Done,
     /* 2129208 */   // Label 28151: @2129208
     /* 2129208 */   GIM_Try, /*On fail goto*//*Label 28152*/ GIMT_Encode4(2129299), // Rule ID 17268 //
     /* 2129213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2129216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2129221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2129224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2129227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2129230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2129233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129259 */     // MIs[0] round
     /* 2129259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129262 */     // MIs[0] policy
     /* 2129262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129272 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2129275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129298 */     // GIR_Coverage, 17268,
     /* 2129298 */     GIR_EraseRootFromParent_Done,
     /* 2129299 */   // Label 28152: @2129299
     /* 2129299 */   GIM_Try, /*On fail goto*//*Label 28153*/ GIMT_Encode4(2129390), // Rule ID 17269 //
     /* 2129304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2129307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2129312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2129315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2129318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2129321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2129324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129350 */     // MIs[0] round
     /* 2129350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129353 */     // MIs[0] policy
     /* 2129353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129363 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2129366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129389 */     // GIR_Coverage, 17269,
     /* 2129389 */     GIR_EraseRootFromParent_Done,
     /* 2129390 */   // Label 28153: @2129390
     /* 2129390 */   GIM_Try, /*On fail goto*//*Label 28154*/ GIMT_Encode4(2129481), // Rule ID 17278 //
     /* 2129395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2129398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2129403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2129406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2129409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2129412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2129415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2129425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129441 */     // MIs[0] round
     /* 2129441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129444 */     // MIs[0] policy
     /* 2129444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129454 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2129457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129480 */     // GIR_Coverage, 17278,
     /* 2129480 */     GIR_EraseRootFromParent_Done,
     /* 2129481 */   // Label 28154: @2129481
     /* 2129481 */   GIM_Try, /*On fail goto*//*Label 28155*/ GIMT_Encode4(2129572), // Rule ID 17279 //
     /* 2129486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2129489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2129494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2129497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2129500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2129503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2129506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2129516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129532 */     // MIs[0] round
     /* 2129532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129535 */     // MIs[0] policy
     /* 2129535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129545 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2129548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129571 */     // GIR_Coverage, 17279,
     /* 2129571 */     GIR_EraseRootFromParent_Done,
     /* 2129572 */   // Label 28155: @2129572
     /* 2129572 */   GIM_Try, /*On fail goto*//*Label 28156*/ GIMT_Encode4(2129663), // Rule ID 17288 //
     /* 2129577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2129580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2129585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2129588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2129591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2129594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2129597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2129600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2129607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129623 */     // MIs[0] round
     /* 2129623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129626 */     // MIs[0] policy
     /* 2129626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129636 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2129639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129662 */     // GIR_Coverage, 17288,
     /* 2129662 */     GIR_EraseRootFromParent_Done,
     /* 2129663 */   // Label 28156: @2129663
     /* 2129663 */   GIM_Try, /*On fail goto*//*Label 28157*/ GIMT_Encode4(2129754), // Rule ID 17289 //
     /* 2129668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2129671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2129676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2129679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2129682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2129685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2129688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2129691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2129698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129714 */     // MIs[0] round
     /* 2129714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129717 */     // MIs[0] policy
     /* 2129717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129727 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2129730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129753 */     // GIR_Coverage, 17289,
     /* 2129753 */     GIR_EraseRootFromParent_Done,
     /* 2129754 */   // Label 28157: @2129754
     /* 2129754 */   GIM_Try, /*On fail goto*//*Label 28158*/ GIMT_Encode4(2129845), // Rule ID 17298 //
     /* 2129759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2129762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2129767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2129770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2129773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2129776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2129779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2129782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2129789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129805 */     // MIs[0] round
     /* 2129805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129808 */     // MIs[0] policy
     /* 2129808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129818 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2129821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129844 */     // GIR_Coverage, 17298,
     /* 2129844 */     GIR_EraseRootFromParent_Done,
     /* 2129845 */   // Label 28158: @2129845
     /* 2129845 */   GIM_Try, /*On fail goto*//*Label 28159*/ GIMT_Encode4(2129936), // Rule ID 17299 //
     /* 2129850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2129853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2129858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2129861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2129864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2129867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2129870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2129873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2129880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129896 */     // MIs[0] round
     /* 2129896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129899 */     // MIs[0] policy
     /* 2129899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129909 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2129912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129935 */     // GIR_Coverage, 17299,
     /* 2129935 */     GIR_EraseRootFromParent_Done,
     /* 2129936 */   // Label 28159: @2129936
     /* 2129936 */   GIM_Try, /*On fail goto*//*Label 28160*/ GIMT_Encode4(2130027), // Rule ID 17308 //
     /* 2129941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2129944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2129949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2129952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2129955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2129958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2129961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129987 */     // MIs[0] round
     /* 2129987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129990 */     // MIs[0] policy
     /* 2129990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130000 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2130003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130026 */     // GIR_Coverage, 17308,
     /* 2130026 */     GIR_EraseRootFromParent_Done,
     /* 2130027 */   // Label 28160: @2130027
     /* 2130027 */   GIM_Try, /*On fail goto*//*Label 28161*/ GIMT_Encode4(2130118), // Rule ID 17309 //
     /* 2130032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2130035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2130040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2130043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2130046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2130049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2130052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2130055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130078 */     // MIs[0] round
     /* 2130078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130081 */     // MIs[0] policy
     /* 2130081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130091 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2130094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130117 */     // GIR_Coverage, 17309,
     /* 2130117 */     GIR_EraseRootFromParent_Done,
     /* 2130118 */   // Label 28161: @2130118
     /* 2130118 */   GIM_Try, /*On fail goto*//*Label 28162*/ GIMT_Encode4(2130209), // Rule ID 17318 //
     /* 2130123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2130126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2130131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2130134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2130137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2130140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2130143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2130146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130169 */     // MIs[0] round
     /* 2130169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130172 */     // MIs[0] policy
     /* 2130172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130182 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2130185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130208 */     // GIR_Coverage, 17318,
     /* 2130208 */     GIR_EraseRootFromParent_Done,
     /* 2130209 */   // Label 28162: @2130209
     /* 2130209 */   GIM_Try, /*On fail goto*//*Label 28163*/ GIMT_Encode4(2130300), // Rule ID 17319 //
     /* 2130214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2130217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2130222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2130225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2130228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2130231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2130234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2130237 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130260 */     // MIs[0] round
     /* 2130260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130263 */     // MIs[0] policy
     /* 2130263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130273 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2130276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130299 */     // GIR_Coverage, 17319,
     /* 2130299 */     GIR_EraseRootFromParent_Done,
     /* 2130300 */   // Label 28163: @2130300
     /* 2130300 */   GIM_Try, /*On fail goto*//*Label 28164*/ GIMT_Encode4(2130391), // Rule ID 17328 //
     /* 2130305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2130308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2130313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2130316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2130319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2130322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2130325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130351 */     // MIs[0] round
     /* 2130351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130354 */     // MIs[0] policy
     /* 2130354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130364 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2130367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130390 */     // GIR_Coverage, 17328,
     /* 2130390 */     GIR_EraseRootFromParent_Done,
     /* 2130391 */   // Label 28164: @2130391
     /* 2130391 */   GIM_Try, /*On fail goto*//*Label 28165*/ GIMT_Encode4(2130482), // Rule ID 17329 //
     /* 2130396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2130399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2130404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2130407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2130410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2130413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2130416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130442 */     // MIs[0] round
     /* 2130442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130445 */     // MIs[0] policy
     /* 2130445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130455 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2130458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130481 */     // GIR_Coverage, 17329,
     /* 2130481 */     GIR_EraseRootFromParent_Done,
     /* 2130482 */   // Label 28165: @2130482
     /* 2130482 */   GIM_Try, /*On fail goto*//*Label 28166*/ GIMT_Encode4(2130573), // Rule ID 17338 //
     /* 2130487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2130490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2130495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2130498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2130501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2130504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2130507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130533 */     // MIs[0] round
     /* 2130533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130536 */     // MIs[0] policy
     /* 2130536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130546 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2130549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130572 */     // GIR_Coverage, 17338,
     /* 2130572 */     GIR_EraseRootFromParent_Done,
     /* 2130573 */   // Label 28166: @2130573
     /* 2130573 */   GIM_Try, /*On fail goto*//*Label 28167*/ GIMT_Encode4(2130664), // Rule ID 17339 //
     /* 2130578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2130581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2130586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2130589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2130592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2130595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2130598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130601 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130624 */     // MIs[0] round
     /* 2130624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130627 */     // MIs[0] policy
     /* 2130627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130637 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2130640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130663 */     // GIR_Coverage, 17339,
     /* 2130663 */     GIR_EraseRootFromParent_Done,
     /* 2130664 */   // Label 28167: @2130664
     /* 2130664 */   GIM_Try, /*On fail goto*//*Label 28168*/ GIMT_Encode4(2130755), // Rule ID 17342 //
     /* 2130669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2130672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2130677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2130680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2130683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2130686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2130689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2130692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2130711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130715 */     // MIs[0] round
     /* 2130715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130718 */     // MIs[0] policy
     /* 2130718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130728 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2130731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130754 */     // GIR_Coverage, 17342,
     /* 2130754 */     GIR_EraseRootFromParent_Done,
     /* 2130755 */   // Label 28168: @2130755
     /* 2130755 */   GIM_Try, /*On fail goto*//*Label 28169*/ GIMT_Encode4(2130846), // Rule ID 17343 //
     /* 2130760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2130763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2130768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2130771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2130774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2130777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2130780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2130783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2130802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130806 */     // MIs[0] round
     /* 2130806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130809 */     // MIs[0] policy
     /* 2130809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130819 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2130822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130845 */     // GIR_Coverage, 17343,
     /* 2130845 */     GIR_EraseRootFromParent_Done,
     /* 2130846 */   // Label 28169: @2130846
     /* 2130846 */   GIM_Try, /*On fail goto*//*Label 28170*/ GIMT_Encode4(2130937), // Rule ID 17346 //
     /* 2130851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2130854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2130859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2130862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2130865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2130868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2130871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2130874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2130893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130897 */     // MIs[0] round
     /* 2130897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130900 */     // MIs[0] policy
     /* 2130900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130910 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2130913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130936 */     // GIR_Coverage, 17346,
     /* 2130936 */     GIR_EraseRootFromParent_Done,
     /* 2130937 */   // Label 28170: @2130937
     /* 2130937 */   GIM_Try, /*On fail goto*//*Label 28171*/ GIMT_Encode4(2131028), // Rule ID 17347 //
     /* 2130942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2130945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2130950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2130953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2130956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2130959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2130962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2130965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2130984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130988 */     // MIs[0] round
     /* 2130988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130991 */     // MIs[0] policy
     /* 2130991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131001 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2131004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131027 */     // GIR_Coverage, 17347,
     /* 2131027 */     GIR_EraseRootFromParent_Done,
     /* 2131028 */   // Label 28171: @2131028
     /* 2131028 */   GIM_Try, /*On fail goto*//*Label 28172*/ GIMT_Encode4(2131119), // Rule ID 17350 //
     /* 2131033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2131036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2131041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2131044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2131047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2131050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2131063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131079 */     // MIs[0] round
     /* 2131079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131082 */     // MIs[0] policy
     /* 2131082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131092 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2131095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131118 */     // GIR_Coverage, 17350,
     /* 2131118 */     GIR_EraseRootFromParent_Done,
     /* 2131119 */   // Label 28172: @2131119
     /* 2131119 */   GIM_Try, /*On fail goto*//*Label 28173*/ GIMT_Encode4(2131210), // Rule ID 17351 //
     /* 2131124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2131127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2131132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2131135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2131138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2131141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2131154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131170 */     // MIs[0] round
     /* 2131170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131173 */     // MIs[0] policy
     /* 2131173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131183 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2131186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131209 */     // GIR_Coverage, 17351,
     /* 2131209 */     GIR_EraseRootFromParent_Done,
     /* 2131210 */   // Label 28173: @2131210
     /* 2131210 */   GIM_Try, /*On fail goto*//*Label 28174*/ GIMT_Encode4(2131301), // Rule ID 17354 //
     /* 2131215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2131218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2131223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2131226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2131229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2131232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2131245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131261 */     // MIs[0] round
     /* 2131261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131264 */     // MIs[0] policy
     /* 2131264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131274 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2131277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131300 */     // GIR_Coverage, 17354,
     /* 2131300 */     GIR_EraseRootFromParent_Done,
     /* 2131301 */   // Label 28174: @2131301
     /* 2131301 */   GIM_Try, /*On fail goto*//*Label 28175*/ GIMT_Encode4(2131392), // Rule ID 17355 //
     /* 2131306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2131309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2131314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2131317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2131320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2131323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2131336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131352 */     // MIs[0] round
     /* 2131352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131355 */     // MIs[0] policy
     /* 2131355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131365 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2131368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131391 */     // GIR_Coverage, 17355,
     /* 2131391 */     GIR_EraseRootFromParent_Done,
     /* 2131392 */   // Label 28175: @2131392
     /* 2131392 */   GIM_Try, /*On fail goto*//*Label 28176*/ GIMT_Encode4(2131483), // Rule ID 17358 //
     /* 2131397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2131400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2131405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2131408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2131411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2131414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2131420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131443 */     // MIs[0] round
     /* 2131443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131446 */     // MIs[0] policy
     /* 2131446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131456 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2131459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131482 */     // GIR_Coverage, 17358,
     /* 2131482 */     GIR_EraseRootFromParent_Done,
     /* 2131483 */   // Label 28176: @2131483
     /* 2131483 */   GIM_Try, /*On fail goto*//*Label 28177*/ GIMT_Encode4(2131574), // Rule ID 17359 //
     /* 2131488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2131491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2131496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2131499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2131502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2131505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2131511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131534 */     // MIs[0] round
     /* 2131534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131537 */     // MIs[0] policy
     /* 2131537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131547 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2131550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131573 */     // GIR_Coverage, 17359,
     /* 2131573 */     GIR_EraseRootFromParent_Done,
     /* 2131574 */   // Label 28177: @2131574
     /* 2131574 */   GIM_Try, /*On fail goto*//*Label 28178*/ GIMT_Encode4(2131665), // Rule ID 17362 //
     /* 2131579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2131582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2131587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2131590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2131593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2131596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131625 */     // MIs[0] round
     /* 2131625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131628 */     // MIs[0] policy
     /* 2131628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131638 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2131641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131664 */     // GIR_Coverage, 17362,
     /* 2131664 */     GIR_EraseRootFromParent_Done,
     /* 2131665 */   // Label 28178: @2131665
     /* 2131665 */   GIM_Try, /*On fail goto*//*Label 28179*/ GIMT_Encode4(2131756), // Rule ID 17363 //
     /* 2131670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2131673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2131678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2131681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2131684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2131687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131716 */     // MIs[0] round
     /* 2131716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131719 */     // MIs[0] policy
     /* 2131719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131729 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2131732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131755 */     // GIR_Coverage, 17363,
     /* 2131755 */     GIR_EraseRootFromParent_Done,
     /* 2131756 */   // Label 28179: @2131756
     /* 2131756 */   GIM_Try, /*On fail goto*//*Label 28180*/ GIMT_Encode4(2131847), // Rule ID 17366 //
     /* 2131761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2131764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2131769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2131772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2131775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2131778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2131791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131807 */     // MIs[0] round
     /* 2131807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131810 */     // MIs[0] policy
     /* 2131810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131820 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2131823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131846 */     // GIR_Coverage, 17366,
     /* 2131846 */     GIR_EraseRootFromParent_Done,
     /* 2131847 */   // Label 28180: @2131847
     /* 2131847 */   GIM_Try, /*On fail goto*//*Label 28181*/ GIMT_Encode4(2131938), // Rule ID 17367 //
     /* 2131852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2131855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2131860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2131863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2131866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2131869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2131882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131898 */     // MIs[0] round
     /* 2131898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131901 */     // MIs[0] policy
     /* 2131901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131911 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2131914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131937 */     // GIR_Coverage, 17367,
     /* 2131937 */     GIR_EraseRootFromParent_Done,
     /* 2131938 */   // Label 28181: @2131938
     /* 2131938 */   GIM_Try, /*On fail goto*//*Label 28182*/ GIMT_Encode4(2132029), // Rule ID 17370 //
     /* 2131943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2131946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2131951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2131954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2131957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2131960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2131973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131989 */     // MIs[0] round
     /* 2131989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131992 */     // MIs[0] policy
     /* 2131992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132002 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2132005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132028 */     // GIR_Coverage, 17370,
     /* 2132028 */     GIR_EraseRootFromParent_Done,
     /* 2132029 */   // Label 28182: @2132029
     /* 2132029 */   GIM_Try, /*On fail goto*//*Label 28183*/ GIMT_Encode4(2132120), // Rule ID 17371 //
     /* 2132034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2132037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2132042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2132045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2132048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2132051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2132064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132080 */     // MIs[0] round
     /* 2132080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132083 */     // MIs[0] policy
     /* 2132083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132093 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2132096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132119 */     // GIR_Coverage, 17371,
     /* 2132119 */     GIR_EraseRootFromParent_Done,
     /* 2132120 */   // Label 28183: @2132120
     /* 2132120 */   GIM_Try, /*On fail goto*//*Label 28184*/ GIMT_Encode4(2132211), // Rule ID 17374 //
     /* 2132125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2132128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2132133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2132136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2132139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2132142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2132155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132171 */     // MIs[0] round
     /* 2132171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132174 */     // MIs[0] policy
     /* 2132174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132184 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2132187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132210 */     // GIR_Coverage, 17374,
     /* 2132210 */     GIR_EraseRootFromParent_Done,
     /* 2132211 */   // Label 28184: @2132211
     /* 2132211 */   GIM_Try, /*On fail goto*//*Label 28185*/ GIMT_Encode4(2132302), // Rule ID 17375 //
     /* 2132216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2132219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2132224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2132227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2132230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2132233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2132246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132262 */     // MIs[0] round
     /* 2132262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132265 */     // MIs[0] policy
     /* 2132265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132275 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2132278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132301 */     // GIR_Coverage, 17375,
     /* 2132301 */     GIR_EraseRootFromParent_Done,
     /* 2132302 */   // Label 28185: @2132302
     /* 2132302 */   GIM_Try, /*On fail goto*//*Label 28186*/ GIMT_Encode4(2132393), // Rule ID 17378 //
     /* 2132307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2132318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2132321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2132324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2132327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132353 */     // MIs[0] round
     /* 2132353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132356 */     // MIs[0] policy
     /* 2132356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132366 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2132369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132392 */     // GIR_Coverage, 17378,
     /* 2132392 */     GIR_EraseRootFromParent_Done,
     /* 2132393 */   // Label 28186: @2132393
     /* 2132393 */   GIM_Try, /*On fail goto*//*Label 28187*/ GIMT_Encode4(2132484), // Rule ID 17379 //
     /* 2132398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2132409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2132412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2132415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2132418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132444 */     // MIs[0] round
     /* 2132444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132447 */     // MIs[0] policy
     /* 2132447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132457 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2132460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132483 */     // GIR_Coverage, 17379,
     /* 2132483 */     GIR_EraseRootFromParent_Done,
     /* 2132484 */   // Label 28187: @2132484
     /* 2132484 */   GIM_Try, /*On fail goto*//*Label 28188*/ GIMT_Encode4(2132575), // Rule ID 17382 //
     /* 2132489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2132500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2132503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2132506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2132509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132535 */     // MIs[0] round
     /* 2132535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132538 */     // MIs[0] policy
     /* 2132538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132548 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2132551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132574 */     // GIR_Coverage, 17382,
     /* 2132574 */     GIR_EraseRootFromParent_Done,
     /* 2132575 */   // Label 28188: @2132575
     /* 2132575 */   GIM_Try, /*On fail goto*//*Label 28189*/ GIMT_Encode4(2132666), // Rule ID 17383 //
     /* 2132580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2132591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2132594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2132597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2132600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132626 */     // MIs[0] round
     /* 2132626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132629 */     // MIs[0] policy
     /* 2132629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132639 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2132642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132665 */     // GIR_Coverage, 17383,
     /* 2132665 */     GIR_EraseRootFromParent_Done,
     /* 2132666 */   // Label 28189: @2132666
     /* 2132666 */   GIM_Try, /*On fail goto*//*Label 28190*/ GIMT_Encode4(2132757), // Rule ID 17386 //
     /* 2132671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2132674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2132682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2132691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132717 */     // MIs[0] round
     /* 2132717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132720 */     // MIs[0] policy
     /* 2132720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132730 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2132733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132756 */     // GIR_Coverage, 17386,
     /* 2132756 */     GIR_EraseRootFromParent_Done,
     /* 2132757 */   // Label 28190: @2132757
     /* 2132757 */   GIM_Try, /*On fail goto*//*Label 28191*/ GIMT_Encode4(2132848), // Rule ID 17387 //
     /* 2132762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2132765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2132773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2132782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132808 */     // MIs[0] round
     /* 2132808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132811 */     // MIs[0] policy
     /* 2132811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132821 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2132824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132834 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132844 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132847 */     // GIR_Coverage, 17387,
     /* 2132847 */     GIR_EraseRootFromParent_Done,
     /* 2132848 */   // Label 28191: @2132848
     /* 2132848 */   GIM_Try, /*On fail goto*//*Label 28192*/ GIMT_Encode4(2132939), // Rule ID 17390 //
     /* 2132853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2132864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2132867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2132870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2132873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132899 */     // MIs[0] round
     /* 2132899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132902 */     // MIs[0] policy
     /* 2132902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132912 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2132915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132938 */     // GIR_Coverage, 17390,
     /* 2132938 */     GIR_EraseRootFromParent_Done,
     /* 2132939 */   // Label 28192: @2132939
     /* 2132939 */   GIM_Try, /*On fail goto*//*Label 28193*/ GIMT_Encode4(2133030), // Rule ID 17391 //
     /* 2132944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2132955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2132958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2132961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2132964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132990 */     // MIs[0] round
     /* 2132990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132993 */     // MIs[0] policy
     /* 2132993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133003 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2133006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133029 */     // GIR_Coverage, 17391,
     /* 2133029 */     GIR_EraseRootFromParent_Done,
     /* 2133030 */   // Label 28193: @2133030
     /* 2133030 */   GIM_Try, /*On fail goto*//*Label 28194*/ GIMT_Encode4(2133121), // Rule ID 17394 //
     /* 2133035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2133038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2133046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2133049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2133052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2133055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133081 */     // MIs[0] round
     /* 2133081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133084 */     // MIs[0] policy
     /* 2133084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133094 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2133097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133120 */     // GIR_Coverage, 17394,
     /* 2133120 */     GIR_EraseRootFromParent_Done,
     /* 2133121 */   // Label 28194: @2133121
     /* 2133121 */   GIM_Try, /*On fail goto*//*Label 28195*/ GIMT_Encode4(2133212), // Rule ID 17395 //
     /* 2133126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2133129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2133137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2133140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2133143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2133146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133172 */     // MIs[0] round
     /* 2133172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133175 */     // MIs[0] policy
     /* 2133175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133185 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2133188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133211 */     // GIR_Coverage, 17395,
     /* 2133211 */     GIR_EraseRootFromParent_Done,
     /* 2133212 */   // Label 28195: @2133212
     /* 2133212 */   GIM_Try, /*On fail goto*//*Label 28196*/ GIMT_Encode4(2133303), // Rule ID 17398 //
     /* 2133217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2133220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2133228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2133231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2133234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2133237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2133240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133263 */     // MIs[0] round
     /* 2133263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133266 */     // MIs[0] policy
     /* 2133266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133276 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2133279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133302 */     // GIR_Coverage, 17398,
     /* 2133302 */     GIR_EraseRootFromParent_Done,
     /* 2133303 */   // Label 28196: @2133303
     /* 2133303 */   GIM_Try, /*On fail goto*//*Label 28197*/ GIMT_Encode4(2133394), // Rule ID 17399 //
     /* 2133308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2133311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2133319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2133322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2133325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2133328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2133331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133354 */     // MIs[0] round
     /* 2133354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133357 */     // MIs[0] policy
     /* 2133357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133367 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2133370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133393 */     // GIR_Coverage, 17399,
     /* 2133393 */     GIR_EraseRootFromParent_Done,
     /* 2133394 */   // Label 28197: @2133394
     /* 2133394 */   GIM_Try, /*On fail goto*//*Label 28198*/ GIMT_Encode4(2133485), // Rule ID 17402 //
     /* 2133399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2133402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2133410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2133413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2133416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2133419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133445 */     // MIs[0] round
     /* 2133445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133448 */     // MIs[0] policy
     /* 2133448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133458 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2133461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133484 */     // GIR_Coverage, 17402,
     /* 2133484 */     GIR_EraseRootFromParent_Done,
     /* 2133485 */   // Label 28198: @2133485
     /* 2133485 */   GIM_Try, /*On fail goto*//*Label 28199*/ GIMT_Encode4(2133576), // Rule ID 17403 //
     /* 2133490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2133493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2133501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2133504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2133507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2133510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133536 */     // MIs[0] round
     /* 2133536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133539 */     // MIs[0] policy
     /* 2133539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133549 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2133552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133575 */     // GIR_Coverage, 17403,
     /* 2133575 */     GIR_EraseRootFromParent_Done,
     /* 2133576 */   // Label 28199: @2133576
     /* 2133576 */   GIM_Try, /*On fail goto*//*Label 28200*/ GIMT_Encode4(2133667), // Rule ID 17406 //
     /* 2133581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2133584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2133592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2133595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2133598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2133601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133627 */     // MIs[0] round
     /* 2133627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133630 */     // MIs[0] policy
     /* 2133630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133640 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2133643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133666 */     // GIR_Coverage, 17406,
     /* 2133666 */     GIR_EraseRootFromParent_Done,
     /* 2133667 */   // Label 28200: @2133667
     /* 2133667 */   GIM_Try, /*On fail goto*//*Label 28201*/ GIMT_Encode4(2133758), // Rule ID 17407 //
     /* 2133672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2133675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2133683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2133686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2133689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2133692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133695 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133718 */     // MIs[0] round
     /* 2133718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133721 */     // MIs[0] policy
     /* 2133721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133731 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2133734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133757 */     // GIR_Coverage, 17407,
     /* 2133757 */     GIR_EraseRootFromParent_Done,
     /* 2133758 */   // Label 28201: @2133758
     /* 2133758 */   GIM_Try, /*On fail goto*//*Label 28202*/ GIMT_Encode4(2133849), // Rule ID 17410 //
     /* 2133763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2133766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2133774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2133777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2133780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2133783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2133786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133809 */     // MIs[0] round
     /* 2133809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133812 */     // MIs[0] policy
     /* 2133812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133822 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2133825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133848 */     // GIR_Coverage, 17410,
     /* 2133848 */     GIR_EraseRootFromParent_Done,
     /* 2133849 */   // Label 28202: @2133849
     /* 2133849 */   GIM_Try, /*On fail goto*//*Label 28203*/ GIMT_Encode4(2133940), // Rule ID 17411 //
     /* 2133854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2133857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2133865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2133868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2133871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2133874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2133877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133900 */     // MIs[0] round
     /* 2133900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133903 */     // MIs[0] policy
     /* 2133903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133913 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2133916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133939 */     // GIR_Coverage, 17411,
     /* 2133939 */     GIR_EraseRootFromParent_Done,
     /* 2133940 */   // Label 28203: @2133940
     /* 2133940 */   GIM_Try, /*On fail goto*//*Label 28204*/ GIMT_Encode4(2134031), // Rule ID 17414 //
     /* 2133945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2133948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2133956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2133959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2133962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2133965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2133968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133991 */     // MIs[0] round
     /* 2133991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133994 */     // MIs[0] policy
     /* 2133994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134004 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2134007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134030 */     // GIR_Coverage, 17414,
     /* 2134030 */     GIR_EraseRootFromParent_Done,
     /* 2134031 */   // Label 28204: @2134031
     /* 2134031 */   GIM_Try, /*On fail goto*//*Label 28205*/ GIMT_Encode4(2134122), // Rule ID 17415 //
     /* 2134036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2134047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2134050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2134053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2134056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2134066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134082 */     // MIs[0] round
     /* 2134082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134085 */     // MIs[0] policy
     /* 2134085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134095 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2134098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134121 */     // GIR_Coverage, 17415,
     /* 2134121 */     GIR_EraseRootFromParent_Done,
     /* 2134122 */   // Label 28205: @2134122
     /* 2134122 */   GIM_Try, /*On fail goto*//*Label 28206*/ GIMT_Encode4(2134213), // Rule ID 17418 //
     /* 2134127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2134130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2134138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2134141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2134144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2134147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2134150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2134157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134173 */     // MIs[0] round
     /* 2134173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134176 */     // MIs[0] policy
     /* 2134176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134186 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2134189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134212 */     // GIR_Coverage, 17418,
     /* 2134212 */     GIR_EraseRootFromParent_Done,
     /* 2134213 */   // Label 28206: @2134213
     /* 2134213 */   GIM_Try, /*On fail goto*//*Label 28207*/ GIMT_Encode4(2134304), // Rule ID 17419 //
     /* 2134218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2134229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2134232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2134235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2134238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2134241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2134248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134264 */     // MIs[0] round
     /* 2134264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134267 */     // MIs[0] policy
     /* 2134267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134277 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2134280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134303 */     // GIR_Coverage, 17419,
     /* 2134303 */     GIR_EraseRootFromParent_Done,
     /* 2134304 */   // Label 28207: @2134304
     /* 2134304 */   GIM_Try, /*On fail goto*//*Label 28208*/ GIMT_Encode4(2134395), // Rule ID 17422 //
     /* 2134309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2134312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2134320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2134323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2134326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2134329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2134332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2134339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134355 */     // MIs[0] round
     /* 2134355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134358 */     // MIs[0] policy
     /* 2134358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134368 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2134371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134394 */     // GIR_Coverage, 17422,
     /* 2134394 */     GIR_EraseRootFromParent_Done,
     /* 2134395 */   // Label 28208: @2134395
     /* 2134395 */   GIM_Try, /*On fail goto*//*Label 28209*/ GIMT_Encode4(2134486), // Rule ID 17423 //
     /* 2134400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2134411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2134414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2134417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2134420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2134423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2134430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134446 */     // MIs[0] round
     /* 2134446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134449 */     // MIs[0] policy
     /* 2134449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134459 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2134462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134485 */     // GIR_Coverage, 17423,
     /* 2134485 */     GIR_EraseRootFromParent_Done,
     /* 2134486 */   // Label 28209: @2134486
     /* 2134486 */   GIM_Try, /*On fail goto*//*Label 28210*/ GIMT_Encode4(2134577), // Rule ID 17426 //
     /* 2134491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2134494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2134502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2134505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2134508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2134511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2134521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134537 */     // MIs[0] round
     /* 2134537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134540 */     // MIs[0] policy
     /* 2134540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134550 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2134553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134576 */     // GIR_Coverage, 17426,
     /* 2134576 */     GIR_EraseRootFromParent_Done,
     /* 2134577 */   // Label 28210: @2134577
     /* 2134577 */   GIM_Try, /*On fail goto*//*Label 28211*/ GIMT_Encode4(2134668), // Rule ID 17427 //
     /* 2134582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2134585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2134593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2134596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2134599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2134602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134605 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2134612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134628 */     // MIs[0] round
     /* 2134628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134631 */     // MIs[0] policy
     /* 2134631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134641 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2134644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134664 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134667 */     // GIR_Coverage, 17427,
     /* 2134667 */     GIR_EraseRootFromParent_Done,
     /* 2134668 */   // Label 28211: @2134668
     /* 2134668 */   GIM_Try, /*On fail goto*//*Label 28212*/ GIMT_Encode4(2134759), // Rule ID 17430 //
     /* 2134673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2134676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2134684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2134687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2134690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2134693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2134703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134719 */     // MIs[0] round
     /* 2134719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134722 */     // MIs[0] policy
     /* 2134722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134732 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2134735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134758 */     // GIR_Coverage, 17430,
     /* 2134758 */     GIR_EraseRootFromParent_Done,
     /* 2134759 */   // Label 28212: @2134759
     /* 2134759 */   GIM_Try, /*On fail goto*//*Label 28213*/ GIMT_Encode4(2134850), // Rule ID 17431 //
     /* 2134764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2134767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2134775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2134778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2134781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2134784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2134794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134810 */     // MIs[0] round
     /* 2134810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134813 */     // MIs[0] policy
     /* 2134813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134823 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2134826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134849 */     // GIR_Coverage, 17431,
     /* 2134849 */     GIR_EraseRootFromParent_Done,
     /* 2134850 */   // Label 28213: @2134850
     /* 2134850 */   GIM_Try, /*On fail goto*//*Label 28214*/ GIMT_Encode4(2134941), // Rule ID 17434 //
     /* 2134855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2134858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2134866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2134869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2134872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2134875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2134878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2134885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134901 */     // MIs[0] round
     /* 2134901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134904 */     // MIs[0] policy
     /* 2134904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134914 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2134917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134940 */     // GIR_Coverage, 17434,
     /* 2134940 */     GIR_EraseRootFromParent_Done,
     /* 2134941 */   // Label 28214: @2134941
     /* 2134941 */   GIM_Try, /*On fail goto*//*Label 28215*/ GIMT_Encode4(2135032), // Rule ID 17435 //
     /* 2134946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2134949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2134957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2134960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2134963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2134966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2134969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2134976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134992 */     // MIs[0] round
     /* 2134992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134995 */     // MIs[0] policy
     /* 2134995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135005 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2135008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135018 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135028 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135031 */     // GIR_Coverage, 17435,
     /* 2135031 */     GIR_EraseRootFromParent_Done,
     /* 2135032 */   // Label 28215: @2135032
     /* 2135032 */   GIM_Try, /*On fail goto*//*Label 28216*/ GIMT_Encode4(2135123), // Rule ID 17438 //
     /* 2135037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2135045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2135048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2135051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2135054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2135057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2135060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2135079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135083 */     // MIs[0] round
     /* 2135083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135086 */     // MIs[0] policy
     /* 2135086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135096 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2135099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135119 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135122 */     // GIR_Coverage, 17438,
     /* 2135122 */     GIR_EraseRootFromParent_Done,
     /* 2135123 */   // Label 28216: @2135123
     /* 2135123 */   GIM_Try, /*On fail goto*//*Label 28217*/ GIMT_Encode4(2135214), // Rule ID 17439 //
     /* 2135128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2135136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2135139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2135142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2135145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2135148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2135151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2135170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135174 */     // MIs[0] round
     /* 2135174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135177 */     // MIs[0] policy
     /* 2135177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135187 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2135190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135213 */     // GIR_Coverage, 17439,
     /* 2135213 */     GIR_EraseRootFromParent_Done,
     /* 2135214 */   // Label 28217: @2135214
     /* 2135214 */   GIM_Try, /*On fail goto*//*Label 28218*/ GIMT_Encode4(2135305), // Rule ID 17442 //
     /* 2135219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2135227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2135230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2135233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2135236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2135239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2135242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2135261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135265 */     // MIs[0] round
     /* 2135265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135268 */     // MIs[0] policy
     /* 2135268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135278 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2135281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135304 */     // GIR_Coverage, 17442,
     /* 2135304 */     GIR_EraseRootFromParent_Done,
     /* 2135305 */   // Label 28218: @2135305
     /* 2135305 */   GIM_Try, /*On fail goto*//*Label 28219*/ GIMT_Encode4(2135396), // Rule ID 17443 //
     /* 2135310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2135318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2135321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2135324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2135327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2135330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2135333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2135352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135356 */     // MIs[0] round
     /* 2135356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135359 */     // MIs[0] policy
     /* 2135359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135369 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2135372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135395 */     // GIR_Coverage, 17443,
     /* 2135395 */     GIR_EraseRootFromParent_Done,
     /* 2135396 */   // Label 28219: @2135396
     /* 2135396 */   GIM_Try, /*On fail goto*//*Label 28220*/ GIMT_Encode4(2135487), // Rule ID 17446 //
     /* 2135401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2135404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2135409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2135412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2135415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2135418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2135421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2135424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2135443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135447 */     // MIs[0] round
     /* 2135447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135450 */     // MIs[0] policy
     /* 2135450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135460 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2135463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135486 */     // GIR_Coverage, 17446,
     /* 2135486 */     GIR_EraseRootFromParent_Done,
     /* 2135487 */   // Label 28220: @2135487
     /* 2135487 */   GIM_Try, /*On fail goto*//*Label 28221*/ GIMT_Encode4(2135578), // Rule ID 17447 //
     /* 2135492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2135495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2135500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2135503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2135506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2135509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2135512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2135515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2135534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135538 */     // MIs[0] round
     /* 2135538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135541 */     // MIs[0] policy
     /* 2135541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135551 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2135554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135577 */     // GIR_Coverage, 17447,
     /* 2135577 */     GIR_EraseRootFromParent_Done,
     /* 2135578 */   // Label 28221: @2135578
     /* 2135578 */   GIM_Try, /*On fail goto*//*Label 28222*/ GIMT_Encode4(2135669), // Rule ID 17450 //
     /* 2135583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2135591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2135594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2135597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2135600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2135603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2135606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2135625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135629 */     // MIs[0] round
     /* 2135629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135632 */     // MIs[0] policy
     /* 2135632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135642 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2135645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135668 */     // GIR_Coverage, 17450,
     /* 2135668 */     GIR_EraseRootFromParent_Done,
     /* 2135669 */   // Label 28222: @2135669
     /* 2135669 */   GIM_Try, /*On fail goto*//*Label 28223*/ GIMT_Encode4(2135760), // Rule ID 17451 //
     /* 2135674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2135682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2135685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2135688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2135691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2135694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2135697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2135716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135720 */     // MIs[0] round
     /* 2135720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135723 */     // MIs[0] policy
     /* 2135723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135733 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2135736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135759 */     // GIR_Coverage, 17451,
     /* 2135759 */     GIR_EraseRootFromParent_Done,
     /* 2135760 */   // Label 28223: @2135760
     /* 2135760 */   GIM_Try, /*On fail goto*//*Label 28224*/ GIMT_Encode4(2135851), // Rule ID 17454 //
     /* 2135765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2135768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2135773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2135776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2135779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2135782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2135785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2135788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2135807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135811 */     // MIs[0] round
     /* 2135811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135814 */     // MIs[0] policy
     /* 2135814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135824 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2135827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135850 */     // GIR_Coverage, 17454,
     /* 2135850 */     GIR_EraseRootFromParent_Done,
     /* 2135851 */   // Label 28224: @2135851
     /* 2135851 */   GIM_Try, /*On fail goto*//*Label 28225*/ GIMT_Encode4(2135942), // Rule ID 17455 //
     /* 2135856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2135859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2135864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2135867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2135870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2135873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2135876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2135879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2135898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135902 */     // MIs[0] round
     /* 2135902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135905 */     // MIs[0] policy
     /* 2135905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135915 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2135918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135941 */     // GIR_Coverage, 17455,
     /* 2135941 */     GIR_EraseRootFromParent_Done,
     /* 2135942 */   // Label 28225: @2135942
     /* 2135942 */   GIM_Try, /*On fail goto*//*Label 28226*/ GIMT_Encode4(2136033), // Rule ID 17458 //
     /* 2135947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2135950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2135955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2135958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2135961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2135964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2135967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2135970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2135989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135993 */     // MIs[0] round
     /* 2135993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135996 */     // MIs[0] policy
     /* 2135996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136006 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2136009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136032 */     // GIR_Coverage, 17458,
     /* 2136032 */     GIR_EraseRootFromParent_Done,
     /* 2136033 */   // Label 28226: @2136033
     /* 2136033 */   GIM_Try, /*On fail goto*//*Label 28227*/ GIMT_Encode4(2136124), // Rule ID 17459 //
     /* 2136038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2136046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2136049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2136052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2136055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2136058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2136061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2136080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136084 */     // MIs[0] round
     /* 2136084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136087 */     // MIs[0] policy
     /* 2136087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136097 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2136100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136123 */     // GIR_Coverage, 17459,
     /* 2136123 */     GIR_EraseRootFromParent_Done,
     /* 2136124 */   // Label 28227: @2136124
     /* 2136124 */   GIM_Try, /*On fail goto*//*Label 28228*/ GIMT_Encode4(2136215), // Rule ID 17462 //
     /* 2136129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2136132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2136137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2136140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2136143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2136146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136175 */     // MIs[0] round
     /* 2136175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136178 */     // MIs[0] policy
     /* 2136178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136188 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2136191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136214 */     // GIR_Coverage, 17462,
     /* 2136214 */     GIR_EraseRootFromParent_Done,
     /* 2136215 */   // Label 28228: @2136215
     /* 2136215 */   GIM_Try, /*On fail goto*//*Label 28229*/ GIMT_Encode4(2136306), // Rule ID 17463 //
     /* 2136220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2136223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2136228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2136231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2136234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2136237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136266 */     // MIs[0] round
     /* 2136266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136269 */     // MIs[0] policy
     /* 2136269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136279 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2136282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136305 */     // GIR_Coverage, 17463,
     /* 2136305 */     GIR_EraseRootFromParent_Done,
     /* 2136306 */   // Label 28229: @2136306
     /* 2136306 */   GIM_Try, /*On fail goto*//*Label 28230*/ GIMT_Encode4(2136397), // Rule ID 17466 //
     /* 2136311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2136314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2136319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2136322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2136325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2136328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2136334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136357 */     // MIs[0] round
     /* 2136357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136360 */     // MIs[0] policy
     /* 2136360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136370 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2136373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136396 */     // GIR_Coverage, 17466,
     /* 2136396 */     GIR_EraseRootFromParent_Done,
     /* 2136397 */   // Label 28230: @2136397
     /* 2136397 */   GIM_Try, /*On fail goto*//*Label 28231*/ GIMT_Encode4(2136488), // Rule ID 17467 //
     /* 2136402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2136405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2136410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2136413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2136416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2136419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2136425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136448 */     // MIs[0] round
     /* 2136448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136451 */     // MIs[0] policy
     /* 2136451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136461 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2136464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136487 */     // GIR_Coverage, 17467,
     /* 2136487 */     GIR_EraseRootFromParent_Done,
     /* 2136488 */   // Label 28231: @2136488
     /* 2136488 */   GIM_Try, /*On fail goto*//*Label 28232*/ GIMT_Encode4(2136579), // Rule ID 17470 //
     /* 2136493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2136496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2136501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2136504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2136507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2136510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2136516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136539 */     // MIs[0] round
     /* 2136539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136542 */     // MIs[0] policy
     /* 2136542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136552 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2136555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136578 */     // GIR_Coverage, 17470,
     /* 2136578 */     GIR_EraseRootFromParent_Done,
     /* 2136579 */   // Label 28232: @2136579
     /* 2136579 */   GIM_Try, /*On fail goto*//*Label 28233*/ GIMT_Encode4(2136670), // Rule ID 17471 //
     /* 2136584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2136587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2136592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2136595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2136598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2136601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2136607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136630 */     // MIs[0] round
     /* 2136630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136633 */     // MIs[0] policy
     /* 2136633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136643 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2136646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136669 */     // GIR_Coverage, 17471,
     /* 2136669 */     GIR_EraseRootFromParent_Done,
     /* 2136670 */   // Label 28233: @2136670
     /* 2136670 */   GIM_Try, /*On fail goto*//*Label 28234*/ GIMT_Encode4(2136761), // Rule ID 17474 //
     /* 2136675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2136678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2136683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2136686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2136689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2136692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2136695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2136717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136721 */     // MIs[0] round
     /* 2136721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136724 */     // MIs[0] policy
     /* 2136724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136734 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2136737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136760 */     // GIR_Coverage, 17474,
     /* 2136760 */     GIR_EraseRootFromParent_Done,
     /* 2136761 */   // Label 28234: @2136761
     /* 2136761 */   GIM_Try, /*On fail goto*//*Label 28235*/ GIMT_Encode4(2136852), // Rule ID 17475 //
     /* 2136766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2136769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2136774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2136777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2136780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2136783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2136786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136789 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2136808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136812 */     // MIs[0] round
     /* 2136812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136815 */     // MIs[0] policy
     /* 2136815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136825 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2136828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136851 */     // GIR_Coverage, 17475,
     /* 2136851 */     GIR_EraseRootFromParent_Done,
     /* 2136852 */   // Label 28235: @2136852
     /* 2136852 */   GIM_Try, /*On fail goto*//*Label 28236*/ GIMT_Encode4(2136943), // Rule ID 17478 //
     /* 2136857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2136860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2136865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2136868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2136871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2136874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2136877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2136899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136903 */     // MIs[0] round
     /* 2136903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136906 */     // MIs[0] policy
     /* 2136906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136916 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2136919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136942 */     // GIR_Coverage, 17478,
     /* 2136942 */     GIR_EraseRootFromParent_Done,
     /* 2136943 */   // Label 28236: @2136943
     /* 2136943 */   GIM_Try, /*On fail goto*//*Label 28237*/ GIMT_Encode4(2137034), // Rule ID 17479 //
     /* 2136948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2136951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2136956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2136959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2136962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2136965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2136968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2136990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136994 */     // MIs[0] round
     /* 2136994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136997 */     // MIs[0] policy
     /* 2136997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137007 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2137010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137033 */     // GIR_Coverage, 17479,
     /* 2137033 */     GIR_EraseRootFromParent_Done,
     /* 2137034 */   // Label 28237: @2137034
     /* 2137034 */   GIM_Try, /*On fail goto*//*Label 28238*/ GIMT_Encode4(2137125), // Rule ID 17482 //
     /* 2137039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2137042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2137047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2137050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2137053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2137056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2137062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2137069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137085 */     // MIs[0] round
     /* 2137085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137088 */     // MIs[0] policy
     /* 2137088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137098 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2137101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137124 */     // GIR_Coverage, 17482,
     /* 2137124 */     GIR_EraseRootFromParent_Done,
     /* 2137125 */   // Label 28238: @2137125
     /* 2137125 */   GIM_Try, /*On fail goto*//*Label 28239*/ GIMT_Encode4(2137216), // Rule ID 17483 //
     /* 2137130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2137133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2137138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2137141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2137144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2137147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2137153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2137160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137176 */     // MIs[0] round
     /* 2137176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137179 */     // MIs[0] policy
     /* 2137179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137189 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2137192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137215 */     // GIR_Coverage, 17483,
     /* 2137215 */     GIR_EraseRootFromParent_Done,
     /* 2137216 */   // Label 28239: @2137216
     /* 2137216 */   GIM_Try, /*On fail goto*//*Label 28240*/ GIMT_Encode4(2137307), // Rule ID 17486 //
     /* 2137221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2137224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2137229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2137232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2137235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2137238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2137241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2137251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2137263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137267 */     // MIs[0] round
     /* 2137267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137270 */     // MIs[0] policy
     /* 2137270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137280 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2137283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137306 */     // GIR_Coverage, 17486,
     /* 2137306 */     GIR_EraseRootFromParent_Done,
     /* 2137307 */   // Label 28240: @2137307
     /* 2137307 */   GIM_Try, /*On fail goto*//*Label 28241*/ GIMT_Encode4(2137398), // Rule ID 17487 //
     /* 2137312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2137315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2137320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2137323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2137326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2137329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2137332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2137342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2137354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137358 */     // MIs[0] round
     /* 2137358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137361 */     // MIs[0] policy
     /* 2137361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137371 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2137374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137397 */     // GIR_Coverage, 17487,
     /* 2137397 */     GIR_EraseRootFromParent_Done,
     /* 2137398 */   // Label 28241: @2137398
     /* 2137398 */   GIM_Try, /*On fail goto*//*Label 28242*/ GIMT_Encode4(2137489), // Rule ID 17490 //
     /* 2137403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2137406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2137411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2137414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2137417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2137420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2137423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2137433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2137437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2137441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2137445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137449 */     // MIs[0] round
     /* 2137449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137452 */     // MIs[0] policy
     /* 2137452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137462 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2137465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137488 */     // GIR_Coverage, 17490,
     /* 2137488 */     GIR_EraseRootFromParent_Done,
     /* 2137489 */   // Label 28242: @2137489
     /* 2137489 */   GIM_Try, /*On fail goto*//*Label 28243*/ GIMT_Encode4(2137580), // Rule ID 17491 //
     /* 2137494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2137497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2137502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2137505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2137508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2137511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2137514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2137524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2137528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2137532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2137536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137540 */     // MIs[0] round
     /* 2137540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137543 */     // MIs[0] policy
     /* 2137543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137553 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2137556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137579 */     // GIR_Coverage, 17491,
     /* 2137579 */     GIR_EraseRootFromParent_Done,
     /* 2137580 */   // Label 28243: @2137580
     /* 2137580 */   GIM_Try, /*On fail goto*//*Label 28244*/ GIMT_Encode4(2137671), // Rule ID 17494 //
     /* 2137585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2137588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2137593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2137596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2137599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2137602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2137605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2137608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2137615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2137627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137631 */     // MIs[0] round
     /* 2137631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137634 */     // MIs[0] policy
     /* 2137634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137644 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2137647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137670 */     // GIR_Coverage, 17494,
     /* 2137670 */     GIR_EraseRootFromParent_Done,
     /* 2137671 */   // Label 28244: @2137671
     /* 2137671 */   GIM_Try, /*On fail goto*//*Label 28245*/ GIMT_Encode4(2137762), // Rule ID 17495 //
     /* 2137676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2137679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2137684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2137687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2137690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2137693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2137696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2137699 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2137706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2137718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137722 */     // MIs[0] round
     /* 2137722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137725 */     // MIs[0] policy
     /* 2137725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137735 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2137738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137761 */     // GIR_Coverage, 17495,
     /* 2137761 */     GIR_EraseRootFromParent_Done,
     /* 2137762 */   // Label 28245: @2137762
     /* 2137762 */   GIM_Try, /*On fail goto*//*Label 28246*/ GIMT_Encode4(2137853), // Rule ID 17498 //
     /* 2137767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2137778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2137781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2137784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2137787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137813 */     // MIs[0] round
     /* 2137813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137816 */     // MIs[0] policy
     /* 2137816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137826 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2137829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137852 */     // GIR_Coverage, 17498,
     /* 2137852 */     GIR_EraseRootFromParent_Done,
     /* 2137853 */   // Label 28246: @2137853
     /* 2137853 */   GIM_Try, /*On fail goto*//*Label 28247*/ GIMT_Encode4(2137944), // Rule ID 17499 //
     /* 2137858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2137861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2137869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2137872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2137875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2137878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137904 */     // MIs[0] round
     /* 2137904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137907 */     // MIs[0] policy
     /* 2137907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137917 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2137920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137943 */     // GIR_Coverage, 17499,
     /* 2137943 */     GIR_EraseRootFromParent_Done,
     /* 2137944 */   // Label 28247: @2137944
     /* 2137944 */   GIM_Try, /*On fail goto*//*Label 28248*/ GIMT_Encode4(2138035), // Rule ID 17502 //
     /* 2137949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2137960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2137963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2137966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2137969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137995 */     // MIs[0] round
     /* 2137995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137998 */     // MIs[0] policy
     /* 2137998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138008 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2138011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138034 */     // GIR_Coverage, 17502,
     /* 2138034 */     GIR_EraseRootFromParent_Done,
     /* 2138035 */   // Label 28248: @2138035
     /* 2138035 */   GIM_Try, /*On fail goto*//*Label 28249*/ GIMT_Encode4(2138126), // Rule ID 17503 //
     /* 2138040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2138051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2138054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2138057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2138060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2138063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138086 */     // MIs[0] round
     /* 2138086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138089 */     // MIs[0] policy
     /* 2138089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138099 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2138102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138125 */     // GIR_Coverage, 17503,
     /* 2138125 */     GIR_EraseRootFromParent_Done,
     /* 2138126 */   // Label 28249: @2138126
     /* 2138126 */   GIM_Try, /*On fail goto*//*Label 28250*/ GIMT_Encode4(2138217), // Rule ID 17506 //
     /* 2138131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2138142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2138145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2138148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2138151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2138154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138177 */     // MIs[0] round
     /* 2138177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138180 */     // MIs[0] policy
     /* 2138180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138190 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2138193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138216 */     // GIR_Coverage, 17506,
     /* 2138216 */     GIR_EraseRootFromParent_Done,
     /* 2138217 */   // Label 28250: @2138217
     /* 2138217 */   GIM_Try, /*On fail goto*//*Label 28251*/ GIMT_Encode4(2138308), // Rule ID 17507 //
     /* 2138222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2138233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2138236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2138239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2138242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2138245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138268 */     // MIs[0] round
     /* 2138268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138271 */     // MIs[0] policy
     /* 2138271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138281 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2138284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138307 */     // GIR_Coverage, 17507,
     /* 2138307 */     GIR_EraseRootFromParent_Done,
     /* 2138308 */   // Label 28251: @2138308
     /* 2138308 */   GIM_Try, /*On fail goto*//*Label 28252*/ GIMT_Encode4(2138399), // Rule ID 17510 //
     /* 2138313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2138316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2138324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2138327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2138330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2138333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138359 */     // MIs[0] round
     /* 2138359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138362 */     // MIs[0] policy
     /* 2138362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138372 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2138375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138398 */     // GIR_Coverage, 17510,
     /* 2138398 */     GIR_EraseRootFromParent_Done,
     /* 2138399 */   // Label 28252: @2138399
     /* 2138399 */   GIM_Try, /*On fail goto*//*Label 28253*/ GIMT_Encode4(2138490), // Rule ID 17511 //
     /* 2138404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2138415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2138418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2138421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2138424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138450 */     // MIs[0] round
     /* 2138450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138453 */     // MIs[0] policy
     /* 2138453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138463 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2138466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138489 */     // GIR_Coverage, 17511,
     /* 2138489 */     GIR_EraseRootFromParent_Done,
     /* 2138490 */   // Label 28253: @2138490
     /* 2138490 */   GIM_Try, /*On fail goto*//*Label 28254*/ GIMT_Encode4(2138581), // Rule ID 17514 //
     /* 2138495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2138506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2138509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2138512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2138515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2138518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138541 */     // MIs[0] round
     /* 2138541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138544 */     // MIs[0] policy
     /* 2138544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138554 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2138557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138580 */     // GIR_Coverage, 17514,
     /* 2138580 */     GIR_EraseRootFromParent_Done,
     /* 2138581 */   // Label 28254: @2138581
     /* 2138581 */   GIM_Try, /*On fail goto*//*Label 28255*/ GIMT_Encode4(2138672), // Rule ID 17515 //
     /* 2138586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2138597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2138600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2138603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2138606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2138609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138632 */     // MIs[0] round
     /* 2138632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138635 */     // MIs[0] policy
     /* 2138635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138645 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2138648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138671 */     // GIR_Coverage, 17515,
     /* 2138671 */     GIR_EraseRootFromParent_Done,
     /* 2138672 */   // Label 28255: @2138672
     /* 2138672 */   GIM_Try, /*On fail goto*//*Label 28256*/ GIMT_Encode4(2138763), // Rule ID 17518 //
     /* 2138677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2138680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2138688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2138691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2138694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2138697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2138700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138723 */     // MIs[0] round
     /* 2138723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138726 */     // MIs[0] policy
     /* 2138726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138736 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2138739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138762 */     // GIR_Coverage, 17518,
     /* 2138762 */     GIR_EraseRootFromParent_Done,
     /* 2138763 */   // Label 28256: @2138763
     /* 2138763 */   GIM_Try, /*On fail goto*//*Label 28257*/ GIMT_Encode4(2138854), // Rule ID 17519 //
     /* 2138768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2138771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2138779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2138782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2138785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2138788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2138791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138814 */     // MIs[0] round
     /* 2138814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138817 */     // MIs[0] policy
     /* 2138817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138827 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2138830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138853 */     // GIR_Coverage, 17519,
     /* 2138853 */     GIR_EraseRootFromParent_Done,
     /* 2138854 */   // Label 28257: @2138854
     /* 2138854 */   GIM_Try, /*On fail goto*//*Label 28258*/ GIMT_Encode4(2138945), // Rule ID 17522 //
     /* 2138859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2138862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2138870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2138873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2138876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2138879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138905 */     // MIs[0] round
     /* 2138905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138908 */     // MIs[0] policy
     /* 2138908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138918 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2138921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138944 */     // GIR_Coverage, 17522,
     /* 2138944 */     GIR_EraseRootFromParent_Done,
     /* 2138945 */   // Label 28258: @2138945
     /* 2138945 */   GIM_Try, /*On fail goto*//*Label 28259*/ GIMT_Encode4(2139036), // Rule ID 17523 //
     /* 2138950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2138961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2138964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2138967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2138970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138996 */     // MIs[0] round
     /* 2138996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138999 */     // MIs[0] policy
     /* 2138999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139009 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2139012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139035 */     // GIR_Coverage, 17523,
     /* 2139035 */     GIR_EraseRootFromParent_Done,
     /* 2139036 */   // Label 28259: @2139036
     /* 2139036 */   GIM_Try, /*On fail goto*//*Label 28260*/ GIMT_Encode4(2139127), // Rule ID 17526 //
     /* 2139041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2139052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2139055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2139058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2139061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2139064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139087 */     // MIs[0] round
     /* 2139087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139090 */     // MIs[0] policy
     /* 2139090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139100 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2139103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139126 */     // GIR_Coverage, 17526,
     /* 2139126 */     GIR_EraseRootFromParent_Done,
     /* 2139127 */   // Label 28260: @2139127
     /* 2139127 */   GIM_Try, /*On fail goto*//*Label 28261*/ GIMT_Encode4(2139218), // Rule ID 17527 //
     /* 2139132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2139135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2139143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2139146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2139149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2139152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2139155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139178 */     // MIs[0] round
     /* 2139178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139181 */     // MIs[0] policy
     /* 2139181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139191 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2139194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139217 */     // GIR_Coverage, 17527,
     /* 2139217 */     GIR_EraseRootFromParent_Done,
     /* 2139218 */   // Label 28261: @2139218
     /* 2139218 */   GIM_Try, /*On fail goto*//*Label 28262*/ GIMT_Encode4(2139309), // Rule ID 17530 //
     /* 2139223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2139234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2139237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2139240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2139243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2139246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139269 */     // MIs[0] round
     /* 2139269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139272 */     // MIs[0] policy
     /* 2139272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139282 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2139285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139308 */     // GIR_Coverage, 17530,
     /* 2139308 */     GIR_EraseRootFromParent_Done,
     /* 2139309 */   // Label 28262: @2139309
     /* 2139309 */   GIM_Try, /*On fail goto*//*Label 28263*/ GIMT_Encode4(2139400), // Rule ID 17531 //
     /* 2139314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2139317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2139325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2139328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2139331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2139334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2139337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139360 */     // MIs[0] round
     /* 2139360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139363 */     // MIs[0] policy
     /* 2139363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139373 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2139376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139399 */     // GIR_Coverage, 17531,
     /* 2139399 */     GIR_EraseRootFromParent_Done,
     /* 2139400 */   // Label 28263: @2139400
     /* 2139400 */   GIM_Try, /*On fail goto*//*Label 28264*/ GIMT_Encode4(2139491), // Rule ID 17534 //
     /* 2139405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2139408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2139416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2139419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2139422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2139425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2139435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139451 */     // MIs[0] round
     /* 2139451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139454 */     // MIs[0] policy
     /* 2139454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139464 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2139467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139490 */     // GIR_Coverage, 17534,
     /* 2139490 */     GIR_EraseRootFromParent_Done,
     /* 2139491 */   // Label 28264: @2139491
     /* 2139491 */   GIM_Try, /*On fail goto*//*Label 28265*/ GIMT_Encode4(2139582), // Rule ID 17535 //
     /* 2139496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2139499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2139507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2139510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2139513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2139516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2139526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139542 */     // MIs[0] round
     /* 2139542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139545 */     // MIs[0] policy
     /* 2139545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139555 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2139558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139581 */     // GIR_Coverage, 17535,
     /* 2139581 */     GIR_EraseRootFromParent_Done,
     /* 2139582 */   // Label 28265: @2139582
     /* 2139582 */   GIM_Try, /*On fail goto*//*Label 28266*/ GIMT_Encode4(2139673), // Rule ID 17538 //
     /* 2139587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2139590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2139598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2139601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2139604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2139607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139633 */     // MIs[0] round
     /* 2139633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139636 */     // MIs[0] policy
     /* 2139636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139646 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2139649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139672 */     // GIR_Coverage, 17538,
     /* 2139672 */     GIR_EraseRootFromParent_Done,
     /* 2139673 */   // Label 28266: @2139673
     /* 2139673 */   GIM_Try, /*On fail goto*//*Label 28267*/ GIMT_Encode4(2139764), // Rule ID 17539 //
     /* 2139678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2139681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2139689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2139692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2139695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2139698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139724 */     // MIs[0] round
     /* 2139724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139727 */     // MIs[0] policy
     /* 2139727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139737 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2139740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139763 */     // GIR_Coverage, 17539,
     /* 2139763 */     GIR_EraseRootFromParent_Done,
     /* 2139764 */   // Label 28267: @2139764
     /* 2139764 */   GIM_Try, /*On fail goto*//*Label 28268*/ GIMT_Encode4(2139855), // Rule ID 17542 //
     /* 2139769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2139772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2139780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2139783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2139786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2139789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2139792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139815 */     // MIs[0] round
     /* 2139815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139818 */     // MIs[0] policy
     /* 2139818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139828 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2139831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139854 */     // GIR_Coverage, 17542,
     /* 2139854 */     GIR_EraseRootFromParent_Done,
     /* 2139855 */   // Label 28268: @2139855
     /* 2139855 */   GIM_Try, /*On fail goto*//*Label 28269*/ GIMT_Encode4(2139946), // Rule ID 17543 //
     /* 2139860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2139863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2139871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2139874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2139877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2139880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2139883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139906 */     // MIs[0] round
     /* 2139906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139909 */     // MIs[0] policy
     /* 2139909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139919 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2139922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139945 */     // GIR_Coverage, 17543,
     /* 2139945 */     GIR_EraseRootFromParent_Done,
     /* 2139946 */   // Label 28269: @2139946
     /* 2139946 */   GIM_Try, /*On fail goto*//*Label 28270*/ GIMT_Encode4(2140037), // Rule ID 17546 //
     /* 2139951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2139962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2139965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2139968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2139971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2139981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139997 */     // MIs[0] round
     /* 2139997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140000 */     // MIs[0] policy
     /* 2140000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140010 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2140013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140036 */     // GIR_Coverage, 17546,
     /* 2140036 */     GIR_EraseRootFromParent_Done,
     /* 2140037 */   // Label 28270: @2140037
     /* 2140037 */   GIM_Try, /*On fail goto*//*Label 28271*/ GIMT_Encode4(2140128), // Rule ID 17547 //
     /* 2140042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2140045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2140050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2140053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2140056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2140059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2140062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2140072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140088 */     // MIs[0] round
     /* 2140088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140091 */     // MIs[0] policy
     /* 2140091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140101 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2140104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140127 */     // GIR_Coverage, 17547,
     /* 2140127 */     GIR_EraseRootFromParent_Done,
     /* 2140128 */   // Label 28271: @2140128
     /* 2140128 */   GIM_Try, /*On fail goto*//*Label 28272*/ GIMT_Encode4(2140219), // Rule ID 17550 //
     /* 2140133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2140136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2140141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2140144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2140147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2140150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2140153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2140156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2140163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140179 */     // MIs[0] round
     /* 2140179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140182 */     // MIs[0] policy
     /* 2140182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140192 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2140195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140218 */     // GIR_Coverage, 17550,
     /* 2140218 */     GIR_EraseRootFromParent_Done,
     /* 2140219 */   // Label 28272: @2140219
     /* 2140219 */   GIM_Try, /*On fail goto*//*Label 28273*/ GIMT_Encode4(2140310), // Rule ID 17551 //
     /* 2140224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2140227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2140232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2140235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2140238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2140241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2140244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2140247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2140254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140270 */     // MIs[0] round
     /* 2140270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140273 */     // MIs[0] policy
     /* 2140273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140283 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2140286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140296 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140306 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140309 */     // GIR_Coverage, 17551,
     /* 2140309 */     GIR_EraseRootFromParent_Done,
     /* 2140310 */   // Label 28273: @2140310
     /* 2140310 */   GIM_Try, /*On fail goto*//*Label 28274*/ GIMT_Encode4(2140401), // Rule ID 17554 //
     /* 2140315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2140318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2140323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2140326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2140329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2140332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2140335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2140345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140361 */     // MIs[0] round
     /* 2140361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140364 */     // MIs[0] policy
     /* 2140364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140374 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2140377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140400 */     // GIR_Coverage, 17554,
     /* 2140400 */     GIR_EraseRootFromParent_Done,
     /* 2140401 */   // Label 28274: @2140401
     /* 2140401 */   GIM_Try, /*On fail goto*//*Label 28275*/ GIMT_Encode4(2140492), // Rule ID 17555 //
     /* 2140406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2140409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2140414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2140417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2140420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2140423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2140426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2140436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140452 */     // MIs[0] round
     /* 2140452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140455 */     // MIs[0] policy
     /* 2140455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140465 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2140468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140491 */     // GIR_Coverage, 17555,
     /* 2140491 */     GIR_EraseRootFromParent_Done,
     /* 2140492 */   // Label 28275: @2140492
     /* 2140492 */   GIM_Try, /*On fail goto*//*Label 28276*/ GIMT_Encode4(2140583), // Rule ID 17558 //
     /* 2140497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2140505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2140508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2140511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2140514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140543 */     // MIs[0] round
     /* 2140543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140546 */     // MIs[0] policy
     /* 2140546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140556 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2140559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140582 */     // GIR_Coverage, 17558,
     /* 2140582 */     GIR_EraseRootFromParent_Done,
     /* 2140583 */   // Label 28276: @2140583
     /* 2140583 */   GIM_Try, /*On fail goto*//*Label 28277*/ GIMT_Encode4(2140674), // Rule ID 17559 //
     /* 2140588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2140596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2140599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2140602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2140605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140634 */     // MIs[0] round
     /* 2140634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140637 */     // MIs[0] policy
     /* 2140637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140647 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2140650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140673 */     // GIR_Coverage, 17559,
     /* 2140673 */     GIR_EraseRootFromParent_Done,
     /* 2140674 */   // Label 28277: @2140674
     /* 2140674 */   GIM_Try, /*On fail goto*//*Label 28278*/ GIMT_Encode4(2140765), // Rule ID 17562 //
     /* 2140679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2140687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2140690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2140693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2140696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140725 */     // MIs[0] round
     /* 2140725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140728 */     // MIs[0] policy
     /* 2140728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140738 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2140741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140764 */     // GIR_Coverage, 17562,
     /* 2140764 */     GIR_EraseRootFromParent_Done,
     /* 2140765 */   // Label 28278: @2140765
     /* 2140765 */   GIM_Try, /*On fail goto*//*Label 28279*/ GIMT_Encode4(2140856), // Rule ID 17563 //
     /* 2140770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2140778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2140781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2140784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2140787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140816 */     // MIs[0] round
     /* 2140816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140819 */     // MIs[0] policy
     /* 2140819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140829 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2140832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140855 */     // GIR_Coverage, 17563,
     /* 2140855 */     GIR_EraseRootFromParent_Done,
     /* 2140856 */   // Label 28279: @2140856
     /* 2140856 */   GIM_Try, /*On fail goto*//*Label 28280*/ GIMT_Encode4(2140947), // Rule ID 17566 //
     /* 2140861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2140864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2140869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2140872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2140875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2140878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140907 */     // MIs[0] round
     /* 2140907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140910 */     // MIs[0] policy
     /* 2140910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140920 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2140923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140946 */     // GIR_Coverage, 17566,
     /* 2140946 */     GIR_EraseRootFromParent_Done,
     /* 2140947 */   // Label 28280: @2140947
     /* 2140947 */   GIM_Try, /*On fail goto*//*Label 28281*/ GIMT_Encode4(2141038), // Rule ID 17567 //
     /* 2140952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2140955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2140960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2140963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2140966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2140969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140975 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140998 */     // MIs[0] round
     /* 2140998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141001 */     // MIs[0] policy
     /* 2141001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141011 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2141014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141037 */     // GIR_Coverage, 17567,
     /* 2141037 */     GIR_EraseRootFromParent_Done,
     /* 2141038 */   // Label 28281: @2141038
     /* 2141038 */   GIM_Try, /*On fail goto*//*Label 28282*/ GIMT_Encode4(2141129), // Rule ID 17570 //
     /* 2141043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2141046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2141051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2141054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2141057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2141060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141089 */     // MIs[0] round
     /* 2141089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141092 */     // MIs[0] policy
     /* 2141092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2141105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141128 */     // GIR_Coverage, 17570,
     /* 2141128 */     GIR_EraseRootFromParent_Done,
     /* 2141129 */   // Label 28282: @2141129
     /* 2141129 */   GIM_Try, /*On fail goto*//*Label 28283*/ GIMT_Encode4(2141220), // Rule ID 17571 //
     /* 2141134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2141137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2141142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2141145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2141148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2141151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141180 */     // MIs[0] round
     /* 2141180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141183 */     // MIs[0] policy
     /* 2141183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141193 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2141196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141206 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141216 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141219 */     // GIR_Coverage, 17571,
     /* 2141219 */     GIR_EraseRootFromParent_Done,
     /* 2141220 */   // Label 28283: @2141220
     /* 2141220 */   GIM_Try, /*On fail goto*//*Label 28284*/ GIMT_Encode4(2141311), // Rule ID 17574 //
     /* 2141225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2141233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2141236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2141239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2141242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2141248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141271 */     // MIs[0] round
     /* 2141271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141274 */     // MIs[0] policy
     /* 2141274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141284 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2141287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141307 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141310 */     // GIR_Coverage, 17574,
     /* 2141310 */     GIR_EraseRootFromParent_Done,
     /* 2141311 */   // Label 28284: @2141311
     /* 2141311 */   GIM_Try, /*On fail goto*//*Label 28285*/ GIMT_Encode4(2141402), // Rule ID 17575 //
     /* 2141316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2141324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2141327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2141330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2141333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2141339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141362 */     // MIs[0] round
     /* 2141362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141365 */     // MIs[0] policy
     /* 2141365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141375 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2141378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141401 */     // GIR_Coverage, 17575,
     /* 2141401 */     GIR_EraseRootFromParent_Done,
     /* 2141402 */   // Label 28285: @2141402
     /* 2141402 */   GIM_Try, /*On fail goto*//*Label 28286*/ GIMT_Encode4(2141493), // Rule ID 17578 //
     /* 2141407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2141410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2141415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2141418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2141421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2141424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2141427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2141430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2141449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141453 */     // MIs[0] round
     /* 2141453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141456 */     // MIs[0] policy
     /* 2141456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141466 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2141469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141492 */     // GIR_Coverage, 17578,
     /* 2141492 */     GIR_EraseRootFromParent_Done,
     /* 2141493 */   // Label 28286: @2141493
     /* 2141493 */   GIM_Try, /*On fail goto*//*Label 28287*/ GIMT_Encode4(2141584), // Rule ID 17579 //
     /* 2141498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2141501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2141506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2141509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2141512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2141515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2141518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2141521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2141540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141544 */     // MIs[0] round
     /* 2141544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141547 */     // MIs[0] policy
     /* 2141547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141557 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2141560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141583 */     // GIR_Coverage, 17579,
     /* 2141583 */     GIR_EraseRootFromParent_Done,
     /* 2141584 */   // Label 28287: @2141584
     /* 2141584 */   GIM_Try, /*On fail goto*//*Label 28288*/ GIMT_Encode4(2141675), // Rule ID 17582 //
     /* 2141589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2141592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2141597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2141600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2141603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2141606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141635 */     // MIs[0] round
     /* 2141635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141638 */     // MIs[0] policy
     /* 2141638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141648 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2141651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141674 */     // GIR_Coverage, 17582,
     /* 2141674 */     GIR_EraseRootFromParent_Done,
     /* 2141675 */   // Label 28288: @2141675
     /* 2141675 */   GIM_Try, /*On fail goto*//*Label 28289*/ GIMT_Encode4(2141766), // Rule ID 17583 //
     /* 2141680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2141683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2141688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2141691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2141694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2141697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141726 */     // MIs[0] round
     /* 2141726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141729 */     // MIs[0] policy
     /* 2141729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141739 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2141742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141765 */     // GIR_Coverage, 17583,
     /* 2141765 */     GIR_EraseRootFromParent_Done,
     /* 2141766 */   // Label 28289: @2141766
     /* 2141766 */   GIM_Try, /*On fail goto*//*Label 28290*/ GIMT_Encode4(2141857), // Rule ID 17586 //
     /* 2141771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2141774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2141779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2141782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2141785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2141788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141817 */     // MIs[0] round
     /* 2141817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141820 */     // MIs[0] policy
     /* 2141820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141830 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2141833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141856 */     // GIR_Coverage, 17586,
     /* 2141856 */     GIR_EraseRootFromParent_Done,
     /* 2141857 */   // Label 28290: @2141857
     /* 2141857 */   GIM_Try, /*On fail goto*//*Label 28291*/ GIMT_Encode4(2141948), // Rule ID 17587 //
     /* 2141862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2141865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2141870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2141873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2141876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2141879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141908 */     // MIs[0] round
     /* 2141908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141911 */     // MIs[0] policy
     /* 2141911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141921 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2141924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141947 */     // GIR_Coverage, 17587,
     /* 2141947 */     GIR_EraseRootFromParent_Done,
     /* 2141948 */   // Label 28291: @2141948
     /* 2141948 */   GIM_Try, /*On fail goto*//*Label 28292*/ GIMT_Encode4(2142039), // Rule ID 17590 //
     /* 2141953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2141956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2141961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2141964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2141967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2141970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2141976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141999 */     // MIs[0] round
     /* 2141999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142002 */     // MIs[0] policy
     /* 2142002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142012 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2142015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142038 */     // GIR_Coverage, 17590,
     /* 2142038 */     GIR_EraseRootFromParent_Done,
     /* 2142039 */   // Label 28292: @2142039
     /* 2142039 */   GIM_Try, /*On fail goto*//*Label 28293*/ GIMT_Encode4(2142130), // Rule ID 17591 //
     /* 2142044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2142047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2142052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2142055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2142058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2142061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2142064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2142067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2142086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142090 */     // MIs[0] round
     /* 2142090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142093 */     // MIs[0] policy
     /* 2142093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142103 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2142106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142129 */     // GIR_Coverage, 17591,
     /* 2142129 */     GIR_EraseRootFromParent_Done,
     /* 2142130 */   // Label 28293: @2142130
     /* 2142130 */   GIM_Try, /*On fail goto*//*Label 28294*/ GIMT_Encode4(2142221), // Rule ID 17594 //
     /* 2142135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2142138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2142143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2142146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2142152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2142155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2142177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142181 */     // MIs[0] round
     /* 2142181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142184 */     // MIs[0] policy
     /* 2142184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142194 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2142197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142220 */     // GIR_Coverage, 17594,
     /* 2142220 */     GIR_EraseRootFromParent_Done,
     /* 2142221 */   // Label 28294: @2142221
     /* 2142221 */   GIM_Try, /*On fail goto*//*Label 28295*/ GIMT_Encode4(2142312), // Rule ID 17595 //
     /* 2142226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2142229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2142234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2142237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2142243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2142246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2142268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142272 */     // MIs[0] round
     /* 2142272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142275 */     // MIs[0] policy
     /* 2142275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142285 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2142288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142311 */     // GIR_Coverage, 17595,
     /* 2142311 */     GIR_EraseRootFromParent_Done,
     /* 2142312 */   // Label 28295: @2142312
     /* 2142312 */   GIM_Try, /*On fail goto*//*Label 28296*/ GIMT_Encode4(2142403), // Rule ID 17598 //
     /* 2142317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2142320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2142325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2142328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2142331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2142334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2142337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2142359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142363 */     // MIs[0] round
     /* 2142363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142366 */     // MIs[0] policy
     /* 2142366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142376 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2142379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142402 */     // GIR_Coverage, 17598,
     /* 2142402 */     GIR_EraseRootFromParent_Done,
     /* 2142403 */   // Label 28296: @2142403
     /* 2142403 */   GIM_Try, /*On fail goto*//*Label 28297*/ GIMT_Encode4(2142494), // Rule ID 17599 //
     /* 2142408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2142411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2142416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2142419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2142422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2142425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2142428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2142450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142454 */     // MIs[0] round
     /* 2142454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142457 */     // MIs[0] policy
     /* 2142457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142467 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2142470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142493 */     // GIR_Coverage, 17599,
     /* 2142493 */     GIR_EraseRootFromParent_Done,
     /* 2142494 */   // Label 28297: @2142494
     /* 2142494 */   GIM_Try, /*On fail goto*//*Label 28298*/ GIMT_Encode4(2142585), // Rule ID 17602 //
     /* 2142499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2142502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2142507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2142510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2142513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2142516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2142519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2142522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2142541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142545 */     // MIs[0] round
     /* 2142545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142548 */     // MIs[0] policy
     /* 2142548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142558 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2142561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142584 */     // GIR_Coverage, 17602,
     /* 2142584 */     GIR_EraseRootFromParent_Done,
     /* 2142585 */   // Label 28298: @2142585
     /* 2142585 */   GIM_Try, /*On fail goto*//*Label 28299*/ GIMT_Encode4(2142676), // Rule ID 17603 //
     /* 2142590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2142593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2142598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2142601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2142604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2142607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2142610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2142613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2142632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142636 */     // MIs[0] round
     /* 2142636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142639 */     // MIs[0] policy
     /* 2142639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142649 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2142652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142675 */     // GIR_Coverage, 17603,
     /* 2142675 */     GIR_EraseRootFromParent_Done,
     /* 2142676 */   // Label 28299: @2142676
     /* 2142676 */   GIM_Try, /*On fail goto*//*Label 28300*/ GIMT_Encode4(2142767), // Rule ID 17606 //
     /* 2142681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2142684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2142689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2142692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2142695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2142698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142727 */     // MIs[0] round
     /* 2142727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142730 */     // MIs[0] policy
     /* 2142730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142740 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2142743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142766 */     // GIR_Coverage, 17606,
     /* 2142766 */     GIR_EraseRootFromParent_Done,
     /* 2142767 */   // Label 28300: @2142767
     /* 2142767 */   GIM_Try, /*On fail goto*//*Label 28301*/ GIMT_Encode4(2142858), // Rule ID 17607 //
     /* 2142772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2142775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2142780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2142783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2142786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2142789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142818 */     // MIs[0] round
     /* 2142818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142821 */     // MIs[0] policy
     /* 2142821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142831 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2142834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142857 */     // GIR_Coverage, 17607,
     /* 2142857 */     GIR_EraseRootFromParent_Done,
     /* 2142858 */   // Label 28301: @2142858
     /* 2142858 */   GIM_Try, /*On fail goto*//*Label 28302*/ GIMT_Encode4(2142949), // Rule ID 17610 //
     /* 2142863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2142866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2142871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2142874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2142877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2142880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142909 */     // MIs[0] round
     /* 2142909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142912 */     // MIs[0] policy
     /* 2142912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142922 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2142925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142948 */     // GIR_Coverage, 17610,
     /* 2142948 */     GIR_EraseRootFromParent_Done,
     /* 2142949 */   // Label 28302: @2142949
     /* 2142949 */   GIM_Try, /*On fail goto*//*Label 28303*/ GIMT_Encode4(2143040), // Rule ID 17611 //
     /* 2142954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2142957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2142962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2142965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2142968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2142971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143000 */     // MIs[0] round
     /* 2143000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143003 */     // MIs[0] policy
     /* 2143003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143013 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2143016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143039 */     // GIR_Coverage, 17611,
     /* 2143039 */     GIR_EraseRootFromParent_Done,
     /* 2143040 */   // Label 28303: @2143040
     /* 2143040 */   GIM_Try, /*On fail goto*//*Label 28304*/ GIMT_Encode4(2143131), // Rule ID 17614 //
     /* 2143045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2143048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2143053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2143056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2143059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2143062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2143065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2143087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143091 */     // MIs[0] round
     /* 2143091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143094 */     // MIs[0] policy
     /* 2143094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143104 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2143107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143130 */     // GIR_Coverage, 17614,
     /* 2143130 */     GIR_EraseRootFromParent_Done,
     /* 2143131 */   // Label 28304: @2143131
     /* 2143131 */   GIM_Try, /*On fail goto*//*Label 28305*/ GIMT_Encode4(2143222), // Rule ID 17615 //
     /* 2143136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2143139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2143144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2143147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2143150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2143153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2143156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2143178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143182 */     // MIs[0] round
     /* 2143182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143185 */     // MIs[0] policy
     /* 2143185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143195 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2143198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143221 */     // GIR_Coverage, 17615,
     /* 2143221 */     GIR_EraseRootFromParent_Done,
     /* 2143222 */   // Label 28305: @2143222
     /* 2143222 */   GIM_Try, /*On fail goto*//*Label 28306*/ GIMT_Encode4(2143313), // Rule ID 17618 //
     /* 2143227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2143230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2143235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2143238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2143241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2143244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2143247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143273 */     // MIs[0] round
     /* 2143273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143276 */     // MIs[0] policy
     /* 2143276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143286 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2143289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143312 */     // GIR_Coverage, 17618,
     /* 2143312 */     GIR_EraseRootFromParent_Done,
     /* 2143313 */   // Label 28306: @2143313
     /* 2143313 */   GIM_Try, /*On fail goto*//*Label 28307*/ GIMT_Encode4(2143404), // Rule ID 17619 //
     /* 2143318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2143321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2143326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2143329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2143332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2143335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2143338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143364 */     // MIs[0] round
     /* 2143364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143367 */     // MIs[0] policy
     /* 2143367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143377 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2143380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143403 */     // GIR_Coverage, 17619,
     /* 2143403 */     GIR_EraseRootFromParent_Done,
     /* 2143404 */   // Label 28307: @2143404
     /* 2143404 */   GIM_Try, /*On fail goto*//*Label 28308*/ GIMT_Encode4(2143495), // Rule ID 17622 //
     /* 2143409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2143412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2143417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2143420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2143423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2143426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2143429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143455 */     // MIs[0] round
     /* 2143455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143458 */     // MIs[0] policy
     /* 2143458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143468 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2143471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143494 */     // GIR_Coverage, 17622,
     /* 2143494 */     GIR_EraseRootFromParent_Done,
     /* 2143495 */   // Label 28308: @2143495
     /* 2143495 */   GIM_Try, /*On fail goto*//*Label 28309*/ GIMT_Encode4(2143586), // Rule ID 17623 //
     /* 2143500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2143503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2143508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2143511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2143514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2143517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2143520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143546 */     // MIs[0] round
     /* 2143546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143549 */     // MIs[0] policy
     /* 2143549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143559 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2143562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143585 */     // GIR_Coverage, 17623,
     /* 2143585 */     GIR_EraseRootFromParent_Done,
     /* 2143586 */   // Label 28309: @2143586
     /* 2143586 */   GIM_Try, /*On fail goto*//*Label 28310*/ GIMT_Encode4(2143677), // Rule ID 17626 //
     /* 2143591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2143594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2143599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2143602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2143605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2143608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2143611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2143633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143637 */     // MIs[0] round
     /* 2143637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143640 */     // MIs[0] policy
     /* 2143640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143650 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2143653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143676 */     // GIR_Coverage, 17626,
     /* 2143676 */     GIR_EraseRootFromParent_Done,
     /* 2143677 */   // Label 28310: @2143677
     /* 2143677 */   GIM_Try, /*On fail goto*//*Label 28311*/ GIMT_Encode4(2143768), // Rule ID 17627 //
     /* 2143682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2143685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2143690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2143693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2143696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2143699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2143702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2143724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143728 */     // MIs[0] round
     /* 2143728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143731 */     // MIs[0] policy
     /* 2143731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143741 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2143744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143767 */     // GIR_Coverage, 17627,
     /* 2143767 */     GIR_EraseRootFromParent_Done,
     /* 2143768 */   // Label 28311: @2143768
     /* 2143768 */   GIM_Try, /*On fail goto*//*Label 28312*/ GIMT_Encode4(2143859), // Rule ID 17630 //
     /* 2143773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2143776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2143781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2143784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2143787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2143790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2143793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143819 */     // MIs[0] round
     /* 2143819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143822 */     // MIs[0] policy
     /* 2143822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143832 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2143835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143858 */     // GIR_Coverage, 17630,
     /* 2143858 */     GIR_EraseRootFromParent_Done,
     /* 2143859 */   // Label 28312: @2143859
     /* 2143859 */   GIM_Try, /*On fail goto*//*Label 28313*/ GIMT_Encode4(2143950), // Rule ID 17631 //
     /* 2143864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2143867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2143872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2143875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2143878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2143881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2143884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143910 */     // MIs[0] round
     /* 2143910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143913 */     // MIs[0] policy
     /* 2143913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143923 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2143926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143936 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143946 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143949 */     // GIR_Coverage, 17631,
     /* 2143949 */     GIR_EraseRootFromParent_Done,
     /* 2143950 */   // Label 28313: @2143950
     /* 2143950 */   GIM_Try, /*On fail goto*//*Label 28314*/ GIMT_Encode4(2144041), // Rule ID 17634 //
     /* 2143955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2143958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2143963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2143966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2143969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2143972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2143975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2143997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144001 */     // MIs[0] round
     /* 2144001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144004 */     // MIs[0] policy
     /* 2144004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144014 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2144017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144040 */     // GIR_Coverage, 17634,
     /* 2144040 */     GIR_EraseRootFromParent_Done,
     /* 2144041 */   // Label 28314: @2144041
     /* 2144041 */   GIM_Try, /*On fail goto*//*Label 28315*/ GIMT_Encode4(2144132), // Rule ID 17635 //
     /* 2144046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2144049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2144054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2144057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2144060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2144063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2144066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144092 */     // MIs[0] round
     /* 2144092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144095 */     // MIs[0] policy
     /* 2144095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144105 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2144108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144131 */     // GIR_Coverage, 17635,
     /* 2144131 */     GIR_EraseRootFromParent_Done,
     /* 2144132 */   // Label 28315: @2144132
     /* 2144132 */   GIM_Try, /*On fail goto*//*Label 28316*/ GIMT_Encode4(2144223), // Rule ID 17638 //
     /* 2144137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2144140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2144145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2144148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2144151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2144154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2144157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2144179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144183 */     // MIs[0] round
     /* 2144183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144186 */     // MIs[0] policy
     /* 2144186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144196 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2144199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144222 */     // GIR_Coverage, 17638,
     /* 2144222 */     GIR_EraseRootFromParent_Done,
     /* 2144223 */   // Label 28316: @2144223
     /* 2144223 */   GIM_Try, /*On fail goto*//*Label 28317*/ GIMT_Encode4(2144314), // Rule ID 17639 //
     /* 2144228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2144231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2144236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2144239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2144242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2144245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2144248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2144270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144274 */     // MIs[0] round
     /* 2144274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144277 */     // MIs[0] policy
     /* 2144277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144287 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2144290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144313 */     // GIR_Coverage, 17639,
     /* 2144313 */     GIR_EraseRootFromParent_Done,
     /* 2144314 */   // Label 28317: @2144314
     /* 2144314 */   GIM_Try, /*On fail goto*//*Label 28318*/ GIMT_Encode4(2144405), // Rule ID 17642 //
     /* 2144319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2144322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2144327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2144330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2144333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144365 */     // MIs[0] round
     /* 2144365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144368 */     // MIs[0] policy
     /* 2144368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144378 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2144381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144404 */     // GIR_Coverage, 17642,
     /* 2144404 */     GIR_EraseRootFromParent_Done,
     /* 2144405 */   // Label 28318: @2144405
     /* 2144405 */   GIM_Try, /*On fail goto*//*Label 28319*/ GIMT_Encode4(2144496), // Rule ID 17643 //
     /* 2144410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2144413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2144418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2144421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2144424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144456 */     // MIs[0] round
     /* 2144456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144459 */     // MIs[0] policy
     /* 2144459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144469 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2144472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144495 */     // GIR_Coverage, 17643,
     /* 2144495 */     GIR_EraseRootFromParent_Done,
     /* 2144496 */   // Label 28319: @2144496
     /* 2144496 */   GIM_Try, /*On fail goto*//*Label 28320*/ GIMT_Encode4(2144587), // Rule ID 17646 //
     /* 2144501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2144504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2144509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2144512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2144515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2144518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2144524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144547 */     // MIs[0] round
     /* 2144547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144550 */     // MIs[0] policy
     /* 2144550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144560 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2144563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144586 */     // GIR_Coverage, 17646,
     /* 2144586 */     GIR_EraseRootFromParent_Done,
     /* 2144587 */   // Label 28320: @2144587
     /* 2144587 */   GIM_Try, /*On fail goto*//*Label 28321*/ GIMT_Encode4(2144678), // Rule ID 17647 //
     /* 2144592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2144595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2144600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2144603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2144606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2144609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2144615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144638 */     // MIs[0] round
     /* 2144638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144641 */     // MIs[0] policy
     /* 2144641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144651 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2144654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144677 */     // GIR_Coverage, 17647,
     /* 2144677 */     GIR_EraseRootFromParent_Done,
     /* 2144678 */   // Label 28321: @2144678
     /* 2144678 */   GIM_Try, /*On fail goto*//*Label 28322*/ GIMT_Encode4(2144769), // Rule ID 17650 //
     /* 2144683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2144686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2144691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2144694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2144697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2144700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2144706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144729 */     // MIs[0] round
     /* 2144729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144732 */     // MIs[0] policy
     /* 2144732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144742 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2144745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144768 */     // GIR_Coverage, 17650,
     /* 2144768 */     GIR_EraseRootFromParent_Done,
     /* 2144769 */   // Label 28322: @2144769
     /* 2144769 */   GIM_Try, /*On fail goto*//*Label 28323*/ GIMT_Encode4(2144860), // Rule ID 17651 //
     /* 2144774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2144777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2144782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2144785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2144788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2144791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2144797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144820 */     // MIs[0] round
     /* 2144820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144823 */     // MIs[0] policy
     /* 2144823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144833 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2144836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144859 */     // GIR_Coverage, 17651,
     /* 2144859 */     GIR_EraseRootFromParent_Done,
     /* 2144860 */   // Label 28323: @2144860
     /* 2144860 */   GIM_Try, /*On fail goto*//*Label 28324*/ GIMT_Encode4(2144951), // Rule ID 17654 //
     /* 2144865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2144868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2144873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2144876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2144879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2144882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2144885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144911 */     // MIs[0] round
     /* 2144911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144914 */     // MIs[0] policy
     /* 2144914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144924 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2144927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144950 */     // GIR_Coverage, 17654,
     /* 2144950 */     GIR_EraseRootFromParent_Done,
     /* 2144951 */   // Label 28324: @2144951
     /* 2144951 */   GIM_Try, /*On fail goto*//*Label 28325*/ GIMT_Encode4(2145042), // Rule ID 17655 //
     /* 2144956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2144959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2144964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2144967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2144970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2144973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2144976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145002 */     // MIs[0] round
     /* 2145002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145005 */     // MIs[0] policy
     /* 2145005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145015 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2145018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145041 */     // GIR_Coverage, 17655,
     /* 2145041 */     GIR_EraseRootFromParent_Done,
     /* 2145042 */   // Label 28325: @2145042
     /* 2145042 */   GIM_Try, /*On fail goto*//*Label 28326*/ GIMT_Encode4(2145133), // Rule ID 17658 //
     /* 2145047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2145050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2145055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2145058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2145061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145093 */     // MIs[0] round
     /* 2145093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145096 */     // MIs[0] policy
     /* 2145096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145106 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2145109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145132 */     // GIR_Coverage, 17658,
     /* 2145132 */     GIR_EraseRootFromParent_Done,
     /* 2145133 */   // Label 28326: @2145133
     /* 2145133 */   GIM_Try, /*On fail goto*//*Label 28327*/ GIMT_Encode4(2145224), // Rule ID 17659 //
     /* 2145138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2145141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2145146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2145149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2145152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145184 */     // MIs[0] round
     /* 2145184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145187 */     // MIs[0] policy
     /* 2145187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145197 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2145200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145223 */     // GIR_Coverage, 17659,
     /* 2145223 */     GIR_EraseRootFromParent_Done,
     /* 2145224 */   // Label 28327: @2145224
     /* 2145224 */   GIM_Try, /*On fail goto*//*Label 28328*/ GIMT_Encode4(2145315), // Rule ID 17662 //
     /* 2145229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2145232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2145237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2145240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2145243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2145246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2145252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145275 */     // MIs[0] round
     /* 2145275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145278 */     // MIs[0] policy
     /* 2145278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145288 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2145291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145314 */     // GIR_Coverage, 17662,
     /* 2145314 */     GIR_EraseRootFromParent_Done,
     /* 2145315 */   // Label 28328: @2145315
     /* 2145315 */   GIM_Try, /*On fail goto*//*Label 28329*/ GIMT_Encode4(2145406), // Rule ID 17663 //
     /* 2145320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2145323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2145328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2145331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2145334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2145337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2145343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145366 */     // MIs[0] round
     /* 2145366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145369 */     // MIs[0] policy
     /* 2145369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145379 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2145382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145405 */     // GIR_Coverage, 17663,
     /* 2145405 */     GIR_EraseRootFromParent_Done,
     /* 2145406 */   // Label 28329: @2145406
     /* 2145406 */   GIM_Try, /*On fail goto*//*Label 28330*/ GIMT_Encode4(2145497), // Rule ID 17666 //
     /* 2145411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2145414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2145419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2145422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2145425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2145428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2145431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2145441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2145453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145457 */     // MIs[0] round
     /* 2145457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145460 */     // MIs[0] policy
     /* 2145460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145470 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2145473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145496 */     // GIR_Coverage, 17666,
     /* 2145496 */     GIR_EraseRootFromParent_Done,
     /* 2145497 */   // Label 28330: @2145497
     /* 2145497 */   GIM_Try, /*On fail goto*//*Label 28331*/ GIMT_Encode4(2145588), // Rule ID 17667 //
     /* 2145502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2145505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2145510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2145513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2145516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2145519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2145522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2145532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2145544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145548 */     // MIs[0] round
     /* 2145548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145551 */     // MIs[0] policy
     /* 2145551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145561 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2145564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145587 */     // GIR_Coverage, 17667,
     /* 2145587 */     GIR_EraseRootFromParent_Done,
     /* 2145588 */   // Label 28331: @2145588
     /* 2145588 */   GIM_Try, /*On fail goto*//*Label 28332*/ GIMT_Encode4(2145679), // Rule ID 17670 //
     /* 2145593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2145596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2145601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2145604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2145607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2145610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2145613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2145635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145639 */     // MIs[0] round
     /* 2145639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145642 */     // MIs[0] policy
     /* 2145642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145652 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2145655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145678 */     // GIR_Coverage, 17670,
     /* 2145678 */     GIR_EraseRootFromParent_Done,
     /* 2145679 */   // Label 28332: @2145679
     /* 2145679 */   GIM_Try, /*On fail goto*//*Label 28333*/ GIMT_Encode4(2145770), // Rule ID 17671 //
     /* 2145684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2145687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2145692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2145695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2145698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2145701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2145704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2145726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145730 */     // MIs[0] round
     /* 2145730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145733 */     // MIs[0] policy
     /* 2145733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145743 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2145746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145769 */     // GIR_Coverage, 17671,
     /* 2145769 */     GIR_EraseRootFromParent_Done,
     /* 2145770 */   // Label 28333: @2145770
     /* 2145770 */   GIM_Try, /*On fail goto*//*Label 28334*/ GIMT_Encode4(2145861), // Rule ID 17674 //
     /* 2145775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2145778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2145783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2145786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2145792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2145795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2145817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145821 */     // MIs[0] round
     /* 2145821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145824 */     // MIs[0] policy
     /* 2145824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145834 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2145837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145860 */     // GIR_Coverage, 17674,
     /* 2145860 */     GIR_EraseRootFromParent_Done,
     /* 2145861 */   // Label 28334: @2145861
     /* 2145861 */   GIM_Try, /*On fail goto*//*Label 28335*/ GIMT_Encode4(2145952), // Rule ID 17675 //
     /* 2145866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2145869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2145874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2145877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2145883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2145886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2145908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145912 */     // MIs[0] round
     /* 2145912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145915 */     // MIs[0] policy
     /* 2145915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145925 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2145928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145951 */     // GIR_Coverage, 17675,
     /* 2145951 */     GIR_EraseRootFromParent_Done,
     /* 2145952 */   // Label 28335: @2145952
     /* 2145952 */   GIM_Try, /*On fail goto*//*Label 28336*/ GIMT_Encode4(2146043), // Rule ID 17678 //
     /* 2145957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2145960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2145968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2145971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2145974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2145977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146003 */     // MIs[0] round
     /* 2146003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146006 */     // MIs[0] policy
     /* 2146006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146016 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2146019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2146023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146042 */     // GIR_Coverage, 17678,
     /* 2146042 */     GIR_EraseRootFromParent_Done,
     /* 2146043 */   // Label 28336: @2146043
     /* 2146043 */   GIM_Try, /*On fail goto*//*Label 28337*/ GIMT_Encode4(2146134), // Rule ID 17679 //
     /* 2146048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2146051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2146056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2146059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2146062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2146065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2146068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146094 */     // MIs[0] round
     /* 2146094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146097 */     // MIs[0] policy
     /* 2146097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146107 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2146110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2146114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146133 */     // GIR_Coverage, 17679,
     /* 2146133 */     GIR_EraseRootFromParent_Done,
     /* 2146134 */   // Label 28337: @2146134
     /* 2146134 */   GIM_Try, /*On fail goto*//*Label 28338*/ GIMT_Encode4(2146225), // Rule ID 17682 //
     /* 2146139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2146142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2146147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2146150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2146153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2146156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2146159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2146162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146185 */     // MIs[0] round
     /* 2146185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146188 */     // MIs[0] policy
     /* 2146188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146198 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2146201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2146205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146224 */     // GIR_Coverage, 17682,
     /* 2146224 */     GIR_EraseRootFromParent_Done,
     /* 2146225 */   // Label 28338: @2146225
     /* 2146225 */   GIM_Try, /*On fail goto*//*Label 28339*/ GIMT_Encode4(2146316), // Rule ID 17683 //
     /* 2146230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2146233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2146238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2146241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2146244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2146247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2146250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2146253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146276 */     // MIs[0] round
     /* 2146276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146279 */     // MIs[0] policy
     /* 2146279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146289 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2146292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2146296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146315 */     // GIR_Coverage, 17683,
     /* 2146315 */     GIR_EraseRootFromParent_Done,
     /* 2146316 */   // Label 28339: @2146316
     /* 2146316 */   GIM_Try, /*On fail goto*//*Label 28340*/ GIMT_Encode4(2146407), // Rule ID 17686 //
     /* 2146321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2146324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2146329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2146332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2146335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2146338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2146341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146367 */     // MIs[0] round
     /* 2146367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146370 */     // MIs[0] policy
     /* 2146370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146380 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2146383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2146387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146406 */     // GIR_Coverage, 17686,
     /* 2146406 */     GIR_EraseRootFromParent_Done,
     /* 2146407 */   // Label 28340: @2146407
     /* 2146407 */   GIM_Try, /*On fail goto*//*Label 28341*/ GIMT_Encode4(2146498), // Rule ID 17687 //
     /* 2146412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2146415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2146420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2146423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2146426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2146429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2146432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146458 */     // MIs[0] round
     /* 2146458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146461 */     // MIs[0] policy
     /* 2146461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146471 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2146474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2146478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146497 */     // GIR_Coverage, 17687,
     /* 2146497 */     GIR_EraseRootFromParent_Done,
     /* 2146498 */   // Label 28341: @2146498
     /* 2146498 */   GIM_Try, /*On fail goto*//*Label 28342*/ GIMT_Encode4(2146589), // Rule ID 17690 //
     /* 2146503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2146506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2146511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2146514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2146517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2146523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146549 */     // MIs[0] round
     /* 2146549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146552 */     // MIs[0] policy
     /* 2146552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146562 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2146565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2146569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146588 */     // GIR_Coverage, 17690,
     /* 2146588 */     GIR_EraseRootFromParent_Done,
     /* 2146589 */   // Label 28342: @2146589
     /* 2146589 */   GIM_Try, /*On fail goto*//*Label 28343*/ GIMT_Encode4(2146680), // Rule ID 17691 //
     /* 2146594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2146597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2146602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2146605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2146608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2146614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146640 */     // MIs[0] round
     /* 2146640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146643 */     // MIs[0] policy
     /* 2146643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146653 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2146656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2146660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146679 */     // GIR_Coverage, 17691,
     /* 2146679 */     GIR_EraseRootFromParent_Done,
     /* 2146680 */   // Label 28343: @2146680
     /* 2146680 */   GIM_Try, /*On fail goto*//*Label 28344*/ GIMT_Encode4(2146771), // Rule ID 17694 //
     /* 2146685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2146688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2146693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2146696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2146699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2146702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2146705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2146708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2146715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146731 */     // MIs[0] round
     /* 2146731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146734 */     // MIs[0] policy
     /* 2146734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146744 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2146747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2146751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146770 */     // GIR_Coverage, 17694,
     /* 2146770 */     GIR_EraseRootFromParent_Done,
     /* 2146771 */   // Label 28344: @2146771
     /* 2146771 */   GIM_Try, /*On fail goto*//*Label 28345*/ GIMT_Encode4(2146862), // Rule ID 17695 //
     /* 2146776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2146779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2146784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2146787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2146790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2146793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2146796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2146799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2146806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146822 */     // MIs[0] round
     /* 2146822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146825 */     // MIs[0] policy
     /* 2146825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146835 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2146838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2146842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146861 */     // GIR_Coverage, 17695,
     /* 2146861 */     GIR_EraseRootFromParent_Done,
     /* 2146862 */   // Label 28345: @2146862
     /* 2146862 */   GIM_Try, /*On fail goto*//*Label 28346*/ GIMT_Encode4(2146953), // Rule ID 17698 //
     /* 2146867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2146870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2146875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2146878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2146881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2146884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2146887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146913 */     // MIs[0] round
     /* 2146913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146916 */     // MIs[0] policy
     /* 2146916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146926 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2146929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2146933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146952 */     // GIR_Coverage, 17698,
     /* 2146952 */     GIR_EraseRootFromParent_Done,
     /* 2146953 */   // Label 28346: @2146953
     /* 2146953 */   GIM_Try, /*On fail goto*//*Label 28347*/ GIMT_Encode4(2147044), // Rule ID 17699 //
     /* 2146958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2146961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2146966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2146969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2146972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2146975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2146978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147004 */     // MIs[0] round
     /* 2147004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147007 */     // MIs[0] policy
     /* 2147007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147017 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2147020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2147024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147043 */     // GIR_Coverage, 17699,
     /* 2147043 */     GIR_EraseRootFromParent_Done,
     /* 2147044 */   // Label 28347: @2147044
     /* 2147044 */   GIM_Try, /*On fail goto*//*Label 28348*/ GIMT_Encode4(2147135), // Rule ID 17702 //
     /* 2147049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2147052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2147057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2147060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2147063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2147066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2147069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147095 */     // MIs[0] round
     /* 2147095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147098 */     // MIs[0] policy
     /* 2147098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147108 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2147111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2147115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147134 */     // GIR_Coverage, 17702,
     /* 2147134 */     GIR_EraseRootFromParent_Done,
     /* 2147135 */   // Label 28348: @2147135
     /* 2147135 */   GIM_Try, /*On fail goto*//*Label 28349*/ GIMT_Encode4(2147226), // Rule ID 17703 //
     /* 2147140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2147143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2147148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2147151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2147154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2147157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2147160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147186 */     // MIs[0] round
     /* 2147186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147189 */     // MIs[0] policy
     /* 2147189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147199 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2147202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2147206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147225 */     // GIR_Coverage, 17703,
     /* 2147225 */     GIR_EraseRootFromParent_Done,
     /* 2147226 */   // Label 28349: @2147226
     /* 2147226 */   GIM_Try, /*On fail goto*//*Label 28350*/ GIMT_Encode4(2147317), // Rule ID 17706 //
     /* 2147231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2147234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2147239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2147242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2147245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2147248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2147251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147277 */     // MIs[0] round
     /* 2147277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147280 */     // MIs[0] policy
     /* 2147280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147290 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2147293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2147297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147316 */     // GIR_Coverage, 17706,
     /* 2147316 */     GIR_EraseRootFromParent_Done,
     /* 2147317 */   // Label 28350: @2147317
     /* 2147317 */   GIM_Try, /*On fail goto*//*Label 28351*/ GIMT_Encode4(2147408), // Rule ID 17707 //
     /* 2147322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2147325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2147330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2147333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2147336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2147339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2147342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147368 */     // MIs[0] round
     /* 2147368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147371 */     // MIs[0] policy
     /* 2147371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147381 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2147384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2147388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147407 */     // GIR_Coverage, 17707,
     /* 2147407 */     GIR_EraseRootFromParent_Done,
     /* 2147408 */   // Label 28351: @2147408
     /* 2147408 */   GIM_Try, /*On fail goto*//*Label 28352*/ GIMT_Encode4(2147499), // Rule ID 17710 //
     /* 2147413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2147416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2147421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2147424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2147427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2147430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2147433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147459 */     // MIs[0] round
     /* 2147459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147462 */     // MIs[0] policy
     /* 2147462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147472 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2147475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2147479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147498 */     // GIR_Coverage, 17710,
     /* 2147498 */     GIR_EraseRootFromParent_Done,
     /* 2147499 */   // Label 28352: @2147499
     /* 2147499 */   GIM_Try, /*On fail goto*//*Label 28353*/ GIMT_Encode4(2147590), // Rule ID 17711 //
     /* 2147504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2147507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2147512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2147515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2147518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2147521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2147524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147550 */     // MIs[0] round
     /* 2147550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147553 */     // MIs[0] policy
     /* 2147553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147563 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2147566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2147570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147589 */     // GIR_Coverage, 17711,
     /* 2147589 */     GIR_EraseRootFromParent_Done,
     /* 2147590 */   // Label 28353: @2147590
     /* 2147590 */   GIM_Try, /*On fail goto*//*Label 28354*/ GIMT_Encode4(2147681), // Rule ID 17714 //
     /* 2147595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2147598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2147603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2147606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2147609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2147612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2147615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2147618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147641 */     // MIs[0] round
     /* 2147641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147644 */     // MIs[0] policy
     /* 2147644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147654 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2147657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2147661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147680 */     // GIR_Coverage, 17714,
     /* 2147680 */     GIR_EraseRootFromParent_Done,
     /* 2147681 */   // Label 28354: @2147681
     /* 2147681 */   GIM_Try, /*On fail goto*//*Label 28355*/ GIMT_Encode4(2147772), // Rule ID 17715 //
     /* 2147686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2147689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2147694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2147697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2147700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2147703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2147706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2147709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147732 */     // MIs[0] round
     /* 2147732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147735 */     // MIs[0] policy
     /* 2147735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147745 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2147748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2147752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147771 */     // GIR_Coverage, 17715,
     /* 2147771 */     GIR_EraseRootFromParent_Done,
     /* 2147772 */   // Label 28355: @2147772
     /* 2147772 */   GIM_Try, /*On fail goto*//*Label 28356*/ GIMT_Encode4(2147863), // Rule ID 17718 //
     /* 2147777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2147780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2147785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2147788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2147791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2147794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2147797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147823 */     // MIs[0] round
     /* 2147823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147826 */     // MIs[0] policy
     /* 2147826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147836 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2147839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2147843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147862 */     // GIR_Coverage, 17718,
     /* 2147862 */     GIR_EraseRootFromParent_Done,
     /* 2147863 */   // Label 28356: @2147863
     /* 2147863 */   GIM_Try, /*On fail goto*//*Label 28357*/ GIMT_Encode4(2147954), // Rule ID 17719 //
     /* 2147868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2147871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2147876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2147879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2147882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2147885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2147888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147914 */     // MIs[0] round
     /* 2147914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147917 */     // MIs[0] policy
     /* 2147917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147927 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2147930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2147934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147953 */     // GIR_Coverage, 17719,
     /* 2147953 */     GIR_EraseRootFromParent_Done,
     /* 2147954 */   // Label 28357: @2147954
     /* 2147954 */   GIM_Try, /*On fail goto*//*Label 28358*/ GIMT_Encode4(2148045), // Rule ID 17722 //
     /* 2147959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2147962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2147967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2147970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2147973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2147976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2147979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148005 */     // MIs[0] round
     /* 2148005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148008 */     // MIs[0] policy
     /* 2148008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148018 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2148021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2148025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148044 */     // GIR_Coverage, 17722,
     /* 2148044 */     GIR_EraseRootFromParent_Done,
     /* 2148045 */   // Label 28358: @2148045
     /* 2148045 */   GIM_Try, /*On fail goto*//*Label 28359*/ GIMT_Encode4(2148136), // Rule ID 17723 //
     /* 2148050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2148053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2148058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2148061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2148064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2148067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2148070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2148080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148096 */     // MIs[0] round
     /* 2148096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148099 */     // MIs[0] policy
     /* 2148099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148109 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2148112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2148116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148135 */     // GIR_Coverage, 17723,
     /* 2148135 */     GIR_EraseRootFromParent_Done,
     /* 2148136 */   // Label 28359: @2148136
     /* 2148136 */   GIM_Try, /*On fail goto*//*Label 28360*/ GIMT_Encode4(2148227), // Rule ID 17726 //
     /* 2148141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2148144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2148149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2148152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2148155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2148158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2148161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2148164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2148171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148187 */     // MIs[0] round
     /* 2148187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148190 */     // MIs[0] policy
     /* 2148190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148200 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2148203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2148207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148226 */     // GIR_Coverage, 17726,
     /* 2148226 */     GIR_EraseRootFromParent_Done,
     /* 2148227 */   // Label 28360: @2148227
     /* 2148227 */   GIM_Try, /*On fail goto*//*Label 28361*/ GIMT_Encode4(2148318), // Rule ID 17727 //
     /* 2148232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2148235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2148240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2148243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2148246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2148249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2148252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2148255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2148262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148278 */     // MIs[0] round
     /* 2148278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148281 */     // MIs[0] policy
     /* 2148281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148291 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2148294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2148298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148317 */     // GIR_Coverage, 17727,
     /* 2148317 */     GIR_EraseRootFromParent_Done,
     /* 2148318 */   // Label 28361: @2148318
     /* 2148318 */   GIM_Try, /*On fail goto*//*Label 28362*/ GIMT_Encode4(2148409), // Rule ID 17730 //
     /* 2148323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2148326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2148331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2148334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2148337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2148340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2148343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2148346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2148353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148369 */     // MIs[0] round
     /* 2148369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148372 */     // MIs[0] policy
     /* 2148372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148382 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2148385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2148389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148408 */     // GIR_Coverage, 17730,
     /* 2148408 */     GIR_EraseRootFromParent_Done,
     /* 2148409 */   // Label 28362: @2148409
     /* 2148409 */   GIM_Try, /*On fail goto*//*Label 28363*/ GIMT_Encode4(2148500), // Rule ID 17731 //
     /* 2148414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2148417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2148422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2148425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2148428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2148431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2148434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2148437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2148444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148460 */     // MIs[0] round
     /* 2148460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148463 */     // MIs[0] policy
     /* 2148463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148473 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2148476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2148480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148499 */     // GIR_Coverage, 17731,
     /* 2148499 */     GIR_EraseRootFromParent_Done,
     /* 2148500 */   // Label 28363: @2148500
     /* 2148500 */   GIM_Try, /*On fail goto*//*Label 28364*/ GIMT_Encode4(2148591), // Rule ID 17734 //
     /* 2148505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2148508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2148513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2148516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2148519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2148522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2148525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148551 */     // MIs[0] round
     /* 2148551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148554 */     // MIs[0] policy
     /* 2148554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148564 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2148567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2148571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148590 */     // GIR_Coverage, 17734,
     /* 2148590 */     GIR_EraseRootFromParent_Done,
     /* 2148591 */   // Label 28364: @2148591
     /* 2148591 */   GIM_Try, /*On fail goto*//*Label 28365*/ GIMT_Encode4(2148682), // Rule ID 17735 //
     /* 2148596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2148599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2148604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2148607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2148610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2148613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2148616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148642 */     // MIs[0] round
     /* 2148642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148645 */     // MIs[0] policy
     /* 2148645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148655 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2148658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2148662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148681 */     // GIR_Coverage, 17735,
     /* 2148681 */     GIR_EraseRootFromParent_Done,
     /* 2148682 */   // Label 28365: @2148682
     /* 2148682 */   GIM_Try, /*On fail goto*//*Label 28366*/ GIMT_Encode4(2148773), // Rule ID 17738 //
     /* 2148687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2148690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2148695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2148698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2148701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2148704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2148707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2148717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148733 */     // MIs[0] round
     /* 2148733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148736 */     // MIs[0] policy
     /* 2148736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148746 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2148749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2148753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148772 */     // GIR_Coverage, 17738,
     /* 2148772 */     GIR_EraseRootFromParent_Done,
     /* 2148773 */   // Label 28366: @2148773
     /* 2148773 */   GIM_Try, /*On fail goto*//*Label 28367*/ GIMT_Encode4(2148864), // Rule ID 17739 //
     /* 2148778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2148781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2148786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2148789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2148792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2148795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2148798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2148808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148824 */     // MIs[0] round
     /* 2148824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148827 */     // MIs[0] policy
     /* 2148827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148837 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2148840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2148844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148863 */     // GIR_Coverage, 17739,
     /* 2148863 */     GIR_EraseRootFromParent_Done,
     /* 2148864 */   // Label 28367: @2148864
     /* 2148864 */   GIM_Try, /*On fail goto*//*Label 28368*/ GIMT_Encode4(2148955), // Rule ID 17742 //
     /* 2148869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2148872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2148877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2148880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2148883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2148886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2148889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2148899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148915 */     // MIs[0] round
     /* 2148915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148918 */     // MIs[0] policy
     /* 2148918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148928 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2148931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2148935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148954 */     // GIR_Coverage, 17742,
     /* 2148954 */     GIR_EraseRootFromParent_Done,
     /* 2148955 */   // Label 28368: @2148955
     /* 2148955 */   GIM_Try, /*On fail goto*//*Label 28369*/ GIMT_Encode4(2149046), // Rule ID 17743 //
     /* 2148960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2148963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2148968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2148971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2148974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2148977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2148980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2148990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149006 */     // MIs[0] round
     /* 2149006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149009 */     // MIs[0] policy
     /* 2149009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149019 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2149022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2149026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149045 */     // GIR_Coverage, 17743,
     /* 2149045 */     GIR_EraseRootFromParent_Done,
     /* 2149046 */   // Label 28369: @2149046
     /* 2149046 */   GIM_Try, /*On fail goto*//*Label 28370*/ GIMT_Encode4(2149137), // Rule ID 17746 //
     /* 2149051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2149054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2149059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2149062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2149065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2149068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2149071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149097 */     // MIs[0] round
     /* 2149097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149100 */     // MIs[0] policy
     /* 2149100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149110 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2149113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2149117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149136 */     // GIR_Coverage, 17746,
     /* 2149136 */     GIR_EraseRootFromParent_Done,
     /* 2149137 */   // Label 28370: @2149137
     /* 2149137 */   GIM_Try, /*On fail goto*//*Label 28371*/ GIMT_Encode4(2149228), // Rule ID 17747 //
     /* 2149142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2149145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2149150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2149153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2149156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2149159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2149162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149188 */     // MIs[0] round
     /* 2149188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149191 */     // MIs[0] policy
     /* 2149191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149201 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2149204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2149208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149227 */     // GIR_Coverage, 17747,
     /* 2149227 */     GIR_EraseRootFromParent_Done,
     /* 2149228 */   // Label 28371: @2149228
     /* 2149228 */   GIM_Try, /*On fail goto*//*Label 28372*/ GIMT_Encode4(2149319), // Rule ID 17750 //
     /* 2149233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2149244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2149247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2149250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2149253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2149256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149279 */     // MIs[0] round
     /* 2149279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149282 */     // MIs[0] policy
     /* 2149282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149292 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2149295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149318 */     // GIR_Coverage, 17750,
     /* 2149318 */     GIR_EraseRootFromParent_Done,
     /* 2149319 */   // Label 28372: @2149319
     /* 2149319 */   GIM_Try, /*On fail goto*//*Label 28373*/ GIMT_Encode4(2149410), // Rule ID 17751 //
     /* 2149324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2149335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2149338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2149341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2149344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2149347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149370 */     // MIs[0] round
     /* 2149370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149373 */     // MIs[0] policy
     /* 2149373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149383 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2149386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149409 */     // GIR_Coverage, 17751,
     /* 2149409 */     GIR_EraseRootFromParent_Done,
     /* 2149410 */   // Label 28373: @2149410
     /* 2149410 */   GIM_Try, /*On fail goto*//*Label 28374*/ GIMT_Encode4(2149501), // Rule ID 17754 //
     /* 2149415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2149426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2149429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2149432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2149435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2149438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149461 */     // MIs[0] round
     /* 2149461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149464 */     // MIs[0] policy
     /* 2149464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149474 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2149477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149500 */     // GIR_Coverage, 17754,
     /* 2149500 */     GIR_EraseRootFromParent_Done,
     /* 2149501 */   // Label 28374: @2149501
     /* 2149501 */   GIM_Try, /*On fail goto*//*Label 28375*/ GIMT_Encode4(2149592), // Rule ID 17755 //
     /* 2149506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2149509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2149517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2149520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2149523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2149526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2149529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149552 */     // MIs[0] round
     /* 2149552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149555 */     // MIs[0] policy
     /* 2149555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149565 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2149568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149591 */     // GIR_Coverage, 17755,
     /* 2149591 */     GIR_EraseRootFromParent_Done,
     /* 2149592 */   // Label 28375: @2149592
     /* 2149592 */   GIM_Try, /*On fail goto*//*Label 28376*/ GIMT_Encode4(2149683), // Rule ID 17758 //
     /* 2149597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2149608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2149611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2149614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2149617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2149620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149643 */     // MIs[0] round
     /* 2149643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149646 */     // MIs[0] policy
     /* 2149646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149656 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2149659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149682 */     // GIR_Coverage, 17758,
     /* 2149682 */     GIR_EraseRootFromParent_Done,
     /* 2149683 */   // Label 28376: @2149683
     /* 2149683 */   GIM_Try, /*On fail goto*//*Label 28377*/ GIMT_Encode4(2149774), // Rule ID 17759 //
     /* 2149688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2149699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2149702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2149705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2149708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2149711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149734 */     // MIs[0] round
     /* 2149734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149737 */     // MIs[0] policy
     /* 2149737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149747 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2149750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149773 */     // GIR_Coverage, 17759,
     /* 2149773 */     GIR_EraseRootFromParent_Done,
     /* 2149774 */   // Label 28377: @2149774
     /* 2149774 */   GIM_Try, /*On fail goto*//*Label 28378*/ GIMT_Encode4(2149865), // Rule ID 17762 //
     /* 2149779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2149790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2149793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2149796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2149799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2149802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149825 */     // MIs[0] round
     /* 2149825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149828 */     // MIs[0] policy
     /* 2149828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149838 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2149841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149864 */     // GIR_Coverage, 17762,
     /* 2149864 */     GIR_EraseRootFromParent_Done,
     /* 2149865 */   // Label 28378: @2149865
     /* 2149865 */   GIM_Try, /*On fail goto*//*Label 28379*/ GIMT_Encode4(2149956), // Rule ID 17763 //
     /* 2149870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2149873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2149881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2149884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2149887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2149890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2149893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149916 */     // MIs[0] round
     /* 2149916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149919 */     // MIs[0] policy
     /* 2149919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149929 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2149932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149955 */     // GIR_Coverage, 17763,
     /* 2149955 */     GIR_EraseRootFromParent_Done,
     /* 2149956 */   // Label 28379: @2149956
     /* 2149956 */   GIM_Try, /*On fail goto*//*Label 28380*/ GIMT_Encode4(2150047), // Rule ID 17766 //
     /* 2149961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2149964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2149972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2149975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2149978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2149981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2149984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150007 */     // MIs[0] round
     /* 2150007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150010 */     // MIs[0] policy
     /* 2150010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150020 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2150023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150046 */     // GIR_Coverage, 17766,
     /* 2150046 */     GIR_EraseRootFromParent_Done,
     /* 2150047 */   // Label 28380: @2150047
     /* 2150047 */   GIM_Try, /*On fail goto*//*Label 28381*/ GIMT_Encode4(2150138), // Rule ID 17767 //
     /* 2150052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2150063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2150066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2150069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2150072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2150075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150098 */     // MIs[0] round
     /* 2150098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150101 */     // MIs[0] policy
     /* 2150101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150111 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2150114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150137 */     // GIR_Coverage, 17767,
     /* 2150137 */     GIR_EraseRootFromParent_Done,
     /* 2150138 */   // Label 28381: @2150138
     /* 2150138 */   GIM_Try, /*On fail goto*//*Label 28382*/ GIMT_Encode4(2150229), // Rule ID 17770 //
     /* 2150143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2150146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2150154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2150157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2150160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2150163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150189 */     // MIs[0] round
     /* 2150189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150192 */     // MIs[0] policy
     /* 2150192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150202 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2150205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150228 */     // GIR_Coverage, 17770,
     /* 2150228 */     GIR_EraseRootFromParent_Done,
     /* 2150229 */   // Label 28382: @2150229
     /* 2150229 */   GIM_Try, /*On fail goto*//*Label 28383*/ GIMT_Encode4(2150320), // Rule ID 17771 //
     /* 2150234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2150237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2150245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2150248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2150251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2150254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150280 */     // MIs[0] round
     /* 2150280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150283 */     // MIs[0] policy
     /* 2150283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150293 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2150296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150319 */     // GIR_Coverage, 17771,
     /* 2150319 */     GIR_EraseRootFromParent_Done,
     /* 2150320 */   // Label 28383: @2150320
     /* 2150320 */   GIM_Try, /*On fail goto*//*Label 28384*/ GIMT_Encode4(2150411), // Rule ID 17774 //
     /* 2150325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2150328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2150336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2150339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2150342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2150345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2150348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150371 */     // MIs[0] round
     /* 2150371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150374 */     // MIs[0] policy
     /* 2150374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150384 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2150387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150410 */     // GIR_Coverage, 17774,
     /* 2150410 */     GIR_EraseRootFromParent_Done,
     /* 2150411 */   // Label 28384: @2150411
     /* 2150411 */   GIM_Try, /*On fail goto*//*Label 28385*/ GIMT_Encode4(2150502), // Rule ID 17775 //
     /* 2150416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2150419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2150427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2150430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2150433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2150436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2150439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150462 */     // MIs[0] round
     /* 2150462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150465 */     // MIs[0] policy
     /* 2150465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150475 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2150478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150501 */     // GIR_Coverage, 17775,
     /* 2150501 */     GIR_EraseRootFromParent_Done,
     /* 2150502 */   // Label 28385: @2150502
     /* 2150502 */   GIM_Try, /*On fail goto*//*Label 28386*/ GIMT_Encode4(2150593), // Rule ID 17778 //
     /* 2150507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2150510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2150518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2150527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2150530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150553 */     // MIs[0] round
     /* 2150553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150556 */     // MIs[0] policy
     /* 2150556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150566 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2150569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150592 */     // GIR_Coverage, 17778,
     /* 2150592 */     GIR_EraseRootFromParent_Done,
     /* 2150593 */   // Label 28386: @2150593
     /* 2150593 */   GIM_Try, /*On fail goto*//*Label 28387*/ GIMT_Encode4(2150684), // Rule ID 17779 //
     /* 2150598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2150601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2150609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2150618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2150621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150644 */     // MIs[0] round
     /* 2150644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150647 */     // MIs[0] policy
     /* 2150647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150657 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2150660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150683 */     // GIR_Coverage, 17779,
     /* 2150683 */     GIR_EraseRootFromParent_Done,
     /* 2150684 */   // Label 28387: @2150684
     /* 2150684 */   GIM_Try, /*On fail goto*//*Label 28388*/ GIMT_Encode4(2150775), // Rule ID 17782 //
     /* 2150689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2150692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2150700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2150703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2150706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2150709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150735 */     // MIs[0] round
     /* 2150735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150738 */     // MIs[0] policy
     /* 2150738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150748 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2150751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150774 */     // GIR_Coverage, 17782,
     /* 2150774 */     GIR_EraseRootFromParent_Done,
     /* 2150775 */   // Label 28388: @2150775
     /* 2150775 */   GIM_Try, /*On fail goto*//*Label 28389*/ GIMT_Encode4(2150866), // Rule ID 17783 //
     /* 2150780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2150783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2150791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2150794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2150797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2150800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150826 */     // MIs[0] round
     /* 2150826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150829 */     // MIs[0] policy
     /* 2150829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150839 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2150842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150865 */     // GIR_Coverage, 17783,
     /* 2150865 */     GIR_EraseRootFromParent_Done,
     /* 2150866 */   // Label 28389: @2150866
     /* 2150866 */   GIM_Try, /*On fail goto*//*Label 28390*/ GIMT_Encode4(2150957), // Rule ID 17786 //
     /* 2150871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2150874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2150882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2150885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2150888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2150891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150917 */     // MIs[0] round
     /* 2150917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150920 */     // MIs[0] policy
     /* 2150920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150930 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2150933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150956 */     // GIR_Coverage, 17786,
     /* 2150956 */     GIR_EraseRootFromParent_Done,
     /* 2150957 */   // Label 28390: @2150957
     /* 2150957 */   GIM_Try, /*On fail goto*//*Label 28391*/ GIMT_Encode4(2151048), // Rule ID 17787 //
     /* 2150962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2150965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2150973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2150976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2150979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2150982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151008 */     // MIs[0] round
     /* 2151008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151011 */     // MIs[0] policy
     /* 2151011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151021 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2151024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151047 */     // GIR_Coverage, 17787,
     /* 2151047 */     GIR_EraseRootFromParent_Done,
     /* 2151048 */   // Label 28391: @2151048
     /* 2151048 */   GIM_Try, /*On fail goto*//*Label 28392*/ GIMT_Encode4(2151139), // Rule ID 17790 //
     /* 2151053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2151056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2151061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2151064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2151067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2151070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2151073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2151076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2151083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151099 */     // MIs[0] round
     /* 2151099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151102 */     // MIs[0] policy
     /* 2151102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151112 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2151115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151138 */     // GIR_Coverage, 17790,
     /* 2151138 */     GIR_EraseRootFromParent_Done,
     /* 2151139 */   // Label 28392: @2151139
     /* 2151139 */   GIM_Try, /*On fail goto*//*Label 28393*/ GIMT_Encode4(2151230), // Rule ID 17791 //
     /* 2151144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2151147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2151152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2151155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2151158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2151161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2151164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2151167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2151174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151190 */     // MIs[0] round
     /* 2151190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151193 */     // MIs[0] policy
     /* 2151193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151203 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2151206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151229 */     // GIR_Coverage, 17791,
     /* 2151229 */     GIR_EraseRootFromParent_Done,
     /* 2151230 */   // Label 28393: @2151230
     /* 2151230 */   GIM_Try, /*On fail goto*//*Label 28394*/ GIMT_Encode4(2151321), // Rule ID 17794 //
     /* 2151235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2151238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2151243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2151246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2151249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2151252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2151255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2151265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151281 */     // MIs[0] round
     /* 2151281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151284 */     // MIs[0] policy
     /* 2151284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151294 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2151297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151320 */     // GIR_Coverage, 17794,
     /* 2151320 */     GIR_EraseRootFromParent_Done,
     /* 2151321 */   // Label 28394: @2151321
     /* 2151321 */   GIM_Try, /*On fail goto*//*Label 28395*/ GIMT_Encode4(2151412), // Rule ID 17795 //
     /* 2151326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2151329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2151334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2151337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2151340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2151343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2151346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2151356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151372 */     // MIs[0] round
     /* 2151372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151375 */     // MIs[0] policy
     /* 2151375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151385 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2151388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151411 */     // GIR_Coverage, 17795,
     /* 2151411 */     GIR_EraseRootFromParent_Done,
     /* 2151412 */   // Label 28395: @2151412
     /* 2151412 */   GIM_Try, /*On fail goto*//*Label 28396*/ GIMT_Encode4(2151503), // Rule ID 17798 //
     /* 2151417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2151420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2151425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2151428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2151431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2151434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2151437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2151447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151463 */     // MIs[0] round
     /* 2151463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151466 */     // MIs[0] policy
     /* 2151466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151476 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2151479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151502 */     // GIR_Coverage, 17798,
     /* 2151502 */     GIR_EraseRootFromParent_Done,
     /* 2151503 */   // Label 28396: @2151503
     /* 2151503 */   GIM_Try, /*On fail goto*//*Label 28397*/ GIMT_Encode4(2151594), // Rule ID 17799 //
     /* 2151508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2151511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2151516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2151519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2151522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2151525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2151528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2151538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151554 */     // MIs[0] round
     /* 2151554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151557 */     // MIs[0] policy
     /* 2151557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151567 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2151570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151593 */     // GIR_Coverage, 17799,
     /* 2151593 */     GIR_EraseRootFromParent_Done,
     /* 2151594 */   // Label 28397: @2151594
     /* 2151594 */   GIM_Try, /*On fail goto*//*Label 28398*/ GIMT_Encode4(2151685), // Rule ID 17802 //
     /* 2151599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2151602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2151607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2151610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2151613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2151616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2151619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2151629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151645 */     // MIs[0] round
     /* 2151645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151648 */     // MIs[0] policy
     /* 2151648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151658 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2151661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151684 */     // GIR_Coverage, 17802,
     /* 2151684 */     GIR_EraseRootFromParent_Done,
     /* 2151685 */   // Label 28398: @2151685
     /* 2151685 */   GIM_Try, /*On fail goto*//*Label 28399*/ GIMT_Encode4(2151776), // Rule ID 17803 //
     /* 2151690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2151693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2151698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2151701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2151704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2151707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2151710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2151720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151736 */     // MIs[0] round
     /* 2151736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151739 */     // MIs[0] policy
     /* 2151739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151749 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2151752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151775 */     // GIR_Coverage, 17803,
     /* 2151775 */     GIR_EraseRootFromParent_Done,
     /* 2151776 */   // Label 28399: @2151776
     /* 2151776 */   GIM_Try, /*On fail goto*//*Label 28400*/ GIMT_Encode4(2151867), // Rule ID 17806 //
     /* 2151781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2151789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2151792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2151795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2151798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2151801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2151819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151827 */     // MIs[0] round
     /* 2151827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151830 */     // MIs[0] policy
     /* 2151830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151840 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2151843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151866 */     // GIR_Coverage, 17806,
     /* 2151866 */     GIR_EraseRootFromParent_Done,
     /* 2151867 */   // Label 28400: @2151867
     /* 2151867 */   GIM_Try, /*On fail goto*//*Label 28401*/ GIMT_Encode4(2151958), // Rule ID 17807 //
     /* 2151872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2151880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2151883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2151886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2151889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2151892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2151910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151918 */     // MIs[0] round
     /* 2151918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151921 */     // MIs[0] policy
     /* 2151921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151931 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2151934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151957 */     // GIR_Coverage, 17807,
     /* 2151957 */     GIR_EraseRootFromParent_Done,
     /* 2151958 */   // Label 28401: @2151958
     /* 2151958 */   GIM_Try, /*On fail goto*//*Label 28402*/ GIMT_Encode4(2152049), // Rule ID 17810 //
     /* 2151963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2151971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2151974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2151977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2151980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2151983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2152001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152009 */     // MIs[0] round
     /* 2152009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152012 */     // MIs[0] policy
     /* 2152012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152022 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2152025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152048 */     // GIR_Coverage, 17810,
     /* 2152048 */     GIR_EraseRootFromParent_Done,
     /* 2152049 */   // Label 28402: @2152049
     /* 2152049 */   GIM_Try, /*On fail goto*//*Label 28403*/ GIMT_Encode4(2152140), // Rule ID 17811 //
     /* 2152054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2152062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2152065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2152068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2152071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2152074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2152077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2152092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152100 */     // MIs[0] round
     /* 2152100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152103 */     // MIs[0] policy
     /* 2152103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152113 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2152116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152139 */     // GIR_Coverage, 17811,
     /* 2152139 */     GIR_EraseRootFromParent_Done,
     /* 2152140 */   // Label 28403: @2152140
     /* 2152140 */   GIM_Try, /*On fail goto*//*Label 28404*/ GIMT_Encode4(2152231), // Rule ID 17814 //
     /* 2152145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2152153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2152156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2152159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2152162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2152165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2152168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152191 */     // MIs[0] round
     /* 2152191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152194 */     // MIs[0] policy
     /* 2152194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152204 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2152207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152230 */     // GIR_Coverage, 17814,
     /* 2152230 */     GIR_EraseRootFromParent_Done,
     /* 2152231 */   // Label 28404: @2152231
     /* 2152231 */   GIM_Try, /*On fail goto*//*Label 28405*/ GIMT_Encode4(2152322), // Rule ID 17815 //
     /* 2152236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2152244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2152247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2152250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2152253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2152256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2152259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152282 */     // MIs[0] round
     /* 2152282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152285 */     // MIs[0] policy
     /* 2152285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152295 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2152298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152321 */     // GIR_Coverage, 17815,
     /* 2152321 */     GIR_EraseRootFromParent_Done,
     /* 2152322 */   // Label 28405: @2152322
     /* 2152322 */   GIM_Try, /*On fail goto*//*Label 28406*/ GIMT_Encode4(2152413), // Rule ID 17818 //
     /* 2152327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2152330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2152335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2152338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2152341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2152344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2152347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2152365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152373 */     // MIs[0] round
     /* 2152373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152376 */     // MIs[0] policy
     /* 2152376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152386 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2152389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152412 */     // GIR_Coverage, 17818,
     /* 2152412 */     GIR_EraseRootFromParent_Done,
     /* 2152413 */   // Label 28406: @2152413
     /* 2152413 */   GIM_Try, /*On fail goto*//*Label 28407*/ GIMT_Encode4(2152504), // Rule ID 17819 //
     /* 2152418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2152426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2152429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2152432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2152435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2152438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2152456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152464 */     // MIs[0] round
     /* 2152464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152467 */     // MIs[0] policy
     /* 2152467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152477 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2152480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152503 */     // GIR_Coverage, 17819,
     /* 2152503 */     GIR_EraseRootFromParent_Done,
     /* 2152504 */   // Label 28407: @2152504
     /* 2152504 */   GIM_Try, /*On fail goto*//*Label 28408*/ GIMT_Encode4(2152595), // Rule ID 17822 //
     /* 2152509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2152517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2152520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2152523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2152526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2152529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2152532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152555 */     // MIs[0] round
     /* 2152555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152558 */     // MIs[0] policy
     /* 2152558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152568 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2152571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152594 */     // GIR_Coverage, 17822,
     /* 2152594 */     GIR_EraseRootFromParent_Done,
     /* 2152595 */   // Label 28408: @2152595
     /* 2152595 */   GIM_Try, /*On fail goto*//*Label 28409*/ GIMT_Encode4(2152686), // Rule ID 17823 //
     /* 2152600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2152608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2152611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2152614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2152617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2152620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2152623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152646 */     // MIs[0] round
     /* 2152646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152649 */     // MIs[0] policy
     /* 2152649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152659 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2152662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152685 */     // GIR_Coverage, 17823,
     /* 2152685 */     GIR_EraseRootFromParent_Done,
     /* 2152686 */   // Label 28409: @2152686
     /* 2152686 */   GIM_Try, /*On fail goto*//*Label 28410*/ GIMT_Encode4(2152777), // Rule ID 17826 //
     /* 2152691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2152694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2152699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2152702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2152705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2152708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2152711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2152714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2152729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152737 */     // MIs[0] round
     /* 2152737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152740 */     // MIs[0] policy
     /* 2152740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152750 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2152753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152776 */     // GIR_Coverage, 17826,
     /* 2152776 */     GIR_EraseRootFromParent_Done,
     /* 2152777 */   // Label 28410: @2152777
     /* 2152777 */   GIM_Try, /*On fail goto*//*Label 28411*/ GIMT_Encode4(2152868), // Rule ID 17827 //
     /* 2152782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2152785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2152790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2152793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2152796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2152799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2152802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2152805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2152820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152828 */     // MIs[0] round
     /* 2152828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152831 */     // MIs[0] policy
     /* 2152831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152841 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2152844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152867 */     // GIR_Coverage, 17827,
     /* 2152867 */     GIR_EraseRootFromParent_Done,
     /* 2152868 */   // Label 28411: @2152868
     /* 2152868 */   GIM_Try, /*On fail goto*//*Label 28412*/ GIMT_Encode4(2152959), // Rule ID 17830 //
     /* 2152873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2152876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2152881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2152884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2152887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2152890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2152893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2152911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152919 */     // MIs[0] round
     /* 2152919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152922 */     // MIs[0] policy
     /* 2152922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152932 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2152935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152958 */     // GIR_Coverage, 17830,
     /* 2152958 */     GIR_EraseRootFromParent_Done,
     /* 2152959 */   // Label 28412: @2152959
     /* 2152959 */   GIM_Try, /*On fail goto*//*Label 28413*/ GIMT_Encode4(2153050), // Rule ID 17831 //
     /* 2152964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2152972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2152975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2152978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2152981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2152984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153010 */     // MIs[0] round
     /* 2153010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153013 */     // MIs[0] policy
     /* 2153013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153023 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2153026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153049 */     // GIR_Coverage, 17831,
     /* 2153049 */     GIR_EraseRootFromParent_Done,
     /* 2153050 */   // Label 28413: @2153050
     /* 2153050 */   GIM_Try, /*On fail goto*//*Label 28414*/ GIMT_Encode4(2153141), // Rule ID 17834 //
     /* 2153055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2153063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2153066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2153069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2153075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2153078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153101 */     // MIs[0] round
     /* 2153101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153104 */     // MIs[0] policy
     /* 2153104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153114 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2153117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153140 */     // GIR_Coverage, 17834,
     /* 2153140 */     GIR_EraseRootFromParent_Done,
     /* 2153141 */   // Label 28414: @2153141
     /* 2153141 */   GIM_Try, /*On fail goto*//*Label 28415*/ GIMT_Encode4(2153232), // Rule ID 17835 //
     /* 2153146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2153154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2153157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2153160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2153166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2153169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153192 */     // MIs[0] round
     /* 2153192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153195 */     // MIs[0] policy
     /* 2153195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153205 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2153208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153231 */     // GIR_Coverage, 17835,
     /* 2153231 */     GIR_EraseRootFromParent_Done,
     /* 2153232 */   // Label 28415: @2153232
     /* 2153232 */   GIM_Try, /*On fail goto*//*Label 28416*/ GIMT_Encode4(2153323), // Rule ID 17838 //
     /* 2153237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2153245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2153248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2153251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2153257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2153260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153283 */     // MIs[0] round
     /* 2153283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153286 */     // MIs[0] policy
     /* 2153286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153296 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2153299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153322 */     // GIR_Coverage, 17838,
     /* 2153322 */     GIR_EraseRootFromParent_Done,
     /* 2153323 */   // Label 28416: @2153323
     /* 2153323 */   GIM_Try, /*On fail goto*//*Label 28417*/ GIMT_Encode4(2153414), // Rule ID 17839 //
     /* 2153328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2153336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2153339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2153342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2153348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2153351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153374 */     // MIs[0] round
     /* 2153374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153377 */     // MIs[0] policy
     /* 2153377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153387 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2153390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153413 */     // GIR_Coverage, 17839,
     /* 2153413 */     GIR_EraseRootFromParent_Done,
     /* 2153414 */   // Label 28417: @2153414
     /* 2153414 */   GIM_Try, /*On fail goto*//*Label 28418*/ GIMT_Encode4(2153505), // Rule ID 17842 //
     /* 2153419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2153422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2153427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2153430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2153433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2153439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2153449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153465 */     // MIs[0] round
     /* 2153465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153468 */     // MIs[0] policy
     /* 2153468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153478 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2153481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153504 */     // GIR_Coverage, 17842,
     /* 2153504 */     GIR_EraseRootFromParent_Done,
     /* 2153505 */   // Label 28418: @2153505
     /* 2153505 */   GIM_Try, /*On fail goto*//*Label 28419*/ GIMT_Encode4(2153596), // Rule ID 17843 //
     /* 2153510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2153513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2153518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2153521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2153524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2153530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2153540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153556 */     // MIs[0] round
     /* 2153556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153559 */     // MIs[0] policy
     /* 2153559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153569 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2153572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153595 */     // GIR_Coverage, 17843,
     /* 2153595 */     GIR_EraseRootFromParent_Done,
     /* 2153596 */   // Label 28419: @2153596
     /* 2153596 */   GIM_Try, /*On fail goto*//*Label 28420*/ GIMT_Encode4(2153687), // Rule ID 17846 //
     /* 2153601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2153604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2153609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2153612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2153615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2153621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153647 */     // MIs[0] round
     /* 2153647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153650 */     // MIs[0] policy
     /* 2153650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153660 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2153663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153686 */     // GIR_Coverage, 17846,
     /* 2153686 */     GIR_EraseRootFromParent_Done,
     /* 2153687 */   // Label 28420: @2153687
     /* 2153687 */   GIM_Try, /*On fail goto*//*Label 28421*/ GIMT_Encode4(2153778), // Rule ID 17847 //
     /* 2153692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2153695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2153700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2153703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2153706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2153712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153738 */     // MIs[0] round
     /* 2153738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153741 */     // MIs[0] policy
     /* 2153741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153751 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2153754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153777 */     // GIR_Coverage, 17847,
     /* 2153777 */     GIR_EraseRootFromParent_Done,
     /* 2153778 */   // Label 28421: @2153778
     /* 2153778 */   GIM_Try, /*On fail goto*//*Label 28422*/ GIMT_Encode4(2153869), // Rule ID 17850 //
     /* 2153783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2153786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2153791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2153794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2153797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2153803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2153806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153829 */     // MIs[0] round
     /* 2153829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153832 */     // MIs[0] policy
     /* 2153832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153842 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2153845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153868 */     // GIR_Coverage, 17850,
     /* 2153868 */     GIR_EraseRootFromParent_Done,
     /* 2153869 */   // Label 28422: @2153869
     /* 2153869 */   GIM_Try, /*On fail goto*//*Label 28423*/ GIMT_Encode4(2153960), // Rule ID 17851 //
     /* 2153874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2153877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2153882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2153885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2153888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2153894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2153897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153920 */     // MIs[0] round
     /* 2153920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153923 */     // MIs[0] policy
     /* 2153923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153933 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2153936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153959 */     // GIR_Coverage, 17851,
     /* 2153959 */     GIR_EraseRootFromParent_Done,
     /* 2153960 */   // Label 28423: @2153960
     /* 2153960 */   GIM_Try, /*On fail goto*//*Label 28424*/ GIMT_Encode4(2154051), // Rule ID 17854 //
     /* 2153965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2153968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2153973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2153976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2153979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2153982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2153985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2153988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2153995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154011 */     // MIs[0] round
     /* 2154011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154014 */     // MIs[0] policy
     /* 2154014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154024 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2154027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154050 */     // GIR_Coverage, 17854,
     /* 2154050 */     GIR_EraseRootFromParent_Done,
     /* 2154051 */   // Label 28424: @2154051
     /* 2154051 */   GIM_Try, /*On fail goto*//*Label 28425*/ GIMT_Encode4(2154142), // Rule ID 17855 //
     /* 2154056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2154059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2154064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2154067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2154070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2154076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2154086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154102 */     // MIs[0] round
     /* 2154102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154105 */     // MIs[0] policy
     /* 2154105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154115 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2154118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154141 */     // GIR_Coverage, 17855,
     /* 2154141 */     GIR_EraseRootFromParent_Done,
     /* 2154142 */   // Label 28425: @2154142
     /* 2154142 */   GIM_Try, /*On fail goto*//*Label 28426*/ GIMT_Encode4(2154233), // Rule ID 17858 //
     /* 2154147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2154150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2154155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2154158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2154161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2154167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2154170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2154177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154193 */     // MIs[0] round
     /* 2154193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154196 */     // MIs[0] policy
     /* 2154196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154206 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2154209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154232 */     // GIR_Coverage, 17858,
     /* 2154232 */     GIR_EraseRootFromParent_Done,
     /* 2154233 */   // Label 28426: @2154233
     /* 2154233 */   GIM_Try, /*On fail goto*//*Label 28427*/ GIMT_Encode4(2154324), // Rule ID 17859 //
     /* 2154238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2154241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2154246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2154249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2154252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2154258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2154261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2154268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154284 */     // MIs[0] round
     /* 2154284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154287 */     // MIs[0] policy
     /* 2154287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154297 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2154300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154323 */     // GIR_Coverage, 17859,
     /* 2154323 */     GIR_EraseRootFromParent_Done,
     /* 2154324 */   // Label 28427: @2154324
     /* 2154324 */   GIM_Try, /*On fail goto*//*Label 28428*/ GIMT_Encode4(2154415), // Rule ID 17862 //
     /* 2154329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2154332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2154337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2154340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2154343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2154349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2154352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2154359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154375 */     // MIs[0] round
     /* 2154375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154378 */     // MIs[0] policy
     /* 2154378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154388 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2154391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154414 */     // GIR_Coverage, 17862,
     /* 2154414 */     GIR_EraseRootFromParent_Done,
     /* 2154415 */   // Label 28428: @2154415
     /* 2154415 */   GIM_Try, /*On fail goto*//*Label 28429*/ GIMT_Encode4(2154506), // Rule ID 17863 //
     /* 2154420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2154423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2154428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2154431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2154434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2154440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2154443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2154450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154466 */     // MIs[0] round
     /* 2154466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154469 */     // MIs[0] policy
     /* 2154469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154479 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2154482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154505 */     // GIR_Coverage, 17863,
     /* 2154505 */     GIR_EraseRootFromParent_Done,
     /* 2154506 */   // Label 28429: @2154506
     /* 2154506 */   GIM_Try, /*On fail goto*//*Label 28430*/ GIMT_Encode4(2154597), // Rule ID 17866 //
     /* 2154511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2154522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2154525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2154528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2154531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154557 */     // MIs[0] round
     /* 2154557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154560 */     // MIs[0] policy
     /* 2154560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154570 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2154573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154596 */     // GIR_Coverage, 17866,
     /* 2154596 */     GIR_EraseRootFromParent_Done,
     /* 2154597 */   // Label 28430: @2154597
     /* 2154597 */   GIM_Try, /*On fail goto*//*Label 28431*/ GIMT_Encode4(2154688), // Rule ID 17867 //
     /* 2154602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2154613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2154616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2154619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2154622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154648 */     // MIs[0] round
     /* 2154648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154651 */     // MIs[0] policy
     /* 2154651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154661 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2154664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154687 */     // GIR_Coverage, 17867,
     /* 2154687 */     GIR_EraseRootFromParent_Done,
     /* 2154688 */   // Label 28431: @2154688
     /* 2154688 */   GIM_Try, /*On fail goto*//*Label 28432*/ GIMT_Encode4(2154779), // Rule ID 17870 //
     /* 2154693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2154704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2154707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2154710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2154713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154739 */     // MIs[0] round
     /* 2154739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154742 */     // MIs[0] policy
     /* 2154742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154752 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2154755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154778 */     // GIR_Coverage, 17870,
     /* 2154778 */     GIR_EraseRootFromParent_Done,
     /* 2154779 */   // Label 28432: @2154779
     /* 2154779 */   GIM_Try, /*On fail goto*//*Label 28433*/ GIMT_Encode4(2154870), // Rule ID 17871 //
     /* 2154784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2154795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2154798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2154801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2154804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154830 */     // MIs[0] round
     /* 2154830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154833 */     // MIs[0] policy
     /* 2154833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154843 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2154846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154869 */     // GIR_Coverage, 17871,
     /* 2154869 */     GIR_EraseRootFromParent_Done,
     /* 2154870 */   // Label 28433: @2154870
     /* 2154870 */   GIM_Try, /*On fail goto*//*Label 28434*/ GIMT_Encode4(2154961), // Rule ID 17874 //
     /* 2154875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2154878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2154886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2154889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2154892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2154895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154921 */     // MIs[0] round
     /* 2154921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154924 */     // MIs[0] policy
     /* 2154924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154934 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2154937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154960 */     // GIR_Coverage, 17874,
     /* 2154960 */     GIR_EraseRootFromParent_Done,
     /* 2154961 */   // Label 28434: @2154961
     /* 2154961 */   GIM_Try, /*On fail goto*//*Label 28435*/ GIMT_Encode4(2155052), // Rule ID 17875 //
     /* 2154966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2154969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2154977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2154980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2154983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2154986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155012 */     // MIs[0] round
     /* 2155012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155015 */     // MIs[0] policy
     /* 2155015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155025 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2155028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155051 */     // GIR_Coverage, 17875,
     /* 2155051 */     GIR_EraseRootFromParent_Done,
     /* 2155052 */   // Label 28435: @2155052
     /* 2155052 */   GIM_Try, /*On fail goto*//*Label 28436*/ GIMT_Encode4(2155143), // Rule ID 17878 //
     /* 2155057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2155068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2155071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2155074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2155077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155103 */     // MIs[0] round
     /* 2155103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155106 */     // MIs[0] policy
     /* 2155106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155116 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2155119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155142 */     // GIR_Coverage, 17878,
     /* 2155142 */     GIR_EraseRootFromParent_Done,
     /* 2155143 */   // Label 28436: @2155143
     /* 2155143 */   GIM_Try, /*On fail goto*//*Label 28437*/ GIMT_Encode4(2155234), // Rule ID 17879 //
     /* 2155148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2155159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2155162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2155165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2155168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155194 */     // MIs[0] round
     /* 2155194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155197 */     // MIs[0] policy
     /* 2155197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155207 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2155210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155233 */     // GIR_Coverage, 17879,
     /* 2155233 */     GIR_EraseRootFromParent_Done,
     /* 2155234 */   // Label 28437: @2155234
     /* 2155234 */   GIM_Try, /*On fail goto*//*Label 28438*/ GIMT_Encode4(2155325), // Rule ID 17882 //
     /* 2155239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2155250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2155253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2155256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2155259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2155262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155285 */     // MIs[0] round
     /* 2155285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155288 */     // MIs[0] policy
     /* 2155288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155298 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2155301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155324 */     // GIR_Coverage, 17882,
     /* 2155324 */     GIR_EraseRootFromParent_Done,
     /* 2155325 */   // Label 28438: @2155325
     /* 2155325 */   GIM_Try, /*On fail goto*//*Label 28439*/ GIMT_Encode4(2155416), // Rule ID 17883 //
     /* 2155330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2155341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2155344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2155347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2155350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2155353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155376 */     // MIs[0] round
     /* 2155376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155379 */     // MIs[0] policy
     /* 2155379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155389 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2155392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155415 */     // GIR_Coverage, 17883,
     /* 2155415 */     GIR_EraseRootFromParent_Done,
     /* 2155416 */   // Label 28439: @2155416
     /* 2155416 */   GIM_Try, /*On fail goto*//*Label 28440*/ GIMT_Encode4(2155507), // Rule ID 17886 //
     /* 2155421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2155432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2155435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2155438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2155441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2155444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155467 */     // MIs[0] round
     /* 2155467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155470 */     // MIs[0] policy
     /* 2155470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155480 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2155483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155506 */     // GIR_Coverage, 17886,
     /* 2155506 */     GIR_EraseRootFromParent_Done,
     /* 2155507 */   // Label 28440: @2155507
     /* 2155507 */   GIM_Try, /*On fail goto*//*Label 28441*/ GIMT_Encode4(2155598), // Rule ID 17887 //
     /* 2155512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2155515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2155523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2155526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2155529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2155532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2155535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155558 */     // MIs[0] round
     /* 2155558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155561 */     // MIs[0] policy
     /* 2155561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155571 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2155574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155597 */     // GIR_Coverage, 17887,
     /* 2155597 */     GIR_EraseRootFromParent_Done,
     /* 2155598 */   // Label 28441: @2155598
     /* 2155598 */   GIM_Try, /*On fail goto*//*Label 28442*/ GIMT_Encode4(2155689), // Rule ID 17890 //
     /* 2155603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2155614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2155617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2155620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2155623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155649 */     // MIs[0] round
     /* 2155649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155652 */     // MIs[0] policy
     /* 2155652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155662 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2155665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155688 */     // GIR_Coverage, 17890,
     /* 2155688 */     GIR_EraseRootFromParent_Done,
     /* 2155689 */   // Label 28442: @2155689
     /* 2155689 */   GIM_Try, /*On fail goto*//*Label 28443*/ GIMT_Encode4(2155780), // Rule ID 17891 //
     /* 2155694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2155705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2155708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2155711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2155714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155740 */     // MIs[0] round
     /* 2155740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155743 */     // MIs[0] policy
     /* 2155743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155753 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2155756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155779 */     // GIR_Coverage, 17891,
     /* 2155779 */     GIR_EraseRootFromParent_Done,
     /* 2155780 */   // Label 28443: @2155780
     /* 2155780 */   GIM_Try, /*On fail goto*//*Label 28444*/ GIMT_Encode4(2155871), // Rule ID 17894 //
     /* 2155785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2155796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2155799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2155802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2155805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155831 */     // MIs[0] round
     /* 2155831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155834 */     // MIs[0] policy
     /* 2155834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155844 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2155847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155870 */     // GIR_Coverage, 17894,
     /* 2155870 */     GIR_EraseRootFromParent_Done,
     /* 2155871 */   // Label 28444: @2155871
     /* 2155871 */   GIM_Try, /*On fail goto*//*Label 28445*/ GIMT_Encode4(2155962), // Rule ID 17895 //
     /* 2155876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2155887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2155890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2155893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2155896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155922 */     // MIs[0] round
     /* 2155922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155925 */     // MIs[0] policy
     /* 2155925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155935 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2155938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155961 */     // GIR_Coverage, 17895,
     /* 2155961 */     GIR_EraseRootFromParent_Done,
     /* 2155962 */   // Label 28445: @2155962
     /* 2155962 */   GIM_Try, /*On fail goto*//*Label 28446*/ GIMT_Encode4(2156053), // Rule ID 17898 //
     /* 2155967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2155978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2155981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2155984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2155987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2155990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156013 */     // MIs[0] round
     /* 2156013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156016 */     // MIs[0] policy
     /* 2156016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156026 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2156029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156052 */     // GIR_Coverage, 17898,
     /* 2156052 */     GIR_EraseRootFromParent_Done,
     /* 2156053 */   // Label 28446: @2156053
     /* 2156053 */   GIM_Try, /*On fail goto*//*Label 28447*/ GIMT_Encode4(2156144), // Rule ID 17899 //
     /* 2156058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2156069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2156072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2156075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2156078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2156081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2156088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156104 */     // MIs[0] round
     /* 2156104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156107 */     // MIs[0] policy
     /* 2156107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156117 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2156120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156143 */     // GIR_Coverage, 17899,
     /* 2156143 */     GIR_EraseRootFromParent_Done,
     /* 2156144 */   // Label 28447: @2156144
     /* 2156144 */   GIM_Try, /*On fail goto*//*Label 28448*/ GIMT_Encode4(2156235), // Rule ID 17902 //
     /* 2156149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2156160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2156163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2156166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2156169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2156179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156195 */     // MIs[0] round
     /* 2156195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156198 */     // MIs[0] policy
     /* 2156198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156208 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2156211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156234 */     // GIR_Coverage, 17902,
     /* 2156234 */     GIR_EraseRootFromParent_Done,
     /* 2156235 */   // Label 28448: @2156235
     /* 2156235 */   GIM_Try, /*On fail goto*//*Label 28449*/ GIMT_Encode4(2156326), // Rule ID 17903 //
     /* 2156240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2156251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2156254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2156257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2156260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2156270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156286 */     // MIs[0] round
     /* 2156286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156289 */     // MIs[0] policy
     /* 2156289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156299 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2156302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156325 */     // GIR_Coverage, 17903,
     /* 2156325 */     GIR_EraseRootFromParent_Done,
     /* 2156326 */   // Label 28449: @2156326
     /* 2156326 */   GIM_Try, /*On fail goto*//*Label 28450*/ GIMT_Encode4(2156417), // Rule ID 17906 //
     /* 2156331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2156342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2156345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2156348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2156351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2156354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2156361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156377 */     // MIs[0] round
     /* 2156377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156380 */     // MIs[0] policy
     /* 2156380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156390 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2156393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156416 */     // GIR_Coverage, 17906,
     /* 2156416 */     GIR_EraseRootFromParent_Done,
     /* 2156417 */   // Label 28450: @2156417
     /* 2156417 */   GIM_Try, /*On fail goto*//*Label 28451*/ GIMT_Encode4(2156508), // Rule ID 17907 //
     /* 2156422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2156433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2156436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2156439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2156442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2156445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2156452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156468 */     // MIs[0] round
     /* 2156468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156471 */     // MIs[0] policy
     /* 2156471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156481 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2156484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156507 */     // GIR_Coverage, 17907,
     /* 2156507 */     GIR_EraseRootFromParent_Done,
     /* 2156508 */   // Label 28451: @2156508
     /* 2156508 */   GIM_Try, /*On fail goto*//*Label 28452*/ GIMT_Encode4(2156599), // Rule ID 17910 //
     /* 2156513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2156524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2156527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2156530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2156533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2156536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2156543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156559 */     // MIs[0] round
     /* 2156559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156562 */     // MIs[0] policy
     /* 2156562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156572 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2156575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156598 */     // GIR_Coverage, 17910,
     /* 2156598 */     GIR_EraseRootFromParent_Done,
     /* 2156599 */   // Label 28452: @2156599
     /* 2156599 */   GIM_Try, /*On fail goto*//*Label 28453*/ GIMT_Encode4(2156690), // Rule ID 17911 //
     /* 2156604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2156615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2156618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2156621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2156624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2156627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2156634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156650 */     // MIs[0] round
     /* 2156650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156653 */     // MIs[0] policy
     /* 2156653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156663 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2156666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156689 */     // GIR_Coverage, 17911,
     /* 2156689 */     GIR_EraseRootFromParent_Done,
     /* 2156690 */   // Label 28453: @2156690
     /* 2156690 */   GIM_Try, /*On fail goto*//*Label 28454*/ GIMT_Encode4(2156781), // Rule ID 17914 //
     /* 2156695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2156706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2156712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2156715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2156725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156741 */     // MIs[0] round
     /* 2156741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156744 */     // MIs[0] policy
     /* 2156744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156754 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2156757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156780 */     // GIR_Coverage, 17914,
     /* 2156780 */     GIR_EraseRootFromParent_Done,
     /* 2156781 */   // Label 28454: @2156781
     /* 2156781 */   GIM_Try, /*On fail goto*//*Label 28455*/ GIMT_Encode4(2156872), // Rule ID 17915 //
     /* 2156786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2156797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2156803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2156806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2156816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156832 */     // MIs[0] round
     /* 2156832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156835 */     // MIs[0] policy
     /* 2156835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156845 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2156848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156871 */     // GIR_Coverage, 17915,
     /* 2156871 */     GIR_EraseRootFromParent_Done,
     /* 2156872 */   // Label 28455: @2156872
     /* 2156872 */   GIM_Try, /*On fail goto*//*Label 28456*/ GIMT_Encode4(2156963), // Rule ID 17918 //
     /* 2156877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2156888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2156891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2156894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2156897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2156907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156923 */     // MIs[0] round
     /* 2156923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156926 */     // MIs[0] policy
     /* 2156926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156936 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2156939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156962 */     // GIR_Coverage, 17918,
     /* 2156962 */     GIR_EraseRootFromParent_Done,
     /* 2156963 */   // Label 28456: @2156963
     /* 2156963 */   GIM_Try, /*On fail goto*//*Label 28457*/ GIMT_Encode4(2157054), // Rule ID 17919 //
     /* 2156968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2156979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2156982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2156985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2156988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2156998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157014 */     // MIs[0] round
     /* 2157014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157017 */     // MIs[0] policy
     /* 2157017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157027 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2157030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157053 */     // GIR_Coverage, 17919,
     /* 2157053 */     GIR_EraseRootFromParent_Done,
     /* 2157054 */   // Label 28457: @2157054
     /* 2157054 */   GIM_Try, /*On fail goto*//*Label 28458*/ GIMT_Encode4(2157145), // Rule ID 17922 //
     /* 2157059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2157062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2157067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2157070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2157073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2157076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2157079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2157089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157105 */     // MIs[0] round
     /* 2157105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157108 */     // MIs[0] policy
     /* 2157108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157118 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2157121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157144 */     // GIR_Coverage, 17922,
     /* 2157144 */     GIR_EraseRootFromParent_Done,
     /* 2157145 */   // Label 28458: @2157145
     /* 2157145 */   GIM_Try, /*On fail goto*//*Label 28459*/ GIMT_Encode4(2157236), // Rule ID 17923 //
     /* 2157150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2157153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2157158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2157161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2157164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2157167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2157170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2157180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157196 */     // MIs[0] round
     /* 2157196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157199 */     // MIs[0] policy
     /* 2157199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157209 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2157212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157235 */     // GIR_Coverage, 17923,
     /* 2157235 */     GIR_EraseRootFromParent_Done,
     /* 2157236 */   // Label 28459: @2157236
     /* 2157236 */   GIM_Try, /*On fail goto*//*Label 28460*/ GIMT_Encode4(2157327), // Rule ID 17926 //
     /* 2157241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2157249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2157252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2157255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2157258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2157261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2157279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157287 */     // MIs[0] round
     /* 2157287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157290 */     // MIs[0] policy
     /* 2157290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157300 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2157303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157326 */     // GIR_Coverage, 17926,
     /* 2157326 */     GIR_EraseRootFromParent_Done,
     /* 2157327 */   // Label 28460: @2157327
     /* 2157327 */   GIM_Try, /*On fail goto*//*Label 28461*/ GIMT_Encode4(2157418), // Rule ID 17927 //
     /* 2157332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2157340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2157343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2157346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2157349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2157352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2157370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157378 */     // MIs[0] round
     /* 2157378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157381 */     // MIs[0] policy
     /* 2157381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157391 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2157394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157417 */     // GIR_Coverage, 17927,
     /* 2157417 */     GIR_EraseRootFromParent_Done,
     /* 2157418 */   // Label 28461: @2157418
     /* 2157418 */   GIM_Try, /*On fail goto*//*Label 28462*/ GIMT_Encode4(2157509), // Rule ID 17930 //
     /* 2157423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2157431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2157434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2157437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2157440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2157443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2157446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2157461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157469 */     // MIs[0] round
     /* 2157469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157472 */     // MIs[0] policy
     /* 2157472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157482 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2157485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157508 */     // GIR_Coverage, 17930,
     /* 2157508 */     GIR_EraseRootFromParent_Done,
     /* 2157509 */   // Label 28462: @2157509
     /* 2157509 */   GIM_Try, /*On fail goto*//*Label 28463*/ GIMT_Encode4(2157600), // Rule ID 17931 //
     /* 2157514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2157522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2157525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2157528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2157531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2157534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2157537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2157552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157560 */     // MIs[0] round
     /* 2157560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157563 */     // MIs[0] policy
     /* 2157563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157573 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2157576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157599 */     // GIR_Coverage, 17931,
     /* 2157599 */     GIR_EraseRootFromParent_Done,
     /* 2157600 */   // Label 28463: @2157600
     /* 2157600 */   GIM_Try, /*On fail goto*//*Label 28464*/ GIMT_Encode4(2157691), // Rule ID 17934 //
     /* 2157605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2157613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2157616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2157619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2157622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2157625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2157643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157651 */     // MIs[0] round
     /* 2157651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157654 */     // MIs[0] policy
     /* 2157654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157664 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2157667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157690 */     // GIR_Coverage, 17934,
     /* 2157690 */     GIR_EraseRootFromParent_Done,
     /* 2157691 */   // Label 28464: @2157691
     /* 2157691 */   GIM_Try, /*On fail goto*//*Label 28465*/ GIMT_Encode4(2157782), // Rule ID 17935 //
     /* 2157696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2157704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2157707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2157710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2157713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2157716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2157734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157742 */     // MIs[0] round
     /* 2157742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157745 */     // MIs[0] policy
     /* 2157745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157755 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2157758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157781 */     // GIR_Coverage, 17935,
     /* 2157781 */     GIR_EraseRootFromParent_Done,
     /* 2157782 */   // Label 28465: @2157782
     /* 2157782 */   GIM_Try, /*On fail goto*//*Label 28466*/ GIMT_Encode4(2157873), // Rule ID 17938 //
     /* 2157787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2157795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2157798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2157801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2157804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2157807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2157825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157833 */     // MIs[0] round
     /* 2157833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157836 */     // MIs[0] policy
     /* 2157836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157846 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2157849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157872 */     // GIR_Coverage, 17938,
     /* 2157872 */     GIR_EraseRootFromParent_Done,
     /* 2157873 */   // Label 28466: @2157873
     /* 2157873 */   GIM_Try, /*On fail goto*//*Label 28467*/ GIMT_Encode4(2157964), // Rule ID 17939 //
     /* 2157878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2157886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2157889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2157892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2157895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2157898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2157916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157924 */     // MIs[0] round
     /* 2157924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157927 */     // MIs[0] policy
     /* 2157927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157937 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2157940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157963 */     // GIR_Coverage, 17939,
     /* 2157963 */     GIR_EraseRootFromParent_Done,
     /* 2157964 */   // Label 28467: @2157964
     /* 2157964 */   GIM_Try, /*On fail goto*//*Label 28468*/ GIMT_Encode4(2158055), // Rule ID 17942 //
     /* 2157969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2157977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2157980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2157983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2157986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2157989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2157992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2158007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158015 */     // MIs[0] round
     /* 2158015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158018 */     // MIs[0] policy
     /* 2158018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158028 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2158031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158054 */     // GIR_Coverage, 17942,
     /* 2158054 */     GIR_EraseRootFromParent_Done,
     /* 2158055 */   // Label 28468: @2158055
     /* 2158055 */   GIM_Try, /*On fail goto*//*Label 28469*/ GIMT_Encode4(2158146), // Rule ID 17943 //
     /* 2158060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2158068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2158071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2158074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2158077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2158080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2158098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158106 */     // MIs[0] round
     /* 2158106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158109 */     // MIs[0] policy
     /* 2158109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158119 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2158122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158145 */     // GIR_Coverage, 17943,
     /* 2158145 */     GIR_EraseRootFromParent_Done,
     /* 2158146 */   // Label 28469: @2158146
     /* 2158146 */   GIM_Try, /*On fail goto*//*Label 28470*/ GIMT_Encode4(2158237), // Rule ID 17946 //
     /* 2158151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2158159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2158162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2158165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2158168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2158171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2158174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2158189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158197 */     // MIs[0] round
     /* 2158197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158200 */     // MIs[0] policy
     /* 2158200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158210 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2158213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158236 */     // GIR_Coverage, 17946,
     /* 2158236 */     GIR_EraseRootFromParent_Done,
     /* 2158237 */   // Label 28470: @2158237
     /* 2158237 */   GIM_Try, /*On fail goto*//*Label 28471*/ GIMT_Encode4(2158328), // Rule ID 17947 //
     /* 2158242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2158250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2158253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2158256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2158259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2158262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2158265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2158280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158288 */     // MIs[0] round
     /* 2158288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158291 */     // MIs[0] policy
     /* 2158291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158301 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2158304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158327 */     // GIR_Coverage, 17947,
     /* 2158327 */     GIR_EraseRootFromParent_Done,
     /* 2158328 */   // Label 28471: @2158328
     /* 2158328 */   GIM_Try, /*On fail goto*//*Label 28472*/ GIMT_Encode4(2158419), // Rule ID 17950 //
     /* 2158333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2158341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2158344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2158347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2158353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158379 */     // MIs[0] round
     /* 2158379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158382 */     // MIs[0] policy
     /* 2158382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158392 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2158395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158418 */     // GIR_Coverage, 17950,
     /* 2158418 */     GIR_EraseRootFromParent_Done,
     /* 2158419 */   // Label 28472: @2158419
     /* 2158419 */   GIM_Try, /*On fail goto*//*Label 28473*/ GIMT_Encode4(2158510), // Rule ID 17951 //
     /* 2158424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2158432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2158435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2158438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2158444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158470 */     // MIs[0] round
     /* 2158470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158473 */     // MIs[0] policy
     /* 2158473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158483 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2158486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158509 */     // GIR_Coverage, 17951,
     /* 2158509 */     GIR_EraseRootFromParent_Done,
     /* 2158510 */   // Label 28473: @2158510
     /* 2158510 */   GIM_Try, /*On fail goto*//*Label 28474*/ GIMT_Encode4(2158601), // Rule ID 17954 //
     /* 2158515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2158523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2158526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2158529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2158535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2158538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158561 */     // MIs[0] round
     /* 2158561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158564 */     // MIs[0] policy
     /* 2158564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158574 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2158577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158600 */     // GIR_Coverage, 17954,
     /* 2158600 */     GIR_EraseRootFromParent_Done,
     /* 2158601 */   // Label 28474: @2158601
     /* 2158601 */   GIM_Try, /*On fail goto*//*Label 28475*/ GIMT_Encode4(2158692), // Rule ID 17955 //
     /* 2158606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2158614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2158617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2158620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2158626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2158629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158652 */     // MIs[0] round
     /* 2158652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158655 */     // MIs[0] policy
     /* 2158655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158665 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2158668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158691 */     // GIR_Coverage, 17955,
     /* 2158691 */     GIR_EraseRootFromParent_Done,
     /* 2158692 */   // Label 28475: @2158692
     /* 2158692 */   GIM_Try, /*On fail goto*//*Label 28476*/ GIMT_Encode4(2158783), // Rule ID 17958 //
     /* 2158697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2158705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2158708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2158711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2158717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2158720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158743 */     // MIs[0] round
     /* 2158743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158746 */     // MIs[0] policy
     /* 2158746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158756 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2158759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158782 */     // GIR_Coverage, 17958,
     /* 2158782 */     GIR_EraseRootFromParent_Done,
     /* 2158783 */   // Label 28476: @2158783
     /* 2158783 */   GIM_Try, /*On fail goto*//*Label 28477*/ GIMT_Encode4(2158874), // Rule ID 17959 //
     /* 2158788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2158796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2158799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2158802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2158808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2158811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158834 */     // MIs[0] round
     /* 2158834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158837 */     // MIs[0] policy
     /* 2158837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158847 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2158850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158873 */     // GIR_Coverage, 17959,
     /* 2158873 */     GIR_EraseRootFromParent_Done,
     /* 2158874 */   // Label 28477: @2158874
     /* 2158874 */   GIM_Try, /*On fail goto*//*Label 28478*/ GIMT_Encode4(2158965), // Rule ID 17962 //
     /* 2158879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2158887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2158890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2158893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2158896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2158899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2158917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158925 */     // MIs[0] round
     /* 2158925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158928 */     // MIs[0] policy
     /* 2158928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158938 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2158941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158964 */     // GIR_Coverage, 17962,
     /* 2158964 */     GIR_EraseRootFromParent_Done,
     /* 2158965 */   // Label 28478: @2158965
     /* 2158965 */   GIM_Try, /*On fail goto*//*Label 28479*/ GIMT_Encode4(2159056), // Rule ID 17963 //
     /* 2158970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2158978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2158981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2158984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2158987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2158990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2159000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159016 */     // MIs[0] round
     /* 2159016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159019 */     // MIs[0] policy
     /* 2159019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159029 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2159032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159055 */     // GIR_Coverage, 17963,
     /* 2159055 */     GIR_EraseRootFromParent_Done,
     /* 2159056 */   // Label 28479: @2159056
     /* 2159056 */   GIM_Try, /*On fail goto*//*Label 28480*/ GIMT_Encode4(2159147), // Rule ID 17966 //
     /* 2159061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2159069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2159072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2159075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2159081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2159091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159107 */     // MIs[0] round
     /* 2159107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159110 */     // MIs[0] policy
     /* 2159110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159120 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2159123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159146 */     // GIR_Coverage, 17966,
     /* 2159146 */     GIR_EraseRootFromParent_Done,
     /* 2159147 */   // Label 28480: @2159147
     /* 2159147 */   GIM_Try, /*On fail goto*//*Label 28481*/ GIMT_Encode4(2159238), // Rule ID 17967 //
     /* 2159152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2159160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2159163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2159166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2159172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2159182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159198 */     // MIs[0] round
     /* 2159198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159201 */     // MIs[0] policy
     /* 2159201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159211 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2159214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159237 */     // GIR_Coverage, 17967,
     /* 2159237 */     GIR_EraseRootFromParent_Done,
     /* 2159238 */   // Label 28481: @2159238
     /* 2159238 */   GIM_Try, /*On fail goto*//*Label 28482*/ GIMT_Encode4(2159329), // Rule ID 17970 //
     /* 2159243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2159251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2159254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2159257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2159263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2159266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2159273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159289 */     // MIs[0] round
     /* 2159289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159292 */     // MIs[0] policy
     /* 2159292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159302 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2159305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159328 */     // GIR_Coverage, 17970,
     /* 2159328 */     GIR_EraseRootFromParent_Done,
     /* 2159329 */   // Label 28482: @2159329
     /* 2159329 */   GIM_Try, /*On fail goto*//*Label 28483*/ GIMT_Encode4(2159420), // Rule ID 17971 //
     /* 2159334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2159342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2159345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2159348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2159354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2159357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2159364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159380 */     // MIs[0] round
     /* 2159380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159383 */     // MIs[0] policy
     /* 2159383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159393 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2159396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159419 */     // GIR_Coverage, 17971,
     /* 2159419 */     GIR_EraseRootFromParent_Done,
     /* 2159420 */   // Label 28483: @2159420
     /* 2159420 */   GIM_Try, /*On fail goto*//*Label 28484*/ GIMT_Encode4(2159511), // Rule ID 17974 //
     /* 2159425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2159428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2159433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2159436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2159439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2159445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2159455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159471 */     // MIs[0] round
     /* 2159471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159474 */     // MIs[0] policy
     /* 2159474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159484 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2159487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159510 */     // GIR_Coverage, 17974,
     /* 2159510 */     GIR_EraseRootFromParent_Done,
     /* 2159511 */   // Label 28484: @2159511
     /* 2159511 */   GIM_Try, /*On fail goto*//*Label 28485*/ GIMT_Encode4(2159602), // Rule ID 17975 //
     /* 2159516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2159519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2159524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2159527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2159530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2159536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2159546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159562 */     // MIs[0] round
     /* 2159562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159565 */     // MIs[0] policy
     /* 2159565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159575 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2159578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159601 */     // GIR_Coverage, 17975,
     /* 2159601 */     GIR_EraseRootFromParent_Done,
     /* 2159602 */   // Label 28485: @2159602
     /* 2159602 */   GIM_Try, /*On fail goto*//*Label 28486*/ GIMT_Encode4(2159693), // Rule ID 17978 //
     /* 2159607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2159610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2159615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2159618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2159621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2159627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2159637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159653 */     // MIs[0] round
     /* 2159653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159656 */     // MIs[0] policy
     /* 2159656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159666 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2159669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159692 */     // GIR_Coverage, 17978,
     /* 2159692 */     GIR_EraseRootFromParent_Done,
     /* 2159693 */   // Label 28486: @2159693
     /* 2159693 */   GIM_Try, /*On fail goto*//*Label 28487*/ GIMT_Encode4(2159784), // Rule ID 17979 //
     /* 2159698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2159701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2159706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2159709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2159712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2159718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2159728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159744 */     // MIs[0] round
     /* 2159744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159747 */     // MIs[0] policy
     /* 2159747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159757 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2159760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159783 */     // GIR_Coverage, 17979,
     /* 2159783 */     GIR_EraseRootFromParent_Done,
     /* 2159784 */   // Label 28487: @2159784
     /* 2159784 */   GIM_Try, /*On fail goto*//*Label 28488*/ GIMT_Encode4(2159875), // Rule ID 17982 //
     /* 2159789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2159792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2159797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2159800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2159803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2159809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2159819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159835 */     // MIs[0] round
     /* 2159835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159838 */     // MIs[0] policy
     /* 2159838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159848 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2159851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159874 */     // GIR_Coverage, 17982,
     /* 2159874 */     GIR_EraseRootFromParent_Done,
     /* 2159875 */   // Label 28488: @2159875
     /* 2159875 */   GIM_Try, /*On fail goto*//*Label 28489*/ GIMT_Encode4(2159966), // Rule ID 17983 //
     /* 2159880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2159883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2159888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2159891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2159894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2159900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2159910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159926 */     // MIs[0] round
     /* 2159926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159929 */     // MIs[0] policy
     /* 2159929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159939 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2159942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159965 */     // GIR_Coverage, 17983,
     /* 2159965 */     GIR_EraseRootFromParent_Done,
     /* 2159966 */   // Label 28489: @2159966
     /* 2159966 */   GIM_Try, /*On fail goto*//*Label 28490*/ GIMT_Encode4(2160057), // Rule ID 17986 //
     /* 2159971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2159982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2159985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2159988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2159991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160017 */     // MIs[0] round
     /* 2160017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160020 */     // MIs[0] policy
     /* 2160020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160030 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2160033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160056 */     // GIR_Coverage, 17986,
     /* 2160056 */     GIR_EraseRootFromParent_Done,
     /* 2160057 */   // Label 28490: @2160057
     /* 2160057 */   GIM_Try, /*On fail goto*//*Label 28491*/ GIMT_Encode4(2160148), // Rule ID 17987 //
     /* 2160062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2160073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2160076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2160079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2160082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2160085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160108 */     // MIs[0] round
     /* 2160108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160111 */     // MIs[0] policy
     /* 2160111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160121 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2160124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160147 */     // GIR_Coverage, 17987,
     /* 2160147 */     GIR_EraseRootFromParent_Done,
     /* 2160148 */   // Label 28491: @2160148
     /* 2160148 */   GIM_Try, /*On fail goto*//*Label 28492*/ GIMT_Encode4(2160239), // Rule ID 17990 //
     /* 2160153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2160164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2160167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2160170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2160173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2160176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160199 */     // MIs[0] round
     /* 2160199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160202 */     // MIs[0] policy
     /* 2160202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160212 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2160215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160238 */     // GIR_Coverage, 17990,
     /* 2160238 */     GIR_EraseRootFromParent_Done,
     /* 2160239 */   // Label 28492: @2160239
     /* 2160239 */   GIM_Try, /*On fail goto*//*Label 28493*/ GIMT_Encode4(2160330), // Rule ID 17991 //
     /* 2160244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2160255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2160258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2160261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2160264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2160267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160290 */     // MIs[0] round
     /* 2160290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160293 */     // MIs[0] policy
     /* 2160293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160303 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2160306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160329 */     // GIR_Coverage, 17991,
     /* 2160329 */     GIR_EraseRootFromParent_Done,
     /* 2160330 */   // Label 28493: @2160330
     /* 2160330 */   GIM_Try, /*On fail goto*//*Label 28494*/ GIMT_Encode4(2160421), // Rule ID 17994 //
     /* 2160335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2160346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2160349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2160352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2160355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2160358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160381 */     // MIs[0] round
     /* 2160381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160384 */     // MIs[0] policy
     /* 2160384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160394 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2160397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160420 */     // GIR_Coverage, 17994,
     /* 2160420 */     GIR_EraseRootFromParent_Done,
     /* 2160421 */   // Label 28494: @2160421
     /* 2160421 */   GIM_Try, /*On fail goto*//*Label 28495*/ GIMT_Encode4(2160512), // Rule ID 17995 //
     /* 2160426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2160437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2160440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2160443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2160446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2160449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160472 */     // MIs[0] round
     /* 2160472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160475 */     // MIs[0] policy
     /* 2160475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160485 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2160488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160511 */     // GIR_Coverage, 17995,
     /* 2160511 */     GIR_EraseRootFromParent_Done,
     /* 2160512 */   // Label 28495: @2160512
     /* 2160512 */   GIM_Try, /*On fail goto*//*Label 28496*/ GIMT_Encode4(2160603), // Rule ID 17998 //
     /* 2160517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2160528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2160531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2160534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2160537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2160540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160563 */     // MIs[0] round
     /* 2160563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160566 */     // MIs[0] policy
     /* 2160566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160576 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2160579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160602 */     // GIR_Coverage, 17998,
     /* 2160602 */     GIR_EraseRootFromParent_Done,
     /* 2160603 */   // Label 28496: @2160603
     /* 2160603 */   GIM_Try, /*On fail goto*//*Label 28497*/ GIMT_Encode4(2160694), // Rule ID 17999 //
     /* 2160608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2160619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2160622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2160625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2160628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2160631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160654 */     // MIs[0] round
     /* 2160654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160657 */     // MIs[0] policy
     /* 2160657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160667 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2160670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160693 */     // GIR_Coverage, 17999,
     /* 2160693 */     GIR_EraseRootFromParent_Done,
     /* 2160694 */   // Label 28497: @2160694
     /* 2160694 */   GIM_Try, /*On fail goto*//*Label 28498*/ GIMT_Encode4(2160785), // Rule ID 18002 //
     /* 2160699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2160710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2160713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2160716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2160719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2160722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160745 */     // MIs[0] round
     /* 2160745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160748 */     // MIs[0] policy
     /* 2160748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160758 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2160761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160784 */     // GIR_Coverage, 18002,
     /* 2160784 */     GIR_EraseRootFromParent_Done,
     /* 2160785 */   // Label 28498: @2160785
     /* 2160785 */   GIM_Try, /*On fail goto*//*Label 28499*/ GIMT_Encode4(2160876), // Rule ID 18003 //
     /* 2160790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2160801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2160804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2160807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2160810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2160813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160836 */     // MIs[0] round
     /* 2160836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160839 */     // MIs[0] policy
     /* 2160839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160849 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2160852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160875 */     // GIR_Coverage, 18003,
     /* 2160875 */     GIR_EraseRootFromParent_Done,
     /* 2160876 */   // Label 28499: @2160876
     /* 2160876 */   GIM_Try, /*On fail goto*//*Label 28500*/ GIMT_Encode4(2160967), // Rule ID 18006 //
     /* 2160881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2160884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2160892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2160895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2160898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2160901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2160904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160927 */     // MIs[0] round
     /* 2160927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160930 */     // MIs[0] policy
     /* 2160930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160940 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2160943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2160963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160966 */     // GIR_Coverage, 18006,
     /* 2160966 */     GIR_EraseRootFromParent_Done,
     /* 2160967 */   // Label 28500: @2160967
     /* 2160967 */   GIM_Try, /*On fail goto*//*Label 28501*/ GIMT_Encode4(2161058), // Rule ID 18007 //
     /* 2160972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2160975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2160983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2160986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2160989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2160992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2160995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161018 */     // MIs[0] round
     /* 2161018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161021 */     // MIs[0] policy
     /* 2161021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161031 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2161034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161057 */     // GIR_Coverage, 18007,
     /* 2161057 */     GIR_EraseRootFromParent_Done,
     /* 2161058 */   // Label 28501: @2161058
     /* 2161058 */   GIM_Try, /*On fail goto*//*Label 28502*/ GIMT_Encode4(2161149), // Rule ID 18010 //
     /* 2161063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2161066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2161074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2161077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2161080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2161083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161109 */     // MIs[0] round
     /* 2161109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161112 */     // MIs[0] policy
     /* 2161112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161122 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2161125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161148 */     // GIR_Coverage, 18010,
     /* 2161148 */     GIR_EraseRootFromParent_Done,
     /* 2161149 */   // Label 28502: @2161149
     /* 2161149 */   GIM_Try, /*On fail goto*//*Label 28503*/ GIMT_Encode4(2161240), // Rule ID 18011 //
     /* 2161154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2161157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2161165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2161168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2161171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2161174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161200 */     // MIs[0] round
     /* 2161200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161203 */     // MIs[0] policy
     /* 2161203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161213 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2161216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161239 */     // GIR_Coverage, 18011,
     /* 2161239 */     GIR_EraseRootFromParent_Done,
     /* 2161240 */   // Label 28503: @2161240
     /* 2161240 */   GIM_Try, /*On fail goto*//*Label 28504*/ GIMT_Encode4(2161331), // Rule ID 18014 //
     /* 2161245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2161248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2161256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2161259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2161262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2161265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2161268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161291 */     // MIs[0] round
     /* 2161291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161294 */     // MIs[0] policy
     /* 2161294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161304 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2161307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161330 */     // GIR_Coverage, 18014,
     /* 2161330 */     GIR_EraseRootFromParent_Done,
     /* 2161331 */   // Label 28504: @2161331
     /* 2161331 */   GIM_Try, /*On fail goto*//*Label 28505*/ GIMT_Encode4(2161422), // Rule ID 18015 //
     /* 2161336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2161339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2161347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2161350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2161353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2161356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2161359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161382 */     // MIs[0] round
     /* 2161382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161385 */     // MIs[0] policy
     /* 2161385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161395 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2161398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161421 */     // GIR_Coverage, 18015,
     /* 2161421 */     GIR_EraseRootFromParent_Done,
     /* 2161422 */   // Label 28505: @2161422
     /* 2161422 */   GIM_Try, /*On fail goto*//*Label 28506*/ GIMT_Encode4(2161513), // Rule ID 18018 //
     /* 2161427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2161430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2161438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2161441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2161444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2161447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2161450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161473 */     // MIs[0] round
     /* 2161473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161476 */     // MIs[0] policy
     /* 2161476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161486 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2161489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161512 */     // GIR_Coverage, 18018,
     /* 2161512 */     GIR_EraseRootFromParent_Done,
     /* 2161513 */   // Label 28506: @2161513
     /* 2161513 */   GIM_Try, /*On fail goto*//*Label 28507*/ GIMT_Encode4(2161604), // Rule ID 18019 //
     /* 2161518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2161521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2161529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2161532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2161535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2161538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2161541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161564 */     // MIs[0] round
     /* 2161564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161567 */     // MIs[0] policy
     /* 2161567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161577 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2161580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161603 */     // GIR_Coverage, 18019,
     /* 2161603 */     GIR_EraseRootFromParent_Done,
     /* 2161604 */   // Label 28507: @2161604
     /* 2161604 */   GIM_Try, /*On fail goto*//*Label 28508*/ GIMT_Encode4(2161695), // Rule ID 18022 //
     /* 2161609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2161612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2161620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2161623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2161626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2161629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161655 */     // MIs[0] round
     /* 2161655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161658 */     // MIs[0] policy
     /* 2161658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161668 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2161671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161694 */     // GIR_Coverage, 18022,
     /* 2161694 */     GIR_EraseRootFromParent_Done,
     /* 2161695 */   // Label 28508: @2161695
     /* 2161695 */   GIM_Try, /*On fail goto*//*Label 28509*/ GIMT_Encode4(2161786), // Rule ID 18023 //
     /* 2161700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2161703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2161711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2161714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2161717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2161720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161746 */     // MIs[0] round
     /* 2161746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161749 */     // MIs[0] policy
     /* 2161749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161759 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2161762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161785 */     // GIR_Coverage, 18023,
     /* 2161785 */     GIR_EraseRootFromParent_Done,
     /* 2161786 */   // Label 28509: @2161786
     /* 2161786 */   GIM_Try, /*On fail goto*//*Label 28510*/ GIMT_Encode4(2161877), // Rule ID 18026 //
     /* 2161791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2161794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2161802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2161805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2161808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2161811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161837 */     // MIs[0] round
     /* 2161837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161840 */     // MIs[0] policy
     /* 2161840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161850 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2161853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161876 */     // GIR_Coverage, 18026,
     /* 2161876 */     GIR_EraseRootFromParent_Done,
     /* 2161877 */   // Label 28510: @2161877
     /* 2161877 */   GIM_Try, /*On fail goto*//*Label 28511*/ GIMT_Encode4(2161968), // Rule ID 18027 //
     /* 2161882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2161885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2161893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2161896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2161899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2161902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161928 */     // MIs[0] round
     /* 2161928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161931 */     // MIs[0] policy
     /* 2161931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161941 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2161944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161967 */     // GIR_Coverage, 18027,
     /* 2161967 */     GIR_EraseRootFromParent_Done,
     /* 2161968 */   // Label 28511: @2161968
     /* 2161968 */   GIM_Try, /*On fail goto*//*Label 28512*/ GIMT_Encode4(2162059), // Rule ID 18030 //
     /* 2161973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2161976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2161984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2161987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2161990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2161993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2161996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2162003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162019 */     // MIs[0] round
     /* 2162019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162022 */     // MIs[0] policy
     /* 2162022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162032 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2162035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162058 */     // GIR_Coverage, 18030,
     /* 2162058 */     GIR_EraseRootFromParent_Done,
     /* 2162059 */   // Label 28512: @2162059
     /* 2162059 */   GIM_Try, /*On fail goto*//*Label 28513*/ GIMT_Encode4(2162150), // Rule ID 18031 //
     /* 2162064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2162067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2162072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2162075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2162078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2162081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2162084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2162087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2162094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162110 */     // MIs[0] round
     /* 2162110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162113 */     // MIs[0] policy
     /* 2162113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162123 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2162126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162149 */     // GIR_Coverage, 18031,
     /* 2162149 */     GIR_EraseRootFromParent_Done,
     /* 2162150 */   // Label 28513: @2162150
     /* 2162150 */   GIM_Try, /*On fail goto*//*Label 28514*/ GIMT_Encode4(2162241), // Rule ID 18034 //
     /* 2162155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2162158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2162163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2162166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2162169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2162172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2162175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2162185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162201 */     // MIs[0] round
     /* 2162201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162204 */     // MIs[0] policy
     /* 2162204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162214 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2162217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162240 */     // GIR_Coverage, 18034,
     /* 2162240 */     GIR_EraseRootFromParent_Done,
     /* 2162241 */   // Label 28514: @2162241
     /* 2162241 */   GIM_Try, /*On fail goto*//*Label 28515*/ GIMT_Encode4(2162332), // Rule ID 18035 //
     /* 2162246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2162249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2162254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2162257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2162260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2162263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2162266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2162276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162292 */     // MIs[0] round
     /* 2162292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162295 */     // MIs[0] policy
     /* 2162295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162305 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2162308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162331 */     // GIR_Coverage, 18035,
     /* 2162331 */     GIR_EraseRootFromParent_Done,
     /* 2162332 */   // Label 28515: @2162332
     /* 2162332 */   GIM_Try, /*On fail goto*//*Label 28516*/ GIMT_Encode4(2162423), // Rule ID 18038 //
     /* 2162337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2162340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2162345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2162348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2162351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2162354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2162357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2162360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2162367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162383 */     // MIs[0] round
     /* 2162383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162386 */     // MIs[0] policy
     /* 2162386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162396 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2162399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162422 */     // GIR_Coverage, 18038,
     /* 2162422 */     GIR_EraseRootFromParent_Done,
     /* 2162423 */   // Label 28516: @2162423
     /* 2162423 */   GIM_Try, /*On fail goto*//*Label 28517*/ GIMT_Encode4(2162514), // Rule ID 18039 //
     /* 2162428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2162431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2162436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2162439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2162442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2162445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2162448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2162451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2162458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162474 */     // MIs[0] round
     /* 2162474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162477 */     // MIs[0] policy
     /* 2162477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162487 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2162490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162513 */     // GIR_Coverage, 18039,
     /* 2162513 */     GIR_EraseRootFromParent_Done,
     /* 2162514 */   // Label 28517: @2162514
     /* 2162514 */   GIM_Try, /*On fail goto*//*Label 28518*/ GIMT_Encode4(2162605), // Rule ID 18042 //
     /* 2162519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2162522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2162527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2162530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2162533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2162536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2162539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2162542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2162549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162565 */     // MIs[0] round
     /* 2162565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162568 */     // MIs[0] policy
     /* 2162568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162578 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2162581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162604 */     // GIR_Coverage, 18042,
     /* 2162604 */     GIR_EraseRootFromParent_Done,
     /* 2162605 */   // Label 28518: @2162605
     /* 2162605 */   GIM_Try, /*On fail goto*//*Label 28519*/ GIMT_Encode4(2162696), // Rule ID 18043 //
     /* 2162610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2162613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2162618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2162621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2162624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2162627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2162630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2162633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2162640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162656 */     // MIs[0] round
     /* 2162656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162659 */     // MIs[0] policy
     /* 2162659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162669 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2162672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162695 */     // GIR_Coverage, 18043,
     /* 2162695 */     GIR_EraseRootFromParent_Done,
     /* 2162696 */   // Label 28519: @2162696
     /* 2162696 */   GIM_Try, /*On fail goto*//*Label 28520*/ GIMT_Encode4(2162787), // Rule ID 18046 //
     /* 2162701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2162709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2162712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2162715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2162718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2162721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2162739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162747 */     // MIs[0] round
     /* 2162747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162750 */     // MIs[0] policy
     /* 2162750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162760 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2162763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162786 */     // GIR_Coverage, 18046,
     /* 2162786 */     GIR_EraseRootFromParent_Done,
     /* 2162787 */   // Label 28520: @2162787
     /* 2162787 */   GIM_Try, /*On fail goto*//*Label 28521*/ GIMT_Encode4(2162878), // Rule ID 18047 //
     /* 2162792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2162800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2162803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2162806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2162809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2162812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2162830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162838 */     // MIs[0] round
     /* 2162838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162841 */     // MIs[0] policy
     /* 2162841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162851 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2162854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162877 */     // GIR_Coverage, 18047,
     /* 2162877 */     GIR_EraseRootFromParent_Done,
     /* 2162878 */   // Label 28521: @2162878
     /* 2162878 */   GIM_Try, /*On fail goto*//*Label 28522*/ GIMT_Encode4(2162969), // Rule ID 18050 //
     /* 2162883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2162891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2162894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2162897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2162900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2162903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2162921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162929 */     // MIs[0] round
     /* 2162929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162932 */     // MIs[0] policy
     /* 2162932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162942 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2162945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162968 */     // GIR_Coverage, 18050,
     /* 2162968 */     GIR_EraseRootFromParent_Done,
     /* 2162969 */   // Label 28522: @2162969
     /* 2162969 */   GIM_Try, /*On fail goto*//*Label 28523*/ GIMT_Encode4(2163060), // Rule ID 18051 //
     /* 2162974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2162982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2162985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2162988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2162991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2162994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2163012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163020 */     // MIs[0] round
     /* 2163020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163023 */     // MIs[0] policy
     /* 2163023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163033 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2163036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163059 */     // GIR_Coverage, 18051,
     /* 2163059 */     GIR_EraseRootFromParent_Done,
     /* 2163060 */   // Label 28523: @2163060
     /* 2163060 */   GIM_Try, /*On fail goto*//*Label 28524*/ GIMT_Encode4(2163151), // Rule ID 18054 //
     /* 2163065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2163073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2163076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2163079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2163082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2163085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2163088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2163103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163111 */     // MIs[0] round
     /* 2163111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163114 */     // MIs[0] policy
     /* 2163114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163124 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2163127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163150 */     // GIR_Coverage, 18054,
     /* 2163150 */     GIR_EraseRootFromParent_Done,
     /* 2163151 */   // Label 28524: @2163151
     /* 2163151 */   GIM_Try, /*On fail goto*//*Label 28525*/ GIMT_Encode4(2163242), // Rule ID 18055 //
     /* 2163156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2163164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2163167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2163170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2163173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2163176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2163179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2163194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163202 */     // MIs[0] round
     /* 2163202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163205 */     // MIs[0] policy
     /* 2163205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163215 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2163218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163241 */     // GIR_Coverage, 18055,
     /* 2163241 */     GIR_EraseRootFromParent_Done,
     /* 2163242 */   // Label 28525: @2163242
     /* 2163242 */   GIM_Try, /*On fail goto*//*Label 28526*/ GIMT_Encode4(2163333), // Rule ID 18058 //
     /* 2163247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2163255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2163258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2163261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2163264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2163267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2163285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163293 */     // MIs[0] round
     /* 2163293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163296 */     // MIs[0] policy
     /* 2163296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163306 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2163309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163332 */     // GIR_Coverage, 18058,
     /* 2163332 */     GIR_EraseRootFromParent_Done,
     /* 2163333 */   // Label 28526: @2163333
     /* 2163333 */   GIM_Try, /*On fail goto*//*Label 28527*/ GIMT_Encode4(2163424), // Rule ID 18059 //
     /* 2163338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2163341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2163346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2163349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2163352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2163355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2163358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2163376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163384 */     // MIs[0] round
     /* 2163384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163387 */     // MIs[0] policy
     /* 2163387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163397 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2163400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163423 */     // GIR_Coverage, 18059,
     /* 2163423 */     GIR_EraseRootFromParent_Done,
     /* 2163424 */   // Label 28527: @2163424
     /* 2163424 */   GIM_Try, /*On fail goto*//*Label 28528*/ GIMT_Encode4(2163515), // Rule ID 18062 //
     /* 2163429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2163437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2163440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2163443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2163446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2163449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2163452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2163467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163475 */     // MIs[0] round
     /* 2163475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163478 */     // MIs[0] policy
     /* 2163478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163488 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2163491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163514 */     // GIR_Coverage, 18062,
     /* 2163514 */     GIR_EraseRootFromParent_Done,
     /* 2163515 */   // Label 28528: @2163515
     /* 2163515 */   GIM_Try, /*On fail goto*//*Label 28529*/ GIMT_Encode4(2163606), // Rule ID 18063 //
     /* 2163520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2163528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2163531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2163534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2163537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2163540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2163543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2163558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163566 */     // MIs[0] round
     /* 2163566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163569 */     // MIs[0] policy
     /* 2163569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163579 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2163582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163605 */     // GIR_Coverage, 18063,
     /* 2163605 */     GIR_EraseRootFromParent_Done,
     /* 2163606 */   // Label 28529: @2163606
     /* 2163606 */   GIM_Try, /*On fail goto*//*Label 28530*/ GIMT_Encode4(2163697), // Rule ID 18066 //
     /* 2163611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2163614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2163619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2163622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2163625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2163628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2163631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2163634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2163649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163657 */     // MIs[0] round
     /* 2163657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163660 */     // MIs[0] policy
     /* 2163660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163670 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2163673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163696 */     // GIR_Coverage, 18066,
     /* 2163696 */     GIR_EraseRootFromParent_Done,
     /* 2163697 */   // Label 28530: @2163697
     /* 2163697 */   GIM_Try, /*On fail goto*//*Label 28531*/ GIMT_Encode4(2163788), // Rule ID 18067 //
     /* 2163702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2163705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2163710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2163713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2163716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2163719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2163722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2163725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2163740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163748 */     // MIs[0] round
     /* 2163748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163751 */     // MIs[0] policy
     /* 2163751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163761 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2163764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163787 */     // GIR_Coverage, 18067,
     /* 2163787 */     GIR_EraseRootFromParent_Done,
     /* 2163788 */   // Label 28531: @2163788
     /* 2163788 */   GIM_Try, /*On fail goto*//*Label 28532*/ GIMT_Encode4(2163879), // Rule ID 18070 //
     /* 2163793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2163801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2163804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2163807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2163810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2163813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2163831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163839 */     // MIs[0] round
     /* 2163839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163842 */     // MIs[0] policy
     /* 2163842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163852 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2163855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163878 */     // GIR_Coverage, 18070,
     /* 2163878 */     GIR_EraseRootFromParent_Done,
     /* 2163879 */   // Label 28532: @2163879
     /* 2163879 */   GIM_Try, /*On fail goto*//*Label 28533*/ GIMT_Encode4(2163970), // Rule ID 18071 //
     /* 2163884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2163887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2163892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2163895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2163898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2163901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2163904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2163922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163930 */     // MIs[0] round
     /* 2163930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163933 */     // MIs[0] policy
     /* 2163933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163943 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2163946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163969 */     // GIR_Coverage, 18071,
     /* 2163969 */     GIR_EraseRootFromParent_Done,
     /* 2163970 */   // Label 28533: @2163970
     /* 2163970 */   GIM_Try, /*On fail goto*//*Label 28534*/ GIMT_Encode4(2164061), // Rule ID 18074 //
     /* 2163975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2163983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2163986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2163989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2163992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2163995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2163998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164021 */     // MIs[0] round
     /* 2164021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164024 */     // MIs[0] policy
     /* 2164024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164034 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2164037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164060 */     // GIR_Coverage, 18074,
     /* 2164060 */     GIR_EraseRootFromParent_Done,
     /* 2164061 */   // Label 28534: @2164061
     /* 2164061 */   GIM_Try, /*On fail goto*//*Label 28535*/ GIMT_Encode4(2164152), // Rule ID 18075 //
     /* 2164066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2164074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2164077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2164080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2164086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2164089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164112 */     // MIs[0] round
     /* 2164112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164115 */     // MIs[0] policy
     /* 2164115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164125 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2164128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164151 */     // GIR_Coverage, 18075,
     /* 2164151 */     GIR_EraseRootFromParent_Done,
     /* 2164152 */   // Label 28535: @2164152
     /* 2164152 */   GIM_Try, /*On fail goto*//*Label 28536*/ GIMT_Encode4(2164243), // Rule ID 18078 //
     /* 2164157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2164165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2164168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2164171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2164177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2164180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164203 */     // MIs[0] round
     /* 2164203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164206 */     // MIs[0] policy
     /* 2164206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164216 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2164219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164242 */     // GIR_Coverage, 18078,
     /* 2164242 */     GIR_EraseRootFromParent_Done,
     /* 2164243 */   // Label 28536: @2164243
     /* 2164243 */   GIM_Try, /*On fail goto*//*Label 28537*/ GIMT_Encode4(2164334), // Rule ID 18079 //
     /* 2164248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2164256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2164259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2164262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2164268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2164271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164294 */     // MIs[0] round
     /* 2164294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164297 */     // MIs[0] policy
     /* 2164297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164307 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2164310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164333 */     // GIR_Coverage, 18079,
     /* 2164333 */     GIR_EraseRootFromParent_Done,
     /* 2164334 */   // Label 28537: @2164334
     /* 2164334 */   GIM_Try, /*On fail goto*//*Label 28538*/ GIMT_Encode4(2164425), // Rule ID 18082 //
     /* 2164339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2164342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2164347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2164350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2164353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2164359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2164369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164385 */     // MIs[0] round
     /* 2164385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164388 */     // MIs[0] policy
     /* 2164388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164398 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2164401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164424 */     // GIR_Coverage, 18082,
     /* 2164424 */     GIR_EraseRootFromParent_Done,
     /* 2164425 */   // Label 28538: @2164425
     /* 2164425 */   GIM_Try, /*On fail goto*//*Label 28539*/ GIMT_Encode4(2164516), // Rule ID 18083 //
     /* 2164430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2164433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2164438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2164441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2164444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2164450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2164460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164476 */     // MIs[0] round
     /* 2164476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164479 */     // MIs[0] policy
     /* 2164479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164489 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2164492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164515 */     // GIR_Coverage, 18083,
     /* 2164515 */     GIR_EraseRootFromParent_Done,
     /* 2164516 */   // Label 28539: @2164516
     /* 2164516 */   GIM_Try, /*On fail goto*//*Label 28540*/ GIMT_Encode4(2164607), // Rule ID 18086 //
     /* 2164521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2164524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2164529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2164532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2164535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2164541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164567 */     // MIs[0] round
     /* 2164567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164570 */     // MIs[0] policy
     /* 2164570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164580 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2164583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164606 */     // GIR_Coverage, 18086,
     /* 2164606 */     GIR_EraseRootFromParent_Done,
     /* 2164607 */   // Label 28540: @2164607
     /* 2164607 */   GIM_Try, /*On fail goto*//*Label 28541*/ GIMT_Encode4(2164698), // Rule ID 18087 //
     /* 2164612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2164615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2164620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2164623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2164626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2164632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164658 */     // MIs[0] round
     /* 2164658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164661 */     // MIs[0] policy
     /* 2164661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164671 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2164674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164697 */     // GIR_Coverage, 18087,
     /* 2164697 */     GIR_EraseRootFromParent_Done,
     /* 2164698 */   // Label 28541: @2164698
     /* 2164698 */   GIM_Try, /*On fail goto*//*Label 28542*/ GIMT_Encode4(2164789), // Rule ID 18090 //
     /* 2164703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2164706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2164711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2164714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2164717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2164723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2164726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164749 */     // MIs[0] round
     /* 2164749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164752 */     // MIs[0] policy
     /* 2164752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164762 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2164765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164788 */     // GIR_Coverage, 18090,
     /* 2164788 */     GIR_EraseRootFromParent_Done,
     /* 2164789 */   // Label 28542: @2164789
     /* 2164789 */   GIM_Try, /*On fail goto*//*Label 28543*/ GIMT_Encode4(2164880), // Rule ID 18091 //
     /* 2164794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2164797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2164802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2164805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2164808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2164814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2164817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164840 */     // MIs[0] round
     /* 2164840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164843 */     // MIs[0] policy
     /* 2164843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164853 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2164856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164879 */     // GIR_Coverage, 18091,
     /* 2164879 */     GIR_EraseRootFromParent_Done,
     /* 2164880 */   // Label 28543: @2164880
     /* 2164880 */   GIM_Try, /*On fail goto*//*Label 28544*/ GIMT_Encode4(2164971), // Rule ID 18094 //
     /* 2164885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2164888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2164893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2164896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2164899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2164902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2164905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2164915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2164923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164931 */     // MIs[0] round
     /* 2164931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164934 */     // MIs[0] policy
     /* 2164934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164944 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2164947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164970 */     // GIR_Coverage, 18094,
     /* 2164970 */     GIR_EraseRootFromParent_Done,
     /* 2164971 */   // Label 28544: @2164971
     /* 2164971 */   GIM_Try, /*On fail goto*//*Label 28545*/ GIMT_Encode4(2165062), // Rule ID 18095 //
     /* 2164976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2164979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2164984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2164987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2164990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2164993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2164996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165022 */     // MIs[0] round
     /* 2165022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165025 */     // MIs[0] policy
     /* 2165025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165035 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2165038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165061 */     // GIR_Coverage, 18095,
     /* 2165061 */     GIR_EraseRootFromParent_Done,
     /* 2165062 */   // Label 28545: @2165062
     /* 2165062 */   GIM_Try, /*On fail goto*//*Label 28546*/ GIMT_Encode4(2165153), // Rule ID 18098 //
     /* 2165067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2165070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2165075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2165078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2165081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2165087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2165090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2165097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165113 */     // MIs[0] round
     /* 2165113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165116 */     // MIs[0] policy
     /* 2165116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165126 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2165129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165152 */     // GIR_Coverage, 18098,
     /* 2165152 */     GIR_EraseRootFromParent_Done,
     /* 2165153 */   // Label 28546: @2165153
     /* 2165153 */   GIM_Try, /*On fail goto*//*Label 28547*/ GIMT_Encode4(2165244), // Rule ID 18099 //
     /* 2165158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2165161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2165166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2165169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2165172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2165178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2165181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2165188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165204 */     // MIs[0] round
     /* 2165204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165207 */     // MIs[0] policy
     /* 2165207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165217 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2165220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165243 */     // GIR_Coverage, 18099,
     /* 2165243 */     GIR_EraseRootFromParent_Done,
     /* 2165244 */   // Label 28547: @2165244
     /* 2165244 */   GIM_Try, /*On fail goto*//*Label 28548*/ GIMT_Encode4(2165335), // Rule ID 18102 //
     /* 2165249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2165252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2165257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2165260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2165263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2165269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2165279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165295 */     // MIs[0] round
     /* 2165295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165298 */     // MIs[0] policy
     /* 2165298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165308 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2165311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165334 */     // GIR_Coverage, 18102,
     /* 2165334 */     GIR_EraseRootFromParent_Done,
     /* 2165335 */   // Label 28548: @2165335
     /* 2165335 */   GIM_Try, /*On fail goto*//*Label 28549*/ GIMT_Encode4(2165426), // Rule ID 18103 //
     /* 2165340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2165343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2165348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2165351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2165354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2165360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2165370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165386 */     // MIs[0] round
     /* 2165386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165389 */     // MIs[0] policy
     /* 2165389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165399 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2165402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165425 */     // GIR_Coverage, 18103,
     /* 2165425 */     GIR_EraseRootFromParent_Done,
     /* 2165426 */   // Label 28549: @2165426
     /* 2165426 */   GIM_Try, /*On fail goto*//*Label 28550*/ GIMT_Encode4(2165517), // Rule ID 18106 //
     /* 2165431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2165442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2165445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2165448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2165451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165477 */     // MIs[0] round
     /* 2165477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165480 */     // MIs[0] policy
     /* 2165480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165490 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2165493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165516 */     // GIR_Coverage, 18106,
     /* 2165516 */     GIR_EraseRootFromParent_Done,
     /* 2165517 */   // Label 28550: @2165517
     /* 2165517 */   GIM_Try, /*On fail goto*//*Label 28551*/ GIMT_Encode4(2165608), // Rule ID 18107 //
     /* 2165522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2165533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2165536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2165539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2165542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165568 */     // MIs[0] round
     /* 2165568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165571 */     // MIs[0] policy
     /* 2165571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165581 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2165584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165607 */     // GIR_Coverage, 18107,
     /* 2165607 */     GIR_EraseRootFromParent_Done,
     /* 2165608 */   // Label 28551: @2165608
     /* 2165608 */   GIM_Try, /*On fail goto*//*Label 28552*/ GIMT_Encode4(2165699), // Rule ID 18110 //
     /* 2165613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2165624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2165627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2165630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2165633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165659 */     // MIs[0] round
     /* 2165659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165662 */     // MIs[0] policy
     /* 2165662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165672 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2165675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165698 */     // GIR_Coverage, 18110,
     /* 2165698 */     GIR_EraseRootFromParent_Done,
     /* 2165699 */   // Label 28552: @2165699
     /* 2165699 */   GIM_Try, /*On fail goto*//*Label 28553*/ GIMT_Encode4(2165790), // Rule ID 18111 //
     /* 2165704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2165715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2165718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2165721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2165724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165750 */     // MIs[0] round
     /* 2165750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165753 */     // MIs[0] policy
     /* 2165753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165763 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2165766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165789 */     // GIR_Coverage, 18111,
     /* 2165789 */     GIR_EraseRootFromParent_Done,
     /* 2165790 */   // Label 28553: @2165790
     /* 2165790 */   GIM_Try, /*On fail goto*//*Label 28554*/ GIMT_Encode4(2165881), // Rule ID 18114 //
     /* 2165795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2165798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2165806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2165809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2165812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2165815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165841 */     // MIs[0] round
     /* 2165841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165844 */     // MIs[0] policy
     /* 2165844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165854 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2165857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165880 */     // GIR_Coverage, 18114,
     /* 2165880 */     GIR_EraseRootFromParent_Done,
     /* 2165881 */   // Label 28554: @2165881
     /* 2165881 */   GIM_Try, /*On fail goto*//*Label 28555*/ GIMT_Encode4(2165972), // Rule ID 18115 //
     /* 2165886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2165889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2165897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2165900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2165903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2165906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165932 */     // MIs[0] round
     /* 2165932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165935 */     // MIs[0] policy
     /* 2165935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165945 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2165948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165971 */     // GIR_Coverage, 18115,
     /* 2165971 */     GIR_EraseRootFromParent_Done,
     /* 2165972 */   // Label 28555: @2165972
     /* 2165972 */   GIM_Try, /*On fail goto*//*Label 28556*/ GIMT_Encode4(2166063), // Rule ID 18118 //
     /* 2165977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2165988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2165991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2165994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2165997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166023 */     // MIs[0] round
     /* 2166023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166026 */     // MIs[0] policy
     /* 2166026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166036 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2166039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166062 */     // GIR_Coverage, 18118,
     /* 2166062 */     GIR_EraseRootFromParent_Done,
     /* 2166063 */   // Label 28556: @2166063
     /* 2166063 */   GIM_Try, /*On fail goto*//*Label 28557*/ GIMT_Encode4(2166154), // Rule ID 18119 //
     /* 2166068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2166071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2166079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2166082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2166085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2166088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166114 */     // MIs[0] round
     /* 2166114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166117 */     // MIs[0] policy
     /* 2166117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166127 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2166130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166153 */     // GIR_Coverage, 18119,
     /* 2166153 */     GIR_EraseRootFromParent_Done,
     /* 2166154 */   // Label 28557: @2166154
     /* 2166154 */   GIM_Try, /*On fail goto*//*Label 28558*/ GIMT_Encode4(2166245), // Rule ID 18122 //
     /* 2166159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2166162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2166170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2166173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2166176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2166179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2166182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166205 */     // MIs[0] round
     /* 2166205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166208 */     // MIs[0] policy
     /* 2166208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166218 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2166221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166244 */     // GIR_Coverage, 18122,
     /* 2166244 */     GIR_EraseRootFromParent_Done,
     /* 2166245 */   // Label 28558: @2166245
     /* 2166245 */   GIM_Try, /*On fail goto*//*Label 28559*/ GIMT_Encode4(2166336), // Rule ID 18123 //
     /* 2166250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2166261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2166264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2166267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2166270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2166273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166296 */     // MIs[0] round
     /* 2166296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166299 */     // MIs[0] policy
     /* 2166299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166309 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2166312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166335 */     // GIR_Coverage, 18123,
     /* 2166335 */     GIR_EraseRootFromParent_Done,
     /* 2166336 */   // Label 28559: @2166336
     /* 2166336 */   GIM_Try, /*On fail goto*//*Label 28560*/ GIMT_Encode4(2166427), // Rule ID 18126 //
     /* 2166341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2166344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2166352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2166355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2166358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2166361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2166364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166387 */     // MIs[0] round
     /* 2166387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166390 */     // MIs[0] policy
     /* 2166390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166400 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2166403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166426 */     // GIR_Coverage, 18126,
     /* 2166426 */     GIR_EraseRootFromParent_Done,
     /* 2166427 */   // Label 28560: @2166427
     /* 2166427 */   GIM_Try, /*On fail goto*//*Label 28561*/ GIMT_Encode4(2166518), // Rule ID 18127 //
     /* 2166432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2166435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2166443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2166446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2166449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2166452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2166455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166478 */     // MIs[0] round
     /* 2166478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166481 */     // MIs[0] policy
     /* 2166481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166491 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2166494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166517 */     // GIR_Coverage, 18127,
     /* 2166517 */     GIR_EraseRootFromParent_Done,
     /* 2166518 */   // Label 28561: @2166518
     /* 2166518 */   GIM_Try, /*On fail goto*//*Label 28562*/ GIMT_Encode4(2166609), // Rule ID 18130 //
     /* 2166523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2166526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2166534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2166537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2166540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2166543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166569 */     // MIs[0] round
     /* 2166569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166572 */     // MIs[0] policy
     /* 2166572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166582 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2166585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166608 */     // GIR_Coverage, 18130,
     /* 2166608 */     GIR_EraseRootFromParent_Done,
     /* 2166609 */   // Label 28562: @2166609
     /* 2166609 */   GIM_Try, /*On fail goto*//*Label 28563*/ GIMT_Encode4(2166700), // Rule ID 18131 //
     /* 2166614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2166617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2166625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2166628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2166631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2166634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166660 */     // MIs[0] round
     /* 2166660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166663 */     // MIs[0] policy
     /* 2166663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166673 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2166676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166699 */     // GIR_Coverage, 18131,
     /* 2166699 */     GIR_EraseRootFromParent_Done,
     /* 2166700 */   // Label 28563: @2166700
     /* 2166700 */   GIM_Try, /*On fail goto*//*Label 28564*/ GIMT_Encode4(2166791), // Rule ID 18134 //
     /* 2166705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2166708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2166716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2166719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2166722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2166725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166751 */     // MIs[0] round
     /* 2166751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166754 */     // MIs[0] policy
     /* 2166754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166764 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2166767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166790 */     // GIR_Coverage, 18134,
     /* 2166790 */     GIR_EraseRootFromParent_Done,
     /* 2166791 */   // Label 28564: @2166791
     /* 2166791 */   GIM_Try, /*On fail goto*//*Label 28565*/ GIMT_Encode4(2166882), // Rule ID 18135 //
     /* 2166796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2166799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2166807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2166810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2166813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2166816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166842 */     // MIs[0] round
     /* 2166842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166845 */     // MIs[0] policy
     /* 2166845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166855 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2166858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166881 */     // GIR_Coverage, 18135,
     /* 2166881 */     GIR_EraseRootFromParent_Done,
     /* 2166882 */   // Label 28565: @2166882
     /* 2166882 */   GIM_Try, /*On fail goto*//*Label 28566*/ GIMT_Encode4(2166973), // Rule ID 18138 //
     /* 2166887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2166890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2166898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2166901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2166904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2166907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2166910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166933 */     // MIs[0] round
     /* 2166933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166936 */     // MIs[0] policy
     /* 2166936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166946 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2166949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166972 */     // GIR_Coverage, 18138,
     /* 2166972 */     GIR_EraseRootFromParent_Done,
     /* 2166973 */   // Label 28566: @2166973
     /* 2166973 */   GIM_Try, /*On fail goto*//*Label 28567*/ GIMT_Encode4(2167064), // Rule ID 18139 //
     /* 2166978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2166981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2166989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2166992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2166995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2166998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2167001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2167008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167024 */     // MIs[0] round
     /* 2167024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167027 */     // MIs[0] policy
     /* 2167027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167037 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2167040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167063 */     // GIR_Coverage, 18139,
     /* 2167063 */     GIR_EraseRootFromParent_Done,
     /* 2167064 */   // Label 28567: @2167064
     /* 2167064 */   GIM_Try, /*On fail goto*//*Label 28568*/ GIMT_Encode4(2167155), // Rule ID 18142 //
     /* 2167069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2167080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2167083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2167086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2167089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2167099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167115 */     // MIs[0] round
     /* 2167115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167118 */     // MIs[0] policy
     /* 2167118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167128 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2167131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167154 */     // GIR_Coverage, 18142,
     /* 2167154 */     GIR_EraseRootFromParent_Done,
     /* 2167155 */   // Label 28568: @2167155
     /* 2167155 */   GIM_Try, /*On fail goto*//*Label 28569*/ GIMT_Encode4(2167246), // Rule ID 18143 //
     /* 2167160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2167171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2167174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2167177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2167180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2167190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167206 */     // MIs[0] round
     /* 2167206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167209 */     // MIs[0] policy
     /* 2167209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167219 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2167222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167245 */     // GIR_Coverage, 18143,
     /* 2167245 */     GIR_EraseRootFromParent_Done,
     /* 2167246 */   // Label 28569: @2167246
     /* 2167246 */   GIM_Try, /*On fail goto*//*Label 28570*/ GIMT_Encode4(2167337), // Rule ID 18146 //
     /* 2167251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2167262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2167265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2167268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2167271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2167274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2167281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167297 */     // MIs[0] round
     /* 2167297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167300 */     // MIs[0] policy
     /* 2167300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167310 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2167313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167336 */     // GIR_Coverage, 18146,
     /* 2167336 */     GIR_EraseRootFromParent_Done,
     /* 2167337 */   // Label 28570: @2167337
     /* 2167337 */   GIM_Try, /*On fail goto*//*Label 28571*/ GIMT_Encode4(2167428), // Rule ID 18147 //
     /* 2167342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2167353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2167356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2167359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2167362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2167365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2167372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167388 */     // MIs[0] round
     /* 2167388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167391 */     // MIs[0] policy
     /* 2167391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167401 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2167404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167427 */     // GIR_Coverage, 18147,
     /* 2167427 */     GIR_EraseRootFromParent_Done,
     /* 2167428 */   // Label 28571: @2167428
     /* 2167428 */   GIM_Try, /*On fail goto*//*Label 28572*/ GIMT_Encode4(2167519), // Rule ID 18150 //
     /* 2167433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2167444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2167447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2167450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2167453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2167456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2167463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167479 */     // MIs[0] round
     /* 2167479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167482 */     // MIs[0] policy
     /* 2167482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167492 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2167495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167518 */     // GIR_Coverage, 18150,
     /* 2167518 */     GIR_EraseRootFromParent_Done,
     /* 2167519 */   // Label 28572: @2167519
     /* 2167519 */   GIM_Try, /*On fail goto*//*Label 28573*/ GIMT_Encode4(2167610), // Rule ID 18151 //
     /* 2167524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2167535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2167538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2167541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2167544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2167547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2167554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167570 */     // MIs[0] round
     /* 2167570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167573 */     // MIs[0] policy
     /* 2167573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167583 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2167586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167609 */     // GIR_Coverage, 18151,
     /* 2167609 */     GIR_EraseRootFromParent_Done,
     /* 2167610 */   // Label 28573: @2167610
     /* 2167610 */   GIM_Try, /*On fail goto*//*Label 28574*/ GIMT_Encode4(2167701), // Rule ID 18154 //
     /* 2167615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2167618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2167626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2167629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2167632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2167635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2167645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167661 */     // MIs[0] round
     /* 2167661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167664 */     // MIs[0] policy
     /* 2167664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167674 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2167677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167700 */     // GIR_Coverage, 18154,
     /* 2167700 */     GIR_EraseRootFromParent_Done,
     /* 2167701 */   // Label 28574: @2167701
     /* 2167701 */   GIM_Try, /*On fail goto*//*Label 28575*/ GIMT_Encode4(2167792), // Rule ID 18155 //
     /* 2167706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2167709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2167717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2167720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2167723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2167726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2167736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167752 */     // MIs[0] round
     /* 2167752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167755 */     // MIs[0] policy
     /* 2167755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167765 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2167768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167791 */     // GIR_Coverage, 18155,
     /* 2167791 */     GIR_EraseRootFromParent_Done,
     /* 2167792 */   // Label 28575: @2167792
     /* 2167792 */   GIM_Try, /*On fail goto*//*Label 28576*/ GIMT_Encode4(2167883), // Rule ID 18158 //
     /* 2167797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2167800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2167808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2167811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2167814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2167817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2167827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167843 */     // MIs[0] round
     /* 2167843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167846 */     // MIs[0] policy
     /* 2167846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167856 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2167859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167882 */     // GIR_Coverage, 18158,
     /* 2167882 */     GIR_EraseRootFromParent_Done,
     /* 2167883 */   // Label 28576: @2167883
     /* 2167883 */   GIM_Try, /*On fail goto*//*Label 28577*/ GIMT_Encode4(2167974), // Rule ID 18159 //
     /* 2167888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2167891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2167899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2167902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2167905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2167908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2167918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167934 */     // MIs[0] round
     /* 2167934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167937 */     // MIs[0] policy
     /* 2167937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167947 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2167950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167973 */     // GIR_Coverage, 18159,
     /* 2167973 */     GIR_EraseRootFromParent_Done,
     /* 2167974 */   // Label 28577: @2167974
     /* 2167974 */   GIM_Try, /*On fail goto*//*Label 28578*/ GIMT_Encode4(2168065), // Rule ID 18162 //
     /* 2167979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2167982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2167990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2167993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2167996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2167999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2168009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168025 */     // MIs[0] round
     /* 2168025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168028 */     // MIs[0] policy
     /* 2168028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168038 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2168041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168064 */     // GIR_Coverage, 18162,
     /* 2168064 */     GIR_EraseRootFromParent_Done,
     /* 2168065 */   // Label 28578: @2168065
     /* 2168065 */   GIM_Try, /*On fail goto*//*Label 28579*/ GIMT_Encode4(2168156), // Rule ID 18163 //
     /* 2168070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2168073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2168078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2168081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2168084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2168087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2168090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2168100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168116 */     // MIs[0] round
     /* 2168116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168119 */     // MIs[0] policy
     /* 2168119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168129 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2168132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168155 */     // GIR_Coverage, 18163,
     /* 2168155 */     GIR_EraseRootFromParent_Done,
     /* 2168156 */   // Label 28579: @2168156
     /* 2168156 */   GIM_Try, /*On fail goto*//*Label 28580*/ GIMT_Encode4(2168247), // Rule ID 18166 //
     /* 2168161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2168169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2168172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2168175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2168178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2168181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2168199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168207 */     // MIs[0] round
     /* 2168207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168210 */     // MIs[0] policy
     /* 2168210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168220 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2168223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168246 */     // GIR_Coverage, 18166,
     /* 2168246 */     GIR_EraseRootFromParent_Done,
     /* 2168247 */   // Label 28580: @2168247
     /* 2168247 */   GIM_Try, /*On fail goto*//*Label 28581*/ GIMT_Encode4(2168338), // Rule ID 18167 //
     /* 2168252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2168260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2168263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2168266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2168269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2168272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2168290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168298 */     // MIs[0] round
     /* 2168298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168301 */     // MIs[0] policy
     /* 2168301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168311 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2168314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168337 */     // GIR_Coverage, 18167,
     /* 2168337 */     GIR_EraseRootFromParent_Done,
     /* 2168338 */   // Label 28581: @2168338
     /* 2168338 */   GIM_Try, /*On fail goto*//*Label 28582*/ GIMT_Encode4(2168429), // Rule ID 18170 //
     /* 2168343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2168351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2168354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2168357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2168360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2168363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2168366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2168381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168389 */     // MIs[0] round
     /* 2168389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168392 */     // MIs[0] policy
     /* 2168392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168402 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2168405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168428 */     // GIR_Coverage, 18170,
     /* 2168428 */     GIR_EraseRootFromParent_Done,
     /* 2168429 */   // Label 28582: @2168429
     /* 2168429 */   GIM_Try, /*On fail goto*//*Label 28583*/ GIMT_Encode4(2168520), // Rule ID 18171 //
     /* 2168434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2168442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2168445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2168448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2168451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2168454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2168457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2168472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168480 */     // MIs[0] round
     /* 2168480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168483 */     // MIs[0] policy
     /* 2168483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168493 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2168496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168519 */     // GIR_Coverage, 18171,
     /* 2168519 */     GIR_EraseRootFromParent_Done,
     /* 2168520 */   // Label 28583: @2168520
     /* 2168520 */   GIM_Try, /*On fail goto*//*Label 28584*/ GIMT_Encode4(2168611), // Rule ID 18174 //
     /* 2168525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2168528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2168533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2168536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2168539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2168542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2168545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2168563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168571 */     // MIs[0] round
     /* 2168571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168574 */     // MIs[0] policy
     /* 2168574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168584 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2168587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168610 */     // GIR_Coverage, 18174,
     /* 2168610 */     GIR_EraseRootFromParent_Done,
     /* 2168611 */   // Label 28584: @2168611
     /* 2168611 */   GIM_Try, /*On fail goto*//*Label 28585*/ GIMT_Encode4(2168702), // Rule ID 18175 //
     /* 2168616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2168619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2168624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2168627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2168630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2168633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2168636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2168654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168662 */     // MIs[0] round
     /* 2168662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168665 */     // MIs[0] policy
     /* 2168665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168675 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2168678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168701 */     // GIR_Coverage, 18175,
     /* 2168701 */     GIR_EraseRootFromParent_Done,
     /* 2168702 */   // Label 28585: @2168702
     /* 2168702 */   GIM_Try, /*On fail goto*//*Label 28586*/ GIMT_Encode4(2168793), // Rule ID 18178 //
     /* 2168707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2168715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2168718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2168721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2168724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2168727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2168745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168753 */     // MIs[0] round
     /* 2168753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168756 */     // MIs[0] policy
     /* 2168756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168766 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2168769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168792 */     // GIR_Coverage, 18178,
     /* 2168792 */     GIR_EraseRootFromParent_Done,
     /* 2168793 */   // Label 28586: @2168793
     /* 2168793 */   GIM_Try, /*On fail goto*//*Label 28587*/ GIMT_Encode4(2168884), // Rule ID 18179 //
     /* 2168798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2168806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2168809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2168812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2168815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2168818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2168836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168844 */     // MIs[0] round
     /* 2168844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168847 */     // MIs[0] policy
     /* 2168847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168857 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2168860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168883 */     // GIR_Coverage, 18179,
     /* 2168883 */     GIR_EraseRootFromParent_Done,
     /* 2168884 */   // Label 28587: @2168884
     /* 2168884 */   GIM_Try, /*On fail goto*//*Label 28588*/ GIMT_Encode4(2168975), // Rule ID 18182 //
     /* 2168889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2168892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2168897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2168900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2168903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2168906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2168909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2168912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2168927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168935 */     // MIs[0] round
     /* 2168935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168938 */     // MIs[0] policy
     /* 2168938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168948 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2168951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168974 */     // GIR_Coverage, 18182,
     /* 2168974 */     GIR_EraseRootFromParent_Done,
     /* 2168975 */   // Label 28588: @2168975
     /* 2168975 */   GIM_Try, /*On fail goto*//*Label 28589*/ GIMT_Encode4(2169066), // Rule ID 18183 //
     /* 2168980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2168983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2168988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2168991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2168994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2168997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2169000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2169018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169026 */     // MIs[0] round
     /* 2169026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169029 */     // MIs[0] policy
     /* 2169029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169039 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2169042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169065 */     // GIR_Coverage, 18183,
     /* 2169065 */     GIR_EraseRootFromParent_Done,
     /* 2169066 */   // Label 28589: @2169066
     /* 2169066 */   GIM_Try, /*On fail goto*//*Label 28590*/ GIMT_Encode4(2169157), // Rule ID 18186 //
     /* 2169071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2169079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2169082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2169085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2169088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2169091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2169094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2169109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169117 */     // MIs[0] round
     /* 2169117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169120 */     // MIs[0] policy
     /* 2169120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169130 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2169133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169156 */     // GIR_Coverage, 18186,
     /* 2169156 */     GIR_EraseRootFromParent_Done,
     /* 2169157 */   // Label 28590: @2169157
     /* 2169157 */   GIM_Try, /*On fail goto*//*Label 28591*/ GIMT_Encode4(2169248), // Rule ID 18187 //
     /* 2169162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2169170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2169173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2169176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2169179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2169182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2169185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2169200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169208 */     // MIs[0] round
     /* 2169208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169211 */     // MIs[0] policy
     /* 2169211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169221 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2169224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169247 */     // GIR_Coverage, 18187,
     /* 2169247 */     GIR_EraseRootFromParent_Done,
     /* 2169248 */   // Label 28591: @2169248
     /* 2169248 */   GIM_Try, /*On fail goto*//*Label 28592*/ GIMT_Encode4(2169339), // Rule ID 18190 //
     /* 2169253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2169256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2169261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2169264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2169267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2169273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169299 */     // MIs[0] round
     /* 2169299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169302 */     // MIs[0] policy
     /* 2169302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169312 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2169315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169338 */     // GIR_Coverage, 18190,
     /* 2169338 */     GIR_EraseRootFromParent_Done,
     /* 2169339 */   // Label 28592: @2169339
     /* 2169339 */   GIM_Try, /*On fail goto*//*Label 28593*/ GIMT_Encode4(2169430), // Rule ID 18191 //
     /* 2169344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2169347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2169352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2169355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2169358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2169364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169390 */     // MIs[0] round
     /* 2169390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169393 */     // MIs[0] policy
     /* 2169393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169403 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2169406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169429 */     // GIR_Coverage, 18191,
     /* 2169429 */     GIR_EraseRootFromParent_Done,
     /* 2169430 */   // Label 28593: @2169430
     /* 2169430 */   GIM_Try, /*On fail goto*//*Label 28594*/ GIMT_Encode4(2169521), // Rule ID 18194 //
     /* 2169435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2169438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2169443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2169446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2169449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2169455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2169458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169481 */     // MIs[0] round
     /* 2169481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169484 */     // MIs[0] policy
     /* 2169484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169494 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2169497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169520 */     // GIR_Coverage, 18194,
     /* 2169520 */     GIR_EraseRootFromParent_Done,
     /* 2169521 */   // Label 28594: @2169521
     /* 2169521 */   GIM_Try, /*On fail goto*//*Label 28595*/ GIMT_Encode4(2169612), // Rule ID 18195 //
     /* 2169526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2169529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2169534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2169537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2169540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2169546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2169549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169572 */     // MIs[0] round
     /* 2169572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169575 */     // MIs[0] policy
     /* 2169575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169585 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2169588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169611 */     // GIR_Coverage, 18195,
     /* 2169611 */     GIR_EraseRootFromParent_Done,
     /* 2169612 */   // Label 28595: @2169612
     /* 2169612 */   GIM_Try, /*On fail goto*//*Label 28596*/ GIMT_Encode4(2169703), // Rule ID 18198 //
     /* 2169617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2169620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2169625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2169628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2169631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2169637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2169640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169663 */     // MIs[0] round
     /* 2169663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169666 */     // MIs[0] policy
     /* 2169666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169676 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2169679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169702 */     // GIR_Coverage, 18198,
     /* 2169702 */     GIR_EraseRootFromParent_Done,
     /* 2169703 */   // Label 28596: @2169703
     /* 2169703 */   GIM_Try, /*On fail goto*//*Label 28597*/ GIMT_Encode4(2169794), // Rule ID 18199 //
     /* 2169708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2169711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2169716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2169719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2169722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2169728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2169731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169754 */     // MIs[0] round
     /* 2169754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169757 */     // MIs[0] policy
     /* 2169757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169767 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2169770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169793 */     // GIR_Coverage, 18199,
     /* 2169793 */     GIR_EraseRootFromParent_Done,
     /* 2169794 */   // Label 28597: @2169794
     /* 2169794 */   GIM_Try, /*On fail goto*//*Label 28598*/ GIMT_Encode4(2169885), // Rule ID 18202 //
     /* 2169799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2169802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2169807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2169810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2169813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2169816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2169819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2169837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169845 */     // MIs[0] round
     /* 2169845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169848 */     // MIs[0] policy
     /* 2169848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169858 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2169861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169884 */     // GIR_Coverage, 18202,
     /* 2169884 */     GIR_EraseRootFromParent_Done,
     /* 2169885 */   // Label 28598: @2169885
     /* 2169885 */   GIM_Try, /*On fail goto*//*Label 28599*/ GIMT_Encode4(2169976), // Rule ID 18203 //
     /* 2169890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2169893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2169898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2169901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2169904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2169907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2169910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2169928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169936 */     // MIs[0] round
     /* 2169936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169939 */     // MIs[0] policy
     /* 2169939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169949 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2169952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169975 */     // GIR_Coverage, 18203,
     /* 2169975 */     GIR_EraseRootFromParent_Done,
     /* 2169976 */   // Label 28599: @2169976
     /* 2169976 */   GIM_Try, /*On fail goto*//*Label 28600*/ GIMT_Encode4(2170067), // Rule ID 18206 //
     /* 2169981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2169984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2169989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2169992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2169995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2169998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2170001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2170011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170027 */     // MIs[0] round
     /* 2170027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170030 */     // MIs[0] policy
     /* 2170030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170040 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2170043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170066 */     // GIR_Coverage, 18206,
     /* 2170066 */     GIR_EraseRootFromParent_Done,
     /* 2170067 */   // Label 28600: @2170067
     /* 2170067 */   GIM_Try, /*On fail goto*//*Label 28601*/ GIMT_Encode4(2170158), // Rule ID 18207 //
     /* 2170072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2170075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2170080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2170083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2170086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2170092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2170102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170118 */     // MIs[0] round
     /* 2170118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170121 */     // MIs[0] policy
     /* 2170121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170131 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2170134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170157 */     // GIR_Coverage, 18207,
     /* 2170157 */     GIR_EraseRootFromParent_Done,
     /* 2170158 */   // Label 28601: @2170158
     /* 2170158 */   GIM_Try, /*On fail goto*//*Label 28602*/ GIMT_Encode4(2170249), // Rule ID 18210 //
     /* 2170163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2170166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2170171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2170174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2170177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2170183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2170186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2170193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170209 */     // MIs[0] round
     /* 2170209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170212 */     // MIs[0] policy
     /* 2170212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170222 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2170225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170248 */     // GIR_Coverage, 18210,
     /* 2170248 */     GIR_EraseRootFromParent_Done,
     /* 2170249 */   // Label 28602: @2170249
     /* 2170249 */   GIM_Try, /*On fail goto*//*Label 28603*/ GIMT_Encode4(2170340), // Rule ID 18211 //
     /* 2170254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2170257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2170262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2170265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2170268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2170274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2170277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2170284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170300 */     // MIs[0] round
     /* 2170300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170303 */     // MIs[0] policy
     /* 2170303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170313 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2170316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170339 */     // GIR_Coverage, 18211,
     /* 2170339 */     GIR_EraseRootFromParent_Done,
     /* 2170340 */   // Label 28603: @2170340
     /* 2170340 */   GIM_Try, /*On fail goto*//*Label 28604*/ GIMT_Encode4(2170431), // Rule ID 18214 //
     /* 2170345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2170348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2170353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2170356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2170359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2170365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2170375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170391 */     // MIs[0] round
     /* 2170391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170394 */     // MIs[0] policy
     /* 2170394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170404 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2170407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170430 */     // GIR_Coverage, 18214,
     /* 2170430 */     GIR_EraseRootFromParent_Done,
     /* 2170431 */   // Label 28604: @2170431
     /* 2170431 */   GIM_Try, /*On fail goto*//*Label 28605*/ GIMT_Encode4(2170522), // Rule ID 18215 //
     /* 2170436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2170439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2170444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2170447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2170450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2170456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2170466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170482 */     // MIs[0] round
     /* 2170482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170485 */     // MIs[0] policy
     /* 2170485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170495 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2170498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170521 */     // GIR_Coverage, 18215,
     /* 2170521 */     GIR_EraseRootFromParent_Done,
     /* 2170522 */   // Label 28605: @2170522
     /* 2170522 */   GIM_Try, /*On fail goto*//*Label 28606*/ GIMT_Encode4(2170613), // Rule ID 18218 //
     /* 2170527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2170530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2170535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2170538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2170541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2170547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2170557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170573 */     // MIs[0] round
     /* 2170573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170576 */     // MIs[0] policy
     /* 2170576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170586 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2170589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170612 */     // GIR_Coverage, 18218,
     /* 2170612 */     GIR_EraseRootFromParent_Done,
     /* 2170613 */   // Label 28606: @2170613
     /* 2170613 */   GIM_Try, /*On fail goto*//*Label 28607*/ GIMT_Encode4(2170704), // Rule ID 18219 //
     /* 2170618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2170621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2170626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2170629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2170632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2170638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2170648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170664 */     // MIs[0] round
     /* 2170664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170667 */     // MIs[0] policy
     /* 2170667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170677 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2170680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170703 */     // GIR_Coverage, 18219,
     /* 2170703 */     GIR_EraseRootFromParent_Done,
     /* 2170704 */   // Label 28607: @2170704
     /* 2170704 */   GIM_Try, /*On fail goto*//*Label 28608*/ GIMT_Encode4(2170795), // Rule ID 18222 //
     /* 2170709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2170712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2170717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2170720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2170723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2170729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2170739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170755 */     // MIs[0] round
     /* 2170755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170758 */     // MIs[0] policy
     /* 2170758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170768 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2170771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170794 */     // GIR_Coverage, 18222,
     /* 2170794 */     GIR_EraseRootFromParent_Done,
     /* 2170795 */   // Label 28608: @2170795
     /* 2170795 */   GIM_Try, /*On fail goto*//*Label 28609*/ GIMT_Encode4(2170886), // Rule ID 18223 //
     /* 2170800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2170803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2170808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2170811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2170814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2170820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2170830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170846 */     // MIs[0] round
     /* 2170846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170849 */     // MIs[0] policy
     /* 2170849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170859 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2170862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170885 */     // GIR_Coverage, 18223,
     /* 2170885 */     GIR_EraseRootFromParent_Done,
     /* 2170886 */   // Label 28609: @2170886
     /* 2170886 */   GIM_Try, /*On fail goto*//*Label 28610*/ GIMT_Encode4(2170977), // Rule ID 18226 //
     /* 2170891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2170902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2170905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2170908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2170911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170937 */     // MIs[0] round
     /* 2170937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170940 */     // MIs[0] policy
     /* 2170940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170950 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2170953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170976 */     // GIR_Coverage, 18226,
     /* 2170976 */     GIR_EraseRootFromParent_Done,
     /* 2170977 */   // Label 28610: @2170977
     /* 2170977 */   GIM_Try, /*On fail goto*//*Label 28611*/ GIMT_Encode4(2171068), // Rule ID 18227 //
     /* 2170982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2170993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2170996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2170999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2171002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2171005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171028 */     // MIs[0] round
     /* 2171028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171031 */     // MIs[0] policy
     /* 2171031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171041 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2171044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171067 */     // GIR_Coverage, 18227,
     /* 2171067 */     GIR_EraseRootFromParent_Done,
     /* 2171068 */   // Label 28611: @2171068
     /* 2171068 */   GIM_Try, /*On fail goto*//*Label 28612*/ GIMT_Encode4(2171159), // Rule ID 18230 //
     /* 2171073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2171084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2171087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2171090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2171093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171119 */     // MIs[0] round
     /* 2171119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171122 */     // MIs[0] policy
     /* 2171122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171132 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2171135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171158 */     // GIR_Coverage, 18230,
     /* 2171158 */     GIR_EraseRootFromParent_Done,
     /* 2171159 */   // Label 28612: @2171159
     /* 2171159 */   GIM_Try, /*On fail goto*//*Label 28613*/ GIMT_Encode4(2171250), // Rule ID 18231 //
     /* 2171164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2171175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2171178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2171181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2171184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171210 */     // MIs[0] round
     /* 2171210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171213 */     // MIs[0] policy
     /* 2171213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171223 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2171226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171249 */     // GIR_Coverage, 18231,
     /* 2171249 */     GIR_EraseRootFromParent_Done,
     /* 2171250 */   // Label 28613: @2171250
     /* 2171250 */   GIM_Try, /*On fail goto*//*Label 28614*/ GIMT_Encode4(2171341), // Rule ID 18234 //
     /* 2171255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2171266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2171269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2171272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2171275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2171278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171301 */     // MIs[0] round
     /* 2171301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171304 */     // MIs[0] policy
     /* 2171304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171314 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2171317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171340 */     // GIR_Coverage, 18234,
     /* 2171340 */     GIR_EraseRootFromParent_Done,
     /* 2171341 */   // Label 28614: @2171341
     /* 2171341 */   GIM_Try, /*On fail goto*//*Label 28615*/ GIMT_Encode4(2171432), // Rule ID 18235 //
     /* 2171346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2171357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2171360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2171363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2171366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2171369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171392 */     // MIs[0] round
     /* 2171392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171395 */     // MIs[0] policy
     /* 2171395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171405 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2171408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171431 */     // GIR_Coverage, 18235,
     /* 2171431 */     GIR_EraseRootFromParent_Done,
     /* 2171432 */   // Label 28615: @2171432
     /* 2171432 */   GIM_Try, /*On fail goto*//*Label 28616*/ GIMT_Encode4(2171523), // Rule ID 18238 //
     /* 2171437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2171448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2171451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2171454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2171457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171483 */     // MIs[0] round
     /* 2171483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171486 */     // MIs[0] policy
     /* 2171486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171496 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2171499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171522 */     // GIR_Coverage, 18238,
     /* 2171522 */     GIR_EraseRootFromParent_Done,
     /* 2171523 */   // Label 28616: @2171523
     /* 2171523 */   GIM_Try, /*On fail goto*//*Label 28617*/ GIMT_Encode4(2171614), // Rule ID 18239 //
     /* 2171528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2171539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2171542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2171545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2171548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171574 */     // MIs[0] round
     /* 2171574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171577 */     // MIs[0] policy
     /* 2171577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171587 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2171590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171613 */     // GIR_Coverage, 18239,
     /* 2171613 */     GIR_EraseRootFromParent_Done,
     /* 2171614 */   // Label 28617: @2171614
     /* 2171614 */   GIM_Try, /*On fail goto*//*Label 28618*/ GIMT_Encode4(2171705), // Rule ID 18242 //
     /* 2171619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2171630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2171633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2171636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2171639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171665 */     // MIs[0] round
     /* 2171665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171668 */     // MIs[0] policy
     /* 2171668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171678 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2171681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171704 */     // GIR_Coverage, 18242,
     /* 2171704 */     GIR_EraseRootFromParent_Done,
     /* 2171705 */   // Label 28618: @2171705
     /* 2171705 */   GIM_Try, /*On fail goto*//*Label 28619*/ GIMT_Encode4(2171796), // Rule ID 18243 //
     /* 2171710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2171721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2171724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2171727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2171730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171756 */     // MIs[0] round
     /* 2171756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171759 */     // MIs[0] policy
     /* 2171759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171769 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2171772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171795 */     // GIR_Coverage, 18243,
     /* 2171795 */     GIR_EraseRootFromParent_Done,
     /* 2171796 */   // Label 28619: @2171796
     /* 2171796 */   GIM_Try, /*On fail goto*//*Label 28620*/ GIMT_Encode4(2171887), // Rule ID 18246 //
     /* 2171801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2171804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2171812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2171815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2171818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2171821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2171824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171847 */     // MIs[0] round
     /* 2171847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171850 */     // MIs[0] policy
     /* 2171850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171860 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2171863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171886 */     // GIR_Coverage, 18246,
     /* 2171886 */     GIR_EraseRootFromParent_Done,
     /* 2171887 */   // Label 28620: @2171887
     /* 2171887 */   GIM_Try, /*On fail goto*//*Label 28621*/ GIMT_Encode4(2171978), // Rule ID 18247 //
     /* 2171892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2171895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2171903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2171906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2171909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2171912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2171915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171938 */     // MIs[0] round
     /* 2171938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171941 */     // MIs[0] policy
     /* 2171941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171951 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2171954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171977 */     // GIR_Coverage, 18247,
     /* 2171977 */     GIR_EraseRootFromParent_Done,
     /* 2171978 */   // Label 28621: @2171978
     /* 2171978 */   GIM_Try, /*On fail goto*//*Label 28622*/ GIMT_Encode4(2172069), // Rule ID 18250 //
     /* 2171983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2171994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2171997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2172000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2172003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172029 */     // MIs[0] round
     /* 2172029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172032 */     // MIs[0] policy
     /* 2172032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172042 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2172045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172068 */     // GIR_Coverage, 18250,
     /* 2172068 */     GIR_EraseRootFromParent_Done,
     /* 2172069 */   // Label 28622: @2172069
     /* 2172069 */   GIM_Try, /*On fail goto*//*Label 28623*/ GIMT_Encode4(2172160), // Rule ID 18251 //
     /* 2172074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2172077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2172085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2172088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2172091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2172094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172120 */     // MIs[0] round
     /* 2172120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172123 */     // MIs[0] policy
     /* 2172123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172133 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2172136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172159 */     // GIR_Coverage, 18251,
     /* 2172159 */     GIR_EraseRootFromParent_Done,
     /* 2172160 */   // Label 28623: @2172160
     /* 2172160 */   GIM_Try, /*On fail goto*//*Label 28624*/ GIMT_Encode4(2172251), // Rule ID 18254 //
     /* 2172165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2172176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2172179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2172182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2172185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2172188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172211 */     // MIs[0] round
     /* 2172211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172214 */     // MIs[0] policy
     /* 2172214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172224 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2172227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172250 */     // GIR_Coverage, 18254,
     /* 2172250 */     GIR_EraseRootFromParent_Done,
     /* 2172251 */   // Label 28624: @2172251
     /* 2172251 */   GIM_Try, /*On fail goto*//*Label 28625*/ GIMT_Encode4(2172342), // Rule ID 18255 //
     /* 2172256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2172259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2172267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2172270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2172273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2172276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2172279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172302 */     // MIs[0] round
     /* 2172302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172305 */     // MIs[0] policy
     /* 2172305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172315 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2172318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172341 */     // GIR_Coverage, 18255,
     /* 2172341 */     GIR_EraseRootFromParent_Done,
     /* 2172342 */   // Label 28625: @2172342
     /* 2172342 */   GIM_Try, /*On fail goto*//*Label 28626*/ GIMT_Encode4(2172433), // Rule ID 18258 //
     /* 2172347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2172358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2172361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2172364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2172367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2172370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172393 */     // MIs[0] round
     /* 2172393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172396 */     // MIs[0] policy
     /* 2172396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172406 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2172409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172432 */     // GIR_Coverage, 18258,
     /* 2172432 */     GIR_EraseRootFromParent_Done,
     /* 2172433 */   // Label 28626: @2172433
     /* 2172433 */   GIM_Try, /*On fail goto*//*Label 28627*/ GIMT_Encode4(2172524), // Rule ID 18259 //
     /* 2172438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2172441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2172449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2172452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2172455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2172458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2172461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172484 */     // MIs[0] round
     /* 2172484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172487 */     // MIs[0] policy
     /* 2172487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172497 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2172500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172523 */     // GIR_Coverage, 18259,
     /* 2172523 */     GIR_EraseRootFromParent_Done,
     /* 2172524 */   // Label 28627: @2172524
     /* 2172524 */   GIM_Try, /*On fail goto*//*Label 28628*/ GIMT_Encode4(2172615), // Rule ID 18262 //
     /* 2172529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2172532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2172540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2172543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2172546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2172549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172575 */     // MIs[0] round
     /* 2172575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172578 */     // MIs[0] policy
     /* 2172578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172588 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2172591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172614 */     // GIR_Coverage, 18262,
     /* 2172614 */     GIR_EraseRootFromParent_Done,
     /* 2172615 */   // Label 28628: @2172615
     /* 2172615 */   GIM_Try, /*On fail goto*//*Label 28629*/ GIMT_Encode4(2172706), // Rule ID 18263 //
     /* 2172620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2172623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2172631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2172634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2172637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2172640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172666 */     // MIs[0] round
     /* 2172666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172669 */     // MIs[0] policy
     /* 2172669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172679 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2172682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172705 */     // GIR_Coverage, 18263,
     /* 2172705 */     GIR_EraseRootFromParent_Done,
     /* 2172706 */   // Label 28629: @2172706
     /* 2172706 */   GIM_Try, /*On fail goto*//*Label 28630*/ GIMT_Encode4(2172797), // Rule ID 18266 //
     /* 2172711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2172714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2172722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2172725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2172728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2172731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172757 */     // MIs[0] round
     /* 2172757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172760 */     // MIs[0] policy
     /* 2172760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172770 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2172773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172796 */     // GIR_Coverage, 18266,
     /* 2172796 */     GIR_EraseRootFromParent_Done,
     /* 2172797 */   // Label 28630: @2172797
     /* 2172797 */   GIM_Try, /*On fail goto*//*Label 28631*/ GIMT_Encode4(2172888), // Rule ID 18267 //
     /* 2172802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2172805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2172813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2172816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2172819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2172822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172848 */     // MIs[0] round
     /* 2172848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172851 */     // MIs[0] policy
     /* 2172851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172861 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2172864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172887 */     // GIR_Coverage, 18267,
     /* 2172887 */     GIR_EraseRootFromParent_Done,
     /* 2172888 */   // Label 28631: @2172888
     /* 2172888 */   GIM_Try, /*On fail goto*//*Label 28632*/ GIMT_Encode4(2172979), // Rule ID 18270 //
     /* 2172893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2172896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2172904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2172907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2172910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2172913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2172916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172939 */     // MIs[0] round
     /* 2172939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172942 */     // MIs[0] policy
     /* 2172942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172952 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2172955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172978 */     // GIR_Coverage, 18270,
     /* 2172978 */     GIR_EraseRootFromParent_Done,
     /* 2172979 */   // Label 28632: @2172979
     /* 2172979 */   GIM_Try, /*On fail goto*//*Label 28633*/ GIMT_Encode4(2173070), // Rule ID 18271 //
     /* 2172984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2172987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2172995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2172998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2173001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2173004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2173007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2173014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173030 */     // MIs[0] round
     /* 2173030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173033 */     // MIs[0] policy
     /* 2173033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173043 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2173046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173069 */     // GIR_Coverage, 18271,
     /* 2173069 */     GIR_EraseRootFromParent_Done,
     /* 2173070 */   // Label 28633: @2173070
     /* 2173070 */   GIM_Try, /*On fail goto*//*Label 28634*/ GIMT_Encode4(2173161), // Rule ID 18274 //
     /* 2173075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2173078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2173083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2173086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2173089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2173092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2173095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2173105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173121 */     // MIs[0] round
     /* 2173121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173124 */     // MIs[0] policy
     /* 2173124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173134 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2173137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173160 */     // GIR_Coverage, 18274,
     /* 2173160 */     GIR_EraseRootFromParent_Done,
     /* 2173161 */   // Label 28634: @2173161
     /* 2173161 */   GIM_Try, /*On fail goto*//*Label 28635*/ GIMT_Encode4(2173252), // Rule ID 18275 //
     /* 2173166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2173169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2173174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2173177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2173180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2173183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2173186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2173196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173212 */     // MIs[0] round
     /* 2173212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173215 */     // MIs[0] policy
     /* 2173215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173225 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2173228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173251 */     // GIR_Coverage, 18275,
     /* 2173251 */     GIR_EraseRootFromParent_Done,
     /* 2173252 */   // Label 28635: @2173252
     /* 2173252 */   GIM_Try, /*On fail goto*//*Label 28636*/ GIMT_Encode4(2173343), // Rule ID 18278 //
     /* 2173257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2173260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2173265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2173268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2173271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2173274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2173277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2173287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173303 */     // MIs[0] round
     /* 2173303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173306 */     // MIs[0] policy
     /* 2173306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173316 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2173319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173342 */     // GIR_Coverage, 18278,
     /* 2173342 */     GIR_EraseRootFromParent_Done,
     /* 2173343 */   // Label 28636: @2173343
     /* 2173343 */   GIM_Try, /*On fail goto*//*Label 28637*/ GIMT_Encode4(2173434), // Rule ID 18279 //
     /* 2173348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2173351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2173356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2173359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2173362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2173365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2173368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2173378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173394 */     // MIs[0] round
     /* 2173394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173397 */     // MIs[0] policy
     /* 2173397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173407 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2173410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173433 */     // GIR_Coverage, 18279,
     /* 2173433 */     GIR_EraseRootFromParent_Done,
     /* 2173434 */   // Label 28637: @2173434
     /* 2173434 */   GIM_Try, /*On fail goto*//*Label 28638*/ GIMT_Encode4(2173525), // Rule ID 18282 //
     /* 2173439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2173442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2173447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2173450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2173453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2173456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2173459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2173462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2173469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173485 */     // MIs[0] round
     /* 2173485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173488 */     // MIs[0] policy
     /* 2173488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173498 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2173501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173524 */     // GIR_Coverage, 18282,
     /* 2173524 */     GIR_EraseRootFromParent_Done,
     /* 2173525 */   // Label 28638: @2173525
     /* 2173525 */   GIM_Try, /*On fail goto*//*Label 28639*/ GIMT_Encode4(2173616), // Rule ID 18283 //
     /* 2173530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2173533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2173538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2173541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2173544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2173547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2173550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2173553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2173560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173576 */     // MIs[0] round
     /* 2173576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173579 */     // MIs[0] policy
     /* 2173579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173589 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2173592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173615 */     // GIR_Coverage, 18283,
     /* 2173615 */     GIR_EraseRootFromParent_Done,
     /* 2173616 */   // Label 28639: @2173616
     /* 2173616 */   GIM_Try, /*On fail goto*//*Label 28640*/ GIMT_Encode4(2173707), // Rule ID 18286 //
     /* 2173621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2173629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2173632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2173635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2173638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2173641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2173659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173667 */     // MIs[0] round
     /* 2173667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173670 */     // MIs[0] policy
     /* 2173670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173680 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2173683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173706 */     // GIR_Coverage, 18286,
     /* 2173706 */     GIR_EraseRootFromParent_Done,
     /* 2173707 */   // Label 28640: @2173707
     /* 2173707 */   GIM_Try, /*On fail goto*//*Label 28641*/ GIMT_Encode4(2173798), // Rule ID 18287 //
     /* 2173712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2173720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2173723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2173726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2173729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2173732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2173750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173758 */     // MIs[0] round
     /* 2173758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173761 */     // MIs[0] policy
     /* 2173761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173771 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2173774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173797 */     // GIR_Coverage, 18287,
     /* 2173797 */     GIR_EraseRootFromParent_Done,
     /* 2173798 */   // Label 28641: @2173798
     /* 2173798 */   GIM_Try, /*On fail goto*//*Label 28642*/ GIMT_Encode4(2173889), // Rule ID 18290 //
     /* 2173803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2173811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2173814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2173817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2173820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2173823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2173841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173849 */     // MIs[0] round
     /* 2173849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173852 */     // MIs[0] policy
     /* 2173852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173862 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2173865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173888 */     // GIR_Coverage, 18290,
     /* 2173888 */     GIR_EraseRootFromParent_Done,
     /* 2173889 */   // Label 28642: @2173889
     /* 2173889 */   GIM_Try, /*On fail goto*//*Label 28643*/ GIMT_Encode4(2173980), // Rule ID 18291 //
     /* 2173894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2173902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2173905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2173908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2173911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2173914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2173932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173940 */     // MIs[0] round
     /* 2173940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173943 */     // MIs[0] policy
     /* 2173943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173953 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2173956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173979 */     // GIR_Coverage, 18291,
     /* 2173979 */     GIR_EraseRootFromParent_Done,
     /* 2173980 */   // Label 28643: @2173980
     /* 2173980 */   GIM_Try, /*On fail goto*//*Label 28644*/ GIMT_Encode4(2174071), // Rule ID 18294 //
     /* 2173985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2173988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2173993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2173996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2173999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2174002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2174005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2174008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2174023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174031 */     // MIs[0] round
     /* 2174031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174034 */     // MIs[0] policy
     /* 2174034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174044 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2174047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174070 */     // GIR_Coverage, 18294,
     /* 2174070 */     GIR_EraseRootFromParent_Done,
     /* 2174071 */   // Label 28644: @2174071
     /* 2174071 */   GIM_Try, /*On fail goto*//*Label 28645*/ GIMT_Encode4(2174162), // Rule ID 18295 //
     /* 2174076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2174084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2174087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2174090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2174093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2174096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2174099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2174114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174122 */     // MIs[0] round
     /* 2174122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174125 */     // MIs[0] policy
     /* 2174125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174135 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2174138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174161 */     // GIR_Coverage, 18295,
     /* 2174161 */     GIR_EraseRootFromParent_Done,
     /* 2174162 */   // Label 28645: @2174162
     /* 2174162 */   GIM_Try, /*On fail goto*//*Label 28646*/ GIMT_Encode4(2174253), // Rule ID 18298 //
     /* 2174167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2174170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2174175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2174178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2174181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2174184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2174187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2174205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174213 */     // MIs[0] round
     /* 2174213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174216 */     // MIs[0] policy
     /* 2174216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174226 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2174229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174252 */     // GIR_Coverage, 18298,
     /* 2174252 */     GIR_EraseRootFromParent_Done,
     /* 2174253 */   // Label 28646: @2174253
     /* 2174253 */   GIM_Try, /*On fail goto*//*Label 28647*/ GIMT_Encode4(2174344), // Rule ID 18299 //
     /* 2174258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2174261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2174266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2174269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2174272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2174275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2174278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2174296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174304 */     // MIs[0] round
     /* 2174304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174307 */     // MIs[0] policy
     /* 2174307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174317 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2174320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174343 */     // GIR_Coverage, 18299,
     /* 2174343 */     GIR_EraseRootFromParent_Done,
     /* 2174344 */   // Label 28647: @2174344
     /* 2174344 */   GIM_Try, /*On fail goto*//*Label 28648*/ GIMT_Encode4(2174435), // Rule ID 18302 //
     /* 2174349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2174357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2174360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2174363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2174366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2174369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2174372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2174387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174395 */     // MIs[0] round
     /* 2174395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174398 */     // MIs[0] policy
     /* 2174398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174408 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2174411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174434 */     // GIR_Coverage, 18302,
     /* 2174434 */     GIR_EraseRootFromParent_Done,
     /* 2174435 */   // Label 28648: @2174435
     /* 2174435 */   GIM_Try, /*On fail goto*//*Label 28649*/ GIMT_Encode4(2174526), // Rule ID 18303 //
     /* 2174440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2174448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2174451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2174454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2174457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2174460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2174463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2174478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174486 */     // MIs[0] round
     /* 2174486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174489 */     // MIs[0] policy
     /* 2174489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174499 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2174502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174525 */     // GIR_Coverage, 18303,
     /* 2174525 */     GIR_EraseRootFromParent_Done,
     /* 2174526 */   // Label 28649: @2174526
     /* 2174526 */   GIM_Try, /*On fail goto*//*Label 28650*/ GIMT_Encode4(2174617), // Rule ID 18306 //
     /* 2174531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2174534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2174539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2174542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2174545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2174548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2174551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2174554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2174569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174577 */     // MIs[0] round
     /* 2174577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174580 */     // MIs[0] policy
     /* 2174580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174590 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2174593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174616 */     // GIR_Coverage, 18306,
     /* 2174616 */     GIR_EraseRootFromParent_Done,
     /* 2174617 */   // Label 28650: @2174617
     /* 2174617 */   GIM_Try, /*On fail goto*//*Label 28651*/ GIMT_Encode4(2174708), // Rule ID 18307 //
     /* 2174622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2174625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2174630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2174633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2174636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2174639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2174642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2174645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2174660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174668 */     // MIs[0] round
     /* 2174668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174671 */     // MIs[0] policy
     /* 2174671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174681 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2174684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174707 */     // GIR_Coverage, 18307,
     /* 2174707 */     GIR_EraseRootFromParent_Done,
     /* 2174708 */   // Label 28651: @2174708
     /* 2174708 */   GIM_Try, /*On fail goto*//*Label 28652*/ GIMT_Encode4(2174799), // Rule ID 18310 //
     /* 2174713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2174716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2174721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2174724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2174727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2174730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2174733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2174751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174759 */     // MIs[0] round
     /* 2174759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174762 */     // MIs[0] policy
     /* 2174762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174772 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2174775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174798 */     // GIR_Coverage, 18310,
     /* 2174798 */     GIR_EraseRootFromParent_Done,
     /* 2174799 */   // Label 28652: @2174799
     /* 2174799 */   GIM_Try, /*On fail goto*//*Label 28653*/ GIMT_Encode4(2174890), // Rule ID 18311 //
     /* 2174804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2174807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2174812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2174815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2174818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2174821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2174824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2174842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174850 */     // MIs[0] round
     /* 2174850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174853 */     // MIs[0] policy
     /* 2174853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174863 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2174866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174889 */     // GIR_Coverage, 18311,
     /* 2174889 */     GIR_EraseRootFromParent_Done,
     /* 2174890 */   // Label 28653: @2174890
     /* 2174890 */   GIM_Try, /*On fail goto*//*Label 28654*/ GIMT_Encode4(2174981), // Rule ID 18314 //
     /* 2174895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2174898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2174903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2174906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2174909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2174912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2174915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2174918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2174933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174941 */     // MIs[0] round
     /* 2174941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174944 */     // MIs[0] policy
     /* 2174944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174954 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2174957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174980 */     // GIR_Coverage, 18314,
     /* 2174980 */     GIR_EraseRootFromParent_Done,
     /* 2174981 */   // Label 28654: @2174981
     /* 2174981 */   GIM_Try, /*On fail goto*//*Label 28655*/ GIMT_Encode4(2175072), // Rule ID 18315 //
     /* 2174986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2174989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2174994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2174997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2175000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2175006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2175009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2175016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175032 */     // MIs[0] round
     /* 2175032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175035 */     // MIs[0] policy
     /* 2175035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175045 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2175048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175071 */     // GIR_Coverage, 18315,
     /* 2175071 */     GIR_EraseRootFromParent_Done,
     /* 2175072 */   // Label 28655: @2175072
     /* 2175072 */   GIM_Try, /*On fail goto*//*Label 28656*/ GIMT_Encode4(2175163), // Rule ID 18318 //
     /* 2175077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2175085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2175088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2175091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2175097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2175100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175123 */     // MIs[0] round
     /* 2175123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175126 */     // MIs[0] policy
     /* 2175126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175136 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2175139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175162 */     // GIR_Coverage, 18318,
     /* 2175162 */     GIR_EraseRootFromParent_Done,
     /* 2175163 */   // Label 28656: @2175163
     /* 2175163 */   GIM_Try, /*On fail goto*//*Label 28657*/ GIMT_Encode4(2175254), // Rule ID 18319 //
     /* 2175168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2175176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2175179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2175182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2175188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2175191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175214 */     // MIs[0] round
     /* 2175214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175217 */     // MIs[0] policy
     /* 2175217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175227 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2175230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175253 */     // GIR_Coverage, 18319,
     /* 2175253 */     GIR_EraseRootFromParent_Done,
     /* 2175254 */   // Label 28657: @2175254
     /* 2175254 */   GIM_Try, /*On fail goto*//*Label 28658*/ GIMT_Encode4(2175345), // Rule ID 18322 //
     /* 2175259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2175262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2175267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2175270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2175273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2175279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2175289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175305 */     // MIs[0] round
     /* 2175305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175308 */     // MIs[0] policy
     /* 2175308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175318 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2175321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175344 */     // GIR_Coverage, 18322,
     /* 2175344 */     GIR_EraseRootFromParent_Done,
     /* 2175345 */   // Label 28658: @2175345
     /* 2175345 */   GIM_Try, /*On fail goto*//*Label 28659*/ GIMT_Encode4(2175436), // Rule ID 18323 //
     /* 2175350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2175353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2175358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2175361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2175364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2175370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2175380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175396 */     // MIs[0] round
     /* 2175396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175399 */     // MIs[0] policy
     /* 2175399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175409 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2175412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175435 */     // GIR_Coverage, 18323,
     /* 2175435 */     GIR_EraseRootFromParent_Done,
     /* 2175436 */   // Label 28659: @2175436
     /* 2175436 */   GIM_Try, /*On fail goto*//*Label 28660*/ GIMT_Encode4(2175527), // Rule ID 18326 //
     /* 2175441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2175444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2175449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2175452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2175455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2175461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2175464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2175471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175487 */     // MIs[0] round
     /* 2175487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175490 */     // MIs[0] policy
     /* 2175490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175500 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2175503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175526 */     // GIR_Coverage, 18326,
     /* 2175526 */     GIR_EraseRootFromParent_Done,
     /* 2175527 */   // Label 28660: @2175527
     /* 2175527 */   GIM_Try, /*On fail goto*//*Label 28661*/ GIMT_Encode4(2175618), // Rule ID 18327 //
     /* 2175532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2175535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2175540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2175543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2175546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2175552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2175555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2175562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175578 */     // MIs[0] round
     /* 2175578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175581 */     // MIs[0] policy
     /* 2175581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175591 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2175594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175617 */     // GIR_Coverage, 18327,
     /* 2175617 */     GIR_EraseRootFromParent_Done,
     /* 2175618 */   // Label 28661: @2175618
     /* 2175618 */   GIM_Try, /*On fail goto*//*Label 28662*/ GIMT_Encode4(2175709), // Rule ID 18330 //
     /* 2175623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2175626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2175631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2175634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2175637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2175643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2175646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175669 */     // MIs[0] round
     /* 2175669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175672 */     // MIs[0] policy
     /* 2175672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175682 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2175685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175708 */     // GIR_Coverage, 18330,
     /* 2175708 */     GIR_EraseRootFromParent_Done,
     /* 2175709 */   // Label 28662: @2175709
     /* 2175709 */   GIM_Try, /*On fail goto*//*Label 28663*/ GIMT_Encode4(2175800), // Rule ID 18331 //
     /* 2175714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2175717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2175722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2175725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2175728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2175734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2175737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175760 */     // MIs[0] round
     /* 2175760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175763 */     // MIs[0] policy
     /* 2175763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175773 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2175776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175796 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175799 */     // GIR_Coverage, 18331,
     /* 2175799 */     GIR_EraseRootFromParent_Done,
     /* 2175800 */   // Label 28663: @2175800
     /* 2175800 */   GIM_Try, /*On fail goto*//*Label 28664*/ GIMT_Encode4(2175891), // Rule ID 18334 //
     /* 2175805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2175808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2175813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2175816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2175819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2175822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2175825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2175835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2175843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175851 */     // MIs[0] round
     /* 2175851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175854 */     // MIs[0] policy
     /* 2175854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175864 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2175867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175890 */     // GIR_Coverage, 18334,
     /* 2175890 */     GIR_EraseRootFromParent_Done,
     /* 2175891 */   // Label 28664: @2175891
     /* 2175891 */   GIM_Try, /*On fail goto*//*Label 28665*/ GIMT_Encode4(2175982), // Rule ID 18335 //
     /* 2175896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2175899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2175904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2175907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2175910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2175913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2175916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2175926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2175934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175942 */     // MIs[0] round
     /* 2175942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175945 */     // MIs[0] policy
     /* 2175945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175955 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2175958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175981 */     // GIR_Coverage, 18335,
     /* 2175981 */     GIR_EraseRootFromParent_Done,
     /* 2175982 */   // Label 28665: @2175982
     /* 2175982 */   GIM_Try, /*On fail goto*//*Label 28666*/ GIMT_Encode4(2176073), // Rule ID 18338 //
     /* 2175987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2175990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2175995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2175998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2176001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2176007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2176017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176033 */     // MIs[0] round
     /* 2176033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176036 */     // MIs[0] policy
     /* 2176036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176046 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2176049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176072 */     // GIR_Coverage, 18338,
     /* 2176072 */     GIR_EraseRootFromParent_Done,
     /* 2176073 */   // Label 28666: @2176073
     /* 2176073 */   GIM_Try, /*On fail goto*//*Label 28667*/ GIMT_Encode4(2176164), // Rule ID 18339 //
     /* 2176078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2176081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2176086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2176089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2176092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2176098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2176108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176124 */     // MIs[0] round
     /* 2176124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176127 */     // MIs[0] policy
     /* 2176127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176137 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2176140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176163 */     // GIR_Coverage, 18339,
     /* 2176163 */     GIR_EraseRootFromParent_Done,
     /* 2176164 */   // Label 28667: @2176164
     /* 2176164 */   GIM_Try, /*On fail goto*//*Label 28668*/ GIMT_Encode4(2176255), // Rule ID 18342 //
     /* 2176169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2176172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2176177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2176180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2176183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2176189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2176199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176215 */     // MIs[0] round
     /* 2176215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176218 */     // MIs[0] policy
     /* 2176218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176228 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2176231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176254 */     // GIR_Coverage, 18342,
     /* 2176254 */     GIR_EraseRootFromParent_Done,
     /* 2176255 */   // Label 28668: @2176255
     /* 2176255 */   GIM_Try, /*On fail goto*//*Label 28669*/ GIMT_Encode4(2176346), // Rule ID 18343 //
     /* 2176260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2176263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2176268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2176271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2176274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2176280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2176290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176306 */     // MIs[0] round
     /* 2176306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176309 */     // MIs[0] policy
     /* 2176309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176319 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2176322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176345 */     // GIR_Coverage, 18343,
     /* 2176345 */     GIR_EraseRootFromParent_Done,
     /* 2176346 */   // Label 28669: @2176346
     /* 2176346 */   GIM_Try, /*On fail goto*//*Label 28670*/ GIMT_Encode4(2176437), // Rule ID 18346 //
     /* 2176351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2176362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2176365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2176368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2176371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176397 */     // MIs[0] round
     /* 2176397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176400 */     // MIs[0] policy
     /* 2176400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176410 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2176413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176436 */     // GIR_Coverage, 18346,
     /* 2176436 */     GIR_EraseRootFromParent_Done,
     /* 2176437 */   // Label 28670: @2176437
     /* 2176437 */   GIM_Try, /*On fail goto*//*Label 28671*/ GIMT_Encode4(2176528), // Rule ID 18347 //
     /* 2176442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2176453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2176456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2176459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2176462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176488 */     // MIs[0] round
     /* 2176488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176491 */     // MIs[0] policy
     /* 2176491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176501 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2176504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176527 */     // GIR_Coverage, 18347,
     /* 2176527 */     GIR_EraseRootFromParent_Done,
     /* 2176528 */   // Label 28671: @2176528
     /* 2176528 */   GIM_Try, /*On fail goto*//*Label 28672*/ GIMT_Encode4(2176619), // Rule ID 18350 //
     /* 2176533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2176544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2176547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2176550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2176553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176579 */     // MIs[0] round
     /* 2176579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176582 */     // MIs[0] policy
     /* 2176582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176592 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2176595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176618 */     // GIR_Coverage, 18350,
     /* 2176618 */     GIR_EraseRootFromParent_Done,
     /* 2176619 */   // Label 28672: @2176619
     /* 2176619 */   GIM_Try, /*On fail goto*//*Label 28673*/ GIMT_Encode4(2176710), // Rule ID 18351 //
     /* 2176624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2176635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2176638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2176641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2176644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176670 */     // MIs[0] round
     /* 2176670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176673 */     // MIs[0] policy
     /* 2176673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176683 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2176686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176709 */     // GIR_Coverage, 18351,
     /* 2176709 */     GIR_EraseRootFromParent_Done,
     /* 2176710 */   // Label 28673: @2176710
     /* 2176710 */   GIM_Try, /*On fail goto*//*Label 28674*/ GIMT_Encode4(2176801), // Rule ID 18354 //
     /* 2176715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2176718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2176726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2176729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2176732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2176735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176761 */     // MIs[0] round
     /* 2176761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176764 */     // MIs[0] policy
     /* 2176764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176774 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2176777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176800 */     // GIR_Coverage, 18354,
     /* 2176800 */     GIR_EraseRootFromParent_Done,
     /* 2176801 */   // Label 28674: @2176801
     /* 2176801 */   GIM_Try, /*On fail goto*//*Label 28675*/ GIMT_Encode4(2176892), // Rule ID 18355 //
     /* 2176806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2176809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2176817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2176820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2176823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2176826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176852 */     // MIs[0] round
     /* 2176852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176855 */     // MIs[0] policy
     /* 2176855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176865 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2176868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176891 */     // GIR_Coverage, 18355,
     /* 2176891 */     GIR_EraseRootFromParent_Done,
     /* 2176892 */   // Label 28675: @2176892
     /* 2176892 */   GIM_Try, /*On fail goto*//*Label 28676*/ GIMT_Encode4(2176983), // Rule ID 18358 //
     /* 2176897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2176908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2176911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2176914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2176917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176943 */     // MIs[0] round
     /* 2176943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176946 */     // MIs[0] policy
     /* 2176946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176956 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2176959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176982 */     // GIR_Coverage, 18358,
     /* 2176982 */     GIR_EraseRootFromParent_Done,
     /* 2176983 */   // Label 28676: @2176983
     /* 2176983 */   GIM_Try, /*On fail goto*//*Label 28677*/ GIMT_Encode4(2177074), // Rule ID 18359 //
     /* 2176988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2176999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2177002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2177005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2177008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177034 */     // MIs[0] round
     /* 2177034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177037 */     // MIs[0] policy
     /* 2177037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177047 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2177050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177073 */     // GIR_Coverage, 18359,
     /* 2177073 */     GIR_EraseRootFromParent_Done,
     /* 2177074 */   // Label 28677: @2177074
     /* 2177074 */   GIM_Try, /*On fail goto*//*Label 28678*/ GIMT_Encode4(2177165), // Rule ID 18362 //
     /* 2177079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2177082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2177090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2177093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2177096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2177099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177125 */     // MIs[0] round
     /* 2177125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177128 */     // MIs[0] policy
     /* 2177128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177138 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2177141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177164 */     // GIR_Coverage, 18362,
     /* 2177164 */     GIR_EraseRootFromParent_Done,
     /* 2177165 */   // Label 28678: @2177165
     /* 2177165 */   GIM_Try, /*On fail goto*//*Label 28679*/ GIMT_Encode4(2177256), // Rule ID 18363 //
     /* 2177170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2177181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2177184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2177187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2177190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177216 */     // MIs[0] round
     /* 2177216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177219 */     // MIs[0] policy
     /* 2177219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177229 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2177232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177255 */     // GIR_Coverage, 18363,
     /* 2177255 */     GIR_EraseRootFromParent_Done,
     /* 2177256 */   // Label 28679: @2177256
     /* 2177256 */   GIM_Try, /*On fail goto*//*Label 28680*/ GIMT_Encode4(2177347), // Rule ID 18366 //
     /* 2177261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2177264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2177272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2177275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2177278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2177281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2177284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177307 */     // MIs[0] round
     /* 2177307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177310 */     // MIs[0] policy
     /* 2177310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177320 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2177323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177346 */     // GIR_Coverage, 18366,
     /* 2177346 */     GIR_EraseRootFromParent_Done,
     /* 2177347 */   // Label 28680: @2177347
     /* 2177347 */   GIM_Try, /*On fail goto*//*Label 28681*/ GIMT_Encode4(2177438), // Rule ID 18367 //
     /* 2177352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2177355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2177363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2177366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2177369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2177372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2177375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177398 */     // MIs[0] round
     /* 2177398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177401 */     // MIs[0] policy
     /* 2177401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177411 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2177414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177437 */     // GIR_Coverage, 18367,
     /* 2177437 */     GIR_EraseRootFromParent_Done,
     /* 2177438 */   // Label 28681: @2177438
     /* 2177438 */   GIM_Try, /*On fail goto*//*Label 28682*/ GIMT_Encode4(2177529), // Rule ID 18370 //
     /* 2177443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2177446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2177454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2177457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2177460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2177463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177489 */     // MIs[0] round
     /* 2177489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177492 */     // MIs[0] policy
     /* 2177492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177502 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2177505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177528 */     // GIR_Coverage, 18370,
     /* 2177528 */     GIR_EraseRootFromParent_Done,
     /* 2177529 */   // Label 28682: @2177529
     /* 2177529 */   GIM_Try, /*On fail goto*//*Label 28683*/ GIMT_Encode4(2177620), // Rule ID 18371 //
     /* 2177534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2177537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2177545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2177548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2177551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2177554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177580 */     // MIs[0] round
     /* 2177580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177583 */     // MIs[0] policy
     /* 2177583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177593 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2177596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177619 */     // GIR_Coverage, 18371,
     /* 2177619 */     GIR_EraseRootFromParent_Done,
     /* 2177620 */   // Label 28683: @2177620
     /* 2177620 */   GIM_Try, /*On fail goto*//*Label 28684*/ GIMT_Encode4(2177711), // Rule ID 18374 //
     /* 2177625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2177628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2177636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2177639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2177642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2177645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177671 */     // MIs[0] round
     /* 2177671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177674 */     // MIs[0] policy
     /* 2177674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177684 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2177687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177710 */     // GIR_Coverage, 18374,
     /* 2177710 */     GIR_EraseRootFromParent_Done,
     /* 2177711 */   // Label 28684: @2177711
     /* 2177711 */   GIM_Try, /*On fail goto*//*Label 28685*/ GIMT_Encode4(2177802), // Rule ID 18375 //
     /* 2177716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2177719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2177727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2177730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2177733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2177736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177762 */     // MIs[0] round
     /* 2177762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177765 */     // MIs[0] policy
     /* 2177765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177775 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2177778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177801 */     // GIR_Coverage, 18375,
     /* 2177801 */     GIR_EraseRootFromParent_Done,
     /* 2177802 */   // Label 28685: @2177802
     /* 2177802 */   GIM_Try, /*On fail goto*//*Label 28686*/ GIMT_Encode4(2177893), // Rule ID 18378 //
     /* 2177807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2177810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2177818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2177821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2177824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2177827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2177830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177853 */     // MIs[0] round
     /* 2177853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177856 */     // MIs[0] policy
     /* 2177856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177866 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2177869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177892 */     // GIR_Coverage, 18378,
     /* 2177892 */     GIR_EraseRootFromParent_Done,
     /* 2177893 */   // Label 28686: @2177893
     /* 2177893 */   GIM_Try, /*On fail goto*//*Label 28687*/ GIMT_Encode4(2177984), // Rule ID 18379 //
     /* 2177898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2177901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2177909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2177912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2177915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2177918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2177921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177944 */     // MIs[0] round
     /* 2177944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177947 */     // MIs[0] policy
     /* 2177947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177957 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2177960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177970 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177980 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177983 */     // GIR_Coverage, 18379,
     /* 2177983 */     GIR_EraseRootFromParent_Done,
     /* 2177984 */   // Label 28687: @2177984
     /* 2177984 */   GIM_Try, /*On fail goto*//*Label 28688*/ GIMT_Encode4(2178075), // Rule ID 18382 //
     /* 2177989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2177992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2178000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2178003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2178006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2178009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178035 */     // MIs[0] round
     /* 2178035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178038 */     // MIs[0] policy
     /* 2178038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178048 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2178051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178074 */     // GIR_Coverage, 18382,
     /* 2178074 */     GIR_EraseRootFromParent_Done,
     /* 2178075 */   // Label 28688: @2178075
     /* 2178075 */   GIM_Try, /*On fail goto*//*Label 28689*/ GIMT_Encode4(2178166), // Rule ID 18383 //
     /* 2178080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2178083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2178091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2178094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2178097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2178100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178126 */     // MIs[0] round
     /* 2178126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178129 */     // MIs[0] policy
     /* 2178129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178139 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2178142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178165 */     // GIR_Coverage, 18383,
     /* 2178165 */     GIR_EraseRootFromParent_Done,
     /* 2178166 */   // Label 28689: @2178166
     /* 2178166 */   GIM_Try, /*On fail goto*//*Label 28690*/ GIMT_Encode4(2178257), // Rule ID 18386 //
     /* 2178171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2178174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2178182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2178185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2178188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2178191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2178194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178217 */     // MIs[0] round
     /* 2178217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178220 */     // MIs[0] policy
     /* 2178220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178230 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2178233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178256 */     // GIR_Coverage, 18386,
     /* 2178256 */     GIR_EraseRootFromParent_Done,
     /* 2178257 */   // Label 28690: @2178257
     /* 2178257 */   GIM_Try, /*On fail goto*//*Label 28691*/ GIMT_Encode4(2178348), // Rule ID 18387 //
     /* 2178262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2178265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2178273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2178276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2178279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2178282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2178285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178308 */     // MIs[0] round
     /* 2178308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178311 */     // MIs[0] policy
     /* 2178311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178321 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2178324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178347 */     // GIR_Coverage, 18387,
     /* 2178347 */     GIR_EraseRootFromParent_Done,
     /* 2178348 */   // Label 28691: @2178348
     /* 2178348 */   GIM_Try, /*On fail goto*//*Label 28692*/ GIMT_Encode4(2178439), // Rule ID 18390 //
     /* 2178353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2178356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2178364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2178367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2178370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2178373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2178376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2178383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178399 */     // MIs[0] round
     /* 2178399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178402 */     // MIs[0] policy
     /* 2178402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178412 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2178415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178438 */     // GIR_Coverage, 18390,
     /* 2178438 */     GIR_EraseRootFromParent_Done,
     /* 2178439 */   // Label 28692: @2178439
     /* 2178439 */   GIM_Try, /*On fail goto*//*Label 28693*/ GIMT_Encode4(2178530), // Rule ID 18391 //
     /* 2178444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2178447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2178455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2178458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2178461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2178464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2178467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2178474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178490 */     // MIs[0] round
     /* 2178490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178493 */     // MIs[0] policy
     /* 2178493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178503 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2178506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178529 */     // GIR_Coverage, 18391,
     /* 2178529 */     GIR_EraseRootFromParent_Done,
     /* 2178530 */   // Label 28693: @2178530
     /* 2178530 */   GIM_Try, /*On fail goto*//*Label 28694*/ GIMT_Encode4(2178621), // Rule ID 18394 //
     /* 2178535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2178538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2178546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2178549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2178552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2178555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178581 */     // MIs[0] round
     /* 2178581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178584 */     // MIs[0] policy
     /* 2178584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178594 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2178597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178620 */     // GIR_Coverage, 18394,
     /* 2178620 */     GIR_EraseRootFromParent_Done,
     /* 2178621 */   // Label 28694: @2178621
     /* 2178621 */   GIM_Try, /*On fail goto*//*Label 28695*/ GIMT_Encode4(2178712), // Rule ID 18395 //
     /* 2178626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2178629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2178637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2178640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2178643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2178646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178672 */     // MIs[0] round
     /* 2178672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178675 */     // MIs[0] policy
     /* 2178675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178685 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2178688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178711 */     // GIR_Coverage, 18395,
     /* 2178711 */     GIR_EraseRootFromParent_Done,
     /* 2178712 */   // Label 28695: @2178712
     /* 2178712 */   GIM_Try, /*On fail goto*//*Label 28696*/ GIMT_Encode4(2178803), // Rule ID 18398 //
     /* 2178717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2178720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2178728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2178731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2178734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2178737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178763 */     // MIs[0] round
     /* 2178763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178766 */     // MIs[0] policy
     /* 2178766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178776 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2178779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178802 */     // GIR_Coverage, 18398,
     /* 2178802 */     GIR_EraseRootFromParent_Done,
     /* 2178803 */   // Label 28696: @2178803
     /* 2178803 */   GIM_Try, /*On fail goto*//*Label 28697*/ GIMT_Encode4(2178894), // Rule ID 18399 //
     /* 2178808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2178811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2178819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2178822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2178825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2178828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178854 */     // MIs[0] round
     /* 2178854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178857 */     // MIs[0] policy
     /* 2178857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178867 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2178870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178893 */     // GIR_Coverage, 18399,
     /* 2178893 */     GIR_EraseRootFromParent_Done,
     /* 2178894 */   // Label 28697: @2178894
     /* 2178894 */   GIM_Try, /*On fail goto*//*Label 28698*/ GIMT_Encode4(2178985), // Rule ID 18402 //
     /* 2178899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2178902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2178910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2178913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2178916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2178919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2178922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2178929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178945 */     // MIs[0] round
     /* 2178945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178948 */     // MIs[0] policy
     /* 2178948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178958 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2178961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178984 */     // GIR_Coverage, 18402,
     /* 2178984 */     GIR_EraseRootFromParent_Done,
     /* 2178985 */   // Label 28698: @2178985
     /* 2178985 */   GIM_Try, /*On fail goto*//*Label 28699*/ GIMT_Encode4(2179076), // Rule ID 18403 //
     /* 2178990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2178993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2179001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2179004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2179007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2179010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2179020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179036 */     // MIs[0] round
     /* 2179036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179039 */     // MIs[0] policy
     /* 2179039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179049 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2179052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179075 */     // GIR_Coverage, 18403,
     /* 2179075 */     GIR_EraseRootFromParent_Done,
     /* 2179076 */   // Label 28699: @2179076
     /* 2179076 */   GIM_Try, /*On fail goto*//*Label 28700*/ GIMT_Encode4(2179167), // Rule ID 18406 //
     /* 2179081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2179089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2179092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2179095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2179101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179127 */     // MIs[0] round
     /* 2179127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179130 */     // MIs[0] policy
     /* 2179130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179140 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2179143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179166 */     // GIR_Coverage, 18406,
     /* 2179166 */     GIR_EraseRootFromParent_Done,
     /* 2179167 */   // Label 28700: @2179167
     /* 2179167 */   GIM_Try, /*On fail goto*//*Label 28701*/ GIMT_Encode4(2179258), // Rule ID 18407 //
     /* 2179172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2179180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2179183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2179186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2179192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179218 */     // MIs[0] round
     /* 2179218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179221 */     // MIs[0] policy
     /* 2179221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179231 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2179234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179257 */     // GIR_Coverage, 18407,
     /* 2179257 */     GIR_EraseRootFromParent_Done,
     /* 2179258 */   // Label 28701: @2179258
     /* 2179258 */   GIM_Try, /*On fail goto*//*Label 28702*/ GIMT_Encode4(2179349), // Rule ID 18410 //
     /* 2179263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2179271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2179274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2179277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2179283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2179286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179309 */     // MIs[0] round
     /* 2179309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179312 */     // MIs[0] policy
     /* 2179312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179322 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2179325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179348 */     // GIR_Coverage, 18410,
     /* 2179348 */     GIR_EraseRootFromParent_Done,
     /* 2179349 */   // Label 28702: @2179349
     /* 2179349 */   GIM_Try, /*On fail goto*//*Label 28703*/ GIMT_Encode4(2179440), // Rule ID 18411 //
     /* 2179354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2179362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2179365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2179368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2179374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2179377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179400 */     // MIs[0] round
     /* 2179400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179403 */     // MIs[0] policy
     /* 2179403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179413 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2179416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179439 */     // GIR_Coverage, 18411,
     /* 2179439 */     GIR_EraseRootFromParent_Done,
     /* 2179440 */   // Label 28703: @2179440
     /* 2179440 */   GIM_Try, /*On fail goto*//*Label 28704*/ GIMT_Encode4(2179531), // Rule ID 18414 //
     /* 2179445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2179448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2179453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2179456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2179459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2179462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2179465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2179483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179491 */     // MIs[0] round
     /* 2179491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179494 */     // MIs[0] policy
     /* 2179494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179504 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2179507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179530 */     // GIR_Coverage, 18414,
     /* 2179530 */     GIR_EraseRootFromParent_Done,
     /* 2179531 */   // Label 28704: @2179531
     /* 2179531 */   GIM_Try, /*On fail goto*//*Label 28705*/ GIMT_Encode4(2179622), // Rule ID 18415 //
     /* 2179536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2179539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2179544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2179547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2179550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2179553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2179556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2179574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179582 */     // MIs[0] round
     /* 2179582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179585 */     // MIs[0] policy
     /* 2179585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179595 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2179598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179621 */     // GIR_Coverage, 18415,
     /* 2179621 */     GIR_EraseRootFromParent_Done,
     /* 2179622 */   // Label 28705: @2179622
     /* 2179622 */   GIM_Try, /*On fail goto*//*Label 28706*/ GIMT_Encode4(2179713), // Rule ID 18418 //
     /* 2179627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2179635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2179638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2179641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2179647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179673 */     // MIs[0] round
     /* 2179673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179676 */     // MIs[0] policy
     /* 2179676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179686 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2179689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179712 */     // GIR_Coverage, 18418,
     /* 2179712 */     GIR_EraseRootFromParent_Done,
     /* 2179713 */   // Label 28706: @2179713
     /* 2179713 */   GIM_Try, /*On fail goto*//*Label 28707*/ GIMT_Encode4(2179804), // Rule ID 18419 //
     /* 2179718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2179726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2179729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2179732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2179738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179764 */     // MIs[0] round
     /* 2179764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179767 */     // MIs[0] policy
     /* 2179767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179777 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2179780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179803 */     // GIR_Coverage, 18419,
     /* 2179803 */     GIR_EraseRootFromParent_Done,
     /* 2179804 */   // Label 28707: @2179804
     /* 2179804 */   GIM_Try, /*On fail goto*//*Label 28708*/ GIMT_Encode4(2179895), // Rule ID 18422 //
     /* 2179809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2179812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2179817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2179820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2179823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2179826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2179829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2179832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2179847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179855 */     // MIs[0] round
     /* 2179855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179858 */     // MIs[0] policy
     /* 2179858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179868 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2179871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179894 */     // GIR_Coverage, 18422,
     /* 2179894 */     GIR_EraseRootFromParent_Done,
     /* 2179895 */   // Label 28708: @2179895
     /* 2179895 */   GIM_Try, /*On fail goto*//*Label 28709*/ GIMT_Encode4(2179986), // Rule ID 18423 //
     /* 2179900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2179903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2179908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2179911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2179914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2179917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2179920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2179923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2179938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179946 */     // MIs[0] round
     /* 2179946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179949 */     // MIs[0] policy
     /* 2179949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179959 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2179962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179985 */     // GIR_Coverage, 18423,
     /* 2179985 */     GIR_EraseRootFromParent_Done,
     /* 2179986 */   // Label 28709: @2179986
     /* 2179986 */   GIM_Try, /*On fail goto*//*Label 28710*/ GIMT_Encode4(2180077), // Rule ID 18426 //
     /* 2179991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2179994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2179999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2180002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2180005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2180008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2180011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2180014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2180029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180037 */     // MIs[0] round
     /* 2180037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180040 */     // MIs[0] policy
     /* 2180040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180050 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2180053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180076 */     // GIR_Coverage, 18426,
     /* 2180076 */     GIR_EraseRootFromParent_Done,
     /* 2180077 */   // Label 28710: @2180077
     /* 2180077 */   GIM_Try, /*On fail goto*//*Label 28711*/ GIMT_Encode4(2180168), // Rule ID 18427 //
     /* 2180082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2180085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2180090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2180093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2180096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2180099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2180102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2180105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2180120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180128 */     // MIs[0] round
     /* 2180128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180131 */     // MIs[0] policy
     /* 2180131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180141 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2180144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180154 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180164 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180167 */     // GIR_Coverage, 18427,
     /* 2180167 */     GIR_EraseRootFromParent_Done,
     /* 2180168 */   // Label 28711: @2180168
     /* 2180168 */   GIM_Try, /*On fail goto*//*Label 28712*/ GIMT_Encode4(2180259), // Rule ID 18430 //
     /* 2180173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2180176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2180181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2180184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2180187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2180193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180219 */     // MIs[0] round
     /* 2180219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180222 */     // MIs[0] policy
     /* 2180222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180232 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2180235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180258 */     // GIR_Coverage, 18430,
     /* 2180258 */     GIR_EraseRootFromParent_Done,
     /* 2180259 */   // Label 28712: @2180259
     /* 2180259 */   GIM_Try, /*On fail goto*//*Label 28713*/ GIMT_Encode4(2180350), // Rule ID 18431 //
     /* 2180264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2180267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2180272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2180275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2180278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2180284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180310 */     // MIs[0] round
     /* 2180310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180313 */     // MIs[0] policy
     /* 2180313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180323 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2180326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180349 */     // GIR_Coverage, 18431,
     /* 2180349 */     GIR_EraseRootFromParent_Done,
     /* 2180350 */   // Label 28713: @2180350
     /* 2180350 */   GIM_Try, /*On fail goto*//*Label 28714*/ GIMT_Encode4(2180441), // Rule ID 18434 //
     /* 2180355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2180358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2180363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2180366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2180369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2180375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2180378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180401 */     // MIs[0] round
     /* 2180401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180404 */     // MIs[0] policy
     /* 2180404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180414 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2180417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180440 */     // GIR_Coverage, 18434,
     /* 2180440 */     GIR_EraseRootFromParent_Done,
     /* 2180441 */   // Label 28714: @2180441
     /* 2180441 */   GIM_Try, /*On fail goto*//*Label 28715*/ GIMT_Encode4(2180532), // Rule ID 18435 //
     /* 2180446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2180449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2180454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2180457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2180460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2180466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2180469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180492 */     // MIs[0] round
     /* 2180492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180495 */     // MIs[0] policy
     /* 2180495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180505 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2180508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180531 */     // GIR_Coverage, 18435,
     /* 2180531 */     GIR_EraseRootFromParent_Done,
     /* 2180532 */   // Label 28715: @2180532
     /* 2180532 */   GIM_Try, /*On fail goto*//*Label 28716*/ GIMT_Encode4(2180623), // Rule ID 18438 //
     /* 2180537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2180540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2180545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2180548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2180551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2180557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2180560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180583 */     // MIs[0] round
     /* 2180583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180586 */     // MIs[0] policy
     /* 2180586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180596 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2180599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180622 */     // GIR_Coverage, 18438,
     /* 2180622 */     GIR_EraseRootFromParent_Done,
     /* 2180623 */   // Label 28716: @2180623
     /* 2180623 */   GIM_Try, /*On fail goto*//*Label 28717*/ GIMT_Encode4(2180714), // Rule ID 18439 //
     /* 2180628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2180631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2180636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2180639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2180642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2180648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2180651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180674 */     // MIs[0] round
     /* 2180674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180677 */     // MIs[0] policy
     /* 2180677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180687 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2180690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180713 */     // GIR_Coverage, 18439,
     /* 2180713 */     GIR_EraseRootFromParent_Done,
     /* 2180714 */   // Label 28717: @2180714
     /* 2180714 */   GIM_Try, /*On fail goto*//*Label 28718*/ GIMT_Encode4(2180805), // Rule ID 18442 //
     /* 2180719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2180722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2180727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2180730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2180733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2180739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180765 */     // MIs[0] round
     /* 2180765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180768 */     // MIs[0] policy
     /* 2180768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180778 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2180781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180804 */     // GIR_Coverage, 18442,
     /* 2180804 */     GIR_EraseRootFromParent_Done,
     /* 2180805 */   // Label 28718: @2180805
     /* 2180805 */   GIM_Try, /*On fail goto*//*Label 28719*/ GIMT_Encode4(2180896), // Rule ID 18443 //
     /* 2180810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2180813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2180818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2180821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2180824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2180830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180856 */     // MIs[0] round
     /* 2180856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180859 */     // MIs[0] policy
     /* 2180859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180869 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2180872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180895 */     // GIR_Coverage, 18443,
     /* 2180895 */     GIR_EraseRootFromParent_Done,
     /* 2180896 */   // Label 28719: @2180896
     /* 2180896 */   GIM_Try, /*On fail goto*//*Label 28720*/ GIMT_Encode4(2180987), // Rule ID 18446 //
     /* 2180901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2180904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2180909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2180912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2180915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2180921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180947 */     // MIs[0] round
     /* 2180947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180950 */     // MIs[0] policy
     /* 2180950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180960 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2180963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180986 */     // GIR_Coverage, 18446,
     /* 2180986 */     GIR_EraseRootFromParent_Done,
     /* 2180987 */   // Label 28720: @2180987
     /* 2180987 */   GIM_Try, /*On fail goto*//*Label 28721*/ GIMT_Encode4(2181078), // Rule ID 18447 //
     /* 2180992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2180995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2181000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2181003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2181006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2181012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2181022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181038 */     // MIs[0] round
     /* 2181038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181041 */     // MIs[0] policy
     /* 2181041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181051 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2181054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181077 */     // GIR_Coverage, 18447,
     /* 2181077 */     GIR_EraseRootFromParent_Done,
     /* 2181078 */   // Label 28721: @2181078
     /* 2181078 */   GIM_Try, /*On fail goto*//*Label 28722*/ GIMT_Encode4(2181169), // Rule ID 18450 //
     /* 2181083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2181086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2181091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2181094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2181097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2181103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2181106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181129 */     // MIs[0] round
     /* 2181129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181132 */     // MIs[0] policy
     /* 2181132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181142 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2181145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181168 */     // GIR_Coverage, 18450,
     /* 2181168 */     GIR_EraseRootFromParent_Done,
     /* 2181169 */   // Label 28722: @2181169
     /* 2181169 */   GIM_Try, /*On fail goto*//*Label 28723*/ GIMT_Encode4(2181260), // Rule ID 18451 //
     /* 2181174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2181177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2181182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2181185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2181188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2181194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2181197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181220 */     // MIs[0] round
     /* 2181220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181223 */     // MIs[0] policy
     /* 2181223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181233 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2181236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181259 */     // GIR_Coverage, 18451,
     /* 2181259 */     GIR_EraseRootFromParent_Done,
     /* 2181260 */   // Label 28723: @2181260
     /* 2181260 */   GIM_Try, /*On fail goto*//*Label 28724*/ GIMT_Encode4(2181351), // Rule ID 18454 //
     /* 2181265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2181268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2181273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2181276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2181279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2181285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2181295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181311 */     // MIs[0] round
     /* 2181311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181314 */     // MIs[0] policy
     /* 2181314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181324 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2181327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181350 */     // GIR_Coverage, 18454,
     /* 2181350 */     GIR_EraseRootFromParent_Done,
     /* 2181351 */   // Label 28724: @2181351
     /* 2181351 */   GIM_Try, /*On fail goto*//*Label 28725*/ GIMT_Encode4(2181442), // Rule ID 18455 //
     /* 2181356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2181359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2181364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2181367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2181370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2181376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2181386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181402 */     // MIs[0] round
     /* 2181402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181405 */     // MIs[0] policy
     /* 2181405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181415 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2181418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181441 */     // GIR_Coverage, 18455,
     /* 2181441 */     GIR_EraseRootFromParent_Done,
     /* 2181442 */   // Label 28725: @2181442
     /* 2181442 */   GIM_Try, /*On fail goto*//*Label 28726*/ GIMT_Encode4(2181533), // Rule ID 18458 //
     /* 2181447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2181450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2181455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2181458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2181461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2181467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2181477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181493 */     // MIs[0] round
     /* 2181493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181496 */     // MIs[0] policy
     /* 2181496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181506 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2181509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181532 */     // GIR_Coverage, 18458,
     /* 2181532 */     GIR_EraseRootFromParent_Done,
     /* 2181533 */   // Label 28726: @2181533
     /* 2181533 */   GIM_Try, /*On fail goto*//*Label 28727*/ GIMT_Encode4(2181624), // Rule ID 18459 //
     /* 2181538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2181541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2181546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2181549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2181552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2181558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2181568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181584 */     // MIs[0] round
     /* 2181584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181587 */     // MIs[0] policy
     /* 2181587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181597 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2181600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181623 */     // GIR_Coverage, 18459,
     /* 2181623 */     GIR_EraseRootFromParent_Done,
     /* 2181624 */   // Label 28727: @2181624
     /* 2181624 */   GIM_Try, /*On fail goto*//*Label 28728*/ GIMT_Encode4(2181715), // Rule ID 18462 //
     /* 2181629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2181632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2181637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2181640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2181643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2181649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181675 */     // MIs[0] round
     /* 2181675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181678 */     // MIs[0] policy
     /* 2181678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181688 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2181691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181714 */     // GIR_Coverage, 18462,
     /* 2181714 */     GIR_EraseRootFromParent_Done,
     /* 2181715 */   // Label 28728: @2181715
     /* 2181715 */   GIM_Try, /*On fail goto*//*Label 28729*/ GIMT_Encode4(2181806), // Rule ID 18463 //
     /* 2181720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2181723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2181728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2181731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2181734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2181740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181766 */     // MIs[0] round
     /* 2181766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181769 */     // MIs[0] policy
     /* 2181769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181779 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2181782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181805 */     // GIR_Coverage, 18463,
     /* 2181805 */     GIR_EraseRootFromParent_Done,
     /* 2181806 */   // Label 28729: @2181806
     /* 2181806 */   GIM_Try, /*On fail goto*//*Label 28730*/ GIMT_Encode4(2181897), // Rule ID 18466 //
     /* 2181811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2181822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2181825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2181828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2181831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181857 */     // MIs[0] round
     /* 2181857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181860 */     // MIs[0] policy
     /* 2181860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181870 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2181873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181896 */     // GIR_Coverage, 18466,
     /* 2181896 */     GIR_EraseRootFromParent_Done,
     /* 2181897 */   // Label 28730: @2181897
     /* 2181897 */   GIM_Try, /*On fail goto*//*Label 28731*/ GIMT_Encode4(2181988), // Rule ID 18467 //
     /* 2181902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2181905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2181913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2181916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2181919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2181922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181948 */     // MIs[0] round
     /* 2181948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181951 */     // MIs[0] policy
     /* 2181951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181961 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2181964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181987 */     // GIR_Coverage, 18467,
     /* 2181987 */     GIR_EraseRootFromParent_Done,
     /* 2181988 */   // Label 28731: @2181988
     /* 2181988 */   GIM_Try, /*On fail goto*//*Label 28732*/ GIMT_Encode4(2182079), // Rule ID 18470 //
     /* 2181993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2182004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2182007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2182010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2182013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182039 */     // MIs[0] round
     /* 2182039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182042 */     // MIs[0] policy
     /* 2182042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2182055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182078 */     // GIR_Coverage, 18470,
     /* 2182078 */     GIR_EraseRootFromParent_Done,
     /* 2182079 */   // Label 28732: @2182079
     /* 2182079 */   GIM_Try, /*On fail goto*//*Label 28733*/ GIMT_Encode4(2182170), // Rule ID 18471 //
     /* 2182084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2182095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2182098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2182101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2182104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182130 */     // MIs[0] round
     /* 2182130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182133 */     // MIs[0] policy
     /* 2182133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182143 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2182146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182169 */     // GIR_Coverage, 18471,
     /* 2182169 */     GIR_EraseRootFromParent_Done,
     /* 2182170 */   // Label 28733: @2182170
     /* 2182170 */   GIM_Try, /*On fail goto*//*Label 28734*/ GIMT_Encode4(2182261), // Rule ID 18474 //
     /* 2182175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2182186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2182189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2182192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2182195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2182198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182221 */     // MIs[0] round
     /* 2182221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182224 */     // MIs[0] policy
     /* 2182224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182234 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2182237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182260 */     // GIR_Coverage, 18474,
     /* 2182260 */     GIR_EraseRootFromParent_Done,
     /* 2182261 */   // Label 28734: @2182261
     /* 2182261 */   GIM_Try, /*On fail goto*//*Label 28735*/ GIMT_Encode4(2182352), // Rule ID 18475 //
     /* 2182266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2182269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2182277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2182280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2182283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2182286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2182289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182312 */     // MIs[0] round
     /* 2182312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182315 */     // MIs[0] policy
     /* 2182315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182325 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2182328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182351 */     // GIR_Coverage, 18475,
     /* 2182351 */     GIR_EraseRootFromParent_Done,
     /* 2182352 */   // Label 28735: @2182352
     /* 2182352 */   GIM_Try, /*On fail goto*//*Label 28736*/ GIMT_Encode4(2182443), // Rule ID 18478 //
     /* 2182357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2182360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2182368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2182371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2182374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2182377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182403 */     // MIs[0] round
     /* 2182403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182406 */     // MIs[0] policy
     /* 2182406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182416 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2182419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182442 */     // GIR_Coverage, 18478,
     /* 2182442 */     GIR_EraseRootFromParent_Done,
     /* 2182443 */   // Label 28736: @2182443
     /* 2182443 */   GIM_Try, /*On fail goto*//*Label 28737*/ GIMT_Encode4(2182534), // Rule ID 18479 //
     /* 2182448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2182459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2182462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2182465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2182468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182494 */     // MIs[0] round
     /* 2182494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182497 */     // MIs[0] policy
     /* 2182497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182507 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2182510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182533 */     // GIR_Coverage, 18479,
     /* 2182533 */     GIR_EraseRootFromParent_Done,
     /* 2182534 */   // Label 28737: @2182534
     /* 2182534 */   GIM_Try, /*On fail goto*//*Label 28738*/ GIMT_Encode4(2182625), // Rule ID 18482 //
     /* 2182539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2182550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2182553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2182556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2182559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182585 */     // MIs[0] round
     /* 2182585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182588 */     // MIs[0] policy
     /* 2182588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182598 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2182601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182624 */     // GIR_Coverage, 18482,
     /* 2182624 */     GIR_EraseRootFromParent_Done,
     /* 2182625 */   // Label 28738: @2182625
     /* 2182625 */   GIM_Try, /*On fail goto*//*Label 28739*/ GIMT_Encode4(2182716), // Rule ID 18483 //
     /* 2182630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2182633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2182641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2182644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2182647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2182650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182676 */     // MIs[0] round
     /* 2182676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182679 */     // MIs[0] policy
     /* 2182679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182689 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2182692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182715 */     // GIR_Coverage, 18483,
     /* 2182715 */     GIR_EraseRootFromParent_Done,
     /* 2182716 */   // Label 28739: @2182716
     /* 2182716 */   GIM_Try, /*On fail goto*//*Label 28740*/ GIMT_Encode4(2182807), // Rule ID 18486 //
     /* 2182721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2182724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2182732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2182735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2182738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2182741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2182744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182767 */     // MIs[0] round
     /* 2182767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182770 */     // MIs[0] policy
     /* 2182770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182780 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2182783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182806 */     // GIR_Coverage, 18486,
     /* 2182806 */     GIR_EraseRootFromParent_Done,
     /* 2182807 */   // Label 28740: @2182807
     /* 2182807 */   GIM_Try, /*On fail goto*//*Label 28741*/ GIMT_Encode4(2182898), // Rule ID 18487 //
     /* 2182812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2182815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2182823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2182826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2182829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2182832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2182835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182858 */     // MIs[0] round
     /* 2182858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182861 */     // MIs[0] policy
     /* 2182861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182871 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2182874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182897 */     // GIR_Coverage, 18487,
     /* 2182897 */     GIR_EraseRootFromParent_Done,
     /* 2182898 */   // Label 28741: @2182898
     /* 2182898 */   GIM_Try, /*On fail goto*//*Label 28742*/ GIMT_Encode4(2182989), // Rule ID 18490 //
     /* 2182903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2182906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2182914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2182917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2182920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2182923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2182926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182949 */     // MIs[0] round
     /* 2182949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182952 */     // MIs[0] policy
     /* 2182952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182962 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2182965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182988 */     // GIR_Coverage, 18490,
     /* 2182988 */     GIR_EraseRootFromParent_Done,
     /* 2182989 */   // Label 28742: @2182989
     /* 2182989 */   GIM_Try, /*On fail goto*//*Label 28743*/ GIMT_Encode4(2183080), // Rule ID 18491 //
     /* 2182994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2183005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2183008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2183011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2183014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183040 */     // MIs[0] round
     /* 2183040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183043 */     // MIs[0] policy
     /* 2183043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183053 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2183056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183079 */     // GIR_Coverage, 18491,
     /* 2183079 */     GIR_EraseRootFromParent_Done,
     /* 2183080 */   // Label 28743: @2183080
     /* 2183080 */   GIM_Try, /*On fail goto*//*Label 28744*/ GIMT_Encode4(2183171), // Rule ID 18494 //
     /* 2183085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2183088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2183096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2183099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2183102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2183105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2183108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183131 */     // MIs[0] round
     /* 2183131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183134 */     // MIs[0] policy
     /* 2183134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183144 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2183147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183170 */     // GIR_Coverage, 18494,
     /* 2183170 */     GIR_EraseRootFromParent_Done,
     /* 2183171 */   // Label 28744: @2183171
     /* 2183171 */   GIM_Try, /*On fail goto*//*Label 28745*/ GIMT_Encode4(2183262), // Rule ID 18495 //
     /* 2183176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2183179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2183187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2183190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2183193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2183196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2183199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183222 */     // MIs[0] round
     /* 2183222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183225 */     // MIs[0] policy
     /* 2183225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183235 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2183238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183261 */     // GIR_Coverage, 18495,
     /* 2183261 */     GIR_EraseRootFromParent_Done,
     /* 2183262 */   // Label 28745: @2183262
     /* 2183262 */   GIM_Try, /*On fail goto*//*Label 28746*/ GIMT_Encode4(2183353), // Rule ID 18498 //
     /* 2183267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2183270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2183278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2183281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2183284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2183287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2183290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183313 */     // MIs[0] round
     /* 2183313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183316 */     // MIs[0] policy
     /* 2183316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183326 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2183329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183352 */     // GIR_Coverage, 18498,
     /* 2183352 */     GIR_EraseRootFromParent_Done,
     /* 2183353 */   // Label 28746: @2183353
     /* 2183353 */   GIM_Try, /*On fail goto*//*Label 28747*/ GIMT_Encode4(2183444), // Rule ID 18499 //
     /* 2183358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2183361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2183369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2183372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2183375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2183378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2183381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183404 */     // MIs[0] round
     /* 2183404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183407 */     // MIs[0] policy
     /* 2183407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183417 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2183420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183443 */     // GIR_Coverage, 18499,
     /* 2183443 */     GIR_EraseRootFromParent_Done,
     /* 2183444 */   // Label 28747: @2183444
     /* 2183444 */   GIM_Try, /*On fail goto*//*Label 28748*/ GIMT_Encode4(2183535), // Rule ID 18502 //
     /* 2183449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2183452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2183460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2183463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2183466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2183469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183495 */     // MIs[0] round
     /* 2183495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183498 */     // MIs[0] policy
     /* 2183498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183508 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2183511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183534 */     // GIR_Coverage, 18502,
     /* 2183534 */     GIR_EraseRootFromParent_Done,
     /* 2183535 */   // Label 28748: @2183535
     /* 2183535 */   GIM_Try, /*On fail goto*//*Label 28749*/ GIMT_Encode4(2183626), // Rule ID 18503 //
     /* 2183540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2183543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2183551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2183554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2183557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2183560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183586 */     // MIs[0] round
     /* 2183586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183589 */     // MIs[0] policy
     /* 2183589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183599 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2183602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183625 */     // GIR_Coverage, 18503,
     /* 2183625 */     GIR_EraseRootFromParent_Done,
     /* 2183626 */   // Label 28749: @2183626
     /* 2183626 */   GIM_Try, /*On fail goto*//*Label 28750*/ GIMT_Encode4(2183717), // Rule ID 18506 //
     /* 2183631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2183634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2183642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2183645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2183648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2183651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183677 */     // MIs[0] round
     /* 2183677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183680 */     // MIs[0] policy
     /* 2183680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183690 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2183693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183716 */     // GIR_Coverage, 18506,
     /* 2183716 */     GIR_EraseRootFromParent_Done,
     /* 2183717 */   // Label 28750: @2183717
     /* 2183717 */   GIM_Try, /*On fail goto*//*Label 28751*/ GIMT_Encode4(2183808), // Rule ID 18507 //
     /* 2183722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2183725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2183733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2183736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2183739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2183742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183768 */     // MIs[0] round
     /* 2183768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183771 */     // MIs[0] policy
     /* 2183771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183781 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2183784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183807 */     // GIR_Coverage, 18507,
     /* 2183807 */     GIR_EraseRootFromParent_Done,
     /* 2183808 */   // Label 28751: @2183808
     /* 2183808 */   GIM_Try, /*On fail goto*//*Label 28752*/ GIMT_Encode4(2183899), // Rule ID 18510 //
     /* 2183813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2183816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2183824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2183827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2183830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2183833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2183836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183859 */     // MIs[0] round
     /* 2183859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183862 */     // MIs[0] policy
     /* 2183862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183872 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2183875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183898 */     // GIR_Coverage, 18510,
     /* 2183898 */     GIR_EraseRootFromParent_Done,
     /* 2183899 */   // Label 28752: @2183899
     /* 2183899 */   GIM_Try, /*On fail goto*//*Label 28753*/ GIMT_Encode4(2183990), // Rule ID 18511 //
     /* 2183904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2183907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2183915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2183918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2183921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2183924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2183927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183950 */     // MIs[0] round
     /* 2183950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183953 */     // MIs[0] policy
     /* 2183953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183963 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2183966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183989 */     // GIR_Coverage, 18511,
     /* 2183989 */     GIR_EraseRootFromParent_Done,
     /* 2183990 */   // Label 28753: @2183990
     /* 2183990 */   GIM_Try, /*On fail goto*//*Label 28754*/ GIMT_Encode4(2184081), // Rule ID 18514 //
     /* 2183995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2183998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2184003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2184006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2184009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2184012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2184015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2184025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184041 */     // MIs[0] round
     /* 2184041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184044 */     // MIs[0] policy
     /* 2184044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184054 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2184057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184080 */     // GIR_Coverage, 18514,
     /* 2184080 */     GIR_EraseRootFromParent_Done,
     /* 2184081 */   // Label 28754: @2184081
     /* 2184081 */   GIM_Try, /*On fail goto*//*Label 28755*/ GIMT_Encode4(2184172), // Rule ID 18515 //
     /* 2184086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2184089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2184094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2184097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2184100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2184103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2184106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2184116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184132 */     // MIs[0] round
     /* 2184132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184135 */     // MIs[0] policy
     /* 2184135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184145 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2184148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184171 */     // GIR_Coverage, 18515,
     /* 2184171 */     GIR_EraseRootFromParent_Done,
     /* 2184172 */   // Label 28755: @2184172
     /* 2184172 */   GIM_Try, /*On fail goto*//*Label 28756*/ GIMT_Encode4(2184263), // Rule ID 18518 //
     /* 2184177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2184180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2184185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2184188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2184191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2184194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2184197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2184207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184223 */     // MIs[0] round
     /* 2184223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184226 */     // MIs[0] policy
     /* 2184226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184236 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2184239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184262 */     // GIR_Coverage, 18518,
     /* 2184262 */     GIR_EraseRootFromParent_Done,
     /* 2184263 */   // Label 28756: @2184263
     /* 2184263 */   GIM_Try, /*On fail goto*//*Label 28757*/ GIMT_Encode4(2184354), // Rule ID 18519 //
     /* 2184268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2184271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2184276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2184279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2184282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2184285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2184288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2184298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184314 */     // MIs[0] round
     /* 2184314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184317 */     // MIs[0] policy
     /* 2184317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184327 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2184330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184353 */     // GIR_Coverage, 18519,
     /* 2184353 */     GIR_EraseRootFromParent_Done,
     /* 2184354 */   // Label 28757: @2184354
     /* 2184354 */   GIM_Try, /*On fail goto*//*Label 28758*/ GIMT_Encode4(2184445), // Rule ID 18522 //
     /* 2184359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2184362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2184367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2184370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2184373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2184376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2184379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2184382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2184389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184405 */     // MIs[0] round
     /* 2184405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184408 */     // MIs[0] policy
     /* 2184408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184418 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2184421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184444 */     // GIR_Coverage, 18522,
     /* 2184444 */     GIR_EraseRootFromParent_Done,
     /* 2184445 */   // Label 28758: @2184445
     /* 2184445 */   GIM_Try, /*On fail goto*//*Label 28759*/ GIMT_Encode4(2184536), // Rule ID 18523 //
     /* 2184450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2184453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2184458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2184461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2184464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2184467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2184470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2184473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2184480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184496 */     // MIs[0] round
     /* 2184496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184499 */     // MIs[0] policy
     /* 2184499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184509 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2184512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184535 */     // GIR_Coverage, 18523,
     /* 2184535 */     GIR_EraseRootFromParent_Done,
     /* 2184536 */   // Label 28759: @2184536
     /* 2184536 */   GIM_Try, /*On fail goto*//*Label 28760*/ GIMT_Encode4(2184627), // Rule ID 18526 //
     /* 2184541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2184549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2184552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2184555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2184558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2184561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2184579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184587 */     // MIs[0] round
     /* 2184587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184590 */     // MIs[0] policy
     /* 2184590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184600 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2184603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184626 */     // GIR_Coverage, 18526,
     /* 2184626 */     GIR_EraseRootFromParent_Done,
     /* 2184627 */   // Label 28760: @2184627
     /* 2184627 */   GIM_Try, /*On fail goto*//*Label 28761*/ GIMT_Encode4(2184718), // Rule ID 18527 //
     /* 2184632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2184640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2184643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2184646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2184649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2184652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2184670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184678 */     // MIs[0] round
     /* 2184678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184681 */     // MIs[0] policy
     /* 2184681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184691 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2184694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184717 */     // GIR_Coverage, 18527,
     /* 2184717 */     GIR_EraseRootFromParent_Done,
     /* 2184718 */   // Label 28761: @2184718
     /* 2184718 */   GIM_Try, /*On fail goto*//*Label 28762*/ GIMT_Encode4(2184809), // Rule ID 18530 //
     /* 2184723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2184731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2184734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2184737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2184740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2184743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2184761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184769 */     // MIs[0] round
     /* 2184769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184772 */     // MIs[0] policy
     /* 2184772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184782 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2184785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184808 */     // GIR_Coverage, 18530,
     /* 2184808 */     GIR_EraseRootFromParent_Done,
     /* 2184809 */   // Label 28762: @2184809
     /* 2184809 */   GIM_Try, /*On fail goto*//*Label 28763*/ GIMT_Encode4(2184900), // Rule ID 18531 //
     /* 2184814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2184822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2184825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2184828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2184831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2184834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2184852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184860 */     // MIs[0] round
     /* 2184860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184863 */     // MIs[0] policy
     /* 2184863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184873 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2184876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184899 */     // GIR_Coverage, 18531,
     /* 2184899 */     GIR_EraseRootFromParent_Done,
     /* 2184900 */   // Label 28763: @2184900
     /* 2184900 */   GIM_Try, /*On fail goto*//*Label 28764*/ GIMT_Encode4(2184991), // Rule ID 18534 //
     /* 2184905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2184908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2184913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2184916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2184919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2184922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2184925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2184943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184951 */     // MIs[0] round
     /* 2184951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184954 */     // MIs[0] policy
     /* 2184954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184964 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2184967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184990 */     // GIR_Coverage, 18534,
     /* 2184990 */     GIR_EraseRootFromParent_Done,
     /* 2184991 */   // Label 28764: @2184991
     /* 2184991 */   GIM_Try, /*On fail goto*//*Label 28765*/ GIMT_Encode4(2185082), // Rule ID 18535 //
     /* 2184996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2184999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2185004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2185007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2185010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2185013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2185016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2185019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2185034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185042 */     // MIs[0] round
     /* 2185042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185045 */     // MIs[0] policy
     /* 2185045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185055 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2185058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185081 */     // GIR_Coverage, 18535,
     /* 2185081 */     GIR_EraseRootFromParent_Done,
     /* 2185082 */   // Label 28765: @2185082
     /* 2185082 */   GIM_Try, /*On fail goto*//*Label 28766*/ GIMT_Encode4(2185173), // Rule ID 18538 //
     /* 2185087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2185090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2185095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2185098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2185101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2185104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2185107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2185125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185133 */     // MIs[0] round
     /* 2185133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185136 */     // MIs[0] policy
     /* 2185136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185146 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2185149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185172 */     // GIR_Coverage, 18538,
     /* 2185172 */     GIR_EraseRootFromParent_Done,
     /* 2185173 */   // Label 28766: @2185173
     /* 2185173 */   GIM_Try, /*On fail goto*//*Label 28767*/ GIMT_Encode4(2185264), // Rule ID 18539 //
     /* 2185178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2185181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2185186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2185189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2185192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2185195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2185198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2185216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185224 */     // MIs[0] round
     /* 2185224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185227 */     // MIs[0] policy
     /* 2185227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185237 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2185240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185263 */     // GIR_Coverage, 18539,
     /* 2185263 */     GIR_EraseRootFromParent_Done,
     /* 2185264 */   // Label 28767: @2185264
     /* 2185264 */   GIM_Try, /*On fail goto*//*Label 28768*/ GIMT_Encode4(2185355), // Rule ID 18542 //
     /* 2185269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2185277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2185280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2185283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2185286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2185289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2185292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2185307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185315 */     // MIs[0] round
     /* 2185315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185318 */     // MIs[0] policy
     /* 2185318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185328 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2185331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185354 */     // GIR_Coverage, 18542,
     /* 2185354 */     GIR_EraseRootFromParent_Done,
     /* 2185355 */   // Label 28768: @2185355
     /* 2185355 */   GIM_Try, /*On fail goto*//*Label 28769*/ GIMT_Encode4(2185446), // Rule ID 18543 //
     /* 2185360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2185368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2185371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2185374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2185377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2185380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2185383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2185398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185406 */     // MIs[0] round
     /* 2185406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185409 */     // MIs[0] policy
     /* 2185409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185419 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2185422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185445 */     // GIR_Coverage, 18543,
     /* 2185445 */     GIR_EraseRootFromParent_Done,
     /* 2185446 */   // Label 28769: @2185446
     /* 2185446 */   GIM_Try, /*On fail goto*//*Label 28770*/ GIMT_Encode4(2185537), // Rule ID 18546 //
     /* 2185451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2185454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2185459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2185462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2185465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2185468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2185471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2185474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2185489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185497 */     // MIs[0] round
     /* 2185497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185500 */     // MIs[0] policy
     /* 2185500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185510 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2185513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185536 */     // GIR_Coverage, 18546,
     /* 2185536 */     GIR_EraseRootFromParent_Done,
     /* 2185537 */   // Label 28770: @2185537
     /* 2185537 */   GIM_Try, /*On fail goto*//*Label 28771*/ GIMT_Encode4(2185628), // Rule ID 18547 //
     /* 2185542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2185545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2185550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2185553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2185556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2185559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2185562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2185565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2185580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185588 */     // MIs[0] round
     /* 2185588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185591 */     // MIs[0] policy
     /* 2185591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185601 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2185604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185627 */     // GIR_Coverage, 18547,
     /* 2185627 */     GIR_EraseRootFromParent_Done,
     /* 2185628 */   // Label 28771: @2185628
     /* 2185628 */   GIM_Try, /*On fail goto*//*Label 28772*/ GIMT_Encode4(2185719), // Rule ID 18550 //
     /* 2185633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2185636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2185641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2185644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2185647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2185650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2185653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2185671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185679 */     // MIs[0] round
     /* 2185679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185682 */     // MIs[0] policy
     /* 2185682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185692 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2185695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185718 */     // GIR_Coverage, 18550,
     /* 2185718 */     GIR_EraseRootFromParent_Done,
     /* 2185719 */   // Label 28772: @2185719
     /* 2185719 */   GIM_Try, /*On fail goto*//*Label 28773*/ GIMT_Encode4(2185810), // Rule ID 18551 //
     /* 2185724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2185727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2185732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2185735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2185738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2185741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2185744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2185762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185770 */     // MIs[0] round
     /* 2185770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185773 */     // MIs[0] policy
     /* 2185773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185783 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2185786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185809 */     // GIR_Coverage, 18551,
     /* 2185809 */     GIR_EraseRootFromParent_Done,
     /* 2185810 */   // Label 28773: @2185810
     /* 2185810 */   GIM_Try, /*On fail goto*//*Label 28774*/ GIMT_Encode4(2185901), // Rule ID 18554 //
     /* 2185815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2185818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2185823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2185826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2185829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2185832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2185835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2185838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2185853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185861 */     // MIs[0] round
     /* 2185861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185864 */     // MIs[0] policy
     /* 2185864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185874 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2185877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185900 */     // GIR_Coverage, 18554,
     /* 2185900 */     GIR_EraseRootFromParent_Done,
     /* 2185901 */   // Label 28774: @2185901
     /* 2185901 */   GIM_Try, /*On fail goto*//*Label 28775*/ GIMT_Encode4(2185992), // Rule ID 18555 //
     /* 2185906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2185909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2185914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2185917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2185920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2185923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2185926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2185929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2185944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185952 */     // MIs[0] round
     /* 2185952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185955 */     // MIs[0] policy
     /* 2185955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185965 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2185968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185991 */     // GIR_Coverage, 18555,
     /* 2185991 */     GIR_EraseRootFromParent_Done,
     /* 2185992 */   // Label 28775: @2185992
     /* 2185992 */   GIM_Try, /*On fail goto*//*Label 28776*/ GIMT_Encode4(2186083), // Rule ID 18558 //
     /* 2185997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2186000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2186005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2186008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2186011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2186017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2186020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186043 */     // MIs[0] round
     /* 2186043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186046 */     // MIs[0] policy
     /* 2186046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186056 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2186059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186082 */     // GIR_Coverage, 18558,
     /* 2186082 */     GIR_EraseRootFromParent_Done,
     /* 2186083 */   // Label 28776: @2186083
     /* 2186083 */   GIM_Try, /*On fail goto*//*Label 28777*/ GIMT_Encode4(2186174), // Rule ID 18559 //
     /* 2186088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2186091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2186096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2186099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2186102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2186108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2186111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186134 */     // MIs[0] round
     /* 2186134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186137 */     // MIs[0] policy
     /* 2186137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186147 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2186150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186173 */     // GIR_Coverage, 18559,
     /* 2186173 */     GIR_EraseRootFromParent_Done,
     /* 2186174 */   // Label 28777: @2186174
     /* 2186174 */   GIM_Try, /*On fail goto*//*Label 28778*/ GIMT_Encode4(2186265), // Rule ID 18562 //
     /* 2186179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2186182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2186187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2186190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2186193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2186199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2186209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186225 */     // MIs[0] round
     /* 2186225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186228 */     // MIs[0] policy
     /* 2186228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186238 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2186241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186264 */     // GIR_Coverage, 18562,
     /* 2186264 */     GIR_EraseRootFromParent_Done,
     /* 2186265 */   // Label 28778: @2186265
     /* 2186265 */   GIM_Try, /*On fail goto*//*Label 28779*/ GIMT_Encode4(2186356), // Rule ID 18563 //
     /* 2186270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2186273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2186278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2186281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2186284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2186290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2186300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186316 */     // MIs[0] round
     /* 2186316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186319 */     // MIs[0] policy
     /* 2186319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186329 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2186332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186355 */     // GIR_Coverage, 18563,
     /* 2186355 */     GIR_EraseRootFromParent_Done,
     /* 2186356 */   // Label 28779: @2186356
     /* 2186356 */   GIM_Try, /*On fail goto*//*Label 28780*/ GIMT_Encode4(2186447), // Rule ID 18566 //
     /* 2186361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2186364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2186369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2186372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2186375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2186381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2186384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2186391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186407 */     // MIs[0] round
     /* 2186407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186410 */     // MIs[0] policy
     /* 2186410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186420 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2186423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186446 */     // GIR_Coverage, 18566,
     /* 2186446 */     GIR_EraseRootFromParent_Done,
     /* 2186447 */   // Label 28780: @2186447
     /* 2186447 */   GIM_Try, /*On fail goto*//*Label 28781*/ GIMT_Encode4(2186538), // Rule ID 18567 //
     /* 2186452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2186455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2186460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2186463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2186466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2186472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2186475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2186482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186498 */     // MIs[0] round
     /* 2186498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186501 */     // MIs[0] policy
     /* 2186501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186511 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2186514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186537 */     // GIR_Coverage, 18567,
     /* 2186537 */     GIR_EraseRootFromParent_Done,
     /* 2186538 */   // Label 28781: @2186538
     /* 2186538 */   GIM_Try, /*On fail goto*//*Label 28782*/ GIMT_Encode4(2186629), // Rule ID 18570 //
     /* 2186543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2186546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2186551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2186554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2186557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2186563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2186566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186589 */     // MIs[0] round
     /* 2186589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186592 */     // MIs[0] policy
     /* 2186592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186602 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2186605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186628 */     // GIR_Coverage, 18570,
     /* 2186628 */     GIR_EraseRootFromParent_Done,
     /* 2186629 */   // Label 28782: @2186629
     /* 2186629 */   GIM_Try, /*On fail goto*//*Label 28783*/ GIMT_Encode4(2186720), // Rule ID 18571 //
     /* 2186634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2186637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2186642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2186645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2186648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2186654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2186657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186680 */     // MIs[0] round
     /* 2186680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186683 */     // MIs[0] policy
     /* 2186683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186693 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2186696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186719 */     // GIR_Coverage, 18571,
     /* 2186719 */     GIR_EraseRootFromParent_Done,
     /* 2186720 */   // Label 28783: @2186720
     /* 2186720 */   GIM_Try, /*On fail goto*//*Label 28784*/ GIMT_Encode4(2186811), // Rule ID 18574 //
     /* 2186725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2186728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2186733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2186736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2186739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2186742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2186745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2186755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2186763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186771 */     // MIs[0] round
     /* 2186771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186774 */     // MIs[0] policy
     /* 2186774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186784 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2186787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186810 */     // GIR_Coverage, 18574,
     /* 2186810 */     GIR_EraseRootFromParent_Done,
     /* 2186811 */   // Label 28784: @2186811
     /* 2186811 */   GIM_Try, /*On fail goto*//*Label 28785*/ GIMT_Encode4(2186902), // Rule ID 18575 //
     /* 2186816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2186819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2186824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2186827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2186830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2186833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2186836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2186846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2186854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186862 */     // MIs[0] round
     /* 2186862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186865 */     // MIs[0] policy
     /* 2186865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186875 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2186878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186901 */     // GIR_Coverage, 18575,
     /* 2186901 */     GIR_EraseRootFromParent_Done,
     /* 2186902 */   // Label 28785: @2186902
     /* 2186902 */   GIM_Try, /*On fail goto*//*Label 28786*/ GIMT_Encode4(2186993), // Rule ID 18578 //
     /* 2186907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2186910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2186915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2186918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2186921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2186924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2186927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2186937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2186945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186953 */     // MIs[0] round
     /* 2186953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186956 */     // MIs[0] policy
     /* 2186956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186966 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2186969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186992 */     // GIR_Coverage, 18578,
     /* 2186992 */     GIR_EraseRootFromParent_Done,
     /* 2186993 */   // Label 28786: @2186993
     /* 2186993 */   GIM_Try, /*On fail goto*//*Label 28787*/ GIMT_Encode4(2187084), // Rule ID 18579 //
     /* 2186998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2187001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2187006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2187009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2187012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2187015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2187018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2187028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2187036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187044 */     // MIs[0] round
     /* 2187044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187047 */     // MIs[0] policy
     /* 2187047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187057 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2187060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187083 */     // GIR_Coverage, 18579,
     /* 2187083 */     GIR_EraseRootFromParent_Done,
     /* 2187084 */   // Label 28787: @2187084
     /* 2187084 */   GIM_Try, /*On fail goto*//*Label 28788*/ GIMT_Encode4(2187175), // Rule ID 18582 //
     /* 2187089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2187092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2187097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2187100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2187103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2187106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2187109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2187119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2187127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187135 */     // MIs[0] round
     /* 2187135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187138 */     // MIs[0] policy
     /* 2187138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187148 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2187151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187174 */     // GIR_Coverage, 18582,
     /* 2187174 */     GIR_EraseRootFromParent_Done,
     /* 2187175 */   // Label 28788: @2187175
     /* 2187175 */   GIM_Try, /*On fail goto*//*Label 28789*/ GIMT_Encode4(2187266), // Rule ID 18583 //
     /* 2187180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2187183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2187188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2187191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2187194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2187197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2187200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2187210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2187218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187226 */     // MIs[0] round
     /* 2187226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187229 */     // MIs[0] policy
     /* 2187229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187239 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2187242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187265 */     // GIR_Coverage, 18583,
     /* 2187265 */     GIR_EraseRootFromParent_Done,
     /* 2187266 */   // Label 28789: @2187266
     /* 2187266 */   GIM_Try, /*On fail goto*//*Label 28790*/ GIMT_Encode4(2187357), // Rule ID 18586 //
     /* 2187271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2187282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2187285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2187288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2187291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187317 */     // MIs[0] round
     /* 2187317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187320 */     // MIs[0] policy
     /* 2187320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187330 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2187333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187356 */     // GIR_Coverage, 18586,
     /* 2187356 */     GIR_EraseRootFromParent_Done,
     /* 2187357 */   // Label 28790: @2187357
     /* 2187357 */   GIM_Try, /*On fail goto*//*Label 28791*/ GIMT_Encode4(2187448), // Rule ID 18587 //
     /* 2187362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2187373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2187376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2187379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2187382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187408 */     // MIs[0] round
     /* 2187408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187411 */     // MIs[0] policy
     /* 2187411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187421 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2187424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187447 */     // GIR_Coverage, 18587,
     /* 2187447 */     GIR_EraseRootFromParent_Done,
     /* 2187448 */   // Label 28791: @2187448
     /* 2187448 */   GIM_Try, /*On fail goto*//*Label 28792*/ GIMT_Encode4(2187539), // Rule ID 18590 //
     /* 2187453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2187464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2187467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2187470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2187473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2187476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187499 */     // MIs[0] round
     /* 2187499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187502 */     // MIs[0] policy
     /* 2187502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187512 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2187515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187538 */     // GIR_Coverage, 18590,
     /* 2187538 */     GIR_EraseRootFromParent_Done,
     /* 2187539 */   // Label 28792: @2187539
     /* 2187539 */   GIM_Try, /*On fail goto*//*Label 28793*/ GIMT_Encode4(2187630), // Rule ID 18591 //
     /* 2187544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2187555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2187558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2187561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2187564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2187567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187590 */     // MIs[0] round
     /* 2187590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187593 */     // MIs[0] policy
     /* 2187593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187603 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2187606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187629 */     // GIR_Coverage, 18591,
     /* 2187629 */     GIR_EraseRootFromParent_Done,
     /* 2187630 */   // Label 28793: @2187630
     /* 2187630 */   GIM_Try, /*On fail goto*//*Label 28794*/ GIMT_Encode4(2187721), // Rule ID 18594 //
     /* 2187635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2187638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2187646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2187649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2187652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2187655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187681 */     // MIs[0] round
     /* 2187681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187684 */     // MIs[0] policy
     /* 2187684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187694 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2187697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187720 */     // GIR_Coverage, 18594,
     /* 2187720 */     GIR_EraseRootFromParent_Done,
     /* 2187721 */   // Label 28794: @2187721
     /* 2187721 */   GIM_Try, /*On fail goto*//*Label 28795*/ GIMT_Encode4(2187812), // Rule ID 18595 //
     /* 2187726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2187729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2187737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2187740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2187743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2187746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187772 */     // MIs[0] round
     /* 2187772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187775 */     // MIs[0] policy
     /* 2187775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187785 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2187788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187811 */     // GIR_Coverage, 18595,
     /* 2187811 */     GIR_EraseRootFromParent_Done,
     /* 2187812 */   // Label 28795: @2187812
     /* 2187812 */   GIM_Try, /*On fail goto*//*Label 28796*/ GIMT_Encode4(2187903), // Rule ID 18598 //
     /* 2187817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2187828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2187831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2187834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2187837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187863 */     // MIs[0] round
     /* 2187863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187866 */     // MIs[0] policy
     /* 2187866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187876 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2187879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187902 */     // GIR_Coverage, 18598,
     /* 2187902 */     GIR_EraseRootFromParent_Done,
     /* 2187903 */   // Label 28796: @2187903
     /* 2187903 */   GIM_Try, /*On fail goto*//*Label 28797*/ GIMT_Encode4(2187994), // Rule ID 18599 //
     /* 2187908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2187919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2187922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2187925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2187928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187954 */     // MIs[0] round
     /* 2187954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187957 */     // MIs[0] policy
     /* 2187957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187967 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2187970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187993 */     // GIR_Coverage, 18599,
     /* 2187993 */     GIR_EraseRootFromParent_Done,
     /* 2187994 */   // Label 28797: @2187994
     /* 2187994 */   GIM_Try, /*On fail goto*//*Label 28798*/ GIMT_Encode4(2188085), // Rule ID 18602 //
     /* 2187999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2188002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2188010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2188013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2188016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2188019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2188029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188045 */     // MIs[0] round
     /* 2188045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188048 */     // MIs[0] policy
     /* 2188048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188058 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2188061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188084 */     // GIR_Coverage, 18602,
     /* 2188084 */     GIR_EraseRootFromParent_Done,
     /* 2188085 */   // Label 28798: @2188085
     /* 2188085 */   GIM_Try, /*On fail goto*//*Label 28799*/ GIMT_Encode4(2188176), // Rule ID 18603 //
     /* 2188090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2188093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2188101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2188104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2188107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2188110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2188120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188136 */     // MIs[0] round
     /* 2188136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188139 */     // MIs[0] policy
     /* 2188139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188149 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2188152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188175 */     // GIR_Coverage, 18603,
     /* 2188175 */     GIR_EraseRootFromParent_Done,
     /* 2188176 */   // Label 28799: @2188176
     /* 2188176 */   GIM_Try, /*On fail goto*//*Label 28800*/ GIMT_Encode4(2188267), // Rule ID 18606 //
     /* 2188181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2188184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2188192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2188195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2188198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2188201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2188204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2188211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188227 */     // MIs[0] round
     /* 2188227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188230 */     // MIs[0] policy
     /* 2188230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188240 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2188243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188266 */     // GIR_Coverage, 18606,
     /* 2188266 */     GIR_EraseRootFromParent_Done,
     /* 2188267 */   // Label 28800: @2188267
     /* 2188267 */   GIM_Try, /*On fail goto*//*Label 28801*/ GIMT_Encode4(2188358), // Rule ID 18607 //
     /* 2188272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2188275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2188283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2188286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2188289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2188292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2188295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2188302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188318 */     // MIs[0] round
     /* 2188318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188321 */     // MIs[0] policy
     /* 2188321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188331 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2188334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188357 */     // GIR_Coverage, 18607,
     /* 2188357 */     GIR_EraseRootFromParent_Done,
     /* 2188358 */   // Label 28801: @2188358
     /* 2188358 */   GIM_Try, /*On fail goto*//*Label 28802*/ GIMT_Encode4(2188449), // Rule ID 18610 //
     /* 2188363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2188366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2188374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2188377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2188380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2188383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188409 */     // MIs[0] round
     /* 2188409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188412 */     // MIs[0] policy
     /* 2188412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188422 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2188425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188448 */     // GIR_Coverage, 18610,
     /* 2188448 */     GIR_EraseRootFromParent_Done,
     /* 2188449 */   // Label 28802: @2188449
     /* 2188449 */   GIM_Try, /*On fail goto*//*Label 28803*/ GIMT_Encode4(2188540), // Rule ID 18611 //
     /* 2188454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2188457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2188465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2188468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2188471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2188474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188500 */     // MIs[0] round
     /* 2188500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188503 */     // MIs[0] policy
     /* 2188503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188513 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2188516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188539 */     // GIR_Coverage, 18611,
     /* 2188539 */     GIR_EraseRootFromParent_Done,
     /* 2188540 */   // Label 28803: @2188540
     /* 2188540 */   GIM_Try, /*On fail goto*//*Label 28804*/ GIMT_Encode4(2188631), // Rule ID 18614 //
     /* 2188545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2188548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2188556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2188559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2188562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2188565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188591 */     // MIs[0] round
     /* 2188591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188594 */     // MIs[0] policy
     /* 2188594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188604 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2188607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188630 */     // GIR_Coverage, 18614,
     /* 2188630 */     GIR_EraseRootFromParent_Done,
     /* 2188631 */   // Label 28804: @2188631
     /* 2188631 */   GIM_Try, /*On fail goto*//*Label 28805*/ GIMT_Encode4(2188722), // Rule ID 18615 //
     /* 2188636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2188639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2188647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2188650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2188653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2188656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188682 */     // MIs[0] round
     /* 2188682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188685 */     // MIs[0] policy
     /* 2188685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188695 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2188698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188721 */     // GIR_Coverage, 18615,
     /* 2188721 */     GIR_EraseRootFromParent_Done,
     /* 2188722 */   // Label 28805: @2188722
     /* 2188722 */   GIM_Try, /*On fail goto*//*Label 28806*/ GIMT_Encode4(2188813), // Rule ID 18618 //
     /* 2188727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2188730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2188738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2188741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2188744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2188747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2188750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188773 */     // MIs[0] round
     /* 2188773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188776 */     // MIs[0] policy
     /* 2188776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188786 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2188789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188812 */     // GIR_Coverage, 18618,
     /* 2188812 */     GIR_EraseRootFromParent_Done,
     /* 2188813 */   // Label 28806: @2188813
     /* 2188813 */   GIM_Try, /*On fail goto*//*Label 28807*/ GIMT_Encode4(2188904), // Rule ID 18619 //
     /* 2188818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2188821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2188829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2188832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2188835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2188838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2188841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188864 */     // MIs[0] round
     /* 2188864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188867 */     // MIs[0] policy
     /* 2188867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188877 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2188880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188903 */     // GIR_Coverage, 18619,
     /* 2188903 */     GIR_EraseRootFromParent_Done,
     /* 2188904 */   // Label 28807: @2188904
     /* 2188904 */   GIM_Try, /*On fail goto*//*Label 28808*/ GIMT_Encode4(2188995), // Rule ID 18622 //
     /* 2188909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2188912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2188920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2188923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2188926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2188929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188955 */     // MIs[0] round
     /* 2188955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188958 */     // MIs[0] policy
     /* 2188958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188968 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2188971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188994 */     // GIR_Coverage, 18622,
     /* 2188994 */     GIR_EraseRootFromParent_Done,
     /* 2188995 */   // Label 28808: @2188995
     /* 2188995 */   GIM_Try, /*On fail goto*//*Label 28809*/ GIMT_Encode4(2189086), // Rule ID 18623 //
     /* 2189000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2189003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2189011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2189014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2189017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2189020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189046 */     // MIs[0] round
     /* 2189046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189049 */     // MIs[0] policy
     /* 2189049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189059 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2189062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189085 */     // GIR_Coverage, 18623,
     /* 2189085 */     GIR_EraseRootFromParent_Done,
     /* 2189086 */   // Label 28809: @2189086
     /* 2189086 */   GIM_Try, /*On fail goto*//*Label 28810*/ GIMT_Encode4(2189177), // Rule ID 18626 //
     /* 2189091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2189094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2189102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2189105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2189108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2189111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189137 */     // MIs[0] round
     /* 2189137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189140 */     // MIs[0] policy
     /* 2189140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189150 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2189153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189176 */     // GIR_Coverage, 18626,
     /* 2189176 */     GIR_EraseRootFromParent_Done,
     /* 2189177 */   // Label 28810: @2189177
     /* 2189177 */   GIM_Try, /*On fail goto*//*Label 28811*/ GIMT_Encode4(2189268), // Rule ID 18627 //
     /* 2189182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2189185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2189193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2189196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2189199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2189202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189228 */     // MIs[0] round
     /* 2189228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189231 */     // MIs[0] policy
     /* 2189231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189241 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2189244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189267 */     // GIR_Coverage, 18627,
     /* 2189267 */     GIR_EraseRootFromParent_Done,
     /* 2189268 */   // Label 28811: @2189268
     /* 2189268 */   GIM_Try, /*On fail goto*//*Label 28812*/ GIMT_Encode4(2189359), // Rule ID 18630 //
     /* 2189273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2189276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2189284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2189287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2189290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2189293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2189296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189319 */     // MIs[0] round
     /* 2189319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189322 */     // MIs[0] policy
     /* 2189322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189332 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2189335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189358 */     // GIR_Coverage, 18630,
     /* 2189358 */     GIR_EraseRootFromParent_Done,
     /* 2189359 */   // Label 28812: @2189359
     /* 2189359 */   GIM_Try, /*On fail goto*//*Label 28813*/ GIMT_Encode4(2189450), // Rule ID 18631 //
     /* 2189364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2189367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2189375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2189378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2189381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2189384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2189387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189410 */     // MIs[0] round
     /* 2189410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189413 */     // MIs[0] policy
     /* 2189413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189423 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2189426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189449 */     // GIR_Coverage, 18631,
     /* 2189449 */     GIR_EraseRootFromParent_Done,
     /* 2189450 */   // Label 28813: @2189450
     /* 2189450 */   GIM_Try, /*On fail goto*//*Label 28814*/ GIMT_Encode4(2189541), // Rule ID 18634 //
     /* 2189455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2189458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2189466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2189469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2189472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2189475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189501 */     // MIs[0] round
     /* 2189501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189504 */     // MIs[0] policy
     /* 2189504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189514 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2189517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189540 */     // GIR_Coverage, 18634,
     /* 2189540 */     GIR_EraseRootFromParent_Done,
     /* 2189541 */   // Label 28814: @2189541
     /* 2189541 */   GIM_Try, /*On fail goto*//*Label 28815*/ GIMT_Encode4(2189632), // Rule ID 18635 //
     /* 2189546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2189549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2189557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2189560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2189563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2189566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189592 */     // MIs[0] round
     /* 2189592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189595 */     // MIs[0] policy
     /* 2189595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189605 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2189608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189631 */     // GIR_Coverage, 18635,
     /* 2189631 */     GIR_EraseRootFromParent_Done,
     /* 2189632 */   // Label 28815: @2189632
     /* 2189632 */   GIM_Try, /*On fail goto*//*Label 28816*/ GIMT_Encode4(2189723), // Rule ID 18638 //
     /* 2189637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2189640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2189648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2189651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2189654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2189657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189683 */     // MIs[0] round
     /* 2189683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189686 */     // MIs[0] policy
     /* 2189686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189696 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2189699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189722 */     // GIR_Coverage, 18638,
     /* 2189722 */     GIR_EraseRootFromParent_Done,
     /* 2189723 */   // Label 28816: @2189723
     /* 2189723 */   GIM_Try, /*On fail goto*//*Label 28817*/ GIMT_Encode4(2189814), // Rule ID 18639 //
     /* 2189728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2189731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2189739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2189742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2189745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2189748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189774 */     // MIs[0] round
     /* 2189774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189777 */     // MIs[0] policy
     /* 2189777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189787 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2189790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189813 */     // GIR_Coverage, 18639,
     /* 2189813 */     GIR_EraseRootFromParent_Done,
     /* 2189814 */   // Label 28817: @2189814
     /* 2189814 */   GIM_Try, /*On fail goto*//*Label 28818*/ GIMT_Encode4(2189905), // Rule ID 18642 //
     /* 2189819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2189822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2189830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2189833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2189836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2189839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189865 */     // MIs[0] round
     /* 2189865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189868 */     // MIs[0] policy
     /* 2189868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189878 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2189881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189904 */     // GIR_Coverage, 18642,
     /* 2189904 */     GIR_EraseRootFromParent_Done,
     /* 2189905 */   // Label 28818: @2189905
     /* 2189905 */   GIM_Try, /*On fail goto*//*Label 28819*/ GIMT_Encode4(2189996), // Rule ID 18643 //
     /* 2189910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2189913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2189921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2189924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2189927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2189930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189956 */     // MIs[0] round
     /* 2189956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189959 */     // MIs[0] policy
     /* 2189959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189969 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2189972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189995 */     // GIR_Coverage, 18643,
     /* 2189995 */     GIR_EraseRootFromParent_Done,
     /* 2189996 */   // Label 28819: @2189996
     /* 2189996 */   GIM_Try, /*On fail goto*//*Label 28820*/ GIMT_Encode4(2190087), // Rule ID 18646 //
     /* 2190001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2190004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2190009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2190012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2190015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2190021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190047 */     // MIs[0] round
     /* 2190047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190050 */     // MIs[0] policy
     /* 2190050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190060 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2190063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190086 */     // GIR_Coverage, 18646,
     /* 2190086 */     GIR_EraseRootFromParent_Done,
     /* 2190087 */   // Label 28820: @2190087
     /* 2190087 */   GIM_Try, /*On fail goto*//*Label 28821*/ GIMT_Encode4(2190178), // Rule ID 18647 //
     /* 2190092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2190095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2190100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2190103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2190106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2190112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190138 */     // MIs[0] round
     /* 2190138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190141 */     // MIs[0] policy
     /* 2190141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190151 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2190154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190177 */     // GIR_Coverage, 18647,
     /* 2190177 */     GIR_EraseRootFromParent_Done,
     /* 2190178 */   // Label 28821: @2190178
     /* 2190178 */   GIM_Try, /*On fail goto*//*Label 28822*/ GIMT_Encode4(2190269), // Rule ID 18650 //
     /* 2190183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2190186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2190191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2190194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2190197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2190203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190229 */     // MIs[0] round
     /* 2190229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190232 */     // MIs[0] policy
     /* 2190232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190242 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2190245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190268 */     // GIR_Coverage, 18650,
     /* 2190268 */     GIR_EraseRootFromParent_Done,
     /* 2190269 */   // Label 28822: @2190269
     /* 2190269 */   GIM_Try, /*On fail goto*//*Label 28823*/ GIMT_Encode4(2190360), // Rule ID 18651 //
     /* 2190274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2190277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2190282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2190285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2190288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2190294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190320 */     // MIs[0] round
     /* 2190320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190323 */     // MIs[0] policy
     /* 2190323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190333 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2190336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190359 */     // GIR_Coverage, 18651,
     /* 2190359 */     GIR_EraseRootFromParent_Done,
     /* 2190360 */   // Label 28823: @2190360
     /* 2190360 */   GIM_Try, /*On fail goto*//*Label 28824*/ GIMT_Encode4(2190451), // Rule ID 18654 //
     /* 2190365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2190368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2190373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2190376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2190379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2190382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2190385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190411 */     // MIs[0] round
     /* 2190411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190414 */     // MIs[0] policy
     /* 2190414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190424 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2190427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190450 */     // GIR_Coverage, 18654,
     /* 2190450 */     GIR_EraseRootFromParent_Done,
     /* 2190451 */   // Label 28824: @2190451
     /* 2190451 */   GIM_Try, /*On fail goto*//*Label 28825*/ GIMT_Encode4(2190542), // Rule ID 18655 //
     /* 2190456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2190459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2190464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2190467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2190470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2190473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2190476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190502 */     // MIs[0] round
     /* 2190502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190505 */     // MIs[0] policy
     /* 2190505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190515 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2190518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190541 */     // GIR_Coverage, 18655,
     /* 2190541 */     GIR_EraseRootFromParent_Done,
     /* 2190542 */   // Label 28825: @2190542
     /* 2190542 */   GIM_Try, /*On fail goto*//*Label 28826*/ GIMT_Encode4(2190633), // Rule ID 18658 //
     /* 2190547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2190550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2190555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2190558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2190561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2190567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190593 */     // MIs[0] round
     /* 2190593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190596 */     // MIs[0] policy
     /* 2190596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190606 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2190609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190632 */     // GIR_Coverage, 18658,
     /* 2190632 */     GIR_EraseRootFromParent_Done,
     /* 2190633 */   // Label 28826: @2190633
     /* 2190633 */   GIM_Try, /*On fail goto*//*Label 28827*/ GIMT_Encode4(2190724), // Rule ID 18659 //
     /* 2190638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2190641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2190646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2190649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2190652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2190658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190684 */     // MIs[0] round
     /* 2190684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190687 */     // MIs[0] policy
     /* 2190687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190697 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2190700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190723 */     // GIR_Coverage, 18659,
     /* 2190723 */     GIR_EraseRootFromParent_Done,
     /* 2190724 */   // Label 28827: @2190724
     /* 2190724 */   GIM_Try, /*On fail goto*//*Label 28828*/ GIMT_Encode4(2190815), // Rule ID 18662 //
     /* 2190729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2190732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2190737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2190740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2190743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2190746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2190749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190775 */     // MIs[0] round
     /* 2190775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190778 */     // MIs[0] policy
     /* 2190778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190788 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2190791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190814 */     // GIR_Coverage, 18662,
     /* 2190814 */     GIR_EraseRootFromParent_Done,
     /* 2190815 */   // Label 28828: @2190815
     /* 2190815 */   GIM_Try, /*On fail goto*//*Label 28829*/ GIMT_Encode4(2190906), // Rule ID 18663 //
     /* 2190820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2190823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2190828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2190831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2190834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2190837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2190840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190866 */     // MIs[0] round
     /* 2190866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190869 */     // MIs[0] policy
     /* 2190869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190879 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2190882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190905 */     // GIR_Coverage, 18663,
     /* 2190905 */     GIR_EraseRootFromParent_Done,
     /* 2190906 */   // Label 28829: @2190906
     /* 2190906 */   GIM_Try, /*On fail goto*//*Label 28830*/ GIMT_Encode4(2190997), // Rule ID 18666 //
     /* 2190911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2190914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2190919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2190922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2190925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2190928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2190931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2190949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190957 */     // MIs[0] round
     /* 2190957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190960 */     // MIs[0] policy
     /* 2190960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190970 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2190973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2190993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190996 */     // GIR_Coverage, 18666,
     /* 2190996 */     GIR_EraseRootFromParent_Done,
     /* 2190997 */   // Label 28830: @2190997
     /* 2190997 */   GIM_Try, /*On fail goto*//*Label 28831*/ GIMT_Encode4(2191088), // Rule ID 18667 //
     /* 2191002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2191005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2191010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2191013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2191016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2191019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2191022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2191040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191048 */     // MIs[0] round
     /* 2191048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191051 */     // MIs[0] policy
     /* 2191051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191061 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2191064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2191084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191087 */     // GIR_Coverage, 18667,
     /* 2191087 */     GIR_EraseRootFromParent_Done,
     /* 2191088 */   // Label 28831: @2191088
     /* 2191088 */   GIM_Try, /*On fail goto*//*Label 28832*/ GIMT_Encode4(2191179), // Rule ID 18670 //
     /* 2191093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2191096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2191101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2191104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2191107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2191113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191139 */     // MIs[0] round
     /* 2191139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191142 */     // MIs[0] policy
     /* 2191142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191152 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2191155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191178 */     // GIR_Coverage, 18670,
     /* 2191178 */     GIR_EraseRootFromParent_Done,
     /* 2191179 */   // Label 28832: @2191179
     /* 2191179 */   GIM_Try, /*On fail goto*//*Label 28833*/ GIMT_Encode4(2191270), // Rule ID 18671 //
     /* 2191184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2191187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2191192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2191195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2191198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2191204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191230 */     // MIs[0] round
     /* 2191230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191233 */     // MIs[0] policy
     /* 2191233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191243 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2191246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191269 */     // GIR_Coverage, 18671,
     /* 2191269 */     GIR_EraseRootFromParent_Done,
     /* 2191270 */   // Label 28833: @2191270
     /* 2191270 */   GIM_Try, /*On fail goto*//*Label 28834*/ GIMT_Encode4(2191361), // Rule ID 18674 //
     /* 2191275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2191278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2191283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2191286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2191289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2191295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2191298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191321 */     // MIs[0] round
     /* 2191321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191324 */     // MIs[0] policy
     /* 2191324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191334 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2191337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191360 */     // GIR_Coverage, 18674,
     /* 2191360 */     GIR_EraseRootFromParent_Done,
     /* 2191361 */   // Label 28834: @2191361
     /* 2191361 */   GIM_Try, /*On fail goto*//*Label 28835*/ GIMT_Encode4(2191452), // Rule ID 18675 //
     /* 2191366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2191369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2191374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2191377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2191380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2191386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2191389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191412 */     // MIs[0] round
     /* 2191412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191415 */     // MIs[0] policy
     /* 2191415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191425 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2191428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191451 */     // GIR_Coverage, 18675,
     /* 2191451 */     GIR_EraseRootFromParent_Done,
     /* 2191452 */   // Label 28835: @2191452
     /* 2191452 */   GIM_Try, /*On fail goto*//*Label 28836*/ GIMT_Encode4(2191543), // Rule ID 18678 //
     /* 2191457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2191460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2191465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2191468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2191471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2191477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2191480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2191487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191503 */     // MIs[0] round
     /* 2191503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191506 */     // MIs[0] policy
     /* 2191506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191516 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2191519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191542 */     // GIR_Coverage, 18678,
     /* 2191542 */     GIR_EraseRootFromParent_Done,
     /* 2191543 */   // Label 28836: @2191543
     /* 2191543 */   GIM_Try, /*On fail goto*//*Label 28837*/ GIMT_Encode4(2191634), // Rule ID 18679 //
     /* 2191548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2191551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2191556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2191559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2191562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2191568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2191571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2191578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191594 */     // MIs[0] round
     /* 2191594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191597 */     // MIs[0] policy
     /* 2191597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191607 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2191610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191633 */     // GIR_Coverage, 18679,
     /* 2191633 */     GIR_EraseRootFromParent_Done,
     /* 2191634 */   // Label 28837: @2191634
     /* 2191634 */   GIM_Try, /*On fail goto*//*Label 28838*/ GIMT_Encode4(2191725), // Rule ID 18682 //
     /* 2191639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2191642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2191647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2191650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2191653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2191659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191685 */     // MIs[0] round
     /* 2191685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191688 */     // MIs[0] policy
     /* 2191688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191698 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2191701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191724 */     // GIR_Coverage, 18682,
     /* 2191724 */     GIR_EraseRootFromParent_Done,
     /* 2191725 */   // Label 28838: @2191725
     /* 2191725 */   GIM_Try, /*On fail goto*//*Label 28839*/ GIMT_Encode4(2191816), // Rule ID 18683 //
     /* 2191730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2191733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2191738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2191741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2191744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2191750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191776 */     // MIs[0] round
     /* 2191776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191779 */     // MIs[0] policy
     /* 2191779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191789 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2191792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191815 */     // GIR_Coverage, 18683,
     /* 2191815 */     GIR_EraseRootFromParent_Done,
     /* 2191816 */   // Label 28839: @2191816
     /* 2191816 */   GIM_Try, /*On fail goto*//*Label 28840*/ GIMT_Encode4(2191907), // Rule ID 18686 //
     /* 2191821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2191824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2191829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2191832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2191835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2191841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191867 */     // MIs[0] round
     /* 2191867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191870 */     // MIs[0] policy
     /* 2191870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191880 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2191883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191906 */     // GIR_Coverage, 18686,
     /* 2191906 */     GIR_EraseRootFromParent_Done,
     /* 2191907 */   // Label 28840: @2191907
     /* 2191907 */   GIM_Try, /*On fail goto*//*Label 28841*/ GIMT_Encode4(2191998), // Rule ID 18687 //
     /* 2191912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2191915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2191920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2191923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2191926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2191932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191958 */     // MIs[0] round
     /* 2191958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191961 */     // MIs[0] policy
     /* 2191961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191971 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2191974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191997 */     // GIR_Coverage, 18687,
     /* 2191997 */     GIR_EraseRootFromParent_Done,
     /* 2191998 */   // Label 28841: @2191998
     /* 2191998 */   GIM_Try, /*On fail goto*//*Label 28842*/ GIMT_Encode4(2192089), // Rule ID 18690 //
     /* 2192003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2192006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2192011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2192014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2192017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2192023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2192026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192049 */     // MIs[0] round
     /* 2192049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192052 */     // MIs[0] policy
     /* 2192052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192062 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2192065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192088 */     // GIR_Coverage, 18690,
     /* 2192088 */     GIR_EraseRootFromParent_Done,
     /* 2192089 */   // Label 28842: @2192089
     /* 2192089 */   GIM_Try, /*On fail goto*//*Label 28843*/ GIMT_Encode4(2192180), // Rule ID 18691 //
     /* 2192094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2192097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2192102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2192105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2192108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2192114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2192117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192140 */     // MIs[0] round
     /* 2192140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192143 */     // MIs[0] policy
     /* 2192143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192153 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2192156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192179 */     // GIR_Coverage, 18691,
     /* 2192179 */     GIR_EraseRootFromParent_Done,
     /* 2192180 */   // Label 28843: @2192180
     /* 2192180 */   GIM_Try, /*On fail goto*//*Label 28844*/ GIMT_Encode4(2192271), // Rule ID 18694 //
     /* 2192185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2192188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2192193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2192196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2192199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2192202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2192205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192231 */     // MIs[0] round
     /* 2192231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192234 */     // MIs[0] policy
     /* 2192234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192244 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2192247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2192267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192270 */     // GIR_Coverage, 18694,
     /* 2192270 */     GIR_EraseRootFromParent_Done,
     /* 2192271 */   // Label 28844: @2192271
     /* 2192271 */   GIM_Try, /*On fail goto*//*Label 28845*/ GIMT_Encode4(2192362), // Rule ID 18695 //
     /* 2192276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2192279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2192284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2192287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2192290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2192293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2192296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192322 */     // MIs[0] round
     /* 2192322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192325 */     // MIs[0] policy
     /* 2192325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192335 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2192338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2192358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192361 */     // GIR_Coverage, 18695,
     /* 2192361 */     GIR_EraseRootFromParent_Done,
     /* 2192362 */   // Label 28845: @2192362
     /* 2192362 */   GIM_Try, /*On fail goto*//*Label 28846*/ GIMT_Encode4(2192453), // Rule ID 18698 //
     /* 2192367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2192370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2192375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2192378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2192381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2192384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2192387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2192397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192413 */     // MIs[0] round
     /* 2192413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192416 */     // MIs[0] policy
     /* 2192416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192426 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2192429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2192449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192452 */     // GIR_Coverage, 18698,
     /* 2192452 */     GIR_EraseRootFromParent_Done,
     /* 2192453 */   // Label 28846: @2192453
     /* 2192453 */   GIM_Try, /*On fail goto*//*Label 28847*/ GIMT_Encode4(2192544), // Rule ID 18699 //
     /* 2192458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2192461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2192466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2192469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2192472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2192475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2192478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2192488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192504 */     // MIs[0] round
     /* 2192504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192507 */     // MIs[0] policy
     /* 2192507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192517 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2192520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2192540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192543 */     // GIR_Coverage, 18699,
     /* 2192543 */     GIR_EraseRootFromParent_Done,
     /* 2192544 */   // Label 28847: @2192544
     /* 2192544 */   GIM_Try, /*On fail goto*//*Label 28848*/ GIMT_Encode4(2192635), // Rule ID 18702 //
     /* 2192549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2192552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2192557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2192560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2192563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2192566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2192569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192595 */     // MIs[0] round
     /* 2192595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192598 */     // MIs[0] policy
     /* 2192598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192608 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2192611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2192631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192634 */     // GIR_Coverage, 18702,
     /* 2192634 */     GIR_EraseRootFromParent_Done,
     /* 2192635 */   // Label 28848: @2192635
     /* 2192635 */   GIM_Try, /*On fail goto*//*Label 28849*/ GIMT_Encode4(2192726), // Rule ID 18703 //
     /* 2192640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2192643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2192648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2192651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2192654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2192657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2192660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2192678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192686 */     // MIs[0] round
     /* 2192686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192689 */     // MIs[0] policy
     /* 2192689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192699 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2192702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2192722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192725 */     // GIR_Coverage, 18703,
     /* 2192725 */     GIR_EraseRootFromParent_Done,
     /* 2192726 */   // Label 28849: @2192726
     /* 2192726 */   GIM_Try, /*On fail goto*//*Label 28850*/ GIMT_Encode4(2192817), // Rule ID 18706 //
     /* 2192731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2192742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2192745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2192748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2192751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192777 */     // MIs[0] round
     /* 2192777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192780 */     // MIs[0] policy
     /* 2192780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192790 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2192793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192816 */     // GIR_Coverage, 18706,
     /* 2192816 */     GIR_EraseRootFromParent_Done,
     /* 2192817 */   // Label 28850: @2192817
     /* 2192817 */   GIM_Try, /*On fail goto*//*Label 28851*/ GIMT_Encode4(2192908), // Rule ID 18707 //
     /* 2192822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2192833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2192836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2192839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2192842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192868 */     // MIs[0] round
     /* 2192868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192871 */     // MIs[0] policy
     /* 2192871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192881 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2192884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192907 */     // GIR_Coverage, 18707,
     /* 2192907 */     GIR_EraseRootFromParent_Done,
     /* 2192908 */   // Label 28851: @2192908
     /* 2192908 */   GIM_Try, /*On fail goto*//*Label 28852*/ GIMT_Encode4(2192999), // Rule ID 18710 //
     /* 2192913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2192924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2192927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2192930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2192933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192959 */     // MIs[0] round
     /* 2192959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192962 */     // MIs[0] policy
     /* 2192962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192972 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2192975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192998 */     // GIR_Coverage, 18710,
     /* 2192998 */     GIR_EraseRootFromParent_Done,
     /* 2192999 */   // Label 28852: @2192999
     /* 2192999 */   GIM_Try, /*On fail goto*//*Label 28853*/ GIMT_Encode4(2193090), // Rule ID 18711 //
     /* 2193004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2193012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2193015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2193018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2193021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2193024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193050 */     // MIs[0] round
     /* 2193050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193053 */     // MIs[0] policy
     /* 2193053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193063 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2193066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193089 */     // GIR_Coverage, 18711,
     /* 2193089 */     GIR_EraseRootFromParent_Done,
     /* 2193090 */   // Label 28853: @2193090
     /* 2193090 */   GIM_Try, /*On fail goto*//*Label 28854*/ GIMT_Encode4(2193181), // Rule ID 18714 //
     /* 2193095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2193103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2193106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2193109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2193112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2193115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193141 */     // MIs[0] round
     /* 2193141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193144 */     // MIs[0] policy
     /* 2193144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193154 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2193157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193180 */     // GIR_Coverage, 18714,
     /* 2193180 */     GIR_EraseRootFromParent_Done,
     /* 2193181 */   // Label 28854: @2193181
     /* 2193181 */   GIM_Try, /*On fail goto*//*Label 28855*/ GIMT_Encode4(2193272), // Rule ID 18715 //
     /* 2193186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2193194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2193197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2193200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2193203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2193206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193232 */     // MIs[0] round
     /* 2193232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193235 */     // MIs[0] policy
     /* 2193235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193245 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2193248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193271 */     // GIR_Coverage, 18715,
     /* 2193271 */     GIR_EraseRootFromParent_Done,
     /* 2193272 */   // Label 28855: @2193272
     /* 2193272 */   GIM_Try, /*On fail goto*//*Label 28856*/ GIMT_Encode4(2193363), // Rule ID 18718 //
     /* 2193277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2193285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2193288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2193291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2193294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2193297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2193300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193323 */     // MIs[0] round
     /* 2193323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193326 */     // MIs[0] policy
     /* 2193326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193336 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2193339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193362 */     // GIR_Coverage, 18718,
     /* 2193362 */     GIR_EraseRootFromParent_Done,
     /* 2193363 */   // Label 28856: @2193363
     /* 2193363 */   GIM_Try, /*On fail goto*//*Label 28857*/ GIMT_Encode4(2193454), // Rule ID 18719 //
     /* 2193368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2193376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2193379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2193382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2193385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2193388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2193391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193414 */     // MIs[0] round
     /* 2193414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193417 */     // MIs[0] policy
     /* 2193417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193427 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2193430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193453 */     // GIR_Coverage, 18719,
     /* 2193453 */     GIR_EraseRootFromParent_Done,
     /* 2193454 */   // Label 28857: @2193454
     /* 2193454 */   GIM_Try, /*On fail goto*//*Label 28858*/ GIMT_Encode4(2193545), // Rule ID 18722 //
     /* 2193459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2193467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2193470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2193473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2193476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2193479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2193482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193505 */     // MIs[0] round
     /* 2193505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193508 */     // MIs[0] policy
     /* 2193508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193518 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2193521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193544 */     // GIR_Coverage, 18722,
     /* 2193544 */     GIR_EraseRootFromParent_Done,
     /* 2193545 */   // Label 28858: @2193545
     /* 2193545 */   GIM_Try, /*On fail goto*//*Label 28859*/ GIMT_Encode4(2193636), // Rule ID 18723 //
     /* 2193550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2193558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2193561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2193564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2193567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2193570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2193573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193596 */     // MIs[0] round
     /* 2193596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193599 */     // MIs[0] policy
     /* 2193599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193609 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2193612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193635 */     // GIR_Coverage, 18723,
     /* 2193635 */     GIR_EraseRootFromParent_Done,
     /* 2193636 */   // Label 28859: @2193636
     /* 2193636 */   GIM_Try, /*On fail goto*//*Label 28860*/ GIMT_Encode4(2193727), // Rule ID 18726 //
     /* 2193641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2193649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2193652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2193655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2193658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2193661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193687 */     // MIs[0] round
     /* 2193687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193690 */     // MIs[0] policy
     /* 2193690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193700 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2193703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193726 */     // GIR_Coverage, 18726,
     /* 2193726 */     GIR_EraseRootFromParent_Done,
     /* 2193727 */   // Label 28860: @2193727
     /* 2193727 */   GIM_Try, /*On fail goto*//*Label 28861*/ GIMT_Encode4(2193818), // Rule ID 18727 //
     /* 2193732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2193740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2193743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2193746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2193749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2193752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193778 */     // MIs[0] round
     /* 2193778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193781 */     // MIs[0] policy
     /* 2193781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193791 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2193794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193817 */     // GIR_Coverage, 18727,
     /* 2193817 */     GIR_EraseRootFromParent_Done,
     /* 2193818 */   // Label 28861: @2193818
     /* 2193818 */   GIM_Try, /*On fail goto*//*Label 28862*/ GIMT_Encode4(2193909), // Rule ID 18730 //
     /* 2193823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2193831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2193834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2193837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2193840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2193843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193869 */     // MIs[0] round
     /* 2193869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193872 */     // MIs[0] policy
     /* 2193872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193882 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2193885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193908 */     // GIR_Coverage, 18730,
     /* 2193908 */     GIR_EraseRootFromParent_Done,
     /* 2193909 */   // Label 28862: @2193909
     /* 2193909 */   GIM_Try, /*On fail goto*//*Label 28863*/ GIMT_Encode4(2194000), // Rule ID 18731 //
     /* 2193914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2193922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2193925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2193928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2193931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2193934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193960 */     // MIs[0] round
     /* 2193960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193963 */     // MIs[0] policy
     /* 2193963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193973 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2193976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193999 */     // GIR_Coverage, 18731,
     /* 2193999 */     GIR_EraseRootFromParent_Done,
     /* 2194000 */   // Label 28863: @2194000
     /* 2194000 */   GIM_Try, /*On fail goto*//*Label 28864*/ GIMT_Encode4(2194091), // Rule ID 18734 //
     /* 2194005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2194008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2194013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2194016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2194019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2194022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2194025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194051 */     // MIs[0] round
     /* 2194051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194054 */     // MIs[0] policy
     /* 2194054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194064 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2194067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194090 */     // GIR_Coverage, 18734,
     /* 2194090 */     GIR_EraseRootFromParent_Done,
     /* 2194091 */   // Label 28864: @2194091
     /* 2194091 */   GIM_Try, /*On fail goto*//*Label 28865*/ GIMT_Encode4(2194182), // Rule ID 18735 //
     /* 2194096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2194099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2194104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2194107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2194110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2194113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2194116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194142 */     // MIs[0] round
     /* 2194142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194145 */     // MIs[0] policy
     /* 2194145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194155 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2194158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194181 */     // GIR_Coverage, 18735,
     /* 2194181 */     GIR_EraseRootFromParent_Done,
     /* 2194182 */   // Label 28865: @2194182
     /* 2194182 */   GIM_Try, /*On fail goto*//*Label 28866*/ GIMT_Encode4(2194273), // Rule ID 18738 //
     /* 2194187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2194190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2194195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2194198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2194201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2194204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2194207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2194217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2194221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194233 */     // MIs[0] round
     /* 2194233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194236 */     // MIs[0] policy
     /* 2194236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194246 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2194249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194272 */     // GIR_Coverage, 18738,
     /* 2194272 */     GIR_EraseRootFromParent_Done,
     /* 2194273 */   // Label 28866: @2194273
     /* 2194273 */   GIM_Try, /*On fail goto*//*Label 28867*/ GIMT_Encode4(2194364), // Rule ID 18739 //
     /* 2194278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2194281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2194286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2194289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2194292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2194295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2194298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2194308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2194312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194324 */     // MIs[0] round
     /* 2194324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194327 */     // MIs[0] policy
     /* 2194327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194337 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2194340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194363 */     // GIR_Coverage, 18739,
     /* 2194363 */     GIR_EraseRootFromParent_Done,
     /* 2194364 */   // Label 28867: @2194364
     /* 2194364 */   GIM_Try, /*On fail goto*//*Label 28868*/ GIMT_Encode4(2194455), // Rule ID 18742 //
     /* 2194369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2194377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2194380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2194383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2194389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2194392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194415 */     // MIs[0] round
     /* 2194415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194418 */     // MIs[0] policy
     /* 2194418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194428 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2194431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194454 */     // GIR_Coverage, 18742,
     /* 2194454 */     GIR_EraseRootFromParent_Done,
     /* 2194455 */   // Label 28868: @2194455
     /* 2194455 */   GIM_Try, /*On fail goto*//*Label 28869*/ GIMT_Encode4(2194546), // Rule ID 18743 //
     /* 2194460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2194468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2194471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2194474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2194480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2194483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194506 */     // MIs[0] round
     /* 2194506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194509 */     // MIs[0] policy
     /* 2194509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194519 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2194522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194545 */     // GIR_Coverage, 18743,
     /* 2194545 */     GIR_EraseRootFromParent_Done,
     /* 2194546 */   // Label 28869: @2194546
     /* 2194546 */   GIM_Try, /*On fail goto*//*Label 28870*/ GIMT_Encode4(2194637), // Rule ID 18746 //
     /* 2194551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2194559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2194562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2194565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2194571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194597 */     // MIs[0] round
     /* 2194597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194600 */     // MIs[0] policy
     /* 2194600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194610 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2194613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194636 */     // GIR_Coverage, 18746,
     /* 2194636 */     GIR_EraseRootFromParent_Done,
     /* 2194637 */   // Label 28870: @2194637
     /* 2194637 */   GIM_Try, /*On fail goto*//*Label 28871*/ GIMT_Encode4(2194728), // Rule ID 18747 //
     /* 2194642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2194650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2194653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2194656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2194662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194688 */     // MIs[0] round
     /* 2194688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194691 */     // MIs[0] policy
     /* 2194691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194701 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2194704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194727 */     // GIR_Coverage, 18747,
     /* 2194727 */     GIR_EraseRootFromParent_Done,
     /* 2194728 */   // Label 28871: @2194728
     /* 2194728 */   GIM_Try, /*On fail goto*//*Label 28872*/ GIMT_Encode4(2194819), // Rule ID 18750 //
     /* 2194733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2194741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2194744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2194747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2194753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194779 */     // MIs[0] round
     /* 2194779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194782 */     // MIs[0] policy
     /* 2194782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194792 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2194795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194818 */     // GIR_Coverage, 18750,
     /* 2194818 */     GIR_EraseRootFromParent_Done,
     /* 2194819 */   // Label 28872: @2194819
     /* 2194819 */   GIM_Try, /*On fail goto*//*Label 28873*/ GIMT_Encode4(2194910), // Rule ID 18751 //
     /* 2194824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2194832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2194835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2194838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2194844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194870 */     // MIs[0] round
     /* 2194870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194873 */     // MIs[0] policy
     /* 2194873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194883 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2194886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194906 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194909 */     // GIR_Coverage, 18751,
     /* 2194909 */     GIR_EraseRootFromParent_Done,
     /* 2194910 */   // Label 28873: @2194910
     /* 2194910 */   GIM_Try, /*On fail goto*//*Label 28874*/ GIMT_Encode4(2195001), // Rule ID 18754 //
     /* 2194915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2194923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2194926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2194929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2194935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194961 */     // MIs[0] round
     /* 2194961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194964 */     // MIs[0] policy
     /* 2194964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194974 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2194977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195000 */     // GIR_Coverage, 18754,
     /* 2195000 */     GIR_EraseRootFromParent_Done,
     /* 2195001 */   // Label 28874: @2195001
     /* 2195001 */   GIM_Try, /*On fail goto*//*Label 28875*/ GIMT_Encode4(2195092), // Rule ID 18755 //
     /* 2195006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2195009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2195014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2195017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2195020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2195023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2195026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2195036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2195044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195052 */     // MIs[0] round
     /* 2195052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195055 */     // MIs[0] policy
     /* 2195055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195065 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2195068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195091 */     // GIR_Coverage, 18755,
     /* 2195091 */     GIR_EraseRootFromParent_Done,
     /* 2195092 */   // Label 28875: @2195092
     /* 2195092 */   GIM_Try, /*On fail goto*//*Label 28876*/ GIMT_Encode4(2195183), // Rule ID 18758 //
     /* 2195097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2195100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2195105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2195108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2195111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2195114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2195117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2195120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2195135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195143 */     // MIs[0] round
     /* 2195143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195146 */     // MIs[0] policy
     /* 2195146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195156 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2195159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195182 */     // GIR_Coverage, 18758,
     /* 2195182 */     GIR_EraseRootFromParent_Done,
     /* 2195183 */   // Label 28876: @2195183
     /* 2195183 */   GIM_Try, /*On fail goto*//*Label 28877*/ GIMT_Encode4(2195274), // Rule ID 18759 //
     /* 2195188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2195191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2195196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2195199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2195202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2195205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2195208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2195211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2195226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195234 */     // MIs[0] round
     /* 2195234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195237 */     // MIs[0] policy
     /* 2195237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195247 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2195250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195273 */     // GIR_Coverage, 18759,
     /* 2195273 */     GIR_EraseRootFromParent_Done,
     /* 2195274 */   // Label 28877: @2195274
     /* 2195274 */   GIM_Try, /*On fail goto*//*Label 28878*/ GIMT_Encode4(2195365), // Rule ID 18762 //
     /* 2195279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2195287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2195290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2195293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2195299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195325 */     // MIs[0] round
     /* 2195325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195328 */     // MIs[0] policy
     /* 2195328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195338 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2195341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195364 */     // GIR_Coverage, 18762,
     /* 2195364 */     GIR_EraseRootFromParent_Done,
     /* 2195365 */   // Label 28878: @2195365
     /* 2195365 */   GIM_Try, /*On fail goto*//*Label 28879*/ GIMT_Encode4(2195456), // Rule ID 18763 //
     /* 2195370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2195378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2195381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2195384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2195390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195416 */     // MIs[0] round
     /* 2195416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195419 */     // MIs[0] policy
     /* 2195419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195429 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2195432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195455 */     // GIR_Coverage, 18763,
     /* 2195455 */     GIR_EraseRootFromParent_Done,
     /* 2195456 */   // Label 28879: @2195456
     /* 2195456 */   GIM_Try, /*On fail goto*//*Label 28880*/ GIMT_Encode4(2195547), // Rule ID 18766 //
     /* 2195461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2195469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2195472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2195475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2195481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195507 */     // MIs[0] round
     /* 2195507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195510 */     // MIs[0] policy
     /* 2195510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195520 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2195523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195546 */     // GIR_Coverage, 18766,
     /* 2195546 */     GIR_EraseRootFromParent_Done,
     /* 2195547 */   // Label 28880: @2195547
     /* 2195547 */   GIM_Try, /*On fail goto*//*Label 28881*/ GIMT_Encode4(2195638), // Rule ID 18767 //
     /* 2195552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2195560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2195563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2195566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2195572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195598 */     // MIs[0] round
     /* 2195598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195601 */     // MIs[0] policy
     /* 2195601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195611 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2195614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195634 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195637 */     // GIR_Coverage, 18767,
     /* 2195637 */     GIR_EraseRootFromParent_Done,
     /* 2195638 */   // Label 28881: @2195638
     /* 2195638 */   GIM_Try, /*On fail goto*//*Label 28882*/ GIMT_Encode4(2195729), // Rule ID 18770 //
     /* 2195643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2195651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2195654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2195657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2195663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2195673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195689 */     // MIs[0] round
     /* 2195689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195692 */     // MIs[0] policy
     /* 2195692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195702 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2195705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195728 */     // GIR_Coverage, 18770,
     /* 2195728 */     GIR_EraseRootFromParent_Done,
     /* 2195729 */   // Label 28882: @2195729
     /* 2195729 */   GIM_Try, /*On fail goto*//*Label 28883*/ GIMT_Encode4(2195820), // Rule ID 18771 //
     /* 2195734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2195742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2195745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2195748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2195754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195757 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2195764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195780 */     // MIs[0] round
     /* 2195780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195783 */     // MIs[0] policy
     /* 2195783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195793 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2195796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195819 */     // GIR_Coverage, 18771,
     /* 2195819 */     GIR_EraseRootFromParent_Done,
     /* 2195820 */   // Label 28883: @2195820
     /* 2195820 */   GIM_Try, /*On fail goto*//*Label 28884*/ GIMT_Encode4(2195911), // Rule ID 18774 //
     /* 2195825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2195833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2195836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2195839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2195845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195871 */     // MIs[0] round
     /* 2195871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195874 */     // MIs[0] policy
     /* 2195874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195884 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2195887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195910 */     // GIR_Coverage, 18774,
     /* 2195910 */     GIR_EraseRootFromParent_Done,
     /* 2195911 */   // Label 28884: @2195911
     /* 2195911 */   GIM_Try, /*On fail goto*//*Label 28885*/ GIMT_Encode4(2196002), // Rule ID 18775 //
     /* 2195916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2195924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2195927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2195930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2195936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195962 */     // MIs[0] round
     /* 2195962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195965 */     // MIs[0] policy
     /* 2195965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195975 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2195978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196001 */     // GIR_Coverage, 18775,
     /* 2196001 */     GIR_EraseRootFromParent_Done,
     /* 2196002 */   // Label 28885: @2196002
     /* 2196002 */   GIM_Try, /*On fail goto*//*Label 28886*/ GIMT_Encode4(2196093), // Rule ID 18778 //
     /* 2196007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2196015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2196018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2196021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2196024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2196027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196053 */     // MIs[0] round
     /* 2196053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196056 */     // MIs[0] policy
     /* 2196056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196066 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2196069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196092 */     // GIR_Coverage, 18778,
     /* 2196092 */     GIR_EraseRootFromParent_Done,
     /* 2196093 */   // Label 28886: @2196093
     /* 2196093 */   GIM_Try, /*On fail goto*//*Label 28887*/ GIMT_Encode4(2196184), // Rule ID 18779 //
     /* 2196098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2196106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2196109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2196112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2196115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2196118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196144 */     // MIs[0] round
     /* 2196144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196147 */     // MIs[0] policy
     /* 2196147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196157 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2196160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196183 */     // GIR_Coverage, 18779,
     /* 2196183 */     GIR_EraseRootFromParent_Done,
     /* 2196184 */   // Label 28887: @2196184
     /* 2196184 */   GIM_Try, /*On fail goto*//*Label 28888*/ GIMT_Encode4(2196275), // Rule ID 18782 //
     /* 2196189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2196197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2196200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2196203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2196206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2196209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2196212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196235 */     // MIs[0] round
     /* 2196235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196238 */     // MIs[0] policy
     /* 2196238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196248 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2196251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196274 */     // GIR_Coverage, 18782,
     /* 2196274 */     GIR_EraseRootFromParent_Done,
     /* 2196275 */   // Label 28888: @2196275
     /* 2196275 */   GIM_Try, /*On fail goto*//*Label 28889*/ GIMT_Encode4(2196366), // Rule ID 18783 //
     /* 2196280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2196288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2196291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2196294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2196297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2196300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2196303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196326 */     // MIs[0] round
     /* 2196326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196329 */     // MIs[0] policy
     /* 2196329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196339 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2196342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196352 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196362 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196365 */     // GIR_Coverage, 18783,
     /* 2196365 */     GIR_EraseRootFromParent_Done,
     /* 2196366 */   // Label 28889: @2196366
     /* 2196366 */   GIM_Try, /*On fail goto*//*Label 28890*/ GIMT_Encode4(2196457), // Rule ID 18786 //
     /* 2196371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2196379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2196382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2196385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2196388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2196391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2196394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2196401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196417 */     // MIs[0] round
     /* 2196417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196420 */     // MIs[0] policy
     /* 2196420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196430 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2196433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196456 */     // GIR_Coverage, 18786,
     /* 2196456 */     GIR_EraseRootFromParent_Done,
     /* 2196457 */   // Label 28890: @2196457
     /* 2196457 */   GIM_Try, /*On fail goto*//*Label 28891*/ GIMT_Encode4(2196548), // Rule ID 18787 //
     /* 2196462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2196470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2196473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2196476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2196479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2196482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2196485 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2196492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196508 */     // MIs[0] round
     /* 2196508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196511 */     // MIs[0] policy
     /* 2196511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196521 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2196524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196547 */     // GIR_Coverage, 18787,
     /* 2196547 */     GIR_EraseRootFromParent_Done,
     /* 2196548 */   // Label 28891: @2196548
     /* 2196548 */   GIM_Try, /*On fail goto*//*Label 28892*/ GIMT_Encode4(2196639), // Rule ID 18790 //
     /* 2196553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2196561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2196564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2196567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2196570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2196573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196599 */     // MIs[0] round
     /* 2196599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196602 */     // MIs[0] policy
     /* 2196602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196612 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2196615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196638 */     // GIR_Coverage, 18790,
     /* 2196638 */     GIR_EraseRootFromParent_Done,
     /* 2196639 */   // Label 28892: @2196639
     /* 2196639 */   GIM_Try, /*On fail goto*//*Label 28893*/ GIMT_Encode4(2196730), // Rule ID 18791 //
     /* 2196644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2196652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2196655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2196658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2196661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2196664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196690 */     // MIs[0] round
     /* 2196690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196693 */     // MIs[0] policy
     /* 2196693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196703 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2196706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196726 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196729 */     // GIR_Coverage, 18791,
     /* 2196729 */     GIR_EraseRootFromParent_Done,
     /* 2196730 */   // Label 28893: @2196730
     /* 2196730 */   GIM_Try, /*On fail goto*//*Label 28894*/ GIMT_Encode4(2196821), // Rule ID 18794 //
     /* 2196735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2196743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2196746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2196749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2196752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2196755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2196758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2196765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196781 */     // MIs[0] round
     /* 2196781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196784 */     // MIs[0] policy
     /* 2196784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196794 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2196797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196820 */     // GIR_Coverage, 18794,
     /* 2196820 */     GIR_EraseRootFromParent_Done,
     /* 2196821 */   // Label 28894: @2196821
     /* 2196821 */   GIM_Try, /*On fail goto*//*Label 28895*/ GIMT_Encode4(2196912), // Rule ID 18795 //
     /* 2196826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2196834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2196837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2196840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2196843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2196846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2196849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2196856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196872 */     // MIs[0] round
     /* 2196872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196875 */     // MIs[0] policy
     /* 2196875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196885 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2196888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196898 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196908 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196911 */     // GIR_Coverage, 18795,
     /* 2196911 */     GIR_EraseRootFromParent_Done,
     /* 2196912 */   // Label 28895: @2196912
     /* 2196912 */   GIM_Try, /*On fail goto*//*Label 28896*/ GIMT_Encode4(2197003), // Rule ID 18798 //
     /* 2196917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2196920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2196925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2196928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2196931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2196934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2196937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196963 */     // MIs[0] round
     /* 2196963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196966 */     // MIs[0] policy
     /* 2196966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196976 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2196979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197002 */     // GIR_Coverage, 18798,
     /* 2197002 */     GIR_EraseRootFromParent_Done,
     /* 2197003 */   // Label 28896: @2197003
     /* 2197003 */   GIM_Try, /*On fail goto*//*Label 28897*/ GIMT_Encode4(2197094), // Rule ID 18799 //
     /* 2197008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2197011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2197016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2197019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2197022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2197025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2197028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2197031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197054 */     // MIs[0] round
     /* 2197054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197057 */     // MIs[0] policy
     /* 2197057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197067 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2197070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197093 */     // GIR_Coverage, 18799,
     /* 2197093 */     GIR_EraseRootFromParent_Done,
     /* 2197094 */   // Label 28897: @2197094
     /* 2197094 */   GIM_Try, /*On fail goto*//*Label 28898*/ GIMT_Encode4(2197185), // Rule ID 18802 //
     /* 2197099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2197102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2197107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2197110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2197113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2197116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2197119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2197129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197145 */     // MIs[0] round
     /* 2197145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197148 */     // MIs[0] policy
     /* 2197148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197158 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2197161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197181 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197184 */     // GIR_Coverage, 18802,
     /* 2197184 */     GIR_EraseRootFromParent_Done,
     /* 2197185 */   // Label 28898: @2197185
     /* 2197185 */   GIM_Try, /*On fail goto*//*Label 28899*/ GIMT_Encode4(2197276), // Rule ID 18803 //
     /* 2197190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2197193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2197198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2197201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2197204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2197207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2197210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2197220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197236 */     // MIs[0] round
     /* 2197236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197239 */     // MIs[0] policy
     /* 2197239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197249 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2197252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197275 */     // GIR_Coverage, 18803,
     /* 2197275 */     GIR_EraseRootFromParent_Done,
     /* 2197276 */   // Label 28899: @2197276
     /* 2197276 */   GIM_Try, /*On fail goto*//*Label 28900*/ GIMT_Encode4(2197367), // Rule ID 18806 //
     /* 2197281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2197284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2197289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2197292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2197295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2197298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2197301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2197304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2197311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197327 */     // MIs[0] round
     /* 2197327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197330 */     // MIs[0] policy
     /* 2197330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197340 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2197343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197366 */     // GIR_Coverage, 18806,
     /* 2197366 */     GIR_EraseRootFromParent_Done,
     /* 2197367 */   // Label 28900: @2197367
     /* 2197367 */   GIM_Try, /*On fail goto*//*Label 28901*/ GIMT_Encode4(2197458), // Rule ID 18807 //
     /* 2197372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2197375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2197380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2197383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2197386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2197389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2197392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2197395 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2197402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197418 */     // MIs[0] round
     /* 2197418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197421 */     // MIs[0] policy
     /* 2197421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197431 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2197434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197457 */     // GIR_Coverage, 18807,
     /* 2197457 */     GIR_EraseRootFromParent_Done,
     /* 2197458 */   // Label 28901: @2197458
     /* 2197458 */   GIM_Try, /*On fail goto*//*Label 28902*/ GIMT_Encode4(2197549), // Rule ID 18810 //
     /* 2197463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2197466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2197471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2197474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2197477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2197480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2197483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2197486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2197493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197509 */     // MIs[0] round
     /* 2197509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197512 */     // MIs[0] policy
     /* 2197512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197522 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2197525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197548 */     // GIR_Coverage, 18810,
     /* 2197548 */     GIR_EraseRootFromParent_Done,
     /* 2197549 */   // Label 28902: @2197549
     /* 2197549 */   GIM_Try, /*On fail goto*//*Label 28903*/ GIMT_Encode4(2197640), // Rule ID 18811 //
     /* 2197554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2197557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2197562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2197565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2197568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2197571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2197574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2197577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2197584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197600 */     // MIs[0] round
     /* 2197600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197603 */     // MIs[0] policy
     /* 2197603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197613 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2197616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197639 */     // GIR_Coverage, 18811,
     /* 2197639 */     GIR_EraseRootFromParent_Done,
     /* 2197640 */   // Label 28903: @2197640
     /* 2197640 */   GIM_Try, /*On fail goto*//*Label 28904*/ GIMT_Encode4(2197731), // Rule ID 18814 //
     /* 2197645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2197653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2197656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2197659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2197665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2197668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197691 */     // MIs[0] round
     /* 2197691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197694 */     // MIs[0] policy
     /* 2197694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197704 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2197707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197730 */     // GIR_Coverage, 18814,
     /* 2197730 */     GIR_EraseRootFromParent_Done,
     /* 2197731 */   // Label 28904: @2197731
     /* 2197731 */   GIM_Try, /*On fail goto*//*Label 28905*/ GIMT_Encode4(2197822), // Rule ID 18815 //
     /* 2197736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2197744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2197747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2197750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2197756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2197759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197782 */     // MIs[0] round
     /* 2197782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197785 */     // MIs[0] policy
     /* 2197785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197795 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2197798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197821 */     // GIR_Coverage, 18815,
     /* 2197821 */     GIR_EraseRootFromParent_Done,
     /* 2197822 */   // Label 28905: @2197822
     /* 2197822 */   GIM_Try, /*On fail goto*//*Label 28906*/ GIMT_Encode4(2197913), // Rule ID 18818 //
     /* 2197827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2197835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2197838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2197841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2197847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197873 */     // MIs[0] round
     /* 2197873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197876 */     // MIs[0] policy
     /* 2197876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197886 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2197889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197912 */     // GIR_Coverage, 18818,
     /* 2197912 */     GIR_EraseRootFromParent_Done,
     /* 2197913 */   // Label 28906: @2197913
     /* 2197913 */   GIM_Try, /*On fail goto*//*Label 28907*/ GIMT_Encode4(2198004), // Rule ID 18819 //
     /* 2197918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2197926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2197929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2197932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2197938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197964 */     // MIs[0] round
     /* 2197964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197967 */     // MIs[0] policy
     /* 2197967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197977 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2197980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197990 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198000 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198003 */     // GIR_Coverage, 18819,
     /* 2198003 */     GIR_EraseRootFromParent_Done,
     /* 2198004 */   // Label 28907: @2198004
     /* 2198004 */   GIM_Try, /*On fail goto*//*Label 28908*/ GIMT_Encode4(2198095), // Rule ID 18822 //
     /* 2198009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2198012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2198017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2198020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2198023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2198029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2198032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198055 */     // MIs[0] round
     /* 2198055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198058 */     // MIs[0] policy
     /* 2198058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198068 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2198071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198094 */     // GIR_Coverage, 18822,
     /* 2198094 */     GIR_EraseRootFromParent_Done,
     /* 2198095 */   // Label 28908: @2198095
     /* 2198095 */   GIM_Try, /*On fail goto*//*Label 28909*/ GIMT_Encode4(2198186), // Rule ID 18823 //
     /* 2198100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2198103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2198108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2198111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2198114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2198120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2198123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198146 */     // MIs[0] round
     /* 2198146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198149 */     // MIs[0] policy
     /* 2198149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198159 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2198162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198185 */     // GIR_Coverage, 18823,
     /* 2198185 */     GIR_EraseRootFromParent_Done,
     /* 2198186 */   // Label 28909: @2198186
     /* 2198186 */   GIM_Try, /*On fail goto*//*Label 28910*/ GIMT_Encode4(2198277), // Rule ID 18826 //
     /* 2198191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2198194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2198199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2198202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2198205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2198211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2198214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198237 */     // MIs[0] round
     /* 2198237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198240 */     // MIs[0] policy
     /* 2198240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198250 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2198253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198276 */     // GIR_Coverage, 18826,
     /* 2198276 */     GIR_EraseRootFromParent_Done,
     /* 2198277 */   // Label 28910: @2198277
     /* 2198277 */   GIM_Try, /*On fail goto*//*Label 28911*/ GIMT_Encode4(2198368), // Rule ID 18827 //
     /* 2198282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2198285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2198290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2198293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2198296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2198302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2198305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198328 */     // MIs[0] round
     /* 2198328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198331 */     // MIs[0] policy
     /* 2198331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198341 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2198344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198367 */     // GIR_Coverage, 18827,
     /* 2198367 */     GIR_EraseRootFromParent_Done,
     /* 2198368 */   // Label 28911: @2198368
     /* 2198368 */   GIM_Try, /*On fail goto*//*Label 28912*/ GIMT_Encode4(2198459), // Rule ID 18830 //
     /* 2198373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2198376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2198381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2198384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2198387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2198393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2198396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2198403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2198407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198419 */     // MIs[0] round
     /* 2198419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198422 */     // MIs[0] policy
     /* 2198422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198432 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2198435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198458 */     // GIR_Coverage, 18830,
     /* 2198458 */     GIR_EraseRootFromParent_Done,
     /* 2198459 */   // Label 28912: @2198459
     /* 2198459 */   GIM_Try, /*On fail goto*//*Label 28913*/ GIMT_Encode4(2198550), // Rule ID 18831 //
     /* 2198464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2198467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2198472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2198475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2198478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2198484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2198487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2198494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2198498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198510 */     // MIs[0] round
     /* 2198510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198513 */     // MIs[0] policy
     /* 2198513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198523 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2198526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198549 */     // GIR_Coverage, 18831,
     /* 2198549 */     GIR_EraseRootFromParent_Done,
     /* 2198550 */   // Label 28913: @2198550
     /* 2198550 */   GIM_Try, /*On fail goto*//*Label 28914*/ GIMT_Encode4(2198641), // Rule ID 18834 //
     /* 2198555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2198563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2198566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2198569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2198575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198601 */     // MIs[0] round
     /* 2198601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198604 */     // MIs[0] policy
     /* 2198604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198614 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2198617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198640 */     // GIR_Coverage, 18834,
     /* 2198640 */     GIR_EraseRootFromParent_Done,
     /* 2198641 */   // Label 28914: @2198641
     /* 2198641 */   GIM_Try, /*On fail goto*//*Label 28915*/ GIMT_Encode4(2198732), // Rule ID 18835 //
     /* 2198646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2198654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2198657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2198660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2198666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198692 */     // MIs[0] round
     /* 2198692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198695 */     // MIs[0] policy
     /* 2198695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198705 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2198708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198731 */     // GIR_Coverage, 18835,
     /* 2198731 */     GIR_EraseRootFromParent_Done,
     /* 2198732 */   // Label 28915: @2198732
     /* 2198732 */   GIM_Try, /*On fail goto*//*Label 28916*/ GIMT_Encode4(2198823), // Rule ID 18838 //
     /* 2198737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2198745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2198748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2198751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2198757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2198760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198783 */     // MIs[0] round
     /* 2198783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198786 */     // MIs[0] policy
     /* 2198786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198796 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2198799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198822 */     // GIR_Coverage, 18838,
     /* 2198822 */     GIR_EraseRootFromParent_Done,
     /* 2198823 */   // Label 28916: @2198823
     /* 2198823 */   GIM_Try, /*On fail goto*//*Label 28917*/ GIMT_Encode4(2198914), // Rule ID 18839 //
     /* 2198828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2198836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2198839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2198842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2198848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2198851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198874 */     // MIs[0] round
     /* 2198874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198877 */     // MIs[0] policy
     /* 2198877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198887 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2198890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198913 */     // GIR_Coverage, 18839,
     /* 2198913 */     GIR_EraseRootFromParent_Done,
     /* 2198914 */   // Label 28917: @2198914
     /* 2198914 */   GIM_Try, /*On fail goto*//*Label 28918*/ GIMT_Encode4(2199005), // Rule ID 18842 //
     /* 2198919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2198927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2198930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2198933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2198939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2198942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198965 */     // MIs[0] round
     /* 2198965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198968 */     // MIs[0] policy
     /* 2198968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198978 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2198981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199004 */     // GIR_Coverage, 18842,
     /* 2199004 */     GIR_EraseRootFromParent_Done,
     /* 2199005 */   // Label 28918: @2199005
     /* 2199005 */   GIM_Try, /*On fail goto*//*Label 28919*/ GIMT_Encode4(2199096), // Rule ID 18843 //
     /* 2199010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2199013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2199018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2199021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2199024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2199027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2199030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2199033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2199040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2199048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199056 */     // MIs[0] round
     /* 2199056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199059 */     // MIs[0] policy
     /* 2199059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199069 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2199072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199095 */     // GIR_Coverage, 18843,
     /* 2199095 */     GIR_EraseRootFromParent_Done,
     /* 2199096 */   // Label 28919: @2199096
     /* 2199096 */   GIM_Try, /*On fail goto*//*Label 28920*/ GIMT_Encode4(2199187), // Rule ID 18846 //
     /* 2199101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2199104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2199109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2199112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2199115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2199118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2199121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2199131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2199135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2199139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199147 */     // MIs[0] round
     /* 2199147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199150 */     // MIs[0] policy
     /* 2199150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199160 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2199163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199186 */     // GIR_Coverage, 18846,
     /* 2199186 */     GIR_EraseRootFromParent_Done,
     /* 2199187 */   // Label 28920: @2199187
     /* 2199187 */   GIM_Try, /*On fail goto*//*Label 28921*/ GIMT_Encode4(2199278), // Rule ID 18847 //
     /* 2199192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2199195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2199200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2199203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2199206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2199209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2199212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2199222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2199226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2199230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199238 */     // MIs[0] round
     /* 2199238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199241 */     // MIs[0] policy
     /* 2199241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199251 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2199254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199264 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199274 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199277 */     // GIR_Coverage, 18847,
     /* 2199277 */     GIR_EraseRootFromParent_Done,
     /* 2199278 */   // Label 28921: @2199278
     /* 2199278 */   GIM_Try, /*On fail goto*//*Label 28922*/ GIMT_Encode4(2199369), // Rule ID 18850 //
     /* 2199283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2199291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2199294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2199297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2199300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2199303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2199306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199329 */     // MIs[0] round
     /* 2199329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199332 */     // MIs[0] policy
     /* 2199332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199342 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2199345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199368 */     // GIR_Coverage, 18850,
     /* 2199368 */     GIR_EraseRootFromParent_Done,
     /* 2199369 */   // Label 28922: @2199369
     /* 2199369 */   GIM_Try, /*On fail goto*//*Label 28923*/ GIMT_Encode4(2199460), // Rule ID 18851 //
     /* 2199374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2199382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2199385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2199388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2199391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2199394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2199397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199420 */     // MIs[0] round
     /* 2199420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199423 */     // MIs[0] policy
     /* 2199423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199433 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2199436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199456 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199459 */     // GIR_Coverage, 18851,
     /* 2199459 */     GIR_EraseRootFromParent_Done,
     /* 2199460 */   // Label 28923: @2199460
     /* 2199460 */   GIM_Try, /*On fail goto*//*Label 28924*/ GIMT_Encode4(2199551), // Rule ID 18854 //
     /* 2199465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2199473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2199476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2199479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2199482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2199485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2199488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199511 */     // MIs[0] round
     /* 2199511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199514 */     // MIs[0] policy
     /* 2199514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2199527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199550 */     // GIR_Coverage, 18854,
     /* 2199550 */     GIR_EraseRootFromParent_Done,
     /* 2199551 */   // Label 28924: @2199551
     /* 2199551 */   GIM_Try, /*On fail goto*//*Label 28925*/ GIMT_Encode4(2199642), // Rule ID 18855 //
     /* 2199556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2199564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2199567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2199570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2199573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2199576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2199579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199602 */     // MIs[0] round
     /* 2199602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199605 */     // MIs[0] policy
     /* 2199605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199615 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2199618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199641 */     // GIR_Coverage, 18855,
     /* 2199641 */     GIR_EraseRootFromParent_Done,
     /* 2199642 */   // Label 28925: @2199642
     /* 2199642 */   GIM_Try, /*On fail goto*//*Label 28926*/ GIMT_Encode4(2199733), // Rule ID 18858 //
     /* 2199647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2199655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2199658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2199661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2199664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2199667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2199670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199693 */     // MIs[0] round
     /* 2199693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199696 */     // MIs[0] policy
     /* 2199696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199706 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2199709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199732 */     // GIR_Coverage, 18858,
     /* 2199732 */     GIR_EraseRootFromParent_Done,
     /* 2199733 */   // Label 28926: @2199733
     /* 2199733 */   GIM_Try, /*On fail goto*//*Label 28927*/ GIMT_Encode4(2199824), // Rule ID 18859 //
     /* 2199738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2199746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2199749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2199752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2199755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2199758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2199761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199784 */     // MIs[0] round
     /* 2199784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199787 */     // MIs[0] policy
     /* 2199787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199797 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2199800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199823 */     // GIR_Coverage, 18859,
     /* 2199823 */     GIR_EraseRootFromParent_Done,
     /* 2199824 */   // Label 28927: @2199824
     /* 2199824 */   GIM_Try, /*On fail goto*//*Label 28928*/ GIMT_Encode4(2199915), // Rule ID 18862 //
     /* 2199829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2199837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2199840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2199843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2199846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2199849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2199859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199875 */     // MIs[0] round
     /* 2199875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199878 */     // MIs[0] policy
     /* 2199878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199888 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2199891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199914 */     // GIR_Coverage, 18862,
     /* 2199914 */     GIR_EraseRootFromParent_Done,
     /* 2199915 */   // Label 28928: @2199915
     /* 2199915 */   GIM_Try, /*On fail goto*//*Label 28929*/ GIMT_Encode4(2200006), // Rule ID 18863 //
     /* 2199920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2199928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2199931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2199934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2199937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2199940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2199950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199966 */     // MIs[0] round
     /* 2199966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199969 */     // MIs[0] policy
     /* 2199969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199979 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2199982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200005 */     // GIR_Coverage, 18863,
     /* 2200005 */     GIR_EraseRootFromParent_Done,
     /* 2200006 */   // Label 28929: @2200006
     /* 2200006 */   GIM_Try, /*On fail goto*//*Label 28930*/ GIMT_Encode4(2200097), // Rule ID 18866 //
     /* 2200011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2200014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2200019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2200022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2200025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2200028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2200031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2200034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200057 */     // MIs[0] round
     /* 2200057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200060 */     // MIs[0] policy
     /* 2200060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200070 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2200073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200096 */     // GIR_Coverage, 18866,
     /* 2200096 */     GIR_EraseRootFromParent_Done,
     /* 2200097 */   // Label 28930: @2200097
     /* 2200097 */   GIM_Try, /*On fail goto*//*Label 28931*/ GIMT_Encode4(2200188), // Rule ID 18867 //
     /* 2200102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2200105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2200110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2200113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2200116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2200119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2200122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2200125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200148 */     // MIs[0] round
     /* 2200148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200151 */     // MIs[0] policy
     /* 2200151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200161 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2200164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200174 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200184 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200187 */     // GIR_Coverage, 18867,
     /* 2200187 */     GIR_EraseRootFromParent_Done,
     /* 2200188 */   // Label 28931: @2200188
     /* 2200188 */   GIM_Try, /*On fail goto*//*Label 28932*/ GIMT_Encode4(2200279), // Rule ID 18870 //
     /* 2200193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2200201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2200204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2200207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2200210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2200213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200239 */     // MIs[0] round
     /* 2200239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200242 */     // MIs[0] policy
     /* 2200242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200252 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2200255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200278 */     // GIR_Coverage, 18870,
     /* 2200278 */     GIR_EraseRootFromParent_Done,
     /* 2200279 */   // Label 28932: @2200279
     /* 2200279 */   GIM_Try, /*On fail goto*//*Label 28933*/ GIMT_Encode4(2200370), // Rule ID 18871 //
     /* 2200284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2200292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2200295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2200298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2200301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2200304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200330 */     // MIs[0] round
     /* 2200330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200333 */     // MIs[0] policy
     /* 2200333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200343 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2200346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200369 */     // GIR_Coverage, 18871,
     /* 2200369 */     GIR_EraseRootFromParent_Done,
     /* 2200370 */   // Label 28933: @2200370
     /* 2200370 */   GIM_Try, /*On fail goto*//*Label 28934*/ GIMT_Encode4(2200461), // Rule ID 18874 //
     /* 2200375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2200383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2200386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2200389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2200392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2200395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2200398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2200405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200421 */     // MIs[0] round
     /* 2200421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200424 */     // MIs[0] policy
     /* 2200424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200434 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2200437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200460 */     // GIR_Coverage, 18874,
     /* 2200460 */     GIR_EraseRootFromParent_Done,
     /* 2200461 */   // Label 28934: @2200461
     /* 2200461 */   GIM_Try, /*On fail goto*//*Label 28935*/ GIMT_Encode4(2200552), // Rule ID 18875 //
     /* 2200466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2200474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2200477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2200480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2200483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2200486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2200489 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2200496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200512 */     // MIs[0] round
     /* 2200512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200515 */     // MIs[0] policy
     /* 2200515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200525 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2200528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200551 */     // GIR_Coverage, 18875,
     /* 2200551 */     GIR_EraseRootFromParent_Done,
     /* 2200552 */   // Label 28935: @2200552
     /* 2200552 */   GIM_Try, /*On fail goto*//*Label 28936*/ GIMT_Encode4(2200643), // Rule ID 18878 //
     /* 2200557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2200565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2200568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2200571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2200574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2200577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2200587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200603 */     // MIs[0] round
     /* 2200603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200606 */     // MIs[0] policy
     /* 2200606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200616 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2200619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200642 */     // GIR_Coverage, 18878,
     /* 2200642 */     GIR_EraseRootFromParent_Done,
     /* 2200643 */   // Label 28936: @2200643
     /* 2200643 */   GIM_Try, /*On fail goto*//*Label 28937*/ GIMT_Encode4(2200734), // Rule ID 18879 //
     /* 2200648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2200656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2200659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2200662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2200665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2200668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2200678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200694 */     // MIs[0] round
     /* 2200694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200697 */     // MIs[0] policy
     /* 2200697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200707 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2200710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200733 */     // GIR_Coverage, 18879,
     /* 2200733 */     GIR_EraseRootFromParent_Done,
     /* 2200734 */   // Label 28937: @2200734
     /* 2200734 */   GIM_Try, /*On fail goto*//*Label 28938*/ GIMT_Encode4(2200825), // Rule ID 18882 //
     /* 2200739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2200747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2200750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2200753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2200756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2200759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2200762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200785 */     // MIs[0] round
     /* 2200785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200788 */     // MIs[0] policy
     /* 2200788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200798 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2200801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200824 */     // GIR_Coverage, 18882,
     /* 2200824 */     GIR_EraseRootFromParent_Done,
     /* 2200825 */   // Label 28938: @2200825
     /* 2200825 */   GIM_Try, /*On fail goto*//*Label 28939*/ GIMT_Encode4(2200916), // Rule ID 18883 //
     /* 2200830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2200838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2200841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2200844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2200847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2200850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2200853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200876 */     // MIs[0] round
     /* 2200876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200879 */     // MIs[0] policy
     /* 2200879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200889 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2200892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200915 */     // GIR_Coverage, 18883,
     /* 2200915 */     GIR_EraseRootFromParent_Done,
     /* 2200916 */   // Label 28939: @2200916
     /* 2200916 */   GIM_Try, /*On fail goto*//*Label 28940*/ GIMT_Encode4(2201007), // Rule ID 18886 //
     /* 2200921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2200924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2200929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2200932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2200935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2200941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200967 */     // MIs[0] round
     /* 2200967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200970 */     // MIs[0] policy
     /* 2200970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200980 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2200983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201006 */     // GIR_Coverage, 18886,
     /* 2201006 */     GIR_EraseRootFromParent_Done,
     /* 2201007 */   // Label 28940: @2201007
     /* 2201007 */   GIM_Try, /*On fail goto*//*Label 28941*/ GIMT_Encode4(2201098), // Rule ID 18887 //
     /* 2201012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2201020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2201023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2201026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2201032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2201035 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201058 */     // MIs[0] round
     /* 2201058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201061 */     // MIs[0] policy
     /* 2201061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201071 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2201074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201097 */     // GIR_Coverage, 18887,
     /* 2201097 */     GIR_EraseRootFromParent_Done,
     /* 2201098 */   // Label 28941: @2201098
     /* 2201098 */   GIM_Try, /*On fail goto*//*Label 28942*/ GIMT_Encode4(2201189), // Rule ID 18890 //
     /* 2201103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2201111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2201114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2201117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2201123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2201126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201149 */     // MIs[0] round
     /* 2201149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201152 */     // MIs[0] policy
     /* 2201152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201162 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2201165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201188 */     // GIR_Coverage, 18890,
     /* 2201188 */     GIR_EraseRootFromParent_Done,
     /* 2201189 */   // Label 28942: @2201189
     /* 2201189 */   GIM_Try, /*On fail goto*//*Label 28943*/ GIMT_Encode4(2201280), // Rule ID 18891 //
     /* 2201194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2201202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2201205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2201208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2201214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2201217 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201240 */     // MIs[0] round
     /* 2201240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201243 */     // MIs[0] policy
     /* 2201243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201253 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2201256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201276 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201279 */     // GIR_Coverage, 18891,
     /* 2201279 */     GIR_EraseRootFromParent_Done,
     /* 2201280 */   // Label 28943: @2201280
     /* 2201280 */   GIM_Try, /*On fail goto*//*Label 28944*/ GIMT_Encode4(2201371), // Rule ID 18894 //
     /* 2201285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2201293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2201296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2201299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2201305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2201308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2201315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201331 */     // MIs[0] round
     /* 2201331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201334 */     // MIs[0] policy
     /* 2201334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201344 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2201347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201370 */     // GIR_Coverage, 18894,
     /* 2201370 */     GIR_EraseRootFromParent_Done,
     /* 2201371 */   // Label 28944: @2201371
     /* 2201371 */   GIM_Try, /*On fail goto*//*Label 28945*/ GIMT_Encode4(2201462), // Rule ID 18895 //
     /* 2201376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2201384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2201387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2201390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2201396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2201399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2201406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201422 */     // MIs[0] round
     /* 2201422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201425 */     // MIs[0] policy
     /* 2201425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201435 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2201438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201461 */     // GIR_Coverage, 18895,
     /* 2201461 */     GIR_EraseRootFromParent_Done,
     /* 2201462 */   // Label 28945: @2201462
     /* 2201462 */   GIM_Try, /*On fail goto*//*Label 28946*/ GIMT_Encode4(2201553), // Rule ID 18898 //
     /* 2201467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2201475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2201478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2201481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2201487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2201490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2201497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201513 */     // MIs[0] round
     /* 2201513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201516 */     // MIs[0] policy
     /* 2201516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201526 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2201529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201552 */     // GIR_Coverage, 18898,
     /* 2201552 */     GIR_EraseRootFromParent_Done,
     /* 2201553 */   // Label 28946: @2201553
     /* 2201553 */   GIM_Try, /*On fail goto*//*Label 28947*/ GIMT_Encode4(2201644), // Rule ID 18899 //
     /* 2201558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2201566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2201569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2201572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2201578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2201581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2201588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201604 */     // MIs[0] round
     /* 2201604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201607 */     // MIs[0] policy
     /* 2201607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201617 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2201620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201643 */     // GIR_Coverage, 18899,
     /* 2201643 */     GIR_EraseRootFromParent_Done,
     /* 2201644 */   // Label 28947: @2201644
     /* 2201644 */   GIM_Try, /*On fail goto*//*Label 28948*/ GIMT_Encode4(2201735), // Rule ID 18902 //
     /* 2201649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2201657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2201660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2201663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2201669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2201672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201695 */     // MIs[0] round
     /* 2201695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201698 */     // MIs[0] policy
     /* 2201698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201708 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2201711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201734 */     // GIR_Coverage, 18902,
     /* 2201734 */     GIR_EraseRootFromParent_Done,
     /* 2201735 */   // Label 28948: @2201735
     /* 2201735 */   GIM_Try, /*On fail goto*//*Label 28949*/ GIMT_Encode4(2201826), // Rule ID 18903 //
     /* 2201740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2201748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2201751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2201754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2201760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2201763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201786 */     // MIs[0] round
     /* 2201786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201789 */     // MIs[0] policy
     /* 2201789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201799 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2201802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201825 */     // GIR_Coverage, 18903,
     /* 2201825 */     GIR_EraseRootFromParent_Done,
     /* 2201826 */   // Label 28949: @2201826
     /* 2201826 */   GIM_Try, /*On fail goto*//*Label 28950*/ GIMT_Encode4(2201917), // Rule ID 18906 //
     /* 2201831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2201834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2201839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2201842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2201845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2201851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2201854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201877 */     // MIs[0] round
     /* 2201877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201880 */     // MIs[0] policy
     /* 2201880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201890 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2201893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201916 */     // GIR_Coverage, 18906,
     /* 2201916 */     GIR_EraseRootFromParent_Done,
     /* 2201917 */   // Label 28950: @2201917
     /* 2201917 */   GIM_Try, /*On fail goto*//*Label 28951*/ GIMT_Encode4(2202008), // Rule ID 18907 //
     /* 2201922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2201925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2201930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2201933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2201936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2201942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2201945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201968 */     // MIs[0] round
     /* 2201968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201971 */     // MIs[0] policy
     /* 2201971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201981 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2201984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202007 */     // GIR_Coverage, 18907,
     /* 2202007 */     GIR_EraseRootFromParent_Done,
     /* 2202008 */   // Label 28951: @2202008
     /* 2202008 */   GIM_Try, /*On fail goto*//*Label 28952*/ GIMT_Encode4(2202099), // Rule ID 18910 //
     /* 2202013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2202016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2202021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2202024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2202027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2202033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2202043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202059 */     // MIs[0] round
     /* 2202059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202062 */     // MIs[0] policy
     /* 2202062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202072 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2202075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202098 */     // GIR_Coverage, 18910,
     /* 2202098 */     GIR_EraseRootFromParent_Done,
     /* 2202099 */   // Label 28952: @2202099
     /* 2202099 */   GIM_Try, /*On fail goto*//*Label 28953*/ GIMT_Encode4(2202190), // Rule ID 18911 //
     /* 2202104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2202107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2202112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2202115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2202118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2202124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2202134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202150 */     // MIs[0] round
     /* 2202150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202153 */     // MIs[0] policy
     /* 2202153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202163 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2202166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202189 */     // GIR_Coverage, 18911,
     /* 2202189 */     GIR_EraseRootFromParent_Done,
     /* 2202190 */   // Label 28953: @2202190
     /* 2202190 */   GIM_Try, /*On fail goto*//*Label 28954*/ GIMT_Encode4(2202281), // Rule ID 18914 //
     /* 2202195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2202198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2202203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2202206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2202209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2202215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2202225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202241 */     // MIs[0] round
     /* 2202241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202244 */     // MIs[0] policy
     /* 2202244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202254 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2202257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202280 */     // GIR_Coverage, 18914,
     /* 2202280 */     GIR_EraseRootFromParent_Done,
     /* 2202281 */   // Label 28954: @2202281
     /* 2202281 */   GIM_Try, /*On fail goto*//*Label 28955*/ GIMT_Encode4(2202372), // Rule ID 18915 //
     /* 2202286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2202289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2202294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2202297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2202300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2202306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2202316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202332 */     // MIs[0] round
     /* 2202332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202335 */     // MIs[0] policy
     /* 2202335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202345 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2202348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202371 */     // GIR_Coverage, 18915,
     /* 2202371 */     GIR_EraseRootFromParent_Done,
     /* 2202372 */   // Label 28955: @2202372
     /* 2202372 */   GIM_Try, /*On fail goto*//*Label 28956*/ GIMT_Encode4(2202463), // Rule ID 18918 //
     /* 2202377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2202380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2202385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2202388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2202391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2202397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2202400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2202407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202423 */     // MIs[0] round
     /* 2202423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202426 */     // MIs[0] policy
     /* 2202426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202436 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2202439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202462 */     // GIR_Coverage, 18918,
     /* 2202462 */     GIR_EraseRootFromParent_Done,
     /* 2202463 */   // Label 28956: @2202463
     /* 2202463 */   GIM_Try, /*On fail goto*//*Label 28957*/ GIMT_Encode4(2202554), // Rule ID 18919 //
     /* 2202468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2202471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2202476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2202479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2202482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2202488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2202491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2202498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202514 */     // MIs[0] round
     /* 2202514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202517 */     // MIs[0] policy
     /* 2202517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202527 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2202530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202553 */     // GIR_Coverage, 18919,
     /* 2202553 */     GIR_EraseRootFromParent_Done,
     /* 2202554 */   // Label 28957: @2202554
     /* 2202554 */   GIM_Try, /*On fail goto*//*Label 28958*/ GIMT_Encode4(2202645), // Rule ID 18922 //
     /* 2202559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2202562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2202570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2202573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2202576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2202579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2202582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202605 */     // MIs[0] round
     /* 2202605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202608 */     // MIs[0] policy
     /* 2202608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202618 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2202621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202644 */     // GIR_Coverage, 18922,
     /* 2202644 */     GIR_EraseRootFromParent_Done,
     /* 2202645 */   // Label 28958: @2202645
     /* 2202645 */   GIM_Try, /*On fail goto*//*Label 28959*/ GIMT_Encode4(2202736), // Rule ID 18923 //
     /* 2202650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2202653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2202661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2202664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2202667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2202670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2202673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202696 */     // MIs[0] round
     /* 2202696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202699 */     // MIs[0] policy
     /* 2202699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202709 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2202712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202735 */     // GIR_Coverage, 18923,
     /* 2202735 */     GIR_EraseRootFromParent_Done,
     /* 2202736 */   // Label 28959: @2202736
     /* 2202736 */   GIM_Try, /*On fail goto*//*Label 28960*/ GIMT_Encode4(2202827), // Rule ID 18926 //
     /* 2202741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2202744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2202752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2202755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2202758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2202761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202787 */     // MIs[0] round
     /* 2202787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202790 */     // MIs[0] policy
     /* 2202790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202800 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2202803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202826 */     // GIR_Coverage, 18926,
     /* 2202826 */     GIR_EraseRootFromParent_Done,
     /* 2202827 */   // Label 28960: @2202827
     /* 2202827 */   GIM_Try, /*On fail goto*//*Label 28961*/ GIMT_Encode4(2202918), // Rule ID 18927 //
     /* 2202832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2202835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2202843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2202846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2202849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2202852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202878 */     // MIs[0] round
     /* 2202878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202881 */     // MIs[0] policy
     /* 2202881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202891 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2202894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202917 */     // GIR_Coverage, 18927,
     /* 2202917 */     GIR_EraseRootFromParent_Done,
     /* 2202918 */   // Label 28961: @2202918
     /* 2202918 */   GIM_Try, /*On fail goto*//*Label 28962*/ GIMT_Encode4(2203009), // Rule ID 18930 //
     /* 2202923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2202926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2202934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2202937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2202940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2202943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2202953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202969 */     // MIs[0] round
     /* 2202969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202972 */     // MIs[0] policy
     /* 2202972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202982 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2202985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203008 */     // GIR_Coverage, 18930,
     /* 2203008 */     GIR_EraseRootFromParent_Done,
     /* 2203009 */   // Label 28962: @2203009
     /* 2203009 */   GIM_Try, /*On fail goto*//*Label 28963*/ GIMT_Encode4(2203100), // Rule ID 18931 //
     /* 2203014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2203017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2203022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2203025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2203028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2203031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2203034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2203037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2203044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203060 */     // MIs[0] round
     /* 2203060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203063 */     // MIs[0] policy
     /* 2203063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203073 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2203076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2203080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203099 */     // GIR_Coverage, 18931,
     /* 2203099 */     GIR_EraseRootFromParent_Done,
     /* 2203100 */   // Label 28963: @2203100
     /* 2203100 */   GIM_Try, /*On fail goto*//*Label 28964*/ GIMT_Encode4(2203191), // Rule ID 18934 //
     /* 2203105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2203108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2203113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2203116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2203119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2203122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2203125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2203128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2203135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203151 */     // MIs[0] round
     /* 2203151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203154 */     // MIs[0] policy
     /* 2203154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203164 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2203167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2203171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203190 */     // GIR_Coverage, 18934,
     /* 2203190 */     GIR_EraseRootFromParent_Done,
     /* 2203191 */   // Label 28964: @2203191
     /* 2203191 */   GIM_Try, /*On fail goto*//*Label 28965*/ GIMT_Encode4(2203282), // Rule ID 18935 //
     /* 2203196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2203199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2203204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2203207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2203210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2203213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2203216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2203219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2203226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203242 */     // MIs[0] round
     /* 2203242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203245 */     // MIs[0] policy
     /* 2203245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203255 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2203258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2203262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203281 */     // GIR_Coverage, 18935,
     /* 2203281 */     GIR_EraseRootFromParent_Done,
     /* 2203282 */   // Label 28965: @2203282
     /* 2203282 */   GIM_Try, /*On fail goto*//*Label 28966*/ GIMT_Encode4(2203373), // Rule ID 18938 //
     /* 2203287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2203290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2203295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2203298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2203301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2203304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2203307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2203310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2203317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203333 */     // MIs[0] round
     /* 2203333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203336 */     // MIs[0] policy
     /* 2203336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203346 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2203349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2203353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203372 */     // GIR_Coverage, 18938,
     /* 2203372 */     GIR_EraseRootFromParent_Done,
     /* 2203373 */   // Label 28966: @2203373
     /* 2203373 */   GIM_Try, /*On fail goto*//*Label 28967*/ GIMT_Encode4(2203464), // Rule ID 18939 //
     /* 2203378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2203381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2203386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2203389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2203392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2203395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2203398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2203401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2203408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203424 */     // MIs[0] round
     /* 2203424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203427 */     // MIs[0] policy
     /* 2203427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203437 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2203440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2203444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203463 */     // GIR_Coverage, 18939,
     /* 2203463 */     GIR_EraseRootFromParent_Done,
     /* 2203464 */   // Label 28967: @2203464
     /* 2203464 */   GIM_Try, /*On fail goto*//*Label 28968*/ GIMT_Encode4(2203555), // Rule ID 18942 //
     /* 2203469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2203472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2203477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2203480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2203483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2203486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2203489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2203492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203515 */     // MIs[0] round
     /* 2203515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203518 */     // MIs[0] policy
     /* 2203518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203528 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2203531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2203535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203554 */     // GIR_Coverage, 18942,
     /* 2203554 */     GIR_EraseRootFromParent_Done,
     /* 2203555 */   // Label 28968: @2203555
     /* 2203555 */   GIM_Try, /*On fail goto*//*Label 28969*/ GIMT_Encode4(2203646), // Rule ID 18943 //
     /* 2203560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2203563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2203568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2203571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2203574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2203577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2203580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2203583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203606 */     // MIs[0] round
     /* 2203606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203609 */     // MIs[0] policy
     /* 2203609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203619 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2203622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2203626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203645 */     // GIR_Coverage, 18943,
     /* 2203645 */     GIR_EraseRootFromParent_Done,
     /* 2203646 */   // Label 28969: @2203646
     /* 2203646 */   GIM_Try, /*On fail goto*//*Label 28970*/ GIMT_Encode4(2203737), // Rule ID 18946 //
     /* 2203651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2203654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2203659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2203662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2203665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2203668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2203671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2203674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2203681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203697 */     // MIs[0] round
     /* 2203697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203700 */     // MIs[0] policy
     /* 2203700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203710 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2203713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2203717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203736 */     // GIR_Coverage, 18946,
     /* 2203736 */     GIR_EraseRootFromParent_Done,
     /* 2203737 */   // Label 28970: @2203737
     /* 2203737 */   GIM_Try, /*On fail goto*//*Label 28971*/ GIMT_Encode4(2203828), // Rule ID 18947 //
     /* 2203742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2203745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2203750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2203753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2203756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2203759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2203762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2203765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2203772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203788 */     // MIs[0] round
     /* 2203788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203791 */     // MIs[0] policy
     /* 2203791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203801 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2203804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2203808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203814 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203824 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203827 */     // GIR_Coverage, 18947,
     /* 2203827 */     GIR_EraseRootFromParent_Done,
     /* 2203828 */   // Label 28971: @2203828
     /* 2203828 */   GIM_Try, /*On fail goto*//*Label 28972*/ GIMT_Encode4(2203919), // Rule ID 18950 //
     /* 2203833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2203836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2203841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2203844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2203847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2203850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2203853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2203856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2203863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203879 */     // MIs[0] round
     /* 2203879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203882 */     // MIs[0] policy
     /* 2203882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203892 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2203895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2203899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203918 */     // GIR_Coverage, 18950,
     /* 2203918 */     GIR_EraseRootFromParent_Done,
     /* 2203919 */   // Label 28972: @2203919
     /* 2203919 */   GIM_Try, /*On fail goto*//*Label 28973*/ GIMT_Encode4(2204010), // Rule ID 18951 //
     /* 2203924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2203927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2203932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2203935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2203938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2203941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2203944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2203947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2203954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203970 */     // MIs[0] round
     /* 2203970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203973 */     // MIs[0] policy
     /* 2203973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203983 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2203986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2203990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203996 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204006 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204009 */     // GIR_Coverage, 18951,
     /* 2204009 */     GIR_EraseRootFromParent_Done,
     /* 2204010 */   // Label 28973: @2204010
     /* 2204010 */   GIM_Try, /*On fail goto*//*Label 28974*/ GIMT_Encode4(2204101), // Rule ID 18954 //
     /* 2204015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2204018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2204023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2204026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2204029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2204032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2204035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2204045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204061 */     // MIs[0] round
     /* 2204061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204064 */     // MIs[0] policy
     /* 2204064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204074 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2204077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2204081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204100 */     // GIR_Coverage, 18954,
     /* 2204100 */     GIR_EraseRootFromParent_Done,
     /* 2204101 */   // Label 28974: @2204101
     /* 2204101 */   GIM_Try, /*On fail goto*//*Label 28975*/ GIMT_Encode4(2204192), // Rule ID 18955 //
     /* 2204106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2204109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2204114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2204117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2204120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2204123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2204126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2204136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204152 */     // MIs[0] round
     /* 2204152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204155 */     // MIs[0] policy
     /* 2204155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204165 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2204168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2204172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204191 */     // GIR_Coverage, 18955,
     /* 2204191 */     GIR_EraseRootFromParent_Done,
     /* 2204192 */   // Label 28975: @2204192
     /* 2204192 */   GIM_Try, /*On fail goto*//*Label 28976*/ GIMT_Encode4(2204283), // Rule ID 18958 //
     /* 2204197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2204200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2204205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2204208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2204211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2204214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2204217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2204220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2204235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204243 */     // MIs[0] round
     /* 2204243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204246 */     // MIs[0] policy
     /* 2204246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204256 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2204259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2204263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204282 */     // GIR_Coverage, 18958,
     /* 2204282 */     GIR_EraseRootFromParent_Done,
     /* 2204283 */   // Label 28976: @2204283
     /* 2204283 */   GIM_Try, /*On fail goto*//*Label 28977*/ GIMT_Encode4(2204374), // Rule ID 18959 //
     /* 2204288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2204291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2204296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2204299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2204302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2204305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2204308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2204311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2204326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204334 */     // MIs[0] round
     /* 2204334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204337 */     // MIs[0] policy
     /* 2204337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204347 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2204350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2204354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204373 */     // GIR_Coverage, 18959,
     /* 2204373 */     GIR_EraseRootFromParent_Done,
     /* 2204374 */   // Label 28977: @2204374
     /* 2204374 */   GIM_Try, /*On fail goto*//*Label 28978*/ GIMT_Encode4(2204465), // Rule ID 18962 //
     /* 2204379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2204382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2204387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2204390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2204393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2204396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2204399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2204402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2204417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204425 */     // MIs[0] round
     /* 2204425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204428 */     // MIs[0] policy
     /* 2204428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204438 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2204441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2204445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204464 */     // GIR_Coverage, 18962,
     /* 2204464 */     GIR_EraseRootFromParent_Done,
     /* 2204465 */   // Label 28978: @2204465
     /* 2204465 */   GIM_Try, /*On fail goto*//*Label 28979*/ GIMT_Encode4(2204556), // Rule ID 18963 //
     /* 2204470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2204473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2204478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2204481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2204484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2204487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2204490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2204493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2204508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204516 */     // MIs[0] round
     /* 2204516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204519 */     // MIs[0] policy
     /* 2204519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204529 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2204532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2204536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204555 */     // GIR_Coverage, 18963,
     /* 2204555 */     GIR_EraseRootFromParent_Done,
     /* 2204556 */   // Label 28979: @2204556
     /* 2204556 */   GIM_Try, /*On fail goto*//*Label 28980*/ GIMT_Encode4(2204647), // Rule ID 18966 //
     /* 2204561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2204564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2204569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2204572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2204575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2204578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2204581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2204584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2204599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204607 */     // MIs[0] round
     /* 2204607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204610 */     // MIs[0] policy
     /* 2204610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204620 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2204623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2204627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204646 */     // GIR_Coverage, 18966,
     /* 2204646 */     GIR_EraseRootFromParent_Done,
     /* 2204647 */   // Label 28980: @2204647
     /* 2204647 */   GIM_Try, /*On fail goto*//*Label 28981*/ GIMT_Encode4(2204738), // Rule ID 18967 //
     /* 2204652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2204655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2204660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2204663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2204666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2204669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2204672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2204675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2204690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204698 */     // MIs[0] round
     /* 2204698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204701 */     // MIs[0] policy
     /* 2204701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204711 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2204714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2204718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204737 */     // GIR_Coverage, 18967,
     /* 2204737 */     GIR_EraseRootFromParent_Done,
     /* 2204738 */   // Label 28981: @2204738
     /* 2204738 */   GIM_Try, /*On fail goto*//*Label 28982*/ GIMT_Encode4(2204829), // Rule ID 18970 //
     /* 2204743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2204746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2204751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2204754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2204757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2204760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2204763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2204773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2204781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204789 */     // MIs[0] round
     /* 2204789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204792 */     // MIs[0] policy
     /* 2204792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204802 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2204805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2204809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204828 */     // GIR_Coverage, 18970,
     /* 2204828 */     GIR_EraseRootFromParent_Done,
     /* 2204829 */   // Label 28982: @2204829
     /* 2204829 */   GIM_Try, /*On fail goto*//*Label 28983*/ GIMT_Encode4(2204920), // Rule ID 18971 //
     /* 2204834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2204837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2204842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2204845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2204848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2204851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2204854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204857 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2204864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2204872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204880 */     // MIs[0] round
     /* 2204880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204883 */     // MIs[0] policy
     /* 2204883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204893 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2204896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2204900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204919 */     // GIR_Coverage, 18971,
     /* 2204919 */     GIR_EraseRootFromParent_Done,
     /* 2204920 */   // Label 28983: @2204920
     /* 2204920 */   GIM_Try, /*On fail goto*//*Label 28984*/ GIMT_Encode4(2205011), // Rule ID 18974 //
     /* 2204925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2204928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2204933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2204936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2204939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2204942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2204945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2204948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2204955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2204963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204971 */     // MIs[0] round
     /* 2204971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204974 */     // MIs[0] policy
     /* 2204974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204984 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2204987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2204991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205010 */     // GIR_Coverage, 18974,
     /* 2205010 */     GIR_EraseRootFromParent_Done,
     /* 2205011 */   // Label 28984: @2205011
     /* 2205011 */   GIM_Try, /*On fail goto*//*Label 28985*/ GIMT_Encode4(2205102), // Rule ID 18975 //
     /* 2205016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2205019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2205024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2205027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2205030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2205033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2205036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2205039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2205046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2205054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205062 */     // MIs[0] round
     /* 2205062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205065 */     // MIs[0] policy
     /* 2205065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205075 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2205078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2205082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205101 */     // GIR_Coverage, 18975,
     /* 2205101 */     GIR_EraseRootFromParent_Done,
     /* 2205102 */   // Label 28985: @2205102
     /* 2205102 */   GIM_Try, /*On fail goto*//*Label 28986*/ GIMT_Encode4(2205193), // Rule ID 18978 //
     /* 2205107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2205110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2205115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2205118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2205121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2205124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2205127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2205130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205153 */     // MIs[0] round
     /* 2205153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205156 */     // MIs[0] policy
     /* 2205156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205166 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2205169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2205173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2205189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205192 */     // GIR_Coverage, 18978,
     /* 2205192 */     GIR_EraseRootFromParent_Done,
     /* 2205193 */   // Label 28986: @2205193
     /* 2205193 */   GIM_Try, /*On fail goto*//*Label 28987*/ GIMT_Encode4(2205284), // Rule ID 18979 //
     /* 2205198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2205201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2205206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2205209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2205212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2205215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2205218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2205221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205244 */     // MIs[0] round
     /* 2205244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205247 */     // MIs[0] policy
     /* 2205247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205257 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2205260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2205264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2205280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205283 */     // GIR_Coverage, 18979,
     /* 2205283 */     GIR_EraseRootFromParent_Done,
     /* 2205284 */   // Label 28987: @2205284
     /* 2205284 */   GIM_Try, /*On fail goto*//*Label 28988*/ GIMT_Encode4(2205375), // Rule ID 18982 //
     /* 2205289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2205292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2205297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2205300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2205303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2205306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2205309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2205312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2205319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205335 */     // MIs[0] round
     /* 2205335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205338 */     // MIs[0] policy
     /* 2205338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205348 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2205351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2205355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2205371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205374 */     // GIR_Coverage, 18982,
     /* 2205374 */     GIR_EraseRootFromParent_Done,
     /* 2205375 */   // Label 28988: @2205375
     /* 2205375 */   GIM_Try, /*On fail goto*//*Label 28989*/ GIMT_Encode4(2205466), // Rule ID 18983 //
     /* 2205380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2205383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2205388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2205391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2205394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2205397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2205400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2205403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2205410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205426 */     // MIs[0] round
     /* 2205426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205429 */     // MIs[0] policy
     /* 2205429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205439 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2205442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2205446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205452 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2205462 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205465 */     // GIR_Coverage, 18983,
     /* 2205465 */     GIR_EraseRootFromParent_Done,
     /* 2205466 */   // Label 28989: @2205466
     /* 2205466 */   GIM_Try, /*On fail goto*//*Label 28990*/ GIMT_Encode4(2205557), // Rule ID 18986 //
     /* 2205471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2205474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2205479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2205482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2205485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2205488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2205491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2205494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2205501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205517 */     // MIs[0] round
     /* 2205517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205520 */     // MIs[0] policy
     /* 2205520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205530 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2205533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2205537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2205553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205556 */     // GIR_Coverage, 18986,
     /* 2205556 */     GIR_EraseRootFromParent_Done,
     /* 2205557 */   // Label 28990: @2205557
     /* 2205557 */   GIM_Try, /*On fail goto*//*Label 28991*/ GIMT_Encode4(2205648), // Rule ID 18987 //
     /* 2205562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2205565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2205570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2205573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2205576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2205579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2205582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2205585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2205592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205608 */     // MIs[0] round
     /* 2205608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205611 */     // MIs[0] policy
     /* 2205611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205621 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2205624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2205628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2205644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205647 */     // GIR_Coverage, 18987,
     /* 2205647 */     GIR_EraseRootFromParent_Done,
     /* 2205648 */   // Label 28991: @2205648
     /* 2205648 */   GIM_Try, /*On fail goto*//*Label 28992*/ GIMT_Encode4(2205739), // Rule ID 18990 //
     /* 2205653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2205656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2205661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2205664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2205667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2205670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2205673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2205676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2205683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205699 */     // MIs[0] round
     /* 2205699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205702 */     // MIs[0] policy
     /* 2205702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205712 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2205715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2205719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2205735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205738 */     // GIR_Coverage, 18990,
     /* 2205738 */     GIR_EraseRootFromParent_Done,
     /* 2205739 */   // Label 28992: @2205739
     /* 2205739 */   GIM_Try, /*On fail goto*//*Label 28993*/ GIMT_Encode4(2205830), // Rule ID 18991 //
     /* 2205744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2205747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2205752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2205755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2205758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2205761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2205764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2205767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2205774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205790 */     // MIs[0] round
     /* 2205790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205793 */     // MIs[0] policy
     /* 2205793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205803 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2205806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2205810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2205826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205829 */     // GIR_Coverage, 18991,
     /* 2205829 */     GIR_EraseRootFromParent_Done,
     /* 2205830 */   // Label 28993: @2205830
     /* 2205830 */   GIM_Try, /*On fail goto*//*Label 28994*/ GIMT_Encode4(2205921), // Rule ID 64349 //
     /* 2205835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2205838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2205843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2205846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2205849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2205852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2205858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205881 */     // MIs[0] round
     /* 2205881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205884 */     // MIs[0] policy
     /* 2205884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205894 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2205897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205920 */     // GIR_Coverage, 64349,
     /* 2205920 */     GIR_EraseRootFromParent_Done,
     /* 2205921 */   // Label 28994: @2205921
     /* 2205921 */   GIM_Try, /*On fail goto*//*Label 28995*/ GIMT_Encode4(2206012), // Rule ID 64350 //
     /* 2205926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2205929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2205934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2205937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2205940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2205943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2205949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205972 */     // MIs[0] round
     /* 2205972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205975 */     // MIs[0] policy
     /* 2205975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205985 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2205988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206008 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206011 */     // GIR_Coverage, 64350,
     /* 2206011 */     GIR_EraseRootFromParent_Done,
     /* 2206012 */   // Label 28995: @2206012
     /* 2206012 */   GIM_Try, /*On fail goto*//*Label 28996*/ GIMT_Encode4(2206103), // Rule ID 64353 //
     /* 2206017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2206020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2206025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2206028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2206031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2206034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2206040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2206043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2206047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206063 */     // MIs[0] round
     /* 2206063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206066 */     // MIs[0] policy
     /* 2206066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206076 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2206076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2206079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206102 */     // GIR_Coverage, 64353,
     /* 2206102 */     GIR_EraseRootFromParent_Done,
     /* 2206103 */   // Label 28996: @2206103
     /* 2206103 */   GIM_Try, /*On fail goto*//*Label 28997*/ GIMT_Encode4(2206194), // Rule ID 64354 //
     /* 2206108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2206111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2206116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2206119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2206122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2206125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2206131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2206134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2206138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206154 */     // MIs[0] round
     /* 2206154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206157 */     // MIs[0] policy
     /* 2206157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206167 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2206167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2206170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206193 */     // GIR_Coverage, 64354,
     /* 2206193 */     GIR_EraseRootFromParent_Done,
     /* 2206194 */   // Label 28997: @2206194
     /* 2206194 */   GIM_Try, /*On fail goto*//*Label 28998*/ GIMT_Encode4(2206285), // Rule ID 64357 //
     /* 2206199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2206202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2206207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2206210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2206213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2206216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2206222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2206225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2206229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206245 */     // MIs[0] round
     /* 2206245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206248 */     // MIs[0] policy
     /* 2206248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206258 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2206258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2206261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206284 */     // GIR_Coverage, 64357,
     /* 2206284 */     GIR_EraseRootFromParent_Done,
     /* 2206285 */   // Label 28998: @2206285
     /* 2206285 */   GIM_Try, /*On fail goto*//*Label 28999*/ GIMT_Encode4(2206376), // Rule ID 64358 //
     /* 2206290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2206293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2206298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2206301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2206304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2206307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2206313 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2206316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2206320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206336 */     // MIs[0] round
     /* 2206336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206339 */     // MIs[0] policy
     /* 2206339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206349 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2206349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2206352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206375 */     // GIR_Coverage, 64358,
     /* 2206375 */     GIR_EraseRootFromParent_Done,
     /* 2206376 */   // Label 28999: @2206376
     /* 2206376 */   GIM_Try, /*On fail goto*//*Label 29000*/ GIMT_Encode4(2206467), // Rule ID 64361 //
     /* 2206381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2206384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2206389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2206392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2206395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2206398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2206404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2206407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2206411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206427 */     // MIs[0] round
     /* 2206427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206430 */     // MIs[0] policy
     /* 2206430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206440 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2206440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1_MASK),
     /* 2206443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206466 */     // GIR_Coverage, 64361,
     /* 2206466 */     GIR_EraseRootFromParent_Done,
     /* 2206467 */   // Label 29000: @2206467
     /* 2206467 */   GIM_Try, /*On fail goto*//*Label 29001*/ GIMT_Encode4(2206558), // Rule ID 64362 //
     /* 2206472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2206475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2206480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2206483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2206486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2206489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2206495 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2206498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2206502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206518 */     // MIs[0] round
     /* 2206518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206521 */     // MIs[0] policy
     /* 2206521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206531 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2206531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1_MASK),
     /* 2206534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206554 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206557 */     // GIR_Coverage, 64362,
     /* 2206557 */     GIR_EraseRootFromParent_Done,
     /* 2206558 */   // Label 29001: @2206558
     /* 2206558 */   GIM_Try, /*On fail goto*//*Label 29002*/ GIMT_Encode4(2206649), // Rule ID 64365 //
     /* 2206563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2206566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2206571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2206574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2206577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2206580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2206586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2206589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2206593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2206601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206609 */     // MIs[0] round
     /* 2206609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206612 */     // MIs[0] policy
     /* 2206612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206622 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2206622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2_MASK),
     /* 2206625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206648 */     // GIR_Coverage, 64365,
     /* 2206648 */     GIR_EraseRootFromParent_Done,
     /* 2206649 */   // Label 29002: @2206649
     /* 2206649 */   GIM_Try, /*On fail goto*//*Label 29003*/ GIMT_Encode4(2206740), // Rule ID 64366 //
     /* 2206654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2206657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2206662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2206665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2206668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2206671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2206677 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2206680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2206684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2206692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206700 */     // MIs[0] round
     /* 2206700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206703 */     // MIs[0] policy
     /* 2206703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206713 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2206713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2_MASK),
     /* 2206716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206736 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206739 */     // GIR_Coverage, 64366,
     /* 2206739 */     GIR_EraseRootFromParent_Done,
     /* 2206740 */   // Label 29003: @2206740
     /* 2206740 */   GIM_Try, /*On fail goto*//*Label 29004*/ GIMT_Encode4(2206831), // Rule ID 64369 //
     /* 2206745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2206748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2206753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2206756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2206759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2206762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2206768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2206771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2206775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206791 */     // MIs[0] round
     /* 2206791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206794 */     // MIs[0] policy
     /* 2206794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206804 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2206804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8_MASK),
     /* 2206807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206830 */     // GIR_Coverage, 64369,
     /* 2206830 */     GIR_EraseRootFromParent_Done,
     /* 2206831 */   // Label 29004: @2206831
     /* 2206831 */   GIM_Try, /*On fail goto*//*Label 29005*/ GIMT_Encode4(2206922), // Rule ID 64370 //
     /* 2206836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2206839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2206844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2206847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2206850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2206853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2206859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2206862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2206866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206882 */     // MIs[0] round
     /* 2206882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206885 */     // MIs[0] policy
     /* 2206885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206895 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2206895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8_MASK),
     /* 2206898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206921 */     // GIR_Coverage, 64370,
     /* 2206921 */     GIR_EraseRootFromParent_Done,
     /* 2206922 */   // Label 29005: @2206922
     /* 2206922 */   GIM_Try, /*On fail goto*//*Label 29006*/ GIMT_Encode4(2207013), // Rule ID 64373 //
     /* 2206927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2206930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2206935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2206938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2206941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2206944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2206950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2206953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2206957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206973 */     // MIs[0] round
     /* 2206973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206976 */     // MIs[0] policy
     /* 2206976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206986 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2206986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4_MASK),
     /* 2206989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2207001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2207006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2207011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207012 */     // GIR_Coverage, 64373,
     /* 2207012 */     GIR_EraseRootFromParent_Done,
     /* 2207013 */   // Label 29006: @2207013
     /* 2207013 */   GIM_Try, /*On fail goto*//*Label 29007*/ GIMT_Encode4(2207104), // Rule ID 64374 //
     /* 2207018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2207021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2207026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2207029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2207032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2207035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2207041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2207044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2207048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2207060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2207064 */     // MIs[0] round
     /* 2207064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207067 */     // MIs[0] policy
     /* 2207067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2207070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2207077 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2207077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4_MASK),
     /* 2207080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2207084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2207086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2207088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2207090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2207092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2207097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2207102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207103 */     // GIR_Coverage, 64374,
     /* 2207103 */     GIR_EraseRootFromParent_Done,
     /* 2207104 */   // Label 29007: @2207104
     /* 2207104 */   GIM_Try, /*On fail goto*//*Label 29008*/ GIMT_Encode4(2207195), // Rule ID 64377 //
     /* 2207109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2207112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2207117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2207120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2207123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2207126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2207132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2207135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2207139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2207151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2207155 */     // MIs[0] round
     /* 2207155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207158 */     // MIs[0] policy
     /* 2207158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2207161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2207168 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2207168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2_MASK),
     /* 2207171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2207175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2207177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2207179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2207181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2207183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2207188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2207193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207194 */     // GIR_Coverage, 64377,
     /* 2207194 */     GIR_EraseRootFromParent_Done,
     /* 2207195 */   // Label 29008: @2207195
     /* 2207195 */   GIM_Try, /*On fail goto*//*Label 29009*/ GIMT_Encode4(2207286), // Rule ID 64378 //
     /* 2207200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2207203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2207208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2207211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2207214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2207217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2207223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2207226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2207230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2207242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2207246 */     // MIs[0] round
     /* 2207246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207249 */     // MIs[0] policy
     /* 2207249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2207252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2207259 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2207259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2_MASK),
     /* 2207262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2207266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2207268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2207270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2207272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2207274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2207279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2207284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207285 */     // GIR_Coverage, 64378,
     /* 2207285 */     GIR_EraseRootFromParent_Done,
     /* 2207286 */   // Label 29009: @2207286
     /* 2207286 */   GIM_Try, /*On fail goto*//*Label 29010*/ GIMT_Encode4(2207377), // Rule ID 64381 //
     /* 2207291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2207294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2207299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2207302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2207305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2207308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2207314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2207317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2207321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2207329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2207333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2207337 */     // MIs[0] round
     /* 2207337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207340 */     // MIs[0] policy
     /* 2207340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2207343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2207350 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2207350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1_MASK),
     /* 2207353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2207357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2207359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2207361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2207363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2207365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2207370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2207375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207376 */     // GIR_Coverage, 64381,
     /* 2207376 */     GIR_EraseRootFromParent_Done,
     /* 2207377 */   // Label 29010: @2207377
     /* 2207377 */   GIM_Try, /*On fail goto*//*Label 29011*/ GIMT_Encode4(2207468), // Rule ID 64382 //
     /* 2207382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2207385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2207390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2207393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2207396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2207399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2207405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2207408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2207412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2207420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2207424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2207428 */     // MIs[0] round
     /* 2207428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207431 */     // MIs[0] policy
     /* 2207431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2207434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2207441 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2207441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1_MASK),
     /* 2207444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2207448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2207450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2207452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2207454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2207456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2207461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2207466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207467 */     // GIR_Coverage, 64382,
     /* 2207467 */     GIR_EraseRootFromParent_Done,
     /* 2207468 */   // Label 29011: @2207468
     /* 2207468 */   GIM_Try, /*On fail goto*//*Label 29012*/ GIMT_Encode4(2207559), // Rule ID 64385 //
     /* 2207473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2207476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2207481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2207484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2207487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2207490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2207496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2207499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2207503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2207511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2207515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2207519 */     // MIs[0] round
     /* 2207519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207522 */     // MIs[0] policy
     /* 2207522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2207525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2207532 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2207532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2_MASK),
     /* 2207535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2207539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2207541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2207543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2207545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2207547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2207552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2207557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207558 */     // GIR_Coverage, 64385,
     /* 2207558 */     GIR_EraseRootFromParent_Done,
     /* 2207559 */   // Label 29012: @2207559
     /* 2207559 */   GIM_Try, /*On fail goto*//*Label 29013*/ GIMT_Encode4(2207650), // Rule ID 64386 //
     /* 2207564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2207567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2207572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2207575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2207578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2207581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2207587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2207590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2207594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2207602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2207606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2207610 */     // MIs[0] round
     /* 2207610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207613 */     // MIs[0] policy
     /* 2207613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2207616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2207623 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2207623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2_MASK),
     /* 2207626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2207630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2207632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2207634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2207636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2207638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2207643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2207648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207649 */     // GIR_Coverage, 64386,
     /* 2207649 */     GIR_EraseRootFromParent_Done,
     /* 2207650 */   // Label 29013: @2207650
     /* 2207650 */   GIM_Try, /*On fail goto*//*Label 29014*/ GIMT_Encode4(2207741), // Rule ID 65063 //
     /* 2207655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2207658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2207663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2207666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2207669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2207672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2207678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2207681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2207685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2207697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2207701 */     // MIs[0] round
     /* 2207701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207704 */     // MIs[0] policy
     /* 2207704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2207707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2207714 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2207714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4_MASK),
     /* 2207717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2207721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2207723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2207725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2207727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2207729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2207734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2207739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207740 */     // GIR_Coverage, 65063,
     /* 2207740 */     GIR_EraseRootFromParent_Done,
     /* 2207741 */   // Label 29014: @2207741
     /* 2207741 */   GIM_Try, /*On fail goto*//*Label 29015*/ GIMT_Encode4(2207832), // Rule ID 65064 //
     /* 2207746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2207749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2207754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2207757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2207760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2207763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2207769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2207772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2207776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2207788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2207792 */     // MIs[0] round
     /* 2207792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207795 */     // MIs[0] policy
     /* 2207795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2207798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2207805 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2207805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4_MASK),
     /* 2207808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2207812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2207814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2207816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2207818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2207820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2207825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2207830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207831 */     // GIR_Coverage, 65064,
     /* 2207831 */     GIR_EraseRootFromParent_Done,
     /* 2207832 */   // Label 29015: @2207832
     /* 2207832 */   GIM_Try, /*On fail goto*//*Label 29016*/ GIMT_Encode4(2207923), // Rule ID 65067 //
     /* 2207837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2207840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2207845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2207848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2207851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2207854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2207860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2207863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2207867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2207879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2207883 */     // MIs[0] round
     /* 2207883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207886 */     // MIs[0] policy
     /* 2207886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2207889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2207896 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2207896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2_MASK),
     /* 2207899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2207903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2207905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2207907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2207909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2207911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2207916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2207921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207922 */     // GIR_Coverage, 65067,
     /* 2207922 */     GIR_EraseRootFromParent_Done,
     /* 2207923 */   // Label 29016: @2207923
     /* 2207923 */   GIM_Try, /*On fail goto*//*Label 29017*/ GIMT_Encode4(2208014), // Rule ID 65068 //
     /* 2207928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2207931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2207936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2207939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2207942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2207945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2207951 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2207954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2207958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2207970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2207974 */     // MIs[0] round
     /* 2207974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207977 */     // MIs[0] policy
     /* 2207977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2207980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2207987 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2207987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2_MASK),
     /* 2207990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2207994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2207996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2207998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2208000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2208002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2208007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2208012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208013 */     // GIR_Coverage, 65068,
     /* 2208013 */     GIR_EraseRootFromParent_Done,
     /* 2208014 */   // Label 29017: @2208014
     /* 2208014 */   GIM_Try, /*On fail goto*//*Label 29018*/ GIMT_Encode4(2208105), // Rule ID 65071 //
     /* 2208019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2208022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2208027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2208030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2208033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2208036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2208039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2208042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2208045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2208049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2208061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2208065 */     // MIs[0] round
     /* 2208065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2208068 */     // MIs[0] policy
     /* 2208068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2208071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2208078 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2208078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1_MASK),
     /* 2208081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2208085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2208087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2208089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2208091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2208093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2208098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2208103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208104 */     // GIR_Coverage, 65071,
     /* 2208104 */     GIR_EraseRootFromParent_Done,
     /* 2208105 */   // Label 29018: @2208105
     /* 2208105 */   GIM_Try, /*On fail goto*//*Label 29019*/ GIMT_Encode4(2208196), // Rule ID 65072 //
     /* 2208110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2208113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2208118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2208121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2208124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2208127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2208130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2208133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2208136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2208140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2208152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2208156 */     // MIs[0] round
     /* 2208156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2208159 */     // MIs[0] policy
     /* 2208159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2208162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2208169 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2208169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1_MASK),
     /* 2208172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2208176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2208178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2208180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2208182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2208184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2208189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2208194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208195 */     // GIR_Coverage, 65072,
     /* 2208195 */     GIR_EraseRootFromParent_Done,
     /* 2208196 */   // Label 29019: @2208196
     /* 2208196 */   GIM_Try, /*On fail goto*//*Label 29020*/ GIMT_Encode4(2208287), // Rule ID 65075 //
     /* 2208201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2208204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2208209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2208212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2208215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2208218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2208221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2208224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2208227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2208231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2208243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2208247 */     // MIs[0] round
     /* 2208247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2208250 */     // MIs[0] policy
     /* 2208250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2208253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2208260 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2208260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2_MASK),
     /* 2208263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2208267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2208269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2208271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2208273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2208275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2208280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2208285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208286 */     // GIR_Coverage, 65075,
     /* 2208286 */     GIR_EraseRootFromParent_Done,
     /* 2208287 */   // Label 29020: @2208287
     /* 2208287 */   GIM_Try, /*On fail goto*//*Label 29021*/ GIMT_Encode4(2208378), // Rule ID 65076 //
     /* 2208292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2208295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2208300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2208303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2208306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2208309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2208312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2208315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2208318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2208322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2208334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2208338 */     // MIs[0] round
     /* 2208338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2208341 */     // MIs[0] policy
     /* 2208341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2208344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2208351 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2208351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2_MASK),
     /* 2208354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2208358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2208360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2208362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2208364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2208366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2208371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2208376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208377 */     // GIR_Coverage, 65076,
     /* 2208377 */     GIR_EraseRootFromParent_Done,
     /* 2208378 */   // Label 29021: @2208378
     /* 2208378 */   GIM_Try, /*On fail goto*//*Label 29022*/ GIMT_Encode4(2208469), // Rule ID 65079 //
     /* 2208383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2208386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2208391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2208394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2208397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2208400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2208403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2208406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2208409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2208413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2208425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2208429 */     // MIs[0] round
     /* 2208429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2208432 */     // MIs[0] policy
     /* 2208432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2208435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2208442 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2208442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4_MASK),
     /* 2208445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2208449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2208451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2208453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2208455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2208457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2208462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2208467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208468 */     // GIR_Coverage, 65079,
     /* 2208468 */     GIR_EraseRootFromParent_Done,
     /* 2208469 */   // Label 29022: @2208469
     /* 2208469 */   GIM_Try, /*On fail goto*//*Label 29023*/ GIMT_Encode4(2208560), // Rule ID 65080 //
     /* 2208474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2208477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2208482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2208485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2208488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2208491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2208494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2208497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2208500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2208504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2208516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2208520 */     // MIs[0] round
     /* 2208520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2208523 */     // MIs[0] policy
     /* 2208523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2208526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2208533 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2208533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4_MASK),
     /* 2208536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2208540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2208542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2208544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2208546 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2208548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2208553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208556 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2208558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208559 */     // GIR_Coverage, 65080,
     /* 2208559 */     GIR_EraseRootFromParent_Done,
     /* 2208560 */   // Label 29023: @2208560
     /* 2208560 */   GIM_Try, /*On fail goto*//*Label 29024*/ GIMT_Encode4(2208651), // Rule ID 65083 //
     /* 2208565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2208568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2208573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2208576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2208579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2208582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2208585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2208588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2208591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2208595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2208599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2208603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2208607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2208611 */     // MIs[0] round
     /* 2208611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2208614 */     // MIs[0] policy
     /* 2208614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2208617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2208624 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2208624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8_MASK),
     /* 2208627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2208631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2208633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2208635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2208637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2208639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2208644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2208649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208650 */     // GIR_Coverage, 65083,
     /* 2208650 */     GIR_EraseRootFromParent_Done,
     /* 2208651 */   // Label 29024: @2208651
     /* 2208651 */   GIM_Try, /*On fail goto*//*Label 29025*/ GIMT_Encode4(2208742), // Rule ID 65084 //
     /* 2208656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2208659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2208664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2208667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2208670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2208673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2208676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2208679 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2208682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2208686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2208690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2208694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2208698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2208702 */     // MIs[0] round
     /* 2208702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2208705 */     // MIs[0] policy
     /* 2208705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2208708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2208715 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2208715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8_MASK),
     /* 2208718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2208722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2208724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2208726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2208728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2208730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2208735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2208740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208741 */     // GIR_Coverage, 65084,
     /* 2208741 */     GIR_EraseRootFromParent_Done,
     /* 2208742 */   // Label 29025: @2208742
     /* 2208742 */   GIM_Try, /*On fail goto*//*Label 29026*/ GIMT_Encode4(2208833), // Rule ID 65087 //
     /* 2208747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2208750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2208755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2208758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2208761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2208764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2208767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2208770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2208773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2208777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2208789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2208793 */     // MIs[0] round
     /* 2208793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2208796 */     // MIs[0] policy
     /* 2208796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2208799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2208806 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11012:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2208806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4_MASK),
     /* 2208809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2208813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2208815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2208817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2208819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2208821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2208826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2208831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208832 */     // GIR_Coverage, 65087,
     /* 2208832 */     GIR_EraseRootFromParent_Done,
     /* 2208833 */   // Label 29026: @2208833
     /* 2208833 */   GIM_Try, /*On fail goto*//*Label 29027*/ GIMT_Encode4(2208924), // Rule ID 65088 //
     /* 2208838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2208841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2208846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2208849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2208852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2208855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2208858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2208861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2208864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2208868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2208880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2208884 */     // MIs[0] round
     /* 2208884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2208887 */     // MIs[0] policy
     /* 2208887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2208890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2208897 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11012:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2208897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4_MASK),
     /* 2208900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2208904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2208906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2208908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2208910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2208912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2208917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2208922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208923 */     // GIR_Coverage, 65088,
     /* 2208923 */     GIR_EraseRootFromParent_Done,
     /* 2208924 */   // Label 29027: @2208924
     /* 2208924 */   GIM_Try, /*On fail goto*//*Label 29028*/ GIMT_Encode4(2209015), // Rule ID 65091 //
     /* 2208929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2208932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2208937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2208940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2208943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2208946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2208949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2208952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2208955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2208959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2208971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2208975 */     // MIs[0] round
     /* 2208975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2208978 */     // MIs[0] policy
     /* 2208978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2208981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2208988 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11012:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2208988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2_MASK),
     /* 2208991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2208995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2208997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2208999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2209001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2209003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2209008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2209013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209014 */     // GIR_Coverage, 65091,
     /* 2209014 */     GIR_EraseRootFromParent_Done,
     /* 2209015 */   // Label 29028: @2209015
     /* 2209015 */   GIM_Try, /*On fail goto*//*Label 29029*/ GIMT_Encode4(2209106), // Rule ID 65092 //
     /* 2209020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2209023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2209028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2209031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2209034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2209037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2209040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2209043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2209046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2209050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2209062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2209066 */     // MIs[0] round
     /* 2209066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2209069 */     // MIs[0] policy
     /* 2209069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2209072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2209079 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11012:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2209079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2_MASK),
     /* 2209082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2209086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2209088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2209090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2209092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2209094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2209099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2209104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209105 */     // GIR_Coverage, 65092,
     /* 2209105 */     GIR_EraseRootFromParent_Done,
     /* 2209106 */   // Label 29029: @2209106
     /* 2209106 */   GIM_Try, /*On fail goto*//*Label 29030*/ GIMT_Encode4(2209197), // Rule ID 65095 //
     /* 2209111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2209114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2209119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2209122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2209125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2209128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2209131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2209134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2209137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2209141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2209153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2209157 */     // MIs[0] round
     /* 2209157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2209160 */     // MIs[0] policy
     /* 2209160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2209163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2209170 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11012:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2209170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1_MASK),
     /* 2209173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2209177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2209179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2209181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2209183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2209185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2209190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2209195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209196 */     // GIR_Coverage, 65095,
     /* 2209196 */     GIR_EraseRootFromParent_Done,
     /* 2209197 */   // Label 29030: @2209197
     /* 2209197 */   GIM_Try, /*On fail goto*//*Label 29031*/ GIMT_Encode4(2209288), // Rule ID 65096 //
     /* 2209202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2209205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2209210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2209213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2209216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2209219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2209222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2209225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2209228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2209232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2209244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2209248 */     // MIs[0] round
     /* 2209248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2209251 */     // MIs[0] policy
     /* 2209251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2209254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2209261 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11012:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2209261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1_MASK),
     /* 2209264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2209268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2209270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2209272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2209274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2209276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2209281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2209286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209287 */     // GIR_Coverage, 65096,
     /* 2209287 */     GIR_EraseRootFromParent_Done,
     /* 2209288 */   // Label 29031: @2209288
     /* 2209288 */   GIM_Try, /*On fail goto*//*Label 29032*/ GIMT_Encode4(2209379), // Rule ID 65099 //
     /* 2209293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2209296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2209301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2209304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2209307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2209310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2209313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2209316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2209319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2209323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2209335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2209339 */     // MIs[0] round
     /* 2209339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2209342 */     // MIs[0] policy
     /* 2209342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2209345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2209352 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11012:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2209352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2_MASK),
     /* 2209355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2209359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2209361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2209363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2209365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2209367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2209372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2209377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209378 */     // GIR_Coverage, 65099,
     /* 2209378 */     GIR_EraseRootFromParent_Done,
     /* 2209379 */   // Label 29032: @2209379
     /* 2209379 */   GIM_Try, /*On fail goto*//*Label 29033*/ GIMT_Encode4(2209470), // Rule ID 65100 //
     /* 2209384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2209387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2209392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2209395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2209398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2209401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2209404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2209407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2209410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2209414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2209426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2209430 */     // MIs[0] round
     /* 2209430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2209433 */     // MIs[0] policy
     /* 2209433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2209436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2209443 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11012:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2209443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2_MASK),
     /* 2209446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2209450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2209452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2209454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2209456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2209458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2209463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2209468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209469 */     // GIR_Coverage, 65100,
     /* 2209469 */     GIR_EraseRootFromParent_Done,
     /* 2209470 */   // Label 29033: @2209470
     /* 2209470 */   GIM_Try, /*On fail goto*//*Label 29034*/ GIMT_Encode4(2209561), // Rule ID 65103 //
     /* 2209475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2209478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2209483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2209486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2209489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2209492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2209495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2209498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2209501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2209505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2209517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2209521 */     // MIs[0] round
     /* 2209521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2209524 */     // MIs[0] policy
     /* 2209524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2209527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2209534 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11012:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2209534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4_MASK),
     /* 2209537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2209541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2209543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2209545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2209547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2209549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2209554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2209559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209560 */     // GIR_Coverage, 65103,
     /* 2209560 */     GIR_EraseRootFromParent_Done,
     /* 2209561 */   // Label 29034: @2209561
     /* 2209561 */   GIM_Try, /*On fail goto*//*Label 29035*/ GIMT_Encode4(2209652), // Rule ID 65104 //
     /* 2209566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2209569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2209574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2209577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2209580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2209583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2209586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2209589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2209592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2209596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2209608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2209612 */     // MIs[0] round
     /* 2209612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2209615 */     // MIs[0] policy
     /* 2209615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2209618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2209625 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11012:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2209625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4_MASK),
     /* 2209628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2209632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2209634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2209636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2209638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2209640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2209645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2209650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209651 */     // GIR_Coverage, 65104,
     /* 2209651 */     GIR_EraseRootFromParent_Done,
     /* 2209652 */   // Label 29035: @2209652
     /* 2209652 */   GIM_Try, /*On fail goto*//*Label 29036*/ GIMT_Encode4(2209743), // Rule ID 65107 //
     /* 2209657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2209660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2209665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2209668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2209671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2209674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2209677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2209680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2209683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2209687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2209699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2209703 */     // MIs[0] round
     /* 2209703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2209706 */     // MIs[0] policy
     /* 2209706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2209709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2209716 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11012:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2209716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8_MASK),
     /* 2209719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2209723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2209725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2209727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2209729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2209731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2209736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2209741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209742 */     // GIR_Coverage, 65107,
     /* 2209742 */     GIR_EraseRootFromParent_Done,
     /* 2209743 */   // Label 29036: @2209743
     /* 2209743 */   GIM_Try, /*On fail goto*//*Label 29037*/ GIMT_Encode4(2209834), // Rule ID 65108 //
     /* 2209748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2209751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2209756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2209759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2209762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2209765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2209768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2209771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2209774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2209778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2209790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2209794 */     // MIs[0] round
     /* 2209794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2209797 */     // MIs[0] policy
     /* 2209797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2209800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2209807 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11012:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2209807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8_MASK),
     /* 2209810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2209814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2209816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2209818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2209820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2209822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2209827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2209832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209833 */     // GIR_Coverage, 65108,
     /* 2209833 */     GIR_EraseRootFromParent_Done,
     /* 2209834 */   // Label 29037: @2209834
     /* 2209834 */   GIM_Reject,
     /* 2209835 */ // Label 26969: @2209835
     /* 2209835 */ GIM_Reject,
     /* 2209836 */ // Label 38: @2209836
     /* 2209836 */ GIM_Try, /*On fail goto*//*Label 29038*/ GIMT_Encode4(2209888),
     /* 2209841 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 2209844 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::riscv_pause),
     /* 2209849 */   GIM_Try, /*On fail goto*//*Label 29039*/ GIMT_Encode4(2209868), // Rule ID 289 //
     /* 2209854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZihintpause_HwMode0),
     /* 2209857 */     // (intrinsic_void 11016:{ *:[iPTR] })  =>  (FENCE 1:{ *:[i64] }, 0:{ *:[i64] })
     /* 2209857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /* 2209860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2209863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209867 */     // GIR_Coverage, 289,
     /* 2209867 */     GIR_EraseRootFromParent_Done,
     /* 2209868 */   // Label 29039: @2209868
     /* 2209868 */   GIM_Try, /*On fail goto*//*Label 29040*/ GIMT_Encode4(2209887), // Rule ID 290 //
     /* 2209873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZihintpause_HwMode1),
     /* 2209876 */     // (intrinsic_void 11016:{ *:[iPTR] })  =>  (FENCE 1:{ *:[i32] }, 0:{ *:[i32] })
     /* 2209876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /* 2209879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2209882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2209885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209886 */     // GIR_Coverage, 290,
     /* 2209886 */     GIR_EraseRootFromParent_Done,
     /* 2209887 */   // Label 29040: @2209887
     /* 2209887 */   GIM_Reject,
     /* 2209888 */ // Label 29038: @2209888
     /* 2209888 */ GIM_Try, /*On fail goto*//*Label 29041*/ GIMT_Encode4(2209971), // Rule ID 35 //
     /* 2209893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2209896 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 2209899 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 2209904 */   // MIs[0] Operand 1
     /* 2209904 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 2209908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRX5RegClassID),
     /* 2209912 */   // MIs[0] ptr
     /* 2209912 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2209916 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRJALRRegClassID),
     /* 2209920 */   // MIs[0] accessinfo
     /* 2209920 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 2209923 */   // (intrinsic_void 192:{ *:[iPTR] }, X5:{ *:[i64] }, GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 2209923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 2209927 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X5), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209933 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X5
     /* 2209937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 2209940 */   GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 2209942 */   GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 2209944 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X1*/0,
     /* 2209947 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X6*/1,
     /* 2209950 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X7*/2,
     /* 2209953 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X28*/3,
     /* 2209956 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X29*/4,
     /* 2209959 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X30*/5,
     /* 2209962 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X31*/6,
     /* 2209965 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2209969 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209970 */   // GIR_Coverage, 35,
     /* 2209970 */   GIR_EraseRootFromParent_Done,
     /* 2209971 */ // Label 29041: @2209971
     /* 2209971 */ GIM_Try, /*On fail goto*//*Label 29042*/ GIMT_Encode4(2210876),
     /* 2209976 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 2209979 */   GIM_Try, /*On fail goto*//*Label 29043*/ GIMT_Encode4(2210051), // Rule ID 623 //
     /* 2209984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2209987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i32),
     /* 2209992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2209995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2209998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2210001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210005 */     // MIs[0] addr
     /* 2210005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2210009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210021 */     // MIs[0] ordering
     /* 2210021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2210024 */     // (intrinsic_w_chain:{ *:[i32] } 10999:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2210024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2210027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2210030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2210032 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210037 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2210039 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2210041 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2210043 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2210045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2210049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210050 */     // GIR_Coverage, 623,
     /* 2210050 */     GIR_EraseRootFromParent_Done,
     /* 2210051 */   // Label 29043: @2210051
     /* 2210051 */   GIM_Try, /*On fail goto*//*Label 29044*/ GIMT_Encode4(2210123), // Rule ID 624 //
     /* 2210056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2210059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i32),
     /* 2210064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2210067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2210070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2210073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210077 */     // MIs[0] addr
     /* 2210077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2210081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210093 */     // MIs[0] ordering
     /* 2210093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2210096 */     // (intrinsic_w_chain:{ *:[i32] } 10985:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2210096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2210099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2210102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2210104 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210109 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2210111 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2210113 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2210115 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2210117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2210121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210122 */     // GIR_Coverage, 624,
     /* 2210122 */     GIR_EraseRootFromParent_Done,
     /* 2210123 */   // Label 29044: @2210123
     /* 2210123 */   GIM_Try, /*On fail goto*//*Label 29045*/ GIMT_Encode4(2210195), // Rule ID 625 //
     /* 2210128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2210131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i32),
     /* 2210136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2210139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2210142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2210145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210149 */     // MIs[0] addr
     /* 2210149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2210153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210165 */     // MIs[0] ordering
     /* 2210165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2210168 */     // (intrinsic_w_chain:{ *:[i32] } 10993:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2210168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2210171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2210174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2210176 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210181 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2210183 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2210185 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2210187 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2210189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2210193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210194 */     // GIR_Coverage, 625,
     /* 2210194 */     GIR_EraseRootFromParent_Done,
     /* 2210195 */   // Label 29045: @2210195
     /* 2210195 */   GIM_Try, /*On fail goto*//*Label 29046*/ GIMT_Encode4(2210267), // Rule ID 626 //
     /* 2210200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2210203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i32),
     /* 2210208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2210211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2210214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2210217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210221 */     // MIs[0] addr
     /* 2210221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2210225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210237 */     // MIs[0] ordering
     /* 2210237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2210240 */     // (intrinsic_w_chain:{ *:[i32] } 10991:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2210240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2210243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2210246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2210248 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210253 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2210255 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2210257 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2210259 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2210261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2210265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210266 */     // GIR_Coverage, 626,
     /* 2210266 */     GIR_EraseRootFromParent_Done,
     /* 2210267 */   // Label 29046: @2210267
     /* 2210267 */   GIM_Try, /*On fail goto*//*Label 29047*/ GIMT_Encode4(2210347), // Rule ID 629 //
     /* 2210272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2210275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i32),
     /* 2210280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2210283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2210286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2210289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210293 */     // MIs[0] addr
     /* 2210293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2210297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210309 */     // MIs[0] ordering
     /* 2210309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2210312 */     // (intrinsic_w_chain:{ *:[i32] } 10995:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2210312 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2210315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2210318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2210321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2210323 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210328 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210333 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2210335 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2210337 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2210339 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2210341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2210345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210346 */     // GIR_Coverage, 629,
     /* 2210346 */     GIR_EraseRootFromParent_Done,
     /* 2210347 */   // Label 29047: @2210347
     /* 2210347 */   GIM_Try, /*On fail goto*//*Label 29048*/ GIMT_Encode4(2210427), // Rule ID 630 //
     /* 2210352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2210355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i32),
     /* 2210360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2210363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2210366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2210369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210373 */     // MIs[0] addr
     /* 2210373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2210377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210389 */     // MIs[0] ordering
     /* 2210389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2210392 */     // (intrinsic_w_chain:{ *:[i32] } 10997:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2210392 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2210395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2210398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2210401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2210403 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210408 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210413 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2210415 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2210417 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2210419 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2210421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2210425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210426 */     // GIR_Coverage, 630,
     /* 2210426 */     GIR_EraseRootFromParent_Done,
     /* 2210427 */   // Label 29048: @2210427
     /* 2210427 */   GIM_Try, /*On fail goto*//*Label 29049*/ GIMT_Encode4(2210499), // Rule ID 636 //
     /* 2210432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2210435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i64),
     /* 2210440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2210443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2210446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2210449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210453 */     // MIs[0] addr
     /* 2210453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2210457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210469 */     // MIs[0] ordering
     /* 2210469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2210472 */     // (intrinsic_w_chain:{ *:[i64] } 11000:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2210472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2210475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2210478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2210480 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210485 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2210487 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2210489 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2210491 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2210493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2210497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210498 */     // GIR_Coverage, 636,
     /* 2210498 */     GIR_EraseRootFromParent_Done,
     /* 2210499 */   // Label 29049: @2210499
     /* 2210499 */   GIM_Try, /*On fail goto*//*Label 29050*/ GIMT_Encode4(2210571), // Rule ID 637 //
     /* 2210504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2210507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i64),
     /* 2210512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2210515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2210518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2210521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210525 */     // MIs[0] addr
     /* 2210525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2210529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210541 */     // MIs[0] ordering
     /* 2210541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2210544 */     // (intrinsic_w_chain:{ *:[i64] } 10986:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2210544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2210547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2210550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2210552 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210557 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2210559 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2210561 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2210563 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2210565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2210569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210570 */     // GIR_Coverage, 637,
     /* 2210570 */     GIR_EraseRootFromParent_Done,
     /* 2210571 */   // Label 29050: @2210571
     /* 2210571 */   GIM_Try, /*On fail goto*//*Label 29051*/ GIMT_Encode4(2210643), // Rule ID 638 //
     /* 2210576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2210579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i64),
     /* 2210584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2210587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2210590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2210593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210597 */     // MIs[0] addr
     /* 2210597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2210601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210613 */     // MIs[0] ordering
     /* 2210613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2210616 */     // (intrinsic_w_chain:{ *:[i64] } 10994:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2210616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2210619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2210622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2210624 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210629 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2210631 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2210633 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2210635 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2210637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2210641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210642 */     // GIR_Coverage, 638,
     /* 2210642 */     GIR_EraseRootFromParent_Done,
     /* 2210643 */   // Label 29051: @2210643
     /* 2210643 */   GIM_Try, /*On fail goto*//*Label 29052*/ GIMT_Encode4(2210715), // Rule ID 639 //
     /* 2210648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2210651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i64),
     /* 2210656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2210659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2210662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2210665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210669 */     // MIs[0] addr
     /* 2210669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2210673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210685 */     // MIs[0] ordering
     /* 2210685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2210688 */     // (intrinsic_w_chain:{ *:[i64] } 10992:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2210688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2210691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2210694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2210696 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210701 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2210703 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2210705 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2210707 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2210709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2210713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210714 */     // GIR_Coverage, 639,
     /* 2210714 */     GIR_EraseRootFromParent_Done,
     /* 2210715 */   // Label 29052: @2210715
     /* 2210715 */   GIM_Try, /*On fail goto*//*Label 29053*/ GIMT_Encode4(2210795), // Rule ID 642 //
     /* 2210720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2210723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i64),
     /* 2210728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2210731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2210734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2210737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210741 */     // MIs[0] addr
     /* 2210741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2210745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210757 */     // MIs[0] ordering
     /* 2210757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2210760 */     // (intrinsic_w_chain:{ *:[i64] } 10996:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2210760 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2210763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2210766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2210769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2210771 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210776 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210781 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2210783 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2210785 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2210787 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2210789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2210793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210794 */     // GIR_Coverage, 642,
     /* 2210794 */     GIR_EraseRootFromParent_Done,
     /* 2210795 */   // Label 29053: @2210795
     /* 2210795 */   GIM_Try, /*On fail goto*//*Label 29054*/ GIMT_Encode4(2210875), // Rule ID 643 //
     /* 2210800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2210803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i64),
     /* 2210808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2210811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2210814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2210817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210821 */     // MIs[0] addr
     /* 2210821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2210825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210837 */     // MIs[0] ordering
     /* 2210837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2210840 */     // (intrinsic_w_chain:{ *:[i64] } 10998:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2210840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2210843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2210846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2210849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2210851 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210856 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210861 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2210863 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2210865 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2210867 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2210869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2210873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210874 */     // GIR_Coverage, 643,
     /* 2210874 */     GIR_EraseRootFromParent_Done,
     /* 2210875 */   // Label 29054: @2210875
     /* 2210875 */   GIM_Reject,
     /* 2210876 */ // Label 29042: @2210876
     /* 2210876 */ GIM_Try, /*On fail goto*//*Label 29055*/ GIMT_Encode4(2211403),
     /* 2210881 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 2210884 */   GIM_Try, /*On fail goto*//*Label 29056*/ GIMT_Encode4(2210973), // Rule ID 627 //
     /* 2210889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2210892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i32),
     /* 2210897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2210900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2210903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2210906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2210909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210913 */     // MIs[0] addr
     /* 2210913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2210917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210933 */     // MIs[0] ordering
     /* 2210933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2210936 */     // (intrinsic_w_chain:{ *:[i32] } 10987:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2210936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2210939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2210942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2210945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2210947 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210952 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2210957 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2210959 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2210961 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2210963 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2210965 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2210967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2210971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210972 */     // GIR_Coverage, 627,
     /* 2210972 */     GIR_EraseRootFromParent_Done,
     /* 2210973 */   // Label 29056: @2210973
     /* 2210973 */   GIM_Try, /*On fail goto*//*Label 29057*/ GIMT_Encode4(2211062), // Rule ID 628 //
     /* 2210978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2210981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i32),
     /* 2210986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2210989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2210992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2210995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2210998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211002 */     // MIs[0] addr
     /* 2211002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2211006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211022 */     // MIs[0] ordering
     /* 2211022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2211025 */     // (intrinsic_w_chain:{ *:[i32] } 10989:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2211025 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2211028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2211031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2211034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2211036 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2211041 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2211046 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2211048 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2211050 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2211052 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2211054 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2211056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2211060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211061 */     // GIR_Coverage, 628,
     /* 2211061 */     GIR_EraseRootFromParent_Done,
     /* 2211062 */   // Label 29057: @2211062
     /* 2211062 */   GIM_Try, /*On fail goto*//*Label 29058*/ GIMT_Encode4(2211151), // Rule ID 640 //
     /* 2211067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2211070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i64),
     /* 2211075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2211078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2211081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2211084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2211087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211091 */     // MIs[0] addr
     /* 2211091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2211095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211111 */     // MIs[0] ordering
     /* 2211111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2211114 */     // (intrinsic_w_chain:{ *:[i64] } 10988:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2211114 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2211117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2211120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2211123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2211125 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2211130 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2211135 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2211137 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2211139 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2211141 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2211143 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2211145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2211149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211150 */     // GIR_Coverage, 640,
     /* 2211150 */     GIR_EraseRootFromParent_Done,
     /* 2211151 */   // Label 29058: @2211151
     /* 2211151 */   GIM_Try, /*On fail goto*//*Label 29059*/ GIMT_Encode4(2211240), // Rule ID 641 //
     /* 2211156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2211159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i64),
     /* 2211164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2211167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2211170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2211173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2211176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211180 */     // MIs[0] addr
     /* 2211180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2211184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211200 */     // MIs[0] ordering
     /* 2211200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2211203 */     // (intrinsic_w_chain:{ *:[i64] } 10990:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2211203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2211206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2211209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2211212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2211214 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2211219 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2211224 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2211226 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2211228 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2211230 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2211232 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2211234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2211238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211239 */     // GIR_Coverage, 641,
     /* 2211239 */     GIR_EraseRootFromParent_Done,
     /* 2211240 */   // Label 29059: @2211240
     /* 2211240 */   GIM_Try, /*On fail goto*//*Label 29060*/ GIMT_Encode4(2211321), // Rule ID 659 //
     /* 2211245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2211248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i32),
     /* 2211253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2211256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2211259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2211262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2211265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211269 */     // MIs[0] addr
     /* 2211269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2211273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211289 */     // MIs[0] ordering
     /* 2211289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2211292 */     // (intrinsic_w_chain:{ *:[i32] } 11001:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2211292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2211295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2211298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2211300 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2211305 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2211307 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2211309 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2211311 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2211313 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2211315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2211319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211320 */     // GIR_Coverage, 659,
     /* 2211320 */     GIR_EraseRootFromParent_Done,
     /* 2211321 */   // Label 29060: @2211321
     /* 2211321 */   GIM_Try, /*On fail goto*//*Label 29061*/ GIMT_Encode4(2211402), // Rule ID 660 //
     /* 2211326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2211329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i64),
     /* 2211334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2211337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2211340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2211343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2211346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211350 */     // MIs[0] addr
     /* 2211350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2211354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211370 */     // MIs[0] ordering
     /* 2211370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2211373 */     // (intrinsic_w_chain:{ *:[i64] } 11002:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2211373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2211376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2211379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2211381 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2211386 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2211388 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2211390 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2211392 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2211394 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2211396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2211400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211401 */     // GIR_Coverage, 660,
     /* 2211401 */     GIR_EraseRootFromParent_Done,
     /* 2211402 */   // Label 29061: @2211402
     /* 2211402 */   GIM_Reject,
     /* 2211403 */ // Label 29055: @2211403
     /* 2211403 */ GIM_Reject,
     /* 2211404 */ // Label 39: @2211404
     /* 2211404 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(32), /*)*//*default:*//*Label 29077*/ GIMT_Encode4(2214524),
     /* 2211415 */ /*GILLT_nxv1s16*//*Label 29062*/ GIMT_Encode4(2211515),
     /* 2211419 */ /*GILLT_nxv1s32*//*Label 29063*/ GIMT_Encode4(2211619),
     /* 2211423 */ /*GILLT_nxv1s64*//*Label 29064*/ GIMT_Encode4(2211836), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211435 */ /*GILLT_nxv2s16*//*Label 29065*/ GIMT_Encode4(2212161),
     /* 2211439 */ /*GILLT_nxv2s32*//*Label 29066*/ GIMT_Encode4(2212265),
     /* 2211443 */ /*GILLT_nxv2s64*//*Label 29067*/ GIMT_Encode4(2212482), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211455 */ /*GILLT_nxv4s16*//*Label 29068*/ GIMT_Encode4(2212807),
     /* 2211459 */ /*GILLT_nxv4s32*//*Label 29069*/ GIMT_Encode4(2212911),
     /* 2211463 */ /*GILLT_nxv4s64*//*Label 29070*/ GIMT_Encode4(2213128), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211475 */ /*GILLT_nxv8s16*//*Label 29071*/ GIMT_Encode4(2213453),
     /* 2211479 */ /*GILLT_nxv8s32*//*Label 29072*/ GIMT_Encode4(2213557),
     /* 2211483 */ /*GILLT_nxv8s64*//*Label 29073*/ GIMT_Encode4(2213774), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211495 */ /*GILLT_nxv16s16*//*Label 29074*/ GIMT_Encode4(2214099),
     /* 2211499 */ /*GILLT_nxv16s32*//*Label 29075*/ GIMT_Encode4(2214203), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211511 */ /*GILLT_nxv32s16*//*Label 29076*/ GIMT_Encode4(2214420),
     /* 2211515 */ // Label 29062: @2211515
     /* 2211515 */ GIM_Try, /*On fail goto*//*Label 29078*/ GIMT_Encode4(2211618),
     /* 2211520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211531 */   GIM_Try, /*On fail goto*//*Label 29079*/ GIMT_Encode4(2211574), // Rule ID 47478 //
     /* 2211536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211539 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2211542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2211556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211573 */     // GIR_Coverage, 47478,
     /* 2211573 */     GIR_EraseRootFromParent_Done,
     /* 2211574 */   // Label 29079: @2211574
     /* 2211574 */   GIM_Try, /*On fail goto*//*Label 29080*/ GIMT_Encode4(2211617), // Rule ID 47479 //
     /* 2211579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211582 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2211585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2211599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211616 */     // GIR_Coverage, 47479,
     /* 2211616 */     GIR_EraseRootFromParent_Done,
     /* 2211617 */   // Label 29080: @2211617
     /* 2211617 */   GIM_Reject,
     /* 2211618 */ // Label 29078: @2211618
     /* 2211618 */ GIM_Reject,
     /* 2211619 */ // Label 29063: @2211619
     /* 2211619 */ GIM_Try, /*On fail goto*//*Label 29081*/ GIMT_Encode4(2211673), // Rule ID 47502 //
     /* 2211624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211638 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211638 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211641 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211645 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211650 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2211655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211657 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211660 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211671 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211672 */   // GIR_Coverage, 47502,
     /* 2211672 */   GIR_EraseRootFromParent_Done,
     /* 2211673 */ // Label 29081: @2211673
     /* 2211673 */ GIM_Try, /*On fail goto*//*Label 29082*/ GIMT_Encode4(2211727), // Rule ID 47503 //
     /* 2211678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211692 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211692 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211695 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211699 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2211709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211711 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211714 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211725 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211726 */   // GIR_Coverage, 47503,
     /* 2211726 */   GIR_EraseRootFromParent_Done,
     /* 2211727 */ // Label 29082: @2211727
     /* 2211727 */ GIM_Try, /*On fail goto*//*Label 29083*/ GIMT_Encode4(2211781), // Rule ID 47568 //
     /* 2211732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211746 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2211763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211768 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211780 */   // GIR_Coverage, 47568,
     /* 2211780 */   GIR_EraseRootFromParent_Done,
     /* 2211781 */ // Label 29083: @2211781
     /* 2211781 */ GIM_Try, /*On fail goto*//*Label 29084*/ GIMT_Encode4(2211835), // Rule ID 47569 //
     /* 2211786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211800 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211800 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211803 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211807 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2211817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211819 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211822 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211833 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211834 */   // GIR_Coverage, 47569,
     /* 2211834 */   GIR_EraseRootFromParent_Done,
     /* 2211835 */ // Label 29084: @2211835
     /* 2211835 */ GIM_Reject,
     /* 2211836 */ // Label 29064: @2211836
     /* 2211836 */ GIM_Try, /*On fail goto*//*Label 29085*/ GIMT_Encode4(2211890), // Rule ID 47522 //
     /* 2211841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2211844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211855 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2211872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211877 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211888 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211889 */   // GIR_Coverage, 47522,
     /* 2211889 */   GIR_EraseRootFromParent_Done,
     /* 2211890 */ // Label 29085: @2211890
     /* 2211890 */ GIM_Try, /*On fail goto*//*Label 29086*/ GIMT_Encode4(2211944), // Rule ID 47523 //
     /* 2211895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2211898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211909 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211909 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211912 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211916 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2211926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211928 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211931 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211942 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211943 */   // GIR_Coverage, 47523,
     /* 2211943 */   GIR_EraseRootFromParent_Done,
     /* 2211944 */ // Label 29086: @2211944
     /* 2211944 */ GIM_Try, /*On fail goto*//*Label 29087*/ GIMT_Encode4(2211998), // Rule ID 47588 //
     /* 2211949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2211952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211963 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211963 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211966 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211970 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2211980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211985 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211997 */   // GIR_Coverage, 47588,
     /* 2211997 */   GIR_EraseRootFromParent_Done,
     /* 2211998 */ // Label 29087: @2211998
     /* 2211998 */ GIM_Try, /*On fail goto*//*Label 29088*/ GIMT_Encode4(2212052), // Rule ID 47589 //
     /* 2212003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2212009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212017 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212017 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212020 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212024 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2212034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212039 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212050 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212051 */   // GIR_Coverage, 47589,
     /* 2212051 */   GIR_EraseRootFromParent_Done,
     /* 2212052 */ // Label 29088: @2212052
     /* 2212052 */ GIM_Try, /*On fail goto*//*Label 29089*/ GIMT_Encode4(2212106), // Rule ID 47622 //
     /* 2212057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2212063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212071 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212071 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212074 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212078 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2212088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212093 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212104 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212105 */   // GIR_Coverage, 47622,
     /* 2212105 */   GIR_EraseRootFromParent_Done,
     /* 2212106 */ // Label 29089: @2212106
     /* 2212106 */ GIM_Try, /*On fail goto*//*Label 29090*/ GIMT_Encode4(2212160), // Rule ID 47623 //
     /* 2212111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2212117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212125 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2212142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212147 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212159 */   // GIR_Coverage, 47623,
     /* 2212159 */   GIR_EraseRootFromParent_Done,
     /* 2212160 */ // Label 29090: @2212160
     /* 2212160 */ GIM_Reject,
     /* 2212161 */ // Label 29065: @2212161
     /* 2212161 */ GIM_Try, /*On fail goto*//*Label 29091*/ GIMT_Encode4(2212264),
     /* 2212166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212177 */   GIM_Try, /*On fail goto*//*Label 29092*/ GIMT_Encode4(2212220), // Rule ID 47482 //
     /* 2212182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212185 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2212188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2212202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212219 */     // GIR_Coverage, 47482,
     /* 2212219 */     GIR_EraseRootFromParent_Done,
     /* 2212220 */   // Label 29092: @2212220
     /* 2212220 */   GIM_Try, /*On fail goto*//*Label 29093*/ GIMT_Encode4(2212263), // Rule ID 47483 //
     /* 2212225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212228 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2212231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2212245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212262 */     // GIR_Coverage, 47483,
     /* 2212262 */     GIR_EraseRootFromParent_Done,
     /* 2212263 */   // Label 29093: @2212263
     /* 2212263 */   GIM_Reject,
     /* 2212264 */ // Label 29091: @2212264
     /* 2212264 */ GIM_Reject,
     /* 2212265 */ // Label 29066: @2212265
     /* 2212265 */ GIM_Try, /*On fail goto*//*Label 29094*/ GIMT_Encode4(2212319), // Rule ID 47506 //
     /* 2212270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212284 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212284 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212287 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212291 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2212301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212306 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212317 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212318 */   // GIR_Coverage, 47506,
     /* 2212318 */   GIR_EraseRootFromParent_Done,
     /* 2212319 */ // Label 29094: @2212319
     /* 2212319 */ GIM_Try, /*On fail goto*//*Label 29095*/ GIMT_Encode4(2212373), // Rule ID 47507 //
     /* 2212324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212338 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212338 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212341 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212345 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2212355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212357 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212360 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212371 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212372 */   // GIR_Coverage, 47507,
     /* 2212372 */   GIR_EraseRootFromParent_Done,
     /* 2212373 */ // Label 29095: @2212373
     /* 2212373 */ GIM_Try, /*On fail goto*//*Label 29096*/ GIMT_Encode4(2212427), // Rule ID 47572 //
     /* 2212378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212392 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2212409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212414 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212425 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212426 */   // GIR_Coverage, 47572,
     /* 2212426 */   GIR_EraseRootFromParent_Done,
     /* 2212427 */ // Label 29096: @2212427
     /* 2212427 */ GIM_Try, /*On fail goto*//*Label 29097*/ GIMT_Encode4(2212481), // Rule ID 47573 //
     /* 2212432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212446 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2212463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212465 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212468 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212479 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212480 */   // GIR_Coverage, 47573,
     /* 2212480 */   GIR_EraseRootFromParent_Done,
     /* 2212481 */ // Label 29097: @2212481
     /* 2212481 */ GIM_Reject,
     /* 2212482 */ // Label 29067: @2212482
     /* 2212482 */ GIM_Try, /*On fail goto*//*Label 29098*/ GIMT_Encode4(2212536), // Rule ID 47526 //
     /* 2212487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212501 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2212518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212523 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212534 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212535 */   // GIR_Coverage, 47526,
     /* 2212535 */   GIR_EraseRootFromParent_Done,
     /* 2212536 */ // Label 29098: @2212536
     /* 2212536 */ GIM_Try, /*On fail goto*//*Label 29099*/ GIMT_Encode4(2212590), // Rule ID 47527 //
     /* 2212541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212555 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2212572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212577 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212588 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212589 */   // GIR_Coverage, 47527,
     /* 2212589 */   GIR_EraseRootFromParent_Done,
     /* 2212590 */ // Label 29099: @2212590
     /* 2212590 */ GIM_Try, /*On fail goto*//*Label 29100*/ GIMT_Encode4(2212644), // Rule ID 47592 //
     /* 2212595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212609 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212609 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212612 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212616 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212621 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2212626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212631 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212642 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212643 */   // GIR_Coverage, 47592,
     /* 2212643 */   GIR_EraseRootFromParent_Done,
     /* 2212644 */ // Label 29100: @2212644
     /* 2212644 */ GIM_Try, /*On fail goto*//*Label 29101*/ GIMT_Encode4(2212698), // Rule ID 47593 //
     /* 2212649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212663 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2212680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212685 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212696 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212697 */   // GIR_Coverage, 47593,
     /* 2212697 */   GIR_EraseRootFromParent_Done,
     /* 2212698 */ // Label 29101: @2212698
     /* 2212698 */ GIM_Try, /*On fail goto*//*Label 29102*/ GIMT_Encode4(2212752), // Rule ID 47626 //
     /* 2212703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212717 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212717 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212720 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212724 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212729 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2212734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212736 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212739 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212750 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212751 */   // GIR_Coverage, 47626,
     /* 2212751 */   GIR_EraseRootFromParent_Done,
     /* 2212752 */ // Label 29102: @2212752
     /* 2212752 */ GIM_Try, /*On fail goto*//*Label 29103*/ GIMT_Encode4(2212806), // Rule ID 47627 //
     /* 2212757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212771 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212771 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212774 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212778 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2212788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212790 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212793 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212804 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212805 */   // GIR_Coverage, 47627,
     /* 2212805 */   GIR_EraseRootFromParent_Done,
     /* 2212806 */ // Label 29103: @2212806
     /* 2212806 */ GIM_Reject,
     /* 2212807 */ // Label 29068: @2212807
     /* 2212807 */ GIM_Try, /*On fail goto*//*Label 29104*/ GIMT_Encode4(2212910),
     /* 2212812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2212815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212823 */   GIM_Try, /*On fail goto*//*Label 29105*/ GIMT_Encode4(2212866), // Rule ID 47486 //
     /* 2212828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212831 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2212834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2212848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212865 */     // GIR_Coverage, 47486,
     /* 2212865 */     GIR_EraseRootFromParent_Done,
     /* 2212866 */   // Label 29105: @2212866
     /* 2212866 */   GIM_Try, /*On fail goto*//*Label 29106*/ GIMT_Encode4(2212909), // Rule ID 47487 //
     /* 2212871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212874 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2212877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2212891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212908 */     // GIR_Coverage, 47487,
     /* 2212908 */     GIR_EraseRootFromParent_Done,
     /* 2212909 */   // Label 29106: @2212909
     /* 2212909 */   GIM_Reject,
     /* 2212910 */ // Label 29104: @2212910
     /* 2212910 */ GIM_Reject,
     /* 2212911 */ // Label 29069: @2212911
     /* 2212911 */ GIM_Try, /*On fail goto*//*Label 29107*/ GIMT_Encode4(2212965), // Rule ID 47510 //
     /* 2212916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2212922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212930 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2212933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2212947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212949 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212952 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212964 */   // GIR_Coverage, 47510,
     /* 2212964 */   GIR_EraseRootFromParent_Done,
     /* 2212965 */ // Label 29107: @2212965
     /* 2212965 */ GIM_Try, /*On fail goto*//*Label 29108*/ GIMT_Encode4(2213019), // Rule ID 47511 //
     /* 2212970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2212976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212984 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212984 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2212987 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212991 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2213001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213006 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213017 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213018 */   // GIR_Coverage, 47511,
     /* 2213018 */   GIR_EraseRootFromParent_Done,
     /* 2213019 */ // Label 29108: @2213019
     /* 2213019 */ GIM_Try, /*On fail goto*//*Label 29109*/ GIMT_Encode4(2213073), // Rule ID 47576 //
     /* 2213024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213038 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213038 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213041 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213045 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2213055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213057 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213060 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213071 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213072 */   // GIR_Coverage, 47576,
     /* 2213072 */   GIR_EraseRootFromParent_Done,
     /* 2213073 */ // Label 29109: @2213073
     /* 2213073 */ GIM_Try, /*On fail goto*//*Label 29110*/ GIMT_Encode4(2213127), // Rule ID 47577 //
     /* 2213078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213092 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2213109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213114 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213125 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213126 */   // GIR_Coverage, 47577,
     /* 2213126 */   GIR_EraseRootFromParent_Done,
     /* 2213127 */ // Label 29110: @2213127
     /* 2213127 */ GIM_Reject,
     /* 2213128 */ // Label 29070: @2213128
     /* 2213128 */ GIM_Try, /*On fail goto*//*Label 29111*/ GIMT_Encode4(2213182), // Rule ID 47530 //
     /* 2213133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2213139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213147 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213147 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213150 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213154 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2213164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213169 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213180 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213181 */   // GIR_Coverage, 47530,
     /* 2213181 */   GIR_EraseRootFromParent_Done,
     /* 2213182 */ // Label 29111: @2213182
     /* 2213182 */ GIM_Try, /*On fail goto*//*Label 29112*/ GIMT_Encode4(2213236), // Rule ID 47531 //
     /* 2213187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2213193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213201 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2213218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213223 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213234 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213235 */   // GIR_Coverage, 47531,
     /* 2213235 */   GIR_EraseRootFromParent_Done,
     /* 2213236 */ // Label 29112: @2213236
     /* 2213236 */ GIM_Try, /*On fail goto*//*Label 29113*/ GIMT_Encode4(2213290), // Rule ID 47596 //
     /* 2213241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213255 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213255 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213258 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213262 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2213272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213274 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213277 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213288 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213289 */   // GIR_Coverage, 47596,
     /* 2213289 */   GIR_EraseRootFromParent_Done,
     /* 2213290 */ // Label 29113: @2213290
     /* 2213290 */ GIM_Try, /*On fail goto*//*Label 29114*/ GIMT_Encode4(2213344), // Rule ID 47597 //
     /* 2213295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213309 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2213326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213331 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213342 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213343 */   // GIR_Coverage, 47597,
     /* 2213343 */   GIR_EraseRootFromParent_Done,
     /* 2213344 */ // Label 29114: @2213344
     /* 2213344 */ GIM_Try, /*On fail goto*//*Label 29115*/ GIMT_Encode4(2213398), // Rule ID 47630 //
     /* 2213349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213363 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213363 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213366 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213370 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2213380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213385 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213397 */   // GIR_Coverage, 47630,
     /* 2213397 */   GIR_EraseRootFromParent_Done,
     /* 2213398 */ // Label 29115: @2213398
     /* 2213398 */ GIM_Try, /*On fail goto*//*Label 29116*/ GIMT_Encode4(2213452), // Rule ID 47631 //
     /* 2213403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213417 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213417 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213420 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213424 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2213434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213439 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213450 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213451 */   // GIR_Coverage, 47631,
     /* 2213451 */   GIR_EraseRootFromParent_Done,
     /* 2213452 */ // Label 29116: @2213452
     /* 2213452 */ GIM_Reject,
     /* 2213453 */ // Label 29071: @2213453
     /* 2213453 */ GIM_Try, /*On fail goto*//*Label 29117*/ GIMT_Encode4(2213556),
     /* 2213458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213469 */   GIM_Try, /*On fail goto*//*Label 29118*/ GIMT_Encode4(2213512), // Rule ID 47490 //
     /* 2213474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213477 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2213480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2213494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213511 */     // GIR_Coverage, 47490,
     /* 2213511 */     GIR_EraseRootFromParent_Done,
     /* 2213512 */   // Label 29118: @2213512
     /* 2213512 */   GIM_Try, /*On fail goto*//*Label 29119*/ GIMT_Encode4(2213555), // Rule ID 47491 //
     /* 2213517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213520 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2213523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2213537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213554 */     // GIR_Coverage, 47491,
     /* 2213554 */     GIR_EraseRootFromParent_Done,
     /* 2213555 */   // Label 29119: @2213555
     /* 2213555 */   GIM_Reject,
     /* 2213556 */ // Label 29117: @2213556
     /* 2213556 */ GIM_Reject,
     /* 2213557 */ // Label 29072: @2213557
     /* 2213557 */ GIM_Try, /*On fail goto*//*Label 29120*/ GIMT_Encode4(2213611), // Rule ID 47514 //
     /* 2213562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213576 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213588 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2213593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213595 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213598 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213609 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213610 */   // GIR_Coverage, 47514,
     /* 2213610 */   GIR_EraseRootFromParent_Done,
     /* 2213611 */ // Label 29120: @2213611
     /* 2213611 */ GIM_Try, /*On fail goto*//*Label 29121*/ GIMT_Encode4(2213665), // Rule ID 47515 //
     /* 2213616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213630 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213630 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213633 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213637 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2213647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213649 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213652 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213663 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213664 */   // GIR_Coverage, 47515,
     /* 2213664 */   GIR_EraseRootFromParent_Done,
     /* 2213665 */ // Label 29121: @2213665
     /* 2213665 */ GIM_Try, /*On fail goto*//*Label 29122*/ GIMT_Encode4(2213719), // Rule ID 47580 //
     /* 2213670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213684 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213684 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213687 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213691 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2213701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213703 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213706 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213717 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213718 */   // GIR_Coverage, 47580,
     /* 2213718 */   GIR_EraseRootFromParent_Done,
     /* 2213719 */ // Label 29122: @2213719
     /* 2213719 */ GIM_Try, /*On fail goto*//*Label 29123*/ GIMT_Encode4(2213773), // Rule ID 47581 //
     /* 2213724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213738 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2213755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213760 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213772 */   // GIR_Coverage, 47581,
     /* 2213772 */   GIR_EraseRootFromParent_Done,
     /* 2213773 */ // Label 29123: @2213773
     /* 2213773 */ GIM_Reject,
     /* 2213774 */ // Label 29073: @2213774
     /* 2213774 */ GIM_Try, /*On fail goto*//*Label 29124*/ GIMT_Encode4(2213828), // Rule ID 47534 //
     /* 2213779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2213785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213793 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2213810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213815 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213826 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213827 */   // GIR_Coverage, 47534,
     /* 2213827 */   GIR_EraseRootFromParent_Done,
     /* 2213828 */ // Label 29124: @2213828
     /* 2213828 */ GIM_Try, /*On fail goto*//*Label 29125*/ GIMT_Encode4(2213882), // Rule ID 47535 //
     /* 2213833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2213839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213847 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213847 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213850 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213854 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2213864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213869 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213880 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213881 */   // GIR_Coverage, 47535,
     /* 2213881 */   GIR_EraseRootFromParent_Done,
     /* 2213882 */ // Label 29125: @2213882
     /* 2213882 */ GIM_Try, /*On fail goto*//*Label 29126*/ GIMT_Encode4(2213936), // Rule ID 47600 //
     /* 2213887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213901 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213901 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213904 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213908 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2213918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213920 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213923 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213935 */   // GIR_Coverage, 47600,
     /* 2213935 */   GIR_EraseRootFromParent_Done,
     /* 2213936 */ // Label 29126: @2213936
     /* 2213936 */ GIM_Try, /*On fail goto*//*Label 29127*/ GIMT_Encode4(2213990), // Rule ID 47601 //
     /* 2213941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213955 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2213972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213974 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213977 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213988 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213989 */   // GIR_Coverage, 47601,
     /* 2213989 */   GIR_EraseRootFromParent_Done,
     /* 2213990 */ // Label 29127: @2213990
     /* 2213990 */ GIM_Try, /*On fail goto*//*Label 29128*/ GIMT_Encode4(2214044), // Rule ID 47634 //
     /* 2213995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214009 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214009 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2214012 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214016 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2214026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214031 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214042 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214043 */   // GIR_Coverage, 47634,
     /* 2214043 */   GIR_EraseRootFromParent_Done,
     /* 2214044 */ // Label 29128: @2214044
     /* 2214044 */ GIM_Try, /*On fail goto*//*Label 29129*/ GIMT_Encode4(2214098), // Rule ID 47635 //
     /* 2214049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2214052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214063 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214063 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2214066 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214070 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2214080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214085 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214096 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214097 */   // GIR_Coverage, 47635,
     /* 2214097 */   GIR_EraseRootFromParent_Done,
     /* 2214098 */ // Label 29129: @2214098
     /* 2214098 */ GIM_Reject,
     /* 2214099 */ // Label 29074: @2214099
     /* 2214099 */ GIM_Try, /*On fail goto*//*Label 29130*/ GIMT_Encode4(2214202),
     /* 2214104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2214107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214115 */   GIM_Try, /*On fail goto*//*Label 29131*/ GIMT_Encode4(2214158), // Rule ID 47494 //
     /* 2214120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214123 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2214126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2214140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214157 */     // GIR_Coverage, 47494,
     /* 2214157 */     GIR_EraseRootFromParent_Done,
     /* 2214158 */   // Label 29131: @2214158
     /* 2214158 */   GIM_Try, /*On fail goto*//*Label 29132*/ GIMT_Encode4(2214201), // Rule ID 47495 //
     /* 2214163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214166 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2214169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2214183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214200 */     // GIR_Coverage, 47495,
     /* 2214200 */     GIR_EraseRootFromParent_Done,
     /* 2214201 */   // Label 29132: @2214201
     /* 2214201 */   GIM_Reject,
     /* 2214202 */ // Label 29130: @2214202
     /* 2214202 */ GIM_Reject,
     /* 2214203 */ // Label 29075: @2214203
     /* 2214203 */ GIM_Try, /*On fail goto*//*Label 29133*/ GIMT_Encode4(2214257), // Rule ID 47518 //
     /* 2214208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2214214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214222 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2214239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214244 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214255 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214256 */   // GIR_Coverage, 47518,
     /* 2214256 */   GIR_EraseRootFromParent_Done,
     /* 2214257 */ // Label 29133: @2214257
     /* 2214257 */ GIM_Try, /*On fail goto*//*Label 29134*/ GIMT_Encode4(2214311), // Rule ID 47519 //
     /* 2214262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2214268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214276 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2214293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214298 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214309 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214310 */   // GIR_Coverage, 47519,
     /* 2214310 */   GIR_EraseRootFromParent_Done,
     /* 2214311 */ // Label 29134: @2214311
     /* 2214311 */ GIM_Try, /*On fail goto*//*Label 29135*/ GIMT_Encode4(2214365), // Rule ID 47584 //
     /* 2214316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2214322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214330 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214342 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2214347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214349 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214352 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214363 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214364 */   // GIR_Coverage, 47584,
     /* 2214364 */   GIR_EraseRootFromParent_Done,
     /* 2214365 */ // Label 29135: @2214365
     /* 2214365 */ GIM_Try, /*On fail goto*//*Label 29136*/ GIMT_Encode4(2214419), // Rule ID 47585 //
     /* 2214370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2214376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214384 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214384 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214387 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214391 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2214401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214406 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214417 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214418 */   // GIR_Coverage, 47585,
     /* 2214418 */   GIR_EraseRootFromParent_Done,
     /* 2214419 */ // Label 29136: @2214419
     /* 2214419 */ GIM_Reject,
     /* 2214420 */ // Label 29076: @2214420
     /* 2214420 */ GIM_Try, /*On fail goto*//*Label 29137*/ GIMT_Encode4(2214523),
     /* 2214425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2214428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214436 */   GIM_Try, /*On fail goto*//*Label 29138*/ GIMT_Encode4(2214479), // Rule ID 47498 //
     /* 2214441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214444 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2214447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2214461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214478 */     // GIR_Coverage, 47498,
     /* 2214478 */     GIR_EraseRootFromParent_Done,
     /* 2214479 */   // Label 29138: @2214479
     /* 2214479 */   GIM_Try, /*On fail goto*//*Label 29139*/ GIMT_Encode4(2214522), // Rule ID 47499 //
     /* 2214484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214487 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2214490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2214504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214521 */     // GIR_Coverage, 47499,
     /* 2214521 */     GIR_EraseRootFromParent_Done,
     /* 2214522 */   // Label 29139: @2214522
     /* 2214522 */   GIM_Reject,
     /* 2214523 */ // Label 29137: @2214523
     /* 2214523 */ GIM_Reject,
     /* 2214524 */ // Label 29077: @2214524
     /* 2214524 */ GIM_Reject,
     /* 2214525 */ // Label 40: @2214525
     /* 2214525 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 29157*/ GIMT_Encode4(2217999),
     /* 2214536 */ /*GILLT_s32*//*Label 29140*/ GIMT_Encode4(2214652),
     /* 2214540 */ /*GILLT_s64*//*Label 29141*/ GIMT_Encode4(2214826), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2214552 */ /*GILLT_nxv1s16*//*Label 29142*/ GIMT_Encode4(2214990),
     /* 2214556 */ /*GILLT_nxv1s32*//*Label 29143*/ GIMT_Encode4(2215094),
     /* 2214560 */ /*GILLT_nxv1s64*//*Label 29144*/ GIMT_Encode4(2215311), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2214572 */ /*GILLT_nxv2s16*//*Label 29145*/ GIMT_Encode4(2215636),
     /* 2214576 */ /*GILLT_nxv2s32*//*Label 29146*/ GIMT_Encode4(2215740),
     /* 2214580 */ /*GILLT_nxv2s64*//*Label 29147*/ GIMT_Encode4(2215957), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2214592 */ /*GILLT_nxv4s16*//*Label 29148*/ GIMT_Encode4(2216282),
     /* 2214596 */ /*GILLT_nxv4s32*//*Label 29149*/ GIMT_Encode4(2216386),
     /* 2214600 */ /*GILLT_nxv4s64*//*Label 29150*/ GIMT_Encode4(2216603), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2214612 */ /*GILLT_nxv8s16*//*Label 29151*/ GIMT_Encode4(2216928),
     /* 2214616 */ /*GILLT_nxv8s32*//*Label 29152*/ GIMT_Encode4(2217032),
     /* 2214620 */ /*GILLT_nxv8s64*//*Label 29153*/ GIMT_Encode4(2217249), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2214632 */ /*GILLT_nxv16s16*//*Label 29154*/ GIMT_Encode4(2217574),
     /* 2214636 */ /*GILLT_nxv16s32*//*Label 29155*/ GIMT_Encode4(2217678), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2214648 */ /*GILLT_nxv32s16*//*Label 29156*/ GIMT_Encode4(2217895),
     /* 2214652 */ // Label 29140: @2214652
     /* 2214652 */ GIM_Try, /*On fail goto*//*Label 29158*/ GIMT_Encode4(2214825),
     /* 2214657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2214660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214668 */   GIM_Try, /*On fail goto*//*Label 29159*/ GIMT_Encode4(2214710), // Rule ID 65345 //
     /* 2214673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode1),
     /* 2214676 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2214676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2214679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2214683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2214692 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2214695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2214700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2214708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214709 */     // GIR_Coverage, 65345,
     /* 2214709 */     GIR_EraseRootFromParent_Done,
     /* 2214710 */   // Label 29159: @2214710
     /* 2214710 */   GIM_Try, /*On fail goto*//*Label 29160*/ GIMT_Encode4(2214752), // Rule ID 65347 //
     /* 2214715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2214718 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2214718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2214721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2214725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2214734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2214737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2214742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2214750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214751 */     // GIR_Coverage, 65347,
     /* 2214751 */     GIR_EraseRootFromParent_Done,
     /* 2214752 */   // Label 29160: @2214752
     /* 2214752 */   GIM_Try, /*On fail goto*//*Label 29161*/ GIMT_Encode4(2214794), // Rule ID 65348 //
     /* 2214757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode1),
     /* 2214760 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2214760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2214763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2214767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2214776 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2214779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2214784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2214792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214793 */     // GIR_Coverage, 65348,
     /* 2214793 */     GIR_EraseRootFromParent_Done,
     /* 2214794 */   // Label 29161: @2214794
     /* 2214794 */   GIM_Try, /*On fail goto*//*Label 29162*/ GIMT_Encode4(2214809), // Rule ID 65350 //
     /* 2214799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2214802 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2214802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2214807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214808 */     // GIR_Coverage, 65350,
     /* 2214808 */     GIR_Done,
     /* 2214809 */   // Label 29162: @2214809
     /* 2214809 */   GIM_Try, /*On fail goto*//*Label 29163*/ GIMT_Encode4(2214824), // Rule ID 65351 //
     /* 2214814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2214817 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2214817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2214822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214823 */     // GIR_Coverage, 65351,
     /* 2214823 */     GIR_Done,
     /* 2214824 */   // Label 29163: @2214824
     /* 2214824 */   GIM_Reject,
     /* 2214825 */ // Label 29158: @2214825
     /* 2214825 */ GIM_Reject,
     /* 2214826 */ // Label 29141: @2214826
     /* 2214826 */ GIM_Try, /*On fail goto*//*Label 29164*/ GIMT_Encode4(2214857), // Rule ID 65335 //
     /* 2214831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2214834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2214837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214845 */   // (sext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i32] }:$src, 0:{ *:[i64] })
     /* 2214845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2214848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214850 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2214852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214855 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214856 */   // GIR_Coverage, 65335,
     /* 2214856 */   GIR_EraseRootFromParent_Done,
     /* 2214857 */ // Label 29164: @2214857
     /* 2214857 */ GIM_Try, /*On fail goto*//*Label 29165*/ GIMT_Encode4(2214910), // Rule ID 65344 //
     /* 2214862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode0),
     /* 2214865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2214868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214876 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2214876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2214879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2214883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214888 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2214892 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2214895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2214900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2214908 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214909 */   // GIR_Coverage, 65344,
     /* 2214909 */   GIR_EraseRootFromParent_Done,
     /* 2214910 */ // Label 29165: @2214910
     /* 2214910 */ GIM_Try, /*On fail goto*//*Label 29166*/ GIMT_Encode4(2214963), // Rule ID 65346 //
     /* 2214915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2214918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2214921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214929 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2214929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2214932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2214936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214941 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2214945 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2214948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2214953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2214961 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214962 */   // GIR_Coverage, 65346,
     /* 2214962 */   GIR_EraseRootFromParent_Done,
     /* 2214963 */ // Label 29166: @2214963
     /* 2214963 */ GIM_Try, /*On fail goto*//*Label 29167*/ GIMT_Encode4(2214989), // Rule ID 65352 //
     /* 2214968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2214971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2214974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214982 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2214982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2214987 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214988 */   // GIR_Coverage, 65352,
     /* 2214988 */   GIR_Done,
     /* 2214989 */ // Label 29167: @2214989
     /* 2214989 */ GIM_Reject,
     /* 2214990 */ // Label 29142: @2214990
     /* 2214990 */ GIM_Try, /*On fail goto*//*Label 29168*/ GIMT_Encode4(2215093),
     /* 2214995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2214998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215006 */   GIM_Try, /*On fail goto*//*Label 29169*/ GIMT_Encode4(2215049), // Rule ID 47536 //
     /* 2215011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215014 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2215017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2215031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215048 */     // GIR_Coverage, 47536,
     /* 2215048 */     GIR_EraseRootFromParent_Done,
     /* 2215049 */   // Label 29169: @2215049
     /* 2215049 */   GIM_Try, /*On fail goto*//*Label 29170*/ GIMT_Encode4(2215092), // Rule ID 47537 //
     /* 2215054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215057 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2215060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2215074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215091 */     // GIR_Coverage, 47537,
     /* 2215091 */     GIR_EraseRootFromParent_Done,
     /* 2215092 */   // Label 29170: @2215092
     /* 2215092 */   GIM_Reject,
     /* 2215093 */ // Label 29168: @2215093
     /* 2215093 */ GIM_Reject,
     /* 2215094 */ // Label 29143: @2215094
     /* 2215094 */ GIM_Try, /*On fail goto*//*Label 29171*/ GIMT_Encode4(2215148), // Rule ID 47548 //
     /* 2215099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2215105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215113 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215113 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2215116 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215120 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2215130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215135 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215146 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215147 */   // GIR_Coverage, 47548,
     /* 2215147 */   GIR_EraseRootFromParent_Done,
     /* 2215148 */ // Label 29171: @2215148
     /* 2215148 */ GIM_Try, /*On fail goto*//*Label 29172*/ GIMT_Encode4(2215202), // Rule ID 47549 //
     /* 2215153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2215159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215167 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2215170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2215184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215189 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215200 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215201 */   // GIR_Coverage, 47549,
     /* 2215201 */   GIR_EraseRootFromParent_Done,
     /* 2215202 */ // Label 29172: @2215202
     /* 2215202 */ GIM_Try, /*On fail goto*//*Label 29173*/ GIMT_Encode4(2215256), // Rule ID 47602 //
     /* 2215207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2215213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215221 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215221 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2215224 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215228 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2215238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215240 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215243 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215254 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215255 */   // GIR_Coverage, 47602,
     /* 2215255 */   GIR_EraseRootFromParent_Done,
     /* 2215256 */ // Label 29173: @2215256
     /* 2215256 */ GIM_Try, /*On fail goto*//*Label 29174*/ GIMT_Encode4(2215310), // Rule ID 47603 //
     /* 2215261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2215267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215275 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215275 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2215278 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215282 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2215292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215297 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215309 */   // GIR_Coverage, 47603,
     /* 2215309 */   GIR_EraseRootFromParent_Done,
     /* 2215310 */ // Label 29174: @2215310
     /* 2215310 */ GIM_Reject,
     /* 2215311 */ // Label 29144: @2215311
     /* 2215311 */ GIM_Try, /*On fail goto*//*Label 29175*/ GIMT_Encode4(2215365), // Rule ID 47558 //
     /* 2215316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2215319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2215322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215330 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2215333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215342 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2215347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215349 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215352 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2215360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215363 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215364 */   // GIR_Coverage, 47558,
     /* 2215364 */   GIR_EraseRootFromParent_Done,
     /* 2215365 */ // Label 29175: @2215365
     /* 2215365 */ GIM_Try, /*On fail goto*//*Label 29176*/ GIMT_Encode4(2215419), // Rule ID 47559 //
     /* 2215370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2215373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2215376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215384 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215384 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2215387 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215391 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2215401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215406 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2215414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215417 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215418 */   // GIR_Coverage, 47559,
     /* 2215418 */   GIR_EraseRootFromParent_Done,
     /* 2215419 */ // Label 29176: @2215419
     /* 2215419 */ GIM_Try, /*On fail goto*//*Label 29177*/ GIMT_Encode4(2215473), // Rule ID 47612 //
     /* 2215424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2215427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2215430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215438 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215438 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2215441 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215445 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2215455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215460 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2215468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215471 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215472 */   // GIR_Coverage, 47612,
     /* 2215472 */   GIR_EraseRootFromParent_Done,
     /* 2215473 */ // Label 29177: @2215473
     /* 2215473 */ GIM_Try, /*On fail goto*//*Label 29178*/ GIMT_Encode4(2215527), // Rule ID 47613 //
     /* 2215478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2215481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2215484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215492 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2215495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2215509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215514 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2215522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215525 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215526 */   // GIR_Coverage, 47613,
     /* 2215526 */   GIR_EraseRootFromParent_Done,
     /* 2215527 */ // Label 29178: @2215527
     /* 2215527 */ GIM_Try, /*On fail goto*//*Label 29179*/ GIMT_Encode4(2215581), // Rule ID 47636 //
     /* 2215532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2215535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2215538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215546 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2215549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2215563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215568 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2215576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215579 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215580 */   // GIR_Coverage, 47636,
     /* 2215580 */   GIR_EraseRootFromParent_Done,
     /* 2215581 */ // Label 29179: @2215581
     /* 2215581 */ GIM_Try, /*On fail goto*//*Label 29180*/ GIMT_Encode4(2215635), // Rule ID 47637 //
     /* 2215586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2215589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2215592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215600 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215600 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2215603 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215607 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2215617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215622 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2215630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215633 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215634 */   // GIR_Coverage, 47637,
     /* 2215634 */   GIR_EraseRootFromParent_Done,
     /* 2215635 */ // Label 29180: @2215635
     /* 2215635 */ GIM_Reject,
     /* 2215636 */ // Label 29145: @2215636
     /* 2215636 */ GIM_Try, /*On fail goto*//*Label 29181*/ GIMT_Encode4(2215739),
     /* 2215641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2215644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215652 */   GIM_Try, /*On fail goto*//*Label 29182*/ GIMT_Encode4(2215695), // Rule ID 47538 //
     /* 2215657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215660 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2215663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2215677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215694 */     // GIR_Coverage, 47538,
     /* 2215694 */     GIR_EraseRootFromParent_Done,
     /* 2215695 */   // Label 29182: @2215695
     /* 2215695 */   GIM_Try, /*On fail goto*//*Label 29183*/ GIMT_Encode4(2215738), // Rule ID 47539 //
     /* 2215700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215703 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2215706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2215720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215737 */     // GIR_Coverage, 47539,
     /* 2215737 */     GIR_EraseRootFromParent_Done,
     /* 2215738 */   // Label 29183: @2215738
     /* 2215738 */   GIM_Reject,
     /* 2215739 */ // Label 29181: @2215739
     /* 2215739 */ GIM_Reject,
     /* 2215740 */ // Label 29146: @2215740
     /* 2215740 */ GIM_Try, /*On fail goto*//*Label 29184*/ GIMT_Encode4(2215794), // Rule ID 47550 //
     /* 2215745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2215751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215759 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2215762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2215776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215781 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215792 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215793 */   // GIR_Coverage, 47550,
     /* 2215793 */   GIR_EraseRootFromParent_Done,
     /* 2215794 */ // Label 29184: @2215794
     /* 2215794 */ GIM_Try, /*On fail goto*//*Label 29185*/ GIMT_Encode4(2215848), // Rule ID 47551 //
     /* 2215799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2215805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215813 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215813 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2215816 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215820 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2215830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215835 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215846 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215847 */   // GIR_Coverage, 47551,
     /* 2215847 */   GIR_EraseRootFromParent_Done,
     /* 2215848 */ // Label 29185: @2215848
     /* 2215848 */ GIM_Try, /*On fail goto*//*Label 29186*/ GIMT_Encode4(2215902), // Rule ID 47604 //
     /* 2215853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2215859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215867 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2215870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2215884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215889 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215900 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215901 */   // GIR_Coverage, 47604,
     /* 2215901 */   GIR_EraseRootFromParent_Done,
     /* 2215902 */ // Label 29186: @2215902
     /* 2215902 */ GIM_Try, /*On fail goto*//*Label 29187*/ GIMT_Encode4(2215956), // Rule ID 47605 //
     /* 2215907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2215913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215921 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2215924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2215938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215940 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215943 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215954 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215955 */   // GIR_Coverage, 47605,
     /* 2215955 */   GIR_EraseRootFromParent_Done,
     /* 2215956 */ // Label 29187: @2215956
     /* 2215956 */ GIM_Reject,
     /* 2215957 */ // Label 29147: @2215957
     /* 2215957 */ GIM_Try, /*On fail goto*//*Label 29188*/ GIMT_Encode4(2216011), // Rule ID 47560 //
     /* 2215962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2215965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2215968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215976 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2215979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2215993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215998 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216009 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216010 */   // GIR_Coverage, 47560,
     /* 2216010 */   GIR_EraseRootFromParent_Done,
     /* 2216011 */ // Label 29188: @2216011
     /* 2216011 */ GIM_Try, /*On fail goto*//*Label 29189*/ GIMT_Encode4(2216065), // Rule ID 47561 //
     /* 2216016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2216022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216030 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216030 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2216033 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216037 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216042 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2216047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216049 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216052 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216063 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216064 */   // GIR_Coverage, 47561,
     /* 2216064 */   GIR_EraseRootFromParent_Done,
     /* 2216065 */ // Label 29189: @2216065
     /* 2216065 */ GIM_Try, /*On fail goto*//*Label 29190*/ GIMT_Encode4(2216119), // Rule ID 47614 //
     /* 2216070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2216076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216084 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216084 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2216087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216091 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2216101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216103 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216106 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216118 */   // GIR_Coverage, 47614,
     /* 2216118 */   GIR_EraseRootFromParent_Done,
     /* 2216119 */ // Label 29190: @2216119
     /* 2216119 */ GIM_Try, /*On fail goto*//*Label 29191*/ GIMT_Encode4(2216173), // Rule ID 47615 //
     /* 2216124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2216130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216138 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216138 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2216141 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216145 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2216155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216157 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216160 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216171 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216172 */   // GIR_Coverage, 47615,
     /* 2216172 */   GIR_EraseRootFromParent_Done,
     /* 2216173 */ // Label 29191: @2216173
     /* 2216173 */ GIM_Try, /*On fail goto*//*Label 29192*/ GIMT_Encode4(2216227), // Rule ID 47638 //
     /* 2216178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2216184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216192 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2216195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2216209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216211 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216214 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216225 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216226 */   // GIR_Coverage, 47638,
     /* 2216226 */   GIR_EraseRootFromParent_Done,
     /* 2216227 */ // Label 29192: @2216227
     /* 2216227 */ GIM_Try, /*On fail goto*//*Label 29193*/ GIMT_Encode4(2216281), // Rule ID 47639 //
     /* 2216232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2216238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216246 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2216249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2216263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216265 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216268 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216279 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216280 */   // GIR_Coverage, 47639,
     /* 2216280 */   GIR_EraseRootFromParent_Done,
     /* 2216281 */ // Label 29193: @2216281
     /* 2216281 */ GIM_Reject,
     /* 2216282 */ // Label 29148: @2216282
     /* 2216282 */ GIM_Try, /*On fail goto*//*Label 29194*/ GIMT_Encode4(2216385),
     /* 2216287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2216290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216298 */   GIM_Try, /*On fail goto*//*Label 29195*/ GIMT_Encode4(2216341), // Rule ID 47540 //
     /* 2216303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216306 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2216309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2216323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216340 */     // GIR_Coverage, 47540,
     /* 2216340 */     GIR_EraseRootFromParent_Done,
     /* 2216341 */   // Label 29195: @2216341
     /* 2216341 */   GIM_Try, /*On fail goto*//*Label 29196*/ GIMT_Encode4(2216384), // Rule ID 47541 //
     /* 2216346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216349 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2216352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2216366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216383 */     // GIR_Coverage, 47541,
     /* 2216383 */     GIR_EraseRootFromParent_Done,
     /* 2216384 */   // Label 29196: @2216384
     /* 2216384 */   GIM_Reject,
     /* 2216385 */ // Label 29194: @2216385
     /* 2216385 */ GIM_Reject,
     /* 2216386 */ // Label 29149: @2216386
     /* 2216386 */ GIM_Try, /*On fail goto*//*Label 29197*/ GIMT_Encode4(2216440), // Rule ID 47552 //
     /* 2216391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2216397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216405 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216405 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2216408 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216412 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2216422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216427 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216439 */   // GIR_Coverage, 47552,
     /* 2216439 */   GIR_EraseRootFromParent_Done,
     /* 2216440 */ // Label 29197: @2216440
     /* 2216440 */ GIM_Try, /*On fail goto*//*Label 29198*/ GIMT_Encode4(2216494), // Rule ID 47553 //
     /* 2216445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2216451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216459 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2216462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2216476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216478 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216481 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216493 */   // GIR_Coverage, 47553,
     /* 2216493 */   GIR_EraseRootFromParent_Done,
     /* 2216494 */ // Label 29198: @2216494
     /* 2216494 */ GIM_Try, /*On fail goto*//*Label 29199*/ GIMT_Encode4(2216548), // Rule ID 47606 //
     /* 2216499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2216505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216513 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2216516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2216530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216535 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216546 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216547 */   // GIR_Coverage, 47606,
     /* 2216547 */   GIR_EraseRootFromParent_Done,
     /* 2216548 */ // Label 29199: @2216548
     /* 2216548 */ GIM_Try, /*On fail goto*//*Label 29200*/ GIMT_Encode4(2216602), // Rule ID 47607 //
     /* 2216553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2216559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216567 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2216570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216579 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2216584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216589 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216600 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216601 */   // GIR_Coverage, 47607,
     /* 2216601 */   GIR_EraseRootFromParent_Done,
     /* 2216602 */ // Label 29200: @2216602
     /* 2216602 */ GIM_Reject,
     /* 2216603 */ // Label 29150: @2216603
     /* 2216603 */ GIM_Try, /*On fail goto*//*Label 29201*/ GIMT_Encode4(2216657), // Rule ID 47562 //
     /* 2216608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2216614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216622 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216622 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2216625 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216629 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2216639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216644 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216656 */   // GIR_Coverage, 47562,
     /* 2216656 */   GIR_EraseRootFromParent_Done,
     /* 2216657 */ // Label 29201: @2216657
     /* 2216657 */ GIM_Try, /*On fail goto*//*Label 29202*/ GIMT_Encode4(2216711), // Rule ID 47563 //
     /* 2216662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2216668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216676 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216676 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2216679 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216683 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2216693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216698 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216710 */   // GIR_Coverage, 47563,
     /* 2216710 */   GIR_EraseRootFromParent_Done,
     /* 2216711 */ // Label 29202: @2216711
     /* 2216711 */ GIM_Try, /*On fail goto*//*Label 29203*/ GIMT_Encode4(2216765), // Rule ID 47616 //
     /* 2216716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2216722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216730 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2216733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2216747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216752 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216763 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216764 */   // GIR_Coverage, 47616,
     /* 2216764 */   GIR_EraseRootFromParent_Done,
     /* 2216765 */ // Label 29203: @2216765
     /* 2216765 */ GIM_Try, /*On fail goto*//*Label 29204*/ GIMT_Encode4(2216819), // Rule ID 47617 //
     /* 2216770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2216776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216784 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216784 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2216787 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216791 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2216801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216806 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216817 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216818 */   // GIR_Coverage, 47617,
     /* 2216818 */   GIR_EraseRootFromParent_Done,
     /* 2216819 */ // Label 29204: @2216819
     /* 2216819 */ GIM_Try, /*On fail goto*//*Label 29205*/ GIMT_Encode4(2216873), // Rule ID 47640 //
     /* 2216824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2216830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216838 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2216841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2216855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216857 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216860 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216871 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216872 */   // GIR_Coverage, 47640,
     /* 2216872 */   GIR_EraseRootFromParent_Done,
     /* 2216873 */ // Label 29205: @2216873
     /* 2216873 */ GIM_Try, /*On fail goto*//*Label 29206*/ GIMT_Encode4(2216927), // Rule ID 47641 //
     /* 2216878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2216884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216892 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2216895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216904 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2216909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216911 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216914 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216925 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216926 */   // GIR_Coverage, 47641,
     /* 2216926 */   GIR_EraseRootFromParent_Done,
     /* 2216927 */ // Label 29206: @2216927
     /* 2216927 */ GIM_Reject,
     /* 2216928 */ // Label 29151: @2216928
     /* 2216928 */ GIM_Try, /*On fail goto*//*Label 29207*/ GIMT_Encode4(2217031),
     /* 2216933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2216936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216944 */   GIM_Try, /*On fail goto*//*Label 29208*/ GIMT_Encode4(2216987), // Rule ID 47542 //
     /* 2216949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216952 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2216955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2216969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216986 */     // GIR_Coverage, 47542,
     /* 2216986 */     GIR_EraseRootFromParent_Done,
     /* 2216987 */   // Label 29208: @2216987
     /* 2216987 */   GIM_Try, /*On fail goto*//*Label 29209*/ GIMT_Encode4(2217030), // Rule ID 47543 //
     /* 2216992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216995 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2216998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2217012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217029 */     // GIR_Coverage, 47543,
     /* 2217029 */     GIR_EraseRootFromParent_Done,
     /* 2217030 */   // Label 29209: @2217030
     /* 2217030 */   GIM_Reject,
     /* 2217031 */ // Label 29207: @2217031
     /* 2217031 */ GIM_Reject,
     /* 2217032 */ // Label 29152: @2217032
     /* 2217032 */ GIM_Try, /*On fail goto*//*Label 29210*/ GIMT_Encode4(2217086), // Rule ID 47554 //
     /* 2217037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2217043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217051 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217051 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2217054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217058 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2217068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217073 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217084 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217085 */   // GIR_Coverage, 47554,
     /* 2217085 */   GIR_EraseRootFromParent_Done,
     /* 2217086 */ // Label 29210: @2217086
     /* 2217086 */ GIM_Try, /*On fail goto*//*Label 29211*/ GIMT_Encode4(2217140), // Rule ID 47555 //
     /* 2217091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2217097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217105 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2217108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2217122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217124 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217127 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217138 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217139 */   // GIR_Coverage, 47555,
     /* 2217139 */   GIR_EraseRootFromParent_Done,
     /* 2217140 */ // Label 29211: @2217140
     /* 2217140 */ GIM_Try, /*On fail goto*//*Label 29212*/ GIMT_Encode4(2217194), // Rule ID 47608 //
     /* 2217145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2217151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217159 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217159 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2217162 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217166 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2217176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217181 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217192 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217193 */   // GIR_Coverage, 47608,
     /* 2217193 */   GIR_EraseRootFromParent_Done,
     /* 2217194 */ // Label 29212: @2217194
     /* 2217194 */ GIM_Try, /*On fail goto*//*Label 29213*/ GIMT_Encode4(2217248), // Rule ID 47609 //
     /* 2217199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2217205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217213 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2217216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2217230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217235 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217246 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217247 */   // GIR_Coverage, 47609,
     /* 2217247 */   GIR_EraseRootFromParent_Done,
     /* 2217248 */ // Label 29213: @2217248
     /* 2217248 */ GIM_Reject,
     /* 2217249 */ // Label 29153: @2217249
     /* 2217249 */ GIM_Try, /*On fail goto*//*Label 29214*/ GIMT_Encode4(2217303), // Rule ID 47564 //
     /* 2217254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2217260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217268 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2217271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2217285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217290 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217301 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217302 */   // GIR_Coverage, 47564,
     /* 2217302 */   GIR_EraseRootFromParent_Done,
     /* 2217303 */ // Label 29214: @2217303
     /* 2217303 */ GIM_Try, /*On fail goto*//*Label 29215*/ GIMT_Encode4(2217357), // Rule ID 47565 //
     /* 2217308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2217314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217322 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2217325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2217339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217344 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217355 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217356 */   // GIR_Coverage, 47565,
     /* 2217356 */   GIR_EraseRootFromParent_Done,
     /* 2217357 */ // Label 29215: @2217357
     /* 2217357 */ GIM_Try, /*On fail goto*//*Label 29216*/ GIMT_Encode4(2217411), // Rule ID 47618 //
     /* 2217362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2217368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217376 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217376 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2217379 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217383 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2217393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217398 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217409 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217410 */   // GIR_Coverage, 47618,
     /* 2217410 */   GIR_EraseRootFromParent_Done,
     /* 2217411 */ // Label 29216: @2217411
     /* 2217411 */ GIM_Try, /*On fail goto*//*Label 29217*/ GIMT_Encode4(2217465), // Rule ID 47619 //
     /* 2217416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2217422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217430 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217430 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2217433 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217437 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2217447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217449 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217452 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217463 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217464 */   // GIR_Coverage, 47619,
     /* 2217464 */   GIR_EraseRootFromParent_Done,
     /* 2217465 */ // Label 29217: @2217465
     /* 2217465 */ GIM_Try, /*On fail goto*//*Label 29218*/ GIMT_Encode4(2217519), // Rule ID 47642 //
     /* 2217470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2217476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217484 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2217487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2217501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217503 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217506 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217518 */   // GIR_Coverage, 47642,
     /* 2217518 */   GIR_EraseRootFromParent_Done,
     /* 2217519 */ // Label 29218: @2217519
     /* 2217519 */ GIM_Try, /*On fail goto*//*Label 29219*/ GIMT_Encode4(2217573), // Rule ID 47643 //
     /* 2217524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2217530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217538 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2217541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2217555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217557 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217560 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217571 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217572 */   // GIR_Coverage, 47643,
     /* 2217572 */   GIR_EraseRootFromParent_Done,
     /* 2217573 */ // Label 29219: @2217573
     /* 2217573 */ GIM_Reject,
     /* 2217574 */ // Label 29154: @2217574
     /* 2217574 */ GIM_Try, /*On fail goto*//*Label 29220*/ GIMT_Encode4(2217677),
     /* 2217579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2217582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217590 */   GIM_Try, /*On fail goto*//*Label 29221*/ GIMT_Encode4(2217633), // Rule ID 47544 //
     /* 2217595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217598 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2217601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2217615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217632 */     // GIR_Coverage, 47544,
     /* 2217632 */     GIR_EraseRootFromParent_Done,
     /* 2217633 */   // Label 29221: @2217633
     /* 2217633 */   GIM_Try, /*On fail goto*//*Label 29222*/ GIMT_Encode4(2217676), // Rule ID 47545 //
     /* 2217638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217641 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2217644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2217658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217675 */     // GIR_Coverage, 47545,
     /* 2217675 */     GIR_EraseRootFromParent_Done,
     /* 2217676 */   // Label 29222: @2217676
     /* 2217676 */   GIM_Reject,
     /* 2217677 */ // Label 29220: @2217677
     /* 2217677 */ GIM_Reject,
     /* 2217678 */ // Label 29155: @2217678
     /* 2217678 */ GIM_Try, /*On fail goto*//*Label 29223*/ GIMT_Encode4(2217732), // Rule ID 47556 //
     /* 2217683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2217689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217697 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2217700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2217714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217716 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217719 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217730 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217731 */   // GIR_Coverage, 47556,
     /* 2217731 */   GIR_EraseRootFromParent_Done,
     /* 2217732 */ // Label 29223: @2217732
     /* 2217732 */ GIM_Try, /*On fail goto*//*Label 29224*/ GIMT_Encode4(2217786), // Rule ID 47557 //
     /* 2217737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2217743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217751 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2217754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2217768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217770 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217773 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217784 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217785 */   // GIR_Coverage, 47557,
     /* 2217785 */   GIR_EraseRootFromParent_Done,
     /* 2217786 */ // Label 29224: @2217786
     /* 2217786 */ GIM_Try, /*On fail goto*//*Label 29225*/ GIMT_Encode4(2217840), // Rule ID 47610 //
     /* 2217791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2217797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217805 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217805 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2217808 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217812 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2217822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217824 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217827 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217838 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217839 */   // GIR_Coverage, 47610,
     /* 2217839 */   GIR_EraseRootFromParent_Done,
     /* 2217840 */ // Label 29225: @2217840
     /* 2217840 */ GIM_Try, /*On fail goto*//*Label 29226*/ GIMT_Encode4(2217894), // Rule ID 47611 //
     /* 2217845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2217851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217859 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2217862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2217876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217878 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217881 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217892 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217893 */   // GIR_Coverage, 47611,
     /* 2217893 */   GIR_EraseRootFromParent_Done,
     /* 2217894 */ // Label 29226: @2217894
     /* 2217894 */ GIM_Reject,
     /* 2217895 */ // Label 29156: @2217895
     /* 2217895 */ GIM_Try, /*On fail goto*//*Label 29227*/ GIMT_Encode4(2217998),
     /* 2217900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2217903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217911 */   GIM_Try, /*On fail goto*//*Label 29228*/ GIMT_Encode4(2217954), // Rule ID 47546 //
     /* 2217916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217919 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2217922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2217936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217953 */     // GIR_Coverage, 47546,
     /* 2217953 */     GIR_EraseRootFromParent_Done,
     /* 2217954 */   // Label 29228: @2217954
     /* 2217954 */   GIM_Try, /*On fail goto*//*Label 29229*/ GIMT_Encode4(2217997), // Rule ID 47547 //
     /* 2217959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217962 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2217965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2217979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217996 */     // GIR_Coverage, 47547,
     /* 2217996 */     GIR_EraseRootFromParent_Done,
     /* 2217997 */   // Label 29229: @2217997
     /* 2217997 */   GIM_Reject,
     /* 2217998 */ // Label 29227: @2217998
     /* 2217998 */ GIM_Reject,
     /* 2217999 */ // Label 29157: @2217999
     /* 2217999 */ GIM_Reject,
     /* 2218000 */ // Label 41: @2218000
     /* 2218000 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 29232*/ GIMT_Encode4(2219042),
     /* 2218011 */ /*GILLT_s32*//*Label 29230*/ GIMT_Encode4(2218019),
     /* 2218015 */ /*GILLT_s64*//*Label 29231*/ GIMT_Encode4(2218677),
     /* 2218019 */ // Label 29230: @2218019
     /* 2218019 */ GIM_Try, /*On fail goto*//*Label 29233*/ GIMT_Encode4(2218676),
     /* 2218024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2218027 */   GIM_Try, /*On fail goto*//*Label 29234*/ GIMT_Encode4(2218063), // Rule ID 64462 //
     /* 2218032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2218035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218043 */     // MIs[0] Operand 2
     /* 2218043 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2218054 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2218054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2218057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218062 */     // GIR_Coverage, 64462,
     /* 2218062 */     GIR_EraseRootFromParent_Done,
     /* 2218063 */   // Label 29234: @2218063
     /* 2218063 */   GIM_Try, /*On fail goto*//*Label 29235*/ GIMT_Encode4(2218099), // Rule ID 64464 //
     /* 2218068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2218071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218079 */     // MIs[0] Operand 2
     /* 2218079 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2218090 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2218090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2218093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218098 */     // GIR_Coverage, 64464,
     /* 2218098 */     GIR_EraseRootFromParent_Done,
     /* 2218099 */   // Label 29235: @2218099
     /* 2218099 */   GIM_Try, /*On fail goto*//*Label 29236*/ GIMT_Encode4(2218135), // Rule ID 2515 //
     /* 2218104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2218107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218115 */     // MIs[0] Operand 2
     /* 2218115 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2218126 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2218126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2218129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218134 */     // GIR_Coverage, 2515,
     /* 2218134 */     GIR_EraseRootFromParent_Done,
     /* 2218135 */   // Label 29236: @2218135
     /* 2218135 */   GIM_Try, /*On fail goto*//*Label 29237*/ GIMT_Encode4(2218171), // Rule ID 2517 //
     /* 2218140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2218143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218151 */     // MIs[0] Operand 2
     /* 2218151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2218162 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2218162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2218165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218170 */     // GIR_Coverage, 2517,
     /* 2218170 */     GIR_EraseRootFromParent_Done,
     /* 2218171 */   // Label 29237: @2218171
     /* 2218171 */   GIM_Try, /*On fail goto*//*Label 29238*/ GIMT_Encode4(2218213), // Rule ID 62548 //
     /* 2218176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2218179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218187 */     // MIs[0] Operand 2
     /* 2218187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2218198 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
     /* 2218198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2218201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2218208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218212 */     // GIR_Coverage, 62548,
     /* 2218212 */     GIR_EraseRootFromParent_Done,
     /* 2218213 */   // Label 29238: @2218213
     /* 2218213 */   GIM_Try, /*On fail goto*//*Label 29239*/ GIMT_Encode4(2218255), // Rule ID 62550 //
     /* 2218218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2218221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218229 */     // MIs[0] Operand 2
     /* 2218229 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2218240 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
     /* 2218240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2218243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2218250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218254 */     // GIR_Coverage, 62550,
     /* 2218254 */     GIR_EraseRootFromParent_Done,
     /* 2218255 */   // Label 29239: @2218255
     /* 2218255 */   GIM_Try, /*On fail goto*//*Label 29240*/ GIMT_Encode4(2218297), // Rule ID 62552 //
     /* 2218260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2218263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218271 */     // MIs[0] Operand 2
     /* 2218271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2218282 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2218282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2218285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218296 */     // GIR_Coverage, 62552,
     /* 2218296 */     GIR_EraseRootFromParent_Done,
     /* 2218297 */   // Label 29240: @2218297
     /* 2218297 */   GIM_Try, /*On fail goto*//*Label 29241*/ GIMT_Encode4(2218339), // Rule ID 64614 //
     /* 2218302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2218305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2218309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218313 */     // MIs[0] Operand 2
     /* 2218313 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2218324 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 16:{ *:[i64] }, 0:{ *:[i64] })
     /* 2218324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2218327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2218334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218338 */     // GIR_Coverage, 64614,
     /* 2218338 */     GIR_EraseRootFromParent_Done,
     /* 2218339 */   // Label 29241: @2218339
     /* 2218339 */   GIM_Try, /*On fail goto*//*Label 29242*/ GIMT_Encode4(2218381), // Rule ID 64615 //
     /* 2218344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2218347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2218351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218355 */     // MIs[0] Operand 2
     /* 2218355 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2218366 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 16:{ *:[i32] }, 0:{ *:[i32] })
     /* 2218366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2218369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2218376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218380 */     // GIR_Coverage, 64615,
     /* 2218380 */     GIR_EraseRootFromParent_Done,
     /* 2218381 */   // Label 29242: @2218381
     /* 2218381 */   GIM_Try, /*On fail goto*//*Label 29243*/ GIMT_Encode4(2218423), // Rule ID 64616 //
     /* 2218386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2218389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2218393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218397 */     // MIs[0] Operand 2
     /* 2218397 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2218408 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 8:{ *:[i64] }, 0:{ *:[i64] })
     /* 2218408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2218411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 2218418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218422 */     // GIR_Coverage, 64616,
     /* 2218422 */     GIR_EraseRootFromParent_Done,
     /* 2218423 */   // Label 29243: @2218423
     /* 2218423 */   GIM_Try, /*On fail goto*//*Label 29244*/ GIMT_Encode4(2218465), // Rule ID 64617 //
     /* 2218428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2218431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2218435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218439 */     // MIs[0] Operand 2
     /* 2218439 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2218450 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 8:{ *:[i32] }, 0:{ *:[i32] })
     /* 2218450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2218453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 2218460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218464 */     // GIR_Coverage, 64617,
     /* 2218464 */     GIR_EraseRootFromParent_Done,
     /* 2218465 */   // Label 29244: @2218465
     /* 2218465 */   GIM_Try, /*On fail goto*//*Label 29245*/ GIMT_Encode4(2218507), // Rule ID 64618 //
     /* 2218470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2218473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2218477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218481 */     // MIs[0] Operand 2
     /* 2218481 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2218492 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i64] }, 0:{ *:[i64] })
     /* 2218492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2218495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2218502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218506 */     // GIR_Coverage, 64618,
     /* 2218506 */     GIR_EraseRootFromParent_Done,
     /* 2218507 */   // Label 29245: @2218507
     /* 2218507 */   GIM_Try, /*On fail goto*//*Label 29246*/ GIMT_Encode4(2218549), // Rule ID 64619 //
     /* 2218512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2218515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2218519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218523 */     // MIs[0] Operand 2
     /* 2218523 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2218534 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }, 0:{ *:[i32] })
     /* 2218534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2218537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2218544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218548 */     // GIR_Coverage, 64619,
     /* 2218548 */     GIR_EraseRootFromParent_Done,
     /* 2218549 */   // Label 29246: @2218549
     /* 2218549 */   GIM_Try, /*On fail goto*//*Label 29247*/ GIMT_Encode4(2218591), // Rule ID 64980 //
     /* 2218554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2218557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218565 */     // MIs[0] Operand 2
     /* 2218565 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2218576 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
     /* 2218576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2218579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2218586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218590 */     // GIR_Coverage, 64980,
     /* 2218590 */     GIR_EraseRootFromParent_Done,
     /* 2218591 */   // Label 29247: @2218591
     /* 2218591 */   GIM_Try, /*On fail goto*//*Label 29248*/ GIMT_Encode4(2218633), // Rule ID 64982 //
     /* 2218596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2218599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218607 */     // MIs[0] Operand 2
     /* 2218607 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2218618 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
     /* 2218618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2218621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2218628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218632 */     // GIR_Coverage, 64982,
     /* 2218632 */     GIR_EraseRootFromParent_Done,
     /* 2218633 */   // Label 29248: @2218633
     /* 2218633 */   GIM_Try, /*On fail goto*//*Label 29249*/ GIMT_Encode4(2218675), // Rule ID 64984 //
     /* 2218638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2218641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218649 */     // MIs[0] Operand 2
     /* 2218649 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2218660 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2218660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2218663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218674 */     // GIR_Coverage, 64984,
     /* 2218674 */     GIR_EraseRootFromParent_Done,
     /* 2218675 */   // Label 29249: @2218675
     /* 2218675 */   GIM_Reject,
     /* 2218676 */ // Label 29233: @2218676
     /* 2218676 */ GIM_Reject,
     /* 2218677 */ // Label 29231: @2218677
     /* 2218677 */ GIM_Try, /*On fail goto*//*Label 29250*/ GIMT_Encode4(2219041),
     /* 2218682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2218685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218693 */   GIM_Try, /*On fail goto*//*Label 29251*/ GIMT_Encode4(2218721), // Rule ID 64461 //
     /* 2218698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2218701 */     // MIs[0] Operand 2
     /* 2218701 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2218712 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2218712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2218715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218720 */     // GIR_Coverage, 64461,
     /* 2218720 */     GIR_EraseRootFromParent_Done,
     /* 2218721 */   // Label 29251: @2218721
     /* 2218721 */   GIM_Try, /*On fail goto*//*Label 29252*/ GIMT_Encode4(2218749), // Rule ID 64463 //
     /* 2218726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2218729 */     // MIs[0] Operand 2
     /* 2218729 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2218740 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2218740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2218743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218748 */     // GIR_Coverage, 64463,
     /* 2218748 */     GIR_EraseRootFromParent_Done,
     /* 2218749 */   // Label 29252: @2218749
     /* 2218749 */   GIM_Try, /*On fail goto*//*Label 29253*/ GIMT_Encode4(2218780), // Rule ID 256 //
     /* 2218754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2218757 */     // MIs[0] Operand 2
     /* 2218757 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2218768 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] })  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2218768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2218771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218779 */     // GIR_Coverage, 256,
     /* 2218779 */     GIR_EraseRootFromParent_Done,
     /* 2218780 */   // Label 29253: @2218780
     /* 2218780 */   GIM_Try, /*On fail goto*//*Label 29254*/ GIMT_Encode4(2218808), // Rule ID 2514 //
     /* 2218785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2218788 */     // MIs[0] Operand 2
     /* 2218788 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2218799 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2218799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2218802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218807 */     // GIR_Coverage, 2514,
     /* 2218807 */     GIR_EraseRootFromParent_Done,
     /* 2218808 */   // Label 29254: @2218808
     /* 2218808 */   GIM_Try, /*On fail goto*//*Label 29255*/ GIMT_Encode4(2218836), // Rule ID 2516 //
     /* 2218813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2218816 */     // MIs[0] Operand 2
     /* 2218816 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2218827 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2218827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2218830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218835 */     // GIR_Coverage, 2516,
     /* 2218835 */     GIR_EraseRootFromParent_Done,
     /* 2218836 */   // Label 29255: @2218836
     /* 2218836 */   GIM_Try, /*On fail goto*//*Label 29256*/ GIMT_Encode4(2218870), // Rule ID 62547 //
     /* 2218841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2218844 */     // MIs[0] Operand 2
     /* 2218844 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2218855 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
     /* 2218855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2218858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2218865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218869 */     // GIR_Coverage, 62547,
     /* 2218869 */     GIR_EraseRootFromParent_Done,
     /* 2218870 */   // Label 29256: @2218870
     /* 2218870 */   GIM_Try, /*On fail goto*//*Label 29257*/ GIMT_Encode4(2218904), // Rule ID 62549 //
     /* 2218875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2218878 */     // MIs[0] Operand 2
     /* 2218878 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2218889 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
     /* 2218889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2218892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2218899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218903 */     // GIR_Coverage, 62549,
     /* 2218903 */     GIR_EraseRootFromParent_Done,
     /* 2218904 */   // Label 29257: @2218904
     /* 2218904 */   GIM_Try, /*On fail goto*//*Label 29258*/ GIMT_Encode4(2218938), // Rule ID 62551 //
     /* 2218909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2218912 */     // MIs[0] Operand 2
     /* 2218912 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2218923 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2218923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2218926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218937 */     // GIR_Coverage, 62551,
     /* 2218937 */     GIR_EraseRootFromParent_Done,
     /* 2218938 */   // Label 29258: @2218938
     /* 2218938 */   GIM_Try, /*On fail goto*//*Label 29259*/ GIMT_Encode4(2218972), // Rule ID 64979 //
     /* 2218943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2218946 */     // MIs[0] Operand 2
     /* 2218946 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2218957 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
     /* 2218957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2218960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2218967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2218970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218971 */     // GIR_Coverage, 64979,
     /* 2218971 */     GIR_EraseRootFromParent_Done,
     /* 2218972 */   // Label 29259: @2218972
     /* 2218972 */   GIM_Try, /*On fail goto*//*Label 29260*/ GIMT_Encode4(2219006), // Rule ID 64981 //
     /* 2218977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2218980 */     // MIs[0] Operand 2
     /* 2218980 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2218991 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
     /* 2218991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2218994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2219001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2219004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219005 */     // GIR_Coverage, 64981,
     /* 2219005 */     GIR_EraseRootFromParent_Done,
     /* 2219006 */   // Label 29260: @2219006
     /* 2219006 */   GIM_Try, /*On fail goto*//*Label 29261*/ GIMT_Encode4(2219040), // Rule ID 64983 //
     /* 2219011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2219014 */     // MIs[0] Operand 2
     /* 2219014 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2219025 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2219025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2219028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2219035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2219038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219039 */     // GIR_Coverage, 64983,
     /* 2219039 */     GIR_EraseRootFromParent_Done,
     /* 2219040 */   // Label 29261: @2219040
     /* 2219040 */   GIM_Reject,
     /* 2219041 */ // Label 29250: @2219041
     /* 2219041 */ GIM_Reject,
     /* 2219042 */ // Label 29232: @2219042
     /* 2219042 */ GIM_Reject,
     /* 2219043 */ // Label 42: @2219043
     /* 2219043 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 29279*/ GIMT_Encode4(2222729),
     /* 2219054 */ /*GILLT_s32*//*Label 29262*/ GIMT_Encode4(2219170),
     /* 2219058 */ /*GILLT_s64*//*Label 29263*/ GIMT_Encode4(2219466), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2219070 */ /*GILLT_nxv1s16*//*Label 29264*/ GIMT_Encode4(2219720),
     /* 2219074 */ /*GILLT_nxv1s32*//*Label 29265*/ GIMT_Encode4(2219824),
     /* 2219078 */ /*GILLT_nxv1s64*//*Label 29266*/ GIMT_Encode4(2220041), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2219090 */ /*GILLT_nxv2s16*//*Label 29267*/ GIMT_Encode4(2220366),
     /* 2219094 */ /*GILLT_nxv2s32*//*Label 29268*/ GIMT_Encode4(2220470),
     /* 2219098 */ /*GILLT_nxv2s64*//*Label 29269*/ GIMT_Encode4(2220687), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2219110 */ /*GILLT_nxv4s16*//*Label 29270*/ GIMT_Encode4(2221012),
     /* 2219114 */ /*GILLT_nxv4s32*//*Label 29271*/ GIMT_Encode4(2221116),
     /* 2219118 */ /*GILLT_nxv4s64*//*Label 29272*/ GIMT_Encode4(2221333), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2219130 */ /*GILLT_nxv8s16*//*Label 29273*/ GIMT_Encode4(2221658),
     /* 2219134 */ /*GILLT_nxv8s32*//*Label 29274*/ GIMT_Encode4(2221762),
     /* 2219138 */ /*GILLT_nxv8s64*//*Label 29275*/ GIMT_Encode4(2221979), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2219150 */ /*GILLT_nxv16s16*//*Label 29276*/ GIMT_Encode4(2222304),
     /* 2219154 */ /*GILLT_nxv16s32*//*Label 29277*/ GIMT_Encode4(2222408), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2219166 */ /*GILLT_nxv32s16*//*Label 29278*/ GIMT_Encode4(2222625),
     /* 2219170 */ // Label 29262: @2219170
     /* 2219170 */ GIM_Try, /*On fail goto*//*Label 29280*/ GIMT_Encode4(2219465),
     /* 2219175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2219178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219186 */   GIM_Try, /*On fail goto*//*Label 29281*/ GIMT_Encode4(2219228), // Rule ID 65340 //
     /* 2219191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2219194 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2219194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2219197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2219210 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2219213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2219218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2219226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219227 */     // GIR_Coverage, 65340,
     /* 2219227 */     GIR_EraseRootFromParent_Done,
     /* 2219228 */   // Label 29281: @2219228
     /* 2219228 */   GIM_Try, /*On fail goto*//*Label 29282*/ GIMT_Encode4(2219270), // Rule ID 65342 //
     /* 2219233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2219236 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2219236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2219239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219248 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2219252 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2219255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2219260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2219268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219269 */     // GIR_Coverage, 65342,
     /* 2219269 */     GIR_EraseRootFromParent_Done,
     /* 2219270 */   // Label 29282: @2219270
     /* 2219270 */   GIM_Try, /*On fail goto*//*Label 29283*/ GIMT_Encode4(2219312), // Rule ID 65343 //
     /* 2219275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2219278 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2219278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2219281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2219294 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2219297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2219302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2219310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219311 */     // GIR_Coverage, 65343,
     /* 2219311 */     GIR_EraseRootFromParent_Done,
     /* 2219312 */   // Label 29283: @2219312
     /* 2219312 */   GIM_Try, /*On fail goto*//*Label 29284*/ GIMT_Encode4(2219327), // Rule ID 65353 //
     /* 2219317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /* 2219320 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2219320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2219325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219326 */     // GIR_Coverage, 65353,
     /* 2219326 */     GIR_Done,
     /* 2219327 */   // Label 29284: @2219327
     /* 2219327 */   GIM_Try, /*On fail goto*//*Label 29285*/ GIMT_Encode4(2219342), // Rule ID 65354 //
     /* 2219332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /* 2219335 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2219335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2219340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219341 */     // GIR_Coverage, 65354,
     /* 2219341 */     GIR_Done,
     /* 2219342 */   // Label 29285: @2219342
     /* 2219342 */   GIM_Try, /*On fail goto*//*Label 29286*/ GIMT_Encode4(2219357), // Rule ID 65356 //
     /* 2219347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2219350 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2219350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2219355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219356 */     // GIR_Coverage, 65356,
     /* 2219356 */     GIR_Done,
     /* 2219357 */   // Label 29286: @2219357
     /* 2219357 */   GIM_Try, /*On fail goto*//*Label 29287*/ GIMT_Encode4(2219372), // Rule ID 65357 //
     /* 2219362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode1),
     /* 2219365 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2219365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2219370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219371 */     // GIR_Coverage, 65357,
     /* 2219371 */     GIR_Done,
     /* 2219372 */   // Label 29287: @2219372
     /* 2219372 */   GIM_Try, /*On fail goto*//*Label 29288*/ GIMT_Encode4(2219395), // Rule ID 65358 //
     /* 2219377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /* 2219380 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2219380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2219383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2219387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219394 */     // GIR_Coverage, 65358,
     /* 2219394 */     GIR_EraseRootFromParent_Done,
     /* 2219395 */   // Label 29288: @2219395
     /* 2219395 */   GIM_Try, /*On fail goto*//*Label 29289*/ GIMT_Encode4(2219418), // Rule ID 65359 //
     /* 2219400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /* 2219403 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2219403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2219406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2219410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219417 */     // GIR_Coverage, 65359,
     /* 2219417 */     GIR_EraseRootFromParent_Done,
     /* 2219418 */   // Label 29289: @2219418
     /* 2219418 */   GIM_Try, /*On fail goto*//*Label 29290*/ GIMT_Encode4(2219441), // Rule ID 65361 //
     /* 2219423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2219426 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2219426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2219429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2219433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219440 */     // GIR_Coverage, 65361,
     /* 2219440 */     GIR_EraseRootFromParent_Done,
     /* 2219441 */   // Label 29290: @2219441
     /* 2219441 */   GIM_Try, /*On fail goto*//*Label 29291*/ GIMT_Encode4(2219464), // Rule ID 65362 //
     /* 2219446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1),
     /* 2219449 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2219449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2219452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2219456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219463 */     // GIR_Coverage, 65362,
     /* 2219463 */     GIR_EraseRootFromParent_Done,
     /* 2219464 */   // Label 29291: @2219464
     /* 2219464 */   GIM_Reject,
     /* 2219465 */ // Label 29280: @2219465
     /* 2219465 */ GIM_Reject,
     /* 2219466 */ // Label 29263: @2219466
     /* 2219466 */ GIM_Try, /*On fail goto*//*Label 29292*/ GIMT_Encode4(2219519), // Rule ID 65338 //
     /* 2219471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2219474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2219477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219485 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i32] }:$src, 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 2219485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2219488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219497 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2219501 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2219504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2219509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 2219517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219518 */   // GIR_Coverage, 65338,
     /* 2219518 */   GIR_EraseRootFromParent_Done,
     /* 2219519 */ // Label 29292: @2219519
     /* 2219519 */ GIM_Try, /*On fail goto*//*Label 29293*/ GIMT_Encode4(2219572), // Rule ID 65339 //
     /* 2219524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2219527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2219530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219538 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2219538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2219541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219550 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2219554 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2219557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2219562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2219570 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219571 */   // GIR_Coverage, 65339,
     /* 2219571 */   GIR_EraseRootFromParent_Done,
     /* 2219572 */ // Label 29293: @2219572
     /* 2219572 */ GIM_Try, /*On fail goto*//*Label 29294*/ GIMT_Encode4(2219625), // Rule ID 65341 //
     /* 2219577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2219580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2219583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219591 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2219591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2219594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219603 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2219607 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2219610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2219615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2219623 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219624 */   // GIR_Coverage, 65341,
     /* 2219624 */   GIR_EraseRootFromParent_Done,
     /* 2219625 */ // Label 29294: @2219625
     /* 2219625 */ GIM_Try, /*On fail goto*//*Label 29295*/ GIMT_Encode4(2219659), // Rule ID 65349 //
     /* 2219630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2219633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2219636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219644 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i32] }:$src, X0:{ *:[i64] })
     /* 2219644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /* 2219647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219649 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2219651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219657 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219658 */   // GIR_Coverage, 65349,
     /* 2219658 */   GIR_EraseRootFromParent_Done,
     /* 2219659 */ // Label 29295: @2219659
     /* 2219659 */ GIM_Try, /*On fail goto*//*Label 29296*/ GIMT_Encode4(2219685), // Rule ID 65355 //
     /* 2219664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2219667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2219670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219678 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2219678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2219683 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219684 */   // GIR_Coverage, 65355,
     /* 2219684 */   GIR_Done,
     /* 2219685 */ // Label 29296: @2219685
     /* 2219685 */ GIM_Try, /*On fail goto*//*Label 29297*/ GIMT_Encode4(2219719), // Rule ID 65360 //
     /* 2219690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2219693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2219696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219704 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i64] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2219704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2219707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219709 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2219711 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219717 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219718 */   // GIR_Coverage, 65360,
     /* 2219718 */   GIR_EraseRootFromParent_Done,
     /* 2219719 */ // Label 29297: @2219719
     /* 2219719 */ GIM_Reject,
     /* 2219720 */ // Label 29264: @2219720
     /* 2219720 */ GIM_Try, /*On fail goto*//*Label 29298*/ GIMT_Encode4(2219823),
     /* 2219725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219736 */   GIM_Try, /*On fail goto*//*Label 29299*/ GIMT_Encode4(2219779), // Rule ID 45788 //
     /* 2219741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219744 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2219747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2219761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219778 */     // GIR_Coverage, 45788,
     /* 2219778 */     GIR_EraseRootFromParent_Done,
     /* 2219779 */   // Label 29299: @2219779
     /* 2219779 */   GIM_Try, /*On fail goto*//*Label 29300*/ GIMT_Encode4(2219822), // Rule ID 45789 //
     /* 2219784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219787 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2219790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2219804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219821 */     // GIR_Coverage, 45789,
     /* 2219821 */     GIR_EraseRootFromParent_Done,
     /* 2219822 */   // Label 29300: @2219822
     /* 2219822 */   GIM_Reject,
     /* 2219823 */ // Label 29298: @2219823
     /* 2219823 */ GIM_Reject,
     /* 2219824 */ // Label 29265: @2219824
     /* 2219824 */ GIM_Try, /*On fail goto*//*Label 29301*/ GIMT_Encode4(2219878), // Rule ID 47500 //
     /* 2219829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2219835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219843 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2219846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2219860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219865 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219877 */   // GIR_Coverage, 47500,
     /* 2219877 */   GIR_EraseRootFromParent_Done,
     /* 2219878 */ // Label 29301: @2219878
     /* 2219878 */ GIM_Try, /*On fail goto*//*Label 29302*/ GIMT_Encode4(2219932), // Rule ID 47501 //
     /* 2219883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2219889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219897 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2219900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2219914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219919 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219930 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219931 */   // GIR_Coverage, 47501,
     /* 2219931 */   GIR_EraseRootFromParent_Done,
     /* 2219932 */ // Label 29302: @2219932
     /* 2219932 */ GIM_Try, /*On fail goto*//*Label 29303*/ GIMT_Encode4(2219986), // Rule ID 47566 //
     /* 2219937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219951 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2219954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2219968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219970 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219973 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219984 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219985 */   // GIR_Coverage, 47566,
     /* 2219985 */   GIR_EraseRootFromParent_Done,
     /* 2219986 */ // Label 29303: @2219986
     /* 2219986 */ GIM_Try, /*On fail goto*//*Label 29304*/ GIMT_Encode4(2220040), // Rule ID 47567 //
     /* 2219991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220005 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2220022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220027 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220038 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220039 */   // GIR_Coverage, 47567,
     /* 2220039 */   GIR_EraseRootFromParent_Done,
     /* 2220040 */ // Label 29304: @2220040
     /* 2220040 */ GIM_Reject,
     /* 2220041 */ // Label 29266: @2220041
     /* 2220041 */ GIM_Try, /*On fail goto*//*Label 29305*/ GIMT_Encode4(2220095), // Rule ID 47520 //
     /* 2220046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2220049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220060 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2220077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220082 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220094 */   // GIR_Coverage, 47520,
     /* 2220094 */   GIR_EraseRootFromParent_Done,
     /* 2220095 */ // Label 29305: @2220095
     /* 2220095 */ GIM_Try, /*On fail goto*//*Label 29306*/ GIMT_Encode4(2220149), // Rule ID 47521 //
     /* 2220100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2220103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220114 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2220131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220133 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220136 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220148 */   // GIR_Coverage, 47521,
     /* 2220148 */   GIR_EraseRootFromParent_Done,
     /* 2220149 */ // Label 29306: @2220149
     /* 2220149 */ GIM_Try, /*On fail goto*//*Label 29307*/ GIMT_Encode4(2220203), // Rule ID 47586 //
     /* 2220154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2220157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220168 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220168 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220171 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220175 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2220185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220187 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220190 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220201 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220202 */   // GIR_Coverage, 47586,
     /* 2220202 */   GIR_EraseRootFromParent_Done,
     /* 2220203 */ // Label 29307: @2220203
     /* 2220203 */ GIM_Try, /*On fail goto*//*Label 29308*/ GIMT_Encode4(2220257), // Rule ID 47587 //
     /* 2220208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2220211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220222 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2220239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220244 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220255 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220256 */   // GIR_Coverage, 47587,
     /* 2220256 */   GIR_EraseRootFromParent_Done,
     /* 2220257 */ // Label 29308: @2220257
     /* 2220257 */ GIM_Try, /*On fail goto*//*Label 29309*/ GIMT_Encode4(2220311), // Rule ID 47620 //
     /* 2220262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2220265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220276 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2220293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220298 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220309 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220310 */   // GIR_Coverage, 47620,
     /* 2220310 */   GIR_EraseRootFromParent_Done,
     /* 2220311 */ // Label 29309: @2220311
     /* 2220311 */ GIM_Try, /*On fail goto*//*Label 29310*/ GIMT_Encode4(2220365), // Rule ID 47621 //
     /* 2220316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2220319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220330 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220342 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2220347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220349 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220352 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220363 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220364 */   // GIR_Coverage, 47621,
     /* 2220364 */   GIR_EraseRootFromParent_Done,
     /* 2220365 */ // Label 29310: @2220365
     /* 2220365 */ GIM_Reject,
     /* 2220366 */ // Label 29267: @2220366
     /* 2220366 */ GIM_Try, /*On fail goto*//*Label 29311*/ GIMT_Encode4(2220469),
     /* 2220371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2220374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220382 */   GIM_Try, /*On fail goto*//*Label 29312*/ GIMT_Encode4(2220425), // Rule ID 47480 //
     /* 2220387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220390 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2220393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2220407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220424 */     // GIR_Coverage, 47480,
     /* 2220424 */     GIR_EraseRootFromParent_Done,
     /* 2220425 */   // Label 29312: @2220425
     /* 2220425 */   GIM_Try, /*On fail goto*//*Label 29313*/ GIMT_Encode4(2220468), // Rule ID 47481 //
     /* 2220430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220433 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2220436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2220450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220467 */     // GIR_Coverage, 47481,
     /* 2220467 */     GIR_EraseRootFromParent_Done,
     /* 2220468 */   // Label 29313: @2220468
     /* 2220468 */   GIM_Reject,
     /* 2220469 */ // Label 29311: @2220469
     /* 2220469 */ GIM_Reject,
     /* 2220470 */ // Label 29268: @2220470
     /* 2220470 */ GIM_Try, /*On fail goto*//*Label 29314*/ GIMT_Encode4(2220524), // Rule ID 47504 //
     /* 2220475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2220481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220489 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2220492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2220506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220511 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220522 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220523 */   // GIR_Coverage, 47504,
     /* 2220523 */   GIR_EraseRootFromParent_Done,
     /* 2220524 */ // Label 29314: @2220524
     /* 2220524 */ GIM_Try, /*On fail goto*//*Label 29315*/ GIMT_Encode4(2220578), // Rule ID 47505 //
     /* 2220529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2220535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220543 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220543 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2220546 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220550 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2220560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220565 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220576 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220577 */   // GIR_Coverage, 47505,
     /* 2220577 */   GIR_EraseRootFromParent_Done,
     /* 2220578 */ // Label 29315: @2220578
     /* 2220578 */ GIM_Try, /*On fail goto*//*Label 29316*/ GIMT_Encode4(2220632), // Rule ID 47570 //
     /* 2220583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2220589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220597 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2220600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2220614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220619 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220630 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220631 */   // GIR_Coverage, 47570,
     /* 2220631 */   GIR_EraseRootFromParent_Done,
     /* 2220632 */ // Label 29316: @2220632
     /* 2220632 */ GIM_Try, /*On fail goto*//*Label 29317*/ GIMT_Encode4(2220686), // Rule ID 47571 //
     /* 2220637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2220643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220651 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2220654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2220668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220670 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220673 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220685 */   // GIR_Coverage, 47571,
     /* 2220685 */   GIR_EraseRootFromParent_Done,
     /* 2220686 */ // Label 29317: @2220686
     /* 2220686 */ GIM_Reject,
     /* 2220687 */ // Label 29269: @2220687
     /* 2220687 */ GIM_Try, /*On fail goto*//*Label 29318*/ GIMT_Encode4(2220741), // Rule ID 47524 //
     /* 2220692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2220695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2220698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220706 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2220709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2220723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220728 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220740 */   // GIR_Coverage, 47524,
     /* 2220740 */   GIR_EraseRootFromParent_Done,
     /* 2220741 */ // Label 29318: @2220741
     /* 2220741 */ GIM_Try, /*On fail goto*//*Label 29319*/ GIMT_Encode4(2220795), // Rule ID 47525 //
     /* 2220746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2220749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2220752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220760 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220760 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2220763 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220767 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2220777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220782 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220793 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220794 */   // GIR_Coverage, 47525,
     /* 2220794 */   GIR_EraseRootFromParent_Done,
     /* 2220795 */ // Label 29319: @2220795
     /* 2220795 */ GIM_Try, /*On fail goto*//*Label 29320*/ GIMT_Encode4(2220849), // Rule ID 47590 //
     /* 2220800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2220803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2220806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220814 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2220817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2220831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220836 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220847 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220848 */   // GIR_Coverage, 47590,
     /* 2220848 */   GIR_EraseRootFromParent_Done,
     /* 2220849 */ // Label 29320: @2220849
     /* 2220849 */ GIM_Try, /*On fail goto*//*Label 29321*/ GIMT_Encode4(2220903), // Rule ID 47591 //
     /* 2220854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2220857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2220860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220868 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220868 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2220871 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220875 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2220885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220887 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220890 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220901 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220902 */   // GIR_Coverage, 47591,
     /* 2220902 */   GIR_EraseRootFromParent_Done,
     /* 2220903 */ // Label 29321: @2220903
     /* 2220903 */ GIM_Try, /*On fail goto*//*Label 29322*/ GIMT_Encode4(2220957), // Rule ID 47624 //
     /* 2220908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2220911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2220914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220922 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220922 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2220925 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220929 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2220939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220944 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2220946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220955 */   GIR_RootConstrainSelectedInstOperands,
     /* 2220956 */   // GIR_Coverage, 47624,
     /* 2220956 */   GIR_EraseRootFromParent_Done,
     /* 2220957 */ // Label 29322: @2220957
     /* 2220957 */ GIM_Try, /*On fail goto*//*Label 29323*/ GIMT_Encode4(2221011), // Rule ID 47625 //
     /* 2220962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2220965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2220968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220976 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2220979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2220993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220998 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221009 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221010 */   // GIR_Coverage, 47625,
     /* 2221010 */   GIR_EraseRootFromParent_Done,
     /* 2221011 */ // Label 29323: @2221011
     /* 2221011 */ GIM_Reject,
     /* 2221012 */ // Label 29270: @2221012
     /* 2221012 */ GIM_Try, /*On fail goto*//*Label 29324*/ GIMT_Encode4(2221115),
     /* 2221017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2221020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221028 */   GIM_Try, /*On fail goto*//*Label 29325*/ GIMT_Encode4(2221071), // Rule ID 47484 //
     /* 2221033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221036 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2221039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2221053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221070 */     // GIR_Coverage, 47484,
     /* 2221070 */     GIR_EraseRootFromParent_Done,
     /* 2221071 */   // Label 29325: @2221071
     /* 2221071 */   GIM_Try, /*On fail goto*//*Label 29326*/ GIMT_Encode4(2221114), // Rule ID 47485 //
     /* 2221076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221079 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2221082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2221096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221113 */     // GIR_Coverage, 47485,
     /* 2221113 */     GIR_EraseRootFromParent_Done,
     /* 2221114 */   // Label 29326: @2221114
     /* 2221114 */   GIM_Reject,
     /* 2221115 */ // Label 29324: @2221115
     /* 2221115 */ GIM_Reject,
     /* 2221116 */ // Label 29271: @2221116
     /* 2221116 */ GIM_Try, /*On fail goto*//*Label 29327*/ GIMT_Encode4(2221170), // Rule ID 47508 //
     /* 2221121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2221127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221135 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2221138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2221152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221157 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221168 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221169 */   // GIR_Coverage, 47508,
     /* 2221169 */   GIR_EraseRootFromParent_Done,
     /* 2221170 */ // Label 29327: @2221170
     /* 2221170 */ GIM_Try, /*On fail goto*//*Label 29328*/ GIMT_Encode4(2221224), // Rule ID 47509 //
     /* 2221175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2221181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221189 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2221192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2221206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221211 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221223 */   // GIR_Coverage, 47509,
     /* 2221223 */   GIR_EraseRootFromParent_Done,
     /* 2221224 */ // Label 29328: @2221224
     /* 2221224 */ GIM_Try, /*On fail goto*//*Label 29329*/ GIMT_Encode4(2221278), // Rule ID 47574 //
     /* 2221229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2221235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221243 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221243 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2221246 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221250 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2221260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221265 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221276 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221277 */   // GIR_Coverage, 47574,
     /* 2221277 */   GIR_EraseRootFromParent_Done,
     /* 2221278 */ // Label 29329: @2221278
     /* 2221278 */ GIM_Try, /*On fail goto*//*Label 29330*/ GIMT_Encode4(2221332), // Rule ID 47575 //
     /* 2221283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2221289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221297 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221297 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2221300 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221304 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2221314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221319 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221330 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221331 */   // GIR_Coverage, 47575,
     /* 2221331 */   GIR_EraseRootFromParent_Done,
     /* 2221332 */ // Label 29330: @2221332
     /* 2221332 */ GIM_Reject,
     /* 2221333 */ // Label 29272: @2221333
     /* 2221333 */ GIM_Try, /*On fail goto*//*Label 29331*/ GIMT_Encode4(2221387), // Rule ID 47528 //
     /* 2221338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2221341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2221344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221352 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2221355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2221369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221374 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221385 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221386 */   // GIR_Coverage, 47528,
     /* 2221386 */   GIR_EraseRootFromParent_Done,
     /* 2221387 */ // Label 29331: @2221387
     /* 2221387 */ GIM_Try, /*On fail goto*//*Label 29332*/ GIMT_Encode4(2221441), // Rule ID 47529 //
     /* 2221392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2221395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2221398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221406 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2221409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2221423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221428 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221440 */   // GIR_Coverage, 47529,
     /* 2221440 */   GIR_EraseRootFromParent_Done,
     /* 2221441 */ // Label 29332: @2221441
     /* 2221441 */ GIM_Try, /*On fail goto*//*Label 29333*/ GIMT_Encode4(2221495), // Rule ID 47594 //
     /* 2221446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2221449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2221452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221460 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221460 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2221463 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221467 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2221477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221479 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221482 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221493 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221494 */   // GIR_Coverage, 47594,
     /* 2221494 */   GIR_EraseRootFromParent_Done,
     /* 2221495 */ // Label 29333: @2221495
     /* 2221495 */ GIM_Try, /*On fail goto*//*Label 29334*/ GIMT_Encode4(2221549), // Rule ID 47595 //
     /* 2221500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2221503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2221506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221514 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221514 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2221517 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221521 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2221531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221536 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221547 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221548 */   // GIR_Coverage, 47595,
     /* 2221548 */   GIR_EraseRootFromParent_Done,
     /* 2221549 */ // Label 29334: @2221549
     /* 2221549 */ GIM_Try, /*On fail goto*//*Label 29335*/ GIMT_Encode4(2221603), // Rule ID 47628 //
     /* 2221554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2221557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2221560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221568 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2221571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2221585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221590 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221601 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221602 */   // GIR_Coverage, 47628,
     /* 2221602 */   GIR_EraseRootFromParent_Done,
     /* 2221603 */ // Label 29335: @2221603
     /* 2221603 */ GIM_Try, /*On fail goto*//*Label 29336*/ GIMT_Encode4(2221657), // Rule ID 47629 //
     /* 2221608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2221611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2221614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221622 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221622 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2221625 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221629 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2221639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221644 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221656 */   // GIR_Coverage, 47629,
     /* 2221656 */   GIR_EraseRootFromParent_Done,
     /* 2221657 */ // Label 29336: @2221657
     /* 2221657 */ GIM_Reject,
     /* 2221658 */ // Label 29273: @2221658
     /* 2221658 */ GIM_Try, /*On fail goto*//*Label 29337*/ GIMT_Encode4(2221761),
     /* 2221663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2221666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221674 */   GIM_Try, /*On fail goto*//*Label 29338*/ GIMT_Encode4(2221717), // Rule ID 47488 //
     /* 2221679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221682 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2221685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2221699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221716 */     // GIR_Coverage, 47488,
     /* 2221716 */     GIR_EraseRootFromParent_Done,
     /* 2221717 */   // Label 29338: @2221717
     /* 2221717 */   GIM_Try, /*On fail goto*//*Label 29339*/ GIMT_Encode4(2221760), // Rule ID 47489 //
     /* 2221722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221725 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2221728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2221742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221759 */     // GIR_Coverage, 47489,
     /* 2221759 */     GIR_EraseRootFromParent_Done,
     /* 2221760 */   // Label 29339: @2221760
     /* 2221760 */   GIM_Reject,
     /* 2221761 */ // Label 29337: @2221761
     /* 2221761 */ GIM_Reject,
     /* 2221762 */ // Label 29274: @2221762
     /* 2221762 */ GIM_Try, /*On fail goto*//*Label 29340*/ GIMT_Encode4(2221816), // Rule ID 47512 //
     /* 2221767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2221773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221781 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221781 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2221784 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221788 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2221798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221800 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221803 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221815 */   // GIR_Coverage, 47512,
     /* 2221815 */   GIR_EraseRootFromParent_Done,
     /* 2221816 */ // Label 29340: @2221816
     /* 2221816 */ GIM_Try, /*On fail goto*//*Label 29341*/ GIMT_Encode4(2221870), // Rule ID 47513 //
     /* 2221821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2221827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221835 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2221838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2221852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221857 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221868 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221869 */   // GIR_Coverage, 47513,
     /* 2221869 */   GIR_EraseRootFromParent_Done,
     /* 2221870 */ // Label 29341: @2221870
     /* 2221870 */ GIM_Try, /*On fail goto*//*Label 29342*/ GIMT_Encode4(2221924), // Rule ID 47578 //
     /* 2221875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2221881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221889 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221889 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2221892 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221896 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2221906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221911 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221922 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221923 */   // GIR_Coverage, 47578,
     /* 2221923 */   GIR_EraseRootFromParent_Done,
     /* 2221924 */ // Label 29342: @2221924
     /* 2221924 */ GIM_Try, /*On fail goto*//*Label 29343*/ GIMT_Encode4(2221978), // Rule ID 47579 //
     /* 2221929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2221935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221943 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2221946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2221960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221965 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2221967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221976 */   GIR_RootConstrainSelectedInstOperands,
     /* 2221977 */   // GIR_Coverage, 47579,
     /* 2221977 */   GIR_EraseRootFromParent_Done,
     /* 2221978 */ // Label 29343: @2221978
     /* 2221978 */ GIM_Reject,
     /* 2221979 */ // Label 29275: @2221979
     /* 2221979 */ GIM_Try, /*On fail goto*//*Label 29344*/ GIMT_Encode4(2222033), // Rule ID 47532 //
     /* 2221984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2221987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2221990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2221994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221998 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2222001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2222015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222020 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222031 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222032 */   // GIR_Coverage, 47532,
     /* 2222032 */   GIR_EraseRootFromParent_Done,
     /* 2222033 */ // Label 29344: @2222033
     /* 2222033 */ GIM_Try, /*On fail goto*//*Label 29345*/ GIMT_Encode4(2222087), // Rule ID 47533 //
     /* 2222038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2222041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2222044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222052 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2222055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2222069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222074 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222086 */   // GIR_Coverage, 47533,
     /* 2222086 */   GIR_EraseRootFromParent_Done,
     /* 2222087 */ // Label 29345: @2222087
     /* 2222087 */ GIM_Try, /*On fail goto*//*Label 29346*/ GIMT_Encode4(2222141), // Rule ID 47598 //
     /* 2222092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2222095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2222098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222106 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222106 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2222109 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222113 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2222123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222125 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222128 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222139 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222140 */   // GIR_Coverage, 47598,
     /* 2222140 */   GIR_EraseRootFromParent_Done,
     /* 2222141 */ // Label 29346: @2222141
     /* 2222141 */ GIM_Try, /*On fail goto*//*Label 29347*/ GIMT_Encode4(2222195), // Rule ID 47599 //
     /* 2222146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2222149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2222152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222160 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2222163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2222177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222182 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222193 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222194 */   // GIR_Coverage, 47599,
     /* 2222194 */   GIR_EraseRootFromParent_Done,
     /* 2222195 */ // Label 29347: @2222195
     /* 2222195 */ GIM_Try, /*On fail goto*//*Label 29348*/ GIMT_Encode4(2222249), // Rule ID 47632 //
     /* 2222200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2222203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2222206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222214 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2222217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2222231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222236 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222247 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222248 */   // GIR_Coverage, 47632,
     /* 2222248 */   GIR_EraseRootFromParent_Done,
     /* 2222249 */ // Label 29348: @2222249
     /* 2222249 */ GIM_Try, /*On fail goto*//*Label 29349*/ GIMT_Encode4(2222303), // Rule ID 47633 //
     /* 2222254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2222257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2222260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222268 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2222271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2222285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222290 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222301 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222302 */   // GIR_Coverage, 47633,
     /* 2222302 */   GIR_EraseRootFromParent_Done,
     /* 2222303 */ // Label 29349: @2222303
     /* 2222303 */ GIM_Reject,
     /* 2222304 */ // Label 29276: @2222304
     /* 2222304 */ GIM_Try, /*On fail goto*//*Label 29350*/ GIMT_Encode4(2222407),
     /* 2222309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2222312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222320 */   GIM_Try, /*On fail goto*//*Label 29351*/ GIMT_Encode4(2222363), // Rule ID 47492 //
     /* 2222325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222328 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2222331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2222345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222362 */     // GIR_Coverage, 47492,
     /* 2222362 */     GIR_EraseRootFromParent_Done,
     /* 2222363 */   // Label 29351: @2222363
     /* 2222363 */   GIM_Try, /*On fail goto*//*Label 29352*/ GIMT_Encode4(2222406), // Rule ID 47493 //
     /* 2222368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222371 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2222374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2222388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222405 */     // GIR_Coverage, 47493,
     /* 2222405 */     GIR_EraseRootFromParent_Done,
     /* 2222406 */   // Label 29352: @2222406
     /* 2222406 */   GIM_Reject,
     /* 2222407 */ // Label 29350: @2222407
     /* 2222407 */ GIM_Reject,
     /* 2222408 */ // Label 29277: @2222408
     /* 2222408 */ GIM_Try, /*On fail goto*//*Label 29353*/ GIMT_Encode4(2222462), // Rule ID 47516 //
     /* 2222413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2222419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222427 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2222430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2222444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222449 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222460 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222461 */   // GIR_Coverage, 47516,
     /* 2222461 */   GIR_EraseRootFromParent_Done,
     /* 2222462 */ // Label 29353: @2222462
     /* 2222462 */ GIM_Try, /*On fail goto*//*Label 29354*/ GIMT_Encode4(2222516), // Rule ID 47517 //
     /* 2222467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2222473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222481 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2222484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2222498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222503 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222515 */   // GIR_Coverage, 47517,
     /* 2222515 */   GIR_EraseRootFromParent_Done,
     /* 2222516 */ // Label 29354: @2222516
     /* 2222516 */ GIM_Try, /*On fail goto*//*Label 29355*/ GIMT_Encode4(2222570), // Rule ID 47582 //
     /* 2222521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2222527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222535 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2222538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2222552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222557 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222568 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222569 */   // GIR_Coverage, 47582,
     /* 2222569 */   GIR_EraseRootFromParent_Done,
     /* 2222570 */ // Label 29355: @2222570
     /* 2222570 */ GIM_Try, /*On fail goto*//*Label 29356*/ GIMT_Encode4(2222624), // Rule ID 47583 //
     /* 2222575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2222581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222589 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2222592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2222606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222611 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2222623 */   // GIR_Coverage, 47583,
     /* 2222623 */   GIR_EraseRootFromParent_Done,
     /* 2222624 */ // Label 29356: @2222624
     /* 2222624 */ GIM_Reject,
     /* 2222625 */ // Label 29278: @2222625
     /* 2222625 */ GIM_Try, /*On fail goto*//*Label 29357*/ GIMT_Encode4(2222728),
     /* 2222630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2222633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222641 */   GIM_Try, /*On fail goto*//*Label 29358*/ GIMT_Encode4(2222684), // Rule ID 47496 //
     /* 2222646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222649 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2222652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2222666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222683 */     // GIR_Coverage, 47496,
     /* 2222683 */     GIR_EraseRootFromParent_Done,
     /* 2222684 */   // Label 29358: @2222684
     /* 2222684 */   GIM_Try, /*On fail goto*//*Label 29359*/ GIMT_Encode4(2222727), // Rule ID 47497 //
     /* 2222689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222692 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2222695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2222709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2222716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222726 */     // GIR_Coverage, 47497,
     /* 2222726 */     GIR_EraseRootFromParent_Done,
     /* 2222727 */   // Label 29359: @2222727
     /* 2222727 */   GIM_Reject,
     /* 2222728 */ // Label 29357: @2222728
     /* 2222728 */ GIM_Reject,
     /* 2222729 */ // Label 29279: @2222729
     /* 2222729 */ GIM_Reject,
     /* 2222730 */ // Label 43: @2222730
     /* 2222730 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29384*/ GIMT_Encode4(2231325),
     /* 2222741 */ /*GILLT_s32*//*Label 29360*/ GIMT_Encode4(2222865),
     /* 2222745 */ /*GILLT_s64*//*Label 29361*/ GIMT_Encode4(2222990), GIMT_Encode4(0),
     /* 2222753 */ /*GILLT_nxv1s8*//*Label 29362*/ GIMT_Encode4(2223335),
     /* 2222757 */ /*GILLT_nxv1s16*//*Label 29363*/ GIMT_Encode4(2223450),
     /* 2222761 */ /*GILLT_nxv1s32*//*Label 29364*/ GIMT_Encode4(2223929),
     /* 2222765 */ /*GILLT_nxv1s64*//*Label 29365*/ GIMT_Encode4(2224408), GIMT_Encode4(0),
     /* 2222773 */ /*GILLT_nxv2s8*//*Label 29366*/ GIMT_Encode4(2224887),
     /* 2222777 */ /*GILLT_nxv2s16*//*Label 29367*/ GIMT_Encode4(2225002),
     /* 2222781 */ /*GILLT_nxv2s32*//*Label 29368*/ GIMT_Encode4(2225481),
     /* 2222785 */ /*GILLT_nxv2s64*//*Label 29369*/ GIMT_Encode4(2225960), GIMT_Encode4(0),
     /* 2222793 */ /*GILLT_nxv4s8*//*Label 29370*/ GIMT_Encode4(2226439),
     /* 2222797 */ /*GILLT_nxv4s16*//*Label 29371*/ GIMT_Encode4(2226554),
     /* 2222801 */ /*GILLT_nxv4s32*//*Label 29372*/ GIMT_Encode4(2227033),
     /* 2222805 */ /*GILLT_nxv4s64*//*Label 29373*/ GIMT_Encode4(2227512), GIMT_Encode4(0),
     /* 2222813 */ /*GILLT_nxv8s8*//*Label 29374*/ GIMT_Encode4(2227991),
     /* 2222817 */ /*GILLT_nxv8s16*//*Label 29375*/ GIMT_Encode4(2228106),
     /* 2222821 */ /*GILLT_nxv8s32*//*Label 29376*/ GIMT_Encode4(2228585),
     /* 2222825 */ /*GILLT_nxv8s64*//*Label 29377*/ GIMT_Encode4(2229064), GIMT_Encode4(0),
     /* 2222833 */ /*GILLT_nxv16s8*//*Label 29378*/ GIMT_Encode4(2229543),
     /* 2222837 */ /*GILLT_nxv16s16*//*Label 29379*/ GIMT_Encode4(2229658),
     /* 2222841 */ /*GILLT_nxv16s32*//*Label 29380*/ GIMT_Encode4(2230137), GIMT_Encode4(0),
     /* 2222849 */ /*GILLT_nxv32s8*//*Label 29381*/ GIMT_Encode4(2230616),
     /* 2222853 */ /*GILLT_nxv32s16*//*Label 29382*/ GIMT_Encode4(2230731), GIMT_Encode4(0),
     /* 2222861 */ /*GILLT_nxv64s8*//*Label 29383*/ GIMT_Encode4(2231210),
     /* 2222865 */ // Label 29360: @2222865
     /* 2222865 */ GIM_Try, /*On fail goto*//*Label 29385*/ GIMT_Encode4(2222989),
     /* 2222870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2222873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2222876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2222880 */   GIM_Try, /*On fail goto*//*Label 29386*/ GIMT_Encode4(2222917), // Rule ID 2471 //
     /* 2222885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /* 2222888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2222892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2222899 */     // (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2)
     /* 2222899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2222902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2222910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2222915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222916 */     // GIR_Coverage, 2471,
     /* 2222916 */     GIR_EraseRootFromParent_Done,
     /* 2222917 */   // Label 29386: @2222917
     /* 2222917 */   GIM_Try, /*On fail goto*//*Label 29387*/ GIMT_Encode4(2222955), // Rule ID 91 //
     /* 2222922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2222925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2222929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2222933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2222937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2222941 */     // MIs[1] Operand 1
     /* 2222941 */     // No operand predicates
     /* 2222941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2222943 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2222943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2222946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2222953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222954 */     // GIR_Coverage, 91,
     /* 2222954 */     GIR_EraseRootFromParent_Done,
     /* 2222955 */   // Label 29387: @2222955
     /* 2222955 */   GIM_Try, /*On fail goto*//*Label 29388*/ GIMT_Encode4(2222988), // Rule ID 105 //
     /* 2222960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2222963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2222967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2222974 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SLL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2222974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2222977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2222986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222987 */     // GIR_Coverage, 105,
     /* 2222987 */     GIR_EraseRootFromParent_Done,
     /* 2222988 */   // Label 29388: @2222988
     /* 2222988 */   GIM_Reject,
     /* 2222989 */ // Label 29385: @2222989
     /* 2222989 */ GIM_Reject,
     /* 2222990 */ // Label 29361: @2222990
     /* 2222990 */ GIM_Try, /*On fail goto*//*Label 29389*/ GIMT_Encode4(2223334),
     /* 2222995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2222998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2223001 */   GIM_Try, /*On fail goto*//*Label 29390*/ GIMT_Encode4(2223095), // Rule ID 253 //
     /* 2223006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2223009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2223013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2223021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2223025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2223029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2223034 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2223045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2223053 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2223057 */     // MIs[2] Operand 1
     /* 2223057 */     // No operand predicates
     /* 2223057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223059 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt))
     /* 2223059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2223062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2223066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223071 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2223075 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2223078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2223083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223088 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // shamt
     /* 2223093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223094 */     // GIR_Coverage, 253,
     /* 2223094 */     GIR_EraseRootFromParent_Done,
     /* 2223095 */   // Label 29390: @2223095
     /* 2223095 */   GIM_Try, /*On fail goto*//*Label 29391*/ GIMT_Encode4(2223167), // Rule ID 2611 //
     /* 2223100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2223103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2223107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2223115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2223119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2223123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2223128 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2223139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2223147 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2223151 */     // MIs[2] Operand 1
     /* 2223151 */     // No operand predicates
     /* 2223151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223153 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SLLI_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2223153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /* 2223156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2223162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2223165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223166 */     // GIR_Coverage, 2611,
     /* 2223166 */     GIR_EraseRootFromParent_Done,
     /* 2223167 */   // Label 29391: @2223167
     /* 2223167 */   GIM_Try, /*On fail goto*//*Label 29392*/ GIMT_Encode4(2223208), // Rule ID 2470 //
     /* 2223172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /* 2223175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2223179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2223183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2223190 */     // (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2)
     /* 2223190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2223193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2223201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2223206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223207 */     // GIR_Coverage, 2470,
     /* 2223207 */     GIR_EraseRootFromParent_Done,
     /* 2223208 */   // Label 29392: @2223208
     /* 2223208 */   GIM_Try, /*On fail goto*//*Label 29393*/ GIMT_Encode4(2223254), // Rule ID 268 //
     /* 2223213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2223216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2223220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2223224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2223228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2223232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2223236 */     // MIs[1] Operand 1
     /* 2223236 */     // No operand predicates
     /* 2223236 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10023),
     /* 2223240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2223242 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)<<P:Predicate_anonymous_10023>>  =>  (SLLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2223242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLIW),
     /* 2223245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2223252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223253 */     // GIR_Coverage, 268,
     /* 2223253 */     GIR_EraseRootFromParent_Done,
     /* 2223254 */   // Label 29393: @2223254
     /* 2223254 */   GIM_Try, /*On fail goto*//*Label 29394*/ GIMT_Encode4(2223296), // Rule ID 90 //
     /* 2223259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2223262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2223266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2223270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2223274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2223278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2223282 */     // MIs[1] Operand 1
     /* 2223282 */     // No operand predicates
     /* 2223282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2223284 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2223284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2223287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2223294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223295 */     // GIR_Coverage, 90,
     /* 2223295 */     GIR_EraseRootFromParent_Done,
     /* 2223296 */   // Label 29394: @2223296
     /* 2223296 */   GIM_Try, /*On fail goto*//*Label 29395*/ GIMT_Encode4(2223333), // Rule ID 104 //
     /* 2223301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2223304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2223308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2223312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2223319 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2223319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2223322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2223331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223332 */     // GIR_Coverage, 104,
     /* 2223332 */     GIR_EraseRootFromParent_Done,
     /* 2223333 */   // Label 29395: @2223333
     /* 2223333 */   GIM_Reject,
     /* 2223334 */ // Label 29389: @2223334
     /* 2223334 */ GIM_Reject,
     /* 2223335 */ // Label 29362: @2223335
     /* 2223335 */ GIM_Try, /*On fail goto*//*Label 29396*/ GIMT_Encode4(2223449),
     /* 2223340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2223343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2223346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223358 */   GIM_Try, /*On fail goto*//*Label 29397*/ GIMT_Encode4(2223403), // Rule ID 48040 //
     /* 2223363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223366 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2223369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2223383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223402 */     // GIR_Coverage, 48040,
     /* 2223402 */     GIR_EraseRootFromParent_Done,
     /* 2223403 */   // Label 29397: @2223403
     /* 2223403 */   GIM_Try, /*On fail goto*//*Label 29398*/ GIMT_Encode4(2223448), // Rule ID 48041 //
     /* 2223408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223411 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2223414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2223428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223447 */     // GIR_Coverage, 48041,
     /* 2223447 */     GIR_EraseRootFromParent_Done,
     /* 2223448 */   // Label 29398: @2223448
     /* 2223448 */   GIM_Reject,
     /* 2223449 */ // Label 29396: @2223449
     /* 2223449 */ GIM_Reject,
     /* 2223450 */ // Label 29363: @2223450
     /* 2223450 */ GIM_Try, /*On fail goto*//*Label 29399*/ GIMT_Encode4(2223928),
     /* 2223455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2223458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2223461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223465 */   GIM_Try, /*On fail goto*//*Label 29400*/ GIMT_Encode4(2223554), // Rule ID 59528 //
     /* 2223470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2223485 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2223504 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223513 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2223516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2223530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223553 */     // GIR_Coverage, 59528,
     /* 2223553 */     GIR_EraseRootFromParent_Done,
     /* 2223554 */   // Label 29400: @2223554
     /* 2223554 */   GIM_Try, /*On fail goto*//*Label 29401*/ GIMT_Encode4(2223643), // Rule ID 59529 //
     /* 2223559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2223574 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2223593 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223602 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2223605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2223619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223642 */     // GIR_Coverage, 59529,
     /* 2223642 */     GIR_EraseRootFromParent_Done,
     /* 2223643 */   // Label 29401: @2223643
     /* 2223643 */   GIM_Try, /*On fail goto*//*Label 29402*/ GIMT_Encode4(2223732), // Rule ID 59530 //
     /* 2223648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2223663 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2223682 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223691 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2223694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2223708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223731 */     // GIR_Coverage, 59530,
     /* 2223731 */     GIR_EraseRootFromParent_Done,
     /* 2223732 */   // Label 29402: @2223732
     /* 2223732 */   GIM_Try, /*On fail goto*//*Label 29403*/ GIMT_Encode4(2223821), // Rule ID 59531 //
     /* 2223737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2223752 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2223771 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223780 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2223783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2223797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223820 */     // GIR_Coverage, 59531,
     /* 2223820 */     GIR_EraseRootFromParent_Done,
     /* 2223821 */   // Label 29403: @2223821
     /* 2223821 */   GIM_Try, /*On fail goto*//*Label 29404*/ GIMT_Encode4(2223874), // Rule ID 48052 //
     /* 2223826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223837 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2223840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2223854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223873 */     // GIR_Coverage, 48052,
     /* 2223873 */     GIR_EraseRootFromParent_Done,
     /* 2223874 */   // Label 29404: @2223874
     /* 2223874 */   GIM_Try, /*On fail goto*//*Label 29405*/ GIMT_Encode4(2223927), // Rule ID 48053 //
     /* 2223879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223890 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2223893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2223907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223926 */     // GIR_Coverage, 48053,
     /* 2223926 */     GIR_EraseRootFromParent_Done,
     /* 2223927 */   // Label 29405: @2223927
     /* 2223927 */   GIM_Reject,
     /* 2223928 */ // Label 29399: @2223928
     /* 2223928 */ GIM_Reject,
     /* 2223929 */ // Label 29364: @2223929
     /* 2223929 */ GIM_Try, /*On fail goto*//*Label 29406*/ GIMT_Encode4(2224407),
     /* 2223934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2223937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2223940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223944 */   GIM_Try, /*On fail goto*//*Label 29407*/ GIMT_Encode4(2224033), // Rule ID 59576 //
     /* 2223949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2223964 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2223983 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223992 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2223995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2224009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224032 */     // GIR_Coverage, 59576,
     /* 2224032 */     GIR_EraseRootFromParent_Done,
     /* 2224033 */   // Label 29407: @2224033
     /* 2224033 */   GIM_Try, /*On fail goto*//*Label 29408*/ GIMT_Encode4(2224122), // Rule ID 59577 //
     /* 2224038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2224041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2224053 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2224072 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224081 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2224084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2224098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224121 */     // GIR_Coverage, 59577,
     /* 2224121 */     GIR_EraseRootFromParent_Done,
     /* 2224122 */   // Label 29408: @2224122
     /* 2224122 */   GIM_Try, /*On fail goto*//*Label 29409*/ GIMT_Encode4(2224211), // Rule ID 59578 //
     /* 2224127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2224130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2224142 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2224161 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224170 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2224173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2224187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224210 */     // GIR_Coverage, 59578,
     /* 2224210 */     GIR_EraseRootFromParent_Done,
     /* 2224211 */   // Label 29409: @2224211
     /* 2224211 */   GIM_Try, /*On fail goto*//*Label 29410*/ GIMT_Encode4(2224300), // Rule ID 59579 //
     /* 2224216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2224219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2224231 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2224250 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224259 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2224262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2224276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224299 */     // GIR_Coverage, 59579,
     /* 2224299 */     GIR_EraseRootFromParent_Done,
     /* 2224300 */   // Label 29410: @2224300
     /* 2224300 */   GIM_Try, /*On fail goto*//*Label 29411*/ GIMT_Encode4(2224353), // Rule ID 48060 //
     /* 2224305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224316 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2224319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2224333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224352 */     // GIR_Coverage, 48060,
     /* 2224352 */     GIR_EraseRootFromParent_Done,
     /* 2224353 */   // Label 29411: @2224353
     /* 2224353 */   GIM_Try, /*On fail goto*//*Label 29412*/ GIMT_Encode4(2224406), // Rule ID 48061 //
     /* 2224358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224369 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2224372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2224386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224405 */     // GIR_Coverage, 48061,
     /* 2224405 */     GIR_EraseRootFromParent_Done,
     /* 2224406 */   // Label 29412: @2224406
     /* 2224406 */   GIM_Reject,
     /* 2224407 */ // Label 29406: @2224407
     /* 2224407 */ GIM_Reject,
     /* 2224408 */ // Label 29365: @2224408
     /* 2224408 */ GIM_Try, /*On fail goto*//*Label 29413*/ GIMT_Encode4(2224886),
     /* 2224413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2224416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2224419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224423 */   GIM_Try, /*On fail goto*//*Label 29414*/ GIMT_Encode4(2224512), // Rule ID 59616 //
     /* 2224428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2224431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2224443 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2224462 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224471 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2224474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2224488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224511 */     // GIR_Coverage, 59616,
     /* 2224511 */     GIR_EraseRootFromParent_Done,
     /* 2224512 */   // Label 29414: @2224512
     /* 2224512 */   GIM_Try, /*On fail goto*//*Label 29415*/ GIMT_Encode4(2224601), // Rule ID 59617 //
     /* 2224517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2224520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2224532 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2224551 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224560 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2224563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2224577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224600 */     // GIR_Coverage, 59617,
     /* 2224600 */     GIR_EraseRootFromParent_Done,
     /* 2224601 */   // Label 29415: @2224601
     /* 2224601 */   GIM_Try, /*On fail goto*//*Label 29416*/ GIMT_Encode4(2224690), // Rule ID 59618 //
     /* 2224606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2224609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2224621 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2224640 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224649 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2224652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2224666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224689 */     // GIR_Coverage, 59618,
     /* 2224689 */     GIR_EraseRootFromParent_Done,
     /* 2224690 */   // Label 29416: @2224690
     /* 2224690 */   GIM_Try, /*On fail goto*//*Label 29417*/ GIMT_Encode4(2224779), // Rule ID 59619 //
     /* 2224695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2224698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2224710 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2224729 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224731 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224738 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2224741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2224755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224778 */     // GIR_Coverage, 59619,
     /* 2224778 */     GIR_EraseRootFromParent_Done,
     /* 2224779 */   // Label 29417: @2224779
     /* 2224779 */   GIM_Try, /*On fail goto*//*Label 29418*/ GIMT_Encode4(2224832), // Rule ID 48076 //
     /* 2224784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2224787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224795 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2224798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2224812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224831 */     // GIR_Coverage, 48076,
     /* 2224831 */     GIR_EraseRootFromParent_Done,
     /* 2224832 */   // Label 29418: @2224832
     /* 2224832 */   GIM_Try, /*On fail goto*//*Label 29419*/ GIMT_Encode4(2224885), // Rule ID 48077 //
     /* 2224837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2224840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224848 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2224851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2224865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224884 */     // GIR_Coverage, 48077,
     /* 2224884 */     GIR_EraseRootFromParent_Done,
     /* 2224885 */   // Label 29419: @2224885
     /* 2224885 */   GIM_Reject,
     /* 2224886 */ // Label 29413: @2224886
     /* 2224886 */ GIM_Reject,
     /* 2224887 */ // Label 29366: @2224887
     /* 2224887 */ GIM_Try, /*On fail goto*//*Label 29420*/ GIMT_Encode4(2225001),
     /* 2224892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2224895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2224898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224906 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224910 */   GIM_Try, /*On fail goto*//*Label 29421*/ GIMT_Encode4(2224955), // Rule ID 48044 //
     /* 2224915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224918 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2224921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2224935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224954 */     // GIR_Coverage, 48044,
     /* 2224954 */     GIR_EraseRootFromParent_Done,
     /* 2224955 */   // Label 29421: @2224955
     /* 2224955 */   GIM_Try, /*On fail goto*//*Label 29422*/ GIMT_Encode4(2225000), // Rule ID 48045 //
     /* 2224960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224963 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2224966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2224980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224999 */     // GIR_Coverage, 48045,
     /* 2224999 */     GIR_EraseRootFromParent_Done,
     /* 2225000 */   // Label 29422: @2225000
     /* 2225000 */   GIM_Reject,
     /* 2225001 */ // Label 29420: @2225001
     /* 2225001 */ GIM_Reject,
     /* 2225002 */ // Label 29367: @2225002
     /* 2225002 */ GIM_Try, /*On fail goto*//*Label 29423*/ GIMT_Encode4(2225480),
     /* 2225007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2225010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2225013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225017 */   GIM_Try, /*On fail goto*//*Label 29424*/ GIMT_Encode4(2225106), // Rule ID 59536 //
     /* 2225022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2225025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2225037 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2225056 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225065 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2225068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2225082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225105 */     // GIR_Coverage, 59536,
     /* 2225105 */     GIR_EraseRootFromParent_Done,
     /* 2225106 */   // Label 29424: @2225106
     /* 2225106 */   GIM_Try, /*On fail goto*//*Label 29425*/ GIMT_Encode4(2225195), // Rule ID 59537 //
     /* 2225111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2225126 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2225145 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225154 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2225157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2225171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225194 */     // GIR_Coverage, 59537,
     /* 2225194 */     GIR_EraseRootFromParent_Done,
     /* 2225195 */   // Label 29425: @2225195
     /* 2225195 */   GIM_Try, /*On fail goto*//*Label 29426*/ GIMT_Encode4(2225284), // Rule ID 59538 //
     /* 2225200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2225203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2225215 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2225234 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225243 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2225246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2225260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225283 */     // GIR_Coverage, 59538,
     /* 2225283 */     GIR_EraseRootFromParent_Done,
     /* 2225284 */   // Label 29426: @2225284
     /* 2225284 */   GIM_Try, /*On fail goto*//*Label 29427*/ GIMT_Encode4(2225373), // Rule ID 59539 //
     /* 2225289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2225304 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2225323 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225332 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2225335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2225349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225372 */     // GIR_Coverage, 59539,
     /* 2225372 */     GIR_EraseRootFromParent_Done,
     /* 2225373 */   // Label 29427: @2225373
     /* 2225373 */   GIM_Try, /*On fail goto*//*Label 29428*/ GIMT_Encode4(2225426), // Rule ID 48056 //
     /* 2225378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225389 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2225392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2225406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225425 */     // GIR_Coverage, 48056,
     /* 2225425 */     GIR_EraseRootFromParent_Done,
     /* 2225426 */   // Label 29428: @2225426
     /* 2225426 */   GIM_Try, /*On fail goto*//*Label 29429*/ GIMT_Encode4(2225479), // Rule ID 48057 //
     /* 2225431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225442 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2225445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2225459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225478 */     // GIR_Coverage, 48057,
     /* 2225478 */     GIR_EraseRootFromParent_Done,
     /* 2225479 */   // Label 29429: @2225479
     /* 2225479 */   GIM_Reject,
     /* 2225480 */ // Label 29423: @2225480
     /* 2225480 */ GIM_Reject,
     /* 2225481 */ // Label 29368: @2225481
     /* 2225481 */ GIM_Try, /*On fail goto*//*Label 29430*/ GIMT_Encode4(2225959),
     /* 2225486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2225489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2225492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225496 */   GIM_Try, /*On fail goto*//*Label 29431*/ GIMT_Encode4(2225585), // Rule ID 59584 //
     /* 2225501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2225504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2225516 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2225535 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225544 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2225547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2225561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225584 */     // GIR_Coverage, 59584,
     /* 2225584 */     GIR_EraseRootFromParent_Done,
     /* 2225585 */   // Label 29431: @2225585
     /* 2225585 */   GIM_Try, /*On fail goto*//*Label 29432*/ GIMT_Encode4(2225674), // Rule ID 59585 //
     /* 2225590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2225605 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2225624 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225633 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2225636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2225650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225673 */     // GIR_Coverage, 59585,
     /* 2225673 */     GIR_EraseRootFromParent_Done,
     /* 2225674 */   // Label 29432: @2225674
     /* 2225674 */   GIM_Try, /*On fail goto*//*Label 29433*/ GIMT_Encode4(2225763), // Rule ID 59586 //
     /* 2225679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2225682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2225694 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2225713 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225722 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2225725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2225739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225762 */     // GIR_Coverage, 59586,
     /* 2225762 */     GIR_EraseRootFromParent_Done,
     /* 2225763 */   // Label 29433: @2225763
     /* 2225763 */   GIM_Try, /*On fail goto*//*Label 29434*/ GIMT_Encode4(2225852), // Rule ID 59587 //
     /* 2225768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2225783 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2225802 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225811 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2225814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2225828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225851 */     // GIR_Coverage, 59587,
     /* 2225851 */     GIR_EraseRootFromParent_Done,
     /* 2225852 */   // Label 29434: @2225852
     /* 2225852 */   GIM_Try, /*On fail goto*//*Label 29435*/ GIMT_Encode4(2225905), // Rule ID 48072 //
     /* 2225857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225868 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2225871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2225885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225904 */     // GIR_Coverage, 48072,
     /* 2225904 */     GIR_EraseRootFromParent_Done,
     /* 2225905 */   // Label 29435: @2225905
     /* 2225905 */   GIM_Try, /*On fail goto*//*Label 29436*/ GIMT_Encode4(2225958), // Rule ID 48073 //
     /* 2225910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225921 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2225924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2225938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225957 */     // GIR_Coverage, 48073,
     /* 2225957 */     GIR_EraseRootFromParent_Done,
     /* 2225958 */   // Label 29436: @2225958
     /* 2225958 */   GIM_Reject,
     /* 2225959 */ // Label 29430: @2225959
     /* 2225959 */ GIM_Reject,
     /* 2225960 */ // Label 29369: @2225960
     /* 2225960 */ GIM_Try, /*On fail goto*//*Label 29437*/ GIMT_Encode4(2226438),
     /* 2225965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2225968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2225971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225975 */   GIM_Try, /*On fail goto*//*Label 29438*/ GIMT_Encode4(2226064), // Rule ID 59624 //
     /* 2225980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2225983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2225995 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2226014 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226023 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2226026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2226040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226063 */     // GIR_Coverage, 59624,
     /* 2226063 */     GIR_EraseRootFromParent_Done,
     /* 2226064 */   // Label 29438: @2226064
     /* 2226064 */   GIM_Try, /*On fail goto*//*Label 29439*/ GIMT_Encode4(2226153), // Rule ID 59625 //
     /* 2226069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2226072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2226084 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2226103 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226112 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2226115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2226129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226152 */     // GIR_Coverage, 59625,
     /* 2226152 */     GIR_EraseRootFromParent_Done,
     /* 2226153 */   // Label 29439: @2226153
     /* 2226153 */   GIM_Try, /*On fail goto*//*Label 29440*/ GIMT_Encode4(2226242), // Rule ID 59626 //
     /* 2226158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2226161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2226173 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2226192 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226201 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2226204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2226218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226241 */     // GIR_Coverage, 59626,
     /* 2226241 */     GIR_EraseRootFromParent_Done,
     /* 2226242 */   // Label 29440: @2226242
     /* 2226242 */   GIM_Try, /*On fail goto*//*Label 29441*/ GIMT_Encode4(2226331), // Rule ID 59627 //
     /* 2226247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2226250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2226262 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2226281 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226290 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2226293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2226307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226330 */     // GIR_Coverage, 59627,
     /* 2226330 */     GIR_EraseRootFromParent_Done,
     /* 2226331 */   // Label 29441: @2226331
     /* 2226331 */   GIM_Try, /*On fail goto*//*Label 29442*/ GIMT_Encode4(2226384), // Rule ID 48116 //
     /* 2226336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2226339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226347 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2226350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2226364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2226379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226383 */     // GIR_Coverage, 48116,
     /* 2226383 */     GIR_EraseRootFromParent_Done,
     /* 2226384 */   // Label 29442: @2226384
     /* 2226384 */   GIM_Try, /*On fail goto*//*Label 29443*/ GIMT_Encode4(2226437), // Rule ID 48117 //
     /* 2226389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2226392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226400 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2226403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2226417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2226432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226436 */     // GIR_Coverage, 48117,
     /* 2226436 */     GIR_EraseRootFromParent_Done,
     /* 2226437 */   // Label 29443: @2226437
     /* 2226437 */   GIM_Reject,
     /* 2226438 */ // Label 29437: @2226438
     /* 2226438 */ GIM_Reject,
     /* 2226439 */ // Label 29370: @2226439
     /* 2226439 */ GIM_Try, /*On fail goto*//*Label 29444*/ GIMT_Encode4(2226553),
     /* 2226444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2226447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2226450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226462 */   GIM_Try, /*On fail goto*//*Label 29445*/ GIMT_Encode4(2226507), // Rule ID 48048 //
     /* 2226467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226470 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2226473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2226487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226506 */     // GIR_Coverage, 48048,
     /* 2226506 */     GIR_EraseRootFromParent_Done,
     /* 2226507 */   // Label 29445: @2226507
     /* 2226507 */   GIM_Try, /*On fail goto*//*Label 29446*/ GIMT_Encode4(2226552), // Rule ID 48049 //
     /* 2226512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226515 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2226518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2226532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226551 */     // GIR_Coverage, 48049,
     /* 2226551 */     GIR_EraseRootFromParent_Done,
     /* 2226552 */   // Label 29446: @2226552
     /* 2226552 */   GIM_Reject,
     /* 2226553 */ // Label 29444: @2226553
     /* 2226553 */ GIM_Reject,
     /* 2226554 */ // Label 29371: @2226554
     /* 2226554 */ GIM_Try, /*On fail goto*//*Label 29447*/ GIMT_Encode4(2227032),
     /* 2226559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2226562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2226565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226569 */   GIM_Try, /*On fail goto*//*Label 29448*/ GIMT_Encode4(2226658), // Rule ID 59544 //
     /* 2226574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2226589 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2226608 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226617 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2226620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2226634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226657 */     // GIR_Coverage, 59544,
     /* 2226657 */     GIR_EraseRootFromParent_Done,
     /* 2226658 */   // Label 29448: @2226658
     /* 2226658 */   GIM_Try, /*On fail goto*//*Label 29449*/ GIMT_Encode4(2226747), // Rule ID 59545 //
     /* 2226663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2226678 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2226697 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226706 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2226709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2226723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226746 */     // GIR_Coverage, 59545,
     /* 2226746 */     GIR_EraseRootFromParent_Done,
     /* 2226747 */   // Label 29449: @2226747
     /* 2226747 */   GIM_Try, /*On fail goto*//*Label 29450*/ GIMT_Encode4(2226836), // Rule ID 59546 //
     /* 2226752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2226767 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2226786 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226795 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2226798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2226812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226835 */     // GIR_Coverage, 59546,
     /* 2226835 */     GIR_EraseRootFromParent_Done,
     /* 2226836 */   // Label 29450: @2226836
     /* 2226836 */   GIM_Try, /*On fail goto*//*Label 29451*/ GIMT_Encode4(2226925), // Rule ID 59547 //
     /* 2226841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2226856 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2226875 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226884 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2226887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2226901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226924 */     // GIR_Coverage, 59547,
     /* 2226924 */     GIR_EraseRootFromParent_Done,
     /* 2226925 */   // Label 29451: @2226925
     /* 2226925 */   GIM_Try, /*On fail goto*//*Label 29452*/ GIMT_Encode4(2226978), // Rule ID 48068 //
     /* 2226930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226941 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2226944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2226958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226977 */     // GIR_Coverage, 48068,
     /* 2226977 */     GIR_EraseRootFromParent_Done,
     /* 2226978 */   // Label 29452: @2226978
     /* 2226978 */   GIM_Try, /*On fail goto*//*Label 29453*/ GIMT_Encode4(2227031), // Rule ID 48069 //
     /* 2226983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2226994 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2226997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2227011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227030 */     // GIR_Coverage, 48069,
     /* 2227030 */     GIR_EraseRootFromParent_Done,
     /* 2227031 */   // Label 29453: @2227031
     /* 2227031 */   GIM_Reject,
     /* 2227032 */ // Label 29447: @2227032
     /* 2227032 */ GIM_Reject,
     /* 2227033 */ // Label 29372: @2227033
     /* 2227033 */ GIM_Try, /*On fail goto*//*Label 29454*/ GIMT_Encode4(2227511),
     /* 2227038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2227041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2227044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227048 */   GIM_Try, /*On fail goto*//*Label 29455*/ GIMT_Encode4(2227137), // Rule ID 59592 //
     /* 2227053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2227056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2227068 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2227083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2227087 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227096 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2227099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2227113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227136 */     // GIR_Coverage, 59592,
     /* 2227136 */     GIR_EraseRootFromParent_Done,
     /* 2227137 */   // Label 29455: @2227137
     /* 2227137 */   GIM_Try, /*On fail goto*//*Label 29456*/ GIMT_Encode4(2227226), // Rule ID 59593 //
     /* 2227142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2227145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2227157 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2227172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2227176 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227185 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2227188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2227202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227225 */     // GIR_Coverage, 59593,
     /* 2227225 */     GIR_EraseRootFromParent_Done,
     /* 2227226 */   // Label 29456: @2227226
     /* 2227226 */   GIM_Try, /*On fail goto*//*Label 29457*/ GIMT_Encode4(2227315), // Rule ID 59594 //
     /* 2227231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2227234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2227246 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2227265 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227274 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2227277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2227291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227314 */     // GIR_Coverage, 59594,
     /* 2227314 */     GIR_EraseRootFromParent_Done,
     /* 2227315 */   // Label 29457: @2227315
     /* 2227315 */   GIM_Try, /*On fail goto*//*Label 29458*/ GIMT_Encode4(2227404), // Rule ID 59595 //
     /* 2227320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2227323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2227335 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2227354 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227363 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2227366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2227380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227403 */     // GIR_Coverage, 59595,
     /* 2227403 */     GIR_EraseRootFromParent_Done,
     /* 2227404 */   // Label 29458: @2227404
     /* 2227404 */   GIM_Try, /*On fail goto*//*Label 29459*/ GIMT_Encode4(2227457), // Rule ID 48104 //
     /* 2227409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227420 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2227423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2227437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227456 */     // GIR_Coverage, 48104,
     /* 2227456 */     GIR_EraseRootFromParent_Done,
     /* 2227457 */   // Label 29459: @2227457
     /* 2227457 */   GIM_Try, /*On fail goto*//*Label 29460*/ GIMT_Encode4(2227510), // Rule ID 48105 //
     /* 2227462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227473 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2227476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2227490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227509 */     // GIR_Coverage, 48105,
     /* 2227509 */     GIR_EraseRootFromParent_Done,
     /* 2227510 */   // Label 29460: @2227510
     /* 2227510 */   GIM_Reject,
     /* 2227511 */ // Label 29454: @2227511
     /* 2227511 */ GIM_Reject,
     /* 2227512 */ // Label 29373: @2227512
     /* 2227512 */ GIM_Try, /*On fail goto*//*Label 29461*/ GIMT_Encode4(2227990),
     /* 2227517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2227520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2227523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227527 */   GIM_Try, /*On fail goto*//*Label 29462*/ GIMT_Encode4(2227616), // Rule ID 59632 //
     /* 2227532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2227535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2227547 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2227562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2227566 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227575 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2227578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2227592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227615 */     // GIR_Coverage, 59632,
     /* 2227615 */     GIR_EraseRootFromParent_Done,
     /* 2227616 */   // Label 29462: @2227616
     /* 2227616 */   GIM_Try, /*On fail goto*//*Label 29463*/ GIMT_Encode4(2227705), // Rule ID 59633 //
     /* 2227621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2227624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2227636 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2227651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2227655 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227664 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2227667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2227681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227704 */     // GIR_Coverage, 59633,
     /* 2227704 */     GIR_EraseRootFromParent_Done,
     /* 2227705 */   // Label 29463: @2227705
     /* 2227705 */   GIM_Try, /*On fail goto*//*Label 29464*/ GIMT_Encode4(2227794), // Rule ID 59634 //
     /* 2227710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2227713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2227725 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2227744 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227753 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2227756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2227770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227793 */     // GIR_Coverage, 59634,
     /* 2227793 */     GIR_EraseRootFromParent_Done,
     /* 2227794 */   // Label 29464: @2227794
     /* 2227794 */   GIM_Try, /*On fail goto*//*Label 29465*/ GIMT_Encode4(2227883), // Rule ID 59635 //
     /* 2227799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2227802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2227814 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2227833 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227842 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2227845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2227859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227882 */     // GIR_Coverage, 59635,
     /* 2227882 */     GIR_EraseRootFromParent_Done,
     /* 2227883 */   // Label 29465: @2227883
     /* 2227883 */   GIM_Try, /*On fail goto*//*Label 29466*/ GIMT_Encode4(2227936), // Rule ID 48120 //
     /* 2227888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2227891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227899 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2227902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2227916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2227931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227935 */     // GIR_Coverage, 48120,
     /* 2227935 */     GIR_EraseRootFromParent_Done,
     /* 2227936 */   // Label 29466: @2227936
     /* 2227936 */   GIM_Try, /*On fail goto*//*Label 29467*/ GIMT_Encode4(2227989), // Rule ID 48121 //
     /* 2227941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2227944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227952 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2227955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2227969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2227984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227988 */     // GIR_Coverage, 48121,
     /* 2227988 */     GIR_EraseRootFromParent_Done,
     /* 2227989 */   // Label 29467: @2227989
     /* 2227989 */   GIM_Reject,
     /* 2227990 */ // Label 29461: @2227990
     /* 2227990 */ GIM_Reject,
     /* 2227991 */ // Label 29374: @2227991
     /* 2227991 */ GIM_Try, /*On fail goto*//*Label 29468*/ GIMT_Encode4(2228105),
     /* 2227996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2227999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2228002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228014 */   GIM_Try, /*On fail goto*//*Label 29469*/ GIMT_Encode4(2228059), // Rule ID 48064 //
     /* 2228019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228022 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2228025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2228039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228058 */     // GIR_Coverage, 48064,
     /* 2228058 */     GIR_EraseRootFromParent_Done,
     /* 2228059 */   // Label 29469: @2228059
     /* 2228059 */   GIM_Try, /*On fail goto*//*Label 29470*/ GIMT_Encode4(2228104), // Rule ID 48065 //
     /* 2228064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228067 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2228070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2228084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228103 */     // GIR_Coverage, 48065,
     /* 2228103 */     GIR_EraseRootFromParent_Done,
     /* 2228104 */   // Label 29470: @2228104
     /* 2228104 */   GIM_Reject,
     /* 2228105 */ // Label 29468: @2228105
     /* 2228105 */ GIM_Reject,
     /* 2228106 */ // Label 29375: @2228106
     /* 2228106 */ GIM_Try, /*On fail goto*//*Label 29471*/ GIMT_Encode4(2228584),
     /* 2228111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2228114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2228117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228121 */   GIM_Try, /*On fail goto*//*Label 29472*/ GIMT_Encode4(2228210), // Rule ID 59552 //
     /* 2228126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2228129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2228137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2228141 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2228143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2228152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2228156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2228160 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2228162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2228169 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2228172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2228186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2228195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2228199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228209 */     // GIR_Coverage, 59552,
     /* 2228209 */     GIR_EraseRootFromParent_Done,
     /* 2228210 */   // Label 29472: @2228210
     /* 2228210 */   GIM_Try, /*On fail goto*//*Label 29473*/ GIMT_Encode4(2228299), // Rule ID 59553 //
     /* 2228215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2228218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2228226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2228230 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2228232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2228241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2228245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2228249 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2228251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2228258 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2228261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2228275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2228284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2228288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228298 */     // GIR_Coverage, 59553,
     /* 2228298 */     GIR_EraseRootFromParent_Done,
     /* 2228299 */   // Label 29473: @2228299
     /* 2228299 */   GIM_Try, /*On fail goto*//*Label 29474*/ GIMT_Encode4(2228388), // Rule ID 59554 //
     /* 2228304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2228307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2228315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2228319 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2228321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2228330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2228334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2228338 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2228340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2228347 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2228350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2228364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2228373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2228377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228387 */     // GIR_Coverage, 59554,
     /* 2228387 */     GIR_EraseRootFromParent_Done,
     /* 2228388 */   // Label 29474: @2228388
     /* 2228388 */   GIM_Try, /*On fail goto*//*Label 29475*/ GIMT_Encode4(2228477), // Rule ID 59555 //
     /* 2228393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2228396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2228404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2228408 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2228410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2228419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2228423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2228427 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2228429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2228436 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2228439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2228453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2228462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2228466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228476 */     // GIR_Coverage, 59555,
     /* 2228476 */     GIR_EraseRootFromParent_Done,
     /* 2228477 */   // Label 29475: @2228477
     /* 2228477 */   GIM_Try, /*On fail goto*//*Label 29476*/ GIMT_Encode4(2228530), // Rule ID 48092 //
     /* 2228482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228493 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2228496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2228510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228529 */     // GIR_Coverage, 48092,
     /* 2228529 */     GIR_EraseRootFromParent_Done,
     /* 2228530 */   // Label 29476: @2228530
     /* 2228530 */   GIM_Try, /*On fail goto*//*Label 29477*/ GIMT_Encode4(2228583), // Rule ID 48093 //
     /* 2228535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228546 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2228549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2228563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228582 */     // GIR_Coverage, 48093,
     /* 2228582 */     GIR_EraseRootFromParent_Done,
     /* 2228583 */   // Label 29477: @2228583
     /* 2228583 */   GIM_Reject,
     /* 2228584 */ // Label 29471: @2228584
     /* 2228584 */ GIM_Reject,
     /* 2228585 */ // Label 29376: @2228585
     /* 2228585 */ GIM_Try, /*On fail goto*//*Label 29478*/ GIMT_Encode4(2229063),
     /* 2228590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2228593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2228596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2228600 */   GIM_Try, /*On fail goto*//*Label 29479*/ GIMT_Encode4(2228689), // Rule ID 59600 //
     /* 2228605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2228608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2228616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2228620 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2228622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2228631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2228635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2228639 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2228641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2228648 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2228651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2228665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2228674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2228678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228688 */     // GIR_Coverage, 59600,
     /* 2228688 */     GIR_EraseRootFromParent_Done,
     /* 2228689 */   // Label 29479: @2228689
     /* 2228689 */   GIM_Try, /*On fail goto*//*Label 29480*/ GIMT_Encode4(2228778), // Rule ID 59601 //
     /* 2228694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2228697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2228705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2228709 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2228711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2228720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2228724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2228728 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2228730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2228737 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2228740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2228754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2228763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2228767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228777 */     // GIR_Coverage, 59601,
     /* 2228777 */     GIR_EraseRootFromParent_Done,
     /* 2228778 */   // Label 29480: @2228778
     /* 2228778 */   GIM_Try, /*On fail goto*//*Label 29481*/ GIMT_Encode4(2228867), // Rule ID 59602 //
     /* 2228783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2228786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2228794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2228798 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2228800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2228809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2228813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2228817 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2228819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2228826 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2228829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2228843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2228852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2228856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228866 */     // GIR_Coverage, 59602,
     /* 2228866 */     GIR_EraseRootFromParent_Done,
     /* 2228867 */   // Label 29481: @2228867
     /* 2228867 */   GIM_Try, /*On fail goto*//*Label 29482*/ GIMT_Encode4(2228956), // Rule ID 59603 //
     /* 2228872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2228875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2228883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2228887 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2228889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2228898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2228902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2228906 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2228908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2228915 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2228918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2228932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2228941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2228945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228955 */     // GIR_Coverage, 59603,
     /* 2228955 */     GIR_EraseRootFromParent_Done,
     /* 2228956 */   // Label 29482: @2228956
     /* 2228956 */   GIM_Try, /*On fail goto*//*Label 29483*/ GIMT_Encode4(2229009), // Rule ID 48108 //
     /* 2228961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2228968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2228972 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2228975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2228989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229008 */     // GIR_Coverage, 48108,
     /* 2229008 */     GIR_EraseRootFromParent_Done,
     /* 2229009 */   // Label 29483: @2229009
     /* 2229009 */   GIM_Try, /*On fail goto*//*Label 29484*/ GIMT_Encode4(2229062), // Rule ID 48109 //
     /* 2229014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229025 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2229028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2229042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229061 */     // GIR_Coverage, 48109,
     /* 2229061 */     GIR_EraseRootFromParent_Done,
     /* 2229062 */   // Label 29484: @2229062
     /* 2229062 */   GIM_Reject,
     /* 2229063 */ // Label 29478: @2229063
     /* 2229063 */ GIM_Reject,
     /* 2229064 */ // Label 29377: @2229064
     /* 2229064 */ GIM_Try, /*On fail goto*//*Label 29485*/ GIMT_Encode4(2229542),
     /* 2229069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2229072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2229075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229079 */   GIM_Try, /*On fail goto*//*Label 29486*/ GIMT_Encode4(2229168), // Rule ID 59640 //
     /* 2229084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2229087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2229091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2229095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2229099 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2229101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2229110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2229114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2229118 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2229120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2229127 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2229130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2229144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2229153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2229157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229167 */     // GIR_Coverage, 59640,
     /* 2229167 */     GIR_EraseRootFromParent_Done,
     /* 2229168 */   // Label 29486: @2229168
     /* 2229168 */   GIM_Try, /*On fail goto*//*Label 29487*/ GIMT_Encode4(2229257), // Rule ID 59641 //
     /* 2229173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2229176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2229180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2229184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2229188 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2229190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2229199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2229203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2229207 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2229209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2229216 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2229219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2229233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2229242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2229246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229256 */     // GIR_Coverage, 59641,
     /* 2229256 */     GIR_EraseRootFromParent_Done,
     /* 2229257 */   // Label 29487: @2229257
     /* 2229257 */   GIM_Try, /*On fail goto*//*Label 29488*/ GIMT_Encode4(2229346), // Rule ID 59642 //
     /* 2229262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2229265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2229269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2229273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2229277 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2229279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2229288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2229292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2229296 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2229298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2229305 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2229308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2229322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2229331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2229335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229345 */     // GIR_Coverage, 59642,
     /* 2229345 */     GIR_EraseRootFromParent_Done,
     /* 2229346 */   // Label 29488: @2229346
     /* 2229346 */   GIM_Try, /*On fail goto*//*Label 29489*/ GIMT_Encode4(2229435), // Rule ID 59643 //
     /* 2229351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2229354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2229358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2229362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2229366 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2229368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2229377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2229381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2229385 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2229387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2229394 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2229397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2229411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2229420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2229424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229434 */     // GIR_Coverage, 59643,
     /* 2229434 */     GIR_EraseRootFromParent_Done,
     /* 2229435 */   // Label 29489: @2229435
     /* 2229435 */   GIM_Try, /*On fail goto*//*Label 29490*/ GIMT_Encode4(2229488), // Rule ID 48124 //
     /* 2229440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2229443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229451 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2229454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2229468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229487 */     // GIR_Coverage, 48124,
     /* 2229487 */     GIR_EraseRootFromParent_Done,
     /* 2229488 */   // Label 29490: @2229488
     /* 2229488 */   GIM_Try, /*On fail goto*//*Label 29491*/ GIMT_Encode4(2229541), // Rule ID 48125 //
     /* 2229493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2229496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229504 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2229507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2229521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229540 */     // GIR_Coverage, 48125,
     /* 2229540 */     GIR_EraseRootFromParent_Done,
     /* 2229541 */   // Label 29491: @2229541
     /* 2229541 */   GIM_Reject,
     /* 2229542 */ // Label 29485: @2229542
     /* 2229542 */ GIM_Reject,
     /* 2229543 */ // Label 29378: @2229543
     /* 2229543 */ GIM_Try, /*On fail goto*//*Label 29492*/ GIMT_Encode4(2229657),
     /* 2229548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2229551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2229554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229566 */   GIM_Try, /*On fail goto*//*Label 29493*/ GIMT_Encode4(2229611), // Rule ID 48080 //
     /* 2229571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229574 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2229577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2229591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229610 */     // GIR_Coverage, 48080,
     /* 2229610 */     GIR_EraseRootFromParent_Done,
     /* 2229611 */   // Label 29493: @2229611
     /* 2229611 */   GIM_Try, /*On fail goto*//*Label 29494*/ GIMT_Encode4(2229656), // Rule ID 48081 //
     /* 2229616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229619 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2229622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2229636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229655 */     // GIR_Coverage, 48081,
     /* 2229655 */     GIR_EraseRootFromParent_Done,
     /* 2229656 */   // Label 29494: @2229656
     /* 2229656 */   GIM_Reject,
     /* 2229657 */ // Label 29492: @2229657
     /* 2229657 */ GIM_Reject,
     /* 2229658 */ // Label 29379: @2229658
     /* 2229658 */ GIM_Try, /*On fail goto*//*Label 29495*/ GIMT_Encode4(2230136),
     /* 2229663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2229666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2229669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229673 */   GIM_Try, /*On fail goto*//*Label 29496*/ GIMT_Encode4(2229762), // Rule ID 59560 //
     /* 2229678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2229681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2229685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2229689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2229693 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2229695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2229704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2229708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2229712 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2229714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2229721 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2229724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2229738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2229747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2229751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229761 */     // GIR_Coverage, 59560,
     /* 2229761 */     GIR_EraseRootFromParent_Done,
     /* 2229762 */   // Label 29496: @2229762
     /* 2229762 */   GIM_Try, /*On fail goto*//*Label 29497*/ GIMT_Encode4(2229851), // Rule ID 59561 //
     /* 2229767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2229770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2229774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2229778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2229782 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2229784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2229793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2229797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2229801 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2229803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2229810 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2229813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2229827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2229836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2229840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229850 */     // GIR_Coverage, 59561,
     /* 2229850 */     GIR_EraseRootFromParent_Done,
     /* 2229851 */   // Label 29497: @2229851
     /* 2229851 */   GIM_Try, /*On fail goto*//*Label 29498*/ GIMT_Encode4(2229940), // Rule ID 59562 //
     /* 2229856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2229859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2229863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2229867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2229871 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2229873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2229882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2229886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2229890 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2229892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2229899 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2229902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2229916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2229925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2229929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229939 */     // GIR_Coverage, 59562,
     /* 2229939 */     GIR_EraseRootFromParent_Done,
     /* 2229940 */   // Label 29498: @2229940
     /* 2229940 */   GIM_Try, /*On fail goto*//*Label 29499*/ GIMT_Encode4(2230029), // Rule ID 59563 //
     /* 2229945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2229948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2229952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2229956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2229960 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2229962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2229971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2229975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2229979 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2229981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2229988 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2229991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2230005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2230014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2230018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230028 */     // GIR_Coverage, 59563,
     /* 2230028 */     GIR_EraseRootFromParent_Done,
     /* 2230029 */   // Label 29499: @2230029
     /* 2230029 */   GIM_Try, /*On fail goto*//*Label 29500*/ GIMT_Encode4(2230082), // Rule ID 48096 //
     /* 2230034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230045 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2230048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2230062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230081 */     // GIR_Coverage, 48096,
     /* 2230081 */     GIR_EraseRootFromParent_Done,
     /* 2230082 */   // Label 29500: @2230082
     /* 2230082 */   GIM_Try, /*On fail goto*//*Label 29501*/ GIMT_Encode4(2230135), // Rule ID 48097 //
     /* 2230087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230098 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2230101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2230115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230134 */     // GIR_Coverage, 48097,
     /* 2230134 */     GIR_EraseRootFromParent_Done,
     /* 2230135 */   // Label 29501: @2230135
     /* 2230135 */   GIM_Reject,
     /* 2230136 */ // Label 29495: @2230136
     /* 2230136 */ GIM_Reject,
     /* 2230137 */ // Label 29380: @2230137
     /* 2230137 */ GIM_Try, /*On fail goto*//*Label 29502*/ GIMT_Encode4(2230615),
     /* 2230142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2230145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2230148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230152 */   GIM_Try, /*On fail goto*//*Label 29503*/ GIMT_Encode4(2230241), // Rule ID 59608 //
     /* 2230157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2230160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2230164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2230168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2230172 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2230174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2230183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2230187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2230191 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2230193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2230200 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2230217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2230226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2230230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230240 */     // GIR_Coverage, 59608,
     /* 2230240 */     GIR_EraseRootFromParent_Done,
     /* 2230241 */   // Label 29503: @2230241
     /* 2230241 */   GIM_Try, /*On fail goto*//*Label 29504*/ GIMT_Encode4(2230330), // Rule ID 59609 //
     /* 2230246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2230249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2230253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2230257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2230261 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2230263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2230272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2230276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2230280 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2230282 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2230289 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2230306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2230315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2230319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230329 */     // GIR_Coverage, 59609,
     /* 2230329 */     GIR_EraseRootFromParent_Done,
     /* 2230330 */   // Label 29504: @2230330
     /* 2230330 */   GIM_Try, /*On fail goto*//*Label 29505*/ GIMT_Encode4(2230419), // Rule ID 59610 //
     /* 2230335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2230338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2230342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2230346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2230350 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2230352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2230361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2230365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2230369 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2230371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2230378 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2230395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2230404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2230408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230418 */     // GIR_Coverage, 59610,
     /* 2230418 */     GIR_EraseRootFromParent_Done,
     /* 2230419 */   // Label 29505: @2230419
     /* 2230419 */   GIM_Try, /*On fail goto*//*Label 29506*/ GIMT_Encode4(2230508), // Rule ID 59611 //
     /* 2230424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2230427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2230431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2230435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2230439 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2230441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2230450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2230454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2230458 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2230460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2230467 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2230484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2230493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2230497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230507 */     // GIR_Coverage, 59611,
     /* 2230507 */     GIR_EraseRootFromParent_Done,
     /* 2230508 */   // Label 29506: @2230508
     /* 2230508 */   GIM_Try, /*On fail goto*//*Label 29507*/ GIMT_Encode4(2230561), // Rule ID 48112 //
     /* 2230513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230524 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2230541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230560 */     // GIR_Coverage, 48112,
     /* 2230560 */     GIR_EraseRootFromParent_Done,
     /* 2230561 */   // Label 29507: @2230561
     /* 2230561 */   GIM_Try, /*On fail goto*//*Label 29508*/ GIMT_Encode4(2230614), // Rule ID 48113 //
     /* 2230566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230577 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2230594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230613 */     // GIR_Coverage, 48113,
     /* 2230613 */     GIR_EraseRootFromParent_Done,
     /* 2230614 */   // Label 29508: @2230614
     /* 2230614 */   GIM_Reject,
     /* 2230615 */ // Label 29502: @2230615
     /* 2230615 */ GIM_Reject,
     /* 2230616 */ // Label 29381: @2230616
     /* 2230616 */ GIM_Try, /*On fail goto*//*Label 29509*/ GIMT_Encode4(2230730),
     /* 2230621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2230624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2230627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230639 */   GIM_Try, /*On fail goto*//*Label 29510*/ GIMT_Encode4(2230684), // Rule ID 48084 //
     /* 2230644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230647 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2230650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2230664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230683 */     // GIR_Coverage, 48084,
     /* 2230683 */     GIR_EraseRootFromParent_Done,
     /* 2230684 */   // Label 29510: @2230684
     /* 2230684 */   GIM_Try, /*On fail goto*//*Label 29511*/ GIMT_Encode4(2230729), // Rule ID 48085 //
     /* 2230689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230692 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2230695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2230709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230728 */     // GIR_Coverage, 48085,
     /* 2230728 */     GIR_EraseRootFromParent_Done,
     /* 2230729 */   // Label 29511: @2230729
     /* 2230729 */   GIM_Reject,
     /* 2230730 */ // Label 29509: @2230730
     /* 2230730 */ GIM_Reject,
     /* 2230731 */ // Label 29382: @2230731
     /* 2230731 */ GIM_Try, /*On fail goto*//*Label 29512*/ GIMT_Encode4(2231209),
     /* 2230736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2230739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2230742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230746 */   GIM_Try, /*On fail goto*//*Label 29513*/ GIMT_Encode4(2230835), // Rule ID 59568 //
     /* 2230751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2230754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2230758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2230762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2230766 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2230768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2230777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2230781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2230785 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2230787 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2230794 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2230797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2230811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2230820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2230824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230834 */     // GIR_Coverage, 59568,
     /* 2230834 */     GIR_EraseRootFromParent_Done,
     /* 2230835 */   // Label 29513: @2230835
     /* 2230835 */   GIM_Try, /*On fail goto*//*Label 29514*/ GIMT_Encode4(2230924), // Rule ID 59569 //
     /* 2230840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2230843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2230847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2230851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2230855 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2230857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2230866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2230870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2230874 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2230876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2230883 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2230886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2230900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2230909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2230913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230923 */     // GIR_Coverage, 59569,
     /* 2230923 */     GIR_EraseRootFromParent_Done,
     /* 2230924 */   // Label 29514: @2230924
     /* 2230924 */   GIM_Try, /*On fail goto*//*Label 29515*/ GIMT_Encode4(2231013), // Rule ID 59570 //
     /* 2230929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2230932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2230936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2230940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2230944 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2230946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2230955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2230959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2230963 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2230965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2230972 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2230975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2230989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2230998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2231002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231012 */     // GIR_Coverage, 59570,
     /* 2231012 */     GIR_EraseRootFromParent_Done,
     /* 2231013 */   // Label 29515: @2231013
     /* 2231013 */   GIM_Try, /*On fail goto*//*Label 29516*/ GIMT_Encode4(2231102), // Rule ID 59571 //
     /* 2231018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2231021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2231025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2231029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2231033 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2231035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2231044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2231048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2231052 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2231054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2231059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2231061 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2231064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2231078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2231087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2231091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231101 */     // GIR_Coverage, 59571,
     /* 2231101 */     GIR_EraseRootFromParent_Done,
     /* 2231102 */   // Label 29516: @2231102
     /* 2231102 */   GIM_Try, /*On fail goto*//*Label 29517*/ GIMT_Encode4(2231155), // Rule ID 48100 //
     /* 2231107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231118 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2231121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2231135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231154 */     // GIR_Coverage, 48100,
     /* 2231154 */     GIR_EraseRootFromParent_Done,
     /* 2231155 */   // Label 29517: @2231155
     /* 2231155 */   GIM_Try, /*On fail goto*//*Label 29518*/ GIMT_Encode4(2231208), // Rule ID 48101 //
     /* 2231160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231171 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2231174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2231188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231207 */     // GIR_Coverage, 48101,
     /* 2231207 */     GIR_EraseRootFromParent_Done,
     /* 2231208 */   // Label 29518: @2231208
     /* 2231208 */   GIM_Reject,
     /* 2231209 */ // Label 29512: @2231209
     /* 2231209 */ GIM_Reject,
     /* 2231210 */ // Label 29383: @2231210
     /* 2231210 */ GIM_Try, /*On fail goto*//*Label 29519*/ GIMT_Encode4(2231324),
     /* 2231215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2231218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2231221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2231233 */   GIM_Try, /*On fail goto*//*Label 29520*/ GIMT_Encode4(2231278), // Rule ID 48088 //
     /* 2231238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231241 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2231244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2231258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231277 */     // GIR_Coverage, 48088,
     /* 2231277 */     GIR_EraseRootFromParent_Done,
     /* 2231278 */   // Label 29520: @2231278
     /* 2231278 */   GIM_Try, /*On fail goto*//*Label 29521*/ GIMT_Encode4(2231323), // Rule ID 48089 //
     /* 2231283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231286 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2231289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2231303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231322 */     // GIR_Coverage, 48089,
     /* 2231322 */     GIR_EraseRootFromParent_Done,
     /* 2231323 */   // Label 29521: @2231323
     /* 2231323 */   GIM_Reject,
     /* 2231324 */ // Label 29519: @2231324
     /* 2231324 */ GIM_Reject,
     /* 2231325 */ // Label 29384: @2231325
     /* 2231325 */ GIM_Reject,
     /* 2231326 */ // Label 44: @2231326
     /* 2231326 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29546*/ GIMT_Encode4(2234356),
     /* 2231337 */ /*GILLT_s32*//*Label 29522*/ GIMT_Encode4(2231461),
     /* 2231341 */ /*GILLT_s64*//*Label 29523*/ GIMT_Encode4(2231545), GIMT_Encode4(0),
     /* 2231349 */ /*GILLT_nxv1s8*//*Label 29524*/ GIMT_Encode4(2231826),
     /* 2231353 */ /*GILLT_nxv1s16*//*Label 29525*/ GIMT_Encode4(2231941),
     /* 2231357 */ /*GILLT_nxv1s32*//*Label 29526*/ GIMT_Encode4(2232056),
     /* 2231361 */ /*GILLT_nxv1s64*//*Label 29527*/ GIMT_Encode4(2232171), GIMT_Encode4(0),
     /* 2231369 */ /*GILLT_nxv2s8*//*Label 29528*/ GIMT_Encode4(2232286),
     /* 2231373 */ /*GILLT_nxv2s16*//*Label 29529*/ GIMT_Encode4(2232401),
     /* 2231377 */ /*GILLT_nxv2s32*//*Label 29530*/ GIMT_Encode4(2232516),
     /* 2231381 */ /*GILLT_nxv2s64*//*Label 29531*/ GIMT_Encode4(2232631), GIMT_Encode4(0),
     /* 2231389 */ /*GILLT_nxv4s8*//*Label 29532*/ GIMT_Encode4(2232746),
     /* 2231393 */ /*GILLT_nxv4s16*//*Label 29533*/ GIMT_Encode4(2232861),
     /* 2231397 */ /*GILLT_nxv4s32*//*Label 29534*/ GIMT_Encode4(2232976),
     /* 2231401 */ /*GILLT_nxv4s64*//*Label 29535*/ GIMT_Encode4(2233091), GIMT_Encode4(0),
     /* 2231409 */ /*GILLT_nxv8s8*//*Label 29536*/ GIMT_Encode4(2233206),
     /* 2231413 */ /*GILLT_nxv8s16*//*Label 29537*/ GIMT_Encode4(2233321),
     /* 2231417 */ /*GILLT_nxv8s32*//*Label 29538*/ GIMT_Encode4(2233436),
     /* 2231421 */ /*GILLT_nxv8s64*//*Label 29539*/ GIMT_Encode4(2233551), GIMT_Encode4(0),
     /* 2231429 */ /*GILLT_nxv16s8*//*Label 29540*/ GIMT_Encode4(2233666),
     /* 2231433 */ /*GILLT_nxv16s16*//*Label 29541*/ GIMT_Encode4(2233781),
     /* 2231437 */ /*GILLT_nxv16s32*//*Label 29542*/ GIMT_Encode4(2233896), GIMT_Encode4(0),
     /* 2231445 */ /*GILLT_nxv32s8*//*Label 29543*/ GIMT_Encode4(2234011),
     /* 2231449 */ /*GILLT_nxv32s16*//*Label 29544*/ GIMT_Encode4(2234126), GIMT_Encode4(0),
     /* 2231457 */ /*GILLT_nxv64s8*//*Label 29545*/ GIMT_Encode4(2234241),
     /* 2231461 */ // Label 29522: @2231461
     /* 2231461 */ GIM_Try, /*On fail goto*//*Label 29547*/ GIMT_Encode4(2231544),
     /* 2231466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2231469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2231472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231480 */   GIM_Try, /*On fail goto*//*Label 29548*/ GIMT_Encode4(2231514), // Rule ID 93 //
     /* 2231485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2231492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2231500 */     // MIs[1] Operand 1
     /* 2231500 */     // No operand predicates
     /* 2231500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231502 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2231502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2231505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2231512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231513 */     // GIR_Coverage, 93,
     /* 2231513 */     GIR_EraseRootFromParent_Done,
     /* 2231514 */   // Label 29548: @2231514
     /* 2231514 */   GIM_Try, /*On fail goto*//*Label 29549*/ GIMT_Encode4(2231543), // Rule ID 107 //
     /* 2231519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2231529 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2231529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2231532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2231541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231542 */     // GIR_Coverage, 107,
     /* 2231542 */     GIR_EraseRootFromParent_Done,
     /* 2231543 */   // Label 29549: @2231543
     /* 2231543 */   GIM_Reject,
     /* 2231544 */ // Label 29547: @2231544
     /* 2231544 */ GIM_Reject,
     /* 2231545 */ // Label 29523: @2231545
     /* 2231545 */ GIM_Try, /*On fail goto*//*Label 29550*/ GIMT_Encode4(2231825),
     /* 2231550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2231553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2231556 */   GIM_Try, /*On fail goto*//*Label 29551*/ GIMT_Encode4(2231628), // Rule ID 257 //
     /* 2231561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2231564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2231572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2231576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2231580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2231584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231589 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2231600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2231604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231608 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2231612 */     // MIs[2] Operand 1
     /* 2231612 */     // No operand predicates
     /* 2231612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2231614 */     // (srl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2231614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /* 2231617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2231623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2231626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231627 */     // GIR_Coverage, 257,
     /* 2231627 */     GIR_EraseRootFromParent_Done,
     /* 2231628 */   // Label 29551: @2231628
     /* 2231628 */   GIM_Try, /*On fail goto*//*Label 29552*/ GIMT_Encode4(2231673), // Rule ID 62562 //
     /* 2231633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2231636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2231644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2231648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2231652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2231656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10025),
     /* 2231660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231662 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })<<P:Predicate_anonymous_10025>>  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2231662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2231665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2231671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231672 */     // GIR_Coverage, 62562,
     /* 2231672 */     GIR_EraseRootFromParent_Done,
     /* 2231673 */   // Label 29552: @2231673
     /* 2231673 */   GIM_Try, /*On fail goto*//*Label 29553*/ GIMT_Encode4(2231745), // Rule ID 269 //
     /* 2231678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2231681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2231689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2231693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2231697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231702 */     // MIs[1] Operand 2
     /* 2231702 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2231713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2231717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231721 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2231725 */     // MIs[2] Operand 1
     /* 2231725 */     // No operand predicates
     /* 2231725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10025),
     /* 2231729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2231731 */     // (srl:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)<<P:Predicate_anonymous_10025>>  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2231731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2231734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2231740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2231743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231744 */     // GIR_Coverage, 269,
     /* 2231744 */     GIR_EraseRootFromParent_Done,
     /* 2231745 */   // Label 29553: @2231745
     /* 2231745 */   GIM_Try, /*On fail goto*//*Label 29554*/ GIMT_Encode4(2231787), // Rule ID 92 //
     /* 2231750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2231753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2231765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2231773 */     // MIs[1] Operand 1
     /* 2231773 */     // No operand predicates
     /* 2231773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231775 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2231775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2231778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2231785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231786 */     // GIR_Coverage, 92,
     /* 2231786 */     GIR_EraseRootFromParent_Done,
     /* 2231787 */   // Label 29554: @2231787
     /* 2231787 */   GIM_Try, /*On fail goto*//*Label 29555*/ GIMT_Encode4(2231824), // Rule ID 106 //
     /* 2231792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2231795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2231810 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2231810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2231813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2231822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231823 */     // GIR_Coverage, 106,
     /* 2231823 */     GIR_EraseRootFromParent_Done,
     /* 2231824 */   // Label 29555: @2231824
     /* 2231824 */   GIM_Reject,
     /* 2231825 */ // Label 29550: @2231825
     /* 2231825 */ GIM_Reject,
     /* 2231826 */ // Label 29524: @2231826
     /* 2231826 */ GIM_Try, /*On fail goto*//*Label 29556*/ GIMT_Encode4(2231940),
     /* 2231831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2231834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2231837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231849 */   GIM_Try, /*On fail goto*//*Label 29557*/ GIMT_Encode4(2231894), // Rule ID 48172 //
     /* 2231854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231857 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2231860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2231874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231893 */     // GIR_Coverage, 48172,
     /* 2231893 */     GIR_EraseRootFromParent_Done,
     /* 2231894 */   // Label 29557: @2231894
     /* 2231894 */   GIM_Try, /*On fail goto*//*Label 29558*/ GIMT_Encode4(2231939), // Rule ID 48173 //
     /* 2231899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231902 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2231905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2231919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231938 */     // GIR_Coverage, 48173,
     /* 2231938 */     GIR_EraseRootFromParent_Done,
     /* 2231939 */   // Label 29558: @2231939
     /* 2231939 */   GIM_Reject,
     /* 2231940 */ // Label 29556: @2231940
     /* 2231940 */ GIM_Reject,
     /* 2231941 */ // Label 29525: @2231941
     /* 2231941 */ GIM_Try, /*On fail goto*//*Label 29559*/ GIMT_Encode4(2232055),
     /* 2231946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2231949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2231952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231964 */   GIM_Try, /*On fail goto*//*Label 29560*/ GIMT_Encode4(2232009), // Rule ID 48184 //
     /* 2231969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231972 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2231975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2231989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232008 */     // GIR_Coverage, 48184,
     /* 2232008 */     GIR_EraseRootFromParent_Done,
     /* 2232009 */   // Label 29560: @2232009
     /* 2232009 */   GIM_Try, /*On fail goto*//*Label 29561*/ GIMT_Encode4(2232054), // Rule ID 48185 //
     /* 2232014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232017 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2232020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2232034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232053 */     // GIR_Coverage, 48185,
     /* 2232053 */     GIR_EraseRootFromParent_Done,
     /* 2232054 */   // Label 29561: @2232054
     /* 2232054 */   GIM_Reject,
     /* 2232055 */ // Label 29559: @2232055
     /* 2232055 */ GIM_Reject,
     /* 2232056 */ // Label 29526: @2232056
     /* 2232056 */ GIM_Try, /*On fail goto*//*Label 29562*/ GIMT_Encode4(2232170),
     /* 2232061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2232064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2232067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232079 */   GIM_Try, /*On fail goto*//*Label 29563*/ GIMT_Encode4(2232124), // Rule ID 48192 //
     /* 2232084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232087 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2232090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2232104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232123 */     // GIR_Coverage, 48192,
     /* 2232123 */     GIR_EraseRootFromParent_Done,
     /* 2232124 */   // Label 29563: @2232124
     /* 2232124 */   GIM_Try, /*On fail goto*//*Label 29564*/ GIMT_Encode4(2232169), // Rule ID 48193 //
     /* 2232129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232132 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2232135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2232149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232168 */     // GIR_Coverage, 48193,
     /* 2232168 */     GIR_EraseRootFromParent_Done,
     /* 2232169 */   // Label 29564: @2232169
     /* 2232169 */   GIM_Reject,
     /* 2232170 */ // Label 29562: @2232170
     /* 2232170 */ GIM_Reject,
     /* 2232171 */ // Label 29527: @2232171
     /* 2232171 */ GIM_Try, /*On fail goto*//*Label 29565*/ GIMT_Encode4(2232285),
     /* 2232176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2232179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2232182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232194 */   GIM_Try, /*On fail goto*//*Label 29566*/ GIMT_Encode4(2232239), // Rule ID 48208 //
     /* 2232199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2232202 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2232205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2232219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232238 */     // GIR_Coverage, 48208,
     /* 2232238 */     GIR_EraseRootFromParent_Done,
     /* 2232239 */   // Label 29566: @2232239
     /* 2232239 */   GIM_Try, /*On fail goto*//*Label 29567*/ GIMT_Encode4(2232284), // Rule ID 48209 //
     /* 2232244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2232247 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2232250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2232264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232283 */     // GIR_Coverage, 48209,
     /* 2232283 */     GIR_EraseRootFromParent_Done,
     /* 2232284 */   // Label 29567: @2232284
     /* 2232284 */   GIM_Reject,
     /* 2232285 */ // Label 29565: @2232285
     /* 2232285 */ GIM_Reject,
     /* 2232286 */ // Label 29528: @2232286
     /* 2232286 */ GIM_Try, /*On fail goto*//*Label 29568*/ GIMT_Encode4(2232400),
     /* 2232291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2232294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2232297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232309 */   GIM_Try, /*On fail goto*//*Label 29569*/ GIMT_Encode4(2232354), // Rule ID 48176 //
     /* 2232314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232317 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2232320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2232334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232353 */     // GIR_Coverage, 48176,
     /* 2232353 */     GIR_EraseRootFromParent_Done,
     /* 2232354 */   // Label 29569: @2232354
     /* 2232354 */   GIM_Try, /*On fail goto*//*Label 29570*/ GIMT_Encode4(2232399), // Rule ID 48177 //
     /* 2232359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232362 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2232365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2232379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232398 */     // GIR_Coverage, 48177,
     /* 2232398 */     GIR_EraseRootFromParent_Done,
     /* 2232399 */   // Label 29570: @2232399
     /* 2232399 */   GIM_Reject,
     /* 2232400 */ // Label 29568: @2232400
     /* 2232400 */ GIM_Reject,
     /* 2232401 */ // Label 29529: @2232401
     /* 2232401 */ GIM_Try, /*On fail goto*//*Label 29571*/ GIMT_Encode4(2232515),
     /* 2232406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2232409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2232412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232424 */   GIM_Try, /*On fail goto*//*Label 29572*/ GIMT_Encode4(2232469), // Rule ID 48188 //
     /* 2232429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232432 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2232435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2232449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232468 */     // GIR_Coverage, 48188,
     /* 2232468 */     GIR_EraseRootFromParent_Done,
     /* 2232469 */   // Label 29572: @2232469
     /* 2232469 */   GIM_Try, /*On fail goto*//*Label 29573*/ GIMT_Encode4(2232514), // Rule ID 48189 //
     /* 2232474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232477 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2232480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2232494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232513 */     // GIR_Coverage, 48189,
     /* 2232513 */     GIR_EraseRootFromParent_Done,
     /* 2232514 */   // Label 29573: @2232514
     /* 2232514 */   GIM_Reject,
     /* 2232515 */ // Label 29571: @2232515
     /* 2232515 */ GIM_Reject,
     /* 2232516 */ // Label 29530: @2232516
     /* 2232516 */ GIM_Try, /*On fail goto*//*Label 29574*/ GIMT_Encode4(2232630),
     /* 2232521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2232524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2232527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232539 */   GIM_Try, /*On fail goto*//*Label 29575*/ GIMT_Encode4(2232584), // Rule ID 48204 //
     /* 2232544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232547 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2232550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2232564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232583 */     // GIR_Coverage, 48204,
     /* 2232583 */     GIR_EraseRootFromParent_Done,
     /* 2232584 */   // Label 29575: @2232584
     /* 2232584 */   GIM_Try, /*On fail goto*//*Label 29576*/ GIMT_Encode4(2232629), // Rule ID 48205 //
     /* 2232589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232592 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2232595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2232609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232628 */     // GIR_Coverage, 48205,
     /* 2232628 */     GIR_EraseRootFromParent_Done,
     /* 2232629 */   // Label 29576: @2232629
     /* 2232629 */   GIM_Reject,
     /* 2232630 */ // Label 29574: @2232630
     /* 2232630 */ GIM_Reject,
     /* 2232631 */ // Label 29531: @2232631
     /* 2232631 */ GIM_Try, /*On fail goto*//*Label 29577*/ GIMT_Encode4(2232745),
     /* 2232636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2232639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2232642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232650 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232654 */   GIM_Try, /*On fail goto*//*Label 29578*/ GIMT_Encode4(2232699), // Rule ID 48248 //
     /* 2232659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2232662 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2232665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2232679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232698 */     // GIR_Coverage, 48248,
     /* 2232698 */     GIR_EraseRootFromParent_Done,
     /* 2232699 */   // Label 29578: @2232699
     /* 2232699 */   GIM_Try, /*On fail goto*//*Label 29579*/ GIMT_Encode4(2232744), // Rule ID 48249 //
     /* 2232704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2232707 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2232710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2232724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232743 */     // GIR_Coverage, 48249,
     /* 2232743 */     GIR_EraseRootFromParent_Done,
     /* 2232744 */   // Label 29579: @2232744
     /* 2232744 */   GIM_Reject,
     /* 2232745 */ // Label 29577: @2232745
     /* 2232745 */ GIM_Reject,
     /* 2232746 */ // Label 29532: @2232746
     /* 2232746 */ GIM_Try, /*On fail goto*//*Label 29580*/ GIMT_Encode4(2232860),
     /* 2232751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2232754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2232757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232769 */   GIM_Try, /*On fail goto*//*Label 29581*/ GIMT_Encode4(2232814), // Rule ID 48180 //
     /* 2232774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232777 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2232780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2232794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232813 */     // GIR_Coverage, 48180,
     /* 2232813 */     GIR_EraseRootFromParent_Done,
     /* 2232814 */   // Label 29581: @2232814
     /* 2232814 */   GIM_Try, /*On fail goto*//*Label 29582*/ GIMT_Encode4(2232859), // Rule ID 48181 //
     /* 2232819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232822 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2232825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2232839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232858 */     // GIR_Coverage, 48181,
     /* 2232858 */     GIR_EraseRootFromParent_Done,
     /* 2232859 */   // Label 29582: @2232859
     /* 2232859 */   GIM_Reject,
     /* 2232860 */ // Label 29580: @2232860
     /* 2232860 */ GIM_Reject,
     /* 2232861 */ // Label 29533: @2232861
     /* 2232861 */ GIM_Try, /*On fail goto*//*Label 29583*/ GIMT_Encode4(2232975),
     /* 2232866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2232869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2232872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232884 */   GIM_Try, /*On fail goto*//*Label 29584*/ GIMT_Encode4(2232929), // Rule ID 48200 //
     /* 2232889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232892 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2232895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2232909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232928 */     // GIR_Coverage, 48200,
     /* 2232928 */     GIR_EraseRootFromParent_Done,
     /* 2232929 */   // Label 29584: @2232929
     /* 2232929 */   GIM_Try, /*On fail goto*//*Label 29585*/ GIMT_Encode4(2232974), // Rule ID 48201 //
     /* 2232934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232937 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2232940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2232954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232973 */     // GIR_Coverage, 48201,
     /* 2232973 */     GIR_EraseRootFromParent_Done,
     /* 2232974 */   // Label 29585: @2232974
     /* 2232974 */   GIM_Reject,
     /* 2232975 */ // Label 29583: @2232975
     /* 2232975 */ GIM_Reject,
     /* 2232976 */ // Label 29534: @2232976
     /* 2232976 */ GIM_Try, /*On fail goto*//*Label 29586*/ GIMT_Encode4(2233090),
     /* 2232981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2232984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2232987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232999 */   GIM_Try, /*On fail goto*//*Label 29587*/ GIMT_Encode4(2233044), // Rule ID 48236 //
     /* 2233004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233007 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2233010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2233024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233043 */     // GIR_Coverage, 48236,
     /* 2233043 */     GIR_EraseRootFromParent_Done,
     /* 2233044 */   // Label 29587: @2233044
     /* 2233044 */   GIM_Try, /*On fail goto*//*Label 29588*/ GIMT_Encode4(2233089), // Rule ID 48237 //
     /* 2233049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233052 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2233055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2233069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233088 */     // GIR_Coverage, 48237,
     /* 2233088 */     GIR_EraseRootFromParent_Done,
     /* 2233089 */   // Label 29588: @2233089
     /* 2233089 */   GIM_Reject,
     /* 2233090 */ // Label 29586: @2233090
     /* 2233090 */ GIM_Reject,
     /* 2233091 */ // Label 29535: @2233091
     /* 2233091 */ GIM_Try, /*On fail goto*//*Label 29589*/ GIMT_Encode4(2233205),
     /* 2233096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2233099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2233102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233114 */   GIM_Try, /*On fail goto*//*Label 29590*/ GIMT_Encode4(2233159), // Rule ID 48252 //
     /* 2233119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2233122 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2233125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2233139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233158 */     // GIR_Coverage, 48252,
     /* 2233158 */     GIR_EraseRootFromParent_Done,
     /* 2233159 */   // Label 29590: @2233159
     /* 2233159 */   GIM_Try, /*On fail goto*//*Label 29591*/ GIMT_Encode4(2233204), // Rule ID 48253 //
     /* 2233164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2233167 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2233170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2233184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233203 */     // GIR_Coverage, 48253,
     /* 2233203 */     GIR_EraseRootFromParent_Done,
     /* 2233204 */   // Label 29591: @2233204
     /* 2233204 */   GIM_Reject,
     /* 2233205 */ // Label 29589: @2233205
     /* 2233205 */ GIM_Reject,
     /* 2233206 */ // Label 29536: @2233206
     /* 2233206 */ GIM_Try, /*On fail goto*//*Label 29592*/ GIMT_Encode4(2233320),
     /* 2233211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2233214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2233217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233229 */   GIM_Try, /*On fail goto*//*Label 29593*/ GIMT_Encode4(2233274), // Rule ID 48196 //
     /* 2233234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233237 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2233240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2233254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233273 */     // GIR_Coverage, 48196,
     /* 2233273 */     GIR_EraseRootFromParent_Done,
     /* 2233274 */   // Label 29593: @2233274
     /* 2233274 */   GIM_Try, /*On fail goto*//*Label 29594*/ GIMT_Encode4(2233319), // Rule ID 48197 //
     /* 2233279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233282 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2233285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2233299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233318 */     // GIR_Coverage, 48197,
     /* 2233318 */     GIR_EraseRootFromParent_Done,
     /* 2233319 */   // Label 29594: @2233319
     /* 2233319 */   GIM_Reject,
     /* 2233320 */ // Label 29592: @2233320
     /* 2233320 */ GIM_Reject,
     /* 2233321 */ // Label 29537: @2233321
     /* 2233321 */ GIM_Try, /*On fail goto*//*Label 29595*/ GIMT_Encode4(2233435),
     /* 2233326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2233329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2233332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233344 */   GIM_Try, /*On fail goto*//*Label 29596*/ GIMT_Encode4(2233389), // Rule ID 48224 //
     /* 2233349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233352 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2233355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2233369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233388 */     // GIR_Coverage, 48224,
     /* 2233388 */     GIR_EraseRootFromParent_Done,
     /* 2233389 */   // Label 29596: @2233389
     /* 2233389 */   GIM_Try, /*On fail goto*//*Label 29597*/ GIMT_Encode4(2233434), // Rule ID 48225 //
     /* 2233394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233397 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2233400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2233414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233433 */     // GIR_Coverage, 48225,
     /* 2233433 */     GIR_EraseRootFromParent_Done,
     /* 2233434 */   // Label 29597: @2233434
     /* 2233434 */   GIM_Reject,
     /* 2233435 */ // Label 29595: @2233435
     /* 2233435 */ GIM_Reject,
     /* 2233436 */ // Label 29538: @2233436
     /* 2233436 */ GIM_Try, /*On fail goto*//*Label 29598*/ GIMT_Encode4(2233550),
     /* 2233441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2233444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2233447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233459 */   GIM_Try, /*On fail goto*//*Label 29599*/ GIMT_Encode4(2233504), // Rule ID 48240 //
     /* 2233464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233467 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2233470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2233484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233503 */     // GIR_Coverage, 48240,
     /* 2233503 */     GIR_EraseRootFromParent_Done,
     /* 2233504 */   // Label 29599: @2233504
     /* 2233504 */   GIM_Try, /*On fail goto*//*Label 29600*/ GIMT_Encode4(2233549), // Rule ID 48241 //
     /* 2233509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233512 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2233515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2233529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233548 */     // GIR_Coverage, 48241,
     /* 2233548 */     GIR_EraseRootFromParent_Done,
     /* 2233549 */   // Label 29600: @2233549
     /* 2233549 */   GIM_Reject,
     /* 2233550 */ // Label 29598: @2233550
     /* 2233550 */ GIM_Reject,
     /* 2233551 */ // Label 29539: @2233551
     /* 2233551 */ GIM_Try, /*On fail goto*//*Label 29601*/ GIMT_Encode4(2233665),
     /* 2233556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2233559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2233562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233574 */   GIM_Try, /*On fail goto*//*Label 29602*/ GIMT_Encode4(2233619), // Rule ID 48256 //
     /* 2233579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2233582 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2233585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2233599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233618 */     // GIR_Coverage, 48256,
     /* 2233618 */     GIR_EraseRootFromParent_Done,
     /* 2233619 */   // Label 29602: @2233619
     /* 2233619 */   GIM_Try, /*On fail goto*//*Label 29603*/ GIMT_Encode4(2233664), // Rule ID 48257 //
     /* 2233624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2233627 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2233630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2233644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233663 */     // GIR_Coverage, 48257,
     /* 2233663 */     GIR_EraseRootFromParent_Done,
     /* 2233664 */   // Label 29603: @2233664
     /* 2233664 */   GIM_Reject,
     /* 2233665 */ // Label 29601: @2233665
     /* 2233665 */ GIM_Reject,
     /* 2233666 */ // Label 29540: @2233666
     /* 2233666 */ GIM_Try, /*On fail goto*//*Label 29604*/ GIMT_Encode4(2233780),
     /* 2233671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2233674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2233677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233685 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233689 */   GIM_Try, /*On fail goto*//*Label 29605*/ GIMT_Encode4(2233734), // Rule ID 48212 //
     /* 2233694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233697 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2233700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2233714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233733 */     // GIR_Coverage, 48212,
     /* 2233733 */     GIR_EraseRootFromParent_Done,
     /* 2233734 */   // Label 29605: @2233734
     /* 2233734 */   GIM_Try, /*On fail goto*//*Label 29606*/ GIMT_Encode4(2233779), // Rule ID 48213 //
     /* 2233739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233742 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2233745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2233759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233778 */     // GIR_Coverage, 48213,
     /* 2233778 */     GIR_EraseRootFromParent_Done,
     /* 2233779 */   // Label 29606: @2233779
     /* 2233779 */   GIM_Reject,
     /* 2233780 */ // Label 29604: @2233780
     /* 2233780 */ GIM_Reject,
     /* 2233781 */ // Label 29541: @2233781
     /* 2233781 */ GIM_Try, /*On fail goto*//*Label 29607*/ GIMT_Encode4(2233895),
     /* 2233786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2233789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2233792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233804 */   GIM_Try, /*On fail goto*//*Label 29608*/ GIMT_Encode4(2233849), // Rule ID 48228 //
     /* 2233809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233812 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2233815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2233829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233848 */     // GIR_Coverage, 48228,
     /* 2233848 */     GIR_EraseRootFromParent_Done,
     /* 2233849 */   // Label 29608: @2233849
     /* 2233849 */   GIM_Try, /*On fail goto*//*Label 29609*/ GIMT_Encode4(2233894), // Rule ID 48229 //
     /* 2233854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233857 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2233860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2233874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233893 */     // GIR_Coverage, 48229,
     /* 2233893 */     GIR_EraseRootFromParent_Done,
     /* 2233894 */   // Label 29609: @2233894
     /* 2233894 */   GIM_Reject,
     /* 2233895 */ // Label 29607: @2233895
     /* 2233895 */ GIM_Reject,
     /* 2233896 */ // Label 29542: @2233896
     /* 2233896 */ GIM_Try, /*On fail goto*//*Label 29610*/ GIMT_Encode4(2234010),
     /* 2233901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2233904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2233907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233915 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233919 */   GIM_Try, /*On fail goto*//*Label 29611*/ GIMT_Encode4(2233964), // Rule ID 48244 //
     /* 2233924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233927 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2233930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2233944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233963 */     // GIR_Coverage, 48244,
     /* 2233963 */     GIR_EraseRootFromParent_Done,
     /* 2233964 */   // Label 29611: @2233964
     /* 2233964 */   GIM_Try, /*On fail goto*//*Label 29612*/ GIMT_Encode4(2234009), // Rule ID 48245 //
     /* 2233969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233972 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2233975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2233989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234008 */     // GIR_Coverage, 48245,
     /* 2234008 */     GIR_EraseRootFromParent_Done,
     /* 2234009 */   // Label 29612: @2234009
     /* 2234009 */   GIM_Reject,
     /* 2234010 */ // Label 29610: @2234010
     /* 2234010 */ GIM_Reject,
     /* 2234011 */ // Label 29543: @2234011
     /* 2234011 */ GIM_Try, /*On fail goto*//*Label 29613*/ GIMT_Encode4(2234125),
     /* 2234016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2234019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2234022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2234026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2234030 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2234034 */   GIM_Try, /*On fail goto*//*Label 29614*/ GIMT_Encode4(2234079), // Rule ID 48216 //
     /* 2234039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234042 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2234045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2234059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234078 */     // GIR_Coverage, 48216,
     /* 2234078 */     GIR_EraseRootFromParent_Done,
     /* 2234079 */   // Label 29614: @2234079
     /* 2234079 */   GIM_Try, /*On fail goto*//*Label 29615*/ GIMT_Encode4(2234124), // Rule ID 48217 //
     /* 2234084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234087 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2234090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2234104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234123 */     // GIR_Coverage, 48217,
     /* 2234123 */     GIR_EraseRootFromParent_Done,
     /* 2234124 */   // Label 29615: @2234124
     /* 2234124 */   GIM_Reject,
     /* 2234125 */ // Label 29613: @2234125
     /* 2234125 */ GIM_Reject,
     /* 2234126 */ // Label 29544: @2234126
     /* 2234126 */ GIM_Try, /*On fail goto*//*Label 29616*/ GIMT_Encode4(2234240),
     /* 2234131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2234134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2234137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2234141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2234145 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2234149 */   GIM_Try, /*On fail goto*//*Label 29617*/ GIMT_Encode4(2234194), // Rule ID 48232 //
     /* 2234154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234157 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2234160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2234174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234193 */     // GIR_Coverage, 48232,
     /* 2234193 */     GIR_EraseRootFromParent_Done,
     /* 2234194 */   // Label 29617: @2234194
     /* 2234194 */   GIM_Try, /*On fail goto*//*Label 29618*/ GIMT_Encode4(2234239), // Rule ID 48233 //
     /* 2234199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234202 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2234205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2234219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234238 */     // GIR_Coverage, 48233,
     /* 2234238 */     GIR_EraseRootFromParent_Done,
     /* 2234239 */   // Label 29618: @2234239
     /* 2234239 */   GIM_Reject,
     /* 2234240 */ // Label 29616: @2234240
     /* 2234240 */ GIM_Reject,
     /* 2234241 */ // Label 29545: @2234241
     /* 2234241 */ GIM_Try, /*On fail goto*//*Label 29619*/ GIMT_Encode4(2234355),
     /* 2234246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2234249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2234252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2234256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2234260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2234264 */   GIM_Try, /*On fail goto*//*Label 29620*/ GIMT_Encode4(2234309), // Rule ID 48220 //
     /* 2234269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234272 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2234275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2234289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234308 */     // GIR_Coverage, 48220,
     /* 2234308 */     GIR_EraseRootFromParent_Done,
     /* 2234309 */   // Label 29620: @2234309
     /* 2234309 */   GIM_Try, /*On fail goto*//*Label 29621*/ GIMT_Encode4(2234354), // Rule ID 48221 //
     /* 2234314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234317 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2234320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2234334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234353 */     // GIR_Coverage, 48221,
     /* 2234353 */     GIR_EraseRootFromParent_Done,
     /* 2234354 */   // Label 29621: @2234354
     /* 2234354 */   GIM_Reject,
     /* 2234355 */ // Label 29619: @2234355
     /* 2234355 */ GIM_Reject,
     /* 2234356 */ // Label 29546: @2234356
     /* 2234356 */ GIM_Reject,
     /* 2234357 */ // Label 45: @2234357
     /* 2234357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29646*/ GIMT_Encode4(2237295),
     /* 2234368 */ /*GILLT_s32*//*Label 29622*/ GIMT_Encode4(2234492),
     /* 2234372 */ /*GILLT_s64*//*Label 29623*/ GIMT_Encode4(2234576), GIMT_Encode4(0),
     /* 2234380 */ /*GILLT_nxv1s8*//*Label 29624*/ GIMT_Encode4(2234765),
     /* 2234384 */ /*GILLT_nxv1s16*//*Label 29625*/ GIMT_Encode4(2234880),
     /* 2234388 */ /*GILLT_nxv1s32*//*Label 29626*/ GIMT_Encode4(2234995),
     /* 2234392 */ /*GILLT_nxv1s64*//*Label 29627*/ GIMT_Encode4(2235110), GIMT_Encode4(0),
     /* 2234400 */ /*GILLT_nxv2s8*//*Label 29628*/ GIMT_Encode4(2235225),
     /* 2234404 */ /*GILLT_nxv2s16*//*Label 29629*/ GIMT_Encode4(2235340),
     /* 2234408 */ /*GILLT_nxv2s32*//*Label 29630*/ GIMT_Encode4(2235455),
     /* 2234412 */ /*GILLT_nxv2s64*//*Label 29631*/ GIMT_Encode4(2235570), GIMT_Encode4(0),
     /* 2234420 */ /*GILLT_nxv4s8*//*Label 29632*/ GIMT_Encode4(2235685),
     /* 2234424 */ /*GILLT_nxv4s16*//*Label 29633*/ GIMT_Encode4(2235800),
     /* 2234428 */ /*GILLT_nxv4s32*//*Label 29634*/ GIMT_Encode4(2235915),
     /* 2234432 */ /*GILLT_nxv4s64*//*Label 29635*/ GIMT_Encode4(2236030), GIMT_Encode4(0),
     /* 2234440 */ /*GILLT_nxv8s8*//*Label 29636*/ GIMT_Encode4(2236145),
     /* 2234444 */ /*GILLT_nxv8s16*//*Label 29637*/ GIMT_Encode4(2236260),
     /* 2234448 */ /*GILLT_nxv8s32*//*Label 29638*/ GIMT_Encode4(2236375),
     /* 2234452 */ /*GILLT_nxv8s64*//*Label 29639*/ GIMT_Encode4(2236490), GIMT_Encode4(0),
     /* 2234460 */ /*GILLT_nxv16s8*//*Label 29640*/ GIMT_Encode4(2236605),
     /* 2234464 */ /*GILLT_nxv16s16*//*Label 29641*/ GIMT_Encode4(2236720),
     /* 2234468 */ /*GILLT_nxv16s32*//*Label 29642*/ GIMT_Encode4(2236835), GIMT_Encode4(0),
     /* 2234476 */ /*GILLT_nxv32s8*//*Label 29643*/ GIMT_Encode4(2236950),
     /* 2234480 */ /*GILLT_nxv32s16*//*Label 29644*/ GIMT_Encode4(2237065), GIMT_Encode4(0),
     /* 2234488 */ /*GILLT_nxv64s8*//*Label 29645*/ GIMT_Encode4(2237180),
     /* 2234492 */ // Label 29622: @2234492
     /* 2234492 */ GIM_Try, /*On fail goto*//*Label 29647*/ GIMT_Encode4(2234575),
     /* 2234497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2234500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2234503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234511 */   GIM_Try, /*On fail goto*//*Label 29648*/ GIMT_Encode4(2234545), // Rule ID 95 //
     /* 2234516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2234519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2234523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2234531 */     // MIs[1] Operand 1
     /* 2234531 */     // No operand predicates
     /* 2234531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234533 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2234533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2234536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2234543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234544 */     // GIR_Coverage, 95,
     /* 2234544 */     GIR_EraseRootFromParent_Done,
     /* 2234545 */   // Label 29648: @2234545
     /* 2234545 */   GIM_Try, /*On fail goto*//*Label 29649*/ GIMT_Encode4(2234574), // Rule ID 109 //
     /* 2234550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2234553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2234560 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRA:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2234560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2234563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2234572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234573 */     // GIR_Coverage, 109,
     /* 2234573 */     GIR_EraseRootFromParent_Done,
     /* 2234574 */   // Label 29649: @2234574
     /* 2234574 */   GIM_Reject,
     /* 2234575 */ // Label 29647: @2234575
     /* 2234575 */ GIM_Reject,
     /* 2234576 */ // Label 29623: @2234576
     /* 2234576 */ GIM_Try, /*On fail goto*//*Label 29650*/ GIMT_Encode4(2234764),
     /* 2234581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2234584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234591 */   GIM_Try, /*On fail goto*//*Label 29651*/ GIMT_Encode4(2234628), // Rule ID 62561 //
     /* 2234596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2234599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2234603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2234607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2234611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2234615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234617 */     // (sra:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2234617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2234620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2234626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234627 */     // GIR_Coverage, 62561,
     /* 2234627 */     GIR_EraseRootFromParent_Done,
     /* 2234628 */   // Label 29651: @2234628
     /* 2234628 */   GIM_Try, /*On fail goto*//*Label 29652*/ GIMT_Encode4(2234692), // Rule ID 259 //
     /* 2234633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2234636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2234640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2234644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2234648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234653 */     // MIs[1] Operand 2
     /* 2234653 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2234664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2234668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234672 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2234676 */     // MIs[2] Operand 1
     /* 2234676 */     // No operand predicates
     /* 2234676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2234678 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2234678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2234681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2234687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2234690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234691 */     // GIR_Coverage, 259,
     /* 2234691 */     GIR_EraseRootFromParent_Done,
     /* 2234692 */   // Label 29652: @2234692
     /* 2234692 */   GIM_Try, /*On fail goto*//*Label 29653*/ GIMT_Encode4(2234730), // Rule ID 94 //
     /* 2234697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2234708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2234716 */     // MIs[1] Operand 1
     /* 2234716 */     // No operand predicates
     /* 2234716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234718 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2234718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2234721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2234728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234729 */     // GIR_Coverage, 94,
     /* 2234729 */     GIR_EraseRootFromParent_Done,
     /* 2234730 */   // Label 29653: @2234730
     /* 2234730 */   GIM_Try, /*On fail goto*//*Label 29654*/ GIMT_Encode4(2234763), // Rule ID 108 //
     /* 2234735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2234749 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRA:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2234749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2234752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2234761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234762 */     // GIR_Coverage, 108,
     /* 2234762 */     GIR_EraseRootFromParent_Done,
     /* 2234763 */   // Label 29654: @2234763
     /* 2234763 */   GIM_Reject,
     /* 2234764 */ // Label 29650: @2234764
     /* 2234764 */ GIM_Reject,
     /* 2234765 */ // Label 29624: @2234765
     /* 2234765 */ GIM_Try, /*On fail goto*//*Label 29655*/ GIMT_Encode4(2234879),
     /* 2234770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2234773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2234776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234788 */   GIM_Try, /*On fail goto*//*Label 29656*/ GIMT_Encode4(2234833), // Rule ID 48304 //
     /* 2234793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234796 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2234799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2234813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234832 */     // GIR_Coverage, 48304,
     /* 2234832 */     GIR_EraseRootFromParent_Done,
     /* 2234833 */   // Label 29656: @2234833
     /* 2234833 */   GIM_Try, /*On fail goto*//*Label 29657*/ GIMT_Encode4(2234878), // Rule ID 48305 //
     /* 2234838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234841 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2234844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2234858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234877 */     // GIR_Coverage, 48305,
     /* 2234877 */     GIR_EraseRootFromParent_Done,
     /* 2234878 */   // Label 29657: @2234878
     /* 2234878 */   GIM_Reject,
     /* 2234879 */ // Label 29655: @2234879
     /* 2234879 */ GIM_Reject,
     /* 2234880 */ // Label 29625: @2234880
     /* 2234880 */ GIM_Try, /*On fail goto*//*Label 29658*/ GIMT_Encode4(2234994),
     /* 2234885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2234888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2234891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234903 */   GIM_Try, /*On fail goto*//*Label 29659*/ GIMT_Encode4(2234948), // Rule ID 48316 //
     /* 2234908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234911 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2234914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2234928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234947 */     // GIR_Coverage, 48316,
     /* 2234947 */     GIR_EraseRootFromParent_Done,
     /* 2234948 */   // Label 29659: @2234948
     /* 2234948 */   GIM_Try, /*On fail goto*//*Label 29660*/ GIMT_Encode4(2234993), // Rule ID 48317 //
     /* 2234953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234956 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2234959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2234973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234992 */     // GIR_Coverage, 48317,
     /* 2234992 */     GIR_EraseRootFromParent_Done,
     /* 2234993 */   // Label 29660: @2234993
     /* 2234993 */   GIM_Reject,
     /* 2234994 */ // Label 29658: @2234994
     /* 2234994 */ GIM_Reject,
     /* 2234995 */ // Label 29626: @2234995
     /* 2234995 */ GIM_Try, /*On fail goto*//*Label 29661*/ GIMT_Encode4(2235109),
     /* 2235000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2235003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2235006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235018 */   GIM_Try, /*On fail goto*//*Label 29662*/ GIMT_Encode4(2235063), // Rule ID 48324 //
     /* 2235023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235026 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2235029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2235043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235062 */     // GIR_Coverage, 48324,
     /* 2235062 */     GIR_EraseRootFromParent_Done,
     /* 2235063 */   // Label 29662: @2235063
     /* 2235063 */   GIM_Try, /*On fail goto*//*Label 29663*/ GIMT_Encode4(2235108), // Rule ID 48325 //
     /* 2235068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235071 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2235074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2235088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235107 */     // GIR_Coverage, 48325,
     /* 2235107 */     GIR_EraseRootFromParent_Done,
     /* 2235108 */   // Label 29663: @2235108
     /* 2235108 */   GIM_Reject,
     /* 2235109 */ // Label 29661: @2235109
     /* 2235109 */ GIM_Reject,
     /* 2235110 */ // Label 29627: @2235110
     /* 2235110 */ GIM_Try, /*On fail goto*//*Label 29664*/ GIMT_Encode4(2235224),
     /* 2235115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2235118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2235121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235133 */   GIM_Try, /*On fail goto*//*Label 29665*/ GIMT_Encode4(2235178), // Rule ID 48340 //
     /* 2235138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235141 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2235144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2235158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235177 */     // GIR_Coverage, 48340,
     /* 2235177 */     GIR_EraseRootFromParent_Done,
     /* 2235178 */   // Label 29665: @2235178
     /* 2235178 */   GIM_Try, /*On fail goto*//*Label 29666*/ GIMT_Encode4(2235223), // Rule ID 48341 //
     /* 2235183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2235186 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2235189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2235203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235222 */     // GIR_Coverage, 48341,
     /* 2235222 */     GIR_EraseRootFromParent_Done,
     /* 2235223 */   // Label 29666: @2235223
     /* 2235223 */   GIM_Reject,
     /* 2235224 */ // Label 29664: @2235224
     /* 2235224 */ GIM_Reject,
     /* 2235225 */ // Label 29628: @2235225
     /* 2235225 */ GIM_Try, /*On fail goto*//*Label 29667*/ GIMT_Encode4(2235339),
     /* 2235230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2235233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2235236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235244 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235248 */   GIM_Try, /*On fail goto*//*Label 29668*/ GIMT_Encode4(2235293), // Rule ID 48308 //
     /* 2235253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235256 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2235259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2235273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235292 */     // GIR_Coverage, 48308,
     /* 2235292 */     GIR_EraseRootFromParent_Done,
     /* 2235293 */   // Label 29668: @2235293
     /* 2235293 */   GIM_Try, /*On fail goto*//*Label 29669*/ GIMT_Encode4(2235338), // Rule ID 48309 //
     /* 2235298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235301 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2235304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2235318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235337 */     // GIR_Coverage, 48309,
     /* 2235337 */     GIR_EraseRootFromParent_Done,
     /* 2235338 */   // Label 29669: @2235338
     /* 2235338 */   GIM_Reject,
     /* 2235339 */ // Label 29667: @2235339
     /* 2235339 */ GIM_Reject,
     /* 2235340 */ // Label 29629: @2235340
     /* 2235340 */ GIM_Try, /*On fail goto*//*Label 29670*/ GIMT_Encode4(2235454),
     /* 2235345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2235348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2235351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235363 */   GIM_Try, /*On fail goto*//*Label 29671*/ GIMT_Encode4(2235408), // Rule ID 48320 //
     /* 2235368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235371 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2235374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2235388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235407 */     // GIR_Coverage, 48320,
     /* 2235407 */     GIR_EraseRootFromParent_Done,
     /* 2235408 */   // Label 29671: @2235408
     /* 2235408 */   GIM_Try, /*On fail goto*//*Label 29672*/ GIMT_Encode4(2235453), // Rule ID 48321 //
     /* 2235413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235416 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2235419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2235433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235452 */     // GIR_Coverage, 48321,
     /* 2235452 */     GIR_EraseRootFromParent_Done,
     /* 2235453 */   // Label 29672: @2235453
     /* 2235453 */   GIM_Reject,
     /* 2235454 */ // Label 29670: @2235454
     /* 2235454 */ GIM_Reject,
     /* 2235455 */ // Label 29630: @2235455
     /* 2235455 */ GIM_Try, /*On fail goto*//*Label 29673*/ GIMT_Encode4(2235569),
     /* 2235460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2235463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2235466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235478 */   GIM_Try, /*On fail goto*//*Label 29674*/ GIMT_Encode4(2235523), // Rule ID 48336 //
     /* 2235483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235486 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2235489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2235503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235522 */     // GIR_Coverage, 48336,
     /* 2235522 */     GIR_EraseRootFromParent_Done,
     /* 2235523 */   // Label 29674: @2235523
     /* 2235523 */   GIM_Try, /*On fail goto*//*Label 29675*/ GIMT_Encode4(2235568), // Rule ID 48337 //
     /* 2235528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235531 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2235534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2235548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235567 */     // GIR_Coverage, 48337,
     /* 2235567 */     GIR_EraseRootFromParent_Done,
     /* 2235568 */   // Label 29675: @2235568
     /* 2235568 */   GIM_Reject,
     /* 2235569 */ // Label 29673: @2235569
     /* 2235569 */ GIM_Reject,
     /* 2235570 */ // Label 29631: @2235570
     /* 2235570 */ GIM_Try, /*On fail goto*//*Label 29676*/ GIMT_Encode4(2235684),
     /* 2235575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2235578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2235581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235593 */   GIM_Try, /*On fail goto*//*Label 29677*/ GIMT_Encode4(2235638), // Rule ID 48380 //
     /* 2235598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235601 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2235604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2235618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235637 */     // GIR_Coverage, 48380,
     /* 2235637 */     GIR_EraseRootFromParent_Done,
     /* 2235638 */   // Label 29677: @2235638
     /* 2235638 */   GIM_Try, /*On fail goto*//*Label 29678*/ GIMT_Encode4(2235683), // Rule ID 48381 //
     /* 2235643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2235646 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2235649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2235663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235682 */     // GIR_Coverage, 48381,
     /* 2235682 */     GIR_EraseRootFromParent_Done,
     /* 2235683 */   // Label 29678: @2235683
     /* 2235683 */   GIM_Reject,
     /* 2235684 */ // Label 29676: @2235684
     /* 2235684 */ GIM_Reject,
     /* 2235685 */ // Label 29632: @2235685
     /* 2235685 */ GIM_Try, /*On fail goto*//*Label 29679*/ GIMT_Encode4(2235799),
     /* 2235690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2235693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2235696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235708 */   GIM_Try, /*On fail goto*//*Label 29680*/ GIMT_Encode4(2235753), // Rule ID 48312 //
     /* 2235713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235716 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2235719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2235733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235752 */     // GIR_Coverage, 48312,
     /* 2235752 */     GIR_EraseRootFromParent_Done,
     /* 2235753 */   // Label 29680: @2235753
     /* 2235753 */   GIM_Try, /*On fail goto*//*Label 29681*/ GIMT_Encode4(2235798), // Rule ID 48313 //
     /* 2235758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235761 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2235764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2235778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235797 */     // GIR_Coverage, 48313,
     /* 2235797 */     GIR_EraseRootFromParent_Done,
     /* 2235798 */   // Label 29681: @2235798
     /* 2235798 */   GIM_Reject,
     /* 2235799 */ // Label 29679: @2235799
     /* 2235799 */ GIM_Reject,
     /* 2235800 */ // Label 29633: @2235800
     /* 2235800 */ GIM_Try, /*On fail goto*//*Label 29682*/ GIMT_Encode4(2235914),
     /* 2235805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2235808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2235811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235823 */   GIM_Try, /*On fail goto*//*Label 29683*/ GIMT_Encode4(2235868), // Rule ID 48332 //
     /* 2235828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235831 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2235834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2235848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235867 */     // GIR_Coverage, 48332,
     /* 2235867 */     GIR_EraseRootFromParent_Done,
     /* 2235868 */   // Label 29683: @2235868
     /* 2235868 */   GIM_Try, /*On fail goto*//*Label 29684*/ GIMT_Encode4(2235913), // Rule ID 48333 //
     /* 2235873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235876 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2235879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2235893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235912 */     // GIR_Coverage, 48333,
     /* 2235912 */     GIR_EraseRootFromParent_Done,
     /* 2235913 */   // Label 29684: @2235913
     /* 2235913 */   GIM_Reject,
     /* 2235914 */ // Label 29682: @2235914
     /* 2235914 */ GIM_Reject,
     /* 2235915 */ // Label 29634: @2235915
     /* 2235915 */ GIM_Try, /*On fail goto*//*Label 29685*/ GIMT_Encode4(2236029),
     /* 2235920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2235923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2235926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235934 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235938 */   GIM_Try, /*On fail goto*//*Label 29686*/ GIMT_Encode4(2235983), // Rule ID 48368 //
     /* 2235943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235946 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2235949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2235963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235982 */     // GIR_Coverage, 48368,
     /* 2235982 */     GIR_EraseRootFromParent_Done,
     /* 2235983 */   // Label 29686: @2235983
     /* 2235983 */   GIM_Try, /*On fail goto*//*Label 29687*/ GIMT_Encode4(2236028), // Rule ID 48369 //
     /* 2235988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235991 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2235994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2236008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236027 */     // GIR_Coverage, 48369,
     /* 2236027 */     GIR_EraseRootFromParent_Done,
     /* 2236028 */   // Label 29687: @2236028
     /* 2236028 */   GIM_Reject,
     /* 2236029 */ // Label 29685: @2236029
     /* 2236029 */ GIM_Reject,
     /* 2236030 */ // Label 29635: @2236030
     /* 2236030 */ GIM_Try, /*On fail goto*//*Label 29688*/ GIMT_Encode4(2236144),
     /* 2236035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2236038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2236041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236053 */   GIM_Try, /*On fail goto*//*Label 29689*/ GIMT_Encode4(2236098), // Rule ID 48384 //
     /* 2236058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2236061 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2236064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2236078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236097 */     // GIR_Coverage, 48384,
     /* 2236097 */     GIR_EraseRootFromParent_Done,
     /* 2236098 */   // Label 29689: @2236098
     /* 2236098 */   GIM_Try, /*On fail goto*//*Label 29690*/ GIMT_Encode4(2236143), // Rule ID 48385 //
     /* 2236103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2236106 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2236109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2236123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236142 */     // GIR_Coverage, 48385,
     /* 2236142 */     GIR_EraseRootFromParent_Done,
     /* 2236143 */   // Label 29690: @2236143
     /* 2236143 */   GIM_Reject,
     /* 2236144 */ // Label 29688: @2236144
     /* 2236144 */ GIM_Reject,
     /* 2236145 */ // Label 29636: @2236145
     /* 2236145 */ GIM_Try, /*On fail goto*//*Label 29691*/ GIMT_Encode4(2236259),
     /* 2236150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2236153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2236156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236164 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236168 */   GIM_Try, /*On fail goto*//*Label 29692*/ GIMT_Encode4(2236213), // Rule ID 48328 //
     /* 2236173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236176 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2236179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2236193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236212 */     // GIR_Coverage, 48328,
     /* 2236212 */     GIR_EraseRootFromParent_Done,
     /* 2236213 */   // Label 29692: @2236213
     /* 2236213 */   GIM_Try, /*On fail goto*//*Label 29693*/ GIMT_Encode4(2236258), // Rule ID 48329 //
     /* 2236218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236221 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2236224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2236238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236257 */     // GIR_Coverage, 48329,
     /* 2236257 */     GIR_EraseRootFromParent_Done,
     /* 2236258 */   // Label 29693: @2236258
     /* 2236258 */   GIM_Reject,
     /* 2236259 */ // Label 29691: @2236259
     /* 2236259 */ GIM_Reject,
     /* 2236260 */ // Label 29637: @2236260
     /* 2236260 */ GIM_Try, /*On fail goto*//*Label 29694*/ GIMT_Encode4(2236374),
     /* 2236265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2236268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2236271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236283 */   GIM_Try, /*On fail goto*//*Label 29695*/ GIMT_Encode4(2236328), // Rule ID 48356 //
     /* 2236288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236291 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2236294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2236308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236327 */     // GIR_Coverage, 48356,
     /* 2236327 */     GIR_EraseRootFromParent_Done,
     /* 2236328 */   // Label 29695: @2236328
     /* 2236328 */   GIM_Try, /*On fail goto*//*Label 29696*/ GIMT_Encode4(2236373), // Rule ID 48357 //
     /* 2236333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236336 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2236339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2236353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236372 */     // GIR_Coverage, 48357,
     /* 2236372 */     GIR_EraseRootFromParent_Done,
     /* 2236373 */   // Label 29696: @2236373
     /* 2236373 */   GIM_Reject,
     /* 2236374 */ // Label 29694: @2236374
     /* 2236374 */ GIM_Reject,
     /* 2236375 */ // Label 29638: @2236375
     /* 2236375 */ GIM_Try, /*On fail goto*//*Label 29697*/ GIMT_Encode4(2236489),
     /* 2236380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2236383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2236386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236394 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236398 */   GIM_Try, /*On fail goto*//*Label 29698*/ GIMT_Encode4(2236443), // Rule ID 48372 //
     /* 2236403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236406 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2236409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2236423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236442 */     // GIR_Coverage, 48372,
     /* 2236442 */     GIR_EraseRootFromParent_Done,
     /* 2236443 */   // Label 29698: @2236443
     /* 2236443 */   GIM_Try, /*On fail goto*//*Label 29699*/ GIMT_Encode4(2236488), // Rule ID 48373 //
     /* 2236448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236451 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2236454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2236468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236487 */     // GIR_Coverage, 48373,
     /* 2236487 */     GIR_EraseRootFromParent_Done,
     /* 2236488 */   // Label 29699: @2236488
     /* 2236488 */   GIM_Reject,
     /* 2236489 */ // Label 29697: @2236489
     /* 2236489 */ GIM_Reject,
     /* 2236490 */ // Label 29639: @2236490
     /* 2236490 */ GIM_Try, /*On fail goto*//*Label 29700*/ GIMT_Encode4(2236604),
     /* 2236495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2236498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2236501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236513 */   GIM_Try, /*On fail goto*//*Label 29701*/ GIMT_Encode4(2236558), // Rule ID 48388 //
     /* 2236518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2236521 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2236524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2236538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236557 */     // GIR_Coverage, 48388,
     /* 2236557 */     GIR_EraseRootFromParent_Done,
     /* 2236558 */   // Label 29701: @2236558
     /* 2236558 */   GIM_Try, /*On fail goto*//*Label 29702*/ GIMT_Encode4(2236603), // Rule ID 48389 //
     /* 2236563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2236566 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2236569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2236583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236602 */     // GIR_Coverage, 48389,
     /* 2236602 */     GIR_EraseRootFromParent_Done,
     /* 2236603 */   // Label 29702: @2236603
     /* 2236603 */   GIM_Reject,
     /* 2236604 */ // Label 29700: @2236604
     /* 2236604 */ GIM_Reject,
     /* 2236605 */ // Label 29640: @2236605
     /* 2236605 */ GIM_Try, /*On fail goto*//*Label 29703*/ GIMT_Encode4(2236719),
     /* 2236610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2236613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2236616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236628 */   GIM_Try, /*On fail goto*//*Label 29704*/ GIMT_Encode4(2236673), // Rule ID 48344 //
     /* 2236633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236636 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2236639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2236653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236672 */     // GIR_Coverage, 48344,
     /* 2236672 */     GIR_EraseRootFromParent_Done,
     /* 2236673 */   // Label 29704: @2236673
     /* 2236673 */   GIM_Try, /*On fail goto*//*Label 29705*/ GIMT_Encode4(2236718), // Rule ID 48345 //
     /* 2236678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236681 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2236684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2236698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236717 */     // GIR_Coverage, 48345,
     /* 2236717 */     GIR_EraseRootFromParent_Done,
     /* 2236718 */   // Label 29705: @2236718
     /* 2236718 */   GIM_Reject,
     /* 2236719 */ // Label 29703: @2236719
     /* 2236719 */ GIM_Reject,
     /* 2236720 */ // Label 29641: @2236720
     /* 2236720 */ GIM_Try, /*On fail goto*//*Label 29706*/ GIMT_Encode4(2236834),
     /* 2236725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2236728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2236731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236739 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236743 */   GIM_Try, /*On fail goto*//*Label 29707*/ GIMT_Encode4(2236788), // Rule ID 48360 //
     /* 2236748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236751 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2236754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2236768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236787 */     // GIR_Coverage, 48360,
     /* 2236787 */     GIR_EraseRootFromParent_Done,
     /* 2236788 */   // Label 29707: @2236788
     /* 2236788 */   GIM_Try, /*On fail goto*//*Label 29708*/ GIMT_Encode4(2236833), // Rule ID 48361 //
     /* 2236793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236796 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2236799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2236813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236832 */     // GIR_Coverage, 48361,
     /* 2236832 */     GIR_EraseRootFromParent_Done,
     /* 2236833 */   // Label 29708: @2236833
     /* 2236833 */   GIM_Reject,
     /* 2236834 */ // Label 29706: @2236834
     /* 2236834 */ GIM_Reject,
     /* 2236835 */ // Label 29642: @2236835
     /* 2236835 */ GIM_Try, /*On fail goto*//*Label 29709*/ GIMT_Encode4(2236949),
     /* 2236840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2236843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2236846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236858 */   GIM_Try, /*On fail goto*//*Label 29710*/ GIMT_Encode4(2236903), // Rule ID 48376 //
     /* 2236863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236866 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2236869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2236883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236902 */     // GIR_Coverage, 48376,
     /* 2236902 */     GIR_EraseRootFromParent_Done,
     /* 2236903 */   // Label 29710: @2236903
     /* 2236903 */   GIM_Try, /*On fail goto*//*Label 29711*/ GIMT_Encode4(2236948), // Rule ID 48377 //
     /* 2236908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236911 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2236914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2236928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236947 */     // GIR_Coverage, 48377,
     /* 2236947 */     GIR_EraseRootFromParent_Done,
     /* 2236948 */   // Label 29711: @2236948
     /* 2236948 */   GIM_Reject,
     /* 2236949 */ // Label 29709: @2236949
     /* 2236949 */ GIM_Reject,
     /* 2236950 */ // Label 29643: @2236950
     /* 2236950 */ GIM_Try, /*On fail goto*//*Label 29712*/ GIMT_Encode4(2237064),
     /* 2236955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2236958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2236961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236973 */   GIM_Try, /*On fail goto*//*Label 29713*/ GIMT_Encode4(2237018), // Rule ID 48348 //
     /* 2236978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236981 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2236984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2236998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237017 */     // GIR_Coverage, 48348,
     /* 2237017 */     GIR_EraseRootFromParent_Done,
     /* 2237018 */   // Label 29713: @2237018
     /* 2237018 */   GIM_Try, /*On fail goto*//*Label 29714*/ GIMT_Encode4(2237063), // Rule ID 48349 //
     /* 2237023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237026 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2237029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2237043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237062 */     // GIR_Coverage, 48349,
     /* 2237062 */     GIR_EraseRootFromParent_Done,
     /* 2237063 */   // Label 29714: @2237063
     /* 2237063 */   GIM_Reject,
     /* 2237064 */ // Label 29712: @2237064
     /* 2237064 */ GIM_Reject,
     /* 2237065 */ // Label 29644: @2237065
     /* 2237065 */ GIM_Try, /*On fail goto*//*Label 29715*/ GIMT_Encode4(2237179),
     /* 2237070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2237073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2237076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2237080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2237084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2237088 */   GIM_Try, /*On fail goto*//*Label 29716*/ GIMT_Encode4(2237133), // Rule ID 48364 //
     /* 2237093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237096 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2237099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2237113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237132 */     // GIR_Coverage, 48364,
     /* 2237132 */     GIR_EraseRootFromParent_Done,
     /* 2237133 */   // Label 29716: @2237133
     /* 2237133 */   GIM_Try, /*On fail goto*//*Label 29717*/ GIMT_Encode4(2237178), // Rule ID 48365 //
     /* 2237138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237141 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2237144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2237158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237177 */     // GIR_Coverage, 48365,
     /* 2237177 */     GIR_EraseRootFromParent_Done,
     /* 2237178 */   // Label 29717: @2237178
     /* 2237178 */   GIM_Reject,
     /* 2237179 */ // Label 29715: @2237179
     /* 2237179 */ GIM_Reject,
     /* 2237180 */ // Label 29645: @2237180
     /* 2237180 */ GIM_Try, /*On fail goto*//*Label 29718*/ GIMT_Encode4(2237294),
     /* 2237185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2237188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2237191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2237195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2237199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2237203 */   GIM_Try, /*On fail goto*//*Label 29719*/ GIMT_Encode4(2237248), // Rule ID 48352 //
     /* 2237208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237211 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2237214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2237228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237247 */     // GIR_Coverage, 48352,
     /* 2237247 */     GIR_EraseRootFromParent_Done,
     /* 2237248 */   // Label 29719: @2237248
     /* 2237248 */   GIM_Try, /*On fail goto*//*Label 29720*/ GIMT_Encode4(2237293), // Rule ID 48353 //
     /* 2237253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237256 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2237259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2237273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237292 */     // GIR_Coverage, 48353,
     /* 2237292 */     GIR_EraseRootFromParent_Done,
     /* 2237293 */   // Label 29720: @2237293
     /* 2237293 */   GIM_Reject,
     /* 2237294 */ // Label 29718: @2237294
     /* 2237294 */ GIM_Reject,
     /* 2237295 */ // Label 29646: @2237295
     /* 2237295 */ GIM_Reject,
     /* 2237296 */ // Label 46: @2237296
     /* 2237296 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29745*/ GIMT_Encode4(2240235),
     /* 2237307 */ /*GILLT_s32*//*Label 29721*/ GIMT_Encode4(2237431),
     /* 2237311 */ /*GILLT_s64*//*Label 29722*/ GIMT_Encode4(2237568), GIMT_Encode4(0),
     /* 2237319 */ /*GILLT_nxv1s8*//*Label 29723*/ GIMT_Encode4(2237705),
     /* 2237323 */ /*GILLT_nxv1s16*//*Label 29724*/ GIMT_Encode4(2237820),
     /* 2237327 */ /*GILLT_nxv1s32*//*Label 29725*/ GIMT_Encode4(2237935),
     /* 2237331 */ /*GILLT_nxv1s64*//*Label 29726*/ GIMT_Encode4(2238050), GIMT_Encode4(0),
     /* 2237339 */ /*GILLT_nxv2s8*//*Label 29727*/ GIMT_Encode4(2238165),
     /* 2237343 */ /*GILLT_nxv2s16*//*Label 29728*/ GIMT_Encode4(2238280),
     /* 2237347 */ /*GILLT_nxv2s32*//*Label 29729*/ GIMT_Encode4(2238395),
     /* 2237351 */ /*GILLT_nxv2s64*//*Label 29730*/ GIMT_Encode4(2238510), GIMT_Encode4(0),
     /* 2237359 */ /*GILLT_nxv4s8*//*Label 29731*/ GIMT_Encode4(2238625),
     /* 2237363 */ /*GILLT_nxv4s16*//*Label 29732*/ GIMT_Encode4(2238740),
     /* 2237367 */ /*GILLT_nxv4s32*//*Label 29733*/ GIMT_Encode4(2238855),
     /* 2237371 */ /*GILLT_nxv4s64*//*Label 29734*/ GIMT_Encode4(2238970), GIMT_Encode4(0),
     /* 2237379 */ /*GILLT_nxv8s8*//*Label 29735*/ GIMT_Encode4(2239085),
     /* 2237383 */ /*GILLT_nxv8s16*//*Label 29736*/ GIMT_Encode4(2239200),
     /* 2237387 */ /*GILLT_nxv8s32*//*Label 29737*/ GIMT_Encode4(2239315),
     /* 2237391 */ /*GILLT_nxv8s64*//*Label 29738*/ GIMT_Encode4(2239430), GIMT_Encode4(0),
     /* 2237399 */ /*GILLT_nxv16s8*//*Label 29739*/ GIMT_Encode4(2239545),
     /* 2237403 */ /*GILLT_nxv16s16*//*Label 29740*/ GIMT_Encode4(2239660),
     /* 2237407 */ /*GILLT_nxv16s32*//*Label 29741*/ GIMT_Encode4(2239775), GIMT_Encode4(0),
     /* 2237415 */ /*GILLT_nxv32s8*//*Label 29742*/ GIMT_Encode4(2239890),
     /* 2237419 */ /*GILLT_nxv32s16*//*Label 29743*/ GIMT_Encode4(2240005), GIMT_Encode4(0),
     /* 2237427 */ /*GILLT_nxv64s8*//*Label 29744*/ GIMT_Encode4(2240120),
     /* 2237431 */ // Label 29721: @2237431
     /* 2237431 */ GIM_Try, /*On fail goto*//*Label 29746*/ GIMT_Encode4(2237567),
     /* 2237436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2237439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2237442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237450 */   GIM_Try, /*On fail goto*//*Label 29747*/ GIMT_Encode4(2237484), // Rule ID 2453 //
     /* 2237455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2237458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2237466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2237470 */     // MIs[1] Operand 1
     /* 2237470 */     // No operand predicates
     /* 2237470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237472 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2237472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2237475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2237482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237483 */     // GIR_Coverage, 2453,
     /* 2237483 */     GIR_EraseRootFromParent_Done,
     /* 2237484 */   // Label 29747: @2237484
     /* 2237484 */   GIM_Try, /*On fail goto*//*Label 29748*/ GIMT_Encode4(2237518), // Rule ID 62544 //
     /* 2237489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2237492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2237500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2237504 */     // MIs[1] Operand 1
     /* 2237504 */     // No operand predicates
     /* 2237504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237506 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2237506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2237509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2237516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237517 */     // GIR_Coverage, 62544,
     /* 2237517 */     GIR_EraseRootFromParent_Done,
     /* 2237518 */   // Label 29748: @2237518
     /* 2237518 */   GIM_Try, /*On fail goto*//*Label 29749*/ GIMT_Encode4(2237547), // Rule ID 2451 //
     /* 2237523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2237526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2237533 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2237533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2237536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2237545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237546 */     // GIR_Coverage, 2451,
     /* 2237546 */     GIR_EraseRootFromParent_Done,
     /* 2237547 */   // Label 29749: @2237547
     /* 2237547 */   GIM_Try, /*On fail goto*//*Label 29750*/ GIMT_Encode4(2237566), // Rule ID 64438 //
     /* 2237552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2237555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237559 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2237559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2237564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237565 */     // GIR_Coverage, 64438,
     /* 2237565 */     GIR_Done,
     /* 2237566 */   // Label 29750: @2237566
     /* 2237566 */   GIM_Reject,
     /* 2237567 */ // Label 29746: @2237567
     /* 2237567 */ GIM_Reject,
     /* 2237568 */ // Label 29722: @2237568
     /* 2237568 */ GIM_Try, /*On fail goto*//*Label 29751*/ GIMT_Encode4(2237704),
     /* 2237573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2237576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2237579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237587 */   GIM_Try, /*On fail goto*//*Label 29752*/ GIMT_Encode4(2237621), // Rule ID 2452 //
     /* 2237592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2237595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2237603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2237607 */     // MIs[1] Operand 1
     /* 2237607 */     // No operand predicates
     /* 2237607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237609 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2237609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2237612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2237619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237620 */     // GIR_Coverage, 2452,
     /* 2237620 */     GIR_EraseRootFromParent_Done,
     /* 2237621 */   // Label 29752: @2237621
     /* 2237621 */   GIM_Try, /*On fail goto*//*Label 29753*/ GIMT_Encode4(2237655), // Rule ID 62543 //
     /* 2237626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2237629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2237637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2237641 */     // MIs[1] Operand 1
     /* 2237641 */     // No operand predicates
     /* 2237641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237643 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2237643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2237646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2237653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237654 */     // GIR_Coverage, 62543,
     /* 2237654 */     GIR_EraseRootFromParent_Done,
     /* 2237655 */   // Label 29753: @2237655
     /* 2237655 */   GIM_Try, /*On fail goto*//*Label 29754*/ GIMT_Encode4(2237684), // Rule ID 2450 //
     /* 2237660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2237663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2237670 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2237670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2237673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2237682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237683 */     // GIR_Coverage, 2450,
     /* 2237683 */     GIR_EraseRootFromParent_Done,
     /* 2237684 */   // Label 29754: @2237684
     /* 2237684 */   GIM_Try, /*On fail goto*//*Label 29755*/ GIMT_Encode4(2237703), // Rule ID 64437 //
     /* 2237689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2237692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237696 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2237696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2237701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237702 */     // GIR_Coverage, 64437,
     /* 2237702 */     GIR_Done,
     /* 2237703 */   // Label 29755: @2237703
     /* 2237703 */   GIM_Reject,
     /* 2237704 */ // Label 29751: @2237704
     /* 2237704 */ GIM_Reject,
     /* 2237705 */ // Label 29723: @2237705
     /* 2237705 */ GIM_Try, /*On fail goto*//*Label 29756*/ GIMT_Encode4(2237819),
     /* 2237710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2237713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2237716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237728 */   GIM_Try, /*On fail goto*//*Label 29757*/ GIMT_Encode4(2237773), // Rule ID 59396 //
     /* 2237733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237736 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2237739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2237753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237772 */     // GIR_Coverage, 59396,
     /* 2237772 */     GIR_EraseRootFromParent_Done,
     /* 2237773 */   // Label 29757: @2237773
     /* 2237773 */   GIM_Try, /*On fail goto*//*Label 29758*/ GIMT_Encode4(2237818), // Rule ID 59397 //
     /* 2237778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237781 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2237784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2237798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237817 */     // GIR_Coverage, 59397,
     /* 2237817 */     GIR_EraseRootFromParent_Done,
     /* 2237818 */   // Label 29758: @2237818
     /* 2237818 */   GIM_Reject,
     /* 2237819 */ // Label 29756: @2237819
     /* 2237819 */ GIM_Reject,
     /* 2237820 */ // Label 29724: @2237820
     /* 2237820 */ GIM_Try, /*On fail goto*//*Label 29759*/ GIMT_Encode4(2237934),
     /* 2237825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2237828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2237831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237843 */   GIM_Try, /*On fail goto*//*Label 29760*/ GIMT_Encode4(2237888), // Rule ID 59408 //
     /* 2237848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237851 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2237854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2237868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237887 */     // GIR_Coverage, 59408,
     /* 2237887 */     GIR_EraseRootFromParent_Done,
     /* 2237888 */   // Label 29760: @2237888
     /* 2237888 */   GIM_Try, /*On fail goto*//*Label 29761*/ GIMT_Encode4(2237933), // Rule ID 59409 //
     /* 2237893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237896 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2237899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2237913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237932 */     // GIR_Coverage, 59409,
     /* 2237932 */     GIR_EraseRootFromParent_Done,
     /* 2237933 */   // Label 29761: @2237933
     /* 2237933 */   GIM_Reject,
     /* 2237934 */ // Label 29759: @2237934
     /* 2237934 */ GIM_Reject,
     /* 2237935 */ // Label 29725: @2237935
     /* 2237935 */ GIM_Try, /*On fail goto*//*Label 29762*/ GIMT_Encode4(2238049),
     /* 2237940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2237943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2237946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237958 */   GIM_Try, /*On fail goto*//*Label 29763*/ GIMT_Encode4(2238003), // Rule ID 59416 //
     /* 2237963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237966 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2237969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2237983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238002 */     // GIR_Coverage, 59416,
     /* 2238002 */     GIR_EraseRootFromParent_Done,
     /* 2238003 */   // Label 29763: @2238003
     /* 2238003 */   GIM_Try, /*On fail goto*//*Label 29764*/ GIMT_Encode4(2238048), // Rule ID 59417 //
     /* 2238008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238011 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2238014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2238028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238047 */     // GIR_Coverage, 59417,
     /* 2238047 */     GIR_EraseRootFromParent_Done,
     /* 2238048 */   // Label 29764: @2238048
     /* 2238048 */   GIM_Reject,
     /* 2238049 */ // Label 29762: @2238049
     /* 2238049 */ GIM_Reject,
     /* 2238050 */ // Label 29726: @2238050
     /* 2238050 */ GIM_Try, /*On fail goto*//*Label 29765*/ GIMT_Encode4(2238164),
     /* 2238055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2238058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2238061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238073 */   GIM_Try, /*On fail goto*//*Label 29766*/ GIMT_Encode4(2238118), // Rule ID 59432 //
     /* 2238078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238081 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2238084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2238098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238117 */     // GIR_Coverage, 59432,
     /* 2238117 */     GIR_EraseRootFromParent_Done,
     /* 2238118 */   // Label 29766: @2238118
     /* 2238118 */   GIM_Try, /*On fail goto*//*Label 29767*/ GIMT_Encode4(2238163), // Rule ID 59433 //
     /* 2238123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238126 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2238129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2238143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238162 */     // GIR_Coverage, 59433,
     /* 2238162 */     GIR_EraseRootFromParent_Done,
     /* 2238163 */   // Label 29767: @2238163
     /* 2238163 */   GIM_Reject,
     /* 2238164 */ // Label 29765: @2238164
     /* 2238164 */ GIM_Reject,
     /* 2238165 */ // Label 29727: @2238165
     /* 2238165 */ GIM_Try, /*On fail goto*//*Label 29768*/ GIMT_Encode4(2238279),
     /* 2238170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2238173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2238176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238188 */   GIM_Try, /*On fail goto*//*Label 29769*/ GIMT_Encode4(2238233), // Rule ID 59400 //
     /* 2238193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238196 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2238199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2238213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238232 */     // GIR_Coverage, 59400,
     /* 2238232 */     GIR_EraseRootFromParent_Done,
     /* 2238233 */   // Label 29769: @2238233
     /* 2238233 */   GIM_Try, /*On fail goto*//*Label 29770*/ GIMT_Encode4(2238278), // Rule ID 59401 //
     /* 2238238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238241 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2238244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2238258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238277 */     // GIR_Coverage, 59401,
     /* 2238277 */     GIR_EraseRootFromParent_Done,
     /* 2238278 */   // Label 29770: @2238278
     /* 2238278 */   GIM_Reject,
     /* 2238279 */ // Label 29768: @2238279
     /* 2238279 */ GIM_Reject,
     /* 2238280 */ // Label 29728: @2238280
     /* 2238280 */ GIM_Try, /*On fail goto*//*Label 29771*/ GIMT_Encode4(2238394),
     /* 2238285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2238288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2238291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238303 */   GIM_Try, /*On fail goto*//*Label 29772*/ GIMT_Encode4(2238348), // Rule ID 59412 //
     /* 2238308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238311 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2238314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2238328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238347 */     // GIR_Coverage, 59412,
     /* 2238347 */     GIR_EraseRootFromParent_Done,
     /* 2238348 */   // Label 29772: @2238348
     /* 2238348 */   GIM_Try, /*On fail goto*//*Label 29773*/ GIMT_Encode4(2238393), // Rule ID 59413 //
     /* 2238353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238356 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2238359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2238373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238392 */     // GIR_Coverage, 59413,
     /* 2238392 */     GIR_EraseRootFromParent_Done,
     /* 2238393 */   // Label 29773: @2238393
     /* 2238393 */   GIM_Reject,
     /* 2238394 */ // Label 29771: @2238394
     /* 2238394 */ GIM_Reject,
     /* 2238395 */ // Label 29729: @2238395
     /* 2238395 */ GIM_Try, /*On fail goto*//*Label 29774*/ GIMT_Encode4(2238509),
     /* 2238400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2238403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2238406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238418 */   GIM_Try, /*On fail goto*//*Label 29775*/ GIMT_Encode4(2238463), // Rule ID 59428 //
     /* 2238423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238426 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2238429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2238443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238462 */     // GIR_Coverage, 59428,
     /* 2238462 */     GIR_EraseRootFromParent_Done,
     /* 2238463 */   // Label 29775: @2238463
     /* 2238463 */   GIM_Try, /*On fail goto*//*Label 29776*/ GIMT_Encode4(2238508), // Rule ID 59429 //
     /* 2238468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238471 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2238474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2238488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238507 */     // GIR_Coverage, 59429,
     /* 2238507 */     GIR_EraseRootFromParent_Done,
     /* 2238508 */   // Label 29776: @2238508
     /* 2238508 */   GIM_Reject,
     /* 2238509 */ // Label 29774: @2238509
     /* 2238509 */ GIM_Reject,
     /* 2238510 */ // Label 29730: @2238510
     /* 2238510 */ GIM_Try, /*On fail goto*//*Label 29777*/ GIMT_Encode4(2238624),
     /* 2238515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2238518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2238521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238533 */   GIM_Try, /*On fail goto*//*Label 29778*/ GIMT_Encode4(2238578), // Rule ID 59472 //
     /* 2238538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238541 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2238544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2238558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238577 */     // GIR_Coverage, 59472,
     /* 2238577 */     GIR_EraseRootFromParent_Done,
     /* 2238578 */   // Label 29778: @2238578
     /* 2238578 */   GIM_Try, /*On fail goto*//*Label 29779*/ GIMT_Encode4(2238623), // Rule ID 59473 //
     /* 2238583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238586 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2238589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2238603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238622 */     // GIR_Coverage, 59473,
     /* 2238622 */     GIR_EraseRootFromParent_Done,
     /* 2238623 */   // Label 29779: @2238623
     /* 2238623 */   GIM_Reject,
     /* 2238624 */ // Label 29777: @2238624
     /* 2238624 */ GIM_Reject,
     /* 2238625 */ // Label 29731: @2238625
     /* 2238625 */ GIM_Try, /*On fail goto*//*Label 29780*/ GIMT_Encode4(2238739),
     /* 2238630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2238633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2238636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238648 */   GIM_Try, /*On fail goto*//*Label 29781*/ GIMT_Encode4(2238693), // Rule ID 59404 //
     /* 2238653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238656 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2238659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2238673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238692 */     // GIR_Coverage, 59404,
     /* 2238692 */     GIR_EraseRootFromParent_Done,
     /* 2238693 */   // Label 29781: @2238693
     /* 2238693 */   GIM_Try, /*On fail goto*//*Label 29782*/ GIMT_Encode4(2238738), // Rule ID 59405 //
     /* 2238698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238701 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2238704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2238718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238737 */     // GIR_Coverage, 59405,
     /* 2238737 */     GIR_EraseRootFromParent_Done,
     /* 2238738 */   // Label 29782: @2238738
     /* 2238738 */   GIM_Reject,
     /* 2238739 */ // Label 29780: @2238739
     /* 2238739 */ GIM_Reject,
     /* 2238740 */ // Label 29732: @2238740
     /* 2238740 */ GIM_Try, /*On fail goto*//*Label 29783*/ GIMT_Encode4(2238854),
     /* 2238745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2238748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2238751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238763 */   GIM_Try, /*On fail goto*//*Label 29784*/ GIMT_Encode4(2238808), // Rule ID 59424 //
     /* 2238768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238771 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2238774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2238788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238807 */     // GIR_Coverage, 59424,
     /* 2238807 */     GIR_EraseRootFromParent_Done,
     /* 2238808 */   // Label 29784: @2238808
     /* 2238808 */   GIM_Try, /*On fail goto*//*Label 29785*/ GIMT_Encode4(2238853), // Rule ID 59425 //
     /* 2238813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238816 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2238819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2238833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238852 */     // GIR_Coverage, 59425,
     /* 2238852 */     GIR_EraseRootFromParent_Done,
     /* 2238853 */   // Label 29785: @2238853
     /* 2238853 */   GIM_Reject,
     /* 2238854 */ // Label 29783: @2238854
     /* 2238854 */ GIM_Reject,
     /* 2238855 */ // Label 29733: @2238855
     /* 2238855 */ GIM_Try, /*On fail goto*//*Label 29786*/ GIMT_Encode4(2238969),
     /* 2238860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2238863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2238866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238878 */   GIM_Try, /*On fail goto*//*Label 29787*/ GIMT_Encode4(2238923), // Rule ID 59460 //
     /* 2238883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238886 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2238889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2238903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238922 */     // GIR_Coverage, 59460,
     /* 2238922 */     GIR_EraseRootFromParent_Done,
     /* 2238923 */   // Label 29787: @2238923
     /* 2238923 */   GIM_Try, /*On fail goto*//*Label 29788*/ GIMT_Encode4(2238968), // Rule ID 59461 //
     /* 2238928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238931 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2238934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2238948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238967 */     // GIR_Coverage, 59461,
     /* 2238967 */     GIR_EraseRootFromParent_Done,
     /* 2238968 */   // Label 29788: @2238968
     /* 2238968 */   GIM_Reject,
     /* 2238969 */ // Label 29786: @2238969
     /* 2238969 */ GIM_Reject,
     /* 2238970 */ // Label 29734: @2238970
     /* 2238970 */ GIM_Try, /*On fail goto*//*Label 29789*/ GIMT_Encode4(2239084),
     /* 2238975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2238978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2238981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238993 */   GIM_Try, /*On fail goto*//*Label 29790*/ GIMT_Encode4(2239038), // Rule ID 59476 //
     /* 2238998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2239001 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2239004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2239018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239037 */     // GIR_Coverage, 59476,
     /* 2239037 */     GIR_EraseRootFromParent_Done,
     /* 2239038 */   // Label 29790: @2239038
     /* 2239038 */   GIM_Try, /*On fail goto*//*Label 29791*/ GIMT_Encode4(2239083), // Rule ID 59477 //
     /* 2239043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2239046 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2239049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2239063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239082 */     // GIR_Coverage, 59477,
     /* 2239082 */     GIR_EraseRootFromParent_Done,
     /* 2239083 */   // Label 29791: @2239083
     /* 2239083 */   GIM_Reject,
     /* 2239084 */ // Label 29789: @2239084
     /* 2239084 */ GIM_Reject,
     /* 2239085 */ // Label 29735: @2239085
     /* 2239085 */ GIM_Try, /*On fail goto*//*Label 29792*/ GIMT_Encode4(2239199),
     /* 2239090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2239093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2239096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239108 */   GIM_Try, /*On fail goto*//*Label 29793*/ GIMT_Encode4(2239153), // Rule ID 59420 //
     /* 2239113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239116 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2239119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2239133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239152 */     // GIR_Coverage, 59420,
     /* 2239152 */     GIR_EraseRootFromParent_Done,
     /* 2239153 */   // Label 29793: @2239153
     /* 2239153 */   GIM_Try, /*On fail goto*//*Label 29794*/ GIMT_Encode4(2239198), // Rule ID 59421 //
     /* 2239158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239161 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2239164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2239178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239197 */     // GIR_Coverage, 59421,
     /* 2239197 */     GIR_EraseRootFromParent_Done,
     /* 2239198 */   // Label 29794: @2239198
     /* 2239198 */   GIM_Reject,
     /* 2239199 */ // Label 29792: @2239199
     /* 2239199 */ GIM_Reject,
     /* 2239200 */ // Label 29736: @2239200
     /* 2239200 */ GIM_Try, /*On fail goto*//*Label 29795*/ GIMT_Encode4(2239314),
     /* 2239205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2239208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2239211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239223 */   GIM_Try, /*On fail goto*//*Label 29796*/ GIMT_Encode4(2239268), // Rule ID 59448 //
     /* 2239228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239231 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2239234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2239248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239267 */     // GIR_Coverage, 59448,
     /* 2239267 */     GIR_EraseRootFromParent_Done,
     /* 2239268 */   // Label 29796: @2239268
     /* 2239268 */   GIM_Try, /*On fail goto*//*Label 29797*/ GIMT_Encode4(2239313), // Rule ID 59449 //
     /* 2239273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239276 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2239279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2239293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239312 */     // GIR_Coverage, 59449,
     /* 2239312 */     GIR_EraseRootFromParent_Done,
     /* 2239313 */   // Label 29797: @2239313
     /* 2239313 */   GIM_Reject,
     /* 2239314 */ // Label 29795: @2239314
     /* 2239314 */ GIM_Reject,
     /* 2239315 */ // Label 29737: @2239315
     /* 2239315 */ GIM_Try, /*On fail goto*//*Label 29798*/ GIMT_Encode4(2239429),
     /* 2239320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2239323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2239326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239338 */   GIM_Try, /*On fail goto*//*Label 29799*/ GIMT_Encode4(2239383), // Rule ID 59464 //
     /* 2239343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239346 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2239349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2239363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239382 */     // GIR_Coverage, 59464,
     /* 2239382 */     GIR_EraseRootFromParent_Done,
     /* 2239383 */   // Label 29799: @2239383
     /* 2239383 */   GIM_Try, /*On fail goto*//*Label 29800*/ GIMT_Encode4(2239428), // Rule ID 59465 //
     /* 2239388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239391 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2239394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2239408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239427 */     // GIR_Coverage, 59465,
     /* 2239427 */     GIR_EraseRootFromParent_Done,
     /* 2239428 */   // Label 29800: @2239428
     /* 2239428 */   GIM_Reject,
     /* 2239429 */ // Label 29798: @2239429
     /* 2239429 */ GIM_Reject,
     /* 2239430 */ // Label 29738: @2239430
     /* 2239430 */ GIM_Try, /*On fail goto*//*Label 29801*/ GIMT_Encode4(2239544),
     /* 2239435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2239438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2239441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239453 */   GIM_Try, /*On fail goto*//*Label 29802*/ GIMT_Encode4(2239498), // Rule ID 59480 //
     /* 2239458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2239461 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2239464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2239478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239497 */     // GIR_Coverage, 59480,
     /* 2239497 */     GIR_EraseRootFromParent_Done,
     /* 2239498 */   // Label 29802: @2239498
     /* 2239498 */   GIM_Try, /*On fail goto*//*Label 29803*/ GIMT_Encode4(2239543), // Rule ID 59481 //
     /* 2239503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2239506 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2239509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2239523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239542 */     // GIR_Coverage, 59481,
     /* 2239542 */     GIR_EraseRootFromParent_Done,
     /* 2239543 */   // Label 29803: @2239543
     /* 2239543 */   GIM_Reject,
     /* 2239544 */ // Label 29801: @2239544
     /* 2239544 */ GIM_Reject,
     /* 2239545 */ // Label 29739: @2239545
     /* 2239545 */ GIM_Try, /*On fail goto*//*Label 29804*/ GIMT_Encode4(2239659),
     /* 2239550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2239553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2239556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239568 */   GIM_Try, /*On fail goto*//*Label 29805*/ GIMT_Encode4(2239613), // Rule ID 59436 //
     /* 2239573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239576 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2239579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2239593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239612 */     // GIR_Coverage, 59436,
     /* 2239612 */     GIR_EraseRootFromParent_Done,
     /* 2239613 */   // Label 29805: @2239613
     /* 2239613 */   GIM_Try, /*On fail goto*//*Label 29806*/ GIMT_Encode4(2239658), // Rule ID 59437 //
     /* 2239618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239621 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2239624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2239638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239657 */     // GIR_Coverage, 59437,
     /* 2239657 */     GIR_EraseRootFromParent_Done,
     /* 2239658 */   // Label 29806: @2239658
     /* 2239658 */   GIM_Reject,
     /* 2239659 */ // Label 29804: @2239659
     /* 2239659 */ GIM_Reject,
     /* 2239660 */ // Label 29740: @2239660
     /* 2239660 */ GIM_Try, /*On fail goto*//*Label 29807*/ GIMT_Encode4(2239774),
     /* 2239665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2239668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2239671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239683 */   GIM_Try, /*On fail goto*//*Label 29808*/ GIMT_Encode4(2239728), // Rule ID 59452 //
     /* 2239688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239691 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2239694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2239708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239727 */     // GIR_Coverage, 59452,
     /* 2239727 */     GIR_EraseRootFromParent_Done,
     /* 2239728 */   // Label 29808: @2239728
     /* 2239728 */   GIM_Try, /*On fail goto*//*Label 29809*/ GIMT_Encode4(2239773), // Rule ID 59453 //
     /* 2239733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239736 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2239739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2239753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239772 */     // GIR_Coverage, 59453,
     /* 2239772 */     GIR_EraseRootFromParent_Done,
     /* 2239773 */   // Label 29809: @2239773
     /* 2239773 */   GIM_Reject,
     /* 2239774 */ // Label 29807: @2239774
     /* 2239774 */ GIM_Reject,
     /* 2239775 */ // Label 29741: @2239775
     /* 2239775 */ GIM_Try, /*On fail goto*//*Label 29810*/ GIMT_Encode4(2239889),
     /* 2239780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2239783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2239786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239798 */   GIM_Try, /*On fail goto*//*Label 29811*/ GIMT_Encode4(2239843), // Rule ID 59468 //
     /* 2239803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239806 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2239809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2239823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239842 */     // GIR_Coverage, 59468,
     /* 2239842 */     GIR_EraseRootFromParent_Done,
     /* 2239843 */   // Label 29811: @2239843
     /* 2239843 */   GIM_Try, /*On fail goto*//*Label 29812*/ GIMT_Encode4(2239888), // Rule ID 59469 //
     /* 2239848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239851 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2239854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2239868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239887 */     // GIR_Coverage, 59469,
     /* 2239887 */     GIR_EraseRootFromParent_Done,
     /* 2239888 */   // Label 29812: @2239888
     /* 2239888 */   GIM_Reject,
     /* 2239889 */ // Label 29810: @2239889
     /* 2239889 */ GIM_Reject,
     /* 2239890 */ // Label 29742: @2239890
     /* 2239890 */ GIM_Try, /*On fail goto*//*Label 29813*/ GIMT_Encode4(2240004),
     /* 2239895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2239898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2239901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239913 */   GIM_Try, /*On fail goto*//*Label 29814*/ GIMT_Encode4(2239958), // Rule ID 59440 //
     /* 2239918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239921 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2239924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2239938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239957 */     // GIR_Coverage, 59440,
     /* 2239957 */     GIR_EraseRootFromParent_Done,
     /* 2239958 */   // Label 29814: @2239958
     /* 2239958 */   GIM_Try, /*On fail goto*//*Label 29815*/ GIMT_Encode4(2240003), // Rule ID 59441 //
     /* 2239963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239966 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2239969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2239983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240002 */     // GIR_Coverage, 59441,
     /* 2240002 */     GIR_EraseRootFromParent_Done,
     /* 2240003 */   // Label 29815: @2240003
     /* 2240003 */   GIM_Reject,
     /* 2240004 */ // Label 29813: @2240004
     /* 2240004 */ GIM_Reject,
     /* 2240005 */ // Label 29743: @2240005
     /* 2240005 */ GIM_Try, /*On fail goto*//*Label 29816*/ GIMT_Encode4(2240119),
     /* 2240010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2240013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2240016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2240020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2240024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2240028 */   GIM_Try, /*On fail goto*//*Label 29817*/ GIMT_Encode4(2240073), // Rule ID 59456 //
     /* 2240033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240036 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2240039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2240053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240072 */     // GIR_Coverage, 59456,
     /* 2240072 */     GIR_EraseRootFromParent_Done,
     /* 2240073 */   // Label 29817: @2240073
     /* 2240073 */   GIM_Try, /*On fail goto*//*Label 29818*/ GIMT_Encode4(2240118), // Rule ID 59457 //
     /* 2240078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240081 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2240084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2240098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240117 */     // GIR_Coverage, 59457,
     /* 2240117 */     GIR_EraseRootFromParent_Done,
     /* 2240118 */   // Label 29818: @2240118
     /* 2240118 */   GIM_Reject,
     /* 2240119 */ // Label 29816: @2240119
     /* 2240119 */ GIM_Reject,
     /* 2240120 */ // Label 29744: @2240120
     /* 2240120 */ GIM_Try, /*On fail goto*//*Label 29819*/ GIMT_Encode4(2240234),
     /* 2240125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2240128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2240131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2240135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2240139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2240143 */   GIM_Try, /*On fail goto*//*Label 29820*/ GIMT_Encode4(2240188), // Rule ID 59444 //
     /* 2240148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240151 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2240154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2240168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240187 */     // GIR_Coverage, 59444,
     /* 2240187 */     GIR_EraseRootFromParent_Done,
     /* 2240188 */   // Label 29820: @2240188
     /* 2240188 */   GIM_Try, /*On fail goto*//*Label 29821*/ GIMT_Encode4(2240233), // Rule ID 59445 //
     /* 2240193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240196 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2240199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2240213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240232 */     // GIR_Coverage, 59445,
     /* 2240232 */     GIR_EraseRootFromParent_Done,
     /* 2240233 */   // Label 29821: @2240233
     /* 2240233 */   GIM_Reject,
     /* 2240234 */ // Label 29819: @2240234
     /* 2240234 */ GIM_Reject,
     /* 2240235 */ // Label 29745: @2240235
     /* 2240235 */ GIM_Reject,
     /* 2240236 */ // Label 47: @2240236
     /* 2240236 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29846*/ GIMT_Encode4(2243145),
     /* 2240247 */ /*GILLT_s32*//*Label 29822*/ GIMT_Encode4(2240371),
     /* 2240251 */ /*GILLT_s64*//*Label 29823*/ GIMT_Encode4(2240493), GIMT_Encode4(0),
     /* 2240259 */ /*GILLT_nxv1s8*//*Label 29824*/ GIMT_Encode4(2240615),
     /* 2240263 */ /*GILLT_nxv1s16*//*Label 29825*/ GIMT_Encode4(2240730),
     /* 2240267 */ /*GILLT_nxv1s32*//*Label 29826*/ GIMT_Encode4(2240845),
     /* 2240271 */ /*GILLT_nxv1s64*//*Label 29827*/ GIMT_Encode4(2240960), GIMT_Encode4(0),
     /* 2240279 */ /*GILLT_nxv2s8*//*Label 29828*/ GIMT_Encode4(2241075),
     /* 2240283 */ /*GILLT_nxv2s16*//*Label 29829*/ GIMT_Encode4(2241190),
     /* 2240287 */ /*GILLT_nxv2s32*//*Label 29830*/ GIMT_Encode4(2241305),
     /* 2240291 */ /*GILLT_nxv2s64*//*Label 29831*/ GIMT_Encode4(2241420), GIMT_Encode4(0),
     /* 2240299 */ /*GILLT_nxv4s8*//*Label 29832*/ GIMT_Encode4(2241535),
     /* 2240303 */ /*GILLT_nxv4s16*//*Label 29833*/ GIMT_Encode4(2241650),
     /* 2240307 */ /*GILLT_nxv4s32*//*Label 29834*/ GIMT_Encode4(2241765),
     /* 2240311 */ /*GILLT_nxv4s64*//*Label 29835*/ GIMT_Encode4(2241880), GIMT_Encode4(0),
     /* 2240319 */ /*GILLT_nxv8s8*//*Label 29836*/ GIMT_Encode4(2241995),
     /* 2240323 */ /*GILLT_nxv8s16*//*Label 29837*/ GIMT_Encode4(2242110),
     /* 2240327 */ /*GILLT_nxv8s32*//*Label 29838*/ GIMT_Encode4(2242225),
     /* 2240331 */ /*GILLT_nxv8s64*//*Label 29839*/ GIMT_Encode4(2242340), GIMT_Encode4(0),
     /* 2240339 */ /*GILLT_nxv16s8*//*Label 29840*/ GIMT_Encode4(2242455),
     /* 2240343 */ /*GILLT_nxv16s16*//*Label 29841*/ GIMT_Encode4(2242570),
     /* 2240347 */ /*GILLT_nxv16s32*//*Label 29842*/ GIMT_Encode4(2242685), GIMT_Encode4(0),
     /* 2240355 */ /*GILLT_nxv32s8*//*Label 29843*/ GIMT_Encode4(2242800),
     /* 2240359 */ /*GILLT_nxv32s16*//*Label 29844*/ GIMT_Encode4(2242915), GIMT_Encode4(0),
     /* 2240367 */ /*GILLT_nxv64s8*//*Label 29845*/ GIMT_Encode4(2243030),
     /* 2240371 */ // Label 29822: @2240371
     /* 2240371 */ GIM_Try, /*On fail goto*//*Label 29847*/ GIMT_Encode4(2240492),
     /* 2240376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2240379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240390 */   GIM_Try, /*On fail goto*//*Label 29848*/ GIMT_Encode4(2240426), // Rule ID 2455 //
     /* 2240395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2240398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2240402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2240410 */     // MIs[1] Operand 1
     /* 2240410 */     // No operand predicates
     /* 2240410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240412 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2240412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2240415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240419 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2240424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240425 */     // GIR_Coverage, 2455,
     /* 2240425 */     GIR_EraseRootFromParent_Done,
     /* 2240426 */   // Label 29848: @2240426
     /* 2240426 */   GIM_Try, /*On fail goto*//*Label 29849*/ GIMT_Encode4(2240462), // Rule ID 62546 //
     /* 2240431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2240434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2240438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2240446 */     // MIs[1] Operand 1
     /* 2240446 */     // No operand predicates
     /* 2240446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240448 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2240448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2240451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240455 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2240460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240461 */     // GIR_Coverage, 62546,
     /* 2240461 */     GIR_EraseRootFromParent_Done,
     /* 2240462 */   // Label 29849: @2240462
     /* 2240462 */   GIM_Try, /*On fail goto*//*Label 29850*/ GIMT_Encode4(2240491), // Rule ID 2449 //
     /* 2240467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2240470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2240477 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2240477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2240480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2240489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240490 */     // GIR_Coverage, 2449,
     /* 2240490 */     GIR_EraseRootFromParent_Done,
     /* 2240491 */   // Label 29850: @2240491
     /* 2240491 */   GIM_Reject,
     /* 2240492 */ // Label 29847: @2240492
     /* 2240492 */ GIM_Reject,
     /* 2240493 */ // Label 29823: @2240493
     /* 2240493 */ GIM_Try, /*On fail goto*//*Label 29851*/ GIMT_Encode4(2240614),
     /* 2240498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2240501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2240504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240512 */   GIM_Try, /*On fail goto*//*Label 29852*/ GIMT_Encode4(2240548), // Rule ID 2454 //
     /* 2240517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2240520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2240524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2240532 */     // MIs[1] Operand 1
     /* 2240532 */     // No operand predicates
     /* 2240532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240534 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2240534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2240537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240541 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2240546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240547 */     // GIR_Coverage, 2454,
     /* 2240547 */     GIR_EraseRootFromParent_Done,
     /* 2240548 */   // Label 29852: @2240548
     /* 2240548 */   GIM_Try, /*On fail goto*//*Label 29853*/ GIMT_Encode4(2240584), // Rule ID 62545 //
     /* 2240553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2240556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2240560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2240568 */     // MIs[1] Operand 1
     /* 2240568 */     // No operand predicates
     /* 2240568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240570 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2240570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2240573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240577 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2240582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240583 */     // GIR_Coverage, 62545,
     /* 2240583 */     GIR_EraseRootFromParent_Done,
     /* 2240584 */   // Label 29853: @2240584
     /* 2240584 */   GIM_Try, /*On fail goto*//*Label 29854*/ GIMT_Encode4(2240613), // Rule ID 2448 //
     /* 2240589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2240592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2240599 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2240599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2240602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2240611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240612 */     // GIR_Coverage, 2448,
     /* 2240612 */     GIR_EraseRootFromParent_Done,
     /* 2240613 */   // Label 29854: @2240613
     /* 2240613 */   GIM_Reject,
     /* 2240614 */ // Label 29851: @2240614
     /* 2240614 */ GIM_Reject,
     /* 2240615 */ // Label 29824: @2240615
     /* 2240615 */ GIM_Try, /*On fail goto*//*Label 29855*/ GIMT_Encode4(2240729),
     /* 2240620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2240623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2240626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240638 */   GIM_Try, /*On fail goto*//*Label 29856*/ GIMT_Encode4(2240683), // Rule ID 59264 //
     /* 2240643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240646 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2240649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2240663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240682 */     // GIR_Coverage, 59264,
     /* 2240682 */     GIR_EraseRootFromParent_Done,
     /* 2240683 */   // Label 29856: @2240683
     /* 2240683 */   GIM_Try, /*On fail goto*//*Label 29857*/ GIMT_Encode4(2240728), // Rule ID 59265 //
     /* 2240688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240691 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2240694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2240708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240727 */     // GIR_Coverage, 59265,
     /* 2240727 */     GIR_EraseRootFromParent_Done,
     /* 2240728 */   // Label 29857: @2240728
     /* 2240728 */   GIM_Reject,
     /* 2240729 */ // Label 29855: @2240729
     /* 2240729 */ GIM_Reject,
     /* 2240730 */ // Label 29825: @2240730
     /* 2240730 */ GIM_Try, /*On fail goto*//*Label 29858*/ GIMT_Encode4(2240844),
     /* 2240735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2240738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2240741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240753 */   GIM_Try, /*On fail goto*//*Label 29859*/ GIMT_Encode4(2240798), // Rule ID 59276 //
     /* 2240758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240761 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2240764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2240778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240797 */     // GIR_Coverage, 59276,
     /* 2240797 */     GIR_EraseRootFromParent_Done,
     /* 2240798 */   // Label 29859: @2240798
     /* 2240798 */   GIM_Try, /*On fail goto*//*Label 29860*/ GIMT_Encode4(2240843), // Rule ID 59277 //
     /* 2240803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240806 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2240809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2240823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240842 */     // GIR_Coverage, 59277,
     /* 2240842 */     GIR_EraseRootFromParent_Done,
     /* 2240843 */   // Label 29860: @2240843
     /* 2240843 */   GIM_Reject,
     /* 2240844 */ // Label 29858: @2240844
     /* 2240844 */ GIM_Reject,
     /* 2240845 */ // Label 29826: @2240845
     /* 2240845 */ GIM_Try, /*On fail goto*//*Label 29861*/ GIMT_Encode4(2240959),
     /* 2240850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2240853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2240856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240868 */   GIM_Try, /*On fail goto*//*Label 29862*/ GIMT_Encode4(2240913), // Rule ID 59284 //
     /* 2240873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240876 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2240879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2240893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240912 */     // GIR_Coverage, 59284,
     /* 2240912 */     GIR_EraseRootFromParent_Done,
     /* 2240913 */   // Label 29862: @2240913
     /* 2240913 */   GIM_Try, /*On fail goto*//*Label 29863*/ GIMT_Encode4(2240958), // Rule ID 59285 //
     /* 2240918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240921 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2240924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2240938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2240945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2240957 */     // GIR_Coverage, 59285,
     /* 2240957 */     GIR_EraseRootFromParent_Done,
     /* 2240958 */   // Label 29863: @2240958
     /* 2240958 */   GIM_Reject,
     /* 2240959 */ // Label 29861: @2240959
     /* 2240959 */ GIM_Reject,
     /* 2240960 */ // Label 29827: @2240960
     /* 2240960 */ GIM_Try, /*On fail goto*//*Label 29864*/ GIMT_Encode4(2241074),
     /* 2240965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2240968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2240971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240983 */   GIM_Try, /*On fail goto*//*Label 29865*/ GIMT_Encode4(2241028), // Rule ID 59300 //
     /* 2240988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2240991 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2240994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2240998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2241008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241027 */     // GIR_Coverage, 59300,
     /* 2241027 */     GIR_EraseRootFromParent_Done,
     /* 2241028 */   // Label 29865: @2241028
     /* 2241028 */   GIM_Try, /*On fail goto*//*Label 29866*/ GIMT_Encode4(2241073), // Rule ID 59301 //
     /* 2241033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2241036 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2241039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2241053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241072 */     // GIR_Coverage, 59301,
     /* 2241072 */     GIR_EraseRootFromParent_Done,
     /* 2241073 */   // Label 29866: @2241073
     /* 2241073 */   GIM_Reject,
     /* 2241074 */ // Label 29864: @2241074
     /* 2241074 */ GIM_Reject,
     /* 2241075 */ // Label 29828: @2241075
     /* 2241075 */ GIM_Try, /*On fail goto*//*Label 29867*/ GIMT_Encode4(2241189),
     /* 2241080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2241083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2241086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241098 */   GIM_Try, /*On fail goto*//*Label 29868*/ GIMT_Encode4(2241143), // Rule ID 59268 //
     /* 2241103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241106 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2241109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2241123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241142 */     // GIR_Coverage, 59268,
     /* 2241142 */     GIR_EraseRootFromParent_Done,
     /* 2241143 */   // Label 29868: @2241143
     /* 2241143 */   GIM_Try, /*On fail goto*//*Label 29869*/ GIMT_Encode4(2241188), // Rule ID 59269 //
     /* 2241148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241151 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2241154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2241168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241187 */     // GIR_Coverage, 59269,
     /* 2241187 */     GIR_EraseRootFromParent_Done,
     /* 2241188 */   // Label 29869: @2241188
     /* 2241188 */   GIM_Reject,
     /* 2241189 */ // Label 29867: @2241189
     /* 2241189 */ GIM_Reject,
     /* 2241190 */ // Label 29829: @2241190
     /* 2241190 */ GIM_Try, /*On fail goto*//*Label 29870*/ GIMT_Encode4(2241304),
     /* 2241195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2241198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2241201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241213 */   GIM_Try, /*On fail goto*//*Label 29871*/ GIMT_Encode4(2241258), // Rule ID 59280 //
     /* 2241218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241221 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2241224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2241238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241257 */     // GIR_Coverage, 59280,
     /* 2241257 */     GIR_EraseRootFromParent_Done,
     /* 2241258 */   // Label 29871: @2241258
     /* 2241258 */   GIM_Try, /*On fail goto*//*Label 29872*/ GIMT_Encode4(2241303), // Rule ID 59281 //
     /* 2241263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241266 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2241269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2241283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241302 */     // GIR_Coverage, 59281,
     /* 2241302 */     GIR_EraseRootFromParent_Done,
     /* 2241303 */   // Label 29872: @2241303
     /* 2241303 */   GIM_Reject,
     /* 2241304 */ // Label 29870: @2241304
     /* 2241304 */ GIM_Reject,
     /* 2241305 */ // Label 29830: @2241305
     /* 2241305 */ GIM_Try, /*On fail goto*//*Label 29873*/ GIMT_Encode4(2241419),
     /* 2241310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2241313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2241316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241328 */   GIM_Try, /*On fail goto*//*Label 29874*/ GIMT_Encode4(2241373), // Rule ID 59296 //
     /* 2241333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241336 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2241339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2241353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241372 */     // GIR_Coverage, 59296,
     /* 2241372 */     GIR_EraseRootFromParent_Done,
     /* 2241373 */   // Label 29874: @2241373
     /* 2241373 */   GIM_Try, /*On fail goto*//*Label 29875*/ GIMT_Encode4(2241418), // Rule ID 59297 //
     /* 2241378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241381 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2241384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2241398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241417 */     // GIR_Coverage, 59297,
     /* 2241417 */     GIR_EraseRootFromParent_Done,
     /* 2241418 */   // Label 29875: @2241418
     /* 2241418 */   GIM_Reject,
     /* 2241419 */ // Label 29873: @2241419
     /* 2241419 */ GIM_Reject,
     /* 2241420 */ // Label 29831: @2241420
     /* 2241420 */ GIM_Try, /*On fail goto*//*Label 29876*/ GIMT_Encode4(2241534),
     /* 2241425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2241428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2241431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241443 */   GIM_Try, /*On fail goto*//*Label 29877*/ GIMT_Encode4(2241488), // Rule ID 59340 //
     /* 2241448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2241451 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2241454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2241468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241487 */     // GIR_Coverage, 59340,
     /* 2241487 */     GIR_EraseRootFromParent_Done,
     /* 2241488 */   // Label 29877: @2241488
     /* 2241488 */   GIM_Try, /*On fail goto*//*Label 29878*/ GIMT_Encode4(2241533), // Rule ID 59341 //
     /* 2241493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2241496 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2241499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2241513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241532 */     // GIR_Coverage, 59341,
     /* 2241532 */     GIR_EraseRootFromParent_Done,
     /* 2241533 */   // Label 29878: @2241533
     /* 2241533 */   GIM_Reject,
     /* 2241534 */ // Label 29876: @2241534
     /* 2241534 */ GIM_Reject,
     /* 2241535 */ // Label 29832: @2241535
     /* 2241535 */ GIM_Try, /*On fail goto*//*Label 29879*/ GIMT_Encode4(2241649),
     /* 2241540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2241543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2241546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241554 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241558 */   GIM_Try, /*On fail goto*//*Label 29880*/ GIMT_Encode4(2241603), // Rule ID 59272 //
     /* 2241563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241566 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2241569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2241583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241602 */     // GIR_Coverage, 59272,
     /* 2241602 */     GIR_EraseRootFromParent_Done,
     /* 2241603 */   // Label 29880: @2241603
     /* 2241603 */   GIM_Try, /*On fail goto*//*Label 29881*/ GIMT_Encode4(2241648), // Rule ID 59273 //
     /* 2241608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241611 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2241614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2241628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241647 */     // GIR_Coverage, 59273,
     /* 2241647 */     GIR_EraseRootFromParent_Done,
     /* 2241648 */   // Label 29881: @2241648
     /* 2241648 */   GIM_Reject,
     /* 2241649 */ // Label 29879: @2241649
     /* 2241649 */ GIM_Reject,
     /* 2241650 */ // Label 29833: @2241650
     /* 2241650 */ GIM_Try, /*On fail goto*//*Label 29882*/ GIMT_Encode4(2241764),
     /* 2241655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2241658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2241661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241673 */   GIM_Try, /*On fail goto*//*Label 29883*/ GIMT_Encode4(2241718), // Rule ID 59292 //
     /* 2241678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241681 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2241684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2241698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241717 */     // GIR_Coverage, 59292,
     /* 2241717 */     GIR_EraseRootFromParent_Done,
     /* 2241718 */   // Label 29883: @2241718
     /* 2241718 */   GIM_Try, /*On fail goto*//*Label 29884*/ GIMT_Encode4(2241763), // Rule ID 59293 //
     /* 2241723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241726 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2241729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2241743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241762 */     // GIR_Coverage, 59293,
     /* 2241762 */     GIR_EraseRootFromParent_Done,
     /* 2241763 */   // Label 29884: @2241763
     /* 2241763 */   GIM_Reject,
     /* 2241764 */ // Label 29882: @2241764
     /* 2241764 */ GIM_Reject,
     /* 2241765 */ // Label 29834: @2241765
     /* 2241765 */ GIM_Try, /*On fail goto*//*Label 29885*/ GIMT_Encode4(2241879),
     /* 2241770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2241773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2241776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241788 */   GIM_Try, /*On fail goto*//*Label 29886*/ GIMT_Encode4(2241833), // Rule ID 59328 //
     /* 2241793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241796 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2241799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2241813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241832 */     // GIR_Coverage, 59328,
     /* 2241832 */     GIR_EraseRootFromParent_Done,
     /* 2241833 */   // Label 29886: @2241833
     /* 2241833 */   GIM_Try, /*On fail goto*//*Label 29887*/ GIMT_Encode4(2241878), // Rule ID 59329 //
     /* 2241838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241841 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2241844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2241858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241877 */     // GIR_Coverage, 59329,
     /* 2241877 */     GIR_EraseRootFromParent_Done,
     /* 2241878 */   // Label 29887: @2241878
     /* 2241878 */   GIM_Reject,
     /* 2241879 */ // Label 29885: @2241879
     /* 2241879 */ GIM_Reject,
     /* 2241880 */ // Label 29835: @2241880
     /* 2241880 */ GIM_Try, /*On fail goto*//*Label 29888*/ GIMT_Encode4(2241994),
     /* 2241885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2241888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2241891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241903 */   GIM_Try, /*On fail goto*//*Label 29889*/ GIMT_Encode4(2241948), // Rule ID 59344 //
     /* 2241908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2241911 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2241914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2241928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241947 */     // GIR_Coverage, 59344,
     /* 2241947 */     GIR_EraseRootFromParent_Done,
     /* 2241948 */   // Label 29889: @2241948
     /* 2241948 */   GIM_Try, /*On fail goto*//*Label 29890*/ GIMT_Encode4(2241993), // Rule ID 59345 //
     /* 2241953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2241956 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2241959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2241963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2241973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2241980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2241992 */     // GIR_Coverage, 59345,
     /* 2241992 */     GIR_EraseRootFromParent_Done,
     /* 2241993 */   // Label 29890: @2241993
     /* 2241993 */   GIM_Reject,
     /* 2241994 */ // Label 29888: @2241994
     /* 2241994 */ GIM_Reject,
     /* 2241995 */ // Label 29836: @2241995
     /* 2241995 */ GIM_Try, /*On fail goto*//*Label 29891*/ GIMT_Encode4(2242109),
     /* 2242000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2242003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2242006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242018 */   GIM_Try, /*On fail goto*//*Label 29892*/ GIMT_Encode4(2242063), // Rule ID 59288 //
     /* 2242023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242026 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2242029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2242043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242062 */     // GIR_Coverage, 59288,
     /* 2242062 */     GIR_EraseRootFromParent_Done,
     /* 2242063 */   // Label 29892: @2242063
     /* 2242063 */   GIM_Try, /*On fail goto*//*Label 29893*/ GIMT_Encode4(2242108), // Rule ID 59289 //
     /* 2242068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242071 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2242074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2242088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242107 */     // GIR_Coverage, 59289,
     /* 2242107 */     GIR_EraseRootFromParent_Done,
     /* 2242108 */   // Label 29893: @2242108
     /* 2242108 */   GIM_Reject,
     /* 2242109 */ // Label 29891: @2242109
     /* 2242109 */ GIM_Reject,
     /* 2242110 */ // Label 29837: @2242110
     /* 2242110 */ GIM_Try, /*On fail goto*//*Label 29894*/ GIMT_Encode4(2242224),
     /* 2242115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2242118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2242121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242133 */   GIM_Try, /*On fail goto*//*Label 29895*/ GIMT_Encode4(2242178), // Rule ID 59316 //
     /* 2242138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242141 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2242144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2242158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242177 */     // GIR_Coverage, 59316,
     /* 2242177 */     GIR_EraseRootFromParent_Done,
     /* 2242178 */   // Label 29895: @2242178
     /* 2242178 */   GIM_Try, /*On fail goto*//*Label 29896*/ GIMT_Encode4(2242223), // Rule ID 59317 //
     /* 2242183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242186 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2242189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2242203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242222 */     // GIR_Coverage, 59317,
     /* 2242222 */     GIR_EraseRootFromParent_Done,
     /* 2242223 */   // Label 29896: @2242223
     /* 2242223 */   GIM_Reject,
     /* 2242224 */ // Label 29894: @2242224
     /* 2242224 */ GIM_Reject,
     /* 2242225 */ // Label 29838: @2242225
     /* 2242225 */ GIM_Try, /*On fail goto*//*Label 29897*/ GIMT_Encode4(2242339),
     /* 2242230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2242233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2242236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242244 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242248 */   GIM_Try, /*On fail goto*//*Label 29898*/ GIMT_Encode4(2242293), // Rule ID 59332 //
     /* 2242253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242256 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2242259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2242273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242292 */     // GIR_Coverage, 59332,
     /* 2242292 */     GIR_EraseRootFromParent_Done,
     /* 2242293 */   // Label 29898: @2242293
     /* 2242293 */   GIM_Try, /*On fail goto*//*Label 29899*/ GIMT_Encode4(2242338), // Rule ID 59333 //
     /* 2242298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242301 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2242304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2242318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242337 */     // GIR_Coverage, 59333,
     /* 2242337 */     GIR_EraseRootFromParent_Done,
     /* 2242338 */   // Label 29899: @2242338
     /* 2242338 */   GIM_Reject,
     /* 2242339 */ // Label 29897: @2242339
     /* 2242339 */ GIM_Reject,
     /* 2242340 */ // Label 29839: @2242340
     /* 2242340 */ GIM_Try, /*On fail goto*//*Label 29900*/ GIMT_Encode4(2242454),
     /* 2242345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2242348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2242351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242363 */   GIM_Try, /*On fail goto*//*Label 29901*/ GIMT_Encode4(2242408), // Rule ID 59348 //
     /* 2242368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2242371 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2242374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2242388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242407 */     // GIR_Coverage, 59348,
     /* 2242407 */     GIR_EraseRootFromParent_Done,
     /* 2242408 */   // Label 29901: @2242408
     /* 2242408 */   GIM_Try, /*On fail goto*//*Label 29902*/ GIMT_Encode4(2242453), // Rule ID 59349 //
     /* 2242413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2242416 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2242419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2242433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242452 */     // GIR_Coverage, 59349,
     /* 2242452 */     GIR_EraseRootFromParent_Done,
     /* 2242453 */   // Label 29902: @2242453
     /* 2242453 */   GIM_Reject,
     /* 2242454 */ // Label 29900: @2242454
     /* 2242454 */ GIM_Reject,
     /* 2242455 */ // Label 29840: @2242455
     /* 2242455 */ GIM_Try, /*On fail goto*//*Label 29903*/ GIMT_Encode4(2242569),
     /* 2242460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2242463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2242466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242478 */   GIM_Try, /*On fail goto*//*Label 29904*/ GIMT_Encode4(2242523), // Rule ID 59304 //
     /* 2242483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242486 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2242489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2242503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242522 */     // GIR_Coverage, 59304,
     /* 2242522 */     GIR_EraseRootFromParent_Done,
     /* 2242523 */   // Label 29904: @2242523
     /* 2242523 */   GIM_Try, /*On fail goto*//*Label 29905*/ GIMT_Encode4(2242568), // Rule ID 59305 //
     /* 2242528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242531 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2242534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2242548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242567 */     // GIR_Coverage, 59305,
     /* 2242567 */     GIR_EraseRootFromParent_Done,
     /* 2242568 */   // Label 29905: @2242568
     /* 2242568 */   GIM_Reject,
     /* 2242569 */ // Label 29903: @2242569
     /* 2242569 */ GIM_Reject,
     /* 2242570 */ // Label 29841: @2242570
     /* 2242570 */ GIM_Try, /*On fail goto*//*Label 29906*/ GIMT_Encode4(2242684),
     /* 2242575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2242578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2242581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242593 */   GIM_Try, /*On fail goto*//*Label 29907*/ GIMT_Encode4(2242638), // Rule ID 59320 //
     /* 2242598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242601 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2242604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2242618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242637 */     // GIR_Coverage, 59320,
     /* 2242637 */     GIR_EraseRootFromParent_Done,
     /* 2242638 */   // Label 29907: @2242638
     /* 2242638 */   GIM_Try, /*On fail goto*//*Label 29908*/ GIMT_Encode4(2242683), // Rule ID 59321 //
     /* 2242643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242646 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2242649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2242663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242682 */     // GIR_Coverage, 59321,
     /* 2242682 */     GIR_EraseRootFromParent_Done,
     /* 2242683 */   // Label 29908: @2242683
     /* 2242683 */   GIM_Reject,
     /* 2242684 */ // Label 29906: @2242684
     /* 2242684 */ GIM_Reject,
     /* 2242685 */ // Label 29842: @2242685
     /* 2242685 */ GIM_Try, /*On fail goto*//*Label 29909*/ GIMT_Encode4(2242799),
     /* 2242690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2242693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2242696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242708 */   GIM_Try, /*On fail goto*//*Label 29910*/ GIMT_Encode4(2242753), // Rule ID 59336 //
     /* 2242713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242716 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2242719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2242733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242752 */     // GIR_Coverage, 59336,
     /* 2242752 */     GIR_EraseRootFromParent_Done,
     /* 2242753 */   // Label 29910: @2242753
     /* 2242753 */   GIM_Try, /*On fail goto*//*Label 29911*/ GIMT_Encode4(2242798), // Rule ID 59337 //
     /* 2242758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242761 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2242764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2242778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242797 */     // GIR_Coverage, 59337,
     /* 2242797 */     GIR_EraseRootFromParent_Done,
     /* 2242798 */   // Label 29911: @2242798
     /* 2242798 */   GIM_Reject,
     /* 2242799 */ // Label 29909: @2242799
     /* 2242799 */ GIM_Reject,
     /* 2242800 */ // Label 29843: @2242800
     /* 2242800 */ GIM_Try, /*On fail goto*//*Label 29912*/ GIMT_Encode4(2242914),
     /* 2242805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2242808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2242811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242823 */   GIM_Try, /*On fail goto*//*Label 29913*/ GIMT_Encode4(2242868), // Rule ID 59308 //
     /* 2242828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242831 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2242834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2242848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242867 */     // GIR_Coverage, 59308,
     /* 2242867 */     GIR_EraseRootFromParent_Done,
     /* 2242868 */   // Label 29913: @2242868
     /* 2242868 */   GIM_Try, /*On fail goto*//*Label 29914*/ GIMT_Encode4(2242913), // Rule ID 59309 //
     /* 2242873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242876 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2242879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2242893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242912 */     // GIR_Coverage, 59309,
     /* 2242912 */     GIR_EraseRootFromParent_Done,
     /* 2242913 */   // Label 29914: @2242913
     /* 2242913 */   GIM_Reject,
     /* 2242914 */ // Label 29912: @2242914
     /* 2242914 */ GIM_Reject,
     /* 2242915 */ // Label 29844: @2242915
     /* 2242915 */ GIM_Try, /*On fail goto*//*Label 29915*/ GIMT_Encode4(2243029),
     /* 2242920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2242923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2242926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242934 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242938 */   GIM_Try, /*On fail goto*//*Label 29916*/ GIMT_Encode4(2242983), // Rule ID 59324 //
     /* 2242943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242946 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2242949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2242963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2242970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2242982 */     // GIR_Coverage, 59324,
     /* 2242982 */     GIR_EraseRootFromParent_Done,
     /* 2242983 */   // Label 29916: @2242983
     /* 2242983 */   GIM_Try, /*On fail goto*//*Label 29917*/ GIMT_Encode4(2243028), // Rule ID 59325 //
     /* 2242988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242991 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2242994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2242998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2243008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243027 */     // GIR_Coverage, 59325,
     /* 2243027 */     GIR_EraseRootFromParent_Done,
     /* 2243028 */   // Label 29917: @2243028
     /* 2243028 */   GIM_Reject,
     /* 2243029 */ // Label 29915: @2243029
     /* 2243029 */ GIM_Reject,
     /* 2243030 */ // Label 29845: @2243030
     /* 2243030 */ GIM_Try, /*On fail goto*//*Label 29918*/ GIMT_Encode4(2243144),
     /* 2243035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2243038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2243041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243053 */   GIM_Try, /*On fail goto*//*Label 29919*/ GIMT_Encode4(2243098), // Rule ID 59312 //
     /* 2243058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243061 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2243064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2243078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243097 */     // GIR_Coverage, 59312,
     /* 2243097 */     GIR_EraseRootFromParent_Done,
     /* 2243098 */   // Label 29919: @2243098
     /* 2243098 */   GIM_Try, /*On fail goto*//*Label 29920*/ GIMT_Encode4(2243143), // Rule ID 59313 //
     /* 2243103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243106 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2243109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2243113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2243123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2243130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2243142 */     // GIR_Coverage, 59313,
     /* 2243142 */     GIR_EraseRootFromParent_Done,
     /* 2243143 */   // Label 29920: @2243143
     /* 2243143 */   GIM_Reject,
     /* 2243144 */ // Label 29918: @2243144
     /* 2243144 */ GIM_Reject,
     /* 2243145 */ // Label 29846: @2243145
     /* 2243145 */ GIM_Reject,
     /* 2243146 */ // Label 48: @2243146
     /* 2243146 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(33), /*)*//*default:*//*Label 29930*/ GIMT_Encode4(2269808),
     /* 2243157 */ /*GILLT_s32*//*Label 29921*/ GIMT_Encode4(2243277),
     /* 2243161 */ /*GILLT_s64*//*Label 29922*/ GIMT_Encode4(2246071),
     /* 2243165 */ /*GILLT_nxv1s1*//*Label 29923*/ GIMT_Encode4(2248865), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2243185 */ /*GILLT_nxv2s1*//*Label 29924*/ GIMT_Encode4(2252706), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2243205 */ /*GILLT_nxv4s1*//*Label 29925*/ GIMT_Encode4(2256547), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2243225 */ /*GILLT_nxv8s1*//*Label 29926*/ GIMT_Encode4(2260388), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2243245 */ /*GILLT_nxv16s1*//*Label 29927*/ GIMT_Encode4(2264229), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2243261 */ /*GILLT_nxv32s1*//*Label 29928*/ GIMT_Encode4(2267110), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2243273 */ /*GILLT_nxv64s1*//*Label 29929*/ GIMT_Encode4(2269031),
     /* 2243277 */ // Label 29921: @2243277
     /* 2243277 */ GIM_Try, /*On fail goto*//*Label 29931*/ GIMT_Encode4(2243320), // Rule ID 159 //
     /* 2243282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2243285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2243288 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2243291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243295 */   // MIs[0] Operand 1
     /* 2243295 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243300 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243304 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2243308 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] })
     /* 2243308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243313 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243319 */   // GIR_Coverage, 159,
     /* 2243319 */   GIR_EraseRootFromParent_Done,
     /* 2243320 */ // Label 29931: @2243320
     /* 2243320 */ GIM_Try, /*On fail goto*//*Label 29932*/ GIMT_Encode4(2243363), // Rule ID 65226 //
     /* 2243325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2243328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2243331 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2243334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243338 */   // MIs[0] Operand 1
     /* 2243338 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243347 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243351 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2243351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243356 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243361 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243362 */   // GIR_Coverage, 65226,
     /* 2243362 */   GIR_EraseRootFromParent_Done,
     /* 2243363 */ // Label 29932: @2243363
     /* 2243363 */ GIM_Try, /*On fail goto*//*Label 29933*/ GIMT_Encode4(2243409), // Rule ID 65232 //
     /* 2243368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2243371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2243374 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2243377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243381 */   // MIs[0] Operand 1
     /* 2243381 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243386 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243390 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243394 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2243394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243399 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243405 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243407 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243408 */   // GIR_Coverage, 65232,
     /* 2243408 */   GIR_EraseRootFromParent_Done,
     /* 2243409 */ // Label 29933: @2243409
     /* 2243409 */ GIM_Try, /*On fail goto*//*Label 29934*/ GIMT_Encode4(2243452), // Rule ID 65262 //
     /* 2243414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2243417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2243420 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2243423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243427 */   // MIs[0] Operand 1
     /* 2243427 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243436 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243440 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2243440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243445 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243450 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243451 */   // GIR_Coverage, 65262,
     /* 2243451 */   GIR_EraseRootFromParent_Done,
     /* 2243452 */ // Label 29934: @2243452
     /* 2243452 */ GIM_Try, /*On fail goto*//*Label 29935*/ GIMT_Encode4(2243498), // Rule ID 65268 //
     /* 2243457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2243460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2243463 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2243466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243470 */   // MIs[0] Operand 1
     /* 2243470 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243479 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243483 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2243483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243488 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243494 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243496 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243497 */   // GIR_Coverage, 65268,
     /* 2243497 */   GIR_EraseRootFromParent_Done,
     /* 2243498 */ // Label 29935: @2243498
     /* 2243498 */ GIM_Try, /*On fail goto*//*Label 29936*/ GIMT_Encode4(2243551), // Rule ID 149 //
     /* 2243503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2243506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2243509 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2243512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243516 */   // MIs[0] Operand 1
     /* 2243516 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243525 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243529 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243533 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243537 */   // MIs[1] Operand 1
     /* 2243537 */   // No operand predicates
     /* 2243537 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243539 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2243539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243544 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243546 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2243549 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243550 */   // GIR_Coverage, 149,
     /* 2243550 */   GIR_EraseRootFromParent_Done,
     /* 2243551 */ // Label 29936: @2243551
     /* 2243551 */ GIM_Try, /*On fail goto*//*Label 29937*/ GIMT_Encode4(2243604), // Rule ID 153 //
     /* 2243556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2243559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2243562 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2243565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243569 */   // MIs[0] Operand 1
     /* 2243569 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2243574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243578 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243582 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243586 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243590 */   // MIs[1] Operand 1
     /* 2243590 */   // No operand predicates
     /* 2243590 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243592 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2243592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243597 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243599 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2243602 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243603 */   // GIR_Coverage, 153,
     /* 2243603 */   GIR_EraseRootFromParent_Done,
     /* 2243604 */ // Label 29937: @2243604
     /* 2243604 */ GIM_Try, /*On fail goto*//*Label 29938*/ GIMT_Encode4(2243657), // Rule ID 65218 //
     /* 2243609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2243612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2243615 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2243618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243622 */   // MIs[0] Operand 1
     /* 2243622 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2243627 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243631 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243635 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243639 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243643 */   // MIs[1] Operand 1
     /* 2243643 */   // No operand predicates
     /* 2243643 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243645 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2243645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243650 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243652 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2243655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243656 */   // GIR_Coverage, 65218,
     /* 2243656 */   GIR_EraseRootFromParent_Done,
     /* 2243657 */ // Label 29938: @2243657
     /* 2243657 */ GIM_Try, /*On fail goto*//*Label 29939*/ GIMT_Encode4(2243710), // Rule ID 65222 //
     /* 2243662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2243665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2243668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2243671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243675 */   // MIs[0] Operand 1
     /* 2243675 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243684 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243688 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243692 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243696 */   // MIs[1] Operand 1
     /* 2243696 */   // No operand predicates
     /* 2243696 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243698 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2243698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243703 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243705 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2243708 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243709 */   // GIR_Coverage, 65222,
     /* 2243709 */   GIR_EraseRootFromParent_Done,
     /* 2243710 */ // Label 29939: @2243710
     /* 2243710 */ GIM_Try, /*On fail goto*//*Label 29940*/ GIMT_Encode4(2243787), // Rule ID 65228 //
     /* 2243715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2243718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2243721 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2243724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243728 */   // MIs[0] Operand 1
     /* 2243728 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243733 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243737 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243745 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2243749 */   // MIs[1] Operand 1
     /* 2243749 */   // No operand predicates
     /* 2243749 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243751 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2243751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2243758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243763 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243767 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2243772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243785 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243786 */   // GIR_Coverage, 65228,
     /* 2243786 */   GIR_EraseRootFromParent_Done,
     /* 2243787 */ // Label 29940: @2243787
     /* 2243787 */ GIM_Try, /*On fail goto*//*Label 29941*/ GIMT_Encode4(2243867), // Rule ID 65234 //
     /* 2243792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2243795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2243798 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2243801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243805 */   // MIs[0] Operand 1
     /* 2243805 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243814 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243818 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243822 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2243826 */   // MIs[1] Operand 1
     /* 2243826 */   // No operand predicates
     /* 2243826 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243828 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2243828 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243831 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2243835 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243840 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243844 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2243849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243856 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243865 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243866 */   // GIR_Coverage, 65234,
     /* 2243866 */   GIR_EraseRootFromParent_Done,
     /* 2243867 */ // Label 29941: @2243867
     /* 2243867 */ GIM_Try, /*On fail goto*//*Label 29942*/ GIMT_Encode4(2243944), // Rule ID 65238 //
     /* 2243872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2243875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2243878 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2243881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243885 */   // MIs[0] Operand 1
     /* 2243885 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2243890 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243894 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243898 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243902 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2243906 */   // MIs[1] Operand 1
     /* 2243906 */   // No operand predicates
     /* 2243906 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243908 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2243908 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243911 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243915 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243920 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243924 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243936 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243942 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243943 */   // GIR_Coverage, 65238,
     /* 2243943 */   GIR_EraseRootFromParent_Done,
     /* 2243944 */ // Label 29942: @2243944
     /* 2243944 */ GIM_Try, /*On fail goto*//*Label 29943*/ GIMT_Encode4(2244021), // Rule ID 65242 //
     /* 2243949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2243952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2243955 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2243958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243962 */   // MIs[0] Operand 1
     /* 2243962 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2243967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243971 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243975 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243979 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2243983 */   // MIs[1] Operand 1
     /* 2243983 */   // No operand predicates
     /* 2243983 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243985 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2243985 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243988 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243992 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243997 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244001 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244013 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244020 */   // GIR_Coverage, 65242,
     /* 2244020 */   GIR_EraseRootFromParent_Done,
     /* 2244021 */ // Label 29943: @2244021
     /* 2244021 */ GIM_Try, /*On fail goto*//*Label 29944*/ GIMT_Encode4(2244096), // Rule ID 65246 //
     /* 2244026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244032 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244039 */   // MIs[0] Operand 1
     /* 2244039 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2244044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244048 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244052 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244056 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2244060 */   // MIs[1] Operand 1
     /* 2244060 */   // No operand predicates
     /* 2244060 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244062 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2244062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244074 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244078 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2244081 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244088 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244094 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244095 */   // GIR_Coverage, 65246,
     /* 2244095 */   GIR_EraseRootFromParent_Done,
     /* 2244096 */ // Label 29944: @2244096
     /* 2244096 */ GIM_Try, /*On fail goto*//*Label 29945*/ GIMT_Encode4(2244171), // Rule ID 65250 //
     /* 2244101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2244107 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244114 */   // MIs[0] Operand 1
     /* 2244114 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2244119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244123 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244127 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244131 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2244135 */   // MIs[1] Operand 1
     /* 2244135 */   // No operand predicates
     /* 2244135 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244137 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2244137 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244140 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244144 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244149 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244153 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2244156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244170 */   // GIR_Coverage, 65250,
     /* 2244170 */   GIR_EraseRootFromParent_Done,
     /* 2244171 */ // Label 29945: @2244171
     /* 2244171 */ GIM_Try, /*On fail goto*//*Label 29946*/ GIMT_Encode4(2244226), // Rule ID 65254 //
     /* 2244176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2244182 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244189 */   // MIs[0] Operand 1
     /* 2244189 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244198 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244202 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244206 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2244210 */   // MIs[1] Operand 1
     /* 2244210 */   // No operand predicates
     /* 2244210 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244212 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2244212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244217 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244219 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244224 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244225 */   // GIR_Coverage, 65254,
     /* 2244225 */   GIR_EraseRootFromParent_Done,
     /* 2244226 */ // Label 29946: @2244226
     /* 2244226 */ GIM_Try, /*On fail goto*//*Label 29947*/ GIMT_Encode4(2244281), // Rule ID 65258 //
     /* 2244231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2244237 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244244 */   // MIs[0] Operand 1
     /* 2244244 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244261 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2244265 */   // MIs[1] Operand 1
     /* 2244265 */   // No operand predicates
     /* 2244265 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244267 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2244267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244272 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244274 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244279 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244280 */   // GIR_Coverage, 65258,
     /* 2244280 */   GIR_EraseRootFromParent_Done,
     /* 2244281 */ // Label 29947: @2244281
     /* 2244281 */ GIM_Try, /*On fail goto*//*Label 29948*/ GIMT_Encode4(2244358), // Rule ID 65264 //
     /* 2244286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244292 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244299 */   // MIs[0] Operand 1
     /* 2244299 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2244304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244316 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2244320 */   // MIs[1] Operand 1
     /* 2244320 */   // No operand predicates
     /* 2244320 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244322 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2244322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2244329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244334 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244338 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2244343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244357 */   // GIR_Coverage, 65264,
     /* 2244357 */   GIR_EraseRootFromParent_Done,
     /* 2244358 */ // Label 29948: @2244358
     /* 2244358 */ GIM_Try, /*On fail goto*//*Label 29949*/ GIMT_Encode4(2244438), // Rule ID 65270 //
     /* 2244363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244369 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244376 */   // MIs[0] Operand 1
     /* 2244376 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2244381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244385 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244389 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244393 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2244397 */   // MIs[1] Operand 1
     /* 2244397 */   // No operand predicates
     /* 2244397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244399 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2244399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2244406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244411 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244415 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2244420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244427 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2244433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244437 */   // GIR_Coverage, 65270,
     /* 2244437 */   GIR_EraseRootFromParent_Done,
     /* 2244438 */ // Label 29949: @2244438
     /* 2244438 */ GIM_Try, /*On fail goto*//*Label 29950*/ GIMT_Encode4(2244515), // Rule ID 65274 //
     /* 2244443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244456 */   // MIs[0] Operand 1
     /* 2244456 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244465 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244469 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244473 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2244477 */   // MIs[1] Operand 1
     /* 2244477 */   // No operand predicates
     /* 2244477 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244479 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2244479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244491 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244495 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244513 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244514 */   // GIR_Coverage, 65274,
     /* 2244514 */   GIR_EraseRootFromParent_Done,
     /* 2244515 */ // Label 29950: @2244515
     /* 2244515 */ GIM_Try, /*On fail goto*//*Label 29951*/ GIMT_Encode4(2244592), // Rule ID 65278 //
     /* 2244520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244526 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244533 */   // MIs[0] Operand 1
     /* 2244533 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244542 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244546 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244550 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2244554 */   // MIs[1] Operand 1
     /* 2244554 */   // No operand predicates
     /* 2244554 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244556 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2244556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244568 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244572 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244590 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244591 */   // GIR_Coverage, 65278,
     /* 2244591 */   GIR_EraseRootFromParent_Done,
     /* 2244592 */ // Label 29951: @2244592
     /* 2244592 */ GIM_Try, /*On fail goto*//*Label 29952*/ GIMT_Encode4(2244667), // Rule ID 65282 //
     /* 2244597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244603 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244610 */   // MIs[0] Operand 1
     /* 2244610 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2244615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244627 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2244631 */   // MIs[1] Operand 1
     /* 2244631 */   // No operand predicates
     /* 2244631 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244633 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2244633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244645 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244649 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2244652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244659 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244665 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244666 */   // GIR_Coverage, 65282,
     /* 2244666 */   GIR_EraseRootFromParent_Done,
     /* 2244667 */ // Label 29952: @2244667
     /* 2244667 */ GIM_Try, /*On fail goto*//*Label 29953*/ GIMT_Encode4(2244742), // Rule ID 65286 //
     /* 2244672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244678 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244685 */   // MIs[0] Operand 1
     /* 2244685 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2244690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244694 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244698 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244702 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2244706 */   // MIs[1] Operand 1
     /* 2244706 */   // No operand predicates
     /* 2244706 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244708 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2244708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244720 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244724 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2244727 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244734 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244740 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244741 */   // GIR_Coverage, 65286,
     /* 2244741 */   GIR_EraseRootFromParent_Done,
     /* 2244742 */ // Label 29953: @2244742
     /* 2244742 */ GIM_Try, /*On fail goto*//*Label 29954*/ GIMT_Encode4(2244797), // Rule ID 65290 //
     /* 2244747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244753 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244760 */   // MIs[0] Operand 1
     /* 2244760 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244769 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244773 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244777 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2244781 */   // MIs[1] Operand 1
     /* 2244781 */   // No operand predicates
     /* 2244781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244783 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2244783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244788 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244790 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244795 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244796 */   // GIR_Coverage, 65290,
     /* 2244796 */   GIR_EraseRootFromParent_Done,
     /* 2244797 */ // Label 29954: @2244797
     /* 2244797 */ GIM_Try, /*On fail goto*//*Label 29955*/ GIMT_Encode4(2244852), // Rule ID 65294 //
     /* 2244802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244808 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244815 */   // MIs[0] Operand 1
     /* 2244815 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244824 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244828 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244832 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2244836 */   // MIs[1] Operand 1
     /* 2244836 */   // No operand predicates
     /* 2244836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244838 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2244838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244843 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244845 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244850 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244851 */   // GIR_Coverage, 65294,
     /* 2244851 */   GIR_EraseRootFromParent_Done,
     /* 2244852 */ // Label 29955: @2244852
     /* 2244852 */ GIM_Try, /*On fail goto*//*Label 29956*/ GIMT_Encode4(2244894), // Rule ID 64450 //
     /* 2244857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2244860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244863 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244870 */   // MIs[0] Operand 1
     /* 2244870 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244875 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244879 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244883 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2244883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2244886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244888 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244890 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244892 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244893 */   // GIR_Coverage, 64450,
     /* 2244893 */   GIR_EraseRootFromParent_Done,
     /* 2244894 */ // Label 29956: @2244894
     /* 2244894 */ GIM_Try, /*On fail goto*//*Label 29957*/ GIMT_Encode4(2244936), // Rule ID 64452 //
     /* 2244899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2244902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244905 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244912 */   // MIs[0] Operand 1
     /* 2244912 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244917 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244921 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244925 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2244925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2244928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244930 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244932 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244935 */   // GIR_Coverage, 64452,
     /* 2244935 */   GIR_EraseRootFromParent_Done,
     /* 2244936 */ // Label 29957: @2244936
     /* 2244936 */ GIM_Try, /*On fail goto*//*Label 29958*/ GIMT_Encode4(2244978), // Rule ID 147 //
     /* 2244941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244947 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244954 */   // MIs[0] Operand 1
     /* 2244954 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2244959 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244963 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244967 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2244967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244972 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244974 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244976 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244977 */   // GIR_Coverage, 147,
     /* 2244977 */   GIR_EraseRootFromParent_Done,
     /* 2244978 */ // Label 29958: @2244978
     /* 2244978 */ GIM_Try, /*On fail goto*//*Label 29959*/ GIMT_Encode4(2245020), // Rule ID 151 //
     /* 2244983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2244986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2244989 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2244992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244996 */   // MIs[0] Operand 1
     /* 2244996 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2245001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245005 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245009 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2245009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245014 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245016 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245018 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245019 */   // GIR_Coverage, 151,
     /* 2245019 */   GIR_EraseRootFromParent_Done,
     /* 2245020 */ // Label 29959: @2245020
     /* 2245020 */ GIM_Try, /*On fail goto*//*Label 29960*/ GIMT_Encode4(2245062), // Rule ID 65220 //
     /* 2245025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2245031 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2245034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245038 */   // MIs[0] Operand 1
     /* 2245038 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2245043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245047 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245051 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2245051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245056 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245058 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245061 */   // GIR_Coverage, 65220,
     /* 2245061 */   GIR_EraseRootFromParent_Done,
     /* 2245062 */ // Label 29960: @2245062
     /* 2245062 */ GIM_Try, /*On fail goto*//*Label 29961*/ GIMT_Encode4(2245104), // Rule ID 65224 //
     /* 2245067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2245073 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2245076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245080 */   // MIs[0] Operand 1
     /* 2245080 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2245085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245089 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245093 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2245093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245098 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245100 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245102 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245103 */   // GIR_Coverage, 65224,
     /* 2245103 */   GIR_EraseRootFromParent_Done,
     /* 2245104 */ // Label 29961: @2245104
     /* 2245104 */ GIM_Try, /*On fail goto*//*Label 29962*/ GIMT_Encode4(2245170), // Rule ID 65230 //
     /* 2245109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2245115 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2245118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245122 */   // MIs[0] Operand 1
     /* 2245122 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245131 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245135 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2245135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2245142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245147 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245151 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2245160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245162 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245168 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245169 */   // GIR_Coverage, 65230,
     /* 2245169 */   GIR_EraseRootFromParent_Done,
     /* 2245170 */ // Label 29962: @2245170
     /* 2245170 */ GIM_Try, /*On fail goto*//*Label 29963*/ GIMT_Encode4(2245239), // Rule ID 65236 //
     /* 2245175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2245181 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2245184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245188 */   // MIs[0] Operand 1
     /* 2245188 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245197 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245201 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2245201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2245208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245213 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245217 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245228 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2245234 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245237 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245238 */   // GIR_Coverage, 65236,
     /* 2245238 */   GIR_EraseRootFromParent_Done,
     /* 2245239 */ // Label 29963: @2245239
     /* 2245239 */ GIM_Try, /*On fail goto*//*Label 29964*/ GIMT_Encode4(2245281), // Rule ID 65240 //
     /* 2245244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2245250 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2245253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245257 */   // MIs[0] Operand 1
     /* 2245257 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245266 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245270 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2245270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245275 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245277 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245279 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245280 */   // GIR_Coverage, 65240,
     /* 2245280 */   GIR_EraseRootFromParent_Done,
     /* 2245281 */ // Label 29964: @2245281
     /* 2245281 */ GIM_Try, /*On fail goto*//*Label 29965*/ GIMT_Encode4(2245323), // Rule ID 65244 //
     /* 2245286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2245292 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2245295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245299 */   // MIs[0] Operand 1
     /* 2245299 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2245304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245308 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245312 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2245312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245317 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245319 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245321 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245322 */   // GIR_Coverage, 65244,
     /* 2245322 */   GIR_EraseRootFromParent_Done,
     /* 2245323 */ // Label 29965: @2245323
     /* 2245323 */ GIM_Try, /*On fail goto*//*Label 29966*/ GIMT_Encode4(2245389), // Rule ID 65248 //
     /* 2245328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2245334 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2245337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245341 */   // MIs[0] Operand 1
     /* 2245341 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2245346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245350 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245354 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2245354 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245357 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245361 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245366 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245370 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245387 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245388 */   // GIR_Coverage, 65248,
     /* 2245388 */   GIR_EraseRootFromParent_Done,
     /* 2245389 */ // Label 29966: @2245389
     /* 2245389 */ GIM_Try, /*On fail goto*//*Label 29967*/ GIMT_Encode4(2245455), // Rule ID 65252 //
     /* 2245394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2245400 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2245403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245407 */   // MIs[0] Operand 1
     /* 2245407 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245416 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245420 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2245420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245432 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245436 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245454 */   // GIR_Coverage, 65252,
     /* 2245454 */   GIR_EraseRootFromParent_Done,
     /* 2245455 */ // Label 29967: @2245455
     /* 2245455 */ GIM_Try, /*On fail goto*//*Label 29968*/ GIMT_Encode4(2245521), // Rule ID 65256 //
     /* 2245460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2245466 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2245469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245473 */   // MIs[0] Operand 1
     /* 2245473 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245482 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245486 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2245486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245498 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245502 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245513 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245519 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245520 */   // GIR_Coverage, 65256,
     /* 2245520 */   GIR_EraseRootFromParent_Done,
     /* 2245521 */ // Label 29968: @2245521
     /* 2245521 */ GIM_Try, /*On fail goto*//*Label 29969*/ GIMT_Encode4(2245587), // Rule ID 65260 //
     /* 2245526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2245532 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2245535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245539 */   // MIs[0] Operand 1
     /* 2245539 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245548 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245552 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2245552 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245555 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245559 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245564 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245568 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245585 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245586 */   // GIR_Coverage, 65260,
     /* 2245586 */   GIR_EraseRootFromParent_Done,
     /* 2245587 */ // Label 29969: @2245587
     /* 2245587 */ GIM_Try, /*On fail goto*//*Label 29970*/ GIMT_Encode4(2245653), // Rule ID 65266 //
     /* 2245592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2245598 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2245601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245605 */   // MIs[0] Operand 1
     /* 2245605 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245614 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245618 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2245618 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245621 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2245625 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245630 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245634 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2245643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245645 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245651 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245652 */   // GIR_Coverage, 65266,
     /* 2245652 */   GIR_EraseRootFromParent_Done,
     /* 2245653 */ // Label 29970: @2245653
     /* 2245653 */ GIM_Try, /*On fail goto*//*Label 29971*/ GIMT_Encode4(2245722), // Rule ID 65272 //
     /* 2245658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2245664 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2245667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245671 */   // MIs[0] Operand 1
     /* 2245671 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245676 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245680 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245684 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2245684 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245687 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2245691 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245696 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245700 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245711 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2245717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245720 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245721 */   // GIR_Coverage, 65272,
     /* 2245721 */   GIR_EraseRootFromParent_Done,
     /* 2245722 */ // Label 29971: @2245722
     /* 2245722 */ GIM_Try, /*On fail goto*//*Label 29972*/ GIMT_Encode4(2245764), // Rule ID 65276 //
     /* 2245727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2245733 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2245736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245740 */   // MIs[0] Operand 1
     /* 2245740 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245749 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245753 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2245753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245758 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245760 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245762 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245763 */   // GIR_Coverage, 65276,
     /* 2245763 */   GIR_EraseRootFromParent_Done,
     /* 2245764 */ // Label 29972: @2245764
     /* 2245764 */ GIM_Try, /*On fail goto*//*Label 29973*/ GIMT_Encode4(2245806), // Rule ID 65280 //
     /* 2245769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2245775 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2245778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245782 */   // MIs[0] Operand 1
     /* 2245782 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2245787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245791 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245795 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2245795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245800 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245802 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245804 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245805 */   // GIR_Coverage, 65280,
     /* 2245805 */   GIR_EraseRootFromParent_Done,
     /* 2245806 */ // Label 29973: @2245806
     /* 2245806 */ GIM_Try, /*On fail goto*//*Label 29974*/ GIMT_Encode4(2245872), // Rule ID 65284 //
     /* 2245811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2245817 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2245820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245824 */   // MIs[0] Operand 1
     /* 2245824 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2245829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245833 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245837 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2245837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245849 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245853 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245871 */   // GIR_Coverage, 65284,
     /* 2245871 */   GIR_EraseRootFromParent_Done,
     /* 2245872 */ // Label 29974: @2245872
     /* 2245872 */ GIM_Try, /*On fail goto*//*Label 29975*/ GIMT_Encode4(2245938), // Rule ID 65288 //
     /* 2245877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2245883 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2245886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245890 */   // MIs[0] Operand 1
     /* 2245890 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245899 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245903 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2245903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245915 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245919 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245936 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245937 */   // GIR_Coverage, 65288,
     /* 2245937 */   GIR_EraseRootFromParent_Done,
     /* 2245938 */ // Label 29975: @2245938
     /* 2245938 */ GIM_Try, /*On fail goto*//*Label 29976*/ GIMT_Encode4(2246004), // Rule ID 65292 //
     /* 2245943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2245946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2245949 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2245952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245956 */   // MIs[0] Operand 1
     /* 2245956 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245965 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245969 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2245969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245981 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245985 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2246002 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246003 */   // GIR_Coverage, 65292,
     /* 2246003 */   GIR_EraseRootFromParent_Done,
     /* 2246004 */ // Label 29976: @2246004
     /* 2246004 */ GIM_Try, /*On fail goto*//*Label 29977*/ GIMT_Encode4(2246070), // Rule ID 65296 //
     /* 2246009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2246012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2246015 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2246018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246022 */   // MIs[0] Operand 1
     /* 2246022 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2246027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246031 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246035 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2246035 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2246038 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2246042 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246047 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2246051 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2246055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2246060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246062 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2246068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246069 */   // GIR_Coverage, 65296,
     /* 2246069 */   GIR_EraseRootFromParent_Done,
     /* 2246070 */ // Label 29977: @2246070
     /* 2246070 */ GIM_Reject,
     /* 2246071 */ // Label 29922: @2246071
     /* 2246071 */ GIM_Try, /*On fail goto*//*Label 29978*/ GIMT_Encode4(2246114), // Rule ID 158 //
     /* 2246076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2246082 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246089 */   // MIs[0] Operand 1
     /* 2246089 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246098 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2246102 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] })
     /* 2246102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2246105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246107 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246112 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246113 */   // GIR_Coverage, 158,
     /* 2246113 */   GIR_EraseRootFromParent_Done,
     /* 2246114 */ // Label 29978: @2246114
     /* 2246114 */ GIM_Try, /*On fail goto*//*Label 29979*/ GIMT_Encode4(2246157), // Rule ID 65225 //
     /* 2246119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2246125 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2246128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246132 */   // MIs[0] Operand 1
     /* 2246132 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246141 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2246145 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2246145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2246148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246150 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2246155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246156 */   // GIR_Coverage, 65225,
     /* 2246156 */   GIR_EraseRootFromParent_Done,
     /* 2246157 */ // Label 29979: @2246157
     /* 2246157 */ GIM_Try, /*On fail goto*//*Label 29980*/ GIMT_Encode4(2246203), // Rule ID 65231 //
     /* 2246162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2246168 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2246171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246175 */   // MIs[0] Operand 1
     /* 2246175 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246184 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2246188 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2246188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2246191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246193 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2246199 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246201 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246202 */   // GIR_Coverage, 65231,
     /* 2246202 */   GIR_EraseRootFromParent_Done,
     /* 2246203 */ // Label 29980: @2246203
     /* 2246203 */ GIM_Try, /*On fail goto*//*Label 29981*/ GIMT_Encode4(2246246), // Rule ID 65261 //
     /* 2246208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2246214 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246221 */   // MIs[0] Operand 1
     /* 2246221 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246230 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2246234 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2246234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2246237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246239 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2246244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246245 */   // GIR_Coverage, 65261,
     /* 2246245 */   GIR_EraseRootFromParent_Done,
     /* 2246246 */ // Label 29981: @2246246
     /* 2246246 */ GIM_Try, /*On fail goto*//*Label 29982*/ GIMT_Encode4(2246292), // Rule ID 65267 //
     /* 2246251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2246257 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246264 */   // MIs[0] Operand 1
     /* 2246264 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246273 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2246277 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2246277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2246280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246282 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2246288 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246291 */   // GIR_Coverage, 65267,
     /* 2246291 */   GIR_EraseRootFromParent_Done,
     /* 2246292 */ // Label 29982: @2246292
     /* 2246292 */ GIM_Try, /*On fail goto*//*Label 29983*/ GIMT_Encode4(2246345), // Rule ID 148 //
     /* 2246297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2246303 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246310 */   // MIs[0] Operand 1
     /* 2246310 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246319 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2246323 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2246327 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2246331 */   // MIs[1] Operand 1
     /* 2246331 */   // No operand predicates
     /* 2246331 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2246333 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2246333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2246336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246338 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246340 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2246343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246344 */   // GIR_Coverage, 148,
     /* 2246344 */   GIR_EraseRootFromParent_Done,
     /* 2246345 */ // Label 29983: @2246345
     /* 2246345 */ GIM_Try, /*On fail goto*//*Label 29984*/ GIMT_Encode4(2246398), // Rule ID 152 //
     /* 2246350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2246356 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246363 */   // MIs[0] Operand 1
     /* 2246363 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2246368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2246376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2246380 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2246384 */   // MIs[1] Operand 1
     /* 2246384 */   // No operand predicates
     /* 2246384 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2246386 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2246386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2246389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246391 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246393 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2246396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246397 */   // GIR_Coverage, 152,
     /* 2246397 */   GIR_EraseRootFromParent_Done,
     /* 2246398 */ // Label 29984: @2246398
     /* 2246398 */ GIM_Try, /*On fail goto*//*Label 29985*/ GIMT_Encode4(2246451), // Rule ID 65217 //
     /* 2246403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2246409 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246416 */   // MIs[0] Operand 1
     /* 2246416 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2246421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246425 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2246429 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2246433 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2246437 */   // MIs[1] Operand 1
     /* 2246437 */   // No operand predicates
     /* 2246437 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2246439 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2246439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2246442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246444 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246446 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2246449 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246450 */   // GIR_Coverage, 65217,
     /* 2246450 */   GIR_EraseRootFromParent_Done,
     /* 2246451 */ // Label 29985: @2246451
     /* 2246451 */ GIM_Try, /*On fail goto*//*Label 29986*/ GIMT_Encode4(2246504), // Rule ID 65221 //
     /* 2246456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2246462 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246469 */   // MIs[0] Operand 1
     /* 2246469 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246478 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2246482 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2246486 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2246490 */   // MIs[1] Operand 1
     /* 2246490 */   // No operand predicates
     /* 2246490 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2246492 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2246492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2246495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246497 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246499 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2246502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246503 */   // GIR_Coverage, 65221,
     /* 2246503 */   GIR_EraseRootFromParent_Done,
     /* 2246504 */ // Label 29986: @2246504
     /* 2246504 */ GIM_Try, /*On fail goto*//*Label 29987*/ GIMT_Encode4(2246581), // Rule ID 65227 //
     /* 2246509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2246515 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246522 */   // MIs[0] Operand 1
     /* 2246522 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246531 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2246535 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2246539 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2246543 */   // MIs[1] Operand 1
     /* 2246543 */   // No operand predicates
     /* 2246543 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2246545 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2246545 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2246548 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2246552 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246557 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2246561 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2246566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2246571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2246579 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246580 */   // GIR_Coverage, 65227,
     /* 2246580 */   GIR_EraseRootFromParent_Done,
     /* 2246581 */ // Label 29987: @2246581
     /* 2246581 */ GIM_Try, /*On fail goto*//*Label 29988*/ GIMT_Encode4(2246661), // Rule ID 65233 //
     /* 2246586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2246592 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246599 */   // MIs[0] Operand 1
     /* 2246599 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246608 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2246612 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2246616 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2246620 */   // MIs[1] Operand 1
     /* 2246620 */   // No operand predicates
     /* 2246620 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2246622 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2246622 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2246625 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2246629 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246634 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2246638 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2246643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2246648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246650 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2246656 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246659 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246660 */   // GIR_Coverage, 65233,
     /* 2246660 */   GIR_EraseRootFromParent_Done,
     /* 2246661 */ // Label 29988: @2246661
     /* 2246661 */ GIM_Try, /*On fail goto*//*Label 29989*/ GIMT_Encode4(2246738), // Rule ID 65237 //
     /* 2246666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2246672 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246679 */   // MIs[0] Operand 1
     /* 2246679 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2246684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246688 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2246692 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2246696 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2246700 */   // MIs[1] Operand 1
     /* 2246700 */   // No operand predicates
     /* 2246700 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2246702 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2246702 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2246705 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2246709 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246714 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2246718 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2246723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2246728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2246736 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246737 */   // GIR_Coverage, 65237,
     /* 2246737 */   GIR_EraseRootFromParent_Done,
     /* 2246738 */ // Label 29989: @2246738
     /* 2246738 */ GIM_Try, /*On fail goto*//*Label 29990*/ GIMT_Encode4(2246815), // Rule ID 65241 //
     /* 2246743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2246749 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246756 */   // MIs[0] Operand 1
     /* 2246756 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246765 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2246769 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2246773 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2246777 */   // MIs[1] Operand 1
     /* 2246777 */   // No operand predicates
     /* 2246777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2246779 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2246779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2246782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2246786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246791 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2246795 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2246800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2246805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2246813 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246814 */   // GIR_Coverage, 65241,
     /* 2246814 */   GIR_EraseRootFromParent_Done,
     /* 2246815 */ // Label 29990: @2246815
     /* 2246815 */ GIM_Try, /*On fail goto*//*Label 29991*/ GIMT_Encode4(2246890), // Rule ID 65245 //
     /* 2246820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2246826 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246833 */   // MIs[0] Operand 1
     /* 2246833 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2246846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2246850 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2246854 */   // MIs[1] Operand 1
     /* 2246854 */   // No operand predicates
     /* 2246854 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2246856 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2246856 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2246859 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2246863 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246868 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2246872 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2246875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2246880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246882 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2246888 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246889 */   // GIR_Coverage, 65245,
     /* 2246889 */   GIR_EraseRootFromParent_Done,
     /* 2246890 */ // Label 29991: @2246890
     /* 2246890 */ GIM_Try, /*On fail goto*//*Label 29992*/ GIMT_Encode4(2246965), // Rule ID 65249 //
     /* 2246895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2246901 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246908 */   // MIs[0] Operand 1
     /* 2246908 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2246913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246917 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2246921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2246925 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2246929 */   // MIs[1] Operand 1
     /* 2246929 */   // No operand predicates
     /* 2246929 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2246931 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2246931 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2246934 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2246938 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2246943 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2246947 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2246950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2246952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2246955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246957 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2246960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2246963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246964 */   // GIR_Coverage, 65249,
     /* 2246964 */   GIR_EraseRootFromParent_Done,
     /* 2246965 */ // Label 29992: @2246965
     /* 2246965 */ GIM_Try, /*On fail goto*//*Label 29993*/ GIMT_Encode4(2247020), // Rule ID 65253 //
     /* 2246970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2246973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2246976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2246979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246983 */   // MIs[0] Operand 1
     /* 2246983 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2246988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2246992 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2246996 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2247000 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2247004 */   // MIs[1] Operand 1
     /* 2247004 */   // No operand predicates
     /* 2247004 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2247006 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2247006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2247009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247011 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247013 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2247018 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247019 */   // GIR_Coverage, 65253,
     /* 2247019 */   GIR_EraseRootFromParent_Done,
     /* 2247020 */ // Label 29993: @2247020
     /* 2247020 */ GIM_Try, /*On fail goto*//*Label 29994*/ GIMT_Encode4(2247075), // Rule ID 65257 //
     /* 2247025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2247031 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2247034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247038 */   // MIs[0] Operand 1
     /* 2247038 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247047 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2247051 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2247055 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2247059 */   // MIs[1] Operand 1
     /* 2247059 */   // No operand predicates
     /* 2247059 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2247061 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2247061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2247064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247066 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247068 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2247073 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247074 */   // GIR_Coverage, 65257,
     /* 2247074 */   GIR_EraseRootFromParent_Done,
     /* 2247075 */ // Label 29994: @2247075
     /* 2247075 */ GIM_Try, /*On fail goto*//*Label 29995*/ GIMT_Encode4(2247152), // Rule ID 65263 //
     /* 2247080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2247086 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2247089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247093 */   // MIs[0] Operand 1
     /* 2247093 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2247098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247102 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2247106 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2247110 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2247114 */   // MIs[1] Operand 1
     /* 2247114 */   // No operand predicates
     /* 2247114 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2247116 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2247116 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2247119 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2247123 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247128 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2247132 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2247137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2247142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2247150 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247151 */   // GIR_Coverage, 65263,
     /* 2247151 */   GIR_EraseRootFromParent_Done,
     /* 2247152 */ // Label 29995: @2247152
     /* 2247152 */ GIM_Try, /*On fail goto*//*Label 29996*/ GIMT_Encode4(2247232), // Rule ID 65269 //
     /* 2247157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2247163 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2247166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247170 */   // MIs[0] Operand 1
     /* 2247170 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2247175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247179 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2247183 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2247187 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2247191 */   // MIs[1] Operand 1
     /* 2247191 */   // No operand predicates
     /* 2247191 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2247193 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2247193 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2247196 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2247200 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247205 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2247209 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2247214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2247219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247221 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2247227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247230 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247231 */   // GIR_Coverage, 65269,
     /* 2247231 */   GIR_EraseRootFromParent_Done,
     /* 2247232 */ // Label 29996: @2247232
     /* 2247232 */ GIM_Try, /*On fail goto*//*Label 29997*/ GIMT_Encode4(2247309), // Rule ID 65273 //
     /* 2247237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2247243 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2247246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247250 */   // MIs[0] Operand 1
     /* 2247250 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247259 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2247263 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2247267 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2247271 */   // MIs[1] Operand 1
     /* 2247271 */   // No operand predicates
     /* 2247271 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2247273 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2247273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2247276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2247280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247285 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2247289 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2247294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2247299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2247307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247308 */   // GIR_Coverage, 65273,
     /* 2247308 */   GIR_EraseRootFromParent_Done,
     /* 2247309 */ // Label 29997: @2247309
     /* 2247309 */ GIM_Try, /*On fail goto*//*Label 29998*/ GIMT_Encode4(2247386), // Rule ID 65277 //
     /* 2247314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2247320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2247323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247327 */   // MIs[0] Operand 1
     /* 2247327 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247336 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2247340 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2247344 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2247348 */   // MIs[1] Operand 1
     /* 2247348 */   // No operand predicates
     /* 2247348 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2247350 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2247350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2247353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2247357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247362 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2247366 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2247371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2247376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2247384 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247385 */   // GIR_Coverage, 65277,
     /* 2247385 */   GIR_EraseRootFromParent_Done,
     /* 2247386 */ // Label 29998: @2247386
     /* 2247386 */ GIM_Try, /*On fail goto*//*Label 29999*/ GIMT_Encode4(2247461), // Rule ID 65281 //
     /* 2247391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2247397 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2247400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247404 */   // MIs[0] Operand 1
     /* 2247404 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2247409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2247417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2247421 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2247425 */   // MIs[1] Operand 1
     /* 2247425 */   // No operand predicates
     /* 2247425 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2247427 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2247427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2247430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2247434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247439 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2247443 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2247446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2247451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2247459 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247460 */   // GIR_Coverage, 65281,
     /* 2247460 */   GIR_EraseRootFromParent_Done,
     /* 2247461 */ // Label 29999: @2247461
     /* 2247461 */ GIM_Try, /*On fail goto*//*Label 30000*/ GIMT_Encode4(2247536), // Rule ID 65285 //
     /* 2247466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2247472 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2247475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247479 */   // MIs[0] Operand 1
     /* 2247479 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2247484 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247488 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2247492 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2247496 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2247500 */   // MIs[1] Operand 1
     /* 2247500 */   // No operand predicates
     /* 2247500 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2247502 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2247502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2247505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2247509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247514 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2247518 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2247521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2247526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2247534 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247535 */   // GIR_Coverage, 65285,
     /* 2247535 */   GIR_EraseRootFromParent_Done,
     /* 2247536 */ // Label 30000: @2247536
     /* 2247536 */ GIM_Try, /*On fail goto*//*Label 30001*/ GIMT_Encode4(2247591), // Rule ID 65289 //
     /* 2247541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2247547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2247550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247554 */   // MIs[0] Operand 1
     /* 2247554 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2247559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247563 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2247567 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2247571 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2247575 */   // MIs[1] Operand 1
     /* 2247575 */   // No operand predicates
     /* 2247575 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2247577 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2247577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2247580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247582 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247584 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2247589 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247590 */   // GIR_Coverage, 65289,
     /* 2247590 */   GIR_EraseRootFromParent_Done,
     /* 2247591 */ // Label 30001: @2247591
     /* 2247591 */ GIM_Try, /*On fail goto*//*Label 30002*/ GIMT_Encode4(2247646), // Rule ID 65293 //
     /* 2247596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2247602 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2247605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247609 */   // MIs[0] Operand 1
     /* 2247609 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247618 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2247622 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2247626 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2247630 */   // MIs[1] Operand 1
     /* 2247630 */   // No operand predicates
     /* 2247630 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2247632 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2247632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2247635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247637 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247639 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2247644 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247645 */   // GIR_Coverage, 65293,
     /* 2247645 */   GIR_EraseRootFromParent_Done,
     /* 2247646 */ // Label 30002: @2247646
     /* 2247646 */ GIM_Try, /*On fail goto*//*Label 30003*/ GIMT_Encode4(2247688), // Rule ID 64449 //
     /* 2247651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2247654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2247657 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2247660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247664 */   // MIs[0] Operand 1
     /* 2247664 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247673 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247677 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2247677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2247680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247682 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247684 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247686 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247687 */   // GIR_Coverage, 64449,
     /* 2247687 */   GIR_EraseRootFromParent_Done,
     /* 2247688 */ // Label 30003: @2247688
     /* 2247688 */ GIM_Try, /*On fail goto*//*Label 30004*/ GIMT_Encode4(2247730), // Rule ID 64451 //
     /* 2247693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2247696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2247699 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2247702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247706 */   // MIs[0] Operand 1
     /* 2247706 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2247711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247715 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247719 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2247719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2247722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247724 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247726 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247728 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247729 */   // GIR_Coverage, 64451,
     /* 2247729 */   GIR_EraseRootFromParent_Done,
     /* 2247730 */ // Label 30004: @2247730
     /* 2247730 */ GIM_Try, /*On fail goto*//*Label 30005*/ GIMT_Encode4(2247772), // Rule ID 146 //
     /* 2247735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2247741 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2247744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247748 */   // MIs[0] Operand 1
     /* 2247748 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247757 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247761 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2247761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2247764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247766 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247768 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247770 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247771 */   // GIR_Coverage, 146,
     /* 2247771 */   GIR_EraseRootFromParent_Done,
     /* 2247772 */ // Label 30005: @2247772
     /* 2247772 */ GIM_Try, /*On fail goto*//*Label 30006*/ GIMT_Encode4(2247814), // Rule ID 150 //
     /* 2247777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2247783 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2247786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247790 */   // MIs[0] Operand 1
     /* 2247790 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247795 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247799 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247803 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2247803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2247806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247808 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247810 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247812 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247813 */   // GIR_Coverage, 150,
     /* 2247813 */   GIR_EraseRootFromParent_Done,
     /* 2247814 */ // Label 30006: @2247814
     /* 2247814 */ GIM_Try, /*On fail goto*//*Label 30007*/ GIMT_Encode4(2247856), // Rule ID 65219 //
     /* 2247819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2247825 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2247828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247832 */   // MIs[0] Operand 1
     /* 2247832 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247837 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247841 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247845 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2247845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2247848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247850 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247852 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247854 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247855 */   // GIR_Coverage, 65219,
     /* 2247855 */   GIR_EraseRootFromParent_Done,
     /* 2247856 */ // Label 30007: @2247856
     /* 2247856 */ GIM_Try, /*On fail goto*//*Label 30008*/ GIMT_Encode4(2247898), // Rule ID 65223 //
     /* 2247861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2247867 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2247870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247874 */   // MIs[0] Operand 1
     /* 2247874 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247883 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247887 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2247887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2247890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247892 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247894 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247896 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247897 */   // GIR_Coverage, 65223,
     /* 2247897 */   GIR_EraseRootFromParent_Done,
     /* 2247898 */ // Label 30008: @2247898
     /* 2247898 */ GIM_Try, /*On fail goto*//*Label 30009*/ GIMT_Encode4(2247964), // Rule ID 65229 //
     /* 2247903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2247909 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2247912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247916 */   // MIs[0] Operand 1
     /* 2247916 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2247921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247925 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247929 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2247929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2247932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2247936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2247941 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2247945 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2247949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2247951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2247954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2247959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2247962 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247963 */   // GIR_Coverage, 65229,
     /* 2247963 */   GIR_EraseRootFromParent_Done,
     /* 2247964 */ // Label 30009: @2247964
     /* 2247964 */ GIM_Try, /*On fail goto*//*Label 30010*/ GIMT_Encode4(2248033), // Rule ID 65235 //
     /* 2247969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2247972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2247975 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2247978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247982 */   // MIs[0] Operand 1
     /* 2247982 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2247987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247991 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2247995 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2247995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2247998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2248002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248007 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2248011 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2248015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2248020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248022 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2248028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248031 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248032 */   // GIR_Coverage, 65235,
     /* 2248032 */   GIR_EraseRootFromParent_Done,
     /* 2248033 */ // Label 30010: @2248033
     /* 2248033 */ GIM_Try, /*On fail goto*//*Label 30011*/ GIMT_Encode4(2248075), // Rule ID 65239 //
     /* 2248038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2248044 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2248047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248051 */   // MIs[0] Operand 1
     /* 2248051 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248060 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248064 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2248064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2248067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248069 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248071 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248073 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248074 */   // GIR_Coverage, 65239,
     /* 2248074 */   GIR_EraseRootFromParent_Done,
     /* 2248075 */ // Label 30011: @2248075
     /* 2248075 */ GIM_Try, /*On fail goto*//*Label 30012*/ GIMT_Encode4(2248117), // Rule ID 65243 //
     /* 2248080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2248086 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2248089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248093 */   // MIs[0] Operand 1
     /* 2248093 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2248098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248102 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248106 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2248106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2248109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248111 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248113 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248116 */   // GIR_Coverage, 65243,
     /* 2248116 */   GIR_EraseRootFromParent_Done,
     /* 2248117 */ // Label 30012: @2248117
     /* 2248117 */ GIM_Try, /*On fail goto*//*Label 30013*/ GIMT_Encode4(2248183), // Rule ID 65247 //
     /* 2248122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2248128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2248131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248135 */   // MIs[0] Operand 1
     /* 2248135 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2248140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248144 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248148 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2248148 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2248151 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2248155 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248160 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2248164 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2248168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2248173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2248181 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248182 */   // GIR_Coverage, 65247,
     /* 2248182 */   GIR_EraseRootFromParent_Done,
     /* 2248183 */ // Label 30013: @2248183
     /* 2248183 */ GIM_Try, /*On fail goto*//*Label 30014*/ GIMT_Encode4(2248249), // Rule ID 65251 //
     /* 2248188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2248194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2248197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248201 */   // MIs[0] Operand 1
     /* 2248201 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248210 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248214 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2248214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2248217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2248221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248226 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2248230 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2248234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2248239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2248247 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248248 */   // GIR_Coverage, 65251,
     /* 2248248 */   GIR_EraseRootFromParent_Done,
     /* 2248249 */ // Label 30014: @2248249
     /* 2248249 */ GIM_Try, /*On fail goto*//*Label 30015*/ GIMT_Encode4(2248315), // Rule ID 65255 //
     /* 2248254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2248260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2248263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248267 */   // MIs[0] Operand 1
     /* 2248267 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248276 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248280 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2248280 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2248283 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2248287 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248292 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2248296 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2248300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2248305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248307 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2248313 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248314 */   // GIR_Coverage, 65255,
     /* 2248314 */   GIR_EraseRootFromParent_Done,
     /* 2248315 */ // Label 30015: @2248315
     /* 2248315 */ GIM_Try, /*On fail goto*//*Label 30016*/ GIMT_Encode4(2248381), // Rule ID 65259 //
     /* 2248320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2248326 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2248329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248333 */   // MIs[0] Operand 1
     /* 2248333 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248342 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248346 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2248346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2248349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2248353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248358 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2248362 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2248366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2248371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2248379 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248380 */   // GIR_Coverage, 65259,
     /* 2248380 */   GIR_EraseRootFromParent_Done,
     /* 2248381 */ // Label 30016: @2248381
     /* 2248381 */ GIM_Try, /*On fail goto*//*Label 30017*/ GIMT_Encode4(2248447), // Rule ID 65265 //
     /* 2248386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2248392 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2248395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248399 */   // MIs[0] Operand 1
     /* 2248399 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2248404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248408 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248412 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2248412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2248415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2248419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248424 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2248428 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2248432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2248437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2248445 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248446 */   // GIR_Coverage, 65265,
     /* 2248446 */   GIR_EraseRootFromParent_Done,
     /* 2248447 */ // Label 30017: @2248447
     /* 2248447 */ GIM_Try, /*On fail goto*//*Label 30018*/ GIMT_Encode4(2248516), // Rule ID 65271 //
     /* 2248452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2248458 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2248461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248465 */   // MIs[0] Operand 1
     /* 2248465 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2248470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248474 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248478 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2248478 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2248481 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2248485 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248490 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2248494 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2248498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2248503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248505 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2248511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248515 */   // GIR_Coverage, 65271,
     /* 2248515 */   GIR_EraseRootFromParent_Done,
     /* 2248516 */ // Label 30018: @2248516
     /* 2248516 */ GIM_Try, /*On fail goto*//*Label 30019*/ GIMT_Encode4(2248558), // Rule ID 65275 //
     /* 2248521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2248527 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2248530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248534 */   // MIs[0] Operand 1
     /* 2248534 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248543 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248547 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2248547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2248550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248552 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248554 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248556 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248557 */   // GIR_Coverage, 65275,
     /* 2248557 */   GIR_EraseRootFromParent_Done,
     /* 2248558 */ // Label 30019: @2248558
     /* 2248558 */ GIM_Try, /*On fail goto*//*Label 30020*/ GIMT_Encode4(2248600), // Rule ID 65279 //
     /* 2248563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2248569 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2248572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248576 */   // MIs[0] Operand 1
     /* 2248576 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2248581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248585 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248589 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2248589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2248592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248594 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248596 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248599 */   // GIR_Coverage, 65279,
     /* 2248599 */   GIR_EraseRootFromParent_Done,
     /* 2248600 */ // Label 30020: @2248600
     /* 2248600 */ GIM_Try, /*On fail goto*//*Label 30021*/ GIMT_Encode4(2248666), // Rule ID 65283 //
     /* 2248605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2248611 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2248614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248618 */   // MIs[0] Operand 1
     /* 2248618 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2248623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248627 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248631 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2248631 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2248634 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2248638 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248643 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2248647 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2248651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2248656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248658 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2248664 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248665 */   // GIR_Coverage, 65283,
     /* 2248665 */   GIR_EraseRootFromParent_Done,
     /* 2248666 */ // Label 30021: @2248666
     /* 2248666 */ GIM_Try, /*On fail goto*//*Label 30022*/ GIMT_Encode4(2248732), // Rule ID 65287 //
     /* 2248671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2248677 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2248680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248684 */   // MIs[0] Operand 1
     /* 2248684 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248693 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248697 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2248697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2248700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2248704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248709 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2248713 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2248717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2248722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2248730 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248731 */   // GIR_Coverage, 65287,
     /* 2248731 */   GIR_EraseRootFromParent_Done,
     /* 2248732 */ // Label 30022: @2248732
     /* 2248732 */ GIM_Try, /*On fail goto*//*Label 30023*/ GIMT_Encode4(2248798), // Rule ID 65291 //
     /* 2248737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2248743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2248746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248750 */   // MIs[0] Operand 1
     /* 2248750 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248759 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248763 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2248763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2248766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2248770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248775 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2248779 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2248783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2248788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248790 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2248796 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248797 */   // GIR_Coverage, 65291,
     /* 2248797 */   GIR_EraseRootFromParent_Done,
     /* 2248798 */ // Label 30023: @2248798
     /* 2248798 */ GIM_Try, /*On fail goto*//*Label 30024*/ GIMT_Encode4(2248864), // Rule ID 65295 //
     /* 2248803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2248806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2248809 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2248812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248816 */   // MIs[0] Operand 1
     /* 2248816 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248825 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2248829 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2248829 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2248832 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2248836 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2248841 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2248845 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2248849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2248851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2248854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248856 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2248859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2248862 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248863 */   // GIR_Coverage, 65295,
     /* 2248863 */   GIR_EraseRootFromParent_Done,
     /* 2248864 */ // Label 30024: @2248864
     /* 2248864 */ GIM_Reject,
     /* 2248865 */ // Label 29923: @2248865
     /* 2248865 */ GIM_Try, /*On fail goto*//*Label 30025*/ GIMT_Encode4(2248913), // Rule ID 45770 //
     /* 2248870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248876 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248883 */   // MIs[0] Operand 1
     /* 2248883 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2248888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248892 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248896 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2248899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248901 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248903 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248911 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248912 */   // GIR_Coverage, 45770,
     /* 2248912 */   GIR_EraseRootFromParent_Done,
     /* 2248913 */ // Label 30025: @2248913
     /* 2248913 */ GIM_Try, /*On fail goto*//*Label 30026*/ GIMT_Encode4(2248961), // Rule ID 45771 //
     /* 2248918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248924 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248931 */   // MIs[0] Operand 1
     /* 2248931 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2248936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248940 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248944 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2248947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248949 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248951 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248959 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248960 */   // GIR_Coverage, 45771,
     /* 2248960 */   GIR_EraseRootFromParent_Done,
     /* 2248961 */ // Label 30026: @2248961
     /* 2248961 */ GIM_Try, /*On fail goto*//*Label 30027*/ GIMT_Encode4(2249009), // Rule ID 45772 //
     /* 2248966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248972 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248979 */   // MIs[0] Operand 1
     /* 2248979 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2248984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248988 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248992 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2248995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248997 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248999 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249008 */   // GIR_Coverage, 45772,
     /* 2249008 */   GIR_EraseRootFromParent_Done,
     /* 2249009 */ // Label 30027: @2249009
     /* 2249009 */ GIM_Try, /*On fail goto*//*Label 30028*/ GIMT_Encode4(2249057), // Rule ID 45773 //
     /* 2249014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2249020 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2249023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249027 */   // MIs[0] Operand 1
     /* 2249027 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2249032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249036 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249040 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2249043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249045 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249047 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249055 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249056 */   // GIR_Coverage, 45773,
     /* 2249056 */   GIR_EraseRootFromParent_Done,
     /* 2249057 */ // Label 30028: @2249057
     /* 2249057 */ GIM_Try, /*On fail goto*//*Label 30029*/ GIMT_Encode4(2249105), // Rule ID 48484 //
     /* 2249062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249075 */   // MIs[0] Operand 1
     /* 2249075 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249084 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249088 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2249091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249093 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249095 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249104 */   // GIR_Coverage, 48484,
     /* 2249104 */   GIR_EraseRootFromParent_Done,
     /* 2249105 */ // Label 30029: @2249105
     /* 2249105 */ GIM_Try, /*On fail goto*//*Label 30030*/ GIMT_Encode4(2249153), // Rule ID 48485 //
     /* 2249110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249116 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249123 */   // MIs[0] Operand 1
     /* 2249123 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249132 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249136 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2249139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249141 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249143 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249151 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249152 */   // GIR_Coverage, 48485,
     /* 2249152 */   GIR_EraseRootFromParent_Done,
     /* 2249153 */ // Label 30030: @2249153
     /* 2249153 */ GIM_Try, /*On fail goto*//*Label 30031*/ GIMT_Encode4(2249201), // Rule ID 48488 //
     /* 2249158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249164 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249171 */   // MIs[0] Operand 1
     /* 2249171 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249180 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249184 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2249187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249189 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249191 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249199 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249200 */   // GIR_Coverage, 48488,
     /* 2249200 */   GIR_EraseRootFromParent_Done,
     /* 2249201 */ // Label 30031: @2249201
     /* 2249201 */ GIM_Try, /*On fail goto*//*Label 30032*/ GIMT_Encode4(2249249), // Rule ID 48489 //
     /* 2249206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249212 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249219 */   // MIs[0] Operand 1
     /* 2249219 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249228 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249232 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2249235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249237 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249239 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249247 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249248 */   // GIR_Coverage, 48489,
     /* 2249248 */   GIR_EraseRootFromParent_Done,
     /* 2249249 */ // Label 30032: @2249249
     /* 2249249 */ GIM_Try, /*On fail goto*//*Label 30033*/ GIMT_Encode4(2249297), // Rule ID 48496 //
     /* 2249254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249267 */   // MIs[0] Operand 1
     /* 2249267 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249276 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249280 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2249283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249285 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249287 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249295 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249296 */   // GIR_Coverage, 48496,
     /* 2249296 */   GIR_EraseRootFromParent_Done,
     /* 2249297 */ // Label 30033: @2249297
     /* 2249297 */ GIM_Try, /*On fail goto*//*Label 30034*/ GIMT_Encode4(2249345), // Rule ID 48497 //
     /* 2249302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249308 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249315 */   // MIs[0] Operand 1
     /* 2249315 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249324 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249328 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2249331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249333 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249335 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249344 */   // GIR_Coverage, 48497,
     /* 2249344 */   GIR_EraseRootFromParent_Done,
     /* 2249345 */ // Label 30034: @2249345
     /* 2249345 */ GIM_Try, /*On fail goto*//*Label 30035*/ GIMT_Encode4(2249393), // Rule ID 48522 //
     /* 2249350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2249356 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2249359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249363 */   // MIs[0] Operand 1
     /* 2249363 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249372 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249376 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2249379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249381 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249383 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249392 */   // GIR_Coverage, 48522,
     /* 2249392 */   GIR_EraseRootFromParent_Done,
     /* 2249393 */ // Label 30035: @2249393
     /* 2249393 */ GIM_Try, /*On fail goto*//*Label 30036*/ GIMT_Encode4(2249441), // Rule ID 48523 //
     /* 2249398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2249404 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2249407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249411 */   // MIs[0] Operand 1
     /* 2249411 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249420 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249424 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2249427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249429 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249431 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249440 */   // GIR_Coverage, 48523,
     /* 2249440 */   GIR_EraseRootFromParent_Done,
     /* 2249441 */ // Label 30036: @2249441
     /* 2249441 */ GIM_Try, /*On fail goto*//*Label 30037*/ GIMT_Encode4(2249489), // Rule ID 48528 //
     /* 2249446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249452 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249459 */   // MIs[0] Operand 1
     /* 2249459 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249468 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249472 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2249475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249477 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249479 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249487 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249488 */   // GIR_Coverage, 48528,
     /* 2249488 */   GIR_EraseRootFromParent_Done,
     /* 2249489 */ // Label 30037: @2249489
     /* 2249489 */ GIM_Try, /*On fail goto*//*Label 30038*/ GIMT_Encode4(2249537), // Rule ID 48529 //
     /* 2249494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249500 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249507 */   // MIs[0] Operand 1
     /* 2249507 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249516 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249520 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2249523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249525 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249527 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249535 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249536 */   // GIR_Coverage, 48529,
     /* 2249536 */   GIR_EraseRootFromParent_Done,
     /* 2249537 */ // Label 30038: @2249537
     /* 2249537 */ GIM_Try, /*On fail goto*//*Label 30039*/ GIMT_Encode4(2249585), // Rule ID 48532 //
     /* 2249542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249548 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249555 */   // MIs[0] Operand 1
     /* 2249555 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249564 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249568 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2249571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249573 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249575 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249583 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249584 */   // GIR_Coverage, 48532,
     /* 2249584 */   GIR_EraseRootFromParent_Done,
     /* 2249585 */ // Label 30039: @2249585
     /* 2249585 */ GIM_Try, /*On fail goto*//*Label 30040*/ GIMT_Encode4(2249633), // Rule ID 48533 //
     /* 2249590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249596 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249603 */   // MIs[0] Operand 1
     /* 2249603 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249612 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249616 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2249619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249621 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249623 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249632 */   // GIR_Coverage, 48533,
     /* 2249632 */   GIR_EraseRootFromParent_Done,
     /* 2249633 */ // Label 30040: @2249633
     /* 2249633 */ GIM_Try, /*On fail goto*//*Label 30041*/ GIMT_Encode4(2249681), // Rule ID 48540 //
     /* 2249638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249644 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249651 */   // MIs[0] Operand 1
     /* 2249651 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249660 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249664 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2249667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249669 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249671 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249679 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249680 */   // GIR_Coverage, 48540,
     /* 2249680 */   GIR_EraseRootFromParent_Done,
     /* 2249681 */ // Label 30041: @2249681
     /* 2249681 */ GIM_Try, /*On fail goto*//*Label 30042*/ GIMT_Encode4(2249729), // Rule ID 48541 //
     /* 2249686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249699 */   // MIs[0] Operand 1
     /* 2249699 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249708 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249712 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2249715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249717 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249719 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249727 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249728 */   // GIR_Coverage, 48541,
     /* 2249728 */   GIR_EraseRootFromParent_Done,
     /* 2249729 */ // Label 30042: @2249729
     /* 2249729 */ GIM_Try, /*On fail goto*//*Label 30043*/ GIMT_Encode4(2249777), // Rule ID 48566 //
     /* 2249734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2249740 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2249743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249747 */   // MIs[0] Operand 1
     /* 2249747 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249756 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249760 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2249763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249765 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249767 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249775 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249776 */   // GIR_Coverage, 48566,
     /* 2249776 */   GIR_EraseRootFromParent_Done,
     /* 2249777 */ // Label 30043: @2249777
     /* 2249777 */ GIM_Try, /*On fail goto*//*Label 30044*/ GIMT_Encode4(2249825), // Rule ID 48567 //
     /* 2249782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2249788 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2249791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249795 */   // MIs[0] Operand 1
     /* 2249795 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249804 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249808 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2249811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249813 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249815 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249823 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249824 */   // GIR_Coverage, 48567,
     /* 2249824 */   GIR_EraseRootFromParent_Done,
     /* 2249825 */ // Label 30044: @2249825
     /* 2249825 */ GIM_Try, /*On fail goto*//*Label 30045*/ GIMT_Encode4(2249873), // Rule ID 48572 //
     /* 2249830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249836 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249843 */   // MIs[0] Operand 1
     /* 2249843 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249852 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249856 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2249859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249861 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249863 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249871 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249872 */   // GIR_Coverage, 48572,
     /* 2249872 */   GIR_EraseRootFromParent_Done,
     /* 2249873 */ // Label 30045: @2249873
     /* 2249873 */ GIM_Try, /*On fail goto*//*Label 30046*/ GIMT_Encode4(2249921), // Rule ID 48573 //
     /* 2249878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249884 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249891 */   // MIs[0] Operand 1
     /* 2249891 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249900 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249904 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2249907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249909 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249911 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249919 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249920 */   // GIR_Coverage, 48573,
     /* 2249920 */   GIR_EraseRootFromParent_Done,
     /* 2249921 */ // Label 30046: @2249921
     /* 2249921 */ GIM_Try, /*On fail goto*//*Label 30047*/ GIMT_Encode4(2249969), // Rule ID 48576 //
     /* 2249926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249932 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249939 */   // MIs[0] Operand 1
     /* 2249939 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249948 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249952 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2249955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249957 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249959 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249967 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249968 */   // GIR_Coverage, 48576,
     /* 2249968 */   GIR_EraseRootFromParent_Done,
     /* 2249969 */ // Label 30047: @2249969
     /* 2249969 */ GIM_Try, /*On fail goto*//*Label 30048*/ GIMT_Encode4(2250017), // Rule ID 48577 //
     /* 2249974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249980 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249987 */   // MIs[0] Operand 1
     /* 2249987 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249996 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250000 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2250003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250005 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250007 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250015 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250016 */   // GIR_Coverage, 48577,
     /* 2250016 */   GIR_EraseRootFromParent_Done,
     /* 2250017 */ // Label 30048: @2250017
     /* 2250017 */ GIM_Try, /*On fail goto*//*Label 30049*/ GIMT_Encode4(2250065), // Rule ID 48584 //
     /* 2250022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2250028 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2250031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250035 */   // MIs[0] Operand 1
     /* 2250035 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250044 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250048 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250053 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250055 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250063 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250064 */   // GIR_Coverage, 48584,
     /* 2250064 */   GIR_EraseRootFromParent_Done,
     /* 2250065 */ // Label 30049: @2250065
     /* 2250065 */ GIM_Try, /*On fail goto*//*Label 30050*/ GIMT_Encode4(2250113), // Rule ID 48585 //
     /* 2250070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2250076 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2250079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250083 */   // MIs[0] Operand 1
     /* 2250083 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250092 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250096 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250101 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250103 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250111 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250112 */   // GIR_Coverage, 48585,
     /* 2250112 */   GIR_EraseRootFromParent_Done,
     /* 2250113 */ // Label 30050: @2250113
     /* 2250113 */ GIM_Try, /*On fail goto*//*Label 30051*/ GIMT_Encode4(2250161), // Rule ID 48614 //
     /* 2250118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2250124 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2250127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250131 */   // MIs[0] Operand 1
     /* 2250131 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250140 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250144 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250149 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250151 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250159 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250160 */   // GIR_Coverage, 48614,
     /* 2250160 */   GIR_EraseRootFromParent_Done,
     /* 2250161 */ // Label 30051: @2250161
     /* 2250161 */ GIM_Try, /*On fail goto*//*Label 30052*/ GIMT_Encode4(2250209), // Rule ID 48615 //
     /* 2250166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2250172 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2250175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250179 */   // MIs[0] Operand 1
     /* 2250179 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250188 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250192 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250197 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250199 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250207 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250208 */   // GIR_Coverage, 48615,
     /* 2250208 */   GIR_EraseRootFromParent_Done,
     /* 2250209 */ // Label 30052: @2250209
     /* 2250209 */ GIM_Try, /*On fail goto*//*Label 30053*/ GIMT_Encode4(2250257), // Rule ID 48618 //
     /* 2250214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2250220 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2250223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250227 */   // MIs[0] Operand 1
     /* 2250227 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250232 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250236 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250240 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2250240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2250243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250245 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250247 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250255 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250256 */   // GIR_Coverage, 48618,
     /* 2250256 */   GIR_EraseRootFromParent_Done,
     /* 2250257 */ // Label 30053: @2250257
     /* 2250257 */ GIM_Try, /*On fail goto*//*Label 30054*/ GIMT_Encode4(2250305), // Rule ID 48619 //
     /* 2250262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2250268 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2250271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250275 */   // MIs[0] Operand 1
     /* 2250275 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250280 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250284 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250288 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2250291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250293 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250295 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250303 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250304 */   // GIR_Coverage, 48619,
     /* 2250304 */   GIR_EraseRootFromParent_Done,
     /* 2250305 */ // Label 30054: @2250305
     /* 2250305 */ GIM_Try, /*On fail goto*//*Label 30055*/ GIMT_Encode4(2250353), // Rule ID 48626 //
     /* 2250310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2250316 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2250319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250323 */   // MIs[0] Operand 1
     /* 2250323 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250332 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250336 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250341 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250343 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250351 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250352 */   // GIR_Coverage, 48626,
     /* 2250352 */   GIR_EraseRootFromParent_Done,
     /* 2250353 */ // Label 30055: @2250353
     /* 2250353 */ GIM_Try, /*On fail goto*//*Label 30056*/ GIMT_Encode4(2250401), // Rule ID 48627 //
     /* 2250358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2250364 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2250367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250371 */   // MIs[0] Operand 1
     /* 2250371 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250380 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250384 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250389 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250391 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250399 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250400 */   // GIR_Coverage, 48627,
     /* 2250400 */   GIR_EraseRootFromParent_Done,
     /* 2250401 */ // Label 30056: @2250401
     /* 2250401 */ GIM_Try, /*On fail goto*//*Label 30057*/ GIMT_Encode4(2250449), // Rule ID 48652 //
     /* 2250406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2250412 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2250415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250419 */   // MIs[0] Operand 1
     /* 2250419 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250428 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250432 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2250435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250437 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250439 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250447 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250448 */   // GIR_Coverage, 48652,
     /* 2250448 */   GIR_EraseRootFromParent_Done,
     /* 2250449 */ // Label 30057: @2250449
     /* 2250449 */ GIM_Try, /*On fail goto*//*Label 30058*/ GIMT_Encode4(2250497), // Rule ID 48653 //
     /* 2250454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2250460 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2250463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250467 */   // MIs[0] Operand 1
     /* 2250467 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250476 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250480 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2250483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250485 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250487 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250495 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250496 */   // GIR_Coverage, 48653,
     /* 2250496 */   GIR_EraseRootFromParent_Done,
     /* 2250497 */ // Label 30058: @2250497
     /* 2250497 */ GIM_Try, /*On fail goto*//*Label 30059*/ GIMT_Encode4(2250545), // Rule ID 48658 //
     /* 2250502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2250508 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2250511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250515 */   // MIs[0] Operand 1
     /* 2250515 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250524 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250528 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2250531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250533 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250535 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250543 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250544 */   // GIR_Coverage, 48658,
     /* 2250544 */   GIR_EraseRootFromParent_Done,
     /* 2250545 */ // Label 30059: @2250545
     /* 2250545 */ GIM_Try, /*On fail goto*//*Label 30060*/ GIMT_Encode4(2250593), // Rule ID 48659 //
     /* 2250550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2250556 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2250559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250563 */   // MIs[0] Operand 1
     /* 2250563 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250572 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250576 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2250579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250581 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250583 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250591 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250592 */   // GIR_Coverage, 48659,
     /* 2250592 */   GIR_EraseRootFromParent_Done,
     /* 2250593 */ // Label 30060: @2250593
     /* 2250593 */ GIM_Try, /*On fail goto*//*Label 30061*/ GIMT_Encode4(2250641), // Rule ID 48662 //
     /* 2250598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2250604 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2250607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250611 */   // MIs[0] Operand 1
     /* 2250611 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250620 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250624 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2250624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2250627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250629 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250631 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250639 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250640 */   // GIR_Coverage, 48662,
     /* 2250640 */   GIR_EraseRootFromParent_Done,
     /* 2250641 */ // Label 30061: @2250641
     /* 2250641 */ GIM_Try, /*On fail goto*//*Label 30062*/ GIMT_Encode4(2250689), // Rule ID 48663 //
     /* 2250646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2250652 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2250655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250659 */   // MIs[0] Operand 1
     /* 2250659 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250668 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250672 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2250675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250677 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250679 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250687 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250688 */   // GIR_Coverage, 48663,
     /* 2250688 */   GIR_EraseRootFromParent_Done,
     /* 2250689 */ // Label 30062: @2250689
     /* 2250689 */ GIM_Try, /*On fail goto*//*Label 30063*/ GIMT_Encode4(2250737), // Rule ID 48670 //
     /* 2250694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2250700 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2250703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250707 */   // MIs[0] Operand 1
     /* 2250707 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250716 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250720 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2250723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250725 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250727 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250735 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250736 */   // GIR_Coverage, 48670,
     /* 2250736 */   GIR_EraseRootFromParent_Done,
     /* 2250737 */ // Label 30063: @2250737
     /* 2250737 */ GIM_Try, /*On fail goto*//*Label 30064*/ GIMT_Encode4(2250785), // Rule ID 48671 //
     /* 2250742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2250748 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2250751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250755 */   // MIs[0] Operand 1
     /* 2250755 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250764 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250768 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2250771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250773 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250775 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250783 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250784 */   // GIR_Coverage, 48671,
     /* 2250784 */   GIR_EraseRootFromParent_Done,
     /* 2250785 */ // Label 30064: @2250785
     /* 2250785 */ GIM_Try, /*On fail goto*//*Label 30065*/ GIMT_Encode4(2250833), // Rule ID 48696 //
     /* 2250790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2250796 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2250799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250803 */   // MIs[0] Operand 1
     /* 2250803 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2250808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250812 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250816 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2250819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250821 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250823 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250831 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250832 */   // GIR_Coverage, 48696,
     /* 2250832 */   GIR_EraseRootFromParent_Done,
     /* 2250833 */ // Label 30065: @2250833
     /* 2250833 */ GIM_Try, /*On fail goto*//*Label 30066*/ GIMT_Encode4(2250881), // Rule ID 48697 //
     /* 2250838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2250844 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2250847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250851 */   // MIs[0] Operand 1
     /* 2250851 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2250856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250860 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250864 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2250867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250869 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250871 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250879 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250880 */   // GIR_Coverage, 48697,
     /* 2250880 */   GIR_EraseRootFromParent_Done,
     /* 2250881 */ // Label 30066: @2250881
     /* 2250881 */ GIM_Try, /*On fail goto*//*Label 30067*/ GIMT_Encode4(2250929), // Rule ID 48702 //
     /* 2250886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2250892 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2250895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250899 */   // MIs[0] Operand 1
     /* 2250899 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2250904 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250908 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250912 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2250915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250917 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250919 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250927 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250928 */   // GIR_Coverage, 48702,
     /* 2250928 */   GIR_EraseRootFromParent_Done,
     /* 2250929 */ // Label 30067: @2250929
     /* 2250929 */ GIM_Try, /*On fail goto*//*Label 30068*/ GIMT_Encode4(2250977), // Rule ID 48703 //
     /* 2250934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2250940 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2250943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250947 */   // MIs[0] Operand 1
     /* 2250947 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2250952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250956 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250960 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2250963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250965 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250967 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250975 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250976 */   // GIR_Coverage, 48703,
     /* 2250976 */   GIR_EraseRootFromParent_Done,
     /* 2250977 */ // Label 30068: @2250977
     /* 2250977 */ GIM_Try, /*On fail goto*//*Label 30069*/ GIMT_Encode4(2251025), // Rule ID 48706 //
     /* 2250982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2250988 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2250991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250995 */   // MIs[0] Operand 1
     /* 2250995 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251000 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251004 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251008 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2251011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251013 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251015 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251023 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251024 */   // GIR_Coverage, 48706,
     /* 2251024 */   GIR_EraseRootFromParent_Done,
     /* 2251025 */ // Label 30069: @2251025
     /* 2251025 */ GIM_Try, /*On fail goto*//*Label 30070*/ GIMT_Encode4(2251073), // Rule ID 48707 //
     /* 2251030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2251036 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2251039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251043 */   // MIs[0] Operand 1
     /* 2251043 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251052 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251056 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2251059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251061 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251063 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251071 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251072 */   // GIR_Coverage, 48707,
     /* 2251072 */   GIR_EraseRootFromParent_Done,
     /* 2251073 */ // Label 30070: @2251073
     /* 2251073 */ GIM_Try, /*On fail goto*//*Label 30071*/ GIMT_Encode4(2251121), // Rule ID 48714 //
     /* 2251078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2251084 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2251087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251091 */   // MIs[0] Operand 1
     /* 2251091 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251096 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251100 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251104 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251109 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251111 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251119 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251120 */   // GIR_Coverage, 48714,
     /* 2251120 */   GIR_EraseRootFromParent_Done,
     /* 2251121 */ // Label 30071: @2251121
     /* 2251121 */ GIM_Try, /*On fail goto*//*Label 30072*/ GIMT_Encode4(2251169), // Rule ID 48715 //
     /* 2251126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2251132 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2251135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251139 */   // MIs[0] Operand 1
     /* 2251139 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251144 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251148 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251152 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2251152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251157 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251159 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251167 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251168 */   // GIR_Coverage, 48715,
     /* 2251168 */   GIR_EraseRootFromParent_Done,
     /* 2251169 */ // Label 30072: @2251169
     /* 2251169 */ GIM_Try, /*On fail goto*//*Label 30073*/ GIMT_Encode4(2251217), // Rule ID 48740 //
     /* 2251174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2251180 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2251183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251187 */   // MIs[0] Operand 1
     /* 2251187 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251196 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251200 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2251203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251205 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251207 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251215 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251216 */   // GIR_Coverage, 48740,
     /* 2251216 */   GIR_EraseRootFromParent_Done,
     /* 2251217 */ // Label 30073: @2251217
     /* 2251217 */ GIM_Try, /*On fail goto*//*Label 30074*/ GIMT_Encode4(2251265), // Rule ID 48741 //
     /* 2251222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2251228 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2251231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251235 */   // MIs[0] Operand 1
     /* 2251235 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251244 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251248 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2251251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251253 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251255 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251263 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251264 */   // GIR_Coverage, 48741,
     /* 2251264 */   GIR_EraseRootFromParent_Done,
     /* 2251265 */ // Label 30074: @2251265
     /* 2251265 */ GIM_Try, /*On fail goto*//*Label 30075*/ GIMT_Encode4(2251313), // Rule ID 48746 //
     /* 2251270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2251276 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2251279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251283 */   // MIs[0] Operand 1
     /* 2251283 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251292 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251296 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2251299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251301 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251303 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251311 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251312 */   // GIR_Coverage, 48746,
     /* 2251312 */   GIR_EraseRootFromParent_Done,
     /* 2251313 */ // Label 30075: @2251313
     /* 2251313 */ GIM_Try, /*On fail goto*//*Label 30076*/ GIMT_Encode4(2251361), // Rule ID 48747 //
     /* 2251318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2251324 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2251327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251331 */   // MIs[0] Operand 1
     /* 2251331 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251336 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251340 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251344 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2251347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251349 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251351 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251359 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251360 */   // GIR_Coverage, 48747,
     /* 2251360 */   GIR_EraseRootFromParent_Done,
     /* 2251361 */ // Label 30076: @2251361
     /* 2251361 */ GIM_Try, /*On fail goto*//*Label 30077*/ GIMT_Encode4(2251409), // Rule ID 48750 //
     /* 2251366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2251372 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2251375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251379 */   // MIs[0] Operand 1
     /* 2251379 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251384 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251388 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251392 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2251395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251397 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251399 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251407 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251408 */   // GIR_Coverage, 48750,
     /* 2251408 */   GIR_EraseRootFromParent_Done,
     /* 2251409 */ // Label 30077: @2251409
     /* 2251409 */ GIM_Try, /*On fail goto*//*Label 30078*/ GIMT_Encode4(2251457), // Rule ID 48751 //
     /* 2251414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2251420 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2251423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251427 */   // MIs[0] Operand 1
     /* 2251427 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251436 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251440 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2251443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251445 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251447 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251455 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251456 */   // GIR_Coverage, 48751,
     /* 2251456 */   GIR_EraseRootFromParent_Done,
     /* 2251457 */ // Label 30078: @2251457
     /* 2251457 */ GIM_Try, /*On fail goto*//*Label 30079*/ GIMT_Encode4(2251505), // Rule ID 48758 //
     /* 2251462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2251468 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2251471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251475 */   // MIs[0] Operand 1
     /* 2251475 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251480 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251484 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251488 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2251491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251493 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251495 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251503 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251504 */   // GIR_Coverage, 48758,
     /* 2251504 */   GIR_EraseRootFromParent_Done,
     /* 2251505 */ // Label 30079: @2251505
     /* 2251505 */ GIM_Try, /*On fail goto*//*Label 30080*/ GIMT_Encode4(2251553), // Rule ID 48759 //
     /* 2251510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2251516 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2251519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251523 */   // MIs[0] Operand 1
     /* 2251523 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251532 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251536 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2251536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2251539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251541 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251543 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251551 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251552 */   // GIR_Coverage, 48759,
     /* 2251552 */   GIR_EraseRootFromParent_Done,
     /* 2251553 */ // Label 30080: @2251553
     /* 2251553 */ GIM_Try, /*On fail goto*//*Label 30081*/ GIMT_Encode4(2251601), // Rule ID 48784 //
     /* 2251558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2251564 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2251567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251571 */   // MIs[0] Operand 1
     /* 2251571 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251580 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251584 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2251587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251589 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251591 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251599 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251600 */   // GIR_Coverage, 48784,
     /* 2251600 */   GIR_EraseRootFromParent_Done,
     /* 2251601 */ // Label 30081: @2251601
     /* 2251601 */ GIM_Try, /*On fail goto*//*Label 30082*/ GIMT_Encode4(2251649), // Rule ID 48785 //
     /* 2251606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2251612 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2251615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251619 */   // MIs[0] Operand 1
     /* 2251619 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251628 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251632 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2251635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251637 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251639 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251647 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251648 */   // GIR_Coverage, 48785,
     /* 2251648 */   GIR_EraseRootFromParent_Done,
     /* 2251649 */ // Label 30082: @2251649
     /* 2251649 */ GIM_Try, /*On fail goto*//*Label 30083*/ GIMT_Encode4(2251697), // Rule ID 48790 //
     /* 2251654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2251660 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2251663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251667 */   // MIs[0] Operand 1
     /* 2251667 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251676 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251680 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2251683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251685 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251687 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251695 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251696 */   // GIR_Coverage, 48790,
     /* 2251696 */   GIR_EraseRootFromParent_Done,
     /* 2251697 */ // Label 30083: @2251697
     /* 2251697 */ GIM_Try, /*On fail goto*//*Label 30084*/ GIMT_Encode4(2251745), // Rule ID 48791 //
     /* 2251702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2251708 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2251711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251715 */   // MIs[0] Operand 1
     /* 2251715 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251724 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251728 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2251731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251733 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251735 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251743 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251744 */   // GIR_Coverage, 48791,
     /* 2251744 */   GIR_EraseRootFromParent_Done,
     /* 2251745 */ // Label 30084: @2251745
     /* 2251745 */ GIM_Try, /*On fail goto*//*Label 30085*/ GIMT_Encode4(2251793), // Rule ID 48794 //
     /* 2251750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2251756 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2251759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251763 */   // MIs[0] Operand 1
     /* 2251763 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251768 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251772 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251776 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2251779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251781 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251783 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251791 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251792 */   // GIR_Coverage, 48794,
     /* 2251792 */   GIR_EraseRootFromParent_Done,
     /* 2251793 */ // Label 30085: @2251793
     /* 2251793 */ GIM_Try, /*On fail goto*//*Label 30086*/ GIMT_Encode4(2251841), // Rule ID 48795 //
     /* 2251798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2251804 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2251807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251811 */   // MIs[0] Operand 1
     /* 2251811 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251820 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251824 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2251827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251829 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251831 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251839 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251840 */   // GIR_Coverage, 48795,
     /* 2251840 */   GIR_EraseRootFromParent_Done,
     /* 2251841 */ // Label 30086: @2251841
     /* 2251841 */ GIM_Try, /*On fail goto*//*Label 30087*/ GIMT_Encode4(2251889), // Rule ID 48802 //
     /* 2251846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2251852 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2251855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251859 */   // MIs[0] Operand 1
     /* 2251859 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251868 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251872 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2251875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251877 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251879 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251887 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251888 */   // GIR_Coverage, 48802,
     /* 2251888 */   GIR_EraseRootFromParent_Done,
     /* 2251889 */ // Label 30087: @2251889
     /* 2251889 */ GIM_Try, /*On fail goto*//*Label 30088*/ GIMT_Encode4(2251937), // Rule ID 48803 //
     /* 2251894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2251900 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2251903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251907 */   // MIs[0] Operand 1
     /* 2251907 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251912 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251916 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251920 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2251920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2251923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251925 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251927 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251935 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251936 */   // GIR_Coverage, 48803,
     /* 2251936 */   GIR_EraseRootFromParent_Done,
     /* 2251937 */ // Label 30088: @2251937
     /* 2251937 */ GIM_Try, /*On fail goto*//*Label 30089*/ GIMT_Encode4(2251985), // Rule ID 48828 //
     /* 2251942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2251948 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2251951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251955 */   // MIs[0] Operand 1
     /* 2251955 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2251960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251964 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251968 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2251971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251973 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251975 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251983 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251984 */   // GIR_Coverage, 48828,
     /* 2251984 */   GIR_EraseRootFromParent_Done,
     /* 2251985 */ // Label 30089: @2251985
     /* 2251985 */ GIM_Try, /*On fail goto*//*Label 30090*/ GIMT_Encode4(2252033), // Rule ID 48829 //
     /* 2251990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2251996 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2251999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252003 */   // MIs[0] Operand 1
     /* 2252003 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252012 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252016 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2252019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252021 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252023 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252031 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252032 */   // GIR_Coverage, 48829,
     /* 2252032 */   GIR_EraseRootFromParent_Done,
     /* 2252033 */ // Label 30090: @2252033
     /* 2252033 */ GIM_Try, /*On fail goto*//*Label 30091*/ GIMT_Encode4(2252081), // Rule ID 48834 //
     /* 2252038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2252044 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2252047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252051 */   // MIs[0] Operand 1
     /* 2252051 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252060 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252064 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252069 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252071 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252079 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252080 */   // GIR_Coverage, 48834,
     /* 2252080 */   GIR_EraseRootFromParent_Done,
     /* 2252081 */ // Label 30091: @2252081
     /* 2252081 */ GIM_Try, /*On fail goto*//*Label 30092*/ GIMT_Encode4(2252129), // Rule ID 48835 //
     /* 2252086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2252092 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2252095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252099 */   // MIs[0] Operand 1
     /* 2252099 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252108 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252112 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252117 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252119 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252127 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252128 */   // GIR_Coverage, 48835,
     /* 2252128 */   GIR_EraseRootFromParent_Done,
     /* 2252129 */ // Label 30092: @2252129
     /* 2252129 */ GIM_Try, /*On fail goto*//*Label 30093*/ GIMT_Encode4(2252177), // Rule ID 48838 //
     /* 2252134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2252140 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2252143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252147 */   // MIs[0] Operand 1
     /* 2252147 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252152 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252156 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252160 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252165 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252167 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252175 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252176 */   // GIR_Coverage, 48838,
     /* 2252176 */   GIR_EraseRootFromParent_Done,
     /* 2252177 */ // Label 30093: @2252177
     /* 2252177 */ GIM_Try, /*On fail goto*//*Label 30094*/ GIMT_Encode4(2252225), // Rule ID 48839 //
     /* 2252182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2252188 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2252191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252195 */   // MIs[0] Operand 1
     /* 2252195 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252204 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252208 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252213 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252215 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252223 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252224 */   // GIR_Coverage, 48839,
     /* 2252224 */   GIR_EraseRootFromParent_Done,
     /* 2252225 */ // Label 30094: @2252225
     /* 2252225 */ GIM_Try, /*On fail goto*//*Label 30095*/ GIMT_Encode4(2252273), // Rule ID 48846 //
     /* 2252230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2252233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2252236 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2252239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252243 */   // MIs[0] Operand 1
     /* 2252243 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252252 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252256 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2252256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2252259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252261 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252263 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252271 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252272 */   // GIR_Coverage, 48846,
     /* 2252272 */   GIR_EraseRootFromParent_Done,
     /* 2252273 */ // Label 30095: @2252273
     /* 2252273 */ GIM_Try, /*On fail goto*//*Label 30096*/ GIMT_Encode4(2252321), // Rule ID 48847 //
     /* 2252278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2252281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2252284 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2252287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252291 */   // MIs[0] Operand 1
     /* 2252291 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252300 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252304 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2252304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2252307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252309 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252311 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252319 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252320 */   // GIR_Coverage, 48847,
     /* 2252320 */   GIR_EraseRootFromParent_Done,
     /* 2252321 */ // Label 30096: @2252321
     /* 2252321 */ GIM_Try, /*On fail goto*//*Label 30097*/ GIMT_Encode4(2252369), // Rule ID 48872 //
     /* 2252326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2252332 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2252335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252339 */   // MIs[0] Operand 1
     /* 2252339 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252348 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252352 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2252355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252357 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252359 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252367 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252368 */   // GIR_Coverage, 48872,
     /* 2252368 */   GIR_EraseRootFromParent_Done,
     /* 2252369 */ // Label 30097: @2252369
     /* 2252369 */ GIM_Try, /*On fail goto*//*Label 30098*/ GIMT_Encode4(2252417), // Rule ID 48873 //
     /* 2252374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2252380 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2252383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252387 */   // MIs[0] Operand 1
     /* 2252387 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252396 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252400 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2252403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252405 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252407 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252416 */   // GIR_Coverage, 48873,
     /* 2252416 */   GIR_EraseRootFromParent_Done,
     /* 2252417 */ // Label 30098: @2252417
     /* 2252417 */ GIM_Try, /*On fail goto*//*Label 30099*/ GIMT_Encode4(2252465), // Rule ID 48878 //
     /* 2252422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2252428 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2252431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252435 */   // MIs[0] Operand 1
     /* 2252435 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252444 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252448 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252453 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252455 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252463 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252464 */   // GIR_Coverage, 48878,
     /* 2252464 */   GIR_EraseRootFromParent_Done,
     /* 2252465 */ // Label 30099: @2252465
     /* 2252465 */ GIM_Try, /*On fail goto*//*Label 30100*/ GIMT_Encode4(2252513), // Rule ID 48879 //
     /* 2252470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2252476 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2252479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252483 */   // MIs[0] Operand 1
     /* 2252483 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252492 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252496 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252501 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252503 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252511 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252512 */   // GIR_Coverage, 48879,
     /* 2252512 */   GIR_EraseRootFromParent_Done,
     /* 2252513 */ // Label 30100: @2252513
     /* 2252513 */ GIM_Try, /*On fail goto*//*Label 30101*/ GIMT_Encode4(2252561), // Rule ID 48882 //
     /* 2252518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2252524 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2252527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252531 */   // MIs[0] Operand 1
     /* 2252531 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252540 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252544 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252549 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252551 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252559 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252560 */   // GIR_Coverage, 48882,
     /* 2252560 */   GIR_EraseRootFromParent_Done,
     /* 2252561 */ // Label 30101: @2252561
     /* 2252561 */ GIM_Try, /*On fail goto*//*Label 30102*/ GIMT_Encode4(2252609), // Rule ID 48883 //
     /* 2252566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2252572 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2252575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252579 */   // MIs[0] Operand 1
     /* 2252579 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252588 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252592 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252597 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252599 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252607 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252608 */   // GIR_Coverage, 48883,
     /* 2252608 */   GIR_EraseRootFromParent_Done,
     /* 2252609 */ // Label 30102: @2252609
     /* 2252609 */ GIM_Try, /*On fail goto*//*Label 30103*/ GIMT_Encode4(2252657), // Rule ID 48890 //
     /* 2252614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2252617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2252620 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2252623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252627 */   // MIs[0] Operand 1
     /* 2252627 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252636 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252640 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2252640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2252643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252645 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252647 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252656 */   // GIR_Coverage, 48890,
     /* 2252656 */   GIR_EraseRootFromParent_Done,
     /* 2252657 */ // Label 30103: @2252657
     /* 2252657 */ GIM_Try, /*On fail goto*//*Label 30104*/ GIMT_Encode4(2252705), // Rule ID 48891 //
     /* 2252662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2252665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2252668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2252671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252675 */   // MIs[0] Operand 1
     /* 2252675 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252684 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252688 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2252688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2252691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252693 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252695 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252703 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252704 */   // GIR_Coverage, 48891,
     /* 2252704 */   GIR_EraseRootFromParent_Done,
     /* 2252705 */ // Label 30104: @2252705
     /* 2252705 */ GIM_Reject,
     /* 2252706 */ // Label 29924: @2252706
     /* 2252706 */ GIM_Try, /*On fail goto*//*Label 30105*/ GIMT_Encode4(2252754), // Rule ID 48480 //
     /* 2252711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252717 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252724 */   // MIs[0] Operand 1
     /* 2252724 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2252729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252733 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252737 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2252740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252742 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252744 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252752 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252753 */   // GIR_Coverage, 48480,
     /* 2252753 */   GIR_EraseRootFromParent_Done,
     /* 2252754 */ // Label 30105: @2252754
     /* 2252754 */ GIM_Try, /*On fail goto*//*Label 30106*/ GIMT_Encode4(2252802), // Rule ID 48481 //
     /* 2252759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252772 */   // MIs[0] Operand 1
     /* 2252772 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2252777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252781 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252785 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2252788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252790 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252792 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252800 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252801 */   // GIR_Coverage, 48481,
     /* 2252801 */   GIR_EraseRootFromParent_Done,
     /* 2252802 */ // Label 30106: @2252802
     /* 2252802 */ GIM_Try, /*On fail goto*//*Label 30107*/ GIMT_Encode4(2252850), // Rule ID 48486 //
     /* 2252807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252813 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252820 */   // MIs[0] Operand 1
     /* 2252820 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2252825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252829 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252833 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2252836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252838 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252840 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252848 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252849 */   // GIR_Coverage, 48486,
     /* 2252849 */   GIR_EraseRootFromParent_Done,
     /* 2252850 */ // Label 30107: @2252850
     /* 2252850 */ GIM_Try, /*On fail goto*//*Label 30108*/ GIMT_Encode4(2252898), // Rule ID 48487 //
     /* 2252855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252861 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252868 */   // MIs[0] Operand 1
     /* 2252868 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2252873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252877 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252881 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2252884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252886 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252888 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252896 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252897 */   // GIR_Coverage, 48487,
     /* 2252897 */   GIR_EraseRootFromParent_Done,
     /* 2252898 */ // Label 30108: @2252898
     /* 2252898 */ GIM_Try, /*On fail goto*//*Label 30109*/ GIMT_Encode4(2252946), // Rule ID 48494 //
     /* 2252903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252909 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252916 */   // MIs[0] Operand 1
     /* 2252916 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2252921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252925 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252929 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2252932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252934 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252936 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252944 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252945 */   // GIR_Coverage, 48494,
     /* 2252945 */   GIR_EraseRootFromParent_Done,
     /* 2252946 */ // Label 30109: @2252946
     /* 2252946 */ GIM_Try, /*On fail goto*//*Label 30110*/ GIMT_Encode4(2252994), // Rule ID 48495 //
     /* 2252951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252957 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252964 */   // MIs[0] Operand 1
     /* 2252964 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2252969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252973 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252977 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2252980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252982 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252984 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252992 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252993 */   // GIR_Coverage, 48495,
     /* 2252993 */   GIR_EraseRootFromParent_Done,
     /* 2252994 */ // Label 30110: @2252994
     /* 2252994 */ GIM_Try, /*On fail goto*//*Label 30111*/ GIMT_Encode4(2253042), // Rule ID 48516 //
     /* 2252999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253005 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253012 */   // MIs[0] Operand 1
     /* 2253012 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253021 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253025 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2253028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253030 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253032 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253040 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253041 */   // GIR_Coverage, 48516,
     /* 2253041 */   GIR_EraseRootFromParent_Done,
     /* 2253042 */ // Label 30111: @2253042
     /* 2253042 */ GIM_Try, /*On fail goto*//*Label 30112*/ GIMT_Encode4(2253090), // Rule ID 48517 //
     /* 2253047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253053 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253060 */   // MIs[0] Operand 1
     /* 2253060 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253069 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253073 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2253076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253078 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253080 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253088 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253089 */   // GIR_Coverage, 48517,
     /* 2253089 */   GIR_EraseRootFromParent_Done,
     /* 2253090 */ // Label 30112: @2253090
     /* 2253090 */ GIM_Try, /*On fail goto*//*Label 30113*/ GIMT_Encode4(2253138), // Rule ID 48524 //
     /* 2253095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2253101 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2253104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253108 */   // MIs[0] Operand 1
     /* 2253108 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253117 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253121 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2253124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253126 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253128 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253136 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253137 */   // GIR_Coverage, 48524,
     /* 2253137 */   GIR_EraseRootFromParent_Done,
     /* 2253138 */ // Label 30113: @2253138
     /* 2253138 */ GIM_Try, /*On fail goto*//*Label 30114*/ GIMT_Encode4(2253186), // Rule ID 48525 //
     /* 2253143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2253149 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2253152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253156 */   // MIs[0] Operand 1
     /* 2253156 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253165 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253169 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2253172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253174 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253176 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253184 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253185 */   // GIR_Coverage, 48525,
     /* 2253185 */   GIR_EraseRootFromParent_Done,
     /* 2253186 */ // Label 30114: @2253186
     /* 2253186 */ GIM_Try, /*On fail goto*//*Label 30115*/ GIMT_Encode4(2253234), // Rule ID 48530 //
     /* 2253191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2253197 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2253200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253204 */   // MIs[0] Operand 1
     /* 2253204 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253213 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253217 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2253220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253222 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253224 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253232 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253233 */   // GIR_Coverage, 48530,
     /* 2253233 */   GIR_EraseRootFromParent_Done,
     /* 2253234 */ // Label 30115: @2253234
     /* 2253234 */ GIM_Try, /*On fail goto*//*Label 30116*/ GIMT_Encode4(2253282), // Rule ID 48531 //
     /* 2253239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2253245 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2253248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253252 */   // MIs[0] Operand 1
     /* 2253252 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253261 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253265 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2253268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253270 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253272 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253280 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253281 */   // GIR_Coverage, 48531,
     /* 2253281 */   GIR_EraseRootFromParent_Done,
     /* 2253282 */ // Label 30116: @2253282
     /* 2253282 */ GIM_Try, /*On fail goto*//*Label 30117*/ GIMT_Encode4(2253330), // Rule ID 48538 //
     /* 2253287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2253293 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2253296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253300 */   // MIs[0] Operand 1
     /* 2253300 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253309 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253313 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2253316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253318 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253320 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253328 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253329 */   // GIR_Coverage, 48538,
     /* 2253329 */   GIR_EraseRootFromParent_Done,
     /* 2253330 */ // Label 30117: @2253330
     /* 2253330 */ GIM_Try, /*On fail goto*//*Label 30118*/ GIMT_Encode4(2253378), // Rule ID 48539 //
     /* 2253335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2253341 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2253344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253348 */   // MIs[0] Operand 1
     /* 2253348 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253353 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253357 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253361 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2253364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253366 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253368 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253376 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253377 */   // GIR_Coverage, 48539,
     /* 2253377 */   GIR_EraseRootFromParent_Done,
     /* 2253378 */ // Label 30118: @2253378
     /* 2253378 */ GIM_Try, /*On fail goto*//*Label 30119*/ GIMT_Encode4(2253426), // Rule ID 48560 //
     /* 2253383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253389 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253396 */   // MIs[0] Operand 1
     /* 2253396 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253401 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253405 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253409 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2253412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253414 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253416 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253424 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253425 */   // GIR_Coverage, 48560,
     /* 2253425 */   GIR_EraseRootFromParent_Done,
     /* 2253426 */ // Label 30119: @2253426
     /* 2253426 */ GIM_Try, /*On fail goto*//*Label 30120*/ GIMT_Encode4(2253474), // Rule ID 48561 //
     /* 2253431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253437 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253444 */   // MIs[0] Operand 1
     /* 2253444 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253453 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253457 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2253460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253462 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253464 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253472 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253473 */   // GIR_Coverage, 48561,
     /* 2253473 */   GIR_EraseRootFromParent_Done,
     /* 2253474 */ // Label 30120: @2253474
     /* 2253474 */ GIM_Try, /*On fail goto*//*Label 30121*/ GIMT_Encode4(2253522), // Rule ID 48568 //
     /* 2253479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2253485 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2253488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253492 */   // MIs[0] Operand 1
     /* 2253492 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253497 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253501 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253505 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2253508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253510 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253512 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253520 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253521 */   // GIR_Coverage, 48568,
     /* 2253521 */   GIR_EraseRootFromParent_Done,
     /* 2253522 */ // Label 30121: @2253522
     /* 2253522 */ GIM_Try, /*On fail goto*//*Label 30122*/ GIMT_Encode4(2253570), // Rule ID 48569 //
     /* 2253527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2253533 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2253536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253540 */   // MIs[0] Operand 1
     /* 2253540 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253545 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253549 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253553 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2253556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253558 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253560 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253568 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253569 */   // GIR_Coverage, 48569,
     /* 2253569 */   GIR_EraseRootFromParent_Done,
     /* 2253570 */ // Label 30122: @2253570
     /* 2253570 */ GIM_Try, /*On fail goto*//*Label 30123*/ GIMT_Encode4(2253618), // Rule ID 48574 //
     /* 2253575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2253581 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2253584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253588 */   // MIs[0] Operand 1
     /* 2253588 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253597 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253601 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2253604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253606 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253608 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253616 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253617 */   // GIR_Coverage, 48574,
     /* 2253617 */   GIR_EraseRootFromParent_Done,
     /* 2253618 */ // Label 30123: @2253618
     /* 2253618 */ GIM_Try, /*On fail goto*//*Label 30124*/ GIMT_Encode4(2253666), // Rule ID 48575 //
     /* 2253623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2253629 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2253632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253636 */   // MIs[0] Operand 1
     /* 2253636 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253641 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253645 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253649 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2253652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253654 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253656 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253664 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253665 */   // GIR_Coverage, 48575,
     /* 2253665 */   GIR_EraseRootFromParent_Done,
     /* 2253666 */ // Label 30124: @2253666
     /* 2253666 */ GIM_Try, /*On fail goto*//*Label 30125*/ GIMT_Encode4(2253714), // Rule ID 48582 //
     /* 2253671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2253677 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2253680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253684 */   // MIs[0] Operand 1
     /* 2253684 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253693 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253697 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2253700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253702 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253704 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253712 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253713 */   // GIR_Coverage, 48582,
     /* 2253713 */   GIR_EraseRootFromParent_Done,
     /* 2253714 */ // Label 30125: @2253714
     /* 2253714 */ GIM_Try, /*On fail goto*//*Label 30126*/ GIMT_Encode4(2253762), // Rule ID 48583 //
     /* 2253719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2253725 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2253728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253732 */   // MIs[0] Operand 1
     /* 2253732 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253737 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253741 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253745 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2253748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253750 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253752 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253760 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253761 */   // GIR_Coverage, 48583,
     /* 2253761 */   GIR_EraseRootFromParent_Done,
     /* 2253762 */ // Label 30126: @2253762
     /* 2253762 */ GIM_Try, /*On fail goto*//*Label 30127*/ GIMT_Encode4(2253810), // Rule ID 48604 //
     /* 2253767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253773 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253780 */   // MIs[0] Operand 1
     /* 2253780 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253789 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253793 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2253796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253798 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253800 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253808 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253809 */   // GIR_Coverage, 48604,
     /* 2253809 */   GIR_EraseRootFromParent_Done,
     /* 2253810 */ // Label 30127: @2253810
     /* 2253810 */ GIM_Try, /*On fail goto*//*Label 30128*/ GIMT_Encode4(2253858), // Rule ID 48605 //
     /* 2253815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253821 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253828 */   // MIs[0] Operand 1
     /* 2253828 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253837 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253841 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2253844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253846 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253848 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253856 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253857 */   // GIR_Coverage, 48605,
     /* 2253857 */   GIR_EraseRootFromParent_Done,
     /* 2253858 */ // Label 30128: @2253858
     /* 2253858 */ GIM_Try, /*On fail goto*//*Label 30129*/ GIMT_Encode4(2253906), // Rule ID 48610 //
     /* 2253863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2253869 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2253872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253876 */   // MIs[0] Operand 1
     /* 2253876 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2253881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253885 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253889 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2253892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253894 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253896 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253904 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253905 */   // GIR_Coverage, 48610,
     /* 2253905 */   GIR_EraseRootFromParent_Done,
     /* 2253906 */ // Label 30129: @2253906
     /* 2253906 */ GIM_Try, /*On fail goto*//*Label 30130*/ GIMT_Encode4(2253954), // Rule ID 48611 //
     /* 2253911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2253917 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2253920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253924 */   // MIs[0] Operand 1
     /* 2253924 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2253929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253933 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253937 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2253940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253942 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253944 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253952 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253953 */   // GIR_Coverage, 48611,
     /* 2253953 */   GIR_EraseRootFromParent_Done,
     /* 2253954 */ // Label 30130: @2253954
     /* 2253954 */ GIM_Try, /*On fail goto*//*Label 30131*/ GIMT_Encode4(2254002), // Rule ID 48616 //
     /* 2253959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2253965 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2253968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253972 */   // MIs[0] Operand 1
     /* 2253972 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2253977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253981 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253985 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2253988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253990 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253992 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254000 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254001 */   // GIR_Coverage, 48616,
     /* 2254001 */   GIR_EraseRootFromParent_Done,
     /* 2254002 */ // Label 30131: @2254002
     /* 2254002 */ GIM_Try, /*On fail goto*//*Label 30132*/ GIMT_Encode4(2254050), // Rule ID 48617 //
     /* 2254007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2254013 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2254016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254020 */   // MIs[0] Operand 1
     /* 2254020 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254025 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254029 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254033 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2254036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254038 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254040 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254048 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254049 */   // GIR_Coverage, 48617,
     /* 2254049 */   GIR_EraseRootFromParent_Done,
     /* 2254050 */ // Label 30132: @2254050
     /* 2254050 */ GIM_Try, /*On fail goto*//*Label 30133*/ GIMT_Encode4(2254098), // Rule ID 48624 //
     /* 2254055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2254061 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2254064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254068 */   // MIs[0] Operand 1
     /* 2254068 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254073 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254077 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254081 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254086 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254088 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254096 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254097 */   // GIR_Coverage, 48624,
     /* 2254097 */   GIR_EraseRootFromParent_Done,
     /* 2254098 */ // Label 30133: @2254098
     /* 2254098 */ GIM_Try, /*On fail goto*//*Label 30134*/ GIMT_Encode4(2254146), // Rule ID 48625 //
     /* 2254103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2254109 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2254112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254116 */   // MIs[0] Operand 1
     /* 2254116 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254125 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254129 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254134 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254136 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254145 */   // GIR_Coverage, 48625,
     /* 2254145 */   GIR_EraseRootFromParent_Done,
     /* 2254146 */ // Label 30134: @2254146
     /* 2254146 */ GIM_Try, /*On fail goto*//*Label 30135*/ GIMT_Encode4(2254194), // Rule ID 48646 //
     /* 2254151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2254157 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2254160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254164 */   // MIs[0] Operand 1
     /* 2254164 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254169 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254173 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254177 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254182 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254184 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254192 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254193 */   // GIR_Coverage, 48646,
     /* 2254193 */   GIR_EraseRootFromParent_Done,
     /* 2254194 */ // Label 30135: @2254194
     /* 2254194 */ GIM_Try, /*On fail goto*//*Label 30136*/ GIMT_Encode4(2254242), // Rule ID 48647 //
     /* 2254199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2254205 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2254208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254212 */   // MIs[0] Operand 1
     /* 2254212 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254221 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254225 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254230 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254232 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254240 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254241 */   // GIR_Coverage, 48647,
     /* 2254241 */   GIR_EraseRootFromParent_Done,
     /* 2254242 */ // Label 30136: @2254242
     /* 2254242 */ GIM_Try, /*On fail goto*//*Label 30137*/ GIMT_Encode4(2254290), // Rule ID 48654 //
     /* 2254247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2254253 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2254256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254260 */   // MIs[0] Operand 1
     /* 2254260 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254269 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254273 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2254276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254278 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254280 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254288 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254289 */   // GIR_Coverage, 48654,
     /* 2254289 */   GIR_EraseRootFromParent_Done,
     /* 2254290 */ // Label 30137: @2254290
     /* 2254290 */ GIM_Try, /*On fail goto*//*Label 30138*/ GIMT_Encode4(2254338), // Rule ID 48655 //
     /* 2254295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2254301 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2254304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254308 */   // MIs[0] Operand 1
     /* 2254308 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254317 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254321 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2254324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254326 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254328 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254336 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254337 */   // GIR_Coverage, 48655,
     /* 2254337 */   GIR_EraseRootFromParent_Done,
     /* 2254338 */ // Label 30138: @2254338
     /* 2254338 */ GIM_Try, /*On fail goto*//*Label 30139*/ GIMT_Encode4(2254386), // Rule ID 48660 //
     /* 2254343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2254349 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2254352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254356 */   // MIs[0] Operand 1
     /* 2254356 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254365 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254369 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2254372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254374 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254376 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254384 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254385 */   // GIR_Coverage, 48660,
     /* 2254385 */   GIR_EraseRootFromParent_Done,
     /* 2254386 */ // Label 30139: @2254386
     /* 2254386 */ GIM_Try, /*On fail goto*//*Label 30140*/ GIMT_Encode4(2254434), // Rule ID 48661 //
     /* 2254391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2254397 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2254400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254404 */   // MIs[0] Operand 1
     /* 2254404 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254413 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254417 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2254420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254422 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254424 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254432 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254433 */   // GIR_Coverage, 48661,
     /* 2254433 */   GIR_EraseRootFromParent_Done,
     /* 2254434 */ // Label 30140: @2254434
     /* 2254434 */ GIM_Try, /*On fail goto*//*Label 30141*/ GIMT_Encode4(2254482), // Rule ID 48668 //
     /* 2254439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2254445 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2254448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254452 */   // MIs[0] Operand 1
     /* 2254452 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254461 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254465 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2254468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254470 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254472 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254480 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254481 */   // GIR_Coverage, 48668,
     /* 2254481 */   GIR_EraseRootFromParent_Done,
     /* 2254482 */ // Label 30141: @2254482
     /* 2254482 */ GIM_Try, /*On fail goto*//*Label 30142*/ GIMT_Encode4(2254530), // Rule ID 48669 //
     /* 2254487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2254493 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2254496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254500 */   // MIs[0] Operand 1
     /* 2254500 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254509 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254513 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2254516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254518 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254520 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254528 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254529 */   // GIR_Coverage, 48669,
     /* 2254529 */   GIR_EraseRootFromParent_Done,
     /* 2254530 */ // Label 30142: @2254530
     /* 2254530 */ GIM_Try, /*On fail goto*//*Label 30143*/ GIMT_Encode4(2254578), // Rule ID 48690 //
     /* 2254535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2254541 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2254544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254548 */   // MIs[0] Operand 1
     /* 2254548 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254553 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254557 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254561 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2254564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254566 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254568 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254576 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254577 */   // GIR_Coverage, 48690,
     /* 2254577 */   GIR_EraseRootFromParent_Done,
     /* 2254578 */ // Label 30143: @2254578
     /* 2254578 */ GIM_Try, /*On fail goto*//*Label 30144*/ GIMT_Encode4(2254626), // Rule ID 48691 //
     /* 2254583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2254589 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2254592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254596 */   // MIs[0] Operand 1
     /* 2254596 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254601 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254605 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254609 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2254612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254614 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254616 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254624 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254625 */   // GIR_Coverage, 48691,
     /* 2254625 */   GIR_EraseRootFromParent_Done,
     /* 2254626 */ // Label 30144: @2254626
     /* 2254626 */ GIM_Try, /*On fail goto*//*Label 30145*/ GIMT_Encode4(2254674), // Rule ID 48698 //
     /* 2254631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2254637 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2254640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254644 */   // MIs[0] Operand 1
     /* 2254644 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254653 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254657 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2254660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254662 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254664 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254672 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254673 */   // GIR_Coverage, 48698,
     /* 2254673 */   GIR_EraseRootFromParent_Done,
     /* 2254674 */ // Label 30145: @2254674
     /* 2254674 */ GIM_Try, /*On fail goto*//*Label 30146*/ GIMT_Encode4(2254722), // Rule ID 48699 //
     /* 2254679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2254685 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2254688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254692 */   // MIs[0] Operand 1
     /* 2254692 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254701 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254705 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2254708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254710 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254712 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254720 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254721 */   // GIR_Coverage, 48699,
     /* 2254721 */   GIR_EraseRootFromParent_Done,
     /* 2254722 */ // Label 30146: @2254722
     /* 2254722 */ GIM_Try, /*On fail goto*//*Label 30147*/ GIMT_Encode4(2254770), // Rule ID 48704 //
     /* 2254727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2254733 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2254736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254740 */   // MIs[0] Operand 1
     /* 2254740 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254749 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254753 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2254756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254758 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254760 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254768 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254769 */   // GIR_Coverage, 48704,
     /* 2254769 */   GIR_EraseRootFromParent_Done,
     /* 2254770 */ // Label 30147: @2254770
     /* 2254770 */ GIM_Try, /*On fail goto*//*Label 30148*/ GIMT_Encode4(2254818), // Rule ID 48705 //
     /* 2254775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2254781 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2254784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254788 */   // MIs[0] Operand 1
     /* 2254788 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254793 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254797 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254801 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2254804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254806 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254808 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254816 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254817 */   // GIR_Coverage, 48705,
     /* 2254817 */   GIR_EraseRootFromParent_Done,
     /* 2254818 */ // Label 30148: @2254818
     /* 2254818 */ GIM_Try, /*On fail goto*//*Label 30149*/ GIMT_Encode4(2254866), // Rule ID 48712 //
     /* 2254823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2254829 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2254832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254836 */   // MIs[0] Operand 1
     /* 2254836 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254845 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254849 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2254852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254854 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254856 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254864 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254865 */   // GIR_Coverage, 48712,
     /* 2254865 */   GIR_EraseRootFromParent_Done,
     /* 2254866 */ // Label 30149: @2254866
     /* 2254866 */ GIM_Try, /*On fail goto*//*Label 30150*/ GIMT_Encode4(2254914), // Rule ID 48713 //
     /* 2254871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2254877 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2254880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254884 */   // MIs[0] Operand 1
     /* 2254884 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254893 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254897 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2254900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254902 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254904 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254912 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254913 */   // GIR_Coverage, 48713,
     /* 2254913 */   GIR_EraseRootFromParent_Done,
     /* 2254914 */ // Label 30150: @2254914
     /* 2254914 */ GIM_Try, /*On fail goto*//*Label 30151*/ GIMT_Encode4(2254962), // Rule ID 48734 //
     /* 2254919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2254925 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2254928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254932 */   // MIs[0] Operand 1
     /* 2254932 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254941 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254945 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2254948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254950 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254952 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254960 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254961 */   // GIR_Coverage, 48734,
     /* 2254961 */   GIR_EraseRootFromParent_Done,
     /* 2254962 */ // Label 30151: @2254962
     /* 2254962 */ GIM_Try, /*On fail goto*//*Label 30152*/ GIMT_Encode4(2255010), // Rule ID 48735 //
     /* 2254967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2254973 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2254976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254980 */   // MIs[0] Operand 1
     /* 2254980 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254989 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254993 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2254996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254998 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255000 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255008 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255009 */   // GIR_Coverage, 48735,
     /* 2255009 */   GIR_EraseRootFromParent_Done,
     /* 2255010 */ // Label 30152: @2255010
     /* 2255010 */ GIM_Try, /*On fail goto*//*Label 30153*/ GIMT_Encode4(2255058), // Rule ID 48742 //
     /* 2255015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2255021 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2255024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255028 */   // MIs[0] Operand 1
     /* 2255028 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255033 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255037 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255041 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2255044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255046 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255048 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255056 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255057 */   // GIR_Coverage, 48742,
     /* 2255057 */   GIR_EraseRootFromParent_Done,
     /* 2255058 */ // Label 30153: @2255058
     /* 2255058 */ GIM_Try, /*On fail goto*//*Label 30154*/ GIMT_Encode4(2255106), // Rule ID 48743 //
     /* 2255063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2255069 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2255072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255076 */   // MIs[0] Operand 1
     /* 2255076 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255085 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255089 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2255092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255094 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255096 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255104 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255105 */   // GIR_Coverage, 48743,
     /* 2255105 */   GIR_EraseRootFromParent_Done,
     /* 2255106 */ // Label 30154: @2255106
     /* 2255106 */ GIM_Try, /*On fail goto*//*Label 30155*/ GIMT_Encode4(2255154), // Rule ID 48748 //
     /* 2255111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2255117 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2255120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255124 */   // MIs[0] Operand 1
     /* 2255124 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255133 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255137 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255142 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255144 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255152 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255153 */   // GIR_Coverage, 48748,
     /* 2255153 */   GIR_EraseRootFromParent_Done,
     /* 2255154 */ // Label 30155: @2255154
     /* 2255154 */ GIM_Try, /*On fail goto*//*Label 30156*/ GIMT_Encode4(2255202), // Rule ID 48749 //
     /* 2255159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2255165 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2255168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255172 */   // MIs[0] Operand 1
     /* 2255172 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255181 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255185 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255190 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255192 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255200 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255201 */   // GIR_Coverage, 48749,
     /* 2255201 */   GIR_EraseRootFromParent_Done,
     /* 2255202 */ // Label 30156: @2255202
     /* 2255202 */ GIM_Try, /*On fail goto*//*Label 30157*/ GIMT_Encode4(2255250), // Rule ID 48756 //
     /* 2255207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2255213 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2255216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255220 */   // MIs[0] Operand 1
     /* 2255220 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255229 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255233 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2255236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255238 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255240 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255248 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255249 */   // GIR_Coverage, 48756,
     /* 2255249 */   GIR_EraseRootFromParent_Done,
     /* 2255250 */ // Label 30157: @2255250
     /* 2255250 */ GIM_Try, /*On fail goto*//*Label 30158*/ GIMT_Encode4(2255298), // Rule ID 48757 //
     /* 2255255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2255261 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2255264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255268 */   // MIs[0] Operand 1
     /* 2255268 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255277 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255281 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2255284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255286 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255288 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255296 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255297 */   // GIR_Coverage, 48757,
     /* 2255297 */   GIR_EraseRootFromParent_Done,
     /* 2255298 */ // Label 30158: @2255298
     /* 2255298 */ GIM_Try, /*On fail goto*//*Label 30159*/ GIMT_Encode4(2255346), // Rule ID 48778 //
     /* 2255303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2255306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2255309 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2255312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255316 */   // MIs[0] Operand 1
     /* 2255316 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255321 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255325 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255329 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2255332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255334 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255336 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255344 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255345 */   // GIR_Coverage, 48778,
     /* 2255345 */   GIR_EraseRootFromParent_Done,
     /* 2255346 */ // Label 30159: @2255346
     /* 2255346 */ GIM_Try, /*On fail goto*//*Label 30160*/ GIMT_Encode4(2255394), // Rule ID 48779 //
     /* 2255351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2255354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2255357 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2255360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255364 */   // MIs[0] Operand 1
     /* 2255364 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255373 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255377 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2255380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255382 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255384 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255392 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255393 */   // GIR_Coverage, 48779,
     /* 2255393 */   GIR_EraseRootFromParent_Done,
     /* 2255394 */ // Label 30160: @2255394
     /* 2255394 */ GIM_Try, /*On fail goto*//*Label 30161*/ GIMT_Encode4(2255442), // Rule ID 48786 //
     /* 2255399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2255405 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2255408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255412 */   // MIs[0] Operand 1
     /* 2255412 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255417 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255421 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255425 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2255428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255430 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255432 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255440 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255441 */   // GIR_Coverage, 48786,
     /* 2255441 */   GIR_EraseRootFromParent_Done,
     /* 2255442 */ // Label 30161: @2255442
     /* 2255442 */ GIM_Try, /*On fail goto*//*Label 30162*/ GIMT_Encode4(2255490), // Rule ID 48787 //
     /* 2255447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2255453 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2255456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255460 */   // MIs[0] Operand 1
     /* 2255460 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255469 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255473 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2255476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255478 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255480 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255488 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255489 */   // GIR_Coverage, 48787,
     /* 2255489 */   GIR_EraseRootFromParent_Done,
     /* 2255490 */ // Label 30162: @2255490
     /* 2255490 */ GIM_Try, /*On fail goto*//*Label 30163*/ GIMT_Encode4(2255538), // Rule ID 48792 //
     /* 2255495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2255501 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2255504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255508 */   // MIs[0] Operand 1
     /* 2255508 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255513 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255517 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255521 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255526 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255528 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255536 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255537 */   // GIR_Coverage, 48792,
     /* 2255537 */   GIR_EraseRootFromParent_Done,
     /* 2255538 */ // Label 30163: @2255538
     /* 2255538 */ GIM_Try, /*On fail goto*//*Label 30164*/ GIMT_Encode4(2255586), // Rule ID 48793 //
     /* 2255543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2255549 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2255552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255556 */   // MIs[0] Operand 1
     /* 2255556 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255565 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255569 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255574 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255576 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255584 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255585 */   // GIR_Coverage, 48793,
     /* 2255585 */   GIR_EraseRootFromParent_Done,
     /* 2255586 */ // Label 30164: @2255586
     /* 2255586 */ GIM_Try, /*On fail goto*//*Label 30165*/ GIMT_Encode4(2255634), // Rule ID 48800 //
     /* 2255591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2255597 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2255600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255604 */   // MIs[0] Operand 1
     /* 2255604 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255613 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255617 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2255620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255622 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255624 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255632 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255633 */   // GIR_Coverage, 48800,
     /* 2255633 */   GIR_EraseRootFromParent_Done,
     /* 2255634 */ // Label 30165: @2255634
     /* 2255634 */ GIM_Try, /*On fail goto*//*Label 30166*/ GIMT_Encode4(2255682), // Rule ID 48801 //
     /* 2255639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2255645 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2255648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255652 */   // MIs[0] Operand 1
     /* 2255652 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255661 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255665 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2255668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255670 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255672 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255680 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255681 */   // GIR_Coverage, 48801,
     /* 2255681 */   GIR_EraseRootFromParent_Done,
     /* 2255682 */ // Label 30166: @2255682
     /* 2255682 */ GIM_Try, /*On fail goto*//*Label 30167*/ GIMT_Encode4(2255730), // Rule ID 48822 //
     /* 2255687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2255690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2255693 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2255696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255700 */   // MIs[0] Operand 1
     /* 2255700 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255709 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255713 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2255716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255718 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255720 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255728 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255729 */   // GIR_Coverage, 48822,
     /* 2255729 */   GIR_EraseRootFromParent_Done,
     /* 2255730 */ // Label 30167: @2255730
     /* 2255730 */ GIM_Try, /*On fail goto*//*Label 30168*/ GIMT_Encode4(2255778), // Rule ID 48823 //
     /* 2255735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2255738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2255741 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2255744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255748 */   // MIs[0] Operand 1
     /* 2255748 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255757 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255761 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2255764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255766 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255768 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255776 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255777 */   // GIR_Coverage, 48823,
     /* 2255777 */   GIR_EraseRootFromParent_Done,
     /* 2255778 */ // Label 30168: @2255778
     /* 2255778 */ GIM_Try, /*On fail goto*//*Label 30169*/ GIMT_Encode4(2255826), // Rule ID 48830 //
     /* 2255783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2255789 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2255792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255796 */   // MIs[0] Operand 1
     /* 2255796 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255805 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255809 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2255812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255814 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255816 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255824 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255825 */   // GIR_Coverage, 48830,
     /* 2255825 */   GIR_EraseRootFromParent_Done,
     /* 2255826 */ // Label 30169: @2255826
     /* 2255826 */ GIM_Try, /*On fail goto*//*Label 30170*/ GIMT_Encode4(2255874), // Rule ID 48831 //
     /* 2255831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2255837 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2255840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255844 */   // MIs[0] Operand 1
     /* 2255844 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255853 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255857 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2255860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255862 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255864 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255872 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255873 */   // GIR_Coverage, 48831,
     /* 2255873 */   GIR_EraseRootFromParent_Done,
     /* 2255874 */ // Label 30170: @2255874
     /* 2255874 */ GIM_Try, /*On fail goto*//*Label 30171*/ GIMT_Encode4(2255922), // Rule ID 48836 //
     /* 2255879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2255885 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2255888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255892 */   // MIs[0] Operand 1
     /* 2255892 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255901 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255905 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2255908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255910 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255912 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255920 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255921 */   // GIR_Coverage, 48836,
     /* 2255921 */   GIR_EraseRootFromParent_Done,
     /* 2255922 */ // Label 30171: @2255922
     /* 2255922 */ GIM_Try, /*On fail goto*//*Label 30172*/ GIMT_Encode4(2255970), // Rule ID 48837 //
     /* 2255927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2255933 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2255936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255940 */   // MIs[0] Operand 1
     /* 2255940 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255949 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255953 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2255956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255958 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255960 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255968 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255969 */   // GIR_Coverage, 48837,
     /* 2255969 */   GIR_EraseRootFromParent_Done,
     /* 2255970 */ // Label 30172: @2255970
     /* 2255970 */ GIM_Try, /*On fail goto*//*Label 30173*/ GIMT_Encode4(2256018), // Rule ID 48844 //
     /* 2255975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2255981 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2255984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255988 */   // MIs[0] Operand 1
     /* 2255988 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255997 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256001 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256006 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256008 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256016 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256017 */   // GIR_Coverage, 48844,
     /* 2256017 */   GIR_EraseRootFromParent_Done,
     /* 2256018 */ // Label 30173: @2256018
     /* 2256018 */ GIM_Try, /*On fail goto*//*Label 30174*/ GIMT_Encode4(2256066), // Rule ID 48845 //
     /* 2256023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2256029 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2256032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256036 */   // MIs[0] Operand 1
     /* 2256036 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256045 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256049 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256054 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256056 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256064 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256065 */   // GIR_Coverage, 48845,
     /* 2256065 */   GIR_EraseRootFromParent_Done,
     /* 2256066 */ // Label 30174: @2256066
     /* 2256066 */ GIM_Try, /*On fail goto*//*Label 30175*/ GIMT_Encode4(2256114), // Rule ID 48866 //
     /* 2256071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2256077 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2256080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256084 */   // MIs[0] Operand 1
     /* 2256084 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256093 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256097 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256102 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256104 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256112 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256113 */   // GIR_Coverage, 48866,
     /* 2256113 */   GIR_EraseRootFromParent_Done,
     /* 2256114 */ // Label 30175: @2256114
     /* 2256114 */ GIM_Try, /*On fail goto*//*Label 30176*/ GIMT_Encode4(2256162), // Rule ID 48867 //
     /* 2256119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2256125 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2256128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256132 */   // MIs[0] Operand 1
     /* 2256132 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256141 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256145 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256150 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256152 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256160 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256161 */   // GIR_Coverage, 48867,
     /* 2256161 */   GIR_EraseRootFromParent_Done,
     /* 2256162 */ // Label 30176: @2256162
     /* 2256162 */ GIM_Try, /*On fail goto*//*Label 30177*/ GIMT_Encode4(2256210), // Rule ID 48874 //
     /* 2256167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2256173 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2256176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256180 */   // MIs[0] Operand 1
     /* 2256180 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256189 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256193 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2256196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256198 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256200 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256208 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256209 */   // GIR_Coverage, 48874,
     /* 2256209 */   GIR_EraseRootFromParent_Done,
     /* 2256210 */ // Label 30177: @2256210
     /* 2256210 */ GIM_Try, /*On fail goto*//*Label 30178*/ GIMT_Encode4(2256258), // Rule ID 48875 //
     /* 2256215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2256221 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2256224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256228 */   // MIs[0] Operand 1
     /* 2256228 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256237 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256241 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2256244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256246 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256248 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256256 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256257 */   // GIR_Coverage, 48875,
     /* 2256257 */   GIR_EraseRootFromParent_Done,
     /* 2256258 */ // Label 30178: @2256258
     /* 2256258 */ GIM_Try, /*On fail goto*//*Label 30179*/ GIMT_Encode4(2256306), // Rule ID 48880 //
     /* 2256263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2256269 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2256272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256276 */   // MIs[0] Operand 1
     /* 2256276 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256285 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256289 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2256292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256294 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256296 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256304 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256305 */   // GIR_Coverage, 48880,
     /* 2256305 */   GIR_EraseRootFromParent_Done,
     /* 2256306 */ // Label 30179: @2256306
     /* 2256306 */ GIM_Try, /*On fail goto*//*Label 30180*/ GIMT_Encode4(2256354), // Rule ID 48881 //
     /* 2256311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2256317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2256320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256324 */   // MIs[0] Operand 1
     /* 2256324 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256333 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256337 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2256340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256342 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256344 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256352 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256353 */   // GIR_Coverage, 48881,
     /* 2256353 */   GIR_EraseRootFromParent_Done,
     /* 2256354 */ // Label 30180: @2256354
     /* 2256354 */ GIM_Try, /*On fail goto*//*Label 30181*/ GIMT_Encode4(2256402), // Rule ID 48888 //
     /* 2256359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2256365 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2256368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256372 */   // MIs[0] Operand 1
     /* 2256372 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256381 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256385 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256390 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256392 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256400 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256401 */   // GIR_Coverage, 48888,
     /* 2256401 */   GIR_EraseRootFromParent_Done,
     /* 2256402 */ // Label 30181: @2256402
     /* 2256402 */ GIM_Try, /*On fail goto*//*Label 30182*/ GIMT_Encode4(2256450), // Rule ID 48889 //
     /* 2256407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2256413 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2256416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256420 */   // MIs[0] Operand 1
     /* 2256420 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256429 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256433 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256438 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256440 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256448 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256449 */   // GIR_Coverage, 48889,
     /* 2256449 */   GIR_EraseRootFromParent_Done,
     /* 2256450 */ // Label 30182: @2256450
     /* 2256450 */ GIM_Try, /*On fail goto*//*Label 30183*/ GIMT_Encode4(2256498), // Rule ID 48910 //
     /* 2256455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2256461 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2256464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256468 */   // MIs[0] Operand 1
     /* 2256468 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256477 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256481 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256486 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256488 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256496 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256497 */   // GIR_Coverage, 48910,
     /* 2256497 */   GIR_EraseRootFromParent_Done,
     /* 2256498 */ // Label 30183: @2256498
     /* 2256498 */ GIM_Try, /*On fail goto*//*Label 30184*/ GIMT_Encode4(2256546), // Rule ID 48911 //
     /* 2256503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2256509 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2256512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256516 */   // MIs[0] Operand 1
     /* 2256516 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256525 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256529 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256534 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256536 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256545 */   // GIR_Coverage, 48911,
     /* 2256545 */   GIR_EraseRootFromParent_Done,
     /* 2256546 */ // Label 30184: @2256546
     /* 2256546 */ GIM_Reject,
     /* 2256547 */ // Label 29925: @2256547
     /* 2256547 */ GIM_Try, /*On fail goto*//*Label 30185*/ GIMT_Encode4(2256595), // Rule ID 48482 //
     /* 2256552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256558 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256565 */   // MIs[0] Operand 1
     /* 2256565 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256574 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256578 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2256581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256583 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256585 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256593 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256594 */   // GIR_Coverage, 48482,
     /* 2256594 */   GIR_EraseRootFromParent_Done,
     /* 2256595 */ // Label 30185: @2256595
     /* 2256595 */ GIM_Try, /*On fail goto*//*Label 30186*/ GIMT_Encode4(2256643), // Rule ID 48483 //
     /* 2256600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256606 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256613 */   // MIs[0] Operand 1
     /* 2256613 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256618 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256622 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256626 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2256629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256631 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256633 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256641 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256642 */   // GIR_Coverage, 48483,
     /* 2256642 */   GIR_EraseRootFromParent_Done,
     /* 2256643 */ // Label 30186: @2256643
     /* 2256643 */ GIM_Try, /*On fail goto*//*Label 30187*/ GIMT_Encode4(2256691), // Rule ID 48492 //
     /* 2256648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256654 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256661 */   // MIs[0] Operand 1
     /* 2256661 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256670 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256674 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2256677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256679 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256681 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256689 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256690 */   // GIR_Coverage, 48492,
     /* 2256690 */   GIR_EraseRootFromParent_Done,
     /* 2256691 */ // Label 30187: @2256691
     /* 2256691 */ GIM_Try, /*On fail goto*//*Label 30188*/ GIMT_Encode4(2256739), // Rule ID 48493 //
     /* 2256696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256702 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256709 */   // MIs[0] Operand 1
     /* 2256709 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256718 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256722 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2256725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256727 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256729 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256737 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256738 */   // GIR_Coverage, 48493,
     /* 2256738 */   GIR_EraseRootFromParent_Done,
     /* 2256739 */ // Label 30188: @2256739
     /* 2256739 */ GIM_Try, /*On fail goto*//*Label 30189*/ GIMT_Encode4(2256787), // Rule ID 48510 //
     /* 2256744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256750 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256757 */   // MIs[0] Operand 1
     /* 2256757 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256766 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256770 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2256773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256775 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256777 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256785 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256786 */   // GIR_Coverage, 48510,
     /* 2256786 */   GIR_EraseRootFromParent_Done,
     /* 2256787 */ // Label 30189: @2256787
     /* 2256787 */ GIM_Try, /*On fail goto*//*Label 30190*/ GIMT_Encode4(2256835), // Rule ID 48511 //
     /* 2256792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256798 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256805 */   // MIs[0] Operand 1
     /* 2256805 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256814 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256818 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2256821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256823 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256825 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256833 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256834 */   // GIR_Coverage, 48511,
     /* 2256834 */   GIR_EraseRootFromParent_Done,
     /* 2256835 */ // Label 30190: @2256835
     /* 2256835 */ GIM_Try, /*On fail goto*//*Label 30191*/ GIMT_Encode4(2256883), // Rule ID 48518 //
     /* 2256840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256846 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256853 */   // MIs[0] Operand 1
     /* 2256853 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256858 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256862 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256866 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2256869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256871 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256873 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256881 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256882 */   // GIR_Coverage, 48518,
     /* 2256882 */   GIR_EraseRootFromParent_Done,
     /* 2256883 */ // Label 30191: @2256883
     /* 2256883 */ GIM_Try, /*On fail goto*//*Label 30192*/ GIMT_Encode4(2256931), // Rule ID 48519 //
     /* 2256888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256894 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256901 */   // MIs[0] Operand 1
     /* 2256901 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256906 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256910 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256914 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2256917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256919 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256921 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256929 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256930 */   // GIR_Coverage, 48519,
     /* 2256930 */   GIR_EraseRootFromParent_Done,
     /* 2256931 */ // Label 30192: @2256931
     /* 2256931 */ GIM_Try, /*On fail goto*//*Label 30193*/ GIMT_Encode4(2256979), // Rule ID 48526 //
     /* 2256936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256942 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256949 */   // MIs[0] Operand 1
     /* 2256949 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2256954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256958 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256962 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2256965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256967 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256969 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256977 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256978 */   // GIR_Coverage, 48526,
     /* 2256978 */   GIR_EraseRootFromParent_Done,
     /* 2256979 */ // Label 30193: @2256979
     /* 2256979 */ GIM_Try, /*On fail goto*//*Label 30194*/ GIMT_Encode4(2257027), // Rule ID 48527 //
     /* 2256984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256990 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256997 */   // MIs[0] Operand 1
     /* 2256997 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257002 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257006 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257010 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2257013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257015 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257017 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257025 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257026 */   // GIR_Coverage, 48527,
     /* 2257026 */   GIR_EraseRootFromParent_Done,
     /* 2257027 */ // Label 30194: @2257027
     /* 2257027 */ GIM_Try, /*On fail goto*//*Label 30195*/ GIMT_Encode4(2257075), // Rule ID 48536 //
     /* 2257032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2257038 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2257041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257045 */   // MIs[0] Operand 1
     /* 2257045 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257050 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257054 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257058 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2257061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257063 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257065 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257073 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257074 */   // GIR_Coverage, 48536,
     /* 2257074 */   GIR_EraseRootFromParent_Done,
     /* 2257075 */ // Label 30195: @2257075
     /* 2257075 */ GIM_Try, /*On fail goto*//*Label 30196*/ GIMT_Encode4(2257123), // Rule ID 48537 //
     /* 2257080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2257086 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2257089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257093 */   // MIs[0] Operand 1
     /* 2257093 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257102 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257106 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2257109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257111 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257113 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257121 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257122 */   // GIR_Coverage, 48537,
     /* 2257122 */   GIR_EraseRootFromParent_Done,
     /* 2257123 */ // Label 30196: @2257123
     /* 2257123 */ GIM_Try, /*On fail goto*//*Label 30197*/ GIMT_Encode4(2257171), // Rule ID 48554 //
     /* 2257128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2257134 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2257137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257141 */   // MIs[0] Operand 1
     /* 2257141 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257146 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257150 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257154 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2257157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257159 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257161 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257170 */   // GIR_Coverage, 48554,
     /* 2257170 */   GIR_EraseRootFromParent_Done,
     /* 2257171 */ // Label 30197: @2257171
     /* 2257171 */ GIM_Try, /*On fail goto*//*Label 30198*/ GIMT_Encode4(2257219), // Rule ID 48555 //
     /* 2257176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2257182 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2257185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257189 */   // MIs[0] Operand 1
     /* 2257189 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257198 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257202 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2257205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257207 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257209 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257217 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257218 */   // GIR_Coverage, 48555,
     /* 2257218 */   GIR_EraseRootFromParent_Done,
     /* 2257219 */ // Label 30198: @2257219
     /* 2257219 */ GIM_Try, /*On fail goto*//*Label 30199*/ GIMT_Encode4(2257267), // Rule ID 48562 //
     /* 2257224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2257227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2257230 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2257233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257237 */   // MIs[0] Operand 1
     /* 2257237 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257246 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257250 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2257250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2257253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257255 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257257 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257265 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257266 */   // GIR_Coverage, 48562,
     /* 2257266 */   GIR_EraseRootFromParent_Done,
     /* 2257267 */ // Label 30199: @2257267
     /* 2257267 */ GIM_Try, /*On fail goto*//*Label 30200*/ GIMT_Encode4(2257315), // Rule ID 48563 //
     /* 2257272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2257275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2257278 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2257281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257285 */   // MIs[0] Operand 1
     /* 2257285 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257294 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257298 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2257301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257303 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257305 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257313 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257314 */   // GIR_Coverage, 48563,
     /* 2257314 */   GIR_EraseRootFromParent_Done,
     /* 2257315 */ // Label 30200: @2257315
     /* 2257315 */ GIM_Try, /*On fail goto*//*Label 30201*/ GIMT_Encode4(2257363), // Rule ID 48570 //
     /* 2257320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2257326 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2257329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257333 */   // MIs[0] Operand 1
     /* 2257333 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257342 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257346 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2257349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257351 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257353 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257361 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257362 */   // GIR_Coverage, 48570,
     /* 2257362 */   GIR_EraseRootFromParent_Done,
     /* 2257363 */ // Label 30201: @2257363
     /* 2257363 */ GIM_Try, /*On fail goto*//*Label 30202*/ GIMT_Encode4(2257411), // Rule ID 48571 //
     /* 2257368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2257374 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2257377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257381 */   // MIs[0] Operand 1
     /* 2257381 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257386 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257390 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257394 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2257397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257399 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257401 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257409 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257410 */   // GIR_Coverage, 48571,
     /* 2257410 */   GIR_EraseRootFromParent_Done,
     /* 2257411 */ // Label 30202: @2257411
     /* 2257411 */ GIM_Try, /*On fail goto*//*Label 30203*/ GIMT_Encode4(2257459), // Rule ID 48580 //
     /* 2257416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2257422 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2257425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257429 */   // MIs[0] Operand 1
     /* 2257429 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257438 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257442 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2257445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257447 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257449 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257457 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257458 */   // GIR_Coverage, 48580,
     /* 2257458 */   GIR_EraseRootFromParent_Done,
     /* 2257459 */ // Label 30203: @2257459
     /* 2257459 */ GIM_Try, /*On fail goto*//*Label 30204*/ GIMT_Encode4(2257507), // Rule ID 48581 //
     /* 2257464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2257470 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2257473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257477 */   // MIs[0] Operand 1
     /* 2257477 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257486 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257490 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2257493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257495 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257497 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257505 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257506 */   // GIR_Coverage, 48581,
     /* 2257506 */   GIR_EraseRootFromParent_Done,
     /* 2257507 */ // Label 30204: @2257507
     /* 2257507 */ GIM_Try, /*On fail goto*//*Label 30205*/ GIMT_Encode4(2257555), // Rule ID 48598 //
     /* 2257512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2257518 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2257521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257525 */   // MIs[0] Operand 1
     /* 2257525 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257534 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257538 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2257541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257543 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257545 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257553 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257554 */   // GIR_Coverage, 48598,
     /* 2257554 */   GIR_EraseRootFromParent_Done,
     /* 2257555 */ // Label 30205: @2257555
     /* 2257555 */ GIM_Try, /*On fail goto*//*Label 30206*/ GIMT_Encode4(2257603), // Rule ID 48599 //
     /* 2257560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2257566 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2257569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257573 */   // MIs[0] Operand 1
     /* 2257573 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257582 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257586 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2257589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257591 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257593 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257601 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257602 */   // GIR_Coverage, 48599,
     /* 2257602 */   GIR_EraseRootFromParent_Done,
     /* 2257603 */ // Label 30206: @2257603
     /* 2257603 */ GIM_Try, /*On fail goto*//*Label 30207*/ GIMT_Encode4(2257651), // Rule ID 48606 //
     /* 2257608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2257611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2257614 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2257617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257621 */   // MIs[0] Operand 1
     /* 2257621 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257626 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257630 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257634 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2257634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2257637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257639 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257641 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257649 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257650 */   // GIR_Coverage, 48606,
     /* 2257650 */   GIR_EraseRootFromParent_Done,
     /* 2257651 */ // Label 30207: @2257651
     /* 2257651 */ GIM_Try, /*On fail goto*//*Label 30208*/ GIMT_Encode4(2257699), // Rule ID 48607 //
     /* 2257656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2257659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2257662 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2257665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257669 */   // MIs[0] Operand 1
     /* 2257669 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257674 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257678 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257682 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2257685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257687 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257689 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257697 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257698 */   // GIR_Coverage, 48607,
     /* 2257698 */   GIR_EraseRootFromParent_Done,
     /* 2257699 */ // Label 30208: @2257699
     /* 2257699 */ GIM_Try, /*On fail goto*//*Label 30209*/ GIMT_Encode4(2257747), // Rule ID 48612 //
     /* 2257704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2257710 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2257713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257717 */   // MIs[0] Operand 1
     /* 2257717 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2257722 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257726 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257730 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2257733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257735 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257737 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257745 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257746 */   // GIR_Coverage, 48612,
     /* 2257746 */   GIR_EraseRootFromParent_Done,
     /* 2257747 */ // Label 30209: @2257747
     /* 2257747 */ GIM_Try, /*On fail goto*//*Label 30210*/ GIMT_Encode4(2257795), // Rule ID 48613 //
     /* 2257752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2257758 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2257761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257765 */   // MIs[0] Operand 1
     /* 2257765 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2257770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257774 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257778 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2257781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257783 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257785 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257793 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257794 */   // GIR_Coverage, 48613,
     /* 2257794 */   GIR_EraseRootFromParent_Done,
     /* 2257795 */ // Label 30210: @2257795
     /* 2257795 */ GIM_Try, /*On fail goto*//*Label 30211*/ GIMT_Encode4(2257843), // Rule ID 48622 //
     /* 2257800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2257806 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2257809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257813 */   // MIs[0] Operand 1
     /* 2257813 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2257818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257822 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257826 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2257829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257831 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257833 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257841 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257842 */   // GIR_Coverage, 48622,
     /* 2257842 */   GIR_EraseRootFromParent_Done,
     /* 2257843 */ // Label 30211: @2257843
     /* 2257843 */ GIM_Try, /*On fail goto*//*Label 30212*/ GIMT_Encode4(2257891), // Rule ID 48623 //
     /* 2257848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2257854 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2257857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257861 */   // MIs[0] Operand 1
     /* 2257861 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2257866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257870 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257874 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2257877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257879 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257881 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257889 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257890 */   // GIR_Coverage, 48623,
     /* 2257890 */   GIR_EraseRootFromParent_Done,
     /* 2257891 */ // Label 30212: @2257891
     /* 2257891 */ GIM_Try, /*On fail goto*//*Label 30213*/ GIMT_Encode4(2257939), // Rule ID 48640 //
     /* 2257896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2257902 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2257905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257909 */   // MIs[0] Operand 1
     /* 2257909 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2257914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257918 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257922 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2257925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257927 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257929 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257937 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257938 */   // GIR_Coverage, 48640,
     /* 2257938 */   GIR_EraseRootFromParent_Done,
     /* 2257939 */ // Label 30213: @2257939
     /* 2257939 */ GIM_Try, /*On fail goto*//*Label 30214*/ GIMT_Encode4(2257987), // Rule ID 48641 //
     /* 2257944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2257950 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2257953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257957 */   // MIs[0] Operand 1
     /* 2257957 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2257962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257966 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257970 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2257973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257975 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257977 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257986 */   // GIR_Coverage, 48641,
     /* 2257986 */   GIR_EraseRootFromParent_Done,
     /* 2257987 */ // Label 30214: @2257987
     /* 2257987 */ GIM_Try, /*On fail goto*//*Label 30215*/ GIMT_Encode4(2258035), // Rule ID 48648 //
     /* 2257992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2257995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2257998 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2258001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258005 */   // MIs[0] Operand 1
     /* 2258005 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258014 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258018 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2258021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258023 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258025 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258033 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258034 */   // GIR_Coverage, 48648,
     /* 2258034 */   GIR_EraseRootFromParent_Done,
     /* 2258035 */ // Label 30215: @2258035
     /* 2258035 */ GIM_Try, /*On fail goto*//*Label 30216*/ GIMT_Encode4(2258083), // Rule ID 48649 //
     /* 2258040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2258046 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2258049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258053 */   // MIs[0] Operand 1
     /* 2258053 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258062 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258066 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2258069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258071 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258073 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258081 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258082 */   // GIR_Coverage, 48649,
     /* 2258082 */   GIR_EraseRootFromParent_Done,
     /* 2258083 */ // Label 30216: @2258083
     /* 2258083 */ GIM_Try, /*On fail goto*//*Label 30217*/ GIMT_Encode4(2258131), // Rule ID 48656 //
     /* 2258088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2258094 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2258097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258101 */   // MIs[0] Operand 1
     /* 2258101 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258106 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258110 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258114 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2258117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258119 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258121 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258129 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258130 */   // GIR_Coverage, 48656,
     /* 2258130 */   GIR_EraseRootFromParent_Done,
     /* 2258131 */ // Label 30217: @2258131
     /* 2258131 */ GIM_Try, /*On fail goto*//*Label 30218*/ GIMT_Encode4(2258179), // Rule ID 48657 //
     /* 2258136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2258142 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2258145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258149 */   // MIs[0] Operand 1
     /* 2258149 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258158 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258162 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2258165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258167 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258169 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258177 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258178 */   // GIR_Coverage, 48657,
     /* 2258178 */   GIR_EraseRootFromParent_Done,
     /* 2258179 */ // Label 30218: @2258179
     /* 2258179 */ GIM_Try, /*On fail goto*//*Label 30219*/ GIMT_Encode4(2258227), // Rule ID 48666 //
     /* 2258184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2258190 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2258193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258197 */   // MIs[0] Operand 1
     /* 2258197 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258206 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258210 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2258213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258215 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258217 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258225 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258226 */   // GIR_Coverage, 48666,
     /* 2258226 */   GIR_EraseRootFromParent_Done,
     /* 2258227 */ // Label 30219: @2258227
     /* 2258227 */ GIM_Try, /*On fail goto*//*Label 30220*/ GIMT_Encode4(2258275), // Rule ID 48667 //
     /* 2258232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2258238 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2258241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258245 */   // MIs[0] Operand 1
     /* 2258245 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258254 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258258 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2258261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258263 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258265 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258273 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258274 */   // GIR_Coverage, 48667,
     /* 2258274 */   GIR_EraseRootFromParent_Done,
     /* 2258275 */ // Label 30220: @2258275
     /* 2258275 */ GIM_Try, /*On fail goto*//*Label 30221*/ GIMT_Encode4(2258323), // Rule ID 48684 //
     /* 2258280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2258286 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2258289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258293 */   // MIs[0] Operand 1
     /* 2258293 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258302 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258306 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2258309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258311 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258313 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258321 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258322 */   // GIR_Coverage, 48684,
     /* 2258322 */   GIR_EraseRootFromParent_Done,
     /* 2258323 */ // Label 30221: @2258323
     /* 2258323 */ GIM_Try, /*On fail goto*//*Label 30222*/ GIMT_Encode4(2258371), // Rule ID 48685 //
     /* 2258328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2258334 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2258337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258341 */   // MIs[0] Operand 1
     /* 2258341 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258350 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258354 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2258357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258359 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258361 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258369 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258370 */   // GIR_Coverage, 48685,
     /* 2258370 */   GIR_EraseRootFromParent_Done,
     /* 2258371 */ // Label 30222: @2258371
     /* 2258371 */ GIM_Try, /*On fail goto*//*Label 30223*/ GIMT_Encode4(2258419), // Rule ID 48692 //
     /* 2258376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2258379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2258382 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2258385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258389 */   // MIs[0] Operand 1
     /* 2258389 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258394 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258398 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258402 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2258405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258407 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258409 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258417 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258418 */   // GIR_Coverage, 48692,
     /* 2258418 */   GIR_EraseRootFromParent_Done,
     /* 2258419 */ // Label 30223: @2258419
     /* 2258419 */ GIM_Try, /*On fail goto*//*Label 30224*/ GIMT_Encode4(2258467), // Rule ID 48693 //
     /* 2258424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2258430 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2258433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258437 */   // MIs[0] Operand 1
     /* 2258437 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258442 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258446 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258450 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2258453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258455 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258457 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258465 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258466 */   // GIR_Coverage, 48693,
     /* 2258466 */   GIR_EraseRootFromParent_Done,
     /* 2258467 */ // Label 30224: @2258467
     /* 2258467 */ GIM_Try, /*On fail goto*//*Label 30225*/ GIMT_Encode4(2258515), // Rule ID 48700 //
     /* 2258472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2258478 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2258481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258485 */   // MIs[0] Operand 1
     /* 2258485 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258490 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258494 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258498 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2258501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258503 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258505 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258513 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258514 */   // GIR_Coverage, 48700,
     /* 2258514 */   GIR_EraseRootFromParent_Done,
     /* 2258515 */ // Label 30225: @2258515
     /* 2258515 */ GIM_Try, /*On fail goto*//*Label 30226*/ GIMT_Encode4(2258563), // Rule ID 48701 //
     /* 2258520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2258526 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2258529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258533 */   // MIs[0] Operand 1
     /* 2258533 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258542 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258546 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2258549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258551 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258553 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258561 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258562 */   // GIR_Coverage, 48701,
     /* 2258562 */   GIR_EraseRootFromParent_Done,
     /* 2258563 */ // Label 30226: @2258563
     /* 2258563 */ GIM_Try, /*On fail goto*//*Label 30227*/ GIMT_Encode4(2258611), // Rule ID 48710 //
     /* 2258568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2258574 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2258577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258581 */   // MIs[0] Operand 1
     /* 2258581 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258586 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258590 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258594 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2258597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258599 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258601 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258609 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258610 */   // GIR_Coverage, 48710,
     /* 2258610 */   GIR_EraseRootFromParent_Done,
     /* 2258611 */ // Label 30227: @2258611
     /* 2258611 */ GIM_Try, /*On fail goto*//*Label 30228*/ GIMT_Encode4(2258659), // Rule ID 48711 //
     /* 2258616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2258622 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2258625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258629 */   // MIs[0] Operand 1
     /* 2258629 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258638 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258642 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2258645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258647 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258649 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258657 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258658 */   // GIR_Coverage, 48711,
     /* 2258658 */   GIR_EraseRootFromParent_Done,
     /* 2258659 */ // Label 30228: @2258659
     /* 2258659 */ GIM_Try, /*On fail goto*//*Label 30229*/ GIMT_Encode4(2258707), // Rule ID 48728 //
     /* 2258664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2258670 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2258673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258677 */   // MIs[0] Operand 1
     /* 2258677 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258682 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258686 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258690 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2258693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258695 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258697 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258705 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258706 */   // GIR_Coverage, 48728,
     /* 2258706 */   GIR_EraseRootFromParent_Done,
     /* 2258707 */ // Label 30229: @2258707
     /* 2258707 */ GIM_Try, /*On fail goto*//*Label 30230*/ GIMT_Encode4(2258755), // Rule ID 48729 //
     /* 2258712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2258718 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2258721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258725 */   // MIs[0] Operand 1
     /* 2258725 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258734 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258738 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2258741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258743 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258745 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258753 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258754 */   // GIR_Coverage, 48729,
     /* 2258754 */   GIR_EraseRootFromParent_Done,
     /* 2258755 */ // Label 30230: @2258755
     /* 2258755 */ GIM_Try, /*On fail goto*//*Label 30231*/ GIMT_Encode4(2258803), // Rule ID 48736 //
     /* 2258760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2258763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2258766 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2258769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258773 */   // MIs[0] Operand 1
     /* 2258773 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258778 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258782 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258786 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2258789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258791 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258793 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258801 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258802 */   // GIR_Coverage, 48736,
     /* 2258802 */   GIR_EraseRootFromParent_Done,
     /* 2258803 */ // Label 30231: @2258803
     /* 2258803 */ GIM_Try, /*On fail goto*//*Label 30232*/ GIMT_Encode4(2258851), // Rule ID 48737 //
     /* 2258808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2258814 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2258817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258821 */   // MIs[0] Operand 1
     /* 2258821 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258826 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258830 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258834 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2258837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258839 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258841 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258849 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258850 */   // GIR_Coverage, 48737,
     /* 2258850 */   GIR_EraseRootFromParent_Done,
     /* 2258851 */ // Label 30232: @2258851
     /* 2258851 */ GIM_Try, /*On fail goto*//*Label 30233*/ GIMT_Encode4(2258899), // Rule ID 48744 //
     /* 2258856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2258862 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2258865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258869 */   // MIs[0] Operand 1
     /* 2258869 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2258874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258878 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258882 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2258885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258887 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258889 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258897 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258898 */   // GIR_Coverage, 48744,
     /* 2258898 */   GIR_EraseRootFromParent_Done,
     /* 2258899 */ // Label 30233: @2258899
     /* 2258899 */ GIM_Try, /*On fail goto*//*Label 30234*/ GIMT_Encode4(2258947), // Rule ID 48745 //
     /* 2258904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2258910 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2258913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258917 */   // MIs[0] Operand 1
     /* 2258917 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2258922 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258926 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258930 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2258933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258935 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258937 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258945 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258946 */   // GIR_Coverage, 48745,
     /* 2258946 */   GIR_EraseRootFromParent_Done,
     /* 2258947 */ // Label 30234: @2258947
     /* 2258947 */ GIM_Try, /*On fail goto*//*Label 30235*/ GIMT_Encode4(2258995), // Rule ID 48754 //
     /* 2258952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2258958 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2258961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258965 */   // MIs[0] Operand 1
     /* 2258965 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2258970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258974 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258978 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2258981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258983 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258985 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258993 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258994 */   // GIR_Coverage, 48754,
     /* 2258994 */   GIR_EraseRootFromParent_Done,
     /* 2258995 */ // Label 30235: @2258995
     /* 2258995 */ GIM_Try, /*On fail goto*//*Label 30236*/ GIMT_Encode4(2259043), // Rule ID 48755 //
     /* 2259000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2259006 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2259009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259013 */   // MIs[0] Operand 1
     /* 2259013 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259022 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259026 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2259029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259031 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259033 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259041 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259042 */   // GIR_Coverage, 48755,
     /* 2259042 */   GIR_EraseRootFromParent_Done,
     /* 2259043 */ // Label 30236: @2259043
     /* 2259043 */ GIM_Try, /*On fail goto*//*Label 30237*/ GIMT_Encode4(2259091), // Rule ID 48772 //
     /* 2259048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2259054 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2259057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259061 */   // MIs[0] Operand 1
     /* 2259061 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259070 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259074 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259079 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259081 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259089 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259090 */   // GIR_Coverage, 48772,
     /* 2259090 */   GIR_EraseRootFromParent_Done,
     /* 2259091 */ // Label 30237: @2259091
     /* 2259091 */ GIM_Try, /*On fail goto*//*Label 30238*/ GIMT_Encode4(2259139), // Rule ID 48773 //
     /* 2259096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2259102 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2259105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259109 */   // MIs[0] Operand 1
     /* 2259109 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259118 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259122 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259127 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259129 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259137 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259138 */   // GIR_Coverage, 48773,
     /* 2259138 */   GIR_EraseRootFromParent_Done,
     /* 2259139 */ // Label 30238: @2259139
     /* 2259139 */ GIM_Try, /*On fail goto*//*Label 30239*/ GIMT_Encode4(2259187), // Rule ID 48780 //
     /* 2259144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2259147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2259150 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2259153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259157 */   // MIs[0] Operand 1
     /* 2259157 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259162 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259166 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259170 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259175 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259177 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259185 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259186 */   // GIR_Coverage, 48780,
     /* 2259186 */   GIR_EraseRootFromParent_Done,
     /* 2259187 */ // Label 30239: @2259187
     /* 2259187 */ GIM_Try, /*On fail goto*//*Label 30240*/ GIMT_Encode4(2259235), // Rule ID 48781 //
     /* 2259192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2259195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2259198 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2259201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259205 */   // MIs[0] Operand 1
     /* 2259205 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259214 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259218 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259223 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259225 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259233 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259234 */   // GIR_Coverage, 48781,
     /* 2259234 */   GIR_EraseRootFromParent_Done,
     /* 2259235 */ // Label 30240: @2259235
     /* 2259235 */ GIM_Try, /*On fail goto*//*Label 30241*/ GIMT_Encode4(2259283), // Rule ID 48788 //
     /* 2259240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2259246 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2259249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259253 */   // MIs[0] Operand 1
     /* 2259253 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259262 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259266 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2259269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259271 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259273 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259281 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259282 */   // GIR_Coverage, 48788,
     /* 2259282 */   GIR_EraseRootFromParent_Done,
     /* 2259283 */ // Label 30241: @2259283
     /* 2259283 */ GIM_Try, /*On fail goto*//*Label 30242*/ GIMT_Encode4(2259331), // Rule ID 48789 //
     /* 2259288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2259294 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2259297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259301 */   // MIs[0] Operand 1
     /* 2259301 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259310 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259314 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2259317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259319 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259321 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259329 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259330 */   // GIR_Coverage, 48789,
     /* 2259330 */   GIR_EraseRootFromParent_Done,
     /* 2259331 */ // Label 30242: @2259331
     /* 2259331 */ GIM_Try, /*On fail goto*//*Label 30243*/ GIMT_Encode4(2259379), // Rule ID 48798 //
     /* 2259336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2259342 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2259345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259349 */   // MIs[0] Operand 1
     /* 2259349 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259358 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259362 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2259365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259367 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259369 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259377 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259378 */   // GIR_Coverage, 48798,
     /* 2259378 */   GIR_EraseRootFromParent_Done,
     /* 2259379 */ // Label 30243: @2259379
     /* 2259379 */ GIM_Try, /*On fail goto*//*Label 30244*/ GIMT_Encode4(2259427), // Rule ID 48799 //
     /* 2259384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2259390 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2259393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259397 */   // MIs[0] Operand 1
     /* 2259397 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259406 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259410 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2259413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259415 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259417 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259425 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259426 */   // GIR_Coverage, 48799,
     /* 2259426 */   GIR_EraseRootFromParent_Done,
     /* 2259427 */ // Label 30244: @2259427
     /* 2259427 */ GIM_Try, /*On fail goto*//*Label 30245*/ GIMT_Encode4(2259475), // Rule ID 48816 //
     /* 2259432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2259438 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2259441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259445 */   // MIs[0] Operand 1
     /* 2259445 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259454 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259458 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259463 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259465 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259474 */   // GIR_Coverage, 48816,
     /* 2259474 */   GIR_EraseRootFromParent_Done,
     /* 2259475 */ // Label 30245: @2259475
     /* 2259475 */ GIM_Try, /*On fail goto*//*Label 30246*/ GIMT_Encode4(2259523), // Rule ID 48817 //
     /* 2259480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2259486 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2259489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259493 */   // MIs[0] Operand 1
     /* 2259493 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259502 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259506 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259511 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259513 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259521 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259522 */   // GIR_Coverage, 48817,
     /* 2259522 */   GIR_EraseRootFromParent_Done,
     /* 2259523 */ // Label 30246: @2259523
     /* 2259523 */ GIM_Try, /*On fail goto*//*Label 30247*/ GIMT_Encode4(2259571), // Rule ID 48824 //
     /* 2259528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2259531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2259534 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2259537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259541 */   // MIs[0] Operand 1
     /* 2259541 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259550 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259554 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259559 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259561 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259569 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259570 */   // GIR_Coverage, 48824,
     /* 2259570 */   GIR_EraseRootFromParent_Done,
     /* 2259571 */ // Label 30247: @2259571
     /* 2259571 */ GIM_Try, /*On fail goto*//*Label 30248*/ GIMT_Encode4(2259619), // Rule ID 48825 //
     /* 2259576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2259579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2259582 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2259585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259589 */   // MIs[0] Operand 1
     /* 2259589 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259594 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259598 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259602 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259607 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259609 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259617 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259618 */   // GIR_Coverage, 48825,
     /* 2259618 */   GIR_EraseRootFromParent_Done,
     /* 2259619 */ // Label 30248: @2259619
     /* 2259619 */ GIM_Try, /*On fail goto*//*Label 30249*/ GIMT_Encode4(2259667), // Rule ID 48832 //
     /* 2259624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2259630 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2259633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259637 */   // MIs[0] Operand 1
     /* 2259637 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259642 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259646 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259650 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2259653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259655 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259657 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259665 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259666 */   // GIR_Coverage, 48832,
     /* 2259666 */   GIR_EraseRootFromParent_Done,
     /* 2259667 */ // Label 30249: @2259667
     /* 2259667 */ GIM_Try, /*On fail goto*//*Label 30250*/ GIMT_Encode4(2259715), // Rule ID 48833 //
     /* 2259672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2259678 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2259681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259685 */   // MIs[0] Operand 1
     /* 2259685 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259694 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259698 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2259701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259703 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259705 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259713 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259714 */   // GIR_Coverage, 48833,
     /* 2259714 */   GIR_EraseRootFromParent_Done,
     /* 2259715 */ // Label 30250: @2259715
     /* 2259715 */ GIM_Try, /*On fail goto*//*Label 30251*/ GIMT_Encode4(2259763), // Rule ID 48842 //
     /* 2259720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2259726 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2259729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259733 */   // MIs[0] Operand 1
     /* 2259733 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259738 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259742 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259746 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2259749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259751 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259753 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259762 */   // GIR_Coverage, 48842,
     /* 2259762 */   GIR_EraseRootFromParent_Done,
     /* 2259763 */ // Label 30251: @2259763
     /* 2259763 */ GIM_Try, /*On fail goto*//*Label 30252*/ GIMT_Encode4(2259811), // Rule ID 48843 //
     /* 2259768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2259774 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2259777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259781 */   // MIs[0] Operand 1
     /* 2259781 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259786 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259790 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259794 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2259797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259799 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259801 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259809 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259810 */   // GIR_Coverage, 48843,
     /* 2259810 */   GIR_EraseRootFromParent_Done,
     /* 2259811 */ // Label 30252: @2259811
     /* 2259811 */ GIM_Try, /*On fail goto*//*Label 30253*/ GIMT_Encode4(2259859), // Rule ID 48860 //
     /* 2259816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2259822 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2259825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259829 */   // MIs[0] Operand 1
     /* 2259829 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259834 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259838 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259842 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2259845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259847 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259849 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259857 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259858 */   // GIR_Coverage, 48860,
     /* 2259858 */   GIR_EraseRootFromParent_Done,
     /* 2259859 */ // Label 30253: @2259859
     /* 2259859 */ GIM_Try, /*On fail goto*//*Label 30254*/ GIMT_Encode4(2259907), // Rule ID 48861 //
     /* 2259864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2259870 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2259873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259877 */   // MIs[0] Operand 1
     /* 2259877 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259882 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259886 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259890 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2259893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259895 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259897 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259905 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259906 */   // GIR_Coverage, 48861,
     /* 2259906 */   GIR_EraseRootFromParent_Done,
     /* 2259907 */ // Label 30254: @2259907
     /* 2259907 */ GIM_Try, /*On fail goto*//*Label 30255*/ GIMT_Encode4(2259955), // Rule ID 48868 //
     /* 2259912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2259915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2259918 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2259921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259925 */   // MIs[0] Operand 1
     /* 2259925 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259934 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259938 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2259941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259943 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259945 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259953 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259954 */   // GIR_Coverage, 48868,
     /* 2259954 */   GIR_EraseRootFromParent_Done,
     /* 2259955 */ // Label 30255: @2259955
     /* 2259955 */ GIM_Try, /*On fail goto*//*Label 30256*/ GIMT_Encode4(2260003), // Rule ID 48869 //
     /* 2259960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2259963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2259966 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2259969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259973 */   // MIs[0] Operand 1
     /* 2259973 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259982 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259986 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2259989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259991 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259993 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260001 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260002 */   // GIR_Coverage, 48869,
     /* 2260002 */   GIR_EraseRootFromParent_Done,
     /* 2260003 */ // Label 30256: @2260003
     /* 2260003 */ GIM_Try, /*On fail goto*//*Label 30257*/ GIMT_Encode4(2260051), // Rule ID 48876 //
     /* 2260008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2260014 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2260017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260021 */   // MIs[0] Operand 1
     /* 2260021 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260030 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260034 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2260037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260039 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260041 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260049 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260050 */   // GIR_Coverage, 48876,
     /* 2260050 */   GIR_EraseRootFromParent_Done,
     /* 2260051 */ // Label 30257: @2260051
     /* 2260051 */ GIM_Try, /*On fail goto*//*Label 30258*/ GIMT_Encode4(2260099), // Rule ID 48877 //
     /* 2260056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2260062 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2260065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260069 */   // MIs[0] Operand 1
     /* 2260069 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260078 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260082 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2260085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260087 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260089 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260097 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260098 */   // GIR_Coverage, 48877,
     /* 2260098 */   GIR_EraseRootFromParent_Done,
     /* 2260099 */ // Label 30258: @2260099
     /* 2260099 */ GIM_Try, /*On fail goto*//*Label 30259*/ GIMT_Encode4(2260147), // Rule ID 48886 //
     /* 2260104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2260110 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2260113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260117 */   // MIs[0] Operand 1
     /* 2260117 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260126 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260130 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260135 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260137 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260145 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260146 */   // GIR_Coverage, 48886,
     /* 2260146 */   GIR_EraseRootFromParent_Done,
     /* 2260147 */ // Label 30259: @2260147
     /* 2260147 */ GIM_Try, /*On fail goto*//*Label 30260*/ GIMT_Encode4(2260195), // Rule ID 48887 //
     /* 2260152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2260158 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2260161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260165 */   // MIs[0] Operand 1
     /* 2260165 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260174 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260178 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260183 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260185 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260193 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260194 */   // GIR_Coverage, 48887,
     /* 2260194 */   GIR_EraseRootFromParent_Done,
     /* 2260195 */ // Label 30260: @2260195
     /* 2260195 */ GIM_Try, /*On fail goto*//*Label 30261*/ GIMT_Encode4(2260243), // Rule ID 48904 //
     /* 2260200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2260206 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2260209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260213 */   // MIs[0] Operand 1
     /* 2260213 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260222 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260226 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2260229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260231 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260233 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260241 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260242 */   // GIR_Coverage, 48904,
     /* 2260242 */   GIR_EraseRootFromParent_Done,
     /* 2260243 */ // Label 30261: @2260243
     /* 2260243 */ GIM_Try, /*On fail goto*//*Label 30262*/ GIMT_Encode4(2260291), // Rule ID 48905 //
     /* 2260248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2260254 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2260257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260261 */   // MIs[0] Operand 1
     /* 2260261 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260270 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260274 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2260277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260279 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260281 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260289 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260290 */   // GIR_Coverage, 48905,
     /* 2260290 */   GIR_EraseRootFromParent_Done,
     /* 2260291 */ // Label 30262: @2260291
     /* 2260291 */ GIM_Try, /*On fail goto*//*Label 30263*/ GIMT_Encode4(2260339), // Rule ID 48912 //
     /* 2260296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2260299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2260302 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2260305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260309 */   // MIs[0] Operand 1
     /* 2260309 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260318 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260322 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2260325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260327 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260329 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260337 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260338 */   // GIR_Coverage, 48912,
     /* 2260338 */   GIR_EraseRootFromParent_Done,
     /* 2260339 */ // Label 30263: @2260339
     /* 2260339 */ GIM_Try, /*On fail goto*//*Label 30264*/ GIMT_Encode4(2260387), // Rule ID 48913 //
     /* 2260344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2260350 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2260353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260357 */   // MIs[0] Operand 1
     /* 2260357 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260366 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260370 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2260373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260375 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260377 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260385 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260386 */   // GIR_Coverage, 48913,
     /* 2260386 */   GIR_EraseRootFromParent_Done,
     /* 2260387 */ // Label 30264: @2260387
     /* 2260387 */ GIM_Reject,
     /* 2260388 */ // Label 29926: @2260388
     /* 2260388 */ GIM_Try, /*On fail goto*//*Label 30265*/ GIMT_Encode4(2260436), // Rule ID 48490 //
     /* 2260393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260399 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260406 */   // MIs[0] Operand 1
     /* 2260406 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260415 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260419 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2260422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260424 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260426 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260434 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260435 */   // GIR_Coverage, 48490,
     /* 2260435 */   GIR_EraseRootFromParent_Done,
     /* 2260436 */ // Label 30265: @2260436
     /* 2260436 */ GIM_Try, /*On fail goto*//*Label 30266*/ GIMT_Encode4(2260484), // Rule ID 48491 //
     /* 2260441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260447 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260454 */   // MIs[0] Operand 1
     /* 2260454 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260463 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260467 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2260470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260472 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260474 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260482 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260483 */   // GIR_Coverage, 48491,
     /* 2260483 */   GIR_EraseRootFromParent_Done,
     /* 2260484 */ // Label 30266: @2260484
     /* 2260484 */ GIM_Try, /*On fail goto*//*Label 30267*/ GIMT_Encode4(2260532), // Rule ID 48504 //
     /* 2260489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260495 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260502 */   // MIs[0] Operand 1
     /* 2260502 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260511 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260515 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2260518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260520 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260522 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260530 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260531 */   // GIR_Coverage, 48504,
     /* 2260531 */   GIR_EraseRootFromParent_Done,
     /* 2260532 */ // Label 30267: @2260532
     /* 2260532 */ GIM_Try, /*On fail goto*//*Label 30268*/ GIMT_Encode4(2260580), // Rule ID 48505 //
     /* 2260537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260543 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260550 */   // MIs[0] Operand 1
     /* 2260550 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260559 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260563 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2260566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260568 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260570 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260578 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260579 */   // GIR_Coverage, 48505,
     /* 2260579 */   GIR_EraseRootFromParent_Done,
     /* 2260580 */ // Label 30268: @2260580
     /* 2260580 */ GIM_Try, /*On fail goto*//*Label 30269*/ GIMT_Encode4(2260628), // Rule ID 48512 //
     /* 2260585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260591 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260598 */   // MIs[0] Operand 1
     /* 2260598 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260607 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260611 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2260614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260616 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260618 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260626 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260627 */   // GIR_Coverage, 48512,
     /* 2260627 */   GIR_EraseRootFromParent_Done,
     /* 2260628 */ // Label 30269: @2260628
     /* 2260628 */ GIM_Try, /*On fail goto*//*Label 30270*/ GIMT_Encode4(2260676), // Rule ID 48513 //
     /* 2260633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260639 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260646 */   // MIs[0] Operand 1
     /* 2260646 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260655 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260659 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2260662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260664 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260666 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260674 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260675 */   // GIR_Coverage, 48513,
     /* 2260675 */   GIR_EraseRootFromParent_Done,
     /* 2260676 */ // Label 30270: @2260676
     /* 2260676 */ GIM_Try, /*On fail goto*//*Label 30271*/ GIMT_Encode4(2260724), // Rule ID 48520 //
     /* 2260681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2260684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260687 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260694 */   // MIs[0] Operand 1
     /* 2260694 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260703 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260707 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2260710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260712 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260714 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260722 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260723 */   // GIR_Coverage, 48520,
     /* 2260723 */   GIR_EraseRootFromParent_Done,
     /* 2260724 */ // Label 30271: @2260724
     /* 2260724 */ GIM_Try, /*On fail goto*//*Label 30272*/ GIMT_Encode4(2260772), // Rule ID 48521 //
     /* 2260729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260735 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260742 */   // MIs[0] Operand 1
     /* 2260742 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260751 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260755 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2260758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260760 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260762 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260770 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260771 */   // GIR_Coverage, 48521,
     /* 2260771 */   GIR_EraseRootFromParent_Done,
     /* 2260772 */ // Label 30272: @2260772
     /* 2260772 */ GIM_Try, /*On fail goto*//*Label 30273*/ GIMT_Encode4(2260820), // Rule ID 48534 //
     /* 2260777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260783 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260790 */   // MIs[0] Operand 1
     /* 2260790 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2260795 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260799 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260803 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2260806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260808 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260810 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260818 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260819 */   // GIR_Coverage, 48534,
     /* 2260819 */   GIR_EraseRootFromParent_Done,
     /* 2260820 */ // Label 30273: @2260820
     /* 2260820 */ GIM_Try, /*On fail goto*//*Label 30274*/ GIMT_Encode4(2260868), // Rule ID 48535 //
     /* 2260825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260831 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260838 */   // MIs[0] Operand 1
     /* 2260838 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2260843 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260847 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260851 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2260854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260856 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260858 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260867 */   // GIR_Coverage, 48535,
     /* 2260867 */   GIR_EraseRootFromParent_Done,
     /* 2260868 */ // Label 30274: @2260868
     /* 2260868 */ GIM_Try, /*On fail goto*//*Label 30275*/ GIMT_Encode4(2260916), // Rule ID 48548 //
     /* 2260873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260879 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260886 */   // MIs[0] Operand 1
     /* 2260886 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2260891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260895 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260899 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2260902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260904 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260906 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260914 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260915 */   // GIR_Coverage, 48548,
     /* 2260915 */   GIR_EraseRootFromParent_Done,
     /* 2260916 */ // Label 30275: @2260916
     /* 2260916 */ GIM_Try, /*On fail goto*//*Label 30276*/ GIMT_Encode4(2260964), // Rule ID 48549 //
     /* 2260921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260934 */   // MIs[0] Operand 1
     /* 2260934 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2260939 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260943 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260947 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2260950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260952 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260954 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260962 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260963 */   // GIR_Coverage, 48549,
     /* 2260963 */   GIR_EraseRootFromParent_Done,
     /* 2260964 */ // Label 30276: @2260964
     /* 2260964 */ GIM_Try, /*On fail goto*//*Label 30277*/ GIMT_Encode4(2261012), // Rule ID 48556 //
     /* 2260969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260975 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260982 */   // MIs[0] Operand 1
     /* 2260982 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2260987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260991 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260995 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2260998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261000 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261002 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261010 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261011 */   // GIR_Coverage, 48556,
     /* 2261011 */   GIR_EraseRootFromParent_Done,
     /* 2261012 */ // Label 30277: @2261012
     /* 2261012 */ GIM_Try, /*On fail goto*//*Label 30278*/ GIMT_Encode4(2261060), // Rule ID 48557 //
     /* 2261017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2261023 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2261026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261030 */   // MIs[0] Operand 1
     /* 2261030 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261039 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261043 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2261046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261048 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261050 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261058 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261059 */   // GIR_Coverage, 48557,
     /* 2261059 */   GIR_EraseRootFromParent_Done,
     /* 2261060 */ // Label 30278: @2261060
     /* 2261060 */ GIM_Try, /*On fail goto*//*Label 30279*/ GIMT_Encode4(2261108), // Rule ID 48564 //
     /* 2261065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2261068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2261071 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2261074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261078 */   // MIs[0] Operand 1
     /* 2261078 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261087 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261091 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2261091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2261094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261096 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261098 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261107 */   // GIR_Coverage, 48564,
     /* 2261107 */   GIR_EraseRootFromParent_Done,
     /* 2261108 */ // Label 30279: @2261108
     /* 2261108 */ GIM_Try, /*On fail goto*//*Label 30280*/ GIMT_Encode4(2261156), // Rule ID 48565 //
     /* 2261113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2261116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2261119 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2261122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261126 */   // MIs[0] Operand 1
     /* 2261126 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261131 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261135 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261139 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2261139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2261142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261144 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261146 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261154 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261155 */   // GIR_Coverage, 48565,
     /* 2261155 */   GIR_EraseRootFromParent_Done,
     /* 2261156 */ // Label 30280: @2261156
     /* 2261156 */ GIM_Try, /*On fail goto*//*Label 30281*/ GIMT_Encode4(2261204), // Rule ID 48578 //
     /* 2261161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2261167 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2261170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261174 */   // MIs[0] Operand 1
     /* 2261174 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261183 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261187 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2261190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261192 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261194 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261202 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261203 */   // GIR_Coverage, 48578,
     /* 2261203 */   GIR_EraseRootFromParent_Done,
     /* 2261204 */ // Label 30281: @2261204
     /* 2261204 */ GIM_Try, /*On fail goto*//*Label 30282*/ GIMT_Encode4(2261252), // Rule ID 48579 //
     /* 2261209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2261215 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2261218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261222 */   // MIs[0] Operand 1
     /* 2261222 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261231 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261235 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2261238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261240 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261242 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261250 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261251 */   // GIR_Coverage, 48579,
     /* 2261251 */   GIR_EraseRootFromParent_Done,
     /* 2261252 */ // Label 30282: @2261252
     /* 2261252 */ GIM_Try, /*On fail goto*//*Label 30283*/ GIMT_Encode4(2261300), // Rule ID 48592 //
     /* 2261257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2261263 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2261266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261270 */   // MIs[0] Operand 1
     /* 2261270 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261279 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261283 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261288 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261290 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261298 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261299 */   // GIR_Coverage, 48592,
     /* 2261299 */   GIR_EraseRootFromParent_Done,
     /* 2261300 */ // Label 30283: @2261300
     /* 2261300 */ GIM_Try, /*On fail goto*//*Label 30284*/ GIMT_Encode4(2261348), // Rule ID 48593 //
     /* 2261305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2261311 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2261314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261318 */   // MIs[0] Operand 1
     /* 2261318 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261327 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261331 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261336 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261338 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261346 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261347 */   // GIR_Coverage, 48593,
     /* 2261347 */   GIR_EraseRootFromParent_Done,
     /* 2261348 */ // Label 30284: @2261348
     /* 2261348 */ GIM_Try, /*On fail goto*//*Label 30285*/ GIMT_Encode4(2261396), // Rule ID 48600 //
     /* 2261353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2261359 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2261362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261366 */   // MIs[0] Operand 1
     /* 2261366 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261375 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261379 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261384 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261386 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261394 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261395 */   // GIR_Coverage, 48600,
     /* 2261395 */   GIR_EraseRootFromParent_Done,
     /* 2261396 */ // Label 30285: @2261396
     /* 2261396 */ GIM_Try, /*On fail goto*//*Label 30286*/ GIMT_Encode4(2261444), // Rule ID 48601 //
     /* 2261401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2261407 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2261410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261414 */   // MIs[0] Operand 1
     /* 2261414 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261423 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261427 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261432 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261434 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261442 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261443 */   // GIR_Coverage, 48601,
     /* 2261443 */   GIR_EraseRootFromParent_Done,
     /* 2261444 */ // Label 30286: @2261444
     /* 2261444 */ GIM_Try, /*On fail goto*//*Label 30287*/ GIMT_Encode4(2261492), // Rule ID 48608 //
     /* 2261449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2261452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2261455 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2261458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261462 */   // MIs[0] Operand 1
     /* 2261462 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261471 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261475 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2261475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2261478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261480 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261482 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261490 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261491 */   // GIR_Coverage, 48608,
     /* 2261491 */   GIR_EraseRootFromParent_Done,
     /* 2261492 */ // Label 30287: @2261492
     /* 2261492 */ GIM_Try, /*On fail goto*//*Label 30288*/ GIMT_Encode4(2261540), // Rule ID 48609 //
     /* 2261497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2261500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2261503 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2261506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261510 */   // MIs[0] Operand 1
     /* 2261510 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261519 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261523 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2261523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2261526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261528 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261530 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261538 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261539 */   // GIR_Coverage, 48609,
     /* 2261539 */   GIR_EraseRootFromParent_Done,
     /* 2261540 */ // Label 30288: @2261540
     /* 2261540 */ GIM_Try, /*On fail goto*//*Label 30289*/ GIMT_Encode4(2261588), // Rule ID 48620 //
     /* 2261545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2261551 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2261554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261558 */   // MIs[0] Operand 1
     /* 2261558 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261567 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261571 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2261574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261576 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261578 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261586 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261587 */   // GIR_Coverage, 48620,
     /* 2261587 */   GIR_EraseRootFromParent_Done,
     /* 2261588 */ // Label 30289: @2261588
     /* 2261588 */ GIM_Try, /*On fail goto*//*Label 30290*/ GIMT_Encode4(2261636), // Rule ID 48621 //
     /* 2261593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2261599 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2261602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261606 */   // MIs[0] Operand 1
     /* 2261606 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261615 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261619 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2261622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261624 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261626 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261634 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261635 */   // GIR_Coverage, 48621,
     /* 2261635 */   GIR_EraseRootFromParent_Done,
     /* 2261636 */ // Label 30290: @2261636
     /* 2261636 */ GIM_Try, /*On fail goto*//*Label 30291*/ GIMT_Encode4(2261684), // Rule ID 48634 //
     /* 2261641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2261647 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2261650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261654 */   // MIs[0] Operand 1
     /* 2261654 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261663 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261667 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261672 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261674 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261682 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261683 */   // GIR_Coverage, 48634,
     /* 2261683 */   GIR_EraseRootFromParent_Done,
     /* 2261684 */ // Label 30291: @2261684
     /* 2261684 */ GIM_Try, /*On fail goto*//*Label 30292*/ GIMT_Encode4(2261732), // Rule ID 48635 //
     /* 2261689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2261695 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2261698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261702 */   // MIs[0] Operand 1
     /* 2261702 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261711 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261715 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261720 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261722 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261730 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261731 */   // GIR_Coverage, 48635,
     /* 2261731 */   GIR_EraseRootFromParent_Done,
     /* 2261732 */ // Label 30292: @2261732
     /* 2261732 */ GIM_Try, /*On fail goto*//*Label 30293*/ GIMT_Encode4(2261780), // Rule ID 48642 //
     /* 2261737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2261743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2261746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261750 */   // MIs[0] Operand 1
     /* 2261750 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261759 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261763 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261768 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261770 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261778 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261779 */   // GIR_Coverage, 48642,
     /* 2261779 */   GIR_EraseRootFromParent_Done,
     /* 2261780 */ // Label 30293: @2261780
     /* 2261780 */ GIM_Try, /*On fail goto*//*Label 30294*/ GIMT_Encode4(2261828), // Rule ID 48643 //
     /* 2261785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2261791 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2261794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261798 */   // MIs[0] Operand 1
     /* 2261798 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261807 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261811 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261816 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261818 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261826 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261827 */   // GIR_Coverage, 48643,
     /* 2261827 */   GIR_EraseRootFromParent_Done,
     /* 2261828 */ // Label 30294: @2261828
     /* 2261828 */ GIM_Try, /*On fail goto*//*Label 30295*/ GIMT_Encode4(2261876), // Rule ID 48650 //
     /* 2261833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2261836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2261839 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2261842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261846 */   // MIs[0] Operand 1
     /* 2261846 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261855 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261859 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2261859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2261862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261864 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261866 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261874 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261875 */   // GIR_Coverage, 48650,
     /* 2261875 */   GIR_EraseRootFromParent_Done,
     /* 2261876 */ // Label 30295: @2261876
     /* 2261876 */ GIM_Try, /*On fail goto*//*Label 30296*/ GIMT_Encode4(2261924), // Rule ID 48651 //
     /* 2261881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2261884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2261887 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2261890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261894 */   // MIs[0] Operand 1
     /* 2261894 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261903 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261907 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2261907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2261910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261912 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261914 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261922 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261923 */   // GIR_Coverage, 48651,
     /* 2261923 */   GIR_EraseRootFromParent_Done,
     /* 2261924 */ // Label 30296: @2261924
     /* 2261924 */ GIM_Try, /*On fail goto*//*Label 30297*/ GIMT_Encode4(2261972), // Rule ID 48664 //
     /* 2261929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2261935 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2261938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261942 */   // MIs[0] Operand 1
     /* 2261942 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2261947 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261951 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261955 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2261958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261960 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261962 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261970 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261971 */   // GIR_Coverage, 48664,
     /* 2261971 */   GIR_EraseRootFromParent_Done,
     /* 2261972 */ // Label 30297: @2261972
     /* 2261972 */ GIM_Try, /*On fail goto*//*Label 30298*/ GIMT_Encode4(2262020), // Rule ID 48665 //
     /* 2261977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2261983 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2261986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261990 */   // MIs[0] Operand 1
     /* 2261990 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2261995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261999 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262003 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2262006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262008 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262010 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262018 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262019 */   // GIR_Coverage, 48665,
     /* 2262019 */   GIR_EraseRootFromParent_Done,
     /* 2262020 */ // Label 30298: @2262020
     /* 2262020 */ GIM_Try, /*On fail goto*//*Label 30299*/ GIMT_Encode4(2262068), // Rule ID 48678 //
     /* 2262025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2262031 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2262034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262038 */   // MIs[0] Operand 1
     /* 2262038 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262047 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262051 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262056 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262058 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262066 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262067 */   // GIR_Coverage, 48678,
     /* 2262067 */   GIR_EraseRootFromParent_Done,
     /* 2262068 */ // Label 30299: @2262068
     /* 2262068 */ GIM_Try, /*On fail goto*//*Label 30300*/ GIMT_Encode4(2262116), // Rule ID 48679 //
     /* 2262073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2262079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2262082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262086 */   // MIs[0] Operand 1
     /* 2262086 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262091 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262095 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262099 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262104 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262106 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262114 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262115 */   // GIR_Coverage, 48679,
     /* 2262115 */   GIR_EraseRootFromParent_Done,
     /* 2262116 */ // Label 30300: @2262116
     /* 2262116 */ GIM_Try, /*On fail goto*//*Label 30301*/ GIMT_Encode4(2262164), // Rule ID 48686 //
     /* 2262121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2262127 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2262130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262134 */   // MIs[0] Operand 1
     /* 2262134 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262143 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262147 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262152 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262154 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262162 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262163 */   // GIR_Coverage, 48686,
     /* 2262163 */   GIR_EraseRootFromParent_Done,
     /* 2262164 */ // Label 30301: @2262164
     /* 2262164 */ GIM_Try, /*On fail goto*//*Label 30302*/ GIMT_Encode4(2262212), // Rule ID 48687 //
     /* 2262169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2262175 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2262178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262182 */   // MIs[0] Operand 1
     /* 2262182 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262191 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262195 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262200 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262202 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262210 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262211 */   // GIR_Coverage, 48687,
     /* 2262211 */   GIR_EraseRootFromParent_Done,
     /* 2262212 */ // Label 30302: @2262212
     /* 2262212 */ GIM_Try, /*On fail goto*//*Label 30303*/ GIMT_Encode4(2262260), // Rule ID 48694 //
     /* 2262217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2262220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2262223 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2262226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262230 */   // MIs[0] Operand 1
     /* 2262230 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262239 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262243 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2262243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262248 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262250 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262258 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262259 */   // GIR_Coverage, 48694,
     /* 2262259 */   GIR_EraseRootFromParent_Done,
     /* 2262260 */ // Label 30303: @2262260
     /* 2262260 */ GIM_Try, /*On fail goto*//*Label 30304*/ GIMT_Encode4(2262308), // Rule ID 48695 //
     /* 2262265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2262268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2262271 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2262274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262278 */   // MIs[0] Operand 1
     /* 2262278 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262287 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262291 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2262291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262296 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262298 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262306 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262307 */   // GIR_Coverage, 48695,
     /* 2262307 */   GIR_EraseRootFromParent_Done,
     /* 2262308 */ // Label 30304: @2262308
     /* 2262308 */ GIM_Try, /*On fail goto*//*Label 30305*/ GIMT_Encode4(2262356), // Rule ID 48708 //
     /* 2262313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2262319 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2262322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262326 */   // MIs[0] Operand 1
     /* 2262326 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262331 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262335 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262339 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2262342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262344 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262346 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262354 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262355 */   // GIR_Coverage, 48708,
     /* 2262355 */   GIR_EraseRootFromParent_Done,
     /* 2262356 */ // Label 30305: @2262356
     /* 2262356 */ GIM_Try, /*On fail goto*//*Label 30306*/ GIMT_Encode4(2262404), // Rule ID 48709 //
     /* 2262361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2262367 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2262370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262374 */   // MIs[0] Operand 1
     /* 2262374 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262383 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262387 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2262390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262392 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262394 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262402 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262403 */   // GIR_Coverage, 48709,
     /* 2262403 */   GIR_EraseRootFromParent_Done,
     /* 2262404 */ // Label 30306: @2262404
     /* 2262404 */ GIM_Try, /*On fail goto*//*Label 30307*/ GIMT_Encode4(2262452), // Rule ID 48722 //
     /* 2262409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2262415 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2262418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262422 */   // MIs[0] Operand 1
     /* 2262422 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262431 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262435 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262440 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262442 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262450 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262451 */   // GIR_Coverage, 48722,
     /* 2262451 */   GIR_EraseRootFromParent_Done,
     /* 2262452 */ // Label 30307: @2262452
     /* 2262452 */ GIM_Try, /*On fail goto*//*Label 30308*/ GIMT_Encode4(2262500), // Rule ID 48723 //
     /* 2262457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2262463 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2262466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262470 */   // MIs[0] Operand 1
     /* 2262470 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262479 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262483 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262488 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262490 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262498 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262499 */   // GIR_Coverage, 48723,
     /* 2262499 */   GIR_EraseRootFromParent_Done,
     /* 2262500 */ // Label 30308: @2262500
     /* 2262500 */ GIM_Try, /*On fail goto*//*Label 30309*/ GIMT_Encode4(2262548), // Rule ID 48730 //
     /* 2262505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2262511 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2262514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262518 */   // MIs[0] Operand 1
     /* 2262518 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262523 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262527 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262531 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262536 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262538 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262546 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262547 */   // GIR_Coverage, 48730,
     /* 2262547 */   GIR_EraseRootFromParent_Done,
     /* 2262548 */ // Label 30309: @2262548
     /* 2262548 */ GIM_Try, /*On fail goto*//*Label 30310*/ GIMT_Encode4(2262596), // Rule ID 48731 //
     /* 2262553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2262559 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2262562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262566 */   // MIs[0] Operand 1
     /* 2262566 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262571 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262575 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262579 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262584 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262586 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262594 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262595 */   // GIR_Coverage, 48731,
     /* 2262595 */   GIR_EraseRootFromParent_Done,
     /* 2262596 */ // Label 30310: @2262596
     /* 2262596 */ GIM_Try, /*On fail goto*//*Label 30311*/ GIMT_Encode4(2262644), // Rule ID 48738 //
     /* 2262601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2262604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2262607 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2262610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262614 */   // MIs[0] Operand 1
     /* 2262614 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262623 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262627 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2262627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262632 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262634 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262642 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262643 */   // GIR_Coverage, 48738,
     /* 2262643 */   GIR_EraseRootFromParent_Done,
     /* 2262644 */ // Label 30311: @2262644
     /* 2262644 */ GIM_Try, /*On fail goto*//*Label 30312*/ GIMT_Encode4(2262692), // Rule ID 48739 //
     /* 2262649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2262652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2262655 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2262658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262662 */   // MIs[0] Operand 1
     /* 2262662 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262667 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262671 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262675 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2262675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262680 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262682 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262690 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262691 */   // GIR_Coverage, 48739,
     /* 2262691 */   GIR_EraseRootFromParent_Done,
     /* 2262692 */ // Label 30312: @2262692
     /* 2262692 */ GIM_Try, /*On fail goto*//*Label 30313*/ GIMT_Encode4(2262740), // Rule ID 48752 //
     /* 2262697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2262703 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2262706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262710 */   // MIs[0] Operand 1
     /* 2262710 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262719 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262723 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2262726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262728 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262730 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262738 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262739 */   // GIR_Coverage, 48752,
     /* 2262739 */   GIR_EraseRootFromParent_Done,
     /* 2262740 */ // Label 30313: @2262740
     /* 2262740 */ GIM_Try, /*On fail goto*//*Label 30314*/ GIMT_Encode4(2262788), // Rule ID 48753 //
     /* 2262745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2262751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2262754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262758 */   // MIs[0] Operand 1
     /* 2262758 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262763 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262767 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262771 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2262774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262776 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262778 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262787 */   // GIR_Coverage, 48753,
     /* 2262787 */   GIR_EraseRootFromParent_Done,
     /* 2262788 */ // Label 30314: @2262788
     /* 2262788 */ GIM_Try, /*On fail goto*//*Label 30315*/ GIMT_Encode4(2262836), // Rule ID 48766 //
     /* 2262793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2262799 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2262802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262806 */   // MIs[0] Operand 1
     /* 2262806 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262815 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262819 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2262822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262824 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262826 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262834 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262835 */   // GIR_Coverage, 48766,
     /* 2262835 */   GIR_EraseRootFromParent_Done,
     /* 2262836 */ // Label 30315: @2262836
     /* 2262836 */ GIM_Try, /*On fail goto*//*Label 30316*/ GIMT_Encode4(2262884), // Rule ID 48767 //
     /* 2262841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2262847 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2262850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262854 */   // MIs[0] Operand 1
     /* 2262854 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262863 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262867 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2262870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262872 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262874 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262882 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262883 */   // GIR_Coverage, 48767,
     /* 2262883 */   GIR_EraseRootFromParent_Done,
     /* 2262884 */ // Label 30316: @2262884
     /* 2262884 */ GIM_Try, /*On fail goto*//*Label 30317*/ GIMT_Encode4(2262932), // Rule ID 48774 //
     /* 2262889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2262895 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2262898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262902 */   // MIs[0] Operand 1
     /* 2262902 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262907 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262911 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262915 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2262918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262920 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262922 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262930 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262931 */   // GIR_Coverage, 48774,
     /* 2262931 */   GIR_EraseRootFromParent_Done,
     /* 2262932 */ // Label 30317: @2262932
     /* 2262932 */ GIM_Try, /*On fail goto*//*Label 30318*/ GIMT_Encode4(2262980), // Rule ID 48775 //
     /* 2262937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2262943 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2262946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262950 */   // MIs[0] Operand 1
     /* 2262950 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262959 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262963 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2262966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262968 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262970 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262978 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262979 */   // GIR_Coverage, 48775,
     /* 2262979 */   GIR_EraseRootFromParent_Done,
     /* 2262980 */ // Label 30318: @2262980
     /* 2262980 */ GIM_Try, /*On fail goto*//*Label 30319*/ GIMT_Encode4(2263028), // Rule ID 48782 //
     /* 2262985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2262988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2262991 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2262994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262998 */   // MIs[0] Operand 1
     /* 2262998 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263003 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263007 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263011 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2263011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263016 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263018 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2263026 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263027 */   // GIR_Coverage, 48782,
     /* 2263027 */   GIR_EraseRootFromParent_Done,
     /* 2263028 */ // Label 30319: @2263028
     /* 2263028 */ GIM_Try, /*On fail goto*//*Label 30320*/ GIMT_Encode4(2263076), // Rule ID 48783 //
     /* 2263033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2263036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2263039 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2263042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263046 */   // MIs[0] Operand 1
     /* 2263046 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263055 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263059 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2263059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263064 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263066 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2263074 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263075 */   // GIR_Coverage, 48783,
     /* 2263075 */   GIR_EraseRootFromParent_Done,
     /* 2263076 */ // Label 30320: @2263076
     /* 2263076 */ GIM_Try, /*On fail goto*//*Label 30321*/ GIMT_Encode4(2263124), // Rule ID 48796 //
     /* 2263081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2263087 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2263090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263094 */   // MIs[0] Operand 1
     /* 2263094 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263103 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263107 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2263110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263112 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263114 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263122 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263123 */   // GIR_Coverage, 48796,
     /* 2263123 */   GIR_EraseRootFromParent_Done,
     /* 2263124 */ // Label 30321: @2263124
     /* 2263124 */ GIM_Try, /*On fail goto*//*Label 30322*/ GIMT_Encode4(2263172), // Rule ID 48797 //
     /* 2263129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2263135 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2263138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263142 */   // MIs[0] Operand 1
     /* 2263142 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263151 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263155 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2263158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263160 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263162 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263170 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263171 */   // GIR_Coverage, 48797,
     /* 2263171 */   GIR_EraseRootFromParent_Done,
     /* 2263172 */ // Label 30322: @2263172
     /* 2263172 */ GIM_Try, /*On fail goto*//*Label 30323*/ GIMT_Encode4(2263220), // Rule ID 48810 //
     /* 2263177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2263183 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2263186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263190 */   // MIs[0] Operand 1
     /* 2263190 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263199 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263203 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2263206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263208 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263210 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263218 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263219 */   // GIR_Coverage, 48810,
     /* 2263219 */   GIR_EraseRootFromParent_Done,
     /* 2263220 */ // Label 30323: @2263220
     /* 2263220 */ GIM_Try, /*On fail goto*//*Label 30324*/ GIMT_Encode4(2263268), // Rule ID 48811 //
     /* 2263225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2263231 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2263234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263238 */   // MIs[0] Operand 1
     /* 2263238 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263247 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263251 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2263254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263256 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263258 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263266 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263267 */   // GIR_Coverage, 48811,
     /* 2263267 */   GIR_EraseRootFromParent_Done,
     /* 2263268 */ // Label 30324: @2263268
     /* 2263268 */ GIM_Try, /*On fail goto*//*Label 30325*/ GIMT_Encode4(2263316), // Rule ID 48818 //
     /* 2263273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2263279 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2263282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263286 */   // MIs[0] Operand 1
     /* 2263286 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263295 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263299 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2263302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263304 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263306 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263314 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263315 */   // GIR_Coverage, 48818,
     /* 2263315 */   GIR_EraseRootFromParent_Done,
     /* 2263316 */ // Label 30325: @2263316
     /* 2263316 */ GIM_Try, /*On fail goto*//*Label 30326*/ GIMT_Encode4(2263364), // Rule ID 48819 //
     /* 2263321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2263327 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2263330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263334 */   // MIs[0] Operand 1
     /* 2263334 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263343 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263347 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2263350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263352 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263354 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263362 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263363 */   // GIR_Coverage, 48819,
     /* 2263363 */   GIR_EraseRootFromParent_Done,
     /* 2263364 */ // Label 30326: @2263364
     /* 2263364 */ GIM_Try, /*On fail goto*//*Label 30327*/ GIMT_Encode4(2263412), // Rule ID 48826 //
     /* 2263369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2263372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2263375 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2263378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263382 */   // MIs[0] Operand 1
     /* 2263382 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263391 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263395 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2263395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263400 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263402 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2263410 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263411 */   // GIR_Coverage, 48826,
     /* 2263411 */   GIR_EraseRootFromParent_Done,
     /* 2263412 */ // Label 30327: @2263412
     /* 2263412 */ GIM_Try, /*On fail goto*//*Label 30328*/ GIMT_Encode4(2263460), // Rule ID 48827 //
     /* 2263417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2263420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2263423 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2263426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263430 */   // MIs[0] Operand 1
     /* 2263430 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263439 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263443 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2263443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263448 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263450 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2263458 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263459 */   // GIR_Coverage, 48827,
     /* 2263459 */   GIR_EraseRootFromParent_Done,
     /* 2263460 */ // Label 30328: @2263460
     /* 2263460 */ GIM_Try, /*On fail goto*//*Label 30329*/ GIMT_Encode4(2263508), // Rule ID 48840 //
     /* 2263465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2263471 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2263474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263478 */   // MIs[0] Operand 1
     /* 2263478 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263487 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263491 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2263494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263496 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263498 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263506 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263507 */   // GIR_Coverage, 48840,
     /* 2263507 */   GIR_EraseRootFromParent_Done,
     /* 2263508 */ // Label 30329: @2263508
     /* 2263508 */ GIM_Try, /*On fail goto*//*Label 30330*/ GIMT_Encode4(2263556), // Rule ID 48841 //
     /* 2263513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2263519 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2263522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263526 */   // MIs[0] Operand 1
     /* 2263526 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263535 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263539 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2263542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263544 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263546 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263554 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263555 */   // GIR_Coverage, 48841,
     /* 2263555 */   GIR_EraseRootFromParent_Done,
     /* 2263556 */ // Label 30330: @2263556
     /* 2263556 */ GIM_Try, /*On fail goto*//*Label 30331*/ GIMT_Encode4(2263604), // Rule ID 48854 //
     /* 2263561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2263567 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2263570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263574 */   // MIs[0] Operand 1
     /* 2263574 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263583 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263587 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263592 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263594 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263602 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263603 */   // GIR_Coverage, 48854,
     /* 2263603 */   GIR_EraseRootFromParent_Done,
     /* 2263604 */ // Label 30331: @2263604
     /* 2263604 */ GIM_Try, /*On fail goto*//*Label 30332*/ GIMT_Encode4(2263652), // Rule ID 48855 //
     /* 2263609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2263615 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2263618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263622 */   // MIs[0] Operand 1
     /* 2263622 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263627 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263631 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263635 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263640 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263642 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263650 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263651 */   // GIR_Coverage, 48855,
     /* 2263651 */   GIR_EraseRootFromParent_Done,
     /* 2263652 */ // Label 30332: @2263652
     /* 2263652 */ GIM_Try, /*On fail goto*//*Label 30333*/ GIMT_Encode4(2263700), // Rule ID 48862 //
     /* 2263657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2263663 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2263666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263670 */   // MIs[0] Operand 1
     /* 2263670 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263679 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263683 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263688 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263690 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263698 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263699 */   // GIR_Coverage, 48862,
     /* 2263699 */   GIR_EraseRootFromParent_Done,
     /* 2263700 */ // Label 30333: @2263700
     /* 2263700 */ GIM_Try, /*On fail goto*//*Label 30334*/ GIMT_Encode4(2263748), // Rule ID 48863 //
     /* 2263705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2263711 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2263714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263718 */   // MIs[0] Operand 1
     /* 2263718 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263723 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263727 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263731 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263736 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263738 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263746 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263747 */   // GIR_Coverage, 48863,
     /* 2263747 */   GIR_EraseRootFromParent_Done,
     /* 2263748 */ // Label 30334: @2263748
     /* 2263748 */ GIM_Try, /*On fail goto*//*Label 30335*/ GIMT_Encode4(2263796), // Rule ID 48870 //
     /* 2263753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2263756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2263759 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2263762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263766 */   // MIs[0] Operand 1
     /* 2263766 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263775 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263779 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2263779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2263782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263784 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263786 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2263794 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263795 */   // GIR_Coverage, 48870,
     /* 2263795 */   GIR_EraseRootFromParent_Done,
     /* 2263796 */ // Label 30335: @2263796
     /* 2263796 */ GIM_Try, /*On fail goto*//*Label 30336*/ GIMT_Encode4(2263844), // Rule ID 48871 //
     /* 2263801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2263804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2263807 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2263810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263814 */   // MIs[0] Operand 1
     /* 2263814 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263823 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263827 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2263827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2263830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263832 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263834 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2263842 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263843 */   // GIR_Coverage, 48871,
     /* 2263843 */   GIR_EraseRootFromParent_Done,
     /* 2263844 */ // Label 30336: @2263844
     /* 2263844 */ GIM_Try, /*On fail goto*//*Label 30337*/ GIMT_Encode4(2263892), // Rule ID 48884 //
     /* 2263849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2263855 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2263858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263862 */   // MIs[0] Operand 1
     /* 2263862 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263871 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263875 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2263878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263880 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263882 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263890 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263891 */   // GIR_Coverage, 48884,
     /* 2263891 */   GIR_EraseRootFromParent_Done,
     /* 2263892 */ // Label 30337: @2263892
     /* 2263892 */ GIM_Try, /*On fail goto*//*Label 30338*/ GIMT_Encode4(2263940), // Rule ID 48885 //
     /* 2263897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2263903 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2263906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263910 */   // MIs[0] Operand 1
     /* 2263910 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263915 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263919 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263923 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2263926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263928 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263930 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263938 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263939 */   // GIR_Coverage, 48885,
     /* 2263939 */   GIR_EraseRootFromParent_Done,
     /* 2263940 */ // Label 30338: @2263940
     /* 2263940 */ GIM_Try, /*On fail goto*//*Label 30339*/ GIMT_Encode4(2263988), // Rule ID 48898 //
     /* 2263945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2263951 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2263954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263958 */   // MIs[0] Operand 1
     /* 2263958 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263967 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263971 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263976 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263978 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263987 */   // GIR_Coverage, 48898,
     /* 2263987 */   GIR_EraseRootFromParent_Done,
     /* 2263988 */ // Label 30339: @2263988
     /* 2263988 */ GIM_Try, /*On fail goto*//*Label 30340*/ GIMT_Encode4(2264036), // Rule ID 48899 //
     /* 2263993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2263999 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2264002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264006 */   // MIs[0] Operand 1
     /* 2264006 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2264011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264015 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264019 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2264022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264024 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264026 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264034 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264035 */   // GIR_Coverage, 48899,
     /* 2264035 */   GIR_EraseRootFromParent_Done,
     /* 2264036 */ // Label 30340: @2264036
     /* 2264036 */ GIM_Try, /*On fail goto*//*Label 30341*/ GIMT_Encode4(2264084), // Rule ID 48906 //
     /* 2264041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2264047 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2264050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264054 */   // MIs[0] Operand 1
     /* 2264054 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2264059 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264063 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264067 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2264067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2264070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264072 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264074 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264083 */   // GIR_Coverage, 48906,
     /* 2264083 */   GIR_EraseRootFromParent_Done,
     /* 2264084 */ // Label 30341: @2264084
     /* 2264084 */ GIM_Try, /*On fail goto*//*Label 30342*/ GIMT_Encode4(2264132), // Rule ID 48907 //
     /* 2264089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2264095 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2264098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264102 */   // MIs[0] Operand 1
     /* 2264102 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2264107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264111 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264115 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2264115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2264118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264120 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264122 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264130 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264131 */   // GIR_Coverage, 48907,
     /* 2264131 */   GIR_EraseRootFromParent_Done,
     /* 2264132 */ // Label 30342: @2264132
     /* 2264132 */ GIM_Try, /*On fail goto*//*Label 30343*/ GIMT_Encode4(2264180), // Rule ID 48914 //
     /* 2264137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2264140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2264143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2264146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264150 */   // MIs[0] Operand 1
     /* 2264150 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2264155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264159 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264163 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2264163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2264166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264168 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264170 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2264178 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264179 */   // GIR_Coverage, 48914,
     /* 2264179 */   GIR_EraseRootFromParent_Done,
     /* 2264180 */ // Label 30343: @2264180
     /* 2264180 */ GIM_Try, /*On fail goto*//*Label 30344*/ GIMT_Encode4(2264228), // Rule ID 48915 //
     /* 2264185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2264188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2264191 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2264194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264198 */   // MIs[0] Operand 1
     /* 2264198 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2264203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264207 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264211 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2264211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2264214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264216 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264218 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2264226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264227 */   // GIR_Coverage, 48915,
     /* 2264227 */   GIR_EraseRootFromParent_Done,
     /* 2264228 */ // Label 30344: @2264228
     /* 2264228 */ GIM_Reject,
     /* 2264229 */ // Label 29927: @2264229
     /* 2264229 */ GIM_Try, /*On fail goto*//*Label 30345*/ GIMT_Encode4(2264277), // Rule ID 48498 //
     /* 2264234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2264240 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2264243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264247 */   // MIs[0] Operand 1
     /* 2264247 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264256 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264260 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2264263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264265 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264267 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264275 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264276 */   // GIR_Coverage, 48498,
     /* 2264276 */   GIR_EraseRootFromParent_Done,
     /* 2264277 */ // Label 30345: @2264277
     /* 2264277 */ GIM_Try, /*On fail goto*//*Label 30346*/ GIMT_Encode4(2264325), // Rule ID 48499 //
     /* 2264282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2264288 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2264291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264295 */   // MIs[0] Operand 1
     /* 2264295 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264300 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264304 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264308 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2264311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264313 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264315 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264324 */   // GIR_Coverage, 48499,
     /* 2264324 */   GIR_EraseRootFromParent_Done,
     /* 2264325 */ // Label 30346: @2264325
     /* 2264325 */ GIM_Try, /*On fail goto*//*Label 30347*/ GIMT_Encode4(2264373), // Rule ID 48506 //
     /* 2264330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2264336 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2264339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264343 */   // MIs[0] Operand 1
     /* 2264343 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264352 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264356 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2264359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264361 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264363 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264371 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264372 */   // GIR_Coverage, 48506,
     /* 2264372 */   GIR_EraseRootFromParent_Done,
     /* 2264373 */ // Label 30347: @2264373
     /* 2264373 */ GIM_Try, /*On fail goto*//*Label 30348*/ GIMT_Encode4(2264421), // Rule ID 48507 //
     /* 2264378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2264384 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2264387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264391 */   // MIs[0] Operand 1
     /* 2264391 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264400 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264404 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2264407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264409 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264411 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264419 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264420 */   // GIR_Coverage, 48507,
     /* 2264420 */   GIR_EraseRootFromParent_Done,
     /* 2264421 */ // Label 30348: @2264421
     /* 2264421 */ GIM_Try, /*On fail goto*//*Label 30349*/ GIMT_Encode4(2264469), // Rule ID 48514 //
     /* 2264426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2264432 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2264435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264439 */   // MIs[0] Operand 1
     /* 2264439 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264448 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264452 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2264452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2264455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264457 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264459 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264467 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264468 */   // GIR_Coverage, 48514,
     /* 2264468 */   GIR_EraseRootFromParent_Done,
     /* 2264469 */ // Label 30349: @2264469
     /* 2264469 */ GIM_Try, /*On fail goto*//*Label 30350*/ GIMT_Encode4(2264517), // Rule ID 48515 //
     /* 2264474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2264480 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2264483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264487 */   // MIs[0] Operand 1
     /* 2264487 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264496 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264500 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2264500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2264503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264505 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264507 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264515 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264516 */   // GIR_Coverage, 48515,
     /* 2264516 */   GIR_EraseRootFromParent_Done,
     /* 2264517 */ // Label 30350: @2264517
     /* 2264517 */ GIM_Try, /*On fail goto*//*Label 30351*/ GIMT_Encode4(2264565), // Rule ID 48542 //
     /* 2264522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2264528 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2264531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264535 */   // MIs[0] Operand 1
     /* 2264535 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264544 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264548 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2264551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264553 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264555 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264563 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264564 */   // GIR_Coverage, 48542,
     /* 2264564 */   GIR_EraseRootFromParent_Done,
     /* 2264565 */ // Label 30351: @2264565
     /* 2264565 */ GIM_Try, /*On fail goto*//*Label 30352*/ GIMT_Encode4(2264613), // Rule ID 48543 //
     /* 2264570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2264576 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2264579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264583 */   // MIs[0] Operand 1
     /* 2264583 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264592 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264596 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2264599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264601 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264603 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264611 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264612 */   // GIR_Coverage, 48543,
     /* 2264612 */   GIR_EraseRootFromParent_Done,
     /* 2264613 */ // Label 30352: @2264613
     /* 2264613 */ GIM_Try, /*On fail goto*//*Label 30353*/ GIMT_Encode4(2264661), // Rule ID 48550 //
     /* 2264618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2264624 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2264627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264631 */   // MIs[0] Operand 1
     /* 2264631 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264640 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264644 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2264647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264649 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264651 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264659 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264660 */   // GIR_Coverage, 48550,
     /* 2264660 */   GIR_EraseRootFromParent_Done,
     /* 2264661 */ // Label 30353: @2264661
     /* 2264661 */ GIM_Try, /*On fail goto*//*Label 30354*/ GIMT_Encode4(2264709), // Rule ID 48551 //
     /* 2264666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2264672 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2264675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264679 */   // MIs[0] Operand 1
     /* 2264679 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264688 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264692 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2264695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264697 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264699 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264708 */   // GIR_Coverage, 48551,
     /* 2264708 */   GIR_EraseRootFromParent_Done,
     /* 2264709 */ // Label 30354: @2264709
     /* 2264709 */ GIM_Try, /*On fail goto*//*Label 30355*/ GIMT_Encode4(2264757), // Rule ID 48558 //
     /* 2264714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2264720 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2264723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264727 */   // MIs[0] Operand 1
     /* 2264727 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264736 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264740 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2264740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2264743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264745 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264747 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264755 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264756 */   // GIR_Coverage, 48558,
     /* 2264756 */   GIR_EraseRootFromParent_Done,
     /* 2264757 */ // Label 30355: @2264757
     /* 2264757 */ GIM_Try, /*On fail goto*//*Label 30356*/ GIMT_Encode4(2264805), // Rule ID 48559 //
     /* 2264762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2264768 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2264771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264775 */   // MIs[0] Operand 1
     /* 2264775 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264784 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264788 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2264788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2264791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264793 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264795 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264803 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264804 */   // GIR_Coverage, 48559,
     /* 2264804 */   GIR_EraseRootFromParent_Done,
     /* 2264805 */ // Label 30356: @2264805
     /* 2264805 */ GIM_Try, /*On fail goto*//*Label 30357*/ GIMT_Encode4(2264853), // Rule ID 48586 //
     /* 2264810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2264816 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2264819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264823 */   // MIs[0] Operand 1
     /* 2264823 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264832 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264836 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2264839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264841 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264843 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264851 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264852 */   // GIR_Coverage, 48586,
     /* 2264852 */   GIR_EraseRootFromParent_Done,
     /* 2264853 */ // Label 30357: @2264853
     /* 2264853 */ GIM_Try, /*On fail goto*//*Label 30358*/ GIMT_Encode4(2264901), // Rule ID 48587 //
     /* 2264858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2264864 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2264867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264871 */   // MIs[0] Operand 1
     /* 2264871 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264880 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264884 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2264887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264889 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264891 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264899 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264900 */   // GIR_Coverage, 48587,
     /* 2264900 */   GIR_EraseRootFromParent_Done,
     /* 2264901 */ // Label 30358: @2264901
     /* 2264901 */ GIM_Try, /*On fail goto*//*Label 30359*/ GIMT_Encode4(2264949), // Rule ID 48594 //
     /* 2264906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2264912 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2264915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264919 */   // MIs[0] Operand 1
     /* 2264919 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264928 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264932 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264937 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264939 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264947 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264948 */   // GIR_Coverage, 48594,
     /* 2264948 */   GIR_EraseRootFromParent_Done,
     /* 2264949 */ // Label 30359: @2264949
     /* 2264949 */ GIM_Try, /*On fail goto*//*Label 30360*/ GIMT_Encode4(2264997), // Rule ID 48595 //
     /* 2264954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2264960 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2264963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264967 */   // MIs[0] Operand 1
     /* 2264967 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264976 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264980 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264985 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264987 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264995 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264996 */   // GIR_Coverage, 48595,
     /* 2264996 */   GIR_EraseRootFromParent_Done,
     /* 2264997 */ // Label 30360: @2264997
     /* 2264997 */ GIM_Try, /*On fail goto*//*Label 30361*/ GIMT_Encode4(2265045), // Rule ID 48602 //
     /* 2265002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2265008 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2265011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265015 */   // MIs[0] Operand 1
     /* 2265015 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2265020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265024 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265028 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2265028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2265031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265033 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265035 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265043 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265044 */   // GIR_Coverage, 48602,
     /* 2265044 */   GIR_EraseRootFromParent_Done,
     /* 2265045 */ // Label 30361: @2265045
     /* 2265045 */ GIM_Try, /*On fail goto*//*Label 30362*/ GIMT_Encode4(2265093), // Rule ID 48603 //
     /* 2265050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2265056 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2265059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265063 */   // MIs[0] Operand 1
     /* 2265063 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2265068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265072 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265076 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2265076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2265079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265081 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265083 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265091 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265092 */   // GIR_Coverage, 48603,
     /* 2265092 */   GIR_EraseRootFromParent_Done,
     /* 2265093 */ // Label 30362: @2265093
     /* 2265093 */ GIM_Try, /*On fail goto*//*Label 30363*/ GIMT_Encode4(2265141), // Rule ID 48628 //
     /* 2265098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2265104 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2265107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265111 */   // MIs[0] Operand 1
     /* 2265111 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2265116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265120 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265124 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2265127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265129 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265131 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265139 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265140 */   // GIR_Coverage, 48628,
     /* 2265140 */   GIR_EraseRootFromParent_Done,
     /* 2265141 */ // Label 30363: @2265141
     /* 2265141 */ GIM_Try, /*On fail goto*//*Label 30364*/ GIMT_Encode4(2265189), // Rule ID 48629 //
     /* 2265146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2265152 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2265155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265159 */   // MIs[0] Operand 1
     /* 2265159 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2265164 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265168 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265172 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2265175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265177 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265179 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265187 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265188 */   // GIR_Coverage, 48629,
     /* 2265188 */   GIR_EraseRootFromParent_Done,
     /* 2265189 */ // Label 30364: @2265189
     /* 2265189 */ GIM_Try, /*On fail goto*//*Label 30365*/ GIMT_Encode4(2265237), // Rule ID 48636 //
     /* 2265194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2265200 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2265203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265207 */   // MIs[0] Operand 1
     /* 2265207 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2265212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265216 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265220 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2265223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265225 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265227 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265235 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265236 */   // GIR_Coverage, 48636,
     /* 2265236 */   GIR_EraseRootFromParent_Done,
     /* 2265237 */ // Label 30365: @2265237
     /* 2265237 */ GIM_Try, /*On fail goto*//*Label 30366*/ GIMT_Encode4(2265285), // Rule ID 48637 //
     /* 2265242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2265248 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2265251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265255 */   // MIs[0] Operand 1
     /* 2265255 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2265260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265264 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265268 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2265271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265273 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265275 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265283 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265284 */   // GIR_Coverage, 48637,
     /* 2265284 */   GIR_EraseRootFromParent_Done,
     /* 2265285 */ // Label 30366: @2265285
     /* 2265285 */ GIM_Try, /*On fail goto*//*Label 30367*/ GIMT_Encode4(2265333), // Rule ID 48644 //
     /* 2265290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2265296 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2265299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265303 */   // MIs[0] Operand 1
     /* 2265303 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2265308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265312 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265316 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2265316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2265319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265321 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265323 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265331 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265332 */   // GIR_Coverage, 48644,
     /* 2265332 */   GIR_EraseRootFromParent_Done,
     /* 2265333 */ // Label 30367: @2265333
     /* 2265333 */ GIM_Try, /*On fail goto*//*Label 30368*/ GIMT_Encode4(2265381), // Rule ID 48645 //
     /* 2265338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2265344 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2265347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265351 */   // MIs[0] Operand 1
     /* 2265351 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2265356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265360 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265364 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2265364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2265367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265369 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265371 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265379 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265380 */   // GIR_Coverage, 48645,
     /* 2265380 */   GIR_EraseRootFromParent_Done,
     /* 2265381 */ // Label 30368: @2265381
     /* 2265381 */ GIM_Try, /*On fail goto*//*Label 30369*/ GIMT_Encode4(2265429), // Rule ID 48672 //
     /* 2265386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2265392 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2265395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265399 */   // MIs[0] Operand 1
     /* 2265399 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265408 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265412 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2265415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265417 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265419 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265427 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265428 */   // GIR_Coverage, 48672,
     /* 2265428 */   GIR_EraseRootFromParent_Done,
     /* 2265429 */ // Label 30369: @2265429
     /* 2265429 */ GIM_Try, /*On fail goto*//*Label 30370*/ GIMT_Encode4(2265477), // Rule ID 48673 //
     /* 2265434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2265440 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2265443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265447 */   // MIs[0] Operand 1
     /* 2265447 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265456 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265460 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2265463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265465 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265467 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265475 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265476 */   // GIR_Coverage, 48673,
     /* 2265476 */   GIR_EraseRootFromParent_Done,
     /* 2265477 */ // Label 30370: @2265477
     /* 2265477 */ GIM_Try, /*On fail goto*//*Label 30371*/ GIMT_Encode4(2265525), // Rule ID 48680 //
     /* 2265482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2265488 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2265491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265495 */   // MIs[0] Operand 1
     /* 2265495 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265504 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265508 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2265511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265513 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265515 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265523 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265524 */   // GIR_Coverage, 48680,
     /* 2265524 */   GIR_EraseRootFromParent_Done,
     /* 2265525 */ // Label 30371: @2265525
     /* 2265525 */ GIM_Try, /*On fail goto*//*Label 30372*/ GIMT_Encode4(2265573), // Rule ID 48681 //
     /* 2265530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2265536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2265539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265543 */   // MIs[0] Operand 1
     /* 2265543 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265552 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265556 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2265559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265561 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265563 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265571 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265572 */   // GIR_Coverage, 48681,
     /* 2265572 */   GIR_EraseRootFromParent_Done,
     /* 2265573 */ // Label 30372: @2265573
     /* 2265573 */ GIM_Try, /*On fail goto*//*Label 30373*/ GIMT_Encode4(2265621), // Rule ID 48688 //
     /* 2265578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2265584 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2265587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265591 */   // MIs[0] Operand 1
     /* 2265591 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265600 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265604 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2265604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265609 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265611 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265619 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265620 */   // GIR_Coverage, 48688,
     /* 2265620 */   GIR_EraseRootFromParent_Done,
     /* 2265621 */ // Label 30373: @2265621
     /* 2265621 */ GIM_Try, /*On fail goto*//*Label 30374*/ GIMT_Encode4(2265669), // Rule ID 48689 //
     /* 2265626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2265632 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2265635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265639 */   // MIs[0] Operand 1
     /* 2265639 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265648 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265652 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2265652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265657 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265659 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265667 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265668 */   // GIR_Coverage, 48689,
     /* 2265668 */   GIR_EraseRootFromParent_Done,
     /* 2265669 */ // Label 30374: @2265669
     /* 2265669 */ GIM_Try, /*On fail goto*//*Label 30375*/ GIMT_Encode4(2265717), // Rule ID 48716 //
     /* 2265674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2265680 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2265683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265687 */   // MIs[0] Operand 1
     /* 2265687 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265692 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265696 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265700 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2265703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265705 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265707 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265716 */   // GIR_Coverage, 48716,
     /* 2265716 */   GIR_EraseRootFromParent_Done,
     /* 2265717 */ // Label 30375: @2265717
     /* 2265717 */ GIM_Try, /*On fail goto*//*Label 30376*/ GIMT_Encode4(2265765), // Rule ID 48717 //
     /* 2265722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2265728 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2265731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265735 */   // MIs[0] Operand 1
     /* 2265735 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265744 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265748 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2265751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265753 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265755 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265763 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265764 */   // GIR_Coverage, 48717,
     /* 2265764 */   GIR_EraseRootFromParent_Done,
     /* 2265765 */ // Label 30376: @2265765
     /* 2265765 */ GIM_Try, /*On fail goto*//*Label 30377*/ GIMT_Encode4(2265813), // Rule ID 48724 //
     /* 2265770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2265776 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2265779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265783 */   // MIs[0] Operand 1
     /* 2265783 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265792 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265796 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2265799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265801 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265803 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265812 */   // GIR_Coverage, 48724,
     /* 2265812 */   GIR_EraseRootFromParent_Done,
     /* 2265813 */ // Label 30377: @2265813
     /* 2265813 */ GIM_Try, /*On fail goto*//*Label 30378*/ GIMT_Encode4(2265861), // Rule ID 48725 //
     /* 2265818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2265824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2265827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265831 */   // MIs[0] Operand 1
     /* 2265831 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265840 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265844 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2265847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265849 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265851 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265859 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265860 */   // GIR_Coverage, 48725,
     /* 2265860 */   GIR_EraseRootFromParent_Done,
     /* 2265861 */ // Label 30378: @2265861
     /* 2265861 */ GIM_Try, /*On fail goto*//*Label 30379*/ GIMT_Encode4(2265909), // Rule ID 48732 //
     /* 2265866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2265872 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2265875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265879 */   // MIs[0] Operand 1
     /* 2265879 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265884 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265888 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265892 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2265892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265897 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265899 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265907 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265908 */   // GIR_Coverage, 48732,
     /* 2265908 */   GIR_EraseRootFromParent_Done,
     /* 2265909 */ // Label 30379: @2265909
     /* 2265909 */ GIM_Try, /*On fail goto*//*Label 30380*/ GIMT_Encode4(2265957), // Rule ID 48733 //
     /* 2265914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2265920 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2265923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265927 */   // MIs[0] Operand 1
     /* 2265927 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265932 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265936 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265940 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2265940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265945 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265947 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265955 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265956 */   // GIR_Coverage, 48733,
     /* 2265956 */   GIR_EraseRootFromParent_Done,
     /* 2265957 */ // Label 30380: @2265957
     /* 2265957 */ GIM_Try, /*On fail goto*//*Label 30381*/ GIMT_Encode4(2266005), // Rule ID 48760 //
     /* 2265962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2265968 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2265971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265975 */   // MIs[0] Operand 1
     /* 2265975 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2265980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265984 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265988 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2265991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265993 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265995 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266004 */   // GIR_Coverage, 48760,
     /* 2266004 */   GIR_EraseRootFromParent_Done,
     /* 2266005 */ // Label 30381: @2266005
     /* 2266005 */ GIM_Try, /*On fail goto*//*Label 30382*/ GIMT_Encode4(2266053), // Rule ID 48761 //
     /* 2266010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2266016 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2266019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266023 */   // MIs[0] Operand 1
     /* 2266023 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2266028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266032 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266036 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2266039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266041 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266043 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266051 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266052 */   // GIR_Coverage, 48761,
     /* 2266052 */   GIR_EraseRootFromParent_Done,
     /* 2266053 */ // Label 30382: @2266053
     /* 2266053 */ GIM_Try, /*On fail goto*//*Label 30383*/ GIMT_Encode4(2266101), // Rule ID 48768 //
     /* 2266058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2266064 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2266067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266071 */   // MIs[0] Operand 1
     /* 2266071 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2266076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266080 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266084 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2266084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2266087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266089 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266091 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266099 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266100 */   // GIR_Coverage, 48768,
     /* 2266100 */   GIR_EraseRootFromParent_Done,
     /* 2266101 */ // Label 30383: @2266101
     /* 2266101 */ GIM_Try, /*On fail goto*//*Label 30384*/ GIMT_Encode4(2266149), // Rule ID 48769 //
     /* 2266106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2266112 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2266115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266119 */   // MIs[0] Operand 1
     /* 2266119 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2266124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266128 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266132 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2266132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2266135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266137 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266139 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266148 */   // GIR_Coverage, 48769,
     /* 2266148 */   GIR_EraseRootFromParent_Done,
     /* 2266149 */ // Label 30384: @2266149
     /* 2266149 */ GIM_Try, /*On fail goto*//*Label 30385*/ GIMT_Encode4(2266197), // Rule ID 48776 //
     /* 2266154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2266160 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2266163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266167 */   // MIs[0] Operand 1
     /* 2266167 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2266172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266176 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266180 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2266180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266185 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266187 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266195 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266196 */   // GIR_Coverage, 48776,
     /* 2266196 */   GIR_EraseRootFromParent_Done,
     /* 2266197 */ // Label 30385: @2266197
     /* 2266197 */ GIM_Try, /*On fail goto*//*Label 30386*/ GIMT_Encode4(2266245), // Rule ID 48777 //
     /* 2266202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2266208 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2266211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266215 */   // MIs[0] Operand 1
     /* 2266215 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2266220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266224 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266228 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2266228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266233 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266235 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266243 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266244 */   // GIR_Coverage, 48777,
     /* 2266244 */   GIR_EraseRootFromParent_Done,
     /* 2266245 */ // Label 30386: @2266245
     /* 2266245 */ GIM_Try, /*On fail goto*//*Label 30387*/ GIMT_Encode4(2266293), // Rule ID 48804 //
     /* 2266250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2266256 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2266259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266263 */   // MIs[0] Operand 1
     /* 2266263 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2266268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266272 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266276 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2266279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266281 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266283 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266291 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266292 */   // GIR_Coverage, 48804,
     /* 2266292 */   GIR_EraseRootFromParent_Done,
     /* 2266293 */ // Label 30387: @2266293
     /* 2266293 */ GIM_Try, /*On fail goto*//*Label 30388*/ GIMT_Encode4(2266341), // Rule ID 48805 //
     /* 2266298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2266304 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2266307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266311 */   // MIs[0] Operand 1
     /* 2266311 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2266316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266320 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266324 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2266327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266329 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266331 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266339 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266340 */   // GIR_Coverage, 48805,
     /* 2266340 */   GIR_EraseRootFromParent_Done,
     /* 2266341 */ // Label 30388: @2266341
     /* 2266341 */ GIM_Try, /*On fail goto*//*Label 30389*/ GIMT_Encode4(2266389), // Rule ID 48812 //
     /* 2266346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2266352 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2266355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266359 */   // MIs[0] Operand 1
     /* 2266359 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2266364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266368 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266372 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2266372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2266375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266377 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266379 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266387 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266388 */   // GIR_Coverage, 48812,
     /* 2266388 */   GIR_EraseRootFromParent_Done,
     /* 2266389 */ // Label 30389: @2266389
     /* 2266389 */ GIM_Try, /*On fail goto*//*Label 30390*/ GIMT_Encode4(2266437), // Rule ID 48813 //
     /* 2266394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2266400 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2266403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266407 */   // MIs[0] Operand 1
     /* 2266407 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2266412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266416 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266420 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2266420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2266423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266425 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266427 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266435 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266436 */   // GIR_Coverage, 48813,
     /* 2266436 */   GIR_EraseRootFromParent_Done,
     /* 2266437 */ // Label 30390: @2266437
     /* 2266437 */ GIM_Try, /*On fail goto*//*Label 30391*/ GIMT_Encode4(2266485), // Rule ID 48820 //
     /* 2266442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2266448 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2266451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266455 */   // MIs[0] Operand 1
     /* 2266455 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2266460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266464 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266468 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2266468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266473 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266475 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266483 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266484 */   // GIR_Coverage, 48820,
     /* 2266484 */   GIR_EraseRootFromParent_Done,
     /* 2266485 */ // Label 30391: @2266485
     /* 2266485 */ GIM_Try, /*On fail goto*//*Label 30392*/ GIMT_Encode4(2266533), // Rule ID 48821 //
     /* 2266490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2266496 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2266499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266503 */   // MIs[0] Operand 1
     /* 2266503 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2266508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266512 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266516 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2266516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266521 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266523 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266531 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266532 */   // GIR_Coverage, 48821,
     /* 2266532 */   GIR_EraseRootFromParent_Done,
     /* 2266533 */ // Label 30392: @2266533
     /* 2266533 */ GIM_Try, /*On fail goto*//*Label 30393*/ GIMT_Encode4(2266581), // Rule ID 48848 //
     /* 2266538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2266544 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2266547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266551 */   // MIs[0] Operand 1
     /* 2266551 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2266556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266560 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266564 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2266567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266569 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266571 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266579 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266580 */   // GIR_Coverage, 48848,
     /* 2266580 */   GIR_EraseRootFromParent_Done,
     /* 2266581 */ // Label 30393: @2266581
     /* 2266581 */ GIM_Try, /*On fail goto*//*Label 30394*/ GIMT_Encode4(2266629), // Rule ID 48849 //
     /* 2266586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2266592 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2266595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266599 */   // MIs[0] Operand 1
     /* 2266599 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2266604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266608 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266612 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2266615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266617 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266619 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266627 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266628 */   // GIR_Coverage, 48849,
     /* 2266628 */   GIR_EraseRootFromParent_Done,
     /* 2266629 */ // Label 30394: @2266629
     /* 2266629 */ GIM_Try, /*On fail goto*//*Label 30395*/ GIMT_Encode4(2266677), // Rule ID 48856 //
     /* 2266634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2266640 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2266643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266647 */   // MIs[0] Operand 1
     /* 2266647 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2266652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266656 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266660 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2266660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2266663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266665 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266667 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266675 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266676 */   // GIR_Coverage, 48856,
     /* 2266676 */   GIR_EraseRootFromParent_Done,
     /* 2266677 */ // Label 30395: @2266677
     /* 2266677 */ GIM_Try, /*On fail goto*//*Label 30396*/ GIMT_Encode4(2266725), // Rule ID 48857 //
     /* 2266682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2266688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2266691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266695 */   // MIs[0] Operand 1
     /* 2266695 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2266700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266704 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266708 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2266708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2266711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266713 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266715 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266723 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266724 */   // GIR_Coverage, 48857,
     /* 2266724 */   GIR_EraseRootFromParent_Done,
     /* 2266725 */ // Label 30396: @2266725
     /* 2266725 */ GIM_Try, /*On fail goto*//*Label 30397*/ GIMT_Encode4(2266773), // Rule ID 48864 //
     /* 2266730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2266736 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2266739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266743 */   // MIs[0] Operand 1
     /* 2266743 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2266748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266752 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266756 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2266756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266761 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266763 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266772 */   // GIR_Coverage, 48864,
     /* 2266772 */   GIR_EraseRootFromParent_Done,
     /* 2266773 */ // Label 30397: @2266773
     /* 2266773 */ GIM_Try, /*On fail goto*//*Label 30398*/ GIMT_Encode4(2266821), // Rule ID 48865 //
     /* 2266778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2266784 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2266787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266791 */   // MIs[0] Operand 1
     /* 2266791 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2266796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266800 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266804 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2266804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266809 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266811 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266819 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266820 */   // GIR_Coverage, 48865,
     /* 2266820 */   GIR_EraseRootFromParent_Done,
     /* 2266821 */ // Label 30398: @2266821
     /* 2266821 */ GIM_Try, /*On fail goto*//*Label 30399*/ GIMT_Encode4(2266869), // Rule ID 48892 //
     /* 2266826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2266832 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2266835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266839 */   // MIs[0] Operand 1
     /* 2266839 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2266844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266848 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266852 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2266855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266857 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266859 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266867 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266868 */   // GIR_Coverage, 48892,
     /* 2266868 */   GIR_EraseRootFromParent_Done,
     /* 2266869 */ // Label 30399: @2266869
     /* 2266869 */ GIM_Try, /*On fail goto*//*Label 30400*/ GIMT_Encode4(2266917), // Rule ID 48893 //
     /* 2266874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2266880 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2266883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266887 */   // MIs[0] Operand 1
     /* 2266887 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2266892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266896 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266900 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2266903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266905 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266907 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266915 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266916 */   // GIR_Coverage, 48893,
     /* 2266916 */   GIR_EraseRootFromParent_Done,
     /* 2266917 */ // Label 30400: @2266917
     /* 2266917 */ GIM_Try, /*On fail goto*//*Label 30401*/ GIMT_Encode4(2266965), // Rule ID 48900 //
     /* 2266922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2266928 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2266931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266935 */   // MIs[0] Operand 1
     /* 2266935 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2266940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266944 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266948 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2266948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2266951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266953 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266955 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266964 */   // GIR_Coverage, 48900,
     /* 2266964 */   GIR_EraseRootFromParent_Done,
     /* 2266965 */ // Label 30401: @2266965
     /* 2266965 */ GIM_Try, /*On fail goto*//*Label 30402*/ GIMT_Encode4(2267013), // Rule ID 48901 //
     /* 2266970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2266976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2266979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266983 */   // MIs[0] Operand 1
     /* 2266983 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2266988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266992 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266996 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2266996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2266999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267001 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2267003 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267011 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267012 */   // GIR_Coverage, 48901,
     /* 2267012 */   GIR_EraseRootFromParent_Done,
     /* 2267013 */ // Label 30402: @2267013
     /* 2267013 */ GIM_Try, /*On fail goto*//*Label 30403*/ GIMT_Encode4(2267061), // Rule ID 48908 //
     /* 2267018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2267024 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2267027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267031 */   // MIs[0] Operand 1
     /* 2267031 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2267036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267040 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267044 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2267044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2267047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267049 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2267051 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267059 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267060 */   // GIR_Coverage, 48908,
     /* 2267060 */   GIR_EraseRootFromParent_Done,
     /* 2267061 */ // Label 30403: @2267061
     /* 2267061 */ GIM_Try, /*On fail goto*//*Label 30404*/ GIMT_Encode4(2267109), // Rule ID 48909 //
     /* 2267066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2267072 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2267075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267079 */   // MIs[0] Operand 1
     /* 2267079 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2267084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267088 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267092 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2267092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2267095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267097 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2267099 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267107 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267108 */   // GIR_Coverage, 48909,
     /* 2267108 */   GIR_EraseRootFromParent_Done,
     /* 2267109 */ // Label 30404: @2267109
     /* 2267109 */ GIM_Reject,
     /* 2267110 */ // Label 29928: @2267110
     /* 2267110 */ GIM_Try, /*On fail goto*//*Label 30405*/ GIMT_Encode4(2267158), // Rule ID 48500 //
     /* 2267115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2267121 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2267124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267128 */   // MIs[0] Operand 1
     /* 2267128 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2267133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267137 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267141 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2267144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267146 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267148 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267156 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267157 */   // GIR_Coverage, 48500,
     /* 2267157 */   GIR_EraseRootFromParent_Done,
     /* 2267158 */ // Label 30405: @2267158
     /* 2267158 */ GIM_Try, /*On fail goto*//*Label 30406*/ GIMT_Encode4(2267206), // Rule ID 48501 //
     /* 2267163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2267169 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2267172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267176 */   // MIs[0] Operand 1
     /* 2267176 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2267181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267185 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267189 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2267192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267194 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267196 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267204 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267205 */   // GIR_Coverage, 48501,
     /* 2267205 */   GIR_EraseRootFromParent_Done,
     /* 2267206 */ // Label 30406: @2267206
     /* 2267206 */ GIM_Try, /*On fail goto*//*Label 30407*/ GIMT_Encode4(2267254), // Rule ID 48508 //
     /* 2267211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2267217 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2267220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267224 */   // MIs[0] Operand 1
     /* 2267224 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2267229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267233 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267237 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2267237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2267240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267242 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267244 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267253 */   // GIR_Coverage, 48508,
     /* 2267253 */   GIR_EraseRootFromParent_Done,
     /* 2267254 */ // Label 30407: @2267254
     /* 2267254 */ GIM_Try, /*On fail goto*//*Label 30408*/ GIMT_Encode4(2267302), // Rule ID 48509 //
     /* 2267259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2267265 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2267268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267272 */   // MIs[0] Operand 1
     /* 2267272 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2267277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267281 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267285 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2267285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2267288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267290 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267292 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267300 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267301 */   // GIR_Coverage, 48509,
     /* 2267301 */   GIR_EraseRootFromParent_Done,
     /* 2267302 */ // Label 30408: @2267302
     /* 2267302 */ GIM_Try, /*On fail goto*//*Label 30409*/ GIMT_Encode4(2267350), // Rule ID 48544 //
     /* 2267307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2267313 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2267316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267320 */   // MIs[0] Operand 1
     /* 2267320 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2267325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267329 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267333 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2267336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267338 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267340 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267349 */   // GIR_Coverage, 48544,
     /* 2267349 */   GIR_EraseRootFromParent_Done,
     /* 2267350 */ // Label 30409: @2267350
     /* 2267350 */ GIM_Try, /*On fail goto*//*Label 30410*/ GIMT_Encode4(2267398), // Rule ID 48545 //
     /* 2267355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2267361 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2267364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267368 */   // MIs[0] Operand 1
     /* 2267368 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2267373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267377 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267381 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2267384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267386 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267388 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267397 */   // GIR_Coverage, 48545,
     /* 2267397 */   GIR_EraseRootFromParent_Done,
     /* 2267398 */ // Label 30410: @2267398
     /* 2267398 */ GIM_Try, /*On fail goto*//*Label 30411*/ GIMT_Encode4(2267446), // Rule ID 48552 //
     /* 2267403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2267409 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2267412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267416 */   // MIs[0] Operand 1
     /* 2267416 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2267421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267425 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267429 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2267429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2267432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267434 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267436 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267445 */   // GIR_Coverage, 48552,
     /* 2267445 */   GIR_EraseRootFromParent_Done,
     /* 2267446 */ // Label 30411: @2267446
     /* 2267446 */ GIM_Try, /*On fail goto*//*Label 30412*/ GIMT_Encode4(2267494), // Rule ID 48553 //
     /* 2267451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2267457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2267460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267464 */   // MIs[0] Operand 1
     /* 2267464 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2267469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267473 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267477 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2267477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2267480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267482 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267484 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267493 */   // GIR_Coverage, 48553,
     /* 2267493 */   GIR_EraseRootFromParent_Done,
     /* 2267494 */ // Label 30412: @2267494
     /* 2267494 */ GIM_Try, /*On fail goto*//*Label 30413*/ GIMT_Encode4(2267542), // Rule ID 48588 //
     /* 2267499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2267505 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2267508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267512 */   // MIs[0] Operand 1
     /* 2267512 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2267517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267521 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267525 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2267528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267530 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267532 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267540 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267541 */   // GIR_Coverage, 48588,
     /* 2267541 */   GIR_EraseRootFromParent_Done,
     /* 2267542 */ // Label 30413: @2267542
     /* 2267542 */ GIM_Try, /*On fail goto*//*Label 30414*/ GIMT_Encode4(2267590), // Rule ID 48589 //
     /* 2267547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2267553 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2267556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267560 */   // MIs[0] Operand 1
     /* 2267560 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2267565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267569 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267573 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2267576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267578 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267580 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267588 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267589 */   // GIR_Coverage, 48589,
     /* 2267589 */   GIR_EraseRootFromParent_Done,
     /* 2267590 */ // Label 30414: @2267590
     /* 2267590 */ GIM_Try, /*On fail goto*//*Label 30415*/ GIMT_Encode4(2267638), // Rule ID 48596 //
     /* 2267595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2267601 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2267604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267608 */   // MIs[0] Operand 1
     /* 2267608 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2267613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267617 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267621 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2267621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2267624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267626 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267628 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267636 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267637 */   // GIR_Coverage, 48596,
     /* 2267637 */   GIR_EraseRootFromParent_Done,
     /* 2267638 */ // Label 30415: @2267638
     /* 2267638 */ GIM_Try, /*On fail goto*//*Label 30416*/ GIMT_Encode4(2267686), // Rule ID 48597 //
     /* 2267643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2267649 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2267652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267656 */   // MIs[0] Operand 1
     /* 2267656 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2267661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267665 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267669 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2267669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2267672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267674 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267676 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267685 */   // GIR_Coverage, 48597,
     /* 2267685 */   GIR_EraseRootFromParent_Done,
     /* 2267686 */ // Label 30416: @2267686
     /* 2267686 */ GIM_Try, /*On fail goto*//*Label 30417*/ GIMT_Encode4(2267734), // Rule ID 48630 //
     /* 2267691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2267697 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2267700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267704 */   // MIs[0] Operand 1
     /* 2267704 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2267709 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267713 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267717 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2267720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267722 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2267724 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267732 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267733 */   // GIR_Coverage, 48630,
     /* 2267733 */   GIR_EraseRootFromParent_Done,
     /* 2267734 */ // Label 30417: @2267734
     /* 2267734 */ GIM_Try, /*On fail goto*//*Label 30418*/ GIMT_Encode4(2267782), // Rule ID 48631 //
     /* 2267739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2267745 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2267748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267752 */   // MIs[0] Operand 1
     /* 2267752 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2267757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267761 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267765 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2267768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267770 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2267772 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267781 */   // GIR_Coverage, 48631,
     /* 2267781 */   GIR_EraseRootFromParent_Done,
     /* 2267782 */ // Label 30418: @2267782
     /* 2267782 */ GIM_Try, /*On fail goto*//*Label 30419*/ GIMT_Encode4(2267830), // Rule ID 48638 //
     /* 2267787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2267793 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2267796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267800 */   // MIs[0] Operand 1
     /* 2267800 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2267805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267809 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267813 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2267813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2267816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267818 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2267820 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267829 */   // GIR_Coverage, 48638,
     /* 2267829 */   GIR_EraseRootFromParent_Done,
     /* 2267830 */ // Label 30419: @2267830
     /* 2267830 */ GIM_Try, /*On fail goto*//*Label 30420*/ GIMT_Encode4(2267878), // Rule ID 48639 //
     /* 2267835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2267841 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2267844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267848 */   // MIs[0] Operand 1
     /* 2267848 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2267853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267857 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267861 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2267861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2267864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267866 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2267868 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267877 */   // GIR_Coverage, 48639,
     /* 2267877 */   GIR_EraseRootFromParent_Done,
     /* 2267878 */ // Label 30420: @2267878
     /* 2267878 */ GIM_Try, /*On fail goto*//*Label 30421*/ GIMT_Encode4(2267926), // Rule ID 48674 //
     /* 2267883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2267889 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2267892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267896 */   // MIs[0] Operand 1
     /* 2267896 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2267901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267905 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267909 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2267912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267914 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267916 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267925 */   // GIR_Coverage, 48674,
     /* 2267925 */   GIR_EraseRootFromParent_Done,
     /* 2267926 */ // Label 30421: @2267926
     /* 2267926 */ GIM_Try, /*On fail goto*//*Label 30422*/ GIMT_Encode4(2267974), // Rule ID 48675 //
     /* 2267931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2267937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2267940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267944 */   // MIs[0] Operand 1
     /* 2267944 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2267949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267953 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267957 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2267960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267962 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267964 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267973 */   // GIR_Coverage, 48675,
     /* 2267973 */   GIR_EraseRootFromParent_Done,
     /* 2267974 */ // Label 30422: @2267974
     /* 2267974 */ GIM_Try, /*On fail goto*//*Label 30423*/ GIMT_Encode4(2268022), // Rule ID 48682 //
     /* 2267979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2267985 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2267988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267992 */   // MIs[0] Operand 1
     /* 2267992 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2267997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268001 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268005 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2268008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268010 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268012 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268020 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268021 */   // GIR_Coverage, 48682,
     /* 2268021 */   GIR_EraseRootFromParent_Done,
     /* 2268022 */ // Label 30423: @2268022
     /* 2268022 */ GIM_Try, /*On fail goto*//*Label 30424*/ GIMT_Encode4(2268070), // Rule ID 48683 //
     /* 2268027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2268033 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2268036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268040 */   // MIs[0] Operand 1
     /* 2268040 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2268045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268049 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268053 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2268056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268058 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268060 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268069 */   // GIR_Coverage, 48683,
     /* 2268069 */   GIR_EraseRootFromParent_Done,
     /* 2268070 */ // Label 30424: @2268070
     /* 2268070 */ GIM_Try, /*On fail goto*//*Label 30425*/ GIMT_Encode4(2268118), // Rule ID 48718 //
     /* 2268075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2268081 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2268084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268088 */   // MIs[0] Operand 1
     /* 2268088 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2268093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268097 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268101 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2268104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268106 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2268108 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268116 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268117 */   // GIR_Coverage, 48718,
     /* 2268117 */   GIR_EraseRootFromParent_Done,
     /* 2268118 */ // Label 30425: @2268118
     /* 2268118 */ GIM_Try, /*On fail goto*//*Label 30426*/ GIMT_Encode4(2268166), // Rule ID 48719 //
     /* 2268123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2268129 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2268132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268136 */   // MIs[0] Operand 1
     /* 2268136 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2268141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268145 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268149 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2268152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268154 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2268156 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268165 */   // GIR_Coverage, 48719,
     /* 2268165 */   GIR_EraseRootFromParent_Done,
     /* 2268166 */ // Label 30426: @2268166
     /* 2268166 */ GIM_Try, /*On fail goto*//*Label 30427*/ GIMT_Encode4(2268214), // Rule ID 48726 //
     /* 2268171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2268177 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2268180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268184 */   // MIs[0] Operand 1
     /* 2268184 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2268189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268193 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268197 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2268200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268202 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2268204 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268212 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268213 */   // GIR_Coverage, 48726,
     /* 2268213 */   GIR_EraseRootFromParent_Done,
     /* 2268214 */ // Label 30427: @2268214
     /* 2268214 */ GIM_Try, /*On fail goto*//*Label 30428*/ GIMT_Encode4(2268262), // Rule ID 48727 //
     /* 2268219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2268225 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2268228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268232 */   // MIs[0] Operand 1
     /* 2268232 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2268237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268241 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268245 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2268248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268250 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2268252 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268260 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268261 */   // GIR_Coverage, 48727,
     /* 2268261 */   GIR_EraseRootFromParent_Done,
     /* 2268262 */ // Label 30428: @2268262
     /* 2268262 */ GIM_Try, /*On fail goto*//*Label 30429*/ GIMT_Encode4(2268310), // Rule ID 48762 //
     /* 2268267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2268273 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2268276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268280 */   // MIs[0] Operand 1
     /* 2268280 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2268285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268289 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268293 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2268296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268298 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268300 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268309 */   // GIR_Coverage, 48762,
     /* 2268309 */   GIR_EraseRootFromParent_Done,
     /* 2268310 */ // Label 30429: @2268310
     /* 2268310 */ GIM_Try, /*On fail goto*//*Label 30430*/ GIMT_Encode4(2268358), // Rule ID 48763 //
     /* 2268315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2268321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2268324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268328 */   // MIs[0] Operand 1
     /* 2268328 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2268333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268337 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268341 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2268344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268346 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268348 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268357 */   // GIR_Coverage, 48763,
     /* 2268357 */   GIR_EraseRootFromParent_Done,
     /* 2268358 */ // Label 30430: @2268358
     /* 2268358 */ GIM_Try, /*On fail goto*//*Label 30431*/ GIMT_Encode4(2268406), // Rule ID 48770 //
     /* 2268363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2268369 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2268372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268376 */   // MIs[0] Operand 1
     /* 2268376 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2268381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268385 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268389 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2268392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268394 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268396 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268404 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268405 */   // GIR_Coverage, 48770,
     /* 2268405 */   GIR_EraseRootFromParent_Done,
     /* 2268406 */ // Label 30431: @2268406
     /* 2268406 */ GIM_Try, /*On fail goto*//*Label 30432*/ GIMT_Encode4(2268454), // Rule ID 48771 //
     /* 2268411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2268417 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2268420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268424 */   // MIs[0] Operand 1
     /* 2268424 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2268429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268433 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268437 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2268440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268442 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268444 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268452 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268453 */   // GIR_Coverage, 48771,
     /* 2268453 */   GIR_EraseRootFromParent_Done,
     /* 2268454 */ // Label 30432: @2268454
     /* 2268454 */ GIM_Try, /*On fail goto*//*Label 30433*/ GIMT_Encode4(2268502), // Rule ID 48806 //
     /* 2268459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2268465 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2268468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268472 */   // MIs[0] Operand 1
     /* 2268472 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2268477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268481 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268485 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2268488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268490 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2268492 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268500 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268501 */   // GIR_Coverage, 48806,
     /* 2268501 */   GIR_EraseRootFromParent_Done,
     /* 2268502 */ // Label 30433: @2268502
     /* 2268502 */ GIM_Try, /*On fail goto*//*Label 30434*/ GIMT_Encode4(2268550), // Rule ID 48807 //
     /* 2268507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2268513 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2268516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268520 */   // MIs[0] Operand 1
     /* 2268520 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2268525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268529 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268533 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2268536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268538 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2268540 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268548 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268549 */   // GIR_Coverage, 48807,
     /* 2268549 */   GIR_EraseRootFromParent_Done,
     /* 2268550 */ // Label 30434: @2268550
     /* 2268550 */ GIM_Try, /*On fail goto*//*Label 30435*/ GIMT_Encode4(2268598), // Rule ID 48814 //
     /* 2268555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2268561 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2268564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268568 */   // MIs[0] Operand 1
     /* 2268568 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2268573 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268577 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268581 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2268584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268586 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2268588 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268596 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268597 */   // GIR_Coverage, 48814,
     /* 2268597 */   GIR_EraseRootFromParent_Done,
     /* 2268598 */ // Label 30435: @2268598
     /* 2268598 */ GIM_Try, /*On fail goto*//*Label 30436*/ GIMT_Encode4(2268646), // Rule ID 48815 //
     /* 2268603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2268609 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2268612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268616 */   // MIs[0] Operand 1
     /* 2268616 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2268621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268625 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268629 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2268632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268634 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2268636 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268644 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268645 */   // GIR_Coverage, 48815,
     /* 2268645 */   GIR_EraseRootFromParent_Done,
     /* 2268646 */ // Label 30436: @2268646
     /* 2268646 */ GIM_Try, /*On fail goto*//*Label 30437*/ GIMT_Encode4(2268694), // Rule ID 48850 //
     /* 2268651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2268657 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2268660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268664 */   // MIs[0] Operand 1
     /* 2268664 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2268669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268673 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268677 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2268680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268682 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268684 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268692 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268693 */   // GIR_Coverage, 48850,
     /* 2268693 */   GIR_EraseRootFromParent_Done,
     /* 2268694 */ // Label 30437: @2268694
     /* 2268694 */ GIM_Try, /*On fail goto*//*Label 30438*/ GIMT_Encode4(2268742), // Rule ID 48851 //
     /* 2268699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2268705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2268708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268712 */   // MIs[0] Operand 1
     /* 2268712 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2268717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268721 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268725 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2268728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268730 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268732 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268740 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268741 */   // GIR_Coverage, 48851,
     /* 2268741 */   GIR_EraseRootFromParent_Done,
     /* 2268742 */ // Label 30438: @2268742
     /* 2268742 */ GIM_Try, /*On fail goto*//*Label 30439*/ GIMT_Encode4(2268790), // Rule ID 48858 //
     /* 2268747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2268753 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2268756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268760 */   // MIs[0] Operand 1
     /* 2268760 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2268765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268769 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268773 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2268776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268778 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268780 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268788 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268789 */   // GIR_Coverage, 48858,
     /* 2268789 */   GIR_EraseRootFromParent_Done,
     /* 2268790 */ // Label 30439: @2268790
     /* 2268790 */ GIM_Try, /*On fail goto*//*Label 30440*/ GIMT_Encode4(2268838), // Rule ID 48859 //
     /* 2268795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2268801 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2268804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268808 */   // MIs[0] Operand 1
     /* 2268808 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2268813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268817 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268821 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2268824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268826 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268828 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268836 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268837 */   // GIR_Coverage, 48859,
     /* 2268837 */   GIR_EraseRootFromParent_Done,
     /* 2268838 */ // Label 30440: @2268838
     /* 2268838 */ GIM_Try, /*On fail goto*//*Label 30441*/ GIMT_Encode4(2268886), // Rule ID 48894 //
     /* 2268843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2268849 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2268852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268856 */   // MIs[0] Operand 1
     /* 2268856 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2268861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268865 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268869 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2268872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268874 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2268876 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268884 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268885 */   // GIR_Coverage, 48894,
     /* 2268885 */   GIR_EraseRootFromParent_Done,
     /* 2268886 */ // Label 30441: @2268886
     /* 2268886 */ GIM_Try, /*On fail goto*//*Label 30442*/ GIMT_Encode4(2268934), // Rule ID 48895 //
     /* 2268891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2268897 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2268900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268904 */   // MIs[0] Operand 1
     /* 2268904 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2268909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268913 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268917 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2268920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268922 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2268924 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268932 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268933 */   // GIR_Coverage, 48895,
     /* 2268933 */   GIR_EraseRootFromParent_Done,
     /* 2268934 */ // Label 30442: @2268934
     /* 2268934 */ GIM_Try, /*On fail goto*//*Label 30443*/ GIMT_Encode4(2268982), // Rule ID 48902 //
     /* 2268939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2268945 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2268948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268952 */   // MIs[0] Operand 1
     /* 2268952 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2268957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268961 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268965 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2268968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268970 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2268972 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268980 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268981 */   // GIR_Coverage, 48902,
     /* 2268981 */   GIR_EraseRootFromParent_Done,
     /* 2268982 */ // Label 30443: @2268982
     /* 2268982 */ GIM_Try, /*On fail goto*//*Label 30444*/ GIMT_Encode4(2269030), // Rule ID 48903 //
     /* 2268987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2268993 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2268996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269000 */   // MIs[0] Operand 1
     /* 2269000 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2269005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269009 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269013 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2269016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269018 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2269020 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269029 */   // GIR_Coverage, 48903,
     /* 2269029 */   GIR_EraseRootFromParent_Done,
     /* 2269030 */ // Label 30444: @2269030
     /* 2269030 */ GIM_Reject,
     /* 2269031 */ // Label 29929: @2269031
     /* 2269031 */ GIM_Try, /*On fail goto*//*Label 30445*/ GIMT_Encode4(2269807),
     /* 2269036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2269039 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2269042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269046 */   GIM_Try, /*On fail goto*//*Label 30446*/ GIMT_Encode4(2269084), // Rule ID 48502 //
     /* 2269051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269054 */     // MIs[0] Operand 1
     /* 2269054 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2269059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269067 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2269070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269083 */     // GIR_Coverage, 48502,
     /* 2269083 */     GIR_EraseRootFromParent_Done,
     /* 2269084 */   // Label 30446: @2269084
     /* 2269084 */   GIM_Try, /*On fail goto*//*Label 30447*/ GIMT_Encode4(2269122), // Rule ID 48503 //
     /* 2269089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269092 */     // MIs[0] Operand 1
     /* 2269092 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2269097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269105 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2269108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269121 */     // GIR_Coverage, 48503,
     /* 2269121 */     GIR_EraseRootFromParent_Done,
     /* 2269122 */   // Label 30447: @2269122
     /* 2269122 */   GIM_Try, /*On fail goto*//*Label 30448*/ GIMT_Encode4(2269160), // Rule ID 48546 //
     /* 2269127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269130 */     // MIs[0] Operand 1
     /* 2269130 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2269135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269143 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2269146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269159 */     // GIR_Coverage, 48546,
     /* 2269159 */     GIR_EraseRootFromParent_Done,
     /* 2269160 */   // Label 30448: @2269160
     /* 2269160 */   GIM_Try, /*On fail goto*//*Label 30449*/ GIMT_Encode4(2269198), // Rule ID 48547 //
     /* 2269165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269168 */     // MIs[0] Operand 1
     /* 2269168 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2269173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269181 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2269184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269197 */     // GIR_Coverage, 48547,
     /* 2269197 */     GIR_EraseRootFromParent_Done,
     /* 2269198 */   // Label 30449: @2269198
     /* 2269198 */   GIM_Try, /*On fail goto*//*Label 30450*/ GIMT_Encode4(2269236), // Rule ID 48590 //
     /* 2269203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269206 */     // MIs[0] Operand 1
     /* 2269206 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2269211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269219 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2269222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269235 */     // GIR_Coverage, 48590,
     /* 2269235 */     GIR_EraseRootFromParent_Done,
     /* 2269236 */   // Label 30450: @2269236
     /* 2269236 */   GIM_Try, /*On fail goto*//*Label 30451*/ GIMT_Encode4(2269274), // Rule ID 48591 //
     /* 2269241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269244 */     // MIs[0] Operand 1
     /* 2269244 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2269249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269257 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2269260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269273 */     // GIR_Coverage, 48591,
     /* 2269273 */     GIR_EraseRootFromParent_Done,
     /* 2269274 */   // Label 30451: @2269274
     /* 2269274 */   GIM_Try, /*On fail goto*//*Label 30452*/ GIMT_Encode4(2269312), // Rule ID 48632 //
     /* 2269279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269282 */     // MIs[0] Operand 1
     /* 2269282 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2269287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269295 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2269298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2269302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269311 */     // GIR_Coverage, 48632,
     /* 2269311 */     GIR_EraseRootFromParent_Done,
     /* 2269312 */   // Label 30452: @2269312
     /* 2269312 */   GIM_Try, /*On fail goto*//*Label 30453*/ GIMT_Encode4(2269350), // Rule ID 48633 //
     /* 2269317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269320 */     // MIs[0] Operand 1
     /* 2269320 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2269325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269333 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2269336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2269340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269349 */     // GIR_Coverage, 48633,
     /* 2269349 */     GIR_EraseRootFromParent_Done,
     /* 2269350 */   // Label 30453: @2269350
     /* 2269350 */   GIM_Try, /*On fail goto*//*Label 30454*/ GIMT_Encode4(2269388), // Rule ID 48676 //
     /* 2269355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269358 */     // MIs[0] Operand 1
     /* 2269358 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2269363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269371 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2269374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269387 */     // GIR_Coverage, 48676,
     /* 2269387 */     GIR_EraseRootFromParent_Done,
     /* 2269388 */   // Label 30454: @2269388
     /* 2269388 */   GIM_Try, /*On fail goto*//*Label 30455*/ GIMT_Encode4(2269426), // Rule ID 48677 //
     /* 2269393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269396 */     // MIs[0] Operand 1
     /* 2269396 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2269401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269409 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2269412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269425 */     // GIR_Coverage, 48677,
     /* 2269425 */     GIR_EraseRootFromParent_Done,
     /* 2269426 */   // Label 30455: @2269426
     /* 2269426 */   GIM_Try, /*On fail goto*//*Label 30456*/ GIMT_Encode4(2269464), // Rule ID 48720 //
     /* 2269431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269434 */     // MIs[0] Operand 1
     /* 2269434 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2269439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269447 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2269450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2269454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269463 */     // GIR_Coverage, 48720,
     /* 2269463 */     GIR_EraseRootFromParent_Done,
     /* 2269464 */   // Label 30456: @2269464
     /* 2269464 */   GIM_Try, /*On fail goto*//*Label 30457*/ GIMT_Encode4(2269502), // Rule ID 48721 //
     /* 2269469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269472 */     // MIs[0] Operand 1
     /* 2269472 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2269477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269485 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2269488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2269492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269501 */     // GIR_Coverage, 48721,
     /* 2269501 */     GIR_EraseRootFromParent_Done,
     /* 2269502 */   // Label 30457: @2269502
     /* 2269502 */   GIM_Try, /*On fail goto*//*Label 30458*/ GIMT_Encode4(2269540), // Rule ID 48764 //
     /* 2269507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269510 */     // MIs[0] Operand 1
     /* 2269510 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2269515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269523 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2269526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269539 */     // GIR_Coverage, 48764,
     /* 2269539 */     GIR_EraseRootFromParent_Done,
     /* 2269540 */   // Label 30458: @2269540
     /* 2269540 */   GIM_Try, /*On fail goto*//*Label 30459*/ GIMT_Encode4(2269578), // Rule ID 48765 //
     /* 2269545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269548 */     // MIs[0] Operand 1
     /* 2269548 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2269553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269561 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2269564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269577 */     // GIR_Coverage, 48765,
     /* 2269577 */     GIR_EraseRootFromParent_Done,
     /* 2269578 */   // Label 30459: @2269578
     /* 2269578 */   GIM_Try, /*On fail goto*//*Label 30460*/ GIMT_Encode4(2269616), // Rule ID 48808 //
     /* 2269583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269586 */     // MIs[0] Operand 1
     /* 2269586 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2269591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269599 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2269602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2269606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269615 */     // GIR_Coverage, 48808,
     /* 2269615 */     GIR_EraseRootFromParent_Done,
     /* 2269616 */   // Label 30460: @2269616
     /* 2269616 */   GIM_Try, /*On fail goto*//*Label 30461*/ GIMT_Encode4(2269654), // Rule ID 48809 //
     /* 2269621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269624 */     // MIs[0] Operand 1
     /* 2269624 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2269629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269637 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2269640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2269644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269653 */     // GIR_Coverage, 48809,
     /* 2269653 */     GIR_EraseRootFromParent_Done,
     /* 2269654 */   // Label 30461: @2269654
     /* 2269654 */   GIM_Try, /*On fail goto*//*Label 30462*/ GIMT_Encode4(2269692), // Rule ID 48852 //
     /* 2269659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269662 */     // MIs[0] Operand 1
     /* 2269662 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2269667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269675 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2269678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269691 */     // GIR_Coverage, 48852,
     /* 2269691 */     GIR_EraseRootFromParent_Done,
     /* 2269692 */   // Label 30462: @2269692
     /* 2269692 */   GIM_Try, /*On fail goto*//*Label 30463*/ GIMT_Encode4(2269730), // Rule ID 48853 //
     /* 2269697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269700 */     // MIs[0] Operand 1
     /* 2269700 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2269705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269713 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2269716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269729 */     // GIR_Coverage, 48853,
     /* 2269729 */     GIR_EraseRootFromParent_Done,
     /* 2269730 */   // Label 30463: @2269730
     /* 2269730 */   GIM_Try, /*On fail goto*//*Label 30464*/ GIMT_Encode4(2269768), // Rule ID 48896 //
     /* 2269735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269738 */     // MIs[0] Operand 1
     /* 2269738 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2269743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269751 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2269754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2269758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269767 */     // GIR_Coverage, 48896,
     /* 2269767 */     GIR_EraseRootFromParent_Done,
     /* 2269768 */   // Label 30464: @2269768
     /* 2269768 */   GIM_Try, /*On fail goto*//*Label 30465*/ GIMT_Encode4(2269806), // Rule ID 48897 //
     /* 2269773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269776 */     // MIs[0] Operand 1
     /* 2269776 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2269781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269789 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2269792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2269796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269805 */     // GIR_Coverage, 48897,
     /* 2269805 */     GIR_EraseRootFromParent_Done,
     /* 2269806 */   // Label 30465: @2269806
     /* 2269806 */   GIM_Reject,
     /* 2269807 */ // Label 30445: @2269807
     /* 2269807 */ GIM_Reject,
     /* 2269808 */ // Label 29930: @2269808
     /* 2269808 */ GIM_Reject,
     /* 2269809 */ // Label 49: @2269809
     /* 2269809 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(30), /*)*//*default:*//*Label 30474*/ GIMT_Encode4(2277270),
     /* 2269820 */ /*GILLT_s32*//*Label 30466*/ GIMT_Encode4(2269928),
     /* 2269824 */ /*GILLT_s64*//*Label 30467*/ GIMT_Encode4(2270685),
     /* 2269828 */ /*GILLT_nxv1s1*//*Label 30468*/ GIMT_Encode4(2271568), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2269848 */ /*GILLT_nxv2s1*//*Label 30469*/ GIMT_Encode4(2272721), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2269868 */ /*GILLT_nxv4s1*//*Label 30470*/ GIMT_Encode4(2273874), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2269888 */ /*GILLT_nxv8s1*//*Label 30471*/ GIMT_Encode4(2275027), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2269908 */ /*GILLT_nxv16s1*//*Label 30472*/ GIMT_Encode4(2276180), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2269924 */ /*GILLT_nxv32s1*//*Label 30473*/ GIMT_Encode4(2276949),
     /* 2269928 */ // Label 30466: @2269928
     /* 2269928 */ GIM_Try, /*On fail goto*//*Label 30475*/ GIMT_Encode4(2269970), // Rule ID 1356 //
     /* 2269933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2269936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2269939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2269942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2269946 */   // MIs[0] Operand 1
     /* 2269946 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2269955 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2269959 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2269959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2269962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269964 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269966 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269968 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269969 */   // GIR_Coverage, 1356,
     /* 2269969 */   GIR_EraseRootFromParent_Done,
     /* 2269970 */ // Label 30475: @2269970
     /* 2269970 */ GIM_Try, /*On fail goto*//*Label 30476*/ GIMT_Encode4(2270012), // Rule ID 1360 //
     /* 2269975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2269978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2269981 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2269984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2269988 */   // MIs[0] Operand 1
     /* 2269988 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2269997 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2270001 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2270001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2270004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270006 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270008 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270010 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270011 */   // GIR_Coverage, 1360,
     /* 2270011 */   GIR_EraseRootFromParent_Done,
     /* 2270012 */ // Label 30476: @2270012
     /* 2270012 */ GIM_Try, /*On fail goto*//*Label 30477*/ GIMT_Encode4(2270054), // Rule ID 1404 //
     /* 2270017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2270020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2270023 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2270026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270030 */   // MIs[0] Operand 1
     /* 2270030 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2270039 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2270043 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2270043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2270046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270048 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270050 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270053 */   // GIR_Coverage, 1404,
     /* 2270053 */   GIR_EraseRootFromParent_Done,
     /* 2270054 */ // Label 30477: @2270054
     /* 2270054 */ GIM_Try, /*On fail goto*//*Label 30478*/ GIMT_Encode4(2270096), // Rule ID 1408 //
     /* 2270059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2270062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2270065 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2270068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270072 */   // MIs[0] Operand 1
     /* 2270072 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2270081 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2270085 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2270085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2270088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270090 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270092 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270094 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270095 */   // GIR_Coverage, 1408,
     /* 2270095 */   GIR_EraseRootFromParent_Done,
     /* 2270096 */ // Label 30478: @2270096
     /* 2270096 */ GIM_Try, /*On fail goto*//*Label 30479*/ GIMT_Encode4(2270138), // Rule ID 1420 //
     /* 2270101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2270104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2270107 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2270110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270114 */   // MIs[0] Operand 1
     /* 2270114 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2270123 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2270127 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2270127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2270130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270132 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270134 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270136 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270137 */   // GIR_Coverage, 1420,
     /* 2270137 */   GIR_EraseRootFromParent_Done,
     /* 2270138 */ // Label 30479: @2270138
     /* 2270138 */ GIM_Try, /*On fail goto*//*Label 30480*/ GIMT_Encode4(2270180), // Rule ID 1424 //
     /* 2270143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2270146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2270149 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2270152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270156 */   // MIs[0] Operand 1
     /* 2270156 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2270165 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2270169 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2270169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2270172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270174 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270176 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270178 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270179 */   // GIR_Coverage, 1424,
     /* 2270179 */   GIR_EraseRootFromParent_Done,
     /* 2270180 */ // Label 30480: @2270180
     /* 2270180 */ GIM_Try, /*On fail goto*//*Label 30481*/ GIMT_Encode4(2270222), // Rule ID 1736 //
     /* 2270185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2270188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2270191 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2270194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270198 */   // MIs[0] Operand 1
     /* 2270198 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2270207 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2270211 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2270211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2270214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270216 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270218 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270220 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270221 */   // GIR_Coverage, 1736,
     /* 2270221 */   GIR_EraseRootFromParent_Done,
     /* 2270222 */ // Label 30481: @2270222
     /* 2270222 */ GIM_Try, /*On fail goto*//*Label 30482*/ GIMT_Encode4(2270264), // Rule ID 1740 //
     /* 2270227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2270230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2270233 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2270236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270240 */   // MIs[0] Operand 1
     /* 2270240 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2270249 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2270253 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2270253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2270256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270258 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270260 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270262 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270263 */   // GIR_Coverage, 1740,
     /* 2270263 */   GIR_EraseRootFromParent_Done,
     /* 2270264 */ // Label 30482: @2270264
     /* 2270264 */ GIM_Try, /*On fail goto*//*Label 30483*/ GIMT_Encode4(2270306), // Rule ID 1778 //
     /* 2270269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2270272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2270275 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2270278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270282 */   // MIs[0] Operand 1
     /* 2270282 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2270291 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2270295 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2270295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2270298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270300 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270302 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270304 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270305 */   // GIR_Coverage, 1778,
     /* 2270305 */   GIR_EraseRootFromParent_Done,
     /* 2270306 */ // Label 30483: @2270306
     /* 2270306 */ GIM_Try, /*On fail goto*//*Label 30484*/ GIMT_Encode4(2270348), // Rule ID 1786 //
     /* 2270311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2270314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2270317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2270320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270324 */   // MIs[0] Operand 1
     /* 2270324 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2270333 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2270337 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2270337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2270340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270342 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270344 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270346 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270347 */   // GIR_Coverage, 1786,
     /* 2270347 */   GIR_EraseRootFromParent_Done,
     /* 2270348 */ // Label 30484: @2270348
     /* 2270348 */ GIM_Try, /*On fail goto*//*Label 30485*/ GIMT_Encode4(2270390), // Rule ID 1814 //
     /* 2270353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2270356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2270359 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2270362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270366 */   // MIs[0] Operand 1
     /* 2270366 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2270375 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2270379 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2270379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2270382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270384 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270386 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270388 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270389 */   // GIR_Coverage, 1814,
     /* 2270389 */   GIR_EraseRootFromParent_Done,
     /* 2270390 */ // Label 30485: @2270390
     /* 2270390 */ GIM_Try, /*On fail goto*//*Label 30486*/ GIMT_Encode4(2270432), // Rule ID 1822 //
     /* 2270395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2270398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2270401 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2270404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270408 */   // MIs[0] Operand 1
     /* 2270408 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2270417 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2270421 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2270421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2270424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270426 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270428 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270430 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270431 */   // GIR_Coverage, 1822,
     /* 2270431 */   GIR_EraseRootFromParent_Done,
     /* 2270432 */ // Label 30486: @2270432
     /* 2270432 */ GIM_Try, /*On fail goto*//*Label 30487*/ GIMT_Encode4(2270474), // Rule ID 2069 //
     /* 2270437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2270440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2270443 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2270446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270450 */   // MIs[0] Operand 1
     /* 2270450 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2270459 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2270463 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2270463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2270466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270468 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270470 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270472 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270473 */   // GIR_Coverage, 2069,
     /* 2270473 */   GIR_EraseRootFromParent_Done,
     /* 2270474 */ // Label 30487: @2270474
     /* 2270474 */ GIM_Try, /*On fail goto*//*Label 30488*/ GIMT_Encode4(2270516), // Rule ID 2073 //
     /* 2270479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2270482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2270485 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2270488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270492 */   // MIs[0] Operand 1
     /* 2270492 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270497 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2270501 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2270505 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2270505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2270508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270510 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270512 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270515 */   // GIR_Coverage, 2073,
     /* 2270515 */   GIR_EraseRootFromParent_Done,
     /* 2270516 */ // Label 30488: @2270516
     /* 2270516 */ GIM_Try, /*On fail goto*//*Label 30489*/ GIMT_Encode4(2270558), // Rule ID 2117 //
     /* 2270521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2270524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2270527 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2270530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270534 */   // MIs[0] Operand 1
     /* 2270534 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2270543 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2270547 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2270547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2270550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270552 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270554 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270556 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270557 */   // GIR_Coverage, 2117,
     /* 2270557 */   GIR_EraseRootFromParent_Done,
     /* 2270558 */ // Label 30489: @2270558
     /* 2270558 */ GIM_Try, /*On fail goto*//*Label 30490*/ GIMT_Encode4(2270600), // Rule ID 2121 //
     /* 2270563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2270566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2270569 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2270572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270576 */   // MIs[0] Operand 1
     /* 2270576 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2270585 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2270589 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2270589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2270592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270594 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270596 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270599 */   // GIR_Coverage, 2121,
     /* 2270599 */   GIR_EraseRootFromParent_Done,
     /* 2270600 */ // Label 30490: @2270600
     /* 2270600 */ GIM_Try, /*On fail goto*//*Label 30491*/ GIMT_Encode4(2270642), // Rule ID 2133 //
     /* 2270605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2270608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2270611 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2270614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270618 */   // MIs[0] Operand 1
     /* 2270618 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2270627 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2270631 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2270631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2270634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270636 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270638 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270640 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270641 */   // GIR_Coverage, 2133,
     /* 2270641 */   GIR_EraseRootFromParent_Done,
     /* 2270642 */ // Label 30491: @2270642
     /* 2270642 */ GIM_Try, /*On fail goto*//*Label 30492*/ GIMT_Encode4(2270684), // Rule ID 2137 //
     /* 2270647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2270650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2270653 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2270656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270660 */   // MIs[0] Operand 1
     /* 2270660 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2270669 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2270673 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2270673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2270676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270678 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270680 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270682 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270683 */   // GIR_Coverage, 2137,
     /* 2270683 */   GIR_EraseRootFromParent_Done,
     /* 2270684 */ // Label 30492: @2270684
     /* 2270684 */ GIM_Reject,
     /* 2270685 */ // Label 30467: @2270685
     /* 2270685 */ GIM_Try, /*On fail goto*//*Label 30493*/ GIMT_Encode4(2270727), // Rule ID 1355 //
     /* 2270690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2270693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2270696 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2270699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270703 */   // MIs[0] Operand 1
     /* 2270703 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2270712 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2270716 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2270716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2270719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270721 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270723 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270725 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270726 */   // GIR_Coverage, 1355,
     /* 2270726 */   GIR_EraseRootFromParent_Done,
     /* 2270727 */ // Label 30493: @2270727
     /* 2270727 */ GIM_Try, /*On fail goto*//*Label 30494*/ GIMT_Encode4(2270769), // Rule ID 1359 //
     /* 2270732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2270735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2270738 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2270741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270745 */   // MIs[0] Operand 1
     /* 2270745 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2270754 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2270758 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2270758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2270761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270763 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270765 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270767 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270768 */   // GIR_Coverage, 1359,
     /* 2270768 */   GIR_EraseRootFromParent_Done,
     /* 2270769 */ // Label 30494: @2270769
     /* 2270769 */ GIM_Try, /*On fail goto*//*Label 30495*/ GIMT_Encode4(2270811), // Rule ID 1403 //
     /* 2270774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2270777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2270780 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2270783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270787 */   // MIs[0] Operand 1
     /* 2270787 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2270796 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2270800 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2270800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2270803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270805 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270807 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270809 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270810 */   // GIR_Coverage, 1403,
     /* 2270810 */   GIR_EraseRootFromParent_Done,
     /* 2270811 */ // Label 30495: @2270811
     /* 2270811 */ GIM_Try, /*On fail goto*//*Label 30496*/ GIMT_Encode4(2270853), // Rule ID 1407 //
     /* 2270816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2270819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2270822 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2270825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270829 */   // MIs[0] Operand 1
     /* 2270829 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270834 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2270838 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2270842 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2270842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2270845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270847 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270849 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270851 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270852 */   // GIR_Coverage, 1407,
     /* 2270852 */   GIR_EraseRootFromParent_Done,
     /* 2270853 */ // Label 30496: @2270853
     /* 2270853 */ GIM_Try, /*On fail goto*//*Label 30497*/ GIMT_Encode4(2270895), // Rule ID 1419 //
     /* 2270858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2270861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2270864 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2270867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270871 */   // MIs[0] Operand 1
     /* 2270871 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2270880 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2270884 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2270884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2270887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270889 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270891 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270894 */   // GIR_Coverage, 1419,
     /* 2270894 */   GIR_EraseRootFromParent_Done,
     /* 2270895 */ // Label 30497: @2270895
     /* 2270895 */ GIM_Try, /*On fail goto*//*Label 30498*/ GIMT_Encode4(2270937), // Rule ID 1423 //
     /* 2270900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2270903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2270906 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2270909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270913 */   // MIs[0] Operand 1
     /* 2270913 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2270922 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2270926 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2270926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2270929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270931 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270933 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270935 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270936 */   // GIR_Coverage, 1423,
     /* 2270936 */   GIR_EraseRootFromParent_Done,
     /* 2270937 */ // Label 30498: @2270937
     /* 2270937 */ GIM_Try, /*On fail goto*//*Label 30499*/ GIMT_Encode4(2270979), // Rule ID 1735 //
     /* 2270942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2270945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2270948 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2270951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270955 */   // MIs[0] Operand 1
     /* 2270955 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2270964 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2270968 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2270968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2270971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270973 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270975 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270977 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270978 */   // GIR_Coverage, 1735,
     /* 2270978 */   GIR_EraseRootFromParent_Done,
     /* 2270979 */ // Label 30499: @2270979
     /* 2270979 */ GIM_Try, /*On fail goto*//*Label 30500*/ GIMT_Encode4(2271021), // Rule ID 1739 //
     /* 2270984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2270987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2270990 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2270993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2270997 */   // MIs[0] Operand 1
     /* 2270997 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271002 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2271006 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2271010 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2271010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2271013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271015 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271017 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271020 */   // GIR_Coverage, 1739,
     /* 2271020 */   GIR_EraseRootFromParent_Done,
     /* 2271021 */ // Label 30500: @2271021
     /* 2271021 */ GIM_Try, /*On fail goto*//*Label 30501*/ GIMT_Encode4(2271063), // Rule ID 1742 //
     /* 2271026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2271029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2271032 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2271035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271039 */   // MIs[0] Operand 1
     /* 2271039 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271048 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271052 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2271052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_INX),
     /* 2271055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271057 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271059 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271061 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271062 */   // GIR_Coverage, 1742,
     /* 2271062 */   GIR_EraseRootFromParent_Done,
     /* 2271063 */ // Label 30501: @2271063
     /* 2271063 */ GIM_Try, /*On fail goto*//*Label 30502*/ GIMT_Encode4(2271105), // Rule ID 1777 //
     /* 2271068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2271071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2271074 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2271077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271081 */   // MIs[0] Operand 1
     /* 2271081 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2271090 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2271094 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2271094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2271097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271099 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271101 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271104 */   // GIR_Coverage, 1777,
     /* 2271104 */   GIR_EraseRootFromParent_Done,
     /* 2271105 */ // Label 30502: @2271105
     /* 2271105 */ GIM_Try, /*On fail goto*//*Label 30503*/ GIMT_Encode4(2271147), // Rule ID 1785 //
     /* 2271110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2271113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2271116 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2271119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271123 */   // MIs[0] Operand 1
     /* 2271123 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2271132 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2271136 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2271136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2271139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271141 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271143 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271145 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271146 */   // GIR_Coverage, 1785,
     /* 2271146 */   GIR_EraseRootFromParent_Done,
     /* 2271147 */ // Label 30503: @2271147
     /* 2271147 */ GIM_Try, /*On fail goto*//*Label 30504*/ GIMT_Encode4(2271189), // Rule ID 1794 //
     /* 2271152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2271155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2271158 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2271161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271165 */   // MIs[0] Operand 1
     /* 2271165 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271174 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271178 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2271178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_INX),
     /* 2271181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271183 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271185 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271187 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271188 */   // GIR_Coverage, 1794,
     /* 2271188 */   GIR_EraseRootFromParent_Done,
     /* 2271189 */ // Label 30504: @2271189
     /* 2271189 */ GIM_Try, /*On fail goto*//*Label 30505*/ GIMT_Encode4(2271231), // Rule ID 1798 //
     /* 2271194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2271197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2271200 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2271203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271207 */   // MIs[0] Operand 1
     /* 2271207 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271216 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271220 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2271220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_INX),
     /* 2271223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271225 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271227 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271230 */   // GIR_Coverage, 1798,
     /* 2271230 */   GIR_EraseRootFromParent_Done,
     /* 2271231 */ // Label 30505: @2271231
     /* 2271231 */ GIM_Try, /*On fail goto*//*Label 30506*/ GIMT_Encode4(2271273), // Rule ID 1813 //
     /* 2271236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2271239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2271242 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2271245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271249 */   // MIs[0] Operand 1
     /* 2271249 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2271258 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2271262 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2271262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2271265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271267 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271269 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271271 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271272 */   // GIR_Coverage, 1813,
     /* 2271272 */   GIR_EraseRootFromParent_Done,
     /* 2271273 */ // Label 30506: @2271273
     /* 2271273 */ GIM_Try, /*On fail goto*//*Label 30507*/ GIMT_Encode4(2271315), // Rule ID 1821 //
     /* 2271278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2271281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2271284 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2271287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271291 */   // MIs[0] Operand 1
     /* 2271291 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2271300 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2271304 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2271304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2271307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271309 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271311 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271313 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271314 */   // GIR_Coverage, 1821,
     /* 2271314 */   GIR_EraseRootFromParent_Done,
     /* 2271315 */ // Label 30507: @2271315
     /* 2271315 */ GIM_Try, /*On fail goto*//*Label 30508*/ GIMT_Encode4(2271357), // Rule ID 2068 //
     /* 2271320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2271323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2271326 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2271329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271333 */   // MIs[0] Operand 1
     /* 2271333 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2271342 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2271346 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2271346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2271349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271351 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271353 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271355 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271356 */   // GIR_Coverage, 2068,
     /* 2271356 */   GIR_EraseRootFromParent_Done,
     /* 2271357 */ // Label 30508: @2271357
     /* 2271357 */ GIM_Try, /*On fail goto*//*Label 30509*/ GIMT_Encode4(2271399), // Rule ID 2072 //
     /* 2271362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2271365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2271368 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2271371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271375 */   // MIs[0] Operand 1
     /* 2271375 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2271384 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2271388 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2271388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2271391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271393 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271395 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271397 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271398 */   // GIR_Coverage, 2072,
     /* 2271398 */   GIR_EraseRootFromParent_Done,
     /* 2271399 */ // Label 30509: @2271399
     /* 2271399 */ GIM_Try, /*On fail goto*//*Label 30510*/ GIMT_Encode4(2271441), // Rule ID 2116 //
     /* 2271404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2271407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2271410 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2271413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271417 */   // MIs[0] Operand 1
     /* 2271417 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2271426 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2271430 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2271430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2271433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271435 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271437 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271440 */   // GIR_Coverage, 2116,
     /* 2271440 */   GIR_EraseRootFromParent_Done,
     /* 2271441 */ // Label 30510: @2271441
     /* 2271441 */ GIM_Try, /*On fail goto*//*Label 30511*/ GIMT_Encode4(2271483), // Rule ID 2120 //
     /* 2271446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2271449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2271452 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2271455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271459 */   // MIs[0] Operand 1
     /* 2271459 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2271468 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2271472 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2271472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2271475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271477 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271479 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271481 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271482 */   // GIR_Coverage, 2120,
     /* 2271482 */   GIR_EraseRootFromParent_Done,
     /* 2271483 */ // Label 30511: @2271483
     /* 2271483 */ GIM_Try, /*On fail goto*//*Label 30512*/ GIMT_Encode4(2271525), // Rule ID 2132 //
     /* 2271488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2271491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2271494 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2271497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271501 */   // MIs[0] Operand 1
     /* 2271501 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2271510 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2271514 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2271514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2271517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271519 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271521 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271523 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271524 */   // GIR_Coverage, 2132,
     /* 2271524 */   GIR_EraseRootFromParent_Done,
     /* 2271525 */ // Label 30512: @2271525
     /* 2271525 */ GIM_Try, /*On fail goto*//*Label 30513*/ GIMT_Encode4(2271567), // Rule ID 2136 //
     /* 2271530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2271533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2271536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2271539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271543 */   // MIs[0] Operand 1
     /* 2271543 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2271552 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2271556 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2271556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2271559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271561 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271563 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271565 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271566 */   // GIR_Coverage, 2136,
     /* 2271566 */   GIR_EraseRootFromParent_Done,
     /* 2271567 */ // Label 30513: @2271567
     /* 2271567 */ GIM_Reject,
     /* 2271568 */ // Label 30468: @2271568
     /* 2271568 */ GIM_Try, /*On fail goto*//*Label 30514*/ GIMT_Encode4(2271616), // Rule ID 57022 //
     /* 2271573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2271579 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2271582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271586 */   // MIs[0] Operand 1
     /* 2271586 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271595 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271599 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2271602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271604 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271606 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271614 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271615 */   // GIR_Coverage, 57022,
     /* 2271615 */   GIR_EraseRootFromParent_Done,
     /* 2271616 */ // Label 30514: @2271616
     /* 2271616 */ GIM_Try, /*On fail goto*//*Label 30515*/ GIMT_Encode4(2271664), // Rule ID 57023 //
     /* 2271621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2271627 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2271630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271634 */   // MIs[0] Operand 1
     /* 2271634 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271643 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271647 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2271650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271652 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271654 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271662 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271663 */   // GIR_Coverage, 57023,
     /* 2271663 */   GIR_EraseRootFromParent_Done,
     /* 2271664 */ // Label 30515: @2271664
     /* 2271664 */ GIM_Try, /*On fail goto*//*Label 30516*/ GIMT_Encode4(2271712), // Rule ID 57042 //
     /* 2271669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2271675 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2271678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271682 */   // MIs[0] Operand 1
     /* 2271682 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271691 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271695 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2271698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271700 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271702 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271710 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271711 */   // GIR_Coverage, 57042,
     /* 2271711 */   GIR_EraseRootFromParent_Done,
     /* 2271712 */ // Label 30516: @2271712
     /* 2271712 */ GIM_Try, /*On fail goto*//*Label 30517*/ GIMT_Encode4(2271760), // Rule ID 57043 //
     /* 2271717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2271723 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2271726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271730 */   // MIs[0] Operand 1
     /* 2271730 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271739 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271743 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2271746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271748 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271750 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271758 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271759 */   // GIR_Coverage, 57043,
     /* 2271759 */   GIR_EraseRootFromParent_Done,
     /* 2271760 */ // Label 30517: @2271760
     /* 2271760 */ GIM_Try, /*On fail goto*//*Label 30518*/ GIMT_Encode4(2271808), // Rule ID 57072 //
     /* 2271765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2271771 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2271774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271778 */   // MIs[0] Operand 1
     /* 2271778 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271787 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271791 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2271794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271796 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271798 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271806 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271807 */   // GIR_Coverage, 57072,
     /* 2271807 */   GIR_EraseRootFromParent_Done,
     /* 2271808 */ // Label 30518: @2271808
     /* 2271808 */ GIM_Try, /*On fail goto*//*Label 30519*/ GIMT_Encode4(2271856), // Rule ID 57073 //
     /* 2271813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2271819 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2271822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271826 */   // MIs[0] Operand 1
     /* 2271826 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271835 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271839 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2271842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271844 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271846 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271854 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271855 */   // GIR_Coverage, 57073,
     /* 2271855 */   GIR_EraseRootFromParent_Done,
     /* 2271856 */ // Label 30519: @2271856
     /* 2271856 */ GIM_Try, /*On fail goto*//*Label 30520*/ GIMT_Encode4(2271904), // Rule ID 57322 //
     /* 2271861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2271867 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2271870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271874 */   // MIs[0] Operand 1
     /* 2271874 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271883 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271887 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2271890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271892 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271894 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271902 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271903 */   // GIR_Coverage, 57322,
     /* 2271903 */   GIR_EraseRootFromParent_Done,
     /* 2271904 */ // Label 30520: @2271904
     /* 2271904 */ GIM_Try, /*On fail goto*//*Label 30521*/ GIMT_Encode4(2271952), // Rule ID 57323 //
     /* 2271909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2271915 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2271918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271922 */   // MIs[0] Operand 1
     /* 2271922 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271931 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271935 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2271938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271940 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271942 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271950 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271951 */   // GIR_Coverage, 57323,
     /* 2271951 */   GIR_EraseRootFromParent_Done,
     /* 2271952 */ // Label 30521: @2271952
     /* 2271952 */ GIM_Try, /*On fail goto*//*Label 30522*/ GIMT_Encode4(2272000), // Rule ID 57342 //
     /* 2271957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2271963 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2271966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271970 */   // MIs[0] Operand 1
     /* 2271970 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271979 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271983 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2271986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271988 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271990 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271999 */   // GIR_Coverage, 57342,
     /* 2271999 */   GIR_EraseRootFromParent_Done,
     /* 2272000 */ // Label 30522: @2272000
     /* 2272000 */ GIM_Try, /*On fail goto*//*Label 30523*/ GIMT_Encode4(2272048), // Rule ID 57343 //
     /* 2272005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2272011 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2272014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272018 */   // MIs[0] Operand 1
     /* 2272018 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272027 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272031 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2272034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272036 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272038 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272046 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272047 */   // GIR_Coverage, 57343,
     /* 2272047 */   GIR_EraseRootFromParent_Done,
     /* 2272048 */ // Label 30523: @2272048
     /* 2272048 */ GIM_Try, /*On fail goto*//*Label 30524*/ GIMT_Encode4(2272096), // Rule ID 57372 //
     /* 2272053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2272059 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2272062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272066 */   // MIs[0] Operand 1
     /* 2272066 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272075 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272079 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2272082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272084 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272086 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272094 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272095 */   // GIR_Coverage, 57372,
     /* 2272095 */   GIR_EraseRootFromParent_Done,
     /* 2272096 */ // Label 30524: @2272096
     /* 2272096 */ GIM_Try, /*On fail goto*//*Label 30525*/ GIMT_Encode4(2272144), // Rule ID 57373 //
     /* 2272101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2272107 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2272110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272114 */   // MIs[0] Operand 1
     /* 2272114 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272123 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272127 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2272130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272132 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272134 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272142 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272143 */   // GIR_Coverage, 57373,
     /* 2272143 */   GIR_EraseRootFromParent_Done,
     /* 2272144 */ // Label 30525: @2272144
     /* 2272144 */ GIM_Try, /*On fail goto*//*Label 30526*/ GIMT_Encode4(2272192), // Rule ID 57622 //
     /* 2272149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2272155 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2272158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272162 */   // MIs[0] Operand 1
     /* 2272162 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272167 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272171 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272175 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2272178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272180 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272182 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272190 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272191 */   // GIR_Coverage, 57622,
     /* 2272191 */   GIR_EraseRootFromParent_Done,
     /* 2272192 */ // Label 30526: @2272192
     /* 2272192 */ GIM_Try, /*On fail goto*//*Label 30527*/ GIMT_Encode4(2272240), // Rule ID 57623 //
     /* 2272197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2272203 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2272206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272210 */   // MIs[0] Operand 1
     /* 2272210 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272219 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272223 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2272226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272228 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272230 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272238 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272239 */   // GIR_Coverage, 57623,
     /* 2272239 */   GIR_EraseRootFromParent_Done,
     /* 2272240 */ // Label 30527: @2272240
     /* 2272240 */ GIM_Try, /*On fail goto*//*Label 30528*/ GIMT_Encode4(2272288), // Rule ID 57642 //
     /* 2272245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2272251 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2272254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272258 */   // MIs[0] Operand 1
     /* 2272258 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272267 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272271 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2272274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272276 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272278 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272286 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272287 */   // GIR_Coverage, 57642,
     /* 2272287 */   GIR_EraseRootFromParent_Done,
     /* 2272288 */ // Label 30528: @2272288
     /* 2272288 */ GIM_Try, /*On fail goto*//*Label 30529*/ GIMT_Encode4(2272336), // Rule ID 57643 //
     /* 2272293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2272299 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2272302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272306 */   // MIs[0] Operand 1
     /* 2272306 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272315 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272319 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2272322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272324 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272326 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272334 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272335 */   // GIR_Coverage, 57643,
     /* 2272335 */   GIR_EraseRootFromParent_Done,
     /* 2272336 */ // Label 30529: @2272336
     /* 2272336 */ GIM_Try, /*On fail goto*//*Label 30530*/ GIMT_Encode4(2272384), // Rule ID 57672 //
     /* 2272341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2272347 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2272350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272354 */   // MIs[0] Operand 1
     /* 2272354 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272363 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272367 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2272370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272372 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272374 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272382 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272383 */   // GIR_Coverage, 57672,
     /* 2272383 */   GIR_EraseRootFromParent_Done,
     /* 2272384 */ // Label 30530: @2272384
     /* 2272384 */ GIM_Try, /*On fail goto*//*Label 30531*/ GIMT_Encode4(2272432), // Rule ID 57673 //
     /* 2272389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2272395 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2272398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272402 */   // MIs[0] Operand 1
     /* 2272402 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272411 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272415 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2272418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272420 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272422 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272430 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272431 */   // GIR_Coverage, 57673,
     /* 2272431 */   GIR_EraseRootFromParent_Done,
     /* 2272432 */ // Label 30531: @2272432
     /* 2272432 */ GIM_Try, /*On fail goto*//*Label 30532*/ GIMT_Encode4(2272480), // Rule ID 57922 //
     /* 2272437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2272443 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2272446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272450 */   // MIs[0] Operand 1
     /* 2272450 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272459 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272463 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2272466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272468 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272470 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272478 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272479 */   // GIR_Coverage, 57922,
     /* 2272479 */   GIR_EraseRootFromParent_Done,
     /* 2272480 */ // Label 30532: @2272480
     /* 2272480 */ GIM_Try, /*On fail goto*//*Label 30533*/ GIMT_Encode4(2272528), // Rule ID 57923 //
     /* 2272485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2272491 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2272494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272498 */   // MIs[0] Operand 1
     /* 2272498 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272507 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272511 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2272514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272516 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272518 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272526 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272527 */   // GIR_Coverage, 57923,
     /* 2272527 */   GIR_EraseRootFromParent_Done,
     /* 2272528 */ // Label 30533: @2272528
     /* 2272528 */ GIM_Try, /*On fail goto*//*Label 30534*/ GIMT_Encode4(2272576), // Rule ID 57942 //
     /* 2272533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2272539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2272542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272546 */   // MIs[0] Operand 1
     /* 2272546 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272551 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272555 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272559 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2272562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272564 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272566 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272574 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272575 */   // GIR_Coverage, 57942,
     /* 2272575 */   GIR_EraseRootFromParent_Done,
     /* 2272576 */ // Label 30534: @2272576
     /* 2272576 */ GIM_Try, /*On fail goto*//*Label 30535*/ GIMT_Encode4(2272624), // Rule ID 57943 //
     /* 2272581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2272587 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2272590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272594 */   // MIs[0] Operand 1
     /* 2272594 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272603 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272607 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2272610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272612 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272614 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272623 */   // GIR_Coverage, 57943,
     /* 2272623 */   GIR_EraseRootFromParent_Done,
     /* 2272624 */ // Label 30535: @2272624
     /* 2272624 */ GIM_Try, /*On fail goto*//*Label 30536*/ GIMT_Encode4(2272672), // Rule ID 57972 //
     /* 2272629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2272635 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2272638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272642 */   // MIs[0] Operand 1
     /* 2272642 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272651 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272655 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2272658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272660 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272662 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272670 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272671 */   // GIR_Coverage, 57972,
     /* 2272671 */   GIR_EraseRootFromParent_Done,
     /* 2272672 */ // Label 30536: @2272672
     /* 2272672 */ GIM_Try, /*On fail goto*//*Label 30537*/ GIMT_Encode4(2272720), // Rule ID 57973 //
     /* 2272677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2272683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2272686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272690 */   // MIs[0] Operand 1
     /* 2272690 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272699 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272703 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2272706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272708 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272710 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272719 */   // GIR_Coverage, 57973,
     /* 2272719 */   GIR_EraseRootFromParent_Done,
     /* 2272720 */ // Label 30537: @2272720
     /* 2272720 */ GIM_Reject,
     /* 2272721 */ // Label 30469: @2272721
     /* 2272721 */ GIM_Try, /*On fail goto*//*Label 30538*/ GIMT_Encode4(2272769), // Rule ID 57032 //
     /* 2272726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2272732 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2272735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272739 */   // MIs[0] Operand 1
     /* 2272739 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272748 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272752 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2272755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272757 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272759 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272767 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272768 */   // GIR_Coverage, 57032,
     /* 2272768 */   GIR_EraseRootFromParent_Done,
     /* 2272769 */ // Label 30538: @2272769
     /* 2272769 */ GIM_Try, /*On fail goto*//*Label 30539*/ GIMT_Encode4(2272817), // Rule ID 57033 //
     /* 2272774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2272780 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2272783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272787 */   // MIs[0] Operand 1
     /* 2272787 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272796 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272800 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2272803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272805 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272807 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272816 */   // GIR_Coverage, 57033,
     /* 2272816 */   GIR_EraseRootFromParent_Done,
     /* 2272817 */ // Label 30539: @2272817
     /* 2272817 */ GIM_Try, /*On fail goto*//*Label 30540*/ GIMT_Encode4(2272865), // Rule ID 57062 //
     /* 2272822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2272828 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2272831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272835 */   // MIs[0] Operand 1
     /* 2272835 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272844 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272848 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2272851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272853 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272855 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272863 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272864 */   // GIR_Coverage, 57062,
     /* 2272864 */   GIR_EraseRootFromParent_Done,
     /* 2272865 */ // Label 30540: @2272865
     /* 2272865 */ GIM_Try, /*On fail goto*//*Label 30541*/ GIMT_Encode4(2272913), // Rule ID 57063 //
     /* 2272870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2272876 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2272879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272883 */   // MIs[0] Operand 1
     /* 2272883 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272892 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272896 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2272899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272901 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272903 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272911 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272912 */   // GIR_Coverage, 57063,
     /* 2272912 */   GIR_EraseRootFromParent_Done,
     /* 2272913 */ // Label 30541: @2272913
     /* 2272913 */ GIM_Try, /*On fail goto*//*Label 30542*/ GIMT_Encode4(2272961), // Rule ID 57142 //
     /* 2272918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2272924 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2272927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272931 */   // MIs[0] Operand 1
     /* 2272931 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272940 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272944 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2272947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272949 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272951 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272959 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272960 */   // GIR_Coverage, 57142,
     /* 2272960 */   GIR_EraseRootFromParent_Done,
     /* 2272961 */ // Label 30542: @2272961
     /* 2272961 */ GIM_Try, /*On fail goto*//*Label 30543*/ GIMT_Encode4(2273009), // Rule ID 57143 //
     /* 2272966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2272972 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2272975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272979 */   // MIs[0] Operand 1
     /* 2272979 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272988 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272992 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2272995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272997 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272999 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273008 */   // GIR_Coverage, 57143,
     /* 2273008 */   GIR_EraseRootFromParent_Done,
     /* 2273009 */ // Label 30543: @2273009
     /* 2273009 */ GIM_Try, /*On fail goto*//*Label 30544*/ GIMT_Encode4(2273057), // Rule ID 57332 //
     /* 2273014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2273020 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2273023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273027 */   // MIs[0] Operand 1
     /* 2273027 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273036 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273040 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2273043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273045 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273047 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273055 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273056 */   // GIR_Coverage, 57332,
     /* 2273056 */   GIR_EraseRootFromParent_Done,
     /* 2273057 */ // Label 30544: @2273057
     /* 2273057 */ GIM_Try, /*On fail goto*//*Label 30545*/ GIMT_Encode4(2273105), // Rule ID 57333 //
     /* 2273062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2273068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2273071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273075 */   // MIs[0] Operand 1
     /* 2273075 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273084 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273088 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2273091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273093 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273095 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273104 */   // GIR_Coverage, 57333,
     /* 2273104 */   GIR_EraseRootFromParent_Done,
     /* 2273105 */ // Label 30545: @2273105
     /* 2273105 */ GIM_Try, /*On fail goto*//*Label 30546*/ GIMT_Encode4(2273153), // Rule ID 57362 //
     /* 2273110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2273116 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2273119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273123 */   // MIs[0] Operand 1
     /* 2273123 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273132 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273136 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2273139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273141 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273143 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273151 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273152 */   // GIR_Coverage, 57362,
     /* 2273152 */   GIR_EraseRootFromParent_Done,
     /* 2273153 */ // Label 30546: @2273153
     /* 2273153 */ GIM_Try, /*On fail goto*//*Label 30547*/ GIMT_Encode4(2273201), // Rule ID 57363 //
     /* 2273158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2273164 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2273167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273171 */   // MIs[0] Operand 1
     /* 2273171 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273180 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273184 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2273187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273189 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273191 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273199 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273200 */   // GIR_Coverage, 57363,
     /* 2273200 */   GIR_EraseRootFromParent_Done,
     /* 2273201 */ // Label 30547: @2273201
     /* 2273201 */ GIM_Try, /*On fail goto*//*Label 30548*/ GIMT_Encode4(2273249), // Rule ID 57442 //
     /* 2273206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2273209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2273212 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2273215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273219 */   // MIs[0] Operand 1
     /* 2273219 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273228 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273232 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2273232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2273235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273237 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273239 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273247 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273248 */   // GIR_Coverage, 57442,
     /* 2273248 */   GIR_EraseRootFromParent_Done,
     /* 2273249 */ // Label 30548: @2273249
     /* 2273249 */ GIM_Try, /*On fail goto*//*Label 30549*/ GIMT_Encode4(2273297), // Rule ID 57443 //
     /* 2273254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2273257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2273260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2273263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273267 */   // MIs[0] Operand 1
     /* 2273267 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273276 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273280 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2273280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2273283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273285 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273287 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273295 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273296 */   // GIR_Coverage, 57443,
     /* 2273296 */   GIR_EraseRootFromParent_Done,
     /* 2273297 */ // Label 30549: @2273297
     /* 2273297 */ GIM_Try, /*On fail goto*//*Label 30550*/ GIMT_Encode4(2273345), // Rule ID 57632 //
     /* 2273302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2273308 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2273311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273315 */   // MIs[0] Operand 1
     /* 2273315 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273324 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273328 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2273331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273333 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273335 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273344 */   // GIR_Coverage, 57632,
     /* 2273344 */   GIR_EraseRootFromParent_Done,
     /* 2273345 */ // Label 30550: @2273345
     /* 2273345 */ GIM_Try, /*On fail goto*//*Label 30551*/ GIMT_Encode4(2273393), // Rule ID 57633 //
     /* 2273350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2273356 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2273359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273363 */   // MIs[0] Operand 1
     /* 2273363 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273372 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273376 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2273379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273381 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273383 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273392 */   // GIR_Coverage, 57633,
     /* 2273392 */   GIR_EraseRootFromParent_Done,
     /* 2273393 */ // Label 30551: @2273393
     /* 2273393 */ GIM_Try, /*On fail goto*//*Label 30552*/ GIMT_Encode4(2273441), // Rule ID 57662 //
     /* 2273398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2273404 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2273407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273411 */   // MIs[0] Operand 1
     /* 2273411 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273420 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273424 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2273427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273429 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273431 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273440 */   // GIR_Coverage, 57662,
     /* 2273440 */   GIR_EraseRootFromParent_Done,
     /* 2273441 */ // Label 30552: @2273441
     /* 2273441 */ GIM_Try, /*On fail goto*//*Label 30553*/ GIMT_Encode4(2273489), // Rule ID 57663 //
     /* 2273446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2273452 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2273455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273459 */   // MIs[0] Operand 1
     /* 2273459 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273468 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273472 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2273475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273477 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273479 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273487 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273488 */   // GIR_Coverage, 57663,
     /* 2273488 */   GIR_EraseRootFromParent_Done,
     /* 2273489 */ // Label 30553: @2273489
     /* 2273489 */ GIM_Try, /*On fail goto*//*Label 30554*/ GIMT_Encode4(2273537), // Rule ID 57742 //
     /* 2273494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2273497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2273500 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2273503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273507 */   // MIs[0] Operand 1
     /* 2273507 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273516 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273520 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2273520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2273523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273525 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273527 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273535 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273536 */   // GIR_Coverage, 57742,
     /* 2273536 */   GIR_EraseRootFromParent_Done,
     /* 2273537 */ // Label 30554: @2273537
     /* 2273537 */ GIM_Try, /*On fail goto*//*Label 30555*/ GIMT_Encode4(2273585), // Rule ID 57743 //
     /* 2273542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2273545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2273548 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2273551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273555 */   // MIs[0] Operand 1
     /* 2273555 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273564 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273568 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2273568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2273571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273573 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273575 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273583 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273584 */   // GIR_Coverage, 57743,
     /* 2273584 */   GIR_EraseRootFromParent_Done,
     /* 2273585 */ // Label 30555: @2273585
     /* 2273585 */ GIM_Try, /*On fail goto*//*Label 30556*/ GIMT_Encode4(2273633), // Rule ID 57932 //
     /* 2273590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2273596 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2273599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273603 */   // MIs[0] Operand 1
     /* 2273603 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273612 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273616 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2273619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273621 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273623 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273632 */   // GIR_Coverage, 57932,
     /* 2273632 */   GIR_EraseRootFromParent_Done,
     /* 2273633 */ // Label 30556: @2273633
     /* 2273633 */ GIM_Try, /*On fail goto*//*Label 30557*/ GIMT_Encode4(2273681), // Rule ID 57933 //
     /* 2273638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2273644 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2273647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273651 */   // MIs[0] Operand 1
     /* 2273651 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273660 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273664 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2273667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273669 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273671 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273679 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273680 */   // GIR_Coverage, 57933,
     /* 2273680 */   GIR_EraseRootFromParent_Done,
     /* 2273681 */ // Label 30557: @2273681
     /* 2273681 */ GIM_Try, /*On fail goto*//*Label 30558*/ GIMT_Encode4(2273729), // Rule ID 57962 //
     /* 2273686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2273692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2273695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273699 */   // MIs[0] Operand 1
     /* 2273699 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273708 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273712 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2273715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273717 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273719 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273727 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273728 */   // GIR_Coverage, 57962,
     /* 2273728 */   GIR_EraseRootFromParent_Done,
     /* 2273729 */ // Label 30558: @2273729
     /* 2273729 */ GIM_Try, /*On fail goto*//*Label 30559*/ GIMT_Encode4(2273777), // Rule ID 57963 //
     /* 2273734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2273740 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2273743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273747 */   // MIs[0] Operand 1
     /* 2273747 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273756 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273760 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2273763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273765 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273767 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273775 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273776 */   // GIR_Coverage, 57963,
     /* 2273776 */   GIR_EraseRootFromParent_Done,
     /* 2273777 */ // Label 30559: @2273777
     /* 2273777 */ GIM_Try, /*On fail goto*//*Label 30560*/ GIMT_Encode4(2273825), // Rule ID 58042 //
     /* 2273782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2273785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2273788 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2273791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273795 */   // MIs[0] Operand 1
     /* 2273795 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273804 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273808 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2273808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2273811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273813 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273815 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273823 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273824 */   // GIR_Coverage, 58042,
     /* 2273824 */   GIR_EraseRootFromParent_Done,
     /* 2273825 */ // Label 30560: @2273825
     /* 2273825 */ GIM_Try, /*On fail goto*//*Label 30561*/ GIMT_Encode4(2273873), // Rule ID 58043 //
     /* 2273830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2273833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2273836 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2273839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273843 */   // MIs[0] Operand 1
     /* 2273843 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273852 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273856 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2273856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2273859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273861 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273863 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273871 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273872 */   // GIR_Coverage, 58043,
     /* 2273872 */   GIR_EraseRootFromParent_Done,
     /* 2273873 */ // Label 30561: @2273873
     /* 2273873 */ GIM_Reject,
     /* 2273874 */ // Label 30470: @2273874
     /* 2273874 */ GIM_Try, /*On fail goto*//*Label 30562*/ GIMT_Encode4(2273922), // Rule ID 57052 //
     /* 2273879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2273885 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2273888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273892 */   // MIs[0] Operand 1
     /* 2273892 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273901 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273905 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2273908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273910 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273912 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273920 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273921 */   // GIR_Coverage, 57052,
     /* 2273921 */   GIR_EraseRootFromParent_Done,
     /* 2273922 */ // Label 30562: @2273922
     /* 2273922 */ GIM_Try, /*On fail goto*//*Label 30563*/ GIMT_Encode4(2273970), // Rule ID 57053 //
     /* 2273927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2273933 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2273936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273940 */   // MIs[0] Operand 1
     /* 2273940 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273949 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273953 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2273956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273958 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273960 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273968 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273969 */   // GIR_Coverage, 57053,
     /* 2273969 */   GIR_EraseRootFromParent_Done,
     /* 2273970 */ // Label 30563: @2273970
     /* 2273970 */ GIM_Try, /*On fail goto*//*Label 30564*/ GIMT_Encode4(2274018), // Rule ID 57112 //
     /* 2273975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2273981 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2273984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273988 */   // MIs[0] Operand 1
     /* 2273988 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273997 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274001 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2274001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2274004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274006 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274008 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274016 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274017 */   // GIR_Coverage, 57112,
     /* 2274017 */   GIR_EraseRootFromParent_Done,
     /* 2274018 */ // Label 30564: @2274018
     /* 2274018 */ GIM_Try, /*On fail goto*//*Label 30565*/ GIMT_Encode4(2274066), // Rule ID 57113 //
     /* 2274023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2274026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2274029 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2274032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274036 */   // MIs[0] Operand 1
     /* 2274036 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2274041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274045 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274049 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2274049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2274052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274054 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274056 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274064 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274065 */   // GIR_Coverage, 57113,
     /* 2274065 */   GIR_EraseRootFromParent_Done,
     /* 2274066 */ // Label 30565: @2274066
     /* 2274066 */ GIM_Try, /*On fail goto*//*Label 30566*/ GIMT_Encode4(2274114), // Rule ID 57152 //
     /* 2274071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2274074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2274077 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2274080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274084 */   // MIs[0] Operand 1
     /* 2274084 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2274089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274093 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274097 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2274097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2274100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274102 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274104 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274112 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274113 */   // GIR_Coverage, 57152,
     /* 2274113 */   GIR_EraseRootFromParent_Done,
     /* 2274114 */ // Label 30566: @2274114
     /* 2274114 */ GIM_Try, /*On fail goto*//*Label 30567*/ GIMT_Encode4(2274162), // Rule ID 57153 //
     /* 2274119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2274122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2274125 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2274128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274132 */   // MIs[0] Operand 1
     /* 2274132 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2274137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274141 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274145 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2274145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2274148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274150 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274152 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274160 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274161 */   // GIR_Coverage, 57153,
     /* 2274161 */   GIR_EraseRootFromParent_Done,
     /* 2274162 */ // Label 30567: @2274162
     /* 2274162 */ GIM_Try, /*On fail goto*//*Label 30568*/ GIMT_Encode4(2274210), // Rule ID 57352 //
     /* 2274167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2274170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2274173 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2274176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274180 */   // MIs[0] Operand 1
     /* 2274180 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2274185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274189 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274193 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2274193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2274196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274198 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274200 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274208 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274209 */   // GIR_Coverage, 57352,
     /* 2274209 */   GIR_EraseRootFromParent_Done,
     /* 2274210 */ // Label 30568: @2274210
     /* 2274210 */ GIM_Try, /*On fail goto*//*Label 30569*/ GIMT_Encode4(2274258), // Rule ID 57353 //
     /* 2274215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2274221 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2274224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274228 */   // MIs[0] Operand 1
     /* 2274228 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2274233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274237 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274241 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2274241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2274244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274246 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274248 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274256 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274257 */   // GIR_Coverage, 57353,
     /* 2274257 */   GIR_EraseRootFromParent_Done,
     /* 2274258 */ // Label 30569: @2274258
     /* 2274258 */ GIM_Try, /*On fail goto*//*Label 30570*/ GIMT_Encode4(2274306), // Rule ID 57412 //
     /* 2274263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2274266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2274269 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2274272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274276 */   // MIs[0] Operand 1
     /* 2274276 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2274281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274285 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274289 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2274289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2274292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274294 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274296 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274304 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274305 */   // GIR_Coverage, 57412,
     /* 2274305 */   GIR_EraseRootFromParent_Done,
     /* 2274306 */ // Label 30570: @2274306
     /* 2274306 */ GIM_Try, /*On fail goto*//*Label 30571*/ GIMT_Encode4(2274354), // Rule ID 57413 //
     /* 2274311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2274314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2274317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2274320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274324 */   // MIs[0] Operand 1
     /* 2274324 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2274329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274333 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274337 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2274337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2274340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274342 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274344 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274352 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274353 */   // GIR_Coverage, 57413,
     /* 2274353 */   GIR_EraseRootFromParent_Done,
     /* 2274354 */ // Label 30571: @2274354
     /* 2274354 */ GIM_Try, /*On fail goto*//*Label 30572*/ GIMT_Encode4(2274402), // Rule ID 57452 //
     /* 2274359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2274362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2274365 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2274368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274372 */   // MIs[0] Operand 1
     /* 2274372 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2274377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274381 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274385 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2274385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2274388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274390 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274392 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274400 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274401 */   // GIR_Coverage, 57452,
     /* 2274401 */   GIR_EraseRootFromParent_Done,
     /* 2274402 */ // Label 30572: @2274402
     /* 2274402 */ GIM_Try, /*On fail goto*//*Label 30573*/ GIMT_Encode4(2274450), // Rule ID 57453 //
     /* 2274407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2274410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2274413 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2274416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274420 */   // MIs[0] Operand 1
     /* 2274420 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2274425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274429 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274433 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2274433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2274436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274438 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274440 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274448 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274449 */   // GIR_Coverage, 57453,
     /* 2274449 */   GIR_EraseRootFromParent_Done,
     /* 2274450 */ // Label 30573: @2274450
     /* 2274450 */ GIM_Try, /*On fail goto*//*Label 30574*/ GIMT_Encode4(2274498), // Rule ID 57652 //
     /* 2274455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2274458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2274461 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2274464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274468 */   // MIs[0] Operand 1
     /* 2274468 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2274473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274477 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274481 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2274481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2274484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274486 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274488 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274496 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274497 */   // GIR_Coverage, 57652,
     /* 2274497 */   GIR_EraseRootFromParent_Done,
     /* 2274498 */ // Label 30574: @2274498
     /* 2274498 */ GIM_Try, /*On fail goto*//*Label 30575*/ GIMT_Encode4(2274546), // Rule ID 57653 //
     /* 2274503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2274509 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2274512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274516 */   // MIs[0] Operand 1
     /* 2274516 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2274521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274525 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274529 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2274529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2274532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274534 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274536 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274545 */   // GIR_Coverage, 57653,
     /* 2274545 */   GIR_EraseRootFromParent_Done,
     /* 2274546 */ // Label 30575: @2274546
     /* 2274546 */ GIM_Try, /*On fail goto*//*Label 30576*/ GIMT_Encode4(2274594), // Rule ID 57712 //
     /* 2274551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2274554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2274557 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2274560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274564 */   // MIs[0] Operand 1
     /* 2274564 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2274569 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274573 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274577 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2274577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2274580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274582 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274584 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274592 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274593 */   // GIR_Coverage, 57712,
     /* 2274593 */   GIR_EraseRootFromParent_Done,
     /* 2274594 */ // Label 30576: @2274594
     /* 2274594 */ GIM_Try, /*On fail goto*//*Label 30577*/ GIMT_Encode4(2274642), // Rule ID 57713 //
     /* 2274599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2274602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2274605 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2274608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274612 */   // MIs[0] Operand 1
     /* 2274612 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2274617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274621 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274625 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2274625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2274628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274630 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274632 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274640 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274641 */   // GIR_Coverage, 57713,
     /* 2274641 */   GIR_EraseRootFromParent_Done,
     /* 2274642 */ // Label 30577: @2274642
     /* 2274642 */ GIM_Try, /*On fail goto*//*Label 30578*/ GIMT_Encode4(2274690), // Rule ID 57752 //
     /* 2274647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2274650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2274653 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2274656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274660 */   // MIs[0] Operand 1
     /* 2274660 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2274665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274669 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274673 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2274673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2274676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274678 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274680 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274688 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274689 */   // GIR_Coverage, 57752,
     /* 2274689 */   GIR_EraseRootFromParent_Done,
     /* 2274690 */ // Label 30578: @2274690
     /* 2274690 */ GIM_Try, /*On fail goto*//*Label 30579*/ GIMT_Encode4(2274738), // Rule ID 57753 //
     /* 2274695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2274698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2274701 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2274704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274708 */   // MIs[0] Operand 1
     /* 2274708 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2274713 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274717 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274721 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2274721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2274724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274726 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274728 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274736 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274737 */   // GIR_Coverage, 57753,
     /* 2274737 */   GIR_EraseRootFromParent_Done,
     /* 2274738 */ // Label 30579: @2274738
     /* 2274738 */ GIM_Try, /*On fail goto*//*Label 30580*/ GIMT_Encode4(2274786), // Rule ID 57952 //
     /* 2274743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2274746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2274749 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2274752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274756 */   // MIs[0] Operand 1
     /* 2274756 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2274761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274765 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274769 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2274769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2274772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274774 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274776 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274784 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274785 */   // GIR_Coverage, 57952,
     /* 2274785 */   GIR_EraseRootFromParent_Done,
     /* 2274786 */ // Label 30580: @2274786
     /* 2274786 */ GIM_Try, /*On fail goto*//*Label 30581*/ GIMT_Encode4(2274834), // Rule ID 57953 //
     /* 2274791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2274797 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2274800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274804 */   // MIs[0] Operand 1
     /* 2274804 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2274809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274813 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274817 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2274817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2274820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274822 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274824 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274833 */   // GIR_Coverage, 57953,
     /* 2274833 */   GIR_EraseRootFromParent_Done,
     /* 2274834 */ // Label 30581: @2274834
     /* 2274834 */ GIM_Try, /*On fail goto*//*Label 30582*/ GIMT_Encode4(2274882), // Rule ID 58012 //
     /* 2274839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2274842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2274845 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2274848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274852 */   // MIs[0] Operand 1
     /* 2274852 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2274857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274861 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274865 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2274865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2274868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274870 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274872 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274880 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274881 */   // GIR_Coverage, 58012,
     /* 2274881 */   GIR_EraseRootFromParent_Done,
     /* 2274882 */ // Label 30582: @2274882
     /* 2274882 */ GIM_Try, /*On fail goto*//*Label 30583*/ GIMT_Encode4(2274930), // Rule ID 58013 //
     /* 2274887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2274890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2274893 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2274896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274900 */   // MIs[0] Operand 1
     /* 2274900 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2274905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274909 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274913 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2274913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2274916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274918 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274920 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274928 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274929 */   // GIR_Coverage, 58013,
     /* 2274929 */   GIR_EraseRootFromParent_Done,
     /* 2274930 */ // Label 30583: @2274930
     /* 2274930 */ GIM_Try, /*On fail goto*//*Label 30584*/ GIMT_Encode4(2274978), // Rule ID 58052 //
     /* 2274935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2274938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2274941 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2274944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274948 */   // MIs[0] Operand 1
     /* 2274948 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2274953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274957 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274961 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2274961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2274964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274966 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274968 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274976 */   GIR_RootConstrainSelectedInstOperands,
     /* 2274977 */   // GIR_Coverage, 58052,
     /* 2274977 */   GIR_EraseRootFromParent_Done,
     /* 2274978 */ // Label 30584: @2274978
     /* 2274978 */ GIM_Try, /*On fail goto*//*Label 30585*/ GIMT_Encode4(2275026), // Rule ID 58053 //
     /* 2274983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2274986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2274989 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2274992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274996 */   // MIs[0] Operand 1
     /* 2274996 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2275001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275005 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275009 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2275009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2275012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275014 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275016 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275024 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275025 */   // GIR_Coverage, 58053,
     /* 2275025 */   GIR_EraseRootFromParent_Done,
     /* 2275026 */ // Label 30585: @2275026
     /* 2275026 */ GIM_Reject,
     /* 2275027 */ // Label 30471: @2275027
     /* 2275027 */ GIM_Try, /*On fail goto*//*Label 30586*/ GIMT_Encode4(2275075), // Rule ID 57082 //
     /* 2275032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2275035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2275038 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2275041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275045 */   // MIs[0] Operand 1
     /* 2275045 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2275050 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275054 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275058 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2275058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2275061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275063 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275065 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275073 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275074 */   // GIR_Coverage, 57082,
     /* 2275074 */   GIR_EraseRootFromParent_Done,
     /* 2275075 */ // Label 30586: @2275075
     /* 2275075 */ GIM_Try, /*On fail goto*//*Label 30587*/ GIMT_Encode4(2275123), // Rule ID 57083 //
     /* 2275080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2275083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2275086 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2275089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275093 */   // MIs[0] Operand 1
     /* 2275093 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2275098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275102 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275106 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2275106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2275109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275111 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275113 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275121 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275122 */   // GIR_Coverage, 57083,
     /* 2275122 */   GIR_EraseRootFromParent_Done,
     /* 2275123 */ // Label 30587: @2275123
     /* 2275123 */ GIM_Try, /*On fail goto*//*Label 30588*/ GIMT_Encode4(2275171), // Rule ID 57122 //
     /* 2275128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2275131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2275134 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2275137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275141 */   // MIs[0] Operand 1
     /* 2275141 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2275146 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275150 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275154 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2275154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2275157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275159 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275161 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275170 */   // GIR_Coverage, 57122,
     /* 2275170 */   GIR_EraseRootFromParent_Done,
     /* 2275171 */ // Label 30588: @2275171
     /* 2275171 */ GIM_Try, /*On fail goto*//*Label 30589*/ GIMT_Encode4(2275219), // Rule ID 57123 //
     /* 2275176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2275179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2275182 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2275185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275189 */   // MIs[0] Operand 1
     /* 2275189 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2275194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275198 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275202 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2275202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2275205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275207 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275209 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275217 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275218 */   // GIR_Coverage, 57123,
     /* 2275218 */   GIR_EraseRootFromParent_Done,
     /* 2275219 */ // Label 30589: @2275219
     /* 2275219 */ GIM_Try, /*On fail goto*//*Label 30590*/ GIMT_Encode4(2275267), // Rule ID 57162 //
     /* 2275224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2275227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2275230 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2275233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275237 */   // MIs[0] Operand 1
     /* 2275237 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2275242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275246 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275250 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2275250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2275253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275255 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275257 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275265 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275266 */   // GIR_Coverage, 57162,
     /* 2275266 */   GIR_EraseRootFromParent_Done,
     /* 2275267 */ // Label 30590: @2275267
     /* 2275267 */ GIM_Try, /*On fail goto*//*Label 30591*/ GIMT_Encode4(2275315), // Rule ID 57163 //
     /* 2275272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2275275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2275278 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2275281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275285 */   // MIs[0] Operand 1
     /* 2275285 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2275290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275294 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275298 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2275298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2275301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275303 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275305 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275313 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275314 */   // GIR_Coverage, 57163,
     /* 2275314 */   GIR_EraseRootFromParent_Done,
     /* 2275315 */ // Label 30591: @2275315
     /* 2275315 */ GIM_Try, /*On fail goto*//*Label 30592*/ GIMT_Encode4(2275363), // Rule ID 57382 //
     /* 2275320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2275323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2275326 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2275329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275333 */   // MIs[0] Operand 1
     /* 2275333 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2275338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275342 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275346 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2275346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2275349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275351 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275353 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275361 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275362 */   // GIR_Coverage, 57382,
     /* 2275362 */   GIR_EraseRootFromParent_Done,
     /* 2275363 */ // Label 30592: @2275363
     /* 2275363 */ GIM_Try, /*On fail goto*//*Label 30593*/ GIMT_Encode4(2275411), // Rule ID 57383 //
     /* 2275368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2275371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2275374 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2275377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275381 */   // MIs[0] Operand 1
     /* 2275381 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2275386 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275390 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275394 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2275394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2275397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275399 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275401 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275409 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275410 */   // GIR_Coverage, 57383,
     /* 2275410 */   GIR_EraseRootFromParent_Done,
     /* 2275411 */ // Label 30593: @2275411
     /* 2275411 */ GIM_Try, /*On fail goto*//*Label 30594*/ GIMT_Encode4(2275459), // Rule ID 57422 //
     /* 2275416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2275419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2275422 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2275425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275429 */   // MIs[0] Operand 1
     /* 2275429 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2275434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275438 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275442 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2275442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2275445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275447 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275449 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275457 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275458 */   // GIR_Coverage, 57422,
     /* 2275458 */   GIR_EraseRootFromParent_Done,
     /* 2275459 */ // Label 30594: @2275459
     /* 2275459 */ GIM_Try, /*On fail goto*//*Label 30595*/ GIMT_Encode4(2275507), // Rule ID 57423 //
     /* 2275464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2275467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2275470 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2275473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275477 */   // MIs[0] Operand 1
     /* 2275477 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2275482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275486 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275490 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2275490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2275493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275495 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275497 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275505 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275506 */   // GIR_Coverage, 57423,
     /* 2275506 */   GIR_EraseRootFromParent_Done,
     /* 2275507 */ // Label 30595: @2275507
     /* 2275507 */ GIM_Try, /*On fail goto*//*Label 30596*/ GIMT_Encode4(2275555), // Rule ID 57462 //
     /* 2275512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2275515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2275518 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2275521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275525 */   // MIs[0] Operand 1
     /* 2275525 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2275530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275534 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275538 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2275538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2275541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275543 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275545 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275553 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275554 */   // GIR_Coverage, 57462,
     /* 2275554 */   GIR_EraseRootFromParent_Done,
     /* 2275555 */ // Label 30596: @2275555
     /* 2275555 */ GIM_Try, /*On fail goto*//*Label 30597*/ GIMT_Encode4(2275603), // Rule ID 57463 //
     /* 2275560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2275563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2275566 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2275569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275573 */   // MIs[0] Operand 1
     /* 2275573 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2275578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275582 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275586 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2275586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2275589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275591 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275593 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275601 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275602 */   // GIR_Coverage, 57463,
     /* 2275602 */   GIR_EraseRootFromParent_Done,
     /* 2275603 */ // Label 30597: @2275603
     /* 2275603 */ GIM_Try, /*On fail goto*//*Label 30598*/ GIMT_Encode4(2275651), // Rule ID 57682 //
     /* 2275608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2275611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2275614 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2275617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275621 */   // MIs[0] Operand 1
     /* 2275621 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2275626 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275630 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275634 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2275634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2275637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275639 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275641 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275649 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275650 */   // GIR_Coverage, 57682,
     /* 2275650 */   GIR_EraseRootFromParent_Done,
     /* 2275651 */ // Label 30598: @2275651
     /* 2275651 */ GIM_Try, /*On fail goto*//*Label 30599*/ GIMT_Encode4(2275699), // Rule ID 57683 //
     /* 2275656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2275659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2275662 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2275665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275669 */   // MIs[0] Operand 1
     /* 2275669 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2275674 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275678 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275682 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2275682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2275685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275687 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275689 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275697 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275698 */   // GIR_Coverage, 57683,
     /* 2275698 */   GIR_EraseRootFromParent_Done,
     /* 2275699 */ // Label 30599: @2275699
     /* 2275699 */ GIM_Try, /*On fail goto*//*Label 30600*/ GIMT_Encode4(2275747), // Rule ID 57722 //
     /* 2275704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2275707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2275710 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2275713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275717 */   // MIs[0] Operand 1
     /* 2275717 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2275722 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275726 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275730 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2275730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2275733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275735 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275737 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275745 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275746 */   // GIR_Coverage, 57722,
     /* 2275746 */   GIR_EraseRootFromParent_Done,
     /* 2275747 */ // Label 30600: @2275747
     /* 2275747 */ GIM_Try, /*On fail goto*//*Label 30601*/ GIMT_Encode4(2275795), // Rule ID 57723 //
     /* 2275752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2275755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2275758 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2275761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275765 */   // MIs[0] Operand 1
     /* 2275765 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2275770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275774 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275778 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2275778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2275781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275783 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275785 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275793 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275794 */   // GIR_Coverage, 57723,
     /* 2275794 */   GIR_EraseRootFromParent_Done,
     /* 2275795 */ // Label 30601: @2275795
     /* 2275795 */ GIM_Try, /*On fail goto*//*Label 30602*/ GIMT_Encode4(2275843), // Rule ID 57762 //
     /* 2275800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2275803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2275806 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2275809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275813 */   // MIs[0] Operand 1
     /* 2275813 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2275818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275822 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275826 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2275826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2275829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275831 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275833 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275841 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275842 */   // GIR_Coverage, 57762,
     /* 2275842 */   GIR_EraseRootFromParent_Done,
     /* 2275843 */ // Label 30602: @2275843
     /* 2275843 */ GIM_Try, /*On fail goto*//*Label 30603*/ GIMT_Encode4(2275891), // Rule ID 57763 //
     /* 2275848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2275851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2275854 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2275857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275861 */   // MIs[0] Operand 1
     /* 2275861 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2275866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275870 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275874 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2275874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2275877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275879 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275881 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275889 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275890 */   // GIR_Coverage, 57763,
     /* 2275890 */   GIR_EraseRootFromParent_Done,
     /* 2275891 */ // Label 30603: @2275891
     /* 2275891 */ GIM_Try, /*On fail goto*//*Label 30604*/ GIMT_Encode4(2275939), // Rule ID 57982 //
     /* 2275896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2275899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2275902 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2275905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275909 */   // MIs[0] Operand 1
     /* 2275909 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2275914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275918 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275922 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2275922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2275925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275927 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275929 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275937 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275938 */   // GIR_Coverage, 57982,
     /* 2275938 */   GIR_EraseRootFromParent_Done,
     /* 2275939 */ // Label 30604: @2275939
     /* 2275939 */ GIM_Try, /*On fail goto*//*Label 30605*/ GIMT_Encode4(2275987), // Rule ID 57983 //
     /* 2275944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2275947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2275950 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2275953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275957 */   // MIs[0] Operand 1
     /* 2275957 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2275962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275966 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275970 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2275970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2275973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275975 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275977 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2275986 */   // GIR_Coverage, 57983,
     /* 2275986 */   GIR_EraseRootFromParent_Done,
     /* 2275987 */ // Label 30605: @2275987
     /* 2275987 */ GIM_Try, /*On fail goto*//*Label 30606*/ GIMT_Encode4(2276035), // Rule ID 58022 //
     /* 2275992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2275995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2275998 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2276001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276005 */   // MIs[0] Operand 1
     /* 2276005 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2276010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276014 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276018 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2276018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2276021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276023 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276025 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276033 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276034 */   // GIR_Coverage, 58022,
     /* 2276034 */   GIR_EraseRootFromParent_Done,
     /* 2276035 */ // Label 30606: @2276035
     /* 2276035 */ GIM_Try, /*On fail goto*//*Label 30607*/ GIMT_Encode4(2276083), // Rule ID 58023 //
     /* 2276040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2276043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2276046 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2276049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276053 */   // MIs[0] Operand 1
     /* 2276053 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2276058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276062 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276066 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2276066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2276069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276071 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276073 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276081 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276082 */   // GIR_Coverage, 58023,
     /* 2276082 */   GIR_EraseRootFromParent_Done,
     /* 2276083 */ // Label 30607: @2276083
     /* 2276083 */ GIM_Try, /*On fail goto*//*Label 30608*/ GIMT_Encode4(2276131), // Rule ID 58062 //
     /* 2276088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2276091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2276094 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2276097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276101 */   // MIs[0] Operand 1
     /* 2276101 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2276106 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276110 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276114 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2276114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2276117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276119 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276121 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276129 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276130 */   // GIR_Coverage, 58062,
     /* 2276130 */   GIR_EraseRootFromParent_Done,
     /* 2276131 */ // Label 30608: @2276131
     /* 2276131 */ GIM_Try, /*On fail goto*//*Label 30609*/ GIMT_Encode4(2276179), // Rule ID 58063 //
     /* 2276136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2276139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2276142 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2276145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276149 */   // MIs[0] Operand 1
     /* 2276149 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2276154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276158 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276162 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2276162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2276165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276167 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276169 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276177 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276178 */   // GIR_Coverage, 58063,
     /* 2276178 */   GIR_EraseRootFromParent_Done,
     /* 2276179 */ // Label 30609: @2276179
     /* 2276179 */ GIM_Reject,
     /* 2276180 */ // Label 30472: @2276180
     /* 2276180 */ GIM_Try, /*On fail goto*//*Label 30610*/ GIMT_Encode4(2276228), // Rule ID 57092 //
     /* 2276185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2276188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2276191 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2276194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276198 */   // MIs[0] Operand 1
     /* 2276198 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2276203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276207 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276211 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2276211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2276214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276216 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276218 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276227 */   // GIR_Coverage, 57092,
     /* 2276227 */   GIR_EraseRootFromParent_Done,
     /* 2276228 */ // Label 30610: @2276228
     /* 2276228 */ GIM_Try, /*On fail goto*//*Label 30611*/ GIMT_Encode4(2276276), // Rule ID 57093 //
     /* 2276233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2276236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2276239 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2276242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276246 */   // MIs[0] Operand 1
     /* 2276246 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2276251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276255 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276259 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2276259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2276262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276264 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276266 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276274 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276275 */   // GIR_Coverage, 57093,
     /* 2276275 */   GIR_EraseRootFromParent_Done,
     /* 2276276 */ // Label 30611: @2276276
     /* 2276276 */ GIM_Try, /*On fail goto*//*Label 30612*/ GIMT_Encode4(2276324), // Rule ID 57132 //
     /* 2276281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2276284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2276287 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2276290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276294 */   // MIs[0] Operand 1
     /* 2276294 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2276299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276303 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276307 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2276307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2276310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276312 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276314 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276322 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276323 */   // GIR_Coverage, 57132,
     /* 2276323 */   GIR_EraseRootFromParent_Done,
     /* 2276324 */ // Label 30612: @2276324
     /* 2276324 */ GIM_Try, /*On fail goto*//*Label 30613*/ GIMT_Encode4(2276372), // Rule ID 57133 //
     /* 2276329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2276332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2276335 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2276338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276342 */   // MIs[0] Operand 1
     /* 2276342 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2276347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276351 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276355 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2276355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2276358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276360 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276362 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276370 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276371 */   // GIR_Coverage, 57133,
     /* 2276371 */   GIR_EraseRootFromParent_Done,
     /* 2276372 */ // Label 30613: @2276372
     /* 2276372 */ GIM_Try, /*On fail goto*//*Label 30614*/ GIMT_Encode4(2276420), // Rule ID 57392 //
     /* 2276377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2276380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2276383 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2276386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276390 */   // MIs[0] Operand 1
     /* 2276390 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2276395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276399 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276403 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2276403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2276406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276408 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276410 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276418 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276419 */   // GIR_Coverage, 57392,
     /* 2276419 */   GIR_EraseRootFromParent_Done,
     /* 2276420 */ // Label 30614: @2276420
     /* 2276420 */ GIM_Try, /*On fail goto*//*Label 30615*/ GIMT_Encode4(2276468), // Rule ID 57393 //
     /* 2276425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2276428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2276431 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2276434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276438 */   // MIs[0] Operand 1
     /* 2276438 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2276443 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276447 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276451 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2276451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2276454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276456 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276458 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276466 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276467 */   // GIR_Coverage, 57393,
     /* 2276467 */   GIR_EraseRootFromParent_Done,
     /* 2276468 */ // Label 30615: @2276468
     /* 2276468 */ GIM_Try, /*On fail goto*//*Label 30616*/ GIMT_Encode4(2276516), // Rule ID 57432 //
     /* 2276473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2276476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2276479 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2276482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276486 */   // MIs[0] Operand 1
     /* 2276486 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2276491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276495 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276499 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2276499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2276502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276504 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276506 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276515 */   // GIR_Coverage, 57432,
     /* 2276515 */   GIR_EraseRootFromParent_Done,
     /* 2276516 */ // Label 30616: @2276516
     /* 2276516 */ GIM_Try, /*On fail goto*//*Label 30617*/ GIMT_Encode4(2276564), // Rule ID 57433 //
     /* 2276521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2276524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2276527 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2276530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276534 */   // MIs[0] Operand 1
     /* 2276534 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2276539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276543 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276547 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2276547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2276550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276552 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276554 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276562 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276563 */   // GIR_Coverage, 57433,
     /* 2276563 */   GIR_EraseRootFromParent_Done,
     /* 2276564 */ // Label 30617: @2276564
     /* 2276564 */ GIM_Try, /*On fail goto*//*Label 30618*/ GIMT_Encode4(2276612), // Rule ID 57692 //
     /* 2276569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2276572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2276575 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2276578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276582 */   // MIs[0] Operand 1
     /* 2276582 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2276587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276591 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276595 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2276595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2276598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276600 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276602 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276610 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276611 */   // GIR_Coverage, 57692,
     /* 2276611 */   GIR_EraseRootFromParent_Done,
     /* 2276612 */ // Label 30618: @2276612
     /* 2276612 */ GIM_Try, /*On fail goto*//*Label 30619*/ GIMT_Encode4(2276660), // Rule ID 57693 //
     /* 2276617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2276620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2276623 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2276626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276630 */   // MIs[0] Operand 1
     /* 2276630 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2276635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276639 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276643 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2276643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2276646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276648 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276650 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276658 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276659 */   // GIR_Coverage, 57693,
     /* 2276659 */   GIR_EraseRootFromParent_Done,
     /* 2276660 */ // Label 30619: @2276660
     /* 2276660 */ GIM_Try, /*On fail goto*//*Label 30620*/ GIMT_Encode4(2276708), // Rule ID 57732 //
     /* 2276665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2276668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2276671 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2276674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276678 */   // MIs[0] Operand 1
     /* 2276678 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2276683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276687 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276691 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2276691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2276694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276696 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276698 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276706 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276707 */   // GIR_Coverage, 57732,
     /* 2276707 */   GIR_EraseRootFromParent_Done,
     /* 2276708 */ // Label 30620: @2276708
     /* 2276708 */ GIM_Try, /*On fail goto*//*Label 30621*/ GIMT_Encode4(2276756), // Rule ID 57733 //
     /* 2276713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2276716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2276719 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2276722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276726 */   // MIs[0] Operand 1
     /* 2276726 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2276731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276735 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276739 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2276739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2276742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276744 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276746 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276754 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276755 */   // GIR_Coverage, 57733,
     /* 2276755 */   GIR_EraseRootFromParent_Done,
     /* 2276756 */ // Label 30621: @2276756
     /* 2276756 */ GIM_Try, /*On fail goto*//*Label 30622*/ GIMT_Encode4(2276804), // Rule ID 57992 //
     /* 2276761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2276764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2276767 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2276770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276774 */   // MIs[0] Operand 1
     /* 2276774 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2276779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276783 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276787 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2276787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2276790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276792 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276794 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276802 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276803 */   // GIR_Coverage, 57992,
     /* 2276803 */   GIR_EraseRootFromParent_Done,
     /* 2276804 */ // Label 30622: @2276804
     /* 2276804 */ GIM_Try, /*On fail goto*//*Label 30623*/ GIMT_Encode4(2276852), // Rule ID 57993 //
     /* 2276809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2276812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2276815 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2276818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276822 */   // MIs[0] Operand 1
     /* 2276822 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2276827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276831 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276835 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2276835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2276838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276840 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276842 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276850 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276851 */   // GIR_Coverage, 57993,
     /* 2276851 */   GIR_EraseRootFromParent_Done,
     /* 2276852 */ // Label 30623: @2276852
     /* 2276852 */ GIM_Try, /*On fail goto*//*Label 30624*/ GIMT_Encode4(2276900), // Rule ID 58032 //
     /* 2276857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2276860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2276863 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2276866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276870 */   // MIs[0] Operand 1
     /* 2276870 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2276875 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276879 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276883 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2276883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2276886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276888 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276890 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276898 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276899 */   // GIR_Coverage, 58032,
     /* 2276899 */   GIR_EraseRootFromParent_Done,
     /* 2276900 */ // Label 30624: @2276900
     /* 2276900 */ GIM_Try, /*On fail goto*//*Label 30625*/ GIMT_Encode4(2276948), // Rule ID 58033 //
     /* 2276905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2276908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2276911 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2276914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276918 */   // MIs[0] Operand 1
     /* 2276918 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2276923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276927 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276931 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2276931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2276934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276936 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276938 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276946 */   GIR_RootConstrainSelectedInstOperands,
     /* 2276947 */   // GIR_Coverage, 58033,
     /* 2276947 */   GIR_EraseRootFromParent_Done,
     /* 2276948 */ // Label 30625: @2276948
     /* 2276948 */ GIM_Reject,
     /* 2276949 */ // Label 30473: @2276949
     /* 2276949 */ GIM_Try, /*On fail goto*//*Label 30626*/ GIMT_Encode4(2277269),
     /* 2276954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2276957 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2276960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276964 */   GIM_Try, /*On fail goto*//*Label 30627*/ GIMT_Encode4(2277002), // Rule ID 57102 //
     /* 2276969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2276972 */     // MIs[0] Operand 1
     /* 2276972 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2276977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276985 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2276985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2276988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277001 */     // GIR_Coverage, 57102,
     /* 2277001 */     GIR_EraseRootFromParent_Done,
     /* 2277002 */   // Label 30627: @2277002
     /* 2277002 */   GIM_Try, /*On fail goto*//*Label 30628*/ GIMT_Encode4(2277040), // Rule ID 57103 //
     /* 2277007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2277010 */     // MIs[0] Operand 1
     /* 2277010 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2277015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277023 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2277023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2277026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277039 */     // GIR_Coverage, 57103,
     /* 2277039 */     GIR_EraseRootFromParent_Done,
     /* 2277040 */   // Label 30628: @2277040
     /* 2277040 */   GIM_Try, /*On fail goto*//*Label 30629*/ GIMT_Encode4(2277078), // Rule ID 57402 //
     /* 2277045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2277048 */     // MIs[0] Operand 1
     /* 2277048 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2277053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277061 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2277061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2277064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277077 */     // GIR_Coverage, 57402,
     /* 2277077 */     GIR_EraseRootFromParent_Done,
     /* 2277078 */   // Label 30629: @2277078
     /* 2277078 */   GIM_Try, /*On fail goto*//*Label 30630*/ GIMT_Encode4(2277116), // Rule ID 57403 //
     /* 2277083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2277086 */     // MIs[0] Operand 1
     /* 2277086 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2277091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277099 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2277099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2277102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277115 */     // GIR_Coverage, 57403,
     /* 2277115 */     GIR_EraseRootFromParent_Done,
     /* 2277116 */   // Label 30630: @2277116
     /* 2277116 */   GIM_Try, /*On fail goto*//*Label 30631*/ GIMT_Encode4(2277154), // Rule ID 57702 //
     /* 2277121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2277124 */     // MIs[0] Operand 1
     /* 2277124 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2277129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277137 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2277137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2277140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277153 */     // GIR_Coverage, 57702,
     /* 2277153 */     GIR_EraseRootFromParent_Done,
     /* 2277154 */   // Label 30631: @2277154
     /* 2277154 */   GIM_Try, /*On fail goto*//*Label 30632*/ GIMT_Encode4(2277192), // Rule ID 57703 //
     /* 2277159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2277162 */     // MIs[0] Operand 1
     /* 2277162 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2277167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277175 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2277175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2277178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277191 */     // GIR_Coverage, 57703,
     /* 2277191 */     GIR_EraseRootFromParent_Done,
     /* 2277192 */   // Label 30632: @2277192
     /* 2277192 */   GIM_Try, /*On fail goto*//*Label 30633*/ GIMT_Encode4(2277230), // Rule ID 58002 //
     /* 2277197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2277200 */     // MIs[0] Operand 1
     /* 2277200 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2277205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277213 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2277213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2277216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277229 */     // GIR_Coverage, 58002,
     /* 2277229 */     GIR_EraseRootFromParent_Done,
     /* 2277230 */   // Label 30633: @2277230
     /* 2277230 */   GIM_Try, /*On fail goto*//*Label 30634*/ GIMT_Encode4(2277268), // Rule ID 58003 //
     /* 2277235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2277238 */     // MIs[0] Operand 1
     /* 2277238 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2277243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277251 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2277251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2277254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277267 */     // GIR_Coverage, 58003,
     /* 2277267 */     GIR_EraseRootFromParent_Done,
     /* 2277268 */   // Label 30634: @2277268
     /* 2277268 */   GIM_Reject,
     /* 2277269 */ // Label 30626: @2277269
     /* 2277269 */ GIM_Reject,
     /* 2277270 */ // Label 30474: @2277270
     /* 2277270 */ GIM_Reject,
     /* 2277271 */ // Label 50: @2277271
     /* 2277271 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30659*/ GIMT_Encode4(2281662),
     /* 2277282 */ /*GILLT_s32*//*Label 30635*/ GIMT_Encode4(2277406),
     /* 2277286 */ /*GILLT_s64*//*Label 30636*/ GIMT_Encode4(2277554), GIMT_Encode4(0),
     /* 2277294 */ /*GILLT_nxv1s8*//*Label 30637*/ GIMT_Encode4(2277702),
     /* 2277298 */ /*GILLT_nxv1s16*//*Label 30638*/ GIMT_Encode4(2277822),
     /* 2277302 */ /*GILLT_nxv1s32*//*Label 30639*/ GIMT_Encode4(2278030),
     /* 2277306 */ /*GILLT_nxv1s64*//*Label 30640*/ GIMT_Encode4(2278238), GIMT_Encode4(0),
     /* 2277314 */ /*GILLT_nxv2s8*//*Label 30641*/ GIMT_Encode4(2278446),
     /* 2277318 */ /*GILLT_nxv2s16*//*Label 30642*/ GIMT_Encode4(2278566),
     /* 2277322 */ /*GILLT_nxv2s32*//*Label 30643*/ GIMT_Encode4(2278774),
     /* 2277326 */ /*GILLT_nxv2s64*//*Label 30644*/ GIMT_Encode4(2278982), GIMT_Encode4(0),
     /* 2277334 */ /*GILLT_nxv4s8*//*Label 30645*/ GIMT_Encode4(2279190),
     /* 2277338 */ /*GILLT_nxv4s16*//*Label 30646*/ GIMT_Encode4(2279310),
     /* 2277342 */ /*GILLT_nxv4s32*//*Label 30647*/ GIMT_Encode4(2279518),
     /* 2277346 */ /*GILLT_nxv4s64*//*Label 30648*/ GIMT_Encode4(2279726), GIMT_Encode4(0),
     /* 2277354 */ /*GILLT_nxv8s8*//*Label 30649*/ GIMT_Encode4(2279934),
     /* 2277358 */ /*GILLT_nxv8s16*//*Label 30650*/ GIMT_Encode4(2280054),
     /* 2277362 */ /*GILLT_nxv8s32*//*Label 30651*/ GIMT_Encode4(2280262),
     /* 2277366 */ /*GILLT_nxv8s64*//*Label 30652*/ GIMT_Encode4(2280470), GIMT_Encode4(0),
     /* 2277374 */ /*GILLT_nxv16s8*//*Label 30653*/ GIMT_Encode4(2280678),
     /* 2277378 */ /*GILLT_nxv16s16*//*Label 30654*/ GIMT_Encode4(2280798),
     /* 2277382 */ /*GILLT_nxv16s32*//*Label 30655*/ GIMT_Encode4(2281006), GIMT_Encode4(0),
     /* 2277390 */ /*GILLT_nxv32s8*//*Label 30656*/ GIMT_Encode4(2281214),
     /* 2277394 */ /*GILLT_nxv32s16*//*Label 30657*/ GIMT_Encode4(2281334), GIMT_Encode4(0),
     /* 2277402 */ /*GILLT_nxv64s8*//*Label 30658*/ GIMT_Encode4(2281542),
     /* 2277406 */ // Label 30635: @2277406
     /* 2277406 */ GIM_Try, /*On fail goto*//*Label 30660*/ GIMT_Encode4(2277553),
     /* 2277411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2277414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277417 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277428 */   GIM_Try, /*On fail goto*//*Label 30661*/ GIMT_Encode4(2277461), // Rule ID 62573 //
     /* 2277433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2277436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2277440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277444 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, 0:{ *:[i32] }, GPR:{ *:[i32] }:$b)  =>  (TH_MVNEZ:{ *:[i32] } GPR:{ *:[i32] }:$b, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2277444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2277447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277449 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2277451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2277457 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2277459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277460 */     // GIR_Coverage, 62573,
     /* 2277460 */     GIR_EraseRootFromParent_Done,
     /* 2277461 */   // Label 30661: @2277461
     /* 2277461 */   GIM_Try, /*On fail goto*//*Label 30662*/ GIMT_Encode4(2277494), // Rule ID 62571 //
     /* 2277466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2277469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2277477 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2277477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2277480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277482 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2277484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2277490 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2277492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277493 */     // GIR_Coverage, 62571,
     /* 2277493 */     GIR_EraseRootFromParent_Done,
     /* 2277494 */   // Label 30662: @2277494
     /* 2277494 */   GIM_Try, /*On fail goto*//*Label 30663*/ GIMT_Encode4(2277523), // Rule ID 62569 //
     /* 2277499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2277502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277510 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$cond)
     /* 2277510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2277513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277515 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2277517 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2277519 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2277521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277522 */     // GIR_Coverage, 62569,
     /* 2277522 */     GIR_EraseRootFromParent_Done,
     /* 2277523 */   // Label 30663: @2277523
     /* 2277523 */   GIM_Try, /*On fail goto*//*Label 30664*/ GIMT_Encode4(2277552), // Rule ID 64626 //
     /* 2277528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
     /* 2277531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277539 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /* 2277539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2277542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2277548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2277550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277551 */     // GIR_Coverage, 64626,
     /* 2277551 */     GIR_EraseRootFromParent_Done,
     /* 2277552 */   // Label 30664: @2277552
     /* 2277552 */   GIM_Reject,
     /* 2277553 */ // Label 30660: @2277553
     /* 2277553 */ GIM_Reject,
     /* 2277554 */ // Label 30636: @2277554
     /* 2277554 */ GIM_Try, /*On fail goto*//*Label 30665*/ GIMT_Encode4(2277701),
     /* 2277559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2277562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2277565 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2277568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277576 */   GIM_Try, /*On fail goto*//*Label 30666*/ GIMT_Encode4(2277609), // Rule ID 62572 //
     /* 2277581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2277584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2277588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277592 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, 0:{ *:[i64] }, GPR:{ *:[i64] }:$b)  =>  (TH_MVNEZ:{ *:[i64] } GPR:{ *:[i64] }:$b, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2277592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2277595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277597 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2277599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2277605 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2277607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277608 */     // GIR_Coverage, 62572,
     /* 2277608 */     GIR_EraseRootFromParent_Done,
     /* 2277609 */   // Label 30666: @2277609
     /* 2277609 */   GIM_Try, /*On fail goto*//*Label 30667*/ GIMT_Encode4(2277642), // Rule ID 62570 //
     /* 2277614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2277617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2277625 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, 0:{ *:[i64] })  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2277625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2277628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277630 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2277632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2277638 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2277640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277641 */     // GIR_Coverage, 62570,
     /* 2277641 */     GIR_EraseRootFromParent_Done,
     /* 2277642 */   // Label 30667: @2277642
     /* 2277642 */   GIM_Try, /*On fail goto*//*Label 30668*/ GIMT_Encode4(2277671), // Rule ID 62568 //
     /* 2277647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2277650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277658 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b)  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b, GPR:{ *:[i64] }:$cond)
     /* 2277658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2277661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277663 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2277665 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2277667 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2277669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277670 */     // GIR_Coverage, 62568,
     /* 2277670 */     GIR_EraseRootFromParent_Done,
     /* 2277671 */   // Label 30668: @2277671
     /* 2277671 */   GIM_Try, /*On fail goto*//*Label 30669*/ GIMT_Encode4(2277700), // Rule ID 64625 //
     /* 2277676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
     /* 2277679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277687 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs3)
     /* 2277687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2277690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2277696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2277698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277699 */     // GIR_Coverage, 64625,
     /* 2277699 */     GIR_EraseRootFromParent_Done,
     /* 2277700 */   // Label 30669: @2277700
     /* 2277700 */   GIM_Reject,
     /* 2277701 */ // Label 30665: @2277701
     /* 2277701 */ GIM_Reject,
     /* 2277702 */ // Label 30637: @2277702
     /* 2277702 */ GIM_Try, /*On fail goto*//*Label 30670*/ GIMT_Encode4(2277821),
     /* 2277707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2277710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2277713 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2277716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2277720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277728 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277732 */   GIM_Try, /*On fail goto*//*Label 30671*/ GIMT_Encode4(2277776), // Rule ID 52232 //
     /* 2277737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277740 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2277743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2277757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277766 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277775 */     // GIR_Coverage, 52232,
     /* 2277775 */     GIR_EraseRootFromParent_Done,
     /* 2277776 */   // Label 30671: @2277776
     /* 2277776 */   GIM_Try, /*On fail goto*//*Label 30672*/ GIMT_Encode4(2277820), // Rule ID 52233 //
     /* 2277781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277784 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2277787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2277801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277810 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277819 */     // GIR_Coverage, 52233,
     /* 2277819 */     GIR_EraseRootFromParent_Done,
     /* 2277820 */   // Label 30672: @2277820
     /* 2277820 */   GIM_Reject,
     /* 2277821 */ // Label 30670: @2277821
     /* 2277821 */ GIM_Reject,
     /* 2277822 */ // Label 30638: @2277822
     /* 2277822 */ GIM_Try, /*On fail goto*//*Label 30673*/ GIMT_Encode4(2278029),
     /* 2277827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2277830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2277833 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2277836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2277840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277848 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277852 */   GIM_Try, /*On fail goto*//*Label 30674*/ GIMT_Encode4(2277896), // Rule ID 52250 //
     /* 2277857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277860 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2277860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2277863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2277877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277886 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277895 */     // GIR_Coverage, 52250,
     /* 2277895 */     GIR_EraseRootFromParent_Done,
     /* 2277896 */   // Label 30674: @2277896
     /* 2277896 */   GIM_Try, /*On fail goto*//*Label 30675*/ GIMT_Encode4(2277940), // Rule ID 52251 //
     /* 2277901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277904 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2277904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2277907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2277921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277930 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277939 */     // GIR_Coverage, 52251,
     /* 2277939 */     GIR_EraseRootFromParent_Done,
     /* 2277940 */   // Label 30675: @2277940
     /* 2277940 */   GIM_Try, /*On fail goto*//*Label 30676*/ GIMT_Encode4(2277984), // Rule ID 58072 //
     /* 2277945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277948 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2277948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2277951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2277965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277974 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277983 */     // GIR_Coverage, 58072,
     /* 2277983 */     GIR_EraseRootFromParent_Done,
     /* 2277984 */   // Label 30676: @2277984
     /* 2277984 */   GIM_Try, /*On fail goto*//*Label 30677*/ GIMT_Encode4(2278028), // Rule ID 58073 //
     /* 2277989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277992 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2277992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2277995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2278009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278018 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278027 */     // GIR_Coverage, 58073,
     /* 2278027 */     GIR_EraseRootFromParent_Done,
     /* 2278028 */   // Label 30677: @2278028
     /* 2278028 */   GIM_Reject,
     /* 2278029 */ // Label 30673: @2278029
     /* 2278029 */ GIM_Reject,
     /* 2278030 */ // Label 30639: @2278030
     /* 2278030 */ GIM_Try, /*On fail goto*//*Label 30678*/ GIMT_Encode4(2278237),
     /* 2278035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2278038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2278041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2278044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2278048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278056 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278060 */   GIM_Try, /*On fail goto*//*Label 30679*/ GIMT_Encode4(2278104), // Rule ID 52262 //
     /* 2278065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278068 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2278068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2278071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2278085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278094 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278103 */     // GIR_Coverage, 52262,
     /* 2278103 */     GIR_EraseRootFromParent_Done,
     /* 2278104 */   // Label 30679: @2278104
     /* 2278104 */   GIM_Try, /*On fail goto*//*Label 30680*/ GIMT_Encode4(2278148), // Rule ID 52263 //
     /* 2278109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278112 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2278112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2278115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2278129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278138 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278147 */     // GIR_Coverage, 52263,
     /* 2278147 */     GIR_EraseRootFromParent_Done,
     /* 2278148 */   // Label 30680: @2278148
     /* 2278148 */   GIM_Try, /*On fail goto*//*Label 30681*/ GIMT_Encode4(2278192), // Rule ID 58092 //
     /* 2278153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278156 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2278156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2278159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2278173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278182 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278191 */     // GIR_Coverage, 58092,
     /* 2278191 */     GIR_EraseRootFromParent_Done,
     /* 2278192 */   // Label 30681: @2278192
     /* 2278192 */   GIM_Try, /*On fail goto*//*Label 30682*/ GIMT_Encode4(2278236), // Rule ID 58093 //
     /* 2278197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278200 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2278200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2278203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2278217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278226 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278235 */     // GIR_Coverage, 58093,
     /* 2278235 */     GIR_EraseRootFromParent_Done,
     /* 2278236 */   // Label 30682: @2278236
     /* 2278236 */   GIM_Reject,
     /* 2278237 */ // Label 30678: @2278237
     /* 2278237 */ GIM_Reject,
     /* 2278238 */ // Label 30640: @2278238
     /* 2278238 */ GIM_Try, /*On fail goto*//*Label 30683*/ GIMT_Encode4(2278445),
     /* 2278243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2278246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2278249 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2278252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2278256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278264 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278268 */   GIM_Try, /*On fail goto*//*Label 30684*/ GIMT_Encode4(2278312), // Rule ID 52286 //
     /* 2278273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2278276 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2278276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2278279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2278293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278302 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278311 */     // GIR_Coverage, 52286,
     /* 2278311 */     GIR_EraseRootFromParent_Done,
     /* 2278312 */   // Label 30684: @2278312
     /* 2278312 */   GIM_Try, /*On fail goto*//*Label 30685*/ GIMT_Encode4(2278356), // Rule ID 52287 //
     /* 2278317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2278320 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2278320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2278323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2278337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278346 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278355 */     // GIR_Coverage, 52287,
     /* 2278355 */     GIR_EraseRootFromParent_Done,
     /* 2278356 */   // Label 30685: @2278356
     /* 2278356 */   GIM_Try, /*On fail goto*//*Label 30686*/ GIMT_Encode4(2278400), // Rule ID 58122 //
     /* 2278361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2278364 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2278364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2278367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2278381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278390 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278399 */     // GIR_Coverage, 58122,
     /* 2278399 */     GIR_EraseRootFromParent_Done,
     /* 2278400 */   // Label 30686: @2278400
     /* 2278400 */   GIM_Try, /*On fail goto*//*Label 30687*/ GIMT_Encode4(2278444), // Rule ID 58123 //
     /* 2278405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2278408 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2278408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2278411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2278425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278434 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278443 */     // GIR_Coverage, 58123,
     /* 2278443 */     GIR_EraseRootFromParent_Done,
     /* 2278444 */   // Label 30687: @2278444
     /* 2278444 */   GIM_Reject,
     /* 2278445 */ // Label 30683: @2278445
     /* 2278445 */ GIM_Reject,
     /* 2278446 */ // Label 30641: @2278446
     /* 2278446 */ GIM_Try, /*On fail goto*//*Label 30688*/ GIMT_Encode4(2278565),
     /* 2278451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2278454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2278457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2278460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2278464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278472 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278476 */   GIM_Try, /*On fail goto*//*Label 30689*/ GIMT_Encode4(2278520), // Rule ID 52238 //
     /* 2278481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278484 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2278487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2278501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278510 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278519 */     // GIR_Coverage, 52238,
     /* 2278519 */     GIR_EraseRootFromParent_Done,
     /* 2278520 */   // Label 30689: @2278520
     /* 2278520 */   GIM_Try, /*On fail goto*//*Label 30690*/ GIMT_Encode4(2278564), // Rule ID 52239 //
     /* 2278525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278528 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2278531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2278545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278554 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278563 */     // GIR_Coverage, 52239,
     /* 2278563 */     GIR_EraseRootFromParent_Done,
     /* 2278564 */   // Label 30690: @2278564
     /* 2278564 */   GIM_Reject,
     /* 2278565 */ // Label 30688: @2278565
     /* 2278565 */ GIM_Reject,
     /* 2278566 */ // Label 30642: @2278566
     /* 2278566 */ GIM_Try, /*On fail goto*//*Label 30691*/ GIMT_Encode4(2278773),
     /* 2278571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2278574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2278577 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2278580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2278584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278592 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278596 */   GIM_Try, /*On fail goto*//*Label 30692*/ GIMT_Encode4(2278640), // Rule ID 52256 //
     /* 2278601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278604 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2278604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2278607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2278621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278630 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278639 */     // GIR_Coverage, 52256,
     /* 2278639 */     GIR_EraseRootFromParent_Done,
     /* 2278640 */   // Label 30692: @2278640
     /* 2278640 */   GIM_Try, /*On fail goto*//*Label 30693*/ GIMT_Encode4(2278684), // Rule ID 52257 //
     /* 2278645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278648 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2278648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2278651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2278665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278674 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278683 */     // GIR_Coverage, 52257,
     /* 2278683 */     GIR_EraseRootFromParent_Done,
     /* 2278684 */   // Label 30693: @2278684
     /* 2278684 */   GIM_Try, /*On fail goto*//*Label 30694*/ GIMT_Encode4(2278728), // Rule ID 58082 //
     /* 2278689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278692 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2278692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2278695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2278709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278718 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278727 */     // GIR_Coverage, 58082,
     /* 2278727 */     GIR_EraseRootFromParent_Done,
     /* 2278728 */   // Label 30694: @2278728
     /* 2278728 */   GIM_Try, /*On fail goto*//*Label 30695*/ GIMT_Encode4(2278772), // Rule ID 58083 //
     /* 2278733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278736 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2278736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2278739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2278753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278762 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278771 */     // GIR_Coverage, 58083,
     /* 2278771 */     GIR_EraseRootFromParent_Done,
     /* 2278772 */   // Label 30695: @2278772
     /* 2278772 */   GIM_Reject,
     /* 2278773 */ // Label 30691: @2278773
     /* 2278773 */ GIM_Reject,
     /* 2278774 */ // Label 30643: @2278774
     /* 2278774 */ GIM_Try, /*On fail goto*//*Label 30696*/ GIMT_Encode4(2278981),
     /* 2278779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2278782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2278785 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2278788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2278792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278800 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278804 */   GIM_Try, /*On fail goto*//*Label 30697*/ GIMT_Encode4(2278848), // Rule ID 52280 //
     /* 2278809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278812 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2278812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2278815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2278829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278838 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278847 */     // GIR_Coverage, 52280,
     /* 2278847 */     GIR_EraseRootFromParent_Done,
     /* 2278848 */   // Label 30697: @2278848
     /* 2278848 */   GIM_Try, /*On fail goto*//*Label 30698*/ GIMT_Encode4(2278892), // Rule ID 52281 //
     /* 2278853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278856 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2278856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2278859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2278873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278882 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278891 */     // GIR_Coverage, 52281,
     /* 2278891 */     GIR_EraseRootFromParent_Done,
     /* 2278892 */   // Label 30698: @2278892
     /* 2278892 */   GIM_Try, /*On fail goto*//*Label 30699*/ GIMT_Encode4(2278936), // Rule ID 58112 //
     /* 2278897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278900 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2278900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2278903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2278917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278926 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278935 */     // GIR_Coverage, 58112,
     /* 2278935 */     GIR_EraseRootFromParent_Done,
     /* 2278936 */   // Label 30699: @2278936
     /* 2278936 */   GIM_Try, /*On fail goto*//*Label 30700*/ GIMT_Encode4(2278980), // Rule ID 58113 //
     /* 2278941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278944 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2278944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2278947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2278961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278970 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278979 */     // GIR_Coverage, 58113,
     /* 2278979 */     GIR_EraseRootFromParent_Done,
     /* 2278980 */   // Label 30700: @2278980
     /* 2278980 */   GIM_Reject,
     /* 2278981 */ // Label 30696: @2278981
     /* 2278981 */ GIM_Reject,
     /* 2278982 */ // Label 30644: @2278982
     /* 2278982 */ GIM_Try, /*On fail goto*//*Label 30701*/ GIMT_Encode4(2279189),
     /* 2278987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2278990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2278993 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2278996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2279000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2279004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2279008 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2279012 */   GIM_Try, /*On fail goto*//*Label 30702*/ GIMT_Encode4(2279056), // Rule ID 52346 //
     /* 2279017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2279020 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2279020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2279023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2279037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279046 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279055 */     // GIR_Coverage, 52346,
     /* 2279055 */     GIR_EraseRootFromParent_Done,
     /* 2279056 */   // Label 30702: @2279056
     /* 2279056 */   GIM_Try, /*On fail goto*//*Label 30703*/ GIMT_Encode4(2279100), // Rule ID 52347 //
     /* 2279061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2279064 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2279064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2279067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2279081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279090 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279099 */     // GIR_Coverage, 52347,
     /* 2279099 */     GIR_EraseRootFromParent_Done,
     /* 2279100 */   // Label 30703: @2279100
     /* 2279100 */   GIM_Try, /*On fail goto*//*Label 30704*/ GIMT_Encode4(2279144), // Rule ID 58192 //
     /* 2279105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2279108 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2279108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2279111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2279125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279134 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279143 */     // GIR_Coverage, 58192,
     /* 2279143 */     GIR_EraseRootFromParent_Done,
     /* 2279144 */   // Label 30704: @2279144
     /* 2279144 */   GIM_Try, /*On fail goto*//*Label 30705*/ GIMT_Encode4(2279188), // Rule ID 58193 //
     /* 2279149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2279152 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2279152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2279155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2279169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279178 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279187 */     // GIR_Coverage, 58193,
     /* 2279187 */     GIR_EraseRootFromParent_Done,
     /* 2279188 */   // Label 30705: @2279188
     /* 2279188 */   GIM_Reject,
     /* 2279189 */ // Label 30701: @2279189
     /* 2279189 */ GIM_Reject,
     /* 2279190 */ // Label 30645: @2279190
     /* 2279190 */ GIM_Try, /*On fail goto*//*Label 30706*/ GIMT_Encode4(2279309),
     /* 2279195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2279198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2279201 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2279204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2279208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2279212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279216 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279220 */   GIM_Try, /*On fail goto*//*Label 30707*/ GIMT_Encode4(2279264), // Rule ID 52244 //
     /* 2279225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279228 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2279231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2279245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279254 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279263 */     // GIR_Coverage, 52244,
     /* 2279263 */     GIR_EraseRootFromParent_Done,
     /* 2279264 */   // Label 30707: @2279264
     /* 2279264 */   GIM_Try, /*On fail goto*//*Label 30708*/ GIMT_Encode4(2279308), // Rule ID 52245 //
     /* 2279269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279272 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2279275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2279289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279298 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279307 */     // GIR_Coverage, 52245,
     /* 2279307 */     GIR_EraseRootFromParent_Done,
     /* 2279308 */   // Label 30708: @2279308
     /* 2279308 */   GIM_Reject,
     /* 2279309 */ // Label 30706: @2279309
     /* 2279309 */ GIM_Reject,
     /* 2279310 */ // Label 30646: @2279310
     /* 2279310 */ GIM_Try, /*On fail goto*//*Label 30709*/ GIMT_Encode4(2279517),
     /* 2279315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2279318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2279321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2279324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2279328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2279332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279336 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279340 */   GIM_Try, /*On fail goto*//*Label 30710*/ GIMT_Encode4(2279384), // Rule ID 52274 //
     /* 2279345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279348 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2279348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2279351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2279365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279374 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279383 */     // GIR_Coverage, 52274,
     /* 2279383 */     GIR_EraseRootFromParent_Done,
     /* 2279384 */   // Label 30710: @2279384
     /* 2279384 */   GIM_Try, /*On fail goto*//*Label 30711*/ GIMT_Encode4(2279428), // Rule ID 52275 //
     /* 2279389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279392 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2279392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2279395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2279409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279418 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279427 */     // GIR_Coverage, 52275,
     /* 2279427 */     GIR_EraseRootFromParent_Done,
     /* 2279428 */   // Label 30711: @2279428
     /* 2279428 */   GIM_Try, /*On fail goto*//*Label 30712*/ GIMT_Encode4(2279472), // Rule ID 58102 //
     /* 2279433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279436 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2279436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2279439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2279453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279462 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279471 */     // GIR_Coverage, 58102,
     /* 2279471 */     GIR_EraseRootFromParent_Done,
     /* 2279472 */   // Label 30712: @2279472
     /* 2279472 */   GIM_Try, /*On fail goto*//*Label 30713*/ GIMT_Encode4(2279516), // Rule ID 58103 //
     /* 2279477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279480 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2279480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2279483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2279497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279506 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279515 */     // GIR_Coverage, 58103,
     /* 2279515 */     GIR_EraseRootFromParent_Done,
     /* 2279516 */   // Label 30713: @2279516
     /* 2279516 */   GIM_Reject,
     /* 2279517 */ // Label 30709: @2279517
     /* 2279517 */ GIM_Reject,
     /* 2279518 */ // Label 30647: @2279518
     /* 2279518 */ GIM_Try, /*On fail goto*//*Label 30714*/ GIMT_Encode4(2279725),
     /* 2279523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2279526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2279529 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2279532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2279536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2279540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2279544 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2279548 */   GIM_Try, /*On fail goto*//*Label 30715*/ GIMT_Encode4(2279592), // Rule ID 52328 //
     /* 2279553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279556 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2279556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2279559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2279573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279582 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279591 */     // GIR_Coverage, 52328,
     /* 2279591 */     GIR_EraseRootFromParent_Done,
     /* 2279592 */   // Label 30715: @2279592
     /* 2279592 */   GIM_Try, /*On fail goto*//*Label 30716*/ GIMT_Encode4(2279636), // Rule ID 52329 //
     /* 2279597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279600 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2279600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2279603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2279617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279626 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279635 */     // GIR_Coverage, 52329,
     /* 2279635 */     GIR_EraseRootFromParent_Done,
     /* 2279636 */   // Label 30716: @2279636
     /* 2279636 */   GIM_Try, /*On fail goto*//*Label 30717*/ GIMT_Encode4(2279680), // Rule ID 58162 //
     /* 2279641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279644 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2279644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2279647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2279661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279670 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279679 */     // GIR_Coverage, 58162,
     /* 2279679 */     GIR_EraseRootFromParent_Done,
     /* 2279680 */   // Label 30717: @2279680
     /* 2279680 */   GIM_Try, /*On fail goto*//*Label 30718*/ GIMT_Encode4(2279724), // Rule ID 58163 //
     /* 2279685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279688 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2279688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2279691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2279705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279714 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279723 */     // GIR_Coverage, 58163,
     /* 2279723 */     GIR_EraseRootFromParent_Done,
     /* 2279724 */   // Label 30718: @2279724
     /* 2279724 */   GIM_Reject,
     /* 2279725 */ // Label 30714: @2279725
     /* 2279725 */ GIM_Reject,
     /* 2279726 */ // Label 30648: @2279726
     /* 2279726 */ GIM_Try, /*On fail goto*//*Label 30719*/ GIMT_Encode4(2279933),
     /* 2279731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2279734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2279737 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2279740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2279744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2279748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279752 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279756 */   GIM_Try, /*On fail goto*//*Label 30720*/ GIMT_Encode4(2279800), // Rule ID 52352 //
     /* 2279761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2279764 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2279764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2279767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2279781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279790 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279799 */     // GIR_Coverage, 52352,
     /* 2279799 */     GIR_EraseRootFromParent_Done,
     /* 2279800 */   // Label 30720: @2279800
     /* 2279800 */   GIM_Try, /*On fail goto*//*Label 30721*/ GIMT_Encode4(2279844), // Rule ID 52353 //
     /* 2279805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2279808 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2279808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2279811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2279825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279834 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279843 */     // GIR_Coverage, 52353,
     /* 2279843 */     GIR_EraseRootFromParent_Done,
     /* 2279844 */   // Label 30721: @2279844
     /* 2279844 */   GIM_Try, /*On fail goto*//*Label 30722*/ GIMT_Encode4(2279888), // Rule ID 58202 //
     /* 2279849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2279852 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2279852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2279855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2279869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279878 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279887 */     // GIR_Coverage, 58202,
     /* 2279887 */     GIR_EraseRootFromParent_Done,
     /* 2279888 */   // Label 30722: @2279888
     /* 2279888 */   GIM_Try, /*On fail goto*//*Label 30723*/ GIMT_Encode4(2279932), // Rule ID 58203 //
     /* 2279893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2279896 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2279896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2279899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2279913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279922 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279931 */     // GIR_Coverage, 58203,
     /* 2279931 */     GIR_EraseRootFromParent_Done,
     /* 2279932 */   // Label 30723: @2279932
     /* 2279932 */   GIM_Reject,
     /* 2279933 */ // Label 30719: @2279933
     /* 2279933 */ GIM_Reject,
     /* 2279934 */ // Label 30649: @2279934
     /* 2279934 */ GIM_Try, /*On fail goto*//*Label 30724*/ GIMT_Encode4(2280053),
     /* 2279939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2279942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2279945 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2279948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2279952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2279956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279960 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279964 */   GIM_Try, /*On fail goto*//*Label 30725*/ GIMT_Encode4(2280008), // Rule ID 52268 //
     /* 2279969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279972 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2279975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2279989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279998 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280007 */     // GIR_Coverage, 52268,
     /* 2280007 */     GIR_EraseRootFromParent_Done,
     /* 2280008 */   // Label 30725: @2280008
     /* 2280008 */   GIM_Try, /*On fail goto*//*Label 30726*/ GIMT_Encode4(2280052), // Rule ID 52269 //
     /* 2280013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280016 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2280019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2280033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280042 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280051 */     // GIR_Coverage, 52269,
     /* 2280051 */     GIR_EraseRootFromParent_Done,
     /* 2280052 */   // Label 30726: @2280052
     /* 2280052 */   GIM_Reject,
     /* 2280053 */ // Label 30724: @2280053
     /* 2280053 */ GIM_Reject,
     /* 2280054 */ // Label 30650: @2280054
     /* 2280054 */ GIM_Try, /*On fail goto*//*Label 30727*/ GIMT_Encode4(2280261),
     /* 2280059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2280062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2280065 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2280068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2280072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2280076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280080 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280084 */   GIM_Try, /*On fail goto*//*Label 30728*/ GIMT_Encode4(2280128), // Rule ID 52310 //
     /* 2280089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280092 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2280092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2280095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2280109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280118 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280127 */     // GIR_Coverage, 52310,
     /* 2280127 */     GIR_EraseRootFromParent_Done,
     /* 2280128 */   // Label 30728: @2280128
     /* 2280128 */   GIM_Try, /*On fail goto*//*Label 30729*/ GIMT_Encode4(2280172), // Rule ID 52311 //
     /* 2280133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280136 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2280136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2280139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2280153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280162 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280171 */     // GIR_Coverage, 52311,
     /* 2280171 */     GIR_EraseRootFromParent_Done,
     /* 2280172 */   // Label 30729: @2280172
     /* 2280172 */   GIM_Try, /*On fail goto*//*Label 30730*/ GIMT_Encode4(2280216), // Rule ID 58132 //
     /* 2280177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280180 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2280180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2280183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2280197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280206 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280215 */     // GIR_Coverage, 58132,
     /* 2280215 */     GIR_EraseRootFromParent_Done,
     /* 2280216 */   // Label 30730: @2280216
     /* 2280216 */   GIM_Try, /*On fail goto*//*Label 30731*/ GIMT_Encode4(2280260), // Rule ID 58133 //
     /* 2280221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280224 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2280224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2280227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2280241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280250 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280259 */     // GIR_Coverage, 58133,
     /* 2280259 */     GIR_EraseRootFromParent_Done,
     /* 2280260 */   // Label 30731: @2280260
     /* 2280260 */   GIM_Reject,
     /* 2280261 */ // Label 30727: @2280261
     /* 2280261 */ GIM_Reject,
     /* 2280262 */ // Label 30651: @2280262
     /* 2280262 */ GIM_Try, /*On fail goto*//*Label 30732*/ GIMT_Encode4(2280469),
     /* 2280267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2280270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2280273 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2280276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2280280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2280284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280288 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280292 */   GIM_Try, /*On fail goto*//*Label 30733*/ GIMT_Encode4(2280336), // Rule ID 52334 //
     /* 2280297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280300 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2280300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2280303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2280317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280326 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280335 */     // GIR_Coverage, 52334,
     /* 2280335 */     GIR_EraseRootFromParent_Done,
     /* 2280336 */   // Label 30733: @2280336
     /* 2280336 */   GIM_Try, /*On fail goto*//*Label 30734*/ GIMT_Encode4(2280380), // Rule ID 52335 //
     /* 2280341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280344 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2280344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2280347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2280361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280370 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280379 */     // GIR_Coverage, 52335,
     /* 2280379 */     GIR_EraseRootFromParent_Done,
     /* 2280380 */   // Label 30734: @2280380
     /* 2280380 */   GIM_Try, /*On fail goto*//*Label 30735*/ GIMT_Encode4(2280424), // Rule ID 58172 //
     /* 2280385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280388 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2280388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2280391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2280405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280414 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280423 */     // GIR_Coverage, 58172,
     /* 2280423 */     GIR_EraseRootFromParent_Done,
     /* 2280424 */   // Label 30735: @2280424
     /* 2280424 */   GIM_Try, /*On fail goto*//*Label 30736*/ GIMT_Encode4(2280468), // Rule ID 58173 //
     /* 2280429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280432 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2280432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2280435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2280449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280458 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280467 */     // GIR_Coverage, 58173,
     /* 2280467 */     GIR_EraseRootFromParent_Done,
     /* 2280468 */   // Label 30736: @2280468
     /* 2280468 */   GIM_Reject,
     /* 2280469 */ // Label 30732: @2280469
     /* 2280469 */ GIM_Reject,
     /* 2280470 */ // Label 30652: @2280470
     /* 2280470 */ GIM_Try, /*On fail goto*//*Label 30737*/ GIMT_Encode4(2280677),
     /* 2280475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2280478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2280481 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2280484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2280488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2280492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2280496 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2280500 */   GIM_Try, /*On fail goto*//*Label 30738*/ GIMT_Encode4(2280544), // Rule ID 52358 //
     /* 2280505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2280508 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2280508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2280511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2280525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280534 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280543 */     // GIR_Coverage, 52358,
     /* 2280543 */     GIR_EraseRootFromParent_Done,
     /* 2280544 */   // Label 30738: @2280544
     /* 2280544 */   GIM_Try, /*On fail goto*//*Label 30739*/ GIMT_Encode4(2280588), // Rule ID 52359 //
     /* 2280549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2280552 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2280552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2280555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2280569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280578 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280587 */     // GIR_Coverage, 52359,
     /* 2280587 */     GIR_EraseRootFromParent_Done,
     /* 2280588 */   // Label 30739: @2280588
     /* 2280588 */   GIM_Try, /*On fail goto*//*Label 30740*/ GIMT_Encode4(2280632), // Rule ID 58212 //
     /* 2280593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2280596 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2280596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2280599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2280613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280622 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280631 */     // GIR_Coverage, 58212,
     /* 2280631 */     GIR_EraseRootFromParent_Done,
     /* 2280632 */   // Label 30740: @2280632
     /* 2280632 */   GIM_Try, /*On fail goto*//*Label 30741*/ GIMT_Encode4(2280676), // Rule ID 58213 //
     /* 2280637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2280640 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2280640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2280643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2280657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280666 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280675 */     // GIR_Coverage, 58213,
     /* 2280675 */     GIR_EraseRootFromParent_Done,
     /* 2280676 */   // Label 30741: @2280676
     /* 2280676 */   GIM_Reject,
     /* 2280677 */ // Label 30737: @2280677
     /* 2280677 */ GIM_Reject,
     /* 2280678 */ // Label 30653: @2280678
     /* 2280678 */ GIM_Try, /*On fail goto*//*Label 30742*/ GIMT_Encode4(2280797),
     /* 2280683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2280686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2280689 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2280692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2280696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2280700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280704 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280708 */   GIM_Try, /*On fail goto*//*Label 30743*/ GIMT_Encode4(2280752), // Rule ID 52292 //
     /* 2280713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280716 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2280719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2280733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280742 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280751 */     // GIR_Coverage, 52292,
     /* 2280751 */     GIR_EraseRootFromParent_Done,
     /* 2280752 */   // Label 30743: @2280752
     /* 2280752 */   GIM_Try, /*On fail goto*//*Label 30744*/ GIMT_Encode4(2280796), // Rule ID 52293 //
     /* 2280757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280760 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2280763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2280777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280786 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280795 */     // GIR_Coverage, 52293,
     /* 2280795 */     GIR_EraseRootFromParent_Done,
     /* 2280796 */   // Label 30744: @2280796
     /* 2280796 */   GIM_Reject,
     /* 2280797 */ // Label 30742: @2280797
     /* 2280797 */ GIM_Reject,
     /* 2280798 */ // Label 30654: @2280798
     /* 2280798 */ GIM_Try, /*On fail goto*//*Label 30745*/ GIMT_Encode4(2281005),
     /* 2280803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2280806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2280809 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2280812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2280816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2280820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280824 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280828 */   GIM_Try, /*On fail goto*//*Label 30746*/ GIMT_Encode4(2280872), // Rule ID 52316 //
     /* 2280833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280836 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2280836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2280839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2280853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280862 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280871 */     // GIR_Coverage, 52316,
     /* 2280871 */     GIR_EraseRootFromParent_Done,
     /* 2280872 */   // Label 30746: @2280872
     /* 2280872 */   GIM_Try, /*On fail goto*//*Label 30747*/ GIMT_Encode4(2280916), // Rule ID 52317 //
     /* 2280877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280880 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2280880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2280883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2280897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280906 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280915 */     // GIR_Coverage, 52317,
     /* 2280915 */     GIR_EraseRootFromParent_Done,
     /* 2280916 */   // Label 30747: @2280916
     /* 2280916 */   GIM_Try, /*On fail goto*//*Label 30748*/ GIMT_Encode4(2280960), // Rule ID 58142 //
     /* 2280921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280924 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2280924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2280927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2280941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280950 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280959 */     // GIR_Coverage, 58142,
     /* 2280959 */     GIR_EraseRootFromParent_Done,
     /* 2280960 */   // Label 30748: @2280960
     /* 2280960 */   GIM_Try, /*On fail goto*//*Label 30749*/ GIMT_Encode4(2281004), // Rule ID 58143 //
     /* 2280965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280968 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2280968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2280971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2280985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2280992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2280994 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2280996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281003 */     // GIR_Coverage, 58143,
     /* 2281003 */     GIR_EraseRootFromParent_Done,
     /* 2281004 */   // Label 30749: @2281004
     /* 2281004 */   GIM_Reject,
     /* 2281005 */ // Label 30745: @2281005
     /* 2281005 */ GIM_Reject,
     /* 2281006 */ // Label 30655: @2281006
     /* 2281006 */ GIM_Try, /*On fail goto*//*Label 30750*/ GIMT_Encode4(2281213),
     /* 2281011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2281014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2281017 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2281020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2281024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2281028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281032 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281036 */   GIM_Try, /*On fail goto*//*Label 30751*/ GIMT_Encode4(2281080), // Rule ID 52340 //
     /* 2281041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281044 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2281044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2281047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2281061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281070 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281079 */     // GIR_Coverage, 52340,
     /* 2281079 */     GIR_EraseRootFromParent_Done,
     /* 2281080 */   // Label 30751: @2281080
     /* 2281080 */   GIM_Try, /*On fail goto*//*Label 30752*/ GIMT_Encode4(2281124), // Rule ID 52341 //
     /* 2281085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281088 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2281088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2281091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2281105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281114 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281123 */     // GIR_Coverage, 52341,
     /* 2281123 */     GIR_EraseRootFromParent_Done,
     /* 2281124 */   // Label 30752: @2281124
     /* 2281124 */   GIM_Try, /*On fail goto*//*Label 30753*/ GIMT_Encode4(2281168), // Rule ID 58182 //
     /* 2281129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281132 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2281132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2281135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2281149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281158 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281167 */     // GIR_Coverage, 58182,
     /* 2281167 */     GIR_EraseRootFromParent_Done,
     /* 2281168 */   // Label 30753: @2281168
     /* 2281168 */   GIM_Try, /*On fail goto*//*Label 30754*/ GIMT_Encode4(2281212), // Rule ID 58183 //
     /* 2281173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281176 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2281176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2281179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2281193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281202 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281211 */     // GIR_Coverage, 58183,
     /* 2281211 */     GIR_EraseRootFromParent_Done,
     /* 2281212 */   // Label 30754: @2281212
     /* 2281212 */   GIM_Reject,
     /* 2281213 */ // Label 30750: @2281213
     /* 2281213 */ GIM_Reject,
     /* 2281214 */ // Label 30656: @2281214
     /* 2281214 */ GIM_Try, /*On fail goto*//*Label 30755*/ GIMT_Encode4(2281333),
     /* 2281219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2281222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2281225 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2281228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2281232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2281236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281240 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281244 */   GIM_Try, /*On fail goto*//*Label 30756*/ GIMT_Encode4(2281288), // Rule ID 52298 //
     /* 2281249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281252 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2281255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2281269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281278 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281287 */     // GIR_Coverage, 52298,
     /* 2281287 */     GIR_EraseRootFromParent_Done,
     /* 2281288 */   // Label 30756: @2281288
     /* 2281288 */   GIM_Try, /*On fail goto*//*Label 30757*/ GIMT_Encode4(2281332), // Rule ID 52299 //
     /* 2281293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281296 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2281299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2281313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281322 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281331 */     // GIR_Coverage, 52299,
     /* 2281331 */     GIR_EraseRootFromParent_Done,
     /* 2281332 */   // Label 30757: @2281332
     /* 2281332 */   GIM_Reject,
     /* 2281333 */ // Label 30755: @2281333
     /* 2281333 */ GIM_Reject,
     /* 2281334 */ // Label 30657: @2281334
     /* 2281334 */ GIM_Try, /*On fail goto*//*Label 30758*/ GIMT_Encode4(2281541),
     /* 2281339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2281342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2281345 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2281348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2281352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2281356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281360 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281364 */   GIM_Try, /*On fail goto*//*Label 30759*/ GIMT_Encode4(2281408), // Rule ID 52322 //
     /* 2281369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281372 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2281372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2281375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2281389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281398 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281407 */     // GIR_Coverage, 52322,
     /* 2281407 */     GIR_EraseRootFromParent_Done,
     /* 2281408 */   // Label 30759: @2281408
     /* 2281408 */   GIM_Try, /*On fail goto*//*Label 30760*/ GIMT_Encode4(2281452), // Rule ID 52323 //
     /* 2281413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281416 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2281416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2281419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2281433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281442 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281451 */     // GIR_Coverage, 52323,
     /* 2281451 */     GIR_EraseRootFromParent_Done,
     /* 2281452 */   // Label 30760: @2281452
     /* 2281452 */   GIM_Try, /*On fail goto*//*Label 30761*/ GIMT_Encode4(2281496), // Rule ID 58152 //
     /* 2281457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281460 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2281460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2281463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2281477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281486 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281495 */     // GIR_Coverage, 58152,
     /* 2281495 */     GIR_EraseRootFromParent_Done,
     /* 2281496 */   // Label 30761: @2281496
     /* 2281496 */   GIM_Try, /*On fail goto*//*Label 30762*/ GIMT_Encode4(2281540), // Rule ID 58153 //
     /* 2281501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281504 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2281504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2281507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2281521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281530 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281539 */     // GIR_Coverage, 58153,
     /* 2281539 */     GIR_EraseRootFromParent_Done,
     /* 2281540 */   // Label 30762: @2281540
     /* 2281540 */   GIM_Reject,
     /* 2281541 */ // Label 30758: @2281541
     /* 2281541 */ GIM_Reject,
     /* 2281542 */ // Label 30658: @2281542
     /* 2281542 */ GIM_Try, /*On fail goto*//*Label 30763*/ GIMT_Encode4(2281661),
     /* 2281547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /* 2281550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2281553 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2281556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2281560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2281564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281568 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281572 */   GIM_Try, /*On fail goto*//*Label 30764*/ GIMT_Encode4(2281616), // Rule ID 52304 //
     /* 2281577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281580 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2281583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2281597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281606 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281615 */     // GIR_Coverage, 52304,
     /* 2281615 */     GIR_EraseRootFromParent_Done,
     /* 2281616 */   // Label 30764: @2281616
     /* 2281616 */   GIM_Try, /*On fail goto*//*Label 30765*/ GIMT_Encode4(2281660), // Rule ID 52305 //
     /* 2281621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281624 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2281627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2281641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281650 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281659 */     // GIR_Coverage, 52305,
     /* 2281659 */     GIR_EraseRootFromParent_Done,
     /* 2281660 */   // Label 30765: @2281660
     /* 2281660 */   GIM_Reject,
     /* 2281661 */ // Label 30763: @2281661
     /* 2281661 */ GIM_Reject,
     /* 2281662 */ // Label 30659: @2281662
     /* 2281662 */ GIM_Reject,
     /* 2281663 */ // Label 51: @2281663
     /* 2281663 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30790*/ GIMT_Encode4(2284396),
     /* 2281674 */ /*GILLT_s32*//*Label 30766*/ GIMT_Encode4(2281798),
     /* 2281678 */ /*GILLT_s64*//*Label 30767*/ GIMT_Encode4(2281832), GIMT_Encode4(0),
     /* 2281686 */ /*GILLT_nxv1s8*//*Label 30768*/ GIMT_Encode4(2281866),
     /* 2281690 */ /*GILLT_nxv1s16*//*Label 30769*/ GIMT_Encode4(2281981),
     /* 2281694 */ /*GILLT_nxv1s32*//*Label 30770*/ GIMT_Encode4(2282096),
     /* 2281698 */ /*GILLT_nxv1s64*//*Label 30771*/ GIMT_Encode4(2282211), GIMT_Encode4(0),
     /* 2281706 */ /*GILLT_nxv2s8*//*Label 30772*/ GIMT_Encode4(2282326),
     /* 2281710 */ /*GILLT_nxv2s16*//*Label 30773*/ GIMT_Encode4(2282441),
     /* 2281714 */ /*GILLT_nxv2s32*//*Label 30774*/ GIMT_Encode4(2282556),
     /* 2281718 */ /*GILLT_nxv2s64*//*Label 30775*/ GIMT_Encode4(2282671), GIMT_Encode4(0),
     /* 2281726 */ /*GILLT_nxv4s8*//*Label 30776*/ GIMT_Encode4(2282786),
     /* 2281730 */ /*GILLT_nxv4s16*//*Label 30777*/ GIMT_Encode4(2282901),
     /* 2281734 */ /*GILLT_nxv4s32*//*Label 30778*/ GIMT_Encode4(2283016),
     /* 2281738 */ /*GILLT_nxv4s64*//*Label 30779*/ GIMT_Encode4(2283131), GIMT_Encode4(0),
     /* 2281746 */ /*GILLT_nxv8s8*//*Label 30780*/ GIMT_Encode4(2283246),
     /* 2281750 */ /*GILLT_nxv8s16*//*Label 30781*/ GIMT_Encode4(2283361),
     /* 2281754 */ /*GILLT_nxv8s32*//*Label 30782*/ GIMT_Encode4(2283476),
     /* 2281758 */ /*GILLT_nxv8s64*//*Label 30783*/ GIMT_Encode4(2283591), GIMT_Encode4(0),
     /* 2281766 */ /*GILLT_nxv16s8*//*Label 30784*/ GIMT_Encode4(2283706),
     /* 2281770 */ /*GILLT_nxv16s16*//*Label 30785*/ GIMT_Encode4(2283821),
     /* 2281774 */ /*GILLT_nxv16s32*//*Label 30786*/ GIMT_Encode4(2283936), GIMT_Encode4(0),
     /* 2281782 */ /*GILLT_nxv32s8*//*Label 30787*/ GIMT_Encode4(2284051),
     /* 2281786 */ /*GILLT_nxv32s16*//*Label 30788*/ GIMT_Encode4(2284166), GIMT_Encode4(0),
     /* 2281794 */ /*GILLT_nxv64s8*//*Label 30789*/ GIMT_Encode4(2284281),
     /* 2281798 */ // Label 30766: @2281798
     /* 2281798 */ GIM_Try, /*On fail goto*//*Label 30791*/ GIMT_Encode4(2281831), // Rule ID 296 //
     /* 2281803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2281806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2281809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2281812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281824 */   // (mulhu:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULHU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2281824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2281829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281830 */   // GIR_Coverage, 296,
     /* 2281830 */   GIR_Done,
     /* 2281831 */ // Label 30791: @2281831
     /* 2281831 */ GIM_Reject,
     /* 2281832 */ // Label 30767: @2281832
     /* 2281832 */ GIM_Try, /*On fail goto*//*Label 30792*/ GIMT_Encode4(2281865), // Rule ID 295 //
     /* 2281837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2281840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2281843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281858 */   // (mulhu:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULHU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2281858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2281863 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281864 */   // GIR_Coverage, 295,
     /* 2281864 */   GIR_Done,
     /* 2281865 */ // Label 30792: @2281865
     /* 2281865 */ GIM_Reject,
     /* 2281866 */ // Label 30768: @2281866
     /* 2281866 */ GIM_Try, /*On fail goto*//*Label 30793*/ GIMT_Encode4(2281980),
     /* 2281871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2281874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2281877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281889 */   GIM_Try, /*On fail goto*//*Label 30794*/ GIMT_Encode4(2281934), // Rule ID 51008 //
     /* 2281894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281897 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2281900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2281914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281933 */     // GIR_Coverage, 51008,
     /* 2281933 */     GIR_EraseRootFromParent_Done,
     /* 2281934 */   // Label 30794: @2281934
     /* 2281934 */   GIM_Try, /*On fail goto*//*Label 30795*/ GIMT_Encode4(2281979), // Rule ID 51009 //
     /* 2281939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281942 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2281945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2281959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281978 */     // GIR_Coverage, 51009,
     /* 2281978 */     GIR_EraseRootFromParent_Done,
     /* 2281979 */   // Label 30795: @2281979
     /* 2281979 */   GIM_Reject,
     /* 2281980 */ // Label 30793: @2281980
     /* 2281980 */ GIM_Reject,
     /* 2281981 */ // Label 30769: @2281981
     /* 2281981 */ GIM_Try, /*On fail goto*//*Label 30796*/ GIMT_Encode4(2282095),
     /* 2281986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2281989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2281992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282000 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282004 */   GIM_Try, /*On fail goto*//*Label 30797*/ GIMT_Encode4(2282049), // Rule ID 51020 //
     /* 2282009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282012 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2282015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2282029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282048 */     // GIR_Coverage, 51020,
     /* 2282048 */     GIR_EraseRootFromParent_Done,
     /* 2282049 */   // Label 30797: @2282049
     /* 2282049 */   GIM_Try, /*On fail goto*//*Label 30798*/ GIMT_Encode4(2282094), // Rule ID 51021 //
     /* 2282054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282057 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2282060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2282074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282093 */     // GIR_Coverage, 51021,
     /* 2282093 */     GIR_EraseRootFromParent_Done,
     /* 2282094 */   // Label 30798: @2282094
     /* 2282094 */   GIM_Reject,
     /* 2282095 */ // Label 30796: @2282095
     /* 2282095 */ GIM_Reject,
     /* 2282096 */ // Label 30770: @2282096
     /* 2282096 */ GIM_Try, /*On fail goto*//*Label 30799*/ GIMT_Encode4(2282210),
     /* 2282101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2282104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2282107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282119 */   GIM_Try, /*On fail goto*//*Label 30800*/ GIMT_Encode4(2282164), // Rule ID 51028 //
     /* 2282124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282127 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2282130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2282144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282163 */     // GIR_Coverage, 51028,
     /* 2282163 */     GIR_EraseRootFromParent_Done,
     /* 2282164 */   // Label 30800: @2282164
     /* 2282164 */   GIM_Try, /*On fail goto*//*Label 30801*/ GIMT_Encode4(2282209), // Rule ID 51029 //
     /* 2282169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282172 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2282175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2282189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282208 */     // GIR_Coverage, 51029,
     /* 2282208 */     GIR_EraseRootFromParent_Done,
     /* 2282209 */   // Label 30801: @2282209
     /* 2282209 */   GIM_Reject,
     /* 2282210 */ // Label 30799: @2282210
     /* 2282210 */ GIM_Reject,
     /* 2282211 */ // Label 30771: @2282211
     /* 2282211 */ GIM_Try, /*On fail goto*//*Label 30802*/ GIMT_Encode4(2282325),
     /* 2282216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2282219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2282222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282234 */   GIM_Try, /*On fail goto*//*Label 30803*/ GIMT_Encode4(2282279), // Rule ID 51096 //
     /* 2282239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2282242 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2282245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2282259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282278 */     // GIR_Coverage, 51096,
     /* 2282278 */     GIR_EraseRootFromParent_Done,
     /* 2282279 */   // Label 30803: @2282279
     /* 2282279 */   GIM_Try, /*On fail goto*//*Label 30804*/ GIMT_Encode4(2282324), // Rule ID 51097 //
     /* 2282284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2282287 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2282290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2282304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282323 */     // GIR_Coverage, 51097,
     /* 2282323 */     GIR_EraseRootFromParent_Done,
     /* 2282324 */   // Label 30804: @2282324
     /* 2282324 */   GIM_Reject,
     /* 2282325 */ // Label 30802: @2282325
     /* 2282325 */ GIM_Reject,
     /* 2282326 */ // Label 30772: @2282326
     /* 2282326 */ GIM_Try, /*On fail goto*//*Label 30805*/ GIMT_Encode4(2282440),
     /* 2282331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2282334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2282337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282349 */   GIM_Try, /*On fail goto*//*Label 30806*/ GIMT_Encode4(2282394), // Rule ID 51012 //
     /* 2282354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282357 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2282360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2282374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282393 */     // GIR_Coverage, 51012,
     /* 2282393 */     GIR_EraseRootFromParent_Done,
     /* 2282394 */   // Label 30806: @2282394
     /* 2282394 */   GIM_Try, /*On fail goto*//*Label 30807*/ GIMT_Encode4(2282439), // Rule ID 51013 //
     /* 2282399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282402 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2282405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2282419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282438 */     // GIR_Coverage, 51013,
     /* 2282438 */     GIR_EraseRootFromParent_Done,
     /* 2282439 */   // Label 30807: @2282439
     /* 2282439 */   GIM_Reject,
     /* 2282440 */ // Label 30805: @2282440
     /* 2282440 */ GIM_Reject,
     /* 2282441 */ // Label 30773: @2282441
     /* 2282441 */ GIM_Try, /*On fail goto*//*Label 30808*/ GIMT_Encode4(2282555),
     /* 2282446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2282449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2282452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282464 */   GIM_Try, /*On fail goto*//*Label 30809*/ GIMT_Encode4(2282509), // Rule ID 51024 //
     /* 2282469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282472 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2282475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2282489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282508 */     // GIR_Coverage, 51024,
     /* 2282508 */     GIR_EraseRootFromParent_Done,
     /* 2282509 */   // Label 30809: @2282509
     /* 2282509 */   GIM_Try, /*On fail goto*//*Label 30810*/ GIMT_Encode4(2282554), // Rule ID 51025 //
     /* 2282514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282517 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2282520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2282534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282553 */     // GIR_Coverage, 51025,
     /* 2282553 */     GIR_EraseRootFromParent_Done,
     /* 2282554 */   // Label 30810: @2282554
     /* 2282554 */   GIM_Reject,
     /* 2282555 */ // Label 30808: @2282555
     /* 2282555 */ GIM_Reject,
     /* 2282556 */ // Label 30774: @2282556
     /* 2282556 */ GIM_Try, /*On fail goto*//*Label 30811*/ GIMT_Encode4(2282670),
     /* 2282561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2282564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2282567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282579 */   GIM_Try, /*On fail goto*//*Label 30812*/ GIMT_Encode4(2282624), // Rule ID 51040 //
     /* 2282584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282587 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2282590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2282604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282623 */     // GIR_Coverage, 51040,
     /* 2282623 */     GIR_EraseRootFromParent_Done,
     /* 2282624 */   // Label 30812: @2282624
     /* 2282624 */   GIM_Try, /*On fail goto*//*Label 30813*/ GIMT_Encode4(2282669), // Rule ID 51041 //
     /* 2282629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282632 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2282635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2282649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282668 */     // GIR_Coverage, 51041,
     /* 2282668 */     GIR_EraseRootFromParent_Done,
     /* 2282669 */   // Label 30813: @2282669
     /* 2282669 */   GIM_Reject,
     /* 2282670 */ // Label 30811: @2282670
     /* 2282670 */ GIM_Reject,
     /* 2282671 */ // Label 30775: @2282671
     /* 2282671 */ GIM_Try, /*On fail goto*//*Label 30814*/ GIMT_Encode4(2282785),
     /* 2282676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2282679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2282682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282694 */   GIM_Try, /*On fail goto*//*Label 30815*/ GIMT_Encode4(2282739), // Rule ID 51100 //
     /* 2282699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2282702 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2282719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282738 */     // GIR_Coverage, 51100,
     /* 2282738 */     GIR_EraseRootFromParent_Done,
     /* 2282739 */   // Label 30815: @2282739
     /* 2282739 */   GIM_Try, /*On fail goto*//*Label 30816*/ GIMT_Encode4(2282784), // Rule ID 51101 //
     /* 2282744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2282747 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2282764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282783 */     // GIR_Coverage, 51101,
     /* 2282783 */     GIR_EraseRootFromParent_Done,
     /* 2282784 */   // Label 30816: @2282784
     /* 2282784 */   GIM_Reject,
     /* 2282785 */ // Label 30814: @2282785
     /* 2282785 */ GIM_Reject,
     /* 2282786 */ // Label 30776: @2282786
     /* 2282786 */ GIM_Try, /*On fail goto*//*Label 30817*/ GIMT_Encode4(2282900),
     /* 2282791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2282794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2282797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282809 */   GIM_Try, /*On fail goto*//*Label 30818*/ GIMT_Encode4(2282854), // Rule ID 51016 //
     /* 2282814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282817 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2282820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2282834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282853 */     // GIR_Coverage, 51016,
     /* 2282853 */     GIR_EraseRootFromParent_Done,
     /* 2282854 */   // Label 30818: @2282854
     /* 2282854 */   GIM_Try, /*On fail goto*//*Label 30819*/ GIMT_Encode4(2282899), // Rule ID 51017 //
     /* 2282859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282862 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2282865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2282879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282898 */     // GIR_Coverage, 51017,
     /* 2282898 */     GIR_EraseRootFromParent_Done,
     /* 2282899 */   // Label 30819: @2282899
     /* 2282899 */   GIM_Reject,
     /* 2282900 */ // Label 30817: @2282900
     /* 2282900 */ GIM_Reject,
     /* 2282901 */ // Label 30777: @2282901
     /* 2282901 */ GIM_Try, /*On fail goto*//*Label 30820*/ GIMT_Encode4(2283015),
     /* 2282906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2282909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2282912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282924 */   GIM_Try, /*On fail goto*//*Label 30821*/ GIMT_Encode4(2282969), // Rule ID 51036 //
     /* 2282929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282932 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2282935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2282949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282968 */     // GIR_Coverage, 51036,
     /* 2282968 */     GIR_EraseRootFromParent_Done,
     /* 2282969 */   // Label 30821: @2282969
     /* 2282969 */   GIM_Try, /*On fail goto*//*Label 30822*/ GIMT_Encode4(2283014), // Rule ID 51037 //
     /* 2282974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282977 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2282980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2282994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283013 */     // GIR_Coverage, 51037,
     /* 2283013 */     GIR_EraseRootFromParent_Done,
     /* 2283014 */   // Label 30822: @2283014
     /* 2283014 */   GIM_Reject,
     /* 2283015 */ // Label 30820: @2283015
     /* 2283015 */ GIM_Reject,
     /* 2283016 */ // Label 30778: @2283016
     /* 2283016 */ GIM_Try, /*On fail goto*//*Label 30823*/ GIMT_Encode4(2283130),
     /* 2283021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2283024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2283027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283039 */   GIM_Try, /*On fail goto*//*Label 30824*/ GIMT_Encode4(2283084), // Rule ID 51068 //
     /* 2283044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283047 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2283064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283083 */     // GIR_Coverage, 51068,
     /* 2283083 */     GIR_EraseRootFromParent_Done,
     /* 2283084 */   // Label 30824: @2283084
     /* 2283084 */   GIM_Try, /*On fail goto*//*Label 30825*/ GIMT_Encode4(2283129), // Rule ID 51069 //
     /* 2283089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283092 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2283109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283128 */     // GIR_Coverage, 51069,
     /* 2283128 */     GIR_EraseRootFromParent_Done,
     /* 2283129 */   // Label 30825: @2283129
     /* 2283129 */   GIM_Reject,
     /* 2283130 */ // Label 30823: @2283130
     /* 2283130 */ GIM_Reject,
     /* 2283131 */ // Label 30779: @2283131
     /* 2283131 */ GIM_Try, /*On fail goto*//*Label 30826*/ GIMT_Encode4(2283245),
     /* 2283136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2283139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2283142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283154 */   GIM_Try, /*On fail goto*//*Label 30827*/ GIMT_Encode4(2283199), // Rule ID 51104 //
     /* 2283159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2283162 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2283179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283198 */     // GIR_Coverage, 51104,
     /* 2283198 */     GIR_EraseRootFromParent_Done,
     /* 2283199 */   // Label 30827: @2283199
     /* 2283199 */   GIM_Try, /*On fail goto*//*Label 30828*/ GIMT_Encode4(2283244), // Rule ID 51105 //
     /* 2283204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2283207 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2283224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283243 */     // GIR_Coverage, 51105,
     /* 2283243 */     GIR_EraseRootFromParent_Done,
     /* 2283244 */   // Label 30828: @2283244
     /* 2283244 */   GIM_Reject,
     /* 2283245 */ // Label 30826: @2283245
     /* 2283245 */ GIM_Reject,
     /* 2283246 */ // Label 30780: @2283246
     /* 2283246 */ GIM_Try, /*On fail goto*//*Label 30829*/ GIMT_Encode4(2283360),
     /* 2283251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2283254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2283257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283269 */   GIM_Try, /*On fail goto*//*Label 30830*/ GIMT_Encode4(2283314), // Rule ID 51032 //
     /* 2283274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283277 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2283280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2283294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283313 */     // GIR_Coverage, 51032,
     /* 2283313 */     GIR_EraseRootFromParent_Done,
     /* 2283314 */   // Label 30830: @2283314
     /* 2283314 */   GIM_Try, /*On fail goto*//*Label 30831*/ GIMT_Encode4(2283359), // Rule ID 51033 //
     /* 2283319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283322 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2283325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2283339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283358 */     // GIR_Coverage, 51033,
     /* 2283358 */     GIR_EraseRootFromParent_Done,
     /* 2283359 */   // Label 30831: @2283359
     /* 2283359 */   GIM_Reject,
     /* 2283360 */ // Label 30829: @2283360
     /* 2283360 */ GIM_Reject,
     /* 2283361 */ // Label 30781: @2283361
     /* 2283361 */ GIM_Try, /*On fail goto*//*Label 30832*/ GIMT_Encode4(2283475),
     /* 2283366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2283369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2283372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283384 */   GIM_Try, /*On fail goto*//*Label 30833*/ GIMT_Encode4(2283429), // Rule ID 51056 //
     /* 2283389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283392 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2283395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2283409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283428 */     // GIR_Coverage, 51056,
     /* 2283428 */     GIR_EraseRootFromParent_Done,
     /* 2283429 */   // Label 30833: @2283429
     /* 2283429 */   GIM_Try, /*On fail goto*//*Label 30834*/ GIMT_Encode4(2283474), // Rule ID 51057 //
     /* 2283434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283437 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2283440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2283454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283473 */     // GIR_Coverage, 51057,
     /* 2283473 */     GIR_EraseRootFromParent_Done,
     /* 2283474 */   // Label 30834: @2283474
     /* 2283474 */   GIM_Reject,
     /* 2283475 */ // Label 30832: @2283475
     /* 2283475 */ GIM_Reject,
     /* 2283476 */ // Label 30782: @2283476
     /* 2283476 */ GIM_Try, /*On fail goto*//*Label 30835*/ GIMT_Encode4(2283590),
     /* 2283481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2283484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2283487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283499 */   GIM_Try, /*On fail goto*//*Label 30836*/ GIMT_Encode4(2283544), // Rule ID 51072 //
     /* 2283504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283507 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2283510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2283524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283543 */     // GIR_Coverage, 51072,
     /* 2283543 */     GIR_EraseRootFromParent_Done,
     /* 2283544 */   // Label 30836: @2283544
     /* 2283544 */   GIM_Try, /*On fail goto*//*Label 30837*/ GIMT_Encode4(2283589), // Rule ID 51073 //
     /* 2283549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283552 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2283555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2283569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283588 */     // GIR_Coverage, 51073,
     /* 2283588 */     GIR_EraseRootFromParent_Done,
     /* 2283589 */   // Label 30837: @2283589
     /* 2283589 */   GIM_Reject,
     /* 2283590 */ // Label 30835: @2283590
     /* 2283590 */ GIM_Reject,
     /* 2283591 */ // Label 30783: @2283591
     /* 2283591 */ GIM_Try, /*On fail goto*//*Label 30838*/ GIMT_Encode4(2283705),
     /* 2283596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2283599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2283602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283614 */   GIM_Try, /*On fail goto*//*Label 30839*/ GIMT_Encode4(2283659), // Rule ID 51108 //
     /* 2283619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2283622 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2283625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2283639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283658 */     // GIR_Coverage, 51108,
     /* 2283658 */     GIR_EraseRootFromParent_Done,
     /* 2283659 */   // Label 30839: @2283659
     /* 2283659 */   GIM_Try, /*On fail goto*//*Label 30840*/ GIMT_Encode4(2283704), // Rule ID 51109 //
     /* 2283664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2283667 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2283670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2283684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283703 */     // GIR_Coverage, 51109,
     /* 2283703 */     GIR_EraseRootFromParent_Done,
     /* 2283704 */   // Label 30840: @2283704
     /* 2283704 */   GIM_Reject,
     /* 2283705 */ // Label 30838: @2283705
     /* 2283705 */ GIM_Reject,
     /* 2283706 */ // Label 30784: @2283706
     /* 2283706 */ GIM_Try, /*On fail goto*//*Label 30841*/ GIMT_Encode4(2283820),
     /* 2283711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2283714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2283717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283729 */   GIM_Try, /*On fail goto*//*Label 30842*/ GIMT_Encode4(2283774), // Rule ID 51044 //
     /* 2283734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283737 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2283740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2283754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283773 */     // GIR_Coverage, 51044,
     /* 2283773 */     GIR_EraseRootFromParent_Done,
     /* 2283774 */   // Label 30842: @2283774
     /* 2283774 */   GIM_Try, /*On fail goto*//*Label 30843*/ GIMT_Encode4(2283819), // Rule ID 51045 //
     /* 2283779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283782 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2283785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2283799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283818 */     // GIR_Coverage, 51045,
     /* 2283818 */     GIR_EraseRootFromParent_Done,
     /* 2283819 */   // Label 30843: @2283819
     /* 2283819 */   GIM_Reject,
     /* 2283820 */ // Label 30841: @2283820
     /* 2283820 */ GIM_Reject,
     /* 2283821 */ // Label 30785: @2283821
     /* 2283821 */ GIM_Try, /*On fail goto*//*Label 30844*/ GIMT_Encode4(2283935),
     /* 2283826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2283829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2283832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283844 */   GIM_Try, /*On fail goto*//*Label 30845*/ GIMT_Encode4(2283889), // Rule ID 51060 //
     /* 2283849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283852 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2283855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2283869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283888 */     // GIR_Coverage, 51060,
     /* 2283888 */     GIR_EraseRootFromParent_Done,
     /* 2283889 */   // Label 30845: @2283889
     /* 2283889 */   GIM_Try, /*On fail goto*//*Label 30846*/ GIMT_Encode4(2283934), // Rule ID 51061 //
     /* 2283894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283897 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2283900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2283914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283933 */     // GIR_Coverage, 51061,
     /* 2283933 */     GIR_EraseRootFromParent_Done,
     /* 2283934 */   // Label 30846: @2283934
     /* 2283934 */   GIM_Reject,
     /* 2283935 */ // Label 30844: @2283935
     /* 2283935 */ GIM_Reject,
     /* 2283936 */ // Label 30786: @2283936
     /* 2283936 */ GIM_Try, /*On fail goto*//*Label 30847*/ GIMT_Encode4(2284050),
     /* 2283941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2283944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2283947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283959 */   GIM_Try, /*On fail goto*//*Label 30848*/ GIMT_Encode4(2284004), // Rule ID 51076 //
     /* 2283964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283967 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2283970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2283984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284003 */     // GIR_Coverage, 51076,
     /* 2284003 */     GIR_EraseRootFromParent_Done,
     /* 2284004 */   // Label 30848: @2284004
     /* 2284004 */   GIM_Try, /*On fail goto*//*Label 30849*/ GIMT_Encode4(2284049), // Rule ID 51077 //
     /* 2284009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284012 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2284029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284048 */     // GIR_Coverage, 51077,
     /* 2284048 */     GIR_EraseRootFromParent_Done,
     /* 2284049 */   // Label 30849: @2284049
     /* 2284049 */   GIM_Reject,
     /* 2284050 */ // Label 30847: @2284050
     /* 2284050 */ GIM_Reject,
     /* 2284051 */ // Label 30787: @2284051
     /* 2284051 */ GIM_Try, /*On fail goto*//*Label 30850*/ GIMT_Encode4(2284165),
     /* 2284056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2284059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2284062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284074 */   GIM_Try, /*On fail goto*//*Label 30851*/ GIMT_Encode4(2284119), // Rule ID 51048 //
     /* 2284079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284082 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2284085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2284099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284118 */     // GIR_Coverage, 51048,
     /* 2284118 */     GIR_EraseRootFromParent_Done,
     /* 2284119 */   // Label 30851: @2284119
     /* 2284119 */   GIM_Try, /*On fail goto*//*Label 30852*/ GIMT_Encode4(2284164), // Rule ID 51049 //
     /* 2284124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284127 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2284130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2284144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284163 */     // GIR_Coverage, 51049,
     /* 2284163 */     GIR_EraseRootFromParent_Done,
     /* 2284164 */   // Label 30852: @2284164
     /* 2284164 */   GIM_Reject,
     /* 2284165 */ // Label 30850: @2284165
     /* 2284165 */ GIM_Reject,
     /* 2284166 */ // Label 30788: @2284166
     /* 2284166 */ GIM_Try, /*On fail goto*//*Label 30853*/ GIMT_Encode4(2284280),
     /* 2284171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2284174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2284177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284189 */   GIM_Try, /*On fail goto*//*Label 30854*/ GIMT_Encode4(2284234), // Rule ID 51064 //
     /* 2284194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284197 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2284200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2284214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284233 */     // GIR_Coverage, 51064,
     /* 2284233 */     GIR_EraseRootFromParent_Done,
     /* 2284234 */   // Label 30854: @2284234
     /* 2284234 */   GIM_Try, /*On fail goto*//*Label 30855*/ GIMT_Encode4(2284279), // Rule ID 51065 //
     /* 2284239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284242 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2284245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2284259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284278 */     // GIR_Coverage, 51065,
     /* 2284278 */     GIR_EraseRootFromParent_Done,
     /* 2284279 */   // Label 30855: @2284279
     /* 2284279 */   GIM_Reject,
     /* 2284280 */ // Label 30853: @2284280
     /* 2284280 */ GIM_Reject,
     /* 2284281 */ // Label 30789: @2284281
     /* 2284281 */ GIM_Try, /*On fail goto*//*Label 30856*/ GIMT_Encode4(2284395),
     /* 2284286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2284289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2284292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284300 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284304 */   GIM_Try, /*On fail goto*//*Label 30857*/ GIMT_Encode4(2284349), // Rule ID 51052 //
     /* 2284309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284312 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2284315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2284329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284348 */     // GIR_Coverage, 51052,
     /* 2284348 */     GIR_EraseRootFromParent_Done,
     /* 2284349 */   // Label 30857: @2284349
     /* 2284349 */   GIM_Try, /*On fail goto*//*Label 30858*/ GIMT_Encode4(2284394), // Rule ID 51053 //
     /* 2284354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284357 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2284360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2284374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284393 */     // GIR_Coverage, 51053,
     /* 2284393 */     GIR_EraseRootFromParent_Done,
     /* 2284394 */   // Label 30858: @2284394
     /* 2284394 */   GIM_Reject,
     /* 2284395 */ // Label 30856: @2284395
     /* 2284395 */ GIM_Reject,
     /* 2284396 */ // Label 30790: @2284396
     /* 2284396 */ GIM_Reject,
     /* 2284397 */ // Label 52: @2284397
     /* 2284397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30883*/ GIMT_Encode4(2287130),
     /* 2284408 */ /*GILLT_s32*//*Label 30859*/ GIMT_Encode4(2284532),
     /* 2284412 */ /*GILLT_s64*//*Label 30860*/ GIMT_Encode4(2284566), GIMT_Encode4(0),
     /* 2284420 */ /*GILLT_nxv1s8*//*Label 30861*/ GIMT_Encode4(2284600),
     /* 2284424 */ /*GILLT_nxv1s16*//*Label 30862*/ GIMT_Encode4(2284715),
     /* 2284428 */ /*GILLT_nxv1s32*//*Label 30863*/ GIMT_Encode4(2284830),
     /* 2284432 */ /*GILLT_nxv1s64*//*Label 30864*/ GIMT_Encode4(2284945), GIMT_Encode4(0),
     /* 2284440 */ /*GILLT_nxv2s8*//*Label 30865*/ GIMT_Encode4(2285060),
     /* 2284444 */ /*GILLT_nxv2s16*//*Label 30866*/ GIMT_Encode4(2285175),
     /* 2284448 */ /*GILLT_nxv2s32*//*Label 30867*/ GIMT_Encode4(2285290),
     /* 2284452 */ /*GILLT_nxv2s64*//*Label 30868*/ GIMT_Encode4(2285405), GIMT_Encode4(0),
     /* 2284460 */ /*GILLT_nxv4s8*//*Label 30869*/ GIMT_Encode4(2285520),
     /* 2284464 */ /*GILLT_nxv4s16*//*Label 30870*/ GIMT_Encode4(2285635),
     /* 2284468 */ /*GILLT_nxv4s32*//*Label 30871*/ GIMT_Encode4(2285750),
     /* 2284472 */ /*GILLT_nxv4s64*//*Label 30872*/ GIMT_Encode4(2285865), GIMT_Encode4(0),
     /* 2284480 */ /*GILLT_nxv8s8*//*Label 30873*/ GIMT_Encode4(2285980),
     /* 2284484 */ /*GILLT_nxv8s16*//*Label 30874*/ GIMT_Encode4(2286095),
     /* 2284488 */ /*GILLT_nxv8s32*//*Label 30875*/ GIMT_Encode4(2286210),
     /* 2284492 */ /*GILLT_nxv8s64*//*Label 30876*/ GIMT_Encode4(2286325), GIMT_Encode4(0),
     /* 2284500 */ /*GILLT_nxv16s8*//*Label 30877*/ GIMT_Encode4(2286440),
     /* 2284504 */ /*GILLT_nxv16s16*//*Label 30878*/ GIMT_Encode4(2286555),
     /* 2284508 */ /*GILLT_nxv16s32*//*Label 30879*/ GIMT_Encode4(2286670), GIMT_Encode4(0),
     /* 2284516 */ /*GILLT_nxv32s8*//*Label 30880*/ GIMT_Encode4(2286785),
     /* 2284520 */ /*GILLT_nxv32s16*//*Label 30881*/ GIMT_Encode4(2286900), GIMT_Encode4(0),
     /* 2284528 */ /*GILLT_nxv64s8*//*Label 30882*/ GIMT_Encode4(2287015),
     /* 2284532 */ // Label 30859: @2284532
     /* 2284532 */ GIM_Try, /*On fail goto*//*Label 30884*/ GIMT_Encode4(2284565), // Rule ID 294 //
     /* 2284537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2284540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2284546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2284550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2284554 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2284558 */   // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2284558 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2284563 */   GIR_RootConstrainSelectedInstOperands,
     /* 2284564 */   // GIR_Coverage, 294,
     /* 2284564 */   GIR_Done,
     /* 2284565 */ // Label 30884: @2284565
     /* 2284565 */ GIM_Reject,
     /* 2284566 */ // Label 30860: @2284566
     /* 2284566 */ GIM_Try, /*On fail goto*//*Label 30885*/ GIMT_Encode4(2284599), // Rule ID 293 //
     /* 2284571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2284574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2284577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2284580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2284584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2284588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2284592 */   // (mulhs:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2284592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2284597 */   GIR_RootConstrainSelectedInstOperands,
     /* 2284598 */   // GIR_Coverage, 293,
     /* 2284598 */   GIR_Done,
     /* 2284599 */ // Label 30885: @2284599
     /* 2284599 */ GIM_Reject,
     /* 2284600 */ // Label 30861: @2284600
     /* 2284600 */ GIM_Try, /*On fail goto*//*Label 30886*/ GIMT_Encode4(2284714),
     /* 2284605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2284608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2284611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284623 */   GIM_Try, /*On fail goto*//*Label 30887*/ GIMT_Encode4(2284668), // Rule ID 50936 //
     /* 2284628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284631 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2284634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2284648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284667 */     // GIR_Coverage, 50936,
     /* 2284667 */     GIR_EraseRootFromParent_Done,
     /* 2284668 */   // Label 30887: @2284668
     /* 2284668 */   GIM_Try, /*On fail goto*//*Label 30888*/ GIMT_Encode4(2284713), // Rule ID 50937 //
     /* 2284673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284676 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2284679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2284693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284712 */     // GIR_Coverage, 50937,
     /* 2284712 */     GIR_EraseRootFromParent_Done,
     /* 2284713 */   // Label 30888: @2284713
     /* 2284713 */   GIM_Reject,
     /* 2284714 */ // Label 30886: @2284714
     /* 2284714 */ GIM_Reject,
     /* 2284715 */ // Label 30862: @2284715
     /* 2284715 */ GIM_Try, /*On fail goto*//*Label 30889*/ GIMT_Encode4(2284829),
     /* 2284720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2284723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2284726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284738 */   GIM_Try, /*On fail goto*//*Label 30890*/ GIMT_Encode4(2284783), // Rule ID 50948 //
     /* 2284743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284746 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2284749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2284763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284782 */     // GIR_Coverage, 50948,
     /* 2284782 */     GIR_EraseRootFromParent_Done,
     /* 2284783 */   // Label 30890: @2284783
     /* 2284783 */   GIM_Try, /*On fail goto*//*Label 30891*/ GIMT_Encode4(2284828), // Rule ID 50949 //
     /* 2284788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284791 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2284794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2284808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284827 */     // GIR_Coverage, 50949,
     /* 2284827 */     GIR_EraseRootFromParent_Done,
     /* 2284828 */   // Label 30891: @2284828
     /* 2284828 */   GIM_Reject,
     /* 2284829 */ // Label 30889: @2284829
     /* 2284829 */ GIM_Reject,
     /* 2284830 */ // Label 30863: @2284830
     /* 2284830 */ GIM_Try, /*On fail goto*//*Label 30892*/ GIMT_Encode4(2284944),
     /* 2284835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2284838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2284841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284853 */   GIM_Try, /*On fail goto*//*Label 30893*/ GIMT_Encode4(2284898), // Rule ID 50956 //
     /* 2284858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284861 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2284864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2284878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284897 */     // GIR_Coverage, 50956,
     /* 2284897 */     GIR_EraseRootFromParent_Done,
     /* 2284898 */   // Label 30893: @2284898
     /* 2284898 */   GIM_Try, /*On fail goto*//*Label 30894*/ GIMT_Encode4(2284943), // Rule ID 50957 //
     /* 2284903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284906 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2284909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2284923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284942 */     // GIR_Coverage, 50957,
     /* 2284942 */     GIR_EraseRootFromParent_Done,
     /* 2284943 */   // Label 30894: @2284943
     /* 2284943 */   GIM_Reject,
     /* 2284944 */ // Label 30892: @2284944
     /* 2284944 */ GIM_Reject,
     /* 2284945 */ // Label 30864: @2284945
     /* 2284945 */ GIM_Try, /*On fail goto*//*Label 30895*/ GIMT_Encode4(2285059),
     /* 2284950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2284953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2284956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284964 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284968 */   GIM_Try, /*On fail goto*//*Label 30896*/ GIMT_Encode4(2285013), // Rule ID 51080 //
     /* 2284973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2284976 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2284979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2284993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285012 */     // GIR_Coverage, 51080,
     /* 2285012 */     GIR_EraseRootFromParent_Done,
     /* 2285013 */   // Label 30896: @2285013
     /* 2285013 */   GIM_Try, /*On fail goto*//*Label 30897*/ GIMT_Encode4(2285058), // Rule ID 51081 //
     /* 2285018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2285021 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2285024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2285038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285057 */     // GIR_Coverage, 51081,
     /* 2285057 */     GIR_EraseRootFromParent_Done,
     /* 2285058 */   // Label 30897: @2285058
     /* 2285058 */   GIM_Reject,
     /* 2285059 */ // Label 30895: @2285059
     /* 2285059 */ GIM_Reject,
     /* 2285060 */ // Label 30865: @2285060
     /* 2285060 */ GIM_Try, /*On fail goto*//*Label 30898*/ GIMT_Encode4(2285174),
     /* 2285065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2285068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2285071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285083 */   GIM_Try, /*On fail goto*//*Label 30899*/ GIMT_Encode4(2285128), // Rule ID 50940 //
     /* 2285088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285091 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2285094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2285108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285127 */     // GIR_Coverage, 50940,
     /* 2285127 */     GIR_EraseRootFromParent_Done,
     /* 2285128 */   // Label 30899: @2285128
     /* 2285128 */   GIM_Try, /*On fail goto*//*Label 30900*/ GIMT_Encode4(2285173), // Rule ID 50941 //
     /* 2285133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285136 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2285139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2285153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285172 */     // GIR_Coverage, 50941,
     /* 2285172 */     GIR_EraseRootFromParent_Done,
     /* 2285173 */   // Label 30900: @2285173
     /* 2285173 */   GIM_Reject,
     /* 2285174 */ // Label 30898: @2285174
     /* 2285174 */ GIM_Reject,
     /* 2285175 */ // Label 30866: @2285175
     /* 2285175 */ GIM_Try, /*On fail goto*//*Label 30901*/ GIMT_Encode4(2285289),
     /* 2285180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2285183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2285186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285198 */   GIM_Try, /*On fail goto*//*Label 30902*/ GIMT_Encode4(2285243), // Rule ID 50952 //
     /* 2285203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285206 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2285209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2285223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285242 */     // GIR_Coverage, 50952,
     /* 2285242 */     GIR_EraseRootFromParent_Done,
     /* 2285243 */   // Label 30902: @2285243
     /* 2285243 */   GIM_Try, /*On fail goto*//*Label 30903*/ GIMT_Encode4(2285288), // Rule ID 50953 //
     /* 2285248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285251 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2285254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2285268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285287 */     // GIR_Coverage, 50953,
     /* 2285287 */     GIR_EraseRootFromParent_Done,
     /* 2285288 */   // Label 30903: @2285288
     /* 2285288 */   GIM_Reject,
     /* 2285289 */ // Label 30901: @2285289
     /* 2285289 */ GIM_Reject,
     /* 2285290 */ // Label 30867: @2285290
     /* 2285290 */ GIM_Try, /*On fail goto*//*Label 30904*/ GIMT_Encode4(2285404),
     /* 2285295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2285298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2285301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285313 */   GIM_Try, /*On fail goto*//*Label 30905*/ GIMT_Encode4(2285358), // Rule ID 50968 //
     /* 2285318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285321 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2285324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2285338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285357 */     // GIR_Coverage, 50968,
     /* 2285357 */     GIR_EraseRootFromParent_Done,
     /* 2285358 */   // Label 30905: @2285358
     /* 2285358 */   GIM_Try, /*On fail goto*//*Label 30906*/ GIMT_Encode4(2285403), // Rule ID 50969 //
     /* 2285363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285366 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2285369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2285383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285402 */     // GIR_Coverage, 50969,
     /* 2285402 */     GIR_EraseRootFromParent_Done,
     /* 2285403 */   // Label 30906: @2285403
     /* 2285403 */   GIM_Reject,
     /* 2285404 */ // Label 30904: @2285404
     /* 2285404 */ GIM_Reject,
     /* 2285405 */ // Label 30868: @2285405
     /* 2285405 */ GIM_Try, /*On fail goto*//*Label 30907*/ GIMT_Encode4(2285519),
     /* 2285410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2285413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2285416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2285420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2285424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2285428 */   GIM_Try, /*On fail goto*//*Label 30908*/ GIMT_Encode4(2285473), // Rule ID 51084 //
     /* 2285433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2285436 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2285439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2285453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285472 */     // GIR_Coverage, 51084,
     /* 2285472 */     GIR_EraseRootFromParent_Done,
     /* 2285473 */   // Label 30908: @2285473
     /* 2285473 */   GIM_Try, /*On fail goto*//*Label 30909*/ GIMT_Encode4(2285518), // Rule ID 51085 //
     /* 2285478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2285481 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2285484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2285498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285517 */     // GIR_Coverage, 51085,
     /* 2285517 */     GIR_EraseRootFromParent_Done,
     /* 2285518 */   // Label 30909: @2285518
     /* 2285518 */   GIM_Reject,
     /* 2285519 */ // Label 30907: @2285519
     /* 2285519 */ GIM_Reject,
     /* 2285520 */ // Label 30869: @2285520
     /* 2285520 */ GIM_Try, /*On fail goto*//*Label 30910*/ GIMT_Encode4(2285634),
     /* 2285525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2285528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2285531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285543 */   GIM_Try, /*On fail goto*//*Label 30911*/ GIMT_Encode4(2285588), // Rule ID 50944 //
     /* 2285548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285551 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2285554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2285568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285587 */     // GIR_Coverage, 50944,
     /* 2285587 */     GIR_EraseRootFromParent_Done,
     /* 2285588 */   // Label 30911: @2285588
     /* 2285588 */   GIM_Try, /*On fail goto*//*Label 30912*/ GIMT_Encode4(2285633), // Rule ID 50945 //
     /* 2285593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285596 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2285599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2285613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285632 */     // GIR_Coverage, 50945,
     /* 2285632 */     GIR_EraseRootFromParent_Done,
     /* 2285633 */   // Label 30912: @2285633
     /* 2285633 */   GIM_Reject,
     /* 2285634 */ // Label 30910: @2285634
     /* 2285634 */ GIM_Reject,
     /* 2285635 */ // Label 30870: @2285635
     /* 2285635 */ GIM_Try, /*On fail goto*//*Label 30913*/ GIMT_Encode4(2285749),
     /* 2285640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2285643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2285646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285658 */   GIM_Try, /*On fail goto*//*Label 30914*/ GIMT_Encode4(2285703), // Rule ID 50964 //
     /* 2285663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285666 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2285669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2285683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285702 */     // GIR_Coverage, 50964,
     /* 2285702 */     GIR_EraseRootFromParent_Done,
     /* 2285703 */   // Label 30914: @2285703
     /* 2285703 */   GIM_Try, /*On fail goto*//*Label 30915*/ GIMT_Encode4(2285748), // Rule ID 50965 //
     /* 2285708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285711 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2285714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2285728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285747 */     // GIR_Coverage, 50965,
     /* 2285747 */     GIR_EraseRootFromParent_Done,
     /* 2285748 */   // Label 30915: @2285748
     /* 2285748 */   GIM_Reject,
     /* 2285749 */ // Label 30913: @2285749
     /* 2285749 */ GIM_Reject,
     /* 2285750 */ // Label 30871: @2285750
     /* 2285750 */ GIM_Try, /*On fail goto*//*Label 30916*/ GIMT_Encode4(2285864),
     /* 2285755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2285758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2285761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2285765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2285769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2285773 */   GIM_Try, /*On fail goto*//*Label 30917*/ GIMT_Encode4(2285818), // Rule ID 50996 //
     /* 2285778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285781 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2285784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2285798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285817 */     // GIR_Coverage, 50996,
     /* 2285817 */     GIR_EraseRootFromParent_Done,
     /* 2285818 */   // Label 30917: @2285818
     /* 2285818 */   GIM_Try, /*On fail goto*//*Label 30918*/ GIMT_Encode4(2285863), // Rule ID 50997 //
     /* 2285823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285826 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2285829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2285843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285862 */     // GIR_Coverage, 50997,
     /* 2285862 */     GIR_EraseRootFromParent_Done,
     /* 2285863 */   // Label 30918: @2285863
     /* 2285863 */   GIM_Reject,
     /* 2285864 */ // Label 30916: @2285864
     /* 2285864 */ GIM_Reject,
     /* 2285865 */ // Label 30872: @2285865
     /* 2285865 */ GIM_Try, /*On fail goto*//*Label 30919*/ GIMT_Encode4(2285979),
     /* 2285870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2285873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2285876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2285880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2285884 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2285888 */   GIM_Try, /*On fail goto*//*Label 30920*/ GIMT_Encode4(2285933), // Rule ID 51088 //
     /* 2285893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2285896 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2285899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2285913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285932 */     // GIR_Coverage, 51088,
     /* 2285932 */     GIR_EraseRootFromParent_Done,
     /* 2285933 */   // Label 30920: @2285933
     /* 2285933 */   GIM_Try, /*On fail goto*//*Label 30921*/ GIMT_Encode4(2285978), // Rule ID 51089 //
     /* 2285938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2285941 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2285944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2285958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285977 */     // GIR_Coverage, 51089,
     /* 2285977 */     GIR_EraseRootFromParent_Done,
     /* 2285978 */   // Label 30921: @2285978
     /* 2285978 */   GIM_Reject,
     /* 2285979 */ // Label 30919: @2285979
     /* 2285979 */ GIM_Reject,
     /* 2285980 */ // Label 30873: @2285980
     /* 2285980 */ GIM_Try, /*On fail goto*//*Label 30922*/ GIMT_Encode4(2286094),
     /* 2285985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2285988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2285991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286003 */   GIM_Try, /*On fail goto*//*Label 30923*/ GIMT_Encode4(2286048), // Rule ID 50960 //
     /* 2286008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286011 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2286014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2286028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286047 */     // GIR_Coverage, 50960,
     /* 2286047 */     GIR_EraseRootFromParent_Done,
     /* 2286048 */   // Label 30923: @2286048
     /* 2286048 */   GIM_Try, /*On fail goto*//*Label 30924*/ GIMT_Encode4(2286093), // Rule ID 50961 //
     /* 2286053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286056 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2286059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2286073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286092 */     // GIR_Coverage, 50961,
     /* 2286092 */     GIR_EraseRootFromParent_Done,
     /* 2286093 */   // Label 30924: @2286093
     /* 2286093 */   GIM_Reject,
     /* 2286094 */ // Label 30922: @2286094
     /* 2286094 */ GIM_Reject,
     /* 2286095 */ // Label 30874: @2286095
     /* 2286095 */ GIM_Try, /*On fail goto*//*Label 30925*/ GIMT_Encode4(2286209),
     /* 2286100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2286103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2286106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286118 */   GIM_Try, /*On fail goto*//*Label 30926*/ GIMT_Encode4(2286163), // Rule ID 50984 //
     /* 2286123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286126 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2286129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2286143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286162 */     // GIR_Coverage, 50984,
     /* 2286162 */     GIR_EraseRootFromParent_Done,
     /* 2286163 */   // Label 30926: @2286163
     /* 2286163 */   GIM_Try, /*On fail goto*//*Label 30927*/ GIMT_Encode4(2286208), // Rule ID 50985 //
     /* 2286168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286171 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2286174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2286188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286207 */     // GIR_Coverage, 50985,
     /* 2286207 */     GIR_EraseRootFromParent_Done,
     /* 2286208 */   // Label 30927: @2286208
     /* 2286208 */   GIM_Reject,
     /* 2286209 */ // Label 30925: @2286209
     /* 2286209 */ GIM_Reject,
     /* 2286210 */ // Label 30875: @2286210
     /* 2286210 */ GIM_Try, /*On fail goto*//*Label 30928*/ GIMT_Encode4(2286324),
     /* 2286215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2286218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2286221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286233 */   GIM_Try, /*On fail goto*//*Label 30929*/ GIMT_Encode4(2286278), // Rule ID 51000 //
     /* 2286238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286241 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2286244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2286258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286277 */     // GIR_Coverage, 51000,
     /* 2286277 */     GIR_EraseRootFromParent_Done,
     /* 2286278 */   // Label 30929: @2286278
     /* 2286278 */   GIM_Try, /*On fail goto*//*Label 30930*/ GIMT_Encode4(2286323), // Rule ID 51001 //
     /* 2286283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286286 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2286289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2286303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286322 */     // GIR_Coverage, 51001,
     /* 2286322 */     GIR_EraseRootFromParent_Done,
     /* 2286323 */   // Label 30930: @2286323
     /* 2286323 */   GIM_Reject,
     /* 2286324 */ // Label 30928: @2286324
     /* 2286324 */ GIM_Reject,
     /* 2286325 */ // Label 30876: @2286325
     /* 2286325 */ GIM_Try, /*On fail goto*//*Label 30931*/ GIMT_Encode4(2286439),
     /* 2286330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2286333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2286336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2286340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2286344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2286348 */   GIM_Try, /*On fail goto*//*Label 30932*/ GIMT_Encode4(2286393), // Rule ID 51092 //
     /* 2286353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2286356 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2286359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2286373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286392 */     // GIR_Coverage, 51092,
     /* 2286392 */     GIR_EraseRootFromParent_Done,
     /* 2286393 */   // Label 30932: @2286393
     /* 2286393 */   GIM_Try, /*On fail goto*//*Label 30933*/ GIMT_Encode4(2286438), // Rule ID 51093 //
     /* 2286398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2286401 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2286404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2286418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286437 */     // GIR_Coverage, 51093,
     /* 2286437 */     GIR_EraseRootFromParent_Done,
     /* 2286438 */   // Label 30933: @2286438
     /* 2286438 */   GIM_Reject,
     /* 2286439 */ // Label 30931: @2286439
     /* 2286439 */ GIM_Reject,
     /* 2286440 */ // Label 30877: @2286440
     /* 2286440 */ GIM_Try, /*On fail goto*//*Label 30934*/ GIMT_Encode4(2286554),
     /* 2286445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2286448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2286451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286463 */   GIM_Try, /*On fail goto*//*Label 30935*/ GIMT_Encode4(2286508), // Rule ID 50972 //
     /* 2286468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286471 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2286474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2286488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286507 */     // GIR_Coverage, 50972,
     /* 2286507 */     GIR_EraseRootFromParent_Done,
     /* 2286508 */   // Label 30935: @2286508
     /* 2286508 */   GIM_Try, /*On fail goto*//*Label 30936*/ GIMT_Encode4(2286553), // Rule ID 50973 //
     /* 2286513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286516 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2286519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2286533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286552 */     // GIR_Coverage, 50973,
     /* 2286552 */     GIR_EraseRootFromParent_Done,
     /* 2286553 */   // Label 30936: @2286553
     /* 2286553 */   GIM_Reject,
     /* 2286554 */ // Label 30934: @2286554
     /* 2286554 */ GIM_Reject,
     /* 2286555 */ // Label 30878: @2286555
     /* 2286555 */ GIM_Try, /*On fail goto*//*Label 30937*/ GIMT_Encode4(2286669),
     /* 2286560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2286563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2286566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286578 */   GIM_Try, /*On fail goto*//*Label 30938*/ GIMT_Encode4(2286623), // Rule ID 50988 //
     /* 2286583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286586 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2286589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2286603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286622 */     // GIR_Coverage, 50988,
     /* 2286622 */     GIR_EraseRootFromParent_Done,
     /* 2286623 */   // Label 30938: @2286623
     /* 2286623 */   GIM_Try, /*On fail goto*//*Label 30939*/ GIMT_Encode4(2286668), // Rule ID 50989 //
     /* 2286628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286631 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2286634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2286648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286667 */     // GIR_Coverage, 50989,
     /* 2286667 */     GIR_EraseRootFromParent_Done,
     /* 2286668 */   // Label 30939: @2286668
     /* 2286668 */   GIM_Reject,
     /* 2286669 */ // Label 30937: @2286669
     /* 2286669 */ GIM_Reject,
     /* 2286670 */ // Label 30879: @2286670
     /* 2286670 */ GIM_Try, /*On fail goto*//*Label 30940*/ GIMT_Encode4(2286784),
     /* 2286675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2286678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2286681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2286685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2286689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2286693 */   GIM_Try, /*On fail goto*//*Label 30941*/ GIMT_Encode4(2286738), // Rule ID 51004 //
     /* 2286698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286701 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2286704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2286718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286737 */     // GIR_Coverage, 51004,
     /* 2286737 */     GIR_EraseRootFromParent_Done,
     /* 2286738 */   // Label 30941: @2286738
     /* 2286738 */   GIM_Try, /*On fail goto*//*Label 30942*/ GIMT_Encode4(2286783), // Rule ID 51005 //
     /* 2286743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286746 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2286749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2286763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286782 */     // GIR_Coverage, 51005,
     /* 2286782 */     GIR_EraseRootFromParent_Done,
     /* 2286783 */   // Label 30942: @2286783
     /* 2286783 */   GIM_Reject,
     /* 2286784 */ // Label 30940: @2286784
     /* 2286784 */ GIM_Reject,
     /* 2286785 */ // Label 30880: @2286785
     /* 2286785 */ GIM_Try, /*On fail goto*//*Label 30943*/ GIMT_Encode4(2286899),
     /* 2286790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2286793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2286796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286808 */   GIM_Try, /*On fail goto*//*Label 30944*/ GIMT_Encode4(2286853), // Rule ID 50976 //
     /* 2286813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286816 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2286819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2286833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286852 */     // GIR_Coverage, 50976,
     /* 2286852 */     GIR_EraseRootFromParent_Done,
     /* 2286853 */   // Label 30944: @2286853
     /* 2286853 */   GIM_Try, /*On fail goto*//*Label 30945*/ GIMT_Encode4(2286898), // Rule ID 50977 //
     /* 2286858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286861 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2286864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2286878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286897 */     // GIR_Coverage, 50977,
     /* 2286897 */     GIR_EraseRootFromParent_Done,
     /* 2286898 */   // Label 30945: @2286898
     /* 2286898 */   GIM_Reject,
     /* 2286899 */ // Label 30943: @2286899
     /* 2286899 */ GIM_Reject,
     /* 2286900 */ // Label 30881: @2286900
     /* 2286900 */ GIM_Try, /*On fail goto*//*Label 30946*/ GIMT_Encode4(2287014),
     /* 2286905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2286908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2286911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2286915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2286919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2286923 */   GIM_Try, /*On fail goto*//*Label 30947*/ GIMT_Encode4(2286968), // Rule ID 50992 //
     /* 2286928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286931 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2286934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2286948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286967 */     // GIR_Coverage, 50992,
     /* 2286967 */     GIR_EraseRootFromParent_Done,
     /* 2286968 */   // Label 30947: @2286968
     /* 2286968 */   GIM_Try, /*On fail goto*//*Label 30948*/ GIMT_Encode4(2287013), // Rule ID 50993 //
     /* 2286973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286976 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2286979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2286993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287012 */     // GIR_Coverage, 50993,
     /* 2287012 */     GIR_EraseRootFromParent_Done,
     /* 2287013 */   // Label 30948: @2287013
     /* 2287013 */   GIM_Reject,
     /* 2287014 */ // Label 30946: @2287014
     /* 2287014 */ GIM_Reject,
     /* 2287015 */ // Label 30882: @2287015
     /* 2287015 */ GIM_Try, /*On fail goto*//*Label 30949*/ GIMT_Encode4(2287129),
     /* 2287020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2287023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2287026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287038 */   GIM_Try, /*On fail goto*//*Label 30950*/ GIMT_Encode4(2287083), // Rule ID 50980 //
     /* 2287043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287046 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2287049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2287063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287082 */     // GIR_Coverage, 50980,
     /* 2287082 */     GIR_EraseRootFromParent_Done,
     /* 2287083 */   // Label 30950: @2287083
     /* 2287083 */   GIM_Try, /*On fail goto*//*Label 30951*/ GIMT_Encode4(2287128), // Rule ID 50981 //
     /* 2287088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287091 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2287094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2287108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287127 */     // GIR_Coverage, 50981,
     /* 2287127 */     GIR_EraseRootFromParent_Done,
     /* 2287128 */   // Label 30951: @2287128
     /* 2287128 */   GIM_Reject,
     /* 2287129 */ // Label 30949: @2287129
     /* 2287129 */ GIM_Reject,
     /* 2287130 */ // Label 30883: @2287130
     /* 2287130 */ GIM_Reject,
     /* 2287131 */ // Label 53: @2287131
     /* 2287131 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30975*/ GIMT_Encode4(2289983),
     /* 2287142 */ /*GILLT_s32*//*Label 30952*/ GIMT_Encode4(2287266), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2287154 */ /*GILLT_nxv1s8*//*Label 30953*/ GIMT_Encode4(2287321),
     /* 2287158 */ /*GILLT_nxv1s16*//*Label 30954*/ GIMT_Encode4(2287442),
     /* 2287162 */ /*GILLT_nxv1s32*//*Label 30955*/ GIMT_Encode4(2287563),
     /* 2287166 */ /*GILLT_nxv1s64*//*Label 30956*/ GIMT_Encode4(2287684), GIMT_Encode4(0),
     /* 2287174 */ /*GILLT_nxv2s8*//*Label 30957*/ GIMT_Encode4(2287805),
     /* 2287178 */ /*GILLT_nxv2s16*//*Label 30958*/ GIMT_Encode4(2287926),
     /* 2287182 */ /*GILLT_nxv2s32*//*Label 30959*/ GIMT_Encode4(2288047),
     /* 2287186 */ /*GILLT_nxv2s64*//*Label 30960*/ GIMT_Encode4(2288168), GIMT_Encode4(0),
     /* 2287194 */ /*GILLT_nxv4s8*//*Label 30961*/ GIMT_Encode4(2288289),
     /* 2287198 */ /*GILLT_nxv4s16*//*Label 30962*/ GIMT_Encode4(2288410),
     /* 2287202 */ /*GILLT_nxv4s32*//*Label 30963*/ GIMT_Encode4(2288531),
     /* 2287206 */ /*GILLT_nxv4s64*//*Label 30964*/ GIMT_Encode4(2288652), GIMT_Encode4(0),
     /* 2287214 */ /*GILLT_nxv8s8*//*Label 30965*/ GIMT_Encode4(2288773),
     /* 2287218 */ /*GILLT_nxv8s16*//*Label 30966*/ GIMT_Encode4(2288894),
     /* 2287222 */ /*GILLT_nxv8s32*//*Label 30967*/ GIMT_Encode4(2289015),
     /* 2287226 */ /*GILLT_nxv8s64*//*Label 30968*/ GIMT_Encode4(2289136), GIMT_Encode4(0),
     /* 2287234 */ /*GILLT_nxv16s8*//*Label 30969*/ GIMT_Encode4(2289257),
     /* 2287238 */ /*GILLT_nxv16s16*//*Label 30970*/ GIMT_Encode4(2289378),
     /* 2287242 */ /*GILLT_nxv16s32*//*Label 30971*/ GIMT_Encode4(2289499), GIMT_Encode4(0),
     /* 2287250 */ /*GILLT_nxv32s8*//*Label 30972*/ GIMT_Encode4(2289620),
     /* 2287254 */ /*GILLT_nxv32s16*//*Label 30973*/ GIMT_Encode4(2289741), GIMT_Encode4(0),
     /* 2287262 */ /*GILLT_nxv64s8*//*Label 30974*/ GIMT_Encode4(2289862),
     /* 2287266 */ // Label 30952: @2287266
     /* 2287266 */ GIM_Try, /*On fail goto*//*Label 30976*/ GIMT_Encode4(2287320),
     /* 2287271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2287274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2287277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2287281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2287285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2287289 */   GIM_Try, /*On fail goto*//*Label 30977*/ GIMT_Encode4(2287304), // Rule ID 64568 //
     /* 2287294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2287297 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2287297 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2287302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287303 */     // GIR_Coverage, 64568,
     /* 2287303 */     GIR_Done,
     /* 2287304 */   // Label 30977: @2287304
     /* 2287304 */   GIM_Try, /*On fail goto*//*Label 30978*/ GIMT_Encode4(2287319), // Rule ID 64569 //
     /* 2287309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2287312 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2287312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2287317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287318 */     // GIR_Coverage, 64569,
     /* 2287318 */     GIR_Done,
     /* 2287319 */   // Label 30978: @2287319
     /* 2287319 */   GIM_Reject,
     /* 2287320 */ // Label 30976: @2287320
     /* 2287320 */ GIM_Reject,
     /* 2287321 */ // Label 30953: @2287321
     /* 2287321 */ GIM_Try, /*On fail goto*//*Label 30979*/ GIMT_Encode4(2287441),
     /* 2287326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2287329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2287332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287344 */   GIM_Try, /*On fail goto*//*Label 30980*/ GIMT_Encode4(2287392), // Rule ID 52496 //
     /* 2287349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287352 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2287355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2287369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287391 */     // GIR_Coverage, 52496,
     /* 2287391 */     GIR_EraseRootFromParent_Done,
     /* 2287392 */   // Label 30980: @2287392
     /* 2287392 */   GIM_Try, /*On fail goto*//*Label 30981*/ GIMT_Encode4(2287440), // Rule ID 52497 //
     /* 2287397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287400 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2287403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2287417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287439 */     // GIR_Coverage, 52497,
     /* 2287439 */     GIR_EraseRootFromParent_Done,
     /* 2287440 */   // Label 30981: @2287440
     /* 2287440 */   GIM_Reject,
     /* 2287441 */ // Label 30979: @2287441
     /* 2287441 */ GIM_Reject,
     /* 2287442 */ // Label 30954: @2287442
     /* 2287442 */ GIM_Try, /*On fail goto*//*Label 30982*/ GIMT_Encode4(2287562),
     /* 2287447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2287450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2287453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287465 */   GIM_Try, /*On fail goto*//*Label 30983*/ GIMT_Encode4(2287513), // Rule ID 52508 //
     /* 2287470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287473 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2287476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2287490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287512 */     // GIR_Coverage, 52508,
     /* 2287512 */     GIR_EraseRootFromParent_Done,
     /* 2287513 */   // Label 30983: @2287513
     /* 2287513 */   GIM_Try, /*On fail goto*//*Label 30984*/ GIMT_Encode4(2287561), // Rule ID 52509 //
     /* 2287518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287521 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2287524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2287538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287560 */     // GIR_Coverage, 52509,
     /* 2287560 */     GIR_EraseRootFromParent_Done,
     /* 2287561 */   // Label 30984: @2287561
     /* 2287561 */   GIM_Reject,
     /* 2287562 */ // Label 30982: @2287562
     /* 2287562 */ GIM_Reject,
     /* 2287563 */ // Label 30955: @2287563
     /* 2287563 */ GIM_Try, /*On fail goto*//*Label 30985*/ GIMT_Encode4(2287683),
     /* 2287568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2287574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287586 */   GIM_Try, /*On fail goto*//*Label 30986*/ GIMT_Encode4(2287634), // Rule ID 52516 //
     /* 2287591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287594 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2287597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2287611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287633 */     // GIR_Coverage, 52516,
     /* 2287633 */     GIR_EraseRootFromParent_Done,
     /* 2287634 */   // Label 30986: @2287634
     /* 2287634 */   GIM_Try, /*On fail goto*//*Label 30987*/ GIMT_Encode4(2287682), // Rule ID 52517 //
     /* 2287639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287642 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2287645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2287659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287681 */     // GIR_Coverage, 52517,
     /* 2287681 */     GIR_EraseRootFromParent_Done,
     /* 2287682 */   // Label 30987: @2287682
     /* 2287682 */   GIM_Reject,
     /* 2287683 */ // Label 30985: @2287683
     /* 2287683 */ GIM_Reject,
     /* 2287684 */ // Label 30956: @2287684
     /* 2287684 */ GIM_Try, /*On fail goto*//*Label 30988*/ GIMT_Encode4(2287804),
     /* 2287689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2287692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2287695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287707 */   GIM_Try, /*On fail goto*//*Label 30989*/ GIMT_Encode4(2287755), // Rule ID 52532 //
     /* 2287712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2287715 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2287718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2287732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287754 */     // GIR_Coverage, 52532,
     /* 2287754 */     GIR_EraseRootFromParent_Done,
     /* 2287755 */   // Label 30989: @2287755
     /* 2287755 */   GIM_Try, /*On fail goto*//*Label 30990*/ GIMT_Encode4(2287803), // Rule ID 52533 //
     /* 2287760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2287763 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2287766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2287780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287802 */     // GIR_Coverage, 52533,
     /* 2287802 */     GIR_EraseRootFromParent_Done,
     /* 2287803 */   // Label 30990: @2287803
     /* 2287803 */   GIM_Reject,
     /* 2287804 */ // Label 30988: @2287804
     /* 2287804 */ GIM_Reject,
     /* 2287805 */ // Label 30957: @2287805
     /* 2287805 */ GIM_Try, /*On fail goto*//*Label 30991*/ GIMT_Encode4(2287925),
     /* 2287810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2287813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2287816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287828 */   GIM_Try, /*On fail goto*//*Label 30992*/ GIMT_Encode4(2287876), // Rule ID 52500 //
     /* 2287833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287836 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2287839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2287853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287875 */     // GIR_Coverage, 52500,
     /* 2287875 */     GIR_EraseRootFromParent_Done,
     /* 2287876 */   // Label 30992: @2287876
     /* 2287876 */   GIM_Try, /*On fail goto*//*Label 30993*/ GIMT_Encode4(2287924), // Rule ID 52501 //
     /* 2287881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287884 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2287887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2287901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287923 */     // GIR_Coverage, 52501,
     /* 2287923 */     GIR_EraseRootFromParent_Done,
     /* 2287924 */   // Label 30993: @2287924
     /* 2287924 */   GIM_Reject,
     /* 2287925 */ // Label 30991: @2287925
     /* 2287925 */ GIM_Reject,
     /* 2287926 */ // Label 30958: @2287926
     /* 2287926 */ GIM_Try, /*On fail goto*//*Label 30994*/ GIMT_Encode4(2288046),
     /* 2287931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2287934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2287937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287949 */   GIM_Try, /*On fail goto*//*Label 30995*/ GIMT_Encode4(2287997), // Rule ID 52512 //
     /* 2287954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287957 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2287960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2287974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287996 */     // GIR_Coverage, 52512,
     /* 2287996 */     GIR_EraseRootFromParent_Done,
     /* 2287997 */   // Label 30995: @2287997
     /* 2287997 */   GIM_Try, /*On fail goto*//*Label 30996*/ GIMT_Encode4(2288045), // Rule ID 52513 //
     /* 2288002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288005 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2288008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2288022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288044 */     // GIR_Coverage, 52513,
     /* 2288044 */     GIR_EraseRootFromParent_Done,
     /* 2288045 */   // Label 30996: @2288045
     /* 2288045 */   GIM_Reject,
     /* 2288046 */ // Label 30994: @2288046
     /* 2288046 */ GIM_Reject,
     /* 2288047 */ // Label 30959: @2288047
     /* 2288047 */ GIM_Try, /*On fail goto*//*Label 30997*/ GIMT_Encode4(2288167),
     /* 2288052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2288055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2288058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288070 */   GIM_Try, /*On fail goto*//*Label 30998*/ GIMT_Encode4(2288118), // Rule ID 52528 //
     /* 2288075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288078 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2288081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2288095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288117 */     // GIR_Coverage, 52528,
     /* 2288117 */     GIR_EraseRootFromParent_Done,
     /* 2288118 */   // Label 30998: @2288118
     /* 2288118 */   GIM_Try, /*On fail goto*//*Label 30999*/ GIMT_Encode4(2288166), // Rule ID 52529 //
     /* 2288123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288126 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2288129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2288143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288165 */     // GIR_Coverage, 52529,
     /* 2288165 */     GIR_EraseRootFromParent_Done,
     /* 2288166 */   // Label 30999: @2288166
     /* 2288166 */   GIM_Reject,
     /* 2288167 */ // Label 30997: @2288167
     /* 2288167 */ GIM_Reject,
     /* 2288168 */ // Label 30960: @2288168
     /* 2288168 */ GIM_Try, /*On fail goto*//*Label 31000*/ GIMT_Encode4(2288288),
     /* 2288173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2288176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2288179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288191 */   GIM_Try, /*On fail goto*//*Label 31001*/ GIMT_Encode4(2288239), // Rule ID 52572 //
     /* 2288196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2288199 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2288202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2288216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288238 */     // GIR_Coverage, 52572,
     /* 2288238 */     GIR_EraseRootFromParent_Done,
     /* 2288239 */   // Label 31001: @2288239
     /* 2288239 */   GIM_Try, /*On fail goto*//*Label 31002*/ GIMT_Encode4(2288287), // Rule ID 52573 //
     /* 2288244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2288247 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2288250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2288264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288286 */     // GIR_Coverage, 52573,
     /* 2288286 */     GIR_EraseRootFromParent_Done,
     /* 2288287 */   // Label 31002: @2288287
     /* 2288287 */   GIM_Reject,
     /* 2288288 */ // Label 31000: @2288288
     /* 2288288 */ GIM_Reject,
     /* 2288289 */ // Label 30961: @2288289
     /* 2288289 */ GIM_Try, /*On fail goto*//*Label 31003*/ GIMT_Encode4(2288409),
     /* 2288294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2288297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2288300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288312 */   GIM_Try, /*On fail goto*//*Label 31004*/ GIMT_Encode4(2288360), // Rule ID 52504 //
     /* 2288317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288320 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2288323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2288337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288359 */     // GIR_Coverage, 52504,
     /* 2288359 */     GIR_EraseRootFromParent_Done,
     /* 2288360 */   // Label 31004: @2288360
     /* 2288360 */   GIM_Try, /*On fail goto*//*Label 31005*/ GIMT_Encode4(2288408), // Rule ID 52505 //
     /* 2288365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288368 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2288371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2288385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288407 */     // GIR_Coverage, 52505,
     /* 2288407 */     GIR_EraseRootFromParent_Done,
     /* 2288408 */   // Label 31005: @2288408
     /* 2288408 */   GIM_Reject,
     /* 2288409 */ // Label 31003: @2288409
     /* 2288409 */ GIM_Reject,
     /* 2288410 */ // Label 30962: @2288410
     /* 2288410 */ GIM_Try, /*On fail goto*//*Label 31006*/ GIMT_Encode4(2288530),
     /* 2288415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2288418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2288421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288433 */   GIM_Try, /*On fail goto*//*Label 31007*/ GIMT_Encode4(2288481), // Rule ID 52524 //
     /* 2288438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288441 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2288444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2288458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288480 */     // GIR_Coverage, 52524,
     /* 2288480 */     GIR_EraseRootFromParent_Done,
     /* 2288481 */   // Label 31007: @2288481
     /* 2288481 */   GIM_Try, /*On fail goto*//*Label 31008*/ GIMT_Encode4(2288529), // Rule ID 52525 //
     /* 2288486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288489 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2288492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2288506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288528 */     // GIR_Coverage, 52525,
     /* 2288528 */     GIR_EraseRootFromParent_Done,
     /* 2288529 */   // Label 31008: @2288529
     /* 2288529 */   GIM_Reject,
     /* 2288530 */ // Label 31006: @2288530
     /* 2288530 */ GIM_Reject,
     /* 2288531 */ // Label 30963: @2288531
     /* 2288531 */ GIM_Try, /*On fail goto*//*Label 31009*/ GIMT_Encode4(2288651),
     /* 2288536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2288539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2288542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288554 */   GIM_Try, /*On fail goto*//*Label 31010*/ GIMT_Encode4(2288602), // Rule ID 52560 //
     /* 2288559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288562 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2288565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2288579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288601 */     // GIR_Coverage, 52560,
     /* 2288601 */     GIR_EraseRootFromParent_Done,
     /* 2288602 */   // Label 31010: @2288602
     /* 2288602 */   GIM_Try, /*On fail goto*//*Label 31011*/ GIMT_Encode4(2288650), // Rule ID 52561 //
     /* 2288607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288610 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2288613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2288627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288649 */     // GIR_Coverage, 52561,
     /* 2288649 */     GIR_EraseRootFromParent_Done,
     /* 2288650 */   // Label 31011: @2288650
     /* 2288650 */   GIM_Reject,
     /* 2288651 */ // Label 31009: @2288651
     /* 2288651 */ GIM_Reject,
     /* 2288652 */ // Label 30964: @2288652
     /* 2288652 */ GIM_Try, /*On fail goto*//*Label 31012*/ GIMT_Encode4(2288772),
     /* 2288657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2288660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2288663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2288667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2288671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2288675 */   GIM_Try, /*On fail goto*//*Label 31013*/ GIMT_Encode4(2288723), // Rule ID 52576 //
     /* 2288680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2288683 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2288686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2288700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288722 */     // GIR_Coverage, 52576,
     /* 2288722 */     GIR_EraseRootFromParent_Done,
     /* 2288723 */   // Label 31013: @2288723
     /* 2288723 */   GIM_Try, /*On fail goto*//*Label 31014*/ GIMT_Encode4(2288771), // Rule ID 52577 //
     /* 2288728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2288731 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2288734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2288748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288770 */     // GIR_Coverage, 52577,
     /* 2288770 */     GIR_EraseRootFromParent_Done,
     /* 2288771 */   // Label 31014: @2288771
     /* 2288771 */   GIM_Reject,
     /* 2288772 */ // Label 31012: @2288772
     /* 2288772 */ GIM_Reject,
     /* 2288773 */ // Label 30965: @2288773
     /* 2288773 */ GIM_Try, /*On fail goto*//*Label 31015*/ GIMT_Encode4(2288893),
     /* 2288778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2288781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2288784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288796 */   GIM_Try, /*On fail goto*//*Label 31016*/ GIMT_Encode4(2288844), // Rule ID 52520 //
     /* 2288801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288804 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2288807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2288821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288843 */     // GIR_Coverage, 52520,
     /* 2288843 */     GIR_EraseRootFromParent_Done,
     /* 2288844 */   // Label 31016: @2288844
     /* 2288844 */   GIM_Try, /*On fail goto*//*Label 31017*/ GIMT_Encode4(2288892), // Rule ID 52521 //
     /* 2288849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288852 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2288855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2288869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288891 */     // GIR_Coverage, 52521,
     /* 2288891 */     GIR_EraseRootFromParent_Done,
     /* 2288892 */   // Label 31017: @2288892
     /* 2288892 */   GIM_Reject,
     /* 2288893 */ // Label 31015: @2288893
     /* 2288893 */ GIM_Reject,
     /* 2288894 */ // Label 30966: @2288894
     /* 2288894 */ GIM_Try, /*On fail goto*//*Label 31018*/ GIMT_Encode4(2289014),
     /* 2288899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2288902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2288905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288917 */   GIM_Try, /*On fail goto*//*Label 31019*/ GIMT_Encode4(2288965), // Rule ID 52548 //
     /* 2288922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288925 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2288928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2288942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288964 */     // GIR_Coverage, 52548,
     /* 2288964 */     GIR_EraseRootFromParent_Done,
     /* 2288965 */   // Label 31019: @2288965
     /* 2288965 */   GIM_Try, /*On fail goto*//*Label 31020*/ GIMT_Encode4(2289013), // Rule ID 52549 //
     /* 2288970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288973 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2288976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2288990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289012 */     // GIR_Coverage, 52549,
     /* 2289012 */     GIR_EraseRootFromParent_Done,
     /* 2289013 */   // Label 31020: @2289013
     /* 2289013 */   GIM_Reject,
     /* 2289014 */ // Label 31018: @2289014
     /* 2289014 */ GIM_Reject,
     /* 2289015 */ // Label 30967: @2289015
     /* 2289015 */ GIM_Try, /*On fail goto*//*Label 31021*/ GIMT_Encode4(2289135),
     /* 2289020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2289023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2289026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289038 */   GIM_Try, /*On fail goto*//*Label 31022*/ GIMT_Encode4(2289086), // Rule ID 52564 //
     /* 2289043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289046 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2289049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2289063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289085 */     // GIR_Coverage, 52564,
     /* 2289085 */     GIR_EraseRootFromParent_Done,
     /* 2289086 */   // Label 31022: @2289086
     /* 2289086 */   GIM_Try, /*On fail goto*//*Label 31023*/ GIMT_Encode4(2289134), // Rule ID 52565 //
     /* 2289091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289094 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2289097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2289111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289133 */     // GIR_Coverage, 52565,
     /* 2289133 */     GIR_EraseRootFromParent_Done,
     /* 2289134 */   // Label 31023: @2289134
     /* 2289134 */   GIM_Reject,
     /* 2289135 */ // Label 31021: @2289135
     /* 2289135 */ GIM_Reject,
     /* 2289136 */ // Label 30968: @2289136
     /* 2289136 */ GIM_Try, /*On fail goto*//*Label 31024*/ GIMT_Encode4(2289256),
     /* 2289141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2289144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2289147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289159 */   GIM_Try, /*On fail goto*//*Label 31025*/ GIMT_Encode4(2289207), // Rule ID 52580 //
     /* 2289164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2289167 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2289170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2289184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289206 */     // GIR_Coverage, 52580,
     /* 2289206 */     GIR_EraseRootFromParent_Done,
     /* 2289207 */   // Label 31025: @2289207
     /* 2289207 */   GIM_Try, /*On fail goto*//*Label 31026*/ GIMT_Encode4(2289255), // Rule ID 52581 //
     /* 2289212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2289215 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2289218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2289232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289254 */     // GIR_Coverage, 52581,
     /* 2289254 */     GIR_EraseRootFromParent_Done,
     /* 2289255 */   // Label 31026: @2289255
     /* 2289255 */   GIM_Reject,
     /* 2289256 */ // Label 31024: @2289256
     /* 2289256 */ GIM_Reject,
     /* 2289257 */ // Label 30969: @2289257
     /* 2289257 */ GIM_Try, /*On fail goto*//*Label 31027*/ GIMT_Encode4(2289377),
     /* 2289262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2289265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2289268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289280 */   GIM_Try, /*On fail goto*//*Label 31028*/ GIMT_Encode4(2289328), // Rule ID 52536 //
     /* 2289285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289288 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2289291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2289305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289327 */     // GIR_Coverage, 52536,
     /* 2289327 */     GIR_EraseRootFromParent_Done,
     /* 2289328 */   // Label 31028: @2289328
     /* 2289328 */   GIM_Try, /*On fail goto*//*Label 31029*/ GIMT_Encode4(2289376), // Rule ID 52537 //
     /* 2289333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289336 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2289339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2289353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289375 */     // GIR_Coverage, 52537,
     /* 2289375 */     GIR_EraseRootFromParent_Done,
     /* 2289376 */   // Label 31029: @2289376
     /* 2289376 */   GIM_Reject,
     /* 2289377 */ // Label 31027: @2289377
     /* 2289377 */ GIM_Reject,
     /* 2289378 */ // Label 30970: @2289378
     /* 2289378 */ GIM_Try, /*On fail goto*//*Label 31030*/ GIMT_Encode4(2289498),
     /* 2289383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2289386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2289389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289401 */   GIM_Try, /*On fail goto*//*Label 31031*/ GIMT_Encode4(2289449), // Rule ID 52552 //
     /* 2289406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289409 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2289412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2289426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289448 */     // GIR_Coverage, 52552,
     /* 2289448 */     GIR_EraseRootFromParent_Done,
     /* 2289449 */   // Label 31031: @2289449
     /* 2289449 */   GIM_Try, /*On fail goto*//*Label 31032*/ GIMT_Encode4(2289497), // Rule ID 52553 //
     /* 2289454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289457 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2289460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2289474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289496 */     // GIR_Coverage, 52553,
     /* 2289496 */     GIR_EraseRootFromParent_Done,
     /* 2289497 */   // Label 31032: @2289497
     /* 2289497 */   GIM_Reject,
     /* 2289498 */ // Label 31030: @2289498
     /* 2289498 */ GIM_Reject,
     /* 2289499 */ // Label 30971: @2289499
     /* 2289499 */ GIM_Try, /*On fail goto*//*Label 31033*/ GIMT_Encode4(2289619),
     /* 2289504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2289507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2289510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289522 */   GIM_Try, /*On fail goto*//*Label 31034*/ GIMT_Encode4(2289570), // Rule ID 52568 //
     /* 2289527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289530 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2289533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2289547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289569 */     // GIR_Coverage, 52568,
     /* 2289569 */     GIR_EraseRootFromParent_Done,
     /* 2289570 */   // Label 31034: @2289570
     /* 2289570 */   GIM_Try, /*On fail goto*//*Label 31035*/ GIMT_Encode4(2289618), // Rule ID 52569 //
     /* 2289575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289578 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2289581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2289595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289617 */     // GIR_Coverage, 52569,
     /* 2289617 */     GIR_EraseRootFromParent_Done,
     /* 2289618 */   // Label 31035: @2289618
     /* 2289618 */   GIM_Reject,
     /* 2289619 */ // Label 31033: @2289619
     /* 2289619 */ GIM_Reject,
     /* 2289620 */ // Label 30972: @2289620
     /* 2289620 */ GIM_Try, /*On fail goto*//*Label 31036*/ GIMT_Encode4(2289740),
     /* 2289625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2289628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2289631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289643 */   GIM_Try, /*On fail goto*//*Label 31037*/ GIMT_Encode4(2289691), // Rule ID 52540 //
     /* 2289648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289651 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2289654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2289668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289690 */     // GIR_Coverage, 52540,
     /* 2289690 */     GIR_EraseRootFromParent_Done,
     /* 2289691 */   // Label 31037: @2289691
     /* 2289691 */   GIM_Try, /*On fail goto*//*Label 31038*/ GIMT_Encode4(2289739), // Rule ID 52541 //
     /* 2289696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289699 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2289702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2289716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289738 */     // GIR_Coverage, 52541,
     /* 2289738 */     GIR_EraseRootFromParent_Done,
     /* 2289739 */   // Label 31038: @2289739
     /* 2289739 */   GIM_Reject,
     /* 2289740 */ // Label 31036: @2289740
     /* 2289740 */ GIM_Reject,
     /* 2289741 */ // Label 30973: @2289741
     /* 2289741 */ GIM_Try, /*On fail goto*//*Label 31039*/ GIMT_Encode4(2289861),
     /* 2289746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2289749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2289752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289764 */   GIM_Try, /*On fail goto*//*Label 31040*/ GIMT_Encode4(2289812), // Rule ID 52556 //
     /* 2289769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289772 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2289775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2289789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289811 */     // GIR_Coverage, 52556,
     /* 2289811 */     GIR_EraseRootFromParent_Done,
     /* 2289812 */   // Label 31040: @2289812
     /* 2289812 */   GIM_Try, /*On fail goto*//*Label 31041*/ GIMT_Encode4(2289860), // Rule ID 52557 //
     /* 2289817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289820 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2289823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2289837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289859 */     // GIR_Coverage, 52557,
     /* 2289859 */     GIR_EraseRootFromParent_Done,
     /* 2289860 */   // Label 31041: @2289860
     /* 2289860 */   GIM_Reject,
     /* 2289861 */ // Label 31039: @2289861
     /* 2289861 */ GIM_Reject,
     /* 2289862 */ // Label 30974: @2289862
     /* 2289862 */ GIM_Try, /*On fail goto*//*Label 31042*/ GIMT_Encode4(2289982),
     /* 2289867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2289870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2289873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289885 */   GIM_Try, /*On fail goto*//*Label 31043*/ GIMT_Encode4(2289933), // Rule ID 52544 //
     /* 2289890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289893 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2289896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2289910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289932 */     // GIR_Coverage, 52544,
     /* 2289932 */     GIR_EraseRootFromParent_Done,
     /* 2289933 */   // Label 31043: @2289933
     /* 2289933 */   GIM_Try, /*On fail goto*//*Label 31044*/ GIMT_Encode4(2289981), // Rule ID 52545 //
     /* 2289938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289941 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2289944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2289958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289980 */     // GIR_Coverage, 52545,
     /* 2289980 */     GIR_EraseRootFromParent_Done,
     /* 2289981 */   // Label 31044: @2289981
     /* 2289981 */   GIM_Reject,
     /* 2289982 */ // Label 31042: @2289982
     /* 2289982 */ GIM_Reject,
     /* 2289983 */ // Label 30975: @2289983
     /* 2289983 */ GIM_Reject,
     /* 2289984 */ // Label 54: @2289984
     /* 2289984 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31068*/ GIMT_Encode4(2292836),
     /* 2289995 */ /*GILLT_s32*//*Label 31045*/ GIMT_Encode4(2290119), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2290007 */ /*GILLT_nxv1s8*//*Label 31046*/ GIMT_Encode4(2290174),
     /* 2290011 */ /*GILLT_nxv1s16*//*Label 31047*/ GIMT_Encode4(2290295),
     /* 2290015 */ /*GILLT_nxv1s32*//*Label 31048*/ GIMT_Encode4(2290416),
     /* 2290019 */ /*GILLT_nxv1s64*//*Label 31049*/ GIMT_Encode4(2290537), GIMT_Encode4(0),
     /* 2290027 */ /*GILLT_nxv2s8*//*Label 31050*/ GIMT_Encode4(2290658),
     /* 2290031 */ /*GILLT_nxv2s16*//*Label 31051*/ GIMT_Encode4(2290779),
     /* 2290035 */ /*GILLT_nxv2s32*//*Label 31052*/ GIMT_Encode4(2290900),
     /* 2290039 */ /*GILLT_nxv2s64*//*Label 31053*/ GIMT_Encode4(2291021), GIMT_Encode4(0),
     /* 2290047 */ /*GILLT_nxv4s8*//*Label 31054*/ GIMT_Encode4(2291142),
     /* 2290051 */ /*GILLT_nxv4s16*//*Label 31055*/ GIMT_Encode4(2291263),
     /* 2290055 */ /*GILLT_nxv4s32*//*Label 31056*/ GIMT_Encode4(2291384),
     /* 2290059 */ /*GILLT_nxv4s64*//*Label 31057*/ GIMT_Encode4(2291505), GIMT_Encode4(0),
     /* 2290067 */ /*GILLT_nxv8s8*//*Label 31058*/ GIMT_Encode4(2291626),
     /* 2290071 */ /*GILLT_nxv8s16*//*Label 31059*/ GIMT_Encode4(2291747),
     /* 2290075 */ /*GILLT_nxv8s32*//*Label 31060*/ GIMT_Encode4(2291868),
     /* 2290079 */ /*GILLT_nxv8s64*//*Label 31061*/ GIMT_Encode4(2291989), GIMT_Encode4(0),
     /* 2290087 */ /*GILLT_nxv16s8*//*Label 31062*/ GIMT_Encode4(2292110),
     /* 2290091 */ /*GILLT_nxv16s16*//*Label 31063*/ GIMT_Encode4(2292231),
     /* 2290095 */ /*GILLT_nxv16s32*//*Label 31064*/ GIMT_Encode4(2292352), GIMT_Encode4(0),
     /* 2290103 */ /*GILLT_nxv32s8*//*Label 31065*/ GIMT_Encode4(2292473),
     /* 2290107 */ /*GILLT_nxv32s16*//*Label 31066*/ GIMT_Encode4(2292594), GIMT_Encode4(0),
     /* 2290115 */ /*GILLT_nxv64s8*//*Label 31067*/ GIMT_Encode4(2292715),
     /* 2290119 */ // Label 31045: @2290119
     /* 2290119 */ GIM_Try, /*On fail goto*//*Label 31069*/ GIMT_Encode4(2290173),
     /* 2290124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2290130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290142 */   GIM_Try, /*On fail goto*//*Label 31070*/ GIMT_Encode4(2290157), // Rule ID 64566 //
     /* 2290147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2290150 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2290150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2290155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290156 */     // GIR_Coverage, 64566,
     /* 2290156 */     GIR_Done,
     /* 2290157 */   // Label 31070: @2290157
     /* 2290157 */   GIM_Try, /*On fail goto*//*Label 31071*/ GIMT_Encode4(2290172), // Rule ID 64567 //
     /* 2290162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2290165 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2290165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2290170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290171 */     // GIR_Coverage, 64567,
     /* 2290171 */     GIR_Done,
     /* 2290172 */   // Label 31071: @2290172
     /* 2290172 */   GIM_Reject,
     /* 2290173 */ // Label 31069: @2290173
     /* 2290173 */ GIM_Reject,
     /* 2290174 */ // Label 31046: @2290174
     /* 2290174 */ GIM_Try, /*On fail goto*//*Label 31072*/ GIMT_Encode4(2290294),
     /* 2290179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2290182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2290185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290197 */   GIM_Try, /*On fail goto*//*Label 31073*/ GIMT_Encode4(2290245), // Rule ID 52364 //
     /* 2290202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290205 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2290208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2290222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290244 */     // GIR_Coverage, 52364,
     /* 2290244 */     GIR_EraseRootFromParent_Done,
     /* 2290245 */   // Label 31073: @2290245
     /* 2290245 */   GIM_Try, /*On fail goto*//*Label 31074*/ GIMT_Encode4(2290293), // Rule ID 52365 //
     /* 2290250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290253 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2290256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2290270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290292 */     // GIR_Coverage, 52365,
     /* 2290292 */     GIR_EraseRootFromParent_Done,
     /* 2290293 */   // Label 31074: @2290293
     /* 2290293 */   GIM_Reject,
     /* 2290294 */ // Label 31072: @2290294
     /* 2290294 */ GIM_Reject,
     /* 2290295 */ // Label 31047: @2290295
     /* 2290295 */ GIM_Try, /*On fail goto*//*Label 31075*/ GIMT_Encode4(2290415),
     /* 2290300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2290303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2290306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290318 */   GIM_Try, /*On fail goto*//*Label 31076*/ GIMT_Encode4(2290366), // Rule ID 52376 //
     /* 2290323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290326 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2290329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2290343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290365 */     // GIR_Coverage, 52376,
     /* 2290365 */     GIR_EraseRootFromParent_Done,
     /* 2290366 */   // Label 31076: @2290366
     /* 2290366 */   GIM_Try, /*On fail goto*//*Label 31077*/ GIMT_Encode4(2290414), // Rule ID 52377 //
     /* 2290371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290374 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2290377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2290391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290413 */     // GIR_Coverage, 52377,
     /* 2290413 */     GIR_EraseRootFromParent_Done,
     /* 2290414 */   // Label 31077: @2290414
     /* 2290414 */   GIM_Reject,
     /* 2290415 */ // Label 31075: @2290415
     /* 2290415 */ GIM_Reject,
     /* 2290416 */ // Label 31048: @2290416
     /* 2290416 */ GIM_Try, /*On fail goto*//*Label 31078*/ GIMT_Encode4(2290536),
     /* 2290421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2290424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2290427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290439 */   GIM_Try, /*On fail goto*//*Label 31079*/ GIMT_Encode4(2290487), // Rule ID 52384 //
     /* 2290444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290447 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2290450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2290464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290486 */     // GIR_Coverage, 52384,
     /* 2290486 */     GIR_EraseRootFromParent_Done,
     /* 2290487 */   // Label 31079: @2290487
     /* 2290487 */   GIM_Try, /*On fail goto*//*Label 31080*/ GIMT_Encode4(2290535), // Rule ID 52385 //
     /* 2290492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290495 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2290498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2290512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290534 */     // GIR_Coverage, 52385,
     /* 2290534 */     GIR_EraseRootFromParent_Done,
     /* 2290535 */   // Label 31080: @2290535
     /* 2290535 */   GIM_Reject,
     /* 2290536 */ // Label 31078: @2290536
     /* 2290536 */ GIM_Reject,
     /* 2290537 */ // Label 31049: @2290537
     /* 2290537 */ GIM_Try, /*On fail goto*//*Label 31081*/ GIMT_Encode4(2290657),
     /* 2290542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2290545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2290548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290560 */   GIM_Try, /*On fail goto*//*Label 31082*/ GIMT_Encode4(2290608), // Rule ID 52400 //
     /* 2290565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2290568 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2290571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2290585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290607 */     // GIR_Coverage, 52400,
     /* 2290607 */     GIR_EraseRootFromParent_Done,
     /* 2290608 */   // Label 31082: @2290608
     /* 2290608 */   GIM_Try, /*On fail goto*//*Label 31083*/ GIMT_Encode4(2290656), // Rule ID 52401 //
     /* 2290613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2290616 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2290619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2290633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290655 */     // GIR_Coverage, 52401,
     /* 2290655 */     GIR_EraseRootFromParent_Done,
     /* 2290656 */   // Label 31083: @2290656
     /* 2290656 */   GIM_Reject,
     /* 2290657 */ // Label 31081: @2290657
     /* 2290657 */ GIM_Reject,
     /* 2290658 */ // Label 31050: @2290658
     /* 2290658 */ GIM_Try, /*On fail goto*//*Label 31084*/ GIMT_Encode4(2290778),
     /* 2290663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2290666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2290669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290681 */   GIM_Try, /*On fail goto*//*Label 31085*/ GIMT_Encode4(2290729), // Rule ID 52368 //
     /* 2290686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290689 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2290692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2290706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290728 */     // GIR_Coverage, 52368,
     /* 2290728 */     GIR_EraseRootFromParent_Done,
     /* 2290729 */   // Label 31085: @2290729
     /* 2290729 */   GIM_Try, /*On fail goto*//*Label 31086*/ GIMT_Encode4(2290777), // Rule ID 52369 //
     /* 2290734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290737 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2290740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2290754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290776 */     // GIR_Coverage, 52369,
     /* 2290776 */     GIR_EraseRootFromParent_Done,
     /* 2290777 */   // Label 31086: @2290777
     /* 2290777 */   GIM_Reject,
     /* 2290778 */ // Label 31084: @2290778
     /* 2290778 */ GIM_Reject,
     /* 2290779 */ // Label 31051: @2290779
     /* 2290779 */ GIM_Try, /*On fail goto*//*Label 31087*/ GIMT_Encode4(2290899),
     /* 2290784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2290787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2290790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290802 */   GIM_Try, /*On fail goto*//*Label 31088*/ GIMT_Encode4(2290850), // Rule ID 52380 //
     /* 2290807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290810 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2290813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2290827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290849 */     // GIR_Coverage, 52380,
     /* 2290849 */     GIR_EraseRootFromParent_Done,
     /* 2290850 */   // Label 31088: @2290850
     /* 2290850 */   GIM_Try, /*On fail goto*//*Label 31089*/ GIMT_Encode4(2290898), // Rule ID 52381 //
     /* 2290855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290858 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2290861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2290875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290897 */     // GIR_Coverage, 52381,
     /* 2290897 */     GIR_EraseRootFromParent_Done,
     /* 2290898 */   // Label 31089: @2290898
     /* 2290898 */   GIM_Reject,
     /* 2290899 */ // Label 31087: @2290899
     /* 2290899 */ GIM_Reject,
     /* 2290900 */ // Label 31052: @2290900
     /* 2290900 */ GIM_Try, /*On fail goto*//*Label 31090*/ GIMT_Encode4(2291020),
     /* 2290905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2290908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2290911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290923 */   GIM_Try, /*On fail goto*//*Label 31091*/ GIMT_Encode4(2290971), // Rule ID 52396 //
     /* 2290928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290931 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2290934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2290948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290966 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290970 */     // GIR_Coverage, 52396,
     /* 2290970 */     GIR_EraseRootFromParent_Done,
     /* 2290971 */   // Label 31091: @2290971
     /* 2290971 */   GIM_Try, /*On fail goto*//*Label 31092*/ GIMT_Encode4(2291019), // Rule ID 52397 //
     /* 2290976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290979 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2290982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2290996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291018 */     // GIR_Coverage, 52397,
     /* 2291018 */     GIR_EraseRootFromParent_Done,
     /* 2291019 */   // Label 31092: @2291019
     /* 2291019 */   GIM_Reject,
     /* 2291020 */ // Label 31090: @2291020
     /* 2291020 */ GIM_Reject,
     /* 2291021 */ // Label 31053: @2291021
     /* 2291021 */ GIM_Try, /*On fail goto*//*Label 31093*/ GIMT_Encode4(2291141),
     /* 2291026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2291029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2291032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291044 */   GIM_Try, /*On fail goto*//*Label 31094*/ GIMT_Encode4(2291092), // Rule ID 52440 //
     /* 2291049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2291052 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2291055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2291069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291091 */     // GIR_Coverage, 52440,
     /* 2291091 */     GIR_EraseRootFromParent_Done,
     /* 2291092 */   // Label 31094: @2291092
     /* 2291092 */   GIM_Try, /*On fail goto*//*Label 31095*/ GIMT_Encode4(2291140), // Rule ID 52441 //
     /* 2291097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2291100 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2291103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2291117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291139 */     // GIR_Coverage, 52441,
     /* 2291139 */     GIR_EraseRootFromParent_Done,
     /* 2291140 */   // Label 31095: @2291140
     /* 2291140 */   GIM_Reject,
     /* 2291141 */ // Label 31093: @2291141
     /* 2291141 */ GIM_Reject,
     /* 2291142 */ // Label 31054: @2291142
     /* 2291142 */ GIM_Try, /*On fail goto*//*Label 31096*/ GIMT_Encode4(2291262),
     /* 2291147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2291150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2291153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291165 */   GIM_Try, /*On fail goto*//*Label 31097*/ GIMT_Encode4(2291213), // Rule ID 52372 //
     /* 2291170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291173 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2291176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2291190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291212 */     // GIR_Coverage, 52372,
     /* 2291212 */     GIR_EraseRootFromParent_Done,
     /* 2291213 */   // Label 31097: @2291213
     /* 2291213 */   GIM_Try, /*On fail goto*//*Label 31098*/ GIMT_Encode4(2291261), // Rule ID 52373 //
     /* 2291218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291221 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2291224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2291238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291260 */     // GIR_Coverage, 52373,
     /* 2291260 */     GIR_EraseRootFromParent_Done,
     /* 2291261 */   // Label 31098: @2291261
     /* 2291261 */   GIM_Reject,
     /* 2291262 */ // Label 31096: @2291262
     /* 2291262 */ GIM_Reject,
     /* 2291263 */ // Label 31055: @2291263
     /* 2291263 */ GIM_Try, /*On fail goto*//*Label 31099*/ GIMT_Encode4(2291383),
     /* 2291268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2291274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291286 */   GIM_Try, /*On fail goto*//*Label 31100*/ GIMT_Encode4(2291334), // Rule ID 52392 //
     /* 2291291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291294 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2291297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2291311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291333 */     // GIR_Coverage, 52392,
     /* 2291333 */     GIR_EraseRootFromParent_Done,
     /* 2291334 */   // Label 31100: @2291334
     /* 2291334 */   GIM_Try, /*On fail goto*//*Label 31101*/ GIMT_Encode4(2291382), // Rule ID 52393 //
     /* 2291339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291342 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2291345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2291359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291377 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291381 */     // GIR_Coverage, 52393,
     /* 2291381 */     GIR_EraseRootFromParent_Done,
     /* 2291382 */   // Label 31101: @2291382
     /* 2291382 */   GIM_Reject,
     /* 2291383 */ // Label 31099: @2291383
     /* 2291383 */ GIM_Reject,
     /* 2291384 */ // Label 31056: @2291384
     /* 2291384 */ GIM_Try, /*On fail goto*//*Label 31102*/ GIMT_Encode4(2291504),
     /* 2291389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2291392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2291395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291407 */   GIM_Try, /*On fail goto*//*Label 31103*/ GIMT_Encode4(2291455), // Rule ID 52428 //
     /* 2291412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291415 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2291418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2291432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291454 */     // GIR_Coverage, 52428,
     /* 2291454 */     GIR_EraseRootFromParent_Done,
     /* 2291455 */   // Label 31103: @2291455
     /* 2291455 */   GIM_Try, /*On fail goto*//*Label 31104*/ GIMT_Encode4(2291503), // Rule ID 52429 //
     /* 2291460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291463 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2291466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2291480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291502 */     // GIR_Coverage, 52429,
     /* 2291502 */     GIR_EraseRootFromParent_Done,
     /* 2291503 */   // Label 31104: @2291503
     /* 2291503 */   GIM_Reject,
     /* 2291504 */ // Label 31102: @2291504
     /* 2291504 */ GIM_Reject,
     /* 2291505 */ // Label 31057: @2291505
     /* 2291505 */ GIM_Try, /*On fail goto*//*Label 31105*/ GIMT_Encode4(2291625),
     /* 2291510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2291513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2291516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291528 */   GIM_Try, /*On fail goto*//*Label 31106*/ GIMT_Encode4(2291576), // Rule ID 52444 //
     /* 2291533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2291536 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2291539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2291553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291575 */     // GIR_Coverage, 52444,
     /* 2291575 */     GIR_EraseRootFromParent_Done,
     /* 2291576 */   // Label 31106: @2291576
     /* 2291576 */   GIM_Try, /*On fail goto*//*Label 31107*/ GIMT_Encode4(2291624), // Rule ID 52445 //
     /* 2291581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2291584 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2291587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2291601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291623 */     // GIR_Coverage, 52445,
     /* 2291623 */     GIR_EraseRootFromParent_Done,
     /* 2291624 */   // Label 31107: @2291624
     /* 2291624 */   GIM_Reject,
     /* 2291625 */ // Label 31105: @2291625
     /* 2291625 */ GIM_Reject,
     /* 2291626 */ // Label 31058: @2291626
     /* 2291626 */ GIM_Try, /*On fail goto*//*Label 31108*/ GIMT_Encode4(2291746),
     /* 2291631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2291634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2291637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291649 */   GIM_Try, /*On fail goto*//*Label 31109*/ GIMT_Encode4(2291697), // Rule ID 52388 //
     /* 2291654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291657 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2291660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2291674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291696 */     // GIR_Coverage, 52388,
     /* 2291696 */     GIR_EraseRootFromParent_Done,
     /* 2291697 */   // Label 31109: @2291697
     /* 2291697 */   GIM_Try, /*On fail goto*//*Label 31110*/ GIMT_Encode4(2291745), // Rule ID 52389 //
     /* 2291702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291705 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2291708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2291722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291744 */     // GIR_Coverage, 52389,
     /* 2291744 */     GIR_EraseRootFromParent_Done,
     /* 2291745 */   // Label 31110: @2291745
     /* 2291745 */   GIM_Reject,
     /* 2291746 */ // Label 31108: @2291746
     /* 2291746 */ GIM_Reject,
     /* 2291747 */ // Label 31059: @2291747
     /* 2291747 */ GIM_Try, /*On fail goto*//*Label 31111*/ GIMT_Encode4(2291867),
     /* 2291752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2291755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2291758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291770 */   GIM_Try, /*On fail goto*//*Label 31112*/ GIMT_Encode4(2291818), // Rule ID 52416 //
     /* 2291775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291778 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2291781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2291795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291817 */     // GIR_Coverage, 52416,
     /* 2291817 */     GIR_EraseRootFromParent_Done,
     /* 2291818 */   // Label 31112: @2291818
     /* 2291818 */   GIM_Try, /*On fail goto*//*Label 31113*/ GIMT_Encode4(2291866), // Rule ID 52417 //
     /* 2291823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291826 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2291829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2291843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291865 */     // GIR_Coverage, 52417,
     /* 2291865 */     GIR_EraseRootFromParent_Done,
     /* 2291866 */   // Label 31113: @2291866
     /* 2291866 */   GIM_Reject,
     /* 2291867 */ // Label 31111: @2291867
     /* 2291867 */ GIM_Reject,
     /* 2291868 */ // Label 31060: @2291868
     /* 2291868 */ GIM_Try, /*On fail goto*//*Label 31114*/ GIMT_Encode4(2291988),
     /* 2291873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2291876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2291879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291891 */   GIM_Try, /*On fail goto*//*Label 31115*/ GIMT_Encode4(2291939), // Rule ID 52432 //
     /* 2291896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291899 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2291902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2291916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291938 */     // GIR_Coverage, 52432,
     /* 2291938 */     GIR_EraseRootFromParent_Done,
     /* 2291939 */   // Label 31115: @2291939
     /* 2291939 */   GIM_Try, /*On fail goto*//*Label 31116*/ GIMT_Encode4(2291987), // Rule ID 52433 //
     /* 2291944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291947 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2291950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2291964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291986 */     // GIR_Coverage, 52433,
     /* 2291986 */     GIR_EraseRootFromParent_Done,
     /* 2291987 */   // Label 31116: @2291987
     /* 2291987 */   GIM_Reject,
     /* 2291988 */ // Label 31114: @2291988
     /* 2291988 */ GIM_Reject,
     /* 2291989 */ // Label 31061: @2291989
     /* 2291989 */ GIM_Try, /*On fail goto*//*Label 31117*/ GIMT_Encode4(2292109),
     /* 2291994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2291997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2292000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292012 */   GIM_Try, /*On fail goto*//*Label 31118*/ GIMT_Encode4(2292060), // Rule ID 52448 //
     /* 2292017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2292020 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2292023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2292037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292059 */     // GIR_Coverage, 52448,
     /* 2292059 */     GIR_EraseRootFromParent_Done,
     /* 2292060 */   // Label 31118: @2292060
     /* 2292060 */   GIM_Try, /*On fail goto*//*Label 31119*/ GIMT_Encode4(2292108), // Rule ID 52449 //
     /* 2292065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2292068 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2292071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2292085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292107 */     // GIR_Coverage, 52449,
     /* 2292107 */     GIR_EraseRootFromParent_Done,
     /* 2292108 */   // Label 31119: @2292108
     /* 2292108 */   GIM_Reject,
     /* 2292109 */ // Label 31117: @2292109
     /* 2292109 */ GIM_Reject,
     /* 2292110 */ // Label 31062: @2292110
     /* 2292110 */ GIM_Try, /*On fail goto*//*Label 31120*/ GIMT_Encode4(2292230),
     /* 2292115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2292118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2292121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292133 */   GIM_Try, /*On fail goto*//*Label 31121*/ GIMT_Encode4(2292181), // Rule ID 52404 //
     /* 2292138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292141 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2292144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2292158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292180 */     // GIR_Coverage, 52404,
     /* 2292180 */     GIR_EraseRootFromParent_Done,
     /* 2292181 */   // Label 31121: @2292181
     /* 2292181 */   GIM_Try, /*On fail goto*//*Label 31122*/ GIMT_Encode4(2292229), // Rule ID 52405 //
     /* 2292186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292189 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2292192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2292206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292228 */     // GIR_Coverage, 52405,
     /* 2292228 */     GIR_EraseRootFromParent_Done,
     /* 2292229 */   // Label 31122: @2292229
     /* 2292229 */   GIM_Reject,
     /* 2292230 */ // Label 31120: @2292230
     /* 2292230 */ GIM_Reject,
     /* 2292231 */ // Label 31063: @2292231
     /* 2292231 */ GIM_Try, /*On fail goto*//*Label 31123*/ GIMT_Encode4(2292351),
     /* 2292236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2292239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2292242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292254 */   GIM_Try, /*On fail goto*//*Label 31124*/ GIMT_Encode4(2292302), // Rule ID 52420 //
     /* 2292259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292262 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2292265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2292279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292301 */     // GIR_Coverage, 52420,
     /* 2292301 */     GIR_EraseRootFromParent_Done,
     /* 2292302 */   // Label 31124: @2292302
     /* 2292302 */   GIM_Try, /*On fail goto*//*Label 31125*/ GIMT_Encode4(2292350), // Rule ID 52421 //
     /* 2292307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292310 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2292313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2292327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292349 */     // GIR_Coverage, 52421,
     /* 2292349 */     GIR_EraseRootFromParent_Done,
     /* 2292350 */   // Label 31125: @2292350
     /* 2292350 */   GIM_Reject,
     /* 2292351 */ // Label 31123: @2292351
     /* 2292351 */ GIM_Reject,
     /* 2292352 */ // Label 31064: @2292352
     /* 2292352 */ GIM_Try, /*On fail goto*//*Label 31126*/ GIMT_Encode4(2292472),
     /* 2292357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2292360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2292363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292375 */   GIM_Try, /*On fail goto*//*Label 31127*/ GIMT_Encode4(2292423), // Rule ID 52436 //
     /* 2292380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292383 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2292386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2292400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292422 */     // GIR_Coverage, 52436,
     /* 2292422 */     GIR_EraseRootFromParent_Done,
     /* 2292423 */   // Label 31127: @2292423
     /* 2292423 */   GIM_Try, /*On fail goto*//*Label 31128*/ GIMT_Encode4(2292471), // Rule ID 52437 //
     /* 2292428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292431 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2292434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2292448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292470 */     // GIR_Coverage, 52437,
     /* 2292470 */     GIR_EraseRootFromParent_Done,
     /* 2292471 */   // Label 31128: @2292471
     /* 2292471 */   GIM_Reject,
     /* 2292472 */ // Label 31126: @2292472
     /* 2292472 */ GIM_Reject,
     /* 2292473 */ // Label 31065: @2292473
     /* 2292473 */ GIM_Try, /*On fail goto*//*Label 31129*/ GIMT_Encode4(2292593),
     /* 2292478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2292481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2292484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292496 */   GIM_Try, /*On fail goto*//*Label 31130*/ GIMT_Encode4(2292544), // Rule ID 52408 //
     /* 2292501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292504 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2292507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2292521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292543 */     // GIR_Coverage, 52408,
     /* 2292543 */     GIR_EraseRootFromParent_Done,
     /* 2292544 */   // Label 31130: @2292544
     /* 2292544 */   GIM_Try, /*On fail goto*//*Label 31131*/ GIMT_Encode4(2292592), // Rule ID 52409 //
     /* 2292549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292552 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2292555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2292569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292591 */     // GIR_Coverage, 52409,
     /* 2292591 */     GIR_EraseRootFromParent_Done,
     /* 2292592 */   // Label 31131: @2292592
     /* 2292592 */   GIM_Reject,
     /* 2292593 */ // Label 31129: @2292593
     /* 2292593 */ GIM_Reject,
     /* 2292594 */ // Label 31066: @2292594
     /* 2292594 */ GIM_Try, /*On fail goto*//*Label 31132*/ GIMT_Encode4(2292714),
     /* 2292599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2292602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2292605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292617 */   GIM_Try, /*On fail goto*//*Label 31133*/ GIMT_Encode4(2292665), // Rule ID 52424 //
     /* 2292622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292625 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2292628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2292642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292664 */     // GIR_Coverage, 52424,
     /* 2292664 */     GIR_EraseRootFromParent_Done,
     /* 2292665 */   // Label 31133: @2292665
     /* 2292665 */   GIM_Try, /*On fail goto*//*Label 31134*/ GIMT_Encode4(2292713), // Rule ID 52425 //
     /* 2292670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292673 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2292676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2292690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292712 */     // GIR_Coverage, 52425,
     /* 2292712 */     GIR_EraseRootFromParent_Done,
     /* 2292713 */   // Label 31134: @2292713
     /* 2292713 */   GIM_Reject,
     /* 2292714 */ // Label 31132: @2292714
     /* 2292714 */ GIM_Reject,
     /* 2292715 */ // Label 31067: @2292715
     /* 2292715 */ GIM_Try, /*On fail goto*//*Label 31135*/ GIMT_Encode4(2292835),
     /* 2292720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2292723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2292726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292738 */   GIM_Try, /*On fail goto*//*Label 31136*/ GIMT_Encode4(2292786), // Rule ID 52412 //
     /* 2292743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292746 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2292749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2292763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292785 */     // GIR_Coverage, 52412,
     /* 2292785 */     GIR_EraseRootFromParent_Done,
     /* 2292786 */   // Label 31136: @2292786
     /* 2292786 */   GIM_Try, /*On fail goto*//*Label 31137*/ GIMT_Encode4(2292834), // Rule ID 52413 //
     /* 2292791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292794 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2292797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2292811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292833 */     // GIR_Coverage, 52413,
     /* 2292833 */     GIR_EraseRootFromParent_Done,
     /* 2292834 */   // Label 31137: @2292834
     /* 2292834 */   GIM_Reject,
     /* 2292835 */ // Label 31135: @2292835
     /* 2292835 */ GIM_Reject,
     /* 2292836 */ // Label 31068: @2292836
     /* 2292836 */ GIM_Reject,
     /* 2292837 */ // Label 55: @2292837
     /* 2292837 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31161*/ GIMT_Encode4(2295689),
     /* 2292848 */ /*GILLT_s32*//*Label 31138*/ GIMT_Encode4(2292972), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2292860 */ /*GILLT_nxv1s8*//*Label 31139*/ GIMT_Encode4(2293027),
     /* 2292864 */ /*GILLT_nxv1s16*//*Label 31140*/ GIMT_Encode4(2293148),
     /* 2292868 */ /*GILLT_nxv1s32*//*Label 31141*/ GIMT_Encode4(2293269),
     /* 2292872 */ /*GILLT_nxv1s64*//*Label 31142*/ GIMT_Encode4(2293390), GIMT_Encode4(0),
     /* 2292880 */ /*GILLT_nxv2s8*//*Label 31143*/ GIMT_Encode4(2293511),
     /* 2292884 */ /*GILLT_nxv2s16*//*Label 31144*/ GIMT_Encode4(2293632),
     /* 2292888 */ /*GILLT_nxv2s32*//*Label 31145*/ GIMT_Encode4(2293753),
     /* 2292892 */ /*GILLT_nxv2s64*//*Label 31146*/ GIMT_Encode4(2293874), GIMT_Encode4(0),
     /* 2292900 */ /*GILLT_nxv4s8*//*Label 31147*/ GIMT_Encode4(2293995),
     /* 2292904 */ /*GILLT_nxv4s16*//*Label 31148*/ GIMT_Encode4(2294116),
     /* 2292908 */ /*GILLT_nxv4s32*//*Label 31149*/ GIMT_Encode4(2294237),
     /* 2292912 */ /*GILLT_nxv4s64*//*Label 31150*/ GIMT_Encode4(2294358), GIMT_Encode4(0),
     /* 2292920 */ /*GILLT_nxv8s8*//*Label 31151*/ GIMT_Encode4(2294479),
     /* 2292924 */ /*GILLT_nxv8s16*//*Label 31152*/ GIMT_Encode4(2294600),
     /* 2292928 */ /*GILLT_nxv8s32*//*Label 31153*/ GIMT_Encode4(2294721),
     /* 2292932 */ /*GILLT_nxv8s64*//*Label 31154*/ GIMT_Encode4(2294842), GIMT_Encode4(0),
     /* 2292940 */ /*GILLT_nxv16s8*//*Label 31155*/ GIMT_Encode4(2294963),
     /* 2292944 */ /*GILLT_nxv16s16*//*Label 31156*/ GIMT_Encode4(2295084),
     /* 2292948 */ /*GILLT_nxv16s32*//*Label 31157*/ GIMT_Encode4(2295205), GIMT_Encode4(0),
     /* 2292956 */ /*GILLT_nxv32s8*//*Label 31158*/ GIMT_Encode4(2295326),
     /* 2292960 */ /*GILLT_nxv32s16*//*Label 31159*/ GIMT_Encode4(2295447), GIMT_Encode4(0),
     /* 2292968 */ /*GILLT_nxv64s8*//*Label 31160*/ GIMT_Encode4(2295568),
     /* 2292972 */ // Label 31138: @2292972
     /* 2292972 */ GIM_Try, /*On fail goto*//*Label 31162*/ GIMT_Encode4(2293026),
     /* 2292977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2292980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2292983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2292987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2292991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2292995 */   GIM_Try, /*On fail goto*//*Label 31163*/ GIMT_Encode4(2293010), // Rule ID 64572 //
     /* 2293000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2293003 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2293003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2293008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293009 */     // GIR_Coverage, 64572,
     /* 2293009 */     GIR_Done,
     /* 2293010 */   // Label 31163: @2293010
     /* 2293010 */   GIM_Try, /*On fail goto*//*Label 31164*/ GIMT_Encode4(2293025), // Rule ID 64573 //
     /* 2293015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2293018 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2293018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2293023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293024 */     // GIR_Coverage, 64573,
     /* 2293024 */     GIR_Done,
     /* 2293025 */   // Label 31164: @2293025
     /* 2293025 */   GIM_Reject,
     /* 2293026 */ // Label 31162: @2293026
     /* 2293026 */ GIM_Reject,
     /* 2293027 */ // Label 31139: @2293027
     /* 2293027 */ GIM_Try, /*On fail goto*//*Label 31165*/ GIMT_Encode4(2293147),
     /* 2293032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2293035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2293038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293050 */   GIM_Try, /*On fail goto*//*Label 31166*/ GIMT_Encode4(2293098), // Rule ID 52716 //
     /* 2293055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293058 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2293061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2293075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293097 */     // GIR_Coverage, 52716,
     /* 2293097 */     GIR_EraseRootFromParent_Done,
     /* 2293098 */   // Label 31166: @2293098
     /* 2293098 */   GIM_Try, /*On fail goto*//*Label 31167*/ GIMT_Encode4(2293146), // Rule ID 52717 //
     /* 2293103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293106 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2293109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2293123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293145 */     // GIR_Coverage, 52717,
     /* 2293145 */     GIR_EraseRootFromParent_Done,
     /* 2293146 */   // Label 31167: @2293146
     /* 2293146 */   GIM_Reject,
     /* 2293147 */ // Label 31165: @2293147
     /* 2293147 */ GIM_Reject,
     /* 2293148 */ // Label 31140: @2293148
     /* 2293148 */ GIM_Try, /*On fail goto*//*Label 31168*/ GIMT_Encode4(2293268),
     /* 2293153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2293159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293167 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293171 */   GIM_Try, /*On fail goto*//*Label 31169*/ GIMT_Encode4(2293219), // Rule ID 52728 //
     /* 2293176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293179 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2293182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2293196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293218 */     // GIR_Coverage, 52728,
     /* 2293218 */     GIR_EraseRootFromParent_Done,
     /* 2293219 */   // Label 31169: @2293219
     /* 2293219 */   GIM_Try, /*On fail goto*//*Label 31170*/ GIMT_Encode4(2293267), // Rule ID 52729 //
     /* 2293224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293227 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2293230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2293244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293266 */     // GIR_Coverage, 52729,
     /* 2293266 */     GIR_EraseRootFromParent_Done,
     /* 2293267 */   // Label 31170: @2293267
     /* 2293267 */   GIM_Reject,
     /* 2293268 */ // Label 31168: @2293268
     /* 2293268 */ GIM_Reject,
     /* 2293269 */ // Label 31141: @2293269
     /* 2293269 */ GIM_Try, /*On fail goto*//*Label 31171*/ GIMT_Encode4(2293389),
     /* 2293274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2293277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2293280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293292 */   GIM_Try, /*On fail goto*//*Label 31172*/ GIMT_Encode4(2293340), // Rule ID 52736 //
     /* 2293297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293300 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2293303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2293317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293339 */     // GIR_Coverage, 52736,
     /* 2293339 */     GIR_EraseRootFromParent_Done,
     /* 2293340 */   // Label 31172: @2293340
     /* 2293340 */   GIM_Try, /*On fail goto*//*Label 31173*/ GIMT_Encode4(2293388), // Rule ID 52737 //
     /* 2293345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293348 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2293351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2293365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293387 */     // GIR_Coverage, 52737,
     /* 2293387 */     GIR_EraseRootFromParent_Done,
     /* 2293388 */   // Label 31173: @2293388
     /* 2293388 */   GIM_Reject,
     /* 2293389 */ // Label 31171: @2293389
     /* 2293389 */ GIM_Reject,
     /* 2293390 */ // Label 31142: @2293390
     /* 2293390 */ GIM_Try, /*On fail goto*//*Label 31174*/ GIMT_Encode4(2293510),
     /* 2293395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2293398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2293401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293413 */   GIM_Try, /*On fail goto*//*Label 31175*/ GIMT_Encode4(2293461), // Rule ID 52752 //
     /* 2293418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2293421 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2293424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2293438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293460 */     // GIR_Coverage, 52752,
     /* 2293460 */     GIR_EraseRootFromParent_Done,
     /* 2293461 */   // Label 31175: @2293461
     /* 2293461 */   GIM_Try, /*On fail goto*//*Label 31176*/ GIMT_Encode4(2293509), // Rule ID 52753 //
     /* 2293466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2293469 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2293472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2293486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293508 */     // GIR_Coverage, 52753,
     /* 2293508 */     GIR_EraseRootFromParent_Done,
     /* 2293509 */   // Label 31176: @2293509
     /* 2293509 */   GIM_Reject,
     /* 2293510 */ // Label 31174: @2293510
     /* 2293510 */ GIM_Reject,
     /* 2293511 */ // Label 31143: @2293511
     /* 2293511 */ GIM_Try, /*On fail goto*//*Label 31177*/ GIMT_Encode4(2293631),
     /* 2293516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2293519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2293522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293534 */   GIM_Try, /*On fail goto*//*Label 31178*/ GIMT_Encode4(2293582), // Rule ID 52720 //
     /* 2293539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293542 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2293545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2293559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293581 */     // GIR_Coverage, 52720,
     /* 2293581 */     GIR_EraseRootFromParent_Done,
     /* 2293582 */   // Label 31178: @2293582
     /* 2293582 */   GIM_Try, /*On fail goto*//*Label 31179*/ GIMT_Encode4(2293630), // Rule ID 52721 //
     /* 2293587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293590 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2293593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2293607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293629 */     // GIR_Coverage, 52721,
     /* 2293629 */     GIR_EraseRootFromParent_Done,
     /* 2293630 */   // Label 31179: @2293630
     /* 2293630 */   GIM_Reject,
     /* 2293631 */ // Label 31177: @2293631
     /* 2293631 */ GIM_Reject,
     /* 2293632 */ // Label 31144: @2293632
     /* 2293632 */ GIM_Try, /*On fail goto*//*Label 31180*/ GIMT_Encode4(2293752),
     /* 2293637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2293640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2293643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293655 */   GIM_Try, /*On fail goto*//*Label 31181*/ GIMT_Encode4(2293703), // Rule ID 52732 //
     /* 2293660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293663 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2293666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2293680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293702 */     // GIR_Coverage, 52732,
     /* 2293702 */     GIR_EraseRootFromParent_Done,
     /* 2293703 */   // Label 31181: @2293703
     /* 2293703 */   GIM_Try, /*On fail goto*//*Label 31182*/ GIMT_Encode4(2293751), // Rule ID 52733 //
     /* 2293708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293711 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2293714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2293728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293750 */     // GIR_Coverage, 52733,
     /* 2293750 */     GIR_EraseRootFromParent_Done,
     /* 2293751 */   // Label 31182: @2293751
     /* 2293751 */   GIM_Reject,
     /* 2293752 */ // Label 31180: @2293752
     /* 2293752 */ GIM_Reject,
     /* 2293753 */ // Label 31145: @2293753
     /* 2293753 */ GIM_Try, /*On fail goto*//*Label 31183*/ GIMT_Encode4(2293873),
     /* 2293758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2293761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2293764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293776 */   GIM_Try, /*On fail goto*//*Label 31184*/ GIMT_Encode4(2293824), // Rule ID 52748 //
     /* 2293781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293784 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2293787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2293801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293823 */     // GIR_Coverage, 52748,
     /* 2293823 */     GIR_EraseRootFromParent_Done,
     /* 2293824 */   // Label 31184: @2293824
     /* 2293824 */   GIM_Try, /*On fail goto*//*Label 31185*/ GIMT_Encode4(2293872), // Rule ID 52749 //
     /* 2293829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293832 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2293835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2293849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293871 */     // GIR_Coverage, 52749,
     /* 2293871 */     GIR_EraseRootFromParent_Done,
     /* 2293872 */   // Label 31185: @2293872
     /* 2293872 */   GIM_Reject,
     /* 2293873 */ // Label 31183: @2293873
     /* 2293873 */ GIM_Reject,
     /* 2293874 */ // Label 31146: @2293874
     /* 2293874 */ GIM_Try, /*On fail goto*//*Label 31186*/ GIMT_Encode4(2293994),
     /* 2293879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2293882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2293885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2293889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2293893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2293897 */   GIM_Try, /*On fail goto*//*Label 31187*/ GIMT_Encode4(2293945), // Rule ID 52792 //
     /* 2293902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2293905 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2293908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2293922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293944 */     // GIR_Coverage, 52792,
     /* 2293944 */     GIR_EraseRootFromParent_Done,
     /* 2293945 */   // Label 31187: @2293945
     /* 2293945 */   GIM_Try, /*On fail goto*//*Label 31188*/ GIMT_Encode4(2293993), // Rule ID 52793 //
     /* 2293950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2293953 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2293956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2293970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293992 */     // GIR_Coverage, 52793,
     /* 2293992 */     GIR_EraseRootFromParent_Done,
     /* 2293993 */   // Label 31188: @2293993
     /* 2293993 */   GIM_Reject,
     /* 2293994 */ // Label 31186: @2293994
     /* 2293994 */ GIM_Reject,
     /* 2293995 */ // Label 31147: @2293995
     /* 2293995 */ GIM_Try, /*On fail goto*//*Label 31189*/ GIMT_Encode4(2294115),
     /* 2294000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2294003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2294006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294018 */   GIM_Try, /*On fail goto*//*Label 31190*/ GIMT_Encode4(2294066), // Rule ID 52724 //
     /* 2294023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294026 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2294029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2294043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294065 */     // GIR_Coverage, 52724,
     /* 2294065 */     GIR_EraseRootFromParent_Done,
     /* 2294066 */   // Label 31190: @2294066
     /* 2294066 */   GIM_Try, /*On fail goto*//*Label 31191*/ GIMT_Encode4(2294114), // Rule ID 52725 //
     /* 2294071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294074 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2294077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2294091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294113 */     // GIR_Coverage, 52725,
     /* 2294113 */     GIR_EraseRootFromParent_Done,
     /* 2294114 */   // Label 31191: @2294114
     /* 2294114 */   GIM_Reject,
     /* 2294115 */ // Label 31189: @2294115
     /* 2294115 */ GIM_Reject,
     /* 2294116 */ // Label 31148: @2294116
     /* 2294116 */ GIM_Try, /*On fail goto*//*Label 31192*/ GIMT_Encode4(2294236),
     /* 2294121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2294124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2294127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294139 */   GIM_Try, /*On fail goto*//*Label 31193*/ GIMT_Encode4(2294187), // Rule ID 52744 //
     /* 2294144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294147 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2294150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2294164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294186 */     // GIR_Coverage, 52744,
     /* 2294186 */     GIR_EraseRootFromParent_Done,
     /* 2294187 */   // Label 31193: @2294187
     /* 2294187 */   GIM_Try, /*On fail goto*//*Label 31194*/ GIMT_Encode4(2294235), // Rule ID 52745 //
     /* 2294192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294195 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2294198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2294212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294234 */     // GIR_Coverage, 52745,
     /* 2294234 */     GIR_EraseRootFromParent_Done,
     /* 2294235 */   // Label 31194: @2294235
     /* 2294235 */   GIM_Reject,
     /* 2294236 */ // Label 31192: @2294236
     /* 2294236 */ GIM_Reject,
     /* 2294237 */ // Label 31149: @2294237
     /* 2294237 */ GIM_Try, /*On fail goto*//*Label 31195*/ GIMT_Encode4(2294357),
     /* 2294242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2294245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2294248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294260 */   GIM_Try, /*On fail goto*//*Label 31196*/ GIMT_Encode4(2294308), // Rule ID 52780 //
     /* 2294265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294268 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2294271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2294285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294307 */     // GIR_Coverage, 52780,
     /* 2294307 */     GIR_EraseRootFromParent_Done,
     /* 2294308 */   // Label 31196: @2294308
     /* 2294308 */   GIM_Try, /*On fail goto*//*Label 31197*/ GIMT_Encode4(2294356), // Rule ID 52781 //
     /* 2294313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294316 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2294319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2294333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294355 */     // GIR_Coverage, 52781,
     /* 2294355 */     GIR_EraseRootFromParent_Done,
     /* 2294356 */   // Label 31197: @2294356
     /* 2294356 */   GIM_Reject,
     /* 2294357 */ // Label 31195: @2294357
     /* 2294357 */ GIM_Reject,
     /* 2294358 */ // Label 31150: @2294358
     /* 2294358 */ GIM_Try, /*On fail goto*//*Label 31198*/ GIMT_Encode4(2294478),
     /* 2294363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2294366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2294369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294381 */   GIM_Try, /*On fail goto*//*Label 31199*/ GIMT_Encode4(2294429), // Rule ID 52796 //
     /* 2294386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2294389 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2294392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2294406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294428 */     // GIR_Coverage, 52796,
     /* 2294428 */     GIR_EraseRootFromParent_Done,
     /* 2294429 */   // Label 31199: @2294429
     /* 2294429 */   GIM_Try, /*On fail goto*//*Label 31200*/ GIMT_Encode4(2294477), // Rule ID 52797 //
     /* 2294434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2294437 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2294440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2294454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294476 */     // GIR_Coverage, 52797,
     /* 2294476 */     GIR_EraseRootFromParent_Done,
     /* 2294477 */   // Label 31200: @2294477
     /* 2294477 */   GIM_Reject,
     /* 2294478 */ // Label 31198: @2294478
     /* 2294478 */ GIM_Reject,
     /* 2294479 */ // Label 31151: @2294479
     /* 2294479 */ GIM_Try, /*On fail goto*//*Label 31201*/ GIMT_Encode4(2294599),
     /* 2294484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2294487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2294490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294502 */   GIM_Try, /*On fail goto*//*Label 31202*/ GIMT_Encode4(2294550), // Rule ID 52740 //
     /* 2294507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294510 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2294513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2294527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294549 */     // GIR_Coverage, 52740,
     /* 2294549 */     GIR_EraseRootFromParent_Done,
     /* 2294550 */   // Label 31202: @2294550
     /* 2294550 */   GIM_Try, /*On fail goto*//*Label 31203*/ GIMT_Encode4(2294598), // Rule ID 52741 //
     /* 2294555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294558 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2294561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2294575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294597 */     // GIR_Coverage, 52741,
     /* 2294597 */     GIR_EraseRootFromParent_Done,
     /* 2294598 */   // Label 31203: @2294598
     /* 2294598 */   GIM_Reject,
     /* 2294599 */ // Label 31201: @2294599
     /* 2294599 */ GIM_Reject,
     /* 2294600 */ // Label 31152: @2294600
     /* 2294600 */ GIM_Try, /*On fail goto*//*Label 31204*/ GIMT_Encode4(2294720),
     /* 2294605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2294608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2294611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294623 */   GIM_Try, /*On fail goto*//*Label 31205*/ GIMT_Encode4(2294671), // Rule ID 52768 //
     /* 2294628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294631 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2294634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2294648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294670 */     // GIR_Coverage, 52768,
     /* 2294670 */     GIR_EraseRootFromParent_Done,
     /* 2294671 */   // Label 31205: @2294671
     /* 2294671 */   GIM_Try, /*On fail goto*//*Label 31206*/ GIMT_Encode4(2294719), // Rule ID 52769 //
     /* 2294676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294679 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2294682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2294696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294718 */     // GIR_Coverage, 52769,
     /* 2294718 */     GIR_EraseRootFromParent_Done,
     /* 2294719 */   // Label 31206: @2294719
     /* 2294719 */   GIM_Reject,
     /* 2294720 */ // Label 31204: @2294720
     /* 2294720 */ GIM_Reject,
     /* 2294721 */ // Label 31153: @2294721
     /* 2294721 */ GIM_Try, /*On fail goto*//*Label 31207*/ GIMT_Encode4(2294841),
     /* 2294726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2294729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2294732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294744 */   GIM_Try, /*On fail goto*//*Label 31208*/ GIMT_Encode4(2294792), // Rule ID 52784 //
     /* 2294749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294752 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2294755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2294769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294791 */     // GIR_Coverage, 52784,
     /* 2294791 */     GIR_EraseRootFromParent_Done,
     /* 2294792 */   // Label 31208: @2294792
     /* 2294792 */   GIM_Try, /*On fail goto*//*Label 31209*/ GIMT_Encode4(2294840), // Rule ID 52785 //
     /* 2294797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294800 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2294803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2294817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294839 */     // GIR_Coverage, 52785,
     /* 2294839 */     GIR_EraseRootFromParent_Done,
     /* 2294840 */   // Label 31209: @2294840
     /* 2294840 */   GIM_Reject,
     /* 2294841 */ // Label 31207: @2294841
     /* 2294841 */ GIM_Reject,
     /* 2294842 */ // Label 31154: @2294842
     /* 2294842 */ GIM_Try, /*On fail goto*//*Label 31210*/ GIMT_Encode4(2294962),
     /* 2294847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2294850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2294853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2294857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2294861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2294865 */   GIM_Try, /*On fail goto*//*Label 31211*/ GIMT_Encode4(2294913), // Rule ID 52800 //
     /* 2294870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2294873 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2294876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2294890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294912 */     // GIR_Coverage, 52800,
     /* 2294912 */     GIR_EraseRootFromParent_Done,
     /* 2294913 */   // Label 31211: @2294913
     /* 2294913 */   GIM_Try, /*On fail goto*//*Label 31212*/ GIMT_Encode4(2294961), // Rule ID 52801 //
     /* 2294918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2294921 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2294924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2294938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294960 */     // GIR_Coverage, 52801,
     /* 2294960 */     GIR_EraseRootFromParent_Done,
     /* 2294961 */   // Label 31212: @2294961
     /* 2294961 */   GIM_Reject,
     /* 2294962 */ // Label 31210: @2294962
     /* 2294962 */ GIM_Reject,
     /* 2294963 */ // Label 31155: @2294963
     /* 2294963 */ GIM_Try, /*On fail goto*//*Label 31213*/ GIMT_Encode4(2295083),
     /* 2294968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2294971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2294974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294986 */   GIM_Try, /*On fail goto*//*Label 31214*/ GIMT_Encode4(2295034), // Rule ID 52756 //
     /* 2294991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294994 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2294997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2295011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295033 */     // GIR_Coverage, 52756,
     /* 2295033 */     GIR_EraseRootFromParent_Done,
     /* 2295034 */   // Label 31214: @2295034
     /* 2295034 */   GIM_Try, /*On fail goto*//*Label 31215*/ GIMT_Encode4(2295082), // Rule ID 52757 //
     /* 2295039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295042 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2295045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2295059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295081 */     // GIR_Coverage, 52757,
     /* 2295081 */     GIR_EraseRootFromParent_Done,
     /* 2295082 */   // Label 31215: @2295082
     /* 2295082 */   GIM_Reject,
     /* 2295083 */ // Label 31213: @2295083
     /* 2295083 */ GIM_Reject,
     /* 2295084 */ // Label 31156: @2295084
     /* 2295084 */ GIM_Try, /*On fail goto*//*Label 31216*/ GIMT_Encode4(2295204),
     /* 2295089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2295092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2295095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295107 */   GIM_Try, /*On fail goto*//*Label 31217*/ GIMT_Encode4(2295155), // Rule ID 52772 //
     /* 2295112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295115 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2295118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2295132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295154 */     // GIR_Coverage, 52772,
     /* 2295154 */     GIR_EraseRootFromParent_Done,
     /* 2295155 */   // Label 31217: @2295155
     /* 2295155 */   GIM_Try, /*On fail goto*//*Label 31218*/ GIMT_Encode4(2295203), // Rule ID 52773 //
     /* 2295160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295163 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2295166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2295180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295202 */     // GIR_Coverage, 52773,
     /* 2295202 */     GIR_EraseRootFromParent_Done,
     /* 2295203 */   // Label 31218: @2295203
     /* 2295203 */   GIM_Reject,
     /* 2295204 */ // Label 31216: @2295204
     /* 2295204 */ GIM_Reject,
     /* 2295205 */ // Label 31157: @2295205
     /* 2295205 */ GIM_Try, /*On fail goto*//*Label 31219*/ GIMT_Encode4(2295325),
     /* 2295210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2295213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2295216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295228 */   GIM_Try, /*On fail goto*//*Label 31220*/ GIMT_Encode4(2295276), // Rule ID 52788 //
     /* 2295233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295236 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2295239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2295253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295275 */     // GIR_Coverage, 52788,
     /* 2295275 */     GIR_EraseRootFromParent_Done,
     /* 2295276 */   // Label 31220: @2295276
     /* 2295276 */   GIM_Try, /*On fail goto*//*Label 31221*/ GIMT_Encode4(2295324), // Rule ID 52789 //
     /* 2295281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295284 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2295287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2295301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295323 */     // GIR_Coverage, 52789,
     /* 2295323 */     GIR_EraseRootFromParent_Done,
     /* 2295324 */   // Label 31221: @2295324
     /* 2295324 */   GIM_Reject,
     /* 2295325 */ // Label 31219: @2295325
     /* 2295325 */ GIM_Reject,
     /* 2295326 */ // Label 31158: @2295326
     /* 2295326 */ GIM_Try, /*On fail goto*//*Label 31222*/ GIMT_Encode4(2295446),
     /* 2295331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2295334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2295337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295349 */   GIM_Try, /*On fail goto*//*Label 31223*/ GIMT_Encode4(2295397), // Rule ID 52760 //
     /* 2295354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295357 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2295360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2295374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295396 */     // GIR_Coverage, 52760,
     /* 2295396 */     GIR_EraseRootFromParent_Done,
     /* 2295397 */   // Label 31223: @2295397
     /* 2295397 */   GIM_Try, /*On fail goto*//*Label 31224*/ GIMT_Encode4(2295445), // Rule ID 52761 //
     /* 2295402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295405 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2295408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2295422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295444 */     // GIR_Coverage, 52761,
     /* 2295444 */     GIR_EraseRootFromParent_Done,
     /* 2295445 */   // Label 31224: @2295445
     /* 2295445 */   GIM_Reject,
     /* 2295446 */ // Label 31222: @2295446
     /* 2295446 */ GIM_Reject,
     /* 2295447 */ // Label 31159: @2295447
     /* 2295447 */ GIM_Try, /*On fail goto*//*Label 31225*/ GIMT_Encode4(2295567),
     /* 2295452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2295455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2295458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295470 */   GIM_Try, /*On fail goto*//*Label 31226*/ GIMT_Encode4(2295518), // Rule ID 52776 //
     /* 2295475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295478 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2295481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2295495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295517 */     // GIR_Coverage, 52776,
     /* 2295517 */     GIR_EraseRootFromParent_Done,
     /* 2295518 */   // Label 31226: @2295518
     /* 2295518 */   GIM_Try, /*On fail goto*//*Label 31227*/ GIMT_Encode4(2295566), // Rule ID 52777 //
     /* 2295523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295526 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2295529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2295543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295565 */     // GIR_Coverage, 52777,
     /* 2295565 */     GIR_EraseRootFromParent_Done,
     /* 2295566 */   // Label 31227: @2295566
     /* 2295566 */   GIM_Reject,
     /* 2295567 */ // Label 31225: @2295567
     /* 2295567 */ GIM_Reject,
     /* 2295568 */ // Label 31160: @2295568
     /* 2295568 */ GIM_Try, /*On fail goto*//*Label 31228*/ GIMT_Encode4(2295688),
     /* 2295573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2295576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2295579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295591 */   GIM_Try, /*On fail goto*//*Label 31229*/ GIMT_Encode4(2295639), // Rule ID 52764 //
     /* 2295596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295599 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2295602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2295616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295638 */     // GIR_Coverage, 52764,
     /* 2295638 */     GIR_EraseRootFromParent_Done,
     /* 2295639 */   // Label 31229: @2295639
     /* 2295639 */   GIM_Try, /*On fail goto*//*Label 31230*/ GIMT_Encode4(2295687), // Rule ID 52765 //
     /* 2295644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295647 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2295650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2295664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295686 */     // GIR_Coverage, 52765,
     /* 2295686 */     GIR_EraseRootFromParent_Done,
     /* 2295687 */   // Label 31230: @2295687
     /* 2295687 */   GIM_Reject,
     /* 2295688 */ // Label 31228: @2295688
     /* 2295688 */ GIM_Reject,
     /* 2295689 */ // Label 31161: @2295689
     /* 2295689 */ GIM_Reject,
     /* 2295690 */ // Label 56: @2295690
     /* 2295690 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31254*/ GIMT_Encode4(2298542),
     /* 2295701 */ /*GILLT_s32*//*Label 31231*/ GIMT_Encode4(2295825), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2295713 */ /*GILLT_nxv1s8*//*Label 31232*/ GIMT_Encode4(2295880),
     /* 2295717 */ /*GILLT_nxv1s16*//*Label 31233*/ GIMT_Encode4(2296001),
     /* 2295721 */ /*GILLT_nxv1s32*//*Label 31234*/ GIMT_Encode4(2296122),
     /* 2295725 */ /*GILLT_nxv1s64*//*Label 31235*/ GIMT_Encode4(2296243), GIMT_Encode4(0),
     /* 2295733 */ /*GILLT_nxv2s8*//*Label 31236*/ GIMT_Encode4(2296364),
     /* 2295737 */ /*GILLT_nxv2s16*//*Label 31237*/ GIMT_Encode4(2296485),
     /* 2295741 */ /*GILLT_nxv2s32*//*Label 31238*/ GIMT_Encode4(2296606),
     /* 2295745 */ /*GILLT_nxv2s64*//*Label 31239*/ GIMT_Encode4(2296727), GIMT_Encode4(0),
     /* 2295753 */ /*GILLT_nxv4s8*//*Label 31240*/ GIMT_Encode4(2296848),
     /* 2295757 */ /*GILLT_nxv4s16*//*Label 31241*/ GIMT_Encode4(2296969),
     /* 2295761 */ /*GILLT_nxv4s32*//*Label 31242*/ GIMT_Encode4(2297090),
     /* 2295765 */ /*GILLT_nxv4s64*//*Label 31243*/ GIMT_Encode4(2297211), GIMT_Encode4(0),
     /* 2295773 */ /*GILLT_nxv8s8*//*Label 31244*/ GIMT_Encode4(2297332),
     /* 2295777 */ /*GILLT_nxv8s16*//*Label 31245*/ GIMT_Encode4(2297453),
     /* 2295781 */ /*GILLT_nxv8s32*//*Label 31246*/ GIMT_Encode4(2297574),
     /* 2295785 */ /*GILLT_nxv8s64*//*Label 31247*/ GIMT_Encode4(2297695), GIMT_Encode4(0),
     /* 2295793 */ /*GILLT_nxv16s8*//*Label 31248*/ GIMT_Encode4(2297816),
     /* 2295797 */ /*GILLT_nxv16s16*//*Label 31249*/ GIMT_Encode4(2297937),
     /* 2295801 */ /*GILLT_nxv16s32*//*Label 31250*/ GIMT_Encode4(2298058), GIMT_Encode4(0),
     /* 2295809 */ /*GILLT_nxv32s8*//*Label 31251*/ GIMT_Encode4(2298179),
     /* 2295813 */ /*GILLT_nxv32s16*//*Label 31252*/ GIMT_Encode4(2298300), GIMT_Encode4(0),
     /* 2295821 */ /*GILLT_nxv64s8*//*Label 31253*/ GIMT_Encode4(2298421),
     /* 2295825 */ // Label 31231: @2295825
     /* 2295825 */ GIM_Try, /*On fail goto*//*Label 31255*/ GIMT_Encode4(2295879),
     /* 2295830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2295833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2295836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2295840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2295844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2295848 */   GIM_Try, /*On fail goto*//*Label 31256*/ GIMT_Encode4(2295863), // Rule ID 64570 //
     /* 2295853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2295856 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2295856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2295861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295862 */     // GIR_Coverage, 64570,
     /* 2295862 */     GIR_Done,
     /* 2295863 */   // Label 31256: @2295863
     /* 2295863 */   GIM_Try, /*On fail goto*//*Label 31257*/ GIMT_Encode4(2295878), // Rule ID 64571 //
     /* 2295868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2295871 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2295871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2295876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295877 */     // GIR_Coverage, 64571,
     /* 2295877 */     GIR_Done,
     /* 2295878 */   // Label 31257: @2295878
     /* 2295878 */   GIM_Reject,
     /* 2295879 */ // Label 31255: @2295879
     /* 2295879 */ GIM_Reject,
     /* 2295880 */ // Label 31232: @2295880
     /* 2295880 */ GIM_Try, /*On fail goto*//*Label 31258*/ GIMT_Encode4(2296000),
     /* 2295885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2295888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2295891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295903 */   GIM_Try, /*On fail goto*//*Label 31259*/ GIMT_Encode4(2295951), // Rule ID 52628 //
     /* 2295908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295911 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2295914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2295928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295950 */     // GIR_Coverage, 52628,
     /* 2295950 */     GIR_EraseRootFromParent_Done,
     /* 2295951 */   // Label 31259: @2295951
     /* 2295951 */   GIM_Try, /*On fail goto*//*Label 31260*/ GIMT_Encode4(2295999), // Rule ID 52629 //
     /* 2295956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295959 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2295962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2295976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295998 */     // GIR_Coverage, 52629,
     /* 2295998 */     GIR_EraseRootFromParent_Done,
     /* 2295999 */   // Label 31260: @2295999
     /* 2295999 */   GIM_Reject,
     /* 2296000 */ // Label 31258: @2296000
     /* 2296000 */ GIM_Reject,
     /* 2296001 */ // Label 31233: @2296001
     /* 2296001 */ GIM_Try, /*On fail goto*//*Label 31261*/ GIMT_Encode4(2296121),
     /* 2296006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2296009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2296012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296024 */   GIM_Try, /*On fail goto*//*Label 31262*/ GIMT_Encode4(2296072), // Rule ID 52640 //
     /* 2296029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296032 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2296035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2296049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296071 */     // GIR_Coverage, 52640,
     /* 2296071 */     GIR_EraseRootFromParent_Done,
     /* 2296072 */   // Label 31262: @2296072
     /* 2296072 */   GIM_Try, /*On fail goto*//*Label 31263*/ GIMT_Encode4(2296120), // Rule ID 52641 //
     /* 2296077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296080 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2296083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2296097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296119 */     // GIR_Coverage, 52641,
     /* 2296119 */     GIR_EraseRootFromParent_Done,
     /* 2296120 */   // Label 31263: @2296120
     /* 2296120 */   GIM_Reject,
     /* 2296121 */ // Label 31261: @2296121
     /* 2296121 */ GIM_Reject,
     /* 2296122 */ // Label 31234: @2296122
     /* 2296122 */ GIM_Try, /*On fail goto*//*Label 31264*/ GIMT_Encode4(2296242),
     /* 2296127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2296130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2296133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296145 */   GIM_Try, /*On fail goto*//*Label 31265*/ GIMT_Encode4(2296193), // Rule ID 52648 //
     /* 2296150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296153 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2296156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2296170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296192 */     // GIR_Coverage, 52648,
     /* 2296192 */     GIR_EraseRootFromParent_Done,
     /* 2296193 */   // Label 31265: @2296193
     /* 2296193 */   GIM_Try, /*On fail goto*//*Label 31266*/ GIMT_Encode4(2296241), // Rule ID 52649 //
     /* 2296198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296201 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2296204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2296218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296240 */     // GIR_Coverage, 52649,
     /* 2296240 */     GIR_EraseRootFromParent_Done,
     /* 2296241 */   // Label 31266: @2296241
     /* 2296241 */   GIM_Reject,
     /* 2296242 */ // Label 31264: @2296242
     /* 2296242 */ GIM_Reject,
     /* 2296243 */ // Label 31235: @2296243
     /* 2296243 */ GIM_Try, /*On fail goto*//*Label 31267*/ GIMT_Encode4(2296363),
     /* 2296248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2296251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2296254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296266 */   GIM_Try, /*On fail goto*//*Label 31268*/ GIMT_Encode4(2296314), // Rule ID 52664 //
     /* 2296271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2296274 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2296277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2296291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2296306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296313 */     // GIR_Coverage, 52664,
     /* 2296313 */     GIR_EraseRootFromParent_Done,
     /* 2296314 */   // Label 31268: @2296314
     /* 2296314 */   GIM_Try, /*On fail goto*//*Label 31269*/ GIMT_Encode4(2296362), // Rule ID 52665 //
     /* 2296319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2296322 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2296325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2296339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2296354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296361 */     // GIR_Coverage, 52665,
     /* 2296361 */     GIR_EraseRootFromParent_Done,
     /* 2296362 */   // Label 31269: @2296362
     /* 2296362 */   GIM_Reject,
     /* 2296363 */ // Label 31267: @2296363
     /* 2296363 */ GIM_Reject,
     /* 2296364 */ // Label 31236: @2296364
     /* 2296364 */ GIM_Try, /*On fail goto*//*Label 31270*/ GIMT_Encode4(2296484),
     /* 2296369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2296372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2296375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296387 */   GIM_Try, /*On fail goto*//*Label 31271*/ GIMT_Encode4(2296435), // Rule ID 52632 //
     /* 2296392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296395 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2296398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2296412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296434 */     // GIR_Coverage, 52632,
     /* 2296434 */     GIR_EraseRootFromParent_Done,
     /* 2296435 */   // Label 31271: @2296435
     /* 2296435 */   GIM_Try, /*On fail goto*//*Label 31272*/ GIMT_Encode4(2296483), // Rule ID 52633 //
     /* 2296440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296443 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2296446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2296460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296482 */     // GIR_Coverage, 52633,
     /* 2296482 */     GIR_EraseRootFromParent_Done,
     /* 2296483 */   // Label 31272: @2296483
     /* 2296483 */   GIM_Reject,
     /* 2296484 */ // Label 31270: @2296484
     /* 2296484 */ GIM_Reject,
     /* 2296485 */ // Label 31237: @2296485
     /* 2296485 */ GIM_Try, /*On fail goto*//*Label 31273*/ GIMT_Encode4(2296605),
     /* 2296490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2296493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2296496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296508 */   GIM_Try, /*On fail goto*//*Label 31274*/ GIMT_Encode4(2296556), // Rule ID 52644 //
     /* 2296513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296516 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2296519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2296533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296555 */     // GIR_Coverage, 52644,
     /* 2296555 */     GIR_EraseRootFromParent_Done,
     /* 2296556 */   // Label 31274: @2296556
     /* 2296556 */   GIM_Try, /*On fail goto*//*Label 31275*/ GIMT_Encode4(2296604), // Rule ID 52645 //
     /* 2296561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296564 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2296567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2296581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296603 */     // GIR_Coverage, 52645,
     /* 2296603 */     GIR_EraseRootFromParent_Done,
     /* 2296604 */   // Label 31275: @2296604
     /* 2296604 */   GIM_Reject,
     /* 2296605 */ // Label 31273: @2296605
     /* 2296605 */ GIM_Reject,
     /* 2296606 */ // Label 31238: @2296606
     /* 2296606 */ GIM_Try, /*On fail goto*//*Label 31276*/ GIMT_Encode4(2296726),
     /* 2296611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2296617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296629 */   GIM_Try, /*On fail goto*//*Label 31277*/ GIMT_Encode4(2296677), // Rule ID 52660 //
     /* 2296634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296637 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2296640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2296654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296676 */     // GIR_Coverage, 52660,
     /* 2296676 */     GIR_EraseRootFromParent_Done,
     /* 2296677 */   // Label 31277: @2296677
     /* 2296677 */   GIM_Try, /*On fail goto*//*Label 31278*/ GIMT_Encode4(2296725), // Rule ID 52661 //
     /* 2296682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296685 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2296688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2296702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296724 */     // GIR_Coverage, 52661,
     /* 2296724 */     GIR_EraseRootFromParent_Done,
     /* 2296725 */   // Label 31278: @2296725
     /* 2296725 */   GIM_Reject,
     /* 2296726 */ // Label 31276: @2296726
     /* 2296726 */ GIM_Reject,
     /* 2296727 */ // Label 31239: @2296727
     /* 2296727 */ GIM_Try, /*On fail goto*//*Label 31279*/ GIMT_Encode4(2296847),
     /* 2296732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2296735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2296738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2296742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2296746 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2296750 */   GIM_Try, /*On fail goto*//*Label 31280*/ GIMT_Encode4(2296798), // Rule ID 52704 //
     /* 2296755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2296758 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2296761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2296775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2296790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296797 */     // GIR_Coverage, 52704,
     /* 2296797 */     GIR_EraseRootFromParent_Done,
     /* 2296798 */   // Label 31280: @2296798
     /* 2296798 */   GIM_Try, /*On fail goto*//*Label 31281*/ GIMT_Encode4(2296846), // Rule ID 52705 //
     /* 2296803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2296806 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2296809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2296823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2296838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296845 */     // GIR_Coverage, 52705,
     /* 2296845 */     GIR_EraseRootFromParent_Done,
     /* 2296846 */   // Label 31281: @2296846
     /* 2296846 */   GIM_Reject,
     /* 2296847 */ // Label 31279: @2296847
     /* 2296847 */ GIM_Reject,
     /* 2296848 */ // Label 31240: @2296848
     /* 2296848 */ GIM_Try, /*On fail goto*//*Label 31282*/ GIMT_Encode4(2296968),
     /* 2296853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2296856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2296859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296871 */   GIM_Try, /*On fail goto*//*Label 31283*/ GIMT_Encode4(2296919), // Rule ID 52636 //
     /* 2296876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296879 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2296882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2296896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296918 */     // GIR_Coverage, 52636,
     /* 2296918 */     GIR_EraseRootFromParent_Done,
     /* 2296919 */   // Label 31283: @2296919
     /* 2296919 */   GIM_Try, /*On fail goto*//*Label 31284*/ GIMT_Encode4(2296967), // Rule ID 52637 //
     /* 2296924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296927 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2296930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2296944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296966 */     // GIR_Coverage, 52637,
     /* 2296966 */     GIR_EraseRootFromParent_Done,
     /* 2296967 */   // Label 31284: @2296967
     /* 2296967 */   GIM_Reject,
     /* 2296968 */ // Label 31282: @2296968
     /* 2296968 */ GIM_Reject,
     /* 2296969 */ // Label 31241: @2296969
     /* 2296969 */ GIM_Try, /*On fail goto*//*Label 31285*/ GIMT_Encode4(2297089),
     /* 2296974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2296977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2296980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296992 */   GIM_Try, /*On fail goto*//*Label 31286*/ GIMT_Encode4(2297040), // Rule ID 52656 //
     /* 2296997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297000 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2297003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2297017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297039 */     // GIR_Coverage, 52656,
     /* 2297039 */     GIR_EraseRootFromParent_Done,
     /* 2297040 */   // Label 31286: @2297040
     /* 2297040 */   GIM_Try, /*On fail goto*//*Label 31287*/ GIMT_Encode4(2297088), // Rule ID 52657 //
     /* 2297045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297048 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2297051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2297065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297087 */     // GIR_Coverage, 52657,
     /* 2297087 */     GIR_EraseRootFromParent_Done,
     /* 2297088 */   // Label 31287: @2297088
     /* 2297088 */   GIM_Reject,
     /* 2297089 */ // Label 31285: @2297089
     /* 2297089 */ GIM_Reject,
     /* 2297090 */ // Label 31242: @2297090
     /* 2297090 */ GIM_Try, /*On fail goto*//*Label 31288*/ GIMT_Encode4(2297210),
     /* 2297095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2297098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2297101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297113 */   GIM_Try, /*On fail goto*//*Label 31289*/ GIMT_Encode4(2297161), // Rule ID 52692 //
     /* 2297118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297121 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2297124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2297138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297160 */     // GIR_Coverage, 52692,
     /* 2297160 */     GIR_EraseRootFromParent_Done,
     /* 2297161 */   // Label 31289: @2297161
     /* 2297161 */   GIM_Try, /*On fail goto*//*Label 31290*/ GIMT_Encode4(2297209), // Rule ID 52693 //
     /* 2297166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297169 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2297172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2297186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297208 */     // GIR_Coverage, 52693,
     /* 2297208 */     GIR_EraseRootFromParent_Done,
     /* 2297209 */   // Label 31290: @2297209
     /* 2297209 */   GIM_Reject,
     /* 2297210 */ // Label 31288: @2297210
     /* 2297210 */ GIM_Reject,
     /* 2297211 */ // Label 31243: @2297211
     /* 2297211 */ GIM_Try, /*On fail goto*//*Label 31291*/ GIMT_Encode4(2297331),
     /* 2297216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2297219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2297222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297234 */   GIM_Try, /*On fail goto*//*Label 31292*/ GIMT_Encode4(2297282), // Rule ID 52708 //
     /* 2297239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2297242 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2297245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2297259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297281 */     // GIR_Coverage, 52708,
     /* 2297281 */     GIR_EraseRootFromParent_Done,
     /* 2297282 */   // Label 31292: @2297282
     /* 2297282 */   GIM_Try, /*On fail goto*//*Label 31293*/ GIMT_Encode4(2297330), // Rule ID 52709 //
     /* 2297287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2297290 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2297293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2297307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297329 */     // GIR_Coverage, 52709,
     /* 2297329 */     GIR_EraseRootFromParent_Done,
     /* 2297330 */   // Label 31293: @2297330
     /* 2297330 */   GIM_Reject,
     /* 2297331 */ // Label 31291: @2297331
     /* 2297331 */ GIM_Reject,
     /* 2297332 */ // Label 31244: @2297332
     /* 2297332 */ GIM_Try, /*On fail goto*//*Label 31294*/ GIMT_Encode4(2297452),
     /* 2297337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2297340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2297343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297355 */   GIM_Try, /*On fail goto*//*Label 31295*/ GIMT_Encode4(2297403), // Rule ID 52652 //
     /* 2297360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297363 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2297366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2297380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297402 */     // GIR_Coverage, 52652,
     /* 2297402 */     GIR_EraseRootFromParent_Done,
     /* 2297403 */   // Label 31295: @2297403
     /* 2297403 */   GIM_Try, /*On fail goto*//*Label 31296*/ GIMT_Encode4(2297451), // Rule ID 52653 //
     /* 2297408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297411 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2297414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2297428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297450 */     // GIR_Coverage, 52653,
     /* 2297450 */     GIR_EraseRootFromParent_Done,
     /* 2297451 */   // Label 31296: @2297451
     /* 2297451 */   GIM_Reject,
     /* 2297452 */ // Label 31294: @2297452
     /* 2297452 */ GIM_Reject,
     /* 2297453 */ // Label 31245: @2297453
     /* 2297453 */ GIM_Try, /*On fail goto*//*Label 31297*/ GIMT_Encode4(2297573),
     /* 2297458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2297461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2297464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297476 */   GIM_Try, /*On fail goto*//*Label 31298*/ GIMT_Encode4(2297524), // Rule ID 52680 //
     /* 2297481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297484 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2297487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2297501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297523 */     // GIR_Coverage, 52680,
     /* 2297523 */     GIR_EraseRootFromParent_Done,
     /* 2297524 */   // Label 31298: @2297524
     /* 2297524 */   GIM_Try, /*On fail goto*//*Label 31299*/ GIMT_Encode4(2297572), // Rule ID 52681 //
     /* 2297529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297532 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2297535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2297549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297571 */     // GIR_Coverage, 52681,
     /* 2297571 */     GIR_EraseRootFromParent_Done,
     /* 2297572 */   // Label 31299: @2297572
     /* 2297572 */   GIM_Reject,
     /* 2297573 */ // Label 31297: @2297573
     /* 2297573 */ GIM_Reject,
     /* 2297574 */ // Label 31246: @2297574
     /* 2297574 */ GIM_Try, /*On fail goto*//*Label 31300*/ GIMT_Encode4(2297694),
     /* 2297579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2297582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2297585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297597 */   GIM_Try, /*On fail goto*//*Label 31301*/ GIMT_Encode4(2297645), // Rule ID 52696 //
     /* 2297602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297605 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2297608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2297622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297644 */     // GIR_Coverage, 52696,
     /* 2297644 */     GIR_EraseRootFromParent_Done,
     /* 2297645 */   // Label 31301: @2297645
     /* 2297645 */   GIM_Try, /*On fail goto*//*Label 31302*/ GIMT_Encode4(2297693), // Rule ID 52697 //
     /* 2297650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297653 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2297656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2297670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297692 */     // GIR_Coverage, 52697,
     /* 2297692 */     GIR_EraseRootFromParent_Done,
     /* 2297693 */   // Label 31302: @2297693
     /* 2297693 */   GIM_Reject,
     /* 2297694 */ // Label 31300: @2297694
     /* 2297694 */ GIM_Reject,
     /* 2297695 */ // Label 31247: @2297695
     /* 2297695 */ GIM_Try, /*On fail goto*//*Label 31303*/ GIMT_Encode4(2297815),
     /* 2297700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2297703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2297706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2297718 */   GIM_Try, /*On fail goto*//*Label 31304*/ GIMT_Encode4(2297766), // Rule ID 52712 //
     /* 2297723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2297726 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2297729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2297743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297765 */     // GIR_Coverage, 52712,
     /* 2297765 */     GIR_EraseRootFromParent_Done,
     /* 2297766 */   // Label 31304: @2297766
     /* 2297766 */   GIM_Try, /*On fail goto*//*Label 31305*/ GIMT_Encode4(2297814), // Rule ID 52713 //
     /* 2297771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2297774 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2297777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2297791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297813 */     // GIR_Coverage, 52713,
     /* 2297813 */     GIR_EraseRootFromParent_Done,
     /* 2297814 */   // Label 31305: @2297814
     /* 2297814 */   GIM_Reject,
     /* 2297815 */ // Label 31303: @2297815
     /* 2297815 */ GIM_Reject,
     /* 2297816 */ // Label 31248: @2297816
     /* 2297816 */ GIM_Try, /*On fail goto*//*Label 31306*/ GIMT_Encode4(2297936),
     /* 2297821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2297824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2297827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297839 */   GIM_Try, /*On fail goto*//*Label 31307*/ GIMT_Encode4(2297887), // Rule ID 52668 //
     /* 2297844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297847 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2297850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2297864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297886 */     // GIR_Coverage, 52668,
     /* 2297886 */     GIR_EraseRootFromParent_Done,
     /* 2297887 */   // Label 31307: @2297887
     /* 2297887 */   GIM_Try, /*On fail goto*//*Label 31308*/ GIMT_Encode4(2297935), // Rule ID 52669 //
     /* 2297892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297895 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2297898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2297912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297934 */     // GIR_Coverage, 52669,
     /* 2297934 */     GIR_EraseRootFromParent_Done,
     /* 2297935 */   // Label 31308: @2297935
     /* 2297935 */   GIM_Reject,
     /* 2297936 */ // Label 31306: @2297936
     /* 2297936 */ GIM_Reject,
     /* 2297937 */ // Label 31249: @2297937
     /* 2297937 */ GIM_Try, /*On fail goto*//*Label 31309*/ GIMT_Encode4(2298057),
     /* 2297942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2297945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2297948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297960 */   GIM_Try, /*On fail goto*//*Label 31310*/ GIMT_Encode4(2298008), // Rule ID 52684 //
     /* 2297965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297968 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2297971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2297985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298007 */     // GIR_Coverage, 52684,
     /* 2298007 */     GIR_EraseRootFromParent_Done,
     /* 2298008 */   // Label 31310: @2298008
     /* 2298008 */   GIM_Try, /*On fail goto*//*Label 31311*/ GIMT_Encode4(2298056), // Rule ID 52685 //
     /* 2298013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298016 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2298019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2298033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298055 */     // GIR_Coverage, 52685,
     /* 2298055 */     GIR_EraseRootFromParent_Done,
     /* 2298056 */   // Label 31311: @2298056
     /* 2298056 */   GIM_Reject,
     /* 2298057 */ // Label 31309: @2298057
     /* 2298057 */ GIM_Reject,
     /* 2298058 */ // Label 31250: @2298058
     /* 2298058 */ GIM_Try, /*On fail goto*//*Label 31312*/ GIMT_Encode4(2298178),
     /* 2298063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2298066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2298069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298081 */   GIM_Try, /*On fail goto*//*Label 31313*/ GIMT_Encode4(2298129), // Rule ID 52700 //
     /* 2298086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298089 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2298092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2298106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298128 */     // GIR_Coverage, 52700,
     /* 2298128 */     GIR_EraseRootFromParent_Done,
     /* 2298129 */   // Label 31313: @2298129
     /* 2298129 */   GIM_Try, /*On fail goto*//*Label 31314*/ GIMT_Encode4(2298177), // Rule ID 52701 //
     /* 2298134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298137 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2298140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2298154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298176 */     // GIR_Coverage, 52701,
     /* 2298176 */     GIR_EraseRootFromParent_Done,
     /* 2298177 */   // Label 31314: @2298177
     /* 2298177 */   GIM_Reject,
     /* 2298178 */ // Label 31312: @2298178
     /* 2298178 */ GIM_Reject,
     /* 2298179 */ // Label 31251: @2298179
     /* 2298179 */ GIM_Try, /*On fail goto*//*Label 31315*/ GIMT_Encode4(2298299),
     /* 2298184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2298187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2298190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298202 */   GIM_Try, /*On fail goto*//*Label 31316*/ GIMT_Encode4(2298250), // Rule ID 52672 //
     /* 2298207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298210 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2298213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2298227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298249 */     // GIR_Coverage, 52672,
     /* 2298249 */     GIR_EraseRootFromParent_Done,
     /* 2298250 */   // Label 31316: @2298250
     /* 2298250 */   GIM_Try, /*On fail goto*//*Label 31317*/ GIMT_Encode4(2298298), // Rule ID 52673 //
     /* 2298255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298258 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2298261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2298275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298297 */     // GIR_Coverage, 52673,
     /* 2298297 */     GIR_EraseRootFromParent_Done,
     /* 2298298 */   // Label 31317: @2298298
     /* 2298298 */   GIM_Reject,
     /* 2298299 */ // Label 31315: @2298299
     /* 2298299 */ GIM_Reject,
     /* 2298300 */ // Label 31252: @2298300
     /* 2298300 */ GIM_Try, /*On fail goto*//*Label 31318*/ GIMT_Encode4(2298420),
     /* 2298305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2298308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2298311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298323 */   GIM_Try, /*On fail goto*//*Label 31319*/ GIMT_Encode4(2298371), // Rule ID 52688 //
     /* 2298328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298331 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2298334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2298348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298370 */     // GIR_Coverage, 52688,
     /* 2298370 */     GIR_EraseRootFromParent_Done,
     /* 2298371 */   // Label 31319: @2298371
     /* 2298371 */   GIM_Try, /*On fail goto*//*Label 31320*/ GIMT_Encode4(2298419), // Rule ID 52689 //
     /* 2298376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298379 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2298382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2298396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298418 */     // GIR_Coverage, 52689,
     /* 2298418 */     GIR_EraseRootFromParent_Done,
     /* 2298419 */   // Label 31320: @2298419
     /* 2298419 */   GIM_Reject,
     /* 2298420 */ // Label 31318: @2298420
     /* 2298420 */ GIM_Reject,
     /* 2298421 */ // Label 31253: @2298421
     /* 2298421 */ GIM_Try, /*On fail goto*//*Label 31321*/ GIMT_Encode4(2298541),
     /* 2298426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2298429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2298432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298444 */   GIM_Try, /*On fail goto*//*Label 31322*/ GIMT_Encode4(2298492), // Rule ID 52676 //
     /* 2298449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298452 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2298455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2298469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298491 */     // GIR_Coverage, 52676,
     /* 2298491 */     GIR_EraseRootFromParent_Done,
     /* 2298492 */   // Label 31322: @2298492
     /* 2298492 */   GIM_Try, /*On fail goto*//*Label 31323*/ GIMT_Encode4(2298540), // Rule ID 52677 //
     /* 2298497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298500 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2298503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2298517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298539 */     // GIR_Coverage, 52677,
     /* 2298539 */     GIR_EraseRootFromParent_Done,
     /* 2298540 */   // Label 31323: @2298540
     /* 2298540 */   GIM_Reject,
     /* 2298541 */ // Label 31321: @2298541
     /* 2298541 */ GIM_Reject,
     /* 2298542 */ // Label 31254: @2298542
     /* 2298542 */ GIM_Reject,
     /* 2298543 */ // Label 57: @2298543
     /* 2298543 */ GIM_Try, /*On fail goto*//*Label 31324*/ GIMT_Encode4(2298600),
     /* 2298548 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2298551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2298554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2298557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2298561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2298565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2298569 */   GIM_Try, /*On fail goto*//*Label 31325*/ GIMT_Encode4(2298584), // Rule ID 64574 //
     /* 2298574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2298577 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2298577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2298582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298583 */     // GIR_Coverage, 64574,
     /* 2298583 */     GIR_Done,
     /* 2298584 */   // Label 31325: @2298584
     /* 2298584 */   GIM_Try, /*On fail goto*//*Label 31326*/ GIMT_Encode4(2298599), // Rule ID 64575 //
     /* 2298589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2298592 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2298592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2298597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298598 */     // GIR_Coverage, 64575,
     /* 2298598 */     GIR_Done,
     /* 2298599 */   // Label 31326: @2298599
     /* 2298599 */   GIM_Reject,
     /* 2298600 */ // Label 31324: @2298600
     /* 2298600 */ GIM_Reject,
     /* 2298601 */ // Label 58: @2298601
     /* 2298601 */ GIM_Try, /*On fail goto*//*Label 31327*/ GIMT_Encode4(2298658),
     /* 2298606 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2298609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2298612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2298615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2298619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2298623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2298627 */   GIM_Try, /*On fail goto*//*Label 31328*/ GIMT_Encode4(2298642), // Rule ID 64576 //
     /* 2298632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2298635 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2298635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2298640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298641 */     // GIR_Coverage, 64576,
     /* 2298641 */     GIR_Done,
     /* 2298642 */   // Label 31328: @2298642
     /* 2298642 */   GIM_Try, /*On fail goto*//*Label 31329*/ GIMT_Encode4(2298657), // Rule ID 64577 //
     /* 2298647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2298650 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2298650 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2298655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298656 */     // GIR_Coverage, 64577,
     /* 2298656 */     GIR_Done,
     /* 2298657 */   // Label 31329: @2298657
     /* 2298657 */   GIM_Reject,
     /* 2298658 */ // Label 31327: @2298658
     /* 2298658 */ GIM_Reject,
     /* 2298659 */ // Label 59: @2298659
     /* 2298659 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31348*/ GIMT_Encode4(2301086),
     /* 2298670 */ /*GILLT_s16*//*Label 31330*/ GIMT_Encode4(2298790),
     /* 2298674 */ /*GILLT_s32*//*Label 31331*/ GIMT_Encode4(2298939),
     /* 2298678 */ /*GILLT_s64*//*Label 31332*/ GIMT_Encode4(2299088), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298690 */ /*GILLT_nxv1s16*//*Label 31333*/ GIMT_Encode4(2299271),
     /* 2298694 */ /*GILLT_nxv1s32*//*Label 31334*/ GIMT_Encode4(2299392),
     /* 2298698 */ /*GILLT_nxv1s64*//*Label 31335*/ GIMT_Encode4(2299513), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298710 */ /*GILLT_nxv2s16*//*Label 31336*/ GIMT_Encode4(2299634),
     /* 2298714 */ /*GILLT_nxv2s32*//*Label 31337*/ GIMT_Encode4(2299755),
     /* 2298718 */ /*GILLT_nxv2s64*//*Label 31338*/ GIMT_Encode4(2299876), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298730 */ /*GILLT_nxv4s16*//*Label 31339*/ GIMT_Encode4(2299997),
     /* 2298734 */ /*GILLT_nxv4s32*//*Label 31340*/ GIMT_Encode4(2300118),
     /* 2298738 */ /*GILLT_nxv4s64*//*Label 31341*/ GIMT_Encode4(2300239), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298750 */ /*GILLT_nxv8s16*//*Label 31342*/ GIMT_Encode4(2300360),
     /* 2298754 */ /*GILLT_nxv8s32*//*Label 31343*/ GIMT_Encode4(2300481),
     /* 2298758 */ /*GILLT_nxv8s64*//*Label 31344*/ GIMT_Encode4(2300602), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298770 */ /*GILLT_nxv16s16*//*Label 31345*/ GIMT_Encode4(2300723),
     /* 2298774 */ /*GILLT_nxv16s32*//*Label 31346*/ GIMT_Encode4(2300844), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298786 */ /*GILLT_nxv32s16*//*Label 31347*/ GIMT_Encode4(2300965),
     /* 2298790 */ // Label 31330: @2298790
     /* 2298790 */ GIM_Try, /*On fail goto*//*Label 31349*/ GIMT_Encode4(2298938),
     /* 2298795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2298798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2298801 */   GIM_Try, /*On fail goto*//*Label 31350*/ GIMT_Encode4(2298835), // Rule ID 1948 //
     /* 2298806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2298809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298821 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2298821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2298824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298834 */     // GIR_Coverage, 1948,
     /* 2298834 */     GIR_EraseRootFromParent_Done,
     /* 2298835 */   // Label 31350: @2298835
     /* 2298835 */   GIM_Try, /*On fail goto*//*Label 31351*/ GIMT_Encode4(2298869), // Rule ID 1949 //
     /* 2298840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2298843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298855 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2298855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2298858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298868 */     // GIR_Coverage, 1949,
     /* 2298868 */     GIR_EraseRootFromParent_Done,
     /* 2298869 */   // Label 31351: @2298869
     /* 2298869 */   GIM_Try, /*On fail goto*//*Label 31352*/ GIMT_Encode4(2298903), // Rule ID 1952 //
     /* 2298874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2298877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298889 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2298889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2298892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298902 */     // GIR_Coverage, 1952,
     /* 2298902 */     GIR_EraseRootFromParent_Done,
     /* 2298903 */   // Label 31352: @2298903
     /* 2298903 */   GIM_Try, /*On fail goto*//*Label 31353*/ GIMT_Encode4(2298937), // Rule ID 1953 //
     /* 2298908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2298911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298923 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2298923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2298926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298936 */     // GIR_Coverage, 1953,
     /* 2298936 */     GIR_EraseRootFromParent_Done,
     /* 2298937 */   // Label 31353: @2298937
     /* 2298937 */   GIM_Reject,
     /* 2298938 */ // Label 31349: @2298938
     /* 2298938 */ GIM_Reject,
     /* 2298939 */ // Label 31331: @2298939
     /* 2298939 */ GIM_Try, /*On fail goto*//*Label 31354*/ GIMT_Encode4(2299087),
     /* 2298944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2298947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2298950 */   GIM_Try, /*On fail goto*//*Label 31355*/ GIMT_Encode4(2298984), // Rule ID 1239 //
     /* 2298955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2298958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298970 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2298970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2298973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298983 */     // GIR_Coverage, 1239,
     /* 2298983 */     GIR_EraseRootFromParent_Done,
     /* 2298984 */   // Label 31355: @2298984
     /* 2298984 */   GIM_Try, /*On fail goto*//*Label 31356*/ GIMT_Encode4(2299018), // Rule ID 1240 //
     /* 2298989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2298992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2299000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2299004 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2299004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2299007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299017 */     // GIR_Coverage, 1240,
     /* 2299017 */     GIR_EraseRootFromParent_Done,
     /* 2299018 */   // Label 31356: @2299018
     /* 2299018 */   GIM_Try, /*On fail goto*//*Label 31357*/ GIMT_Encode4(2299052), // Rule ID 1243 //
     /* 2299023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2299026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2299030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2299034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2299038 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2299038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2299041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299051 */     // GIR_Coverage, 1243,
     /* 2299051 */     GIR_EraseRootFromParent_Done,
     /* 2299052 */   // Label 31357: @2299052
     /* 2299052 */   GIM_Try, /*On fail goto*//*Label 31358*/ GIMT_Encode4(2299086), // Rule ID 1244 //
     /* 2299057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2299060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2299064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2299068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2299072 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2299072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2299075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299085 */     // GIR_Coverage, 1244,
     /* 2299085 */     GIR_EraseRootFromParent_Done,
     /* 2299086 */   // Label 31358: @2299086
     /* 2299086 */   GIM_Reject,
     /* 2299087 */ // Label 31354: @2299087
     /* 2299087 */ GIM_Reject,
     /* 2299088 */ // Label 31332: @2299088
     /* 2299088 */ GIM_Try, /*On fail goto*//*Label 31359*/ GIMT_Encode4(2299270),
     /* 2299093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2299096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2299099 */   GIM_Try, /*On fail goto*//*Label 31360*/ GIMT_Encode4(2299133), // Rule ID 1574 //
     /* 2299104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2299107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299119 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2299119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2299122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299132 */     // GIR_Coverage, 1574,
     /* 2299132 */     GIR_EraseRootFromParent_Done,
     /* 2299133 */   // Label 31360: @2299133
     /* 2299133 */   GIM_Try, /*On fail goto*//*Label 31361*/ GIMT_Encode4(2299167), // Rule ID 1575 //
     /* 2299138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2299141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299153 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2299153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2299156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299166 */     // GIR_Coverage, 1575,
     /* 2299166 */     GIR_EraseRootFromParent_Done,
     /* 2299167 */   // Label 31361: @2299167
     /* 2299167 */   GIM_Try, /*On fail goto*//*Label 31362*/ GIMT_Encode4(2299201), // Rule ID 1578 //
     /* 2299172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2299175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299187 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2299187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2299190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299200 */     // GIR_Coverage, 1578,
     /* 2299200 */     GIR_EraseRootFromParent_Done,
     /* 2299201 */   // Label 31362: @2299201
     /* 2299201 */   GIM_Try, /*On fail goto*//*Label 31363*/ GIMT_Encode4(2299235), // Rule ID 1579 //
     /* 2299206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2299209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299221 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2299221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2299224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299234 */     // GIR_Coverage, 1579,
     /* 2299234 */     GIR_EraseRootFromParent_Done,
     /* 2299235 */   // Label 31363: @2299235
     /* 2299235 */   GIM_Try, /*On fail goto*//*Label 31364*/ GIMT_Encode4(2299269), // Rule ID 1581 //
     /* 2299240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2299243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2299247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2299251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2299255 */     // (fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2299255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2299258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299268 */     // GIR_Coverage, 1581,
     /* 2299268 */     GIR_EraseRootFromParent_Done,
     /* 2299269 */   // Label 31364: @2299269
     /* 2299269 */   GIM_Reject,
     /* 2299270 */ // Label 31359: @2299270
     /* 2299270 */ GIM_Reject,
     /* 2299271 */ // Label 31333: @2299271
     /* 2299271 */ GIM_Try, /*On fail goto*//*Label 31365*/ GIMT_Encode4(2299391),
     /* 2299276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2299279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2299282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299294 */   GIM_Try, /*On fail goto*//*Label 31366*/ GIMT_Encode4(2299342), // Rule ID 45752 //
     /* 2299299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2299302 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2299305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2299319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299341 */     // GIR_Coverage, 45752,
     /* 2299341 */     GIR_EraseRootFromParent_Done,
     /* 2299342 */   // Label 31366: @2299342
     /* 2299342 */   GIM_Try, /*On fail goto*//*Label 31367*/ GIMT_Encode4(2299390), // Rule ID 45753 //
     /* 2299347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2299350 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2299353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2299367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299389 */     // GIR_Coverage, 45753,
     /* 2299389 */     GIR_EraseRootFromParent_Done,
     /* 2299390 */   // Label 31367: @2299390
     /* 2299390 */   GIM_Reject,
     /* 2299391 */ // Label 31365: @2299391
     /* 2299391 */ GIM_Reject,
     /* 2299392 */ // Label 31334: @2299392
     /* 2299392 */ GIM_Try, /*On fail goto*//*Label 31368*/ GIMT_Encode4(2299512),
     /* 2299397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2299400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2299403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299415 */   GIM_Try, /*On fail goto*//*Label 31369*/ GIMT_Encode4(2299463), // Rule ID 53292 //
     /* 2299420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2299423 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2299426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2299440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299462 */     // GIR_Coverage, 53292,
     /* 2299462 */     GIR_EraseRootFromParent_Done,
     /* 2299463 */   // Label 31369: @2299463
     /* 2299463 */   GIM_Try, /*On fail goto*//*Label 31370*/ GIMT_Encode4(2299511), // Rule ID 53293 //
     /* 2299468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2299471 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2299474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2299488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299510 */     // GIR_Coverage, 53293,
     /* 2299510 */     GIR_EraseRootFromParent_Done,
     /* 2299511 */   // Label 31370: @2299511
     /* 2299511 */   GIM_Reject,
     /* 2299512 */ // Label 31368: @2299512
     /* 2299512 */ GIM_Reject,
     /* 2299513 */ // Label 31335: @2299513
     /* 2299513 */ GIM_Try, /*On fail goto*//*Label 31371*/ GIMT_Encode4(2299633),
     /* 2299518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2299524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299536 */   GIM_Try, /*On fail goto*//*Label 31372*/ GIMT_Encode4(2299584), // Rule ID 53328 //
     /* 2299541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299544 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2299547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2299561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299583 */     // GIR_Coverage, 53328,
     /* 2299583 */     GIR_EraseRootFromParent_Done,
     /* 2299584 */   // Label 31372: @2299584
     /* 2299584 */   GIM_Try, /*On fail goto*//*Label 31373*/ GIMT_Encode4(2299632), // Rule ID 53329 //
     /* 2299589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299592 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2299595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2299609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299631 */     // GIR_Coverage, 53329,
     /* 2299631 */     GIR_EraseRootFromParent_Done,
     /* 2299632 */   // Label 31373: @2299632
     /* 2299632 */   GIM_Reject,
     /* 2299633 */ // Label 31371: @2299633
     /* 2299633 */ GIM_Reject,
     /* 2299634 */ // Label 31336: @2299634
     /* 2299634 */ GIM_Try, /*On fail goto*//*Label 31374*/ GIMT_Encode4(2299754),
     /* 2299639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2299645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299657 */   GIM_Try, /*On fail goto*//*Label 31375*/ GIMT_Encode4(2299705), // Rule ID 53280 //
     /* 2299662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2299665 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2299668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2299682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299704 */     // GIR_Coverage, 53280,
     /* 2299704 */     GIR_EraseRootFromParent_Done,
     /* 2299705 */   // Label 31375: @2299705
     /* 2299705 */   GIM_Try, /*On fail goto*//*Label 31376*/ GIMT_Encode4(2299753), // Rule ID 53281 //
     /* 2299710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2299713 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2299716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2299730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299752 */     // GIR_Coverage, 53281,
     /* 2299752 */     GIR_EraseRootFromParent_Done,
     /* 2299753 */   // Label 31376: @2299753
     /* 2299753 */   GIM_Reject,
     /* 2299754 */ // Label 31374: @2299754
     /* 2299754 */ GIM_Reject,
     /* 2299755 */ // Label 31337: @2299755
     /* 2299755 */ GIM_Try, /*On fail goto*//*Label 31377*/ GIMT_Encode4(2299875),
     /* 2299760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2299763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2299766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299778 */   GIM_Try, /*On fail goto*//*Label 31378*/ GIMT_Encode4(2299826), // Rule ID 53316 //
     /* 2299783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2299786 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2299789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2299803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299825 */     // GIR_Coverage, 53316,
     /* 2299825 */     GIR_EraseRootFromParent_Done,
     /* 2299826 */   // Label 31378: @2299826
     /* 2299826 */   GIM_Try, /*On fail goto*//*Label 31379*/ GIMT_Encode4(2299874), // Rule ID 53317 //
     /* 2299831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2299834 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2299837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2299851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299873 */     // GIR_Coverage, 53317,
     /* 2299873 */     GIR_EraseRootFromParent_Done,
     /* 2299874 */   // Label 31379: @2299874
     /* 2299874 */   GIM_Reject,
     /* 2299875 */ // Label 31377: @2299875
     /* 2299875 */ GIM_Reject,
     /* 2299876 */ // Label 31338: @2299876
     /* 2299876 */ GIM_Try, /*On fail goto*//*Label 31380*/ GIMT_Encode4(2299996),
     /* 2299881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2299884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2299887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299899 */   GIM_Try, /*On fail goto*//*Label 31381*/ GIMT_Encode4(2299947), // Rule ID 53412 //
     /* 2299904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299907 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2299910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2299924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299946 */     // GIR_Coverage, 53412,
     /* 2299946 */     GIR_EraseRootFromParent_Done,
     /* 2299947 */   // Label 31381: @2299947
     /* 2299947 */   GIM_Try, /*On fail goto*//*Label 31382*/ GIMT_Encode4(2299995), // Rule ID 53413 //
     /* 2299952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299955 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2299958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2299972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299994 */     // GIR_Coverage, 53413,
     /* 2299994 */     GIR_EraseRootFromParent_Done,
     /* 2299995 */   // Label 31382: @2299995
     /* 2299995 */   GIM_Reject,
     /* 2299996 */ // Label 31380: @2299996
     /* 2299996 */ GIM_Reject,
     /* 2299997 */ // Label 31339: @2299997
     /* 2299997 */ GIM_Try, /*On fail goto*//*Label 31383*/ GIMT_Encode4(2300117),
     /* 2300002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2300005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2300008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300020 */   GIM_Try, /*On fail goto*//*Label 31384*/ GIMT_Encode4(2300068), // Rule ID 53304 //
     /* 2300025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300028 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2300031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2300045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300067 */     // GIR_Coverage, 53304,
     /* 2300067 */     GIR_EraseRootFromParent_Done,
     /* 2300068 */   // Label 31384: @2300068
     /* 2300068 */   GIM_Try, /*On fail goto*//*Label 31385*/ GIMT_Encode4(2300116), // Rule ID 53305 //
     /* 2300073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300076 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2300079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2300093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300115 */     // GIR_Coverage, 53305,
     /* 2300115 */     GIR_EraseRootFromParent_Done,
     /* 2300116 */   // Label 31385: @2300116
     /* 2300116 */   GIM_Reject,
     /* 2300117 */ // Label 31383: @2300117
     /* 2300117 */ GIM_Reject,
     /* 2300118 */ // Label 31340: @2300118
     /* 2300118 */ GIM_Try, /*On fail goto*//*Label 31386*/ GIMT_Encode4(2300238),
     /* 2300123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2300126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2300129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300141 */   GIM_Try, /*On fail goto*//*Label 31387*/ GIMT_Encode4(2300189), // Rule ID 53376 //
     /* 2300146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300149 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2300152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2300166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300188 */     // GIR_Coverage, 53376,
     /* 2300188 */     GIR_EraseRootFromParent_Done,
     /* 2300189 */   // Label 31387: @2300189
     /* 2300189 */   GIM_Try, /*On fail goto*//*Label 31388*/ GIMT_Encode4(2300237), // Rule ID 53377 //
     /* 2300194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300197 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2300200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2300214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300236 */     // GIR_Coverage, 53377,
     /* 2300236 */     GIR_EraseRootFromParent_Done,
     /* 2300237 */   // Label 31388: @2300237
     /* 2300237 */   GIM_Reject,
     /* 2300238 */ // Label 31386: @2300238
     /* 2300238 */ GIM_Reject,
     /* 2300239 */ // Label 31341: @2300239
     /* 2300239 */ GIM_Try, /*On fail goto*//*Label 31389*/ GIMT_Encode4(2300359),
     /* 2300244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2300247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2300250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300262 */   GIM_Try, /*On fail goto*//*Label 31390*/ GIMT_Encode4(2300310), // Rule ID 53424 //
     /* 2300267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2300270 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2300273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2300287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300309 */     // GIR_Coverage, 53424,
     /* 2300309 */     GIR_EraseRootFromParent_Done,
     /* 2300310 */   // Label 31390: @2300310
     /* 2300310 */   GIM_Try, /*On fail goto*//*Label 31391*/ GIMT_Encode4(2300358), // Rule ID 53425 //
     /* 2300315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2300318 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2300321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2300335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300357 */     // GIR_Coverage, 53425,
     /* 2300357 */     GIR_EraseRootFromParent_Done,
     /* 2300358 */   // Label 31391: @2300358
     /* 2300358 */   GIM_Reject,
     /* 2300359 */ // Label 31389: @2300359
     /* 2300359 */ GIM_Reject,
     /* 2300360 */ // Label 31342: @2300360
     /* 2300360 */ GIM_Try, /*On fail goto*//*Label 31392*/ GIMT_Encode4(2300480),
     /* 2300365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2300371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300383 */   GIM_Try, /*On fail goto*//*Label 31393*/ GIMT_Encode4(2300431), // Rule ID 53340 //
     /* 2300388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300391 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2300394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2300408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300430 */     // GIR_Coverage, 53340,
     /* 2300430 */     GIR_EraseRootFromParent_Done,
     /* 2300431 */   // Label 31393: @2300431
     /* 2300431 */   GIM_Try, /*On fail goto*//*Label 31394*/ GIMT_Encode4(2300479), // Rule ID 53341 //
     /* 2300436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300439 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2300442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2300456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300478 */     // GIR_Coverage, 53341,
     /* 2300478 */     GIR_EraseRootFromParent_Done,
     /* 2300479 */   // Label 31394: @2300479
     /* 2300479 */   GIM_Reject,
     /* 2300480 */ // Label 31392: @2300480
     /* 2300480 */ GIM_Reject,
     /* 2300481 */ // Label 31343: @2300481
     /* 2300481 */ GIM_Try, /*On fail goto*//*Label 31395*/ GIMT_Encode4(2300601),
     /* 2300486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2300489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2300492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300504 */   GIM_Try, /*On fail goto*//*Label 31396*/ GIMT_Encode4(2300552), // Rule ID 53388 //
     /* 2300509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300512 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2300515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2300529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300551 */     // GIR_Coverage, 53388,
     /* 2300551 */     GIR_EraseRootFromParent_Done,
     /* 2300552 */   // Label 31396: @2300552
     /* 2300552 */   GIM_Try, /*On fail goto*//*Label 31397*/ GIMT_Encode4(2300600), // Rule ID 53389 //
     /* 2300557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300560 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2300563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2300577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300599 */     // GIR_Coverage, 53389,
     /* 2300599 */     GIR_EraseRootFromParent_Done,
     /* 2300600 */   // Label 31397: @2300600
     /* 2300600 */   GIM_Reject,
     /* 2300601 */ // Label 31395: @2300601
     /* 2300601 */ GIM_Reject,
     /* 2300602 */ // Label 31344: @2300602
     /* 2300602 */ GIM_Try, /*On fail goto*//*Label 31398*/ GIMT_Encode4(2300722),
     /* 2300607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2300610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2300613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300625 */   GIM_Try, /*On fail goto*//*Label 31399*/ GIMT_Encode4(2300673), // Rule ID 53436 //
     /* 2300630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2300633 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2300636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2300650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300672 */     // GIR_Coverage, 53436,
     /* 2300672 */     GIR_EraseRootFromParent_Done,
     /* 2300673 */   // Label 31399: @2300673
     /* 2300673 */   GIM_Try, /*On fail goto*//*Label 31400*/ GIMT_Encode4(2300721), // Rule ID 53437 //
     /* 2300678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2300681 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2300684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2300698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300720 */     // GIR_Coverage, 53437,
     /* 2300720 */     GIR_EraseRootFromParent_Done,
     /* 2300721 */   // Label 31400: @2300721
     /* 2300721 */   GIM_Reject,
     /* 2300722 */ // Label 31398: @2300722
     /* 2300722 */ GIM_Reject,
     /* 2300723 */ // Label 31345: @2300723
     /* 2300723 */ GIM_Try, /*On fail goto*//*Label 31401*/ GIMT_Encode4(2300843),
     /* 2300728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2300731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2300734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300746 */   GIM_Try, /*On fail goto*//*Label 31402*/ GIMT_Encode4(2300794), // Rule ID 53352 //
     /* 2300751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300754 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2300757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2300771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300793 */     // GIR_Coverage, 53352,
     /* 2300793 */     GIR_EraseRootFromParent_Done,
     /* 2300794 */   // Label 31402: @2300794
     /* 2300794 */   GIM_Try, /*On fail goto*//*Label 31403*/ GIMT_Encode4(2300842), // Rule ID 53353 //
     /* 2300799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300802 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2300805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2300819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300841 */     // GIR_Coverage, 53353,
     /* 2300841 */     GIR_EraseRootFromParent_Done,
     /* 2300842 */   // Label 31403: @2300842
     /* 2300842 */   GIM_Reject,
     /* 2300843 */ // Label 31401: @2300843
     /* 2300843 */ GIM_Reject,
     /* 2300844 */ // Label 31346: @2300844
     /* 2300844 */ GIM_Try, /*On fail goto*//*Label 31404*/ GIMT_Encode4(2300964),
     /* 2300849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2300852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2300855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300867 */   GIM_Try, /*On fail goto*//*Label 31405*/ GIMT_Encode4(2300915), // Rule ID 53400 //
     /* 2300872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300875 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2300878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2300892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300914 */     // GIR_Coverage, 53400,
     /* 2300914 */     GIR_EraseRootFromParent_Done,
     /* 2300915 */   // Label 31405: @2300915
     /* 2300915 */   GIM_Try, /*On fail goto*//*Label 31406*/ GIMT_Encode4(2300963), // Rule ID 53401 //
     /* 2300920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300923 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2300926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2300940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300962 */     // GIR_Coverage, 53401,
     /* 2300962 */     GIR_EraseRootFromParent_Done,
     /* 2300963 */   // Label 31406: @2300963
     /* 2300963 */   GIM_Reject,
     /* 2300964 */ // Label 31404: @2300964
     /* 2300964 */ GIM_Reject,
     /* 2300965 */ // Label 31347: @2300965
     /* 2300965 */ GIM_Try, /*On fail goto*//*Label 31407*/ GIMT_Encode4(2301085),
     /* 2300970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2300973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2300976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300988 */   GIM_Try, /*On fail goto*//*Label 31408*/ GIMT_Encode4(2301036), // Rule ID 53364 //
     /* 2300993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300996 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2300999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2301013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301035 */     // GIR_Coverage, 53364,
     /* 2301035 */     GIR_EraseRootFromParent_Done,
     /* 2301036 */   // Label 31408: @2301036
     /* 2301036 */   GIM_Try, /*On fail goto*//*Label 31409*/ GIMT_Encode4(2301084), // Rule ID 53365 //
     /* 2301041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2301044 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2301047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2301061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301083 */     // GIR_Coverage, 53365,
     /* 2301083 */     GIR_EraseRootFromParent_Done,
     /* 2301084 */   // Label 31409: @2301084
     /* 2301084 */   GIM_Reject,
     /* 2301085 */ // Label 31407: @2301085
     /* 2301085 */ GIM_Reject,
     /* 2301086 */ // Label 31348: @2301086
     /* 2301086 */ GIM_Reject,
     /* 2301087 */ // Label 60: @2301087
     /* 2301087 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31428*/ GIMT_Encode4(2303514),
     /* 2301098 */ /*GILLT_s16*//*Label 31410*/ GIMT_Encode4(2301218),
     /* 2301102 */ /*GILLT_s32*//*Label 31411*/ GIMT_Encode4(2301367),
     /* 2301106 */ /*GILLT_s64*//*Label 31412*/ GIMT_Encode4(2301516), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301118 */ /*GILLT_nxv1s16*//*Label 31413*/ GIMT_Encode4(2301699),
     /* 2301122 */ /*GILLT_nxv1s32*//*Label 31414*/ GIMT_Encode4(2301820),
     /* 2301126 */ /*GILLT_nxv1s64*//*Label 31415*/ GIMT_Encode4(2301941), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301138 */ /*GILLT_nxv2s16*//*Label 31416*/ GIMT_Encode4(2302062),
     /* 2301142 */ /*GILLT_nxv2s32*//*Label 31417*/ GIMT_Encode4(2302183),
     /* 2301146 */ /*GILLT_nxv2s64*//*Label 31418*/ GIMT_Encode4(2302304), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301158 */ /*GILLT_nxv4s16*//*Label 31419*/ GIMT_Encode4(2302425),
     /* 2301162 */ /*GILLT_nxv4s32*//*Label 31420*/ GIMT_Encode4(2302546),
     /* 2301166 */ /*GILLT_nxv4s64*//*Label 31421*/ GIMT_Encode4(2302667), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301178 */ /*GILLT_nxv8s16*//*Label 31422*/ GIMT_Encode4(2302788),
     /* 2301182 */ /*GILLT_nxv8s32*//*Label 31423*/ GIMT_Encode4(2302909),
     /* 2301186 */ /*GILLT_nxv8s64*//*Label 31424*/ GIMT_Encode4(2303030), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301198 */ /*GILLT_nxv16s16*//*Label 31425*/ GIMT_Encode4(2303151),
     /* 2301202 */ /*GILLT_nxv16s32*//*Label 31426*/ GIMT_Encode4(2303272), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301214 */ /*GILLT_nxv32s16*//*Label 31427*/ GIMT_Encode4(2303393),
     /* 2301218 */ // Label 31410: @2301218
     /* 2301218 */ GIM_Try, /*On fail goto*//*Label 31429*/ GIMT_Encode4(2301366),
     /* 2301223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2301226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2301229 */   GIM_Try, /*On fail goto*//*Label 31430*/ GIMT_Encode4(2301263), // Rule ID 1956 //
     /* 2301234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2301237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301249 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2301249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2301252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301262 */     // GIR_Coverage, 1956,
     /* 2301262 */     GIR_EraseRootFromParent_Done,
     /* 2301263 */   // Label 31430: @2301263
     /* 2301263 */   GIM_Try, /*On fail goto*//*Label 31431*/ GIMT_Encode4(2301297), // Rule ID 1957 //
     /* 2301268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2301271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301283 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2301283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2301286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301296 */     // GIR_Coverage, 1957,
     /* 2301296 */     GIR_EraseRootFromParent_Done,
     /* 2301297 */   // Label 31431: @2301297
     /* 2301297 */   GIM_Try, /*On fail goto*//*Label 31432*/ GIMT_Encode4(2301331), // Rule ID 1960 //
     /* 2301302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2301305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301317 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2301317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2301320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301330 */     // GIR_Coverage, 1960,
     /* 2301330 */     GIR_EraseRootFromParent_Done,
     /* 2301331 */   // Label 31432: @2301331
     /* 2301331 */   GIM_Try, /*On fail goto*//*Label 31433*/ GIMT_Encode4(2301365), // Rule ID 1961 //
     /* 2301336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2301339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301351 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2301351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2301354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301364 */     // GIR_Coverage, 1961,
     /* 2301364 */     GIR_EraseRootFromParent_Done,
     /* 2301365 */   // Label 31433: @2301365
     /* 2301365 */   GIM_Reject,
     /* 2301366 */ // Label 31429: @2301366
     /* 2301366 */ GIM_Reject,
     /* 2301367 */ // Label 31411: @2301367
     /* 2301367 */ GIM_Try, /*On fail goto*//*Label 31434*/ GIMT_Encode4(2301515),
     /* 2301372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2301375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2301378 */   GIM_Try, /*On fail goto*//*Label 31435*/ GIMT_Encode4(2301412), // Rule ID 1247 //
     /* 2301383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2301386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301398 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2301398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2301401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301411 */     // GIR_Coverage, 1247,
     /* 2301411 */     GIR_EraseRootFromParent_Done,
     /* 2301412 */   // Label 31435: @2301412
     /* 2301412 */   GIM_Try, /*On fail goto*//*Label 31436*/ GIMT_Encode4(2301446), // Rule ID 1248 //
     /* 2301417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2301420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301432 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2301432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2301435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301445 */     // GIR_Coverage, 1248,
     /* 2301445 */     GIR_EraseRootFromParent_Done,
     /* 2301446 */   // Label 31436: @2301446
     /* 2301446 */   GIM_Try, /*On fail goto*//*Label 31437*/ GIMT_Encode4(2301480), // Rule ID 1251 //
     /* 2301451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2301454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301466 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2301466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2301469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301479 */     // GIR_Coverage, 1251,
     /* 2301479 */     GIR_EraseRootFromParent_Done,
     /* 2301480 */   // Label 31437: @2301480
     /* 2301480 */   GIM_Try, /*On fail goto*//*Label 31438*/ GIMT_Encode4(2301514), // Rule ID 1252 //
     /* 2301485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2301488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301500 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2301500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2301503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301513 */     // GIR_Coverage, 1252,
     /* 2301513 */     GIR_EraseRootFromParent_Done,
     /* 2301514 */   // Label 31438: @2301514
     /* 2301514 */   GIM_Reject,
     /* 2301515 */ // Label 31434: @2301515
     /* 2301515 */ GIM_Reject,
     /* 2301516 */ // Label 31412: @2301516
     /* 2301516 */ GIM_Try, /*On fail goto*//*Label 31439*/ GIMT_Encode4(2301698),
     /* 2301521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2301524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2301527 */   GIM_Try, /*On fail goto*//*Label 31440*/ GIMT_Encode4(2301561), // Rule ID 1584 //
     /* 2301532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2301535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301547 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2301547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2301550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301560 */     // GIR_Coverage, 1584,
     /* 2301560 */     GIR_EraseRootFromParent_Done,
     /* 2301561 */   // Label 31440: @2301561
     /* 2301561 */   GIM_Try, /*On fail goto*//*Label 31441*/ GIMT_Encode4(2301595), // Rule ID 1585 //
     /* 2301566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2301569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301581 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2301581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2301584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301594 */     // GIR_Coverage, 1585,
     /* 2301594 */     GIR_EraseRootFromParent_Done,
     /* 2301595 */   // Label 31441: @2301595
     /* 2301595 */   GIM_Try, /*On fail goto*//*Label 31442*/ GIMT_Encode4(2301629), // Rule ID 1588 //
     /* 2301600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2301603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301615 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2301615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2301618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301628 */     // GIR_Coverage, 1588,
     /* 2301628 */     GIR_EraseRootFromParent_Done,
     /* 2301629 */   // Label 31442: @2301629
     /* 2301629 */   GIM_Try, /*On fail goto*//*Label 31443*/ GIMT_Encode4(2301663), // Rule ID 1589 //
     /* 2301634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2301637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301649 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2301649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2301652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301662 */     // GIR_Coverage, 1589,
     /* 2301662 */     GIR_EraseRootFromParent_Done,
     /* 2301663 */   // Label 31443: @2301663
     /* 2301663 */   GIM_Try, /*On fail goto*//*Label 31444*/ GIMT_Encode4(2301697), // Rule ID 1591 //
     /* 2301668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2301671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301683 */     // (fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2301683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2301686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301696 */     // GIR_Coverage, 1591,
     /* 2301696 */     GIR_EraseRootFromParent_Done,
     /* 2301697 */   // Label 31444: @2301697
     /* 2301697 */   GIM_Reject,
     /* 2301698 */ // Label 31439: @2301698
     /* 2301698 */ GIM_Reject,
     /* 2301699 */ // Label 31413: @2301699
     /* 2301699 */ GIM_Try, /*On fail goto*//*Label 31445*/ GIMT_Encode4(2301819),
     /* 2301704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2301707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2301710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301722 */   GIM_Try, /*On fail goto*//*Label 31446*/ GIMT_Encode4(2301770), // Rule ID 53448 //
     /* 2301727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2301730 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2301733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2301747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301769 */     // GIR_Coverage, 53448,
     /* 2301769 */     GIR_EraseRootFromParent_Done,
     /* 2301770 */   // Label 31446: @2301770
     /* 2301770 */   GIM_Try, /*On fail goto*//*Label 31447*/ GIMT_Encode4(2301818), // Rule ID 53449 //
     /* 2301775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2301778 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2301781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2301795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301817 */     // GIR_Coverage, 53449,
     /* 2301817 */     GIR_EraseRootFromParent_Done,
     /* 2301818 */   // Label 31447: @2301818
     /* 2301818 */   GIM_Reject,
     /* 2301819 */ // Label 31445: @2301819
     /* 2301819 */ GIM_Reject,
     /* 2301820 */ // Label 31414: @2301820
     /* 2301820 */ GIM_Try, /*On fail goto*//*Label 31448*/ GIMT_Encode4(2301940),
     /* 2301825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2301828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2301831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301843 */   GIM_Try, /*On fail goto*//*Label 31449*/ GIMT_Encode4(2301891), // Rule ID 53472 //
     /* 2301848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2301851 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2301854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2301868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301890 */     // GIR_Coverage, 53472,
     /* 2301890 */     GIR_EraseRootFromParent_Done,
     /* 2301891 */   // Label 31449: @2301891
     /* 2301891 */   GIM_Try, /*On fail goto*//*Label 31450*/ GIMT_Encode4(2301939), // Rule ID 53473 //
     /* 2301896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2301899 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2301902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2301916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301938 */     // GIR_Coverage, 53473,
     /* 2301938 */     GIR_EraseRootFromParent_Done,
     /* 2301939 */   // Label 31450: @2301939
     /* 2301939 */   GIM_Reject,
     /* 2301940 */ // Label 31448: @2301940
     /* 2301940 */ GIM_Reject,
     /* 2301941 */ // Label 31415: @2301941
     /* 2301941 */ GIM_Try, /*On fail goto*//*Label 31451*/ GIMT_Encode4(2302061),
     /* 2301946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2301949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2301952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301964 */   GIM_Try, /*On fail goto*//*Label 31452*/ GIMT_Encode4(2302012), // Rule ID 53508 //
     /* 2301969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2301972 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2301975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2301989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302011 */     // GIR_Coverage, 53508,
     /* 2302011 */     GIR_EraseRootFromParent_Done,
     /* 2302012 */   // Label 31452: @2302012
     /* 2302012 */   GIM_Try, /*On fail goto*//*Label 31453*/ GIMT_Encode4(2302060), // Rule ID 53509 //
     /* 2302017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2302020 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2302023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2302037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302059 */     // GIR_Coverage, 53509,
     /* 2302059 */     GIR_EraseRootFromParent_Done,
     /* 2302060 */   // Label 31453: @2302060
     /* 2302060 */   GIM_Reject,
     /* 2302061 */ // Label 31451: @2302061
     /* 2302061 */ GIM_Reject,
     /* 2302062 */ // Label 31416: @2302062
     /* 2302062 */ GIM_Try, /*On fail goto*//*Label 31454*/ GIMT_Encode4(2302182),
     /* 2302067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2302070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2302073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302085 */   GIM_Try, /*On fail goto*//*Label 31455*/ GIMT_Encode4(2302133), // Rule ID 53460 //
     /* 2302090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302093 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2302096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2302110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302132 */     // GIR_Coverage, 53460,
     /* 2302132 */     GIR_EraseRootFromParent_Done,
     /* 2302133 */   // Label 31455: @2302133
     /* 2302133 */   GIM_Try, /*On fail goto*//*Label 31456*/ GIMT_Encode4(2302181), // Rule ID 53461 //
     /* 2302138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302141 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2302144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2302158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302180 */     // GIR_Coverage, 53461,
     /* 2302180 */     GIR_EraseRootFromParent_Done,
     /* 2302181 */   // Label 31456: @2302181
     /* 2302181 */   GIM_Reject,
     /* 2302182 */ // Label 31454: @2302182
     /* 2302182 */ GIM_Reject,
     /* 2302183 */ // Label 31417: @2302183
     /* 2302183 */ GIM_Try, /*On fail goto*//*Label 31457*/ GIMT_Encode4(2302303),
     /* 2302188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2302191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2302194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302206 */   GIM_Try, /*On fail goto*//*Label 31458*/ GIMT_Encode4(2302254), // Rule ID 53496 //
     /* 2302211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2302214 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2302217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2302231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302253 */     // GIR_Coverage, 53496,
     /* 2302253 */     GIR_EraseRootFromParent_Done,
     /* 2302254 */   // Label 31458: @2302254
     /* 2302254 */   GIM_Try, /*On fail goto*//*Label 31459*/ GIMT_Encode4(2302302), // Rule ID 53497 //
     /* 2302259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2302262 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2302265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2302279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302301 */     // GIR_Coverage, 53497,
     /* 2302301 */     GIR_EraseRootFromParent_Done,
     /* 2302302 */   // Label 31459: @2302302
     /* 2302302 */   GIM_Reject,
     /* 2302303 */ // Label 31457: @2302303
     /* 2302303 */ GIM_Reject,
     /* 2302304 */ // Label 31418: @2302304
     /* 2302304 */ GIM_Try, /*On fail goto*//*Label 31460*/ GIMT_Encode4(2302424),
     /* 2302309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2302312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2302315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302327 */   GIM_Try, /*On fail goto*//*Label 31461*/ GIMT_Encode4(2302375), // Rule ID 53592 //
     /* 2302332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2302335 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2302338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2302352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302374 */     // GIR_Coverage, 53592,
     /* 2302374 */     GIR_EraseRootFromParent_Done,
     /* 2302375 */   // Label 31461: @2302375
     /* 2302375 */   GIM_Try, /*On fail goto*//*Label 31462*/ GIMT_Encode4(2302423), // Rule ID 53593 //
     /* 2302380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2302383 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2302386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2302400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302422 */     // GIR_Coverage, 53593,
     /* 2302422 */     GIR_EraseRootFromParent_Done,
     /* 2302423 */   // Label 31462: @2302423
     /* 2302423 */   GIM_Reject,
     /* 2302424 */ // Label 31460: @2302424
     /* 2302424 */ GIM_Reject,
     /* 2302425 */ // Label 31419: @2302425
     /* 2302425 */ GIM_Try, /*On fail goto*//*Label 31463*/ GIMT_Encode4(2302545),
     /* 2302430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2302436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302448 */   GIM_Try, /*On fail goto*//*Label 31464*/ GIMT_Encode4(2302496), // Rule ID 53484 //
     /* 2302453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302456 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2302459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2302473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302495 */     // GIR_Coverage, 53484,
     /* 2302495 */     GIR_EraseRootFromParent_Done,
     /* 2302496 */   // Label 31464: @2302496
     /* 2302496 */   GIM_Try, /*On fail goto*//*Label 31465*/ GIMT_Encode4(2302544), // Rule ID 53485 //
     /* 2302501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302504 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2302507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2302521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302543 */     // GIR_Coverage, 53485,
     /* 2302543 */     GIR_EraseRootFromParent_Done,
     /* 2302544 */   // Label 31465: @2302544
     /* 2302544 */   GIM_Reject,
     /* 2302545 */ // Label 31463: @2302545
     /* 2302545 */ GIM_Reject,
     /* 2302546 */ // Label 31420: @2302546
     /* 2302546 */ GIM_Try, /*On fail goto*//*Label 31466*/ GIMT_Encode4(2302666),
     /* 2302551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2302554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2302557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302569 */   GIM_Try, /*On fail goto*//*Label 31467*/ GIMT_Encode4(2302617), // Rule ID 53556 //
     /* 2302574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2302577 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2302580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2302594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302616 */     // GIR_Coverage, 53556,
     /* 2302616 */     GIR_EraseRootFromParent_Done,
     /* 2302617 */   // Label 31467: @2302617
     /* 2302617 */   GIM_Try, /*On fail goto*//*Label 31468*/ GIMT_Encode4(2302665), // Rule ID 53557 //
     /* 2302622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2302625 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2302628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2302642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302664 */     // GIR_Coverage, 53557,
     /* 2302664 */     GIR_EraseRootFromParent_Done,
     /* 2302665 */   // Label 31468: @2302665
     /* 2302665 */   GIM_Reject,
     /* 2302666 */ // Label 31466: @2302666
     /* 2302666 */ GIM_Reject,
     /* 2302667 */ // Label 31421: @2302667
     /* 2302667 */ GIM_Try, /*On fail goto*//*Label 31469*/ GIMT_Encode4(2302787),
     /* 2302672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2302675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2302678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302690 */   GIM_Try, /*On fail goto*//*Label 31470*/ GIMT_Encode4(2302738), // Rule ID 53604 //
     /* 2302695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2302698 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2302701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2302715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302737 */     // GIR_Coverage, 53604,
     /* 2302737 */     GIR_EraseRootFromParent_Done,
     /* 2302738 */   // Label 31470: @2302738
     /* 2302738 */   GIM_Try, /*On fail goto*//*Label 31471*/ GIMT_Encode4(2302786), // Rule ID 53605 //
     /* 2302743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2302746 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2302749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2302763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302785 */     // GIR_Coverage, 53605,
     /* 2302785 */     GIR_EraseRootFromParent_Done,
     /* 2302786 */   // Label 31471: @2302786
     /* 2302786 */   GIM_Reject,
     /* 2302787 */ // Label 31469: @2302787
     /* 2302787 */ GIM_Reject,
     /* 2302788 */ // Label 31422: @2302788
     /* 2302788 */ GIM_Try, /*On fail goto*//*Label 31472*/ GIMT_Encode4(2302908),
     /* 2302793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2302796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2302799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302811 */   GIM_Try, /*On fail goto*//*Label 31473*/ GIMT_Encode4(2302859), // Rule ID 53520 //
     /* 2302816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302819 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2302822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2302836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302858 */     // GIR_Coverage, 53520,
     /* 2302858 */     GIR_EraseRootFromParent_Done,
     /* 2302859 */   // Label 31473: @2302859
     /* 2302859 */   GIM_Try, /*On fail goto*//*Label 31474*/ GIMT_Encode4(2302907), // Rule ID 53521 //
     /* 2302864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302867 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2302870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2302884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302906 */     // GIR_Coverage, 53521,
     /* 2302906 */     GIR_EraseRootFromParent_Done,
     /* 2302907 */   // Label 31474: @2302907
     /* 2302907 */   GIM_Reject,
     /* 2302908 */ // Label 31472: @2302908
     /* 2302908 */ GIM_Reject,
     /* 2302909 */ // Label 31423: @2302909
     /* 2302909 */ GIM_Try, /*On fail goto*//*Label 31475*/ GIMT_Encode4(2303029),
     /* 2302914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2302917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2302920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302932 */   GIM_Try, /*On fail goto*//*Label 31476*/ GIMT_Encode4(2302980), // Rule ID 53568 //
     /* 2302937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2302940 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2302943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2302957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302979 */     // GIR_Coverage, 53568,
     /* 2302979 */     GIR_EraseRootFromParent_Done,
     /* 2302980 */   // Label 31476: @2302980
     /* 2302980 */   GIM_Try, /*On fail goto*//*Label 31477*/ GIMT_Encode4(2303028), // Rule ID 53569 //
     /* 2302985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2302988 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2302991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2303005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303027 */     // GIR_Coverage, 53569,
     /* 2303027 */     GIR_EraseRootFromParent_Done,
     /* 2303028 */   // Label 31477: @2303028
     /* 2303028 */   GIM_Reject,
     /* 2303029 */ // Label 31475: @2303029
     /* 2303029 */ GIM_Reject,
     /* 2303030 */ // Label 31424: @2303030
     /* 2303030 */ GIM_Try, /*On fail goto*//*Label 31478*/ GIMT_Encode4(2303150),
     /* 2303035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2303038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2303041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303053 */   GIM_Try, /*On fail goto*//*Label 31479*/ GIMT_Encode4(2303101), // Rule ID 53616 //
     /* 2303058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2303061 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2303064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2303078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303100 */     // GIR_Coverage, 53616,
     /* 2303100 */     GIR_EraseRootFromParent_Done,
     /* 2303101 */   // Label 31479: @2303101
     /* 2303101 */   GIM_Try, /*On fail goto*//*Label 31480*/ GIMT_Encode4(2303149), // Rule ID 53617 //
     /* 2303106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2303109 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2303112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2303126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303148 */     // GIR_Coverage, 53617,
     /* 2303148 */     GIR_EraseRootFromParent_Done,
     /* 2303149 */   // Label 31480: @2303149
     /* 2303149 */   GIM_Reject,
     /* 2303150 */ // Label 31478: @2303150
     /* 2303150 */ GIM_Reject,
     /* 2303151 */ // Label 31425: @2303151
     /* 2303151 */ GIM_Try, /*On fail goto*//*Label 31481*/ GIMT_Encode4(2303271),
     /* 2303156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2303159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2303162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303174 */   GIM_Try, /*On fail goto*//*Label 31482*/ GIMT_Encode4(2303222), // Rule ID 53532 //
     /* 2303179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2303182 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2303185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2303199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303221 */     // GIR_Coverage, 53532,
     /* 2303221 */     GIR_EraseRootFromParent_Done,
     /* 2303222 */   // Label 31482: @2303222
     /* 2303222 */   GIM_Try, /*On fail goto*//*Label 31483*/ GIMT_Encode4(2303270), // Rule ID 53533 //
     /* 2303227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2303230 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2303233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2303247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303269 */     // GIR_Coverage, 53533,
     /* 2303269 */     GIR_EraseRootFromParent_Done,
     /* 2303270 */   // Label 31483: @2303270
     /* 2303270 */   GIM_Reject,
     /* 2303271 */ // Label 31481: @2303271
     /* 2303271 */ GIM_Reject,
     /* 2303272 */ // Label 31426: @2303272
     /* 2303272 */ GIM_Try, /*On fail goto*//*Label 31484*/ GIMT_Encode4(2303392),
     /* 2303277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2303283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303295 */   GIM_Try, /*On fail goto*//*Label 31485*/ GIMT_Encode4(2303343), // Rule ID 53580 //
     /* 2303300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303303 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2303306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2303320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303342 */     // GIR_Coverage, 53580,
     /* 2303342 */     GIR_EraseRootFromParent_Done,
     /* 2303343 */   // Label 31485: @2303343
     /* 2303343 */   GIM_Try, /*On fail goto*//*Label 31486*/ GIMT_Encode4(2303391), // Rule ID 53581 //
     /* 2303348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303351 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2303354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2303368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303390 */     // GIR_Coverage, 53581,
     /* 2303390 */     GIR_EraseRootFromParent_Done,
     /* 2303391 */   // Label 31486: @2303391
     /* 2303391 */   GIM_Reject,
     /* 2303392 */ // Label 31484: @2303392
     /* 2303392 */ GIM_Reject,
     /* 2303393 */ // Label 31427: @2303393
     /* 2303393 */ GIM_Try, /*On fail goto*//*Label 31487*/ GIMT_Encode4(2303513),
     /* 2303398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2303401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2303404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303416 */   GIM_Try, /*On fail goto*//*Label 31488*/ GIMT_Encode4(2303464), // Rule ID 53544 //
     /* 2303421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2303424 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2303427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2303441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303463 */     // GIR_Coverage, 53544,
     /* 2303463 */     GIR_EraseRootFromParent_Done,
     /* 2303464 */   // Label 31488: @2303464
     /* 2303464 */   GIM_Try, /*On fail goto*//*Label 31489*/ GIMT_Encode4(2303512), // Rule ID 53545 //
     /* 2303469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2303472 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2303475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2303489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303511 */     // GIR_Coverage, 53545,
     /* 2303511 */     GIR_EraseRootFromParent_Done,
     /* 2303512 */   // Label 31489: @2303512
     /* 2303512 */   GIM_Reject,
     /* 2303513 */ // Label 31487: @2303513
     /* 2303513 */ GIM_Reject,
     /* 2303514 */ // Label 31428: @2303514
     /* 2303514 */ GIM_Reject,
     /* 2303515 */ // Label 61: @2303515
     /* 2303515 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31508*/ GIMT_Encode4(2305942),
     /* 2303526 */ /*GILLT_s16*//*Label 31490*/ GIMT_Encode4(2303646),
     /* 2303530 */ /*GILLT_s32*//*Label 31491*/ GIMT_Encode4(2303795),
     /* 2303534 */ /*GILLT_s64*//*Label 31492*/ GIMT_Encode4(2303944), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303546 */ /*GILLT_nxv1s16*//*Label 31493*/ GIMT_Encode4(2304127),
     /* 2303550 */ /*GILLT_nxv1s32*//*Label 31494*/ GIMT_Encode4(2304248),
     /* 2303554 */ /*GILLT_nxv1s64*//*Label 31495*/ GIMT_Encode4(2304369), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303566 */ /*GILLT_nxv2s16*//*Label 31496*/ GIMT_Encode4(2304490),
     /* 2303570 */ /*GILLT_nxv2s32*//*Label 31497*/ GIMT_Encode4(2304611),
     /* 2303574 */ /*GILLT_nxv2s64*//*Label 31498*/ GIMT_Encode4(2304732), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303586 */ /*GILLT_nxv4s16*//*Label 31499*/ GIMT_Encode4(2304853),
     /* 2303590 */ /*GILLT_nxv4s32*//*Label 31500*/ GIMT_Encode4(2304974),
     /* 2303594 */ /*GILLT_nxv4s64*//*Label 31501*/ GIMT_Encode4(2305095), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303606 */ /*GILLT_nxv8s16*//*Label 31502*/ GIMT_Encode4(2305216),
     /* 2303610 */ /*GILLT_nxv8s32*//*Label 31503*/ GIMT_Encode4(2305337),
     /* 2303614 */ /*GILLT_nxv8s64*//*Label 31504*/ GIMT_Encode4(2305458), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303626 */ /*GILLT_nxv16s16*//*Label 31505*/ GIMT_Encode4(2305579),
     /* 2303630 */ /*GILLT_nxv16s32*//*Label 31506*/ GIMT_Encode4(2305700), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303642 */ /*GILLT_nxv32s16*//*Label 31507*/ GIMT_Encode4(2305821),
     /* 2303646 */ // Label 31490: @2303646
     /* 2303646 */ GIM_Try, /*On fail goto*//*Label 31509*/ GIMT_Encode4(2303794),
     /* 2303651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2303657 */   GIM_Try, /*On fail goto*//*Label 31510*/ GIMT_Encode4(2303691), // Rule ID 1964 //
     /* 2303662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2303665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303677 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2303677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2303680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303690 */     // GIR_Coverage, 1964,
     /* 2303690 */     GIR_EraseRootFromParent_Done,
     /* 2303691 */   // Label 31510: @2303691
     /* 2303691 */   GIM_Try, /*On fail goto*//*Label 31511*/ GIMT_Encode4(2303725), // Rule ID 1965 //
     /* 2303696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2303699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303711 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2303711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2303714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303724 */     // GIR_Coverage, 1965,
     /* 2303724 */     GIR_EraseRootFromParent_Done,
     /* 2303725 */   // Label 31511: @2303725
     /* 2303725 */   GIM_Try, /*On fail goto*//*Label 31512*/ GIMT_Encode4(2303759), // Rule ID 1968 //
     /* 2303730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2303733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303745 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2303745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2303748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303758 */     // GIR_Coverage, 1968,
     /* 2303758 */     GIR_EraseRootFromParent_Done,
     /* 2303759 */   // Label 31512: @2303759
     /* 2303759 */   GIM_Try, /*On fail goto*//*Label 31513*/ GIMT_Encode4(2303793), // Rule ID 1969 //
     /* 2303764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2303767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303779 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2303779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2303782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303792 */     // GIR_Coverage, 1969,
     /* 2303792 */     GIR_EraseRootFromParent_Done,
     /* 2303793 */   // Label 31513: @2303793
     /* 2303793 */   GIM_Reject,
     /* 2303794 */ // Label 31509: @2303794
     /* 2303794 */ GIM_Reject,
     /* 2303795 */ // Label 31491: @2303795
     /* 2303795 */ GIM_Try, /*On fail goto*//*Label 31514*/ GIMT_Encode4(2303943),
     /* 2303800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2303803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2303806 */   GIM_Try, /*On fail goto*//*Label 31515*/ GIMT_Encode4(2303840), // Rule ID 1255 //
     /* 2303811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2303814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2303818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2303822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2303826 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2303826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2303829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303839 */     // GIR_Coverage, 1255,
     /* 2303839 */     GIR_EraseRootFromParent_Done,
     /* 2303840 */   // Label 31515: @2303840
     /* 2303840 */   GIM_Try, /*On fail goto*//*Label 31516*/ GIMT_Encode4(2303874), // Rule ID 1256 //
     /* 2303845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2303848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2303852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2303856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2303860 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2303860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2303863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303873 */     // GIR_Coverage, 1256,
     /* 2303873 */     GIR_EraseRootFromParent_Done,
     /* 2303874 */   // Label 31516: @2303874
     /* 2303874 */   GIM_Try, /*On fail goto*//*Label 31517*/ GIMT_Encode4(2303908), // Rule ID 1259 //
     /* 2303879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2303882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2303886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2303890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2303894 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2303894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2303897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303907 */     // GIR_Coverage, 1259,
     /* 2303907 */     GIR_EraseRootFromParent_Done,
     /* 2303908 */   // Label 31517: @2303908
     /* 2303908 */   GIM_Try, /*On fail goto*//*Label 31518*/ GIMT_Encode4(2303942), // Rule ID 1260 //
     /* 2303913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2303916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2303920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2303924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2303928 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2303928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2303931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303941 */     // GIR_Coverage, 1260,
     /* 2303941 */     GIR_EraseRootFromParent_Done,
     /* 2303942 */   // Label 31518: @2303942
     /* 2303942 */   GIM_Reject,
     /* 2303943 */ // Label 31514: @2303943
     /* 2303943 */ GIM_Reject,
     /* 2303944 */ // Label 31492: @2303944
     /* 2303944 */ GIM_Try, /*On fail goto*//*Label 31519*/ GIMT_Encode4(2304126),
     /* 2303949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2303952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2303955 */   GIM_Try, /*On fail goto*//*Label 31520*/ GIMT_Encode4(2303989), // Rule ID 1594 //
     /* 2303960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2303963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2303967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2303971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2303975 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2303975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2303978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303988 */     // GIR_Coverage, 1594,
     /* 2303988 */     GIR_EraseRootFromParent_Done,
     /* 2303989 */   // Label 31520: @2303989
     /* 2303989 */   GIM_Try, /*On fail goto*//*Label 31521*/ GIMT_Encode4(2304023), // Rule ID 1595 //
     /* 2303994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2303997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2304001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2304005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2304009 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2304009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2304012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304022 */     // GIR_Coverage, 1595,
     /* 2304022 */     GIR_EraseRootFromParent_Done,
     /* 2304023 */   // Label 31521: @2304023
     /* 2304023 */   GIM_Try, /*On fail goto*//*Label 31522*/ GIMT_Encode4(2304057), // Rule ID 1598 //
     /* 2304028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2304031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2304035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2304039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2304043 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2304043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2304046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304056 */     // GIR_Coverage, 1598,
     /* 2304056 */     GIR_EraseRootFromParent_Done,
     /* 2304057 */   // Label 31522: @2304057
     /* 2304057 */   GIM_Try, /*On fail goto*//*Label 31523*/ GIMT_Encode4(2304091), // Rule ID 1599 //
     /* 2304062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2304065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2304069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2304073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2304077 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2304077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2304080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304090 */     // GIR_Coverage, 1599,
     /* 2304090 */     GIR_EraseRootFromParent_Done,
     /* 2304091 */   // Label 31523: @2304091
     /* 2304091 */   GIM_Try, /*On fail goto*//*Label 31524*/ GIMT_Encode4(2304125), // Rule ID 1601 //
     /* 2304096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2304099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2304103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2304107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2304111 */     // (fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2304111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2304114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304124 */     // GIR_Coverage, 1601,
     /* 2304124 */     GIR_EraseRootFromParent_Done,
     /* 2304125 */   // Label 31524: @2304125
     /* 2304125 */   GIM_Reject,
     /* 2304126 */ // Label 31519: @2304126
     /* 2304126 */ GIM_Reject,
     /* 2304127 */ // Label 31493: @2304127
     /* 2304127 */ GIM_Try, /*On fail goto*//*Label 31525*/ GIMT_Encode4(2304247),
     /* 2304132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2304135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2304138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304146 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304150 */   GIM_Try, /*On fail goto*//*Label 31526*/ GIMT_Encode4(2304198), // Rule ID 54216 //
     /* 2304155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304158 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2304161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2304175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304197 */     // GIR_Coverage, 54216,
     /* 2304197 */     GIR_EraseRootFromParent_Done,
     /* 2304198 */   // Label 31526: @2304198
     /* 2304198 */   GIM_Try, /*On fail goto*//*Label 31527*/ GIMT_Encode4(2304246), // Rule ID 54217 //
     /* 2304203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304206 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2304209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2304223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304245 */     // GIR_Coverage, 54217,
     /* 2304245 */     GIR_EraseRootFromParent_Done,
     /* 2304246 */   // Label 31527: @2304246
     /* 2304246 */   GIM_Reject,
     /* 2304247 */ // Label 31525: @2304247
     /* 2304247 */ GIM_Reject,
     /* 2304248 */ // Label 31494: @2304248
     /* 2304248 */ GIM_Try, /*On fail goto*//*Label 31528*/ GIMT_Encode4(2304368),
     /* 2304253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2304256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2304259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304271 */   GIM_Try, /*On fail goto*//*Label 31529*/ GIMT_Encode4(2304319), // Rule ID 54240 //
     /* 2304276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2304279 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2304282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2304296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304318 */     // GIR_Coverage, 54240,
     /* 2304318 */     GIR_EraseRootFromParent_Done,
     /* 2304319 */   // Label 31529: @2304319
     /* 2304319 */   GIM_Try, /*On fail goto*//*Label 31530*/ GIMT_Encode4(2304367), // Rule ID 54241 //
     /* 2304324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2304327 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2304330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2304344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304366 */     // GIR_Coverage, 54241,
     /* 2304366 */     GIR_EraseRootFromParent_Done,
     /* 2304367 */   // Label 31530: @2304367
     /* 2304367 */   GIM_Reject,
     /* 2304368 */ // Label 31528: @2304368
     /* 2304368 */ GIM_Reject,
     /* 2304369 */ // Label 31495: @2304369
     /* 2304369 */ GIM_Try, /*On fail goto*//*Label 31531*/ GIMT_Encode4(2304489),
     /* 2304374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2304377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2304380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304392 */   GIM_Try, /*On fail goto*//*Label 31532*/ GIMT_Encode4(2304440), // Rule ID 54276 //
     /* 2304397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2304400 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2304403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2304417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304439 */     // GIR_Coverage, 54276,
     /* 2304439 */     GIR_EraseRootFromParent_Done,
     /* 2304440 */   // Label 31532: @2304440
     /* 2304440 */   GIM_Try, /*On fail goto*//*Label 31533*/ GIMT_Encode4(2304488), // Rule ID 54277 //
     /* 2304445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2304448 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2304451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2304465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304487 */     // GIR_Coverage, 54277,
     /* 2304487 */     GIR_EraseRootFromParent_Done,
     /* 2304488 */   // Label 31533: @2304488
     /* 2304488 */   GIM_Reject,
     /* 2304489 */ // Label 31531: @2304489
     /* 2304489 */ GIM_Reject,
     /* 2304490 */ // Label 31496: @2304490
     /* 2304490 */ GIM_Try, /*On fail goto*//*Label 31534*/ GIMT_Encode4(2304610),
     /* 2304495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2304498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2304501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304513 */   GIM_Try, /*On fail goto*//*Label 31535*/ GIMT_Encode4(2304561), // Rule ID 54228 //
     /* 2304518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304521 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2304524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2304538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304560 */     // GIR_Coverage, 54228,
     /* 2304560 */     GIR_EraseRootFromParent_Done,
     /* 2304561 */   // Label 31535: @2304561
     /* 2304561 */   GIM_Try, /*On fail goto*//*Label 31536*/ GIMT_Encode4(2304609), // Rule ID 54229 //
     /* 2304566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304569 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2304572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2304586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304608 */     // GIR_Coverage, 54229,
     /* 2304608 */     GIR_EraseRootFromParent_Done,
     /* 2304609 */   // Label 31536: @2304609
     /* 2304609 */   GIM_Reject,
     /* 2304610 */ // Label 31534: @2304610
     /* 2304610 */ GIM_Reject,
     /* 2304611 */ // Label 31497: @2304611
     /* 2304611 */ GIM_Try, /*On fail goto*//*Label 31537*/ GIMT_Encode4(2304731),
     /* 2304616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2304619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2304622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304634 */   GIM_Try, /*On fail goto*//*Label 31538*/ GIMT_Encode4(2304682), // Rule ID 54264 //
     /* 2304639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2304642 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2304645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2304659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304681 */     // GIR_Coverage, 54264,
     /* 2304681 */     GIR_EraseRootFromParent_Done,
     /* 2304682 */   // Label 31538: @2304682
     /* 2304682 */   GIM_Try, /*On fail goto*//*Label 31539*/ GIMT_Encode4(2304730), // Rule ID 54265 //
     /* 2304687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2304690 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2304693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2304707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304729 */     // GIR_Coverage, 54265,
     /* 2304729 */     GIR_EraseRootFromParent_Done,
     /* 2304730 */   // Label 31539: @2304730
     /* 2304730 */   GIM_Reject,
     /* 2304731 */ // Label 31537: @2304731
     /* 2304731 */ GIM_Reject,
     /* 2304732 */ // Label 31498: @2304732
     /* 2304732 */ GIM_Try, /*On fail goto*//*Label 31540*/ GIMT_Encode4(2304852),
     /* 2304737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2304740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2304743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304755 */   GIM_Try, /*On fail goto*//*Label 31541*/ GIMT_Encode4(2304803), // Rule ID 54360 //
     /* 2304760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2304763 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2304766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2304780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304802 */     // GIR_Coverage, 54360,
     /* 2304802 */     GIR_EraseRootFromParent_Done,
     /* 2304803 */   // Label 31541: @2304803
     /* 2304803 */   GIM_Try, /*On fail goto*//*Label 31542*/ GIMT_Encode4(2304851), // Rule ID 54361 //
     /* 2304808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2304811 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2304814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2304828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304850 */     // GIR_Coverage, 54361,
     /* 2304850 */     GIR_EraseRootFromParent_Done,
     /* 2304851 */   // Label 31542: @2304851
     /* 2304851 */   GIM_Reject,
     /* 2304852 */ // Label 31540: @2304852
     /* 2304852 */ GIM_Reject,
     /* 2304853 */ // Label 31499: @2304853
     /* 2304853 */ GIM_Try, /*On fail goto*//*Label 31543*/ GIMT_Encode4(2304973),
     /* 2304858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2304861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2304864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2304876 */   GIM_Try, /*On fail goto*//*Label 31544*/ GIMT_Encode4(2304924), // Rule ID 54252 //
     /* 2304881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304884 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2304887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2304901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304923 */     // GIR_Coverage, 54252,
     /* 2304923 */     GIR_EraseRootFromParent_Done,
     /* 2304924 */   // Label 31544: @2304924
     /* 2304924 */   GIM_Try, /*On fail goto*//*Label 31545*/ GIMT_Encode4(2304972), // Rule ID 54253 //
     /* 2304929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304932 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2304935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2304949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304971 */     // GIR_Coverage, 54253,
     /* 2304971 */     GIR_EraseRootFromParent_Done,
     /* 2304972 */   // Label 31545: @2304972
     /* 2304972 */   GIM_Reject,
     /* 2304973 */ // Label 31543: @2304973
     /* 2304973 */ GIM_Reject,
     /* 2304974 */ // Label 31500: @2304974
     /* 2304974 */ GIM_Try, /*On fail goto*//*Label 31546*/ GIMT_Encode4(2305094),
     /* 2304979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2304982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2304985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304997 */   GIM_Try, /*On fail goto*//*Label 31547*/ GIMT_Encode4(2305045), // Rule ID 54324 //
     /* 2305002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305005 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2305008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2305022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305044 */     // GIR_Coverage, 54324,
     /* 2305044 */     GIR_EraseRootFromParent_Done,
     /* 2305045 */   // Label 31547: @2305045
     /* 2305045 */   GIM_Try, /*On fail goto*//*Label 31548*/ GIMT_Encode4(2305093), // Rule ID 54325 //
     /* 2305050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305053 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2305056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2305070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305092 */     // GIR_Coverage, 54325,
     /* 2305092 */     GIR_EraseRootFromParent_Done,
     /* 2305093 */   // Label 31548: @2305093
     /* 2305093 */   GIM_Reject,
     /* 2305094 */ // Label 31546: @2305094
     /* 2305094 */ GIM_Reject,
     /* 2305095 */ // Label 31501: @2305095
     /* 2305095 */ GIM_Try, /*On fail goto*//*Label 31549*/ GIMT_Encode4(2305215),
     /* 2305100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2305103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2305106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305118 */   GIM_Try, /*On fail goto*//*Label 31550*/ GIMT_Encode4(2305166), // Rule ID 54372 //
     /* 2305123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2305126 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2305129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2305143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305165 */     // GIR_Coverage, 54372,
     /* 2305165 */     GIR_EraseRootFromParent_Done,
     /* 2305166 */   // Label 31550: @2305166
     /* 2305166 */   GIM_Try, /*On fail goto*//*Label 31551*/ GIMT_Encode4(2305214), // Rule ID 54373 //
     /* 2305171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2305174 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2305177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2305191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305213 */     // GIR_Coverage, 54373,
     /* 2305213 */     GIR_EraseRootFromParent_Done,
     /* 2305214 */   // Label 31551: @2305214
     /* 2305214 */   GIM_Reject,
     /* 2305215 */ // Label 31549: @2305215
     /* 2305215 */ GIM_Reject,
     /* 2305216 */ // Label 31502: @2305216
     /* 2305216 */ GIM_Try, /*On fail goto*//*Label 31552*/ GIMT_Encode4(2305336),
     /* 2305221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2305224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2305227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305239 */   GIM_Try, /*On fail goto*//*Label 31553*/ GIMT_Encode4(2305287), // Rule ID 54288 //
     /* 2305244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2305247 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2305250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2305264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305286 */     // GIR_Coverage, 54288,
     /* 2305286 */     GIR_EraseRootFromParent_Done,
     /* 2305287 */   // Label 31553: @2305287
     /* 2305287 */   GIM_Try, /*On fail goto*//*Label 31554*/ GIMT_Encode4(2305335), // Rule ID 54289 //
     /* 2305292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2305295 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2305298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2305312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305334 */     // GIR_Coverage, 54289,
     /* 2305334 */     GIR_EraseRootFromParent_Done,
     /* 2305335 */   // Label 31554: @2305335
     /* 2305335 */   GIM_Reject,
     /* 2305336 */ // Label 31552: @2305336
     /* 2305336 */ GIM_Reject,
     /* 2305337 */ // Label 31503: @2305337
     /* 2305337 */ GIM_Try, /*On fail goto*//*Label 31555*/ GIMT_Encode4(2305457),
     /* 2305342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2305348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305360 */   GIM_Try, /*On fail goto*//*Label 31556*/ GIMT_Encode4(2305408), // Rule ID 54336 //
     /* 2305365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305368 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2305371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2305385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305407 */     // GIR_Coverage, 54336,
     /* 2305407 */     GIR_EraseRootFromParent_Done,
     /* 2305408 */   // Label 31556: @2305408
     /* 2305408 */   GIM_Try, /*On fail goto*//*Label 31557*/ GIMT_Encode4(2305456), // Rule ID 54337 //
     /* 2305413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305416 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2305419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2305433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305455 */     // GIR_Coverage, 54337,
     /* 2305455 */     GIR_EraseRootFromParent_Done,
     /* 2305456 */   // Label 31557: @2305456
     /* 2305456 */   GIM_Reject,
     /* 2305457 */ // Label 31555: @2305457
     /* 2305457 */ GIM_Reject,
     /* 2305458 */ // Label 31504: @2305458
     /* 2305458 */ GIM_Try, /*On fail goto*//*Label 31558*/ GIMT_Encode4(2305578),
     /* 2305463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2305466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2305469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2305473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2305477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2305481 */   GIM_Try, /*On fail goto*//*Label 31559*/ GIMT_Encode4(2305529), // Rule ID 54384 //
     /* 2305486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2305489 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2305492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2305506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305528 */     // GIR_Coverage, 54384,
     /* 2305528 */     GIR_EraseRootFromParent_Done,
     /* 2305529 */   // Label 31559: @2305529
     /* 2305529 */   GIM_Try, /*On fail goto*//*Label 31560*/ GIMT_Encode4(2305577), // Rule ID 54385 //
     /* 2305534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2305537 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2305540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2305554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305576 */     // GIR_Coverage, 54385,
     /* 2305576 */     GIR_EraseRootFromParent_Done,
     /* 2305577 */   // Label 31560: @2305577
     /* 2305577 */   GIM_Reject,
     /* 2305578 */ // Label 31558: @2305578
     /* 2305578 */ GIM_Reject,
     /* 2305579 */ // Label 31505: @2305579
     /* 2305579 */ GIM_Try, /*On fail goto*//*Label 31561*/ GIMT_Encode4(2305699),
     /* 2305584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2305587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2305590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305602 */   GIM_Try, /*On fail goto*//*Label 31562*/ GIMT_Encode4(2305650), // Rule ID 54300 //
     /* 2305607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2305610 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2305613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2305627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305649 */     // GIR_Coverage, 54300,
     /* 2305649 */     GIR_EraseRootFromParent_Done,
     /* 2305650 */   // Label 31562: @2305650
     /* 2305650 */   GIM_Try, /*On fail goto*//*Label 31563*/ GIMT_Encode4(2305698), // Rule ID 54301 //
     /* 2305655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2305658 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2305661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2305675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305697 */     // GIR_Coverage, 54301,
     /* 2305697 */     GIR_EraseRootFromParent_Done,
     /* 2305698 */   // Label 31563: @2305698
     /* 2305698 */   GIM_Reject,
     /* 2305699 */ // Label 31561: @2305699
     /* 2305699 */ GIM_Reject,
     /* 2305700 */ // Label 31506: @2305700
     /* 2305700 */ GIM_Try, /*On fail goto*//*Label 31564*/ GIMT_Encode4(2305820),
     /* 2305705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2305708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2305711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2305715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2305719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2305723 */   GIM_Try, /*On fail goto*//*Label 31565*/ GIMT_Encode4(2305771), // Rule ID 54348 //
     /* 2305728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305731 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2305734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2305748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305770 */     // GIR_Coverage, 54348,
     /* 2305770 */     GIR_EraseRootFromParent_Done,
     /* 2305771 */   // Label 31565: @2305771
     /* 2305771 */   GIM_Try, /*On fail goto*//*Label 31566*/ GIMT_Encode4(2305819), // Rule ID 54349 //
     /* 2305776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305779 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2305782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2305796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305818 */     // GIR_Coverage, 54349,
     /* 2305818 */     GIR_EraseRootFromParent_Done,
     /* 2305819 */   // Label 31566: @2305819
     /* 2305819 */   GIM_Reject,
     /* 2305820 */ // Label 31564: @2305820
     /* 2305820 */ GIM_Reject,
     /* 2305821 */ // Label 31507: @2305821
     /* 2305821 */ GIM_Try, /*On fail goto*//*Label 31567*/ GIMT_Encode4(2305941),
     /* 2305826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2305829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2305832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2305836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2305840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2305844 */   GIM_Try, /*On fail goto*//*Label 31568*/ GIMT_Encode4(2305892), // Rule ID 54312 //
     /* 2305849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2305852 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2305855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2305869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305891 */     // GIR_Coverage, 54312,
     /* 2305891 */     GIR_EraseRootFromParent_Done,
     /* 2305892 */   // Label 31568: @2305892
     /* 2305892 */   GIM_Try, /*On fail goto*//*Label 31569*/ GIMT_Encode4(2305940), // Rule ID 54313 //
     /* 2305897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2305900 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2305903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2305917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305939 */     // GIR_Coverage, 54313,
     /* 2305939 */     GIR_EraseRootFromParent_Done,
     /* 2305940 */   // Label 31569: @2305940
     /* 2305940 */   GIM_Reject,
     /* 2305941 */ // Label 31567: @2305941
     /* 2305941 */ GIM_Reject,
     /* 2305942 */ // Label 31508: @2305942
     /* 2305942 */ GIM_Reject,
     /* 2305943 */ // Label 62: @2305943
     /* 2305943 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31588*/ GIMT_Encode4(2322587),
     /* 2305954 */ /*GILLT_s16*//*Label 31570*/ GIMT_Encode4(2306074),
     /* 2305958 */ /*GILLT_s32*//*Label 31571*/ GIMT_Encode4(2307510),
     /* 2305962 */ /*GILLT_s64*//*Label 31572*/ GIMT_Encode4(2308946), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2305974 */ /*GILLT_nxv1s16*//*Label 31573*/ GIMT_Encode4(2310737),
     /* 2305978 */ /*GILLT_nxv1s32*//*Label 31574*/ GIMT_Encode4(2311527),
     /* 2305982 */ /*GILLT_nxv1s64*//*Label 31575*/ GIMT_Encode4(2312317), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2305994 */ /*GILLT_nxv2s16*//*Label 31576*/ GIMT_Encode4(2313107),
     /* 2305998 */ /*GILLT_nxv2s32*//*Label 31577*/ GIMT_Encode4(2313897),
     /* 2306002 */ /*GILLT_nxv2s64*//*Label 31578*/ GIMT_Encode4(2314687), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2306014 */ /*GILLT_nxv4s16*//*Label 31579*/ GIMT_Encode4(2315477),
     /* 2306018 */ /*GILLT_nxv4s32*//*Label 31580*/ GIMT_Encode4(2316267),
     /* 2306022 */ /*GILLT_nxv4s64*//*Label 31581*/ GIMT_Encode4(2317057), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2306034 */ /*GILLT_nxv8s16*//*Label 31582*/ GIMT_Encode4(2317847),
     /* 2306038 */ /*GILLT_nxv8s32*//*Label 31583*/ GIMT_Encode4(2318637),
     /* 2306042 */ /*GILLT_nxv8s64*//*Label 31584*/ GIMT_Encode4(2319427), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2306054 */ /*GILLT_nxv16s16*//*Label 31585*/ GIMT_Encode4(2320217),
     /* 2306058 */ /*GILLT_nxv16s32*//*Label 31586*/ GIMT_Encode4(2321007), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2306070 */ /*GILLT_nxv32s16*//*Label 31587*/ GIMT_Encode4(2321797),
     /* 2306074 */ // Label 31570: @2306074
     /* 2306074 */ GIM_Try, /*On fail goto*//*Label 31589*/ GIMT_Encode4(2307509),
     /* 2306079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2306085 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2306088 */   GIM_Try, /*On fail goto*//*Label 31590*/ GIMT_Encode4(2306160), // Rule ID 2005 //
     /* 2306093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2306096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306140 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2306140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2306143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306159 */     // GIR_Coverage, 2005,
     /* 2306159 */     GIR_EraseRootFromParent_Done,
     /* 2306160 */   // Label 31590: @2306160
     /* 2306160 */   GIM_Try, /*On fail goto*//*Label 31591*/ GIMT_Encode4(2306232), // Rule ID 2006 //
     /* 2306165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2306168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306205 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306212 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2306212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2306215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306231 */     // GIR_Coverage, 2006,
     /* 2306231 */     GIR_EraseRootFromParent_Done,
     /* 2306232 */   // Label 31591: @2306232
     /* 2306232 */   GIM_Try, /*On fail goto*//*Label 31592*/ GIMT_Encode4(2306304), // Rule ID 2038 //
     /* 2306237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2306240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306284 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2306284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2306287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306303 */     // GIR_Coverage, 2038,
     /* 2306303 */     GIR_EraseRootFromParent_Done,
     /* 2306304 */   // Label 31592: @2306304
     /* 2306304 */   GIM_Try, /*On fail goto*//*Label 31593*/ GIMT_Encode4(2306376), // Rule ID 2039 //
     /* 2306309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2306312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306356 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2306356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2306359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306375 */     // GIR_Coverage, 2039,
     /* 2306375 */     GIR_EraseRootFromParent_Done,
     /* 2306376 */   // Label 31593: @2306376
     /* 2306376 */   GIM_Try, /*On fail goto*//*Label 31594*/ GIMT_Encode4(2306448), // Rule ID 65406 //
     /* 2306381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2306384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306421 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306428 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2306428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2306431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306447 */     // GIR_Coverage, 65406,
     /* 2306447 */     GIR_EraseRootFromParent_Done,
     /* 2306448 */   // Label 31594: @2306448
     /* 2306448 */   GIM_Try, /*On fail goto*//*Label 31595*/ GIMT_Encode4(2306520), // Rule ID 65407 //
     /* 2306453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2306456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306500 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2306500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2306503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306519 */     // GIR_Coverage, 65407,
     /* 2306519 */     GIR_EraseRootFromParent_Done,
     /* 2306520 */   // Label 31595: @2306520
     /* 2306520 */   GIM_Try, /*On fail goto*//*Label 31596*/ GIMT_Encode4(2306592), // Rule ID 65414 //
     /* 2306525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2306528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306572 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2306572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2306575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306591 */     // GIR_Coverage, 65414,
     /* 2306591 */     GIR_EraseRootFromParent_Done,
     /* 2306592 */   // Label 31596: @2306592
     /* 2306592 */   GIM_Try, /*On fail goto*//*Label 31597*/ GIMT_Encode4(2306664), // Rule ID 65415 //
     /* 2306597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2306600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306644 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2306644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2306647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306663 */     // GIR_Coverage, 65415,
     /* 2306663 */     GIR_EraseRootFromParent_Done,
     /* 2306664 */   // Label 31597: @2306664
     /* 2306664 */   GIM_Try, /*On fail goto*//*Label 31598*/ GIMT_Encode4(2306721), // Rule ID 2001 //
     /* 2306669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2306672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306703 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2306703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2306706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306720 */     // GIR_Coverage, 2001,
     /* 2306720 */     GIR_EraseRootFromParent_Done,
     /* 2306721 */   // Label 31598: @2306721
     /* 2306721 */   GIM_Try, /*On fail goto*//*Label 31599*/ GIMT_Encode4(2306778), // Rule ID 2002 //
     /* 2306726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2306729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306760 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2306760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2306763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306777 */     // GIR_Coverage, 2002,
     /* 2306777 */     GIR_EraseRootFromParent_Done,
     /* 2306778 */   // Label 31599: @2306778
     /* 2306778 */   GIM_Try, /*On fail goto*//*Label 31600*/ GIMT_Encode4(2306835), // Rule ID 2034 //
     /* 2306783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2306786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306817 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2306817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2306820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306834 */     // GIR_Coverage, 2034,
     /* 2306834 */     GIR_EraseRootFromParent_Done,
     /* 2306835 */   // Label 31600: @2306835
     /* 2306835 */   GIM_Try, /*On fail goto*//*Label 31601*/ GIMT_Encode4(2306892), // Rule ID 2035 //
     /* 2306840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2306843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2306872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306874 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2306874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2306877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306891 */     // GIR_Coverage, 2035,
     /* 2306891 */     GIR_EraseRootFromParent_Done,
     /* 2306892 */   // Label 31601: @2306892
     /* 2306892 */   GIM_Try, /*On fail goto*//*Label 31602*/ GIMT_Encode4(2306949), // Rule ID 65402 //
     /* 2306897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2306900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306931 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2306931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2306934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306948 */     // GIR_Coverage, 65402,
     /* 2306948 */     GIR_EraseRootFromParent_Done,
     /* 2306949 */   // Label 31602: @2306949
     /* 2306949 */   GIM_Try, /*On fail goto*//*Label 31603*/ GIMT_Encode4(2307006), // Rule ID 65403 //
     /* 2306954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2306957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2306977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2306986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306988 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2306988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2306991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307005 */     // GIR_Coverage, 65403,
     /* 2307005 */     GIR_EraseRootFromParent_Done,
     /* 2307006 */   // Label 31603: @2307006
     /* 2307006 */   GIM_Try, /*On fail goto*//*Label 31604*/ GIMT_Encode4(2307063), // Rule ID 65410 //
     /* 2307011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2307014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2307034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307045 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2307045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2307048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307062 */     // GIR_Coverage, 65410,
     /* 2307062 */     GIR_EraseRootFromParent_Done,
     /* 2307063 */   // Label 31604: @2307063
     /* 2307063 */   GIM_Try, /*On fail goto*//*Label 31605*/ GIMT_Encode4(2307120), // Rule ID 65411 //
     /* 2307068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2307071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2307091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307102 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2307102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2307105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307119 */     // GIR_Coverage, 65411,
     /* 2307119 */     GIR_EraseRootFromParent_Done,
     /* 2307120 */   // Label 31605: @2307120
     /* 2307120 */   GIM_Try, /*On fail goto*//*Label 31606*/ GIMT_Encode4(2307177), // Rule ID 1997 //
     /* 2307125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2307128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2307144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2307152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307159 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2307159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2307162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2307172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307176 */     // GIR_Coverage, 1997,
     /* 2307176 */     GIR_EraseRootFromParent_Done,
     /* 2307177 */   // Label 31606: @2307177
     /* 2307177 */   GIM_Try, /*On fail goto*//*Label 31607*/ GIMT_Encode4(2307234), // Rule ID 1998 //
     /* 2307182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2307185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2307201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2307209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307216 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2307216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2307219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2307229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307233 */     // GIR_Coverage, 1998,
     /* 2307233 */     GIR_EraseRootFromParent_Done,
     /* 2307234 */   // Label 31607: @2307234
     /* 2307234 */   GIM_Try, /*On fail goto*//*Label 31608*/ GIMT_Encode4(2307291), // Rule ID 2030 //
     /* 2307239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2307242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2307258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2307266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307273 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2307273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2307276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2307286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307290 */     // GIR_Coverage, 2030,
     /* 2307290 */     GIR_EraseRootFromParent_Done,
     /* 2307291 */   // Label 31608: @2307291
     /* 2307291 */   GIM_Try, /*On fail goto*//*Label 31609*/ GIMT_Encode4(2307348), // Rule ID 2031 //
     /* 2307296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2307299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2307315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2307323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307330 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2307330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2307333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2307343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307347 */     // GIR_Coverage, 2031,
     /* 2307347 */     GIR_EraseRootFromParent_Done,
     /* 2307348 */   // Label 31609: @2307348
     /* 2307348 */   GIM_Try, /*On fail goto*//*Label 31610*/ GIMT_Encode4(2307388), // Rule ID 1993 //
     /* 2307353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2307356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307372 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2307372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2307375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307387 */     // GIR_Coverage, 1993,
     /* 2307387 */     GIR_EraseRootFromParent_Done,
     /* 2307388 */   // Label 31610: @2307388
     /* 2307388 */   GIM_Try, /*On fail goto*//*Label 31611*/ GIMT_Encode4(2307428), // Rule ID 1994 //
     /* 2307393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2307396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307412 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2307412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2307415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307427 */     // GIR_Coverage, 1994,
     /* 2307427 */     GIR_EraseRootFromParent_Done,
     /* 2307428 */   // Label 31611: @2307428
     /* 2307428 */   GIM_Try, /*On fail goto*//*Label 31612*/ GIMT_Encode4(2307468), // Rule ID 2026 //
     /* 2307433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2307436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307452 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2307452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2307455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307467 */     // GIR_Coverage, 2026,
     /* 2307467 */     GIR_EraseRootFromParent_Done,
     /* 2307468 */   // Label 31612: @2307468
     /* 2307468 */   GIM_Try, /*On fail goto*//*Label 31613*/ GIMT_Encode4(2307508), // Rule ID 2027 //
     /* 2307473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2307476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307492 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2307492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2307495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307507 */     // GIR_Coverage, 2027,
     /* 2307507 */     GIR_EraseRootFromParent_Done,
     /* 2307508 */   // Label 31613: @2307508
     /* 2307508 */   GIM_Reject,
     /* 2307509 */ // Label 31589: @2307509
     /* 2307509 */ GIM_Reject,
     /* 2307510 */ // Label 31571: @2307510
     /* 2307510 */ GIM_Try, /*On fail goto*//*Label 31614*/ GIMT_Encode4(2308945),
     /* 2307515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2307521 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2307524 */   GIM_Try, /*On fail goto*//*Label 31615*/ GIMT_Encode4(2307596), // Rule ID 1304 //
     /* 2307529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2307532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307576 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2307576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2307579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307595 */     // GIR_Coverage, 1304,
     /* 2307595 */     GIR_EraseRootFromParent_Done,
     /* 2307596 */   // Label 31615: @2307596
     /* 2307596 */   GIM_Try, /*On fail goto*//*Label 31616*/ GIMT_Encode4(2307668), // Rule ID 1305 //
     /* 2307601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2307604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307648 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2307648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2307651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307667 */     // GIR_Coverage, 1305,
     /* 2307667 */     GIR_EraseRootFromParent_Done,
     /* 2307668 */   // Label 31616: @2307668
     /* 2307668 */   GIM_Try, /*On fail goto*//*Label 31617*/ GIMT_Encode4(2307740), // Rule ID 1325 //
     /* 2307673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2307676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307720 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2307720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2307723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307739 */     // GIR_Coverage, 1325,
     /* 2307739 */     GIR_EraseRootFromParent_Done,
     /* 2307740 */   // Label 31617: @2307740
     /* 2307740 */   GIM_Try, /*On fail goto*//*Label 31618*/ GIMT_Encode4(2307812), // Rule ID 1326 //
     /* 2307745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2307748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307792 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2307792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2307795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307811 */     // GIR_Coverage, 1326,
     /* 2307811 */     GIR_EraseRootFromParent_Done,
     /* 2307812 */   // Label 31618: @2307812
     /* 2307812 */   GIM_Try, /*On fail goto*//*Label 31619*/ GIMT_Encode4(2307884), // Rule ID 65370 //
     /* 2307817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2307820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307864 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2307864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2307867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307883 */     // GIR_Coverage, 65370,
     /* 2307883 */     GIR_EraseRootFromParent_Done,
     /* 2307884 */   // Label 31619: @2307884
     /* 2307884 */   GIM_Try, /*On fail goto*//*Label 31620*/ GIMT_Encode4(2307956), // Rule ID 65371 //
     /* 2307889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2307892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307936 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2307936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2307939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307955 */     // GIR_Coverage, 65371,
     /* 2307955 */     GIR_EraseRootFromParent_Done,
     /* 2307956 */   // Label 31620: @2307956
     /* 2307956 */   GIM_Try, /*On fail goto*//*Label 31621*/ GIMT_Encode4(2308028), // Rule ID 65378 //
     /* 2307961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2307964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308008 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2308008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2308011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2308019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2308023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308027 */     // GIR_Coverage, 65378,
     /* 2308027 */     GIR_EraseRootFromParent_Done,
     /* 2308028 */   // Label 31621: @2308028
     /* 2308028 */   GIM_Try, /*On fail goto*//*Label 31622*/ GIMT_Encode4(2308100), // Rule ID 65379 //
     /* 2308033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2308036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308080 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2308080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2308083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2308091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2308095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308099 */     // GIR_Coverage, 65379,
     /* 2308099 */     GIR_EraseRootFromParent_Done,
     /* 2308100 */   // Label 31622: @2308100
     /* 2308100 */   GIM_Try, /*On fail goto*//*Label 31623*/ GIMT_Encode4(2308157), // Rule ID 1300 //
     /* 2308105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2308108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308139 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2308139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2308142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308156 */     // GIR_Coverage, 1300,
     /* 2308156 */     GIR_EraseRootFromParent_Done,
     /* 2308157 */   // Label 31623: @2308157
     /* 2308157 */   GIM_Try, /*On fail goto*//*Label 31624*/ GIMT_Encode4(2308214), // Rule ID 1301 //
     /* 2308162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2308165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308196 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2308196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2308199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308213 */     // GIR_Coverage, 1301,
     /* 2308213 */     GIR_EraseRootFromParent_Done,
     /* 2308214 */   // Label 31624: @2308214
     /* 2308214 */   GIM_Try, /*On fail goto*//*Label 31625*/ GIMT_Encode4(2308271), // Rule ID 1321 //
     /* 2308219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2308222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308253 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2308253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2308256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308270 */     // GIR_Coverage, 1321,
     /* 2308270 */     GIR_EraseRootFromParent_Done,
     /* 2308271 */   // Label 31625: @2308271
     /* 2308271 */   GIM_Try, /*On fail goto*//*Label 31626*/ GIMT_Encode4(2308328), // Rule ID 1322 //
     /* 2308276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2308279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308310 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2308310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2308313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308327 */     // GIR_Coverage, 1322,
     /* 2308327 */     GIR_EraseRootFromParent_Done,
     /* 2308328 */   // Label 31626: @2308328
     /* 2308328 */   GIM_Try, /*On fail goto*//*Label 31627*/ GIMT_Encode4(2308385), // Rule ID 65366 //
     /* 2308333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2308336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308367 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2308367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2308370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2308378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308384 */     // GIR_Coverage, 65366,
     /* 2308384 */     GIR_EraseRootFromParent_Done,
     /* 2308385 */   // Label 31627: @2308385
     /* 2308385 */   GIM_Try, /*On fail goto*//*Label 31628*/ GIMT_Encode4(2308442), // Rule ID 65367 //
     /* 2308390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2308393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308424 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2308424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2308427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2308435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308441 */     // GIR_Coverage, 65367,
     /* 2308441 */     GIR_EraseRootFromParent_Done,
     /* 2308442 */   // Label 31628: @2308442
     /* 2308442 */   GIM_Try, /*On fail goto*//*Label 31629*/ GIMT_Encode4(2308499), // Rule ID 65374 //
     /* 2308447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2308450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308481 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2308481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2308484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2308492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308498 */     // GIR_Coverage, 65374,
     /* 2308498 */     GIR_EraseRootFromParent_Done,
     /* 2308499 */   // Label 31629: @2308499
     /* 2308499 */   GIM_Try, /*On fail goto*//*Label 31630*/ GIMT_Encode4(2308556), // Rule ID 65375 //
     /* 2308504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2308507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308538 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2308538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2308541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2308549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308555 */     // GIR_Coverage, 65375,
     /* 2308555 */     GIR_EraseRootFromParent_Done,
     /* 2308556 */   // Label 31630: @2308556
     /* 2308556 */   GIM_Try, /*On fail goto*//*Label 31631*/ GIMT_Encode4(2308613), // Rule ID 1296 //
     /* 2308561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2308564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308595 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2308595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2308598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2308608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308612 */     // GIR_Coverage, 1296,
     /* 2308612 */     GIR_EraseRootFromParent_Done,
     /* 2308613 */   // Label 31631: @2308613
     /* 2308613 */   GIM_Try, /*On fail goto*//*Label 31632*/ GIMT_Encode4(2308670), // Rule ID 1297 //
     /* 2308618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2308621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308652 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2308652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2308655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2308665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308669 */     // GIR_Coverage, 1297,
     /* 2308669 */     GIR_EraseRootFromParent_Done,
     /* 2308670 */   // Label 31632: @2308670
     /* 2308670 */   GIM_Try, /*On fail goto*//*Label 31633*/ GIMT_Encode4(2308727), // Rule ID 1317 //
     /* 2308675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2308678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308709 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2308709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2308712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2308722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308726 */     // GIR_Coverage, 1317,
     /* 2308726 */     GIR_EraseRootFromParent_Done,
     /* 2308727 */   // Label 31633: @2308727
     /* 2308727 */   GIM_Try, /*On fail goto*//*Label 31634*/ GIMT_Encode4(2308784), // Rule ID 1318 //
     /* 2308732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2308735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2308759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308766 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2308766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2308769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2308779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308783 */     // GIR_Coverage, 1318,
     /* 2308783 */     GIR_EraseRootFromParent_Done,
     /* 2308784 */   // Label 31634: @2308784
     /* 2308784 */   GIM_Try, /*On fail goto*//*Label 31635*/ GIMT_Encode4(2308824), // Rule ID 1292 //
     /* 2308789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2308792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308808 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2308808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2308811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308823 */     // GIR_Coverage, 1292,
     /* 2308823 */     GIR_EraseRootFromParent_Done,
     /* 2308824 */   // Label 31635: @2308824
     /* 2308824 */   GIM_Try, /*On fail goto*//*Label 31636*/ GIMT_Encode4(2308864), // Rule ID 1293 //
     /* 2308829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2308832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2308848 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2308848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2308851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308863 */     // GIR_Coverage, 1293,
     /* 2308863 */     GIR_EraseRootFromParent_Done,
     /* 2308864 */   // Label 31636: @2308864
     /* 2308864 */   GIM_Try, /*On fail goto*//*Label 31637*/ GIMT_Encode4(2308904), // Rule ID 1313 //
     /* 2308869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2308872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308888 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2308888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2308891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308903 */     // GIR_Coverage, 1313,
     /* 2308903 */     GIR_EraseRootFromParent_Done,
     /* 2308904 */   // Label 31637: @2308904
     /* 2308904 */   GIM_Try, /*On fail goto*//*Label 31638*/ GIMT_Encode4(2308944), // Rule ID 1314 //
     /* 2308909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2308912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2308928 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2308928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2308931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308943 */     // GIR_Coverage, 1314,
     /* 2308943 */     GIR_EraseRootFromParent_Done,
     /* 2308944 */   // Label 31638: @2308944
     /* 2308944 */   GIM_Reject,
     /* 2308945 */ // Label 31614: @2308945
     /* 2308945 */ GIM_Reject,
     /* 2308946 */ // Label 31572: @2308946
     /* 2308946 */ GIM_Try, /*On fail goto*//*Label 31639*/ GIMT_Encode4(2310736),
     /* 2308951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2308954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2308957 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2308960 */   GIM_Try, /*On fail goto*//*Label 31640*/ GIMT_Encode4(2309032), // Rule ID 1641 //
     /* 2308965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2308968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2308984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309012 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2309012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2309015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309031 */     // GIR_Coverage, 1641,
     /* 2309031 */     GIR_EraseRootFromParent_Done,
     /* 2309032 */   // Label 31640: @2309032
     /* 2309032 */   GIM_Try, /*On fail goto*//*Label 31641*/ GIMT_Encode4(2309104), // Rule ID 1642 //
     /* 2309037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2309040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309077 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309084 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2309084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2309087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309103 */     // GIR_Coverage, 1642,
     /* 2309103 */     GIR_EraseRootFromParent_Done,
     /* 2309104 */   // Label 31641: @2309104
     /* 2309104 */   GIM_Try, /*On fail goto*//*Label 31642*/ GIMT_Encode4(2309176), // Rule ID 1664 //
     /* 2309109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2309112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309149 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309156 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2309156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2309159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309175 */     // GIR_Coverage, 1664,
     /* 2309175 */     GIR_EraseRootFromParent_Done,
     /* 2309176 */   // Label 31642: @2309176
     /* 2309176 */   GIM_Try, /*On fail goto*//*Label 31643*/ GIMT_Encode4(2309248), // Rule ID 1696 //
     /* 2309181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2309184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309228 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2309228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2309231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309247 */     // GIR_Coverage, 1696,
     /* 2309247 */     GIR_EraseRootFromParent_Done,
     /* 2309248 */   // Label 31643: @2309248
     /* 2309248 */   GIM_Try, /*On fail goto*//*Label 31644*/ GIMT_Encode4(2309320), // Rule ID 1697 //
     /* 2309253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2309256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309300 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2309300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2309303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309319 */     // GIR_Coverage, 1697,
     /* 2309319 */     GIR_EraseRootFromParent_Done,
     /* 2309320 */   // Label 31644: @2309320
     /* 2309320 */   GIM_Try, /*On fail goto*//*Label 31645*/ GIMT_Encode4(2309392), // Rule ID 65386 //
     /* 2309325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2309328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309372 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2309372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2309375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2309383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309391 */     // GIR_Coverage, 65386,
     /* 2309391 */     GIR_EraseRootFromParent_Done,
     /* 2309392 */   // Label 31645: @2309392
     /* 2309392 */   GIM_Try, /*On fail goto*//*Label 31646*/ GIMT_Encode4(2309464), // Rule ID 65387 //
     /* 2309397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2309400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309444 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2309444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2309447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2309455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309463 */     // GIR_Coverage, 65387,
     /* 2309463 */     GIR_EraseRootFromParent_Done,
     /* 2309464 */   // Label 31646: @2309464
     /* 2309464 */   GIM_Try, /*On fail goto*//*Label 31647*/ GIMT_Encode4(2309536), // Rule ID 65391 //
     /* 2309469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2309472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309516 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2309516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2309519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2309527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309535 */     // GIR_Coverage, 65391,
     /* 2309535 */     GIR_EraseRootFromParent_Done,
     /* 2309536 */   // Label 31647: @2309536
     /* 2309536 */   GIM_Try, /*On fail goto*//*Label 31648*/ GIMT_Encode4(2309608), // Rule ID 65398 //
     /* 2309541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2309544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309588 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2309588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2309591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2309599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309607 */     // GIR_Coverage, 65398,
     /* 2309607 */     GIR_EraseRootFromParent_Done,
     /* 2309608 */   // Label 31648: @2309608
     /* 2309608 */   GIM_Try, /*On fail goto*//*Label 31649*/ GIMT_Encode4(2309680), // Rule ID 65399 //
     /* 2309613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2309616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309660 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2309660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2309663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2309671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309679 */     // GIR_Coverage, 65399,
     /* 2309679 */     GIR_EraseRootFromParent_Done,
     /* 2309680 */   // Label 31649: @2309680
     /* 2309680 */   GIM_Try, /*On fail goto*//*Label 31650*/ GIMT_Encode4(2309737), // Rule ID 1637 //
     /* 2309685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2309688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309719 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2309719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2309722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2309732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309736 */     // GIR_Coverage, 1637,
     /* 2309736 */     GIR_EraseRootFromParent_Done,
     /* 2309737 */   // Label 31650: @2309737
     /* 2309737 */   GIM_Try, /*On fail goto*//*Label 31651*/ GIMT_Encode4(2309794), // Rule ID 1638 //
     /* 2309742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2309745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309776 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2309776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2309779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2309789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309793 */     // GIR_Coverage, 1638,
     /* 2309793 */     GIR_EraseRootFromParent_Done,
     /* 2309794 */   // Label 31651: @2309794
     /* 2309794 */   GIM_Try, /*On fail goto*//*Label 31652*/ GIMT_Encode4(2309851), // Rule ID 1662 //
     /* 2309799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2309802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309833 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2309833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2309836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2309846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309850 */     // GIR_Coverage, 1662,
     /* 2309850 */     GIR_EraseRootFromParent_Done,
     /* 2309851 */   // Label 31652: @2309851
     /* 2309851 */   GIM_Try, /*On fail goto*//*Label 31653*/ GIMT_Encode4(2309908), // Rule ID 1692 //
     /* 2309856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2309859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309890 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2309890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2309893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2309903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309907 */     // GIR_Coverage, 1692,
     /* 2309907 */     GIR_EraseRootFromParent_Done,
     /* 2309908 */   // Label 31653: @2309908
     /* 2309908 */   GIM_Try, /*On fail goto*//*Label 31654*/ GIMT_Encode4(2309965), // Rule ID 1693 //
     /* 2309913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2309916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309947 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2309947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2309950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2309960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309964 */     // GIR_Coverage, 1693,
     /* 2309964 */     GIR_EraseRootFromParent_Done,
     /* 2309965 */   // Label 31654: @2309965
     /* 2309965 */   GIM_Try, /*On fail goto*//*Label 31655*/ GIMT_Encode4(2310022), // Rule ID 65382 //
     /* 2309970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2309973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310004 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2310004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2310007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310021 */     // GIR_Coverage, 65382,
     /* 2310021 */     GIR_EraseRootFromParent_Done,
     /* 2310022 */   // Label 31655: @2310022
     /* 2310022 */   GIM_Try, /*On fail goto*//*Label 31656*/ GIMT_Encode4(2310079), // Rule ID 65383 //
     /* 2310027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2310030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2310050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310061 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2310061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2310064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310078 */     // GIR_Coverage, 65383,
     /* 2310078 */     GIR_EraseRootFromParent_Done,
     /* 2310079 */   // Label 31656: @2310079
     /* 2310079 */   GIM_Try, /*On fail goto*//*Label 31657*/ GIMT_Encode4(2310136), // Rule ID 65389 //
     /* 2310084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2310087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2310107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310118 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2310118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2310121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310135 */     // GIR_Coverage, 65389,
     /* 2310135 */     GIR_EraseRootFromParent_Done,
     /* 2310136 */   // Label 31657: @2310136
     /* 2310136 */   GIM_Try, /*On fail goto*//*Label 31658*/ GIMT_Encode4(2310193), // Rule ID 65394 //
     /* 2310141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2310144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2310164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310175 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2310175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2310178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310192 */     // GIR_Coverage, 65394,
     /* 2310192 */     GIR_EraseRootFromParent_Done,
     /* 2310193 */   // Label 31658: @2310193
     /* 2310193 */   GIM_Try, /*On fail goto*//*Label 31659*/ GIMT_Encode4(2310250), // Rule ID 65395 //
     /* 2310198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2310201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2310221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310232 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2310232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2310235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310249 */     // GIR_Coverage, 65395,
     /* 2310249 */     GIR_EraseRootFromParent_Done,
     /* 2310250 */   // Label 31659: @2310250
     /* 2310250 */   GIM_Try, /*On fail goto*//*Label 31660*/ GIMT_Encode4(2310307), // Rule ID 1633 //
     /* 2310255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2310258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2310282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310289 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2310289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2310292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2310302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310306 */     // GIR_Coverage, 1633,
     /* 2310306 */     GIR_EraseRootFromParent_Done,
     /* 2310307 */   // Label 31660: @2310307
     /* 2310307 */   GIM_Try, /*On fail goto*//*Label 31661*/ GIMT_Encode4(2310364), // Rule ID 1634 //
     /* 2310312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2310315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2310339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310346 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2310346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2310349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2310359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310363 */     // GIR_Coverage, 1634,
     /* 2310363 */     GIR_EraseRootFromParent_Done,
     /* 2310364 */   // Label 31661: @2310364
     /* 2310364 */   GIM_Try, /*On fail goto*//*Label 31662*/ GIMT_Encode4(2310421), // Rule ID 1660 //
     /* 2310369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2310372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2310396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310403 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2310403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2310406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2310416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310420 */     // GIR_Coverage, 1660,
     /* 2310420 */     GIR_EraseRootFromParent_Done,
     /* 2310421 */   // Label 31662: @2310421
     /* 2310421 */   GIM_Try, /*On fail goto*//*Label 31663*/ GIMT_Encode4(2310478), // Rule ID 1688 //
     /* 2310426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2310429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2310453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310460 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2310460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2310463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2310473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310477 */     // GIR_Coverage, 1688,
     /* 2310477 */     GIR_EraseRootFromParent_Done,
     /* 2310478 */   // Label 31663: @2310478
     /* 2310478 */   GIM_Try, /*On fail goto*//*Label 31664*/ GIMT_Encode4(2310535), // Rule ID 1689 //
     /* 2310483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2310486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2310510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310517 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2310517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2310520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2310530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310534 */     // GIR_Coverage, 1689,
     /* 2310534 */     GIR_EraseRootFromParent_Done,
     /* 2310535 */   // Label 31664: @2310535
     /* 2310535 */   GIM_Try, /*On fail goto*//*Label 31665*/ GIMT_Encode4(2310575), // Rule ID 1629 //
     /* 2310540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2310543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310559 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2310559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2310562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310574 */     // GIR_Coverage, 1629,
     /* 2310574 */     GIR_EraseRootFromParent_Done,
     /* 2310575 */   // Label 31665: @2310575
     /* 2310575 */   GIM_Try, /*On fail goto*//*Label 31666*/ GIMT_Encode4(2310615), // Rule ID 1630 //
     /* 2310580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2310583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310599 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2310599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2310602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310614 */     // GIR_Coverage, 1630,
     /* 2310614 */     GIR_EraseRootFromParent_Done,
     /* 2310615 */   // Label 31666: @2310615
     /* 2310615 */   GIM_Try, /*On fail goto*//*Label 31667*/ GIMT_Encode4(2310655), // Rule ID 1658 //
     /* 2310620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2310623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310639 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2310639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2310642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310654 */     // GIR_Coverage, 1658,
     /* 2310654 */     GIR_EraseRootFromParent_Done,
     /* 2310655 */   // Label 31667: @2310655
     /* 2310655 */   GIM_Try, /*On fail goto*//*Label 31668*/ GIMT_Encode4(2310695), // Rule ID 1684 //
     /* 2310660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2310663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310679 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2310679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2310682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310694 */     // GIR_Coverage, 1684,
     /* 2310694 */     GIR_EraseRootFromParent_Done,
     /* 2310695 */   // Label 31668: @2310695
     /* 2310695 */   GIM_Try, /*On fail goto*//*Label 31669*/ GIMT_Encode4(2310735), // Rule ID 1685 //
     /* 2310700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2310703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310719 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2310719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2310722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310734 */     // GIR_Coverage, 1685,
     /* 2310734 */     GIR_EraseRootFromParent_Done,
     /* 2310735 */   // Label 31669: @2310735
     /* 2310735 */   GIM_Reject,
     /* 2310736 */ // Label 31639: @2310736
     /* 2310736 */ GIM_Reject,
     /* 2310737 */ // Label 31573: @2310737
     /* 2310737 */ GIM_Try, /*On fail goto*//*Label 31670*/ GIMT_Encode4(2311526),
     /* 2310742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2310745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2310748 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2310751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310755 */   GIM_Try, /*On fail goto*//*Label 31671*/ GIMT_Encode4(2310832), // Rule ID 54830 //
     /* 2310760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2310763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2310775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2310796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310801 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310803 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2310806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2310818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310831 */     // GIR_Coverage, 54830,
     /* 2310831 */     GIR_EraseRootFromParent_Done,
     /* 2310832 */   // Label 31671: @2310832
     /* 2310832 */   GIM_Try, /*On fail goto*//*Label 31672*/ GIMT_Encode4(2310909), // Rule ID 54831 //
     /* 2310837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2310840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2310852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2310873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310880 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2310883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2310895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310908 */     // GIR_Coverage, 54831,
     /* 2310908 */     GIR_EraseRootFromParent_Done,
     /* 2310909 */   // Label 31672: @2310909
     /* 2310909 */   GIM_Try, /*On fail goto*//*Label 31673*/ GIMT_Encode4(2310986), // Rule ID 72370 //
     /* 2310914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2310917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2310933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2310950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310957 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2310960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2310972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310985 */     // GIR_Coverage, 72370,
     /* 2310985 */     GIR_EraseRootFromParent_Done,
     /* 2310986 */   // Label 31673: @2310986
     /* 2310986 */   GIM_Try, /*On fail goto*//*Label 31674*/ GIMT_Encode4(2311063), // Rule ID 72371 //
     /* 2310991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2310994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2311010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2311027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311034 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2311037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311062 */     // GIR_Coverage, 72371,
     /* 2311062 */     GIR_EraseRootFromParent_Done,
     /* 2311063 */   // Label 31674: @2311063
     /* 2311063 */   GIM_Try, /*On fail goto*//*Label 31675*/ GIMT_Encode4(2311125), // Rule ID 54834 //
     /* 2311068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2311083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311098 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2311101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311124 */     // GIR_Coverage, 54834,
     /* 2311124 */     GIR_EraseRootFromParent_Done,
     /* 2311125 */   // Label 31675: @2311125
     /* 2311125 */   GIM_Try, /*On fail goto*//*Label 31676*/ GIMT_Encode4(2311187), // Rule ID 54835 //
     /* 2311130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2311145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311160 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2311163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311186 */     // GIR_Coverage, 54835,
     /* 2311186 */     GIR_EraseRootFromParent_Done,
     /* 2311187 */   // Label 31676: @2311187
     /* 2311187 */   GIM_Try, /*On fail goto*//*Label 31677*/ GIMT_Encode4(2311249), // Rule ID 72374 //
     /* 2311192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2311211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311222 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2311225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311248 */     // GIR_Coverage, 72374,
     /* 2311248 */     GIR_EraseRootFromParent_Done,
     /* 2311249 */   // Label 31677: @2311249
     /* 2311249 */   GIM_Try, /*On fail goto*//*Label 31678*/ GIMT_Encode4(2311311), // Rule ID 72375 //
     /* 2311254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2311273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311284 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2311287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311310 */     // GIR_Coverage, 72375,
     /* 2311310 */     GIR_EraseRootFromParent_Done,
     /* 2311311 */   // Label 31678: @2311311
     /* 2311311 */   GIM_Try, /*On fail goto*//*Label 31679*/ GIMT_Encode4(2311373), // Rule ID 54826 //
     /* 2311316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2311339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311346 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2311349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2311359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311372 */     // GIR_Coverage, 54826,
     /* 2311372 */     GIR_EraseRootFromParent_Done,
     /* 2311373 */   // Label 31679: @2311373
     /* 2311373 */   GIM_Try, /*On fail goto*//*Label 31680*/ GIMT_Encode4(2311435), // Rule ID 54827 //
     /* 2311378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2311401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311408 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2311411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2311421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311434 */     // GIR_Coverage, 54827,
     /* 2311434 */     GIR_EraseRootFromParent_Done,
     /* 2311435 */   // Label 31680: @2311435
     /* 2311435 */   GIM_Try, /*On fail goto*//*Label 31681*/ GIMT_Encode4(2311480), // Rule ID 54822 //
     /* 2311440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311455 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2311458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311479 */     // GIR_Coverage, 54822,
     /* 2311479 */     GIR_EraseRootFromParent_Done,
     /* 2311480 */   // Label 31681: @2311480
     /* 2311480 */   GIM_Try, /*On fail goto*//*Label 31682*/ GIMT_Encode4(2311525), // Rule ID 54823 //
     /* 2311485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311500 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2311503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311524 */     // GIR_Coverage, 54823,
     /* 2311524 */     GIR_EraseRootFromParent_Done,
     /* 2311525 */   // Label 31682: @2311525
     /* 2311525 */   GIM_Reject,
     /* 2311526 */ // Label 31670: @2311526
     /* 2311526 */ GIM_Reject,
     /* 2311527 */ // Label 31574: @2311527
     /* 2311527 */ GIM_Try, /*On fail goto*//*Label 31683*/ GIMT_Encode4(2312316),
     /* 2311532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2311535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2311538 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2311541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311545 */   GIM_Try, /*On fail goto*//*Label 31684*/ GIMT_Encode4(2311622), // Rule ID 54958 //
     /* 2311550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2311553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2311565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2311586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311593 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2311596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311621 */     // GIR_Coverage, 54958,
     /* 2311621 */     GIR_EraseRootFromParent_Done,
     /* 2311622 */   // Label 31684: @2311622
     /* 2311622 */   GIM_Try, /*On fail goto*//*Label 31685*/ GIMT_Encode4(2311699), // Rule ID 54959 //
     /* 2311627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2311630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2311642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2311663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311670 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2311673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311698 */     // GIR_Coverage, 54959,
     /* 2311698 */     GIR_EraseRootFromParent_Done,
     /* 2311699 */   // Label 31685: @2311699
     /* 2311699 */   GIM_Try, /*On fail goto*//*Label 31686*/ GIMT_Encode4(2311776), // Rule ID 72482 //
     /* 2311704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2311707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2311723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2311740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311747 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2311750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311775 */     // GIR_Coverage, 72482,
     /* 2311775 */     GIR_EraseRootFromParent_Done,
     /* 2311776 */   // Label 31686: @2311776
     /* 2311776 */   GIM_Try, /*On fail goto*//*Label 31687*/ GIMT_Encode4(2311853), // Rule ID 72483 //
     /* 2311781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2311784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2311800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2311817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311824 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2311827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311852 */     // GIR_Coverage, 72483,
     /* 2311852 */     GIR_EraseRootFromParent_Done,
     /* 2311853 */   // Label 31687: @2311853
     /* 2311853 */   GIM_Try, /*On fail goto*//*Label 31688*/ GIMT_Encode4(2311915), // Rule ID 54962 //
     /* 2311858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2311861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2311873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311888 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2311891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311914 */     // GIR_Coverage, 54962,
     /* 2311914 */     GIR_EraseRootFromParent_Done,
     /* 2311915 */   // Label 31688: @2311915
     /* 2311915 */   GIM_Try, /*On fail goto*//*Label 31689*/ GIMT_Encode4(2311977), // Rule ID 54963 //
     /* 2311920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2311923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2311935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311950 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2311953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311976 */     // GIR_Coverage, 54963,
     /* 2311976 */     GIR_EraseRootFromParent_Done,
     /* 2311977 */   // Label 31689: @2311977
     /* 2311977 */   GIM_Try, /*On fail goto*//*Label 31690*/ GIMT_Encode4(2312039), // Rule ID 72486 //
     /* 2311982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2311985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2312001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312012 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2312015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312038 */     // GIR_Coverage, 72486,
     /* 2312038 */     GIR_EraseRootFromParent_Done,
     /* 2312039 */   // Label 31690: @2312039
     /* 2312039 */   GIM_Try, /*On fail goto*//*Label 31691*/ GIMT_Encode4(2312101), // Rule ID 72487 //
     /* 2312044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2312047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2312063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312074 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2312077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312100 */     // GIR_Coverage, 72487,
     /* 2312100 */     GIR_EraseRootFromParent_Done,
     /* 2312101 */   // Label 31691: @2312101
     /* 2312101 */   GIM_Try, /*On fail goto*//*Label 31692*/ GIMT_Encode4(2312163), // Rule ID 54954 //
     /* 2312106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2312109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2312129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312136 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2312139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2312149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312162 */     // GIR_Coverage, 54954,
     /* 2312162 */     GIR_EraseRootFromParent_Done,
     /* 2312163 */   // Label 31692: @2312163
     /* 2312163 */   GIM_Try, /*On fail goto*//*Label 31693*/ GIMT_Encode4(2312225), // Rule ID 54955 //
     /* 2312168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2312171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2312191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312198 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2312201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2312211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312224 */     // GIR_Coverage, 54955,
     /* 2312224 */     GIR_EraseRootFromParent_Done,
     /* 2312225 */   // Label 31693: @2312225
     /* 2312225 */   GIM_Try, /*On fail goto*//*Label 31694*/ GIMT_Encode4(2312270), // Rule ID 54950 //
     /* 2312230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2312233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312245 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2312248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312269 */     // GIR_Coverage, 54950,
     /* 2312269 */     GIR_EraseRootFromParent_Done,
     /* 2312270 */   // Label 31694: @2312270
     /* 2312270 */   GIM_Try, /*On fail goto*//*Label 31695*/ GIMT_Encode4(2312315), // Rule ID 54951 //
     /* 2312275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2312278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312290 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2312293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312314 */     // GIR_Coverage, 54951,
     /* 2312314 */     GIR_EraseRootFromParent_Done,
     /* 2312315 */   // Label 31695: @2312315
     /* 2312315 */   GIM_Reject,
     /* 2312316 */ // Label 31683: @2312316
     /* 2312316 */ GIM_Reject,
     /* 2312317 */ // Label 31575: @2312317
     /* 2312317 */ GIM_Try, /*On fail goto*//*Label 31696*/ GIMT_Encode4(2313106),
     /* 2312322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2312328 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2312331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312335 */   GIM_Try, /*On fail goto*//*Label 31697*/ GIMT_Encode4(2312412), // Rule ID 55150 //
     /* 2312340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312383 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2312386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312411 */     // GIR_Coverage, 55150,
     /* 2312411 */     GIR_EraseRootFromParent_Done,
     /* 2312412 */   // Label 31697: @2312412
     /* 2312412 */   GIM_Try, /*On fail goto*//*Label 31698*/ GIMT_Encode4(2312489), // Rule ID 55151 //
     /* 2312417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312460 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2312463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312488 */     // GIR_Coverage, 55151,
     /* 2312488 */     GIR_EraseRootFromParent_Done,
     /* 2312489 */   // Label 31698: @2312489
     /* 2312489 */   GIM_Try, /*On fail goto*//*Label 31699*/ GIMT_Encode4(2312566), // Rule ID 72650 //
     /* 2312494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312537 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2312540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312565 */     // GIR_Coverage, 72650,
     /* 2312565 */     GIR_EraseRootFromParent_Done,
     /* 2312566 */   // Label 31699: @2312566
     /* 2312566 */   GIM_Try, /*On fail goto*//*Label 31700*/ GIMT_Encode4(2312643), // Rule ID 72651 //
     /* 2312571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312614 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2312617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312642 */     // GIR_Coverage, 72651,
     /* 2312642 */     GIR_EraseRootFromParent_Done,
     /* 2312643 */   // Label 31700: @2312643
     /* 2312643 */   GIM_Try, /*On fail goto*//*Label 31701*/ GIMT_Encode4(2312705), // Rule ID 55154 //
     /* 2312648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312678 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2312681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312704 */     // GIR_Coverage, 55154,
     /* 2312704 */     GIR_EraseRootFromParent_Done,
     /* 2312705 */   // Label 31701: @2312705
     /* 2312705 */   GIM_Try, /*On fail goto*//*Label 31702*/ GIMT_Encode4(2312767), // Rule ID 55155 //
     /* 2312710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312740 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2312743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312766 */     // GIR_Coverage, 55155,
     /* 2312766 */     GIR_EraseRootFromParent_Done,
     /* 2312767 */   // Label 31702: @2312767
     /* 2312767 */   GIM_Try, /*On fail goto*//*Label 31703*/ GIMT_Encode4(2312829), // Rule ID 72654 //
     /* 2312772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312802 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2312805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312828 */     // GIR_Coverage, 72654,
     /* 2312828 */     GIR_EraseRootFromParent_Done,
     /* 2312829 */   // Label 31703: @2312829
     /* 2312829 */   GIM_Try, /*On fail goto*//*Label 31704*/ GIMT_Encode4(2312891), // Rule ID 72655 //
     /* 2312834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312864 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2312867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312890 */     // GIR_Coverage, 72655,
     /* 2312890 */     GIR_EraseRootFromParent_Done,
     /* 2312891 */   // Label 31704: @2312891
     /* 2312891 */   GIM_Try, /*On fail goto*//*Label 31705*/ GIMT_Encode4(2312953), // Rule ID 55146 //
     /* 2312896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312926 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2312929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2312939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312952 */     // GIR_Coverage, 55146,
     /* 2312952 */     GIR_EraseRootFromParent_Done,
     /* 2312953 */   // Label 31705: @2312953
     /* 2312953 */   GIM_Try, /*On fail goto*//*Label 31706*/ GIMT_Encode4(2313015), // Rule ID 55147 //
     /* 2312958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312988 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2312991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2313001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313014 */     // GIR_Coverage, 55147,
     /* 2313014 */     GIR_EraseRootFromParent_Done,
     /* 2313015 */   // Label 31706: @2313015
     /* 2313015 */   GIM_Try, /*On fail goto*//*Label 31707*/ GIMT_Encode4(2313060), // Rule ID 55142 //
     /* 2313020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2313023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313035 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2313038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313059 */     // GIR_Coverage, 55142,
     /* 2313059 */     GIR_EraseRootFromParent_Done,
     /* 2313060 */   // Label 31707: @2313060
     /* 2313060 */   GIM_Try, /*On fail goto*//*Label 31708*/ GIMT_Encode4(2313105), // Rule ID 55143 //
     /* 2313065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2313068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313080 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2313083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313104 */     // GIR_Coverage, 55143,
     /* 2313104 */     GIR_EraseRootFromParent_Done,
     /* 2313105 */   // Label 31708: @2313105
     /* 2313105 */   GIM_Reject,
     /* 2313106 */ // Label 31696: @2313106
     /* 2313106 */ GIM_Reject,
     /* 2313107 */ // Label 31576: @2313107
     /* 2313107 */ GIM_Try, /*On fail goto*//*Label 31709*/ GIMT_Encode4(2313896),
     /* 2313112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2313118 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2313121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313125 */   GIM_Try, /*On fail goto*//*Label 31710*/ GIMT_Encode4(2313202), // Rule ID 54894 //
     /* 2313130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313173 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2313176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313201 */     // GIR_Coverage, 54894,
     /* 2313201 */     GIR_EraseRootFromParent_Done,
     /* 2313202 */   // Label 31710: @2313202
     /* 2313202 */   GIM_Try, /*On fail goto*//*Label 31711*/ GIMT_Encode4(2313279), // Rule ID 54895 //
     /* 2313207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313250 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2313253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313278 */     // GIR_Coverage, 54895,
     /* 2313278 */     GIR_EraseRootFromParent_Done,
     /* 2313279 */   // Label 31711: @2313279
     /* 2313279 */   GIM_Try, /*On fail goto*//*Label 31712*/ GIMT_Encode4(2313356), // Rule ID 72426 //
     /* 2313284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313327 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2313330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313355 */     // GIR_Coverage, 72426,
     /* 2313355 */     GIR_EraseRootFromParent_Done,
     /* 2313356 */   // Label 31712: @2313356
     /* 2313356 */   GIM_Try, /*On fail goto*//*Label 31713*/ GIMT_Encode4(2313433), // Rule ID 72427 //
     /* 2313361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313404 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2313407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313432 */     // GIR_Coverage, 72427,
     /* 2313432 */     GIR_EraseRootFromParent_Done,
     /* 2313433 */   // Label 31713: @2313433
     /* 2313433 */   GIM_Try, /*On fail goto*//*Label 31714*/ GIMT_Encode4(2313495), // Rule ID 54898 //
     /* 2313438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313468 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2313471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313494 */     // GIR_Coverage, 54898,
     /* 2313494 */     GIR_EraseRootFromParent_Done,
     /* 2313495 */   // Label 31714: @2313495
     /* 2313495 */   GIM_Try, /*On fail goto*//*Label 31715*/ GIMT_Encode4(2313557), // Rule ID 54899 //
     /* 2313500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313530 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2313533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313556 */     // GIR_Coverage, 54899,
     /* 2313556 */     GIR_EraseRootFromParent_Done,
     /* 2313557 */   // Label 31715: @2313557
     /* 2313557 */   GIM_Try, /*On fail goto*//*Label 31716*/ GIMT_Encode4(2313619), // Rule ID 72430 //
     /* 2313562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313592 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2313595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313618 */     // GIR_Coverage, 72430,
     /* 2313618 */     GIR_EraseRootFromParent_Done,
     /* 2313619 */   // Label 31716: @2313619
     /* 2313619 */   GIM_Try, /*On fail goto*//*Label 31717*/ GIMT_Encode4(2313681), // Rule ID 72431 //
     /* 2313624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313654 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2313657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313680 */     // GIR_Coverage, 72431,
     /* 2313680 */     GIR_EraseRootFromParent_Done,
     /* 2313681 */   // Label 31717: @2313681
     /* 2313681 */   GIM_Try, /*On fail goto*//*Label 31718*/ GIMT_Encode4(2313743), // Rule ID 54890 //
     /* 2313686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313716 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2313719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2313729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313742 */     // GIR_Coverage, 54890,
     /* 2313742 */     GIR_EraseRootFromParent_Done,
     /* 2313743 */   // Label 31718: @2313743
     /* 2313743 */   GIM_Try, /*On fail goto*//*Label 31719*/ GIMT_Encode4(2313805), // Rule ID 54891 //
     /* 2313748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313778 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2313781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2313791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313804 */     // GIR_Coverage, 54891,
     /* 2313804 */     GIR_EraseRootFromParent_Done,
     /* 2313805 */   // Label 31719: @2313805
     /* 2313805 */   GIM_Try, /*On fail goto*//*Label 31720*/ GIMT_Encode4(2313850), // Rule ID 54886 //
     /* 2313810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313825 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2313828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313849 */     // GIR_Coverage, 54886,
     /* 2313849 */     GIR_EraseRootFromParent_Done,
     /* 2313850 */   // Label 31720: @2313850
     /* 2313850 */   GIM_Try, /*On fail goto*//*Label 31721*/ GIMT_Encode4(2313895), // Rule ID 54887 //
     /* 2313855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313870 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2313873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313894 */     // GIR_Coverage, 54887,
     /* 2313894 */     GIR_EraseRootFromParent_Done,
     /* 2313895 */   // Label 31721: @2313895
     /* 2313895 */   GIM_Reject,
     /* 2313896 */ // Label 31709: @2313896
     /* 2313896 */ GIM_Reject,
     /* 2313897 */ // Label 31577: @2313897
     /* 2313897 */ GIM_Try, /*On fail goto*//*Label 31722*/ GIMT_Encode4(2314686),
     /* 2313902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2313905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2313908 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2313911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313915 */   GIM_Try, /*On fail goto*//*Label 31723*/ GIMT_Encode4(2313992), // Rule ID 55086 //
     /* 2313920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2313923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2313935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2313956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313963 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2313966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313991 */     // GIR_Coverage, 55086,
     /* 2313991 */     GIR_EraseRootFromParent_Done,
     /* 2313992 */   // Label 31723: @2313992
     /* 2313992 */   GIM_Try, /*On fail goto*//*Label 31724*/ GIMT_Encode4(2314069), // Rule ID 55087 //
     /* 2313997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2314012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2314033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314040 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2314043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314068 */     // GIR_Coverage, 55087,
     /* 2314068 */     GIR_EraseRootFromParent_Done,
     /* 2314069 */   // Label 31724: @2314069
     /* 2314069 */   GIM_Try, /*On fail goto*//*Label 31725*/ GIMT_Encode4(2314146), // Rule ID 72594 //
     /* 2314074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2314093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2314110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314117 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2314120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314145 */     // GIR_Coverage, 72594,
     /* 2314145 */     GIR_EraseRootFromParent_Done,
     /* 2314146 */   // Label 31725: @2314146
     /* 2314146 */   GIM_Try, /*On fail goto*//*Label 31726*/ GIMT_Encode4(2314223), // Rule ID 72595 //
     /* 2314151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2314170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2314187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314194 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2314197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314222 */     // GIR_Coverage, 72595,
     /* 2314222 */     GIR_EraseRootFromParent_Done,
     /* 2314223 */   // Label 31726: @2314223
     /* 2314223 */   GIM_Try, /*On fail goto*//*Label 31727*/ GIMT_Encode4(2314285), // Rule ID 55090 //
     /* 2314228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2314243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314258 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2314261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314284 */     // GIR_Coverage, 55090,
     /* 2314284 */     GIR_EraseRootFromParent_Done,
     /* 2314285 */   // Label 31727: @2314285
     /* 2314285 */   GIM_Try, /*On fail goto*//*Label 31728*/ GIMT_Encode4(2314347), // Rule ID 55091 //
     /* 2314290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2314305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314320 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2314323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314346 */     // GIR_Coverage, 55091,
     /* 2314346 */     GIR_EraseRootFromParent_Done,
     /* 2314347 */   // Label 31728: @2314347
     /* 2314347 */   GIM_Try, /*On fail goto*//*Label 31729*/ GIMT_Encode4(2314409), // Rule ID 72598 //
     /* 2314352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2314371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314382 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2314385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314408 */     // GIR_Coverage, 72598,
     /* 2314408 */     GIR_EraseRootFromParent_Done,
     /* 2314409 */   // Label 31729: @2314409
     /* 2314409 */   GIM_Try, /*On fail goto*//*Label 31730*/ GIMT_Encode4(2314471), // Rule ID 72599 //
     /* 2314414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2314433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314444 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2314447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314470 */     // GIR_Coverage, 72599,
     /* 2314470 */     GIR_EraseRootFromParent_Done,
     /* 2314471 */   // Label 31730: @2314471
     /* 2314471 */   GIM_Try, /*On fail goto*//*Label 31731*/ GIMT_Encode4(2314533), // Rule ID 55082 //
     /* 2314476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2314499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314506 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2314509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2314519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314532 */     // GIR_Coverage, 55082,
     /* 2314532 */     GIR_EraseRootFromParent_Done,
     /* 2314533 */   // Label 31731: @2314533
     /* 2314533 */   GIM_Try, /*On fail goto*//*Label 31732*/ GIMT_Encode4(2314595), // Rule ID 55083 //
     /* 2314538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2314561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314568 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2314571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2314581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314594 */     // GIR_Coverage, 55083,
     /* 2314594 */     GIR_EraseRootFromParent_Done,
     /* 2314595 */   // Label 31732: @2314595
     /* 2314595 */   GIM_Try, /*On fail goto*//*Label 31733*/ GIMT_Encode4(2314640), // Rule ID 55078 //
     /* 2314600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314615 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2314618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314639 */     // GIR_Coverage, 55078,
     /* 2314639 */     GIR_EraseRootFromParent_Done,
     /* 2314640 */   // Label 31733: @2314640
     /* 2314640 */   GIM_Try, /*On fail goto*//*Label 31734*/ GIMT_Encode4(2314685), // Rule ID 55079 //
     /* 2314645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314660 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2314663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314684 */     // GIR_Coverage, 55079,
     /* 2314684 */     GIR_EraseRootFromParent_Done,
     /* 2314685 */   // Label 31734: @2314685
     /* 2314685 */   GIM_Reject,
     /* 2314686 */ // Label 31722: @2314686
     /* 2314686 */ GIM_Reject,
     /* 2314687 */ // Label 31578: @2314687
     /* 2314687 */ GIM_Try, /*On fail goto*//*Label 31735*/ GIMT_Encode4(2315476),
     /* 2314692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2314695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2314698 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2314701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314705 */   GIM_Try, /*On fail goto*//*Label 31736*/ GIMT_Encode4(2314782), // Rule ID 55598 //
     /* 2314710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2314713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2314725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2314746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314753 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2314756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314781 */     // GIR_Coverage, 55598,
     /* 2314781 */     GIR_EraseRootFromParent_Done,
     /* 2314782 */   // Label 31736: @2314782
     /* 2314782 */   GIM_Try, /*On fail goto*//*Label 31737*/ GIMT_Encode4(2314859), // Rule ID 55599 //
     /* 2314787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2314790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2314802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2314823 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314830 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2314833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314858 */     // GIR_Coverage, 55599,
     /* 2314858 */     GIR_EraseRootFromParent_Done,
     /* 2314859 */   // Label 31737: @2314859
     /* 2314859 */   GIM_Try, /*On fail goto*//*Label 31738*/ GIMT_Encode4(2314936), // Rule ID 73042 //
     /* 2314864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2314867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2314883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2314900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314907 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2314910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314935 */     // GIR_Coverage, 73042,
     /* 2314935 */     GIR_EraseRootFromParent_Done,
     /* 2314936 */   // Label 31738: @2314936
     /* 2314936 */   GIM_Try, /*On fail goto*//*Label 31739*/ GIMT_Encode4(2315013), // Rule ID 73043 //
     /* 2314941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2314944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2314960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2314977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314984 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2314987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315012 */     // GIR_Coverage, 73043,
     /* 2315012 */     GIR_EraseRootFromParent_Done,
     /* 2315013 */   // Label 31739: @2315013
     /* 2315013 */   GIM_Try, /*On fail goto*//*Label 31740*/ GIMT_Encode4(2315075), // Rule ID 55602 //
     /* 2315018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2315021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2315033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315048 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2315051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315074 */     // GIR_Coverage, 55602,
     /* 2315074 */     GIR_EraseRootFromParent_Done,
     /* 2315075 */   // Label 31740: @2315075
     /* 2315075 */   GIM_Try, /*On fail goto*//*Label 31741*/ GIMT_Encode4(2315137), // Rule ID 55603 //
     /* 2315080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2315083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2315095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315110 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2315113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315136 */     // GIR_Coverage, 55603,
     /* 2315136 */     GIR_EraseRootFromParent_Done,
     /* 2315137 */   // Label 31741: @2315137
     /* 2315137 */   GIM_Try, /*On fail goto*//*Label 31742*/ GIMT_Encode4(2315199), // Rule ID 73046 //
     /* 2315142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2315145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2315161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315172 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2315175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315198 */     // GIR_Coverage, 73046,
     /* 2315198 */     GIR_EraseRootFromParent_Done,
     /* 2315199 */   // Label 31742: @2315199
     /* 2315199 */   GIM_Try, /*On fail goto*//*Label 31743*/ GIMT_Encode4(2315261), // Rule ID 73047 //
     /* 2315204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2315207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2315223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315234 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2315237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315260 */     // GIR_Coverage, 73047,
     /* 2315260 */     GIR_EraseRootFromParent_Done,
     /* 2315261 */   // Label 31743: @2315261
     /* 2315261 */   GIM_Try, /*On fail goto*//*Label 31744*/ GIMT_Encode4(2315323), // Rule ID 55594 //
     /* 2315266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2315269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2315289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315296 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2315299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2315309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315322 */     // GIR_Coverage, 55594,
     /* 2315322 */     GIR_EraseRootFromParent_Done,
     /* 2315323 */   // Label 31744: @2315323
     /* 2315323 */   GIM_Try, /*On fail goto*//*Label 31745*/ GIMT_Encode4(2315385), // Rule ID 55595 //
     /* 2315328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2315331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2315351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315358 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2315361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2315371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315384 */     // GIR_Coverage, 55595,
     /* 2315384 */     GIR_EraseRootFromParent_Done,
     /* 2315385 */   // Label 31745: @2315385
     /* 2315385 */   GIM_Try, /*On fail goto*//*Label 31746*/ GIMT_Encode4(2315430), // Rule ID 55590 //
     /* 2315390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2315393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315405 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2315408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315429 */     // GIR_Coverage, 55590,
     /* 2315429 */     GIR_EraseRootFromParent_Done,
     /* 2315430 */   // Label 31746: @2315430
     /* 2315430 */   GIM_Try, /*On fail goto*//*Label 31747*/ GIMT_Encode4(2315475), // Rule ID 55591 //
     /* 2315435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2315438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315450 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2315453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315474 */     // GIR_Coverage, 55591,
     /* 2315474 */     GIR_EraseRootFromParent_Done,
     /* 2315475 */   // Label 31747: @2315475
     /* 2315475 */   GIM_Reject,
     /* 2315476 */ // Label 31735: @2315476
     /* 2315476 */ GIM_Reject,
     /* 2315477 */ // Label 31579: @2315477
     /* 2315477 */ GIM_Try, /*On fail goto*//*Label 31748*/ GIMT_Encode4(2316266),
     /* 2315482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2315485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2315488 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2315491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315495 */   GIM_Try, /*On fail goto*//*Label 31749*/ GIMT_Encode4(2315572), // Rule ID 55022 //
     /* 2315500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2315503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2315515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2315536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315543 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2315546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315571 */     // GIR_Coverage, 55022,
     /* 2315571 */     GIR_EraseRootFromParent_Done,
     /* 2315572 */   // Label 31749: @2315572
     /* 2315572 */   GIM_Try, /*On fail goto*//*Label 31750*/ GIMT_Encode4(2315649), // Rule ID 55023 //
     /* 2315577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2315592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2315613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315620 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2315623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315648 */     // GIR_Coverage, 55023,
     /* 2315648 */     GIR_EraseRootFromParent_Done,
     /* 2315649 */   // Label 31750: @2315649
     /* 2315649 */   GIM_Try, /*On fail goto*//*Label 31751*/ GIMT_Encode4(2315726), // Rule ID 72538 //
     /* 2315654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2315657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2315673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2315690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315697 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2315700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315725 */     // GIR_Coverage, 72538,
     /* 2315725 */     GIR_EraseRootFromParent_Done,
     /* 2315726 */   // Label 31751: @2315726
     /* 2315726 */   GIM_Try, /*On fail goto*//*Label 31752*/ GIMT_Encode4(2315803), // Rule ID 72539 //
     /* 2315731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2315750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2315767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315774 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2315777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315802 */     // GIR_Coverage, 72539,
     /* 2315802 */     GIR_EraseRootFromParent_Done,
     /* 2315803 */   // Label 31752: @2315803
     /* 2315803 */   GIM_Try, /*On fail goto*//*Label 31753*/ GIMT_Encode4(2315865), // Rule ID 55026 //
     /* 2315808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2315811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2315823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315838 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2315841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315864 */     // GIR_Coverage, 55026,
     /* 2315864 */     GIR_EraseRootFromParent_Done,
     /* 2315865 */   // Label 31753: @2315865
     /* 2315865 */   GIM_Try, /*On fail goto*//*Label 31754*/ GIMT_Encode4(2315927), // Rule ID 55027 //
     /* 2315870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2315885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315900 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2315903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315926 */     // GIR_Coverage, 55027,
     /* 2315926 */     GIR_EraseRootFromParent_Done,
     /* 2315927 */   // Label 31754: @2315927
     /* 2315927 */   GIM_Try, /*On fail goto*//*Label 31755*/ GIMT_Encode4(2315989), // Rule ID 72542 //
     /* 2315932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2315935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2315951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315962 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2315965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315988 */     // GIR_Coverage, 72542,
     /* 2315988 */     GIR_EraseRootFromParent_Done,
     /* 2315989 */   // Label 31755: @2315989
     /* 2315989 */   GIM_Try, /*On fail goto*//*Label 31756*/ GIMT_Encode4(2316051), // Rule ID 72543 //
     /* 2315994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2316013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316024 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2316027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316050 */     // GIR_Coverage, 72543,
     /* 2316050 */     GIR_EraseRootFromParent_Done,
     /* 2316051 */   // Label 31756: @2316051
     /* 2316051 */   GIM_Try, /*On fail goto*//*Label 31757*/ GIMT_Encode4(2316113), // Rule ID 55018 //
     /* 2316056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2316059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2316079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316086 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2316089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2316099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316112 */     // GIR_Coverage, 55018,
     /* 2316112 */     GIR_EraseRootFromParent_Done,
     /* 2316113 */   // Label 31757: @2316113
     /* 2316113 */   GIM_Try, /*On fail goto*//*Label 31758*/ GIMT_Encode4(2316175), // Rule ID 55019 //
     /* 2316118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2316121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2316141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316148 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2316151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2316161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316174 */     // GIR_Coverage, 55019,
     /* 2316174 */     GIR_EraseRootFromParent_Done,
     /* 2316175 */   // Label 31758: @2316175
     /* 2316175 */   GIM_Try, /*On fail goto*//*Label 31759*/ GIMT_Encode4(2316220), // Rule ID 55014 //
     /* 2316180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2316183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316195 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2316198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316219 */     // GIR_Coverage, 55014,
     /* 2316219 */     GIR_EraseRootFromParent_Done,
     /* 2316220 */   // Label 31759: @2316220
     /* 2316220 */   GIM_Try, /*On fail goto*//*Label 31760*/ GIMT_Encode4(2316265), // Rule ID 55015 //
     /* 2316225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2316228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316240 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2316243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316264 */     // GIR_Coverage, 55015,
     /* 2316264 */     GIR_EraseRootFromParent_Done,
     /* 2316265 */   // Label 31760: @2316265
     /* 2316265 */   GIM_Reject,
     /* 2316266 */ // Label 31748: @2316266
     /* 2316266 */ GIM_Reject,
     /* 2316267 */ // Label 31580: @2316267
     /* 2316267 */ GIM_Try, /*On fail goto*//*Label 31761*/ GIMT_Encode4(2317056),
     /* 2316272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2316278 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2316281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316285 */   GIM_Try, /*On fail goto*//*Label 31762*/ GIMT_Encode4(2316362), // Rule ID 55406 //
     /* 2316290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316333 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2316336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316361 */     // GIR_Coverage, 55406,
     /* 2316361 */     GIR_EraseRootFromParent_Done,
     /* 2316362 */   // Label 31762: @2316362
     /* 2316362 */   GIM_Try, /*On fail goto*//*Label 31763*/ GIMT_Encode4(2316439), // Rule ID 55407 //
     /* 2316367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316410 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2316413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316438 */     // GIR_Coverage, 55407,
     /* 2316438 */     GIR_EraseRootFromParent_Done,
     /* 2316439 */   // Label 31763: @2316439
     /* 2316439 */   GIM_Try, /*On fail goto*//*Label 31764*/ GIMT_Encode4(2316516), // Rule ID 72874 //
     /* 2316444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316487 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2316490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316515 */     // GIR_Coverage, 72874,
     /* 2316515 */     GIR_EraseRootFromParent_Done,
     /* 2316516 */   // Label 31764: @2316516
     /* 2316516 */   GIM_Try, /*On fail goto*//*Label 31765*/ GIMT_Encode4(2316593), // Rule ID 72875 //
     /* 2316521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316564 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2316567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316592 */     // GIR_Coverage, 72875,
     /* 2316592 */     GIR_EraseRootFromParent_Done,
     /* 2316593 */   // Label 31765: @2316593
     /* 2316593 */   GIM_Try, /*On fail goto*//*Label 31766*/ GIMT_Encode4(2316655), // Rule ID 55410 //
     /* 2316598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316628 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2316631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316654 */     // GIR_Coverage, 55410,
     /* 2316654 */     GIR_EraseRootFromParent_Done,
     /* 2316655 */   // Label 31766: @2316655
     /* 2316655 */   GIM_Try, /*On fail goto*//*Label 31767*/ GIMT_Encode4(2316717), // Rule ID 55411 //
     /* 2316660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316690 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2316693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316716 */     // GIR_Coverage, 55411,
     /* 2316716 */     GIR_EraseRootFromParent_Done,
     /* 2316717 */   // Label 31767: @2316717
     /* 2316717 */   GIM_Try, /*On fail goto*//*Label 31768*/ GIMT_Encode4(2316779), // Rule ID 72878 //
     /* 2316722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316752 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2316755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316778 */     // GIR_Coverage, 72878,
     /* 2316778 */     GIR_EraseRootFromParent_Done,
     /* 2316779 */   // Label 31768: @2316779
     /* 2316779 */   GIM_Try, /*On fail goto*//*Label 31769*/ GIMT_Encode4(2316841), // Rule ID 72879 //
     /* 2316784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316814 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2316817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316840 */     // GIR_Coverage, 72879,
     /* 2316840 */     GIR_EraseRootFromParent_Done,
     /* 2316841 */   // Label 31769: @2316841
     /* 2316841 */   GIM_Try, /*On fail goto*//*Label 31770*/ GIMT_Encode4(2316903), // Rule ID 55402 //
     /* 2316846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316876 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2316879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2316889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316902 */     // GIR_Coverage, 55402,
     /* 2316902 */     GIR_EraseRootFromParent_Done,
     /* 2316903 */   // Label 31770: @2316903
     /* 2316903 */   GIM_Try, /*On fail goto*//*Label 31771*/ GIMT_Encode4(2316965), // Rule ID 55403 //
     /* 2316908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2316931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316938 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2316941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2316951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316964 */     // GIR_Coverage, 55403,
     /* 2316964 */     GIR_EraseRootFromParent_Done,
     /* 2316965 */   // Label 31771: @2316965
     /* 2316965 */   GIM_Try, /*On fail goto*//*Label 31772*/ GIMT_Encode4(2317010), // Rule ID 55398 //
     /* 2316970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316985 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2316988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317009 */     // GIR_Coverage, 55398,
     /* 2317009 */     GIR_EraseRootFromParent_Done,
     /* 2317010 */   // Label 31772: @2317010
     /* 2317010 */   GIM_Try, /*On fail goto*//*Label 31773*/ GIMT_Encode4(2317055), // Rule ID 55399 //
     /* 2317015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2317018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317030 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2317033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317054 */     // GIR_Coverage, 55399,
     /* 2317054 */     GIR_EraseRootFromParent_Done,
     /* 2317055 */   // Label 31773: @2317055
     /* 2317055 */   GIM_Reject,
     /* 2317056 */ // Label 31761: @2317056
     /* 2317056 */ GIM_Reject,
     /* 2317057 */ // Label 31581: @2317057
     /* 2317057 */ GIM_Try, /*On fail goto*//*Label 31774*/ GIMT_Encode4(2317846),
     /* 2317062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2317068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2317071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317075 */   GIM_Try, /*On fail goto*//*Label 31775*/ GIMT_Encode4(2317152), // Rule ID 55662 //
     /* 2317080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317123 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2317126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317151 */     // GIR_Coverage, 55662,
     /* 2317151 */     GIR_EraseRootFromParent_Done,
     /* 2317152 */   // Label 31775: @2317152
     /* 2317152 */   GIM_Try, /*On fail goto*//*Label 31776*/ GIMT_Encode4(2317229), // Rule ID 55663 //
     /* 2317157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317200 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2317203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317228 */     // GIR_Coverage, 55663,
     /* 2317228 */     GIR_EraseRootFromParent_Done,
     /* 2317229 */   // Label 31776: @2317229
     /* 2317229 */   GIM_Try, /*On fail goto*//*Label 31777*/ GIMT_Encode4(2317306), // Rule ID 73098 //
     /* 2317234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317277 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2317280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317305 */     // GIR_Coverage, 73098,
     /* 2317305 */     GIR_EraseRootFromParent_Done,
     /* 2317306 */   // Label 31777: @2317306
     /* 2317306 */   GIM_Try, /*On fail goto*//*Label 31778*/ GIMT_Encode4(2317383), // Rule ID 73099 //
     /* 2317311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317354 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2317357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317382 */     // GIR_Coverage, 73099,
     /* 2317382 */     GIR_EraseRootFromParent_Done,
     /* 2317383 */   // Label 31778: @2317383
     /* 2317383 */   GIM_Try, /*On fail goto*//*Label 31779*/ GIMT_Encode4(2317445), // Rule ID 55666 //
     /* 2317388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317418 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2317421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317444 */     // GIR_Coverage, 55666,
     /* 2317444 */     GIR_EraseRootFromParent_Done,
     /* 2317445 */   // Label 31779: @2317445
     /* 2317445 */   GIM_Try, /*On fail goto*//*Label 31780*/ GIMT_Encode4(2317507), // Rule ID 55667 //
     /* 2317450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317480 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2317483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317506 */     // GIR_Coverage, 55667,
     /* 2317506 */     GIR_EraseRootFromParent_Done,
     /* 2317507 */   // Label 31780: @2317507
     /* 2317507 */   GIM_Try, /*On fail goto*//*Label 31781*/ GIMT_Encode4(2317569), // Rule ID 73102 //
     /* 2317512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317542 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2317545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317568 */     // GIR_Coverage, 73102,
     /* 2317568 */     GIR_EraseRootFromParent_Done,
     /* 2317569 */   // Label 31781: @2317569
     /* 2317569 */   GIM_Try, /*On fail goto*//*Label 31782*/ GIMT_Encode4(2317631), // Rule ID 73103 //
     /* 2317574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317604 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2317607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317630 */     // GIR_Coverage, 73103,
     /* 2317630 */     GIR_EraseRootFromParent_Done,
     /* 2317631 */   // Label 31782: @2317631
     /* 2317631 */   GIM_Try, /*On fail goto*//*Label 31783*/ GIMT_Encode4(2317693), // Rule ID 55658 //
     /* 2317636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317666 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2317669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2317679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317692 */     // GIR_Coverage, 55658,
     /* 2317692 */     GIR_EraseRootFromParent_Done,
     /* 2317693 */   // Label 31783: @2317693
     /* 2317693 */   GIM_Try, /*On fail goto*//*Label 31784*/ GIMT_Encode4(2317755), // Rule ID 55659 //
     /* 2317698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2317721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317728 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2317731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2317741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317754 */     // GIR_Coverage, 55659,
     /* 2317754 */     GIR_EraseRootFromParent_Done,
     /* 2317755 */   // Label 31784: @2317755
     /* 2317755 */   GIM_Try, /*On fail goto*//*Label 31785*/ GIMT_Encode4(2317800), // Rule ID 55654 //
     /* 2317760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317775 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2317778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317799 */     // GIR_Coverage, 55654,
     /* 2317799 */     GIR_EraseRootFromParent_Done,
     /* 2317800 */   // Label 31785: @2317800
     /* 2317800 */   GIM_Try, /*On fail goto*//*Label 31786*/ GIMT_Encode4(2317845), // Rule ID 55655 //
     /* 2317805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317820 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2317823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317844 */     // GIR_Coverage, 55655,
     /* 2317844 */     GIR_EraseRootFromParent_Done,
     /* 2317845 */   // Label 31786: @2317845
     /* 2317845 */   GIM_Reject,
     /* 2317846 */ // Label 31774: @2317846
     /* 2317846 */ GIM_Reject,
     /* 2317847 */ // Label 31582: @2317847
     /* 2317847 */ GIM_Try, /*On fail goto*//*Label 31787*/ GIMT_Encode4(2318636),
     /* 2317852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2317855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2317858 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2317861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317865 */   GIM_Try, /*On fail goto*//*Label 31788*/ GIMT_Encode4(2317942), // Rule ID 55214 //
     /* 2317870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2317873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2317885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2317906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317913 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2317916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317941 */     // GIR_Coverage, 55214,
     /* 2317941 */     GIR_EraseRootFromParent_Done,
     /* 2317942 */   // Label 31788: @2317942
     /* 2317942 */   GIM_Try, /*On fail goto*//*Label 31789*/ GIMT_Encode4(2318019), // Rule ID 55215 //
     /* 2317947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2317950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2317962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2317983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317990 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2317993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318018 */     // GIR_Coverage, 55215,
     /* 2318018 */     GIR_EraseRootFromParent_Done,
     /* 2318019 */   // Label 31789: @2318019
     /* 2318019 */   GIM_Try, /*On fail goto*//*Label 31790*/ GIMT_Encode4(2318096), // Rule ID 72706 //
     /* 2318024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2318043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2318060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318067 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2318070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318095 */     // GIR_Coverage, 72706,
     /* 2318095 */     GIR_EraseRootFromParent_Done,
     /* 2318096 */   // Label 31790: @2318096
     /* 2318096 */   GIM_Try, /*On fail goto*//*Label 31791*/ GIMT_Encode4(2318173), // Rule ID 72707 //
     /* 2318101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2318120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2318137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318144 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2318147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318172 */     // GIR_Coverage, 72707,
     /* 2318172 */     GIR_EraseRootFromParent_Done,
     /* 2318173 */   // Label 31791: @2318173
     /* 2318173 */   GIM_Try, /*On fail goto*//*Label 31792*/ GIMT_Encode4(2318235), // Rule ID 55218 //
     /* 2318178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2318193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318208 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2318211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318234 */     // GIR_Coverage, 55218,
     /* 2318234 */     GIR_EraseRootFromParent_Done,
     /* 2318235 */   // Label 31792: @2318235
     /* 2318235 */   GIM_Try, /*On fail goto*//*Label 31793*/ GIMT_Encode4(2318297), // Rule ID 55219 //
     /* 2318240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2318255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318270 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2318273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318296 */     // GIR_Coverage, 55219,
     /* 2318296 */     GIR_EraseRootFromParent_Done,
     /* 2318297 */   // Label 31793: @2318297
     /* 2318297 */   GIM_Try, /*On fail goto*//*Label 31794*/ GIMT_Encode4(2318359), // Rule ID 72710 //
     /* 2318302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2318321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318332 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2318335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318358 */     // GIR_Coverage, 72710,
     /* 2318358 */     GIR_EraseRootFromParent_Done,
     /* 2318359 */   // Label 31794: @2318359
     /* 2318359 */   GIM_Try, /*On fail goto*//*Label 31795*/ GIMT_Encode4(2318421), // Rule ID 72711 //
     /* 2318364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2318383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318394 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2318397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318420 */     // GIR_Coverage, 72711,
     /* 2318420 */     GIR_EraseRootFromParent_Done,
     /* 2318421 */   // Label 31795: @2318421
     /* 2318421 */   GIM_Try, /*On fail goto*//*Label 31796*/ GIMT_Encode4(2318483), // Rule ID 55210 //
     /* 2318426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2318449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318456 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2318459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2318469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318482 */     // GIR_Coverage, 55210,
     /* 2318482 */     GIR_EraseRootFromParent_Done,
     /* 2318483 */   // Label 31796: @2318483
     /* 2318483 */   GIM_Try, /*On fail goto*//*Label 31797*/ GIMT_Encode4(2318545), // Rule ID 55211 //
     /* 2318488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2318511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318518 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2318521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2318531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318544 */     // GIR_Coverage, 55211,
     /* 2318544 */     GIR_EraseRootFromParent_Done,
     /* 2318545 */   // Label 31797: @2318545
     /* 2318545 */   GIM_Try, /*On fail goto*//*Label 31798*/ GIMT_Encode4(2318590), // Rule ID 55206 //
     /* 2318550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318565 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2318568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318589 */     // GIR_Coverage, 55206,
     /* 2318589 */     GIR_EraseRootFromParent_Done,
     /* 2318590 */   // Label 31798: @2318590
     /* 2318590 */   GIM_Try, /*On fail goto*//*Label 31799*/ GIMT_Encode4(2318635), // Rule ID 55207 //
     /* 2318595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318610 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2318613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318634 */     // GIR_Coverage, 55207,
     /* 2318634 */     GIR_EraseRootFromParent_Done,
     /* 2318635 */   // Label 31799: @2318635
     /* 2318635 */   GIM_Reject,
     /* 2318636 */ // Label 31787: @2318636
     /* 2318636 */ GIM_Reject,
     /* 2318637 */ // Label 31583: @2318637
     /* 2318637 */ GIM_Try, /*On fail goto*//*Label 31800*/ GIMT_Encode4(2319426),
     /* 2318642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2318645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2318648 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2318651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318655 */   GIM_Try, /*On fail goto*//*Label 31801*/ GIMT_Encode4(2318732), // Rule ID 55470 //
     /* 2318660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2318663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2318675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2318696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318703 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2318706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318731 */     // GIR_Coverage, 55470,
     /* 2318731 */     GIR_EraseRootFromParent_Done,
     /* 2318732 */   // Label 31801: @2318732
     /* 2318732 */   GIM_Try, /*On fail goto*//*Label 31802*/ GIMT_Encode4(2318809), // Rule ID 55471 //
     /* 2318737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2318740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2318752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2318773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318780 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2318783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318808 */     // GIR_Coverage, 55471,
     /* 2318808 */     GIR_EraseRootFromParent_Done,
     /* 2318809 */   // Label 31802: @2318809
     /* 2318809 */   GIM_Try, /*On fail goto*//*Label 31803*/ GIMT_Encode4(2318886), // Rule ID 72930 //
     /* 2318814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2318817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2318833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2318850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318857 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2318860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318885 */     // GIR_Coverage, 72930,
     /* 2318885 */     GIR_EraseRootFromParent_Done,
     /* 2318886 */   // Label 31803: @2318886
     /* 2318886 */   GIM_Try, /*On fail goto*//*Label 31804*/ GIMT_Encode4(2318963), // Rule ID 72931 //
     /* 2318891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2318894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2318910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2318927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318934 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2318937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318962 */     // GIR_Coverage, 72931,
     /* 2318962 */     GIR_EraseRootFromParent_Done,
     /* 2318963 */   // Label 31804: @2318963
     /* 2318963 */   GIM_Try, /*On fail goto*//*Label 31805*/ GIMT_Encode4(2319025), // Rule ID 55474 //
     /* 2318968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2318971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2318983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318998 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2319001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319024 */     // GIR_Coverage, 55474,
     /* 2319024 */     GIR_EraseRootFromParent_Done,
     /* 2319025 */   // Label 31805: @2319025
     /* 2319025 */   GIM_Try, /*On fail goto*//*Label 31806*/ GIMT_Encode4(2319087), // Rule ID 55475 //
     /* 2319030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319060 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2319063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319086 */     // GIR_Coverage, 55475,
     /* 2319086 */     GIR_EraseRootFromParent_Done,
     /* 2319087 */   // Label 31806: @2319087
     /* 2319087 */   GIM_Try, /*On fail goto*//*Label 31807*/ GIMT_Encode4(2319149), // Rule ID 72934 //
     /* 2319092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2319095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319122 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2319125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319148 */     // GIR_Coverage, 72934,
     /* 2319148 */     GIR_EraseRootFromParent_Done,
     /* 2319149 */   // Label 31807: @2319149
     /* 2319149 */   GIM_Try, /*On fail goto*//*Label 31808*/ GIMT_Encode4(2319211), // Rule ID 72935 //
     /* 2319154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319184 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2319187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319210 */     // GIR_Coverage, 72935,
     /* 2319210 */     GIR_EraseRootFromParent_Done,
     /* 2319211 */   // Label 31808: @2319211
     /* 2319211 */   GIM_Try, /*On fail goto*//*Label 31809*/ GIMT_Encode4(2319273), // Rule ID 55466 //
     /* 2319216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2319219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319246 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2319249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319272 */     // GIR_Coverage, 55466,
     /* 2319272 */     GIR_EraseRootFromParent_Done,
     /* 2319273 */   // Label 31809: @2319273
     /* 2319273 */   GIM_Try, /*On fail goto*//*Label 31810*/ GIMT_Encode4(2319335), // Rule ID 55467 //
     /* 2319278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319308 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2319311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319334 */     // GIR_Coverage, 55467,
     /* 2319334 */     GIR_EraseRootFromParent_Done,
     /* 2319335 */   // Label 31810: @2319335
     /* 2319335 */   GIM_Try, /*On fail goto*//*Label 31811*/ GIMT_Encode4(2319380), // Rule ID 55462 //
     /* 2319340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2319343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319355 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2319358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319379 */     // GIR_Coverage, 55462,
     /* 2319379 */     GIR_EraseRootFromParent_Done,
     /* 2319380 */   // Label 31811: @2319380
     /* 2319380 */   GIM_Try, /*On fail goto*//*Label 31812*/ GIMT_Encode4(2319425), // Rule ID 55463 //
     /* 2319385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319400 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2319403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319424 */     // GIR_Coverage, 55463,
     /* 2319424 */     GIR_EraseRootFromParent_Done,
     /* 2319425 */   // Label 31812: @2319425
     /* 2319425 */   GIM_Reject,
     /* 2319426 */ // Label 31800: @2319426
     /* 2319426 */ GIM_Reject,
     /* 2319427 */ // Label 31584: @2319427
     /* 2319427 */ GIM_Try, /*On fail goto*//*Label 31813*/ GIMT_Encode4(2320216),
     /* 2319432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2319438 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2319441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319445 */   GIM_Try, /*On fail goto*//*Label 31814*/ GIMT_Encode4(2319522), // Rule ID 55726 //
     /* 2319450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2319453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319493 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2319496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319521 */     // GIR_Coverage, 55726,
     /* 2319521 */     GIR_EraseRootFromParent_Done,
     /* 2319522 */   // Label 31814: @2319522
     /* 2319522 */   GIM_Try, /*On fail goto*//*Label 31815*/ GIMT_Encode4(2319599), // Rule ID 55727 //
     /* 2319527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2319530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319570 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2319573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319598 */     // GIR_Coverage, 55727,
     /* 2319598 */     GIR_EraseRootFromParent_Done,
     /* 2319599 */   // Label 31815: @2319599
     /* 2319599 */   GIM_Try, /*On fail goto*//*Label 31816*/ GIMT_Encode4(2319676), // Rule ID 73154 //
     /* 2319604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2319607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319647 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2319650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319675 */     // GIR_Coverage, 73154,
     /* 2319675 */     GIR_EraseRootFromParent_Done,
     /* 2319676 */   // Label 31816: @2319676
     /* 2319676 */   GIM_Try, /*On fail goto*//*Label 31817*/ GIMT_Encode4(2319753), // Rule ID 73155 //
     /* 2319681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2319684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319724 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2319727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319752 */     // GIR_Coverage, 73155,
     /* 2319752 */     GIR_EraseRootFromParent_Done,
     /* 2319753 */   // Label 31817: @2319753
     /* 2319753 */   GIM_Try, /*On fail goto*//*Label 31818*/ GIMT_Encode4(2319815), // Rule ID 55730 //
     /* 2319758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2319761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319788 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2319791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319814 */     // GIR_Coverage, 55730,
     /* 2319814 */     GIR_EraseRootFromParent_Done,
     /* 2319815 */   // Label 31818: @2319815
     /* 2319815 */   GIM_Try, /*On fail goto*//*Label 31819*/ GIMT_Encode4(2319877), // Rule ID 55731 //
     /* 2319820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2319823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319850 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2319853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319876 */     // GIR_Coverage, 55731,
     /* 2319876 */     GIR_EraseRootFromParent_Done,
     /* 2319877 */   // Label 31819: @2319877
     /* 2319877 */   GIM_Try, /*On fail goto*//*Label 31820*/ GIMT_Encode4(2319939), // Rule ID 73158 //
     /* 2319882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2319885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319912 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2319915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319938 */     // GIR_Coverage, 73158,
     /* 2319938 */     GIR_EraseRootFromParent_Done,
     /* 2319939 */   // Label 31820: @2319939
     /* 2319939 */   GIM_Try, /*On fail goto*//*Label 31821*/ GIMT_Encode4(2320001), // Rule ID 73159 //
     /* 2319944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2319947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319974 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2319977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320000 */     // GIR_Coverage, 73159,
     /* 2320000 */     GIR_EraseRootFromParent_Done,
     /* 2320001 */   // Label 31821: @2320001
     /* 2320001 */   GIM_Try, /*On fail goto*//*Label 31822*/ GIMT_Encode4(2320063), // Rule ID 55722 //
     /* 2320006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2320009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2320029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320036 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2320039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2320049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2320058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320062 */     // GIR_Coverage, 55722,
     /* 2320062 */     GIR_EraseRootFromParent_Done,
     /* 2320063 */   // Label 31822: @2320063
     /* 2320063 */   GIM_Try, /*On fail goto*//*Label 31823*/ GIMT_Encode4(2320125), // Rule ID 55723 //
     /* 2320068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2320071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2320091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320098 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2320101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2320111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2320120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320124 */     // GIR_Coverage, 55723,
     /* 2320124 */     GIR_EraseRootFromParent_Done,
     /* 2320125 */   // Label 31823: @2320125
     /* 2320125 */   GIM_Try, /*On fail goto*//*Label 31824*/ GIMT_Encode4(2320170), // Rule ID 55718 //
     /* 2320130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2320133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320145 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2320148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2320165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320169 */     // GIR_Coverage, 55718,
     /* 2320169 */     GIR_EraseRootFromParent_Done,
     /* 2320170 */   // Label 31824: @2320170
     /* 2320170 */   GIM_Try, /*On fail goto*//*Label 31825*/ GIMT_Encode4(2320215), // Rule ID 55719 //
     /* 2320175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2320178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320190 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2320193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2320210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320214 */     // GIR_Coverage, 55719,
     /* 2320214 */     GIR_EraseRootFromParent_Done,
     /* 2320215 */   // Label 31825: @2320215
     /* 2320215 */   GIM_Reject,
     /* 2320216 */ // Label 31813: @2320216
     /* 2320216 */ GIM_Reject,
     /* 2320217 */ // Label 31585: @2320217
     /* 2320217 */ GIM_Try, /*On fail goto*//*Label 31826*/ GIMT_Encode4(2321006),
     /* 2320222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2320228 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2320231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320235 */   GIM_Try, /*On fail goto*//*Label 31827*/ GIMT_Encode4(2320312), // Rule ID 55278 //
     /* 2320240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2320243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320283 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2320286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320311 */     // GIR_Coverage, 55278,
     /* 2320311 */     GIR_EraseRootFromParent_Done,
     /* 2320312 */   // Label 31827: @2320312
     /* 2320312 */   GIM_Try, /*On fail goto*//*Label 31828*/ GIMT_Encode4(2320389), // Rule ID 55279 //
     /* 2320317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2320320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320360 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2320363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320388 */     // GIR_Coverage, 55279,
     /* 2320388 */     GIR_EraseRootFromParent_Done,
     /* 2320389 */   // Label 31828: @2320389
     /* 2320389 */   GIM_Try, /*On fail goto*//*Label 31829*/ GIMT_Encode4(2320466), // Rule ID 72762 //
     /* 2320394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2320397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320437 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2320440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320465 */     // GIR_Coverage, 72762,
     /* 2320465 */     GIR_EraseRootFromParent_Done,
     /* 2320466 */   // Label 31829: @2320466
     /* 2320466 */   GIM_Try, /*On fail goto*//*Label 31830*/ GIMT_Encode4(2320543), // Rule ID 72763 //
     /* 2320471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2320474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320514 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2320517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320542 */     // GIR_Coverage, 72763,
     /* 2320542 */     GIR_EraseRootFromParent_Done,
     /* 2320543 */   // Label 31830: @2320543
     /* 2320543 */   GIM_Try, /*On fail goto*//*Label 31831*/ GIMT_Encode4(2320605), // Rule ID 55282 //
     /* 2320548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2320551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320578 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2320581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320604 */     // GIR_Coverage, 55282,
     /* 2320604 */     GIR_EraseRootFromParent_Done,
     /* 2320605 */   // Label 31831: @2320605
     /* 2320605 */   GIM_Try, /*On fail goto*//*Label 31832*/ GIMT_Encode4(2320667), // Rule ID 55283 //
     /* 2320610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2320613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320640 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2320643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320666 */     // GIR_Coverage, 55283,
     /* 2320666 */     GIR_EraseRootFromParent_Done,
     /* 2320667 */   // Label 31832: @2320667
     /* 2320667 */   GIM_Try, /*On fail goto*//*Label 31833*/ GIMT_Encode4(2320729), // Rule ID 72766 //
     /* 2320672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2320675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320702 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2320705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320728 */     // GIR_Coverage, 72766,
     /* 2320728 */     GIR_EraseRootFromParent_Done,
     /* 2320729 */   // Label 31833: @2320729
     /* 2320729 */   GIM_Try, /*On fail goto*//*Label 31834*/ GIMT_Encode4(2320791), // Rule ID 72767 //
     /* 2320734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2320737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320764 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2320767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320790 */     // GIR_Coverage, 72767,
     /* 2320790 */     GIR_EraseRootFromParent_Done,
     /* 2320791 */   // Label 31834: @2320791
     /* 2320791 */   GIM_Try, /*On fail goto*//*Label 31835*/ GIMT_Encode4(2320853), // Rule ID 55274 //
     /* 2320796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2320799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320826 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2320829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2320839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320852 */     // GIR_Coverage, 55274,
     /* 2320852 */     GIR_EraseRootFromParent_Done,
     /* 2320853 */   // Label 31835: @2320853
     /* 2320853 */   GIM_Try, /*On fail goto*//*Label 31836*/ GIMT_Encode4(2320915), // Rule ID 55275 //
     /* 2320858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2320861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320888 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2320891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2320901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320914 */     // GIR_Coverage, 55275,
     /* 2320914 */     GIR_EraseRootFromParent_Done,
     /* 2320915 */   // Label 31836: @2320915
     /* 2320915 */   GIM_Try, /*On fail goto*//*Label 31837*/ GIMT_Encode4(2320960), // Rule ID 55270 //
     /* 2320920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2320923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320935 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2320938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320959 */     // GIR_Coverage, 55270,
     /* 2320959 */     GIR_EraseRootFromParent_Done,
     /* 2320960 */   // Label 31837: @2320960
     /* 2320960 */   GIM_Try, /*On fail goto*//*Label 31838*/ GIMT_Encode4(2321005), // Rule ID 55271 //
     /* 2320965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2320968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320980 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2320983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321004 */     // GIR_Coverage, 55271,
     /* 2321004 */     GIR_EraseRootFromParent_Done,
     /* 2321005 */   // Label 31838: @2321005
     /* 2321005 */   GIM_Reject,
     /* 2321006 */ // Label 31826: @2321006
     /* 2321006 */ GIM_Reject,
     /* 2321007 */ // Label 31586: @2321007
     /* 2321007 */ GIM_Try, /*On fail goto*//*Label 31839*/ GIMT_Encode4(2321796),
     /* 2321012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2321018 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2321021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321025 */   GIM_Try, /*On fail goto*//*Label 31840*/ GIMT_Encode4(2321102), // Rule ID 55534 //
     /* 2321030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2321033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321073 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2321076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321101 */     // GIR_Coverage, 55534,
     /* 2321101 */     GIR_EraseRootFromParent_Done,
     /* 2321102 */   // Label 31840: @2321102
     /* 2321102 */   GIM_Try, /*On fail goto*//*Label 31841*/ GIMT_Encode4(2321179), // Rule ID 55535 //
     /* 2321107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2321110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321150 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2321153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321178 */     // GIR_Coverage, 55535,
     /* 2321178 */     GIR_EraseRootFromParent_Done,
     /* 2321179 */   // Label 31841: @2321179
     /* 2321179 */   GIM_Try, /*On fail goto*//*Label 31842*/ GIMT_Encode4(2321256), // Rule ID 72986 //
     /* 2321184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2321187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321227 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2321230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321255 */     // GIR_Coverage, 72986,
     /* 2321255 */     GIR_EraseRootFromParent_Done,
     /* 2321256 */   // Label 31842: @2321256
     /* 2321256 */   GIM_Try, /*On fail goto*//*Label 31843*/ GIMT_Encode4(2321333), // Rule ID 72987 //
     /* 2321261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2321264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321304 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2321307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321332 */     // GIR_Coverage, 72987,
     /* 2321332 */     GIR_EraseRootFromParent_Done,
     /* 2321333 */   // Label 31843: @2321333
     /* 2321333 */   GIM_Try, /*On fail goto*//*Label 31844*/ GIMT_Encode4(2321395), // Rule ID 55538 //
     /* 2321338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2321341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321368 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2321371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321394 */     // GIR_Coverage, 55538,
     /* 2321394 */     GIR_EraseRootFromParent_Done,
     /* 2321395 */   // Label 31844: @2321395
     /* 2321395 */   GIM_Try, /*On fail goto*//*Label 31845*/ GIMT_Encode4(2321457), // Rule ID 55539 //
     /* 2321400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2321403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321430 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2321433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321456 */     // GIR_Coverage, 55539,
     /* 2321456 */     GIR_EraseRootFromParent_Done,
     /* 2321457 */   // Label 31845: @2321457
     /* 2321457 */   GIM_Try, /*On fail goto*//*Label 31846*/ GIMT_Encode4(2321519), // Rule ID 72990 //
     /* 2321462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2321465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321492 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2321495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321518 */     // GIR_Coverage, 72990,
     /* 2321518 */     GIR_EraseRootFromParent_Done,
     /* 2321519 */   // Label 31846: @2321519
     /* 2321519 */   GIM_Try, /*On fail goto*//*Label 31847*/ GIMT_Encode4(2321581), // Rule ID 72991 //
     /* 2321524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2321527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321554 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2321557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321580 */     // GIR_Coverage, 72991,
     /* 2321580 */     GIR_EraseRootFromParent_Done,
     /* 2321581 */   // Label 31847: @2321581
     /* 2321581 */   GIM_Try, /*On fail goto*//*Label 31848*/ GIMT_Encode4(2321643), // Rule ID 55530 //
     /* 2321586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2321589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2321601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321616 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2321619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2321629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321642 */     // GIR_Coverage, 55530,
     /* 2321642 */     GIR_EraseRootFromParent_Done,
     /* 2321643 */   // Label 31848: @2321643
     /* 2321643 */   GIM_Try, /*On fail goto*//*Label 31849*/ GIMT_Encode4(2321705), // Rule ID 55531 //
     /* 2321648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2321651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2321663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2321671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321678 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2321681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2321691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321704 */     // GIR_Coverage, 55531,
     /* 2321704 */     GIR_EraseRootFromParent_Done,
     /* 2321705 */   // Label 31849: @2321705
     /* 2321705 */   GIM_Try, /*On fail goto*//*Label 31850*/ GIMT_Encode4(2321750), // Rule ID 55526 //
     /* 2321710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2321713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321725 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2321728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321749 */     // GIR_Coverage, 55526,
     /* 2321749 */     GIR_EraseRootFromParent_Done,
     /* 2321750 */   // Label 31850: @2321750
     /* 2321750 */   GIM_Try, /*On fail goto*//*Label 31851*/ GIMT_Encode4(2321795), // Rule ID 55527 //
     /* 2321755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2321758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321770 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2321773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321794 */     // GIR_Coverage, 55527,
     /* 2321794 */     GIR_EraseRootFromParent_Done,
     /* 2321795 */   // Label 31851: @2321795
     /* 2321795 */   GIM_Reject,
     /* 2321796 */ // Label 31839: @2321796
     /* 2321796 */ GIM_Reject,
     /* 2321797 */ // Label 31587: @2321797
     /* 2321797 */ GIM_Try, /*On fail goto*//*Label 31852*/ GIMT_Encode4(2322586),
     /* 2321802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2321805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2321808 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2321811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321815 */   GIM_Try, /*On fail goto*//*Label 31853*/ GIMT_Encode4(2321892), // Rule ID 55342 //
     /* 2321820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2321835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2321856 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321863 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2321866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321891 */     // GIR_Coverage, 55342,
     /* 2321891 */     GIR_EraseRootFromParent_Done,
     /* 2321892 */   // Label 31853: @2321892
     /* 2321892 */   GIM_Try, /*On fail goto*//*Label 31854*/ GIMT_Encode4(2321969), // Rule ID 55343 //
     /* 2321897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2321912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2321933 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321940 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2321943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321968 */     // GIR_Coverage, 55343,
     /* 2321968 */     GIR_EraseRootFromParent_Done,
     /* 2321969 */   // Label 31854: @2321969
     /* 2321969 */   GIM_Try, /*On fail goto*//*Label 31855*/ GIMT_Encode4(2322046), // Rule ID 72818 //
     /* 2321974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2321993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2321998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2322002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2322010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2322017 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2322020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2322032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322045 */     // GIR_Coverage, 72818,
     /* 2322045 */     GIR_EraseRootFromParent_Done,
     /* 2322046 */   // Label 31855: @2322046
     /* 2322046 */   GIM_Try, /*On fail goto*//*Label 31856*/ GIMT_Encode4(2322123), // Rule ID 72819 //
     /* 2322051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2322062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2322070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2322079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2322087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2322094 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2322097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2322109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322122 */     // GIR_Coverage, 72819,
     /* 2322122 */     GIR_EraseRootFromParent_Done,
     /* 2322123 */   // Label 31856: @2322123
     /* 2322123 */   GIM_Try, /*On fail goto*//*Label 31857*/ GIMT_Encode4(2322185), // Rule ID 55346 //
     /* 2322128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2322135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2322143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322158 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2322161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322184 */     // GIR_Coverage, 55346,
     /* 2322184 */     GIR_EraseRootFromParent_Done,
     /* 2322185 */   // Label 31857: @2322185
     /* 2322185 */   GIM_Try, /*On fail goto*//*Label 31858*/ GIMT_Encode4(2322247), // Rule ID 55347 //
     /* 2322190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2322197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2322205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322220 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2322223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322246 */     // GIR_Coverage, 55347,
     /* 2322246 */     GIR_EraseRootFromParent_Done,
     /* 2322247 */   // Label 31858: @2322247
     /* 2322247 */   GIM_Try, /*On fail goto*//*Label 31859*/ GIMT_Encode4(2322309), // Rule ID 72822 //
     /* 2322252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2322263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2322271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322282 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2322285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322308 */     // GIR_Coverage, 72822,
     /* 2322308 */     GIR_EraseRootFromParent_Done,
     /* 2322309 */   // Label 31859: @2322309
     /* 2322309 */   GIM_Try, /*On fail goto*//*Label 31860*/ GIMT_Encode4(2322371), // Rule ID 72823 //
     /* 2322314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2322325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2322333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322344 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2322347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322370 */     // GIR_Coverage, 72823,
     /* 2322370 */     GIR_EraseRootFromParent_Done,
     /* 2322371 */   // Label 31860: @2322371
     /* 2322371 */   GIM_Try, /*On fail goto*//*Label 31861*/ GIMT_Encode4(2322433), // Rule ID 55338 //
     /* 2322376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2322399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322406 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2322409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2322419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322432 */     // GIR_Coverage, 55338,
     /* 2322432 */     GIR_EraseRootFromParent_Done,
     /* 2322433 */   // Label 31861: @2322433
     /* 2322433 */   GIM_Try, /*On fail goto*//*Label 31862*/ GIMT_Encode4(2322495), // Rule ID 55339 //
     /* 2322438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2322461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322468 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2322471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2322481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322494 */     // GIR_Coverage, 55339,
     /* 2322494 */     GIR_EraseRootFromParent_Done,
     /* 2322495 */   // Label 31862: @2322495
     /* 2322495 */   GIM_Try, /*On fail goto*//*Label 31863*/ GIMT_Encode4(2322540), // Rule ID 55334 //
     /* 2322500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322515 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2322518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322539 */     // GIR_Coverage, 55334,
     /* 2322539 */     GIR_EraseRootFromParent_Done,
     /* 2322540 */   // Label 31863: @2322540
     /* 2322540 */   GIM_Try, /*On fail goto*//*Label 31864*/ GIMT_Encode4(2322585), // Rule ID 55335 //
     /* 2322545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322560 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2322563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322584 */     // GIR_Coverage, 55335,
     /* 2322584 */     GIR_EraseRootFromParent_Done,
     /* 2322585 */   // Label 31864: @2322585
     /* 2322585 */   GIM_Reject,
     /* 2322586 */ // Label 31852: @2322586
     /* 2322586 */ GIM_Reject,
     /* 2322587 */ // Label 31588: @2322587
     /* 2322587 */ GIM_Reject,
     /* 2322588 */ // Label 63: @2322588
     /* 2322588 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31883*/ GIMT_Encode4(2325015),
     /* 2322599 */ /*GILLT_s16*//*Label 31865*/ GIMT_Encode4(2322719),
     /* 2322603 */ /*GILLT_s32*//*Label 31866*/ GIMT_Encode4(2322868),
     /* 2322607 */ /*GILLT_s64*//*Label 31867*/ GIMT_Encode4(2323017), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322619 */ /*GILLT_nxv1s16*//*Label 31868*/ GIMT_Encode4(2323200),
     /* 2322623 */ /*GILLT_nxv1s32*//*Label 31869*/ GIMT_Encode4(2323321),
     /* 2322627 */ /*GILLT_nxv1s64*//*Label 31870*/ GIMT_Encode4(2323442), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322639 */ /*GILLT_nxv2s16*//*Label 31871*/ GIMT_Encode4(2323563),
     /* 2322643 */ /*GILLT_nxv2s32*//*Label 31872*/ GIMT_Encode4(2323684),
     /* 2322647 */ /*GILLT_nxv2s64*//*Label 31873*/ GIMT_Encode4(2323805), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322659 */ /*GILLT_nxv4s16*//*Label 31874*/ GIMT_Encode4(2323926),
     /* 2322663 */ /*GILLT_nxv4s32*//*Label 31875*/ GIMT_Encode4(2324047),
     /* 2322667 */ /*GILLT_nxv4s64*//*Label 31876*/ GIMT_Encode4(2324168), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322679 */ /*GILLT_nxv8s16*//*Label 31877*/ GIMT_Encode4(2324289),
     /* 2322683 */ /*GILLT_nxv8s32*//*Label 31878*/ GIMT_Encode4(2324410),
     /* 2322687 */ /*GILLT_nxv8s64*//*Label 31879*/ GIMT_Encode4(2324531), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322699 */ /*GILLT_nxv16s16*//*Label 31880*/ GIMT_Encode4(2324652),
     /* 2322703 */ /*GILLT_nxv16s32*//*Label 31881*/ GIMT_Encode4(2324773), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322715 */ /*GILLT_nxv32s16*//*Label 31882*/ GIMT_Encode4(2324894),
     /* 2322719 */ // Label 31865: @2322719
     /* 2322719 */ GIM_Try, /*On fail goto*//*Label 31884*/ GIMT_Encode4(2322867),
     /* 2322724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2322727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2322730 */   GIM_Try, /*On fail goto*//*Label 31885*/ GIMT_Encode4(2322764), // Rule ID 1972 //
     /* 2322735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2322738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2322742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2322746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2322750 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2322750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2322753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322763 */     // GIR_Coverage, 1972,
     /* 2322763 */     GIR_EraseRootFromParent_Done,
     /* 2322764 */   // Label 31885: @2322764
     /* 2322764 */   GIM_Try, /*On fail goto*//*Label 31886*/ GIMT_Encode4(2322798), // Rule ID 1973 //
     /* 2322769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2322772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2322776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2322780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2322784 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2322784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2322787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322797 */     // GIR_Coverage, 1973,
     /* 2322797 */     GIR_EraseRootFromParent_Done,
     /* 2322798 */   // Label 31886: @2322798
     /* 2322798 */   GIM_Try, /*On fail goto*//*Label 31887*/ GIMT_Encode4(2322832), // Rule ID 1976 //
     /* 2322803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2322806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2322810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2322814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2322818 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2322818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2322821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322831 */     // GIR_Coverage, 1976,
     /* 2322831 */     GIR_EraseRootFromParent_Done,
     /* 2322832 */   // Label 31887: @2322832
     /* 2322832 */   GIM_Try, /*On fail goto*//*Label 31888*/ GIMT_Encode4(2322866), // Rule ID 1977 //
     /* 2322837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2322840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2322844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2322848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2322852 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2322852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2322855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322865 */     // GIR_Coverage, 1977,
     /* 2322865 */     GIR_EraseRootFromParent_Done,
     /* 2322866 */   // Label 31888: @2322866
     /* 2322866 */   GIM_Reject,
     /* 2322867 */ // Label 31884: @2322867
     /* 2322867 */ GIM_Reject,
     /* 2322868 */ // Label 31866: @2322868
     /* 2322868 */ GIM_Try, /*On fail goto*//*Label 31889*/ GIMT_Encode4(2323016),
     /* 2322873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2322876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2322879 */   GIM_Try, /*On fail goto*//*Label 31890*/ GIMT_Encode4(2322913), // Rule ID 1263 //
     /* 2322884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2322887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2322891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2322895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2322899 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2322899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2322902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322912 */     // GIR_Coverage, 1263,
     /* 2322912 */     GIR_EraseRootFromParent_Done,
     /* 2322913 */   // Label 31890: @2322913
     /* 2322913 */   GIM_Try, /*On fail goto*//*Label 31891*/ GIMT_Encode4(2322947), // Rule ID 1264 //
     /* 2322918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2322921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2322925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2322929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2322933 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2322933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2322936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322946 */     // GIR_Coverage, 1264,
     /* 2322946 */     GIR_EraseRootFromParent_Done,
     /* 2322947 */   // Label 31891: @2322947
     /* 2322947 */   GIM_Try, /*On fail goto*//*Label 31892*/ GIMT_Encode4(2322981), // Rule ID 1267 //
     /* 2322952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2322955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2322959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2322963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2322967 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2322967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2322970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322980 */     // GIR_Coverage, 1267,
     /* 2322980 */     GIR_EraseRootFromParent_Done,
     /* 2322981 */   // Label 31892: @2322981
     /* 2322981 */   GIM_Try, /*On fail goto*//*Label 31893*/ GIMT_Encode4(2323015), // Rule ID 1268 //
     /* 2322986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2322989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2322993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2322997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2323001 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2323001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2323004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323014 */     // GIR_Coverage, 1268,
     /* 2323014 */     GIR_EraseRootFromParent_Done,
     /* 2323015 */   // Label 31893: @2323015
     /* 2323015 */   GIM_Reject,
     /* 2323016 */ // Label 31889: @2323016
     /* 2323016 */ GIM_Reject,
     /* 2323017 */ // Label 31867: @2323017
     /* 2323017 */ GIM_Try, /*On fail goto*//*Label 31894*/ GIMT_Encode4(2323199),
     /* 2323022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2323025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2323028 */   GIM_Try, /*On fail goto*//*Label 31895*/ GIMT_Encode4(2323062), // Rule ID 1604 //
     /* 2323033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2323036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2323040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2323044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2323048 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2323048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2323051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323061 */     // GIR_Coverage, 1604,
     /* 2323061 */     GIR_EraseRootFromParent_Done,
     /* 2323062 */   // Label 31895: @2323062
     /* 2323062 */   GIM_Try, /*On fail goto*//*Label 31896*/ GIMT_Encode4(2323096), // Rule ID 1605 //
     /* 2323067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2323070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2323074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2323078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2323082 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2323082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2323085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323095 */     // GIR_Coverage, 1605,
     /* 2323095 */     GIR_EraseRootFromParent_Done,
     /* 2323096 */   // Label 31896: @2323096
     /* 2323096 */   GIM_Try, /*On fail goto*//*Label 31897*/ GIMT_Encode4(2323130), // Rule ID 1608 //
     /* 2323101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2323104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2323108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2323112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2323116 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2323116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2323119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323129 */     // GIR_Coverage, 1608,
     /* 2323129 */     GIR_EraseRootFromParent_Done,
     /* 2323130 */   // Label 31897: @2323130
     /* 2323130 */   GIM_Try, /*On fail goto*//*Label 31898*/ GIMT_Encode4(2323164), // Rule ID 1609 //
     /* 2323135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2323138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2323142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2323146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2323150 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2323150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2323153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323163 */     // GIR_Coverage, 1609,
     /* 2323163 */     GIR_EraseRootFromParent_Done,
     /* 2323164 */   // Label 31898: @2323164
     /* 2323164 */   GIM_Try, /*On fail goto*//*Label 31899*/ GIMT_Encode4(2323198), // Rule ID 1611 //
     /* 2323169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2323172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2323176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2323180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2323184 */     // (fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2323184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2323187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323197 */     // GIR_Coverage, 1611,
     /* 2323197 */     GIR_EraseRootFromParent_Done,
     /* 2323198 */   // Label 31899: @2323198
     /* 2323198 */   GIM_Reject,
     /* 2323199 */ // Label 31894: @2323199
     /* 2323199 */ GIM_Reject,
     /* 2323200 */ // Label 31868: @2323200
     /* 2323200 */ GIM_Try, /*On fail goto*//*Label 31900*/ GIMT_Encode4(2323320),
     /* 2323205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2323208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2323211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323223 */   GIM_Try, /*On fail goto*//*Label 31901*/ GIMT_Encode4(2323271), // Rule ID 54396 //
     /* 2323228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2323231 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2323234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2323248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323270 */     // GIR_Coverage, 54396,
     /* 2323270 */     GIR_EraseRootFromParent_Done,
     /* 2323271 */   // Label 31901: @2323271
     /* 2323271 */   GIM_Try, /*On fail goto*//*Label 31902*/ GIMT_Encode4(2323319), // Rule ID 54397 //
     /* 2323276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2323279 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2323282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2323296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323318 */     // GIR_Coverage, 54397,
     /* 2323318 */     GIR_EraseRootFromParent_Done,
     /* 2323319 */   // Label 31902: @2323319
     /* 2323319 */   GIM_Reject,
     /* 2323320 */ // Label 31900: @2323320
     /* 2323320 */ GIM_Reject,
     /* 2323321 */ // Label 31869: @2323321
     /* 2323321 */ GIM_Try, /*On fail goto*//*Label 31903*/ GIMT_Encode4(2323441),
     /* 2323326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2323329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2323332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323344 */   GIM_Try, /*On fail goto*//*Label 31904*/ GIMT_Encode4(2323392), // Rule ID 54420 //
     /* 2323349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2323352 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2323355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2323369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323391 */     // GIR_Coverage, 54420,
     /* 2323391 */     GIR_EraseRootFromParent_Done,
     /* 2323392 */   // Label 31904: @2323392
     /* 2323392 */   GIM_Try, /*On fail goto*//*Label 31905*/ GIMT_Encode4(2323440), // Rule ID 54421 //
     /* 2323397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2323400 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2323403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2323417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323439 */     // GIR_Coverage, 54421,
     /* 2323439 */     GIR_EraseRootFromParent_Done,
     /* 2323440 */   // Label 31905: @2323440
     /* 2323440 */   GIM_Reject,
     /* 2323441 */ // Label 31903: @2323441
     /* 2323441 */ GIM_Reject,
     /* 2323442 */ // Label 31870: @2323442
     /* 2323442 */ GIM_Try, /*On fail goto*//*Label 31906*/ GIMT_Encode4(2323562),
     /* 2323447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2323450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2323453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323465 */   GIM_Try, /*On fail goto*//*Label 31907*/ GIMT_Encode4(2323513), // Rule ID 54456 //
     /* 2323470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323473 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2323476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2323490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323512 */     // GIR_Coverage, 54456,
     /* 2323512 */     GIR_EraseRootFromParent_Done,
     /* 2323513 */   // Label 31907: @2323513
     /* 2323513 */   GIM_Try, /*On fail goto*//*Label 31908*/ GIMT_Encode4(2323561), // Rule ID 54457 //
     /* 2323518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323521 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2323524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2323538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323560 */     // GIR_Coverage, 54457,
     /* 2323560 */     GIR_EraseRootFromParent_Done,
     /* 2323561 */   // Label 31908: @2323561
     /* 2323561 */   GIM_Reject,
     /* 2323562 */ // Label 31906: @2323562
     /* 2323562 */ GIM_Reject,
     /* 2323563 */ // Label 31871: @2323563
     /* 2323563 */ GIM_Try, /*On fail goto*//*Label 31909*/ GIMT_Encode4(2323683),
     /* 2323568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2323571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2323574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323586 */   GIM_Try, /*On fail goto*//*Label 31910*/ GIMT_Encode4(2323634), // Rule ID 54408 //
     /* 2323591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2323594 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2323597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2323611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323633 */     // GIR_Coverage, 54408,
     /* 2323633 */     GIR_EraseRootFromParent_Done,
     /* 2323634 */   // Label 31910: @2323634
     /* 2323634 */   GIM_Try, /*On fail goto*//*Label 31911*/ GIMT_Encode4(2323682), // Rule ID 54409 //
     /* 2323639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2323642 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2323645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2323659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323681 */     // GIR_Coverage, 54409,
     /* 2323681 */     GIR_EraseRootFromParent_Done,
     /* 2323682 */   // Label 31911: @2323682
     /* 2323682 */   GIM_Reject,
     /* 2323683 */ // Label 31909: @2323683
     /* 2323683 */ GIM_Reject,
     /* 2323684 */ // Label 31872: @2323684
     /* 2323684 */ GIM_Try, /*On fail goto*//*Label 31912*/ GIMT_Encode4(2323804),
     /* 2323689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2323692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2323695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323707 */   GIM_Try, /*On fail goto*//*Label 31913*/ GIMT_Encode4(2323755), // Rule ID 54444 //
     /* 2323712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2323715 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2323718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2323732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323754 */     // GIR_Coverage, 54444,
     /* 2323754 */     GIR_EraseRootFromParent_Done,
     /* 2323755 */   // Label 31913: @2323755
     /* 2323755 */   GIM_Try, /*On fail goto*//*Label 31914*/ GIMT_Encode4(2323803), // Rule ID 54445 //
     /* 2323760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2323763 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2323766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2323780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323802 */     // GIR_Coverage, 54445,
     /* 2323802 */     GIR_EraseRootFromParent_Done,
     /* 2323803 */   // Label 31914: @2323803
     /* 2323803 */   GIM_Reject,
     /* 2323804 */ // Label 31912: @2323804
     /* 2323804 */ GIM_Reject,
     /* 2323805 */ // Label 31873: @2323805
     /* 2323805 */ GIM_Try, /*On fail goto*//*Label 31915*/ GIMT_Encode4(2323925),
     /* 2323810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2323813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2323816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323828 */   GIM_Try, /*On fail goto*//*Label 31916*/ GIMT_Encode4(2323876), // Rule ID 54540 //
     /* 2323833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323836 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2323839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2323853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323875 */     // GIR_Coverage, 54540,
     /* 2323875 */     GIR_EraseRootFromParent_Done,
     /* 2323876 */   // Label 31916: @2323876
     /* 2323876 */   GIM_Try, /*On fail goto*//*Label 31917*/ GIMT_Encode4(2323924), // Rule ID 54541 //
     /* 2323881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323884 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2323887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2323901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323923 */     // GIR_Coverage, 54541,
     /* 2323923 */     GIR_EraseRootFromParent_Done,
     /* 2323924 */   // Label 31917: @2323924
     /* 2323924 */   GIM_Reject,
     /* 2323925 */ // Label 31915: @2323925
     /* 2323925 */ GIM_Reject,
     /* 2323926 */ // Label 31874: @2323926
     /* 2323926 */ GIM_Try, /*On fail goto*//*Label 31918*/ GIMT_Encode4(2324046),
     /* 2323931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2323934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2323937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323949 */   GIM_Try, /*On fail goto*//*Label 31919*/ GIMT_Encode4(2323997), // Rule ID 54432 //
     /* 2323954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2323957 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2323960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2323974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2323983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323996 */     // GIR_Coverage, 54432,
     /* 2323996 */     GIR_EraseRootFromParent_Done,
     /* 2323997 */   // Label 31919: @2323997
     /* 2323997 */   GIM_Try, /*On fail goto*//*Label 31920*/ GIMT_Encode4(2324045), // Rule ID 54433 //
     /* 2324002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324005 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2324008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2324022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324044 */     // GIR_Coverage, 54433,
     /* 2324044 */     GIR_EraseRootFromParent_Done,
     /* 2324045 */   // Label 31920: @2324045
     /* 2324045 */   GIM_Reject,
     /* 2324046 */ // Label 31918: @2324046
     /* 2324046 */ GIM_Reject,
     /* 2324047 */ // Label 31875: @2324047
     /* 2324047 */ GIM_Try, /*On fail goto*//*Label 31921*/ GIMT_Encode4(2324167),
     /* 2324052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2324055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2324058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324070 */   GIM_Try, /*On fail goto*//*Label 31922*/ GIMT_Encode4(2324118), // Rule ID 54504 //
     /* 2324075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2324078 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2324081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2324095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324117 */     // GIR_Coverage, 54504,
     /* 2324117 */     GIR_EraseRootFromParent_Done,
     /* 2324118 */   // Label 31922: @2324118
     /* 2324118 */   GIM_Try, /*On fail goto*//*Label 31923*/ GIMT_Encode4(2324166), // Rule ID 54505 //
     /* 2324123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2324126 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2324129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2324143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324165 */     // GIR_Coverage, 54505,
     /* 2324165 */     GIR_EraseRootFromParent_Done,
     /* 2324166 */   // Label 31923: @2324166
     /* 2324166 */   GIM_Reject,
     /* 2324167 */ // Label 31921: @2324167
     /* 2324167 */ GIM_Reject,
     /* 2324168 */ // Label 31876: @2324168
     /* 2324168 */ GIM_Try, /*On fail goto*//*Label 31924*/ GIMT_Encode4(2324288),
     /* 2324173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2324176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2324179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324191 */   GIM_Try, /*On fail goto*//*Label 31925*/ GIMT_Encode4(2324239), // Rule ID 54552 //
     /* 2324196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2324199 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2324202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2324216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324238 */     // GIR_Coverage, 54552,
     /* 2324238 */     GIR_EraseRootFromParent_Done,
     /* 2324239 */   // Label 31925: @2324239
     /* 2324239 */   GIM_Try, /*On fail goto*//*Label 31926*/ GIMT_Encode4(2324287), // Rule ID 54553 //
     /* 2324244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2324247 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2324250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2324264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324286 */     // GIR_Coverage, 54553,
     /* 2324286 */     GIR_EraseRootFromParent_Done,
     /* 2324287 */   // Label 31926: @2324287
     /* 2324287 */   GIM_Reject,
     /* 2324288 */ // Label 31924: @2324288
     /* 2324288 */ GIM_Reject,
     /* 2324289 */ // Label 31877: @2324289
     /* 2324289 */ GIM_Try, /*On fail goto*//*Label 31927*/ GIMT_Encode4(2324409),
     /* 2324294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2324297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2324300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324312 */   GIM_Try, /*On fail goto*//*Label 31928*/ GIMT_Encode4(2324360), // Rule ID 54468 //
     /* 2324317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324320 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2324323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2324337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324359 */     // GIR_Coverage, 54468,
     /* 2324359 */     GIR_EraseRootFromParent_Done,
     /* 2324360 */   // Label 31928: @2324360
     /* 2324360 */   GIM_Try, /*On fail goto*//*Label 31929*/ GIMT_Encode4(2324408), // Rule ID 54469 //
     /* 2324365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324368 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2324371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2324385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324407 */     // GIR_Coverage, 54469,
     /* 2324407 */     GIR_EraseRootFromParent_Done,
     /* 2324408 */   // Label 31929: @2324408
     /* 2324408 */   GIM_Reject,
     /* 2324409 */ // Label 31927: @2324409
     /* 2324409 */ GIM_Reject,
     /* 2324410 */ // Label 31878: @2324410
     /* 2324410 */ GIM_Try, /*On fail goto*//*Label 31930*/ GIMT_Encode4(2324530),
     /* 2324415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2324418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2324421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324433 */   GIM_Try, /*On fail goto*//*Label 31931*/ GIMT_Encode4(2324481), // Rule ID 54516 //
     /* 2324438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2324441 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2324444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2324458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324480 */     // GIR_Coverage, 54516,
     /* 2324480 */     GIR_EraseRootFromParent_Done,
     /* 2324481 */   // Label 31931: @2324481
     /* 2324481 */   GIM_Try, /*On fail goto*//*Label 31932*/ GIMT_Encode4(2324529), // Rule ID 54517 //
     /* 2324486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2324489 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2324492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2324506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324528 */     // GIR_Coverage, 54517,
     /* 2324528 */     GIR_EraseRootFromParent_Done,
     /* 2324529 */   // Label 31932: @2324529
     /* 2324529 */   GIM_Reject,
     /* 2324530 */ // Label 31930: @2324530
     /* 2324530 */ GIM_Reject,
     /* 2324531 */ // Label 31879: @2324531
     /* 2324531 */ GIM_Try, /*On fail goto*//*Label 31933*/ GIMT_Encode4(2324651),
     /* 2324536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2324539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2324542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324554 */   GIM_Try, /*On fail goto*//*Label 31934*/ GIMT_Encode4(2324602), // Rule ID 54564 //
     /* 2324559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2324562 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2324565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2324579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324601 */     // GIR_Coverage, 54564,
     /* 2324601 */     GIR_EraseRootFromParent_Done,
     /* 2324602 */   // Label 31934: @2324602
     /* 2324602 */   GIM_Try, /*On fail goto*//*Label 31935*/ GIMT_Encode4(2324650), // Rule ID 54565 //
     /* 2324607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2324610 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2324613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2324627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324649 */     // GIR_Coverage, 54565,
     /* 2324649 */     GIR_EraseRootFromParent_Done,
     /* 2324650 */   // Label 31935: @2324650
     /* 2324650 */   GIM_Reject,
     /* 2324651 */ // Label 31933: @2324651
     /* 2324651 */ GIM_Reject,
     /* 2324652 */ // Label 31880: @2324652
     /* 2324652 */ GIM_Try, /*On fail goto*//*Label 31936*/ GIMT_Encode4(2324772),
     /* 2324657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2324663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324675 */   GIM_Try, /*On fail goto*//*Label 31937*/ GIMT_Encode4(2324723), // Rule ID 54480 //
     /* 2324680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324683 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2324686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2324700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324722 */     // GIR_Coverage, 54480,
     /* 2324722 */     GIR_EraseRootFromParent_Done,
     /* 2324723 */   // Label 31937: @2324723
     /* 2324723 */   GIM_Try, /*On fail goto*//*Label 31938*/ GIMT_Encode4(2324771), // Rule ID 54481 //
     /* 2324728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324731 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2324734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2324748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324770 */     // GIR_Coverage, 54481,
     /* 2324770 */     GIR_EraseRootFromParent_Done,
     /* 2324771 */   // Label 31938: @2324771
     /* 2324771 */   GIM_Reject,
     /* 2324772 */ // Label 31936: @2324772
     /* 2324772 */ GIM_Reject,
     /* 2324773 */ // Label 31881: @2324773
     /* 2324773 */ GIM_Try, /*On fail goto*//*Label 31939*/ GIMT_Encode4(2324893),
     /* 2324778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2324784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324796 */   GIM_Try, /*On fail goto*//*Label 31940*/ GIMT_Encode4(2324844), // Rule ID 54528 //
     /* 2324801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2324804 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2324807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2324821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324843 */     // GIR_Coverage, 54528,
     /* 2324843 */     GIR_EraseRootFromParent_Done,
     /* 2324844 */   // Label 31940: @2324844
     /* 2324844 */   GIM_Try, /*On fail goto*//*Label 31941*/ GIMT_Encode4(2324892), // Rule ID 54529 //
     /* 2324849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2324852 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2324855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2324869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324891 */     // GIR_Coverage, 54529,
     /* 2324891 */     GIR_EraseRootFromParent_Done,
     /* 2324892 */   // Label 31941: @2324892
     /* 2324892 */   GIM_Reject,
     /* 2324893 */ // Label 31939: @2324893
     /* 2324893 */ GIM_Reject,
     /* 2324894 */ // Label 31882: @2324894
     /* 2324894 */ GIM_Try, /*On fail goto*//*Label 31942*/ GIMT_Encode4(2325014),
     /* 2324899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2324902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2324905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324917 */   GIM_Try, /*On fail goto*//*Label 31943*/ GIMT_Encode4(2324965), // Rule ID 54492 //
     /* 2324922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324925 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2324928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2324942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324964 */     // GIR_Coverage, 54492,
     /* 2324964 */     GIR_EraseRootFromParent_Done,
     /* 2324965 */   // Label 31943: @2324965
     /* 2324965 */   GIM_Try, /*On fail goto*//*Label 31944*/ GIMT_Encode4(2325013), // Rule ID 54493 //
     /* 2324970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324973 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2324976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2324990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2324999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325012 */     // GIR_Coverage, 54493,
     /* 2325012 */     GIR_EraseRootFromParent_Done,
     /* 2325013 */   // Label 31944: @2325013
     /* 2325013 */   GIM_Reject,
     /* 2325014 */ // Label 31942: @2325014
     /* 2325014 */ GIM_Reject,
     /* 2325015 */ // Label 31883: @2325015
     /* 2325015 */ GIM_Reject,
     /* 2325016 */ // Label 64: @2325016
     /* 2325016 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31963*/ GIMT_Encode4(2326986),
     /* 2325027 */ /*GILLT_s16*//*Label 31945*/ GIMT_Encode4(2325147),
     /* 2325031 */ /*GILLT_s32*//*Label 31946*/ GIMT_Encode4(2325211),
     /* 2325035 */ /*GILLT_s64*//*Label 31947*/ GIMT_Encode4(2325275), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325047 */ /*GILLT_nxv1s16*//*Label 31948*/ GIMT_Encode4(2325366),
     /* 2325051 */ /*GILLT_nxv1s32*//*Label 31949*/ GIMT_Encode4(2325474),
     /* 2325055 */ /*GILLT_nxv1s64*//*Label 31950*/ GIMT_Encode4(2325582), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325067 */ /*GILLT_nxv2s16*//*Label 31951*/ GIMT_Encode4(2325690),
     /* 2325071 */ /*GILLT_nxv2s32*//*Label 31952*/ GIMT_Encode4(2325798),
     /* 2325075 */ /*GILLT_nxv2s64*//*Label 31953*/ GIMT_Encode4(2325906), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325087 */ /*GILLT_nxv4s16*//*Label 31954*/ GIMT_Encode4(2326014),
     /* 2325091 */ /*GILLT_nxv4s32*//*Label 31955*/ GIMT_Encode4(2326122),
     /* 2325095 */ /*GILLT_nxv4s64*//*Label 31956*/ GIMT_Encode4(2326230), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325107 */ /*GILLT_nxv8s16*//*Label 31957*/ GIMT_Encode4(2326338),
     /* 2325111 */ /*GILLT_nxv8s32*//*Label 31958*/ GIMT_Encode4(2326446),
     /* 2325115 */ /*GILLT_nxv8s64*//*Label 31959*/ GIMT_Encode4(2326554), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325127 */ /*GILLT_nxv16s16*//*Label 31960*/ GIMT_Encode4(2326662),
     /* 2325131 */ /*GILLT_nxv16s32*//*Label 31961*/ GIMT_Encode4(2326770), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325143 */ /*GILLT_nxv32s16*//*Label 31962*/ GIMT_Encode4(2326878),
     /* 2325147 */ // Label 31945: @2325147
     /* 2325147 */ GIM_Try, /*On fail goto*//*Label 31964*/ GIMT_Encode4(2325210),
     /* 2325152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2325155 */   GIM_Try, /*On fail goto*//*Label 31965*/ GIMT_Encode4(2325182), // Rule ID 1982 //
     /* 2325160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2325163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325171 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2325171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2325174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325181 */     // GIR_Coverage, 1982,
     /* 2325181 */     GIR_EraseRootFromParent_Done,
     /* 2325182 */   // Label 31965: @2325182
     /* 2325182 */   GIM_Try, /*On fail goto*//*Label 31966*/ GIMT_Encode4(2325209), // Rule ID 2015 //
     /* 2325187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2325190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325198 */     // (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2325198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2325201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325208 */     // GIR_Coverage, 2015,
     /* 2325208 */     GIR_EraseRootFromParent_Done,
     /* 2325209 */   // Label 31966: @2325209
     /* 2325209 */   GIM_Reject,
     /* 2325210 */ // Label 31964: @2325210
     /* 2325210 */ GIM_Reject,
     /* 2325211 */ // Label 31946: @2325211
     /* 2325211 */ GIM_Try, /*On fail goto*//*Label 31967*/ GIMT_Encode4(2325274),
     /* 2325216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325219 */   GIM_Try, /*On fail goto*//*Label 31968*/ GIMT_Encode4(2325246), // Rule ID 1273 //
     /* 2325224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2325227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325235 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2325235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2325238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325245 */     // GIR_Coverage, 1273,
     /* 2325245 */     GIR_EraseRootFromParent_Done,
     /* 2325246 */   // Label 31968: @2325246
     /* 2325246 */   GIM_Try, /*On fail goto*//*Label 31969*/ GIMT_Encode4(2325273), // Rule ID 1281 //
     /* 2325251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2325254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325262 */     // (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2325262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2325265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325272 */     // GIR_Coverage, 1281,
     /* 2325272 */     GIR_EraseRootFromParent_Done,
     /* 2325273 */   // Label 31969: @2325273
     /* 2325273 */   GIM_Reject,
     /* 2325274 */ // Label 31967: @2325274
     /* 2325274 */ GIM_Reject,
     /* 2325275 */ // Label 31947: @2325275
     /* 2325275 */ GIM_Try, /*On fail goto*//*Label 31970*/ GIMT_Encode4(2325365),
     /* 2325280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325283 */   GIM_Try, /*On fail goto*//*Label 31971*/ GIMT_Encode4(2325310), // Rule ID 1616 //
     /* 2325288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2325291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325299 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2325299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2325302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325309 */     // GIR_Coverage, 1616,
     /* 2325309 */     GIR_EraseRootFromParent_Done,
     /* 2325310 */   // Label 31971: @2325310
     /* 2325310 */   GIM_Try, /*On fail goto*//*Label 31972*/ GIMT_Encode4(2325337), // Rule ID 1649 //
     /* 2325315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2325318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325326 */     // (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2325326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2325329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325336 */     // GIR_Coverage, 1649,
     /* 2325336 */     GIR_EraseRootFromParent_Done,
     /* 2325337 */   // Label 31972: @2325337
     /* 2325337 */   GIM_Try, /*On fail goto*//*Label 31973*/ GIMT_Encode4(2325364), // Rule ID 1671 //
     /* 2325342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2325345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325353 */     // (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2325353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2325356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325363 */     // GIR_Coverage, 1671,
     /* 2325363 */     GIR_EraseRootFromParent_Done,
     /* 2325364 */   // Label 31973: @2325364
     /* 2325364 */   GIM_Reject,
     /* 2325365 */ // Label 31970: @2325365
     /* 2325365 */ GIM_Reject,
     /* 2325366 */ // Label 31948: @2325366
     /* 2325366 */ GIM_Try, /*On fail goto*//*Label 31974*/ GIMT_Encode4(2325473),
     /* 2325371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2325374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325382 */   GIM_Try, /*On fail goto*//*Label 31975*/ GIMT_Encode4(2325427), // Rule ID 56234 //
     /* 2325387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2325390 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2325393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2325407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325426 */     // GIR_Coverage, 56234,
     /* 2325426 */     GIR_EraseRootFromParent_Done,
     /* 2325427 */   // Label 31975: @2325427
     /* 2325427 */   GIM_Try, /*On fail goto*//*Label 31976*/ GIMT_Encode4(2325472), // Rule ID 56235 //
     /* 2325432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2325435 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2325438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2325452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325471 */     // GIR_Coverage, 56235,
     /* 2325471 */     GIR_EraseRootFromParent_Done,
     /* 2325472 */   // Label 31976: @2325472
     /* 2325472 */   GIM_Reject,
     /* 2325473 */ // Label 31974: @2325473
     /* 2325473 */ GIM_Reject,
     /* 2325474 */ // Label 31949: @2325474
     /* 2325474 */ GIM_Try, /*On fail goto*//*Label 31977*/ GIMT_Encode4(2325581),
     /* 2325479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2325482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325490 */   GIM_Try, /*On fail goto*//*Label 31978*/ GIMT_Encode4(2325535), // Rule ID 56274 //
     /* 2325495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2325498 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2325501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2325515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325534 */     // GIR_Coverage, 56274,
     /* 2325534 */     GIR_EraseRootFromParent_Done,
     /* 2325535 */   // Label 31978: @2325535
     /* 2325535 */   GIM_Try, /*On fail goto*//*Label 31979*/ GIMT_Encode4(2325580), // Rule ID 56275 //
     /* 2325540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2325543 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2325546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2325560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325579 */     // GIR_Coverage, 56275,
     /* 2325579 */     GIR_EraseRootFromParent_Done,
     /* 2325580 */   // Label 31979: @2325580
     /* 2325580 */   GIM_Reject,
     /* 2325581 */ // Label 31977: @2325581
     /* 2325581 */ GIM_Reject,
     /* 2325582 */ // Label 31950: @2325582
     /* 2325582 */ GIM_Try, /*On fail goto*//*Label 31980*/ GIMT_Encode4(2325689),
     /* 2325587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2325590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325598 */   GIM_Try, /*On fail goto*//*Label 31981*/ GIMT_Encode4(2325643), // Rule ID 56334 //
     /* 2325603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2325606 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2325609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2325623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2325638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325642 */     // GIR_Coverage, 56334,
     /* 2325642 */     GIR_EraseRootFromParent_Done,
     /* 2325643 */   // Label 31981: @2325643
     /* 2325643 */   GIM_Try, /*On fail goto*//*Label 31982*/ GIMT_Encode4(2325688), // Rule ID 56335 //
     /* 2325648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2325651 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2325654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2325668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2325683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325687 */     // GIR_Coverage, 56335,
     /* 2325687 */     GIR_EraseRootFromParent_Done,
     /* 2325688 */   // Label 31982: @2325688
     /* 2325688 */   GIM_Reject,
     /* 2325689 */ // Label 31980: @2325689
     /* 2325689 */ GIM_Reject,
     /* 2325690 */ // Label 31951: @2325690
     /* 2325690 */ GIM_Try, /*On fail goto*//*Label 31983*/ GIMT_Encode4(2325797),
     /* 2325695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2325698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325706 */   GIM_Try, /*On fail goto*//*Label 31984*/ GIMT_Encode4(2325751), // Rule ID 56254 //
     /* 2325711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2325714 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2325717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2325731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325750 */     // GIR_Coverage, 56254,
     /* 2325750 */     GIR_EraseRootFromParent_Done,
     /* 2325751 */   // Label 31984: @2325751
     /* 2325751 */   GIM_Try, /*On fail goto*//*Label 31985*/ GIMT_Encode4(2325796), // Rule ID 56255 //
     /* 2325756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2325759 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2325762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2325776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325795 */     // GIR_Coverage, 56255,
     /* 2325795 */     GIR_EraseRootFromParent_Done,
     /* 2325796 */   // Label 31985: @2325796
     /* 2325796 */   GIM_Reject,
     /* 2325797 */ // Label 31983: @2325797
     /* 2325797 */ GIM_Reject,
     /* 2325798 */ // Label 31952: @2325798
     /* 2325798 */ GIM_Try, /*On fail goto*//*Label 31986*/ GIMT_Encode4(2325905),
     /* 2325803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2325806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325814 */   GIM_Try, /*On fail goto*//*Label 31987*/ GIMT_Encode4(2325859), // Rule ID 56314 //
     /* 2325819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2325822 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2325825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2325839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325858 */     // GIR_Coverage, 56314,
     /* 2325858 */     GIR_EraseRootFromParent_Done,
     /* 2325859 */   // Label 31987: @2325859
     /* 2325859 */   GIM_Try, /*On fail goto*//*Label 31988*/ GIMT_Encode4(2325904), // Rule ID 56315 //
     /* 2325864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2325867 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2325870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2325884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325903 */     // GIR_Coverage, 56315,
     /* 2325903 */     GIR_EraseRootFromParent_Done,
     /* 2325904 */   // Label 31988: @2325904
     /* 2325904 */   GIM_Reject,
     /* 2325905 */ // Label 31986: @2325905
     /* 2325905 */ GIM_Reject,
     /* 2325906 */ // Label 31953: @2325906
     /* 2325906 */ GIM_Try, /*On fail goto*//*Label 31989*/ GIMT_Encode4(2326013),
     /* 2325911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2325914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325922 */   GIM_Try, /*On fail goto*//*Label 31990*/ GIMT_Encode4(2325967), // Rule ID 56474 //
     /* 2325927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2325930 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2325933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2325947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2325962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325966 */     // GIR_Coverage, 56474,
     /* 2325966 */     GIR_EraseRootFromParent_Done,
     /* 2325967 */   // Label 31990: @2325967
     /* 2325967 */   GIM_Try, /*On fail goto*//*Label 31991*/ GIMT_Encode4(2326012), // Rule ID 56475 //
     /* 2325972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2325975 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2325978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2325992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2325999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2326007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326011 */     // GIR_Coverage, 56475,
     /* 2326011 */     GIR_EraseRootFromParent_Done,
     /* 2326012 */   // Label 31991: @2326012
     /* 2326012 */   GIM_Reject,
     /* 2326013 */ // Label 31989: @2326013
     /* 2326013 */ GIM_Reject,
     /* 2326014 */ // Label 31954: @2326014
     /* 2326014 */ GIM_Try, /*On fail goto*//*Label 31992*/ GIMT_Encode4(2326121),
     /* 2326019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2326022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326030 */   GIM_Try, /*On fail goto*//*Label 31993*/ GIMT_Encode4(2326075), // Rule ID 56294 //
     /* 2326035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2326038 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2326041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2326055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326074 */     // GIR_Coverage, 56294,
     /* 2326074 */     GIR_EraseRootFromParent_Done,
     /* 2326075 */   // Label 31993: @2326075
     /* 2326075 */   GIM_Try, /*On fail goto*//*Label 31994*/ GIMT_Encode4(2326120), // Rule ID 56295 //
     /* 2326080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2326083 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2326086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2326100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326119 */     // GIR_Coverage, 56295,
     /* 2326119 */     GIR_EraseRootFromParent_Done,
     /* 2326120 */   // Label 31994: @2326120
     /* 2326120 */   GIM_Reject,
     /* 2326121 */ // Label 31992: @2326121
     /* 2326121 */ GIM_Reject,
     /* 2326122 */ // Label 31955: @2326122
     /* 2326122 */ GIM_Try, /*On fail goto*//*Label 31995*/ GIMT_Encode4(2326229),
     /* 2326127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2326130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326138 */   GIM_Try, /*On fail goto*//*Label 31996*/ GIMT_Encode4(2326183), // Rule ID 56414 //
     /* 2326143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2326146 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2326149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2326163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326182 */     // GIR_Coverage, 56414,
     /* 2326182 */     GIR_EraseRootFromParent_Done,
     /* 2326183 */   // Label 31996: @2326183
     /* 2326183 */   GIM_Try, /*On fail goto*//*Label 31997*/ GIMT_Encode4(2326228), // Rule ID 56415 //
     /* 2326188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2326191 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2326194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2326208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326227 */     // GIR_Coverage, 56415,
     /* 2326227 */     GIR_EraseRootFromParent_Done,
     /* 2326228 */   // Label 31997: @2326228
     /* 2326228 */   GIM_Reject,
     /* 2326229 */ // Label 31995: @2326229
     /* 2326229 */ GIM_Reject,
     /* 2326230 */ // Label 31956: @2326230
     /* 2326230 */ GIM_Try, /*On fail goto*//*Label 31998*/ GIMT_Encode4(2326337),
     /* 2326235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2326238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326246 */   GIM_Try, /*On fail goto*//*Label 31999*/ GIMT_Encode4(2326291), // Rule ID 56494 //
     /* 2326251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2326254 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2326257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2326271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2326286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326290 */     // GIR_Coverage, 56494,
     /* 2326290 */     GIR_EraseRootFromParent_Done,
     /* 2326291 */   // Label 31999: @2326291
     /* 2326291 */   GIM_Try, /*On fail goto*//*Label 32000*/ GIMT_Encode4(2326336), // Rule ID 56495 //
     /* 2326296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2326299 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2326302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2326316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2326331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326335 */     // GIR_Coverage, 56495,
     /* 2326335 */     GIR_EraseRootFromParent_Done,
     /* 2326336 */   // Label 32000: @2326336
     /* 2326336 */   GIM_Reject,
     /* 2326337 */ // Label 31998: @2326337
     /* 2326337 */ GIM_Reject,
     /* 2326338 */ // Label 31957: @2326338
     /* 2326338 */ GIM_Try, /*On fail goto*//*Label 32001*/ GIMT_Encode4(2326445),
     /* 2326343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2326346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326354 */   GIM_Try, /*On fail goto*//*Label 32002*/ GIMT_Encode4(2326399), // Rule ID 56354 //
     /* 2326359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2326362 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2326365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2326379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326398 */     // GIR_Coverage, 56354,
     /* 2326398 */     GIR_EraseRootFromParent_Done,
     /* 2326399 */   // Label 32002: @2326399
     /* 2326399 */   GIM_Try, /*On fail goto*//*Label 32003*/ GIMT_Encode4(2326444), // Rule ID 56355 //
     /* 2326404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2326407 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2326410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2326424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326443 */     // GIR_Coverage, 56355,
     /* 2326443 */     GIR_EraseRootFromParent_Done,
     /* 2326444 */   // Label 32003: @2326444
     /* 2326444 */   GIM_Reject,
     /* 2326445 */ // Label 32001: @2326445
     /* 2326445 */ GIM_Reject,
     /* 2326446 */ // Label 31958: @2326446
     /* 2326446 */ GIM_Try, /*On fail goto*//*Label 32004*/ GIMT_Encode4(2326553),
     /* 2326451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2326454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326462 */   GIM_Try, /*On fail goto*//*Label 32005*/ GIMT_Encode4(2326507), // Rule ID 56434 //
     /* 2326467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2326470 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2326473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2326487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326506 */     // GIR_Coverage, 56434,
     /* 2326506 */     GIR_EraseRootFromParent_Done,
     /* 2326507 */   // Label 32005: @2326507
     /* 2326507 */   GIM_Try, /*On fail goto*//*Label 32006*/ GIMT_Encode4(2326552), // Rule ID 56435 //
     /* 2326512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2326515 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2326518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2326532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326551 */     // GIR_Coverage, 56435,
     /* 2326551 */     GIR_EraseRootFromParent_Done,
     /* 2326552 */   // Label 32006: @2326552
     /* 2326552 */   GIM_Reject,
     /* 2326553 */ // Label 32004: @2326553
     /* 2326553 */ GIM_Reject,
     /* 2326554 */ // Label 31959: @2326554
     /* 2326554 */ GIM_Try, /*On fail goto*//*Label 32007*/ GIMT_Encode4(2326661),
     /* 2326559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2326562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326570 */   GIM_Try, /*On fail goto*//*Label 32008*/ GIMT_Encode4(2326615), // Rule ID 56514 //
     /* 2326575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2326578 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2326581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2326595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2326610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326614 */     // GIR_Coverage, 56514,
     /* 2326614 */     GIR_EraseRootFromParent_Done,
     /* 2326615 */   // Label 32008: @2326615
     /* 2326615 */   GIM_Try, /*On fail goto*//*Label 32009*/ GIMT_Encode4(2326660), // Rule ID 56515 //
     /* 2326620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2326623 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2326626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2326640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2326655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326659 */     // GIR_Coverage, 56515,
     /* 2326659 */     GIR_EraseRootFromParent_Done,
     /* 2326660 */   // Label 32009: @2326660
     /* 2326660 */   GIM_Reject,
     /* 2326661 */ // Label 32007: @2326661
     /* 2326661 */ GIM_Reject,
     /* 2326662 */ // Label 31960: @2326662
     /* 2326662 */ GIM_Try, /*On fail goto*//*Label 32010*/ GIMT_Encode4(2326769),
     /* 2326667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2326670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326678 */   GIM_Try, /*On fail goto*//*Label 32011*/ GIMT_Encode4(2326723), // Rule ID 56374 //
     /* 2326683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2326686 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2326689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2326703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326722 */     // GIR_Coverage, 56374,
     /* 2326722 */     GIR_EraseRootFromParent_Done,
     /* 2326723 */   // Label 32011: @2326723
     /* 2326723 */   GIM_Try, /*On fail goto*//*Label 32012*/ GIMT_Encode4(2326768), // Rule ID 56375 //
     /* 2326728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2326731 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2326734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2326748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326767 */     // GIR_Coverage, 56375,
     /* 2326767 */     GIR_EraseRootFromParent_Done,
     /* 2326768 */   // Label 32012: @2326768
     /* 2326768 */   GIM_Reject,
     /* 2326769 */ // Label 32010: @2326769
     /* 2326769 */ GIM_Reject,
     /* 2326770 */ // Label 31961: @2326770
     /* 2326770 */ GIM_Try, /*On fail goto*//*Label 32013*/ GIMT_Encode4(2326877),
     /* 2326775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2326778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326786 */   GIM_Try, /*On fail goto*//*Label 32014*/ GIMT_Encode4(2326831), // Rule ID 56454 //
     /* 2326791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2326794 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2326797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2326811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326830 */     // GIR_Coverage, 56454,
     /* 2326830 */     GIR_EraseRootFromParent_Done,
     /* 2326831 */   // Label 32014: @2326831
     /* 2326831 */   GIM_Try, /*On fail goto*//*Label 32015*/ GIMT_Encode4(2326876), // Rule ID 56455 //
     /* 2326836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2326839 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2326842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2326856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326875 */     // GIR_Coverage, 56455,
     /* 2326875 */     GIR_EraseRootFromParent_Done,
     /* 2326876 */   // Label 32015: @2326876
     /* 2326876 */   GIM_Reject,
     /* 2326877 */ // Label 32013: @2326877
     /* 2326877 */ GIM_Reject,
     /* 2326878 */ // Label 31962: @2326878
     /* 2326878 */ GIM_Try, /*On fail goto*//*Label 32016*/ GIMT_Encode4(2326985),
     /* 2326883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2326886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326894 */   GIM_Try, /*On fail goto*//*Label 32017*/ GIMT_Encode4(2326939), // Rule ID 56394 //
     /* 2326899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2326902 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2326905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2326919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326938 */     // GIR_Coverage, 56394,
     /* 2326938 */     GIR_EraseRootFromParent_Done,
     /* 2326939 */   // Label 32017: @2326939
     /* 2326939 */   GIM_Try, /*On fail goto*//*Label 32018*/ GIMT_Encode4(2326984), // Rule ID 56395 //
     /* 2326944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2326947 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2326950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2326964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2326973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326983 */     // GIR_Coverage, 56395,
     /* 2326983 */     GIR_EraseRootFromParent_Done,
     /* 2326984 */   // Label 32018: @2326984
     /* 2326984 */   GIM_Reject,
     /* 2326985 */ // Label 32016: @2326985
     /* 2326985 */ GIM_Reject,
     /* 2326986 */ // Label 31963: @2326986
     /* 2326986 */ GIM_Reject,
     /* 2326987 */ // Label 65: @2326987
     /* 2326987 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 32021*/ GIMT_Encode4(2327439),
     /* 2326998 */ /*GILLT_s32*//*Label 32019*/ GIMT_Encode4(2327006),
     /* 2327002 */ /*GILLT_s64*//*Label 32020*/ GIMT_Encode4(2327128),
     /* 2327006 */ // Label 32019: @2327006
     /* 2327006 */ GIM_Try, /*On fail goto*//*Label 32022*/ GIMT_Encode4(2327127),
     /* 2327011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327014 */   GIM_Try, /*On fail goto*//*Label 32023*/ GIMT_Encode4(2327042), // Rule ID 2156 //
     /* 2327019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2327022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2327026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2327030 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2327030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2327033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327041 */     // GIR_Coverage, 2156,
     /* 2327041 */     GIR_EraseRootFromParent_Done,
     /* 2327042 */   // Label 32023: @2327042
     /* 2327042 */   GIM_Try, /*On fail goto*//*Label 32024*/ GIMT_Encode4(2327070), // Rule ID 2157 //
     /* 2327047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2327050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2327054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2327058 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2327058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2327061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327069 */     // GIR_Coverage, 2157,
     /* 2327069 */     GIR_EraseRootFromParent_Done,
     /* 2327070 */   // Label 32024: @2327070
     /* 2327070 */   GIM_Try, /*On fail goto*//*Label 32025*/ GIMT_Encode4(2327098), // Rule ID 2172 //
     /* 2327075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2327078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327086 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2327086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2327089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327097 */     // GIR_Coverage, 2172,
     /* 2327097 */     GIR_EraseRootFromParent_Done,
     /* 2327098 */   // Label 32025: @2327098
     /* 2327098 */   GIM_Try, /*On fail goto*//*Label 32026*/ GIMT_Encode4(2327126), // Rule ID 2173 //
     /* 2327103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2327106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327114 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2327114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2327117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327125 */     // GIR_Coverage, 2173,
     /* 2327125 */     GIR_EraseRootFromParent_Done,
     /* 2327126 */   // Label 32026: @2327126
     /* 2327126 */   GIM_Reject,
     /* 2327127 */ // Label 32022: @2327127
     /* 2327127 */ GIM_Reject,
     /* 2327128 */ // Label 32020: @2327128
     /* 2327128 */ GIM_Try, /*On fail goto*//*Label 32027*/ GIMT_Encode4(2327159), // Rule ID 1558 //
     /* 2327133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2327136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2327147 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2327147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2327150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327152 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327157 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327158 */   // GIR_Coverage, 1558,
     /* 2327158 */   GIR_EraseRootFromParent_Done,
     /* 2327159 */ // Label 32027: @2327159
     /* 2327159 */ GIM_Try, /*On fail goto*//*Label 32028*/ GIMT_Encode4(2327190), // Rule ID 1559 //
     /* 2327164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2327167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2327178 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2327178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2327181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327183 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327188 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327189 */   // GIR_Coverage, 1559,
     /* 2327189 */   GIR_EraseRootFromParent_Done,
     /* 2327190 */ // Label 32028: @2327190
     /* 2327190 */ GIM_Try, /*On fail goto*//*Label 32029*/ GIMT_Encode4(2327221), // Rule ID 1563 //
     /* 2327195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2327198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327209 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_INX:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2327209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2327212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327214 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327219 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327220 */   // GIR_Coverage, 1563,
     /* 2327220 */   GIR_EraseRootFromParent_Done,
     /* 2327221 */ // Label 32029: @2327221
     /* 2327221 */ GIM_Try, /*On fail goto*//*Label 32030*/ GIMT_Encode4(2327252), // Rule ID 1570 //
     /* 2327226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2327229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2327236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327240 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2327240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2327243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327245 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327250 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327251 */   // GIR_Coverage, 1570,
     /* 2327251 */   GIR_EraseRootFromParent_Done,
     /* 2327252 */ // Label 32030: @2327252
     /* 2327252 */ GIM_Try, /*On fail goto*//*Label 32031*/ GIMT_Encode4(2327283), // Rule ID 1571 //
     /* 2327257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2327260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2327267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327271 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2327271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2327274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327276 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327281 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327282 */   // GIR_Coverage, 1571,
     /* 2327282 */   GIR_EraseRootFromParent_Done,
     /* 2327283 */ // Label 32031: @2327283
     /* 2327283 */ GIM_Try, /*On fail goto*//*Label 32032*/ GIMT_Encode4(2327314), // Rule ID 2290 //
     /* 2327288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2327291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2327302 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2327302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2327305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327307 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327312 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327313 */   // GIR_Coverage, 2290,
     /* 2327313 */   GIR_EraseRootFromParent_Done,
     /* 2327314 */ // Label 32032: @2327314
     /* 2327314 */ GIM_Try, /*On fail goto*//*Label 32033*/ GIMT_Encode4(2327345), // Rule ID 2291 //
     /* 2327319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2327322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2327333 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2327333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2327336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327338 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327344 */   // GIR_Coverage, 2291,
     /* 2327344 */   GIR_EraseRootFromParent_Done,
     /* 2327345 */ // Label 32033: @2327345
     /* 2327345 */ GIM_Try, /*On fail goto*//*Label 32034*/ GIMT_Encode4(2327376), // Rule ID 2302 //
     /* 2327350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2327353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2327360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327364 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2327364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2327367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327369 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327374 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327375 */   // GIR_Coverage, 2302,
     /* 2327375 */   GIR_EraseRootFromParent_Done,
     /* 2327376 */ // Label 32034: @2327376
     /* 2327376 */ GIM_Try, /*On fail goto*//*Label 32035*/ GIMT_Encode4(2327407), // Rule ID 2303 //
     /* 2327381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2327384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2327391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327395 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2327395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2327398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327400 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327405 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327406 */   // GIR_Coverage, 2303,
     /* 2327406 */   GIR_EraseRootFromParent_Done,
     /* 2327407 */ // Label 32035: @2327407
     /* 2327407 */ GIM_Try, /*On fail goto*//*Label 32036*/ GIMT_Encode4(2327438), // Rule ID 2311 //
     /* 2327412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2327415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327426 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_INX:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2327426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2327429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327431 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327437 */   // GIR_Coverage, 2311,
     /* 2327437 */   GIR_EraseRootFromParent_Done,
     /* 2327438 */ // Label 32036: @2327438
     /* 2327438 */ GIM_Reject,
     /* 2327439 */ // Label 32021: @2327439
     /* 2327439 */ GIM_Reject,
     /* 2327440 */ // Label 66: @2327440
     /* 2327440 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(28), /*)*//*default:*//*Label 32048*/ GIMT_Encode4(2328975),
     /* 2327451 */ /*GILLT_s16*//*Label 32037*/ GIMT_Encode4(2327555),
     /* 2327455 */ /*GILLT_s32*//*Label 32038*/ GIMT_Encode4(2327835), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2327471 */ /*GILLT_nxv1s16*//*Label 32039*/ GIMT_Encode4(2327985),
     /* 2327475 */ /*GILLT_nxv1s32*//*Label 32040*/ GIMT_Encode4(2328095), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2327491 */ /*GILLT_nxv2s16*//*Label 32041*/ GIMT_Encode4(2328205),
     /* 2327495 */ /*GILLT_nxv2s32*//*Label 32042*/ GIMT_Encode4(2328315), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2327511 */ /*GILLT_nxv4s16*//*Label 32043*/ GIMT_Encode4(2328425),
     /* 2327515 */ /*GILLT_nxv4s32*//*Label 32044*/ GIMT_Encode4(2328535), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2327531 */ /*GILLT_nxv8s16*//*Label 32045*/ GIMT_Encode4(2328645),
     /* 2327535 */ /*GILLT_nxv8s32*//*Label 32046*/ GIMT_Encode4(2328755), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2327551 */ /*GILLT_nxv16s16*//*Label 32047*/ GIMT_Encode4(2328865),
     /* 2327555 */ // Label 32037: @2327555
     /* 2327555 */ GIM_Try, /*On fail goto*//*Label 32049*/ GIMT_Encode4(2327586), // Rule ID 2152 //
     /* 2327560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2327563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2327570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2327574 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2327574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2327577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327579 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327584 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327585 */   // GIR_Coverage, 2152,
     /* 2327585 */   GIR_EraseRootFromParent_Done,
     /* 2327586 */ // Label 32049: @2327586
     /* 2327586 */ GIM_Try, /*On fail goto*//*Label 32050*/ GIMT_Encode4(2327617), // Rule ID 2153 //
     /* 2327591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2327594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2327601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2327605 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2327605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2327608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327610 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327615 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327616 */   // GIR_Coverage, 2153,
     /* 2327616 */   GIR_EraseRootFromParent_Done,
     /* 2327617 */ // Label 32050: @2327617
     /* 2327617 */ GIM_Try, /*On fail goto*//*Label 32051*/ GIMT_Encode4(2327648), // Rule ID 2168 //
     /* 2327622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2327625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327636 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2327636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2327639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327641 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327646 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327647 */   // GIR_Coverage, 2168,
     /* 2327647 */   GIR_EraseRootFromParent_Done,
     /* 2327648 */ // Label 32051: @2327648
     /* 2327648 */ GIM_Try, /*On fail goto*//*Label 32052*/ GIMT_Encode4(2327679), // Rule ID 2169 //
     /* 2327653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2327656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327667 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2327667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2327670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327672 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327677 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327678 */   // GIR_Coverage, 2169,
     /* 2327678 */   GIR_EraseRootFromParent_Done,
     /* 2327679 */ // Label 32052: @2327679
     /* 2327679 */ GIM_Try, /*On fail goto*//*Label 32053*/ GIMT_Encode4(2327710), // Rule ID 2286 //
     /* 2327684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2327687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2327694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327698 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2327698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2327701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327703 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327708 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327709 */   // GIR_Coverage, 2286,
     /* 2327709 */   GIR_EraseRootFromParent_Done,
     /* 2327710 */ // Label 32053: @2327710
     /* 2327710 */ GIM_Try, /*On fail goto*//*Label 32054*/ GIMT_Encode4(2327741), // Rule ID 2287 //
     /* 2327715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2327718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2327725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327729 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2327729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2327732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327734 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327740 */   // GIR_Coverage, 2287,
     /* 2327740 */   GIR_EraseRootFromParent_Done,
     /* 2327741 */ // Label 32054: @2327741
     /* 2327741 */ GIM_Try, /*On fail goto*//*Label 32055*/ GIMT_Encode4(2327772), // Rule ID 2298 //
     /* 2327746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2327749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2327760 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2327760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2327763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327765 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327770 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327771 */   // GIR_Coverage, 2298,
     /* 2327771 */   GIR_EraseRootFromParent_Done,
     /* 2327772 */ // Label 32055: @2327772
     /* 2327772 */ GIM_Try, /*On fail goto*//*Label 32056*/ GIMT_Encode4(2327803), // Rule ID 2299 //
     /* 2327777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2327780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2327791 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2327791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2327794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327796 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327801 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327802 */   // GIR_Coverage, 2299,
     /* 2327802 */   GIR_EraseRootFromParent_Done,
     /* 2327803 */ // Label 32056: @2327803
     /* 2327803 */ GIM_Try, /*On fail goto*//*Label 32057*/ GIMT_Encode4(2327834), // Rule ID 2309 //
     /* 2327808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2327811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327822 */   // (fpround:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_INX:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2327822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2327825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327827 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327833 */   // GIR_Coverage, 2309,
     /* 2327833 */   GIR_EraseRootFromParent_Done,
     /* 2327834 */ // Label 32057: @2327834
     /* 2327834 */ GIM_Reject,
     /* 2327835 */ // Label 32038: @2327835
     /* 2327835 */ GIM_Try, /*On fail goto*//*Label 32058*/ GIMT_Encode4(2327984),
     /* 2327840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327843 */   GIM_Try, /*On fail goto*//*Label 32059*/ GIMT_Encode4(2327871), // Rule ID 1554 //
     /* 2327848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2327851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2327855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327859 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2327859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2327862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327870 */     // GIR_Coverage, 1554,
     /* 2327870 */     GIR_EraseRootFromParent_Done,
     /* 2327871 */   // Label 32059: @2327871
     /* 2327871 */   GIM_Try, /*On fail goto*//*Label 32060*/ GIMT_Encode4(2327899), // Rule ID 1555 //
     /* 2327876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2327879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2327883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327887 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2327887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2327890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327898 */     // GIR_Coverage, 1555,
     /* 2327898 */     GIR_EraseRootFromParent_Done,
     /* 2327899 */   // Label 32060: @2327899
     /* 2327899 */   GIM_Try, /*On fail goto*//*Label 32061*/ GIMT_Encode4(2327927), // Rule ID 1561 //
     /* 2327904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2327907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327915 */     // (fpround:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_INX:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2327915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2327918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327926 */     // GIR_Coverage, 1561,
     /* 2327926 */     GIR_EraseRootFromParent_Done,
     /* 2327927 */   // Label 32061: @2327927
     /* 2327927 */   GIM_Try, /*On fail goto*//*Label 32062*/ GIMT_Encode4(2327955), // Rule ID 1566 //
     /* 2327932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2327935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2327943 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2327943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2327946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327954 */     // GIR_Coverage, 1566,
     /* 2327954 */     GIR_EraseRootFromParent_Done,
     /* 2327955 */   // Label 32062: @2327955
     /* 2327955 */   GIM_Try, /*On fail goto*//*Label 32063*/ GIMT_Encode4(2327983), // Rule ID 1567 //
     /* 2327960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2327963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2327971 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2327971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2327974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327982 */     // GIR_Coverage, 1567,
     /* 2327982 */     GIR_EraseRootFromParent_Done,
     /* 2327983 */   // Label 32063: @2327983
     /* 2327983 */   GIM_Reject,
     /* 2327984 */ // Label 32058: @2327984
     /* 2327984 */ GIM_Reject,
     /* 2327985 */ // Label 32039: @2327985
     /* 2327985 */ GIM_Try, /*On fail goto*//*Label 32064*/ GIMT_Encode4(2328094),
     /* 2327990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328001 */   GIM_Try, /*On fail goto*//*Label 32065*/ GIMT_Encode4(2328047), // Rule ID 58882 //
     /* 2328006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2328009 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2328012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2328026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328046 */     // GIR_Coverage, 58882,
     /* 2328046 */     GIR_EraseRootFromParent_Done,
     /* 2328047 */   // Label 32065: @2328047
     /* 2328047 */   GIM_Try, /*On fail goto*//*Label 32066*/ GIMT_Encode4(2328093), // Rule ID 58883 //
     /* 2328052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2328055 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2328058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2328072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328092 */     // GIR_Coverage, 58883,
     /* 2328092 */     GIR_EraseRootFromParent_Done,
     /* 2328093 */   // Label 32066: @2328093
     /* 2328093 */   GIM_Reject,
     /* 2328094 */ // Label 32064: @2328094
     /* 2328094 */ GIM_Reject,
     /* 2328095 */ // Label 32040: @2328095
     /* 2328095 */ GIM_Try, /*On fail goto*//*Label 32067*/ GIMT_Encode4(2328204),
     /* 2328100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2328103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328111 */   GIM_Try, /*On fail goto*//*Label 32068*/ GIMT_Encode4(2328157), // Rule ID 58892 //
     /* 2328116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2328119 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2328122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2328136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328156 */     // GIR_Coverage, 58892,
     /* 2328156 */     GIR_EraseRootFromParent_Done,
     /* 2328157 */   // Label 32068: @2328157
     /* 2328157 */   GIM_Try, /*On fail goto*//*Label 32069*/ GIMT_Encode4(2328203), // Rule ID 58893 //
     /* 2328162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2328165 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2328168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2328182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328202 */     // GIR_Coverage, 58893,
     /* 2328202 */     GIR_EraseRootFromParent_Done,
     /* 2328203 */   // Label 32069: @2328203
     /* 2328203 */   GIM_Reject,
     /* 2328204 */ // Label 32067: @2328204
     /* 2328204 */ GIM_Reject,
     /* 2328205 */ // Label 32041: @2328205
     /* 2328205 */ GIM_Try, /*On fail goto*//*Label 32070*/ GIMT_Encode4(2328314),
     /* 2328210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328221 */   GIM_Try, /*On fail goto*//*Label 32071*/ GIMT_Encode4(2328267), // Rule ID 58884 //
     /* 2328226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2328229 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2328246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328266 */     // GIR_Coverage, 58884,
     /* 2328266 */     GIR_EraseRootFromParent_Done,
     /* 2328267 */   // Label 32071: @2328267
     /* 2328267 */   GIM_Try, /*On fail goto*//*Label 32072*/ GIMT_Encode4(2328313), // Rule ID 58885 //
     /* 2328272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2328275 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2328292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328312 */     // GIR_Coverage, 58885,
     /* 2328312 */     GIR_EraseRootFromParent_Done,
     /* 2328313 */   // Label 32072: @2328313
     /* 2328313 */   GIM_Reject,
     /* 2328314 */ // Label 32070: @2328314
     /* 2328314 */ GIM_Reject,
     /* 2328315 */ // Label 32042: @2328315
     /* 2328315 */ GIM_Try, /*On fail goto*//*Label 32073*/ GIMT_Encode4(2328424),
     /* 2328320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2328323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328331 */   GIM_Try, /*On fail goto*//*Label 32074*/ GIMT_Encode4(2328377), // Rule ID 58894 //
     /* 2328336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2328339 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2328356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328376 */     // GIR_Coverage, 58894,
     /* 2328376 */     GIR_EraseRootFromParent_Done,
     /* 2328377 */   // Label 32074: @2328377
     /* 2328377 */   GIM_Try, /*On fail goto*//*Label 32075*/ GIMT_Encode4(2328423), // Rule ID 58895 //
     /* 2328382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2328385 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2328402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328422 */     // GIR_Coverage, 58895,
     /* 2328422 */     GIR_EraseRootFromParent_Done,
     /* 2328423 */   // Label 32075: @2328423
     /* 2328423 */   GIM_Reject,
     /* 2328424 */ // Label 32073: @2328424
     /* 2328424 */ GIM_Reject,
     /* 2328425 */ // Label 32043: @2328425
     /* 2328425 */ GIM_Try, /*On fail goto*//*Label 32076*/ GIMT_Encode4(2328534),
     /* 2328430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2328433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328441 */   GIM_Try, /*On fail goto*//*Label 32077*/ GIMT_Encode4(2328487), // Rule ID 58886 //
     /* 2328446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2328449 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2328452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2328466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328486 */     // GIR_Coverage, 58886,
     /* 2328486 */     GIR_EraseRootFromParent_Done,
     /* 2328487 */   // Label 32077: @2328487
     /* 2328487 */   GIM_Try, /*On fail goto*//*Label 32078*/ GIMT_Encode4(2328533), // Rule ID 58887 //
     /* 2328492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2328495 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2328498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2328512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328532 */     // GIR_Coverage, 58887,
     /* 2328532 */     GIR_EraseRootFromParent_Done,
     /* 2328533 */   // Label 32078: @2328533
     /* 2328533 */   GIM_Reject,
     /* 2328534 */ // Label 32076: @2328534
     /* 2328534 */ GIM_Reject,
     /* 2328535 */ // Label 32044: @2328535
     /* 2328535 */ GIM_Try, /*On fail goto*//*Label 32079*/ GIMT_Encode4(2328644),
     /* 2328540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2328543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328551 */   GIM_Try, /*On fail goto*//*Label 32080*/ GIMT_Encode4(2328597), // Rule ID 58896 //
     /* 2328556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2328559 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2328562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2328576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328596 */     // GIR_Coverage, 58896,
     /* 2328596 */     GIR_EraseRootFromParent_Done,
     /* 2328597 */   // Label 32080: @2328597
     /* 2328597 */   GIM_Try, /*On fail goto*//*Label 32081*/ GIMT_Encode4(2328643), // Rule ID 58897 //
     /* 2328602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2328605 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2328608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2328622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328642 */     // GIR_Coverage, 58897,
     /* 2328642 */     GIR_EraseRootFromParent_Done,
     /* 2328643 */   // Label 32081: @2328643
     /* 2328643 */   GIM_Reject,
     /* 2328644 */ // Label 32079: @2328644
     /* 2328644 */ GIM_Reject,
     /* 2328645 */ // Label 32045: @2328645
     /* 2328645 */ GIM_Try, /*On fail goto*//*Label 32082*/ GIMT_Encode4(2328754),
     /* 2328650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2328653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328661 */   GIM_Try, /*On fail goto*//*Label 32083*/ GIMT_Encode4(2328707), // Rule ID 58888 //
     /* 2328666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2328669 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2328672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2328686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328706 */     // GIR_Coverage, 58888,
     /* 2328706 */     GIR_EraseRootFromParent_Done,
     /* 2328707 */   // Label 32083: @2328707
     /* 2328707 */   GIM_Try, /*On fail goto*//*Label 32084*/ GIMT_Encode4(2328753), // Rule ID 58889 //
     /* 2328712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2328715 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2328718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2328732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328752 */     // GIR_Coverage, 58889,
     /* 2328752 */     GIR_EraseRootFromParent_Done,
     /* 2328753 */   // Label 32084: @2328753
     /* 2328753 */   GIM_Reject,
     /* 2328754 */ // Label 32082: @2328754
     /* 2328754 */ GIM_Reject,
     /* 2328755 */ // Label 32046: @2328755
     /* 2328755 */ GIM_Try, /*On fail goto*//*Label 32085*/ GIMT_Encode4(2328864),
     /* 2328760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2328763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328771 */   GIM_Try, /*On fail goto*//*Label 32086*/ GIMT_Encode4(2328817), // Rule ID 58898 //
     /* 2328776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2328779 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2328782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2328796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328816 */     // GIR_Coverage, 58898,
     /* 2328816 */     GIR_EraseRootFromParent_Done,
     /* 2328817 */   // Label 32086: @2328817
     /* 2328817 */   GIM_Try, /*On fail goto*//*Label 32087*/ GIMT_Encode4(2328863), // Rule ID 58899 //
     /* 2328822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2328825 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2328828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2328842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328862 */     // GIR_Coverage, 58899,
     /* 2328862 */     GIR_EraseRootFromParent_Done,
     /* 2328863 */   // Label 32087: @2328863
     /* 2328863 */   GIM_Reject,
     /* 2328864 */ // Label 32085: @2328864
     /* 2328864 */ GIM_Reject,
     /* 2328865 */ // Label 32047: @2328865
     /* 2328865 */ GIM_Try, /*On fail goto*//*Label 32088*/ GIMT_Encode4(2328974),
     /* 2328870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2328873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328881 */   GIM_Try, /*On fail goto*//*Label 32089*/ GIMT_Encode4(2328927), // Rule ID 58890 //
     /* 2328886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2328889 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2328892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2328906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328926 */     // GIR_Coverage, 58890,
     /* 2328926 */     GIR_EraseRootFromParent_Done,
     /* 2328927 */   // Label 32089: @2328927
     /* 2328927 */   GIM_Try, /*On fail goto*//*Label 32090*/ GIMT_Encode4(2328973), // Rule ID 58891 //
     /* 2328932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2328935 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2328938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2328952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328972 */     // GIR_Coverage, 58891,
     /* 2328972 */     GIR_EraseRootFromParent_Done,
     /* 2328973 */   // Label 32090: @2328973
     /* 2328973 */   GIM_Reject,
     /* 2328974 */ // Label 32088: @2328974
     /* 2328974 */ GIM_Reject,
     /* 2328975 */ // Label 32048: @2328975
     /* 2328975 */ GIM_Reject,
     /* 2328976 */ // Label 67: @2328976
     /* 2328976 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 32114*/ GIMT_Encode4(2333861),
     /* 2328987 */ /*GILLT_s32*//*Label 32091*/ GIMT_Encode4(2329103),
     /* 2328991 */ /*GILLT_s64*//*Label 32092*/ GIMT_Encode4(2329476), GIMT_Encode4(0),
     /* 2328999 */ /*GILLT_nxv1s8*//*Label 32093*/ GIMT_Encode4(2329663),
     /* 2329003 */ /*GILLT_nxv1s16*//*Label 32094*/ GIMT_Encode4(2329767),
     /* 2329007 */ /*GILLT_nxv1s32*//*Label 32095*/ GIMT_Encode4(2329984),
     /* 2329011 */ /*GILLT_nxv1s64*//*Label 32096*/ GIMT_Encode4(2330309), GIMT_Encode4(0),
     /* 2329019 */ /*GILLT_nxv2s8*//*Label 32097*/ GIMT_Encode4(2330526),
     /* 2329023 */ /*GILLT_nxv2s16*//*Label 32098*/ GIMT_Encode4(2330630),
     /* 2329027 */ /*GILLT_nxv2s32*//*Label 32099*/ GIMT_Encode4(2330847),
     /* 2329031 */ /*GILLT_nxv2s64*//*Label 32100*/ GIMT_Encode4(2331172), GIMT_Encode4(0),
     /* 2329039 */ /*GILLT_nxv4s8*//*Label 32101*/ GIMT_Encode4(2331389),
     /* 2329043 */ /*GILLT_nxv4s16*//*Label 32102*/ GIMT_Encode4(2331493),
     /* 2329047 */ /*GILLT_nxv4s32*//*Label 32103*/ GIMT_Encode4(2331710),
     /* 2329051 */ /*GILLT_nxv4s64*//*Label 32104*/ GIMT_Encode4(2332035), GIMT_Encode4(0),
     /* 2329059 */ /*GILLT_nxv8s8*//*Label 32105*/ GIMT_Encode4(2332252),
     /* 2329063 */ /*GILLT_nxv8s16*//*Label 32106*/ GIMT_Encode4(2332356),
     /* 2329067 */ /*GILLT_nxv8s32*//*Label 32107*/ GIMT_Encode4(2332573),
     /* 2329071 */ /*GILLT_nxv8s64*//*Label 32108*/ GIMT_Encode4(2332898), GIMT_Encode4(0),
     /* 2329079 */ /*GILLT_nxv16s8*//*Label 32109*/ GIMT_Encode4(2333115),
     /* 2329083 */ /*GILLT_nxv16s16*//*Label 32110*/ GIMT_Encode4(2333219),
     /* 2329087 */ /*GILLT_nxv16s32*//*Label 32111*/ GIMT_Encode4(2333436), GIMT_Encode4(0),
     /* 2329095 */ /*GILLT_nxv32s8*//*Label 32112*/ GIMT_Encode4(2333653),
     /* 2329099 */ /*GILLT_nxv32s16*//*Label 32113*/ GIMT_Encode4(2333757),
     /* 2329103 */ // Label 32091: @2329103
     /* 2329103 */ GIM_Try, /*On fail goto*//*Label 32115*/ GIMT_Encode4(2329134), // Rule ID 1446 //
     /* 2329108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2329111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2329114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2329122 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2329122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2329125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329127 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329132 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329133 */   // GIR_Coverage, 1446,
     /* 2329133 */   GIR_EraseRootFromParent_Done,
     /* 2329134 */ // Label 32115: @2329134
     /* 2329134 */ GIM_Try, /*On fail goto*//*Label 32116*/ GIMT_Encode4(2329165), // Rule ID 1447 //
     /* 2329139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2329142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2329145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2329153 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2329153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2329156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329158 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329163 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329164 */   // GIR_Coverage, 1447,
     /* 2329164 */   GIR_EraseRootFromParent_Done,
     /* 2329165 */ // Label 32116: @2329165
     /* 2329165 */ GIM_Try, /*On fail goto*//*Label 32117*/ GIMT_Encode4(2329196), // Rule ID 1472 //
     /* 2329170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2329173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2329176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2329184 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2329184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2329187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329189 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329194 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329195 */   // GIR_Coverage, 1472,
     /* 2329195 */   GIR_EraseRootFromParent_Done,
     /* 2329196 */ // Label 32117: @2329196
     /* 2329196 */ GIM_Try, /*On fail goto*//*Label 32118*/ GIMT_Encode4(2329227), // Rule ID 1473 //
     /* 2329201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2329204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2329207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2329215 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2329215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2329218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329220 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329225 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329226 */   // GIR_Coverage, 1473,
     /* 2329226 */   GIR_EraseRootFromParent_Done,
     /* 2329227 */ // Label 32118: @2329227
     /* 2329227 */ GIM_Try, /*On fail goto*//*Label 32119*/ GIMT_Encode4(2329258), // Rule ID 1840 //
     /* 2329232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2329235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2329238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2329246 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2329246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2329249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329251 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329256 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329257 */   // GIR_Coverage, 1840,
     /* 2329257 */   GIR_EraseRootFromParent_Done,
     /* 2329258 */ // Label 32119: @2329258
     /* 2329258 */ GIM_Try, /*On fail goto*//*Label 32120*/ GIMT_Encode4(2329289), // Rule ID 1841 //
     /* 2329263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2329266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2329269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2329277 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2329277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2329280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329282 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329287 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329288 */   // GIR_Coverage, 1841,
     /* 2329288 */   GIR_EraseRootFromParent_Done,
     /* 2329289 */ // Label 32120: @2329289
     /* 2329289 */ GIM_Try, /*On fail goto*//*Label 32121*/ GIMT_Encode4(2329320), // Rule ID 1866 //
     /* 2329294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2329297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2329300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2329308 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2329308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2329311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329313 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329319 */   // GIR_Coverage, 1866,
     /* 2329319 */   GIR_EraseRootFromParent_Done,
     /* 2329320 */ // Label 32121: @2329320
     /* 2329320 */ GIM_Try, /*On fail goto*//*Label 32122*/ GIMT_Encode4(2329351), // Rule ID 1867 //
     /* 2329325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2329328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2329331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2329339 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2329339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2329342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329344 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329350 */   // GIR_Coverage, 1867,
     /* 2329350 */   GIR_EraseRootFromParent_Done,
     /* 2329351 */ // Label 32122: @2329351
     /* 2329351 */ GIM_Try, /*On fail goto*//*Label 32123*/ GIMT_Encode4(2329382), // Rule ID 2182 //
     /* 2329356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2329359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2329362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2329370 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2329370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2329373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329375 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329380 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329381 */   // GIR_Coverage, 2182,
     /* 2329381 */   GIR_EraseRootFromParent_Done,
     /* 2329382 */ // Label 32123: @2329382
     /* 2329382 */ GIM_Try, /*On fail goto*//*Label 32124*/ GIMT_Encode4(2329413), // Rule ID 2183 //
     /* 2329387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2329390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2329393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2329401 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2329401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2329404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329406 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329411 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329412 */   // GIR_Coverage, 2183,
     /* 2329412 */   GIR_EraseRootFromParent_Done,
     /* 2329413 */ // Label 32124: @2329413
     /* 2329413 */ GIM_Try, /*On fail goto*//*Label 32125*/ GIMT_Encode4(2329444), // Rule ID 2208 //
     /* 2329418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2329421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2329424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2329432 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2329432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2329435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329437 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329442 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329443 */   // GIR_Coverage, 2208,
     /* 2329443 */   GIR_EraseRootFromParent_Done,
     /* 2329444 */ // Label 32125: @2329444
     /* 2329444 */ GIM_Try, /*On fail goto*//*Label 32126*/ GIMT_Encode4(2329475), // Rule ID 2209 //
     /* 2329449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2329452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2329455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2329463 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2329463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2329466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329468 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329474 */   // GIR_Coverage, 2209,
     /* 2329474 */   GIR_EraseRootFromParent_Done,
     /* 2329475 */ // Label 32126: @2329475
     /* 2329475 */ GIM_Reject,
     /* 2329476 */ // Label 32092: @2329476
     /* 2329476 */ GIM_Try, /*On fail goto*//*Label 32127*/ GIMT_Encode4(2329507), // Rule ID 1503 //
     /* 2329481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2329484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2329487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2329495 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2329495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2329498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329500 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329505 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329506 */   // GIR_Coverage, 1503,
     /* 2329506 */   GIR_EraseRootFromParent_Done,
     /* 2329507 */ // Label 32127: @2329507
     /* 2329507 */ GIM_Try, /*On fail goto*//*Label 32128*/ GIMT_Encode4(2329538), // Rule ID 1531 //
     /* 2329512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2329515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2329518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2329526 */   // (fp_to_sint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2329526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2329529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329531 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329536 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329537 */   // GIR_Coverage, 1531,
     /* 2329537 */   GIR_EraseRootFromParent_Done,
     /* 2329538 */ // Label 32128: @2329538
     /* 2329538 */ GIM_Try, /*On fail goto*//*Label 32129*/ GIMT_Encode4(2329569), // Rule ID 1903 //
     /* 2329543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2329546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2329549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2329557 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2329557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2329560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329562 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329567 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329568 */   // GIR_Coverage, 1903,
     /* 2329568 */   GIR_EraseRootFromParent_Done,
     /* 2329569 */ // Label 32129: @2329569
     /* 2329569 */ GIM_Try, /*On fail goto*//*Label 32130*/ GIMT_Encode4(2329600), // Rule ID 1931 //
     /* 2329574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2329577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2329580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329588 */   // (fp_to_sint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2329588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2329591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329593 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329599 */   // GIR_Coverage, 1931,
     /* 2329599 */   GIR_EraseRootFromParent_Done,
     /* 2329600 */ // Label 32130: @2329600
     /* 2329600 */ GIM_Try, /*On fail goto*//*Label 32131*/ GIMT_Encode4(2329631), // Rule ID 2237 //
     /* 2329605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2329608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2329611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2329619 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2329619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2329622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329624 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329629 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329630 */   // GIR_Coverage, 2237,
     /* 2329630 */   GIR_EraseRootFromParent_Done,
     /* 2329631 */ // Label 32131: @2329631
     /* 2329631 */ GIM_Try, /*On fail goto*//*Label 32132*/ GIMT_Encode4(2329662), // Rule ID 2263 //
     /* 2329636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2329639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2329642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2329646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2329650 */   // (fp_to_sint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2329650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2329653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329655 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2329660 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329661 */   // GIR_Coverage, 2263,
     /* 2329661 */   GIR_EraseRootFromParent_Done,
     /* 2329662 */ // Label 32132: @2329662
     /* 2329662 */ GIM_Reject,
     /* 2329663 */ // Label 32093: @2329663
     /* 2329663 */ GIM_Try, /*On fail goto*//*Label 32133*/ GIMT_Encode4(2329766),
     /* 2329668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2329671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329679 */   GIM_Try, /*On fail goto*//*Label 32134*/ GIMT_Encode4(2329722), // Rule ID 45812 //
     /* 2329684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329687 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2329690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2329704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329721 */     // GIR_Coverage, 45812,
     /* 2329721 */     GIR_EraseRootFromParent_Done,
     /* 2329722 */   // Label 32134: @2329722
     /* 2329722 */   GIM_Try, /*On fail goto*//*Label 32135*/ GIMT_Encode4(2329765), // Rule ID 45813 //
     /* 2329727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329730 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2329733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2329747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329764 */     // GIR_Coverage, 45813,
     /* 2329764 */     GIR_EraseRootFromParent_Done,
     /* 2329765 */   // Label 32135: @2329765
     /* 2329765 */   GIM_Reject,
     /* 2329766 */ // Label 32133: @2329766
     /* 2329766 */ GIM_Reject,
     /* 2329767 */ // Label 32094: @2329767
     /* 2329767 */ GIM_Try, /*On fail goto*//*Label 32136*/ GIMT_Encode4(2329821), // Rule ID 45796 //
     /* 2329772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2329778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329786 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329786 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2329789 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329793 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2329803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329805 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329808 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329819 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329820 */   // GIR_Coverage, 45796,
     /* 2329820 */   GIR_EraseRootFromParent_Done,
     /* 2329821 */ // Label 32136: @2329821
     /* 2329821 */ GIM_Try, /*On fail goto*//*Label 32137*/ GIMT_Encode4(2329875), // Rule ID 45797 //
     /* 2329826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2329832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329840 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329840 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2329843 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329847 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2329857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329859 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329862 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329873 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329874 */   // GIR_Coverage, 45797,
     /* 2329874 */   GIR_EraseRootFromParent_Done,
     /* 2329875 */ // Label 32137: @2329875
     /* 2329875 */ GIM_Try, /*On fail goto*//*Label 32138*/ GIMT_Encode4(2329929), // Rule ID 58720 //
     /* 2329880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2329883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2329886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329894 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329894 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2329897 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329901 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2329911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329916 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329927 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329928 */   // GIR_Coverage, 58720,
     /* 2329928 */   GIR_EraseRootFromParent_Done,
     /* 2329929 */ // Label 32138: @2329929
     /* 2329929 */ GIM_Try, /*On fail goto*//*Label 32139*/ GIMT_Encode4(2329983), // Rule ID 58721 //
     /* 2329934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2329937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2329940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329948 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329948 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2329951 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329955 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2329965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329967 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329970 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329981 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329982 */   // GIR_Coverage, 58721,
     /* 2329982 */   GIR_EraseRootFromParent_Done,
     /* 2329983 */ // Label 32139: @2329983
     /* 2329983 */ GIM_Reject,
     /* 2329984 */ // Label 32095: @2329984
     /* 2329984 */ GIM_Try, /*On fail goto*//*Label 32140*/ GIMT_Encode4(2330038), // Rule ID 45804 //
     /* 2329989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2329995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330003 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2330006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2330020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330025 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330036 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330037 */   // GIR_Coverage, 45804,
     /* 2330037 */   GIR_EraseRootFromParent_Done,
     /* 2330038 */ // Label 32140: @2330038
     /* 2330038 */ GIM_Try, /*On fail goto*//*Label 32141*/ GIMT_Encode4(2330092), // Rule ID 45805 //
     /* 2330043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2330049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330057 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2330060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2330074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330076 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330079 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330090 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330091 */   // GIR_Coverage, 45805,
     /* 2330091 */   GIR_EraseRootFromParent_Done,
     /* 2330092 */ // Label 32141: @2330092
     /* 2330092 */ GIM_Try, /*On fail goto*//*Label 32142*/ GIMT_Encode4(2330146), // Rule ID 58288 //
     /* 2330097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2330100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2330103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330111 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2330114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2330128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330133 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330145 */   // GIR_Coverage, 58288,
     /* 2330145 */   GIR_EraseRootFromParent_Done,
     /* 2330146 */ // Label 32142: @2330146
     /* 2330146 */ GIM_Try, /*On fail goto*//*Label 32143*/ GIMT_Encode4(2330200), // Rule ID 58289 //
     /* 2330151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2330154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2330157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330165 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2330168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2330182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330187 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330199 */   // GIR_Coverage, 58289,
     /* 2330199 */   GIR_EraseRootFromParent_Done,
     /* 2330200 */ // Label 32143: @2330200
     /* 2330200 */ GIM_Try, /*On fail goto*//*Label 32144*/ GIMT_Encode4(2330254), // Rule ID 58740 //
     /* 2330205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2330208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2330211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330219 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330219 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2330222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330226 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2330236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330241 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330253 */   // GIR_Coverage, 58740,
     /* 2330253 */   GIR_EraseRootFromParent_Done,
     /* 2330254 */ // Label 32144: @2330254
     /* 2330254 */ GIM_Try, /*On fail goto*//*Label 32145*/ GIMT_Encode4(2330308), // Rule ID 58741 //
     /* 2330259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2330262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2330265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330273 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2330276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2330290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330295 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330306 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330307 */   // GIR_Coverage, 58741,
     /* 2330307 */   GIR_EraseRootFromParent_Done,
     /* 2330308 */ // Label 32145: @2330308
     /* 2330308 */ GIM_Reject,
     /* 2330309 */ // Label 32096: @2330309
     /* 2330309 */ GIM_Try, /*On fail goto*//*Label 32146*/ GIMT_Encode4(2330363), // Rule ID 58300 //
     /* 2330314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2330317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2330320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330328 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2330331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2330345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330350 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2330358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330361 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330362 */   // GIR_Coverage, 58300,
     /* 2330362 */   GIR_EraseRootFromParent_Done,
     /* 2330363 */ // Label 32146: @2330363
     /* 2330363 */ GIM_Try, /*On fail goto*//*Label 32147*/ GIMT_Encode4(2330417), // Rule ID 58301 //
     /* 2330368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2330371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2330374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330382 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2330385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2330399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330404 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2330412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330416 */   // GIR_Coverage, 58301,
     /* 2330416 */   GIR_EraseRootFromParent_Done,
     /* 2330417 */ // Label 32147: @2330417
     /* 2330417 */ GIM_Try, /*On fail goto*//*Label 32148*/ GIMT_Encode4(2330471), // Rule ID 58532 //
     /* 2330422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2330425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2330428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330436 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2330439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2330453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330458 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330470 */   // GIR_Coverage, 58532,
     /* 2330470 */   GIR_EraseRootFromParent_Done,
     /* 2330471 */ // Label 32148: @2330471
     /* 2330471 */ GIM_Try, /*On fail goto*//*Label 32149*/ GIMT_Encode4(2330525), // Rule ID 58533 //
     /* 2330476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2330479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2330482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330490 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2330493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2330507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330509 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330512 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330523 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330524 */   // GIR_Coverage, 58533,
     /* 2330524 */   GIR_EraseRootFromParent_Done,
     /* 2330525 */ // Label 32149: @2330525
     /* 2330525 */ GIM_Reject,
     /* 2330526 */ // Label 32097: @2330526
     /* 2330526 */ GIM_Try, /*On fail goto*//*Label 32150*/ GIMT_Encode4(2330629),
     /* 2330531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2330534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330542 */   GIM_Try, /*On fail goto*//*Label 32151*/ GIMT_Encode4(2330585), // Rule ID 58700 //
     /* 2330547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330550 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2330553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2330567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330584 */     // GIR_Coverage, 58700,
     /* 2330584 */     GIR_EraseRootFromParent_Done,
     /* 2330585 */   // Label 32151: @2330585
     /* 2330585 */   GIM_Try, /*On fail goto*//*Label 32152*/ GIMT_Encode4(2330628), // Rule ID 58701 //
     /* 2330590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330593 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2330596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2330610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330627 */     // GIR_Coverage, 58701,
     /* 2330627 */     GIR_EraseRootFromParent_Done,
     /* 2330628 */   // Label 32152: @2330628
     /* 2330628 */   GIM_Reject,
     /* 2330629 */ // Label 32150: @2330629
     /* 2330629 */ GIM_Reject,
     /* 2330630 */ // Label 32098: @2330630
     /* 2330630 */ GIM_Try, /*On fail goto*//*Label 32153*/ GIMT_Encode4(2330684), // Rule ID 58284 //
     /* 2330635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2330641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330649 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2330652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2330666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330671 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330682 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330683 */   // GIR_Coverage, 58284,
     /* 2330683 */   GIR_EraseRootFromParent_Done,
     /* 2330684 */ // Label 32153: @2330684
     /* 2330684 */ GIM_Try, /*On fail goto*//*Label 32154*/ GIMT_Encode4(2330738), // Rule ID 58285 //
     /* 2330689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2330695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330703 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2330706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2330720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330725 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330736 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330737 */   // GIR_Coverage, 58285,
     /* 2330737 */   GIR_EraseRootFromParent_Done,
     /* 2330738 */ // Label 32154: @2330738
     /* 2330738 */ GIM_Try, /*On fail goto*//*Label 32155*/ GIMT_Encode4(2330792), // Rule ID 58724 //
     /* 2330743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2330746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2330749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330757 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2330760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2330774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330779 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330791 */   // GIR_Coverage, 58724,
     /* 2330791 */   GIR_EraseRootFromParent_Done,
     /* 2330792 */ // Label 32155: @2330792
     /* 2330792 */ GIM_Try, /*On fail goto*//*Label 32156*/ GIMT_Encode4(2330846), // Rule ID 58725 //
     /* 2330797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2330800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2330803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330811 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2330814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2330828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330833 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330844 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330845 */   // GIR_Coverage, 58725,
     /* 2330845 */   GIR_EraseRootFromParent_Done,
     /* 2330846 */ // Label 32156: @2330846
     /* 2330846 */ GIM_Reject,
     /* 2330847 */ // Label 32099: @2330847
     /* 2330847 */ GIM_Try, /*On fail goto*//*Label 32157*/ GIMT_Encode4(2330901), // Rule ID 58296 //
     /* 2330852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2330855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2330858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330866 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330866 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2330869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330873 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2330883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330888 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330899 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330900 */   // GIR_Coverage, 58296,
     /* 2330900 */   GIR_EraseRootFromParent_Done,
     /* 2330901 */ // Label 32157: @2330901
     /* 2330901 */ GIM_Try, /*On fail goto*//*Label 32158*/ GIMT_Encode4(2330955), // Rule ID 58297 //
     /* 2330906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2330909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2330912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330920 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2330923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2330937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330939 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330942 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330953 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330954 */   // GIR_Coverage, 58297,
     /* 2330954 */   GIR_EraseRootFromParent_Done,
     /* 2330955 */ // Label 32158: @2330955
     /* 2330955 */ GIM_Try, /*On fail goto*//*Label 32159*/ GIMT_Encode4(2331009), // Rule ID 58516 //
     /* 2330960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2330966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330974 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2330977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2330991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330996 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331008 */   // GIR_Coverage, 58516,
     /* 2331008 */   GIR_EraseRootFromParent_Done,
     /* 2331009 */ // Label 32159: @2331009
     /* 2331009 */ GIM_Try, /*On fail goto*//*Label 32160*/ GIMT_Encode4(2331063), // Rule ID 58517 //
     /* 2331014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2331020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331028 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2331031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2331045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331050 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331061 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331062 */   // GIR_Coverage, 58517,
     /* 2331062 */   GIR_EraseRootFromParent_Done,
     /* 2331063 */ // Label 32160: @2331063
     /* 2331063 */ GIM_Try, /*On fail goto*//*Label 32161*/ GIMT_Encode4(2331117), // Rule ID 58744 //
     /* 2331068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2331071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2331074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331082 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2331085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2331099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331101 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331104 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331116 */   // GIR_Coverage, 58744,
     /* 2331116 */   GIR_EraseRootFromParent_Done,
     /* 2331117 */ // Label 32161: @2331117
     /* 2331117 */ GIM_Try, /*On fail goto*//*Label 32162*/ GIMT_Encode4(2331171), // Rule ID 58745 //
     /* 2331122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2331125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2331128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331136 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2331139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2331153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331158 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331170 */   // GIR_Coverage, 58745,
     /* 2331170 */   GIR_EraseRootFromParent_Done,
     /* 2331171 */ // Label 32162: @2331171
     /* 2331171 */ GIM_Reject,
     /* 2331172 */ // Label 32100: @2331172
     /* 2331172 */ GIM_Try, /*On fail goto*//*Label 32163*/ GIMT_Encode4(2331226), // Rule ID 58328 //
     /* 2331177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2331180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2331183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331191 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2331194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2331208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331213 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2331221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331224 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331225 */   // GIR_Coverage, 58328,
     /* 2331225 */   GIR_EraseRootFromParent_Done,
     /* 2331226 */ // Label 32163: @2331226
     /* 2331226 */ GIM_Try, /*On fail goto*//*Label 32164*/ GIMT_Encode4(2331280), // Rule ID 58329 //
     /* 2331231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2331234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2331237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331245 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331245 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2331248 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331252 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2331262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331267 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2331275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331278 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331279 */   // GIR_Coverage, 58329,
     /* 2331279 */   GIR_EraseRootFromParent_Done,
     /* 2331280 */ // Label 32164: @2331280
     /* 2331280 */ GIM_Try, /*On fail goto*//*Label 32165*/ GIMT_Encode4(2331334), // Rule ID 58536 //
     /* 2331285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2331288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2331291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331299 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331299 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2331302 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331306 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2331316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331321 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331332 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331333 */   // GIR_Coverage, 58536,
     /* 2331333 */   GIR_EraseRootFromParent_Done,
     /* 2331334 */ // Label 32165: @2331334
     /* 2331334 */ GIM_Try, /*On fail goto*//*Label 32166*/ GIMT_Encode4(2331388), // Rule ID 58537 //
     /* 2331339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2331342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2331345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331353 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331353 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2331356 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331360 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2331370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331375 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331386 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331387 */   // GIR_Coverage, 58537,
     /* 2331387 */   GIR_EraseRootFromParent_Done,
     /* 2331388 */ // Label 32166: @2331388
     /* 2331388 */ GIM_Reject,
     /* 2331389 */ // Label 32101: @2331389
     /* 2331389 */ GIM_Try, /*On fail goto*//*Label 32167*/ GIMT_Encode4(2331492),
     /* 2331394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2331397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331405 */   GIM_Try, /*On fail goto*//*Label 32168*/ GIMT_Encode4(2331448), // Rule ID 58704 //
     /* 2331410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331413 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2331416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2331430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331447 */     // GIR_Coverage, 58704,
     /* 2331447 */     GIR_EraseRootFromParent_Done,
     /* 2331448 */   // Label 32168: @2331448
     /* 2331448 */   GIM_Try, /*On fail goto*//*Label 32169*/ GIMT_Encode4(2331491), // Rule ID 58705 //
     /* 2331453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331456 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2331459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2331473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331490 */     // GIR_Coverage, 58705,
     /* 2331490 */     GIR_EraseRootFromParent_Done,
     /* 2331491 */   // Label 32169: @2331491
     /* 2331491 */   GIM_Reject,
     /* 2331492 */ // Label 32167: @2331492
     /* 2331492 */ GIM_Reject,
     /* 2331493 */ // Label 32102: @2331493
     /* 2331493 */ GIM_Try, /*On fail goto*//*Label 32170*/ GIMT_Encode4(2331547), // Rule ID 58292 //
     /* 2331498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2331504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331512 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2331515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2331529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331531 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331534 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331546 */   // GIR_Coverage, 58292,
     /* 2331546 */   GIR_EraseRootFromParent_Done,
     /* 2331547 */ // Label 32170: @2331547
     /* 2331547 */ GIM_Try, /*On fail goto*//*Label 32171*/ GIMT_Encode4(2331601), // Rule ID 58293 //
     /* 2331552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2331558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331566 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2331569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2331583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331588 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331599 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331600 */   // GIR_Coverage, 58293,
     /* 2331600 */   GIR_EraseRootFromParent_Done,
     /* 2331601 */ // Label 32171: @2331601
     /* 2331601 */ GIM_Try, /*On fail goto*//*Label 32172*/ GIMT_Encode4(2331655), // Rule ID 58728 //
     /* 2331606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2331609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2331612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331620 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2331623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2331637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331642 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331654 */   // GIR_Coverage, 58728,
     /* 2331654 */   GIR_EraseRootFromParent_Done,
     /* 2331655 */ // Label 32172: @2331655
     /* 2331655 */ GIM_Try, /*On fail goto*//*Label 32173*/ GIMT_Encode4(2331709), // Rule ID 58729 //
     /* 2331660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2331663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2331666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331674 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2331677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2331691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331696 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331708 */   // GIR_Coverage, 58729,
     /* 2331708 */   GIR_EraseRootFromParent_Done,
     /* 2331709 */ // Label 32173: @2331709
     /* 2331709 */ GIM_Reject,
     /* 2331710 */ // Label 32103: @2331710
     /* 2331710 */ GIM_Try, /*On fail goto*//*Label 32174*/ GIMT_Encode4(2331764), // Rule ID 58316 //
     /* 2331715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2331718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2331721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331729 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331729 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2331732 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331736 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331741 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2331746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331748 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331751 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331762 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331763 */   // GIR_Coverage, 58316,
     /* 2331763 */   GIR_EraseRootFromParent_Done,
     /* 2331764 */ // Label 32174: @2331764
     /* 2331764 */ GIM_Try, /*On fail goto*//*Label 32175*/ GIMT_Encode4(2331818), // Rule ID 58317 //
     /* 2331769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2331772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2331775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331783 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331783 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2331786 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331790 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2331800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331802 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331805 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331816 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331817 */   // GIR_Coverage, 58317,
     /* 2331817 */   GIR_EraseRootFromParent_Done,
     /* 2331818 */ // Label 32175: @2331818
     /* 2331818 */ GIM_Try, /*On fail goto*//*Label 32176*/ GIMT_Encode4(2331872), // Rule ID 58520 //
     /* 2331823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2331829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331837 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2331840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2331854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331856 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331859 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331871 */   // GIR_Coverage, 58520,
     /* 2331871 */   GIR_EraseRootFromParent_Done,
     /* 2331872 */ // Label 32176: @2331872
     /* 2331872 */ GIM_Try, /*On fail goto*//*Label 32177*/ GIMT_Encode4(2331926), // Rule ID 58521 //
     /* 2331877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2331883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331891 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2331894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331903 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2331908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331910 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331913 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331925 */   // GIR_Coverage, 58521,
     /* 2331925 */   GIR_EraseRootFromParent_Done,
     /* 2331926 */ // Label 32177: @2331926
     /* 2331926 */ GIM_Try, /*On fail goto*//*Label 32178*/ GIMT_Encode4(2331980), // Rule ID 58748 //
     /* 2331931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2331934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2331937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331945 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2331948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2331962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331967 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331978 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331979 */   // GIR_Coverage, 58748,
     /* 2331979 */   GIR_EraseRootFromParent_Done,
     /* 2331980 */ // Label 32178: @2331980
     /* 2331980 */ GIM_Try, /*On fail goto*//*Label 32179*/ GIMT_Encode4(2332034), // Rule ID 58749 //
     /* 2331985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2331988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2331991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331999 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2332002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2332016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332021 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332032 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332033 */   // GIR_Coverage, 58749,
     /* 2332033 */   GIR_EraseRootFromParent_Done,
     /* 2332034 */ // Label 32179: @2332034
     /* 2332034 */ GIM_Reject,
     /* 2332035 */ // Label 32104: @2332035
     /* 2332035 */ GIM_Try, /*On fail goto*//*Label 32180*/ GIMT_Encode4(2332089), // Rule ID 58332 //
     /* 2332040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2332043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2332046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332054 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2332057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2332071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332073 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332076 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2332084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332087 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332088 */   // GIR_Coverage, 58332,
     /* 2332088 */   GIR_EraseRootFromParent_Done,
     /* 2332089 */ // Label 32180: @2332089
     /* 2332089 */ GIM_Try, /*On fail goto*//*Label 32181*/ GIMT_Encode4(2332143), // Rule ID 58333 //
     /* 2332094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2332097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2332100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332108 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2332111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2332125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332130 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2332138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332141 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332142 */   // GIR_Coverage, 58333,
     /* 2332142 */   GIR_EraseRootFromParent_Done,
     /* 2332143 */ // Label 32181: @2332143
     /* 2332143 */ GIM_Try, /*On fail goto*//*Label 32182*/ GIMT_Encode4(2332197), // Rule ID 58540 //
     /* 2332148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2332151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2332154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332162 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2332165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332174 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2332179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332181 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332184 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332195 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332196 */   // GIR_Coverage, 58540,
     /* 2332196 */   GIR_EraseRootFromParent_Done,
     /* 2332197 */ // Label 32182: @2332197
     /* 2332197 */ GIM_Try, /*On fail goto*//*Label 32183*/ GIMT_Encode4(2332251), // Rule ID 58541 //
     /* 2332202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2332205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2332208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332216 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2332219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2332233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332235 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332238 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332249 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332250 */   // GIR_Coverage, 58541,
     /* 2332250 */   GIR_EraseRootFromParent_Done,
     /* 2332251 */ // Label 32183: @2332251
     /* 2332251 */ GIM_Reject,
     /* 2332252 */ // Label 32105: @2332252
     /* 2332252 */ GIM_Try, /*On fail goto*//*Label 32184*/ GIMT_Encode4(2332355),
     /* 2332257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2332260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332268 */   GIM_Try, /*On fail goto*//*Label 32185*/ GIMT_Encode4(2332311), // Rule ID 58708 //
     /* 2332273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2332276 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2332279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2332293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332310 */     // GIR_Coverage, 58708,
     /* 2332310 */     GIR_EraseRootFromParent_Done,
     /* 2332311 */   // Label 32185: @2332311
     /* 2332311 */   GIM_Try, /*On fail goto*//*Label 32186*/ GIMT_Encode4(2332354), // Rule ID 58709 //
     /* 2332316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2332319 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2332322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2332336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332353 */     // GIR_Coverage, 58709,
     /* 2332353 */     GIR_EraseRootFromParent_Done,
     /* 2332354 */   // Label 32186: @2332354
     /* 2332354 */   GIM_Reject,
     /* 2332355 */ // Label 32184: @2332355
     /* 2332355 */ GIM_Reject,
     /* 2332356 */ // Label 32106: @2332356
     /* 2332356 */ GIM_Try, /*On fail goto*//*Label 32187*/ GIMT_Encode4(2332410), // Rule ID 58304 //
     /* 2332361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2332364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2332367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332375 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332375 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2332378 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332382 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2332392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332394 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332397 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332408 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332409 */   // GIR_Coverage, 58304,
     /* 2332409 */   GIR_EraseRootFromParent_Done,
     /* 2332410 */ // Label 32187: @2332410
     /* 2332410 */ GIM_Try, /*On fail goto*//*Label 32188*/ GIMT_Encode4(2332464), // Rule ID 58305 //
     /* 2332415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2332418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2332421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332429 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2332432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2332446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332451 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332462 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332463 */   // GIR_Coverage, 58305,
     /* 2332463 */   GIR_EraseRootFromParent_Done,
     /* 2332464 */ // Label 32188: @2332464
     /* 2332464 */ GIM_Try, /*On fail goto*//*Label 32189*/ GIMT_Encode4(2332518), // Rule ID 58732 //
     /* 2332469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2332472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2332475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332483 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332483 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2332486 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332490 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2332500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332505 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332516 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332517 */   // GIR_Coverage, 58732,
     /* 2332517 */   GIR_EraseRootFromParent_Done,
     /* 2332518 */ // Label 32189: @2332518
     /* 2332518 */ GIM_Try, /*On fail goto*//*Label 32190*/ GIMT_Encode4(2332572), // Rule ID 58733 //
     /* 2332523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2332526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2332529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332537 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332537 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2332540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332544 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2332554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332556 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332559 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332570 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332571 */   // GIR_Coverage, 58733,
     /* 2332571 */   GIR_EraseRootFromParent_Done,
     /* 2332572 */ // Label 32190: @2332572
     /* 2332572 */ GIM_Reject,
     /* 2332573 */ // Label 32107: @2332573
     /* 2332573 */ GIM_Try, /*On fail goto*//*Label 32191*/ GIMT_Encode4(2332627), // Rule ID 58320 //
     /* 2332578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2332581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2332584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332592 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332592 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2332595 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332599 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332604 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2332609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332611 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332614 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332625 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332626 */   // GIR_Coverage, 58320,
     /* 2332626 */   GIR_EraseRootFromParent_Done,
     /* 2332627 */ // Label 32191: @2332627
     /* 2332627 */ GIM_Try, /*On fail goto*//*Label 32192*/ GIMT_Encode4(2332681), // Rule ID 58321 //
     /* 2332632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2332635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2332638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332646 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332646 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2332649 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332653 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2332663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332665 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332668 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332679 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332680 */   // GIR_Coverage, 58321,
     /* 2332680 */   GIR_EraseRootFromParent_Done,
     /* 2332681 */ // Label 32192: @2332681
     /* 2332681 */ GIM_Try, /*On fail goto*//*Label 32193*/ GIMT_Encode4(2332735), // Rule ID 58524 //
     /* 2332686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2332689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2332692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332700 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2332703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332712 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2332717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332722 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332733 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332734 */   // GIR_Coverage, 58524,
     /* 2332734 */   GIR_EraseRootFromParent_Done,
     /* 2332735 */ // Label 32193: @2332735
     /* 2332735 */ GIM_Try, /*On fail goto*//*Label 32194*/ GIMT_Encode4(2332789), // Rule ID 58525 //
     /* 2332740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2332743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2332746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332754 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332754 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2332757 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332761 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2332771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332776 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332787 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332788 */   // GIR_Coverage, 58525,
     /* 2332788 */   GIR_EraseRootFromParent_Done,
     /* 2332789 */ // Label 32194: @2332789
     /* 2332789 */ GIM_Try, /*On fail goto*//*Label 32195*/ GIMT_Encode4(2332843), // Rule ID 58752 //
     /* 2332794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2332797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2332800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2332808 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332808 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2332811 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332815 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2332825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332830 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332841 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332842 */   // GIR_Coverage, 58752,
     /* 2332842 */   GIR_EraseRootFromParent_Done,
     /* 2332843 */ // Label 32195: @2332843
     /* 2332843 */ GIM_Try, /*On fail goto*//*Label 32196*/ GIMT_Encode4(2332897), // Rule ID 58753 //
     /* 2332848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2332851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2332854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2332862 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332862 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2332865 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332869 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2332879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332881 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332884 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332896 */   // GIR_Coverage, 58753,
     /* 2332896 */   GIR_EraseRootFromParent_Done,
     /* 2332897 */ // Label 32196: @2332897
     /* 2332897 */ GIM_Reject,
     /* 2332898 */ // Label 32108: @2332898
     /* 2332898 */ GIM_Try, /*On fail goto*//*Label 32197*/ GIMT_Encode4(2332952), // Rule ID 58336 //
     /* 2332903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2332906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2332909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2332913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2332917 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332917 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2332920 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332924 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2332934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332936 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332939 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2332947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332950 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332951 */   // GIR_Coverage, 58336,
     /* 2332951 */   GIR_EraseRootFromParent_Done,
     /* 2332952 */ // Label 32197: @2332952
     /* 2332952 */ GIM_Try, /*On fail goto*//*Label 32198*/ GIMT_Encode4(2333006), // Rule ID 58337 //
     /* 2332957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2332960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2332963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2332967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2332971 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332971 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2332974 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332978 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2332988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332990 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332993 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2333001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333004 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333005 */   // GIR_Coverage, 58337,
     /* 2333005 */   GIR_EraseRootFromParent_Done,
     /* 2333006 */ // Label 32198: @2333006
     /* 2333006 */ GIM_Try, /*On fail goto*//*Label 32199*/ GIMT_Encode4(2333060), // Rule ID 58544 //
     /* 2333011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2333014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2333017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333025 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2333028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2333042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333047 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333058 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333059 */   // GIR_Coverage, 58544,
     /* 2333059 */   GIR_EraseRootFromParent_Done,
     /* 2333060 */ // Label 32199: @2333060
     /* 2333060 */ GIM_Try, /*On fail goto*//*Label 32200*/ GIMT_Encode4(2333114), // Rule ID 58545 //
     /* 2333065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2333068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2333071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333079 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333079 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2333082 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333086 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2333096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333098 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333101 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333112 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333113 */   // GIR_Coverage, 58545,
     /* 2333113 */   GIR_EraseRootFromParent_Done,
     /* 2333114 */ // Label 32200: @2333114
     /* 2333114 */ GIM_Reject,
     /* 2333115 */ // Label 32109: @2333115
     /* 2333115 */ GIM_Try, /*On fail goto*//*Label 32201*/ GIMT_Encode4(2333218),
     /* 2333120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2333123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333131 */   GIM_Try, /*On fail goto*//*Label 32202*/ GIMT_Encode4(2333174), // Rule ID 58712 //
     /* 2333136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333139 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2333142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2333156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333173 */     // GIR_Coverage, 58712,
     /* 2333173 */     GIR_EraseRootFromParent_Done,
     /* 2333174 */   // Label 32202: @2333174
     /* 2333174 */   GIM_Try, /*On fail goto*//*Label 32203*/ GIMT_Encode4(2333217), // Rule ID 58713 //
     /* 2333179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333182 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2333185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2333199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333216 */     // GIR_Coverage, 58713,
     /* 2333216 */     GIR_EraseRootFromParent_Done,
     /* 2333217 */   // Label 32203: @2333217
     /* 2333217 */   GIM_Reject,
     /* 2333218 */ // Label 32201: @2333218
     /* 2333218 */ GIM_Reject,
     /* 2333219 */ // Label 32110: @2333219
     /* 2333219 */ GIM_Try, /*On fail goto*//*Label 32204*/ GIMT_Encode4(2333273), // Rule ID 58308 //
     /* 2333224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2333230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333238 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2333241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2333255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333260 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333271 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333272 */   // GIR_Coverage, 58308,
     /* 2333272 */   GIR_EraseRootFromParent_Done,
     /* 2333273 */ // Label 32204: @2333273
     /* 2333273 */ GIM_Try, /*On fail goto*//*Label 32205*/ GIMT_Encode4(2333327), // Rule ID 58309 //
     /* 2333278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2333284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333292 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333292 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2333295 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333299 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2333309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333314 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333325 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333326 */   // GIR_Coverage, 58309,
     /* 2333326 */   GIR_EraseRootFromParent_Done,
     /* 2333327 */ // Label 32205: @2333327
     /* 2333327 */ GIM_Try, /*On fail goto*//*Label 32206*/ GIMT_Encode4(2333381), // Rule ID 58736 //
     /* 2333332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2333335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2333338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333346 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2333349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2333363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333368 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333379 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333380 */   // GIR_Coverage, 58736,
     /* 2333380 */   GIR_EraseRootFromParent_Done,
     /* 2333381 */ // Label 32206: @2333381
     /* 2333381 */ GIM_Try, /*On fail goto*//*Label 32207*/ GIMT_Encode4(2333435), // Rule ID 58737 //
     /* 2333386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2333389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2333392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333400 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333400 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2333403 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333407 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2333417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333419 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333422 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333433 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333434 */   // GIR_Coverage, 58737,
     /* 2333434 */   GIR_EraseRootFromParent_Done,
     /* 2333435 */ // Label 32207: @2333435
     /* 2333435 */ GIM_Reject,
     /* 2333436 */ // Label 32111: @2333436
     /* 2333436 */ GIM_Try, /*On fail goto*//*Label 32208*/ GIMT_Encode4(2333490), // Rule ID 58324 //
     /* 2333441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2333444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2333447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333455 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2333458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2333472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333474 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333477 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333488 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333489 */   // GIR_Coverage, 58324,
     /* 2333489 */   GIR_EraseRootFromParent_Done,
     /* 2333490 */ // Label 32208: @2333490
     /* 2333490 */ GIM_Try, /*On fail goto*//*Label 32209*/ GIMT_Encode4(2333544), // Rule ID 58325 //
     /* 2333495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2333498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2333501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333509 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333509 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2333512 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333516 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2333526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333531 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333542 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333543 */   // GIR_Coverage, 58325,
     /* 2333543 */   GIR_EraseRootFromParent_Done,
     /* 2333544 */ // Label 32209: @2333544
     /* 2333544 */ GIM_Try, /*On fail goto*//*Label 32210*/ GIMT_Encode4(2333598), // Rule ID 58528 //
     /* 2333549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2333555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333563 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333563 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2333566 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333570 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2333580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333582 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333585 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333596 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333597 */   // GIR_Coverage, 58528,
     /* 2333597 */   GIR_EraseRootFromParent_Done,
     /* 2333598 */ // Label 32210: @2333598
     /* 2333598 */ GIM_Try, /*On fail goto*//*Label 32211*/ GIMT_Encode4(2333652), // Rule ID 58529 //
     /* 2333603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2333609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333617 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333617 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2333620 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333624 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2333634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333639 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333650 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333651 */   // GIR_Coverage, 58529,
     /* 2333651 */   GIR_EraseRootFromParent_Done,
     /* 2333652 */ // Label 32211: @2333652
     /* 2333652 */ GIM_Reject,
     /* 2333653 */ // Label 32112: @2333653
     /* 2333653 */ GIM_Try, /*On fail goto*//*Label 32212*/ GIMT_Encode4(2333756),
     /* 2333658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2333661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333669 */   GIM_Try, /*On fail goto*//*Label 32213*/ GIMT_Encode4(2333712), // Rule ID 58716 //
     /* 2333674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333677 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2333680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2333694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333711 */     // GIR_Coverage, 58716,
     /* 2333711 */     GIR_EraseRootFromParent_Done,
     /* 2333712 */   // Label 32213: @2333712
     /* 2333712 */   GIM_Try, /*On fail goto*//*Label 32214*/ GIMT_Encode4(2333755), // Rule ID 58717 //
     /* 2333717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333720 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2333723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2333737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333754 */     // GIR_Coverage, 58717,
     /* 2333754 */     GIR_EraseRootFromParent_Done,
     /* 2333755 */   // Label 32214: @2333755
     /* 2333755 */   GIM_Reject,
     /* 2333756 */ // Label 32212: @2333756
     /* 2333756 */ GIM_Reject,
     /* 2333757 */ // Label 32113: @2333757
     /* 2333757 */ GIM_Try, /*On fail goto*//*Label 32215*/ GIMT_Encode4(2333860),
     /* 2333762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2333765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333773 */   GIM_Try, /*On fail goto*//*Label 32216*/ GIMT_Encode4(2333816), // Rule ID 58312 //
     /* 2333778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333781 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2333784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2333798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333815 */     // GIR_Coverage, 58312,
     /* 2333815 */     GIR_EraseRootFromParent_Done,
     /* 2333816 */   // Label 32216: @2333816
     /* 2333816 */   GIM_Try, /*On fail goto*//*Label 32217*/ GIMT_Encode4(2333859), // Rule ID 58313 //
     /* 2333821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333824 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2333827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2333841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333858 */     // GIR_Coverage, 58313,
     /* 2333858 */     GIR_EraseRootFromParent_Done,
     /* 2333859 */   // Label 32217: @2333859
     /* 2333859 */   GIM_Reject,
     /* 2333860 */ // Label 32215: @2333860
     /* 2333860 */ GIM_Reject,
     /* 2333861 */ // Label 32114: @2333861
     /* 2333861 */ GIM_Reject,
     /* 2333862 */ // Label 68: @2333862
     /* 2333862 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 32241*/ GIMT_Encode4(2338747),
     /* 2333873 */ /*GILLT_s32*//*Label 32218*/ GIMT_Encode4(2333989),
     /* 2333877 */ /*GILLT_s64*//*Label 32219*/ GIMT_Encode4(2334362), GIMT_Encode4(0),
     /* 2333885 */ /*GILLT_nxv1s8*//*Label 32220*/ GIMT_Encode4(2334549),
     /* 2333889 */ /*GILLT_nxv1s16*//*Label 32221*/ GIMT_Encode4(2334653),
     /* 2333893 */ /*GILLT_nxv1s32*//*Label 32222*/ GIMT_Encode4(2334870),
     /* 2333897 */ /*GILLT_nxv1s64*//*Label 32223*/ GIMT_Encode4(2335195), GIMT_Encode4(0),
     /* 2333905 */ /*GILLT_nxv2s8*//*Label 32224*/ GIMT_Encode4(2335412),
     /* 2333909 */ /*GILLT_nxv2s16*//*Label 32225*/ GIMT_Encode4(2335516),
     /* 2333913 */ /*GILLT_nxv2s32*//*Label 32226*/ GIMT_Encode4(2335733),
     /* 2333917 */ /*GILLT_nxv2s64*//*Label 32227*/ GIMT_Encode4(2336058), GIMT_Encode4(0),
     /* 2333925 */ /*GILLT_nxv4s8*//*Label 32228*/ GIMT_Encode4(2336275),
     /* 2333929 */ /*GILLT_nxv4s16*//*Label 32229*/ GIMT_Encode4(2336379),
     /* 2333933 */ /*GILLT_nxv4s32*//*Label 32230*/ GIMT_Encode4(2336596),
     /* 2333937 */ /*GILLT_nxv4s64*//*Label 32231*/ GIMT_Encode4(2336921), GIMT_Encode4(0),
     /* 2333945 */ /*GILLT_nxv8s8*//*Label 32232*/ GIMT_Encode4(2337138),
     /* 2333949 */ /*GILLT_nxv8s16*//*Label 32233*/ GIMT_Encode4(2337242),
     /* 2333953 */ /*GILLT_nxv8s32*//*Label 32234*/ GIMT_Encode4(2337459),
     /* 2333957 */ /*GILLT_nxv8s64*//*Label 32235*/ GIMT_Encode4(2337784), GIMT_Encode4(0),
     /* 2333965 */ /*GILLT_nxv16s8*//*Label 32236*/ GIMT_Encode4(2338001),
     /* 2333969 */ /*GILLT_nxv16s16*//*Label 32237*/ GIMT_Encode4(2338105),
     /* 2333973 */ /*GILLT_nxv16s32*//*Label 32238*/ GIMT_Encode4(2338322), GIMT_Encode4(0),
     /* 2333981 */ /*GILLT_nxv32s8*//*Label 32239*/ GIMT_Encode4(2338539),
     /* 2333985 */ /*GILLT_nxv32s16*//*Label 32240*/ GIMT_Encode4(2338643),
     /* 2333989 */ // Label 32218: @2333989
     /* 2333989 */ GIM_Try, /*On fail goto*//*Label 32242*/ GIMT_Encode4(2334020), // Rule ID 1450 //
     /* 2333994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2333997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2334000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334008 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2334008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2334011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334013 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334018 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334019 */   // GIR_Coverage, 1450,
     /* 2334019 */   GIR_EraseRootFromParent_Done,
     /* 2334020 */ // Label 32242: @2334020
     /* 2334020 */ GIM_Try, /*On fail goto*//*Label 32243*/ GIMT_Encode4(2334051), // Rule ID 1451 //
     /* 2334025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2334028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2334031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334039 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2334039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2334042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334044 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334049 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334050 */   // GIR_Coverage, 1451,
     /* 2334050 */   GIR_EraseRootFromParent_Done,
     /* 2334051 */ // Label 32243: @2334051
     /* 2334051 */ GIM_Try, /*On fail goto*//*Label 32244*/ GIMT_Encode4(2334082), // Rule ID 1476 //
     /* 2334056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2334059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2334062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334070 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2334070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2334073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334075 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334080 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334081 */   // GIR_Coverage, 1476,
     /* 2334081 */   GIR_EraseRootFromParent_Done,
     /* 2334082 */ // Label 32244: @2334082
     /* 2334082 */ GIM_Try, /*On fail goto*//*Label 32245*/ GIMT_Encode4(2334113), // Rule ID 1477 //
     /* 2334087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2334090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2334093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334101 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2334101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2334104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334106 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334111 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334112 */   // GIR_Coverage, 1477,
     /* 2334112 */   GIR_EraseRootFromParent_Done,
     /* 2334113 */ // Label 32245: @2334113
     /* 2334113 */ GIM_Try, /*On fail goto*//*Label 32246*/ GIMT_Encode4(2334144), // Rule ID 1844 //
     /* 2334118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2334121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2334124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2334132 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2334132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2334135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334137 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334142 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334143 */   // GIR_Coverage, 1844,
     /* 2334143 */   GIR_EraseRootFromParent_Done,
     /* 2334144 */ // Label 32246: @2334144
     /* 2334144 */ GIM_Try, /*On fail goto*//*Label 32247*/ GIMT_Encode4(2334175), // Rule ID 1845 //
     /* 2334149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2334152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2334155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2334163 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2334163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2334166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334168 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334174 */   // GIR_Coverage, 1845,
     /* 2334174 */   GIR_EraseRootFromParent_Done,
     /* 2334175 */ // Label 32247: @2334175
     /* 2334175 */ GIM_Try, /*On fail goto*//*Label 32248*/ GIMT_Encode4(2334206), // Rule ID 1870 //
     /* 2334180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2334183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2334186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2334194 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2334194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2334197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334199 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334204 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334205 */   // GIR_Coverage, 1870,
     /* 2334205 */   GIR_EraseRootFromParent_Done,
     /* 2334206 */ // Label 32248: @2334206
     /* 2334206 */ GIM_Try, /*On fail goto*//*Label 32249*/ GIMT_Encode4(2334237), // Rule ID 1871 //
     /* 2334211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2334214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2334217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2334225 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2334225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2334228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334230 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334235 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334236 */   // GIR_Coverage, 1871,
     /* 2334236 */   GIR_EraseRootFromParent_Done,
     /* 2334237 */ // Label 32249: @2334237
     /* 2334237 */ GIM_Try, /*On fail goto*//*Label 32250*/ GIMT_Encode4(2334268), // Rule ID 2186 //
     /* 2334242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2334245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2334248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2334256 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2334256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2334259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334261 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334266 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334267 */   // GIR_Coverage, 2186,
     /* 2334267 */   GIR_EraseRootFromParent_Done,
     /* 2334268 */ // Label 32250: @2334268
     /* 2334268 */ GIM_Try, /*On fail goto*//*Label 32251*/ GIMT_Encode4(2334299), // Rule ID 2187 //
     /* 2334273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2334276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2334279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2334287 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2334287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2334290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334292 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334297 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334298 */   // GIR_Coverage, 2187,
     /* 2334298 */   GIR_EraseRootFromParent_Done,
     /* 2334299 */ // Label 32251: @2334299
     /* 2334299 */ GIM_Try, /*On fail goto*//*Label 32252*/ GIMT_Encode4(2334330), // Rule ID 2212 //
     /* 2334304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2334307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2334310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2334318 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2334318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2334321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334323 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334328 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334329 */   // GIR_Coverage, 2212,
     /* 2334329 */   GIR_EraseRootFromParent_Done,
     /* 2334330 */ // Label 32252: @2334330
     /* 2334330 */ GIM_Try, /*On fail goto*//*Label 32253*/ GIMT_Encode4(2334361), // Rule ID 2213 //
     /* 2334335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2334338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2334341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2334349 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2334349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2334352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334354 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334359 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334360 */   // GIR_Coverage, 2213,
     /* 2334360 */   GIR_EraseRootFromParent_Done,
     /* 2334361 */ // Label 32253: @2334361
     /* 2334361 */ GIM_Reject,
     /* 2334362 */ // Label 32219: @2334362
     /* 2334362 */ GIM_Try, /*On fail goto*//*Label 32254*/ GIMT_Encode4(2334393), // Rule ID 1505 //
     /* 2334367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2334370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2334373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334381 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2334381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S),
     /* 2334384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334386 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334392 */   // GIR_Coverage, 1505,
     /* 2334392 */   GIR_EraseRootFromParent_Done,
     /* 2334393 */ // Label 32254: @2334393
     /* 2334393 */ GIM_Try, /*On fail goto*//*Label 32255*/ GIMT_Encode4(2334424), // Rule ID 1533 //
     /* 2334398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2334401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2334404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334412 */   // (fp_to_uint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2334412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S_INX),
     /* 2334415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334417 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334422 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334423 */   // GIR_Coverage, 1533,
     /* 2334423 */   GIR_EraseRootFromParent_Done,
     /* 2334424 */ // Label 32255: @2334424
     /* 2334424 */ GIM_Try, /*On fail goto*//*Label 32256*/ GIMT_Encode4(2334455), // Rule ID 1905 //
     /* 2334429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2334432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2334435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2334443 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2334443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D),
     /* 2334446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334448 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334454 */   // GIR_Coverage, 1905,
     /* 2334454 */   GIR_EraseRootFromParent_Done,
     /* 2334455 */ // Label 32256: @2334455
     /* 2334455 */ GIM_Try, /*On fail goto*//*Label 32257*/ GIMT_Encode4(2334486), // Rule ID 1933 //
     /* 2334460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2334463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2334466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334474 */   // (fp_to_uint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2334474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D_INX),
     /* 2334477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334479 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334484 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334485 */   // GIR_Coverage, 1933,
     /* 2334485 */   GIR_EraseRootFromParent_Done,
     /* 2334486 */ // Label 32257: @2334486
     /* 2334486 */ GIM_Try, /*On fail goto*//*Label 32258*/ GIMT_Encode4(2334517), // Rule ID 2239 //
     /* 2334491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2334494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2334497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2334505 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2334505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H),
     /* 2334508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334510 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334515 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334516 */   // GIR_Coverage, 2239,
     /* 2334516 */   GIR_EraseRootFromParent_Done,
     /* 2334517 */ // Label 32258: @2334517
     /* 2334517 */ GIM_Try, /*On fail goto*//*Label 32259*/ GIMT_Encode4(2334548), // Rule ID 2265 //
     /* 2334522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2334525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2334528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2334536 */   // (fp_to_uint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2334536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H_INX),
     /* 2334539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334541 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2334546 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334547 */   // GIR_Coverage, 2265,
     /* 2334547 */   GIR_EraseRootFromParent_Done,
     /* 2334548 */ // Label 32259: @2334548
     /* 2334548 */ GIM_Reject,
     /* 2334549 */ // Label 32220: @2334549
     /* 2334549 */ GIM_Try, /*On fail goto*//*Label 32260*/ GIMT_Encode4(2334652),
     /* 2334554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2334557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334565 */   GIM_Try, /*On fail goto*//*Label 32261*/ GIMT_Encode4(2334608), // Rule ID 58756 //
     /* 2334570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334573 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2334576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2334590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334607 */     // GIR_Coverage, 58756,
     /* 2334607 */     GIR_EraseRootFromParent_Done,
     /* 2334608 */   // Label 32261: @2334608
     /* 2334608 */   GIM_Try, /*On fail goto*//*Label 32262*/ GIMT_Encode4(2334651), // Rule ID 58757 //
     /* 2334613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334616 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2334619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2334633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334650 */     // GIR_Coverage, 58757,
     /* 2334650 */     GIR_EraseRootFromParent_Done,
     /* 2334651 */   // Label 32262: @2334651
     /* 2334651 */   GIM_Reject,
     /* 2334652 */ // Label 32260: @2334652
     /* 2334652 */ GIM_Reject,
     /* 2334653 */ // Label 32221: @2334653
     /* 2334653 */ GIM_Try, /*On fail goto*//*Label 32263*/ GIMT_Encode4(2334707), // Rule ID 58340 //
     /* 2334658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2334664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334672 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2334675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2334689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334691 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334694 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334705 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334706 */   // GIR_Coverage, 58340,
     /* 2334706 */   GIR_EraseRootFromParent_Done,
     /* 2334707 */ // Label 32263: @2334707
     /* 2334707 */ GIM_Try, /*On fail goto*//*Label 32264*/ GIMT_Encode4(2334761), // Rule ID 58341 //
     /* 2334712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2334718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334726 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334726 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2334729 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334733 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2334743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334745 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334748 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334759 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334760 */   // GIR_Coverage, 58341,
     /* 2334760 */   GIR_EraseRootFromParent_Done,
     /* 2334761 */ // Label 32264: @2334761
     /* 2334761 */ GIM_Try, /*On fail goto*//*Label 32265*/ GIMT_Encode4(2334815), // Rule ID 58780 //
     /* 2334766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2334769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2334772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334780 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334780 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2334783 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334787 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334792 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2334797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334799 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334802 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334813 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334814 */   // GIR_Coverage, 58780,
     /* 2334814 */   GIR_EraseRootFromParent_Done,
     /* 2334815 */ // Label 32265: @2334815
     /* 2334815 */ GIM_Try, /*On fail goto*//*Label 32266*/ GIMT_Encode4(2334869), // Rule ID 58781 //
     /* 2334820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2334823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2334826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334834 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334834 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2334837 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334841 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2334851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334856 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334867 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334868 */   // GIR_Coverage, 58781,
     /* 2334868 */   GIR_EraseRootFromParent_Done,
     /* 2334869 */ // Label 32266: @2334869
     /* 2334869 */ GIM_Reject,
     /* 2334870 */ // Label 32222: @2334870
     /* 2334870 */ GIM_Try, /*On fail goto*//*Label 32267*/ GIMT_Encode4(2334924), // Rule ID 58348 //
     /* 2334875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2334878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2334881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334889 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334889 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2334892 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334896 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2334906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334911 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334922 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334923 */   // GIR_Coverage, 58348,
     /* 2334923 */   GIR_EraseRootFromParent_Done,
     /* 2334924 */ // Label 32267: @2334924
     /* 2334924 */ GIM_Try, /*On fail goto*//*Label 32268*/ GIMT_Encode4(2334978), // Rule ID 58349 //
     /* 2334929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2334932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2334935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334943 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2334946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2334960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334965 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334976 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334977 */   // GIR_Coverage, 58349,
     /* 2334977 */   GIR_EraseRootFromParent_Done,
     /* 2334978 */ // Label 32268: @2334978
     /* 2334978 */ GIM_Try, /*On fail goto*//*Label 32269*/ GIMT_Encode4(2335032), // Rule ID 58548 //
     /* 2334983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2334989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334997 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2335000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2335014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335019 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335031 */   // GIR_Coverage, 58548,
     /* 2335031 */   GIR_EraseRootFromParent_Done,
     /* 2335032 */ // Label 32269: @2335032
     /* 2335032 */ GIM_Try, /*On fail goto*//*Label 32270*/ GIMT_Encode4(2335086), // Rule ID 58549 //
     /* 2335037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2335043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335051 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335051 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2335054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335058 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2335068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335073 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335084 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335085 */   // GIR_Coverage, 58549,
     /* 2335085 */   GIR_EraseRootFromParent_Done,
     /* 2335086 */ // Label 32270: @2335086
     /* 2335086 */ GIM_Try, /*On fail goto*//*Label 32271*/ GIMT_Encode4(2335140), // Rule ID 58800 //
     /* 2335091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2335094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2335097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335105 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2335108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2335122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335124 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335127 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335138 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335139 */   // GIR_Coverage, 58800,
     /* 2335139 */   GIR_EraseRootFromParent_Done,
     /* 2335140 */ // Label 32271: @2335140
     /* 2335140 */ GIM_Try, /*On fail goto*//*Label 32272*/ GIMT_Encode4(2335194), // Rule ID 58801 //
     /* 2335145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2335148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2335151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335159 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335159 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2335162 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335166 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2335176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335181 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335192 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335193 */   // GIR_Coverage, 58801,
     /* 2335193 */   GIR_EraseRootFromParent_Done,
     /* 2335194 */ // Label 32272: @2335194
     /* 2335194 */ GIM_Reject,
     /* 2335195 */ // Label 32223: @2335195
     /* 2335195 */ GIM_Try, /*On fail goto*//*Label 32273*/ GIMT_Encode4(2335249), // Rule ID 58360 //
     /* 2335200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2335203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2335206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335214 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2335217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2335231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335236 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2335244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335247 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335248 */   // GIR_Coverage, 58360,
     /* 2335248 */   GIR_EraseRootFromParent_Done,
     /* 2335249 */ // Label 32273: @2335249
     /* 2335249 */ GIM_Try, /*On fail goto*//*Label 32274*/ GIMT_Encode4(2335303), // Rule ID 58361 //
     /* 2335254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2335257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2335260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335268 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2335271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2335285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335290 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2335298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335301 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335302 */   // GIR_Coverage, 58361,
     /* 2335302 */   GIR_EraseRootFromParent_Done,
     /* 2335303 */ // Label 32274: @2335303
     /* 2335303 */ GIM_Try, /*On fail goto*//*Label 32275*/ GIMT_Encode4(2335357), // Rule ID 58568 //
     /* 2335308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2335311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2335314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335322 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2335325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2335339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335344 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335355 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335356 */   // GIR_Coverage, 58568,
     /* 2335356 */   GIR_EraseRootFromParent_Done,
     /* 2335357 */ // Label 32275: @2335357
     /* 2335357 */ GIM_Try, /*On fail goto*//*Label 32276*/ GIMT_Encode4(2335411), // Rule ID 58569 //
     /* 2335362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2335365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2335368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335376 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335376 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2335379 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335383 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2335393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335398 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335409 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335410 */   // GIR_Coverage, 58569,
     /* 2335410 */   GIR_EraseRootFromParent_Done,
     /* 2335411 */ // Label 32276: @2335411
     /* 2335411 */ GIM_Reject,
     /* 2335412 */ // Label 32224: @2335412
     /* 2335412 */ GIM_Try, /*On fail goto*//*Label 32277*/ GIMT_Encode4(2335515),
     /* 2335417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2335420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335428 */   GIM_Try, /*On fail goto*//*Label 32278*/ GIMT_Encode4(2335471), // Rule ID 58760 //
     /* 2335433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335436 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2335439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2335453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335470 */     // GIR_Coverage, 58760,
     /* 2335470 */     GIR_EraseRootFromParent_Done,
     /* 2335471 */   // Label 32278: @2335471
     /* 2335471 */   GIM_Try, /*On fail goto*//*Label 32279*/ GIMT_Encode4(2335514), // Rule ID 58761 //
     /* 2335476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335479 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2335482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2335496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335513 */     // GIR_Coverage, 58761,
     /* 2335513 */     GIR_EraseRootFromParent_Done,
     /* 2335514 */   // Label 32279: @2335514
     /* 2335514 */   GIM_Reject,
     /* 2335515 */ // Label 32277: @2335515
     /* 2335515 */ GIM_Reject,
     /* 2335516 */ // Label 32225: @2335516
     /* 2335516 */ GIM_Try, /*On fail goto*//*Label 32280*/ GIMT_Encode4(2335570), // Rule ID 58344 //
     /* 2335521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2335527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335535 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2335538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2335552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335557 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335568 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335569 */   // GIR_Coverage, 58344,
     /* 2335569 */   GIR_EraseRootFromParent_Done,
     /* 2335570 */ // Label 32280: @2335570
     /* 2335570 */ GIM_Try, /*On fail goto*//*Label 32281*/ GIMT_Encode4(2335624), // Rule ID 58345 //
     /* 2335575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2335581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335589 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2335592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2335606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335611 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335623 */   // GIR_Coverage, 58345,
     /* 2335623 */   GIR_EraseRootFromParent_Done,
     /* 2335624 */ // Label 32281: @2335624
     /* 2335624 */ GIM_Try, /*On fail goto*//*Label 32282*/ GIMT_Encode4(2335678), // Rule ID 58784 //
     /* 2335629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2335632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2335635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335643 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2335646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2335660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335665 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335676 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335677 */   // GIR_Coverage, 58784,
     /* 2335677 */   GIR_EraseRootFromParent_Done,
     /* 2335678 */ // Label 32282: @2335678
     /* 2335678 */ GIM_Try, /*On fail goto*//*Label 32283*/ GIMT_Encode4(2335732), // Rule ID 58785 //
     /* 2335683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2335686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2335689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335697 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2335700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2335714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335716 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335719 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335730 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335731 */   // GIR_Coverage, 58785,
     /* 2335731 */   GIR_EraseRootFromParent_Done,
     /* 2335732 */ // Label 32283: @2335732
     /* 2335732 */ GIM_Reject,
     /* 2335733 */ // Label 32226: @2335733
     /* 2335733 */ GIM_Try, /*On fail goto*//*Label 32284*/ GIMT_Encode4(2335787), // Rule ID 58356 //
     /* 2335738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2335741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2335744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335752 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335752 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2335755 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335759 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2335769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335774 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335785 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335786 */   // GIR_Coverage, 58356,
     /* 2335786 */   GIR_EraseRootFromParent_Done,
     /* 2335787 */ // Label 32284: @2335787
     /* 2335787 */ GIM_Try, /*On fail goto*//*Label 32285*/ GIMT_Encode4(2335841), // Rule ID 58357 //
     /* 2335792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2335795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2335798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335806 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335806 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2335809 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335813 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2335823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335825 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335828 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335839 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335840 */   // GIR_Coverage, 58357,
     /* 2335840 */   GIR_EraseRootFromParent_Done,
     /* 2335841 */ // Label 32285: @2335841
     /* 2335841 */ GIM_Try, /*On fail goto*//*Label 32286*/ GIMT_Encode4(2335895), // Rule ID 58552 //
     /* 2335846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2335852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335860 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2335863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2335877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335879 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335882 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335894 */   // GIR_Coverage, 58552,
     /* 2335894 */   GIR_EraseRootFromParent_Done,
     /* 2335895 */ // Label 32286: @2335895
     /* 2335895 */ GIM_Try, /*On fail goto*//*Label 32287*/ GIMT_Encode4(2335949), // Rule ID 58553 //
     /* 2335900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2335906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335914 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2335917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2335931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335936 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335947 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335948 */   // GIR_Coverage, 58553,
     /* 2335948 */   GIR_EraseRootFromParent_Done,
     /* 2335949 */ // Label 32287: @2335949
     /* 2335949 */ GIM_Try, /*On fail goto*//*Label 32288*/ GIMT_Encode4(2336003), // Rule ID 58804 //
     /* 2335954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2335957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2335960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335968 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2335971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2335985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335987 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335990 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336001 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336002 */   // GIR_Coverage, 58804,
     /* 2336002 */   GIR_EraseRootFromParent_Done,
     /* 2336003 */ // Label 32288: @2336003
     /* 2336003 */ GIM_Try, /*On fail goto*//*Label 32289*/ GIMT_Encode4(2336057), // Rule ID 58805 //
     /* 2336008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2336011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2336014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336022 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336022 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2336025 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336029 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2336039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336044 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336055 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336056 */   // GIR_Coverage, 58805,
     /* 2336056 */   GIR_EraseRootFromParent_Done,
     /* 2336057 */ // Label 32289: @2336057
     /* 2336057 */ GIM_Reject,
     /* 2336058 */ // Label 32227: @2336058
     /* 2336058 */ GIM_Try, /*On fail goto*//*Label 32290*/ GIMT_Encode4(2336112), // Rule ID 58388 //
     /* 2336063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2336066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2336069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336077 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2336080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2336094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336099 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336111 */   // GIR_Coverage, 58388,
     /* 2336111 */   GIR_EraseRootFromParent_Done,
     /* 2336112 */ // Label 32290: @2336112
     /* 2336112 */ GIM_Try, /*On fail goto*//*Label 32291*/ GIMT_Encode4(2336166), // Rule ID 58389 //
     /* 2336117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2336120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2336123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336131 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336131 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2336134 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336138 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2336148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336153 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336165 */   // GIR_Coverage, 58389,
     /* 2336165 */   GIR_EraseRootFromParent_Done,
     /* 2336166 */ // Label 32291: @2336166
     /* 2336166 */ GIM_Try, /*On fail goto*//*Label 32292*/ GIMT_Encode4(2336220), // Rule ID 58572 //
     /* 2336171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2336174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2336177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336185 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336185 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2336188 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336192 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2336202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336204 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336207 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336218 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336219 */   // GIR_Coverage, 58572,
     /* 2336219 */   GIR_EraseRootFromParent_Done,
     /* 2336220 */ // Label 32292: @2336220
     /* 2336220 */ GIM_Try, /*On fail goto*//*Label 32293*/ GIMT_Encode4(2336274), // Rule ID 58573 //
     /* 2336225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2336228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2336231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336239 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336239 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2336242 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336246 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2336256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336261 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336272 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336273 */   // GIR_Coverage, 58573,
     /* 2336273 */   GIR_EraseRootFromParent_Done,
     /* 2336274 */ // Label 32293: @2336274
     /* 2336274 */ GIM_Reject,
     /* 2336275 */ // Label 32228: @2336275
     /* 2336275 */ GIM_Try, /*On fail goto*//*Label 32294*/ GIMT_Encode4(2336378),
     /* 2336280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2336283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336291 */   GIM_Try, /*On fail goto*//*Label 32295*/ GIMT_Encode4(2336334), // Rule ID 58764 //
     /* 2336296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336299 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2336302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2336316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336333 */     // GIR_Coverage, 58764,
     /* 2336333 */     GIR_EraseRootFromParent_Done,
     /* 2336334 */   // Label 32295: @2336334
     /* 2336334 */   GIM_Try, /*On fail goto*//*Label 32296*/ GIMT_Encode4(2336377), // Rule ID 58765 //
     /* 2336339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336342 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2336345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2336359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336376 */     // GIR_Coverage, 58765,
     /* 2336376 */     GIR_EraseRootFromParent_Done,
     /* 2336377 */   // Label 32296: @2336377
     /* 2336377 */   GIM_Reject,
     /* 2336378 */ // Label 32294: @2336378
     /* 2336378 */ GIM_Reject,
     /* 2336379 */ // Label 32229: @2336379
     /* 2336379 */ GIM_Try, /*On fail goto*//*Label 32297*/ GIMT_Encode4(2336433), // Rule ID 58352 //
     /* 2336384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2336390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336398 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2336401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2336415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336420 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336431 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336432 */   // GIR_Coverage, 58352,
     /* 2336432 */   GIR_EraseRootFromParent_Done,
     /* 2336433 */ // Label 32297: @2336433
     /* 2336433 */ GIM_Try, /*On fail goto*//*Label 32298*/ GIMT_Encode4(2336487), // Rule ID 58353 //
     /* 2336438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2336444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336452 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2336455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2336469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336474 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336485 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336486 */   // GIR_Coverage, 58353,
     /* 2336486 */   GIR_EraseRootFromParent_Done,
     /* 2336487 */ // Label 32298: @2336487
     /* 2336487 */ GIM_Try, /*On fail goto*//*Label 32299*/ GIMT_Encode4(2336541), // Rule ID 58788 //
     /* 2336492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2336495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2336498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336506 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2336509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2336523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336528 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336539 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336540 */   // GIR_Coverage, 58788,
     /* 2336540 */   GIR_EraseRootFromParent_Done,
     /* 2336541 */ // Label 32299: @2336541
     /* 2336541 */ GIM_Try, /*On fail goto*//*Label 32300*/ GIMT_Encode4(2336595), // Rule ID 58789 //
     /* 2336546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2336549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2336552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336560 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2336563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2336577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336582 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336593 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336594 */   // GIR_Coverage, 58789,
     /* 2336594 */   GIR_EraseRootFromParent_Done,
     /* 2336595 */ // Label 32300: @2336595
     /* 2336595 */ GIM_Reject,
     /* 2336596 */ // Label 32230: @2336596
     /* 2336596 */ GIM_Try, /*On fail goto*//*Label 32301*/ GIMT_Encode4(2336650), // Rule ID 58376 //
     /* 2336601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2336604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2336607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336615 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336615 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2336618 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336622 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2336632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336637 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336648 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336649 */   // GIR_Coverage, 58376,
     /* 2336649 */   GIR_EraseRootFromParent_Done,
     /* 2336650 */ // Label 32301: @2336650
     /* 2336650 */ GIM_Try, /*On fail goto*//*Label 32302*/ GIMT_Encode4(2336704), // Rule ID 58377 //
     /* 2336655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2336658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2336661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336669 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2336672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2336686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336691 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336703 */   // GIR_Coverage, 58377,
     /* 2336703 */   GIR_EraseRootFromParent_Done,
     /* 2336704 */ // Label 32302: @2336704
     /* 2336704 */ GIM_Try, /*On fail goto*//*Label 32303*/ GIMT_Encode4(2336758), // Rule ID 58556 //
     /* 2336709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2336715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336723 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2336726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2336740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336745 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336756 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336757 */   // GIR_Coverage, 58556,
     /* 2336757 */   GIR_EraseRootFromParent_Done,
     /* 2336758 */ // Label 32303: @2336758
     /* 2336758 */ GIM_Try, /*On fail goto*//*Label 32304*/ GIMT_Encode4(2336812), // Rule ID 58557 //
     /* 2336763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2336769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336777 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336777 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2336780 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336784 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2336794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336796 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336799 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336811 */   // GIR_Coverage, 58557,
     /* 2336811 */   GIR_EraseRootFromParent_Done,
     /* 2336812 */ // Label 32304: @2336812
     /* 2336812 */ GIM_Try, /*On fail goto*//*Label 32305*/ GIMT_Encode4(2336866), // Rule ID 58808 //
     /* 2336817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2336820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2336823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336831 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2336834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2336848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336853 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336864 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336865 */   // GIR_Coverage, 58808,
     /* 2336865 */   GIR_EraseRootFromParent_Done,
     /* 2336866 */ // Label 32305: @2336866
     /* 2336866 */ GIM_Try, /*On fail goto*//*Label 32306*/ GIMT_Encode4(2336920), // Rule ID 58809 //
     /* 2336871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2336874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2336877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336885 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336885 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2336888 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336892 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2336902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336904 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336907 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336919 */   // GIR_Coverage, 58809,
     /* 2336919 */   GIR_EraseRootFromParent_Done,
     /* 2336920 */ // Label 32306: @2336920
     /* 2336920 */ GIM_Reject,
     /* 2336921 */ // Label 32231: @2336921
     /* 2336921 */ GIM_Try, /*On fail goto*//*Label 32307*/ GIMT_Encode4(2336975), // Rule ID 58392 //
     /* 2336926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2336929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2336932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336940 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2336943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2336957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336962 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336973 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336974 */   // GIR_Coverage, 58392,
     /* 2336974 */   GIR_EraseRootFromParent_Done,
     /* 2336975 */ // Label 32307: @2336975
     /* 2336975 */ GIM_Try, /*On fail goto*//*Label 32308*/ GIMT_Encode4(2337029), // Rule ID 58393 //
     /* 2336980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2336983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2336986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336994 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2336997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2337011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337013 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337016 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337027 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337028 */   // GIR_Coverage, 58393,
     /* 2337028 */   GIR_EraseRootFromParent_Done,
     /* 2337029 */ // Label 32308: @2337029
     /* 2337029 */ GIM_Try, /*On fail goto*//*Label 32309*/ GIMT_Encode4(2337083), // Rule ID 58576 //
     /* 2337034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2337037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2337040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337048 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337048 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2337051 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337055 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2337065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337070 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337081 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337082 */   // GIR_Coverage, 58576,
     /* 2337082 */   GIR_EraseRootFromParent_Done,
     /* 2337083 */ // Label 32309: @2337083
     /* 2337083 */ GIM_Try, /*On fail goto*//*Label 32310*/ GIMT_Encode4(2337137), // Rule ID 58577 //
     /* 2337088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2337091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2337094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337102 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2337105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337114 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2337119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337121 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337124 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337135 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337136 */   // GIR_Coverage, 58577,
     /* 2337136 */   GIR_EraseRootFromParent_Done,
     /* 2337137 */ // Label 32310: @2337137
     /* 2337137 */ GIM_Reject,
     /* 2337138 */ // Label 32232: @2337138
     /* 2337138 */ GIM_Try, /*On fail goto*//*Label 32311*/ GIMT_Encode4(2337241),
     /* 2337143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2337146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337154 */   GIM_Try, /*On fail goto*//*Label 32312*/ GIMT_Encode4(2337197), // Rule ID 58768 //
     /* 2337159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337162 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2337165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2337179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337196 */     // GIR_Coverage, 58768,
     /* 2337196 */     GIR_EraseRootFromParent_Done,
     /* 2337197 */   // Label 32312: @2337197
     /* 2337197 */   GIM_Try, /*On fail goto*//*Label 32313*/ GIMT_Encode4(2337240), // Rule ID 58769 //
     /* 2337202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337205 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2337208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2337222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337239 */     // GIR_Coverage, 58769,
     /* 2337239 */     GIR_EraseRootFromParent_Done,
     /* 2337240 */   // Label 32313: @2337240
     /* 2337240 */   GIM_Reject,
     /* 2337241 */ // Label 32311: @2337241
     /* 2337241 */ GIM_Reject,
     /* 2337242 */ // Label 32233: @2337242
     /* 2337242 */ GIM_Try, /*On fail goto*//*Label 32314*/ GIMT_Encode4(2337296), // Rule ID 58364 //
     /* 2337247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2337253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337261 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2337264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2337278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337283 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337294 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337295 */   // GIR_Coverage, 58364,
     /* 2337295 */   GIR_EraseRootFromParent_Done,
     /* 2337296 */ // Label 32314: @2337296
     /* 2337296 */ GIM_Try, /*On fail goto*//*Label 32315*/ GIMT_Encode4(2337350), // Rule ID 58365 //
     /* 2337301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2337307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337315 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337315 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2337318 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337322 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2337332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337337 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337349 */   // GIR_Coverage, 58365,
     /* 2337349 */   GIR_EraseRootFromParent_Done,
     /* 2337350 */ // Label 32315: @2337350
     /* 2337350 */ GIM_Try, /*On fail goto*//*Label 32316*/ GIMT_Encode4(2337404), // Rule ID 58792 //
     /* 2337355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2337358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2337361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337369 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2337372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2337386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337388 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337391 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337402 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337403 */   // GIR_Coverage, 58792,
     /* 2337403 */   GIR_EraseRootFromParent_Done,
     /* 2337404 */ // Label 32316: @2337404
     /* 2337404 */ GIM_Try, /*On fail goto*//*Label 32317*/ GIMT_Encode4(2337458), // Rule ID 58793 //
     /* 2337409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2337412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2337415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337423 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2337426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2337440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337445 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337456 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337457 */   // GIR_Coverage, 58793,
     /* 2337457 */   GIR_EraseRootFromParent_Done,
     /* 2337458 */ // Label 32317: @2337458
     /* 2337458 */ GIM_Reject,
     /* 2337459 */ // Label 32234: @2337459
     /* 2337459 */ GIM_Try, /*On fail goto*//*Label 32318*/ GIMT_Encode4(2337513), // Rule ID 58380 //
     /* 2337464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2337467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2337470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337478 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337478 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2337481 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337485 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2337495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337500 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337511 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337512 */   // GIR_Coverage, 58380,
     /* 2337512 */   GIR_EraseRootFromParent_Done,
     /* 2337513 */ // Label 32318: @2337513
     /* 2337513 */ GIM_Try, /*On fail goto*//*Label 32319*/ GIMT_Encode4(2337567), // Rule ID 58381 //
     /* 2337518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2337521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2337524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337532 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337532 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2337535 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337539 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2337549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337551 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337554 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337565 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337566 */   // GIR_Coverage, 58381,
     /* 2337566 */   GIR_EraseRootFromParent_Done,
     /* 2337567 */ // Label 32319: @2337567
     /* 2337567 */ GIM_Try, /*On fail goto*//*Label 32320*/ GIMT_Encode4(2337621), // Rule ID 58560 //
     /* 2337572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2337578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337586 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337586 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2337589 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337593 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2337603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337608 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337619 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337620 */   // GIR_Coverage, 58560,
     /* 2337620 */   GIR_EraseRootFromParent_Done,
     /* 2337621 */ // Label 32320: @2337621
     /* 2337621 */ GIM_Try, /*On fail goto*//*Label 32321*/ GIMT_Encode4(2337675), // Rule ID 58561 //
     /* 2337626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2337632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337640 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337640 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2337643 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337647 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2337657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337659 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337662 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337673 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337674 */   // GIR_Coverage, 58561,
     /* 2337674 */   GIR_EraseRootFromParent_Done,
     /* 2337675 */ // Label 32321: @2337675
     /* 2337675 */ GIM_Try, /*On fail goto*//*Label 32322*/ GIMT_Encode4(2337729), // Rule ID 58812 //
     /* 2337680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2337683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2337686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337694 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337694 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2337697 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337701 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337706 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2337711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337713 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337716 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337727 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337728 */   // GIR_Coverage, 58812,
     /* 2337728 */   GIR_EraseRootFromParent_Done,
     /* 2337729 */ // Label 32322: @2337729
     /* 2337729 */ GIM_Try, /*On fail goto*//*Label 32323*/ GIMT_Encode4(2337783), // Rule ID 58813 //
     /* 2337734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2337737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2337740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337748 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337748 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2337751 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337755 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2337765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337767 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337770 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337781 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337782 */   // GIR_Coverage, 58813,
     /* 2337782 */   GIR_EraseRootFromParent_Done,
     /* 2337783 */ // Label 32323: @2337783
     /* 2337783 */ GIM_Reject,
     /* 2337784 */ // Label 32235: @2337784
     /* 2337784 */ GIM_Try, /*On fail goto*//*Label 32324*/ GIMT_Encode4(2337838), // Rule ID 58396 //
     /* 2337789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2337792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2337795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337803 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337803 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2337806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337810 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2337820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337822 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337825 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337836 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337837 */   // GIR_Coverage, 58396,
     /* 2337837 */   GIR_EraseRootFromParent_Done,
     /* 2337838 */ // Label 32324: @2337838
     /* 2337838 */ GIM_Try, /*On fail goto*//*Label 32325*/ GIMT_Encode4(2337892), // Rule ID 58397 //
     /* 2337843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2337846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2337849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337857 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337857 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2337860 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337864 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2337874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337876 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337879 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337890 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337891 */   // GIR_Coverage, 58397,
     /* 2337891 */   GIR_EraseRootFromParent_Done,
     /* 2337892 */ // Label 32325: @2337892
     /* 2337892 */ GIM_Try, /*On fail goto*//*Label 32326*/ GIMT_Encode4(2337946), // Rule ID 58580 //
     /* 2337897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2337900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2337903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337911 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337911 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2337914 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337918 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2337928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337933 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337944 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337945 */   // GIR_Coverage, 58580,
     /* 2337945 */   GIR_EraseRootFromParent_Done,
     /* 2337946 */ // Label 32326: @2337946
     /* 2337946 */ GIM_Try, /*On fail goto*//*Label 32327*/ GIMT_Encode4(2338000), // Rule ID 58581 //
     /* 2337951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2337954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2337957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337965 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2337968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337977 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2337982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337984 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337987 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337999 */   // GIR_Coverage, 58581,
     /* 2337999 */   GIR_EraseRootFromParent_Done,
     /* 2338000 */ // Label 32327: @2338000
     /* 2338000 */ GIM_Reject,
     /* 2338001 */ // Label 32236: @2338001
     /* 2338001 */ GIM_Try, /*On fail goto*//*Label 32328*/ GIMT_Encode4(2338104),
     /* 2338006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2338009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338017 */   GIM_Try, /*On fail goto*//*Label 32329*/ GIMT_Encode4(2338060), // Rule ID 58772 //
     /* 2338022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338025 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2338028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2338042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338059 */     // GIR_Coverage, 58772,
     /* 2338059 */     GIR_EraseRootFromParent_Done,
     /* 2338060 */   // Label 32329: @2338060
     /* 2338060 */   GIM_Try, /*On fail goto*//*Label 32330*/ GIMT_Encode4(2338103), // Rule ID 58773 //
     /* 2338065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338068 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2338071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2338085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338102 */     // GIR_Coverage, 58773,
     /* 2338102 */     GIR_EraseRootFromParent_Done,
     /* 2338103 */   // Label 32330: @2338103
     /* 2338103 */   GIM_Reject,
     /* 2338104 */ // Label 32328: @2338104
     /* 2338104 */ GIM_Reject,
     /* 2338105 */ // Label 32237: @2338105
     /* 2338105 */ GIM_Try, /*On fail goto*//*Label 32331*/ GIMT_Encode4(2338159), // Rule ID 58368 //
     /* 2338110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2338116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338124 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2338127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2338141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338146 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338157 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338158 */   // GIR_Coverage, 58368,
     /* 2338158 */   GIR_EraseRootFromParent_Done,
     /* 2338159 */ // Label 32331: @2338159
     /* 2338159 */ GIM_Try, /*On fail goto*//*Label 32332*/ GIMT_Encode4(2338213), // Rule ID 58369 //
     /* 2338164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2338170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338178 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2338181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2338195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338200 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338211 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338212 */   // GIR_Coverage, 58369,
     /* 2338212 */   GIR_EraseRootFromParent_Done,
     /* 2338213 */ // Label 32332: @2338213
     /* 2338213 */ GIM_Try, /*On fail goto*//*Label 32333*/ GIMT_Encode4(2338267), // Rule ID 58796 //
     /* 2338218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2338221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2338224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338232 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338232 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2338235 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338239 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2338249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338254 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338265 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338266 */   // GIR_Coverage, 58796,
     /* 2338266 */   GIR_EraseRootFromParent_Done,
     /* 2338267 */ // Label 32333: @2338267
     /* 2338267 */ GIM_Try, /*On fail goto*//*Label 32334*/ GIMT_Encode4(2338321), // Rule ID 58797 //
     /* 2338272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2338275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2338278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338286 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2338289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2338303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338308 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338319 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338320 */   // GIR_Coverage, 58797,
     /* 2338320 */   GIR_EraseRootFromParent_Done,
     /* 2338321 */ // Label 32334: @2338321
     /* 2338321 */ GIM_Reject,
     /* 2338322 */ // Label 32238: @2338322
     /* 2338322 */ GIM_Try, /*On fail goto*//*Label 32335*/ GIMT_Encode4(2338376), // Rule ID 58384 //
     /* 2338327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2338330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2338333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338341 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338341 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2338344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338348 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2338358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338360 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338363 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338374 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338375 */   // GIR_Coverage, 58384,
     /* 2338375 */   GIR_EraseRootFromParent_Done,
     /* 2338376 */ // Label 32335: @2338376
     /* 2338376 */ GIM_Try, /*On fail goto*//*Label 32336*/ GIMT_Encode4(2338430), // Rule ID 58385 //
     /* 2338381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2338384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2338387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338395 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338395 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2338398 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338402 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2338412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338417 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338428 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338429 */   // GIR_Coverage, 58385,
     /* 2338429 */   GIR_EraseRootFromParent_Done,
     /* 2338430 */ // Label 32336: @2338430
     /* 2338430 */ GIM_Try, /*On fail goto*//*Label 32337*/ GIMT_Encode4(2338484), // Rule ID 58564 //
     /* 2338435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2338441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338449 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338449 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2338452 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338456 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2338466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338471 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338482 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338483 */   // GIR_Coverage, 58564,
     /* 2338483 */   GIR_EraseRootFromParent_Done,
     /* 2338484 */ // Label 32337: @2338484
     /* 2338484 */ GIM_Try, /*On fail goto*//*Label 32338*/ GIMT_Encode4(2338538), // Rule ID 58565 //
     /* 2338489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2338495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338503 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338503 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2338506 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338510 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2338520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338525 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338536 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338537 */   // GIR_Coverage, 58565,
     /* 2338537 */   GIR_EraseRootFromParent_Done,
     /* 2338538 */ // Label 32338: @2338538
     /* 2338538 */ GIM_Reject,
     /* 2338539 */ // Label 32239: @2338539
     /* 2338539 */ GIM_Try, /*On fail goto*//*Label 32339*/ GIMT_Encode4(2338642),
     /* 2338544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2338547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338555 */   GIM_Try, /*On fail goto*//*Label 32340*/ GIMT_Encode4(2338598), // Rule ID 58776 //
     /* 2338560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338563 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2338566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2338580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338597 */     // GIR_Coverage, 58776,
     /* 2338597 */     GIR_EraseRootFromParent_Done,
     /* 2338598 */   // Label 32340: @2338598
     /* 2338598 */   GIM_Try, /*On fail goto*//*Label 32341*/ GIMT_Encode4(2338641), // Rule ID 58777 //
     /* 2338603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338606 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2338609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2338623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338640 */     // GIR_Coverage, 58777,
     /* 2338640 */     GIR_EraseRootFromParent_Done,
     /* 2338641 */   // Label 32341: @2338641
     /* 2338641 */   GIM_Reject,
     /* 2338642 */ // Label 32339: @2338642
     /* 2338642 */ GIM_Reject,
     /* 2338643 */ // Label 32240: @2338643
     /* 2338643 */ GIM_Try, /*On fail goto*//*Label 32342*/ GIMT_Encode4(2338746),
     /* 2338648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2338651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338659 */   GIM_Try, /*On fail goto*//*Label 32343*/ GIMT_Encode4(2338702), // Rule ID 58372 //
     /* 2338664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338667 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2338670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2338684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338701 */     // GIR_Coverage, 58372,
     /* 2338701 */     GIR_EraseRootFromParent_Done,
     /* 2338702 */   // Label 32343: @2338702
     /* 2338702 */   GIM_Try, /*On fail goto*//*Label 32344*/ GIMT_Encode4(2338745), // Rule ID 58373 //
     /* 2338707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338710 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2338713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2338727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338744 */     // GIR_Coverage, 58373,
     /* 2338744 */     GIR_EraseRootFromParent_Done,
     /* 2338745 */   // Label 32344: @2338745
     /* 2338745 */   GIM_Reject,
     /* 2338746 */ // Label 32342: @2338746
     /* 2338746 */ GIM_Reject,
     /* 2338747 */ // Label 32241: @2338747
     /* 2338747 */ GIM_Reject,
     /* 2338748 */ // Label 69: @2338748
     /* 2338748 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32363*/ GIMT_Encode4(2344033),
     /* 2338759 */ /*GILLT_s16*//*Label 32345*/ GIMT_Encode4(2338879),
     /* 2338763 */ /*GILLT_s32*//*Label 32346*/ GIMT_Encode4(2339140),
     /* 2338767 */ /*GILLT_s64*//*Label 32347*/ GIMT_Encode4(2339401), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2338779 */ /*GILLT_nxv1s16*//*Label 32348*/ GIMT_Encode4(2339662),
     /* 2338783 */ /*GILLT_nxv1s32*//*Label 32349*/ GIMT_Encode4(2339999),
     /* 2338787 */ /*GILLT_nxv1s64*//*Label 32350*/ GIMT_Encode4(2340336), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2338799 */ /*GILLT_nxv2s16*//*Label 32351*/ GIMT_Encode4(2340559),
     /* 2338803 */ /*GILLT_nxv2s32*//*Label 32352*/ GIMT_Encode4(2340896),
     /* 2338807 */ /*GILLT_nxv2s64*//*Label 32353*/ GIMT_Encode4(2341233), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2338819 */ /*GILLT_nxv4s16*//*Label 32354*/ GIMT_Encode4(2341456),
     /* 2338823 */ /*GILLT_nxv4s32*//*Label 32355*/ GIMT_Encode4(2341793),
     /* 2338827 */ /*GILLT_nxv4s64*//*Label 32356*/ GIMT_Encode4(2342130), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2338839 */ /*GILLT_nxv8s16*//*Label 32357*/ GIMT_Encode4(2342353),
     /* 2338843 */ /*GILLT_nxv8s32*//*Label 32358*/ GIMT_Encode4(2342690),
     /* 2338847 */ /*GILLT_nxv8s64*//*Label 32359*/ GIMT_Encode4(2343027), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2338859 */ /*GILLT_nxv16s16*//*Label 32360*/ GIMT_Encode4(2343250),
     /* 2338863 */ /*GILLT_nxv16s32*//*Label 32361*/ GIMT_Encode4(2343587), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2338875 */ /*GILLT_nxv32s16*//*Label 32362*/ GIMT_Encode4(2343810),
     /* 2338879 */ // Label 32345: @2338879
     /* 2338879 */ GIM_Try, /*On fail goto*//*Label 32364*/ GIMT_Encode4(2338916), // Rule ID 2251 //
     /* 2338884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2338887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2338890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338894 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2338901 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2338901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2338904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2338911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338914 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338915 */   // GIR_Coverage, 2251,
     /* 2338915 */   GIR_EraseRootFromParent_Done,
     /* 2338916 */ // Label 32364: @2338916
     /* 2338916 */ GIM_Try, /*On fail goto*//*Label 32365*/ GIMT_Encode4(2338953), // Rule ID 2277 //
     /* 2338921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2338924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2338927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338931 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2338938 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2338938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2338941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2338948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338951 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338952 */   // GIR_Coverage, 2277,
     /* 2338952 */   GIR_EraseRootFromParent_Done,
     /* 2338953 */ // Label 32365: @2338953
     /* 2338953 */ GIM_Try, /*On fail goto*//*Label 32366*/ GIMT_Encode4(2338984), // Rule ID 2200 //
     /* 2338958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2338961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2338964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338972 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2338972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2338975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338977 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338982 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338983 */   // GIR_Coverage, 2200,
     /* 2338983 */   GIR_EraseRootFromParent_Done,
     /* 2338984 */ // Label 32366: @2338984
     /* 2338984 */ GIM_Try, /*On fail goto*//*Label 32367*/ GIMT_Encode4(2339015), // Rule ID 2201 //
     /* 2338989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2338992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2338995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339003 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2339003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2339006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339008 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339013 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339014 */   // GIR_Coverage, 2201,
     /* 2339014 */   GIR_EraseRootFromParent_Done,
     /* 2339015 */ // Label 32367: @2339015
     /* 2339015 */ GIM_Try, /*On fail goto*//*Label 32368*/ GIMT_Encode4(2339046), // Rule ID 2226 //
     /* 2339020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2339023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2339026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2339030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339034 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2339034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2339037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339039 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339044 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339045 */   // GIR_Coverage, 2226,
     /* 2339045 */   GIR_EraseRootFromParent_Done,
     /* 2339046 */ // Label 32368: @2339046
     /* 2339046 */ GIM_Try, /*On fail goto*//*Label 32369*/ GIMT_Encode4(2339077), // Rule ID 2227 //
     /* 2339051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2339054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2339057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2339061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339065 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2339065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2339068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339070 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339075 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339076 */   // GIR_Coverage, 2227,
     /* 2339076 */   GIR_EraseRootFromParent_Done,
     /* 2339077 */ // Label 32369: @2339077
     /* 2339077 */ GIM_Try, /*On fail goto*//*Label 32370*/ GIMT_Encode4(2339108), // Rule ID 2255 //
     /* 2339082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2339085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2339092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339096 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2339096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L),
     /* 2339099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339101 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339107 */   // GIR_Coverage, 2255,
     /* 2339107 */   GIR_EraseRootFromParent_Done,
     /* 2339108 */ // Label 32370: @2339108
     /* 2339108 */ GIM_Try, /*On fail goto*//*Label 32371*/ GIMT_Encode4(2339139), // Rule ID 2281 //
     /* 2339113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2339116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2339123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339127 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2339127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L_INX),
     /* 2339130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339132 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339137 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339138 */   // GIR_Coverage, 2281,
     /* 2339138 */   GIR_EraseRootFromParent_Done,
     /* 2339139 */ // Label 32371: @2339139
     /* 2339139 */ GIM_Reject,
     /* 2339140 */ // Label 32346: @2339140
     /* 2339140 */ GIM_Try, /*On fail goto*//*Label 32372*/ GIMT_Encode4(2339177), // Rule ID 1517 //
     /* 2339145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2339148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339155 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2339162 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2339162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2339165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2339172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339175 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339176 */   // GIR_Coverage, 1517,
     /* 2339176 */   GIR_EraseRootFromParent_Done,
     /* 2339177 */ // Label 32372: @2339177
     /* 2339177 */ GIM_Try, /*On fail goto*//*Label 32373*/ GIMT_Encode4(2339214), // Rule ID 1545 //
     /* 2339182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2339185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339192 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2339199 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2339199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2339202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2339209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339212 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339213 */   // GIR_Coverage, 1545,
     /* 2339213 */   GIR_EraseRootFromParent_Done,
     /* 2339214 */ // Label 32373: @2339214
     /* 2339214 */ GIM_Try, /*On fail goto*//*Label 32374*/ GIMT_Encode4(2339245), // Rule ID 1464 //
     /* 2339219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2339222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2339225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339233 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2339233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2339236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339238 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339243 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339244 */   // GIR_Coverage, 1464,
     /* 2339244 */   GIR_EraseRootFromParent_Done,
     /* 2339245 */ // Label 32374: @2339245
     /* 2339245 */ GIM_Try, /*On fail goto*//*Label 32375*/ GIMT_Encode4(2339276), // Rule ID 1465 //
     /* 2339250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2339253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2339256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339264 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2339264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2339267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339269 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339274 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339275 */   // GIR_Coverage, 1465,
     /* 2339275 */   GIR_EraseRootFromParent_Done,
     /* 2339276 */ // Label 32375: @2339276
     /* 2339276 */ GIM_Try, /*On fail goto*//*Label 32376*/ GIMT_Encode4(2339307), // Rule ID 1490 //
     /* 2339281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2339284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2339287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339295 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2339295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2339298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339300 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339305 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339306 */   // GIR_Coverage, 1490,
     /* 2339306 */   GIR_EraseRootFromParent_Done,
     /* 2339307 */ // Label 32376: @2339307
     /* 2339307 */ GIM_Try, /*On fail goto*//*Label 32377*/ GIMT_Encode4(2339338), // Rule ID 1491 //
     /* 2339312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2339315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2339318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339326 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2339326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2339329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339331 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339336 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339337 */   // GIR_Coverage, 1491,
     /* 2339337 */   GIR_EraseRootFromParent_Done,
     /* 2339338 */ // Label 32377: @2339338
     /* 2339338 */ GIM_Try, /*On fail goto*//*Label 32378*/ GIMT_Encode4(2339369), // Rule ID 1521 //
     /* 2339343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2339346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339357 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2339357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L),
     /* 2339360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339362 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339367 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339368 */   // GIR_Coverage, 1521,
     /* 2339368 */   GIR_EraseRootFromParent_Done,
     /* 2339369 */ // Label 32378: @2339369
     /* 2339369 */ GIM_Try, /*On fail goto*//*Label 32379*/ GIMT_Encode4(2339400), // Rule ID 1549 //
     /* 2339374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2339377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339388 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2339388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L_INX),
     /* 2339391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339393 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339398 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339399 */   // GIR_Coverage, 1549,
     /* 2339399 */   GIR_EraseRootFromParent_Done,
     /* 2339400 */ // Label 32379: @2339400
     /* 2339400 */ GIM_Reject,
     /* 2339401 */ // Label 32347: @2339401
     /* 2339401 */ GIM_Try, /*On fail goto*//*Label 32380*/ GIMT_Encode4(2339438), // Rule ID 1897 //
     /* 2339406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2339409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339416 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2339423 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2339423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2339426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2339433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2339436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339437 */   // GIR_Coverage, 1897,
     /* 2339437 */   GIR_EraseRootFromParent_Done,
     /* 2339438 */ // Label 32380: @2339438
     /* 2339438 */ GIM_Try, /*On fail goto*//*Label 32381*/ GIMT_Encode4(2339475), // Rule ID 1925 //
     /* 2339443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2339446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339453 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2339460 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2339460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_INX),
     /* 2339463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2339470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2339473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339474 */   // GIR_Coverage, 1925,
     /* 2339474 */   GIR_EraseRootFromParent_Done,
     /* 2339475 */ // Label 32381: @2339475
     /* 2339475 */ GIM_Try, /*On fail goto*//*Label 32382*/ GIMT_Encode4(2339506), // Rule ID 1858 //
     /* 2339480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2339483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2339486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339494 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2339494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2339497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339499 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2339504 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339505 */   // GIR_Coverage, 1858,
     /* 2339505 */   GIR_EraseRootFromParent_Done,
     /* 2339506 */ // Label 32382: @2339506
     /* 2339506 */ GIM_Try, /*On fail goto*//*Label 32383*/ GIMT_Encode4(2339537), // Rule ID 1859 //
     /* 2339511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2339514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2339517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339525 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2339525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2339528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339530 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2339535 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339536 */   // GIR_Coverage, 1859,
     /* 2339536 */   GIR_EraseRootFromParent_Done,
     /* 2339537 */ // Label 32383: @2339537
     /* 2339537 */ GIM_Try, /*On fail goto*//*Label 32384*/ GIMT_Encode4(2339568), // Rule ID 1884 //
     /* 2339542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2339545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2339548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339556 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2339556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2339559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339561 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2339566 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339567 */   // GIR_Coverage, 1884,
     /* 2339567 */   GIR_EraseRootFromParent_Done,
     /* 2339568 */ // Label 32384: @2339568
     /* 2339568 */ GIM_Try, /*On fail goto*//*Label 32385*/ GIMT_Encode4(2339599), // Rule ID 1885 //
     /* 2339573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2339576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2339579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339587 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2339587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2339590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339592 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2339597 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339598 */   // GIR_Coverage, 1885,
     /* 2339598 */   GIR_EraseRootFromParent_Done,
     /* 2339599 */ // Label 32385: @2339599
     /* 2339599 */ GIM_Try, /*On fail goto*//*Label 32386*/ GIMT_Encode4(2339630), // Rule ID 1915 //
     /* 2339604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2339607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339618 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2339618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L),
     /* 2339621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339623 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339628 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339629 */   // GIR_Coverage, 1915,
     /* 2339629 */   GIR_EraseRootFromParent_Done,
     /* 2339630 */ // Label 32386: @2339630
     /* 2339630 */ GIM_Try, /*On fail goto*//*Label 32387*/ GIMT_Encode4(2339661), // Rule ID 1943 //
     /* 2339635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2339638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339649 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2339649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L_INX),
     /* 2339652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339654 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339659 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339660 */   // GIR_Coverage, 1943,
     /* 2339660 */   GIR_EraseRootFromParent_Done,
     /* 2339661 */ // Label 32387: @2339661
     /* 2339661 */ GIM_Reject,
     /* 2339662 */ // Label 32348: @2339662
     /* 2339662 */ GIM_Try, /*On fail goto*//*Label 32388*/ GIMT_Encode4(2339719), // Rule ID 45792 //
     /* 2339667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2339673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339681 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2339684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2339698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339703 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339717 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339718 */   // GIR_Coverage, 45792,
     /* 2339718 */   GIR_EraseRootFromParent_Done,
     /* 2339719 */ // Label 32388: @2339719
     /* 2339719 */ GIM_Try, /*On fail goto*//*Label 32389*/ GIMT_Encode4(2339776), // Rule ID 45793 //
     /* 2339724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2339730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339738 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2339741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2339755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339760 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339774 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339775 */   // GIR_Coverage, 45793,
     /* 2339775 */   GIR_EraseRootFromParent_Done,
     /* 2339776 */ // Label 32389: @2339776
     /* 2339776 */ GIM_Try, /*On fail goto*//*Label 32390*/ GIMT_Encode4(2339830), // Rule ID 45800 //
     /* 2339781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2339787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339795 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339795 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2339798 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339802 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2339812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339814 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339817 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339829 */   // GIR_Coverage, 45800,
     /* 2339829 */   GIR_EraseRootFromParent_Done,
     /* 2339830 */ // Label 32390: @2339830
     /* 2339830 */ GIM_Try, /*On fail goto*//*Label 32391*/ GIMT_Encode4(2339884), // Rule ID 45801 //
     /* 2339835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2339841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339849 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2339852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2339866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339868 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339871 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339882 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339883 */   // GIR_Coverage, 45801,
     /* 2339883 */   GIR_EraseRootFromParent_Done,
     /* 2339884 */ // Label 32391: @2339884
     /* 2339884 */ GIM_Try, /*On fail goto*//*Label 32392*/ GIMT_Encode4(2339941), // Rule ID 45808 //
     /* 2339889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2339895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339903 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2339906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2339920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339922 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339925 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339939 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339940 */   // GIR_Coverage, 45808,
     /* 2339940 */   GIR_EraseRootFromParent_Done,
     /* 2339941 */ // Label 32392: @2339941
     /* 2339941 */ GIM_Try, /*On fail goto*//*Label 32393*/ GIMT_Encode4(2339998), // Rule ID 45809 //
     /* 2339946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2339952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339960 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2339963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2339977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339982 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339997 */   // GIR_Coverage, 45809,
     /* 2339997 */   GIR_EraseRootFromParent_Done,
     /* 2339998 */ // Label 32393: @2339998
     /* 2339998 */ GIM_Reject,
     /* 2339999 */ // Label 32349: @2339999
     /* 2339999 */ GIM_Try, /*On fail goto*//*Label 32394*/ GIMT_Encode4(2340056), // Rule ID 58404 //
     /* 2340004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2340007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2340010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340018 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2340021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2340035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340040 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340054 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340055 */   // GIR_Coverage, 58404,
     /* 2340055 */   GIR_EraseRootFromParent_Done,
     /* 2340056 */ // Label 32394: @2340056
     /* 2340056 */ GIM_Try, /*On fail goto*//*Label 32395*/ GIMT_Encode4(2340113), // Rule ID 58405 //
     /* 2340061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2340064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2340067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340075 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340075 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2340078 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340082 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2340092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340097 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340111 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340112 */   // GIR_Coverage, 58405,
     /* 2340112 */   GIR_EraseRootFromParent_Done,
     /* 2340113 */ // Label 32395: @2340113
     /* 2340113 */ GIM_Try, /*On fail goto*//*Label 32396*/ GIMT_Encode4(2340167), // Rule ID 58604 //
     /* 2340118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2340121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2340124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340132 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2340135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2340149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340151 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340154 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340166 */   // GIR_Coverage, 58604,
     /* 2340166 */   GIR_EraseRootFromParent_Done,
     /* 2340167 */ // Label 32396: @2340167
     /* 2340167 */ GIM_Try, /*On fail goto*//*Label 32397*/ GIMT_Encode4(2340221), // Rule ID 58605 //
     /* 2340172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2340175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2340178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340186 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340186 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2340189 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340193 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2340203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340205 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340208 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340219 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340220 */   // GIR_Coverage, 58605,
     /* 2340220 */   GIR_EraseRootFromParent_Done,
     /* 2340221 */ // Label 32397: @2340221
     /* 2340221 */ GIM_Try, /*On fail goto*//*Label 32398*/ GIMT_Encode4(2340278), // Rule ID 58832 //
     /* 2340226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2340229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2340232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340240 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340240 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2340243 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340247 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2340257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340259 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340262 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340276 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340277 */   // GIR_Coverage, 58832,
     /* 2340277 */   GIR_EraseRootFromParent_Done,
     /* 2340278 */ // Label 32398: @2340278
     /* 2340278 */ GIM_Try, /*On fail goto*//*Label 32399*/ GIMT_Encode4(2340335), // Rule ID 58833 //
     /* 2340283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2340286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2340289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340297 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340297 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2340300 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340304 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2340314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340319 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340333 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340334 */   // GIR_Coverage, 58833,
     /* 2340334 */   GIR_EraseRootFromParent_Done,
     /* 2340335 */ // Label 32399: @2340335
     /* 2340335 */ GIM_Reject,
     /* 2340336 */ // Label 32350: @2340336
     /* 2340336 */ GIM_Try, /*On fail goto*//*Label 32400*/ GIMT_Encode4(2340393), // Rule ID 58416 //
     /* 2340341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2340344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2340347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340355 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340355 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2340358 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340362 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2340372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340374 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340377 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340392 */   // GIR_Coverage, 58416,
     /* 2340392 */   GIR_EraseRootFromParent_Done,
     /* 2340393 */ // Label 32400: @2340393
     /* 2340393 */ GIM_Try, /*On fail goto*//*Label 32401*/ GIMT_Encode4(2340450), // Rule ID 58417 //
     /* 2340398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2340401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2340404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340412 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2340415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2340429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340431 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340434 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340448 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340449 */   // GIR_Coverage, 58417,
     /* 2340449 */   GIR_EraseRootFromParent_Done,
     /* 2340450 */ // Label 32401: @2340450
     /* 2340450 */ GIM_Try, /*On fail goto*//*Label 32402*/ GIMT_Encode4(2340504), // Rule ID 58624 //
     /* 2340455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2340458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2340461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340469 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2340472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2340486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340491 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340503 */   // GIR_Coverage, 58624,
     /* 2340503 */   GIR_EraseRootFromParent_Done,
     /* 2340504 */ // Label 32402: @2340504
     /* 2340504 */ GIM_Try, /*On fail goto*//*Label 32403*/ GIMT_Encode4(2340558), // Rule ID 58625 //
     /* 2340509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2340512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2340515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340523 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340523 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2340526 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340530 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2340540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340542 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340545 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340556 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340557 */   // GIR_Coverage, 58625,
     /* 2340557 */   GIR_EraseRootFromParent_Done,
     /* 2340558 */ // Label 32403: @2340558
     /* 2340558 */ GIM_Reject,
     /* 2340559 */ // Label 32351: @2340559
     /* 2340559 */ GIM_Try, /*On fail goto*//*Label 32404*/ GIMT_Encode4(2340616), // Rule ID 58400 //
     /* 2340564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2340570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340578 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340578 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2340581 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340585 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2340595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340600 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340614 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340615 */   // GIR_Coverage, 58400,
     /* 2340615 */   GIR_EraseRootFromParent_Done,
     /* 2340616 */ // Label 32404: @2340616
     /* 2340616 */ GIM_Try, /*On fail goto*//*Label 32405*/ GIMT_Encode4(2340673), // Rule ID 58401 //
     /* 2340621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2340627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340635 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340635 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2340638 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340642 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2340652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340657 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340671 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340672 */   // GIR_Coverage, 58401,
     /* 2340672 */   GIR_EraseRootFromParent_Done,
     /* 2340673 */ // Label 32405: @2340673
     /* 2340673 */ GIM_Try, /*On fail goto*//*Label 32406*/ GIMT_Encode4(2340727), // Rule ID 58584 //
     /* 2340678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2340684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340692 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340692 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2340695 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340699 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2340709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340711 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340714 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340725 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340726 */   // GIR_Coverage, 58584,
     /* 2340726 */   GIR_EraseRootFromParent_Done,
     /* 2340727 */ // Label 32406: @2340727
     /* 2340727 */ GIM_Try, /*On fail goto*//*Label 32407*/ GIMT_Encode4(2340781), // Rule ID 58585 //
     /* 2340732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2340738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340746 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2340749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2340763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340768 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340780 */   // GIR_Coverage, 58585,
     /* 2340780 */   GIR_EraseRootFromParent_Done,
     /* 2340781 */ // Label 32407: @2340781
     /* 2340781 */ GIM_Try, /*On fail goto*//*Label 32408*/ GIMT_Encode4(2340838), // Rule ID 58816 //
     /* 2340786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2340792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340800 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340800 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2340803 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340807 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2340817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340819 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340822 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340836 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340837 */   // GIR_Coverage, 58816,
     /* 2340837 */   GIR_EraseRootFromParent_Done,
     /* 2340838 */ // Label 32408: @2340838
     /* 2340838 */ GIM_Try, /*On fail goto*//*Label 32409*/ GIMT_Encode4(2340895), // Rule ID 58817 //
     /* 2340843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2340849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340857 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340857 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2340860 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340864 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2340874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340876 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340879 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340894 */   // GIR_Coverage, 58817,
     /* 2340894 */   GIR_EraseRootFromParent_Done,
     /* 2340895 */ // Label 32409: @2340895
     /* 2340895 */ GIM_Reject,
     /* 2340896 */ // Label 32352: @2340896
     /* 2340896 */ GIM_Try, /*On fail goto*//*Label 32410*/ GIMT_Encode4(2340953), // Rule ID 58412 //
     /* 2340901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2340904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2340907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340915 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2340918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2340932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340934 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340937 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340951 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340952 */   // GIR_Coverage, 58412,
     /* 2340952 */   GIR_EraseRootFromParent_Done,
     /* 2340953 */ // Label 32410: @2340953
     /* 2340953 */ GIM_Try, /*On fail goto*//*Label 32411*/ GIMT_Encode4(2341010), // Rule ID 58413 //
     /* 2340958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2340961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2340964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340972 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2340975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2340989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340994 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341008 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341009 */   // GIR_Coverage, 58413,
     /* 2341009 */   GIR_EraseRootFromParent_Done,
     /* 2341010 */ // Label 32411: @2341010
     /* 2341010 */ GIM_Try, /*On fail goto*//*Label 32412*/ GIMT_Encode4(2341064), // Rule ID 58608 //
     /* 2341015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2341018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2341021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341029 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341029 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2341032 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341036 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2341046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341048 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341051 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341062 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341063 */   // GIR_Coverage, 58608,
     /* 2341063 */   GIR_EraseRootFromParent_Done,
     /* 2341064 */ // Label 32412: @2341064
     /* 2341064 */ GIM_Try, /*On fail goto*//*Label 32413*/ GIMT_Encode4(2341118), // Rule ID 58609 //
     /* 2341069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2341072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2341075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341083 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341083 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2341086 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341090 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2341100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341102 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341105 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341116 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341117 */   // GIR_Coverage, 58609,
     /* 2341117 */   GIR_EraseRootFromParent_Done,
     /* 2341118 */ // Label 32413: @2341118
     /* 2341118 */ GIM_Try, /*On fail goto*//*Label 32414*/ GIMT_Encode4(2341175), // Rule ID 58836 //
     /* 2341123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2341126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2341129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341137 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341137 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2341140 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341144 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2341154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341156 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341159 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341174 */   // GIR_Coverage, 58836,
     /* 2341174 */   GIR_EraseRootFromParent_Done,
     /* 2341175 */ // Label 32414: @2341175
     /* 2341175 */ GIM_Try, /*On fail goto*//*Label 32415*/ GIMT_Encode4(2341232), // Rule ID 58837 //
     /* 2341180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2341183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2341186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341194 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341194 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2341197 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341201 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2341211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341213 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341216 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341230 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341231 */   // GIR_Coverage, 58837,
     /* 2341231 */   GIR_EraseRootFromParent_Done,
     /* 2341232 */ // Label 32415: @2341232
     /* 2341232 */ GIM_Reject,
     /* 2341233 */ // Label 32353: @2341233
     /* 2341233 */ GIM_Try, /*On fail goto*//*Label 32416*/ GIMT_Encode4(2341290), // Rule ID 58444 //
     /* 2341238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2341241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2341244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341252 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2341255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2341269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341274 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341288 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341289 */   // GIR_Coverage, 58444,
     /* 2341289 */   GIR_EraseRootFromParent_Done,
     /* 2341290 */ // Label 32416: @2341290
     /* 2341290 */ GIM_Try, /*On fail goto*//*Label 32417*/ GIMT_Encode4(2341347), // Rule ID 58445 //
     /* 2341295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2341298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2341301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341309 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2341312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2341326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341331 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341345 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341346 */   // GIR_Coverage, 58445,
     /* 2341346 */   GIR_EraseRootFromParent_Done,
     /* 2341347 */ // Label 32417: @2341347
     /* 2341347 */ GIM_Try, /*On fail goto*//*Label 32418*/ GIMT_Encode4(2341401), // Rule ID 58628 //
     /* 2341352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2341355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2341358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341366 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341366 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2341369 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341373 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2341383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341385 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341388 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341399 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341400 */   // GIR_Coverage, 58628,
     /* 2341400 */   GIR_EraseRootFromParent_Done,
     /* 2341401 */ // Label 32418: @2341401
     /* 2341401 */ GIM_Try, /*On fail goto*//*Label 32419*/ GIMT_Encode4(2341455), // Rule ID 58629 //
     /* 2341406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2341409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2341412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341420 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2341423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2341437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341442 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341454 */   // GIR_Coverage, 58629,
     /* 2341454 */   GIR_EraseRootFromParent_Done,
     /* 2341455 */ // Label 32419: @2341455
     /* 2341455 */ GIM_Reject,
     /* 2341456 */ // Label 32354: @2341456
     /* 2341456 */ GIM_Try, /*On fail goto*//*Label 32420*/ GIMT_Encode4(2341513), // Rule ID 58408 //
     /* 2341461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2341467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341475 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341475 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2341478 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341482 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341487 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2341492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341494 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341497 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341511 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341512 */   // GIR_Coverage, 58408,
     /* 2341512 */   GIR_EraseRootFromParent_Done,
     /* 2341513 */ // Label 32420: @2341513
     /* 2341513 */ GIM_Try, /*On fail goto*//*Label 32421*/ GIMT_Encode4(2341570), // Rule ID 58409 //
     /* 2341518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2341524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341532 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341532 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2341535 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341539 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2341549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341551 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341554 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341568 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341569 */   // GIR_Coverage, 58409,
     /* 2341569 */   GIR_EraseRootFromParent_Done,
     /* 2341570 */ // Label 32421: @2341570
     /* 2341570 */ GIM_Try, /*On fail goto*//*Label 32422*/ GIMT_Encode4(2341624), // Rule ID 58588 //
     /* 2341575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2341581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341589 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2341592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2341606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341611 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341623 */   // GIR_Coverage, 58588,
     /* 2341623 */   GIR_EraseRootFromParent_Done,
     /* 2341624 */ // Label 32422: @2341624
     /* 2341624 */ GIM_Try, /*On fail goto*//*Label 32423*/ GIMT_Encode4(2341678), // Rule ID 58589 //
     /* 2341629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2341635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341643 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2341646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2341660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341665 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341676 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341677 */   // GIR_Coverage, 58589,
     /* 2341677 */   GIR_EraseRootFromParent_Done,
     /* 2341678 */ // Label 32423: @2341678
     /* 2341678 */ GIM_Try, /*On fail goto*//*Label 32424*/ GIMT_Encode4(2341735), // Rule ID 58820 //
     /* 2341683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2341689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341697 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2341700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2341714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341716 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341719 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341733 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341734 */   // GIR_Coverage, 58820,
     /* 2341734 */   GIR_EraseRootFromParent_Done,
     /* 2341735 */ // Label 32424: @2341735
     /* 2341735 */ GIM_Try, /*On fail goto*//*Label 32425*/ GIMT_Encode4(2341792), // Rule ID 58821 //
     /* 2341740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2341746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341754 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341754 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2341757 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341761 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2341771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341776 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341791 */   // GIR_Coverage, 58821,
     /* 2341791 */   GIR_EraseRootFromParent_Done,
     /* 2341792 */ // Label 32425: @2341792
     /* 2341792 */ GIM_Reject,
     /* 2341793 */ // Label 32355: @2341793
     /* 2341793 */ GIM_Try, /*On fail goto*//*Label 32426*/ GIMT_Encode4(2341850), // Rule ID 58432 //
     /* 2341798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2341801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2341804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341812 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341812 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2341815 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341819 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2341829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341831 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341834 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341848 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341849 */   // GIR_Coverage, 58432,
     /* 2341849 */   GIR_EraseRootFromParent_Done,
     /* 2341850 */ // Label 32426: @2341850
     /* 2341850 */ GIM_Try, /*On fail goto*//*Label 32427*/ GIMT_Encode4(2341907), // Rule ID 58433 //
     /* 2341855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2341858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2341861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341869 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2341872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2341886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341891 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341905 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341906 */   // GIR_Coverage, 58433,
     /* 2341906 */   GIR_EraseRootFromParent_Done,
     /* 2341907 */ // Label 32427: @2341907
     /* 2341907 */ GIM_Try, /*On fail goto*//*Label 32428*/ GIMT_Encode4(2341961), // Rule ID 58612 //
     /* 2341912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2341915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2341918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341926 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2341929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2341943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341945 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341948 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341959 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341960 */   // GIR_Coverage, 58612,
     /* 2341960 */   GIR_EraseRootFromParent_Done,
     /* 2341961 */ // Label 32428: @2341961
     /* 2341961 */ GIM_Try, /*On fail goto*//*Label 32429*/ GIMT_Encode4(2342015), // Rule ID 58613 //
     /* 2341966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2341969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2341972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341980 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341980 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2341983 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341987 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2341997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341999 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342002 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342013 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342014 */   // GIR_Coverage, 58613,
     /* 2342014 */   GIR_EraseRootFromParent_Done,
     /* 2342015 */ // Label 32429: @2342015
     /* 2342015 */ GIM_Try, /*On fail goto*//*Label 32430*/ GIMT_Encode4(2342072), // Rule ID 58840 //
     /* 2342020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2342023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2342026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342034 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342034 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2342037 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342041 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2342051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342053 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342056 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342070 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342071 */   // GIR_Coverage, 58840,
     /* 2342071 */   GIR_EraseRootFromParent_Done,
     /* 2342072 */ // Label 32430: @2342072
     /* 2342072 */ GIM_Try, /*On fail goto*//*Label 32431*/ GIMT_Encode4(2342129), // Rule ID 58841 //
     /* 2342077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2342080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2342083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342091 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342091 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2342094 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342098 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2342108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342113 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342127 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342128 */   // GIR_Coverage, 58841,
     /* 2342128 */   GIR_EraseRootFromParent_Done,
     /* 2342129 */ // Label 32431: @2342129
     /* 2342129 */ GIM_Reject,
     /* 2342130 */ // Label 32356: @2342130
     /* 2342130 */ GIM_Try, /*On fail goto*//*Label 32432*/ GIMT_Encode4(2342187), // Rule ID 58448 //
     /* 2342135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2342138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2342141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342149 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342149 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2342152 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342156 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2342166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342171 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2342182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342185 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342186 */   // GIR_Coverage, 58448,
     /* 2342186 */   GIR_EraseRootFromParent_Done,
     /* 2342187 */ // Label 32432: @2342187
     /* 2342187 */ GIM_Try, /*On fail goto*//*Label 32433*/ GIMT_Encode4(2342244), // Rule ID 58449 //
     /* 2342192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2342195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2342198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342206 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342206 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2342209 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342213 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2342223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342228 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2342239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342242 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342243 */   // GIR_Coverage, 58449,
     /* 2342243 */   GIR_EraseRootFromParent_Done,
     /* 2342244 */ // Label 32433: @2342244
     /* 2342244 */ GIM_Try, /*On fail goto*//*Label 32434*/ GIMT_Encode4(2342298), // Rule ID 58632 //
     /* 2342249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2342252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2342255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342263 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2342266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2342280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342282 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342285 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342296 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342297 */   // GIR_Coverage, 58632,
     /* 2342297 */   GIR_EraseRootFromParent_Done,
     /* 2342298 */ // Label 32434: @2342298
     /* 2342298 */ GIM_Try, /*On fail goto*//*Label 32435*/ GIMT_Encode4(2342352), // Rule ID 58633 //
     /* 2342303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2342306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2342309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342317 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342317 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2342320 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342324 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2342334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342336 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342339 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342350 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342351 */   // GIR_Coverage, 58633,
     /* 2342351 */   GIR_EraseRootFromParent_Done,
     /* 2342352 */ // Label 32435: @2342352
     /* 2342352 */ GIM_Reject,
     /* 2342353 */ // Label 32357: @2342353
     /* 2342353 */ GIM_Try, /*On fail goto*//*Label 32436*/ GIMT_Encode4(2342410), // Rule ID 58420 //
     /* 2342358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2342364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342372 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342372 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2342375 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342379 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2342389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342394 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342408 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342409 */   // GIR_Coverage, 58420,
     /* 2342409 */   GIR_EraseRootFromParent_Done,
     /* 2342410 */ // Label 32436: @2342410
     /* 2342410 */ GIM_Try, /*On fail goto*//*Label 32437*/ GIMT_Encode4(2342467), // Rule ID 58421 //
     /* 2342415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2342418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2342421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342429 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2342432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2342446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342451 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342465 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342466 */   // GIR_Coverage, 58421,
     /* 2342466 */   GIR_EraseRootFromParent_Done,
     /* 2342467 */ // Label 32437: @2342467
     /* 2342467 */ GIM_Try, /*On fail goto*//*Label 32438*/ GIMT_Encode4(2342521), // Rule ID 58592 //
     /* 2342472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2342478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342486 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2342489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2342503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342508 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342519 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342520 */   // GIR_Coverage, 58592,
     /* 2342520 */   GIR_EraseRootFromParent_Done,
     /* 2342521 */ // Label 32438: @2342521
     /* 2342521 */ GIM_Try, /*On fail goto*//*Label 32439*/ GIMT_Encode4(2342575), // Rule ID 58593 //
     /* 2342526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2342529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2342532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342540 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2342543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2342557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342559 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342562 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342573 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342574 */   // GIR_Coverage, 58593,
     /* 2342574 */   GIR_EraseRootFromParent_Done,
     /* 2342575 */ // Label 32439: @2342575
     /* 2342575 */ GIM_Try, /*On fail goto*//*Label 32440*/ GIMT_Encode4(2342632), // Rule ID 58824 //
     /* 2342580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2342586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342594 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2342597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2342611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342616 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342630 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342631 */   // GIR_Coverage, 58824,
     /* 2342631 */   GIR_EraseRootFromParent_Done,
     /* 2342632 */ // Label 32440: @2342632
     /* 2342632 */ GIM_Try, /*On fail goto*//*Label 32441*/ GIMT_Encode4(2342689), // Rule ID 58825 //
     /* 2342637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2342640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2342643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342651 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2342654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2342668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342670 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342673 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342687 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342688 */   // GIR_Coverage, 58825,
     /* 2342688 */   GIR_EraseRootFromParent_Done,
     /* 2342689 */ // Label 32441: @2342689
     /* 2342689 */ GIM_Reject,
     /* 2342690 */ // Label 32358: @2342690
     /* 2342690 */ GIM_Try, /*On fail goto*//*Label 32442*/ GIMT_Encode4(2342747), // Rule ID 58436 //
     /* 2342695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2342698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2342701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342709 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342709 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2342712 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342716 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2342726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342731 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342745 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342746 */   // GIR_Coverage, 58436,
     /* 2342746 */   GIR_EraseRootFromParent_Done,
     /* 2342747 */ // Label 32442: @2342747
     /* 2342747 */ GIM_Try, /*On fail goto*//*Label 32443*/ GIMT_Encode4(2342804), // Rule ID 58437 //
     /* 2342752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2342755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2342758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342766 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2342769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2342783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342788 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342802 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342803 */   // GIR_Coverage, 58437,
     /* 2342803 */   GIR_EraseRootFromParent_Done,
     /* 2342804 */ // Label 32443: @2342804
     /* 2342804 */ GIM_Try, /*On fail goto*//*Label 32444*/ GIMT_Encode4(2342858), // Rule ID 58616 //
     /* 2342809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2342812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2342815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342823 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2342826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2342840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342845 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342856 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342857 */   // GIR_Coverage, 58616,
     /* 2342857 */   GIR_EraseRootFromParent_Done,
     /* 2342858 */ // Label 32444: @2342858
     /* 2342858 */ GIM_Try, /*On fail goto*//*Label 32445*/ GIMT_Encode4(2342912), // Rule ID 58617 //
     /* 2342863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2342866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2342869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342877 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2342880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2342894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342899 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342910 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342911 */   // GIR_Coverage, 58617,
     /* 2342911 */   GIR_EraseRootFromParent_Done,
     /* 2342912 */ // Label 32445: @2342912
     /* 2342912 */ GIM_Try, /*On fail goto*//*Label 32446*/ GIMT_Encode4(2342969), // Rule ID 58844 //
     /* 2342917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2342920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2342923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342931 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342931 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2342934 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342938 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2342948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342950 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342953 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342967 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342968 */   // GIR_Coverage, 58844,
     /* 2342968 */   GIR_EraseRootFromParent_Done,
     /* 2342969 */ // Label 32446: @2342969
     /* 2342969 */ GIM_Try, /*On fail goto*//*Label 32447*/ GIMT_Encode4(2343026), // Rule ID 58845 //
     /* 2342974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2342977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2342980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342988 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2342991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2343005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343007 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343010 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343024 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343025 */   // GIR_Coverage, 58845,
     /* 2343025 */   GIR_EraseRootFromParent_Done,
     /* 2343026 */ // Label 32447: @2343026
     /* 2343026 */ GIM_Reject,
     /* 2343027 */ // Label 32359: @2343027
     /* 2343027 */ GIM_Try, /*On fail goto*//*Label 32448*/ GIMT_Encode4(2343084), // Rule ID 58452 //
     /* 2343032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2343035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2343038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343046 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2343049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2343063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343068 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2343079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343083 */   // GIR_Coverage, 58452,
     /* 2343083 */   GIR_EraseRootFromParent_Done,
     /* 2343084 */ // Label 32448: @2343084
     /* 2343084 */ GIM_Try, /*On fail goto*//*Label 32449*/ GIMT_Encode4(2343141), // Rule ID 58453 //
     /* 2343089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2343092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2343095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343103 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343103 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2343106 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343110 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2343120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343125 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2343136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343139 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343140 */   // GIR_Coverage, 58453,
     /* 2343140 */   GIR_EraseRootFromParent_Done,
     /* 2343141 */ // Label 32449: @2343141
     /* 2343141 */ GIM_Try, /*On fail goto*//*Label 32450*/ GIMT_Encode4(2343195), // Rule ID 58636 //
     /* 2343146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2343149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2343152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343160 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2343163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2343177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343182 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343193 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343194 */   // GIR_Coverage, 58636,
     /* 2343194 */   GIR_EraseRootFromParent_Done,
     /* 2343195 */ // Label 32450: @2343195
     /* 2343195 */ GIM_Try, /*On fail goto*//*Label 32451*/ GIMT_Encode4(2343249), // Rule ID 58637 //
     /* 2343200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2343203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2343206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343214 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2343217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2343231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343236 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343247 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343248 */   // GIR_Coverage, 58637,
     /* 2343248 */   GIR_EraseRootFromParent_Done,
     /* 2343249 */ // Label 32451: @2343249
     /* 2343249 */ GIM_Reject,
     /* 2343250 */ // Label 32360: @2343250
     /* 2343250 */ GIM_Try, /*On fail goto*//*Label 32452*/ GIMT_Encode4(2343307), // Rule ID 58424 //
     /* 2343255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2343261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343269 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2343272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2343286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343291 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343305 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343306 */   // GIR_Coverage, 58424,
     /* 2343306 */   GIR_EraseRootFromParent_Done,
     /* 2343307 */ // Label 32452: @2343307
     /* 2343307 */ GIM_Try, /*On fail goto*//*Label 32453*/ GIMT_Encode4(2343364), // Rule ID 58425 //
     /* 2343312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2343318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343326 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343326 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2343329 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343333 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2343343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343345 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343348 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343362 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343363 */   // GIR_Coverage, 58425,
     /* 2343363 */   GIR_EraseRootFromParent_Done,
     /* 2343364 */ // Label 32453: @2343364
     /* 2343364 */ GIM_Try, /*On fail goto*//*Label 32454*/ GIMT_Encode4(2343418), // Rule ID 58596 //
     /* 2343369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2343375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2343383 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2343386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2343400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343405 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343416 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343417 */   // GIR_Coverage, 58596,
     /* 2343417 */   GIR_EraseRootFromParent_Done,
     /* 2343418 */ // Label 32454: @2343418
     /* 2343418 */ GIM_Try, /*On fail goto*//*Label 32455*/ GIMT_Encode4(2343472), // Rule ID 58597 //
     /* 2343423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2343429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2343437 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343437 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2343440 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343444 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2343454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343459 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343470 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343471 */   // GIR_Coverage, 58597,
     /* 2343471 */   GIR_EraseRootFromParent_Done,
     /* 2343472 */ // Label 32455: @2343472
     /* 2343472 */ GIM_Try, /*On fail goto*//*Label 32456*/ GIMT_Encode4(2343529), // Rule ID 58828 //
     /* 2343477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2343483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343491 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343491 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2343494 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343498 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2343508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343510 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343513 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343527 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343528 */   // GIR_Coverage, 58828,
     /* 2343528 */   GIR_EraseRootFromParent_Done,
     /* 2343529 */ // Label 32456: @2343529
     /* 2343529 */ GIM_Try, /*On fail goto*//*Label 32457*/ GIMT_Encode4(2343586), // Rule ID 58829 //
     /* 2343534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2343540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343548 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2343551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2343565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343570 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343584 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343585 */   // GIR_Coverage, 58829,
     /* 2343585 */   GIR_EraseRootFromParent_Done,
     /* 2343586 */ // Label 32457: @2343586
     /* 2343586 */ GIM_Reject,
     /* 2343587 */ // Label 32361: @2343587
     /* 2343587 */ GIM_Try, /*On fail goto*//*Label 32458*/ GIMT_Encode4(2343644), // Rule ID 58440 //
     /* 2343592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2343595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2343598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343606 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2343609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2343623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343628 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343642 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343643 */   // GIR_Coverage, 58440,
     /* 2343643 */   GIR_EraseRootFromParent_Done,
     /* 2343644 */ // Label 32458: @2343644
     /* 2343644 */ GIM_Try, /*On fail goto*//*Label 32459*/ GIMT_Encode4(2343701), // Rule ID 58441 //
     /* 2343649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2343652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2343655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343663 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2343666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2343680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343685 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343699 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343700 */   // GIR_Coverage, 58441,
     /* 2343700 */   GIR_EraseRootFromParent_Done,
     /* 2343701 */ // Label 32459: @2343701
     /* 2343701 */ GIM_Try, /*On fail goto*//*Label 32460*/ GIMT_Encode4(2343755), // Rule ID 58620 //
     /* 2343706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2343709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2343712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343720 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343720 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2343723 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343727 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2343737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343739 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343742 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343753 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343754 */   // GIR_Coverage, 58620,
     /* 2343754 */   GIR_EraseRootFromParent_Done,
     /* 2343755 */ // Label 32460: @2343755
     /* 2343755 */ GIM_Try, /*On fail goto*//*Label 32461*/ GIMT_Encode4(2343809), // Rule ID 58621 //
     /* 2343760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2343763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2343766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343774 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2343777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2343791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343796 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343807 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343808 */   // GIR_Coverage, 58621,
     /* 2343808 */   GIR_EraseRootFromParent_Done,
     /* 2343809 */ // Label 32461: @2343809
     /* 2343809 */ GIM_Reject,
     /* 2343810 */ // Label 32362: @2343810
     /* 2343810 */ GIM_Try, /*On fail goto*//*Label 32462*/ GIMT_Encode4(2343867), // Rule ID 58428 //
     /* 2343815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2343821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343829 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343829 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2343832 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343836 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2343846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343851 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343865 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343866 */   // GIR_Coverage, 58428,
     /* 2343866 */   GIR_EraseRootFromParent_Done,
     /* 2343867 */ // Label 32462: @2343867
     /* 2343867 */ GIM_Try, /*On fail goto*//*Label 32463*/ GIMT_Encode4(2343924), // Rule ID 58429 //
     /* 2343872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2343878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343886 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2343889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2343903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343908 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343922 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343923 */   // GIR_Coverage, 58429,
     /* 2343923 */   GIR_EraseRootFromParent_Done,
     /* 2343924 */ // Label 32463: @2343924
     /* 2343924 */ GIM_Try, /*On fail goto*//*Label 32464*/ GIMT_Encode4(2343978), // Rule ID 58600 //
     /* 2343929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2343935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343943 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2343946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2343960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343965 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343976 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343977 */   // GIR_Coverage, 58600,
     /* 2343977 */   GIR_EraseRootFromParent_Done,
     /* 2343978 */ // Label 32464: @2343978
     /* 2343978 */ GIM_Try, /*On fail goto*//*Label 32465*/ GIMT_Encode4(2344032), // Rule ID 58601 //
     /* 2343983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2343989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343997 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2344000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2344014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344019 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344031 */   // GIR_Coverage, 58601,
     /* 2344031 */   GIR_EraseRootFromParent_Done,
     /* 2344032 */ // Label 32465: @2344032
     /* 2344032 */ GIM_Reject,
     /* 2344033 */ // Label 32363: @2344033
     /* 2344033 */ GIM_Reject,
     /* 2344034 */ // Label 70: @2344034
     /* 2344034 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32484*/ GIMT_Encode4(2349319),
     /* 2344045 */ /*GILLT_s16*//*Label 32466*/ GIMT_Encode4(2344165),
     /* 2344049 */ /*GILLT_s32*//*Label 32467*/ GIMT_Encode4(2344426),
     /* 2344053 */ /*GILLT_s64*//*Label 32468*/ GIMT_Encode4(2344687), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344065 */ /*GILLT_nxv1s16*//*Label 32469*/ GIMT_Encode4(2344948),
     /* 2344069 */ /*GILLT_nxv1s32*//*Label 32470*/ GIMT_Encode4(2345285),
     /* 2344073 */ /*GILLT_nxv1s64*//*Label 32471*/ GIMT_Encode4(2345622), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344085 */ /*GILLT_nxv2s16*//*Label 32472*/ GIMT_Encode4(2345845),
     /* 2344089 */ /*GILLT_nxv2s32*//*Label 32473*/ GIMT_Encode4(2346182),
     /* 2344093 */ /*GILLT_nxv2s64*//*Label 32474*/ GIMT_Encode4(2346519), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344105 */ /*GILLT_nxv4s16*//*Label 32475*/ GIMT_Encode4(2346742),
     /* 2344109 */ /*GILLT_nxv4s32*//*Label 32476*/ GIMT_Encode4(2347079),
     /* 2344113 */ /*GILLT_nxv4s64*//*Label 32477*/ GIMT_Encode4(2347416), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344125 */ /*GILLT_nxv8s16*//*Label 32478*/ GIMT_Encode4(2347639),
     /* 2344129 */ /*GILLT_nxv8s32*//*Label 32479*/ GIMT_Encode4(2347976),
     /* 2344133 */ /*GILLT_nxv8s64*//*Label 32480*/ GIMT_Encode4(2348313), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344145 */ /*GILLT_nxv16s16*//*Label 32481*/ GIMT_Encode4(2348536),
     /* 2344149 */ /*GILLT_nxv16s32*//*Label 32482*/ GIMT_Encode4(2348873), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344161 */ /*GILLT_nxv32s16*//*Label 32483*/ GIMT_Encode4(2349096),
     /* 2344165 */ // Label 32466: @2344165
     /* 2344165 */ GIM_Try, /*On fail goto*//*Label 32485*/ GIMT_Encode4(2344202), // Rule ID 2253 //
     /* 2344170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2344173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2344180 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2344187 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2344187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2344190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2344197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344200 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344201 */   // GIR_Coverage, 2253,
     /* 2344201 */   GIR_EraseRootFromParent_Done,
     /* 2344202 */ // Label 32485: @2344202
     /* 2344202 */ GIM_Try, /*On fail goto*//*Label 32486*/ GIMT_Encode4(2344239), // Rule ID 2279 //
     /* 2344207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2344210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2344217 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2344224 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2344224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2344227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2344234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344237 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344238 */   // GIR_Coverage, 2279,
     /* 2344238 */   GIR_EraseRootFromParent_Done,
     /* 2344239 */ // Label 32486: @2344239
     /* 2344239 */ GIM_Try, /*On fail goto*//*Label 32487*/ GIMT_Encode4(2344270), // Rule ID 2204 //
     /* 2344244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2344247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2344254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344258 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2344258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2344261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344263 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344268 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344269 */   // GIR_Coverage, 2204,
     /* 2344269 */   GIR_EraseRootFromParent_Done,
     /* 2344270 */ // Label 32487: @2344270
     /* 2344270 */ GIM_Try, /*On fail goto*//*Label 32488*/ GIMT_Encode4(2344301), // Rule ID 2205 //
     /* 2344275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2344278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2344285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344289 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2344289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2344292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344294 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344300 */   // GIR_Coverage, 2205,
     /* 2344300 */   GIR_EraseRootFromParent_Done,
     /* 2344301 */ // Label 32488: @2344301
     /* 2344301 */ GIM_Try, /*On fail goto*//*Label 32489*/ GIMT_Encode4(2344332), // Rule ID 2230 //
     /* 2344306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2344309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2344316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344320 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2344320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2344323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344325 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344330 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344331 */   // GIR_Coverage, 2230,
     /* 2344331 */   GIR_EraseRootFromParent_Done,
     /* 2344332 */ // Label 32489: @2344332
     /* 2344332 */ GIM_Try, /*On fail goto*//*Label 32490*/ GIMT_Encode4(2344363), // Rule ID 2231 //
     /* 2344337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2344340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2344347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344351 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2344351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2344354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344356 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344361 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344362 */   // GIR_Coverage, 2231,
     /* 2344362 */   GIR_EraseRootFromParent_Done,
     /* 2344363 */ // Label 32490: @2344363
     /* 2344363 */ GIM_Try, /*On fail goto*//*Label 32491*/ GIMT_Encode4(2344394), // Rule ID 2257 //
     /* 2344368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2344371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2344378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344382 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2344382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU),
     /* 2344385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344387 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344392 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344393 */   // GIR_Coverage, 2257,
     /* 2344393 */   GIR_EraseRootFromParent_Done,
     /* 2344394 */ // Label 32491: @2344394
     /* 2344394 */ GIM_Try, /*On fail goto*//*Label 32492*/ GIMT_Encode4(2344425), // Rule ID 2283 //
     /* 2344399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2344402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2344409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344413 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2344413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU_INX),
     /* 2344416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344418 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344423 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344424 */   // GIR_Coverage, 2283,
     /* 2344424 */   GIR_EraseRootFromParent_Done,
     /* 2344425 */ // Label 32492: @2344425
     /* 2344425 */ GIM_Reject,
     /* 2344426 */ // Label 32467: @2344426
     /* 2344426 */ GIM_Try, /*On fail goto*//*Label 32493*/ GIMT_Encode4(2344463), // Rule ID 1519 //
     /* 2344431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2344434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2344441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2344448 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2344448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2344451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2344458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344461 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344462 */   // GIR_Coverage, 1519,
     /* 2344462 */   GIR_EraseRootFromParent_Done,
     /* 2344463 */ // Label 32493: @2344463
     /* 2344463 */ GIM_Try, /*On fail goto*//*Label 32494*/ GIMT_Encode4(2344500), // Rule ID 1547 //
     /* 2344468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2344471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2344478 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2344485 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2344485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2344488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2344495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344498 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344499 */   // GIR_Coverage, 1547,
     /* 2344499 */   GIR_EraseRootFromParent_Done,
     /* 2344500 */ // Label 32494: @2344500
     /* 2344500 */ GIM_Try, /*On fail goto*//*Label 32495*/ GIMT_Encode4(2344531), // Rule ID 1468 //
     /* 2344505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2344508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2344515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344519 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2344519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2344522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344524 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344529 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344530 */   // GIR_Coverage, 1468,
     /* 2344530 */   GIR_EraseRootFromParent_Done,
     /* 2344531 */ // Label 32495: @2344531
     /* 2344531 */ GIM_Try, /*On fail goto*//*Label 32496*/ GIMT_Encode4(2344562), // Rule ID 1469 //
     /* 2344536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2344539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2344546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344550 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2344550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2344553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344555 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344560 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344561 */   // GIR_Coverage, 1469,
     /* 2344561 */   GIR_EraseRootFromParent_Done,
     /* 2344562 */ // Label 32496: @2344562
     /* 2344562 */ GIM_Try, /*On fail goto*//*Label 32497*/ GIMT_Encode4(2344593), // Rule ID 1494 //
     /* 2344567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2344570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2344577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344581 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2344581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2344584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344586 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344591 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344592 */   // GIR_Coverage, 1494,
     /* 2344592 */   GIR_EraseRootFromParent_Done,
     /* 2344593 */ // Label 32497: @2344593
     /* 2344593 */ GIM_Try, /*On fail goto*//*Label 32498*/ GIMT_Encode4(2344624), // Rule ID 1495 //
     /* 2344598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2344601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2344608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344612 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2344612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2344615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344617 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344623 */   // GIR_Coverage, 1495,
     /* 2344623 */   GIR_EraseRootFromParent_Done,
     /* 2344624 */ // Label 32498: @2344624
     /* 2344624 */ GIM_Try, /*On fail goto*//*Label 32499*/ GIMT_Encode4(2344655), // Rule ID 1523 //
     /* 2344629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2344632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2344639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344643 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2344643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU),
     /* 2344646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344648 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344654 */   // GIR_Coverage, 1523,
     /* 2344654 */   GIR_EraseRootFromParent_Done,
     /* 2344655 */ // Label 32499: @2344655
     /* 2344655 */ GIM_Try, /*On fail goto*//*Label 32500*/ GIMT_Encode4(2344686), // Rule ID 1551 //
     /* 2344660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2344663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2344670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344674 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2344674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU_INX),
     /* 2344677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344679 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344685 */   // GIR_Coverage, 1551,
     /* 2344685 */   GIR_EraseRootFromParent_Done,
     /* 2344686 */ // Label 32500: @2344686
     /* 2344686 */ GIM_Reject,
     /* 2344687 */ // Label 32468: @2344687
     /* 2344687 */ GIM_Try, /*On fail goto*//*Label 32501*/ GIMT_Encode4(2344724), // Rule ID 1899 //
     /* 2344692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2344695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344702 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2344709 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2344709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2344712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2344719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2344722 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344723 */   // GIR_Coverage, 1899,
     /* 2344723 */   GIR_EraseRootFromParent_Done,
     /* 2344724 */ // Label 32501: @2344724
     /* 2344724 */ GIM_Try, /*On fail goto*//*Label 32502*/ GIMT_Encode4(2344761), // Rule ID 1927 //
     /* 2344729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2344732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2344746 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2344746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_INX),
     /* 2344749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2344756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2344759 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344760 */   // GIR_Coverage, 1927,
     /* 2344760 */   GIR_EraseRootFromParent_Done,
     /* 2344761 */ // Label 32502: @2344761
     /* 2344761 */ GIM_Try, /*On fail goto*//*Label 32503*/ GIMT_Encode4(2344792), // Rule ID 1862 //
     /* 2344766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2344769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344780 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2344780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2344783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344785 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2344790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344791 */   // GIR_Coverage, 1862,
     /* 2344791 */   GIR_EraseRootFromParent_Done,
     /* 2344792 */ // Label 32503: @2344792
     /* 2344792 */ GIM_Try, /*On fail goto*//*Label 32504*/ GIMT_Encode4(2344823), // Rule ID 1863 //
     /* 2344797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2344800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344811 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2344811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2344814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344816 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2344821 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344822 */   // GIR_Coverage, 1863,
     /* 2344822 */   GIR_EraseRootFromParent_Done,
     /* 2344823 */ // Label 32504: @2344823
     /* 2344823 */ GIM_Try, /*On fail goto*//*Label 32505*/ GIMT_Encode4(2344854), // Rule ID 1888 //
     /* 2344828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2344831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2344838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344842 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2344842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2344845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344847 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2344852 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344853 */   // GIR_Coverage, 1888,
     /* 2344853 */   GIR_EraseRootFromParent_Done,
     /* 2344854 */ // Label 32505: @2344854
     /* 2344854 */ GIM_Try, /*On fail goto*//*Label 32506*/ GIMT_Encode4(2344885), // Rule ID 1889 //
     /* 2344859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2344862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2344869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344873 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2344873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2344876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344878 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2344883 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344884 */   // GIR_Coverage, 1889,
     /* 2344884 */   GIR_EraseRootFromParent_Done,
     /* 2344885 */ // Label 32506: @2344885
     /* 2344885 */ GIM_Try, /*On fail goto*//*Label 32507*/ GIMT_Encode4(2344916), // Rule ID 1917 //
     /* 2344890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2344893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344904 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2344904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU),
     /* 2344907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344909 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344914 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344915 */   // GIR_Coverage, 1917,
     /* 2344915 */   GIR_EraseRootFromParent_Done,
     /* 2344916 */ // Label 32507: @2344916
     /* 2344916 */ GIM_Try, /*On fail goto*//*Label 32508*/ GIMT_Encode4(2344947), // Rule ID 1945 //
     /* 2344921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2344924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344935 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2344935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU_INX),
     /* 2344938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344940 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344945 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344946 */   // GIR_Coverage, 1945,
     /* 2344946 */   GIR_EraseRootFromParent_Done,
     /* 2344947 */ // Label 32508: @2344947
     /* 2344947 */ GIM_Reject,
     /* 2344948 */ // Label 32469: @2344948
     /* 2344948 */ GIM_Try, /*On fail goto*//*Label 32509*/ GIMT_Encode4(2345005), // Rule ID 58456 //
     /* 2344953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2344956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2344959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344967 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344967 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2344970 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344974 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2344984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344989 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345004 */   // GIR_Coverage, 58456,
     /* 2345004 */   GIR_EraseRootFromParent_Done,
     /* 2345005 */ // Label 32509: @2345005
     /* 2345005 */ GIM_Try, /*On fail goto*//*Label 32510*/ GIMT_Encode4(2345062), // Rule ID 58457 //
     /* 2345010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2345016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345024 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345024 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2345027 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345031 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2345041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345046 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345061 */   // GIR_Coverage, 58457,
     /* 2345061 */   GIR_EraseRootFromParent_Done,
     /* 2345062 */ // Label 32510: @2345062
     /* 2345062 */ GIM_Try, /*On fail goto*//*Label 32511*/ GIMT_Encode4(2345116), // Rule ID 58640 //
     /* 2345067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2345073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345081 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2345084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2345098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345100 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345103 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345114 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345115 */   // GIR_Coverage, 58640,
     /* 2345115 */   GIR_EraseRootFromParent_Done,
     /* 2345116 */ // Label 32511: @2345116
     /* 2345116 */ GIM_Try, /*On fail goto*//*Label 32512*/ GIMT_Encode4(2345170), // Rule ID 58641 //
     /* 2345121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2345127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345135 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2345138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2345152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345157 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345168 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345169 */   // GIR_Coverage, 58641,
     /* 2345169 */   GIR_EraseRootFromParent_Done,
     /* 2345170 */ // Label 32512: @2345170
     /* 2345170 */ GIM_Try, /*On fail goto*//*Label 32513*/ GIMT_Encode4(2345227), // Rule ID 58848 //
     /* 2345175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2345181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345189 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2345192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2345206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345211 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345225 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345226 */   // GIR_Coverage, 58848,
     /* 2345226 */   GIR_EraseRootFromParent_Done,
     /* 2345227 */ // Label 32513: @2345227
     /* 2345227 */ GIM_Try, /*On fail goto*//*Label 32514*/ GIMT_Encode4(2345284), // Rule ID 58849 //
     /* 2345232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2345238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345246 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2345249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2345263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345265 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345268 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345282 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345283 */   // GIR_Coverage, 58849,
     /* 2345283 */   GIR_EraseRootFromParent_Done,
     /* 2345284 */ // Label 32514: @2345284
     /* 2345284 */ GIM_Reject,
     /* 2345285 */ // Label 32470: @2345285
     /* 2345285 */ GIM_Try, /*On fail goto*//*Label 32515*/ GIMT_Encode4(2345342), // Rule ID 58464 //
     /* 2345290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2345293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2345296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345304 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2345307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2345321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345323 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345326 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345340 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345341 */   // GIR_Coverage, 58464,
     /* 2345341 */   GIR_EraseRootFromParent_Done,
     /* 2345342 */ // Label 32515: @2345342
     /* 2345342 */ GIM_Try, /*On fail goto*//*Label 32516*/ GIMT_Encode4(2345399), // Rule ID 58465 //
     /* 2345347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2345350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2345353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345361 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2345364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2345378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345383 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345397 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345398 */   // GIR_Coverage, 58465,
     /* 2345398 */   GIR_EraseRootFromParent_Done,
     /* 2345399 */ // Label 32516: @2345399
     /* 2345399 */ GIM_Try, /*On fail goto*//*Label 32517*/ GIMT_Encode4(2345453), // Rule ID 58664 //
     /* 2345404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2345407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2345410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345418 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345418 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2345421 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345425 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2345435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345437 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345440 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345451 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345452 */   // GIR_Coverage, 58664,
     /* 2345452 */   GIR_EraseRootFromParent_Done,
     /* 2345453 */ // Label 32517: @2345453
     /* 2345453 */ GIM_Try, /*On fail goto*//*Label 32518*/ GIMT_Encode4(2345507), // Rule ID 58665 //
     /* 2345458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2345461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2345464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345472 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345472 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2345475 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345479 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2345489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345491 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345494 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345505 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345506 */   // GIR_Coverage, 58665,
     /* 2345506 */   GIR_EraseRootFromParent_Done,
     /* 2345507 */ // Label 32518: @2345507
     /* 2345507 */ GIM_Try, /*On fail goto*//*Label 32519*/ GIMT_Encode4(2345564), // Rule ID 58868 //
     /* 2345512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2345515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2345518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345526 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2345529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2345543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345548 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345562 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345563 */   // GIR_Coverage, 58868,
     /* 2345563 */   GIR_EraseRootFromParent_Done,
     /* 2345564 */ // Label 32519: @2345564
     /* 2345564 */ GIM_Try, /*On fail goto*//*Label 32520*/ GIMT_Encode4(2345621), // Rule ID 58869 //
     /* 2345569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2345572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2345575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345583 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2345586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2345600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345605 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345619 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345620 */   // GIR_Coverage, 58869,
     /* 2345620 */   GIR_EraseRootFromParent_Done,
     /* 2345621 */ // Label 32520: @2345621
     /* 2345621 */ GIM_Reject,
     /* 2345622 */ // Label 32471: @2345622
     /* 2345622 */ GIM_Try, /*On fail goto*//*Label 32521*/ GIMT_Encode4(2345679), // Rule ID 58476 //
     /* 2345627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2345630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2345633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345641 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345641 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2345644 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345648 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2345658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345660 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345663 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345677 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345678 */   // GIR_Coverage, 58476,
     /* 2345678 */   GIR_EraseRootFromParent_Done,
     /* 2345679 */ // Label 32521: @2345679
     /* 2345679 */ GIM_Try, /*On fail goto*//*Label 32522*/ GIMT_Encode4(2345736), // Rule ID 58477 //
     /* 2345684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2345687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2345690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345698 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2345701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2345715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345720 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345734 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345735 */   // GIR_Coverage, 58477,
     /* 2345735 */   GIR_EraseRootFromParent_Done,
     /* 2345736 */ // Label 32522: @2345736
     /* 2345736 */ GIM_Try, /*On fail goto*//*Label 32523*/ GIMT_Encode4(2345790), // Rule ID 58684 //
     /* 2345741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2345744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2345747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345755 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2345758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2345772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345774 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345777 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345788 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345789 */   // GIR_Coverage, 58684,
     /* 2345789 */   GIR_EraseRootFromParent_Done,
     /* 2345790 */ // Label 32523: @2345790
     /* 2345790 */ GIM_Try, /*On fail goto*//*Label 32524*/ GIMT_Encode4(2345844), // Rule ID 58685 //
     /* 2345795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2345798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2345801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345809 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2345812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2345826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345828 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345831 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345842 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345843 */   // GIR_Coverage, 58685,
     /* 2345843 */   GIR_EraseRootFromParent_Done,
     /* 2345844 */ // Label 32524: @2345844
     /* 2345844 */ GIM_Reject,
     /* 2345845 */ // Label 32472: @2345845
     /* 2345845 */ GIM_Try, /*On fail goto*//*Label 32525*/ GIMT_Encode4(2345902), // Rule ID 58460 //
     /* 2345850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2345856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345864 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2345867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345876 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2345881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345886 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345900 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345901 */   // GIR_Coverage, 58460,
     /* 2345901 */   GIR_EraseRootFromParent_Done,
     /* 2345902 */ // Label 32525: @2345902
     /* 2345902 */ GIM_Try, /*On fail goto*//*Label 32526*/ GIMT_Encode4(2345959), // Rule ID 58461 //
     /* 2345907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2345913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345921 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2345924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2345938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345940 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345943 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345957 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345958 */   // GIR_Coverage, 58461,
     /* 2345958 */   GIR_EraseRootFromParent_Done,
     /* 2345959 */ // Label 32526: @2345959
     /* 2345959 */ GIM_Try, /*On fail goto*//*Label 32527*/ GIMT_Encode4(2346013), // Rule ID 58644 //
     /* 2345964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2345970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345978 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345978 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2345981 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345985 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2345995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346000 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346011 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346012 */   // GIR_Coverage, 58644,
     /* 2346012 */   GIR_EraseRootFromParent_Done,
     /* 2346013 */ // Label 32527: @2346013
     /* 2346013 */ GIM_Try, /*On fail goto*//*Label 32528*/ GIMT_Encode4(2346067), // Rule ID 58645 //
     /* 2346018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2346024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346032 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346032 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2346035 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346039 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2346049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346051 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346054 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346065 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346066 */   // GIR_Coverage, 58645,
     /* 2346066 */   GIR_EraseRootFromParent_Done,
     /* 2346067 */ // Label 32528: @2346067
     /* 2346067 */ GIM_Try, /*On fail goto*//*Label 32529*/ GIMT_Encode4(2346124), // Rule ID 58852 //
     /* 2346072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2346078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346086 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2346089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2346103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346108 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346122 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346123 */   // GIR_Coverage, 58852,
     /* 2346123 */   GIR_EraseRootFromParent_Done,
     /* 2346124 */ // Label 32529: @2346124
     /* 2346124 */ GIM_Try, /*On fail goto*//*Label 32530*/ GIMT_Encode4(2346181), // Rule ID 58853 //
     /* 2346129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2346135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346143 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346143 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2346146 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346150 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2346160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346162 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346165 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346179 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346180 */   // GIR_Coverage, 58853,
     /* 2346180 */   GIR_EraseRootFromParent_Done,
     /* 2346181 */ // Label 32530: @2346181
     /* 2346181 */ GIM_Reject,
     /* 2346182 */ // Label 32473: @2346182
     /* 2346182 */ GIM_Try, /*On fail goto*//*Label 32531*/ GIMT_Encode4(2346239), // Rule ID 58472 //
     /* 2346187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2346190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2346193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346201 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2346204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2346218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346223 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346237 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346238 */   // GIR_Coverage, 58472,
     /* 2346238 */   GIR_EraseRootFromParent_Done,
     /* 2346239 */ // Label 32531: @2346239
     /* 2346239 */ GIM_Try, /*On fail goto*//*Label 32532*/ GIMT_Encode4(2346296), // Rule ID 58473 //
     /* 2346244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2346247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2346250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346258 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346258 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2346261 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346265 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2346275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346280 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346294 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346295 */   // GIR_Coverage, 58473,
     /* 2346295 */   GIR_EraseRootFromParent_Done,
     /* 2346296 */ // Label 32532: @2346296
     /* 2346296 */ GIM_Try, /*On fail goto*//*Label 32533*/ GIMT_Encode4(2346350), // Rule ID 58668 //
     /* 2346301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2346304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2346307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346315 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346315 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2346318 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346322 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2346332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346337 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346349 */   // GIR_Coverage, 58668,
     /* 2346349 */   GIR_EraseRootFromParent_Done,
     /* 2346350 */ // Label 32533: @2346350
     /* 2346350 */ GIM_Try, /*On fail goto*//*Label 32534*/ GIMT_Encode4(2346404), // Rule ID 58669 //
     /* 2346355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2346358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2346361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346369 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2346372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2346386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346388 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346391 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346402 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346403 */   // GIR_Coverage, 58669,
     /* 2346403 */   GIR_EraseRootFromParent_Done,
     /* 2346404 */ // Label 32534: @2346404
     /* 2346404 */ GIM_Try, /*On fail goto*//*Label 32535*/ GIMT_Encode4(2346461), // Rule ID 58872 //
     /* 2346409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2346412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2346415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346423 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2346426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2346440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346445 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346459 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346460 */   // GIR_Coverage, 58872,
     /* 2346460 */   GIR_EraseRootFromParent_Done,
     /* 2346461 */ // Label 32535: @2346461
     /* 2346461 */ GIM_Try, /*On fail goto*//*Label 32536*/ GIMT_Encode4(2346518), // Rule ID 58873 //
     /* 2346466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2346469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2346472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346480 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346480 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2346483 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346487 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2346497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346502 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346516 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346517 */   // GIR_Coverage, 58873,
     /* 2346517 */   GIR_EraseRootFromParent_Done,
     /* 2346518 */ // Label 32536: @2346518
     /* 2346518 */ GIM_Reject,
     /* 2346519 */ // Label 32474: @2346519
     /* 2346519 */ GIM_Try, /*On fail goto*//*Label 32537*/ GIMT_Encode4(2346576), // Rule ID 58504 //
     /* 2346524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2346527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2346530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346538 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2346541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2346555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346557 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346560 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2346571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346574 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346575 */   // GIR_Coverage, 58504,
     /* 2346575 */   GIR_EraseRootFromParent_Done,
     /* 2346576 */ // Label 32537: @2346576
     /* 2346576 */ GIM_Try, /*On fail goto*//*Label 32538*/ GIMT_Encode4(2346633), // Rule ID 58505 //
     /* 2346581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2346584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2346587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346595 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2346598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2346612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346614 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346617 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2346628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346632 */   // GIR_Coverage, 58505,
     /* 2346632 */   GIR_EraseRootFromParent_Done,
     /* 2346633 */ // Label 32538: @2346633
     /* 2346633 */ GIM_Try, /*On fail goto*//*Label 32539*/ GIMT_Encode4(2346687), // Rule ID 58688 //
     /* 2346638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2346641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2346644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346652 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346652 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2346655 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346659 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2346669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346671 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346674 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346685 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346686 */   // GIR_Coverage, 58688,
     /* 2346686 */   GIR_EraseRootFromParent_Done,
     /* 2346687 */ // Label 32539: @2346687
     /* 2346687 */ GIM_Try, /*On fail goto*//*Label 32540*/ GIMT_Encode4(2346741), // Rule ID 58689 //
     /* 2346692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2346695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2346698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346706 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2346709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2346723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346728 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346740 */   // GIR_Coverage, 58689,
     /* 2346740 */   GIR_EraseRootFromParent_Done,
     /* 2346741 */ // Label 32540: @2346741
     /* 2346741 */ GIM_Reject,
     /* 2346742 */ // Label 32475: @2346742
     /* 2346742 */ GIM_Try, /*On fail goto*//*Label 32541*/ GIMT_Encode4(2346799), // Rule ID 58468 //
     /* 2346747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2346753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346761 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2346764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2346778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346783 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346797 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346798 */   // GIR_Coverage, 58468,
     /* 2346798 */   GIR_EraseRootFromParent_Done,
     /* 2346799 */ // Label 32541: @2346799
     /* 2346799 */ GIM_Try, /*On fail goto*//*Label 32542*/ GIMT_Encode4(2346856), // Rule ID 58469 //
     /* 2346804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2346810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346818 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346818 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2346821 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346825 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2346835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346837 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346840 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346854 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346855 */   // GIR_Coverage, 58469,
     /* 2346855 */   GIR_EraseRootFromParent_Done,
     /* 2346856 */ // Label 32542: @2346856
     /* 2346856 */ GIM_Try, /*On fail goto*//*Label 32543*/ GIMT_Encode4(2346910), // Rule ID 58648 //
     /* 2346861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2346867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346875 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2346878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2346892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346897 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346908 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346909 */   // GIR_Coverage, 58648,
     /* 2346909 */   GIR_EraseRootFromParent_Done,
     /* 2346910 */ // Label 32543: @2346910
     /* 2346910 */ GIM_Try, /*On fail goto*//*Label 32544*/ GIMT_Encode4(2346964), // Rule ID 58649 //
     /* 2346915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2346921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346929 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2346932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2346946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346948 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346951 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346962 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346963 */   // GIR_Coverage, 58649,
     /* 2346963 */   GIR_EraseRootFromParent_Done,
     /* 2346964 */ // Label 32544: @2346964
     /* 2346964 */ GIM_Try, /*On fail goto*//*Label 32545*/ GIMT_Encode4(2347021), // Rule ID 58856 //
     /* 2346969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2346975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346983 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346983 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2346986 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346990 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2347000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347005 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347020 */   // GIR_Coverage, 58856,
     /* 2347020 */   GIR_EraseRootFromParent_Done,
     /* 2347021 */ // Label 32545: @2347021
     /* 2347021 */ GIM_Try, /*On fail goto*//*Label 32546*/ GIMT_Encode4(2347078), // Rule ID 58857 //
     /* 2347026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2347032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347040 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347040 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2347043 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347047 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2347057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347059 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347062 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347076 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347077 */   // GIR_Coverage, 58857,
     /* 2347077 */   GIR_EraseRootFromParent_Done,
     /* 2347078 */ // Label 32546: @2347078
     /* 2347078 */ GIM_Reject,
     /* 2347079 */ // Label 32476: @2347079
     /* 2347079 */ GIM_Try, /*On fail goto*//*Label 32547*/ GIMT_Encode4(2347136), // Rule ID 58492 //
     /* 2347084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2347087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2347090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347098 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347098 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2347101 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347105 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2347115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347120 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347134 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347135 */   // GIR_Coverage, 58492,
     /* 2347135 */   GIR_EraseRootFromParent_Done,
     /* 2347136 */ // Label 32547: @2347136
     /* 2347136 */ GIM_Try, /*On fail goto*//*Label 32548*/ GIMT_Encode4(2347193), // Rule ID 58493 //
     /* 2347141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2347144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2347147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347155 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347155 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2347158 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347162 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2347172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347177 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347191 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347192 */   // GIR_Coverage, 58493,
     /* 2347192 */   GIR_EraseRootFromParent_Done,
     /* 2347193 */ // Label 32548: @2347193
     /* 2347193 */ GIM_Try, /*On fail goto*//*Label 32549*/ GIMT_Encode4(2347247), // Rule ID 58672 //
     /* 2347198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2347201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2347204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347212 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347212 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2347215 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347219 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2347229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347231 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347234 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347245 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347246 */   // GIR_Coverage, 58672,
     /* 2347246 */   GIR_EraseRootFromParent_Done,
     /* 2347247 */ // Label 32549: @2347247
     /* 2347247 */ GIM_Try, /*On fail goto*//*Label 32550*/ GIMT_Encode4(2347301), // Rule ID 58673 //
     /* 2347252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2347255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2347258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347266 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2347269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2347283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347288 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347300 */   // GIR_Coverage, 58673,
     /* 2347300 */   GIR_EraseRootFromParent_Done,
     /* 2347301 */ // Label 32550: @2347301
     /* 2347301 */ GIM_Try, /*On fail goto*//*Label 32551*/ GIMT_Encode4(2347358), // Rule ID 58876 //
     /* 2347306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2347309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2347312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347320 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347320 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2347323 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347327 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2347337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347342 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347357 */   // GIR_Coverage, 58876,
     /* 2347357 */   GIR_EraseRootFromParent_Done,
     /* 2347358 */ // Label 32551: @2347358
     /* 2347358 */ GIM_Try, /*On fail goto*//*Label 32552*/ GIMT_Encode4(2347415), // Rule ID 58877 //
     /* 2347363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2347366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2347369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347377 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347377 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2347380 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347384 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2347394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347396 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347399 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347413 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347414 */   // GIR_Coverage, 58877,
     /* 2347414 */   GIR_EraseRootFromParent_Done,
     /* 2347415 */ // Label 32552: @2347415
     /* 2347415 */ GIM_Reject,
     /* 2347416 */ // Label 32477: @2347416
     /* 2347416 */ GIM_Try, /*On fail goto*//*Label 32553*/ GIMT_Encode4(2347473), // Rule ID 58508 //
     /* 2347421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2347424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2347427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347435 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347435 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2347438 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347442 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2347452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347454 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347457 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347471 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347472 */   // GIR_Coverage, 58508,
     /* 2347472 */   GIR_EraseRootFromParent_Done,
     /* 2347473 */ // Label 32553: @2347473
     /* 2347473 */ GIM_Try, /*On fail goto*//*Label 32554*/ GIMT_Encode4(2347530), // Rule ID 58509 //
     /* 2347478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2347481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2347484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347492 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2347495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2347509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347514 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347528 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347529 */   // GIR_Coverage, 58509,
     /* 2347529 */   GIR_EraseRootFromParent_Done,
     /* 2347530 */ // Label 32554: @2347530
     /* 2347530 */ GIM_Try, /*On fail goto*//*Label 32555*/ GIMT_Encode4(2347584), // Rule ID 58692 //
     /* 2347535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2347538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2347541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347549 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347549 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2347552 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347556 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2347566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347568 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347571 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347582 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347583 */   // GIR_Coverage, 58692,
     /* 2347583 */   GIR_EraseRootFromParent_Done,
     /* 2347584 */ // Label 32555: @2347584
     /* 2347584 */ GIM_Try, /*On fail goto*//*Label 32556*/ GIMT_Encode4(2347638), // Rule ID 58693 //
     /* 2347589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2347592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2347595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347603 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2347606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2347620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347625 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347636 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347637 */   // GIR_Coverage, 58693,
     /* 2347637 */   GIR_EraseRootFromParent_Done,
     /* 2347638 */ // Label 32556: @2347638
     /* 2347638 */ GIM_Reject,
     /* 2347639 */ // Label 32478: @2347639
     /* 2347639 */ GIM_Try, /*On fail goto*//*Label 32557*/ GIMT_Encode4(2347696), // Rule ID 58480 //
     /* 2347644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2347647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2347650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347658 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2347661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2347675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347680 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347694 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347695 */   // GIR_Coverage, 58480,
     /* 2347695 */   GIR_EraseRootFromParent_Done,
     /* 2347696 */ // Label 32557: @2347696
     /* 2347696 */ GIM_Try, /*On fail goto*//*Label 32558*/ GIMT_Encode4(2347753), // Rule ID 58481 //
     /* 2347701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2347707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347715 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2347718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347727 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2347732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347734 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347737 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347751 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347752 */   // GIR_Coverage, 58481,
     /* 2347752 */   GIR_EraseRootFromParent_Done,
     /* 2347753 */ // Label 32558: @2347753
     /* 2347753 */ GIM_Try, /*On fail goto*//*Label 32559*/ GIMT_Encode4(2347807), // Rule ID 58652 //
     /* 2347758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2347761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2347764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347772 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2347775 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347779 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2347789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347794 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347805 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347806 */   // GIR_Coverage, 58652,
     /* 2347806 */   GIR_EraseRootFromParent_Done,
     /* 2347807 */ // Label 32559: @2347807
     /* 2347807 */ GIM_Try, /*On fail goto*//*Label 32560*/ GIMT_Encode4(2347861), // Rule ID 58653 //
     /* 2347812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2347818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347826 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2347829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2347843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347848 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347859 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347860 */   // GIR_Coverage, 58653,
     /* 2347860 */   GIR_EraseRootFromParent_Done,
     /* 2347861 */ // Label 32560: @2347861
     /* 2347861 */ GIM_Try, /*On fail goto*//*Label 32561*/ GIMT_Encode4(2347918), // Rule ID 58860 //
     /* 2347866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2347869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2347872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347880 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2347883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2347897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347902 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347916 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347917 */   // GIR_Coverage, 58860,
     /* 2347917 */   GIR_EraseRootFromParent_Done,
     /* 2347918 */ // Label 32561: @2347918
     /* 2347918 */ GIM_Try, /*On fail goto*//*Label 32562*/ GIMT_Encode4(2347975), // Rule ID 58861 //
     /* 2347923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2347929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347937 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347937 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2347940 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347944 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2347954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347959 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347973 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347974 */   // GIR_Coverage, 58861,
     /* 2347974 */   GIR_EraseRootFromParent_Done,
     /* 2347975 */ // Label 32562: @2347975
     /* 2347975 */ GIM_Reject,
     /* 2347976 */ // Label 32479: @2347976
     /* 2347976 */ GIM_Try, /*On fail goto*//*Label 32563*/ GIMT_Encode4(2348033), // Rule ID 58496 //
     /* 2347981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2347984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2347987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347995 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2347998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2348012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348014 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348017 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348031 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348032 */   // GIR_Coverage, 58496,
     /* 2348032 */   GIR_EraseRootFromParent_Done,
     /* 2348033 */ // Label 32563: @2348033
     /* 2348033 */ GIM_Try, /*On fail goto*//*Label 32564*/ GIMT_Encode4(2348090), // Rule ID 58497 //
     /* 2348038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2348041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2348044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348052 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2348055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2348069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348074 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348088 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348089 */   // GIR_Coverage, 58497,
     /* 2348089 */   GIR_EraseRootFromParent_Done,
     /* 2348090 */ // Label 32564: @2348090
     /* 2348090 */ GIM_Try, /*On fail goto*//*Label 32565*/ GIMT_Encode4(2348144), // Rule ID 58676 //
     /* 2348095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2348098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2348101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2348109 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348109 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2348112 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348116 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2348126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348131 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348142 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348143 */   // GIR_Coverage, 58676,
     /* 2348143 */   GIR_EraseRootFromParent_Done,
     /* 2348144 */ // Label 32565: @2348144
     /* 2348144 */ GIM_Try, /*On fail goto*//*Label 32566*/ GIMT_Encode4(2348198), // Rule ID 58677 //
     /* 2348149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2348152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2348155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2348163 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348163 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2348166 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348170 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2348180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348182 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348185 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348196 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348197 */   // GIR_Coverage, 58677,
     /* 2348197 */   GIR_EraseRootFromParent_Done,
     /* 2348198 */ // Label 32566: @2348198
     /* 2348198 */ GIM_Try, /*On fail goto*//*Label 32567*/ GIMT_Encode4(2348255), // Rule ID 58880 //
     /* 2348203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2348206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2348209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348217 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2348220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2348234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348236 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348239 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348253 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348254 */   // GIR_Coverage, 58880,
     /* 2348254 */   GIR_EraseRootFromParent_Done,
     /* 2348255 */ // Label 32567: @2348255
     /* 2348255 */ GIM_Try, /*On fail goto*//*Label 32568*/ GIMT_Encode4(2348312), // Rule ID 58881 //
     /* 2348260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2348263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2348266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348274 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348274 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2348277 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348281 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2348291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348293 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348296 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348310 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348311 */   // GIR_Coverage, 58881,
     /* 2348311 */   GIR_EraseRootFromParent_Done,
     /* 2348312 */ // Label 32568: @2348312
     /* 2348312 */ GIM_Reject,
     /* 2348313 */ // Label 32480: @2348313
     /* 2348313 */ GIM_Try, /*On fail goto*//*Label 32569*/ GIMT_Encode4(2348370), // Rule ID 58512 //
     /* 2348318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2348321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2348324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348332 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348332 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2348335 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348339 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2348349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348354 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2348365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348368 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348369 */   // GIR_Coverage, 58512,
     /* 2348369 */   GIR_EraseRootFromParent_Done,
     /* 2348370 */ // Label 32569: @2348370
     /* 2348370 */ GIM_Try, /*On fail goto*//*Label 32570*/ GIMT_Encode4(2348427), // Rule ID 58513 //
     /* 2348375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2348378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2348381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348389 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348389 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2348392 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348396 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2348406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348411 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2348422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348425 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348426 */   // GIR_Coverage, 58513,
     /* 2348426 */   GIR_EraseRootFromParent_Done,
     /* 2348427 */ // Label 32570: @2348427
     /* 2348427 */ GIM_Try, /*On fail goto*//*Label 32571*/ GIMT_Encode4(2348481), // Rule ID 58696 //
     /* 2348432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2348435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2348438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348446 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2348449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2348463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348465 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348468 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348479 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348480 */   // GIR_Coverage, 58696,
     /* 2348480 */   GIR_EraseRootFromParent_Done,
     /* 2348481 */ // Label 32571: @2348481
     /* 2348481 */ GIM_Try, /*On fail goto*//*Label 32572*/ GIMT_Encode4(2348535), // Rule ID 58697 //
     /* 2348486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2348489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2348492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348500 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2348503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2348517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348519 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348522 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348533 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348534 */   // GIR_Coverage, 58697,
     /* 2348534 */   GIR_EraseRootFromParent_Done,
     /* 2348535 */ // Label 32572: @2348535
     /* 2348535 */ GIM_Reject,
     /* 2348536 */ // Label 32481: @2348536
     /* 2348536 */ GIM_Try, /*On fail goto*//*Label 32573*/ GIMT_Encode4(2348593), // Rule ID 58484 //
     /* 2348541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2348544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2348547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348555 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2348558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2348572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348577 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348591 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348592 */   // GIR_Coverage, 58484,
     /* 2348592 */   GIR_EraseRootFromParent_Done,
     /* 2348593 */ // Label 32573: @2348593
     /* 2348593 */ GIM_Try, /*On fail goto*//*Label 32574*/ GIMT_Encode4(2348650), // Rule ID 58485 //
     /* 2348598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2348601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2348604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348612 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2348615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2348629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348631 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348634 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348648 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348649 */   // GIR_Coverage, 58485,
     /* 2348649 */   GIR_EraseRootFromParent_Done,
     /* 2348650 */ // Label 32574: @2348650
     /* 2348650 */ GIM_Try, /*On fail goto*//*Label 32575*/ GIMT_Encode4(2348704), // Rule ID 58656 //
     /* 2348655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2348658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2348661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2348669 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2348672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2348686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348691 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348703 */   // GIR_Coverage, 58656,
     /* 2348703 */   GIR_EraseRootFromParent_Done,
     /* 2348704 */ // Label 32575: @2348704
     /* 2348704 */ GIM_Try, /*On fail goto*//*Label 32576*/ GIMT_Encode4(2348758), // Rule ID 58657 //
     /* 2348709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2348712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2348715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2348723 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2348726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2348740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348745 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348756 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348757 */   // GIR_Coverage, 58657,
     /* 2348757 */   GIR_EraseRootFromParent_Done,
     /* 2348758 */ // Label 32576: @2348758
     /* 2348758 */ GIM_Try, /*On fail goto*//*Label 32577*/ GIMT_Encode4(2348815), // Rule ID 58864 //
     /* 2348763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2348766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2348769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348777 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348777 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2348780 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348784 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2348794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348796 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348799 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348813 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348814 */   // GIR_Coverage, 58864,
     /* 2348814 */   GIR_EraseRootFromParent_Done,
     /* 2348815 */ // Label 32577: @2348815
     /* 2348815 */ GIM_Try, /*On fail goto*//*Label 32578*/ GIMT_Encode4(2348872), // Rule ID 58865 //
     /* 2348820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2348823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2348826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348834 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348834 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2348837 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348841 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2348851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348856 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348871 */   // GIR_Coverage, 58865,
     /* 2348871 */   GIR_EraseRootFromParent_Done,
     /* 2348872 */ // Label 32578: @2348872
     /* 2348872 */ GIM_Reject,
     /* 2348873 */ // Label 32482: @2348873
     /* 2348873 */ GIM_Try, /*On fail goto*//*Label 32579*/ GIMT_Encode4(2348930), // Rule ID 58500 //
     /* 2348878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2348881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2348884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348892 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2348895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348904 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2348909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348911 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348914 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348928 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348929 */   // GIR_Coverage, 58500,
     /* 2348929 */   GIR_EraseRootFromParent_Done,
     /* 2348930 */ // Label 32579: @2348930
     /* 2348930 */ GIM_Try, /*On fail goto*//*Label 32580*/ GIMT_Encode4(2348987), // Rule ID 58501 //
     /* 2348935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2348938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2348941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348949 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2348952 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348956 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2348966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348971 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348986 */   // GIR_Coverage, 58501,
     /* 2348986 */   GIR_EraseRootFromParent_Done,
     /* 2348987 */ // Label 32580: @2348987
     /* 2348987 */ GIM_Try, /*On fail goto*//*Label 32581*/ GIMT_Encode4(2349041), // Rule ID 58680 //
     /* 2348992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2348995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2348998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2349002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2349006 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2349009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2349023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349028 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349039 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349040 */   // GIR_Coverage, 58680,
     /* 2349040 */   GIR_EraseRootFromParent_Done,
     /* 2349041 */ // Label 32581: @2349041
     /* 2349041 */ GIM_Try, /*On fail goto*//*Label 32582*/ GIMT_Encode4(2349095), // Rule ID 58681 //
     /* 2349046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2349049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2349052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2349056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2349060 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2349063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2349077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349082 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349094 */   // GIR_Coverage, 58681,
     /* 2349094 */   GIR_EraseRootFromParent_Done,
     /* 2349095 */ // Label 32582: @2349095
     /* 2349095 */ GIM_Reject,
     /* 2349096 */ // Label 32483: @2349096
     /* 2349096 */ GIM_Try, /*On fail goto*//*Label 32583*/ GIMT_Encode4(2349153), // Rule ID 58488 //
     /* 2349101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2349104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2349107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2349111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2349115 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349115 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2349118 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349122 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2349132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349137 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349151 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349152 */   // GIR_Coverage, 58488,
     /* 2349152 */   GIR_EraseRootFromParent_Done,
     /* 2349153 */ // Label 32583: @2349153
     /* 2349153 */ GIM_Try, /*On fail goto*//*Label 32584*/ GIMT_Encode4(2349210), // Rule ID 58489 //
     /* 2349158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2349161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2349164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2349168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2349172 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349172 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2349175 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349179 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2349189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349194 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349208 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349209 */   // GIR_Coverage, 58489,
     /* 2349209 */   GIR_EraseRootFromParent_Done,
     /* 2349210 */ // Label 32584: @2349210
     /* 2349210 */ GIM_Try, /*On fail goto*//*Label 32585*/ GIMT_Encode4(2349264), // Rule ID 58660 //
     /* 2349215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2349218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2349221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2349225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2349229 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349229 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2349232 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349236 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2349246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349251 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349262 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349263 */   // GIR_Coverage, 58660,
     /* 2349263 */   GIR_EraseRootFromParent_Done,
     /* 2349264 */ // Label 32585: @2349264
     /* 2349264 */ GIM_Try, /*On fail goto*//*Label 32586*/ GIMT_Encode4(2349318), // Rule ID 58661 //
     /* 2349269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2349272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2349275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2349279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2349283 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349283 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2349286 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349290 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2349300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349305 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349316 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349317 */   // GIR_Coverage, 58661,
     /* 2349317 */   GIR_EraseRootFromParent_Done,
     /* 2349318 */ // Label 32586: @2349318
     /* 2349318 */ GIM_Reject,
     /* 2349319 */ // Label 32484: @2349319
     /* 2349319 */ GIM_Reject,
     /* 2349320 */ // Label 71: @2349320
     /* 2349320 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32605*/ GIMT_Encode4(2351290),
     /* 2349331 */ /*GILLT_s16*//*Label 32587*/ GIMT_Encode4(2349451),
     /* 2349335 */ /*GILLT_s32*//*Label 32588*/ GIMT_Encode4(2349515),
     /* 2349339 */ /*GILLT_s64*//*Label 32589*/ GIMT_Encode4(2349579), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2349351 */ /*GILLT_nxv1s16*//*Label 32590*/ GIMT_Encode4(2349670),
     /* 2349355 */ /*GILLT_nxv1s32*//*Label 32591*/ GIMT_Encode4(2349778),
     /* 2349359 */ /*GILLT_nxv1s64*//*Label 32592*/ GIMT_Encode4(2349886), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2349371 */ /*GILLT_nxv2s16*//*Label 32593*/ GIMT_Encode4(2349994),
     /* 2349375 */ /*GILLT_nxv2s32*//*Label 32594*/ GIMT_Encode4(2350102),
     /* 2349379 */ /*GILLT_nxv2s64*//*Label 32595*/ GIMT_Encode4(2350210), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2349391 */ /*GILLT_nxv4s16*//*Label 32596*/ GIMT_Encode4(2350318),
     /* 2349395 */ /*GILLT_nxv4s32*//*Label 32597*/ GIMT_Encode4(2350426),
     /* 2349399 */ /*GILLT_nxv4s64*//*Label 32598*/ GIMT_Encode4(2350534), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2349411 */ /*GILLT_nxv8s16*//*Label 32599*/ GIMT_Encode4(2350642),
     /* 2349415 */ /*GILLT_nxv8s32*//*Label 32600*/ GIMT_Encode4(2350750),
     /* 2349419 */ /*GILLT_nxv8s64*//*Label 32601*/ GIMT_Encode4(2350858), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2349431 */ /*GILLT_nxv16s16*//*Label 32602*/ GIMT_Encode4(2350966),
     /* 2349435 */ /*GILLT_nxv16s32*//*Label 32603*/ GIMT_Encode4(2351074), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2349447 */ /*GILLT_nxv32s16*//*Label 32604*/ GIMT_Encode4(2351182),
     /* 2349451 */ // Label 32587: @2349451
     /* 2349451 */ GIM_Try, /*On fail goto*//*Label 32606*/ GIMT_Encode4(2349514),
     /* 2349456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2349459 */   GIM_Try, /*On fail goto*//*Label 32607*/ GIMT_Encode4(2349486), // Rule ID 1983 //
     /* 2349464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2349467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349475 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2349475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H),
     /* 2349478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349485 */     // GIR_Coverage, 1983,
     /* 2349485 */     GIR_EraseRootFromParent_Done,
     /* 2349486 */   // Label 32607: @2349486
     /* 2349486 */   GIM_Try, /*On fail goto*//*Label 32608*/ GIMT_Encode4(2349513), // Rule ID 2016 //
     /* 2349491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2349494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349502 */     // (fabs:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2349502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H_INX),
     /* 2349505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349512 */     // GIR_Coverage, 2016,
     /* 2349512 */     GIR_EraseRootFromParent_Done,
     /* 2349513 */   // Label 32608: @2349513
     /* 2349513 */   GIM_Reject,
     /* 2349514 */ // Label 32606: @2349514
     /* 2349514 */ GIM_Reject,
     /* 2349515 */ // Label 32588: @2349515
     /* 2349515 */ GIM_Try, /*On fail goto*//*Label 32609*/ GIMT_Encode4(2349578),
     /* 2349520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2349523 */   GIM_Try, /*On fail goto*//*Label 32610*/ GIMT_Encode4(2349550), // Rule ID 1274 //
     /* 2349528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2349531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349539 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2349539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S),
     /* 2349542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349549 */     // GIR_Coverage, 1274,
     /* 2349549 */     GIR_EraseRootFromParent_Done,
     /* 2349550 */   // Label 32610: @2349550
     /* 2349550 */   GIM_Try, /*On fail goto*//*Label 32611*/ GIMT_Encode4(2349577), // Rule ID 1282 //
     /* 2349555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2349558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349566 */     // (fabs:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2349566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S_INX),
     /* 2349569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349576 */     // GIR_Coverage, 1282,
     /* 2349576 */     GIR_EraseRootFromParent_Done,
     /* 2349577 */   // Label 32611: @2349577
     /* 2349577 */   GIM_Reject,
     /* 2349578 */ // Label 32609: @2349578
     /* 2349578 */ GIM_Reject,
     /* 2349579 */ // Label 32589: @2349579
     /* 2349579 */ GIM_Try, /*On fail goto*//*Label 32612*/ GIMT_Encode4(2349669),
     /* 2349584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2349587 */   GIM_Try, /*On fail goto*//*Label 32613*/ GIMT_Encode4(2349614), // Rule ID 1617 //
     /* 2349592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2349595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2349599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2349603 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2349603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D),
     /* 2349606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349613 */     // GIR_Coverage, 1617,
     /* 2349613 */     GIR_EraseRootFromParent_Done,
     /* 2349614 */   // Label 32613: @2349614
     /* 2349614 */   GIM_Try, /*On fail goto*//*Label 32614*/ GIMT_Encode4(2349641), // Rule ID 1650 //
     /* 2349619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2349622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2349626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2349630 */     // (fabs:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2349630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_INX),
     /* 2349633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349640 */     // GIR_Coverage, 1650,
     /* 2349640 */     GIR_EraseRootFromParent_Done,
     /* 2349641 */   // Label 32614: @2349641
     /* 2349641 */   GIM_Try, /*On fail goto*//*Label 32615*/ GIMT_Encode4(2349668), // Rule ID 1672 //
     /* 2349646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2349649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2349653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2349657 */     // (fabs:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2349657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_IN32X),
     /* 2349660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349667 */     // GIR_Coverage, 1672,
     /* 2349667 */     GIR_EraseRootFromParent_Done,
     /* 2349668 */   // Label 32615: @2349668
     /* 2349668 */   GIM_Reject,
     /* 2349669 */ // Label 32612: @2349669
     /* 2349669 */ GIM_Reject,
     /* 2349670 */ // Label 32590: @2349670
     /* 2349670 */ GIM_Try, /*On fail goto*//*Label 32616*/ GIMT_Encode4(2349777),
     /* 2349675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2349678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349686 */   GIM_Try, /*On fail goto*//*Label 32617*/ GIMT_Encode4(2349731), // Rule ID 56232 //
     /* 2349691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2349694 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2349697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2349711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349730 */     // GIR_Coverage, 56232,
     /* 2349730 */     GIR_EraseRootFromParent_Done,
     /* 2349731 */   // Label 32617: @2349731
     /* 2349731 */   GIM_Try, /*On fail goto*//*Label 32618*/ GIMT_Encode4(2349776), // Rule ID 56233 //
     /* 2349736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2349739 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2349742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2349756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349775 */     // GIR_Coverage, 56233,
     /* 2349775 */     GIR_EraseRootFromParent_Done,
     /* 2349776 */   // Label 32618: @2349776
     /* 2349776 */   GIM_Reject,
     /* 2349777 */ // Label 32616: @2349777
     /* 2349777 */ GIM_Reject,
     /* 2349778 */ // Label 32591: @2349778
     /* 2349778 */ GIM_Try, /*On fail goto*//*Label 32619*/ GIMT_Encode4(2349885),
     /* 2349783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2349786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349794 */   GIM_Try, /*On fail goto*//*Label 32620*/ GIMT_Encode4(2349839), // Rule ID 56272 //
     /* 2349799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2349802 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2349805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2349819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349838 */     // GIR_Coverage, 56272,
     /* 2349838 */     GIR_EraseRootFromParent_Done,
     /* 2349839 */   // Label 32620: @2349839
     /* 2349839 */   GIM_Try, /*On fail goto*//*Label 32621*/ GIMT_Encode4(2349884), // Rule ID 56273 //
     /* 2349844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2349847 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2349850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2349864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349883 */     // GIR_Coverage, 56273,
     /* 2349883 */     GIR_EraseRootFromParent_Done,
     /* 2349884 */   // Label 32621: @2349884
     /* 2349884 */   GIM_Reject,
     /* 2349885 */ // Label 32619: @2349885
     /* 2349885 */ GIM_Reject,
     /* 2349886 */ // Label 32592: @2349886
     /* 2349886 */ GIM_Try, /*On fail goto*//*Label 32622*/ GIMT_Encode4(2349993),
     /* 2349891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2349894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349902 */   GIM_Try, /*On fail goto*//*Label 32623*/ GIMT_Encode4(2349947), // Rule ID 56332 //
     /* 2349907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2349910 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2349913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2349927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349946 */     // GIR_Coverage, 56332,
     /* 2349946 */     GIR_EraseRootFromParent_Done,
     /* 2349947 */   // Label 32623: @2349947
     /* 2349947 */   GIM_Try, /*On fail goto*//*Label 32624*/ GIMT_Encode4(2349992), // Rule ID 56333 //
     /* 2349952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2349955 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2349958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2349972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2349981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349991 */     // GIR_Coverage, 56333,
     /* 2349991 */     GIR_EraseRootFromParent_Done,
     /* 2349992 */   // Label 32624: @2349992
     /* 2349992 */   GIM_Reject,
     /* 2349993 */ // Label 32622: @2349993
     /* 2349993 */ GIM_Reject,
     /* 2349994 */ // Label 32593: @2349994
     /* 2349994 */ GIM_Try, /*On fail goto*//*Label 32625*/ GIMT_Encode4(2350101),
     /* 2349999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2350002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350010 */   GIM_Try, /*On fail goto*//*Label 32626*/ GIMT_Encode4(2350055), // Rule ID 56252 //
     /* 2350015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2350018 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2350021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2350035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350054 */     // GIR_Coverage, 56252,
     /* 2350054 */     GIR_EraseRootFromParent_Done,
     /* 2350055 */   // Label 32626: @2350055
     /* 2350055 */   GIM_Try, /*On fail goto*//*Label 32627*/ GIMT_Encode4(2350100), // Rule ID 56253 //
     /* 2350060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2350063 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2350066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2350080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350099 */     // GIR_Coverage, 56253,
     /* 2350099 */     GIR_EraseRootFromParent_Done,
     /* 2350100 */   // Label 32627: @2350100
     /* 2350100 */   GIM_Reject,
     /* 2350101 */ // Label 32625: @2350101
     /* 2350101 */ GIM_Reject,
     /* 2350102 */ // Label 32594: @2350102
     /* 2350102 */ GIM_Try, /*On fail goto*//*Label 32628*/ GIMT_Encode4(2350209),
     /* 2350107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2350110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350118 */   GIM_Try, /*On fail goto*//*Label 32629*/ GIMT_Encode4(2350163), // Rule ID 56312 //
     /* 2350123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2350126 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2350129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2350143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350162 */     // GIR_Coverage, 56312,
     /* 2350162 */     GIR_EraseRootFromParent_Done,
     /* 2350163 */   // Label 32629: @2350163
     /* 2350163 */   GIM_Try, /*On fail goto*//*Label 32630*/ GIMT_Encode4(2350208), // Rule ID 56313 //
     /* 2350168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2350171 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2350174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2350188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350207 */     // GIR_Coverage, 56313,
     /* 2350207 */     GIR_EraseRootFromParent_Done,
     /* 2350208 */   // Label 32630: @2350208
     /* 2350208 */   GIM_Reject,
     /* 2350209 */ // Label 32628: @2350209
     /* 2350209 */ GIM_Reject,
     /* 2350210 */ // Label 32595: @2350210
     /* 2350210 */ GIM_Try, /*On fail goto*//*Label 32631*/ GIMT_Encode4(2350317),
     /* 2350215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2350218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350226 */   GIM_Try, /*On fail goto*//*Label 32632*/ GIMT_Encode4(2350271), // Rule ID 56472 //
     /* 2350231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2350234 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2350237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2350251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350270 */     // GIR_Coverage, 56472,
     /* 2350270 */     GIR_EraseRootFromParent_Done,
     /* 2350271 */   // Label 32632: @2350271
     /* 2350271 */   GIM_Try, /*On fail goto*//*Label 32633*/ GIMT_Encode4(2350316), // Rule ID 56473 //
     /* 2350276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2350279 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2350282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2350296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350315 */     // GIR_Coverage, 56473,
     /* 2350315 */     GIR_EraseRootFromParent_Done,
     /* 2350316 */   // Label 32633: @2350316
     /* 2350316 */   GIM_Reject,
     /* 2350317 */ // Label 32631: @2350317
     /* 2350317 */ GIM_Reject,
     /* 2350318 */ // Label 32596: @2350318
     /* 2350318 */ GIM_Try, /*On fail goto*//*Label 32634*/ GIMT_Encode4(2350425),
     /* 2350323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2350326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350334 */   GIM_Try, /*On fail goto*//*Label 32635*/ GIMT_Encode4(2350379), // Rule ID 56292 //
     /* 2350339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2350342 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2350359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350378 */     // GIR_Coverage, 56292,
     /* 2350378 */     GIR_EraseRootFromParent_Done,
     /* 2350379 */   // Label 32635: @2350379
     /* 2350379 */   GIM_Try, /*On fail goto*//*Label 32636*/ GIMT_Encode4(2350424), // Rule ID 56293 //
     /* 2350384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2350387 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2350404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350423 */     // GIR_Coverage, 56293,
     /* 2350423 */     GIR_EraseRootFromParent_Done,
     /* 2350424 */   // Label 32636: @2350424
     /* 2350424 */   GIM_Reject,
     /* 2350425 */ // Label 32634: @2350425
     /* 2350425 */ GIM_Reject,
     /* 2350426 */ // Label 32597: @2350426
     /* 2350426 */ GIM_Try, /*On fail goto*//*Label 32637*/ GIMT_Encode4(2350533),
     /* 2350431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2350434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350442 */   GIM_Try, /*On fail goto*//*Label 32638*/ GIMT_Encode4(2350487), // Rule ID 56412 //
     /* 2350447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2350450 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2350453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2350467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350486 */     // GIR_Coverage, 56412,
     /* 2350486 */     GIR_EraseRootFromParent_Done,
     /* 2350487 */   // Label 32638: @2350487
     /* 2350487 */   GIM_Try, /*On fail goto*//*Label 32639*/ GIMT_Encode4(2350532), // Rule ID 56413 //
     /* 2350492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2350495 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2350498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2350512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350531 */     // GIR_Coverage, 56413,
     /* 2350531 */     GIR_EraseRootFromParent_Done,
     /* 2350532 */   // Label 32639: @2350532
     /* 2350532 */   GIM_Reject,
     /* 2350533 */ // Label 32637: @2350533
     /* 2350533 */ GIM_Reject,
     /* 2350534 */ // Label 32598: @2350534
     /* 2350534 */ GIM_Try, /*On fail goto*//*Label 32640*/ GIMT_Encode4(2350641),
     /* 2350539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2350542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350550 */   GIM_Try, /*On fail goto*//*Label 32641*/ GIMT_Encode4(2350595), // Rule ID 56492 //
     /* 2350555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2350558 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2350561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2350575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350594 */     // GIR_Coverage, 56492,
     /* 2350594 */     GIR_EraseRootFromParent_Done,
     /* 2350595 */   // Label 32641: @2350595
     /* 2350595 */   GIM_Try, /*On fail goto*//*Label 32642*/ GIMT_Encode4(2350640), // Rule ID 56493 //
     /* 2350600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2350603 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2350606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2350620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350639 */     // GIR_Coverage, 56493,
     /* 2350639 */     GIR_EraseRootFromParent_Done,
     /* 2350640 */   // Label 32642: @2350640
     /* 2350640 */   GIM_Reject,
     /* 2350641 */ // Label 32640: @2350641
     /* 2350641 */ GIM_Reject,
     /* 2350642 */ // Label 32599: @2350642
     /* 2350642 */ GIM_Try, /*On fail goto*//*Label 32643*/ GIMT_Encode4(2350749),
     /* 2350647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2350650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350658 */   GIM_Try, /*On fail goto*//*Label 32644*/ GIMT_Encode4(2350703), // Rule ID 56352 //
     /* 2350663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2350666 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2350669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2350683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350702 */     // GIR_Coverage, 56352,
     /* 2350702 */     GIR_EraseRootFromParent_Done,
     /* 2350703 */   // Label 32644: @2350703
     /* 2350703 */   GIM_Try, /*On fail goto*//*Label 32645*/ GIMT_Encode4(2350748), // Rule ID 56353 //
     /* 2350708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2350711 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2350714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2350728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350747 */     // GIR_Coverage, 56353,
     /* 2350747 */     GIR_EraseRootFromParent_Done,
     /* 2350748 */   // Label 32645: @2350748
     /* 2350748 */   GIM_Reject,
     /* 2350749 */ // Label 32643: @2350749
     /* 2350749 */ GIM_Reject,
     /* 2350750 */ // Label 32600: @2350750
     /* 2350750 */ GIM_Try, /*On fail goto*//*Label 32646*/ GIMT_Encode4(2350857),
     /* 2350755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2350758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350766 */   GIM_Try, /*On fail goto*//*Label 32647*/ GIMT_Encode4(2350811), // Rule ID 56432 //
     /* 2350771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2350774 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2350777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2350791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350810 */     // GIR_Coverage, 56432,
     /* 2350810 */     GIR_EraseRootFromParent_Done,
     /* 2350811 */   // Label 32647: @2350811
     /* 2350811 */   GIM_Try, /*On fail goto*//*Label 32648*/ GIMT_Encode4(2350856), // Rule ID 56433 //
     /* 2350816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2350819 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2350822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2350836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350855 */     // GIR_Coverage, 56433,
     /* 2350855 */     GIR_EraseRootFromParent_Done,
     /* 2350856 */   // Label 32648: @2350856
     /* 2350856 */   GIM_Reject,
     /* 2350857 */ // Label 32646: @2350857
     /* 2350857 */ GIM_Reject,
     /* 2350858 */ // Label 32601: @2350858
     /* 2350858 */ GIM_Try, /*On fail goto*//*Label 32649*/ GIMT_Encode4(2350965),
     /* 2350863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2350866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350874 */   GIM_Try, /*On fail goto*//*Label 32650*/ GIMT_Encode4(2350919), // Rule ID 56512 //
     /* 2350879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2350882 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2350885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2350899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350918 */     // GIR_Coverage, 56512,
     /* 2350918 */     GIR_EraseRootFromParent_Done,
     /* 2350919 */   // Label 32650: @2350919
     /* 2350919 */   GIM_Try, /*On fail goto*//*Label 32651*/ GIMT_Encode4(2350964), // Rule ID 56513 //
     /* 2350924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2350927 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2350930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2350944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2350953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350963 */     // GIR_Coverage, 56513,
     /* 2350963 */     GIR_EraseRootFromParent_Done,
     /* 2350964 */   // Label 32651: @2350964
     /* 2350964 */   GIM_Reject,
     /* 2350965 */ // Label 32649: @2350965
     /* 2350965 */ GIM_Reject,
     /* 2350966 */ // Label 32602: @2350966
     /* 2350966 */ GIM_Try, /*On fail goto*//*Label 32652*/ GIMT_Encode4(2351073),
     /* 2350971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2350974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350982 */   GIM_Try, /*On fail goto*//*Label 32653*/ GIMT_Encode4(2351027), // Rule ID 56372 //
     /* 2350987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2350990 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2350993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2351007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2351014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2351016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351026 */     // GIR_Coverage, 56372,
     /* 2351026 */     GIR_EraseRootFromParent_Done,
     /* 2351027 */   // Label 32653: @2351027
     /* 2351027 */   GIM_Try, /*On fail goto*//*Label 32654*/ GIMT_Encode4(2351072), // Rule ID 56373 //
     /* 2351032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2351035 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2351038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2351052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2351059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2351061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351071 */     // GIR_Coverage, 56373,
     /* 2351071 */     GIR_EraseRootFromParent_Done,
     /* 2351072 */   // Label 32654: @2351072
     /* 2351072 */   GIM_Reject,
     /* 2351073 */ // Label 32652: @2351073
     /* 2351073 */ GIM_Reject,
     /* 2351074 */ // Label 32603: @2351074
     /* 2351074 */ GIM_Try, /*On fail goto*//*Label 32655*/ GIMT_Encode4(2351181),
     /* 2351079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2351082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351090 */   GIM_Try, /*On fail goto*//*Label 32656*/ GIMT_Encode4(2351135), // Rule ID 56452 //
     /* 2351095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2351098 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2351101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2351115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2351122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2351124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351134 */     // GIR_Coverage, 56452,
     /* 2351134 */     GIR_EraseRootFromParent_Done,
     /* 2351135 */   // Label 32656: @2351135
     /* 2351135 */   GIM_Try, /*On fail goto*//*Label 32657*/ GIMT_Encode4(2351180), // Rule ID 56453 //
     /* 2351140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2351143 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2351146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2351160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2351167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2351169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351179 */     // GIR_Coverage, 56453,
     /* 2351179 */     GIR_EraseRootFromParent_Done,
     /* 2351180 */   // Label 32657: @2351180
     /* 2351180 */   GIM_Reject,
     /* 2351181 */ // Label 32655: @2351181
     /* 2351181 */ GIM_Reject,
     /* 2351182 */ // Label 32604: @2351182
     /* 2351182 */ GIM_Try, /*On fail goto*//*Label 32658*/ GIMT_Encode4(2351289),
     /* 2351187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2351190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351198 */   GIM_Try, /*On fail goto*//*Label 32659*/ GIMT_Encode4(2351243), // Rule ID 56392 //
     /* 2351203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2351206 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2351209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2351223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2351230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2351232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351242 */     // GIR_Coverage, 56392,
     /* 2351242 */     GIR_EraseRootFromParent_Done,
     /* 2351243 */   // Label 32659: @2351243
     /* 2351243 */   GIM_Try, /*On fail goto*//*Label 32660*/ GIMT_Encode4(2351288), // Rule ID 56393 //
     /* 2351248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2351251 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2351254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2351268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2351275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2351277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351287 */     // GIR_Coverage, 56393,
     /* 2351287 */     GIR_EraseRootFromParent_Done,
     /* 2351288 */   // Label 32660: @2351288
     /* 2351288 */   GIM_Reject,
     /* 2351289 */ // Label 32658: @2351289
     /* 2351289 */ GIM_Reject,
     /* 2351290 */ // Label 32605: @2351290
     /* 2351290 */ GIM_Reject,
     /* 2351291 */ // Label 72: @2351291
     /* 2351291 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32679*/ GIMT_Encode4(2357352),
     /* 2351302 */ /*GILLT_s16*//*Label 32661*/ GIMT_Encode4(2351422),
     /* 2351306 */ /*GILLT_s32*//*Label 32662*/ GIMT_Encode4(2352098),
     /* 2351310 */ /*GILLT_s64*//*Label 32663*/ GIMT_Encode4(2352774), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2351322 */ /*GILLT_nxv1s16*//*Label 32664*/ GIMT_Encode4(2353587),
     /* 2351326 */ /*GILLT_nxv1s32*//*Label 32665*/ GIMT_Encode4(2353838),
     /* 2351330 */ /*GILLT_nxv1s64*//*Label 32666*/ GIMT_Encode4(2354089), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2351342 */ /*GILLT_nxv2s16*//*Label 32667*/ GIMT_Encode4(2354340),
     /* 2351346 */ /*GILLT_nxv2s32*//*Label 32668*/ GIMT_Encode4(2354591),
     /* 2351350 */ /*GILLT_nxv2s64*//*Label 32669*/ GIMT_Encode4(2354842), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2351362 */ /*GILLT_nxv4s16*//*Label 32670*/ GIMT_Encode4(2355093),
     /* 2351366 */ /*GILLT_nxv4s32*//*Label 32671*/ GIMT_Encode4(2355344),
     /* 2351370 */ /*GILLT_nxv4s64*//*Label 32672*/ GIMT_Encode4(2355595), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2351382 */ /*GILLT_nxv8s16*//*Label 32673*/ GIMT_Encode4(2355846),
     /* 2351386 */ /*GILLT_nxv8s32*//*Label 32674*/ GIMT_Encode4(2356097),
     /* 2351390 */ /*GILLT_nxv8s64*//*Label 32675*/ GIMT_Encode4(2356348), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2351402 */ /*GILLT_nxv16s16*//*Label 32676*/ GIMT_Encode4(2356599),
     /* 2351406 */ /*GILLT_nxv16s32*//*Label 32677*/ GIMT_Encode4(2356850), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2351418 */ /*GILLT_nxv32s16*//*Label 32678*/ GIMT_Encode4(2357101),
     /* 2351422 */ // Label 32661: @2351422
     /* 2351422 */ GIM_Try, /*On fail goto*//*Label 32680*/ GIMT_Encode4(2352097),
     /* 2351427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2351430 */   GIM_Try, /*On fail goto*//*Label 32681*/ GIMT_Encode4(2351481), // Rule ID 1988 //
     /* 2351435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2351438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2351441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2351461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351468 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs2))  =>  (FSGNJN_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)
     /* 2351468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2351471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351480 */     // GIR_Coverage, 1988,
     /* 2351480 */     GIR_EraseRootFromParent_Done,
     /* 2351481 */   // Label 32681: @2351481
     /* 2351481 */   GIM_Try, /*On fail goto*//*Label 32682*/ GIMT_Encode4(2351532), // Rule ID 2021 //
     /* 2351486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2351489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2351492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2351512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351519 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2))  =>  (FSGNJN_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)
     /* 2351519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2351522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351531 */     // GIR_Coverage, 2021,
     /* 2351531 */     GIR_EraseRootFromParent_Done,
     /* 2351532 */   // Label 32682: @2351532
     /* 2351532 */   GIM_Try, /*On fail goto*//*Label 32683*/ GIMT_Encode4(2351562), // Rule ID 1986 //
     /* 2351537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2351540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2351543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351555 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2351555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2351560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351561 */     // GIR_Coverage, 1986,
     /* 2351561 */     GIR_Done,
     /* 2351562 */   // Label 32683: @2351562
     /* 2351562 */   GIM_Try, /*On fail goto*//*Label 32684*/ GIMT_Encode4(2351618), // Rule ID 1989 //
     /* 2351567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2351570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2351573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2351585 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2351585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2351588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2351592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351597 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351601 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2351604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2351609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351617 */     // GIR_Coverage, 1989,
     /* 2351617 */     GIR_EraseRootFromParent_Done,
     /* 2351618 */   // Label 32684: @2351618
     /* 2351618 */   GIM_Try, /*On fail goto*//*Label 32685*/ GIMT_Encode4(2351674), // Rule ID 1990 //
     /* 2351623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2351626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2351629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2351641 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2351641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2351644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2351648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351653 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351657 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2351660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2351665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351673 */     // GIR_Coverage, 1990,
     /* 2351673 */     GIR_EraseRootFromParent_Done,
     /* 2351674 */   // Label 32685: @2351674
     /* 2351674 */   GIM_Try, /*On fail goto*//*Label 32686*/ GIMT_Encode4(2351704), // Rule ID 2019 //
     /* 2351679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2351682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2351685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351697 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2351697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2351702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351703 */     // GIR_Coverage, 2019,
     /* 2351703 */     GIR_Done,
     /* 2351704 */   // Label 32686: @2351704
     /* 2351704 */   GIM_Try, /*On fail goto*//*Label 32687*/ GIMT_Encode4(2351760), // Rule ID 2022 //
     /* 2351709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2351712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2351715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2351727 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2351727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2351730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2351734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351739 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351743 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2351746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2351751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351759 */     // GIR_Coverage, 2022,
     /* 2351759 */     GIR_EraseRootFromParent_Done,
     /* 2351760 */   // Label 32687: @2351760
     /* 2351760 */   GIM_Try, /*On fail goto*//*Label 32688*/ GIMT_Encode4(2351816), // Rule ID 2023 //
     /* 2351765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2351768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2351771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2351783 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2351783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2351786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2351790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351795 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351799 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2351802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2351807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351815 */     // GIR_Coverage, 2023,
     /* 2351815 */     GIR_EraseRootFromParent_Done,
     /* 2351816 */   // Label 32688: @2351816
     /* 2351816 */   GIM_Try, /*On fail goto*//*Label 32689*/ GIMT_Encode4(2351872), // Rule ID 2292 //
     /* 2351821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2351824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2351827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2351839 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2351839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2351842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2351846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351851 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351855 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2351858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2351863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351871 */     // GIR_Coverage, 2292,
     /* 2351871 */     GIR_EraseRootFromParent_Done,
     /* 2351872 */   // Label 32689: @2351872
     /* 2351872 */   GIM_Try, /*On fail goto*//*Label 32690*/ GIMT_Encode4(2351928), // Rule ID 2293 //
     /* 2351877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2351880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2351883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2351891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2351895 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2351895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2351898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2351902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351907 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351911 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2351914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2351919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351927 */     // GIR_Coverage, 2293,
     /* 2351927 */     GIR_EraseRootFromParent_Done,
     /* 2351928 */   // Label 32690: @2351928
     /* 2351928 */   GIM_Try, /*On fail goto*//*Label 32691*/ GIMT_Encode4(2351984), // Rule ID 2304 //
     /* 2351933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2351936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2351939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2351951 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2351951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2351954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2351958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351963 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351967 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2351970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2351975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351983 */     // GIR_Coverage, 2304,
     /* 2351983 */     GIR_EraseRootFromParent_Done,
     /* 2351984 */   // Label 32691: @2351984
     /* 2351984 */   GIM_Try, /*On fail goto*//*Label 32692*/ GIMT_Encode4(2352040), // Rule ID 2305 //
     /* 2351989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2351992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2351995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2352003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2352007 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2352007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2352010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2352014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2352023 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2352026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2352031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352039 */     // GIR_Coverage, 2305,
     /* 2352039 */     GIR_EraseRootFromParent_Done,
     /* 2352040 */   // Label 32692: @2352040
     /* 2352040 */   GIM_Try, /*On fail goto*//*Label 32693*/ GIMT_Encode4(2352096), // Rule ID 2312 //
     /* 2352045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2352048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2352051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2352055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2352059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2352063 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_INX:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2352063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2352066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2352070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2352079 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2352082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2352087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352095 */     // GIR_Coverage, 2312,
     /* 2352095 */     GIR_EraseRootFromParent_Done,
     /* 2352096 */   // Label 32693: @2352096
     /* 2352096 */   GIM_Reject,
     /* 2352097 */ // Label 32680: @2352097
     /* 2352097 */ GIM_Reject,
     /* 2352098 */ // Label 32662: @2352098
     /* 2352098 */ GIM_Try, /*On fail goto*//*Label 32694*/ GIMT_Encode4(2352773),
     /* 2352103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2352106 */   GIM_Try, /*On fail goto*//*Label 32695*/ GIMT_Encode4(2352157), // Rule ID 1289 //
     /* 2352111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2352114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2352117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2352137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352144 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs2))  =>  (FSGNJN_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)
     /* 2352144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2352147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352156 */     // GIR_Coverage, 1289,
     /* 2352156 */     GIR_EraseRootFromParent_Done,
     /* 2352157 */   // Label 32695: @2352157
     /* 2352157 */   GIM_Try, /*On fail goto*//*Label 32696*/ GIMT_Encode4(2352208), // Rule ID 1310 //
     /* 2352162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2352165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2352168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2352188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352195 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2))  =>  (FSGNJN_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)
     /* 2352195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2352198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352207 */     // GIR_Coverage, 1310,
     /* 2352207 */     GIR_EraseRootFromParent_Done,
     /* 2352208 */   // Label 32696: @2352208
     /* 2352208 */   GIM_Try, /*On fail goto*//*Label 32697*/ GIMT_Encode4(2352238), // Rule ID 1285 //
     /* 2352213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2352216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2352219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352231 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2352231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2352236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352237 */     // GIR_Coverage, 1285,
     /* 2352237 */     GIR_Done,
     /* 2352238 */   // Label 32697: @2352238
     /* 2352238 */   GIM_Try, /*On fail goto*//*Label 32698*/ GIMT_Encode4(2352268), // Rule ID 1286 //
     /* 2352243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2352246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2352249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352261 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2352261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2352266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352267 */     // GIR_Coverage, 1286,
     /* 2352267 */     GIR_Done,
     /* 2352268 */   // Label 32698: @2352268
     /* 2352268 */   GIM_Try, /*On fail goto*//*Label 32699*/ GIMT_Encode4(2352324), // Rule ID 1625 //
     /* 2352273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2352276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2352279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2352291 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2352291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2352294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2352298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352303 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2352307 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2352310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2352315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352323 */     // GIR_Coverage, 1625,
     /* 2352323 */     GIR_EraseRootFromParent_Done,
     /* 2352324 */   // Label 32699: @2352324
     /* 2352324 */   GIM_Try, /*On fail goto*//*Label 32700*/ GIMT_Encode4(2352380), // Rule ID 1626 //
     /* 2352329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2352332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2352335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2352347 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2352347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2352350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2352354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352359 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2352363 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2352366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2352371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352379 */     // GIR_Coverage, 1626,
     /* 2352379 */     GIR_EraseRootFromParent_Done,
     /* 2352380 */   // Label 32700: @2352380
     /* 2352380 */   GIM_Try, /*On fail goto*//*Label 32701*/ GIMT_Encode4(2352436), // Rule ID 1656 //
     /* 2352385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2352388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2352391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2352403 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_INX:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2352403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2352406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2352410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352415 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2352419 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2352422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2352427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352435 */     // GIR_Coverage, 1656,
     /* 2352435 */     GIR_EraseRootFromParent_Done,
     /* 2352436 */   // Label 32701: @2352436
     /* 2352436 */   GIM_Try, /*On fail goto*//*Label 32702*/ GIMT_Encode4(2352492), // Rule ID 1680 //
     /* 2352441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2352444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2352447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2352459 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2352459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2352462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2352466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352471 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2352475 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2352478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2352483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352491 */     // GIR_Coverage, 1680,
     /* 2352491 */     GIR_EraseRootFromParent_Done,
     /* 2352492 */   // Label 32702: @2352492
     /* 2352492 */   GIM_Try, /*On fail goto*//*Label 32703*/ GIMT_Encode4(2352548), // Rule ID 1681 //
     /* 2352497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2352500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2352503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2352515 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2352515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2352518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2352522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352527 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2352531 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2352534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2352539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352547 */     // GIR_Coverage, 1681,
     /* 2352547 */     GIR_EraseRootFromParent_Done,
     /* 2352548 */   // Label 32703: @2352548
     /* 2352548 */   GIM_Try, /*On fail goto*//*Label 32704*/ GIMT_Encode4(2352604), // Rule ID 2164 //
     /* 2352553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2352556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2352559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2352571 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2352571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2352574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2352578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2352587 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2352590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2352595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352603 */     // GIR_Coverage, 2164,
     /* 2352603 */     GIR_EraseRootFromParent_Done,
     /* 2352604 */   // Label 32704: @2352604
     /* 2352604 */   GIM_Try, /*On fail goto*//*Label 32705*/ GIMT_Encode4(2352660), // Rule ID 2165 //
     /* 2352609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2352612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2352615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2352627 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2352627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2352630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2352634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352639 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2352643 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2352646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2352651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352659 */     // GIR_Coverage, 2165,
     /* 2352659 */     GIR_EraseRootFromParent_Done,
     /* 2352660 */   // Label 32705: @2352660
     /* 2352660 */   GIM_Try, /*On fail goto*//*Label 32706*/ GIMT_Encode4(2352716), // Rule ID 2178 //
     /* 2352665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2352668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2352671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2352683 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2352683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2352686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2352690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352695 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2352699 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2352702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2352707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352715 */     // GIR_Coverage, 2178,
     /* 2352715 */     GIR_EraseRootFromParent_Done,
     /* 2352716 */   // Label 32706: @2352716
     /* 2352716 */   GIM_Try, /*On fail goto*//*Label 32707*/ GIMT_Encode4(2352772), // Rule ID 2179 //
     /* 2352721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2352724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2352727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2352735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2352739 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2352739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2352742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2352746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352751 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2352755 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2352758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2352763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352771 */     // GIR_Coverage, 2179,
     /* 2352771 */     GIR_EraseRootFromParent_Done,
     /* 2352772 */   // Label 32707: @2352772
     /* 2352772 */   GIM_Reject,
     /* 2352773 */ // Label 32694: @2352773
     /* 2352773 */ GIM_Reject,
     /* 2352774 */ // Label 32663: @2352774
     /* 2352774 */ GIM_Try, /*On fail goto*//*Label 32708*/ GIMT_Encode4(2353586),
     /* 2352779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2352782 */   GIM_Try, /*On fail goto*//*Label 32709*/ GIMT_Encode4(2352833), // Rule ID 1622 //
     /* 2352787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2352790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2352793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2352797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2352801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2352813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2352818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352820 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs2))  =>  (FSGNJN_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)
     /* 2352820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2352823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352832 */     // GIR_Coverage, 1622,
     /* 2352832 */     GIR_EraseRootFromParent_Done,
     /* 2352833 */   // Label 32709: @2352833
     /* 2352833 */   GIM_Try, /*On fail goto*//*Label 32710*/ GIMT_Encode4(2352884), // Rule ID 1654 //
     /* 2352838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2352841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2352844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2352848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2352852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2352864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2352869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352871 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)
     /* 2352871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2352874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352883 */     // GIR_Coverage, 1654,
     /* 2352883 */     GIR_EraseRootFromParent_Done,
     /* 2352884 */   // Label 32710: @2352884
     /* 2352884 */   GIM_Try, /*On fail goto*//*Label 32711*/ GIMT_Encode4(2352935), // Rule ID 1677 //
     /* 2352889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2352892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2352895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2352899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2352903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2352915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2352920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352922 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)
     /* 2352922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2352925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352934 */     // GIR_Coverage, 1677,
     /* 2352934 */     GIR_EraseRootFromParent_Done,
     /* 2352935 */   // Label 32711: @2352935
     /* 2352935 */   GIM_Try, /*On fail goto*//*Label 32712*/ GIMT_Encode4(2352965), // Rule ID 1620 //
     /* 2352940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2352943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2352946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2352950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2352954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2352958 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2352958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2352963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352964 */     // GIR_Coverage, 1620,
     /* 2352964 */     GIR_Done,
     /* 2352965 */   // Label 32712: @2352965
     /* 2352965 */   GIM_Try, /*On fail goto*//*Label 32713*/ GIMT_Encode4(2353021), // Rule ID 1623 //
     /* 2352970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2352973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2352976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2352980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2352984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2352988 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2352988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2352991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2352995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2353004 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2353007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2353012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353020 */     // GIR_Coverage, 1623,
     /* 2353020 */     GIR_EraseRootFromParent_Done,
     /* 2353021 */   // Label 32713: @2353021
     /* 2353021 */   GIM_Try, /*On fail goto*//*Label 32714*/ GIMT_Encode4(2353077), // Rule ID 1624 //
     /* 2353026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2353029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2353032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2353036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2353040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2353044 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2353044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2353047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2353051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2353060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2353063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2353068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353076 */     // GIR_Coverage, 1624,
     /* 2353076 */     GIR_EraseRootFromParent_Done,
     /* 2353077 */   // Label 32714: @2353077
     /* 2353077 */   GIM_Try, /*On fail goto*//*Label 32715*/ GIMT_Encode4(2353107), // Rule ID 1652 //
     /* 2353082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2353085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2353088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2353092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2353096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2353100 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2353100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2353105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353106 */     // GIR_Coverage, 1652,
     /* 2353106 */     GIR_Done,
     /* 2353107 */   // Label 32715: @2353107
     /* 2353107 */   GIM_Try, /*On fail goto*//*Label 32716*/ GIMT_Encode4(2353163), // Rule ID 1655 //
     /* 2353112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2353115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2353118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2353122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2353126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2353130 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_INX:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2353130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2353133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2353137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2353146 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2353149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2353154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353162 */     // GIR_Coverage, 1655,
     /* 2353162 */     GIR_EraseRootFromParent_Done,
     /* 2353163 */   // Label 32716: @2353163
     /* 2353163 */   GIM_Try, /*On fail goto*//*Label 32717*/ GIMT_Encode4(2353193), // Rule ID 1675 //
     /* 2353168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2353171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2353174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353186 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2353186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2353191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353192 */     // GIR_Coverage, 1675,
     /* 2353192 */     GIR_Done,
     /* 2353193 */   // Label 32717: @2353193
     /* 2353193 */   GIM_Try, /*On fail goto*//*Label 32718*/ GIMT_Encode4(2353249), // Rule ID 1678 //
     /* 2353198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2353201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2353204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2353216 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2353216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2353219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2353223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2353232 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2353235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2353240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353248 */     // GIR_Coverage, 1678,
     /* 2353248 */     GIR_EraseRootFromParent_Done,
     /* 2353249 */   // Label 32718: @2353249
     /* 2353249 */   GIM_Try, /*On fail goto*//*Label 32719*/ GIMT_Encode4(2353305), // Rule ID 1679 //
     /* 2353254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2353257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2353260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2353272 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2353272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2353275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2353279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353284 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2353288 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2353291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2353296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353304 */     // GIR_Coverage, 1679,
     /* 2353304 */     GIR_EraseRootFromParent_Done,
     /* 2353305 */   // Label 32719: @2353305
     /* 2353305 */   GIM_Try, /*On fail goto*//*Label 32720*/ GIMT_Encode4(2353361), // Rule ID 2294 //
     /* 2353310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2353313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2353316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2353320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2353324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2353328 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2353328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2353331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2353335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353340 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2353344 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2353347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2353352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353360 */     // GIR_Coverage, 2294,
     /* 2353360 */     GIR_EraseRootFromParent_Done,
     /* 2353361 */   // Label 32720: @2353361
     /* 2353361 */   GIM_Try, /*On fail goto*//*Label 32721*/ GIMT_Encode4(2353417), // Rule ID 2295 //
     /* 2353366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2353369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2353372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2353376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2353380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2353384 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2353384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2353387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2353391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2353400 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2353403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2353408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353416 */     // GIR_Coverage, 2295,
     /* 2353416 */     GIR_EraseRootFromParent_Done,
     /* 2353417 */   // Label 32721: @2353417
     /* 2353417 */   GIM_Try, /*On fail goto*//*Label 32722*/ GIMT_Encode4(2353473), // Rule ID 2306 //
     /* 2353422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2353425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2353428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2353440 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2353440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2353443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2353447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2353456 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2353459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2353464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353472 */     // GIR_Coverage, 2306,
     /* 2353472 */     GIR_EraseRootFromParent_Done,
     /* 2353473 */   // Label 32722: @2353473
     /* 2353473 */   GIM_Try, /*On fail goto*//*Label 32723*/ GIMT_Encode4(2353529), // Rule ID 2307 //
     /* 2353478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2353481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2353484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2353496 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2353496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2353499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2353503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2353512 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2353515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2353520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353528 */     // GIR_Coverage, 2307,
     /* 2353528 */     GIR_EraseRootFromParent_Done,
     /* 2353529 */   // Label 32723: @2353529
     /* 2353529 */   GIM_Try, /*On fail goto*//*Label 32724*/ GIMT_Encode4(2353585), // Rule ID 2313 //
     /* 2353534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2353537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2353540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2353544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2353548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2353552 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_INX:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2353552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2353555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2353559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353564 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2353568 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2353571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2353576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353584 */     // GIR_Coverage, 2313,
     /* 2353584 */     GIR_EraseRootFromParent_Done,
     /* 2353585 */   // Label 32724: @2353585
     /* 2353585 */   GIM_Reject,
     /* 2353586 */ // Label 32708: @2353586
     /* 2353586 */ GIM_Reject,
     /* 2353587 */ // Label 32664: @2353587
     /* 2353587 */ GIM_Try, /*On fail goto*//*Label 32725*/ GIMT_Encode4(2353837),
     /* 2353592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2353595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2353598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353606 */   GIM_Try, /*On fail goto*//*Label 32726*/ GIMT_Encode4(2353672), // Rule ID 56242 //
     /* 2353611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2353626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353633 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2353636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2353650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353671 */     // GIR_Coverage, 56242,
     /* 2353671 */     GIR_EraseRootFromParent_Done,
     /* 2353672 */   // Label 32726: @2353672
     /* 2353672 */   GIM_Try, /*On fail goto*//*Label 32727*/ GIMT_Encode4(2353738), // Rule ID 56243 //
     /* 2353677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2353680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2353692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353699 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2353702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2353716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353737 */     // GIR_Coverage, 56243,
     /* 2353737 */     GIR_EraseRootFromParent_Done,
     /* 2353738 */   // Label 32727: @2353738
     /* 2353738 */   GIM_Try, /*On fail goto*//*Label 32728*/ GIMT_Encode4(2353787), // Rule ID 56236 //
     /* 2353743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353750 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2353753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2353767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353786 */     // GIR_Coverage, 56236,
     /* 2353786 */     GIR_EraseRootFromParent_Done,
     /* 2353787 */   // Label 32728: @2353787
     /* 2353787 */   GIM_Try, /*On fail goto*//*Label 32729*/ GIMT_Encode4(2353836), // Rule ID 56237 //
     /* 2353792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2353795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353799 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2353802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2353816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353835 */     // GIR_Coverage, 56237,
     /* 2353835 */     GIR_EraseRootFromParent_Done,
     /* 2353836 */   // Label 32729: @2353836
     /* 2353836 */   GIM_Reject,
     /* 2353837 */ // Label 32725: @2353837
     /* 2353837 */ GIM_Reject,
     /* 2353838 */ // Label 32665: @2353838
     /* 2353838 */ GIM_Try, /*On fail goto*//*Label 32730*/ GIMT_Encode4(2354088),
     /* 2353843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2353846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2353849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353857 */   GIM_Try, /*On fail goto*//*Label 32731*/ GIMT_Encode4(2353923), // Rule ID 56282 //
     /* 2353862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2353865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2353877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353884 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2353887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2353901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353922 */     // GIR_Coverage, 56282,
     /* 2353922 */     GIR_EraseRootFromParent_Done,
     /* 2353923 */   // Label 32731: @2353923
     /* 2353923 */   GIM_Try, /*On fail goto*//*Label 32732*/ GIMT_Encode4(2353989), // Rule ID 56283 //
     /* 2353928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2353931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2353943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353950 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2353953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2353967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353988 */     // GIR_Coverage, 56283,
     /* 2353988 */     GIR_EraseRootFromParent_Done,
     /* 2353989 */   // Label 32732: @2353989
     /* 2353989 */   GIM_Try, /*On fail goto*//*Label 32733*/ GIMT_Encode4(2354038), // Rule ID 56276 //
     /* 2353994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2353997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354001 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2354004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2354018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354037 */     // GIR_Coverage, 56276,
     /* 2354037 */     GIR_EraseRootFromParent_Done,
     /* 2354038 */   // Label 32733: @2354038
     /* 2354038 */   GIM_Try, /*On fail goto*//*Label 32734*/ GIMT_Encode4(2354087), // Rule ID 56277 //
     /* 2354043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354050 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2354053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2354067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354086 */     // GIR_Coverage, 56277,
     /* 2354086 */     GIR_EraseRootFromParent_Done,
     /* 2354087 */   // Label 32734: @2354087
     /* 2354087 */   GIM_Reject,
     /* 2354088 */ // Label 32730: @2354088
     /* 2354088 */ GIM_Reject,
     /* 2354089 */ // Label 32666: @2354089
     /* 2354089 */ GIM_Try, /*On fail goto*//*Label 32735*/ GIMT_Encode4(2354339),
     /* 2354094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2354097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2354100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354108 */   GIM_Try, /*On fail goto*//*Label 32736*/ GIMT_Encode4(2354174), // Rule ID 56342 //
     /* 2354113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2354116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2354128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354135 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2354138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2354152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354173 */     // GIR_Coverage, 56342,
     /* 2354173 */     GIR_EraseRootFromParent_Done,
     /* 2354174 */   // Label 32736: @2354174
     /* 2354174 */   GIM_Try, /*On fail goto*//*Label 32737*/ GIMT_Encode4(2354240), // Rule ID 56343 //
     /* 2354179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2354182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2354194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354201 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2354204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2354218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354239 */     // GIR_Coverage, 56343,
     /* 2354239 */     GIR_EraseRootFromParent_Done,
     /* 2354240 */   // Label 32737: @2354240
     /* 2354240 */   GIM_Try, /*On fail goto*//*Label 32738*/ GIMT_Encode4(2354289), // Rule ID 56336 //
     /* 2354245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2354248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354252 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2354255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2354269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354288 */     // GIR_Coverage, 56336,
     /* 2354288 */     GIR_EraseRootFromParent_Done,
     /* 2354289 */   // Label 32738: @2354289
     /* 2354289 */   GIM_Try, /*On fail goto*//*Label 32739*/ GIMT_Encode4(2354338), // Rule ID 56337 //
     /* 2354294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2354297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354301 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2354304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2354318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354337 */     // GIR_Coverage, 56337,
     /* 2354337 */     GIR_EraseRootFromParent_Done,
     /* 2354338 */   // Label 32739: @2354338
     /* 2354338 */   GIM_Reject,
     /* 2354339 */ // Label 32735: @2354339
     /* 2354339 */ GIM_Reject,
     /* 2354340 */ // Label 32667: @2354340
     /* 2354340 */ GIM_Try, /*On fail goto*//*Label 32740*/ GIMT_Encode4(2354590),
     /* 2354345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2354348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2354351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354359 */   GIM_Try, /*On fail goto*//*Label 32741*/ GIMT_Encode4(2354425), // Rule ID 56262 //
     /* 2354364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2354379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354386 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2354389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2354403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354424 */     // GIR_Coverage, 56262,
     /* 2354424 */     GIR_EraseRootFromParent_Done,
     /* 2354425 */   // Label 32741: @2354425
     /* 2354425 */   GIM_Try, /*On fail goto*//*Label 32742*/ GIMT_Encode4(2354491), // Rule ID 56263 //
     /* 2354430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2354445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354452 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2354455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2354469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354490 */     // GIR_Coverage, 56263,
     /* 2354490 */     GIR_EraseRootFromParent_Done,
     /* 2354491 */   // Label 32742: @2354491
     /* 2354491 */   GIM_Try, /*On fail goto*//*Label 32743*/ GIMT_Encode4(2354540), // Rule ID 56256 //
     /* 2354496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354503 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2354506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2354520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354539 */     // GIR_Coverage, 56256,
     /* 2354539 */     GIR_EraseRootFromParent_Done,
     /* 2354540 */   // Label 32743: @2354540
     /* 2354540 */   GIM_Try, /*On fail goto*//*Label 32744*/ GIMT_Encode4(2354589), // Rule ID 56257 //
     /* 2354545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354552 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2354555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2354569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354588 */     // GIR_Coverage, 56257,
     /* 2354588 */     GIR_EraseRootFromParent_Done,
     /* 2354589 */   // Label 32744: @2354589
     /* 2354589 */   GIM_Reject,
     /* 2354590 */ // Label 32740: @2354590
     /* 2354590 */ GIM_Reject,
     /* 2354591 */ // Label 32668: @2354591
     /* 2354591 */ GIM_Try, /*On fail goto*//*Label 32745*/ GIMT_Encode4(2354841),
     /* 2354596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2354599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2354602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354610 */   GIM_Try, /*On fail goto*//*Label 32746*/ GIMT_Encode4(2354676), // Rule ID 56322 //
     /* 2354615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2354630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354637 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2354640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2354654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354675 */     // GIR_Coverage, 56322,
     /* 2354675 */     GIR_EraseRootFromParent_Done,
     /* 2354676 */   // Label 32746: @2354676
     /* 2354676 */   GIM_Try, /*On fail goto*//*Label 32747*/ GIMT_Encode4(2354742), // Rule ID 56323 //
     /* 2354681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2354696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354703 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2354706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2354720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354741 */     // GIR_Coverage, 56323,
     /* 2354741 */     GIR_EraseRootFromParent_Done,
     /* 2354742 */   // Label 32747: @2354742
     /* 2354742 */   GIM_Try, /*On fail goto*//*Label 32748*/ GIMT_Encode4(2354791), // Rule ID 56316 //
     /* 2354747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354754 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2354757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2354771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354790 */     // GIR_Coverage, 56316,
     /* 2354790 */     GIR_EraseRootFromParent_Done,
     /* 2354791 */   // Label 32748: @2354791
     /* 2354791 */   GIM_Try, /*On fail goto*//*Label 32749*/ GIMT_Encode4(2354840), // Rule ID 56317 //
     /* 2354796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354803 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2354806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2354820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354839 */     // GIR_Coverage, 56317,
     /* 2354839 */     GIR_EraseRootFromParent_Done,
     /* 2354840 */   // Label 32749: @2354840
     /* 2354840 */   GIM_Reject,
     /* 2354841 */ // Label 32745: @2354841
     /* 2354841 */ GIM_Reject,
     /* 2354842 */ // Label 32669: @2354842
     /* 2354842 */ GIM_Try, /*On fail goto*//*Label 32750*/ GIMT_Encode4(2355092),
     /* 2354847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2354850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2354853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354861 */   GIM_Try, /*On fail goto*//*Label 32751*/ GIMT_Encode4(2354927), // Rule ID 56482 //
     /* 2354866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2354869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2354881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354888 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2354891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2354905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354926 */     // GIR_Coverage, 56482,
     /* 2354926 */     GIR_EraseRootFromParent_Done,
     /* 2354927 */   // Label 32751: @2354927
     /* 2354927 */   GIM_Try, /*On fail goto*//*Label 32752*/ GIMT_Encode4(2354993), // Rule ID 56483 //
     /* 2354932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2354935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2354947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354954 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2354957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2354971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354992 */     // GIR_Coverage, 56483,
     /* 2354992 */     GIR_EraseRootFromParent_Done,
     /* 2354993 */   // Label 32752: @2354993
     /* 2354993 */   GIM_Try, /*On fail goto*//*Label 32753*/ GIMT_Encode4(2355042), // Rule ID 56476 //
     /* 2354998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2355001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355005 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2355008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2355022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2355037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355041 */     // GIR_Coverage, 56476,
     /* 2355041 */     GIR_EraseRootFromParent_Done,
     /* 2355042 */   // Label 32753: @2355042
     /* 2355042 */   GIM_Try, /*On fail goto*//*Label 32754*/ GIMT_Encode4(2355091), // Rule ID 56477 //
     /* 2355047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2355050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355054 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2355057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2355071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2355086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355090 */     // GIR_Coverage, 56477,
     /* 2355090 */     GIR_EraseRootFromParent_Done,
     /* 2355091 */   // Label 32754: @2355091
     /* 2355091 */   GIM_Reject,
     /* 2355092 */ // Label 32750: @2355092
     /* 2355092 */ GIM_Reject,
     /* 2355093 */ // Label 32670: @2355093
     /* 2355093 */ GIM_Try, /*On fail goto*//*Label 32755*/ GIMT_Encode4(2355343),
     /* 2355098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2355101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2355104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355112 */   GIM_Try, /*On fail goto*//*Label 32756*/ GIMT_Encode4(2355178), // Rule ID 56302 //
     /* 2355117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2355120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2355132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355139 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2355142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2355156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355177 */     // GIR_Coverage, 56302,
     /* 2355177 */     GIR_EraseRootFromParent_Done,
     /* 2355178 */   // Label 32756: @2355178
     /* 2355178 */   GIM_Try, /*On fail goto*//*Label 32757*/ GIMT_Encode4(2355244), // Rule ID 56303 //
     /* 2355183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2355186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2355198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355205 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2355208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2355222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355243 */     // GIR_Coverage, 56303,
     /* 2355243 */     GIR_EraseRootFromParent_Done,
     /* 2355244 */   // Label 32757: @2355244
     /* 2355244 */   GIM_Try, /*On fail goto*//*Label 32758*/ GIMT_Encode4(2355293), // Rule ID 56296 //
     /* 2355249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2355252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355256 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2355259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2355273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355292 */     // GIR_Coverage, 56296,
     /* 2355292 */     GIR_EraseRootFromParent_Done,
     /* 2355293 */   // Label 32758: @2355293
     /* 2355293 */   GIM_Try, /*On fail goto*//*Label 32759*/ GIMT_Encode4(2355342), // Rule ID 56297 //
     /* 2355298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2355301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355305 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2355308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2355322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355341 */     // GIR_Coverage, 56297,
     /* 2355341 */     GIR_EraseRootFromParent_Done,
     /* 2355342 */   // Label 32759: @2355342
     /* 2355342 */   GIM_Reject,
     /* 2355343 */ // Label 32755: @2355343
     /* 2355343 */ GIM_Reject,
     /* 2355344 */ // Label 32671: @2355344
     /* 2355344 */ GIM_Try, /*On fail goto*//*Label 32760*/ GIMT_Encode4(2355594),
     /* 2355349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2355352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2355355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355363 */   GIM_Try, /*On fail goto*//*Label 32761*/ GIMT_Encode4(2355429), // Rule ID 56422 //
     /* 2355368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2355371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2355383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355390 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2355393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2355407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355428 */     // GIR_Coverage, 56422,
     /* 2355428 */     GIR_EraseRootFromParent_Done,
     /* 2355429 */   // Label 32761: @2355429
     /* 2355429 */   GIM_Try, /*On fail goto*//*Label 32762*/ GIMT_Encode4(2355495), // Rule ID 56423 //
     /* 2355434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2355437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2355449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355456 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2355459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2355473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355494 */     // GIR_Coverage, 56423,
     /* 2355494 */     GIR_EraseRootFromParent_Done,
     /* 2355495 */   // Label 32762: @2355495
     /* 2355495 */   GIM_Try, /*On fail goto*//*Label 32763*/ GIMT_Encode4(2355544), // Rule ID 56416 //
     /* 2355500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2355503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355507 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2355510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2355524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355543 */     // GIR_Coverage, 56416,
     /* 2355543 */     GIR_EraseRootFromParent_Done,
     /* 2355544 */   // Label 32763: @2355544
     /* 2355544 */   GIM_Try, /*On fail goto*//*Label 32764*/ GIMT_Encode4(2355593), // Rule ID 56417 //
     /* 2355549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2355552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355556 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2355559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2355573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355592 */     // GIR_Coverage, 56417,
     /* 2355592 */     GIR_EraseRootFromParent_Done,
     /* 2355593 */   // Label 32764: @2355593
     /* 2355593 */   GIM_Reject,
     /* 2355594 */ // Label 32760: @2355594
     /* 2355594 */ GIM_Reject,
     /* 2355595 */ // Label 32672: @2355595
     /* 2355595 */ GIM_Try, /*On fail goto*//*Label 32765*/ GIMT_Encode4(2355845),
     /* 2355600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2355603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2355606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355614 */   GIM_Try, /*On fail goto*//*Label 32766*/ GIMT_Encode4(2355680), // Rule ID 56502 //
     /* 2355619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2355622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2355634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355641 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2355644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2355658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2355675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355679 */     // GIR_Coverage, 56502,
     /* 2355679 */     GIR_EraseRootFromParent_Done,
     /* 2355680 */   // Label 32766: @2355680
     /* 2355680 */   GIM_Try, /*On fail goto*//*Label 32767*/ GIMT_Encode4(2355746), // Rule ID 56503 //
     /* 2355685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2355688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2355700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355707 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2355710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2355724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2355741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355745 */     // GIR_Coverage, 56503,
     /* 2355745 */     GIR_EraseRootFromParent_Done,
     /* 2355746 */   // Label 32767: @2355746
     /* 2355746 */   GIM_Try, /*On fail goto*//*Label 32768*/ GIMT_Encode4(2355795), // Rule ID 56496 //
     /* 2355751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2355754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355758 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2355761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2355775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2355790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355794 */     // GIR_Coverage, 56496,
     /* 2355794 */     GIR_EraseRootFromParent_Done,
     /* 2355795 */   // Label 32768: @2355795
     /* 2355795 */   GIM_Try, /*On fail goto*//*Label 32769*/ GIMT_Encode4(2355844), // Rule ID 56497 //
     /* 2355800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2355803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355807 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2355810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2355824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2355839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355843 */     // GIR_Coverage, 56497,
     /* 2355843 */     GIR_EraseRootFromParent_Done,
     /* 2355844 */   // Label 32769: @2355844
     /* 2355844 */   GIM_Reject,
     /* 2355845 */ // Label 32765: @2355845
     /* 2355845 */ GIM_Reject,
     /* 2355846 */ // Label 32673: @2355846
     /* 2355846 */ GIM_Try, /*On fail goto*//*Label 32770*/ GIMT_Encode4(2356096),
     /* 2355851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2355854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2355857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355865 */   GIM_Try, /*On fail goto*//*Label 32771*/ GIMT_Encode4(2355931), // Rule ID 56362 //
     /* 2355870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2355873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2355885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355892 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2355895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2355909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355930 */     // GIR_Coverage, 56362,
     /* 2355930 */     GIR_EraseRootFromParent_Done,
     /* 2355931 */   // Label 32771: @2355931
     /* 2355931 */   GIM_Try, /*On fail goto*//*Label 32772*/ GIMT_Encode4(2355997), // Rule ID 56363 //
     /* 2355936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2355939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2355951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355958 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2355961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2355975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355996 */     // GIR_Coverage, 56363,
     /* 2355996 */     GIR_EraseRootFromParent_Done,
     /* 2355997 */   // Label 32772: @2355997
     /* 2355997 */   GIM_Try, /*On fail goto*//*Label 32773*/ GIMT_Encode4(2356046), // Rule ID 56356 //
     /* 2356002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2356005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356009 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2356012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2356026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356045 */     // GIR_Coverage, 56356,
     /* 2356045 */     GIR_EraseRootFromParent_Done,
     /* 2356046 */   // Label 32773: @2356046
     /* 2356046 */   GIM_Try, /*On fail goto*//*Label 32774*/ GIMT_Encode4(2356095), // Rule ID 56357 //
     /* 2356051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2356054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356058 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2356061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2356075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356094 */     // GIR_Coverage, 56357,
     /* 2356094 */     GIR_EraseRootFromParent_Done,
     /* 2356095 */   // Label 32774: @2356095
     /* 2356095 */   GIM_Reject,
     /* 2356096 */ // Label 32770: @2356096
     /* 2356096 */ GIM_Reject,
     /* 2356097 */ // Label 32674: @2356097
     /* 2356097 */ GIM_Try, /*On fail goto*//*Label 32775*/ GIMT_Encode4(2356347),
     /* 2356102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2356105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2356108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356116 */   GIM_Try, /*On fail goto*//*Label 32776*/ GIMT_Encode4(2356182), // Rule ID 56442 //
     /* 2356121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2356124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2356136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356143 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2356146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2356160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356181 */     // GIR_Coverage, 56442,
     /* 2356181 */     GIR_EraseRootFromParent_Done,
     /* 2356182 */   // Label 32776: @2356182
     /* 2356182 */   GIM_Try, /*On fail goto*//*Label 32777*/ GIMT_Encode4(2356248), // Rule ID 56443 //
     /* 2356187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2356190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2356202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356209 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2356212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2356226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356247 */     // GIR_Coverage, 56443,
     /* 2356247 */     GIR_EraseRootFromParent_Done,
     /* 2356248 */   // Label 32777: @2356248
     /* 2356248 */   GIM_Try, /*On fail goto*//*Label 32778*/ GIMT_Encode4(2356297), // Rule ID 56436 //
     /* 2356253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2356256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356260 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2356263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2356277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356296 */     // GIR_Coverage, 56436,
     /* 2356296 */     GIR_EraseRootFromParent_Done,
     /* 2356297 */   // Label 32778: @2356297
     /* 2356297 */   GIM_Try, /*On fail goto*//*Label 32779*/ GIMT_Encode4(2356346), // Rule ID 56437 //
     /* 2356302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2356305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356309 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2356312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2356326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356345 */     // GIR_Coverage, 56437,
     /* 2356345 */     GIR_EraseRootFromParent_Done,
     /* 2356346 */   // Label 32779: @2356346
     /* 2356346 */   GIM_Reject,
     /* 2356347 */ // Label 32775: @2356347
     /* 2356347 */ GIM_Reject,
     /* 2356348 */ // Label 32675: @2356348
     /* 2356348 */ GIM_Try, /*On fail goto*//*Label 32780*/ GIMT_Encode4(2356598),
     /* 2356353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2356356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2356359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356367 */   GIM_Try, /*On fail goto*//*Label 32781*/ GIMT_Encode4(2356433), // Rule ID 56522 //
     /* 2356372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2356375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2356387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356394 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2356397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2356411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356432 */     // GIR_Coverage, 56522,
     /* 2356432 */     GIR_EraseRootFromParent_Done,
     /* 2356433 */   // Label 32781: @2356433
     /* 2356433 */   GIM_Try, /*On fail goto*//*Label 32782*/ GIMT_Encode4(2356499), // Rule ID 56523 //
     /* 2356438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2356441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2356453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356460 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2356463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2356477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356498 */     // GIR_Coverage, 56523,
     /* 2356498 */     GIR_EraseRootFromParent_Done,
     /* 2356499 */   // Label 32782: @2356499
     /* 2356499 */   GIM_Try, /*On fail goto*//*Label 32783*/ GIMT_Encode4(2356548), // Rule ID 56516 //
     /* 2356504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2356507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356511 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2356514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2356528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356547 */     // GIR_Coverage, 56516,
     /* 2356547 */     GIR_EraseRootFromParent_Done,
     /* 2356548 */   // Label 32783: @2356548
     /* 2356548 */   GIM_Try, /*On fail goto*//*Label 32784*/ GIMT_Encode4(2356597), // Rule ID 56517 //
     /* 2356553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2356556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356560 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2356563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2356577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356596 */     // GIR_Coverage, 56517,
     /* 2356596 */     GIR_EraseRootFromParent_Done,
     /* 2356597 */   // Label 32784: @2356597
     /* 2356597 */   GIM_Reject,
     /* 2356598 */ // Label 32780: @2356598
     /* 2356598 */ GIM_Reject,
     /* 2356599 */ // Label 32676: @2356599
     /* 2356599 */ GIM_Try, /*On fail goto*//*Label 32785*/ GIMT_Encode4(2356849),
     /* 2356604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2356607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2356610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356618 */   GIM_Try, /*On fail goto*//*Label 32786*/ GIMT_Encode4(2356684), // Rule ID 56382 //
     /* 2356623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2356626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2356638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356645 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2356648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2356662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356683 */     // GIR_Coverage, 56382,
     /* 2356683 */     GIR_EraseRootFromParent_Done,
     /* 2356684 */   // Label 32786: @2356684
     /* 2356684 */   GIM_Try, /*On fail goto*//*Label 32787*/ GIMT_Encode4(2356750), // Rule ID 56383 //
     /* 2356689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2356692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2356704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356711 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2356714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2356728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356749 */     // GIR_Coverage, 56383,
     /* 2356749 */     GIR_EraseRootFromParent_Done,
     /* 2356750 */   // Label 32787: @2356750
     /* 2356750 */   GIM_Try, /*On fail goto*//*Label 32788*/ GIMT_Encode4(2356799), // Rule ID 56376 //
     /* 2356755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2356758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356762 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2356765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2356779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356798 */     // GIR_Coverage, 56376,
     /* 2356798 */     GIR_EraseRootFromParent_Done,
     /* 2356799 */   // Label 32788: @2356799
     /* 2356799 */   GIM_Try, /*On fail goto*//*Label 32789*/ GIMT_Encode4(2356848), // Rule ID 56377 //
     /* 2356804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2356807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356811 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2356814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2356828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356847 */     // GIR_Coverage, 56377,
     /* 2356847 */     GIR_EraseRootFromParent_Done,
     /* 2356848 */   // Label 32789: @2356848
     /* 2356848 */   GIM_Reject,
     /* 2356849 */ // Label 32785: @2356849
     /* 2356849 */ GIM_Reject,
     /* 2356850 */ // Label 32677: @2356850
     /* 2356850 */ GIM_Try, /*On fail goto*//*Label 32790*/ GIMT_Encode4(2357100),
     /* 2356855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2356858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2356861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356869 */   GIM_Try, /*On fail goto*//*Label 32791*/ GIMT_Encode4(2356935), // Rule ID 56462 //
     /* 2356874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2356877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2356889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356896 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2356899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2356913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356934 */     // GIR_Coverage, 56462,
     /* 2356934 */     GIR_EraseRootFromParent_Done,
     /* 2356935 */   // Label 32791: @2356935
     /* 2356935 */   GIM_Try, /*On fail goto*//*Label 32792*/ GIMT_Encode4(2357001), // Rule ID 56463 //
     /* 2356940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2356943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2356955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356962 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2356965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2356979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357000 */     // GIR_Coverage, 56463,
     /* 2357000 */     GIR_EraseRootFromParent_Done,
     /* 2357001 */   // Label 32792: @2357001
     /* 2357001 */   GIM_Try, /*On fail goto*//*Label 32793*/ GIMT_Encode4(2357050), // Rule ID 56456 //
     /* 2357006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2357009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357013 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2357016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2357030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357049 */     // GIR_Coverage, 56456,
     /* 2357049 */     GIR_EraseRootFromParent_Done,
     /* 2357050 */   // Label 32793: @2357050
     /* 2357050 */   GIM_Try, /*On fail goto*//*Label 32794*/ GIMT_Encode4(2357099), // Rule ID 56457 //
     /* 2357055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2357058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357062 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2357065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2357079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357098 */     // GIR_Coverage, 56457,
     /* 2357098 */     GIR_EraseRootFromParent_Done,
     /* 2357099 */   // Label 32794: @2357099
     /* 2357099 */   GIM_Reject,
     /* 2357100 */ // Label 32790: @2357100
     /* 2357100 */ GIM_Reject,
     /* 2357101 */ // Label 32678: @2357101
     /* 2357101 */ GIM_Try, /*On fail goto*//*Label 32795*/ GIMT_Encode4(2357351),
     /* 2357106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2357109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2357112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357120 */   GIM_Try, /*On fail goto*//*Label 32796*/ GIMT_Encode4(2357186), // Rule ID 56402 //
     /* 2357125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2357140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357147 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2357150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2357164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357185 */     // GIR_Coverage, 56402,
     /* 2357185 */     GIR_EraseRootFromParent_Done,
     /* 2357186 */   // Label 32796: @2357186
     /* 2357186 */   GIM_Try, /*On fail goto*//*Label 32797*/ GIMT_Encode4(2357252), // Rule ID 56403 //
     /* 2357191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2357194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2357206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357213 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2357216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2357230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357251 */     // GIR_Coverage, 56403,
     /* 2357251 */     GIR_EraseRootFromParent_Done,
     /* 2357252 */   // Label 32797: @2357252
     /* 2357252 */   GIM_Try, /*On fail goto*//*Label 32798*/ GIMT_Encode4(2357301), // Rule ID 56396 //
     /* 2357257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357264 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2357267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2357281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357300 */     // GIR_Coverage, 56396,
     /* 2357300 */     GIR_EraseRootFromParent_Done,
     /* 2357301 */   // Label 32798: @2357301
     /* 2357301 */   GIM_Try, /*On fail goto*//*Label 32799*/ GIMT_Encode4(2357350), // Rule ID 56397 //
     /* 2357306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2357309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357313 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2357316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2357330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357349 */     // GIR_Coverage, 56397,
     /* 2357349 */     GIR_EraseRootFromParent_Done,
     /* 2357350 */   // Label 32799: @2357350
     /* 2357350 */   GIM_Reject,
     /* 2357351 */ // Label 32795: @2357351
     /* 2357351 */ GIM_Reject,
     /* 2357352 */ // Label 32679: @2357352
     /* 2357352 */ GIM_Reject,
     /* 2357353 */ // Label 73: @2357353
     /* 2357353 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32803*/ GIMT_Encode4(2357542),
     /* 2357364 */ /*GILLT_s16*//*Label 32800*/ GIMT_Encode4(2357376),
     /* 2357368 */ /*GILLT_s32*//*Label 32801*/ GIMT_Encode4(2357426),
     /* 2357372 */ /*GILLT_s64*//*Label 32802*/ GIMT_Encode4(2357476),
     /* 2357376 */ // Label 32800: @2357376
     /* 2357376 */ GIM_Try, /*On fail goto*//*Label 32804*/ GIMT_Encode4(2357425),
     /* 2357381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2357384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2357388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2357392 */   GIM_Try, /*On fail goto*//*Label 32805*/ GIMT_Encode4(2357408), // Rule ID 2056 //
     /* 2357397 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2357397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2357400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357407 */     // GIR_Coverage, 2056,
     /* 2357407 */     GIR_EraseRootFromParent_Done,
     /* 2357408 */   // Label 32805: @2357408
     /* 2357408 */   GIM_Try, /*On fail goto*//*Label 32806*/ GIMT_Encode4(2357424), // Rule ID 2057 //
     /* 2357413 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2357413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2357416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357423 */     // GIR_Coverage, 2057,
     /* 2357423 */     GIR_EraseRootFromParent_Done,
     /* 2357424 */   // Label 32806: @2357424
     /* 2357424 */   GIM_Reject,
     /* 2357425 */ // Label 32804: @2357425
     /* 2357425 */ GIM_Reject,
     /* 2357426 */ // Label 32801: @2357426
     /* 2357426 */ GIM_Try, /*On fail goto*//*Label 32807*/ GIMT_Encode4(2357475),
     /* 2357431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2357434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2357438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2357442 */   GIM_Try, /*On fail goto*//*Label 32808*/ GIMT_Encode4(2357458), // Rule ID 1343 //
     /* 2357447 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2357447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2357450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357457 */     // GIR_Coverage, 1343,
     /* 2357457 */     GIR_EraseRootFromParent_Done,
     /* 2357458 */   // Label 32808: @2357458
     /* 2357458 */   GIM_Try, /*On fail goto*//*Label 32809*/ GIMT_Encode4(2357474), // Rule ID 1344 //
     /* 2357463 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2357463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2357466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357473 */     // GIR_Coverage, 1344,
     /* 2357473 */     GIR_EraseRootFromParent_Done,
     /* 2357474 */   // Label 32809: @2357474
     /* 2357474 */   GIM_Reject,
     /* 2357475 */ // Label 32807: @2357475
     /* 2357475 */ GIM_Reject,
     /* 2357476 */ // Label 32802: @2357476
     /* 2357476 */ GIM_Try, /*On fail goto*//*Label 32810*/ GIMT_Encode4(2357541),
     /* 2357481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2357484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357492 */   GIM_Try, /*On fail goto*//*Label 32811*/ GIMT_Encode4(2357508), // Rule ID 1720 //
     /* 2357497 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2357497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2357500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357507 */     // GIR_Coverage, 1720,
     /* 2357507 */     GIR_EraseRootFromParent_Done,
     /* 2357508 */   // Label 32811: @2357508
     /* 2357508 */   GIM_Try, /*On fail goto*//*Label 32812*/ GIMT_Encode4(2357524), // Rule ID 1721 //
     /* 2357513 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2357513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2357516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357523 */     // GIR_Coverage, 1721,
     /* 2357523 */     GIR_EraseRootFromParent_Done,
     /* 2357524 */   // Label 32812: @2357524
     /* 2357524 */   GIM_Try, /*On fail goto*//*Label 32813*/ GIMT_Encode4(2357540), // Rule ID 1722 //
     /* 2357529 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2357529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2357532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357539 */     // GIR_Coverage, 1722,
     /* 2357539 */     GIR_EraseRootFromParent_Done,
     /* 2357540 */   // Label 32813: @2357540
     /* 2357540 */   GIM_Reject,
     /* 2357541 */ // Label 32810: @2357541
     /* 2357541 */ GIM_Reject,
     /* 2357542 */ // Label 32803: @2357542
     /* 2357542 */ GIM_Reject,
     /* 2357543 */ // Label 74: @2357543
     /* 2357543 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32832*/ GIMT_Encode4(2359627),
     /* 2357554 */ /*GILLT_s16*//*Label 32814*/ GIMT_Encode4(2357674),
     /* 2357558 */ /*GILLT_s32*//*Label 32815*/ GIMT_Encode4(2357741),
     /* 2357562 */ /*GILLT_s64*//*Label 32816*/ GIMT_Encode4(2357808), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357574 */ /*GILLT_nxv1s16*//*Label 32817*/ GIMT_Encode4(2357902),
     /* 2357578 */ /*GILLT_nxv1s32*//*Label 32818*/ GIMT_Encode4(2358017),
     /* 2357582 */ /*GILLT_nxv1s64*//*Label 32819*/ GIMT_Encode4(2358132), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357594 */ /*GILLT_nxv2s16*//*Label 32820*/ GIMT_Encode4(2358247),
     /* 2357598 */ /*GILLT_nxv2s32*//*Label 32821*/ GIMT_Encode4(2358362),
     /* 2357602 */ /*GILLT_nxv2s64*//*Label 32822*/ GIMT_Encode4(2358477), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357614 */ /*GILLT_nxv4s16*//*Label 32823*/ GIMT_Encode4(2358592),
     /* 2357618 */ /*GILLT_nxv4s32*//*Label 32824*/ GIMT_Encode4(2358707),
     /* 2357622 */ /*GILLT_nxv4s64*//*Label 32825*/ GIMT_Encode4(2358822), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357634 */ /*GILLT_nxv8s16*//*Label 32826*/ GIMT_Encode4(2358937),
     /* 2357638 */ /*GILLT_nxv8s32*//*Label 32827*/ GIMT_Encode4(2359052),
     /* 2357642 */ /*GILLT_nxv8s64*//*Label 32828*/ GIMT_Encode4(2359167), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357654 */ /*GILLT_nxv16s16*//*Label 32829*/ GIMT_Encode4(2359282),
     /* 2357658 */ /*GILLT_nxv16s32*//*Label 32830*/ GIMT_Encode4(2359397), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357670 */ /*GILLT_nxv32s16*//*Label 32831*/ GIMT_Encode4(2359512),
     /* 2357674 */ // Label 32814: @2357674
     /* 2357674 */ GIM_Try, /*On fail goto*//*Label 32833*/ GIMT_Encode4(2357740),
     /* 2357679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2357682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2357685 */   GIM_Try, /*On fail goto*//*Label 32834*/ GIMT_Encode4(2357712), // Rule ID 2044 //
     /* 2357690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2357693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2357697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2357701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2357705 */     // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2357705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2357710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357711 */     // GIR_Coverage, 2044,
     /* 2357711 */     GIR_Done,
     /* 2357712 */   // Label 32834: @2357712
     /* 2357712 */   GIM_Try, /*On fail goto*//*Label 32835*/ GIMT_Encode4(2357739), // Rule ID 2045 //
     /* 2357717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2357720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357732 */     // (fminnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2357732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2357737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357738 */     // GIR_Coverage, 2045,
     /* 2357738 */     GIR_Done,
     /* 2357739 */   // Label 32835: @2357739
     /* 2357739 */   GIM_Reject,
     /* 2357740 */ // Label 32833: @2357740
     /* 2357740 */ GIM_Reject,
     /* 2357741 */ // Label 32815: @2357741
     /* 2357741 */ GIM_Try, /*On fail goto*//*Label 32836*/ GIMT_Encode4(2357807),
     /* 2357746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2357749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2357752 */   GIM_Try, /*On fail goto*//*Label 32837*/ GIMT_Encode4(2357779), // Rule ID 1331 //
     /* 2357757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2357760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2357764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2357768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2357772 */     // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2357772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2357777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357778 */     // GIR_Coverage, 1331,
     /* 2357778 */     GIR_Done,
     /* 2357779 */   // Label 32837: @2357779
     /* 2357779 */   GIM_Try, /*On fail goto*//*Label 32838*/ GIMT_Encode4(2357806), // Rule ID 1332 //
     /* 2357784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2357787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2357791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2357795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2357799 */     // (fminnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2357799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2357804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357805 */     // GIR_Coverage, 1332,
     /* 2357805 */     GIR_Done,
     /* 2357806 */   // Label 32838: @2357806
     /* 2357806 */   GIM_Reject,
     /* 2357807 */ // Label 32836: @2357807
     /* 2357807 */ GIM_Reject,
     /* 2357808 */ // Label 32816: @2357808
     /* 2357808 */ GIM_Try, /*On fail goto*//*Label 32839*/ GIMT_Encode4(2357901),
     /* 2357813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2357816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2357819 */   GIM_Try, /*On fail goto*//*Label 32840*/ GIMT_Encode4(2357846), // Rule ID 1702 //
     /* 2357824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2357827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357839 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2357839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2357844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357845 */     // GIR_Coverage, 1702,
     /* 2357845 */     GIR_Done,
     /* 2357846 */   // Label 32840: @2357846
     /* 2357846 */   GIM_Try, /*On fail goto*//*Label 32841*/ GIMT_Encode4(2357873), // Rule ID 1703 //
     /* 2357851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2357854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357866 */     // (fminnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2357866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2357871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357872 */     // GIR_Coverage, 1703,
     /* 2357872 */     GIR_Done,
     /* 2357873 */   // Label 32841: @2357873
     /* 2357873 */   GIM_Try, /*On fail goto*//*Label 32842*/ GIMT_Encode4(2357900), // Rule ID 1704 //
     /* 2357878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2357881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2357885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2357889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2357893 */     // (fminnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2357893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2357898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357899 */     // GIR_Coverage, 1704,
     /* 2357899 */     GIR_Done,
     /* 2357900 */   // Label 32842: @2357900
     /* 2357900 */   GIM_Reject,
     /* 2357901 */ // Label 32839: @2357901
     /* 2357901 */ GIM_Reject,
     /* 2357902 */ // Label 32817: @2357902
     /* 2357902 */ GIM_Try, /*On fail goto*//*Label 32843*/ GIMT_Encode4(2358016),
     /* 2357907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2357910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2357913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357925 */   GIM_Try, /*On fail goto*//*Label 32844*/ GIMT_Encode4(2357970), // Rule ID 45744 //
     /* 2357930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357933 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2357950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357969 */     // GIR_Coverage, 45744,
     /* 2357969 */     GIR_EraseRootFromParent_Done,
     /* 2357970 */   // Label 32844: @2357970
     /* 2357970 */   GIM_Try, /*On fail goto*//*Label 32845*/ GIMT_Encode4(2358015), // Rule ID 45745 //
     /* 2357975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2357978 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2357995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358014 */     // GIR_Coverage, 45745,
     /* 2358014 */     GIR_EraseRootFromParent_Done,
     /* 2358015 */   // Label 32845: @2358015
     /* 2358015 */   GIM_Reject,
     /* 2358016 */ // Label 32843: @2358016
     /* 2358016 */ GIM_Reject,
     /* 2358017 */ // Label 32818: @2358017
     /* 2358017 */ GIM_Try, /*On fail goto*//*Label 32846*/ GIMT_Encode4(2358131),
     /* 2358022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2358025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2358028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358040 */   GIM_Try, /*On fail goto*//*Label 32847*/ GIMT_Encode4(2358085), // Rule ID 56534 //
     /* 2358045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2358048 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2358051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2358065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358084 */     // GIR_Coverage, 56534,
     /* 2358084 */     GIR_EraseRootFromParent_Done,
     /* 2358085 */   // Label 32847: @2358085
     /* 2358085 */   GIM_Try, /*On fail goto*//*Label 32848*/ GIMT_Encode4(2358130), // Rule ID 56535 //
     /* 2358090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2358093 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2358096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2358110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358129 */     // GIR_Coverage, 56535,
     /* 2358129 */     GIR_EraseRootFromParent_Done,
     /* 2358130 */   // Label 32848: @2358130
     /* 2358130 */   GIM_Reject,
     /* 2358131 */ // Label 32846: @2358131
     /* 2358131 */ GIM_Reject,
     /* 2358132 */ // Label 32819: @2358132
     /* 2358132 */ GIM_Try, /*On fail goto*//*Label 32849*/ GIMT_Encode4(2358246),
     /* 2358137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2358140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2358143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358155 */   GIM_Try, /*On fail goto*//*Label 32850*/ GIMT_Encode4(2358200), // Rule ID 56552 //
     /* 2358160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2358163 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2358166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2358180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358199 */     // GIR_Coverage, 56552,
     /* 2358199 */     GIR_EraseRootFromParent_Done,
     /* 2358200 */   // Label 32850: @2358200
     /* 2358200 */   GIM_Try, /*On fail goto*//*Label 32851*/ GIMT_Encode4(2358245), // Rule ID 56553 //
     /* 2358205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2358208 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2358211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2358225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358244 */     // GIR_Coverage, 56553,
     /* 2358244 */     GIR_EraseRootFromParent_Done,
     /* 2358245 */   // Label 32851: @2358245
     /* 2358245 */   GIM_Reject,
     /* 2358246 */ // Label 32849: @2358246
     /* 2358246 */ GIM_Reject,
     /* 2358247 */ // Label 32820: @2358247
     /* 2358247 */ GIM_Try, /*On fail goto*//*Label 32852*/ GIMT_Encode4(2358361),
     /* 2358252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2358255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2358258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358270 */   GIM_Try, /*On fail goto*//*Label 32853*/ GIMT_Encode4(2358315), // Rule ID 56528 //
     /* 2358275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358278 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2358281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2358295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358314 */     // GIR_Coverage, 56528,
     /* 2358314 */     GIR_EraseRootFromParent_Done,
     /* 2358315 */   // Label 32853: @2358315
     /* 2358315 */   GIM_Try, /*On fail goto*//*Label 32854*/ GIMT_Encode4(2358360), // Rule ID 56529 //
     /* 2358320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358323 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2358326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2358340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358359 */     // GIR_Coverage, 56529,
     /* 2358359 */     GIR_EraseRootFromParent_Done,
     /* 2358360 */   // Label 32854: @2358360
     /* 2358360 */   GIM_Reject,
     /* 2358361 */ // Label 32852: @2358361
     /* 2358361 */ GIM_Reject,
     /* 2358362 */ // Label 32821: @2358362
     /* 2358362 */ GIM_Try, /*On fail goto*//*Label 32855*/ GIMT_Encode4(2358476),
     /* 2358367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2358370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2358373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358385 */   GIM_Try, /*On fail goto*//*Label 32856*/ GIMT_Encode4(2358430), // Rule ID 56546 //
     /* 2358390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2358393 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2358396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2358410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358429 */     // GIR_Coverage, 56546,
     /* 2358429 */     GIR_EraseRootFromParent_Done,
     /* 2358430 */   // Label 32856: @2358430
     /* 2358430 */   GIM_Try, /*On fail goto*//*Label 32857*/ GIMT_Encode4(2358475), // Rule ID 56547 //
     /* 2358435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2358438 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2358441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2358455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358474 */     // GIR_Coverage, 56547,
     /* 2358474 */     GIR_EraseRootFromParent_Done,
     /* 2358475 */   // Label 32857: @2358475
     /* 2358475 */   GIM_Reject,
     /* 2358476 */ // Label 32855: @2358476
     /* 2358476 */ GIM_Reject,
     /* 2358477 */ // Label 32822: @2358477
     /* 2358477 */ GIM_Try, /*On fail goto*//*Label 32858*/ GIMT_Encode4(2358591),
     /* 2358482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2358485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2358488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358500 */   GIM_Try, /*On fail goto*//*Label 32859*/ GIMT_Encode4(2358545), // Rule ID 56594 //
     /* 2358505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2358508 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2358525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358544 */     // GIR_Coverage, 56594,
     /* 2358544 */     GIR_EraseRootFromParent_Done,
     /* 2358545 */   // Label 32859: @2358545
     /* 2358545 */   GIM_Try, /*On fail goto*//*Label 32860*/ GIMT_Encode4(2358590), // Rule ID 56595 //
     /* 2358550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2358553 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2358570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358589 */     // GIR_Coverage, 56595,
     /* 2358589 */     GIR_EraseRootFromParent_Done,
     /* 2358590 */   // Label 32860: @2358590
     /* 2358590 */   GIM_Reject,
     /* 2358591 */ // Label 32858: @2358591
     /* 2358591 */ GIM_Reject,
     /* 2358592 */ // Label 32823: @2358592
     /* 2358592 */ GIM_Try, /*On fail goto*//*Label 32861*/ GIMT_Encode4(2358706),
     /* 2358597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2358600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2358603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358615 */   GIM_Try, /*On fail goto*//*Label 32862*/ GIMT_Encode4(2358660), // Rule ID 56540 //
     /* 2358620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358623 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2358640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358659 */     // GIR_Coverage, 56540,
     /* 2358659 */     GIR_EraseRootFromParent_Done,
     /* 2358660 */   // Label 32862: @2358660
     /* 2358660 */   GIM_Try, /*On fail goto*//*Label 32863*/ GIMT_Encode4(2358705), // Rule ID 56541 //
     /* 2358665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358668 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2358685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358704 */     // GIR_Coverage, 56541,
     /* 2358704 */     GIR_EraseRootFromParent_Done,
     /* 2358705 */   // Label 32863: @2358705
     /* 2358705 */   GIM_Reject,
     /* 2358706 */ // Label 32861: @2358706
     /* 2358706 */ GIM_Reject,
     /* 2358707 */ // Label 32824: @2358707
     /* 2358707 */ GIM_Try, /*On fail goto*//*Label 32864*/ GIMT_Encode4(2358821),
     /* 2358712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2358715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2358718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358730 */   GIM_Try, /*On fail goto*//*Label 32865*/ GIMT_Encode4(2358775), // Rule ID 56576 //
     /* 2358735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2358738 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2358741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2358755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358774 */     // GIR_Coverage, 56576,
     /* 2358774 */     GIR_EraseRootFromParent_Done,
     /* 2358775 */   // Label 32865: @2358775
     /* 2358775 */   GIM_Try, /*On fail goto*//*Label 32866*/ GIMT_Encode4(2358820), // Rule ID 56577 //
     /* 2358780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2358783 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2358786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2358800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358819 */     // GIR_Coverage, 56577,
     /* 2358819 */     GIR_EraseRootFromParent_Done,
     /* 2358820 */   // Label 32866: @2358820
     /* 2358820 */   GIM_Reject,
     /* 2358821 */ // Label 32864: @2358821
     /* 2358821 */ GIM_Reject,
     /* 2358822 */ // Label 32825: @2358822
     /* 2358822 */ GIM_Try, /*On fail goto*//*Label 32867*/ GIMT_Encode4(2358936),
     /* 2358827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2358830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2358833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358845 */   GIM_Try, /*On fail goto*//*Label 32868*/ GIMT_Encode4(2358890), // Rule ID 56600 //
     /* 2358850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2358853 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2358856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2358870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358889 */     // GIR_Coverage, 56600,
     /* 2358889 */     GIR_EraseRootFromParent_Done,
     /* 2358890 */   // Label 32868: @2358890
     /* 2358890 */   GIM_Try, /*On fail goto*//*Label 32869*/ GIMT_Encode4(2358935), // Rule ID 56601 //
     /* 2358895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2358898 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2358901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2358915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358934 */     // GIR_Coverage, 56601,
     /* 2358934 */     GIR_EraseRootFromParent_Done,
     /* 2358935 */   // Label 32869: @2358935
     /* 2358935 */   GIM_Reject,
     /* 2358936 */ // Label 32867: @2358936
     /* 2358936 */ GIM_Reject,
     /* 2358937 */ // Label 32826: @2358937
     /* 2358937 */ GIM_Try, /*On fail goto*//*Label 32870*/ GIMT_Encode4(2359051),
     /* 2358942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2358945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2358948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358960 */   GIM_Try, /*On fail goto*//*Label 32871*/ GIMT_Encode4(2359005), // Rule ID 56558 //
     /* 2358965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358968 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2358971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2358985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359004 */     // GIR_Coverage, 56558,
     /* 2359004 */     GIR_EraseRootFromParent_Done,
     /* 2359005 */   // Label 32871: @2359005
     /* 2359005 */   GIM_Try, /*On fail goto*//*Label 32872*/ GIMT_Encode4(2359050), // Rule ID 56559 //
     /* 2359010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2359013 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2359016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2359030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359049 */     // GIR_Coverage, 56559,
     /* 2359049 */     GIR_EraseRootFromParent_Done,
     /* 2359050 */   // Label 32872: @2359050
     /* 2359050 */   GIM_Reject,
     /* 2359051 */ // Label 32870: @2359051
     /* 2359051 */ GIM_Reject,
     /* 2359052 */ // Label 32827: @2359052
     /* 2359052 */ GIM_Try, /*On fail goto*//*Label 32873*/ GIMT_Encode4(2359166),
     /* 2359057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2359060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2359063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359075 */   GIM_Try, /*On fail goto*//*Label 32874*/ GIMT_Encode4(2359120), // Rule ID 56582 //
     /* 2359080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2359083 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2359086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2359100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359119 */     // GIR_Coverage, 56582,
     /* 2359119 */     GIR_EraseRootFromParent_Done,
     /* 2359120 */   // Label 32874: @2359120
     /* 2359120 */   GIM_Try, /*On fail goto*//*Label 32875*/ GIMT_Encode4(2359165), // Rule ID 56583 //
     /* 2359125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359128 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2359131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2359145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359164 */     // GIR_Coverage, 56583,
     /* 2359164 */     GIR_EraseRootFromParent_Done,
     /* 2359165 */   // Label 32875: @2359165
     /* 2359165 */   GIM_Reject,
     /* 2359166 */ // Label 32873: @2359166
     /* 2359166 */ GIM_Reject,
     /* 2359167 */ // Label 32828: @2359167
     /* 2359167 */ GIM_Try, /*On fail goto*//*Label 32876*/ GIMT_Encode4(2359281),
     /* 2359172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2359175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2359178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359190 */   GIM_Try, /*On fail goto*//*Label 32877*/ GIMT_Encode4(2359235), // Rule ID 56606 //
     /* 2359195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2359198 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2359201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2359215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359234 */     // GIR_Coverage, 56606,
     /* 2359234 */     GIR_EraseRootFromParent_Done,
     /* 2359235 */   // Label 32877: @2359235
     /* 2359235 */   GIM_Try, /*On fail goto*//*Label 32878*/ GIMT_Encode4(2359280), // Rule ID 56607 //
     /* 2359240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2359243 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2359246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2359260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359279 */     // GIR_Coverage, 56607,
     /* 2359279 */     GIR_EraseRootFromParent_Done,
     /* 2359280 */   // Label 32878: @2359280
     /* 2359280 */   GIM_Reject,
     /* 2359281 */ // Label 32876: @2359281
     /* 2359281 */ GIM_Reject,
     /* 2359282 */ // Label 32829: @2359282
     /* 2359282 */ GIM_Try, /*On fail goto*//*Label 32879*/ GIMT_Encode4(2359396),
     /* 2359287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2359290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2359293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359305 */   GIM_Try, /*On fail goto*//*Label 32880*/ GIMT_Encode4(2359350), // Rule ID 56564 //
     /* 2359310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2359313 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2359316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2359330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359349 */     // GIR_Coverage, 56564,
     /* 2359349 */     GIR_EraseRootFromParent_Done,
     /* 2359350 */   // Label 32880: @2359350
     /* 2359350 */   GIM_Try, /*On fail goto*//*Label 32881*/ GIMT_Encode4(2359395), // Rule ID 56565 //
     /* 2359355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2359358 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2359361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2359375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359394 */     // GIR_Coverage, 56565,
     /* 2359394 */     GIR_EraseRootFromParent_Done,
     /* 2359395 */   // Label 32881: @2359395
     /* 2359395 */   GIM_Reject,
     /* 2359396 */ // Label 32879: @2359396
     /* 2359396 */ GIM_Reject,
     /* 2359397 */ // Label 32830: @2359397
     /* 2359397 */ GIM_Try, /*On fail goto*//*Label 32882*/ GIMT_Encode4(2359511),
     /* 2359402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2359405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2359408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359420 */   GIM_Try, /*On fail goto*//*Label 32883*/ GIMT_Encode4(2359465), // Rule ID 56588 //
     /* 2359425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2359428 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2359431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2359445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359464 */     // GIR_Coverage, 56588,
     /* 2359464 */     GIR_EraseRootFromParent_Done,
     /* 2359465 */   // Label 32883: @2359465
     /* 2359465 */   GIM_Try, /*On fail goto*//*Label 32884*/ GIMT_Encode4(2359510), // Rule ID 56589 //
     /* 2359470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359473 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2359476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2359490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359509 */     // GIR_Coverage, 56589,
     /* 2359509 */     GIR_EraseRootFromParent_Done,
     /* 2359510 */   // Label 32884: @2359510
     /* 2359510 */   GIM_Reject,
     /* 2359511 */ // Label 32882: @2359511
     /* 2359511 */ GIM_Reject,
     /* 2359512 */ // Label 32831: @2359512
     /* 2359512 */ GIM_Try, /*On fail goto*//*Label 32885*/ GIMT_Encode4(2359626),
     /* 2359517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2359520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2359523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359535 */   GIM_Try, /*On fail goto*//*Label 32886*/ GIMT_Encode4(2359580), // Rule ID 56570 //
     /* 2359540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2359543 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2359546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2359560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359579 */     // GIR_Coverage, 56570,
     /* 2359579 */     GIR_EraseRootFromParent_Done,
     /* 2359580 */   // Label 32886: @2359580
     /* 2359580 */   GIM_Try, /*On fail goto*//*Label 32887*/ GIMT_Encode4(2359625), // Rule ID 56571 //
     /* 2359585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2359588 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2359591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2359605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359624 */     // GIR_Coverage, 56571,
     /* 2359624 */     GIR_EraseRootFromParent_Done,
     /* 2359625 */   // Label 32887: @2359625
     /* 2359625 */   GIM_Reject,
     /* 2359626 */ // Label 32885: @2359626
     /* 2359626 */ GIM_Reject,
     /* 2359627 */ // Label 32832: @2359627
     /* 2359627 */ GIM_Reject,
     /* 2359628 */ // Label 75: @2359628
     /* 2359628 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32906*/ GIMT_Encode4(2361712),
     /* 2359639 */ /*GILLT_s16*//*Label 32888*/ GIMT_Encode4(2359759),
     /* 2359643 */ /*GILLT_s32*//*Label 32889*/ GIMT_Encode4(2359826),
     /* 2359647 */ /*GILLT_s64*//*Label 32890*/ GIMT_Encode4(2359893), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359659 */ /*GILLT_nxv1s16*//*Label 32891*/ GIMT_Encode4(2359987),
     /* 2359663 */ /*GILLT_nxv1s32*//*Label 32892*/ GIMT_Encode4(2360102),
     /* 2359667 */ /*GILLT_nxv1s64*//*Label 32893*/ GIMT_Encode4(2360217), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359679 */ /*GILLT_nxv2s16*//*Label 32894*/ GIMT_Encode4(2360332),
     /* 2359683 */ /*GILLT_nxv2s32*//*Label 32895*/ GIMT_Encode4(2360447),
     /* 2359687 */ /*GILLT_nxv2s64*//*Label 32896*/ GIMT_Encode4(2360562), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359699 */ /*GILLT_nxv4s16*//*Label 32897*/ GIMT_Encode4(2360677),
     /* 2359703 */ /*GILLT_nxv4s32*//*Label 32898*/ GIMT_Encode4(2360792),
     /* 2359707 */ /*GILLT_nxv4s64*//*Label 32899*/ GIMT_Encode4(2360907), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359719 */ /*GILLT_nxv8s16*//*Label 32900*/ GIMT_Encode4(2361022),
     /* 2359723 */ /*GILLT_nxv8s32*//*Label 32901*/ GIMT_Encode4(2361137),
     /* 2359727 */ /*GILLT_nxv8s64*//*Label 32902*/ GIMT_Encode4(2361252), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359739 */ /*GILLT_nxv16s16*//*Label 32903*/ GIMT_Encode4(2361367),
     /* 2359743 */ /*GILLT_nxv16s32*//*Label 32904*/ GIMT_Encode4(2361482), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359755 */ /*GILLT_nxv32s16*//*Label 32905*/ GIMT_Encode4(2361597),
     /* 2359759 */ // Label 32888: @2359759
     /* 2359759 */ GIM_Try, /*On fail goto*//*Label 32907*/ GIMT_Encode4(2359825),
     /* 2359764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2359767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2359770 */   GIM_Try, /*On fail goto*//*Label 32908*/ GIMT_Encode4(2359797), // Rule ID 2046 //
     /* 2359775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2359778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359790 */     // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2359790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2359795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359796 */     // GIR_Coverage, 2046,
     /* 2359796 */     GIR_Done,
     /* 2359797 */   // Label 32908: @2359797
     /* 2359797 */   GIM_Try, /*On fail goto*//*Label 32909*/ GIMT_Encode4(2359824), // Rule ID 2047 //
     /* 2359802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2359805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2359809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2359813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2359817 */     // (fmaxnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2359817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2359822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359823 */     // GIR_Coverage, 2047,
     /* 2359823 */     GIR_Done,
     /* 2359824 */   // Label 32909: @2359824
     /* 2359824 */   GIM_Reject,
     /* 2359825 */ // Label 32907: @2359825
     /* 2359825 */ GIM_Reject,
     /* 2359826 */ // Label 32889: @2359826
     /* 2359826 */ GIM_Try, /*On fail goto*//*Label 32910*/ GIMT_Encode4(2359892),
     /* 2359831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2359834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2359837 */   GIM_Try, /*On fail goto*//*Label 32911*/ GIMT_Encode4(2359864), // Rule ID 1333 //
     /* 2359842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2359845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359857 */     // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2359857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2359862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359863 */     // GIR_Coverage, 1333,
     /* 2359863 */     GIR_Done,
     /* 2359864 */   // Label 32911: @2359864
     /* 2359864 */   GIM_Try, /*On fail goto*//*Label 32912*/ GIMT_Encode4(2359891), // Rule ID 1334 //
     /* 2359869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2359872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2359876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2359880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2359884 */     // (fmaxnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2359884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2359889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359890 */     // GIR_Coverage, 1334,
     /* 2359890 */     GIR_Done,
     /* 2359891 */   // Label 32912: @2359891
     /* 2359891 */   GIM_Reject,
     /* 2359892 */ // Label 32910: @2359892
     /* 2359892 */ GIM_Reject,
     /* 2359893 */ // Label 32890: @2359893
     /* 2359893 */ GIM_Try, /*On fail goto*//*Label 32913*/ GIMT_Encode4(2359986),
     /* 2359898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2359901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2359904 */   GIM_Try, /*On fail goto*//*Label 32914*/ GIMT_Encode4(2359931), // Rule ID 1705 //
     /* 2359909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2359912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359924 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2359924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2359929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359930 */     // GIR_Coverage, 1705,
     /* 2359930 */     GIR_Done,
     /* 2359931 */   // Label 32914: @2359931
     /* 2359931 */   GIM_Try, /*On fail goto*//*Label 32915*/ GIMT_Encode4(2359958), // Rule ID 1706 //
     /* 2359936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2359939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2359943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2359947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2359951 */     // (fmaxnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2359951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2359956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359957 */     // GIR_Coverage, 1706,
     /* 2359957 */     GIR_Done,
     /* 2359958 */   // Label 32915: @2359958
     /* 2359958 */   GIM_Try, /*On fail goto*//*Label 32916*/ GIMT_Encode4(2359985), // Rule ID 1707 //
     /* 2359963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2359966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359978 */     // (fmaxnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2359978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2359983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359984 */     // GIR_Coverage, 1707,
     /* 2359984 */     GIR_Done,
     /* 2359985 */   // Label 32916: @2359985
     /* 2359985 */   GIM_Reject,
     /* 2359986 */ // Label 32913: @2359986
     /* 2359986 */ GIM_Reject,
     /* 2359987 */ // Label 32891: @2359987
     /* 2359987 */ GIM_Try, /*On fail goto*//*Label 32917*/ GIMT_Encode4(2360101),
     /* 2359992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2359995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2359998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360010 */   GIM_Try, /*On fail goto*//*Label 32918*/ GIMT_Encode4(2360055), // Rule ID 56612 //
     /* 2360015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360018 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2360021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2360035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360054 */     // GIR_Coverage, 56612,
     /* 2360054 */     GIR_EraseRootFromParent_Done,
     /* 2360055 */   // Label 32918: @2360055
     /* 2360055 */   GIM_Try, /*On fail goto*//*Label 32919*/ GIMT_Encode4(2360100), // Rule ID 56613 //
     /* 2360060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360063 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2360066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2360080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360099 */     // GIR_Coverage, 56613,
     /* 2360099 */     GIR_EraseRootFromParent_Done,
     /* 2360100 */   // Label 32919: @2360100
     /* 2360100 */   GIM_Reject,
     /* 2360101 */ // Label 32917: @2360101
     /* 2360101 */ GIM_Reject,
     /* 2360102 */ // Label 32892: @2360102
     /* 2360102 */ GIM_Try, /*On fail goto*//*Label 32920*/ GIMT_Encode4(2360216),
     /* 2360107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2360110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2360113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360125 */   GIM_Try, /*On fail goto*//*Label 32921*/ GIMT_Encode4(2360170), // Rule ID 56624 //
     /* 2360130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2360133 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2360136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2360150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360169 */     // GIR_Coverage, 56624,
     /* 2360169 */     GIR_EraseRootFromParent_Done,
     /* 2360170 */   // Label 32921: @2360170
     /* 2360170 */   GIM_Try, /*On fail goto*//*Label 32922*/ GIMT_Encode4(2360215), // Rule ID 56625 //
     /* 2360175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2360178 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2360181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2360195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360214 */     // GIR_Coverage, 56625,
     /* 2360214 */     GIR_EraseRootFromParent_Done,
     /* 2360215 */   // Label 32922: @2360215
     /* 2360215 */   GIM_Reject,
     /* 2360216 */ // Label 32920: @2360216
     /* 2360216 */ GIM_Reject,
     /* 2360217 */ // Label 32893: @2360217
     /* 2360217 */ GIM_Try, /*On fail goto*//*Label 32923*/ GIMT_Encode4(2360331),
     /* 2360222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2360225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2360228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360240 */   GIM_Try, /*On fail goto*//*Label 32924*/ GIMT_Encode4(2360285), // Rule ID 56642 //
     /* 2360245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2360248 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2360251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2360265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360284 */     // GIR_Coverage, 56642,
     /* 2360284 */     GIR_EraseRootFromParent_Done,
     /* 2360285 */   // Label 32924: @2360285
     /* 2360285 */   GIM_Try, /*On fail goto*//*Label 32925*/ GIMT_Encode4(2360330), // Rule ID 56643 //
     /* 2360290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2360293 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2360296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2360310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360329 */     // GIR_Coverage, 56643,
     /* 2360329 */     GIR_EraseRootFromParent_Done,
     /* 2360330 */   // Label 32925: @2360330
     /* 2360330 */   GIM_Reject,
     /* 2360331 */ // Label 32923: @2360331
     /* 2360331 */ GIM_Reject,
     /* 2360332 */ // Label 32894: @2360332
     /* 2360332 */ GIM_Try, /*On fail goto*//*Label 32926*/ GIMT_Encode4(2360446),
     /* 2360337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2360340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2360343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360355 */   GIM_Try, /*On fail goto*//*Label 32927*/ GIMT_Encode4(2360400), // Rule ID 56618 //
     /* 2360360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360363 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2360366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2360380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360399 */     // GIR_Coverage, 56618,
     /* 2360399 */     GIR_EraseRootFromParent_Done,
     /* 2360400 */   // Label 32927: @2360400
     /* 2360400 */   GIM_Try, /*On fail goto*//*Label 32928*/ GIMT_Encode4(2360445), // Rule ID 56619 //
     /* 2360405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360408 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2360411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2360425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360444 */     // GIR_Coverage, 56619,
     /* 2360444 */     GIR_EraseRootFromParent_Done,
     /* 2360445 */   // Label 32928: @2360445
     /* 2360445 */   GIM_Reject,
     /* 2360446 */ // Label 32926: @2360446
     /* 2360446 */ GIM_Reject,
     /* 2360447 */ // Label 32895: @2360447
     /* 2360447 */ GIM_Try, /*On fail goto*//*Label 32929*/ GIMT_Encode4(2360561),
     /* 2360452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2360455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2360458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360470 */   GIM_Try, /*On fail goto*//*Label 32930*/ GIMT_Encode4(2360515), // Rule ID 56636 //
     /* 2360475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2360478 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2360481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2360495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360514 */     // GIR_Coverage, 56636,
     /* 2360514 */     GIR_EraseRootFromParent_Done,
     /* 2360515 */   // Label 32930: @2360515
     /* 2360515 */   GIM_Try, /*On fail goto*//*Label 32931*/ GIMT_Encode4(2360560), // Rule ID 56637 //
     /* 2360520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2360523 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2360526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2360540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360559 */     // GIR_Coverage, 56637,
     /* 2360559 */     GIR_EraseRootFromParent_Done,
     /* 2360560 */   // Label 32931: @2360560
     /* 2360560 */   GIM_Reject,
     /* 2360561 */ // Label 32929: @2360561
     /* 2360561 */ GIM_Reject,
     /* 2360562 */ // Label 32896: @2360562
     /* 2360562 */ GIM_Try, /*On fail goto*//*Label 32932*/ GIMT_Encode4(2360676),
     /* 2360567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2360570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2360573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360585 */   GIM_Try, /*On fail goto*//*Label 32933*/ GIMT_Encode4(2360630), // Rule ID 56684 //
     /* 2360590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2360593 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2360596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2360610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360629 */     // GIR_Coverage, 56684,
     /* 2360629 */     GIR_EraseRootFromParent_Done,
     /* 2360630 */   // Label 32933: @2360630
     /* 2360630 */   GIM_Try, /*On fail goto*//*Label 32934*/ GIMT_Encode4(2360675), // Rule ID 56685 //
     /* 2360635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2360638 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2360641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2360655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360674 */     // GIR_Coverage, 56685,
     /* 2360674 */     GIR_EraseRootFromParent_Done,
     /* 2360675 */   // Label 32934: @2360675
     /* 2360675 */   GIM_Reject,
     /* 2360676 */ // Label 32932: @2360676
     /* 2360676 */ GIM_Reject,
     /* 2360677 */ // Label 32897: @2360677
     /* 2360677 */ GIM_Try, /*On fail goto*//*Label 32935*/ GIMT_Encode4(2360791),
     /* 2360682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2360685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2360688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360700 */   GIM_Try, /*On fail goto*//*Label 32936*/ GIMT_Encode4(2360745), // Rule ID 56630 //
     /* 2360705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360708 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2360711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2360725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360744 */     // GIR_Coverage, 56630,
     /* 2360744 */     GIR_EraseRootFromParent_Done,
     /* 2360745 */   // Label 32936: @2360745
     /* 2360745 */   GIM_Try, /*On fail goto*//*Label 32937*/ GIMT_Encode4(2360790), // Rule ID 56631 //
     /* 2360750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360753 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2360756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2360770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360789 */     // GIR_Coverage, 56631,
     /* 2360789 */     GIR_EraseRootFromParent_Done,
     /* 2360790 */   // Label 32937: @2360790
     /* 2360790 */   GIM_Reject,
     /* 2360791 */ // Label 32935: @2360791
     /* 2360791 */ GIM_Reject,
     /* 2360792 */ // Label 32898: @2360792
     /* 2360792 */ GIM_Try, /*On fail goto*//*Label 32938*/ GIMT_Encode4(2360906),
     /* 2360797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2360800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2360803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360815 */   GIM_Try, /*On fail goto*//*Label 32939*/ GIMT_Encode4(2360860), // Rule ID 56666 //
     /* 2360820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2360823 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2360826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2360840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360859 */     // GIR_Coverage, 56666,
     /* 2360859 */     GIR_EraseRootFromParent_Done,
     /* 2360860 */   // Label 32939: @2360860
     /* 2360860 */   GIM_Try, /*On fail goto*//*Label 32940*/ GIMT_Encode4(2360905), // Rule ID 56667 //
     /* 2360865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2360868 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2360871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2360885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360904 */     // GIR_Coverage, 56667,
     /* 2360904 */     GIR_EraseRootFromParent_Done,
     /* 2360905 */   // Label 32940: @2360905
     /* 2360905 */   GIM_Reject,
     /* 2360906 */ // Label 32938: @2360906
     /* 2360906 */ GIM_Reject,
     /* 2360907 */ // Label 32899: @2360907
     /* 2360907 */ GIM_Try, /*On fail goto*//*Label 32941*/ GIMT_Encode4(2361021),
     /* 2360912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2360915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2360918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360930 */   GIM_Try, /*On fail goto*//*Label 32942*/ GIMT_Encode4(2360975), // Rule ID 56690 //
     /* 2360935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2360938 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2360941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2360955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360974 */     // GIR_Coverage, 56690,
     /* 2360974 */     GIR_EraseRootFromParent_Done,
     /* 2360975 */   // Label 32942: @2360975
     /* 2360975 */   GIM_Try, /*On fail goto*//*Label 32943*/ GIMT_Encode4(2361020), // Rule ID 56691 //
     /* 2360980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2360983 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2360986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2361000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361019 */     // GIR_Coverage, 56691,
     /* 2361019 */     GIR_EraseRootFromParent_Done,
     /* 2361020 */   // Label 32943: @2361020
     /* 2361020 */   GIM_Reject,
     /* 2361021 */ // Label 32941: @2361021
     /* 2361021 */ GIM_Reject,
     /* 2361022 */ // Label 32900: @2361022
     /* 2361022 */ GIM_Try, /*On fail goto*//*Label 32944*/ GIMT_Encode4(2361136),
     /* 2361027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2361030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2361033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361045 */   GIM_Try, /*On fail goto*//*Label 32945*/ GIMT_Encode4(2361090), // Rule ID 56648 //
     /* 2361050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2361053 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2361056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2361070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361089 */     // GIR_Coverage, 56648,
     /* 2361089 */     GIR_EraseRootFromParent_Done,
     /* 2361090 */   // Label 32945: @2361090
     /* 2361090 */   GIM_Try, /*On fail goto*//*Label 32946*/ GIMT_Encode4(2361135), // Rule ID 56649 //
     /* 2361095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361098 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2361101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2361115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361134 */     // GIR_Coverage, 56649,
     /* 2361134 */     GIR_EraseRootFromParent_Done,
     /* 2361135 */   // Label 32946: @2361135
     /* 2361135 */   GIM_Reject,
     /* 2361136 */ // Label 32944: @2361136
     /* 2361136 */ GIM_Reject,
     /* 2361137 */ // Label 32901: @2361137
     /* 2361137 */ GIM_Try, /*On fail goto*//*Label 32947*/ GIMT_Encode4(2361251),
     /* 2361142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2361145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2361148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361160 */   GIM_Try, /*On fail goto*//*Label 32948*/ GIMT_Encode4(2361205), // Rule ID 56672 //
     /* 2361165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2361168 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2361171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2361185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361204 */     // GIR_Coverage, 56672,
     /* 2361204 */     GIR_EraseRootFromParent_Done,
     /* 2361205 */   // Label 32948: @2361205
     /* 2361205 */   GIM_Try, /*On fail goto*//*Label 32949*/ GIMT_Encode4(2361250), // Rule ID 56673 //
     /* 2361210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2361213 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2361216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2361230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361249 */     // GIR_Coverage, 56673,
     /* 2361249 */     GIR_EraseRootFromParent_Done,
     /* 2361250 */   // Label 32949: @2361250
     /* 2361250 */   GIM_Reject,
     /* 2361251 */ // Label 32947: @2361251
     /* 2361251 */ GIM_Reject,
     /* 2361252 */ // Label 32902: @2361252
     /* 2361252 */ GIM_Try, /*On fail goto*//*Label 32950*/ GIMT_Encode4(2361366),
     /* 2361257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2361260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2361263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361275 */   GIM_Try, /*On fail goto*//*Label 32951*/ GIMT_Encode4(2361320), // Rule ID 56696 //
     /* 2361280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2361283 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2361286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2361300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361319 */     // GIR_Coverage, 56696,
     /* 2361319 */     GIR_EraseRootFromParent_Done,
     /* 2361320 */   // Label 32951: @2361320
     /* 2361320 */   GIM_Try, /*On fail goto*//*Label 32952*/ GIMT_Encode4(2361365), // Rule ID 56697 //
     /* 2361325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2361328 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2361331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2361345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361364 */     // GIR_Coverage, 56697,
     /* 2361364 */     GIR_EraseRootFromParent_Done,
     /* 2361365 */   // Label 32952: @2361365
     /* 2361365 */   GIM_Reject,
     /* 2361366 */ // Label 32950: @2361366
     /* 2361366 */ GIM_Reject,
     /* 2361367 */ // Label 32903: @2361367
     /* 2361367 */ GIM_Try, /*On fail goto*//*Label 32953*/ GIMT_Encode4(2361481),
     /* 2361372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2361375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2361378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361386 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361390 */   GIM_Try, /*On fail goto*//*Label 32954*/ GIMT_Encode4(2361435), // Rule ID 56654 //
     /* 2361395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2361398 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2361401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2361415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361434 */     // GIR_Coverage, 56654,
     /* 2361434 */     GIR_EraseRootFromParent_Done,
     /* 2361435 */   // Label 32954: @2361435
     /* 2361435 */   GIM_Try, /*On fail goto*//*Label 32955*/ GIMT_Encode4(2361480), // Rule ID 56655 //
     /* 2361440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361443 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2361446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2361460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361479 */     // GIR_Coverage, 56655,
     /* 2361479 */     GIR_EraseRootFromParent_Done,
     /* 2361480 */   // Label 32955: @2361480
     /* 2361480 */   GIM_Reject,
     /* 2361481 */ // Label 32953: @2361481
     /* 2361481 */ GIM_Reject,
     /* 2361482 */ // Label 32904: @2361482
     /* 2361482 */ GIM_Try, /*On fail goto*//*Label 32956*/ GIMT_Encode4(2361596),
     /* 2361487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2361490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2361493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361505 */   GIM_Try, /*On fail goto*//*Label 32957*/ GIMT_Encode4(2361550), // Rule ID 56678 //
     /* 2361510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2361513 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2361516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2361530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361549 */     // GIR_Coverage, 56678,
     /* 2361549 */     GIR_EraseRootFromParent_Done,
     /* 2361550 */   // Label 32957: @2361550
     /* 2361550 */   GIM_Try, /*On fail goto*//*Label 32958*/ GIMT_Encode4(2361595), // Rule ID 56679 //
     /* 2361555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2361558 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2361561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2361575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361594 */     // GIR_Coverage, 56679,
     /* 2361594 */     GIR_EraseRootFromParent_Done,
     /* 2361595 */   // Label 32958: @2361595
     /* 2361595 */   GIM_Reject,
     /* 2361596 */ // Label 32956: @2361596
     /* 2361596 */ GIM_Reject,
     /* 2361597 */ // Label 32905: @2361597
     /* 2361597 */ GIM_Try, /*On fail goto*//*Label 32959*/ GIMT_Encode4(2361711),
     /* 2361602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2361605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2361608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361620 */   GIM_Try, /*On fail goto*//*Label 32960*/ GIMT_Encode4(2361665), // Rule ID 56660 //
     /* 2361625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2361628 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2361631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2361645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361664 */     // GIR_Coverage, 56660,
     /* 2361664 */     GIR_EraseRootFromParent_Done,
     /* 2361665 */   // Label 32960: @2361665
     /* 2361665 */   GIM_Try, /*On fail goto*//*Label 32961*/ GIMT_Encode4(2361710), // Rule ID 56661 //
     /* 2361670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361673 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2361676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2361690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361709 */     // GIR_Coverage, 56661,
     /* 2361709 */     GIR_EraseRootFromParent_Done,
     /* 2361710 */   // Label 32961: @2361710
     /* 2361710 */   GIM_Reject,
     /* 2361711 */ // Label 32959: @2361711
     /* 2361711 */ GIM_Reject,
     /* 2361712 */ // Label 32906: @2361712
     /* 2361712 */ GIM_Reject,
     /* 2361713 */ // Label 76: @2361713
     /* 2361713 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32965*/ GIMT_Encode4(2361838),
     /* 2361724 */ /*GILLT_s16*//*Label 32962*/ GIMT_Encode4(2361736),
     /* 2361728 */ /*GILLT_s32*//*Label 32963*/ GIMT_Encode4(2361770),
     /* 2361732 */ /*GILLT_s64*//*Label 32964*/ GIMT_Encode4(2361804),
     /* 2361736 */ // Label 32962: @2361736
     /* 2361736 */ GIM_Try, /*On fail goto*//*Label 32966*/ GIMT_Encode4(2361769), // Rule ID 2398 //
     /* 2361741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2361744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2361747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2361750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361762 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMINM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2361762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_H),
     /* 2361767 */   GIR_RootConstrainSelectedInstOperands,
     /* 2361768 */   // GIR_Coverage, 2398,
     /* 2361768 */   GIR_Done,
     /* 2361769 */ // Label 32966: @2361769
     /* 2361769 */ GIM_Reject,
     /* 2361770 */ // Label 32963: @2361770
     /* 2361770 */ GIM_Try, /*On fail goto*//*Label 32967*/ GIMT_Encode4(2361803), // Rule ID 2316 //
     /* 2361775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2361778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2361781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2361784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361796 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMINM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2361796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_S),
     /* 2361801 */   GIR_RootConstrainSelectedInstOperands,
     /* 2361802 */   // GIR_Coverage, 2316,
     /* 2361802 */   GIR_Done,
     /* 2361803 */ // Label 32967: @2361803
     /* 2361803 */ GIM_Reject,
     /* 2361804 */ // Label 32964: @2361804
     /* 2361804 */ GIM_Try, /*On fail goto*//*Label 32968*/ GIMT_Encode4(2361837), // Rule ID 2356 //
     /* 2361809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2361812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2361815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2361818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361826 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361830 */   // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMINM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2361830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_D),
     /* 2361835 */   GIR_RootConstrainSelectedInstOperands,
     /* 2361836 */   // GIR_Coverage, 2356,
     /* 2361836 */   GIR_Done,
     /* 2361837 */ // Label 32968: @2361837
     /* 2361837 */ GIM_Reject,
     /* 2361838 */ // Label 32965: @2361838
     /* 2361838 */ GIM_Reject,
     /* 2361839 */ // Label 77: @2361839
     /* 2361839 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32972*/ GIMT_Encode4(2361964),
     /* 2361850 */ /*GILLT_s16*//*Label 32969*/ GIMT_Encode4(2361862),
     /* 2361854 */ /*GILLT_s32*//*Label 32970*/ GIMT_Encode4(2361896),
     /* 2361858 */ /*GILLT_s64*//*Label 32971*/ GIMT_Encode4(2361930),
     /* 2361862 */ // Label 32969: @2361862
     /* 2361862 */ GIM_Try, /*On fail goto*//*Label 32973*/ GIMT_Encode4(2361895), // Rule ID 2399 //
     /* 2361867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2361870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2361873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2361876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361884 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361888 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAXM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2361888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_H),
     /* 2361893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2361894 */   // GIR_Coverage, 2399,
     /* 2361894 */   GIR_Done,
     /* 2361895 */ // Label 32973: @2361895
     /* 2361895 */ GIM_Reject,
     /* 2361896 */ // Label 32970: @2361896
     /* 2361896 */ GIM_Try, /*On fail goto*//*Label 32974*/ GIMT_Encode4(2361929), // Rule ID 2317 //
     /* 2361901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2361904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2361907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2361910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361922 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAXM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2361922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_S),
     /* 2361927 */   GIR_RootConstrainSelectedInstOperands,
     /* 2361928 */   // GIR_Coverage, 2317,
     /* 2361928 */   GIR_Done,
     /* 2361929 */ // Label 32974: @2361929
     /* 2361929 */ GIM_Reject,
     /* 2361930 */ // Label 32971: @2361930
     /* 2361930 */ GIM_Try, /*On fail goto*//*Label 32975*/ GIMT_Encode4(2361963), // Rule ID 2357 //
     /* 2361935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2361938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2361941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2361944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361956 */   // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAXM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2361956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_D),
     /* 2361961 */   GIR_RootConstrainSelectedInstOperands,
     /* 2361962 */   // GIR_Coverage, 2357,
     /* 2361962 */   GIR_Done,
     /* 2361963 */ // Label 32975: @2361963
     /* 2361963 */ GIM_Reject,
     /* 2361964 */ // Label 32972: @2361964
     /* 2361964 */ GIM_Reject,
     /* 2361965 */ // Label 78: @2361965
     /* 2361965 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32994*/ GIMT_Encode4(2364049),
     /* 2361976 */ /*GILLT_s16*//*Label 32976*/ GIMT_Encode4(2362096),
     /* 2361980 */ /*GILLT_s32*//*Label 32977*/ GIMT_Encode4(2362163),
     /* 2361984 */ /*GILLT_s64*//*Label 32978*/ GIMT_Encode4(2362230), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361996 */ /*GILLT_nxv1s16*//*Label 32979*/ GIMT_Encode4(2362324),
     /* 2362000 */ /*GILLT_nxv1s32*//*Label 32980*/ GIMT_Encode4(2362439),
     /* 2362004 */ /*GILLT_nxv1s64*//*Label 32981*/ GIMT_Encode4(2362554), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2362016 */ /*GILLT_nxv2s16*//*Label 32982*/ GIMT_Encode4(2362669),
     /* 2362020 */ /*GILLT_nxv2s32*//*Label 32983*/ GIMT_Encode4(2362784),
     /* 2362024 */ /*GILLT_nxv2s64*//*Label 32984*/ GIMT_Encode4(2362899), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2362036 */ /*GILLT_nxv4s16*//*Label 32985*/ GIMT_Encode4(2363014),
     /* 2362040 */ /*GILLT_nxv4s32*//*Label 32986*/ GIMT_Encode4(2363129),
     /* 2362044 */ /*GILLT_nxv4s64*//*Label 32987*/ GIMT_Encode4(2363244), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2362056 */ /*GILLT_nxv8s16*//*Label 32988*/ GIMT_Encode4(2363359),
     /* 2362060 */ /*GILLT_nxv8s32*//*Label 32989*/ GIMT_Encode4(2363474),
     /* 2362064 */ /*GILLT_nxv8s64*//*Label 32990*/ GIMT_Encode4(2363589), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2362076 */ /*GILLT_nxv16s16*//*Label 32991*/ GIMT_Encode4(2363704),
     /* 2362080 */ /*GILLT_nxv16s32*//*Label 32992*/ GIMT_Encode4(2363819), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2362092 */ /*GILLT_nxv32s16*//*Label 32993*/ GIMT_Encode4(2363934),
     /* 2362096 */ // Label 32976: @2362096
     /* 2362096 */ GIM_Try, /*On fail goto*//*Label 32995*/ GIMT_Encode4(2362162),
     /* 2362101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2362104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2362107 */   GIM_Try, /*On fail goto*//*Label 32996*/ GIMT_Encode4(2362134), // Rule ID 2048 //
     /* 2362112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2362115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2362119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2362123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2362127 */     // (fminimumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2362127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2362132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362133 */     // GIR_Coverage, 2048,
     /* 2362133 */     GIR_Done,
     /* 2362134 */   // Label 32996: @2362134
     /* 2362134 */   GIM_Try, /*On fail goto*//*Label 32997*/ GIMT_Encode4(2362161), // Rule ID 2049 //
     /* 2362139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2362142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2362146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2362150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2362154 */     // (fminimumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2362154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2362159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362160 */     // GIR_Coverage, 2049,
     /* 2362160 */     GIR_Done,
     /* 2362161 */   // Label 32997: @2362161
     /* 2362161 */   GIM_Reject,
     /* 2362162 */ // Label 32995: @2362162
     /* 2362162 */ GIM_Reject,
     /* 2362163 */ // Label 32977: @2362163
     /* 2362163 */ GIM_Try, /*On fail goto*//*Label 32998*/ GIMT_Encode4(2362229),
     /* 2362168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2362171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2362174 */   GIM_Try, /*On fail goto*//*Label 32999*/ GIMT_Encode4(2362201), // Rule ID 1335 //
     /* 2362179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2362182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2362186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2362190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2362194 */     // (fminimumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2362194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2362199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362200 */     // GIR_Coverage, 1335,
     /* 2362200 */     GIR_Done,
     /* 2362201 */   // Label 32999: @2362201
     /* 2362201 */   GIM_Try, /*On fail goto*//*Label 33000*/ GIMT_Encode4(2362228), // Rule ID 1336 //
     /* 2362206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2362209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2362213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2362217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2362221 */     // (fminimumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2362221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2362226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362227 */     // GIR_Coverage, 1336,
     /* 2362227 */     GIR_Done,
     /* 2362228 */   // Label 33000: @2362228
     /* 2362228 */   GIM_Reject,
     /* 2362229 */ // Label 32998: @2362229
     /* 2362229 */ GIM_Reject,
     /* 2362230 */ // Label 32978: @2362230
     /* 2362230 */ GIM_Try, /*On fail goto*//*Label 33001*/ GIMT_Encode4(2362323),
     /* 2362235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2362238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2362241 */   GIM_Try, /*On fail goto*//*Label 33002*/ GIMT_Encode4(2362268), // Rule ID 1708 //
     /* 2362246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2362249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2362253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2362257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2362261 */     // (fminimumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2362261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2362266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362267 */     // GIR_Coverage, 1708,
     /* 2362267 */     GIR_Done,
     /* 2362268 */   // Label 33002: @2362268
     /* 2362268 */   GIM_Try, /*On fail goto*//*Label 33003*/ GIMT_Encode4(2362295), // Rule ID 1709 //
     /* 2362273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2362276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2362280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2362284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2362288 */     // (fminimumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2362288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2362293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362294 */     // GIR_Coverage, 1709,
     /* 2362294 */     GIR_Done,
     /* 2362295 */   // Label 33003: @2362295
     /* 2362295 */   GIM_Try, /*On fail goto*//*Label 33004*/ GIMT_Encode4(2362322), // Rule ID 1710 //
     /* 2362300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2362303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2362307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2362311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2362315 */     // (fminimumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2362315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2362320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362321 */     // GIR_Coverage, 1710,
     /* 2362321 */     GIR_Done,
     /* 2362322 */   // Label 33004: @2362322
     /* 2362322 */   GIM_Reject,
     /* 2362323 */ // Label 33001: @2362323
     /* 2362323 */ GIM_Reject,
     /* 2362324 */ // Label 32979: @2362324
     /* 2362324 */ GIM_Try, /*On fail goto*//*Label 33005*/ GIMT_Encode4(2362438),
     /* 2362329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2362332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2362335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362347 */   GIM_Try, /*On fail goto*//*Label 33006*/ GIMT_Encode4(2362392), // Rule ID 56702 //
     /* 2362352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2362355 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2362358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2362372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362391 */     // GIR_Coverage, 56702,
     /* 2362391 */     GIR_EraseRootFromParent_Done,
     /* 2362392 */   // Label 33006: @2362392
     /* 2362392 */   GIM_Try, /*On fail goto*//*Label 33007*/ GIMT_Encode4(2362437), // Rule ID 56703 //
     /* 2362397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2362400 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2362403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2362417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362436 */     // GIR_Coverage, 56703,
     /* 2362436 */     GIR_EraseRootFromParent_Done,
     /* 2362437 */   // Label 33007: @2362437
     /* 2362437 */   GIM_Reject,
     /* 2362438 */ // Label 33005: @2362438
     /* 2362438 */ GIM_Reject,
     /* 2362439 */ // Label 32980: @2362439
     /* 2362439 */ GIM_Try, /*On fail goto*//*Label 33008*/ GIMT_Encode4(2362553),
     /* 2362444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2362447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2362450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362462 */   GIM_Try, /*On fail goto*//*Label 33009*/ GIMT_Encode4(2362507), // Rule ID 56714 //
     /* 2362467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2362470 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2362473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2362487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362506 */     // GIR_Coverage, 56714,
     /* 2362506 */     GIR_EraseRootFromParent_Done,
     /* 2362507 */   // Label 33009: @2362507
     /* 2362507 */   GIM_Try, /*On fail goto*//*Label 33010*/ GIMT_Encode4(2362552), // Rule ID 56715 //
     /* 2362512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2362515 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2362518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2362532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362551 */     // GIR_Coverage, 56715,
     /* 2362551 */     GIR_EraseRootFromParent_Done,
     /* 2362552 */   // Label 33010: @2362552
     /* 2362552 */   GIM_Reject,
     /* 2362553 */ // Label 33008: @2362553
     /* 2362553 */ GIM_Reject,
     /* 2362554 */ // Label 32981: @2362554
     /* 2362554 */ GIM_Try, /*On fail goto*//*Label 33011*/ GIMT_Encode4(2362668),
     /* 2362559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2362562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2362565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362573 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362577 */   GIM_Try, /*On fail goto*//*Label 33012*/ GIMT_Encode4(2362622), // Rule ID 56732 //
     /* 2362582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2362585 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2362588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2362602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362621 */     // GIR_Coverage, 56732,
     /* 2362621 */     GIR_EraseRootFromParent_Done,
     /* 2362622 */   // Label 33012: @2362622
     /* 2362622 */   GIM_Try, /*On fail goto*//*Label 33013*/ GIMT_Encode4(2362667), // Rule ID 56733 //
     /* 2362627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2362630 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2362633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2362647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362666 */     // GIR_Coverage, 56733,
     /* 2362666 */     GIR_EraseRootFromParent_Done,
     /* 2362667 */   // Label 33013: @2362667
     /* 2362667 */   GIM_Reject,
     /* 2362668 */ // Label 33011: @2362668
     /* 2362668 */ GIM_Reject,
     /* 2362669 */ // Label 32982: @2362669
     /* 2362669 */ GIM_Try, /*On fail goto*//*Label 33014*/ GIMT_Encode4(2362783),
     /* 2362674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2362677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2362680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362692 */   GIM_Try, /*On fail goto*//*Label 33015*/ GIMT_Encode4(2362737), // Rule ID 56708 //
     /* 2362697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2362700 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2362703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2362717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362736 */     // GIR_Coverage, 56708,
     /* 2362736 */     GIR_EraseRootFromParent_Done,
     /* 2362737 */   // Label 33015: @2362737
     /* 2362737 */   GIM_Try, /*On fail goto*//*Label 33016*/ GIMT_Encode4(2362782), // Rule ID 56709 //
     /* 2362742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2362745 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2362748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2362762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362781 */     // GIR_Coverage, 56709,
     /* 2362781 */     GIR_EraseRootFromParent_Done,
     /* 2362782 */   // Label 33016: @2362782
     /* 2362782 */   GIM_Reject,
     /* 2362783 */ // Label 33014: @2362783
     /* 2362783 */ GIM_Reject,
     /* 2362784 */ // Label 32983: @2362784
     /* 2362784 */ GIM_Try, /*On fail goto*//*Label 33017*/ GIMT_Encode4(2362898),
     /* 2362789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2362792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2362795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362807 */   GIM_Try, /*On fail goto*//*Label 33018*/ GIMT_Encode4(2362852), // Rule ID 56726 //
     /* 2362812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2362815 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2362818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2362832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362851 */     // GIR_Coverage, 56726,
     /* 2362851 */     GIR_EraseRootFromParent_Done,
     /* 2362852 */   // Label 33018: @2362852
     /* 2362852 */   GIM_Try, /*On fail goto*//*Label 33019*/ GIMT_Encode4(2362897), // Rule ID 56727 //
     /* 2362857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2362860 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2362863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2362877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362896 */     // GIR_Coverage, 56727,
     /* 2362896 */     GIR_EraseRootFromParent_Done,
     /* 2362897 */   // Label 33019: @2362897
     /* 2362897 */   GIM_Reject,
     /* 2362898 */ // Label 33017: @2362898
     /* 2362898 */ GIM_Reject,
     /* 2362899 */ // Label 32984: @2362899
     /* 2362899 */ GIM_Try, /*On fail goto*//*Label 33020*/ GIMT_Encode4(2363013),
     /* 2362904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2362907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2362910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362922 */   GIM_Try, /*On fail goto*//*Label 33021*/ GIMT_Encode4(2362967), // Rule ID 56774 //
     /* 2362927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2362930 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2362933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2362947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362966 */     // GIR_Coverage, 56774,
     /* 2362966 */     GIR_EraseRootFromParent_Done,
     /* 2362967 */   // Label 33021: @2362967
     /* 2362967 */   GIM_Try, /*On fail goto*//*Label 33022*/ GIMT_Encode4(2363012), // Rule ID 56775 //
     /* 2362972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2362975 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2362978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2362992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363011 */     // GIR_Coverage, 56775,
     /* 2363011 */     GIR_EraseRootFromParent_Done,
     /* 2363012 */   // Label 33022: @2363012
     /* 2363012 */   GIM_Reject,
     /* 2363013 */ // Label 33020: @2363013
     /* 2363013 */ GIM_Reject,
     /* 2363014 */ // Label 32985: @2363014
     /* 2363014 */ GIM_Try, /*On fail goto*//*Label 33023*/ GIMT_Encode4(2363128),
     /* 2363019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2363022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2363025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363033 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363037 */   GIM_Try, /*On fail goto*//*Label 33024*/ GIMT_Encode4(2363082), // Rule ID 56720 //
     /* 2363042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363045 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2363048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2363062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363081 */     // GIR_Coverage, 56720,
     /* 2363081 */     GIR_EraseRootFromParent_Done,
     /* 2363082 */   // Label 33024: @2363082
     /* 2363082 */   GIM_Try, /*On fail goto*//*Label 33025*/ GIMT_Encode4(2363127), // Rule ID 56721 //
     /* 2363087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2363090 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2363093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2363107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363126 */     // GIR_Coverage, 56721,
     /* 2363126 */     GIR_EraseRootFromParent_Done,
     /* 2363127 */   // Label 33025: @2363127
     /* 2363127 */   GIM_Reject,
     /* 2363128 */ // Label 33023: @2363128
     /* 2363128 */ GIM_Reject,
     /* 2363129 */ // Label 32986: @2363129
     /* 2363129 */ GIM_Try, /*On fail goto*//*Label 33026*/ GIMT_Encode4(2363243),
     /* 2363134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2363137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2363140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363152 */   GIM_Try, /*On fail goto*//*Label 33027*/ GIMT_Encode4(2363197), // Rule ID 56756 //
     /* 2363157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2363160 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2363163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2363177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363196 */     // GIR_Coverage, 56756,
     /* 2363196 */     GIR_EraseRootFromParent_Done,
     /* 2363197 */   // Label 33027: @2363197
     /* 2363197 */   GIM_Try, /*On fail goto*//*Label 33028*/ GIMT_Encode4(2363242), // Rule ID 56757 //
     /* 2363202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2363205 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2363208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2363222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363241 */     // GIR_Coverage, 56757,
     /* 2363241 */     GIR_EraseRootFromParent_Done,
     /* 2363242 */   // Label 33028: @2363242
     /* 2363242 */   GIM_Reject,
     /* 2363243 */ // Label 33026: @2363243
     /* 2363243 */ GIM_Reject,
     /* 2363244 */ // Label 32987: @2363244
     /* 2363244 */ GIM_Try, /*On fail goto*//*Label 33029*/ GIMT_Encode4(2363358),
     /* 2363249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2363252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2363255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363267 */   GIM_Try, /*On fail goto*//*Label 33030*/ GIMT_Encode4(2363312), // Rule ID 56780 //
     /* 2363272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2363275 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2363278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2363292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363311 */     // GIR_Coverage, 56780,
     /* 2363311 */     GIR_EraseRootFromParent_Done,
     /* 2363312 */   // Label 33030: @2363312
     /* 2363312 */   GIM_Try, /*On fail goto*//*Label 33031*/ GIMT_Encode4(2363357), // Rule ID 56781 //
     /* 2363317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2363320 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2363323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2363337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363356 */     // GIR_Coverage, 56781,
     /* 2363356 */     GIR_EraseRootFromParent_Done,
     /* 2363357 */   // Label 33031: @2363357
     /* 2363357 */   GIM_Reject,
     /* 2363358 */ // Label 33029: @2363358
     /* 2363358 */ GIM_Reject,
     /* 2363359 */ // Label 32988: @2363359
     /* 2363359 */ GIM_Try, /*On fail goto*//*Label 33032*/ GIMT_Encode4(2363473),
     /* 2363364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2363367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2363370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363382 */   GIM_Try, /*On fail goto*//*Label 33033*/ GIMT_Encode4(2363427), // Rule ID 56738 //
     /* 2363387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363390 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2363393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2363407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363426 */     // GIR_Coverage, 56738,
     /* 2363426 */     GIR_EraseRootFromParent_Done,
     /* 2363427 */   // Label 33033: @2363427
     /* 2363427 */   GIM_Try, /*On fail goto*//*Label 33034*/ GIMT_Encode4(2363472), // Rule ID 56739 //
     /* 2363432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2363435 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2363438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2363452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363471 */     // GIR_Coverage, 56739,
     /* 2363471 */     GIR_EraseRootFromParent_Done,
     /* 2363472 */   // Label 33034: @2363472
     /* 2363472 */   GIM_Reject,
     /* 2363473 */ // Label 33032: @2363473
     /* 2363473 */ GIM_Reject,
     /* 2363474 */ // Label 32989: @2363474
     /* 2363474 */ GIM_Try, /*On fail goto*//*Label 33035*/ GIMT_Encode4(2363588),
     /* 2363479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2363482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2363485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363493 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363497 */   GIM_Try, /*On fail goto*//*Label 33036*/ GIMT_Encode4(2363542), // Rule ID 56762 //
     /* 2363502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2363505 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2363508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2363522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363541 */     // GIR_Coverage, 56762,
     /* 2363541 */     GIR_EraseRootFromParent_Done,
     /* 2363542 */   // Label 33036: @2363542
     /* 2363542 */   GIM_Try, /*On fail goto*//*Label 33037*/ GIMT_Encode4(2363587), // Rule ID 56763 //
     /* 2363547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2363550 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2363553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2363567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363586 */     // GIR_Coverage, 56763,
     /* 2363586 */     GIR_EraseRootFromParent_Done,
     /* 2363587 */   // Label 33037: @2363587
     /* 2363587 */   GIM_Reject,
     /* 2363588 */ // Label 33035: @2363588
     /* 2363588 */ GIM_Reject,
     /* 2363589 */ // Label 32990: @2363589
     /* 2363589 */ GIM_Try, /*On fail goto*//*Label 33038*/ GIMT_Encode4(2363703),
     /* 2363594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2363597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2363600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363612 */   GIM_Try, /*On fail goto*//*Label 33039*/ GIMT_Encode4(2363657), // Rule ID 56786 //
     /* 2363617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2363620 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2363623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2363637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363656 */     // GIR_Coverage, 56786,
     /* 2363656 */     GIR_EraseRootFromParent_Done,
     /* 2363657 */   // Label 33039: @2363657
     /* 2363657 */   GIM_Try, /*On fail goto*//*Label 33040*/ GIMT_Encode4(2363702), // Rule ID 56787 //
     /* 2363662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2363665 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2363668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2363682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363701 */     // GIR_Coverage, 56787,
     /* 2363701 */     GIR_EraseRootFromParent_Done,
     /* 2363702 */   // Label 33040: @2363702
     /* 2363702 */   GIM_Reject,
     /* 2363703 */ // Label 33038: @2363703
     /* 2363703 */ GIM_Reject,
     /* 2363704 */ // Label 32991: @2363704
     /* 2363704 */ GIM_Try, /*On fail goto*//*Label 33041*/ GIMT_Encode4(2363818),
     /* 2363709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2363712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2363715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363723 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363727 */   GIM_Try, /*On fail goto*//*Label 33042*/ GIMT_Encode4(2363772), // Rule ID 56744 //
     /* 2363732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363735 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2363738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2363752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363771 */     // GIR_Coverage, 56744,
     /* 2363771 */     GIR_EraseRootFromParent_Done,
     /* 2363772 */   // Label 33042: @2363772
     /* 2363772 */   GIM_Try, /*On fail goto*//*Label 33043*/ GIMT_Encode4(2363817), // Rule ID 56745 //
     /* 2363777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2363780 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2363783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2363797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363816 */     // GIR_Coverage, 56745,
     /* 2363816 */     GIR_EraseRootFromParent_Done,
     /* 2363817 */   // Label 33043: @2363817
     /* 2363817 */   GIM_Reject,
     /* 2363818 */ // Label 33041: @2363818
     /* 2363818 */ GIM_Reject,
     /* 2363819 */ // Label 32992: @2363819
     /* 2363819 */ GIM_Try, /*On fail goto*//*Label 33044*/ GIMT_Encode4(2363933),
     /* 2363824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2363827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2363830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363842 */   GIM_Try, /*On fail goto*//*Label 33045*/ GIMT_Encode4(2363887), // Rule ID 56768 //
     /* 2363847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2363850 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2363853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2363867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363886 */     // GIR_Coverage, 56768,
     /* 2363886 */     GIR_EraseRootFromParent_Done,
     /* 2363887 */   // Label 33045: @2363887
     /* 2363887 */   GIM_Try, /*On fail goto*//*Label 33046*/ GIMT_Encode4(2363932), // Rule ID 56769 //
     /* 2363892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2363895 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2363898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2363912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363931 */     // GIR_Coverage, 56769,
     /* 2363931 */     GIR_EraseRootFromParent_Done,
     /* 2363932 */   // Label 33046: @2363932
     /* 2363932 */   GIM_Reject,
     /* 2363933 */ // Label 33044: @2363933
     /* 2363933 */ GIM_Reject,
     /* 2363934 */ // Label 32993: @2363934
     /* 2363934 */ GIM_Try, /*On fail goto*//*Label 33047*/ GIMT_Encode4(2364048),
     /* 2363939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2363942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2363945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363957 */   GIM_Try, /*On fail goto*//*Label 33048*/ GIMT_Encode4(2364002), // Rule ID 56750 //
     /* 2363962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363965 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2363968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2363982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364001 */     // GIR_Coverage, 56750,
     /* 2364001 */     GIR_EraseRootFromParent_Done,
     /* 2364002 */   // Label 33048: @2364002
     /* 2364002 */   GIM_Try, /*On fail goto*//*Label 33049*/ GIMT_Encode4(2364047), // Rule ID 56751 //
     /* 2364007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2364010 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2364013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2364027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364046 */     // GIR_Coverage, 56751,
     /* 2364046 */     GIR_EraseRootFromParent_Done,
     /* 2364047 */   // Label 33049: @2364047
     /* 2364047 */   GIM_Reject,
     /* 2364048 */ // Label 33047: @2364048
     /* 2364048 */ GIM_Reject,
     /* 2364049 */ // Label 32994: @2364049
     /* 2364049 */ GIM_Reject,
     /* 2364050 */ // Label 79: @2364050
     /* 2364050 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 33068*/ GIMT_Encode4(2366134),
     /* 2364061 */ /*GILLT_s16*//*Label 33050*/ GIMT_Encode4(2364181),
     /* 2364065 */ /*GILLT_s32*//*Label 33051*/ GIMT_Encode4(2364248),
     /* 2364069 */ /*GILLT_s64*//*Label 33052*/ GIMT_Encode4(2364315), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2364081 */ /*GILLT_nxv1s16*//*Label 33053*/ GIMT_Encode4(2364409),
     /* 2364085 */ /*GILLT_nxv1s32*//*Label 33054*/ GIMT_Encode4(2364524),
     /* 2364089 */ /*GILLT_nxv1s64*//*Label 33055*/ GIMT_Encode4(2364639), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2364101 */ /*GILLT_nxv2s16*//*Label 33056*/ GIMT_Encode4(2364754),
     /* 2364105 */ /*GILLT_nxv2s32*//*Label 33057*/ GIMT_Encode4(2364869),
     /* 2364109 */ /*GILLT_nxv2s64*//*Label 33058*/ GIMT_Encode4(2364984), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2364121 */ /*GILLT_nxv4s16*//*Label 33059*/ GIMT_Encode4(2365099),
     /* 2364125 */ /*GILLT_nxv4s32*//*Label 33060*/ GIMT_Encode4(2365214),
     /* 2364129 */ /*GILLT_nxv4s64*//*Label 33061*/ GIMT_Encode4(2365329), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2364141 */ /*GILLT_nxv8s16*//*Label 33062*/ GIMT_Encode4(2365444),
     /* 2364145 */ /*GILLT_nxv8s32*//*Label 33063*/ GIMT_Encode4(2365559),
     /* 2364149 */ /*GILLT_nxv8s64*//*Label 33064*/ GIMT_Encode4(2365674), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2364161 */ /*GILLT_nxv16s16*//*Label 33065*/ GIMT_Encode4(2365789),
     /* 2364165 */ /*GILLT_nxv16s32*//*Label 33066*/ GIMT_Encode4(2365904), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2364177 */ /*GILLT_nxv32s16*//*Label 33067*/ GIMT_Encode4(2366019),
     /* 2364181 */ // Label 33050: @2364181
     /* 2364181 */ GIM_Try, /*On fail goto*//*Label 33069*/ GIMT_Encode4(2364247),
     /* 2364186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2364189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2364192 */   GIM_Try, /*On fail goto*//*Label 33070*/ GIMT_Encode4(2364219), // Rule ID 2050 //
     /* 2364197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2364200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2364204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2364208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2364212 */     // (fmaximumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2364212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2364217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364218 */     // GIR_Coverage, 2050,
     /* 2364218 */     GIR_Done,
     /* 2364219 */   // Label 33070: @2364219
     /* 2364219 */   GIM_Try, /*On fail goto*//*Label 33071*/ GIMT_Encode4(2364246), // Rule ID 2051 //
     /* 2364224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2364227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2364231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2364235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2364239 */     // (fmaximumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2364239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2364244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364245 */     // GIR_Coverage, 2051,
     /* 2364245 */     GIR_Done,
     /* 2364246 */   // Label 33071: @2364246
     /* 2364246 */   GIM_Reject,
     /* 2364247 */ // Label 33069: @2364247
     /* 2364247 */ GIM_Reject,
     /* 2364248 */ // Label 33051: @2364248
     /* 2364248 */ GIM_Try, /*On fail goto*//*Label 33072*/ GIMT_Encode4(2364314),
     /* 2364253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2364256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2364259 */   GIM_Try, /*On fail goto*//*Label 33073*/ GIMT_Encode4(2364286), // Rule ID 1337 //
     /* 2364264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2364267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2364271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2364275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2364279 */     // (fmaximumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2364279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2364284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364285 */     // GIR_Coverage, 1337,
     /* 2364285 */     GIR_Done,
     /* 2364286 */   // Label 33073: @2364286
     /* 2364286 */   GIM_Try, /*On fail goto*//*Label 33074*/ GIMT_Encode4(2364313), // Rule ID 1338 //
     /* 2364291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2364294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2364298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2364302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2364306 */     // (fmaximumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2364306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2364311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364312 */     // GIR_Coverage, 1338,
     /* 2364312 */     GIR_Done,
     /* 2364313 */   // Label 33074: @2364313
     /* 2364313 */   GIM_Reject,
     /* 2364314 */ // Label 33072: @2364314
     /* 2364314 */ GIM_Reject,
     /* 2364315 */ // Label 33052: @2364315
     /* 2364315 */ GIM_Try, /*On fail goto*//*Label 33075*/ GIMT_Encode4(2364408),
     /* 2364320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2364323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2364326 */   GIM_Try, /*On fail goto*//*Label 33076*/ GIMT_Encode4(2364353), // Rule ID 1711 //
     /* 2364331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2364334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2364338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2364342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2364346 */     // (fmaximumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2364346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2364351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364352 */     // GIR_Coverage, 1711,
     /* 2364352 */     GIR_Done,
     /* 2364353 */   // Label 33076: @2364353
     /* 2364353 */   GIM_Try, /*On fail goto*//*Label 33077*/ GIMT_Encode4(2364380), // Rule ID 1712 //
     /* 2364358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2364361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2364365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2364369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2364373 */     // (fmaximumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2364373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2364378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364379 */     // GIR_Coverage, 1712,
     /* 2364379 */     GIR_Done,
     /* 2364380 */   // Label 33077: @2364380
     /* 2364380 */   GIM_Try, /*On fail goto*//*Label 33078*/ GIMT_Encode4(2364407), // Rule ID 1713 //
     /* 2364385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2364388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364400 */     // (fmaximumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2364400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2364405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364406 */     // GIR_Coverage, 1713,
     /* 2364406 */     GIR_Done,
     /* 2364407 */   // Label 33078: @2364407
     /* 2364407 */   GIM_Reject,
     /* 2364408 */ // Label 33075: @2364408
     /* 2364408 */ GIM_Reject,
     /* 2364409 */ // Label 33053: @2364409
     /* 2364409 */ GIM_Try, /*On fail goto*//*Label 33079*/ GIMT_Encode4(2364523),
     /* 2364414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2364417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2364420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364432 */   GIM_Try, /*On fail goto*//*Label 33080*/ GIMT_Encode4(2364477), // Rule ID 56792 //
     /* 2364437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2364440 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2364443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2364457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364476 */     // GIR_Coverage, 56792,
     /* 2364476 */     GIR_EraseRootFromParent_Done,
     /* 2364477 */   // Label 33080: @2364477
     /* 2364477 */   GIM_Try, /*On fail goto*//*Label 33081*/ GIMT_Encode4(2364522), // Rule ID 56793 //
     /* 2364482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2364485 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2364488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2364502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364521 */     // GIR_Coverage, 56793,
     /* 2364521 */     GIR_EraseRootFromParent_Done,
     /* 2364522 */   // Label 33081: @2364522
     /* 2364522 */   GIM_Reject,
     /* 2364523 */ // Label 33079: @2364523
     /* 2364523 */ GIM_Reject,
     /* 2364524 */ // Label 33054: @2364524
     /* 2364524 */ GIM_Try, /*On fail goto*//*Label 33082*/ GIMT_Encode4(2364638),
     /* 2364529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2364532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2364535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364547 */   GIM_Try, /*On fail goto*//*Label 33083*/ GIMT_Encode4(2364592), // Rule ID 56804 //
     /* 2364552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2364555 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2364558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2364572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364591 */     // GIR_Coverage, 56804,
     /* 2364591 */     GIR_EraseRootFromParent_Done,
     /* 2364592 */   // Label 33083: @2364592
     /* 2364592 */   GIM_Try, /*On fail goto*//*Label 33084*/ GIMT_Encode4(2364637), // Rule ID 56805 //
     /* 2364597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2364600 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2364603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2364617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364636 */     // GIR_Coverage, 56805,
     /* 2364636 */     GIR_EraseRootFromParent_Done,
     /* 2364637 */   // Label 33084: @2364637
     /* 2364637 */   GIM_Reject,
     /* 2364638 */ // Label 33082: @2364638
     /* 2364638 */ GIM_Reject,
     /* 2364639 */ // Label 33055: @2364639
     /* 2364639 */ GIM_Try, /*On fail goto*//*Label 33085*/ GIMT_Encode4(2364753),
     /* 2364644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2364647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2364650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364662 */   GIM_Try, /*On fail goto*//*Label 33086*/ GIMT_Encode4(2364707), // Rule ID 56822 //
     /* 2364667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2364670 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2364673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2364687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364706 */     // GIR_Coverage, 56822,
     /* 2364706 */     GIR_EraseRootFromParent_Done,
     /* 2364707 */   // Label 33086: @2364707
     /* 2364707 */   GIM_Try, /*On fail goto*//*Label 33087*/ GIMT_Encode4(2364752), // Rule ID 56823 //
     /* 2364712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2364715 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2364718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2364732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364751 */     // GIR_Coverage, 56823,
     /* 2364751 */     GIR_EraseRootFromParent_Done,
     /* 2364752 */   // Label 33087: @2364752
     /* 2364752 */   GIM_Reject,
     /* 2364753 */ // Label 33085: @2364753
     /* 2364753 */ GIM_Reject,
     /* 2364754 */ // Label 33056: @2364754
     /* 2364754 */ GIM_Try, /*On fail goto*//*Label 33088*/ GIMT_Encode4(2364868),
     /* 2364759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2364762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2364765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364777 */   GIM_Try, /*On fail goto*//*Label 33089*/ GIMT_Encode4(2364822), // Rule ID 56798 //
     /* 2364782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2364785 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2364788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2364802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364821 */     // GIR_Coverage, 56798,
     /* 2364821 */     GIR_EraseRootFromParent_Done,
     /* 2364822 */   // Label 33089: @2364822
     /* 2364822 */   GIM_Try, /*On fail goto*//*Label 33090*/ GIMT_Encode4(2364867), // Rule ID 56799 //
     /* 2364827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2364830 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2364833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2364847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364866 */     // GIR_Coverage, 56799,
     /* 2364866 */     GIR_EraseRootFromParent_Done,
     /* 2364867 */   // Label 33090: @2364867
     /* 2364867 */   GIM_Reject,
     /* 2364868 */ // Label 33088: @2364868
     /* 2364868 */ GIM_Reject,
     /* 2364869 */ // Label 33057: @2364869
     /* 2364869 */ GIM_Try, /*On fail goto*//*Label 33091*/ GIMT_Encode4(2364983),
     /* 2364874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2364877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2364880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364892 */   GIM_Try, /*On fail goto*//*Label 33092*/ GIMT_Encode4(2364937), // Rule ID 56816 //
     /* 2364897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2364900 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2364903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2364917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364936 */     // GIR_Coverage, 56816,
     /* 2364936 */     GIR_EraseRootFromParent_Done,
     /* 2364937 */   // Label 33092: @2364937
     /* 2364937 */   GIM_Try, /*On fail goto*//*Label 33093*/ GIMT_Encode4(2364982), // Rule ID 56817 //
     /* 2364942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2364945 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2364948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2364962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364981 */     // GIR_Coverage, 56817,
     /* 2364981 */     GIR_EraseRootFromParent_Done,
     /* 2364982 */   // Label 33093: @2364982
     /* 2364982 */   GIM_Reject,
     /* 2364983 */ // Label 33091: @2364983
     /* 2364983 */ GIM_Reject,
     /* 2364984 */ // Label 33058: @2364984
     /* 2364984 */ GIM_Try, /*On fail goto*//*Label 33094*/ GIMT_Encode4(2365098),
     /* 2364989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2364992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2364995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365003 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365007 */   GIM_Try, /*On fail goto*//*Label 33095*/ GIMT_Encode4(2365052), // Rule ID 56864 //
     /* 2365012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2365015 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2365018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2365032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365051 */     // GIR_Coverage, 56864,
     /* 2365051 */     GIR_EraseRootFromParent_Done,
     /* 2365052 */   // Label 33095: @2365052
     /* 2365052 */   GIM_Try, /*On fail goto*//*Label 33096*/ GIMT_Encode4(2365097), // Rule ID 56865 //
     /* 2365057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2365060 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2365063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2365077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365096 */     // GIR_Coverage, 56865,
     /* 2365096 */     GIR_EraseRootFromParent_Done,
     /* 2365097 */   // Label 33096: @2365097
     /* 2365097 */   GIM_Reject,
     /* 2365098 */ // Label 33094: @2365098
     /* 2365098 */ GIM_Reject,
     /* 2365099 */ // Label 33059: @2365099
     /* 2365099 */ GIM_Try, /*On fail goto*//*Label 33097*/ GIMT_Encode4(2365213),
     /* 2365104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2365107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2365110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365122 */   GIM_Try, /*On fail goto*//*Label 33098*/ GIMT_Encode4(2365167), // Rule ID 56810 //
     /* 2365127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2365130 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2365133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2365147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365166 */     // GIR_Coverage, 56810,
     /* 2365166 */     GIR_EraseRootFromParent_Done,
     /* 2365167 */   // Label 33098: @2365167
     /* 2365167 */   GIM_Try, /*On fail goto*//*Label 33099*/ GIMT_Encode4(2365212), // Rule ID 56811 //
     /* 2365172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2365175 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2365178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2365192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365211 */     // GIR_Coverage, 56811,
     /* 2365211 */     GIR_EraseRootFromParent_Done,
     /* 2365212 */   // Label 33099: @2365212
     /* 2365212 */   GIM_Reject,
     /* 2365213 */ // Label 33097: @2365213
     /* 2365213 */ GIM_Reject,
     /* 2365214 */ // Label 33060: @2365214
     /* 2365214 */ GIM_Try, /*On fail goto*//*Label 33100*/ GIMT_Encode4(2365328),
     /* 2365219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2365222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2365225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365237 */   GIM_Try, /*On fail goto*//*Label 33101*/ GIMT_Encode4(2365282), // Rule ID 56846 //
     /* 2365242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2365245 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2365248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2365262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365281 */     // GIR_Coverage, 56846,
     /* 2365281 */     GIR_EraseRootFromParent_Done,
     /* 2365282 */   // Label 33101: @2365282
     /* 2365282 */   GIM_Try, /*On fail goto*//*Label 33102*/ GIMT_Encode4(2365327), // Rule ID 56847 //
     /* 2365287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2365290 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2365293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2365307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365326 */     // GIR_Coverage, 56847,
     /* 2365326 */     GIR_EraseRootFromParent_Done,
     /* 2365327 */   // Label 33102: @2365327
     /* 2365327 */   GIM_Reject,
     /* 2365328 */ // Label 33100: @2365328
     /* 2365328 */ GIM_Reject,
     /* 2365329 */ // Label 33061: @2365329
     /* 2365329 */ GIM_Try, /*On fail goto*//*Label 33103*/ GIMT_Encode4(2365443),
     /* 2365334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2365337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2365340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365352 */   GIM_Try, /*On fail goto*//*Label 33104*/ GIMT_Encode4(2365397), // Rule ID 56870 //
     /* 2365357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2365360 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2365363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2365377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365396 */     // GIR_Coverage, 56870,
     /* 2365396 */     GIR_EraseRootFromParent_Done,
     /* 2365397 */   // Label 33104: @2365397
     /* 2365397 */   GIM_Try, /*On fail goto*//*Label 33105*/ GIMT_Encode4(2365442), // Rule ID 56871 //
     /* 2365402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2365405 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2365408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2365422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365441 */     // GIR_Coverage, 56871,
     /* 2365441 */     GIR_EraseRootFromParent_Done,
     /* 2365442 */   // Label 33105: @2365442
     /* 2365442 */   GIM_Reject,
     /* 2365443 */ // Label 33103: @2365443
     /* 2365443 */ GIM_Reject,
     /* 2365444 */ // Label 33062: @2365444
     /* 2365444 */ GIM_Try, /*On fail goto*//*Label 33106*/ GIMT_Encode4(2365558),
     /* 2365449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2365452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2365455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365463 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365467 */   GIM_Try, /*On fail goto*//*Label 33107*/ GIMT_Encode4(2365512), // Rule ID 56828 //
     /* 2365472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2365475 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2365478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2365492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365511 */     // GIR_Coverage, 56828,
     /* 2365511 */     GIR_EraseRootFromParent_Done,
     /* 2365512 */   // Label 33107: @2365512
     /* 2365512 */   GIM_Try, /*On fail goto*//*Label 33108*/ GIMT_Encode4(2365557), // Rule ID 56829 //
     /* 2365517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2365520 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2365523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2365537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365556 */     // GIR_Coverage, 56829,
     /* 2365556 */     GIR_EraseRootFromParent_Done,
     /* 2365557 */   // Label 33108: @2365557
     /* 2365557 */   GIM_Reject,
     /* 2365558 */ // Label 33106: @2365558
     /* 2365558 */ GIM_Reject,
     /* 2365559 */ // Label 33063: @2365559
     /* 2365559 */ GIM_Try, /*On fail goto*//*Label 33109*/ GIMT_Encode4(2365673),
     /* 2365564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2365567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2365570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365582 */   GIM_Try, /*On fail goto*//*Label 33110*/ GIMT_Encode4(2365627), // Rule ID 56852 //
     /* 2365587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2365590 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2365593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2365607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365626 */     // GIR_Coverage, 56852,
     /* 2365626 */     GIR_EraseRootFromParent_Done,
     /* 2365627 */   // Label 33110: @2365627
     /* 2365627 */   GIM_Try, /*On fail goto*//*Label 33111*/ GIMT_Encode4(2365672), // Rule ID 56853 //
     /* 2365632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2365635 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2365638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2365652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365671 */     // GIR_Coverage, 56853,
     /* 2365671 */     GIR_EraseRootFromParent_Done,
     /* 2365672 */   // Label 33111: @2365672
     /* 2365672 */   GIM_Reject,
     /* 2365673 */ // Label 33109: @2365673
     /* 2365673 */ GIM_Reject,
     /* 2365674 */ // Label 33064: @2365674
     /* 2365674 */ GIM_Try, /*On fail goto*//*Label 33112*/ GIMT_Encode4(2365788),
     /* 2365679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2365682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2365685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365697 */   GIM_Try, /*On fail goto*//*Label 33113*/ GIMT_Encode4(2365742), // Rule ID 56876 //
     /* 2365702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2365705 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2365708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2365722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365741 */     // GIR_Coverage, 56876,
     /* 2365741 */     GIR_EraseRootFromParent_Done,
     /* 2365742 */   // Label 33113: @2365742
     /* 2365742 */   GIM_Try, /*On fail goto*//*Label 33114*/ GIMT_Encode4(2365787), // Rule ID 56877 //
     /* 2365747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2365750 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2365753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2365767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365786 */     // GIR_Coverage, 56877,
     /* 2365786 */     GIR_EraseRootFromParent_Done,
     /* 2365787 */   // Label 33114: @2365787
     /* 2365787 */   GIM_Reject,
     /* 2365788 */ // Label 33112: @2365788
     /* 2365788 */ GIM_Reject,
     /* 2365789 */ // Label 33065: @2365789
     /* 2365789 */ GIM_Try, /*On fail goto*//*Label 33115*/ GIMT_Encode4(2365903),
     /* 2365794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2365797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2365800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365812 */   GIM_Try, /*On fail goto*//*Label 33116*/ GIMT_Encode4(2365857), // Rule ID 56834 //
     /* 2365817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2365820 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2365823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2365837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365856 */     // GIR_Coverage, 56834,
     /* 2365856 */     GIR_EraseRootFromParent_Done,
     /* 2365857 */   // Label 33116: @2365857
     /* 2365857 */   GIM_Try, /*On fail goto*//*Label 33117*/ GIMT_Encode4(2365902), // Rule ID 56835 //
     /* 2365862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2365865 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2365868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2365882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365901 */     // GIR_Coverage, 56835,
     /* 2365901 */     GIR_EraseRootFromParent_Done,
     /* 2365902 */   // Label 33117: @2365902
     /* 2365902 */   GIM_Reject,
     /* 2365903 */ // Label 33115: @2365903
     /* 2365903 */ GIM_Reject,
     /* 2365904 */ // Label 33066: @2365904
     /* 2365904 */ GIM_Try, /*On fail goto*//*Label 33118*/ GIMT_Encode4(2366018),
     /* 2365909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2365912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2365915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365927 */   GIM_Try, /*On fail goto*//*Label 33119*/ GIMT_Encode4(2365972), // Rule ID 56858 //
     /* 2365932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2365935 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2365938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2365952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365971 */     // GIR_Coverage, 56858,
     /* 2365971 */     GIR_EraseRootFromParent_Done,
     /* 2365972 */   // Label 33119: @2365972
     /* 2365972 */   GIM_Try, /*On fail goto*//*Label 33120*/ GIMT_Encode4(2366017), // Rule ID 56859 //
     /* 2365977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2365980 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2365983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2365997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366016 */     // GIR_Coverage, 56859,
     /* 2366016 */     GIR_EraseRootFromParent_Done,
     /* 2366017 */   // Label 33120: @2366017
     /* 2366017 */   GIM_Reject,
     /* 2366018 */ // Label 33118: @2366018
     /* 2366018 */ GIM_Reject,
     /* 2366019 */ // Label 33067: @2366019
     /* 2366019 */ GIM_Try, /*On fail goto*//*Label 33121*/ GIMT_Encode4(2366133),
     /* 2366024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2366027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2366030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366038 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366042 */   GIM_Try, /*On fail goto*//*Label 33122*/ GIMT_Encode4(2366087), // Rule ID 56840 //
     /* 2366047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2366050 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2366053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2366067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366086 */     // GIR_Coverage, 56840,
     /* 2366086 */     GIR_EraseRootFromParent_Done,
     /* 2366087 */   // Label 33122: @2366087
     /* 2366087 */   GIM_Try, /*On fail goto*//*Label 33123*/ GIMT_Encode4(2366132), // Rule ID 56841 //
     /* 2366092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2366095 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2366098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2366112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366131 */     // GIR_Coverage, 56841,
     /* 2366131 */     GIR_EraseRootFromParent_Done,
     /* 2366132 */   // Label 33123: @2366132
     /* 2366132 */   GIM_Reject,
     /* 2366133 */ // Label 33121: @2366133
     /* 2366133 */ GIM_Reject,
     /* 2366134 */ // Label 33068: @2366134
     /* 2366134 */ GIM_Reject,
     /* 2366135 */ // Label 80: @2366135
     /* 2366135 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33148*/ GIMT_Encode4(2368910),
     /* 2366146 */ /*GILLT_s32*//*Label 33124*/ GIMT_Encode4(2366270),
     /* 2366150 */ /*GILLT_s64*//*Label 33125*/ GIMT_Encode4(2366325), GIMT_Encode4(0),
     /* 2366158 */ /*GILLT_nxv1s8*//*Label 33126*/ GIMT_Encode4(2366380),
     /* 2366162 */ /*GILLT_nxv1s16*//*Label 33127*/ GIMT_Encode4(2366495),
     /* 2366166 */ /*GILLT_nxv1s32*//*Label 33128*/ GIMT_Encode4(2366610),
     /* 2366170 */ /*GILLT_nxv1s64*//*Label 33129*/ GIMT_Encode4(2366725), GIMT_Encode4(0),
     /* 2366178 */ /*GILLT_nxv2s8*//*Label 33130*/ GIMT_Encode4(2366840),
     /* 2366182 */ /*GILLT_nxv2s16*//*Label 33131*/ GIMT_Encode4(2366955),
     /* 2366186 */ /*GILLT_nxv2s32*//*Label 33132*/ GIMT_Encode4(2367070),
     /* 2366190 */ /*GILLT_nxv2s64*//*Label 33133*/ GIMT_Encode4(2367185), GIMT_Encode4(0),
     /* 2366198 */ /*GILLT_nxv4s8*//*Label 33134*/ GIMT_Encode4(2367300),
     /* 2366202 */ /*GILLT_nxv4s16*//*Label 33135*/ GIMT_Encode4(2367415),
     /* 2366206 */ /*GILLT_nxv4s32*//*Label 33136*/ GIMT_Encode4(2367530),
     /* 2366210 */ /*GILLT_nxv4s64*//*Label 33137*/ GIMT_Encode4(2367645), GIMT_Encode4(0),
     /* 2366218 */ /*GILLT_nxv8s8*//*Label 33138*/ GIMT_Encode4(2367760),
     /* 2366222 */ /*GILLT_nxv8s16*//*Label 33139*/ GIMT_Encode4(2367875),
     /* 2366226 */ /*GILLT_nxv8s32*//*Label 33140*/ GIMT_Encode4(2367990),
     /* 2366230 */ /*GILLT_nxv8s64*//*Label 33141*/ GIMT_Encode4(2368105), GIMT_Encode4(0),
     /* 2366238 */ /*GILLT_nxv16s8*//*Label 33142*/ GIMT_Encode4(2368220),
     /* 2366242 */ /*GILLT_nxv16s16*//*Label 33143*/ GIMT_Encode4(2368335),
     /* 2366246 */ /*GILLT_nxv16s32*//*Label 33144*/ GIMT_Encode4(2368450), GIMT_Encode4(0),
     /* 2366254 */ /*GILLT_nxv32s8*//*Label 33145*/ GIMT_Encode4(2368565),
     /* 2366258 */ /*GILLT_nxv32s16*//*Label 33146*/ GIMT_Encode4(2368680), GIMT_Encode4(0),
     /* 2366266 */ /*GILLT_nxv64s8*//*Label 33147*/ GIMT_Encode4(2368795),
     /* 2366270 */ // Label 33124: @2366270
     /* 2366270 */ GIM_Try, /*On fail goto*//*Label 33149*/ GIMT_Encode4(2366324),
     /* 2366275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2366278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2366281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366293 */   GIM_Try, /*On fail goto*//*Label 33150*/ GIMT_Encode4(2366308), // Rule ID 64454 //
     /* 2366298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2366301 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2366301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2366306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366307 */     // GIR_Coverage, 64454,
     /* 2366307 */     GIR_Done,
     /* 2366308 */   // Label 33150: @2366308
     /* 2366308 */   GIM_Try, /*On fail goto*//*Label 33151*/ GIMT_Encode4(2366323), // Rule ID 2519 //
     /* 2366313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2366316 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2366316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2366321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366322 */     // GIR_Coverage, 2519,
     /* 2366322 */     GIR_Done,
     /* 2366323 */   // Label 33151: @2366323
     /* 2366323 */   GIM_Reject,
     /* 2366324 */ // Label 33149: @2366324
     /* 2366324 */ GIM_Reject,
     /* 2366325 */ // Label 33125: @2366325
     /* 2366325 */ GIM_Try, /*On fail goto*//*Label 33152*/ GIMT_Encode4(2366379),
     /* 2366330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2366333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2366336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366348 */   GIM_Try, /*On fail goto*//*Label 33153*/ GIMT_Encode4(2366363), // Rule ID 64453 //
     /* 2366353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2366356 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2366356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2366361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366362 */     // GIR_Coverage, 64453,
     /* 2366362 */     GIR_Done,
     /* 2366363 */   // Label 33153: @2366363
     /* 2366363 */   GIM_Try, /*On fail goto*//*Label 33154*/ GIMT_Encode4(2366378), // Rule ID 2518 //
     /* 2366368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2366371 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2366371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2366376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366377 */     // GIR_Coverage, 2518,
     /* 2366377 */     GIR_Done,
     /* 2366378 */   // Label 33154: @2366378
     /* 2366378 */   GIM_Reject,
     /* 2366379 */ // Label 33152: @2366379
     /* 2366379 */ GIM_Reject,
     /* 2366380 */ // Label 33126: @2366380
     /* 2366380 */ GIM_Try, /*On fail goto*//*Label 33155*/ GIMT_Encode4(2366494),
     /* 2366385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2366388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2366391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366403 */   GIM_Try, /*On fail goto*//*Label 33156*/ GIMT_Encode4(2366448), // Rule ID 50584 //
     /* 2366408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366411 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2366414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2366428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366447 */     // GIR_Coverage, 50584,
     /* 2366447 */     GIR_EraseRootFromParent_Done,
     /* 2366448 */   // Label 33156: @2366448
     /* 2366448 */   GIM_Try, /*On fail goto*//*Label 33157*/ GIMT_Encode4(2366493), // Rule ID 50585 //
     /* 2366453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366456 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2366459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2366473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366492 */     // GIR_Coverage, 50585,
     /* 2366492 */     GIR_EraseRootFromParent_Done,
     /* 2366493 */   // Label 33157: @2366493
     /* 2366493 */   GIM_Reject,
     /* 2366494 */ // Label 33155: @2366494
     /* 2366494 */ GIM_Reject,
     /* 2366495 */ // Label 33127: @2366495
     /* 2366495 */ GIM_Try, /*On fail goto*//*Label 33158*/ GIMT_Encode4(2366609),
     /* 2366500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2366503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2366506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366518 */   GIM_Try, /*On fail goto*//*Label 33159*/ GIMT_Encode4(2366563), // Rule ID 50596 //
     /* 2366523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366526 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2366529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2366543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366562 */     // GIR_Coverage, 50596,
     /* 2366562 */     GIR_EraseRootFromParent_Done,
     /* 2366563 */   // Label 33159: @2366563
     /* 2366563 */   GIM_Try, /*On fail goto*//*Label 33160*/ GIMT_Encode4(2366608), // Rule ID 50597 //
     /* 2366568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366571 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2366574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2366588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366607 */     // GIR_Coverage, 50597,
     /* 2366607 */     GIR_EraseRootFromParent_Done,
     /* 2366608 */   // Label 33160: @2366608
     /* 2366608 */   GIM_Reject,
     /* 2366609 */ // Label 33158: @2366609
     /* 2366609 */ GIM_Reject,
     /* 2366610 */ // Label 33128: @2366610
     /* 2366610 */ GIM_Try, /*On fail goto*//*Label 33161*/ GIMT_Encode4(2366724),
     /* 2366615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2366618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2366621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366633 */   GIM_Try, /*On fail goto*//*Label 33162*/ GIMT_Encode4(2366678), // Rule ID 50604 //
     /* 2366638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366641 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2366644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2366658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366677 */     // GIR_Coverage, 50604,
     /* 2366677 */     GIR_EraseRootFromParent_Done,
     /* 2366678 */   // Label 33162: @2366678
     /* 2366678 */   GIM_Try, /*On fail goto*//*Label 33163*/ GIMT_Encode4(2366723), // Rule ID 50605 //
     /* 2366683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366686 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2366689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2366703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366722 */     // GIR_Coverage, 50605,
     /* 2366722 */     GIR_EraseRootFromParent_Done,
     /* 2366723 */   // Label 33163: @2366723
     /* 2366723 */   GIM_Reject,
     /* 2366724 */ // Label 33161: @2366724
     /* 2366724 */ GIM_Reject,
     /* 2366725 */ // Label 33129: @2366725
     /* 2366725 */ GIM_Try, /*On fail goto*//*Label 33164*/ GIMT_Encode4(2366839),
     /* 2366730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2366733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2366736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366748 */   GIM_Try, /*On fail goto*//*Label 33165*/ GIMT_Encode4(2366793), // Rule ID 50620 //
     /* 2366753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2366756 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2366759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2366773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366792 */     // GIR_Coverage, 50620,
     /* 2366792 */     GIR_EraseRootFromParent_Done,
     /* 2366793 */   // Label 33165: @2366793
     /* 2366793 */   GIM_Try, /*On fail goto*//*Label 33166*/ GIMT_Encode4(2366838), // Rule ID 50621 //
     /* 2366798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2366801 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2366804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2366818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366837 */     // GIR_Coverage, 50621,
     /* 2366837 */     GIR_EraseRootFromParent_Done,
     /* 2366838 */   // Label 33166: @2366838
     /* 2366838 */   GIM_Reject,
     /* 2366839 */ // Label 33164: @2366839
     /* 2366839 */ GIM_Reject,
     /* 2366840 */ // Label 33130: @2366840
     /* 2366840 */ GIM_Try, /*On fail goto*//*Label 33167*/ GIMT_Encode4(2366954),
     /* 2366845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2366848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2366851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366863 */   GIM_Try, /*On fail goto*//*Label 33168*/ GIMT_Encode4(2366908), // Rule ID 50588 //
     /* 2366868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366871 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2366874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2366888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366907 */     // GIR_Coverage, 50588,
     /* 2366907 */     GIR_EraseRootFromParent_Done,
     /* 2366908 */   // Label 33168: @2366908
     /* 2366908 */   GIM_Try, /*On fail goto*//*Label 33169*/ GIMT_Encode4(2366953), // Rule ID 50589 //
     /* 2366913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366916 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2366919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2366933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366952 */     // GIR_Coverage, 50589,
     /* 2366952 */     GIR_EraseRootFromParent_Done,
     /* 2366953 */   // Label 33169: @2366953
     /* 2366953 */   GIM_Reject,
     /* 2366954 */ // Label 33167: @2366954
     /* 2366954 */ GIM_Reject,
     /* 2366955 */ // Label 33131: @2366955
     /* 2366955 */ GIM_Try, /*On fail goto*//*Label 33170*/ GIMT_Encode4(2367069),
     /* 2366960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2366963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2366966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366978 */   GIM_Try, /*On fail goto*//*Label 33171*/ GIMT_Encode4(2367023), // Rule ID 50600 //
     /* 2366983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366986 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2366989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2367003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367022 */     // GIR_Coverage, 50600,
     /* 2367022 */     GIR_EraseRootFromParent_Done,
     /* 2367023 */   // Label 33171: @2367023
     /* 2367023 */   GIM_Try, /*On fail goto*//*Label 33172*/ GIMT_Encode4(2367068), // Rule ID 50601 //
     /* 2367028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367031 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2367034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2367048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367067 */     // GIR_Coverage, 50601,
     /* 2367067 */     GIR_EraseRootFromParent_Done,
     /* 2367068 */   // Label 33172: @2367068
     /* 2367068 */   GIM_Reject,
     /* 2367069 */ // Label 33170: @2367069
     /* 2367069 */ GIM_Reject,
     /* 2367070 */ // Label 33132: @2367070
     /* 2367070 */ GIM_Try, /*On fail goto*//*Label 33173*/ GIMT_Encode4(2367184),
     /* 2367075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2367078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2367081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367093 */   GIM_Try, /*On fail goto*//*Label 33174*/ GIMT_Encode4(2367138), // Rule ID 50616 //
     /* 2367098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367101 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2367104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2367118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367137 */     // GIR_Coverage, 50616,
     /* 2367137 */     GIR_EraseRootFromParent_Done,
     /* 2367138 */   // Label 33174: @2367138
     /* 2367138 */   GIM_Try, /*On fail goto*//*Label 33175*/ GIMT_Encode4(2367183), // Rule ID 50617 //
     /* 2367143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367146 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2367149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2367163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367182 */     // GIR_Coverage, 50617,
     /* 2367182 */     GIR_EraseRootFromParent_Done,
     /* 2367183 */   // Label 33175: @2367183
     /* 2367183 */   GIM_Reject,
     /* 2367184 */ // Label 33173: @2367184
     /* 2367184 */ GIM_Reject,
     /* 2367185 */ // Label 33133: @2367185
     /* 2367185 */ GIM_Try, /*On fail goto*//*Label 33176*/ GIMT_Encode4(2367299),
     /* 2367190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2367193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2367196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367208 */   GIM_Try, /*On fail goto*//*Label 33177*/ GIMT_Encode4(2367253), // Rule ID 50660 //
     /* 2367213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2367216 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2367219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2367233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367252 */     // GIR_Coverage, 50660,
     /* 2367252 */     GIR_EraseRootFromParent_Done,
     /* 2367253 */   // Label 33177: @2367253
     /* 2367253 */   GIM_Try, /*On fail goto*//*Label 33178*/ GIMT_Encode4(2367298), // Rule ID 50661 //
     /* 2367258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2367261 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2367264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2367278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367297 */     // GIR_Coverage, 50661,
     /* 2367297 */     GIR_EraseRootFromParent_Done,
     /* 2367298 */   // Label 33178: @2367298
     /* 2367298 */   GIM_Reject,
     /* 2367299 */ // Label 33176: @2367299
     /* 2367299 */ GIM_Reject,
     /* 2367300 */ // Label 33134: @2367300
     /* 2367300 */ GIM_Try, /*On fail goto*//*Label 33179*/ GIMT_Encode4(2367414),
     /* 2367305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2367308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2367311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367323 */   GIM_Try, /*On fail goto*//*Label 33180*/ GIMT_Encode4(2367368), // Rule ID 50592 //
     /* 2367328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367331 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2367334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2367348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367367 */     // GIR_Coverage, 50592,
     /* 2367367 */     GIR_EraseRootFromParent_Done,
     /* 2367368 */   // Label 33180: @2367368
     /* 2367368 */   GIM_Try, /*On fail goto*//*Label 33181*/ GIMT_Encode4(2367413), // Rule ID 50593 //
     /* 2367373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367376 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2367379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2367393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367412 */     // GIR_Coverage, 50593,
     /* 2367412 */     GIR_EraseRootFromParent_Done,
     /* 2367413 */   // Label 33181: @2367413
     /* 2367413 */   GIM_Reject,
     /* 2367414 */ // Label 33179: @2367414
     /* 2367414 */ GIM_Reject,
     /* 2367415 */ // Label 33135: @2367415
     /* 2367415 */ GIM_Try, /*On fail goto*//*Label 33182*/ GIMT_Encode4(2367529),
     /* 2367420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2367423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2367426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367438 */   GIM_Try, /*On fail goto*//*Label 33183*/ GIMT_Encode4(2367483), // Rule ID 50612 //
     /* 2367443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367446 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2367449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2367463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367482 */     // GIR_Coverage, 50612,
     /* 2367482 */     GIR_EraseRootFromParent_Done,
     /* 2367483 */   // Label 33183: @2367483
     /* 2367483 */   GIM_Try, /*On fail goto*//*Label 33184*/ GIMT_Encode4(2367528), // Rule ID 50613 //
     /* 2367488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367491 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2367494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2367508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367527 */     // GIR_Coverage, 50613,
     /* 2367527 */     GIR_EraseRootFromParent_Done,
     /* 2367528 */   // Label 33184: @2367528
     /* 2367528 */   GIM_Reject,
     /* 2367529 */ // Label 33182: @2367529
     /* 2367529 */ GIM_Reject,
     /* 2367530 */ // Label 33136: @2367530
     /* 2367530 */ GIM_Try, /*On fail goto*//*Label 33185*/ GIMT_Encode4(2367644),
     /* 2367535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2367538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2367541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367553 */   GIM_Try, /*On fail goto*//*Label 33186*/ GIMT_Encode4(2367598), // Rule ID 50648 //
     /* 2367558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367561 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2367564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2367578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367597 */     // GIR_Coverage, 50648,
     /* 2367597 */     GIR_EraseRootFromParent_Done,
     /* 2367598 */   // Label 33186: @2367598
     /* 2367598 */   GIM_Try, /*On fail goto*//*Label 33187*/ GIMT_Encode4(2367643), // Rule ID 50649 //
     /* 2367603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367606 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2367609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2367623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367642 */     // GIR_Coverage, 50649,
     /* 2367642 */     GIR_EraseRootFromParent_Done,
     /* 2367643 */   // Label 33187: @2367643
     /* 2367643 */   GIM_Reject,
     /* 2367644 */ // Label 33185: @2367644
     /* 2367644 */ GIM_Reject,
     /* 2367645 */ // Label 33137: @2367645
     /* 2367645 */ GIM_Try, /*On fail goto*//*Label 33188*/ GIMT_Encode4(2367759),
     /* 2367650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2367653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2367656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367668 */   GIM_Try, /*On fail goto*//*Label 33189*/ GIMT_Encode4(2367713), // Rule ID 50664 //
     /* 2367673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2367676 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2367679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2367693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367712 */     // GIR_Coverage, 50664,
     /* 2367712 */     GIR_EraseRootFromParent_Done,
     /* 2367713 */   // Label 33189: @2367713
     /* 2367713 */   GIM_Try, /*On fail goto*//*Label 33190*/ GIMT_Encode4(2367758), // Rule ID 50665 //
     /* 2367718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2367721 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2367724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2367738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367757 */     // GIR_Coverage, 50665,
     /* 2367757 */     GIR_EraseRootFromParent_Done,
     /* 2367758 */   // Label 33190: @2367758
     /* 2367758 */   GIM_Reject,
     /* 2367759 */ // Label 33188: @2367759
     /* 2367759 */ GIM_Reject,
     /* 2367760 */ // Label 33138: @2367760
     /* 2367760 */ GIM_Try, /*On fail goto*//*Label 33191*/ GIMT_Encode4(2367874),
     /* 2367765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2367768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2367771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367783 */   GIM_Try, /*On fail goto*//*Label 33192*/ GIMT_Encode4(2367828), // Rule ID 50608 //
     /* 2367788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367791 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2367794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2367808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367827 */     // GIR_Coverage, 50608,
     /* 2367827 */     GIR_EraseRootFromParent_Done,
     /* 2367828 */   // Label 33192: @2367828
     /* 2367828 */   GIM_Try, /*On fail goto*//*Label 33193*/ GIMT_Encode4(2367873), // Rule ID 50609 //
     /* 2367833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367836 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2367839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2367853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367872 */     // GIR_Coverage, 50609,
     /* 2367872 */     GIR_EraseRootFromParent_Done,
     /* 2367873 */   // Label 33193: @2367873
     /* 2367873 */   GIM_Reject,
     /* 2367874 */ // Label 33191: @2367874
     /* 2367874 */ GIM_Reject,
     /* 2367875 */ // Label 33139: @2367875
     /* 2367875 */ GIM_Try, /*On fail goto*//*Label 33194*/ GIMT_Encode4(2367989),
     /* 2367880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2367883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2367886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367898 */   GIM_Try, /*On fail goto*//*Label 33195*/ GIMT_Encode4(2367943), // Rule ID 50636 //
     /* 2367903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367906 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2367909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2367923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367942 */     // GIR_Coverage, 50636,
     /* 2367942 */     GIR_EraseRootFromParent_Done,
     /* 2367943 */   // Label 33195: @2367943
     /* 2367943 */   GIM_Try, /*On fail goto*//*Label 33196*/ GIMT_Encode4(2367988), // Rule ID 50637 //
     /* 2367948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367951 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2367954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2367968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367987 */     // GIR_Coverage, 50637,
     /* 2367987 */     GIR_EraseRootFromParent_Done,
     /* 2367988 */   // Label 33196: @2367988
     /* 2367988 */   GIM_Reject,
     /* 2367989 */ // Label 33194: @2367989
     /* 2367989 */ GIM_Reject,
     /* 2367990 */ // Label 33140: @2367990
     /* 2367990 */ GIM_Try, /*On fail goto*//*Label 33197*/ GIMT_Encode4(2368104),
     /* 2367995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2367998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2368001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368013 */   GIM_Try, /*On fail goto*//*Label 33198*/ GIMT_Encode4(2368058), // Rule ID 50652 //
     /* 2368018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368021 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2368024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2368038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368057 */     // GIR_Coverage, 50652,
     /* 2368057 */     GIR_EraseRootFromParent_Done,
     /* 2368058 */   // Label 33198: @2368058
     /* 2368058 */   GIM_Try, /*On fail goto*//*Label 33199*/ GIMT_Encode4(2368103), // Rule ID 50653 //
     /* 2368063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368066 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2368069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2368083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368102 */     // GIR_Coverage, 50653,
     /* 2368102 */     GIR_EraseRootFromParent_Done,
     /* 2368103 */   // Label 33199: @2368103
     /* 2368103 */   GIM_Reject,
     /* 2368104 */ // Label 33197: @2368104
     /* 2368104 */ GIM_Reject,
     /* 2368105 */ // Label 33141: @2368105
     /* 2368105 */ GIM_Try, /*On fail goto*//*Label 33200*/ GIMT_Encode4(2368219),
     /* 2368110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2368113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2368116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368128 */   GIM_Try, /*On fail goto*//*Label 33201*/ GIMT_Encode4(2368173), // Rule ID 50668 //
     /* 2368133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2368136 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2368139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2368153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368172 */     // GIR_Coverage, 50668,
     /* 2368172 */     GIR_EraseRootFromParent_Done,
     /* 2368173 */   // Label 33201: @2368173
     /* 2368173 */   GIM_Try, /*On fail goto*//*Label 33202*/ GIMT_Encode4(2368218), // Rule ID 50669 //
     /* 2368178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2368181 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2368184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2368198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368217 */     // GIR_Coverage, 50669,
     /* 2368217 */     GIR_EraseRootFromParent_Done,
     /* 2368218 */   // Label 33202: @2368218
     /* 2368218 */   GIM_Reject,
     /* 2368219 */ // Label 33200: @2368219
     /* 2368219 */ GIM_Reject,
     /* 2368220 */ // Label 33142: @2368220
     /* 2368220 */ GIM_Try, /*On fail goto*//*Label 33203*/ GIMT_Encode4(2368334),
     /* 2368225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2368228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2368231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368243 */   GIM_Try, /*On fail goto*//*Label 33204*/ GIMT_Encode4(2368288), // Rule ID 50624 //
     /* 2368248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368251 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2368254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2368268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368287 */     // GIR_Coverage, 50624,
     /* 2368287 */     GIR_EraseRootFromParent_Done,
     /* 2368288 */   // Label 33204: @2368288
     /* 2368288 */   GIM_Try, /*On fail goto*//*Label 33205*/ GIMT_Encode4(2368333), // Rule ID 50625 //
     /* 2368293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368296 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2368299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2368313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368332 */     // GIR_Coverage, 50625,
     /* 2368332 */     GIR_EraseRootFromParent_Done,
     /* 2368333 */   // Label 33205: @2368333
     /* 2368333 */   GIM_Reject,
     /* 2368334 */ // Label 33203: @2368334
     /* 2368334 */ GIM_Reject,
     /* 2368335 */ // Label 33143: @2368335
     /* 2368335 */ GIM_Try, /*On fail goto*//*Label 33206*/ GIMT_Encode4(2368449),
     /* 2368340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2368343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2368346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368358 */   GIM_Try, /*On fail goto*//*Label 33207*/ GIMT_Encode4(2368403), // Rule ID 50640 //
     /* 2368363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368366 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2368369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2368383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368402 */     // GIR_Coverage, 50640,
     /* 2368402 */     GIR_EraseRootFromParent_Done,
     /* 2368403 */   // Label 33207: @2368403
     /* 2368403 */   GIM_Try, /*On fail goto*//*Label 33208*/ GIMT_Encode4(2368448), // Rule ID 50641 //
     /* 2368408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368411 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2368414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2368428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368447 */     // GIR_Coverage, 50641,
     /* 2368447 */     GIR_EraseRootFromParent_Done,
     /* 2368448 */   // Label 33208: @2368448
     /* 2368448 */   GIM_Reject,
     /* 2368449 */ // Label 33206: @2368449
     /* 2368449 */ GIM_Reject,
     /* 2368450 */ // Label 33144: @2368450
     /* 2368450 */ GIM_Try, /*On fail goto*//*Label 33209*/ GIMT_Encode4(2368564),
     /* 2368455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2368458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2368461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368473 */   GIM_Try, /*On fail goto*//*Label 33210*/ GIMT_Encode4(2368518), // Rule ID 50656 //
     /* 2368478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368481 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2368484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2368498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368517 */     // GIR_Coverage, 50656,
     /* 2368517 */     GIR_EraseRootFromParent_Done,
     /* 2368518 */   // Label 33210: @2368518
     /* 2368518 */   GIM_Try, /*On fail goto*//*Label 33211*/ GIMT_Encode4(2368563), // Rule ID 50657 //
     /* 2368523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368526 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2368529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2368543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368562 */     // GIR_Coverage, 50657,
     /* 2368562 */     GIR_EraseRootFromParent_Done,
     /* 2368563 */   // Label 33211: @2368563
     /* 2368563 */   GIM_Reject,
     /* 2368564 */ // Label 33209: @2368564
     /* 2368564 */ GIM_Reject,
     /* 2368565 */ // Label 33145: @2368565
     /* 2368565 */ GIM_Try, /*On fail goto*//*Label 33212*/ GIMT_Encode4(2368679),
     /* 2368570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2368573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2368576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368588 */   GIM_Try, /*On fail goto*//*Label 33213*/ GIMT_Encode4(2368633), // Rule ID 50628 //
     /* 2368593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368596 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2368599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2368613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368632 */     // GIR_Coverage, 50628,
     /* 2368632 */     GIR_EraseRootFromParent_Done,
     /* 2368633 */   // Label 33213: @2368633
     /* 2368633 */   GIM_Try, /*On fail goto*//*Label 33214*/ GIMT_Encode4(2368678), // Rule ID 50629 //
     /* 2368638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368641 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2368644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2368658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368677 */     // GIR_Coverage, 50629,
     /* 2368677 */     GIR_EraseRootFromParent_Done,
     /* 2368678 */   // Label 33214: @2368678
     /* 2368678 */   GIM_Reject,
     /* 2368679 */ // Label 33212: @2368679
     /* 2368679 */ GIM_Reject,
     /* 2368680 */ // Label 33146: @2368680
     /* 2368680 */ GIM_Try, /*On fail goto*//*Label 33215*/ GIMT_Encode4(2368794),
     /* 2368685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2368688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2368691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368703 */   GIM_Try, /*On fail goto*//*Label 33216*/ GIMT_Encode4(2368748), // Rule ID 50644 //
     /* 2368708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368711 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2368714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2368728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368747 */     // GIR_Coverage, 50644,
     /* 2368747 */     GIR_EraseRootFromParent_Done,
     /* 2368748 */   // Label 33216: @2368748
     /* 2368748 */   GIM_Try, /*On fail goto*//*Label 33217*/ GIMT_Encode4(2368793), // Rule ID 50645 //
     /* 2368753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368756 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2368759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2368773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368792 */     // GIR_Coverage, 50645,
     /* 2368792 */     GIR_EraseRootFromParent_Done,
     /* 2368793 */   // Label 33217: @2368793
     /* 2368793 */   GIM_Reject,
     /* 2368794 */ // Label 33215: @2368794
     /* 2368794 */ GIM_Reject,
     /* 2368795 */ // Label 33147: @2368795
     /* 2368795 */ GIM_Try, /*On fail goto*//*Label 33218*/ GIMT_Encode4(2368909),
     /* 2368800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2368803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2368806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368818 */   GIM_Try, /*On fail goto*//*Label 33219*/ GIMT_Encode4(2368863), // Rule ID 50632 //
     /* 2368823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368826 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2368829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2368843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368862 */     // GIR_Coverage, 50632,
     /* 2368862 */     GIR_EraseRootFromParent_Done,
     /* 2368863 */   // Label 33219: @2368863
     /* 2368863 */   GIM_Try, /*On fail goto*//*Label 33220*/ GIMT_Encode4(2368908), // Rule ID 50633 //
     /* 2368868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368871 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2368874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2368888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368907 */     // GIR_Coverage, 50633,
     /* 2368907 */     GIR_EraseRootFromParent_Done,
     /* 2368908 */   // Label 33220: @2368908
     /* 2368908 */   GIM_Reject,
     /* 2368909 */ // Label 33218: @2368909
     /* 2368909 */ GIM_Reject,
     /* 2368910 */ // Label 33148: @2368910
     /* 2368910 */ GIM_Reject,
     /* 2368911 */ // Label 81: @2368911
     /* 2368911 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33245*/ GIMT_Encode4(2371686),
     /* 2368922 */ /*GILLT_s32*//*Label 33221*/ GIMT_Encode4(2369046),
     /* 2368926 */ /*GILLT_s64*//*Label 33222*/ GIMT_Encode4(2369101), GIMT_Encode4(0),
     /* 2368934 */ /*GILLT_nxv1s8*//*Label 33223*/ GIMT_Encode4(2369156),
     /* 2368938 */ /*GILLT_nxv1s16*//*Label 33224*/ GIMT_Encode4(2369271),
     /* 2368942 */ /*GILLT_nxv1s32*//*Label 33225*/ GIMT_Encode4(2369386),
     /* 2368946 */ /*GILLT_nxv1s64*//*Label 33226*/ GIMT_Encode4(2369501), GIMT_Encode4(0),
     /* 2368954 */ /*GILLT_nxv2s8*//*Label 33227*/ GIMT_Encode4(2369616),
     /* 2368958 */ /*GILLT_nxv2s16*//*Label 33228*/ GIMT_Encode4(2369731),
     /* 2368962 */ /*GILLT_nxv2s32*//*Label 33229*/ GIMT_Encode4(2369846),
     /* 2368966 */ /*GILLT_nxv2s64*//*Label 33230*/ GIMT_Encode4(2369961), GIMT_Encode4(0),
     /* 2368974 */ /*GILLT_nxv4s8*//*Label 33231*/ GIMT_Encode4(2370076),
     /* 2368978 */ /*GILLT_nxv4s16*//*Label 33232*/ GIMT_Encode4(2370191),
     /* 2368982 */ /*GILLT_nxv4s32*//*Label 33233*/ GIMT_Encode4(2370306),
     /* 2368986 */ /*GILLT_nxv4s64*//*Label 33234*/ GIMT_Encode4(2370421), GIMT_Encode4(0),
     /* 2368994 */ /*GILLT_nxv8s8*//*Label 33235*/ GIMT_Encode4(2370536),
     /* 2368998 */ /*GILLT_nxv8s16*//*Label 33236*/ GIMT_Encode4(2370651),
     /* 2369002 */ /*GILLT_nxv8s32*//*Label 33237*/ GIMT_Encode4(2370766),
     /* 2369006 */ /*GILLT_nxv8s64*//*Label 33238*/ GIMT_Encode4(2370881), GIMT_Encode4(0),
     /* 2369014 */ /*GILLT_nxv16s8*//*Label 33239*/ GIMT_Encode4(2370996),
     /* 2369018 */ /*GILLT_nxv16s16*//*Label 33240*/ GIMT_Encode4(2371111),
     /* 2369022 */ /*GILLT_nxv16s32*//*Label 33241*/ GIMT_Encode4(2371226), GIMT_Encode4(0),
     /* 2369030 */ /*GILLT_nxv32s8*//*Label 33242*/ GIMT_Encode4(2371341),
     /* 2369034 */ /*GILLT_nxv32s16*//*Label 33243*/ GIMT_Encode4(2371456), GIMT_Encode4(0),
     /* 2369042 */ /*GILLT_nxv64s8*//*Label 33244*/ GIMT_Encode4(2371571),
     /* 2369046 */ // Label 33221: @2369046
     /* 2369046 */ GIM_Try, /*On fail goto*//*Label 33246*/ GIMT_Encode4(2369100),
     /* 2369051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2369054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2369057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369069 */   GIM_Try, /*On fail goto*//*Label 33247*/ GIMT_Encode4(2369084), // Rule ID 64458 //
     /* 2369074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2369077 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2369077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2369082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369083 */     // GIR_Coverage, 64458,
     /* 2369083 */     GIR_Done,
     /* 2369084 */   // Label 33247: @2369084
     /* 2369084 */   GIM_Try, /*On fail goto*//*Label 33248*/ GIMT_Encode4(2369099), // Rule ID 2521 //
     /* 2369089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2369092 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2369092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2369097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369098 */     // GIR_Coverage, 2521,
     /* 2369098 */     GIR_Done,
     /* 2369099 */   // Label 33248: @2369099
     /* 2369099 */   GIM_Reject,
     /* 2369100 */ // Label 33246: @2369100
     /* 2369100 */ GIM_Reject,
     /* 2369101 */ // Label 33222: @2369101
     /* 2369101 */ GIM_Try, /*On fail goto*//*Label 33249*/ GIMT_Encode4(2369155),
     /* 2369106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2369109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2369112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369124 */   GIM_Try, /*On fail goto*//*Label 33250*/ GIMT_Encode4(2369139), // Rule ID 64457 //
     /* 2369129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2369132 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2369132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2369137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369138 */     // GIR_Coverage, 64457,
     /* 2369138 */     GIR_Done,
     /* 2369139 */   // Label 33250: @2369139
     /* 2369139 */   GIM_Try, /*On fail goto*//*Label 33251*/ GIMT_Encode4(2369154), // Rule ID 2520 //
     /* 2369144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2369147 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2369147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2369152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369153 */     // GIR_Coverage, 2520,
     /* 2369153 */     GIR_Done,
     /* 2369154 */   // Label 33251: @2369154
     /* 2369154 */   GIM_Reject,
     /* 2369155 */ // Label 33249: @2369155
     /* 2369155 */ GIM_Reject,
     /* 2369156 */ // Label 33223: @2369156
     /* 2369156 */ GIM_Try, /*On fail goto*//*Label 33252*/ GIMT_Encode4(2369270),
     /* 2369161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2369164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2369167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369179 */   GIM_Try, /*On fail goto*//*Label 33253*/ GIMT_Encode4(2369224), // Rule ID 50760 //
     /* 2369184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369187 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2369190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2369204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369223 */     // GIR_Coverage, 50760,
     /* 2369223 */     GIR_EraseRootFromParent_Done,
     /* 2369224 */   // Label 33253: @2369224
     /* 2369224 */   GIM_Try, /*On fail goto*//*Label 33254*/ GIMT_Encode4(2369269), // Rule ID 50761 //
     /* 2369229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369232 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2369235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2369249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369268 */     // GIR_Coverage, 50761,
     /* 2369268 */     GIR_EraseRootFromParent_Done,
     /* 2369269 */   // Label 33254: @2369269
     /* 2369269 */   GIM_Reject,
     /* 2369270 */ // Label 33252: @2369270
     /* 2369270 */ GIM_Reject,
     /* 2369271 */ // Label 33224: @2369271
     /* 2369271 */ GIM_Try, /*On fail goto*//*Label 33255*/ GIMT_Encode4(2369385),
     /* 2369276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2369279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2369282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369294 */   GIM_Try, /*On fail goto*//*Label 33256*/ GIMT_Encode4(2369339), // Rule ID 50772 //
     /* 2369299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369302 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2369305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2369319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369338 */     // GIR_Coverage, 50772,
     /* 2369338 */     GIR_EraseRootFromParent_Done,
     /* 2369339 */   // Label 33256: @2369339
     /* 2369339 */   GIM_Try, /*On fail goto*//*Label 33257*/ GIMT_Encode4(2369384), // Rule ID 50773 //
     /* 2369344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369347 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2369350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2369364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369383 */     // GIR_Coverage, 50773,
     /* 2369383 */     GIR_EraseRootFromParent_Done,
     /* 2369384 */   // Label 33257: @2369384
     /* 2369384 */   GIM_Reject,
     /* 2369385 */ // Label 33255: @2369385
     /* 2369385 */ GIM_Reject,
     /* 2369386 */ // Label 33225: @2369386
     /* 2369386 */ GIM_Try, /*On fail goto*//*Label 33258*/ GIMT_Encode4(2369500),
     /* 2369391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2369394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2369397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369409 */   GIM_Try, /*On fail goto*//*Label 33259*/ GIMT_Encode4(2369454), // Rule ID 50780 //
     /* 2369414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369417 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2369420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2369434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369453 */     // GIR_Coverage, 50780,
     /* 2369453 */     GIR_EraseRootFromParent_Done,
     /* 2369454 */   // Label 33259: @2369454
     /* 2369454 */   GIM_Try, /*On fail goto*//*Label 33260*/ GIMT_Encode4(2369499), // Rule ID 50781 //
     /* 2369459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369462 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2369465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2369479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369498 */     // GIR_Coverage, 50781,
     /* 2369498 */     GIR_EraseRootFromParent_Done,
     /* 2369499 */   // Label 33260: @2369499
     /* 2369499 */   GIM_Reject,
     /* 2369500 */ // Label 33258: @2369500
     /* 2369500 */ GIM_Reject,
     /* 2369501 */ // Label 33226: @2369501
     /* 2369501 */ GIM_Try, /*On fail goto*//*Label 33261*/ GIMT_Encode4(2369615),
     /* 2369506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2369509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2369512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369524 */   GIM_Try, /*On fail goto*//*Label 33262*/ GIMT_Encode4(2369569), // Rule ID 50796 //
     /* 2369529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2369532 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2369535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2369549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369568 */     // GIR_Coverage, 50796,
     /* 2369568 */     GIR_EraseRootFromParent_Done,
     /* 2369569 */   // Label 33262: @2369569
     /* 2369569 */   GIM_Try, /*On fail goto*//*Label 33263*/ GIMT_Encode4(2369614), // Rule ID 50797 //
     /* 2369574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2369577 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2369580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2369594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369613 */     // GIR_Coverage, 50797,
     /* 2369613 */     GIR_EraseRootFromParent_Done,
     /* 2369614 */   // Label 33263: @2369614
     /* 2369614 */   GIM_Reject,
     /* 2369615 */ // Label 33261: @2369615
     /* 2369615 */ GIM_Reject,
     /* 2369616 */ // Label 33227: @2369616
     /* 2369616 */ GIM_Try, /*On fail goto*//*Label 33264*/ GIMT_Encode4(2369730),
     /* 2369621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2369624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2369627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369639 */   GIM_Try, /*On fail goto*//*Label 33265*/ GIMT_Encode4(2369684), // Rule ID 50764 //
     /* 2369644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369647 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2369650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2369664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369683 */     // GIR_Coverage, 50764,
     /* 2369683 */     GIR_EraseRootFromParent_Done,
     /* 2369684 */   // Label 33265: @2369684
     /* 2369684 */   GIM_Try, /*On fail goto*//*Label 33266*/ GIMT_Encode4(2369729), // Rule ID 50765 //
     /* 2369689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369692 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2369695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2369709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369728 */     // GIR_Coverage, 50765,
     /* 2369728 */     GIR_EraseRootFromParent_Done,
     /* 2369729 */   // Label 33266: @2369729
     /* 2369729 */   GIM_Reject,
     /* 2369730 */ // Label 33264: @2369730
     /* 2369730 */ GIM_Reject,
     /* 2369731 */ // Label 33228: @2369731
     /* 2369731 */ GIM_Try, /*On fail goto*//*Label 33267*/ GIMT_Encode4(2369845),
     /* 2369736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2369739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2369742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369754 */   GIM_Try, /*On fail goto*//*Label 33268*/ GIMT_Encode4(2369799), // Rule ID 50776 //
     /* 2369759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369762 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2369765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2369779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369798 */     // GIR_Coverage, 50776,
     /* 2369798 */     GIR_EraseRootFromParent_Done,
     /* 2369799 */   // Label 33268: @2369799
     /* 2369799 */   GIM_Try, /*On fail goto*//*Label 33269*/ GIMT_Encode4(2369844), // Rule ID 50777 //
     /* 2369804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369807 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2369810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2369824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369843 */     // GIR_Coverage, 50777,
     /* 2369843 */     GIR_EraseRootFromParent_Done,
     /* 2369844 */   // Label 33269: @2369844
     /* 2369844 */   GIM_Reject,
     /* 2369845 */ // Label 33267: @2369845
     /* 2369845 */ GIM_Reject,
     /* 2369846 */ // Label 33229: @2369846
     /* 2369846 */ GIM_Try, /*On fail goto*//*Label 33270*/ GIMT_Encode4(2369960),
     /* 2369851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2369854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2369857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369869 */   GIM_Try, /*On fail goto*//*Label 33271*/ GIMT_Encode4(2369914), // Rule ID 50792 //
     /* 2369874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369877 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2369880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2369894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369913 */     // GIR_Coverage, 50792,
     /* 2369913 */     GIR_EraseRootFromParent_Done,
     /* 2369914 */   // Label 33271: @2369914
     /* 2369914 */   GIM_Try, /*On fail goto*//*Label 33272*/ GIMT_Encode4(2369959), // Rule ID 50793 //
     /* 2369919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369922 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2369925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2369939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369958 */     // GIR_Coverage, 50793,
     /* 2369958 */     GIR_EraseRootFromParent_Done,
     /* 2369959 */   // Label 33272: @2369959
     /* 2369959 */   GIM_Reject,
     /* 2369960 */ // Label 33270: @2369960
     /* 2369960 */ GIM_Reject,
     /* 2369961 */ // Label 33230: @2369961
     /* 2369961 */ GIM_Try, /*On fail goto*//*Label 33273*/ GIMT_Encode4(2370075),
     /* 2369966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2369969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2369972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369984 */   GIM_Try, /*On fail goto*//*Label 33274*/ GIMT_Encode4(2370029), // Rule ID 50836 //
     /* 2369989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2369992 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2369995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2370009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370028 */     // GIR_Coverage, 50836,
     /* 2370028 */     GIR_EraseRootFromParent_Done,
     /* 2370029 */   // Label 33274: @2370029
     /* 2370029 */   GIM_Try, /*On fail goto*//*Label 33275*/ GIMT_Encode4(2370074), // Rule ID 50837 //
     /* 2370034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2370037 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2370040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2370054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370073 */     // GIR_Coverage, 50837,
     /* 2370073 */     GIR_EraseRootFromParent_Done,
     /* 2370074 */   // Label 33275: @2370074
     /* 2370074 */   GIM_Reject,
     /* 2370075 */ // Label 33273: @2370075
     /* 2370075 */ GIM_Reject,
     /* 2370076 */ // Label 33231: @2370076
     /* 2370076 */ GIM_Try, /*On fail goto*//*Label 33276*/ GIMT_Encode4(2370190),
     /* 2370081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2370084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2370087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370099 */   GIM_Try, /*On fail goto*//*Label 33277*/ GIMT_Encode4(2370144), // Rule ID 50768 //
     /* 2370104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370107 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2370110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2370124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370143 */     // GIR_Coverage, 50768,
     /* 2370143 */     GIR_EraseRootFromParent_Done,
     /* 2370144 */   // Label 33277: @2370144
     /* 2370144 */   GIM_Try, /*On fail goto*//*Label 33278*/ GIMT_Encode4(2370189), // Rule ID 50769 //
     /* 2370149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370152 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2370155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2370169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370188 */     // GIR_Coverage, 50769,
     /* 2370188 */     GIR_EraseRootFromParent_Done,
     /* 2370189 */   // Label 33278: @2370189
     /* 2370189 */   GIM_Reject,
     /* 2370190 */ // Label 33276: @2370190
     /* 2370190 */ GIM_Reject,
     /* 2370191 */ // Label 33232: @2370191
     /* 2370191 */ GIM_Try, /*On fail goto*//*Label 33279*/ GIMT_Encode4(2370305),
     /* 2370196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2370199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2370202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370214 */   GIM_Try, /*On fail goto*//*Label 33280*/ GIMT_Encode4(2370259), // Rule ID 50788 //
     /* 2370219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370222 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2370225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2370239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370258 */     // GIR_Coverage, 50788,
     /* 2370258 */     GIR_EraseRootFromParent_Done,
     /* 2370259 */   // Label 33280: @2370259
     /* 2370259 */   GIM_Try, /*On fail goto*//*Label 33281*/ GIMT_Encode4(2370304), // Rule ID 50789 //
     /* 2370264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370267 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2370270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2370284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370303 */     // GIR_Coverage, 50789,
     /* 2370303 */     GIR_EraseRootFromParent_Done,
     /* 2370304 */   // Label 33281: @2370304
     /* 2370304 */   GIM_Reject,
     /* 2370305 */ // Label 33279: @2370305
     /* 2370305 */ GIM_Reject,
     /* 2370306 */ // Label 33233: @2370306
     /* 2370306 */ GIM_Try, /*On fail goto*//*Label 33282*/ GIMT_Encode4(2370420),
     /* 2370311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2370314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2370317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370329 */   GIM_Try, /*On fail goto*//*Label 33283*/ GIMT_Encode4(2370374), // Rule ID 50824 //
     /* 2370334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370337 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2370340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2370354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370373 */     // GIR_Coverage, 50824,
     /* 2370373 */     GIR_EraseRootFromParent_Done,
     /* 2370374 */   // Label 33283: @2370374
     /* 2370374 */   GIM_Try, /*On fail goto*//*Label 33284*/ GIMT_Encode4(2370419), // Rule ID 50825 //
     /* 2370379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370382 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2370385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2370399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370418 */     // GIR_Coverage, 50825,
     /* 2370418 */     GIR_EraseRootFromParent_Done,
     /* 2370419 */   // Label 33284: @2370419
     /* 2370419 */   GIM_Reject,
     /* 2370420 */ // Label 33282: @2370420
     /* 2370420 */ GIM_Reject,
     /* 2370421 */ // Label 33234: @2370421
     /* 2370421 */ GIM_Try, /*On fail goto*//*Label 33285*/ GIMT_Encode4(2370535),
     /* 2370426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2370429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2370432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2370436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2370440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2370444 */   GIM_Try, /*On fail goto*//*Label 33286*/ GIMT_Encode4(2370489), // Rule ID 50840 //
     /* 2370449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2370452 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2370455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2370469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370488 */     // GIR_Coverage, 50840,
     /* 2370488 */     GIR_EraseRootFromParent_Done,
     /* 2370489 */   // Label 33286: @2370489
     /* 2370489 */   GIM_Try, /*On fail goto*//*Label 33287*/ GIMT_Encode4(2370534), // Rule ID 50841 //
     /* 2370494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2370497 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2370500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2370514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370533 */     // GIR_Coverage, 50841,
     /* 2370533 */     GIR_EraseRootFromParent_Done,
     /* 2370534 */   // Label 33287: @2370534
     /* 2370534 */   GIM_Reject,
     /* 2370535 */ // Label 33285: @2370535
     /* 2370535 */ GIM_Reject,
     /* 2370536 */ // Label 33235: @2370536
     /* 2370536 */ GIM_Try, /*On fail goto*//*Label 33288*/ GIMT_Encode4(2370650),
     /* 2370541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2370544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2370547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370559 */   GIM_Try, /*On fail goto*//*Label 33289*/ GIMT_Encode4(2370604), // Rule ID 50784 //
     /* 2370564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370567 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2370570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2370584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370603 */     // GIR_Coverage, 50784,
     /* 2370603 */     GIR_EraseRootFromParent_Done,
     /* 2370604 */   // Label 33289: @2370604
     /* 2370604 */   GIM_Try, /*On fail goto*//*Label 33290*/ GIMT_Encode4(2370649), // Rule ID 50785 //
     /* 2370609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370612 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2370615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2370629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370648 */     // GIR_Coverage, 50785,
     /* 2370648 */     GIR_EraseRootFromParent_Done,
     /* 2370649 */   // Label 33290: @2370649
     /* 2370649 */   GIM_Reject,
     /* 2370650 */ // Label 33288: @2370650
     /* 2370650 */ GIM_Reject,
     /* 2370651 */ // Label 33236: @2370651
     /* 2370651 */ GIM_Try, /*On fail goto*//*Label 33291*/ GIMT_Encode4(2370765),
     /* 2370656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2370659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2370662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370674 */   GIM_Try, /*On fail goto*//*Label 33292*/ GIMT_Encode4(2370719), // Rule ID 50812 //
     /* 2370679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370682 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2370685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2370699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370718 */     // GIR_Coverage, 50812,
     /* 2370718 */     GIR_EraseRootFromParent_Done,
     /* 2370719 */   // Label 33292: @2370719
     /* 2370719 */   GIM_Try, /*On fail goto*//*Label 33293*/ GIMT_Encode4(2370764), // Rule ID 50813 //
     /* 2370724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370727 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2370730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2370744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370763 */     // GIR_Coverage, 50813,
     /* 2370763 */     GIR_EraseRootFromParent_Done,
     /* 2370764 */   // Label 33293: @2370764
     /* 2370764 */   GIM_Reject,
     /* 2370765 */ // Label 33291: @2370765
     /* 2370765 */ GIM_Reject,
     /* 2370766 */ // Label 33237: @2370766
     /* 2370766 */ GIM_Try, /*On fail goto*//*Label 33294*/ GIMT_Encode4(2370880),
     /* 2370771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2370774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2370777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2370781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2370785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2370789 */   GIM_Try, /*On fail goto*//*Label 33295*/ GIMT_Encode4(2370834), // Rule ID 50828 //
     /* 2370794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370797 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2370800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2370814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370833 */     // GIR_Coverage, 50828,
     /* 2370833 */     GIR_EraseRootFromParent_Done,
     /* 2370834 */   // Label 33295: @2370834
     /* 2370834 */   GIM_Try, /*On fail goto*//*Label 33296*/ GIMT_Encode4(2370879), // Rule ID 50829 //
     /* 2370839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370842 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2370845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2370859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370878 */     // GIR_Coverage, 50829,
     /* 2370878 */     GIR_EraseRootFromParent_Done,
     /* 2370879 */   // Label 33296: @2370879
     /* 2370879 */   GIM_Reject,
     /* 2370880 */ // Label 33294: @2370880
     /* 2370880 */ GIM_Reject,
     /* 2370881 */ // Label 33238: @2370881
     /* 2370881 */ GIM_Try, /*On fail goto*//*Label 33297*/ GIMT_Encode4(2370995),
     /* 2370886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2370889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2370892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2370896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2370900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2370904 */   GIM_Try, /*On fail goto*//*Label 33298*/ GIMT_Encode4(2370949), // Rule ID 50844 //
     /* 2370909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2370912 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2370915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2370929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370948 */     // GIR_Coverage, 50844,
     /* 2370948 */     GIR_EraseRootFromParent_Done,
     /* 2370949 */   // Label 33298: @2370949
     /* 2370949 */   GIM_Try, /*On fail goto*//*Label 33299*/ GIMT_Encode4(2370994), // Rule ID 50845 //
     /* 2370954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2370957 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2370960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2370974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370993 */     // GIR_Coverage, 50845,
     /* 2370993 */     GIR_EraseRootFromParent_Done,
     /* 2370994 */   // Label 33299: @2370994
     /* 2370994 */   GIM_Reject,
     /* 2370995 */ // Label 33297: @2370995
     /* 2370995 */ GIM_Reject,
     /* 2370996 */ // Label 33239: @2370996
     /* 2370996 */ GIM_Try, /*On fail goto*//*Label 33300*/ GIMT_Encode4(2371110),
     /* 2371001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2371004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2371007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371019 */   GIM_Try, /*On fail goto*//*Label 33301*/ GIMT_Encode4(2371064), // Rule ID 50800 //
     /* 2371024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371027 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2371030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2371044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371063 */     // GIR_Coverage, 50800,
     /* 2371063 */     GIR_EraseRootFromParent_Done,
     /* 2371064 */   // Label 33301: @2371064
     /* 2371064 */   GIM_Try, /*On fail goto*//*Label 33302*/ GIMT_Encode4(2371109), // Rule ID 50801 //
     /* 2371069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371072 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2371075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2371089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371108 */     // GIR_Coverage, 50801,
     /* 2371108 */     GIR_EraseRootFromParent_Done,
     /* 2371109 */   // Label 33302: @2371109
     /* 2371109 */   GIM_Reject,
     /* 2371110 */ // Label 33300: @2371110
     /* 2371110 */ GIM_Reject,
     /* 2371111 */ // Label 33240: @2371111
     /* 2371111 */ GIM_Try, /*On fail goto*//*Label 33303*/ GIMT_Encode4(2371225),
     /* 2371116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2371119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2371122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371134 */   GIM_Try, /*On fail goto*//*Label 33304*/ GIMT_Encode4(2371179), // Rule ID 50816 //
     /* 2371139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371142 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2371145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2371159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371178 */     // GIR_Coverage, 50816,
     /* 2371178 */     GIR_EraseRootFromParent_Done,
     /* 2371179 */   // Label 33304: @2371179
     /* 2371179 */   GIM_Try, /*On fail goto*//*Label 33305*/ GIMT_Encode4(2371224), // Rule ID 50817 //
     /* 2371184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371187 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2371190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2371204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371223 */     // GIR_Coverage, 50817,
     /* 2371223 */     GIR_EraseRootFromParent_Done,
     /* 2371224 */   // Label 33305: @2371224
     /* 2371224 */   GIM_Reject,
     /* 2371225 */ // Label 33303: @2371225
     /* 2371225 */ GIM_Reject,
     /* 2371226 */ // Label 33241: @2371226
     /* 2371226 */ GIM_Try, /*On fail goto*//*Label 33306*/ GIMT_Encode4(2371340),
     /* 2371231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2371234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2371237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371249 */   GIM_Try, /*On fail goto*//*Label 33307*/ GIMT_Encode4(2371294), // Rule ID 50832 //
     /* 2371254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371257 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2371260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2371274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371293 */     // GIR_Coverage, 50832,
     /* 2371293 */     GIR_EraseRootFromParent_Done,
     /* 2371294 */   // Label 33307: @2371294
     /* 2371294 */   GIM_Try, /*On fail goto*//*Label 33308*/ GIMT_Encode4(2371339), // Rule ID 50833 //
     /* 2371299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371302 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2371305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2371319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371338 */     // GIR_Coverage, 50833,
     /* 2371338 */     GIR_EraseRootFromParent_Done,
     /* 2371339 */   // Label 33308: @2371339
     /* 2371339 */   GIM_Reject,
     /* 2371340 */ // Label 33306: @2371340
     /* 2371340 */ GIM_Reject,
     /* 2371341 */ // Label 33242: @2371341
     /* 2371341 */ GIM_Try, /*On fail goto*//*Label 33309*/ GIMT_Encode4(2371455),
     /* 2371346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2371349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2371352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371360 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371364 */   GIM_Try, /*On fail goto*//*Label 33310*/ GIMT_Encode4(2371409), // Rule ID 50804 //
     /* 2371369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371372 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2371375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2371389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371408 */     // GIR_Coverage, 50804,
     /* 2371408 */     GIR_EraseRootFromParent_Done,
     /* 2371409 */   // Label 33310: @2371409
     /* 2371409 */   GIM_Try, /*On fail goto*//*Label 33311*/ GIMT_Encode4(2371454), // Rule ID 50805 //
     /* 2371414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371417 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2371420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2371434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371453 */     // GIR_Coverage, 50805,
     /* 2371453 */     GIR_EraseRootFromParent_Done,
     /* 2371454 */   // Label 33311: @2371454
     /* 2371454 */   GIM_Reject,
     /* 2371455 */ // Label 33309: @2371455
     /* 2371455 */ GIM_Reject,
     /* 2371456 */ // Label 33243: @2371456
     /* 2371456 */ GIM_Try, /*On fail goto*//*Label 33312*/ GIMT_Encode4(2371570),
     /* 2371461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2371464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2371467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371479 */   GIM_Try, /*On fail goto*//*Label 33313*/ GIMT_Encode4(2371524), // Rule ID 50820 //
     /* 2371484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371487 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2371490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2371504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371523 */     // GIR_Coverage, 50820,
     /* 2371523 */     GIR_EraseRootFromParent_Done,
     /* 2371524 */   // Label 33313: @2371524
     /* 2371524 */   GIM_Try, /*On fail goto*//*Label 33314*/ GIMT_Encode4(2371569), // Rule ID 50821 //
     /* 2371529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371532 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2371535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2371549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371568 */     // GIR_Coverage, 50821,
     /* 2371568 */     GIR_EraseRootFromParent_Done,
     /* 2371569 */   // Label 33314: @2371569
     /* 2371569 */   GIM_Reject,
     /* 2371570 */ // Label 33312: @2371570
     /* 2371570 */ GIM_Reject,
     /* 2371571 */ // Label 33244: @2371571
     /* 2371571 */ GIM_Try, /*On fail goto*//*Label 33315*/ GIMT_Encode4(2371685),
     /* 2371576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2371579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2371582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371594 */   GIM_Try, /*On fail goto*//*Label 33316*/ GIMT_Encode4(2371639), // Rule ID 50808 //
     /* 2371599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371602 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2371605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2371619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371638 */     // GIR_Coverage, 50808,
     /* 2371638 */     GIR_EraseRootFromParent_Done,
     /* 2371639 */   // Label 33316: @2371639
     /* 2371639 */   GIM_Try, /*On fail goto*//*Label 33317*/ GIMT_Encode4(2371684), // Rule ID 50809 //
     /* 2371644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371647 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2371650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2371664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371683 */     // GIR_Coverage, 50809,
     /* 2371683 */     GIR_EraseRootFromParent_Done,
     /* 2371684 */   // Label 33317: @2371684
     /* 2371684 */   GIM_Reject,
     /* 2371685 */ // Label 33315: @2371685
     /* 2371685 */ GIM_Reject,
     /* 2371686 */ // Label 33245: @2371686
     /* 2371686 */ GIM_Reject,
     /* 2371687 */ // Label 82: @2371687
     /* 2371687 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33342*/ GIMT_Encode4(2374462),
     /* 2371698 */ /*GILLT_s32*//*Label 33318*/ GIMT_Encode4(2371822),
     /* 2371702 */ /*GILLT_s64*//*Label 33319*/ GIMT_Encode4(2371877), GIMT_Encode4(0),
     /* 2371710 */ /*GILLT_nxv1s8*//*Label 33320*/ GIMT_Encode4(2371932),
     /* 2371714 */ /*GILLT_nxv1s16*//*Label 33321*/ GIMT_Encode4(2372047),
     /* 2371718 */ /*GILLT_nxv1s32*//*Label 33322*/ GIMT_Encode4(2372162),
     /* 2371722 */ /*GILLT_nxv1s64*//*Label 33323*/ GIMT_Encode4(2372277), GIMT_Encode4(0),
     /* 2371730 */ /*GILLT_nxv2s8*//*Label 33324*/ GIMT_Encode4(2372392),
     /* 2371734 */ /*GILLT_nxv2s16*//*Label 33325*/ GIMT_Encode4(2372507),
     /* 2371738 */ /*GILLT_nxv2s32*//*Label 33326*/ GIMT_Encode4(2372622),
     /* 2371742 */ /*GILLT_nxv2s64*//*Label 33327*/ GIMT_Encode4(2372737), GIMT_Encode4(0),
     /* 2371750 */ /*GILLT_nxv4s8*//*Label 33328*/ GIMT_Encode4(2372852),
     /* 2371754 */ /*GILLT_nxv4s16*//*Label 33329*/ GIMT_Encode4(2372967),
     /* 2371758 */ /*GILLT_nxv4s32*//*Label 33330*/ GIMT_Encode4(2373082),
     /* 2371762 */ /*GILLT_nxv4s64*//*Label 33331*/ GIMT_Encode4(2373197), GIMT_Encode4(0),
     /* 2371770 */ /*GILLT_nxv8s8*//*Label 33332*/ GIMT_Encode4(2373312),
     /* 2371774 */ /*GILLT_nxv8s16*//*Label 33333*/ GIMT_Encode4(2373427),
     /* 2371778 */ /*GILLT_nxv8s32*//*Label 33334*/ GIMT_Encode4(2373542),
     /* 2371782 */ /*GILLT_nxv8s64*//*Label 33335*/ GIMT_Encode4(2373657), GIMT_Encode4(0),
     /* 2371790 */ /*GILLT_nxv16s8*//*Label 33336*/ GIMT_Encode4(2373772),
     /* 2371794 */ /*GILLT_nxv16s16*//*Label 33337*/ GIMT_Encode4(2373887),
     /* 2371798 */ /*GILLT_nxv16s32*//*Label 33338*/ GIMT_Encode4(2374002), GIMT_Encode4(0),
     /* 2371806 */ /*GILLT_nxv32s8*//*Label 33339*/ GIMT_Encode4(2374117),
     /* 2371810 */ /*GILLT_nxv32s16*//*Label 33340*/ GIMT_Encode4(2374232), GIMT_Encode4(0),
     /* 2371818 */ /*GILLT_nxv64s8*//*Label 33341*/ GIMT_Encode4(2374347),
     /* 2371822 */ // Label 33318: @2371822
     /* 2371822 */ GIM_Try, /*On fail goto*//*Label 33343*/ GIMT_Encode4(2371876),
     /* 2371827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2371830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2371833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2371837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2371841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2371845 */   GIM_Try, /*On fail goto*//*Label 33344*/ GIMT_Encode4(2371860), // Rule ID 64456 //
     /* 2371850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2371853 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2371853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2371858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371859 */     // GIR_Coverage, 64456,
     /* 2371859 */     GIR_Done,
     /* 2371860 */   // Label 33344: @2371860
     /* 2371860 */   GIM_Try, /*On fail goto*//*Label 33345*/ GIMT_Encode4(2371875), // Rule ID 2523 //
     /* 2371865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2371868 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2371868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2371873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371874 */     // GIR_Coverage, 2523,
     /* 2371874 */     GIR_Done,
     /* 2371875 */   // Label 33345: @2371875
     /* 2371875 */   GIM_Reject,
     /* 2371876 */ // Label 33343: @2371876
     /* 2371876 */ GIM_Reject,
     /* 2371877 */ // Label 33319: @2371877
     /* 2371877 */ GIM_Try, /*On fail goto*//*Label 33346*/ GIMT_Encode4(2371931),
     /* 2371882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2371885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2371888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2371892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2371896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2371900 */   GIM_Try, /*On fail goto*//*Label 33347*/ GIMT_Encode4(2371915), // Rule ID 64455 //
     /* 2371905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2371908 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2371908 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2371913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371914 */     // GIR_Coverage, 64455,
     /* 2371914 */     GIR_Done,
     /* 2371915 */   // Label 33347: @2371915
     /* 2371915 */   GIM_Try, /*On fail goto*//*Label 33348*/ GIMT_Encode4(2371930), // Rule ID 2522 //
     /* 2371920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2371923 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2371923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2371928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371929 */     // GIR_Coverage, 2522,
     /* 2371929 */     GIR_Done,
     /* 2371930 */   // Label 33348: @2371930
     /* 2371930 */   GIM_Reject,
     /* 2371931 */ // Label 33346: @2371931
     /* 2371931 */ GIM_Reject,
     /* 2371932 */ // Label 33320: @2371932
     /* 2371932 */ GIM_Try, /*On fail goto*//*Label 33349*/ GIMT_Encode4(2372046),
     /* 2371937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2371940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2371943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371955 */   GIM_Try, /*On fail goto*//*Label 33350*/ GIMT_Encode4(2372000), // Rule ID 50496 //
     /* 2371960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371963 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2371966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2371980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371999 */     // GIR_Coverage, 50496,
     /* 2371999 */     GIR_EraseRootFromParent_Done,
     /* 2372000 */   // Label 33350: @2372000
     /* 2372000 */   GIM_Try, /*On fail goto*//*Label 33351*/ GIMT_Encode4(2372045), // Rule ID 50497 //
     /* 2372005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372008 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2372011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2372025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372044 */     // GIR_Coverage, 50497,
     /* 2372044 */     GIR_EraseRootFromParent_Done,
     /* 2372045 */   // Label 33351: @2372045
     /* 2372045 */   GIM_Reject,
     /* 2372046 */ // Label 33349: @2372046
     /* 2372046 */ GIM_Reject,
     /* 2372047 */ // Label 33321: @2372047
     /* 2372047 */ GIM_Try, /*On fail goto*//*Label 33352*/ GIMT_Encode4(2372161),
     /* 2372052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2372055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2372058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372070 */   GIM_Try, /*On fail goto*//*Label 33353*/ GIMT_Encode4(2372115), // Rule ID 50508 //
     /* 2372075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372078 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2372081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2372095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372114 */     // GIR_Coverage, 50508,
     /* 2372114 */     GIR_EraseRootFromParent_Done,
     /* 2372115 */   // Label 33353: @2372115
     /* 2372115 */   GIM_Try, /*On fail goto*//*Label 33354*/ GIMT_Encode4(2372160), // Rule ID 50509 //
     /* 2372120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372123 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2372126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2372140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372159 */     // GIR_Coverage, 50509,
     /* 2372159 */     GIR_EraseRootFromParent_Done,
     /* 2372160 */   // Label 33354: @2372160
     /* 2372160 */   GIM_Reject,
     /* 2372161 */ // Label 33352: @2372161
     /* 2372161 */ GIM_Reject,
     /* 2372162 */ // Label 33322: @2372162
     /* 2372162 */ GIM_Try, /*On fail goto*//*Label 33355*/ GIMT_Encode4(2372276),
     /* 2372167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2372170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2372173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372185 */   GIM_Try, /*On fail goto*//*Label 33356*/ GIMT_Encode4(2372230), // Rule ID 50516 //
     /* 2372190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372193 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2372196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2372210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372229 */     // GIR_Coverage, 50516,
     /* 2372229 */     GIR_EraseRootFromParent_Done,
     /* 2372230 */   // Label 33356: @2372230
     /* 2372230 */   GIM_Try, /*On fail goto*//*Label 33357*/ GIMT_Encode4(2372275), // Rule ID 50517 //
     /* 2372235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372238 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2372241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2372255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372274 */     // GIR_Coverage, 50517,
     /* 2372274 */     GIR_EraseRootFromParent_Done,
     /* 2372275 */   // Label 33357: @2372275
     /* 2372275 */   GIM_Reject,
     /* 2372276 */ // Label 33355: @2372276
     /* 2372276 */ GIM_Reject,
     /* 2372277 */ // Label 33323: @2372277
     /* 2372277 */ GIM_Try, /*On fail goto*//*Label 33358*/ GIMT_Encode4(2372391),
     /* 2372282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2372285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2372288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372300 */   GIM_Try, /*On fail goto*//*Label 33359*/ GIMT_Encode4(2372345), // Rule ID 50532 //
     /* 2372305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2372308 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2372311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2372325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2372340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372344 */     // GIR_Coverage, 50532,
     /* 2372344 */     GIR_EraseRootFromParent_Done,
     /* 2372345 */   // Label 33359: @2372345
     /* 2372345 */   GIM_Try, /*On fail goto*//*Label 33360*/ GIMT_Encode4(2372390), // Rule ID 50533 //
     /* 2372350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2372353 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2372356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2372370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2372385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372389 */     // GIR_Coverage, 50533,
     /* 2372389 */     GIR_EraseRootFromParent_Done,
     /* 2372390 */   // Label 33360: @2372390
     /* 2372390 */   GIM_Reject,
     /* 2372391 */ // Label 33358: @2372391
     /* 2372391 */ GIM_Reject,
     /* 2372392 */ // Label 33324: @2372392
     /* 2372392 */ GIM_Try, /*On fail goto*//*Label 33361*/ GIMT_Encode4(2372506),
     /* 2372397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2372400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2372403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372415 */   GIM_Try, /*On fail goto*//*Label 33362*/ GIMT_Encode4(2372460), // Rule ID 50500 //
     /* 2372420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372423 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2372426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2372440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372459 */     // GIR_Coverage, 50500,
     /* 2372459 */     GIR_EraseRootFromParent_Done,
     /* 2372460 */   // Label 33362: @2372460
     /* 2372460 */   GIM_Try, /*On fail goto*//*Label 33363*/ GIMT_Encode4(2372505), // Rule ID 50501 //
     /* 2372465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372468 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2372471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2372485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372504 */     // GIR_Coverage, 50501,
     /* 2372504 */     GIR_EraseRootFromParent_Done,
     /* 2372505 */   // Label 33363: @2372505
     /* 2372505 */   GIM_Reject,
     /* 2372506 */ // Label 33361: @2372506
     /* 2372506 */ GIM_Reject,
     /* 2372507 */ // Label 33325: @2372507
     /* 2372507 */ GIM_Try, /*On fail goto*//*Label 33364*/ GIMT_Encode4(2372621),
     /* 2372512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2372515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2372518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372530 */   GIM_Try, /*On fail goto*//*Label 33365*/ GIMT_Encode4(2372575), // Rule ID 50512 //
     /* 2372535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372538 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2372541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2372555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372574 */     // GIR_Coverage, 50512,
     /* 2372574 */     GIR_EraseRootFromParent_Done,
     /* 2372575 */   // Label 33365: @2372575
     /* 2372575 */   GIM_Try, /*On fail goto*//*Label 33366*/ GIMT_Encode4(2372620), // Rule ID 50513 //
     /* 2372580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372583 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2372586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2372600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372619 */     // GIR_Coverage, 50513,
     /* 2372619 */     GIR_EraseRootFromParent_Done,
     /* 2372620 */   // Label 33366: @2372620
     /* 2372620 */   GIM_Reject,
     /* 2372621 */ // Label 33364: @2372621
     /* 2372621 */ GIM_Reject,
     /* 2372622 */ // Label 33326: @2372622
     /* 2372622 */ GIM_Try, /*On fail goto*//*Label 33367*/ GIMT_Encode4(2372736),
     /* 2372627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2372630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2372633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372641 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372645 */   GIM_Try, /*On fail goto*//*Label 33368*/ GIMT_Encode4(2372690), // Rule ID 50528 //
     /* 2372650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372653 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2372656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2372670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372689 */     // GIR_Coverage, 50528,
     /* 2372689 */     GIR_EraseRootFromParent_Done,
     /* 2372690 */   // Label 33368: @2372690
     /* 2372690 */   GIM_Try, /*On fail goto*//*Label 33369*/ GIMT_Encode4(2372735), // Rule ID 50529 //
     /* 2372695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372698 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2372701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2372715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372734 */     // GIR_Coverage, 50529,
     /* 2372734 */     GIR_EraseRootFromParent_Done,
     /* 2372735 */   // Label 33369: @2372735
     /* 2372735 */   GIM_Reject,
     /* 2372736 */ // Label 33367: @2372736
     /* 2372736 */ GIM_Reject,
     /* 2372737 */ // Label 33327: @2372737
     /* 2372737 */ GIM_Try, /*On fail goto*//*Label 33370*/ GIMT_Encode4(2372851),
     /* 2372742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2372745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2372748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2372752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2372756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2372760 */   GIM_Try, /*On fail goto*//*Label 33371*/ GIMT_Encode4(2372805), // Rule ID 50572 //
     /* 2372765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2372768 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2372771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2372785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2372800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372804 */     // GIR_Coverage, 50572,
     /* 2372804 */     GIR_EraseRootFromParent_Done,
     /* 2372805 */   // Label 33371: @2372805
     /* 2372805 */   GIM_Try, /*On fail goto*//*Label 33372*/ GIMT_Encode4(2372850), // Rule ID 50573 //
     /* 2372810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2372813 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2372816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2372830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2372845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372849 */     // GIR_Coverage, 50573,
     /* 2372849 */     GIR_EraseRootFromParent_Done,
     /* 2372850 */   // Label 33372: @2372850
     /* 2372850 */   GIM_Reject,
     /* 2372851 */ // Label 33370: @2372851
     /* 2372851 */ GIM_Reject,
     /* 2372852 */ // Label 33328: @2372852
     /* 2372852 */ GIM_Try, /*On fail goto*//*Label 33373*/ GIMT_Encode4(2372966),
     /* 2372857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2372860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2372863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372871 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372875 */   GIM_Try, /*On fail goto*//*Label 33374*/ GIMT_Encode4(2372920), // Rule ID 50504 //
     /* 2372880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372883 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2372886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2372900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372919 */     // GIR_Coverage, 50504,
     /* 2372919 */     GIR_EraseRootFromParent_Done,
     /* 2372920 */   // Label 33374: @2372920
     /* 2372920 */   GIM_Try, /*On fail goto*//*Label 33375*/ GIMT_Encode4(2372965), // Rule ID 50505 //
     /* 2372925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372928 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2372931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2372945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372964 */     // GIR_Coverage, 50505,
     /* 2372964 */     GIR_EraseRootFromParent_Done,
     /* 2372965 */   // Label 33375: @2372965
     /* 2372965 */   GIM_Reject,
     /* 2372966 */ // Label 33373: @2372966
     /* 2372966 */ GIM_Reject,
     /* 2372967 */ // Label 33329: @2372967
     /* 2372967 */ GIM_Try, /*On fail goto*//*Label 33376*/ GIMT_Encode4(2373081),
     /* 2372972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2372975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2372978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372990 */   GIM_Try, /*On fail goto*//*Label 33377*/ GIMT_Encode4(2373035), // Rule ID 50524 //
     /* 2372995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372998 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2373001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2373015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373034 */     // GIR_Coverage, 50524,
     /* 2373034 */     GIR_EraseRootFromParent_Done,
     /* 2373035 */   // Label 33377: @2373035
     /* 2373035 */   GIM_Try, /*On fail goto*//*Label 33378*/ GIMT_Encode4(2373080), // Rule ID 50525 //
     /* 2373040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373043 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2373046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2373060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373079 */     // GIR_Coverage, 50525,
     /* 2373079 */     GIR_EraseRootFromParent_Done,
     /* 2373080 */   // Label 33378: @2373080
     /* 2373080 */   GIM_Reject,
     /* 2373081 */ // Label 33376: @2373081
     /* 2373081 */ GIM_Reject,
     /* 2373082 */ // Label 33330: @2373082
     /* 2373082 */ GIM_Try, /*On fail goto*//*Label 33379*/ GIMT_Encode4(2373196),
     /* 2373087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2373090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2373093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373105 */   GIM_Try, /*On fail goto*//*Label 33380*/ GIMT_Encode4(2373150), // Rule ID 50560 //
     /* 2373110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373113 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2373116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2373130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373149 */     // GIR_Coverage, 50560,
     /* 2373149 */     GIR_EraseRootFromParent_Done,
     /* 2373150 */   // Label 33380: @2373150
     /* 2373150 */   GIM_Try, /*On fail goto*//*Label 33381*/ GIMT_Encode4(2373195), // Rule ID 50561 //
     /* 2373155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373158 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2373161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2373175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373194 */     // GIR_Coverage, 50561,
     /* 2373194 */     GIR_EraseRootFromParent_Done,
     /* 2373195 */   // Label 33381: @2373195
     /* 2373195 */   GIM_Reject,
     /* 2373196 */ // Label 33379: @2373196
     /* 2373196 */ GIM_Reject,
     /* 2373197 */ // Label 33331: @2373197
     /* 2373197 */ GIM_Try, /*On fail goto*//*Label 33382*/ GIMT_Encode4(2373311),
     /* 2373202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2373205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2373208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373220 */   GIM_Try, /*On fail goto*//*Label 33383*/ GIMT_Encode4(2373265), // Rule ID 50576 //
     /* 2373225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2373228 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2373231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2373245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373264 */     // GIR_Coverage, 50576,
     /* 2373264 */     GIR_EraseRootFromParent_Done,
     /* 2373265 */   // Label 33383: @2373265
     /* 2373265 */   GIM_Try, /*On fail goto*//*Label 33384*/ GIMT_Encode4(2373310), // Rule ID 50577 //
     /* 2373270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2373273 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2373276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2373290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373309 */     // GIR_Coverage, 50577,
     /* 2373309 */     GIR_EraseRootFromParent_Done,
     /* 2373310 */   // Label 33384: @2373310
     /* 2373310 */   GIM_Reject,
     /* 2373311 */ // Label 33382: @2373311
     /* 2373311 */ GIM_Reject,
     /* 2373312 */ // Label 33332: @2373312
     /* 2373312 */ GIM_Try, /*On fail goto*//*Label 33385*/ GIMT_Encode4(2373426),
     /* 2373317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2373320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2373323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373331 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373335 */   GIM_Try, /*On fail goto*//*Label 33386*/ GIMT_Encode4(2373380), // Rule ID 50520 //
     /* 2373340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373343 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2373346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2373360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373379 */     // GIR_Coverage, 50520,
     /* 2373379 */     GIR_EraseRootFromParent_Done,
     /* 2373380 */   // Label 33386: @2373380
     /* 2373380 */   GIM_Try, /*On fail goto*//*Label 33387*/ GIMT_Encode4(2373425), // Rule ID 50521 //
     /* 2373385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373388 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2373391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2373405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373424 */     // GIR_Coverage, 50521,
     /* 2373424 */     GIR_EraseRootFromParent_Done,
     /* 2373425 */   // Label 33387: @2373425
     /* 2373425 */   GIM_Reject,
     /* 2373426 */ // Label 33385: @2373426
     /* 2373426 */ GIM_Reject,
     /* 2373427 */ // Label 33333: @2373427
     /* 2373427 */ GIM_Try, /*On fail goto*//*Label 33388*/ GIMT_Encode4(2373541),
     /* 2373432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2373435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2373438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373450 */   GIM_Try, /*On fail goto*//*Label 33389*/ GIMT_Encode4(2373495), // Rule ID 50548 //
     /* 2373455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373458 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2373461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2373475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373494 */     // GIR_Coverage, 50548,
     /* 2373494 */     GIR_EraseRootFromParent_Done,
     /* 2373495 */   // Label 33389: @2373495
     /* 2373495 */   GIM_Try, /*On fail goto*//*Label 33390*/ GIMT_Encode4(2373540), // Rule ID 50549 //
     /* 2373500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373503 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2373506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2373520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373539 */     // GIR_Coverage, 50549,
     /* 2373539 */     GIR_EraseRootFromParent_Done,
     /* 2373540 */   // Label 33390: @2373540
     /* 2373540 */   GIM_Reject,
     /* 2373541 */ // Label 33388: @2373541
     /* 2373541 */ GIM_Reject,
     /* 2373542 */ // Label 33334: @2373542
     /* 2373542 */ GIM_Try, /*On fail goto*//*Label 33391*/ GIMT_Encode4(2373656),
     /* 2373547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2373550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2373553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373565 */   GIM_Try, /*On fail goto*//*Label 33392*/ GIMT_Encode4(2373610), // Rule ID 50564 //
     /* 2373570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373573 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2373576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2373590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373609 */     // GIR_Coverage, 50564,
     /* 2373609 */     GIR_EraseRootFromParent_Done,
     /* 2373610 */   // Label 33392: @2373610
     /* 2373610 */   GIM_Try, /*On fail goto*//*Label 33393*/ GIMT_Encode4(2373655), // Rule ID 50565 //
     /* 2373615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373618 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2373621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2373635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373654 */     // GIR_Coverage, 50565,
     /* 2373654 */     GIR_EraseRootFromParent_Done,
     /* 2373655 */   // Label 33393: @2373655
     /* 2373655 */   GIM_Reject,
     /* 2373656 */ // Label 33391: @2373656
     /* 2373656 */ GIM_Reject,
     /* 2373657 */ // Label 33335: @2373657
     /* 2373657 */ GIM_Try, /*On fail goto*//*Label 33394*/ GIMT_Encode4(2373771),
     /* 2373662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2373665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2373668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2373672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2373676 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2373680 */   GIM_Try, /*On fail goto*//*Label 33395*/ GIMT_Encode4(2373725), // Rule ID 50580 //
     /* 2373685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2373688 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2373691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2373705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373724 */     // GIR_Coverage, 50580,
     /* 2373724 */     GIR_EraseRootFromParent_Done,
     /* 2373725 */   // Label 33395: @2373725
     /* 2373725 */   GIM_Try, /*On fail goto*//*Label 33396*/ GIMT_Encode4(2373770), // Rule ID 50581 //
     /* 2373730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2373733 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2373736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2373750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373769 */     // GIR_Coverage, 50581,
     /* 2373769 */     GIR_EraseRootFromParent_Done,
     /* 2373770 */   // Label 33396: @2373770
     /* 2373770 */   GIM_Reject,
     /* 2373771 */ // Label 33394: @2373771
     /* 2373771 */ GIM_Reject,
     /* 2373772 */ // Label 33336: @2373772
     /* 2373772 */ GIM_Try, /*On fail goto*//*Label 33397*/ GIMT_Encode4(2373886),
     /* 2373777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2373780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2373783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373795 */   GIM_Try, /*On fail goto*//*Label 33398*/ GIMT_Encode4(2373840), // Rule ID 50536 //
     /* 2373800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373803 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2373806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2373820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373839 */     // GIR_Coverage, 50536,
     /* 2373839 */     GIR_EraseRootFromParent_Done,
     /* 2373840 */   // Label 33398: @2373840
     /* 2373840 */   GIM_Try, /*On fail goto*//*Label 33399*/ GIMT_Encode4(2373885), // Rule ID 50537 //
     /* 2373845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373848 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2373851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2373865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373884 */     // GIR_Coverage, 50537,
     /* 2373884 */     GIR_EraseRootFromParent_Done,
     /* 2373885 */   // Label 33399: @2373885
     /* 2373885 */   GIM_Reject,
     /* 2373886 */ // Label 33397: @2373886
     /* 2373886 */ GIM_Reject,
     /* 2373887 */ // Label 33337: @2373887
     /* 2373887 */ GIM_Try, /*On fail goto*//*Label 33400*/ GIMT_Encode4(2374001),
     /* 2373892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2373895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2373898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373906 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373910 */   GIM_Try, /*On fail goto*//*Label 33401*/ GIMT_Encode4(2373955), // Rule ID 50552 //
     /* 2373915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373918 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2373921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2373935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373954 */     // GIR_Coverage, 50552,
     /* 2373954 */     GIR_EraseRootFromParent_Done,
     /* 2373955 */   // Label 33401: @2373955
     /* 2373955 */   GIM_Try, /*On fail goto*//*Label 33402*/ GIMT_Encode4(2374000), // Rule ID 50553 //
     /* 2373960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373963 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2373966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2373980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373999 */     // GIR_Coverage, 50553,
     /* 2373999 */     GIR_EraseRootFromParent_Done,
     /* 2374000 */   // Label 33402: @2374000
     /* 2374000 */   GIM_Reject,
     /* 2374001 */ // Label 33400: @2374001
     /* 2374001 */ GIM_Reject,
     /* 2374002 */ // Label 33338: @2374002
     /* 2374002 */ GIM_Try, /*On fail goto*//*Label 33403*/ GIMT_Encode4(2374116),
     /* 2374007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2374010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2374013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374025 */   GIM_Try, /*On fail goto*//*Label 33404*/ GIMT_Encode4(2374070), // Rule ID 50568 //
     /* 2374030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374033 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2374036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2374050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374069 */     // GIR_Coverage, 50568,
     /* 2374069 */     GIR_EraseRootFromParent_Done,
     /* 2374070 */   // Label 33404: @2374070
     /* 2374070 */   GIM_Try, /*On fail goto*//*Label 33405*/ GIMT_Encode4(2374115), // Rule ID 50569 //
     /* 2374075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374078 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2374081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2374095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374114 */     // GIR_Coverage, 50569,
     /* 2374114 */     GIR_EraseRootFromParent_Done,
     /* 2374115 */   // Label 33405: @2374115
     /* 2374115 */   GIM_Reject,
     /* 2374116 */ // Label 33403: @2374116
     /* 2374116 */ GIM_Reject,
     /* 2374117 */ // Label 33339: @2374117
     /* 2374117 */ GIM_Try, /*On fail goto*//*Label 33406*/ GIMT_Encode4(2374231),
     /* 2374122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2374125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2374128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374140 */   GIM_Try, /*On fail goto*//*Label 33407*/ GIMT_Encode4(2374185), // Rule ID 50540 //
     /* 2374145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374148 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2374151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2374165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374184 */     // GIR_Coverage, 50540,
     /* 2374184 */     GIR_EraseRootFromParent_Done,
     /* 2374185 */   // Label 33407: @2374185
     /* 2374185 */   GIM_Try, /*On fail goto*//*Label 33408*/ GIMT_Encode4(2374230), // Rule ID 50541 //
     /* 2374190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374193 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2374196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2374210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374229 */     // GIR_Coverage, 50541,
     /* 2374229 */     GIR_EraseRootFromParent_Done,
     /* 2374230 */   // Label 33408: @2374230
     /* 2374230 */   GIM_Reject,
     /* 2374231 */ // Label 33406: @2374231
     /* 2374231 */ GIM_Reject,
     /* 2374232 */ // Label 33340: @2374232
     /* 2374232 */ GIM_Try, /*On fail goto*//*Label 33409*/ GIMT_Encode4(2374346),
     /* 2374237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2374240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2374243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374255 */   GIM_Try, /*On fail goto*//*Label 33410*/ GIMT_Encode4(2374300), // Rule ID 50556 //
     /* 2374260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374263 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2374266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2374280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374299 */     // GIR_Coverage, 50556,
     /* 2374299 */     GIR_EraseRootFromParent_Done,
     /* 2374300 */   // Label 33410: @2374300
     /* 2374300 */   GIM_Try, /*On fail goto*//*Label 33411*/ GIMT_Encode4(2374345), // Rule ID 50557 //
     /* 2374305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374308 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2374311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2374325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374344 */     // GIR_Coverage, 50557,
     /* 2374344 */     GIR_EraseRootFromParent_Done,
     /* 2374345 */   // Label 33411: @2374345
     /* 2374345 */   GIM_Reject,
     /* 2374346 */ // Label 33409: @2374346
     /* 2374346 */ GIM_Reject,
     /* 2374347 */ // Label 33341: @2374347
     /* 2374347 */ GIM_Try, /*On fail goto*//*Label 33412*/ GIMT_Encode4(2374461),
     /* 2374352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2374355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2374358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374366 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374370 */   GIM_Try, /*On fail goto*//*Label 33413*/ GIMT_Encode4(2374415), // Rule ID 50544 //
     /* 2374375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374378 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2374381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2374395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374414 */     // GIR_Coverage, 50544,
     /* 2374414 */     GIR_EraseRootFromParent_Done,
     /* 2374415 */   // Label 33413: @2374415
     /* 2374415 */   GIM_Try, /*On fail goto*//*Label 33414*/ GIMT_Encode4(2374460), // Rule ID 50545 //
     /* 2374420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374423 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2374426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2374440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374459 */     // GIR_Coverage, 50545,
     /* 2374459 */     GIR_EraseRootFromParent_Done,
     /* 2374460 */   // Label 33414: @2374460
     /* 2374460 */   GIM_Reject,
     /* 2374461 */ // Label 33412: @2374461
     /* 2374461 */ GIM_Reject,
     /* 2374462 */ // Label 33342: @2374462
     /* 2374462 */ GIM_Reject,
     /* 2374463 */ // Label 83: @2374463
     /* 2374463 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33439*/ GIMT_Encode4(2377238),
     /* 2374474 */ /*GILLT_s32*//*Label 33415*/ GIMT_Encode4(2374598),
     /* 2374478 */ /*GILLT_s64*//*Label 33416*/ GIMT_Encode4(2374653), GIMT_Encode4(0),
     /* 2374486 */ /*GILLT_nxv1s8*//*Label 33417*/ GIMT_Encode4(2374708),
     /* 2374490 */ /*GILLT_nxv1s16*//*Label 33418*/ GIMT_Encode4(2374823),
     /* 2374494 */ /*GILLT_nxv1s32*//*Label 33419*/ GIMT_Encode4(2374938),
     /* 2374498 */ /*GILLT_nxv1s64*//*Label 33420*/ GIMT_Encode4(2375053), GIMT_Encode4(0),
     /* 2374506 */ /*GILLT_nxv2s8*//*Label 33421*/ GIMT_Encode4(2375168),
     /* 2374510 */ /*GILLT_nxv2s16*//*Label 33422*/ GIMT_Encode4(2375283),
     /* 2374514 */ /*GILLT_nxv2s32*//*Label 33423*/ GIMT_Encode4(2375398),
     /* 2374518 */ /*GILLT_nxv2s64*//*Label 33424*/ GIMT_Encode4(2375513), GIMT_Encode4(0),
     /* 2374526 */ /*GILLT_nxv4s8*//*Label 33425*/ GIMT_Encode4(2375628),
     /* 2374530 */ /*GILLT_nxv4s16*//*Label 33426*/ GIMT_Encode4(2375743),
     /* 2374534 */ /*GILLT_nxv4s32*//*Label 33427*/ GIMT_Encode4(2375858),
     /* 2374538 */ /*GILLT_nxv4s64*//*Label 33428*/ GIMT_Encode4(2375973), GIMT_Encode4(0),
     /* 2374546 */ /*GILLT_nxv8s8*//*Label 33429*/ GIMT_Encode4(2376088),
     /* 2374550 */ /*GILLT_nxv8s16*//*Label 33430*/ GIMT_Encode4(2376203),
     /* 2374554 */ /*GILLT_nxv8s32*//*Label 33431*/ GIMT_Encode4(2376318),
     /* 2374558 */ /*GILLT_nxv8s64*//*Label 33432*/ GIMT_Encode4(2376433), GIMT_Encode4(0),
     /* 2374566 */ /*GILLT_nxv16s8*//*Label 33433*/ GIMT_Encode4(2376548),
     /* 2374570 */ /*GILLT_nxv16s16*//*Label 33434*/ GIMT_Encode4(2376663),
     /* 2374574 */ /*GILLT_nxv16s32*//*Label 33435*/ GIMT_Encode4(2376778), GIMT_Encode4(0),
     /* 2374582 */ /*GILLT_nxv32s8*//*Label 33436*/ GIMT_Encode4(2376893),
     /* 2374586 */ /*GILLT_nxv32s16*//*Label 33437*/ GIMT_Encode4(2377008), GIMT_Encode4(0),
     /* 2374594 */ /*GILLT_nxv64s8*//*Label 33438*/ GIMT_Encode4(2377123),
     /* 2374598 */ // Label 33415: @2374598
     /* 2374598 */ GIM_Try, /*On fail goto*//*Label 33440*/ GIMT_Encode4(2374652),
     /* 2374603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2374606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2374609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2374613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2374617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2374621 */   GIM_Try, /*On fail goto*//*Label 33441*/ GIMT_Encode4(2374636), // Rule ID 64460 //
     /* 2374626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2374629 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2374629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2374634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374635 */     // GIR_Coverage, 64460,
     /* 2374635 */     GIR_Done,
     /* 2374636 */   // Label 33441: @2374636
     /* 2374636 */   GIM_Try, /*On fail goto*//*Label 33442*/ GIMT_Encode4(2374651), // Rule ID 2525 //
     /* 2374641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2374644 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2374644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2374649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374650 */     // GIR_Coverage, 2525,
     /* 2374650 */     GIR_Done,
     /* 2374651 */   // Label 33442: @2374651
     /* 2374651 */   GIM_Reject,
     /* 2374652 */ // Label 33440: @2374652
     /* 2374652 */ GIM_Reject,
     /* 2374653 */ // Label 33416: @2374653
     /* 2374653 */ GIM_Try, /*On fail goto*//*Label 33443*/ GIMT_Encode4(2374707),
     /* 2374658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2374661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2374664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2374668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2374672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2374676 */   GIM_Try, /*On fail goto*//*Label 33444*/ GIMT_Encode4(2374691), // Rule ID 64459 //
     /* 2374681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2374684 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2374684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2374689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374690 */     // GIR_Coverage, 64459,
     /* 2374690 */     GIR_Done,
     /* 2374691 */   // Label 33444: @2374691
     /* 2374691 */   GIM_Try, /*On fail goto*//*Label 33445*/ GIMT_Encode4(2374706), // Rule ID 2524 //
     /* 2374696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2374699 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2374699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2374704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374705 */     // GIR_Coverage, 2524,
     /* 2374705 */     GIR_Done,
     /* 2374706 */   // Label 33445: @2374706
     /* 2374706 */   GIM_Reject,
     /* 2374707 */ // Label 33443: @2374707
     /* 2374707 */ GIM_Reject,
     /* 2374708 */ // Label 33417: @2374708
     /* 2374708 */ GIM_Try, /*On fail goto*//*Label 33446*/ GIMT_Encode4(2374822),
     /* 2374713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2374716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2374719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374731 */   GIM_Try, /*On fail goto*//*Label 33447*/ GIMT_Encode4(2374776), // Rule ID 50672 //
     /* 2374736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374739 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2374742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2374756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374775 */     // GIR_Coverage, 50672,
     /* 2374775 */     GIR_EraseRootFromParent_Done,
     /* 2374776 */   // Label 33447: @2374776
     /* 2374776 */   GIM_Try, /*On fail goto*//*Label 33448*/ GIMT_Encode4(2374821), // Rule ID 50673 //
     /* 2374781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374784 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2374787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2374801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374820 */     // GIR_Coverage, 50673,
     /* 2374820 */     GIR_EraseRootFromParent_Done,
     /* 2374821 */   // Label 33448: @2374821
     /* 2374821 */   GIM_Reject,
     /* 2374822 */ // Label 33446: @2374822
     /* 2374822 */ GIM_Reject,
     /* 2374823 */ // Label 33418: @2374823
     /* 2374823 */ GIM_Try, /*On fail goto*//*Label 33449*/ GIMT_Encode4(2374937),
     /* 2374828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2374831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2374834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374842 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374846 */   GIM_Try, /*On fail goto*//*Label 33450*/ GIMT_Encode4(2374891), // Rule ID 50684 //
     /* 2374851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374854 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2374857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2374871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374890 */     // GIR_Coverage, 50684,
     /* 2374890 */     GIR_EraseRootFromParent_Done,
     /* 2374891 */   // Label 33450: @2374891
     /* 2374891 */   GIM_Try, /*On fail goto*//*Label 33451*/ GIMT_Encode4(2374936), // Rule ID 50685 //
     /* 2374896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374899 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2374902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2374916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374935 */     // GIR_Coverage, 50685,
     /* 2374935 */     GIR_EraseRootFromParent_Done,
     /* 2374936 */   // Label 33451: @2374936
     /* 2374936 */   GIM_Reject,
     /* 2374937 */ // Label 33449: @2374937
     /* 2374937 */ GIM_Reject,
     /* 2374938 */ // Label 33419: @2374938
     /* 2374938 */ GIM_Try, /*On fail goto*//*Label 33452*/ GIMT_Encode4(2375052),
     /* 2374943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2374946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2374949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374961 */   GIM_Try, /*On fail goto*//*Label 33453*/ GIMT_Encode4(2375006), // Rule ID 50692 //
     /* 2374966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374969 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2374972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2374986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375005 */     // GIR_Coverage, 50692,
     /* 2375005 */     GIR_EraseRootFromParent_Done,
     /* 2375006 */   // Label 33453: @2375006
     /* 2375006 */   GIM_Try, /*On fail goto*//*Label 33454*/ GIMT_Encode4(2375051), // Rule ID 50693 //
     /* 2375011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375014 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2375017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2375031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375050 */     // GIR_Coverage, 50693,
     /* 2375050 */     GIR_EraseRootFromParent_Done,
     /* 2375051 */   // Label 33454: @2375051
     /* 2375051 */   GIM_Reject,
     /* 2375052 */ // Label 33452: @2375052
     /* 2375052 */ GIM_Reject,
     /* 2375053 */ // Label 33420: @2375053
     /* 2375053 */ GIM_Try, /*On fail goto*//*Label 33455*/ GIMT_Encode4(2375167),
     /* 2375058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2375061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2375064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375076 */   GIM_Try, /*On fail goto*//*Label 33456*/ GIMT_Encode4(2375121), // Rule ID 50708 //
     /* 2375081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2375084 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2375087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2375101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2375116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375120 */     // GIR_Coverage, 50708,
     /* 2375120 */     GIR_EraseRootFromParent_Done,
     /* 2375121 */   // Label 33456: @2375121
     /* 2375121 */   GIM_Try, /*On fail goto*//*Label 33457*/ GIMT_Encode4(2375166), // Rule ID 50709 //
     /* 2375126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2375129 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2375132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2375146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2375161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375165 */     // GIR_Coverage, 50709,
     /* 2375165 */     GIR_EraseRootFromParent_Done,
     /* 2375166 */   // Label 33457: @2375166
     /* 2375166 */   GIM_Reject,
     /* 2375167 */ // Label 33455: @2375167
     /* 2375167 */ GIM_Reject,
     /* 2375168 */ // Label 33421: @2375168
     /* 2375168 */ GIM_Try, /*On fail goto*//*Label 33458*/ GIMT_Encode4(2375282),
     /* 2375173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2375176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2375179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375191 */   GIM_Try, /*On fail goto*//*Label 33459*/ GIMT_Encode4(2375236), // Rule ID 50676 //
     /* 2375196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375199 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2375202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2375216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375235 */     // GIR_Coverage, 50676,
     /* 2375235 */     GIR_EraseRootFromParent_Done,
     /* 2375236 */   // Label 33459: @2375236
     /* 2375236 */   GIM_Try, /*On fail goto*//*Label 33460*/ GIMT_Encode4(2375281), // Rule ID 50677 //
     /* 2375241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375244 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2375247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2375261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375280 */     // GIR_Coverage, 50677,
     /* 2375280 */     GIR_EraseRootFromParent_Done,
     /* 2375281 */   // Label 33460: @2375281
     /* 2375281 */   GIM_Reject,
     /* 2375282 */ // Label 33458: @2375282
     /* 2375282 */ GIM_Reject,
     /* 2375283 */ // Label 33422: @2375283
     /* 2375283 */ GIM_Try, /*On fail goto*//*Label 33461*/ GIMT_Encode4(2375397),
     /* 2375288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2375291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2375294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375306 */   GIM_Try, /*On fail goto*//*Label 33462*/ GIMT_Encode4(2375351), // Rule ID 50688 //
     /* 2375311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375314 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2375317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2375331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375350 */     // GIR_Coverage, 50688,
     /* 2375350 */     GIR_EraseRootFromParent_Done,
     /* 2375351 */   // Label 33462: @2375351
     /* 2375351 */   GIM_Try, /*On fail goto*//*Label 33463*/ GIMT_Encode4(2375396), // Rule ID 50689 //
     /* 2375356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375359 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2375362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2375376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375395 */     // GIR_Coverage, 50689,
     /* 2375395 */     GIR_EraseRootFromParent_Done,
     /* 2375396 */   // Label 33463: @2375396
     /* 2375396 */   GIM_Reject,
     /* 2375397 */ // Label 33461: @2375397
     /* 2375397 */ GIM_Reject,
     /* 2375398 */ // Label 33423: @2375398
     /* 2375398 */ GIM_Try, /*On fail goto*//*Label 33464*/ GIMT_Encode4(2375512),
     /* 2375403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2375406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2375409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375417 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375421 */   GIM_Try, /*On fail goto*//*Label 33465*/ GIMT_Encode4(2375466), // Rule ID 50704 //
     /* 2375426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375429 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2375432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2375446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375465 */     // GIR_Coverage, 50704,
     /* 2375465 */     GIR_EraseRootFromParent_Done,
     /* 2375466 */   // Label 33465: @2375466
     /* 2375466 */   GIM_Try, /*On fail goto*//*Label 33466*/ GIMT_Encode4(2375511), // Rule ID 50705 //
     /* 2375471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375474 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2375477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2375491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375510 */     // GIR_Coverage, 50705,
     /* 2375510 */     GIR_EraseRootFromParent_Done,
     /* 2375511 */   // Label 33466: @2375511
     /* 2375511 */   GIM_Reject,
     /* 2375512 */ // Label 33464: @2375512
     /* 2375512 */ GIM_Reject,
     /* 2375513 */ // Label 33424: @2375513
     /* 2375513 */ GIM_Try, /*On fail goto*//*Label 33467*/ GIMT_Encode4(2375627),
     /* 2375518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2375521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2375524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2375528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2375532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2375536 */   GIM_Try, /*On fail goto*//*Label 33468*/ GIMT_Encode4(2375581), // Rule ID 50748 //
     /* 2375541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2375544 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2375547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2375561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2375576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375580 */     // GIR_Coverage, 50748,
     /* 2375580 */     GIR_EraseRootFromParent_Done,
     /* 2375581 */   // Label 33468: @2375581
     /* 2375581 */   GIM_Try, /*On fail goto*//*Label 33469*/ GIMT_Encode4(2375626), // Rule ID 50749 //
     /* 2375586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2375589 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2375592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2375606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2375621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375625 */     // GIR_Coverage, 50749,
     /* 2375625 */     GIR_EraseRootFromParent_Done,
     /* 2375626 */   // Label 33469: @2375626
     /* 2375626 */   GIM_Reject,
     /* 2375627 */ // Label 33467: @2375627
     /* 2375627 */ GIM_Reject,
     /* 2375628 */ // Label 33425: @2375628
     /* 2375628 */ GIM_Try, /*On fail goto*//*Label 33470*/ GIMT_Encode4(2375742),
     /* 2375633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2375636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2375639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375651 */   GIM_Try, /*On fail goto*//*Label 33471*/ GIMT_Encode4(2375696), // Rule ID 50680 //
     /* 2375656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375659 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2375662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2375676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375695 */     // GIR_Coverage, 50680,
     /* 2375695 */     GIR_EraseRootFromParent_Done,
     /* 2375696 */   // Label 33471: @2375696
     /* 2375696 */   GIM_Try, /*On fail goto*//*Label 33472*/ GIMT_Encode4(2375741), // Rule ID 50681 //
     /* 2375701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375704 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2375707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2375721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375740 */     // GIR_Coverage, 50681,
     /* 2375740 */     GIR_EraseRootFromParent_Done,
     /* 2375741 */   // Label 33472: @2375741
     /* 2375741 */   GIM_Reject,
     /* 2375742 */ // Label 33470: @2375742
     /* 2375742 */ GIM_Reject,
     /* 2375743 */ // Label 33426: @2375743
     /* 2375743 */ GIM_Try, /*On fail goto*//*Label 33473*/ GIMT_Encode4(2375857),
     /* 2375748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2375751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2375754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375766 */   GIM_Try, /*On fail goto*//*Label 33474*/ GIMT_Encode4(2375811), // Rule ID 50700 //
     /* 2375771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375774 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2375777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2375791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375810 */     // GIR_Coverage, 50700,
     /* 2375810 */     GIR_EraseRootFromParent_Done,
     /* 2375811 */   // Label 33474: @2375811
     /* 2375811 */   GIM_Try, /*On fail goto*//*Label 33475*/ GIMT_Encode4(2375856), // Rule ID 50701 //
     /* 2375816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375819 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2375822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2375836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375855 */     // GIR_Coverage, 50701,
     /* 2375855 */     GIR_EraseRootFromParent_Done,
     /* 2375856 */   // Label 33475: @2375856
     /* 2375856 */   GIM_Reject,
     /* 2375857 */ // Label 33473: @2375857
     /* 2375857 */ GIM_Reject,
     /* 2375858 */ // Label 33427: @2375858
     /* 2375858 */ GIM_Try, /*On fail goto*//*Label 33476*/ GIMT_Encode4(2375972),
     /* 2375863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2375866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2375869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2375873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2375877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2375881 */   GIM_Try, /*On fail goto*//*Label 33477*/ GIMT_Encode4(2375926), // Rule ID 50736 //
     /* 2375886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375889 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2375892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2375906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375925 */     // GIR_Coverage, 50736,
     /* 2375925 */     GIR_EraseRootFromParent_Done,
     /* 2375926 */   // Label 33477: @2375926
     /* 2375926 */   GIM_Try, /*On fail goto*//*Label 33478*/ GIMT_Encode4(2375971), // Rule ID 50737 //
     /* 2375931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375934 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2375937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2375951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375970 */     // GIR_Coverage, 50737,
     /* 2375970 */     GIR_EraseRootFromParent_Done,
     /* 2375971 */   // Label 33478: @2375971
     /* 2375971 */   GIM_Reject,
     /* 2375972 */ // Label 33476: @2375972
     /* 2375972 */ GIM_Reject,
     /* 2375973 */ // Label 33428: @2375973
     /* 2375973 */ GIM_Try, /*On fail goto*//*Label 33479*/ GIMT_Encode4(2376087),
     /* 2375978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2375981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2375984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2375988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2375992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2375996 */   GIM_Try, /*On fail goto*//*Label 33480*/ GIMT_Encode4(2376041), // Rule ID 50752 //
     /* 2376001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2376004 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2376007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2376021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376040 */     // GIR_Coverage, 50752,
     /* 2376040 */     GIR_EraseRootFromParent_Done,
     /* 2376041 */   // Label 33480: @2376041
     /* 2376041 */   GIM_Try, /*On fail goto*//*Label 33481*/ GIMT_Encode4(2376086), // Rule ID 50753 //
     /* 2376046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2376049 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2376052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2376066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376085 */     // GIR_Coverage, 50753,
     /* 2376085 */     GIR_EraseRootFromParent_Done,
     /* 2376086 */   // Label 33481: @2376086
     /* 2376086 */   GIM_Reject,
     /* 2376087 */ // Label 33479: @2376087
     /* 2376087 */ GIM_Reject,
     /* 2376088 */ // Label 33429: @2376088
     /* 2376088 */ GIM_Try, /*On fail goto*//*Label 33482*/ GIMT_Encode4(2376202),
     /* 2376093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2376096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2376099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376111 */   GIM_Try, /*On fail goto*//*Label 33483*/ GIMT_Encode4(2376156), // Rule ID 50696 //
     /* 2376116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376119 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2376122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2376136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376155 */     // GIR_Coverage, 50696,
     /* 2376155 */     GIR_EraseRootFromParent_Done,
     /* 2376156 */   // Label 33483: @2376156
     /* 2376156 */   GIM_Try, /*On fail goto*//*Label 33484*/ GIMT_Encode4(2376201), // Rule ID 50697 //
     /* 2376161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376164 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2376167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2376181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376200 */     // GIR_Coverage, 50697,
     /* 2376200 */     GIR_EraseRootFromParent_Done,
     /* 2376201 */   // Label 33484: @2376201
     /* 2376201 */   GIM_Reject,
     /* 2376202 */ // Label 33482: @2376202
     /* 2376202 */ GIM_Reject,
     /* 2376203 */ // Label 33430: @2376203
     /* 2376203 */ GIM_Try, /*On fail goto*//*Label 33485*/ GIMT_Encode4(2376317),
     /* 2376208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2376211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2376214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376222 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376226 */   GIM_Try, /*On fail goto*//*Label 33486*/ GIMT_Encode4(2376271), // Rule ID 50724 //
     /* 2376231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376234 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2376237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2376251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376270 */     // GIR_Coverage, 50724,
     /* 2376270 */     GIR_EraseRootFromParent_Done,
     /* 2376271 */   // Label 33486: @2376271
     /* 2376271 */   GIM_Try, /*On fail goto*//*Label 33487*/ GIMT_Encode4(2376316), // Rule ID 50725 //
     /* 2376276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376279 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2376282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2376296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376315 */     // GIR_Coverage, 50725,
     /* 2376315 */     GIR_EraseRootFromParent_Done,
     /* 2376316 */   // Label 33487: @2376316
     /* 2376316 */   GIM_Reject,
     /* 2376317 */ // Label 33485: @2376317
     /* 2376317 */ GIM_Reject,
     /* 2376318 */ // Label 33431: @2376318
     /* 2376318 */ GIM_Try, /*On fail goto*//*Label 33488*/ GIMT_Encode4(2376432),
     /* 2376323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2376326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2376329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376341 */   GIM_Try, /*On fail goto*//*Label 33489*/ GIMT_Encode4(2376386), // Rule ID 50740 //
     /* 2376346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376349 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2376352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2376366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376385 */     // GIR_Coverage, 50740,
     /* 2376385 */     GIR_EraseRootFromParent_Done,
     /* 2376386 */   // Label 33489: @2376386
     /* 2376386 */   GIM_Try, /*On fail goto*//*Label 33490*/ GIMT_Encode4(2376431), // Rule ID 50741 //
     /* 2376391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376394 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2376397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2376411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376430 */     // GIR_Coverage, 50741,
     /* 2376430 */     GIR_EraseRootFromParent_Done,
     /* 2376431 */   // Label 33490: @2376431
     /* 2376431 */   GIM_Reject,
     /* 2376432 */ // Label 33488: @2376432
     /* 2376432 */ GIM_Reject,
     /* 2376433 */ // Label 33432: @2376433
     /* 2376433 */ GIM_Try, /*On fail goto*//*Label 33491*/ GIMT_Encode4(2376547),
     /* 2376438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2376441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2376444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2376448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2376452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2376456 */   GIM_Try, /*On fail goto*//*Label 33492*/ GIMT_Encode4(2376501), // Rule ID 50756 //
     /* 2376461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2376464 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2376467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2376481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376500 */     // GIR_Coverage, 50756,
     /* 2376500 */     GIR_EraseRootFromParent_Done,
     /* 2376501 */   // Label 33492: @2376501
     /* 2376501 */   GIM_Try, /*On fail goto*//*Label 33493*/ GIMT_Encode4(2376546), // Rule ID 50757 //
     /* 2376506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2376509 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2376512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2376526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376545 */     // GIR_Coverage, 50757,
     /* 2376545 */     GIR_EraseRootFromParent_Done,
     /* 2376546 */   // Label 33493: @2376546
     /* 2376546 */   GIM_Reject,
     /* 2376547 */ // Label 33491: @2376547
     /* 2376547 */ GIM_Reject,
     /* 2376548 */ // Label 33433: @2376548
     /* 2376548 */ GIM_Try, /*On fail goto*//*Label 33494*/ GIMT_Encode4(2376662),
     /* 2376553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2376556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2376559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376571 */   GIM_Try, /*On fail goto*//*Label 33495*/ GIMT_Encode4(2376616), // Rule ID 50712 //
     /* 2376576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376579 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2376582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2376596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376615 */     // GIR_Coverage, 50712,
     /* 2376615 */     GIR_EraseRootFromParent_Done,
     /* 2376616 */   // Label 33495: @2376616
     /* 2376616 */   GIM_Try, /*On fail goto*//*Label 33496*/ GIMT_Encode4(2376661), // Rule ID 50713 //
     /* 2376621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376624 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2376627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2376641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376660 */     // GIR_Coverage, 50713,
     /* 2376660 */     GIR_EraseRootFromParent_Done,
     /* 2376661 */   // Label 33496: @2376661
     /* 2376661 */   GIM_Reject,
     /* 2376662 */ // Label 33494: @2376662
     /* 2376662 */ GIM_Reject,
     /* 2376663 */ // Label 33434: @2376663
     /* 2376663 */ GIM_Try, /*On fail goto*//*Label 33497*/ GIMT_Encode4(2376777),
     /* 2376668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2376671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2376674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376682 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376686 */   GIM_Try, /*On fail goto*//*Label 33498*/ GIMT_Encode4(2376731), // Rule ID 50728 //
     /* 2376691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376694 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2376697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2376711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376730 */     // GIR_Coverage, 50728,
     /* 2376730 */     GIR_EraseRootFromParent_Done,
     /* 2376731 */   // Label 33498: @2376731
     /* 2376731 */   GIM_Try, /*On fail goto*//*Label 33499*/ GIMT_Encode4(2376776), // Rule ID 50729 //
     /* 2376736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376739 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2376742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2376756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376775 */     // GIR_Coverage, 50729,
     /* 2376775 */     GIR_EraseRootFromParent_Done,
     /* 2376776 */   // Label 33499: @2376776
     /* 2376776 */   GIM_Reject,
     /* 2376777 */ // Label 33497: @2376777
     /* 2376777 */ GIM_Reject,
     /* 2376778 */ // Label 33435: @2376778
     /* 2376778 */ GIM_Try, /*On fail goto*//*Label 33500*/ GIMT_Encode4(2376892),
     /* 2376783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2376786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2376789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2376793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2376797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2376801 */   GIM_Try, /*On fail goto*//*Label 33501*/ GIMT_Encode4(2376846), // Rule ID 50744 //
     /* 2376806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376809 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2376812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2376826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376845 */     // GIR_Coverage, 50744,
     /* 2376845 */     GIR_EraseRootFromParent_Done,
     /* 2376846 */   // Label 33501: @2376846
     /* 2376846 */   GIM_Try, /*On fail goto*//*Label 33502*/ GIMT_Encode4(2376891), // Rule ID 50745 //
     /* 2376851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376854 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2376857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2376871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376890 */     // GIR_Coverage, 50745,
     /* 2376890 */     GIR_EraseRootFromParent_Done,
     /* 2376891 */   // Label 33502: @2376891
     /* 2376891 */   GIM_Reject,
     /* 2376892 */ // Label 33500: @2376892
     /* 2376892 */ GIM_Reject,
     /* 2376893 */ // Label 33436: @2376893
     /* 2376893 */ GIM_Try, /*On fail goto*//*Label 33503*/ GIMT_Encode4(2377007),
     /* 2376898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2376901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2376904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376912 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376916 */   GIM_Try, /*On fail goto*//*Label 33504*/ GIMT_Encode4(2376961), // Rule ID 50716 //
     /* 2376921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376924 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2376927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2376941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376960 */     // GIR_Coverage, 50716,
     /* 2376960 */     GIR_EraseRootFromParent_Done,
     /* 2376961 */   // Label 33504: @2376961
     /* 2376961 */   GIM_Try, /*On fail goto*//*Label 33505*/ GIMT_Encode4(2377006), // Rule ID 50717 //
     /* 2376966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376969 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2376972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2376986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377005 */     // GIR_Coverage, 50717,
     /* 2377005 */     GIR_EraseRootFromParent_Done,
     /* 2377006 */   // Label 33505: @2377006
     /* 2377006 */   GIM_Reject,
     /* 2377007 */ // Label 33503: @2377007
     /* 2377007 */ GIM_Reject,
     /* 2377008 */ // Label 33437: @2377008
     /* 2377008 */ GIM_Try, /*On fail goto*//*Label 33506*/ GIMT_Encode4(2377122),
     /* 2377013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2377016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2377019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377031 */   GIM_Try, /*On fail goto*//*Label 33507*/ GIMT_Encode4(2377076), // Rule ID 50732 //
     /* 2377036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377039 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2377042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2377056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377075 */     // GIR_Coverage, 50732,
     /* 2377075 */     GIR_EraseRootFromParent_Done,
     /* 2377076 */   // Label 33507: @2377076
     /* 2377076 */   GIM_Try, /*On fail goto*//*Label 33508*/ GIMT_Encode4(2377121), // Rule ID 50733 //
     /* 2377081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377084 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2377087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2377101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377120 */     // GIR_Coverage, 50733,
     /* 2377120 */     GIR_EraseRootFromParent_Done,
     /* 2377121 */   // Label 33508: @2377121
     /* 2377121 */   GIM_Reject,
     /* 2377122 */ // Label 33506: @2377122
     /* 2377122 */ GIM_Reject,
     /* 2377123 */ // Label 33438: @2377123
     /* 2377123 */ GIM_Try, /*On fail goto*//*Label 33509*/ GIMT_Encode4(2377237),
     /* 2377128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2377131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2377134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377146 */   GIM_Try, /*On fail goto*//*Label 33510*/ GIMT_Encode4(2377191), // Rule ID 50720 //
     /* 2377151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377154 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2377157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2377171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377190 */     // GIR_Coverage, 50720,
     /* 2377190 */     GIR_EraseRootFromParent_Done,
     /* 2377191 */   // Label 33510: @2377191
     /* 2377191 */   GIM_Try, /*On fail goto*//*Label 33511*/ GIMT_Encode4(2377236), // Rule ID 50721 //
     /* 2377196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377199 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2377202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2377216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377235 */     // GIR_Coverage, 50721,
     /* 2377235 */     GIR_EraseRootFromParent_Done,
     /* 2377236 */   // Label 33511: @2377236
     /* 2377236 */   GIM_Reject,
     /* 2377237 */ // Label 33509: @2377237
     /* 2377237 */ GIM_Reject,
     /* 2377238 */ // Label 33439: @2377238
     /* 2377238 */ GIM_Reject,
     /* 2377239 */ // Label 84: @2377239
     /* 2377239 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33514*/ GIMT_Encode4(2377396),
     /* 2377250 */ /*GILLT_s32*//*Label 33512*/ GIMT_Encode4(2377258),
     /* 2377254 */ /*GILLT_s64*//*Label 33513*/ GIMT_Encode4(2377327),
     /* 2377258 */ // Label 33512: @2377258
     /* 2377258 */ GIM_Try, /*On fail goto*//*Label 33515*/ GIMT_Encode4(2377326),
     /* 2377263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2377266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377274 */   GIM_Try, /*On fail goto*//*Label 33516*/ GIMT_Encode4(2377289), // Rule ID 64448 //
     /* 2377279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2377282 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_ABS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2377282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2377287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377288 */     // GIR_Coverage, 64448,
     /* 2377288 */     GIR_Done,
     /* 2377289 */   // Label 33516: @2377289
     /* 2377289 */   GIM_Try, /*On fail goto*//*Label 33517*/ GIMT_Encode4(2377325), // Rule ID 62503 //
     /* 2377294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode1),
     /* 2377297 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (PseudoCCSUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, 2:{ *:[i32] }, GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2377297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2377300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2377302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2377310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2377313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377315 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2377321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377324 */     // GIR_Coverage, 62503,
     /* 2377324 */     GIR_EraseRootFromParent_Done,
     /* 2377325 */   // Label 33517: @2377325
     /* 2377325 */   GIM_Reject,
     /* 2377326 */ // Label 33515: @2377326
     /* 2377326 */ GIM_Reject,
     /* 2377327 */ // Label 33513: @2377327
     /* 2377327 */ GIM_Try, /*On fail goto*//*Label 33518*/ GIMT_Encode4(2377395),
     /* 2377332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2377335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377343 */   GIM_Try, /*On fail goto*//*Label 33519*/ GIMT_Encode4(2377358), // Rule ID 64447 //
     /* 2377348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2377351 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_ABS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2377351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2377356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377357 */     // GIR_Coverage, 64447,
     /* 2377357 */     GIR_Done,
     /* 2377358 */   // Label 33519: @2377358
     /* 2377358 */   GIM_Try, /*On fail goto*//*Label 33520*/ GIMT_Encode4(2377394), // Rule ID 62502 //
     /* 2377363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode0),
     /* 2377366 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (PseudoCCSUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, 2:{ *:[i64] }, GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2377366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2377369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2377371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2377379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2377382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2377390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377393 */     // GIR_Coverage, 62502,
     /* 2377393 */     GIR_EraseRootFromParent_Done,
     /* 2377394 */   // Label 33520: @2377394
     /* 2377394 */   GIM_Reject,
     /* 2377395 */ // Label 33518: @2377395
     /* 2377395 */ GIM_Reject,
     /* 2377396 */ // Label 33514: @2377396
     /* 2377396 */ GIM_Reject,
     /* 2377397 */ // Label 85: @2377397
     /* 2377397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33523*/ GIMT_Encode4(2377976),
     /* 2377408 */ /*GILLT_s32*//*Label 33521*/ GIMT_Encode4(2377416),
     /* 2377412 */ /*GILLT_s64*//*Label 33522*/ GIMT_Encode4(2377789),
     /* 2377416 */ // Label 33521: @2377416
     /* 2377416 */ GIM_Try, /*On fail goto*//*Label 33524*/ GIMT_Encode4(2377447), // Rule ID 1460 //
     /* 2377421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2377424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2377427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2377435 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2377435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2377438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377440 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377445 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377446 */   // GIR_Coverage, 1460,
     /* 2377446 */   GIR_EraseRootFromParent_Done,
     /* 2377447 */ // Label 33524: @2377447
     /* 2377447 */ GIM_Try, /*On fail goto*//*Label 33525*/ GIMT_Encode4(2377478), // Rule ID 1461 //
     /* 2377452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2377455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2377458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2377466 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2377466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2377469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377471 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377476 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377477 */   // GIR_Coverage, 1461,
     /* 2377477 */   GIR_EraseRootFromParent_Done,
     /* 2377478 */ // Label 33525: @2377478
     /* 2377478 */ GIM_Try, /*On fail goto*//*Label 33526*/ GIMT_Encode4(2377509), // Rule ID 1486 //
     /* 2377483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2377486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2377489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2377497 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2377497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2377500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377502 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377507 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377508 */   // GIR_Coverage, 1486,
     /* 2377508 */   GIR_EraseRootFromParent_Done,
     /* 2377509 */ // Label 33526: @2377509
     /* 2377509 */ GIM_Try, /*On fail goto*//*Label 33527*/ GIMT_Encode4(2377540), // Rule ID 1487 //
     /* 2377514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2377517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2377520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2377528 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2377528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2377531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377533 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377538 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377539 */   // GIR_Coverage, 1487,
     /* 2377539 */   GIR_EraseRootFromParent_Done,
     /* 2377540 */ // Label 33527: @2377540
     /* 2377540 */ GIM_Try, /*On fail goto*//*Label 33528*/ GIMT_Encode4(2377571), // Rule ID 1854 //
     /* 2377545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2377548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2377551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2377559 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2377559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2377562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377564 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377569 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377570 */   // GIR_Coverage, 1854,
     /* 2377570 */   GIR_EraseRootFromParent_Done,
     /* 2377571 */ // Label 33528: @2377571
     /* 2377571 */ GIM_Try, /*On fail goto*//*Label 33529*/ GIMT_Encode4(2377602), // Rule ID 1855 //
     /* 2377576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2377579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2377582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2377590 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2377590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2377593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377595 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377600 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377601 */   // GIR_Coverage, 1855,
     /* 2377601 */   GIR_EraseRootFromParent_Done,
     /* 2377602 */ // Label 33529: @2377602
     /* 2377602 */ GIM_Try, /*On fail goto*//*Label 33530*/ GIMT_Encode4(2377633), // Rule ID 1880 //
     /* 2377607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2377610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2377613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2377621 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2377621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2377624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377626 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377632 */   // GIR_Coverage, 1880,
     /* 2377632 */   GIR_EraseRootFromParent_Done,
     /* 2377633 */ // Label 33530: @2377633
     /* 2377633 */ GIM_Try, /*On fail goto*//*Label 33531*/ GIMT_Encode4(2377664), // Rule ID 1881 //
     /* 2377638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2377641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2377644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2377652 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2377652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2377655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377657 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377662 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377663 */   // GIR_Coverage, 1881,
     /* 2377663 */   GIR_EraseRootFromParent_Done,
     /* 2377664 */ // Label 33531: @2377664
     /* 2377664 */ GIM_Try, /*On fail goto*//*Label 33532*/ GIMT_Encode4(2377695), // Rule ID 2196 //
     /* 2377669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2377672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2377675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2377683 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2377683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2377686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377688 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377693 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377694 */   // GIR_Coverage, 2196,
     /* 2377694 */   GIR_EraseRootFromParent_Done,
     /* 2377695 */ // Label 33532: @2377695
     /* 2377695 */ GIM_Try, /*On fail goto*//*Label 33533*/ GIMT_Encode4(2377726), // Rule ID 2197 //
     /* 2377700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2377703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2377706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2377714 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2377714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2377717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377719 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377724 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377725 */   // GIR_Coverage, 2197,
     /* 2377725 */   GIR_EraseRootFromParent_Done,
     /* 2377726 */ // Label 33533: @2377726
     /* 2377726 */ GIM_Try, /*On fail goto*//*Label 33534*/ GIMT_Encode4(2377757), // Rule ID 2222 //
     /* 2377731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2377734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2377737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2377745 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2377745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2377748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377750 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377755 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377756 */   // GIR_Coverage, 2222,
     /* 2377756 */   GIR_EraseRootFromParent_Done,
     /* 2377757 */ // Label 33534: @2377757
     /* 2377757 */ GIM_Try, /*On fail goto*//*Label 33535*/ GIMT_Encode4(2377788), // Rule ID 2223 //
     /* 2377762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2377765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2377768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2377776 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2377776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2377779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377781 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377787 */   // GIR_Coverage, 2223,
     /* 2377787 */   GIR_EraseRootFromParent_Done,
     /* 2377788 */ // Label 33535: @2377788
     /* 2377788 */ GIM_Reject,
     /* 2377789 */ // Label 33522: @2377789
     /* 2377789 */ GIM_Try, /*On fail goto*//*Label 33536*/ GIMT_Encode4(2377820), // Rule ID 1513 //
     /* 2377794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2377797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2377800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2377808 */   // (lround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2377808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2377811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377813 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377818 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377819 */   // GIR_Coverage, 1513,
     /* 2377819 */   GIR_EraseRootFromParent_Done,
     /* 2377820 */ // Label 33536: @2377820
     /* 2377820 */ GIM_Try, /*On fail goto*//*Label 33537*/ GIMT_Encode4(2377851), // Rule ID 1541 //
     /* 2377825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2377828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2377831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2377839 */   // (lround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2377839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2377842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377844 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377849 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377850 */   // GIR_Coverage, 1541,
     /* 2377850 */   GIR_EraseRootFromParent_Done,
     /* 2377851 */ // Label 33537: @2377851
     /* 2377851 */ GIM_Try, /*On fail goto*//*Label 33538*/ GIMT_Encode4(2377882), // Rule ID 1911 //
     /* 2377856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2377859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2377862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2377870 */   // (lround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2377870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2377873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377875 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377880 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377881 */   // GIR_Coverage, 1911,
     /* 2377881 */   GIR_EraseRootFromParent_Done,
     /* 2377882 */ // Label 33538: @2377882
     /* 2377882 */ GIM_Try, /*On fail goto*//*Label 33539*/ GIMT_Encode4(2377913), // Rule ID 1939 //
     /* 2377887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2377890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2377893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377901 */   // (lround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2377901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2377904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377906 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377911 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377912 */   // GIR_Coverage, 1939,
     /* 2377912 */   GIR_EraseRootFromParent_Done,
     /* 2377913 */ // Label 33539: @2377913
     /* 2377913 */ GIM_Try, /*On fail goto*//*Label 33540*/ GIMT_Encode4(2377944), // Rule ID 2247 //
     /* 2377918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2377921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2377924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2377932 */   // (lround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2377932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2377935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377937 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377942 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377943 */   // GIR_Coverage, 2247,
     /* 2377943 */   GIR_EraseRootFromParent_Done,
     /* 2377944 */ // Label 33540: @2377944
     /* 2377944 */ GIM_Try, /*On fail goto*//*Label 33541*/ GIMT_Encode4(2377975), // Rule ID 2273 //
     /* 2377949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2377952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2377955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2377959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2377963 */   // (lround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2377963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2377966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377968 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377973 */   GIR_RootConstrainSelectedInstOperands,
     /* 2377974 */   // GIR_Coverage, 2273,
     /* 2377974 */   GIR_EraseRootFromParent_Done,
     /* 2377975 */ // Label 33541: @2377975
     /* 2377975 */ GIM_Reject,
     /* 2377976 */ // Label 33523: @2377976
     /* 2377976 */ GIM_Reject,
     /* 2377977 */ // Label 86: @2377977
     /* 2377977 */ GIM_Try, /*On fail goto*//*Label 33542*/ GIMT_Encode4(2378186),
     /* 2377982 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2377985 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33546*/ GIMT_Encode4(2378185),
     /* 2377996 */   /*GILLT_s16*//*Label 33543*/ GIMT_Encode4(2378008),
     /* 2378000 */   /*GILLT_s32*//*Label 33544*/ GIMT_Encode4(2378067),
     /* 2378004 */   /*GILLT_s64*//*Label 33545*/ GIMT_Encode4(2378126),
     /* 2378008 */   // Label 33543: @2378008
     /* 2378008 */   GIM_Try, /*On fail goto*//*Label 33547*/ GIMT_Encode4(2378066),
     /* 2378013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378017 */     GIM_Try, /*On fail goto*//*Label 33548*/ GIMT_Encode4(2378041), // Rule ID 2249 //
     /* 2378022 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2378025 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2378029 */       // (llround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2378029 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2378032 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378034 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378036 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378039 */       GIR_RootConstrainSelectedInstOperands,
     /* 2378040 */       // GIR_Coverage, 2249,
     /* 2378040 */       GIR_EraseRootFromParent_Done,
     /* 2378041 */     // Label 33548: @2378041
     /* 2378041 */     GIM_Try, /*On fail goto*//*Label 33549*/ GIMT_Encode4(2378065), // Rule ID 2275 //
     /* 2378046 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2378049 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2378053 */       // (llround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2378053 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2378056 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378058 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378060 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378063 */       GIR_RootConstrainSelectedInstOperands,
     /* 2378064 */       // GIR_Coverage, 2275,
     /* 2378064 */       GIR_EraseRootFromParent_Done,
     /* 2378065 */     // Label 33549: @2378065
     /* 2378065 */     GIM_Reject,
     /* 2378066 */   // Label 33547: @2378066
     /* 2378066 */   GIM_Reject,
     /* 2378067 */   // Label 33544: @2378067
     /* 2378067 */   GIM_Try, /*On fail goto*//*Label 33550*/ GIMT_Encode4(2378125),
     /* 2378072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378076 */     GIM_Try, /*On fail goto*//*Label 33551*/ GIMT_Encode4(2378100), // Rule ID 1515 //
     /* 2378081 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2378084 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2378088 */       // (llround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2378088 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2378091 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378093 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378095 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378098 */       GIR_RootConstrainSelectedInstOperands,
     /* 2378099 */       // GIR_Coverage, 1515,
     /* 2378099 */       GIR_EraseRootFromParent_Done,
     /* 2378100 */     // Label 33551: @2378100
     /* 2378100 */     GIM_Try, /*On fail goto*//*Label 33552*/ GIMT_Encode4(2378124), // Rule ID 1543 //
     /* 2378105 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2378108 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2378112 */       // (llround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2378112 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2378115 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378117 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378119 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378122 */       GIR_RootConstrainSelectedInstOperands,
     /* 2378123 */       // GIR_Coverage, 1543,
     /* 2378123 */       GIR_EraseRootFromParent_Done,
     /* 2378124 */     // Label 33552: @2378124
     /* 2378124 */     GIM_Reject,
     /* 2378125 */   // Label 33550: @2378125
     /* 2378125 */   GIM_Reject,
     /* 2378126 */   // Label 33545: @2378126
     /* 2378126 */   GIM_Try, /*On fail goto*//*Label 33553*/ GIMT_Encode4(2378184),
     /* 2378131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378135 */     GIM_Try, /*On fail goto*//*Label 33554*/ GIMT_Encode4(2378159), // Rule ID 1913 //
     /* 2378140 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2378143 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2378147 */       // (llround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2378147 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2378150 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378152 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378154 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378157 */       GIR_RootConstrainSelectedInstOperands,
     /* 2378158 */       // GIR_Coverage, 1913,
     /* 2378158 */       GIR_EraseRootFromParent_Done,
     /* 2378159 */     // Label 33554: @2378159
     /* 2378159 */     GIM_Try, /*On fail goto*//*Label 33555*/ GIMT_Encode4(2378183), // Rule ID 1941 //
     /* 2378164 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2378167 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378171 */       // (llround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2378171 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2378174 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378176 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378178 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378181 */       GIR_RootConstrainSelectedInstOperands,
     /* 2378182 */       // GIR_Coverage, 1941,
     /* 2378182 */       GIR_EraseRootFromParent_Done,
     /* 2378183 */     // Label 33555: @2378183
     /* 2378183 */     GIM_Reject,
     /* 2378184 */   // Label 33553: @2378184
     /* 2378184 */   GIM_Reject,
     /* 2378185 */   // Label 33546: @2378185
     /* 2378185 */   GIM_Reject,
     /* 2378186 */ // Label 33542: @2378186
     /* 2378186 */ GIM_Reject,
     /* 2378187 */ // Label 87: @2378187
     /* 2378187 */ GIM_Try, /*On fail goto*//*Label 33556*/ GIMT_Encode4(2378202), // Rule ID 4 //
     /* 2378192 */   // MIs[0] imm20
     /* 2378192 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 2378195 */   // (br (bb:{ *:[Other] }):$imm20)  =>  (PseudoBR (bb:{ *:[Other] }):$imm20)
     /* 2378195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoBR),
     /* 2378200 */   GIR_RootConstrainSelectedInstOperands,
     /* 2378201 */   // GIR_Coverage, 4,
     /* 2378201 */   GIR_Done,
     /* 2378202 */ // Label 33556: @2378202
     /* 2378202 */ GIM_Reject,
     /* 2378203 */ // Label 88: @2378203
     /* 2378203 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33581*/ GIMT_Encode4(2380722),
     /* 2378214 */ /*GILLT_s32*//*Label 33557*/ GIMT_Encode4(2378338),
     /* 2378218 */ /*GILLT_s64*//*Label 33558*/ GIMT_Encode4(2378386), GIMT_Encode4(0),
     /* 2378226 */ /*GILLT_nxv1s8*//*Label 33559*/ GIMT_Encode4(2378434),
     /* 2378230 */ /*GILLT_nxv1s16*//*Label 33560*/ GIMT_Encode4(2378538),
     /* 2378234 */ /*GILLT_nxv1s32*//*Label 33561*/ GIMT_Encode4(2378642),
     /* 2378238 */ /*GILLT_nxv1s64*//*Label 33562*/ GIMT_Encode4(2378746), GIMT_Encode4(0),
     /* 2378246 */ /*GILLT_nxv2s8*//*Label 33563*/ GIMT_Encode4(2378850),
     /* 2378250 */ /*GILLT_nxv2s16*//*Label 33564*/ GIMT_Encode4(2378954),
     /* 2378254 */ /*GILLT_nxv2s32*//*Label 33565*/ GIMT_Encode4(2379058),
     /* 2378258 */ /*GILLT_nxv2s64*//*Label 33566*/ GIMT_Encode4(2379162), GIMT_Encode4(0),
     /* 2378266 */ /*GILLT_nxv4s8*//*Label 33567*/ GIMT_Encode4(2379266),
     /* 2378270 */ /*GILLT_nxv4s16*//*Label 33568*/ GIMT_Encode4(2379370),
     /* 2378274 */ /*GILLT_nxv4s32*//*Label 33569*/ GIMT_Encode4(2379474),
     /* 2378278 */ /*GILLT_nxv4s64*//*Label 33570*/ GIMT_Encode4(2379578), GIMT_Encode4(0),
     /* 2378286 */ /*GILLT_nxv8s8*//*Label 33571*/ GIMT_Encode4(2379682),
     /* 2378290 */ /*GILLT_nxv8s16*//*Label 33572*/ GIMT_Encode4(2379786),
     /* 2378294 */ /*GILLT_nxv8s32*//*Label 33573*/ GIMT_Encode4(2379890),
     /* 2378298 */ /*GILLT_nxv8s64*//*Label 33574*/ GIMT_Encode4(2379994), GIMT_Encode4(0),
     /* 2378306 */ /*GILLT_nxv16s8*//*Label 33575*/ GIMT_Encode4(2380098),
     /* 2378310 */ /*GILLT_nxv16s16*//*Label 33576*/ GIMT_Encode4(2380202),
     /* 2378314 */ /*GILLT_nxv16s32*//*Label 33577*/ GIMT_Encode4(2380306), GIMT_Encode4(0),
     /* 2378322 */ /*GILLT_nxv32s8*//*Label 33578*/ GIMT_Encode4(2380410),
     /* 2378326 */ /*GILLT_nxv32s16*//*Label 33579*/ GIMT_Encode4(2380514), GIMT_Encode4(0),
     /* 2378334 */ /*GILLT_nxv64s8*//*Label 33580*/ GIMT_Encode4(2380618),
     /* 2378338 */ // Label 33557: @2378338
     /* 2378338 */ GIM_Try, /*On fail goto*//*Label 33582*/ GIMT_Encode4(2378385),
     /* 2378343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2378346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378354 */   GIM_Try, /*On fail goto*//*Label 33583*/ GIMT_Encode4(2378369), // Rule ID 2507 //
     /* 2378359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2378362 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CTZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2378362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2378367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378368 */     // GIR_Coverage, 2507,
     /* 2378368 */     GIR_Done,
     /* 2378369 */   // Label 33583: @2378369
     /* 2378369 */   GIM_Try, /*On fail goto*//*Label 33584*/ GIMT_Encode4(2378384), // Rule ID 64431 //
     /* 2378374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2378377 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2378377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2378382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378383 */     // GIR_Coverage, 64431,
     /* 2378383 */     GIR_Done,
     /* 2378384 */   // Label 33584: @2378384
     /* 2378384 */   GIM_Reject,
     /* 2378385 */ // Label 33582: @2378385
     /* 2378385 */ GIM_Reject,
     /* 2378386 */ // Label 33558: @2378386
     /* 2378386 */ GIM_Try, /*On fail goto*//*Label 33585*/ GIMT_Encode4(2378433),
     /* 2378391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2378394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378402 */   GIM_Try, /*On fail goto*//*Label 33586*/ GIMT_Encode4(2378417), // Rule ID 2506 //
     /* 2378407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2378410 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2378410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2378415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378416 */     // GIR_Coverage, 2506,
     /* 2378416 */     GIR_Done,
     /* 2378417 */   // Label 33586: @2378417
     /* 2378417 */   GIM_Try, /*On fail goto*//*Label 33587*/ GIMT_Encode4(2378432), // Rule ID 64430 //
     /* 2378422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2378425 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2378425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2378430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378431 */     // GIR_Coverage, 64430,
     /* 2378431 */     GIR_Done,
     /* 2378432 */   // Label 33587: @2378432
     /* 2378432 */   GIM_Reject,
     /* 2378433 */ // Label 33585: @2378433
     /* 2378433 */ GIM_Reject,
     /* 2378434 */ // Label 33559: @2378434
     /* 2378434 */ GIM_Try, /*On fail goto*//*Label 33588*/ GIMT_Encode4(2378537),
     /* 2378439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2378442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378450 */   GIM_Try, /*On fail goto*//*Label 33589*/ GIMT_Encode4(2378493), // Rule ID 59176 //
     /* 2378455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378458 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2378461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2378475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378492 */     // GIR_Coverage, 59176,
     /* 2378492 */     GIR_EraseRootFromParent_Done,
     /* 2378493 */   // Label 33589: @2378493
     /* 2378493 */   GIM_Try, /*On fail goto*//*Label 33590*/ GIMT_Encode4(2378536), // Rule ID 59177 //
     /* 2378498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378501 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2378504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2378518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378535 */     // GIR_Coverage, 59177,
     /* 2378535 */     GIR_EraseRootFromParent_Done,
     /* 2378536 */   // Label 33590: @2378536
     /* 2378536 */   GIM_Reject,
     /* 2378537 */ // Label 33588: @2378537
     /* 2378537 */ GIM_Reject,
     /* 2378538 */ // Label 33560: @2378538
     /* 2378538 */ GIM_Try, /*On fail goto*//*Label 33591*/ GIMT_Encode4(2378641),
     /* 2378543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2378546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378554 */   GIM_Try, /*On fail goto*//*Label 33592*/ GIMT_Encode4(2378597), // Rule ID 59182 //
     /* 2378559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378562 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2378565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2378579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378596 */     // GIR_Coverage, 59182,
     /* 2378596 */     GIR_EraseRootFromParent_Done,
     /* 2378597 */   // Label 33592: @2378597
     /* 2378597 */   GIM_Try, /*On fail goto*//*Label 33593*/ GIMT_Encode4(2378640), // Rule ID 59183 //
     /* 2378602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378605 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2378608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2378622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378639 */     // GIR_Coverage, 59183,
     /* 2378639 */     GIR_EraseRootFromParent_Done,
     /* 2378640 */   // Label 33593: @2378640
     /* 2378640 */   GIM_Reject,
     /* 2378641 */ // Label 33591: @2378641
     /* 2378641 */ GIM_Reject,
     /* 2378642 */ // Label 33561: @2378642
     /* 2378642 */ GIM_Try, /*On fail goto*//*Label 33594*/ GIMT_Encode4(2378745),
     /* 2378647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2378650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378658 */   GIM_Try, /*On fail goto*//*Label 33595*/ GIMT_Encode4(2378701), // Rule ID 59186 //
     /* 2378663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378666 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2378669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2378683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378700 */     // GIR_Coverage, 59186,
     /* 2378700 */     GIR_EraseRootFromParent_Done,
     /* 2378701 */   // Label 33595: @2378701
     /* 2378701 */   GIM_Try, /*On fail goto*//*Label 33596*/ GIMT_Encode4(2378744), // Rule ID 59187 //
     /* 2378706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378709 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2378712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2378726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378743 */     // GIR_Coverage, 59187,
     /* 2378743 */     GIR_EraseRootFromParent_Done,
     /* 2378744 */   // Label 33596: @2378744
     /* 2378744 */   GIM_Reject,
     /* 2378745 */ // Label 33594: @2378745
     /* 2378745 */ GIM_Reject,
     /* 2378746 */ // Label 33562: @2378746
     /* 2378746 */ GIM_Try, /*On fail goto*//*Label 33597*/ GIMT_Encode4(2378849),
     /* 2378751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2378754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378762 */   GIM_Try, /*On fail goto*//*Label 33598*/ GIMT_Encode4(2378805), // Rule ID 59194 //
     /* 2378767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2378770 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2378773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2378787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378804 */     // GIR_Coverage, 59194,
     /* 2378804 */     GIR_EraseRootFromParent_Done,
     /* 2378805 */   // Label 33598: @2378805
     /* 2378805 */   GIM_Try, /*On fail goto*//*Label 33599*/ GIMT_Encode4(2378848), // Rule ID 59195 //
     /* 2378810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2378813 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2378816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2378830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378847 */     // GIR_Coverage, 59195,
     /* 2378847 */     GIR_EraseRootFromParent_Done,
     /* 2378848 */   // Label 33599: @2378848
     /* 2378848 */   GIM_Reject,
     /* 2378849 */ // Label 33597: @2378849
     /* 2378849 */ GIM_Reject,
     /* 2378850 */ // Label 33563: @2378850
     /* 2378850 */ GIM_Try, /*On fail goto*//*Label 33600*/ GIMT_Encode4(2378953),
     /* 2378855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2378858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378866 */   GIM_Try, /*On fail goto*//*Label 33601*/ GIMT_Encode4(2378909), // Rule ID 59178 //
     /* 2378871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378874 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2378877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2378891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378908 */     // GIR_Coverage, 59178,
     /* 2378908 */     GIR_EraseRootFromParent_Done,
     /* 2378909 */   // Label 33601: @2378909
     /* 2378909 */   GIM_Try, /*On fail goto*//*Label 33602*/ GIMT_Encode4(2378952), // Rule ID 59179 //
     /* 2378914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378917 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2378920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2378934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378951 */     // GIR_Coverage, 59179,
     /* 2378951 */     GIR_EraseRootFromParent_Done,
     /* 2378952 */   // Label 33602: @2378952
     /* 2378952 */   GIM_Reject,
     /* 2378953 */ // Label 33600: @2378953
     /* 2378953 */ GIM_Reject,
     /* 2378954 */ // Label 33564: @2378954
     /* 2378954 */ GIM_Try, /*On fail goto*//*Label 33603*/ GIMT_Encode4(2379057),
     /* 2378959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2378962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378970 */   GIM_Try, /*On fail goto*//*Label 33604*/ GIMT_Encode4(2379013), // Rule ID 59184 //
     /* 2378975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378978 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2378981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2378995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379012 */     // GIR_Coverage, 59184,
     /* 2379012 */     GIR_EraseRootFromParent_Done,
     /* 2379013 */   // Label 33604: @2379013
     /* 2379013 */   GIM_Try, /*On fail goto*//*Label 33605*/ GIMT_Encode4(2379056), // Rule ID 59185 //
     /* 2379018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379021 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2379024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2379038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379055 */     // GIR_Coverage, 59185,
     /* 2379055 */     GIR_EraseRootFromParent_Done,
     /* 2379056 */   // Label 33605: @2379056
     /* 2379056 */   GIM_Reject,
     /* 2379057 */ // Label 33603: @2379057
     /* 2379057 */ GIM_Reject,
     /* 2379058 */ // Label 33565: @2379058
     /* 2379058 */ GIM_Try, /*On fail goto*//*Label 33606*/ GIMT_Encode4(2379161),
     /* 2379063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2379066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379074 */   GIM_Try, /*On fail goto*//*Label 33607*/ GIMT_Encode4(2379117), // Rule ID 59192 //
     /* 2379079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379082 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2379085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2379099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379116 */     // GIR_Coverage, 59192,
     /* 2379116 */     GIR_EraseRootFromParent_Done,
     /* 2379117 */   // Label 33607: @2379117
     /* 2379117 */   GIM_Try, /*On fail goto*//*Label 33608*/ GIMT_Encode4(2379160), // Rule ID 59193 //
     /* 2379122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379125 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2379128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2379142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379159 */     // GIR_Coverage, 59193,
     /* 2379159 */     GIR_EraseRootFromParent_Done,
     /* 2379160 */   // Label 33608: @2379160
     /* 2379160 */   GIM_Reject,
     /* 2379161 */ // Label 33606: @2379161
     /* 2379161 */ GIM_Reject,
     /* 2379162 */ // Label 33566: @2379162
     /* 2379162 */ GIM_Try, /*On fail goto*//*Label 33609*/ GIMT_Encode4(2379265),
     /* 2379167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2379170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379178 */   GIM_Try, /*On fail goto*//*Label 33610*/ GIMT_Encode4(2379221), // Rule ID 59214 //
     /* 2379183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2379186 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2379189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2379203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379220 */     // GIR_Coverage, 59214,
     /* 2379220 */     GIR_EraseRootFromParent_Done,
     /* 2379221 */   // Label 33610: @2379221
     /* 2379221 */   GIM_Try, /*On fail goto*//*Label 33611*/ GIMT_Encode4(2379264), // Rule ID 59215 //
     /* 2379226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2379229 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2379232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2379246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379263 */     // GIR_Coverage, 59215,
     /* 2379263 */     GIR_EraseRootFromParent_Done,
     /* 2379264 */   // Label 33611: @2379264
     /* 2379264 */   GIM_Reject,
     /* 2379265 */ // Label 33609: @2379265
     /* 2379265 */ GIM_Reject,
     /* 2379266 */ // Label 33567: @2379266
     /* 2379266 */ GIM_Try, /*On fail goto*//*Label 33612*/ GIMT_Encode4(2379369),
     /* 2379271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2379274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379282 */   GIM_Try, /*On fail goto*//*Label 33613*/ GIMT_Encode4(2379325), // Rule ID 59180 //
     /* 2379287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379290 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2379293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2379307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379324 */     // GIR_Coverage, 59180,
     /* 2379324 */     GIR_EraseRootFromParent_Done,
     /* 2379325 */   // Label 33613: @2379325
     /* 2379325 */   GIM_Try, /*On fail goto*//*Label 33614*/ GIMT_Encode4(2379368), // Rule ID 59181 //
     /* 2379330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379333 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2379336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2379350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379367 */     // GIR_Coverage, 59181,
     /* 2379367 */     GIR_EraseRootFromParent_Done,
     /* 2379368 */   // Label 33614: @2379368
     /* 2379368 */   GIM_Reject,
     /* 2379369 */ // Label 33612: @2379369
     /* 2379369 */ GIM_Reject,
     /* 2379370 */ // Label 33568: @2379370
     /* 2379370 */ GIM_Try, /*On fail goto*//*Label 33615*/ GIMT_Encode4(2379473),
     /* 2379375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2379378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379386 */   GIM_Try, /*On fail goto*//*Label 33616*/ GIMT_Encode4(2379429), // Rule ID 59190 //
     /* 2379391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379394 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2379397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2379411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379428 */     // GIR_Coverage, 59190,
     /* 2379428 */     GIR_EraseRootFromParent_Done,
     /* 2379429 */   // Label 33616: @2379429
     /* 2379429 */   GIM_Try, /*On fail goto*//*Label 33617*/ GIMT_Encode4(2379472), // Rule ID 59191 //
     /* 2379434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379437 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2379440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2379454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379471 */     // GIR_Coverage, 59191,
     /* 2379471 */     GIR_EraseRootFromParent_Done,
     /* 2379472 */   // Label 33617: @2379472
     /* 2379472 */   GIM_Reject,
     /* 2379473 */ // Label 33615: @2379473
     /* 2379473 */ GIM_Reject,
     /* 2379474 */ // Label 33569: @2379474
     /* 2379474 */ GIM_Try, /*On fail goto*//*Label 33618*/ GIMT_Encode4(2379577),
     /* 2379479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2379482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379490 */   GIM_Try, /*On fail goto*//*Label 33619*/ GIMT_Encode4(2379533), // Rule ID 59208 //
     /* 2379495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379498 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2379501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2379515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379532 */     // GIR_Coverage, 59208,
     /* 2379532 */     GIR_EraseRootFromParent_Done,
     /* 2379533 */   // Label 33619: @2379533
     /* 2379533 */   GIM_Try, /*On fail goto*//*Label 33620*/ GIMT_Encode4(2379576), // Rule ID 59209 //
     /* 2379538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379541 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2379544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2379558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379575 */     // GIR_Coverage, 59209,
     /* 2379575 */     GIR_EraseRootFromParent_Done,
     /* 2379576 */   // Label 33620: @2379576
     /* 2379576 */   GIM_Reject,
     /* 2379577 */ // Label 33618: @2379577
     /* 2379577 */ GIM_Reject,
     /* 2379578 */ // Label 33570: @2379578
     /* 2379578 */ GIM_Try, /*On fail goto*//*Label 33621*/ GIMT_Encode4(2379681),
     /* 2379583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2379586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379594 */   GIM_Try, /*On fail goto*//*Label 33622*/ GIMT_Encode4(2379637), // Rule ID 59216 //
     /* 2379599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2379602 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2379605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2379619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379636 */     // GIR_Coverage, 59216,
     /* 2379636 */     GIR_EraseRootFromParent_Done,
     /* 2379637 */   // Label 33622: @2379637
     /* 2379637 */   GIM_Try, /*On fail goto*//*Label 33623*/ GIMT_Encode4(2379680), // Rule ID 59217 //
     /* 2379642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2379645 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2379648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2379662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379679 */     // GIR_Coverage, 59217,
     /* 2379679 */     GIR_EraseRootFromParent_Done,
     /* 2379680 */   // Label 33623: @2379680
     /* 2379680 */   GIM_Reject,
     /* 2379681 */ // Label 33621: @2379681
     /* 2379681 */ GIM_Reject,
     /* 2379682 */ // Label 33571: @2379682
     /* 2379682 */ GIM_Try, /*On fail goto*//*Label 33624*/ GIMT_Encode4(2379785),
     /* 2379687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2379690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379698 */   GIM_Try, /*On fail goto*//*Label 33625*/ GIMT_Encode4(2379741), // Rule ID 59188 //
     /* 2379703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379706 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2379709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2379723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379740 */     // GIR_Coverage, 59188,
     /* 2379740 */     GIR_EraseRootFromParent_Done,
     /* 2379741 */   // Label 33625: @2379741
     /* 2379741 */   GIM_Try, /*On fail goto*//*Label 33626*/ GIMT_Encode4(2379784), // Rule ID 59189 //
     /* 2379746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379749 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2379752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2379766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379783 */     // GIR_Coverage, 59189,
     /* 2379783 */     GIR_EraseRootFromParent_Done,
     /* 2379784 */   // Label 33626: @2379784
     /* 2379784 */   GIM_Reject,
     /* 2379785 */ // Label 33624: @2379785
     /* 2379785 */ GIM_Reject,
     /* 2379786 */ // Label 33572: @2379786
     /* 2379786 */ GIM_Try, /*On fail goto*//*Label 33627*/ GIMT_Encode4(2379889),
     /* 2379791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2379794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379802 */   GIM_Try, /*On fail goto*//*Label 33628*/ GIMT_Encode4(2379845), // Rule ID 59202 //
     /* 2379807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379810 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2379813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2379827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379844 */     // GIR_Coverage, 59202,
     /* 2379844 */     GIR_EraseRootFromParent_Done,
     /* 2379845 */   // Label 33628: @2379845
     /* 2379845 */   GIM_Try, /*On fail goto*//*Label 33629*/ GIMT_Encode4(2379888), // Rule ID 59203 //
     /* 2379850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379853 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2379856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2379870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379887 */     // GIR_Coverage, 59203,
     /* 2379887 */     GIR_EraseRootFromParent_Done,
     /* 2379888 */   // Label 33629: @2379888
     /* 2379888 */   GIM_Reject,
     /* 2379889 */ // Label 33627: @2379889
     /* 2379889 */ GIM_Reject,
     /* 2379890 */ // Label 33573: @2379890
     /* 2379890 */ GIM_Try, /*On fail goto*//*Label 33630*/ GIMT_Encode4(2379993),
     /* 2379895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2379898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379906 */   GIM_Try, /*On fail goto*//*Label 33631*/ GIMT_Encode4(2379949), // Rule ID 59210 //
     /* 2379911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379914 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2379917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2379931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379948 */     // GIR_Coverage, 59210,
     /* 2379948 */     GIR_EraseRootFromParent_Done,
     /* 2379949 */   // Label 33631: @2379949
     /* 2379949 */   GIM_Try, /*On fail goto*//*Label 33632*/ GIMT_Encode4(2379992), // Rule ID 59211 //
     /* 2379954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379957 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2379960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2379974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379991 */     // GIR_Coverage, 59211,
     /* 2379991 */     GIR_EraseRootFromParent_Done,
     /* 2379992 */   // Label 33632: @2379992
     /* 2379992 */   GIM_Reject,
     /* 2379993 */ // Label 33630: @2379993
     /* 2379993 */ GIM_Reject,
     /* 2379994 */ // Label 33574: @2379994
     /* 2379994 */ GIM_Try, /*On fail goto*//*Label 33633*/ GIMT_Encode4(2380097),
     /* 2379999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2380002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380010 */   GIM_Try, /*On fail goto*//*Label 33634*/ GIMT_Encode4(2380053), // Rule ID 59218 //
     /* 2380015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2380018 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2380021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2380035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380052 */     // GIR_Coverage, 59218,
     /* 2380052 */     GIR_EraseRootFromParent_Done,
     /* 2380053 */   // Label 33634: @2380053
     /* 2380053 */   GIM_Try, /*On fail goto*//*Label 33635*/ GIMT_Encode4(2380096), // Rule ID 59219 //
     /* 2380058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2380061 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2380064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2380078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380095 */     // GIR_Coverage, 59219,
     /* 2380095 */     GIR_EraseRootFromParent_Done,
     /* 2380096 */   // Label 33635: @2380096
     /* 2380096 */   GIM_Reject,
     /* 2380097 */ // Label 33633: @2380097
     /* 2380097 */ GIM_Reject,
     /* 2380098 */ // Label 33575: @2380098
     /* 2380098 */ GIM_Try, /*On fail goto*//*Label 33636*/ GIMT_Encode4(2380201),
     /* 2380103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2380106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380114 */   GIM_Try, /*On fail goto*//*Label 33637*/ GIMT_Encode4(2380157), // Rule ID 59196 //
     /* 2380119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380122 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2380125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2380139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380156 */     // GIR_Coverage, 59196,
     /* 2380156 */     GIR_EraseRootFromParent_Done,
     /* 2380157 */   // Label 33637: @2380157
     /* 2380157 */   GIM_Try, /*On fail goto*//*Label 33638*/ GIMT_Encode4(2380200), // Rule ID 59197 //
     /* 2380162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380165 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2380168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2380182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380199 */     // GIR_Coverage, 59197,
     /* 2380199 */     GIR_EraseRootFromParent_Done,
     /* 2380200 */   // Label 33638: @2380200
     /* 2380200 */   GIM_Reject,
     /* 2380201 */ // Label 33636: @2380201
     /* 2380201 */ GIM_Reject,
     /* 2380202 */ // Label 33576: @2380202
     /* 2380202 */ GIM_Try, /*On fail goto*//*Label 33639*/ GIMT_Encode4(2380305),
     /* 2380207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2380210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380218 */   GIM_Try, /*On fail goto*//*Label 33640*/ GIMT_Encode4(2380261), // Rule ID 59204 //
     /* 2380223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380226 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2380229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2380243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380260 */     // GIR_Coverage, 59204,
     /* 2380260 */     GIR_EraseRootFromParent_Done,
     /* 2380261 */   // Label 33640: @2380261
     /* 2380261 */   GIM_Try, /*On fail goto*//*Label 33641*/ GIMT_Encode4(2380304), // Rule ID 59205 //
     /* 2380266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380269 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2380272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2380286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380303 */     // GIR_Coverage, 59205,
     /* 2380303 */     GIR_EraseRootFromParent_Done,
     /* 2380304 */   // Label 33641: @2380304
     /* 2380304 */   GIM_Reject,
     /* 2380305 */ // Label 33639: @2380305
     /* 2380305 */ GIM_Reject,
     /* 2380306 */ // Label 33577: @2380306
     /* 2380306 */ GIM_Try, /*On fail goto*//*Label 33642*/ GIMT_Encode4(2380409),
     /* 2380311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2380314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380322 */   GIM_Try, /*On fail goto*//*Label 33643*/ GIMT_Encode4(2380365), // Rule ID 59212 //
     /* 2380327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380330 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2380333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2380347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380364 */     // GIR_Coverage, 59212,
     /* 2380364 */     GIR_EraseRootFromParent_Done,
     /* 2380365 */   // Label 33643: @2380365
     /* 2380365 */   GIM_Try, /*On fail goto*//*Label 33644*/ GIMT_Encode4(2380408), // Rule ID 59213 //
     /* 2380370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380373 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2380376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2380390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380407 */     // GIR_Coverage, 59213,
     /* 2380407 */     GIR_EraseRootFromParent_Done,
     /* 2380408 */   // Label 33644: @2380408
     /* 2380408 */   GIM_Reject,
     /* 2380409 */ // Label 33642: @2380409
     /* 2380409 */ GIM_Reject,
     /* 2380410 */ // Label 33578: @2380410
     /* 2380410 */ GIM_Try, /*On fail goto*//*Label 33645*/ GIMT_Encode4(2380513),
     /* 2380415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2380418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380426 */   GIM_Try, /*On fail goto*//*Label 33646*/ GIMT_Encode4(2380469), // Rule ID 59198 //
     /* 2380431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380434 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2380437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2380451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380468 */     // GIR_Coverage, 59198,
     /* 2380468 */     GIR_EraseRootFromParent_Done,
     /* 2380469 */   // Label 33646: @2380469
     /* 2380469 */   GIM_Try, /*On fail goto*//*Label 33647*/ GIMT_Encode4(2380512), // Rule ID 59199 //
     /* 2380474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380477 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2380480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2380494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380511 */     // GIR_Coverage, 59199,
     /* 2380511 */     GIR_EraseRootFromParent_Done,
     /* 2380512 */   // Label 33647: @2380512
     /* 2380512 */   GIM_Reject,
     /* 2380513 */ // Label 33645: @2380513
     /* 2380513 */ GIM_Reject,
     /* 2380514 */ // Label 33579: @2380514
     /* 2380514 */ GIM_Try, /*On fail goto*//*Label 33648*/ GIMT_Encode4(2380617),
     /* 2380519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2380522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380530 */   GIM_Try, /*On fail goto*//*Label 33649*/ GIMT_Encode4(2380573), // Rule ID 59206 //
     /* 2380535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380538 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2380541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2380555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380572 */     // GIR_Coverage, 59206,
     /* 2380572 */     GIR_EraseRootFromParent_Done,
     /* 2380573 */   // Label 33649: @2380573
     /* 2380573 */   GIM_Try, /*On fail goto*//*Label 33650*/ GIMT_Encode4(2380616), // Rule ID 59207 //
     /* 2380578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380581 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2380584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2380598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380615 */     // GIR_Coverage, 59207,
     /* 2380615 */     GIR_EraseRootFromParent_Done,
     /* 2380616 */   // Label 33650: @2380616
     /* 2380616 */   GIM_Reject,
     /* 2380617 */ // Label 33648: @2380617
     /* 2380617 */ GIM_Reject,
     /* 2380618 */ // Label 33580: @2380618
     /* 2380618 */ GIM_Try, /*On fail goto*//*Label 33651*/ GIMT_Encode4(2380721),
     /* 2380623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2380626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380634 */   GIM_Try, /*On fail goto*//*Label 33652*/ GIMT_Encode4(2380677), // Rule ID 59200 //
     /* 2380639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380642 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2380645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2380659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380676 */     // GIR_Coverage, 59200,
     /* 2380676 */     GIR_EraseRootFromParent_Done,
     /* 2380677 */   // Label 33652: @2380677
     /* 2380677 */   GIM_Try, /*On fail goto*//*Label 33653*/ GIMT_Encode4(2380720), // Rule ID 59201 //
     /* 2380682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380685 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2380688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2380702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380719 */     // GIR_Coverage, 59201,
     /* 2380719 */     GIR_EraseRootFromParent_Done,
     /* 2380720 */   // Label 33653: @2380720
     /* 2380720 */   GIM_Reject,
     /* 2380721 */ // Label 33651: @2380721
     /* 2380721 */ GIM_Reject,
     /* 2380722 */ // Label 33581: @2380722
     /* 2380722 */ GIM_Reject,
     /* 2380723 */ // Label 89: @2380723
     /* 2380723 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33678*/ GIMT_Encode4(2383380),
     /* 2380734 */ /*GILLT_s32*//*Label 33654*/ GIMT_Encode4(2380858),
     /* 2380738 */ /*GILLT_s64*//*Label 33655*/ GIMT_Encode4(2380975), GIMT_Encode4(0),
     /* 2380746 */ /*GILLT_nxv1s8*//*Label 33656*/ GIMT_Encode4(2381092),
     /* 2380750 */ /*GILLT_nxv1s16*//*Label 33657*/ GIMT_Encode4(2381196),
     /* 2380754 */ /*GILLT_nxv1s32*//*Label 33658*/ GIMT_Encode4(2381300),
     /* 2380758 */ /*GILLT_nxv1s64*//*Label 33659*/ GIMT_Encode4(2381404), GIMT_Encode4(0),
     /* 2380766 */ /*GILLT_nxv2s8*//*Label 33660*/ GIMT_Encode4(2381508),
     /* 2380770 */ /*GILLT_nxv2s16*//*Label 33661*/ GIMT_Encode4(2381612),
     /* 2380774 */ /*GILLT_nxv2s32*//*Label 33662*/ GIMT_Encode4(2381716),
     /* 2380778 */ /*GILLT_nxv2s64*//*Label 33663*/ GIMT_Encode4(2381820), GIMT_Encode4(0),
     /* 2380786 */ /*GILLT_nxv4s8*//*Label 33664*/ GIMT_Encode4(2381924),
     /* 2380790 */ /*GILLT_nxv4s16*//*Label 33665*/ GIMT_Encode4(2382028),
     /* 2380794 */ /*GILLT_nxv4s32*//*Label 33666*/ GIMT_Encode4(2382132),
     /* 2380798 */ /*GILLT_nxv4s64*//*Label 33667*/ GIMT_Encode4(2382236), GIMT_Encode4(0),
     /* 2380806 */ /*GILLT_nxv8s8*//*Label 33668*/ GIMT_Encode4(2382340),
     /* 2380810 */ /*GILLT_nxv8s16*//*Label 33669*/ GIMT_Encode4(2382444),
     /* 2380814 */ /*GILLT_nxv8s32*//*Label 33670*/ GIMT_Encode4(2382548),
     /* 2380818 */ /*GILLT_nxv8s64*//*Label 33671*/ GIMT_Encode4(2382652), GIMT_Encode4(0),
     /* 2380826 */ /*GILLT_nxv16s8*//*Label 33672*/ GIMT_Encode4(2382756),
     /* 2380830 */ /*GILLT_nxv16s16*//*Label 33673*/ GIMT_Encode4(2382860),
     /* 2380834 */ /*GILLT_nxv16s32*//*Label 33674*/ GIMT_Encode4(2382964), GIMT_Encode4(0),
     /* 2380842 */ /*GILLT_nxv32s8*//*Label 33675*/ GIMT_Encode4(2383068),
     /* 2380846 */ /*GILLT_nxv32s16*//*Label 33676*/ GIMT_Encode4(2383172), GIMT_Encode4(0),
     /* 2380854 */ /*GILLT_nxv64s8*//*Label 33677*/ GIMT_Encode4(2383276),
     /* 2380858 */ // Label 33654: @2380858
     /* 2380858 */ GIM_Try, /*On fail goto*//*Label 33679*/ GIMT_Encode4(2380974),
     /* 2380863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2380866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380870 */   GIM_Try, /*On fail goto*//*Label 33680*/ GIMT_Encode4(2380916), // Rule ID 62556 //
     /* 2380875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2380878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2380882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2380886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2380890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2380894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380899 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2380903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2380905 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (TH_FF0:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2380905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2380908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2380914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380915 */     // GIR_Coverage, 62556,
     /* 2380915 */     GIR_EraseRootFromParent_Done,
     /* 2380916 */   // Label 33680: @2380916
     /* 2380916 */   GIM_Try, /*On fail goto*//*Label 33681*/ GIMT_Encode4(2380935), // Rule ID 2505 //
     /* 2380921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2380924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380928 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2380928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2380933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380934 */     // GIR_Coverage, 2505,
     /* 2380934 */     GIR_Done,
     /* 2380935 */   // Label 33681: @2380935
     /* 2380935 */   GIM_Try, /*On fail goto*//*Label 33682*/ GIMT_Encode4(2380954), // Rule ID 62554 //
     /* 2380940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2380943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380947 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2380947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2380952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380953 */     // GIR_Coverage, 62554,
     /* 2380953 */     GIR_Done,
     /* 2380954 */   // Label 33682: @2380954
     /* 2380954 */   GIM_Try, /*On fail goto*//*Label 33683*/ GIMT_Encode4(2380973), // Rule ID 64433 //
     /* 2380959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2380962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380966 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FL1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2380966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2380971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380972 */     // GIR_Coverage, 64433,
     /* 2380972 */     GIR_Done,
     /* 2380973 */   // Label 33683: @2380973
     /* 2380973 */   GIM_Reject,
     /* 2380974 */ // Label 33679: @2380974
     /* 2380974 */ GIM_Reject,
     /* 2380975 */ // Label 33655: @2380975
     /* 2380975 */ GIM_Try, /*On fail goto*//*Label 33684*/ GIMT_Encode4(2381091),
     /* 2380980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2380983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380987 */   GIM_Try, /*On fail goto*//*Label 33685*/ GIMT_Encode4(2381033), // Rule ID 62555 //
     /* 2380992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2380995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2380999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2381003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2381011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381016 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2381020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2381022 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }))  =>  (TH_FF0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2381022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2381025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2381031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381032 */     // GIR_Coverage, 62555,
     /* 2381032 */     GIR_EraseRootFromParent_Done,
     /* 2381033 */   // Label 33685: @2381033
     /* 2381033 */   GIM_Try, /*On fail goto*//*Label 33686*/ GIMT_Encode4(2381052), // Rule ID 2504 //
     /* 2381038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2381041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381045 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2381045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2381050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381051 */     // GIR_Coverage, 2504,
     /* 2381051 */     GIR_Done,
     /* 2381052 */   // Label 33686: @2381052
     /* 2381052 */   GIM_Try, /*On fail goto*//*Label 33687*/ GIMT_Encode4(2381071), // Rule ID 62553 //
     /* 2381057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2381060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381064 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2381064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2381069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381070 */     // GIR_Coverage, 62553,
     /* 2381070 */     GIR_Done,
     /* 2381071 */   // Label 33687: @2381071
     /* 2381071 */   GIM_Try, /*On fail goto*//*Label 33688*/ GIMT_Encode4(2381090), // Rule ID 64432 //
     /* 2381076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2381079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381083 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FL1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2381083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2381088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381089 */     // GIR_Coverage, 64432,
     /* 2381089 */     GIR_Done,
     /* 2381090 */   // Label 33688: @2381090
     /* 2381090 */   GIM_Reject,
     /* 2381091 */ // Label 33684: @2381091
     /* 2381091 */ GIM_Reject,
     /* 2381092 */ // Label 33656: @2381092
     /* 2381092 */ GIM_Try, /*On fail goto*//*Label 33689*/ GIMT_Encode4(2381195),
     /* 2381097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2381100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381108 */   GIM_Try, /*On fail goto*//*Label 33690*/ GIMT_Encode4(2381151), // Rule ID 59132 //
     /* 2381113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381116 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2381119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2381133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381150 */     // GIR_Coverage, 59132,
     /* 2381150 */     GIR_EraseRootFromParent_Done,
     /* 2381151 */   // Label 33690: @2381151
     /* 2381151 */   GIM_Try, /*On fail goto*//*Label 33691*/ GIMT_Encode4(2381194), // Rule ID 59133 //
     /* 2381156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381159 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2381162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2381176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381193 */     // GIR_Coverage, 59133,
     /* 2381193 */     GIR_EraseRootFromParent_Done,
     /* 2381194 */   // Label 33691: @2381194
     /* 2381194 */   GIM_Reject,
     /* 2381195 */ // Label 33689: @2381195
     /* 2381195 */ GIM_Reject,
     /* 2381196 */ // Label 33657: @2381196
     /* 2381196 */ GIM_Try, /*On fail goto*//*Label 33692*/ GIMT_Encode4(2381299),
     /* 2381201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2381204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381212 */   GIM_Try, /*On fail goto*//*Label 33693*/ GIMT_Encode4(2381255), // Rule ID 59138 //
     /* 2381217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381220 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2381223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2381237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381254 */     // GIR_Coverage, 59138,
     /* 2381254 */     GIR_EraseRootFromParent_Done,
     /* 2381255 */   // Label 33693: @2381255
     /* 2381255 */   GIM_Try, /*On fail goto*//*Label 33694*/ GIMT_Encode4(2381298), // Rule ID 59139 //
     /* 2381260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381263 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2381266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2381280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381297 */     // GIR_Coverage, 59139,
     /* 2381297 */     GIR_EraseRootFromParent_Done,
     /* 2381298 */   // Label 33694: @2381298
     /* 2381298 */   GIM_Reject,
     /* 2381299 */ // Label 33692: @2381299
     /* 2381299 */ GIM_Reject,
     /* 2381300 */ // Label 33658: @2381300
     /* 2381300 */ GIM_Try, /*On fail goto*//*Label 33695*/ GIMT_Encode4(2381403),
     /* 2381305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2381308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381316 */   GIM_Try, /*On fail goto*//*Label 33696*/ GIMT_Encode4(2381359), // Rule ID 59142 //
     /* 2381321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381324 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2381327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2381341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381358 */     // GIR_Coverage, 59142,
     /* 2381358 */     GIR_EraseRootFromParent_Done,
     /* 2381359 */   // Label 33696: @2381359
     /* 2381359 */   GIM_Try, /*On fail goto*//*Label 33697*/ GIMT_Encode4(2381402), // Rule ID 59143 //
     /* 2381364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381367 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2381370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2381384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381401 */     // GIR_Coverage, 59143,
     /* 2381401 */     GIR_EraseRootFromParent_Done,
     /* 2381402 */   // Label 33697: @2381402
     /* 2381402 */   GIM_Reject,
     /* 2381403 */ // Label 33695: @2381403
     /* 2381403 */ GIM_Reject,
     /* 2381404 */ // Label 33659: @2381404
     /* 2381404 */ GIM_Try, /*On fail goto*//*Label 33698*/ GIMT_Encode4(2381507),
     /* 2381409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2381412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381420 */   GIM_Try, /*On fail goto*//*Label 33699*/ GIMT_Encode4(2381463), // Rule ID 59150 //
     /* 2381425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2381428 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2381431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2381445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2381458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381462 */     // GIR_Coverage, 59150,
     /* 2381462 */     GIR_EraseRootFromParent_Done,
     /* 2381463 */   // Label 33699: @2381463
     /* 2381463 */   GIM_Try, /*On fail goto*//*Label 33700*/ GIMT_Encode4(2381506), // Rule ID 59151 //
     /* 2381468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2381471 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2381474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2381488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2381501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381505 */     // GIR_Coverage, 59151,
     /* 2381505 */     GIR_EraseRootFromParent_Done,
     /* 2381506 */   // Label 33700: @2381506
     /* 2381506 */   GIM_Reject,
     /* 2381507 */ // Label 33698: @2381507
     /* 2381507 */ GIM_Reject,
     /* 2381508 */ // Label 33660: @2381508
     /* 2381508 */ GIM_Try, /*On fail goto*//*Label 33701*/ GIMT_Encode4(2381611),
     /* 2381513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2381516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381524 */   GIM_Try, /*On fail goto*//*Label 33702*/ GIMT_Encode4(2381567), // Rule ID 59134 //
     /* 2381529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381532 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2381535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2381549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381566 */     // GIR_Coverage, 59134,
     /* 2381566 */     GIR_EraseRootFromParent_Done,
     /* 2381567 */   // Label 33702: @2381567
     /* 2381567 */   GIM_Try, /*On fail goto*//*Label 33703*/ GIMT_Encode4(2381610), // Rule ID 59135 //
     /* 2381572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381575 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2381578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2381592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381609 */     // GIR_Coverage, 59135,
     /* 2381609 */     GIR_EraseRootFromParent_Done,
     /* 2381610 */   // Label 33703: @2381610
     /* 2381610 */   GIM_Reject,
     /* 2381611 */ // Label 33701: @2381611
     /* 2381611 */ GIM_Reject,
     /* 2381612 */ // Label 33661: @2381612
     /* 2381612 */ GIM_Try, /*On fail goto*//*Label 33704*/ GIMT_Encode4(2381715),
     /* 2381617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2381620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381628 */   GIM_Try, /*On fail goto*//*Label 33705*/ GIMT_Encode4(2381671), // Rule ID 59140 //
     /* 2381633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381636 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2381639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2381653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381670 */     // GIR_Coverage, 59140,
     /* 2381670 */     GIR_EraseRootFromParent_Done,
     /* 2381671 */   // Label 33705: @2381671
     /* 2381671 */   GIM_Try, /*On fail goto*//*Label 33706*/ GIMT_Encode4(2381714), // Rule ID 59141 //
     /* 2381676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381679 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2381682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2381696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381713 */     // GIR_Coverage, 59141,
     /* 2381713 */     GIR_EraseRootFromParent_Done,
     /* 2381714 */   // Label 33706: @2381714
     /* 2381714 */   GIM_Reject,
     /* 2381715 */ // Label 33704: @2381715
     /* 2381715 */ GIM_Reject,
     /* 2381716 */ // Label 33662: @2381716
     /* 2381716 */ GIM_Try, /*On fail goto*//*Label 33707*/ GIMT_Encode4(2381819),
     /* 2381721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2381724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381732 */   GIM_Try, /*On fail goto*//*Label 33708*/ GIMT_Encode4(2381775), // Rule ID 59148 //
     /* 2381737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381740 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2381743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2381757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381774 */     // GIR_Coverage, 59148,
     /* 2381774 */     GIR_EraseRootFromParent_Done,
     /* 2381775 */   // Label 33708: @2381775
     /* 2381775 */   GIM_Try, /*On fail goto*//*Label 33709*/ GIMT_Encode4(2381818), // Rule ID 59149 //
     /* 2381780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381783 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2381786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2381800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381817 */     // GIR_Coverage, 59149,
     /* 2381817 */     GIR_EraseRootFromParent_Done,
     /* 2381818 */   // Label 33709: @2381818
     /* 2381818 */   GIM_Reject,
     /* 2381819 */ // Label 33707: @2381819
     /* 2381819 */ GIM_Reject,
     /* 2381820 */ // Label 33663: @2381820
     /* 2381820 */ GIM_Try, /*On fail goto*//*Label 33710*/ GIMT_Encode4(2381923),
     /* 2381825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2381828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2381832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2381836 */   GIM_Try, /*On fail goto*//*Label 33711*/ GIMT_Encode4(2381879), // Rule ID 59170 //
     /* 2381841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2381844 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2381847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2381861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2381874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381878 */     // GIR_Coverage, 59170,
     /* 2381878 */     GIR_EraseRootFromParent_Done,
     /* 2381879 */   // Label 33711: @2381879
     /* 2381879 */   GIM_Try, /*On fail goto*//*Label 33712*/ GIMT_Encode4(2381922), // Rule ID 59171 //
     /* 2381884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2381887 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2381890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2381904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2381917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381921 */     // GIR_Coverage, 59171,
     /* 2381921 */     GIR_EraseRootFromParent_Done,
     /* 2381922 */   // Label 33712: @2381922
     /* 2381922 */   GIM_Reject,
     /* 2381923 */ // Label 33710: @2381923
     /* 2381923 */ GIM_Reject,
     /* 2381924 */ // Label 33664: @2381924
     /* 2381924 */ GIM_Try, /*On fail goto*//*Label 33713*/ GIMT_Encode4(2382027),
     /* 2381929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2381932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381940 */   GIM_Try, /*On fail goto*//*Label 33714*/ GIMT_Encode4(2381983), // Rule ID 59136 //
     /* 2381945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381948 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2381951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2381965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381982 */     // GIR_Coverage, 59136,
     /* 2381982 */     GIR_EraseRootFromParent_Done,
     /* 2381983 */   // Label 33714: @2381983
     /* 2381983 */   GIM_Try, /*On fail goto*//*Label 33715*/ GIMT_Encode4(2382026), // Rule ID 59137 //
     /* 2381988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381991 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2381994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2382008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382025 */     // GIR_Coverage, 59137,
     /* 2382025 */     GIR_EraseRootFromParent_Done,
     /* 2382026 */   // Label 33715: @2382026
     /* 2382026 */   GIM_Reject,
     /* 2382027 */ // Label 33713: @2382027
     /* 2382027 */ GIM_Reject,
     /* 2382028 */ // Label 33665: @2382028
     /* 2382028 */ GIM_Try, /*On fail goto*//*Label 33716*/ GIMT_Encode4(2382131),
     /* 2382033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2382036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382044 */   GIM_Try, /*On fail goto*//*Label 33717*/ GIMT_Encode4(2382087), // Rule ID 59146 //
     /* 2382049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382052 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2382055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2382069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382086 */     // GIR_Coverage, 59146,
     /* 2382086 */     GIR_EraseRootFromParent_Done,
     /* 2382087 */   // Label 33717: @2382087
     /* 2382087 */   GIM_Try, /*On fail goto*//*Label 33718*/ GIMT_Encode4(2382130), // Rule ID 59147 //
     /* 2382092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382095 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2382098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2382112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382129 */     // GIR_Coverage, 59147,
     /* 2382129 */     GIR_EraseRootFromParent_Done,
     /* 2382130 */   // Label 33718: @2382130
     /* 2382130 */   GIM_Reject,
     /* 2382131 */ // Label 33716: @2382131
     /* 2382131 */ GIM_Reject,
     /* 2382132 */ // Label 33666: @2382132
     /* 2382132 */ GIM_Try, /*On fail goto*//*Label 33719*/ GIMT_Encode4(2382235),
     /* 2382137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2382140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382148 */   GIM_Try, /*On fail goto*//*Label 33720*/ GIMT_Encode4(2382191), // Rule ID 59164 //
     /* 2382153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382156 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2382159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2382173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382190 */     // GIR_Coverage, 59164,
     /* 2382190 */     GIR_EraseRootFromParent_Done,
     /* 2382191 */   // Label 33720: @2382191
     /* 2382191 */   GIM_Try, /*On fail goto*//*Label 33721*/ GIMT_Encode4(2382234), // Rule ID 59165 //
     /* 2382196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382199 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2382202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2382216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382233 */     // GIR_Coverage, 59165,
     /* 2382233 */     GIR_EraseRootFromParent_Done,
     /* 2382234 */   // Label 33721: @2382234
     /* 2382234 */   GIM_Reject,
     /* 2382235 */ // Label 33719: @2382235
     /* 2382235 */ GIM_Reject,
     /* 2382236 */ // Label 33667: @2382236
     /* 2382236 */ GIM_Try, /*On fail goto*//*Label 33722*/ GIMT_Encode4(2382339),
     /* 2382241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2382244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382252 */   GIM_Try, /*On fail goto*//*Label 33723*/ GIMT_Encode4(2382295), // Rule ID 59172 //
     /* 2382257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2382260 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2382263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2382277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382294 */     // GIR_Coverage, 59172,
     /* 2382294 */     GIR_EraseRootFromParent_Done,
     /* 2382295 */   // Label 33723: @2382295
     /* 2382295 */   GIM_Try, /*On fail goto*//*Label 33724*/ GIMT_Encode4(2382338), // Rule ID 59173 //
     /* 2382300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2382303 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2382306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2382320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382337 */     // GIR_Coverage, 59173,
     /* 2382337 */     GIR_EraseRootFromParent_Done,
     /* 2382338 */   // Label 33724: @2382338
     /* 2382338 */   GIM_Reject,
     /* 2382339 */ // Label 33722: @2382339
     /* 2382339 */ GIM_Reject,
     /* 2382340 */ // Label 33668: @2382340
     /* 2382340 */ GIM_Try, /*On fail goto*//*Label 33725*/ GIMT_Encode4(2382443),
     /* 2382345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2382348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382356 */   GIM_Try, /*On fail goto*//*Label 33726*/ GIMT_Encode4(2382399), // Rule ID 59144 //
     /* 2382361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382364 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2382367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2382381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382398 */     // GIR_Coverage, 59144,
     /* 2382398 */     GIR_EraseRootFromParent_Done,
     /* 2382399 */   // Label 33726: @2382399
     /* 2382399 */   GIM_Try, /*On fail goto*//*Label 33727*/ GIMT_Encode4(2382442), // Rule ID 59145 //
     /* 2382404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382407 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2382410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2382424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382441 */     // GIR_Coverage, 59145,
     /* 2382441 */     GIR_EraseRootFromParent_Done,
     /* 2382442 */   // Label 33727: @2382442
     /* 2382442 */   GIM_Reject,
     /* 2382443 */ // Label 33725: @2382443
     /* 2382443 */ GIM_Reject,
     /* 2382444 */ // Label 33669: @2382444
     /* 2382444 */ GIM_Try, /*On fail goto*//*Label 33728*/ GIMT_Encode4(2382547),
     /* 2382449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2382452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382460 */   GIM_Try, /*On fail goto*//*Label 33729*/ GIMT_Encode4(2382503), // Rule ID 59158 //
     /* 2382465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382468 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2382471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2382485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382502 */     // GIR_Coverage, 59158,
     /* 2382502 */     GIR_EraseRootFromParent_Done,
     /* 2382503 */   // Label 33729: @2382503
     /* 2382503 */   GIM_Try, /*On fail goto*//*Label 33730*/ GIMT_Encode4(2382546), // Rule ID 59159 //
     /* 2382508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382511 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2382514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2382528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382545 */     // GIR_Coverage, 59159,
     /* 2382545 */     GIR_EraseRootFromParent_Done,
     /* 2382546 */   // Label 33730: @2382546
     /* 2382546 */   GIM_Reject,
     /* 2382547 */ // Label 33728: @2382547
     /* 2382547 */ GIM_Reject,
     /* 2382548 */ // Label 33670: @2382548
     /* 2382548 */ GIM_Try, /*On fail goto*//*Label 33731*/ GIMT_Encode4(2382651),
     /* 2382553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2382556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382564 */   GIM_Try, /*On fail goto*//*Label 33732*/ GIMT_Encode4(2382607), // Rule ID 59166 //
     /* 2382569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382572 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2382575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2382589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382606 */     // GIR_Coverage, 59166,
     /* 2382606 */     GIR_EraseRootFromParent_Done,
     /* 2382607 */   // Label 33732: @2382607
     /* 2382607 */   GIM_Try, /*On fail goto*//*Label 33733*/ GIMT_Encode4(2382650), // Rule ID 59167 //
     /* 2382612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382615 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2382618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2382632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382649 */     // GIR_Coverage, 59167,
     /* 2382649 */     GIR_EraseRootFromParent_Done,
     /* 2382650 */   // Label 33733: @2382650
     /* 2382650 */   GIM_Reject,
     /* 2382651 */ // Label 33731: @2382651
     /* 2382651 */ GIM_Reject,
     /* 2382652 */ // Label 33671: @2382652
     /* 2382652 */ GIM_Try, /*On fail goto*//*Label 33734*/ GIMT_Encode4(2382755),
     /* 2382657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2382660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382668 */   GIM_Try, /*On fail goto*//*Label 33735*/ GIMT_Encode4(2382711), // Rule ID 59174 //
     /* 2382673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2382676 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2382679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2382693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382710 */     // GIR_Coverage, 59174,
     /* 2382710 */     GIR_EraseRootFromParent_Done,
     /* 2382711 */   // Label 33735: @2382711
     /* 2382711 */   GIM_Try, /*On fail goto*//*Label 33736*/ GIMT_Encode4(2382754), // Rule ID 59175 //
     /* 2382716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2382719 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2382722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2382736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382753 */     // GIR_Coverage, 59175,
     /* 2382753 */     GIR_EraseRootFromParent_Done,
     /* 2382754 */   // Label 33736: @2382754
     /* 2382754 */   GIM_Reject,
     /* 2382755 */ // Label 33734: @2382755
     /* 2382755 */ GIM_Reject,
     /* 2382756 */ // Label 33672: @2382756
     /* 2382756 */ GIM_Try, /*On fail goto*//*Label 33737*/ GIMT_Encode4(2382859),
     /* 2382761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2382764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382772 */   GIM_Try, /*On fail goto*//*Label 33738*/ GIMT_Encode4(2382815), // Rule ID 59152 //
     /* 2382777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382780 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2382783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2382797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382814 */     // GIR_Coverage, 59152,
     /* 2382814 */     GIR_EraseRootFromParent_Done,
     /* 2382815 */   // Label 33738: @2382815
     /* 2382815 */   GIM_Try, /*On fail goto*//*Label 33739*/ GIMT_Encode4(2382858), // Rule ID 59153 //
     /* 2382820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382823 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2382826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2382840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382857 */     // GIR_Coverage, 59153,
     /* 2382857 */     GIR_EraseRootFromParent_Done,
     /* 2382858 */   // Label 33739: @2382858
     /* 2382858 */   GIM_Reject,
     /* 2382859 */ // Label 33737: @2382859
     /* 2382859 */ GIM_Reject,
     /* 2382860 */ // Label 33673: @2382860
     /* 2382860 */ GIM_Try, /*On fail goto*//*Label 33740*/ GIMT_Encode4(2382963),
     /* 2382865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2382868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382876 */   GIM_Try, /*On fail goto*//*Label 33741*/ GIMT_Encode4(2382919), // Rule ID 59160 //
     /* 2382881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382884 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2382887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2382901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382918 */     // GIR_Coverage, 59160,
     /* 2382918 */     GIR_EraseRootFromParent_Done,
     /* 2382919 */   // Label 33741: @2382919
     /* 2382919 */   GIM_Try, /*On fail goto*//*Label 33742*/ GIMT_Encode4(2382962), // Rule ID 59161 //
     /* 2382924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382927 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2382930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2382944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382961 */     // GIR_Coverage, 59161,
     /* 2382961 */     GIR_EraseRootFromParent_Done,
     /* 2382962 */   // Label 33742: @2382962
     /* 2382962 */   GIM_Reject,
     /* 2382963 */ // Label 33740: @2382963
     /* 2382963 */ GIM_Reject,
     /* 2382964 */ // Label 33674: @2382964
     /* 2382964 */ GIM_Try, /*On fail goto*//*Label 33743*/ GIMT_Encode4(2383067),
     /* 2382969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2382972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382980 */   GIM_Try, /*On fail goto*//*Label 33744*/ GIMT_Encode4(2383023), // Rule ID 59168 //
     /* 2382985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382988 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2382991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2383005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383022 */     // GIR_Coverage, 59168,
     /* 2383022 */     GIR_EraseRootFromParent_Done,
     /* 2383023 */   // Label 33744: @2383023
     /* 2383023 */   GIM_Try, /*On fail goto*//*Label 33745*/ GIMT_Encode4(2383066), // Rule ID 59169 //
     /* 2383028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383031 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2383034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2383048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383065 */     // GIR_Coverage, 59169,
     /* 2383065 */     GIR_EraseRootFromParent_Done,
     /* 2383066 */   // Label 33745: @2383066
     /* 2383066 */   GIM_Reject,
     /* 2383067 */ // Label 33743: @2383067
     /* 2383067 */ GIM_Reject,
     /* 2383068 */ // Label 33675: @2383068
     /* 2383068 */ GIM_Try, /*On fail goto*//*Label 33746*/ GIMT_Encode4(2383171),
     /* 2383073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2383076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383084 */   GIM_Try, /*On fail goto*//*Label 33747*/ GIMT_Encode4(2383127), // Rule ID 59154 //
     /* 2383089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383092 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2383095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2383109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383126 */     // GIR_Coverage, 59154,
     /* 2383126 */     GIR_EraseRootFromParent_Done,
     /* 2383127 */   // Label 33747: @2383127
     /* 2383127 */   GIM_Try, /*On fail goto*//*Label 33748*/ GIMT_Encode4(2383170), // Rule ID 59155 //
     /* 2383132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383135 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2383138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2383152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383169 */     // GIR_Coverage, 59155,
     /* 2383169 */     GIR_EraseRootFromParent_Done,
     /* 2383170 */   // Label 33748: @2383170
     /* 2383170 */   GIM_Reject,
     /* 2383171 */ // Label 33746: @2383171
     /* 2383171 */ GIM_Reject,
     /* 2383172 */ // Label 33676: @2383172
     /* 2383172 */ GIM_Try, /*On fail goto*//*Label 33749*/ GIMT_Encode4(2383275),
     /* 2383177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2383180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383188 */   GIM_Try, /*On fail goto*//*Label 33750*/ GIMT_Encode4(2383231), // Rule ID 59162 //
     /* 2383193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383196 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2383199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2383213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383230 */     // GIR_Coverage, 59162,
     /* 2383230 */     GIR_EraseRootFromParent_Done,
     /* 2383231 */   // Label 33750: @2383231
     /* 2383231 */   GIM_Try, /*On fail goto*//*Label 33751*/ GIMT_Encode4(2383274), // Rule ID 59163 //
     /* 2383236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383239 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2383242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2383256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383273 */     // GIR_Coverage, 59163,
     /* 2383273 */     GIR_EraseRootFromParent_Done,
     /* 2383274 */   // Label 33751: @2383274
     /* 2383274 */   GIM_Reject,
     /* 2383275 */ // Label 33749: @2383275
     /* 2383275 */ GIM_Reject,
     /* 2383276 */ // Label 33677: @2383276
     /* 2383276 */ GIM_Try, /*On fail goto*//*Label 33752*/ GIMT_Encode4(2383379),
     /* 2383281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2383284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383292 */   GIM_Try, /*On fail goto*//*Label 33753*/ GIMT_Encode4(2383335), // Rule ID 59156 //
     /* 2383297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383300 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2383303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2383317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383334 */     // GIR_Coverage, 59156,
     /* 2383334 */     GIR_EraseRootFromParent_Done,
     /* 2383335 */   // Label 33753: @2383335
     /* 2383335 */   GIM_Try, /*On fail goto*//*Label 33754*/ GIMT_Encode4(2383378), // Rule ID 59157 //
     /* 2383340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383343 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2383346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2383360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383377 */     // GIR_Coverage, 59157,
     /* 2383377 */     GIR_EraseRootFromParent_Done,
     /* 2383378 */   // Label 33754: @2383378
     /* 2383378 */   GIM_Reject,
     /* 2383379 */ // Label 33752: @2383379
     /* 2383379 */ GIM_Reject,
     /* 2383380 */ // Label 33678: @2383380
     /* 2383380 */ GIM_Reject,
     /* 2383381 */ // Label 90: @2383381
     /* 2383381 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33779*/ GIMT_Encode4(2385931),
     /* 2383392 */ /*GILLT_s32*//*Label 33755*/ GIMT_Encode4(2383516),
     /* 2383396 */ /*GILLT_s64*//*Label 33756*/ GIMT_Encode4(2383564), GIMT_Encode4(0),
     /* 2383404 */ /*GILLT_nxv1s8*//*Label 33757*/ GIMT_Encode4(2383643),
     /* 2383408 */ /*GILLT_nxv1s16*//*Label 33758*/ GIMT_Encode4(2383747),
     /* 2383412 */ /*GILLT_nxv1s32*//*Label 33759*/ GIMT_Encode4(2383851),
     /* 2383416 */ /*GILLT_nxv1s64*//*Label 33760*/ GIMT_Encode4(2383955), GIMT_Encode4(0),
     /* 2383424 */ /*GILLT_nxv2s8*//*Label 33761*/ GIMT_Encode4(2384059),
     /* 2383428 */ /*GILLT_nxv2s16*//*Label 33762*/ GIMT_Encode4(2384163),
     /* 2383432 */ /*GILLT_nxv2s32*//*Label 33763*/ GIMT_Encode4(2384267),
     /* 2383436 */ /*GILLT_nxv2s64*//*Label 33764*/ GIMT_Encode4(2384371), GIMT_Encode4(0),
     /* 2383444 */ /*GILLT_nxv4s8*//*Label 33765*/ GIMT_Encode4(2384475),
     /* 2383448 */ /*GILLT_nxv4s16*//*Label 33766*/ GIMT_Encode4(2384579),
     /* 2383452 */ /*GILLT_nxv4s32*//*Label 33767*/ GIMT_Encode4(2384683),
     /* 2383456 */ /*GILLT_nxv4s64*//*Label 33768*/ GIMT_Encode4(2384787), GIMT_Encode4(0),
     /* 2383464 */ /*GILLT_nxv8s8*//*Label 33769*/ GIMT_Encode4(2384891),
     /* 2383468 */ /*GILLT_nxv8s16*//*Label 33770*/ GIMT_Encode4(2384995),
     /* 2383472 */ /*GILLT_nxv8s32*//*Label 33771*/ GIMT_Encode4(2385099),
     /* 2383476 */ /*GILLT_nxv8s64*//*Label 33772*/ GIMT_Encode4(2385203), GIMT_Encode4(0),
     /* 2383484 */ /*GILLT_nxv16s8*//*Label 33773*/ GIMT_Encode4(2385307),
     /* 2383488 */ /*GILLT_nxv16s16*//*Label 33774*/ GIMT_Encode4(2385411),
     /* 2383492 */ /*GILLT_nxv16s32*//*Label 33775*/ GIMT_Encode4(2385515), GIMT_Encode4(0),
     /* 2383500 */ /*GILLT_nxv32s8*//*Label 33776*/ GIMT_Encode4(2385619),
     /* 2383504 */ /*GILLT_nxv32s16*//*Label 33777*/ GIMT_Encode4(2385723), GIMT_Encode4(0),
     /* 2383512 */ /*GILLT_nxv64s8*//*Label 33778*/ GIMT_Encode4(2385827),
     /* 2383516 */ // Label 33755: @2383516
     /* 2383516 */ GIM_Try, /*On fail goto*//*Label 33780*/ GIMT_Encode4(2383563),
     /* 2383521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2383524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2383528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2383532 */   GIM_Try, /*On fail goto*//*Label 33781*/ GIMT_Encode4(2383547), // Rule ID 2509 //
     /* 2383537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2383540 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CPOP:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2383540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2383545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383546 */     // GIR_Coverage, 2509,
     /* 2383546 */     GIR_Done,
     /* 2383547 */   // Label 33781: @2383547
     /* 2383547 */   GIM_Try, /*On fail goto*//*Label 33782*/ GIMT_Encode4(2383562), // Rule ID 64436 //
     /* 2383552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2383555 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_CNT:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2383555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2383560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383561 */     // GIR_Coverage, 64436,
     /* 2383561 */     GIR_Done,
     /* 2383562 */   // Label 33782: @2383562
     /* 2383562 */   GIM_Reject,
     /* 2383563 */ // Label 33780: @2383563
     /* 2383563 */ GIM_Reject,
     /* 2383564 */ // Label 33756: @2383564
     /* 2383564 */ GIM_Try, /*On fail goto*//*Label 33783*/ GIMT_Encode4(2383642),
     /* 2383569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2383572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2383576 */   GIM_Try, /*On fail goto*//*Label 33784*/ GIMT_Encode4(2383603), // Rule ID 2512 //
     /* 2383581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2383584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2383591 */     // (ctpop:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (CPOPW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2383591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CPOPW),
     /* 2383594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2383601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383602 */     // GIR_Coverage, 2512,
     /* 2383602 */     GIR_EraseRootFromParent_Done,
     /* 2383603 */   // Label 33784: @2383603
     /* 2383603 */   GIM_Try, /*On fail goto*//*Label 33785*/ GIMT_Encode4(2383622), // Rule ID 2508 //
     /* 2383608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2383611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2383615 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CPOP:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2383615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2383620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383621 */     // GIR_Coverage, 2508,
     /* 2383621 */     GIR_Done,
     /* 2383622 */   // Label 33785: @2383622
     /* 2383622 */   GIM_Try, /*On fail goto*//*Label 33786*/ GIMT_Encode4(2383641), // Rule ID 64435 //
     /* 2383627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2383630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2383634 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_CNT:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2383634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2383639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383640 */     // GIR_Coverage, 64435,
     /* 2383640 */     GIR_Done,
     /* 2383641 */   // Label 33786: @2383641
     /* 2383641 */   GIM_Reject,
     /* 2383642 */ // Label 33783: @2383642
     /* 2383642 */ GIM_Reject,
     /* 2383643 */ // Label 33757: @2383643
     /* 2383643 */ GIM_Try, /*On fail goto*//*Label 33787*/ GIMT_Encode4(2383746),
     /* 2383648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2383651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383659 */   GIM_Try, /*On fail goto*//*Label 33788*/ GIMT_Encode4(2383702), // Rule ID 59220 //
     /* 2383664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383667 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2383670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2383684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383701 */     // GIR_Coverage, 59220,
     /* 2383701 */     GIR_EraseRootFromParent_Done,
     /* 2383702 */   // Label 33788: @2383702
     /* 2383702 */   GIM_Try, /*On fail goto*//*Label 33789*/ GIMT_Encode4(2383745), // Rule ID 59221 //
     /* 2383707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383710 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2383713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2383727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383744 */     // GIR_Coverage, 59221,
     /* 2383744 */     GIR_EraseRootFromParent_Done,
     /* 2383745 */   // Label 33789: @2383745
     /* 2383745 */   GIM_Reject,
     /* 2383746 */ // Label 33787: @2383746
     /* 2383746 */ GIM_Reject,
     /* 2383747 */ // Label 33758: @2383747
     /* 2383747 */ GIM_Try, /*On fail goto*//*Label 33790*/ GIMT_Encode4(2383850),
     /* 2383752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2383755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383763 */   GIM_Try, /*On fail goto*//*Label 33791*/ GIMT_Encode4(2383806), // Rule ID 59226 //
     /* 2383768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383771 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2383774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2383788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383805 */     // GIR_Coverage, 59226,
     /* 2383805 */     GIR_EraseRootFromParent_Done,
     /* 2383806 */   // Label 33791: @2383806
     /* 2383806 */   GIM_Try, /*On fail goto*//*Label 33792*/ GIMT_Encode4(2383849), // Rule ID 59227 //
     /* 2383811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383814 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2383817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2383831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383848 */     // GIR_Coverage, 59227,
     /* 2383848 */     GIR_EraseRootFromParent_Done,
     /* 2383849 */   // Label 33792: @2383849
     /* 2383849 */   GIM_Reject,
     /* 2383850 */ // Label 33790: @2383850
     /* 2383850 */ GIM_Reject,
     /* 2383851 */ // Label 33759: @2383851
     /* 2383851 */ GIM_Try, /*On fail goto*//*Label 33793*/ GIMT_Encode4(2383954),
     /* 2383856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2383859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383867 */   GIM_Try, /*On fail goto*//*Label 33794*/ GIMT_Encode4(2383910), // Rule ID 59230 //
     /* 2383872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383875 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2383878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2383892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383909 */     // GIR_Coverage, 59230,
     /* 2383909 */     GIR_EraseRootFromParent_Done,
     /* 2383910 */   // Label 33794: @2383910
     /* 2383910 */   GIM_Try, /*On fail goto*//*Label 33795*/ GIMT_Encode4(2383953), // Rule ID 59231 //
     /* 2383915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383918 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2383921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2383935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383952 */     // GIR_Coverage, 59231,
     /* 2383952 */     GIR_EraseRootFromParent_Done,
     /* 2383953 */   // Label 33795: @2383953
     /* 2383953 */   GIM_Reject,
     /* 2383954 */ // Label 33793: @2383954
     /* 2383954 */ GIM_Reject,
     /* 2383955 */ // Label 33760: @2383955
     /* 2383955 */ GIM_Try, /*On fail goto*//*Label 33796*/ GIMT_Encode4(2384058),
     /* 2383960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2383963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383971 */   GIM_Try, /*On fail goto*//*Label 33797*/ GIMT_Encode4(2384014), // Rule ID 59238 //
     /* 2383976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2383979 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2383982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2383996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384013 */     // GIR_Coverage, 59238,
     /* 2384013 */     GIR_EraseRootFromParent_Done,
     /* 2384014 */   // Label 33797: @2384014
     /* 2384014 */   GIM_Try, /*On fail goto*//*Label 33798*/ GIMT_Encode4(2384057), // Rule ID 59239 //
     /* 2384019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2384022 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2384025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2384039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384056 */     // GIR_Coverage, 59239,
     /* 2384056 */     GIR_EraseRootFromParent_Done,
     /* 2384057 */   // Label 33798: @2384057
     /* 2384057 */   GIM_Reject,
     /* 2384058 */ // Label 33796: @2384058
     /* 2384058 */ GIM_Reject,
     /* 2384059 */ // Label 33761: @2384059
     /* 2384059 */ GIM_Try, /*On fail goto*//*Label 33799*/ GIMT_Encode4(2384162),
     /* 2384064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2384067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384075 */   GIM_Try, /*On fail goto*//*Label 33800*/ GIMT_Encode4(2384118), // Rule ID 59222 //
     /* 2384080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384083 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2384086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2384100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384117 */     // GIR_Coverage, 59222,
     /* 2384117 */     GIR_EraseRootFromParent_Done,
     /* 2384118 */   // Label 33800: @2384118
     /* 2384118 */   GIM_Try, /*On fail goto*//*Label 33801*/ GIMT_Encode4(2384161), // Rule ID 59223 //
     /* 2384123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384126 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2384129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2384143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384160 */     // GIR_Coverage, 59223,
     /* 2384160 */     GIR_EraseRootFromParent_Done,
     /* 2384161 */   // Label 33801: @2384161
     /* 2384161 */   GIM_Reject,
     /* 2384162 */ // Label 33799: @2384162
     /* 2384162 */ GIM_Reject,
     /* 2384163 */ // Label 33762: @2384163
     /* 2384163 */ GIM_Try, /*On fail goto*//*Label 33802*/ GIMT_Encode4(2384266),
     /* 2384168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2384171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384179 */   GIM_Try, /*On fail goto*//*Label 33803*/ GIMT_Encode4(2384222), // Rule ID 59228 //
     /* 2384184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384187 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2384190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2384204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384221 */     // GIR_Coverage, 59228,
     /* 2384221 */     GIR_EraseRootFromParent_Done,
     /* 2384222 */   // Label 33803: @2384222
     /* 2384222 */   GIM_Try, /*On fail goto*//*Label 33804*/ GIMT_Encode4(2384265), // Rule ID 59229 //
     /* 2384227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384230 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2384233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2384247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384264 */     // GIR_Coverage, 59229,
     /* 2384264 */     GIR_EraseRootFromParent_Done,
     /* 2384265 */   // Label 33804: @2384265
     /* 2384265 */   GIM_Reject,
     /* 2384266 */ // Label 33802: @2384266
     /* 2384266 */ GIM_Reject,
     /* 2384267 */ // Label 33763: @2384267
     /* 2384267 */ GIM_Try, /*On fail goto*//*Label 33805*/ GIMT_Encode4(2384370),
     /* 2384272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2384275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384283 */   GIM_Try, /*On fail goto*//*Label 33806*/ GIMT_Encode4(2384326), // Rule ID 59236 //
     /* 2384288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384291 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2384294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2384308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384325 */     // GIR_Coverage, 59236,
     /* 2384325 */     GIR_EraseRootFromParent_Done,
     /* 2384326 */   // Label 33806: @2384326
     /* 2384326 */   GIM_Try, /*On fail goto*//*Label 33807*/ GIMT_Encode4(2384369), // Rule ID 59237 //
     /* 2384331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384334 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2384337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2384351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384368 */     // GIR_Coverage, 59237,
     /* 2384368 */     GIR_EraseRootFromParent_Done,
     /* 2384369 */   // Label 33807: @2384369
     /* 2384369 */   GIM_Reject,
     /* 2384370 */ // Label 33805: @2384370
     /* 2384370 */ GIM_Reject,
     /* 2384371 */ // Label 33764: @2384371
     /* 2384371 */ GIM_Try, /*On fail goto*//*Label 33808*/ GIMT_Encode4(2384474),
     /* 2384376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2384379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384387 */   GIM_Try, /*On fail goto*//*Label 33809*/ GIMT_Encode4(2384430), // Rule ID 59258 //
     /* 2384392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2384395 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2384398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2384412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384429 */     // GIR_Coverage, 59258,
     /* 2384429 */     GIR_EraseRootFromParent_Done,
     /* 2384430 */   // Label 33809: @2384430
     /* 2384430 */   GIM_Try, /*On fail goto*//*Label 33810*/ GIMT_Encode4(2384473), // Rule ID 59259 //
     /* 2384435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2384438 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2384441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2384455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384472 */     // GIR_Coverage, 59259,
     /* 2384472 */     GIR_EraseRootFromParent_Done,
     /* 2384473 */   // Label 33810: @2384473
     /* 2384473 */   GIM_Reject,
     /* 2384474 */ // Label 33808: @2384474
     /* 2384474 */ GIM_Reject,
     /* 2384475 */ // Label 33765: @2384475
     /* 2384475 */ GIM_Try, /*On fail goto*//*Label 33811*/ GIMT_Encode4(2384578),
     /* 2384480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2384483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384491 */   GIM_Try, /*On fail goto*//*Label 33812*/ GIMT_Encode4(2384534), // Rule ID 59224 //
     /* 2384496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384499 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2384502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2384516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384533 */     // GIR_Coverage, 59224,
     /* 2384533 */     GIR_EraseRootFromParent_Done,
     /* 2384534 */   // Label 33812: @2384534
     /* 2384534 */   GIM_Try, /*On fail goto*//*Label 33813*/ GIMT_Encode4(2384577), // Rule ID 59225 //
     /* 2384539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384542 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2384545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2384559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384576 */     // GIR_Coverage, 59225,
     /* 2384576 */     GIR_EraseRootFromParent_Done,
     /* 2384577 */   // Label 33813: @2384577
     /* 2384577 */   GIM_Reject,
     /* 2384578 */ // Label 33811: @2384578
     /* 2384578 */ GIM_Reject,
     /* 2384579 */ // Label 33766: @2384579
     /* 2384579 */ GIM_Try, /*On fail goto*//*Label 33814*/ GIMT_Encode4(2384682),
     /* 2384584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2384587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384595 */   GIM_Try, /*On fail goto*//*Label 33815*/ GIMT_Encode4(2384638), // Rule ID 59234 //
     /* 2384600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384603 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2384606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2384620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384637 */     // GIR_Coverage, 59234,
     /* 2384637 */     GIR_EraseRootFromParent_Done,
     /* 2384638 */   // Label 33815: @2384638
     /* 2384638 */   GIM_Try, /*On fail goto*//*Label 33816*/ GIMT_Encode4(2384681), // Rule ID 59235 //
     /* 2384643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384646 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2384649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2384663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384680 */     // GIR_Coverage, 59235,
     /* 2384680 */     GIR_EraseRootFromParent_Done,
     /* 2384681 */   // Label 33816: @2384681
     /* 2384681 */   GIM_Reject,
     /* 2384682 */ // Label 33814: @2384682
     /* 2384682 */ GIM_Reject,
     /* 2384683 */ // Label 33767: @2384683
     /* 2384683 */ GIM_Try, /*On fail goto*//*Label 33817*/ GIMT_Encode4(2384786),
     /* 2384688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2384691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384699 */   GIM_Try, /*On fail goto*//*Label 33818*/ GIMT_Encode4(2384742), // Rule ID 59252 //
     /* 2384704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384707 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2384710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2384724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384741 */     // GIR_Coverage, 59252,
     /* 2384741 */     GIR_EraseRootFromParent_Done,
     /* 2384742 */   // Label 33818: @2384742
     /* 2384742 */   GIM_Try, /*On fail goto*//*Label 33819*/ GIMT_Encode4(2384785), // Rule ID 59253 //
     /* 2384747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384750 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2384753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2384767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384784 */     // GIR_Coverage, 59253,
     /* 2384784 */     GIR_EraseRootFromParent_Done,
     /* 2384785 */   // Label 33819: @2384785
     /* 2384785 */   GIM_Reject,
     /* 2384786 */ // Label 33817: @2384786
     /* 2384786 */ GIM_Reject,
     /* 2384787 */ // Label 33768: @2384787
     /* 2384787 */ GIM_Try, /*On fail goto*//*Label 33820*/ GIMT_Encode4(2384890),
     /* 2384792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2384795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384803 */   GIM_Try, /*On fail goto*//*Label 33821*/ GIMT_Encode4(2384846), // Rule ID 59260 //
     /* 2384808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2384811 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2384814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2384828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384845 */     // GIR_Coverage, 59260,
     /* 2384845 */     GIR_EraseRootFromParent_Done,
     /* 2384846 */   // Label 33821: @2384846
     /* 2384846 */   GIM_Try, /*On fail goto*//*Label 33822*/ GIMT_Encode4(2384889), // Rule ID 59261 //
     /* 2384851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2384854 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2384857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2384871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384888 */     // GIR_Coverage, 59261,
     /* 2384888 */     GIR_EraseRootFromParent_Done,
     /* 2384889 */   // Label 33822: @2384889
     /* 2384889 */   GIM_Reject,
     /* 2384890 */ // Label 33820: @2384890
     /* 2384890 */ GIM_Reject,
     /* 2384891 */ // Label 33769: @2384891
     /* 2384891 */ GIM_Try, /*On fail goto*//*Label 33823*/ GIMT_Encode4(2384994),
     /* 2384896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2384899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384907 */   GIM_Try, /*On fail goto*//*Label 33824*/ GIMT_Encode4(2384950), // Rule ID 59232 //
     /* 2384912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384915 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2384918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2384932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384949 */     // GIR_Coverage, 59232,
     /* 2384949 */     GIR_EraseRootFromParent_Done,
     /* 2384950 */   // Label 33824: @2384950
     /* 2384950 */   GIM_Try, /*On fail goto*//*Label 33825*/ GIMT_Encode4(2384993), // Rule ID 59233 //
     /* 2384955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384958 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2384961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2384975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384992 */     // GIR_Coverage, 59233,
     /* 2384992 */     GIR_EraseRootFromParent_Done,
     /* 2384993 */   // Label 33825: @2384993
     /* 2384993 */   GIM_Reject,
     /* 2384994 */ // Label 33823: @2384994
     /* 2384994 */ GIM_Reject,
     /* 2384995 */ // Label 33770: @2384995
     /* 2384995 */ GIM_Try, /*On fail goto*//*Label 33826*/ GIMT_Encode4(2385098),
     /* 2385000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2385003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385011 */   GIM_Try, /*On fail goto*//*Label 33827*/ GIMT_Encode4(2385054), // Rule ID 59246 //
     /* 2385016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385019 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2385022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2385036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385053 */     // GIR_Coverage, 59246,
     /* 2385053 */     GIR_EraseRootFromParent_Done,
     /* 2385054 */   // Label 33827: @2385054
     /* 2385054 */   GIM_Try, /*On fail goto*//*Label 33828*/ GIMT_Encode4(2385097), // Rule ID 59247 //
     /* 2385059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385062 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2385065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2385079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385096 */     // GIR_Coverage, 59247,
     /* 2385096 */     GIR_EraseRootFromParent_Done,
     /* 2385097 */   // Label 33828: @2385097
     /* 2385097 */   GIM_Reject,
     /* 2385098 */ // Label 33826: @2385098
     /* 2385098 */ GIM_Reject,
     /* 2385099 */ // Label 33771: @2385099
     /* 2385099 */ GIM_Try, /*On fail goto*//*Label 33829*/ GIMT_Encode4(2385202),
     /* 2385104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2385107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385115 */   GIM_Try, /*On fail goto*//*Label 33830*/ GIMT_Encode4(2385158), // Rule ID 59254 //
     /* 2385120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385123 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2385126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2385140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385157 */     // GIR_Coverage, 59254,
     /* 2385157 */     GIR_EraseRootFromParent_Done,
     /* 2385158 */   // Label 33830: @2385158
     /* 2385158 */   GIM_Try, /*On fail goto*//*Label 33831*/ GIMT_Encode4(2385201), // Rule ID 59255 //
     /* 2385163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385166 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2385169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2385183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385200 */     // GIR_Coverage, 59255,
     /* 2385200 */     GIR_EraseRootFromParent_Done,
     /* 2385201 */   // Label 33831: @2385201
     /* 2385201 */   GIM_Reject,
     /* 2385202 */ // Label 33829: @2385202
     /* 2385202 */ GIM_Reject,
     /* 2385203 */ // Label 33772: @2385203
     /* 2385203 */ GIM_Try, /*On fail goto*//*Label 33832*/ GIMT_Encode4(2385306),
     /* 2385208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2385211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385219 */   GIM_Try, /*On fail goto*//*Label 33833*/ GIMT_Encode4(2385262), // Rule ID 59262 //
     /* 2385224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2385227 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2385230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2385244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385261 */     // GIR_Coverage, 59262,
     /* 2385261 */     GIR_EraseRootFromParent_Done,
     /* 2385262 */   // Label 33833: @2385262
     /* 2385262 */   GIM_Try, /*On fail goto*//*Label 33834*/ GIMT_Encode4(2385305), // Rule ID 59263 //
     /* 2385267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2385270 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2385273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2385287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385304 */     // GIR_Coverage, 59263,
     /* 2385304 */     GIR_EraseRootFromParent_Done,
     /* 2385305 */   // Label 33834: @2385305
     /* 2385305 */   GIM_Reject,
     /* 2385306 */ // Label 33832: @2385306
     /* 2385306 */ GIM_Reject,
     /* 2385307 */ // Label 33773: @2385307
     /* 2385307 */ GIM_Try, /*On fail goto*//*Label 33835*/ GIMT_Encode4(2385410),
     /* 2385312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2385315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385323 */   GIM_Try, /*On fail goto*//*Label 33836*/ GIMT_Encode4(2385366), // Rule ID 59240 //
     /* 2385328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385331 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2385334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2385348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385365 */     // GIR_Coverage, 59240,
     /* 2385365 */     GIR_EraseRootFromParent_Done,
     /* 2385366 */   // Label 33836: @2385366
     /* 2385366 */   GIM_Try, /*On fail goto*//*Label 33837*/ GIMT_Encode4(2385409), // Rule ID 59241 //
     /* 2385371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385374 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2385377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2385391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385408 */     // GIR_Coverage, 59241,
     /* 2385408 */     GIR_EraseRootFromParent_Done,
     /* 2385409 */   // Label 33837: @2385409
     /* 2385409 */   GIM_Reject,
     /* 2385410 */ // Label 33835: @2385410
     /* 2385410 */ GIM_Reject,
     /* 2385411 */ // Label 33774: @2385411
     /* 2385411 */ GIM_Try, /*On fail goto*//*Label 33838*/ GIMT_Encode4(2385514),
     /* 2385416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2385419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385427 */   GIM_Try, /*On fail goto*//*Label 33839*/ GIMT_Encode4(2385470), // Rule ID 59248 //
     /* 2385432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385435 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2385438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2385452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385469 */     // GIR_Coverage, 59248,
     /* 2385469 */     GIR_EraseRootFromParent_Done,
     /* 2385470 */   // Label 33839: @2385470
     /* 2385470 */   GIM_Try, /*On fail goto*//*Label 33840*/ GIMT_Encode4(2385513), // Rule ID 59249 //
     /* 2385475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385478 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2385481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2385495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385512 */     // GIR_Coverage, 59249,
     /* 2385512 */     GIR_EraseRootFromParent_Done,
     /* 2385513 */   // Label 33840: @2385513
     /* 2385513 */   GIM_Reject,
     /* 2385514 */ // Label 33838: @2385514
     /* 2385514 */ GIM_Reject,
     /* 2385515 */ // Label 33775: @2385515
     /* 2385515 */ GIM_Try, /*On fail goto*//*Label 33841*/ GIMT_Encode4(2385618),
     /* 2385520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2385523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385531 */   GIM_Try, /*On fail goto*//*Label 33842*/ GIMT_Encode4(2385574), // Rule ID 59256 //
     /* 2385536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385539 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2385542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2385556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385573 */     // GIR_Coverage, 59256,
     /* 2385573 */     GIR_EraseRootFromParent_Done,
     /* 2385574 */   // Label 33842: @2385574
     /* 2385574 */   GIM_Try, /*On fail goto*//*Label 33843*/ GIMT_Encode4(2385617), // Rule ID 59257 //
     /* 2385579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385582 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2385585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2385599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385616 */     // GIR_Coverage, 59257,
     /* 2385616 */     GIR_EraseRootFromParent_Done,
     /* 2385617 */   // Label 33843: @2385617
     /* 2385617 */   GIM_Reject,
     /* 2385618 */ // Label 33841: @2385618
     /* 2385618 */ GIM_Reject,
     /* 2385619 */ // Label 33776: @2385619
     /* 2385619 */ GIM_Try, /*On fail goto*//*Label 33844*/ GIMT_Encode4(2385722),
     /* 2385624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2385627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385635 */   GIM_Try, /*On fail goto*//*Label 33845*/ GIMT_Encode4(2385678), // Rule ID 59242 //
     /* 2385640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385643 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2385646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2385660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385677 */     // GIR_Coverage, 59242,
     /* 2385677 */     GIR_EraseRootFromParent_Done,
     /* 2385678 */   // Label 33845: @2385678
     /* 2385678 */   GIM_Try, /*On fail goto*//*Label 33846*/ GIMT_Encode4(2385721), // Rule ID 59243 //
     /* 2385683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385686 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2385689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2385703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385720 */     // GIR_Coverage, 59243,
     /* 2385720 */     GIR_EraseRootFromParent_Done,
     /* 2385721 */   // Label 33846: @2385721
     /* 2385721 */   GIM_Reject,
     /* 2385722 */ // Label 33844: @2385722
     /* 2385722 */ GIM_Reject,
     /* 2385723 */ // Label 33777: @2385723
     /* 2385723 */ GIM_Try, /*On fail goto*//*Label 33847*/ GIMT_Encode4(2385826),
     /* 2385728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2385731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385739 */   GIM_Try, /*On fail goto*//*Label 33848*/ GIMT_Encode4(2385782), // Rule ID 59250 //
     /* 2385744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385747 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2385750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2385764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385781 */     // GIR_Coverage, 59250,
     /* 2385781 */     GIR_EraseRootFromParent_Done,
     /* 2385782 */   // Label 33848: @2385782
     /* 2385782 */   GIM_Try, /*On fail goto*//*Label 33849*/ GIMT_Encode4(2385825), // Rule ID 59251 //
     /* 2385787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385790 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2385793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2385807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385824 */     // GIR_Coverage, 59251,
     /* 2385824 */     GIR_EraseRootFromParent_Done,
     /* 2385825 */   // Label 33849: @2385825
     /* 2385825 */   GIM_Reject,
     /* 2385826 */ // Label 33847: @2385826
     /* 2385826 */ GIM_Reject,
     /* 2385827 */ // Label 33778: @2385827
     /* 2385827 */ GIM_Try, /*On fail goto*//*Label 33850*/ GIMT_Encode4(2385930),
     /* 2385832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2385835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385843 */   GIM_Try, /*On fail goto*//*Label 33851*/ GIMT_Encode4(2385886), // Rule ID 59244 //
     /* 2385848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385851 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2385854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2385868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385885 */     // GIR_Coverage, 59244,
     /* 2385885 */     GIR_EraseRootFromParent_Done,
     /* 2385886 */   // Label 33851: @2385886
     /* 2385886 */   GIM_Try, /*On fail goto*//*Label 33852*/ GIMT_Encode4(2385929), // Rule ID 59245 //
     /* 2385891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385894 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2385897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2385911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385928 */     // GIR_Coverage, 59245,
     /* 2385928 */     GIR_EraseRootFromParent_Done,
     /* 2385929 */   // Label 33852: @2385929
     /* 2385929 */   GIM_Reject,
     /* 2385930 */ // Label 33850: @2385930
     /* 2385930 */ GIM_Reject,
     /* 2385931 */ // Label 33779: @2385931
     /* 2385931 */ GIM_Reject,
     /* 2385932 */ // Label 91: @2385932
     /* 2385932 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33877*/ GIMT_Encode4(2388466),
     /* 2385943 */ /*GILLT_s32*//*Label 33853*/ GIMT_Encode4(2386067),
     /* 2385947 */ /*GILLT_s64*//*Label 33854*/ GIMT_Encode4(2386130), GIMT_Encode4(0),
     /* 2385955 */ /*GILLT_nxv1s8*//*Label 33855*/ GIMT_Encode4(2386178),
     /* 2385959 */ /*GILLT_nxv1s16*//*Label 33856*/ GIMT_Encode4(2386282),
     /* 2385963 */ /*GILLT_nxv1s32*//*Label 33857*/ GIMT_Encode4(2386386),
     /* 2385967 */ /*GILLT_nxv1s64*//*Label 33858*/ GIMT_Encode4(2386490), GIMT_Encode4(0),
     /* 2385975 */ /*GILLT_nxv2s8*//*Label 33859*/ GIMT_Encode4(2386594),
     /* 2385979 */ /*GILLT_nxv2s16*//*Label 33860*/ GIMT_Encode4(2386698),
     /* 2385983 */ /*GILLT_nxv2s32*//*Label 33861*/ GIMT_Encode4(2386802),
     /* 2385987 */ /*GILLT_nxv2s64*//*Label 33862*/ GIMT_Encode4(2386906), GIMT_Encode4(0),
     /* 2385995 */ /*GILLT_nxv4s8*//*Label 33863*/ GIMT_Encode4(2387010),
     /* 2385999 */ /*GILLT_nxv4s16*//*Label 33864*/ GIMT_Encode4(2387114),
     /* 2386003 */ /*GILLT_nxv4s32*//*Label 33865*/ GIMT_Encode4(2387218),
     /* 2386007 */ /*GILLT_nxv4s64*//*Label 33866*/ GIMT_Encode4(2387322), GIMT_Encode4(0),
     /* 2386015 */ /*GILLT_nxv8s8*//*Label 33867*/ GIMT_Encode4(2387426),
     /* 2386019 */ /*GILLT_nxv8s16*//*Label 33868*/ GIMT_Encode4(2387530),
     /* 2386023 */ /*GILLT_nxv8s32*//*Label 33869*/ GIMT_Encode4(2387634),
     /* 2386027 */ /*GILLT_nxv8s64*//*Label 33870*/ GIMT_Encode4(2387738), GIMT_Encode4(0),
     /* 2386035 */ /*GILLT_nxv16s8*//*Label 33871*/ GIMT_Encode4(2387842),
     /* 2386039 */ /*GILLT_nxv16s16*//*Label 33872*/ GIMT_Encode4(2387946),
     /* 2386043 */ /*GILLT_nxv16s32*//*Label 33873*/ GIMT_Encode4(2388050), GIMT_Encode4(0),
     /* 2386051 */ /*GILLT_nxv32s8*//*Label 33874*/ GIMT_Encode4(2388154),
     /* 2386055 */ /*GILLT_nxv32s16*//*Label 33875*/ GIMT_Encode4(2388258), GIMT_Encode4(0),
     /* 2386063 */ /*GILLT_nxv64s8*//*Label 33876*/ GIMT_Encode4(2388362),
     /* 2386067 */ // Label 33853: @2386067
     /* 2386067 */ GIM_Try, /*On fail goto*//*Label 33878*/ GIMT_Encode4(2386129),
     /* 2386072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2386075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2386079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2386083 */   GIM_Try, /*On fail goto*//*Label 33879*/ GIMT_Encode4(2386098), // Rule ID 2526 //
     /* 2386088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0),
     /* 2386091 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2386091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2386096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386097 */     // GIR_Coverage, 2526,
     /* 2386097 */     GIR_Done,
     /* 2386098 */   // Label 33879: @2386098
     /* 2386098 */   GIM_Try, /*On fail goto*//*Label 33880*/ GIMT_Encode4(2386113), // Rule ID 2527 //
     /* 2386103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1),
     /* 2386106 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2386106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2386111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386112 */     // GIR_Coverage, 2527,
     /* 2386112 */     GIR_Done,
     /* 2386113 */   // Label 33880: @2386113
     /* 2386113 */   GIM_Try, /*On fail goto*//*Label 33881*/ GIMT_Encode4(2386128), // Rule ID 62558 //
     /* 2386118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2386121 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_REV:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2386121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2386126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386127 */     // GIR_Coverage, 62558,
     /* 2386127 */     GIR_Done,
     /* 2386128 */   // Label 33881: @2386128
     /* 2386128 */   GIM_Reject,
     /* 2386129 */ // Label 33878: @2386129
     /* 2386129 */ GIM_Reject,
     /* 2386130 */ // Label 33854: @2386130
     /* 2386130 */ GIM_Try, /*On fail goto*//*Label 33882*/ GIMT_Encode4(2386177),
     /* 2386135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2386138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2386142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2386146 */   GIM_Try, /*On fail goto*//*Label 33883*/ GIMT_Encode4(2386161), // Rule ID 2528 //
     /* 2386151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2386154 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (REV8_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2386154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV64),
     /* 2386159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386160 */     // GIR_Coverage, 2528,
     /* 2386160 */     GIR_Done,
     /* 2386161 */   // Label 33883: @2386161
     /* 2386161 */   GIM_Try, /*On fail goto*//*Label 33884*/ GIMT_Encode4(2386176), // Rule ID 62557 //
     /* 2386166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2386169 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_REV:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2386169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2386174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386175 */     // GIR_Coverage, 62557,
     /* 2386175 */     GIR_Done,
     /* 2386176 */   // Label 33884: @2386176
     /* 2386176 */   GIM_Reject,
     /* 2386177 */ // Label 33882: @2386177
     /* 2386177 */ GIM_Reject,
     /* 2386178 */ // Label 33855: @2386178
     /* 2386178 */ GIM_Try, /*On fail goto*//*Label 33885*/ GIMT_Encode4(2386281),
     /* 2386183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2386186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386194 */   GIM_Try, /*On fail goto*//*Label 33886*/ GIMT_Encode4(2386237), // Rule ID 59088 //
     /* 2386199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2386202 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2386205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2386219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386236 */     // GIR_Coverage, 59088,
     /* 2386236 */     GIR_EraseRootFromParent_Done,
     /* 2386237 */   // Label 33886: @2386237
     /* 2386237 */   GIM_Try, /*On fail goto*//*Label 33887*/ GIMT_Encode4(2386280), // Rule ID 59089 //
     /* 2386242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386245 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2386248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2386262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386279 */     // GIR_Coverage, 59089,
     /* 2386279 */     GIR_EraseRootFromParent_Done,
     /* 2386280 */   // Label 33887: @2386280
     /* 2386280 */   GIM_Reject,
     /* 2386281 */ // Label 33885: @2386281
     /* 2386281 */ GIM_Reject,
     /* 2386282 */ // Label 33856: @2386282
     /* 2386282 */ GIM_Try, /*On fail goto*//*Label 33888*/ GIMT_Encode4(2386385),
     /* 2386287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2386290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386298 */   GIM_Try, /*On fail goto*//*Label 33889*/ GIMT_Encode4(2386341), // Rule ID 59094 //
     /* 2386303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2386306 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2386309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2386323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386340 */     // GIR_Coverage, 59094,
     /* 2386340 */     GIR_EraseRootFromParent_Done,
     /* 2386341 */   // Label 33889: @2386341
     /* 2386341 */   GIM_Try, /*On fail goto*//*Label 33890*/ GIMT_Encode4(2386384), // Rule ID 59095 //
     /* 2386346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386349 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2386352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2386366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386383 */     // GIR_Coverage, 59095,
     /* 2386383 */     GIR_EraseRootFromParent_Done,
     /* 2386384 */   // Label 33890: @2386384
     /* 2386384 */   GIM_Reject,
     /* 2386385 */ // Label 33888: @2386385
     /* 2386385 */ GIM_Reject,
     /* 2386386 */ // Label 33857: @2386386
     /* 2386386 */ GIM_Try, /*On fail goto*//*Label 33891*/ GIMT_Encode4(2386489),
     /* 2386391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2386394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386402 */   GIM_Try, /*On fail goto*//*Label 33892*/ GIMT_Encode4(2386445), // Rule ID 59098 //
     /* 2386407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2386410 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2386413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2386427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386444 */     // GIR_Coverage, 59098,
     /* 2386444 */     GIR_EraseRootFromParent_Done,
     /* 2386445 */   // Label 33892: @2386445
     /* 2386445 */   GIM_Try, /*On fail goto*//*Label 33893*/ GIMT_Encode4(2386488), // Rule ID 59099 //
     /* 2386450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386453 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2386456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2386470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386487 */     // GIR_Coverage, 59099,
     /* 2386487 */     GIR_EraseRootFromParent_Done,
     /* 2386488 */   // Label 33893: @2386488
     /* 2386488 */   GIM_Reject,
     /* 2386489 */ // Label 33891: @2386489
     /* 2386489 */ GIM_Reject,
     /* 2386490 */ // Label 33858: @2386490
     /* 2386490 */ GIM_Try, /*On fail goto*//*Label 33894*/ GIMT_Encode4(2386593),
     /* 2386495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2386498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386506 */   GIM_Try, /*On fail goto*//*Label 33895*/ GIMT_Encode4(2386549), // Rule ID 59106 //
     /* 2386511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2386514 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2386517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2386531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386548 */     // GIR_Coverage, 59106,
     /* 2386548 */     GIR_EraseRootFromParent_Done,
     /* 2386549 */   // Label 33895: @2386549
     /* 2386549 */   GIM_Try, /*On fail goto*//*Label 33896*/ GIMT_Encode4(2386592), // Rule ID 59107 //
     /* 2386554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2386557 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2386560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2386574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386591 */     // GIR_Coverage, 59107,
     /* 2386591 */     GIR_EraseRootFromParent_Done,
     /* 2386592 */   // Label 33896: @2386592
     /* 2386592 */   GIM_Reject,
     /* 2386593 */ // Label 33894: @2386593
     /* 2386593 */ GIM_Reject,
     /* 2386594 */ // Label 33859: @2386594
     /* 2386594 */ GIM_Try, /*On fail goto*//*Label 33897*/ GIMT_Encode4(2386697),
     /* 2386599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2386602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386610 */   GIM_Try, /*On fail goto*//*Label 33898*/ GIMT_Encode4(2386653), // Rule ID 59090 //
     /* 2386615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2386618 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2386621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2386635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386652 */     // GIR_Coverage, 59090,
     /* 2386652 */     GIR_EraseRootFromParent_Done,
     /* 2386653 */   // Label 33898: @2386653
     /* 2386653 */   GIM_Try, /*On fail goto*//*Label 33899*/ GIMT_Encode4(2386696), // Rule ID 59091 //
     /* 2386658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386661 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2386664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2386678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386695 */     // GIR_Coverage, 59091,
     /* 2386695 */     GIR_EraseRootFromParent_Done,
     /* 2386696 */   // Label 33899: @2386696
     /* 2386696 */   GIM_Reject,
     /* 2386697 */ // Label 33897: @2386697
     /* 2386697 */ GIM_Reject,
     /* 2386698 */ // Label 33860: @2386698
     /* 2386698 */ GIM_Try, /*On fail goto*//*Label 33900*/ GIMT_Encode4(2386801),
     /* 2386703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2386706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386714 */   GIM_Try, /*On fail goto*//*Label 33901*/ GIMT_Encode4(2386757), // Rule ID 59096 //
     /* 2386719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2386722 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2386725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2386739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386756 */     // GIR_Coverage, 59096,
     /* 2386756 */     GIR_EraseRootFromParent_Done,
     /* 2386757 */   // Label 33901: @2386757
     /* 2386757 */   GIM_Try, /*On fail goto*//*Label 33902*/ GIMT_Encode4(2386800), // Rule ID 59097 //
     /* 2386762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386765 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2386768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2386782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386799 */     // GIR_Coverage, 59097,
     /* 2386799 */     GIR_EraseRootFromParent_Done,
     /* 2386800 */   // Label 33902: @2386800
     /* 2386800 */   GIM_Reject,
     /* 2386801 */ // Label 33900: @2386801
     /* 2386801 */ GIM_Reject,
     /* 2386802 */ // Label 33861: @2386802
     /* 2386802 */ GIM_Try, /*On fail goto*//*Label 33903*/ GIMT_Encode4(2386905),
     /* 2386807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2386810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386818 */   GIM_Try, /*On fail goto*//*Label 33904*/ GIMT_Encode4(2386861), // Rule ID 59104 //
     /* 2386823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2386826 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2386829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2386843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386860 */     // GIR_Coverage, 59104,
     /* 2386860 */     GIR_EraseRootFromParent_Done,
     /* 2386861 */   // Label 33904: @2386861
     /* 2386861 */   GIM_Try, /*On fail goto*//*Label 33905*/ GIMT_Encode4(2386904), // Rule ID 59105 //
     /* 2386866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386869 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2386872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2386886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386903 */     // GIR_Coverage, 59105,
     /* 2386903 */     GIR_EraseRootFromParent_Done,
     /* 2386904 */   // Label 33905: @2386904
     /* 2386904 */   GIM_Reject,
     /* 2386905 */ // Label 33903: @2386905
     /* 2386905 */ GIM_Reject,
     /* 2386906 */ // Label 33862: @2386906
     /* 2386906 */ GIM_Try, /*On fail goto*//*Label 33906*/ GIMT_Encode4(2387009),
     /* 2386911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2386914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386922 */   GIM_Try, /*On fail goto*//*Label 33907*/ GIMT_Encode4(2386965), // Rule ID 59126 //
     /* 2386927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2386930 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2386933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2386947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386964 */     // GIR_Coverage, 59126,
     /* 2386964 */     GIR_EraseRootFromParent_Done,
     /* 2386965 */   // Label 33907: @2386965
     /* 2386965 */   GIM_Try, /*On fail goto*//*Label 33908*/ GIMT_Encode4(2387008), // Rule ID 59127 //
     /* 2386970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2386973 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2386976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2386990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387007 */     // GIR_Coverage, 59127,
     /* 2387007 */     GIR_EraseRootFromParent_Done,
     /* 2387008 */   // Label 33908: @2387008
     /* 2387008 */   GIM_Reject,
     /* 2387009 */ // Label 33906: @2387009
     /* 2387009 */ GIM_Reject,
     /* 2387010 */ // Label 33863: @2387010
     /* 2387010 */ GIM_Try, /*On fail goto*//*Label 33909*/ GIMT_Encode4(2387113),
     /* 2387015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2387018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387026 */   GIM_Try, /*On fail goto*//*Label 33910*/ GIMT_Encode4(2387069), // Rule ID 59092 //
     /* 2387031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2387034 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2387037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2387051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387068 */     // GIR_Coverage, 59092,
     /* 2387068 */     GIR_EraseRootFromParent_Done,
     /* 2387069 */   // Label 33910: @2387069
     /* 2387069 */   GIM_Try, /*On fail goto*//*Label 33911*/ GIMT_Encode4(2387112), // Rule ID 59093 //
     /* 2387074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2387077 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2387080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2387094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387111 */     // GIR_Coverage, 59093,
     /* 2387111 */     GIR_EraseRootFromParent_Done,
     /* 2387112 */   // Label 33911: @2387112
     /* 2387112 */   GIM_Reject,
     /* 2387113 */ // Label 33909: @2387113
     /* 2387113 */ GIM_Reject,
     /* 2387114 */ // Label 33864: @2387114
     /* 2387114 */ GIM_Try, /*On fail goto*//*Label 33912*/ GIMT_Encode4(2387217),
     /* 2387119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2387122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387130 */   GIM_Try, /*On fail goto*//*Label 33913*/ GIMT_Encode4(2387173), // Rule ID 59102 //
     /* 2387135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2387138 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2387141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2387155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387172 */     // GIR_Coverage, 59102,
     /* 2387172 */     GIR_EraseRootFromParent_Done,
     /* 2387173 */   // Label 33913: @2387173
     /* 2387173 */   GIM_Try, /*On fail goto*//*Label 33914*/ GIMT_Encode4(2387216), // Rule ID 59103 //
     /* 2387178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2387181 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2387184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2387198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387215 */     // GIR_Coverage, 59103,
     /* 2387215 */     GIR_EraseRootFromParent_Done,
     /* 2387216 */   // Label 33914: @2387216
     /* 2387216 */   GIM_Reject,
     /* 2387217 */ // Label 33912: @2387217
     /* 2387217 */ GIM_Reject,
     /* 2387218 */ // Label 33865: @2387218
     /* 2387218 */ GIM_Try, /*On fail goto*//*Label 33915*/ GIMT_Encode4(2387321),
     /* 2387223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2387226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387234 */   GIM_Try, /*On fail goto*//*Label 33916*/ GIMT_Encode4(2387277), // Rule ID 59120 //
     /* 2387239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2387242 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2387245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2387259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387276 */     // GIR_Coverage, 59120,
     /* 2387276 */     GIR_EraseRootFromParent_Done,
     /* 2387277 */   // Label 33916: @2387277
     /* 2387277 */   GIM_Try, /*On fail goto*//*Label 33917*/ GIMT_Encode4(2387320), // Rule ID 59121 //
     /* 2387282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2387285 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2387288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2387302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387319 */     // GIR_Coverage, 59121,
     /* 2387319 */     GIR_EraseRootFromParent_Done,
     /* 2387320 */   // Label 33917: @2387320
     /* 2387320 */   GIM_Reject,
     /* 2387321 */ // Label 33915: @2387321
     /* 2387321 */ GIM_Reject,
     /* 2387322 */ // Label 33866: @2387322
     /* 2387322 */ GIM_Try, /*On fail goto*//*Label 33918*/ GIMT_Encode4(2387425),
     /* 2387327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2387330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387338 */   GIM_Try, /*On fail goto*//*Label 33919*/ GIMT_Encode4(2387381), // Rule ID 59128 //
     /* 2387343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2387346 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2387349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2387363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387380 */     // GIR_Coverage, 59128,
     /* 2387380 */     GIR_EraseRootFromParent_Done,
     /* 2387381 */   // Label 33919: @2387381
     /* 2387381 */   GIM_Try, /*On fail goto*//*Label 33920*/ GIMT_Encode4(2387424), // Rule ID 59129 //
     /* 2387386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2387389 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2387392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2387406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387423 */     // GIR_Coverage, 59129,
     /* 2387423 */     GIR_EraseRootFromParent_Done,
     /* 2387424 */   // Label 33920: @2387424
     /* 2387424 */   GIM_Reject,
     /* 2387425 */ // Label 33918: @2387425
     /* 2387425 */ GIM_Reject,
     /* 2387426 */ // Label 33867: @2387426
     /* 2387426 */ GIM_Try, /*On fail goto*//*Label 33921*/ GIMT_Encode4(2387529),
     /* 2387431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2387434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387442 */   GIM_Try, /*On fail goto*//*Label 33922*/ GIMT_Encode4(2387485), // Rule ID 59100 //
     /* 2387447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2387450 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2387453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2387467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387484 */     // GIR_Coverage, 59100,
     /* 2387484 */     GIR_EraseRootFromParent_Done,
     /* 2387485 */   // Label 33922: @2387485
     /* 2387485 */   GIM_Try, /*On fail goto*//*Label 33923*/ GIMT_Encode4(2387528), // Rule ID 59101 //
     /* 2387490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2387493 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2387496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2387510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387527 */     // GIR_Coverage, 59101,
     /* 2387527 */     GIR_EraseRootFromParent_Done,
     /* 2387528 */   // Label 33923: @2387528
     /* 2387528 */   GIM_Reject,
     /* 2387529 */ // Label 33921: @2387529
     /* 2387529 */ GIM_Reject,
     /* 2387530 */ // Label 33868: @2387530
     /* 2387530 */ GIM_Try, /*On fail goto*//*Label 33924*/ GIMT_Encode4(2387633),
     /* 2387535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2387538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387546 */   GIM_Try, /*On fail goto*//*Label 33925*/ GIMT_Encode4(2387589), // Rule ID 59114 //
     /* 2387551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2387554 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2387557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2387571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387588 */     // GIR_Coverage, 59114,
     /* 2387588 */     GIR_EraseRootFromParent_Done,
     /* 2387589 */   // Label 33925: @2387589
     /* 2387589 */   GIM_Try, /*On fail goto*//*Label 33926*/ GIMT_Encode4(2387632), // Rule ID 59115 //
     /* 2387594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2387597 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2387600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2387614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387631 */     // GIR_Coverage, 59115,
     /* 2387631 */     GIR_EraseRootFromParent_Done,
     /* 2387632 */   // Label 33926: @2387632
     /* 2387632 */   GIM_Reject,
     /* 2387633 */ // Label 33924: @2387633
     /* 2387633 */ GIM_Reject,
     /* 2387634 */ // Label 33869: @2387634
     /* 2387634 */ GIM_Try, /*On fail goto*//*Label 33927*/ GIMT_Encode4(2387737),
     /* 2387639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2387642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387650 */   GIM_Try, /*On fail goto*//*Label 33928*/ GIMT_Encode4(2387693), // Rule ID 59122 //
     /* 2387655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2387658 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2387661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2387675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387692 */     // GIR_Coverage, 59122,
     /* 2387692 */     GIR_EraseRootFromParent_Done,
     /* 2387693 */   // Label 33928: @2387693
     /* 2387693 */   GIM_Try, /*On fail goto*//*Label 33929*/ GIMT_Encode4(2387736), // Rule ID 59123 //
     /* 2387698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2387701 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2387704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2387718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387735 */     // GIR_Coverage, 59123,
     /* 2387735 */     GIR_EraseRootFromParent_Done,
     /* 2387736 */   // Label 33929: @2387736
     /* 2387736 */   GIM_Reject,
     /* 2387737 */ // Label 33927: @2387737
     /* 2387737 */ GIM_Reject,
     /* 2387738 */ // Label 33870: @2387738
     /* 2387738 */ GIM_Try, /*On fail goto*//*Label 33930*/ GIMT_Encode4(2387841),
     /* 2387743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2387746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387754 */   GIM_Try, /*On fail goto*//*Label 33931*/ GIMT_Encode4(2387797), // Rule ID 59130 //
     /* 2387759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2387762 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2387765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2387779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387796 */     // GIR_Coverage, 59130,
     /* 2387796 */     GIR_EraseRootFromParent_Done,
     /* 2387797 */   // Label 33931: @2387797
     /* 2387797 */   GIM_Try, /*On fail goto*//*Label 33932*/ GIMT_Encode4(2387840), // Rule ID 59131 //
     /* 2387802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2387805 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2387808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2387822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387839 */     // GIR_Coverage, 59131,
     /* 2387839 */     GIR_EraseRootFromParent_Done,
     /* 2387840 */   // Label 33932: @2387840
     /* 2387840 */   GIM_Reject,
     /* 2387841 */ // Label 33930: @2387841
     /* 2387841 */ GIM_Reject,
     /* 2387842 */ // Label 33871: @2387842
     /* 2387842 */ GIM_Try, /*On fail goto*//*Label 33933*/ GIMT_Encode4(2387945),
     /* 2387847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2387850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387858 */   GIM_Try, /*On fail goto*//*Label 33934*/ GIMT_Encode4(2387901), // Rule ID 59108 //
     /* 2387863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2387866 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2387869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2387883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387900 */     // GIR_Coverage, 59108,
     /* 2387900 */     GIR_EraseRootFromParent_Done,
     /* 2387901 */   // Label 33934: @2387901
     /* 2387901 */   GIM_Try, /*On fail goto*//*Label 33935*/ GIMT_Encode4(2387944), // Rule ID 59109 //
     /* 2387906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2387909 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2387912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2387926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387943 */     // GIR_Coverage, 59109,
     /* 2387943 */     GIR_EraseRootFromParent_Done,
     /* 2387944 */   // Label 33935: @2387944
     /* 2387944 */   GIM_Reject,
     /* 2387945 */ // Label 33933: @2387945
     /* 2387945 */ GIM_Reject,
     /* 2387946 */ // Label 33872: @2387946
     /* 2387946 */ GIM_Try, /*On fail goto*//*Label 33936*/ GIMT_Encode4(2388049),
     /* 2387951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2387954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387962 */   GIM_Try, /*On fail goto*//*Label 33937*/ GIMT_Encode4(2388005), // Rule ID 59116 //
     /* 2387967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2387970 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2387973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2387987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388004 */     // GIR_Coverage, 59116,
     /* 2388004 */     GIR_EraseRootFromParent_Done,
     /* 2388005 */   // Label 33937: @2388005
     /* 2388005 */   GIM_Try, /*On fail goto*//*Label 33938*/ GIMT_Encode4(2388048), // Rule ID 59117 //
     /* 2388010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2388013 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2388016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2388030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388047 */     // GIR_Coverage, 59117,
     /* 2388047 */     GIR_EraseRootFromParent_Done,
     /* 2388048 */   // Label 33938: @2388048
     /* 2388048 */   GIM_Reject,
     /* 2388049 */ // Label 33936: @2388049
     /* 2388049 */ GIM_Reject,
     /* 2388050 */ // Label 33873: @2388050
     /* 2388050 */ GIM_Try, /*On fail goto*//*Label 33939*/ GIMT_Encode4(2388153),
     /* 2388055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2388058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388066 */   GIM_Try, /*On fail goto*//*Label 33940*/ GIMT_Encode4(2388109), // Rule ID 59124 //
     /* 2388071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2388074 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2388077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2388091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388108 */     // GIR_Coverage, 59124,
     /* 2388108 */     GIR_EraseRootFromParent_Done,
     /* 2388109 */   // Label 33940: @2388109
     /* 2388109 */   GIM_Try, /*On fail goto*//*Label 33941*/ GIMT_Encode4(2388152), // Rule ID 59125 //
     /* 2388114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2388117 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2388120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2388134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388151 */     // GIR_Coverage, 59125,
     /* 2388151 */     GIR_EraseRootFromParent_Done,
     /* 2388152 */   // Label 33941: @2388152
     /* 2388152 */   GIM_Reject,
     /* 2388153 */ // Label 33939: @2388153
     /* 2388153 */ GIM_Reject,
     /* 2388154 */ // Label 33874: @2388154
     /* 2388154 */ GIM_Try, /*On fail goto*//*Label 33942*/ GIMT_Encode4(2388257),
     /* 2388159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2388162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388170 */   GIM_Try, /*On fail goto*//*Label 33943*/ GIMT_Encode4(2388213), // Rule ID 59110 //
     /* 2388175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2388178 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2388181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2388195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388212 */     // GIR_Coverage, 59110,
     /* 2388212 */     GIR_EraseRootFromParent_Done,
     /* 2388213 */   // Label 33943: @2388213
     /* 2388213 */   GIM_Try, /*On fail goto*//*Label 33944*/ GIMT_Encode4(2388256), // Rule ID 59111 //
     /* 2388218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2388221 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2388224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2388238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388255 */     // GIR_Coverage, 59111,
     /* 2388255 */     GIR_EraseRootFromParent_Done,
     /* 2388256 */   // Label 33944: @2388256
     /* 2388256 */   GIM_Reject,
     /* 2388257 */ // Label 33942: @2388257
     /* 2388257 */ GIM_Reject,
     /* 2388258 */ // Label 33875: @2388258
     /* 2388258 */ GIM_Try, /*On fail goto*//*Label 33945*/ GIMT_Encode4(2388361),
     /* 2388263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2388266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388274 */   GIM_Try, /*On fail goto*//*Label 33946*/ GIMT_Encode4(2388317), // Rule ID 59118 //
     /* 2388279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2388282 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2388285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2388299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388316 */     // GIR_Coverage, 59118,
     /* 2388316 */     GIR_EraseRootFromParent_Done,
     /* 2388317 */   // Label 33946: @2388317
     /* 2388317 */   GIM_Try, /*On fail goto*//*Label 33947*/ GIMT_Encode4(2388360), // Rule ID 59119 //
     /* 2388322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2388325 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2388328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2388342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388359 */     // GIR_Coverage, 59119,
     /* 2388359 */     GIR_EraseRootFromParent_Done,
     /* 2388360 */   // Label 33947: @2388360
     /* 2388360 */   GIM_Reject,
     /* 2388361 */ // Label 33945: @2388361
     /* 2388361 */ GIM_Reject,
     /* 2388362 */ // Label 33876: @2388362
     /* 2388362 */ GIM_Try, /*On fail goto*//*Label 33948*/ GIMT_Encode4(2388465),
     /* 2388367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2388370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388378 */   GIM_Try, /*On fail goto*//*Label 33949*/ GIMT_Encode4(2388421), // Rule ID 59112 //
     /* 2388383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2388386 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2388389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2388403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388420 */     // GIR_Coverage, 59112,
     /* 2388420 */     GIR_EraseRootFromParent_Done,
     /* 2388421 */   // Label 33949: @2388421
     /* 2388421 */   GIM_Try, /*On fail goto*//*Label 33950*/ GIMT_Encode4(2388464), // Rule ID 59113 //
     /* 2388426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2388429 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2388432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2388446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388463 */     // GIR_Coverage, 59113,
     /* 2388463 */     GIR_EraseRootFromParent_Done,
     /* 2388464 */   // Label 33950: @2388464
     /* 2388464 */   GIM_Reject,
     /* 2388465 */ // Label 33948: @2388465
     /* 2388465 */ GIM_Reject,
     /* 2388466 */ // Label 33877: @2388466
     /* 2388466 */ GIM_Reject,
     /* 2388467 */ // Label 92: @2388467
     /* 2388467 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33975*/ GIMT_Encode4(2390960),
     /* 2388478 */ /*GILLT_s32*//*Label 33951*/ GIMT_Encode4(2388602),
     /* 2388482 */ /*GILLT_s64*//*Label 33952*/ GIMT_Encode4(2388637), GIMT_Encode4(0),
     /* 2388490 */ /*GILLT_nxv1s8*//*Label 33953*/ GIMT_Encode4(2388672),
     /* 2388494 */ /*GILLT_nxv1s16*//*Label 33954*/ GIMT_Encode4(2388776),
     /* 2388498 */ /*GILLT_nxv1s32*//*Label 33955*/ GIMT_Encode4(2388880),
     /* 2388502 */ /*GILLT_nxv1s64*//*Label 33956*/ GIMT_Encode4(2388984), GIMT_Encode4(0),
     /* 2388510 */ /*GILLT_nxv2s8*//*Label 33957*/ GIMT_Encode4(2389088),
     /* 2388514 */ /*GILLT_nxv2s16*//*Label 33958*/ GIMT_Encode4(2389192),
     /* 2388518 */ /*GILLT_nxv2s32*//*Label 33959*/ GIMT_Encode4(2389296),
     /* 2388522 */ /*GILLT_nxv2s64*//*Label 33960*/ GIMT_Encode4(2389400), GIMT_Encode4(0),
     /* 2388530 */ /*GILLT_nxv4s8*//*Label 33961*/ GIMT_Encode4(2389504),
     /* 2388534 */ /*GILLT_nxv4s16*//*Label 33962*/ GIMT_Encode4(2389608),
     /* 2388538 */ /*GILLT_nxv4s32*//*Label 33963*/ GIMT_Encode4(2389712),
     /* 2388542 */ /*GILLT_nxv4s64*//*Label 33964*/ GIMT_Encode4(2389816), GIMT_Encode4(0),
     /* 2388550 */ /*GILLT_nxv8s8*//*Label 33965*/ GIMT_Encode4(2389920),
     /* 2388554 */ /*GILLT_nxv8s16*//*Label 33966*/ GIMT_Encode4(2390024),
     /* 2388558 */ /*GILLT_nxv8s32*//*Label 33967*/ GIMT_Encode4(2390128),
     /* 2388562 */ /*GILLT_nxv8s64*//*Label 33968*/ GIMT_Encode4(2390232), GIMT_Encode4(0),
     /* 2388570 */ /*GILLT_nxv16s8*//*Label 33969*/ GIMT_Encode4(2390336),
     /* 2388574 */ /*GILLT_nxv16s16*//*Label 33970*/ GIMT_Encode4(2390440),
     /* 2388578 */ /*GILLT_nxv16s32*//*Label 33971*/ GIMT_Encode4(2390544), GIMT_Encode4(0),
     /* 2388586 */ /*GILLT_nxv32s8*//*Label 33972*/ GIMT_Encode4(2390648),
     /* 2388590 */ /*GILLT_nxv32s16*//*Label 33973*/ GIMT_Encode4(2390752), GIMT_Encode4(0),
     /* 2388598 */ /*GILLT_nxv64s8*//*Label 33974*/ GIMT_Encode4(2390856),
     /* 2388602 */ // Label 33951: @2388602
     /* 2388602 */ GIM_Try, /*On fail goto*//*Label 33976*/ GIMT_Encode4(2388636), // Rule ID 64441 //
     /* 2388607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2388610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2388617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2388621 */   // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$rs)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2388621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2388624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388626 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2388628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2388631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2388634 */   GIR_RootConstrainSelectedInstOperands,
     /* 2388635 */   // GIR_Coverage, 64441,
     /* 2388635 */   GIR_EraseRootFromParent_Done,
     /* 2388636 */ // Label 33976: @2388636
     /* 2388636 */ GIM_Reject,
     /* 2388637 */ // Label 33952: @2388637
     /* 2388637 */ GIM_Try, /*On fail goto*//*Label 33977*/ GIMT_Encode4(2388671), // Rule ID 64440 //
     /* 2388642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2388645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2388648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2388652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2388656 */   // (bitreverse:{ *:[i64] } GPR:{ *:[i64] }:$rs)  =>  (CV_BITREV:{ *:[i64] } GPR:{ *:[i64] }:$rs, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2388656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2388659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388661 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2388663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2388666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2388669 */   GIR_RootConstrainSelectedInstOperands,
     /* 2388670 */   // GIR_Coverage, 64440,
     /* 2388670 */   GIR_EraseRootFromParent_Done,
     /* 2388671 */ // Label 33977: @2388671
     /* 2388671 */ GIM_Reject,
     /* 2388672 */ // Label 33953: @2388672
     /* 2388672 */ GIM_Try, /*On fail goto*//*Label 33978*/ GIMT_Encode4(2388775),
     /* 2388677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2388680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388688 */   GIM_Try, /*On fail goto*//*Label 33979*/ GIMT_Encode4(2388731), // Rule ID 58912 //
     /* 2388693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388696 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2388699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2388713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388730 */     // GIR_Coverage, 58912,
     /* 2388730 */     GIR_EraseRootFromParent_Done,
     /* 2388731 */   // Label 33979: @2388731
     /* 2388731 */   GIM_Try, /*On fail goto*//*Label 33980*/ GIMT_Encode4(2388774), // Rule ID 58913 //
     /* 2388736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388739 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2388742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2388756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388773 */     // GIR_Coverage, 58913,
     /* 2388773 */     GIR_EraseRootFromParent_Done,
     /* 2388774 */   // Label 33980: @2388774
     /* 2388774 */   GIM_Reject,
     /* 2388775 */ // Label 33978: @2388775
     /* 2388775 */ GIM_Reject,
     /* 2388776 */ // Label 33954: @2388776
     /* 2388776 */ GIM_Try, /*On fail goto*//*Label 33981*/ GIMT_Encode4(2388879),
     /* 2388781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2388784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388792 */   GIM_Try, /*On fail goto*//*Label 33982*/ GIMT_Encode4(2388835), // Rule ID 59050 //
     /* 2388797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388800 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2388803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2388817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388834 */     // GIR_Coverage, 59050,
     /* 2388834 */     GIR_EraseRootFromParent_Done,
     /* 2388835 */   // Label 33982: @2388835
     /* 2388835 */   GIM_Try, /*On fail goto*//*Label 33983*/ GIMT_Encode4(2388878), // Rule ID 59051 //
     /* 2388840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388843 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2388846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2388860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388877 */     // GIR_Coverage, 59051,
     /* 2388877 */     GIR_EraseRootFromParent_Done,
     /* 2388878 */   // Label 33983: @2388878
     /* 2388878 */   GIM_Reject,
     /* 2388879 */ // Label 33981: @2388879
     /* 2388879 */ GIM_Reject,
     /* 2388880 */ // Label 33955: @2388880
     /* 2388880 */ GIM_Try, /*On fail goto*//*Label 33984*/ GIMT_Encode4(2388983),
     /* 2388885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2388888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388896 */   GIM_Try, /*On fail goto*//*Label 33985*/ GIMT_Encode4(2388939), // Rule ID 59054 //
     /* 2388901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388904 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2388907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2388921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388938 */     // GIR_Coverage, 59054,
     /* 2388938 */     GIR_EraseRootFromParent_Done,
     /* 2388939 */   // Label 33985: @2388939
     /* 2388939 */   GIM_Try, /*On fail goto*//*Label 33986*/ GIMT_Encode4(2388982), // Rule ID 59055 //
     /* 2388944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388947 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2388950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2388964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388981 */     // GIR_Coverage, 59055,
     /* 2388981 */     GIR_EraseRootFromParent_Done,
     /* 2388982 */   // Label 33986: @2388982
     /* 2388982 */   GIM_Reject,
     /* 2388983 */ // Label 33984: @2388983
     /* 2388983 */ GIM_Reject,
     /* 2388984 */ // Label 33956: @2388984
     /* 2388984 */ GIM_Try, /*On fail goto*//*Label 33987*/ GIMT_Encode4(2389087),
     /* 2388989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2388992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389000 */   GIM_Try, /*On fail goto*//*Label 33988*/ GIMT_Encode4(2389043), // Rule ID 59062 //
     /* 2389005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2389008 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2389011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2389025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389042 */     // GIR_Coverage, 59062,
     /* 2389042 */     GIR_EraseRootFromParent_Done,
     /* 2389043 */   // Label 33988: @2389043
     /* 2389043 */   GIM_Try, /*On fail goto*//*Label 33989*/ GIMT_Encode4(2389086), // Rule ID 59063 //
     /* 2389048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2389051 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2389054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2389068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389085 */     // GIR_Coverage, 59063,
     /* 2389085 */     GIR_EraseRootFromParent_Done,
     /* 2389086 */   // Label 33989: @2389086
     /* 2389086 */   GIM_Reject,
     /* 2389087 */ // Label 33987: @2389087
     /* 2389087 */ GIM_Reject,
     /* 2389088 */ // Label 33957: @2389088
     /* 2389088 */ GIM_Try, /*On fail goto*//*Label 33990*/ GIMT_Encode4(2389191),
     /* 2389093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2389096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389104 */   GIM_Try, /*On fail goto*//*Label 33991*/ GIMT_Encode4(2389147), // Rule ID 59046 //
     /* 2389109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389112 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2389115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2389129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389146 */     // GIR_Coverage, 59046,
     /* 2389146 */     GIR_EraseRootFromParent_Done,
     /* 2389147 */   // Label 33991: @2389147
     /* 2389147 */   GIM_Try, /*On fail goto*//*Label 33992*/ GIMT_Encode4(2389190), // Rule ID 59047 //
     /* 2389152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389155 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2389158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2389172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389189 */     // GIR_Coverage, 59047,
     /* 2389189 */     GIR_EraseRootFromParent_Done,
     /* 2389190 */   // Label 33992: @2389190
     /* 2389190 */   GIM_Reject,
     /* 2389191 */ // Label 33990: @2389191
     /* 2389191 */ GIM_Reject,
     /* 2389192 */ // Label 33958: @2389192
     /* 2389192 */ GIM_Try, /*On fail goto*//*Label 33993*/ GIMT_Encode4(2389295),
     /* 2389197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2389200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389208 */   GIM_Try, /*On fail goto*//*Label 33994*/ GIMT_Encode4(2389251), // Rule ID 59052 //
     /* 2389213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389216 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2389219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2389233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389250 */     // GIR_Coverage, 59052,
     /* 2389250 */     GIR_EraseRootFromParent_Done,
     /* 2389251 */   // Label 33994: @2389251
     /* 2389251 */   GIM_Try, /*On fail goto*//*Label 33995*/ GIMT_Encode4(2389294), // Rule ID 59053 //
     /* 2389256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389259 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2389262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2389276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389293 */     // GIR_Coverage, 59053,
     /* 2389293 */     GIR_EraseRootFromParent_Done,
     /* 2389294 */   // Label 33995: @2389294
     /* 2389294 */   GIM_Reject,
     /* 2389295 */ // Label 33993: @2389295
     /* 2389295 */ GIM_Reject,
     /* 2389296 */ // Label 33959: @2389296
     /* 2389296 */ GIM_Try, /*On fail goto*//*Label 33996*/ GIMT_Encode4(2389399),
     /* 2389301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2389304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389312 */   GIM_Try, /*On fail goto*//*Label 33997*/ GIMT_Encode4(2389355), // Rule ID 59060 //
     /* 2389317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389320 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2389323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2389337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389354 */     // GIR_Coverage, 59060,
     /* 2389354 */     GIR_EraseRootFromParent_Done,
     /* 2389355 */   // Label 33997: @2389355
     /* 2389355 */   GIM_Try, /*On fail goto*//*Label 33998*/ GIMT_Encode4(2389398), // Rule ID 59061 //
     /* 2389360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389363 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2389366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2389380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389397 */     // GIR_Coverage, 59061,
     /* 2389397 */     GIR_EraseRootFromParent_Done,
     /* 2389398 */   // Label 33998: @2389398
     /* 2389398 */   GIM_Reject,
     /* 2389399 */ // Label 33996: @2389399
     /* 2389399 */ GIM_Reject,
     /* 2389400 */ // Label 33960: @2389400
     /* 2389400 */ GIM_Try, /*On fail goto*//*Label 33999*/ GIMT_Encode4(2389503),
     /* 2389405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2389408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389416 */   GIM_Try, /*On fail goto*//*Label 34000*/ GIMT_Encode4(2389459), // Rule ID 59082 //
     /* 2389421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2389424 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2389427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2389441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389458 */     // GIR_Coverage, 59082,
     /* 2389458 */     GIR_EraseRootFromParent_Done,
     /* 2389459 */   // Label 34000: @2389459
     /* 2389459 */   GIM_Try, /*On fail goto*//*Label 34001*/ GIMT_Encode4(2389502), // Rule ID 59083 //
     /* 2389464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2389467 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2389470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2389484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389501 */     // GIR_Coverage, 59083,
     /* 2389501 */     GIR_EraseRootFromParent_Done,
     /* 2389502 */   // Label 34001: @2389502
     /* 2389502 */   GIM_Reject,
     /* 2389503 */ // Label 33999: @2389503
     /* 2389503 */ GIM_Reject,
     /* 2389504 */ // Label 33961: @2389504
     /* 2389504 */ GIM_Try, /*On fail goto*//*Label 34002*/ GIMT_Encode4(2389607),
     /* 2389509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2389512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389520 */   GIM_Try, /*On fail goto*//*Label 34003*/ GIMT_Encode4(2389563), // Rule ID 59048 //
     /* 2389525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389528 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2389531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2389545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389562 */     // GIR_Coverage, 59048,
     /* 2389562 */     GIR_EraseRootFromParent_Done,
     /* 2389563 */   // Label 34003: @2389563
     /* 2389563 */   GIM_Try, /*On fail goto*//*Label 34004*/ GIMT_Encode4(2389606), // Rule ID 59049 //
     /* 2389568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389571 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2389574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2389588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389605 */     // GIR_Coverage, 59049,
     /* 2389605 */     GIR_EraseRootFromParent_Done,
     /* 2389606 */   // Label 34004: @2389606
     /* 2389606 */   GIM_Reject,
     /* 2389607 */ // Label 34002: @2389607
     /* 2389607 */ GIM_Reject,
     /* 2389608 */ // Label 33962: @2389608
     /* 2389608 */ GIM_Try, /*On fail goto*//*Label 34005*/ GIMT_Encode4(2389711),
     /* 2389613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2389616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389624 */   GIM_Try, /*On fail goto*//*Label 34006*/ GIMT_Encode4(2389667), // Rule ID 59058 //
     /* 2389629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389632 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2389635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2389649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389666 */     // GIR_Coverage, 59058,
     /* 2389666 */     GIR_EraseRootFromParent_Done,
     /* 2389667 */   // Label 34006: @2389667
     /* 2389667 */   GIM_Try, /*On fail goto*//*Label 34007*/ GIMT_Encode4(2389710), // Rule ID 59059 //
     /* 2389672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389675 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2389678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2389692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389709 */     // GIR_Coverage, 59059,
     /* 2389709 */     GIR_EraseRootFromParent_Done,
     /* 2389710 */   // Label 34007: @2389710
     /* 2389710 */   GIM_Reject,
     /* 2389711 */ // Label 34005: @2389711
     /* 2389711 */ GIM_Reject,
     /* 2389712 */ // Label 33963: @2389712
     /* 2389712 */ GIM_Try, /*On fail goto*//*Label 34008*/ GIMT_Encode4(2389815),
     /* 2389717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2389720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389728 */   GIM_Try, /*On fail goto*//*Label 34009*/ GIMT_Encode4(2389771), // Rule ID 59076 //
     /* 2389733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389736 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2389739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2389753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389770 */     // GIR_Coverage, 59076,
     /* 2389770 */     GIR_EraseRootFromParent_Done,
     /* 2389771 */   // Label 34009: @2389771
     /* 2389771 */   GIM_Try, /*On fail goto*//*Label 34010*/ GIMT_Encode4(2389814), // Rule ID 59077 //
     /* 2389776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389779 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2389782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2389796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389813 */     // GIR_Coverage, 59077,
     /* 2389813 */     GIR_EraseRootFromParent_Done,
     /* 2389814 */   // Label 34010: @2389814
     /* 2389814 */   GIM_Reject,
     /* 2389815 */ // Label 34008: @2389815
     /* 2389815 */ GIM_Reject,
     /* 2389816 */ // Label 33964: @2389816
     /* 2389816 */ GIM_Try, /*On fail goto*//*Label 34011*/ GIMT_Encode4(2389919),
     /* 2389821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2389824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389832 */   GIM_Try, /*On fail goto*//*Label 34012*/ GIMT_Encode4(2389875), // Rule ID 59084 //
     /* 2389837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2389840 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2389843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2389857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389874 */     // GIR_Coverage, 59084,
     /* 2389874 */     GIR_EraseRootFromParent_Done,
     /* 2389875 */   // Label 34012: @2389875
     /* 2389875 */   GIM_Try, /*On fail goto*//*Label 34013*/ GIMT_Encode4(2389918), // Rule ID 59085 //
     /* 2389880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2389883 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2389886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2389900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389917 */     // GIR_Coverage, 59085,
     /* 2389917 */     GIR_EraseRootFromParent_Done,
     /* 2389918 */   // Label 34013: @2389918
     /* 2389918 */   GIM_Reject,
     /* 2389919 */ // Label 34011: @2389919
     /* 2389919 */ GIM_Reject,
     /* 2389920 */ // Label 33965: @2389920
     /* 2389920 */ GIM_Try, /*On fail goto*//*Label 34014*/ GIMT_Encode4(2390023),
     /* 2389925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2389928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389936 */   GIM_Try, /*On fail goto*//*Label 34015*/ GIMT_Encode4(2389979), // Rule ID 59056 //
     /* 2389941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389944 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2389947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2389961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389978 */     // GIR_Coverage, 59056,
     /* 2389978 */     GIR_EraseRootFromParent_Done,
     /* 2389979 */   // Label 34015: @2389979
     /* 2389979 */   GIM_Try, /*On fail goto*//*Label 34016*/ GIMT_Encode4(2390022), // Rule ID 59057 //
     /* 2389984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389987 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2389990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2390004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390021 */     // GIR_Coverage, 59057,
     /* 2390021 */     GIR_EraseRootFromParent_Done,
     /* 2390022 */   // Label 34016: @2390022
     /* 2390022 */   GIM_Reject,
     /* 2390023 */ // Label 34014: @2390023
     /* 2390023 */ GIM_Reject,
     /* 2390024 */ // Label 33966: @2390024
     /* 2390024 */ GIM_Try, /*On fail goto*//*Label 34017*/ GIMT_Encode4(2390127),
     /* 2390029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2390032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390040 */   GIM_Try, /*On fail goto*//*Label 34018*/ GIMT_Encode4(2390083), // Rule ID 59070 //
     /* 2390045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2390048 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2390051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2390065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390082 */     // GIR_Coverage, 59070,
     /* 2390082 */     GIR_EraseRootFromParent_Done,
     /* 2390083 */   // Label 34018: @2390083
     /* 2390083 */   GIM_Try, /*On fail goto*//*Label 34019*/ GIMT_Encode4(2390126), // Rule ID 59071 //
     /* 2390088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2390091 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2390094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2390108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390125 */     // GIR_Coverage, 59071,
     /* 2390125 */     GIR_EraseRootFromParent_Done,
     /* 2390126 */   // Label 34019: @2390126
     /* 2390126 */   GIM_Reject,
     /* 2390127 */ // Label 34017: @2390127
     /* 2390127 */ GIM_Reject,
     /* 2390128 */ // Label 33967: @2390128
     /* 2390128 */ GIM_Try, /*On fail goto*//*Label 34020*/ GIMT_Encode4(2390231),
     /* 2390133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2390136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390144 */   GIM_Try, /*On fail goto*//*Label 34021*/ GIMT_Encode4(2390187), // Rule ID 59078 //
     /* 2390149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2390152 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2390155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2390169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390186 */     // GIR_Coverage, 59078,
     /* 2390186 */     GIR_EraseRootFromParent_Done,
     /* 2390187 */   // Label 34021: @2390187
     /* 2390187 */   GIM_Try, /*On fail goto*//*Label 34022*/ GIMT_Encode4(2390230), // Rule ID 59079 //
     /* 2390192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2390195 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2390198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2390212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390229 */     // GIR_Coverage, 59079,
     /* 2390229 */     GIR_EraseRootFromParent_Done,
     /* 2390230 */   // Label 34022: @2390230
     /* 2390230 */   GIM_Reject,
     /* 2390231 */ // Label 34020: @2390231
     /* 2390231 */ GIM_Reject,
     /* 2390232 */ // Label 33968: @2390232
     /* 2390232 */ GIM_Try, /*On fail goto*//*Label 34023*/ GIMT_Encode4(2390335),
     /* 2390237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2390240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390248 */   GIM_Try, /*On fail goto*//*Label 34024*/ GIMT_Encode4(2390291), // Rule ID 59086 //
     /* 2390253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2390256 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2390259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2390273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390290 */     // GIR_Coverage, 59086,
     /* 2390290 */     GIR_EraseRootFromParent_Done,
     /* 2390291 */   // Label 34024: @2390291
     /* 2390291 */   GIM_Try, /*On fail goto*//*Label 34025*/ GIMT_Encode4(2390334), // Rule ID 59087 //
     /* 2390296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2390299 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2390302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2390316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390333 */     // GIR_Coverage, 59087,
     /* 2390333 */     GIR_EraseRootFromParent_Done,
     /* 2390334 */   // Label 34025: @2390334
     /* 2390334 */   GIM_Reject,
     /* 2390335 */ // Label 34023: @2390335
     /* 2390335 */ GIM_Reject,
     /* 2390336 */ // Label 33969: @2390336
     /* 2390336 */ GIM_Try, /*On fail goto*//*Label 34026*/ GIMT_Encode4(2390439),
     /* 2390341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2390344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390352 */   GIM_Try, /*On fail goto*//*Label 34027*/ GIMT_Encode4(2390395), // Rule ID 59064 //
     /* 2390357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2390360 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2390363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2390377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390394 */     // GIR_Coverage, 59064,
     /* 2390394 */     GIR_EraseRootFromParent_Done,
     /* 2390395 */   // Label 34027: @2390395
     /* 2390395 */   GIM_Try, /*On fail goto*//*Label 34028*/ GIMT_Encode4(2390438), // Rule ID 59065 //
     /* 2390400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2390403 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2390406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2390420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390437 */     // GIR_Coverage, 59065,
     /* 2390437 */     GIR_EraseRootFromParent_Done,
     /* 2390438 */   // Label 34028: @2390438
     /* 2390438 */   GIM_Reject,
     /* 2390439 */ // Label 34026: @2390439
     /* 2390439 */ GIM_Reject,
     /* 2390440 */ // Label 33970: @2390440
     /* 2390440 */ GIM_Try, /*On fail goto*//*Label 34029*/ GIMT_Encode4(2390543),
     /* 2390445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2390448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390456 */   GIM_Try, /*On fail goto*//*Label 34030*/ GIMT_Encode4(2390499), // Rule ID 59072 //
     /* 2390461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2390464 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2390467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2390481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390498 */     // GIR_Coverage, 59072,
     /* 2390498 */     GIR_EraseRootFromParent_Done,
     /* 2390499 */   // Label 34030: @2390499
     /* 2390499 */   GIM_Try, /*On fail goto*//*Label 34031*/ GIMT_Encode4(2390542), // Rule ID 59073 //
     /* 2390504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2390507 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2390510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2390524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390541 */     // GIR_Coverage, 59073,
     /* 2390541 */     GIR_EraseRootFromParent_Done,
     /* 2390542 */   // Label 34031: @2390542
     /* 2390542 */   GIM_Reject,
     /* 2390543 */ // Label 34029: @2390543
     /* 2390543 */ GIM_Reject,
     /* 2390544 */ // Label 33971: @2390544
     /* 2390544 */ GIM_Try, /*On fail goto*//*Label 34032*/ GIMT_Encode4(2390647),
     /* 2390549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2390552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390560 */   GIM_Try, /*On fail goto*//*Label 34033*/ GIMT_Encode4(2390603), // Rule ID 59080 //
     /* 2390565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2390568 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2390571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2390585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390602 */     // GIR_Coverage, 59080,
     /* 2390602 */     GIR_EraseRootFromParent_Done,
     /* 2390603 */   // Label 34033: @2390603
     /* 2390603 */   GIM_Try, /*On fail goto*//*Label 34034*/ GIMT_Encode4(2390646), // Rule ID 59081 //
     /* 2390608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2390611 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2390614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2390628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390645 */     // GIR_Coverage, 59081,
     /* 2390645 */     GIR_EraseRootFromParent_Done,
     /* 2390646 */   // Label 34034: @2390646
     /* 2390646 */   GIM_Reject,
     /* 2390647 */ // Label 34032: @2390647
     /* 2390647 */ GIM_Reject,
     /* 2390648 */ // Label 33972: @2390648
     /* 2390648 */ GIM_Try, /*On fail goto*//*Label 34035*/ GIMT_Encode4(2390751),
     /* 2390653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2390656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390664 */   GIM_Try, /*On fail goto*//*Label 34036*/ GIMT_Encode4(2390707), // Rule ID 59066 //
     /* 2390669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2390672 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2390675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2390689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390706 */     // GIR_Coverage, 59066,
     /* 2390706 */     GIR_EraseRootFromParent_Done,
     /* 2390707 */   // Label 34036: @2390707
     /* 2390707 */   GIM_Try, /*On fail goto*//*Label 34037*/ GIMT_Encode4(2390750), // Rule ID 59067 //
     /* 2390712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2390715 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2390718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2390732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390749 */     // GIR_Coverage, 59067,
     /* 2390749 */     GIR_EraseRootFromParent_Done,
     /* 2390750 */   // Label 34037: @2390750
     /* 2390750 */   GIM_Reject,
     /* 2390751 */ // Label 34035: @2390751
     /* 2390751 */ GIM_Reject,
     /* 2390752 */ // Label 33973: @2390752
     /* 2390752 */ GIM_Try, /*On fail goto*//*Label 34038*/ GIMT_Encode4(2390855),
     /* 2390757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2390760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390768 */   GIM_Try, /*On fail goto*//*Label 34039*/ GIMT_Encode4(2390811), // Rule ID 59074 //
     /* 2390773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2390776 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2390779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2390793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390810 */     // GIR_Coverage, 59074,
     /* 2390810 */     GIR_EraseRootFromParent_Done,
     /* 2390811 */   // Label 34039: @2390811
     /* 2390811 */   GIM_Try, /*On fail goto*//*Label 34040*/ GIMT_Encode4(2390854), // Rule ID 59075 //
     /* 2390816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2390819 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2390822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2390836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390853 */     // GIR_Coverage, 59075,
     /* 2390853 */     GIR_EraseRootFromParent_Done,
     /* 2390854 */   // Label 34040: @2390854
     /* 2390854 */   GIM_Reject,
     /* 2390855 */ // Label 34038: @2390855
     /* 2390855 */ GIM_Reject,
     /* 2390856 */ // Label 33974: @2390856
     /* 2390856 */ GIM_Try, /*On fail goto*//*Label 34041*/ GIMT_Encode4(2390959),
     /* 2390861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2390864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390872 */   GIM_Try, /*On fail goto*//*Label 34042*/ GIMT_Encode4(2390915), // Rule ID 59068 //
     /* 2390877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2390880 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2390883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2390897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390914 */     // GIR_Coverage, 59068,
     /* 2390914 */     GIR_EraseRootFromParent_Done,
     /* 2390915 */   // Label 34042: @2390915
     /* 2390915 */   GIM_Try, /*On fail goto*//*Label 34043*/ GIMT_Encode4(2390958), // Rule ID 59069 //
     /* 2390920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2390923 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2390926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2390940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390957 */     // GIR_Coverage, 59069,
     /* 2390957 */     GIR_EraseRootFromParent_Done,
     /* 2390958 */   // Label 34043: @2390958
     /* 2390958 */   GIM_Reject,
     /* 2390959 */ // Label 34041: @2390959
     /* 2390959 */ GIM_Reject,
     /* 2390960 */ // Label 33975: @2390960
     /* 2390960 */ GIM_Reject,
     /* 2390961 */ // Label 93: @2390961
     /* 2390961 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34047*/ GIMT_Encode4(2391158),
     /* 2390972 */ /*GILLT_s16*//*Label 34044*/ GIMT_Encode4(2390984),
     /* 2390976 */ /*GILLT_s32*//*Label 34045*/ GIMT_Encode4(2391042),
     /* 2390980 */ /*GILLT_s64*//*Label 34046*/ GIMT_Encode4(2391100),
     /* 2390984 */ // Label 34044: @2390984
     /* 2390984 */ GIM_Try, /*On fail goto*//*Label 34048*/ GIMT_Encode4(2391041),
     /* 2390989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391000 */   GIM_Try, /*On fail goto*//*Label 34049*/ GIMT_Encode4(2391020), // Rule ID 2422 //
     /* 2391005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2391008 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i64] })
     /* 2391008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2391011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391019 */     // GIR_Coverage, 2422,
     /* 2391019 */     GIR_EraseRootFromParent_Done,
     /* 2391020 */   // Label 34049: @2391020
     /* 2391020 */   GIM_Try, /*On fail goto*//*Label 34050*/ GIMT_Encode4(2391040), // Rule ID 2423 //
     /* 2391025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2391028 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i32] })
     /* 2391028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2391031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391039 */     // GIR_Coverage, 2423,
     /* 2391039 */     GIR_EraseRootFromParent_Done,
     /* 2391040 */   // Label 34050: @2391040
     /* 2391040 */   GIM_Reject,
     /* 2391041 */ // Label 34048: @2391041
     /* 2391041 */ GIM_Reject,
     /* 2391042 */ // Label 34045: @2391042
     /* 2391042 */ GIM_Try, /*On fail goto*//*Label 34051*/ GIMT_Encode4(2391099),
     /* 2391047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391058 */   GIM_Try, /*On fail goto*//*Label 34052*/ GIMT_Encode4(2391078), // Rule ID 2340 //
     /* 2391063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2391066 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i64] })
     /* 2391066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2391069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391077 */     // GIR_Coverage, 2340,
     /* 2391077 */     GIR_EraseRootFromParent_Done,
     /* 2391078 */   // Label 34052: @2391078
     /* 2391078 */   GIM_Try, /*On fail goto*//*Label 34053*/ GIMT_Encode4(2391098), // Rule ID 2341 //
     /* 2391083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2391086 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i32] })
     /* 2391086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2391089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391097 */     // GIR_Coverage, 2341,
     /* 2391097 */     GIR_EraseRootFromParent_Done,
     /* 2391098 */   // Label 34053: @2391098
     /* 2391098 */   GIM_Reject,
     /* 2391099 */ // Label 34051: @2391099
     /* 2391099 */ GIM_Reject,
     /* 2391100 */ // Label 34046: @2391100
     /* 2391100 */ GIM_Try, /*On fail goto*//*Label 34054*/ GIMT_Encode4(2391157),
     /* 2391105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2391108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391116 */   GIM_Try, /*On fail goto*//*Label 34055*/ GIMT_Encode4(2391136), // Rule ID 2380 //
     /* 2391121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2391124 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i64] })
     /* 2391124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2391127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391135 */     // GIR_Coverage, 2380,
     /* 2391135 */     GIR_EraseRootFromParent_Done,
     /* 2391136 */   // Label 34055: @2391136
     /* 2391136 */   GIM_Try, /*On fail goto*//*Label 34056*/ GIMT_Encode4(2391156), // Rule ID 2381 //
     /* 2391141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2391144 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i32] })
     /* 2391144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2391147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391155 */     // GIR_Coverage, 2381,
     /* 2391155 */     GIR_EraseRootFromParent_Done,
     /* 2391156 */   // Label 34056: @2391156
     /* 2391156 */   GIM_Reject,
     /* 2391157 */ // Label 34054: @2391157
     /* 2391157 */ GIM_Reject,
     /* 2391158 */ // Label 34047: @2391158
     /* 2391158 */ GIM_Reject,
     /* 2391159 */ // Label 94: @2391159
     /* 2391159 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34075*/ GIMT_Encode4(2393334),
     /* 2391170 */ /*GILLT_s16*//*Label 34057*/ GIMT_Encode4(2391290),
     /* 2391174 */ /*GILLT_s32*//*Label 34058*/ GIMT_Encode4(2391412),
     /* 2391178 */ /*GILLT_s64*//*Label 34059*/ GIMT_Encode4(2391534), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2391190 */ /*GILLT_nxv1s16*//*Label 34060*/ GIMT_Encode4(2391684),
     /* 2391194 */ /*GILLT_nxv1s32*//*Label 34061*/ GIMT_Encode4(2391794),
     /* 2391198 */ /*GILLT_nxv1s64*//*Label 34062*/ GIMT_Encode4(2391904), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2391210 */ /*GILLT_nxv2s16*//*Label 34063*/ GIMT_Encode4(2392014),
     /* 2391214 */ /*GILLT_nxv2s32*//*Label 34064*/ GIMT_Encode4(2392124),
     /* 2391218 */ /*GILLT_nxv2s64*//*Label 34065*/ GIMT_Encode4(2392234), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2391230 */ /*GILLT_nxv4s16*//*Label 34066*/ GIMT_Encode4(2392344),
     /* 2391234 */ /*GILLT_nxv4s32*//*Label 34067*/ GIMT_Encode4(2392454),
     /* 2391238 */ /*GILLT_nxv4s64*//*Label 34068*/ GIMT_Encode4(2392564), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2391250 */ /*GILLT_nxv8s16*//*Label 34069*/ GIMT_Encode4(2392674),
     /* 2391254 */ /*GILLT_nxv8s32*//*Label 34070*/ GIMT_Encode4(2392784),
     /* 2391258 */ /*GILLT_nxv8s64*//*Label 34071*/ GIMT_Encode4(2392894), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2391270 */ /*GILLT_nxv16s16*//*Label 34072*/ GIMT_Encode4(2393004),
     /* 2391274 */ /*GILLT_nxv16s32*//*Label 34073*/ GIMT_Encode4(2393114), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2391286 */ /*GILLT_nxv32s16*//*Label 34074*/ GIMT_Encode4(2393224),
     /* 2391290 */ // Label 34057: @2391290
     /* 2391290 */ GIM_Try, /*On fail goto*//*Label 34076*/ GIMT_Encode4(2391411),
     /* 2391295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391298 */   GIM_Try, /*On fail goto*//*Label 34077*/ GIMT_Encode4(2391326), // Rule ID 1980 //
     /* 2391303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2391306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391314 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2391314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2391317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391325 */     // GIR_Coverage, 1980,
     /* 2391325 */     GIR_EraseRootFromParent_Done,
     /* 2391326 */   // Label 34077: @2391326
     /* 2391326 */   GIM_Try, /*On fail goto*//*Label 34078*/ GIMT_Encode4(2391354), // Rule ID 1981 //
     /* 2391331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2391334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391342 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2391342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2391345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391353 */     // GIR_Coverage, 1981,
     /* 2391353 */     GIR_EraseRootFromParent_Done,
     /* 2391354 */   // Label 34078: @2391354
     /* 2391354 */   GIM_Try, /*On fail goto*//*Label 34079*/ GIMT_Encode4(2391382), // Rule ID 2013 //
     /* 2391359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2391362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391370 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2391370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2391373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391381 */     // GIR_Coverage, 2013,
     /* 2391381 */     GIR_EraseRootFromParent_Done,
     /* 2391382 */   // Label 34079: @2391382
     /* 2391382 */   GIM_Try, /*On fail goto*//*Label 34080*/ GIMT_Encode4(2391410), // Rule ID 2014 //
     /* 2391387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2391390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391398 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2391398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2391401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391409 */     // GIR_Coverage, 2014,
     /* 2391409 */     GIR_EraseRootFromParent_Done,
     /* 2391410 */   // Label 34080: @2391410
     /* 2391410 */   GIM_Reject,
     /* 2391411 */ // Label 34076: @2391411
     /* 2391411 */ GIM_Reject,
     /* 2391412 */ // Label 34058: @2391412
     /* 2391412 */ GIM_Try, /*On fail goto*//*Label 34081*/ GIMT_Encode4(2391533),
     /* 2391417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391420 */   GIM_Try, /*On fail goto*//*Label 34082*/ GIMT_Encode4(2391448), // Rule ID 1271 //
     /* 2391425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2391428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391436 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2391436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2391439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391447 */     // GIR_Coverage, 1271,
     /* 2391447 */     GIR_EraseRootFromParent_Done,
     /* 2391448 */   // Label 34082: @2391448
     /* 2391448 */   GIM_Try, /*On fail goto*//*Label 34083*/ GIMT_Encode4(2391476), // Rule ID 1272 //
     /* 2391453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2391456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391464 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2391464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2391467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391475 */     // GIR_Coverage, 1272,
     /* 2391475 */     GIR_EraseRootFromParent_Done,
     /* 2391476 */   // Label 34083: @2391476
     /* 2391476 */   GIM_Try, /*On fail goto*//*Label 34084*/ GIMT_Encode4(2391504), // Rule ID 1279 //
     /* 2391481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2391484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2391488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2391492 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2391492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2391495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391503 */     // GIR_Coverage, 1279,
     /* 2391503 */     GIR_EraseRootFromParent_Done,
     /* 2391504 */   // Label 34084: @2391504
     /* 2391504 */   GIM_Try, /*On fail goto*//*Label 34085*/ GIMT_Encode4(2391532), // Rule ID 1280 //
     /* 2391509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2391512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2391516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2391520 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2391520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2391523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391531 */     // GIR_Coverage, 1280,
     /* 2391531 */     GIR_EraseRootFromParent_Done,
     /* 2391532 */   // Label 34085: @2391532
     /* 2391532 */   GIM_Reject,
     /* 2391533 */ // Label 34081: @2391533
     /* 2391533 */ GIM_Reject,
     /* 2391534 */ // Label 34059: @2391534
     /* 2391534 */ GIM_Try, /*On fail goto*//*Label 34086*/ GIMT_Encode4(2391683),
     /* 2391539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2391542 */   GIM_Try, /*On fail goto*//*Label 34087*/ GIMT_Encode4(2391570), // Rule ID 1614 //
     /* 2391547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2391550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391558 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2391558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2391561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391569 */     // GIR_Coverage, 1614,
     /* 2391569 */     GIR_EraseRootFromParent_Done,
     /* 2391570 */   // Label 34087: @2391570
     /* 2391570 */   GIM_Try, /*On fail goto*//*Label 34088*/ GIMT_Encode4(2391598), // Rule ID 1615 //
     /* 2391575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2391578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391586 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2391586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2391589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391597 */     // GIR_Coverage, 1615,
     /* 2391597 */     GIR_EraseRootFromParent_Done,
     /* 2391598 */   // Label 34088: @2391598
     /* 2391598 */   GIM_Try, /*On fail goto*//*Label 34089*/ GIMT_Encode4(2391626), // Rule ID 1648 //
     /* 2391603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2391606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2391610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2391614 */     // (fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2391614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2391617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391625 */     // GIR_Coverage, 1648,
     /* 2391625 */     GIR_EraseRootFromParent_Done,
     /* 2391626 */   // Label 34089: @2391626
     /* 2391626 */   GIM_Try, /*On fail goto*//*Label 34090*/ GIMT_Encode4(2391654), // Rule ID 1669 //
     /* 2391631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2391634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2391638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2391642 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2391642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2391645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391653 */     // GIR_Coverage, 1669,
     /* 2391653 */     GIR_EraseRootFromParent_Done,
     /* 2391654 */   // Label 34090: @2391654
     /* 2391654 */   GIM_Try, /*On fail goto*//*Label 34091*/ GIMT_Encode4(2391682), // Rule ID 1670 //
     /* 2391659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2391662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2391666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2391670 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2391670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2391673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391681 */     // GIR_Coverage, 1670,
     /* 2391681 */     GIR_EraseRootFromParent_Done,
     /* 2391682 */   // Label 34091: @2391682
     /* 2391682 */   GIM_Reject,
     /* 2391683 */ // Label 34086: @2391683
     /* 2391683 */ GIM_Reject,
     /* 2391684 */ // Label 34060: @2391684
     /* 2391684 */ GIM_Try, /*On fail goto*//*Label 34092*/ GIMT_Encode4(2391793),
     /* 2391689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2391692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391700 */   GIM_Try, /*On fail goto*//*Label 34093*/ GIMT_Encode4(2391746), // Rule ID 56230 //
     /* 2391705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2391708 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2391711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2391725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391745 */     // GIR_Coverage, 56230,
     /* 2391745 */     GIR_EraseRootFromParent_Done,
     /* 2391746 */   // Label 34093: @2391746
     /* 2391746 */   GIM_Try, /*On fail goto*//*Label 34094*/ GIMT_Encode4(2391792), // Rule ID 56231 //
     /* 2391751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2391754 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2391757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2391771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391791 */     // GIR_Coverage, 56231,
     /* 2391791 */     GIR_EraseRootFromParent_Done,
     /* 2391792 */   // Label 34094: @2391792
     /* 2391792 */   GIM_Reject,
     /* 2391793 */ // Label 34092: @2391793
     /* 2391793 */ GIM_Reject,
     /* 2391794 */ // Label 34061: @2391794
     /* 2391794 */ GIM_Try, /*On fail goto*//*Label 34095*/ GIMT_Encode4(2391903),
     /* 2391799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391810 */   GIM_Try, /*On fail goto*//*Label 34096*/ GIMT_Encode4(2391856), // Rule ID 56270 //
     /* 2391815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2391818 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2391821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2391835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391855 */     // GIR_Coverage, 56270,
     /* 2391855 */     GIR_EraseRootFromParent_Done,
     /* 2391856 */   // Label 34096: @2391856
     /* 2391856 */   GIM_Try, /*On fail goto*//*Label 34097*/ GIMT_Encode4(2391902), // Rule ID 56271 //
     /* 2391861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2391864 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2391867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2391881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391901 */     // GIR_Coverage, 56271,
     /* 2391901 */     GIR_EraseRootFromParent_Done,
     /* 2391902 */   // Label 34097: @2391902
     /* 2391902 */   GIM_Reject,
     /* 2391903 */ // Label 34095: @2391903
     /* 2391903 */ GIM_Reject,
     /* 2391904 */ // Label 34062: @2391904
     /* 2391904 */ GIM_Try, /*On fail goto*//*Label 34098*/ GIMT_Encode4(2392013),
     /* 2391909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2391912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391920 */   GIM_Try, /*On fail goto*//*Label 34099*/ GIMT_Encode4(2391966), // Rule ID 56330 //
     /* 2391925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2391928 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2391931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2391945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2391961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391965 */     // GIR_Coverage, 56330,
     /* 2391965 */     GIR_EraseRootFromParent_Done,
     /* 2391966 */   // Label 34099: @2391966
     /* 2391966 */   GIM_Try, /*On fail goto*//*Label 34100*/ GIMT_Encode4(2392012), // Rule ID 56331 //
     /* 2391971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2391974 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2391977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2391991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392011 */     // GIR_Coverage, 56331,
     /* 2392011 */     GIR_EraseRootFromParent_Done,
     /* 2392012 */   // Label 34100: @2392012
     /* 2392012 */   GIM_Reject,
     /* 2392013 */ // Label 34098: @2392013
     /* 2392013 */ GIM_Reject,
     /* 2392014 */ // Label 34063: @2392014
     /* 2392014 */ GIM_Try, /*On fail goto*//*Label 34101*/ GIMT_Encode4(2392123),
     /* 2392019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2392022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392030 */   GIM_Try, /*On fail goto*//*Label 34102*/ GIMT_Encode4(2392076), // Rule ID 56250 //
     /* 2392035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2392038 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2392041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2392055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392075 */     // GIR_Coverage, 56250,
     /* 2392075 */     GIR_EraseRootFromParent_Done,
     /* 2392076 */   // Label 34102: @2392076
     /* 2392076 */   GIM_Try, /*On fail goto*//*Label 34103*/ GIMT_Encode4(2392122), // Rule ID 56251 //
     /* 2392081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2392084 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2392087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2392101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392121 */     // GIR_Coverage, 56251,
     /* 2392121 */     GIR_EraseRootFromParent_Done,
     /* 2392122 */   // Label 34103: @2392122
     /* 2392122 */   GIM_Reject,
     /* 2392123 */ // Label 34101: @2392123
     /* 2392123 */ GIM_Reject,
     /* 2392124 */ // Label 34064: @2392124
     /* 2392124 */ GIM_Try, /*On fail goto*//*Label 34104*/ GIMT_Encode4(2392233),
     /* 2392129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2392132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392140 */   GIM_Try, /*On fail goto*//*Label 34105*/ GIMT_Encode4(2392186), // Rule ID 56310 //
     /* 2392145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2392148 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2392151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2392165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392185 */     // GIR_Coverage, 56310,
     /* 2392185 */     GIR_EraseRootFromParent_Done,
     /* 2392186 */   // Label 34105: @2392186
     /* 2392186 */   GIM_Try, /*On fail goto*//*Label 34106*/ GIMT_Encode4(2392232), // Rule ID 56311 //
     /* 2392191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2392194 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2392197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2392211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392231 */     // GIR_Coverage, 56311,
     /* 2392231 */     GIR_EraseRootFromParent_Done,
     /* 2392232 */   // Label 34106: @2392232
     /* 2392232 */   GIM_Reject,
     /* 2392233 */ // Label 34104: @2392233
     /* 2392233 */ GIM_Reject,
     /* 2392234 */ // Label 34065: @2392234
     /* 2392234 */ GIM_Try, /*On fail goto*//*Label 34107*/ GIMT_Encode4(2392343),
     /* 2392239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2392242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2392246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2392250 */   GIM_Try, /*On fail goto*//*Label 34108*/ GIMT_Encode4(2392296), // Rule ID 56470 //
     /* 2392255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2392258 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2392261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2392275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392295 */     // GIR_Coverage, 56470,
     /* 2392295 */     GIR_EraseRootFromParent_Done,
     /* 2392296 */   // Label 34108: @2392296
     /* 2392296 */   GIM_Try, /*On fail goto*//*Label 34109*/ GIMT_Encode4(2392342), // Rule ID 56471 //
     /* 2392301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2392304 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2392307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2392321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392341 */     // GIR_Coverage, 56471,
     /* 2392341 */     GIR_EraseRootFromParent_Done,
     /* 2392342 */   // Label 34109: @2392342
     /* 2392342 */   GIM_Reject,
     /* 2392343 */ // Label 34107: @2392343
     /* 2392343 */ GIM_Reject,
     /* 2392344 */ // Label 34066: @2392344
     /* 2392344 */ GIM_Try, /*On fail goto*//*Label 34110*/ GIMT_Encode4(2392453),
     /* 2392349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2392352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392360 */   GIM_Try, /*On fail goto*//*Label 34111*/ GIMT_Encode4(2392406), // Rule ID 56290 //
     /* 2392365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2392368 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2392371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2392385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392405 */     // GIR_Coverage, 56290,
     /* 2392405 */     GIR_EraseRootFromParent_Done,
     /* 2392406 */   // Label 34111: @2392406
     /* 2392406 */   GIM_Try, /*On fail goto*//*Label 34112*/ GIMT_Encode4(2392452), // Rule ID 56291 //
     /* 2392411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2392414 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2392417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2392431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392451 */     // GIR_Coverage, 56291,
     /* 2392451 */     GIR_EraseRootFromParent_Done,
     /* 2392452 */   // Label 34112: @2392452
     /* 2392452 */   GIM_Reject,
     /* 2392453 */ // Label 34110: @2392453
     /* 2392453 */ GIM_Reject,
     /* 2392454 */ // Label 34067: @2392454
     /* 2392454 */ GIM_Try, /*On fail goto*//*Label 34113*/ GIMT_Encode4(2392563),
     /* 2392459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2392462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2392466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2392470 */   GIM_Try, /*On fail goto*//*Label 34114*/ GIMT_Encode4(2392516), // Rule ID 56410 //
     /* 2392475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2392478 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2392481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2392495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392515 */     // GIR_Coverage, 56410,
     /* 2392515 */     GIR_EraseRootFromParent_Done,
     /* 2392516 */   // Label 34114: @2392516
     /* 2392516 */   GIM_Try, /*On fail goto*//*Label 34115*/ GIMT_Encode4(2392562), // Rule ID 56411 //
     /* 2392521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2392524 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2392527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2392541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392561 */     // GIR_Coverage, 56411,
     /* 2392561 */     GIR_EraseRootFromParent_Done,
     /* 2392562 */   // Label 34115: @2392562
     /* 2392562 */   GIM_Reject,
     /* 2392563 */ // Label 34113: @2392563
     /* 2392563 */ GIM_Reject,
     /* 2392564 */ // Label 34068: @2392564
     /* 2392564 */ GIM_Try, /*On fail goto*//*Label 34116*/ GIMT_Encode4(2392673),
     /* 2392569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2392572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2392576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2392580 */   GIM_Try, /*On fail goto*//*Label 34117*/ GIMT_Encode4(2392626), // Rule ID 56490 //
     /* 2392585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2392588 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2392591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2392605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392625 */     // GIR_Coverage, 56490,
     /* 2392625 */     GIR_EraseRootFromParent_Done,
     /* 2392626 */   // Label 34117: @2392626
     /* 2392626 */   GIM_Try, /*On fail goto*//*Label 34118*/ GIMT_Encode4(2392672), // Rule ID 56491 //
     /* 2392631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2392634 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2392637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2392651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392671 */     // GIR_Coverage, 56491,
     /* 2392671 */     GIR_EraseRootFromParent_Done,
     /* 2392672 */   // Label 34118: @2392672
     /* 2392672 */   GIM_Reject,
     /* 2392673 */ // Label 34116: @2392673
     /* 2392673 */ GIM_Reject,
     /* 2392674 */ // Label 34069: @2392674
     /* 2392674 */ GIM_Try, /*On fail goto*//*Label 34119*/ GIMT_Encode4(2392783),
     /* 2392679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2392682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2392686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2392690 */   GIM_Try, /*On fail goto*//*Label 34120*/ GIMT_Encode4(2392736), // Rule ID 56350 //
     /* 2392695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2392698 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2392701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2392715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392735 */     // GIR_Coverage, 56350,
     /* 2392735 */     GIR_EraseRootFromParent_Done,
     /* 2392736 */   // Label 34120: @2392736
     /* 2392736 */   GIM_Try, /*On fail goto*//*Label 34121*/ GIMT_Encode4(2392782), // Rule ID 56351 //
     /* 2392741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2392744 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2392747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2392761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392781 */     // GIR_Coverage, 56351,
     /* 2392781 */     GIR_EraseRootFromParent_Done,
     /* 2392782 */   // Label 34121: @2392782
     /* 2392782 */   GIM_Reject,
     /* 2392783 */ // Label 34119: @2392783
     /* 2392783 */ GIM_Reject,
     /* 2392784 */ // Label 34070: @2392784
     /* 2392784 */ GIM_Try, /*On fail goto*//*Label 34122*/ GIMT_Encode4(2392893),
     /* 2392789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2392792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2392796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2392800 */   GIM_Try, /*On fail goto*//*Label 34123*/ GIMT_Encode4(2392846), // Rule ID 56430 //
     /* 2392805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2392808 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2392811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2392825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392845 */     // GIR_Coverage, 56430,
     /* 2392845 */     GIR_EraseRootFromParent_Done,
     /* 2392846 */   // Label 34123: @2392846
     /* 2392846 */   GIM_Try, /*On fail goto*//*Label 34124*/ GIMT_Encode4(2392892), // Rule ID 56431 //
     /* 2392851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2392854 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2392857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2392871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392891 */     // GIR_Coverage, 56431,
     /* 2392891 */     GIR_EraseRootFromParent_Done,
     /* 2392892 */   // Label 34124: @2392892
     /* 2392892 */   GIM_Reject,
     /* 2392893 */ // Label 34122: @2392893
     /* 2392893 */ GIM_Reject,
     /* 2392894 */ // Label 34071: @2392894
     /* 2392894 */ GIM_Try, /*On fail goto*//*Label 34125*/ GIMT_Encode4(2393003),
     /* 2392899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2392902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2392906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2392910 */   GIM_Try, /*On fail goto*//*Label 34126*/ GIMT_Encode4(2392956), // Rule ID 56510 //
     /* 2392915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2392918 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2392921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2392935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392955 */     // GIR_Coverage, 56510,
     /* 2392955 */     GIR_EraseRootFromParent_Done,
     /* 2392956 */   // Label 34126: @2392956
     /* 2392956 */   GIM_Try, /*On fail goto*//*Label 34127*/ GIMT_Encode4(2393002), // Rule ID 56511 //
     /* 2392961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2392964 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2392967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2392981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393001 */     // GIR_Coverage, 56511,
     /* 2393001 */     GIR_EraseRootFromParent_Done,
     /* 2393002 */   // Label 34127: @2393002
     /* 2393002 */   GIM_Reject,
     /* 2393003 */ // Label 34125: @2393003
     /* 2393003 */ GIM_Reject,
     /* 2393004 */ // Label 34072: @2393004
     /* 2393004 */ GIM_Try, /*On fail goto*//*Label 34128*/ GIMT_Encode4(2393113),
     /* 2393009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2393012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393020 */   GIM_Try, /*On fail goto*//*Label 34129*/ GIMT_Encode4(2393066), // Rule ID 56370 //
     /* 2393025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393028 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2393031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2393045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2393052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393065 */     // GIR_Coverage, 56370,
     /* 2393065 */     GIR_EraseRootFromParent_Done,
     /* 2393066 */   // Label 34129: @2393066
     /* 2393066 */   GIM_Try, /*On fail goto*//*Label 34130*/ GIMT_Encode4(2393112), // Rule ID 56371 //
     /* 2393071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393074 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2393077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2393091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2393098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393111 */     // GIR_Coverage, 56371,
     /* 2393111 */     GIR_EraseRootFromParent_Done,
     /* 2393112 */   // Label 34130: @2393112
     /* 2393112 */   GIM_Reject,
     /* 2393113 */ // Label 34128: @2393113
     /* 2393113 */ GIM_Reject,
     /* 2393114 */ // Label 34073: @2393114
     /* 2393114 */ GIM_Try, /*On fail goto*//*Label 34131*/ GIMT_Encode4(2393223),
     /* 2393119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2393122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2393126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2393130 */   GIM_Try, /*On fail goto*//*Label 34132*/ GIMT_Encode4(2393176), // Rule ID 56450 //
     /* 2393135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2393138 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2393141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2393155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2393162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393175 */     // GIR_Coverage, 56450,
     /* 2393175 */     GIR_EraseRootFromParent_Done,
     /* 2393176 */   // Label 34132: @2393176
     /* 2393176 */   GIM_Try, /*On fail goto*//*Label 34133*/ GIMT_Encode4(2393222), // Rule ID 56451 //
     /* 2393181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2393184 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2393187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2393201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2393208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393221 */     // GIR_Coverage, 56451,
     /* 2393221 */     GIR_EraseRootFromParent_Done,
     /* 2393222 */   // Label 34133: @2393222
     /* 2393222 */   GIM_Reject,
     /* 2393223 */ // Label 34131: @2393223
     /* 2393223 */ GIM_Reject,
     /* 2393224 */ // Label 34074: @2393224
     /* 2393224 */ GIM_Try, /*On fail goto*//*Label 34134*/ GIMT_Encode4(2393333),
     /* 2393229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2393232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2393236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2393240 */   GIM_Try, /*On fail goto*//*Label 34135*/ GIMT_Encode4(2393286), // Rule ID 56390 //
     /* 2393245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393248 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2393251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2393265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2393272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393285 */     // GIR_Coverage, 56390,
     /* 2393285 */     GIR_EraseRootFromParent_Done,
     /* 2393286 */   // Label 34135: @2393286
     /* 2393286 */   GIM_Try, /*On fail goto*//*Label 34136*/ GIMT_Encode4(2393332), // Rule ID 56391 //
     /* 2393291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393294 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2393297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2393311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2393318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393331 */     // GIR_Coverage, 56391,
     /* 2393331 */     GIR_EraseRootFromParent_Done,
     /* 2393332 */   // Label 34136: @2393332
     /* 2393332 */   GIM_Reject,
     /* 2393333 */ // Label 34134: @2393333
     /* 2393333 */ GIM_Reject,
     /* 2393334 */ // Label 34075: @2393334
     /* 2393334 */ GIM_Reject,
     /* 2393335 */ // Label 95: @2393335
     /* 2393335 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34140*/ GIMT_Encode4(2393532),
     /* 2393346 */ /*GILLT_s16*//*Label 34137*/ GIMT_Encode4(2393358),
     /* 2393350 */ /*GILLT_s32*//*Label 34138*/ GIMT_Encode4(2393416),
     /* 2393354 */ /*GILLT_s64*//*Label 34139*/ GIMT_Encode4(2393474),
     /* 2393358 */ // Label 34137: @2393358
     /* 2393358 */ GIM_Try, /*On fail goto*//*Label 34141*/ GIMT_Encode4(2393415),
     /* 2393363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2393366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2393370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2393374 */   GIM_Try, /*On fail goto*//*Label 34142*/ GIMT_Encode4(2393394), // Rule ID 2418 //
     /* 2393379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2393382 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i64] })
     /* 2393382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2393385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2393392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393393 */     // GIR_Coverage, 2418,
     /* 2393393 */     GIR_EraseRootFromParent_Done,
     /* 2393394 */   // Label 34142: @2393394
     /* 2393394 */   GIM_Try, /*On fail goto*//*Label 34143*/ GIMT_Encode4(2393414), // Rule ID 2419 //
     /* 2393399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2393402 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i32] })
     /* 2393402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2393405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2393412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393413 */     // GIR_Coverage, 2419,
     /* 2393413 */     GIR_EraseRootFromParent_Done,
     /* 2393414 */   // Label 34143: @2393414
     /* 2393414 */   GIM_Reject,
     /* 2393415 */ // Label 34141: @2393415
     /* 2393415 */ GIM_Reject,
     /* 2393416 */ // Label 34138: @2393416
     /* 2393416 */ GIM_Try, /*On fail goto*//*Label 34144*/ GIMT_Encode4(2393473),
     /* 2393421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2393424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393432 */   GIM_Try, /*On fail goto*//*Label 34145*/ GIMT_Encode4(2393452), // Rule ID 2336 //
     /* 2393437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2393440 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i64] })
     /* 2393440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2393443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2393450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393451 */     // GIR_Coverage, 2336,
     /* 2393451 */     GIR_EraseRootFromParent_Done,
     /* 2393452 */   // Label 34145: @2393452
     /* 2393452 */   GIM_Try, /*On fail goto*//*Label 34146*/ GIMT_Encode4(2393472), // Rule ID 2337 //
     /* 2393457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2393460 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i32] })
     /* 2393460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2393463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2393470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393471 */     // GIR_Coverage, 2337,
     /* 2393471 */     GIR_EraseRootFromParent_Done,
     /* 2393472 */   // Label 34146: @2393472
     /* 2393472 */   GIM_Reject,
     /* 2393473 */ // Label 34144: @2393473
     /* 2393473 */ GIM_Reject,
     /* 2393474 */ // Label 34139: @2393474
     /* 2393474 */ GIM_Try, /*On fail goto*//*Label 34147*/ GIMT_Encode4(2393531),
     /* 2393479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393490 */   GIM_Try, /*On fail goto*//*Label 34148*/ GIMT_Encode4(2393510), // Rule ID 2376 //
     /* 2393495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2393498 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i64] })
     /* 2393498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2393501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2393508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393509 */     // GIR_Coverage, 2376,
     /* 2393509 */     GIR_EraseRootFromParent_Done,
     /* 2393510 */   // Label 34148: @2393510
     /* 2393510 */   GIM_Try, /*On fail goto*//*Label 34149*/ GIMT_Encode4(2393530), // Rule ID 2377 //
     /* 2393515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2393518 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i32] })
     /* 2393518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2393521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2393528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393529 */     // GIR_Coverage, 2377,
     /* 2393529 */     GIR_EraseRootFromParent_Done,
     /* 2393530 */   // Label 34149: @2393530
     /* 2393530 */   GIM_Reject,
     /* 2393531 */ // Label 34147: @2393531
     /* 2393531 */ GIM_Reject,
     /* 2393532 */ // Label 34140: @2393532
     /* 2393532 */ GIM_Reject,
     /* 2393533 */ // Label 96: @2393533
     /* 2393533 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34153*/ GIMT_Encode4(2393730),
     /* 2393544 */ /*GILLT_s16*//*Label 34150*/ GIMT_Encode4(2393556),
     /* 2393548 */ /*GILLT_s32*//*Label 34151*/ GIMT_Encode4(2393614),
     /* 2393552 */ /*GILLT_s64*//*Label 34152*/ GIMT_Encode4(2393672),
     /* 2393556 */ // Label 34150: @2393556
     /* 2393556 */ GIM_Try, /*On fail goto*//*Label 34154*/ GIMT_Encode4(2393613),
     /* 2393561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2393564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2393568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2393572 */   GIM_Try, /*On fail goto*//*Label 34155*/ GIMT_Encode4(2393592), // Rule ID 2402 //
     /* 2393577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2393580 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2393580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2393583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393591 */     // GIR_Coverage, 2402,
     /* 2393591 */     GIR_EraseRootFromParent_Done,
     /* 2393592 */   // Label 34155: @2393592
     /* 2393592 */   GIM_Try, /*On fail goto*//*Label 34156*/ GIMT_Encode4(2393612), // Rule ID 2403 //
     /* 2393597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2393600 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2393600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2393603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393611 */     // GIR_Coverage, 2403,
     /* 2393611 */     GIR_EraseRootFromParent_Done,
     /* 2393612 */   // Label 34156: @2393612
     /* 2393612 */   GIM_Reject,
     /* 2393613 */ // Label 34154: @2393613
     /* 2393613 */ GIM_Reject,
     /* 2393614 */ // Label 34151: @2393614
     /* 2393614 */ GIM_Try, /*On fail goto*//*Label 34157*/ GIMT_Encode4(2393671),
     /* 2393619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2393622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393630 */   GIM_Try, /*On fail goto*//*Label 34158*/ GIMT_Encode4(2393650), // Rule ID 2320 //
     /* 2393635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2393638 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2393638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2393641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393649 */     // GIR_Coverage, 2320,
     /* 2393649 */     GIR_EraseRootFromParent_Done,
     /* 2393650 */   // Label 34158: @2393650
     /* 2393650 */   GIM_Try, /*On fail goto*//*Label 34159*/ GIMT_Encode4(2393670), // Rule ID 2321 //
     /* 2393655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2393658 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2393658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2393661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393669 */     // GIR_Coverage, 2321,
     /* 2393669 */     GIR_EraseRootFromParent_Done,
     /* 2393670 */   // Label 34159: @2393670
     /* 2393670 */   GIM_Reject,
     /* 2393671 */ // Label 34157: @2393671
     /* 2393671 */ GIM_Reject,
     /* 2393672 */ // Label 34152: @2393672
     /* 2393672 */ GIM_Try, /*On fail goto*//*Label 34160*/ GIMT_Encode4(2393729),
     /* 2393677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393688 */   GIM_Try, /*On fail goto*//*Label 34161*/ GIMT_Encode4(2393708), // Rule ID 2360 //
     /* 2393693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2393696 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2393696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2393699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393707 */     // GIR_Coverage, 2360,
     /* 2393707 */     GIR_EraseRootFromParent_Done,
     /* 2393708 */   // Label 34161: @2393708
     /* 2393708 */   GIM_Try, /*On fail goto*//*Label 34162*/ GIMT_Encode4(2393728), // Rule ID 2361 //
     /* 2393713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2393716 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2393716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2393719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393727 */     // GIR_Coverage, 2361,
     /* 2393727 */     GIR_EraseRootFromParent_Done,
     /* 2393728 */   // Label 34162: @2393728
     /* 2393728 */   GIM_Reject,
     /* 2393729 */ // Label 34160: @2393729
     /* 2393729 */ GIM_Reject,
     /* 2393730 */ // Label 34153: @2393730
     /* 2393730 */ GIM_Reject,
     /* 2393731 */ // Label 97: @2393731
     /* 2393731 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34166*/ GIMT_Encode4(2393928),
     /* 2393742 */ /*GILLT_s16*//*Label 34163*/ GIMT_Encode4(2393754),
     /* 2393746 */ /*GILLT_s32*//*Label 34164*/ GIMT_Encode4(2393812),
     /* 2393750 */ /*GILLT_s64*//*Label 34165*/ GIMT_Encode4(2393870),
     /* 2393754 */ // Label 34163: @2393754
     /* 2393754 */ GIM_Try, /*On fail goto*//*Label 34167*/ GIMT_Encode4(2393811),
     /* 2393759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2393762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2393766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2393770 */   GIM_Try, /*On fail goto*//*Label 34168*/ GIMT_Encode4(2393790), // Rule ID 2406 //
     /* 2393775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2393778 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2393778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2393781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393789 */     // GIR_Coverage, 2406,
     /* 2393789 */     GIR_EraseRootFromParent_Done,
     /* 2393790 */   // Label 34168: @2393790
     /* 2393790 */   GIM_Try, /*On fail goto*//*Label 34169*/ GIMT_Encode4(2393810), // Rule ID 2407 //
     /* 2393795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2393798 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2393798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2393801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393809 */     // GIR_Coverage, 2407,
     /* 2393809 */     GIR_EraseRootFromParent_Done,
     /* 2393810 */   // Label 34169: @2393810
     /* 2393810 */   GIM_Reject,
     /* 2393811 */ // Label 34167: @2393811
     /* 2393811 */ GIM_Reject,
     /* 2393812 */ // Label 34164: @2393812
     /* 2393812 */ GIM_Try, /*On fail goto*//*Label 34170*/ GIMT_Encode4(2393869),
     /* 2393817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2393820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393828 */   GIM_Try, /*On fail goto*//*Label 34171*/ GIMT_Encode4(2393848), // Rule ID 2324 //
     /* 2393833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2393836 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2393836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2393839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393847 */     // GIR_Coverage, 2324,
     /* 2393847 */     GIR_EraseRootFromParent_Done,
     /* 2393848 */   // Label 34171: @2393848
     /* 2393848 */   GIM_Try, /*On fail goto*//*Label 34172*/ GIMT_Encode4(2393868), // Rule ID 2325 //
     /* 2393853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2393856 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2393856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2393859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393867 */     // GIR_Coverage, 2325,
     /* 2393867 */     GIR_EraseRootFromParent_Done,
     /* 2393868 */   // Label 34172: @2393868
     /* 2393868 */   GIM_Reject,
     /* 2393869 */ // Label 34170: @2393869
     /* 2393869 */ GIM_Reject,
     /* 2393870 */ // Label 34165: @2393870
     /* 2393870 */ GIM_Try, /*On fail goto*//*Label 34173*/ GIMT_Encode4(2393927),
     /* 2393875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393886 */   GIM_Try, /*On fail goto*//*Label 34174*/ GIMT_Encode4(2393906), // Rule ID 2364 //
     /* 2393891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2393894 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2393894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2393897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393905 */     // GIR_Coverage, 2364,
     /* 2393905 */     GIR_EraseRootFromParent_Done,
     /* 2393906 */   // Label 34174: @2393906
     /* 2393906 */   GIM_Try, /*On fail goto*//*Label 34175*/ GIMT_Encode4(2393926), // Rule ID 2365 //
     /* 2393911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2393914 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2393914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2393917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393925 */     // GIR_Coverage, 2365,
     /* 2393925 */     GIR_EraseRootFromParent_Done,
     /* 2393926 */   // Label 34175: @2393926
     /* 2393926 */   GIM_Reject,
     /* 2393927 */ // Label 34173: @2393927
     /* 2393927 */ GIM_Reject,
     /* 2393928 */ // Label 34166: @2393928
     /* 2393928 */ GIM_Reject,
     /* 2393929 */ // Label 98: @2393929
     /* 2393929 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34194*/ GIMT_Encode4(2396356),
     /* 2393940 */ /*GILLT_s16*//*Label 34176*/ GIMT_Encode4(2394060),
     /* 2393944 */ /*GILLT_s32*//*Label 34177*/ GIMT_Encode4(2394209),
     /* 2393948 */ /*GILLT_s64*//*Label 34178*/ GIMT_Encode4(2394358), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2393960 */ /*GILLT_nxv1s16*//*Label 34179*/ GIMT_Encode4(2394541),
     /* 2393964 */ /*GILLT_nxv1s32*//*Label 34180*/ GIMT_Encode4(2394662),
     /* 2393968 */ /*GILLT_nxv1s64*//*Label 34181*/ GIMT_Encode4(2394783), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2393980 */ /*GILLT_nxv2s16*//*Label 34182*/ GIMT_Encode4(2394904),
     /* 2393984 */ /*GILLT_nxv2s32*//*Label 34183*/ GIMT_Encode4(2395025),
     /* 2393988 */ /*GILLT_nxv2s64*//*Label 34184*/ GIMT_Encode4(2395146), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394000 */ /*GILLT_nxv4s16*//*Label 34185*/ GIMT_Encode4(2395267),
     /* 2394004 */ /*GILLT_nxv4s32*//*Label 34186*/ GIMT_Encode4(2395388),
     /* 2394008 */ /*GILLT_nxv4s64*//*Label 34187*/ GIMT_Encode4(2395509), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394020 */ /*GILLT_nxv8s16*//*Label 34188*/ GIMT_Encode4(2395630),
     /* 2394024 */ /*GILLT_nxv8s32*//*Label 34189*/ GIMT_Encode4(2395751),
     /* 2394028 */ /*GILLT_nxv8s64*//*Label 34190*/ GIMT_Encode4(2395872), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394040 */ /*GILLT_nxv16s16*//*Label 34191*/ GIMT_Encode4(2395993),
     /* 2394044 */ /*GILLT_nxv16s32*//*Label 34192*/ GIMT_Encode4(2396114), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394056 */ /*GILLT_nxv32s16*//*Label 34193*/ GIMT_Encode4(2396235),
     /* 2394060 */ // Label 34176: @2394060
     /* 2394060 */ GIM_Try, /*On fail goto*//*Label 34195*/ GIMT_Encode4(2394208),
     /* 2394065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2394068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2394071 */   GIM_Try, /*On fail goto*//*Label 34196*/ GIMT_Encode4(2394105), // Rule ID 1946 //
     /* 2394076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2394079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394091 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2394091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2394094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394104 */     // GIR_Coverage, 1946,
     /* 2394104 */     GIR_EraseRootFromParent_Done,
     /* 2394105 */   // Label 34196: @2394105
     /* 2394105 */   GIM_Try, /*On fail goto*//*Label 34197*/ GIMT_Encode4(2394139), // Rule ID 1947 //
     /* 2394110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2394113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394125 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2394125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2394128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394138 */     // GIR_Coverage, 1947,
     /* 2394138 */     GIR_EraseRootFromParent_Done,
     /* 2394139 */   // Label 34197: @2394139
     /* 2394139 */   GIM_Try, /*On fail goto*//*Label 34198*/ GIMT_Encode4(2394173), // Rule ID 1950 //
     /* 2394144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2394147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394159 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2394159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2394162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394172 */     // GIR_Coverage, 1950,
     /* 2394172 */     GIR_EraseRootFromParent_Done,
     /* 2394173 */   // Label 34198: @2394173
     /* 2394173 */   GIM_Try, /*On fail goto*//*Label 34199*/ GIMT_Encode4(2394207), // Rule ID 1951 //
     /* 2394178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2394181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394193 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2394193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2394196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394206 */     // GIR_Coverage, 1951,
     /* 2394206 */     GIR_EraseRootFromParent_Done,
     /* 2394207 */   // Label 34199: @2394207
     /* 2394207 */   GIM_Reject,
     /* 2394208 */ // Label 34195: @2394208
     /* 2394208 */ GIM_Reject,
     /* 2394209 */ // Label 34177: @2394209
     /* 2394209 */ GIM_Try, /*On fail goto*//*Label 34200*/ GIMT_Encode4(2394357),
     /* 2394214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2394217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2394220 */   GIM_Try, /*On fail goto*//*Label 34201*/ GIMT_Encode4(2394254), // Rule ID 1237 //
     /* 2394225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2394228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394240 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2394240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2394243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394253 */     // GIR_Coverage, 1237,
     /* 2394253 */     GIR_EraseRootFromParent_Done,
     /* 2394254 */   // Label 34201: @2394254
     /* 2394254 */   GIM_Try, /*On fail goto*//*Label 34202*/ GIMT_Encode4(2394288), // Rule ID 1238 //
     /* 2394259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2394262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394274 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2394274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2394277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394287 */     // GIR_Coverage, 1238,
     /* 2394287 */     GIR_EraseRootFromParent_Done,
     /* 2394288 */   // Label 34202: @2394288
     /* 2394288 */   GIM_Try, /*On fail goto*//*Label 34203*/ GIMT_Encode4(2394322), // Rule ID 1241 //
     /* 2394293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2394296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394308 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2394308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2394311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394321 */     // GIR_Coverage, 1241,
     /* 2394321 */     GIR_EraseRootFromParent_Done,
     /* 2394322 */   // Label 34203: @2394322
     /* 2394322 */   GIM_Try, /*On fail goto*//*Label 34204*/ GIMT_Encode4(2394356), // Rule ID 1242 //
     /* 2394327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2394330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394342 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2394342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2394345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394355 */     // GIR_Coverage, 1242,
     /* 2394355 */     GIR_EraseRootFromParent_Done,
     /* 2394356 */   // Label 34204: @2394356
     /* 2394356 */   GIM_Reject,
     /* 2394357 */ // Label 34200: @2394357
     /* 2394357 */ GIM_Reject,
     /* 2394358 */ // Label 34178: @2394358
     /* 2394358 */ GIM_Try, /*On fail goto*//*Label 34205*/ GIMT_Encode4(2394540),
     /* 2394363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2394369 */   GIM_Try, /*On fail goto*//*Label 34206*/ GIMT_Encode4(2394403), // Rule ID 1572 //
     /* 2394374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2394377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394389 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2394389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2394392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394402 */     // GIR_Coverage, 1572,
     /* 2394402 */     GIR_EraseRootFromParent_Done,
     /* 2394403 */   // Label 34206: @2394403
     /* 2394403 */   GIM_Try, /*On fail goto*//*Label 34207*/ GIMT_Encode4(2394437), // Rule ID 1573 //
     /* 2394408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2394411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394423 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2394423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2394426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394436 */     // GIR_Coverage, 1573,
     /* 2394436 */     GIR_EraseRootFromParent_Done,
     /* 2394437 */   // Label 34207: @2394437
     /* 2394437 */   GIM_Try, /*On fail goto*//*Label 34208*/ GIMT_Encode4(2394471), // Rule ID 1576 //
     /* 2394442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2394445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394457 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2394457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2394460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394470 */     // GIR_Coverage, 1576,
     /* 2394470 */     GIR_EraseRootFromParent_Done,
     /* 2394471 */   // Label 34208: @2394471
     /* 2394471 */   GIM_Try, /*On fail goto*//*Label 34209*/ GIMT_Encode4(2394505), // Rule ID 1577 //
     /* 2394476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2394479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394491 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2394491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2394494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394504 */     // GIR_Coverage, 1577,
     /* 2394504 */     GIR_EraseRootFromParent_Done,
     /* 2394505 */   // Label 34209: @2394505
     /* 2394505 */   GIM_Try, /*On fail goto*//*Label 34210*/ GIMT_Encode4(2394539), // Rule ID 1580 //
     /* 2394510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2394513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394525 */     // (strict_fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2394525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2394528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394538 */     // GIR_Coverage, 1580,
     /* 2394538 */     GIR_EraseRootFromParent_Done,
     /* 2394539 */   // Label 34210: @2394539
     /* 2394539 */   GIM_Reject,
     /* 2394540 */ // Label 34205: @2394540
     /* 2394540 */ GIM_Reject,
     /* 2394541 */ // Label 34179: @2394541
     /* 2394541 */ GIM_Try, /*On fail goto*//*Label 34211*/ GIMT_Encode4(2394661),
     /* 2394546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2394549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2394552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394564 */   GIM_Try, /*On fail goto*//*Label 34212*/ GIMT_Encode4(2394612), // Rule ID 45750 //
     /* 2394569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2394572 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2394575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2394589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394611 */     // GIR_Coverage, 45750,
     /* 2394611 */     GIR_EraseRootFromParent_Done,
     /* 2394612 */   // Label 34212: @2394612
     /* 2394612 */   GIM_Try, /*On fail goto*//*Label 34213*/ GIMT_Encode4(2394660), // Rule ID 45751 //
     /* 2394617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2394620 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2394623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2394637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394659 */     // GIR_Coverage, 45751,
     /* 2394659 */     GIR_EraseRootFromParent_Done,
     /* 2394660 */   // Label 34213: @2394660
     /* 2394660 */   GIM_Reject,
     /* 2394661 */ // Label 34211: @2394661
     /* 2394661 */ GIM_Reject,
     /* 2394662 */ // Label 34180: @2394662
     /* 2394662 */ GIM_Try, /*On fail goto*//*Label 34214*/ GIMT_Encode4(2394782),
     /* 2394667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2394670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2394673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394685 */   GIM_Try, /*On fail goto*//*Label 34215*/ GIMT_Encode4(2394733), // Rule ID 53290 //
     /* 2394690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2394693 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2394696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2394710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394732 */     // GIR_Coverage, 53290,
     /* 2394732 */     GIR_EraseRootFromParent_Done,
     /* 2394733 */   // Label 34215: @2394733
     /* 2394733 */   GIM_Try, /*On fail goto*//*Label 34216*/ GIMT_Encode4(2394781), // Rule ID 53291 //
     /* 2394738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2394741 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2394744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2394758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394780 */     // GIR_Coverage, 53291,
     /* 2394780 */     GIR_EraseRootFromParent_Done,
     /* 2394781 */   // Label 34216: @2394781
     /* 2394781 */   GIM_Reject,
     /* 2394782 */ // Label 34214: @2394782
     /* 2394782 */ GIM_Reject,
     /* 2394783 */ // Label 34181: @2394783
     /* 2394783 */ GIM_Try, /*On fail goto*//*Label 34217*/ GIMT_Encode4(2394903),
     /* 2394788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2394791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2394794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394806 */   GIM_Try, /*On fail goto*//*Label 34218*/ GIMT_Encode4(2394854), // Rule ID 53326 //
     /* 2394811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2394814 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2394817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2394831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2394849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394853 */     // GIR_Coverage, 53326,
     /* 2394853 */     GIR_EraseRootFromParent_Done,
     /* 2394854 */   // Label 34218: @2394854
     /* 2394854 */   GIM_Try, /*On fail goto*//*Label 34219*/ GIMT_Encode4(2394902), // Rule ID 53327 //
     /* 2394859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2394862 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2394865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2394879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2394897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394901 */     // GIR_Coverage, 53327,
     /* 2394901 */     GIR_EraseRootFromParent_Done,
     /* 2394902 */   // Label 34219: @2394902
     /* 2394902 */   GIM_Reject,
     /* 2394903 */ // Label 34217: @2394903
     /* 2394903 */ GIM_Reject,
     /* 2394904 */ // Label 34182: @2394904
     /* 2394904 */ GIM_Try, /*On fail goto*//*Label 34220*/ GIMT_Encode4(2395024),
     /* 2394909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2394912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2394915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394927 */   GIM_Try, /*On fail goto*//*Label 34221*/ GIMT_Encode4(2394975), // Rule ID 53278 //
     /* 2394932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2394935 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2394938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2394952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394974 */     // GIR_Coverage, 53278,
     /* 2394974 */     GIR_EraseRootFromParent_Done,
     /* 2394975 */   // Label 34221: @2394975
     /* 2394975 */   GIM_Try, /*On fail goto*//*Label 34222*/ GIMT_Encode4(2395023), // Rule ID 53279 //
     /* 2394980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2394983 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2394986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2395000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395022 */     // GIR_Coverage, 53279,
     /* 2395022 */     GIR_EraseRootFromParent_Done,
     /* 2395023 */   // Label 34222: @2395023
     /* 2395023 */   GIM_Reject,
     /* 2395024 */ // Label 34220: @2395024
     /* 2395024 */ GIM_Reject,
     /* 2395025 */ // Label 34183: @2395025
     /* 2395025 */ GIM_Try, /*On fail goto*//*Label 34223*/ GIMT_Encode4(2395145),
     /* 2395030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2395033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2395036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395048 */   GIM_Try, /*On fail goto*//*Label 34224*/ GIMT_Encode4(2395096), // Rule ID 53314 //
     /* 2395053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2395056 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2395059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2395073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395095 */     // GIR_Coverage, 53314,
     /* 2395095 */     GIR_EraseRootFromParent_Done,
     /* 2395096 */   // Label 34224: @2395096
     /* 2395096 */   GIM_Try, /*On fail goto*//*Label 34225*/ GIMT_Encode4(2395144), // Rule ID 53315 //
     /* 2395101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2395104 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2395107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2395121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395143 */     // GIR_Coverage, 53315,
     /* 2395143 */     GIR_EraseRootFromParent_Done,
     /* 2395144 */   // Label 34225: @2395144
     /* 2395144 */   GIM_Reject,
     /* 2395145 */ // Label 34223: @2395145
     /* 2395145 */ GIM_Reject,
     /* 2395146 */ // Label 34184: @2395146
     /* 2395146 */ GIM_Try, /*On fail goto*//*Label 34226*/ GIMT_Encode4(2395266),
     /* 2395151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2395154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2395157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395169 */   GIM_Try, /*On fail goto*//*Label 34227*/ GIMT_Encode4(2395217), // Rule ID 53410 //
     /* 2395174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2395177 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2395180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2395194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395216 */     // GIR_Coverage, 53410,
     /* 2395216 */     GIR_EraseRootFromParent_Done,
     /* 2395217 */   // Label 34227: @2395217
     /* 2395217 */   GIM_Try, /*On fail goto*//*Label 34228*/ GIMT_Encode4(2395265), // Rule ID 53411 //
     /* 2395222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2395225 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2395228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2395242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395264 */     // GIR_Coverage, 53411,
     /* 2395264 */     GIR_EraseRootFromParent_Done,
     /* 2395265 */   // Label 34228: @2395265
     /* 2395265 */   GIM_Reject,
     /* 2395266 */ // Label 34226: @2395266
     /* 2395266 */ GIM_Reject,
     /* 2395267 */ // Label 34185: @2395267
     /* 2395267 */ GIM_Try, /*On fail goto*//*Label 34229*/ GIMT_Encode4(2395387),
     /* 2395272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2395278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395290 */   GIM_Try, /*On fail goto*//*Label 34230*/ GIMT_Encode4(2395338), // Rule ID 53302 //
     /* 2395295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395298 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2395301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2395315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395337 */     // GIR_Coverage, 53302,
     /* 2395337 */     GIR_EraseRootFromParent_Done,
     /* 2395338 */   // Label 34230: @2395338
     /* 2395338 */   GIM_Try, /*On fail goto*//*Label 34231*/ GIMT_Encode4(2395386), // Rule ID 53303 //
     /* 2395343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395346 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2395349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2395363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395385 */     // GIR_Coverage, 53303,
     /* 2395385 */     GIR_EraseRootFromParent_Done,
     /* 2395386 */   // Label 34231: @2395386
     /* 2395386 */   GIM_Reject,
     /* 2395387 */ // Label 34229: @2395387
     /* 2395387 */ GIM_Reject,
     /* 2395388 */ // Label 34186: @2395388
     /* 2395388 */ GIM_Try, /*On fail goto*//*Label 34232*/ GIMT_Encode4(2395508),
     /* 2395393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2395396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2395399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395411 */   GIM_Try, /*On fail goto*//*Label 34233*/ GIMT_Encode4(2395459), // Rule ID 53374 //
     /* 2395416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2395419 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2395422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2395436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395458 */     // GIR_Coverage, 53374,
     /* 2395458 */     GIR_EraseRootFromParent_Done,
     /* 2395459 */   // Label 34233: @2395459
     /* 2395459 */   GIM_Try, /*On fail goto*//*Label 34234*/ GIMT_Encode4(2395507), // Rule ID 53375 //
     /* 2395464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2395467 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2395470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2395484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395506 */     // GIR_Coverage, 53375,
     /* 2395506 */     GIR_EraseRootFromParent_Done,
     /* 2395507 */   // Label 34234: @2395507
     /* 2395507 */   GIM_Reject,
     /* 2395508 */ // Label 34232: @2395508
     /* 2395508 */ GIM_Reject,
     /* 2395509 */ // Label 34187: @2395509
     /* 2395509 */ GIM_Try, /*On fail goto*//*Label 34235*/ GIMT_Encode4(2395629),
     /* 2395514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2395517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2395520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2395524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2395528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2395532 */   GIM_Try, /*On fail goto*//*Label 34236*/ GIMT_Encode4(2395580), // Rule ID 53422 //
     /* 2395537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2395540 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2395543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2395557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395579 */     // GIR_Coverage, 53422,
     /* 2395579 */     GIR_EraseRootFromParent_Done,
     /* 2395580 */   // Label 34236: @2395580
     /* 2395580 */   GIM_Try, /*On fail goto*//*Label 34237*/ GIMT_Encode4(2395628), // Rule ID 53423 //
     /* 2395585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2395588 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2395591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2395605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395627 */     // GIR_Coverage, 53423,
     /* 2395627 */     GIR_EraseRootFromParent_Done,
     /* 2395628 */   // Label 34237: @2395628
     /* 2395628 */   GIM_Reject,
     /* 2395629 */ // Label 34235: @2395629
     /* 2395629 */ GIM_Reject,
     /* 2395630 */ // Label 34188: @2395630
     /* 2395630 */ GIM_Try, /*On fail goto*//*Label 34238*/ GIMT_Encode4(2395750),
     /* 2395635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2395638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2395641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395653 */   GIM_Try, /*On fail goto*//*Label 34239*/ GIMT_Encode4(2395701), // Rule ID 53338 //
     /* 2395658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395661 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2395664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2395678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395700 */     // GIR_Coverage, 53338,
     /* 2395700 */     GIR_EraseRootFromParent_Done,
     /* 2395701 */   // Label 34239: @2395701
     /* 2395701 */   GIM_Try, /*On fail goto*//*Label 34240*/ GIMT_Encode4(2395749), // Rule ID 53339 //
     /* 2395706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395709 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2395712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2395726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395748 */     // GIR_Coverage, 53339,
     /* 2395748 */     GIR_EraseRootFromParent_Done,
     /* 2395749 */   // Label 34240: @2395749
     /* 2395749 */   GIM_Reject,
     /* 2395750 */ // Label 34238: @2395750
     /* 2395750 */ GIM_Reject,
     /* 2395751 */ // Label 34189: @2395751
     /* 2395751 */ GIM_Try, /*On fail goto*//*Label 34241*/ GIMT_Encode4(2395871),
     /* 2395756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2395759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2395762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2395766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2395770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2395774 */   GIM_Try, /*On fail goto*//*Label 34242*/ GIMT_Encode4(2395822), // Rule ID 53386 //
     /* 2395779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2395782 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2395785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2395799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395821 */     // GIR_Coverage, 53386,
     /* 2395821 */     GIR_EraseRootFromParent_Done,
     /* 2395822 */   // Label 34242: @2395822
     /* 2395822 */   GIM_Try, /*On fail goto*//*Label 34243*/ GIMT_Encode4(2395870), // Rule ID 53387 //
     /* 2395827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2395830 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2395833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2395847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395869 */     // GIR_Coverage, 53387,
     /* 2395869 */     GIR_EraseRootFromParent_Done,
     /* 2395870 */   // Label 34243: @2395870
     /* 2395870 */   GIM_Reject,
     /* 2395871 */ // Label 34241: @2395871
     /* 2395871 */ GIM_Reject,
     /* 2395872 */ // Label 34190: @2395872
     /* 2395872 */ GIM_Try, /*On fail goto*//*Label 34244*/ GIMT_Encode4(2395992),
     /* 2395877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2395880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2395883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2395887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2395891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2395895 */   GIM_Try, /*On fail goto*//*Label 34245*/ GIMT_Encode4(2395943), // Rule ID 53434 //
     /* 2395900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2395903 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2395906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2395920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395942 */     // GIR_Coverage, 53434,
     /* 2395942 */     GIR_EraseRootFromParent_Done,
     /* 2395943 */   // Label 34245: @2395943
     /* 2395943 */   GIM_Try, /*On fail goto*//*Label 34246*/ GIMT_Encode4(2395991), // Rule ID 53435 //
     /* 2395948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2395951 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2395954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2395968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395990 */     // GIR_Coverage, 53435,
     /* 2395990 */     GIR_EraseRootFromParent_Done,
     /* 2395991 */   // Label 34246: @2395991
     /* 2395991 */   GIM_Reject,
     /* 2395992 */ // Label 34244: @2395992
     /* 2395992 */ GIM_Reject,
     /* 2395993 */ // Label 34191: @2395993
     /* 2395993 */ GIM_Try, /*On fail goto*//*Label 34247*/ GIMT_Encode4(2396113),
     /* 2395998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2396001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2396004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396016 */   GIM_Try, /*On fail goto*//*Label 34248*/ GIMT_Encode4(2396064), // Rule ID 53350 //
     /* 2396021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396024 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2396027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2396041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396063 */     // GIR_Coverage, 53350,
     /* 2396063 */     GIR_EraseRootFromParent_Done,
     /* 2396064 */   // Label 34248: @2396064
     /* 2396064 */   GIM_Try, /*On fail goto*//*Label 34249*/ GIMT_Encode4(2396112), // Rule ID 53351 //
     /* 2396069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396072 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2396075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2396089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396111 */     // GIR_Coverage, 53351,
     /* 2396111 */     GIR_EraseRootFromParent_Done,
     /* 2396112 */   // Label 34249: @2396112
     /* 2396112 */   GIM_Reject,
     /* 2396113 */ // Label 34247: @2396113
     /* 2396113 */ GIM_Reject,
     /* 2396114 */ // Label 34192: @2396114
     /* 2396114 */ GIM_Try, /*On fail goto*//*Label 34250*/ GIMT_Encode4(2396234),
     /* 2396119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2396122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2396125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396137 */   GIM_Try, /*On fail goto*//*Label 34251*/ GIMT_Encode4(2396185), // Rule ID 53398 //
     /* 2396142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396145 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2396148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2396162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396184 */     // GIR_Coverage, 53398,
     /* 2396184 */     GIR_EraseRootFromParent_Done,
     /* 2396185 */   // Label 34251: @2396185
     /* 2396185 */   GIM_Try, /*On fail goto*//*Label 34252*/ GIMT_Encode4(2396233), // Rule ID 53399 //
     /* 2396190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396193 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2396196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2396210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396232 */     // GIR_Coverage, 53399,
     /* 2396232 */     GIR_EraseRootFromParent_Done,
     /* 2396233 */   // Label 34252: @2396233
     /* 2396233 */   GIM_Reject,
     /* 2396234 */ // Label 34250: @2396234
     /* 2396234 */ GIM_Reject,
     /* 2396235 */ // Label 34193: @2396235
     /* 2396235 */ GIM_Try, /*On fail goto*//*Label 34253*/ GIMT_Encode4(2396355),
     /* 2396240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2396243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2396246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396258 */   GIM_Try, /*On fail goto*//*Label 34254*/ GIMT_Encode4(2396306), // Rule ID 53362 //
     /* 2396263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396266 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2396269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2396283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396305 */     // GIR_Coverage, 53362,
     /* 2396305 */     GIR_EraseRootFromParent_Done,
     /* 2396306 */   // Label 34254: @2396306
     /* 2396306 */   GIM_Try, /*On fail goto*//*Label 34255*/ GIMT_Encode4(2396354), // Rule ID 53363 //
     /* 2396311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396314 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2396317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2396331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396353 */     // GIR_Coverage, 53363,
     /* 2396353 */     GIR_EraseRootFromParent_Done,
     /* 2396354 */   // Label 34255: @2396354
     /* 2396354 */   GIM_Reject,
     /* 2396355 */ // Label 34253: @2396355
     /* 2396355 */ GIM_Reject,
     /* 2396356 */ // Label 34194: @2396356
     /* 2396356 */ GIM_Reject,
     /* 2396357 */ // Label 99: @2396357
     /* 2396357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34274*/ GIMT_Encode4(2398784),
     /* 2396368 */ /*GILLT_s16*//*Label 34256*/ GIMT_Encode4(2396488),
     /* 2396372 */ /*GILLT_s32*//*Label 34257*/ GIMT_Encode4(2396637),
     /* 2396376 */ /*GILLT_s64*//*Label 34258*/ GIMT_Encode4(2396786), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2396388 */ /*GILLT_nxv1s16*//*Label 34259*/ GIMT_Encode4(2396969),
     /* 2396392 */ /*GILLT_nxv1s32*//*Label 34260*/ GIMT_Encode4(2397090),
     /* 2396396 */ /*GILLT_nxv1s64*//*Label 34261*/ GIMT_Encode4(2397211), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2396408 */ /*GILLT_nxv2s16*//*Label 34262*/ GIMT_Encode4(2397332),
     /* 2396412 */ /*GILLT_nxv2s32*//*Label 34263*/ GIMT_Encode4(2397453),
     /* 2396416 */ /*GILLT_nxv2s64*//*Label 34264*/ GIMT_Encode4(2397574), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2396428 */ /*GILLT_nxv4s16*//*Label 34265*/ GIMT_Encode4(2397695),
     /* 2396432 */ /*GILLT_nxv4s32*//*Label 34266*/ GIMT_Encode4(2397816),
     /* 2396436 */ /*GILLT_nxv4s64*//*Label 34267*/ GIMT_Encode4(2397937), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2396448 */ /*GILLT_nxv8s16*//*Label 34268*/ GIMT_Encode4(2398058),
     /* 2396452 */ /*GILLT_nxv8s32*//*Label 34269*/ GIMT_Encode4(2398179),
     /* 2396456 */ /*GILLT_nxv8s64*//*Label 34270*/ GIMT_Encode4(2398300), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2396468 */ /*GILLT_nxv16s16*//*Label 34271*/ GIMT_Encode4(2398421),
     /* 2396472 */ /*GILLT_nxv16s32*//*Label 34272*/ GIMT_Encode4(2398542), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2396484 */ /*GILLT_nxv32s16*//*Label 34273*/ GIMT_Encode4(2398663),
     /* 2396488 */ // Label 34256: @2396488
     /* 2396488 */ GIM_Try, /*On fail goto*//*Label 34275*/ GIMT_Encode4(2396636),
     /* 2396493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2396496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2396499 */   GIM_Try, /*On fail goto*//*Label 34276*/ GIMT_Encode4(2396533), // Rule ID 1954 //
     /* 2396504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2396507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2396511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2396515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2396519 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2396519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2396522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396532 */     // GIR_Coverage, 1954,
     /* 2396532 */     GIR_EraseRootFromParent_Done,
     /* 2396533 */   // Label 34276: @2396533
     /* 2396533 */   GIM_Try, /*On fail goto*//*Label 34277*/ GIMT_Encode4(2396567), // Rule ID 1955 //
     /* 2396538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2396541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2396545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2396549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2396553 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2396553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2396556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396566 */     // GIR_Coverage, 1955,
     /* 2396566 */     GIR_EraseRootFromParent_Done,
     /* 2396567 */   // Label 34277: @2396567
     /* 2396567 */   GIM_Try, /*On fail goto*//*Label 34278*/ GIMT_Encode4(2396601), // Rule ID 1958 //
     /* 2396572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2396575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2396579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2396583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2396587 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2396587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2396590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396600 */     // GIR_Coverage, 1958,
     /* 2396600 */     GIR_EraseRootFromParent_Done,
     /* 2396601 */   // Label 34278: @2396601
     /* 2396601 */   GIM_Try, /*On fail goto*//*Label 34279*/ GIMT_Encode4(2396635), // Rule ID 1959 //
     /* 2396606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2396609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2396613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2396617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2396621 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2396621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2396624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396634 */     // GIR_Coverage, 1959,
     /* 2396634 */     GIR_EraseRootFromParent_Done,
     /* 2396635 */   // Label 34279: @2396635
     /* 2396635 */   GIM_Reject,
     /* 2396636 */ // Label 34275: @2396636
     /* 2396636 */ GIM_Reject,
     /* 2396637 */ // Label 34257: @2396637
     /* 2396637 */ GIM_Try, /*On fail goto*//*Label 34280*/ GIMT_Encode4(2396785),
     /* 2396642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2396645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2396648 */   GIM_Try, /*On fail goto*//*Label 34281*/ GIMT_Encode4(2396682), // Rule ID 1245 //
     /* 2396653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2396656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2396660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2396664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2396668 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2396668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2396671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396681 */     // GIR_Coverage, 1245,
     /* 2396681 */     GIR_EraseRootFromParent_Done,
     /* 2396682 */   // Label 34281: @2396682
     /* 2396682 */   GIM_Try, /*On fail goto*//*Label 34282*/ GIMT_Encode4(2396716), // Rule ID 1246 //
     /* 2396687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2396690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2396694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2396698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2396702 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2396702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2396705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396715 */     // GIR_Coverage, 1246,
     /* 2396715 */     GIR_EraseRootFromParent_Done,
     /* 2396716 */   // Label 34282: @2396716
     /* 2396716 */   GIM_Try, /*On fail goto*//*Label 34283*/ GIMT_Encode4(2396750), // Rule ID 1249 //
     /* 2396721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2396724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2396728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2396732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2396736 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2396736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2396739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396749 */     // GIR_Coverage, 1249,
     /* 2396749 */     GIR_EraseRootFromParent_Done,
     /* 2396750 */   // Label 34283: @2396750
     /* 2396750 */   GIM_Try, /*On fail goto*//*Label 34284*/ GIMT_Encode4(2396784), // Rule ID 1250 //
     /* 2396755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2396758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2396762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2396766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2396770 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2396770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2396773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396783 */     // GIR_Coverage, 1250,
     /* 2396783 */     GIR_EraseRootFromParent_Done,
     /* 2396784 */   // Label 34284: @2396784
     /* 2396784 */   GIM_Reject,
     /* 2396785 */ // Label 34280: @2396785
     /* 2396785 */ GIM_Reject,
     /* 2396786 */ // Label 34258: @2396786
     /* 2396786 */ GIM_Try, /*On fail goto*//*Label 34285*/ GIMT_Encode4(2396968),
     /* 2396791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2396794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2396797 */   GIM_Try, /*On fail goto*//*Label 34286*/ GIMT_Encode4(2396831), // Rule ID 1582 //
     /* 2396802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2396805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2396809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2396813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2396817 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2396817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2396820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396830 */     // GIR_Coverage, 1582,
     /* 2396830 */     GIR_EraseRootFromParent_Done,
     /* 2396831 */   // Label 34286: @2396831
     /* 2396831 */   GIM_Try, /*On fail goto*//*Label 34287*/ GIMT_Encode4(2396865), // Rule ID 1583 //
     /* 2396836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2396839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2396843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2396847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2396851 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2396851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2396854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396864 */     // GIR_Coverage, 1583,
     /* 2396864 */     GIR_EraseRootFromParent_Done,
     /* 2396865 */   // Label 34287: @2396865
     /* 2396865 */   GIM_Try, /*On fail goto*//*Label 34288*/ GIMT_Encode4(2396899), // Rule ID 1586 //
     /* 2396870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2396873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2396877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2396881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2396885 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2396885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2396888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396898 */     // GIR_Coverage, 1586,
     /* 2396898 */     GIR_EraseRootFromParent_Done,
     /* 2396899 */   // Label 34288: @2396899
     /* 2396899 */   GIM_Try, /*On fail goto*//*Label 34289*/ GIMT_Encode4(2396933), // Rule ID 1587 //
     /* 2396904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2396907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2396911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2396915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2396919 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2396919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2396922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396932 */     // GIR_Coverage, 1587,
     /* 2396932 */     GIR_EraseRootFromParent_Done,
     /* 2396933 */   // Label 34289: @2396933
     /* 2396933 */   GIM_Try, /*On fail goto*//*Label 34290*/ GIMT_Encode4(2396967), // Rule ID 1590 //
     /* 2396938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2396941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2396945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2396949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2396953 */     // (strict_fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2396953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2396956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396966 */     // GIR_Coverage, 1590,
     /* 2396966 */     GIR_EraseRootFromParent_Done,
     /* 2396967 */   // Label 34290: @2396967
     /* 2396967 */   GIM_Reject,
     /* 2396968 */ // Label 34285: @2396968
     /* 2396968 */ GIM_Reject,
     /* 2396969 */ // Label 34259: @2396969
     /* 2396969 */ GIM_Try, /*On fail goto*//*Label 34291*/ GIMT_Encode4(2397089),
     /* 2396974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2396977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2396980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396992 */   GIM_Try, /*On fail goto*//*Label 34292*/ GIMT_Encode4(2397040), // Rule ID 53446 //
     /* 2396997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397000 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2397003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2397017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397039 */     // GIR_Coverage, 53446,
     /* 2397039 */     GIR_EraseRootFromParent_Done,
     /* 2397040 */   // Label 34292: @2397040
     /* 2397040 */   GIM_Try, /*On fail goto*//*Label 34293*/ GIMT_Encode4(2397088), // Rule ID 53447 //
     /* 2397045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397048 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2397051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2397065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397087 */     // GIR_Coverage, 53447,
     /* 2397087 */     GIR_EraseRootFromParent_Done,
     /* 2397088 */   // Label 34293: @2397088
     /* 2397088 */   GIM_Reject,
     /* 2397089 */ // Label 34291: @2397089
     /* 2397089 */ GIM_Reject,
     /* 2397090 */ // Label 34260: @2397090
     /* 2397090 */ GIM_Try, /*On fail goto*//*Label 34294*/ GIMT_Encode4(2397210),
     /* 2397095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2397098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2397101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397113 */   GIM_Try, /*On fail goto*//*Label 34295*/ GIMT_Encode4(2397161), // Rule ID 53470 //
     /* 2397118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2397121 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2397124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2397138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397160 */     // GIR_Coverage, 53470,
     /* 2397160 */     GIR_EraseRootFromParent_Done,
     /* 2397161 */   // Label 34295: @2397161
     /* 2397161 */   GIM_Try, /*On fail goto*//*Label 34296*/ GIMT_Encode4(2397209), // Rule ID 53471 //
     /* 2397166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2397169 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2397172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2397186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397208 */     // GIR_Coverage, 53471,
     /* 2397208 */     GIR_EraseRootFromParent_Done,
     /* 2397209 */   // Label 34296: @2397209
     /* 2397209 */   GIM_Reject,
     /* 2397210 */ // Label 34294: @2397210
     /* 2397210 */ GIM_Reject,
     /* 2397211 */ // Label 34261: @2397211
     /* 2397211 */ GIM_Try, /*On fail goto*//*Label 34297*/ GIMT_Encode4(2397331),
     /* 2397216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2397219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2397222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397234 */   GIM_Try, /*On fail goto*//*Label 34298*/ GIMT_Encode4(2397282), // Rule ID 53506 //
     /* 2397239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2397242 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2397245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2397259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397281 */     // GIR_Coverage, 53506,
     /* 2397281 */     GIR_EraseRootFromParent_Done,
     /* 2397282 */   // Label 34298: @2397282
     /* 2397282 */   GIM_Try, /*On fail goto*//*Label 34299*/ GIMT_Encode4(2397330), // Rule ID 53507 //
     /* 2397287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397290 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2397293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2397307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397329 */     // GIR_Coverage, 53507,
     /* 2397329 */     GIR_EraseRootFromParent_Done,
     /* 2397330 */   // Label 34299: @2397330
     /* 2397330 */   GIM_Reject,
     /* 2397331 */ // Label 34297: @2397331
     /* 2397331 */ GIM_Reject,
     /* 2397332 */ // Label 34262: @2397332
     /* 2397332 */ GIM_Try, /*On fail goto*//*Label 34300*/ GIMT_Encode4(2397452),
     /* 2397337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2397343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397355 */   GIM_Try, /*On fail goto*//*Label 34301*/ GIMT_Encode4(2397403), // Rule ID 53458 //
     /* 2397360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397363 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2397366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2397380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397402 */     // GIR_Coverage, 53458,
     /* 2397402 */     GIR_EraseRootFromParent_Done,
     /* 2397403 */   // Label 34301: @2397403
     /* 2397403 */   GIM_Try, /*On fail goto*//*Label 34302*/ GIMT_Encode4(2397451), // Rule ID 53459 //
     /* 2397408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397411 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2397414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2397428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397450 */     // GIR_Coverage, 53459,
     /* 2397450 */     GIR_EraseRootFromParent_Done,
     /* 2397451 */   // Label 34302: @2397451
     /* 2397451 */   GIM_Reject,
     /* 2397452 */ // Label 34300: @2397452
     /* 2397452 */ GIM_Reject,
     /* 2397453 */ // Label 34263: @2397453
     /* 2397453 */ GIM_Try, /*On fail goto*//*Label 34303*/ GIMT_Encode4(2397573),
     /* 2397458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2397461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2397464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397476 */   GIM_Try, /*On fail goto*//*Label 34304*/ GIMT_Encode4(2397524), // Rule ID 53494 //
     /* 2397481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2397484 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2397487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2397501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397523 */     // GIR_Coverage, 53494,
     /* 2397523 */     GIR_EraseRootFromParent_Done,
     /* 2397524 */   // Label 34304: @2397524
     /* 2397524 */   GIM_Try, /*On fail goto*//*Label 34305*/ GIMT_Encode4(2397572), // Rule ID 53495 //
     /* 2397529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2397532 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2397535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2397549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397571 */     // GIR_Coverage, 53495,
     /* 2397571 */     GIR_EraseRootFromParent_Done,
     /* 2397572 */   // Label 34305: @2397572
     /* 2397572 */   GIM_Reject,
     /* 2397573 */ // Label 34303: @2397573
     /* 2397573 */ GIM_Reject,
     /* 2397574 */ // Label 34264: @2397574
     /* 2397574 */ GIM_Try, /*On fail goto*//*Label 34306*/ GIMT_Encode4(2397694),
     /* 2397579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2397582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2397585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397597 */   GIM_Try, /*On fail goto*//*Label 34307*/ GIMT_Encode4(2397645), // Rule ID 53590 //
     /* 2397602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2397605 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2397608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2397622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397644 */     // GIR_Coverage, 53590,
     /* 2397644 */     GIR_EraseRootFromParent_Done,
     /* 2397645 */   // Label 34307: @2397645
     /* 2397645 */   GIM_Try, /*On fail goto*//*Label 34308*/ GIMT_Encode4(2397693), // Rule ID 53591 //
     /* 2397650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397653 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2397656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2397670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397692 */     // GIR_Coverage, 53591,
     /* 2397692 */     GIR_EraseRootFromParent_Done,
     /* 2397693 */   // Label 34308: @2397693
     /* 2397693 */   GIM_Reject,
     /* 2397694 */ // Label 34306: @2397694
     /* 2397694 */ GIM_Reject,
     /* 2397695 */ // Label 34265: @2397695
     /* 2397695 */ GIM_Try, /*On fail goto*//*Label 34309*/ GIMT_Encode4(2397815),
     /* 2397700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2397703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2397706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397718 */   GIM_Try, /*On fail goto*//*Label 34310*/ GIMT_Encode4(2397766), // Rule ID 53482 //
     /* 2397723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397726 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2397729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2397743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397765 */     // GIR_Coverage, 53482,
     /* 2397765 */     GIR_EraseRootFromParent_Done,
     /* 2397766 */   // Label 34310: @2397766
     /* 2397766 */   GIM_Try, /*On fail goto*//*Label 34311*/ GIMT_Encode4(2397814), // Rule ID 53483 //
     /* 2397771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397774 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2397777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2397791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397813 */     // GIR_Coverage, 53483,
     /* 2397813 */     GIR_EraseRootFromParent_Done,
     /* 2397814 */   // Label 34311: @2397814
     /* 2397814 */   GIM_Reject,
     /* 2397815 */ // Label 34309: @2397815
     /* 2397815 */ GIM_Reject,
     /* 2397816 */ // Label 34266: @2397816
     /* 2397816 */ GIM_Try, /*On fail goto*//*Label 34312*/ GIMT_Encode4(2397936),
     /* 2397821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2397824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2397827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397839 */   GIM_Try, /*On fail goto*//*Label 34313*/ GIMT_Encode4(2397887), // Rule ID 53554 //
     /* 2397844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2397847 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2397850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2397864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397886 */     // GIR_Coverage, 53554,
     /* 2397886 */     GIR_EraseRootFromParent_Done,
     /* 2397887 */   // Label 34313: @2397887
     /* 2397887 */   GIM_Try, /*On fail goto*//*Label 34314*/ GIMT_Encode4(2397935), // Rule ID 53555 //
     /* 2397892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2397895 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2397898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2397912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397934 */     // GIR_Coverage, 53555,
     /* 2397934 */     GIR_EraseRootFromParent_Done,
     /* 2397935 */   // Label 34314: @2397935
     /* 2397935 */   GIM_Reject,
     /* 2397936 */ // Label 34312: @2397936
     /* 2397936 */ GIM_Reject,
     /* 2397937 */ // Label 34267: @2397937
     /* 2397937 */ GIM_Try, /*On fail goto*//*Label 34315*/ GIMT_Encode4(2398057),
     /* 2397942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2397948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397960 */   GIM_Try, /*On fail goto*//*Label 34316*/ GIMT_Encode4(2398008), // Rule ID 53602 //
     /* 2397965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2397968 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2397971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2397985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398007 */     // GIR_Coverage, 53602,
     /* 2398007 */     GIR_EraseRootFromParent_Done,
     /* 2398008 */   // Label 34316: @2398008
     /* 2398008 */   GIM_Try, /*On fail goto*//*Label 34317*/ GIMT_Encode4(2398056), // Rule ID 53603 //
     /* 2398013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2398016 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2398019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2398033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398055 */     // GIR_Coverage, 53603,
     /* 2398055 */     GIR_EraseRootFromParent_Done,
     /* 2398056 */   // Label 34317: @2398056
     /* 2398056 */   GIM_Reject,
     /* 2398057 */ // Label 34315: @2398057
     /* 2398057 */ GIM_Reject,
     /* 2398058 */ // Label 34268: @2398058
     /* 2398058 */ GIM_Try, /*On fail goto*//*Label 34318*/ GIMT_Encode4(2398178),
     /* 2398063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2398066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2398069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398081 */   GIM_Try, /*On fail goto*//*Label 34319*/ GIMT_Encode4(2398129), // Rule ID 53518 //
     /* 2398086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398089 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2398092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2398106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398128 */     // GIR_Coverage, 53518,
     /* 2398128 */     GIR_EraseRootFromParent_Done,
     /* 2398129 */   // Label 34319: @2398129
     /* 2398129 */   GIM_Try, /*On fail goto*//*Label 34320*/ GIMT_Encode4(2398177), // Rule ID 53519 //
     /* 2398134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398137 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2398140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2398154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398176 */     // GIR_Coverage, 53519,
     /* 2398176 */     GIR_EraseRootFromParent_Done,
     /* 2398177 */   // Label 34320: @2398177
     /* 2398177 */   GIM_Reject,
     /* 2398178 */ // Label 34318: @2398178
     /* 2398178 */ GIM_Reject,
     /* 2398179 */ // Label 34269: @2398179
     /* 2398179 */ GIM_Try, /*On fail goto*//*Label 34321*/ GIMT_Encode4(2398299),
     /* 2398184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2398190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398202 */   GIM_Try, /*On fail goto*//*Label 34322*/ GIMT_Encode4(2398250), // Rule ID 53566 //
     /* 2398207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398210 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2398213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2398227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398249 */     // GIR_Coverage, 53566,
     /* 2398249 */     GIR_EraseRootFromParent_Done,
     /* 2398250 */   // Label 34322: @2398250
     /* 2398250 */   GIM_Try, /*On fail goto*//*Label 34323*/ GIMT_Encode4(2398298), // Rule ID 53567 //
     /* 2398255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398258 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2398261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2398275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398297 */     // GIR_Coverage, 53567,
     /* 2398297 */     GIR_EraseRootFromParent_Done,
     /* 2398298 */   // Label 34323: @2398298
     /* 2398298 */   GIM_Reject,
     /* 2398299 */ // Label 34321: @2398299
     /* 2398299 */ GIM_Reject,
     /* 2398300 */ // Label 34270: @2398300
     /* 2398300 */ GIM_Try, /*On fail goto*//*Label 34324*/ GIMT_Encode4(2398420),
     /* 2398305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2398308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2398311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398323 */   GIM_Try, /*On fail goto*//*Label 34325*/ GIMT_Encode4(2398371), // Rule ID 53614 //
     /* 2398328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2398331 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2398334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2398348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398370 */     // GIR_Coverage, 53614,
     /* 2398370 */     GIR_EraseRootFromParent_Done,
     /* 2398371 */   // Label 34325: @2398371
     /* 2398371 */   GIM_Try, /*On fail goto*//*Label 34326*/ GIMT_Encode4(2398419), // Rule ID 53615 //
     /* 2398376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2398379 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2398382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2398396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398418 */     // GIR_Coverage, 53615,
     /* 2398418 */     GIR_EraseRootFromParent_Done,
     /* 2398419 */   // Label 34326: @2398419
     /* 2398419 */   GIM_Reject,
     /* 2398420 */ // Label 34324: @2398420
     /* 2398420 */ GIM_Reject,
     /* 2398421 */ // Label 34271: @2398421
     /* 2398421 */ GIM_Try, /*On fail goto*//*Label 34327*/ GIMT_Encode4(2398541),
     /* 2398426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2398429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2398432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398444 */   GIM_Try, /*On fail goto*//*Label 34328*/ GIMT_Encode4(2398492), // Rule ID 53530 //
     /* 2398449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398452 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2398455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2398469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398491 */     // GIR_Coverage, 53530,
     /* 2398491 */     GIR_EraseRootFromParent_Done,
     /* 2398492 */   // Label 34328: @2398492
     /* 2398492 */   GIM_Try, /*On fail goto*//*Label 34329*/ GIMT_Encode4(2398540), // Rule ID 53531 //
     /* 2398497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398500 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2398503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2398517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398539 */     // GIR_Coverage, 53531,
     /* 2398539 */     GIR_EraseRootFromParent_Done,
     /* 2398540 */   // Label 34329: @2398540
     /* 2398540 */   GIM_Reject,
     /* 2398541 */ // Label 34327: @2398541
     /* 2398541 */ GIM_Reject,
     /* 2398542 */ // Label 34272: @2398542
     /* 2398542 */ GIM_Try, /*On fail goto*//*Label 34330*/ GIMT_Encode4(2398662),
     /* 2398547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2398550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2398553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398565 */   GIM_Try, /*On fail goto*//*Label 34331*/ GIMT_Encode4(2398613), // Rule ID 53578 //
     /* 2398570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398573 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2398576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2398590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398612 */     // GIR_Coverage, 53578,
     /* 2398612 */     GIR_EraseRootFromParent_Done,
     /* 2398613 */   // Label 34331: @2398613
     /* 2398613 */   GIM_Try, /*On fail goto*//*Label 34332*/ GIMT_Encode4(2398661), // Rule ID 53579 //
     /* 2398618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398621 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2398624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2398638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398660 */     // GIR_Coverage, 53579,
     /* 2398660 */     GIR_EraseRootFromParent_Done,
     /* 2398661 */   // Label 34332: @2398661
     /* 2398661 */   GIM_Reject,
     /* 2398662 */ // Label 34330: @2398662
     /* 2398662 */ GIM_Reject,
     /* 2398663 */ // Label 34273: @2398663
     /* 2398663 */ GIM_Try, /*On fail goto*//*Label 34333*/ GIMT_Encode4(2398783),
     /* 2398668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2398671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2398674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398682 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398686 */   GIM_Try, /*On fail goto*//*Label 34334*/ GIMT_Encode4(2398734), // Rule ID 53542 //
     /* 2398691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398694 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2398697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2398711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398733 */     // GIR_Coverage, 53542,
     /* 2398733 */     GIR_EraseRootFromParent_Done,
     /* 2398734 */   // Label 34334: @2398734
     /* 2398734 */   GIM_Try, /*On fail goto*//*Label 34335*/ GIMT_Encode4(2398782), // Rule ID 53543 //
     /* 2398739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398742 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2398745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2398759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398781 */     // GIR_Coverage, 53543,
     /* 2398781 */     GIR_EraseRootFromParent_Done,
     /* 2398782 */   // Label 34335: @2398782
     /* 2398782 */   GIM_Reject,
     /* 2398783 */ // Label 34333: @2398783
     /* 2398783 */ GIM_Reject,
     /* 2398784 */ // Label 34274: @2398784
     /* 2398784 */ GIM_Reject,
     /* 2398785 */ // Label 100: @2398785
     /* 2398785 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34354*/ GIMT_Encode4(2401212),
     /* 2398796 */ /*GILLT_s16*//*Label 34336*/ GIMT_Encode4(2398916),
     /* 2398800 */ /*GILLT_s32*//*Label 34337*/ GIMT_Encode4(2399065),
     /* 2398804 */ /*GILLT_s64*//*Label 34338*/ GIMT_Encode4(2399214), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2398816 */ /*GILLT_nxv1s16*//*Label 34339*/ GIMT_Encode4(2399397),
     /* 2398820 */ /*GILLT_nxv1s32*//*Label 34340*/ GIMT_Encode4(2399518),
     /* 2398824 */ /*GILLT_nxv1s64*//*Label 34341*/ GIMT_Encode4(2399639), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2398836 */ /*GILLT_nxv2s16*//*Label 34342*/ GIMT_Encode4(2399760),
     /* 2398840 */ /*GILLT_nxv2s32*//*Label 34343*/ GIMT_Encode4(2399881),
     /* 2398844 */ /*GILLT_nxv2s64*//*Label 34344*/ GIMT_Encode4(2400002), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2398856 */ /*GILLT_nxv4s16*//*Label 34345*/ GIMT_Encode4(2400123),
     /* 2398860 */ /*GILLT_nxv4s32*//*Label 34346*/ GIMT_Encode4(2400244),
     /* 2398864 */ /*GILLT_nxv4s64*//*Label 34347*/ GIMT_Encode4(2400365), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2398876 */ /*GILLT_nxv8s16*//*Label 34348*/ GIMT_Encode4(2400486),
     /* 2398880 */ /*GILLT_nxv8s32*//*Label 34349*/ GIMT_Encode4(2400607),
     /* 2398884 */ /*GILLT_nxv8s64*//*Label 34350*/ GIMT_Encode4(2400728), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2398896 */ /*GILLT_nxv16s16*//*Label 34351*/ GIMT_Encode4(2400849),
     /* 2398900 */ /*GILLT_nxv16s32*//*Label 34352*/ GIMT_Encode4(2400970), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2398912 */ /*GILLT_nxv32s16*//*Label 34353*/ GIMT_Encode4(2401091),
     /* 2398916 */ // Label 34336: @2398916
     /* 2398916 */ GIM_Try, /*On fail goto*//*Label 34355*/ GIMT_Encode4(2399064),
     /* 2398921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2398924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2398927 */   GIM_Try, /*On fail goto*//*Label 34356*/ GIMT_Encode4(2398961), // Rule ID 1962 //
     /* 2398932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2398935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2398939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2398943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2398947 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2398947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2398950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398960 */     // GIR_Coverage, 1962,
     /* 2398960 */     GIR_EraseRootFromParent_Done,
     /* 2398961 */   // Label 34356: @2398961
     /* 2398961 */   GIM_Try, /*On fail goto*//*Label 34357*/ GIMT_Encode4(2398995), // Rule ID 1963 //
     /* 2398966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2398969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2398973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2398977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2398981 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2398981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2398984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398994 */     // GIR_Coverage, 1963,
     /* 2398994 */     GIR_EraseRootFromParent_Done,
     /* 2398995 */   // Label 34357: @2398995
     /* 2398995 */   GIM_Try, /*On fail goto*//*Label 34358*/ GIMT_Encode4(2399029), // Rule ID 1966 //
     /* 2399000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2399003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399015 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2399015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2399018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399028 */     // GIR_Coverage, 1966,
     /* 2399028 */     GIR_EraseRootFromParent_Done,
     /* 2399029 */   // Label 34358: @2399029
     /* 2399029 */   GIM_Try, /*On fail goto*//*Label 34359*/ GIMT_Encode4(2399063), // Rule ID 1967 //
     /* 2399034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2399037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399049 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2399049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2399052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399062 */     // GIR_Coverage, 1967,
     /* 2399062 */     GIR_EraseRootFromParent_Done,
     /* 2399063 */   // Label 34359: @2399063
     /* 2399063 */   GIM_Reject,
     /* 2399064 */ // Label 34355: @2399064
     /* 2399064 */ GIM_Reject,
     /* 2399065 */ // Label 34337: @2399065
     /* 2399065 */ GIM_Try, /*On fail goto*//*Label 34360*/ GIMT_Encode4(2399213),
     /* 2399070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2399073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2399076 */   GIM_Try, /*On fail goto*//*Label 34361*/ GIMT_Encode4(2399110), // Rule ID 1253 //
     /* 2399081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2399084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399096 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2399096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2399099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399109 */     // GIR_Coverage, 1253,
     /* 2399109 */     GIR_EraseRootFromParent_Done,
     /* 2399110 */   // Label 34361: @2399110
     /* 2399110 */   GIM_Try, /*On fail goto*//*Label 34362*/ GIMT_Encode4(2399144), // Rule ID 1254 //
     /* 2399115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2399118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399130 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2399130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2399133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399143 */     // GIR_Coverage, 1254,
     /* 2399143 */     GIR_EraseRootFromParent_Done,
     /* 2399144 */   // Label 34362: @2399144
     /* 2399144 */   GIM_Try, /*On fail goto*//*Label 34363*/ GIMT_Encode4(2399178), // Rule ID 1257 //
     /* 2399149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2399152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399164 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2399164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2399167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399177 */     // GIR_Coverage, 1257,
     /* 2399177 */     GIR_EraseRootFromParent_Done,
     /* 2399178 */   // Label 34363: @2399178
     /* 2399178 */   GIM_Try, /*On fail goto*//*Label 34364*/ GIMT_Encode4(2399212), // Rule ID 1258 //
     /* 2399183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2399186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399198 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2399198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2399201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399211 */     // GIR_Coverage, 1258,
     /* 2399211 */     GIR_EraseRootFromParent_Done,
     /* 2399212 */   // Label 34364: @2399212
     /* 2399212 */   GIM_Reject,
     /* 2399213 */ // Label 34360: @2399213
     /* 2399213 */ GIM_Reject,
     /* 2399214 */ // Label 34338: @2399214
     /* 2399214 */ GIM_Try, /*On fail goto*//*Label 34365*/ GIMT_Encode4(2399396),
     /* 2399219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2399222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2399225 */   GIM_Try, /*On fail goto*//*Label 34366*/ GIMT_Encode4(2399259), // Rule ID 1592 //
     /* 2399230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2399233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399245 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2399245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2399248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399258 */     // GIR_Coverage, 1592,
     /* 2399258 */     GIR_EraseRootFromParent_Done,
     /* 2399259 */   // Label 34366: @2399259
     /* 2399259 */   GIM_Try, /*On fail goto*//*Label 34367*/ GIMT_Encode4(2399293), // Rule ID 1593 //
     /* 2399264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2399267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399279 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2399279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2399282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399292 */     // GIR_Coverage, 1593,
     /* 2399292 */     GIR_EraseRootFromParent_Done,
     /* 2399293 */   // Label 34367: @2399293
     /* 2399293 */   GIM_Try, /*On fail goto*//*Label 34368*/ GIMT_Encode4(2399327), // Rule ID 1596 //
     /* 2399298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2399301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399313 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2399313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2399316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399326 */     // GIR_Coverage, 1596,
     /* 2399326 */     GIR_EraseRootFromParent_Done,
     /* 2399327 */   // Label 34368: @2399327
     /* 2399327 */   GIM_Try, /*On fail goto*//*Label 34369*/ GIMT_Encode4(2399361), // Rule ID 1597 //
     /* 2399332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2399335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399347 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2399347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2399350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399360 */     // GIR_Coverage, 1597,
     /* 2399360 */     GIR_EraseRootFromParent_Done,
     /* 2399361 */   // Label 34369: @2399361
     /* 2399361 */   GIM_Try, /*On fail goto*//*Label 34370*/ GIMT_Encode4(2399395), // Rule ID 1600 //
     /* 2399366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2399369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2399373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2399377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2399381 */     // (strict_fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2399381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2399384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399394 */     // GIR_Coverage, 1600,
     /* 2399394 */     GIR_EraseRootFromParent_Done,
     /* 2399395 */   // Label 34370: @2399395
     /* 2399395 */   GIM_Reject,
     /* 2399396 */ // Label 34365: @2399396
     /* 2399396 */ GIM_Reject,
     /* 2399397 */ // Label 34339: @2399397
     /* 2399397 */ GIM_Try, /*On fail goto*//*Label 34371*/ GIMT_Encode4(2399517),
     /* 2399402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2399405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2399408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399420 */   GIM_Try, /*On fail goto*//*Label 34372*/ GIMT_Encode4(2399468), // Rule ID 54214 //
     /* 2399425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399428 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2399431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2399445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399467 */     // GIR_Coverage, 54214,
     /* 2399467 */     GIR_EraseRootFromParent_Done,
     /* 2399468 */   // Label 34372: @2399468
     /* 2399468 */   GIM_Try, /*On fail goto*//*Label 34373*/ GIMT_Encode4(2399516), // Rule ID 54215 //
     /* 2399473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2399476 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2399479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2399493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399515 */     // GIR_Coverage, 54215,
     /* 2399515 */     GIR_EraseRootFromParent_Done,
     /* 2399516 */   // Label 34373: @2399516
     /* 2399516 */   GIM_Reject,
     /* 2399517 */ // Label 34371: @2399517
     /* 2399517 */ GIM_Reject,
     /* 2399518 */ // Label 34340: @2399518
     /* 2399518 */ GIM_Try, /*On fail goto*//*Label 34374*/ GIMT_Encode4(2399638),
     /* 2399523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2399526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2399529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399541 */   GIM_Try, /*On fail goto*//*Label 34375*/ GIMT_Encode4(2399589), // Rule ID 54238 //
     /* 2399546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2399549 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2399552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2399566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399588 */     // GIR_Coverage, 54238,
     /* 2399588 */     GIR_EraseRootFromParent_Done,
     /* 2399589 */   // Label 34375: @2399589
     /* 2399589 */   GIM_Try, /*On fail goto*//*Label 34376*/ GIMT_Encode4(2399637), // Rule ID 54239 //
     /* 2399594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2399597 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2399600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2399614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399636 */     // GIR_Coverage, 54239,
     /* 2399636 */     GIR_EraseRootFromParent_Done,
     /* 2399637 */   // Label 34376: @2399637
     /* 2399637 */   GIM_Reject,
     /* 2399638 */ // Label 34374: @2399638
     /* 2399638 */ GIM_Reject,
     /* 2399639 */ // Label 34341: @2399639
     /* 2399639 */ GIM_Try, /*On fail goto*//*Label 34377*/ GIMT_Encode4(2399759),
     /* 2399644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2399647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2399650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399662 */   GIM_Try, /*On fail goto*//*Label 34378*/ GIMT_Encode4(2399710), // Rule ID 54274 //
     /* 2399667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399670 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2399673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2399687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399709 */     // GIR_Coverage, 54274,
     /* 2399709 */     GIR_EraseRootFromParent_Done,
     /* 2399710 */   // Label 34378: @2399710
     /* 2399710 */   GIM_Try, /*On fail goto*//*Label 34379*/ GIMT_Encode4(2399758), // Rule ID 54275 //
     /* 2399715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399718 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2399721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2399735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399757 */     // GIR_Coverage, 54275,
     /* 2399757 */     GIR_EraseRootFromParent_Done,
     /* 2399758 */   // Label 34379: @2399758
     /* 2399758 */   GIM_Reject,
     /* 2399759 */ // Label 34377: @2399759
     /* 2399759 */ GIM_Reject,
     /* 2399760 */ // Label 34342: @2399760
     /* 2399760 */ GIM_Try, /*On fail goto*//*Label 34380*/ GIMT_Encode4(2399880),
     /* 2399765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2399768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2399771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399783 */   GIM_Try, /*On fail goto*//*Label 34381*/ GIMT_Encode4(2399831), // Rule ID 54226 //
     /* 2399788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399791 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2399794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2399808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399830 */     // GIR_Coverage, 54226,
     /* 2399830 */     GIR_EraseRootFromParent_Done,
     /* 2399831 */   // Label 34381: @2399831
     /* 2399831 */   GIM_Try, /*On fail goto*//*Label 34382*/ GIMT_Encode4(2399879), // Rule ID 54227 //
     /* 2399836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2399839 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2399842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2399856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399878 */     // GIR_Coverage, 54227,
     /* 2399878 */     GIR_EraseRootFromParent_Done,
     /* 2399879 */   // Label 34382: @2399879
     /* 2399879 */   GIM_Reject,
     /* 2399880 */ // Label 34380: @2399880
     /* 2399880 */ GIM_Reject,
     /* 2399881 */ // Label 34343: @2399881
     /* 2399881 */ GIM_Try, /*On fail goto*//*Label 34383*/ GIMT_Encode4(2400001),
     /* 2399886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2399889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2399892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399904 */   GIM_Try, /*On fail goto*//*Label 34384*/ GIMT_Encode4(2399952), // Rule ID 54262 //
     /* 2399909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2399912 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2399915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2399929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399951 */     // GIR_Coverage, 54262,
     /* 2399951 */     GIR_EraseRootFromParent_Done,
     /* 2399952 */   // Label 34384: @2399952
     /* 2399952 */   GIM_Try, /*On fail goto*//*Label 34385*/ GIMT_Encode4(2400000), // Rule ID 54263 //
     /* 2399957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2399960 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2399963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2399977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399999 */     // GIR_Coverage, 54263,
     /* 2399999 */     GIR_EraseRootFromParent_Done,
     /* 2400000 */   // Label 34385: @2400000
     /* 2400000 */   GIM_Reject,
     /* 2400001 */ // Label 34383: @2400001
     /* 2400001 */ GIM_Reject,
     /* 2400002 */ // Label 34344: @2400002
     /* 2400002 */ GIM_Try, /*On fail goto*//*Label 34386*/ GIMT_Encode4(2400122),
     /* 2400007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2400010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2400013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400025 */   GIM_Try, /*On fail goto*//*Label 34387*/ GIMT_Encode4(2400073), // Rule ID 54358 //
     /* 2400030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2400033 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2400036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2400050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400072 */     // GIR_Coverage, 54358,
     /* 2400072 */     GIR_EraseRootFromParent_Done,
     /* 2400073 */   // Label 34387: @2400073
     /* 2400073 */   GIM_Try, /*On fail goto*//*Label 34388*/ GIMT_Encode4(2400121), // Rule ID 54359 //
     /* 2400078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2400081 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2400084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2400098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400120 */     // GIR_Coverage, 54359,
     /* 2400120 */     GIR_EraseRootFromParent_Done,
     /* 2400121 */   // Label 34388: @2400121
     /* 2400121 */   GIM_Reject,
     /* 2400122 */ // Label 34386: @2400122
     /* 2400122 */ GIM_Reject,
     /* 2400123 */ // Label 34345: @2400123
     /* 2400123 */ GIM_Try, /*On fail goto*//*Label 34389*/ GIMT_Encode4(2400243),
     /* 2400128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2400131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2400134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400146 */   GIM_Try, /*On fail goto*//*Label 34390*/ GIMT_Encode4(2400194), // Rule ID 54250 //
     /* 2400151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400154 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2400157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2400171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400193 */     // GIR_Coverage, 54250,
     /* 2400193 */     GIR_EraseRootFromParent_Done,
     /* 2400194 */   // Label 34390: @2400194
     /* 2400194 */   GIM_Try, /*On fail goto*//*Label 34391*/ GIMT_Encode4(2400242), // Rule ID 54251 //
     /* 2400199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400202 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2400205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2400219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400241 */     // GIR_Coverage, 54251,
     /* 2400241 */     GIR_EraseRootFromParent_Done,
     /* 2400242 */   // Label 34391: @2400242
     /* 2400242 */   GIM_Reject,
     /* 2400243 */ // Label 34389: @2400243
     /* 2400243 */ GIM_Reject,
     /* 2400244 */ // Label 34346: @2400244
     /* 2400244 */ GIM_Try, /*On fail goto*//*Label 34392*/ GIMT_Encode4(2400364),
     /* 2400249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2400255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400267 */   GIM_Try, /*On fail goto*//*Label 34393*/ GIMT_Encode4(2400315), // Rule ID 54322 //
     /* 2400272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400275 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2400278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2400292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400314 */     // GIR_Coverage, 54322,
     /* 2400314 */     GIR_EraseRootFromParent_Done,
     /* 2400315 */   // Label 34393: @2400315
     /* 2400315 */   GIM_Try, /*On fail goto*//*Label 34394*/ GIMT_Encode4(2400363), // Rule ID 54323 //
     /* 2400320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400323 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2400326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2400340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400362 */     // GIR_Coverage, 54323,
     /* 2400362 */     GIR_EraseRootFromParent_Done,
     /* 2400363 */   // Label 34394: @2400363
     /* 2400363 */   GIM_Reject,
     /* 2400364 */ // Label 34392: @2400364
     /* 2400364 */ GIM_Reject,
     /* 2400365 */ // Label 34347: @2400365
     /* 2400365 */ GIM_Try, /*On fail goto*//*Label 34395*/ GIMT_Encode4(2400485),
     /* 2400370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2400373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2400376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400384 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400388 */   GIM_Try, /*On fail goto*//*Label 34396*/ GIMT_Encode4(2400436), // Rule ID 54370 //
     /* 2400393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2400396 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2400399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2400413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400435 */     // GIR_Coverage, 54370,
     /* 2400435 */     GIR_EraseRootFromParent_Done,
     /* 2400436 */   // Label 34396: @2400436
     /* 2400436 */   GIM_Try, /*On fail goto*//*Label 34397*/ GIMT_Encode4(2400484), // Rule ID 54371 //
     /* 2400441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2400444 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2400447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2400461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400483 */     // GIR_Coverage, 54371,
     /* 2400483 */     GIR_EraseRootFromParent_Done,
     /* 2400484 */   // Label 34397: @2400484
     /* 2400484 */   GIM_Reject,
     /* 2400485 */ // Label 34395: @2400485
     /* 2400485 */ GIM_Reject,
     /* 2400486 */ // Label 34348: @2400486
     /* 2400486 */ GIM_Try, /*On fail goto*//*Label 34398*/ GIMT_Encode4(2400606),
     /* 2400491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2400494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2400497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400509 */   GIM_Try, /*On fail goto*//*Label 34399*/ GIMT_Encode4(2400557), // Rule ID 54286 //
     /* 2400514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400517 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2400520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2400534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400556 */     // GIR_Coverage, 54286,
     /* 2400556 */     GIR_EraseRootFromParent_Done,
     /* 2400557 */   // Label 34399: @2400557
     /* 2400557 */   GIM_Try, /*On fail goto*//*Label 34400*/ GIMT_Encode4(2400605), // Rule ID 54287 //
     /* 2400562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400565 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2400568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2400582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400604 */     // GIR_Coverage, 54287,
     /* 2400604 */     GIR_EraseRootFromParent_Done,
     /* 2400605 */   // Label 34400: @2400605
     /* 2400605 */   GIM_Reject,
     /* 2400606 */ // Label 34398: @2400606
     /* 2400606 */ GIM_Reject,
     /* 2400607 */ // Label 34349: @2400607
     /* 2400607 */ GIM_Try, /*On fail goto*//*Label 34401*/ GIMT_Encode4(2400727),
     /* 2400612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2400615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2400618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400626 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400630 */   GIM_Try, /*On fail goto*//*Label 34402*/ GIMT_Encode4(2400678), // Rule ID 54334 //
     /* 2400635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400638 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2400641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2400655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400677 */     // GIR_Coverage, 54334,
     /* 2400677 */     GIR_EraseRootFromParent_Done,
     /* 2400678 */   // Label 34402: @2400678
     /* 2400678 */   GIM_Try, /*On fail goto*//*Label 34403*/ GIMT_Encode4(2400726), // Rule ID 54335 //
     /* 2400683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400686 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2400689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2400703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400725 */     // GIR_Coverage, 54335,
     /* 2400725 */     GIR_EraseRootFromParent_Done,
     /* 2400726 */   // Label 34403: @2400726
     /* 2400726 */   GIM_Reject,
     /* 2400727 */ // Label 34401: @2400727
     /* 2400727 */ GIM_Reject,
     /* 2400728 */ // Label 34350: @2400728
     /* 2400728 */ GIM_Try, /*On fail goto*//*Label 34404*/ GIMT_Encode4(2400848),
     /* 2400733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2400736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2400739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400751 */   GIM_Try, /*On fail goto*//*Label 34405*/ GIMT_Encode4(2400799), // Rule ID 54382 //
     /* 2400756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2400759 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2400762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2400776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400798 */     // GIR_Coverage, 54382,
     /* 2400798 */     GIR_EraseRootFromParent_Done,
     /* 2400799 */   // Label 34405: @2400799
     /* 2400799 */   GIM_Try, /*On fail goto*//*Label 34406*/ GIMT_Encode4(2400847), // Rule ID 54383 //
     /* 2400804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2400807 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2400810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2400824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400846 */     // GIR_Coverage, 54383,
     /* 2400846 */     GIR_EraseRootFromParent_Done,
     /* 2400847 */   // Label 34406: @2400847
     /* 2400847 */   GIM_Reject,
     /* 2400848 */ // Label 34404: @2400848
     /* 2400848 */ GIM_Reject,
     /* 2400849 */ // Label 34351: @2400849
     /* 2400849 */ GIM_Try, /*On fail goto*//*Label 34407*/ GIMT_Encode4(2400969),
     /* 2400854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2400860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400872 */   GIM_Try, /*On fail goto*//*Label 34408*/ GIMT_Encode4(2400920), // Rule ID 54298 //
     /* 2400877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400880 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2400883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2400897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400919 */     // GIR_Coverage, 54298,
     /* 2400919 */     GIR_EraseRootFromParent_Done,
     /* 2400920 */   // Label 34408: @2400920
     /* 2400920 */   GIM_Try, /*On fail goto*//*Label 34409*/ GIMT_Encode4(2400968), // Rule ID 54299 //
     /* 2400925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400928 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2400931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2400945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400967 */     // GIR_Coverage, 54299,
     /* 2400967 */     GIR_EraseRootFromParent_Done,
     /* 2400968 */   // Label 34409: @2400968
     /* 2400968 */   GIM_Reject,
     /* 2400969 */ // Label 34407: @2400969
     /* 2400969 */ GIM_Reject,
     /* 2400970 */ // Label 34352: @2400970
     /* 2400970 */ GIM_Try, /*On fail goto*//*Label 34410*/ GIMT_Encode4(2401090),
     /* 2400975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2400978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2400981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400993 */   GIM_Try, /*On fail goto*//*Label 34411*/ GIMT_Encode4(2401041), // Rule ID 54346 //
     /* 2400998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401001 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2401004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2401018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401040 */     // GIR_Coverage, 54346,
     /* 2401040 */     GIR_EraseRootFromParent_Done,
     /* 2401041 */   // Label 34411: @2401041
     /* 2401041 */   GIM_Try, /*On fail goto*//*Label 34412*/ GIMT_Encode4(2401089), // Rule ID 54347 //
     /* 2401046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401049 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2401052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2401066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401088 */     // GIR_Coverage, 54347,
     /* 2401088 */     GIR_EraseRootFromParent_Done,
     /* 2401089 */   // Label 34412: @2401089
     /* 2401089 */   GIM_Reject,
     /* 2401090 */ // Label 34410: @2401090
     /* 2401090 */ GIM_Reject,
     /* 2401091 */ // Label 34353: @2401091
     /* 2401091 */ GIM_Try, /*On fail goto*//*Label 34413*/ GIMT_Encode4(2401211),
     /* 2401096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2401099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2401102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401114 */   GIM_Try, /*On fail goto*//*Label 34414*/ GIMT_Encode4(2401162), // Rule ID 54310 //
     /* 2401119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401122 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2401125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2401139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401161 */     // GIR_Coverage, 54310,
     /* 2401161 */     GIR_EraseRootFromParent_Done,
     /* 2401162 */   // Label 34414: @2401162
     /* 2401162 */   GIM_Try, /*On fail goto*//*Label 34415*/ GIMT_Encode4(2401210), // Rule ID 54311 //
     /* 2401167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2401170 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2401173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2401187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401209 */     // GIR_Coverage, 54311,
     /* 2401209 */     GIR_EraseRootFromParent_Done,
     /* 2401210 */   // Label 34415: @2401210
     /* 2401210 */   GIM_Reject,
     /* 2401211 */ // Label 34413: @2401211
     /* 2401211 */ GIM_Reject,
     /* 2401212 */ // Label 34354: @2401212
     /* 2401212 */ GIM_Reject,
     /* 2401213 */ // Label 101: @2401213
     /* 2401213 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34434*/ GIMT_Encode4(2403640),
     /* 2401224 */ /*GILLT_s16*//*Label 34416*/ GIMT_Encode4(2401344),
     /* 2401228 */ /*GILLT_s32*//*Label 34417*/ GIMT_Encode4(2401493),
     /* 2401232 */ /*GILLT_s64*//*Label 34418*/ GIMT_Encode4(2401642), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401244 */ /*GILLT_nxv1s16*//*Label 34419*/ GIMT_Encode4(2401825),
     /* 2401248 */ /*GILLT_nxv1s32*//*Label 34420*/ GIMT_Encode4(2401946),
     /* 2401252 */ /*GILLT_nxv1s64*//*Label 34421*/ GIMT_Encode4(2402067), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401264 */ /*GILLT_nxv2s16*//*Label 34422*/ GIMT_Encode4(2402188),
     /* 2401268 */ /*GILLT_nxv2s32*//*Label 34423*/ GIMT_Encode4(2402309),
     /* 2401272 */ /*GILLT_nxv2s64*//*Label 34424*/ GIMT_Encode4(2402430), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401284 */ /*GILLT_nxv4s16*//*Label 34425*/ GIMT_Encode4(2402551),
     /* 2401288 */ /*GILLT_nxv4s32*//*Label 34426*/ GIMT_Encode4(2402672),
     /* 2401292 */ /*GILLT_nxv4s64*//*Label 34427*/ GIMT_Encode4(2402793), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401304 */ /*GILLT_nxv8s16*//*Label 34428*/ GIMT_Encode4(2402914),
     /* 2401308 */ /*GILLT_nxv8s32*//*Label 34429*/ GIMT_Encode4(2403035),
     /* 2401312 */ /*GILLT_nxv8s64*//*Label 34430*/ GIMT_Encode4(2403156), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401324 */ /*GILLT_nxv16s16*//*Label 34431*/ GIMT_Encode4(2403277),
     /* 2401328 */ /*GILLT_nxv16s32*//*Label 34432*/ GIMT_Encode4(2403398), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401340 */ /*GILLT_nxv32s16*//*Label 34433*/ GIMT_Encode4(2403519),
     /* 2401344 */ // Label 34416: @2401344
     /* 2401344 */ GIM_Try, /*On fail goto*//*Label 34435*/ GIMT_Encode4(2401492),
     /* 2401349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2401355 */   GIM_Try, /*On fail goto*//*Label 34436*/ GIMT_Encode4(2401389), // Rule ID 1970 //
     /* 2401360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2401363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401375 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2401375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2401378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401388 */     // GIR_Coverage, 1970,
     /* 2401388 */     GIR_EraseRootFromParent_Done,
     /* 2401389 */   // Label 34436: @2401389
     /* 2401389 */   GIM_Try, /*On fail goto*//*Label 34437*/ GIMT_Encode4(2401423), // Rule ID 1971 //
     /* 2401394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2401397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401409 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2401409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2401412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401422 */     // GIR_Coverage, 1971,
     /* 2401422 */     GIR_EraseRootFromParent_Done,
     /* 2401423 */   // Label 34437: @2401423
     /* 2401423 */   GIM_Try, /*On fail goto*//*Label 34438*/ GIMT_Encode4(2401457), // Rule ID 1974 //
     /* 2401428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2401431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401443 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2401443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2401446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401456 */     // GIR_Coverage, 1974,
     /* 2401456 */     GIR_EraseRootFromParent_Done,
     /* 2401457 */   // Label 34438: @2401457
     /* 2401457 */   GIM_Try, /*On fail goto*//*Label 34439*/ GIMT_Encode4(2401491), // Rule ID 1975 //
     /* 2401462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2401465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401477 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2401477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2401480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401490 */     // GIR_Coverage, 1975,
     /* 2401490 */     GIR_EraseRootFromParent_Done,
     /* 2401491 */   // Label 34439: @2401491
     /* 2401491 */   GIM_Reject,
     /* 2401492 */ // Label 34435: @2401492
     /* 2401492 */ GIM_Reject,
     /* 2401493 */ // Label 34417: @2401493
     /* 2401493 */ GIM_Try, /*On fail goto*//*Label 34440*/ GIMT_Encode4(2401641),
     /* 2401498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2401501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2401504 */   GIM_Try, /*On fail goto*//*Label 34441*/ GIMT_Encode4(2401538), // Rule ID 1261 //
     /* 2401509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2401512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2401516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2401520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2401524 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2401524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2401527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401537 */     // GIR_Coverage, 1261,
     /* 2401537 */     GIR_EraseRootFromParent_Done,
     /* 2401538 */   // Label 34441: @2401538
     /* 2401538 */   GIM_Try, /*On fail goto*//*Label 34442*/ GIMT_Encode4(2401572), // Rule ID 1262 //
     /* 2401543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2401546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2401550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2401554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2401558 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2401558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2401561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401571 */     // GIR_Coverage, 1262,
     /* 2401571 */     GIR_EraseRootFromParent_Done,
     /* 2401572 */   // Label 34442: @2401572
     /* 2401572 */   GIM_Try, /*On fail goto*//*Label 34443*/ GIMT_Encode4(2401606), // Rule ID 1265 //
     /* 2401577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2401580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2401584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2401588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2401592 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2401592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2401595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401605 */     // GIR_Coverage, 1265,
     /* 2401605 */     GIR_EraseRootFromParent_Done,
     /* 2401606 */   // Label 34443: @2401606
     /* 2401606 */   GIM_Try, /*On fail goto*//*Label 34444*/ GIMT_Encode4(2401640), // Rule ID 1266 //
     /* 2401611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2401614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2401618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2401622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2401626 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2401626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2401629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401639 */     // GIR_Coverage, 1266,
     /* 2401639 */     GIR_EraseRootFromParent_Done,
     /* 2401640 */   // Label 34444: @2401640
     /* 2401640 */   GIM_Reject,
     /* 2401641 */ // Label 34440: @2401641
     /* 2401641 */ GIM_Reject,
     /* 2401642 */ // Label 34418: @2401642
     /* 2401642 */ GIM_Try, /*On fail goto*//*Label 34445*/ GIMT_Encode4(2401824),
     /* 2401647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2401650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2401653 */   GIM_Try, /*On fail goto*//*Label 34446*/ GIMT_Encode4(2401687), // Rule ID 1602 //
     /* 2401658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2401661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2401665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2401669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2401673 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2401673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2401676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401686 */     // GIR_Coverage, 1602,
     /* 2401686 */     GIR_EraseRootFromParent_Done,
     /* 2401687 */   // Label 34446: @2401687
     /* 2401687 */   GIM_Try, /*On fail goto*//*Label 34447*/ GIMT_Encode4(2401721), // Rule ID 1603 //
     /* 2401692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2401695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2401699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2401703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2401707 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2401707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2401710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401720 */     // GIR_Coverage, 1603,
     /* 2401720 */     GIR_EraseRootFromParent_Done,
     /* 2401721 */   // Label 34447: @2401721
     /* 2401721 */   GIM_Try, /*On fail goto*//*Label 34448*/ GIMT_Encode4(2401755), // Rule ID 1606 //
     /* 2401726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2401729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2401733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2401737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2401741 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2401741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2401744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401754 */     // GIR_Coverage, 1606,
     /* 2401754 */     GIR_EraseRootFromParent_Done,
     /* 2401755 */   // Label 34448: @2401755
     /* 2401755 */   GIM_Try, /*On fail goto*//*Label 34449*/ GIMT_Encode4(2401789), // Rule ID 1607 //
     /* 2401760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2401763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2401767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2401771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2401775 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2401775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2401778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401788 */     // GIR_Coverage, 1607,
     /* 2401788 */     GIR_EraseRootFromParent_Done,
     /* 2401789 */   // Label 34449: @2401789
     /* 2401789 */   GIM_Try, /*On fail goto*//*Label 34450*/ GIMT_Encode4(2401823), // Rule ID 1610 //
     /* 2401794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2401797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2401801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2401805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2401809 */     // (strict_fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2401809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2401812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401822 */     // GIR_Coverage, 1610,
     /* 2401822 */     GIR_EraseRootFromParent_Done,
     /* 2401823 */   // Label 34450: @2401823
     /* 2401823 */   GIM_Reject,
     /* 2401824 */ // Label 34445: @2401824
     /* 2401824 */ GIM_Reject,
     /* 2401825 */ // Label 34419: @2401825
     /* 2401825 */ GIM_Try, /*On fail goto*//*Label 34451*/ GIMT_Encode4(2401945),
     /* 2401830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2401833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2401836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401848 */   GIM_Try, /*On fail goto*//*Label 34452*/ GIMT_Encode4(2401896), // Rule ID 54394 //
     /* 2401853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401856 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2401859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2401873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401895 */     // GIR_Coverage, 54394,
     /* 2401895 */     GIR_EraseRootFromParent_Done,
     /* 2401896 */   // Label 34452: @2401896
     /* 2401896 */   GIM_Try, /*On fail goto*//*Label 34453*/ GIMT_Encode4(2401944), // Rule ID 54395 //
     /* 2401901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2401904 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2401907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2401921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401943 */     // GIR_Coverage, 54395,
     /* 2401943 */     GIR_EraseRootFromParent_Done,
     /* 2401944 */   // Label 34453: @2401944
     /* 2401944 */   GIM_Reject,
     /* 2401945 */ // Label 34451: @2401945
     /* 2401945 */ GIM_Reject,
     /* 2401946 */ // Label 34420: @2401946
     /* 2401946 */ GIM_Try, /*On fail goto*//*Label 34454*/ GIMT_Encode4(2402066),
     /* 2401951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2401954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2401957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401969 */   GIM_Try, /*On fail goto*//*Label 34455*/ GIMT_Encode4(2402017), // Rule ID 54418 //
     /* 2401974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401977 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2401980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2401994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402016 */     // GIR_Coverage, 54418,
     /* 2402016 */     GIR_EraseRootFromParent_Done,
     /* 2402017 */   // Label 34455: @2402017
     /* 2402017 */   GIM_Try, /*On fail goto*//*Label 34456*/ GIMT_Encode4(2402065), // Rule ID 54419 //
     /* 2402022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2402025 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2402028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2402042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402064 */     // GIR_Coverage, 54419,
     /* 2402064 */     GIR_EraseRootFromParent_Done,
     /* 2402065 */   // Label 34456: @2402065
     /* 2402065 */   GIM_Reject,
     /* 2402066 */ // Label 34454: @2402066
     /* 2402066 */ GIM_Reject,
     /* 2402067 */ // Label 34421: @2402067
     /* 2402067 */ GIM_Try, /*On fail goto*//*Label 34457*/ GIMT_Encode4(2402187),
     /* 2402072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2402075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2402078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2402082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2402086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2402090 */   GIM_Try, /*On fail goto*//*Label 34458*/ GIMT_Encode4(2402138), // Rule ID 54454 //
     /* 2402095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2402098 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2402101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2402115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2402133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402137 */     // GIR_Coverage, 54454,
     /* 2402137 */     GIR_EraseRootFromParent_Done,
     /* 2402138 */   // Label 34458: @2402138
     /* 2402138 */   GIM_Try, /*On fail goto*//*Label 34459*/ GIMT_Encode4(2402186), // Rule ID 54455 //
     /* 2402143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2402146 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2402149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2402163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2402181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402185 */     // GIR_Coverage, 54455,
     /* 2402185 */     GIR_EraseRootFromParent_Done,
     /* 2402186 */   // Label 34459: @2402186
     /* 2402186 */   GIM_Reject,
     /* 2402187 */ // Label 34457: @2402187
     /* 2402187 */ GIM_Reject,
     /* 2402188 */ // Label 34422: @2402188
     /* 2402188 */ GIM_Try, /*On fail goto*//*Label 34460*/ GIMT_Encode4(2402308),
     /* 2402193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2402196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2402199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2402203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2402207 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2402211 */   GIM_Try, /*On fail goto*//*Label 34461*/ GIMT_Encode4(2402259), // Rule ID 54406 //
     /* 2402216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402219 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2402222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2402236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402258 */     // GIR_Coverage, 54406,
     /* 2402258 */     GIR_EraseRootFromParent_Done,
     /* 2402259 */   // Label 34461: @2402259
     /* 2402259 */   GIM_Try, /*On fail goto*//*Label 34462*/ GIMT_Encode4(2402307), // Rule ID 54407 //
     /* 2402264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402267 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2402270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2402284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402306 */     // GIR_Coverage, 54407,
     /* 2402306 */     GIR_EraseRootFromParent_Done,
     /* 2402307 */   // Label 34462: @2402307
     /* 2402307 */   GIM_Reject,
     /* 2402308 */ // Label 34460: @2402308
     /* 2402308 */ GIM_Reject,
     /* 2402309 */ // Label 34423: @2402309
     /* 2402309 */ GIM_Try, /*On fail goto*//*Label 34463*/ GIMT_Encode4(2402429),
     /* 2402314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2402317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2402320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2402324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2402328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2402332 */   GIM_Try, /*On fail goto*//*Label 34464*/ GIMT_Encode4(2402380), // Rule ID 54442 //
     /* 2402337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2402340 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2402343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2402357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402379 */     // GIR_Coverage, 54442,
     /* 2402379 */     GIR_EraseRootFromParent_Done,
     /* 2402380 */   // Label 34464: @2402380
     /* 2402380 */   GIM_Try, /*On fail goto*//*Label 34465*/ GIMT_Encode4(2402428), // Rule ID 54443 //
     /* 2402385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2402388 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2402391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2402405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402427 */     // GIR_Coverage, 54443,
     /* 2402427 */     GIR_EraseRootFromParent_Done,
     /* 2402428 */   // Label 34465: @2402428
     /* 2402428 */   GIM_Reject,
     /* 2402429 */ // Label 34463: @2402429
     /* 2402429 */ GIM_Reject,
     /* 2402430 */ // Label 34424: @2402430
     /* 2402430 */ GIM_Try, /*On fail goto*//*Label 34466*/ GIMT_Encode4(2402550),
     /* 2402435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2402438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2402441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402453 */   GIM_Try, /*On fail goto*//*Label 34467*/ GIMT_Encode4(2402501), // Rule ID 54538 //
     /* 2402458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2402461 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2402464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2402478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2402496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402500 */     // GIR_Coverage, 54538,
     /* 2402500 */     GIR_EraseRootFromParent_Done,
     /* 2402501 */   // Label 34467: @2402501
     /* 2402501 */   GIM_Try, /*On fail goto*//*Label 34468*/ GIMT_Encode4(2402549), // Rule ID 54539 //
     /* 2402506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2402509 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2402512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2402526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2402544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402548 */     // GIR_Coverage, 54539,
     /* 2402548 */     GIR_EraseRootFromParent_Done,
     /* 2402549 */   // Label 34468: @2402549
     /* 2402549 */   GIM_Reject,
     /* 2402550 */ // Label 34466: @2402550
     /* 2402550 */ GIM_Reject,
     /* 2402551 */ // Label 34425: @2402551
     /* 2402551 */ GIM_Try, /*On fail goto*//*Label 34469*/ GIMT_Encode4(2402671),
     /* 2402556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2402559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2402562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2402566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2402570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2402574 */   GIM_Try, /*On fail goto*//*Label 34470*/ GIMT_Encode4(2402622), // Rule ID 54430 //
     /* 2402579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402582 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2402585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2402599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402621 */     // GIR_Coverage, 54430,
     /* 2402621 */     GIR_EraseRootFromParent_Done,
     /* 2402622 */   // Label 34470: @2402622
     /* 2402622 */   GIM_Try, /*On fail goto*//*Label 34471*/ GIMT_Encode4(2402670), // Rule ID 54431 //
     /* 2402627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402630 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2402633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2402647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402669 */     // GIR_Coverage, 54431,
     /* 2402669 */     GIR_EraseRootFromParent_Done,
     /* 2402670 */   // Label 34471: @2402670
     /* 2402670 */   GIM_Reject,
     /* 2402671 */ // Label 34469: @2402671
     /* 2402671 */ GIM_Reject,
     /* 2402672 */ // Label 34426: @2402672
     /* 2402672 */ GIM_Try, /*On fail goto*//*Label 34472*/ GIMT_Encode4(2402792),
     /* 2402677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2402680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2402683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402695 */   GIM_Try, /*On fail goto*//*Label 34473*/ GIMT_Encode4(2402743), // Rule ID 54502 //
     /* 2402700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2402703 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2402706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2402720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402742 */     // GIR_Coverage, 54502,
     /* 2402742 */     GIR_EraseRootFromParent_Done,
     /* 2402743 */   // Label 34473: @2402743
     /* 2402743 */   GIM_Try, /*On fail goto*//*Label 34474*/ GIMT_Encode4(2402791), // Rule ID 54503 //
     /* 2402748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2402751 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2402754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2402768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402790 */     // GIR_Coverage, 54503,
     /* 2402790 */     GIR_EraseRootFromParent_Done,
     /* 2402791 */   // Label 34474: @2402791
     /* 2402791 */   GIM_Reject,
     /* 2402792 */ // Label 34472: @2402792
     /* 2402792 */ GIM_Reject,
     /* 2402793 */ // Label 34427: @2402793
     /* 2402793 */ GIM_Try, /*On fail goto*//*Label 34475*/ GIMT_Encode4(2402913),
     /* 2402798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2402801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2402804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402816 */   GIM_Try, /*On fail goto*//*Label 34476*/ GIMT_Encode4(2402864), // Rule ID 54550 //
     /* 2402821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2402824 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2402827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2402841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2402859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402863 */     // GIR_Coverage, 54550,
     /* 2402863 */     GIR_EraseRootFromParent_Done,
     /* 2402864 */   // Label 34476: @2402864
     /* 2402864 */   GIM_Try, /*On fail goto*//*Label 34477*/ GIMT_Encode4(2402912), // Rule ID 54551 //
     /* 2402869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2402872 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2402875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2402889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2402907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402911 */     // GIR_Coverage, 54551,
     /* 2402911 */     GIR_EraseRootFromParent_Done,
     /* 2402912 */   // Label 34477: @2402912
     /* 2402912 */   GIM_Reject,
     /* 2402913 */ // Label 34475: @2402913
     /* 2402913 */ GIM_Reject,
     /* 2402914 */ // Label 34428: @2402914
     /* 2402914 */ GIM_Try, /*On fail goto*//*Label 34478*/ GIMT_Encode4(2403034),
     /* 2402919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2402925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402937 */   GIM_Try, /*On fail goto*//*Label 34479*/ GIMT_Encode4(2402985), // Rule ID 54466 //
     /* 2402942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402945 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2402948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2402962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402984 */     // GIR_Coverage, 54466,
     /* 2402984 */     GIR_EraseRootFromParent_Done,
     /* 2402985 */   // Label 34479: @2402985
     /* 2402985 */   GIM_Try, /*On fail goto*//*Label 34480*/ GIMT_Encode4(2403033), // Rule ID 54467 //
     /* 2402990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402993 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2402996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2403010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403032 */     // GIR_Coverage, 54467,
     /* 2403032 */     GIR_EraseRootFromParent_Done,
     /* 2403033 */   // Label 34480: @2403033
     /* 2403033 */   GIM_Reject,
     /* 2403034 */ // Label 34478: @2403034
     /* 2403034 */ GIM_Reject,
     /* 2403035 */ // Label 34429: @2403035
     /* 2403035 */ GIM_Try, /*On fail goto*//*Label 34481*/ GIMT_Encode4(2403155),
     /* 2403040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2403043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2403046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403058 */   GIM_Try, /*On fail goto*//*Label 34482*/ GIMT_Encode4(2403106), // Rule ID 54514 //
     /* 2403063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403066 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2403069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2403083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403105 */     // GIR_Coverage, 54514,
     /* 2403105 */     GIR_EraseRootFromParent_Done,
     /* 2403106 */   // Label 34482: @2403106
     /* 2403106 */   GIM_Try, /*On fail goto*//*Label 34483*/ GIMT_Encode4(2403154), // Rule ID 54515 //
     /* 2403111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403114 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2403117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2403131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403153 */     // GIR_Coverage, 54515,
     /* 2403153 */     GIR_EraseRootFromParent_Done,
     /* 2403154 */   // Label 34483: @2403154
     /* 2403154 */   GIM_Reject,
     /* 2403155 */ // Label 34481: @2403155
     /* 2403155 */ GIM_Reject,
     /* 2403156 */ // Label 34430: @2403156
     /* 2403156 */ GIM_Try, /*On fail goto*//*Label 34484*/ GIMT_Encode4(2403276),
     /* 2403161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2403164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2403167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403179 */   GIM_Try, /*On fail goto*//*Label 34485*/ GIMT_Encode4(2403227), // Rule ID 54562 //
     /* 2403184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2403187 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2403190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2403204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403226 */     // GIR_Coverage, 54562,
     /* 2403226 */     GIR_EraseRootFromParent_Done,
     /* 2403227 */   // Label 34485: @2403227
     /* 2403227 */   GIM_Try, /*On fail goto*//*Label 34486*/ GIMT_Encode4(2403275), // Rule ID 54563 //
     /* 2403232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2403235 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2403238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2403252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403274 */     // GIR_Coverage, 54563,
     /* 2403274 */     GIR_EraseRootFromParent_Done,
     /* 2403275 */   // Label 34486: @2403275
     /* 2403275 */   GIM_Reject,
     /* 2403276 */ // Label 34484: @2403276
     /* 2403276 */ GIM_Reject,
     /* 2403277 */ // Label 34431: @2403277
     /* 2403277 */ GIM_Try, /*On fail goto*//*Label 34487*/ GIMT_Encode4(2403397),
     /* 2403282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2403285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2403288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403300 */   GIM_Try, /*On fail goto*//*Label 34488*/ GIMT_Encode4(2403348), // Rule ID 54478 //
     /* 2403305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2403308 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2403311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2403325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403347 */     // GIR_Coverage, 54478,
     /* 2403347 */     GIR_EraseRootFromParent_Done,
     /* 2403348 */   // Label 34488: @2403348
     /* 2403348 */   GIM_Try, /*On fail goto*//*Label 34489*/ GIMT_Encode4(2403396), // Rule ID 54479 //
     /* 2403353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2403356 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2403359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2403373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403395 */     // GIR_Coverage, 54479,
     /* 2403395 */     GIR_EraseRootFromParent_Done,
     /* 2403396 */   // Label 34489: @2403396
     /* 2403396 */   GIM_Reject,
     /* 2403397 */ // Label 34487: @2403397
     /* 2403397 */ GIM_Reject,
     /* 2403398 */ // Label 34432: @2403398
     /* 2403398 */ GIM_Try, /*On fail goto*//*Label 34490*/ GIMT_Encode4(2403518),
     /* 2403403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2403406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2403409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403417 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403421 */   GIM_Try, /*On fail goto*//*Label 34491*/ GIMT_Encode4(2403469), // Rule ID 54526 //
     /* 2403426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403429 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2403432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2403446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403468 */     // GIR_Coverage, 54526,
     /* 2403468 */     GIR_EraseRootFromParent_Done,
     /* 2403469 */   // Label 34491: @2403469
     /* 2403469 */   GIM_Try, /*On fail goto*//*Label 34492*/ GIMT_Encode4(2403517), // Rule ID 54527 //
     /* 2403474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403477 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2403480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2403494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403516 */     // GIR_Coverage, 54527,
     /* 2403516 */     GIR_EraseRootFromParent_Done,
     /* 2403517 */   // Label 34492: @2403517
     /* 2403517 */   GIM_Reject,
     /* 2403518 */ // Label 34490: @2403518
     /* 2403518 */ GIM_Reject,
     /* 2403519 */ // Label 34433: @2403519
     /* 2403519 */ GIM_Try, /*On fail goto*//*Label 34493*/ GIMT_Encode4(2403639),
     /* 2403524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2403527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2403530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403542 */   GIM_Try, /*On fail goto*//*Label 34494*/ GIMT_Encode4(2403590), // Rule ID 54490 //
     /* 2403547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2403550 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2403553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2403567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403589 */     // GIR_Coverage, 54490,
     /* 2403589 */     GIR_EraseRootFromParent_Done,
     /* 2403590 */   // Label 34494: @2403590
     /* 2403590 */   GIM_Try, /*On fail goto*//*Label 34495*/ GIMT_Encode4(2403638), // Rule ID 54491 //
     /* 2403595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2403598 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2403601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2403615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403637 */     // GIR_Coverage, 54491,
     /* 2403637 */     GIR_EraseRootFromParent_Done,
     /* 2403638 */   // Label 34495: @2403638
     /* 2403638 */   GIM_Reject,
     /* 2403639 */ // Label 34493: @2403639
     /* 2403639 */ GIM_Reject,
     /* 2403640 */ // Label 34434: @2403640
     /* 2403640 */ GIM_Reject,
     /* 2403641 */ // Label 102: @2403641
     /* 2403641 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34514*/ GIMT_Encode4(2420285),
     /* 2403652 */ /*GILLT_s16*//*Label 34496*/ GIMT_Encode4(2403772),
     /* 2403656 */ /*GILLT_s32*//*Label 34497*/ GIMT_Encode4(2405208),
     /* 2403660 */ /*GILLT_s64*//*Label 34498*/ GIMT_Encode4(2406644), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2403672 */ /*GILLT_nxv1s16*//*Label 34499*/ GIMT_Encode4(2408435),
     /* 2403676 */ /*GILLT_nxv1s32*//*Label 34500*/ GIMT_Encode4(2409225),
     /* 2403680 */ /*GILLT_nxv1s64*//*Label 34501*/ GIMT_Encode4(2410015), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2403692 */ /*GILLT_nxv2s16*//*Label 34502*/ GIMT_Encode4(2410805),
     /* 2403696 */ /*GILLT_nxv2s32*//*Label 34503*/ GIMT_Encode4(2411595),
     /* 2403700 */ /*GILLT_nxv2s64*//*Label 34504*/ GIMT_Encode4(2412385), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2403712 */ /*GILLT_nxv4s16*//*Label 34505*/ GIMT_Encode4(2413175),
     /* 2403716 */ /*GILLT_nxv4s32*//*Label 34506*/ GIMT_Encode4(2413965),
     /* 2403720 */ /*GILLT_nxv4s64*//*Label 34507*/ GIMT_Encode4(2414755), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2403732 */ /*GILLT_nxv8s16*//*Label 34508*/ GIMT_Encode4(2415545),
     /* 2403736 */ /*GILLT_nxv8s32*//*Label 34509*/ GIMT_Encode4(2416335),
     /* 2403740 */ /*GILLT_nxv8s64*//*Label 34510*/ GIMT_Encode4(2417125), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2403752 */ /*GILLT_nxv16s16*//*Label 34511*/ GIMT_Encode4(2417915),
     /* 2403756 */ /*GILLT_nxv16s32*//*Label 34512*/ GIMT_Encode4(2418705), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2403768 */ /*GILLT_nxv32s16*//*Label 34513*/ GIMT_Encode4(2419495),
     /* 2403772 */ // Label 34496: @2403772
     /* 2403772 */ GIM_Try, /*On fail goto*//*Label 34515*/ GIMT_Encode4(2405207),
     /* 2403777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2403780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2403783 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2403786 */   GIM_Try, /*On fail goto*//*Label 34516*/ GIMT_Encode4(2403858), // Rule ID 2003 //
     /* 2403791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2403794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2403810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2403831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403838 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2403838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2403841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403857 */     // GIR_Coverage, 2003,
     /* 2403857 */     GIR_EraseRootFromParent_Done,
     /* 2403858 */   // Label 34516: @2403858
     /* 2403858 */   GIM_Try, /*On fail goto*//*Label 34517*/ GIMT_Encode4(2403930), // Rule ID 2004 //
     /* 2403863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2403866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2403882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2403903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2403908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403910 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2403910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2403913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403929 */     // GIR_Coverage, 2004,
     /* 2403929 */     GIR_EraseRootFromParent_Done,
     /* 2403930 */   // Label 34517: @2403930
     /* 2403930 */   GIM_Try, /*On fail goto*//*Label 34518*/ GIMT_Encode4(2404002), // Rule ID 2036 //
     /* 2403935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2403938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2403954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2403975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2403980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403982 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2403982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2403985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404001 */     // GIR_Coverage, 2036,
     /* 2404001 */     GIR_EraseRootFromParent_Done,
     /* 2404002 */   // Label 34518: @2404002
     /* 2404002 */   GIM_Try, /*On fail goto*//*Label 34519*/ GIMT_Encode4(2404074), // Rule ID 2037 //
     /* 2404007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2404010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404054 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2404054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2404057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404073 */     // GIR_Coverage, 2037,
     /* 2404073 */     GIR_EraseRootFromParent_Done,
     /* 2404074 */   // Label 34519: @2404074
     /* 2404074 */   GIM_Try, /*On fail goto*//*Label 34520*/ GIMT_Encode4(2404146), // Rule ID 65404 //
     /* 2404079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2404082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404126 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2404126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2404129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404145 */     // GIR_Coverage, 65404,
     /* 2404145 */     GIR_EraseRootFromParent_Done,
     /* 2404146 */   // Label 34520: @2404146
     /* 2404146 */   GIM_Try, /*On fail goto*//*Label 34521*/ GIMT_Encode4(2404218), // Rule ID 65405 //
     /* 2404151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2404154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404198 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2404198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2404201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404217 */     // GIR_Coverage, 65405,
     /* 2404217 */     GIR_EraseRootFromParent_Done,
     /* 2404218 */   // Label 34521: @2404218
     /* 2404218 */   GIM_Try, /*On fail goto*//*Label 34522*/ GIMT_Encode4(2404290), // Rule ID 65412 //
     /* 2404223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2404226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404270 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2404270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2404273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404289 */     // GIR_Coverage, 65412,
     /* 2404289 */     GIR_EraseRootFromParent_Done,
     /* 2404290 */   // Label 34522: @2404290
     /* 2404290 */   GIM_Try, /*On fail goto*//*Label 34523*/ GIMT_Encode4(2404362), // Rule ID 65413 //
     /* 2404295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2404298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404342 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2404342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2404345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404361 */     // GIR_Coverage, 65413,
     /* 2404361 */     GIR_EraseRootFromParent_Done,
     /* 2404362 */   // Label 34523: @2404362
     /* 2404362 */   GIM_Try, /*On fail goto*//*Label 34524*/ GIMT_Encode4(2404419), // Rule ID 1999 //
     /* 2404367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2404370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404401 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2404401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2404404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404418 */     // GIR_Coverage, 1999,
     /* 2404418 */     GIR_EraseRootFromParent_Done,
     /* 2404419 */   // Label 34524: @2404419
     /* 2404419 */   GIM_Try, /*On fail goto*//*Label 34525*/ GIMT_Encode4(2404476), // Rule ID 2000 //
     /* 2404424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2404427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404458 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2404458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2404461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404475 */     // GIR_Coverage, 2000,
     /* 2404475 */     GIR_EraseRootFromParent_Done,
     /* 2404476 */   // Label 34525: @2404476
     /* 2404476 */   GIM_Try, /*On fail goto*//*Label 34526*/ GIMT_Encode4(2404533), // Rule ID 2032 //
     /* 2404481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2404484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404515 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2404515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2404518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404532 */     // GIR_Coverage, 2032,
     /* 2404532 */     GIR_EraseRootFromParent_Done,
     /* 2404533 */   // Label 34526: @2404533
     /* 2404533 */   GIM_Try, /*On fail goto*//*Label 34527*/ GIMT_Encode4(2404590), // Rule ID 2033 //
     /* 2404538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2404541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404572 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2404572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2404575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404589 */     // GIR_Coverage, 2033,
     /* 2404589 */     GIR_EraseRootFromParent_Done,
     /* 2404590 */   // Label 34527: @2404590
     /* 2404590 */   GIM_Try, /*On fail goto*//*Label 34528*/ GIMT_Encode4(2404647), // Rule ID 65400 //
     /* 2404595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2404598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404629 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2404629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2404632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404646 */     // GIR_Coverage, 65400,
     /* 2404646 */     GIR_EraseRootFromParent_Done,
     /* 2404647 */   // Label 34528: @2404647
     /* 2404647 */   GIM_Try, /*On fail goto*//*Label 34529*/ GIMT_Encode4(2404704), // Rule ID 65401 //
     /* 2404652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2404655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404686 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2404686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2404689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404703 */     // GIR_Coverage, 65401,
     /* 2404703 */     GIR_EraseRootFromParent_Done,
     /* 2404704 */   // Label 34529: @2404704
     /* 2404704 */   GIM_Try, /*On fail goto*//*Label 34530*/ GIMT_Encode4(2404761), // Rule ID 65408 //
     /* 2404709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2404712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404743 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2404743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2404746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404760 */     // GIR_Coverage, 65408,
     /* 2404760 */     GIR_EraseRootFromParent_Done,
     /* 2404761 */   // Label 34530: @2404761
     /* 2404761 */   GIM_Try, /*On fail goto*//*Label 34531*/ GIMT_Encode4(2404818), // Rule ID 65409 //
     /* 2404766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2404769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404800 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2404800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2404803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404817 */     // GIR_Coverage, 65409,
     /* 2404817 */     GIR_EraseRootFromParent_Done,
     /* 2404818 */   // Label 34531: @2404818
     /* 2404818 */   GIM_Try, /*On fail goto*//*Label 34532*/ GIMT_Encode4(2404875), // Rule ID 1995 //
     /* 2404823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2404826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2404842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404857 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2404857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2404860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2404870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404874 */     // GIR_Coverage, 1995,
     /* 2404874 */     GIR_EraseRootFromParent_Done,
     /* 2404875 */   // Label 34532: @2404875
     /* 2404875 */   GIM_Try, /*On fail goto*//*Label 34533*/ GIMT_Encode4(2404932), // Rule ID 1996 //
     /* 2404880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2404883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2404899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2404912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404914 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2404914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2404917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2404927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404931 */     // GIR_Coverage, 1996,
     /* 2404931 */     GIR_EraseRootFromParent_Done,
     /* 2404932 */   // Label 34533: @2404932
     /* 2404932 */   GIM_Try, /*On fail goto*//*Label 34534*/ GIMT_Encode4(2404989), // Rule ID 2028 //
     /* 2404937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2404940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2404956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2404964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2404969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404971 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2404971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2404974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2404984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404988 */     // GIR_Coverage, 2028,
     /* 2404988 */     GIR_EraseRootFromParent_Done,
     /* 2404989 */   // Label 34534: @2404989
     /* 2404989 */   GIM_Try, /*On fail goto*//*Label 34535*/ GIMT_Encode4(2405046), // Rule ID 2029 //
     /* 2404994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2404997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2405013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2405021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405028 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2405028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2405031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2405041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405045 */     // GIR_Coverage, 2029,
     /* 2405045 */     GIR_EraseRootFromParent_Done,
     /* 2405046 */   // Label 34535: @2405046
     /* 2405046 */   GIM_Try, /*On fail goto*//*Label 34536*/ GIMT_Encode4(2405086), // Rule ID 1991 //
     /* 2405051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2405054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405070 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2405070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2405073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405085 */     // GIR_Coverage, 1991,
     /* 2405085 */     GIR_EraseRootFromParent_Done,
     /* 2405086 */   // Label 34536: @2405086
     /* 2405086 */   GIM_Try, /*On fail goto*//*Label 34537*/ GIMT_Encode4(2405126), // Rule ID 1992 //
     /* 2405091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2405094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405110 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2405110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2405113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405125 */     // GIR_Coverage, 1992,
     /* 2405125 */     GIR_EraseRootFromParent_Done,
     /* 2405126 */   // Label 34537: @2405126
     /* 2405126 */   GIM_Try, /*On fail goto*//*Label 34538*/ GIMT_Encode4(2405166), // Rule ID 2024 //
     /* 2405131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2405134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405150 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2405150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2405153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405165 */     // GIR_Coverage, 2024,
     /* 2405165 */     GIR_EraseRootFromParent_Done,
     /* 2405166 */   // Label 34538: @2405166
     /* 2405166 */   GIM_Try, /*On fail goto*//*Label 34539*/ GIMT_Encode4(2405206), // Rule ID 2025 //
     /* 2405171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2405174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405190 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2405190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2405193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405205 */     // GIR_Coverage, 2025,
     /* 2405205 */     GIR_EraseRootFromParent_Done,
     /* 2405206 */   // Label 34539: @2405206
     /* 2405206 */   GIM_Reject,
     /* 2405207 */ // Label 34515: @2405207
     /* 2405207 */ GIM_Reject,
     /* 2405208 */ // Label 34497: @2405208
     /* 2405208 */ GIM_Try, /*On fail goto*//*Label 34540*/ GIMT_Encode4(2406643),
     /* 2405213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2405219 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2405222 */   GIM_Try, /*On fail goto*//*Label 34541*/ GIMT_Encode4(2405294), // Rule ID 1302 //
     /* 2405227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2405230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405274 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2405274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2405277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405293 */     // GIR_Coverage, 1302,
     /* 2405293 */     GIR_EraseRootFromParent_Done,
     /* 2405294 */   // Label 34541: @2405294
     /* 2405294 */   GIM_Try, /*On fail goto*//*Label 34542*/ GIMT_Encode4(2405366), // Rule ID 1303 //
     /* 2405299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2405302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405346 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2405346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2405349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405365 */     // GIR_Coverage, 1303,
     /* 2405365 */     GIR_EraseRootFromParent_Done,
     /* 2405366 */   // Label 34542: @2405366
     /* 2405366 */   GIM_Try, /*On fail goto*//*Label 34543*/ GIMT_Encode4(2405438), // Rule ID 1323 //
     /* 2405371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2405374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405418 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2405418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2405421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405437 */     // GIR_Coverage, 1323,
     /* 2405437 */     GIR_EraseRootFromParent_Done,
     /* 2405438 */   // Label 34543: @2405438
     /* 2405438 */   GIM_Try, /*On fail goto*//*Label 34544*/ GIMT_Encode4(2405510), // Rule ID 1324 //
     /* 2405443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2405446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405490 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2405490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2405493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405509 */     // GIR_Coverage, 1324,
     /* 2405509 */     GIR_EraseRootFromParent_Done,
     /* 2405510 */   // Label 34544: @2405510
     /* 2405510 */   GIM_Try, /*On fail goto*//*Label 34545*/ GIMT_Encode4(2405582), // Rule ID 65368 //
     /* 2405515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2405518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405562 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2405562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2405565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405581 */     // GIR_Coverage, 65368,
     /* 2405581 */     GIR_EraseRootFromParent_Done,
     /* 2405582 */   // Label 34545: @2405582
     /* 2405582 */   GIM_Try, /*On fail goto*//*Label 34546*/ GIMT_Encode4(2405654), // Rule ID 65369 //
     /* 2405587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2405590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405634 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2405634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2405637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405653 */     // GIR_Coverage, 65369,
     /* 2405653 */     GIR_EraseRootFromParent_Done,
     /* 2405654 */   // Label 34546: @2405654
     /* 2405654 */   GIM_Try, /*On fail goto*//*Label 34547*/ GIMT_Encode4(2405726), // Rule ID 65376 //
     /* 2405659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2405662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405706 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2405706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2405709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405725 */     // GIR_Coverage, 65376,
     /* 2405725 */     GIR_EraseRootFromParent_Done,
     /* 2405726 */   // Label 34547: @2405726
     /* 2405726 */   GIM_Try, /*On fail goto*//*Label 34548*/ GIMT_Encode4(2405798), // Rule ID 65377 //
     /* 2405731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2405734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405778 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2405778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2405781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405797 */     // GIR_Coverage, 65377,
     /* 2405797 */     GIR_EraseRootFromParent_Done,
     /* 2405798 */   // Label 34548: @2405798
     /* 2405798 */   GIM_Try, /*On fail goto*//*Label 34549*/ GIMT_Encode4(2405855), // Rule ID 1298 //
     /* 2405803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2405806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405837 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2405837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2405840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405854 */     // GIR_Coverage, 1298,
     /* 2405854 */     GIR_EraseRootFromParent_Done,
     /* 2405855 */   // Label 34549: @2405855
     /* 2405855 */   GIM_Try, /*On fail goto*//*Label 34550*/ GIMT_Encode4(2405912), // Rule ID 1299 //
     /* 2405860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2405863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405894 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2405894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2405897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405911 */     // GIR_Coverage, 1299,
     /* 2405911 */     GIR_EraseRootFromParent_Done,
     /* 2405912 */   // Label 34550: @2405912
     /* 2405912 */   GIM_Try, /*On fail goto*//*Label 34551*/ GIMT_Encode4(2405969), // Rule ID 1319 //
     /* 2405917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2405920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405951 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2405951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2405954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405968 */     // GIR_Coverage, 1319,
     /* 2405968 */     GIR_EraseRootFromParent_Done,
     /* 2405969 */   // Label 34551: @2405969
     /* 2405969 */   GIM_Try, /*On fail goto*//*Label 34552*/ GIMT_Encode4(2406026), // Rule ID 1320 //
     /* 2405974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2405977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406008 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2406008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2406011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406025 */     // GIR_Coverage, 1320,
     /* 2406025 */     GIR_EraseRootFromParent_Done,
     /* 2406026 */   // Label 34552: @2406026
     /* 2406026 */   GIM_Try, /*On fail goto*//*Label 34553*/ GIMT_Encode4(2406083), // Rule ID 65364 //
     /* 2406031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2406034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406065 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2406065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2406068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2406076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406082 */     // GIR_Coverage, 65364,
     /* 2406082 */     GIR_EraseRootFromParent_Done,
     /* 2406083 */   // Label 34553: @2406083
     /* 2406083 */   GIM_Try, /*On fail goto*//*Label 34554*/ GIMT_Encode4(2406140), // Rule ID 65365 //
     /* 2406088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2406091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406122 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2406122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2406125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2406133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406139 */     // GIR_Coverage, 65365,
     /* 2406139 */     GIR_EraseRootFromParent_Done,
     /* 2406140 */   // Label 34554: @2406140
     /* 2406140 */   GIM_Try, /*On fail goto*//*Label 34555*/ GIMT_Encode4(2406197), // Rule ID 65372 //
     /* 2406145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2406148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406179 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2406179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2406182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2406190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406196 */     // GIR_Coverage, 65372,
     /* 2406196 */     GIR_EraseRootFromParent_Done,
     /* 2406197 */   // Label 34555: @2406197
     /* 2406197 */   GIM_Try, /*On fail goto*//*Label 34556*/ GIMT_Encode4(2406254), // Rule ID 65373 //
     /* 2406202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2406205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406236 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2406236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2406239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2406247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406253 */     // GIR_Coverage, 65373,
     /* 2406253 */     GIR_EraseRootFromParent_Done,
     /* 2406254 */   // Label 34556: @2406254
     /* 2406254 */   GIM_Try, /*On fail goto*//*Label 34557*/ GIMT_Encode4(2406311), // Rule ID 1294 //
     /* 2406259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2406262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2406278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406293 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2406293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2406296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2406306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406310 */     // GIR_Coverage, 1294,
     /* 2406310 */     GIR_EraseRootFromParent_Done,
     /* 2406311 */   // Label 34557: @2406311
     /* 2406311 */   GIM_Try, /*On fail goto*//*Label 34558*/ GIMT_Encode4(2406368), // Rule ID 1295 //
     /* 2406316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2406319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2406335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406350 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2406350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2406353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2406363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406367 */     // GIR_Coverage, 1295,
     /* 2406367 */     GIR_EraseRootFromParent_Done,
     /* 2406368 */   // Label 34558: @2406368
     /* 2406368 */   GIM_Try, /*On fail goto*//*Label 34559*/ GIMT_Encode4(2406425), // Rule ID 1315 //
     /* 2406373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2406376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2406392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406407 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2406407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2406410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2406420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406424 */     // GIR_Coverage, 1315,
     /* 2406424 */     GIR_EraseRootFromParent_Done,
     /* 2406425 */   // Label 34559: @2406425
     /* 2406425 */   GIM_Try, /*On fail goto*//*Label 34560*/ GIMT_Encode4(2406482), // Rule ID 1316 //
     /* 2406430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2406433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2406449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406464 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2406464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2406467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2406477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406481 */     // GIR_Coverage, 1316,
     /* 2406481 */     GIR_EraseRootFromParent_Done,
     /* 2406482 */   // Label 34560: @2406482
     /* 2406482 */   GIM_Try, /*On fail goto*//*Label 34561*/ GIMT_Encode4(2406522), // Rule ID 1290 //
     /* 2406487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2406490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406506 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2406506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2406509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406521 */     // GIR_Coverage, 1290,
     /* 2406521 */     GIR_EraseRootFromParent_Done,
     /* 2406522 */   // Label 34561: @2406522
     /* 2406522 */   GIM_Try, /*On fail goto*//*Label 34562*/ GIMT_Encode4(2406562), // Rule ID 1291 //
     /* 2406527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2406530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2406546 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2406546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2406549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406561 */     // GIR_Coverage, 1291,
     /* 2406561 */     GIR_EraseRootFromParent_Done,
     /* 2406562 */   // Label 34562: @2406562
     /* 2406562 */   GIM_Try, /*On fail goto*//*Label 34563*/ GIMT_Encode4(2406602), // Rule ID 1311 //
     /* 2406567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2406570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406586 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2406586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2406589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406601 */     // GIR_Coverage, 1311,
     /* 2406601 */     GIR_EraseRootFromParent_Done,
     /* 2406602 */   // Label 34563: @2406602
     /* 2406602 */   GIM_Try, /*On fail goto*//*Label 34564*/ GIMT_Encode4(2406642), // Rule ID 1312 //
     /* 2406607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2406610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2406626 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2406626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2406629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406641 */     // GIR_Coverage, 1312,
     /* 2406641 */     GIR_EraseRootFromParent_Done,
     /* 2406642 */   // Label 34564: @2406642
     /* 2406642 */   GIM_Reject,
     /* 2406643 */ // Label 34540: @2406643
     /* 2406643 */ GIM_Reject,
     /* 2406644 */ // Label 34498: @2406644
     /* 2406644 */ GIM_Try, /*On fail goto*//*Label 34565*/ GIMT_Encode4(2408434),
     /* 2406649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2406655 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2406658 */   GIM_Try, /*On fail goto*//*Label 34566*/ GIMT_Encode4(2406730), // Rule ID 1639 //
     /* 2406663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2406666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406710 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2406710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2406713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2406725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406729 */     // GIR_Coverage, 1639,
     /* 2406729 */     GIR_EraseRootFromParent_Done,
     /* 2406730 */   // Label 34566: @2406730
     /* 2406730 */   GIM_Try, /*On fail goto*//*Label 34567*/ GIMT_Encode4(2406802), // Rule ID 1640 //
     /* 2406735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2406738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406782 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2406782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2406785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2406797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406801 */     // GIR_Coverage, 1640,
     /* 2406801 */     GIR_EraseRootFromParent_Done,
     /* 2406802 */   // Label 34567: @2406802
     /* 2406802 */   GIM_Try, /*On fail goto*//*Label 34568*/ GIMT_Encode4(2406874), // Rule ID 1663 //
     /* 2406807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2406810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406854 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2406854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2406857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2406869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406873 */     // GIR_Coverage, 1663,
     /* 2406873 */     GIR_EraseRootFromParent_Done,
     /* 2406874 */   // Label 34568: @2406874
     /* 2406874 */   GIM_Try, /*On fail goto*//*Label 34569*/ GIMT_Encode4(2406946), // Rule ID 1694 //
     /* 2406879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2406882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406926 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2406926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2406929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2406941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406945 */     // GIR_Coverage, 1694,
     /* 2406945 */     GIR_EraseRootFromParent_Done,
     /* 2406946 */   // Label 34569: @2406946
     /* 2406946 */   GIM_Try, /*On fail goto*//*Label 34570*/ GIMT_Encode4(2407018), // Rule ID 1695 //
     /* 2406951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2406954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406998 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2406998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2407001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407017 */     // GIR_Coverage, 1695,
     /* 2407017 */     GIR_EraseRootFromParent_Done,
     /* 2407018 */   // Label 34570: @2407018
     /* 2407018 */   GIM_Try, /*On fail goto*//*Label 34571*/ GIMT_Encode4(2407090), // Rule ID 65384 //
     /* 2407023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2407026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407070 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2407070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2407073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407089 */     // GIR_Coverage, 65384,
     /* 2407089 */     GIR_EraseRootFromParent_Done,
     /* 2407090 */   // Label 34571: @2407090
     /* 2407090 */   GIM_Try, /*On fail goto*//*Label 34572*/ GIMT_Encode4(2407162), // Rule ID 65385 //
     /* 2407095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2407098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407142 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2407142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2407145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407161 */     // GIR_Coverage, 65385,
     /* 2407161 */     GIR_EraseRootFromParent_Done,
     /* 2407162 */   // Label 34572: @2407162
     /* 2407162 */   GIM_Try, /*On fail goto*//*Label 34573*/ GIMT_Encode4(2407234), // Rule ID 65390 //
     /* 2407167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2407170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407214 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2407214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2407217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407233 */     // GIR_Coverage, 65390,
     /* 2407233 */     GIR_EraseRootFromParent_Done,
     /* 2407234 */   // Label 34573: @2407234
     /* 2407234 */   GIM_Try, /*On fail goto*//*Label 34574*/ GIMT_Encode4(2407306), // Rule ID 65396 //
     /* 2407239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2407242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407286 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2407286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2407289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407305 */     // GIR_Coverage, 65396,
     /* 2407305 */     GIR_EraseRootFromParent_Done,
     /* 2407306 */   // Label 34574: @2407306
     /* 2407306 */   GIM_Try, /*On fail goto*//*Label 34575*/ GIMT_Encode4(2407378), // Rule ID 65397 //
     /* 2407311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2407314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407358 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2407358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2407361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407377 */     // GIR_Coverage, 65397,
     /* 2407377 */     GIR_EraseRootFromParent_Done,
     /* 2407378 */   // Label 34575: @2407378
     /* 2407378 */   GIM_Try, /*On fail goto*//*Label 34576*/ GIMT_Encode4(2407435), // Rule ID 1635 //
     /* 2407383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2407386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407417 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2407417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2407420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2407430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407434 */     // GIR_Coverage, 1635,
     /* 2407434 */     GIR_EraseRootFromParent_Done,
     /* 2407435 */   // Label 34576: @2407435
     /* 2407435 */   GIM_Try, /*On fail goto*//*Label 34577*/ GIMT_Encode4(2407492), // Rule ID 1636 //
     /* 2407440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2407443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407474 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2407474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2407477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2407487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407491 */     // GIR_Coverage, 1636,
     /* 2407491 */     GIR_EraseRootFromParent_Done,
     /* 2407492 */   // Label 34577: @2407492
     /* 2407492 */   GIM_Try, /*On fail goto*//*Label 34578*/ GIMT_Encode4(2407549), // Rule ID 1661 //
     /* 2407497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2407500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407531 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2407531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2407534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2407544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407548 */     // GIR_Coverage, 1661,
     /* 2407548 */     GIR_EraseRootFromParent_Done,
     /* 2407549 */   // Label 34578: @2407549
     /* 2407549 */   GIM_Try, /*On fail goto*//*Label 34579*/ GIMT_Encode4(2407606), // Rule ID 1690 //
     /* 2407554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2407557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407588 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2407588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2407591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2407601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407605 */     // GIR_Coverage, 1690,
     /* 2407605 */     GIR_EraseRootFromParent_Done,
     /* 2407606 */   // Label 34579: @2407606
     /* 2407606 */   GIM_Try, /*On fail goto*//*Label 34580*/ GIMT_Encode4(2407663), // Rule ID 1691 //
     /* 2407611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2407614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407645 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2407645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2407648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2407658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407662 */     // GIR_Coverage, 1691,
     /* 2407662 */     GIR_EraseRootFromParent_Done,
     /* 2407663 */   // Label 34580: @2407663
     /* 2407663 */   GIM_Try, /*On fail goto*//*Label 34581*/ GIMT_Encode4(2407720), // Rule ID 65380 //
     /* 2407668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2407671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407702 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2407702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2407705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2407715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407719 */     // GIR_Coverage, 65380,
     /* 2407719 */     GIR_EraseRootFromParent_Done,
     /* 2407720 */   // Label 34581: @2407720
     /* 2407720 */   GIM_Try, /*On fail goto*//*Label 34582*/ GIMT_Encode4(2407777), // Rule ID 65381 //
     /* 2407725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2407728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407759 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2407759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2407762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2407772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407776 */     // GIR_Coverage, 65381,
     /* 2407776 */     GIR_EraseRootFromParent_Done,
     /* 2407777 */   // Label 34582: @2407777
     /* 2407777 */   GIM_Try, /*On fail goto*//*Label 34583*/ GIMT_Encode4(2407834), // Rule ID 65388 //
     /* 2407782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2407785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407816 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2407816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2407819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2407829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407833 */     // GIR_Coverage, 65388,
     /* 2407833 */     GIR_EraseRootFromParent_Done,
     /* 2407834 */   // Label 34583: @2407834
     /* 2407834 */   GIM_Try, /*On fail goto*//*Label 34584*/ GIMT_Encode4(2407891), // Rule ID 65392 //
     /* 2407839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2407842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407873 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2407873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2407876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2407886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407890 */     // GIR_Coverage, 65392,
     /* 2407890 */     GIR_EraseRootFromParent_Done,
     /* 2407891 */   // Label 34584: @2407891
     /* 2407891 */   GIM_Try, /*On fail goto*//*Label 34585*/ GIMT_Encode4(2407948), // Rule ID 65393 //
     /* 2407896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2407899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407930 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2407930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2407933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2407943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407947 */     // GIR_Coverage, 65393,
     /* 2407947 */     GIR_EraseRootFromParent_Done,
     /* 2407948 */   // Label 34585: @2407948
     /* 2407948 */   GIM_Try, /*On fail goto*//*Label 34586*/ GIMT_Encode4(2408005), // Rule ID 1631 //
     /* 2407953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2407956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2407972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407987 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2407987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2407990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2408000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408004 */     // GIR_Coverage, 1631,
     /* 2408004 */     GIR_EraseRootFromParent_Done,
     /* 2408005 */   // Label 34586: @2408005
     /* 2408005 */   GIM_Try, /*On fail goto*//*Label 34587*/ GIMT_Encode4(2408062), // Rule ID 1632 //
     /* 2408010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2408013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2408017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2408021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2408025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2408037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2408042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408044 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2408044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2408047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2408057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408061 */     // GIR_Coverage, 1632,
     /* 2408061 */     GIR_EraseRootFromParent_Done,
     /* 2408062 */   // Label 34587: @2408062
     /* 2408062 */   GIM_Try, /*On fail goto*//*Label 34588*/ GIMT_Encode4(2408119), // Rule ID 1659 //
     /* 2408067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2408070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2408074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2408078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2408082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2408094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2408099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408101 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2408101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2408104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2408114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408118 */     // GIR_Coverage, 1659,
     /* 2408118 */     GIR_EraseRootFromParent_Done,
     /* 2408119 */   // Label 34588: @2408119
     /* 2408119 */   GIM_Try, /*On fail goto*//*Label 34589*/ GIMT_Encode4(2408176), // Rule ID 1686 //
     /* 2408124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2408127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2408151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408158 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2408158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2408161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2408171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408175 */     // GIR_Coverage, 1686,
     /* 2408175 */     GIR_EraseRootFromParent_Done,
     /* 2408176 */   // Label 34589: @2408176
     /* 2408176 */   GIM_Try, /*On fail goto*//*Label 34590*/ GIMT_Encode4(2408233), // Rule ID 1687 //
     /* 2408181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2408184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2408208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408215 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2408215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2408218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2408228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408232 */     // GIR_Coverage, 1687,
     /* 2408232 */     GIR_EraseRootFromParent_Done,
     /* 2408233 */   // Label 34590: @2408233
     /* 2408233 */   GIM_Try, /*On fail goto*//*Label 34591*/ GIMT_Encode4(2408273), // Rule ID 1627 //
     /* 2408238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2408241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2408245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2408249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2408253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2408257 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2408257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2408260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408272 */     // GIR_Coverage, 1627,
     /* 2408272 */     GIR_EraseRootFromParent_Done,
     /* 2408273 */   // Label 34591: @2408273
     /* 2408273 */   GIM_Try, /*On fail goto*//*Label 34592*/ GIMT_Encode4(2408313), // Rule ID 1628 //
     /* 2408278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2408281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2408285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2408289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2408293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2408297 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2408297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2408300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408312 */     // GIR_Coverage, 1628,
     /* 2408312 */     GIR_EraseRootFromParent_Done,
     /* 2408313 */   // Label 34592: @2408313
     /* 2408313 */   GIM_Try, /*On fail goto*//*Label 34593*/ GIMT_Encode4(2408353), // Rule ID 1657 //
     /* 2408318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2408321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2408325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2408329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2408333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2408337 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2408337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2408340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408352 */     // GIR_Coverage, 1657,
     /* 2408352 */     GIR_EraseRootFromParent_Done,
     /* 2408353 */   // Label 34593: @2408353
     /* 2408353 */   GIM_Try, /*On fail goto*//*Label 34594*/ GIMT_Encode4(2408393), // Rule ID 1682 //
     /* 2408358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2408361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408377 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2408377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2408380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408392 */     // GIR_Coverage, 1682,
     /* 2408392 */     GIR_EraseRootFromParent_Done,
     /* 2408393 */   // Label 34594: @2408393
     /* 2408393 */   GIM_Try, /*On fail goto*//*Label 34595*/ GIMT_Encode4(2408433), // Rule ID 1683 //
     /* 2408398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2408401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2408417 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2408417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2408420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408432 */     // GIR_Coverage, 1683,
     /* 2408432 */     GIR_EraseRootFromParent_Done,
     /* 2408433 */   // Label 34595: @2408433
     /* 2408433 */   GIM_Reject,
     /* 2408434 */ // Label 34565: @2408434
     /* 2408434 */ GIM_Reject,
     /* 2408435 */ // Label 34499: @2408435
     /* 2408435 */ GIM_Try, /*On fail goto*//*Label 34596*/ GIMT_Encode4(2409224),
     /* 2408440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2408443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2408446 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2408449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408453 */   GIM_Try, /*On fail goto*//*Label 34597*/ GIMT_Encode4(2408530), // Rule ID 54828 //
     /* 2408458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2408461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2408473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2408494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408501 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2408504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408529 */     // GIR_Coverage, 54828,
     /* 2408529 */     GIR_EraseRootFromParent_Done,
     /* 2408530 */   // Label 34597: @2408530
     /* 2408530 */   GIM_Try, /*On fail goto*//*Label 34598*/ GIMT_Encode4(2408607), // Rule ID 54829 //
     /* 2408535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2408538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2408550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2408571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408578 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2408581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408606 */     // GIR_Coverage, 54829,
     /* 2408606 */     GIR_EraseRootFromParent_Done,
     /* 2408607 */   // Label 34598: @2408607
     /* 2408607 */   GIM_Try, /*On fail goto*//*Label 34599*/ GIMT_Encode4(2408684), // Rule ID 72368 //
     /* 2408612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2408615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2408631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2408648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408655 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2408658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2408662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408683 */     // GIR_Coverage, 72368,
     /* 2408683 */     GIR_EraseRootFromParent_Done,
     /* 2408684 */   // Label 34599: @2408684
     /* 2408684 */   GIM_Try, /*On fail goto*//*Label 34600*/ GIMT_Encode4(2408761), // Rule ID 72369 //
     /* 2408689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2408692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2408708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2408725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408732 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2408735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2408739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408760 */     // GIR_Coverage, 72369,
     /* 2408760 */     GIR_EraseRootFromParent_Done,
     /* 2408761 */   // Label 34600: @2408761
     /* 2408761 */   GIM_Try, /*On fail goto*//*Label 34601*/ GIMT_Encode4(2408823), // Rule ID 54832 //
     /* 2408766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2408769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2408781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408796 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2408799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408822 */     // GIR_Coverage, 54832,
     /* 2408822 */     GIR_EraseRootFromParent_Done,
     /* 2408823 */   // Label 34601: @2408823
     /* 2408823 */   GIM_Try, /*On fail goto*//*Label 34602*/ GIMT_Encode4(2408885), // Rule ID 54833 //
     /* 2408828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2408831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2408843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408858 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2408861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408884 */     // GIR_Coverage, 54833,
     /* 2408884 */     GIR_EraseRootFromParent_Done,
     /* 2408885 */   // Label 34602: @2408885
     /* 2408885 */   GIM_Try, /*On fail goto*//*Label 34603*/ GIMT_Encode4(2408947), // Rule ID 72372 //
     /* 2408890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2408893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2408909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408920 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2408923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2408927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408946 */     // GIR_Coverage, 72372,
     /* 2408946 */     GIR_EraseRootFromParent_Done,
     /* 2408947 */   // Label 34603: @2408947
     /* 2408947 */   GIM_Try, /*On fail goto*//*Label 34604*/ GIMT_Encode4(2409009), // Rule ID 72373 //
     /* 2408952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2408955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2408971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408982 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2408985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2408989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409008 */     // GIR_Coverage, 72373,
     /* 2409008 */     GIR_EraseRootFromParent_Done,
     /* 2409009 */   // Label 34604: @2409009
     /* 2409009 */   GIM_Try, /*On fail goto*//*Label 34605*/ GIMT_Encode4(2409071), // Rule ID 54824 //
     /* 2409014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2409017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2409029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2409037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409044 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2409047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2409057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409070 */     // GIR_Coverage, 54824,
     /* 2409070 */     GIR_EraseRootFromParent_Done,
     /* 2409071 */   // Label 34605: @2409071
     /* 2409071 */   GIM_Try, /*On fail goto*//*Label 34606*/ GIMT_Encode4(2409133), // Rule ID 54825 //
     /* 2409076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2409079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2409091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2409099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409106 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2409109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2409119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409132 */     // GIR_Coverage, 54825,
     /* 2409132 */     GIR_EraseRootFromParent_Done,
     /* 2409133 */   // Label 34606: @2409133
     /* 2409133 */   GIM_Try, /*On fail goto*//*Label 34607*/ GIMT_Encode4(2409178), // Rule ID 54820 //
     /* 2409138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2409141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409153 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2409156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409177 */     // GIR_Coverage, 54820,
     /* 2409177 */     GIR_EraseRootFromParent_Done,
     /* 2409178 */   // Label 34607: @2409178
     /* 2409178 */   GIM_Try, /*On fail goto*//*Label 34608*/ GIMT_Encode4(2409223), // Rule ID 54821 //
     /* 2409183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2409186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409198 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2409201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409222 */     // GIR_Coverage, 54821,
     /* 2409222 */     GIR_EraseRootFromParent_Done,
     /* 2409223 */   // Label 34608: @2409223
     /* 2409223 */   GIM_Reject,
     /* 2409224 */ // Label 34596: @2409224
     /* 2409224 */ GIM_Reject,
     /* 2409225 */ // Label 34500: @2409225
     /* 2409225 */ GIM_Try, /*On fail goto*//*Label 34609*/ GIMT_Encode4(2410014),
     /* 2409230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2409236 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2409239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409243 */   GIM_Try, /*On fail goto*//*Label 34610*/ GIMT_Encode4(2409320), // Rule ID 54956 //
     /* 2409248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2409251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409291 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2409294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409319 */     // GIR_Coverage, 54956,
     /* 2409319 */     GIR_EraseRootFromParent_Done,
     /* 2409320 */   // Label 34610: @2409320
     /* 2409320 */   GIM_Try, /*On fail goto*//*Label 34611*/ GIMT_Encode4(2409397), // Rule ID 54957 //
     /* 2409325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2409328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409368 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2409371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409396 */     // GIR_Coverage, 54957,
     /* 2409396 */     GIR_EraseRootFromParent_Done,
     /* 2409397 */   // Label 34611: @2409397
     /* 2409397 */   GIM_Try, /*On fail goto*//*Label 34612*/ GIMT_Encode4(2409474), // Rule ID 72480 //
     /* 2409402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2409405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409445 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2409448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409473 */     // GIR_Coverage, 72480,
     /* 2409473 */     GIR_EraseRootFromParent_Done,
     /* 2409474 */   // Label 34612: @2409474
     /* 2409474 */   GIM_Try, /*On fail goto*//*Label 34613*/ GIMT_Encode4(2409551), // Rule ID 72481 //
     /* 2409479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2409482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409522 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2409525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409550 */     // GIR_Coverage, 72481,
     /* 2409550 */     GIR_EraseRootFromParent_Done,
     /* 2409551 */   // Label 34613: @2409551
     /* 2409551 */   GIM_Try, /*On fail goto*//*Label 34614*/ GIMT_Encode4(2409613), // Rule ID 54960 //
     /* 2409556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2409559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409586 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2409589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409612 */     // GIR_Coverage, 54960,
     /* 2409612 */     GIR_EraseRootFromParent_Done,
     /* 2409613 */   // Label 34614: @2409613
     /* 2409613 */   GIM_Try, /*On fail goto*//*Label 34615*/ GIMT_Encode4(2409675), // Rule ID 54961 //
     /* 2409618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2409621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409648 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2409651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409674 */     // GIR_Coverage, 54961,
     /* 2409674 */     GIR_EraseRootFromParent_Done,
     /* 2409675 */   // Label 34615: @2409675
     /* 2409675 */   GIM_Try, /*On fail goto*//*Label 34616*/ GIMT_Encode4(2409737), // Rule ID 72484 //
     /* 2409680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2409683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409710 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2409713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409736 */     // GIR_Coverage, 72484,
     /* 2409736 */     GIR_EraseRootFromParent_Done,
     /* 2409737 */   // Label 34616: @2409737
     /* 2409737 */   GIM_Try, /*On fail goto*//*Label 34617*/ GIMT_Encode4(2409799), // Rule ID 72485 //
     /* 2409742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2409745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409772 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2409775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409798 */     // GIR_Coverage, 72485,
     /* 2409798 */     GIR_EraseRootFromParent_Done,
     /* 2409799 */   // Label 34617: @2409799
     /* 2409799 */   GIM_Try, /*On fail goto*//*Label 34618*/ GIMT_Encode4(2409861), // Rule ID 54952 //
     /* 2409804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2409807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2409819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409834 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2409837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2409847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409860 */     // GIR_Coverage, 54952,
     /* 2409860 */     GIR_EraseRootFromParent_Done,
     /* 2409861 */   // Label 34618: @2409861
     /* 2409861 */   GIM_Try, /*On fail goto*//*Label 34619*/ GIMT_Encode4(2409923), // Rule ID 54953 //
     /* 2409866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2409869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2409881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2409889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409896 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2409899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2409909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409922 */     // GIR_Coverage, 54953,
     /* 2409922 */     GIR_EraseRootFromParent_Done,
     /* 2409923 */   // Label 34619: @2409923
     /* 2409923 */   GIM_Try, /*On fail goto*//*Label 34620*/ GIMT_Encode4(2409968), // Rule ID 54948 //
     /* 2409928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2409931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409943 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2409946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409967 */     // GIR_Coverage, 54948,
     /* 2409967 */     GIR_EraseRootFromParent_Done,
     /* 2409968 */   // Label 34620: @2409968
     /* 2409968 */   GIM_Try, /*On fail goto*//*Label 34621*/ GIMT_Encode4(2410013), // Rule ID 54949 //
     /* 2409973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2409976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409988 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2409991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410012 */     // GIR_Coverage, 54949,
     /* 2410012 */     GIR_EraseRootFromParent_Done,
     /* 2410013 */   // Label 34621: @2410013
     /* 2410013 */   GIM_Reject,
     /* 2410014 */ // Label 34609: @2410014
     /* 2410014 */ GIM_Reject,
     /* 2410015 */ // Label 34501: @2410015
     /* 2410015 */ GIM_Try, /*On fail goto*//*Label 34622*/ GIMT_Encode4(2410804),
     /* 2410020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2410026 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2410029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410033 */   GIM_Try, /*On fail goto*//*Label 34623*/ GIMT_Encode4(2410110), // Rule ID 55148 //
     /* 2410038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410081 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2410084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410109 */     // GIR_Coverage, 55148,
     /* 2410109 */     GIR_EraseRootFromParent_Done,
     /* 2410110 */   // Label 34623: @2410110
     /* 2410110 */   GIM_Try, /*On fail goto*//*Label 34624*/ GIMT_Encode4(2410187), // Rule ID 55149 //
     /* 2410115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410158 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2410161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410186 */     // GIR_Coverage, 55149,
     /* 2410186 */     GIR_EraseRootFromParent_Done,
     /* 2410187 */   // Label 34624: @2410187
     /* 2410187 */   GIM_Try, /*On fail goto*//*Label 34625*/ GIMT_Encode4(2410264), // Rule ID 72648 //
     /* 2410192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410235 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2410238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410263 */     // GIR_Coverage, 72648,
     /* 2410263 */     GIR_EraseRootFromParent_Done,
     /* 2410264 */   // Label 34625: @2410264
     /* 2410264 */   GIM_Try, /*On fail goto*//*Label 34626*/ GIMT_Encode4(2410341), // Rule ID 72649 //
     /* 2410269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410312 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2410315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410340 */     // GIR_Coverage, 72649,
     /* 2410340 */     GIR_EraseRootFromParent_Done,
     /* 2410341 */   // Label 34626: @2410341
     /* 2410341 */   GIM_Try, /*On fail goto*//*Label 34627*/ GIMT_Encode4(2410403), // Rule ID 55152 //
     /* 2410346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410376 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2410379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410402 */     // GIR_Coverage, 55152,
     /* 2410402 */     GIR_EraseRootFromParent_Done,
     /* 2410403 */   // Label 34627: @2410403
     /* 2410403 */   GIM_Try, /*On fail goto*//*Label 34628*/ GIMT_Encode4(2410465), // Rule ID 55153 //
     /* 2410408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410438 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2410441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410464 */     // GIR_Coverage, 55153,
     /* 2410464 */     GIR_EraseRootFromParent_Done,
     /* 2410465 */   // Label 34628: @2410465
     /* 2410465 */   GIM_Try, /*On fail goto*//*Label 34629*/ GIMT_Encode4(2410527), // Rule ID 72652 //
     /* 2410470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410500 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2410503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410526 */     // GIR_Coverage, 72652,
     /* 2410526 */     GIR_EraseRootFromParent_Done,
     /* 2410527 */   // Label 34629: @2410527
     /* 2410527 */   GIM_Try, /*On fail goto*//*Label 34630*/ GIMT_Encode4(2410589), // Rule ID 72653 //
     /* 2410532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410562 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2410565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410588 */     // GIR_Coverage, 72653,
     /* 2410588 */     GIR_EraseRootFromParent_Done,
     /* 2410589 */   // Label 34630: @2410589
     /* 2410589 */   GIM_Try, /*On fail goto*//*Label 34631*/ GIMT_Encode4(2410651), // Rule ID 55144 //
     /* 2410594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410624 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2410627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2410637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410650 */     // GIR_Coverage, 55144,
     /* 2410650 */     GIR_EraseRootFromParent_Done,
     /* 2410651 */   // Label 34631: @2410651
     /* 2410651 */   GIM_Try, /*On fail goto*//*Label 34632*/ GIMT_Encode4(2410713), // Rule ID 55145 //
     /* 2410656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2410679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410686 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2410689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2410699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410712 */     // GIR_Coverage, 55145,
     /* 2410712 */     GIR_EraseRootFromParent_Done,
     /* 2410713 */   // Label 34632: @2410713
     /* 2410713 */   GIM_Try, /*On fail goto*//*Label 34633*/ GIMT_Encode4(2410758), // Rule ID 55140 //
     /* 2410718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410733 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2410736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410757 */     // GIR_Coverage, 55140,
     /* 2410757 */     GIR_EraseRootFromParent_Done,
     /* 2410758 */   // Label 34633: @2410758
     /* 2410758 */   GIM_Try, /*On fail goto*//*Label 34634*/ GIMT_Encode4(2410803), // Rule ID 55141 //
     /* 2410763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410778 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2410781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410802 */     // GIR_Coverage, 55141,
     /* 2410802 */     GIR_EraseRootFromParent_Done,
     /* 2410803 */   // Label 34634: @2410803
     /* 2410803 */   GIM_Reject,
     /* 2410804 */ // Label 34622: @2410804
     /* 2410804 */ GIM_Reject,
     /* 2410805 */ // Label 34502: @2410805
     /* 2410805 */ GIM_Try, /*On fail goto*//*Label 34635*/ GIMT_Encode4(2411594),
     /* 2410810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2410813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2410816 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2410819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410823 */   GIM_Try, /*On fail goto*//*Label 34636*/ GIMT_Encode4(2410900), // Rule ID 54892 //
     /* 2410828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2410831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2410843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2410864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410869 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410871 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2410874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2410895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410899 */     // GIR_Coverage, 54892,
     /* 2410899 */     GIR_EraseRootFromParent_Done,
     /* 2410900 */   // Label 34636: @2410900
     /* 2410900 */   GIM_Try, /*On fail goto*//*Label 34637*/ GIMT_Encode4(2410977), // Rule ID 54893 //
     /* 2410905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2410908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2410920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2410941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410948 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2410951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2410972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410976 */     // GIR_Coverage, 54893,
     /* 2410976 */     GIR_EraseRootFromParent_Done,
     /* 2410977 */   // Label 34637: @2410977
     /* 2410977 */   GIM_Try, /*On fail goto*//*Label 34638*/ GIMT_Encode4(2411054), // Rule ID 72424 //
     /* 2410982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2410985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2411001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2411018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411025 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2411028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411053 */     // GIR_Coverage, 72424,
     /* 2411053 */     GIR_EraseRootFromParent_Done,
     /* 2411054 */   // Label 34638: @2411054
     /* 2411054 */   GIM_Try, /*On fail goto*//*Label 34639*/ GIMT_Encode4(2411131), // Rule ID 72425 //
     /* 2411059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2411078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2411095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411102 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2411105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411130 */     // GIR_Coverage, 72425,
     /* 2411130 */     GIR_EraseRootFromParent_Done,
     /* 2411131 */   // Label 34639: @2411131
     /* 2411131 */   GIM_Try, /*On fail goto*//*Label 34640*/ GIMT_Encode4(2411193), // Rule ID 54896 //
     /* 2411136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2411151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411166 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2411169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411192 */     // GIR_Coverage, 54896,
     /* 2411192 */     GIR_EraseRootFromParent_Done,
     /* 2411193 */   // Label 34640: @2411193
     /* 2411193 */   GIM_Try, /*On fail goto*//*Label 34641*/ GIMT_Encode4(2411255), // Rule ID 54897 //
     /* 2411198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2411213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411228 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2411231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411254 */     // GIR_Coverage, 54897,
     /* 2411254 */     GIR_EraseRootFromParent_Done,
     /* 2411255 */   // Label 34641: @2411255
     /* 2411255 */   GIM_Try, /*On fail goto*//*Label 34642*/ GIMT_Encode4(2411317), // Rule ID 72428 //
     /* 2411260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2411279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411290 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2411293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411316 */     // GIR_Coverage, 72428,
     /* 2411316 */     GIR_EraseRootFromParent_Done,
     /* 2411317 */   // Label 34642: @2411317
     /* 2411317 */   GIM_Try, /*On fail goto*//*Label 34643*/ GIMT_Encode4(2411379), // Rule ID 72429 //
     /* 2411322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2411341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411352 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2411355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411378 */     // GIR_Coverage, 72429,
     /* 2411378 */     GIR_EraseRootFromParent_Done,
     /* 2411379 */   // Label 34643: @2411379
     /* 2411379 */   GIM_Try, /*On fail goto*//*Label 34644*/ GIMT_Encode4(2411441), // Rule ID 54888 //
     /* 2411384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2411407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411414 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2411417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2411427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411440 */     // GIR_Coverage, 54888,
     /* 2411440 */     GIR_EraseRootFromParent_Done,
     /* 2411441 */   // Label 34644: @2411441
     /* 2411441 */   GIM_Try, /*On fail goto*//*Label 34645*/ GIMT_Encode4(2411503), // Rule ID 54889 //
     /* 2411446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2411469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411476 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2411479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2411489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411502 */     // GIR_Coverage, 54889,
     /* 2411502 */     GIR_EraseRootFromParent_Done,
     /* 2411503 */   // Label 34645: @2411503
     /* 2411503 */   GIM_Try, /*On fail goto*//*Label 34646*/ GIMT_Encode4(2411548), // Rule ID 54884 //
     /* 2411508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411523 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2411526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411547 */     // GIR_Coverage, 54884,
     /* 2411547 */     GIR_EraseRootFromParent_Done,
     /* 2411548 */   // Label 34646: @2411548
     /* 2411548 */   GIM_Try, /*On fail goto*//*Label 34647*/ GIMT_Encode4(2411593), // Rule ID 54885 //
     /* 2411553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411568 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2411571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411592 */     // GIR_Coverage, 54885,
     /* 2411592 */     GIR_EraseRootFromParent_Done,
     /* 2411593 */   // Label 34647: @2411593
     /* 2411593 */   GIM_Reject,
     /* 2411594 */ // Label 34635: @2411594
     /* 2411594 */ GIM_Reject,
     /* 2411595 */ // Label 34503: @2411595
     /* 2411595 */ GIM_Try, /*On fail goto*//*Label 34648*/ GIMT_Encode4(2412384),
     /* 2411600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2411603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2411606 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2411609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411613 */   GIM_Try, /*On fail goto*//*Label 34649*/ GIMT_Encode4(2411690), // Rule ID 55084 //
     /* 2411618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2411621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2411633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2411654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411661 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2411664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2411685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411689 */     // GIR_Coverage, 55084,
     /* 2411689 */     GIR_EraseRootFromParent_Done,
     /* 2411690 */   // Label 34649: @2411690
     /* 2411690 */   GIM_Try, /*On fail goto*//*Label 34650*/ GIMT_Encode4(2411767), // Rule ID 55085 //
     /* 2411695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2411698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2411710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2411731 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411738 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2411741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2411762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411766 */     // GIR_Coverage, 55085,
     /* 2411766 */     GIR_EraseRootFromParent_Done,
     /* 2411767 */   // Label 34650: @2411767
     /* 2411767 */   GIM_Try, /*On fail goto*//*Label 34651*/ GIMT_Encode4(2411844), // Rule ID 72592 //
     /* 2411772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2411775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2411791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2411808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411815 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2411818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2411839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411843 */     // GIR_Coverage, 72592,
     /* 2411843 */     GIR_EraseRootFromParent_Done,
     /* 2411844 */   // Label 34651: @2411844
     /* 2411844 */   GIM_Try, /*On fail goto*//*Label 34652*/ GIMT_Encode4(2411921), // Rule ID 72593 //
     /* 2411849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2411852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2411868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2411885 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411892 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2411895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2411916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411920 */     // GIR_Coverage, 72593,
     /* 2411920 */     GIR_EraseRootFromParent_Done,
     /* 2411921 */   // Label 34652: @2411921
     /* 2411921 */   GIM_Try, /*On fail goto*//*Label 34653*/ GIMT_Encode4(2411983), // Rule ID 55088 //
     /* 2411926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2411929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2411941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411956 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2411959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2411978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411982 */     // GIR_Coverage, 55088,
     /* 2411982 */     GIR_EraseRootFromParent_Done,
     /* 2411983 */   // Label 34653: @2411983
     /* 2411983 */   GIM_Try, /*On fail goto*//*Label 34654*/ GIMT_Encode4(2412045), // Rule ID 55089 //
     /* 2411988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2411991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2412003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412018 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2412021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412044 */     // GIR_Coverage, 55089,
     /* 2412044 */     GIR_EraseRootFromParent_Done,
     /* 2412045 */   // Label 34654: @2412045
     /* 2412045 */   GIM_Try, /*On fail goto*//*Label 34655*/ GIMT_Encode4(2412107), // Rule ID 72596 //
     /* 2412050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2412053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2412069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412080 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2412083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412106 */     // GIR_Coverage, 72596,
     /* 2412106 */     GIR_EraseRootFromParent_Done,
     /* 2412107 */   // Label 34655: @2412107
     /* 2412107 */   GIM_Try, /*On fail goto*//*Label 34656*/ GIMT_Encode4(2412169), // Rule ID 72597 //
     /* 2412112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2412115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2412131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412142 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2412145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412168 */     // GIR_Coverage, 72597,
     /* 2412168 */     GIR_EraseRootFromParent_Done,
     /* 2412169 */   // Label 34656: @2412169
     /* 2412169 */   GIM_Try, /*On fail goto*//*Label 34657*/ GIMT_Encode4(2412231), // Rule ID 55080 //
     /* 2412174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2412177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2412197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412204 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2412207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2412217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412230 */     // GIR_Coverage, 55080,
     /* 2412230 */     GIR_EraseRootFromParent_Done,
     /* 2412231 */   // Label 34657: @2412231
     /* 2412231 */   GIM_Try, /*On fail goto*//*Label 34658*/ GIMT_Encode4(2412293), // Rule ID 55081 //
     /* 2412236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2412239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2412259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412266 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2412269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2412279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412292 */     // GIR_Coverage, 55081,
     /* 2412292 */     GIR_EraseRootFromParent_Done,
     /* 2412293 */   // Label 34658: @2412293
     /* 2412293 */   GIM_Try, /*On fail goto*//*Label 34659*/ GIMT_Encode4(2412338), // Rule ID 55076 //
     /* 2412298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2412301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412313 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2412316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412337 */     // GIR_Coverage, 55076,
     /* 2412337 */     GIR_EraseRootFromParent_Done,
     /* 2412338 */   // Label 34659: @2412338
     /* 2412338 */   GIM_Try, /*On fail goto*//*Label 34660*/ GIMT_Encode4(2412383), // Rule ID 55077 //
     /* 2412343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2412346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412358 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2412361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412382 */     // GIR_Coverage, 55077,
     /* 2412382 */     GIR_EraseRootFromParent_Done,
     /* 2412383 */   // Label 34660: @2412383
     /* 2412383 */   GIM_Reject,
     /* 2412384 */ // Label 34648: @2412384
     /* 2412384 */ GIM_Reject,
     /* 2412385 */ // Label 34504: @2412385
     /* 2412385 */ GIM_Try, /*On fail goto*//*Label 34661*/ GIMT_Encode4(2413174),
     /* 2412390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2412396 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2412399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412403 */   GIM_Try, /*On fail goto*//*Label 34662*/ GIMT_Encode4(2412480), // Rule ID 55596 //
     /* 2412408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2412411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412451 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2412454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412479 */     // GIR_Coverage, 55596,
     /* 2412479 */     GIR_EraseRootFromParent_Done,
     /* 2412480 */   // Label 34662: @2412480
     /* 2412480 */   GIM_Try, /*On fail goto*//*Label 34663*/ GIMT_Encode4(2412557), // Rule ID 55597 //
     /* 2412485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2412488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412528 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2412531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412556 */     // GIR_Coverage, 55597,
     /* 2412556 */     GIR_EraseRootFromParent_Done,
     /* 2412557 */   // Label 34663: @2412557
     /* 2412557 */   GIM_Try, /*On fail goto*//*Label 34664*/ GIMT_Encode4(2412634), // Rule ID 73040 //
     /* 2412562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2412565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412605 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2412608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412633 */     // GIR_Coverage, 73040,
     /* 2412633 */     GIR_EraseRootFromParent_Done,
     /* 2412634 */   // Label 34664: @2412634
     /* 2412634 */   GIM_Try, /*On fail goto*//*Label 34665*/ GIMT_Encode4(2412711), // Rule ID 73041 //
     /* 2412639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2412642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412682 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2412685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412710 */     // GIR_Coverage, 73041,
     /* 2412710 */     GIR_EraseRootFromParent_Done,
     /* 2412711 */   // Label 34665: @2412711
     /* 2412711 */   GIM_Try, /*On fail goto*//*Label 34666*/ GIMT_Encode4(2412773), // Rule ID 55600 //
     /* 2412716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2412719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412746 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2412749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412772 */     // GIR_Coverage, 55600,
     /* 2412772 */     GIR_EraseRootFromParent_Done,
     /* 2412773 */   // Label 34666: @2412773
     /* 2412773 */   GIM_Try, /*On fail goto*//*Label 34667*/ GIMT_Encode4(2412835), // Rule ID 55601 //
     /* 2412778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2412781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412808 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2412811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412834 */     // GIR_Coverage, 55601,
     /* 2412834 */     GIR_EraseRootFromParent_Done,
     /* 2412835 */   // Label 34667: @2412835
     /* 2412835 */   GIM_Try, /*On fail goto*//*Label 34668*/ GIMT_Encode4(2412897), // Rule ID 73044 //
     /* 2412840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2412843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412870 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2412873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412896 */     // GIR_Coverage, 73044,
     /* 2412896 */     GIR_EraseRootFromParent_Done,
     /* 2412897 */   // Label 34668: @2412897
     /* 2412897 */   GIM_Try, /*On fail goto*//*Label 34669*/ GIMT_Encode4(2412959), // Rule ID 73045 //
     /* 2412902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2412905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412932 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2412935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412958 */     // GIR_Coverage, 73045,
     /* 2412958 */     GIR_EraseRootFromParent_Done,
     /* 2412959 */   // Label 34669: @2412959
     /* 2412959 */   GIM_Try, /*On fail goto*//*Label 34670*/ GIMT_Encode4(2413021), // Rule ID 55592 //
     /* 2412964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2412967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2412987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412994 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2412997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413020 */     // GIR_Coverage, 55592,
     /* 2413020 */     GIR_EraseRootFromParent_Done,
     /* 2413021 */   // Label 34670: @2413021
     /* 2413021 */   GIM_Try, /*On fail goto*//*Label 34671*/ GIMT_Encode4(2413083), // Rule ID 55593 //
     /* 2413026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2413029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2413049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413056 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2413059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413082 */     // GIR_Coverage, 55593,
     /* 2413082 */     GIR_EraseRootFromParent_Done,
     /* 2413083 */   // Label 34671: @2413083
     /* 2413083 */   GIM_Try, /*On fail goto*//*Label 34672*/ GIMT_Encode4(2413128), // Rule ID 55588 //
     /* 2413088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2413091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413103 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2413106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413127 */     // GIR_Coverage, 55588,
     /* 2413127 */     GIR_EraseRootFromParent_Done,
     /* 2413128 */   // Label 34672: @2413128
     /* 2413128 */   GIM_Try, /*On fail goto*//*Label 34673*/ GIMT_Encode4(2413173), // Rule ID 55589 //
     /* 2413133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2413136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413148 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2413151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413172 */     // GIR_Coverage, 55589,
     /* 2413172 */     GIR_EraseRootFromParent_Done,
     /* 2413173 */   // Label 34673: @2413173
     /* 2413173 */   GIM_Reject,
     /* 2413174 */ // Label 34661: @2413174
     /* 2413174 */ GIM_Reject,
     /* 2413175 */ // Label 34505: @2413175
     /* 2413175 */ GIM_Try, /*On fail goto*//*Label 34674*/ GIMT_Encode4(2413964),
     /* 2413180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2413186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2413189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413193 */   GIM_Try, /*On fail goto*//*Label 34675*/ GIMT_Encode4(2413270), // Rule ID 55020 //
     /* 2413198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413241 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2413244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413269 */     // GIR_Coverage, 55020,
     /* 2413269 */     GIR_EraseRootFromParent_Done,
     /* 2413270 */   // Label 34675: @2413270
     /* 2413270 */   GIM_Try, /*On fail goto*//*Label 34676*/ GIMT_Encode4(2413347), // Rule ID 55021 //
     /* 2413275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413318 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2413321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413346 */     // GIR_Coverage, 55021,
     /* 2413346 */     GIR_EraseRootFromParent_Done,
     /* 2413347 */   // Label 34676: @2413347
     /* 2413347 */   GIM_Try, /*On fail goto*//*Label 34677*/ GIMT_Encode4(2413424), // Rule ID 72536 //
     /* 2413352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413395 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2413398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413423 */     // GIR_Coverage, 72536,
     /* 2413423 */     GIR_EraseRootFromParent_Done,
     /* 2413424 */   // Label 34677: @2413424
     /* 2413424 */   GIM_Try, /*On fail goto*//*Label 34678*/ GIMT_Encode4(2413501), // Rule ID 72537 //
     /* 2413429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413472 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2413475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413500 */     // GIR_Coverage, 72537,
     /* 2413500 */     GIR_EraseRootFromParent_Done,
     /* 2413501 */   // Label 34678: @2413501
     /* 2413501 */   GIM_Try, /*On fail goto*//*Label 34679*/ GIMT_Encode4(2413563), // Rule ID 55024 //
     /* 2413506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413536 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2413539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413562 */     // GIR_Coverage, 55024,
     /* 2413562 */     GIR_EraseRootFromParent_Done,
     /* 2413563 */   // Label 34679: @2413563
     /* 2413563 */   GIM_Try, /*On fail goto*//*Label 34680*/ GIMT_Encode4(2413625), // Rule ID 55025 //
     /* 2413568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413598 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2413601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413624 */     // GIR_Coverage, 55025,
     /* 2413624 */     GIR_EraseRootFromParent_Done,
     /* 2413625 */   // Label 34680: @2413625
     /* 2413625 */   GIM_Try, /*On fail goto*//*Label 34681*/ GIMT_Encode4(2413687), // Rule ID 72540 //
     /* 2413630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413660 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2413663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413686 */     // GIR_Coverage, 72540,
     /* 2413686 */     GIR_EraseRootFromParent_Done,
     /* 2413687 */   // Label 34681: @2413687
     /* 2413687 */   GIM_Try, /*On fail goto*//*Label 34682*/ GIMT_Encode4(2413749), // Rule ID 72541 //
     /* 2413692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413722 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2413725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413748 */     // GIR_Coverage, 72541,
     /* 2413748 */     GIR_EraseRootFromParent_Done,
     /* 2413749 */   // Label 34682: @2413749
     /* 2413749 */   GIM_Try, /*On fail goto*//*Label 34683*/ GIMT_Encode4(2413811), // Rule ID 55016 //
     /* 2413754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413784 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2413787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413810 */     // GIR_Coverage, 55016,
     /* 2413810 */     GIR_EraseRootFromParent_Done,
     /* 2413811 */   // Label 34683: @2413811
     /* 2413811 */   GIM_Try, /*On fail goto*//*Label 34684*/ GIMT_Encode4(2413873), // Rule ID 55017 //
     /* 2413816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413846 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2413849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413872 */     // GIR_Coverage, 55017,
     /* 2413872 */     GIR_EraseRootFromParent_Done,
     /* 2413873 */   // Label 34684: @2413873
     /* 2413873 */   GIM_Try, /*On fail goto*//*Label 34685*/ GIMT_Encode4(2413918), // Rule ID 55012 //
     /* 2413878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413893 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2413896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413917 */     // GIR_Coverage, 55012,
     /* 2413917 */     GIR_EraseRootFromParent_Done,
     /* 2413918 */   // Label 34685: @2413918
     /* 2413918 */   GIM_Try, /*On fail goto*//*Label 34686*/ GIMT_Encode4(2413963), // Rule ID 55013 //
     /* 2413923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413938 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2413941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413962 */     // GIR_Coverage, 55013,
     /* 2413962 */     GIR_EraseRootFromParent_Done,
     /* 2413963 */   // Label 34686: @2413963
     /* 2413963 */   GIM_Reject,
     /* 2413964 */ // Label 34674: @2413964
     /* 2413964 */ GIM_Reject,
     /* 2413965 */ // Label 34506: @2413965
     /* 2413965 */ GIM_Try, /*On fail goto*//*Label 34687*/ GIMT_Encode4(2414754),
     /* 2413970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2413973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2413976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2413979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413983 */   GIM_Try, /*On fail goto*//*Label 34688*/ GIMT_Encode4(2414060), // Rule ID 55404 //
     /* 2413988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2413991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414031 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2414034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414059 */     // GIR_Coverage, 55404,
     /* 2414059 */     GIR_EraseRootFromParent_Done,
     /* 2414060 */   // Label 34688: @2414060
     /* 2414060 */   GIM_Try, /*On fail goto*//*Label 34689*/ GIMT_Encode4(2414137), // Rule ID 55405 //
     /* 2414065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414108 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2414111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414136 */     // GIR_Coverage, 55405,
     /* 2414136 */     GIR_EraseRootFromParent_Done,
     /* 2414137 */   // Label 34689: @2414137
     /* 2414137 */   GIM_Try, /*On fail goto*//*Label 34690*/ GIMT_Encode4(2414214), // Rule ID 72872 //
     /* 2414142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414185 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2414188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414213 */     // GIR_Coverage, 72872,
     /* 2414213 */     GIR_EraseRootFromParent_Done,
     /* 2414214 */   // Label 34690: @2414214
     /* 2414214 */   GIM_Try, /*On fail goto*//*Label 34691*/ GIMT_Encode4(2414291), // Rule ID 72873 //
     /* 2414219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414262 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2414265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414290 */     // GIR_Coverage, 72873,
     /* 2414290 */     GIR_EraseRootFromParent_Done,
     /* 2414291 */   // Label 34691: @2414291
     /* 2414291 */   GIM_Try, /*On fail goto*//*Label 34692*/ GIMT_Encode4(2414353), // Rule ID 55408 //
     /* 2414296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414326 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2414329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414352 */     // GIR_Coverage, 55408,
     /* 2414352 */     GIR_EraseRootFromParent_Done,
     /* 2414353 */   // Label 34692: @2414353
     /* 2414353 */   GIM_Try, /*On fail goto*//*Label 34693*/ GIMT_Encode4(2414415), // Rule ID 55409 //
     /* 2414358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414388 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2414391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414414 */     // GIR_Coverage, 55409,
     /* 2414414 */     GIR_EraseRootFromParent_Done,
     /* 2414415 */   // Label 34693: @2414415
     /* 2414415 */   GIM_Try, /*On fail goto*//*Label 34694*/ GIMT_Encode4(2414477), // Rule ID 72876 //
     /* 2414420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414450 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2414453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414476 */     // GIR_Coverage, 72876,
     /* 2414476 */     GIR_EraseRootFromParent_Done,
     /* 2414477 */   // Label 34694: @2414477
     /* 2414477 */   GIM_Try, /*On fail goto*//*Label 34695*/ GIMT_Encode4(2414539), // Rule ID 72877 //
     /* 2414482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414512 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2414515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414538 */     // GIR_Coverage, 72877,
     /* 2414538 */     GIR_EraseRootFromParent_Done,
     /* 2414539 */   // Label 34695: @2414539
     /* 2414539 */   GIM_Try, /*On fail goto*//*Label 34696*/ GIMT_Encode4(2414601), // Rule ID 55400 //
     /* 2414544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414574 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2414577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2414587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414600 */     // GIR_Coverage, 55400,
     /* 2414600 */     GIR_EraseRootFromParent_Done,
     /* 2414601 */   // Label 34696: @2414601
     /* 2414601 */   GIM_Try, /*On fail goto*//*Label 34697*/ GIMT_Encode4(2414663), // Rule ID 55401 //
     /* 2414606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2414629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414636 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2414639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2414649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414662 */     // GIR_Coverage, 55401,
     /* 2414662 */     GIR_EraseRootFromParent_Done,
     /* 2414663 */   // Label 34697: @2414663
     /* 2414663 */   GIM_Try, /*On fail goto*//*Label 34698*/ GIMT_Encode4(2414708), // Rule ID 55396 //
     /* 2414668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414683 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2414686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414707 */     // GIR_Coverage, 55396,
     /* 2414707 */     GIR_EraseRootFromParent_Done,
     /* 2414708 */   // Label 34698: @2414708
     /* 2414708 */   GIM_Try, /*On fail goto*//*Label 34699*/ GIMT_Encode4(2414753), // Rule ID 55397 //
     /* 2414713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414728 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2414731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414752 */     // GIR_Coverage, 55397,
     /* 2414752 */     GIR_EraseRootFromParent_Done,
     /* 2414753 */   // Label 34699: @2414753
     /* 2414753 */   GIM_Reject,
     /* 2414754 */ // Label 34687: @2414754
     /* 2414754 */ GIM_Reject,
     /* 2414755 */ // Label 34507: @2414755
     /* 2414755 */ GIM_Try, /*On fail goto*//*Label 34700*/ GIMT_Encode4(2415544),
     /* 2414760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2414763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2414766 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2414769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414773 */   GIM_Try, /*On fail goto*//*Label 34701*/ GIMT_Encode4(2414850), // Rule ID 55660 //
     /* 2414778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2414781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2414793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2414814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414821 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2414824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414849 */     // GIR_Coverage, 55660,
     /* 2414849 */     GIR_EraseRootFromParent_Done,
     /* 2414850 */   // Label 34701: @2414850
     /* 2414850 */   GIM_Try, /*On fail goto*//*Label 34702*/ GIMT_Encode4(2414927), // Rule ID 55661 //
     /* 2414855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2414870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2414891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414898 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2414901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414926 */     // GIR_Coverage, 55661,
     /* 2414926 */     GIR_EraseRootFromParent_Done,
     /* 2414927 */   // Label 34702: @2414927
     /* 2414927 */   GIM_Try, /*On fail goto*//*Label 34703*/ GIMT_Encode4(2415004), // Rule ID 73096 //
     /* 2414932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2414935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2414951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2414968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414975 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2414978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415003 */     // GIR_Coverage, 73096,
     /* 2415003 */     GIR_EraseRootFromParent_Done,
     /* 2415004 */   // Label 34703: @2415004
     /* 2415004 */   GIM_Try, /*On fail goto*//*Label 34704*/ GIMT_Encode4(2415081), // Rule ID 73097 //
     /* 2415009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2415028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2415045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415052 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2415055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415080 */     // GIR_Coverage, 73097,
     /* 2415080 */     GIR_EraseRootFromParent_Done,
     /* 2415081 */   // Label 34704: @2415081
     /* 2415081 */   GIM_Try, /*On fail goto*//*Label 34705*/ GIMT_Encode4(2415143), // Rule ID 55664 //
     /* 2415086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2415101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415116 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2415119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415142 */     // GIR_Coverage, 55664,
     /* 2415142 */     GIR_EraseRootFromParent_Done,
     /* 2415143 */   // Label 34705: @2415143
     /* 2415143 */   GIM_Try, /*On fail goto*//*Label 34706*/ GIMT_Encode4(2415205), // Rule ID 55665 //
     /* 2415148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2415163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415178 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2415181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415204 */     // GIR_Coverage, 55665,
     /* 2415204 */     GIR_EraseRootFromParent_Done,
     /* 2415205 */   // Label 34706: @2415205
     /* 2415205 */   GIM_Try, /*On fail goto*//*Label 34707*/ GIMT_Encode4(2415267), // Rule ID 73100 //
     /* 2415210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2415229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415240 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2415243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415266 */     // GIR_Coverage, 73100,
     /* 2415266 */     GIR_EraseRootFromParent_Done,
     /* 2415267 */   // Label 34707: @2415267
     /* 2415267 */   GIM_Try, /*On fail goto*//*Label 34708*/ GIMT_Encode4(2415329), // Rule ID 73101 //
     /* 2415272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2415291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415302 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2415305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415328 */     // GIR_Coverage, 73101,
     /* 2415328 */     GIR_EraseRootFromParent_Done,
     /* 2415329 */   // Label 34708: @2415329
     /* 2415329 */   GIM_Try, /*On fail goto*//*Label 34709*/ GIMT_Encode4(2415391), // Rule ID 55656 //
     /* 2415334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2415357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415364 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2415367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2415377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415390 */     // GIR_Coverage, 55656,
     /* 2415390 */     GIR_EraseRootFromParent_Done,
     /* 2415391 */   // Label 34709: @2415391
     /* 2415391 */   GIM_Try, /*On fail goto*//*Label 34710*/ GIMT_Encode4(2415453), // Rule ID 55657 //
     /* 2415396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2415419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415426 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2415429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2415439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415452 */     // GIR_Coverage, 55657,
     /* 2415452 */     GIR_EraseRootFromParent_Done,
     /* 2415453 */   // Label 34710: @2415453
     /* 2415453 */   GIM_Try, /*On fail goto*//*Label 34711*/ GIMT_Encode4(2415498), // Rule ID 55652 //
     /* 2415458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415473 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2415476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415497 */     // GIR_Coverage, 55652,
     /* 2415497 */     GIR_EraseRootFromParent_Done,
     /* 2415498 */   // Label 34711: @2415498
     /* 2415498 */   GIM_Try, /*On fail goto*//*Label 34712*/ GIMT_Encode4(2415543), // Rule ID 55653 //
     /* 2415503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415518 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2415521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415542 */     // GIR_Coverage, 55653,
     /* 2415542 */     GIR_EraseRootFromParent_Done,
     /* 2415543 */   // Label 34712: @2415543
     /* 2415543 */   GIM_Reject,
     /* 2415544 */ // Label 34700: @2415544
     /* 2415544 */ GIM_Reject,
     /* 2415545 */ // Label 34508: @2415545
     /* 2415545 */ GIM_Try, /*On fail goto*//*Label 34713*/ GIMT_Encode4(2416334),
     /* 2415550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2415553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2415556 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2415559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415563 */   GIM_Try, /*On fail goto*//*Label 34714*/ GIMT_Encode4(2415640), // Rule ID 55212 //
     /* 2415568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2415571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2415583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2415604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415611 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2415614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415639 */     // GIR_Coverage, 55212,
     /* 2415639 */     GIR_EraseRootFromParent_Done,
     /* 2415640 */   // Label 34714: @2415640
     /* 2415640 */   GIM_Try, /*On fail goto*//*Label 34715*/ GIMT_Encode4(2415717), // Rule ID 55213 //
     /* 2415645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2415648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2415660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2415681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415688 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2415691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415716 */     // GIR_Coverage, 55213,
     /* 2415716 */     GIR_EraseRootFromParent_Done,
     /* 2415717 */   // Label 34715: @2415717
     /* 2415717 */   GIM_Try, /*On fail goto*//*Label 34716*/ GIMT_Encode4(2415794), // Rule ID 72704 //
     /* 2415722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2415725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2415741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2415758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415765 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2415768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415793 */     // GIR_Coverage, 72704,
     /* 2415793 */     GIR_EraseRootFromParent_Done,
     /* 2415794 */   // Label 34716: @2415794
     /* 2415794 */   GIM_Try, /*On fail goto*//*Label 34717*/ GIMT_Encode4(2415871), // Rule ID 72705 //
     /* 2415799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2415802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2415818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2415835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415842 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2415845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415870 */     // GIR_Coverage, 72705,
     /* 2415870 */     GIR_EraseRootFromParent_Done,
     /* 2415871 */   // Label 34717: @2415871
     /* 2415871 */   GIM_Try, /*On fail goto*//*Label 34718*/ GIMT_Encode4(2415933), // Rule ID 55216 //
     /* 2415876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2415879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2415891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415906 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2415909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415932 */     // GIR_Coverage, 55216,
     /* 2415932 */     GIR_EraseRootFromParent_Done,
     /* 2415933 */   // Label 34718: @2415933
     /* 2415933 */   GIM_Try, /*On fail goto*//*Label 34719*/ GIMT_Encode4(2415995), // Rule ID 55217 //
     /* 2415938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2415941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2415953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415968 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2415971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415994 */     // GIR_Coverage, 55217,
     /* 2415994 */     GIR_EraseRootFromParent_Done,
     /* 2415995 */   // Label 34719: @2415995
     /* 2415995 */   GIM_Try, /*On fail goto*//*Label 34720*/ GIMT_Encode4(2416057), // Rule ID 72708 //
     /* 2416000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2416003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2416019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416030 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2416033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416056 */     // GIR_Coverage, 72708,
     /* 2416056 */     GIR_EraseRootFromParent_Done,
     /* 2416057 */   // Label 34720: @2416057
     /* 2416057 */   GIM_Try, /*On fail goto*//*Label 34721*/ GIMT_Encode4(2416119), // Rule ID 72709 //
     /* 2416062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2416065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2416081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416092 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2416095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416118 */     // GIR_Coverage, 72709,
     /* 2416118 */     GIR_EraseRootFromParent_Done,
     /* 2416119 */   // Label 34721: @2416119
     /* 2416119 */   GIM_Try, /*On fail goto*//*Label 34722*/ GIMT_Encode4(2416181), // Rule ID 55208 //
     /* 2416124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2416127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2416147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416154 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2416157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416180 */     // GIR_Coverage, 55208,
     /* 2416180 */     GIR_EraseRootFromParent_Done,
     /* 2416181 */   // Label 34722: @2416181
     /* 2416181 */   GIM_Try, /*On fail goto*//*Label 34723*/ GIMT_Encode4(2416243), // Rule ID 55209 //
     /* 2416186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2416189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2416209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416216 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2416219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416242 */     // GIR_Coverage, 55209,
     /* 2416242 */     GIR_EraseRootFromParent_Done,
     /* 2416243 */   // Label 34723: @2416243
     /* 2416243 */   GIM_Try, /*On fail goto*//*Label 34724*/ GIMT_Encode4(2416288), // Rule ID 55204 //
     /* 2416248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2416251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416263 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2416266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416287 */     // GIR_Coverage, 55204,
     /* 2416287 */     GIR_EraseRootFromParent_Done,
     /* 2416288 */   // Label 34724: @2416288
     /* 2416288 */   GIM_Try, /*On fail goto*//*Label 34725*/ GIMT_Encode4(2416333), // Rule ID 55205 //
     /* 2416293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2416296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416308 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2416311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416332 */     // GIR_Coverage, 55205,
     /* 2416332 */     GIR_EraseRootFromParent_Done,
     /* 2416333 */   // Label 34725: @2416333
     /* 2416333 */   GIM_Reject,
     /* 2416334 */ // Label 34713: @2416334
     /* 2416334 */ GIM_Reject,
     /* 2416335 */ // Label 34509: @2416335
     /* 2416335 */ GIM_Try, /*On fail goto*//*Label 34726*/ GIMT_Encode4(2417124),
     /* 2416340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2416346 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2416349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416353 */   GIM_Try, /*On fail goto*//*Label 34727*/ GIMT_Encode4(2416430), // Rule ID 55468 //
     /* 2416358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416399 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416401 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2416404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416429 */     // GIR_Coverage, 55468,
     /* 2416429 */     GIR_EraseRootFromParent_Done,
     /* 2416430 */   // Label 34727: @2416430
     /* 2416430 */   GIM_Try, /*On fail goto*//*Label 34728*/ GIMT_Encode4(2416507), // Rule ID 55469 //
     /* 2416435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416478 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2416481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416506 */     // GIR_Coverage, 55469,
     /* 2416506 */     GIR_EraseRootFromParent_Done,
     /* 2416507 */   // Label 34728: @2416507
     /* 2416507 */   GIM_Try, /*On fail goto*//*Label 34729*/ GIMT_Encode4(2416584), // Rule ID 72928 //
     /* 2416512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416555 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2416558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416583 */     // GIR_Coverage, 72928,
     /* 2416583 */     GIR_EraseRootFromParent_Done,
     /* 2416584 */   // Label 34729: @2416584
     /* 2416584 */   GIM_Try, /*On fail goto*//*Label 34730*/ GIMT_Encode4(2416661), // Rule ID 72929 //
     /* 2416589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416632 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2416635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416660 */     // GIR_Coverage, 72929,
     /* 2416660 */     GIR_EraseRootFromParent_Done,
     /* 2416661 */   // Label 34730: @2416661
     /* 2416661 */   GIM_Try, /*On fail goto*//*Label 34731*/ GIMT_Encode4(2416723), // Rule ID 55472 //
     /* 2416666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416696 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2416699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416722 */     // GIR_Coverage, 55472,
     /* 2416722 */     GIR_EraseRootFromParent_Done,
     /* 2416723 */   // Label 34731: @2416723
     /* 2416723 */   GIM_Try, /*On fail goto*//*Label 34732*/ GIMT_Encode4(2416785), // Rule ID 55473 //
     /* 2416728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416758 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2416761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416784 */     // GIR_Coverage, 55473,
     /* 2416784 */     GIR_EraseRootFromParent_Done,
     /* 2416785 */   // Label 34732: @2416785
     /* 2416785 */   GIM_Try, /*On fail goto*//*Label 34733*/ GIMT_Encode4(2416847), // Rule ID 72932 //
     /* 2416790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416820 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2416823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416846 */     // GIR_Coverage, 72932,
     /* 2416846 */     GIR_EraseRootFromParent_Done,
     /* 2416847 */   // Label 34733: @2416847
     /* 2416847 */   GIM_Try, /*On fail goto*//*Label 34734*/ GIMT_Encode4(2416909), // Rule ID 72933 //
     /* 2416852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416882 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2416885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416908 */     // GIR_Coverage, 72933,
     /* 2416908 */     GIR_EraseRootFromParent_Done,
     /* 2416909 */   // Label 34734: @2416909
     /* 2416909 */   GIM_Try, /*On fail goto*//*Label 34735*/ GIMT_Encode4(2416971), // Rule ID 55464 //
     /* 2416914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416944 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2416947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416970 */     // GIR_Coverage, 55464,
     /* 2416970 */     GIR_EraseRootFromParent_Done,
     /* 2416971 */   // Label 34735: @2416971
     /* 2416971 */   GIM_Try, /*On fail goto*//*Label 34736*/ GIMT_Encode4(2417033), // Rule ID 55465 //
     /* 2416976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2416999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417006 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2417009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2417019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417032 */     // GIR_Coverage, 55465,
     /* 2417032 */     GIR_EraseRootFromParent_Done,
     /* 2417033 */   // Label 34736: @2417033
     /* 2417033 */   GIM_Try, /*On fail goto*//*Label 34737*/ GIMT_Encode4(2417078), // Rule ID 55460 //
     /* 2417038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2417041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417053 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2417056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417077 */     // GIR_Coverage, 55460,
     /* 2417077 */     GIR_EraseRootFromParent_Done,
     /* 2417078 */   // Label 34737: @2417078
     /* 2417078 */   GIM_Try, /*On fail goto*//*Label 34738*/ GIMT_Encode4(2417123), // Rule ID 55461 //
     /* 2417083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2417086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417098 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2417101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417122 */     // GIR_Coverage, 55461,
     /* 2417122 */     GIR_EraseRootFromParent_Done,
     /* 2417123 */   // Label 34738: @2417123
     /* 2417123 */   GIM_Reject,
     /* 2417124 */ // Label 34726: @2417124
     /* 2417124 */ GIM_Reject,
     /* 2417125 */ // Label 34510: @2417125
     /* 2417125 */ GIM_Try, /*On fail goto*//*Label 34739*/ GIMT_Encode4(2417914),
     /* 2417130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2417136 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2417139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417143 */   GIM_Try, /*On fail goto*//*Label 34740*/ GIMT_Encode4(2417220), // Rule ID 55724 //
     /* 2417148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2417151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417191 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2417194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417219 */     // GIR_Coverage, 55724,
     /* 2417219 */     GIR_EraseRootFromParent_Done,
     /* 2417220 */   // Label 34740: @2417220
     /* 2417220 */   GIM_Try, /*On fail goto*//*Label 34741*/ GIMT_Encode4(2417297), // Rule ID 55725 //
     /* 2417225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2417228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417261 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417268 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2417271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417296 */     // GIR_Coverage, 55725,
     /* 2417296 */     GIR_EraseRootFromParent_Done,
     /* 2417297 */   // Label 34741: @2417297
     /* 2417297 */   GIM_Try, /*On fail goto*//*Label 34742*/ GIMT_Encode4(2417374), // Rule ID 73152 //
     /* 2417302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2417305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417338 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417345 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2417348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417373 */     // GIR_Coverage, 73152,
     /* 2417373 */     GIR_EraseRootFromParent_Done,
     /* 2417374 */   // Label 34742: @2417374
     /* 2417374 */   GIM_Try, /*On fail goto*//*Label 34743*/ GIMT_Encode4(2417451), // Rule ID 73153 //
     /* 2417379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2417382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417422 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2417425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417450 */     // GIR_Coverage, 73153,
     /* 2417450 */     GIR_EraseRootFromParent_Done,
     /* 2417451 */   // Label 34743: @2417451
     /* 2417451 */   GIM_Try, /*On fail goto*//*Label 34744*/ GIMT_Encode4(2417513), // Rule ID 55728 //
     /* 2417456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2417459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417486 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2417489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417512 */     // GIR_Coverage, 55728,
     /* 2417512 */     GIR_EraseRootFromParent_Done,
     /* 2417513 */   // Label 34744: @2417513
     /* 2417513 */   GIM_Try, /*On fail goto*//*Label 34745*/ GIMT_Encode4(2417575), // Rule ID 55729 //
     /* 2417518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2417521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417548 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2417551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417574 */     // GIR_Coverage, 55729,
     /* 2417574 */     GIR_EraseRootFromParent_Done,
     /* 2417575 */   // Label 34745: @2417575
     /* 2417575 */   GIM_Try, /*On fail goto*//*Label 34746*/ GIMT_Encode4(2417637), // Rule ID 73156 //
     /* 2417580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2417583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417610 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2417613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417636 */     // GIR_Coverage, 73156,
     /* 2417636 */     GIR_EraseRootFromParent_Done,
     /* 2417637 */   // Label 34746: @2417637
     /* 2417637 */   GIM_Try, /*On fail goto*//*Label 34747*/ GIMT_Encode4(2417699), // Rule ID 73157 //
     /* 2417642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2417645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417672 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2417675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417698 */     // GIR_Coverage, 73157,
     /* 2417698 */     GIR_EraseRootFromParent_Done,
     /* 2417699 */   // Label 34747: @2417699
     /* 2417699 */   GIM_Try, /*On fail goto*//*Label 34748*/ GIMT_Encode4(2417761), // Rule ID 55720 //
     /* 2417704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2417707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417734 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2417737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2417747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417760 */     // GIR_Coverage, 55720,
     /* 2417760 */     GIR_EraseRootFromParent_Done,
     /* 2417761 */   // Label 34748: @2417761
     /* 2417761 */   GIM_Try, /*On fail goto*//*Label 34749*/ GIMT_Encode4(2417823), // Rule ID 55721 //
     /* 2417766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2417769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2417789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417796 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2417799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2417809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417822 */     // GIR_Coverage, 55721,
     /* 2417822 */     GIR_EraseRootFromParent_Done,
     /* 2417823 */   // Label 34749: @2417823
     /* 2417823 */   GIM_Try, /*On fail goto*//*Label 34750*/ GIMT_Encode4(2417868), // Rule ID 55716 //
     /* 2417828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2417831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417843 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2417846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417867 */     // GIR_Coverage, 55716,
     /* 2417867 */     GIR_EraseRootFromParent_Done,
     /* 2417868 */   // Label 34750: @2417868
     /* 2417868 */   GIM_Try, /*On fail goto*//*Label 34751*/ GIMT_Encode4(2417913), // Rule ID 55717 //
     /* 2417873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2417876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417888 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2417891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417912 */     // GIR_Coverage, 55717,
     /* 2417912 */     GIR_EraseRootFromParent_Done,
     /* 2417913 */   // Label 34751: @2417913
     /* 2417913 */   GIM_Reject,
     /* 2417914 */ // Label 34739: @2417914
     /* 2417914 */ GIM_Reject,
     /* 2417915 */ // Label 34511: @2417915
     /* 2417915 */ GIM_Try, /*On fail goto*//*Label 34752*/ GIMT_Encode4(2418704),
     /* 2417920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2417923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2417926 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2417929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417933 */   GIM_Try, /*On fail goto*//*Label 34753*/ GIMT_Encode4(2418010), // Rule ID 55276 //
     /* 2417938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2417953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2417974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417981 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2417984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418009 */     // GIR_Coverage, 55276,
     /* 2418009 */     GIR_EraseRootFromParent_Done,
     /* 2418010 */   // Label 34753: @2418010
     /* 2418010 */   GIM_Try, /*On fail goto*//*Label 34754*/ GIMT_Encode4(2418087), // Rule ID 55277 //
     /* 2418015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2418018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2418030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2418051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418058 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2418061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418086 */     // GIR_Coverage, 55277,
     /* 2418086 */     GIR_EraseRootFromParent_Done,
     /* 2418087 */   // Label 34754: @2418087
     /* 2418087 */   GIM_Try, /*On fail goto*//*Label 34755*/ GIMT_Encode4(2418164), // Rule ID 72760 //
     /* 2418092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2418095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2418111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2418128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418135 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2418138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418163 */     // GIR_Coverage, 72760,
     /* 2418163 */     GIR_EraseRootFromParent_Done,
     /* 2418164 */   // Label 34755: @2418164
     /* 2418164 */   GIM_Try, /*On fail goto*//*Label 34756*/ GIMT_Encode4(2418241), // Rule ID 72761 //
     /* 2418169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2418172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2418188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2418205 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418212 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2418215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418240 */     // GIR_Coverage, 72761,
     /* 2418240 */     GIR_EraseRootFromParent_Done,
     /* 2418241 */   // Label 34756: @2418241
     /* 2418241 */   GIM_Try, /*On fail goto*//*Label 34757*/ GIMT_Encode4(2418303), // Rule ID 55280 //
     /* 2418246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2418249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2418261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418276 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2418279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418302 */     // GIR_Coverage, 55280,
     /* 2418302 */     GIR_EraseRootFromParent_Done,
     /* 2418303 */   // Label 34757: @2418303
     /* 2418303 */   GIM_Try, /*On fail goto*//*Label 34758*/ GIMT_Encode4(2418365), // Rule ID 55281 //
     /* 2418308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2418311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2418323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418338 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2418341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418364 */     // GIR_Coverage, 55281,
     /* 2418364 */     GIR_EraseRootFromParent_Done,
     /* 2418365 */   // Label 34758: @2418365
     /* 2418365 */   GIM_Try, /*On fail goto*//*Label 34759*/ GIMT_Encode4(2418427), // Rule ID 72764 //
     /* 2418370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2418373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2418389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418400 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2418403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418426 */     // GIR_Coverage, 72764,
     /* 2418426 */     GIR_EraseRootFromParent_Done,
     /* 2418427 */   // Label 34759: @2418427
     /* 2418427 */   GIM_Try, /*On fail goto*//*Label 34760*/ GIMT_Encode4(2418489), // Rule ID 72765 //
     /* 2418432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2418435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2418451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418462 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2418465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418488 */     // GIR_Coverage, 72765,
     /* 2418488 */     GIR_EraseRootFromParent_Done,
     /* 2418489 */   // Label 34760: @2418489
     /* 2418489 */   GIM_Try, /*On fail goto*//*Label 34761*/ GIMT_Encode4(2418551), // Rule ID 55272 //
     /* 2418494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2418497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2418517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418524 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2418527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2418537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418550 */     // GIR_Coverage, 55272,
     /* 2418550 */     GIR_EraseRootFromParent_Done,
     /* 2418551 */   // Label 34761: @2418551
     /* 2418551 */   GIM_Try, /*On fail goto*//*Label 34762*/ GIMT_Encode4(2418613), // Rule ID 55273 //
     /* 2418556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2418559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2418579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418586 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2418589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2418599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418612 */     // GIR_Coverage, 55273,
     /* 2418612 */     GIR_EraseRootFromParent_Done,
     /* 2418613 */   // Label 34762: @2418613
     /* 2418613 */   GIM_Try, /*On fail goto*//*Label 34763*/ GIMT_Encode4(2418658), // Rule ID 55268 //
     /* 2418618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2418621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418633 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2418636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418657 */     // GIR_Coverage, 55268,
     /* 2418657 */     GIR_EraseRootFromParent_Done,
     /* 2418658 */   // Label 34763: @2418658
     /* 2418658 */   GIM_Try, /*On fail goto*//*Label 34764*/ GIMT_Encode4(2418703), // Rule ID 55269 //
     /* 2418663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2418666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418678 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2418681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418702 */     // GIR_Coverage, 55269,
     /* 2418702 */     GIR_EraseRootFromParent_Done,
     /* 2418703 */   // Label 34764: @2418703
     /* 2418703 */   GIM_Reject,
     /* 2418704 */ // Label 34752: @2418704
     /* 2418704 */ GIM_Reject,
     /* 2418705 */ // Label 34512: @2418705
     /* 2418705 */ GIM_Try, /*On fail goto*//*Label 34765*/ GIMT_Encode4(2419494),
     /* 2418710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2418713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2418716 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2418719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418723 */   GIM_Try, /*On fail goto*//*Label 34766*/ GIMT_Encode4(2418800), // Rule ID 55532 //
     /* 2418728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2418731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2418743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2418764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418771 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2418774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418799 */     // GIR_Coverage, 55532,
     /* 2418799 */     GIR_EraseRootFromParent_Done,
     /* 2418800 */   // Label 34766: @2418800
     /* 2418800 */   GIM_Try, /*On fail goto*//*Label 34767*/ GIMT_Encode4(2418877), // Rule ID 55533 //
     /* 2418805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2418808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2418820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2418841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418848 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2418851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418876 */     // GIR_Coverage, 55533,
     /* 2418876 */     GIR_EraseRootFromParent_Done,
     /* 2418877 */   // Label 34767: @2418877
     /* 2418877 */   GIM_Try, /*On fail goto*//*Label 34768*/ GIMT_Encode4(2418954), // Rule ID 72984 //
     /* 2418882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2418885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2418901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2418918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418925 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2418928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418953 */     // GIR_Coverage, 72984,
     /* 2418953 */     GIR_EraseRootFromParent_Done,
     /* 2418954 */   // Label 34768: @2418954
     /* 2418954 */   GIM_Try, /*On fail goto*//*Label 34769*/ GIMT_Encode4(2419031), // Rule ID 72985 //
     /* 2418959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2418962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2418978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2418995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2419002 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2419005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2419017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419030 */     // GIR_Coverage, 72985,
     /* 2419030 */     GIR_EraseRootFromParent_Done,
     /* 2419031 */   // Label 34769: @2419031
     /* 2419031 */   GIM_Try, /*On fail goto*//*Label 34770*/ GIMT_Encode4(2419093), // Rule ID 55536 //
     /* 2419036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2419039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2419051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419066 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2419069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419092 */     // GIR_Coverage, 55536,
     /* 2419092 */     GIR_EraseRootFromParent_Done,
     /* 2419093 */   // Label 34770: @2419093
     /* 2419093 */   GIM_Try, /*On fail goto*//*Label 34771*/ GIMT_Encode4(2419155), // Rule ID 55537 //
     /* 2419098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2419101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2419113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419128 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2419131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419154 */     // GIR_Coverage, 55537,
     /* 2419154 */     GIR_EraseRootFromParent_Done,
     /* 2419155 */   // Label 34771: @2419155
     /* 2419155 */   GIM_Try, /*On fail goto*//*Label 34772*/ GIMT_Encode4(2419217), // Rule ID 72988 //
     /* 2419160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2419163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2419179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419190 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2419193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419216 */     // GIR_Coverage, 72988,
     /* 2419216 */     GIR_EraseRootFromParent_Done,
     /* 2419217 */   // Label 34772: @2419217
     /* 2419217 */   GIM_Try, /*On fail goto*//*Label 34773*/ GIMT_Encode4(2419279), // Rule ID 72989 //
     /* 2419222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2419225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2419241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419252 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2419255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419278 */     // GIR_Coverage, 72989,
     /* 2419278 */     GIR_EraseRootFromParent_Done,
     /* 2419279 */   // Label 34773: @2419279
     /* 2419279 */   GIM_Try, /*On fail goto*//*Label 34774*/ GIMT_Encode4(2419341), // Rule ID 55528 //
     /* 2419284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2419287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2419307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419314 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2419317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2419323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2419327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419340 */     // GIR_Coverage, 55528,
     /* 2419340 */     GIR_EraseRootFromParent_Done,
     /* 2419341 */   // Label 34774: @2419341
     /* 2419341 */   GIM_Try, /*On fail goto*//*Label 34775*/ GIMT_Encode4(2419403), // Rule ID 55529 //
     /* 2419346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2419349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2419369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419376 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2419379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2419385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2419389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419402 */     // GIR_Coverage, 55529,
     /* 2419402 */     GIR_EraseRootFromParent_Done,
     /* 2419403 */   // Label 34775: @2419403
     /* 2419403 */   GIM_Try, /*On fail goto*//*Label 34776*/ GIMT_Encode4(2419448), // Rule ID 55524 //
     /* 2419408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2419411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419423 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2419426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2419432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419447 */     // GIR_Coverage, 55524,
     /* 2419447 */     GIR_EraseRootFromParent_Done,
     /* 2419448 */   // Label 34776: @2419448
     /* 2419448 */   GIM_Try, /*On fail goto*//*Label 34777*/ GIMT_Encode4(2419493), // Rule ID 55525 //
     /* 2419453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2419456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419468 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2419471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2419477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419492 */     // GIR_Coverage, 55525,
     /* 2419492 */     GIR_EraseRootFromParent_Done,
     /* 2419493 */   // Label 34777: @2419493
     /* 2419493 */   GIM_Reject,
     /* 2419494 */ // Label 34765: @2419494
     /* 2419494 */ GIM_Reject,
     /* 2419495 */ // Label 34513: @2419495
     /* 2419495 */ GIM_Try, /*On fail goto*//*Label 34778*/ GIMT_Encode4(2420284),
     /* 2419500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2419503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2419506 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2419509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419513 */   GIM_Try, /*On fail goto*//*Label 34779*/ GIMT_Encode4(2419590), // Rule ID 55340 //
     /* 2419518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2419533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2419546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2419554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2419561 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2419564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2419576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419589 */     // GIR_Coverage, 55340,
     /* 2419589 */     GIR_EraseRootFromParent_Done,
     /* 2419590 */   // Label 34779: @2419590
     /* 2419590 */   GIM_Try, /*On fail goto*//*Label 34780*/ GIMT_Encode4(2419667), // Rule ID 55341 //
     /* 2419595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2419610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2419623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2419631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2419638 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2419641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2419653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419666 */     // GIR_Coverage, 55341,
     /* 2419666 */     GIR_EraseRootFromParent_Done,
     /* 2419667 */   // Label 34780: @2419667
     /* 2419667 */   GIM_Try, /*On fail goto*//*Label 34781*/ GIMT_Encode4(2419744), // Rule ID 72816 //
     /* 2419672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2419691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2419700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2419708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2419715 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2419718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2419730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419743 */     // GIR_Coverage, 72816,
     /* 2419743 */     GIR_EraseRootFromParent_Done,
     /* 2419744 */   // Label 34781: @2419744
     /* 2419744 */   GIM_Try, /*On fail goto*//*Label 34782*/ GIMT_Encode4(2419821), // Rule ID 72817 //
     /* 2419749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2419768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2419777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2419785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2419792 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2419795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2419807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419820 */     // GIR_Coverage, 72817,
     /* 2419820 */     GIR_EraseRootFromParent_Done,
     /* 2419821 */   // Label 34782: @2419821
     /* 2419821 */   GIM_Try, /*On fail goto*//*Label 34783*/ GIMT_Encode4(2419883), // Rule ID 55344 //
     /* 2419826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2419841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419856 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2419859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419882 */     // GIR_Coverage, 55344,
     /* 2419882 */     GIR_EraseRootFromParent_Done,
     /* 2419883 */   // Label 34783: @2419883
     /* 2419883 */   GIM_Try, /*On fail goto*//*Label 34784*/ GIMT_Encode4(2419945), // Rule ID 55345 //
     /* 2419888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2419903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419918 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2419921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419944 */     // GIR_Coverage, 55345,
     /* 2419944 */     GIR_EraseRootFromParent_Done,
     /* 2419945 */   // Label 34784: @2419945
     /* 2419945 */   GIM_Try, /*On fail goto*//*Label 34785*/ GIMT_Encode4(2420007), // Rule ID 72820 //
     /* 2419950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2419969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419980 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2419983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420006 */     // GIR_Coverage, 72820,
     /* 2420006 */     GIR_EraseRootFromParent_Done,
     /* 2420007 */   // Label 34785: @2420007
     /* 2420007 */   GIM_Try, /*On fail goto*//*Label 34786*/ GIMT_Encode4(2420069), // Rule ID 72821 //
     /* 2420012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2420015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2420023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2420031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420042 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2420045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420068 */     // GIR_Coverage, 72821,
     /* 2420068 */     GIR_EraseRootFromParent_Done,
     /* 2420069 */   // Label 34786: @2420069
     /* 2420069 */   GIM_Try, /*On fail goto*//*Label 34787*/ GIMT_Encode4(2420131), // Rule ID 55336 //
     /* 2420074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2420077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2420097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420104 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2420107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2420117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420130 */     // GIR_Coverage, 55336,
     /* 2420130 */     GIR_EraseRootFromParent_Done,
     /* 2420131 */   // Label 34787: @2420131
     /* 2420131 */   GIM_Try, /*On fail goto*//*Label 34788*/ GIMT_Encode4(2420193), // Rule ID 55337 //
     /* 2420136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2420139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2420159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420166 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2420169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2420179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420192 */     // GIR_Coverage, 55337,
     /* 2420192 */     GIR_EraseRootFromParent_Done,
     /* 2420193 */   // Label 34788: @2420193
     /* 2420193 */   GIM_Try, /*On fail goto*//*Label 34789*/ GIMT_Encode4(2420238), // Rule ID 55332 //
     /* 2420198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2420201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420213 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2420216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420237 */     // GIR_Coverage, 55332,
     /* 2420237 */     GIR_EraseRootFromParent_Done,
     /* 2420238 */   // Label 34789: @2420238
     /* 2420238 */   GIM_Try, /*On fail goto*//*Label 34790*/ GIMT_Encode4(2420283), // Rule ID 55333 //
     /* 2420243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2420246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420258 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2420261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420282 */     // GIR_Coverage, 55333,
     /* 2420282 */     GIR_EraseRootFromParent_Done,
     /* 2420283 */   // Label 34790: @2420283
     /* 2420283 */   GIM_Reject,
     /* 2420284 */ // Label 34778: @2420284
     /* 2420284 */ GIM_Reject,
     /* 2420285 */ // Label 34514: @2420285
     /* 2420285 */ GIM_Reject,
     /* 2420286 */ // Label 103: @2420286
     /* 2420286 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34809*/ GIMT_Encode4(2422461),
     /* 2420297 */ /*GILLT_s16*//*Label 34791*/ GIMT_Encode4(2420417),
     /* 2420301 */ /*GILLT_s32*//*Label 34792*/ GIMT_Encode4(2420539),
     /* 2420305 */ /*GILLT_s64*//*Label 34793*/ GIMT_Encode4(2420661), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2420317 */ /*GILLT_nxv1s16*//*Label 34794*/ GIMT_Encode4(2420811),
     /* 2420321 */ /*GILLT_nxv1s32*//*Label 34795*/ GIMT_Encode4(2420921),
     /* 2420325 */ /*GILLT_nxv1s64*//*Label 34796*/ GIMT_Encode4(2421031), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2420337 */ /*GILLT_nxv2s16*//*Label 34797*/ GIMT_Encode4(2421141),
     /* 2420341 */ /*GILLT_nxv2s32*//*Label 34798*/ GIMT_Encode4(2421251),
     /* 2420345 */ /*GILLT_nxv2s64*//*Label 34799*/ GIMT_Encode4(2421361), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2420357 */ /*GILLT_nxv4s16*//*Label 34800*/ GIMT_Encode4(2421471),
     /* 2420361 */ /*GILLT_nxv4s32*//*Label 34801*/ GIMT_Encode4(2421581),
     /* 2420365 */ /*GILLT_nxv4s64*//*Label 34802*/ GIMT_Encode4(2421691), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2420377 */ /*GILLT_nxv8s16*//*Label 34803*/ GIMT_Encode4(2421801),
     /* 2420381 */ /*GILLT_nxv8s32*//*Label 34804*/ GIMT_Encode4(2421911),
     /* 2420385 */ /*GILLT_nxv8s64*//*Label 34805*/ GIMT_Encode4(2422021), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2420397 */ /*GILLT_nxv16s16*//*Label 34806*/ GIMT_Encode4(2422131),
     /* 2420401 */ /*GILLT_nxv16s32*//*Label 34807*/ GIMT_Encode4(2422241), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2420413 */ /*GILLT_nxv32s16*//*Label 34808*/ GIMT_Encode4(2422351),
     /* 2420417 */ // Label 34791: @2420417
     /* 2420417 */ GIM_Try, /*On fail goto*//*Label 34810*/ GIMT_Encode4(2420538),
     /* 2420422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2420425 */   GIM_Try, /*On fail goto*//*Label 34811*/ GIMT_Encode4(2420453), // Rule ID 1978 //
     /* 2420430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2420433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2420437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2420441 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2420441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2420444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420452 */     // GIR_Coverage, 1978,
     /* 2420452 */     GIR_EraseRootFromParent_Done,
     /* 2420453 */   // Label 34811: @2420453
     /* 2420453 */   GIM_Try, /*On fail goto*//*Label 34812*/ GIMT_Encode4(2420481), // Rule ID 1979 //
     /* 2420458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2420461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2420465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2420469 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2420469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2420472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420480 */     // GIR_Coverage, 1979,
     /* 2420480 */     GIR_EraseRootFromParent_Done,
     /* 2420481 */   // Label 34812: @2420481
     /* 2420481 */   GIM_Try, /*On fail goto*//*Label 34813*/ GIMT_Encode4(2420509), // Rule ID 2011 //
     /* 2420486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2420489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2420493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2420497 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2420497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2420500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420508 */     // GIR_Coverage, 2011,
     /* 2420508 */     GIR_EraseRootFromParent_Done,
     /* 2420509 */   // Label 34813: @2420509
     /* 2420509 */   GIM_Try, /*On fail goto*//*Label 34814*/ GIMT_Encode4(2420537), // Rule ID 2012 //
     /* 2420514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2420517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2420521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2420525 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2420525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2420528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420536 */     // GIR_Coverage, 2012,
     /* 2420536 */     GIR_EraseRootFromParent_Done,
     /* 2420537 */   // Label 34814: @2420537
     /* 2420537 */   GIM_Reject,
     /* 2420538 */ // Label 34810: @2420538
     /* 2420538 */ GIM_Reject,
     /* 2420539 */ // Label 34792: @2420539
     /* 2420539 */ GIM_Try, /*On fail goto*//*Label 34815*/ GIMT_Encode4(2420660),
     /* 2420544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2420547 */   GIM_Try, /*On fail goto*//*Label 34816*/ GIMT_Encode4(2420575), // Rule ID 1269 //
     /* 2420552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2420555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2420559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2420563 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2420563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2420566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420574 */     // GIR_Coverage, 1269,
     /* 2420574 */     GIR_EraseRootFromParent_Done,
     /* 2420575 */   // Label 34816: @2420575
     /* 2420575 */   GIM_Try, /*On fail goto*//*Label 34817*/ GIMT_Encode4(2420603), // Rule ID 1270 //
     /* 2420580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2420583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2420587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2420591 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2420591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2420594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420602 */     // GIR_Coverage, 1270,
     /* 2420602 */     GIR_EraseRootFromParent_Done,
     /* 2420603 */   // Label 34817: @2420603
     /* 2420603 */   GIM_Try, /*On fail goto*//*Label 34818*/ GIMT_Encode4(2420631), // Rule ID 1277 //
     /* 2420608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2420611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2420615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2420619 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2420619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2420622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420630 */     // GIR_Coverage, 1277,
     /* 2420630 */     GIR_EraseRootFromParent_Done,
     /* 2420631 */   // Label 34818: @2420631
     /* 2420631 */   GIM_Try, /*On fail goto*//*Label 34819*/ GIMT_Encode4(2420659), // Rule ID 1278 //
     /* 2420636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2420639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2420643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2420647 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2420647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2420650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420658 */     // GIR_Coverage, 1278,
     /* 2420658 */     GIR_EraseRootFromParent_Done,
     /* 2420659 */   // Label 34819: @2420659
     /* 2420659 */   GIM_Reject,
     /* 2420660 */ // Label 34815: @2420660
     /* 2420660 */ GIM_Reject,
     /* 2420661 */ // Label 34793: @2420661
     /* 2420661 */ GIM_Try, /*On fail goto*//*Label 34820*/ GIMT_Encode4(2420810),
     /* 2420666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420669 */   GIM_Try, /*On fail goto*//*Label 34821*/ GIMT_Encode4(2420697), // Rule ID 1612 //
     /* 2420674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2420677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2420681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2420685 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2420685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2420688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420696 */     // GIR_Coverage, 1612,
     /* 2420696 */     GIR_EraseRootFromParent_Done,
     /* 2420697 */   // Label 34821: @2420697
     /* 2420697 */   GIM_Try, /*On fail goto*//*Label 34822*/ GIMT_Encode4(2420725), // Rule ID 1613 //
     /* 2420702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2420705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2420709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2420713 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2420713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2420716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420724 */     // GIR_Coverage, 1613,
     /* 2420724 */     GIR_EraseRootFromParent_Done,
     /* 2420725 */   // Label 34822: @2420725
     /* 2420725 */   GIM_Try, /*On fail goto*//*Label 34823*/ GIMT_Encode4(2420753), // Rule ID 1647 //
     /* 2420730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2420733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420741 */     // (strict_fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2420741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2420744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420752 */     // GIR_Coverage, 1647,
     /* 2420752 */     GIR_EraseRootFromParent_Done,
     /* 2420753 */   // Label 34823: @2420753
     /* 2420753 */   GIM_Try, /*On fail goto*//*Label 34824*/ GIMT_Encode4(2420781), // Rule ID 1667 //
     /* 2420758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2420761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2420765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2420769 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2420769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2420772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420780 */     // GIR_Coverage, 1667,
     /* 2420780 */     GIR_EraseRootFromParent_Done,
     /* 2420781 */   // Label 34824: @2420781
     /* 2420781 */   GIM_Try, /*On fail goto*//*Label 34825*/ GIMT_Encode4(2420809), // Rule ID 1668 //
     /* 2420786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2420789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2420793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2420797 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2420797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2420800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420808 */     // GIR_Coverage, 1668,
     /* 2420808 */     GIR_EraseRootFromParent_Done,
     /* 2420809 */   // Label 34825: @2420809
     /* 2420809 */   GIM_Reject,
     /* 2420810 */ // Label 34820: @2420810
     /* 2420810 */ GIM_Reject,
     /* 2420811 */ // Label 34794: @2420811
     /* 2420811 */ GIM_Try, /*On fail goto*//*Label 34826*/ GIMT_Encode4(2420920),
     /* 2420816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2420819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420827 */   GIM_Try, /*On fail goto*//*Label 34827*/ GIMT_Encode4(2420873), // Rule ID 56228 //
     /* 2420832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2420835 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2420835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2420838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2420852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420872 */     // GIR_Coverage, 56228,
     /* 2420872 */     GIR_EraseRootFromParent_Done,
     /* 2420873 */   // Label 34827: @2420873
     /* 2420873 */   GIM_Try, /*On fail goto*//*Label 34828*/ GIMT_Encode4(2420919), // Rule ID 56229 //
     /* 2420878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2420881 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2420881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2420884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2420898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420918 */     // GIR_Coverage, 56229,
     /* 2420918 */     GIR_EraseRootFromParent_Done,
     /* 2420919 */   // Label 34828: @2420919
     /* 2420919 */   GIM_Reject,
     /* 2420920 */ // Label 34826: @2420920
     /* 2420920 */ GIM_Reject,
     /* 2420921 */ // Label 34795: @2420921
     /* 2420921 */ GIM_Try, /*On fail goto*//*Label 34829*/ GIMT_Encode4(2421030),
     /* 2420926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2420929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420937 */   GIM_Try, /*On fail goto*//*Label 34830*/ GIMT_Encode4(2420983), // Rule ID 56268 //
     /* 2420942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420945 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2420945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2420948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2420962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420982 */     // GIR_Coverage, 56268,
     /* 2420982 */     GIR_EraseRootFromParent_Done,
     /* 2420983 */   // Label 34830: @2420983
     /* 2420983 */   GIM_Try, /*On fail goto*//*Label 34831*/ GIMT_Encode4(2421029), // Rule ID 56269 //
     /* 2420988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420991 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2420991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2420994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2421008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421028 */     // GIR_Coverage, 56269,
     /* 2421028 */     GIR_EraseRootFromParent_Done,
     /* 2421029 */   // Label 34831: @2421029
     /* 2421029 */   GIM_Reject,
     /* 2421030 */ // Label 34829: @2421030
     /* 2421030 */ GIM_Reject,
     /* 2421031 */ // Label 34796: @2421031
     /* 2421031 */ GIM_Try, /*On fail goto*//*Label 34832*/ GIMT_Encode4(2421140),
     /* 2421036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2421039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421047 */   GIM_Try, /*On fail goto*//*Label 34833*/ GIMT_Encode4(2421093), // Rule ID 56328 //
     /* 2421052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421055 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2421055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2421058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2421072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421092 */     // GIR_Coverage, 56328,
     /* 2421092 */     GIR_EraseRootFromParent_Done,
     /* 2421093 */   // Label 34833: @2421093
     /* 2421093 */   GIM_Try, /*On fail goto*//*Label 34834*/ GIMT_Encode4(2421139), // Rule ID 56329 //
     /* 2421098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421101 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2421101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2421104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2421118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421138 */     // GIR_Coverage, 56329,
     /* 2421138 */     GIR_EraseRootFromParent_Done,
     /* 2421139 */   // Label 34834: @2421139
     /* 2421139 */   GIM_Reject,
     /* 2421140 */ // Label 34832: @2421140
     /* 2421140 */ GIM_Reject,
     /* 2421141 */ // Label 34797: @2421141
     /* 2421141 */ GIM_Try, /*On fail goto*//*Label 34835*/ GIMT_Encode4(2421250),
     /* 2421146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2421149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421157 */   GIM_Try, /*On fail goto*//*Label 34836*/ GIMT_Encode4(2421203), // Rule ID 56248 //
     /* 2421162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2421165 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2421165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2421168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2421182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421202 */     // GIR_Coverage, 56248,
     /* 2421202 */     GIR_EraseRootFromParent_Done,
     /* 2421203 */   // Label 34836: @2421203
     /* 2421203 */   GIM_Try, /*On fail goto*//*Label 34837*/ GIMT_Encode4(2421249), // Rule ID 56249 //
     /* 2421208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2421211 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2421211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2421214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2421228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421248 */     // GIR_Coverage, 56249,
     /* 2421248 */     GIR_EraseRootFromParent_Done,
     /* 2421249 */   // Label 34837: @2421249
     /* 2421249 */   GIM_Reject,
     /* 2421250 */ // Label 34835: @2421250
     /* 2421250 */ GIM_Reject,
     /* 2421251 */ // Label 34798: @2421251
     /* 2421251 */ GIM_Try, /*On fail goto*//*Label 34838*/ GIMT_Encode4(2421360),
     /* 2421256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2421259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421267 */   GIM_Try, /*On fail goto*//*Label 34839*/ GIMT_Encode4(2421313), // Rule ID 56308 //
     /* 2421272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2421275 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2421275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2421278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2421292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421312 */     // GIR_Coverage, 56308,
     /* 2421312 */     GIR_EraseRootFromParent_Done,
     /* 2421313 */   // Label 34839: @2421313
     /* 2421313 */   GIM_Try, /*On fail goto*//*Label 34840*/ GIMT_Encode4(2421359), // Rule ID 56309 //
     /* 2421318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2421321 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2421321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2421324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2421338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421358 */     // GIR_Coverage, 56309,
     /* 2421358 */     GIR_EraseRootFromParent_Done,
     /* 2421359 */   // Label 34840: @2421359
     /* 2421359 */   GIM_Reject,
     /* 2421360 */ // Label 34838: @2421360
     /* 2421360 */ GIM_Reject,
     /* 2421361 */ // Label 34799: @2421361
     /* 2421361 */ GIM_Try, /*On fail goto*//*Label 34841*/ GIMT_Encode4(2421470),
     /* 2421366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2421369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421377 */   GIM_Try, /*On fail goto*//*Label 34842*/ GIMT_Encode4(2421423), // Rule ID 56468 //
     /* 2421382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421385 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2421385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2421388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2421402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421422 */     // GIR_Coverage, 56468,
     /* 2421422 */     GIR_EraseRootFromParent_Done,
     /* 2421423 */   // Label 34842: @2421423
     /* 2421423 */   GIM_Try, /*On fail goto*//*Label 34843*/ GIMT_Encode4(2421469), // Rule ID 56469 //
     /* 2421428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421431 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2421431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2421434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2421448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421468 */     // GIR_Coverage, 56469,
     /* 2421468 */     GIR_EraseRootFromParent_Done,
     /* 2421469 */   // Label 34843: @2421469
     /* 2421469 */   GIM_Reject,
     /* 2421470 */ // Label 34841: @2421470
     /* 2421470 */ GIM_Reject,
     /* 2421471 */ // Label 34800: @2421471
     /* 2421471 */ GIM_Try, /*On fail goto*//*Label 34844*/ GIMT_Encode4(2421580),
     /* 2421476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2421479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421487 */   GIM_Try, /*On fail goto*//*Label 34845*/ GIMT_Encode4(2421533), // Rule ID 56288 //
     /* 2421492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2421495 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2421495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2421498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2421512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421532 */     // GIR_Coverage, 56288,
     /* 2421532 */     GIR_EraseRootFromParent_Done,
     /* 2421533 */   // Label 34845: @2421533
     /* 2421533 */   GIM_Try, /*On fail goto*//*Label 34846*/ GIMT_Encode4(2421579), // Rule ID 56289 //
     /* 2421538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2421541 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2421541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2421544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2421558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421578 */     // GIR_Coverage, 56289,
     /* 2421578 */     GIR_EraseRootFromParent_Done,
     /* 2421579 */   // Label 34846: @2421579
     /* 2421579 */   GIM_Reject,
     /* 2421580 */ // Label 34844: @2421580
     /* 2421580 */ GIM_Reject,
     /* 2421581 */ // Label 34801: @2421581
     /* 2421581 */ GIM_Try, /*On fail goto*//*Label 34847*/ GIMT_Encode4(2421690),
     /* 2421586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2421589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421597 */   GIM_Try, /*On fail goto*//*Label 34848*/ GIMT_Encode4(2421643), // Rule ID 56408 //
     /* 2421602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2421605 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2421605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2421608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2421622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421642 */     // GIR_Coverage, 56408,
     /* 2421642 */     GIR_EraseRootFromParent_Done,
     /* 2421643 */   // Label 34848: @2421643
     /* 2421643 */   GIM_Try, /*On fail goto*//*Label 34849*/ GIMT_Encode4(2421689), // Rule ID 56409 //
     /* 2421648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2421651 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2421651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2421654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2421668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421688 */     // GIR_Coverage, 56409,
     /* 2421688 */     GIR_EraseRootFromParent_Done,
     /* 2421689 */   // Label 34849: @2421689
     /* 2421689 */   GIM_Reject,
     /* 2421690 */ // Label 34847: @2421690
     /* 2421690 */ GIM_Reject,
     /* 2421691 */ // Label 34802: @2421691
     /* 2421691 */ GIM_Try, /*On fail goto*//*Label 34850*/ GIMT_Encode4(2421800),
     /* 2421696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2421699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421707 */   GIM_Try, /*On fail goto*//*Label 34851*/ GIMT_Encode4(2421753), // Rule ID 56488 //
     /* 2421712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421715 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2421715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2421718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2421732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421752 */     // GIR_Coverage, 56488,
     /* 2421752 */     GIR_EraseRootFromParent_Done,
     /* 2421753 */   // Label 34851: @2421753
     /* 2421753 */   GIM_Try, /*On fail goto*//*Label 34852*/ GIMT_Encode4(2421799), // Rule ID 56489 //
     /* 2421758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421761 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2421761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2421764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2421778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421798 */     // GIR_Coverage, 56489,
     /* 2421798 */     GIR_EraseRootFromParent_Done,
     /* 2421799 */   // Label 34852: @2421799
     /* 2421799 */   GIM_Reject,
     /* 2421800 */ // Label 34850: @2421800
     /* 2421800 */ GIM_Reject,
     /* 2421801 */ // Label 34803: @2421801
     /* 2421801 */ GIM_Try, /*On fail goto*//*Label 34853*/ GIMT_Encode4(2421910),
     /* 2421806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2421809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421817 */   GIM_Try, /*On fail goto*//*Label 34854*/ GIMT_Encode4(2421863), // Rule ID 56348 //
     /* 2421822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2421825 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2421825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2421828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2421842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421862 */     // GIR_Coverage, 56348,
     /* 2421862 */     GIR_EraseRootFromParent_Done,
     /* 2421863 */   // Label 34854: @2421863
     /* 2421863 */   GIM_Try, /*On fail goto*//*Label 34855*/ GIMT_Encode4(2421909), // Rule ID 56349 //
     /* 2421868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2421871 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2421871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2421874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2421888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421908 */     // GIR_Coverage, 56349,
     /* 2421908 */     GIR_EraseRootFromParent_Done,
     /* 2421909 */   // Label 34855: @2421909
     /* 2421909 */   GIM_Reject,
     /* 2421910 */ // Label 34853: @2421910
     /* 2421910 */ GIM_Reject,
     /* 2421911 */ // Label 34804: @2421911
     /* 2421911 */ GIM_Try, /*On fail goto*//*Label 34856*/ GIMT_Encode4(2422020),
     /* 2421916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2421919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421927 */   GIM_Try, /*On fail goto*//*Label 34857*/ GIMT_Encode4(2421973), // Rule ID 56428 //
     /* 2421932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2421935 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2421935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2421938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2421952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2421957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2421959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421972 */     // GIR_Coverage, 56428,
     /* 2421972 */     GIR_EraseRootFromParent_Done,
     /* 2421973 */   // Label 34857: @2421973
     /* 2421973 */   GIM_Try, /*On fail goto*//*Label 34858*/ GIMT_Encode4(2422019), // Rule ID 56429 //
     /* 2421978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2421981 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2421981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2421984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2421988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2421993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2421995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2421998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2422003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2422005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422018 */     // GIR_Coverage, 56429,
     /* 2422018 */     GIR_EraseRootFromParent_Done,
     /* 2422019 */   // Label 34858: @2422019
     /* 2422019 */   GIM_Reject,
     /* 2422020 */ // Label 34856: @2422020
     /* 2422020 */ GIM_Reject,
     /* 2422021 */ // Label 34805: @2422021
     /* 2422021 */ GIM_Try, /*On fail goto*//*Label 34859*/ GIMT_Encode4(2422130),
     /* 2422026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2422029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422037 */   GIM_Try, /*On fail goto*//*Label 34860*/ GIMT_Encode4(2422083), // Rule ID 56508 //
     /* 2422042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2422045 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2422045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2422048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2422052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2422057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2422059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2422062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2422067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2422069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2422078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422082 */     // GIR_Coverage, 56508,
     /* 2422082 */     GIR_EraseRootFromParent_Done,
     /* 2422083 */   // Label 34860: @2422083
     /* 2422083 */   GIM_Try, /*On fail goto*//*Label 34861*/ GIMT_Encode4(2422129), // Rule ID 56509 //
     /* 2422088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2422091 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2422091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2422094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2422098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2422103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2422105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2422108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2422113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2422115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2422124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422128 */     // GIR_Coverage, 56509,
     /* 2422128 */     GIR_EraseRootFromParent_Done,
     /* 2422129 */   // Label 34861: @2422129
     /* 2422129 */   GIM_Reject,
     /* 2422130 */ // Label 34859: @2422130
     /* 2422130 */ GIM_Reject,
     /* 2422131 */ // Label 34806: @2422131
     /* 2422131 */ GIM_Try, /*On fail goto*//*Label 34862*/ GIMT_Encode4(2422240),
     /* 2422136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422147 */   GIM_Try, /*On fail goto*//*Label 34863*/ GIMT_Encode4(2422193), // Rule ID 56368 //
     /* 2422152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2422155 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2422155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2422158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2422162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2422167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2422169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2422172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2422177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2422179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422192 */     // GIR_Coverage, 56368,
     /* 2422192 */     GIR_EraseRootFromParent_Done,
     /* 2422193 */   // Label 34863: @2422193
     /* 2422193 */   GIM_Try, /*On fail goto*//*Label 34864*/ GIMT_Encode4(2422239), // Rule ID 56369 //
     /* 2422198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2422201 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2422201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2422204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2422208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2422213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2422215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2422218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2422223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2422225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422238 */     // GIR_Coverage, 56369,
     /* 2422238 */     GIR_EraseRootFromParent_Done,
     /* 2422239 */   // Label 34864: @2422239
     /* 2422239 */   GIM_Reject,
     /* 2422240 */ // Label 34862: @2422240
     /* 2422240 */ GIM_Reject,
     /* 2422241 */ // Label 34807: @2422241
     /* 2422241 */ GIM_Try, /*On fail goto*//*Label 34865*/ GIMT_Encode4(2422350),
     /* 2422246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422257 */   GIM_Try, /*On fail goto*//*Label 34866*/ GIMT_Encode4(2422303), // Rule ID 56448 //
     /* 2422262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2422265 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2422265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2422268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2422272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2422277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2422279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2422282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2422287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2422289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422302 */     // GIR_Coverage, 56448,
     /* 2422302 */     GIR_EraseRootFromParent_Done,
     /* 2422303 */   // Label 34866: @2422303
     /* 2422303 */   GIM_Try, /*On fail goto*//*Label 34867*/ GIMT_Encode4(2422349), // Rule ID 56449 //
     /* 2422308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2422311 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2422311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2422314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2422318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2422323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2422325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2422328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2422333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2422335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422348 */     // GIR_Coverage, 56449,
     /* 2422348 */     GIR_EraseRootFromParent_Done,
     /* 2422349 */   // Label 34867: @2422349
     /* 2422349 */   GIM_Reject,
     /* 2422350 */ // Label 34865: @2422350
     /* 2422350 */ GIM_Reject,
     /* 2422351 */ // Label 34808: @2422351
     /* 2422351 */ GIM_Try, /*On fail goto*//*Label 34868*/ GIMT_Encode4(2422460),
     /* 2422356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2422359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422367 */   GIM_Try, /*On fail goto*//*Label 34869*/ GIMT_Encode4(2422413), // Rule ID 56388 //
     /* 2422372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2422375 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2422375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2422378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2422382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2422387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2422389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2422392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2422397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2422399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422412 */     // GIR_Coverage, 56388,
     /* 2422412 */     GIR_EraseRootFromParent_Done,
     /* 2422413 */   // Label 34869: @2422413
     /* 2422413 */   GIM_Try, /*On fail goto*//*Label 34870*/ GIMT_Encode4(2422459), // Rule ID 56389 //
     /* 2422418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2422421 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2422421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2422424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2422428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2422433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2422435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2422438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2422443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2422445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422458 */     // GIR_Coverage, 56389,
     /* 2422458 */     GIR_EraseRootFromParent_Done,
     /* 2422459 */   // Label 34870: @2422459
     /* 2422459 */   GIM_Reject,
     /* 2422460 */ // Label 34868: @2422460
     /* 2422460 */ GIM_Reject,
     /* 2422461 */ // Label 34809: @2422461
     /* 2422461 */ GIM_Reject,
     /* 2422462 */ // Label 104: @2422462
     /* 2422462 */ GIM_Try, /*On fail goto*//*Label 34871*/ GIMT_Encode4(2422474), // Rule ID 283 //
     /* 2422467 */   // (trap)  =>  (UNIMP)
     /* 2422467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::UNIMP),
     /* 2422472 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422473 */   // GIR_Coverage, 283,
     /* 2422473 */   GIR_Done,
     /* 2422474 */ // Label 34871: @2422474
     /* 2422474 */ GIM_Reject,
     /* 2422475 */ // Label 105: @2422475
     /* 2422475 */ GIM_Try, /*On fail goto*//*Label 34872*/ GIMT_Encode4(2422487), // Rule ID 284 //
     /* 2422480 */   // (debugtrap)  =>  (EBREAK)
     /* 2422480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::EBREAK),
     /* 2422485 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422486 */   // GIR_Coverage, 284,
     /* 2422486 */   GIR_Done,
     /* 2422487 */ // Label 34872: @2422487
     /* 2422487 */ GIM_Reject,
     /* 2422488 */ // Label 106: @2422488
     /* 2422488 */ GIM_Try, /*On fail goto*//*Label 34873*/ GIMT_Encode4(2422582),
     /* 2422493 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2422496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422503 */   GIM_Try, /*On fail goto*//*Label 34874*/ GIMT_Encode4(2422522), // Rule ID 2510 //
     /* 2422508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2422511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422515 */     // (riscv_clzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2422515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZW),
     /* 2422520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422521 */     // GIR_Coverage, 2510,
     /* 2422521 */     GIR_Done,
     /* 2422522 */   // Label 34874: @2422522
     /* 2422522 */   GIM_Try, /*On fail goto*//*Label 34875*/ GIMT_Encode4(2422581), // Rule ID 62563 //
     /* 2422527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2422530 */     // (riscv_clzw:{ *:[i64] } i64:{ *:[i64] }:$rs1)  =>  (TH_FF0:{ *:[i64] } (SLLI:{ *:[i64] } (XORI:{ *:[i64] } i64:{ *:[i64] }:$rs1, -1:{ *:[i64] }), 32:{ *:[i64] }))
     /* 2422530 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 2422533 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2422537 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2422542 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /* 2422546 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/uint8_t(-1),
     /* 2422549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 2422551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2422554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2422558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2422563 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2422566 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2422569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2422571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2422574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2422579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422580 */     // GIR_Coverage, 62563,
     /* 2422580 */     GIR_EraseRootFromParent_Done,
     /* 2422581 */   // Label 34875: @2422581
     /* 2422581 */   GIM_Reject,
     /* 2422582 */ // Label 34873: @2422582
     /* 2422582 */ GIM_Reject,
     /* 2422583 */ // Label 107: @2422583
     /* 2422583 */ GIM_Try, /*On fail goto*//*Label 34876*/ GIMT_Encode4(2422612), // Rule ID 2511 //
     /* 2422588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2422591 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2422594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422605 */   // (riscv_ctzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2422605 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZW),
     /* 2422610 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422611 */   // GIR_Coverage, 2511,
     /* 2422611 */   GIR_Done,
     /* 2422612 */ // Label 34876: @2422612
     /* 2422612 */ GIM_Reject,
     /* 2422613 */ // Label 108: @2422613
     /* 2422613 */ GIM_Try, /*On fail goto*//*Label 34877*/ GIMT_Encode4(2422649), // Rule ID 309 //
     /* 2422618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2422621 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2422624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2422630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422642 */   // (riscv_divuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2422642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVUW),
     /* 2422647 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422648 */   // GIR_Coverage, 309,
     /* 2422648 */   GIR_Done,
     /* 2422649 */ // Label 34877: @2422649
     /* 2422649 */ GIM_Reject,
     /* 2422650 */ // Label 109: @2422650
     /* 2422650 */ GIM_Try, /*On fail goto*//*Label 34878*/ GIMT_Encode4(2422686), // Rule ID 308 //
     /* 2422655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2422658 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2422661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2422667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422679 */   // (riscv_divw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2422679 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVW),
     /* 2422684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422685 */   // GIR_Coverage, 308,
     /* 2422685 */   GIR_Done,
     /* 2422686 */ // Label 34878: @2422686
     /* 2422686 */ GIM_Reject,
     /* 2422687 */ // Label 110: @2422687
     /* 2422687 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34881*/ GIMT_Encode4(2423046),
     /* 2422698 */ /*GILLT_s32*//*Label 34879*/ GIMT_Encode4(2422706),
     /* 2422702 */ /*GILLT_s64*//*Label 34880*/ GIMT_Encode4(2422863),
     /* 2422706 */ // Label 34879: @2422706
     /* 2422706 */ GIM_Try, /*On fail goto*//*Label 34882*/ GIMT_Encode4(2422732), // Rule ID 1276 //
     /* 2422711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2422714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2422725 */   // (riscv_fclass:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2422725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2422730 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422731 */   // GIR_Coverage, 1276,
     /* 2422731 */   GIR_Done,
     /* 2422732 */ // Label 34882: @2422732
     /* 2422732 */ GIM_Try, /*On fail goto*//*Label 34883*/ GIMT_Encode4(2422758), // Rule ID 1284 //
     /* 2422737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2422740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2422751 */   // (riscv_fclass:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2422751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2422756 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422757 */   // GIR_Coverage, 1284,
     /* 2422757 */   GIR_Done,
     /* 2422758 */ // Label 34883: @2422758
     /* 2422758 */ GIM_Try, /*On fail goto*//*Label 34884*/ GIMT_Encode4(2422784), // Rule ID 1619 //
     /* 2422763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2422766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2422777 */   // (riscv_fclass:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2422777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2422782 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422783 */   // GIR_Coverage, 1619,
     /* 2422783 */   GIR_Done,
     /* 2422784 */ // Label 34884: @2422784
     /* 2422784 */ GIM_Try, /*On fail goto*//*Label 34885*/ GIMT_Encode4(2422810), // Rule ID 1674 //
     /* 2422789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2422792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2422803 */   // (riscv_fclass:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2422803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2422808 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422809 */   // GIR_Coverage, 1674,
     /* 2422809 */   GIR_Done,
     /* 2422810 */ // Label 34885: @2422810
     /* 2422810 */ GIM_Try, /*On fail goto*//*Label 34886*/ GIMT_Encode4(2422836), // Rule ID 1985 //
     /* 2422815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2422818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2422821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2422829 */   // (riscv_fclass:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2422829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2422834 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422835 */   // GIR_Coverage, 1985,
     /* 2422835 */   GIR_Done,
     /* 2422836 */ // Label 34886: @2422836
     /* 2422836 */ GIM_Try, /*On fail goto*//*Label 34887*/ GIMT_Encode4(2422862), // Rule ID 2018 //
     /* 2422841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2422844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2422847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2422855 */   // (riscv_fclass:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2422855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2422860 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422861 */   // GIR_Coverage, 2018,
     /* 2422861 */   GIR_Done,
     /* 2422862 */ // Label 34887: @2422862
     /* 2422862 */ GIM_Reject,
     /* 2422863 */ // Label 34880: @2422863
     /* 2422863 */ GIM_Try, /*On fail goto*//*Label 34888*/ GIMT_Encode4(2422889), // Rule ID 1275 //
     /* 2422868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2422871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2422882 */   // (riscv_fclass:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2422882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2422887 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422888 */   // GIR_Coverage, 1275,
     /* 2422888 */   GIR_Done,
     /* 2422889 */ // Label 34888: @2422889
     /* 2422889 */ GIM_Try, /*On fail goto*//*Label 34889*/ GIMT_Encode4(2422915), // Rule ID 1283 //
     /* 2422894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2422897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2422908 */   // (riscv_fclass:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2422908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2422913 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422914 */   // GIR_Coverage, 1283,
     /* 2422914 */   GIR_Done,
     /* 2422915 */ // Label 34889: @2422915
     /* 2422915 */ GIM_Try, /*On fail goto*//*Label 34890*/ GIMT_Encode4(2422941), // Rule ID 1618 //
     /* 2422920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2422923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2422934 */   // (riscv_fclass:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2422934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2422939 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422940 */   // GIR_Coverage, 1618,
     /* 2422940 */   GIR_Done,
     /* 2422941 */ // Label 34890: @2422941
     /* 2422941 */ GIM_Try, /*On fail goto*//*Label 34891*/ GIMT_Encode4(2422967), // Rule ID 1651 //
     /* 2422946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2422949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422960 */   // (riscv_fclass:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCLASS_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2422960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_INX),
     /* 2422965 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422966 */   // GIR_Coverage, 1651,
     /* 2422966 */   GIR_Done,
     /* 2422967 */ // Label 34891: @2422967
     /* 2422967 */ GIM_Try, /*On fail goto*//*Label 34892*/ GIMT_Encode4(2422993), // Rule ID 1673 //
     /* 2422972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2422975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2422986 */   // (riscv_fclass:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2422986 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2422991 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422992 */   // GIR_Coverage, 1673,
     /* 2422992 */   GIR_Done,
     /* 2422993 */ // Label 34892: @2422993
     /* 2422993 */ GIM_Try, /*On fail goto*//*Label 34893*/ GIMT_Encode4(2423019), // Rule ID 1984 //
     /* 2422998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2423001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2423004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2423012 */   // (riscv_fclass:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2423012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2423017 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423018 */   // GIR_Coverage, 1984,
     /* 2423018 */   GIR_Done,
     /* 2423019 */ // Label 34893: @2423019
     /* 2423019 */ GIM_Try, /*On fail goto*//*Label 34894*/ GIMT_Encode4(2423045), // Rule ID 2017 //
     /* 2423024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2423027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2423030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2423038 */   // (riscv_fclass:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2423038 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2423043 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423044 */   // GIR_Coverage, 2017,
     /* 2423044 */   GIR_Done,
     /* 2423045 */ // Label 34894: @2423045
     /* 2423045 */ GIM_Reject,
     /* 2423046 */ // Label 34881: @2423046
     /* 2423046 */ GIM_Reject,
     /* 2423047 */ // Label 111: @2423047
     /* 2423047 */ GIM_Try, /*On fail goto*//*Label 34895*/ GIMT_Encode4(2423244),
     /* 2423052 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2423055 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34899*/ GIMT_Encode4(2423243),
     /* 2423066 */   /*GILLT_s16*//*Label 34896*/ GIMT_Encode4(2423078),
     /* 2423070 */   /*GILLT_s32*//*Label 34897*/ GIMT_Encode4(2423133),
     /* 2423074 */   /*GILLT_s64*//*Label 34898*/ GIMT_Encode4(2423188),
     /* 2423078 */   // Label 34896: @2423078
     /* 2423078 */   GIM_Try, /*On fail goto*//*Label 34900*/ GIMT_Encode4(2423132),
     /* 2423083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423087 */     GIM_Try, /*On fail goto*//*Label 34901*/ GIMT_Encode4(2423109), // Rule ID 2235 //
     /* 2423092 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2423095 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2423099 */       // MIs[0] frm
     /* 2423099 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2423102 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2423102 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2423107 */       GIR_RootConstrainSelectedInstOperands,
     /* 2423108 */       // GIR_Coverage, 2235,
     /* 2423108 */       GIR_Done,
     /* 2423109 */     // Label 34901: @2423109
     /* 2423109 */     GIM_Try, /*On fail goto*//*Label 34902*/ GIMT_Encode4(2423131), // Rule ID 2261 //
     /* 2423114 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2423117 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2423121 */       // MIs[0] frm
     /* 2423121 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2423124 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2423124 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2423129 */       GIR_RootConstrainSelectedInstOperands,
     /* 2423130 */       // GIR_Coverage, 2261,
     /* 2423130 */       GIR_Done,
     /* 2423131 */     // Label 34902: @2423131
     /* 2423131 */     GIM_Reject,
     /* 2423132 */   // Label 34900: @2423132
     /* 2423132 */   GIM_Reject,
     /* 2423133 */   // Label 34897: @2423133
     /* 2423133 */   GIM_Try, /*On fail goto*//*Label 34903*/ GIMT_Encode4(2423187),
     /* 2423138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423142 */     GIM_Try, /*On fail goto*//*Label 34904*/ GIMT_Encode4(2423164), // Rule ID 1501 //
     /* 2423147 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2423150 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2423154 */       // MIs[0] frm
     /* 2423154 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2423157 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2423157 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2423162 */       GIR_RootConstrainSelectedInstOperands,
     /* 2423163 */       // GIR_Coverage, 1501,
     /* 2423163 */       GIR_Done,
     /* 2423164 */     // Label 34904: @2423164
     /* 2423164 */     GIM_Try, /*On fail goto*//*Label 34905*/ GIMT_Encode4(2423186), // Rule ID 1529 //
     /* 2423169 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2423172 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2423176 */       // MIs[0] frm
     /* 2423176 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2423179 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2423179 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2423184 */       GIR_RootConstrainSelectedInstOperands,
     /* 2423185 */       // GIR_Coverage, 1529,
     /* 2423185 */       GIR_Done,
     /* 2423186 */     // Label 34905: @2423186
     /* 2423186 */     GIM_Reject,
     /* 2423187 */   // Label 34903: @2423187
     /* 2423187 */   GIM_Reject,
     /* 2423188 */   // Label 34898: @2423188
     /* 2423188 */   GIM_Try, /*On fail goto*//*Label 34906*/ GIMT_Encode4(2423242),
     /* 2423193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423197 */     GIM_Try, /*On fail goto*//*Label 34907*/ GIMT_Encode4(2423219), // Rule ID 1895 //
     /* 2423202 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2423205 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2423209 */       // MIs[0] frm
     /* 2423209 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2423212 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2423212 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2423217 */       GIR_RootConstrainSelectedInstOperands,
     /* 2423218 */       // GIR_Coverage, 1895,
     /* 2423218 */       GIR_Done,
     /* 2423219 */     // Label 34907: @2423219
     /* 2423219 */     GIM_Try, /*On fail goto*//*Label 34908*/ GIMT_Encode4(2423241), // Rule ID 1923 //
     /* 2423224 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2423227 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423231 */       // MIs[0] frm
     /* 2423231 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2423234 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2423234 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_INX),
     /* 2423239 */       GIR_RootConstrainSelectedInstOperands,
     /* 2423240 */       // GIR_Coverage, 1923,
     /* 2423240 */       GIR_Done,
     /* 2423241 */     // Label 34908: @2423241
     /* 2423241 */     GIM_Reject,
     /* 2423242 */   // Label 34906: @2423242
     /* 2423242 */   GIM_Reject,
     /* 2423243 */   // Label 34899: @2423243
     /* 2423243 */   GIM_Reject,
     /* 2423244 */ // Label 34895: @2423244
     /* 2423244 */ GIM_Reject,
     /* 2423245 */ // Label 112: @2423245
     /* 2423245 */ GIM_Try, /*On fail goto*//*Label 34909*/ GIMT_Encode4(2423442),
     /* 2423250 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2423253 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34913*/ GIMT_Encode4(2423441),
     /* 2423264 */   /*GILLT_s16*//*Label 34910*/ GIMT_Encode4(2423276),
     /* 2423268 */   /*GILLT_s32*//*Label 34911*/ GIMT_Encode4(2423331),
     /* 2423272 */   /*GILLT_s64*//*Label 34912*/ GIMT_Encode4(2423386),
     /* 2423276 */   // Label 34910: @2423276
     /* 2423276 */   GIM_Try, /*On fail goto*//*Label 34914*/ GIMT_Encode4(2423330),
     /* 2423281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423285 */     GIM_Try, /*On fail goto*//*Label 34915*/ GIMT_Encode4(2423307), // Rule ID 2233 //
     /* 2423290 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2423293 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2423297 */       // MIs[0] frm
     /* 2423297 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2423300 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2423300 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2423305 */       GIR_RootConstrainSelectedInstOperands,
     /* 2423306 */       // GIR_Coverage, 2233,
     /* 2423306 */       GIR_Done,
     /* 2423307 */     // Label 34915: @2423307
     /* 2423307 */     GIM_Try, /*On fail goto*//*Label 34916*/ GIMT_Encode4(2423329), // Rule ID 2259 //
     /* 2423312 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2423315 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2423319 */       // MIs[0] frm
     /* 2423319 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2423322 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2423322 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2423327 */       GIR_RootConstrainSelectedInstOperands,
     /* 2423328 */       // GIR_Coverage, 2259,
     /* 2423328 */       GIR_Done,
     /* 2423329 */     // Label 34916: @2423329
     /* 2423329 */     GIM_Reject,
     /* 2423330 */   // Label 34914: @2423330
     /* 2423330 */   GIM_Reject,
     /* 2423331 */   // Label 34911: @2423331
     /* 2423331 */   GIM_Try, /*On fail goto*//*Label 34917*/ GIMT_Encode4(2423385),
     /* 2423336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423340 */     GIM_Try, /*On fail goto*//*Label 34918*/ GIMT_Encode4(2423362), // Rule ID 1499 //
     /* 2423345 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2423348 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2423352 */       // MIs[0] frm
     /* 2423352 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2423355 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2423355 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2423360 */       GIR_RootConstrainSelectedInstOperands,
     /* 2423361 */       // GIR_Coverage, 1499,
     /* 2423361 */       GIR_Done,
     /* 2423362 */     // Label 34918: @2423362
     /* 2423362 */     GIM_Try, /*On fail goto*//*Label 34919*/ GIMT_Encode4(2423384), // Rule ID 1527 //
     /* 2423367 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2423370 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2423374 */       // MIs[0] frm
     /* 2423374 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2423377 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2423377 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2423382 */       GIR_RootConstrainSelectedInstOperands,
     /* 2423383 */       // GIR_Coverage, 1527,
     /* 2423383 */       GIR_Done,
     /* 2423384 */     // Label 34919: @2423384
     /* 2423384 */     GIM_Reject,
     /* 2423385 */   // Label 34917: @2423385
     /* 2423385 */   GIM_Reject,
     /* 2423386 */   // Label 34912: @2423386
     /* 2423386 */   GIM_Try, /*On fail goto*//*Label 34920*/ GIMT_Encode4(2423440),
     /* 2423391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423395 */     GIM_Try, /*On fail goto*//*Label 34921*/ GIMT_Encode4(2423417), // Rule ID 1893 //
     /* 2423400 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2423403 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2423407 */       // MIs[0] frm
     /* 2423407 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2423410 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2423410 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2423415 */       GIR_RootConstrainSelectedInstOperands,
     /* 2423416 */       // GIR_Coverage, 1893,
     /* 2423416 */       GIR_Done,
     /* 2423417 */     // Label 34921: @2423417
     /* 2423417 */     GIM_Try, /*On fail goto*//*Label 34922*/ GIMT_Encode4(2423439), // Rule ID 1921 //
     /* 2423422 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2423425 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423429 */       // MIs[0] frm
     /* 2423429 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2423432 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2423432 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_INX),
     /* 2423437 */       GIR_RootConstrainSelectedInstOperands,
     /* 2423438 */       // GIR_Coverage, 1921,
     /* 2423438 */       GIR_Done,
     /* 2423439 */     // Label 34922: @2423439
     /* 2423439 */     GIM_Reject,
     /* 2423440 */   // Label 34920: @2423440
     /* 2423440 */   GIM_Reject,
     /* 2423441 */   // Label 34913: @2423441
     /* 2423441 */   GIM_Reject,
     /* 2423442 */ // Label 34909: @2423442
     /* 2423442 */ GIM_Reject,
     /* 2423443 */ // Label 113: @2423443
     /* 2423443 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34925*/ GIMT_Encode4(2423502),
     /* 2423454 */ /*GILLT_s32*//*Label 34923*/ GIMT_Encode4(2423462),
     /* 2423458 */ /*GILLT_s64*//*Label 34924*/ GIMT_Encode4(2423482),
     /* 2423462 */ // Label 34923: @2423462
     /* 2423462 */ GIM_Try, /*On fail goto*//*Label 34926*/ GIMT_Encode4(2423481), // Rule ID 67 //
     /* 2423467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423474 */   // (riscv_read_vlenb:{ *:[i32] })  =>  (PseudoReadVLENB:{ *:[i32] })
     /* 2423474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2423479 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423480 */   // GIR_Coverage, 67,
     /* 2423480 */   GIR_Done,
     /* 2423481 */ // Label 34926: @2423481
     /* 2423481 */ GIM_Reject,
     /* 2423482 */ // Label 34924: @2423482
     /* 2423482 */ GIM_Try, /*On fail goto*//*Label 34927*/ GIMT_Encode4(2423501), // Rule ID 66 //
     /* 2423487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423494 */   // (riscv_read_vlenb:{ *:[i64] })  =>  (PseudoReadVLENB:{ *:[i64] })
     /* 2423494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2423499 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423500 */   // GIR_Coverage, 66,
     /* 2423500 */   GIR_Done,
     /* 2423501 */ // Label 34927: @2423501
     /* 2423501 */ GIM_Reject,
     /* 2423502 */ // Label 34925: @2423502
     /* 2423502 */ GIM_Reject,
     /* 2423503 */ // Label 114: @2423503
     /* 2423503 */ GIM_Try, /*On fail goto*//*Label 34928*/ GIMT_Encode4(2423539), // Rule ID 310 //
     /* 2423508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2423511 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2423514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2423517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2423520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423532 */   // (riscv_remuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2423532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMUW),
     /* 2423537 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423538 */   // GIR_Coverage, 310,
     /* 2423538 */   GIR_Done,
     /* 2423539 */ // Label 34928: @2423539
     /* 2423539 */ GIM_Reject,
     /* 2423540 */ // Label 115: @2423540
     /* 2423540 */ GIM_Try, /*On fail goto*//*Label 34929*/ GIMT_Encode4(2423664),
     /* 2423545 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2423548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2423551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2423554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423562 */   GIM_Try, /*On fail goto*//*Label 34930*/ GIMT_Encode4(2423598), // Rule ID 2459 //
     /* 2423567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2423570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423582 */     // MIs[1] Operand 1
     /* 2423582 */     // No operand predicates
     /* 2423582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423584 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2423584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2423587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423591 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2423596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423597 */     // GIR_Coverage, 2459,
     /* 2423597 */     GIR_EraseRootFromParent_Done,
     /* 2423598 */   // Label 34930: @2423598
     /* 2423598 */   GIM_Try, /*On fail goto*//*Label 34931*/ GIMT_Encode4(2423634), // Rule ID 62560 //
     /* 2423603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2423606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423618 */     // MIs[1] Operand 1
     /* 2423618 */     // No operand predicates
     /* 2423618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423620 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2423620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2423623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423627 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2423632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423633 */     // GIR_Coverage, 62560,
     /* 2423633 */     GIR_EraseRootFromParent_Done,
     /* 2423634 */   // Label 34931: @2423634
     /* 2423634 */   GIM_Try, /*On fail goto*//*Label 34932*/ GIMT_Encode4(2423663), // Rule ID 2456 //
     /* 2423639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2423642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2423649 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2423649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROLW),
     /* 2423652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2423661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423662 */     // GIR_Coverage, 2456,
     /* 2423662 */     GIR_EraseRootFromParent_Done,
     /* 2423663 */   // Label 34932: @2423663
     /* 2423663 */   GIM_Reject,
     /* 2423664 */ // Label 34929: @2423664
     /* 2423664 */ GIM_Reject,
     /* 2423665 */ // Label 116: @2423665
     /* 2423665 */ GIM_Try, /*On fail goto*//*Label 34933*/ GIMT_Encode4(2423785),
     /* 2423670 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2423673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2423676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2423679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423687 */   GIM_Try, /*On fail goto*//*Label 34934*/ GIMT_Encode4(2423721), // Rule ID 2458 //
     /* 2423692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2423695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423707 */     // MIs[1] Operand 1
     /* 2423707 */     // No operand predicates
     /* 2423707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423709 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2423709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2423712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2423719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423720 */     // GIR_Coverage, 2458,
     /* 2423720 */     GIR_EraseRootFromParent_Done,
     /* 2423721 */   // Label 34934: @2423721
     /* 2423721 */   GIM_Try, /*On fail goto*//*Label 34935*/ GIMT_Encode4(2423755), // Rule ID 62559 //
     /* 2423726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2423729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423741 */     // MIs[1] Operand 1
     /* 2423741 */     // No operand predicates
     /* 2423741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423743 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2423743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2423746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2423753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423754 */     // GIR_Coverage, 62559,
     /* 2423754 */     GIR_EraseRootFromParent_Done,
     /* 2423755 */   // Label 34935: @2423755
     /* 2423755 */   GIM_Try, /*On fail goto*//*Label 34936*/ GIMT_Encode4(2423784), // Rule ID 2457 //
     /* 2423760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2423763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2423770 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (RORW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2423770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORW),
     /* 2423773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2423782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423783 */     // GIR_Coverage, 2457,
     /* 2423783 */     GIR_EraseRootFromParent_Done,
     /* 2423784 */   // Label 34936: @2423784
     /* 2423784 */   GIM_Reject,
     /* 2423785 */ // Label 34933: @2423785
     /* 2423785 */ GIM_Reject,
     /* 2423786 */ // Label 117: @2423786
     /* 2423786 */ GIM_Try, /*On fail goto*//*Label 34937*/ GIMT_Encode4(2423832), // Rule ID 261 //
     /* 2423791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2423794 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2423797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2423800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2423803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423811 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2423818 */   // (riscv_sllw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2423818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLW),
     /* 2423821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423823 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2423830 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423831 */   // GIR_Coverage, 261,
     /* 2423831 */   GIR_EraseRootFromParent_Done,
     /* 2423832 */ // Label 34937: @2423832
     /* 2423832 */ GIM_Reject,
     /* 2423833 */ // Label 118: @2423833
     /* 2423833 */ GIM_Try, /*On fail goto*//*Label 34938*/ GIMT_Encode4(2423879), // Rule ID 263 //
     /* 2423838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2423841 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2423844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2423847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2423850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423858 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2423865 */   // (riscv_sraw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRAW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2423865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAW),
     /* 2423868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423870 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2423877 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423878 */   // GIR_Coverage, 263,
     /* 2423878 */   GIR_EraseRootFromParent_Done,
     /* 2423879 */ // Label 34938: @2423879
     /* 2423879 */ GIM_Reject,
     /* 2423880 */ // Label 119: @2423880
     /* 2423880 */ GIM_Try, /*On fail goto*//*Label 34939*/ GIMT_Encode4(2423926), // Rule ID 262 //
     /* 2423885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2423888 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2423891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2423894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2423897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423905 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2423912 */   // (riscv_srlw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2423912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLW),
     /* 2423915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423917 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2423924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2423925 */   // GIR_Coverage, 262,
     /* 2423925 */   GIR_EraseRootFromParent_Done,
     /* 2423926 */ // Label 34939: @2423926
     /* 2423926 */ GIM_Reject,
     /* 2423927 */ // Label 120: @2423927
     /* 2423927 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 34947*/ GIMT_Encode4(2424575),
     /* 2423938 */ /*GILLT_nxv1s1*//*Label 34940*/ GIMT_Encode4(2424050), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2423958 */ /*GILLT_nxv2s1*//*Label 34941*/ GIMT_Encode4(2424125), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2423978 */ /*GILLT_nxv4s1*//*Label 34942*/ GIMT_Encode4(2424200), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2423998 */ /*GILLT_nxv8s1*//*Label 34943*/ GIMT_Encode4(2424275), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424018 */ /*GILLT_nxv16s1*//*Label 34944*/ GIMT_Encode4(2424350), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424034 */ /*GILLT_nxv32s1*//*Label 34945*/ GIMT_Encode4(2424425), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424046 */ /*GILLT_nxv64s1*//*Label 34946*/ GIMT_Encode4(2424500),
     /* 2424050 */ // Label 34940: @2424050
     /* 2424050 */ GIM_Try, /*On fail goto*//*Label 34948*/ GIMT_Encode4(2424087), // Rule ID 44706 //
     /* 2424055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2424061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424072 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2424072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2424075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424086 */   // GIR_Coverage, 44706,
     /* 2424086 */   GIR_EraseRootFromParent_Done,
     /* 2424087 */ // Label 34948: @2424087
     /* 2424087 */ GIM_Try, /*On fail goto*//*Label 34949*/ GIMT_Encode4(2424124), // Rule ID 44707 //
     /* 2424092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2424098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424102 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424109 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2424109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2424112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424122 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424123 */   // GIR_Coverage, 44707,
     /* 2424123 */   GIR_EraseRootFromParent_Done,
     /* 2424124 */ // Label 34949: @2424124
     /* 2424124 */ GIM_Reject,
     /* 2424125 */ // Label 34941: @2424125
     /* 2424125 */ GIM_Try, /*On fail goto*//*Label 34950*/ GIMT_Encode4(2424162), // Rule ID 44734 //
     /* 2424130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2424136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424140 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424147 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2424147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2424150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424152 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424160 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424161 */   // GIR_Coverage, 44734,
     /* 2424161 */   GIR_EraseRootFromParent_Done,
     /* 2424162 */ // Label 34950: @2424162
     /* 2424162 */ GIM_Try, /*On fail goto*//*Label 34951*/ GIMT_Encode4(2424199), // Rule ID 44735 //
     /* 2424167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2424173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424177 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424184 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2424184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2424187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424197 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424198 */   // GIR_Coverage, 44735,
     /* 2424198 */   GIR_EraseRootFromParent_Done,
     /* 2424199 */ // Label 34951: @2424199
     /* 2424199 */ GIM_Reject,
     /* 2424200 */ // Label 34942: @2424200
     /* 2424200 */ GIM_Try, /*On fail goto*//*Label 34952*/ GIMT_Encode4(2424237), // Rule ID 44762 //
     /* 2424205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2424211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424215 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424222 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2424222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2424225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424235 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424236 */   // GIR_Coverage, 44762,
     /* 2424236 */   GIR_EraseRootFromParent_Done,
     /* 2424237 */ // Label 34952: @2424237
     /* 2424237 */ GIM_Try, /*On fail goto*//*Label 34953*/ GIMT_Encode4(2424274), // Rule ID 44763 //
     /* 2424242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2424248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424252 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424259 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2424259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2424262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424272 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424273 */   // GIR_Coverage, 44763,
     /* 2424273 */   GIR_EraseRootFromParent_Done,
     /* 2424274 */ // Label 34953: @2424274
     /* 2424274 */ GIM_Reject,
     /* 2424275 */ // Label 34943: @2424275
     /* 2424275 */ GIM_Try, /*On fail goto*//*Label 34954*/ GIMT_Encode4(2424312), // Rule ID 44790 //
     /* 2424280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2424286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424290 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424297 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2424297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2424300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424310 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424311 */   // GIR_Coverage, 44790,
     /* 2424311 */   GIR_EraseRootFromParent_Done,
     /* 2424312 */ // Label 34954: @2424312
     /* 2424312 */ GIM_Try, /*On fail goto*//*Label 34955*/ GIMT_Encode4(2424349), // Rule ID 44791 //
     /* 2424317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2424323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424327 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424334 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2424334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2424337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424348 */   // GIR_Coverage, 44791,
     /* 2424348 */   GIR_EraseRootFromParent_Done,
     /* 2424349 */ // Label 34955: @2424349
     /* 2424349 */ GIM_Reject,
     /* 2424350 */ // Label 34944: @2424350
     /* 2424350 */ GIM_Try, /*On fail goto*//*Label 34956*/ GIMT_Encode4(2424387), // Rule ID 44818 //
     /* 2424355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2424361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424365 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424372 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2424372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2424375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424385 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424386 */   // GIR_Coverage, 44818,
     /* 2424386 */   GIR_EraseRootFromParent_Done,
     /* 2424387 */ // Label 34956: @2424387
     /* 2424387 */ GIM_Try, /*On fail goto*//*Label 34957*/ GIMT_Encode4(2424424), // Rule ID 44819 //
     /* 2424392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2424398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424402 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424409 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2424409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2424412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424422 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424423 */   // GIR_Coverage, 44819,
     /* 2424423 */   GIR_EraseRootFromParent_Done,
     /* 2424424 */ // Label 34957: @2424424
     /* 2424424 */ GIM_Reject,
     /* 2424425 */ // Label 34945: @2424425
     /* 2424425 */ GIM_Try, /*On fail goto*//*Label 34958*/ GIMT_Encode4(2424462), // Rule ID 44846 //
     /* 2424430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2424436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424440 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424447 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2424447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2424450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424460 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424461 */   // GIR_Coverage, 44846,
     /* 2424461 */   GIR_EraseRootFromParent_Done,
     /* 2424462 */ // Label 34958: @2424462
     /* 2424462 */ GIM_Try, /*On fail goto*//*Label 34959*/ GIMT_Encode4(2424499), // Rule ID 44847 //
     /* 2424467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2424473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424477 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424484 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2424484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2424487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424497 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424498 */   // GIR_Coverage, 44847,
     /* 2424498 */   GIR_EraseRootFromParent_Done,
     /* 2424499 */ // Label 34959: @2424499
     /* 2424499 */ GIM_Reject,
     /* 2424500 */ // Label 34946: @2424500
     /* 2424500 */ GIM_Try, /*On fail goto*//*Label 34960*/ GIMT_Encode4(2424537), // Rule ID 44874 //
     /* 2424505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2424511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424515 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424522 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2424522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2424525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424535 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424536 */   // GIR_Coverage, 44874,
     /* 2424536 */   GIR_EraseRootFromParent_Done,
     /* 2424537 */ // Label 34960: @2424537
     /* 2424537 */ GIM_Try, /*On fail goto*//*Label 34961*/ GIMT_Encode4(2424574), // Rule ID 44875 //
     /* 2424542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2424548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424552 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424559 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2424559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2424562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424572 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424573 */   // GIR_Coverage, 44875,
     /* 2424573 */   GIR_EraseRootFromParent_Done,
     /* 2424574 */ // Label 34961: @2424574
     /* 2424574 */ GIM_Reject,
     /* 2424575 */ // Label 34947: @2424575
     /* 2424575 */ GIM_Reject,
     /* 2424576 */ // Label 121: @2424576
     /* 2424576 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 34969*/ GIMT_Encode4(2425224),
     /* 2424587 */ /*GILLT_nxv1s1*//*Label 34962*/ GIMT_Encode4(2424699), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424607 */ /*GILLT_nxv2s1*//*Label 34963*/ GIMT_Encode4(2424774), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424627 */ /*GILLT_nxv4s1*//*Label 34964*/ GIMT_Encode4(2424849), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424647 */ /*GILLT_nxv8s1*//*Label 34965*/ GIMT_Encode4(2424924), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424667 */ /*GILLT_nxv16s1*//*Label 34966*/ GIMT_Encode4(2424999), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424683 */ /*GILLT_nxv32s1*//*Label 34967*/ GIMT_Encode4(2425074), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424695 */ /*GILLT_nxv64s1*//*Label 34968*/ GIMT_Encode4(2425149),
     /* 2424699 */ // Label 34962: @2424699
     /* 2424699 */ GIM_Try, /*On fail goto*//*Label 34970*/ GIMT_Encode4(2424736), // Rule ID 44704 //
     /* 2424704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2424710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424714 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424721 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2424721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2424724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424734 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424735 */   // GIR_Coverage, 44704,
     /* 2424735 */   GIR_EraseRootFromParent_Done,
     /* 2424736 */ // Label 34970: @2424736
     /* 2424736 */ GIM_Try, /*On fail goto*//*Label 34971*/ GIMT_Encode4(2424773), // Rule ID 44705 //
     /* 2424741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2424747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424751 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424758 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2424758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2424761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424772 */   // GIR_Coverage, 44705,
     /* 2424772 */   GIR_EraseRootFromParent_Done,
     /* 2424773 */ // Label 34971: @2424773
     /* 2424773 */ GIM_Reject,
     /* 2424774 */ // Label 34963: @2424774
     /* 2424774 */ GIM_Try, /*On fail goto*//*Label 34972*/ GIMT_Encode4(2424811), // Rule ID 44732 //
     /* 2424779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2424785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424789 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424796 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2424796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2424799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424801 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424809 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424810 */   // GIR_Coverage, 44732,
     /* 2424810 */   GIR_EraseRootFromParent_Done,
     /* 2424811 */ // Label 34972: @2424811
     /* 2424811 */ GIM_Try, /*On fail goto*//*Label 34973*/ GIMT_Encode4(2424848), // Rule ID 44733 //
     /* 2424816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2424822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424826 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424833 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2424833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2424836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424846 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424847 */   // GIR_Coverage, 44733,
     /* 2424847 */   GIR_EraseRootFromParent_Done,
     /* 2424848 */ // Label 34973: @2424848
     /* 2424848 */ GIM_Reject,
     /* 2424849 */ // Label 34964: @2424849
     /* 2424849 */ GIM_Try, /*On fail goto*//*Label 34974*/ GIMT_Encode4(2424886), // Rule ID 44760 //
     /* 2424854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2424860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424864 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424871 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2424871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2424874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424884 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424885 */   // GIR_Coverage, 44760,
     /* 2424885 */   GIR_EraseRootFromParent_Done,
     /* 2424886 */ // Label 34974: @2424886
     /* 2424886 */ GIM_Try, /*On fail goto*//*Label 34975*/ GIMT_Encode4(2424923), // Rule ID 44761 //
     /* 2424891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2424897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424901 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424908 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2424908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2424911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424921 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424922 */   // GIR_Coverage, 44761,
     /* 2424922 */   GIR_EraseRootFromParent_Done,
     /* 2424923 */ // Label 34975: @2424923
     /* 2424923 */ GIM_Reject,
     /* 2424924 */ // Label 34965: @2424924
     /* 2424924 */ GIM_Try, /*On fail goto*//*Label 34976*/ GIMT_Encode4(2424961), // Rule ID 44788 //
     /* 2424929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2424935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424939 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424946 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2424946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2424949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424959 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424960 */   // GIR_Coverage, 44788,
     /* 2424960 */   GIR_EraseRootFromParent_Done,
     /* 2424961 */ // Label 34976: @2424961
     /* 2424961 */ GIM_Try, /*On fail goto*//*Label 34977*/ GIMT_Encode4(2424998), // Rule ID 44789 //
     /* 2424966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2424972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424976 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424983 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2424983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2424986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2424997 */   // GIR_Coverage, 44789,
     /* 2424997 */   GIR_EraseRootFromParent_Done,
     /* 2424998 */ // Label 34977: @2424998
     /* 2424998 */ GIM_Reject,
     /* 2424999 */ // Label 34966: @2424999
     /* 2424999 */ GIM_Try, /*On fail goto*//*Label 34978*/ GIMT_Encode4(2425036), // Rule ID 44816 //
     /* 2425004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2425010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425014 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425021 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2425021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2425024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425034 */   GIR_RootConstrainSelectedInstOperands,
     /* 2425035 */   // GIR_Coverage, 44816,
     /* 2425035 */   GIR_EraseRootFromParent_Done,
     /* 2425036 */ // Label 34978: @2425036
     /* 2425036 */ GIM_Try, /*On fail goto*//*Label 34979*/ GIMT_Encode4(2425073), // Rule ID 44817 //
     /* 2425041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2425047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425051 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425058 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2425058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2425061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425071 */   GIR_RootConstrainSelectedInstOperands,
     /* 2425072 */   // GIR_Coverage, 44817,
     /* 2425072 */   GIR_EraseRootFromParent_Done,
     /* 2425073 */ // Label 34979: @2425073
     /* 2425073 */ GIM_Reject,
     /* 2425074 */ // Label 34967: @2425074
     /* 2425074 */ GIM_Try, /*On fail goto*//*Label 34980*/ GIMT_Encode4(2425111), // Rule ID 44844 //
     /* 2425079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2425085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425089 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425096 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2425096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2425099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425109 */   GIR_RootConstrainSelectedInstOperands,
     /* 2425110 */   // GIR_Coverage, 44844,
     /* 2425110 */   GIR_EraseRootFromParent_Done,
     /* 2425111 */ // Label 34980: @2425111
     /* 2425111 */ GIM_Try, /*On fail goto*//*Label 34981*/ GIMT_Encode4(2425148), // Rule ID 44845 //
     /* 2425116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2425122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425126 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425133 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2425133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2425136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425146 */   GIR_RootConstrainSelectedInstOperands,
     /* 2425147 */   // GIR_Coverage, 44845,
     /* 2425147 */   GIR_EraseRootFromParent_Done,
     /* 2425148 */ // Label 34981: @2425148
     /* 2425148 */ GIM_Reject,
     /* 2425149 */ // Label 34968: @2425149
     /* 2425149 */ GIM_Try, /*On fail goto*//*Label 34982*/ GIMT_Encode4(2425186), // Rule ID 44872 //
     /* 2425154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2425160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425164 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425171 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2425171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2425174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425184 */   GIR_RootConstrainSelectedInstOperands,
     /* 2425185 */   // GIR_Coverage, 44872,
     /* 2425185 */   GIR_EraseRootFromParent_Done,
     /* 2425186 */ // Label 34982: @2425186
     /* 2425186 */ GIM_Try, /*On fail goto*//*Label 34983*/ GIMT_Encode4(2425223), // Rule ID 44873 //
     /* 2425191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2425197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425201 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425208 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2425208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2425211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425221 */   GIR_RootConstrainSelectedInstOperands,
     /* 2425222 */   // GIR_Coverage, 44873,
     /* 2425222 */   GIR_EraseRootFromParent_Done,
     /* 2425223 */ // Label 34983: @2425223
     /* 2425223 */ GIM_Reject,
     /* 2425224 */ // Label 34969: @2425224
     /* 2425224 */ GIM_Reject,
     /* 2425225 */ // Label 122: @2425225
     /* 2425225 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35006*/ GIMT_Encode4(2429482),
     /* 2425236 */ /*GILLT_nxv1s8*//*Label 34984*/ GIMT_Encode4(2425348),
     /* 2425240 */ /*GILLT_nxv1s16*//*Label 34985*/ GIMT_Encode4(2425465),
     /* 2425244 */ /*GILLT_nxv1s32*//*Label 34986*/ GIMT_Encode4(2425686),
     /* 2425248 */ /*GILLT_nxv1s64*//*Label 34987*/ GIMT_Encode4(2425907), GIMT_Encode4(0),
     /* 2425256 */ /*GILLT_nxv2s8*//*Label 34988*/ GIMT_Encode4(2426128),
     /* 2425260 */ /*GILLT_nxv2s16*//*Label 34989*/ GIMT_Encode4(2426245),
     /* 2425264 */ /*GILLT_nxv2s32*//*Label 34990*/ GIMT_Encode4(2426466),
     /* 2425268 */ /*GILLT_nxv2s64*//*Label 34991*/ GIMT_Encode4(2426687), GIMT_Encode4(0),
     /* 2425276 */ /*GILLT_nxv4s8*//*Label 34992*/ GIMT_Encode4(2426908),
     /* 2425280 */ /*GILLT_nxv4s16*//*Label 34993*/ GIMT_Encode4(2427025),
     /* 2425284 */ /*GILLT_nxv4s32*//*Label 34994*/ GIMT_Encode4(2427246),
     /* 2425288 */ /*GILLT_nxv4s64*//*Label 34995*/ GIMT_Encode4(2427467), GIMT_Encode4(0),
     /* 2425296 */ /*GILLT_nxv8s8*//*Label 34996*/ GIMT_Encode4(2427688),
     /* 2425300 */ /*GILLT_nxv8s16*//*Label 34997*/ GIMT_Encode4(2427805),
     /* 2425304 */ /*GILLT_nxv8s32*//*Label 34998*/ GIMT_Encode4(2428026),
     /* 2425308 */ /*GILLT_nxv8s64*//*Label 34999*/ GIMT_Encode4(2428247), GIMT_Encode4(0),
     /* 2425316 */ /*GILLT_nxv16s8*//*Label 35000*/ GIMT_Encode4(2428468),
     /* 2425320 */ /*GILLT_nxv16s16*//*Label 35001*/ GIMT_Encode4(2428585),
     /* 2425324 */ /*GILLT_nxv16s32*//*Label 35002*/ GIMT_Encode4(2428806), GIMT_Encode4(0),
     /* 2425332 */ /*GILLT_nxv32s8*//*Label 35003*/ GIMT_Encode4(2429027),
     /* 2425336 */ /*GILLT_nxv32s16*//*Label 35004*/ GIMT_Encode4(2429144), GIMT_Encode4(0),
     /* 2425344 */ /*GILLT_nxv64s8*//*Label 35005*/ GIMT_Encode4(2429365),
     /* 2425348 */ // Label 34984: @2425348
     /* 2425348 */ GIM_Try, /*On fail goto*//*Label 35007*/ GIMT_Encode4(2425464),
     /* 2425353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2425356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2425359 */   GIM_Try, /*On fail goto*//*Label 35008*/ GIMT_Encode4(2425411), // Rule ID 32294 //
     /* 2425364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425389 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2425392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425394 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425410 */     // GIR_Coverage, 32294,
     /* 2425410 */     GIR_EraseRootFromParent_Done,
     /* 2425411 */   // Label 35008: @2425411
     /* 2425411 */   GIM_Try, /*On fail goto*//*Label 35009*/ GIMT_Encode4(2425463), // Rule ID 32295 //
     /* 2425416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425441 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2425444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425446 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425462 */     // GIR_Coverage, 32295,
     /* 2425462 */     GIR_EraseRootFromParent_Done,
     /* 2425463 */   // Label 35009: @2425463
     /* 2425463 */   GIM_Reject,
     /* 2425464 */ // Label 35007: @2425464
     /* 2425464 */ GIM_Reject,
     /* 2425465 */ // Label 34985: @2425465
     /* 2425465 */ GIM_Try, /*On fail goto*//*Label 35010*/ GIMT_Encode4(2425685),
     /* 2425470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2425473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2425476 */   GIM_Try, /*On fail goto*//*Label 35011*/ GIMT_Encode4(2425528), // Rule ID 32564 //
     /* 2425481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425506 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2425509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425511 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425527 */     // GIR_Coverage, 32564,
     /* 2425527 */     GIR_EraseRootFromParent_Done,
     /* 2425528 */   // Label 35011: @2425528
     /* 2425528 */   GIM_Try, /*On fail goto*//*Label 35012*/ GIMT_Encode4(2425580), // Rule ID 32565 //
     /* 2425533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425558 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2425561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425563 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425579 */     // GIR_Coverage, 32565,
     /* 2425579 */     GIR_EraseRootFromParent_Done,
     /* 2425580 */   // Label 35012: @2425580
     /* 2425580 */   GIM_Try, /*On fail goto*//*Label 35013*/ GIMT_Encode4(2425632), // Rule ID 34274 //
     /* 2425585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425610 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2425613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425615 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425631 */     // GIR_Coverage, 34274,
     /* 2425631 */     GIR_EraseRootFromParent_Done,
     /* 2425632 */   // Label 35013: @2425632
     /* 2425632 */   GIM_Try, /*On fail goto*//*Label 35014*/ GIMT_Encode4(2425684), // Rule ID 34275 //
     /* 2425637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425662 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2425665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425667 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425683 */     // GIR_Coverage, 34275,
     /* 2425683 */     GIR_EraseRootFromParent_Done,
     /* 2425684 */   // Label 35014: @2425684
     /* 2425684 */   GIM_Reject,
     /* 2425685 */ // Label 35010: @2425685
     /* 2425685 */ GIM_Reject,
     /* 2425686 */ // Label 34986: @2425686
     /* 2425686 */ GIM_Try, /*On fail goto*//*Label 35015*/ GIMT_Encode4(2425906),
     /* 2425691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2425694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2425697 */   GIM_Try, /*On fail goto*//*Label 35016*/ GIMT_Encode4(2425749), // Rule ID 32744 //
     /* 2425702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425727 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2425730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425732 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425748 */     // GIR_Coverage, 32744,
     /* 2425748 */     GIR_EraseRootFromParent_Done,
     /* 2425749 */   // Label 35016: @2425749
     /* 2425749 */   GIM_Try, /*On fail goto*//*Label 35017*/ GIMT_Encode4(2425801), // Rule ID 32745 //
     /* 2425754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425779 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2425782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425784 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425800 */     // GIR_Coverage, 32745,
     /* 2425800 */     GIR_EraseRootFromParent_Done,
     /* 2425801 */   // Label 35017: @2425801
     /* 2425801 */   GIM_Try, /*On fail goto*//*Label 35018*/ GIMT_Encode4(2425853), // Rule ID 34454 //
     /* 2425806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425831 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2425834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425836 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425852 */     // GIR_Coverage, 34454,
     /* 2425852 */     GIR_EraseRootFromParent_Done,
     /* 2425853 */   // Label 35018: @2425853
     /* 2425853 */   GIM_Try, /*On fail goto*//*Label 35019*/ GIMT_Encode4(2425905), // Rule ID 34455 //
     /* 2425858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425883 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2425886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425888 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425904 */     // GIR_Coverage, 34455,
     /* 2425904 */     GIR_EraseRootFromParent_Done,
     /* 2425905 */   // Label 35019: @2425905
     /* 2425905 */   GIM_Reject,
     /* 2425906 */ // Label 35015: @2425906
     /* 2425906 */ GIM_Reject,
     /* 2425907 */ // Label 34987: @2425907
     /* 2425907 */ GIM_Try, /*On fail goto*//*Label 35020*/ GIMT_Encode4(2426127),
     /* 2425912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2425915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2425918 */   GIM_Try, /*On fail goto*//*Label 35021*/ GIMT_Encode4(2425970), // Rule ID 33104 //
     /* 2425923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2425926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425948 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2425951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425953 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425969 */     // GIR_Coverage, 33104,
     /* 2425969 */     GIR_EraseRootFromParent_Done,
     /* 2425970 */   // Label 35021: @2425970
     /* 2425970 */   GIM_Try, /*On fail goto*//*Label 35022*/ GIMT_Encode4(2426022), // Rule ID 33105 //
     /* 2425975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2425978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426000 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2426003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426005 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426021 */     // GIR_Coverage, 33105,
     /* 2426021 */     GIR_EraseRootFromParent_Done,
     /* 2426022 */   // Label 35022: @2426022
     /* 2426022 */   GIM_Try, /*On fail goto*//*Label 35023*/ GIMT_Encode4(2426074), // Rule ID 34724 //
     /* 2426027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2426030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426052 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2426055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426057 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426073 */     // GIR_Coverage, 34724,
     /* 2426073 */     GIR_EraseRootFromParent_Done,
     /* 2426074 */   // Label 35023: @2426074
     /* 2426074 */   GIM_Try, /*On fail goto*//*Label 35024*/ GIMT_Encode4(2426126), // Rule ID 34725 //
     /* 2426079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2426082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426104 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2426107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426109 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426125 */     // GIR_Coverage, 34725,
     /* 2426125 */     GIR_EraseRootFromParent_Done,
     /* 2426126 */   // Label 35024: @2426126
     /* 2426126 */   GIM_Reject,
     /* 2426127 */ // Label 35020: @2426127
     /* 2426127 */ GIM_Reject,
     /* 2426128 */ // Label 34988: @2426128
     /* 2426128 */ GIM_Try, /*On fail goto*//*Label 35025*/ GIMT_Encode4(2426244),
     /* 2426133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2426136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2426139 */   GIM_Try, /*On fail goto*//*Label 35026*/ GIMT_Encode4(2426191), // Rule ID 32384 //
     /* 2426144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426169 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2426172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426174 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426190 */     // GIR_Coverage, 32384,
     /* 2426190 */     GIR_EraseRootFromParent_Done,
     /* 2426191 */   // Label 35026: @2426191
     /* 2426191 */   GIM_Try, /*On fail goto*//*Label 35027*/ GIMT_Encode4(2426243), // Rule ID 32385 //
     /* 2426196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426221 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2426224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426226 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426242 */     // GIR_Coverage, 32385,
     /* 2426242 */     GIR_EraseRootFromParent_Done,
     /* 2426243 */   // Label 35027: @2426243
     /* 2426243 */   GIM_Reject,
     /* 2426244 */ // Label 35025: @2426244
     /* 2426244 */ GIM_Reject,
     /* 2426245 */ // Label 34989: @2426245
     /* 2426245 */ GIM_Try, /*On fail goto*//*Label 35028*/ GIMT_Encode4(2426465),
     /* 2426250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2426253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2426256 */   GIM_Try, /*On fail goto*//*Label 35029*/ GIMT_Encode4(2426308), // Rule ID 32654 //
     /* 2426261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426286 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2426289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426291 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426307 */     // GIR_Coverage, 32654,
     /* 2426307 */     GIR_EraseRootFromParent_Done,
     /* 2426308 */   // Label 35029: @2426308
     /* 2426308 */   GIM_Try, /*On fail goto*//*Label 35030*/ GIMT_Encode4(2426360), // Rule ID 32655 //
     /* 2426313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426338 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2426341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426343 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426359 */     // GIR_Coverage, 32655,
     /* 2426359 */     GIR_EraseRootFromParent_Done,
     /* 2426360 */   // Label 35030: @2426360
     /* 2426360 */   GIM_Try, /*On fail goto*//*Label 35031*/ GIMT_Encode4(2426412), // Rule ID 34364 //
     /* 2426365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426390 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2426393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426395 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426411 */     // GIR_Coverage, 34364,
     /* 2426411 */     GIR_EraseRootFromParent_Done,
     /* 2426412 */   // Label 35031: @2426412
     /* 2426412 */   GIM_Try, /*On fail goto*//*Label 35032*/ GIMT_Encode4(2426464), // Rule ID 34365 //
     /* 2426417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426442 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2426445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426447 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426463 */     // GIR_Coverage, 34365,
     /* 2426463 */     GIR_EraseRootFromParent_Done,
     /* 2426464 */   // Label 35032: @2426464
     /* 2426464 */   GIM_Reject,
     /* 2426465 */ // Label 35028: @2426465
     /* 2426465 */ GIM_Reject,
     /* 2426466 */ // Label 34990: @2426466
     /* 2426466 */ GIM_Try, /*On fail goto*//*Label 35033*/ GIMT_Encode4(2426686),
     /* 2426471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2426474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2426477 */   GIM_Try, /*On fail goto*//*Label 35034*/ GIMT_Encode4(2426529), // Rule ID 33014 //
     /* 2426482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426507 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2426510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426512 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426528 */     // GIR_Coverage, 33014,
     /* 2426528 */     GIR_EraseRootFromParent_Done,
     /* 2426529 */   // Label 35034: @2426529
     /* 2426529 */   GIM_Try, /*On fail goto*//*Label 35035*/ GIMT_Encode4(2426581), // Rule ID 33015 //
     /* 2426534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426559 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2426562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426564 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426580 */     // GIR_Coverage, 33015,
     /* 2426580 */     GIR_EraseRootFromParent_Done,
     /* 2426581 */   // Label 35035: @2426581
     /* 2426581 */   GIM_Try, /*On fail goto*//*Label 35036*/ GIMT_Encode4(2426633), // Rule ID 34634 //
     /* 2426586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426611 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2426614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426616 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426632 */     // GIR_Coverage, 34634,
     /* 2426632 */     GIR_EraseRootFromParent_Done,
     /* 2426633 */   // Label 35036: @2426633
     /* 2426633 */   GIM_Try, /*On fail goto*//*Label 35037*/ GIMT_Encode4(2426685), // Rule ID 34635 //
     /* 2426638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426663 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2426666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426668 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426684 */     // GIR_Coverage, 34635,
     /* 2426684 */     GIR_EraseRootFromParent_Done,
     /* 2426685 */   // Label 35037: @2426685
     /* 2426685 */   GIM_Reject,
     /* 2426686 */ // Label 35033: @2426686
     /* 2426686 */ GIM_Reject,
     /* 2426687 */ // Label 34991: @2426687
     /* 2426687 */ GIM_Try, /*On fail goto*//*Label 35038*/ GIMT_Encode4(2426907),
     /* 2426692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2426695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2426698 */   GIM_Try, /*On fail goto*//*Label 35039*/ GIMT_Encode4(2426750), // Rule ID 34004 //
     /* 2426703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2426706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426728 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2426731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426733 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426749 */     // GIR_Coverage, 34004,
     /* 2426749 */     GIR_EraseRootFromParent_Done,
     /* 2426750 */   // Label 35039: @2426750
     /* 2426750 */   GIM_Try, /*On fail goto*//*Label 35040*/ GIMT_Encode4(2426802), // Rule ID 34005 //
     /* 2426755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2426758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426780 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2426783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426785 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426801 */     // GIR_Coverage, 34005,
     /* 2426801 */     GIR_EraseRootFromParent_Done,
     /* 2426802 */   // Label 35040: @2426802
     /* 2426802 */   GIM_Try, /*On fail goto*//*Label 35041*/ GIMT_Encode4(2426854), // Rule ID 35354 //
     /* 2426807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2426810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426832 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2426835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426837 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426853 */     // GIR_Coverage, 35354,
     /* 2426853 */     GIR_EraseRootFromParent_Done,
     /* 2426854 */   // Label 35041: @2426854
     /* 2426854 */   GIM_Try, /*On fail goto*//*Label 35042*/ GIMT_Encode4(2426906), // Rule ID 35355 //
     /* 2426859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2426862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426884 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2426887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426889 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426905 */     // GIR_Coverage, 35355,
     /* 2426905 */     GIR_EraseRootFromParent_Done,
     /* 2426906 */   // Label 35042: @2426906
     /* 2426906 */   GIM_Reject,
     /* 2426907 */ // Label 35038: @2426907
     /* 2426907 */ GIM_Reject,
     /* 2426908 */ // Label 34992: @2426908
     /* 2426908 */ GIM_Try, /*On fail goto*//*Label 35043*/ GIMT_Encode4(2427024),
     /* 2426913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2426916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2426919 */   GIM_Try, /*On fail goto*//*Label 35044*/ GIMT_Encode4(2426971), // Rule ID 32474 //
     /* 2426924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426949 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2426952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426954 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426970 */     // GIR_Coverage, 32474,
     /* 2426970 */     GIR_EraseRootFromParent_Done,
     /* 2426971 */   // Label 35044: @2426971
     /* 2426971 */   GIM_Try, /*On fail goto*//*Label 35045*/ GIMT_Encode4(2427023), // Rule ID 32475 //
     /* 2426976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427001 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2427004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427006 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427022 */     // GIR_Coverage, 32475,
     /* 2427022 */     GIR_EraseRootFromParent_Done,
     /* 2427023 */   // Label 35045: @2427023
     /* 2427023 */   GIM_Reject,
     /* 2427024 */ // Label 35043: @2427024
     /* 2427024 */ GIM_Reject,
     /* 2427025 */ // Label 34993: @2427025
     /* 2427025 */ GIM_Try, /*On fail goto*//*Label 35046*/ GIMT_Encode4(2427245),
     /* 2427030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2427033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2427036 */   GIM_Try, /*On fail goto*//*Label 35047*/ GIMT_Encode4(2427088), // Rule ID 32924 //
     /* 2427041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427066 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2427069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427071 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427087 */     // GIR_Coverage, 32924,
     /* 2427087 */     GIR_EraseRootFromParent_Done,
     /* 2427088 */   // Label 35047: @2427088
     /* 2427088 */   GIM_Try, /*On fail goto*//*Label 35048*/ GIMT_Encode4(2427140), // Rule ID 32925 //
     /* 2427093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427118 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2427121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427123 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427139 */     // GIR_Coverage, 32925,
     /* 2427139 */     GIR_EraseRootFromParent_Done,
     /* 2427140 */   // Label 35048: @2427140
     /* 2427140 */   GIM_Try, /*On fail goto*//*Label 35049*/ GIMT_Encode4(2427192), // Rule ID 34544 //
     /* 2427145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427170 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2427173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427175 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427191 */     // GIR_Coverage, 34544,
     /* 2427191 */     GIR_EraseRootFromParent_Done,
     /* 2427192 */   // Label 35049: @2427192
     /* 2427192 */   GIM_Try, /*On fail goto*//*Label 35050*/ GIMT_Encode4(2427244), // Rule ID 34545 //
     /* 2427197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427222 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2427225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427227 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427243 */     // GIR_Coverage, 34545,
     /* 2427243 */     GIR_EraseRootFromParent_Done,
     /* 2427244 */   // Label 35050: @2427244
     /* 2427244 */   GIM_Reject,
     /* 2427245 */ // Label 35046: @2427245
     /* 2427245 */ GIM_Reject,
     /* 2427246 */ // Label 34994: @2427246
     /* 2427246 */ GIM_Try, /*On fail goto*//*Label 35051*/ GIMT_Encode4(2427466),
     /* 2427251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2427254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2427257 */   GIM_Try, /*On fail goto*//*Label 35052*/ GIMT_Encode4(2427309), // Rule ID 33734 //
     /* 2427262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427287 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2427290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427292 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427308 */     // GIR_Coverage, 33734,
     /* 2427308 */     GIR_EraseRootFromParent_Done,
     /* 2427309 */   // Label 35052: @2427309
     /* 2427309 */   GIM_Try, /*On fail goto*//*Label 35053*/ GIMT_Encode4(2427361), // Rule ID 33735 //
     /* 2427314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427339 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2427342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427344 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427360 */     // GIR_Coverage, 33735,
     /* 2427360 */     GIR_EraseRootFromParent_Done,
     /* 2427361 */   // Label 35053: @2427361
     /* 2427361 */   GIM_Try, /*On fail goto*//*Label 35054*/ GIMT_Encode4(2427413), // Rule ID 35084 //
     /* 2427366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427391 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2427394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427396 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427412 */     // GIR_Coverage, 35084,
     /* 2427412 */     GIR_EraseRootFromParent_Done,
     /* 2427413 */   // Label 35054: @2427413
     /* 2427413 */   GIM_Try, /*On fail goto*//*Label 35055*/ GIMT_Encode4(2427465), // Rule ID 35085 //
     /* 2427418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427443 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2427446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427448 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427464 */     // GIR_Coverage, 35085,
     /* 2427464 */     GIR_EraseRootFromParent_Done,
     /* 2427465 */   // Label 35055: @2427465
     /* 2427465 */   GIM_Reject,
     /* 2427466 */ // Label 35051: @2427466
     /* 2427466 */ GIM_Reject,
     /* 2427467 */ // Label 34995: @2427467
     /* 2427467 */ GIM_Try, /*On fail goto*//*Label 35056*/ GIMT_Encode4(2427687),
     /* 2427472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2427475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2427478 */   GIM_Try, /*On fail goto*//*Label 35057*/ GIMT_Encode4(2427530), // Rule ID 34094 //
     /* 2427483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2427486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427508 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2427511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427513 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2427525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427529 */     // GIR_Coverage, 34094,
     /* 2427529 */     GIR_EraseRootFromParent_Done,
     /* 2427530 */   // Label 35057: @2427530
     /* 2427530 */   GIM_Try, /*On fail goto*//*Label 35058*/ GIMT_Encode4(2427582), // Rule ID 34095 //
     /* 2427535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2427538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427560 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2427563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427565 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2427577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427581 */     // GIR_Coverage, 34095,
     /* 2427581 */     GIR_EraseRootFromParent_Done,
     /* 2427582 */   // Label 35058: @2427582
     /* 2427582 */   GIM_Try, /*On fail goto*//*Label 35059*/ GIMT_Encode4(2427634), // Rule ID 35444 //
     /* 2427587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2427590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427612 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2427615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427617 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2427629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427633 */     // GIR_Coverage, 35444,
     /* 2427633 */     GIR_EraseRootFromParent_Done,
     /* 2427634 */   // Label 35059: @2427634
     /* 2427634 */   GIM_Try, /*On fail goto*//*Label 35060*/ GIMT_Encode4(2427686), // Rule ID 35445 //
     /* 2427639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2427642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2427657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427664 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2427667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427669 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2427681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427685 */     // GIR_Coverage, 35445,
     /* 2427685 */     GIR_EraseRootFromParent_Done,
     /* 2427686 */   // Label 35060: @2427686
     /* 2427686 */   GIM_Reject,
     /* 2427687 */ // Label 35056: @2427687
     /* 2427687 */ GIM_Reject,
     /* 2427688 */ // Label 34996: @2427688
     /* 2427688 */ GIM_Try, /*On fail goto*//*Label 35061*/ GIMT_Encode4(2427804),
     /* 2427693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2427696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2427699 */   GIM_Try, /*On fail goto*//*Label 35062*/ GIMT_Encode4(2427751), // Rule ID 32834 //
     /* 2427704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427729 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2427732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427734 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427750 */     // GIR_Coverage, 32834,
     /* 2427750 */     GIR_EraseRootFromParent_Done,
     /* 2427751 */   // Label 35062: @2427751
     /* 2427751 */   GIM_Try, /*On fail goto*//*Label 35063*/ GIMT_Encode4(2427803), // Rule ID 32835 //
     /* 2427756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427781 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2427784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427786 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427802 */     // GIR_Coverage, 32835,
     /* 2427802 */     GIR_EraseRootFromParent_Done,
     /* 2427803 */   // Label 35063: @2427803
     /* 2427803 */   GIM_Reject,
     /* 2427804 */ // Label 35061: @2427804
     /* 2427804 */ GIM_Reject,
     /* 2427805 */ // Label 34997: @2427805
     /* 2427805 */ GIM_Try, /*On fail goto*//*Label 35064*/ GIMT_Encode4(2428025),
     /* 2427810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2427813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2427816 */   GIM_Try, /*On fail goto*//*Label 35065*/ GIMT_Encode4(2427868), // Rule ID 33464 //
     /* 2427821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427846 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2427849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427851 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427867 */     // GIR_Coverage, 33464,
     /* 2427867 */     GIR_EraseRootFromParent_Done,
     /* 2427868 */   // Label 35065: @2427868
     /* 2427868 */   GIM_Try, /*On fail goto*//*Label 35066*/ GIMT_Encode4(2427920), // Rule ID 33465 //
     /* 2427873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427898 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2427901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427903 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427919 */     // GIR_Coverage, 33465,
     /* 2427919 */     GIR_EraseRootFromParent_Done,
     /* 2427920 */   // Label 35066: @2427920
     /* 2427920 */   GIM_Try, /*On fail goto*//*Label 35067*/ GIMT_Encode4(2427972), // Rule ID 34814 //
     /* 2427925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427950 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2427953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427955 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427971 */     // GIR_Coverage, 34814,
     /* 2427971 */     GIR_EraseRootFromParent_Done,
     /* 2427972 */   // Label 35067: @2427972
     /* 2427972 */   GIM_Try, /*On fail goto*//*Label 35068*/ GIMT_Encode4(2428024), // Rule ID 34815 //
     /* 2427977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428002 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2428002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2428005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428007 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428023 */     // GIR_Coverage, 34815,
     /* 2428023 */     GIR_EraseRootFromParent_Done,
     /* 2428024 */   // Label 35068: @2428024
     /* 2428024 */   GIM_Reject,
     /* 2428025 */ // Label 35064: @2428025
     /* 2428025 */ GIM_Reject,
     /* 2428026 */ // Label 34998: @2428026
     /* 2428026 */ GIM_Try, /*On fail goto*//*Label 35069*/ GIMT_Encode4(2428246),
     /* 2428031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2428034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2428037 */   GIM_Try, /*On fail goto*//*Label 35070*/ GIMT_Encode4(2428089), // Rule ID 33824 //
     /* 2428042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428067 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2428067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2428070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428072 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428088 */     // GIR_Coverage, 33824,
     /* 2428088 */     GIR_EraseRootFromParent_Done,
     /* 2428089 */   // Label 35070: @2428089
     /* 2428089 */   GIM_Try, /*On fail goto*//*Label 35071*/ GIMT_Encode4(2428141), // Rule ID 33825 //
     /* 2428094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428119 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2428119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2428122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428124 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428140 */     // GIR_Coverage, 33825,
     /* 2428140 */     GIR_EraseRootFromParent_Done,
     /* 2428141 */   // Label 35071: @2428141
     /* 2428141 */   GIM_Try, /*On fail goto*//*Label 35072*/ GIMT_Encode4(2428193), // Rule ID 35174 //
     /* 2428146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428171 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2428171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2428174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428176 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428192 */     // GIR_Coverage, 35174,
     /* 2428192 */     GIR_EraseRootFromParent_Done,
     /* 2428193 */   // Label 35072: @2428193
     /* 2428193 */   GIM_Try, /*On fail goto*//*Label 35073*/ GIMT_Encode4(2428245), // Rule ID 35175 //
     /* 2428198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428223 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2428223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2428226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428228 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428244 */     // GIR_Coverage, 35175,
     /* 2428244 */     GIR_EraseRootFromParent_Done,
     /* 2428245 */   // Label 35073: @2428245
     /* 2428245 */   GIM_Reject,
     /* 2428246 */ // Label 35069: @2428246
     /* 2428246 */ GIM_Reject,
     /* 2428247 */ // Label 34999: @2428247
     /* 2428247 */ GIM_Try, /*On fail goto*//*Label 35074*/ GIMT_Encode4(2428467),
     /* 2428252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2428255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2428258 */   GIM_Try, /*On fail goto*//*Label 35075*/ GIMT_Encode4(2428310), // Rule ID 34184 //
     /* 2428263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2428266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428288 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2428288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2428291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428293 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2428305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428309 */     // GIR_Coverage, 34184,
     /* 2428309 */     GIR_EraseRootFromParent_Done,
     /* 2428310 */   // Label 35075: @2428310
     /* 2428310 */   GIM_Try, /*On fail goto*//*Label 35076*/ GIMT_Encode4(2428362), // Rule ID 34185 //
     /* 2428315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2428318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428340 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2428340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2428343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428345 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2428357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428361 */     // GIR_Coverage, 34185,
     /* 2428361 */     GIR_EraseRootFromParent_Done,
     /* 2428362 */   // Label 35076: @2428362
     /* 2428362 */   GIM_Try, /*On fail goto*//*Label 35077*/ GIMT_Encode4(2428414), // Rule ID 35534 //
     /* 2428367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2428370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428392 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2428392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2428395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428397 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2428409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428413 */     // GIR_Coverage, 35534,
     /* 2428413 */     GIR_EraseRootFromParent_Done,
     /* 2428414 */   // Label 35077: @2428414
     /* 2428414 */   GIM_Try, /*On fail goto*//*Label 35078*/ GIMT_Encode4(2428466), // Rule ID 35535 //
     /* 2428419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2428422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428444 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2428444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2428447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428449 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2428461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428465 */     // GIR_Coverage, 35535,
     /* 2428465 */     GIR_EraseRootFromParent_Done,
     /* 2428466 */   // Label 35078: @2428466
     /* 2428466 */   GIM_Reject,
     /* 2428467 */ // Label 35074: @2428467
     /* 2428467 */ GIM_Reject,
     /* 2428468 */ // Label 35000: @2428468
     /* 2428468 */ GIM_Try, /*On fail goto*//*Label 35079*/ GIMT_Encode4(2428584),
     /* 2428473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2428476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2428479 */   GIM_Try, /*On fail goto*//*Label 35080*/ GIMT_Encode4(2428531), // Rule ID 33194 //
     /* 2428484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2428494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2428498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2428502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428509 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2428509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2428512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428514 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2428526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428530 */     // GIR_Coverage, 33194,
     /* 2428530 */     GIR_EraseRootFromParent_Done,
     /* 2428531 */   // Label 35080: @2428531
     /* 2428531 */   GIM_Try, /*On fail goto*//*Label 35081*/ GIMT_Encode4(2428583), // Rule ID 33195 //
     /* 2428536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2428546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2428550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2428554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428561 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2428561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2428564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428566 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2428578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428582 */     // GIR_Coverage, 33195,
     /* 2428582 */     GIR_EraseRootFromParent_Done,
     /* 2428583 */   // Label 35081: @2428583
     /* 2428583 */   GIM_Reject,
     /* 2428584 */ // Label 35079: @2428584
     /* 2428584 */ GIM_Reject,
     /* 2428585 */ // Label 35001: @2428585
     /* 2428585 */ GIM_Try, /*On fail goto*//*Label 35082*/ GIMT_Encode4(2428805),
     /* 2428590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2428593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2428596 */   GIM_Try, /*On fail goto*//*Label 35083*/ GIMT_Encode4(2428648), // Rule ID 33554 //
     /* 2428601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428626 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2428626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2428629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428631 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428647 */     // GIR_Coverage, 33554,
     /* 2428647 */     GIR_EraseRootFromParent_Done,
     /* 2428648 */   // Label 35083: @2428648
     /* 2428648 */   GIM_Try, /*On fail goto*//*Label 35084*/ GIMT_Encode4(2428700), // Rule ID 33555 //
     /* 2428653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428678 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2428678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2428681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428683 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428699 */     // GIR_Coverage, 33555,
     /* 2428699 */     GIR_EraseRootFromParent_Done,
     /* 2428700 */   // Label 35084: @2428700
     /* 2428700 */   GIM_Try, /*On fail goto*//*Label 35085*/ GIMT_Encode4(2428752), // Rule ID 34904 //
     /* 2428705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428730 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2428730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2428733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428735 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428751 */     // GIR_Coverage, 34904,
     /* 2428751 */     GIR_EraseRootFromParent_Done,
     /* 2428752 */   // Label 35085: @2428752
     /* 2428752 */   GIM_Try, /*On fail goto*//*Label 35086*/ GIMT_Encode4(2428804), // Rule ID 34905 //
     /* 2428757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2428775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428782 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2428782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2428785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428787 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428803 */     // GIR_Coverage, 34905,
     /* 2428803 */     GIR_EraseRootFromParent_Done,
     /* 2428804 */   // Label 35086: @2428804
     /* 2428804 */   GIM_Reject,
     /* 2428805 */ // Label 35082: @2428805
     /* 2428805 */ GIM_Reject,
     /* 2428806 */ // Label 35002: @2428806
     /* 2428806 */ GIM_Try, /*On fail goto*//*Label 35087*/ GIMT_Encode4(2429026),
     /* 2428811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2428814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2428817 */   GIM_Try, /*On fail goto*//*Label 35088*/ GIMT_Encode4(2428869), // Rule ID 33914 //
     /* 2428822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428847 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2428847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2428850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428852 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428868 */     // GIR_Coverage, 33914,
     /* 2428868 */     GIR_EraseRootFromParent_Done,
     /* 2428869 */   // Label 35088: @2428869
     /* 2428869 */   GIM_Try, /*On fail goto*//*Label 35089*/ GIMT_Encode4(2428921), // Rule ID 33915 //
     /* 2428874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428899 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2428899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2428902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428904 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428920 */     // GIR_Coverage, 33915,
     /* 2428920 */     GIR_EraseRootFromParent_Done,
     /* 2428921 */   // Label 35089: @2428921
     /* 2428921 */   GIM_Try, /*On fail goto*//*Label 35090*/ GIMT_Encode4(2428973), // Rule ID 35264 //
     /* 2428926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428951 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2428951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2428954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428956 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2428958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2428960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428972 */     // GIR_Coverage, 35264,
     /* 2428972 */     GIR_EraseRootFromParent_Done,
     /* 2428973 */   // Label 35090: @2428973
     /* 2428973 */   GIM_Try, /*On fail goto*//*Label 35091*/ GIMT_Encode4(2429025), // Rule ID 35265 //
     /* 2428978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2428996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429003 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2429006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429008 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429024 */     // GIR_Coverage, 35265,
     /* 2429024 */     GIR_EraseRootFromParent_Done,
     /* 2429025 */   // Label 35091: @2429025
     /* 2429025 */   GIM_Reject,
     /* 2429026 */ // Label 35087: @2429026
     /* 2429026 */ GIM_Reject,
     /* 2429027 */ // Label 35003: @2429027
     /* 2429027 */ GIM_Try, /*On fail goto*//*Label 35092*/ GIMT_Encode4(2429143),
     /* 2429032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2429035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2429038 */   GIM_Try, /*On fail goto*//*Label 35093*/ GIMT_Encode4(2429090), // Rule ID 33284 //
     /* 2429043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2429053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2429057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2429061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429068 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2429071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429073 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429089 */     // GIR_Coverage, 33284,
     /* 2429089 */     GIR_EraseRootFromParent_Done,
     /* 2429090 */   // Label 35093: @2429090
     /* 2429090 */   GIM_Try, /*On fail goto*//*Label 35094*/ GIMT_Encode4(2429142), // Rule ID 33285 //
     /* 2429095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2429105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2429109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2429113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429120 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2429123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429125 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429141 */     // GIR_Coverage, 33285,
     /* 2429141 */     GIR_EraseRootFromParent_Done,
     /* 2429142 */   // Label 35094: @2429142
     /* 2429142 */   GIM_Reject,
     /* 2429143 */ // Label 35092: @2429143
     /* 2429143 */ GIM_Reject,
     /* 2429144 */ // Label 35004: @2429144
     /* 2429144 */ GIM_Try, /*On fail goto*//*Label 35095*/ GIMT_Encode4(2429364),
     /* 2429149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2429152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2429155 */   GIM_Try, /*On fail goto*//*Label 35096*/ GIMT_Encode4(2429207), // Rule ID 33644 //
     /* 2429160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429185 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2429188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429190 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429206 */     // GIR_Coverage, 33644,
     /* 2429206 */     GIR_EraseRootFromParent_Done,
     /* 2429207 */   // Label 35096: @2429207
     /* 2429207 */   GIM_Try, /*On fail goto*//*Label 35097*/ GIMT_Encode4(2429259), // Rule ID 33645 //
     /* 2429212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429237 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2429240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429242 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429258 */     // GIR_Coverage, 33645,
     /* 2429258 */     GIR_EraseRootFromParent_Done,
     /* 2429259 */   // Label 35097: @2429259
     /* 2429259 */   GIM_Try, /*On fail goto*//*Label 35098*/ GIMT_Encode4(2429311), // Rule ID 34994 //
     /* 2429264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429289 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2429292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429294 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429310 */     // GIR_Coverage, 34994,
     /* 2429310 */     GIR_EraseRootFromParent_Done,
     /* 2429311 */   // Label 35098: @2429311
     /* 2429311 */   GIM_Try, /*On fail goto*//*Label 35099*/ GIMT_Encode4(2429363), // Rule ID 34995 //
     /* 2429316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429341 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2429344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429346 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429362 */     // GIR_Coverage, 34995,
     /* 2429362 */     GIR_EraseRootFromParent_Done,
     /* 2429363 */   // Label 35099: @2429363
     /* 2429363 */   GIM_Reject,
     /* 2429364 */ // Label 35095: @2429364
     /* 2429364 */ GIM_Reject,
     /* 2429365 */ // Label 35005: @2429365
     /* 2429365 */ GIM_Try, /*On fail goto*//*Label 35100*/ GIMT_Encode4(2429481),
     /* 2429370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2429373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2429376 */   GIM_Try, /*On fail goto*//*Label 35101*/ GIMT_Encode4(2429428), // Rule ID 33374 //
     /* 2429381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429406 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2429409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429411 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429427 */     // GIR_Coverage, 33374,
     /* 2429427 */     GIR_EraseRootFromParent_Done,
     /* 2429428 */   // Label 35101: @2429428
     /* 2429428 */   GIM_Try, /*On fail goto*//*Label 35102*/ GIMT_Encode4(2429480), // Rule ID 33375 //
     /* 2429433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2429451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429458 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2429461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429463 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429479 */     // GIR_Coverage, 33375,
     /* 2429479 */     GIR_EraseRootFromParent_Done,
     /* 2429480 */   // Label 35102: @2429480
     /* 2429480 */   GIM_Reject,
     /* 2429481 */ // Label 35100: @2429481
     /* 2429481 */ GIM_Reject,
     /* 2429482 */ // Label 35006: @2429482
     /* 2429482 */ GIM_Reject,
     /* 2429483 */ // Label 123: @2429483
     /* 2429483 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35125*/ GIMT_Encode4(2441362),
     /* 2429494 */ /*GILLT_nxv1s8*//*Label 35103*/ GIMT_Encode4(2429606),
     /* 2429498 */ /*GILLT_nxv1s16*//*Label 35104*/ GIMT_Encode4(2429929),
     /* 2429502 */ /*GILLT_nxv1s32*//*Label 35105*/ GIMT_Encode4(2430562),
     /* 2429506 */ /*GILLT_nxv1s64*//*Label 35106*/ GIMT_Encode4(2431195), GIMT_Encode4(0),
     /* 2429514 */ /*GILLT_nxv2s8*//*Label 35107*/ GIMT_Encode4(2431828),
     /* 2429518 */ /*GILLT_nxv2s16*//*Label 35108*/ GIMT_Encode4(2432151),
     /* 2429522 */ /*GILLT_nxv2s32*//*Label 35109*/ GIMT_Encode4(2432784),
     /* 2429526 */ /*GILLT_nxv2s64*//*Label 35110*/ GIMT_Encode4(2433417), GIMT_Encode4(0),
     /* 2429534 */ /*GILLT_nxv4s8*//*Label 35111*/ GIMT_Encode4(2434050),
     /* 2429538 */ /*GILLT_nxv4s16*//*Label 35112*/ GIMT_Encode4(2434373),
     /* 2429542 */ /*GILLT_nxv4s32*//*Label 35113*/ GIMT_Encode4(2435006),
     /* 2429546 */ /*GILLT_nxv4s64*//*Label 35114*/ GIMT_Encode4(2435639), GIMT_Encode4(0),
     /* 2429554 */ /*GILLT_nxv8s8*//*Label 35115*/ GIMT_Encode4(2436272),
     /* 2429558 */ /*GILLT_nxv8s16*//*Label 35116*/ GIMT_Encode4(2436595),
     /* 2429562 */ /*GILLT_nxv8s32*//*Label 35117*/ GIMT_Encode4(2437228),
     /* 2429566 */ /*GILLT_nxv8s64*//*Label 35118*/ GIMT_Encode4(2437861), GIMT_Encode4(0),
     /* 2429574 */ /*GILLT_nxv16s8*//*Label 35119*/ GIMT_Encode4(2438494),
     /* 2429578 */ /*GILLT_nxv16s16*//*Label 35120*/ GIMT_Encode4(2438817),
     /* 2429582 */ /*GILLT_nxv16s32*//*Label 35121*/ GIMT_Encode4(2439450), GIMT_Encode4(0),
     /* 2429590 */ /*GILLT_nxv32s8*//*Label 35122*/ GIMT_Encode4(2440083),
     /* 2429594 */ /*GILLT_nxv32s16*//*Label 35123*/ GIMT_Encode4(2440406), GIMT_Encode4(0),
     /* 2429602 */ /*GILLT_nxv64s8*//*Label 35124*/ GIMT_Encode4(2441039),
     /* 2429606 */ // Label 35103: @2429606
     /* 2429606 */ GIM_Try, /*On fail goto*//*Label 35126*/ GIMT_Encode4(2429928),
     /* 2429611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2429614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2429617 */   GIM_Try, /*On fail goto*//*Label 35127*/ GIMT_Encode4(2429700), // Rule ID 45438 //
     /* 2429622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429658 */     // MIs[1] Operand 1
     /* 2429658 */     // No operand predicates
     /* 2429658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429662 */     // MIs[0] policy
     /* 2429662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429674 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2429677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429686 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429699 */     // GIR_Coverage, 45438,
     /* 2429699 */     GIR_EraseRootFromParent_Done,
     /* 2429700 */   // Label 35127: @2429700
     /* 2429700 */   GIM_Try, /*On fail goto*//*Label 35128*/ GIMT_Encode4(2429783), // Rule ID 45439 //
     /* 2429705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429741 */     // MIs[1] Operand 1
     /* 2429741 */     // No operand predicates
     /* 2429741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429745 */     // MIs[0] policy
     /* 2429745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429757 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2429760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429782 */     // GIR_Coverage, 45439,
     /* 2429782 */     GIR_EraseRootFromParent_Done,
     /* 2429783 */   // Label 35128: @2429783
     /* 2429783 */   GIM_Try, /*On fail goto*//*Label 35129*/ GIMT_Encode4(2429855), // Rule ID 45440 //
     /* 2429788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429820 */     // MIs[0] policy
     /* 2429820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429830 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2429833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429854 */     // GIR_Coverage, 45440,
     /* 2429854 */     GIR_EraseRootFromParent_Done,
     /* 2429855 */   // Label 35129: @2429855
     /* 2429855 */   GIM_Try, /*On fail goto*//*Label 35130*/ GIMT_Encode4(2429927), // Rule ID 45441 //
     /* 2429860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429892 */     // MIs[0] policy
     /* 2429892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429902 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2429905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429926 */     // GIR_Coverage, 45441,
     /* 2429926 */     GIR_EraseRootFromParent_Done,
     /* 2429927 */   // Label 35130: @2429927
     /* 2429927 */   GIM_Reject,
     /* 2429928 */ // Label 35126: @2429928
     /* 2429928 */ GIM_Reject,
     /* 2429929 */ // Label 35104: @2429929
     /* 2429929 */ GIM_Try, /*On fail goto*//*Label 35131*/ GIMT_Encode4(2430561),
     /* 2429934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2429937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2429940 */   GIM_Try, /*On fail goto*//*Label 35132*/ GIMT_Encode4(2430023), // Rule ID 45450 //
     /* 2429945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429981 */     // MIs[1] Operand 1
     /* 2429981 */     // No operand predicates
     /* 2429981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429985 */     // MIs[0] policy
     /* 2429985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429997 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2430000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430022 */     // GIR_Coverage, 45450,
     /* 2430022 */     GIR_EraseRootFromParent_Done,
     /* 2430023 */   // Label 35132: @2430023
     /* 2430023 */   GIM_Try, /*On fail goto*//*Label 35133*/ GIMT_Encode4(2430106), // Rule ID 45451 //
     /* 2430028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430064 */     // MIs[1] Operand 1
     /* 2430064 */     // No operand predicates
     /* 2430064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430068 */     // MIs[0] policy
     /* 2430068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430080 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2430083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430105 */     // GIR_Coverage, 45451,
     /* 2430105 */     GIR_EraseRootFromParent_Done,
     /* 2430106 */   // Label 35133: @2430106
     /* 2430106 */   GIM_Try, /*On fail goto*//*Label 35134*/ GIMT_Encode4(2430189), // Rule ID 45526 //
     /* 2430111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430147 */     // MIs[1] Operand 1
     /* 2430147 */     // No operand predicates
     /* 2430147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430151 */     // MIs[0] policy
     /* 2430151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430163 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2430166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430188 */     // GIR_Coverage, 45526,
     /* 2430188 */     GIR_EraseRootFromParent_Done,
     /* 2430189 */   // Label 35134: @2430189
     /* 2430189 */   GIM_Try, /*On fail goto*//*Label 35135*/ GIMT_Encode4(2430272), // Rule ID 45527 //
     /* 2430194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430230 */     // MIs[1] Operand 1
     /* 2430230 */     // No operand predicates
     /* 2430230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430234 */     // MIs[0] policy
     /* 2430234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430246 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2430249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430258 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430271 */     // GIR_Coverage, 45527,
     /* 2430271 */     GIR_EraseRootFromParent_Done,
     /* 2430272 */   // Label 35135: @2430272
     /* 2430272 */   GIM_Try, /*On fail goto*//*Label 35136*/ GIMT_Encode4(2430344), // Rule ID 45452 //
     /* 2430277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430309 */     // MIs[0] policy
     /* 2430309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430319 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2430322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430330 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430343 */     // GIR_Coverage, 45452,
     /* 2430343 */     GIR_EraseRootFromParent_Done,
     /* 2430344 */   // Label 35136: @2430344
     /* 2430344 */   GIM_Try, /*On fail goto*//*Label 35137*/ GIMT_Encode4(2430416), // Rule ID 45453 //
     /* 2430349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430381 */     // MIs[0] policy
     /* 2430381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430391 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2430394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430402 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430415 */     // GIR_Coverage, 45453,
     /* 2430415 */     GIR_EraseRootFromParent_Done,
     /* 2430416 */   // Label 35137: @2430416
     /* 2430416 */   GIM_Try, /*On fail goto*//*Label 35138*/ GIMT_Encode4(2430488), // Rule ID 45528 //
     /* 2430421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430453 */     // MIs[0] policy
     /* 2430453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430463 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2430466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430474 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430487 */     // GIR_Coverage, 45528,
     /* 2430487 */     GIR_EraseRootFromParent_Done,
     /* 2430488 */   // Label 35138: @2430488
     /* 2430488 */   GIM_Try, /*On fail goto*//*Label 35139*/ GIMT_Encode4(2430560), // Rule ID 45529 //
     /* 2430493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430525 */     // MIs[0] policy
     /* 2430525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430535 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2430538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430546 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430559 */     // GIR_Coverage, 45529,
     /* 2430559 */     GIR_EraseRootFromParent_Done,
     /* 2430560 */   // Label 35139: @2430560
     /* 2430560 */   GIM_Reject,
     /* 2430561 */ // Label 35131: @2430561
     /* 2430561 */ GIM_Reject,
     /* 2430562 */ // Label 35105: @2430562
     /* 2430562 */ GIM_Try, /*On fail goto*//*Label 35140*/ GIMT_Encode4(2431194),
     /* 2430567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2430570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2430573 */   GIM_Try, /*On fail goto*//*Label 35141*/ GIMT_Encode4(2430656), // Rule ID 45458 //
     /* 2430578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430614 */     // MIs[1] Operand 1
     /* 2430614 */     // No operand predicates
     /* 2430614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430618 */     // MIs[0] policy
     /* 2430618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430630 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2430633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430642 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430655 */     // GIR_Coverage, 45458,
     /* 2430655 */     GIR_EraseRootFromParent_Done,
     /* 2430656 */   // Label 35141: @2430656
     /* 2430656 */   GIM_Try, /*On fail goto*//*Label 35142*/ GIMT_Encode4(2430739), // Rule ID 45459 //
     /* 2430661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430697 */     // MIs[1] Operand 1
     /* 2430697 */     // No operand predicates
     /* 2430697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430701 */     // MIs[0] policy
     /* 2430701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430713 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2430716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430725 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430738 */     // GIR_Coverage, 45459,
     /* 2430738 */     GIR_EraseRootFromParent_Done,
     /* 2430739 */   // Label 35142: @2430739
     /* 2430739 */   GIM_Try, /*On fail goto*//*Label 35143*/ GIMT_Encode4(2430822), // Rule ID 45534 //
     /* 2430744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430780 */     // MIs[1] Operand 1
     /* 2430780 */     // No operand predicates
     /* 2430780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430784 */     // MIs[0] policy
     /* 2430784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430796 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2430799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430808 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430821 */     // GIR_Coverage, 45534,
     /* 2430821 */     GIR_EraseRootFromParent_Done,
     /* 2430822 */   // Label 35143: @2430822
     /* 2430822 */   GIM_Try, /*On fail goto*//*Label 35144*/ GIMT_Encode4(2430905), // Rule ID 45535 //
     /* 2430827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430863 */     // MIs[1] Operand 1
     /* 2430863 */     // No operand predicates
     /* 2430863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430867 */     // MIs[0] policy
     /* 2430867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430879 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2430882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430904 */     // GIR_Coverage, 45535,
     /* 2430904 */     GIR_EraseRootFromParent_Done,
     /* 2430905 */   // Label 35144: @2430905
     /* 2430905 */   GIM_Try, /*On fail goto*//*Label 35145*/ GIMT_Encode4(2430977), // Rule ID 45460 //
     /* 2430910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430942 */     // MIs[0] policy
     /* 2430942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430952 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2430955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430963 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430976 */     // GIR_Coverage, 45460,
     /* 2430976 */     GIR_EraseRootFromParent_Done,
     /* 2430977 */   // Label 35145: @2430977
     /* 2430977 */   GIM_Try, /*On fail goto*//*Label 35146*/ GIMT_Encode4(2431049), // Rule ID 45461 //
     /* 2430982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431014 */     // MIs[0] policy
     /* 2431014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431024 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2431027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431035 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431048 */     // GIR_Coverage, 45461,
     /* 2431048 */     GIR_EraseRootFromParent_Done,
     /* 2431049 */   // Label 35146: @2431049
     /* 2431049 */   GIM_Try, /*On fail goto*//*Label 35147*/ GIMT_Encode4(2431121), // Rule ID 45536 //
     /* 2431054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2431063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431086 */     // MIs[0] policy
     /* 2431086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431096 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2431099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431120 */     // GIR_Coverage, 45536,
     /* 2431120 */     GIR_EraseRootFromParent_Done,
     /* 2431121 */   // Label 35147: @2431121
     /* 2431121 */   GIM_Try, /*On fail goto*//*Label 35148*/ GIMT_Encode4(2431193), // Rule ID 45537 //
     /* 2431126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2431135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431158 */     // MIs[0] policy
     /* 2431158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431168 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2431171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431179 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431192 */     // GIR_Coverage, 45537,
     /* 2431192 */     GIR_EraseRootFromParent_Done,
     /* 2431193 */   // Label 35148: @2431193
     /* 2431193 */   GIM_Reject,
     /* 2431194 */ // Label 35140: @2431194
     /* 2431194 */ GIM_Reject,
     /* 2431195 */ // Label 35106: @2431195
     /* 2431195 */ GIM_Try, /*On fail goto*//*Label 35149*/ GIMT_Encode4(2431827),
     /* 2431200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2431203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2431206 */   GIM_Try, /*On fail goto*//*Label 35150*/ GIMT_Encode4(2431289), // Rule ID 45474 //
     /* 2431211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2431220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431247 */     // MIs[1] Operand 1
     /* 2431247 */     // No operand predicates
     /* 2431247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431251 */     // MIs[0] policy
     /* 2431251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431263 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2431266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431288 */     // GIR_Coverage, 45474,
     /* 2431288 */     GIR_EraseRootFromParent_Done,
     /* 2431289 */   // Label 35150: @2431289
     /* 2431289 */   GIM_Try, /*On fail goto*//*Label 35151*/ GIMT_Encode4(2431372), // Rule ID 45475 //
     /* 2431294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2431303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431330 */     // MIs[1] Operand 1
     /* 2431330 */     // No operand predicates
     /* 2431330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431334 */     // MIs[0] policy
     /* 2431334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431346 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2431349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431358 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431371 */     // GIR_Coverage, 45475,
     /* 2431371 */     GIR_EraseRootFromParent_Done,
     /* 2431372 */   // Label 35151: @2431372
     /* 2431372 */   GIM_Try, /*On fail goto*//*Label 35152*/ GIMT_Encode4(2431455), // Rule ID 45546 //
     /* 2431377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2431386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431413 */     // MIs[1] Operand 1
     /* 2431413 */     // No operand predicates
     /* 2431413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431417 */     // MIs[0] policy
     /* 2431417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431429 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2431432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431454 */     // GIR_Coverage, 45546,
     /* 2431454 */     GIR_EraseRootFromParent_Done,
     /* 2431455 */   // Label 35152: @2431455
     /* 2431455 */   GIM_Try, /*On fail goto*//*Label 35153*/ GIMT_Encode4(2431538), // Rule ID 45547 //
     /* 2431460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2431469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431496 */     // MIs[1] Operand 1
     /* 2431496 */     // No operand predicates
     /* 2431496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431500 */     // MIs[0] policy
     /* 2431500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431512 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2431515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431537 */     // GIR_Coverage, 45547,
     /* 2431537 */     GIR_EraseRootFromParent_Done,
     /* 2431538 */   // Label 35153: @2431538
     /* 2431538 */   GIM_Try, /*On fail goto*//*Label 35154*/ GIMT_Encode4(2431610), // Rule ID 45476 //
     /* 2431543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2431552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431575 */     // MIs[0] policy
     /* 2431575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431585 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2431588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431609 */     // GIR_Coverage, 45476,
     /* 2431609 */     GIR_EraseRootFromParent_Done,
     /* 2431610 */   // Label 35154: @2431610
     /* 2431610 */   GIM_Try, /*On fail goto*//*Label 35155*/ GIMT_Encode4(2431682), // Rule ID 45477 //
     /* 2431615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2431624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431647 */     // MIs[0] policy
     /* 2431647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431657 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2431660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431668 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431681 */     // GIR_Coverage, 45477,
     /* 2431681 */     GIR_EraseRootFromParent_Done,
     /* 2431682 */   // Label 35155: @2431682
     /* 2431682 */   GIM_Try, /*On fail goto*//*Label 35156*/ GIMT_Encode4(2431754), // Rule ID 45548 //
     /* 2431687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2431696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431719 */     // MIs[0] policy
     /* 2431719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431729 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2431732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431740 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431753 */     // GIR_Coverage, 45548,
     /* 2431753 */     GIR_EraseRootFromParent_Done,
     /* 2431754 */   // Label 35156: @2431754
     /* 2431754 */   GIM_Try, /*On fail goto*//*Label 35157*/ GIMT_Encode4(2431826), // Rule ID 45549 //
     /* 2431759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2431768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431791 */     // MIs[0] policy
     /* 2431791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431801 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2431804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431812 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431825 */     // GIR_Coverage, 45549,
     /* 2431825 */     GIR_EraseRootFromParent_Done,
     /* 2431826 */   // Label 35157: @2431826
     /* 2431826 */   GIM_Reject,
     /* 2431827 */ // Label 35149: @2431827
     /* 2431827 */ GIM_Reject,
     /* 2431828 */ // Label 35107: @2431828
     /* 2431828 */ GIM_Try, /*On fail goto*//*Label 35158*/ GIMT_Encode4(2432150),
     /* 2431833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2431836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2431839 */   GIM_Try, /*On fail goto*//*Label 35159*/ GIMT_Encode4(2431922), // Rule ID 45442 //
     /* 2431844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431880 */     // MIs[1] Operand 1
     /* 2431880 */     // No operand predicates
     /* 2431880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431884 */     // MIs[0] policy
     /* 2431884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431896 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2431899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2431918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431921 */     // GIR_Coverage, 45442,
     /* 2431921 */     GIR_EraseRootFromParent_Done,
     /* 2431922 */   // Label 35159: @2431922
     /* 2431922 */   GIM_Try, /*On fail goto*//*Label 35160*/ GIMT_Encode4(2432005), // Rule ID 45443 //
     /* 2431927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431963 */     // MIs[1] Operand 1
     /* 2431963 */     // No operand predicates
     /* 2431963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431967 */     // MIs[0] policy
     /* 2431967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431979 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2431982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432004 */     // GIR_Coverage, 45443,
     /* 2432004 */     GIR_EraseRootFromParent_Done,
     /* 2432005 */   // Label 35160: @2432005
     /* 2432005 */   GIM_Try, /*On fail goto*//*Label 35161*/ GIMT_Encode4(2432077), // Rule ID 45444 //
     /* 2432010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432042 */     // MIs[0] policy
     /* 2432042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432052 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2432055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432073 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432076 */     // GIR_Coverage, 45444,
     /* 2432076 */     GIR_EraseRootFromParent_Done,
     /* 2432077 */   // Label 35161: @2432077
     /* 2432077 */   GIM_Try, /*On fail goto*//*Label 35162*/ GIMT_Encode4(2432149), // Rule ID 45445 //
     /* 2432082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432114 */     // MIs[0] policy
     /* 2432114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432124 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2432127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432145 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432148 */     // GIR_Coverage, 45445,
     /* 2432148 */     GIR_EraseRootFromParent_Done,
     /* 2432149 */   // Label 35162: @2432149
     /* 2432149 */   GIM_Reject,
     /* 2432150 */ // Label 35158: @2432150
     /* 2432150 */ GIM_Reject,
     /* 2432151 */ // Label 35108: @2432151
     /* 2432151 */ GIM_Try, /*On fail goto*//*Label 35163*/ GIMT_Encode4(2432783),
     /* 2432156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2432159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2432162 */   GIM_Try, /*On fail goto*//*Label 35164*/ GIMT_Encode4(2432245), // Rule ID 45454 //
     /* 2432167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432203 */     // MIs[1] Operand 1
     /* 2432203 */     // No operand predicates
     /* 2432203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432207 */     // MIs[0] policy
     /* 2432207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432219 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2432222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432244 */     // GIR_Coverage, 45454,
     /* 2432244 */     GIR_EraseRootFromParent_Done,
     /* 2432245 */   // Label 35164: @2432245
     /* 2432245 */   GIM_Try, /*On fail goto*//*Label 35165*/ GIMT_Encode4(2432328), // Rule ID 45455 //
     /* 2432250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432286 */     // MIs[1] Operand 1
     /* 2432286 */     // No operand predicates
     /* 2432286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432290 */     // MIs[0] policy
     /* 2432290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432302 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2432305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432314 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432327 */     // GIR_Coverage, 45455,
     /* 2432327 */     GIR_EraseRootFromParent_Done,
     /* 2432328 */   // Label 35165: @2432328
     /* 2432328 */   GIM_Try, /*On fail goto*//*Label 35166*/ GIMT_Encode4(2432411), // Rule ID 45530 //
     /* 2432333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432369 */     // MIs[1] Operand 1
     /* 2432369 */     // No operand predicates
     /* 2432369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432373 */     // MIs[0] policy
     /* 2432373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432385 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2432388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432410 */     // GIR_Coverage, 45530,
     /* 2432410 */     GIR_EraseRootFromParent_Done,
     /* 2432411 */   // Label 35166: @2432411
     /* 2432411 */   GIM_Try, /*On fail goto*//*Label 35167*/ GIMT_Encode4(2432494), // Rule ID 45531 //
     /* 2432416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432452 */     // MIs[1] Operand 1
     /* 2432452 */     // No operand predicates
     /* 2432452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432456 */     // MIs[0] policy
     /* 2432456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432468 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2432471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432480 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432493 */     // GIR_Coverage, 45531,
     /* 2432493 */     GIR_EraseRootFromParent_Done,
     /* 2432494 */   // Label 35167: @2432494
     /* 2432494 */   GIM_Try, /*On fail goto*//*Label 35168*/ GIMT_Encode4(2432566), // Rule ID 45456 //
     /* 2432499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432531 */     // MIs[0] policy
     /* 2432531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432541 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2432544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432552 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432565 */     // GIR_Coverage, 45456,
     /* 2432565 */     GIR_EraseRootFromParent_Done,
     /* 2432566 */   // Label 35168: @2432566
     /* 2432566 */   GIM_Try, /*On fail goto*//*Label 35169*/ GIMT_Encode4(2432638), // Rule ID 45457 //
     /* 2432571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432603 */     // MIs[0] policy
     /* 2432603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432613 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2432616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432624 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432637 */     // GIR_Coverage, 45457,
     /* 2432637 */     GIR_EraseRootFromParent_Done,
     /* 2432638 */   // Label 35169: @2432638
     /* 2432638 */   GIM_Try, /*On fail goto*//*Label 35170*/ GIMT_Encode4(2432710), // Rule ID 45532 //
     /* 2432643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432675 */     // MIs[0] policy
     /* 2432675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432685 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2432688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432696 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432709 */     // GIR_Coverage, 45532,
     /* 2432709 */     GIR_EraseRootFromParent_Done,
     /* 2432710 */   // Label 35170: @2432710
     /* 2432710 */   GIM_Try, /*On fail goto*//*Label 35171*/ GIMT_Encode4(2432782), // Rule ID 45533 //
     /* 2432715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432747 */     // MIs[0] policy
     /* 2432747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432757 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2432760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432768 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432781 */     // GIR_Coverage, 45533,
     /* 2432781 */     GIR_EraseRootFromParent_Done,
     /* 2432782 */   // Label 35171: @2432782
     /* 2432782 */   GIM_Reject,
     /* 2432783 */ // Label 35163: @2432783
     /* 2432783 */ GIM_Reject,
     /* 2432784 */ // Label 35109: @2432784
     /* 2432784 */ GIM_Try, /*On fail goto*//*Label 35172*/ GIMT_Encode4(2433416),
     /* 2432789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2432792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2432795 */   GIM_Try, /*On fail goto*//*Label 35173*/ GIMT_Encode4(2432878), // Rule ID 45470 //
     /* 2432800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432836 */     // MIs[1] Operand 1
     /* 2432836 */     // No operand predicates
     /* 2432836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432840 */     // MIs[0] policy
     /* 2432840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432852 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2432855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432864 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432877 */     // GIR_Coverage, 45470,
     /* 2432877 */     GIR_EraseRootFromParent_Done,
     /* 2432878 */   // Label 35173: @2432878
     /* 2432878 */   GIM_Try, /*On fail goto*//*Label 35174*/ GIMT_Encode4(2432961), // Rule ID 45471 //
     /* 2432883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432919 */     // MIs[1] Operand 1
     /* 2432919 */     // No operand predicates
     /* 2432919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432923 */     // MIs[0] policy
     /* 2432923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432935 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2432938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432960 */     // GIR_Coverage, 45471,
     /* 2432960 */     GIR_EraseRootFromParent_Done,
     /* 2432961 */   // Label 35174: @2432961
     /* 2432961 */   GIM_Try, /*On fail goto*//*Label 35175*/ GIMT_Encode4(2433044), // Rule ID 45542 //
     /* 2432966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433002 */     // MIs[1] Operand 1
     /* 2433002 */     // No operand predicates
     /* 2433002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433006 */     // MIs[0] policy
     /* 2433006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433018 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2433021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433030 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433043 */     // GIR_Coverage, 45542,
     /* 2433043 */     GIR_EraseRootFromParent_Done,
     /* 2433044 */   // Label 35175: @2433044
     /* 2433044 */   GIM_Try, /*On fail goto*//*Label 35176*/ GIMT_Encode4(2433127), // Rule ID 45543 //
     /* 2433049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2433058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433085 */     // MIs[1] Operand 1
     /* 2433085 */     // No operand predicates
     /* 2433085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433089 */     // MIs[0] policy
     /* 2433089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433101 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2433104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433126 */     // GIR_Coverage, 45543,
     /* 2433126 */     GIR_EraseRootFromParent_Done,
     /* 2433127 */   // Label 35176: @2433127
     /* 2433127 */   GIM_Try, /*On fail goto*//*Label 35177*/ GIMT_Encode4(2433199), // Rule ID 45472 //
     /* 2433132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2433141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433164 */     // MIs[0] policy
     /* 2433164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433174 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2433177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433198 */     // GIR_Coverage, 45472,
     /* 2433198 */     GIR_EraseRootFromParent_Done,
     /* 2433199 */   // Label 35177: @2433199
     /* 2433199 */   GIM_Try, /*On fail goto*//*Label 35178*/ GIMT_Encode4(2433271), // Rule ID 45473 //
     /* 2433204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2433213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433236 */     // MIs[0] policy
     /* 2433236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433246 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2433249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433270 */     // GIR_Coverage, 45473,
     /* 2433270 */     GIR_EraseRootFromParent_Done,
     /* 2433271 */   // Label 35178: @2433271
     /* 2433271 */   GIM_Try, /*On fail goto*//*Label 35179*/ GIMT_Encode4(2433343), // Rule ID 45544 //
     /* 2433276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2433285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433308 */     // MIs[0] policy
     /* 2433308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433318 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2433321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433342 */     // GIR_Coverage, 45544,
     /* 2433342 */     GIR_EraseRootFromParent_Done,
     /* 2433343 */   // Label 35179: @2433343
     /* 2433343 */   GIM_Try, /*On fail goto*//*Label 35180*/ GIMT_Encode4(2433415), // Rule ID 45545 //
     /* 2433348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2433357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433380 */     // MIs[0] policy
     /* 2433380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433390 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2433393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433414 */     // GIR_Coverage, 45545,
     /* 2433414 */     GIR_EraseRootFromParent_Done,
     /* 2433415 */   // Label 35180: @2433415
     /* 2433415 */   GIM_Reject,
     /* 2433416 */ // Label 35172: @2433416
     /* 2433416 */ GIM_Reject,
     /* 2433417 */ // Label 35110: @2433417
     /* 2433417 */ GIM_Try, /*On fail goto*//*Label 35181*/ GIMT_Encode4(2434049),
     /* 2433422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2433425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2433428 */   GIM_Try, /*On fail goto*//*Label 35182*/ GIMT_Encode4(2433511), // Rule ID 45514 //
     /* 2433433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2433436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2433442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433469 */     // MIs[1] Operand 1
     /* 2433469 */     // No operand predicates
     /* 2433469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433473 */     // MIs[0] policy
     /* 2433473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433485 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2433488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433510 */     // GIR_Coverage, 45514,
     /* 2433510 */     GIR_EraseRootFromParent_Done,
     /* 2433511 */   // Label 35182: @2433511
     /* 2433511 */   GIM_Try, /*On fail goto*//*Label 35183*/ GIMT_Encode4(2433594), // Rule ID 45515 //
     /* 2433516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2433519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2433525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433552 */     // MIs[1] Operand 1
     /* 2433552 */     // No operand predicates
     /* 2433552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433556 */     // MIs[0] policy
     /* 2433556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433568 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2433571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433580 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433593 */     // GIR_Coverage, 45515,
     /* 2433593 */     GIR_EraseRootFromParent_Done,
     /* 2433594 */   // Label 35183: @2433594
     /* 2433594 */   GIM_Try, /*On fail goto*//*Label 35184*/ GIMT_Encode4(2433677), // Rule ID 45574 //
     /* 2433599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2433602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2433608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433635 */     // MIs[1] Operand 1
     /* 2433635 */     // No operand predicates
     /* 2433635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433639 */     // MIs[0] policy
     /* 2433639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433651 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2433654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433676 */     // GIR_Coverage, 45574,
     /* 2433676 */     GIR_EraseRootFromParent_Done,
     /* 2433677 */   // Label 35184: @2433677
     /* 2433677 */   GIM_Try, /*On fail goto*//*Label 35185*/ GIMT_Encode4(2433760), // Rule ID 45575 //
     /* 2433682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2433685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2433691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433718 */     // MIs[1] Operand 1
     /* 2433718 */     // No operand predicates
     /* 2433718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433722 */     // MIs[0] policy
     /* 2433722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433734 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2433737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433746 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433759 */     // GIR_Coverage, 45575,
     /* 2433759 */     GIR_EraseRootFromParent_Done,
     /* 2433760 */   // Label 35185: @2433760
     /* 2433760 */   GIM_Try, /*On fail goto*//*Label 35186*/ GIMT_Encode4(2433832), // Rule ID 45516 //
     /* 2433765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2433768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2433774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433797 */     // MIs[0] policy
     /* 2433797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433807 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2433810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433818 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433831 */     // GIR_Coverage, 45516,
     /* 2433831 */     GIR_EraseRootFromParent_Done,
     /* 2433832 */   // Label 35186: @2433832
     /* 2433832 */   GIM_Try, /*On fail goto*//*Label 35187*/ GIMT_Encode4(2433904), // Rule ID 45517 //
     /* 2433837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2433840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2433846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433869 */     // MIs[0] policy
     /* 2433869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433879 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2433882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433890 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433903 */     // GIR_Coverage, 45517,
     /* 2433903 */     GIR_EraseRootFromParent_Done,
     /* 2433904 */   // Label 35187: @2433904
     /* 2433904 */   GIM_Try, /*On fail goto*//*Label 35188*/ GIMT_Encode4(2433976), // Rule ID 45576 //
     /* 2433909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2433912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2433918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433941 */     // MIs[0] policy
     /* 2433941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433951 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2433954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433962 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433975 */     // GIR_Coverage, 45576,
     /* 2433975 */     GIR_EraseRootFromParent_Done,
     /* 2433976 */   // Label 35188: @2433976
     /* 2433976 */   GIM_Try, /*On fail goto*//*Label 35189*/ GIMT_Encode4(2434048), // Rule ID 45577 //
     /* 2433981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2433984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2433990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434013 */     // MIs[0] policy
     /* 2434013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434023 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2434026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434034 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434047 */     // GIR_Coverage, 45577,
     /* 2434047 */     GIR_EraseRootFromParent_Done,
     /* 2434048 */   // Label 35189: @2434048
     /* 2434048 */   GIM_Reject,
     /* 2434049 */ // Label 35181: @2434049
     /* 2434049 */ GIM_Reject,
     /* 2434050 */ // Label 35111: @2434050
     /* 2434050 */ GIM_Try, /*On fail goto*//*Label 35190*/ GIMT_Encode4(2434372),
     /* 2434055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2434058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2434061 */   GIM_Try, /*On fail goto*//*Label 35191*/ GIMT_Encode4(2434144), // Rule ID 45446 //
     /* 2434066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434102 */     // MIs[1] Operand 1
     /* 2434102 */     // No operand predicates
     /* 2434102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434106 */     // MIs[0] policy
     /* 2434106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434118 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2434121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434130 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434143 */     // GIR_Coverage, 45446,
     /* 2434143 */     GIR_EraseRootFromParent_Done,
     /* 2434144 */   // Label 35191: @2434144
     /* 2434144 */   GIM_Try, /*On fail goto*//*Label 35192*/ GIMT_Encode4(2434227), // Rule ID 45447 //
     /* 2434149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434185 */     // MIs[1] Operand 1
     /* 2434185 */     // No operand predicates
     /* 2434185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434189 */     // MIs[0] policy
     /* 2434189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434201 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2434204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434223 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434226 */     // GIR_Coverage, 45447,
     /* 2434226 */     GIR_EraseRootFromParent_Done,
     /* 2434227 */   // Label 35192: @2434227
     /* 2434227 */   GIM_Try, /*On fail goto*//*Label 35193*/ GIMT_Encode4(2434299), // Rule ID 45448 //
     /* 2434232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434264 */     // MIs[0] policy
     /* 2434264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434274 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2434277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434295 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434298 */     // GIR_Coverage, 45448,
     /* 2434298 */     GIR_EraseRootFromParent_Done,
     /* 2434299 */   // Label 35193: @2434299
     /* 2434299 */   GIM_Try, /*On fail goto*//*Label 35194*/ GIMT_Encode4(2434371), // Rule ID 45449 //
     /* 2434304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434336 */     // MIs[0] policy
     /* 2434336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434346 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2434349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434370 */     // GIR_Coverage, 45449,
     /* 2434370 */     GIR_EraseRootFromParent_Done,
     /* 2434371 */   // Label 35194: @2434371
     /* 2434371 */   GIM_Reject,
     /* 2434372 */ // Label 35190: @2434372
     /* 2434372 */ GIM_Reject,
     /* 2434373 */ // Label 35112: @2434373
     /* 2434373 */ GIM_Try, /*On fail goto*//*Label 35195*/ GIMT_Encode4(2435005),
     /* 2434378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2434381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2434384 */   GIM_Try, /*On fail goto*//*Label 35196*/ GIMT_Encode4(2434467), // Rule ID 45466 //
     /* 2434389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434425 */     // MIs[1] Operand 1
     /* 2434425 */     // No operand predicates
     /* 2434425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434429 */     // MIs[0] policy
     /* 2434429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434441 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2434444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434466 */     // GIR_Coverage, 45466,
     /* 2434466 */     GIR_EraseRootFromParent_Done,
     /* 2434467 */   // Label 35196: @2434467
     /* 2434467 */   GIM_Try, /*On fail goto*//*Label 35197*/ GIMT_Encode4(2434550), // Rule ID 45467 //
     /* 2434472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434508 */     // MIs[1] Operand 1
     /* 2434508 */     // No operand predicates
     /* 2434508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434512 */     // MIs[0] policy
     /* 2434512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434524 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2434527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434549 */     // GIR_Coverage, 45467,
     /* 2434549 */     GIR_EraseRootFromParent_Done,
     /* 2434550 */   // Label 35197: @2434550
     /* 2434550 */   GIM_Try, /*On fail goto*//*Label 35198*/ GIMT_Encode4(2434633), // Rule ID 45538 //
     /* 2434555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434591 */     // MIs[1] Operand 1
     /* 2434591 */     // No operand predicates
     /* 2434591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434595 */     // MIs[0] policy
     /* 2434595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434607 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2434610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434632 */     // GIR_Coverage, 45538,
     /* 2434632 */     GIR_EraseRootFromParent_Done,
     /* 2434633 */   // Label 35198: @2434633
     /* 2434633 */   GIM_Try, /*On fail goto*//*Label 35199*/ GIMT_Encode4(2434716), // Rule ID 45539 //
     /* 2434638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434674 */     // MIs[1] Operand 1
     /* 2434674 */     // No operand predicates
     /* 2434674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434678 */     // MIs[0] policy
     /* 2434678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434690 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2434693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434702 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434715 */     // GIR_Coverage, 45539,
     /* 2434715 */     GIR_EraseRootFromParent_Done,
     /* 2434716 */   // Label 35199: @2434716
     /* 2434716 */   GIM_Try, /*On fail goto*//*Label 35200*/ GIMT_Encode4(2434788), // Rule ID 45468 //
     /* 2434721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434753 */     // MIs[0] policy
     /* 2434753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434763 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2434766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434774 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434787 */     // GIR_Coverage, 45468,
     /* 2434787 */     GIR_EraseRootFromParent_Done,
     /* 2434788 */   // Label 35200: @2434788
     /* 2434788 */   GIM_Try, /*On fail goto*//*Label 35201*/ GIMT_Encode4(2434860), // Rule ID 45469 //
     /* 2434793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434825 */     // MIs[0] policy
     /* 2434825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434835 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2434838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434846 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434859 */     // GIR_Coverage, 45469,
     /* 2434859 */     GIR_EraseRootFromParent_Done,
     /* 2434860 */   // Label 35201: @2434860
     /* 2434860 */   GIM_Try, /*On fail goto*//*Label 35202*/ GIMT_Encode4(2434932), // Rule ID 45540 //
     /* 2434865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434897 */     // MIs[0] policy
     /* 2434897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434907 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2434910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434918 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434931 */     // GIR_Coverage, 45540,
     /* 2434931 */     GIR_EraseRootFromParent_Done,
     /* 2434932 */   // Label 35202: @2434932
     /* 2434932 */   GIM_Try, /*On fail goto*//*Label 35203*/ GIMT_Encode4(2435004), // Rule ID 45541 //
     /* 2434937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434969 */     // MIs[0] policy
     /* 2434969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434979 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2434982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434990 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435003 */     // GIR_Coverage, 45541,
     /* 2435003 */     GIR_EraseRootFromParent_Done,
     /* 2435004 */   // Label 35203: @2435004
     /* 2435004 */   GIM_Reject,
     /* 2435005 */ // Label 35195: @2435005
     /* 2435005 */ GIM_Reject,
     /* 2435006 */ // Label 35113: @2435006
     /* 2435006 */ GIM_Try, /*On fail goto*//*Label 35204*/ GIMT_Encode4(2435638),
     /* 2435011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2435014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2435017 */   GIM_Try, /*On fail goto*//*Label 35205*/ GIMT_Encode4(2435100), // Rule ID 45502 //
     /* 2435022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2435031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435058 */     // MIs[1] Operand 1
     /* 2435058 */     // No operand predicates
     /* 2435058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435062 */     // MIs[0] policy
     /* 2435062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435074 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2435077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435099 */     // GIR_Coverage, 45502,
     /* 2435099 */     GIR_EraseRootFromParent_Done,
     /* 2435100 */   // Label 35205: @2435100
     /* 2435100 */   GIM_Try, /*On fail goto*//*Label 35206*/ GIMT_Encode4(2435183), // Rule ID 45503 //
     /* 2435105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2435114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435141 */     // MIs[1] Operand 1
     /* 2435141 */     // No operand predicates
     /* 2435141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435145 */     // MIs[0] policy
     /* 2435145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435157 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2435160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435182 */     // GIR_Coverage, 45503,
     /* 2435182 */     GIR_EraseRootFromParent_Done,
     /* 2435183 */   // Label 35206: @2435183
     /* 2435183 */   GIM_Try, /*On fail goto*//*Label 35207*/ GIMT_Encode4(2435266), // Rule ID 45562 //
     /* 2435188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2435197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435224 */     // MIs[1] Operand 1
     /* 2435224 */     // No operand predicates
     /* 2435224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435228 */     // MIs[0] policy
     /* 2435228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435240 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2435243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435252 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435265 */     // GIR_Coverage, 45562,
     /* 2435265 */     GIR_EraseRootFromParent_Done,
     /* 2435266 */   // Label 35207: @2435266
     /* 2435266 */   GIM_Try, /*On fail goto*//*Label 35208*/ GIMT_Encode4(2435349), // Rule ID 45563 //
     /* 2435271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2435280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435307 */     // MIs[1] Operand 1
     /* 2435307 */     // No operand predicates
     /* 2435307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435311 */     // MIs[0] policy
     /* 2435311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435323 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2435326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435348 */     // GIR_Coverage, 45563,
     /* 2435348 */     GIR_EraseRootFromParent_Done,
     /* 2435349 */   // Label 35208: @2435349
     /* 2435349 */   GIM_Try, /*On fail goto*//*Label 35209*/ GIMT_Encode4(2435421), // Rule ID 45504 //
     /* 2435354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2435363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435386 */     // MIs[0] policy
     /* 2435386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435396 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2435399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435420 */     // GIR_Coverage, 45504,
     /* 2435420 */     GIR_EraseRootFromParent_Done,
     /* 2435421 */   // Label 35209: @2435421
     /* 2435421 */   GIM_Try, /*On fail goto*//*Label 35210*/ GIMT_Encode4(2435493), // Rule ID 45505 //
     /* 2435426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2435435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435458 */     // MIs[0] policy
     /* 2435458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435468 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2435471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435492 */     // GIR_Coverage, 45505,
     /* 2435492 */     GIR_EraseRootFromParent_Done,
     /* 2435493 */   // Label 35210: @2435493
     /* 2435493 */   GIM_Try, /*On fail goto*//*Label 35211*/ GIMT_Encode4(2435565), // Rule ID 45564 //
     /* 2435498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2435507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435530 */     // MIs[0] policy
     /* 2435530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435540 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2435543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435564 */     // GIR_Coverage, 45564,
     /* 2435564 */     GIR_EraseRootFromParent_Done,
     /* 2435565 */   // Label 35211: @2435565
     /* 2435565 */   GIM_Try, /*On fail goto*//*Label 35212*/ GIMT_Encode4(2435637), // Rule ID 45565 //
     /* 2435570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2435579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435602 */     // MIs[0] policy
     /* 2435602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435612 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2435615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435636 */     // GIR_Coverage, 45565,
     /* 2435636 */     GIR_EraseRootFromParent_Done,
     /* 2435637 */   // Label 35212: @2435637
     /* 2435637 */   GIM_Reject,
     /* 2435638 */ // Label 35204: @2435638
     /* 2435638 */ GIM_Reject,
     /* 2435639 */ // Label 35114: @2435639
     /* 2435639 */ GIM_Try, /*On fail goto*//*Label 35213*/ GIMT_Encode4(2436271),
     /* 2435644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2435647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2435650 */   GIM_Try, /*On fail goto*//*Label 35214*/ GIMT_Encode4(2435733), // Rule ID 45518 //
     /* 2435655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2435664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435691 */     // MIs[1] Operand 1
     /* 2435691 */     // No operand predicates
     /* 2435691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435695 */     // MIs[0] policy
     /* 2435695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435707 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2435710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435732 */     // GIR_Coverage, 45518,
     /* 2435732 */     GIR_EraseRootFromParent_Done,
     /* 2435733 */   // Label 35214: @2435733
     /* 2435733 */   GIM_Try, /*On fail goto*//*Label 35215*/ GIMT_Encode4(2435816), // Rule ID 45519 //
     /* 2435738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2435741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2435747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435774 */     // MIs[1] Operand 1
     /* 2435774 */     // No operand predicates
     /* 2435774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435778 */     // MIs[0] policy
     /* 2435778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435790 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2435793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435802 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435815 */     // GIR_Coverage, 45519,
     /* 2435815 */     GIR_EraseRootFromParent_Done,
     /* 2435816 */   // Label 35215: @2435816
     /* 2435816 */   GIM_Try, /*On fail goto*//*Label 35216*/ GIMT_Encode4(2435899), // Rule ID 45578 //
     /* 2435821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2435830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435857 */     // MIs[1] Operand 1
     /* 2435857 */     // No operand predicates
     /* 2435857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435861 */     // MIs[0] policy
     /* 2435861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435873 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2435876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435885 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435898 */     // GIR_Coverage, 45578,
     /* 2435898 */     GIR_EraseRootFromParent_Done,
     /* 2435899 */   // Label 35216: @2435899
     /* 2435899 */   GIM_Try, /*On fail goto*//*Label 35217*/ GIMT_Encode4(2435982), // Rule ID 45579 //
     /* 2435904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2435907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2435913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435940 */     // MIs[1] Operand 1
     /* 2435940 */     // No operand predicates
     /* 2435940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435944 */     // MIs[0] policy
     /* 2435944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435956 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2435959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435968 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435981 */     // GIR_Coverage, 45579,
     /* 2435981 */     GIR_EraseRootFromParent_Done,
     /* 2435982 */   // Label 35217: @2435982
     /* 2435982 */   GIM_Try, /*On fail goto*//*Label 35218*/ GIMT_Encode4(2436054), // Rule ID 45520 //
     /* 2435987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2435996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2436003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436019 */     // MIs[0] policy
     /* 2436019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436029 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2436032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436040 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436053 */     // GIR_Coverage, 45520,
     /* 2436053 */     GIR_EraseRootFromParent_Done,
     /* 2436054 */   // Label 35218: @2436054
     /* 2436054 */   GIM_Try, /*On fail goto*//*Label 35219*/ GIMT_Encode4(2436126), // Rule ID 45521 //
     /* 2436059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2436062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2436068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2436075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436091 */     // MIs[0] policy
     /* 2436091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436101 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2436104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436112 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436125 */     // GIR_Coverage, 45521,
     /* 2436125 */     GIR_EraseRootFromParent_Done,
     /* 2436126 */   // Label 35219: @2436126
     /* 2436126 */   GIM_Try, /*On fail goto*//*Label 35220*/ GIMT_Encode4(2436198), // Rule ID 45580 //
     /* 2436131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2436134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2436140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2436147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436163 */     // MIs[0] policy
     /* 2436163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436173 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2436176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436184 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436197 */     // GIR_Coverage, 45580,
     /* 2436197 */     GIR_EraseRootFromParent_Done,
     /* 2436198 */   // Label 35220: @2436198
     /* 2436198 */   GIM_Try, /*On fail goto*//*Label 35221*/ GIMT_Encode4(2436270), // Rule ID 45581 //
     /* 2436203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2436206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2436212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2436219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436235 */     // MIs[0] policy
     /* 2436235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436245 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2436248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436256 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436269 */     // GIR_Coverage, 45581,
     /* 2436269 */     GIR_EraseRootFromParent_Done,
     /* 2436270 */   // Label 35221: @2436270
     /* 2436270 */   GIM_Reject,
     /* 2436271 */ // Label 35213: @2436271
     /* 2436271 */ GIM_Reject,
     /* 2436272 */ // Label 35115: @2436272
     /* 2436272 */ GIM_Try, /*On fail goto*//*Label 35222*/ GIMT_Encode4(2436594),
     /* 2436277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2436280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2436283 */   GIM_Try, /*On fail goto*//*Label 35223*/ GIMT_Encode4(2436366), // Rule ID 45462 //
     /* 2436288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436324 */     // MIs[1] Operand 1
     /* 2436324 */     // No operand predicates
     /* 2436324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436328 */     // MIs[0] policy
     /* 2436328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436340 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2436343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436352 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436365 */     // GIR_Coverage, 45462,
     /* 2436365 */     GIR_EraseRootFromParent_Done,
     /* 2436366 */   // Label 35223: @2436366
     /* 2436366 */   GIM_Try, /*On fail goto*//*Label 35224*/ GIMT_Encode4(2436449), // Rule ID 45463 //
     /* 2436371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436407 */     // MIs[1] Operand 1
     /* 2436407 */     // No operand predicates
     /* 2436407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436411 */     // MIs[0] policy
     /* 2436411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436423 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2436426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436448 */     // GIR_Coverage, 45463,
     /* 2436448 */     GIR_EraseRootFromParent_Done,
     /* 2436449 */   // Label 35224: @2436449
     /* 2436449 */   GIM_Try, /*On fail goto*//*Label 35225*/ GIMT_Encode4(2436521), // Rule ID 45464 //
     /* 2436454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436486 */     // MIs[0] policy
     /* 2436486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436496 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2436499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436520 */     // GIR_Coverage, 45464,
     /* 2436520 */     GIR_EraseRootFromParent_Done,
     /* 2436521 */   // Label 35225: @2436521
     /* 2436521 */   GIM_Try, /*On fail goto*//*Label 35226*/ GIMT_Encode4(2436593), // Rule ID 45465 //
     /* 2436526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436558 */     // MIs[0] policy
     /* 2436558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436568 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2436571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436579 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436592 */     // GIR_Coverage, 45465,
     /* 2436592 */     GIR_EraseRootFromParent_Done,
     /* 2436593 */   // Label 35226: @2436593
     /* 2436593 */   GIM_Reject,
     /* 2436594 */ // Label 35222: @2436594
     /* 2436594 */ GIM_Reject,
     /* 2436595 */ // Label 35116: @2436595
     /* 2436595 */ GIM_Try, /*On fail goto*//*Label 35227*/ GIMT_Encode4(2437227),
     /* 2436600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2436603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2436606 */   GIM_Try, /*On fail goto*//*Label 35228*/ GIMT_Encode4(2436689), // Rule ID 45490 //
     /* 2436611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436647 */     // MIs[1] Operand 1
     /* 2436647 */     // No operand predicates
     /* 2436647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436651 */     // MIs[0] policy
     /* 2436651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436663 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2436666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436688 */     // GIR_Coverage, 45490,
     /* 2436688 */     GIR_EraseRootFromParent_Done,
     /* 2436689 */   // Label 35228: @2436689
     /* 2436689 */   GIM_Try, /*On fail goto*//*Label 35229*/ GIMT_Encode4(2436772), // Rule ID 45491 //
     /* 2436694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436730 */     // MIs[1] Operand 1
     /* 2436730 */     // No operand predicates
     /* 2436730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436734 */     // MIs[0] policy
     /* 2436734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436746 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2436749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436758 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436771 */     // GIR_Coverage, 45491,
     /* 2436771 */     GIR_EraseRootFromParent_Done,
     /* 2436772 */   // Label 35229: @2436772
     /* 2436772 */   GIM_Try, /*On fail goto*//*Label 35230*/ GIMT_Encode4(2436855), // Rule ID 45550 //
     /* 2436777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436813 */     // MIs[1] Operand 1
     /* 2436813 */     // No operand predicates
     /* 2436813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436817 */     // MIs[0] policy
     /* 2436817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436829 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2436832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436854 */     // GIR_Coverage, 45550,
     /* 2436854 */     GIR_EraseRootFromParent_Done,
     /* 2436855 */   // Label 35230: @2436855
     /* 2436855 */   GIM_Try, /*On fail goto*//*Label 35231*/ GIMT_Encode4(2436938), // Rule ID 45551 //
     /* 2436860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436896 */     // MIs[1] Operand 1
     /* 2436896 */     // No operand predicates
     /* 2436896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436900 */     // MIs[0] policy
     /* 2436900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436912 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2436915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436924 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436937 */     // GIR_Coverage, 45551,
     /* 2436937 */     GIR_EraseRootFromParent_Done,
     /* 2436938 */   // Label 35231: @2436938
     /* 2436938 */   GIM_Try, /*On fail goto*//*Label 35232*/ GIMT_Encode4(2437010), // Rule ID 45492 //
     /* 2436943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436975 */     // MIs[0] policy
     /* 2436975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436985 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2436988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436996 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437009 */     // GIR_Coverage, 45492,
     /* 2437009 */     GIR_EraseRootFromParent_Done,
     /* 2437010 */   // Label 35232: @2437010
     /* 2437010 */   GIM_Try, /*On fail goto*//*Label 35233*/ GIMT_Encode4(2437082), // Rule ID 45493 //
     /* 2437015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2437024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437047 */     // MIs[0] policy
     /* 2437047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437057 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2437060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437081 */     // GIR_Coverage, 45493,
     /* 2437081 */     GIR_EraseRootFromParent_Done,
     /* 2437082 */   // Label 35233: @2437082
     /* 2437082 */   GIM_Try, /*On fail goto*//*Label 35234*/ GIMT_Encode4(2437154), // Rule ID 45552 //
     /* 2437087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2437096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437119 */     // MIs[0] policy
     /* 2437119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437129 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2437132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437153 */     // GIR_Coverage, 45552,
     /* 2437153 */     GIR_EraseRootFromParent_Done,
     /* 2437154 */   // Label 35234: @2437154
     /* 2437154 */   GIM_Try, /*On fail goto*//*Label 35235*/ GIMT_Encode4(2437226), // Rule ID 45553 //
     /* 2437159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2437168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437191 */     // MIs[0] policy
     /* 2437191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437201 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2437204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437225 */     // GIR_Coverage, 45553,
     /* 2437225 */     GIR_EraseRootFromParent_Done,
     /* 2437226 */   // Label 35235: @2437226
     /* 2437226 */   GIM_Reject,
     /* 2437227 */ // Label 35227: @2437227
     /* 2437227 */ GIM_Reject,
     /* 2437228 */ // Label 35117: @2437228
     /* 2437228 */ GIM_Try, /*On fail goto*//*Label 35236*/ GIMT_Encode4(2437860),
     /* 2437233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2437236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2437239 */   GIM_Try, /*On fail goto*//*Label 35237*/ GIMT_Encode4(2437322), // Rule ID 45506 //
     /* 2437244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2437253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437280 */     // MIs[1] Operand 1
     /* 2437280 */     // No operand predicates
     /* 2437280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437284 */     // MIs[0] policy
     /* 2437284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437296 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2437299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437321 */     // GIR_Coverage, 45506,
     /* 2437321 */     GIR_EraseRootFromParent_Done,
     /* 2437322 */   // Label 35237: @2437322
     /* 2437322 */   GIM_Try, /*On fail goto*//*Label 35238*/ GIMT_Encode4(2437405), // Rule ID 45507 //
     /* 2437327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2437336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437363 */     // MIs[1] Operand 1
     /* 2437363 */     // No operand predicates
     /* 2437363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437367 */     // MIs[0] policy
     /* 2437367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437379 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2437382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437404 */     // GIR_Coverage, 45507,
     /* 2437404 */     GIR_EraseRootFromParent_Done,
     /* 2437405 */   // Label 35238: @2437405
     /* 2437405 */   GIM_Try, /*On fail goto*//*Label 35239*/ GIMT_Encode4(2437488), // Rule ID 45566 //
     /* 2437410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2437419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437446 */     // MIs[1] Operand 1
     /* 2437446 */     // No operand predicates
     /* 2437446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437450 */     // MIs[0] policy
     /* 2437450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437462 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2437465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437474 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437487 */     // GIR_Coverage, 45566,
     /* 2437487 */     GIR_EraseRootFromParent_Done,
     /* 2437488 */   // Label 35239: @2437488
     /* 2437488 */   GIM_Try, /*On fail goto*//*Label 35240*/ GIMT_Encode4(2437571), // Rule ID 45567 //
     /* 2437493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2437502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437529 */     // MIs[1] Operand 1
     /* 2437529 */     // No operand predicates
     /* 2437529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437533 */     // MIs[0] policy
     /* 2437533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437545 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2437548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437570 */     // GIR_Coverage, 45567,
     /* 2437570 */     GIR_EraseRootFromParent_Done,
     /* 2437571 */   // Label 35240: @2437571
     /* 2437571 */   GIM_Try, /*On fail goto*//*Label 35241*/ GIMT_Encode4(2437643), // Rule ID 45508 //
     /* 2437576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2437585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437608 */     // MIs[0] policy
     /* 2437608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437618 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2437621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437642 */     // GIR_Coverage, 45508,
     /* 2437642 */     GIR_EraseRootFromParent_Done,
     /* 2437643 */   // Label 35241: @2437643
     /* 2437643 */   GIM_Try, /*On fail goto*//*Label 35242*/ GIMT_Encode4(2437715), // Rule ID 45509 //
     /* 2437648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2437657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437680 */     // MIs[0] policy
     /* 2437680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437690 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2437693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437714 */     // GIR_Coverage, 45509,
     /* 2437714 */     GIR_EraseRootFromParent_Done,
     /* 2437715 */   // Label 35242: @2437715
     /* 2437715 */   GIM_Try, /*On fail goto*//*Label 35243*/ GIMT_Encode4(2437787), // Rule ID 45568 //
     /* 2437720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2437729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437752 */     // MIs[0] policy
     /* 2437752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437762 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2437765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437786 */     // GIR_Coverage, 45568,
     /* 2437786 */     GIR_EraseRootFromParent_Done,
     /* 2437787 */   // Label 35243: @2437787
     /* 2437787 */   GIM_Try, /*On fail goto*//*Label 35244*/ GIMT_Encode4(2437859), // Rule ID 45569 //
     /* 2437792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2437801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437824 */     // MIs[0] policy
     /* 2437824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437834 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2437837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437858 */     // GIR_Coverage, 45569,
     /* 2437858 */     GIR_EraseRootFromParent_Done,
     /* 2437859 */   // Label 35244: @2437859
     /* 2437859 */   GIM_Reject,
     /* 2437860 */ // Label 35236: @2437860
     /* 2437860 */ GIM_Reject,
     /* 2437861 */ // Label 35118: @2437861
     /* 2437861 */ GIM_Try, /*On fail goto*//*Label 35245*/ GIMT_Encode4(2438493),
     /* 2437866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2437869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2437872 */   GIM_Try, /*On fail goto*//*Label 35246*/ GIMT_Encode4(2437955), // Rule ID 45522 //
     /* 2437877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2437880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2437886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437913 */     // MIs[1] Operand 1
     /* 2437913 */     // No operand predicates
     /* 2437913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437917 */     // MIs[0] policy
     /* 2437917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437929 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2437932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437954 */     // GIR_Coverage, 45522,
     /* 2437954 */     GIR_EraseRootFromParent_Done,
     /* 2437955 */   // Label 35246: @2437955
     /* 2437955 */   GIM_Try, /*On fail goto*//*Label 35247*/ GIMT_Encode4(2438038), // Rule ID 45523 //
     /* 2437960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2437963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2437969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437996 */     // MIs[1] Operand 1
     /* 2437996 */     // No operand predicates
     /* 2437996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438000 */     // MIs[0] policy
     /* 2438000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438012 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2438015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438024 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2438034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438037 */     // GIR_Coverage, 45523,
     /* 2438037 */     GIR_EraseRootFromParent_Done,
     /* 2438038 */   // Label 35247: @2438038
     /* 2438038 */   GIM_Try, /*On fail goto*//*Label 35248*/ GIMT_Encode4(2438121), // Rule ID 45582 //
     /* 2438043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2438046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2438052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438079 */     // MIs[1] Operand 1
     /* 2438079 */     // No operand predicates
     /* 2438079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438083 */     // MIs[0] policy
     /* 2438083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438095 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2438098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2438117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438120 */     // GIR_Coverage, 45582,
     /* 2438120 */     GIR_EraseRootFromParent_Done,
     /* 2438121 */   // Label 35248: @2438121
     /* 2438121 */   GIM_Try, /*On fail goto*//*Label 35249*/ GIMT_Encode4(2438204), // Rule ID 45583 //
     /* 2438126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2438129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2438135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438162 */     // MIs[1] Operand 1
     /* 2438162 */     // No operand predicates
     /* 2438162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438166 */     // MIs[0] policy
     /* 2438166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438178 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2438181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438190 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2438200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438203 */     // GIR_Coverage, 45583,
     /* 2438203 */     GIR_EraseRootFromParent_Done,
     /* 2438204 */   // Label 35249: @2438204
     /* 2438204 */   GIM_Try, /*On fail goto*//*Label 35250*/ GIMT_Encode4(2438276), // Rule ID 45524 //
     /* 2438209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2438212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2438218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438241 */     // MIs[0] policy
     /* 2438241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438251 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2438254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438262 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2438272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438275 */     // GIR_Coverage, 45524,
     /* 2438275 */     GIR_EraseRootFromParent_Done,
     /* 2438276 */   // Label 35250: @2438276
     /* 2438276 */   GIM_Try, /*On fail goto*//*Label 35251*/ GIMT_Encode4(2438348), // Rule ID 45525 //
     /* 2438281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2438284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2438290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438313 */     // MIs[0] policy
     /* 2438313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438323 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2438326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438334 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2438344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438347 */     // GIR_Coverage, 45525,
     /* 2438347 */     GIR_EraseRootFromParent_Done,
     /* 2438348 */   // Label 35251: @2438348
     /* 2438348 */   GIM_Try, /*On fail goto*//*Label 35252*/ GIMT_Encode4(2438420), // Rule ID 45584 //
     /* 2438353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2438356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2438362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438385 */     // MIs[0] policy
     /* 2438385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438395 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2438398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438406 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2438416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438419 */     // GIR_Coverage, 45584,
     /* 2438419 */     GIR_EraseRootFromParent_Done,
     /* 2438420 */   // Label 35252: @2438420
     /* 2438420 */   GIM_Try, /*On fail goto*//*Label 35253*/ GIMT_Encode4(2438492), // Rule ID 45585 //
     /* 2438425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2438428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2438434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438457 */     // MIs[0] policy
     /* 2438457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438467 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2438470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438478 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2438488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438491 */     // GIR_Coverage, 45585,
     /* 2438491 */     GIR_EraseRootFromParent_Done,
     /* 2438492 */   // Label 35253: @2438492
     /* 2438492 */   GIM_Reject,
     /* 2438493 */ // Label 35245: @2438493
     /* 2438493 */ GIM_Reject,
     /* 2438494 */ // Label 35119: @2438494
     /* 2438494 */ GIM_Try, /*On fail goto*//*Label 35254*/ GIMT_Encode4(2438816),
     /* 2438499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2438502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2438505 */   GIM_Try, /*On fail goto*//*Label 35255*/ GIMT_Encode4(2438588), // Rule ID 45478 //
     /* 2438510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2438526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2438530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2438534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438546 */     // MIs[1] Operand 1
     /* 2438546 */     // No operand predicates
     /* 2438546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438550 */     // MIs[0] policy
     /* 2438550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438562 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2438565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438574 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438587 */     // GIR_Coverage, 45478,
     /* 2438587 */     GIR_EraseRootFromParent_Done,
     /* 2438588 */   // Label 35255: @2438588
     /* 2438588 */   GIM_Try, /*On fail goto*//*Label 35256*/ GIMT_Encode4(2438671), // Rule ID 45479 //
     /* 2438593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2438609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2438613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2438617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438629 */     // MIs[1] Operand 1
     /* 2438629 */     // No operand predicates
     /* 2438629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438633 */     // MIs[0] policy
     /* 2438633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438645 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2438648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438670 */     // GIR_Coverage, 45479,
     /* 2438670 */     GIR_EraseRootFromParent_Done,
     /* 2438671 */   // Label 35256: @2438671
     /* 2438671 */   GIM_Try, /*On fail goto*//*Label 35257*/ GIMT_Encode4(2438743), // Rule ID 45480 //
     /* 2438676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2438692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2438696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2438700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438708 */     // MIs[0] policy
     /* 2438708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438718 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2438721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438742 */     // GIR_Coverage, 45480,
     /* 2438742 */     GIR_EraseRootFromParent_Done,
     /* 2438743 */   // Label 35257: @2438743
     /* 2438743 */   GIM_Try, /*On fail goto*//*Label 35258*/ GIMT_Encode4(2438815), // Rule ID 45481 //
     /* 2438748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2438764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2438768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2438772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438780 */     // MIs[0] policy
     /* 2438780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438790 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2438793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438814 */     // GIR_Coverage, 45481,
     /* 2438814 */     GIR_EraseRootFromParent_Done,
     /* 2438815 */   // Label 35258: @2438815
     /* 2438815 */   GIM_Reject,
     /* 2438816 */ // Label 35254: @2438816
     /* 2438816 */ GIM_Reject,
     /* 2438817 */ // Label 35120: @2438817
     /* 2438817 */ GIM_Try, /*On fail goto*//*Label 35259*/ GIMT_Encode4(2439449),
     /* 2438822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2438825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2438828 */   GIM_Try, /*On fail goto*//*Label 35260*/ GIMT_Encode4(2438911), // Rule ID 45494 //
     /* 2438833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2438849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438869 */     // MIs[1] Operand 1
     /* 2438869 */     // No operand predicates
     /* 2438869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438873 */     // MIs[0] policy
     /* 2438873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438885 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2438888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438910 */     // GIR_Coverage, 45494,
     /* 2438910 */     GIR_EraseRootFromParent_Done,
     /* 2438911 */   // Label 35260: @2438911
     /* 2438911 */   GIM_Try, /*On fail goto*//*Label 35261*/ GIMT_Encode4(2438994), // Rule ID 45495 //
     /* 2438916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2438932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438952 */     // MIs[1] Operand 1
     /* 2438952 */     // No operand predicates
     /* 2438952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438956 */     // MIs[0] policy
     /* 2438956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438968 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2438971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438980 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438993 */     // GIR_Coverage, 45495,
     /* 2438993 */     GIR_EraseRootFromParent_Done,
     /* 2438994 */   // Label 35261: @2438994
     /* 2438994 */   GIM_Try, /*On fail goto*//*Label 35262*/ GIMT_Encode4(2439077), // Rule ID 45554 //
     /* 2438999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2439008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439035 */     // MIs[1] Operand 1
     /* 2439035 */     // No operand predicates
     /* 2439035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439039 */     // MIs[0] policy
     /* 2439039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439051 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2439054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439073 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439076 */     // GIR_Coverage, 45554,
     /* 2439076 */     GIR_EraseRootFromParent_Done,
     /* 2439077 */   // Label 35262: @2439077
     /* 2439077 */   GIM_Try, /*On fail goto*//*Label 35263*/ GIMT_Encode4(2439160), // Rule ID 45555 //
     /* 2439082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2439091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439118 */     // MIs[1] Operand 1
     /* 2439118 */     // No operand predicates
     /* 2439118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439122 */     // MIs[0] policy
     /* 2439122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439134 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2439137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439146 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439159 */     // GIR_Coverage, 45555,
     /* 2439159 */     GIR_EraseRootFromParent_Done,
     /* 2439160 */   // Label 35263: @2439160
     /* 2439160 */   GIM_Try, /*On fail goto*//*Label 35264*/ GIMT_Encode4(2439232), // Rule ID 45496 //
     /* 2439165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2439174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439197 */     // MIs[0] policy
     /* 2439197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439207 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2439210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439218 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439228 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439231 */     // GIR_Coverage, 45496,
     /* 2439231 */     GIR_EraseRootFromParent_Done,
     /* 2439232 */   // Label 35264: @2439232
     /* 2439232 */   GIM_Try, /*On fail goto*//*Label 35265*/ GIMT_Encode4(2439304), // Rule ID 45497 //
     /* 2439237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2439246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439269 */     // MIs[0] policy
     /* 2439269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439279 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2439282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439290 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439303 */     // GIR_Coverage, 45497,
     /* 2439303 */     GIR_EraseRootFromParent_Done,
     /* 2439304 */   // Label 35265: @2439304
     /* 2439304 */   GIM_Try, /*On fail goto*//*Label 35266*/ GIMT_Encode4(2439376), // Rule ID 45556 //
     /* 2439309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2439318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439341 */     // MIs[0] policy
     /* 2439341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439351 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2439354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439362 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439375 */     // GIR_Coverage, 45556,
     /* 2439375 */     GIR_EraseRootFromParent_Done,
     /* 2439376 */   // Label 35266: @2439376
     /* 2439376 */   GIM_Try, /*On fail goto*//*Label 35267*/ GIMT_Encode4(2439448), // Rule ID 45557 //
     /* 2439381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2439390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439413 */     // MIs[0] policy
     /* 2439413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439423 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2439426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439434 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439447 */     // GIR_Coverage, 45557,
     /* 2439447 */     GIR_EraseRootFromParent_Done,
     /* 2439448 */   // Label 35267: @2439448
     /* 2439448 */   GIM_Reject,
     /* 2439449 */ // Label 35259: @2439449
     /* 2439449 */ GIM_Reject,
     /* 2439450 */ // Label 35121: @2439450
     /* 2439450 */ GIM_Try, /*On fail goto*//*Label 35268*/ GIMT_Encode4(2440082),
     /* 2439455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2439458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2439461 */   GIM_Try, /*On fail goto*//*Label 35269*/ GIMT_Encode4(2439544), // Rule ID 45510 //
     /* 2439466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2439475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439502 */     // MIs[1] Operand 1
     /* 2439502 */     // No operand predicates
     /* 2439502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439506 */     // MIs[0] policy
     /* 2439506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439518 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2439521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439543 */     // GIR_Coverage, 45510,
     /* 2439543 */     GIR_EraseRootFromParent_Done,
     /* 2439544 */   // Label 35269: @2439544
     /* 2439544 */   GIM_Try, /*On fail goto*//*Label 35270*/ GIMT_Encode4(2439627), // Rule ID 45511 //
     /* 2439549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2439558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439585 */     // MIs[1] Operand 1
     /* 2439585 */     // No operand predicates
     /* 2439585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439589 */     // MIs[0] policy
     /* 2439589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439601 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2439604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439626 */     // GIR_Coverage, 45511,
     /* 2439626 */     GIR_EraseRootFromParent_Done,
     /* 2439627 */   // Label 35270: @2439627
     /* 2439627 */   GIM_Try, /*On fail goto*//*Label 35271*/ GIMT_Encode4(2439710), // Rule ID 45570 //
     /* 2439632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2439641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439668 */     // MIs[1] Operand 1
     /* 2439668 */     // No operand predicates
     /* 2439668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439672 */     // MIs[0] policy
     /* 2439672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439684 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2439687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439696 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439709 */     // GIR_Coverage, 45570,
     /* 2439709 */     GIR_EraseRootFromParent_Done,
     /* 2439710 */   // Label 35271: @2439710
     /* 2439710 */   GIM_Try, /*On fail goto*//*Label 35272*/ GIMT_Encode4(2439793), // Rule ID 45571 //
     /* 2439715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2439724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439751 */     // MIs[1] Operand 1
     /* 2439751 */     // No operand predicates
     /* 2439751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439755 */     // MIs[0] policy
     /* 2439755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439767 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2439770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439792 */     // GIR_Coverage, 45571,
     /* 2439792 */     GIR_EraseRootFromParent_Done,
     /* 2439793 */   // Label 35272: @2439793
     /* 2439793 */   GIM_Try, /*On fail goto*//*Label 35273*/ GIMT_Encode4(2439865), // Rule ID 45512 //
     /* 2439798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2439807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439830 */     // MIs[0] policy
     /* 2439830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439840 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2439843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439864 */     // GIR_Coverage, 45512,
     /* 2439864 */     GIR_EraseRootFromParent_Done,
     /* 2439865 */   // Label 35273: @2439865
     /* 2439865 */   GIM_Try, /*On fail goto*//*Label 35274*/ GIMT_Encode4(2439937), // Rule ID 45513 //
     /* 2439870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2439879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439902 */     // MIs[0] policy
     /* 2439902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439912 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2439915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439936 */     // GIR_Coverage, 45513,
     /* 2439936 */     GIR_EraseRootFromParent_Done,
     /* 2439937 */   // Label 35274: @2439937
     /* 2439937 */   GIM_Try, /*On fail goto*//*Label 35275*/ GIMT_Encode4(2440009), // Rule ID 45572 //
     /* 2439942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2439951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439974 */     // MIs[0] policy
     /* 2439974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439984 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2439987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440008 */     // GIR_Coverage, 45572,
     /* 2440008 */     GIR_EraseRootFromParent_Done,
     /* 2440009 */   // Label 35275: @2440009
     /* 2440009 */   GIM_Try, /*On fail goto*//*Label 35276*/ GIMT_Encode4(2440081), // Rule ID 45573 //
     /* 2440014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2440023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2440030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440046 */     // MIs[0] policy
     /* 2440046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440056 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2440059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440080 */     // GIR_Coverage, 45573,
     /* 2440080 */     GIR_EraseRootFromParent_Done,
     /* 2440081 */   // Label 35276: @2440081
     /* 2440081 */   GIM_Reject,
     /* 2440082 */ // Label 35268: @2440082
     /* 2440082 */ GIM_Reject,
     /* 2440083 */ // Label 35122: @2440083
     /* 2440083 */ GIM_Try, /*On fail goto*//*Label 35277*/ GIMT_Encode4(2440405),
     /* 2440088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2440091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2440094 */   GIM_Try, /*On fail goto*//*Label 35278*/ GIMT_Encode4(2440177), // Rule ID 45482 //
     /* 2440099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2440108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2440115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440135 */     // MIs[1] Operand 1
     /* 2440135 */     // No operand predicates
     /* 2440135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440139 */     // MIs[0] policy
     /* 2440139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440151 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2440154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2440173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440176 */     // GIR_Coverage, 45482,
     /* 2440176 */     GIR_EraseRootFromParent_Done,
     /* 2440177 */   // Label 35278: @2440177
     /* 2440177 */   GIM_Try, /*On fail goto*//*Label 35279*/ GIMT_Encode4(2440260), // Rule ID 45483 //
     /* 2440182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2440191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2440198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440218 */     // MIs[1] Operand 1
     /* 2440218 */     // No operand predicates
     /* 2440218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440222 */     // MIs[0] policy
     /* 2440222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440234 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2440237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440246 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2440256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440259 */     // GIR_Coverage, 45483,
     /* 2440259 */     GIR_EraseRootFromParent_Done,
     /* 2440260 */   // Label 35279: @2440260
     /* 2440260 */   GIM_Try, /*On fail goto*//*Label 35280*/ GIMT_Encode4(2440332), // Rule ID 45484 //
     /* 2440265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2440274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2440281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440297 */     // MIs[0] policy
     /* 2440297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440307 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2440310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440318 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2440328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440331 */     // GIR_Coverage, 45484,
     /* 2440331 */     GIR_EraseRootFromParent_Done,
     /* 2440332 */   // Label 35280: @2440332
     /* 2440332 */   GIM_Try, /*On fail goto*//*Label 35281*/ GIMT_Encode4(2440404), // Rule ID 45485 //
     /* 2440337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2440346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2440353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440369 */     // MIs[0] policy
     /* 2440369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440379 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2440382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440390 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2440400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440403 */     // GIR_Coverage, 45485,
     /* 2440403 */     GIR_EraseRootFromParent_Done,
     /* 2440404 */   // Label 35281: @2440404
     /* 2440404 */   GIM_Reject,
     /* 2440405 */ // Label 35277: @2440405
     /* 2440405 */ GIM_Reject,
     /* 2440406 */ // Label 35123: @2440406
     /* 2440406 */ GIM_Try, /*On fail goto*//*Label 35282*/ GIMT_Encode4(2441038),
     /* 2440411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2440414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2440417 */   GIM_Try, /*On fail goto*//*Label 35283*/ GIMT_Encode4(2440500), // Rule ID 45498 //
     /* 2440422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2440431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2440438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440458 */     // MIs[1] Operand 1
     /* 2440458 */     // No operand predicates
     /* 2440458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440462 */     // MIs[0] policy
     /* 2440462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440474 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2440477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440486 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440499 */     // GIR_Coverage, 45498,
     /* 2440499 */     GIR_EraseRootFromParent_Done,
     /* 2440500 */   // Label 35283: @2440500
     /* 2440500 */   GIM_Try, /*On fail goto*//*Label 35284*/ GIMT_Encode4(2440583), // Rule ID 45499 //
     /* 2440505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2440514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2440521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440541 */     // MIs[1] Operand 1
     /* 2440541 */     // No operand predicates
     /* 2440541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440545 */     // MIs[0] policy
     /* 2440545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440557 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2440560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440582 */     // GIR_Coverage, 45499,
     /* 2440582 */     GIR_EraseRootFromParent_Done,
     /* 2440583 */   // Label 35284: @2440583
     /* 2440583 */   GIM_Try, /*On fail goto*//*Label 35285*/ GIMT_Encode4(2440666), // Rule ID 45558 //
     /* 2440588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2440597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2440604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440624 */     // MIs[1] Operand 1
     /* 2440624 */     // No operand predicates
     /* 2440624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440628 */     // MIs[0] policy
     /* 2440628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440640 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2440643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440652 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440665 */     // GIR_Coverage, 45558,
     /* 2440665 */     GIR_EraseRootFromParent_Done,
     /* 2440666 */   // Label 35285: @2440666
     /* 2440666 */   GIM_Try, /*On fail goto*//*Label 35286*/ GIMT_Encode4(2440749), // Rule ID 45559 //
     /* 2440671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2440680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2440687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440707 */     // MIs[1] Operand 1
     /* 2440707 */     // No operand predicates
     /* 2440707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440711 */     // MIs[0] policy
     /* 2440711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440723 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2440726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440748 */     // GIR_Coverage, 45559,
     /* 2440748 */     GIR_EraseRootFromParent_Done,
     /* 2440749 */   // Label 35286: @2440749
     /* 2440749 */   GIM_Try, /*On fail goto*//*Label 35287*/ GIMT_Encode4(2440821), // Rule ID 45500 //
     /* 2440754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2440763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2440770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440786 */     // MIs[0] policy
     /* 2440786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440796 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2440799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440820 */     // GIR_Coverage, 45500,
     /* 2440820 */     GIR_EraseRootFromParent_Done,
     /* 2440821 */   // Label 35287: @2440821
     /* 2440821 */   GIM_Try, /*On fail goto*//*Label 35288*/ GIMT_Encode4(2440893), // Rule ID 45501 //
     /* 2440826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2440835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2440842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440858 */     // MIs[0] policy
     /* 2440858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440868 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2440871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440892 */     // GIR_Coverage, 45501,
     /* 2440892 */     GIR_EraseRootFromParent_Done,
     /* 2440893 */   // Label 35288: @2440893
     /* 2440893 */   GIM_Try, /*On fail goto*//*Label 35289*/ GIMT_Encode4(2440965), // Rule ID 45560 //
     /* 2440898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2440907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2440914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440930 */     // MIs[0] policy
     /* 2440930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440940 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2440943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440964 */     // GIR_Coverage, 45560,
     /* 2440964 */     GIR_EraseRootFromParent_Done,
     /* 2440965 */   // Label 35289: @2440965
     /* 2440965 */   GIM_Try, /*On fail goto*//*Label 35290*/ GIMT_Encode4(2441037), // Rule ID 45561 //
     /* 2440970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2440979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2440986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2440994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441002 */     // MIs[0] policy
     /* 2441002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441012 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2441015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2441033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441036 */     // GIR_Coverage, 45561,
     /* 2441036 */     GIR_EraseRootFromParent_Done,
     /* 2441037 */   // Label 35290: @2441037
     /* 2441037 */   GIM_Reject,
     /* 2441038 */ // Label 35282: @2441038
     /* 2441038 */ GIM_Reject,
     /* 2441039 */ // Label 35124: @2441039
     /* 2441039 */ GIM_Try, /*On fail goto*//*Label 35291*/ GIMT_Encode4(2441361),
     /* 2441044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2441047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2441050 */   GIM_Try, /*On fail goto*//*Label 35292*/ GIMT_Encode4(2441133), // Rule ID 45486 //
     /* 2441055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2441064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2441071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441091 */     // MIs[1] Operand 1
     /* 2441091 */     // No operand predicates
     /* 2441091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441095 */     // MIs[0] policy
     /* 2441095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441107 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2441110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2441129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441132 */     // GIR_Coverage, 45486,
     /* 2441132 */     GIR_EraseRootFromParent_Done,
     /* 2441133 */   // Label 35292: @2441133
     /* 2441133 */   GIM_Try, /*On fail goto*//*Label 35293*/ GIMT_Encode4(2441216), // Rule ID 45487 //
     /* 2441138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2441147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2441154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441174 */     // MIs[1] Operand 1
     /* 2441174 */     // No operand predicates
     /* 2441174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441178 */     // MIs[0] policy
     /* 2441178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441190 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2441193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441202 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2441212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441215 */     // GIR_Coverage, 45487,
     /* 2441215 */     GIR_EraseRootFromParent_Done,
     /* 2441216 */   // Label 35293: @2441216
     /* 2441216 */   GIM_Try, /*On fail goto*//*Label 35294*/ GIMT_Encode4(2441288), // Rule ID 45488 //
     /* 2441221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2441230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2441237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441253 */     // MIs[0] policy
     /* 2441253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441263 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2441266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441274 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2441284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441287 */     // GIR_Coverage, 45488,
     /* 2441287 */     GIR_EraseRootFromParent_Done,
     /* 2441288 */   // Label 35294: @2441288
     /* 2441288 */   GIM_Try, /*On fail goto*//*Label 35295*/ GIMT_Encode4(2441360), // Rule ID 45489 //
     /* 2441293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2441302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2441309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441325 */     // MIs[0] policy
     /* 2441325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441335 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2441338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441346 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2441356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441359 */     // GIR_Coverage, 45489,
     /* 2441359 */     GIR_EraseRootFromParent_Done,
     /* 2441360 */   // Label 35295: @2441360
     /* 2441360 */   GIM_Reject,
     /* 2441361 */ // Label 35291: @2441361
     /* 2441361 */ GIM_Reject,
     /* 2441362 */ // Label 35125: @2441362
     /* 2441362 */ GIM_Reject,
     /* 2441363 */ // Label 124: @2441363
     /* 2441363 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35318*/ GIMT_Encode4(2453242),
     /* 2441374 */ /*GILLT_nxv1s8*//*Label 35296*/ GIMT_Encode4(2441486),
     /* 2441378 */ /*GILLT_nxv1s16*//*Label 35297*/ GIMT_Encode4(2441809),
     /* 2441382 */ /*GILLT_nxv1s32*//*Label 35298*/ GIMT_Encode4(2442442),
     /* 2441386 */ /*GILLT_nxv1s64*//*Label 35299*/ GIMT_Encode4(2443075), GIMT_Encode4(0),
     /* 2441394 */ /*GILLT_nxv2s8*//*Label 35300*/ GIMT_Encode4(2443708),
     /* 2441398 */ /*GILLT_nxv2s16*//*Label 35301*/ GIMT_Encode4(2444031),
     /* 2441402 */ /*GILLT_nxv2s32*//*Label 35302*/ GIMT_Encode4(2444664),
     /* 2441406 */ /*GILLT_nxv2s64*//*Label 35303*/ GIMT_Encode4(2445297), GIMT_Encode4(0),
     /* 2441414 */ /*GILLT_nxv4s8*//*Label 35304*/ GIMT_Encode4(2445930),
     /* 2441418 */ /*GILLT_nxv4s16*//*Label 35305*/ GIMT_Encode4(2446253),
     /* 2441422 */ /*GILLT_nxv4s32*//*Label 35306*/ GIMT_Encode4(2446886),
     /* 2441426 */ /*GILLT_nxv4s64*//*Label 35307*/ GIMT_Encode4(2447519), GIMT_Encode4(0),
     /* 2441434 */ /*GILLT_nxv8s8*//*Label 35308*/ GIMT_Encode4(2448152),
     /* 2441438 */ /*GILLT_nxv8s16*//*Label 35309*/ GIMT_Encode4(2448475),
     /* 2441442 */ /*GILLT_nxv8s32*//*Label 35310*/ GIMT_Encode4(2449108),
     /* 2441446 */ /*GILLT_nxv8s64*//*Label 35311*/ GIMT_Encode4(2449741), GIMT_Encode4(0),
     /* 2441454 */ /*GILLT_nxv16s8*//*Label 35312*/ GIMT_Encode4(2450374),
     /* 2441458 */ /*GILLT_nxv16s16*//*Label 35313*/ GIMT_Encode4(2450697),
     /* 2441462 */ /*GILLT_nxv16s32*//*Label 35314*/ GIMT_Encode4(2451330), GIMT_Encode4(0),
     /* 2441470 */ /*GILLT_nxv32s8*//*Label 35315*/ GIMT_Encode4(2451963),
     /* 2441474 */ /*GILLT_nxv32s16*//*Label 35316*/ GIMT_Encode4(2452286), GIMT_Encode4(0),
     /* 2441482 */ /*GILLT_nxv64s8*//*Label 35317*/ GIMT_Encode4(2452919),
     /* 2441486 */ // Label 35296: @2441486
     /* 2441486 */ GIM_Try, /*On fail goto*//*Label 35319*/ GIMT_Encode4(2441808),
     /* 2441491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2441494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2441497 */   GIM_Try, /*On fail goto*//*Label 35320*/ GIMT_Encode4(2441580), // Rule ID 25352 //
     /* 2441502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441538 */     // MIs[1] Operand 1
     /* 2441538 */     // No operand predicates
     /* 2441538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441542 */     // MIs[0] policy
     /* 2441542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441554 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2441557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441566 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2441576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441579 */     // GIR_Coverage, 25352,
     /* 2441579 */     GIR_EraseRootFromParent_Done,
     /* 2441580 */   // Label 35320: @2441580
     /* 2441580 */   GIM_Try, /*On fail goto*//*Label 35321*/ GIMT_Encode4(2441663), // Rule ID 25353 //
     /* 2441585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441621 */     // MIs[1] Operand 1
     /* 2441621 */     // No operand predicates
     /* 2441621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441625 */     // MIs[0] policy
     /* 2441625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441637 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2441640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2441659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441662 */     // GIR_Coverage, 25353,
     /* 2441662 */     GIR_EraseRootFromParent_Done,
     /* 2441663 */   // Label 35321: @2441663
     /* 2441663 */   GIM_Try, /*On fail goto*//*Label 35322*/ GIMT_Encode4(2441735), // Rule ID 25354 //
     /* 2441668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441700 */     // MIs[0] policy
     /* 2441700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441710 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2441713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2441731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441734 */     // GIR_Coverage, 25354,
     /* 2441734 */     GIR_EraseRootFromParent_Done,
     /* 2441735 */   // Label 35322: @2441735
     /* 2441735 */   GIM_Try, /*On fail goto*//*Label 35323*/ GIMT_Encode4(2441807), // Rule ID 25355 //
     /* 2441740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441772 */     // MIs[0] policy
     /* 2441772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441782 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2441785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2441803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441806 */     // GIR_Coverage, 25355,
     /* 2441806 */     GIR_EraseRootFromParent_Done,
     /* 2441807 */   // Label 35323: @2441807
     /* 2441807 */   GIM_Reject,
     /* 2441808 */ // Label 35319: @2441808
     /* 2441808 */ GIM_Reject,
     /* 2441809 */ // Label 35297: @2441809
     /* 2441809 */ GIM_Try, /*On fail goto*//*Label 35324*/ GIMT_Encode4(2442441),
     /* 2441814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2441817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2441820 */   GIM_Try, /*On fail goto*//*Label 35325*/ GIMT_Encode4(2441903), // Rule ID 45302 //
     /* 2441825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441861 */     // MIs[1] Operand 1
     /* 2441861 */     // No operand predicates
     /* 2441861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441865 */     // MIs[0] policy
     /* 2441865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441877 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2441880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2441899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441902 */     // GIR_Coverage, 45302,
     /* 2441902 */     GIR_EraseRootFromParent_Done,
     /* 2441903 */   // Label 35325: @2441903
     /* 2441903 */   GIM_Try, /*On fail goto*//*Label 35326*/ GIMT_Encode4(2441986), // Rule ID 45303 //
     /* 2441908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441944 */     // MIs[1] Operand 1
     /* 2441944 */     // No operand predicates
     /* 2441944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441948 */     // MIs[0] policy
     /* 2441948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441960 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2441963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441972 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2441982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441985 */     // GIR_Coverage, 45303,
     /* 2441985 */     GIR_EraseRootFromParent_Done,
     /* 2441986 */   // Label 35326: @2441986
     /* 2441986 */   GIM_Try, /*On fail goto*//*Label 35327*/ GIMT_Encode4(2442069), // Rule ID 45378 //
     /* 2441991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2442000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442027 */     // MIs[1] Operand 1
     /* 2442027 */     // No operand predicates
     /* 2442027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442031 */     // MIs[0] policy
     /* 2442031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442043 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2442046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442068 */     // GIR_Coverage, 45378,
     /* 2442068 */     GIR_EraseRootFromParent_Done,
     /* 2442069 */   // Label 35327: @2442069
     /* 2442069 */   GIM_Try, /*On fail goto*//*Label 35328*/ GIMT_Encode4(2442152), // Rule ID 45379 //
     /* 2442074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2442083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442110 */     // MIs[1] Operand 1
     /* 2442110 */     // No operand predicates
     /* 2442110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442114 */     // MIs[0] policy
     /* 2442114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442126 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2442129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442151 */     // GIR_Coverage, 45379,
     /* 2442151 */     GIR_EraseRootFromParent_Done,
     /* 2442152 */   // Label 35328: @2442152
     /* 2442152 */   GIM_Try, /*On fail goto*//*Label 35329*/ GIMT_Encode4(2442224), // Rule ID 45304 //
     /* 2442157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2442166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442189 */     // MIs[0] policy
     /* 2442189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442199 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2442202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442210 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442223 */     // GIR_Coverage, 45304,
     /* 2442223 */     GIR_EraseRootFromParent_Done,
     /* 2442224 */   // Label 35329: @2442224
     /* 2442224 */   GIM_Try, /*On fail goto*//*Label 35330*/ GIMT_Encode4(2442296), // Rule ID 45305 //
     /* 2442229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2442238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442261 */     // MIs[0] policy
     /* 2442261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442271 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2442274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442282 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442295 */     // GIR_Coverage, 45305,
     /* 2442295 */     GIR_EraseRootFromParent_Done,
     /* 2442296 */   // Label 35330: @2442296
     /* 2442296 */   GIM_Try, /*On fail goto*//*Label 35331*/ GIMT_Encode4(2442368), // Rule ID 45380 //
     /* 2442301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2442310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442333 */     // MIs[0] policy
     /* 2442333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442343 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2442346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442354 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442367 */     // GIR_Coverage, 45380,
     /* 2442367 */     GIR_EraseRootFromParent_Done,
     /* 2442368 */   // Label 35331: @2442368
     /* 2442368 */   GIM_Try, /*On fail goto*//*Label 35332*/ GIMT_Encode4(2442440), // Rule ID 45381 //
     /* 2442373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2442382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442405 */     // MIs[0] policy
     /* 2442405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442415 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2442418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442426 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442439 */     // GIR_Coverage, 45381,
     /* 2442439 */     GIR_EraseRootFromParent_Done,
     /* 2442440 */   // Label 35332: @2442440
     /* 2442440 */   GIM_Reject,
     /* 2442441 */ // Label 35324: @2442441
     /* 2442441 */ GIM_Reject,
     /* 2442442 */ // Label 35298: @2442442
     /* 2442442 */ GIM_Try, /*On fail goto*//*Label 35333*/ GIMT_Encode4(2443074),
     /* 2442447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2442450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2442453 */   GIM_Try, /*On fail goto*//*Label 35334*/ GIMT_Encode4(2442536), // Rule ID 45310 //
     /* 2442458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2442467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442494 */     // MIs[1] Operand 1
     /* 2442494 */     // No operand predicates
     /* 2442494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442498 */     // MIs[0] policy
     /* 2442498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442510 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2442513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442522 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442535 */     // GIR_Coverage, 45310,
     /* 2442535 */     GIR_EraseRootFromParent_Done,
     /* 2442536 */   // Label 35334: @2442536
     /* 2442536 */   GIM_Try, /*On fail goto*//*Label 35335*/ GIMT_Encode4(2442619), // Rule ID 45311 //
     /* 2442541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2442550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442577 */     // MIs[1] Operand 1
     /* 2442577 */     // No operand predicates
     /* 2442577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442581 */     // MIs[0] policy
     /* 2442581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442593 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2442596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442618 */     // GIR_Coverage, 45311,
     /* 2442618 */     GIR_EraseRootFromParent_Done,
     /* 2442619 */   // Label 35335: @2442619
     /* 2442619 */   GIM_Try, /*On fail goto*//*Label 35336*/ GIMT_Encode4(2442702), // Rule ID 45386 //
     /* 2442624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2442633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442660 */     // MIs[1] Operand 1
     /* 2442660 */     // No operand predicates
     /* 2442660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442664 */     // MIs[0] policy
     /* 2442664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442676 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2442679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442688 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442701 */     // GIR_Coverage, 45386,
     /* 2442701 */     GIR_EraseRootFromParent_Done,
     /* 2442702 */   // Label 35336: @2442702
     /* 2442702 */   GIM_Try, /*On fail goto*//*Label 35337*/ GIMT_Encode4(2442785), // Rule ID 45387 //
     /* 2442707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2442716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442743 */     // MIs[1] Operand 1
     /* 2442743 */     // No operand predicates
     /* 2442743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442747 */     // MIs[0] policy
     /* 2442747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442759 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2442762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442784 */     // GIR_Coverage, 45387,
     /* 2442784 */     GIR_EraseRootFromParent_Done,
     /* 2442785 */   // Label 35337: @2442785
     /* 2442785 */   GIM_Try, /*On fail goto*//*Label 35338*/ GIMT_Encode4(2442857), // Rule ID 45312 //
     /* 2442790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2442799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442822 */     // MIs[0] policy
     /* 2442822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442832 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2442835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442856 */     // GIR_Coverage, 45312,
     /* 2442856 */     GIR_EraseRootFromParent_Done,
     /* 2442857 */   // Label 35338: @2442857
     /* 2442857 */   GIM_Try, /*On fail goto*//*Label 35339*/ GIMT_Encode4(2442929), // Rule ID 45313 //
     /* 2442862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2442871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442894 */     // MIs[0] policy
     /* 2442894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442904 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2442907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442928 */     // GIR_Coverage, 45313,
     /* 2442928 */     GIR_EraseRootFromParent_Done,
     /* 2442929 */   // Label 35339: @2442929
     /* 2442929 */   GIM_Try, /*On fail goto*//*Label 35340*/ GIMT_Encode4(2443001), // Rule ID 45388 //
     /* 2442934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2442943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442966 */     // MIs[0] policy
     /* 2442966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442976 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2442979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443000 */     // GIR_Coverage, 45388,
     /* 2443000 */     GIR_EraseRootFromParent_Done,
     /* 2443001 */   // Label 35340: @2443001
     /* 2443001 */   GIM_Try, /*On fail goto*//*Label 35341*/ GIMT_Encode4(2443073), // Rule ID 45389 //
     /* 2443006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2443015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443038 */     // MIs[0] policy
     /* 2443038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443048 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2443051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443069 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443072 */     // GIR_Coverage, 45389,
     /* 2443072 */     GIR_EraseRootFromParent_Done,
     /* 2443073 */   // Label 35341: @2443073
     /* 2443073 */   GIM_Reject,
     /* 2443074 */ // Label 35333: @2443074
     /* 2443074 */ GIM_Reject,
     /* 2443075 */ // Label 35299: @2443075
     /* 2443075 */ GIM_Try, /*On fail goto*//*Label 35342*/ GIMT_Encode4(2443707),
     /* 2443080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2443083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2443086 */   GIM_Try, /*On fail goto*//*Label 35343*/ GIMT_Encode4(2443169), // Rule ID 45326 //
     /* 2443091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2443094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2443100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443127 */     // MIs[1] Operand 1
     /* 2443127 */     // No operand predicates
     /* 2443127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443131 */     // MIs[0] policy
     /* 2443131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443143 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2443146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443155 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443168 */     // GIR_Coverage, 45326,
     /* 2443168 */     GIR_EraseRootFromParent_Done,
     /* 2443169 */   // Label 35343: @2443169
     /* 2443169 */   GIM_Try, /*On fail goto*//*Label 35344*/ GIMT_Encode4(2443252), // Rule ID 45327 //
     /* 2443174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2443177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2443183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443210 */     // MIs[1] Operand 1
     /* 2443210 */     // No operand predicates
     /* 2443210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443214 */     // MIs[0] policy
     /* 2443214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443226 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2443229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443238 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443251 */     // GIR_Coverage, 45327,
     /* 2443251 */     GIR_EraseRootFromParent_Done,
     /* 2443252 */   // Label 35344: @2443252
     /* 2443252 */   GIM_Try, /*On fail goto*//*Label 35345*/ GIMT_Encode4(2443335), // Rule ID 45398 //
     /* 2443257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2443260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2443266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443293 */     // MIs[1] Operand 1
     /* 2443293 */     // No operand predicates
     /* 2443293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443297 */     // MIs[0] policy
     /* 2443297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443309 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2443312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443334 */     // GIR_Coverage, 45398,
     /* 2443334 */     GIR_EraseRootFromParent_Done,
     /* 2443335 */   // Label 35345: @2443335
     /* 2443335 */   GIM_Try, /*On fail goto*//*Label 35346*/ GIMT_Encode4(2443418), // Rule ID 45399 //
     /* 2443340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2443343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2443349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443376 */     // MIs[1] Operand 1
     /* 2443376 */     // No operand predicates
     /* 2443376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443380 */     // MIs[0] policy
     /* 2443380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443392 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2443395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443417 */     // GIR_Coverage, 45399,
     /* 2443417 */     GIR_EraseRootFromParent_Done,
     /* 2443418 */   // Label 35346: @2443418
     /* 2443418 */   GIM_Try, /*On fail goto*//*Label 35347*/ GIMT_Encode4(2443490), // Rule ID 45328 //
     /* 2443423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2443426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2443432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443455 */     // MIs[0] policy
     /* 2443455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443465 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2443468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443476 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443489 */     // GIR_Coverage, 45328,
     /* 2443489 */     GIR_EraseRootFromParent_Done,
     /* 2443490 */   // Label 35347: @2443490
     /* 2443490 */   GIM_Try, /*On fail goto*//*Label 35348*/ GIMT_Encode4(2443562), // Rule ID 45329 //
     /* 2443495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2443498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2443504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443527 */     // MIs[0] policy
     /* 2443527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443537 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2443540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443561 */     // GIR_Coverage, 45329,
     /* 2443561 */     GIR_EraseRootFromParent_Done,
     /* 2443562 */   // Label 35348: @2443562
     /* 2443562 */   GIM_Try, /*On fail goto*//*Label 35349*/ GIMT_Encode4(2443634), // Rule ID 45400 //
     /* 2443567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2443570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2443576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443599 */     // MIs[0] policy
     /* 2443599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443609 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2443612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443633 */     // GIR_Coverage, 45400,
     /* 2443633 */     GIR_EraseRootFromParent_Done,
     /* 2443634 */   // Label 35349: @2443634
     /* 2443634 */   GIM_Try, /*On fail goto*//*Label 35350*/ GIMT_Encode4(2443706), // Rule ID 45401 //
     /* 2443639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2443642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2443648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443671 */     // MIs[0] policy
     /* 2443671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443681 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2443684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443692 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443705 */     // GIR_Coverage, 45401,
     /* 2443705 */     GIR_EraseRootFromParent_Done,
     /* 2443706 */   // Label 35350: @2443706
     /* 2443706 */   GIM_Reject,
     /* 2443707 */ // Label 35342: @2443707
     /* 2443707 */ GIM_Reject,
     /* 2443708 */ // Label 35300: @2443708
     /* 2443708 */ GIM_Try, /*On fail goto*//*Label 35351*/ GIMT_Encode4(2444030),
     /* 2443713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2443716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2443719 */   GIM_Try, /*On fail goto*//*Label 35352*/ GIMT_Encode4(2443802), // Rule ID 45294 //
     /* 2443724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443760 */     // MIs[1] Operand 1
     /* 2443760 */     // No operand predicates
     /* 2443760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443764 */     // MIs[0] policy
     /* 2443764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443776 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2443779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2443798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443801 */     // GIR_Coverage, 45294,
     /* 2443801 */     GIR_EraseRootFromParent_Done,
     /* 2443802 */   // Label 35352: @2443802
     /* 2443802 */   GIM_Try, /*On fail goto*//*Label 35353*/ GIMT_Encode4(2443885), // Rule ID 45295 //
     /* 2443807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443843 */     // MIs[1] Operand 1
     /* 2443843 */     // No operand predicates
     /* 2443843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443847 */     // MIs[0] policy
     /* 2443847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443859 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2443862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2443881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443884 */     // GIR_Coverage, 45295,
     /* 2443884 */     GIR_EraseRootFromParent_Done,
     /* 2443885 */   // Label 35353: @2443885
     /* 2443885 */   GIM_Try, /*On fail goto*//*Label 35354*/ GIMT_Encode4(2443957), // Rule ID 45296 //
     /* 2443890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443922 */     // MIs[0] policy
     /* 2443922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443932 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2443935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2443953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443956 */     // GIR_Coverage, 45296,
     /* 2443956 */     GIR_EraseRootFromParent_Done,
     /* 2443957 */   // Label 35354: @2443957
     /* 2443957 */   GIM_Try, /*On fail goto*//*Label 35355*/ GIMT_Encode4(2444029), // Rule ID 45297 //
     /* 2443962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443994 */     // MIs[0] policy
     /* 2443994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444004 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2444007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444028 */     // GIR_Coverage, 45297,
     /* 2444028 */     GIR_EraseRootFromParent_Done,
     /* 2444029 */   // Label 35355: @2444029
     /* 2444029 */   GIM_Reject,
     /* 2444030 */ // Label 35351: @2444030
     /* 2444030 */ GIM_Reject,
     /* 2444031 */ // Label 35301: @2444031
     /* 2444031 */ GIM_Try, /*On fail goto*//*Label 35356*/ GIMT_Encode4(2444663),
     /* 2444036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2444039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2444042 */   GIM_Try, /*On fail goto*//*Label 35357*/ GIMT_Encode4(2444125), // Rule ID 45306 //
     /* 2444047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2444056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444083 */     // MIs[1] Operand 1
     /* 2444083 */     // No operand predicates
     /* 2444083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444087 */     // MIs[0] policy
     /* 2444087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444099 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2444102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444124 */     // GIR_Coverage, 45306,
     /* 2444124 */     GIR_EraseRootFromParent_Done,
     /* 2444125 */   // Label 35357: @2444125
     /* 2444125 */   GIM_Try, /*On fail goto*//*Label 35358*/ GIMT_Encode4(2444208), // Rule ID 45307 //
     /* 2444130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2444139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444166 */     // MIs[1] Operand 1
     /* 2444166 */     // No operand predicates
     /* 2444166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444170 */     // MIs[0] policy
     /* 2444170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444182 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2444185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444194 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444207 */     // GIR_Coverage, 45307,
     /* 2444207 */     GIR_EraseRootFromParent_Done,
     /* 2444208 */   // Label 35358: @2444208
     /* 2444208 */   GIM_Try, /*On fail goto*//*Label 35359*/ GIMT_Encode4(2444291), // Rule ID 45382 //
     /* 2444213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2444222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444249 */     // MIs[1] Operand 1
     /* 2444249 */     // No operand predicates
     /* 2444249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444253 */     // MIs[0] policy
     /* 2444253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444265 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2444268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444290 */     // GIR_Coverage, 45382,
     /* 2444290 */     GIR_EraseRootFromParent_Done,
     /* 2444291 */   // Label 35359: @2444291
     /* 2444291 */   GIM_Try, /*On fail goto*//*Label 35360*/ GIMT_Encode4(2444374), // Rule ID 45383 //
     /* 2444296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2444305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444332 */     // MIs[1] Operand 1
     /* 2444332 */     // No operand predicates
     /* 2444332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444336 */     // MIs[0] policy
     /* 2444336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444348 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2444351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444360 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444373 */     // GIR_Coverage, 45383,
     /* 2444373 */     GIR_EraseRootFromParent_Done,
     /* 2444374 */   // Label 35360: @2444374
     /* 2444374 */   GIM_Try, /*On fail goto*//*Label 35361*/ GIMT_Encode4(2444446), // Rule ID 45308 //
     /* 2444379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2444388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444411 */     // MIs[0] policy
     /* 2444411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444421 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2444424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444432 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444445 */     // GIR_Coverage, 45308,
     /* 2444445 */     GIR_EraseRootFromParent_Done,
     /* 2444446 */   // Label 35361: @2444446
     /* 2444446 */   GIM_Try, /*On fail goto*//*Label 35362*/ GIMT_Encode4(2444518), // Rule ID 45309 //
     /* 2444451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2444460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444483 */     // MIs[0] policy
     /* 2444483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444493 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2444496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444504 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444517 */     // GIR_Coverage, 45309,
     /* 2444517 */     GIR_EraseRootFromParent_Done,
     /* 2444518 */   // Label 35362: @2444518
     /* 2444518 */   GIM_Try, /*On fail goto*//*Label 35363*/ GIMT_Encode4(2444590), // Rule ID 45384 //
     /* 2444523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2444532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444555 */     // MIs[0] policy
     /* 2444555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444565 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2444568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444576 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444589 */     // GIR_Coverage, 45384,
     /* 2444589 */     GIR_EraseRootFromParent_Done,
     /* 2444590 */   // Label 35363: @2444590
     /* 2444590 */   GIM_Try, /*On fail goto*//*Label 35364*/ GIMT_Encode4(2444662), // Rule ID 45385 //
     /* 2444595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2444604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444627 */     // MIs[0] policy
     /* 2444627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444637 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2444640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444648 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444661 */     // GIR_Coverage, 45385,
     /* 2444661 */     GIR_EraseRootFromParent_Done,
     /* 2444662 */   // Label 35364: @2444662
     /* 2444662 */   GIM_Reject,
     /* 2444663 */ // Label 35356: @2444663
     /* 2444663 */ GIM_Reject,
     /* 2444664 */ // Label 35302: @2444664
     /* 2444664 */ GIM_Try, /*On fail goto*//*Label 35365*/ GIMT_Encode4(2445296),
     /* 2444669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2444672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2444675 */   GIM_Try, /*On fail goto*//*Label 35366*/ GIMT_Encode4(2444758), // Rule ID 45322 //
     /* 2444680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2444689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444716 */     // MIs[1] Operand 1
     /* 2444716 */     // No operand predicates
     /* 2444716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444720 */     // MIs[0] policy
     /* 2444720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444732 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2444735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444744 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2444754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444757 */     // GIR_Coverage, 45322,
     /* 2444757 */     GIR_EraseRootFromParent_Done,
     /* 2444758 */   // Label 35366: @2444758
     /* 2444758 */   GIM_Try, /*On fail goto*//*Label 35367*/ GIMT_Encode4(2444841), // Rule ID 45323 //
     /* 2444763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2444772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444799 */     // MIs[1] Operand 1
     /* 2444799 */     // No operand predicates
     /* 2444799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444803 */     // MIs[0] policy
     /* 2444803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444815 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2444818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2444837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444840 */     // GIR_Coverage, 45323,
     /* 2444840 */     GIR_EraseRootFromParent_Done,
     /* 2444841 */   // Label 35367: @2444841
     /* 2444841 */   GIM_Try, /*On fail goto*//*Label 35368*/ GIMT_Encode4(2444924), // Rule ID 45394 //
     /* 2444846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2444855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444882 */     // MIs[1] Operand 1
     /* 2444882 */     // No operand predicates
     /* 2444882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444886 */     // MIs[0] policy
     /* 2444886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444898 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2444901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444910 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2444920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444923 */     // GIR_Coverage, 45394,
     /* 2444923 */     GIR_EraseRootFromParent_Done,
     /* 2444924 */   // Label 35368: @2444924
     /* 2444924 */   GIM_Try, /*On fail goto*//*Label 35369*/ GIMT_Encode4(2445007), // Rule ID 45395 //
     /* 2444929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2444938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444965 */     // MIs[1] Operand 1
     /* 2444965 */     // No operand predicates
     /* 2444965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444969 */     // MIs[0] policy
     /* 2444969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444981 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2444984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445006 */     // GIR_Coverage, 45395,
     /* 2445006 */     GIR_EraseRootFromParent_Done,
     /* 2445007 */   // Label 35369: @2445007
     /* 2445007 */   GIM_Try, /*On fail goto*//*Label 35370*/ GIMT_Encode4(2445079), // Rule ID 45324 //
     /* 2445012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2445021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445044 */     // MIs[0] policy
     /* 2445044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445054 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2445057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445078 */     // GIR_Coverage, 45324,
     /* 2445078 */     GIR_EraseRootFromParent_Done,
     /* 2445079 */   // Label 35370: @2445079
     /* 2445079 */   GIM_Try, /*On fail goto*//*Label 35371*/ GIMT_Encode4(2445151), // Rule ID 45325 //
     /* 2445084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2445093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445116 */     // MIs[0] policy
     /* 2445116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445126 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2445129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445147 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445150 */     // GIR_Coverage, 45325,
     /* 2445150 */     GIR_EraseRootFromParent_Done,
     /* 2445151 */   // Label 35371: @2445151
     /* 2445151 */   GIM_Try, /*On fail goto*//*Label 35372*/ GIMT_Encode4(2445223), // Rule ID 45396 //
     /* 2445156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2445165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445188 */     // MIs[0] policy
     /* 2445188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445198 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2445201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445222 */     // GIR_Coverage, 45396,
     /* 2445222 */     GIR_EraseRootFromParent_Done,
     /* 2445223 */   // Label 35372: @2445223
     /* 2445223 */   GIM_Try, /*On fail goto*//*Label 35373*/ GIMT_Encode4(2445295), // Rule ID 45397 //
     /* 2445228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2445237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445260 */     // MIs[0] policy
     /* 2445260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445270 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2445273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445294 */     // GIR_Coverage, 45397,
     /* 2445294 */     GIR_EraseRootFromParent_Done,
     /* 2445295 */   // Label 35373: @2445295
     /* 2445295 */   GIM_Reject,
     /* 2445296 */ // Label 35365: @2445296
     /* 2445296 */ GIM_Reject,
     /* 2445297 */ // Label 35303: @2445297
     /* 2445297 */ GIM_Try, /*On fail goto*//*Label 35374*/ GIMT_Encode4(2445929),
     /* 2445302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2445305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2445308 */   GIM_Try, /*On fail goto*//*Label 35375*/ GIMT_Encode4(2445391), // Rule ID 45366 //
     /* 2445313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2445316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2445322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445349 */     // MIs[1] Operand 1
     /* 2445349 */     // No operand predicates
     /* 2445349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445353 */     // MIs[0] policy
     /* 2445353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445365 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2445368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445390 */     // GIR_Coverage, 45366,
     /* 2445390 */     GIR_EraseRootFromParent_Done,
     /* 2445391 */   // Label 35375: @2445391
     /* 2445391 */   GIM_Try, /*On fail goto*//*Label 35376*/ GIMT_Encode4(2445474), // Rule ID 45367 //
     /* 2445396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2445399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2445405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445432 */     // MIs[1] Operand 1
     /* 2445432 */     // No operand predicates
     /* 2445432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445436 */     // MIs[0] policy
     /* 2445436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445448 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2445451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445473 */     // GIR_Coverage, 45367,
     /* 2445473 */     GIR_EraseRootFromParent_Done,
     /* 2445474 */   // Label 35376: @2445474
     /* 2445474 */   GIM_Try, /*On fail goto*//*Label 35377*/ GIMT_Encode4(2445557), // Rule ID 45426 //
     /* 2445479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2445482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2445488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445515 */     // MIs[1] Operand 1
     /* 2445515 */     // No operand predicates
     /* 2445515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445519 */     // MIs[0] policy
     /* 2445519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445531 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2445534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445556 */     // GIR_Coverage, 45426,
     /* 2445556 */     GIR_EraseRootFromParent_Done,
     /* 2445557 */   // Label 35377: @2445557
     /* 2445557 */   GIM_Try, /*On fail goto*//*Label 35378*/ GIMT_Encode4(2445640), // Rule ID 45427 //
     /* 2445562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2445565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2445571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445598 */     // MIs[1] Operand 1
     /* 2445598 */     // No operand predicates
     /* 2445598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445602 */     // MIs[0] policy
     /* 2445602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445614 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2445617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445639 */     // GIR_Coverage, 45427,
     /* 2445639 */     GIR_EraseRootFromParent_Done,
     /* 2445640 */   // Label 35378: @2445640
     /* 2445640 */   GIM_Try, /*On fail goto*//*Label 35379*/ GIMT_Encode4(2445712), // Rule ID 45368 //
     /* 2445645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2445648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2445654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445677 */     // MIs[0] policy
     /* 2445677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445687 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2445690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445711 */     // GIR_Coverage, 45368,
     /* 2445711 */     GIR_EraseRootFromParent_Done,
     /* 2445712 */   // Label 35379: @2445712
     /* 2445712 */   GIM_Try, /*On fail goto*//*Label 35380*/ GIMT_Encode4(2445784), // Rule ID 45369 //
     /* 2445717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2445720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2445726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445749 */     // MIs[0] policy
     /* 2445749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445759 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2445762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445770 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445783 */     // GIR_Coverage, 45369,
     /* 2445783 */     GIR_EraseRootFromParent_Done,
     /* 2445784 */   // Label 35380: @2445784
     /* 2445784 */   GIM_Try, /*On fail goto*//*Label 35381*/ GIMT_Encode4(2445856), // Rule ID 45428 //
     /* 2445789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2445792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2445798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445821 */     // MIs[0] policy
     /* 2445821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445831 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2445834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445842 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445855 */     // GIR_Coverage, 45428,
     /* 2445855 */     GIR_EraseRootFromParent_Done,
     /* 2445856 */   // Label 35381: @2445856
     /* 2445856 */   GIM_Try, /*On fail goto*//*Label 35382*/ GIMT_Encode4(2445928), // Rule ID 45429 //
     /* 2445861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2445864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2445870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445893 */     // MIs[0] policy
     /* 2445893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445903 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2445906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445914 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445927 */     // GIR_Coverage, 45429,
     /* 2445927 */     GIR_EraseRootFromParent_Done,
     /* 2445928 */   // Label 35382: @2445928
     /* 2445928 */   GIM_Reject,
     /* 2445929 */ // Label 35374: @2445929
     /* 2445929 */ GIM_Reject,
     /* 2445930 */ // Label 35304: @2445930
     /* 2445930 */ GIM_Try, /*On fail goto*//*Label 35383*/ GIMT_Encode4(2446252),
     /* 2445935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2445938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2445941 */   GIM_Try, /*On fail goto*//*Label 35384*/ GIMT_Encode4(2446024), // Rule ID 45298 //
     /* 2445946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445982 */     // MIs[1] Operand 1
     /* 2445982 */     // No operand predicates
     /* 2445982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445986 */     // MIs[0] policy
     /* 2445986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445998 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2446001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446010 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2446020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446023 */     // GIR_Coverage, 45298,
     /* 2446023 */     GIR_EraseRootFromParent_Done,
     /* 2446024 */   // Label 35384: @2446024
     /* 2446024 */   GIM_Try, /*On fail goto*//*Label 35385*/ GIMT_Encode4(2446107), // Rule ID 45299 //
     /* 2446029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446065 */     // MIs[1] Operand 1
     /* 2446065 */     // No operand predicates
     /* 2446065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446069 */     // MIs[0] policy
     /* 2446069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446081 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2446084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2446103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446106 */     // GIR_Coverage, 45299,
     /* 2446106 */     GIR_EraseRootFromParent_Done,
     /* 2446107 */   // Label 35385: @2446107
     /* 2446107 */   GIM_Try, /*On fail goto*//*Label 35386*/ GIMT_Encode4(2446179), // Rule ID 45300 //
     /* 2446112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446144 */     // MIs[0] policy
     /* 2446144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446154 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2446157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2446175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446178 */     // GIR_Coverage, 45300,
     /* 2446178 */     GIR_EraseRootFromParent_Done,
     /* 2446179 */   // Label 35386: @2446179
     /* 2446179 */   GIM_Try, /*On fail goto*//*Label 35387*/ GIMT_Encode4(2446251), // Rule ID 45301 //
     /* 2446184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446216 */     // MIs[0] policy
     /* 2446216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446226 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2446229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2446247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446250 */     // GIR_Coverage, 45301,
     /* 2446250 */     GIR_EraseRootFromParent_Done,
     /* 2446251 */   // Label 35387: @2446251
     /* 2446251 */   GIM_Reject,
     /* 2446252 */ // Label 35383: @2446252
     /* 2446252 */ GIM_Reject,
     /* 2446253 */ // Label 35305: @2446253
     /* 2446253 */ GIM_Try, /*On fail goto*//*Label 35388*/ GIMT_Encode4(2446885),
     /* 2446258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2446261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2446264 */   GIM_Try, /*On fail goto*//*Label 35389*/ GIMT_Encode4(2446347), // Rule ID 45318 //
     /* 2446269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446305 */     // MIs[1] Operand 1
     /* 2446305 */     // No operand predicates
     /* 2446305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446309 */     // MIs[0] policy
     /* 2446309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446321 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2446324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446346 */     // GIR_Coverage, 45318,
     /* 2446346 */     GIR_EraseRootFromParent_Done,
     /* 2446347 */   // Label 35389: @2446347
     /* 2446347 */   GIM_Try, /*On fail goto*//*Label 35390*/ GIMT_Encode4(2446430), // Rule ID 45319 //
     /* 2446352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446388 */     // MIs[1] Operand 1
     /* 2446388 */     // No operand predicates
     /* 2446388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446392 */     // MIs[0] policy
     /* 2446392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446404 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2446407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446416 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446429 */     // GIR_Coverage, 45319,
     /* 2446429 */     GIR_EraseRootFromParent_Done,
     /* 2446430 */   // Label 35390: @2446430
     /* 2446430 */   GIM_Try, /*On fail goto*//*Label 35391*/ GIMT_Encode4(2446513), // Rule ID 45390 //
     /* 2446435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446471 */     // MIs[1] Operand 1
     /* 2446471 */     // No operand predicates
     /* 2446471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446475 */     // MIs[0] policy
     /* 2446475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446487 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2446490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446499 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446512 */     // GIR_Coverage, 45390,
     /* 2446512 */     GIR_EraseRootFromParent_Done,
     /* 2446513 */   // Label 35391: @2446513
     /* 2446513 */   GIM_Try, /*On fail goto*//*Label 35392*/ GIMT_Encode4(2446596), // Rule ID 45391 //
     /* 2446518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446554 */     // MIs[1] Operand 1
     /* 2446554 */     // No operand predicates
     /* 2446554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446558 */     // MIs[0] policy
     /* 2446558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446570 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2446573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446582 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446595 */     // GIR_Coverage, 45391,
     /* 2446595 */     GIR_EraseRootFromParent_Done,
     /* 2446596 */   // Label 35392: @2446596
     /* 2446596 */   GIM_Try, /*On fail goto*//*Label 35393*/ GIMT_Encode4(2446668), // Rule ID 45320 //
     /* 2446601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446633 */     // MIs[0] policy
     /* 2446633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446643 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2446646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446654 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446667 */     // GIR_Coverage, 45320,
     /* 2446667 */     GIR_EraseRootFromParent_Done,
     /* 2446668 */   // Label 35393: @2446668
     /* 2446668 */   GIM_Try, /*On fail goto*//*Label 35394*/ GIMT_Encode4(2446740), // Rule ID 45321 //
     /* 2446673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446705 */     // MIs[0] policy
     /* 2446705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446715 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2446718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446726 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446739 */     // GIR_Coverage, 45321,
     /* 2446739 */     GIR_EraseRootFromParent_Done,
     /* 2446740 */   // Label 35394: @2446740
     /* 2446740 */   GIM_Try, /*On fail goto*//*Label 35395*/ GIMT_Encode4(2446812), // Rule ID 45392 //
     /* 2446745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446777 */     // MIs[0] policy
     /* 2446777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446787 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2446790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446798 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446811 */     // GIR_Coverage, 45392,
     /* 2446811 */     GIR_EraseRootFromParent_Done,
     /* 2446812 */   // Label 35395: @2446812
     /* 2446812 */   GIM_Try, /*On fail goto*//*Label 35396*/ GIMT_Encode4(2446884), // Rule ID 45393 //
     /* 2446817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446849 */     // MIs[0] policy
     /* 2446849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446859 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2446862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446870 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446883 */     // GIR_Coverage, 45393,
     /* 2446883 */     GIR_EraseRootFromParent_Done,
     /* 2446884 */   // Label 35396: @2446884
     /* 2446884 */   GIM_Reject,
     /* 2446885 */ // Label 35388: @2446885
     /* 2446885 */ GIM_Reject,
     /* 2446886 */ // Label 35306: @2446886
     /* 2446886 */ GIM_Try, /*On fail goto*//*Label 35397*/ GIMT_Encode4(2447518),
     /* 2446891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2446894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2446897 */   GIM_Try, /*On fail goto*//*Label 35398*/ GIMT_Encode4(2446980), // Rule ID 45354 //
     /* 2446902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2446918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446934 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446938 */     // MIs[1] Operand 1
     /* 2446938 */     // No operand predicates
     /* 2446938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446942 */     // MIs[0] policy
     /* 2446942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446954 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2446957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446966 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446979 */     // GIR_Coverage, 45354,
     /* 2446979 */     GIR_EraseRootFromParent_Done,
     /* 2446980 */   // Label 35398: @2446980
     /* 2446980 */   GIM_Try, /*On fail goto*//*Label 35399*/ GIMT_Encode4(2447063), // Rule ID 45355 //
     /* 2446985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2446994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2447001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447021 */     // MIs[1] Operand 1
     /* 2447021 */     // No operand predicates
     /* 2447021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447025 */     // MIs[0] policy
     /* 2447025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447037 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2447040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447062 */     // GIR_Coverage, 45355,
     /* 2447062 */     GIR_EraseRootFromParent_Done,
     /* 2447063 */   // Label 35399: @2447063
     /* 2447063 */   GIM_Try, /*On fail goto*//*Label 35400*/ GIMT_Encode4(2447146), // Rule ID 45414 //
     /* 2447068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2447077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2447084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447104 */     // MIs[1] Operand 1
     /* 2447104 */     // No operand predicates
     /* 2447104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447108 */     // MIs[0] policy
     /* 2447108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447120 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2447123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447132 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447145 */     // GIR_Coverage, 45414,
     /* 2447145 */     GIR_EraseRootFromParent_Done,
     /* 2447146 */   // Label 35400: @2447146
     /* 2447146 */   GIM_Try, /*On fail goto*//*Label 35401*/ GIMT_Encode4(2447229), // Rule ID 45415 //
     /* 2447151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2447160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2447167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447187 */     // MIs[1] Operand 1
     /* 2447187 */     // No operand predicates
     /* 2447187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447191 */     // MIs[0] policy
     /* 2447191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447203 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2447206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447228 */     // GIR_Coverage, 45415,
     /* 2447228 */     GIR_EraseRootFromParent_Done,
     /* 2447229 */   // Label 35401: @2447229
     /* 2447229 */   GIM_Try, /*On fail goto*//*Label 35402*/ GIMT_Encode4(2447301), // Rule ID 45356 //
     /* 2447234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2447243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2447250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447266 */     // MIs[0] policy
     /* 2447266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447276 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2447279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447300 */     // GIR_Coverage, 45356,
     /* 2447300 */     GIR_EraseRootFromParent_Done,
     /* 2447301 */   // Label 35402: @2447301
     /* 2447301 */   GIM_Try, /*On fail goto*//*Label 35403*/ GIMT_Encode4(2447373), // Rule ID 45357 //
     /* 2447306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2447315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2447322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447338 */     // MIs[0] policy
     /* 2447338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447348 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2447351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447372 */     // GIR_Coverage, 45357,
     /* 2447372 */     GIR_EraseRootFromParent_Done,
     /* 2447373 */   // Label 35403: @2447373
     /* 2447373 */   GIM_Try, /*On fail goto*//*Label 35404*/ GIMT_Encode4(2447445), // Rule ID 45416 //
     /* 2447378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2447387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2447394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447410 */     // MIs[0] policy
     /* 2447410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447420 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2447423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447444 */     // GIR_Coverage, 45416,
     /* 2447444 */     GIR_EraseRootFromParent_Done,
     /* 2447445 */   // Label 35404: @2447445
     /* 2447445 */   GIM_Try, /*On fail goto*//*Label 35405*/ GIMT_Encode4(2447517), // Rule ID 45417 //
     /* 2447450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2447459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2447466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2447474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447482 */     // MIs[0] policy
     /* 2447482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447492 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2447495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447516 */     // GIR_Coverage, 45417,
     /* 2447516 */     GIR_EraseRootFromParent_Done,
     /* 2447517 */   // Label 35405: @2447517
     /* 2447517 */   GIM_Reject,
     /* 2447518 */ // Label 35397: @2447518
     /* 2447518 */ GIM_Reject,
     /* 2447519 */ // Label 35307: @2447519
     /* 2447519 */ GIM_Try, /*On fail goto*//*Label 35406*/ GIMT_Encode4(2448151),
     /* 2447524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2447527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2447530 */   GIM_Try, /*On fail goto*//*Label 35407*/ GIMT_Encode4(2447613), // Rule ID 45370 //
     /* 2447535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2447544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447571 */     // MIs[1] Operand 1
     /* 2447571 */     // No operand predicates
     /* 2447571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447575 */     // MIs[0] policy
     /* 2447575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447587 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2447590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447612 */     // GIR_Coverage, 45370,
     /* 2447612 */     GIR_EraseRootFromParent_Done,
     /* 2447613 */   // Label 35407: @2447613
     /* 2447613 */   GIM_Try, /*On fail goto*//*Label 35408*/ GIMT_Encode4(2447696), // Rule ID 45371 //
     /* 2447618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2447627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447654 */     // MIs[1] Operand 1
     /* 2447654 */     // No operand predicates
     /* 2447654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447658 */     // MIs[0] policy
     /* 2447658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447670 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2447673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447695 */     // GIR_Coverage, 45371,
     /* 2447695 */     GIR_EraseRootFromParent_Done,
     /* 2447696 */   // Label 35408: @2447696
     /* 2447696 */   GIM_Try, /*On fail goto*//*Label 35409*/ GIMT_Encode4(2447779), // Rule ID 45430 //
     /* 2447701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2447710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447737 */     // MIs[1] Operand 1
     /* 2447737 */     // No operand predicates
     /* 2447737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447741 */     // MIs[0] policy
     /* 2447741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447753 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2447756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447778 */     // GIR_Coverage, 45430,
     /* 2447778 */     GIR_EraseRootFromParent_Done,
     /* 2447779 */   // Label 35409: @2447779
     /* 2447779 */   GIM_Try, /*On fail goto*//*Label 35410*/ GIMT_Encode4(2447862), // Rule ID 45431 //
     /* 2447784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2447793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447820 */     // MIs[1] Operand 1
     /* 2447820 */     // No operand predicates
     /* 2447820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447824 */     // MIs[0] policy
     /* 2447824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447836 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2447839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447861 */     // GIR_Coverage, 45431,
     /* 2447861 */     GIR_EraseRootFromParent_Done,
     /* 2447862 */   // Label 35410: @2447862
     /* 2447862 */   GIM_Try, /*On fail goto*//*Label 35411*/ GIMT_Encode4(2447934), // Rule ID 45372 //
     /* 2447867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2447876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447899 */     // MIs[0] policy
     /* 2447899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447909 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2447912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447920 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447933 */     // GIR_Coverage, 45372,
     /* 2447933 */     GIR_EraseRootFromParent_Done,
     /* 2447934 */   // Label 35411: @2447934
     /* 2447934 */   GIM_Try, /*On fail goto*//*Label 35412*/ GIMT_Encode4(2448006), // Rule ID 45373 //
     /* 2447939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2447948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447971 */     // MIs[0] policy
     /* 2447971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447981 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2447984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2448002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448005 */     // GIR_Coverage, 45373,
     /* 2448005 */     GIR_EraseRootFromParent_Done,
     /* 2448006 */   // Label 35412: @2448006
     /* 2448006 */   GIM_Try, /*On fail goto*//*Label 35413*/ GIMT_Encode4(2448078), // Rule ID 45432 //
     /* 2448011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2448014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2448020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2448027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448043 */     // MIs[0] policy
     /* 2448043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448053 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2448056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448064 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2448074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448077 */     // GIR_Coverage, 45432,
     /* 2448077 */     GIR_EraseRootFromParent_Done,
     /* 2448078 */   // Label 35413: @2448078
     /* 2448078 */   GIM_Try, /*On fail goto*//*Label 35414*/ GIMT_Encode4(2448150), // Rule ID 45433 //
     /* 2448083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2448086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2448092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2448099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448115 */     // MIs[0] policy
     /* 2448115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448125 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2448128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448136 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2448146 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448149 */     // GIR_Coverage, 45433,
     /* 2448149 */     GIR_EraseRootFromParent_Done,
     /* 2448150 */   // Label 35414: @2448150
     /* 2448150 */   GIM_Reject,
     /* 2448151 */ // Label 35406: @2448151
     /* 2448151 */ GIM_Reject,
     /* 2448152 */ // Label 35308: @2448152
     /* 2448152 */ GIM_Try, /*On fail goto*//*Label 35415*/ GIMT_Encode4(2448474),
     /* 2448157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2448160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2448163 */   GIM_Try, /*On fail goto*//*Label 35416*/ GIMT_Encode4(2448246), // Rule ID 45314 //
     /* 2448168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448204 */     // MIs[1] Operand 1
     /* 2448204 */     // No operand predicates
     /* 2448204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448208 */     // MIs[0] policy
     /* 2448208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448220 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2448223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448232 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2448242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448245 */     // GIR_Coverage, 45314,
     /* 2448245 */     GIR_EraseRootFromParent_Done,
     /* 2448246 */   // Label 35416: @2448246
     /* 2448246 */   GIM_Try, /*On fail goto*//*Label 35417*/ GIMT_Encode4(2448329), // Rule ID 45315 //
     /* 2448251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448287 */     // MIs[1] Operand 1
     /* 2448287 */     // No operand predicates
     /* 2448287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448291 */     // MIs[0] policy
     /* 2448291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448303 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2448306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2448325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448328 */     // GIR_Coverage, 45315,
     /* 2448328 */     GIR_EraseRootFromParent_Done,
     /* 2448329 */   // Label 35417: @2448329
     /* 2448329 */   GIM_Try, /*On fail goto*//*Label 35418*/ GIMT_Encode4(2448401), // Rule ID 45316 //
     /* 2448334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448366 */     // MIs[0] policy
     /* 2448366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448376 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2448379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2448397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448400 */     // GIR_Coverage, 45316,
     /* 2448400 */     GIR_EraseRootFromParent_Done,
     /* 2448401 */   // Label 35418: @2448401
     /* 2448401 */   GIM_Try, /*On fail goto*//*Label 35419*/ GIMT_Encode4(2448473), // Rule ID 45317 //
     /* 2448406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448438 */     // MIs[0] policy
     /* 2448438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448448 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2448451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2448469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448472 */     // GIR_Coverage, 45317,
     /* 2448472 */     GIR_EraseRootFromParent_Done,
     /* 2448473 */   // Label 35419: @2448473
     /* 2448473 */   GIM_Reject,
     /* 2448474 */ // Label 35415: @2448474
     /* 2448474 */ GIM_Reject,
     /* 2448475 */ // Label 35309: @2448475
     /* 2448475 */ GIM_Try, /*On fail goto*//*Label 35420*/ GIMT_Encode4(2449107),
     /* 2448480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2448483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2448486 */   GIM_Try, /*On fail goto*//*Label 35421*/ GIMT_Encode4(2448569), // Rule ID 45342 //
     /* 2448491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448527 */     // MIs[1] Operand 1
     /* 2448527 */     // No operand predicates
     /* 2448527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448531 */     // MIs[0] policy
     /* 2448531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448543 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2448546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448568 */     // GIR_Coverage, 45342,
     /* 2448568 */     GIR_EraseRootFromParent_Done,
     /* 2448569 */   // Label 35421: @2448569
     /* 2448569 */   GIM_Try, /*On fail goto*//*Label 35422*/ GIMT_Encode4(2448652), // Rule ID 45343 //
     /* 2448574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448610 */     // MIs[1] Operand 1
     /* 2448610 */     // No operand predicates
     /* 2448610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448614 */     // MIs[0] policy
     /* 2448614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448626 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2448629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448638 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448651 */     // GIR_Coverage, 45343,
     /* 2448651 */     GIR_EraseRootFromParent_Done,
     /* 2448652 */   // Label 35422: @2448652
     /* 2448652 */   GIM_Try, /*On fail goto*//*Label 35423*/ GIMT_Encode4(2448735), // Rule ID 45402 //
     /* 2448657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448693 */     // MIs[1] Operand 1
     /* 2448693 */     // No operand predicates
     /* 2448693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448697 */     // MIs[0] policy
     /* 2448697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448709 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2448712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448734 */     // GIR_Coverage, 45402,
     /* 2448734 */     GIR_EraseRootFromParent_Done,
     /* 2448735 */   // Label 35423: @2448735
     /* 2448735 */   GIM_Try, /*On fail goto*//*Label 35424*/ GIMT_Encode4(2448818), // Rule ID 45403 //
     /* 2448740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448776 */     // MIs[1] Operand 1
     /* 2448776 */     // No operand predicates
     /* 2448776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448780 */     // MIs[0] policy
     /* 2448780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448792 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2448795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448804 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448817 */     // GIR_Coverage, 45403,
     /* 2448817 */     GIR_EraseRootFromParent_Done,
     /* 2448818 */   // Label 35424: @2448818
     /* 2448818 */   GIM_Try, /*On fail goto*//*Label 35425*/ GIMT_Encode4(2448890), // Rule ID 45344 //
     /* 2448823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448855 */     // MIs[0] policy
     /* 2448855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448865 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2448868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448876 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448889 */     // GIR_Coverage, 45344,
     /* 2448889 */     GIR_EraseRootFromParent_Done,
     /* 2448890 */   // Label 35425: @2448890
     /* 2448890 */   GIM_Try, /*On fail goto*//*Label 35426*/ GIMT_Encode4(2448962), // Rule ID 45345 //
     /* 2448895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448927 */     // MIs[0] policy
     /* 2448927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448937 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2448940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448948 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448961 */     // GIR_Coverage, 45345,
     /* 2448961 */     GIR_EraseRootFromParent_Done,
     /* 2448962 */   // Label 35426: @2448962
     /* 2448962 */   GIM_Try, /*On fail goto*//*Label 35427*/ GIMT_Encode4(2449034), // Rule ID 45404 //
     /* 2448967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448999 */     // MIs[0] policy
     /* 2448999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449009 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2449012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2449030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449033 */     // GIR_Coverage, 45404,
     /* 2449033 */     GIR_EraseRootFromParent_Done,
     /* 2449034 */   // Label 35427: @2449034
     /* 2449034 */   GIM_Try, /*On fail goto*//*Label 35428*/ GIMT_Encode4(2449106), // Rule ID 45405 //
     /* 2449039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2449048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449071 */     // MIs[0] policy
     /* 2449071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449081 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2449084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2449102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449105 */     // GIR_Coverage, 45405,
     /* 2449105 */     GIR_EraseRootFromParent_Done,
     /* 2449106 */   // Label 35428: @2449106
     /* 2449106 */   GIM_Reject,
     /* 2449107 */ // Label 35420: @2449107
     /* 2449107 */ GIM_Reject,
     /* 2449108 */ // Label 35310: @2449108
     /* 2449108 */ GIM_Try, /*On fail goto*//*Label 35429*/ GIMT_Encode4(2449740),
     /* 2449113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2449116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2449119 */   GIM_Try, /*On fail goto*//*Label 35430*/ GIMT_Encode4(2449202), // Rule ID 45358 //
     /* 2449124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2449133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449160 */     // MIs[1] Operand 1
     /* 2449160 */     // No operand predicates
     /* 2449160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449164 */     // MIs[0] policy
     /* 2449164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449176 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2449179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449188 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449201 */     // GIR_Coverage, 45358,
     /* 2449201 */     GIR_EraseRootFromParent_Done,
     /* 2449202 */   // Label 35430: @2449202
     /* 2449202 */   GIM_Try, /*On fail goto*//*Label 35431*/ GIMT_Encode4(2449285), // Rule ID 45359 //
     /* 2449207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2449216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449243 */     // MIs[1] Operand 1
     /* 2449243 */     // No operand predicates
     /* 2449243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449247 */     // MIs[0] policy
     /* 2449247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449259 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2449262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449271 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449284 */     // GIR_Coverage, 45359,
     /* 2449284 */     GIR_EraseRootFromParent_Done,
     /* 2449285 */   // Label 35431: @2449285
     /* 2449285 */   GIM_Try, /*On fail goto*//*Label 35432*/ GIMT_Encode4(2449368), // Rule ID 45418 //
     /* 2449290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2449299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449326 */     // MIs[1] Operand 1
     /* 2449326 */     // No operand predicates
     /* 2449326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449330 */     // MIs[0] policy
     /* 2449330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449342 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2449345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449354 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449367 */     // GIR_Coverage, 45418,
     /* 2449367 */     GIR_EraseRootFromParent_Done,
     /* 2449368 */   // Label 35432: @2449368
     /* 2449368 */   GIM_Try, /*On fail goto*//*Label 35433*/ GIMT_Encode4(2449451), // Rule ID 45419 //
     /* 2449373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2449382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449409 */     // MIs[1] Operand 1
     /* 2449409 */     // No operand predicates
     /* 2449409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449413 */     // MIs[0] policy
     /* 2449413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449425 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2449428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449450 */     // GIR_Coverage, 45419,
     /* 2449450 */     GIR_EraseRootFromParent_Done,
     /* 2449451 */   // Label 35433: @2449451
     /* 2449451 */   GIM_Try, /*On fail goto*//*Label 35434*/ GIMT_Encode4(2449523), // Rule ID 45360 //
     /* 2449456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2449465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449488 */     // MIs[0] policy
     /* 2449488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449498 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2449501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449522 */     // GIR_Coverage, 45360,
     /* 2449522 */     GIR_EraseRootFromParent_Done,
     /* 2449523 */   // Label 35434: @2449523
     /* 2449523 */   GIM_Try, /*On fail goto*//*Label 35435*/ GIMT_Encode4(2449595), // Rule ID 45361 //
     /* 2449528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2449537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449560 */     // MIs[0] policy
     /* 2449560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449570 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2449573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449581 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449594 */     // GIR_Coverage, 45361,
     /* 2449594 */     GIR_EraseRootFromParent_Done,
     /* 2449595 */   // Label 35435: @2449595
     /* 2449595 */   GIM_Try, /*On fail goto*//*Label 35436*/ GIMT_Encode4(2449667), // Rule ID 45420 //
     /* 2449600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2449609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449632 */     // MIs[0] policy
     /* 2449632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449642 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2449645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449666 */     // GIR_Coverage, 45420,
     /* 2449666 */     GIR_EraseRootFromParent_Done,
     /* 2449667 */   // Label 35436: @2449667
     /* 2449667 */   GIM_Try, /*On fail goto*//*Label 35437*/ GIMT_Encode4(2449739), // Rule ID 45421 //
     /* 2449672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2449681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449704 */     // MIs[0] policy
     /* 2449704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449714 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2449717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449725 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449738 */     // GIR_Coverage, 45421,
     /* 2449738 */     GIR_EraseRootFromParent_Done,
     /* 2449739 */   // Label 35437: @2449739
     /* 2449739 */   GIM_Reject,
     /* 2449740 */ // Label 35429: @2449740
     /* 2449740 */ GIM_Reject,
     /* 2449741 */ // Label 35311: @2449741
     /* 2449741 */ GIM_Try, /*On fail goto*//*Label 35438*/ GIMT_Encode4(2450373),
     /* 2449746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2449749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2449752 */   GIM_Try, /*On fail goto*//*Label 35439*/ GIMT_Encode4(2449835), // Rule ID 45374 //
     /* 2449757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2449760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2449766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449793 */     // MIs[1] Operand 1
     /* 2449793 */     // No operand predicates
     /* 2449793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449797 */     // MIs[0] policy
     /* 2449797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449809 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2449812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449834 */     // GIR_Coverage, 45374,
     /* 2449834 */     GIR_EraseRootFromParent_Done,
     /* 2449835 */   // Label 35439: @2449835
     /* 2449835 */   GIM_Try, /*On fail goto*//*Label 35440*/ GIMT_Encode4(2449918), // Rule ID 45375 //
     /* 2449840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2449843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2449849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449876 */     // MIs[1] Operand 1
     /* 2449876 */     // No operand predicates
     /* 2449876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449880 */     // MIs[0] policy
     /* 2449880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449892 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2449895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449904 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449917 */     // GIR_Coverage, 45375,
     /* 2449917 */     GIR_EraseRootFromParent_Done,
     /* 2449918 */   // Label 35440: @2449918
     /* 2449918 */   GIM_Try, /*On fail goto*//*Label 35441*/ GIMT_Encode4(2450001), // Rule ID 45434 //
     /* 2449923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2449926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2449932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449959 */     // MIs[1] Operand 1
     /* 2449959 */     // No operand predicates
     /* 2449959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449963 */     // MIs[0] policy
     /* 2449963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449975 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2449978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450000 */     // GIR_Coverage, 45434,
     /* 2450000 */     GIR_EraseRootFromParent_Done,
     /* 2450001 */   // Label 35441: @2450001
     /* 2450001 */   GIM_Try, /*On fail goto*//*Label 35442*/ GIMT_Encode4(2450084), // Rule ID 45435 //
     /* 2450006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2450009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2450015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450042 */     // MIs[1] Operand 1
     /* 2450042 */     // No operand predicates
     /* 2450042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450046 */     // MIs[0] policy
     /* 2450046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450058 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2450061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450070 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2450080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450083 */     // GIR_Coverage, 45435,
     /* 2450083 */     GIR_EraseRootFromParent_Done,
     /* 2450084 */   // Label 35442: @2450084
     /* 2450084 */   GIM_Try, /*On fail goto*//*Label 35443*/ GIMT_Encode4(2450156), // Rule ID 45376 //
     /* 2450089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2450092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2450098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450121 */     // MIs[0] policy
     /* 2450121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450131 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450142 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2450152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450155 */     // GIR_Coverage, 45376,
     /* 2450155 */     GIR_EraseRootFromParent_Done,
     /* 2450156 */   // Label 35443: @2450156
     /* 2450156 */   GIM_Try, /*On fail goto*//*Label 35444*/ GIMT_Encode4(2450228), // Rule ID 45377 //
     /* 2450161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2450164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2450170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450193 */     // MIs[0] policy
     /* 2450193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450203 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450214 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2450224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450227 */     // GIR_Coverage, 45377,
     /* 2450227 */     GIR_EraseRootFromParent_Done,
     /* 2450228 */   // Label 35444: @2450228
     /* 2450228 */   GIM_Try, /*On fail goto*//*Label 35445*/ GIMT_Encode4(2450300), // Rule ID 45436 //
     /* 2450233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2450236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2450242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450265 */     // MIs[0] policy
     /* 2450265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450275 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450286 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2450296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450299 */     // GIR_Coverage, 45436,
     /* 2450299 */     GIR_EraseRootFromParent_Done,
     /* 2450300 */   // Label 35445: @2450300
     /* 2450300 */   GIM_Try, /*On fail goto*//*Label 35446*/ GIMT_Encode4(2450372), // Rule ID 45437 //
     /* 2450305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2450308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2450314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450337 */     // MIs[0] policy
     /* 2450337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450347 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450358 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2450368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450371 */     // GIR_Coverage, 45437,
     /* 2450371 */     GIR_EraseRootFromParent_Done,
     /* 2450372 */   // Label 35446: @2450372
     /* 2450372 */   GIM_Reject,
     /* 2450373 */ // Label 35438: @2450373
     /* 2450373 */ GIM_Reject,
     /* 2450374 */ // Label 35312: @2450374
     /* 2450374 */ GIM_Try, /*On fail goto*//*Label 35447*/ GIMT_Encode4(2450696),
     /* 2450379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2450382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2450385 */   GIM_Try, /*On fail goto*//*Label 35448*/ GIMT_Encode4(2450468), // Rule ID 45330 //
     /* 2450390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2450399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2450406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450426 */     // MIs[1] Operand 1
     /* 2450426 */     // No operand predicates
     /* 2450426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450430 */     // MIs[0] policy
     /* 2450430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450442 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2450445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450454 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450467 */     // GIR_Coverage, 45330,
     /* 2450467 */     GIR_EraseRootFromParent_Done,
     /* 2450468 */   // Label 35448: @2450468
     /* 2450468 */   GIM_Try, /*On fail goto*//*Label 35449*/ GIMT_Encode4(2450551), // Rule ID 45331 //
     /* 2450473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2450482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2450489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450509 */     // MIs[1] Operand 1
     /* 2450509 */     // No operand predicates
     /* 2450509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450513 */     // MIs[0] policy
     /* 2450513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450525 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2450528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450550 */     // GIR_Coverage, 45331,
     /* 2450550 */     GIR_EraseRootFromParent_Done,
     /* 2450551 */   // Label 35449: @2450551
     /* 2450551 */   GIM_Try, /*On fail goto*//*Label 35450*/ GIMT_Encode4(2450623), // Rule ID 45332 //
     /* 2450556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2450565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2450572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450588 */     // MIs[0] policy
     /* 2450588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450598 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2450601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450622 */     // GIR_Coverage, 45332,
     /* 2450622 */     GIR_EraseRootFromParent_Done,
     /* 2450623 */   // Label 35450: @2450623
     /* 2450623 */   GIM_Try, /*On fail goto*//*Label 35451*/ GIMT_Encode4(2450695), // Rule ID 45333 //
     /* 2450628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2450637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2450644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450660 */     // MIs[0] policy
     /* 2450660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450670 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2450673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450691 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450694 */     // GIR_Coverage, 45333,
     /* 2450694 */     GIR_EraseRootFromParent_Done,
     /* 2450695 */   // Label 35451: @2450695
     /* 2450695 */   GIM_Reject,
     /* 2450696 */ // Label 35447: @2450696
     /* 2450696 */ GIM_Reject,
     /* 2450697 */ // Label 35313: @2450697
     /* 2450697 */ GIM_Try, /*On fail goto*//*Label 35452*/ GIMT_Encode4(2451329),
     /* 2450702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2450705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2450708 */   GIM_Try, /*On fail goto*//*Label 35453*/ GIMT_Encode4(2450791), // Rule ID 45346 //
     /* 2450713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2450722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2450729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450749 */     // MIs[1] Operand 1
     /* 2450749 */     // No operand predicates
     /* 2450749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450753 */     // MIs[0] policy
     /* 2450753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450765 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2450768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450790 */     // GIR_Coverage, 45346,
     /* 2450790 */     GIR_EraseRootFromParent_Done,
     /* 2450791 */   // Label 35453: @2450791
     /* 2450791 */   GIM_Try, /*On fail goto*//*Label 35454*/ GIMT_Encode4(2450874), // Rule ID 45347 //
     /* 2450796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2450805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2450812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450832 */     // MIs[1] Operand 1
     /* 2450832 */     // No operand predicates
     /* 2450832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450836 */     // MIs[0] policy
     /* 2450836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450848 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2450851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450873 */     // GIR_Coverage, 45347,
     /* 2450873 */     GIR_EraseRootFromParent_Done,
     /* 2450874 */   // Label 35454: @2450874
     /* 2450874 */   GIM_Try, /*On fail goto*//*Label 35455*/ GIMT_Encode4(2450957), // Rule ID 45406 //
     /* 2450879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2450888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2450895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450915 */     // MIs[1] Operand 1
     /* 2450915 */     // No operand predicates
     /* 2450915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450919 */     // MIs[0] policy
     /* 2450919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450931 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2450934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450956 */     // GIR_Coverage, 45406,
     /* 2450956 */     GIR_EraseRootFromParent_Done,
     /* 2450957 */   // Label 35455: @2450957
     /* 2450957 */   GIM_Try, /*On fail goto*//*Label 35456*/ GIMT_Encode4(2451040), // Rule ID 45407 //
     /* 2450962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2450971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2450978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2450986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450998 */     // MIs[1] Operand 1
     /* 2450998 */     // No operand predicates
     /* 2450998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451002 */     // MIs[0] policy
     /* 2451002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451014 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2451017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451026 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2451036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451039 */     // GIR_Coverage, 45407,
     /* 2451039 */     GIR_EraseRootFromParent_Done,
     /* 2451040 */   // Label 35456: @2451040
     /* 2451040 */   GIM_Try, /*On fail goto*//*Label 35457*/ GIMT_Encode4(2451112), // Rule ID 45348 //
     /* 2451045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2451048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2451054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451077 */     // MIs[0] policy
     /* 2451077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451087 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2451090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451098 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2451108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451111 */     // GIR_Coverage, 45348,
     /* 2451111 */     GIR_EraseRootFromParent_Done,
     /* 2451112 */   // Label 35457: @2451112
     /* 2451112 */   GIM_Try, /*On fail goto*//*Label 35458*/ GIMT_Encode4(2451184), // Rule ID 45349 //
     /* 2451117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2451126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451149 */     // MIs[0] policy
     /* 2451149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451159 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2451162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451170 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2451180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451183 */     // GIR_Coverage, 45349,
     /* 2451183 */     GIR_EraseRootFromParent_Done,
     /* 2451184 */   // Label 35458: @2451184
     /* 2451184 */   GIM_Try, /*On fail goto*//*Label 35459*/ GIMT_Encode4(2451256), // Rule ID 45408 //
     /* 2451189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2451192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2451198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451221 */     // MIs[0] policy
     /* 2451221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451231 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2451234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451242 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2451252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451255 */     // GIR_Coverage, 45408,
     /* 2451255 */     GIR_EraseRootFromParent_Done,
     /* 2451256 */   // Label 35459: @2451256
     /* 2451256 */   GIM_Try, /*On fail goto*//*Label 35460*/ GIMT_Encode4(2451328), // Rule ID 45409 //
     /* 2451261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2451270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451293 */     // MIs[0] policy
     /* 2451293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451303 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2451306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451314 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2451324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451327 */     // GIR_Coverage, 45409,
     /* 2451327 */     GIR_EraseRootFromParent_Done,
     /* 2451328 */   // Label 35460: @2451328
     /* 2451328 */   GIM_Reject,
     /* 2451329 */ // Label 35452: @2451329
     /* 2451329 */ GIM_Reject,
     /* 2451330 */ // Label 35314: @2451330
     /* 2451330 */ GIM_Try, /*On fail goto*//*Label 35461*/ GIMT_Encode4(2451962),
     /* 2451335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2451338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2451341 */   GIM_Try, /*On fail goto*//*Label 35462*/ GIMT_Encode4(2451424), // Rule ID 45362 //
     /* 2451346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2451349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2451355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2451362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451382 */     // MIs[1] Operand 1
     /* 2451382 */     // No operand predicates
     /* 2451382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451386 */     // MIs[0] policy
     /* 2451386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451398 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2451401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451410 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451423 */     // GIR_Coverage, 45362,
     /* 2451423 */     GIR_EraseRootFromParent_Done,
     /* 2451424 */   // Label 35462: @2451424
     /* 2451424 */   GIM_Try, /*On fail goto*//*Label 35463*/ GIMT_Encode4(2451507), // Rule ID 45363 //
     /* 2451429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2451438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2451445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451465 */     // MIs[1] Operand 1
     /* 2451465 */     // No operand predicates
     /* 2451465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451469 */     // MIs[0] policy
     /* 2451469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451481 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2451484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451493 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451506 */     // GIR_Coverage, 45363,
     /* 2451506 */     GIR_EraseRootFromParent_Done,
     /* 2451507 */   // Label 35463: @2451507
     /* 2451507 */   GIM_Try, /*On fail goto*//*Label 35464*/ GIMT_Encode4(2451590), // Rule ID 45422 //
     /* 2451512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2451515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2451521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2451528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451548 */     // MIs[1] Operand 1
     /* 2451548 */     // No operand predicates
     /* 2451548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451552 */     // MIs[0] policy
     /* 2451552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451564 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2451567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451576 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451589 */     // GIR_Coverage, 45422,
     /* 2451589 */     GIR_EraseRootFromParent_Done,
     /* 2451590 */   // Label 35464: @2451590
     /* 2451590 */   GIM_Try, /*On fail goto*//*Label 35465*/ GIMT_Encode4(2451673), // Rule ID 45423 //
     /* 2451595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2451604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2451611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451631 */     // MIs[1] Operand 1
     /* 2451631 */     // No operand predicates
     /* 2451631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451635 */     // MIs[0] policy
     /* 2451635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451647 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2451650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451672 */     // GIR_Coverage, 45423,
     /* 2451672 */     GIR_EraseRootFromParent_Done,
     /* 2451673 */   // Label 35465: @2451673
     /* 2451673 */   GIM_Try, /*On fail goto*//*Label 35466*/ GIMT_Encode4(2451745), // Rule ID 45364 //
     /* 2451678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2451681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2451687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2451694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451710 */     // MIs[0] policy
     /* 2451710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451720 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2451723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451731 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451744 */     // GIR_Coverage, 45364,
     /* 2451744 */     GIR_EraseRootFromParent_Done,
     /* 2451745 */   // Label 35466: @2451745
     /* 2451745 */   GIM_Try, /*On fail goto*//*Label 35467*/ GIMT_Encode4(2451817), // Rule ID 45365 //
     /* 2451750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2451759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2451766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451782 */     // MIs[0] policy
     /* 2451782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451792 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2451795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451803 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451816 */     // GIR_Coverage, 45365,
     /* 2451816 */     GIR_EraseRootFromParent_Done,
     /* 2451817 */   // Label 35467: @2451817
     /* 2451817 */   GIM_Try, /*On fail goto*//*Label 35468*/ GIMT_Encode4(2451889), // Rule ID 45424 //
     /* 2451822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2451825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2451831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2451838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451854 */     // MIs[0] policy
     /* 2451854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451864 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2451867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451875 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451888 */     // GIR_Coverage, 45424,
     /* 2451888 */     GIR_EraseRootFromParent_Done,
     /* 2451889 */   // Label 35468: @2451889
     /* 2451889 */   GIM_Try, /*On fail goto*//*Label 35469*/ GIMT_Encode4(2451961), // Rule ID 45425 //
     /* 2451894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2451903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2451910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2451918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451926 */     // MIs[0] policy
     /* 2451926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451936 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2451939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451960 */     // GIR_Coverage, 45425,
     /* 2451960 */     GIR_EraseRootFromParent_Done,
     /* 2451961 */   // Label 35469: @2451961
     /* 2451961 */   GIM_Reject,
     /* 2451962 */ // Label 35461: @2451962
     /* 2451962 */ GIM_Reject,
     /* 2451963 */ // Label 35315: @2451963
     /* 2451963 */ GIM_Try, /*On fail goto*//*Label 35470*/ GIMT_Encode4(2452285),
     /* 2451968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2451971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2451974 */   GIM_Try, /*On fail goto*//*Label 35471*/ GIMT_Encode4(2452057), // Rule ID 45334 //
     /* 2451979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2451982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2451988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2452003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452015 */     // MIs[1] Operand 1
     /* 2452015 */     // No operand predicates
     /* 2452015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452019 */     // MIs[0] policy
     /* 2452019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452031 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2452034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2452053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452056 */     // GIR_Coverage, 45334,
     /* 2452056 */     GIR_EraseRootFromParent_Done,
     /* 2452057 */   // Label 35471: @2452057
     /* 2452057 */   GIM_Try, /*On fail goto*//*Label 35472*/ GIMT_Encode4(2452140), // Rule ID 45335 //
     /* 2452062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2452071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2452078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2452082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2452086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452098 */     // MIs[1] Operand 1
     /* 2452098 */     // No operand predicates
     /* 2452098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452102 */     // MIs[0] policy
     /* 2452102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452114 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2452117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452126 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2452136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452139 */     // GIR_Coverage, 45335,
     /* 2452139 */     GIR_EraseRootFromParent_Done,
     /* 2452140 */   // Label 35472: @2452140
     /* 2452140 */   GIM_Try, /*On fail goto*//*Label 35473*/ GIMT_Encode4(2452212), // Rule ID 45336 //
     /* 2452145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2452154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2452161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2452165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2452169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452177 */     // MIs[0] policy
     /* 2452177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452187 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2452190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452198 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2452208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452211 */     // GIR_Coverage, 45336,
     /* 2452211 */     GIR_EraseRootFromParent_Done,
     /* 2452212 */   // Label 35473: @2452212
     /* 2452212 */   GIM_Try, /*On fail goto*//*Label 35474*/ GIMT_Encode4(2452284), // Rule ID 45337 //
     /* 2452217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2452226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2452233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2452237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2452241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452249 */     // MIs[0] policy
     /* 2452249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452259 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2452262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452270 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2452280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452283 */     // GIR_Coverage, 45337,
     /* 2452283 */     GIR_EraseRootFromParent_Done,
     /* 2452284 */   // Label 35474: @2452284
     /* 2452284 */   GIM_Reject,
     /* 2452285 */ // Label 35470: @2452285
     /* 2452285 */ GIM_Reject,
     /* 2452286 */ // Label 35316: @2452286
     /* 2452286 */ GIM_Try, /*On fail goto*//*Label 35475*/ GIMT_Encode4(2452918),
     /* 2452291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2452294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2452297 */   GIM_Try, /*On fail goto*//*Label 35476*/ GIMT_Encode4(2452380), // Rule ID 45350 //
     /* 2452302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2452311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2452318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452338 */     // MIs[1] Operand 1
     /* 2452338 */     // No operand predicates
     /* 2452338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452342 */     // MIs[0] policy
     /* 2452342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452354 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2452357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452379 */     // GIR_Coverage, 45350,
     /* 2452379 */     GIR_EraseRootFromParent_Done,
     /* 2452380 */   // Label 35476: @2452380
     /* 2452380 */   GIM_Try, /*On fail goto*//*Label 35477*/ GIMT_Encode4(2452463), // Rule ID 45351 //
     /* 2452385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2452394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2452401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452421 */     // MIs[1] Operand 1
     /* 2452421 */     // No operand predicates
     /* 2452421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452425 */     // MIs[0] policy
     /* 2452425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452437 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2452440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452459 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452462 */     // GIR_Coverage, 45351,
     /* 2452462 */     GIR_EraseRootFromParent_Done,
     /* 2452463 */   // Label 35477: @2452463
     /* 2452463 */   GIM_Try, /*On fail goto*//*Label 35478*/ GIMT_Encode4(2452546), // Rule ID 45410 //
     /* 2452468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2452477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2452484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452504 */     // MIs[1] Operand 1
     /* 2452504 */     // No operand predicates
     /* 2452504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452508 */     // MIs[0] policy
     /* 2452508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452520 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2452523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452545 */     // GIR_Coverage, 45410,
     /* 2452545 */     GIR_EraseRootFromParent_Done,
     /* 2452546 */   // Label 35478: @2452546
     /* 2452546 */   GIM_Try, /*On fail goto*//*Label 35479*/ GIMT_Encode4(2452629), // Rule ID 45411 //
     /* 2452551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2452560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2452567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452587 */     // MIs[1] Operand 1
     /* 2452587 */     // No operand predicates
     /* 2452587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452591 */     // MIs[0] policy
     /* 2452591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452603 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2452606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452628 */     // GIR_Coverage, 45411,
     /* 2452628 */     GIR_EraseRootFromParent_Done,
     /* 2452629 */   // Label 35479: @2452629
     /* 2452629 */   GIM_Try, /*On fail goto*//*Label 35480*/ GIMT_Encode4(2452701), // Rule ID 45352 //
     /* 2452634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2452643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2452650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452666 */     // MIs[0] policy
     /* 2452666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452676 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2452679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452700 */     // GIR_Coverage, 45352,
     /* 2452700 */     GIR_EraseRootFromParent_Done,
     /* 2452701 */   // Label 35480: @2452701
     /* 2452701 */   GIM_Try, /*On fail goto*//*Label 35481*/ GIMT_Encode4(2452773), // Rule ID 45353 //
     /* 2452706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2452715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2452722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452738 */     // MIs[0] policy
     /* 2452738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452748 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2452751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452769 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452772 */     // GIR_Coverage, 45353,
     /* 2452772 */     GIR_EraseRootFromParent_Done,
     /* 2452773 */   // Label 35481: @2452773
     /* 2452773 */   GIM_Try, /*On fail goto*//*Label 35482*/ GIMT_Encode4(2452845), // Rule ID 45412 //
     /* 2452778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2452787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2452794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452810 */     // MIs[0] policy
     /* 2452810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452820 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2452823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452841 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452844 */     // GIR_Coverage, 45412,
     /* 2452844 */     GIR_EraseRootFromParent_Done,
     /* 2452845 */   // Label 35482: @2452845
     /* 2452845 */   GIM_Try, /*On fail goto*//*Label 35483*/ GIMT_Encode4(2452917), // Rule ID 45413 //
     /* 2452850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2452859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2452866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452882 */     // MIs[0] policy
     /* 2452882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452892 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2452895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452916 */     // GIR_Coverage, 45413,
     /* 2452916 */     GIR_EraseRootFromParent_Done,
     /* 2452917 */   // Label 35483: @2452917
     /* 2452917 */   GIM_Reject,
     /* 2452918 */ // Label 35475: @2452918
     /* 2452918 */ GIM_Reject,
     /* 2452919 */ // Label 35317: @2452919
     /* 2452919 */ GIM_Try, /*On fail goto*//*Label 35484*/ GIMT_Encode4(2453241),
     /* 2452924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2452927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2452930 */   GIM_Try, /*On fail goto*//*Label 35485*/ GIMT_Encode4(2453013), // Rule ID 45338 //
     /* 2452935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2452944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2452951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2452959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452971 */     // MIs[1] Operand 1
     /* 2452971 */     // No operand predicates
     /* 2452971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452975 */     // MIs[0] policy
     /* 2452975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452987 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2452990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2453009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453012 */     // GIR_Coverage, 45338,
     /* 2453012 */     GIR_EraseRootFromParent_Done,
     /* 2453013 */   // Label 35485: @2453013
     /* 2453013 */   GIM_Try, /*On fail goto*//*Label 35486*/ GIMT_Encode4(2453096), // Rule ID 45339 //
     /* 2453018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2453021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2453027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2453034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453054 */     // MIs[1] Operand 1
     /* 2453054 */     // No operand predicates
     /* 2453054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453058 */     // MIs[0] policy
     /* 2453058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453070 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2453073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453082 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2453092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453095 */     // GIR_Coverage, 45339,
     /* 2453095 */     GIR_EraseRootFromParent_Done,
     /* 2453096 */   // Label 35486: @2453096
     /* 2453096 */   GIM_Try, /*On fail goto*//*Label 35487*/ GIMT_Encode4(2453168), // Rule ID 45340 //
     /* 2453101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2453104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2453110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2453113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2453117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2453129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453133 */     // MIs[0] policy
     /* 2453133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453143 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2453143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2453146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2453154 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2453164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453167 */     // GIR_Coverage, 45340,
     /* 2453167 */     GIR_EraseRootFromParent_Done,
     /* 2453168 */   // Label 35487: @2453168
     /* 2453168 */   GIM_Try, /*On fail goto*//*Label 35488*/ GIMT_Encode4(2453240), // Rule ID 45341 //
     /* 2453173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2453176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2453182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2453189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2453201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453205 */     // MIs[0] policy
     /* 2453205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453215 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2453218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2453226 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2453236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453239 */     // GIR_Coverage, 45341,
     /* 2453239 */     GIR_EraseRootFromParent_Done,
     /* 2453240 */   // Label 35488: @2453240
     /* 2453240 */   GIM_Reject,
     /* 2453241 */ // Label 35484: @2453241
     /* 2453241 */ GIM_Reject,
     /* 2453242 */ // Label 35318: @2453242
     /* 2453242 */ GIM_Reject,
     /* 2453243 */ // Label 125: @2453243
     /* 2453243 */ GIM_Reject,
     /* 2453244 */ }; // Size: 2453244 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
